import type { AppBridgeState, Path, PathValue, StateWithoutFeatures } from '@shopify/app-bridge';
declare type Query = keyof AppBridgeState | Path<StateWithoutFeatures<AppBridgeState>>;
declare type State<K extends Query> = K extends keyof AppBridgeState ? AppBridgeState[K] : K extends Path<StateWithoutFeatures<AppBridgeState>> ? PathValue<StateWithoutFeatures<AppBridgeState>, K> : K extends never ? AppBridgeState : never;
interface UseAppBridgeState {
    (): AppBridgeState | undefined;
    <K extends Query>(query: K): State<K> | undefined;
    <PartialState>(query: keyof AppBridgeState): PartialState | undefined;
}
export declare const useAppBridgeState: UseAppBridgeState;
export {};
