import {
  packageManagerFromUserAgent
} from "./chunk-N766LDXO.js";
import {
  currentProcessIsGlobal,
  inferPackageManagerForGlobalCLI,
  outputContent,
  outputToken
} from "./chunk-YK3ZIR2O.js";
import {
  init_cjs_shims
} from "./chunk-POZ5MGPT.js";

// ../cli-kit/dist/public/node/upgrade.js
init_cjs_shims();
function cliInstallCommand() {
  let isGlobal = currentProcessIsGlobal(), packageManager = packageManagerFromUserAgent();
  return packageManager === "unknown" && (packageManager = inferPackageManagerForGlobalCLI()), packageManager === "unknown" && (packageManager = "npm"), packageManager === "yarn" ? `${packageManager} ${isGlobal ? "global " : ""}add @shopify/cli@latest` : `${packageManager} ${packageManager === "pnpm" ? "add" : "install"} ${isGlobal ? "-g " : ""}@shopify/cli@latest`;
}
function getOutputUpdateCLIReminder(version) {
  return outputContent`💡 Version ${version} available! Run ${outputToken.genericShellCommand(cliInstallCommand())}`.value;
}

export {
  cliInstallCommand,
  getOutputUpdateCLIReminder
};
//# sourceMappingURL=chunk-44VQQ5IT.js.map
