import {
  require_zod_to_json_schema
} from "./chunk-QSUS3GJF.js";
import {
  demoStepsSchema
} from "./chunk-3ZYNGWAE.js";
import {
  base_command_default
} from "./chunk-ONFQ5XTX.js";
import {
  outputInfo,
  renderInfo
} from "./chunk-YK3ZIR2O.js";
import {
  __toESM,
  init_cjs_shims
} from "./chunk-POZ5MGPT.js";

// src/cli/commands/demo/print-ai-prompt.ts
init_cjs_shims();
var import_zod_to_json_schema = __toESM(require_zod_to_json_schema(), 1);
var PrintAIPrompt = class extends base_command_default {
  static {
    this.description = "Prints the prompts for a chat-enabled LLM to generate a demo";
  }
  static {
    this.hidden = !0;
  }
  async run() {
    let jsonSchema = import_zod_to_json_schema.default.default(demoStepsSchema, "demo-steps"), printable = JSON.stringify(jsonSchema);
    renderInfo({ body: "Copy and paste the following into the system prompt." }), outputInfo(`You are creating a demo for a Shopify CLI command, using a strictly typed JSON file.
The file defines the steps that will be executed during the demo.

The JSON schema for this file is:
\`\`\`json
${printable}
\`\`\`
`), renderInfo({ body: "Then, fill out the following and paste it into the chat box." }), outputInfo(`Generate a human-readable JSON file which will be used to create the demo. The JSON file must be typed according to the JSON schema.

The purpose of the command is: {A short description of the command.}

The demo should perform the following steps:

{
  List the steps for the command, like:
  1. Prompt for this
  2. Autocomplete that
}

============================================================
`);
  }
};

export {
  PrintAIPrompt
};
//# sourceMappingURL=chunk-GO4OU2FC.js.map
