import type { MetaThemePartials, MetaThemes } from './types';
export { createMetaTheme } from './utils';
export declare const metaThemes: MetaThemes;
export declare const metaThemePartials: MetaThemePartials;
export declare const metaThemeDefaultPartial: import("./types").MetaThemePartialShape;
export declare const metaThemeDefault: {
    border: {
        "border-radius-full": import("./types").MetaTokenProperties;
        "border-radius-0": import("./types").MetaTokenProperties;
        "border-radius-200": import("./types").MetaTokenProperties;
        "border-radius-100": import("./types").MetaTokenProperties;
        "border-radius-050": import("./types").MetaTokenProperties;
        "border-radius-150": import("./types").MetaTokenProperties;
        "border-radius-300": import("./types").MetaTokenProperties;
        "border-radius-400": import("./types").MetaTokenProperties;
        "border-radius-500": import("./types").MetaTokenProperties;
        "border-radius-750": import("./types").MetaTokenProperties;
        "border-width-0": import("./types").MetaTokenProperties;
        "border-width-100": import("./types").MetaTokenProperties;
        "border-width-050": import("./types").MetaTokenProperties;
        "border-width-0165": import("./types").MetaTokenProperties;
        "border-width-025": import("./types").MetaTokenProperties;
    };
    breakpoints: {
        "breakpoints-xs": import("./types").MetaTokenProperties;
        "breakpoints-sm": import("./types").MetaTokenProperties;
        "breakpoints-md": import("./types").MetaTokenProperties;
        "breakpoints-lg": import("./types").MetaTokenProperties;
        "breakpoints-xl": import("./types").MetaTokenProperties;
    };
    color: {
        "color-scheme": import("./types").MetaTokenProperties;
        "color-bg-fill-active": import("./types").MetaTokenProperties;
        "color-bg-fill-brand-active": import("./types").MetaTokenProperties;
        "color-bg-fill-brand-disabled": import("./types").MetaTokenProperties;
        "color-bg-fill-brand-hover": import("./types").MetaTokenProperties;
        "color-bg-fill-brand-selected": import("./types").MetaTokenProperties;
        "color-bg-fill-brand": import("./types").MetaTokenProperties;
        "color-bg-fill-caution-active": import("./types").MetaTokenProperties;
        "color-bg-fill-caution-hover": import("./types").MetaTokenProperties;
        "color-bg-fill-caution-secondary": import("./types").MetaTokenProperties;
        "color-bg-fill-caution": import("./types").MetaTokenProperties;
        "color-bg-fill-critical-active": import("./types").MetaTokenProperties;
        "color-bg-fill-critical-hover": import("./types").MetaTokenProperties;
        "color-bg-fill-critical-secondary": import("./types").MetaTokenProperties;
        "color-bg-fill-critical-selected": import("./types").MetaTokenProperties;
        "color-bg-fill-critical": import("./types").MetaTokenProperties;
        "color-bg-fill-disabled": import("./types").MetaTokenProperties;
        "color-bg-fill-emphasis-active": import("./types").MetaTokenProperties;
        "color-bg-fill-emphasis-hover": import("./types").MetaTokenProperties;
        "color-bg-fill-emphasis": import("./types").MetaTokenProperties;
        "color-bg-fill-hover": import("./types").MetaTokenProperties;
        "color-bg-fill-info-active": import("./types").MetaTokenProperties;
        "color-bg-fill-info-hover": import("./types").MetaTokenProperties;
        "color-bg-fill-info-secondary": import("./types").MetaTokenProperties;
        "color-bg-fill-info": import("./types").MetaTokenProperties;
        "color-bg-fill-inverse-active": import("./types").MetaTokenProperties;
        "color-bg-fill-inverse-hover": import("./types").MetaTokenProperties;
        "color-bg-fill-inverse": import("./types").MetaTokenProperties;
        "color-bg-fill-magic-secondary-active": import("./types").MetaTokenProperties;
        "color-bg-fill-magic-secondary-hover": import("./types").MetaTokenProperties;
        "color-bg-fill-magic-secondary": import("./types").MetaTokenProperties;
        "color-bg-fill-magic": import("./types").MetaTokenProperties;
        "color-bg-fill-secondary-active": import("./types").MetaTokenProperties;
        "color-bg-fill-secondary-hover": import("./types").MetaTokenProperties;
        "color-bg-fill-secondary": import("./types").MetaTokenProperties;
        "color-bg-fill-selected": import("./types").MetaTokenProperties;
        "color-bg-fill-success-active": import("./types").MetaTokenProperties;
        "color-bg-fill-success-hover": import("./types").MetaTokenProperties;
        "color-bg-fill-success-secondary": import("./types").MetaTokenProperties;
        "color-bg-fill-success": import("./types").MetaTokenProperties;
        "color-bg-fill-tertiary-active": import("./types").MetaTokenProperties;
        "color-bg-fill-tertiary-hover": import("./types").MetaTokenProperties;
        "color-bg-fill-tertiary": import("./types").MetaTokenProperties;
        "color-bg-fill-transparent-active": import("./types").MetaTokenProperties;
        "color-bg-fill-transparent-hover": import("./types").MetaTokenProperties;
        "color-bg-fill-transparent-secondary-active": import("./types").MetaTokenProperties;
        "color-bg-fill-transparent-secondary-hover": import("./types").MetaTokenProperties;
        "color-bg-fill-transparent-secondary": import("./types").MetaTokenProperties;
        "color-bg-fill-transparent-selected": import("./types").MetaTokenProperties;
        "color-bg-fill-transparent": import("./types").MetaTokenProperties;
        "color-bg-fill-warning-active": import("./types").MetaTokenProperties;
        "color-bg-fill-warning-hover": import("./types").MetaTokenProperties;
        "color-bg-fill-warning-secondary": import("./types").MetaTokenProperties;
        "color-bg-fill-warning": import("./types").MetaTokenProperties;
        "color-bg-fill": import("./types").MetaTokenProperties;
        "color-bg-inverse": import("./types").MetaTokenProperties;
        "color-bg-surface-active": import("./types").MetaTokenProperties;
        "color-bg-surface-brand-active": import("./types").MetaTokenProperties;
        "color-bg-surface-brand-hover": import("./types").MetaTokenProperties;
        "color-bg-surface-brand-selected": import("./types").MetaTokenProperties;
        "color-bg-surface-brand": import("./types").MetaTokenProperties;
        "color-bg-surface-caution-active": import("./types").MetaTokenProperties;
        "color-bg-surface-caution-hover": import("./types").MetaTokenProperties;
        "color-bg-surface-caution": import("./types").MetaTokenProperties;
        "color-bg-surface-critical-active": import("./types").MetaTokenProperties;
        "color-bg-surface-critical-hover": import("./types").MetaTokenProperties;
        "color-bg-surface-critical": import("./types").MetaTokenProperties;
        "color-bg-surface-disabled": import("./types").MetaTokenProperties;
        "color-bg-surface-emphasis-active": import("./types").MetaTokenProperties;
        "color-bg-surface-emphasis-hover": import("./types").MetaTokenProperties;
        "color-bg-surface-emphasis": import("./types").MetaTokenProperties;
        "color-bg-surface-hover": import("./types").MetaTokenProperties;
        "color-bg-surface-info-active": import("./types").MetaTokenProperties;
        "color-bg-surface-info-hover": import("./types").MetaTokenProperties;
        "color-bg-surface-info": import("./types").MetaTokenProperties;
        "color-bg-surface-inverse": import("./types").MetaTokenProperties;
        "color-bg-surface-magic-active": import("./types").MetaTokenProperties;
        "color-bg-surface-magic-hover": import("./types").MetaTokenProperties;
        "color-bg-surface-magic": import("./types").MetaTokenProperties;
        "color-bg-surface-secondary-active": import("./types").MetaTokenProperties;
        "color-bg-surface-secondary-hover": import("./types").MetaTokenProperties;
        "color-bg-surface-secondary-selected": import("./types").MetaTokenProperties;
        "color-bg-surface-secondary": import("./types").MetaTokenProperties;
        "color-bg-surface-selected": import("./types").MetaTokenProperties;
        "color-bg-surface-success-active": import("./types").MetaTokenProperties;
        "color-bg-surface-success-hover": import("./types").MetaTokenProperties;
        "color-bg-surface-success": import("./types").MetaTokenProperties;
        "color-bg-surface-tertiary-active": import("./types").MetaTokenProperties;
        "color-bg-surface-tertiary-hover": import("./types").MetaTokenProperties;
        "color-bg-surface-tertiary": import("./types").MetaTokenProperties;
        "color-bg-surface-transparent": import("./types").MetaTokenProperties;
        "color-bg-surface-warning-active": import("./types").MetaTokenProperties;
        "color-bg-surface-warning-hover": import("./types").MetaTokenProperties;
        "color-bg-surface-warning": import("./types").MetaTokenProperties;
        "color-bg-surface": import("./types").MetaTokenProperties;
        "color-bg": import("./types").MetaTokenProperties;
        "color-avatar-bg-fill": import("./types").MetaTokenProperties;
        "color-avatar-five-bg-fill": import("./types").MetaTokenProperties;
        "color-avatar-four-bg-fill": import("./types").MetaTokenProperties;
        "color-avatar-one-bg-fill": import("./types").MetaTokenProperties;
        "color-avatar-seven-bg-fill": import("./types").MetaTokenProperties;
        "color-avatar-six-bg-fill": import("./types").MetaTokenProperties;
        "color-avatar-three-bg-fill": import("./types").MetaTokenProperties;
        "color-avatar-two-bg-fill": import("./types").MetaTokenProperties;
        "color-backdrop-bg": import("./types").MetaTokenProperties;
        "color-button-gradient-bg-fill": import("./types").MetaTokenProperties;
        "color-checkbox-bg-surface-disabled": import("./types").MetaTokenProperties;
        "color-input-bg-surface-active": import("./types").MetaTokenProperties;
        "color-input-bg-surface-hover": import("./types").MetaTokenProperties;
        "color-input-bg-surface": import("./types").MetaTokenProperties;
        "color-nav-bg-surface-active": import("./types").MetaTokenProperties;
        "color-nav-bg-surface-hover": import("./types").MetaTokenProperties;
        "color-nav-bg-surface-selected": import("./types").MetaTokenProperties;
        "color-nav-bg-surface": import("./types").MetaTokenProperties;
        "color-nav-bg": import("./types").MetaTokenProperties;
        "color-radio-button-bg-surface-disabled": import("./types").MetaTokenProperties;
        "color-video-thumbnail-play-button-bg-fill-hover": import("./types").MetaTokenProperties;
        "color-video-thumbnail-play-button-bg-fill": import("./types").MetaTokenProperties;
        "color-scrollbar-thumb-bg-hover": import("./types").MetaTokenProperties;
        "color-border": import("./types").MetaTokenProperties;
        "color-border-brand": import("./types").MetaTokenProperties;
        "color-border-caution": import("./types").MetaTokenProperties;
        "color-border-critical-secondary": import("./types").MetaTokenProperties;
        "color-border-critical": import("./types").MetaTokenProperties;
        "color-border-disabled": import("./types").MetaTokenProperties;
        "color-border-emphasis-active": import("./types").MetaTokenProperties;
        "color-border-emphasis-hover": import("./types").MetaTokenProperties;
        "color-border-emphasis": import("./types").MetaTokenProperties;
        "color-border-focus": import("./types").MetaTokenProperties;
        "color-border-hover": import("./types").MetaTokenProperties;
        "color-border-info": import("./types").MetaTokenProperties;
        "color-border-inverse-active": import("./types").MetaTokenProperties;
        "color-border-inverse-hover": import("./types").MetaTokenProperties;
        "color-border-inverse": import("./types").MetaTokenProperties;
        "color-border-magic-secondary": import("./types").MetaTokenProperties;
        "color-border-magic-secondary-hover": import("./types").MetaTokenProperties;
        "color-border-magic": import("./types").MetaTokenProperties;
        "color-border-secondary": import("./types").MetaTokenProperties;
        "color-border-success": import("./types").MetaTokenProperties;
        "color-border-tertiary": import("./types").MetaTokenProperties;
        "color-border-warning": import("./types").MetaTokenProperties;
        "color-border-gradient-experimental": import("./types").MetaTokenProperties;
        "color-border-gradient-hover-experimental": import("./types").MetaTokenProperties;
        "color-border-gradient-selected-experimental": import("./types").MetaTokenProperties;
        "color-border-gradient-active-experimental": import("./types").MetaTokenProperties;
        "color-input-border-active": import("./types").MetaTokenProperties;
        "color-input-border-hover": import("./types").MetaTokenProperties;
        "color-input-border": import("./types").MetaTokenProperties;
        "color-tooltip-tail-down-border-experimental": import("./types").MetaTokenProperties;
        "color-tooltip-tail-up-border-experimental": import("./types").MetaTokenProperties;
        "color-icon-active": import("./types").MetaTokenProperties;
        "color-icon-brand": import("./types").MetaTokenProperties;
        "color-icon-caution": import("./types").MetaTokenProperties;
        "color-icon-critical": import("./types").MetaTokenProperties;
        "color-icon-disabled": import("./types").MetaTokenProperties;
        "color-icon-emphasis-active": import("./types").MetaTokenProperties;
        "color-icon-emphasis-hover": import("./types").MetaTokenProperties;
        "color-icon-emphasis": import("./types").MetaTokenProperties;
        "color-icon-hover": import("./types").MetaTokenProperties;
        "color-icon-info": import("./types").MetaTokenProperties;
        "color-icon-inverse": import("./types").MetaTokenProperties;
        "color-icon-magic": import("./types").MetaTokenProperties;
        "color-icon-secondary-active": import("./types").MetaTokenProperties;
        "color-icon-secondary-hover": import("./types").MetaTokenProperties;
        "color-icon-secondary": import("./types").MetaTokenProperties;
        "color-icon-success": import("./types").MetaTokenProperties;
        "color-icon-warning": import("./types").MetaTokenProperties;
        "color-icon": import("./types").MetaTokenProperties;
        "color-checkbox-icon-disabled": import("./types").MetaTokenProperties;
        "color-radio-button-icon-disabled": import("./types").MetaTokenProperties;
        "color-text-brand-hover": import("./types").MetaTokenProperties;
        "color-text-brand-on-bg-fill-active": import("./types").MetaTokenProperties;
        "color-text-brand-on-bg-fill-disabled": import("./types").MetaTokenProperties;
        "color-text-brand-on-bg-fill-hover": import("./types").MetaTokenProperties;
        "color-text-brand-on-bg-fill": import("./types").MetaTokenProperties;
        "color-text-brand": import("./types").MetaTokenProperties;
        "color-text-caution-secondary": import("./types").MetaTokenProperties;
        "color-text-caution-active": import("./types").MetaTokenProperties;
        "color-text-caution-hover": import("./types").MetaTokenProperties;
        "color-text-caution-on-bg-fill": import("./types").MetaTokenProperties;
        "color-text-caution": import("./types").MetaTokenProperties;
        "color-text-critical-secondary": import("./types").MetaTokenProperties;
        "color-text-critical-active": import("./types").MetaTokenProperties;
        "color-text-critical-hover": import("./types").MetaTokenProperties;
        "color-text-critical-on-bg-fill": import("./types").MetaTokenProperties;
        "color-text-critical": import("./types").MetaTokenProperties;
        "color-text-disabled": import("./types").MetaTokenProperties;
        "color-text-emphasis-active": import("./types").MetaTokenProperties;
        "color-text-emphasis-hover": import("./types").MetaTokenProperties;
        "color-text-emphasis-on-bg-fill-active": import("./types").MetaTokenProperties;
        "color-text-emphasis-on-bg-fill-hover": import("./types").MetaTokenProperties;
        "color-text-emphasis-on-bg-fill": import("./types").MetaTokenProperties;
        "color-text-emphasis": import("./types").MetaTokenProperties;
        "color-text-info-secondary": import("./types").MetaTokenProperties;
        "color-text-info-active": import("./types").MetaTokenProperties;
        "color-text-info-hover": import("./types").MetaTokenProperties;
        "color-text-info-on-bg-fill": import("./types").MetaTokenProperties;
        "color-text-info": import("./types").MetaTokenProperties;
        "color-text-inverse-secondary": import("./types").MetaTokenProperties;
        "color-text-inverse": import("./types").MetaTokenProperties;
        "color-text-link-active": import("./types").MetaTokenProperties;
        "color-text-link-hover": import("./types").MetaTokenProperties;
        "color-text-link-inverse": import("./types").MetaTokenProperties;
        "color-text-link": import("./types").MetaTokenProperties;
        "color-text-magic-on-bg-fill": import("./types").MetaTokenProperties;
        "color-text-magic": import("./types").MetaTokenProperties;
        "color-text-magic-secondary": import("./types").MetaTokenProperties;
        "color-text-secondary": import("./types").MetaTokenProperties;
        "color-text-success-secondary": import("./types").MetaTokenProperties;
        "color-text-success-active": import("./types").MetaTokenProperties;
        "color-text-success-hover": import("./types").MetaTokenProperties;
        "color-text-success-on-bg-fill": import("./types").MetaTokenProperties;
        "color-text-success": import("./types").MetaTokenProperties;
        "color-text-warning-secondary": import("./types").MetaTokenProperties;
        "color-text-warning-active": import("./types").MetaTokenProperties;
        "color-text-warning-hover": import("./types").MetaTokenProperties;
        "color-text-warning-on-bg-fill": import("./types").MetaTokenProperties;
        "color-text-warning": import("./types").MetaTokenProperties;
        "color-text": import("./types").MetaTokenProperties;
        "color-avatar-five-text-on-bg-fill": import("./types").MetaTokenProperties;
        "color-avatar-four-text-on-bg-fill": import("./types").MetaTokenProperties;
        "color-avatar-one-text-on-bg-fill": import("./types").MetaTokenProperties;
        "color-avatar-seven-text-on-bg-fill": import("./types").MetaTokenProperties;
        "color-avatar-six-text-on-bg-fill": import("./types").MetaTokenProperties;
        "color-avatar-text-on-bg-fill": import("./types").MetaTokenProperties;
        "color-avatar-three-text-on-bg-fill": import("./types").MetaTokenProperties;
        "color-avatar-two-text-on-bg-fill": import("./types").MetaTokenProperties;
        "color-video-thumbnail-play-button-text-on-bg-fill": import("./types").MetaTokenProperties;
    };
    font: {
        "font-family-sans": import("./types").MetaTokenProperties;
        "font-family-mono": import("./types").MetaTokenProperties;
        "font-letter-spacing-densest": import("./types").MetaTokenProperties;
        "font-letter-spacing-denser": import("./types").MetaTokenProperties;
        "font-letter-spacing-dense": import("./types").MetaTokenProperties;
        "font-letter-spacing-normal": import("./types").MetaTokenProperties;
        "font-line-height-300": import("./types").MetaTokenProperties;
        "font-line-height-400": import("./types").MetaTokenProperties;
        "font-line-height-500": import("./types").MetaTokenProperties;
        "font-line-height-600": import("./types").MetaTokenProperties;
        "font-line-height-700": import("./types").MetaTokenProperties;
        "font-line-height-800": import("./types").MetaTokenProperties;
        "font-line-height-1000": import("./types").MetaTokenProperties;
        "font-line-height-1200": import("./types").MetaTokenProperties;
        "font-size-300": import("./types").MetaTokenProperties;
        "font-size-400": import("./types").MetaTokenProperties;
        "font-size-500": import("./types").MetaTokenProperties;
        "font-size-750": import("./types").MetaTokenProperties;
        "font-size-600": import("./types").MetaTokenProperties;
        "font-size-800": import("./types").MetaTokenProperties;
        "font-size-1000": import("./types").MetaTokenProperties;
        "font-size-275": import("./types").MetaTokenProperties;
        "font-size-325": import("./types").MetaTokenProperties;
        "font-size-350": import("./types").MetaTokenProperties;
        "font-size-450": import("./types").MetaTokenProperties;
        "font-size-550": import("./types").MetaTokenProperties;
        "font-size-900": import("./types").MetaTokenProperties;
        "font-weight-regular": import("./types").MetaTokenProperties;
        "font-weight-medium": import("./types").MetaTokenProperties;
        "font-weight-semibold": import("./types").MetaTokenProperties;
        "font-weight-bold": import("./types").MetaTokenProperties;
    };
    height: {
        "height-0": import("./types").MetaTokenProperties;
        "height-200": import("./types").MetaTokenProperties;
        "height-100": import("./types").MetaTokenProperties;
        "height-050": import("./types").MetaTokenProperties;
        "height-150": import("./types").MetaTokenProperties;
        "height-300": import("./types").MetaTokenProperties;
        "height-400": import("./types").MetaTokenProperties;
        "height-500": import("./types").MetaTokenProperties;
        "height-025": import("./types").MetaTokenProperties;
        "height-600": import("./types").MetaTokenProperties;
        "height-700": import("./types").MetaTokenProperties;
        "height-800": import("./types").MetaTokenProperties;
        "height-1000": import("./types").MetaTokenProperties;
        "height-1200": import("./types").MetaTokenProperties;
        "height-900": import("./types").MetaTokenProperties;
        "height-1600": import("./types").MetaTokenProperties;
        "height-2000": import("./types").MetaTokenProperties;
        "height-2400": import("./types").MetaTokenProperties;
        "height-2800": import("./types").MetaTokenProperties;
        "height-3200": import("./types").MetaTokenProperties;
    };
    motion: {
        "motion-duration-250": import("./types").MetaTokenProperties;
        "motion-duration-0": import("./types").MetaTokenProperties;
        "motion-duration-200": import("./types").MetaTokenProperties;
        "motion-duration-50": import("./types").MetaTokenProperties;
        "motion-duration-100": import("./types").MetaTokenProperties;
        "motion-duration-150": import("./types").MetaTokenProperties;
        "motion-duration-300": import("./types").MetaTokenProperties;
        "motion-duration-400": import("./types").MetaTokenProperties;
        "motion-duration-500": import("./types").MetaTokenProperties;
        "motion-duration-350": import("./types").MetaTokenProperties;
        "motion-duration-450": import("./types").MetaTokenProperties;
        "motion-duration-5000": import("./types").MetaTokenProperties;
        "motion-keyframes-bounce": import("./types").MetaTokenProperties;
        "motion-keyframes-fade-in": import("./types").MetaTokenProperties;
        "motion-keyframes-pulse": import("./types").MetaTokenProperties;
        "motion-keyframes-spin": import("./types").MetaTokenProperties;
        "motion-keyframes-appear-above": import("./types").MetaTokenProperties;
        "motion-keyframes-appear-below": import("./types").MetaTokenProperties;
        "motion-ease": import("./types").MetaTokenProperties;
        "motion-ease-in": import("./types").MetaTokenProperties;
        "motion-ease-out": import("./types").MetaTokenProperties;
        "motion-ease-in-out": import("./types").MetaTokenProperties;
        "motion-linear": import("./types").MetaTokenProperties;
    };
    shadow: {
        "shadow-button": import("./types").MetaTokenProperties;
        "shadow-button-hover": import("./types").MetaTokenProperties;
        "shadow-button-inset": import("./types").MetaTokenProperties;
        "shadow-button-primary": import("./types").MetaTokenProperties;
        "shadow-button-primary-hover": import("./types").MetaTokenProperties;
        "shadow-button-primary-inset": import("./types").MetaTokenProperties;
        "shadow-button-primary-critical": import("./types").MetaTokenProperties;
        "shadow-button-primary-critical-hover": import("./types").MetaTokenProperties;
        "shadow-button-primary-critical-inset": import("./types").MetaTokenProperties;
        "shadow-button-primary-success": import("./types").MetaTokenProperties;
        "shadow-button-primary-success-hover": import("./types").MetaTokenProperties;
        "shadow-button-primary-success-inset": import("./types").MetaTokenProperties;
        "shadow-border-inset": import("./types").MetaTokenProperties;
        "shadow-0": import("./types").MetaTokenProperties;
        "shadow-200": import("./types").MetaTokenProperties;
        "shadow-100": import("./types").MetaTokenProperties;
        "shadow-300": import("./types").MetaTokenProperties;
        "shadow-400": import("./types").MetaTokenProperties;
        "shadow-500": import("./types").MetaTokenProperties;
        "shadow-600": import("./types").MetaTokenProperties;
        "shadow-bevel-100": import("./types").MetaTokenProperties;
        "shadow-inset-200": import("./types").MetaTokenProperties;
        "shadow-inset-100": import("./types").MetaTokenProperties;
    };
    space: {
        "space-button-group-gap": import("./types").MetaTokenProperties;
        "space-card-gap": import("./types").MetaTokenProperties;
        "space-card-padding": import("./types").MetaTokenProperties;
        "space-table-cell-padding": import("./types").MetaTokenProperties;
        "space-0": import("./types").MetaTokenProperties;
        "space-200": import("./types").MetaTokenProperties;
        "space-100": import("./types").MetaTokenProperties;
        "space-050": import("./types").MetaTokenProperties;
        "space-150": import("./types").MetaTokenProperties;
        "space-300": import("./types").MetaTokenProperties;
        "space-400": import("./types").MetaTokenProperties;
        "space-500": import("./types").MetaTokenProperties;
        "space-025": import("./types").MetaTokenProperties;
        "space-600": import("./types").MetaTokenProperties;
        "space-800": import("./types").MetaTokenProperties;
        "space-1000": import("./types").MetaTokenProperties;
        "space-1200": import("./types").MetaTokenProperties;
        "space-1600": import("./types").MetaTokenProperties;
        "space-2000": import("./types").MetaTokenProperties;
        "space-2400": import("./types").MetaTokenProperties;
        "space-2800": import("./types").MetaTokenProperties;
        "space-3200": import("./types").MetaTokenProperties;
    };
    text: {
        "text-heading-3xl-font-family": import("./types").MetaTokenProperties;
        "text-heading-3xl-font-letter-spacing": import("./types").MetaTokenProperties;
        "text-heading-3xl-font-line-height": import("./types").MetaTokenProperties;
        "text-heading-3xl-font-size": import("./types").MetaTokenProperties;
        "text-heading-3xl-font-weight": import("./types").MetaTokenProperties;
        "text-heading-2xl-font-family": import("./types").MetaTokenProperties;
        "text-heading-2xl-font-letter-spacing": import("./types").MetaTokenProperties;
        "text-heading-2xl-font-line-height": import("./types").MetaTokenProperties;
        "text-heading-2xl-font-size": import("./types").MetaTokenProperties;
        "text-heading-2xl-font-weight": import("./types").MetaTokenProperties;
        "text-heading-xl-font-family": import("./types").MetaTokenProperties;
        "text-heading-xl-font-letter-spacing": import("./types").MetaTokenProperties;
        "text-heading-xl-font-line-height": import("./types").MetaTokenProperties;
        "text-heading-xl-font-size": import("./types").MetaTokenProperties;
        "text-heading-xl-font-weight": import("./types").MetaTokenProperties;
        "text-heading-lg-font-family": import("./types").MetaTokenProperties;
        "text-heading-lg-font-letter-spacing": import("./types").MetaTokenProperties;
        "text-heading-lg-font-line-height": import("./types").MetaTokenProperties;
        "text-heading-lg-font-size": import("./types").MetaTokenProperties;
        "text-heading-lg-font-weight": import("./types").MetaTokenProperties;
        "text-heading-md-font-family": import("./types").MetaTokenProperties;
        "text-heading-md-font-letter-spacing": import("./types").MetaTokenProperties;
        "text-heading-md-font-line-height": import("./types").MetaTokenProperties;
        "text-heading-md-font-size": import("./types").MetaTokenProperties;
        "text-heading-md-font-weight": import("./types").MetaTokenProperties;
        "text-heading-sm-font-family": import("./types").MetaTokenProperties;
        "text-heading-sm-font-letter-spacing": import("./types").MetaTokenProperties;
        "text-heading-sm-font-line-height": import("./types").MetaTokenProperties;
        "text-heading-sm-font-size": import("./types").MetaTokenProperties;
        "text-heading-sm-font-weight": import("./types").MetaTokenProperties;
        "text-heading-xs-font-family": import("./types").MetaTokenProperties;
        "text-heading-xs-font-letter-spacing": import("./types").MetaTokenProperties;
        "text-heading-xs-font-line-height": import("./types").MetaTokenProperties;
        "text-heading-xs-font-size": import("./types").MetaTokenProperties;
        "text-heading-xs-font-weight": import("./types").MetaTokenProperties;
        "text-body-lg-font-family": import("./types").MetaTokenProperties;
        "text-body-lg-font-letter-spacing": import("./types").MetaTokenProperties;
        "text-body-lg-font-line-height": import("./types").MetaTokenProperties;
        "text-body-lg-font-size": import("./types").MetaTokenProperties;
        "text-body-lg-font-weight": import("./types").MetaTokenProperties;
        "text-body-md-font-family": import("./types").MetaTokenProperties;
        "text-body-md-font-letter-spacing": import("./types").MetaTokenProperties;
        "text-body-md-font-line-height": import("./types").MetaTokenProperties;
        "text-body-md-font-size": import("./types").MetaTokenProperties;
        "text-body-md-font-weight": import("./types").MetaTokenProperties;
        "text-body-sm-font-family": import("./types").MetaTokenProperties;
        "text-body-sm-font-letter-spacing": import("./types").MetaTokenProperties;
        "text-body-sm-font-line-height": import("./types").MetaTokenProperties;
        "text-body-sm-font-size": import("./types").MetaTokenProperties;
        "text-body-sm-font-weight": import("./types").MetaTokenProperties;
        "text-body-xs-font-family": import("./types").MetaTokenProperties;
        "text-body-xs-font-letter-spacing": import("./types").MetaTokenProperties;
        "text-body-xs-font-line-height": import("./types").MetaTokenProperties;
        "text-body-xs-font-size": import("./types").MetaTokenProperties;
        "text-body-xs-font-weight": import("./types").MetaTokenProperties;
    };
    width: {
        "width-0": import("./types").MetaTokenProperties;
        "width-200": import("./types").MetaTokenProperties;
        "width-100": import("./types").MetaTokenProperties;
        "width-050": import("./types").MetaTokenProperties;
        "width-150": import("./types").MetaTokenProperties;
        "width-300": import("./types").MetaTokenProperties;
        "width-400": import("./types").MetaTokenProperties;
        "width-500": import("./types").MetaTokenProperties;
        "width-025": import("./types").MetaTokenProperties;
        "width-600": import("./types").MetaTokenProperties;
        "width-700": import("./types").MetaTokenProperties;
        "width-800": import("./types").MetaTokenProperties;
        "width-1000": import("./types").MetaTokenProperties;
        "width-1200": import("./types").MetaTokenProperties;
        "width-900": import("./types").MetaTokenProperties;
        "width-1600": import("./types").MetaTokenProperties;
        "width-2000": import("./types").MetaTokenProperties;
        "width-2400": import("./types").MetaTokenProperties;
        "width-2800": import("./types").MetaTokenProperties;
        "width-3200": import("./types").MetaTokenProperties;
    };
    zIndex: {
        "z-index-1": import("./types").MetaTokenProperties;
        "z-index-2": import("./types").MetaTokenProperties;
        "z-index-3": import("./types").MetaTokenProperties;
        "z-index-4": import("./types").MetaTokenProperties;
        "z-index-5": import("./types").MetaTokenProperties;
        "z-index-6": import("./types").MetaTokenProperties;
        "z-index-7": import("./types").MetaTokenProperties;
        "z-index-8": import("./types").MetaTokenProperties;
        "z-index-9": import("./types").MetaTokenProperties;
        "z-index-10": import("./types").MetaTokenProperties;
        "z-index-11": import("./types").MetaTokenProperties;
        "z-index-12": import("./types").MetaTokenProperties;
        "z-index-0": import("./types").MetaTokenProperties;
    };
};
//# sourceMappingURL=index.d.ts.map