import { begin, callback } from './oauth/oauth.mjs';
import { nonce } from './oauth/nonce.mjs';
import { safeCompare } from './oauth/safe-compare.mjs';
import { getEmbeddedAppUrl, buildEmbeddedAppUrl } from './get-embedded-app-url.mjs';
import { tokenExchange } from './oauth/token-exchange.mjs';

function shopifyAuth(config) {
    const shopify = {
        begin: begin(config),
        callback: callback(config),
        nonce,
        safeCompare,
        getEmbeddedAppUrl: getEmbeddedAppUrl(config),
        buildEmbeddedAppUrl: buildEmbeddedAppUrl(config),
        tokenExchange: tokenExchange(config),
    };
    return shopify;
}

export { shopifyAuth };
//# sourceMappingURL=index.mjs.map
