import React, { useEffect, useState } from "react";
import { useAuthenticatedFetch } from "../hooks/useAuthenticatedFetch.js";
import {
  Frame,
  Button,
  Page,
  Layout,
  Text,
  InlineStack,
  Card,
  Box,
  BlockStack,
} from "@shopify/polaris";

export default function Contact() {
  return (
    <Frame>
      <Page title="Contact Us">
        <Layout>
          <Layout.Section>
            <InlineStack align="center">
              <div style={{ margin: "30px 0", width: "100%" }}>
                <Card>
                  <BlockStack gap={400} align="space-between">
                    <Text variant="headingMd" fontWeight="regular" as="h6">
                      Contact Us For any kind of Support. We'll get to you
                      shortly
                    </Text>

                    <Box gap={400} align="space-between">
                      <Button primary url={"mailto:info@priorityprotection.io"}>
                        Contact Us
                      </Button>
                    </Box>
                  </BlockStack>
                </Card>
              </div>
            </InlineStack>
          </Layout.Section>
        </Layout>
      </Page>
    </Frame>
  );
}
