import {
  findPort
} from "./chunk-AUKMJHJ7.js";
import {
  ALIAS_NAME,
  ALL_ROUTE_CHOICES,
  CSS_STRATEGY_HELP_URL_MAP,
  CSS_STRATEGY_NAME_MAP,
  CustomerAccountPush,
  DEFAULT_APP_PORT,
  DEFAULT_INSPECTOR_PORT,
  GitDirectoryNotCleanError,
  I18N_CHOICES,
  I18N_STRATEGY_NAME_MAP,
  LANGUAGES,
  Link,
  SETUP_CSS_STRATEGIES,
  SETUP_I18N_STRATEGIES,
  STYLING_CHOICES,
  TUNNEL_DOMAIN,
  adminRequest,
  assertOxygenChecks,
  businessPlatformOrganizationsRequest,
  businessPlatformOrganizationsRequestDoc,
  businessPlatformRequest,
  businessPlatformRequestDoc,
  checkIfIgnoredInGitRepository,
  checkRemixVersions,
  commitAll,
  commonFlags,
  createAbortHandler,
  createDotEnvFileLine,
  createEnvironmentCliChoiceLabel,
  createInitialCommit,
  createPlatformShortcut,
  createRemixLogger,
  createStorefront,
  deprecated,
  downloadGitRepository,
  enhanceAuthLogs,
  enhanceH2Logs,
  ensureInsideGitDirectory,
  ensureIsClean,
  execAsync,
  findEnvironmentByBranchOrThrow,
  findEnvironmentOrThrow,
  findHydrogenPlugin,
  findOxygenPlugin,
  flagsToCamelObject,
  formatCode,
  generateProjectEntries,
  generateRoutes,
  getAllEnvironmentVariables,
  getAssetsDir,
  getCliCommand,
  getCodeFormatOptions,
  getConfig,
  getDebugBannerLine,
  getDevConfigInBackground,
  getLatestGitCommit,
  getProjectPaths,
  getRawRemixConfig,
  getRemixConfig,
  getRepoNodeModules,
  getSkeletonSourceDir,
  getStarterDir,
  getStorefrontEnvVariables,
  getStorefrontEnvironments,
  getStorefronts,
  getTemplateAppFile,
  getUtilityBannerlines,
  getViteConfig,
  handleCliShortcut,
  handleCssStrategy,
  handleDependencies,
  handleI18n,
  handleLanguage,
  handleMiniOxygenImportFail,
  handleProjectLocation,
  handleRemixImportFail,
  handleRouteGeneration,
  handleStorefrontLink,
  hasViteConfig,
  hydrogenPackagesPath,
  importLangAstGrep,
  importLocal,
  importVite,
  initializeGitRepository,
  isClassicProject,
  isClean,
  isH2Verbose,
  isHydrogenMonorepo,
  isMockShop,
  isV1RouteConventionInstalled,
  isViteProject,
  linkStorefront,
  logRequestLine,
  login,
  logout,
  mergePackageJson,
  mergeTsConfig,
  muteDevLogs,
  muteRemixLogs,
  notifyIssueWithTunnelAndMockShop,
  orderEnvironmentsBySafety,
  overrideFlag,
  parseGid,
  parseProcessFlags,
  patchEnvFile,
  readAndParseDotEnv,
  renderCssPrompt,
  renderI18nPrompt,
  renderLoginSuccess,
  renderProjectReady,
  replaceFileContent,
  setH2OVerbose,
  setStorefront,
  setUserAccount,
  setupCssStrategy,
  setupI18nStrategy,
  startTunnelAndPushConfig,
  supressNodeExperimentalWarnings,
  unsetStorefront,
  waitForJob,
  writeDotEnv
} from "./chunk-JRECCYJM.js";
import {
  require_lib as require_lib4
} from "./chunk-NUP5TATA.js";
import {
  require_normalize_path
} from "./chunk-PMUQTGZJ.js";
import {
  import_websocket_server
} from "./chunk-NCKQIOV4.js";
import {
  require_fs,
  require_glob,
  require_inflight,
  require_inherits
} from "./chunk-OXKHBIW7.js";
import {
  KitchenSinkStatic
} from "./chunk-3DZ2Z5F7.js";
import {
  Search
} from "./chunk-P2HC3CUV.js";
import {
  Upgrade
} from "./chunk-ECD63UWY.js";
import {
  getOutputUpdateCLIReminder
} from "./chunk-44VQQ5IT.js";
import {
  Version
} from "./chunk-ZTHIONMB.js";
import "./chunk-PCGPDW4N.js";
import "./chunk-74LQ7ZSW.js";
import {
  HelpCommand
} from "./chunk-ICYU4JKU.js";
import {
  KitchenSinkAsync
} from "./chunk-VZ6ZDQBM.js";
import {
  KitchenSinkAll
} from "./chunk-EARW2CGK.js";
import "./chunk-SVKRBSOG.js";
import "./chunk-AV2DDU5Q.js";
import {
  KitchenSinkPrompts
} from "./chunk-HJEKQ36N.js";
import "./chunk-GXXQT43J.js";
import {
  Logout
} from "./chunk-SQPCZKX5.js";
import {
  FunctionUploadUrlGenerateMutation,
  appManagementFqdn,
  checkPort,
  developerDashboardFqdn,
  ensureAuthenticatedAdmin,
  ensureAuthenticatedAppManagement,
  ensureAuthenticatedBusinessPlatform,
  ensureAuthenticatedPartners,
  ensureAuthenticatedStorefront,
  ensureAuthenticatedThemes,
  err,
  getRandomPort,
  graphqlRequest,
  graphqlRequestDoc,
  normalizeStoreFqdn,
  ok,
  partnersFqdn,
  partnersRequest,
  partnersRequestDoc,
  require_lib as require_lib3
} from "./chunk-MQCE7QDZ.js";
import {
  setNextDeprecationDate
} from "./chunk-LCWH3FW5.js";
import {
  CommandFlags
} from "./chunk-63OWMCSM.js";
import {
  Catalog
} from "./chunk-E5YZHXRF.js";
import {
  GenerateFile
} from "./chunk-47L545SZ.js";
import {
  Demo
} from "./chunk-OGVAYZHB.js";
import {
  PrintAIPrompt
} from "./chunk-GO4OU2FC.js";
import "./chunk-QSUS3GJF.js";
import "./chunk-3ZYNGWAE.js";
import {
  deepStrict,
  errorsToString,
  z
} from "./chunk-NLUGD7PZ.js";
import {
  DocsGenerate
} from "./chunk-V7KJMBZN.js";
import {
  base_command_default,
  decodeToml,
  encodeToml
} from "./chunk-ONFQ5XTX.js";
import {
  require_byline,
  require_end_of_stream,
  require_error_stack_parser,
  require_iserror,
  require_pump,
  require_stack_generator
} from "./chunk-QPYUGCEP.js";
import {
  ClientError,
  FetchError,
  buildHeaders,
  execCLI2,
  fanoutHooks,
  fetch as fetch2,
  formData,
  getBackendPort,
  getEnvironmentVariables,
  getListOfTunnelPlugins,
  getOrganization,
  gql,
  reportAnalyticsEvent,
  require_graphql,
  require_lib as require_lib2,
  require_mime_types,
  version
} from "./chunk-NLZ5VWA3.js";
import "./chunk-VSLR7ET4.js";
import {
  fileHash,
  hashString,
  randomUUID
} from "./chunk-PP4BSPLO.js";
import {
  platformAndArch,
  username
} from "./chunk-BPHTUL36.js";
import {
  LocalStorage,
  UnknownPackageManagerError,
  addNPMDependenciesIfNeeded,
  addResolutionOrOverride,
  checkForNewVersion,
  findUpAndReadPackageJson,
  getDependencies,
  getPackageManager,
  getPackageName,
  getPackageVersion,
  installNPMDependenciesRecursively,
  installNodeModules,
  lockfiles,
  packageManager,
  packageManagerFromUserAgent,
  readAndParsePackageJson,
  require_ajv,
  usesWorkspaces,
  versionSatisfies,
  writePackageJSON
} from "./chunk-N766LDXO.js";
import {
  require_semver
} from "./chunk-BYPQXSAL.js";
import {
  require_once
} from "./chunk-O5K4AU7Q.js";
import {
  CLI_KIT_VERSION
} from "./chunk-2J35X4IR.js";
import {
  AbortController as AbortController2,
  AbortError,
  AbortSignal,
  AbortSilentError,
  Box_default,
  BugError,
  CancelExecution,
  ConcurrentOutput,
  FatalError,
  Static,
  Text,
  addPublicMetadata,
  ansi_escapes_default,
  appHost,
  appPort,
  appendFile,
  camelize,
  capitalize,
  chmod,
  ciPlatform,
  codespacePortForwardingDomain,
  codespaceURL,
  collectLog,
  consoleError,
  consoleLog,
  consoleWarn,
  constantize,
  copyFile,
  createFileReadStream,
  createFileWriteStream,
  createRuntimeMetadataContainer,
  currentProcessIsGlobal,
  difference,
  exec,
  fetchSpinPort,
  figures_default,
  fileExists,
  fileExistsSync,
  fileHasExecutablePermissions,
  fileLastUpdatedTimestamp,
  fileRealPath,
  fileSize,
  fileSizeSync,
  findPathUp,
  firstPartyDev,
  formatDate,
  formatLocalDate,
  formatPackageManagerCommand,
  formatSection,
  generateRandomNameForSubdirectory,
  getArrayRejectingUndefined,
  getRandomName,
  gitpodURL,
  glob,
  handleCtrlC,
  hyphenate,
  import_ts_error,
  inTemporaryDirectory,
  inferPackageManagerForGlobalCLI,
  init_tslib_es6,
  installGlobalCLIPrompt,
  installGlobalShopifyCLI,
  isDirectory,
  isShopify,
  isSpin,
  isSpinEnvironment,
  isTTY,
  isTerminalInteractive,
  isTruthy,
  isUnitTest,
  isVerbose,
  itemToString,
  joinWithAnd,
  linesToColumns,
  matchGlob,
  mkdir,
  mkdirSync,
  moveFile,
  normalizeDelimitedString,
  npmRunPathEnv,
  openURL,
  outputCompleted,
  outputContent,
  outputDebug,
  outputInfo,
  outputNewline,
  outputSuccess,
  outputToken,
  outputWarn,
  pascalize,
  pluralize,
  printEventsJson,
  readFile,
  readFileSync,
  removeFile,
  renameFile,
  render,
  renderAutocompletePrompt,
  renderConcurrent,
  renderConfirmationPrompt,
  renderDangerousConfirmationPrompt,
  renderError,
  renderFatalError,
  renderInfo,
  renderSelectPrompt,
  renderSuccess,
  renderTable,
  renderTasks,
  renderText,
  renderTextPrompt,
  renderWarning,
  require_arrayLikeKeys,
  require_arrayMap,
  require_arrayPush,
  require_baseDifference,
  require_baseEach,
  require_baseFlatten,
  require_baseForOwn,
  require_baseGet,
  require_baseGetAllKeys,
  require_baseIsEqual,
  require_baseIteratee,
  require_baseKeys,
  require_baseRest,
  require_castPath,
  require_defineProperty,
  require_eq,
  require_get,
  require_getSymbols,
  require_getTag,
  require_isArguments,
  require_isArray,
  require_isArrayLike,
  require_isArrayLikeObject,
  require_isBuffer,
  require_isIndex,
  require_isObject,
  require_isPrototype,
  require_isTypedArray,
  require_keys,
  require_mapToArray,
  require_overArg,
  require_react,
  require_scheduler,
  require_stubArray,
  require_toKey,
  require_toString,
  rmdir,
  runWithTimer,
  sleep,
  sliceAnsi,
  slugify,
  source_default,
  spinFqdn,
  spinVariables,
  stringifyMessage,
  stripAnsi,
  temporaryDirectory,
  terminalSupportsRawMode,
  touchFile,
  treeKill,
  tryParseInt,
  tslib_es6_exports,
  uniq,
  uniqBy,
  unlinkFileSync,
  unstyled,
  useAbortSignal,
  useConcurrentOutputContext,
  useEmbeddedThemeCLI,
  useThemebundling,
  use_input_default,
  use_stdin_default,
  writeFile,
  writeFileSync
} from "./chunk-YK3ZIR2O.js";
import {
  require_signal_exit
} from "./chunk-QETDXAFX.js";
import {
  defaultThemeKitAccessDomain,
  environmentVariables,
  logsFolder
} from "./chunk-F6BSBHJJ.js";
import {
  require_lib
} from "./chunk-6DU4BL5F.js";
import {
  require_src
} from "./chunk-SNOECVP4.js";
import "./chunk-2AW6NZQ5.js";
import {
  require_brace_expansion,
  require_buffer_from
} from "./chunk-6XKWVDB6.js";
import "./chunk-UBB7JKND.js";
import {
  basename,
  cwd,
  dirname,
  extname,
  isSubpath,
  joinPath,
  moduleDirectory,
  normalizePath,
  relativePath,
  relativizePath,
  resolvePath,
  sniffForJson
} from "./chunk-T2GATXSP.js";
import {
  require_graceful_fs
} from "./chunk-XVNW332R.js";
import "./chunk-LAPJDMM4.js";
import "./chunk-7Q3MMWAC.js";
import {
  require_micromatch
} from "./chunk-F27QYMO7.js";
import "./chunk-ZFVK6EQX.js";
import "./chunk-522OB3EU.js";
import "./chunk-PNN7RS7Y.js";
import {
  __commonJS,
  __esm,
  __export,
  __require,
  __toCommonJS,
  __toESM,
  init_cjs_shims
} from "./chunk-POZ5MGPT.js";

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/common.js
var require_common = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/common.js"(exports) {
    "use strict";
    init_cjs_shims();
    var escapeStringFor = {};
    for (let c = 0; c < 128; c++)
      escapeStringFor[c] = String.fromCharCode(c);
    escapeStringFor[39] = "\\'";
    escapeStringFor[34] = '\\"';
    escapeStringFor[92] = "\\\\";
    escapeStringFor[8] = "\\b";
    escapeStringFor[12] = "\\f";
    escapeStringFor[10] = "\\n";
    escapeStringFor[13] = "\\r";
    escapeStringFor[9] = "\\t";
    escapeStringFor[11] = "\\v";
    exports.abstract = function(optMethodName) {
      let methodName = optMethodName || "";
      return function() {
        throw new Error(
          "this method " + methodName + " is abstract! (it has no implementation in class " + this.constructor.name + ")"
        );
      };
    };
    exports.assert = function(cond, message) {
      if (!cond)
        throw new Error(message || "Assertion failed");
    };
    exports.defineLazyProperty = function(obj, propName, getterFn) {
      let memo;
      Object.defineProperty(obj, propName, {
        get() {
          return memo || (memo = getterFn.call(this)), memo;
        }
      });
    };
    exports.clone = function(obj) {
      return obj && Object.assign({}, obj);
    };
    exports.repeatFn = function(fn, n) {
      let arr = [];
      for (; n-- > 0; )
        arr.push(fn());
      return arr;
    };
    exports.repeatStr = function(str, n) {
      return new Array(n + 1).join(str);
    };
    exports.repeat = function(x, n) {
      return exports.repeatFn(() => x, n);
    };
    exports.getDuplicates = function(array) {
      let duplicates = [];
      for (let idx = 0; idx < array.length; idx++) {
        let x = array[idx];
        array.lastIndexOf(x) !== idx && duplicates.indexOf(x) < 0 && duplicates.push(x);
      }
      return duplicates;
    };
    exports.copyWithoutDuplicates = function(array) {
      let noDuplicates = [];
      return array.forEach((entry) => {
        noDuplicates.indexOf(entry) < 0 && noDuplicates.push(entry);
      }), noDuplicates;
    };
    exports.isSyntactic = function(ruleName) {
      let firstChar = ruleName[0];
      return firstChar === firstChar.toUpperCase();
    };
    exports.isLexical = function(ruleName) {
      return !exports.isSyntactic(ruleName);
    };
    exports.padLeft = function(str, len, optChar) {
      let ch = optChar || " ";
      return str.length < len ? exports.repeatStr(ch, len - str.length) + str : str;
    };
    exports.StringBuffer = function() {
      this.strings = [];
    };
    exports.StringBuffer.prototype.append = function(str) {
      this.strings.push(str);
    };
    exports.StringBuffer.prototype.contents = function() {
      return this.strings.join("");
    };
    var escapeUnicode = (str) => String.fromCodePoint(parseInt(str, 16));
    exports.unescapeCodePoint = function(s) {
      if (s.charAt(0) === "\\")
        switch (s.charAt(1)) {
          case "b":
            return "\b";
          case "f":
            return "\f";
          case "n":
            return `
`;
          case "r":
            return "\r";
          case "t":
            return "	";
          case "v":
            return "\v";
          case "x":
            return escapeUnicode(s.slice(2, 4));
          case "u":
            return s.charAt(2) === "{" ? escapeUnicode(s.slice(3, -1)) : escapeUnicode(s.slice(2, 6));
          default:
            return s.charAt(1);
        }
      else
        return s;
    };
    exports.unexpectedObjToString = function(obj) {
      if (obj == null)
        return String(obj);
      let baseToString = Object.prototype.toString.call(obj);
      try {
        let typeName;
        return obj.constructor && obj.constructor.name ? typeName = obj.constructor.name : baseToString.indexOf("[object ") === 0 ? typeName = baseToString.slice(8, -1) : typeName = typeof obj, typeName + ": " + JSON.stringify(String(obj));
      } catch {
        return baseToString;
      }
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/extras/VisitorFamily.js
var require_VisitorFamily = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/extras/VisitorFamily.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var { assert } = require_common();
    function getProp(name, thing, fn) {
      return fn(thing[name]);
    }
    function mapProp(name, thing, fn) {
      return thing[name].map(fn);
    }
    function getPropWalkFn(descriptor) {
      let parts = descriptor.split(/ ?\[\]/);
      return parts.length === 2 ? mapProp.bind(null, parts[0]) : getProp.bind(null, descriptor);
    }
    function getProps(walkFns, thing, fn) {
      return walkFns.map((walkFn) => walkFn(thing, fn));
    }
    function getWalkFn(shape) {
      return typeof shape == "string" ? getProps.bind(null, [getPropWalkFn(shape)]) : Array.isArray(shape) ? getProps.bind(null, shape.map(getPropWalkFn)) : (assert(typeof shape == "function", "Expected a string, Array, or function"), assert(shape.length === 2, "Expected a function of arity 2, got " + shape.length), shape);
    }
    function isRestrictedIdentifier(str) {
      return /^[a-zA-Z_][0-9a-zA-Z_]*$/.test(str);
    }
    function trim(s) {
      return s.trim();
    }
    function parseSignature(sig) {
      let parts = sig.split(/[()]/).map(trim);
      if (parts.length === 3 && parts[2] === "") {
        let name = parts[0], params = [];
        if (parts[1].length > 0 && (params = parts[1].split(",").map(trim)), isRestrictedIdentifier(name) && params.every(isRestrictedIdentifier))
          return { name, formals: params };
      }
      throw new Error("Invalid operation signature: " + sig);
    }
    function VisitorFamily(config2) {
      this._shapes = config2.shapes, this._getTag = config2.getTag, this.Adapter = function(thing, family) {
        this._adaptee = thing, this._family = family;
      }, this.Adapter.prototype.valueOf = function() {
        throw new Error("heeey!");
      }, this.operations = {}, this._arities = /* @__PURE__ */ Object.create(null), this._getChildren = /* @__PURE__ */ Object.create(null), Object.keys(this._shapes).forEach((k) => {
        let shape = this._shapes[k];
        this._getChildren[k] = getWalkFn(shape), typeof shape != "function" && (this._arities[k] = Array.isArray(shape) ? shape.length : 1);
      }), this._wrap = (thing) => new this.Adapter(thing, this);
    }
    VisitorFamily.prototype.wrap = function(thing) {
      return this._wrap(thing);
    };
    VisitorFamily.prototype._checkActionDict = function(dict) {
      Object.keys(dict).forEach((k) => {
        assert(k in this._getChildren, "Unrecognized action name '" + k + "'");
        let action = dict[k];
        if (assert(typeof action == "function", "Key '" + k + "': expected function, got " + action), k in this._arities) {
          let expected = this._arities[k], actual = dict[k].length;
          assert(
            actual === expected,
            "Action '" + k + "' has the wrong arity: expected " + expected + ", got " + actual
          );
        }
      });
    };
    VisitorFamily.prototype.addOperation = function(signature, actions) {
      let sig = parseSignature(signature), { name } = sig;
      this._checkActionDict(actions), this.operations[name] = {
        name,
        formals: sig.formals,
        actions
      };
      let family = this;
      return this.Adapter.prototype[name] = function(...args) {
        let tag = family._getTag(this._adaptee);
        assert(tag in family._getChildren, "getTag returned unrecognized tag '" + tag + "'"), assert(tag in actions, "No action for '" + tag + "' in operation '" + name + "'");
        let argsObj = /* @__PURE__ */ Object.create(null);
        for (let [i, val] of Object.entries(args))
          argsObj[sig.formals[i]] = val;
        let oldArgs = this.args;
        this.args = argsObj;
        let ans = actions[tag].apply(
          this,
          family._getChildren[tag](this._adaptee, family._wrap)
        );
        return this.args = oldArgs, ans;
      }, this;
    };
    module.exports = VisitorFamily;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/extras/semantics-toAST.js
var require_semantics_toAST = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/extras/semantics-toAST.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var defaultOperation = {
      _terminal() {
        return this.sourceString;
      },
      _nonterminal(...children) {
        let { ctorName } = this._node, { mapping } = this.args;
        if (!Object.prototype.hasOwnProperty.call(mapping, ctorName)) {
          if (this.isLexical())
            return this.sourceString;
          let realChildren = children.filter((child) => !child.isTerminal());
          if (realChildren.length === 1)
            return realChildren[0].toAST(mapping);
        }
        if (typeof mapping[ctorName] == "number")
          return children[mapping[ctorName]].toAST(mapping);
        let propMap = mapping[ctorName] || children, node = {
          type: ctorName
        };
        for (let prop in propMap) {
          let mappedProp = mapping[ctorName] && mapping[ctorName][prop];
          typeof mappedProp == "number" ? node[prop] = children[mappedProp].toAST(mapping) : typeof mappedProp == "string" || typeof mappedProp == "boolean" || mappedProp === null ? node[prop] = mappedProp : typeof mappedProp == "object" && mappedProp instanceof Number ? node[prop] = Number(mappedProp) : typeof mappedProp == "function" ? node[prop] = mappedProp.call(this, children) : mappedProp === void 0 && (children[prop] && !children[prop].isTerminal() ? node[prop] = children[prop].toAST(mapping) : delete node[prop]);
        }
        return node;
      },
      _iter(...children) {
        return this._node.isOptional() ? this.numChildren === 0 ? null : children[0].toAST(this.args.mapping) : children.map(function(child) {
          return child.toAST(this.args.mapping);
        }, this);
      },
      NonemptyListOf(first, sep3, rest) {
        return [first.toAST(this.args.mapping)].concat(rest.toAST(this.args.mapping));
      },
      EmptyListOf() {
        return [];
      }
    };
    function toAST(res, mapping) {
      if (typeof res.failed != "function" || res.failed())
        throw new Error("toAST() expects a succesful MatchResult as first parameter");
      mapping = Object.assign({}, mapping);
      let operation = Object.assign({}, defaultOperation);
      for (let termName in mapping)
        typeof mapping[termName] == "function" && (operation[termName] = mapping[termName], delete mapping[termName]);
      return res._cst.grammar.createSemantics().addOperation("toAST(mapping)", operation)(res).toAST(mapping);
    }
    function semanticsForToAST(g) {
      if (typeof g.createSemantics != "function")
        throw new Error("semanticsToAST() expects a Grammar as parameter");
      return g.createSemantics().addOperation("toAST(mapping)", defaultOperation);
    }
    module.exports = {
      helper: toAST,
      semantics: semanticsForToAST
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/extras/index.js
var require_extras = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/extras/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = {
      VisitorFamily: require_VisitorFamily(),
      semanticsForToAST: require_semantics_toAST().semantics,
      toAST: require_semantics_toAST().helper
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/Failure.js
var require_Failure = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/Failure.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    function isValidType(type) {
      return type === "description" || type === "string" || type === "code";
    }
    function Failure(pexpr, text, type) {
      if (!isValidType(type))
        throw new Error("invalid Failure type: " + type);
      this.pexpr = pexpr, this.text = text, this.type = type, this.fluffy = !1;
    }
    Failure.prototype.getPExpr = function() {
      return this.pexpr;
    };
    Failure.prototype.getText = function() {
      return this.text;
    };
    Failure.prototype.getType = function() {
      return this.type;
    };
    Failure.prototype.isDescription = function() {
      return this.type === "description";
    };
    Failure.prototype.isStringTerminal = function() {
      return this.type === "string";
    };
    Failure.prototype.isCode = function() {
      return this.type === "code";
    };
    Failure.prototype.isFluffy = function() {
      return this.fluffy;
    };
    Failure.prototype.makeFluffy = function() {
      this.fluffy = !0;
    };
    Failure.prototype.clearFluffy = function() {
      this.fluffy = !1;
    };
    Failure.prototype.subsumes = function(that) {
      return this.getText() === that.getText() && this.type === that.type && (!this.isFluffy() || this.isFluffy() && that.isFluffy());
    };
    Failure.prototype.toString = function() {
      return this.type === "string" ? JSON.stringify(this.getText()) : this.getText();
    };
    Failure.prototype.clone = function() {
      let failure = new Failure(this.pexpr, this.text, this.type);
      return this.isFluffy() && failure.makeFluffy(), failure;
    };
    Failure.prototype.toKey = function() {
      return this.toString() + "#" + this.type;
    };
    module.exports = Failure;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/nodes.js
var require_nodes = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/nodes.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var common = require_common(), Node2 = class {
      constructor(matchLength) {
        this.matchLength = matchLength;
      }
      get ctorName() {
        throw new Error("subclass responsibility");
      }
      numChildren() {
        return this.children ? this.children.length : 0;
      }
      childAt(idx) {
        if (this.children)
          return this.children[idx];
      }
      indexOfChild(arg) {
        return this.children.indexOf(arg);
      }
      hasChildren() {
        return this.numChildren() > 0;
      }
      hasNoChildren() {
        return !this.hasChildren();
      }
      onlyChild() {
        if (this.numChildren() !== 1)
          throw new Error(
            "cannot get only child of a node of type " + this.ctorName + " (it has " + this.numChildren() + " children)"
          );
        return this.firstChild();
      }
      firstChild() {
        if (this.hasNoChildren())
          throw new Error(
            "cannot get first child of a " + this.ctorName + " node, which has no children"
          );
        return this.childAt(0);
      }
      lastChild() {
        if (this.hasNoChildren())
          throw new Error(
            "cannot get last child of a " + this.ctorName + " node, which has no children"
          );
        return this.childAt(this.numChildren() - 1);
      }
      childBefore(child) {
        let childIdx = this.indexOfChild(child);
        if (childIdx < 0)
          throw new Error("Node.childBefore() called w/ an argument that is not a child");
        if (childIdx === 0)
          throw new Error("cannot get child before first child");
        return this.childAt(childIdx - 1);
      }
      childAfter(child) {
        let childIdx = this.indexOfChild(child);
        if (childIdx < 0)
          throw new Error("Node.childAfter() called w/ an argument that is not a child");
        if (childIdx === this.numChildren() - 1)
          throw new Error("cannot get child after last child");
        return this.childAt(childIdx + 1);
      }
      isTerminal() {
        return !1;
      }
      isNonterminal() {
        return !1;
      }
      isIteration() {
        return !1;
      }
      isOptional() {
        return !1;
      }
    }, TerminalNode = class extends Node2 {
      get ctorName() {
        return "_terminal";
      }
      isTerminal() {
        return !0;
      }
      get primitiveValue() {
        throw new Error("The `primitiveValue` property was removed in Ohm v17.");
      }
    }, NonterminalNode = class extends Node2 {
      constructor(ruleName, children, childOffsets, matchLength) {
        super(matchLength), this.ruleName = ruleName, this.children = children, this.childOffsets = childOffsets;
      }
      get ctorName() {
        return this.ruleName;
      }
      isNonterminal() {
        return !0;
      }
      isLexical() {
        return common.isLexical(this.ctorName);
      }
      isSyntactic() {
        return common.isSyntactic(this.ctorName);
      }
    }, IterationNode = class extends Node2 {
      constructor(children, childOffsets, matchLength, isOptional) {
        super(matchLength), this.children = children, this.childOffsets = childOffsets, this.optional = isOptional;
      }
      get ctorName() {
        return "_iter";
      }
      isIteration() {
        return !0;
      }
      isOptional() {
        return this.optional;
      }
    };
    module.exports = {
      Node: Node2,
      TerminalNode,
      NonterminalNode,
      IterationNode
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/third_party/UnicodeCategories.js
var require_UnicodeCategories = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/third_party/UnicodeCategories.js"(exports, module) {
    init_cjs_shims();
    module.exports = {
      // Letters
      Lu: /[A-Z\xC0-\xD6\xD8-\xDE\u0100\u0102\u0104\u0106\u0108\u010A\u010C\u010E\u0110\u0112\u0114\u0116\u0118\u011A\u011C\u011E\u0120\u0122\u0124\u0126\u0128\u012A\u012C\u012E\u0130\u0132\u0134\u0136\u0139\u013B\u013D\u013F\u0141\u0143\u0145\u0147\u014A\u014C\u014E\u0150\u0152\u0154\u0156\u0158\u015A\u015C\u015E\u0160\u0162\u0164\u0166\u0168\u016A\u016C\u016E\u0170\u0172\u0174\u0176\u0178\u0179\u017B\u017D\u0181\u0182\u0184\u0186\u0187\u0189-\u018B\u018E-\u0191\u0193\u0194\u0196-\u0198\u019C\u019D\u019F\u01A0\u01A2\u01A4\u01A6\u01A7\u01A9\u01AC\u01AE\u01AF\u01B1-\u01B3\u01B5\u01B7\u01B8\u01BC\u01C4\u01C7\u01CA\u01CD\u01CF\u01D1\u01D3\u01D5\u01D7\u01D9\u01DB\u01DE\u01E0\u01E2\u01E4\u01E6\u01E8\u01EA\u01EC\u01EE\u01F1\u01F4\u01F6-\u01F8\u01FA\u01FC\u01FE\u0200\u0202\u0204\u0206\u0208\u020A\u020C\u020E\u0210\u0212\u0214\u0216\u0218\u021A\u021C\u021E\u0220\u0222\u0224\u0226\u0228\u022A\u022C\u022E\u0230\u0232\u023A\u023B\u023D\u023E\u0241\u0243-\u0246\u0248\u024A\u024C\u024E\u0370\u0372\u0376\u037F\u0386\u0388-\u038A\u038C\u038E\u038F\u0391-\u03A1\u03A3-\u03AB\u03CF\u03D2-\u03D4\u03D8\u03DA\u03DC\u03DE\u03E0\u03E2\u03E4\u03E6\u03E8\u03EA\u03EC\u03EE\u03F4\u03F7\u03F9\u03FA\u03FD-\u042F\u0460\u0462\u0464\u0466\u0468\u046A\u046C\u046E\u0470\u0472\u0474\u0476\u0478\u047A\u047C\u047E\u0480\u048A\u048C\u048E\u0490\u0492\u0494\u0496\u0498\u049A\u049C\u049E\u04A0\u04A2\u04A4\u04A6\u04A8\u04AA\u04AC\u04AE\u04B0\u04B2\u04B4\u04B6\u04B8\u04BA\u04BC\u04BE\u04C0\u04C1\u04C3\u04C5\u04C7\u04C9\u04CB\u04CD\u04D0\u04D2\u04D4\u04D6\u04D8\u04DA\u04DC\u04DE\u04E0\u04E2\u04E4\u04E6\u04E8\u04EA\u04EC\u04EE\u04F0\u04F2\u04F4\u04F6\u04F8\u04FA\u04FC\u04FE\u0500\u0502\u0504\u0506\u0508\u050A\u050C\u050E\u0510\u0512\u0514\u0516\u0518\u051A\u051C\u051E\u0520\u0522\u0524\u0526\u0528\u052A\u052C\u052E\u0531-\u0556\u10A0-\u10C5\u10C7\u10CD\u13A0-\u13F5\u1E00\u1E02\u1E04\u1E06\u1E08\u1E0A\u1E0C\u1E0E\u1E10\u1E12\u1E14\u1E16\u1E18\u1E1A\u1E1C\u1E1E\u1E20\u1E22\u1E24\u1E26\u1E28\u1E2A\u1E2C\u1E2E\u1E30\u1E32\u1E34\u1E36\u1E38\u1E3A\u1E3C\u1E3E\u1E40\u1E42\u1E44\u1E46\u1E48\u1E4A\u1E4C\u1E4E\u1E50\u1E52\u1E54\u1E56\u1E58\u1E5A\u1E5C\u1E5E\u1E60\u1E62\u1E64\u1E66\u1E68\u1E6A\u1E6C\u1E6E\u1E70\u1E72\u1E74\u1E76\u1E78\u1E7A\u1E7C\u1E7E\u1E80\u1E82\u1E84\u1E86\u1E88\u1E8A\u1E8C\u1E8E\u1E90\u1E92\u1E94\u1E9E\u1EA0\u1EA2\u1EA4\u1EA6\u1EA8\u1EAA\u1EAC\u1EAE\u1EB0\u1EB2\u1EB4\u1EB6\u1EB8\u1EBA\u1EBC\u1EBE\u1EC0\u1EC2\u1EC4\u1EC6\u1EC8\u1ECA\u1ECC\u1ECE\u1ED0\u1ED2\u1ED4\u1ED6\u1ED8\u1EDA\u1EDC\u1EDE\u1EE0\u1EE2\u1EE4\u1EE6\u1EE8\u1EEA\u1EEC\u1EEE\u1EF0\u1EF2\u1EF4\u1EF6\u1EF8\u1EFA\u1EFC\u1EFE\u1F08-\u1F0F\u1F18-\u1F1D\u1F28-\u1F2F\u1F38-\u1F3F\u1F48-\u1F4D\u1F59\u1F5B\u1F5D\u1F5F\u1F68-\u1F6F\u1FB8-\u1FBB\u1FC8-\u1FCB\u1FD8-\u1FDB\u1FE8-\u1FEC\u1FF8-\u1FFB\u2102\u2107\u210B-\u210D\u2110-\u2112\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u2130-\u2133\u213E\u213F\u2145\u2183\u2C00-\u2C2E\u2C60\u2C62-\u2C64\u2C67\u2C69\u2C6B\u2C6D-\u2C70\u2C72\u2C75\u2C7E-\u2C80\u2C82\u2C84\u2C86\u2C88\u2C8A\u2C8C\u2C8E\u2C90\u2C92\u2C94\u2C96\u2C98\u2C9A\u2C9C\u2C9E\u2CA0\u2CA2\u2CA4\u2CA6\u2CA8\u2CAA\u2CAC\u2CAE\u2CB0\u2CB2\u2CB4\u2CB6\u2CB8\u2CBA\u2CBC\u2CBE\u2CC0\u2CC2\u2CC4\u2CC6\u2CC8\u2CCA\u2CCC\u2CCE\u2CD0\u2CD2\u2CD4\u2CD6\u2CD8\u2CDA\u2CDC\u2CDE\u2CE0\u2CE2\u2CEB\u2CED\u2CF2\uA640\uA642\uA644\uA646\uA648\uA64A\uA64C\uA64E\uA650\uA652\uA654\uA656\uA658\uA65A\uA65C\uA65E\uA660\uA662\uA664\uA666\uA668\uA66A\uA66C\uA680\uA682\uA684\uA686\uA688\uA68A\uA68C\uA68E\uA690\uA692\uA694\uA696\uA698\uA69A\uA722\uA724\uA726\uA728\uA72A\uA72C\uA72E\uA732\uA734\uA736\uA738\uA73A\uA73C\uA73E\uA740\uA742\uA744\uA746\uA748\uA74A\uA74C\uA74E\uA750\uA752\uA754\uA756\uA758\uA75A\uA75C\uA75E\uA760\uA762\uA764\uA766\uA768\uA76A\uA76C\uA76E\uA779\uA77B\uA77D\uA77E\uA780\uA782\uA784\uA786\uA78B\uA78D\uA790\uA792\uA796\uA798\uA79A\uA79C\uA79E\uA7A0\uA7A2\uA7A4\uA7A6\uA7A8\uA7AA-\uA7AE\uA7B0-\uA7B4\uA7B6\uFF21-\uFF3A]|\uD801[\uDC00-\uDC27\uDCB0-\uDCD3]|\uD803[\uDC80-\uDCB2]|\uD806[\uDCA0-\uDCBF]|\uD835[\uDC00-\uDC19\uDC34-\uDC4D\uDC68-\uDC81\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB5\uDCD0-\uDCE9\uDD04\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD38\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD6C-\uDD85\uDDA0-\uDDB9\uDDD4-\uDDED\uDE08-\uDE21\uDE3C-\uDE55\uDE70-\uDE89\uDEA8-\uDEC0\uDEE2-\uDEFA\uDF1C-\uDF34\uDF56-\uDF6E\uDF90-\uDFA8\uDFCA]|\uD83A[\uDD00-\uDD21]/,
      Ll: /[a-z\xB5\xDF-\xF6\xF8-\xFF\u0101\u0103\u0105\u0107\u0109\u010B\u010D\u010F\u0111\u0113\u0115\u0117\u0119\u011B\u011D\u011F\u0121\u0123\u0125\u0127\u0129\u012B\u012D\u012F\u0131\u0133\u0135\u0137\u0138\u013A\u013C\u013E\u0140\u0142\u0144\u0146\u0148\u0149\u014B\u014D\u014F\u0151\u0153\u0155\u0157\u0159\u015B\u015D\u015F\u0161\u0163\u0165\u0167\u0169\u016B\u016D\u016F\u0171\u0173\u0175\u0177\u017A\u017C\u017E-\u0180\u0183\u0185\u0188\u018C\u018D\u0192\u0195\u0199-\u019B\u019E\u01A1\u01A3\u01A5\u01A8\u01AA\u01AB\u01AD\u01B0\u01B4\u01B6\u01B9\u01BA\u01BD-\u01BF\u01C6\u01C9\u01CC\u01CE\u01D0\u01D2\u01D4\u01D6\u01D8\u01DA\u01DC\u01DD\u01DF\u01E1\u01E3\u01E5\u01E7\u01E9\u01EB\u01ED\u01EF\u01F0\u01F3\u01F5\u01F9\u01FB\u01FD\u01FF\u0201\u0203\u0205\u0207\u0209\u020B\u020D\u020F\u0211\u0213\u0215\u0217\u0219\u021B\u021D\u021F\u0221\u0223\u0225\u0227\u0229\u022B\u022D\u022F\u0231\u0233-\u0239\u023C\u023F\u0240\u0242\u0247\u0249\u024B\u024D\u024F-\u0293\u0295-\u02AF\u0371\u0373\u0377\u037B-\u037D\u0390\u03AC-\u03CE\u03D0\u03D1\u03D5-\u03D7\u03D9\u03DB\u03DD\u03DF\u03E1\u03E3\u03E5\u03E7\u03E9\u03EB\u03ED\u03EF-\u03F3\u03F5\u03F8\u03FB\u03FC\u0430-\u045F\u0461\u0463\u0465\u0467\u0469\u046B\u046D\u046F\u0471\u0473\u0475\u0477\u0479\u047B\u047D\u047F\u0481\u048B\u048D\u048F\u0491\u0493\u0495\u0497\u0499\u049B\u049D\u049F\u04A1\u04A3\u04A5\u04A7\u04A9\u04AB\u04AD\u04AF\u04B1\u04B3\u04B5\u04B7\u04B9\u04BB\u04BD\u04BF\u04C2\u04C4\u04C6\u04C8\u04CA\u04CC\u04CE\u04CF\u04D1\u04D3\u04D5\u04D7\u04D9\u04DB\u04DD\u04DF\u04E1\u04E3\u04E5\u04E7\u04E9\u04EB\u04ED\u04EF\u04F1\u04F3\u04F5\u04F7\u04F9\u04FB\u04FD\u04FF\u0501\u0503\u0505\u0507\u0509\u050B\u050D\u050F\u0511\u0513\u0515\u0517\u0519\u051B\u051D\u051F\u0521\u0523\u0525\u0527\u0529\u052B\u052D\u052F\u0561-\u0587\u13F8-\u13FD\u1C80-\u1C88\u1D00-\u1D2B\u1D6B-\u1D77\u1D79-\u1D9A\u1E01\u1E03\u1E05\u1E07\u1E09\u1E0B\u1E0D\u1E0F\u1E11\u1E13\u1E15\u1E17\u1E19\u1E1B\u1E1D\u1E1F\u1E21\u1E23\u1E25\u1E27\u1E29\u1E2B\u1E2D\u1E2F\u1E31\u1E33\u1E35\u1E37\u1E39\u1E3B\u1E3D\u1E3F\u1E41\u1E43\u1E45\u1E47\u1E49\u1E4B\u1E4D\u1E4F\u1E51\u1E53\u1E55\u1E57\u1E59\u1E5B\u1E5D\u1E5F\u1E61\u1E63\u1E65\u1E67\u1E69\u1E6B\u1E6D\u1E6F\u1E71\u1E73\u1E75\u1E77\u1E79\u1E7B\u1E7D\u1E7F\u1E81\u1E83\u1E85\u1E87\u1E89\u1E8B\u1E8D\u1E8F\u1E91\u1E93\u1E95-\u1E9D\u1E9F\u1EA1\u1EA3\u1EA5\u1EA7\u1EA9\u1EAB\u1EAD\u1EAF\u1EB1\u1EB3\u1EB5\u1EB7\u1EB9\u1EBB\u1EBD\u1EBF\u1EC1\u1EC3\u1EC5\u1EC7\u1EC9\u1ECB\u1ECD\u1ECF\u1ED1\u1ED3\u1ED5\u1ED7\u1ED9\u1EDB\u1EDD\u1EDF\u1EE1\u1EE3\u1EE5\u1EE7\u1EE9\u1EEB\u1EED\u1EEF\u1EF1\u1EF3\u1EF5\u1EF7\u1EF9\u1EFB\u1EFD\u1EFF-\u1F07\u1F10-\u1F15\u1F20-\u1F27\u1F30-\u1F37\u1F40-\u1F45\u1F50-\u1F57\u1F60-\u1F67\u1F70-\u1F7D\u1F80-\u1F87\u1F90-\u1F97\u1FA0-\u1FA7\u1FB0-\u1FB4\u1FB6\u1FB7\u1FBE\u1FC2-\u1FC4\u1FC6\u1FC7\u1FD0-\u1FD3\u1FD6\u1FD7\u1FE0-\u1FE7\u1FF2-\u1FF4\u1FF6\u1FF7\u210A\u210E\u210F\u2113\u212F\u2134\u2139\u213C\u213D\u2146-\u2149\u214E\u2184\u2C30-\u2C5E\u2C61\u2C65\u2C66\u2C68\u2C6A\u2C6C\u2C71\u2C73\u2C74\u2C76-\u2C7B\u2C81\u2C83\u2C85\u2C87\u2C89\u2C8B\u2C8D\u2C8F\u2C91\u2C93\u2C95\u2C97\u2C99\u2C9B\u2C9D\u2C9F\u2CA1\u2CA3\u2CA5\u2CA7\u2CA9\u2CAB\u2CAD\u2CAF\u2CB1\u2CB3\u2CB5\u2CB7\u2CB9\u2CBB\u2CBD\u2CBF\u2CC1\u2CC3\u2CC5\u2CC7\u2CC9\u2CCB\u2CCD\u2CCF\u2CD1\u2CD3\u2CD5\u2CD7\u2CD9\u2CDB\u2CDD\u2CDF\u2CE1\u2CE3\u2CE4\u2CEC\u2CEE\u2CF3\u2D00-\u2D25\u2D27\u2D2D\uA641\uA643\uA645\uA647\uA649\uA64B\uA64D\uA64F\uA651\uA653\uA655\uA657\uA659\uA65B\uA65D\uA65F\uA661\uA663\uA665\uA667\uA669\uA66B\uA66D\uA681\uA683\uA685\uA687\uA689\uA68B\uA68D\uA68F\uA691\uA693\uA695\uA697\uA699\uA69B\uA723\uA725\uA727\uA729\uA72B\uA72D\uA72F-\uA731\uA733\uA735\uA737\uA739\uA73B\uA73D\uA73F\uA741\uA743\uA745\uA747\uA749\uA74B\uA74D\uA74F\uA751\uA753\uA755\uA757\uA759\uA75B\uA75D\uA75F\uA761\uA763\uA765\uA767\uA769\uA76B\uA76D\uA76F\uA771-\uA778\uA77A\uA77C\uA77F\uA781\uA783\uA785\uA787\uA78C\uA78E\uA791\uA793-\uA795\uA797\uA799\uA79B\uA79D\uA79F\uA7A1\uA7A3\uA7A5\uA7A7\uA7A9\uA7B5\uA7B7\uA7FA\uAB30-\uAB5A\uAB60-\uAB65\uAB70-\uABBF\uFB00-\uFB06\uFB13-\uFB17\uFF41-\uFF5A]|\uD801[\uDC28-\uDC4F\uDCD8-\uDCFB]|\uD803[\uDCC0-\uDCF2]|\uD806[\uDCC0-\uDCDF]|\uD835[\uDC1A-\uDC33\uDC4E-\uDC54\uDC56-\uDC67\uDC82-\uDC9B\uDCB6-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDCCF\uDCEA-\uDD03\uDD1E-\uDD37\uDD52-\uDD6B\uDD86-\uDD9F\uDDBA-\uDDD3\uDDEE-\uDE07\uDE22-\uDE3B\uDE56-\uDE6F\uDE8A-\uDEA5\uDEC2-\uDEDA\uDEDC-\uDEE1\uDEFC-\uDF14\uDF16-\uDF1B\uDF36-\uDF4E\uDF50-\uDF55\uDF70-\uDF88\uDF8A-\uDF8F\uDFAA-\uDFC2\uDFC4-\uDFC9\uDFCB]|\uD83A[\uDD22-\uDD43]/,
      Lt: /[\u01C5\u01C8\u01CB\u01F2\u1F88-\u1F8F\u1F98-\u1F9F\u1FA8-\u1FAF\u1FBC\u1FCC\u1FFC]/,
      Lm: /[\u02B0-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0374\u037A\u0559\u0640\u06E5\u06E6\u07F4\u07F5\u07FA\u081A\u0824\u0828\u0971\u0E46\u0EC6\u10FC\u17D7\u1843\u1AA7\u1C78-\u1C7D\u1D2C-\u1D6A\u1D78\u1D9B-\u1DBF\u2071\u207F\u2090-\u209C\u2C7C\u2C7D\u2D6F\u2E2F\u3005\u3031-\u3035\u303B\u309D\u309E\u30FC-\u30FE\uA015\uA4F8-\uA4FD\uA60C\uA67F\uA69C\uA69D\uA717-\uA71F\uA770\uA788\uA7F8\uA7F9\uA9CF\uA9E6\uAA70\uAADD\uAAF3\uAAF4\uAB5C-\uAB5F\uFF70\uFF9E\uFF9F]|\uD81A[\uDF40-\uDF43]|\uD81B[\uDF93-\uDF9F\uDFE0]/,
      Lo: /[\xAA\xBA\u01BB\u01C0-\u01C3\u0294\u05D0-\u05EA\u05F0-\u05F2\u0620-\u063F\u0641-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u0800-\u0815\u0840-\u0858\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0972-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E45\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10D0-\u10FA\u10FD-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16F1-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17DC\u1820-\u1842\u1844-\u1877\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C77\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u2135-\u2138\u2D30-\u2D67\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3006\u303C\u3041-\u3096\u309F\u30A1-\u30FA\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA014\uA016-\uA48C\uA4D0-\uA4F7\uA500-\uA60B\uA610-\uA61F\uA62A\uA62B\uA66E\uA6A0-\uA6E5\uA78F\uA7F7\uA7FB-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9E0-\uA9E4\uA9E7-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA6F\uAA71-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB\uAADC\uAAE0-\uAAEA\uAAF2\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uABC0-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF66-\uFF6F\uFF71-\uFF9D\uFFA0-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF30-\uDF40\uDF42-\uDF49\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF]|\uD801[\uDC50-\uDC9D\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF19]|\uD806[\uDCFF\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC72-\uDC8F]|\uD808[\uDC00-\uDF99]|\uD809[\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD83A[\uDC00-\uDCC4]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]/,
      // Numbers
      Nl: /[\u16EE-\u16F0\u2160-\u2182\u2185-\u2188\u3007\u3021-\u3029\u3038-\u303A\uA6E6-\uA6EF]|\uD800[\uDD40-\uDD74\uDF41\uDF4A\uDFD1-\uDFD5]|\uD809[\uDC00-\uDC6E]/,
      Nd: /[0-9\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0BE6-\u0BEF\u0C66-\u0C6F\u0CE6-\u0CEF\u0D66-\u0D6F\u0DE6-\u0DEF\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F29\u1040-\u1049\u1090-\u1099\u17E0-\u17E9\u1810-\u1819\u1946-\u194F\u19D0-\u19D9\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\uA620-\uA629\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uA9F0-\uA9F9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19]|\uD801[\uDCA0-\uDCA9]|\uD804[\uDC66-\uDC6F\uDCF0-\uDCF9\uDD36-\uDD3F\uDDD0-\uDDD9\uDEF0-\uDEF9]|[\uD805\uD807][\uDC50-\uDC59\uDCD0-\uDCD9\uDE50-\uDE59\uDEC0-\uDEC9\uDF30-\uDF39]|\uD806[\uDCE0-\uDCE9]|\uD81A[\uDE60-\uDE69\uDF50-\uDF59]|\uD835[\uDFCE-\uDFFF]|\uD83A[\uDD50-\uDD59]/,
      // Marks
      Mn: /[\u0300-\u036F\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u065F\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u0711\u0730-\u074A\u07A6-\u07B0\u07EB-\u07F3\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u08D4-\u08E1\u08E3-\u0902\u093A\u093C\u0941-\u0948\u094D\u0951-\u0957\u0962\u0963\u0981\u09BC\u09C1-\u09C4\u09CD\u09E2\u09E3\u0A01\u0A02\u0A3C\u0A41\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A70\u0A71\u0A75\u0A81\u0A82\u0ABC\u0AC1-\u0AC5\u0AC7\u0AC8\u0ACD\u0AE2\u0AE3\u0B01\u0B3C\u0B3F\u0B41-\u0B44\u0B4D\u0B56\u0B62\u0B63\u0B82\u0BC0\u0BCD\u0C00\u0C3E-\u0C40\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C81\u0CBC\u0CBF\u0CC6\u0CCC\u0CCD\u0CE2\u0CE3\u0D01\u0D41-\u0D44\u0D4D\u0D62\u0D63\u0DCA\u0DD2-\u0DD4\u0DD6\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0EB1\u0EB4-\u0EB9\u0EBB\u0EBC\u0EC8-\u0ECD\u0F18\u0F19\u0F35\u0F37\u0F39\u0F71-\u0F7E\u0F80-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102D-\u1030\u1032-\u1037\u1039\u103A\u103D\u103E\u1058\u1059\u105E-\u1060\u1071-\u1074\u1082\u1085\u1086\u108D\u109D\u135D-\u135F\u1712-\u1714\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4\u17B5\u17B7-\u17BD\u17C6\u17C9-\u17D3\u17DD\u180B-\u180D\u1885\u1886\u18A9\u1920-\u1922\u1927\u1928\u1932\u1939-\u193B\u1A17\u1A18\u1A1B\u1A56\u1A58-\u1A5E\u1A60\u1A62\u1A65-\u1A6C\u1A73-\u1A7C\u1A7F\u1AB0-\u1ABD\u1B00-\u1B03\u1B34\u1B36-\u1B3A\u1B3C\u1B42\u1B6B-\u1B73\u1B80\u1B81\u1BA2-\u1BA5\u1BA8\u1BA9\u1BAB-\u1BAD\u1BE6\u1BE8\u1BE9\u1BED\u1BEF-\u1BF1\u1C2C-\u1C33\u1C36\u1C37\u1CD0-\u1CD2\u1CD4-\u1CE0\u1CE2-\u1CE8\u1CED\u1CF4\u1CF8\u1CF9\u1DC0-\u1DF5\u1DFB-\u1DFF\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302D\u3099\u309A\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA825\uA826\uA8C4\uA8C5\uA8E0-\uA8F1\uA926-\uA92D\uA947-\uA951\uA980-\uA982\uA9B3\uA9B6-\uA9B9\uA9BC\uA9E5\uAA29-\uAA2E\uAA31\uAA32\uAA35\uAA36\uAA43\uAA4C\uAA7C\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEC\uAAED\uAAF6\uABE5\uABE8\uABED\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F]|\uD800[\uDDFD\uDEE0\uDF76-\uDF7A]|\uD802[\uDE01-\uDE03\uDE05\uDE06\uDE0C-\uDE0F\uDE38-\uDE3A\uDE3F\uDEE5\uDEE6]|\uD804[\uDC01\uDC38-\uDC46\uDC7F-\uDC81\uDCB3-\uDCB6\uDCB9\uDCBA\uDD00-\uDD02\uDD27-\uDD2B\uDD2D-\uDD34\uDD73\uDD80\uDD81\uDDB6-\uDDBE\uDDCA-\uDDCC\uDE2F-\uDE31\uDE34\uDE36\uDE37\uDE3E\uDEDF\uDEE3-\uDEEA\uDF00\uDF01\uDF3C\uDF40\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDC38-\uDC3F\uDC42-\uDC44\uDC46\uDCB3-\uDCB8\uDCBA\uDCBF\uDCC0\uDCC2\uDCC3\uDDB2-\uDDB5\uDDBC\uDDBD\uDDBF\uDDC0\uDDDC\uDDDD\uDE33-\uDE3A\uDE3D\uDE3F\uDE40\uDEAB\uDEAD\uDEB0-\uDEB5\uDEB7\uDF1D-\uDF1F\uDF22-\uDF25\uDF27-\uDF2B]|\uD807[\uDC30-\uDC36\uDC38-\uDC3D\uDC3F\uDC92-\uDCA7\uDCAA-\uDCB0\uDCB2\uDCB3\uDCB5\uDCB6]|\uD81A[\uDEF0-\uDEF4\uDF30-\uDF36]|\uD81B[\uDF8F-\uDF92]|\uD82F[\uDC9D\uDC9E]|\uD834[\uDD67-\uDD69\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD836[\uDE00-\uDE36\uDE3B-\uDE6C\uDE75\uDE84\uDE9B-\uDE9F\uDEA1-\uDEAF]|\uD838[\uDC00-\uDC06\uDC08-\uDC18\uDC1B-\uDC21\uDC23\uDC24\uDC26-\uDC2A]|\uD83A[\uDCD0-\uDCD6\uDD44-\uDD4A]|\uDB40[\uDD00-\uDDEF]/,
      Mc: /[\u0903-\u0903]|[\u093E-\u0940]|[\u0949-\u094C]|[\u0982-\u0983]|[\u09BE-\u09C0]|[\u09C7-\u09C8]|[\u09CB-\u09CC]|[\u09D7-\u09D7]|[\u0A3E-\u0A40]|[\u0A83-\u0A83]|[\u0ABE-\u0AC0]|[\u0AC9-\u0AC9]|[\u0ACB-\u0ACC]|[\u0B02-\u0B03]|[\u0B3E-\u0B3E]|[\u0B40-\u0B40]|[\u0B47-\u0B48]|[\u0B4B-\u0B4C]|[\u0B57-\u0B57]|[\u0B83-\u0B83]|[\u0BBE-\u0BBF]|[\u0BC1-\u0BC2]|[\u0BC6-\u0BC8]|[\u0BCA-\u0BCC]|[\u0BD7-\u0BD7]|[\u0C01-\u0C03]|[\u0C41-\u0C44]|[\u0C82-\u0C83]|[\u0CBE-\u0CBE]|[\u0CC0-\u0CC4]|[\u0CC7-\u0CC8]|[\u0CCA-\u0CCB]|[\u0CD5-\u0CD6]|[\u0D02-\u0D03]|[\u0D3E-\u0D40]|[\u0D46-\u0D48]|[\u0D4A-\u0D4C]|[\u0D57-\u0D57]|[\u0F3E-\u0F3F]|[\u0F7F-\u0F7F]/,
      // Punctuation, Connector
      Pc: /[_\u203F\u2040\u2054\uFE33\uFE34\uFE4D-\uFE4F\uFF3F]/,
      // Separator, Space
      Zs: /[ \xA0\u1680\u2000-\u200A\u202F\u205F\u3000]/,
      // These two are not real Unicode categories, but our useful for Ohm.
      // L is a combination of all the letter categories.
      // Ltmo is a combination of Lt, Lm, and Lo.
      L: /[A-Za-z\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16F1-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2183\u2184\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005\u3006\u3031-\u3035\u303B\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6E5\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF30-\uDF40\uDF42-\uDF49\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF]|\uD801[\uDC00-\uDC9D\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF19]|\uD806[\uDCA0-\uDCDF\uDCFF\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC72-\uDC8F]|\uD808[\uDC00-\uDF99]|\uD809[\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50\uDF93-\uDF9F\uDFE0]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4\uDD00-\uDD43]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]/,
      Ltmo: /[\u01C5\u01C8\u01CB\u01F2\u1F88-\u1F8F\u1F98-\u1F9F\u1FA8-\u1FAF\u1FBC\u1FCC\u1FFC]|[\u02B0-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0374\u037A\u0559\u0640\u06E5\u06E6\u07F4\u07F5\u07FA\u081A\u0824\u0828\u0971\u0E46\u0EC6\u10FC\u17D7\u1843\u1AA7\u1C78-\u1C7D\u1D2C-\u1D6A\u1D78\u1D9B-\u1DBF\u2071\u207F\u2090-\u209C\u2C7C\u2C7D\u2D6F\u2E2F\u3005\u3031-\u3035\u303B\u309D\u309E\u30FC-\u30FE\uA015\uA4F8-\uA4FD\uA60C\uA67F\uA69C\uA69D\uA717-\uA71F\uA770\uA788\uA7F8\uA7F9\uA9CF\uA9E6\uAA70\uAADD\uAAF3\uAAF4\uAB5C-\uAB5F\uFF70\uFF9E\uFF9F]|\uD81A[\uDF40-\uDF43]|\uD81B[\uDF93-\uDF9F\uDFE0]|[\xAA\xBA\u01BB\u01C0-\u01C3\u0294\u05D0-\u05EA\u05F0-\u05F2\u0620-\u063F\u0641-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u0800-\u0815\u0840-\u0858\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0972-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E45\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10D0-\u10FA\u10FD-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16F1-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17DC\u1820-\u1842\u1844-\u1877\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C77\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u2135-\u2138\u2D30-\u2D67\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3006\u303C\u3041-\u3096\u309F\u30A1-\u30FA\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA014\uA016-\uA48C\uA4D0-\uA4F7\uA500-\uA60B\uA610-\uA61F\uA62A\uA62B\uA66E\uA6A0-\uA6E5\uA78F\uA7F7\uA7FB-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9E0-\uA9E4\uA9E7-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA6F\uAA71-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB\uAADC\uAAE0-\uAAEA\uAAF2\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uABC0-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF66-\uFF6F\uFF71-\uFF9D\uFFA0-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF30-\uDF40\uDF42-\uDF49\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF]|\uD801[\uDC50-\uDC9D\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF19]|\uD806[\uDCFF\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC72-\uDC8F]|\uD808[\uDC00-\uDF99]|\uD809[\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD83A[\uDC00-\uDCC4]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]/
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-main.js
var require_pexprs_main = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-main.js"(exports) {
    "use strict";
    init_cjs_shims();
    var UnicodeCategories = require_UnicodeCategories(), common = require_common(), PExpr = class _PExpr {
      constructor() {
        if (this.constructor === _PExpr)
          throw new Error("PExpr cannot be instantiated -- it's abstract");
      }
      // Set the `source` property to the interval containing the source for this expression.
      withSource(interval) {
        return interval && (this.source = interval.trimmed()), this;
      }
    }, any = Object.create(PExpr.prototype), end = Object.create(PExpr.prototype), Terminal = class extends PExpr {
      constructor(obj) {
        super(), this.obj = obj;
      }
    }, Range3 = class extends PExpr {
      constructor(from, to) {
        super(), this.from = from, this.to = to, this.matchCodePoint = from.length > 1 || to.length > 1;
      }
    }, Param = class extends PExpr {
      constructor(index) {
        super(), this.index = index;
      }
    }, Alt = class extends PExpr {
      constructor(terms) {
        super(), this.terms = terms;
      }
    }, Extend = class extends Alt {
      constructor(superGrammar, name, body) {
        let origBody = superGrammar.rules[name].body;
        super([body, origBody]), this.superGrammar = superGrammar, this.name = name, this.body = body;
      }
    }, Splice = class extends Alt {
      constructor(superGrammar, ruleName, beforeTerms, afterTerms) {
        let origBody = superGrammar.rules[ruleName].body;
        super([...beforeTerms, origBody, ...afterTerms]), this.superGrammar = superGrammar, this.ruleName = ruleName, this.expansionPos = beforeTerms.length;
      }
    }, Seq = class extends PExpr {
      constructor(factors) {
        super(), this.factors = factors;
      }
    }, Iter = class extends PExpr {
      constructor(expr) {
        super(), this.expr = expr;
      }
    }, Star = class extends Iter {
    }, Plus = class extends Iter {
    }, Opt = class extends Iter {
    };
    Star.prototype.operator = "*";
    Plus.prototype.operator = "+";
    Opt.prototype.operator = "?";
    Star.prototype.minNumMatches = 0;
    Plus.prototype.minNumMatches = 1;
    Opt.prototype.minNumMatches = 0;
    Star.prototype.maxNumMatches = Number.POSITIVE_INFINITY;
    Plus.prototype.maxNumMatches = Number.POSITIVE_INFINITY;
    Opt.prototype.maxNumMatches = 1;
    var Not = class extends PExpr {
      constructor(expr) {
        super(), this.expr = expr;
      }
    }, Lookahead = class extends PExpr {
      constructor(expr) {
        super(), this.expr = expr;
      }
    }, Lex = class extends PExpr {
      constructor(expr) {
        super(), this.expr = expr;
      }
    }, Apply = class extends PExpr {
      constructor(ruleName, args = []) {
        super(), this.ruleName = ruleName, this.args = args;
      }
      isSyntactic() {
        return common.isSyntactic(this.ruleName);
      }
      // This method just caches the result of `this.toString()` in a non-enumerable property.
      toMemoKey() {
        return this._memoKey || Object.defineProperty(this, "_memoKey", { value: this.toString() }), this._memoKey;
      }
    }, UnicodeChar = class extends PExpr {
      constructor(category) {
        super(), this.category = category, this.pattern = UnicodeCategories[category];
      }
    };
    exports.PExpr = PExpr;
    exports.any = any;
    exports.end = end;
    exports.Terminal = Terminal;
    exports.Range = Range3;
    exports.Param = Param;
    exports.Alt = Alt;
    exports.Extend = Extend;
    exports.Splice = Splice;
    exports.Seq = Seq;
    exports.Iter = Iter;
    exports.Star = Star;
    exports.Plus = Plus;
    exports.Opt = Opt;
    exports.Not = Not;
    exports.Lookahead = Lookahead;
    exports.Lex = Lex;
    exports.Apply = Apply;
    exports.UnicodeChar = UnicodeChar;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-allowsSkippingPrecedingSpace.js
var require_pexprs_allowsSkippingPrecedingSpace = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-allowsSkippingPrecedingSpace.js"() {
    "use strict";
    init_cjs_shims();
    var common = require_common(), pexprs = require_pexprs_main();
    pexprs.PExpr.prototype.allowsSkippingPrecedingSpace = common.abstract(
      "allowsSkippingPrecedingSpace"
    );
    pexprs.any.allowsSkippingPrecedingSpace = pexprs.end.allowsSkippingPrecedingSpace = pexprs.Apply.prototype.allowsSkippingPrecedingSpace = pexprs.Terminal.prototype.allowsSkippingPrecedingSpace = pexprs.Range.prototype.allowsSkippingPrecedingSpace = pexprs.UnicodeChar.prototype.allowsSkippingPrecedingSpace = function() {
      return !0;
    };
    pexprs.Alt.prototype.allowsSkippingPrecedingSpace = pexprs.Iter.prototype.allowsSkippingPrecedingSpace = pexprs.Lex.prototype.allowsSkippingPrecedingSpace = pexprs.Lookahead.prototype.allowsSkippingPrecedingSpace = pexprs.Not.prototype.allowsSkippingPrecedingSpace = pexprs.Param.prototype.allowsSkippingPrecedingSpace = pexprs.Seq.prototype.allowsSkippingPrecedingSpace = function() {
      return !1;
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/Namespace.js
var require_Namespace = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/Namespace.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    function Namespace() {
    }
    Namespace.prototype = /* @__PURE__ */ Object.create(null);
    Namespace.asNamespace = function(objOrNamespace) {
      return objOrNamespace instanceof Namespace ? objOrNamespace : Namespace.createNamespace(objOrNamespace);
    };
    Namespace.createNamespace = function(optProps) {
      return Namespace.extend(Namespace.prototype, optProps);
    };
    Namespace.extend = function(namespace, optProps) {
      if (namespace !== Namespace.prototype && !(namespace instanceof Namespace))
        throw new TypeError("not a Namespace object: " + namespace);
      let ns = Object.create(namespace, {
        constructor: {
          value: Namespace,
          enumerable: !1,
          writable: !0,
          configurable: !0
        }
      });
      return Object.assign(ns, optProps);
    };
    Namespace.toString = function(ns) {
      return Object.prototype.toString.call(ns);
    };
    module.exports = Namespace;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/errors.js
var require_errors = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/errors.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var { assert } = require_common(), Namespace = require_Namespace(), pexprs = require_pexprs_main();
    function createError2(message, optInterval) {
      let e;
      return optInterval ? (e = new Error(optInterval.getLineAndColumnMessage() + message), e.shortMessage = message, e.interval = optInterval) : e = new Error(message), e;
    }
    function intervalSourcesDontMatch() {
      return createError2("Interval sources don't match");
    }
    function grammarSyntaxError(matchFailure) {
      let e = new Error();
      return Object.defineProperty(e, "message", {
        enumerable: !0,
        get() {
          return matchFailure.message;
        }
      }), Object.defineProperty(e, "shortMessage", {
        enumerable: !0,
        get() {
          return "Expected " + matchFailure.getExpectedText();
        }
      }), e.interval = matchFailure.getInterval(), e;
    }
    function undeclaredGrammar(grammarName, namespace, interval) {
      let message = namespace ? "Grammar " + grammarName + " is not declared in namespace " + Namespace.toString(namespace) : "Undeclared grammar " + grammarName;
      return createError2(message, interval);
    }
    function duplicateGrammarDeclaration(grammar, namespace) {
      return createError2("Grammar " + grammar.name + " is already declared in this namespace");
    }
    function undeclaredRule(ruleName, grammarName, optInterval) {
      return createError2(
        "Rule " + ruleName + " is not declared in grammar " + grammarName,
        optInterval
      );
    }
    function cannotOverrideUndeclaredRule(ruleName, grammarName, optSource) {
      return createError2(
        "Cannot override rule " + ruleName + " because it is not declared in " + grammarName,
        optSource
      );
    }
    function cannotExtendUndeclaredRule(ruleName, grammarName, optSource) {
      return createError2(
        "Cannot extend rule " + ruleName + " because it is not declared in " + grammarName,
        optSource
      );
    }
    function duplicateRuleDeclaration(ruleName, grammarName, declGrammarName, optSource) {
      let message = "Duplicate declaration for rule '" + ruleName + "' in grammar '" + grammarName + "'";
      return grammarName !== declGrammarName && (message += " (originally declared in '" + declGrammarName + "')"), createError2(message, optSource);
    }
    function wrongNumberOfParameters(ruleName, expected, actual, source) {
      return createError2(
        "Wrong number of parameters for rule " + ruleName + " (expected " + expected + ", got " + actual + ")",
        source
      );
    }
    function wrongNumberOfArguments(ruleName, expected, actual, expr) {
      return createError2(
        "Wrong number of arguments for rule " + ruleName + " (expected " + expected + ", got " + actual + ")",
        expr
      );
    }
    function duplicateParameterNames(ruleName, duplicates, source) {
      return createError2(
        "Duplicate parameter names in rule " + ruleName + ": " + duplicates.join(", "),
        source
      );
    }
    function invalidParameter(ruleName, expr) {
      return createError2(
        "Invalid parameter to rule " + ruleName + ": " + expr + " has arity " + expr.getArity() + ", but parameter expressions must have arity 1",
        expr.source
      );
    }
    var syntacticVsLexicalNote = "NOTE: A _syntactic rule_ is a rule whose name begins with a capital letter. See https://ohmjs.org/d/svl for more details.";
    function applicationOfSyntacticRuleFromLexicalContext(ruleName, applyExpr) {
      return createError2(
        "Cannot apply syntactic rule " + ruleName + " from here (inside a lexical context)",
        applyExpr.source
      );
    }
    function applySyntacticWithLexicalRuleApplication(applyExpr) {
      let { ruleName } = applyExpr;
      return createError2(
        `applySyntactic is for syntactic rules, but '${ruleName}' is a lexical rule. ` + syntacticVsLexicalNote,
        applyExpr.source
      );
    }
    function unnecessaryExperimentalApplySyntactic(applyExpr) {
      return createError2(
        "applySyntactic is not required here (in a syntactic context)",
        applyExpr.source
      );
    }
    function incorrectArgumentType(expectedType, expr) {
      return createError2("Incorrect argument type: expected " + expectedType, expr.source);
    }
    function multipleSuperSplices(expr) {
      return createError2("'...' can appear at most once in a rule body", expr.source);
    }
    function invalidCodePoint(applyWrapper) {
      let node = applyWrapper._node;
      assert(node && node.isNonterminal() && node.ctorName === "escapeChar_unicodeCodePoint");
      let digitIntervals = applyWrapper.children.slice(1, -1).map((d) => d.source), fullInterval = digitIntervals[0].coverageWith(...digitIntervals.slice(1));
      return createError2(
        `U+${fullInterval.contents} is not a valid Unicode code point`,
        fullInterval
      );
    }
    function kleeneExprHasNullableOperand(kleeneExpr, applicationStack) {
      let actuals = applicationStack.length > 0 ? applicationStack[applicationStack.length - 1].args : [], message = "Nullable expression " + kleeneExpr.expr.substituteParams(actuals) + " is not allowed inside '" + kleeneExpr.operator + "' (possible infinite loop)";
      if (applicationStack.length > 0) {
        let stackTrace = applicationStack.map((app) => new pexprs.Apply(app.ruleName, app.args)).join(`
`);
        message += `
Application stack (most recent application last):
` + stackTrace;
      }
      return createError2(message, kleeneExpr.expr.source);
    }
    function inconsistentArity(ruleName, expected, actual, expr) {
      return createError2(
        "Rule " + ruleName + " involves an alternation which has inconsistent arity (expected " + expected + ", got " + actual + ")",
        expr.source
      );
    }
    function duplicatePropertyNames(duplicates) {
      return createError2("Object pattern has duplicate property names: " + duplicates.join(", "));
    }
    function invalidConstructorCall(grammar, ctorName, children) {
      return createError2(
        "Attempt to invoke constructor " + ctorName + " with invalid or unexpected arguments"
      );
    }
    function multipleErrors(errors2) {
      let messages = errors2.map((e) => e.message);
      return createError2(["Errors:"].concat(messages).join(`
- `), errors2[0].interval);
    }
    function missingSemanticAction(ctorName, name, type, stack) {
      let stackTrace = stack.slice(0, -1).map((info2) => {
        let ans = "  " + info2[0].name + " > " + info2[1];
        return info2.length === 3 ? ans + " for '" + info2[2] + "'" : ans;
      }).join(`
`);
      stackTrace += `
  ` + name + " > " + ctorName;
      let moreInfo = "";
      ctorName === "_iter" && (moreInfo = [
        `
NOTE: as of Ohm v16, there is no default action for iteration nodes \u2014 see `,
        "  https://ohmjs.org/d/dsa for details."
      ].join(`
`));
      let message = [
        `Missing semantic action for '${ctorName}' in ${type} '${name}'.${moreInfo}`,
        "Action stack (most recent call last):",
        stackTrace
      ].join(`
`), e = createError2(message);
      return e.name = "missingSemanticAction", e;
    }
    module.exports = {
      applicationOfSyntacticRuleFromLexicalContext,
      applySyntacticWithLexicalRuleApplication,
      cannotExtendUndeclaredRule,
      cannotOverrideUndeclaredRule,
      duplicateGrammarDeclaration,
      duplicateParameterNames,
      duplicatePropertyNames,
      duplicateRuleDeclaration,
      inconsistentArity,
      incorrectArgumentType,
      intervalSourcesDontMatch,
      invalidCodePoint,
      invalidConstructorCall,
      invalidParameter,
      grammarSyntaxError,
      kleeneExprHasNullableOperand,
      missingSemanticAction,
      multipleSuperSplices,
      undeclaredGrammar,
      undeclaredRule,
      unnecessaryExperimentalApplySyntactic,
      wrongNumberOfArguments,
      wrongNumberOfParameters,
      throwErrors(errors2) {
        if (errors2.length === 1)
          throw errors2[0];
        if (errors2.length > 1)
          throw multipleErrors(errors2);
      }
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/util.js
var require_util = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/util.js"(exports) {
    "use strict";
    init_cjs_shims();
    var common = require_common();
    function padNumbersToEqualLength(arr) {
      let maxLen = 0;
      return arr.map((n) => {
        let str = n.toString();
        return maxLen = Math.max(maxLen, str.length), str;
      }).map((s) => common.padLeft(s, maxLen));
    }
    function strcpy(dest, src, offset) {
      let origDestLen = dest.length, start = dest.slice(0, offset), end = dest.slice(offset + src.length);
      return (start + src + end).substr(0, origDestLen);
    }
    function lineAndColumnToMessage(...ranges) {
      let lineAndCol = this, { offset } = lineAndCol, { repeatStr } = common, sb = new common.StringBuffer();
      sb.append("Line " + lineAndCol.lineNum + ", col " + lineAndCol.colNum + `:
`);
      let lineNumbers = padNumbersToEqualLength([
        lineAndCol.prevLine == null ? 0 : lineAndCol.lineNum - 1,
        lineAndCol.lineNum,
        lineAndCol.nextLine == null ? 0 : lineAndCol.lineNum + 1
      ]), appendLine = (num, content, prefix) => {
        sb.append(prefix + lineNumbers[num] + " | " + content + `
`);
      };
      lineAndCol.prevLine != null && appendLine(0, lineAndCol.prevLine, "  "), appendLine(1, lineAndCol.line, "> ");
      let lineLen = lineAndCol.line.length, indicationLine = repeatStr(" ", lineLen + 1);
      for (let i = 0; i < ranges.length; ++i) {
        let startIdx = ranges[i][0], endIdx = ranges[i][1];
        common.assert(startIdx >= 0 && startIdx <= endIdx, "range start must be >= 0 and <= end");
        let lineStartOffset = offset - lineAndCol.colNum + 1;
        startIdx = Math.max(0, startIdx - lineStartOffset), endIdx = Math.min(endIdx - lineStartOffset, lineLen), indicationLine = strcpy(indicationLine, repeatStr("~", endIdx - startIdx), startIdx);
      }
      let gutterWidth = 2 + lineNumbers[1].length + 3;
      return sb.append(repeatStr(" ", gutterWidth)), indicationLine = strcpy(indicationLine, "^", lineAndCol.colNum - 1), sb.append(indicationLine.replace(/ +$/, "") + `
`), lineAndCol.nextLine != null && appendLine(2, lineAndCol.nextLine, "  "), sb.contents();
    }
    var builtInRulesCallbacks = [];
    exports.awaitBuiltInRules = (cb) => {
      builtInRulesCallbacks.push(cb);
    };
    exports.announceBuiltInRules = (grammar) => {
      builtInRulesCallbacks.forEach((cb) => {
        cb(grammar);
      }), builtInRulesCallbacks = null;
    };
    exports.getLineAndColumn = (str, offset) => {
      let lineNum = 1, colNum = 1, currOffset = 0, lineStartOffset = 0, nextLine = null, prevLine = null, prevLineStartOffset = -1;
      for (; currOffset < offset; ) {
        let c = str.charAt(currOffset++);
        c === `
` ? (lineNum++, colNum = 1, prevLineStartOffset = lineStartOffset, lineStartOffset = currOffset) : c !== "\r" && colNum++;
      }
      let lineEndOffset = str.indexOf(`
`, lineStartOffset);
      if (lineEndOffset === -1)
        lineEndOffset = str.length;
      else {
        let nextLineEndOffset = str.indexOf(`
`, lineEndOffset + 1);
        nextLine = nextLineEndOffset === -1 ? str.slice(lineEndOffset) : str.slice(lineEndOffset, nextLineEndOffset), nextLine = nextLine.replace(/^\r?\n/, "").replace(/\r$/, "");
      }
      prevLineStartOffset >= 0 && (prevLine = str.slice(prevLineStartOffset, lineStartOffset).replace(/\r?\n$/, ""));
      let line = str.slice(lineStartOffset, lineEndOffset).replace(/\r$/, "");
      return {
        offset,
        lineNum,
        colNum,
        line,
        prevLine,
        nextLine,
        toString: lineAndColumnToMessage
      };
    };
    exports.getLineAndColumnMessage = function(str, offset, ...ranges) {
      return exports.getLineAndColumn(str, offset).toString(...ranges);
    };
    exports.uniqueId = /* @__PURE__ */ (() => {
      let idCounter3 = 0;
      return (prefix) => "" + prefix + idCounter3++;
    })();
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-assertAllApplicationsAreValid.js
var require_pexprs_assertAllApplicationsAreValid = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-assertAllApplicationsAreValid.js"() {
    "use strict";
    init_cjs_shims();
    var { abstract, isSyntactic } = require_common(), errors2 = require_errors(), pexprs = require_pexprs_main(), util2 = require_util(), BuiltInRules;
    util2.awaitBuiltInRules((g) => {
      BuiltInRules = g;
    });
    var lexifyCount;
    pexprs.PExpr.prototype.assertAllApplicationsAreValid = function(ruleName, grammar) {
      lexifyCount = 0, this._assertAllApplicationsAreValid(ruleName, grammar);
    };
    pexprs.PExpr.prototype._assertAllApplicationsAreValid = abstract(
      "_assertAllApplicationsAreValid"
    );
    pexprs.any._assertAllApplicationsAreValid = pexprs.end._assertAllApplicationsAreValid = pexprs.Terminal.prototype._assertAllApplicationsAreValid = pexprs.Range.prototype._assertAllApplicationsAreValid = pexprs.Param.prototype._assertAllApplicationsAreValid = pexprs.UnicodeChar.prototype._assertAllApplicationsAreValid = function(ruleName, grammar) {
    };
    pexprs.Lex.prototype._assertAllApplicationsAreValid = function(ruleName, grammar) {
      lexifyCount++, this.expr._assertAllApplicationsAreValid(ruleName, grammar), lexifyCount--;
    };
    pexprs.Alt.prototype._assertAllApplicationsAreValid = function(ruleName, grammar) {
      for (let idx = 0; idx < this.terms.length; idx++)
        this.terms[idx]._assertAllApplicationsAreValid(ruleName, grammar);
    };
    pexprs.Seq.prototype._assertAllApplicationsAreValid = function(ruleName, grammar) {
      for (let idx = 0; idx < this.factors.length; idx++)
        this.factors[idx]._assertAllApplicationsAreValid(ruleName, grammar);
    };
    pexprs.Iter.prototype._assertAllApplicationsAreValid = pexprs.Not.prototype._assertAllApplicationsAreValid = pexprs.Lookahead.prototype._assertAllApplicationsAreValid = function(ruleName, grammar) {
      this.expr._assertAllApplicationsAreValid(ruleName, grammar);
    };
    pexprs.Apply.prototype._assertAllApplicationsAreValid = function(ruleName, grammar, skipSyntacticCheck = !1) {
      let ruleInfo = grammar.rules[this.ruleName], isContextSyntactic = isSyntactic(ruleName) && lexifyCount === 0;
      if (!ruleInfo)
        throw errors2.undeclaredRule(this.ruleName, grammar.name, this.source);
      if (!skipSyntacticCheck && isSyntactic(this.ruleName) && !isContextSyntactic)
        throw errors2.applicationOfSyntacticRuleFromLexicalContext(this.ruleName, this);
      let actual = this.args.length, expected = ruleInfo.formals.length;
      if (actual !== expected)
        throw errors2.wrongNumberOfArguments(this.ruleName, expected, actual, this.source);
      let isBuiltInApplySyntactic = BuiltInRules && ruleInfo === BuiltInRules.rules.applySyntactic;
      if (BuiltInRules && ruleInfo === BuiltInRules.rules.caseInsensitive && !(this.args[0] instanceof pexprs.Terminal))
        throw errors2.incorrectArgumentType('a Terminal (e.g. "abc")', this.args[0]);
      if (isBuiltInApplySyntactic) {
        let arg = this.args[0];
        if (!(arg instanceof pexprs.Apply))
          throw errors2.incorrectArgumentType("a syntactic rule application", arg);
        if (!isSyntactic(arg.ruleName))
          throw errors2.applySyntacticWithLexicalRuleApplication(arg);
        if (isContextSyntactic)
          throw errors2.unnecessaryExperimentalApplySyntactic(this);
      }
      this.args.forEach((arg) => {
        if (arg._assertAllApplicationsAreValid(ruleName, grammar, isBuiltInApplySyntactic), arg.getArity() !== 1)
          throw errors2.invalidParameter(this.ruleName, arg);
      });
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-assertChoicesHaveUniformArity.js
var require_pexprs_assertChoicesHaveUniformArity = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-assertChoicesHaveUniformArity.js"() {
    "use strict";
    init_cjs_shims();
    var common = require_common(), errors2 = require_errors(), pexprs = require_pexprs_main();
    pexprs.PExpr.prototype.assertChoicesHaveUniformArity = common.abstract(
      "assertChoicesHaveUniformArity"
    );
    pexprs.any.assertChoicesHaveUniformArity = pexprs.end.assertChoicesHaveUniformArity = pexprs.Terminal.prototype.assertChoicesHaveUniformArity = pexprs.Range.prototype.assertChoicesHaveUniformArity = pexprs.Param.prototype.assertChoicesHaveUniformArity = pexprs.Lex.prototype.assertChoicesHaveUniformArity = pexprs.UnicodeChar.prototype.assertChoicesHaveUniformArity = function(ruleName) {
    };
    pexprs.Alt.prototype.assertChoicesHaveUniformArity = function(ruleName) {
      if (this.terms.length === 0)
        return;
      let arity = this.terms[0].getArity();
      for (let idx = 0; idx < this.terms.length; idx++) {
        let term = this.terms[idx];
        term.assertChoicesHaveUniformArity();
        let otherArity = term.getArity();
        if (arity !== otherArity)
          throw errors2.inconsistentArity(ruleName, arity, otherArity, term);
      }
    };
    pexprs.Extend.prototype.assertChoicesHaveUniformArity = function(ruleName) {
      let actualArity = this.terms[0].getArity(), expectedArity = this.terms[1].getArity();
      if (actualArity !== expectedArity)
        throw errors2.inconsistentArity(ruleName, expectedArity, actualArity, this.terms[0]);
    };
    pexprs.Seq.prototype.assertChoicesHaveUniformArity = function(ruleName) {
      for (let idx = 0; idx < this.factors.length; idx++)
        this.factors[idx].assertChoicesHaveUniformArity(ruleName);
    };
    pexprs.Iter.prototype.assertChoicesHaveUniformArity = function(ruleName) {
      this.expr.assertChoicesHaveUniformArity(ruleName);
    };
    pexprs.Not.prototype.assertChoicesHaveUniformArity = function(ruleName) {
    };
    pexprs.Lookahead.prototype.assertChoicesHaveUniformArity = function(ruleName) {
      this.expr.assertChoicesHaveUniformArity(ruleName);
    };
    pexprs.Apply.prototype.assertChoicesHaveUniformArity = function(ruleName) {
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-assertIteratedExprsAreNotNullable.js
var require_pexprs_assertIteratedExprsAreNotNullable = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-assertIteratedExprsAreNotNullable.js"() {
    "use strict";
    init_cjs_shims();
    var common = require_common(), errors2 = require_errors(), pexprs = require_pexprs_main();
    pexprs.PExpr.prototype.assertIteratedExprsAreNotNullable = common.abstract(
      "assertIteratedExprsAreNotNullable"
    );
    pexprs.any.assertIteratedExprsAreNotNullable = pexprs.end.assertIteratedExprsAreNotNullable = pexprs.Terminal.prototype.assertIteratedExprsAreNotNullable = pexprs.Range.prototype.assertIteratedExprsAreNotNullable = pexprs.Param.prototype.assertIteratedExprsAreNotNullable = pexprs.UnicodeChar.prototype.assertIteratedExprsAreNotNullable = function(grammar) {
    };
    pexprs.Alt.prototype.assertIteratedExprsAreNotNullable = function(grammar) {
      for (let idx = 0; idx < this.terms.length; idx++)
        this.terms[idx].assertIteratedExprsAreNotNullable(grammar);
    };
    pexprs.Seq.prototype.assertIteratedExprsAreNotNullable = function(grammar) {
      for (let idx = 0; idx < this.factors.length; idx++)
        this.factors[idx].assertIteratedExprsAreNotNullable(grammar);
    };
    pexprs.Iter.prototype.assertIteratedExprsAreNotNullable = function(grammar) {
      if (this.expr.assertIteratedExprsAreNotNullable(grammar), this.expr.isNullable(grammar))
        throw errors2.kleeneExprHasNullableOperand(this, []);
    };
    pexprs.Opt.prototype.assertIteratedExprsAreNotNullable = pexprs.Not.prototype.assertIteratedExprsAreNotNullable = pexprs.Lookahead.prototype.assertIteratedExprsAreNotNullable = pexprs.Lex.prototype.assertIteratedExprsAreNotNullable = function(grammar) {
      this.expr.assertIteratedExprsAreNotNullable(grammar);
    };
    pexprs.Apply.prototype.assertIteratedExprsAreNotNullable = function(grammar) {
      this.args.forEach((arg) => {
        arg.assertIteratedExprsAreNotNullable(grammar);
      });
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/Interval.js
var require_Interval = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/Interval.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var { assert } = require_common(), errors2 = require_errors(), util2 = require_util();
    function Interval(sourceString, startIdx, endIdx) {
      this.sourceString = sourceString, this.startIdx = startIdx, this.endIdx = endIdx;
    }
    Interval.coverage = function(firstInterval, ...intervals) {
      let { startIdx, endIdx } = firstInterval;
      for (let interval of intervals) {
        if (interval.sourceString !== firstInterval.sourceString)
          throw errors2.intervalSourcesDontMatch();
        startIdx = Math.min(startIdx, interval.startIdx), endIdx = Math.max(endIdx, interval.endIdx);
      }
      return new Interval(firstInterval.sourceString, startIdx, endIdx);
    };
    Interval.prototype = {
      coverageWith(...intervals) {
        return Interval.coverage(...intervals, this);
      },
      collapsedLeft() {
        return new Interval(this.sourceString, this.startIdx, this.startIdx);
      },
      collapsedRight() {
        return new Interval(this.sourceString, this.endIdx, this.endIdx);
      },
      getLineAndColumn() {
        return util2.getLineAndColumn(this.sourceString, this.startIdx);
      },
      getLineAndColumnMessage() {
        let range = [this.startIdx, this.endIdx];
        return util2.getLineAndColumnMessage(this.sourceString, this.startIdx, range);
      },
      // Returns an array of 0, 1, or 2 intervals that represents the result of the
      // interval difference operation.
      minus(that) {
        if (this.sourceString !== that.sourceString)
          throw errors2.intervalSourcesDontMatch();
        return this.startIdx === that.startIdx && this.endIdx === that.endIdx ? [] : this.startIdx < that.startIdx && that.endIdx < this.endIdx ? [
          new Interval(this.sourceString, this.startIdx, that.startIdx),
          new Interval(this.sourceString, that.endIdx, this.endIdx)
        ] : this.startIdx < that.endIdx && that.endIdx < this.endIdx ? [new Interval(this.sourceString, that.endIdx, this.endIdx)] : this.startIdx < that.startIdx && that.startIdx < this.endIdx ? [new Interval(this.sourceString, this.startIdx, that.startIdx)] : [this];
      },
      // Returns a new Interval that has the same extent as this one, but which is relative
      // to `that`, an Interval that fully covers this one.
      relativeTo(that) {
        if (this.sourceString !== that.sourceString)
          throw errors2.intervalSourcesDontMatch();
        return assert(
          this.startIdx >= that.startIdx && this.endIdx <= that.endIdx,
          "other interval does not cover this one"
        ), new Interval(
          this.sourceString,
          this.startIdx - that.startIdx,
          this.endIdx - that.startIdx
        );
      },
      // Returns a new Interval which contains the same contents as this one,
      // but with whitespace trimmed from both ends.
      trimmed() {
        let { contents } = this, startIdx = this.startIdx + contents.match(/^\s*/)[0].length, endIdx = this.endIdx - contents.match(/\s*$/)[0].length;
        return new Interval(this.sourceString, startIdx, endIdx);
      },
      subInterval(offset, len) {
        let newStartIdx = this.startIdx + offset;
        return new Interval(this.sourceString, newStartIdx, newStartIdx + len);
      }
    };
    Object.defineProperties(Interval.prototype, {
      contents: {
        get() {
          return this._contents === void 0 && (this._contents = this.sourceString.slice(this.startIdx, this.endIdx)), this._contents;
        },
        enumerable: !0
      },
      length: {
        get() {
          return this.endIdx - this.startIdx;
        },
        enumerable: !0
      }
    });
    module.exports = Interval;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/Trace.js
var require_Trace = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/Trace.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Interval = require_Interval(), common = require_common(), BALLOT_X = "\u2717", CHECK_MARK = "\u2713", DOT_OPERATOR = "\u22C5", RIGHTWARDS_DOUBLE_ARROW = "\u21D2", SYMBOL_FOR_HORIZONTAL_TABULATION = "\u2409", SYMBOL_FOR_LINE_FEED = "\u240A", SYMBOL_FOR_CARRIAGE_RETURN = "\u240D", Flags52 = {
      succeeded: 1,
      isRootNode: 2,
      isImplicitSpaces: 4,
      isMemoized: 8,
      isHeadOfLeftRecursion: 16,
      terminatesLR: 32
    };
    function spaces(n) {
      return common.repeat(" ", n).join("");
    }
    function getInputExcerpt(input, pos, len) {
      let excerpt = asEscapedString(input.slice(pos, pos + len));
      return excerpt.length < len ? excerpt + common.repeat(" ", len - excerpt.length).join("") : excerpt;
    }
    function asEscapedString(obj) {
      return typeof obj == "string" ? obj.replace(/ /g, DOT_OPERATOR).replace(/\t/g, SYMBOL_FOR_HORIZONTAL_TABULATION).replace(/\n/g, SYMBOL_FOR_LINE_FEED).replace(/\r/g, SYMBOL_FOR_CARRIAGE_RETURN) : String(obj);
    }
    function Trace(input, pos1, pos2, expr, succeeded, bindings, optChildren) {
      this.input = input, this.pos = this.pos1 = pos1, this.pos2 = pos2, this.source = new Interval(input, pos1, pos2), this.expr = expr, this.bindings = bindings, this.children = optChildren || [], this.terminatingLREntry = null, this._flags = succeeded ? Flags52.succeeded : 0;
    }
    Trace.prototype.SKIP = {};
    Object.defineProperty(Trace.prototype, "displayString", {
      get() {
        return this.expr.toDisplayString();
      }
    });
    Object.keys(Flags52).forEach((name) => {
      let mask = Flags52[name];
      Object.defineProperty(Trace.prototype, name, {
        get() {
          return (this._flags & mask) !== 0;
        },
        set(val) {
          val ? this._flags |= mask : this._flags &= ~mask;
        }
      });
    });
    Trace.prototype.clone = function() {
      return this.cloneWithExpr(this.expr);
    };
    Trace.prototype.cloneWithExpr = function(expr) {
      let ans = new Trace(
        this.input,
        this.pos,
        this.pos2,
        expr,
        this.succeeded,
        this.bindings,
        this.children
      );
      return ans.isHeadOfLeftRecursion = this.isHeadOfLeftRecursion, ans.isImplicitSpaces = this.isImplicitSpaces, ans.isMemoized = this.isMemoized, ans.isRootNode = this.isRootNode, ans.terminatesLR = this.terminatesLR, ans.terminatingLREntry = this.terminatingLREntry, ans;
    };
    Trace.prototype.recordLRTermination = function(ruleBodyTrace, value) {
      this.terminatingLREntry = new Trace(
        this.input,
        this.pos,
        this.pos2,
        this.expr,
        !1,
        [value],
        [ruleBodyTrace]
      ), this.terminatingLREntry.terminatesLR = !0;
    };
    Trace.prototype.walk = function(visitorObjOrFn, optThisArg) {
      let visitor = visitorObjOrFn;
      typeof visitor == "function" && (visitor = { enter: visitor });
      function _walk(node, parent, depth) {
        let recurse = !0;
        visitor.enter && visitor.enter.call(optThisArg, node, parent, depth) === Trace.prototype.SKIP && (recurse = !1), recurse && (node.children.forEach((child) => {
          _walk(child, node, depth + 1);
        }), visitor.exit && visitor.exit.call(optThisArg, node, parent, depth));
      }
      this.isRootNode ? this.children.forEach((c) => {
        _walk(c, null, 0);
      }) : _walk(this, null, 0);
    };
    Trace.prototype.toString = function() {
      let sb = new common.StringBuffer();
      return this.walk((node, parent, depth) => {
        if (!node)
          return this.SKIP;
        if (node.expr.constructor.name !== "Alt") {
          if (sb.append(getInputExcerpt(node.input, node.pos, 10) + spaces(depth * 2 + 1)), sb.append((node.succeeded ? CHECK_MARK : BALLOT_X) + " " + node.displayString), node.isHeadOfLeftRecursion && sb.append(" (LR)"), node.succeeded) {
            let contents = asEscapedString(node.source.contents);
            sb.append(" " + RIGHTWARDS_DOUBLE_ARROW + "  "), sb.append(typeof contents == "string" ? '"' + contents + '"' : contents);
          }
          sb.append(`
`);
        }
      }), sb.contents();
    };
    module.exports = Trace;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-eval.js
var require_pexprs_eval = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-eval.js"() {
    "use strict";
    init_cjs_shims();
    var Trace = require_Trace(), common = require_common(), errors2 = require_errors(), nodes = require_nodes(), pexprs = require_pexprs_main(), { TerminalNode } = nodes, { NonterminalNode } = nodes, { IterationNode } = nodes;
    pexprs.PExpr.prototype.eval = common.abstract("eval");
    pexprs.any.eval = function(state) {
      let { inputStream } = state, origPos = inputStream.pos, ch = inputStream.next();
      return ch ? (state.pushBinding(new TerminalNode(ch.length), origPos), !0) : (state.processFailure(origPos, this), !1);
    };
    pexprs.end.eval = function(state) {
      let { inputStream } = state, origPos = inputStream.pos;
      return inputStream.atEnd() ? (state.pushBinding(new TerminalNode(0), origPos), !0) : (state.processFailure(origPos, this), !1);
    };
    pexprs.Terminal.prototype.eval = function(state) {
      let { inputStream } = state, origPos = inputStream.pos;
      return inputStream.matchString(this.obj) ? (state.pushBinding(new TerminalNode(this.obj.length), origPos), !0) : (state.processFailure(origPos, this), !1);
    };
    pexprs.Range.prototype.eval = function(state) {
      let { inputStream } = state, origPos = inputStream.pos, cp3 = this.matchCodePoint ? inputStream.nextCodePoint() : inputStream.nextCharCode();
      return cp3 !== void 0 && this.from.codePointAt(0) <= cp3 && cp3 <= this.to.codePointAt(0) ? (state.pushBinding(new TerminalNode(String.fromCodePoint(cp3).length), origPos), !0) : (state.processFailure(origPos, this), !1);
    };
    pexprs.Param.prototype.eval = function(state) {
      return state.eval(state.currentApplication().args[this.index]);
    };
    pexprs.Lex.prototype.eval = function(state) {
      state.enterLexifiedContext();
      let ans = state.eval(this.expr);
      return state.exitLexifiedContext(), ans;
    };
    pexprs.Alt.prototype.eval = function(state) {
      for (let idx = 0; idx < this.terms.length; idx++)
        if (state.eval(this.terms[idx]))
          return !0;
      return !1;
    };
    pexprs.Seq.prototype.eval = function(state) {
      for (let idx = 0; idx < this.factors.length; idx++) {
        let factor = this.factors[idx];
        if (!state.eval(factor))
          return !1;
      }
      return !0;
    };
    pexprs.Iter.prototype.eval = function(state) {
      let { inputStream } = state, origPos = inputStream.pos, arity = this.getArity(), cols = [], colOffsets = [];
      for (; cols.length < arity; )
        cols.push([]), colOffsets.push([]);
      let numMatches = 0, prevPos = origPos, idx;
      for (; numMatches < this.maxNumMatches && state.eval(this.expr); ) {
        if (inputStream.pos === prevPos)
          throw errors2.kleeneExprHasNullableOperand(this, state._applicationStack);
        prevPos = inputStream.pos, numMatches++;
        let row = state._bindings.splice(state._bindings.length - arity, arity), rowOffsets = state._bindingOffsets.splice(
          state._bindingOffsets.length - arity,
          arity
        );
        for (idx = 0; idx < row.length; idx++)
          cols[idx].push(row[idx]), colOffsets[idx].push(rowOffsets[idx]);
      }
      if (numMatches < this.minNumMatches)
        return !1;
      let offset = state.posToOffset(origPos), matchLength = 0;
      if (numMatches > 0) {
        let lastCol = cols[arity - 1], lastColOffsets = colOffsets[arity - 1], endOffset = lastColOffsets[lastColOffsets.length - 1] + lastCol[lastCol.length - 1].matchLength;
        offset = colOffsets[0][0], matchLength = endOffset - offset;
      }
      let isOptional = this instanceof pexprs.Opt;
      for (idx = 0; idx < cols.length; idx++)
        state._bindings.push(
          new IterationNode(cols[idx], colOffsets[idx], matchLength, isOptional)
        ), state._bindingOffsets.push(offset);
      return !0;
    };
    pexprs.Not.prototype.eval = function(state) {
      let { inputStream } = state, origPos = inputStream.pos;
      state.pushFailuresInfo();
      let ans = state.eval(this.expr);
      return state.popFailuresInfo(), ans ? (state.processFailure(origPos, this), !1) : (inputStream.pos = origPos, !0);
    };
    pexprs.Lookahead.prototype.eval = function(state) {
      let { inputStream } = state, origPos = inputStream.pos;
      return state.eval(this.expr) ? (inputStream.pos = origPos, !0) : !1;
    };
    pexprs.Apply.prototype.eval = function(state) {
      let caller = state.currentApplication(), actuals = caller ? caller.args : [], app = this.substituteParams(actuals), posInfo = state.getCurrentPosInfo();
      if (posInfo.isActive(app))
        return app.handleCycle(state);
      let memoKey = app.toMemoKey(), memoRec = posInfo.memo[memoKey];
      if (memoRec && posInfo.shouldUseMemoizedResult(memoRec)) {
        if (state.hasNecessaryInfo(memoRec))
          return state.useMemoizedResult(state.inputStream.pos, memoRec);
        delete posInfo.memo[memoKey];
      }
      return app.reallyEval(state);
    };
    pexprs.Apply.prototype.handleCycle = function(state) {
      let posInfo = state.getCurrentPosInfo(), { currentLeftRecursion } = posInfo, memoKey = this.toMemoKey(), memoRec = posInfo.memo[memoKey];
      return currentLeftRecursion && currentLeftRecursion.headApplication.toMemoKey() === memoKey ? memoRec.updateInvolvedApplicationMemoKeys() : memoRec || (memoRec = posInfo.memoize(memoKey, {
        matchLength: 0,
        examinedLength: 0,
        value: !1,
        rightmostFailureOffset: -1
      }), posInfo.startLeftRecursion(this, memoRec)), state.useMemoizedResult(state.inputStream.pos, memoRec);
    };
    pexprs.Apply.prototype.reallyEval = function(state) {
      let { inputStream } = state, origPos = inputStream.pos, origPosInfo = state.getCurrentPosInfo(), ruleInfo = state.grammar.rules[this.ruleName], { body } = ruleInfo, { description } = ruleInfo;
      state.enterApplication(origPosInfo, this), description && state.pushFailuresInfo();
      let origInputStreamExaminedLength = inputStream.examinedLength;
      inputStream.examinedLength = 0;
      let value = this.evalOnce(body, state), currentLR = origPosInfo.currentLeftRecursion, memoKey = this.toMemoKey(), isHeadOfLeftRecursion = currentLR && currentLR.headApplication.toMemoKey() === memoKey, memoRec;
      isHeadOfLeftRecursion ? (value = this.growSeedResult(body, state, origPos, currentLR, value), origPosInfo.endLeftRecursion(), memoRec = currentLR, memoRec.examinedLength = inputStream.examinedLength - origPos, memoRec.rightmostFailureOffset = state._getRightmostFailureOffset(), origPosInfo.memoize(memoKey, memoRec)) : (!currentLR || !currentLR.isInvolved(memoKey)) && (memoRec = origPosInfo.memoize(memoKey, {
        matchLength: inputStream.pos - origPos,
        examinedLength: inputStream.examinedLength - origPos,
        value,
        failuresAtRightmostPosition: state.cloneRecordedFailures(),
        rightmostFailureOffset: state._getRightmostFailureOffset()
      }));
      let succeeded = !!value;
      if (description && (state.popFailuresInfo(), succeeded || state.processFailure(origPos, this), memoRec && (memoRec.failuresAtRightmostPosition = state.cloneRecordedFailures())), state.isTracing() && memoRec) {
        let entry = state.getTraceEntry(origPos, this, succeeded, succeeded ? [value] : []);
        isHeadOfLeftRecursion && (common.assert(entry.terminatingLREntry != null || !succeeded), entry.isHeadOfLeftRecursion = !0), memoRec.traceEntry = entry;
      }
      return inputStream.examinedLength = Math.max(
        inputStream.examinedLength,
        origInputStreamExaminedLength
      ), state.exitApplication(origPosInfo, value), succeeded;
    };
    pexprs.Apply.prototype.evalOnce = function(expr, state) {
      let { inputStream } = state, origPos = inputStream.pos;
      if (state.eval(expr)) {
        let arity = expr.getArity(), bindings = state._bindings.splice(state._bindings.length - arity, arity), offsets = state._bindingOffsets.splice(state._bindingOffsets.length - arity, arity), matchLength = inputStream.pos - origPos;
        return new NonterminalNode(this.ruleName, bindings, offsets, matchLength);
      } else
        return !1;
    };
    pexprs.Apply.prototype.growSeedResult = function(body, state, origPos, lrMemoRec, newValue) {
      if (!newValue)
        return !1;
      let { inputStream } = state;
      for (; ; ) {
        if (lrMemoRec.matchLength = inputStream.pos - origPos, lrMemoRec.value = newValue, lrMemoRec.failuresAtRightmostPosition = state.cloneRecordedFailures(), state.isTracing()) {
          let seedTrace = state.trace[state.trace.length - 1];
          lrMemoRec.traceEntry = new Trace(
            state.input,
            origPos,
            inputStream.pos,
            this,
            !0,
            [newValue],
            [seedTrace.clone()]
          );
        }
        if (inputStream.pos = origPos, newValue = this.evalOnce(body, state), inputStream.pos - origPos <= lrMemoRec.matchLength)
          break;
        state.isTracing() && state.trace.splice(-2, 1);
      }
      return state.isTracing() && lrMemoRec.traceEntry.recordLRTermination(state.trace.pop(), newValue), inputStream.pos = origPos + lrMemoRec.matchLength, lrMemoRec.value;
    };
    pexprs.UnicodeChar.prototype.eval = function(state) {
      let { inputStream } = state, origPos = inputStream.pos, ch = inputStream.next();
      return ch && this.pattern.test(ch) ? (state.pushBinding(new TerminalNode(ch.length), origPos), !0) : (state.processFailure(origPos, this), !1);
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-getArity.js
var require_pexprs_getArity = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-getArity.js"() {
    "use strict";
    init_cjs_shims();
    var common = require_common(), pexprs = require_pexprs_main();
    pexprs.PExpr.prototype.getArity = common.abstract("getArity");
    pexprs.any.getArity = pexprs.end.getArity = pexprs.Terminal.prototype.getArity = pexprs.Range.prototype.getArity = pexprs.Param.prototype.getArity = pexprs.Apply.prototype.getArity = pexprs.UnicodeChar.prototype.getArity = function() {
      return 1;
    };
    pexprs.Alt.prototype.getArity = function() {
      return this.terms.length === 0 ? 0 : this.terms[0].getArity();
    };
    pexprs.Seq.prototype.getArity = function() {
      let arity = 0;
      for (let idx = 0; idx < this.factors.length; idx++)
        arity += this.factors[idx].getArity();
      return arity;
    };
    pexprs.Iter.prototype.getArity = function() {
      return this.expr.getArity();
    };
    pexprs.Not.prototype.getArity = function() {
      return 0;
    };
    pexprs.Lookahead.prototype.getArity = pexprs.Lex.prototype.getArity = function() {
      return this.expr.getArity();
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-outputRecipe.js
var require_pexprs_outputRecipe = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-outputRecipe.js"() {
    "use strict";
    init_cjs_shims();
    var common = require_common(), pexprs = require_pexprs_main();
    function getMetaInfo(expr, grammarInterval) {
      let metaInfo = {};
      if (expr.source && grammarInterval) {
        let adjusted = expr.source.relativeTo(grammarInterval);
        metaInfo.sourceInterval = [adjusted.startIdx, adjusted.endIdx];
      }
      return metaInfo;
    }
    pexprs.PExpr.prototype.outputRecipe = common.abstract("outputRecipe");
    pexprs.any.outputRecipe = function(formals, grammarInterval) {
      return ["any", getMetaInfo(this, grammarInterval)];
    };
    pexprs.end.outputRecipe = function(formals, grammarInterval) {
      return ["end", getMetaInfo(this, grammarInterval)];
    };
    pexprs.Terminal.prototype.outputRecipe = function(formals, grammarInterval) {
      return ["terminal", getMetaInfo(this, grammarInterval), this.obj];
    };
    pexprs.Range.prototype.outputRecipe = function(formals, grammarInterval) {
      return ["range", getMetaInfo(this, grammarInterval), this.from, this.to];
    };
    pexprs.Param.prototype.outputRecipe = function(formals, grammarInterval) {
      return ["param", getMetaInfo(this, grammarInterval), this.index];
    };
    pexprs.Alt.prototype.outputRecipe = function(formals, grammarInterval) {
      return ["alt", getMetaInfo(this, grammarInterval)].concat(
        this.terms.map((term) => term.outputRecipe(formals, grammarInterval))
      );
    };
    pexprs.Extend.prototype.outputRecipe = function(formals, grammarInterval) {
      return this.terms[0].outputRecipe(formals, grammarInterval);
    };
    pexprs.Splice.prototype.outputRecipe = function(formals, grammarInterval) {
      let beforeTerms = this.terms.slice(0, this.expansionPos), afterTerms = this.terms.slice(this.expansionPos + 1);
      return [
        "splice",
        getMetaInfo(this, grammarInterval),
        beforeTerms.map((term) => term.outputRecipe(formals, grammarInterval)),
        afterTerms.map((term) => term.outputRecipe(formals, grammarInterval))
      ];
    };
    pexprs.Seq.prototype.outputRecipe = function(formals, grammarInterval) {
      return ["seq", getMetaInfo(this, grammarInterval)].concat(
        this.factors.map((factor) => factor.outputRecipe(formals, grammarInterval))
      );
    };
    pexprs.Star.prototype.outputRecipe = pexprs.Plus.prototype.outputRecipe = pexprs.Opt.prototype.outputRecipe = pexprs.Not.prototype.outputRecipe = pexprs.Lookahead.prototype.outputRecipe = pexprs.Lex.prototype.outputRecipe = function(formals, grammarInterval) {
      return [
        this.constructor.name.toLowerCase(),
        getMetaInfo(this, grammarInterval),
        this.expr.outputRecipe(formals, grammarInterval)
      ];
    };
    pexprs.Apply.prototype.outputRecipe = function(formals, grammarInterval) {
      return [
        "app",
        getMetaInfo(this, grammarInterval),
        this.ruleName,
        this.args.map((arg) => arg.outputRecipe(formals, grammarInterval))
      ];
    };
    pexprs.UnicodeChar.prototype.outputRecipe = function(formals, grammarInterval) {
      return ["unicodeChar", getMetaInfo(this, grammarInterval), this.category];
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-introduceParams.js
var require_pexprs_introduceParams = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-introduceParams.js"() {
    "use strict";
    init_cjs_shims();
    var common = require_common(), pexprs = require_pexprs_main();
    pexprs.PExpr.prototype.introduceParams = common.abstract("introduceParams");
    pexprs.any.introduceParams = pexprs.end.introduceParams = pexprs.Terminal.prototype.introduceParams = pexprs.Range.prototype.introduceParams = pexprs.Param.prototype.introduceParams = pexprs.UnicodeChar.prototype.introduceParams = function(formals) {
      return this;
    };
    pexprs.Alt.prototype.introduceParams = function(formals) {
      return this.terms.forEach((term, idx, terms) => {
        terms[idx] = term.introduceParams(formals);
      }), this;
    };
    pexprs.Seq.prototype.introduceParams = function(formals) {
      return this.factors.forEach((factor, idx, factors) => {
        factors[idx] = factor.introduceParams(formals);
      }), this;
    };
    pexprs.Iter.prototype.introduceParams = pexprs.Not.prototype.introduceParams = pexprs.Lookahead.prototype.introduceParams = pexprs.Lex.prototype.introduceParams = function(formals) {
      return this.expr = this.expr.introduceParams(formals), this;
    };
    pexprs.Apply.prototype.introduceParams = function(formals) {
      let index = formals.indexOf(this.ruleName);
      if (index >= 0) {
        if (this.args.length > 0)
          throw new Error("Parameterized rules cannot be passed as arguments to another rule.");
        return new pexprs.Param(index).withSource(this.source);
      } else
        return this.args.forEach((arg, idx, args) => {
          args[idx] = arg.introduceParams(formals);
        }), this;
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-isNullable.js
var require_pexprs_isNullable = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-isNullable.js"() {
    "use strict";
    init_cjs_shims();
    var common = require_common(), pexprs = require_pexprs_main();
    pexprs.PExpr.prototype.isNullable = function(grammar) {
      return this._isNullable(grammar, /* @__PURE__ */ Object.create(null));
    };
    pexprs.PExpr.prototype._isNullable = common.abstract("_isNullable");
    pexprs.any._isNullable = pexprs.Range.prototype._isNullable = pexprs.Param.prototype._isNullable = pexprs.Plus.prototype._isNullable = pexprs.UnicodeChar.prototype._isNullable = function(grammar, memo) {
      return !1;
    };
    pexprs.end._isNullable = function(grammar, memo) {
      return !0;
    };
    pexprs.Terminal.prototype._isNullable = function(grammar, memo) {
      return typeof this.obj == "string" ? this.obj === "" : !1;
    };
    pexprs.Alt.prototype._isNullable = function(grammar, memo) {
      return this.terms.length === 0 || this.terms.some((term) => term._isNullable(grammar, memo));
    };
    pexprs.Seq.prototype._isNullable = function(grammar, memo) {
      return this.factors.every((factor) => factor._isNullable(grammar, memo));
    };
    pexprs.Star.prototype._isNullable = pexprs.Opt.prototype._isNullable = pexprs.Not.prototype._isNullable = pexprs.Lookahead.prototype._isNullable = function(grammar, memo) {
      return !0;
    };
    pexprs.Lex.prototype._isNullable = function(grammar, memo) {
      return this.expr._isNullable(grammar, memo);
    };
    pexprs.Apply.prototype._isNullable = function(grammar, memo) {
      let key = this.toMemoKey();
      if (!Object.prototype.hasOwnProperty.call(memo, key)) {
        let { body } = grammar.rules[this.ruleName], inlined = body.substituteParams(this.args);
        memo[key] = !1, memo[key] = inlined._isNullable(grammar, memo);
      }
      return memo[key];
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-substituteParams.js
var require_pexprs_substituteParams = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-substituteParams.js"() {
    "use strict";
    init_cjs_shims();
    var common = require_common(), pexprs = require_pexprs_main();
    pexprs.PExpr.prototype.substituteParams = common.abstract("substituteParams");
    pexprs.any.substituteParams = pexprs.end.substituteParams = pexprs.Terminal.prototype.substituteParams = pexprs.Range.prototype.substituteParams = pexprs.UnicodeChar.prototype.substituteParams = function(actuals) {
      return this;
    };
    pexprs.Param.prototype.substituteParams = function(actuals) {
      return actuals[this.index];
    };
    pexprs.Alt.prototype.substituteParams = function(actuals) {
      return new pexprs.Alt(this.terms.map((term) => term.substituteParams(actuals)));
    };
    pexprs.Seq.prototype.substituteParams = function(actuals) {
      return new pexprs.Seq(this.factors.map((factor) => factor.substituteParams(actuals)));
    };
    pexprs.Iter.prototype.substituteParams = pexprs.Not.prototype.substituteParams = pexprs.Lookahead.prototype.substituteParams = pexprs.Lex.prototype.substituteParams = function(actuals) {
      return new this.constructor(this.expr.substituteParams(actuals));
    };
    pexprs.Apply.prototype.substituteParams = function(actuals) {
      if (this.args.length === 0)
        return this;
      {
        let args = this.args.map((arg) => arg.substituteParams(actuals));
        return new pexprs.Apply(this.ruleName, args);
      }
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-toArgumentNameList.js
var require_pexprs_toArgumentNameList = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-toArgumentNameList.js"() {
    "use strict";
    init_cjs_shims();
    var common = require_common(), pexprs = require_pexprs_main(), { copyWithoutDuplicates } = common;
    function isRestrictedJSIdentifier(str) {
      return /^[a-zA-Z_$][0-9a-zA-Z_$]*$/.test(str);
    }
    function resolveDuplicatedNames(argumentNameList) {
      let count = /* @__PURE__ */ Object.create(null);
      argumentNameList.forEach((argName) => {
        count[argName] = (count[argName] || 0) + 1;
      }), Object.keys(count).forEach((dupArgName) => {
        if (count[dupArgName] <= 1)
          return;
        let subscript = 1;
        argumentNameList.forEach((argName, idx) => {
          argName === dupArgName && (argumentNameList[idx] = argName + "_" + subscript++);
        });
      });
    }
    pexprs.PExpr.prototype.toArgumentNameList = common.abstract("toArgumentNameList");
    pexprs.any.toArgumentNameList = function(firstArgIndex, noDupCheck) {
      return ["any"];
    };
    pexprs.end.toArgumentNameList = function(firstArgIndex, noDupCheck) {
      return ["end"];
    };
    pexprs.Terminal.prototype.toArgumentNameList = function(firstArgIndex, noDupCheck) {
      return typeof this.obj == "string" && /^[_a-zA-Z0-9]+$/.test(this.obj) ? ["_" + this.obj] : ["$" + firstArgIndex];
    };
    pexprs.Range.prototype.toArgumentNameList = function(firstArgIndex, noDupCheck) {
      let argName = this.from + "_to_" + this.to;
      return isRestrictedJSIdentifier(argName) || (argName = "_" + argName), isRestrictedJSIdentifier(argName) || (argName = "$" + firstArgIndex), [argName];
    };
    pexprs.Alt.prototype.toArgumentNameList = function(firstArgIndex, noDupCheck) {
      let termArgNameLists = this.terms.map(
        (term) => term.toArgumentNameList(firstArgIndex, !0)
      ), argumentNameList = [], numArgs = termArgNameLists[0].length;
      for (let colIdx = 0; colIdx < numArgs; colIdx++) {
        let col = [];
        for (let rowIdx = 0; rowIdx < this.terms.length; rowIdx++)
          col.push(termArgNameLists[rowIdx][colIdx]);
        let uniqueNames = copyWithoutDuplicates(col);
        argumentNameList.push(uniqueNames.join("_or_"));
      }
      return noDupCheck || resolveDuplicatedNames(argumentNameList), argumentNameList;
    };
    pexprs.Seq.prototype.toArgumentNameList = function(firstArgIndex, noDupCheck) {
      let argumentNameList = [];
      return this.factors.forEach((factor) => {
        let factorArgumentNameList = factor.toArgumentNameList(firstArgIndex, !0);
        argumentNameList = argumentNameList.concat(factorArgumentNameList), firstArgIndex += factorArgumentNameList.length;
      }), noDupCheck || resolveDuplicatedNames(argumentNameList), argumentNameList;
    };
    pexprs.Iter.prototype.toArgumentNameList = function(firstArgIndex, noDupCheck) {
      let argumentNameList = this.expr.toArgumentNameList(firstArgIndex, noDupCheck).map(
        (exprArgumentString) => exprArgumentString[exprArgumentString.length - 1] === "s" ? exprArgumentString + "es" : exprArgumentString + "s"
      );
      return noDupCheck || resolveDuplicatedNames(argumentNameList), argumentNameList;
    };
    pexprs.Opt.prototype.toArgumentNameList = function(firstArgIndex, noDupCheck) {
      return this.expr.toArgumentNameList(firstArgIndex, noDupCheck).map((argName) => "opt" + argName[0].toUpperCase() + argName.slice(1));
    };
    pexprs.Not.prototype.toArgumentNameList = function(firstArgIndex, noDupCheck) {
      return [];
    };
    pexprs.Lookahead.prototype.toArgumentNameList = pexprs.Lex.prototype.toArgumentNameList = function(firstArgIndex, noDupCheck) {
      return this.expr.toArgumentNameList(firstArgIndex, noDupCheck);
    };
    pexprs.Apply.prototype.toArgumentNameList = function(firstArgIndex, noDupCheck) {
      return [this.ruleName];
    };
    pexprs.UnicodeChar.prototype.toArgumentNameList = function(firstArgIndex, noDupCheck) {
      return ["$" + firstArgIndex];
    };
    pexprs.Param.prototype.toArgumentNameList = function(firstArgIndex, noDupCheck) {
      return ["param" + this.index];
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-toDisplayString.js
var require_pexprs_toDisplayString = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-toDisplayString.js"() {
    "use strict";
    init_cjs_shims();
    var common = require_common(), pexprs = require_pexprs_main();
    pexprs.PExpr.prototype.toDisplayString = common.abstract("toDisplayString");
    pexprs.Alt.prototype.toDisplayString = pexprs.Seq.prototype.toDisplayString = function() {
      return this.source ? this.source.trimmed().contents : "[" + this.constructor.name + "]";
    };
    pexprs.any.toDisplayString = pexprs.end.toDisplayString = pexprs.Iter.prototype.toDisplayString = pexprs.Not.prototype.toDisplayString = pexprs.Lookahead.prototype.toDisplayString = pexprs.Lex.prototype.toDisplayString = pexprs.Terminal.prototype.toDisplayString = pexprs.Range.prototype.toDisplayString = pexprs.Param.prototype.toDisplayString = function() {
      return this.toString();
    };
    pexprs.Apply.prototype.toDisplayString = function() {
      if (this.args.length > 0) {
        let ps = this.args.map((arg) => arg.toDisplayString());
        return this.ruleName + "<" + ps.join(",") + ">";
      } else
        return this.ruleName;
    };
    pexprs.UnicodeChar.prototype.toDisplayString = function() {
      return "Unicode [" + this.category + "] character";
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-toFailure.js
var require_pexprs_toFailure = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-toFailure.js"() {
    "use strict";
    init_cjs_shims();
    var Failure = require_Failure(), common = require_common(), pexprs = require_pexprs_main();
    pexprs.PExpr.prototype.toFailure = common.abstract("toFailure");
    pexprs.any.toFailure = function(grammar) {
      return new Failure(this, "any object", "description");
    };
    pexprs.end.toFailure = function(grammar) {
      return new Failure(this, "end of input", "description");
    };
    pexprs.Terminal.prototype.toFailure = function(grammar) {
      return new Failure(this, this.obj, "string");
    };
    pexprs.Range.prototype.toFailure = function(grammar) {
      return new Failure(this, JSON.stringify(this.from) + ".." + JSON.stringify(this.to), "code");
    };
    pexprs.Not.prototype.toFailure = function(grammar) {
      let description = this.expr === pexprs.any ? "nothing" : "not " + this.expr.toFailure(grammar);
      return new Failure(this, description, "description");
    };
    pexprs.Lookahead.prototype.toFailure = function(grammar) {
      return this.expr.toFailure(grammar);
    };
    pexprs.Apply.prototype.toFailure = function(grammar) {
      let { description } = grammar.rules[this.ruleName];
      return description || (description = (/^[aeiouAEIOU]/.test(this.ruleName) ? "an" : "a") + " " + this.ruleName), new Failure(this, description, "description");
    };
    pexprs.UnicodeChar.prototype.toFailure = function(grammar) {
      return new Failure(this, "a Unicode [" + this.category + "] character", "description");
    };
    pexprs.Alt.prototype.toFailure = function(grammar) {
      let description = "(" + this.terms.map((t7) => t7.toFailure(grammar)).join(" or ") + ")";
      return new Failure(this, description, "description");
    };
    pexprs.Seq.prototype.toFailure = function(grammar) {
      let description = "(" + this.factors.map((f) => f.toFailure(grammar)).join(" ") + ")";
      return new Failure(this, description, "description");
    };
    pexprs.Iter.prototype.toFailure = function(grammar) {
      let description = "(" + this.expr.toFailure(grammar) + this.operator + ")";
      return new Failure(this, description, "description");
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-toString.js
var require_pexprs_toString = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs-toString.js"() {
    "use strict";
    init_cjs_shims();
    var common = require_common(), pexprs = require_pexprs_main();
    pexprs.PExpr.prototype.toString = common.abstract("toString");
    pexprs.any.toString = function() {
      return "any";
    };
    pexprs.end.toString = function() {
      return "end";
    };
    pexprs.Terminal.prototype.toString = function() {
      return JSON.stringify(this.obj);
    };
    pexprs.Range.prototype.toString = function() {
      return JSON.stringify(this.from) + ".." + JSON.stringify(this.to);
    };
    pexprs.Param.prototype.toString = function() {
      return "$" + this.index;
    };
    pexprs.Lex.prototype.toString = function() {
      return "#(" + this.expr.toString() + ")";
    };
    pexprs.Alt.prototype.toString = function() {
      return this.terms.length === 1 ? this.terms[0].toString() : "(" + this.terms.map((term) => term.toString()).join(" | ") + ")";
    };
    pexprs.Seq.prototype.toString = function() {
      return this.factors.length === 1 ? this.factors[0].toString() : "(" + this.factors.map((factor) => factor.toString()).join(" ") + ")";
    };
    pexprs.Iter.prototype.toString = function() {
      return this.expr + this.operator;
    };
    pexprs.Not.prototype.toString = function() {
      return "~" + this.expr;
    };
    pexprs.Lookahead.prototype.toString = function() {
      return "&" + this.expr;
    };
    pexprs.Apply.prototype.toString = function() {
      if (this.args.length > 0) {
        let ps = this.args.map((arg) => arg.toString());
        return this.ruleName + "<" + ps.join(",") + ">";
      } else
        return this.ruleName;
    };
    pexprs.UnicodeChar.prototype.toString = function() {
      return "\\p{" + this.category + "}";
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs.js
var require_pexprs = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/pexprs.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = require_pexprs_main();
    require_pexprs_allowsSkippingPrecedingSpace();
    require_pexprs_assertAllApplicationsAreValid();
    require_pexprs_assertChoicesHaveUniformArity();
    require_pexprs_assertIteratedExprsAreNotNullable();
    require_pexprs_eval();
    require_pexprs_getArity();
    require_pexprs_outputRecipe();
    require_pexprs_introduceParams();
    require_pexprs_isNullable();
    require_pexprs_substituteParams();
    require_pexprs_toArgumentNameList();
    require_pexprs_toDisplayString();
    require_pexprs_toFailure();
    require_pexprs_toString();
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/CaseInsensitiveTerminal.js
var require_CaseInsensitiveTerminal = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/CaseInsensitiveTerminal.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Failure = require_Failure(), { TerminalNode } = require_nodes(), { assert } = require_common(), { PExpr, Terminal } = require_pexprs(), CaseInsensitiveTerminal = class _CaseInsensitiveTerminal extends PExpr {
      constructor(param) {
        super(), this.obj = param;
      }
      _getString(state) {
        let terminal = state.currentApplication().args[this.obj.index];
        return assert(terminal instanceof Terminal, "expected a Terminal expression"), terminal.obj;
      }
      // Implementation of the PExpr API
      allowsSkippingPrecedingSpace() {
        return !0;
      }
      eval(state) {
        let { inputStream } = state, origPos = inputStream.pos, matchStr = this._getString(state);
        return inputStream.matchString(matchStr, !0) ? (state.pushBinding(new TerminalNode(matchStr.length), origPos), !0) : (state.processFailure(origPos, this), !1);
      }
      getArity() {
        return 1;
      }
      substituteParams(actuals) {
        return new _CaseInsensitiveTerminal(this.obj.substituteParams(actuals));
      }
      toDisplayString() {
        return this.obj.toDisplayString() + " (case-insensitive)";
      }
      toFailure(grammar) {
        return new Failure(
          this,
          this.obj.toFailure(grammar) + " (case-insensitive)",
          "description"
        );
      }
      _isNullable(grammar, memo) {
        return this.obj._isNullable(grammar, memo);
      }
    };
    module.exports = CaseInsensitiveTerminal;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/InputStream.js
var require_InputStream = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/InputStream.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Interval = require_Interval();
    function InputStream(source) {
      this.source = source, this.pos = 0, this.examinedLength = 0;
    }
    InputStream.prototype = {
      atEnd() {
        let ans = this.pos === this.source.length;
        return this.examinedLength = Math.max(this.examinedLength, this.pos + 1), ans;
      },
      next() {
        let ans = this.source[this.pos++];
        return this.examinedLength = Math.max(this.examinedLength, this.pos), ans;
      },
      nextCharCode() {
        let nextChar = this.next();
        return nextChar && nextChar.charCodeAt(0);
      },
      nextCodePoint() {
        let cp3 = this.source.slice(this.pos++).codePointAt(0);
        return cp3 > 65535 && (this.pos += 1), this.examinedLength = Math.max(this.examinedLength, this.pos), cp3;
      },
      matchString(s, optIgnoreCase) {
        let idx;
        if (optIgnoreCase) {
          for (idx = 0; idx < s.length; idx++) {
            let actual = this.next(), expected = s[idx];
            if (actual == null || actual.toUpperCase() !== expected.toUpperCase())
              return !1;
          }
          return !0;
        }
        for (idx = 0; idx < s.length; idx++)
          if (this.next() !== s[idx])
            return !1;
        return !0;
      },
      sourceSlice(startIdx, endIdx) {
        return this.source.slice(startIdx, endIdx);
      },
      interval(startIdx, optEndIdx) {
        return new Interval(this.source, startIdx, optEndIdx || this.pos);
      }
    };
    module.exports = InputStream;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/MatchResult.js
var require_MatchResult = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/MatchResult.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var common = require_common(), util2 = require_util(), Interval = require_Interval();
    function MatchResult(matcher, input, startExpr, cst, cstOffset, rightmostFailurePosition, optRecordedFailures) {
      this.matcher = matcher, this.input = input, this.startExpr = startExpr, this._cst = cst, this._cstOffset = cstOffset, this._rightmostFailurePosition = rightmostFailurePosition, this._rightmostFailures = optRecordedFailures, this.failed() && (common.defineLazyProperty(this, "message", function() {
        let detail = "Expected " + this.getExpectedText();
        return util2.getLineAndColumnMessage(this.input, this.getRightmostFailurePosition()) + detail;
      }), common.defineLazyProperty(this, "shortMessage", function() {
        let detail = "expected " + this.getExpectedText(), errorInfo = util2.getLineAndColumn(this.input, this.getRightmostFailurePosition());
        return "Line " + errorInfo.lineNum + ", col " + errorInfo.colNum + ": " + detail;
      }));
    }
    MatchResult.prototype.succeeded = function() {
      return !!this._cst;
    };
    MatchResult.prototype.failed = function() {
      return !this.succeeded();
    };
    MatchResult.prototype.getRightmostFailurePosition = function() {
      return this._rightmostFailurePosition;
    };
    MatchResult.prototype.getRightmostFailures = function() {
      if (!this._rightmostFailures) {
        this.matcher.setInput(this.input);
        let matchResultWithFailures = this.matcher._match(
          this.startExpr,
          !1,
          this.getRightmostFailurePosition()
        );
        this._rightmostFailures = matchResultWithFailures.getRightmostFailures();
      }
      return this._rightmostFailures;
    };
    MatchResult.prototype.toString = function() {
      return this.succeeded() ? "[match succeeded]" : "[match failed at position " + this.getRightmostFailurePosition() + "]";
    };
    MatchResult.prototype.getExpectedText = function() {
      if (this.succeeded())
        throw new Error("cannot get expected text of a successful MatchResult");
      let sb = new common.StringBuffer(), failures = this.getRightmostFailures();
      failures = failures.filter((failure) => !failure.isFluffy());
      for (let idx = 0; idx < failures.length; idx++)
        idx > 0 && (idx === failures.length - 1 ? sb.append(failures.length > 2 ? ", or " : " or ") : sb.append(", ")), sb.append(failures[idx].toString());
      return sb.contents();
    };
    MatchResult.prototype.getInterval = function() {
      let pos = this.getRightmostFailurePosition();
      return new Interval(this.input, pos, pos);
    };
    module.exports = MatchResult;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/PosInfo.js
var require_PosInfo = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/PosInfo.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    function PosInfo() {
      this.applicationMemoKeyStack = [], this.memo = {}, this.maxExaminedLength = 0, this.maxRightmostFailureOffset = -1, this.currentLeftRecursion = void 0;
    }
    PosInfo.prototype = {
      isActive(application) {
        return this.applicationMemoKeyStack.indexOf(application.toMemoKey()) >= 0;
      },
      enter(application) {
        this.applicationMemoKeyStack.push(application.toMemoKey());
      },
      exit() {
        this.applicationMemoKeyStack.pop();
      },
      startLeftRecursion(headApplication, memoRec) {
        memoRec.isLeftRecursion = !0, memoRec.headApplication = headApplication, memoRec.nextLeftRecursion = this.currentLeftRecursion, this.currentLeftRecursion = memoRec;
        let { applicationMemoKeyStack } = this, indexOfFirstInvolvedRule = applicationMemoKeyStack.indexOf(headApplication.toMemoKey()) + 1, involvedApplicationMemoKeys = applicationMemoKeyStack.slice(
          indexOfFirstInvolvedRule
        );
        memoRec.isInvolved = function(applicationMemoKey) {
          return involvedApplicationMemoKeys.indexOf(applicationMemoKey) >= 0;
        }, memoRec.updateInvolvedApplicationMemoKeys = function() {
          for (let idx = indexOfFirstInvolvedRule; idx < applicationMemoKeyStack.length; idx++) {
            let applicationMemoKey = applicationMemoKeyStack[idx];
            this.isInvolved(applicationMemoKey) || involvedApplicationMemoKeys.push(applicationMemoKey);
          }
        };
      },
      endLeftRecursion() {
        this.currentLeftRecursion = this.currentLeftRecursion.nextLeftRecursion;
      },
      // Note: this method doesn't get called for the "head" of a left recursion -- for LR heads,
      // the memoized result (which starts out being a failure) is always used.
      shouldUseMemoizedResult(memoRec) {
        if (!memoRec.isLeftRecursion)
          return !0;
        let { applicationMemoKeyStack } = this;
        for (let idx = 0; idx < applicationMemoKeyStack.length; idx++) {
          let applicationMemoKey = applicationMemoKeyStack[idx];
          if (memoRec.isInvolved(applicationMemoKey))
            return !1;
        }
        return !0;
      },
      memoize(memoKey, memoRec) {
        return this.memo[memoKey] = memoRec, this.maxExaminedLength = Math.max(this.maxExaminedLength, memoRec.examinedLength), this.maxRightmostFailureOffset = Math.max(
          this.maxRightmostFailureOffset,
          memoRec.rightmostFailureOffset
        ), memoRec;
      },
      clearObsoleteEntries(pos, invalidatedIdx) {
        if (pos + this.maxExaminedLength <= invalidatedIdx)
          return;
        let { memo } = this;
        this.maxExaminedLength = 0, this.maxRightmostFailureOffset = -1, Object.keys(memo).forEach((k) => {
          let memoRec = memo[k];
          pos + memoRec.examinedLength > invalidatedIdx ? delete memo[k] : (this.maxExaminedLength = Math.max(this.maxExaminedLength, memoRec.examinedLength), this.maxRightmostFailureOffset = Math.max(
            this.maxRightmostFailureOffset,
            memoRec.rightmostFailureOffset
          ));
        });
      }
    };
    module.exports = PosInfo;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/MatchState.js
var require_MatchState = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/MatchState.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var InputStream = require_InputStream(), MatchResult = require_MatchResult(), PosInfo = require_PosInfo(), Trace = require_Trace(), pexprs = require_pexprs(), util2 = require_util(), builtInApplySyntacticBody;
    util2.awaitBuiltInRules((builtInRules) => {
      builtInApplySyntacticBody = builtInRules.rules.applySyntactic.body;
    });
    var applySpaces = new pexprs.Apply("spaces");
    function MatchState(matcher, startExpr, optPositionToRecordFailures) {
      this.matcher = matcher, this.startExpr = startExpr, this.grammar = matcher.grammar, this.input = matcher.input, this.inputStream = new InputStream(matcher.input), this.memoTable = matcher.memoTable, this._bindings = [], this._bindingOffsets = [], this._applicationStack = [], this._posStack = [0], this.inLexifiedContextStack = [!1], this.rightmostFailurePosition = -1, this._rightmostFailurePositionStack = [], this._recordedFailuresStack = [], optPositionToRecordFailures !== void 0 && (this.positionToRecordFailures = optPositionToRecordFailures, this.recordedFailures = /* @__PURE__ */ Object.create(null));
    }
    MatchState.prototype = {
      posToOffset(pos) {
        return pos - this._posStack[this._posStack.length - 1];
      },
      enterApplication(posInfo, app) {
        this._posStack.push(this.inputStream.pos), this._applicationStack.push(app), this.inLexifiedContextStack.push(!1), posInfo.enter(app), this._rightmostFailurePositionStack.push(this.rightmostFailurePosition), this.rightmostFailurePosition = -1;
      },
      exitApplication(posInfo, optNode) {
        let origPos = this._posStack.pop();
        this._applicationStack.pop(), this.inLexifiedContextStack.pop(), posInfo.exit(), this.rightmostFailurePosition = Math.max(
          this.rightmostFailurePosition,
          this._rightmostFailurePositionStack.pop()
        ), optNode && this.pushBinding(optNode, origPos);
      },
      enterLexifiedContext() {
        this.inLexifiedContextStack.push(!0);
      },
      exitLexifiedContext() {
        this.inLexifiedContextStack.pop();
      },
      currentApplication() {
        return this._applicationStack[this._applicationStack.length - 1];
      },
      inSyntacticContext() {
        let currentApplication = this.currentApplication();
        return currentApplication ? currentApplication.isSyntactic() && !this.inLexifiedContext() : this.startExpr.factors[0].isSyntactic();
      },
      inLexifiedContext() {
        return this.inLexifiedContextStack[this.inLexifiedContextStack.length - 1];
      },
      skipSpaces() {
        return this.pushFailuresInfo(), this.eval(applySpaces), this.popBinding(), this.popFailuresInfo(), this.inputStream.pos;
      },
      skipSpacesIfInSyntacticContext() {
        return this.inSyntacticContext() ? this.skipSpaces() : this.inputStream.pos;
      },
      maybeSkipSpacesBefore(expr) {
        return expr.allowsSkippingPrecedingSpace() && expr !== applySpaces ? this.skipSpacesIfInSyntacticContext() : this.inputStream.pos;
      },
      pushBinding(node, origPos) {
        this._bindings.push(node), this._bindingOffsets.push(this.posToOffset(origPos));
      },
      popBinding() {
        this._bindings.pop(), this._bindingOffsets.pop();
      },
      numBindings() {
        return this._bindings.length;
      },
      truncateBindings(newLength) {
        for (; this._bindings.length > newLength; )
          this.popBinding();
      },
      getCurrentPosInfo() {
        return this.getPosInfo(this.inputStream.pos);
      },
      getPosInfo(pos) {
        let posInfo = this.memoTable[pos];
        return posInfo || (posInfo = this.memoTable[pos] = new PosInfo()), posInfo;
      },
      processFailure(pos, expr) {
        if (this.rightmostFailurePosition = Math.max(this.rightmostFailurePosition, pos), this.recordedFailures && pos === this.positionToRecordFailures) {
          let app = this.currentApplication();
          app && (expr = expr.substituteParams(app.args)), this.recordFailure(expr.toFailure(this.grammar), !1);
        }
      },
      recordFailure(failure, shouldCloneIfNew) {
        let key = failure.toKey();
        this.recordedFailures[key] ? this.recordedFailures[key].isFluffy() && !failure.isFluffy() && this.recordedFailures[key].clearFluffy() : this.recordedFailures[key] = shouldCloneIfNew ? failure.clone() : failure;
      },
      recordFailures(failures, shouldCloneIfNew) {
        Object.keys(failures).forEach((key) => {
          this.recordFailure(failures[key], shouldCloneIfNew);
        });
      },
      cloneRecordedFailures() {
        if (!this.recordedFailures)
          return;
        let ans = /* @__PURE__ */ Object.create(null);
        return Object.keys(this.recordedFailures).forEach((key) => {
          ans[key] = this.recordedFailures[key].clone();
        }), ans;
      },
      getRightmostFailurePosition() {
        return this.rightmostFailurePosition;
      },
      _getRightmostFailureOffset() {
        return this.rightmostFailurePosition >= 0 ? this.posToOffset(this.rightmostFailurePosition) : -1;
      },
      // Returns the memoized trace entry for `expr` at `pos`, if one exists, `null` otherwise.
      getMemoizedTraceEntry(pos, expr) {
        let posInfo = this.memoTable[pos];
        if (posInfo && expr instanceof pexprs.Apply) {
          let memoRec = posInfo.memo[expr.toMemoKey()];
          if (memoRec && memoRec.traceEntry) {
            let entry = memoRec.traceEntry.cloneWithExpr(expr);
            return entry.isMemoized = !0, entry;
          }
        }
        return null;
      },
      // Returns a new trace entry, with the currently active trace array as its children.
      getTraceEntry(pos, expr, succeeded, bindings) {
        if (expr instanceof pexprs.Apply) {
          let app = this.currentApplication(), actuals = app ? app.args : [];
          expr = expr.substituteParams(actuals);
        }
        return this.getMemoizedTraceEntry(pos, expr) || new Trace(this.input, pos, this.inputStream.pos, expr, succeeded, bindings, this.trace);
      },
      isTracing() {
        return !!this.trace;
      },
      hasNecessaryInfo(memoRec) {
        return this.trace && !memoRec.traceEntry ? !1 : this.recordedFailures && this.inputStream.pos + memoRec.rightmostFailureOffset === this.positionToRecordFailures ? !!memoRec.failuresAtRightmostPosition : !0;
      },
      useMemoizedResult(origPos, memoRec) {
        this.trace && this.trace.push(memoRec.traceEntry);
        let memoRecRightmostFailurePosition = this.inputStream.pos + memoRec.rightmostFailureOffset;
        return this.rightmostFailurePosition = Math.max(
          this.rightmostFailurePosition,
          memoRecRightmostFailurePosition
        ), this.recordedFailures && this.positionToRecordFailures === memoRecRightmostFailurePosition && memoRec.failuresAtRightmostPosition && this.recordFailures(memoRec.failuresAtRightmostPosition, !0), this.inputStream.examinedLength = Math.max(
          this.inputStream.examinedLength,
          memoRec.examinedLength + origPos
        ), memoRec.value ? (this.inputStream.pos += memoRec.matchLength, this.pushBinding(memoRec.value, origPos), !0) : !1;
      },
      // Evaluate `expr` and return `true` if it succeeded, `false` otherwise. On success, `bindings`
      // will have `expr.getArity()` more elements than before, and the input stream's position may
      // have increased. On failure, `bindings` and position will be unchanged.
      eval(expr) {
        let { inputStream } = this, origNumBindings = this._bindings.length, origRecordedFailures;
        this.recordedFailures && (origRecordedFailures = this.recordedFailures, this.recordedFailures = /* @__PURE__ */ Object.create(null));
        let origPos = inputStream.pos, memoPos = this.maybeSkipSpacesBefore(expr), origTrace;
        this.trace && (origTrace = this.trace, this.trace = []);
        let ans = expr.eval(this);
        if (this.trace) {
          let bindings = this._bindings.slice(origNumBindings), traceEntry = this.getTraceEntry(memoPos, expr, ans, bindings);
          traceEntry.isImplicitSpaces = expr === applySpaces, traceEntry.isRootNode = expr === this.startExpr, origTrace.push(traceEntry), this.trace = origTrace;
        }
        return ans ? this.recordedFailures && inputStream.pos === this.positionToRecordFailures && Object.keys(this.recordedFailures).forEach((key) => {
          this.recordedFailures[key].makeFluffy();
        }) : (inputStream.pos = origPos, this.truncateBindings(origNumBindings)), this.recordedFailures && this.recordFailures(origRecordedFailures, !1), expr === builtInApplySyntacticBody && this.skipSpaces(), ans;
      },
      getMatchResult() {
        this.eval(this.startExpr);
        let rightmostFailures;
        this.recordedFailures && (rightmostFailures = Object.keys(this.recordedFailures).map(
          (key) => this.recordedFailures[key]
        ));
        let cst = this._bindings[0];
        return cst && (cst.grammar = this.grammar), new MatchResult(
          this.matcher,
          this.input,
          this.startExpr,
          cst,
          this._bindingOffsets[0],
          this.rightmostFailurePosition,
          rightmostFailures
        );
      },
      getTrace() {
        this.trace = [];
        let matchResult = this.getMatchResult(), rootTrace = this.trace[this.trace.length - 1];
        return rootTrace.result = matchResult, rootTrace;
      },
      pushFailuresInfo() {
        this._rightmostFailurePositionStack.push(this.rightmostFailurePosition), this._recordedFailuresStack.push(this.recordedFailures);
      },
      popFailuresInfo() {
        this.rightmostFailurePosition = this._rightmostFailurePositionStack.pop(), this.recordedFailures = this._recordedFailuresStack.pop();
      }
    };
    module.exports = MatchState;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/Matcher.js
var require_Matcher = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/Matcher.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var MatchState = require_MatchState(), pexprs = require_pexprs();
    function Matcher(grammar) {
      this.grammar = grammar, this.memoTable = [], this.input = "";
    }
    Matcher.prototype.getInput = function() {
      return this.input;
    };
    Matcher.prototype.setInput = function(str) {
      return this.input !== str && this.replaceInputRange(0, this.input.length, str), this;
    };
    Matcher.prototype.replaceInputRange = function(startIdx, endIdx, str) {
      let currentInput = this.input;
      if (startIdx < 0 || startIdx > currentInput.length || endIdx < 0 || endIdx > currentInput.length || startIdx > endIdx)
        throw new Error("Invalid indices: " + startIdx + " and " + endIdx);
      this.input = currentInput.slice(0, startIdx) + str + currentInput.slice(endIdx);
      let restOfMemoTable = this.memoTable.slice(endIdx);
      this.memoTable.length = startIdx;
      for (let idx = 0; idx < str.length; idx++)
        this.memoTable.push(void 0);
      restOfMemoTable.forEach(function(posInfo) {
        this.memoTable.push(posInfo);
      }, this);
      for (let pos = 0; pos < startIdx; pos++) {
        let posInfo = this.memoTable[pos];
        posInfo && posInfo.clearObsoleteEntries(pos, startIdx);
      }
      return this;
    };
    Matcher.prototype.match = function(optStartApplicationStr) {
      return this._match(this._getStartExpr(optStartApplicationStr), !1);
    };
    Matcher.prototype.trace = function(optStartApplicationStr) {
      return this._match(this._getStartExpr(optStartApplicationStr), !0);
    };
    Matcher.prototype._match = function(startExpr, tracing, optPositionToRecordFailures) {
      let state = new MatchState(this, startExpr, optPositionToRecordFailures);
      return tracing ? state.getTrace() : state.getMatchResult();
    };
    Matcher.prototype._getStartExpr = function(optStartApplicationStr) {
      let applicationStr = optStartApplicationStr || this.grammar.defaultStartRule;
      if (!applicationStr)
        throw new Error("Missing start rule argument -- the grammar has no default start rule.");
      let startApp = this.grammar.parseApplication(applicationStr);
      return new pexprs.Seq([startApp, pexprs.end]);
    };
    module.exports = Matcher;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/Semantics.js
var require_Semantics = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/Semantics.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var InputStream = require_InputStream(), { IterationNode } = require_nodes(), MatchResult = require_MatchResult(), common = require_common(), errors2 = require_errors(), util2 = require_util(), globalActionStack = [], hasOwnProperty = (x, prop) => Object.prototype.hasOwnProperty.call(x, prop), Wrapper = class {
      constructor(node, sourceInterval, baseInterval) {
        this._node = node, this.source = sourceInterval, this._baseInterval = baseInterval, node.isNonterminal() && common.assert(sourceInterval === baseInterval), this._childWrappers = [];
      }
      toString() {
        return "[semantics wrapper for " + this._node.grammar.name + "]";
      }
      _forgetMemoizedResultFor(attributeName) {
        delete this._node[this._semantics.attributeKeys[attributeName]], this.children.forEach((child) => {
          child._forgetMemoizedResultFor(attributeName);
        });
      }
      // Returns the wrapper of the specified child node. Child wrappers are created lazily and
      // cached in the parent wrapper's `_childWrappers` instance variable.
      child(idx) {
        if (!(0 <= idx && idx < this._node.numChildren()))
          return;
        let childWrapper = this._childWrappers[idx];
        if (!childWrapper) {
          let childNode = this._node.childAt(idx), offset = this._node.childOffsets[idx], source = this._baseInterval.subInterval(offset, childNode.matchLength), base = childNode.isNonterminal() ? source : this._baseInterval;
          childWrapper = this._childWrappers[idx] = this._semantics.wrap(childNode, source, base);
        }
        return childWrapper;
      }
      // Returns an array containing the wrappers of all of the children of the node associated
      // with this wrapper.
      _children() {
        for (let idx = 0; idx < this._node.numChildren(); idx++)
          this.child(idx);
        return this._childWrappers;
      }
      // Returns `true` if the CST node associated with this wrapper corresponds to an iteration
      // expression, i.e., a Kleene-*, Kleene-+, or an optional. Returns `false` otherwise.
      isIteration() {
        return this._node.isIteration();
      }
      // Returns `true` if the CST node associated with this wrapper is a terminal node, `false`
      // otherwise.
      isTerminal() {
        return this._node.isTerminal();
      }
      // Returns `true` if the CST node associated with this wrapper is a nonterminal node, `false`
      // otherwise.
      isNonterminal() {
        return this._node.isNonterminal();
      }
      // Returns `true` if the CST node associated with this wrapper is a nonterminal node
      // corresponding to a syntactic rule, `false` otherwise.
      isSyntactic() {
        return this.isNonterminal() && this._node.isSyntactic();
      }
      // Returns `true` if the CST node associated with this wrapper is a nonterminal node
      // corresponding to a lexical rule, `false` otherwise.
      isLexical() {
        return this.isNonterminal() && this._node.isLexical();
      }
      // Returns `true` if the CST node associated with this wrapper is an iterator node
      // having either one or no child (? operator), `false` otherwise.
      // Otherwise, throws an exception.
      isOptional() {
        return this._node.isOptional();
      }
      // Create a new _iter wrapper in the same semantics as this wrapper.
      iteration(optChildWrappers) {
        let childWrappers = optChildWrappers || [], childNodes = childWrappers.map((c) => c._node), iter = new IterationNode(childNodes, [], -1, !1), wrapper = this._semantics.wrap(iter, null, null);
        return wrapper._childWrappers = childWrappers, wrapper;
      }
      // Returns an array containing the children of this CST node.
      get children() {
        return this._children();
      }
      // Returns the name of grammar rule that created this CST node.
      get ctorName() {
        return this._node.ctorName;
      }
      // TODO: Remove this eventually (deprecated in v0.12).
      get interval() {
        throw new Error("The `interval` property is deprecated -- use `source` instead");
      }
      // Returns the number of children of this CST node.
      get numChildren() {
        return this._node.numChildren();
      }
      // Returns the contents of the input stream consumed by this CST node.
      get sourceString() {
        return this.source.contents;
      }
    };
    function Semantics(grammar, superSemantics) {
      let self2 = this;
      if (this.grammar = grammar, this.checkedActionDicts = !1, this.Wrapper = class extends (superSemantics ? superSemantics.Wrapper : Wrapper) {
        constructor(node, sourceInterval, baseInterval) {
          super(node, sourceInterval, baseInterval), self2.checkActionDictsIfHaventAlready(), this._semantics = self2;
        }
      }, this.super = superSemantics, superSemantics) {
        if (!(grammar.equals(this.super.grammar) || grammar._inheritsFrom(this.super.grammar)))
          throw new Error(
            "Cannot extend a semantics for grammar '" + this.super.grammar.name + "' for use with grammar '" + grammar.name + "' (not a sub-grammar)"
          );
        this.operations = Object.create(this.super.operations), this.attributes = Object.create(this.super.attributes), this.attributeKeys = /* @__PURE__ */ Object.create(null);
        for (let attributeName in this.attributes)
          Object.defineProperty(this.attributeKeys, attributeName, {
            value: util2.uniqueId(attributeName)
          });
      } else
        this.operations = /* @__PURE__ */ Object.create(null), this.attributes = /* @__PURE__ */ Object.create(null), this.attributeKeys = /* @__PURE__ */ Object.create(null);
    }
    Semantics.prototype.toString = function() {
      return "[semantics for " + this.grammar.name + "]";
    };
    Semantics.prototype.checkActionDictsIfHaventAlready = function() {
      this.checkedActionDicts || (this.checkActionDicts(), this.checkedActionDicts = !0);
    };
    Semantics.prototype.checkActionDicts = function() {
      let name;
      for (name in this.operations)
        this.operations[name].checkActionDict(this.grammar);
      for (name in this.attributes)
        this.attributes[name].checkActionDict(this.grammar);
    };
    Semantics.prototype.toRecipe = function(semanticsOnly) {
      function hasSuperSemantics(s) {
        return s.super !== Semantics.BuiltInSemantics._getSemantics();
      }
      let str = `(function(g) {
`;
      if (hasSuperSemantics(this)) {
        str += "  var semantics = " + this.super.toRecipe(!0) + "(g";
        let superSemanticsGrammar = this.super.grammar, relatedGrammar = this.grammar;
        for (; relatedGrammar !== superSemanticsGrammar; )
          str += ".superGrammar", relatedGrammar = relatedGrammar.superGrammar;
        str += `);
`, str += "  return g.extendSemantics(semantics)";
      } else
        str += "  return g.createSemantics()";
      return ["Operation", "Attribute"].forEach((type) => {
        let semanticOperations = this[type.toLowerCase() + "s"];
        Object.keys(semanticOperations).forEach((name) => {
          let { actionDict, formals, builtInDefault } = semanticOperations[name], signature = name;
          formals.length > 0 && (signature += "(" + formals.join(", ") + ")");
          let method;
          hasSuperSemantics(this) && this.super[type.toLowerCase() + "s"][name] ? method = "extend" + type : method = "add" + type, str += `
    .` + method + "(" + JSON.stringify(signature) + ", {";
          let srcArray = [];
          Object.keys(actionDict).forEach((actionName) => {
            if (actionDict[actionName] !== builtInDefault) {
              let source = actionDict[actionName].toString().trim();
              source = source.replace(/^.*\(/, "function("), srcArray.push(`
      ` + JSON.stringify(actionName) + ": " + source);
            }
          }), str += srcArray.join(",") + `
    })`;
        });
      }), str += `;
  })`, semanticsOnly || (str = `(function() {
  var grammar = this.fromRecipe(` + this.grammar.toRecipe() + `);
  var semantics = ` + str + `(grammar);
  return semantics;
});
`), str;
    };
    function parseSignature(signature, type) {
      if (!Semantics.prototypeGrammar)
        return common.assert(signature.indexOf("(") === -1), {
          name: signature,
          formals: []
        };
      let r2 = Semantics.prototypeGrammar.match(
        signature,
        type === "operation" ? "OperationSignature" : "AttributeSignature"
      );
      if (r2.failed())
        throw new Error(r2.message);
      return Semantics.prototypeGrammarSemantics(r2).parse();
    }
    function newDefaultAction(type, name, doIt) {
      return function(...children) {
        let args = (this._semantics.operations[name] || this._semantics.attributes[name]).formals.map((formal) => this.args[formal]);
        if (!this.isIteration() && children.length === 1)
          return doIt.apply(children[0], args);
        throw errors2.missingSemanticAction(this.ctorName, name, type, globalActionStack);
      };
    }
    Semantics.prototype.addOperationOrAttribute = function(type, signature, actionDict) {
      let typePlural = type + "s", parsedNameAndFormalArgs = parseSignature(signature, type), { name } = parsedNameAndFormalArgs, { formals } = parsedNameAndFormalArgs;
      this.assertNewName(name, type);
      let builtInDefault = newDefaultAction(type, name, doIt), realActionDict = { _default: builtInDefault };
      Object.keys(actionDict).forEach((name2) => {
        realActionDict[name2] = actionDict[name2];
      });
      let entry = type === "operation" ? new Operation2(name, formals, realActionDict, builtInDefault) : new Attribute(name, realActionDict, builtInDefault);
      entry.checkActionDict(this.grammar), this[typePlural][name] = entry;
      function doIt(...args) {
        let thisThing = this._semantics[typePlural][name];
        if (arguments.length !== thisThing.formals.length)
          throw new Error(
            "Invalid number of arguments passed to " + name + " " + type + " (expected " + thisThing.formals.length + ", got " + arguments.length + ")"
          );
        let argsObj = /* @__PURE__ */ Object.create(null);
        for (let [idx, val] of Object.entries(args)) {
          let formal = thisThing.formals[idx];
          argsObj[formal] = val;
        }
        let oldArgs = this.args;
        this.args = argsObj;
        let ans = thisThing.execute(this._semantics, this);
        return this.args = oldArgs, ans;
      }
      type === "operation" ? (this.Wrapper.prototype[name] = doIt, this.Wrapper.prototype[name].toString = function() {
        return "[" + name + " operation]";
      }) : (Object.defineProperty(this.Wrapper.prototype, name, {
        get: doIt,
        configurable: !0
        // So the property can be deleted.
      }), Object.defineProperty(this.attributeKeys, name, {
        value: util2.uniqueId(name)
      }));
    };
    Semantics.prototype.extendOperationOrAttribute = function(type, name, actionDict) {
      let typePlural = type + "s";
      if (parseSignature(name, "attribute"), !(this.super && name in this.super[typePlural]))
        throw new Error(
          "Cannot extend " + type + " '" + name + "': did not inherit an " + type + " with that name"
        );
      if (hasOwnProperty(this[typePlural], name))
        throw new Error("Cannot extend " + type + " '" + name + "' again");
      let inheritedFormals = this[typePlural][name].formals, inheritedActionDict = this[typePlural][name].actionDict, newActionDict = Object.create(inheritedActionDict);
      Object.keys(actionDict).forEach((name2) => {
        newActionDict[name2] = actionDict[name2];
      }), this[typePlural][name] = type === "operation" ? new Operation2(name, inheritedFormals, newActionDict) : new Attribute(name, newActionDict), this[typePlural][name].checkActionDict(this.grammar);
    };
    Semantics.prototype.assertNewName = function(name, type) {
      if (hasOwnProperty(Wrapper.prototype, name))
        throw new Error("Cannot add " + type + " '" + name + "': that's a reserved name");
      if (name in this.operations)
        throw new Error(
          "Cannot add " + type + " '" + name + "': an operation with that name already exists"
        );
      if (name in this.attributes)
        throw new Error(
          "Cannot add " + type + " '" + name + "': an attribute with that name already exists"
        );
    };
    Semantics.prototype.wrap = function(node, source, optBaseInterval) {
      let baseInterval = optBaseInterval || source;
      return node instanceof this.Wrapper ? node : new this.Wrapper(node, source, baseInterval);
    };
    Semantics.createSemantics = function(grammar, optSuperSemantics) {
      let s = new Semantics(
        grammar,
        optSuperSemantics !== void 0 ? optSuperSemantics : Semantics.BuiltInSemantics._getSemantics()
      ), proxy = function(matchResult) {
        if (!(matchResult instanceof MatchResult))
          throw new TypeError(
            "Semantics expected a MatchResult, but got " + common.unexpectedObjToString(matchResult)
          );
        if (matchResult.failed())
          throw new TypeError("cannot apply Semantics to " + matchResult.toString());
        let cst = matchResult._cst;
        if (cst.grammar !== grammar)
          throw new Error(
            "Cannot use a MatchResult from grammar '" + cst.grammar.name + "' with a semantics for '" + grammar.name + "'"
          );
        let inputStream = new InputStream(matchResult.input);
        return s.wrap(cst, inputStream.interval(matchResult._cstOffset, matchResult.input.length));
      };
      return proxy.addOperation = function(signature, actionDict) {
        return s.addOperationOrAttribute("operation", signature, actionDict), proxy;
      }, proxy.extendOperation = function(name, actionDict) {
        return s.extendOperationOrAttribute("operation", name, actionDict), proxy;
      }, proxy.addAttribute = function(name, actionDict) {
        return s.addOperationOrAttribute("attribute", name, actionDict), proxy;
      }, proxy.extendAttribute = function(name, actionDict) {
        return s.extendOperationOrAttribute("attribute", name, actionDict), proxy;
      }, proxy._getActionDict = function(operationOrAttributeName) {
        let action = s.operations[operationOrAttributeName] || s.attributes[operationOrAttributeName];
        if (!action)
          throw new Error(
            '"' + operationOrAttributeName + '" is not a valid operation or attribute name in this semantics for "' + grammar.name + '"'
          );
        return action.actionDict;
      }, proxy._remove = function(operationOrAttributeName) {
        let semantic;
        return operationOrAttributeName in s.operations ? (semantic = s.operations[operationOrAttributeName], delete s.operations[operationOrAttributeName]) : operationOrAttributeName in s.attributes && (semantic = s.attributes[operationOrAttributeName], delete s.attributes[operationOrAttributeName]), delete s.Wrapper.prototype[operationOrAttributeName], semantic;
      }, proxy.getOperationNames = function() {
        return Object.keys(s.operations);
      }, proxy.getAttributeNames = function() {
        return Object.keys(s.attributes);
      }, proxy.getGrammar = function() {
        return s.grammar;
      }, proxy.toRecipe = function(semanticsOnly) {
        return s.toRecipe(semanticsOnly);
      }, proxy.toString = s.toString.bind(s), proxy._getSemantics = function() {
        return s;
      }, proxy;
    };
    var Operation2 = class {
      constructor(name, formals, actionDict, builtInDefault) {
        this.name = name, this.formals = formals, this.actionDict = actionDict, this.builtInDefault = builtInDefault;
      }
      checkActionDict(grammar) {
        grammar._checkTopDownActionDict(this.typeName, this.name, this.actionDict);
      }
      // Execute this operation on the CST node associated with `nodeWrapper` in the context of the
      // given Semantics instance.
      execute(semantics, nodeWrapper) {
        try {
          let { ctorName } = nodeWrapper._node, actionFn = this.actionDict[ctorName];
          return actionFn ? (globalActionStack.push([this, ctorName]), actionFn.apply(nodeWrapper, nodeWrapper._children())) : nodeWrapper.isNonterminal() && (actionFn = this.actionDict._nonterminal, actionFn) ? (globalActionStack.push([this, "_nonterminal", ctorName]), actionFn.apply(nodeWrapper, nodeWrapper._children())) : (globalActionStack.push([this, "default action", ctorName]), this.actionDict._default.apply(nodeWrapper, nodeWrapper._children()));
        } finally {
          globalActionStack.pop();
        }
      }
    };
    Operation2.prototype.typeName = "operation";
    var Attribute = class extends Operation2 {
      constructor(name, actionDict, builtInDefault) {
        super(name, [], actionDict, builtInDefault);
      }
      execute(semantics, nodeWrapper) {
        let node = nodeWrapper._node, key = semantics.attributeKeys[this.name];
        return hasOwnProperty(node, key) || (node[key] = Operation2.prototype.execute.call(this, semantics, nodeWrapper)), node[key];
      }
    };
    Attribute.prototype.typeName = "attribute";
    module.exports = Semantics;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/Grammar.js
var require_Grammar = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/Grammar.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var CaseInsensitiveTerminal = require_CaseInsensitiveTerminal(), Matcher = require_Matcher(), Semantics = require_Semantics(), common = require_common(), errors2 = require_errors(), pexprs = require_pexprs(), SPECIAL_ACTION_NAMES = ["_iter", "_terminal", "_nonterminal", "_default"];
    function getSortedRuleValues(grammar) {
      return Object.keys(grammar.rules).sort().map((name) => grammar.rules[name]);
    }
    var jsonToJS = (str) => str.replace(/\u2028/g, "\\u2028").replace(/\u2029/g, "\\u2029");
    function Grammar(name, superGrammar, rules, optDefaultStartRule) {
      if (this.name = name, this.superGrammar = superGrammar, this.rules = rules, optDefaultStartRule) {
        if (!(optDefaultStartRule in rules))
          throw new Error(
            "Invalid start rule: '" + optDefaultStartRule + "' is not a rule in grammar '" + name + "'"
          );
        this.defaultStartRule = optDefaultStartRule;
      }
    }
    var ohmGrammar, buildGrammar;
    Grammar.initApplicationParser = function(grammar, builderFn) {
      ohmGrammar = grammar, buildGrammar = builderFn;
    };
    Grammar.prototype = {
      matcher() {
        return new Matcher(this);
      },
      // Return true if the grammar is a built-in grammar, otherwise false.
      // NOTE: This might give an unexpected result if called before BuiltInRules is defined!
      isBuiltIn() {
        return this === Grammar.ProtoBuiltInRules || this === Grammar.BuiltInRules;
      },
      equals(g) {
        if (this === g)
          return !0;
        if (g == null || this.name !== g.name || this.defaultStartRule !== g.defaultStartRule || !(this.superGrammar === g.superGrammar || this.superGrammar.equals(g.superGrammar)))
          return !1;
        let myRules = getSortedRuleValues(this), otherRules = getSortedRuleValues(g);
        return myRules.length === otherRules.length && myRules.every((rule, i) => rule.description === otherRules[i].description && rule.formals.join(",") === otherRules[i].formals.join(",") && rule.body.toString() === otherRules[i].body.toString());
      },
      match(input, optStartApplication) {
        let m = this.matcher();
        return m.replaceInputRange(0, 0, input), m.match(optStartApplication);
      },
      trace(input, optStartApplication) {
        let m = this.matcher();
        return m.replaceInputRange(0, 0, input), m.trace(optStartApplication);
      },
      createSemantics() {
        return Semantics.createSemantics(this);
      },
      extendSemantics(superSemantics) {
        return Semantics.createSemantics(this, superSemantics._getSemantics());
      },
      // Check that every key in `actionDict` corresponds to a semantic action, and that it maps to
      // a function of the correct arity. If not, throw an exception.
      _checkTopDownActionDict(what, name, actionDict) {
        let problems = [];
        for (let k in actionDict) {
          let v = actionDict[k];
          if (!SPECIAL_ACTION_NAMES.includes(k) && !(k in this.rules)) {
            problems.push(`'${k}' is not a valid semantic action for '${this.name}'`);
            continue;
          }
          if (typeof v != "function") {
            problems.push(`'${k}' must be a function in an action dictionary for '${this.name}'`);
            continue;
          }
          let actual = v.length, expected = this._topDownActionArity(k);
          if (actual !== expected) {
            let details;
            k === "_iter" || k === "_nonterminal" ? details = `it should use a rest parameter, e.g. \`${k}(...children) {}\`. NOTE: this is new in Ohm v16 \u2014 see https://ohmjs.org/d/ati for details.` : details = `expected ${expected}, got ${actual}`, problems.push(`Semantic action '${k}' has the wrong arity: ${details}`);
          }
        }
        if (problems.length > 0) {
          let prettyProblems = problems.map((problem) => "- " + problem), error = new Error(
            [
              `Found errors in the action dictionary of the '${name}' ${what}:`,
              ...prettyProblems
            ].join(`
`)
          );
          throw error.problems = problems, error;
        }
      },
      // Return the expected arity for a semantic action named `actionName`, which
      // is either a rule name or a special action name like '_nonterminal'.
      _topDownActionArity(actionName) {
        return SPECIAL_ACTION_NAMES.includes(actionName) ? 0 : this.rules[actionName].body.getArity();
      },
      _inheritsFrom(grammar) {
        let g = this.superGrammar;
        for (; g; ) {
          if (g.equals(grammar, !0))
            return !0;
          g = g.superGrammar;
        }
        return !1;
      },
      toRecipe(superGrammarExpr = void 0) {
        let metaInfo = {};
        this.source && (metaInfo.source = this.source.contents);
        let startRule = null;
        this.defaultStartRule && (startRule = this.defaultStartRule);
        let rules = {};
        Object.keys(this.rules).forEach((ruleName) => {
          let ruleInfo = this.rules[ruleName], { body } = ruleInfo, isDefinition = !this.superGrammar || !this.superGrammar.rules[ruleName], operation;
          isDefinition ? operation = "define" : operation = body instanceof pexprs.Extend ? "extend" : "override";
          let metaInfo2 = {};
          if (ruleInfo.source && this.source) {
            let adjusted = ruleInfo.source.relativeTo(this.source);
            metaInfo2.sourceInterval = [adjusted.startIdx, adjusted.endIdx];
          }
          let description = isDefinition ? ruleInfo.description : null, bodyRecipe = body.outputRecipe(ruleInfo.formals, this.source);
          rules[ruleName] = [
            operation,
            // "define"/"extend"/"override"
            metaInfo2,
            description,
            ruleInfo.formals,
            bodyRecipe
          ];
        });
        let superGrammarOutput = "null";
        superGrammarExpr ? superGrammarOutput = superGrammarExpr : this.superGrammar && !this.superGrammar.isBuiltIn() && (superGrammarOutput = this.superGrammar.toRecipe());
        let recipeElements = [
          ...["grammar", metaInfo, this.name].map(JSON.stringify),
          superGrammarOutput,
          ...[startRule, rules].map(JSON.stringify)
        ];
        return jsonToJS(`[${recipeElements.join(",")}]`);
      },
      // TODO: Come up with better names for these methods.
      // TODO: Write the analog of these methods for inherited attributes.
      toOperationActionDictionaryTemplate() {
        return this._toOperationOrAttributeActionDictionaryTemplate();
      },
      toAttributeActionDictionaryTemplate() {
        return this._toOperationOrAttributeActionDictionaryTemplate();
      },
      _toOperationOrAttributeActionDictionaryTemplate() {
        let sb = new common.StringBuffer();
        sb.append("{");
        let first = !0;
        for (let ruleName in this.rules) {
          let { body } = this.rules[ruleName];
          first ? first = !1 : sb.append(","), sb.append(`
`), sb.append("  "), this.addSemanticActionTemplate(ruleName, body, sb);
        }
        return sb.append(`
}`), sb.contents();
      },
      addSemanticActionTemplate(ruleName, body, sb) {
        sb.append(ruleName), sb.append(": function(");
        let arity = this._topDownActionArity(ruleName);
        sb.append(common.repeat("_", arity).join(", ")), sb.append(`) {
`), sb.append("  }");
      },
      // Parse a string which expresses a rule application in this grammar, and return the
      // resulting Apply node.
      parseApplication(str) {
        let app;
        if (str.indexOf("<") === -1)
          app = new pexprs.Apply(str);
        else {
          let cst = ohmGrammar.match(str, "Base_application");
          app = buildGrammar(cst, {});
        }
        if (!(app.ruleName in this.rules))
          throw errors2.undeclaredRule(app.ruleName, this.name);
        let { formals } = this.rules[app.ruleName];
        if (formals.length !== app.args.length) {
          let { source } = this.rules[app.ruleName];
          throw errors2.wrongNumberOfParameters(
            app.ruleName,
            formals.length,
            app.args.length,
            source
          );
        }
        return app;
      }
    };
    Grammar.ProtoBuiltInRules = new Grammar(
      "ProtoBuiltInRules",
      // name
      void 0,
      // supergrammar
      {
        any: {
          body: pexprs.any,
          formals: [],
          description: "any character",
          primitive: !0
        },
        end: {
          body: pexprs.end,
          formals: [],
          description: "end of input",
          primitive: !0
        },
        caseInsensitive: {
          body: new CaseInsensitiveTerminal(new pexprs.Param(0)),
          formals: ["str"],
          primitive: !0
        },
        lower: {
          body: new pexprs.UnicodeChar("Ll"),
          formals: [],
          description: "a lowercase letter",
          primitive: !0
        },
        upper: {
          body: new pexprs.UnicodeChar("Lu"),
          formals: [],
          description: "an uppercase letter",
          primitive: !0
        },
        // Union of Lt (titlecase), Lm (modifier), and Lo (other), i.e. any letter not in Ll or Lu.
        unicodeLtmo: {
          body: new pexprs.UnicodeChar("Ltmo"),
          formals: [],
          description: "a Unicode character in Lt, Lm, or Lo",
          primitive: !0
        },
        // These rules are not truly primitive (they could be written in userland) but are defined
        // here for bootstrapping purposes.
        spaces: {
          body: new pexprs.Star(new pexprs.Apply("space")),
          formals: []
        },
        space: {
          body: new pexprs.Range("\0", " "),
          formals: [],
          description: "a space"
        }
      }
    );
    module.exports = Grammar;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/GrammarDecl.js
var require_GrammarDecl = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/GrammarDecl.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Grammar = require_Grammar(), InputStream = require_InputStream(), common = require_common(), errors2 = require_errors(), pexprs = require_pexprs();
    function GrammarDecl(name) {
      this.name = name;
    }
    GrammarDecl.prototype.sourceInterval = function(startIdx, endIdx) {
      return this.source.subInterval(startIdx, endIdx - startIdx);
    };
    GrammarDecl.prototype.ensureSuperGrammar = function() {
      return this.superGrammar || this.withSuperGrammar(
        // TODO: The conditional expression below is an ugly hack. It's kind of ok because
        // I doubt anyone will ever try to declare a grammar called `BuiltInRules`. Still,
        // we should try to find a better way to do this.
        this.name === "BuiltInRules" ? Grammar.ProtoBuiltInRules : Grammar.BuiltInRules
      ), this.superGrammar;
    };
    GrammarDecl.prototype.ensureSuperGrammarRuleForOverriding = function(name, source) {
      let ruleInfo = this.ensureSuperGrammar().rules[name];
      if (!ruleInfo)
        throw errors2.cannotOverrideUndeclaredRule(name, this.superGrammar.name, source);
      return ruleInfo;
    };
    GrammarDecl.prototype.installOverriddenOrExtendedRule = function(name, formals, body, source) {
      let duplicateParameterNames = common.getDuplicates(formals);
      if (duplicateParameterNames.length > 0)
        throw errors2.duplicateParameterNames(name, duplicateParameterNames, source);
      let ruleInfo = this.ensureSuperGrammar().rules[name], expectedFormals = ruleInfo.formals, expectedNumFormals = expectedFormals ? expectedFormals.length : 0;
      if (formals.length !== expectedNumFormals)
        throw errors2.wrongNumberOfParameters(name, expectedNumFormals, formals.length, source);
      return this.install(name, formals, body, ruleInfo.description, source);
    };
    GrammarDecl.prototype.install = function(name, formals, body, description, source) {
      return this.rules[name] = {
        body: body.introduceParams(formals),
        formals,
        description,
        source
      }, this;
    };
    GrammarDecl.prototype.withSuperGrammar = function(superGrammar) {
      if (this.superGrammar)
        throw new Error("the super grammar of a GrammarDecl cannot be set more than once");
      return this.superGrammar = superGrammar, this.rules = Object.create(superGrammar.rules), superGrammar.isBuiltIn() || (this.defaultStartRule = superGrammar.defaultStartRule), this;
    };
    GrammarDecl.prototype.withDefaultStartRule = function(ruleName) {
      return this.defaultStartRule = ruleName, this;
    };
    GrammarDecl.prototype.withSource = function(source) {
      return this.source = new InputStream(source).interval(0, source.length), this;
    };
    GrammarDecl.prototype.build = function() {
      let grammar = new Grammar(
        this.name,
        this.ensureSuperGrammar(),
        this.rules,
        this.defaultStartRule
      ), grammarErrors = [], grammarHasInvalidApplications = !1;
      return Object.keys(grammar.rules).forEach((ruleName) => {
        let { body } = grammar.rules[ruleName];
        try {
          body.assertChoicesHaveUniformArity(ruleName);
        } catch (e) {
          grammarErrors.push(e);
        }
        try {
          body.assertAllApplicationsAreValid(ruleName, grammar);
        } catch (e) {
          grammarErrors.push(e), grammarHasInvalidApplications = !0;
        }
      }), grammarHasInvalidApplications || Object.keys(grammar.rules).forEach((ruleName) => {
        let { body } = grammar.rules[ruleName];
        try {
          body.assertIteratedExprsAreNotNullable(grammar, []);
        } catch (e) {
          grammarErrors.push(e);
        }
      }), grammarErrors.length > 0 && errors2.throwErrors(grammarErrors), this.source && (grammar.source = this.source), grammar;
    };
    GrammarDecl.prototype.define = function(name, formals, body, description, source) {
      if (this.ensureSuperGrammar(), this.superGrammar.rules[name])
        throw errors2.duplicateRuleDeclaration(name, this.name, this.superGrammar.name, source);
      if (this.rules[name])
        throw errors2.duplicateRuleDeclaration(name, this.name, this.name, source);
      let duplicateParameterNames = common.getDuplicates(formals);
      if (duplicateParameterNames.length > 0)
        throw errors2.duplicateParameterNames(name, duplicateParameterNames, source);
      return this.install(name, formals, body, description, source);
    };
    GrammarDecl.prototype.override = function(name, formals, body, descIgnored, source) {
      return this.ensureSuperGrammarRuleForOverriding(name, source), this.installOverriddenOrExtendedRule(name, formals, body, source), this;
    };
    GrammarDecl.prototype.extend = function(name, formals, fragment, descIgnored, source) {
      if (!this.ensureSuperGrammar().rules[name])
        throw errors2.cannotExtendUndeclaredRule(name, this.superGrammar.name, source);
      let body = new pexprs.Extend(this.superGrammar, name, fragment);
      return body.source = fragment.source, this.installOverriddenOrExtendedRule(name, formals, body, source), this;
    };
    module.exports = GrammarDecl;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/Builder.js
var require_Builder = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/Builder.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Grammar = require_Grammar(), GrammarDecl = require_GrammarDecl(), pexprs = require_pexprs();
    function Builder() {
    }
    Builder.prototype = {
      currentDecl: null,
      currentRuleName: null,
      newGrammar(name) {
        return new GrammarDecl(name);
      },
      grammar(metaInfo, name, superGrammar, defaultStartRule, rules) {
        let gDecl = new GrammarDecl(name);
        return superGrammar && gDecl.withSuperGrammar(
          superGrammar instanceof Grammar ? superGrammar : this.fromRecipe(superGrammar)
        ), defaultStartRule && gDecl.withDefaultStartRule(defaultStartRule), metaInfo && metaInfo.source && gDecl.withSource(metaInfo.source), this.currentDecl = gDecl, Object.keys(rules).forEach((ruleName) => {
          this.currentRuleName = ruleName;
          let ruleRecipe = rules[ruleName], action = ruleRecipe[0], metaInfo2 = ruleRecipe[1], description = ruleRecipe[2], formals = ruleRecipe[3], body = this.fromRecipe(ruleRecipe[4]), source;
          gDecl.source && metaInfo2 && metaInfo2.sourceInterval && (source = gDecl.source.subInterval(
            metaInfo2.sourceInterval[0],
            metaInfo2.sourceInterval[1] - metaInfo2.sourceInterval[0]
          )), gDecl[action](ruleName, formals, body, description, source);
        }), this.currentRuleName = this.currentDecl = null, gDecl.build();
      },
      terminal(x) {
        return new pexprs.Terminal(x);
      },
      range(from, to) {
        return new pexprs.Range(from, to);
      },
      param(index) {
        return new pexprs.Param(index);
      },
      alt(...termArgs) {
        let terms = [];
        for (let arg of termArgs)
          arg instanceof pexprs.PExpr || (arg = this.fromRecipe(arg)), arg instanceof pexprs.Alt ? terms = terms.concat(arg.terms) : terms.push(arg);
        return terms.length === 1 ? terms[0] : new pexprs.Alt(terms);
      },
      seq(...factorArgs) {
        let factors = [];
        for (let arg of factorArgs)
          arg instanceof pexprs.PExpr || (arg = this.fromRecipe(arg)), arg instanceof pexprs.Seq ? factors = factors.concat(arg.factors) : factors.push(arg);
        return factors.length === 1 ? factors[0] : new pexprs.Seq(factors);
      },
      star(expr) {
        return expr instanceof pexprs.PExpr || (expr = this.fromRecipe(expr)), new pexprs.Star(expr);
      },
      plus(expr) {
        return expr instanceof pexprs.PExpr || (expr = this.fromRecipe(expr)), new pexprs.Plus(expr);
      },
      opt(expr) {
        return expr instanceof pexprs.PExpr || (expr = this.fromRecipe(expr)), new pexprs.Opt(expr);
      },
      not(expr) {
        return expr instanceof pexprs.PExpr || (expr = this.fromRecipe(expr)), new pexprs.Not(expr);
      },
      la(expr) {
        return this.lookahead(expr);
      },
      lookahead(expr) {
        return expr instanceof pexprs.PExpr || (expr = this.fromRecipe(expr)), new pexprs.Lookahead(expr);
      },
      lex(expr) {
        return expr instanceof pexprs.PExpr || (expr = this.fromRecipe(expr)), new pexprs.Lex(expr);
      },
      app(ruleName, optParams) {
        return optParams && optParams.length > 0 && (optParams = optParams.map(function(param) {
          return param instanceof pexprs.PExpr ? param : this.fromRecipe(param);
        }, this)), new pexprs.Apply(ruleName, optParams);
      },
      // Note that unlike other methods in this class, this method cannot be used as a
      // convenience constructor. It only works with recipes, because it relies on
      // `this.currentDecl` and `this.currentRuleName` being set.
      splice(beforeTerms, afterTerms) {
        return new pexprs.Splice(
          this.currentDecl.superGrammar,
          this.currentRuleName,
          beforeTerms.map((term) => this.fromRecipe(term)),
          afterTerms.map((term) => this.fromRecipe(term))
        );
      },
      fromRecipe(recipe) {
        let args = recipe[0] === "grammar" ? recipe.slice(1) : recipe.slice(2), result = this[recipe[0]](...args), metaInfo = recipe[1];
        return metaInfo && metaInfo.sourceInterval && this.currentDecl && result.withSource(this.currentDecl.sourceInterval(...metaInfo.sourceInterval)), result;
      }
    };
    module.exports = Builder;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/package.json
var require_package = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/package.json"(exports, module) {
    module.exports = {
      name: "ohm-js",
      version: "16.6.0",
      description: "An object-oriented language for parsing and pattern matching",
      repository: "https://github.com/harc/ohm",
      keywords: [
        "parser",
        "compiler",
        "pattern matching",
        "pattern-matching",
        "ometa",
        "ometa/js",
        "ometa-js",
        "ometajs",
        "rapid",
        "prototyping"
      ],
      homepage: "https://ohmjs.org",
      bugs: "https://github.com/harc/ohm/issues",
      main: "index.js",
      module: "dist/ohm.esm.js",
      files: [
        "src",
        "dist",
        "extras",
        "third_party",
        "index.d.ts"
      ],
      types: "index.d.ts",
      scripts: {
        prebootstrap: "bash scripts/prebootstrap",
        bootstrap: "bash scripts/bootstrap --test || (echo 'Bootstrap failed.' && mv -v dist/ohm-grammar.js.old dist/ohm-grammar.js && mv -v dist/built-in-rules.js.old dist/built-in-rules.js && mv -v dist/operations-and-attributes.js.old dist/operations-and-attributes.js)",
        build: "yarn build-debug && webpack --mode=production",
        "build-debug": "webpack --mode=development && yarn build-esm && node scripts/generate-types.mjs",
        "build-esm": "rollup -c rollup.config.mjs",
        clean: "rm -f dist/ohm.js dist/ohm.min.js",
        lint: "eslint . --ignore-path ../.eslintignore",
        format: "prettier . --write --ignore-path ../.prettierignore --config ../.prettierrc && eslint . --ignore-path ../.eslintignore --fix",
        test: "ava && ava --config ava-ts.config.js test/test-typings.ts",
        "test-watch": "ava --watch",
        "pre-commit": "yarn run lint && yarn run build && yarn run test",
        prepublishOnly: "bash scripts/prepublishOnly",
        prepack: "cp ../../README.md . && yarn build",
        postpack: "rm README.md",
        postpublish: "echo '\u{1F449}  Now go to https://github.com/harc/ohm/releases and create a release.'",
        "unsafe-bootstrap": "bash scripts/bootstrap",
        "update-contributors": "bash scripts/update-contributors",
        watch: "webpack --mode=development --watch"
      },
      license: "MIT",
      author: "Alex Warth <alexwarth@gmail.com> (http://tinlizzie.org/~awarth)",
      contributors: [
        "Patrick Dubroy <pdubroy@gmail.com>",
        "Meixian Li <lmeixian@gmail.com>",
        "Marko R\xF6der <m.roeder@photon-software.de>",
        "Tony Garnock-Jones <tonygarnockjones@gmail.com>",
        "Saketh Kasibatla <sake.kasi@gmail.com>",
        "Lionel Landwerlin <llandwerlin@gmail.com>",
        "Jason Merrill <jwmerrill@gmail.com>",
        "Ray Toal <rtoal@lmu.edu>",
        "Yoshiki Ohshima <Yoshiki.Ohshima@acm.org>",
        "megabuz <3299889+megabuz@users.noreply.github.com>",
        "Jonathan Edwards <JonathanMEdwards@gmail.com>",
        "Milan Lajto\u0161 <milan.lajtos@me.com>",
        "Neil Jewers <njjewers@uwaterloo.ca>",
        "stagas <gstagas@gmail.com>",
        "AngryPowman <angrypowman@qq.com>",
        "Arthur Carabott <arthurc@gmail.com>",
        "Casey Olson <casey.m.olson@gmail.com>",
        "Daniel Tomlinson <DanielTomlinson@me.com>",
        "Ian Harris <ian@fofgof.xyz>",
        "Justin Chase <justin.m.chase@gmail.com>",
        "Leslie Ying <acetophore@users.noreply.github.com>",
        "Luca Guzzon <luca.guzzon@gmail.com>",
        "Mike Niebling <(none)>",
        "Patrick Dubroy <patrick@sourcegraph.com>",
        "Pierre Donias <pierre.donias@gmail.com>",
        "Stan Rozenraukh <stan@stanistan.com>",
        "Stephan Seidt <stephan.seidt@gmail.com>",
        "Steve Phillips <steve@tryingtobeawesome.com>",
        "Szymon Kaliski <kaliskiszymon@gmail.com>",
        "Thomas Nyberg <tomnyberg@gmail.com>",
        "Vse Mozhet Byt <vsemozhetbyt@gmail.com>",
        "Wil Chung <10446+iamwilhelm@users.noreply.github.com>",
        "Zachary Sakowitz <zsakowitz@gmail.com>",
        "abego <ub@abego-software.de>",
        "acslk <d_vd415@hotmail.com>",
        "codeZeilen <codeZeilen@users.noreply.github.com>",
        "kassadin <kassadin@foxmail.com>",
        "owch <bowenrainyday@gmail.com>",
        "sfinnie <scott.finnie@gmail.com>"
      ],
      dependencies: {},
      devDependencies: {
        "@ohm-js/cli": "^1.0.0",
        "@rollup/plugin-commonjs": "^21.0.1",
        "@rollup/plugin-json": "^4.1.0",
        "@rollup/plugin-node-resolve": "^13.1.3",
        ava: "^3.15.0",
        "ava-spec": "^1.1.1",
        dedent: "^0.7.0",
        eslint: "^7.9.0",
        "eslint-config-google": "^0.14.0",
        "eslint-plugin-ava": "^11.0.0",
        "eslint-plugin-camelcase-ohm": "^0.2.1",
        "eslint-plugin-no-extension-in-require": "^0.2.0",
        husky: "^4.2.5",
        jsdom: "^9.9.1",
        json: "^9.0.6",
        markscript: "^0.5.0",
        "node-static": "^0.7.11",
        "ohm-grammar-ecmascript": "^1.0.0",
        rollup: "^2.63.0",
        "ts-loader": "^8.0.4",
        "ts-node": "^9.0.0",
        typescript: "^4.0.3",
        "walk-sync": "^2.2.0",
        webpack: "^4.44.2",
        "webpack-cli": "^3.3.12"
      },
      engines: {
        node: ">=0.12.1"
      }
    };
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/version.js
var require_version = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/version.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = typeof __GLOBAL_OHM_VERSION__ == "string" ? __GLOBAL_OHM_VERSION__ : require_package().version;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/makeRecipe.js
var require_makeRecipe = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/makeRecipe.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Builder = require_Builder();
    function makeRecipe(recipe) {
      return typeof recipe == "function" ? recipe.call(new Builder()) : (typeof recipe == "string" && (recipe = JSON.parse(recipe)), new Builder().fromRecipe(recipe));
    }
    exports.makeRecipe = makeRecipe;
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/dist/built-in-rules.js
var require_built_in_rules = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/dist/built-in-rules.js"(exports, module) {
    init_cjs_shims();
    var { makeRecipe } = require_makeRecipe();
    module.exports = makeRecipe(["grammar", { source: `BuiltInRules {

  alnum  (an alpha-numeric character)
    = letter
    | digit

  letter  (a letter)
    = lower
    | upper
    | unicodeLtmo

  digit  (a digit)
    = "0".."9"

  hexDigit  (a hexadecimal digit)
    = digit
    | "a".."f"
    | "A".."F"

  ListOf<elem, sep>
    = NonemptyListOf<elem, sep>
    | EmptyListOf<elem, sep>

  NonemptyListOf<elem, sep>
    = elem (sep elem)*

  EmptyListOf<elem, sep>
    = /* nothing */

  listOf<elem, sep>
    = nonemptyListOf<elem, sep>
    | emptyListOf<elem, sep>

  nonemptyListOf<elem, sep>
    = elem (sep elem)*

  emptyListOf<elem, sep>
    = /* nothing */

  // Allows a syntactic rule application within a lexical context.
  applySyntactic<app> = app
}` }, "BuiltInRules", null, null, { alnum: ["define", { sourceInterval: [18, 78] }, "an alpha-numeric character", [], ["alt", { sourceInterval: [60, 78] }, ["app", { sourceInterval: [60, 66] }, "letter", []], ["app", { sourceInterval: [73, 78] }, "digit", []]]], letter: ["define", { sourceInterval: [82, 142] }, "a letter", [], ["alt", { sourceInterval: [107, 142] }, ["app", { sourceInterval: [107, 112] }, "lower", []], ["app", { sourceInterval: [119, 124] }, "upper", []], ["app", { sourceInterval: [131, 142] }, "unicodeLtmo", []]]], digit: ["define", { sourceInterval: [146, 177] }, "a digit", [], ["range", { sourceInterval: [169, 177] }, "0", "9"]], hexDigit: ["define", { sourceInterval: [181, 254] }, "a hexadecimal digit", [], ["alt", { sourceInterval: [219, 254] }, ["app", { sourceInterval: [219, 224] }, "digit", []], ["range", { sourceInterval: [231, 239] }, "a", "f"], ["range", { sourceInterval: [246, 254] }, "A", "F"]]], ListOf: ["define", { sourceInterval: [258, 336] }, null, ["elem", "sep"], ["alt", { sourceInterval: [282, 336] }, ["app", { sourceInterval: [282, 307] }, "NonemptyListOf", [["param", { sourceInterval: [297, 301] }, 0], ["param", { sourceInterval: [303, 306] }, 1]]], ["app", { sourceInterval: [314, 336] }, "EmptyListOf", [["param", { sourceInterval: [326, 330] }, 0], ["param", { sourceInterval: [332, 335] }, 1]]]]], NonemptyListOf: ["define", { sourceInterval: [340, 388] }, null, ["elem", "sep"], ["seq", { sourceInterval: [372, 388] }, ["param", { sourceInterval: [372, 376] }, 0], ["star", { sourceInterval: [377, 388] }, ["seq", { sourceInterval: [378, 386] }, ["param", { sourceInterval: [378, 381] }, 1], ["param", { sourceInterval: [382, 386] }, 0]]]]], EmptyListOf: ["define", { sourceInterval: [392, 434] }, null, ["elem", "sep"], ["seq", { sourceInterval: [438, 438] }]], listOf: ["define", { sourceInterval: [438, 516] }, null, ["elem", "sep"], ["alt", { sourceInterval: [462, 516] }, ["app", { sourceInterval: [462, 487] }, "nonemptyListOf", [["param", { sourceInterval: [477, 481] }, 0], ["param", { sourceInterval: [483, 486] }, 1]]], ["app", { sourceInterval: [494, 516] }, "emptyListOf", [["param", { sourceInterval: [506, 510] }, 0], ["param", { sourceInterval: [512, 515] }, 1]]]]], nonemptyListOf: ["define", { sourceInterval: [520, 568] }, null, ["elem", "sep"], ["seq", { sourceInterval: [552, 568] }, ["param", { sourceInterval: [552, 556] }, 0], ["star", { sourceInterval: [557, 568] }, ["seq", { sourceInterval: [558, 566] }, ["param", { sourceInterval: [558, 561] }, 1], ["param", { sourceInterval: [562, 566] }, 0]]]]], emptyListOf: ["define", { sourceInterval: [572, 682] }, null, ["elem", "sep"], ["seq", { sourceInterval: [685, 685] }]], applySyntactic: ["define", { sourceInterval: [685, 710] }, null, ["app"], ["param", { sourceInterval: [707, 710] }, 0]] }]);
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/grammarDeferredInit.js
var require_grammarDeferredInit = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/grammarDeferredInit.js"() {
    "use strict";
    init_cjs_shims();
    var Grammar = require_Grammar();
    Grammar.BuiltInRules = require_built_in_rules();
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/dist/operations-and-attributes.js
var require_operations_and_attributes = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/dist/operations-and-attributes.js"(exports, module) {
    init_cjs_shims();
    var { makeRecipe } = require_makeRecipe();
    module.exports = makeRecipe(["grammar", { source: `OperationsAndAttributes {

  AttributeSignature =
    name

  OperationSignature =
    name Formals?

  Formals
    = "(" ListOf<name, ","> ")"

  name  (a name)
    = nameFirst nameRest*

  nameFirst
    = "_"
    | letter

  nameRest
    = "_"
    | alnum

}` }, "OperationsAndAttributes", null, "AttributeSignature", { AttributeSignature: ["define", { sourceInterval: [29, 58] }, null, [], ["app", { sourceInterval: [54, 58] }, "name", []]], OperationSignature: ["define", { sourceInterval: [62, 100] }, null, [], ["seq", { sourceInterval: [87, 100] }, ["app", { sourceInterval: [87, 91] }, "name", []], ["opt", { sourceInterval: [92, 100] }, ["app", { sourceInterval: [92, 99] }, "Formals", []]]]], Formals: ["define", { sourceInterval: [104, 143] }, null, [], ["seq", { sourceInterval: [118, 143] }, ["terminal", { sourceInterval: [118, 121] }, "("], ["app", { sourceInterval: [122, 139] }, "ListOf", [["app", { sourceInterval: [129, 133] }, "name", []], ["terminal", { sourceInterval: [135, 138] }, ","]]], ["terminal", { sourceInterval: [140, 143] }, ")"]]], name: ["define", { sourceInterval: [147, 187] }, "a name", [], ["seq", { sourceInterval: [168, 187] }, ["app", { sourceInterval: [168, 177] }, "nameFirst", []], ["star", { sourceInterval: [178, 187] }, ["app", { sourceInterval: [178, 186] }, "nameRest", []]]]], nameFirst: ["define", { sourceInterval: [191, 223] }, null, [], ["alt", { sourceInterval: [207, 223] }, ["terminal", { sourceInterval: [207, 210] }, "_"], ["app", { sourceInterval: [217, 223] }, "letter", []]]], nameRest: ["define", { sourceInterval: [227, 257] }, null, [], ["alt", { sourceInterval: [242, 257] }, ["terminal", { sourceInterval: [242, 245] }, "_"], ["app", { sourceInterval: [252, 257] }, "alnum", []]]] }]);
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/semanticsDeferredInit.js
var require_semanticsDeferredInit = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/semanticsDeferredInit.js"() {
    "use strict";
    init_cjs_shims();
    var Semantics = require_Semantics(), util2 = require_util();
    util2.awaitBuiltInRules((builtInRules) => {
      let operationsAndAttributesGrammar = require_operations_and_attributes();
      initBuiltInSemantics(builtInRules), initPrototypeParser(operationsAndAttributesGrammar);
    });
    function initBuiltInSemantics(builtInRules) {
      let actions = {
        empty() {
          return this.iteration();
        },
        nonEmpty(first, _2, rest) {
          return this.iteration([first].concat(rest.children));
        }
      };
      Semantics.BuiltInSemantics = Semantics.createSemantics(builtInRules, null).addOperation(
        "asIteration",
        {
          emptyListOf: actions.empty,
          nonemptyListOf: actions.nonEmpty,
          EmptyListOf: actions.empty,
          NonemptyListOf: actions.nonEmpty
        }
      );
    }
    function initPrototypeParser(grammar) {
      Semantics.prototypeGrammarSemantics = grammar.createSemantics().addOperation("parse", {
        AttributeSignature(name) {
          return {
            name: name.parse(),
            formals: []
          };
        },
        OperationSignature(name, optFormals) {
          return {
            name: name.parse(),
            formals: optFormals.children.map((c) => c.parse())[0] || []
          };
        },
        Formals(oparen, fs6, cparen) {
          return fs6.asIteration().children.map((c) => c.parse());
        },
        name(first, rest) {
          return this.sourceString;
        }
      }), Semantics.prototypeGrammar = grammar;
    }
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/deferredInit.js
var require_deferredInit = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/deferredInit.js"() {
    "use strict";
    init_cjs_shims();
    require_grammarDeferredInit();
    require_semanticsDeferredInit();
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/dist/ohm-grammar.js
var require_ohm_grammar = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/dist/ohm-grammar.js"(exports, module) {
    init_cjs_shims();
    var { makeRecipe } = require_makeRecipe();
    module.exports = makeRecipe(["grammar", { source: `Ohm {

  Grammars
    = Grammar*

  Grammar
    = ident SuperGrammar? "{" Rule* "}"

  SuperGrammar
    = "<:" ident

  Rule
    = ident Formals? ruleDescr? "="  RuleBody  -- define
    | ident Formals?            ":=" OverrideRuleBody  -- override
    | ident Formals?            "+=" RuleBody  -- extend

  RuleBody
    = "|"? NonemptyListOf<TopLevelTerm, "|">

  TopLevelTerm
    = Seq caseName  -- inline
    | Seq

  OverrideRuleBody
    = "|"? NonemptyListOf<OverrideTopLevelTerm, "|">

  OverrideTopLevelTerm
    = "..."  -- superSplice
    | TopLevelTerm

  Formals
    = "<" ListOf<ident, ","> ">"

  Params
    = "<" ListOf<Seq, ","> ">"

  Alt
    = NonemptyListOf<Seq, "|">

  Seq
    = Iter*

  Iter
    = Pred "*"  -- star
    | Pred "+"  -- plus
    | Pred "?"  -- opt
    | Pred

  Pred
    = "~" Lex  -- not
    | "&" Lex  -- lookahead
    | Lex

  Lex
    = "#" Base  -- lex
    | Base

  Base
    = ident Params? ~(ruleDescr? "=" | ":=" | "+=")  -- application
    | oneCharTerminal ".." oneCharTerminal           -- range
    | terminal                                       -- terminal
    | "(" Alt ")"                                    -- paren

  ruleDescr  (a rule description)
    = "(" ruleDescrText ")"

  ruleDescrText
    = (~")" any)*

  caseName
    = "--" (~"\\n" space)* name (~"\\n" space)* ("\\n" | &"}")

  name  (a name)
    = nameFirst nameRest*

  nameFirst
    = "_"
    | letter

  nameRest
    = "_"
    | alnum

  ident  (an identifier)
    = name

  terminal
    = "\\"" terminalChar* "\\""

  oneCharTerminal
    = "\\"" terminalChar "\\""

  terminalChar
    = escapeChar
      | ~"\\\\" ~"\\"" ~"\\n" "\\u{0}".."\\u{10FFFF}"

  escapeChar  (an escape sequence)
    = "\\\\\\\\"                                     -- backslash
    | "\\\\\\""                                     -- doubleQuote
    | "\\\\\\'"                                     -- singleQuote
    | "\\\\b"                                      -- backspace
    | "\\\\n"                                      -- lineFeed
    | "\\\\r"                                      -- carriageReturn
    | "\\\\t"                                      -- tab
    | "\\\\u{" hexDigit hexDigit? hexDigit?
             hexDigit? hexDigit? hexDigit? "}"   -- unicodeCodePoint
    | "\\\\u" hexDigit hexDigit hexDigit hexDigit  -- unicodeEscape
    | "\\\\x" hexDigit hexDigit                    -- hexEscape

  space
   += comment

  comment
    = "//" (~"\\n" any)* &("\\n" | end)  -- singleLine
    | "/*" (~"*/" any)* "*/"  -- multiLine

  tokens = token*

  token = caseName | comment | ident | operator | punctuation | terminal | any

  operator = "<:" | "=" | ":=" | "+=" | "*" | "+" | "?" | "~" | "&"

  punctuation = "<" | ">" | "," | "--"
}` }, "Ohm", null, "Grammars", { Grammars: ["define", { sourceInterval: [9, 32] }, null, [], ["star", { sourceInterval: [24, 32] }, ["app", { sourceInterval: [24, 31] }, "Grammar", []]]], Grammar: ["define", { sourceInterval: [36, 83] }, null, [], ["seq", { sourceInterval: [50, 83] }, ["app", { sourceInterval: [50, 55] }, "ident", []], ["opt", { sourceInterval: [56, 69] }, ["app", { sourceInterval: [56, 68] }, "SuperGrammar", []]], ["terminal", { sourceInterval: [70, 73] }, "{"], ["star", { sourceInterval: [74, 79] }, ["app", { sourceInterval: [74, 78] }, "Rule", []]], ["terminal", { sourceInterval: [80, 83] }, "}"]]], SuperGrammar: ["define", { sourceInterval: [87, 116] }, null, [], ["seq", { sourceInterval: [106, 116] }, ["terminal", { sourceInterval: [106, 110] }, "<:"], ["app", { sourceInterval: [111, 116] }, "ident", []]]], Rule_define: ["define", { sourceInterval: [131, 181] }, null, [], ["seq", { sourceInterval: [131, 170] }, ["app", { sourceInterval: [131, 136] }, "ident", []], ["opt", { sourceInterval: [137, 145] }, ["app", { sourceInterval: [137, 144] }, "Formals", []]], ["opt", { sourceInterval: [146, 156] }, ["app", { sourceInterval: [146, 155] }, "ruleDescr", []]], ["terminal", { sourceInterval: [157, 160] }, "="], ["app", { sourceInterval: [162, 170] }, "RuleBody", []]]], Rule_override: ["define", { sourceInterval: [188, 248] }, null, [], ["seq", { sourceInterval: [188, 235] }, ["app", { sourceInterval: [188, 193] }, "ident", []], ["opt", { sourceInterval: [194, 202] }, ["app", { sourceInterval: [194, 201] }, "Formals", []]], ["terminal", { sourceInterval: [214, 218] }, ":="], ["app", { sourceInterval: [219, 235] }, "OverrideRuleBody", []]]], Rule_extend: ["define", { sourceInterval: [255, 305] }, null, [], ["seq", { sourceInterval: [255, 294] }, ["app", { sourceInterval: [255, 260] }, "ident", []], ["opt", { sourceInterval: [261, 269] }, ["app", { sourceInterval: [261, 268] }, "Formals", []]], ["terminal", { sourceInterval: [281, 285] }, "+="], ["app", { sourceInterval: [286, 294] }, "RuleBody", []]]], Rule: ["define", { sourceInterval: [120, 305] }, null, [], ["alt", { sourceInterval: [131, 305] }, ["app", { sourceInterval: [131, 170] }, "Rule_define", []], ["app", { sourceInterval: [188, 235] }, "Rule_override", []], ["app", { sourceInterval: [255, 294] }, "Rule_extend", []]]], RuleBody: ["define", { sourceInterval: [309, 362] }, null, [], ["seq", { sourceInterval: [324, 362] }, ["opt", { sourceInterval: [324, 328] }, ["terminal", { sourceInterval: [324, 327] }, "|"]], ["app", { sourceInterval: [329, 362] }, "NonemptyListOf", [["app", { sourceInterval: [344, 356] }, "TopLevelTerm", []], ["terminal", { sourceInterval: [358, 361] }, "|"]]]]], TopLevelTerm_inline: ["define", { sourceInterval: [385, 408] }, null, [], ["seq", { sourceInterval: [385, 397] }, ["app", { sourceInterval: [385, 388] }, "Seq", []], ["app", { sourceInterval: [389, 397] }, "caseName", []]]], TopLevelTerm: ["define", { sourceInterval: [366, 418] }, null, [], ["alt", { sourceInterval: [385, 418] }, ["app", { sourceInterval: [385, 397] }, "TopLevelTerm_inline", []], ["app", { sourceInterval: [415, 418] }, "Seq", []]]], OverrideRuleBody: ["define", { sourceInterval: [422, 491] }, null, [], ["seq", { sourceInterval: [445, 491] }, ["opt", { sourceInterval: [445, 449] }, ["terminal", { sourceInterval: [445, 448] }, "|"]], ["app", { sourceInterval: [450, 491] }, "NonemptyListOf", [["app", { sourceInterval: [465, 485] }, "OverrideTopLevelTerm", []], ["terminal", { sourceInterval: [487, 490] }, "|"]]]]], OverrideTopLevelTerm_superSplice: ["define", { sourceInterval: [522, 543] }, null, [], ["terminal", { sourceInterval: [522, 527] }, "..."]], OverrideTopLevelTerm: ["define", { sourceInterval: [495, 562] }, null, [], ["alt", { sourceInterval: [522, 562] }, ["app", { sourceInterval: [522, 527] }, "OverrideTopLevelTerm_superSplice", []], ["app", { sourceInterval: [550, 562] }, "TopLevelTerm", []]]], Formals: ["define", { sourceInterval: [566, 606] }, null, [], ["seq", { sourceInterval: [580, 606] }, ["terminal", { sourceInterval: [580, 583] }, "<"], ["app", { sourceInterval: [584, 602] }, "ListOf", [["app", { sourceInterval: [591, 596] }, "ident", []], ["terminal", { sourceInterval: [598, 601] }, ","]]], ["terminal", { sourceInterval: [603, 606] }, ">"]]], Params: ["define", { sourceInterval: [610, 647] }, null, [], ["seq", { sourceInterval: [623, 647] }, ["terminal", { sourceInterval: [623, 626] }, "<"], ["app", { sourceInterval: [627, 643] }, "ListOf", [["app", { sourceInterval: [634, 637] }, "Seq", []], ["terminal", { sourceInterval: [639, 642] }, ","]]], ["terminal", { sourceInterval: [644, 647] }, ">"]]], Alt: ["define", { sourceInterval: [651, 685] }, null, [], ["app", { sourceInterval: [661, 685] }, "NonemptyListOf", [["app", { sourceInterval: [676, 679] }, "Seq", []], ["terminal", { sourceInterval: [681, 684] }, "|"]]]], Seq: ["define", { sourceInterval: [689, 704] }, null, [], ["star", { sourceInterval: [699, 704] }, ["app", { sourceInterval: [699, 703] }, "Iter", []]]], Iter_star: ["define", { sourceInterval: [719, 736] }, null, [], ["seq", { sourceInterval: [719, 727] }, ["app", { sourceInterval: [719, 723] }, "Pred", []], ["terminal", { sourceInterval: [724, 727] }, "*"]]], Iter_plus: ["define", { sourceInterval: [743, 760] }, null, [], ["seq", { sourceInterval: [743, 751] }, ["app", { sourceInterval: [743, 747] }, "Pred", []], ["terminal", { sourceInterval: [748, 751] }, "+"]]], Iter_opt: ["define", { sourceInterval: [767, 783] }, null, [], ["seq", { sourceInterval: [767, 775] }, ["app", { sourceInterval: [767, 771] }, "Pred", []], ["terminal", { sourceInterval: [772, 775] }, "?"]]], Iter: ["define", { sourceInterval: [708, 794] }, null, [], ["alt", { sourceInterval: [719, 794] }, ["app", { sourceInterval: [719, 727] }, "Iter_star", []], ["app", { sourceInterval: [743, 751] }, "Iter_plus", []], ["app", { sourceInterval: [767, 775] }, "Iter_opt", []], ["app", { sourceInterval: [790, 794] }, "Pred", []]]], Pred_not: ["define", { sourceInterval: [809, 824] }, null, [], ["seq", { sourceInterval: [809, 816] }, ["terminal", { sourceInterval: [809, 812] }, "~"], ["app", { sourceInterval: [813, 816] }, "Lex", []]]], Pred_lookahead: ["define", { sourceInterval: [831, 852] }, null, [], ["seq", { sourceInterval: [831, 838] }, ["terminal", { sourceInterval: [831, 834] }, "&"], ["app", { sourceInterval: [835, 838] }, "Lex", []]]], Pred: ["define", { sourceInterval: [798, 862] }, null, [], ["alt", { sourceInterval: [809, 862] }, ["app", { sourceInterval: [809, 816] }, "Pred_not", []], ["app", { sourceInterval: [831, 838] }, "Pred_lookahead", []], ["app", { sourceInterval: [859, 862] }, "Lex", []]]], Lex_lex: ["define", { sourceInterval: [876, 892] }, null, [], ["seq", { sourceInterval: [876, 884] }, ["terminal", { sourceInterval: [876, 879] }, "#"], ["app", { sourceInterval: [880, 884] }, "Base", []]]], Lex: ["define", { sourceInterval: [866, 903] }, null, [], ["alt", { sourceInterval: [876, 903] }, ["app", { sourceInterval: [876, 884] }, "Lex_lex", []], ["app", { sourceInterval: [899, 903] }, "Base", []]]], Base_application: ["define", { sourceInterval: [918, 979] }, null, [], ["seq", { sourceInterval: [918, 963] }, ["app", { sourceInterval: [918, 923] }, "ident", []], ["opt", { sourceInterval: [924, 931] }, ["app", { sourceInterval: [924, 930] }, "Params", []]], ["not", { sourceInterval: [932, 963] }, ["alt", { sourceInterval: [934, 962] }, ["seq", { sourceInterval: [934, 948] }, ["opt", { sourceInterval: [934, 944] }, ["app", { sourceInterval: [934, 943] }, "ruleDescr", []]], ["terminal", { sourceInterval: [945, 948] }, "="]], ["terminal", { sourceInterval: [951, 955] }, ":="], ["terminal", { sourceInterval: [958, 962] }, "+="]]]]], Base_range: ["define", { sourceInterval: [986, 1041] }, null, [], ["seq", { sourceInterval: [986, 1022] }, ["app", { sourceInterval: [986, 1001] }, "oneCharTerminal", []], ["terminal", { sourceInterval: [1002, 1006] }, ".."], ["app", { sourceInterval: [1007, 1022] }, "oneCharTerminal", []]]], Base_terminal: ["define", { sourceInterval: [1048, 1106] }, null, [], ["app", { sourceInterval: [1048, 1056] }, "terminal", []]], Base_paren: ["define", { sourceInterval: [1113, 1168] }, null, [], ["seq", { sourceInterval: [1113, 1124] }, ["terminal", { sourceInterval: [1113, 1116] }, "("], ["app", { sourceInterval: [1117, 1120] }, "Alt", []], ["terminal", { sourceInterval: [1121, 1124] }, ")"]]], Base: ["define", { sourceInterval: [907, 1168] }, null, [], ["alt", { sourceInterval: [918, 1168] }, ["app", { sourceInterval: [918, 963] }, "Base_application", []], ["app", { sourceInterval: [986, 1022] }, "Base_range", []], ["app", { sourceInterval: [1048, 1056] }, "Base_terminal", []], ["app", { sourceInterval: [1113, 1124] }, "Base_paren", []]]], ruleDescr: ["define", { sourceInterval: [1172, 1231] }, "a rule description", [], ["seq", { sourceInterval: [1210, 1231] }, ["terminal", { sourceInterval: [1210, 1213] }, "("], ["app", { sourceInterval: [1214, 1227] }, "ruleDescrText", []], ["terminal", { sourceInterval: [1228, 1231] }, ")"]]], ruleDescrText: ["define", { sourceInterval: [1235, 1266] }, null, [], ["star", { sourceInterval: [1255, 1266] }, ["seq", { sourceInterval: [1256, 1264] }, ["not", { sourceInterval: [1256, 1260] }, ["terminal", { sourceInterval: [1257, 1260] }, ")"]], ["app", { sourceInterval: [1261, 1264] }, "any", []]]]], caseName: ["define", { sourceInterval: [1270, 1338] }, null, [], ["seq", { sourceInterval: [1285, 1338] }, ["terminal", { sourceInterval: [1285, 1289] }, "--"], ["star", { sourceInterval: [1290, 1304] }, ["seq", { sourceInterval: [1291, 1302] }, ["not", { sourceInterval: [1291, 1296] }, ["terminal", { sourceInterval: [1292, 1296] }, `
`]], ["app", { sourceInterval: [1297, 1302] }, "space", []]]], ["app", { sourceInterval: [1305, 1309] }, "name", []], ["star", { sourceInterval: [1310, 1324] }, ["seq", { sourceInterval: [1311, 1322] }, ["not", { sourceInterval: [1311, 1316] }, ["terminal", { sourceInterval: [1312, 1316] }, `
`]], ["app", { sourceInterval: [1317, 1322] }, "space", []]]], ["alt", { sourceInterval: [1326, 1337] }, ["terminal", { sourceInterval: [1326, 1330] }, `
`], ["lookahead", { sourceInterval: [1333, 1337] }, ["terminal", { sourceInterval: [1334, 1337] }, "}"]]]]], name: ["define", { sourceInterval: [1342, 1382] }, "a name", [], ["seq", { sourceInterval: [1363, 1382] }, ["app", { sourceInterval: [1363, 1372] }, "nameFirst", []], ["star", { sourceInterval: [1373, 1382] }, ["app", { sourceInterval: [1373, 1381] }, "nameRest", []]]]], nameFirst: ["define", { sourceInterval: [1386, 1418] }, null, [], ["alt", { sourceInterval: [1402, 1418] }, ["terminal", { sourceInterval: [1402, 1405] }, "_"], ["app", { sourceInterval: [1412, 1418] }, "letter", []]]], nameRest: ["define", { sourceInterval: [1422, 1452] }, null, [], ["alt", { sourceInterval: [1437, 1452] }, ["terminal", { sourceInterval: [1437, 1440] }, "_"], ["app", { sourceInterval: [1447, 1452] }, "alnum", []]]], ident: ["define", { sourceInterval: [1456, 1489] }, "an identifier", [], ["app", { sourceInterval: [1485, 1489] }, "name", []]], terminal: ["define", { sourceInterval: [1493, 1531] }, null, [], ["seq", { sourceInterval: [1508, 1531] }, ["terminal", { sourceInterval: [1508, 1512] }, '"'], ["star", { sourceInterval: [1513, 1526] }, ["app", { sourceInterval: [1513, 1525] }, "terminalChar", []]], ["terminal", { sourceInterval: [1527, 1531] }, '"']]], oneCharTerminal: ["define", { sourceInterval: [1535, 1579] }, null, [], ["seq", { sourceInterval: [1557, 1579] }, ["terminal", { sourceInterval: [1557, 1561] }, '"'], ["app", { sourceInterval: [1562, 1574] }, "terminalChar", []], ["terminal", { sourceInterval: [1575, 1579] }, '"']]], terminalChar: ["define", { sourceInterval: [1583, 1660] }, null, [], ["alt", { sourceInterval: [1602, 1660] }, ["app", { sourceInterval: [1602, 1612] }, "escapeChar", []], ["seq", { sourceInterval: [1621, 1660] }, ["not", { sourceInterval: [1621, 1626] }, ["terminal", { sourceInterval: [1622, 1626] }, "\\"]], ["not", { sourceInterval: [1627, 1632] }, ["terminal", { sourceInterval: [1628, 1632] }, '"']], ["not", { sourceInterval: [1633, 1638] }, ["terminal", { sourceInterval: [1634, 1638] }, `
`]], ["range", { sourceInterval: [1639, 1660] }, "\0", "\u{10FFFF}"]]]], escapeChar_backslash: ["define", { sourceInterval: [1703, 1758] }, null, [], ["terminal", { sourceInterval: [1703, 1709] }, "\\\\"]], escapeChar_doubleQuote: ["define", { sourceInterval: [1765, 1822] }, null, [], ["terminal", { sourceInterval: [1765, 1771] }, '\\"']], escapeChar_singleQuote: ["define", { sourceInterval: [1829, 1886] }, null, [], ["terminal", { sourceInterval: [1829, 1835] }, "\\'"]], escapeChar_backspace: ["define", { sourceInterval: [1893, 1948] }, null, [], ["terminal", { sourceInterval: [1893, 1898] }, "\\b"]], escapeChar_lineFeed: ["define", { sourceInterval: [1955, 2009] }, null, [], ["terminal", { sourceInterval: [1955, 1960] }, "\\n"]], escapeChar_carriageReturn: ["define", { sourceInterval: [2016, 2076] }, null, [], ["terminal", { sourceInterval: [2016, 2021] }, "\\r"]], escapeChar_tab: ["define", { sourceInterval: [2083, 2132] }, null, [], ["terminal", { sourceInterval: [2083, 2088] }, "\\t"]], escapeChar_unicodeCodePoint: ["define", { sourceInterval: [2139, 2243] }, null, [], ["seq", { sourceInterval: [2139, 2221] }, ["terminal", { sourceInterval: [2139, 2145] }, "\\u{"], ["app", { sourceInterval: [2146, 2154] }, "hexDigit", []], ["opt", { sourceInterval: [2155, 2164] }, ["app", { sourceInterval: [2155, 2163] }, "hexDigit", []]], ["opt", { sourceInterval: [2165, 2174] }, ["app", { sourceInterval: [2165, 2173] }, "hexDigit", []]], ["opt", { sourceInterval: [2188, 2197] }, ["app", { sourceInterval: [2188, 2196] }, "hexDigit", []]], ["opt", { sourceInterval: [2198, 2207] }, ["app", { sourceInterval: [2198, 2206] }, "hexDigit", []]], ["opt", { sourceInterval: [2208, 2217] }, ["app", { sourceInterval: [2208, 2216] }, "hexDigit", []]], ["terminal", { sourceInterval: [2218, 2221] }, "}"]]], escapeChar_unicodeEscape: ["define", { sourceInterval: [2250, 2309] }, null, [], ["seq", { sourceInterval: [2250, 2291] }, ["terminal", { sourceInterval: [2250, 2255] }, "\\u"], ["app", { sourceInterval: [2256, 2264] }, "hexDigit", []], ["app", { sourceInterval: [2265, 2273] }, "hexDigit", []], ["app", { sourceInterval: [2274, 2282] }, "hexDigit", []], ["app", { sourceInterval: [2283, 2291] }, "hexDigit", []]]], escapeChar_hexEscape: ["define", { sourceInterval: [2316, 2371] }, null, [], ["seq", { sourceInterval: [2316, 2339] }, ["terminal", { sourceInterval: [2316, 2321] }, "\\x"], ["app", { sourceInterval: [2322, 2330] }, "hexDigit", []], ["app", { sourceInterval: [2331, 2339] }, "hexDigit", []]]], escapeChar: ["define", { sourceInterval: [1664, 2371] }, "an escape sequence", [], ["alt", { sourceInterval: [1703, 2371] }, ["app", { sourceInterval: [1703, 1709] }, "escapeChar_backslash", []], ["app", { sourceInterval: [1765, 1771] }, "escapeChar_doubleQuote", []], ["app", { sourceInterval: [1829, 1835] }, "escapeChar_singleQuote", []], ["app", { sourceInterval: [1893, 1898] }, "escapeChar_backspace", []], ["app", { sourceInterval: [1955, 1960] }, "escapeChar_lineFeed", []], ["app", { sourceInterval: [2016, 2021] }, "escapeChar_carriageReturn", []], ["app", { sourceInterval: [2083, 2088] }, "escapeChar_tab", []], ["app", { sourceInterval: [2139, 2221] }, "escapeChar_unicodeCodePoint", []], ["app", { sourceInterval: [2250, 2291] }, "escapeChar_unicodeEscape", []], ["app", { sourceInterval: [2316, 2339] }, "escapeChar_hexEscape", []]]], space: ["extend", { sourceInterval: [2375, 2394] }, null, [], ["app", { sourceInterval: [2387, 2394] }, "comment", []]], comment_singleLine: ["define", { sourceInterval: [2412, 2458] }, null, [], ["seq", { sourceInterval: [2412, 2443] }, ["terminal", { sourceInterval: [2412, 2416] }, "//"], ["star", { sourceInterval: [2417, 2429] }, ["seq", { sourceInterval: [2418, 2427] }, ["not", { sourceInterval: [2418, 2423] }, ["terminal", { sourceInterval: [2419, 2423] }, `
`]], ["app", { sourceInterval: [2424, 2427] }, "any", []]]], ["lookahead", { sourceInterval: [2430, 2443] }, ["alt", { sourceInterval: [2432, 2442] }, ["terminal", { sourceInterval: [2432, 2436] }, `
`], ["app", { sourceInterval: [2439, 2442] }, "end", []]]]]], comment_multiLine: ["define", { sourceInterval: [2465, 2501] }, null, [], ["seq", { sourceInterval: [2465, 2487] }, ["terminal", { sourceInterval: [2465, 2469] }, "/*"], ["star", { sourceInterval: [2470, 2482] }, ["seq", { sourceInterval: [2471, 2480] }, ["not", { sourceInterval: [2471, 2476] }, ["terminal", { sourceInterval: [2472, 2476] }, "*/"]], ["app", { sourceInterval: [2477, 2480] }, "any", []]]], ["terminal", { sourceInterval: [2483, 2487] }, "*/"]]], comment: ["define", { sourceInterval: [2398, 2501] }, null, [], ["alt", { sourceInterval: [2412, 2501] }, ["app", { sourceInterval: [2412, 2443] }, "comment_singleLine", []], ["app", { sourceInterval: [2465, 2487] }, "comment_multiLine", []]]], tokens: ["define", { sourceInterval: [2505, 2520] }, null, [], ["star", { sourceInterval: [2514, 2520] }, ["app", { sourceInterval: [2514, 2519] }, "token", []]]], token: ["define", { sourceInterval: [2524, 2600] }, null, [], ["alt", { sourceInterval: [2532, 2600] }, ["app", { sourceInterval: [2532, 2540] }, "caseName", []], ["app", { sourceInterval: [2543, 2550] }, "comment", []], ["app", { sourceInterval: [2553, 2558] }, "ident", []], ["app", { sourceInterval: [2561, 2569] }, "operator", []], ["app", { sourceInterval: [2572, 2583] }, "punctuation", []], ["app", { sourceInterval: [2586, 2594] }, "terminal", []], ["app", { sourceInterval: [2597, 2600] }, "any", []]]], operator: ["define", { sourceInterval: [2604, 2669] }, null, [], ["alt", { sourceInterval: [2615, 2669] }, ["terminal", { sourceInterval: [2615, 2619] }, "<:"], ["terminal", { sourceInterval: [2622, 2625] }, "="], ["terminal", { sourceInterval: [2628, 2632] }, ":="], ["terminal", { sourceInterval: [2635, 2639] }, "+="], ["terminal", { sourceInterval: [2642, 2645] }, "*"], ["terminal", { sourceInterval: [2648, 2651] }, "+"], ["terminal", { sourceInterval: [2654, 2657] }, "?"], ["terminal", { sourceInterval: [2660, 2663] }, "~"], ["terminal", { sourceInterval: [2666, 2669] }, "&"]]], punctuation: ["define", { sourceInterval: [2673, 2709] }, null, [], ["alt", { sourceInterval: [2687, 2709] }, ["terminal", { sourceInterval: [2687, 2690] }, "<"], ["terminal", { sourceInterval: [2693, 2696] }, ">"], ["terminal", { sourceInterval: [2699, 2702] }, ","], ["terminal", { sourceInterval: [2705, 2709] }, "--"]]] }]);
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/main.js
var require_main = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/src/main.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Builder = require_Builder(), Grammar = require_Grammar(), Namespace = require_Namespace(), common = require_common(), errors2 = require_errors(), pexprs = require_pexprs(), util2 = require_util(), version2 = require_version(), { makeRecipe } = require_makeRecipe(), ohmGrammar, superSplicePlaceholder = Object.create(pexprs.PExpr.prototype), isBuffer = (obj) => !!obj.constructor && typeof obj.constructor.isBuffer == "function" && obj.constructor.isBuffer(obj);
    function buildGrammar(match2, namespace, optOhmGrammarForTesting) {
      let builder = new Builder(), decl, currentRuleName, currentRuleFormals, overriding = !1;
      return (optOhmGrammarForTesting || ohmGrammar).createSemantics().addOperation("visit", {
        Grammars(grammarIter) {
          return grammarIter.children.map((c) => c.visit());
        },
        Grammar(id, s, _open, rules, _close) {
          let grammarName = id.visit();
          decl = builder.newGrammar(grammarName, namespace), s.child(0) && s.child(0).visit(), rules.children.map((c) => c.visit());
          let g = decl.build();
          if (g.source = this.source.trimmed(), grammarName in namespace)
            throw errors2.duplicateGrammarDeclaration(g, namespace);
          return namespace[grammarName] = g, g;
        },
        SuperGrammar(_2, n) {
          let superGrammarName = n.visit();
          if (superGrammarName === "null")
            decl.withSuperGrammar(null);
          else {
            if (!namespace || !(superGrammarName in namespace))
              throw errors2.undeclaredGrammar(superGrammarName, namespace, n.source);
            decl.withSuperGrammar(namespace[superGrammarName]);
          }
        },
        Rule_define(n, fs6, d, _2, b) {
          currentRuleName = n.visit(), currentRuleFormals = fs6.children.map((c) => c.visit())[0] || [], !decl.defaultStartRule && decl.ensureSuperGrammar() !== Grammar.ProtoBuiltInRules && decl.withDefaultStartRule(currentRuleName);
          let body = b.visit(), description = d.children.map((c) => c.visit())[0], source = this.source.trimmed();
          return decl.define(currentRuleName, currentRuleFormals, body, description, source);
        },
        Rule_override(n, fs6, _2, b) {
          currentRuleName = n.visit(), currentRuleFormals = fs6.children.map((c) => c.visit())[0] || [];
          let source = this.source.trimmed();
          decl.ensureSuperGrammarRuleForOverriding(currentRuleName, source), overriding = !0;
          let body = b.visit();
          return overriding = !1, decl.override(currentRuleName, currentRuleFormals, body, null, source);
        },
        Rule_extend(n, fs6, _2, b) {
          currentRuleName = n.visit(), currentRuleFormals = fs6.children.map((c) => c.visit())[0] || [];
          let body = b.visit(), source = this.source.trimmed();
          return decl.extend(currentRuleName, currentRuleFormals, body, null, source);
        },
        RuleBody(_2, terms) {
          return builder.alt(...terms.visit()).withSource(this.source);
        },
        OverrideRuleBody(_2, terms) {
          let args = terms.visit(), expansionPos = args.indexOf(superSplicePlaceholder);
          if (expansionPos >= 0) {
            let beforeTerms = args.slice(0, expansionPos), afterTerms = args.slice(expansionPos + 1);
            return afterTerms.forEach((t7) => {
              if (t7 === superSplicePlaceholder)
                throw errors2.multipleSuperSplices(t7);
            }), new pexprs.Splice(
              decl.superGrammar,
              currentRuleName,
              beforeTerms,
              afterTerms
            ).withSource(this.source);
          } else
            return builder.alt(...args).withSource(this.source);
        },
        Formals(opointy, fs6, cpointy) {
          return fs6.visit();
        },
        Params(opointy, ps, cpointy) {
          return ps.visit();
        },
        Alt(seqs) {
          return builder.alt(...seqs.visit()).withSource(this.source);
        },
        TopLevelTerm_inline(b, n) {
          let inlineRuleName = currentRuleName + "_" + n.visit(), body = b.visit(), source = this.source.trimmed(), isNewRuleDeclaration = !(decl.superGrammar && decl.superGrammar.rules[inlineRuleName]);
          overriding && !isNewRuleDeclaration ? decl.override(inlineRuleName, currentRuleFormals, body, null, source) : decl.define(inlineRuleName, currentRuleFormals, body, null, source);
          let params = currentRuleFormals.map((formal) => builder.app(formal));
          return builder.app(inlineRuleName, params).withSource(body.source);
        },
        OverrideTopLevelTerm_superSplice(_2) {
          return superSplicePlaceholder;
        },
        Seq(expr) {
          return builder.seq(...expr.children.map((c) => c.visit())).withSource(this.source);
        },
        Iter_star(x, _2) {
          return builder.star(x.visit()).withSource(this.source);
        },
        Iter_plus(x, _2) {
          return builder.plus(x.visit()).withSource(this.source);
        },
        Iter_opt(x, _2) {
          return builder.opt(x.visit()).withSource(this.source);
        },
        Pred_not(_2, x) {
          return builder.not(x.visit()).withSource(this.source);
        },
        Pred_lookahead(_2, x) {
          return builder.lookahead(x.visit()).withSource(this.source);
        },
        Lex_lex(_2, x) {
          return builder.lex(x.visit()).withSource(this.source);
        },
        Base_application(rule, ps) {
          let params = ps.children.map((c) => c.visit())[0] || [];
          return builder.app(rule.visit(), params).withSource(this.source);
        },
        Base_range(from, _2, to) {
          return builder.range(from.visit(), to.visit()).withSource(this.source);
        },
        Base_terminal(expr) {
          return builder.terminal(expr.visit()).withSource(this.source);
        },
        Base_paren(open2, x, close) {
          return x.visit();
        },
        ruleDescr(open2, t7, close) {
          return t7.visit();
        },
        ruleDescrText(_2) {
          return this.sourceString.trim();
        },
        caseName(_2, space1, n, space2, end) {
          return n.visit();
        },
        name(first, rest) {
          return this.sourceString;
        },
        nameFirst(expr) {
        },
        nameRest(expr) {
        },
        terminal(open2, cs, close) {
          return cs.children.map((c) => c.visit()).join("");
        },
        oneCharTerminal(open2, c, close) {
          return c.visit();
        },
        escapeChar(c) {
          try {
            return common.unescapeCodePoint(this.sourceString);
          } catch (err2) {
            throw err2 instanceof RangeError && err2.message.startsWith("Invalid code point ") ? errors2.invalidCodePoint(c) : err2;
          }
        },
        NonemptyListOf(x, _2, xs) {
          return [x.visit()].concat(xs.children.map((c) => c.visit()));
        },
        EmptyListOf() {
          return [];
        },
        _terminal() {
          return this.sourceString;
        }
      })(match2).visit();
    }
    function compileAndLoad(source, namespace) {
      let m = ohmGrammar.match(source, "Grammars");
      if (m.failed())
        throw errors2.grammarSyntaxError(m);
      return buildGrammar(m, namespace);
    }
    function grammar(source, optNamespace) {
      let ns = grammars(source, optNamespace), grammarNames = Object.keys(ns);
      if (grammarNames.length === 0)
        throw new Error("Missing grammar definition");
      if (grammarNames.length > 1) {
        let interval = ns[grammarNames[1]].source;
        throw new Error(
          util2.getLineAndColumnMessage(interval.sourceString, interval.startIdx) + "Found more than one grammar definition -- use ohm.grammars() instead."
        );
      }
      return ns[grammarNames[0]];
    }
    function grammars(source, optNamespace) {
      let ns = Namespace.extend(Namespace.asNamespace(optNamespace));
      if (typeof source != "string")
        if (isBuffer(source))
          source = source.toString();
        else
          throw new TypeError(
            "Expected string as first argument, got " + common.unexpectedObjToString(source)
          );
      return compileAndLoad(source, ns), ns;
    }
    function grammarFromScriptElement(optNode) {
      throw new Error(
        "grammarFromScriptElement was removed in Ohm v16.0. See https://ohmjs.org/d/gfs for more info."
      );
    }
    function grammarsFromScriptElements(optNodeOrNodeList) {
      throw new Error(
        "grammarsFromScriptElements was removed in Ohm v16.0. See https://ohmjs.org/d/gfs for more info."
      );
    }
    module.exports = {
      createNamespace: Namespace.createNamespace,
      grammar,
      grammars,
      grammarFromScriptElement,
      grammarsFromScriptElements,
      makeRecipe,
      ohmGrammar: null,
      // Initialized below, after Grammar.BuiltInRules.
      pexprs,
      util: util2,
      version: version2
    };
    module.exports._buildGrammar = buildGrammar;
    require_deferredInit();
    util2.announceBuiltInRules(Grammar.BuiltInRules);
    module.exports.ohmGrammar = ohmGrammar = require_ohm_grammar();
    Grammar.initApplicationParser(ohmGrammar, buildGrammar);
  }
});

// ../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/index.js
var require_ohm_js = __commonJS({
  "../../node_modules/.pnpm/ohm-js@16.6.0/node_modules/ohm-js/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var ohm = require_main();
    ohm.extras = require_extras();
    module.exports = ohm;
  }
});

// ../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/grammar/liquid-html.ohm.js
var require_liquid_html_ohm = __commonJS({
  "../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/grammar/liquid-html.ohm.js"(exports, module) {
    init_cjs_shims();
    module.exports = String.raw`Helpers {
  Node = TextNode*
  TextNode = AnyExceptPlus<openControl>
  openControl = end

  empty = /* nothing */
  anyExcept<lit> = (~ lit any)
  anyExceptStar<lit> = (~ lit any)*
  anyExceptPlus<lit> = (~ lit any)+
  AnyExcept<lit> = (~ lit any)
  AnyExceptPlus<lit> = (~ lit any)+
  AnyExceptStar<lit> = (~ lit any)*
  identifierCharacter = alnum | "_" | "-"

  orderedListOf<a, b, sep> =
    | nonemptyOrderedListOf<a, b, sep>
    | emptyListOf<a, sep>
  nonemptyOrderedListOf<a, b, sep> =
    | nonemptyListOf<b, sep>
    | nonemptyOrderedListOfBoth<a, b, sep>
    | nonemptyListOf<a, sep>
  nonemptyOrderedListOfBoth<a, b, sep> =
    nonemptyListOf<a, sep> (sep nonemptyListOf<b, sep>)

  singleQuote = "'" | "‘" | "’"
  doubleQuote = "\"" | "“" | "”"
  controls = "\u{007F}".."\u{009F}"
  noncharacters = "\u{FDD0}".."\u{FDEF}"
  newline = "\r"? "\n"
}

Liquid <: Helpers {
  Node := (liquidNode | TextNode)*
  openControl := "{{" | "{%"
  endOfTagName = &("-%}" | "-}}" | "%}" | "}}")
  endOfVarName = ~identifierCharacter
  endOfIdentifier = endOfTagName | endOfVarName

  liquidNode =
    | liquidBlockComment
    | liquidRawTag
    | liquidDrop
    | liquidTagClose
    | liquidTagOpen
    | liquidTag
    | liquidInlineComment

  liquidTagStrict =
    | liquidTagAssign
    | liquidTagBreak
    | liquidTagContinue
    | liquidTagCycle
    | liquidTagDecrement
    | liquidTagEcho
    | liquidTagElse
    | liquidTagElsif
    | liquidTagInclude
    | liquidTagIncrement
    | liquidTagLayout
    | liquidTagLiquid
    | liquidTagRender
    | liquidTagSection
    | liquidTagSections
    | liquidTagWhen

  liquidTag =
    | liquidTagStrict
    | liquidTagBaseCase

  liquidTagOpenStrict =
    | liquidTagOpenCase
    | liquidTagOpenCapture
    | liquidTagOpenForm
    | liquidTagOpenFor
    | liquidTagOpenTablerow
    | liquidTagOpenIf
    | liquidTagOpenPaginate
    | liquidTagOpenUnless

  liquidTagOpen =
    | liquidTagOpenStrict
    | liquidTagOpenBaseCase

  liquidTagClose = "{%" "-"? space* "end" blockName space* tagMarkup "-"? "%}"

  // These two are the same but transformed differently
  liquidTagRule<name, markup> =
    "{%" "-"? space* (name endOfIdentifier) space* markup "-"? "%}"
  liquidTagOpenRule<name, markup> =
    "{%" "-"? space* (name endOfIdentifier) space* markup "-"? "%}"

  liquidTagBaseCase = liquidTagRule<liquidTagName, tagMarkup>

  liquidTagEcho = liquidTagRule<"echo", liquidTagEchoMarkup>
  liquidTagEchoMarkup = liquidVariable<delimTag>

  liquidTagAssign = liquidTagRule<"assign", liquidTagAssignMarkup>
  liquidTagAssignMarkup = variableSegment space* "=" space* liquidVariable<delimTag>

  liquidTagCycle = liquidTagRule<"cycle", liquidTagCycleMarkup>
  liquidTagCycleMarkup = (liquidExpression<delimTag> ":")? space* nonemptyListOf<liquidExpression<delimTag>, argumentSeparator> space*

  liquidTagIncrement = liquidTagRule<"increment", variableSegmentAsLookupMarkup>
  liquidTagDecrement = liquidTagRule<"decrement", variableSegmentAsLookupMarkup>
  liquidTagOpenCapture = liquidTagOpenRule<"capture", variableSegmentAsLookupMarkup>
  variableSegmentAsLookupMarkup = variableSegmentAsLookup space*

  liquidTagSection = liquidTagRule<"section", liquidTagSectionMarkup>
  liquidTagSectionMarkup = liquidString<delimTag> space*

  liquidTagSections = liquidTagRule<"sections", liquidTagSectionsMarkup>
  liquidTagSectionsMarkup = liquidString<delimTag> space*

  liquidTagLayout = liquidTagRule<"layout", liquidTagLayoutMarkup>
  liquidTagLayoutMarkup = liquidExpression<delimTag> space*

  // We'll black hole the statement and switch parser in the cst builder
  // We do this because it's technically the same grammar (with minor redefinitions)
  // and it would be a huge chore and maintenance hell to rewrite all the rules with
  // hspace = " " | "\t"
  //
  // The alternative is that this grammar parses the {% liquid tagMarkup %} as its own string,
  // and then we switch to the LiquidStatement grammar that
  // redefines liquidTagOpenRule, liquidTagRule, and space.
  liquidTagLiquid = liquidTagRule<"liquid", liquidTagLiquidMarkup>
  liquidTagLiquidMarkup = tagMarkup

  liquidTagInclude = liquidTagRule<"include", liquidTagRenderMarkup>
  liquidTagRender = liquidTagRule<"render", liquidTagRenderMarkup>
  liquidTagRenderMarkup =
    snippetExpression renderVariableExpression? renderAliasExpression? (argumentSeparatorOptionalComma tagArguments) (space* ",")? space*
  snippetExpression = liquidString<delimTag> | variableSegmentAsLookup
  renderVariableExpression = space+ ("for" | "with") space+ liquidExpression<delimTag>
  renderAliasExpression = space+ "as" space+ variableSegment

  liquidTagOpenBaseCase = liquidTagOpenRule<blockName, tagMarkup>

  liquidTagOpenForm = liquidTagOpenRule<"form", liquidTagOpenFormMarkup>
  liquidTagOpenFormMarkup = arguments<delimTag> (space* ",")? space*

  liquidTagOpenFor = liquidTagOpenRule<"for", liquidTagOpenForMarkup>
  liquidTagOpenForMarkup =
    variableSegment space* "in" space* liquidExpression<delimTag>
    (space* "reversed")? argumentSeparatorOptionalComma
    tagArguments (space* ",")? space*

  // It's the same, the difference is support for different named arguments<delim>
  liquidTagOpenTablerow = liquidTagOpenRule<"tablerow", liquidTagOpenForMarkup>

  liquidTagOpenCase = liquidTagOpenRule<"case", liquidTagOpenCaseMarkup>
  liquidTagOpenCaseMarkup = liquidExpression<delimTag> space*

  liquidTagWhen = liquidTagRule<"when", liquidTagWhenMarkup>
  liquidTagWhenMarkup = nonemptyListOf<liquidExpression<delimTag>, whenMarkupSep> space*
  whenMarkupSep = space* ("," | "or" ~identifier) space*

  liquidTagOpenIf = liquidTagOpenRule<"if", liquidTagOpenConditionalMarkup>
  liquidTagOpenUnless = liquidTagOpenRule<"unless", liquidTagOpenConditionalMarkup>
  liquidTagElsif = liquidTagRule<"elsif", liquidTagOpenConditionalMarkup>

  liquidTagBreak = liquidTagRule<"break", empty>
  liquidTagContinue = liquidTagRule<"continue", empty>
  liquidTagElse = liquidTagRule<"else", empty>

  liquidTagOpenConditionalMarkup = nonemptyListOf<condition<delimTag>, conditionSeparator> space*
  conditionSeparator = &logicalOperator
  condition<delim> = logicalOperator? space* (comparison<delim> | liquidExpression<delim>) space*
  logicalOperator = ("and" | "or") ~identifier
  comparison<delim> = liquidExpression<delim> space* comparator space* liquidExpression<delim>
  comparator =
    ( "=="
    | "!="
    | ">="
    | "<="
    | ">"
    | "<")
    | ("contains" ~identifier)

  liquidTagOpenPaginate = liquidTagOpenRule<"paginate", liquidTagOpenPaginateMarkup>
  liquidTagOpenPaginateMarkup =
    liquidExpression<delimTag> space+ "by" space+ liquidExpression<delimTag> argumentSeparatorOptionalComma tagArguments (space* ",")? space*

  liquidDrop = "{{" "-"? space* liquidDropCases "-"? "}}"
  liquidDropCases = liquidVariable<delimVO> | liquidDropBaseCase
  liquidDropBaseCase = anyExceptStar<delimVO>
  liquidInlineComment = "{%" "-"? space* "#" space? tagMarkup "-"? "%}"

  liquidRawTag =
    | liquidRawTagImpl<"raw">
    | liquidRawTagImpl<"javascript">
    | liquidRawTagImpl<"schema">
    | liquidRawTagImpl<"stylesheet">
    | liquidRawTagImpl<"style">
  liquidRawTagImpl<name> =
    "{%" "-"? space* (name endOfIdentifier) space* tagMarkup "-"? "%}"
    anyExceptStar<liquidRawTagClose<name>>
    "{%" "-"? space* "end" (name endOfIdentifier) space* "-"? "%}"
  liquidRawTagClose<name> =
    "{%" "-"? space* "end" (name endOfIdentifier) space* "-"? "%}"

  liquidBlockComment =
    commentBlockStart
      (liquidBlockComment | anyExceptPlus<(commentBlockStart | commentBlockEnd)>)*
    commentBlockEnd
  commentBlockStart = "{%" "-"? space* ("comment"    endOfIdentifier) space* tagMarkup "-"? "%}"
  commentBlockEnd   = "{%" "-"? space* ("endcomment" endOfIdentifier) space* tagMarkup "-"? "%}"

  // In order for the grammar to "fallback" to the base case, this
  // rule must pass if and only if we support what we parse. This
  // implies that—since we don't support filters yet—we have a
  // positive lookahead on "-}}" or "}}" in the rule. We do this
  // because we'd otherwise positively match the following string
  // instead of falling back to the other rule:
  // {{ 'string' | some_filter }}
  liquidVariable<delim> = liquidExpression<delim> liquidFilter<delim>* space* &delim

  liquidExpression<delim> =
    | liquidString<delim>
    | liquidNumber
    | liquidLiteral
    | liquidRange<delim>
    | liquidVariableLookup<delim>

  liquidString<delim> = liquidSingleQuotedString<delim> | liquidDoubleQuotedString<delim>
  liquidSingleQuotedString<delim> = "'" anyExceptStar<("'"| delim)> "'"
  liquidDoubleQuotedString<delim> = "\"" anyExceptStar<("\""| delim)> "\""

  liquidNumber = liquidFloat | liquidInteger
  liquidInteger = "-"? digit+
  liquidFloat = "-"? digit+ "." digit+

  liquidLiteral =
    ( "true"
    | "false"
    | "blank"
    | "empty"
    | "nil"
    | "null"
    ) endOfIdentifier

  liquidRange<delim> =
    "(" space* liquidExpression<delim> space* ".." space* liquidExpression<delim> space* ")"

  liquidVariableLookup<delim> =
    | variableSegment lookup<delim>*
    | empty lookup<delim>+
  lookup<delim> =
    | indexLookup<delim>
    | dotLookup
  indexLookup<delim> = space* "[" space* liquidExpression<delim> space* "]"
  dotLookup = space* "." space* identifier

  liquidFilter<delim> = space* "|" space* identifier (space* ":" space* arguments<delim> (space* ",")?)?

  arguments<delim> = nonemptyOrderedListOf<positionalArgument<delim>, namedArgument<delim>, argumentSeparator>
  argumentSeparator = space* "," space*
  argumentSeparatorOptionalComma = space* ","? space*
  positionalArgument<delim> = liquidExpression<delim> ~(space* ":")
  namedArgument<delim> = variableSegment space* ":" space* liquidExpression<delim>
  tagArguments = listOf<namedArgument<delimTag>, argumentSeparatorOptionalComma>

  variableSegment = (letter | "_") identifierCharacter*
  variableSegmentAsLookup = variableSegment
  identifier = variableSegment "?"?

  tagMarkup = anyExceptStar<delimTag>

  liquidTagName =
    letter (alnum | "_")*

  blockName =
    // Shopify blocks
    ( "form"
    | "paginate"
    // Base blocks
    | "capture"
    | "case"
    | "for"
    | "ifchanged"
    | "if"
    | "unless"
    | "tablerow"
    ) endOfIdentifier

  delimTag = "-%}" | "%}"
  delimVO = "-}}" | "}}"
}

LiquidStatement <: Liquid {
  Node := listOf<LiquidStatement, statementSep> (space | newline)*

  // This is the big brains moment: we redefine space to exclude newlines.
  //
  // Which means that all our other Liquid rules can be reused
  // without modification(!)
  //
  // We don't need to maintain rules like this:
  // - liquidVariable<space>
  // - liquidExpression<space>
  // - variableLookup<space>
  // - ... long list of stuff that takes space as param
  // - liquidString<space>
  //
  // All we need is this little, VERY IMPORTANT, part right here that
  // make it so we can parse the same way in Liquid tags.
  //
  // I'm putting in this huge comment so that it's more obvious.
  space := " " | "\t"

  LiquidStatement =
    | liquidBlockComment
    | liquidRawTag
    | liquidTagClose
    | liquidTagOpen
    | liquidTag
    | liquidInlineComment

  liquidTagOpenRule<name, markup>
    := (name ~identifierCharacter) space* markup &liquidStatementEnd

  liquidTagRule<name, markup>
    := (name ~identifierCharacter) space* markup &liquidStatementEnd

  liquidTagClose
    := "end" (blockName ~identifierCharacter) space* tagMarkup &liquidStatementEnd

  liquidRawTagImpl<name>
    := (name ~identifierCharacter) space* tagMarkup newline
      anyExceptStar<liquidRawTagClose<name>>
      "end" name space* &liquidStatementEnd

  liquidRawTagClose<name>
    := "end" name space* &liquidStatementEnd

  liquidBlockComment :=
    commentBlockStart statementSep
      (listOf<liquidCommentBlockStatement, statementSep> statementSep)?
    commentBlockEnd

  liquidCommentBlockStatement =
    | liquidBlockComment
    | nonTerminalCommentLine

  commentBlockStart
    := ("comment" ~identifierCharacter) space* tagMarkup

  commentBlockEnd
    := ("endcomment" ~identifierCharacter) space* tagMarkup

  nonTerminalCommentLine
    = ~commentBlockEnd anyExceptPlus<newline>

  liquidInlineComment
    := "#" space? tagMarkup &liquidStatementEnd

  tagMarkup := anyExceptStar<liquidStatementEnd>

  // trailing whitespace, newline, + anything else before the next tag
  statementSep = space* newline (space | newline)*

  liquidStatementEnd = newline | end
  delimTag := liquidStatementEnd
}

LiquidHTML <: Liquid {
  Node := yamlFrontmatter? (HtmlNode | liquidNode | TextNode)*
  openControl += "<"

  yamlFrontmatter =
    "---" newline anyExceptStar<"---"> "---" newline

  HtmlNode =
    | HtmlDoctype
    | HtmlComment
    | HtmlRawTag
    | HtmlVoidElement
    | HtmlSelfClosingElement
    | HtmlTagClose
    | HtmlTagOpen

  // https://html.spec.whatwg.org/multipage/syntax.html#the-doctype
  HtmlDoctype =
    #("<!" caseInsensitive<"doctype"> space+ caseInsensitive<"html">) legacyDoctypeString? ">"
  legacyDoctypeString
    = anyExceptPlus<">">

  HtmlComment = "<!--" #(anyExceptStar<"-->"> "-->")

  // These are black holes, we'll ignore what's in them
  HtmlRawTag =
    | HtmlRawTagImpl<"script">
    | HtmlRawTagImpl<"style">
    | HtmlRawTagImpl<"svg">

  HtmlRawTagImpl<name> =
    TagStart<name>
      (HtmlRawTagImpl<name> | AnyExceptPlus<(TagStart<name> | TagEnd<name>)>)*
    TagEnd<name>
  TagStart<name> = "<" name AttrList ">"
  TagEnd<name> = "</" name ">"

  HtmlVoidElement =
    #("<" voidElementName &(space | "/" | ">")) AttrList "/"? ">"

  HtmlSelfClosingElement =
    #("<" tagName) AttrList "/>"

  HtmlTagOpen =
    #("<" tagName) AttrList ">"

  HtmlTagClose =
    #("</" tagName) ">"

  tagName = leadingTagNamePart trailingTagNamePart*

  // The difference here is that the first text part must start
  // with a letter, but trailing text parts don't have that
  // requirement
  leadingTagNamePart =
    | liquidDrop
    | leadingTagNameTextNode

  trailingTagNamePart =
    | liquidDrop
    | trailingTagNameTextNode

  leadingTagNameTextNode = letter (alnum | "-" | ":")*
  trailingTagNameTextNode = (alnum | "-" | ":")+

  AttrList = Attr*

  Attr =
    liquidNode | AttrSingleQuoted | AttrDoubleQuoted | AttrUnquoted | attrEmpty

  attrEmpty = attrName

  AttrUnquoted = attrName "=" attrUnquotedValue
  AttrSingleQuoted = attrName "=" singleQuote #(attrSingleQuotedValue singleQuote)
  AttrDoubleQuoted = attrName "=" doubleQuote #(attrDoubleQuotedValue doubleQuote)

  attrName = (liquidDrop | attrNameTextNode)+

  // https://html.spec.whatwg.org/#attributes-2
  attrNameTextNode = anyExceptPlus<(space | quotes | "=" | ">" | "/>" | "{{" | "{%" | controls | noncharacters)>
  attrUnquotedValue = (liquidDrop | attrUnquotedTextNode)*
  attrSingleQuotedValue = (liquidNode | attrSingleQuotedTextNode)*
  attrDoubleQuotedValue = (liquidNode | attrDoubleQuotedTextNode)*

  attrUnquotedTextNode = anyExceptPlus<(space | quotes | "=" | "<" | ">" | "${"`"}" | "{{" | "{%")>
  attrSingleQuotedTextNode = anyExceptPlus<(singleQuote | "{{" | "{%")>
  attrDoubleQuotedTextNode = anyExceptPlus<(doubleQuote | "{{" | "{%")>

  quotes = singleQuote | doubleQuote

  // https://www.w3.org/TR/2011/WD-html-markup-20110113/syntax.html#void-element
  voidElementName =
    ( caseInsensitive<"area">
    | caseInsensitive<"base">
    | caseInsensitive<"br">
    | caseInsensitive<"col">
    | caseInsensitive<"command">
    | caseInsensitive<"embed">
    | caseInsensitive<"hr">
    | caseInsensitive<"img">
    | caseInsensitive<"input">
    | caseInsensitive<"keygen">
    | caseInsensitive<"link">
    | caseInsensitive<"meta">
    | caseInsensitive<"param">
    | caseInsensitive<"source">
    | caseInsensitive<"track">
    | caseInsensitive<"wbr">
    ) ~identifierCharacter
}

StrictLiquid <: Liquid {
  liquidTag := liquidTagStrict
  liquidTagOpen := liquidTagOpenStrict
}

StrictLiquidStatement <: LiquidStatement {
  liquidTag := liquidTagStrict
  liquidTagOpen := liquidTagOpenStrict
}

StrictLiquidHTML <: LiquidHTML {
  liquidTag := liquidTagStrict
  liquidTagOpen := liquidTagOpenStrict
}

WithPlaceholderLiquid <: Liquid {
  liquidTagName := (letter | "█") (alnum | "_")*
  variableSegment := (letter | "_" | "█") identifierCharacter*
}

WithPlaceholderLiquidStatement <: LiquidStatement {
  liquidTagName := (letter | "█") (alnum | "_")*
  variableSegment := (letter | "_" | "█") identifierCharacter*
}

WithPlaceholderLiquidHTML <: LiquidHTML {
  liquidTagName := (letter | "█") (alnum | "_")*
  variableSegment := (letter | "_" | "█") identifierCharacter*
  leadingTagNameTextNode := (letter | "█") (alnum | "-" | ":" | "█")*
  trailingTagNameTextNode := (alnum | "-" | ":" | "█")+
}
`;
  }
});

// ../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/dist/grammar.js
var require_grammar = __commonJS({
  "../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/dist/grammar.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.TAGS_WITHOUT_MARKUP = exports.VOID_ELEMENTS = exports.RAW_TAGS = exports.BLOCKS = exports.placeholderGrammars = exports.tolerantGrammars = exports.strictGrammars = exports.TextNodeGrammar = exports.liquidHtmlGrammars = void 0;
    var ohm_js_1 = __importDefault(require_ohm_js());
    exports.liquidHtmlGrammars = ohm_js_1.default.grammars(require_liquid_html_ohm());
    exports.TextNodeGrammar = exports.liquidHtmlGrammars.Helpers;
    exports.strictGrammars = {
      Liquid: exports.liquidHtmlGrammars.StrictLiquid,
      LiquidHTML: exports.liquidHtmlGrammars.StrictLiquidHTML,
      LiquidStatement: exports.liquidHtmlGrammars.StrictLiquidStatement
    };
    exports.tolerantGrammars = {
      Liquid: exports.liquidHtmlGrammars.Liquid,
      LiquidHTML: exports.liquidHtmlGrammars.LiquidHTML,
      LiquidStatement: exports.liquidHtmlGrammars.LiquidStatement
    };
    exports.placeholderGrammars = {
      Liquid: exports.liquidHtmlGrammars.WithPlaceholderLiquid,
      LiquidHTML: exports.liquidHtmlGrammars.WithPlaceholderLiquidHTML,
      LiquidStatement: exports.liquidHtmlGrammars.WithPlaceholderLiquidStatement
    };
    exports.BLOCKS = exports.strictGrammars.LiquidHTML.rules.blockName.body.factors[0].terms.map((x) => x.obj);
    exports.RAW_TAGS = exports.strictGrammars.LiquidHTML.rules.liquidRawTag.body.terms.map((term) => term.args[0].obj).concat("comment");
    exports.VOID_ELEMENTS = exports.strictGrammars.LiquidHTML.rules.voidElementName.body.factors[0].terms.map((x) => x.args[0].obj);
    exports.TAGS_WITHOUT_MARKUP = [
      "style",
      "schema",
      "javascript",
      "else",
      "break",
      "continue",
      "comment",
      "raw"
    ];
  }
});

// ../../node_modules/.pnpm/isarray@1.0.0/node_modules/isarray/index.js
var require_isarray = __commonJS({
  "../../node_modules/.pnpm/isarray@1.0.0/node_modules/isarray/index.js"(exports, module) {
    init_cjs_shims();
    var toString2 = {}.toString;
    module.exports = Array.isArray || function(arr) {
      return toString2.call(arr) == "[object Array]";
    };
  }
});

// ../../node_modules/.pnpm/isobject@2.1.0/node_modules/isobject/index.js
var require_isobject = __commonJS({
  "../../node_modules/.pnpm/isobject@2.1.0/node_modules/isobject/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var isArray = require_isarray();
    module.exports = function(val) {
      return val != null && typeof val == "object" && isArray(val) === !1;
    };
  }
});

// ../../node_modules/.pnpm/line-column@1.0.2/node_modules/line-column/lib/line-column.js
var require_line_column = __commonJS({
  "../../node_modules/.pnpm/line-column@1.0.2/node_modules/line-column/lib/line-column.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var isArray = require_isarray(), isObject4 = require_isobject(), slice = Array.prototype.slice;
    module.exports = LineColumnFinder;
    function LineColumnFinder(str, options) {
      if (!(this instanceof LineColumnFinder))
        return typeof options == "number" ? new LineColumnFinder(str).fromIndex(options) : new LineColumnFinder(str, options);
      this.str = str || "", this.lineToIndex = buildLineToIndex(this.str), options = options || {}, this.origin = typeof options.origin > "u" ? 1 : options.origin;
    }
    LineColumnFinder.prototype.fromIndex = function(index) {
      if (index < 0 || index >= this.str.length || isNaN(index))
        return null;
      var line = findLowerIndexInRangeArray(index, this.lineToIndex);
      return {
        line: line + this.origin,
        col: index - this.lineToIndex[line] + this.origin
      };
    };
    LineColumnFinder.prototype.toIndex = function(line, column) {
      if (typeof column > "u")
        return isArray(line) && line.length >= 2 ? this.toIndex(line[0], line[1]) : isObject4(line) && "line" in line && ("col" in line || "column" in line) ? this.toIndex(line.line, "col" in line ? line.col : line.column) : -1;
      if (isNaN(line) || isNaN(column))
        return -1;
      if (line -= this.origin, column -= this.origin, line >= 0 && column >= 0 && line < this.lineToIndex.length) {
        var lineIndex = this.lineToIndex[line], nextIndex = line === this.lineToIndex.length - 1 ? this.str.length : this.lineToIndex[line + 1];
        if (column < nextIndex - lineIndex)
          return lineIndex + column;
      }
      return -1;
    };
    function buildLineToIndex(str) {
      for (var lines = str.split(`
`), lineToIndex = new Array(lines.length), index = 0, i = 0, l = lines.length; i < l; i++)
        lineToIndex[i] = index, index += lines[i].length + /* "\n".length */
        1;
      return lineToIndex;
    }
    function findLowerIndexInRangeArray(value, arr) {
      if (value >= arr[arr.length - 1])
        return arr.length - 1;
      for (var min = 0, max = arr.length - 2, mid; min < max; )
        if (mid = min + (max - min >> 1), value < arr[mid])
          max = mid - 1;
        else if (value >= arr[mid + 1])
          min = mid + 1;
        else {
          min = mid;
          break;
        }
      return min;
    }
  }
});

// ../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/dist/errors.js
var require_errors2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/dist/errors.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.LiquidHTMLASTParsingError = exports.LiquidHTMLCSTParsingError = void 0;
    var line_column_1 = __importDefault(require_line_column()), LiquidHTMLCSTParsingError = class extends SyntaxError {
      constructor(ohm) {
        super(ohm.shortMessage), this.name = "LiquidHTMLParsingError";
        let input = ohm.input, errorPos = ohm._rightmostFailurePosition, lineCol = (0, line_column_1.default)(input).fromIndex(Math.min(errorPos, input.length - 1));
        lineCol && (this.loc = {
          start: {
            line: lineCol.line,
            column: lineCol.col
          },
          end: {
            line: lineCol.line,
            column: lineCol.col
          }
        });
      }
    };
    exports.LiquidHTMLCSTParsingError = LiquidHTMLCSTParsingError;
    var LiquidHTMLASTParsingError = class extends SyntaxError {
      constructor(message, source, startIndex, endIndex) {
        super(message), this.name = "LiquidHTMLParsingError";
        let lc = (0, line_column_1.default)(source), start = lc.fromIndex(startIndex), end = lc.fromIndex(Math.min(endIndex, source.length - 1));
        this.loc = {
          start: {
            line: start.line,
            column: start.col
          },
          end: {
            line: end.line,
            column: end.col
          }
        };
      }
    };
    exports.LiquidHTMLASTParsingError = LiquidHTMLASTParsingError;
  }
});

// ../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/dist/types.js
var require_types = __commonJS({
  "../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/dist/types.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.nonTraversableProperties = exports.LiquidNodeTypes = exports.HtmlNodeTypes = exports.Comparators = exports.NamedTags = exports.NodeTypes = void 0;
    var NodeTypes;
    (function(NodeTypes2) {
      NodeTypes2.Document = "Document", NodeTypes2.LiquidRawTag = "LiquidRawTag", NodeTypes2.LiquidTag = "LiquidTag", NodeTypes2.LiquidBranch = "LiquidBranch", NodeTypes2.LiquidVariableOutput = "LiquidVariableOutput", NodeTypes2.HtmlSelfClosingElement = "HtmlSelfClosingElement", NodeTypes2.HtmlVoidElement = "HtmlVoidElement", NodeTypes2.HtmlDoctype = "HtmlDoctype", NodeTypes2.HtmlComment = "HtmlComment", NodeTypes2.HtmlElement = "HtmlElement", NodeTypes2.HtmlDanglingMarkerClose = "HtmlDanglingMarkerClose", NodeTypes2.HtmlRawNode = "HtmlRawNode", NodeTypes2.AttrSingleQuoted = "AttrSingleQuoted", NodeTypes2.AttrDoubleQuoted = "AttrDoubleQuoted", NodeTypes2.AttrUnquoted = "AttrUnquoted", NodeTypes2.AttrEmpty = "AttrEmpty", NodeTypes2.TextNode = "TextNode", NodeTypes2.YAMLFrontmatter = "YAMLFrontmatter", NodeTypes2.LiquidVariable = "LiquidVariable", NodeTypes2.LiquidFilter = "LiquidFilter", NodeTypes2.NamedArgument = "NamedArgument", NodeTypes2.LiquidLiteral = "LiquidLiteral", NodeTypes2.String = "String", NodeTypes2.Number = "Number", NodeTypes2.Range = "Range", NodeTypes2.VariableLookup = "VariableLookup", NodeTypes2.Comparison = "Comparison", NodeTypes2.LogicalExpression = "LogicalExpression", NodeTypes2.AssignMarkup = "AssignMarkup", NodeTypes2.CycleMarkup = "CycleMarkup", NodeTypes2.ForMarkup = "ForMarkup", NodeTypes2.PaginateMarkup = "PaginateMarkup", NodeTypes2.RawMarkup = "RawMarkup", NodeTypes2.RenderMarkup = "RenderMarkup", NodeTypes2.RenderVariableExpression = "RenderVariableExpression";
    })(NodeTypes = exports.NodeTypes || (exports.NodeTypes = {}));
    var NamedTags;
    (function(NamedTags2) {
      NamedTags2.assign = "assign", NamedTags2.capture = "capture", NamedTags2.case = "case", NamedTags2.cycle = "cycle", NamedTags2.decrement = "decrement", NamedTags2.echo = "echo", NamedTags2.elsif = "elsif", NamedTags2.for = "for", NamedTags2.form = "form", NamedTags2.if = "if", NamedTags2.include = "include", NamedTags2.increment = "increment", NamedTags2.layout = "layout", NamedTags2.liquid = "liquid", NamedTags2.paginate = "paginate", NamedTags2.render = "render", NamedTags2.section = "section", NamedTags2.sections = "sections", NamedTags2.tablerow = "tablerow", NamedTags2.unless = "unless", NamedTags2.when = "when";
    })(NamedTags = exports.NamedTags || (exports.NamedTags = {}));
    var Comparators;
    (function(Comparators2) {
      Comparators2.CONTAINS = "contains", Comparators2.EQUAL = "==", Comparators2.GREATER_THAN = ">", Comparators2.GREATER_THAN_OR_EQUAL = ">=", Comparators2.LESS_THAN = "<", Comparators2.LESS_THAN_OR_EQUAL = "<=", Comparators2.NOT_EQUAL = "!=";
    })(Comparators = exports.Comparators || (exports.Comparators = {}));
    exports.HtmlNodeTypes = [
      NodeTypes.HtmlElement,
      NodeTypes.HtmlDanglingMarkerClose,
      NodeTypes.HtmlRawNode,
      NodeTypes.HtmlVoidElement,
      NodeTypes.HtmlSelfClosingElement
    ];
    exports.LiquidNodeTypes = [
      NodeTypes.LiquidTag,
      NodeTypes.LiquidVariableOutput,
      NodeTypes.LiquidBranch,
      NodeTypes.LiquidRawTag
    ];
    exports.nonTraversableProperties = /* @__PURE__ */ new Set([
      "parentNode",
      "prev",
      "next",
      "firstChild",
      "lastChild"
    ]);
  }
});

// ../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/dist/stage-1-cst.js
var require_stage_1_cst = __commonJS({
  "../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/dist/stage-1-cst.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.toLiquidCST = exports.toLiquidHtmlCST = exports.LiquidLiteralValues = exports.ConcreteNodeTypes = void 0;
    var extras_1 = require_extras(), grammar_1 = require_grammar(), errors_1 = require_errors2(), types_1 = require_types(), ConcreteNodeTypes;
    (function(ConcreteNodeTypes2) {
      ConcreteNodeTypes2.HtmlDoctype = "HtmlDoctype", ConcreteNodeTypes2.HtmlComment = "HtmlComment", ConcreteNodeTypes2.HtmlRawTag = "HtmlRawTag", ConcreteNodeTypes2.HtmlVoidElement = "HtmlVoidElement", ConcreteNodeTypes2.HtmlSelfClosingElement = "HtmlSelfClosingElement", ConcreteNodeTypes2.HtmlTagOpen = "HtmlTagOpen", ConcreteNodeTypes2.HtmlTagClose = "HtmlTagClose", ConcreteNodeTypes2.AttrSingleQuoted = "AttrSingleQuoted", ConcreteNodeTypes2.AttrDoubleQuoted = "AttrDoubleQuoted", ConcreteNodeTypes2.AttrUnquoted = "AttrUnquoted", ConcreteNodeTypes2.AttrEmpty = "AttrEmpty", ConcreteNodeTypes2.LiquidVariableOutput = "LiquidVariableOutput", ConcreteNodeTypes2.LiquidRawTag = "LiquidRawTag", ConcreteNodeTypes2.LiquidTag = "LiquidTag", ConcreteNodeTypes2.LiquidTagOpen = "LiquidTagOpen", ConcreteNodeTypes2.LiquidTagClose = "LiquidTagClose", ConcreteNodeTypes2.TextNode = "TextNode", ConcreteNodeTypes2.YAMLFrontmatter = "YAMLFrontmatter", ConcreteNodeTypes2.LiquidVariable = "LiquidVariable", ConcreteNodeTypes2.LiquidFilter = "LiquidFilter", ConcreteNodeTypes2.NamedArgument = "NamedArgument", ConcreteNodeTypes2.LiquidLiteral = "LiquidLiteral", ConcreteNodeTypes2.VariableLookup = "VariableLookup", ConcreteNodeTypes2.String = "String", ConcreteNodeTypes2.Number = "Number", ConcreteNodeTypes2.Range = "Range", ConcreteNodeTypes2.Comparison = "Comparison", ConcreteNodeTypes2.Condition = "Condition", ConcreteNodeTypes2.AssignMarkup = "AssignMarkup", ConcreteNodeTypes2.CycleMarkup = "CycleMarkup", ConcreteNodeTypes2.ForMarkup = "ForMarkup", ConcreteNodeTypes2.RenderMarkup = "RenderMarkup", ConcreteNodeTypes2.PaginateMarkup = "PaginateMarkup", ConcreteNodeTypes2.RenderVariableExpression = "RenderVariableExpression";
    })(ConcreteNodeTypes = exports.ConcreteNodeTypes || (exports.ConcreteNodeTypes = {}));
    exports.LiquidLiteralValues = {
      nil: null,
      null: null,
      true: !0,
      false: !1,
      blank: "",
      empty: ""
    };
    var markup = (i) => (tokens) => tokens[i].sourceString.trim(), markupTrimEnd = (i) => (tokens) => tokens[i].sourceString.trimEnd(), Grammars = {
      strict: grammar_1.strictGrammars,
      tolerant: grammar_1.tolerantGrammars,
      completion: grammar_1.placeholderGrammars
    };
    function toLiquidHtmlCST(source, options = { mode: "tolerant" }) {
      let grammars = Grammars[options.mode], grammar = grammars.LiquidHTML;
      return toCST(source, grammars, grammar, [
        "HelperMappings",
        "LiquidMappings",
        "LiquidHTMLMappings"
      ]);
    }
    exports.toLiquidHtmlCST = toLiquidHtmlCST;
    function toLiquidCST(source, options = { mode: "tolerant" }) {
      let grammars = Grammars[options.mode], grammar = grammars.Liquid;
      return toCST(source, grammars, grammar, ["HelperMappings", "LiquidMappings"]);
    }
    exports.toLiquidCST = toLiquidCST;
    function toCST(source, grammars, grammar, cstMappings, matchingSource = source, offset = 0) {
      let locStart = (tokens) => offset + tokens[0].source.startIdx, locEnd = (tokens) => offset + tokens[tokens.length - 1].source.endIdx, locEndSecondToLast = (tokens) => offset + tokens[tokens.length - 2].source.endIdx, textNode = {
        type: ConcreteNodeTypes.TextNode,
        value: function() {
          return this.sourceString;
        },
        locStart,
        locEnd,
        source
      }, res = grammar.match(matchingSource, "Node");
      if (res.failed())
        throw new errors_1.LiquidHTMLCSTParsingError(res);
      let HelperMappings = {
        Node: 0,
        TextNode: textNode,
        orderedListOf: 0,
        listOf: 0,
        empty: () => null,
        emptyListOf: () => [],
        nonemptyListOf(first, _sep, rest) {
          let self2 = this;
          return [first.toAST(self2.args.mapping)].concat(rest.toAST(self2.args.mapping));
        },
        nonemptyOrderedListOf: 0,
        nonemptyOrderedListOfBoth(nonemptyListOfA, _sep, nonemptyListOfB) {
          let self2 = this;
          return nonemptyListOfA.toAST(self2.args.mapping).concat(nonemptyListOfB.toAST(self2.args.mapping));
        }
      }, LiquidMappings = {
        liquidNode: 0,
        liquidRawTag: 0,
        liquidRawTagImpl: {
          type: ConcreteNodeTypes.LiquidRawTag,
          name: 3,
          body: 9,
          children: (tokens) => {
            let nameNode = tokens[3], rawMarkupStringNode = tokens[9];
            switch (nameNode.sourceString) {
              case "raw":
                return toCST(source, grammars, grammar_1.TextNodeGrammar, ["HelperMappings"], rawMarkupStringNode.sourceString, offset + rawMarkupStringNode.source.startIdx);
              default:
                return toCST(source, grammars, grammars.Liquid, ["HelperMappings", "LiquidMappings"], rawMarkupStringNode.sourceString, offset + rawMarkupStringNode.source.startIdx);
            }
          },
          markup: 6,
          whitespaceStart: 1,
          whitespaceEnd: 7,
          delimiterWhitespaceStart: 11,
          delimiterWhitespaceEnd: 17,
          locStart,
          locEnd,
          source,
          blockStartLocStart: (tokens) => tokens[0].source.startIdx,
          blockStartLocEnd: (tokens) => tokens[8].source.endIdx,
          blockEndLocStart: (tokens) => tokens[10].source.startIdx,
          blockEndLocEnd: (tokens) => tokens[18].source.endIdx
        },
        liquidBlockComment: {
          type: ConcreteNodeTypes.LiquidRawTag,
          name: "comment",
          body: (tokens) => tokens[1].sourceString,
          children: (tokens) => toCST(source, grammars, grammar_1.TextNodeGrammar, ["HelperMappings"], tokens[1].sourceString, offset + tokens[1].source.startIdx),
          whitespaceStart: (tokens) => tokens[0].children[1].sourceString,
          whitespaceEnd: (tokens) => tokens[0].children[7].sourceString,
          delimiterWhitespaceStart: (tokens) => tokens[2].children[1].sourceString,
          delimiterWhitespaceEnd: (tokens) => tokens[2].children[7].sourceString,
          locStart,
          locEnd,
          source,
          blockStartLocStart: (tokens) => tokens[0].source.startIdx,
          blockStartLocEnd: (tokens) => tokens[0].source.endIdx,
          blockEndLocStart: (tokens) => tokens[2].source.startIdx,
          blockEndLocEnd: (tokens) => tokens[2].source.endIdx
        },
        liquidInlineComment: {
          type: ConcreteNodeTypes.LiquidTag,
          name: 3,
          markup: markupTrimEnd(5),
          whitespaceStart: 1,
          whitespaceEnd: 6,
          locStart,
          locEnd,
          source
        },
        liquidTagOpen: 0,
        liquidTagOpenStrict: 0,
        liquidTagOpenBaseCase: 0,
        liquidTagOpenRule: {
          type: ConcreteNodeTypes.LiquidTagOpen,
          name: 3,
          markup(nodes) {
            let markupNode = nodes[6], nameNode = nodes[3];
            return types_1.NamedTags.hasOwnProperty(nameNode.sourceString) ? markupNode.toAST(this.args.mapping) : markupNode.sourceString.trim();
          },
          whitespaceStart: 1,
          whitespaceEnd: 7,
          locStart,
          locEnd,
          source
        },
        liquidTagOpenCapture: 0,
        liquidTagOpenForm: 0,
        liquidTagOpenFormMarkup: 0,
        liquidTagOpenFor: 0,
        liquidTagOpenForMarkup: {
          type: ConcreteNodeTypes.ForMarkup,
          variableName: 0,
          collection: 4,
          reversed: 6,
          args: 8,
          locStart,
          locEnd,
          source
        },
        liquidTagBreak: 0,
        liquidTagContinue: 0,
        liquidTagOpenTablerow: 0,
        liquidTagOpenPaginate: 0,
        liquidTagOpenPaginateMarkup: {
          type: ConcreteNodeTypes.PaginateMarkup,
          collection: 0,
          pageSize: 4,
          args: 6,
          locStart,
          locEnd,
          source
        },
        liquidTagOpenCase: 0,
        liquidTagOpenCaseMarkup: 0,
        liquidTagWhen: 0,
        liquidTagWhenMarkup: 0,
        liquidTagOpenIf: 0,
        liquidTagOpenUnless: 0,
        liquidTagElsif: 0,
        liquidTagElse: 0,
        liquidTagOpenConditionalMarkup: 0,
        condition: {
          type: ConcreteNodeTypes.Condition,
          relation: 0,
          expression: 2,
          locStart,
          locEnd,
          source
        },
        comparison: {
          type: ConcreteNodeTypes.Comparison,
          comparator: 2,
          left: 0,
          right: 4,
          locStart,
          locEnd,
          source
        },
        liquidTagClose: {
          type: ConcreteNodeTypes.LiquidTagClose,
          name: 4,
          whitespaceStart: 1,
          whitespaceEnd: 7,
          locStart,
          locEnd,
          source
        },
        liquidTag: 0,
        liquidTagStrict: 0,
        liquidTagBaseCase: 0,
        liquidTagAssign: 0,
        liquidTagEcho: 0,
        liquidTagCycle: 0,
        liquidTagIncrement: 0,
        liquidTagDecrement: 0,
        liquidTagRender: 0,
        liquidTagInclude: 0,
        liquidTagSection: 0,
        liquidTagSections: 0,
        liquidTagLayout: 0,
        liquidTagRule: {
          type: ConcreteNodeTypes.LiquidTag,
          name: 3,
          markup(nodes) {
            let markupNode = nodes[6], nameNode = nodes[3];
            return types_1.NamedTags.hasOwnProperty(nameNode.sourceString) ? markupNode.toAST(this.args.mapping) : markupNode.sourceString.trim();
          },
          whitespaceStart: 1,
          whitespaceEnd: 7,
          source,
          locStart,
          locEnd
        },
        liquidTagLiquid: 0,
        liquidTagLiquidMarkup(tagMarkup) {
          return toCST(source, grammars, grammars.LiquidStatement, ["HelperMappings", "LiquidMappings", "LiquidStatement"], tagMarkup.sourceString, offset + tagMarkup.source.startIdx);
        },
        liquidTagEchoMarkup: 0,
        liquidTagSectionMarkup: 0,
        liquidTagSectionsMarkup: 0,
        liquidTagLayoutMarkup: 0,
        liquidTagAssignMarkup: {
          type: ConcreteNodeTypes.AssignMarkup,
          name: 0,
          value: 4,
          locStart,
          locEnd,
          source
        },
        liquidTagCycleMarkup: {
          type: ConcreteNodeTypes.CycleMarkup,
          groupName: 0,
          args: 3,
          locStart,
          locEnd,
          source
        },
        liquidTagRenderMarkup: {
          type: ConcreteNodeTypes.RenderMarkup,
          snippet: 0,
          variable: 1,
          alias: 2,
          args: 4,
          locStart,
          locEnd,
          source
        },
        snippetExpression: 0,
        renderVariableExpression: {
          type: ConcreteNodeTypes.RenderVariableExpression,
          kind: 1,
          name: 3,
          locStart,
          locEnd,
          source
        },
        renderAliasExpression: 3,
        liquidDrop: {
          type: ConcreteNodeTypes.LiquidVariableOutput,
          markup: 3,
          whitespaceStart: 1,
          whitespaceEnd: 4,
          locStart,
          locEnd,
          source
        },
        liquidDropCases: 0,
        liquidExpression: 0,
        liquidDropBaseCase: (sw) => sw.sourceString.trimEnd(),
        liquidVariable: {
          type: ConcreteNodeTypes.LiquidVariable,
          expression: 0,
          filters: 1,
          rawSource: (tokens) => source.slice(locStart(tokens), tokens[tokens.length - 2].source.endIdx).trimEnd(),
          locStart,
          // The last node of this rule is a positive lookahead, we don't
          // want its endIdx, we want the endIdx of the previous one.
          locEnd: locEndSecondToLast,
          source
        },
        liquidFilter: {
          type: ConcreteNodeTypes.LiquidFilter,
          name: 3,
          locStart,
          locEnd,
          source,
          args(nodes) {
            return nodes[7].sourceString === "" ? [] : nodes[7].toAST(this.args.mapping);
          }
        },
        arguments: 0,
        tagArguments: 0,
        positionalArgument: 0,
        namedArgument: {
          type: ConcreteNodeTypes.NamedArgument,
          name: 0,
          value: 4,
          locStart,
          locEnd,
          source
        },
        liquidString: 0,
        liquidDoubleQuotedString: {
          type: ConcreteNodeTypes.String,
          single: () => !1,
          value: 1,
          locStart,
          locEnd,
          source
        },
        liquidSingleQuotedString: {
          type: ConcreteNodeTypes.String,
          single: () => !0,
          value: 1,
          locStart,
          locEnd,
          source
        },
        liquidNumber: {
          type: ConcreteNodeTypes.Number,
          value: 0,
          locStart,
          locEnd,
          source
        },
        liquidLiteral: {
          type: ConcreteNodeTypes.LiquidLiteral,
          value: (tokens) => {
            let keyword = tokens[0].sourceString;
            return exports.LiquidLiteralValues[keyword];
          },
          keyword: 0,
          locStart,
          locEnd,
          source
        },
        liquidRange: {
          type: ConcreteNodeTypes.Range,
          start: 2,
          end: 6,
          locStart,
          locEnd,
          source
        },
        liquidVariableLookup: {
          type: ConcreteNodeTypes.VariableLookup,
          name: 0,
          lookups: 1,
          locStart,
          locEnd,
          source
        },
        variableSegmentAsLookupMarkup: 0,
        variableSegmentAsLookup: {
          type: ConcreteNodeTypes.VariableLookup,
          name: 0,
          lookups: () => [],
          locStart,
          locEnd,
          source
        },
        lookup: 0,
        indexLookup: 3,
        dotLookup: {
          type: ConcreteNodeTypes.String,
          value: 3,
          locStart: (nodes) => offset + nodes[2].source.startIdx,
          locEnd: (nodes) => offset + nodes[nodes.length - 1].source.endIdx,
          source
        },
        // trim on both sides
        tagMarkup: (n) => n.sourceString.trim()
      }, LiquidStatement = {
        LiquidStatement: 0,
        liquidTagOpenRule: {
          type: ConcreteNodeTypes.LiquidTagOpen,
          name: 0,
          markup(nodes) {
            let markupNode = nodes[2], nameNode = nodes[0];
            return types_1.NamedTags.hasOwnProperty(nameNode.sourceString) ? markupNode.toAST(this.args.mapping) : markupNode.sourceString.trim();
          },
          whitespaceStart: null,
          whitespaceEnd: null,
          locStart,
          locEnd: locEndSecondToLast,
          source
        },
        liquidTagClose: {
          type: ConcreteNodeTypes.LiquidTagClose,
          name: 1,
          whitespaceStart: null,
          whitespaceEnd: null,
          locStart,
          locEnd: locEndSecondToLast,
          source
        },
        liquidTagRule: {
          type: ConcreteNodeTypes.LiquidTag,
          name: 0,
          markup(nodes) {
            let markupNode = nodes[2], nameNode = nodes[0];
            return types_1.NamedTags.hasOwnProperty(nameNode.sourceString) ? markupNode.toAST(this.args.mapping) : markupNode.sourceString.trim();
          },
          whitespaceStart: null,
          whitespaceEnd: null,
          locStart,
          locEnd: locEndSecondToLast,
          source
        },
        liquidRawTagImpl: {
          type: ConcreteNodeTypes.LiquidRawTag,
          name: 0,
          body: 4,
          children(nodes) {
            return toCST(source, grammars, grammar_1.TextNodeGrammar, ["HelperMappings"], nodes[4].sourceString, offset + nodes[4].source.startIdx);
          },
          whitespaceStart: null,
          whitespaceEnd: null,
          delimiterWhitespaceStart: null,
          delimiterWhitespaceEnd: null,
          locStart,
          locEnd: locEndSecondToLast,
          source,
          blockStartLocStart: (tokens) => offset + tokens[0].source.startIdx,
          blockStartLocEnd: (tokens) => offset + tokens[2].source.endIdx,
          blockEndLocStart: (tokens) => offset + tokens[5].source.startIdx,
          blockEndLocEnd: (tokens) => offset + tokens[5].source.endIdx
        },
        liquidBlockComment: {
          type: ConcreteNodeTypes.LiquidRawTag,
          name: "comment",
          body: (tokens) => (
            // We want this to behave like LiquidRawTag, so we have to do some
            // shenanigans to make it behave the same while also supporting
            // nested comments
            //
            // We're stripping the newline from the statementSep, that's why we
            // slice(1). Since statementSep = newline (space | newline)*
            tokens[1].sourceString.slice(1) + tokens[2].sourceString
          ),
          children(tokens) {
            let commentSource = tokens[1].sourceString.slice(1) + tokens[2].sourceString;
            return toCST(source, grammars, grammar_1.TextNodeGrammar, ["HelperMappings"], commentSource, offset + tokens[1].source.startIdx + 1);
          },
          whitespaceStart: "",
          whitespaceEnd: "",
          delimiterWhitespaceStart: "",
          delimiterWhitespaceEnd: "",
          locStart,
          locEnd,
          source,
          blockStartLocStart: (tokens) => offset + tokens[0].source.startIdx,
          blockStartLocEnd: (tokens) => offset + tokens[0].source.endIdx,
          blockEndLocStart: (tokens) => offset + tokens[4].source.startIdx,
          blockEndLocEnd: (tokens) => offset + tokens[4].source.endIdx
        },
        liquidInlineComment: {
          type: ConcreteNodeTypes.LiquidTag,
          name: 0,
          markup: markupTrimEnd(2),
          whitespaceStart: null,
          whitespaceEnd: null,
          locStart,
          locEnd: locEndSecondToLast,
          source
        }
      }, LiquidHTMLMappings = {
        Node(frontmatter, nodes) {
          let self2 = this;
          return (frontmatter.sourceString.length === 0 ? [] : [frontmatter.toAST(self2.args.mapping)]).concat(nodes.toAST(self2.args.mapping));
        },
        yamlFrontmatter: {
          type: ConcreteNodeTypes.YAMLFrontmatter,
          body: 2,
          locStart,
          locEnd,
          source
        },
        HtmlDoctype: {
          type: ConcreteNodeTypes.HtmlDoctype,
          legacyDoctypeString: 4,
          locStart,
          locEnd,
          source
        },
        HtmlComment: {
          type: ConcreteNodeTypes.HtmlComment,
          body: markup(1),
          locStart,
          locEnd,
          source
        },
        HtmlRawTagImpl: {
          type: ConcreteNodeTypes.HtmlRawTag,
          name: (tokens) => tokens[0].children[1].sourceString,
          attrList(tokens) {
            let mappings = this.args.mapping;
            return tokens[0].children[2].toAST(mappings);
          },
          body: (tokens) => source.slice(tokens[0].source.endIdx, tokens[2].source.startIdx),
          children: (tokens) => {
            let rawMarkup = source.slice(tokens[0].source.endIdx, tokens[2].source.startIdx);
            return toCST(source, grammars, grammars.Liquid, ["HelperMappings", "LiquidMappings"], rawMarkup, tokens[0].source.endIdx);
          },
          locStart,
          locEnd,
          source,
          blockStartLocStart: (tokens) => tokens[0].source.startIdx,
          blockStartLocEnd: (tokens) => tokens[0].source.endIdx,
          blockEndLocStart: (tokens) => tokens[2].source.startIdx,
          blockEndLocEnd: (tokens) => tokens[2].source.endIdx
        },
        HtmlVoidElement: {
          type: ConcreteNodeTypes.HtmlVoidElement,
          name: 1,
          attrList: 3,
          locStart,
          locEnd,
          source
        },
        HtmlSelfClosingElement: {
          type: ConcreteNodeTypes.HtmlSelfClosingElement,
          name: 1,
          attrList: 2,
          locStart,
          locEnd,
          source
        },
        HtmlTagOpen: {
          type: ConcreteNodeTypes.HtmlTagOpen,
          name: 1,
          attrList: 2,
          locStart,
          locEnd,
          source
        },
        HtmlTagClose: {
          type: ConcreteNodeTypes.HtmlTagClose,
          name: 1,
          locStart,
          locEnd,
          source
        },
        leadingTagNamePart: 0,
        leadingTagNameTextNode: textNode,
        trailingTagNamePart: 0,
        trailingTagNameTextNode: textNode,
        tagName(leadingPart, trailingParts) {
          let mappings = this.args.mapping;
          return [leadingPart.toAST(mappings)].concat(trailingParts.toAST(mappings));
        },
        AttrUnquoted: {
          type: ConcreteNodeTypes.AttrUnquoted,
          name: 0,
          value: 2,
          locStart,
          locEnd,
          source
        },
        AttrSingleQuoted: {
          type: ConcreteNodeTypes.AttrSingleQuoted,
          name: 0,
          value: 3,
          locStart,
          locEnd,
          source
        },
        AttrDoubleQuoted: {
          type: ConcreteNodeTypes.AttrDoubleQuoted,
          name: 0,
          value: 3,
          locStart,
          locEnd,
          source
        },
        attrEmpty: {
          type: ConcreteNodeTypes.AttrEmpty,
          name: 0,
          locStart,
          locEnd,
          source
        },
        attrName: 0,
        attrNameTextNode: textNode,
        attrDoubleQuotedValue: 0,
        attrSingleQuotedValue: 0,
        attrUnquotedValue: 0,
        attrDoubleQuotedTextNode: textNode,
        attrSingleQuotedTextNode: textNode,
        attrUnquotedTextNode: textNode
      }, defaultMappings = {
        HelperMappings,
        LiquidMappings,
        LiquidHTMLMappings,
        LiquidStatement
      }, selectedMappings = cstMappings.reduce((mappings, key) => ({
        ...mappings,
        ...defaultMappings[key]
      }), {});
      return (0, extras_1.toAST)(res, selectedMappings);
    }
  }
});

// ../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/dist/utils.js
var require_utils = __commonJS({
  "../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/dist/utils.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.dropLast = exports.deepGet = exports.locEnd = exports.locStart = exports.assertNever = void 0;
    function assertNever(x) {
      throw new Error(`Unexpected object: ${x.type}`);
    }
    exports.assertNever = assertNever;
    function locStart(node) {
      return node.position.start;
    }
    exports.locStart = locStart;
    function locEnd(node) {
      return node.position.end;
    }
    exports.locEnd = locEnd;
    function deepGet(path3, obj) {
      return path3.reduce((curr, k) => {
        if (curr && curr[k] !== void 0)
          return curr[k];
      }, obj);
    }
    exports.deepGet = deepGet;
    function dropLast(n, xs) {
      let result = [...xs];
      for (let i = 0; i < n; i++)
        result.pop();
      return result;
    }
    exports.dropLast = dropLast;
  }
});

// ../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/dist/stage-2-ast.js
var require_stage_2_ast = __commonJS({
  "../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/dist/stage-2-ast.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.isLiquidHtmlNode = exports.walk = exports.cstToAst = exports.toLiquidHtmlAST = exports.toLiquidAST = exports.isBranchedTag = exports.RawMarkupKinds = void 0;
    var stage_1_cst_1 = require_stage_1_cst(), types_1 = require_types(), utils_1 = require_utils(), errors_1 = require_errors2(), grammar_1 = require_grammar(), stage_1_cst_2 = require_stage_1_cst(), RawMarkupKinds;
    (function(RawMarkupKinds2) {
      RawMarkupKinds2.css = "css", RawMarkupKinds2.html = "html", RawMarkupKinds2.javascript = "javascript", RawMarkupKinds2.json = "json", RawMarkupKinds2.markdown = "markdown", RawMarkupKinds2.typescript = "typescript", RawMarkupKinds2.text = "text";
    })(RawMarkupKinds = exports.RawMarkupKinds || (exports.RawMarkupKinds = {}));
    function isBranchedTag(node) {
      return node.type === types_1.NodeTypes.LiquidTag && ["if", "for", "unless", "case"].includes(node.name);
    }
    exports.isBranchedTag = isBranchedTag;
    function isConcreteLiquidBranchDisguisedAsTag(node) {
      return node.type === stage_1_cst_1.ConcreteNodeTypes.LiquidTag && ["else", "elsif", "when"].includes(node.name);
    }
    function toLiquidAST(source, options = {
      allowUnclosedDocumentNode: !0,
      mode: "tolerant"
    }) {
      let cst = (0, stage_1_cst_2.toLiquidCST)(source, { mode: options.mode });
      return {
        type: types_1.NodeTypes.Document,
        source,
        _source: source,
        children: cstToAst(cst, options),
        name: "#document",
        position: {
          start: 0,
          end: source.length
        }
      };
    }
    exports.toLiquidAST = toLiquidAST;
    function toLiquidHtmlAST(source, options = {
      allowUnclosedDocumentNode: !1,
      mode: "tolerant"
    }) {
      let cst = (0, stage_1_cst_1.toLiquidHtmlCST)(source, { mode: options.mode });
      return {
        type: types_1.NodeTypes.Document,
        source,
        _source: source,
        children: cstToAst(cst, options),
        name: "#document",
        position: {
          start: 0,
          end: source.length
        }
      };
    }
    exports.toLiquidHtmlAST = toLiquidHtmlAST;
    var ASTBuilder = class {
      constructor(source) {
        this.ast = [], this.cursor = [], this.source = source;
      }
      // Returns the array to push nodes to.
      get current() {
        return (0, utils_1.deepGet)(this.cursor, this.ast);
      }
      // Returns the position of the current node in the array
      get currentPosition() {
        return (this.current || []).length - 1;
      }
      get parent() {
        if (this.cursor.length != 0)
          return (0, utils_1.deepGet)((0, utils_1.dropLast)(1, this.cursor), this.ast);
      }
      get grandparent() {
        if (!(this.cursor.length < 4))
          return (0, utils_1.deepGet)((0, utils_1.dropLast)(3, this.cursor), this.ast);
      }
      open(node) {
        this.current.push(node), this.cursor.push(this.currentPosition), this.cursor.push("children"), isBranchedTag(node) && this.open(toUnnamedLiquidBranch(node));
      }
      push(node) {
        if (node.type === types_1.NodeTypes.LiquidBranch) {
          let previousBranch = this.findCloseableParentBranch(node);
          if (previousBranch) {
            for (; this.parent && this.parent !== previousBranch && this.parent.type === types_1.NodeTypes.HtmlElement; )
              this.parent.blockEndPosition = { start: node.position.start, end: node.position.start }, this.closeParentWith(node);
            this.closeParentWith(node);
          }
          this.open(node);
        } else
          this.current.push(node);
      }
      close(node, nodeType) {
        var _a38, _b;
        if (isLiquidBranch(this.parent) && this.closeParentWith(node), !this.parent)
          throw new errors_1.LiquidHTMLASTParsingError(`Attempting to close ${nodeType} '${getName2(node)}' before it was opened`, this.source, node.locStart, node.locEnd);
        if (getName2(this.parent) !== getName2(node) || this.parent.type !== nodeType) {
          let suitableParent = this.findCloseableParentNode(node);
          if (this.parent.type === types_1.NodeTypes.HtmlElement && suitableParent)
            for (; this.parent !== suitableParent; )
              this.parent.blockEndPosition = { start: node.locStart, end: node.locStart }, this.closeParentWith(node);
          else
            throw new errors_1.LiquidHTMLASTParsingError(`Attempting to close ${nodeType} '${getName2(node)}' before ${this.parent.type} '${getName2(this.parent)}' was closed`, this.source, this.parent.position.start, node.locEnd);
        }
        this.parent.position.end = node.locEnd, this.parent.blockEndPosition = position(node), this.parent.type == types_1.NodeTypes.LiquidTag && node.type == stage_1_cst_1.ConcreteNodeTypes.LiquidTagClose && (this.parent.delimiterWhitespaceStart = (_a38 = node.whitespaceStart) !== null && _a38 !== void 0 ? _a38 : "", this.parent.delimiterWhitespaceEnd = (_b = node.whitespaceEnd) !== null && _b !== void 0 ? _b : ""), this.cursor.pop(), this.cursor.pop();
      }
      // This function performs the following tasks:
      // - Tries to find a parent branch to close when pushing a new branch.
      // - This is necessary because we allow unclosed HTML element nodes.
      // - The function traverses up the tree until it finds a LiquidBranch.
      // - If it encounters anything other than an Unclosed HTML Element, it throws.
      findCloseableParentBranch(next) {
        for (let index = this.cursor.length - 1; index > 0; index -= 2) {
          let parent = (0, utils_1.deepGet)(this.cursor.slice(0, index), this.ast), parentProperty = this.cursor[index], isUnclosedHtmlElement = parent.type === types_1.NodeTypes.HtmlElement && parentProperty === "children";
          if (parent.type === types_1.NodeTypes.LiquidBranch)
            return parent;
          if (!isUnclosedHtmlElement)
            throw new errors_1.LiquidHTMLASTParsingError(`Attempting to open LiquidBranch '${next.name}' before ${parent.type} '${getName2(parent)}' was closed`, this.source, parent.position.start, next.position.end);
        }
        return null;
      }
      // Check if there's a parent in the ancestry that this node correctly closes
      findCloseableParentNode(current) {
        for (let index = this.cursor.length - 1; index > 0; index -= 2) {
          let parent = (0, utils_1.deepGet)(this.cursor.slice(0, index), this.ast);
          if (getName2(parent) === getName2(current) && parent.type === types_1.NodeTypes.LiquidTag && ["if", "unless", "case"].includes(parent.name))
            return parent;
          if (parent.type === types_1.NodeTypes.LiquidTag)
            return null;
        }
        return null;
      }
      // sets the parent's end position to the start of the next one.
      closeParentWith(next) {
        this.parent && ("locStart" in next ? this.parent.position.end = next.locStart : this.parent.position.end = next.position.start), this.cursor.pop(), this.cursor.pop();
      }
    };
    function isLiquidBranch(node) {
      return !!node && node.type === types_1.NodeTypes.LiquidBranch;
    }
    function getName2(node) {
      if (!node)
        return null;
      switch (node.type) {
        case types_1.NodeTypes.HtmlElement:
        case types_1.NodeTypes.HtmlDanglingMarkerClose:
        case types_1.NodeTypes.HtmlSelfClosingElement:
        case stage_1_cst_1.ConcreteNodeTypes.HtmlTagClose:
          return node.name.map((part) => part.type === types_1.NodeTypes.TextNode || part.type == stage_1_cst_1.ConcreteNodeTypes.TextNode ? part.value : typeof part.markup == "string" ? `{{${part.markup.trim()}}}` : `{{${part.markup.rawSource}}}`).join("");
        case types_1.NodeTypes.AttrEmpty:
        case types_1.NodeTypes.AttrUnquoted:
        case types_1.NodeTypes.AttrDoubleQuoted:
        case types_1.NodeTypes.AttrSingleQuoted:
          return node.name.map((part) => typeof part == "string" ? part : part.source.slice(part.position.start, part.position.end)).join("");
        default:
          return node.name;
      }
    }
    function cstToAst(cst, options) {
      var _a38;
      if (cst.length === 0)
        return [];
      let builder = buildAst(cst, options);
      if (!options.allowUnclosedDocumentNode && builder.cursor.length !== 0)
        throw new errors_1.LiquidHTMLASTParsingError(`Attempting to end parsing before ${(_a38 = builder.parent) === null || _a38 === void 0 ? void 0 : _a38.type} '${getName2(builder.parent)}' was closed`, builder.source, builder.source.length - 1, builder.source.length);
      return builder.ast;
    }
    exports.cstToAst = cstToAst;
    function buildAst(cst, options) {
      var _a38, _b, _c, _d;
      let builder = new ASTBuilder(cst[0].source);
      for (let i = 0; i < cst.length; i++) {
        let node = cst[i];
        switch (node.type) {
          case stage_1_cst_1.ConcreteNodeTypes.TextNode: {
            builder.push(toTextNode(node));
            break;
          }
          case stage_1_cst_1.ConcreteNodeTypes.LiquidVariableOutput: {
            builder.push(toLiquidVariableOutput(node));
            break;
          }
          case stage_1_cst_1.ConcreteNodeTypes.LiquidTagOpen: {
            builder.open(toLiquidTag(node, { ...options, isBlockTag: !0 }));
            break;
          }
          case stage_1_cst_1.ConcreteNodeTypes.LiquidTagClose: {
            builder.close(node, types_1.NodeTypes.LiquidTag);
            break;
          }
          case stage_1_cst_1.ConcreteNodeTypes.LiquidTag: {
            builder.push(toLiquidTag(node, { ...options, isBlockTag: !1 }));
            break;
          }
          case stage_1_cst_1.ConcreteNodeTypes.LiquidRawTag: {
            builder.push({
              type: types_1.NodeTypes.LiquidRawTag,
              markup: markup(node.name, node.markup),
              name: node.name,
              body: toRawMarkup(node, options),
              whitespaceStart: (_a38 = node.whitespaceStart) !== null && _a38 !== void 0 ? _a38 : "",
              whitespaceEnd: (_b = node.whitespaceEnd) !== null && _b !== void 0 ? _b : "",
              delimiterWhitespaceStart: (_c = node.delimiterWhitespaceStart) !== null && _c !== void 0 ? _c : "",
              delimiterWhitespaceEnd: (_d = node.delimiterWhitespaceEnd) !== null && _d !== void 0 ? _d : "",
              position: position(node),
              blockStartPosition: {
                start: node.blockStartLocStart,
                end: node.blockStartLocEnd
              },
              blockEndPosition: {
                start: node.blockEndLocStart,
                end: node.blockEndLocEnd
              },
              source: node.source
            });
            break;
          }
          case stage_1_cst_1.ConcreteNodeTypes.HtmlTagOpen: {
            builder.open(toHtmlElement(node, options));
            break;
          }
          case stage_1_cst_1.ConcreteNodeTypes.HtmlTagClose: {
            isAcceptableDanglingMarkerClose(builder, cst, i, options.mode) ? builder.push(toHtmlDanglingMarkerClose(node, options)) : builder.close(node, types_1.NodeTypes.HtmlElement);
            break;
          }
          case stage_1_cst_1.ConcreteNodeTypes.HtmlVoidElement: {
            builder.push(toHtmlVoidElement(node, options));
            break;
          }
          case stage_1_cst_1.ConcreteNodeTypes.HtmlSelfClosingElement: {
            builder.push(toHtmlSelfClosingElement(node, options));
            break;
          }
          case stage_1_cst_1.ConcreteNodeTypes.HtmlDoctype: {
            builder.push({
              type: types_1.NodeTypes.HtmlDoctype,
              legacyDoctypeString: node.legacyDoctypeString,
              position: position(node),
              source: node.source
            });
            break;
          }
          case stage_1_cst_1.ConcreteNodeTypes.HtmlComment: {
            builder.push({
              type: types_1.NodeTypes.HtmlComment,
              body: node.body,
              position: position(node),
              source: node.source
            });
            break;
          }
          case stage_1_cst_1.ConcreteNodeTypes.HtmlRawTag: {
            builder.push({
              type: types_1.NodeTypes.HtmlRawNode,
              name: node.name,
              body: toRawMarkup(node, options),
              attributes: toAttributes(node.attrList || [], options),
              position: position(node),
              source: node.source,
              blockStartPosition: {
                start: node.blockStartLocStart,
                end: node.blockStartLocEnd
              },
              blockEndPosition: {
                start: node.blockEndLocStart,
                end: node.blockEndLocEnd
              }
            });
            break;
          }
          case stage_1_cst_1.ConcreteNodeTypes.AttrEmpty: {
            builder.push({
              type: types_1.NodeTypes.AttrEmpty,
              name: cstToAst(node.name, options),
              position: position(node),
              source: node.source
            });
            break;
          }
          case stage_1_cst_1.ConcreteNodeTypes.AttrSingleQuoted:
          case stage_1_cst_1.ConcreteNodeTypes.AttrDoubleQuoted:
          case stage_1_cst_1.ConcreteNodeTypes.AttrUnquoted: {
            let abstractNode = {
              type: node.type,
              name: cstToAst(node.name, options),
              position: position(node),
              source: node.source,
              // placeholders
              attributePosition: { start: -1, end: -1 },
              value: []
            }, value = toAttributeValue(node.value, options);
            abstractNode.value = value, abstractNode.attributePosition = toAttributePosition(node, value), builder.push(abstractNode);
            break;
          }
          case stage_1_cst_1.ConcreteNodeTypes.YAMLFrontmatter: {
            builder.push({
              type: types_1.NodeTypes.YAMLFrontmatter,
              body: node.body,
              position: position(node),
              source: node.source
            });
            break;
          }
          default:
            (0, utils_1.assertNever)(node);
        }
      }
      return builder;
    }
    function nameLength(names) {
      let start = names.at(0);
      return names.at(-1).locEnd - start.locStart;
    }
    function toAttributePosition(node, value) {
      return value.length === 0 ? {
        start: node.locStart + nameLength(node.name) + 1 + 1,
        // name=""
        // 012345678
        // 0 + 4 + 1 + 1
        // = 6
        end: node.locStart + nameLength(node.name) + 1 + 1
        // name=""
        // 012345678
        // 0 + 4 + 1 + 2
        // = 6
      } : {
        start: value[0].position.start,
        end: value[value.length - 1].position.end
      };
    }
    function toAttributeValue(value, options) {
      return cstToAst(value, options);
    }
    function toAttributes(attrList, options) {
      return cstToAst(attrList, options);
    }
    function liquidTagBaseAttributes(node) {
      var _a38, _b;
      return {
        type: types_1.NodeTypes.LiquidTag,
        position: position(node),
        whitespaceStart: (_a38 = node.whitespaceStart) !== null && _a38 !== void 0 ? _a38 : "",
        whitespaceEnd: (_b = node.whitespaceEnd) !== null && _b !== void 0 ? _b : "",
        blockStartPosition: position(node),
        source: node.source
      };
    }
    function liquidBranchBaseAttributes(node) {
      var _a38, _b;
      return {
        type: types_1.NodeTypes.LiquidBranch,
        children: [],
        position: position(node),
        whitespaceStart: (_a38 = node.whitespaceStart) !== null && _a38 !== void 0 ? _a38 : "",
        whitespaceEnd: (_b = node.whitespaceEnd) !== null && _b !== void 0 ? _b : "",
        blockStartPosition: position(node),
        source: node.source
      };
    }
    function toLiquidTag(node, options) {
      return typeof node.markup != "string" ? toNamedLiquidTag(node, options) : isConcreteLiquidBranchDisguisedAsTag(node) ? toNamedLiquidBranchBaseCase(node) : options.isBlockTag ? {
        name: node.name,
        markup: markup(node.name, node.markup),
        children: options.isBlockTag ? [] : void 0,
        ...liquidTagBaseAttributes(node)
      } : {
        name: node.name,
        markup: markup(node.name, node.markup),
        ...liquidTagBaseAttributes(node)
      };
    }
    function toNamedLiquidTag(node, options) {
      switch (node.name) {
        case types_1.NamedTags.echo:
          return {
            ...liquidTagBaseAttributes(node),
            name: types_1.NamedTags.echo,
            markup: toLiquidVariable(node.markup)
          };
        case types_1.NamedTags.assign:
          return {
            ...liquidTagBaseAttributes(node),
            name: types_1.NamedTags.assign,
            markup: toAssignMarkup(node.markup)
          };
        case types_1.NamedTags.cycle:
          return {
            ...liquidTagBaseAttributes(node),
            name: node.name,
            markup: toCycleMarkup(node.markup)
          };
        case types_1.NamedTags.increment:
        case types_1.NamedTags.decrement:
          return {
            ...liquidTagBaseAttributes(node),
            name: node.name,
            markup: toExpression(node.markup)
          };
        case types_1.NamedTags.capture:
          return {
            ...liquidTagBaseAttributes(node),
            name: node.name,
            markup: toExpression(node.markup),
            children: []
          };
        case types_1.NamedTags.include:
        case types_1.NamedTags.render:
          return {
            ...liquidTagBaseAttributes(node),
            name: node.name,
            markup: toRenderMarkup(node.markup)
          };
        case types_1.NamedTags.layout:
        case types_1.NamedTags.section:
          return {
            ...liquidTagBaseAttributes(node),
            name: node.name,
            markup: toExpression(node.markup)
          };
        case types_1.NamedTags.sections:
          return {
            ...liquidTagBaseAttributes(node),
            name: node.name,
            markup: toExpression(node.markup)
          };
        case types_1.NamedTags.form:
          return {
            ...liquidTagBaseAttributes(node),
            name: node.name,
            markup: node.markup.map(toLiquidArgument),
            children: []
          };
        case types_1.NamedTags.tablerow:
        case types_1.NamedTags.for:
          return {
            ...liquidTagBaseAttributes(node),
            name: node.name,
            markup: toForMarkup(node.markup),
            children: []
          };
        case types_1.NamedTags.paginate:
          return {
            ...liquidTagBaseAttributes(node),
            name: node.name,
            markup: toPaginateMarkup(node.markup),
            children: []
          };
        case types_1.NamedTags.if:
        case types_1.NamedTags.unless:
          return {
            ...liquidTagBaseAttributes(node),
            name: node.name,
            markup: toConditionalExpression(node.markup),
            children: []
          };
        case types_1.NamedTags.elsif:
          return {
            ...liquidBranchBaseAttributes(node),
            name: node.name,
            markup: toConditionalExpression(node.markup)
          };
        case types_1.NamedTags.case:
          return {
            ...liquidTagBaseAttributes(node),
            name: node.name,
            markup: toExpression(node.markup),
            children: []
          };
        case types_1.NamedTags.when:
          return {
            ...liquidBranchBaseAttributes(node),
            name: node.name,
            markup: node.markup.map(toExpression)
          };
        case types_1.NamedTags.liquid:
          return {
            ...liquidTagBaseAttributes(node),
            name: node.name,
            markup: cstToAst(node.markup, options)
          };
        default:
          return (0, utils_1.assertNever)(node);
      }
    }
    function toNamedLiquidBranchBaseCase(node) {
      var _a38, _b;
      return {
        name: node.name,
        type: types_1.NodeTypes.LiquidBranch,
        markup: node.name !== "else" ? node.markup : "",
        position: { start: node.locStart, end: node.locEnd },
        children: [],
        blockStartPosition: { start: node.locStart, end: node.locEnd },
        whitespaceStart: (_a38 = node.whitespaceStart) !== null && _a38 !== void 0 ? _a38 : "",
        whitespaceEnd: (_b = node.whitespaceEnd) !== null && _b !== void 0 ? _b : "",
        source: node.source
      };
    }
    function toUnnamedLiquidBranch(parentNode) {
      return {
        type: types_1.NodeTypes.LiquidBranch,
        name: null,
        markup: "",
        position: {
          start: parentNode.position.end,
          end: parentNode.position.end
          // tmp value
        },
        blockStartPosition: {
          start: parentNode.position.end,
          end: parentNode.position.end
        },
        children: [],
        whitespaceStart: "",
        whitespaceEnd: "",
        source: parentNode.source
      };
    }
    function toAssignMarkup(node) {
      return {
        type: types_1.NodeTypes.AssignMarkup,
        name: node.name,
        value: toLiquidVariable(node.value),
        position: position(node),
        source: node.source
      };
    }
    function toCycleMarkup(node) {
      return {
        type: types_1.NodeTypes.CycleMarkup,
        groupName: node.groupName ? toExpression(node.groupName) : null,
        args: node.args.map(toExpression),
        position: position(node),
        source: node.source
      };
    }
    function toForMarkup(node) {
      return {
        type: types_1.NodeTypes.ForMarkup,
        variableName: node.variableName,
        collection: toExpression(node.collection),
        args: node.args.map(toNamedArgument),
        reversed: !!node.reversed,
        position: position(node),
        source: node.source
      };
    }
    function toPaginateMarkup(node) {
      return {
        type: types_1.NodeTypes.PaginateMarkup,
        collection: toExpression(node.collection),
        pageSize: toExpression(node.pageSize),
        position: position(node),
        args: node.args ? node.args.map(toNamedArgument) : [],
        source: node.source
      };
    }
    function toRawMarkup(node, options) {
      return {
        type: types_1.NodeTypes.RawMarkup,
        kind: toRawMarkupKind(node),
        nodes: cstToAst(node.children, options),
        value: node.body,
        position: {
          start: node.blockStartLocEnd,
          end: node.blockEndLocStart
        },
        source: node.source
      };
    }
    function toRawMarkupKind(node) {
      switch (node.type) {
        case stage_1_cst_1.ConcreteNodeTypes.HtmlRawTag:
          return toRawMarkupKindFromHtmlNode(node);
        case stage_1_cst_1.ConcreteNodeTypes.LiquidRawTag:
          return toRawMarkupKindFromLiquidNode(node);
        default:
          return (0, utils_1.assertNever)(node);
      }
    }
    var liquidToken = /(\{%|\{\{)-?/g;
    function toRawMarkupKindFromHtmlNode(node) {
      var _a38;
      switch (node.name) {
        case "script": {
          let scriptAttr = (_a38 = node.attrList) === null || _a38 === void 0 ? void 0 : _a38.find((attr) => "name" in attr && typeof attr.name != "string" && attr.name.length === 1 && attr.name[0].type === stage_1_cst_1.ConcreteNodeTypes.TextNode && attr.name[0].value === "type");
          if (!scriptAttr || !("value" in scriptAttr) || scriptAttr.value.length === 0 || scriptAttr.value[0].type !== stage_1_cst_1.ConcreteNodeTypes.TextNode)
            return RawMarkupKinds.javascript;
          let type = scriptAttr.value[0].value;
          return type === "text/markdown" ? RawMarkupKinds.markdown : type === "application/x-typescript" ? RawMarkupKinds.typescript : type === "text/html" ? RawMarkupKinds.html : type && (type.endsWith("json") || type.endsWith("importmap")) || type === "speculationrules" ? RawMarkupKinds.json : RawMarkupKinds.javascript;
        }
        case "style":
          return liquidToken.test(node.body) ? RawMarkupKinds.text : RawMarkupKinds.css;
        default:
          return RawMarkupKinds.text;
      }
    }
    function toRawMarkupKindFromLiquidNode(node) {
      switch (node.name) {
        case "javascript":
          return RawMarkupKinds.javascript;
        case "stylesheet":
        case "style":
          return liquidToken.test(node.body) ? RawMarkupKinds.text : RawMarkupKinds.css;
        case "schema":
          return RawMarkupKinds.json;
        default:
          return RawMarkupKinds.text;
      }
    }
    function toRenderMarkup(node) {
      return {
        type: types_1.NodeTypes.RenderMarkup,
        snippet: toExpression(node.snippet),
        alias: node.alias,
        variable: toRenderVariableExpression(node.variable),
        args: node.args.map(toNamedArgument),
        position: position(node),
        source: node.source
      };
    }
    function toRenderVariableExpression(node) {
      return node ? {
        type: types_1.NodeTypes.RenderVariableExpression,
        kind: node.kind,
        name: toExpression(node.name),
        position: position(node),
        source: node.source
      } : null;
    }
    function toConditionalExpression(nodes) {
      if (nodes.length === 1)
        return toComparisonOrExpression(nodes[0]);
      let [first, second] = nodes, [, ...rest] = nodes;
      return {
        type: types_1.NodeTypes.LogicalExpression,
        relation: second.relation,
        left: toComparisonOrExpression(first),
        right: toConditionalExpression(rest),
        position: {
          start: first.locStart,
          end: nodes[nodes.length - 1].locEnd
        },
        source: first.source
      };
    }
    function toComparisonOrExpression(node) {
      let expression = node.expression;
      switch (expression.type) {
        case stage_1_cst_1.ConcreteNodeTypes.Comparison:
          return toComparison(expression);
        default:
          return toExpression(expression);
      }
    }
    function toComparison(node) {
      return {
        type: types_1.NodeTypes.Comparison,
        comparator: node.comparator,
        left: toExpression(node.left),
        right: toExpression(node.right),
        position: position(node),
        source: node.source
      };
    }
    function toLiquidVariableOutput(node) {
      var _a38, _b;
      return {
        type: types_1.NodeTypes.LiquidVariableOutput,
        markup: typeof node.markup == "string" ? node.markup : toLiquidVariable(node.markup),
        whitespaceStart: (_a38 = node.whitespaceStart) !== null && _a38 !== void 0 ? _a38 : "",
        whitespaceEnd: (_b = node.whitespaceEnd) !== null && _b !== void 0 ? _b : "",
        position: position(node),
        source: node.source
      };
    }
    function toLiquidVariable(node) {
      return {
        type: types_1.NodeTypes.LiquidVariable,
        expression: toExpression(node.expression),
        filters: node.filters.map(toFilter),
        position: position(node),
        rawSource: node.rawSource,
        source: node.source
      };
    }
    function toExpression(node) {
      switch (node.type) {
        case stage_1_cst_1.ConcreteNodeTypes.String:
          return {
            type: types_1.NodeTypes.String,
            position: position(node),
            single: node.single,
            value: node.value,
            source: node.source
          };
        case stage_1_cst_1.ConcreteNodeTypes.Number:
          return {
            type: types_1.NodeTypes.Number,
            position: position(node),
            value: node.value,
            source: node.source
          };
        case stage_1_cst_1.ConcreteNodeTypes.LiquidLiteral:
          return {
            type: types_1.NodeTypes.LiquidLiteral,
            position: position(node),
            value: node.value,
            keyword: node.keyword,
            source: node.source
          };
        case stage_1_cst_1.ConcreteNodeTypes.Range:
          return {
            type: types_1.NodeTypes.Range,
            start: toExpression(node.start),
            end: toExpression(node.end),
            position: position(node),
            source: node.source
          };
        case stage_1_cst_1.ConcreteNodeTypes.VariableLookup:
          return {
            type: types_1.NodeTypes.VariableLookup,
            name: node.name,
            lookups: node.lookups.map(toExpression),
            position: position(node),
            source: node.source
          };
        default:
          return (0, utils_1.assertNever)(node);
      }
    }
    function toFilter(node) {
      return {
        type: types_1.NodeTypes.LiquidFilter,
        name: node.name,
        args: node.args.map(toLiquidArgument),
        position: position(node),
        source: node.source
      };
    }
    function toLiquidArgument(node) {
      switch (node.type) {
        case stage_1_cst_1.ConcreteNodeTypes.NamedArgument:
          return toNamedArgument(node);
        default:
          return toExpression(node);
      }
    }
    function toNamedArgument(node) {
      return {
        type: types_1.NodeTypes.NamedArgument,
        name: node.name,
        value: toExpression(node.value),
        position: position(node),
        source: node.source
      };
    }
    function toHtmlElement(node, options) {
      return {
        type: types_1.NodeTypes.HtmlElement,
        name: cstToAst(node.name, options),
        attributes: toAttributes(node.attrList || [], options),
        position: position(node),
        blockStartPosition: position(node),
        blockEndPosition: { start: -1, end: -1 },
        children: [],
        source: node.source
      };
    }
    function toHtmlDanglingMarkerClose(node, options) {
      return {
        type: types_1.NodeTypes.HtmlDanglingMarkerClose,
        name: cstToAst(node.name, options),
        position: position(node),
        blockStartPosition: position(node),
        source: node.source
      };
    }
    function toHtmlVoidElement(node, options) {
      return {
        type: types_1.NodeTypes.HtmlVoidElement,
        name: node.name,
        attributes: toAttributes(node.attrList || [], options),
        position: position(node),
        blockStartPosition: position(node),
        source: node.source
      };
    }
    function toHtmlSelfClosingElement(node, options) {
      return {
        type: types_1.NodeTypes.HtmlSelfClosingElement,
        name: cstToAst(node.name, options),
        attributes: toAttributes(node.attrList || [], options),
        position: position(node),
        blockStartPosition: position(node),
        source: node.source
      };
    }
    function toTextNode(node) {
      return {
        type: types_1.NodeTypes.TextNode,
        value: node.value,
        position: position(node),
        source: node.source
      };
    }
    function isAcceptableDanglingMarkerClose(builder, cst, currIndex, mode) {
      if (mode === "completion") {
        let current = cst[currIndex];
        return !(builder.parent && builder.parent.type === types_1.NodeTypes.HtmlElement && getName2(builder.parent) === getName2(current));
      }
      return isAcceptableDanglingMarker(builder);
    }
    function isAcceptableDanglingMarker(builder) {
      let { parent, grandparent } = builder;
      return !parent || !grandparent ? !1 : parent.type === types_1.NodeTypes.LiquidBranch && grandparent.type === types_1.NodeTypes.LiquidTag && ["if", "unless", "case"].includes(grandparent.name);
    }
    function markup(name, markup2) {
      return grammar_1.TAGS_WITHOUT_MARKUP.includes(name) ? "" : markup2;
    }
    function position(node) {
      return {
        start: node.locStart,
        end: node.locEnd
      };
    }
    function walk(ast, fn, parentNode) {
      for (let key of Object.keys(ast)) {
        if (types_1.nonTraversableProperties.has(key))
          continue;
        let value = ast[key];
        Array.isArray(value) ? value.filter(isLiquidHtmlNode).forEach((node) => walk(node, fn, ast)) : isLiquidHtmlNode(value) && walk(value, fn, ast);
      }
      fn(ast, parentNode);
    }
    exports.walk = walk;
    function isLiquidHtmlNode(value) {
      return value !== null && typeof value == "object" && "type" in value && types_1.NodeTypes.hasOwnProperty(value.type);
    }
    exports.isLiquidHtmlNode = isLiquidHtmlNode;
  }
});

// ../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/dist/conditional-comment.js
var require_conditional_comment = __commonJS({
  "../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/dist/conditional-comment.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.getConditionalComment = void 0;
    var commentRegex = /(<!--\[if[^\]]*]>)((.|\n)*)(<!\[endif\]-->)$/, getConditionalComment = (comment) => {
      let matches = comment.match(commentRegex);
      if (matches)
        return {
          startTag: matches[1],
          body: matches[2].trim(),
          endTag: matches[4]
        };
    };
    exports.getConditionalComment = getConditionalComment;
  }
});

// ../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/dist/index.js
var require_dist = __commonJS({
  "../../node_modules/.pnpm/@shopify+liquid-html-parser@2.0.3/node_modules/@shopify/liquid-html-parser/dist/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p) && __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.getConditionalComment = exports.BLOCKS = exports.VOID_ELEMENTS = exports.RAW_TAGS = exports.TAGS_WITHOUT_MARKUP = void 0;
    __exportStar(require_stage_2_ast(), exports);
    __exportStar(require_types(), exports);
    __exportStar(require_errors2(), exports);
    var grammar_1 = require_grammar();
    Object.defineProperty(exports, "TAGS_WITHOUT_MARKUP", { enumerable: !0, get: function() {
      return grammar_1.TAGS_WITHOUT_MARKUP;
    } });
    Object.defineProperty(exports, "RAW_TAGS", { enumerable: !0, get: function() {
      return grammar_1.RAW_TAGS;
    } });
    Object.defineProperty(exports, "VOID_ELEMENTS", { enumerable: !0, get: function() {
      return grammar_1.VOID_ELEMENTS;
    } });
    Object.defineProperty(exports, "BLOCKS", { enumerable: !0, get: function() {
      return grammar_1.BLOCKS;
    } });
    var conditional_comment_1 = require_conditional_comment();
    Object.defineProperty(exports, "getConditionalComment", { enumerable: !0, get: function() {
      return conditional_comment_1.getConditionalComment;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/types/theme-liquid-docs.js
var require_theme_liquid_docs = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/types/theme-liquid-docs.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/types/schema-prop-factory.js
var require_schema_prop_factory = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/types/schema-prop-factory.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.SchemaProp = void 0;
    var SchemaProp = class _SchemaProp {
      constructor(options) {
        this.options = options;
      }
      /** Creates a string setting definition */
      static string(defaultValue) {
        return new _SchemaProp({ type: "string", defaultValue });
      }
      /** Creates a number setting definition */
      static number(defaultValue) {
        return new _SchemaProp({ type: "number", defaultValue });
      }
      /** Creates a boolean setting definition */
      static boolean(defaultValue) {
        return new _SchemaProp({ type: "boolean", defaultValue });
      }
      /**
       * Creates an object setting definition
       *
       * Usage:
       * ```
       * const schema = {
       *   user: SchemaProp.object({
       *     age: SchemaProp.number(),
       *     name: SchemaProp.string(),
       *   })
       * };
       * ```
       *
       * @returns a schema property definition for an object type
       */
      static object(properties, defaultValue) {
        return new _SchemaProp({ type: "object", defaultValue, properties });
      }
      /**
       * Creates an array setting definition
       *
       * Usage:
       * ```
       * const schema = {
       *   numbers: SchemaProp.array(SchemaProp.number(), [0, 1]),
       *   strings: SchemaProp.array(SchemaProp.string(), ["foo", "bar"]),
       *   users: SchemaProp.array(SchemaProp.object({
       *    name: SchemaProp.string(),
       *    age: SchemaProp.number(),
       *   })),
       * };
       * ```
       *
       * @param itemType the type of the items in the array
       * @returns a schema property definition for an object type
       */
      static array(itemType, defaultValue) {
        return new _SchemaProp({ type: "array", defaultValue, itemType });
      }
      /**
       * A schema prop can be optional, making the setting T | undefined.
       *
       * Usage:
       * ```
       * const Schema = {
       *   age: SchemaProp.number().optional(),
       * }
       * ```
       */
      optional() {
        return this.options.optional = !0, this;
      }
      defaultValue() {
        return this.options.defaultValue;
      }
    };
    exports.SchemaProp = SchemaProp;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/types.js
var require_types2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/types.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p) && __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ConfigTarget = exports.Severity = exports.LiquidHtmlNodeTypes = exports.SourceCodeType = exports.Modes = exports.isPropertyNode = exports.isArrayNode = exports.isObjectNode = void 0;
    var liquid_html_parser_1 = require_dist();
    Object.defineProperty(exports, "LiquidHtmlNodeTypes", { enumerable: !0, get: function() {
      return liquid_html_parser_1.NodeTypes;
    } });
    __exportStar(require_theme_liquid_docs(), exports);
    __exportStar(require_schema_prop_factory(), exports);
    var isObjectNode = (node) => node?.type === "Object";
    exports.isObjectNode = isObjectNode;
    var isArrayNode = (node) => node?.type === "Array";
    exports.isArrayNode = isArrayNode;
    var isPropertyNode = (node) => node?.type === "Property";
    exports.isPropertyNode = isPropertyNode;
    exports.Modes = ["theme", "app"];
    var SourceCodeType;
    (function(SourceCodeType2) {
      SourceCodeType2.JSON = "JSON", SourceCodeType2.LiquidHtml = "LiquidHtml";
    })(SourceCodeType = exports.SourceCodeType || (exports.SourceCodeType = {}));
    var Severity3;
    (function(Severity4) {
      Severity4[Severity4.ERROR = 0] = "ERROR", Severity4[Severity4.WARNING = 1] = "WARNING", Severity4[Severity4.INFO = 2] = "INFO";
    })(Severity3 = exports.Severity || (exports.Severity = {}));
    var ConfigTarget;
    (function(ConfigTarget2) {
      ConfigTarget2.All = "all", ConfigTarget2.Recommended = "recommended", ConfigTarget2.ThemeAppExtension = "theme-app-extension";
    })(ConfigTarget = exports.ConfigTarget || (exports.ConfigTarget = {}));
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/visitors/liquid.js
var require_liquid = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/visitors/liquid.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.visitLiquid = void 0;
    var liquid_html_parser_1 = require_dist();
    function isLiquidHtmlNode(thing) {
      return !!thing && typeof thing == "object" && "type" in thing;
    }
    async function visitLiquid(node, check2) {
      let stack = [{ node, ancestors: [] }], method;
      for (; stack.length > 0; ) {
        let { node: node2, ancestors } = stack.pop(), lineage = ancestors.concat(node2);
        method = check2[node2.type], method && await method(node2, ancestors);
        for (let key in node2) {
          if (!node2.hasOwnProperty(key) || liquid_html_parser_1.nonTraversableProperties.has(key))
            continue;
          let value = node2[key];
          if (Array.isArray(value))
            for (let i = value.length - 1; i >= 0; i--) {
              let item = value[i];
              isLiquidHtmlNode(item) && stack.push({ node: item, ancestors: lineage });
            }
          else
            isLiquidHtmlNode(value) && stack.push({ node: value, ancestors: lineage });
        }
        method = check2[`${node2.type}:exit`], method && await method(node2, ancestors);
      }
    }
    exports.visitLiquid = visitLiquid;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/visitors/json.js
var require_json = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/visitors/json.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.visitJSON = void 0;
    function isJSONNode(thing) {
      return !!thing && typeof thing == "object" && "type" in thing;
    }
    var nonTraversableProperties = /* @__PURE__ */ new Set(["loc"]);
    async function visitJSON(node, check2) {
      let stack = [{ node, ancestors: [] }], method;
      for (; stack.length > 0; ) {
        let { node: node2, ancestors } = stack.pop(), lineage = ancestors.concat(node2);
        method = check2[node2.type], method && await method(node2, ancestors);
        for (let key in node2) {
          if (!node2.hasOwnProperty(key) || nonTraversableProperties.has(key))
            continue;
          let value = node2[key];
          if (Array.isArray(value))
            for (let i = value.length - 1; i >= 0; i--) {
              let item = value[i];
              isJSONNode(item) && stack.push({ node: item, ancestors: lineage });
            }
          else
            isJSONNode(value) && stack.push({ node: value, ancestors: lineage });
        }
        method = check2[`${node2.type}:exit`], method && await method(node2, ancestors);
      }
    }
    exports.visitJSON = visitJSON;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/visitors/index.js
var require_visitors = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/visitors/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.visitJSON = exports.visitLiquid = void 0;
    var liquid_1 = require_liquid();
    Object.defineProperty(exports, "visitLiquid", { enumerable: !0, get: function() {
      return liquid_1.visitLiquid;
    } });
    var json_1 = require_json();
    Object.defineProperty(exports, "visitJSON", { enumerable: !0, get: function() {
      return json_1.visitJSON;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/disabled-checks/index.js
var require_disabled_checks = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/disabled-checks/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.createDisabledChecksModule = void 0;
    function createDisabledChecksModule() {
      let SPECIFIC_CHECK_NOT_DEFINED = "@all", INLINE_COMMENT_TAG = "#", disabledChecks = /* @__PURE__ */ new Map();
      function determineRanges(absolutePath, value, position) {
        let [_2, command, checksJoined] = value.trim().match(/^(?:theme\-check\-(disable|enable)) ?(.*)/) || [];
        (checksJoined ? checksJoined.split(/,[ ]*/) : [SPECIFIC_CHECK_NOT_DEFINED]).forEach((check2) => {
          let disabledRanges = disabledChecks.get(absolutePath);
          if (command === "disable" && (disabledRanges.has(check2) || disabledRanges.set(check2, []), disabledRanges.get(check2).push({ from: position.end })), command === "enable") {
            let disabledRangesForCheck = disabledRanges.get(check2);
            if (disabledRangesForCheck)
              disabledRangesForCheck[disabledRangesForCheck.length - 1].to = position.start;
            else if (check2 === SPECIFIC_CHECK_NOT_DEFINED)
              for (let ranges of disabledRanges.values())
                for (let range of ranges)
                  range.to || (range.to = position.start);
          }
        });
      }
      let DisabledChecksVisitor = {
        meta: { schema: {} },
        create: ({ file }) => ({
          async onCodePathStart() {
            disabledChecks.set(file.absolutePath, /* @__PURE__ */ new Map());
          },
          async LiquidRawTag(node) {
            node.name === "comment" && determineRanges(file.absolutePath, node.body.value, node.position);
          },
          async LiquidTag(node) {
            typeof node.markup != "string" || node.name !== INLINE_COMMENT_TAG || determineRanges(file.absolutePath, node.markup, node.position);
          }
        })
      };
      function isDisabled(offense) {
        return [SPECIFIC_CHECK_NOT_DEFINED, offense.check].flatMap((check2) => disabledChecks.has(offense.absolutePath) ? disabledChecks.get(offense.absolutePath).has(check2) ? disabledChecks.get(offense.absolutePath).get(check2) : [] : []).some((range) => offense.start.index >= range.from && (!range.to || offense.end.index <= range.to));
      }
      return {
        DisabledChecksVisitor,
        isDisabled
      };
    }
    exports.createDisabledChecksModule = createDisabledChecksModule;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/path.js
var require_path = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/path.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.join = exports.relative = void 0;
    function relative(absolutePath, root) {
      return absolutePath.replace(root, "").replace(/^\//, "");
    }
    exports.relative = relative;
    function join6(...paths) {
      return paths.map(removeTrailingSlash2).join("/");
    }
    exports.join = join6;
    function removeTrailingSlash2(path3) {
      return path3.replace(/\/+$/, "");
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/utils/array.js
var require_array = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/utils/array.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.findLastAndIndex = exports.findLastIndex = exports.findLast = exports.last = exports.first = void 0;
    function first(arr) {
      return arr[0];
    }
    exports.first = first;
    function last(arr, offset = 0) {
      return arr[arr.length - 1 + offset];
    }
    exports.last = last;
    function findLast(array, pred) {
      return array[findLastIndex(array, pred)];
    }
    exports.findLast = findLast;
    function findLastIndex(array, pred) {
      for (let i = array.length - 1; i >= 0; i--)
        if (pred(array[i]))
          return i;
      return -1;
    }
    exports.findLastIndex = findLastIndex;
    function findLastAndIndex(array, pred) {
      let index = findLastIndex(array, pred);
      return [array[index], index];
    }
    exports.findLastAndIndex = findLastAndIndex;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/utils/position.js
var require_position = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/utils/position.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.getOffset = exports.getPosition = void 0;
    var line_column_1 = __importDefault(require_line_column());
    function getPosition(source, index) {
      let lineCol = (0, line_column_1.default)(source, { origin: 0 }).fromIndex(Math.min(index, source.length - 1));
      return {
        index,
        line: lineCol ? lineCol.line : -1,
        character: lineCol ? lineCol.col : -1
      };
    }
    exports.getPosition = getPosition;
    function getOffset(source, line, column) {
      return (0, line_column_1.default)(source, { origin: 1 }).toIndex(line, column);
    }
    exports.getOffset = getOffset;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/utils/error.js
var require_error = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/utils/error.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.asError = exports.isError = void 0;
    var PARSE_ERROR_MESSAGES = {
      1: "Invalid symbol found in the input.",
      2: "Invalid number format detected.",
      3: "Property name expected but not found.",
      4: "A value was expected but not found.",
      5: "Colon `:` expected after the property name.",
      6: "Comma `,` expected between elements and properties.",
      7: "Closing brace `}` expected.",
      8: "Closing bracket `]` expected.",
      9: "End of file expected.",
      10: "Invalid comment token found.",
      11: "Unexpected end of comment.",
      12: "Unexpected end of string.",
      13: "Unexpected end of number.",
      14: "Invalid Unicode escape sequence.",
      15: "Invalid escape character found.",
      16: "Invalid character found in the input."
    };
    function isError2(error) {
      return error instanceof Error;
    }
    exports.isError = isError2;
    function asError(error) {
      return error instanceof Error ? error : typeof error == "string" ? new Error(error) : error && typeof error == "object" && "error" in error ? new Error(getParseErrorMessage(error)) : error && typeof error.toString == "function" ? new Error(error.toString()) : new Error("An unknown error occurred");
    }
    exports.asError = asError;
    function getParseErrorMessage(parseError) {
      return PARSE_ERROR_MESSAGES[parseError.error] || "Unknown parse error.";
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/utils/types.js
var require_types3 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/utils/types.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.assertNever = void 0;
    function assertNever(x) {
      throw new Error(`We should never reach this code, you are missing a case for ${x}`);
    }
    exports.assertNever = assertNever;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/utils/memo.js
var require_memo = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/utils/memo.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.memoize = exports.memo = void 0;
    var Unset = Symbol("Unset");
    function memo(fn) {
      let cachedValue = Unset, memoedFunction = (...args) => (cachedValue === Unset && (cachedValue = fn(...args)), cachedValue);
      return memoedFunction.clearCache = () => {
        cachedValue = Unset;
      }, memoedFunction;
    }
    exports.memo = memo;
    function memoize(fn, keyFn) {
      let cache2 = {};
      return (arg) => {
        let key = keyFn(arg);
        return cache2[key] || (cache2[key] = fn(arg)), cache2[key];
      };
    }
    exports.memoize = memoize;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/utils/indexBy.js
var require_indexBy = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/utils/indexBy.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.indexBy = void 0;
    function indexBy(keyFn, collection) {
      let record = {};
      for (let item of collection)
        record[keyFn(item)] = item;
      return record;
    }
    exports.indexBy = indexBy;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/utils/index.js
var require_utils2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/utils/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p) && __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    __exportStar(require_array(), exports);
    __exportStar(require_position(), exports);
    __exportStar(require_error(), exports);
    __exportStar(require_types3(), exports);
    __exportStar(require_memo(), exports);
    __exportStar(require_indexBy(), exports);
  }
});

// ../../node_modules/.pnpm/minimatch@9.0.3/node_modules/minimatch/dist/cjs/assert-valid-pattern.js
var require_assert_valid_pattern = __commonJS({
  "../../node_modules/.pnpm/minimatch@9.0.3/node_modules/minimatch/dist/cjs/assert-valid-pattern.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.assertValidPattern = void 0;
    var MAX_PATTERN_LENGTH = 1024 * 64, assertValidPattern = (pattern) => {
      if (typeof pattern != "string")
        throw new TypeError("invalid pattern");
      if (pattern.length > MAX_PATTERN_LENGTH)
        throw new TypeError("pattern is too long");
    };
    exports.assertValidPattern = assertValidPattern;
  }
});

// ../../node_modules/.pnpm/minimatch@9.0.3/node_modules/minimatch/dist/cjs/brace-expressions.js
var require_brace_expressions = __commonJS({
  "../../node_modules/.pnpm/minimatch@9.0.3/node_modules/minimatch/dist/cjs/brace-expressions.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.parseClass = void 0;
    var posixClasses = {
      "[:alnum:]": ["\\p{L}\\p{Nl}\\p{Nd}", !0],
      "[:alpha:]": ["\\p{L}\\p{Nl}", !0],
      "[:ascii:]": ["\\x00-\\x7f", !1],
      "[:blank:]": ["\\p{Zs}\\t", !0],
      "[:cntrl:]": ["\\p{Cc}", !0],
      "[:digit:]": ["\\p{Nd}", !0],
      "[:graph:]": ["\\p{Z}\\p{C}", !0, !0],
      "[:lower:]": ["\\p{Ll}", !0],
      "[:print:]": ["\\p{C}", !0],
      "[:punct:]": ["\\p{P}", !0],
      "[:space:]": ["\\p{Z}\\t\\r\\n\\v\\f", !0],
      "[:upper:]": ["\\p{Lu}", !0],
      "[:word:]": ["\\p{L}\\p{Nl}\\p{Nd}\\p{Pc}", !0],
      "[:xdigit:]": ["A-Fa-f0-9", !1]
    }, braceEscape = (s) => s.replace(/[[\]\\-]/g, "\\$&"), regexpEscape = (s) => s.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&"), rangesToString = (ranges) => ranges.join(""), parseClass = (glob2, position) => {
      let pos = position;
      if (glob2.charAt(pos) !== "[")
        throw new Error("not in a brace expression");
      let ranges = [], negs = [], i = pos + 1, sawStart = !1, uflag = !1, escaping = !1, negate = !1, endPos = pos, rangeStart = "";
      WHILE:
        for (; i < glob2.length; ) {
          let c = glob2.charAt(i);
          if ((c === "!" || c === "^") && i === pos + 1) {
            negate = !0, i++;
            continue;
          }
          if (c === "]" && sawStart && !escaping) {
            endPos = i + 1;
            break;
          }
          if (sawStart = !0, c === "\\" && !escaping) {
            escaping = !0, i++;
            continue;
          }
          if (c === "[" && !escaping) {
            for (let [cls, [unip, u, neg]] of Object.entries(posixClasses))
              if (glob2.startsWith(cls, i)) {
                if (rangeStart)
                  return ["$.", !1, glob2.length - pos, !0];
                i += cls.length, neg ? negs.push(unip) : ranges.push(unip), uflag = uflag || u;
                continue WHILE;
              }
          }
          if (escaping = !1, rangeStart) {
            c > rangeStart ? ranges.push(braceEscape(rangeStart) + "-" + braceEscape(c)) : c === rangeStart && ranges.push(braceEscape(c)), rangeStart = "", i++;
            continue;
          }
          if (glob2.startsWith("-]", i + 1)) {
            ranges.push(braceEscape(c + "-")), i += 2;
            continue;
          }
          if (glob2.startsWith("-", i + 1)) {
            rangeStart = c, i += 2;
            continue;
          }
          ranges.push(braceEscape(c)), i++;
        }
      if (endPos < i)
        return ["", !1, 0, !1];
      if (!ranges.length && !negs.length)
        return ["$.", !1, glob2.length - pos, !0];
      if (negs.length === 0 && ranges.length === 1 && /^\\?.$/.test(ranges[0]) && !negate) {
        let r2 = ranges[0].length === 2 ? ranges[0].slice(-1) : ranges[0];
        return [regexpEscape(r2), !1, endPos - pos, !1];
      }
      let sranges = "[" + (negate ? "^" : "") + rangesToString(ranges) + "]", snegs = "[" + (negate ? "" : "^") + rangesToString(negs) + "]";
      return [ranges.length && negs.length ? "(" + sranges + "|" + snegs + ")" : ranges.length ? sranges : snegs, uflag, endPos - pos, !0];
    };
    exports.parseClass = parseClass;
  }
});

// ../../node_modules/.pnpm/minimatch@9.0.3/node_modules/minimatch/dist/cjs/unescape.js
var require_unescape = __commonJS({
  "../../node_modules/.pnpm/minimatch@9.0.3/node_modules/minimatch/dist/cjs/unescape.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.unescape = void 0;
    var unescape3 = (s, { windowsPathsNoEscape = !1 } = {}) => windowsPathsNoEscape ? s.replace(/\[([^\/\\])\]/g, "$1") : s.replace(/((?!\\).|^)\[([^\/\\])\]/g, "$1$2").replace(/\\([^\/])/g, "$1");
    exports.unescape = unescape3;
  }
});

// ../../node_modules/.pnpm/minimatch@9.0.3/node_modules/minimatch/dist/cjs/ast.js
var require_ast = __commonJS({
  "../../node_modules/.pnpm/minimatch@9.0.3/node_modules/minimatch/dist/cjs/ast.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.AST = void 0;
    var brace_expressions_js_1 = require_brace_expressions(), unescape_js_1 = require_unescape(), types = /* @__PURE__ */ new Set(["!", "?", "+", "*", "@"]), isExtglobType = (c) => types.has(c), startNoTraversal = "(?!(?:^|/)\\.\\.?(?:$|/))", startNoDot = "(?!\\.)", addPatternStart = /* @__PURE__ */ new Set(["[", "."]), justDots = /* @__PURE__ */ new Set(["..", "."]), reSpecials = new Set("().*{}+?[]^$\\!"), regExpEscape = (s) => s.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&"), qmark = "[^/]", star = qmark + "*?", starNoEmpty = qmark + "+?", AST = class _AST {
      type;
      #root;
      #hasMagic;
      #uflag = !1;
      #parts = [];
      #parent;
      #parentIndex;
      #negs;
      #filledNegs = !1;
      #options;
      #toString;
      // set to true if it's an extglob with no children
      // (which really means one child of '')
      #emptyExt = !1;
      constructor(type, parent, options = {}) {
        this.type = type, type && (this.#hasMagic = !0), this.#parent = parent, this.#root = this.#parent ? this.#parent.#root : this, this.#options = this.#root === this ? options : this.#root.#options, this.#negs = this.#root === this ? [] : this.#root.#negs, type === "!" && !this.#root.#filledNegs && this.#negs.push(this), this.#parentIndex = this.#parent ? this.#parent.#parts.length : 0;
      }
      get hasMagic() {
        if (this.#hasMagic !== void 0)
          return this.#hasMagic;
        for (let p of this.#parts)
          if (typeof p != "string" && (p.type || p.hasMagic))
            return this.#hasMagic = !0;
        return this.#hasMagic;
      }
      // reconstructs the pattern
      toString() {
        return this.#toString !== void 0 ? this.#toString : this.type ? this.#toString = this.type + "(" + this.#parts.map((p) => String(p)).join("|") + ")" : this.#toString = this.#parts.map((p) => String(p)).join("");
      }
      #fillNegs() {
        if (this !== this.#root)
          throw new Error("should only call on root");
        if (this.#filledNegs)
          return this;
        this.toString(), this.#filledNegs = !0;
        let n;
        for (; n = this.#negs.pop(); ) {
          if (n.type !== "!")
            continue;
          let p = n, pp = p.#parent;
          for (; pp; ) {
            for (let i = p.#parentIndex + 1; !pp.type && i < pp.#parts.length; i++)
              for (let part of n.#parts) {
                if (typeof part == "string")
                  throw new Error("string part in extglob AST??");
                part.copyIn(pp.#parts[i]);
              }
            p = pp, pp = p.#parent;
          }
        }
        return this;
      }
      push(...parts) {
        for (let p of parts)
          if (p !== "") {
            if (typeof p != "string" && !(p instanceof _AST && p.#parent === this))
              throw new Error("invalid part: " + p);
            this.#parts.push(p);
          }
      }
      toJSON() {
        let ret = this.type === null ? this.#parts.slice().map((p) => typeof p == "string" ? p : p.toJSON()) : [this.type, ...this.#parts.map((p) => p.toJSON())];
        return this.isStart() && !this.type && ret.unshift([]), this.isEnd() && (this === this.#root || this.#root.#filledNegs && this.#parent?.type === "!") && ret.push({}), ret;
      }
      isStart() {
        if (this.#root === this)
          return !0;
        if (!this.#parent?.isStart())
          return !1;
        if (this.#parentIndex === 0)
          return !0;
        let p = this.#parent;
        for (let i = 0; i < this.#parentIndex; i++) {
          let pp = p.#parts[i];
          if (!(pp instanceof _AST && pp.type === "!"))
            return !1;
        }
        return !0;
      }
      isEnd() {
        if (this.#root === this || this.#parent?.type === "!")
          return !0;
        if (!this.#parent?.isEnd())
          return !1;
        if (!this.type)
          return this.#parent?.isEnd();
        let pl = this.#parent ? this.#parent.#parts.length : 0;
        return this.#parentIndex === pl - 1;
      }
      copyIn(part) {
        typeof part == "string" ? this.push(part) : this.push(part.clone(this));
      }
      clone(parent) {
        let c = new _AST(this.type, parent);
        for (let p of this.#parts)
          c.copyIn(p);
        return c;
      }
      static #parseAST(str, ast, pos, opt) {
        let escaping = !1, inBrace = !1, braceStart = -1, braceNeg = !1;
        if (ast.type === null) {
          let i2 = pos, acc2 = "";
          for (; i2 < str.length; ) {
            let c = str.charAt(i2++);
            if (escaping || c === "\\") {
              escaping = !escaping, acc2 += c;
              continue;
            }
            if (inBrace) {
              i2 === braceStart + 1 ? (c === "^" || c === "!") && (braceNeg = !0) : c === "]" && !(i2 === braceStart + 2 && braceNeg) && (inBrace = !1), acc2 += c;
              continue;
            } else if (c === "[") {
              inBrace = !0, braceStart = i2, braceNeg = !1, acc2 += c;
              continue;
            }
            if (!opt.noext && isExtglobType(c) && str.charAt(i2) === "(") {
              ast.push(acc2), acc2 = "";
              let ext = new _AST(c, ast);
              i2 = _AST.#parseAST(str, ext, i2, opt), ast.push(ext);
              continue;
            }
            acc2 += c;
          }
          return ast.push(acc2), i2;
        }
        let i = pos + 1, part = new _AST(null, ast), parts = [], acc = "";
        for (; i < str.length; ) {
          let c = str.charAt(i++);
          if (escaping || c === "\\") {
            escaping = !escaping, acc += c;
            continue;
          }
          if (inBrace) {
            i === braceStart + 1 ? (c === "^" || c === "!") && (braceNeg = !0) : c === "]" && !(i === braceStart + 2 && braceNeg) && (inBrace = !1), acc += c;
            continue;
          } else if (c === "[") {
            inBrace = !0, braceStart = i, braceNeg = !1, acc += c;
            continue;
          }
          if (isExtglobType(c) && str.charAt(i) === "(") {
            part.push(acc), acc = "";
            let ext = new _AST(c, part);
            part.push(ext), i = _AST.#parseAST(str, ext, i, opt);
            continue;
          }
          if (c === "|") {
            part.push(acc), acc = "", parts.push(part), part = new _AST(null, ast);
            continue;
          }
          if (c === ")")
            return acc === "" && ast.#parts.length === 0 && (ast.#emptyExt = !0), part.push(acc), acc = "", ast.push(...parts, part), i;
          acc += c;
        }
        return ast.type = null, ast.#hasMagic = void 0, ast.#parts = [str.substring(pos - 1)], i;
      }
      static fromGlob(pattern, options = {}) {
        let ast = new _AST(null, void 0, options);
        return _AST.#parseAST(pattern, ast, 0, options), ast;
      }
      // returns the regular expression if there's magic, or the unescaped
      // string if not.
      toMMPattern() {
        if (this !== this.#root)
          return this.#root.toMMPattern();
        let glob2 = this.toString(), [re, body, hasMagic, uflag] = this.toRegExpSource();
        if (!(hasMagic || this.#hasMagic || this.#options.nocase && !this.#options.nocaseMagicOnly && glob2.toUpperCase() !== glob2.toLowerCase()))
          return body;
        let flags = (this.#options.nocase ? "i" : "") + (uflag ? "u" : "");
        return Object.assign(new RegExp(`^${re}$`, flags), {
          _src: re,
          _glob: glob2
        });
      }
      // returns the string match, the regexp source, whether there's magic
      // in the regexp (so a regular expression is required) and whether or
      // not the uflag is needed for the regular expression (for posix classes)
      // TODO: instead of injecting the start/end at this point, just return
      // the BODY of the regexp, along with the start/end portions suitable
      // for binding the start/end in either a joined full-path makeRe context
      // (where we bind to (^|/), or a standalone matchPart context (where
      // we bind to ^, and not /).  Otherwise slashes get duped!
      //
      // In part-matching mode, the start is:
      // - if not isStart: nothing
      // - if traversal possible, but not allowed: ^(?!\.\.?$)
      // - if dots allowed or not possible: ^
      // - if dots possible and not allowed: ^(?!\.)
      // end is:
      // - if not isEnd(): nothing
      // - else: $
      //
      // In full-path matching mode, we put the slash at the START of the
      // pattern, so start is:
      // - if first pattern: same as part-matching mode
      // - if not isStart(): nothing
      // - if traversal possible, but not allowed: /(?!\.\.?(?:$|/))
      // - if dots allowed or not possible: /
      // - if dots possible and not allowed: /(?!\.)
      // end is:
      // - if last pattern, same as part-matching mode
      // - else nothing
      //
      // Always put the (?:$|/) on negated tails, though, because that has to be
      // there to bind the end of the negated pattern portion, and it's easier to
      // just stick it in now rather than try to inject it later in the middle of
      // the pattern.
      //
      // We can just always return the same end, and leave it up to the caller
      // to know whether it's going to be used joined or in parts.
      // And, if the start is adjusted slightly, can do the same there:
      // - if not isStart: nothing
      // - if traversal possible, but not allowed: (?:/|^)(?!\.\.?$)
      // - if dots allowed or not possible: (?:/|^)
      // - if dots possible and not allowed: (?:/|^)(?!\.)
      //
      // But it's better to have a simpler binding without a conditional, for
      // performance, so probably better to return both start options.
      //
      // Then the caller just ignores the end if it's not the first pattern,
      // and the start always gets applied.
      //
      // But that's always going to be $ if it's the ending pattern, or nothing,
      // so the caller can just attach $ at the end of the pattern when building.
      //
      // So the todo is:
      // - better detect what kind of start is needed
      // - return both flavors of starting pattern
      // - attach $ at the end of the pattern when creating the actual RegExp
      //
      // Ah, but wait, no, that all only applies to the root when the first pattern
      // is not an extglob. If the first pattern IS an extglob, then we need all
      // that dot prevention biz to live in the extglob portions, because eg
      // +(*|.x*) can match .xy but not .yx.
      //
      // So, return the two flavors if it's #root and the first child is not an
      // AST, otherwise leave it to the child AST to handle it, and there,
      // use the (?:^|/) style of start binding.
      //
      // Even simplified further:
      // - Since the start for a join is eg /(?!\.) and the start for a part
      // is ^(?!\.), we can just prepend (?!\.) to the pattern (either root
      // or start or whatever) and prepend ^ or / at the Regexp construction.
      toRegExpSource(allowDot) {
        let dot = allowDot ?? !!this.#options.dot;
        if (this.#root === this && this.#fillNegs(), !this.type) {
          let noEmpty = this.isStart() && this.isEnd(), src = this.#parts.map((p) => {
            let [re, _2, hasMagic, uflag] = typeof p == "string" ? _AST.#parseGlob(p, this.#hasMagic, noEmpty) : p.toRegExpSource(allowDot);
            return this.#hasMagic = this.#hasMagic || hasMagic, this.#uflag = this.#uflag || uflag, re;
          }).join(""), start2 = "";
          if (this.isStart() && typeof this.#parts[0] == "string" && !(this.#parts.length === 1 && justDots.has(this.#parts[0]))) {
            let aps = addPatternStart, needNoTrav = (
              // dots are allowed, and the pattern starts with [ or .
              dot && aps.has(src.charAt(0)) || // the pattern starts with \., and then [ or .
              src.startsWith("\\.") && aps.has(src.charAt(2)) || // the pattern starts with \.\., and then [ or .
              src.startsWith("\\.\\.") && aps.has(src.charAt(4))
            ), needNoDot = !dot && !allowDot && aps.has(src.charAt(0));
            start2 = needNoTrav ? startNoTraversal : needNoDot ? startNoDot : "";
          }
          let end = "";
          return this.isEnd() && this.#root.#filledNegs && this.#parent?.type === "!" && (end = "(?:$|\\/)"), [
            start2 + src + end,
            (0, unescape_js_1.unescape)(src),
            this.#hasMagic = !!this.#hasMagic,
            this.#uflag
          ];
        }
        let repeated = this.type === "*" || this.type === "+", start = this.type === "!" ? "(?:(?!(?:" : "(?:", body = this.#partsToRegExp(dot);
        if (this.isStart() && this.isEnd() && !body && this.type !== "!") {
          let s = this.toString();
          return this.#parts = [s], this.type = null, this.#hasMagic = void 0, [s, (0, unescape_js_1.unescape)(this.toString()), !1, !1];
        }
        let bodyDotAllowed = !repeated || allowDot || dot || !startNoDot ? "" : this.#partsToRegExp(!0);
        bodyDotAllowed === body && (bodyDotAllowed = ""), bodyDotAllowed && (body = `(?:${body})(?:${bodyDotAllowed})*?`);
        let final = "";
        if (this.type === "!" && this.#emptyExt)
          final = (this.isStart() && !dot ? startNoDot : "") + starNoEmpty;
        else {
          let close = this.type === "!" ? (
            // !() must match something,but !(x) can match ''
            "))" + (this.isStart() && !dot && !allowDot ? startNoDot : "") + star + ")"
          ) : this.type === "@" ? ")" : this.type === "?" ? ")?" : this.type === "+" && bodyDotAllowed ? ")" : this.type === "*" && bodyDotAllowed ? ")?" : `)${this.type}`;
          final = start + body + close;
        }
        return [
          final,
          (0, unescape_js_1.unescape)(body),
          this.#hasMagic = !!this.#hasMagic,
          this.#uflag
        ];
      }
      #partsToRegExp(dot) {
        return this.#parts.map((p) => {
          if (typeof p == "string")
            throw new Error("string type in extglob ast??");
          let [re, _2, _hasMagic, uflag] = p.toRegExpSource(dot);
          return this.#uflag = this.#uflag || uflag, re;
        }).filter((p) => !(this.isStart() && this.isEnd()) || !!p).join("|");
      }
      static #parseGlob(glob2, hasMagic, noEmpty = !1) {
        let escaping = !1, re = "", uflag = !1;
        for (let i = 0; i < glob2.length; i++) {
          let c = glob2.charAt(i);
          if (escaping) {
            escaping = !1, re += (reSpecials.has(c) ? "\\" : "") + c;
            continue;
          }
          if (c === "\\") {
            i === glob2.length - 1 ? re += "\\\\" : escaping = !0;
            continue;
          }
          if (c === "[") {
            let [src, needUflag, consumed, magic] = (0, brace_expressions_js_1.parseClass)(glob2, i);
            if (consumed) {
              re += src, uflag = uflag || needUflag, i += consumed - 1, hasMagic = hasMagic || magic;
              continue;
            }
          }
          if (c === "*") {
            noEmpty && glob2 === "*" ? re += starNoEmpty : re += star, hasMagic = !0;
            continue;
          }
          if (c === "?") {
            re += qmark, hasMagic = !0;
            continue;
          }
          re += regExpEscape(c);
        }
        return [re, (0, unescape_js_1.unescape)(glob2), !!hasMagic, uflag];
      }
    };
    exports.AST = AST;
  }
});

// ../../node_modules/.pnpm/minimatch@9.0.3/node_modules/minimatch/dist/cjs/escape.js
var require_escape = __commonJS({
  "../../node_modules/.pnpm/minimatch@9.0.3/node_modules/minimatch/dist/cjs/escape.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.escape = void 0;
    var escape2 = (s, { windowsPathsNoEscape = !1 } = {}) => windowsPathsNoEscape ? s.replace(/[?*()[\]]/g, "[$&]") : s.replace(/[?*()[\]\\]/g, "\\$&");
    exports.escape = escape2;
  }
});

// ../../node_modules/.pnpm/minimatch@9.0.3/node_modules/minimatch/dist/cjs/index.js
var require_cjs = __commonJS({
  "../../node_modules/.pnpm/minimatch@9.0.3/node_modules/minimatch/dist/cjs/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.unescape = exports.escape = exports.AST = exports.Minimatch = exports.match = exports.makeRe = exports.braceExpand = exports.defaults = exports.filter = exports.GLOBSTAR = exports.sep = exports.minimatch = void 0;
    var brace_expansion_1 = __importDefault(require_brace_expansion()), assert_valid_pattern_js_1 = require_assert_valid_pattern(), ast_js_1 = require_ast(), escape_js_1 = require_escape(), unescape_js_1 = require_unescape(), minimatch = (p, pattern, options = {}) => ((0, assert_valid_pattern_js_1.assertValidPattern)(pattern), !options.nocomment && pattern.charAt(0) === "#" ? !1 : new Minimatch(pattern, options).match(p));
    exports.minimatch = minimatch;
    var starDotExtRE = /^\*+([^+@!?\*\[\(]*)$/, starDotExtTest = (ext2) => (f) => !f.startsWith(".") && f.endsWith(ext2), starDotExtTestDot = (ext2) => (f) => f.endsWith(ext2), starDotExtTestNocase = (ext2) => (ext2 = ext2.toLowerCase(), (f) => !f.startsWith(".") && f.toLowerCase().endsWith(ext2)), starDotExtTestNocaseDot = (ext2) => (ext2 = ext2.toLowerCase(), (f) => f.toLowerCase().endsWith(ext2)), starDotStarRE = /^\*+\.\*+$/, starDotStarTest = (f) => !f.startsWith(".") && f.includes("."), starDotStarTestDot = (f) => f !== "." && f !== ".." && f.includes("."), dotStarRE = /^\.\*+$/, dotStarTest = (f) => f !== "." && f !== ".." && f.startsWith("."), starRE = /^\*+$/, starTest = (f) => f.length !== 0 && !f.startsWith("."), starTestDot = (f) => f.length !== 0 && f !== "." && f !== "..", qmarksRE = /^\?+([^+@!?\*\[\(]*)?$/, qmarksTestNocase = ([$0, ext2 = ""]) => {
      let noext = qmarksTestNoExt([$0]);
      return ext2 ? (ext2 = ext2.toLowerCase(), (f) => noext(f) && f.toLowerCase().endsWith(ext2)) : noext;
    }, qmarksTestNocaseDot = ([$0, ext2 = ""]) => {
      let noext = qmarksTestNoExtDot([$0]);
      return ext2 ? (ext2 = ext2.toLowerCase(), (f) => noext(f) && f.toLowerCase().endsWith(ext2)) : noext;
    }, qmarksTestDot = ([$0, ext2 = ""]) => {
      let noext = qmarksTestNoExtDot([$0]);
      return ext2 ? (f) => noext(f) && f.endsWith(ext2) : noext;
    }, qmarksTest = ([$0, ext2 = ""]) => {
      let noext = qmarksTestNoExt([$0]);
      return ext2 ? (f) => noext(f) && f.endsWith(ext2) : noext;
    }, qmarksTestNoExt = ([$0]) => {
      let len = $0.length;
      return (f) => f.length === len && !f.startsWith(".");
    }, qmarksTestNoExtDot = ([$0]) => {
      let len = $0.length;
      return (f) => f.length === len && f !== "." && f !== "..";
    }, defaultPlatform = typeof process == "object" && process ? typeof process.env == "object" && process.env && process.env.__MINIMATCH_TESTING_PLATFORM__ || process.platform : "posix", path3 = {
      win32: { sep: "\\" },
      posix: { sep: "/" }
    };
    exports.sep = defaultPlatform === "win32" ? path3.win32.sep : path3.posix.sep;
    exports.minimatch.sep = exports.sep;
    exports.GLOBSTAR = Symbol("globstar **");
    exports.minimatch.GLOBSTAR = exports.GLOBSTAR;
    var qmark = "[^/]", star = qmark + "*?", twoStarDot = "(?:(?!(?:\\/|^)(?:\\.{1,2})($|\\/)).)*?", twoStarNoDot = "(?:(?!(?:\\/|^)\\.).)*?", filter = (pattern, options = {}) => (p) => (0, exports.minimatch)(p, pattern, options);
    exports.filter = filter;
    exports.minimatch.filter = exports.filter;
    var ext = (a, b = {}) => Object.assign({}, a, b), defaults = (def) => {
      if (!def || typeof def != "object" || !Object.keys(def).length)
        return exports.minimatch;
      let orig = exports.minimatch;
      return Object.assign((p, pattern, options = {}) => orig(p, pattern, ext(def, options)), {
        Minimatch: class extends orig.Minimatch {
          constructor(pattern, options = {}) {
            super(pattern, ext(def, options));
          }
          static defaults(options) {
            return orig.defaults(ext(def, options)).Minimatch;
          }
        },
        AST: class extends orig.AST {
          /* c8 ignore start */
          constructor(type, parent, options = {}) {
            super(type, parent, ext(def, options));
          }
          /* c8 ignore stop */
          static fromGlob(pattern, options = {}) {
            return orig.AST.fromGlob(pattern, ext(def, options));
          }
        },
        unescape: (s, options = {}) => orig.unescape(s, ext(def, options)),
        escape: (s, options = {}) => orig.escape(s, ext(def, options)),
        filter: (pattern, options = {}) => orig.filter(pattern, ext(def, options)),
        defaults: (options) => orig.defaults(ext(def, options)),
        makeRe: (pattern, options = {}) => orig.makeRe(pattern, ext(def, options)),
        braceExpand: (pattern, options = {}) => orig.braceExpand(pattern, ext(def, options)),
        match: (list2, pattern, options = {}) => orig.match(list2, pattern, ext(def, options)),
        sep: orig.sep,
        GLOBSTAR: exports.GLOBSTAR
      });
    };
    exports.defaults = defaults;
    exports.minimatch.defaults = exports.defaults;
    var braceExpand = (pattern, options = {}) => ((0, assert_valid_pattern_js_1.assertValidPattern)(pattern), options.nobrace || !/\{(?:(?!\{).)*\}/.test(pattern) ? [pattern] : (0, brace_expansion_1.default)(pattern));
    exports.braceExpand = braceExpand;
    exports.minimatch.braceExpand = exports.braceExpand;
    var makeRe = (pattern, options = {}) => new Minimatch(pattern, options).makeRe();
    exports.makeRe = makeRe;
    exports.minimatch.makeRe = exports.makeRe;
    var match2 = (list2, pattern, options = {}) => {
      let mm = new Minimatch(pattern, options);
      return list2 = list2.filter((f) => mm.match(f)), mm.options.nonull && !list2.length && list2.push(pattern), list2;
    };
    exports.match = match2;
    exports.minimatch.match = exports.match;
    var globMagic = /[?*]|[+@!]\(.*?\)|\[|\]/, regExpEscape = (s) => s.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&"), Minimatch = class {
      options;
      set;
      pattern;
      windowsPathsNoEscape;
      nonegate;
      negate;
      comment;
      empty;
      preserveMultipleSlashes;
      partial;
      globSet;
      globParts;
      nocase;
      isWindows;
      platform;
      windowsNoMagicRoot;
      regexp;
      constructor(pattern, options = {}) {
        (0, assert_valid_pattern_js_1.assertValidPattern)(pattern), options = options || {}, this.options = options, this.pattern = pattern, this.platform = options.platform || defaultPlatform, this.isWindows = this.platform === "win32", this.windowsPathsNoEscape = !!options.windowsPathsNoEscape || options.allowWindowsEscape === !1, this.windowsPathsNoEscape && (this.pattern = this.pattern.replace(/\\/g, "/")), this.preserveMultipleSlashes = !!options.preserveMultipleSlashes, this.regexp = null, this.negate = !1, this.nonegate = !!options.nonegate, this.comment = !1, this.empty = !1, this.partial = !!options.partial, this.nocase = !!this.options.nocase, this.windowsNoMagicRoot = options.windowsNoMagicRoot !== void 0 ? options.windowsNoMagicRoot : !!(this.isWindows && this.nocase), this.globSet = [], this.globParts = [], this.set = [], this.make();
      }
      hasMagic() {
        if (this.options.magicalBraces && this.set.length > 1)
          return !0;
        for (let pattern of this.set)
          for (let part of pattern)
            if (typeof part != "string")
              return !0;
        return !1;
      }
      debug(..._2) {
      }
      make() {
        let pattern = this.pattern, options = this.options;
        if (!options.nocomment && pattern.charAt(0) === "#") {
          this.comment = !0;
          return;
        }
        if (!pattern) {
          this.empty = !0;
          return;
        }
        this.parseNegate(), this.globSet = [...new Set(this.braceExpand())], options.debug && (this.debug = (...args) => console.error(...args)), this.debug(this.pattern, this.globSet);
        let rawGlobParts = this.globSet.map((s) => this.slashSplit(s));
        this.globParts = this.preprocess(rawGlobParts), this.debug(this.pattern, this.globParts);
        let set2 = this.globParts.map((s, _2, __) => {
          if (this.isWindows && this.windowsNoMagicRoot) {
            let isUNC = s[0] === "" && s[1] === "" && (s[2] === "?" || !globMagic.test(s[2])) && !globMagic.test(s[3]), isDrive = /^[a-z]:/i.test(s[0]);
            if (isUNC)
              return [...s.slice(0, 4), ...s.slice(4).map((ss) => this.parse(ss))];
            if (isDrive)
              return [s[0], ...s.slice(1).map((ss) => this.parse(ss))];
          }
          return s.map((ss) => this.parse(ss));
        });
        if (this.debug(this.pattern, set2), this.set = set2.filter((s) => s.indexOf(!1) === -1), this.isWindows)
          for (let i = 0; i < this.set.length; i++) {
            let p = this.set[i];
            p[0] === "" && p[1] === "" && this.globParts[i][2] === "?" && typeof p[3] == "string" && /^[a-z]:$/i.test(p[3]) && (p[2] = "?");
          }
        this.debug(this.pattern, this.set);
      }
      // various transforms to equivalent pattern sets that are
      // faster to process in a filesystem walk.  The goal is to
      // eliminate what we can, and push all ** patterns as far
      // to the right as possible, even if it increases the number
      // of patterns that we have to process.
      preprocess(globParts) {
        if (this.options.noglobstar)
          for (let i = 0; i < globParts.length; i++)
            for (let j = 0; j < globParts[i].length; j++)
              globParts[i][j] === "**" && (globParts[i][j] = "*");
        let { optimizationLevel = 1 } = this.options;
        return optimizationLevel >= 2 ? (globParts = this.firstPhasePreProcess(globParts), globParts = this.secondPhasePreProcess(globParts)) : optimizationLevel >= 1 ? globParts = this.levelOneOptimize(globParts) : globParts = this.adjascentGlobstarOptimize(globParts), globParts;
      }
      // just get rid of adjascent ** portions
      adjascentGlobstarOptimize(globParts) {
        return globParts.map((parts) => {
          let gs = -1;
          for (; (gs = parts.indexOf("**", gs + 1)) !== -1; ) {
            let i = gs;
            for (; parts[i + 1] === "**"; )
              i++;
            i !== gs && parts.splice(gs, i - gs);
          }
          return parts;
        });
      }
      // get rid of adjascent ** and resolve .. portions
      levelOneOptimize(globParts) {
        return globParts.map((parts) => (parts = parts.reduce((set2, part) => {
          let prev = set2[set2.length - 1];
          return part === "**" && prev === "**" ? set2 : part === ".." && prev && prev !== ".." && prev !== "." && prev !== "**" ? (set2.pop(), set2) : (set2.push(part), set2);
        }, []), parts.length === 0 ? [""] : parts));
      }
      levelTwoFileOptimize(parts) {
        Array.isArray(parts) || (parts = this.slashSplit(parts));
        let didSomething = !1;
        do {
          if (didSomething = !1, !this.preserveMultipleSlashes) {
            for (let i = 1; i < parts.length - 1; i++) {
              let p = parts[i];
              i === 1 && p === "" && parts[0] === "" || (p === "." || p === "") && (didSomething = !0, parts.splice(i, 1), i--);
            }
            parts[0] === "." && parts.length === 2 && (parts[1] === "." || parts[1] === "") && (didSomething = !0, parts.pop());
          }
          let dd = 0;
          for (; (dd = parts.indexOf("..", dd + 1)) !== -1; ) {
            let p = parts[dd - 1];
            p && p !== "." && p !== ".." && p !== "**" && (didSomething = !0, parts.splice(dd - 1, 2), dd -= 2);
          }
        } while (didSomething);
        return parts.length === 0 ? [""] : parts;
      }
      // First phase: single-pattern processing
      // <pre> is 1 or more portions
      // <rest> is 1 or more portions
      // <p> is any portion other than ., .., '', or **
      // <e> is . or ''
      //
      // **/.. is *brutal* for filesystem walking performance, because
      // it effectively resets the recursive walk each time it occurs,
      // and ** cannot be reduced out by a .. pattern part like a regexp
      // or most strings (other than .., ., and '') can be.
      //
      // <pre>/**/../<p>/<p>/<rest> -> {<pre>/../<p>/<p>/<rest>,<pre>/**/<p>/<p>/<rest>}
      // <pre>/<e>/<rest> -> <pre>/<rest>
      // <pre>/<p>/../<rest> -> <pre>/<rest>
      // **/**/<rest> -> **/<rest>
      //
      // **/*/<rest> -> */**/<rest> <== not valid because ** doesn't follow
      // this WOULD be allowed if ** did follow symlinks, or * didn't
      firstPhasePreProcess(globParts) {
        let didSomething = !1;
        do {
          didSomething = !1;
          for (let parts of globParts) {
            let gs = -1;
            for (; (gs = parts.indexOf("**", gs + 1)) !== -1; ) {
              let gss = gs;
              for (; parts[gss + 1] === "**"; )
                gss++;
              gss > gs && parts.splice(gs + 1, gss - gs);
              let next = parts[gs + 1], p = parts[gs + 2], p2 = parts[gs + 3];
              if (next !== ".." || !p || p === "." || p === ".." || !p2 || p2 === "." || p2 === "..")
                continue;
              didSomething = !0, parts.splice(gs, 1);
              let other = parts.slice(0);
              other[gs] = "**", globParts.push(other), gs--;
            }
            if (!this.preserveMultipleSlashes) {
              for (let i = 1; i < parts.length - 1; i++) {
                let p = parts[i];
                i === 1 && p === "" && parts[0] === "" || (p === "." || p === "") && (didSomething = !0, parts.splice(i, 1), i--);
              }
              parts[0] === "." && parts.length === 2 && (parts[1] === "." || parts[1] === "") && (didSomething = !0, parts.pop());
            }
            let dd = 0;
            for (; (dd = parts.indexOf("..", dd + 1)) !== -1; ) {
              let p = parts[dd - 1];
              if (p && p !== "." && p !== ".." && p !== "**") {
                didSomething = !0;
                let splin = dd === 1 && parts[dd + 1] === "**" ? ["."] : [];
                parts.splice(dd - 1, 2, ...splin), parts.length === 0 && parts.push(""), dd -= 2;
              }
            }
          }
        } while (didSomething);
        return globParts;
      }
      // second phase: multi-pattern dedupes
      // {<pre>/*/<rest>,<pre>/<p>/<rest>} -> <pre>/*/<rest>
      // {<pre>/<rest>,<pre>/<rest>} -> <pre>/<rest>
      // {<pre>/**/<rest>,<pre>/<rest>} -> <pre>/**/<rest>
      //
      // {<pre>/**/<rest>,<pre>/**/<p>/<rest>} -> <pre>/**/<rest>
      // ^-- not valid because ** doens't follow symlinks
      secondPhasePreProcess(globParts) {
        for (let i = 0; i < globParts.length - 1; i++)
          for (let j = i + 1; j < globParts.length; j++) {
            let matched = this.partsMatch(globParts[i], globParts[j], !this.preserveMultipleSlashes);
            matched && (globParts[i] = matched, globParts[j] = []);
          }
        return globParts.filter((gs) => gs.length);
      }
      partsMatch(a, b, emptyGSMatch = !1) {
        let ai = 0, bi = 0, result = [], which = "";
        for (; ai < a.length && bi < b.length; )
          if (a[ai] === b[bi])
            result.push(which === "b" ? b[bi] : a[ai]), ai++, bi++;
          else if (emptyGSMatch && a[ai] === "**" && b[bi] === a[ai + 1])
            result.push(a[ai]), ai++;
          else if (emptyGSMatch && b[bi] === "**" && a[ai] === b[bi + 1])
            result.push(b[bi]), bi++;
          else if (a[ai] === "*" && b[bi] && (this.options.dot || !b[bi].startsWith(".")) && b[bi] !== "**") {
            if (which === "b")
              return !1;
            which = "a", result.push(a[ai]), ai++, bi++;
          } else if (b[bi] === "*" && a[ai] && (this.options.dot || !a[ai].startsWith(".")) && a[ai] !== "**") {
            if (which === "a")
              return !1;
            which = "b", result.push(b[bi]), ai++, bi++;
          } else
            return !1;
        return a.length === b.length && result;
      }
      parseNegate() {
        if (this.nonegate)
          return;
        let pattern = this.pattern, negate = !1, negateOffset = 0;
        for (let i = 0; i < pattern.length && pattern.charAt(i) === "!"; i++)
          negate = !negate, negateOffset++;
        negateOffset && (this.pattern = pattern.slice(negateOffset)), this.negate = negate;
      }
      // set partial to true to test if, for example,
      // "/a/b" matches the start of "/*/b/*/d"
      // Partial means, if you run out of file before you run
      // out of pattern, then that's fine, as long as all
      // the parts match.
      matchOne(file, pattern, partial = !1) {
        let options = this.options;
        if (this.isWindows) {
          let fileDrive = typeof file[0] == "string" && /^[a-z]:$/i.test(file[0]), fileUNC = !fileDrive && file[0] === "" && file[1] === "" && file[2] === "?" && /^[a-z]:$/i.test(file[3]), patternDrive = typeof pattern[0] == "string" && /^[a-z]:$/i.test(pattern[0]), patternUNC = !patternDrive && pattern[0] === "" && pattern[1] === "" && pattern[2] === "?" && typeof pattern[3] == "string" && /^[a-z]:$/i.test(pattern[3]), fdi = fileUNC ? 3 : fileDrive ? 0 : void 0, pdi = patternUNC ? 3 : patternDrive ? 0 : void 0;
          if (typeof fdi == "number" && typeof pdi == "number") {
            let [fd, pd] = [file[fdi], pattern[pdi]];
            fd.toLowerCase() === pd.toLowerCase() && (pattern[pdi] = fd, pdi > fdi ? pattern = pattern.slice(pdi) : fdi > pdi && (file = file.slice(fdi)));
          }
        }
        let { optimizationLevel = 1 } = this.options;
        optimizationLevel >= 2 && (file = this.levelTwoFileOptimize(file)), this.debug("matchOne", this, { file, pattern }), this.debug("matchOne", file.length, pattern.length);
        for (var fi = 0, pi = 0, fl = file.length, pl = pattern.length; fi < fl && pi < pl; fi++, pi++) {
          this.debug("matchOne loop");
          var p = pattern[pi], f = file[fi];
          if (this.debug(pattern, p, f), p === !1)
            return !1;
          if (p === exports.GLOBSTAR) {
            this.debug("GLOBSTAR", [pattern, p, f]);
            var fr = fi, pr = pi + 1;
            if (pr === pl) {
              for (this.debug("** at the end"); fi < fl; fi++)
                if (file[fi] === "." || file[fi] === ".." || !options.dot && file[fi].charAt(0) === ".")
                  return !1;
              return !0;
            }
            for (; fr < fl; ) {
              var swallowee = file[fr];
              if (this.debug(`
globstar while`, file, fr, pattern, pr, swallowee), this.matchOne(file.slice(fr), pattern.slice(pr), partial))
                return this.debug("globstar found match!", fr, fl, swallowee), !0;
              if (swallowee === "." || swallowee === ".." || !options.dot && swallowee.charAt(0) === ".") {
                this.debug("dot detected!", file, fr, pattern, pr);
                break;
              }
              this.debug("globstar swallow a segment, and continue"), fr++;
            }
            return !!(partial && (this.debug(`
>>> no match, partial?`, file, fr, pattern, pr), fr === fl));
          }
          let hit;
          if (typeof p == "string" ? (hit = f === p, this.debug("string match", p, f, hit)) : (hit = p.test(f), this.debug("pattern match", p, f, hit)), !hit)
            return !1;
        }
        if (fi === fl && pi === pl)
          return !0;
        if (fi === fl)
          return partial;
        if (pi === pl)
          return fi === fl - 1 && file[fi] === "";
        throw new Error("wtf?");
      }
      braceExpand() {
        return (0, exports.braceExpand)(this.pattern, this.options);
      }
      parse(pattern) {
        (0, assert_valid_pattern_js_1.assertValidPattern)(pattern);
        let options = this.options;
        if (pattern === "**")
          return exports.GLOBSTAR;
        if (pattern === "")
          return "";
        let m, fastTest = null;
        (m = pattern.match(starRE)) ? fastTest = options.dot ? starTestDot : starTest : (m = pattern.match(starDotExtRE)) ? fastTest = (options.nocase ? options.dot ? starDotExtTestNocaseDot : starDotExtTestNocase : options.dot ? starDotExtTestDot : starDotExtTest)(m[1]) : (m = pattern.match(qmarksRE)) ? fastTest = (options.nocase ? options.dot ? qmarksTestNocaseDot : qmarksTestNocase : options.dot ? qmarksTestDot : qmarksTest)(m) : (m = pattern.match(starDotStarRE)) ? fastTest = options.dot ? starDotStarTestDot : starDotStarTest : (m = pattern.match(dotStarRE)) && (fastTest = dotStarTest);
        let re = ast_js_1.AST.fromGlob(pattern, this.options).toMMPattern();
        return fastTest ? Object.assign(re, { test: fastTest }) : re;
      }
      makeRe() {
        if (this.regexp || this.regexp === !1)
          return this.regexp;
        let set2 = this.set;
        if (!set2.length)
          return this.regexp = !1, this.regexp;
        let options = this.options, twoStar = options.noglobstar ? star : options.dot ? twoStarDot : twoStarNoDot, flags = new Set(options.nocase ? ["i"] : []), re = set2.map((pattern) => {
          let pp = pattern.map((p) => {
            if (p instanceof RegExp)
              for (let f of p.flags.split(""))
                flags.add(f);
            return typeof p == "string" ? regExpEscape(p) : p === exports.GLOBSTAR ? exports.GLOBSTAR : p._src;
          });
          return pp.forEach((p, i) => {
            let next = pp[i + 1], prev = pp[i - 1];
            p !== exports.GLOBSTAR || prev === exports.GLOBSTAR || (prev === void 0 ? next !== void 0 && next !== exports.GLOBSTAR ? pp[i + 1] = "(?:\\/|" + twoStar + "\\/)?" + next : pp[i] = twoStar : next === void 0 ? pp[i - 1] = prev + "(?:\\/|" + twoStar + ")?" : next !== exports.GLOBSTAR && (pp[i - 1] = prev + "(?:\\/|\\/" + twoStar + "\\/)" + next, pp[i + 1] = exports.GLOBSTAR));
          }), pp.filter((p) => p !== exports.GLOBSTAR).join("/");
        }).join("|"), [open2, close] = set2.length > 1 ? ["(?:", ")"] : ["", ""];
        re = "^" + open2 + re + close + "$", this.negate && (re = "^(?!" + re + ").+$");
        try {
          this.regexp = new RegExp(re, [...flags].join(""));
        } catch {
          this.regexp = !1;
        }
        return this.regexp;
      }
      slashSplit(p) {
        return this.preserveMultipleSlashes ? p.split("/") : this.isWindows && /^\/\/[^\/]+/.test(p) ? ["", ...p.split(/\/+/)] : p.split(/\/+/);
      }
      match(f, partial = this.partial) {
        if (this.debug("match", f, this.pattern), this.comment)
          return !1;
        if (this.empty)
          return f === "";
        if (f === "/" && partial)
          return !0;
        let options = this.options;
        this.isWindows && (f = f.split("\\").join("/"));
        let ff = this.slashSplit(f);
        this.debug(this.pattern, "split", ff);
        let set2 = this.set;
        this.debug(this.pattern, "set", set2);
        let filename = ff[ff.length - 1];
        if (!filename)
          for (let i = ff.length - 2; !filename && i >= 0; i--)
            filename = ff[i];
        for (let i = 0; i < set2.length; i++) {
          let pattern = set2[i], file = ff;
          if (options.matchBase && pattern.length === 1 && (file = [filename]), this.matchOne(file, pattern, partial))
            return options.flipNegate ? !0 : !this.negate;
        }
        return options.flipNegate ? !1 : this.negate;
      }
      static defaults(def) {
        return exports.minimatch.defaults(def).Minimatch;
      }
    };
    exports.Minimatch = Minimatch;
    var ast_js_2 = require_ast();
    Object.defineProperty(exports, "AST", { enumerable: !0, get: function() {
      return ast_js_2.AST;
    } });
    var escape_js_2 = require_escape();
    Object.defineProperty(exports, "escape", { enumerable: !0, get: function() {
      return escape_js_2.escape;
    } });
    var unescape_js_2 = require_unescape();
    Object.defineProperty(exports, "unescape", { enumerable: !0, get: function() {
      return unescape_js_2.unescape;
    } });
    exports.minimatch.AST = ast_js_1.AST;
    exports.minimatch.Minimatch = Minimatch;
    exports.minimatch.escape = escape_js_1.escape;
    exports.minimatch.unescape = unescape_js_1.unescape;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/ignore.js
var require_ignore = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/ignore.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.isIgnored = void 0;
    var minimatch_1 = require_cjs();
    function isIgnored(absolutePath, config2, checkDef) {
      return [...checkIgnorePatterns(checkDef, config2), ...asArray(config2.ignore)].map((pattern) => pattern.replace(/^\//, config2.root + "/").replace(/^([^\/])/, "**/$1").replace(/\/\*$/, "/**")).some((pattern) => (0, minimatch_1.minimatch)(absolutePath, pattern));
    }
    exports.isIgnored = isIgnored;
    function checkIgnorePatterns(checkDef, config2) {
      var _a38;
      return checkDef ? asArray((_a38 = config2.settings[checkDef.meta.code]) === null || _a38 === void 0 ? void 0 : _a38.ignore) : [];
    }
    function asArray(x) {
      return x ?? [];
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/AugmentedThemeDocset.js
var require_AugmentedThemeDocset = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/AugmentedThemeDocset.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.AugmentedThemeDocset = void 0;
    var utils_1 = require_utils2(), toFilterEntry = (name) => ({ name }), aliasedFilters = ["camelcase", "handle", "t"], undocumentedFilters = [
      "_online_store_editor_live_setting",
      "addresses_url",
      "app_block_path?",
      "app_block_path_for",
      "app_extension_path?",
      "app_snippet_path?",
      "cancel_customer_order_link",
      "debug",
      "delete_customer_address_link",
      "dev_shop?",
      "distance_from",
      "edit_customer_address_link",
      "encode_url_component",
      "excerpt",
      "format_code",
      "global_block_type?",
      "h",
      "handle_from",
      "installments_pricing",
      "link_to_theme",
      "login_button",
      "login_url",
      "logout_url",
      "pad_spaces",
      "paragraphize",
      "recover_password_link",
      "recover_url",
      "register_url",
      "registration_uuid_from",
      "root_account_url",
      "sentence",
      "theme_url",
      "unit",
      "weight"
    ], undocumentedObjectEntryKeys = [
      "locale",
      "direction",
      "skip_to_content_link",
      "checkout_html_classes",
      "checkout_stylesheets",
      "checkout_scripts",
      "content_for_logo",
      "breadcrumb",
      "order_summary_toggle",
      "content_for_order_summary",
      "alternative_payment_methods",
      "content_for_footer",
      "tracking_code"
    ], toObjectEntry = (name, access2, returnType) => ({
      name,
      ...access2 && { access: access2 },
      ...returnType && { return_type: returnType }
    }), undocumentedObjects = ["customer_address", "product_variant"], legacyCheckoutEntries = undocumentedObjectEntryKeys.map((objectKey) => toObjectEntry(objectKey, { global: !1, parents: [], template: [] }, [
      { type: "string", name: "" }
    ])), toTagEntry = (name) => ({ name }), undocumentedTags = ["elsif", "ifchanged", "when", "schema"], AugmentedThemeDocset = class {
      constructor(themeDocset) {
        this.themeDocset = themeDocset, this.isAugmented = !0, this.filters = (0, utils_1.memo)(async () => [
          ...await this.themeDocset.filters(),
          ...aliasedFilters.map(toFilterEntry),
          ...undocumentedFilters.map(toFilterEntry)
        ]), this.objects = (0, utils_1.memo)(async () => [
          ...await this.themeDocset.objects(),
          ...undocumentedObjects.map((obj) => toObjectEntry(obj)),
          ...legacyCheckoutEntries
        ]), this.tags = (0, utils_1.memo)(async () => [...await this.themeDocset.tags(), ...undocumentedTags.map(toTagEntry)]), this.systemTranslations = (0, utils_1.memo)(async () => this.themeDocset.systemTranslations());
      }
    };
    exports.AugmentedThemeDocset = AugmentedThemeDocset;
  }
});

// ../../node_modules/.pnpm/jsonc-parser@3.2.1/node_modules/jsonc-parser/lib/umd/impl/scanner.js
function createScanner(text, ignoreTrivia = !1) {
  let len = text.length, pos = 0, value = "", tokenOffset = 0, token = 16, lineNumber = 0, lineStartOffset = 0, tokenLineStartOffset = 0, prevTokenLineStartOffset = 0, scanError = 0;
  function scanHexDigits(count, exact) {
    let digits = 0, value2 = 0;
    for (; digits < count || !exact; ) {
      let ch = text.charCodeAt(pos);
      if (ch >= 48 && ch <= 57)
        value2 = value2 * 16 + ch - 48;
      else if (ch >= 65 && ch <= 70)
        value2 = value2 * 16 + ch - 65 + 10;
      else if (ch >= 97 && ch <= 102)
        value2 = value2 * 16 + ch - 97 + 10;
      else
        break;
      pos++, digits++;
    }
    return digits < count && (value2 = -1), value2;
  }
  function setPosition(newPosition) {
    pos = newPosition, value = "", tokenOffset = 0, token = 16, scanError = 0;
  }
  function scanNumber() {
    let start = pos;
    if (text.charCodeAt(pos) === 48)
      pos++;
    else
      for (pos++; pos < text.length && isDigit(text.charCodeAt(pos)); )
        pos++;
    if (pos < text.length && text.charCodeAt(pos) === 46)
      if (pos++, pos < text.length && isDigit(text.charCodeAt(pos)))
        for (pos++; pos < text.length && isDigit(text.charCodeAt(pos)); )
          pos++;
      else
        return scanError = 3, text.substring(start, pos);
    let end = pos;
    if (pos < text.length && (text.charCodeAt(pos) === 69 || text.charCodeAt(pos) === 101))
      if (pos++, (pos < text.length && text.charCodeAt(pos) === 43 || text.charCodeAt(pos) === 45) && pos++, pos < text.length && isDigit(text.charCodeAt(pos))) {
        for (pos++; pos < text.length && isDigit(text.charCodeAt(pos)); )
          pos++;
        end = pos;
      } else
        scanError = 3;
    return text.substring(start, end);
  }
  function scanString() {
    let result = "", start = pos;
    for (; ; ) {
      if (pos >= len) {
        result += text.substring(start, pos), scanError = 2;
        break;
      }
      let ch = text.charCodeAt(pos);
      if (ch === 34) {
        result += text.substring(start, pos), pos++;
        break;
      }
      if (ch === 92) {
        if (result += text.substring(start, pos), pos++, pos >= len) {
          scanError = 2;
          break;
        }
        switch (text.charCodeAt(pos++)) {
          case 34:
            result += '"';
            break;
          case 92:
            result += "\\";
            break;
          case 47:
            result += "/";
            break;
          case 98:
            result += "\b";
            break;
          case 102:
            result += "\f";
            break;
          case 110:
            result += `
`;
            break;
          case 114:
            result += "\r";
            break;
          case 116:
            result += "	";
            break;
          case 117:
            let ch3 = scanHexDigits(4, !0);
            ch3 >= 0 ? result += String.fromCharCode(ch3) : scanError = 4;
            break;
          default:
            scanError = 5;
        }
        start = pos;
        continue;
      }
      if (ch >= 0 && ch <= 31)
        if (isLineBreak(ch)) {
          result += text.substring(start, pos), scanError = 2;
          break;
        } else
          scanError = 6;
      pos++;
    }
    return result;
  }
  function scanNext() {
    if (value = "", scanError = 0, tokenOffset = pos, lineStartOffset = lineNumber, prevTokenLineStartOffset = tokenLineStartOffset, pos >= len)
      return tokenOffset = len, token = 17;
    let code = text.charCodeAt(pos);
    if (isWhiteSpace(code)) {
      do
        pos++, value += String.fromCharCode(code), code = text.charCodeAt(pos);
      while (isWhiteSpace(code));
      return token = 15;
    }
    if (isLineBreak(code))
      return pos++, value += String.fromCharCode(code), code === 13 && text.charCodeAt(pos) === 10 && (pos++, value += `
`), lineNumber++, tokenLineStartOffset = pos, token = 14;
    switch (code) {
      case 123:
        return pos++, token = 1;
      case 125:
        return pos++, token = 2;
      case 91:
        return pos++, token = 3;
      case 93:
        return pos++, token = 4;
      case 58:
        return pos++, token = 6;
      case 44:
        return pos++, token = 5;
      case 34:
        return pos++, value = scanString(), token = 10;
      case 47:
        let start = pos - 1;
        if (text.charCodeAt(pos + 1) === 47) {
          for (pos += 2; pos < len && !isLineBreak(text.charCodeAt(pos)); )
            pos++;
          return value = text.substring(start, pos), token = 12;
        }
        if (text.charCodeAt(pos + 1) === 42) {
          pos += 2;
          let safeLength = len - 1, commentClosed = !1;
          for (; pos < safeLength; ) {
            let ch = text.charCodeAt(pos);
            if (ch === 42 && text.charCodeAt(pos + 1) === 47) {
              pos += 2, commentClosed = !0;
              break;
            }
            pos++, isLineBreak(ch) && (ch === 13 && text.charCodeAt(pos) === 10 && pos++, lineNumber++, tokenLineStartOffset = pos);
          }
          return commentClosed || (pos++, scanError = 1), value = text.substring(start, pos), token = 13;
        }
        return value += String.fromCharCode(code), pos++, token = 16;
      case 45:
        if (value += String.fromCharCode(code), pos++, pos === len || !isDigit(text.charCodeAt(pos)))
          return token = 16;
      case 48:
      case 49:
      case 50:
      case 51:
      case 52:
      case 53:
      case 54:
      case 55:
      case 56:
      case 57:
        return value += scanNumber(), token = 11;
      default:
        for (; pos < len && isUnknownContentCharacter(code); )
          pos++, code = text.charCodeAt(pos);
        if (tokenOffset !== pos) {
          switch (value = text.substring(tokenOffset, pos), value) {
            case "true":
              return token = 8;
            case "false":
              return token = 9;
            case "null":
              return token = 7;
          }
          return token = 16;
        }
        return value += String.fromCharCode(code), pos++, token = 16;
    }
  }
  function isUnknownContentCharacter(code) {
    if (isWhiteSpace(code) || isLineBreak(code))
      return !1;
    switch (code) {
      case 125:
      case 93:
      case 123:
      case 91:
      case 34:
      case 58:
      case 44:
      case 47:
        return !1;
    }
    return !0;
  }
  function scanNextNonTrivia() {
    let result;
    do
      result = scanNext();
    while (result >= 12 && result <= 15);
    return result;
  }
  return {
    setPosition,
    getPosition: () => pos,
    scan: ignoreTrivia ? scanNextNonTrivia : scanNext,
    getToken: () => token,
    getTokenValue: () => value,
    getTokenOffset: () => tokenOffset,
    getTokenLength: () => pos - tokenOffset,
    getTokenStartLine: () => lineStartOffset,
    getTokenStartCharacter: () => tokenOffset - prevTokenLineStartOffset,
    getTokenError: () => scanError
  };
}
function isWhiteSpace(ch) {
  return ch === 32 || ch === 9;
}
function isLineBreak(ch) {
  return ch === 10 || ch === 13;
}
function isDigit(ch) {
  return ch >= 48 && ch <= 57;
}
var CharacterCodes, init_scanner = __esm({
  "../../node_modules/.pnpm/jsonc-parser@3.2.1/node_modules/jsonc-parser/lib/umd/impl/scanner.js"() {
    "use strict";
    init_cjs_shims();
    (function(CharacterCodes2) {
      CharacterCodes2[CharacterCodes2.lineFeed = 10] = "lineFeed", CharacterCodes2[CharacterCodes2.carriageReturn = 13] = "carriageReturn", CharacterCodes2[CharacterCodes2.space = 32] = "space", CharacterCodes2[CharacterCodes2._0 = 48] = "_0", CharacterCodes2[CharacterCodes2._1 = 49] = "_1", CharacterCodes2[CharacterCodes2._2 = 50] = "_2", CharacterCodes2[CharacterCodes2._3 = 51] = "_3", CharacterCodes2[CharacterCodes2._4 = 52] = "_4", CharacterCodes2[CharacterCodes2._5 = 53] = "_5", CharacterCodes2[CharacterCodes2._6 = 54] = "_6", CharacterCodes2[CharacterCodes2._7 = 55] = "_7", CharacterCodes2[CharacterCodes2._8 = 56] = "_8", CharacterCodes2[CharacterCodes2._9 = 57] = "_9", CharacterCodes2[CharacterCodes2.a = 97] = "a", CharacterCodes2[CharacterCodes2.b = 98] = "b", CharacterCodes2[CharacterCodes2.c = 99] = "c", CharacterCodes2[CharacterCodes2.d = 100] = "d", CharacterCodes2[CharacterCodes2.e = 101] = "e", CharacterCodes2[CharacterCodes2.f = 102] = "f", CharacterCodes2[CharacterCodes2.g = 103] = "g", CharacterCodes2[CharacterCodes2.h = 104] = "h", CharacterCodes2[CharacterCodes2.i = 105] = "i", CharacterCodes2[CharacterCodes2.j = 106] = "j", CharacterCodes2[CharacterCodes2.k = 107] = "k", CharacterCodes2[CharacterCodes2.l = 108] = "l", CharacterCodes2[CharacterCodes2.m = 109] = "m", CharacterCodes2[CharacterCodes2.n = 110] = "n", CharacterCodes2[CharacterCodes2.o = 111] = "o", CharacterCodes2[CharacterCodes2.p = 112] = "p", CharacterCodes2[CharacterCodes2.q = 113] = "q", CharacterCodes2[CharacterCodes2.r = 114] = "r", CharacterCodes2[CharacterCodes2.s = 115] = "s", CharacterCodes2[CharacterCodes2.t = 116] = "t", CharacterCodes2[CharacterCodes2.u = 117] = "u", CharacterCodes2[CharacterCodes2.v = 118] = "v", CharacterCodes2[CharacterCodes2.w = 119] = "w", CharacterCodes2[CharacterCodes2.x = 120] = "x", CharacterCodes2[CharacterCodes2.y = 121] = "y", CharacterCodes2[CharacterCodes2.z = 122] = "z", CharacterCodes2[CharacterCodes2.A = 65] = "A", CharacterCodes2[CharacterCodes2.B = 66] = "B", CharacterCodes2[CharacterCodes2.C = 67] = "C", CharacterCodes2[CharacterCodes2.D = 68] = "D", CharacterCodes2[CharacterCodes2.E = 69] = "E", CharacterCodes2[CharacterCodes2.F = 70] = "F", CharacterCodes2[CharacterCodes2.G = 71] = "G", CharacterCodes2[CharacterCodes2.H = 72] = "H", CharacterCodes2[CharacterCodes2.I = 73] = "I", CharacterCodes2[CharacterCodes2.J = 74] = "J", CharacterCodes2[CharacterCodes2.K = 75] = "K", CharacterCodes2[CharacterCodes2.L = 76] = "L", CharacterCodes2[CharacterCodes2.M = 77] = "M", CharacterCodes2[CharacterCodes2.N = 78] = "N", CharacterCodes2[CharacterCodes2.O = 79] = "O", CharacterCodes2[CharacterCodes2.P = 80] = "P", CharacterCodes2[CharacterCodes2.Q = 81] = "Q", CharacterCodes2[CharacterCodes2.R = 82] = "R", CharacterCodes2[CharacterCodes2.S = 83] = "S", CharacterCodes2[CharacterCodes2.T = 84] = "T", CharacterCodes2[CharacterCodes2.U = 85] = "U", CharacterCodes2[CharacterCodes2.V = 86] = "V", CharacterCodes2[CharacterCodes2.W = 87] = "W", CharacterCodes2[CharacterCodes2.X = 88] = "X", CharacterCodes2[CharacterCodes2.Y = 89] = "Y", CharacterCodes2[CharacterCodes2.Z = 90] = "Z", CharacterCodes2[CharacterCodes2.asterisk = 42] = "asterisk", CharacterCodes2[CharacterCodes2.backslash = 92] = "backslash", CharacterCodes2[CharacterCodes2.closeBrace = 125] = "closeBrace", CharacterCodes2[CharacterCodes2.closeBracket = 93] = "closeBracket", CharacterCodes2[CharacterCodes2.colon = 58] = "colon", CharacterCodes2[CharacterCodes2.comma = 44] = "comma", CharacterCodes2[CharacterCodes2.dot = 46] = "dot", CharacterCodes2[CharacterCodes2.doubleQuote = 34] = "doubleQuote", CharacterCodes2[CharacterCodes2.minus = 45] = "minus", CharacterCodes2[CharacterCodes2.openBrace = 123] = "openBrace", CharacterCodes2[CharacterCodes2.openBracket = 91] = "openBracket", CharacterCodes2[CharacterCodes2.plus = 43] = "plus", CharacterCodes2[CharacterCodes2.slash = 47] = "slash", CharacterCodes2[CharacterCodes2.formFeed = 12] = "formFeed", CharacterCodes2[CharacterCodes2.tab = 9] = "tab";
    })(CharacterCodes || (CharacterCodes = {}));
  }
});

// ../../node_modules/.pnpm/jsonc-parser@3.2.1/node_modules/jsonc-parser/lib/umd/impl/string-intern.js
var cachedSpaces, maxCachedValues, cachedBreakLinesWithSpaces, supportedEols, init_string_intern = __esm({
  "../../node_modules/.pnpm/jsonc-parser@3.2.1/node_modules/jsonc-parser/lib/umd/impl/string-intern.js"() {
    init_cjs_shims();
    cachedSpaces = new Array(20).fill(0).map((_2, index) => " ".repeat(index)), maxCachedValues = 200, cachedBreakLinesWithSpaces = {
      " ": {
        "\n": new Array(maxCachedValues).fill(0).map((_2, index) => `
` + " ".repeat(index)),
        "\r": new Array(maxCachedValues).fill(0).map((_2, index) => "\r" + " ".repeat(index)),
        "\r\n": new Array(maxCachedValues).fill(0).map((_2, index) => `\r
` + " ".repeat(index))
      },
      "	": {
        "\n": new Array(maxCachedValues).fill(0).map((_2, index) => `
` + "	".repeat(index)),
        "\r": new Array(maxCachedValues).fill(0).map((_2, index) => "\r" + "	".repeat(index)),
        "\r\n": new Array(maxCachedValues).fill(0).map((_2, index) => `\r
` + "	".repeat(index))
      }
    }, supportedEols = [`
`, "\r", `\r
`];
  }
});

// ../../node_modules/.pnpm/jsonc-parser@3.2.1/node_modules/jsonc-parser/lib/umd/impl/format.js
function format(documentText, range, options) {
  let initialIndentLevel, formatText, formatTextStart, rangeStart, rangeEnd;
  if (range) {
    for (rangeStart = range.offset, rangeEnd = rangeStart + range.length, formatTextStart = rangeStart; formatTextStart > 0 && !isEOL(documentText, formatTextStart - 1); )
      formatTextStart--;
    let endOffset = rangeEnd;
    for (; endOffset < documentText.length && !isEOL(documentText, endOffset); )
      endOffset++;
    formatText = documentText.substring(formatTextStart, endOffset), initialIndentLevel = computeIndentLevel(formatText, options);
  } else
    formatText = documentText, initialIndentLevel = 0, formatTextStart = 0, rangeStart = 0, rangeEnd = documentText.length;
  let eol = getEOL(options, documentText), eolFastPathSupported = supportedEols.includes(eol), numberLineBreaks = 0, indentLevel = 0, indentValue;
  options.insertSpaces ? indentValue = cachedSpaces[options.tabSize || 4] ?? repeat(cachedSpaces[1], options.tabSize || 4) : indentValue = "	";
  let indentType = indentValue === "	" ? "	" : " ", scanner = createScanner(formatText, !1), hasError = !1;
  function newLinesAndIndent() {
    if (numberLineBreaks > 1)
      return repeat(eol, numberLineBreaks) + repeat(indentValue, initialIndentLevel + indentLevel);
    let amountOfSpaces = indentValue.length * (initialIndentLevel + indentLevel);
    return !eolFastPathSupported || amountOfSpaces > cachedBreakLinesWithSpaces[indentType][eol].length ? eol + repeat(indentValue, initialIndentLevel + indentLevel) : amountOfSpaces <= 0 ? eol : cachedBreakLinesWithSpaces[indentType][eol][amountOfSpaces];
  }
  function scanNext() {
    let token = scanner.scan();
    for (numberLineBreaks = 0; token === 15 || token === 14; )
      token === 14 && options.keepLines ? numberLineBreaks += 1 : token === 14 && (numberLineBreaks = 1), token = scanner.scan();
    return hasError = token === 16 || scanner.getTokenError() !== 0, token;
  }
  let editOperations = [];
  function addEdit(text, startOffset, endOffset) {
    !hasError && (!range || startOffset < rangeEnd && endOffset > rangeStart) && documentText.substring(startOffset, endOffset) !== text && editOperations.push({ offset: startOffset, length: endOffset - startOffset, content: text });
  }
  let firstToken = scanNext();
  if (options.keepLines && numberLineBreaks > 0 && addEdit(repeat(eol, numberLineBreaks), 0, 0), firstToken !== 17) {
    let firstTokenStart = scanner.getTokenOffset() + formatTextStart, initialIndent = indentValue.length * initialIndentLevel < 20 && options.insertSpaces ? cachedSpaces[indentValue.length * initialIndentLevel] : repeat(indentValue, initialIndentLevel);
    addEdit(initialIndent, formatTextStart, firstTokenStart);
  }
  for (; firstToken !== 17; ) {
    let firstTokenEnd = scanner.getTokenOffset() + scanner.getTokenLength() + formatTextStart, secondToken = scanNext(), replaceContent = "", needsLineBreak = !1;
    for (; numberLineBreaks === 0 && (secondToken === 12 || secondToken === 13); ) {
      let commentTokenStart = scanner.getTokenOffset() + formatTextStart;
      addEdit(cachedSpaces[1], firstTokenEnd, commentTokenStart), firstTokenEnd = scanner.getTokenOffset() + scanner.getTokenLength() + formatTextStart, needsLineBreak = secondToken === 12, replaceContent = needsLineBreak ? newLinesAndIndent() : "", secondToken = scanNext();
    }
    if (secondToken === 2)
      firstToken !== 1 && indentLevel--, options.keepLines && numberLineBreaks > 0 || !options.keepLines && firstToken !== 1 ? replaceContent = newLinesAndIndent() : options.keepLines && (replaceContent = cachedSpaces[1]);
    else if (secondToken === 4)
      firstToken !== 3 && indentLevel--, options.keepLines && numberLineBreaks > 0 || !options.keepLines && firstToken !== 3 ? replaceContent = newLinesAndIndent() : options.keepLines && (replaceContent = cachedSpaces[1]);
    else {
      switch (firstToken) {
        case 3:
        case 1:
          indentLevel++, options.keepLines && numberLineBreaks > 0 || !options.keepLines ? replaceContent = newLinesAndIndent() : replaceContent = cachedSpaces[1];
          break;
        case 5:
          options.keepLines && numberLineBreaks > 0 || !options.keepLines ? replaceContent = newLinesAndIndent() : replaceContent = cachedSpaces[1];
          break;
        case 12:
          replaceContent = newLinesAndIndent();
          break;
        case 13:
          numberLineBreaks > 0 ? replaceContent = newLinesAndIndent() : needsLineBreak || (replaceContent = cachedSpaces[1]);
          break;
        case 6:
          options.keepLines && numberLineBreaks > 0 ? replaceContent = newLinesAndIndent() : needsLineBreak || (replaceContent = cachedSpaces[1]);
          break;
        case 10:
          options.keepLines && numberLineBreaks > 0 ? replaceContent = newLinesAndIndent() : secondToken === 6 && !needsLineBreak && (replaceContent = "");
          break;
        case 7:
        case 8:
        case 9:
        case 11:
        case 2:
        case 4:
          options.keepLines && numberLineBreaks > 0 ? replaceContent = newLinesAndIndent() : (secondToken === 12 || secondToken === 13) && !needsLineBreak ? replaceContent = cachedSpaces[1] : secondToken !== 5 && secondToken !== 17 && (hasError = !0);
          break;
        case 16:
          hasError = !0;
          break;
      }
      numberLineBreaks > 0 && (secondToken === 12 || secondToken === 13) && (replaceContent = newLinesAndIndent());
    }
    secondToken === 17 && (options.keepLines && numberLineBreaks > 0 ? replaceContent = newLinesAndIndent() : replaceContent = options.insertFinalNewline ? eol : "");
    let secondTokenStart = scanner.getTokenOffset() + formatTextStart;
    addEdit(replaceContent, firstTokenEnd, secondTokenStart), firstToken = secondToken;
  }
  return editOperations;
}
function repeat(s, count) {
  let result = "";
  for (let i = 0; i < count; i++)
    result += s;
  return result;
}
function computeIndentLevel(content, options) {
  let i = 0, nChars = 0, tabSize = options.tabSize || 4;
  for (; i < content.length; ) {
    let ch = content.charAt(i);
    if (ch === cachedSpaces[1])
      nChars++;
    else if (ch === "	")
      nChars += tabSize;
    else
      break;
    i++;
  }
  return Math.floor(nChars / tabSize);
}
function getEOL(options, text) {
  for (let i = 0; i < text.length; i++) {
    let ch = text.charAt(i);
    if (ch === "\r")
      return i + 1 < text.length && text.charAt(i + 1) === `
` ? `\r
` : "\r";
    if (ch === `
`)
      return `
`;
  }
  return options && options.eol || `
`;
}
function isEOL(text, offset) {
  return `\r
`.indexOf(text.charAt(offset)) !== -1;
}
var init_format = __esm({
  "../../node_modules/.pnpm/jsonc-parser@3.2.1/node_modules/jsonc-parser/lib/umd/impl/format.js"() {
    "use strict";
    init_cjs_shims();
    init_scanner();
    init_string_intern();
  }
});

// ../../node_modules/.pnpm/jsonc-parser@3.2.1/node_modules/jsonc-parser/lib/umd/impl/parser.js
function getLocation(text, position) {
  let segments = [], earlyReturnException = new Object(), previousNode, previousNodeInst = {
    value: {},
    offset: 0,
    length: 0,
    type: "object",
    parent: void 0
  }, isAtPropertyKey = !1;
  function setPreviousNode(value, offset, length, type) {
    previousNodeInst.value = value, previousNodeInst.offset = offset, previousNodeInst.length = length, previousNodeInst.type = type, previousNodeInst.colonOffset = void 0, previousNode = previousNodeInst;
  }
  try {
    visit(text, {
      onObjectBegin: (offset, length) => {
        if (position <= offset)
          throw earlyReturnException;
        previousNode = void 0, isAtPropertyKey = position > offset, segments.push("");
      },
      onObjectProperty: (name, offset, length) => {
        if (position < offset || (setPreviousNode(name, offset, length, "property"), segments[segments.length - 1] = name, position <= offset + length))
          throw earlyReturnException;
      },
      onObjectEnd: (offset, length) => {
        if (position <= offset)
          throw earlyReturnException;
        previousNode = void 0, segments.pop();
      },
      onArrayBegin: (offset, length) => {
        if (position <= offset)
          throw earlyReturnException;
        previousNode = void 0, segments.push(0);
      },
      onArrayEnd: (offset, length) => {
        if (position <= offset)
          throw earlyReturnException;
        previousNode = void 0, segments.pop();
      },
      onLiteralValue: (value, offset, length) => {
        if (position < offset || (setPreviousNode(value, offset, length, getNodeType(value)), position <= offset + length))
          throw earlyReturnException;
      },
      onSeparator: (sep3, offset, length) => {
        if (position <= offset)
          throw earlyReturnException;
        if (sep3 === ":" && previousNode && previousNode.type === "property")
          previousNode.colonOffset = offset, isAtPropertyKey = !1, previousNode = void 0;
        else if (sep3 === ",") {
          let last = segments[segments.length - 1];
          typeof last == "number" ? segments[segments.length - 1] = last + 1 : (isAtPropertyKey = !0, segments[segments.length - 1] = ""), previousNode = void 0;
        }
      }
    });
  } catch (e) {
    if (e !== earlyReturnException)
      throw e;
  }
  return {
    path: segments,
    previousNode,
    isAtPropertyKey,
    matches: (pattern) => {
      let k = 0;
      for (let i = 0; k < pattern.length && i < segments.length; i++)
        if (pattern[k] === segments[i] || pattern[k] === "*")
          k++;
        else if (pattern[k] !== "**")
          return !1;
      return k === pattern.length;
    }
  };
}
function parse(text, errors2 = [], options = ParseOptions.DEFAULT) {
  let currentProperty = null, currentParent = [], previousParents = [];
  function onValue(value) {
    Array.isArray(currentParent) ? currentParent.push(value) : currentProperty !== null && (currentParent[currentProperty] = value);
  }
  return visit(text, {
    onObjectBegin: () => {
      let object = {};
      onValue(object), previousParents.push(currentParent), currentParent = object, currentProperty = null;
    },
    onObjectProperty: (name) => {
      currentProperty = name;
    },
    onObjectEnd: () => {
      currentParent = previousParents.pop();
    },
    onArrayBegin: () => {
      let array = [];
      onValue(array), previousParents.push(currentParent), currentParent = array, currentProperty = null;
    },
    onArrayEnd: () => {
      currentParent = previousParents.pop();
    },
    onLiteralValue: onValue,
    onError: (error, offset, length) => {
      errors2.push({ error, offset, length });
    }
  }, options), currentParent[0];
}
function parseTree(text, errors2 = [], options = ParseOptions.DEFAULT) {
  let currentParent = { type: "array", offset: -1, length: -1, children: [], parent: void 0 };
  function ensurePropertyComplete(endOffset) {
    currentParent.type === "property" && (currentParent.length = endOffset - currentParent.offset, currentParent = currentParent.parent);
  }
  function onValue(valueNode) {
    return currentParent.children.push(valueNode), valueNode;
  }
  visit(text, {
    onObjectBegin: (offset) => {
      currentParent = onValue({ type: "object", offset, length: -1, parent: currentParent, children: [] });
    },
    onObjectProperty: (name, offset, length) => {
      currentParent = onValue({ type: "property", offset, length: -1, parent: currentParent, children: [] }), currentParent.children.push({ type: "string", value: name, offset, length, parent: currentParent });
    },
    onObjectEnd: (offset, length) => {
      ensurePropertyComplete(offset + length), currentParent.length = offset + length - currentParent.offset, currentParent = currentParent.parent, ensurePropertyComplete(offset + length);
    },
    onArrayBegin: (offset, length) => {
      currentParent = onValue({ type: "array", offset, length: -1, parent: currentParent, children: [] });
    },
    onArrayEnd: (offset, length) => {
      currentParent.length = offset + length - currentParent.offset, currentParent = currentParent.parent, ensurePropertyComplete(offset + length);
    },
    onLiteralValue: (value, offset, length) => {
      onValue({ type: getNodeType(value), offset, length, parent: currentParent, value }), ensurePropertyComplete(offset + length);
    },
    onSeparator: (sep3, offset, length) => {
      currentParent.type === "property" && (sep3 === ":" ? currentParent.colonOffset = offset : sep3 === "," && ensurePropertyComplete(offset));
    },
    onError: (error, offset, length) => {
      errors2.push({ error, offset, length });
    }
  }, options);
  let result = currentParent.children[0];
  return result && delete result.parent, result;
}
function findNodeAtLocation(root, path3) {
  if (!root)
    return;
  let node = root;
  for (let segment of path3)
    if (typeof segment == "string") {
      if (node.type !== "object" || !Array.isArray(node.children))
        return;
      let found = !1;
      for (let propertyNode of node.children)
        if (Array.isArray(propertyNode.children) && propertyNode.children[0].value === segment && propertyNode.children.length === 2) {
          node = propertyNode.children[1], found = !0;
          break;
        }
      if (!found)
        return;
    } else {
      let index = segment;
      if (node.type !== "array" || index < 0 || !Array.isArray(node.children) || index >= node.children.length)
        return;
      node = node.children[index];
    }
  return node;
}
function getNodePath(node) {
  if (!node.parent || !node.parent.children)
    return [];
  let path3 = getNodePath(node.parent);
  if (node.parent.type === "property") {
    let key = node.parent.children[0].value;
    path3.push(key);
  } else if (node.parent.type === "array") {
    let index = node.parent.children.indexOf(node);
    index !== -1 && path3.push(index);
  }
  return path3;
}
function getNodeValue(node) {
  switch (node.type) {
    case "array":
      return node.children.map(getNodeValue);
    case "object":
      let obj = /* @__PURE__ */ Object.create(null);
      for (let prop of node.children) {
        let valueNode = prop.children[1];
        valueNode && (obj[prop.children[0].value] = getNodeValue(valueNode));
      }
      return obj;
    case "null":
    case "string":
    case "number":
    case "boolean":
      return node.value;
    default:
      return;
  }
}
function contains(node, offset, includeRightBound = !1) {
  return offset >= node.offset && offset < node.offset + node.length || includeRightBound && offset === node.offset + node.length;
}
function findNodeAtOffset(node, offset, includeRightBound = !1) {
  if (contains(node, offset, includeRightBound)) {
    let children = node.children;
    if (Array.isArray(children))
      for (let i = 0; i < children.length && children[i].offset <= offset; i++) {
        let item = findNodeAtOffset(children[i], offset, includeRightBound);
        if (item)
          return item;
      }
    return node;
  }
}
function visit(text, visitor, options = ParseOptions.DEFAULT) {
  let _scanner = createScanner(text, !1), _jsonPath = [];
  function toNoArgVisit(visitFunction) {
    return visitFunction ? () => visitFunction(_scanner.getTokenOffset(), _scanner.getTokenLength(), _scanner.getTokenStartLine(), _scanner.getTokenStartCharacter()) : () => !0;
  }
  function toNoArgVisitWithPath(visitFunction) {
    return visitFunction ? () => visitFunction(_scanner.getTokenOffset(), _scanner.getTokenLength(), _scanner.getTokenStartLine(), _scanner.getTokenStartCharacter(), () => _jsonPath.slice()) : () => !0;
  }
  function toOneArgVisit(visitFunction) {
    return visitFunction ? (arg) => visitFunction(arg, _scanner.getTokenOffset(), _scanner.getTokenLength(), _scanner.getTokenStartLine(), _scanner.getTokenStartCharacter()) : () => !0;
  }
  function toOneArgVisitWithPath(visitFunction) {
    return visitFunction ? (arg) => visitFunction(arg, _scanner.getTokenOffset(), _scanner.getTokenLength(), _scanner.getTokenStartLine(), _scanner.getTokenStartCharacter(), () => _jsonPath.slice()) : () => !0;
  }
  let onObjectBegin = toNoArgVisitWithPath(visitor.onObjectBegin), onObjectProperty = toOneArgVisitWithPath(visitor.onObjectProperty), onObjectEnd = toNoArgVisit(visitor.onObjectEnd), onArrayBegin = toNoArgVisitWithPath(visitor.onArrayBegin), onArrayEnd = toNoArgVisit(visitor.onArrayEnd), onLiteralValue = toOneArgVisitWithPath(visitor.onLiteralValue), onSeparator = toOneArgVisit(visitor.onSeparator), onComment = toNoArgVisit(visitor.onComment), onError = toOneArgVisit(visitor.onError), disallowComments = options && options.disallowComments, allowTrailingComma = options && options.allowTrailingComma;
  function scanNext() {
    for (; ; ) {
      let token = _scanner.scan();
      switch (_scanner.getTokenError()) {
        case 4:
          handleError(
            14
            /* ParseErrorCode.InvalidUnicode */
          );
          break;
        case 5:
          handleError(
            15
            /* ParseErrorCode.InvalidEscapeCharacter */
          );
          break;
        case 3:
          handleError(
            13
            /* ParseErrorCode.UnexpectedEndOfNumber */
          );
          break;
        case 1:
          disallowComments || handleError(
            11
            /* ParseErrorCode.UnexpectedEndOfComment */
          );
          break;
        case 2:
          handleError(
            12
            /* ParseErrorCode.UnexpectedEndOfString */
          );
          break;
        case 6:
          handleError(
            16
            /* ParseErrorCode.InvalidCharacter */
          );
          break;
      }
      switch (token) {
        case 12:
        case 13:
          disallowComments ? handleError(
            10
            /* ParseErrorCode.InvalidCommentToken */
          ) : onComment();
          break;
        case 16:
          handleError(
            1
            /* ParseErrorCode.InvalidSymbol */
          );
          break;
        case 15:
        case 14:
          break;
        default:
          return token;
      }
    }
  }
  function handleError(error, skipUntilAfter = [], skipUntil = []) {
    if (onError(error), skipUntilAfter.length + skipUntil.length > 0) {
      let token = _scanner.getToken();
      for (; token !== 17; ) {
        if (skipUntilAfter.indexOf(token) !== -1) {
          scanNext();
          break;
        } else if (skipUntil.indexOf(token) !== -1)
          break;
        token = scanNext();
      }
    }
  }
  function parseString(isValue) {
    let value = _scanner.getTokenValue();
    return isValue ? onLiteralValue(value) : (onObjectProperty(value), _jsonPath.push(value)), scanNext(), !0;
  }
  function parseLiteral() {
    switch (_scanner.getToken()) {
      case 11:
        let tokenValue = _scanner.getTokenValue(), value = Number(tokenValue);
        isNaN(value) && (handleError(
          2
          /* ParseErrorCode.InvalidNumberFormat */
        ), value = 0), onLiteralValue(value);
        break;
      case 7:
        onLiteralValue(null);
        break;
      case 8:
        onLiteralValue(!0);
        break;
      case 9:
        onLiteralValue(!1);
        break;
      default:
        return !1;
    }
    return scanNext(), !0;
  }
  function parseProperty() {
    return _scanner.getToken() !== 10 ? (handleError(3, [], [
      2,
      5
      /* SyntaxKind.CommaToken */
    ]), !1) : (parseString(!1), _scanner.getToken() === 6 ? (onSeparator(":"), scanNext(), parseValue() || handleError(4, [], [
      2,
      5
      /* SyntaxKind.CommaToken */
    ])) : handleError(5, [], [
      2,
      5
      /* SyntaxKind.CommaToken */
    ]), _jsonPath.pop(), !0);
  }
  function parseObject() {
    onObjectBegin(), scanNext();
    let needsComma = !1;
    for (; _scanner.getToken() !== 2 && _scanner.getToken() !== 17; ) {
      if (_scanner.getToken() === 5) {
        if (needsComma || handleError(4, [], []), onSeparator(","), scanNext(), _scanner.getToken() === 2 && allowTrailingComma)
          break;
      } else
        needsComma && handleError(6, [], []);
      parseProperty() || handleError(4, [], [
        2,
        5
        /* SyntaxKind.CommaToken */
      ]), needsComma = !0;
    }
    return onObjectEnd(), _scanner.getToken() !== 2 ? handleError(7, [
      2
      /* SyntaxKind.CloseBraceToken */
    ], []) : scanNext(), !0;
  }
  function parseArray() {
    onArrayBegin(), scanNext();
    let isFirstElement = !0, needsComma = !1;
    for (; _scanner.getToken() !== 4 && _scanner.getToken() !== 17; ) {
      if (_scanner.getToken() === 5) {
        if (needsComma || handleError(4, [], []), onSeparator(","), scanNext(), _scanner.getToken() === 4 && allowTrailingComma)
          break;
      } else
        needsComma && handleError(6, [], []);
      isFirstElement ? (_jsonPath.push(0), isFirstElement = !1) : _jsonPath[_jsonPath.length - 1]++, parseValue() || handleError(4, [], [
        4,
        5
        /* SyntaxKind.CommaToken */
      ]), needsComma = !0;
    }
    return onArrayEnd(), isFirstElement || _jsonPath.pop(), _scanner.getToken() !== 4 ? handleError(8, [
      4
      /* SyntaxKind.CloseBracketToken */
    ], []) : scanNext(), !0;
  }
  function parseValue() {
    switch (_scanner.getToken()) {
      case 3:
        return parseArray();
      case 1:
        return parseObject();
      case 10:
        return parseString(!0);
      default:
        return parseLiteral();
    }
  }
  return scanNext(), _scanner.getToken() === 17 ? options.allowEmptyContent ? !0 : (handleError(4, [], []), !1) : parseValue() ? (_scanner.getToken() !== 17 && handleError(9, [], []), !0) : (handleError(4, [], []), !1);
}
function stripComments(text, replaceCh) {
  let _scanner = createScanner(text), parts = [], kind, offset = 0, pos;
  do
    switch (pos = _scanner.getPosition(), kind = _scanner.scan(), kind) {
      case 12:
      case 13:
      case 17:
        offset !== pos && parts.push(text.substring(offset, pos)), replaceCh !== void 0 && parts.push(_scanner.getTokenValue().replace(/[^\r\n]/g, replaceCh)), offset = _scanner.getPosition();
        break;
    }
  while (kind !== 17);
  return parts.join("");
}
function getNodeType(value) {
  switch (typeof value) {
    case "boolean":
      return "boolean";
    case "number":
      return "number";
    case "string":
      return "string";
    case "object": {
      if (value) {
        if (Array.isArray(value))
          return "array";
      } else
        return "null";
      return "object";
    }
    default:
      return "null";
  }
}
var ParseOptions, init_parser = __esm({
  "../../node_modules/.pnpm/jsonc-parser@3.2.1/node_modules/jsonc-parser/lib/umd/impl/parser.js"() {
    "use strict";
    init_cjs_shims();
    init_scanner();
    (function(ParseOptions2) {
      ParseOptions2.DEFAULT = {
        allowTrailingComma: !1
      };
    })(ParseOptions || (ParseOptions = {}));
  }
});

// ../../node_modules/.pnpm/jsonc-parser@3.2.1/node_modules/jsonc-parser/lib/umd/impl/edit.js
function setProperty(text, originalPath, value, options) {
  let path3 = originalPath.slice(), root = parseTree(text, []), parent, lastSegment;
  for (; path3.length > 0 && (lastSegment = path3.pop(), parent = findNodeAtLocation(root, path3), parent === void 0 && value !== void 0); )
    typeof lastSegment == "string" ? value = { [lastSegment]: value } : value = [value];
  if (parent)
    if (parent.type === "object" && typeof lastSegment == "string" && Array.isArray(parent.children)) {
      let existing = findNodeAtLocation(parent, [lastSegment]);
      if (existing !== void 0)
        if (value === void 0) {
          if (!existing.parent)
            throw new Error("Malformed AST");
          let propertyIndex = parent.children.indexOf(existing.parent), removeBegin, removeEnd = existing.parent.offset + existing.parent.length;
          if (propertyIndex > 0) {
            let previous = parent.children[propertyIndex - 1];
            removeBegin = previous.offset + previous.length;
          } else
            removeBegin = parent.offset + 1, parent.children.length > 1 && (removeEnd = parent.children[1].offset);
          return withFormatting(text, { offset: removeBegin, length: removeEnd - removeBegin, content: "" }, options);
        } else
          return withFormatting(text, { offset: existing.offset, length: existing.length, content: JSON.stringify(value) }, options);
      else {
        if (value === void 0)
          return [];
        let newProperty = `${JSON.stringify(lastSegment)}: ${JSON.stringify(value)}`, index = options.getInsertionIndex ? options.getInsertionIndex(parent.children.map((p) => p.children[0].value)) : parent.children.length, edit;
        if (index > 0) {
          let previous = parent.children[index - 1];
          edit = { offset: previous.offset + previous.length, length: 0, content: "," + newProperty };
        } else
          parent.children.length === 0 ? edit = { offset: parent.offset + 1, length: 0, content: newProperty } : edit = { offset: parent.offset + 1, length: 0, content: newProperty + "," };
        return withFormatting(text, edit, options);
      }
    } else if (parent.type === "array" && typeof lastSegment == "number" && Array.isArray(parent.children)) {
      let insertIndex = lastSegment;
      if (insertIndex === -1) {
        let newProperty = `${JSON.stringify(value)}`, edit;
        if (parent.children.length === 0)
          edit = { offset: parent.offset + 1, length: 0, content: newProperty };
        else {
          let previous = parent.children[parent.children.length - 1];
          edit = { offset: previous.offset + previous.length, length: 0, content: "," + newProperty };
        }
        return withFormatting(text, edit, options);
      } else if (value === void 0 && parent.children.length >= 0) {
        let removalIndex = lastSegment, toRemove = parent.children[removalIndex], edit;
        if (parent.children.length === 1)
          edit = { offset: parent.offset + 1, length: parent.length - 2, content: "" };
        else if (parent.children.length - 1 === removalIndex) {
          let previous = parent.children[removalIndex - 1], offset = previous.offset + previous.length, parentEndOffset = parent.offset + parent.length;
          edit = { offset, length: parentEndOffset - 2 - offset, content: "" };
        } else
          edit = { offset: toRemove.offset, length: parent.children[removalIndex + 1].offset - toRemove.offset, content: "" };
        return withFormatting(text, edit, options);
      } else if (value !== void 0) {
        let edit, newProperty = `${JSON.stringify(value)}`;
        if (!options.isArrayInsertion && parent.children.length > lastSegment) {
          let toModify = parent.children[lastSegment];
          edit = { offset: toModify.offset, length: toModify.length, content: newProperty };
        } else if (parent.children.length === 0 || lastSegment === 0)
          edit = { offset: parent.offset + 1, length: 0, content: parent.children.length === 0 ? newProperty : newProperty + "," };
        else {
          let index = lastSegment > parent.children.length ? parent.children.length : lastSegment, previous = parent.children[index - 1];
          edit = { offset: previous.offset + previous.length, length: 0, content: "," + newProperty };
        }
        return withFormatting(text, edit, options);
      } else
        throw new Error(`Can not ${value === void 0 ? "remove" : options.isArrayInsertion ? "insert" : "modify"} Array index ${insertIndex} as length is not sufficient`);
    } else
      throw new Error(`Can not add ${typeof lastSegment != "number" ? "index" : "property"} to parent of type ${parent.type}`);
  else {
    if (value === void 0)
      throw new Error("Can not delete in empty document");
    return withFormatting(text, { offset: root ? root.offset : 0, length: root ? root.length : 0, content: JSON.stringify(value) }, options);
  }
}
function withFormatting(text, edit, options) {
  if (!options.formattingOptions)
    return [edit];
  let newText = applyEdit(text, edit), begin = edit.offset, end = edit.offset + edit.content.length;
  if (edit.length === 0 || edit.content.length === 0) {
    for (; begin > 0 && !isEOL(newText, begin - 1); )
      begin--;
    for (; end < newText.length && !isEOL(newText, end); )
      end++;
  }
  let edits = format(newText, { offset: begin, length: end - begin }, { ...options.formattingOptions, keepLines: !1 });
  for (let i = edits.length - 1; i >= 0; i--) {
    let edit2 = edits[i];
    newText = applyEdit(newText, edit2), begin = Math.min(begin, edit2.offset), end = Math.max(end, edit2.offset + edit2.length), end += edit2.content.length - edit2.length;
  }
  let editLength = text.length - (newText.length - end) - begin;
  return [{ offset: begin, length: editLength, content: newText.substring(begin, end) }];
}
function applyEdit(text, edit) {
  return text.substring(0, edit.offset) + edit.content + text.substring(edit.offset + edit.length);
}
var init_edit = __esm({
  "../../node_modules/.pnpm/jsonc-parser@3.2.1/node_modules/jsonc-parser/lib/umd/impl/edit.js"() {
    "use strict";
    init_cjs_shims();
    init_format();
    init_parser();
  }
});

// ../../node_modules/.pnpm/jsonc-parser@3.2.1/node_modules/jsonc-parser/lib/umd/main.js
var main_exports = {};
__export(main_exports, {
  ParseErrorCode: () => ParseErrorCode,
  ScanError: () => ScanError,
  SyntaxKind: () => SyntaxKind,
  applyEdits: () => applyEdits,
  createScanner: () => createScanner2,
  findNodeAtLocation: () => findNodeAtLocation2,
  findNodeAtOffset: () => findNodeAtOffset2,
  format: () => format2,
  getLocation: () => getLocation2,
  getNodePath: () => getNodePath2,
  getNodeValue: () => getNodeValue2,
  modify: () => modify,
  parse: () => parse2,
  parseTree: () => parseTree2,
  printParseErrorCode: () => printParseErrorCode,
  stripComments: () => stripComments2,
  visit: () => visit2
});
function printParseErrorCode(code) {
  switch (code) {
    case 1:
      return "InvalidSymbol";
    case 2:
      return "InvalidNumberFormat";
    case 3:
      return "PropertyNameExpected";
    case 4:
      return "ValueExpected";
    case 5:
      return "ColonExpected";
    case 6:
      return "CommaExpected";
    case 7:
      return "CloseBraceExpected";
    case 8:
      return "CloseBracketExpected";
    case 9:
      return "EndOfFileExpected";
    case 10:
      return "InvalidCommentToken";
    case 11:
      return "UnexpectedEndOfComment";
    case 12:
      return "UnexpectedEndOfString";
    case 13:
      return "UnexpectedEndOfNumber";
    case 14:
      return "InvalidUnicode";
    case 15:
      return "InvalidEscapeCharacter";
    case 16:
      return "InvalidCharacter";
  }
  return "<unknown ParseErrorCode>";
}
function format2(documentText, range, options) {
  return format(documentText, range, options);
}
function modify(text, path3, value, options) {
  return setProperty(text, path3, value, options);
}
function applyEdits(text, edits) {
  let sortedEdits = edits.slice(0).sort((a, b) => {
    let diff2 = a.offset - b.offset;
    return diff2 === 0 ? a.length - b.length : diff2;
  }), lastModifiedOffset = text.length;
  for (let i = sortedEdits.length - 1; i >= 0; i--) {
    let e = sortedEdits[i];
    if (e.offset + e.length <= lastModifiedOffset)
      text = applyEdit(text, e);
    else
      throw new Error("Overlapping edit");
    lastModifiedOffset = e.offset;
  }
  return text;
}
var createScanner2, ScanError, SyntaxKind, getLocation2, parse2, parseTree2, findNodeAtLocation2, findNodeAtOffset2, getNodePath2, getNodeValue2, visit2, stripComments2, ParseErrorCode, init_main = __esm({
  "../../node_modules/.pnpm/jsonc-parser@3.2.1/node_modules/jsonc-parser/lib/umd/main.js"() {
    "use strict";
    init_cjs_shims();
    init_format();
    init_edit();
    init_scanner();
    init_parser();
    createScanner2 = createScanner;
    (function(ScanError2) {
      ScanError2[ScanError2.None = 0] = "None", ScanError2[ScanError2.UnexpectedEndOfComment = 1] = "UnexpectedEndOfComment", ScanError2[ScanError2.UnexpectedEndOfString = 2] = "UnexpectedEndOfString", ScanError2[ScanError2.UnexpectedEndOfNumber = 3] = "UnexpectedEndOfNumber", ScanError2[ScanError2.InvalidUnicode = 4] = "InvalidUnicode", ScanError2[ScanError2.InvalidEscapeCharacter = 5] = "InvalidEscapeCharacter", ScanError2[ScanError2.InvalidCharacter = 6] = "InvalidCharacter";
    })(ScanError || (ScanError = {}));
    (function(SyntaxKind2) {
      SyntaxKind2[SyntaxKind2.OpenBraceToken = 1] = "OpenBraceToken", SyntaxKind2[SyntaxKind2.CloseBraceToken = 2] = "CloseBraceToken", SyntaxKind2[SyntaxKind2.OpenBracketToken = 3] = "OpenBracketToken", SyntaxKind2[SyntaxKind2.CloseBracketToken = 4] = "CloseBracketToken", SyntaxKind2[SyntaxKind2.CommaToken = 5] = "CommaToken", SyntaxKind2[SyntaxKind2.ColonToken = 6] = "ColonToken", SyntaxKind2[SyntaxKind2.NullKeyword = 7] = "NullKeyword", SyntaxKind2[SyntaxKind2.TrueKeyword = 8] = "TrueKeyword", SyntaxKind2[SyntaxKind2.FalseKeyword = 9] = "FalseKeyword", SyntaxKind2[SyntaxKind2.StringLiteral = 10] = "StringLiteral", SyntaxKind2[SyntaxKind2.NumericLiteral = 11] = "NumericLiteral", SyntaxKind2[SyntaxKind2.LineCommentTrivia = 12] = "LineCommentTrivia", SyntaxKind2[SyntaxKind2.BlockCommentTrivia = 13] = "BlockCommentTrivia", SyntaxKind2[SyntaxKind2.LineBreakTrivia = 14] = "LineBreakTrivia", SyntaxKind2[SyntaxKind2.Trivia = 15] = "Trivia", SyntaxKind2[SyntaxKind2.Unknown = 16] = "Unknown", SyntaxKind2[SyntaxKind2.EOF = 17] = "EOF";
    })(SyntaxKind || (SyntaxKind = {}));
    getLocation2 = getLocation, parse2 = parse, parseTree2 = parseTree, findNodeAtLocation2 = findNodeAtLocation, findNodeAtOffset2 = findNodeAtOffset, getNodePath2 = getNodePath, getNodeValue2 = getNodeValue, visit2 = visit, stripComments2 = stripComments;
    (function(ParseErrorCode2) {
      ParseErrorCode2[ParseErrorCode2.InvalidSymbol = 1] = "InvalidSymbol", ParseErrorCode2[ParseErrorCode2.InvalidNumberFormat = 2] = "InvalidNumberFormat", ParseErrorCode2[ParseErrorCode2.PropertyNameExpected = 3] = "PropertyNameExpected", ParseErrorCode2[ParseErrorCode2.ValueExpected = 4] = "ValueExpected", ParseErrorCode2[ParseErrorCode2.ColonExpected = 5] = "ColonExpected", ParseErrorCode2[ParseErrorCode2.CommaExpected = 6] = "CommaExpected", ParseErrorCode2[ParseErrorCode2.CloseBraceExpected = 7] = "CloseBraceExpected", ParseErrorCode2[ParseErrorCode2.CloseBracketExpected = 8] = "CloseBracketExpected", ParseErrorCode2[ParseErrorCode2.EndOfFileExpected = 9] = "EndOfFileExpected", ParseErrorCode2[ParseErrorCode2.InvalidCommentToken = 10] = "InvalidCommentToken", ParseErrorCode2[ParseErrorCode2.UnexpectedEndOfComment = 11] = "UnexpectedEndOfComment", ParseErrorCode2[ParseErrorCode2.UnexpectedEndOfString = 12] = "UnexpectedEndOfString", ParseErrorCode2[ParseErrorCode2.UnexpectedEndOfNumber = 13] = "UnexpectedEndOfNumber", ParseErrorCode2[ParseErrorCode2.InvalidUnicode = 14] = "InvalidUnicode", ParseErrorCode2[ParseErrorCode2.InvalidEscapeCharacter = 15] = "InvalidEscapeCharacter", ParseErrorCode2[ParseErrorCode2.InvalidCharacter = 16] = "InvalidCharacter";
    })(ParseErrorCode || (ParseErrorCode = {}));
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/utils/objects.js
function equals(one, other) {
  if (one === other)
    return !0;
  if (one == null || other === null || other === void 0 || typeof one != typeof other || typeof one != "object" || Array.isArray(one) !== Array.isArray(other))
    return !1;
  let i, key;
  if (Array.isArray(one)) {
    if (one.length !== other.length)
      return !1;
    for (i = 0; i < one.length; i++)
      if (!equals(one[i], other[i]))
        return !1;
  } else {
    let oneKeys = [];
    for (key in one)
      oneKeys.push(key);
    oneKeys.sort();
    let otherKeys = [];
    for (key in other)
      otherKeys.push(key);
    if (otherKeys.sort(), !equals(oneKeys, otherKeys))
      return !1;
    for (i = 0; i < oneKeys.length; i++)
      if (!equals(one[oneKeys[i]], other[oneKeys[i]]))
        return !1;
  }
  return !0;
}
function isNumber(val) {
  return typeof val == "number";
}
function isDefined(val) {
  return typeof val < "u";
}
function isBoolean(val) {
  return typeof val == "boolean";
}
function isString(val) {
  return typeof val == "string";
}
function isObject(val) {
  return typeof val == "object" && val !== null && !Array.isArray(val);
}
var init_objects = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/utils/objects.js"() {
    init_cjs_shims();
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/utils/strings.js
function startsWith(haystack, needle) {
  if (haystack.length < needle.length)
    return !1;
  for (let i = 0; i < needle.length; i++)
    if (haystack[i] !== needle[i])
      return !1;
  return !0;
}
function endsWith(haystack, needle) {
  let diff2 = haystack.length - needle.length;
  return diff2 > 0 ? haystack.lastIndexOf(needle) === diff2 : diff2 === 0 ? haystack === needle : !1;
}
function extendedRegExp(pattern) {
  let flags = "";
  startsWith(pattern, "(?i)") && (pattern = pattern.substring(4), flags = "i");
  try {
    return new RegExp(pattern, flags + "u");
  } catch {
    try {
      return new RegExp(pattern, flags);
    } catch {
      return;
    }
  }
}
function stringLength(str) {
  let count = 0;
  for (let i = 0; i < str.length; i++) {
    count++;
    let code = str.charCodeAt(i);
    55296 <= code && code <= 56319 && i++;
  }
  return count;
}
var init_strings = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/utils/strings.js"() {
    init_cjs_shims();
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-types@3.17.5/node_modules/vscode-languageserver-types/lib/esm/main.js
var DocumentUri, URI, integer, uinteger, Position, Range, Location, LocationLink, Color, ColorInformation, ColorPresentation, FoldingRangeKind, FoldingRange, DiagnosticRelatedInformation, DiagnosticSeverity, DiagnosticTag, CodeDescription, Diagnostic, Command, TextEdit, ChangeAnnotation, ChangeAnnotationIdentifier, AnnotatedTextEdit, TextDocumentEdit, CreateFile, RenameFile, DeleteFile, WorkspaceEdit, TextDocumentIdentifier, VersionedTextDocumentIdentifier, OptionalVersionedTextDocumentIdentifier, TextDocumentItem, MarkupKind, MarkupContent, CompletionItemKind, InsertTextFormat, CompletionItemTag, InsertReplaceEdit, InsertTextMode, CompletionItemLabelDetails, CompletionItem, CompletionList, MarkedString, Hover, ParameterInformation, SignatureInformation, DocumentHighlightKind, DocumentHighlight, SymbolKind, SymbolTag, SymbolInformation, WorkspaceSymbol, DocumentSymbol, CodeActionKind, CodeActionTriggerKind, CodeActionContext, CodeAction, CodeLens, FormattingOptions, DocumentLink, SelectionRange, SemanticTokenTypes, SemanticTokenModifiers, SemanticTokens, InlineValueText, InlineValueVariableLookup, InlineValueEvaluatableExpression, InlineValueContext, InlayHintKind, InlayHintLabelPart, InlayHint, StringValue, InlineCompletionItem, InlineCompletionList, InlineCompletionTriggerKind, SelectedCompletionInfo, InlineCompletionContext, WorkspaceFolder, TextDocument, FullTextDocument, Is, init_main2 = __esm({
  "../../node_modules/.pnpm/vscode-languageserver-types@3.17.5/node_modules/vscode-languageserver-types/lib/esm/main.js"() {
    "use strict";
    init_cjs_shims();
    (function(DocumentUri3) {
      function is(value) {
        return typeof value == "string";
      }
      DocumentUri3.is = is;
    })(DocumentUri || (DocumentUri = {}));
    (function(URI4) {
      function is(value) {
        return typeof value == "string";
      }
      URI4.is = is;
    })(URI || (URI = {}));
    (function(integer3) {
      integer3.MIN_VALUE = -2147483648, integer3.MAX_VALUE = 2147483647;
      function is(value) {
        return typeof value == "number" && integer3.MIN_VALUE <= value && value <= integer3.MAX_VALUE;
      }
      integer3.is = is;
    })(integer || (integer = {}));
    (function(uinteger3) {
      uinteger3.MIN_VALUE = 0, uinteger3.MAX_VALUE = 2147483647;
      function is(value) {
        return typeof value == "number" && uinteger3.MIN_VALUE <= value && value <= uinteger3.MAX_VALUE;
      }
      uinteger3.is = is;
    })(uinteger || (uinteger = {}));
    (function(Position3) {
      function create(line, character) {
        return line === Number.MAX_VALUE && (line = uinteger.MAX_VALUE), character === Number.MAX_VALUE && (character = uinteger.MAX_VALUE), { line, character };
      }
      Position3.create = create;
      function is(value) {
        let candidate = value;
        return Is.objectLiteral(candidate) && Is.uinteger(candidate.line) && Is.uinteger(candidate.character);
      }
      Position3.is = is;
    })(Position || (Position = {}));
    (function(Range3) {
      function create(one, two, three, four) {
        if (Is.uinteger(one) && Is.uinteger(two) && Is.uinteger(three) && Is.uinteger(four))
          return { start: Position.create(one, two), end: Position.create(three, four) };
        if (Position.is(one) && Position.is(two))
          return { start: one, end: two };
        throw new Error(`Range#create called with invalid arguments[${one}, ${two}, ${three}, ${four}]`);
      }
      Range3.create = create;
      function is(value) {
        let candidate = value;
        return Is.objectLiteral(candidate) && Position.is(candidate.start) && Position.is(candidate.end);
      }
      Range3.is = is;
    })(Range || (Range = {}));
    (function(Location3) {
      function create(uri, range) {
        return { uri, range };
      }
      Location3.create = create;
      function is(value) {
        let candidate = value;
        return Is.objectLiteral(candidate) && Range.is(candidate.range) && (Is.string(candidate.uri) || Is.undefined(candidate.uri));
      }
      Location3.is = is;
    })(Location || (Location = {}));
    (function(LocationLink3) {
      function create(targetUri, targetRange, targetSelectionRange, originSelectionRange) {
        return { targetUri, targetRange, targetSelectionRange, originSelectionRange };
      }
      LocationLink3.create = create;
      function is(value) {
        let candidate = value;
        return Is.objectLiteral(candidate) && Range.is(candidate.targetRange) && Is.string(candidate.targetUri) && Range.is(candidate.targetSelectionRange) && (Range.is(candidate.originSelectionRange) || Is.undefined(candidate.originSelectionRange));
      }
      LocationLink3.is = is;
    })(LocationLink || (LocationLink = {}));
    (function(Color3) {
      function create(red, green, blue, alpha) {
        return {
          red,
          green,
          blue,
          alpha
        };
      }
      Color3.create = create;
      function is(value) {
        let candidate = value;
        return Is.objectLiteral(candidate) && Is.numberRange(candidate.red, 0, 1) && Is.numberRange(candidate.green, 0, 1) && Is.numberRange(candidate.blue, 0, 1) && Is.numberRange(candidate.alpha, 0, 1);
      }
      Color3.is = is;
    })(Color || (Color = {}));
    (function(ColorInformation3) {
      function create(range, color) {
        return {
          range,
          color
        };
      }
      ColorInformation3.create = create;
      function is(value) {
        let candidate = value;
        return Is.objectLiteral(candidate) && Range.is(candidate.range) && Color.is(candidate.color);
      }
      ColorInformation3.is = is;
    })(ColorInformation || (ColorInformation = {}));
    (function(ColorPresentation3) {
      function create(label, textEdit, additionalTextEdits) {
        return {
          label,
          textEdit,
          additionalTextEdits
        };
      }
      ColorPresentation3.create = create;
      function is(value) {
        let candidate = value;
        return Is.objectLiteral(candidate) && Is.string(candidate.label) && (Is.undefined(candidate.textEdit) || TextEdit.is(candidate)) && (Is.undefined(candidate.additionalTextEdits) || Is.typedArray(candidate.additionalTextEdits, TextEdit.is));
      }
      ColorPresentation3.is = is;
    })(ColorPresentation || (ColorPresentation = {}));
    (function(FoldingRangeKind3) {
      FoldingRangeKind3.Comment = "comment", FoldingRangeKind3.Imports = "imports", FoldingRangeKind3.Region = "region";
    })(FoldingRangeKind || (FoldingRangeKind = {}));
    (function(FoldingRange3) {
      function create(startLine, endLine, startCharacter, endCharacter, kind, collapsedText) {
        let result = {
          startLine,
          endLine
        };
        return Is.defined(startCharacter) && (result.startCharacter = startCharacter), Is.defined(endCharacter) && (result.endCharacter = endCharacter), Is.defined(kind) && (result.kind = kind), Is.defined(collapsedText) && (result.collapsedText = collapsedText), result;
      }
      FoldingRange3.create = create;
      function is(value) {
        let candidate = value;
        return Is.objectLiteral(candidate) && Is.uinteger(candidate.startLine) && Is.uinteger(candidate.startLine) && (Is.undefined(candidate.startCharacter) || Is.uinteger(candidate.startCharacter)) && (Is.undefined(candidate.endCharacter) || Is.uinteger(candidate.endCharacter)) && (Is.undefined(candidate.kind) || Is.string(candidate.kind));
      }
      FoldingRange3.is = is;
    })(FoldingRange || (FoldingRange = {}));
    (function(DiagnosticRelatedInformation3) {
      function create(location2, message) {
        return {
          location: location2,
          message
        };
      }
      DiagnosticRelatedInformation3.create = create;
      function is(value) {
        let candidate = value;
        return Is.defined(candidate) && Location.is(candidate.location) && Is.string(candidate.message);
      }
      DiagnosticRelatedInformation3.is = is;
    })(DiagnosticRelatedInformation || (DiagnosticRelatedInformation = {}));
    (function(DiagnosticSeverity3) {
      DiagnosticSeverity3.Error = 1, DiagnosticSeverity3.Warning = 2, DiagnosticSeverity3.Information = 3, DiagnosticSeverity3.Hint = 4;
    })(DiagnosticSeverity || (DiagnosticSeverity = {}));
    (function(DiagnosticTag3) {
      DiagnosticTag3.Unnecessary = 1, DiagnosticTag3.Deprecated = 2;
    })(DiagnosticTag || (DiagnosticTag = {}));
    (function(CodeDescription3) {
      function is(value) {
        let candidate = value;
        return Is.objectLiteral(candidate) && Is.string(candidate.href);
      }
      CodeDescription3.is = is;
    })(CodeDescription || (CodeDescription = {}));
    (function(Diagnostic3) {
      function create(range, message, severity, code, source, relatedInformation) {
        let result = { range, message };
        return Is.defined(severity) && (result.severity = severity), Is.defined(code) && (result.code = code), Is.defined(source) && (result.source = source), Is.defined(relatedInformation) && (result.relatedInformation = relatedInformation), result;
      }
      Diagnostic3.create = create;
      function is(value) {
        var _a38;
        let candidate = value;
        return Is.defined(candidate) && Range.is(candidate.range) && Is.string(candidate.message) && (Is.number(candidate.severity) || Is.undefined(candidate.severity)) && (Is.integer(candidate.code) || Is.string(candidate.code) || Is.undefined(candidate.code)) && (Is.undefined(candidate.codeDescription) || Is.string((_a38 = candidate.codeDescription) === null || _a38 === void 0 ? void 0 : _a38.href)) && (Is.string(candidate.source) || Is.undefined(candidate.source)) && (Is.undefined(candidate.relatedInformation) || Is.typedArray(candidate.relatedInformation, DiagnosticRelatedInformation.is));
      }
      Diagnostic3.is = is;
    })(Diagnostic || (Diagnostic = {}));
    (function(Command11) {
      function create(title, command, ...args) {
        let result = { title, command };
        return Is.defined(args) && args.length > 0 && (result.arguments = args), result;
      }
      Command11.create = create;
      function is(value) {
        let candidate = value;
        return Is.defined(candidate) && Is.string(candidate.title) && Is.string(candidate.command);
      }
      Command11.is = is;
    })(Command || (Command = {}));
    (function(TextEdit3) {
      function replace(range, newText) {
        return { range, newText };
      }
      TextEdit3.replace = replace;
      function insert2(position, newText) {
        return { range: { start: position, end: position }, newText };
      }
      TextEdit3.insert = insert2;
      function del(range) {
        return { range, newText: "" };
      }
      TextEdit3.del = del;
      function is(value) {
        let candidate = value;
        return Is.objectLiteral(candidate) && Is.string(candidate.newText) && Range.is(candidate.range);
      }
      TextEdit3.is = is;
    })(TextEdit || (TextEdit = {}));
    (function(ChangeAnnotation3) {
      function create(label, needsConfirmation, description) {
        let result = { label };
        return needsConfirmation !== void 0 && (result.needsConfirmation = needsConfirmation), description !== void 0 && (result.description = description), result;
      }
      ChangeAnnotation3.create = create;
      function is(value) {
        let candidate = value;
        return Is.objectLiteral(candidate) && Is.string(candidate.label) && (Is.boolean(candidate.needsConfirmation) || candidate.needsConfirmation === void 0) && (Is.string(candidate.description) || candidate.description === void 0);
      }
      ChangeAnnotation3.is = is;
    })(ChangeAnnotation || (ChangeAnnotation = {}));
    (function(ChangeAnnotationIdentifier3) {
      function is(value) {
        let candidate = value;
        return Is.string(candidate);
      }
      ChangeAnnotationIdentifier3.is = is;
    })(ChangeAnnotationIdentifier || (ChangeAnnotationIdentifier = {}));
    (function(AnnotatedTextEdit3) {
      function replace(range, newText, annotation) {
        return { range, newText, annotationId: annotation };
      }
      AnnotatedTextEdit3.replace = replace;
      function insert2(position, newText, annotation) {
        return { range: { start: position, end: position }, newText, annotationId: annotation };
      }
      AnnotatedTextEdit3.insert = insert2;
      function del(range, annotation) {
        return { range, newText: "", annotationId: annotation };
      }
      AnnotatedTextEdit3.del = del;
      function is(value) {
        let candidate = value;
        return TextEdit.is(candidate) && (ChangeAnnotation.is(candidate.annotationId) || ChangeAnnotationIdentifier.is(candidate.annotationId));
      }
      AnnotatedTextEdit3.is = is;
    })(AnnotatedTextEdit || (AnnotatedTextEdit = {}));
    (function(TextDocumentEdit3) {
      function create(textDocument, edits) {
        return { textDocument, edits };
      }
      TextDocumentEdit3.create = create;
      function is(value) {
        let candidate = value;
        return Is.defined(candidate) && OptionalVersionedTextDocumentIdentifier.is(candidate.textDocument) && Array.isArray(candidate.edits);
      }
      TextDocumentEdit3.is = is;
    })(TextDocumentEdit || (TextDocumentEdit = {}));
    (function(CreateFile3) {
      function create(uri, options, annotation) {
        let result = {
          kind: "create",
          uri
        };
        return options !== void 0 && (options.overwrite !== void 0 || options.ignoreIfExists !== void 0) && (result.options = options), annotation !== void 0 && (result.annotationId = annotation), result;
      }
      CreateFile3.create = create;
      function is(value) {
        let candidate = value;
        return candidate && candidate.kind === "create" && Is.string(candidate.uri) && (candidate.options === void 0 || (candidate.options.overwrite === void 0 || Is.boolean(candidate.options.overwrite)) && (candidate.options.ignoreIfExists === void 0 || Is.boolean(candidate.options.ignoreIfExists))) && (candidate.annotationId === void 0 || ChangeAnnotationIdentifier.is(candidate.annotationId));
      }
      CreateFile3.is = is;
    })(CreateFile || (CreateFile = {}));
    (function(RenameFile3) {
      function create(oldUri, newUri, options, annotation) {
        let result = {
          kind: "rename",
          oldUri,
          newUri
        };
        return options !== void 0 && (options.overwrite !== void 0 || options.ignoreIfExists !== void 0) && (result.options = options), annotation !== void 0 && (result.annotationId = annotation), result;
      }
      RenameFile3.create = create;
      function is(value) {
        let candidate = value;
        return candidate && candidate.kind === "rename" && Is.string(candidate.oldUri) && Is.string(candidate.newUri) && (candidate.options === void 0 || (candidate.options.overwrite === void 0 || Is.boolean(candidate.options.overwrite)) && (candidate.options.ignoreIfExists === void 0 || Is.boolean(candidate.options.ignoreIfExists))) && (candidate.annotationId === void 0 || ChangeAnnotationIdentifier.is(candidate.annotationId));
      }
      RenameFile3.is = is;
    })(RenameFile || (RenameFile = {}));
    (function(DeleteFile3) {
      function create(uri, options, annotation) {
        let result = {
          kind: "delete",
          uri
        };
        return options !== void 0 && (options.recursive !== void 0 || options.ignoreIfNotExists !== void 0) && (result.options = options), annotation !== void 0 && (result.annotationId = annotation), result;
      }
      DeleteFile3.create = create;
      function is(value) {
        let candidate = value;
        return candidate && candidate.kind === "delete" && Is.string(candidate.uri) && (candidate.options === void 0 || (candidate.options.recursive === void 0 || Is.boolean(candidate.options.recursive)) && (candidate.options.ignoreIfNotExists === void 0 || Is.boolean(candidate.options.ignoreIfNotExists))) && (candidate.annotationId === void 0 || ChangeAnnotationIdentifier.is(candidate.annotationId));
      }
      DeleteFile3.is = is;
    })(DeleteFile || (DeleteFile = {}));
    (function(WorkspaceEdit3) {
      function is(value) {
        let candidate = value;
        return candidate && (candidate.changes !== void 0 || candidate.documentChanges !== void 0) && (candidate.documentChanges === void 0 || candidate.documentChanges.every((change) => Is.string(change.kind) ? CreateFile.is(change) || RenameFile.is(change) || DeleteFile.is(change) : TextDocumentEdit.is(change)));
      }
      WorkspaceEdit3.is = is;
    })(WorkspaceEdit || (WorkspaceEdit = {}));
    (function(TextDocumentIdentifier3) {
      function create(uri) {
        return { uri };
      }
      TextDocumentIdentifier3.create = create;
      function is(value) {
        let candidate = value;
        return Is.defined(candidate) && Is.string(candidate.uri);
      }
      TextDocumentIdentifier3.is = is;
    })(TextDocumentIdentifier || (TextDocumentIdentifier = {}));
    (function(VersionedTextDocumentIdentifier3) {
      function create(uri, version2) {
        return { uri, version: version2 };
      }
      VersionedTextDocumentIdentifier3.create = create;
      function is(value) {
        let candidate = value;
        return Is.defined(candidate) && Is.string(candidate.uri) && Is.integer(candidate.version);
      }
      VersionedTextDocumentIdentifier3.is = is;
    })(VersionedTextDocumentIdentifier || (VersionedTextDocumentIdentifier = {}));
    (function(OptionalVersionedTextDocumentIdentifier3) {
      function create(uri, version2) {
        return { uri, version: version2 };
      }
      OptionalVersionedTextDocumentIdentifier3.create = create;
      function is(value) {
        let candidate = value;
        return Is.defined(candidate) && Is.string(candidate.uri) && (candidate.version === null || Is.integer(candidate.version));
      }
      OptionalVersionedTextDocumentIdentifier3.is = is;
    })(OptionalVersionedTextDocumentIdentifier || (OptionalVersionedTextDocumentIdentifier = {}));
    (function(TextDocumentItem3) {
      function create(uri, languageId, version2, text) {
        return { uri, languageId, version: version2, text };
      }
      TextDocumentItem3.create = create;
      function is(value) {
        let candidate = value;
        return Is.defined(candidate) && Is.string(candidate.uri) && Is.string(candidate.languageId) && Is.integer(candidate.version) && Is.string(candidate.text);
      }
      TextDocumentItem3.is = is;
    })(TextDocumentItem || (TextDocumentItem = {}));
    (function(MarkupKind3) {
      MarkupKind3.PlainText = "plaintext", MarkupKind3.Markdown = "markdown";
      function is(value) {
        let candidate = value;
        return candidate === MarkupKind3.PlainText || candidate === MarkupKind3.Markdown;
      }
      MarkupKind3.is = is;
    })(MarkupKind || (MarkupKind = {}));
    (function(MarkupContent3) {
      function is(value) {
        let candidate = value;
        return Is.objectLiteral(value) && MarkupKind.is(candidate.kind) && Is.string(candidate.value);
      }
      MarkupContent3.is = is;
    })(MarkupContent || (MarkupContent = {}));
    (function(CompletionItemKind3) {
      CompletionItemKind3.Text = 1, CompletionItemKind3.Method = 2, CompletionItemKind3.Function = 3, CompletionItemKind3.Constructor = 4, CompletionItemKind3.Field = 5, CompletionItemKind3.Variable = 6, CompletionItemKind3.Class = 7, CompletionItemKind3.Interface = 8, CompletionItemKind3.Module = 9, CompletionItemKind3.Property = 10, CompletionItemKind3.Unit = 11, CompletionItemKind3.Value = 12, CompletionItemKind3.Enum = 13, CompletionItemKind3.Keyword = 14, CompletionItemKind3.Snippet = 15, CompletionItemKind3.Color = 16, CompletionItemKind3.File = 17, CompletionItemKind3.Reference = 18, CompletionItemKind3.Folder = 19, CompletionItemKind3.EnumMember = 20, CompletionItemKind3.Constant = 21, CompletionItemKind3.Struct = 22, CompletionItemKind3.Event = 23, CompletionItemKind3.Operator = 24, CompletionItemKind3.TypeParameter = 25;
    })(CompletionItemKind || (CompletionItemKind = {}));
    (function(InsertTextFormat3) {
      InsertTextFormat3.PlainText = 1, InsertTextFormat3.Snippet = 2;
    })(InsertTextFormat || (InsertTextFormat = {}));
    (function(CompletionItemTag3) {
      CompletionItemTag3.Deprecated = 1;
    })(CompletionItemTag || (CompletionItemTag = {}));
    (function(InsertReplaceEdit3) {
      function create(newText, insert2, replace) {
        return { newText, insert: insert2, replace };
      }
      InsertReplaceEdit3.create = create;
      function is(value) {
        let candidate = value;
        return candidate && Is.string(candidate.newText) && Range.is(candidate.insert) && Range.is(candidate.replace);
      }
      InsertReplaceEdit3.is = is;
    })(InsertReplaceEdit || (InsertReplaceEdit = {}));
    (function(InsertTextMode3) {
      InsertTextMode3.asIs = 1, InsertTextMode3.adjustIndentation = 2;
    })(InsertTextMode || (InsertTextMode = {}));
    (function(CompletionItemLabelDetails3) {
      function is(value) {
        let candidate = value;
        return candidate && (Is.string(candidate.detail) || candidate.detail === void 0) && (Is.string(candidate.description) || candidate.description === void 0);
      }
      CompletionItemLabelDetails3.is = is;
    })(CompletionItemLabelDetails || (CompletionItemLabelDetails = {}));
    (function(CompletionItem3) {
      function create(label) {
        return { label };
      }
      CompletionItem3.create = create;
    })(CompletionItem || (CompletionItem = {}));
    (function(CompletionList3) {
      function create(items, isIncomplete) {
        return { items: items || [], isIncomplete: !!isIncomplete };
      }
      CompletionList3.create = create;
    })(CompletionList || (CompletionList = {}));
    (function(MarkedString3) {
      function fromPlainText(plainText) {
        return plainText.replace(/[\\`*_{}[\]()#+\-.!]/g, "\\$&");
      }
      MarkedString3.fromPlainText = fromPlainText;
      function is(value) {
        let candidate = value;
        return Is.string(candidate) || Is.objectLiteral(candidate) && Is.string(candidate.language) && Is.string(candidate.value);
      }
      MarkedString3.is = is;
    })(MarkedString || (MarkedString = {}));
    (function(Hover3) {
      function is(value) {
        let candidate = value;
        return !!candidate && Is.objectLiteral(candidate) && (MarkupContent.is(candidate.contents) || MarkedString.is(candidate.contents) || Is.typedArray(candidate.contents, MarkedString.is)) && (value.range === void 0 || Range.is(value.range));
      }
      Hover3.is = is;
    })(Hover || (Hover = {}));
    (function(ParameterInformation3) {
      function create(label, documentation) {
        return documentation ? { label, documentation } : { label };
      }
      ParameterInformation3.create = create;
    })(ParameterInformation || (ParameterInformation = {}));
    (function(SignatureInformation3) {
      function create(label, documentation, ...parameters) {
        let result = { label };
        return Is.defined(documentation) && (result.documentation = documentation), Is.defined(parameters) ? result.parameters = parameters : result.parameters = [], result;
      }
      SignatureInformation3.create = create;
    })(SignatureInformation || (SignatureInformation = {}));
    (function(DocumentHighlightKind3) {
      DocumentHighlightKind3.Text = 1, DocumentHighlightKind3.Read = 2, DocumentHighlightKind3.Write = 3;
    })(DocumentHighlightKind || (DocumentHighlightKind = {}));
    (function(DocumentHighlight3) {
      function create(range, kind) {
        let result = { range };
        return Is.number(kind) && (result.kind = kind), result;
      }
      DocumentHighlight3.create = create;
    })(DocumentHighlight || (DocumentHighlight = {}));
    (function(SymbolKind3) {
      SymbolKind3.File = 1, SymbolKind3.Module = 2, SymbolKind3.Namespace = 3, SymbolKind3.Package = 4, SymbolKind3.Class = 5, SymbolKind3.Method = 6, SymbolKind3.Property = 7, SymbolKind3.Field = 8, SymbolKind3.Constructor = 9, SymbolKind3.Enum = 10, SymbolKind3.Interface = 11, SymbolKind3.Function = 12, SymbolKind3.Variable = 13, SymbolKind3.Constant = 14, SymbolKind3.String = 15, SymbolKind3.Number = 16, SymbolKind3.Boolean = 17, SymbolKind3.Array = 18, SymbolKind3.Object = 19, SymbolKind3.Key = 20, SymbolKind3.Null = 21, SymbolKind3.EnumMember = 22, SymbolKind3.Struct = 23, SymbolKind3.Event = 24, SymbolKind3.Operator = 25, SymbolKind3.TypeParameter = 26;
    })(SymbolKind || (SymbolKind = {}));
    (function(SymbolTag3) {
      SymbolTag3.Deprecated = 1;
    })(SymbolTag || (SymbolTag = {}));
    (function(SymbolInformation3) {
      function create(name, kind, range, uri, containerName) {
        let result = {
          name,
          kind,
          location: { uri, range }
        };
        return containerName && (result.containerName = containerName), result;
      }
      SymbolInformation3.create = create;
    })(SymbolInformation || (SymbolInformation = {}));
    (function(WorkspaceSymbol3) {
      function create(name, kind, uri, range) {
        return range !== void 0 ? { name, kind, location: { uri, range } } : { name, kind, location: { uri } };
      }
      WorkspaceSymbol3.create = create;
    })(WorkspaceSymbol || (WorkspaceSymbol = {}));
    (function(DocumentSymbol3) {
      function create(name, detail, kind, range, selectionRange, children) {
        let result = {
          name,
          detail,
          kind,
          range,
          selectionRange
        };
        return children !== void 0 && (result.children = children), result;
      }
      DocumentSymbol3.create = create;
      function is(value) {
        let candidate = value;
        return candidate && Is.string(candidate.name) && Is.number(candidate.kind) && Range.is(candidate.range) && Range.is(candidate.selectionRange) && (candidate.detail === void 0 || Is.string(candidate.detail)) && (candidate.deprecated === void 0 || Is.boolean(candidate.deprecated)) && (candidate.children === void 0 || Array.isArray(candidate.children)) && (candidate.tags === void 0 || Array.isArray(candidate.tags));
      }
      DocumentSymbol3.is = is;
    })(DocumentSymbol || (DocumentSymbol = {}));
    (function(CodeActionKind3) {
      CodeActionKind3.Empty = "", CodeActionKind3.QuickFix = "quickfix", CodeActionKind3.Refactor = "refactor", CodeActionKind3.RefactorExtract = "refactor.extract", CodeActionKind3.RefactorInline = "refactor.inline", CodeActionKind3.RefactorRewrite = "refactor.rewrite", CodeActionKind3.Source = "source", CodeActionKind3.SourceOrganizeImports = "source.organizeImports", CodeActionKind3.SourceFixAll = "source.fixAll";
    })(CodeActionKind || (CodeActionKind = {}));
    (function(CodeActionTriggerKind3) {
      CodeActionTriggerKind3.Invoked = 1, CodeActionTriggerKind3.Automatic = 2;
    })(CodeActionTriggerKind || (CodeActionTriggerKind = {}));
    (function(CodeActionContext3) {
      function create(diagnostics, only, triggerKind) {
        let result = { diagnostics };
        return only != null && (result.only = only), triggerKind != null && (result.triggerKind = triggerKind), result;
      }
      CodeActionContext3.create = create;
      function is(value) {
        let candidate = value;
        return Is.defined(candidate) && Is.typedArray(candidate.diagnostics, Diagnostic.is) && (candidate.only === void 0 || Is.typedArray(candidate.only, Is.string)) && (candidate.triggerKind === void 0 || candidate.triggerKind === CodeActionTriggerKind.Invoked || candidate.triggerKind === CodeActionTriggerKind.Automatic);
      }
      CodeActionContext3.is = is;
    })(CodeActionContext || (CodeActionContext = {}));
    (function(CodeAction3) {
      function create(title, kindOrCommandOrEdit, kind) {
        let result = { title }, checkKind = !0;
        return typeof kindOrCommandOrEdit == "string" ? (checkKind = !1, result.kind = kindOrCommandOrEdit) : Command.is(kindOrCommandOrEdit) ? result.command = kindOrCommandOrEdit : result.edit = kindOrCommandOrEdit, checkKind && kind !== void 0 && (result.kind = kind), result;
      }
      CodeAction3.create = create;
      function is(value) {
        let candidate = value;
        return candidate && Is.string(candidate.title) && (candidate.diagnostics === void 0 || Is.typedArray(candidate.diagnostics, Diagnostic.is)) && (candidate.kind === void 0 || Is.string(candidate.kind)) && (candidate.edit !== void 0 || candidate.command !== void 0) && (candidate.command === void 0 || Command.is(candidate.command)) && (candidate.isPreferred === void 0 || Is.boolean(candidate.isPreferred)) && (candidate.edit === void 0 || WorkspaceEdit.is(candidate.edit));
      }
      CodeAction3.is = is;
    })(CodeAction || (CodeAction = {}));
    (function(CodeLens3) {
      function create(range, data) {
        let result = { range };
        return Is.defined(data) && (result.data = data), result;
      }
      CodeLens3.create = create;
      function is(value) {
        let candidate = value;
        return Is.defined(candidate) && Range.is(candidate.range) && (Is.undefined(candidate.command) || Command.is(candidate.command));
      }
      CodeLens3.is = is;
    })(CodeLens || (CodeLens = {}));
    (function(FormattingOptions3) {
      function create(tabSize, insertSpaces) {
        return { tabSize, insertSpaces };
      }
      FormattingOptions3.create = create;
      function is(value) {
        let candidate = value;
        return Is.defined(candidate) && Is.uinteger(candidate.tabSize) && Is.boolean(candidate.insertSpaces);
      }
      FormattingOptions3.is = is;
    })(FormattingOptions || (FormattingOptions = {}));
    (function(DocumentLink3) {
      function create(range, target, data) {
        return { range, target, data };
      }
      DocumentLink3.create = create;
      function is(value) {
        let candidate = value;
        return Is.defined(candidate) && Range.is(candidate.range) && (Is.undefined(candidate.target) || Is.string(candidate.target));
      }
      DocumentLink3.is = is;
    })(DocumentLink || (DocumentLink = {}));
    (function(SelectionRange3) {
      function create(range, parent) {
        return { range, parent };
      }
      SelectionRange3.create = create;
      function is(value) {
        let candidate = value;
        return Is.objectLiteral(candidate) && Range.is(candidate.range) && (candidate.parent === void 0 || SelectionRange3.is(candidate.parent));
      }
      SelectionRange3.is = is;
    })(SelectionRange || (SelectionRange = {}));
    (function(SemanticTokenTypes3) {
      SemanticTokenTypes3.namespace = "namespace", SemanticTokenTypes3.type = "type", SemanticTokenTypes3.class = "class", SemanticTokenTypes3.enum = "enum", SemanticTokenTypes3.interface = "interface", SemanticTokenTypes3.struct = "struct", SemanticTokenTypes3.typeParameter = "typeParameter", SemanticTokenTypes3.parameter = "parameter", SemanticTokenTypes3.variable = "variable", SemanticTokenTypes3.property = "property", SemanticTokenTypes3.enumMember = "enumMember", SemanticTokenTypes3.event = "event", SemanticTokenTypes3.function = "function", SemanticTokenTypes3.method = "method", SemanticTokenTypes3.macro = "macro", SemanticTokenTypes3.keyword = "keyword", SemanticTokenTypes3.modifier = "modifier", SemanticTokenTypes3.comment = "comment", SemanticTokenTypes3.string = "string", SemanticTokenTypes3.number = "number", SemanticTokenTypes3.regexp = "regexp", SemanticTokenTypes3.operator = "operator", SemanticTokenTypes3.decorator = "decorator";
    })(SemanticTokenTypes || (SemanticTokenTypes = {}));
    (function(SemanticTokenModifiers3) {
      SemanticTokenModifiers3.declaration = "declaration", SemanticTokenModifiers3.definition = "definition", SemanticTokenModifiers3.readonly = "readonly", SemanticTokenModifiers3.static = "static", SemanticTokenModifiers3.deprecated = "deprecated", SemanticTokenModifiers3.abstract = "abstract", SemanticTokenModifiers3.async = "async", SemanticTokenModifiers3.modification = "modification", SemanticTokenModifiers3.documentation = "documentation", SemanticTokenModifiers3.defaultLibrary = "defaultLibrary";
    })(SemanticTokenModifiers || (SemanticTokenModifiers = {}));
    (function(SemanticTokens3) {
      function is(value) {
        let candidate = value;
        return Is.objectLiteral(candidate) && (candidate.resultId === void 0 || typeof candidate.resultId == "string") && Array.isArray(candidate.data) && (candidate.data.length === 0 || typeof candidate.data[0] == "number");
      }
      SemanticTokens3.is = is;
    })(SemanticTokens || (SemanticTokens = {}));
    (function(InlineValueText3) {
      function create(range, text) {
        return { range, text };
      }
      InlineValueText3.create = create;
      function is(value) {
        let candidate = value;
        return candidate != null && Range.is(candidate.range) && Is.string(candidate.text);
      }
      InlineValueText3.is = is;
    })(InlineValueText || (InlineValueText = {}));
    (function(InlineValueVariableLookup3) {
      function create(range, variableName, caseSensitiveLookup) {
        return { range, variableName, caseSensitiveLookup };
      }
      InlineValueVariableLookup3.create = create;
      function is(value) {
        let candidate = value;
        return candidate != null && Range.is(candidate.range) && Is.boolean(candidate.caseSensitiveLookup) && (Is.string(candidate.variableName) || candidate.variableName === void 0);
      }
      InlineValueVariableLookup3.is = is;
    })(InlineValueVariableLookup || (InlineValueVariableLookup = {}));
    (function(InlineValueEvaluatableExpression3) {
      function create(range, expression) {
        return { range, expression };
      }
      InlineValueEvaluatableExpression3.create = create;
      function is(value) {
        let candidate = value;
        return candidate != null && Range.is(candidate.range) && (Is.string(candidate.expression) || candidate.expression === void 0);
      }
      InlineValueEvaluatableExpression3.is = is;
    })(InlineValueEvaluatableExpression || (InlineValueEvaluatableExpression = {}));
    (function(InlineValueContext3) {
      function create(frameId, stoppedLocation) {
        return { frameId, stoppedLocation };
      }
      InlineValueContext3.create = create;
      function is(value) {
        let candidate = value;
        return Is.defined(candidate) && Range.is(value.stoppedLocation);
      }
      InlineValueContext3.is = is;
    })(InlineValueContext || (InlineValueContext = {}));
    (function(InlayHintKind3) {
      InlayHintKind3.Type = 1, InlayHintKind3.Parameter = 2;
      function is(value) {
        return value === 1 || value === 2;
      }
      InlayHintKind3.is = is;
    })(InlayHintKind || (InlayHintKind = {}));
    (function(InlayHintLabelPart3) {
      function create(value) {
        return { value };
      }
      InlayHintLabelPart3.create = create;
      function is(value) {
        let candidate = value;
        return Is.objectLiteral(candidate) && (candidate.tooltip === void 0 || Is.string(candidate.tooltip) || MarkupContent.is(candidate.tooltip)) && (candidate.location === void 0 || Location.is(candidate.location)) && (candidate.command === void 0 || Command.is(candidate.command));
      }
      InlayHintLabelPart3.is = is;
    })(InlayHintLabelPart || (InlayHintLabelPart = {}));
    (function(InlayHint3) {
      function create(position, label, kind) {
        let result = { position, label };
        return kind !== void 0 && (result.kind = kind), result;
      }
      InlayHint3.create = create;
      function is(value) {
        let candidate = value;
        return Is.objectLiteral(candidate) && Position.is(candidate.position) && (Is.string(candidate.label) || Is.typedArray(candidate.label, InlayHintLabelPart.is)) && (candidate.kind === void 0 || InlayHintKind.is(candidate.kind)) && candidate.textEdits === void 0 || Is.typedArray(candidate.textEdits, TextEdit.is) && (candidate.tooltip === void 0 || Is.string(candidate.tooltip) || MarkupContent.is(candidate.tooltip)) && (candidate.paddingLeft === void 0 || Is.boolean(candidate.paddingLeft)) && (candidate.paddingRight === void 0 || Is.boolean(candidate.paddingRight));
      }
      InlayHint3.is = is;
    })(InlayHint || (InlayHint = {}));
    (function(StringValue2) {
      function createSnippet(value) {
        return { kind: "snippet", value };
      }
      StringValue2.createSnippet = createSnippet;
    })(StringValue || (StringValue = {}));
    (function(InlineCompletionItem2) {
      function create(insertText, filterText, range, command) {
        return { insertText, filterText, range, command };
      }
      InlineCompletionItem2.create = create;
    })(InlineCompletionItem || (InlineCompletionItem = {}));
    (function(InlineCompletionList2) {
      function create(items) {
        return { items };
      }
      InlineCompletionList2.create = create;
    })(InlineCompletionList || (InlineCompletionList = {}));
    (function(InlineCompletionTriggerKind2) {
      InlineCompletionTriggerKind2.Invoked = 0, InlineCompletionTriggerKind2.Automatic = 1;
    })(InlineCompletionTriggerKind || (InlineCompletionTriggerKind = {}));
    (function(SelectedCompletionInfo2) {
      function create(range, text) {
        return { range, text };
      }
      SelectedCompletionInfo2.create = create;
    })(SelectedCompletionInfo || (SelectedCompletionInfo = {}));
    (function(InlineCompletionContext2) {
      function create(triggerKind, selectedCompletionInfo) {
        return { triggerKind, selectedCompletionInfo };
      }
      InlineCompletionContext2.create = create;
    })(InlineCompletionContext || (InlineCompletionContext = {}));
    (function(WorkspaceFolder3) {
      function is(value) {
        let candidate = value;
        return Is.objectLiteral(candidate) && URI.is(candidate.uri) && Is.string(candidate.name);
      }
      WorkspaceFolder3.is = is;
    })(WorkspaceFolder || (WorkspaceFolder = {}));
    (function(TextDocument5) {
      function create(uri, languageId, version2, content) {
        return new FullTextDocument(uri, languageId, version2, content);
      }
      TextDocument5.create = create;
      function is(value) {
        let candidate = value;
        return !!(Is.defined(candidate) && Is.string(candidate.uri) && (Is.undefined(candidate.languageId) || Is.string(candidate.languageId)) && Is.uinteger(candidate.lineCount) && Is.func(candidate.getText) && Is.func(candidate.positionAt) && Is.func(candidate.offsetAt));
      }
      TextDocument5.is = is;
      function applyEdits2(document2, edits) {
        let text = document2.getText(), sortedEdits = mergeSort3(edits, (a, b) => {
          let diff2 = a.range.start.line - b.range.start.line;
          return diff2 === 0 ? a.range.start.character - b.range.start.character : diff2;
        }), lastModifiedOffset = text.length;
        for (let i = sortedEdits.length - 1; i >= 0; i--) {
          let e = sortedEdits[i], startOffset = document2.offsetAt(e.range.start), endOffset = document2.offsetAt(e.range.end);
          if (endOffset <= lastModifiedOffset)
            text = text.substring(0, startOffset) + e.newText + text.substring(endOffset, text.length);
          else
            throw new Error("Overlapping edit");
          lastModifiedOffset = startOffset;
        }
        return text;
      }
      TextDocument5.applyEdits = applyEdits2;
      function mergeSort3(data, compare2) {
        if (data.length <= 1)
          return data;
        let p = data.length / 2 | 0, left = data.slice(0, p), right = data.slice(p);
        mergeSort3(left, compare2), mergeSort3(right, compare2);
        let leftIdx = 0, rightIdx = 0, i = 0;
        for (; leftIdx < left.length && rightIdx < right.length; )
          compare2(left[leftIdx], right[rightIdx]) <= 0 ? data[i++] = left[leftIdx++] : data[i++] = right[rightIdx++];
        for (; leftIdx < left.length; )
          data[i++] = left[leftIdx++];
        for (; rightIdx < right.length; )
          data[i++] = right[rightIdx++];
        return data;
      }
    })(TextDocument || (TextDocument = {}));
    FullTextDocument = class {
      constructor(uri, languageId, version2, content) {
        this._uri = uri, this._languageId = languageId, this._version = version2, this._content = content, this._lineOffsets = void 0;
      }
      get uri() {
        return this._uri;
      }
      get languageId() {
        return this._languageId;
      }
      get version() {
        return this._version;
      }
      getText(range) {
        if (range) {
          let start = this.offsetAt(range.start), end = this.offsetAt(range.end);
          return this._content.substring(start, end);
        }
        return this._content;
      }
      update(event, version2) {
        this._content = event.text, this._version = version2, this._lineOffsets = void 0;
      }
      getLineOffsets() {
        if (this._lineOffsets === void 0) {
          let lineOffsets = [], text = this._content, isLineStart = !0;
          for (let i = 0; i < text.length; i++) {
            isLineStart && (lineOffsets.push(i), isLineStart = !1);
            let ch = text.charAt(i);
            isLineStart = ch === "\r" || ch === `
`, ch === "\r" && i + 1 < text.length && text.charAt(i + 1) === `
` && i++;
          }
          isLineStart && text.length > 0 && lineOffsets.push(text.length), this._lineOffsets = lineOffsets;
        }
        return this._lineOffsets;
      }
      positionAt(offset) {
        offset = Math.max(Math.min(offset, this._content.length), 0);
        let lineOffsets = this.getLineOffsets(), low = 0, high = lineOffsets.length;
        if (high === 0)
          return Position.create(0, offset);
        for (; low < high; ) {
          let mid = Math.floor((low + high) / 2);
          lineOffsets[mid] > offset ? high = mid : low = mid + 1;
        }
        let line = low - 1;
        return Position.create(line, offset - lineOffsets[line]);
      }
      offsetAt(position) {
        let lineOffsets = this.getLineOffsets();
        if (position.line >= lineOffsets.length)
          return this._content.length;
        if (position.line < 0)
          return 0;
        let lineOffset = lineOffsets[position.line], nextLineOffset = position.line + 1 < lineOffsets.length ? lineOffsets[position.line + 1] : this._content.length;
        return Math.max(Math.min(lineOffset + position.character, nextLineOffset), lineOffset);
      }
      get lineCount() {
        return this.getLineOffsets().length;
      }
    };
    (function(Is3) {
      let toString2 = Object.prototype.toString;
      function defined(value) {
        return typeof value < "u";
      }
      Is3.defined = defined;
      function undefined2(value) {
        return typeof value > "u";
      }
      Is3.undefined = undefined2;
      function boolean(value) {
        return value === !0 || value === !1;
      }
      Is3.boolean = boolean;
      function string(value) {
        return toString2.call(value) === "[object String]";
      }
      Is3.string = string;
      function number(value) {
        return toString2.call(value) === "[object Number]";
      }
      Is3.number = number;
      function numberRange(value, min, max) {
        return toString2.call(value) === "[object Number]" && min <= value && value <= max;
      }
      Is3.numberRange = numberRange;
      function integer3(value) {
        return toString2.call(value) === "[object Number]" && -2147483648 <= value && value <= 2147483647;
      }
      Is3.integer = integer3;
      function uinteger3(value) {
        return toString2.call(value) === "[object Number]" && 0 <= value && value <= 2147483647;
      }
      Is3.uinteger = uinteger3;
      function func(value) {
        return toString2.call(value) === "[object Function]";
      }
      Is3.func = func;
      function objectLiteral(value) {
        return value !== null && typeof value == "object";
      }
      Is3.objectLiteral = objectLiteral;
      function typedArray(value, check2) {
        return Array.isArray(value) && value.every(check2);
      }
      Is3.typedArray = typedArray;
    })(Is || (Is = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-textdocument@1.0.11/node_modules/vscode-languageserver-textdocument/lib/esm/main.js
function mergeSort(data, compare2) {
  if (data.length <= 1)
    return data;
  let p = data.length / 2 | 0, left = data.slice(0, p), right = data.slice(p);
  mergeSort(left, compare2), mergeSort(right, compare2);
  let leftIdx = 0, rightIdx = 0, i = 0;
  for (; leftIdx < left.length && rightIdx < right.length; )
    compare2(left[leftIdx], right[rightIdx]) <= 0 ? data[i++] = left[leftIdx++] : data[i++] = right[rightIdx++];
  for (; leftIdx < left.length; )
    data[i++] = left[leftIdx++];
  for (; rightIdx < right.length; )
    data[i++] = right[rightIdx++];
  return data;
}
function computeLineOffsets(text, isAtLineStart, textOffset = 0) {
  let result = isAtLineStart ? [textOffset] : [];
  for (let i = 0; i < text.length; i++) {
    let ch = text.charCodeAt(i);
    (ch === 13 || ch === 10) && (ch === 13 && i + 1 < text.length && text.charCodeAt(i + 1) === 10 && i++, result.push(textOffset + i + 1));
  }
  return result;
}
function getWellformedRange(range) {
  let start = range.start, end = range.end;
  return start.line > end.line || start.line === end.line && start.character > end.character ? { start: end, end: start } : range;
}
function getWellformedEdit(textEdit) {
  let range = getWellformedRange(textEdit.range);
  return range !== textEdit.range ? { newText: textEdit.newText, range } : textEdit;
}
var FullTextDocument2, TextDocument2, init_main3 = __esm({
  "../../node_modules/.pnpm/vscode-languageserver-textdocument@1.0.11/node_modules/vscode-languageserver-textdocument/lib/esm/main.js"() {
    "use strict";
    init_cjs_shims();
    FullTextDocument2 = class _FullTextDocument {
      constructor(uri, languageId, version2, content) {
        this._uri = uri, this._languageId = languageId, this._version = version2, this._content = content, this._lineOffsets = void 0;
      }
      get uri() {
        return this._uri;
      }
      get languageId() {
        return this._languageId;
      }
      get version() {
        return this._version;
      }
      getText(range) {
        if (range) {
          let start = this.offsetAt(range.start), end = this.offsetAt(range.end);
          return this._content.substring(start, end);
        }
        return this._content;
      }
      update(changes, version2) {
        for (let change of changes)
          if (_FullTextDocument.isIncremental(change)) {
            let range = getWellformedRange(change.range), startOffset = this.offsetAt(range.start), endOffset = this.offsetAt(range.end);
            this._content = this._content.substring(0, startOffset) + change.text + this._content.substring(endOffset, this._content.length);
            let startLine = Math.max(range.start.line, 0), endLine = Math.max(range.end.line, 0), lineOffsets = this._lineOffsets, addedLineOffsets = computeLineOffsets(change.text, !1, startOffset);
            if (endLine - startLine === addedLineOffsets.length)
              for (let i = 0, len = addedLineOffsets.length; i < len; i++)
                lineOffsets[i + startLine + 1] = addedLineOffsets[i];
            else
              addedLineOffsets.length < 1e4 ? lineOffsets.splice(startLine + 1, endLine - startLine, ...addedLineOffsets) : this._lineOffsets = lineOffsets = lineOffsets.slice(0, startLine + 1).concat(addedLineOffsets, lineOffsets.slice(endLine + 1));
            let diff2 = change.text.length - (endOffset - startOffset);
            if (diff2 !== 0)
              for (let i = startLine + 1 + addedLineOffsets.length, len = lineOffsets.length; i < len; i++)
                lineOffsets[i] = lineOffsets[i] + diff2;
          } else if (_FullTextDocument.isFull(change))
            this._content = change.text, this._lineOffsets = void 0;
          else
            throw new Error("Unknown change event received");
        this._version = version2;
      }
      getLineOffsets() {
        return this._lineOffsets === void 0 && (this._lineOffsets = computeLineOffsets(this._content, !0)), this._lineOffsets;
      }
      positionAt(offset) {
        offset = Math.max(Math.min(offset, this._content.length), 0);
        let lineOffsets = this.getLineOffsets(), low = 0, high = lineOffsets.length;
        if (high === 0)
          return { line: 0, character: offset };
        for (; low < high; ) {
          let mid = Math.floor((low + high) / 2);
          lineOffsets[mid] > offset ? high = mid : low = mid + 1;
        }
        let line = low - 1;
        return { line, character: offset - lineOffsets[line] };
      }
      offsetAt(position) {
        let lineOffsets = this.getLineOffsets();
        if (position.line >= lineOffsets.length)
          return this._content.length;
        if (position.line < 0)
          return 0;
        let lineOffset = lineOffsets[position.line], nextLineOffset = position.line + 1 < lineOffsets.length ? lineOffsets[position.line + 1] : this._content.length;
        return Math.max(Math.min(lineOffset + position.character, nextLineOffset), lineOffset);
      }
      get lineCount() {
        return this.getLineOffsets().length;
      }
      static isIncremental(event) {
        let candidate = event;
        return candidate != null && typeof candidate.text == "string" && candidate.range !== void 0 && (candidate.rangeLength === void 0 || typeof candidate.rangeLength == "number");
      }
      static isFull(event) {
        let candidate = event;
        return candidate != null && typeof candidate.text == "string" && candidate.range === void 0 && candidate.rangeLength === void 0;
      }
    };
    (function(TextDocument5) {
      function create(uri, languageId, version2, content) {
        return new FullTextDocument2(uri, languageId, version2, content);
      }
      TextDocument5.create = create;
      function update2(document2, changes, version2) {
        if (document2 instanceof FullTextDocument2)
          return document2.update(changes, version2), document2;
        throw new Error("TextDocument.update: document must be created by TextDocument.create");
      }
      TextDocument5.update = update2;
      function applyEdits2(document2, edits) {
        let text = document2.getText(), sortedEdits = mergeSort(edits.map(getWellformedEdit), (a, b) => {
          let diff2 = a.range.start.line - b.range.start.line;
          return diff2 === 0 ? a.range.start.character - b.range.start.character : diff2;
        }), lastModifiedOffset = 0, spans = [];
        for (let e of sortedEdits) {
          let startOffset = document2.offsetAt(e.range.start);
          if (startOffset < lastModifiedOffset)
            throw new Error("Overlapping edit");
          startOffset > lastModifiedOffset && spans.push(text.substring(lastModifiedOffset, startOffset)), e.newText.length && spans.push(e.newText), lastModifiedOffset = document2.offsetAt(e.range.end);
        }
        return spans.push(text.substr(lastModifiedOffset)), spans.join("");
      }
      TextDocument5.applyEdits = applyEdits2;
    })(TextDocument2 || (TextDocument2 = {}));
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/jsonLanguageTypes.js
var ErrorCode, SchemaDraft, ClientCapabilities, init_jsonLanguageTypes = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/jsonLanguageTypes.js"() {
    init_cjs_shims();
    init_main2();
    init_main3();
    (function(ErrorCode2) {
      ErrorCode2[ErrorCode2.Undefined = 0] = "Undefined", ErrorCode2[ErrorCode2.EnumValueMismatch = 1] = "EnumValueMismatch", ErrorCode2[ErrorCode2.Deprecated = 2] = "Deprecated", ErrorCode2[ErrorCode2.UnexpectedEndOfComment = 257] = "UnexpectedEndOfComment", ErrorCode2[ErrorCode2.UnexpectedEndOfString = 258] = "UnexpectedEndOfString", ErrorCode2[ErrorCode2.UnexpectedEndOfNumber = 259] = "UnexpectedEndOfNumber", ErrorCode2[ErrorCode2.InvalidUnicode = 260] = "InvalidUnicode", ErrorCode2[ErrorCode2.InvalidEscapeCharacter = 261] = "InvalidEscapeCharacter", ErrorCode2[ErrorCode2.InvalidCharacter = 262] = "InvalidCharacter", ErrorCode2[ErrorCode2.PropertyExpected = 513] = "PropertyExpected", ErrorCode2[ErrorCode2.CommaExpected = 514] = "CommaExpected", ErrorCode2[ErrorCode2.ColonExpected = 515] = "ColonExpected", ErrorCode2[ErrorCode2.ValueExpected = 516] = "ValueExpected", ErrorCode2[ErrorCode2.CommaOrCloseBacketExpected = 517] = "CommaOrCloseBacketExpected", ErrorCode2[ErrorCode2.CommaOrCloseBraceExpected = 518] = "CommaOrCloseBraceExpected", ErrorCode2[ErrorCode2.TrailingComma = 519] = "TrailingComma", ErrorCode2[ErrorCode2.DuplicateKey = 520] = "DuplicateKey", ErrorCode2[ErrorCode2.CommentNotPermitted = 521] = "CommentNotPermitted", ErrorCode2[ErrorCode2.PropertyKeysMustBeDoublequoted = 528] = "PropertyKeysMustBeDoublequoted", ErrorCode2[ErrorCode2.SchemaResolveError = 768] = "SchemaResolveError", ErrorCode2[ErrorCode2.SchemaUnsupportedFeature = 769] = "SchemaUnsupportedFeature";
    })(ErrorCode || (ErrorCode = {}));
    (function(SchemaDraft2) {
      SchemaDraft2[SchemaDraft2.v3 = 3] = "v3", SchemaDraft2[SchemaDraft2.v4 = 4] = "v4", SchemaDraft2[SchemaDraft2.v6 = 6] = "v6", SchemaDraft2[SchemaDraft2.v7 = 7] = "v7", SchemaDraft2[SchemaDraft2.v2019_09 = 19] = "v2019_09", SchemaDraft2[SchemaDraft2.v2020_12 = 20] = "v2020_12";
    })(SchemaDraft || (SchemaDraft = {}));
    (function(ClientCapabilities2) {
      ClientCapabilities2.LATEST = {
        textDocument: {
          completion: {
            completionItem: {
              documentationFormat: [MarkupKind.Markdown, MarkupKind.PlainText],
              commitCharactersSupport: !0,
              labelDetailsSupport: !0
            }
          }
        }
      };
    })(ClientCapabilities || (ClientCapabilities = {}));
  }
});

// ../../node_modules/.pnpm/@vscode+l10n@0.0.18/node_modules/@vscode/l10n/dist/main.js
var require_main2 = __commonJS({
  "../../node_modules/.pnpm/@vscode+l10n@0.0.18/node_modules/@vscode/l10n/dist/main.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var __defProp = Object.defineProperty, __getOwnPropDesc = Object.getOwnPropertyDescriptor, __getOwnPropNames = Object.getOwnPropertyNames, __hasOwnProp = Object.prototype.hasOwnProperty, __export2 = (target, all) => {
      for (var name in all)
        __defProp(target, name, { get: all[name], enumerable: !0 });
    }, __copyProps = (to, from, except, desc) => {
      if (from && typeof from == "object" || typeof from == "function")
        for (let key of __getOwnPropNames(from))
          !__hasOwnProp.call(to, key) && key !== except && __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
      return to;
    }, __toCommonJS2 = (mod) => __copyProps(__defProp({}, "__esModule", { value: !0 }), mod), main_exports4 = {};
    __export2(main_exports4, {
      config: () => config2,
      t: () => t7
    });
    module.exports = __toCommonJS2(main_exports4);
    var import_fs84 = __require("fs"), import_promises11 = __require("fs/promises");
    async function readFileFromUri(uri) {
      if (uri.protocol === "file:")
        return await (0, import_promises11.readFile)(uri, "utf8");
      if (uri.protocol === "http:" || uri.protocol === "https:") {
        let res = await fetch(uri.toString(), {
          headers: {
            "Accept-Encoding": "gzip, deflate",
            Accept: "application/json"
          },
          redirect: "follow"
        });
        if (!res.ok) {
          let error = `Unexpected ${res.status} response while trying to read ${uri}`;
          try {
            error += `: ${await res.text()}`;
          } catch {
          }
          throw new Error(error);
        }
        return await res.text();
      }
      throw new Error("Unsupported protocol");
    }
    function readFileFromFsPath(fsPath) {
      return (0, import_fs84.readFileSync)(fsPath, "utf8");
    }
    var bundle;
    function config2(config22) {
      if ("contents" in config22) {
        typeof config22.contents == "string" ? bundle = JSON.parse(config22.contents) : bundle = config22.contents;
        return;
      }
      if ("fsPath" in config22) {
        let fileContent = readFileFromFsPath(config22.fsPath), content = JSON.parse(fileContent);
        bundle = isBuiltinExtension(content) ? content.contents.bundle : content;
        return;
      }
      if (config22.uri) {
        let uri = config22.uri;
        return typeof config22.uri == "string" && (uri = new URL(config22.uri)), new Promise((resolve2, reject) => {
          readFileFromUri(uri).then((uriContent) => {
            try {
              let content = JSON.parse(uriContent);
              bundle = isBuiltinExtension(content) ? content.contents.bundle : content, resolve2();
            } catch (err2) {
              reject(err2);
            }
          }).catch((err2) => {
            reject(err2);
          });
        });
      }
    }
    function t7(...args) {
      let firstArg = args[0], key, message, formatArgs;
      if (typeof firstArg == "string")
        key = firstArg, message = firstArg, args.splice(0, 1), formatArgs = !args || typeof args[0] != "object" ? args : args[0];
      else if (firstArg instanceof Array) {
        let replacements = args.slice(1);
        if (firstArg.length !== replacements.length + 1)
          throw new Error("expected a string as the first argument to l10n.t");
        let str = firstArg[0];
        for (let i = 1; i < firstArg.length; i++)
          str += `{${i - 1}}` + firstArg[i];
        return t7(str, ...replacements);
      } else
        message = firstArg.message, key = message, firstArg.comment && firstArg.comment.length > 0 && (key += `/${Array.isArray(firstArg.comment) ? firstArg.comment.join("") : firstArg.comment}`), formatArgs = firstArg.args ?? {};
      let messageFromBundle = bundle?.[key];
      return messageFromBundle ? typeof messageFromBundle == "string" ? format4(messageFromBundle, formatArgs) : messageFromBundle.comment ? format4(messageFromBundle.message, formatArgs) : format4(message, formatArgs) : format4(message, formatArgs);
    }
    var _format2Regexp = /{([^}]+)}/g;
    function format4(template2, values) {
      return Object.keys(values).length === 0 ? template2 : template2.replace(_format2Regexp, (match2, group) => values[group] ?? match2);
    }
    function isBuiltinExtension(json) {
      return typeof json?.contents?.bundle == "object" && typeof json?.version == "string";
    }
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/parser/jsonParser.js
function asSchema(schema) {
  return isBoolean(schema) ? schema ? {} : { not: {} } : schema;
}
function newJSONDocument(root, diagnostics = []) {
  return new JSONDocument(root, diagnostics, []);
}
function getNodeValue3(node) {
  return getNodeValue2(node);
}
function getNodePath3(node) {
  return getNodePath2(node);
}
function contains2(node, offset, includeRightBound = !1) {
  return offset >= node.offset && offset < node.offset + node.length || includeRightBound && offset === node.offset + node.length;
}
function getSchemaDraft(schema, fallBack = SchemaDraft.v2020_12) {
  let schemaId = schema.$schema;
  return schemaId ? schemaDraftFromId[schemaId] ?? fallBack : fallBack;
}
function validate(n, schema, validationResult, matchingSchemas, context) {
  if (!n || !matchingSchemas.include(n))
    return;
  if (n.type === "property")
    return validate(n.valueNode, schema, validationResult, matchingSchemas, context);
  let node = n;
  switch (_validateNode(), node.type) {
    case "object":
      _validateObjectNode(node);
      break;
    case "array":
      _validateArrayNode(node);
      break;
    case "string":
      _validateStringNode(node);
      break;
    case "number":
      _validateNumberNode(node);
      break;
  }
  matchingSchemas.add({ node, schema });
  function _validateNode() {
    function matchesType(type) {
      return node.type === type || type === "integer" && node.type === "number" && node.isInteger;
    }
    if (Array.isArray(schema.type) ? schema.type.some(matchesType) || validationResult.problems.push({
      location: { offset: node.offset, length: node.length },
      message: schema.errorMessage || l10n.t("Incorrect type. Expected one of {0}.", schema.type.join(", "))
    }) : schema.type && (matchesType(schema.type) || validationResult.problems.push({
      location: { offset: node.offset, length: node.length },
      message: schema.errorMessage || l10n.t('Incorrect type. Expected "{0}".', schema.type)
    })), Array.isArray(schema.allOf))
      for (let subSchemaRef of schema.allOf) {
        let subValidationResult = new ValidationResult(), subMatchingSchemas = matchingSchemas.newSub();
        validate(node, asSchema(subSchemaRef), subValidationResult, subMatchingSchemas, context), validationResult.merge(subValidationResult), matchingSchemas.merge(subMatchingSchemas);
      }
    let notSchema = asSchema(schema.not);
    if (notSchema) {
      let subValidationResult = new ValidationResult(), subMatchingSchemas = matchingSchemas.newSub();
      validate(node, notSchema, subValidationResult, subMatchingSchemas, context), subValidationResult.hasProblems() || validationResult.problems.push({
        location: { offset: node.offset, length: node.length },
        message: schema.errorMessage || l10n.t("Matches a schema that is not allowed.")
      });
      for (let ms of subMatchingSchemas.schemas)
        ms.inverted = !ms.inverted, matchingSchemas.add(ms);
    }
    let testAlternatives = (alternatives, maxOneMatch) => {
      let matches = [], bestMatch;
      for (let subSchemaRef of alternatives) {
        let subSchema = asSchema(subSchemaRef), subValidationResult = new ValidationResult(), subMatchingSchemas = matchingSchemas.newSub();
        if (validate(node, subSchema, subValidationResult, subMatchingSchemas, context), subValidationResult.hasProblems() || matches.push(subSchema), !bestMatch)
          bestMatch = { schema: subSchema, validationResult: subValidationResult, matchingSchemas: subMatchingSchemas };
        else if (!maxOneMatch && !subValidationResult.hasProblems() && !bestMatch.validationResult.hasProblems())
          bestMatch.matchingSchemas.merge(subMatchingSchemas), bestMatch.validationResult.propertiesMatches += subValidationResult.propertiesMatches, bestMatch.validationResult.propertiesValueMatches += subValidationResult.propertiesValueMatches, bestMatch.validationResult.mergeProcessedProperties(subValidationResult);
        else {
          let compareResult = subValidationResult.compare(bestMatch.validationResult);
          compareResult > 0 ? bestMatch = { schema: subSchema, validationResult: subValidationResult, matchingSchemas: subMatchingSchemas } : compareResult === 0 && (bestMatch.matchingSchemas.merge(subMatchingSchemas), bestMatch.validationResult.mergeEnumValues(subValidationResult));
        }
      }
      return matches.length > 1 && maxOneMatch && validationResult.problems.push({
        location: { offset: node.offset, length: 1 },
        message: l10n.t("Matches multiple schemas when only one must validate.")
      }), bestMatch && (validationResult.merge(bestMatch.validationResult), matchingSchemas.merge(bestMatch.matchingSchemas)), matches.length;
    };
    Array.isArray(schema.anyOf) && testAlternatives(schema.anyOf, !1), Array.isArray(schema.oneOf) && testAlternatives(schema.oneOf, !0);
    let testBranch = (schema2) => {
      let subValidationResult = new ValidationResult(), subMatchingSchemas = matchingSchemas.newSub();
      validate(node, asSchema(schema2), subValidationResult, subMatchingSchemas, context), validationResult.merge(subValidationResult), matchingSchemas.merge(subMatchingSchemas);
    }, testCondition = (ifSchema2, thenSchema, elseSchema) => {
      let subSchema = asSchema(ifSchema2), subValidationResult = new ValidationResult(), subMatchingSchemas = matchingSchemas.newSub();
      validate(node, subSchema, subValidationResult, subMatchingSchemas, context), matchingSchemas.merge(subMatchingSchemas), validationResult.mergeProcessedProperties(subValidationResult), subValidationResult.hasProblems() ? elseSchema && testBranch(elseSchema) : thenSchema && testBranch(thenSchema);
    }, ifSchema = asSchema(schema.if);
    if (ifSchema && testCondition(ifSchema, asSchema(schema.then), asSchema(schema.else)), Array.isArray(schema.enum)) {
      let val = getNodeValue3(node), enumValueMatch = !1;
      for (let e of schema.enum)
        if (equals(val, e)) {
          enumValueMatch = !0;
          break;
        }
      validationResult.enumValues = schema.enum, validationResult.enumValueMatch = enumValueMatch, enumValueMatch || validationResult.problems.push({
        location: { offset: node.offset, length: node.length },
        code: ErrorCode.EnumValueMismatch,
        message: schema.errorMessage || l10n.t("Value is not accepted. Valid values: {0}.", schema.enum.map((v) => JSON.stringify(v)).join(", "))
      });
    }
    if (isDefined(schema.const)) {
      let val = getNodeValue3(node);
      equals(val, schema.const) ? validationResult.enumValueMatch = !0 : (validationResult.problems.push({
        location: { offset: node.offset, length: node.length },
        code: ErrorCode.EnumValueMismatch,
        message: schema.errorMessage || l10n.t("Value must be {0}.", JSON.stringify(schema.const))
      }), validationResult.enumValueMatch = !1), validationResult.enumValues = [schema.const];
    }
    let deprecationMessage = schema.deprecationMessage;
    if (deprecationMessage || schema.deprecated) {
      deprecationMessage = deprecationMessage || l10n.t("Value is deprecated");
      let targetNode = node.parent?.type === "property" ? node.parent : node;
      validationResult.problems.push({
        location: { offset: targetNode.offset, length: targetNode.length },
        severity: DiagnosticSeverity.Warning,
        message: deprecationMessage,
        code: ErrorCode.Deprecated
      });
    }
  }
  function _validateNumberNode(node2) {
    let val = node2.value;
    function normalizeFloats(float) {
      let parts = /^(-?\d+)(?:\.(\d+))?(?:e([-+]\d+))?$/.exec(float.toString());
      return parts && {
        value: Number(parts[1] + (parts[2] || "")),
        multiplier: (parts[2]?.length || 0) - (parseInt(parts[3]) || 0)
      };
    }
    if (isNumber(schema.multipleOf)) {
      let remainder = -1;
      if (Number.isInteger(schema.multipleOf))
        remainder = val % schema.multipleOf;
      else {
        let normMultipleOf = normalizeFloats(schema.multipleOf), normValue = normalizeFloats(val);
        if (normMultipleOf && normValue) {
          let multiplier = 10 ** Math.abs(normValue.multiplier - normMultipleOf.multiplier);
          normValue.multiplier < normMultipleOf.multiplier ? normValue.value *= multiplier : normMultipleOf.value *= multiplier, remainder = normValue.value % normMultipleOf.value;
        }
      }
      remainder !== 0 && validationResult.problems.push({
        location: { offset: node2.offset, length: node2.length },
        message: l10n.t("Value is not divisible by {0}.", schema.multipleOf)
      });
    }
    function getExclusiveLimit(limit, exclusive) {
      if (isNumber(exclusive))
        return exclusive;
      if (isBoolean(exclusive) && exclusive)
        return limit;
    }
    function getLimit(limit, exclusive) {
      if (!isBoolean(exclusive) || !exclusive)
        return limit;
    }
    let exclusiveMinimum = getExclusiveLimit(schema.minimum, schema.exclusiveMinimum);
    isNumber(exclusiveMinimum) && val <= exclusiveMinimum && validationResult.problems.push({
      location: { offset: node2.offset, length: node2.length },
      message: l10n.t("Value is below the exclusive minimum of {0}.", exclusiveMinimum)
    });
    let exclusiveMaximum = getExclusiveLimit(schema.maximum, schema.exclusiveMaximum);
    isNumber(exclusiveMaximum) && val >= exclusiveMaximum && validationResult.problems.push({
      location: { offset: node2.offset, length: node2.length },
      message: l10n.t("Value is above the exclusive maximum of {0}.", exclusiveMaximum)
    });
    let minimum = getLimit(schema.minimum, schema.exclusiveMinimum);
    isNumber(minimum) && val < minimum && validationResult.problems.push({
      location: { offset: node2.offset, length: node2.length },
      message: l10n.t("Value is below the minimum of {0}.", minimum)
    });
    let maximum = getLimit(schema.maximum, schema.exclusiveMaximum);
    isNumber(maximum) && val > maximum && validationResult.problems.push({
      location: { offset: node2.offset, length: node2.length },
      message: l10n.t("Value is above the maximum of {0}.", maximum)
    });
  }
  function _validateStringNode(node2) {
    if (isNumber(schema.minLength) && stringLength(node2.value) < schema.minLength && validationResult.problems.push({
      location: { offset: node2.offset, length: node2.length },
      message: l10n.t("String is shorter than the minimum length of {0}.", schema.minLength)
    }), isNumber(schema.maxLength) && stringLength(node2.value) > schema.maxLength && validationResult.problems.push({
      location: { offset: node2.offset, length: node2.length },
      message: l10n.t("String is longer than the maximum length of {0}.", schema.maxLength)
    }), isString(schema.pattern) && (extendedRegExp(schema.pattern)?.test(node2.value) || validationResult.problems.push({
      location: { offset: node2.offset, length: node2.length },
      message: schema.patternErrorMessage || schema.errorMessage || l10n.t('String does not match the pattern of "{0}".', schema.pattern)
    })), schema.format)
      switch (schema.format) {
        case "uri":
        case "uri-reference":
          {
            let errorMessage2;
            if (!node2.value)
              errorMessage2 = l10n.t("URI expected.");
            else {
              let match2 = /^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/.exec(node2.value);
              match2 ? !match2[2] && schema.format === "uri" && (errorMessage2 = l10n.t("URI with a scheme is expected.")) : errorMessage2 = l10n.t("URI is expected.");
            }
            errorMessage2 && validationResult.problems.push({
              location: { offset: node2.offset, length: node2.length },
              message: schema.patternErrorMessage || schema.errorMessage || l10n.t("String is not a URI: {0}", errorMessage2)
            });
          }
          break;
        case "color-hex":
        case "date-time":
        case "date":
        case "time":
        case "email":
        case "hostname":
        case "ipv4":
        case "ipv6":
          let format4 = formats[schema.format];
          (!node2.value || !format4.pattern.exec(node2.value)) && validationResult.problems.push({
            location: { offset: node2.offset, length: node2.length },
            message: schema.patternErrorMessage || schema.errorMessage || format4.errorMessage
          });
        default:
      }
  }
  function _validateArrayNode(node2) {
    let prefixItemsSchemas, additionalItemSchema;
    context.schemaDraft >= SchemaDraft.v2020_12 ? (prefixItemsSchemas = schema.prefixItems, additionalItemSchema = Array.isArray(schema.items) ? void 0 : schema.items) : (prefixItemsSchemas = Array.isArray(schema.items) ? schema.items : void 0, additionalItemSchema = Array.isArray(schema.items) ? schema.additionalItems : schema.items);
    let index = 0;
    if (prefixItemsSchemas !== void 0) {
      let max = Math.min(prefixItemsSchemas.length, node2.items.length);
      for (; index < max; index++) {
        let subSchemaRef = prefixItemsSchemas[index], subSchema = asSchema(subSchemaRef), itemValidationResult = new ValidationResult(), item = node2.items[index];
        item && (validate(item, subSchema, itemValidationResult, matchingSchemas, context), validationResult.mergePropertyMatch(itemValidationResult)), validationResult.processedProperties.add(String(index));
      }
    }
    if (additionalItemSchema !== void 0 && index < node2.items.length)
      if (typeof additionalItemSchema == "boolean")
        for (additionalItemSchema === !1 && validationResult.problems.push({
          location: { offset: node2.offset, length: node2.length },
          message: l10n.t("Array has too many items according to schema. Expected {0} or fewer.", index)
        }); index < node2.items.length; index++)
          validationResult.processedProperties.add(String(index)), validationResult.propertiesValueMatches++;
      else
        for (; index < node2.items.length; index++) {
          let itemValidationResult = new ValidationResult();
          validate(node2.items[index], additionalItemSchema, itemValidationResult, matchingSchemas, context), validationResult.mergePropertyMatch(itemValidationResult), validationResult.processedProperties.add(String(index));
        }
    let containsSchema = asSchema(schema.contains);
    if (containsSchema) {
      let containsCount = 0;
      for (let index2 = 0; index2 < node2.items.length; index2++) {
        let item = node2.items[index2], itemValidationResult = new ValidationResult();
        validate(item, containsSchema, itemValidationResult, NoOpSchemaCollector.instance, context), itemValidationResult.hasProblems() || (containsCount++, context.schemaDraft >= SchemaDraft.v2020_12 && validationResult.processedProperties.add(String(index2)));
      }
      containsCount === 0 && !isNumber(schema.minContains) && validationResult.problems.push({
        location: { offset: node2.offset, length: node2.length },
        message: schema.errorMessage || l10n.t("Array does not contain required item.")
      }), isNumber(schema.minContains) && containsCount < schema.minContains && validationResult.problems.push({
        location: { offset: node2.offset, length: node2.length },
        message: schema.errorMessage || l10n.t("Array has too few items that match the contains contraint. Expected {0} or more.", schema.minContains)
      }), isNumber(schema.maxContains) && containsCount > schema.maxContains && validationResult.problems.push({
        location: { offset: node2.offset, length: node2.length },
        message: schema.errorMessage || l10n.t("Array has too many items that match the contains contraint. Expected {0} or less.", schema.maxContains)
      });
    }
    let unevaluatedItems = schema.unevaluatedItems;
    if (unevaluatedItems !== void 0)
      for (let i = 0; i < node2.items.length; i++) {
        if (!validationResult.processedProperties.has(String(i)))
          if (unevaluatedItems === !1)
            validationResult.problems.push({
              location: { offset: node2.offset, length: node2.length },
              message: l10n.t("Item does not match any validation rule from the array.")
            });
          else {
            let itemValidationResult = new ValidationResult();
            validate(node2.items[i], schema.unevaluatedItems, itemValidationResult, matchingSchemas, context), validationResult.mergePropertyMatch(itemValidationResult);
          }
        validationResult.processedProperties.add(String(i)), validationResult.propertiesValueMatches++;
      }
    if (isNumber(schema.minItems) && node2.items.length < schema.minItems && validationResult.problems.push({
      location: { offset: node2.offset, length: node2.length },
      message: l10n.t("Array has too few items. Expected {0} or more.", schema.minItems)
    }), isNumber(schema.maxItems) && node2.items.length > schema.maxItems && validationResult.problems.push({
      location: { offset: node2.offset, length: node2.length },
      message: l10n.t("Array has too many items. Expected {0} or fewer.", schema.maxItems)
    }), schema.uniqueItems === !0) {
      let hasDuplicates = function() {
        for (let i = 0; i < values.length - 1; i++) {
          let value = values[i];
          for (let j = i + 1; j < values.length; j++)
            if (equals(value, values[j]))
              return !0;
        }
        return !1;
      }, values = getNodeValue3(node2);
      hasDuplicates() && validationResult.problems.push({
        location: { offset: node2.offset, length: node2.length },
        message: l10n.t("Array has duplicate items.")
      });
    }
  }
  function _validateObjectNode(node2) {
    let seenKeys = /* @__PURE__ */ Object.create(null), unprocessedProperties = /* @__PURE__ */ new Set();
    for (let propertyNode of node2.properties) {
      let key = propertyNode.keyNode.value;
      seenKeys[key] = propertyNode.valueNode, unprocessedProperties.add(key);
    }
    if (Array.isArray(schema.required)) {
      for (let propertyName of schema.required)
        if (!seenKeys[propertyName]) {
          let keyNode = node2.parent && node2.parent.type === "property" && node2.parent.keyNode, location2 = keyNode ? { offset: keyNode.offset, length: keyNode.length } : { offset: node2.offset, length: 1 };
          validationResult.problems.push({
            location: location2,
            message: l10n.t('Missing property "{0}".', propertyName)
          });
        }
    }
    let propertyProcessed = (prop) => {
      unprocessedProperties.delete(prop), validationResult.processedProperties.add(prop);
    };
    if (schema.properties)
      for (let propertyName of Object.keys(schema.properties)) {
        propertyProcessed(propertyName);
        let propertySchema = schema.properties[propertyName], child = seenKeys[propertyName];
        if (child)
          if (isBoolean(propertySchema))
            if (propertySchema)
              validationResult.propertiesMatches++, validationResult.propertiesValueMatches++;
            else {
              let propertyNode = child.parent;
              validationResult.problems.push({
                location: { offset: propertyNode.keyNode.offset, length: propertyNode.keyNode.length },
                message: schema.errorMessage || l10n.t("Property {0} is not allowed.", propertyName)
              });
            }
          else {
            let propertyValidationResult = new ValidationResult();
            validate(child, propertySchema, propertyValidationResult, matchingSchemas, context), validationResult.mergePropertyMatch(propertyValidationResult);
          }
      }
    if (schema.patternProperties)
      for (let propertyPattern of Object.keys(schema.patternProperties)) {
        let regex = extendedRegExp(propertyPattern);
        if (regex) {
          let processed = [];
          for (let propertyName of unprocessedProperties)
            if (regex.test(propertyName)) {
              processed.push(propertyName);
              let child = seenKeys[propertyName];
              if (child) {
                let propertySchema = schema.patternProperties[propertyPattern];
                if (isBoolean(propertySchema))
                  if (propertySchema)
                    validationResult.propertiesMatches++, validationResult.propertiesValueMatches++;
                  else {
                    let propertyNode = child.parent;
                    validationResult.problems.push({
                      location: { offset: propertyNode.keyNode.offset, length: propertyNode.keyNode.length },
                      message: schema.errorMessage || l10n.t("Property {0} is not allowed.", propertyName)
                    });
                  }
                else {
                  let propertyValidationResult = new ValidationResult();
                  validate(child, propertySchema, propertyValidationResult, matchingSchemas, context), validationResult.mergePropertyMatch(propertyValidationResult);
                }
              }
            }
          processed.forEach(propertyProcessed);
        }
      }
    let additionalProperties = schema.additionalProperties;
    if (additionalProperties !== void 0)
      for (let propertyName of unprocessedProperties) {
        propertyProcessed(propertyName);
        let child = seenKeys[propertyName];
        if (child) {
          if (additionalProperties === !1) {
            let propertyNode = child.parent;
            validationResult.problems.push({
              location: { offset: propertyNode.keyNode.offset, length: propertyNode.keyNode.length },
              message: schema.errorMessage || l10n.t("Property {0} is not allowed.", propertyName)
            });
          } else if (additionalProperties !== !0) {
            let propertyValidationResult = new ValidationResult();
            validate(child, additionalProperties, propertyValidationResult, matchingSchemas, context), validationResult.mergePropertyMatch(propertyValidationResult);
          }
        }
      }
    let unevaluatedProperties = schema.unevaluatedProperties;
    if (unevaluatedProperties !== void 0) {
      let processed = [];
      for (let propertyName of unprocessedProperties)
        if (!validationResult.processedProperties.has(propertyName)) {
          processed.push(propertyName);
          let child = seenKeys[propertyName];
          if (child) {
            if (unevaluatedProperties === !1) {
              let propertyNode = child.parent;
              validationResult.problems.push({
                location: { offset: propertyNode.keyNode.offset, length: propertyNode.keyNode.length },
                message: schema.errorMessage || l10n.t("Property {0} is not allowed.", propertyName)
              });
            } else if (unevaluatedProperties !== !0) {
              let propertyValidationResult = new ValidationResult();
              validate(child, unevaluatedProperties, propertyValidationResult, matchingSchemas, context), validationResult.mergePropertyMatch(propertyValidationResult);
            }
          }
        }
      processed.forEach(propertyProcessed);
    }
    if (isNumber(schema.maxProperties) && node2.properties.length > schema.maxProperties && validationResult.problems.push({
      location: { offset: node2.offset, length: node2.length },
      message: l10n.t("Object has more properties than limit of {0}.", schema.maxProperties)
    }), isNumber(schema.minProperties) && node2.properties.length < schema.minProperties && validationResult.problems.push({
      location: { offset: node2.offset, length: node2.length },
      message: l10n.t("Object has fewer properties than the required number of {0}", schema.minProperties)
    }), schema.dependentRequired)
      for (let key in schema.dependentRequired) {
        let prop = seenKeys[key], propertyDeps = schema.dependentRequired[key];
        prop && Array.isArray(propertyDeps) && _validatePropertyDependencies(key, propertyDeps);
      }
    if (schema.dependentSchemas)
      for (let key in schema.dependentSchemas) {
        let prop = seenKeys[key], propertyDeps = schema.dependentSchemas[key];
        prop && isObject(propertyDeps) && _validatePropertyDependencies(key, propertyDeps);
      }
    if (schema.dependencies)
      for (let key in schema.dependencies)
        seenKeys[key] && _validatePropertyDependencies(key, schema.dependencies[key]);
    let propertyNames = asSchema(schema.propertyNames);
    if (propertyNames)
      for (let f of node2.properties) {
        let key = f.keyNode;
        key && validate(key, propertyNames, validationResult, NoOpSchemaCollector.instance, context);
      }
    function _validatePropertyDependencies(key, propertyDep) {
      if (Array.isArray(propertyDep))
        for (let requiredProp of propertyDep)
          seenKeys[requiredProp] ? validationResult.propertiesValueMatches++ : validationResult.problems.push({
            location: { offset: node2.offset, length: node2.length },
            message: l10n.t("Object is missing property {0} required by property {1}.", requiredProp, key)
          });
      else {
        let propertySchema = asSchema(propertyDep);
        if (propertySchema) {
          let propertyValidationResult = new ValidationResult();
          validate(node2, propertySchema, propertyValidationResult, matchingSchemas, context), validationResult.mergePropertyMatch(propertyValidationResult);
        }
      }
    }
  }
}
function parse3(textDocument, config2) {
  let problems = [], lastProblemOffset = -1, text = textDocument.getText(), scanner = createScanner2(text, !1), commentRanges = config2 && config2.collectComments ? [] : void 0;
  function _scanNext() {
    for (; ; ) {
      let token2 = scanner.scan();
      switch (_checkScanError(), token2) {
        case 12:
        case 13:
          Array.isArray(commentRanges) && commentRanges.push(Range.create(textDocument.positionAt(scanner.getTokenOffset()), textDocument.positionAt(scanner.getTokenOffset() + scanner.getTokenLength())));
          break;
        case 15:
        case 14:
          break;
        default:
          return token2;
      }
    }
  }
  function _accept(token2) {
    return scanner.getToken() === token2 ? (_scanNext(), !0) : !1;
  }
  function _errorAtRange(message, code, startOffset, endOffset, severity = DiagnosticSeverity.Error) {
    if (problems.length === 0 || startOffset !== lastProblemOffset) {
      let range = Range.create(textDocument.positionAt(startOffset), textDocument.positionAt(endOffset));
      problems.push(Diagnostic.create(range, message, severity, code, textDocument.languageId)), lastProblemOffset = startOffset;
    }
  }
  function _error(message, code, node = void 0, skipUntilAfter = [], skipUntil = []) {
    let start = scanner.getTokenOffset(), end = scanner.getTokenOffset() + scanner.getTokenLength();
    if (start === end && start > 0) {
      for (start--; start > 0 && /\s/.test(text.charAt(start)); )
        start--;
      end = start + 1;
    }
    if (_errorAtRange(message, code, start, end), node && _finalize(node, !1), skipUntilAfter.length + skipUntil.length > 0) {
      let token2 = scanner.getToken();
      for (; token2 !== 17; ) {
        if (skipUntilAfter.indexOf(token2) !== -1) {
          _scanNext();
          break;
        } else if (skipUntil.indexOf(token2) !== -1)
          break;
        token2 = _scanNext();
      }
    }
    return node;
  }
  function _checkScanError() {
    switch (scanner.getTokenError()) {
      case 4:
        return _error(l10n.t("Invalid unicode sequence in string."), ErrorCode.InvalidUnicode), !0;
      case 5:
        return _error(l10n.t("Invalid escape character in string."), ErrorCode.InvalidEscapeCharacter), !0;
      case 3:
        return _error(l10n.t("Unexpected end of number."), ErrorCode.UnexpectedEndOfNumber), !0;
      case 1:
        return _error(l10n.t("Unexpected end of comment."), ErrorCode.UnexpectedEndOfComment), !0;
      case 2:
        return _error(l10n.t("Unexpected end of string."), ErrorCode.UnexpectedEndOfString), !0;
      case 6:
        return _error(l10n.t("Invalid characters in string. Control characters must be escaped."), ErrorCode.InvalidCharacter), !0;
    }
    return !1;
  }
  function _finalize(node, scanNext) {
    return node.length = scanner.getTokenOffset() + scanner.getTokenLength() - node.offset, scanNext && _scanNext(), node;
  }
  function _parseArray(parent) {
    if (scanner.getToken() !== 3)
      return;
    let node = new ArrayASTNodeImpl(parent, scanner.getTokenOffset());
    _scanNext();
    let count = 0, needsComma = !1;
    for (; scanner.getToken() !== 4 && scanner.getToken() !== 17; ) {
      if (scanner.getToken() === 5) {
        needsComma || _error(l10n.t("Value expected"), ErrorCode.ValueExpected);
        let commaOffset = scanner.getTokenOffset();
        if (_scanNext(), scanner.getToken() === 4) {
          needsComma && _errorAtRange(l10n.t("Trailing comma"), ErrorCode.TrailingComma, commaOffset, commaOffset + 1);
          continue;
        }
      } else
        needsComma && _error(l10n.t("Expected comma"), ErrorCode.CommaExpected);
      let item = _parseValue(node);
      item ? node.items.push(item) : _error(l10n.t("Value expected"), ErrorCode.ValueExpected, void 0, [], [
        4,
        5
        /* Json.SyntaxKind.CommaToken */
      ]), needsComma = !0;
    }
    return scanner.getToken() !== 4 ? _error(l10n.t("Expected comma or closing bracket"), ErrorCode.CommaOrCloseBacketExpected, node) : _finalize(node, !0);
  }
  let keyPlaceholder = new StringASTNodeImpl(void 0, 0, 0);
  function _parseProperty(parent, keysSeen) {
    let node = new PropertyASTNodeImpl(parent, scanner.getTokenOffset(), keyPlaceholder), key = _parseString(node);
    if (!key)
      if (scanner.getToken() === 16) {
        _error(l10n.t("Property keys must be doublequoted"), ErrorCode.PropertyKeysMustBeDoublequoted);
        let keyNode = new StringASTNodeImpl(node, scanner.getTokenOffset(), scanner.getTokenLength());
        keyNode.value = scanner.getTokenValue(), key = keyNode, _scanNext();
      } else
        return;
    if (node.keyNode = key, key.value !== "//") {
      let seen = keysSeen[key.value];
      seen ? (_errorAtRange(l10n.t("Duplicate object key"), ErrorCode.DuplicateKey, node.keyNode.offset, node.keyNode.offset + node.keyNode.length, DiagnosticSeverity.Warning), isObject(seen) && _errorAtRange(l10n.t("Duplicate object key"), ErrorCode.DuplicateKey, seen.keyNode.offset, seen.keyNode.offset + seen.keyNode.length, DiagnosticSeverity.Warning), keysSeen[key.value] = !0) : keysSeen[key.value] = node;
    }
    if (scanner.getToken() === 6)
      node.colonOffset = scanner.getTokenOffset(), _scanNext();
    else if (_error(l10n.t("Colon expected"), ErrorCode.ColonExpected), scanner.getToken() === 10 && textDocument.positionAt(key.offset + key.length).line < textDocument.positionAt(scanner.getTokenOffset()).line)
      return node.length = key.length, node;
    let value = _parseValue(node);
    return value ? (node.valueNode = value, node.length = value.offset + value.length - node.offset, node) : _error(l10n.t("Value expected"), ErrorCode.ValueExpected, node, [], [
      2,
      5
      /* Json.SyntaxKind.CommaToken */
    ]);
  }
  function _parseObject(parent) {
    if (scanner.getToken() !== 1)
      return;
    let node = new ObjectASTNodeImpl(parent, scanner.getTokenOffset()), keysSeen = /* @__PURE__ */ Object.create(null);
    _scanNext();
    let needsComma = !1;
    for (; scanner.getToken() !== 2 && scanner.getToken() !== 17; ) {
      if (scanner.getToken() === 5) {
        needsComma || _error(l10n.t("Property expected"), ErrorCode.PropertyExpected);
        let commaOffset = scanner.getTokenOffset();
        if (_scanNext(), scanner.getToken() === 2) {
          needsComma && _errorAtRange(l10n.t("Trailing comma"), ErrorCode.TrailingComma, commaOffset, commaOffset + 1);
          continue;
        }
      } else
        needsComma && _error(l10n.t("Expected comma"), ErrorCode.CommaExpected);
      let property = _parseProperty(node, keysSeen);
      property ? node.properties.push(property) : _error(l10n.t("Property expected"), ErrorCode.PropertyExpected, void 0, [], [
        2,
        5
        /* Json.SyntaxKind.CommaToken */
      ]), needsComma = !0;
    }
    return scanner.getToken() !== 2 ? _error(l10n.t("Expected comma or closing brace"), ErrorCode.CommaOrCloseBraceExpected, node) : _finalize(node, !0);
  }
  function _parseString(parent) {
    if (scanner.getToken() !== 10)
      return;
    let node = new StringASTNodeImpl(parent, scanner.getTokenOffset());
    return node.value = scanner.getTokenValue(), _finalize(node, !0);
  }
  function _parseNumber(parent) {
    if (scanner.getToken() !== 11)
      return;
    let node = new NumberASTNodeImpl(parent, scanner.getTokenOffset());
    if (scanner.getTokenError() === 0) {
      let tokenValue = scanner.getTokenValue();
      try {
        let numberValue = JSON.parse(tokenValue);
        if (!isNumber(numberValue))
          return _error(l10n.t("Invalid number format."), ErrorCode.Undefined, node);
        node.value = numberValue;
      } catch {
        return _error(l10n.t("Invalid number format."), ErrorCode.Undefined, node);
      }
      node.isInteger = tokenValue.indexOf(".") === -1;
    }
    return _finalize(node, !0);
  }
  function _parseLiteral(parent) {
    let node;
    switch (scanner.getToken()) {
      case 7:
        return _finalize(new NullASTNodeImpl(parent, scanner.getTokenOffset()), !0);
      case 8:
        return _finalize(new BooleanASTNodeImpl(parent, !0, scanner.getTokenOffset()), !0);
      case 9:
        return _finalize(new BooleanASTNodeImpl(parent, !1, scanner.getTokenOffset()), !0);
      default:
        return;
    }
  }
  function _parseValue(parent) {
    return _parseArray(parent) || _parseObject(parent) || _parseString(parent) || _parseNumber(parent) || _parseLiteral(parent);
  }
  let _root;
  return _scanNext() !== 17 && (_root = _parseValue(_root), _root ? scanner.getToken() !== 17 && _error(l10n.t("End of file expected."), ErrorCode.Undefined) : _error(l10n.t("Expected a JSON object, array or literal."), ErrorCode.Undefined)), new JSONDocument(_root, problems, commentRanges);
}
var l10n, formats, ASTNodeImpl, NullASTNodeImpl, BooleanASTNodeImpl, ArrayASTNodeImpl, NumberASTNodeImpl, StringASTNodeImpl, PropertyASTNodeImpl, ObjectASTNodeImpl, EnumMatch, schemaDraftFromId, EvaluationContext, SchemaCollector, NoOpSchemaCollector, ValidationResult, JSONDocument, init_jsonParser = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/parser/jsonParser.js"() {
    init_cjs_shims();
    init_main();
    init_objects();
    init_strings();
    init_jsonLanguageTypes();
    l10n = __toESM(require_main2()), formats = {
      "color-hex": { errorMessage: l10n.t("Invalid color format. Use #RGB, #RGBA, #RRGGBB or #RRGGBBAA."), pattern: /^#([0-9A-Fa-f]{3,4}|([0-9A-Fa-f]{2}){3,4})$/ },
      "date-time": { errorMessage: l10n.t("String is not a RFC3339 date-time."), pattern: /^(\d{4})-(0[1-9]|1[0-2])-(0[1-9]|[12][0-9]|3[01])T([01][0-9]|2[0-3]):([0-5][0-9]):([0-5][0-9]|60)(\.[0-9]+)?(Z|(\+|-)([01][0-9]|2[0-3]):([0-5][0-9]))$/i },
      date: { errorMessage: l10n.t("String is not a RFC3339 date."), pattern: /^(\d{4})-(0[1-9]|1[0-2])-(0[1-9]|[12][0-9]|3[01])$/i },
      time: { errorMessage: l10n.t("String is not a RFC3339 time."), pattern: /^([01][0-9]|2[0-3]):([0-5][0-9]):([0-5][0-9]|60)(\.[0-9]+)?(Z|(\+|-)([01][0-9]|2[0-3]):([0-5][0-9]))$/i },
      email: { errorMessage: l10n.t("String is not an e-mail address."), pattern: /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z0-9-]+\.)+[a-zA-Z]{2,}))$/ },
      hostname: { errorMessage: l10n.t("String is not a hostname."), pattern: /^(?=.{1,253}\.?$)[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?(?:\.[a-z0-9](?:[-0-9a-z]{0,61}[0-9a-z])?)*\.?$/i },
      ipv4: { errorMessage: l10n.t("String is not an IPv4 address."), pattern: /^(?:(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)\.){3}(?:25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)$/ },
      ipv6: { errorMessage: l10n.t("String is not an IPv6 address."), pattern: /^((([0-9a-f]{1,4}:){7}([0-9a-f]{1,4}|:))|(([0-9a-f]{1,4}:){6}(:[0-9a-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9a-f]{1,4}:){5}(((:[0-9a-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9a-f]{1,4}:){4}(((:[0-9a-f]{1,4}){1,3})|((:[0-9a-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){3}(((:[0-9a-f]{1,4}){1,4})|((:[0-9a-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){2}(((:[0-9a-f]{1,4}){1,5})|((:[0-9a-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){1}(((:[0-9a-f]{1,4}){1,6})|((:[0-9a-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9a-f]{1,4}){1,7})|((:[0-9a-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))$/i }
    }, ASTNodeImpl = class {
      constructor(parent, offset, length = 0) {
        this.offset = offset, this.length = length, this.parent = parent;
      }
      get children() {
        return [];
      }
      toString() {
        return "type: " + this.type + " (" + this.offset + "/" + this.length + ")" + (this.parent ? " parent: {" + this.parent.toString() + "}" : "");
      }
    }, NullASTNodeImpl = class extends ASTNodeImpl {
      constructor(parent, offset) {
        super(parent, offset), this.type = "null", this.value = null;
      }
    }, BooleanASTNodeImpl = class extends ASTNodeImpl {
      constructor(parent, boolValue, offset) {
        super(parent, offset), this.type = "boolean", this.value = boolValue;
      }
    }, ArrayASTNodeImpl = class extends ASTNodeImpl {
      constructor(parent, offset) {
        super(parent, offset), this.type = "array", this.items = [];
      }
      get children() {
        return this.items;
      }
    }, NumberASTNodeImpl = class extends ASTNodeImpl {
      constructor(parent, offset) {
        super(parent, offset), this.type = "number", this.isInteger = !0, this.value = Number.NaN;
      }
    }, StringASTNodeImpl = class extends ASTNodeImpl {
      constructor(parent, offset, length) {
        super(parent, offset, length), this.type = "string", this.value = "";
      }
    }, PropertyASTNodeImpl = class extends ASTNodeImpl {
      constructor(parent, offset, keyNode) {
        super(parent, offset), this.type = "property", this.colonOffset = -1, this.keyNode = keyNode;
      }
      get children() {
        return this.valueNode ? [this.keyNode, this.valueNode] : [this.keyNode];
      }
    }, ObjectASTNodeImpl = class extends ASTNodeImpl {
      constructor(parent, offset) {
        super(parent, offset), this.type = "object", this.properties = [];
      }
      get children() {
        return this.properties;
      }
    };
    (function(EnumMatch2) {
      EnumMatch2[EnumMatch2.Key = 0] = "Key", EnumMatch2[EnumMatch2.Enum = 1] = "Enum";
    })(EnumMatch || (EnumMatch = {}));
    schemaDraftFromId = {
      "http://json-schema.org/draft-03/schema#": SchemaDraft.v3,
      "http://json-schema.org/draft-04/schema#": SchemaDraft.v4,
      "http://json-schema.org/draft-06/schema#": SchemaDraft.v6,
      "http://json-schema.org/draft-07/schema#": SchemaDraft.v7,
      "https://json-schema.org/draft/2019-09/schema": SchemaDraft.v2019_09,
      "https://json-schema.org/draft/2020-12/schema": SchemaDraft.v2020_12
    }, EvaluationContext = class {
      constructor(schemaDraft) {
        this.schemaDraft = schemaDraft;
      }
    }, SchemaCollector = class _SchemaCollector {
      constructor(focusOffset = -1, exclude) {
        this.focusOffset = focusOffset, this.exclude = exclude, this.schemas = [];
      }
      add(schema) {
        this.schemas.push(schema);
      }
      merge(other) {
        Array.prototype.push.apply(this.schemas, other.schemas);
      }
      include(node) {
        return (this.focusOffset === -1 || contains2(node, this.focusOffset)) && node !== this.exclude;
      }
      newSub() {
        return new _SchemaCollector(-1, this.exclude);
      }
    }, NoOpSchemaCollector = class {
      constructor() {
      }
      get schemas() {
        return [];
      }
      add(_schema) {
      }
      merge(_other) {
      }
      include(_node) {
        return !0;
      }
      newSub() {
        return this;
      }
    };
    NoOpSchemaCollector.instance = new NoOpSchemaCollector();
    ValidationResult = class {
      constructor() {
        this.problems = [], this.propertiesMatches = 0, this.processedProperties = /* @__PURE__ */ new Set(), this.propertiesValueMatches = 0, this.primaryValueMatches = 0, this.enumValueMatch = !1, this.enumValues = void 0;
      }
      hasProblems() {
        return !!this.problems.length;
      }
      merge(validationResult) {
        this.problems = this.problems.concat(validationResult.problems), this.propertiesMatches += validationResult.propertiesMatches, this.propertiesValueMatches += validationResult.propertiesValueMatches, this.mergeProcessedProperties(validationResult);
      }
      mergeEnumValues(validationResult) {
        if (!this.enumValueMatch && !validationResult.enumValueMatch && this.enumValues && validationResult.enumValues) {
          this.enumValues = this.enumValues.concat(validationResult.enumValues);
          for (let error of this.problems)
            error.code === ErrorCode.EnumValueMismatch && (error.message = l10n.t("Value is not accepted. Valid values: {0}.", this.enumValues.map((v) => JSON.stringify(v)).join(", ")));
        }
      }
      mergePropertyMatch(propertyValidationResult) {
        this.problems = this.problems.concat(propertyValidationResult.problems), this.propertiesMatches++, (propertyValidationResult.enumValueMatch || !propertyValidationResult.hasProblems() && propertyValidationResult.propertiesMatches) && this.propertiesValueMatches++, propertyValidationResult.enumValueMatch && propertyValidationResult.enumValues && propertyValidationResult.enumValues.length === 1 && this.primaryValueMatches++;
      }
      mergeProcessedProperties(validationResult) {
        validationResult.processedProperties.forEach((p) => this.processedProperties.add(p));
      }
      compare(other) {
        let hasProblems = this.hasProblems();
        return hasProblems !== other.hasProblems() ? hasProblems ? -1 : 1 : this.enumValueMatch !== other.enumValueMatch ? other.enumValueMatch ? -1 : 1 : this.primaryValueMatches !== other.primaryValueMatches ? this.primaryValueMatches - other.primaryValueMatches : this.propertiesValueMatches !== other.propertiesValueMatches ? this.propertiesValueMatches - other.propertiesValueMatches : this.propertiesMatches - other.propertiesMatches;
      }
    };
    JSONDocument = class {
      constructor(root, syntaxErrors = [], comments = []) {
        this.root = root, this.syntaxErrors = syntaxErrors, this.comments = comments;
      }
      getNodeFromOffset(offset, includeRightBound = !1) {
        if (this.root)
          return findNodeAtOffset2(this.root, offset, includeRightBound);
      }
      visit(visitor) {
        if (this.root) {
          let doVisit = (node) => {
            let ctn = visitor(node), children = node.children;
            if (Array.isArray(children))
              for (let i = 0; i < children.length && ctn; i++)
                ctn = doVisit(children[i]);
            return ctn;
          };
          doVisit(this.root);
        }
      }
      validate(textDocument, schema, severity = DiagnosticSeverity.Warning, schemaDraft) {
        if (this.root && schema) {
          let validationResult = new ValidationResult();
          return validate(this.root, schema, validationResult, NoOpSchemaCollector.instance, new EvaluationContext(schemaDraft ?? getSchemaDraft(schema))), validationResult.problems.map((p) => {
            let range = Range.create(textDocument.positionAt(p.location.offset), textDocument.positionAt(p.location.offset + p.location.length));
            return Diagnostic.create(range, p.message, p.severity ?? severity, p.code);
          });
        }
      }
      getMatchingSchemas(schema, focusOffset = -1, exclude) {
        if (this.root && schema) {
          let matchingSchemas = new SchemaCollector(focusOffset, exclude), schemaDraft = getSchemaDraft(schema), context = new EvaluationContext(schemaDraft);
          return validate(this.root, schema, new ValidationResult(), matchingSchemas, context), matchingSchemas.schemas;
        }
        return [];
      }
    };
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/utils/json.js
function stringifyObject(obj, indent, stringifyLiteral) {
  if (obj !== null && typeof obj == "object") {
    let newIndent = indent + "	";
    if (Array.isArray(obj)) {
      if (obj.length === 0)
        return "[]";
      let result = `[
`;
      for (let i = 0; i < obj.length; i++)
        result += newIndent + stringifyObject(obj[i], newIndent, stringifyLiteral), i < obj.length - 1 && (result += ","), result += `
`;
      return result += indent + "]", result;
    } else {
      let keys = Object.keys(obj);
      if (keys.length === 0)
        return "{}";
      let result = `{
`;
      for (let i = 0; i < keys.length; i++) {
        let key = keys[i];
        result += newIndent + JSON.stringify(key) + ": " + stringifyObject(obj[key], newIndent, stringifyLiteral), i < keys.length - 1 && (result += ","), result += `
`;
      }
      return result += indent + "}", result;
    }
  }
  return stringifyLiteral(obj);
}
var init_json = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/utils/json.js"() {
    init_cjs_shims();
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/jsonCompletion.js
var l10n2, valueCommitCharacters, propertyCommitCharacters, JSONCompletion, init_jsonCompletion = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/jsonCompletion.js"() {
    init_cjs_shims();
    init_jsonParser();
    init_main();
    init_json();
    init_strings();
    init_objects();
    init_jsonLanguageTypes();
    l10n2 = __toESM(require_main2()), valueCommitCharacters = [",", "}", "]"], propertyCommitCharacters = [":"], JSONCompletion = class {
      constructor(schemaService, contributions = [], promiseConstructor = Promise, clientCapabilities = {}) {
        this.schemaService = schemaService, this.contributions = contributions, this.promiseConstructor = promiseConstructor, this.clientCapabilities = clientCapabilities;
      }
      doResolve(item) {
        for (let i = this.contributions.length - 1; i >= 0; i--) {
          let resolveCompletion = this.contributions[i].resolveCompletion;
          if (resolveCompletion) {
            let resolver = resolveCompletion(item);
            if (resolver)
              return resolver;
          }
        }
        return this.promiseConstructor.resolve(item);
      }
      doComplete(document2, position, doc) {
        let result = {
          items: [],
          isIncomplete: !1
        }, text = document2.getText(), offset = document2.offsetAt(position), node = doc.getNodeFromOffset(offset, !0);
        if (this.isInComment(document2, node ? node.offset : 0, offset))
          return Promise.resolve(result);
        if (node && offset === node.offset + node.length && offset > 0) {
          let ch = text[offset - 1];
          (node.type === "object" && ch === "}" || node.type === "array" && ch === "]") && (node = node.parent);
        }
        let currentWord = this.getCurrentWord(document2, offset), overwriteRange;
        if (node && (node.type === "string" || node.type === "number" || node.type === "boolean" || node.type === "null"))
          overwriteRange = Range.create(document2.positionAt(node.offset), document2.positionAt(node.offset + node.length));
        else {
          let overwriteStart = offset - currentWord.length;
          overwriteStart > 0 && text[overwriteStart - 1] === '"' && overwriteStart--, overwriteRange = Range.create(document2.positionAt(overwriteStart), position);
        }
        let supportsCommitCharacters = !1, proposed = /* @__PURE__ */ new Map(), collector = {
          add: (suggestion) => {
            let label = suggestion.label, existing = proposed.get(label);
            if (existing)
              existing.documentation || (existing.documentation = suggestion.documentation), existing.detail || (existing.detail = suggestion.detail), existing.labelDetails || (existing.labelDetails = suggestion.labelDetails);
            else {
              if (label = label.replace(/[\n]/g, "\u21B5"), label.length > 60) {
                let shortendedLabel = label.substr(0, 57).trim() + "...";
                proposed.has(shortendedLabel) || (label = shortendedLabel);
              }
              suggestion.textEdit = TextEdit.replace(overwriteRange, suggestion.insertText), supportsCommitCharacters && (suggestion.commitCharacters = suggestion.kind === CompletionItemKind.Property ? propertyCommitCharacters : valueCommitCharacters), suggestion.label = label, proposed.set(label, suggestion), result.items.push(suggestion);
            }
          },
          setAsIncomplete: () => {
            result.isIncomplete = !0;
          },
          error: (message) => {
            console.error(message);
          },
          getNumberOfProposals: () => result.items.length
        };
        return this.schemaService.getSchemaForResource(document2.uri, doc).then((schema) => {
          let collectionPromises = [], addValue = !0, currentKey = "", currentProperty;
          if (node && node.type === "string") {
            let parent = node.parent;
            parent && parent.type === "property" && parent.keyNode === node && (addValue = !parent.valueNode, currentProperty = parent, currentKey = text.substr(node.offset + 1, node.length - 2), parent && (node = parent.parent));
          }
          if (node && node.type === "object") {
            if (node.offset === offset)
              return result;
            node.properties.forEach((p) => {
              (!currentProperty || currentProperty !== p) && proposed.set(p.keyNode.value, CompletionItem.create("__"));
            });
            let separatorAfter = "";
            addValue && (separatorAfter = this.evaluateSeparatorAfter(document2, document2.offsetAt(overwriteRange.end))), schema ? this.getPropertyCompletions(schema, doc, node, addValue, separatorAfter, collector) : this.getSchemaLessPropertyCompletions(doc, node, currentKey, collector);
            let location2 = getNodePath3(node);
            this.contributions.forEach((contribution) => {
              let collectPromise = contribution.collectPropertyCompletions(document2.uri, location2, currentWord, addValue, separatorAfter === "", collector);
              collectPromise && collectionPromises.push(collectPromise);
            }), !schema && currentWord.length > 0 && text.charAt(offset - currentWord.length - 1) !== '"' && (collector.add({
              kind: CompletionItemKind.Property,
              label: this.getLabelForValue(currentWord),
              insertText: this.getInsertTextForProperty(currentWord, void 0, !1, separatorAfter),
              insertTextFormat: InsertTextFormat.Snippet,
              documentation: ""
            }), collector.setAsIncomplete());
          }
          let types = {};
          return schema ? this.getValueCompletions(schema, doc, node, offset, document2, collector, types) : this.getSchemaLessValueCompletions(doc, node, offset, document2, collector), this.contributions.length > 0 && this.getContributedValueCompletions(doc, node, offset, document2, collector, collectionPromises), this.promiseConstructor.all(collectionPromises).then(() => {
            if (collector.getNumberOfProposals() === 0) {
              let offsetForSeparator = offset;
              node && (node.type === "string" || node.type === "number" || node.type === "boolean" || node.type === "null") && (offsetForSeparator = node.offset + node.length);
              let separatorAfter = this.evaluateSeparatorAfter(document2, offsetForSeparator);
              this.addFillerValueCompletions(types, separatorAfter, collector);
            }
            return result;
          });
        });
      }
      getPropertyCompletions(schema, doc, node, addValue, separatorAfter, collector) {
        doc.getMatchingSchemas(schema.schema, node.offset).forEach((s) => {
          if (s.node === node && !s.inverted) {
            let schemaProperties = s.schema.properties;
            schemaProperties && Object.keys(schemaProperties).forEach((key) => {
              let propertySchema = schemaProperties[key];
              if (typeof propertySchema == "object" && !propertySchema.deprecationMessage && !propertySchema.doNotSuggest) {
                let proposal = {
                  kind: CompletionItemKind.Property,
                  label: key,
                  insertText: this.getInsertTextForProperty(key, propertySchema, addValue, separatorAfter),
                  insertTextFormat: InsertTextFormat.Snippet,
                  filterText: this.getFilterTextForValue(key),
                  documentation: this.fromMarkup(propertySchema.markdownDescription) || propertySchema.description || ""
                };
                propertySchema.suggestSortText !== void 0 && (proposal.sortText = propertySchema.suggestSortText), proposal.insertText && endsWith(proposal.insertText, `$1${separatorAfter}`) && (proposal.command = {
                  title: "Suggest",
                  command: "editor.action.triggerSuggest"
                }), collector.add(proposal);
              }
            });
            let schemaPropertyNames = s.schema.propertyNames;
            if (typeof schemaPropertyNames == "object" && !schemaPropertyNames.deprecationMessage && !schemaPropertyNames.doNotSuggest) {
              let propertyNameCompletionItem = (name, enumDescription = void 0) => {
                let proposal = {
                  kind: CompletionItemKind.Property,
                  label: name,
                  insertText: this.getInsertTextForProperty(name, void 0, addValue, separatorAfter),
                  insertTextFormat: InsertTextFormat.Snippet,
                  filterText: this.getFilterTextForValue(name),
                  documentation: enumDescription || this.fromMarkup(schemaPropertyNames.markdownDescription) || schemaPropertyNames.description || ""
                };
                schemaPropertyNames.suggestSortText !== void 0 && (proposal.sortText = schemaPropertyNames.suggestSortText), proposal.insertText && endsWith(proposal.insertText, `$1${separatorAfter}`) && (proposal.command = {
                  title: "Suggest",
                  command: "editor.action.triggerSuggest"
                }), collector.add(proposal);
              };
              if (schemaPropertyNames.enum)
                for (let i = 0; i < schemaPropertyNames.enum.length; i++) {
                  let enumDescription;
                  schemaPropertyNames.markdownEnumDescriptions && i < schemaPropertyNames.markdownEnumDescriptions.length ? enumDescription = this.fromMarkup(schemaPropertyNames.markdownEnumDescriptions[i]) : schemaPropertyNames.enumDescriptions && i < schemaPropertyNames.enumDescriptions.length && (enumDescription = schemaPropertyNames.enumDescriptions[i]), propertyNameCompletionItem(schemaPropertyNames.enum[i], enumDescription);
                }
              schemaPropertyNames.const && propertyNameCompletionItem(schemaPropertyNames.const);
            }
          }
        });
      }
      getSchemaLessPropertyCompletions(doc, node, currentKey, collector) {
        let collectCompletionsForSimilarObject = (obj) => {
          obj.properties.forEach((p) => {
            let key = p.keyNode.value;
            collector.add({
              kind: CompletionItemKind.Property,
              label: key,
              insertText: this.getInsertTextForValue(key, ""),
              insertTextFormat: InsertTextFormat.Snippet,
              filterText: this.getFilterTextForValue(key),
              documentation: ""
            });
          });
        };
        if (node.parent)
          if (node.parent.type === "property") {
            let parentKey = node.parent.keyNode.value;
            doc.visit((n) => (n.type === "property" && n !== node.parent && n.keyNode.value === parentKey && n.valueNode && n.valueNode.type === "object" && collectCompletionsForSimilarObject(n.valueNode), !0));
          } else
            node.parent.type === "array" && node.parent.items.forEach((n) => {
              n.type === "object" && n !== node && collectCompletionsForSimilarObject(n);
            });
        else
          node.type === "object" && collector.add({
            kind: CompletionItemKind.Property,
            label: "$schema",
            insertText: this.getInsertTextForProperty("$schema", void 0, !0, ""),
            insertTextFormat: InsertTextFormat.Snippet,
            documentation: "",
            filterText: this.getFilterTextForValue("$schema")
          });
      }
      getSchemaLessValueCompletions(doc, node, offset, document2, collector) {
        let offsetForSeparator = offset;
        if (node && (node.type === "string" || node.type === "number" || node.type === "boolean" || node.type === "null") && (offsetForSeparator = node.offset + node.length, node = node.parent), !node) {
          collector.add({
            kind: this.getSuggestionKind("object"),
            label: "Empty object",
            insertText: this.getInsertTextForValue({}, ""),
            insertTextFormat: InsertTextFormat.Snippet,
            documentation: ""
          }), collector.add({
            kind: this.getSuggestionKind("array"),
            label: "Empty array",
            insertText: this.getInsertTextForValue([], ""),
            insertTextFormat: InsertTextFormat.Snippet,
            documentation: ""
          });
          return;
        }
        let separatorAfter = this.evaluateSeparatorAfter(document2, offsetForSeparator), collectSuggestionsForValues = (value) => {
          value.parent && !contains2(value.parent, offset, !0) && collector.add({
            kind: this.getSuggestionKind(value.type),
            label: this.getLabelTextForMatchingNode(value, document2),
            insertText: this.getInsertTextForMatchingNode(value, document2, separatorAfter),
            insertTextFormat: InsertTextFormat.Snippet,
            documentation: ""
          }), value.type === "boolean" && this.addBooleanValueCompletion(!value.value, separatorAfter, collector);
        };
        if (node.type === "property" && offset > (node.colonOffset || 0)) {
          let valueNode = node.valueNode;
          if (valueNode && (offset > valueNode.offset + valueNode.length || valueNode.type === "object" || valueNode.type === "array"))
            return;
          let parentKey = node.keyNode.value;
          doc.visit((n) => (n.type === "property" && n.keyNode.value === parentKey && n.valueNode && collectSuggestionsForValues(n.valueNode), !0)), parentKey === "$schema" && node.parent && !node.parent.parent && this.addDollarSchemaCompletions(separatorAfter, collector);
        }
        if (node.type === "array")
          if (node.parent && node.parent.type === "property") {
            let parentKey = node.parent.keyNode.value;
            doc.visit((n) => (n.type === "property" && n.keyNode.value === parentKey && n.valueNode && n.valueNode.type === "array" && n.valueNode.items.forEach(collectSuggestionsForValues), !0));
          } else
            node.items.forEach(collectSuggestionsForValues);
      }
      getValueCompletions(schema, doc, node, offset, document2, collector, types) {
        let offsetForSeparator = offset, parentKey, valueNode;
        if (node && (node.type === "string" || node.type === "number" || node.type === "boolean" || node.type === "null") && (offsetForSeparator = node.offset + node.length, valueNode = node, node = node.parent), !node) {
          this.addSchemaValueCompletions(schema.schema, "", collector, types);
          return;
        }
        if (node.type === "property" && offset > (node.colonOffset || 0)) {
          let valueNode2 = node.valueNode;
          if (valueNode2 && offset > valueNode2.offset + valueNode2.length)
            return;
          parentKey = node.keyNode.value, node = node.parent;
        }
        if (node && (parentKey !== void 0 || node.type === "array")) {
          let separatorAfter = this.evaluateSeparatorAfter(document2, offsetForSeparator), matchingSchemas = doc.getMatchingSchemas(schema.schema, node.offset, valueNode);
          for (let s of matchingSchemas)
            if (s.node === node && !s.inverted && s.schema) {
              if (node.type === "array" && s.schema.items) {
                let c = collector;
                if (s.schema.uniqueItems) {
                  let existingValues = /* @__PURE__ */ new Set();
                  node.children.forEach((n) => {
                    n.type !== "array" && n.type !== "object" && existingValues.add(this.getLabelForValue(getNodeValue3(n)));
                  }), c = {
                    ...collector,
                    add(suggestion) {
                      existingValues.has(suggestion.label) || collector.add(suggestion);
                    }
                  };
                }
                if (Array.isArray(s.schema.items)) {
                  let index = this.findItemAtOffset(node, document2, offset);
                  index < s.schema.items.length && this.addSchemaValueCompletions(s.schema.items[index], separatorAfter, c, types);
                } else
                  this.addSchemaValueCompletions(s.schema.items, separatorAfter, c, types);
              }
              if (parentKey !== void 0) {
                let propertyMatched = !1;
                if (s.schema.properties) {
                  let propertySchema = s.schema.properties[parentKey];
                  propertySchema && (propertyMatched = !0, this.addSchemaValueCompletions(propertySchema, separatorAfter, collector, types));
                }
                if (s.schema.patternProperties && !propertyMatched) {
                  for (let pattern of Object.keys(s.schema.patternProperties))
                    if (extendedRegExp(pattern)?.test(parentKey)) {
                      propertyMatched = !0;
                      let propertySchema = s.schema.patternProperties[pattern];
                      this.addSchemaValueCompletions(propertySchema, separatorAfter, collector, types);
                    }
                }
                if (s.schema.additionalProperties && !propertyMatched) {
                  let propertySchema = s.schema.additionalProperties;
                  this.addSchemaValueCompletions(propertySchema, separatorAfter, collector, types);
                }
              }
            }
          parentKey === "$schema" && !node.parent && this.addDollarSchemaCompletions(separatorAfter, collector), types.boolean && (this.addBooleanValueCompletion(!0, separatorAfter, collector), this.addBooleanValueCompletion(!1, separatorAfter, collector)), types.null && this.addNullValueCompletion(separatorAfter, collector);
        }
      }
      getContributedValueCompletions(doc, node, offset, document2, collector, collectionPromises) {
        if (!node)
          this.contributions.forEach((contribution) => {
            let collectPromise = contribution.collectDefaultCompletions(document2.uri, collector);
            collectPromise && collectionPromises.push(collectPromise);
          });
        else if ((node.type === "string" || node.type === "number" || node.type === "boolean" || node.type === "null") && (node = node.parent), node && node.type === "property" && offset > (node.colonOffset || 0)) {
          let parentKey = node.keyNode.value, valueNode = node.valueNode;
          if ((!valueNode || offset <= valueNode.offset + valueNode.length) && node.parent) {
            let location2 = getNodePath3(node.parent);
            this.contributions.forEach((contribution) => {
              let collectPromise = contribution.collectValueCompletions(document2.uri, location2, parentKey, collector);
              collectPromise && collectionPromises.push(collectPromise);
            });
          }
        }
      }
      addSchemaValueCompletions(schema, separatorAfter, collector, types) {
        typeof schema == "object" && (this.addEnumValueCompletions(schema, separatorAfter, collector), this.addDefaultValueCompletions(schema, separatorAfter, collector), this.collectTypes(schema, types), Array.isArray(schema.allOf) && schema.allOf.forEach((s) => this.addSchemaValueCompletions(s, separatorAfter, collector, types)), Array.isArray(schema.anyOf) && schema.anyOf.forEach((s) => this.addSchemaValueCompletions(s, separatorAfter, collector, types)), Array.isArray(schema.oneOf) && schema.oneOf.forEach((s) => this.addSchemaValueCompletions(s, separatorAfter, collector, types)));
      }
      addDefaultValueCompletions(schema, separatorAfter, collector, arrayDepth = 0) {
        let hasProposals = !1;
        if (isDefined(schema.default)) {
          let type = schema.type, value = schema.default;
          for (let i = arrayDepth; i > 0; i--)
            value = [value], type = "array";
          let completionItem = {
            kind: this.getSuggestionKind(type),
            label: this.getLabelForValue(value),
            insertText: this.getInsertTextForValue(value, separatorAfter),
            insertTextFormat: InsertTextFormat.Snippet
          };
          this.doesSupportsLabelDetails() ? completionItem.labelDetails = { description: l10n2.t("Default value") } : completionItem.detail = l10n2.t("Default value"), collector.add(completionItem), hasProposals = !0;
        }
        Array.isArray(schema.examples) && schema.examples.forEach((example) => {
          let type = schema.type, value = example;
          for (let i = arrayDepth; i > 0; i--)
            value = [value], type = "array";
          collector.add({
            kind: this.getSuggestionKind(type),
            label: this.getLabelForValue(value),
            insertText: this.getInsertTextForValue(value, separatorAfter),
            insertTextFormat: InsertTextFormat.Snippet
          }), hasProposals = !0;
        }), Array.isArray(schema.defaultSnippets) && schema.defaultSnippets.forEach((s) => {
          let type = schema.type, value = s.body, label = s.label, insertText, filterText;
          if (isDefined(value)) {
            let type2 = schema.type;
            for (let i = arrayDepth; i > 0; i--)
              value = [value], type2 = "array";
            insertText = this.getInsertTextForSnippetValue(value, separatorAfter), filterText = this.getFilterTextForSnippetValue(value), label = label || this.getLabelForSnippetValue(value);
          } else if (typeof s.bodyText == "string") {
            let prefix = "", suffix = "", indent = "";
            for (let i = arrayDepth; i > 0; i--)
              prefix = prefix + indent + `[
`, suffix = suffix + `
` + indent + "]", indent += "	", type = "array";
            insertText = prefix + indent + s.bodyText.split(`
`).join(`
` + indent) + suffix + separatorAfter, label = label || insertText, filterText = insertText.replace(/[\n]/g, "");
          } else
            return;
          collector.add({
            kind: this.getSuggestionKind(type),
            label,
            documentation: this.fromMarkup(s.markdownDescription) || s.description,
            insertText,
            insertTextFormat: InsertTextFormat.Snippet,
            filterText
          }), hasProposals = !0;
        }), !hasProposals && typeof schema.items == "object" && !Array.isArray(schema.items) && arrayDepth < 5 && this.addDefaultValueCompletions(schema.items, separatorAfter, collector, arrayDepth + 1);
      }
      addEnumValueCompletions(schema, separatorAfter, collector) {
        if (isDefined(schema.const) && collector.add({
          kind: this.getSuggestionKind(schema.type),
          label: this.getLabelForValue(schema.const),
          insertText: this.getInsertTextForValue(schema.const, separatorAfter),
          insertTextFormat: InsertTextFormat.Snippet,
          documentation: this.fromMarkup(schema.markdownDescription) || schema.description
        }), Array.isArray(schema.enum))
          for (let i = 0, length = schema.enum.length; i < length; i++) {
            let enm = schema.enum[i], documentation = this.fromMarkup(schema.markdownDescription) || schema.description;
            schema.markdownEnumDescriptions && i < schema.markdownEnumDescriptions.length && this.doesSupportMarkdown() ? documentation = this.fromMarkup(schema.markdownEnumDescriptions[i]) : schema.enumDescriptions && i < schema.enumDescriptions.length && (documentation = schema.enumDescriptions[i]), collector.add({
              kind: this.getSuggestionKind(schema.type),
              label: this.getLabelForValue(enm),
              insertText: this.getInsertTextForValue(enm, separatorAfter),
              insertTextFormat: InsertTextFormat.Snippet,
              documentation
            });
          }
      }
      collectTypes(schema, types) {
        if (Array.isArray(schema.enum) || isDefined(schema.const))
          return;
        let type = schema.type;
        Array.isArray(type) ? type.forEach((t7) => types[t7] = !0) : type && (types[type] = !0);
      }
      addFillerValueCompletions(types, separatorAfter, collector) {
        types.object && collector.add({
          kind: this.getSuggestionKind("object"),
          label: "{}",
          insertText: this.getInsertTextForGuessedValue({}, separatorAfter),
          insertTextFormat: InsertTextFormat.Snippet,
          detail: l10n2.t("New object"),
          documentation: ""
        }), types.array && collector.add({
          kind: this.getSuggestionKind("array"),
          label: "[]",
          insertText: this.getInsertTextForGuessedValue([], separatorAfter),
          insertTextFormat: InsertTextFormat.Snippet,
          detail: l10n2.t("New array"),
          documentation: ""
        });
      }
      addBooleanValueCompletion(value, separatorAfter, collector) {
        collector.add({
          kind: this.getSuggestionKind("boolean"),
          label: value ? "true" : "false",
          insertText: this.getInsertTextForValue(value, separatorAfter),
          insertTextFormat: InsertTextFormat.Snippet,
          documentation: ""
        });
      }
      addNullValueCompletion(separatorAfter, collector) {
        collector.add({
          kind: this.getSuggestionKind("null"),
          label: "null",
          insertText: "null" + separatorAfter,
          insertTextFormat: InsertTextFormat.Snippet,
          documentation: ""
        });
      }
      addDollarSchemaCompletions(separatorAfter, collector) {
        this.schemaService.getRegisteredSchemaIds((schema) => schema === "http" || schema === "https").forEach((schemaId) => {
          schemaId.startsWith("http://json-schema.org/draft-") && (schemaId = schemaId + "#"), collector.add({
            kind: CompletionItemKind.Module,
            label: this.getLabelForValue(schemaId),
            filterText: this.getFilterTextForValue(schemaId),
            insertText: this.getInsertTextForValue(schemaId, separatorAfter),
            insertTextFormat: InsertTextFormat.Snippet,
            documentation: ""
          });
        });
      }
      getLabelForValue(value) {
        return JSON.stringify(value);
      }
      getValueFromLabel(value) {
        return JSON.parse(value);
      }
      getFilterTextForValue(value) {
        return JSON.stringify(value);
      }
      getFilterTextForSnippetValue(value) {
        return JSON.stringify(value).replace(/\$\{\d+:([^}]+)\}|\$\d+/g, "$1");
      }
      getLabelForSnippetValue(value) {
        return JSON.stringify(value).replace(/\$\{\d+:([^}]+)\}|\$\d+/g, "$1");
      }
      getInsertTextForPlainText(text) {
        return text.replace(/[\\\$\}]/g, "\\$&");
      }
      getInsertTextForValue(value, separatorAfter) {
        let text = JSON.stringify(value, null, "	");
        return text === "{}" ? "{$1}" + separatorAfter : text === "[]" ? "[$1]" + separatorAfter : this.getInsertTextForPlainText(text + separatorAfter);
      }
      getInsertTextForSnippetValue(value, separatorAfter) {
        return stringifyObject(value, "", (value2) => typeof value2 == "string" && value2[0] === "^" ? value2.substr(1) : JSON.stringify(value2)) + separatorAfter;
      }
      getInsertTextForGuessedValue(value, separatorAfter) {
        switch (typeof value) {
          case "object":
            return value === null ? "${1:null}" + separatorAfter : this.getInsertTextForValue(value, separatorAfter);
          case "string":
            let snippetValue = JSON.stringify(value);
            return snippetValue = snippetValue.substr(1, snippetValue.length - 2), snippetValue = this.getInsertTextForPlainText(snippetValue), '"${1:' + snippetValue + '}"' + separatorAfter;
          case "number":
          case "boolean":
            return "${1:" + JSON.stringify(value) + "}" + separatorAfter;
        }
        return this.getInsertTextForValue(value, separatorAfter);
      }
      getSuggestionKind(type) {
        if (Array.isArray(type)) {
          let array = type;
          type = array.length > 0 ? array[0] : void 0;
        }
        if (!type)
          return CompletionItemKind.Value;
        switch (type) {
          case "string":
            return CompletionItemKind.Value;
          case "object":
            return CompletionItemKind.Module;
          case "property":
            return CompletionItemKind.Property;
          default:
            return CompletionItemKind.Value;
        }
      }
      getLabelTextForMatchingNode(node, document2) {
        switch (node.type) {
          case "array":
            return "[]";
          case "object":
            return "{}";
          default:
            return document2.getText().substr(node.offset, node.length);
        }
      }
      getInsertTextForMatchingNode(node, document2, separatorAfter) {
        switch (node.type) {
          case "array":
            return this.getInsertTextForValue([], separatorAfter);
          case "object":
            return this.getInsertTextForValue({}, separatorAfter);
          default:
            let content = document2.getText().substr(node.offset, node.length) + separatorAfter;
            return this.getInsertTextForPlainText(content);
        }
      }
      getInsertTextForProperty(key, propertySchema, addValue, separatorAfter) {
        let propertyText = this.getInsertTextForValue(key, "");
        if (!addValue)
          return propertyText;
        let resultText = propertyText + ": ", value, nValueProposals = 0;
        if (propertySchema) {
          if (Array.isArray(propertySchema.defaultSnippets)) {
            if (propertySchema.defaultSnippets.length === 1) {
              let body = propertySchema.defaultSnippets[0].body;
              isDefined(body) && (value = this.getInsertTextForSnippetValue(body, ""));
            }
            nValueProposals += propertySchema.defaultSnippets.length;
          }
          if (propertySchema.enum && (!value && propertySchema.enum.length === 1 && (value = this.getInsertTextForGuessedValue(propertySchema.enum[0], "")), nValueProposals += propertySchema.enum.length), isDefined(propertySchema.const) && (value || (value = this.getInsertTextForGuessedValue(propertySchema.const, "")), nValueProposals++), isDefined(propertySchema.default) && (value || (value = this.getInsertTextForGuessedValue(propertySchema.default, "")), nValueProposals++), Array.isArray(propertySchema.examples) && propertySchema.examples.length && (value || (value = this.getInsertTextForGuessedValue(propertySchema.examples[0], "")), nValueProposals += propertySchema.examples.length), nValueProposals === 0) {
            let type = Array.isArray(propertySchema.type) ? propertySchema.type[0] : propertySchema.type;
            switch (type || (propertySchema.properties ? type = "object" : propertySchema.items && (type = "array")), type) {
              case "boolean":
                value = "$1";
                break;
              case "string":
                value = '"$1"';
                break;
              case "object":
                value = "{$1}";
                break;
              case "array":
                value = "[$1]";
                break;
              case "number":
              case "integer":
                value = "${1:0}";
                break;
              case "null":
                value = "${1:null}";
                break;
              default:
                return propertyText;
            }
          }
        }
        return (!value || nValueProposals > 1) && (value = "$1"), resultText + value + separatorAfter;
      }
      getCurrentWord(document2, offset) {
        let i = offset - 1, text = document2.getText();
        for (; i >= 0 && ` 	
\r\v":{[,]}`.indexOf(text.charAt(i)) === -1; )
          i--;
        return text.substring(i + 1, offset);
      }
      evaluateSeparatorAfter(document2, offset) {
        let scanner = createScanner2(document2.getText(), !0);
        switch (scanner.setPosition(offset), scanner.scan()) {
          case 5:
          case 2:
          case 4:
          case 17:
            return "";
          default:
            return ",";
        }
      }
      findItemAtOffset(node, document2, offset) {
        let scanner = createScanner2(document2.getText(), !0), children = node.items;
        for (let i = children.length - 1; i >= 0; i--) {
          let child = children[i];
          if (offset > child.offset + child.length)
            return scanner.setPosition(child.offset + child.length), scanner.scan() === 5 && offset >= scanner.getTokenOffset() + scanner.getTokenLength() ? i + 1 : i;
          if (offset >= child.offset)
            return i;
        }
        return 0;
      }
      isInComment(document2, start, offset) {
        let scanner = createScanner2(document2.getText(), !1);
        scanner.setPosition(start);
        let token = scanner.scan();
        for (; token !== 17 && scanner.getTokenOffset() + scanner.getTokenLength() < offset; )
          token = scanner.scan();
        return (token === 12 || token === 13) && scanner.getTokenOffset() <= offset;
      }
      fromMarkup(markupString) {
        if (markupString && this.doesSupportMarkdown())
          return {
            kind: MarkupKind.Markdown,
            value: markupString
          };
      }
      doesSupportMarkdown() {
        if (!isDefined(this.supportsMarkdown)) {
          let documentationFormat = this.clientCapabilities.textDocument?.completion?.completionItem?.documentationFormat;
          this.supportsMarkdown = Array.isArray(documentationFormat) && documentationFormat.indexOf(MarkupKind.Markdown) !== -1;
        }
        return this.supportsMarkdown;
      }
      doesSupportsCommitCharacters() {
        return isDefined(this.supportsCommitCharacters) || (this.labelDetailsSupport = this.clientCapabilities.textDocument?.completion?.completionItem?.commitCharactersSupport), this.supportsCommitCharacters;
      }
      doesSupportsLabelDetails() {
        return isDefined(this.labelDetailsSupport) || (this.labelDetailsSupport = this.clientCapabilities.textDocument?.completion?.completionItem?.labelDetailsSupport), this.labelDetailsSupport;
      }
    };
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/jsonHover.js
function toMarkdown(plain) {
  if (plain)
    return plain.replace(/([^\n\r])(\r?\n)([^\n\r])/gm, `$1

$3`).replace(/[\\`*_{}[\]()#+\-.!]/g, "\\$&");
}
function toMarkdownCodeBlock(content) {
  return content.indexOf("`") !== -1 ? "`` " + content + " ``" : content;
}
var JSONHover, init_jsonHover = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/jsonHover.js"() {
    init_cjs_shims();
    init_jsonParser();
    init_jsonLanguageTypes();
    JSONHover = class {
      constructor(schemaService, contributions = [], promiseConstructor) {
        this.schemaService = schemaService, this.contributions = contributions, this.promise = promiseConstructor || Promise;
      }
      doHover(document2, position, doc) {
        let offset = document2.offsetAt(position), node = doc.getNodeFromOffset(offset);
        if (!node || (node.type === "object" || node.type === "array") && offset > node.offset + 1 && offset < node.offset + node.length - 1)
          return this.promise.resolve(null);
        let hoverRangeNode = node;
        if (node.type === "string") {
          let parent = node.parent;
          if (parent && parent.type === "property" && parent.keyNode === node && (node = parent.valueNode, !node))
            return this.promise.resolve(null);
        }
        let hoverRange = Range.create(document2.positionAt(hoverRangeNode.offset), document2.positionAt(hoverRangeNode.offset + hoverRangeNode.length)), createHover = (contents) => ({
          contents,
          range: hoverRange
        }), location2 = getNodePath3(node);
        for (let i = this.contributions.length - 1; i >= 0; i--) {
          let promise = this.contributions[i].getInfoContribution(document2.uri, location2);
          if (promise)
            return promise.then((htmlContent) => createHover(htmlContent));
        }
        return this.schemaService.getSchemaForResource(document2.uri, doc).then((schema) => {
          if (schema && node) {
            let matchingSchemas = doc.getMatchingSchemas(schema.schema, node.offset), title, markdownDescription, markdownEnumValueDescription, enumValue;
            matchingSchemas.every((s) => {
              if (s.node === node && !s.inverted && s.schema && (title = title || s.schema.title, markdownDescription = markdownDescription || s.schema.markdownDescription || toMarkdown(s.schema.description), s.schema.enum)) {
                let idx = s.schema.enum.indexOf(getNodeValue3(node));
                s.schema.markdownEnumDescriptions ? markdownEnumValueDescription = s.schema.markdownEnumDescriptions[idx] : s.schema.enumDescriptions && (markdownEnumValueDescription = toMarkdown(s.schema.enumDescriptions[idx])), markdownEnumValueDescription && (enumValue = s.schema.enum[idx], typeof enumValue != "string" && (enumValue = JSON.stringify(enumValue)));
              }
              return !0;
            });
            let result = "";
            return title && (result = toMarkdown(title)), markdownDescription && (result.length > 0 && (result += `

`), result += markdownDescription), markdownEnumValueDescription && (result.length > 0 && (result += `

`), result += `\`${toMarkdownCodeBlock(enumValue)}\`: ${markdownEnumValueDescription}`), createHover([result]);
          }
          return null;
        });
      }
    };
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/jsonValidation.js
function schemaAllowsComments(schemaRef) {
  if (schemaRef && typeof schemaRef == "object") {
    if (isBoolean(schemaRef.allowComments))
      return schemaRef.allowComments;
    if (schemaRef.allOf)
      for (let schema of schemaRef.allOf) {
        let allow = schemaAllowsComments(schema);
        if (isBoolean(allow))
          return allow;
      }
  }
}
function schemaAllowsTrailingCommas(schemaRef) {
  if (schemaRef && typeof schemaRef == "object") {
    if (isBoolean(schemaRef.allowTrailingCommas))
      return schemaRef.allowTrailingCommas;
    let deprSchemaRef = schemaRef;
    if (isBoolean(deprSchemaRef.allowsTrailingCommas))
      return deprSchemaRef.allowsTrailingCommas;
    if (schemaRef.allOf)
      for (let schema of schemaRef.allOf) {
        let allow = schemaAllowsTrailingCommas(schema);
        if (isBoolean(allow))
          return allow;
      }
  }
}
function toDiagnosticSeverity(severityLevel) {
  switch (severityLevel) {
    case "error":
      return DiagnosticSeverity.Error;
    case "warning":
      return DiagnosticSeverity.Warning;
    case "ignore":
      return;
  }
}
var l10n3, JSONValidation, idCounter, init_jsonValidation = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/jsonValidation.js"() {
    init_cjs_shims();
    init_jsonLanguageTypes();
    l10n3 = __toESM(require_main2());
    init_objects();
    JSONValidation = class {
      constructor(jsonSchemaService, promiseConstructor) {
        this.jsonSchemaService = jsonSchemaService, this.promise = promiseConstructor, this.validationEnabled = !0;
      }
      configure(raw) {
        raw && (this.validationEnabled = raw.validate !== !1, this.commentSeverity = raw.allowComments ? void 0 : DiagnosticSeverity.Error);
      }
      doValidation(textDocument, jsonDocument, documentSettings, schema) {
        if (!this.validationEnabled)
          return this.promise.resolve([]);
        let diagnostics = [], added = {}, addProblem = (problem) => {
          let signature = problem.range.start.line + " " + problem.range.start.character + " " + problem.message;
          added[signature] || (added[signature] = !0, diagnostics.push(problem));
        }, getDiagnostics = (schema2) => {
          let trailingCommaSeverity = documentSettings?.trailingCommas ? toDiagnosticSeverity(documentSettings.trailingCommas) : DiagnosticSeverity.Error, commentSeverity = documentSettings?.comments ? toDiagnosticSeverity(documentSettings.comments) : this.commentSeverity, schemaValidation = documentSettings?.schemaValidation ? toDiagnosticSeverity(documentSettings.schemaValidation) : DiagnosticSeverity.Warning, schemaRequest = documentSettings?.schemaRequest ? toDiagnosticSeverity(documentSettings.schemaRequest) : DiagnosticSeverity.Warning;
          if (schema2) {
            let addSchemaProblem = (errorMessage2, errorCode) => {
              if (jsonDocument.root && schemaRequest) {
                let astRoot = jsonDocument.root, property = astRoot.type === "object" ? astRoot.properties[0] : void 0;
                if (property && property.keyNode.value === "$schema") {
                  let node = property.valueNode || property, range = Range.create(textDocument.positionAt(node.offset), textDocument.positionAt(node.offset + node.length));
                  addProblem(Diagnostic.create(range, errorMessage2, schemaRequest, errorCode));
                } else {
                  let range = Range.create(textDocument.positionAt(astRoot.offset), textDocument.positionAt(astRoot.offset + 1));
                  addProblem(Diagnostic.create(range, errorMessage2, schemaRequest, errorCode));
                }
              }
            };
            if (schema2.errors.length)
              addSchemaProblem(schema2.errors[0], ErrorCode.SchemaResolveError);
            else if (schemaValidation) {
              for (let warning of schema2.warnings)
                addSchemaProblem(warning, ErrorCode.SchemaUnsupportedFeature);
              let semanticErrors = jsonDocument.validate(textDocument, schema2.schema, schemaValidation, documentSettings?.schemaDraft);
              semanticErrors && semanticErrors.forEach(addProblem);
            }
            schemaAllowsComments(schema2.schema) && (commentSeverity = void 0), schemaAllowsTrailingCommas(schema2.schema) && (trailingCommaSeverity = void 0);
          }
          for (let p of jsonDocument.syntaxErrors) {
            if (p.code === ErrorCode.TrailingComma) {
              if (typeof trailingCommaSeverity != "number")
                continue;
              p.severity = trailingCommaSeverity;
            }
            addProblem(p);
          }
          if (typeof commentSeverity == "number") {
            let message = l10n3.t("Comments are not permitted in JSON.");
            jsonDocument.comments.forEach((c) => {
              addProblem(Diagnostic.create(c, message, commentSeverity, ErrorCode.CommentNotPermitted));
            });
          }
          return diagnostics;
        };
        if (schema) {
          let uri = schema.id || "schemaservice://untitled/" + idCounter++;
          return this.jsonSchemaService.registerExternalSchema({ uri, schema }).getResolvedSchema().then((resolvedSchema) => getDiagnostics(resolvedSchema));
        }
        return this.jsonSchemaService.getSchemaForResource(textDocument.uri, jsonDocument).then((schema2) => getDiagnostics(schema2));
      }
      getLanguageStatus(textDocument, jsonDocument) {
        return { schemas: this.jsonSchemaService.getSchemaURIsForResource(textDocument.uri, jsonDocument) };
      }
    }, idCounter = 0;
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/utils/colors.js
function hexDigit(charCode) {
  return charCode < 48 ? 0 : charCode <= 57 ? charCode - 48 : (charCode < 97 && (charCode += 32), charCode >= 97 && charCode <= 102 ? charCode - 97 + 10 : 0);
}
function colorFromHex(text) {
  if (text[0] === "#")
    switch (text.length) {
      case 4:
        return {
          red: hexDigit(text.charCodeAt(1)) * 17 / 255,
          green: hexDigit(text.charCodeAt(2)) * 17 / 255,
          blue: hexDigit(text.charCodeAt(3)) * 17 / 255,
          alpha: 1
        };
      case 5:
        return {
          red: hexDigit(text.charCodeAt(1)) * 17 / 255,
          green: hexDigit(text.charCodeAt(2)) * 17 / 255,
          blue: hexDigit(text.charCodeAt(3)) * 17 / 255,
          alpha: hexDigit(text.charCodeAt(4)) * 17 / 255
        };
      case 7:
        return {
          red: (hexDigit(text.charCodeAt(1)) * 16 + hexDigit(text.charCodeAt(2))) / 255,
          green: (hexDigit(text.charCodeAt(3)) * 16 + hexDigit(text.charCodeAt(4))) / 255,
          blue: (hexDigit(text.charCodeAt(5)) * 16 + hexDigit(text.charCodeAt(6))) / 255,
          alpha: 1
        };
      case 9:
        return {
          red: (hexDigit(text.charCodeAt(1)) * 16 + hexDigit(text.charCodeAt(2))) / 255,
          green: (hexDigit(text.charCodeAt(3)) * 16 + hexDigit(text.charCodeAt(4))) / 255,
          blue: (hexDigit(text.charCodeAt(5)) * 16 + hexDigit(text.charCodeAt(6))) / 255,
          alpha: (hexDigit(text.charCodeAt(7)) * 16 + hexDigit(text.charCodeAt(8))) / 255
        };
    }
}
var init_colors = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/utils/colors.js"() {
    init_cjs_shims();
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/jsonDocumentSymbols.js
function getRange(document2, node) {
  return Range.create(document2.positionAt(node.offset), document2.positionAt(node.offset + node.length));
}
function getName(node) {
  return getNodeValue3(node) || l10n4.t("<empty>");
}
var l10n4, JSONDocumentSymbols, init_jsonDocumentSymbols = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/jsonDocumentSymbols.js"() {
    init_cjs_shims();
    init_jsonParser();
    init_strings();
    init_colors();
    l10n4 = __toESM(require_main2());
    init_jsonLanguageTypes();
    JSONDocumentSymbols = class {
      constructor(schemaService) {
        this.schemaService = schemaService;
      }
      findDocumentSymbols(document2, doc, context = { resultLimit: Number.MAX_VALUE }) {
        let root = doc.root;
        if (!root)
          return [];
        let limit = context.resultLimit || Number.MAX_VALUE, resourceString = document2.uri;
        if ((resourceString === "vscode://defaultsettings/keybindings.json" || endsWith(resourceString.toLowerCase(), "/user/keybindings.json")) && root.type === "array") {
          let result2 = [];
          for (let item of root.items)
            if (item.type === "object") {
              for (let property of item.properties)
                if (property.keyNode.value === "key" && property.valueNode) {
                  let location2 = Location.create(document2.uri, getRange(document2, item));
                  if (result2.push({ name: getName(property.valueNode), kind: SymbolKind.Function, location: location2 }), limit--, limit <= 0)
                    return context && context.onResultLimitExceeded && context.onResultLimitExceeded(resourceString), result2;
                }
            }
          return result2;
        }
        let toVisit = [
          { node: root, containerName: "" }
        ], nextToVisit = 0, limitExceeded = !1, result = [], collectOutlineEntries = (node, containerName) => {
          node.type === "array" ? node.items.forEach((node2) => {
            node2 && toVisit.push({ node: node2, containerName });
          }) : node.type === "object" && node.properties.forEach((property) => {
            let valueNode = property.valueNode;
            if (valueNode)
              if (limit > 0) {
                limit--;
                let location2 = Location.create(document2.uri, getRange(document2, property)), childContainerName = containerName ? containerName + "." + property.keyNode.value : property.keyNode.value;
                result.push({ name: this.getKeyLabel(property), kind: this.getSymbolKind(valueNode.type), location: location2, containerName }), toVisit.push({ node: valueNode, containerName: childContainerName });
              } else
                limitExceeded = !0;
          });
        };
        for (; nextToVisit < toVisit.length; ) {
          let next = toVisit[nextToVisit++];
          collectOutlineEntries(next.node, next.containerName);
        }
        return limitExceeded && context && context.onResultLimitExceeded && context.onResultLimitExceeded(resourceString), result;
      }
      findDocumentSymbols2(document2, doc, context = { resultLimit: Number.MAX_VALUE }) {
        let root = doc.root;
        if (!root)
          return [];
        let limit = context.resultLimit || Number.MAX_VALUE, resourceString = document2.uri;
        if ((resourceString === "vscode://defaultsettings/keybindings.json" || endsWith(resourceString.toLowerCase(), "/user/keybindings.json")) && root.type === "array") {
          let result2 = [];
          for (let item of root.items)
            if (item.type === "object") {
              for (let property of item.properties)
                if (property.keyNode.value === "key" && property.valueNode) {
                  let range = getRange(document2, item), selectionRange = getRange(document2, property.keyNode);
                  if (result2.push({ name: getName(property.valueNode), kind: SymbolKind.Function, range, selectionRange }), limit--, limit <= 0)
                    return context && context.onResultLimitExceeded && context.onResultLimitExceeded(resourceString), result2;
                }
            }
          return result2;
        }
        let result = [], toVisit = [
          { node: root, result }
        ], nextToVisit = 0, limitExceeded = !1, collectOutlineEntries = (node, result2) => {
          node.type === "array" ? node.items.forEach((node2, index) => {
            if (node2)
              if (limit > 0) {
                limit--;
                let range = getRange(document2, node2), selectionRange = range, symbol = { name: String(index), kind: this.getSymbolKind(node2.type), range, selectionRange, children: [] };
                result2.push(symbol), toVisit.push({ result: symbol.children, node: node2 });
              } else
                limitExceeded = !0;
          }) : node.type === "object" && node.properties.forEach((property) => {
            let valueNode = property.valueNode;
            if (valueNode)
              if (limit > 0) {
                limit--;
                let range = getRange(document2, property), selectionRange = getRange(document2, property.keyNode), children = [], symbol = { name: this.getKeyLabel(property), kind: this.getSymbolKind(valueNode.type), range, selectionRange, children, detail: this.getDetail(valueNode) };
                result2.push(symbol), toVisit.push({ result: children, node: valueNode });
              } else
                limitExceeded = !0;
          });
        };
        for (; nextToVisit < toVisit.length; ) {
          let next = toVisit[nextToVisit++];
          collectOutlineEntries(next.node, next.result);
        }
        return limitExceeded && context && context.onResultLimitExceeded && context.onResultLimitExceeded(resourceString), result;
      }
      getSymbolKind(nodeType) {
        switch (nodeType) {
          case "object":
            return SymbolKind.Module;
          case "string":
            return SymbolKind.String;
          case "number":
            return SymbolKind.Number;
          case "array":
            return SymbolKind.Array;
          case "boolean":
            return SymbolKind.Boolean;
          default:
            return SymbolKind.Variable;
        }
      }
      getKeyLabel(property) {
        let name = property.keyNode.value;
        return name && (name = name.replace(/[\n]/g, "\u21B5")), name && name.trim() ? name : `"${name}"`;
      }
      getDetail(node) {
        if (node) {
          if (node.type === "boolean" || node.type === "number" || node.type === "null" || node.type === "string")
            return String(node.value);
          if (node.type === "array")
            return node.children.length ? void 0 : "[]";
          if (node.type === "object")
            return node.children.length ? void 0 : "{}";
        }
      }
      findDocumentColors(document2, doc, context) {
        return this.schemaService.getSchemaForResource(document2.uri, doc).then((schema) => {
          let result = [];
          if (schema) {
            let limit = context && typeof context.resultLimit == "number" ? context.resultLimit : Number.MAX_VALUE, matchingSchemas = doc.getMatchingSchemas(schema.schema), visitedNode = {};
            for (let s of matchingSchemas)
              if (!s.inverted && s.schema && (s.schema.format === "color" || s.schema.format === "color-hex") && s.node && s.node.type === "string") {
                let nodeId = String(s.node.offset);
                if (!visitedNode[nodeId]) {
                  let color = colorFromHex(getNodeValue3(s.node));
                  if (color) {
                    let range = getRange(document2, s.node);
                    result.push({ color, range });
                  }
                  if (visitedNode[nodeId] = !0, limit--, limit <= 0)
                    return context && context.onResultLimitExceeded && context.onResultLimitExceeded(document2.uri), result;
                }
              }
          }
          return result;
        });
      }
      getColorPresentations(document2, doc, color, range) {
        let result = [], red256 = Math.round(color.red * 255), green256 = Math.round(color.green * 255), blue256 = Math.round(color.blue * 255);
        function toTwoDigitHex(n) {
          let r2 = n.toString(16);
          return r2.length !== 2 ? "0" + r2 : r2;
        }
        let label;
        return color.alpha === 1 ? label = `#${toTwoDigitHex(red256)}${toTwoDigitHex(green256)}${toTwoDigitHex(blue256)}` : label = `#${toTwoDigitHex(red256)}${toTwoDigitHex(green256)}${toTwoDigitHex(blue256)}${toTwoDigitHex(Math.round(color.alpha * 255))}`, result.push({ label, textEdit: TextEdit.replace(range, JSON.stringify(label)) }), result;
      }
    };
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/configuration.js
var l10n5, schemaContributions, descriptions, init_configuration = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/configuration.js"() {
    init_cjs_shims();
    l10n5 = __toESM(require_main2()), schemaContributions = {
      schemaAssociations: [],
      schemas: {
        // bundle the schema-schema to include (localized) descriptions
        "http://json-schema.org/draft-04/schema#": {
          $schema: "http://json-schema.org/draft-04/schema#",
          definitions: {
            schemaArray: {
              type: "array",
              minItems: 1,
              items: {
                $ref: "#"
              }
            },
            positiveInteger: {
              type: "integer",
              minimum: 0
            },
            positiveIntegerDefault0: {
              allOf: [
                {
                  $ref: "#/definitions/positiveInteger"
                },
                {
                  default: 0
                }
              ]
            },
            simpleTypes: {
              type: "string",
              enum: [
                "array",
                "boolean",
                "integer",
                "null",
                "number",
                "object",
                "string"
              ]
            },
            stringArray: {
              type: "array",
              items: {
                type: "string"
              },
              minItems: 1,
              uniqueItems: !0
            }
          },
          type: "object",
          properties: {
            id: {
              type: "string",
              format: "uri"
            },
            $schema: {
              type: "string",
              format: "uri"
            },
            title: {
              type: "string"
            },
            description: {
              type: "string"
            },
            default: {},
            multipleOf: {
              type: "number",
              minimum: 0,
              exclusiveMinimum: !0
            },
            maximum: {
              type: "number"
            },
            exclusiveMaximum: {
              type: "boolean",
              default: !1
            },
            minimum: {
              type: "number"
            },
            exclusiveMinimum: {
              type: "boolean",
              default: !1
            },
            maxLength: {
              allOf: [
                {
                  $ref: "#/definitions/positiveInteger"
                }
              ]
            },
            minLength: {
              allOf: [
                {
                  $ref: "#/definitions/positiveIntegerDefault0"
                }
              ]
            },
            pattern: {
              type: "string",
              format: "regex"
            },
            additionalItems: {
              anyOf: [
                {
                  type: "boolean"
                },
                {
                  $ref: "#"
                }
              ],
              default: {}
            },
            items: {
              anyOf: [
                {
                  $ref: "#"
                },
                {
                  $ref: "#/definitions/schemaArray"
                }
              ],
              default: {}
            },
            maxItems: {
              allOf: [
                {
                  $ref: "#/definitions/positiveInteger"
                }
              ]
            },
            minItems: {
              allOf: [
                {
                  $ref: "#/definitions/positiveIntegerDefault0"
                }
              ]
            },
            uniqueItems: {
              type: "boolean",
              default: !1
            },
            maxProperties: {
              allOf: [
                {
                  $ref: "#/definitions/positiveInteger"
                }
              ]
            },
            minProperties: {
              allOf: [
                {
                  $ref: "#/definitions/positiveIntegerDefault0"
                }
              ]
            },
            required: {
              allOf: [
                {
                  $ref: "#/definitions/stringArray"
                }
              ]
            },
            additionalProperties: {
              anyOf: [
                {
                  type: "boolean"
                },
                {
                  $ref: "#"
                }
              ],
              default: {}
            },
            definitions: {
              type: "object",
              additionalProperties: {
                $ref: "#"
              },
              default: {}
            },
            properties: {
              type: "object",
              additionalProperties: {
                $ref: "#"
              },
              default: {}
            },
            patternProperties: {
              type: "object",
              additionalProperties: {
                $ref: "#"
              },
              default: {}
            },
            dependencies: {
              type: "object",
              additionalProperties: {
                anyOf: [
                  {
                    $ref: "#"
                  },
                  {
                    $ref: "#/definitions/stringArray"
                  }
                ]
              }
            },
            enum: {
              type: "array",
              minItems: 1,
              uniqueItems: !0
            },
            type: {
              anyOf: [
                {
                  $ref: "#/definitions/simpleTypes"
                },
                {
                  type: "array",
                  items: {
                    $ref: "#/definitions/simpleTypes"
                  },
                  minItems: 1,
                  uniqueItems: !0
                }
              ]
            },
            format: {
              anyOf: [
                {
                  type: "string",
                  enum: [
                    "date-time",
                    "uri",
                    "email",
                    "hostname",
                    "ipv4",
                    "ipv6",
                    "regex"
                  ]
                },
                {
                  type: "string"
                }
              ]
            },
            allOf: {
              allOf: [
                {
                  $ref: "#/definitions/schemaArray"
                }
              ]
            },
            anyOf: {
              allOf: [
                {
                  $ref: "#/definitions/schemaArray"
                }
              ]
            },
            oneOf: {
              allOf: [
                {
                  $ref: "#/definitions/schemaArray"
                }
              ]
            },
            not: {
              allOf: [
                {
                  $ref: "#"
                }
              ]
            }
          },
          dependencies: {
            exclusiveMaximum: [
              "maximum"
            ],
            exclusiveMinimum: [
              "minimum"
            ]
          },
          default: {}
        },
        "http://json-schema.org/draft-07/schema#": {
          definitions: {
            schemaArray: {
              type: "array",
              minItems: 1,
              items: { $ref: "#" }
            },
            nonNegativeInteger: {
              type: "integer",
              minimum: 0
            },
            nonNegativeIntegerDefault0: {
              allOf: [
                { $ref: "#/definitions/nonNegativeInteger" },
                { default: 0 }
              ]
            },
            simpleTypes: {
              enum: [
                "array",
                "boolean",
                "integer",
                "null",
                "number",
                "object",
                "string"
              ]
            },
            stringArray: {
              type: "array",
              items: { type: "string" },
              uniqueItems: !0,
              default: []
            }
          },
          type: ["object", "boolean"],
          properties: {
            $id: {
              type: "string",
              format: "uri-reference"
            },
            $schema: {
              type: "string",
              format: "uri"
            },
            $ref: {
              type: "string",
              format: "uri-reference"
            },
            $comment: {
              type: "string"
            },
            title: {
              type: "string"
            },
            description: {
              type: "string"
            },
            default: !0,
            readOnly: {
              type: "boolean",
              default: !1
            },
            examples: {
              type: "array",
              items: !0
            },
            multipleOf: {
              type: "number",
              exclusiveMinimum: 0
            },
            maximum: {
              type: "number"
            },
            exclusiveMaximum: {
              type: "number"
            },
            minimum: {
              type: "number"
            },
            exclusiveMinimum: {
              type: "number"
            },
            maxLength: { $ref: "#/definitions/nonNegativeInteger" },
            minLength: { $ref: "#/definitions/nonNegativeIntegerDefault0" },
            pattern: {
              type: "string",
              format: "regex"
            },
            additionalItems: { $ref: "#" },
            items: {
              anyOf: [
                { $ref: "#" },
                { $ref: "#/definitions/schemaArray" }
              ],
              default: !0
            },
            maxItems: { $ref: "#/definitions/nonNegativeInteger" },
            minItems: { $ref: "#/definitions/nonNegativeIntegerDefault0" },
            uniqueItems: {
              type: "boolean",
              default: !1
            },
            contains: { $ref: "#" },
            maxProperties: { $ref: "#/definitions/nonNegativeInteger" },
            minProperties: { $ref: "#/definitions/nonNegativeIntegerDefault0" },
            required: { $ref: "#/definitions/stringArray" },
            additionalProperties: { $ref: "#" },
            definitions: {
              type: "object",
              additionalProperties: { $ref: "#" },
              default: {}
            },
            properties: {
              type: "object",
              additionalProperties: { $ref: "#" },
              default: {}
            },
            patternProperties: {
              type: "object",
              additionalProperties: { $ref: "#" },
              propertyNames: { format: "regex" },
              default: {}
            },
            dependencies: {
              type: "object",
              additionalProperties: {
                anyOf: [
                  { $ref: "#" },
                  { $ref: "#/definitions/stringArray" }
                ]
              }
            },
            propertyNames: { $ref: "#" },
            const: !0,
            enum: {
              type: "array",
              items: !0,
              minItems: 1,
              uniqueItems: !0
            },
            type: {
              anyOf: [
                { $ref: "#/definitions/simpleTypes" },
                {
                  type: "array",
                  items: { $ref: "#/definitions/simpleTypes" },
                  minItems: 1,
                  uniqueItems: !0
                }
              ]
            },
            format: { type: "string" },
            contentMediaType: { type: "string" },
            contentEncoding: { type: "string" },
            if: { $ref: "#" },
            then: { $ref: "#" },
            else: { $ref: "#" },
            allOf: { $ref: "#/definitions/schemaArray" },
            anyOf: { $ref: "#/definitions/schemaArray" },
            oneOf: { $ref: "#/definitions/schemaArray" },
            not: { $ref: "#" }
          },
          default: !0
        }
      }
    }, descriptions = {
      id: l10n5.t("A unique identifier for the schema."),
      $schema: l10n5.t("The schema to verify this document against."),
      title: l10n5.t("A descriptive title of the element."),
      description: l10n5.t("A long description of the element. Used in hover menus and suggestions."),
      default: l10n5.t("A default value. Used by suggestions."),
      multipleOf: l10n5.t("A number that should cleanly divide the current value (i.e. have no remainder)."),
      maximum: l10n5.t("The maximum numerical value, inclusive by default."),
      exclusiveMaximum: l10n5.t("Makes the maximum property exclusive."),
      minimum: l10n5.t("The minimum numerical value, inclusive by default."),
      exclusiveMinimum: l10n5.t("Makes the minimum property exclusive."),
      maxLength: l10n5.t("The maximum length of a string."),
      minLength: l10n5.t("The minimum length of a string."),
      pattern: l10n5.t("A regular expression to match the string against. It is not implicitly anchored."),
      additionalItems: l10n5.t("For arrays, only when items is set as an array. If it is a schema, then this schema validates items after the ones specified by the items array. If it is false, then additional items will cause validation to fail."),
      items: l10n5.t("For arrays. Can either be a schema to validate every element against or an array of schemas to validate each item against in order (the first schema will validate the first element, the second schema will validate the second element, and so on."),
      maxItems: l10n5.t("The maximum number of items that can be inside an array. Inclusive."),
      minItems: l10n5.t("The minimum number of items that can be inside an array. Inclusive."),
      uniqueItems: l10n5.t("If all of the items in the array must be unique. Defaults to false."),
      maxProperties: l10n5.t("The maximum number of properties an object can have. Inclusive."),
      minProperties: l10n5.t("The minimum number of properties an object can have. Inclusive."),
      required: l10n5.t("An array of strings that lists the names of all properties required on this object."),
      additionalProperties: l10n5.t("Either a schema or a boolean. If a schema, then used to validate all properties not matched by 'properties' or 'patternProperties'. If false, then any properties not matched by either will cause this schema to fail."),
      definitions: l10n5.t("Not used for validation. Place subschemas here that you wish to reference inline with $ref."),
      properties: l10n5.t("A map of property names to schemas for each property."),
      patternProperties: l10n5.t("A map of regular expressions on property names to schemas for matching properties."),
      dependencies: l10n5.t("A map of property names to either an array of property names or a schema. An array of property names means the property named in the key depends on the properties in the array being present in the object in order to be valid. If the value is a schema, then the schema is only applied to the object if the property in the key exists on the object."),
      enum: l10n5.t("The set of literal values that are valid."),
      type: l10n5.t("Either a string of one of the basic schema types (number, integer, null, array, object, boolean, string) or an array of strings specifying a subset of those types."),
      format: l10n5.t("Describes the format expected for the value."),
      allOf: l10n5.t("An array of schemas, all of which must match."),
      anyOf: l10n5.t("An array of schemas, where at least one must match."),
      oneOf: l10n5.t("An array of schemas, exactly one of which must match."),
      not: l10n5.t("A schema which must not match."),
      $id: l10n5.t("A unique identifier for the schema."),
      $ref: l10n5.t("Reference a definition hosted on any location."),
      $comment: l10n5.t("Comments from schema authors to readers or maintainers of the schema."),
      readOnly: l10n5.t("Indicates that the value of the instance is managed exclusively by the owning authority."),
      examples: l10n5.t("Sample JSON values associated with a particular schema, for the purpose of illustrating usage."),
      contains: l10n5.t('An array instance is valid against "contains" if at least one of its elements is valid against the given schema.'),
      propertyNames: l10n5.t("If the instance is an object, this keyword validates if every property name in the instance validates against the provided schema."),
      const: l10n5.t("An instance validates successfully against this keyword if its value is equal to the value of the keyword."),
      contentMediaType: l10n5.t("Describes the media type of a string property."),
      contentEncoding: l10n5.t("Describes the content encoding of a string property."),
      if: l10n5.t('The validation outcome of the "if" subschema controls which of the "then" or "else" keywords are evaluated.'),
      then: l10n5.t('The "if" subschema is used for validation when the "if" subschema succeeds.'),
      else: l10n5.t('The "else" subschema is used for validation when the "if" subschema fails.')
    };
    for (let schemaName in schemaContributions.schemas) {
      let schema = schemaContributions.schemas[schemaName];
      for (let property in schema.properties) {
        let propertyObject = schema.properties[property];
        typeof propertyObject == "boolean" && (propertyObject = schema.properties[property] = {});
        let description = descriptions[property];
        description && (propertyObject.description = description);
      }
    }
  }
});

// ../../node_modules/.pnpm/vscode-uri@3.0.8/node_modules/vscode-uri/lib/esm/index.mjs
var LIB, URI2, Utils, init_esm = __esm({
  "../../node_modules/.pnpm/vscode-uri@3.0.8/node_modules/vscode-uri/lib/esm/index.mjs"() {
    init_cjs_shims();
    (() => {
      "use strict";
      var t7 = { 470: (t8) => {
        function e2(t9) {
          if (typeof t9 != "string")
            throw new TypeError("Path must be a string. Received " + JSON.stringify(t9));
        }
        function r3(t9, e3) {
          for (var r4, n3 = "", i = 0, o = -1, s = 0, h = 0; h <= t9.length; ++h) {
            if (h < t9.length)
              r4 = t9.charCodeAt(h);
            else {
              if (r4 === 47)
                break;
              r4 = 47;
            }
            if (r4 === 47) {
              if (!(o === h - 1 || s === 1))
                if (o !== h - 1 && s === 2) {
                  if (n3.length < 2 || i !== 2 || n3.charCodeAt(n3.length - 1) !== 46 || n3.charCodeAt(n3.length - 2) !== 46) {
                    if (n3.length > 2) {
                      var a = n3.lastIndexOf("/");
                      if (a !== n3.length - 1) {
                        a === -1 ? (n3 = "", i = 0) : i = (n3 = n3.slice(0, a)).length - 1 - n3.lastIndexOf("/"), o = h, s = 0;
                        continue;
                      }
                    } else if (n3.length === 2 || n3.length === 1) {
                      n3 = "", i = 0, o = h, s = 0;
                      continue;
                    }
                  }
                  e3 && (n3.length > 0 ? n3 += "/.." : n3 = "..", i = 2);
                } else
                  n3.length > 0 ? n3 += "/" + t9.slice(o + 1, h) : n3 = t9.slice(o + 1, h), i = h - o - 1;
              o = h, s = 0;
            } else
              r4 === 46 && s !== -1 ? ++s : s = -1;
          }
          return n3;
        }
        var n2 = { resolve: function() {
          for (var t9, n3 = "", i = !1, o = arguments.length - 1; o >= -1 && !i; o--) {
            var s;
            o >= 0 ? s = arguments[o] : (t9 === void 0 && (t9 = process.cwd()), s = t9), e2(s), s.length !== 0 && (n3 = s + "/" + n3, i = s.charCodeAt(0) === 47);
          }
          return n3 = r3(n3, !i), i ? n3.length > 0 ? "/" + n3 : "/" : n3.length > 0 ? n3 : ".";
        }, normalize: function(t9) {
          if (e2(t9), t9.length === 0)
            return ".";
          var n3 = t9.charCodeAt(0) === 47, i = t9.charCodeAt(t9.length - 1) === 47;
          return (t9 = r3(t9, !n3)).length !== 0 || n3 || (t9 = "."), t9.length > 0 && i && (t9 += "/"), n3 ? "/" + t9 : t9;
        }, isAbsolute: function(t9) {
          return e2(t9), t9.length > 0 && t9.charCodeAt(0) === 47;
        }, join: function() {
          if (arguments.length === 0)
            return ".";
          for (var t9, r4 = 0; r4 < arguments.length; ++r4) {
            var i = arguments[r4];
            e2(i), i.length > 0 && (t9 === void 0 ? t9 = i : t9 += "/" + i);
          }
          return t9 === void 0 ? "." : n2.normalize(t9);
        }, relative: function(t9, r4) {
          if (e2(t9), e2(r4), t9 === r4 || (t9 = n2.resolve(t9)) === (r4 = n2.resolve(r4)))
            return "";
          for (var i = 1; i < t9.length && t9.charCodeAt(i) === 47; ++i)
            ;
          for (var o = t9.length, s = o - i, h = 1; h < r4.length && r4.charCodeAt(h) === 47; ++h)
            ;
          for (var a = r4.length - h, c = s < a ? s : a, f = -1, u = 0; u <= c; ++u) {
            if (u === c) {
              if (a > c) {
                if (r4.charCodeAt(h + u) === 47)
                  return r4.slice(h + u + 1);
                if (u === 0)
                  return r4.slice(h + u);
              } else
                s > c && (t9.charCodeAt(i + u) === 47 ? f = u : u === 0 && (f = 0));
              break;
            }
            var l = t9.charCodeAt(i + u);
            if (l !== r4.charCodeAt(h + u))
              break;
            l === 47 && (f = u);
          }
          var g = "";
          for (u = i + f + 1; u <= o; ++u)
            u !== o && t9.charCodeAt(u) !== 47 || (g.length === 0 ? g += ".." : g += "/..");
          return g.length > 0 ? g + r4.slice(h + f) : (h += f, r4.charCodeAt(h) === 47 && ++h, r4.slice(h));
        }, _makeLong: function(t9) {
          return t9;
        }, dirname: function(t9) {
          if (e2(t9), t9.length === 0)
            return ".";
          for (var r4 = t9.charCodeAt(0), n3 = r4 === 47, i = -1, o = !0, s = t9.length - 1; s >= 1; --s)
            if ((r4 = t9.charCodeAt(s)) === 47) {
              if (!o) {
                i = s;
                break;
              }
            } else
              o = !1;
          return i === -1 ? n3 ? "/" : "." : n3 && i === 1 ? "//" : t9.slice(0, i);
        }, basename: function(t9, r4) {
          if (r4 !== void 0 && typeof r4 != "string")
            throw new TypeError('"ext" argument must be a string');
          e2(t9);
          var n3, i = 0, o = -1, s = !0;
          if (r4 !== void 0 && r4.length > 0 && r4.length <= t9.length) {
            if (r4.length === t9.length && r4 === t9)
              return "";
            var h = r4.length - 1, a = -1;
            for (n3 = t9.length - 1; n3 >= 0; --n3) {
              var c = t9.charCodeAt(n3);
              if (c === 47) {
                if (!s) {
                  i = n3 + 1;
                  break;
                }
              } else
                a === -1 && (s = !1, a = n3 + 1), h >= 0 && (c === r4.charCodeAt(h) ? --h == -1 && (o = n3) : (h = -1, o = a));
            }
            return i === o ? o = a : o === -1 && (o = t9.length), t9.slice(i, o);
          }
          for (n3 = t9.length - 1; n3 >= 0; --n3)
            if (t9.charCodeAt(n3) === 47) {
              if (!s) {
                i = n3 + 1;
                break;
              }
            } else
              o === -1 && (s = !1, o = n3 + 1);
          return o === -1 ? "" : t9.slice(i, o);
        }, extname: function(t9) {
          e2(t9);
          for (var r4 = -1, n3 = 0, i = -1, o = !0, s = 0, h = t9.length - 1; h >= 0; --h) {
            var a = t9.charCodeAt(h);
            if (a !== 47)
              i === -1 && (o = !1, i = h + 1), a === 46 ? r4 === -1 ? r4 = h : s !== 1 && (s = 1) : r4 !== -1 && (s = -1);
            else if (!o) {
              n3 = h + 1;
              break;
            }
          }
          return r4 === -1 || i === -1 || s === 0 || s === 1 && r4 === i - 1 && r4 === n3 + 1 ? "" : t9.slice(r4, i);
        }, format: function(t9) {
          if (t9 === null || typeof t9 != "object")
            throw new TypeError('The "pathObject" argument must be of type Object. Received type ' + typeof t9);
          return function(t10, e3) {
            var r4 = e3.dir || e3.root, n3 = e3.base || (e3.name || "") + (e3.ext || "");
            return r4 ? r4 === e3.root ? r4 + n3 : r4 + "/" + n3 : n3;
          }(0, t9);
        }, parse: function(t9) {
          e2(t9);
          var r4 = { root: "", dir: "", base: "", ext: "", name: "" };
          if (t9.length === 0)
            return r4;
          var n3, i = t9.charCodeAt(0), o = i === 47;
          o ? (r4.root = "/", n3 = 1) : n3 = 0;
          for (var s = -1, h = 0, a = -1, c = !0, f = t9.length - 1, u = 0; f >= n3; --f)
            if ((i = t9.charCodeAt(f)) !== 47)
              a === -1 && (c = !1, a = f + 1), i === 46 ? s === -1 ? s = f : u !== 1 && (u = 1) : s !== -1 && (u = -1);
            else if (!c) {
              h = f + 1;
              break;
            }
          return s === -1 || a === -1 || u === 0 || u === 1 && s === a - 1 && s === h + 1 ? a !== -1 && (r4.base = r4.name = h === 0 && o ? t9.slice(1, a) : t9.slice(h, a)) : (h === 0 && o ? (r4.name = t9.slice(1, s), r4.base = t9.slice(1, a)) : (r4.name = t9.slice(h, s), r4.base = t9.slice(h, a)), r4.ext = t9.slice(s, a)), h > 0 ? r4.dir = t9.slice(0, h - 1) : o && (r4.dir = "/"), r4;
        }, sep: "/", delimiter: ":", win32: null, posix: null };
        n2.posix = n2, t8.exports = n2;
      } }, e = {};
      function r2(n2) {
        var i = e[n2];
        if (i !== void 0)
          return i.exports;
        var o = e[n2] = { exports: {} };
        return t7[n2](o, o.exports, r2), o.exports;
      }
      r2.d = (t8, e2) => {
        for (var n2 in e2)
          r2.o(e2, n2) && !r2.o(t8, n2) && Object.defineProperty(t8, n2, { enumerable: !0, get: e2[n2] });
      }, r2.o = (t8, e2) => Object.prototype.hasOwnProperty.call(t8, e2), r2.r = (t8) => {
        typeof Symbol < "u" && Symbol.toStringTag && Object.defineProperty(t8, Symbol.toStringTag, { value: "Module" }), Object.defineProperty(t8, "__esModule", { value: !0 });
      };
      var n = {};
      (() => {
        let t8;
        r2.r(n), r2.d(n, { URI: () => f, Utils: () => P }), typeof process == "object" ? t8 = process.platform === "win32" : typeof navigator == "object" && (t8 = navigator.userAgent.indexOf("Windows") >= 0);
        let e2 = /^\w[\w\d+.-]*$/, i = /^\//, o = /^\/\//;
        function s(t9, r3) {
          if (!t9.scheme && r3)
            throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t9.authority}", path: "${t9.path}", query: "${t9.query}", fragment: "${t9.fragment}"}`);
          if (t9.scheme && !e2.test(t9.scheme))
            throw new Error("[UriError]: Scheme contains illegal characters.");
          if (t9.path) {
            if (t9.authority) {
              if (!i.test(t9.path))
                throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character');
            } else if (o.test(t9.path))
              throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")');
          }
        }
        let h = "", a = "/", c = /^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;
        class f {
          static isUri(t9) {
            return t9 instanceof f || !!t9 && typeof t9.authority == "string" && typeof t9.fragment == "string" && typeof t9.path == "string" && typeof t9.query == "string" && typeof t9.scheme == "string" && typeof t9.fsPath == "string" && typeof t9.with == "function" && typeof t9.toString == "function";
          }
          scheme;
          authority;
          path;
          query;
          fragment;
          constructor(t9, e3, r3, n2, i2, o2 = !1) {
            typeof t9 == "object" ? (this.scheme = t9.scheme || h, this.authority = t9.authority || h, this.path = t9.path || h, this.query = t9.query || h, this.fragment = t9.fragment || h) : (this.scheme = /* @__PURE__ */ function(t10, e4) {
              return t10 || e4 ? t10 : "file";
            }(t9, o2), this.authority = e3 || h, this.path = function(t10, e4) {
              switch (t10) {
                case "https":
                case "http":
                case "file":
                  e4 ? e4[0] !== a && (e4 = a + e4) : e4 = a;
              }
              return e4;
            }(this.scheme, r3 || h), this.query = n2 || h, this.fragment = i2 || h, s(this, o2));
          }
          get fsPath() {
            return m(this, !1);
          }
          with(t9) {
            if (!t9)
              return this;
            let { scheme: e3, authority: r3, path: n2, query: i2, fragment: o2 } = t9;
            return e3 === void 0 ? e3 = this.scheme : e3 === null && (e3 = h), r3 === void 0 ? r3 = this.authority : r3 === null && (r3 = h), n2 === void 0 ? n2 = this.path : n2 === null && (n2 = h), i2 === void 0 ? i2 = this.query : i2 === null && (i2 = h), o2 === void 0 ? o2 = this.fragment : o2 === null && (o2 = h), e3 === this.scheme && r3 === this.authority && n2 === this.path && i2 === this.query && o2 === this.fragment ? this : new l(e3, r3, n2, i2, o2);
          }
          static parse(t9, e3 = !1) {
            let r3 = c.exec(t9);
            return r3 ? new l(r3[2] || h, C(r3[4] || h), C(r3[5] || h), C(r3[7] || h), C(r3[9] || h), e3) : new l(h, h, h, h, h);
          }
          static file(e3) {
            let r3 = h;
            if (t8 && (e3 = e3.replace(/\\/g, a)), e3[0] === a && e3[1] === a) {
              let t9 = e3.indexOf(a, 2);
              t9 === -1 ? (r3 = e3.substring(2), e3 = a) : (r3 = e3.substring(2, t9), e3 = e3.substring(t9) || a);
            }
            return new l("file", r3, e3, h, h);
          }
          static from(t9) {
            let e3 = new l(t9.scheme, t9.authority, t9.path, t9.query, t9.fragment);
            return s(e3, !0), e3;
          }
          toString(t9 = !1) {
            return y(this, t9);
          }
          toJSON() {
            return this;
          }
          static revive(t9) {
            if (t9) {
              if (t9 instanceof f)
                return t9;
              {
                let e3 = new l(t9);
                return e3._formatted = t9.external, e3._fsPath = t9._sep === u ? t9.fsPath : null, e3;
              }
            }
            return t9;
          }
        }
        let u = t8 ? 1 : void 0;
        class l extends f {
          _formatted = null;
          _fsPath = null;
          get fsPath() {
            return this._fsPath || (this._fsPath = m(this, !1)), this._fsPath;
          }
          toString(t9 = !1) {
            return t9 ? y(this, !0) : (this._formatted || (this._formatted = y(this, !1)), this._formatted);
          }
          toJSON() {
            let t9 = { $mid: 1 };
            return this._fsPath && (t9.fsPath = this._fsPath, t9._sep = u), this._formatted && (t9.external = this._formatted), this.path && (t9.path = this.path), this.scheme && (t9.scheme = this.scheme), this.authority && (t9.authority = this.authority), this.query && (t9.query = this.query), this.fragment && (t9.fragment = this.fragment), t9;
          }
        }
        let g = { 58: "%3A", 47: "%2F", 63: "%3F", 35: "%23", 91: "%5B", 93: "%5D", 64: "%40", 33: "%21", 36: "%24", 38: "%26", 39: "%27", 40: "%28", 41: "%29", 42: "%2A", 43: "%2B", 44: "%2C", 59: "%3B", 61: "%3D", 32: "%20" };
        function d(t9, e3, r3) {
          let n2, i2 = -1;
          for (let o2 = 0; o2 < t9.length; o2++) {
            let s2 = t9.charCodeAt(o2);
            if (s2 >= 97 && s2 <= 122 || s2 >= 65 && s2 <= 90 || s2 >= 48 && s2 <= 57 || s2 === 45 || s2 === 46 || s2 === 95 || s2 === 126 || e3 && s2 === 47 || r3 && s2 === 91 || r3 && s2 === 93 || r3 && s2 === 58)
              i2 !== -1 && (n2 += encodeURIComponent(t9.substring(i2, o2)), i2 = -1), n2 !== void 0 && (n2 += t9.charAt(o2));
            else {
              n2 === void 0 && (n2 = t9.substr(0, o2));
              let e4 = g[s2];
              e4 !== void 0 ? (i2 !== -1 && (n2 += encodeURIComponent(t9.substring(i2, o2)), i2 = -1), n2 += e4) : i2 === -1 && (i2 = o2);
            }
          }
          return i2 !== -1 && (n2 += encodeURIComponent(t9.substring(i2))), n2 !== void 0 ? n2 : t9;
        }
        function p(t9) {
          let e3;
          for (let r3 = 0; r3 < t9.length; r3++) {
            let n2 = t9.charCodeAt(r3);
            n2 === 35 || n2 === 63 ? (e3 === void 0 && (e3 = t9.substr(0, r3)), e3 += g[n2]) : e3 !== void 0 && (e3 += t9[r3]);
          }
          return e3 !== void 0 ? e3 : t9;
        }
        function m(e3, r3) {
          let n2;
          return n2 = e3.authority && e3.path.length > 1 && e3.scheme === "file" ? `//${e3.authority}${e3.path}` : e3.path.charCodeAt(0) === 47 && (e3.path.charCodeAt(1) >= 65 && e3.path.charCodeAt(1) <= 90 || e3.path.charCodeAt(1) >= 97 && e3.path.charCodeAt(1) <= 122) && e3.path.charCodeAt(2) === 58 ? r3 ? e3.path.substr(1) : e3.path[1].toLowerCase() + e3.path.substr(2) : e3.path, t8 && (n2 = n2.replace(/\//g, "\\")), n2;
        }
        function y(t9, e3) {
          let r3 = e3 ? p : d, n2 = "", { scheme: i2, authority: o2, path: s2, query: h2, fragment: c2 } = t9;
          if (i2 && (n2 += i2, n2 += ":"), (o2 || i2 === "file") && (n2 += a, n2 += a), o2) {
            let t10 = o2.indexOf("@");
            if (t10 !== -1) {
              let e4 = o2.substr(0, t10);
              o2 = o2.substr(t10 + 1), t10 = e4.lastIndexOf(":"), t10 === -1 ? n2 += r3(e4, !1, !1) : (n2 += r3(e4.substr(0, t10), !1, !1), n2 += ":", n2 += r3(e4.substr(t10 + 1), !1, !0)), n2 += "@";
            }
            o2 = o2.toLowerCase(), t10 = o2.lastIndexOf(":"), t10 === -1 ? n2 += r3(o2, !1, !0) : (n2 += r3(o2.substr(0, t10), !1, !0), n2 += o2.substr(t10));
          }
          if (s2) {
            if (s2.length >= 3 && s2.charCodeAt(0) === 47 && s2.charCodeAt(2) === 58) {
              let t10 = s2.charCodeAt(1);
              t10 >= 65 && t10 <= 90 && (s2 = `/${String.fromCharCode(t10 + 32)}:${s2.substr(3)}`);
            } else if (s2.length >= 2 && s2.charCodeAt(1) === 58) {
              let t10 = s2.charCodeAt(0);
              t10 >= 65 && t10 <= 90 && (s2 = `${String.fromCharCode(t10 + 32)}:${s2.substr(2)}`);
            }
            n2 += r3(s2, !0, !1);
          }
          return h2 && (n2 += "?", n2 += r3(h2, !1, !1)), c2 && (n2 += "#", n2 += e3 ? c2 : d(c2, !1, !1)), n2;
        }
        function v(t9) {
          try {
            return decodeURIComponent(t9);
          } catch {
            return t9.length > 3 ? t9.substr(0, 3) + v(t9.substr(3)) : t9;
          }
        }
        let b = /(%[0-9A-Za-z][0-9A-Za-z])+/g;
        function C(t9) {
          return t9.match(b) ? t9.replace(b, (t10) => v(t10)) : t9;
        }
        var A = r2(470);
        let w = A.posix || A, x = "/";
        var P;
        (function(t9) {
          t9.joinPath = function(t10, ...e3) {
            return t10.with({ path: w.join(t10.path, ...e3) });
          }, t9.resolvePath = function(t10, ...e3) {
            let r3 = t10.path, n2 = !1;
            r3[0] !== x && (r3 = x + r3, n2 = !0);
            let i2 = w.resolve(r3, ...e3);
            return n2 && i2[0] === x && !t10.authority && (i2 = i2.substring(1)), t10.with({ path: i2 });
          }, t9.dirname = function(t10) {
            if (t10.path.length === 0 || t10.path === x)
              return t10;
            let e3 = w.dirname(t10.path);
            return e3.length === 1 && e3.charCodeAt(0) === 46 && (e3 = ""), t10.with({ path: e3 });
          }, t9.basename = function(t10) {
            return w.basename(t10.path);
          }, t9.extname = function(t10) {
            return w.extname(t10.path);
          };
        })(P || (P = {}));
      })(), LIB = n;
    })();
    ({ URI: URI2, Utils } = LIB);
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/utils/glob.js
function createRegex(glob2, opts) {
  if (typeof glob2 != "string")
    throw new TypeError("Expected a string");
  let str = String(glob2), reStr = "", extended = opts ? !!opts.extended : !1, globstar = opts ? !!opts.globstar : !1, inGroup = !1, flags = opts && typeof opts.flags == "string" ? opts.flags : "", c;
  for (let i = 0, len = str.length; i < len; i++)
    switch (c = str[i], c) {
      case "/":
      case "$":
      case "^":
      case "+":
      case ".":
      case "(":
      case ")":
      case "=":
      case "!":
      case "|":
        reStr += "\\" + c;
        break;
      case "?":
        if (extended) {
          reStr += ".";
          break;
        }
      case "[":
      case "]":
        if (extended) {
          reStr += c;
          break;
        }
      case "{":
        if (extended) {
          inGroup = !0, reStr += "(";
          break;
        }
      case "}":
        if (extended) {
          inGroup = !1, reStr += ")";
          break;
        }
      case ",":
        if (inGroup) {
          reStr += "|";
          break;
        }
        reStr += "\\" + c;
        break;
      case "*":
        let prevChar = str[i - 1], starCount = 1;
        for (; str[i + 1] === "*"; )
          starCount++, i++;
        let nextChar = str[i + 1];
        globstar ? starCount > 1 && (prevChar === "/" || prevChar === void 0 || prevChar === "{" || prevChar === ",") && (nextChar === "/" || nextChar === void 0 || nextChar === "," || nextChar === "}") ? (nextChar === "/" ? i++ : prevChar === "/" && reStr.endsWith("\\/") && (reStr = reStr.substr(0, reStr.length - 2)), reStr += "((?:[^/]*(?:/|$))*)") : reStr += "([^/]*)" : reStr += ".*";
        break;
      default:
        reStr += c;
    }
  return (!flags || !~flags.indexOf("g")) && (reStr = "^" + reStr + "$"), new RegExp(reStr, flags);
}
var init_glob = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/utils/glob.js"() {
    init_cjs_shims();
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/jsonSchemaService.js
function normalizeId(id) {
  try {
    return URI2.parse(id).toString(!0);
  } catch {
    return id;
  }
}
function normalizeResourceForMatching(resource) {
  try {
    return URI2.parse(resource).with({ fragment: null, query: null }).toString(!0);
  } catch {
    return resource;
  }
}
function toDisplayString(url) {
  try {
    let uri = URI2.parse(url);
    if (uri.scheme === "file")
      return uri.fsPath;
  } catch {
  }
  return url;
}
var l10n6, BANG, PATH_SEP, FilePatternAssociation, SchemaHandle, UnresolvedSchema, ResolvedSchema, JSONSchemaService, idCounter2, init_jsonSchemaService = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/jsonSchemaService.js"() {
    init_cjs_shims();
    init_main();
    init_esm();
    init_strings();
    init_jsonParser();
    l10n6 = __toESM(require_main2());
    init_glob();
    init_objects();
    BANG = "!", PATH_SEP = "/", FilePatternAssociation = class {
      constructor(pattern, folderUri, uris) {
        this.folderUri = folderUri, this.uris = uris, this.globWrappers = [];
        try {
          for (let patternString of pattern) {
            let include = patternString[0] !== BANG;
            include || (patternString = patternString.substring(1)), patternString.length > 0 && (patternString[0] === PATH_SEP && (patternString = patternString.substring(1)), this.globWrappers.push({
              regexp: createRegex("**/" + patternString, { extended: !0, globstar: !0 }),
              include
            }));
          }
          folderUri && (folderUri = normalizeResourceForMatching(folderUri), folderUri.endsWith("/") || (folderUri = folderUri + "/"), this.folderUri = folderUri);
        } catch {
          this.globWrappers.length = 0, this.uris = [];
        }
      }
      matchesPattern(fileName) {
        if (this.folderUri && !fileName.startsWith(this.folderUri))
          return !1;
        let match2 = !1;
        for (let { regexp, include } of this.globWrappers)
          regexp.test(fileName) && (match2 = include);
        return match2;
      }
      getURIs() {
        return this.uris;
      }
    }, SchemaHandle = class {
      constructor(service, uri, unresolvedSchemaContent) {
        this.service = service, this.uri = uri, this.dependencies = /* @__PURE__ */ new Set(), this.anchors = void 0, unresolvedSchemaContent && (this.unresolvedSchema = this.service.promise.resolve(new UnresolvedSchema(unresolvedSchemaContent)));
      }
      getUnresolvedSchema() {
        return this.unresolvedSchema || (this.unresolvedSchema = this.service.loadSchema(this.uri)), this.unresolvedSchema;
      }
      getResolvedSchema() {
        return this.resolvedSchema || (this.resolvedSchema = this.getUnresolvedSchema().then((unresolved) => this.service.resolveSchemaContent(unresolved, this))), this.resolvedSchema;
      }
      clearSchema() {
        let hasChanges = !!this.unresolvedSchema;
        return this.resolvedSchema = void 0, this.unresolvedSchema = void 0, this.dependencies.clear(), this.anchors = void 0, hasChanges;
      }
    }, UnresolvedSchema = class {
      constructor(schema, errors2 = []) {
        this.schema = schema, this.errors = errors2;
      }
    }, ResolvedSchema = class {
      constructor(schema, errors2 = [], warnings = [], schemaDraft) {
        this.schema = schema, this.errors = errors2, this.warnings = warnings, this.schemaDraft = schemaDraft;
      }
      getSection(path3) {
        let schemaRef = this.getSectionRecursive(path3, this.schema);
        if (schemaRef)
          return asSchema(schemaRef);
      }
      getSectionRecursive(path3, schema) {
        if (!schema || typeof schema == "boolean" || path3.length === 0)
          return schema;
        let next = path3.shift();
        if (schema.properties && typeof schema.properties[next])
          return this.getSectionRecursive(path3, schema.properties[next]);
        if (schema.patternProperties) {
          for (let pattern of Object.keys(schema.patternProperties))
            if (extendedRegExp(pattern)?.test(next))
              return this.getSectionRecursive(path3, schema.patternProperties[pattern]);
        } else {
          if (typeof schema.additionalProperties == "object")
            return this.getSectionRecursive(path3, schema.additionalProperties);
          if (next.match("[0-9]+")) {
            if (Array.isArray(schema.items)) {
              let index = parseInt(next, 10);
              if (!isNaN(index) && schema.items[index])
                return this.getSectionRecursive(path3, schema.items[index]);
            } else if (schema.items)
              return this.getSectionRecursive(path3, schema.items);
          }
        }
      }
    }, JSONSchemaService = class {
      constructor(requestService, contextService, promiseConstructor) {
        this.contextService = contextService, this.requestService = requestService, this.promiseConstructor = promiseConstructor || Promise, this.callOnDispose = [], this.contributionSchemas = {}, this.contributionAssociations = [], this.schemasById = {}, this.filePatternAssociations = [], this.registeredSchemasIds = {};
      }
      getRegisteredSchemaIds(filter) {
        return Object.keys(this.registeredSchemasIds).filter((id) => {
          let scheme = URI2.parse(id).scheme;
          return scheme !== "schemaservice" && (!filter || filter(scheme));
        });
      }
      get promise() {
        return this.promiseConstructor;
      }
      dispose() {
        for (; this.callOnDispose.length > 0; )
          this.callOnDispose.pop()();
      }
      onResourceChange(uri) {
        this.cachedSchemaForResource = void 0;
        let hasChanges = !1;
        uri = normalizeId(uri);
        let toWalk = [uri], all = Object.keys(this.schemasById).map((key) => this.schemasById[key]);
        for (; toWalk.length; ) {
          let curr = toWalk.pop();
          for (let i = 0; i < all.length; i++) {
            let handle = all[i];
            handle && (handle.uri === curr || handle.dependencies.has(curr)) && (handle.uri !== curr && toWalk.push(handle.uri), handle.clearSchema() && (hasChanges = !0), all[i] = void 0);
          }
        }
        return hasChanges;
      }
      setSchemaContributions(schemaContributions2) {
        if (schemaContributions2.schemas) {
          let schemas = schemaContributions2.schemas;
          for (let id in schemas) {
            let normalizedId = normalizeId(id);
            this.contributionSchemas[normalizedId] = this.addSchemaHandle(normalizedId, schemas[id]);
          }
        }
        if (Array.isArray(schemaContributions2.schemaAssociations)) {
          let schemaAssociations = schemaContributions2.schemaAssociations;
          for (let schemaAssociation of schemaAssociations) {
            let uris = schemaAssociation.uris.map(normalizeId), association = this.addFilePatternAssociation(schemaAssociation.pattern, schemaAssociation.folderUri, uris);
            this.contributionAssociations.push(association);
          }
        }
      }
      addSchemaHandle(id, unresolvedSchemaContent) {
        let schemaHandle = new SchemaHandle(this, id, unresolvedSchemaContent);
        return this.schemasById[id] = schemaHandle, schemaHandle;
      }
      getOrAddSchemaHandle(id, unresolvedSchemaContent) {
        return this.schemasById[id] || this.addSchemaHandle(id, unresolvedSchemaContent);
      }
      addFilePatternAssociation(pattern, folderUri, uris) {
        let fpa = new FilePatternAssociation(pattern, folderUri, uris);
        return this.filePatternAssociations.push(fpa), fpa;
      }
      registerExternalSchema(config2) {
        let id = normalizeId(config2.uri);
        return this.registeredSchemasIds[id] = !0, this.cachedSchemaForResource = void 0, config2.fileMatch && config2.fileMatch.length && this.addFilePatternAssociation(config2.fileMatch, config2.folderUri, [id]), config2.schema ? this.addSchemaHandle(id, config2.schema) : this.getOrAddSchemaHandle(id);
      }
      clearExternalSchemas() {
        this.schemasById = {}, this.filePatternAssociations = [], this.registeredSchemasIds = {}, this.cachedSchemaForResource = void 0;
        for (let id in this.contributionSchemas)
          this.schemasById[id] = this.contributionSchemas[id], this.registeredSchemasIds[id] = !0;
        for (let contributionAssociation of this.contributionAssociations)
          this.filePatternAssociations.push(contributionAssociation);
      }
      getResolvedSchema(schemaId) {
        let id = normalizeId(schemaId), schemaHandle = this.schemasById[id];
        return schemaHandle ? schemaHandle.getResolvedSchema() : this.promise.resolve(void 0);
      }
      loadSchema(url) {
        if (!this.requestService) {
          let errorMessage2 = l10n6.t("Unable to load schema from '{0}'. No schema request service available", toDisplayString(url));
          return this.promise.resolve(new UnresolvedSchema({}, [errorMessage2]));
        }
        return url.startsWith("http://json-schema.org/") && (url = "https" + url.substring(4)), this.requestService(url).then((content) => {
          if (!content) {
            let errorMessage2 = l10n6.t("Unable to load schema from '{0}': No content.", toDisplayString(url));
            return new UnresolvedSchema({}, [errorMessage2]);
          }
          let errors2 = [];
          content.charCodeAt(0) === 65279 && (errors2.push(l10n6.t("Problem reading content from '{0}': UTF-8 with BOM detected, only UTF 8 is allowed.", toDisplayString(url))), content = content.trimStart());
          let schemaContent = {}, jsonErrors = [];
          return schemaContent = parse2(content, jsonErrors), jsonErrors.length && errors2.push(l10n6.t("Unable to parse content from '{0}': Parse error at offset {1}.", toDisplayString(url), jsonErrors[0].offset)), new UnresolvedSchema(schemaContent, errors2);
        }, (error) => {
          let errorMessage2 = error.toString(), errorSplit = error.toString().split("Error: ");
          return errorSplit.length > 1 && (errorMessage2 = errorSplit[1]), endsWith(errorMessage2, ".") && (errorMessage2 = errorMessage2.substr(0, errorMessage2.length - 1)), new UnresolvedSchema({}, [l10n6.t("Unable to load schema from '{0}': {1}.", toDisplayString(url), errorMessage2)]);
        });
      }
      resolveSchemaContent(schemaToResolve, handle) {
        let resolveErrors = schemaToResolve.errors.slice(0), schema = schemaToResolve.schema, schemaDraft = schema.$schema ? normalizeId(schema.$schema) : void 0;
        if (schemaDraft === "http://json-schema.org/draft-03/schema")
          return this.promise.resolve(new ResolvedSchema({}, [l10n6.t("Draft-03 schemas are not supported.")], [], schemaDraft));
        let usesUnsupportedFeatures = /* @__PURE__ */ new Set(), contextService = this.contextService, findSectionByJSONPointer = (schema2, path3) => {
          path3 = decodeURIComponent(path3);
          let current = schema2;
          return path3[0] === "/" && (path3 = path3.substring(1)), path3.split("/").some((part) => (part = part.replace(/~1/g, "/").replace(/~0/g, "~"), current = current[part], !current)), current;
        }, findSchemaById = (schema2, handle2, id) => (handle2.anchors || (handle2.anchors = collectAnchors(schema2)), handle2.anchors.get(id)), merge = (target, section) => {
          for (let key in section)
            section.hasOwnProperty(key) && key !== "id" && key !== "$id" && (target[key] = section[key]);
        }, mergeRef = (target, sourceRoot, sourceHandle, refSegment) => {
          let section;
          refSegment === void 0 || refSegment.length === 0 ? section = sourceRoot : refSegment.charAt(0) === "/" ? section = findSectionByJSONPointer(sourceRoot, refSegment) : section = findSchemaById(sourceRoot, sourceHandle, refSegment), section ? merge(target, section) : resolveErrors.push(l10n6.t("$ref '{0}' in '{1}' can not be resolved.", refSegment || "", sourceHandle.uri));
        }, resolveExternalLink = (node, uri, refSegment, parentHandle) => {
          contextService && !/^[A-Za-z][A-Za-z0-9+\-.+]*:\/\/.*/.test(uri) && (uri = contextService.resolveRelativePath(uri, parentHandle.uri)), uri = normalizeId(uri);
          let referencedHandle = this.getOrAddSchemaHandle(uri);
          return referencedHandle.getUnresolvedSchema().then((unresolvedSchema) => {
            if (parentHandle.dependencies.add(uri), unresolvedSchema.errors.length) {
              let loc = refSegment ? uri + "#" + refSegment : uri;
              resolveErrors.push(l10n6.t("Problems loading reference '{0}': {1}", loc, unresolvedSchema.errors[0]));
            }
            return mergeRef(node, unresolvedSchema.schema, referencedHandle, refSegment), resolveRefs(node, unresolvedSchema.schema, referencedHandle);
          });
        }, resolveRefs = (node, parentSchema, parentHandle) => {
          let openPromises = [];
          return this.traverseNodes(node, (next) => {
            let seenRefs = /* @__PURE__ */ new Set();
            for (; next.$ref; ) {
              let ref = next.$ref, segments = ref.split("#", 2);
              if (delete next.$ref, segments[0].length > 0) {
                openPromises.push(resolveExternalLink(next, segments[0], segments[1], parentHandle));
                return;
              } else if (!seenRefs.has(ref)) {
                let id = segments[1];
                mergeRef(next, parentSchema, parentHandle, id), seenRefs.add(ref);
              }
            }
            next.$recursiveRef && usesUnsupportedFeatures.add("$recursiveRef"), next.$dynamicRef && usesUnsupportedFeatures.add("$dynamicRef");
          }), this.promise.all(openPromises);
        }, collectAnchors = (root) => {
          let result = /* @__PURE__ */ new Map();
          return this.traverseNodes(root, (next) => {
            let id = next.$id || next.id, anchor = isString(id) && id.charAt(0) === "#" ? id.substring(1) : next.$anchor;
            anchor && (result.has(anchor) ? resolveErrors.push(l10n6.t("Duplicate anchor declaration: '{0}'", anchor)) : result.set(anchor, next)), next.$recursiveAnchor && usesUnsupportedFeatures.add("$recursiveAnchor"), next.$dynamicAnchor && usesUnsupportedFeatures.add("$dynamicAnchor");
          }), result;
        };
        return resolveRefs(schema, schema, handle).then((_2) => {
          let resolveWarnings = [];
          return usesUnsupportedFeatures.size && resolveWarnings.push(l10n6.t("The schema uses meta-schema features ({0}) that are not yet supported by the validator.", Array.from(usesUnsupportedFeatures.keys()).join(", "))), new ResolvedSchema(schema, resolveErrors, resolveWarnings, schemaDraft);
        });
      }
      traverseNodes(root, handle) {
        if (!root || typeof root != "object")
          return Promise.resolve(null);
        let seen = /* @__PURE__ */ new Set(), collectEntries = (...entries) => {
          for (let entry of entries)
            isObject(entry) && toWalk.push(entry);
        }, collectMapEntries = (...maps) => {
          for (let map of maps)
            if (isObject(map))
              for (let k in map) {
                let entry = map[k];
                isObject(entry) && toWalk.push(entry);
              }
        }, collectArrayEntries = (...arrays) => {
          for (let array of arrays)
            if (Array.isArray(array))
              for (let entry of array)
                isObject(entry) && toWalk.push(entry);
        }, collectEntryOrArrayEntries = (items) => {
          if (Array.isArray(items))
            for (let entry of items)
              isObject(entry) && toWalk.push(entry);
          else
            isObject(items) && toWalk.push(items);
        }, toWalk = [root], next = toWalk.pop();
        for (; next; )
          seen.has(next) || (seen.add(next), handle(next), collectEntries(next.additionalItems, next.additionalProperties, next.not, next.contains, next.propertyNames, next.if, next.then, next.else, next.unevaluatedItems, next.unevaluatedProperties), collectMapEntries(next.definitions, next.$defs, next.properties, next.patternProperties, next.dependencies, next.dependentSchemas), collectArrayEntries(next.anyOf, next.allOf, next.oneOf, next.prefixItems), collectEntryOrArrayEntries(next.items)), next = toWalk.pop();
      }
      getSchemaFromProperty(resource, document2) {
        if (document2.root?.type === "object") {
          for (let p of document2.root.properties)
            if (p.keyNode.value === "$schema" && p.valueNode?.type === "string") {
              let schemaId = p.valueNode.value;
              return this.contextService && !/^\w[\w\d+.-]*:/.test(schemaId) && (schemaId = this.contextService.resolveRelativePath(schemaId, resource)), schemaId;
            }
        }
      }
      getAssociatedSchemas(resource) {
        let seen = /* @__PURE__ */ Object.create(null), schemas = [], normalizedResource = normalizeResourceForMatching(resource);
        for (let entry of this.filePatternAssociations)
          if (entry.matchesPattern(normalizedResource))
            for (let schemaId of entry.getURIs())
              seen[schemaId] || (schemas.push(schemaId), seen[schemaId] = !0);
        return schemas;
      }
      getSchemaURIsForResource(resource, document2) {
        let schemeId = document2 && this.getSchemaFromProperty(resource, document2);
        return schemeId ? [schemeId] : this.getAssociatedSchemas(resource);
      }
      getSchemaForResource(resource, document2) {
        if (document2) {
          let schemeId = this.getSchemaFromProperty(resource, document2);
          if (schemeId) {
            let id = normalizeId(schemeId);
            return this.getOrAddSchemaHandle(id).getResolvedSchema();
          }
        }
        if (this.cachedSchemaForResource && this.cachedSchemaForResource.resource === resource)
          return this.cachedSchemaForResource.resolvedSchema;
        let schemas = this.getAssociatedSchemas(resource), resolvedSchema = schemas.length > 0 ? this.createCombinedSchema(resource, schemas).getResolvedSchema() : this.promise.resolve(void 0);
        return this.cachedSchemaForResource = { resource, resolvedSchema }, resolvedSchema;
      }
      createCombinedSchema(resource, schemaIds) {
        if (schemaIds.length === 1)
          return this.getOrAddSchemaHandle(schemaIds[0]);
        {
          let combinedSchemaId = "schemaservice://combinedSchema/" + encodeURIComponent(resource), combinedSchema = {
            allOf: schemaIds.map((schemaId) => ({ $ref: schemaId }))
          };
          return this.addSchemaHandle(combinedSchemaId, combinedSchema);
        }
      }
      getMatchingSchemas(document2, jsonDocument, schema) {
        if (schema) {
          let id = schema.id || "schemaservice://untitled/matchingSchemas/" + idCounter2++;
          return this.addSchemaHandle(id, schema).getResolvedSchema().then((resolvedSchema) => jsonDocument.getMatchingSchemas(resolvedSchema.schema).filter((s) => !s.inverted));
        }
        return this.getSchemaForResource(document2.uri, jsonDocument).then((schema2) => schema2 ? jsonDocument.getMatchingSchemas(schema2.schema).filter((s) => !s.inverted) : []);
      }
    }, idCounter2 = 0;
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/jsonFolding.js
function getFoldingRanges(document2, context) {
  let ranges = [], nestingLevels = [], stack = [], prevStart = -1, scanner = createScanner2(document2.getText(), !1), token = scanner.scan();
  function addRange(range) {
    ranges.push(range), nestingLevels.push(stack.length);
  }
  for (; token !== 17; ) {
    switch (token) {
      case 1:
      case 3: {
        let startLine = document2.positionAt(scanner.getTokenOffset()).line, range = { startLine, endLine: startLine, kind: token === 1 ? "object" : "array" };
        stack.push(range);
        break;
      }
      case 2:
      case 4: {
        let kind = token === 2 ? "object" : "array";
        if (stack.length > 0 && stack[stack.length - 1].kind === kind) {
          let range = stack.pop(), line = document2.positionAt(scanner.getTokenOffset()).line;
          range && line > range.startLine + 1 && prevStart !== range.startLine && (range.endLine = line - 1, addRange(range), prevStart = range.startLine);
        }
        break;
      }
      case 13: {
        let startLine = document2.positionAt(scanner.getTokenOffset()).line, endLine = document2.positionAt(scanner.getTokenOffset() + scanner.getTokenLength()).line;
        scanner.getTokenError() === 1 && startLine + 1 < document2.lineCount ? scanner.setPosition(document2.offsetAt(Position.create(startLine + 1, 0))) : startLine < endLine && (addRange({ startLine, endLine, kind: FoldingRangeKind.Comment }), prevStart = startLine);
        break;
      }
      case 12: {
        let m = document2.getText().substr(scanner.getTokenOffset(), scanner.getTokenLength()).match(/^\/\/\s*#(region\b)|(endregion\b)/);
        if (m) {
          let line = document2.positionAt(scanner.getTokenOffset()).line;
          if (m[1]) {
            let range = { startLine: line, endLine: line, kind: FoldingRangeKind.Region };
            stack.push(range);
          } else {
            let i = stack.length - 1;
            for (; i >= 0 && stack[i].kind !== FoldingRangeKind.Region; )
              i--;
            if (i >= 0) {
              let range = stack[i];
              stack.length = i, line > range.startLine && prevStart !== range.startLine && (range.endLine = line, addRange(range), prevStart = range.startLine);
            }
          }
        }
        break;
      }
    }
    token = scanner.scan();
  }
  let rangeLimit = context && context.rangeLimit;
  if (typeof rangeLimit != "number" || ranges.length <= rangeLimit)
    return ranges;
  context && context.onRangeLimitExceeded && context.onRangeLimitExceeded(document2.uri);
  let counts = [];
  for (let level of nestingLevels)
    level < 30 && (counts[level] = (counts[level] || 0) + 1);
  let entries = 0, maxLevel = 0;
  for (let i = 0; i < counts.length; i++) {
    let n = counts[i];
    if (n) {
      if (n + entries > rangeLimit) {
        maxLevel = i;
        break;
      }
      entries += n;
    }
  }
  let result = [];
  for (let i = 0; i < ranges.length; i++) {
    let level = nestingLevels[i];
    typeof level == "number" && (level < maxLevel || level === maxLevel && entries++ < rangeLimit) && result.push(ranges[i]);
  }
  return result;
}
var init_jsonFolding = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/jsonFolding.js"() {
    init_cjs_shims();
    init_main();
    init_jsonLanguageTypes();
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/jsonSelectionRanges.js
function getSelectionRanges(document2, positions, doc) {
  function getSelectionRange(position) {
    let offset = document2.offsetAt(position), node = doc.getNodeFromOffset(offset, !0), result = [];
    for (; node; ) {
      switch (node.type) {
        case "string":
        case "object":
        case "array":
          let cStart = node.offset + 1, cEnd = node.offset + node.length - 1;
          cStart < cEnd && offset >= cStart && offset <= cEnd && result.push(newRange(cStart, cEnd)), result.push(newRange(node.offset, node.offset + node.length));
          break;
        case "number":
        case "boolean":
        case "null":
        case "property":
          result.push(newRange(node.offset, node.offset + node.length));
          break;
      }
      if (node.type === "property" || node.parent && node.parent.type === "array") {
        let afterCommaOffset = getOffsetAfterNextToken(
          node.offset + node.length,
          5
          /* SyntaxKind.CommaToken */
        );
        afterCommaOffset !== -1 && result.push(newRange(node.offset, afterCommaOffset));
      }
      node = node.parent;
    }
    let current;
    for (let index = result.length - 1; index >= 0; index--)
      current = SelectionRange.create(result[index], current);
    return current || (current = SelectionRange.create(Range.create(position, position))), current;
  }
  function newRange(start, end) {
    return Range.create(document2.positionAt(start), document2.positionAt(end));
  }
  let scanner = createScanner2(document2.getText(), !0);
  function getOffsetAfterNextToken(offset, expectedToken) {
    return scanner.setPosition(offset), scanner.scan() === expectedToken ? scanner.getTokenOffset() + scanner.getTokenLength() : -1;
  }
  return positions.map(getSelectionRange);
}
var init_jsonSelectionRanges = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/jsonSelectionRanges.js"() {
    init_cjs_shims();
    init_jsonLanguageTypes();
    init_main();
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/utils/format.js
function format3(documentToFormat, formattingOptions, formattingRange) {
  let range;
  if (formattingRange) {
    let offset = documentToFormat.offsetAt(formattingRange.start), length = documentToFormat.offsetAt(formattingRange.end) - offset;
    range = { offset, length };
  }
  let options = {
    tabSize: formattingOptions ? formattingOptions.tabSize : 4,
    insertSpaces: formattingOptions?.insertSpaces === !0,
    insertFinalNewline: formattingOptions?.insertFinalNewline === !0,
    eol: `
`,
    keepLines: formattingOptions?.keepLines === !0
  };
  return format2(documentToFormat.getText(), range, options).map((edit) => TextEdit.replace(Range.create(documentToFormat.positionAt(edit.offset), documentToFormat.positionAt(edit.offset + edit.length)), edit.content));
}
var init_format2 = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/utils/format.js"() {
    init_cjs_shims();
    init_main();
    init_jsonLanguageTypes();
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/utils/propertyTree.js
function compareProperties(propertyTree1, propertyTree2) {
  let propertyName1 = propertyTree1.propertyName.toLowerCase(), propertyName2 = propertyTree2.propertyName.toLowerCase();
  return propertyName1 < propertyName2 ? -1 : propertyName1 > propertyName2 ? 1 : 0;
}
function binarySearchOnPropertyArray(propertyTreeArray, propertyTree, compare_fn) {
  let propertyName = propertyTree.propertyName.toLowerCase(), firstPropertyInArrayName = propertyTreeArray[0].propertyName.toLowerCase(), lastPropertyInArrayName = propertyTreeArray[propertyTreeArray.length - 1].propertyName.toLowerCase();
  if (propertyName < firstPropertyInArrayName)
    return 0;
  if (propertyName > lastPropertyInArrayName)
    return propertyTreeArray.length;
  let m = 0, n = propertyTreeArray.length - 1;
  for (; m <= n; ) {
    let k = n + m >> 1, cmp = compare_fn(propertyTree, propertyTreeArray[k]);
    if (cmp > 0)
      m = k + 1;
    else if (cmp < 0)
      n = k - 1;
    else
      return k;
  }
  return -m - 1;
}
var Container, PropertyTree, init_propertyTree = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/utils/propertyTree.js"() {
    init_cjs_shims();
    (function(Container2) {
      Container2[Container2.Object = 0] = "Object", Container2[Container2.Array = 1] = "Array";
    })(Container || (Container = {}));
    PropertyTree = class {
      constructor(propertyName, beginningLineNumber) {
        this.propertyName = propertyName ?? "", this.beginningLineNumber = beginningLineNumber, this.childrenProperties = [], this.lastProperty = !1, this.noKeyName = !1;
      }
      addChildProperty(childProperty) {
        if (childProperty.parent = this, this.childrenProperties.length > 0) {
          let insertionIndex = 0;
          childProperty.noKeyName ? insertionIndex = this.childrenProperties.length : insertionIndex = binarySearchOnPropertyArray(this.childrenProperties, childProperty, compareProperties), insertionIndex < 0 && (insertionIndex = insertionIndex * -1 - 1), this.childrenProperties.splice(insertionIndex, 0, childProperty);
        } else
          this.childrenProperties.push(childProperty);
        return childProperty;
      }
    };
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/utils/sort.js
function sort(documentToSort, formattingOptions) {
  let options = {
    ...formattingOptions,
    keepLines: !1
    // keepLines must be false so that the properties are on separate lines for the sorting
  }, formattedJsonString = TextDocument2.applyEdits(documentToSort, format3(documentToSort, options, void 0)), formattedJsonDocument = TextDocument2.create("test://test.json", "json", 0, formattedJsonString), jsonPropertyTree = findJsoncPropertyTree(formattedJsonDocument), sortedJsonDocument = sortJsoncDocument(formattedJsonDocument, jsonPropertyTree), edits = format3(sortedJsonDocument, options, void 0), sortedAndFormattedJsonDocument = TextDocument2.applyEdits(sortedJsonDocument, edits);
  return [TextEdit.replace(Range.create(Position.create(0, 0), documentToSort.positionAt(documentToSort.getText().length)), sortedAndFormattedJsonDocument)];
}
function findJsoncPropertyTree(formattedDocument) {
  let formattedString = formattedDocument.getText(), scanner = createScanner2(formattedString, !1), rootTree = new PropertyTree(), currentTree = rootTree, currentProperty = rootTree, lastProperty = rootTree, token, lastTokenLine = 0, numberOfCharactersOnPreviousLines = 0, lastNonTriviaNonCommentToken, secondToLastNonTriviaNonCommentToken, lineOfLastNonTriviaNonCommentToken = -1, endIndexOfLastNonTriviaNonCommentToken = -1, beginningLineNumber = 0, endLineNumber = 0, currentContainerStack = [], updateLastPropertyEndLineNumber = !1, updateBeginningLineNumber = !1;
  for (; (token = scanner.scan()) !== 17; ) {
    if (updateLastPropertyEndLineNumber === !0 && token !== 14 && token !== 15 && token !== 12 && token !== 13 && currentProperty.endLineNumber === void 0) {
      let endLineNumber2 = scanner.getTokenStartLine();
      secondToLastNonTriviaNonCommentToken === 2 || secondToLastNonTriviaNonCommentToken === 4 ? lastProperty.endLineNumber = endLineNumber2 - 1 : currentProperty.endLineNumber = endLineNumber2 - 1, beginningLineNumber = endLineNumber2, updateLastPropertyEndLineNumber = !1;
    }
    if (updateBeginningLineNumber === !0 && token !== 14 && token !== 15 && token !== 12 && token !== 13 && (beginningLineNumber = scanner.getTokenStartLine(), updateBeginningLineNumber = !1), scanner.getTokenStartLine() !== lastTokenLine) {
      for (let i = lastTokenLine; i < scanner.getTokenStartLine(); i++) {
        let lengthOfLine = formattedDocument.getText(Range.create(Position.create(i, 0), Position.create(i + 1, 0))).length;
        numberOfCharactersOnPreviousLines = numberOfCharactersOnPreviousLines + lengthOfLine;
      }
      lastTokenLine = scanner.getTokenStartLine();
    }
    switch (token) {
      case 10: {
        if (lastNonTriviaNonCommentToken === void 0 || lastNonTriviaNonCommentToken === 1 || lastNonTriviaNonCommentToken === 5 && currentContainerStack[currentContainerStack.length - 1] === Container.Object) {
          let childProperty = new PropertyTree(scanner.getTokenValue(), beginningLineNumber);
          lastProperty = currentProperty, currentProperty = currentTree.addChildProperty(childProperty);
        }
        break;
      }
      case 3: {
        if (rootTree.beginningLineNumber === void 0 && (rootTree.beginningLineNumber = scanner.getTokenStartLine()), currentContainerStack[currentContainerStack.length - 1] === Container.Object)
          currentTree = currentProperty;
        else if (currentContainerStack[currentContainerStack.length - 1] === Container.Array) {
          let childProperty = new PropertyTree(scanner.getTokenValue(), beginningLineNumber);
          childProperty.noKeyName = !0, lastProperty = currentProperty, currentProperty = currentTree.addChildProperty(childProperty), currentTree = currentProperty;
        }
        currentContainerStack.push(Container.Array), currentProperty.type = Container.Array, beginningLineNumber = scanner.getTokenStartLine(), beginningLineNumber++;
        break;
      }
      case 1: {
        if (rootTree.beginningLineNumber === void 0)
          rootTree.beginningLineNumber = scanner.getTokenStartLine();
        else if (currentContainerStack[currentContainerStack.length - 1] === Container.Array) {
          let childProperty = new PropertyTree(scanner.getTokenValue(), beginningLineNumber);
          childProperty.noKeyName = !0, lastProperty = currentProperty, currentProperty = currentTree.addChildProperty(childProperty);
        }
        currentProperty.type = Container.Object, currentContainerStack.push(Container.Object), currentTree = currentProperty, beginningLineNumber = scanner.getTokenStartLine(), beginningLineNumber++;
        break;
      }
      case 4: {
        endLineNumber = scanner.getTokenStartLine(), currentContainerStack.pop(), currentProperty.endLineNumber === void 0 && (lastNonTriviaNonCommentToken === 2 || lastNonTriviaNonCommentToken === 4) && (currentProperty.endLineNumber = endLineNumber - 1, currentProperty.lastProperty = !0, currentProperty.lineWhereToAddComma = lineOfLastNonTriviaNonCommentToken, currentProperty.indexWhereToAddComa = endIndexOfLastNonTriviaNonCommentToken, lastProperty = currentProperty, currentProperty = currentProperty ? currentProperty.parent : void 0, currentTree = currentProperty), rootTree.endLineNumber = endLineNumber, beginningLineNumber = endLineNumber + 1;
        break;
      }
      case 2: {
        endLineNumber = scanner.getTokenStartLine(), currentContainerStack.pop(), lastNonTriviaNonCommentToken !== 1 && (currentProperty.endLineNumber === void 0 && (currentProperty.endLineNumber = endLineNumber - 1, currentProperty.lastProperty = !0, currentProperty.lineWhereToAddComma = lineOfLastNonTriviaNonCommentToken, currentProperty.indexWhereToAddComa = endIndexOfLastNonTriviaNonCommentToken), lastProperty = currentProperty, currentProperty = currentProperty ? currentProperty.parent : void 0, currentTree = currentProperty), rootTree.endLineNumber = scanner.getTokenStartLine(), beginningLineNumber = endLineNumber + 1;
        break;
      }
      case 5: {
        endLineNumber = scanner.getTokenStartLine(), currentProperty.endLineNumber === void 0 && (currentContainerStack[currentContainerStack.length - 1] === Container.Object || currentContainerStack[currentContainerStack.length - 1] === Container.Array && (lastNonTriviaNonCommentToken === 2 || lastNonTriviaNonCommentToken === 4)) && (currentProperty.endLineNumber = endLineNumber, currentProperty.commaIndex = scanner.getTokenOffset() - numberOfCharactersOnPreviousLines, currentProperty.commaLine = endLineNumber), (lastNonTriviaNonCommentToken === 2 || lastNonTriviaNonCommentToken === 4) && (lastProperty = currentProperty, currentProperty = currentProperty ? currentProperty.parent : void 0, currentTree = currentProperty), beginningLineNumber = endLineNumber + 1;
        break;
      }
      case 13: {
        lastNonTriviaNonCommentToken === 5 && lineOfLastNonTriviaNonCommentToken === scanner.getTokenStartLine() && (currentContainerStack[currentContainerStack.length - 1] === Container.Array && (secondToLastNonTriviaNonCommentToken === 2 || secondToLastNonTriviaNonCommentToken === 4) || currentContainerStack[currentContainerStack.length - 1] === Container.Object) && (currentContainerStack[currentContainerStack.length - 1] === Container.Array && (secondToLastNonTriviaNonCommentToken === 2 || secondToLastNonTriviaNonCommentToken === 4) || currentContainerStack[currentContainerStack.length - 1] === Container.Object) && (currentProperty.endLineNumber = void 0, updateLastPropertyEndLineNumber = !0), (lastNonTriviaNonCommentToken === 1 || lastNonTriviaNonCommentToken === 3) && lineOfLastNonTriviaNonCommentToken === scanner.getTokenStartLine() && (updateBeginningLineNumber = !0);
        break;
      }
    }
    token !== 14 && token !== 13 && token !== 12 && token !== 15 && (secondToLastNonTriviaNonCommentToken = lastNonTriviaNonCommentToken, lastNonTriviaNonCommentToken = token, lineOfLastNonTriviaNonCommentToken = scanner.getTokenStartLine(), endIndexOfLastNonTriviaNonCommentToken = scanner.getTokenOffset() + scanner.getTokenLength() - numberOfCharactersOnPreviousLines);
  }
  return rootTree;
}
function sortJsoncDocument(jsonDocument, propertyTree) {
  if (propertyTree.childrenProperties.length === 0)
    return jsonDocument;
  let sortedJsonDocument = TextDocument2.create("test://test.json", "json", 0, jsonDocument.getText()), queueToSort = [];
  for (updateSortingQueue(queueToSort, propertyTree, propertyTree.beginningLineNumber); queueToSort.length > 0; ) {
    let dataToSort = queueToSort.shift(), propertyTreeArray = dataToSort.propertyTreeArray, beginningLineNumber = dataToSort.beginningLineNumber;
    for (let i = 0; i < propertyTreeArray.length; i++) {
      let propertyTree2 = propertyTreeArray[i], range = Range.create(Position.create(propertyTree2.beginningLineNumber, 0), Position.create(propertyTree2.endLineNumber + 1, 0)), jsonContentToReplace = jsonDocument.getText(range), jsonDocumentToReplace = TextDocument2.create("test://test.json", "json", 0, jsonContentToReplace);
      if (propertyTree2.lastProperty === !0 && i !== propertyTreeArray.length - 1) {
        let lineWhereToAddComma = propertyTree2.lineWhereToAddComma - propertyTree2.beginningLineNumber, indexWhereToAddComma = propertyTree2.indexWhereToAddComa, edit2 = {
          range: Range.create(Position.create(lineWhereToAddComma, indexWhereToAddComma), Position.create(lineWhereToAddComma, indexWhereToAddComma)),
          text: ","
        };
        TextDocument2.update(jsonDocumentToReplace, [edit2], 1);
      } else if (propertyTree2.lastProperty === !1 && i === propertyTreeArray.length - 1) {
        let commaIndex = propertyTree2.commaIndex, lineWhereToRemoveComma = propertyTree2.commaLine - propertyTree2.beginningLineNumber, edit2 = {
          range: Range.create(Position.create(lineWhereToRemoveComma, commaIndex), Position.create(lineWhereToRemoveComma, commaIndex + 1)),
          text: ""
        };
        TextDocument2.update(jsonDocumentToReplace, [edit2], 1);
      }
      let length = propertyTree2.endLineNumber - propertyTree2.beginningLineNumber + 1, edit = {
        range: Range.create(Position.create(beginningLineNumber, 0), Position.create(beginningLineNumber + length, 0)),
        text: jsonDocumentToReplace.getText()
      };
      TextDocument2.update(sortedJsonDocument, [edit], 1), updateSortingQueue(queueToSort, propertyTree2, beginningLineNumber), beginningLineNumber = beginningLineNumber + length;
    }
  }
  return sortedJsonDocument;
}
function updateSortingQueue(queue, propertyTree, beginningLineNumber) {
  if (propertyTree.childrenProperties.length !== 0)
    if (propertyTree.type === Container.Object) {
      let minimumBeginningLineNumber = 1 / 0;
      for (let childProperty of propertyTree.childrenProperties)
        childProperty.beginningLineNumber < minimumBeginningLineNumber && (minimumBeginningLineNumber = childProperty.beginningLineNumber);
      let diff2 = minimumBeginningLineNumber - propertyTree.beginningLineNumber;
      beginningLineNumber = beginningLineNumber + diff2, queue.push(new SortingRange(beginningLineNumber, propertyTree.childrenProperties));
    } else
      propertyTree.type === Container.Array && updateSortingQueueForArrayProperties(queue, propertyTree, beginningLineNumber);
}
function updateSortingQueueForArrayProperties(queue, propertyTree, beginningLineNumber) {
  for (let subObject of propertyTree.childrenProperties) {
    if (subObject.type === Container.Object) {
      let minimumBeginningLineNumber = 1 / 0;
      for (let childProperty of subObject.childrenProperties)
        childProperty.beginningLineNumber < minimumBeginningLineNumber && (minimumBeginningLineNumber = childProperty.beginningLineNumber);
      let diff2 = minimumBeginningLineNumber - subObject.beginningLineNumber;
      queue.push(new SortingRange(beginningLineNumber + subObject.beginningLineNumber - propertyTree.beginningLineNumber + diff2, subObject.childrenProperties));
    }
    subObject.type === Container.Array && updateSortingQueueForArrayProperties(queue, subObject, beginningLineNumber + subObject.beginningLineNumber - propertyTree.beginningLineNumber);
  }
}
var SortingRange, init_sort = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/utils/sort.js"() {
    init_cjs_shims();
    init_main();
    init_jsonLanguageTypes();
    init_format2();
    init_propertyTree();
    SortingRange = class {
      constructor(beginningLineNumber, propertyTreeArray) {
        this.beginningLineNumber = beginningLineNumber, this.propertyTreeArray = propertyTreeArray;
      }
    };
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/jsonLinks.js
function findLinks(document2, doc) {
  let links = [];
  return doc.visit((node) => {
    if (node.type === "property" && node.keyNode.value === "$ref" && node.valueNode?.type === "string") {
      let path3 = node.valueNode.value, targetNode = findTargetNode(doc, path3);
      if (targetNode) {
        let targetPos = document2.positionAt(targetNode.offset);
        links.push({
          target: `${document2.uri}#${targetPos.line + 1},${targetPos.character + 1}`,
          range: createRange(document2, node.valueNode)
        });
      }
    }
    return !0;
  }), Promise.resolve(links);
}
function createRange(document2, node) {
  return Range.create(document2.positionAt(node.offset + 1), document2.positionAt(node.offset + node.length - 1));
}
function findTargetNode(doc, path3) {
  let tokens = parseJSONPointer(path3);
  return tokens ? findNode(tokens, doc.root) : null;
}
function findNode(pointer, node) {
  if (!node)
    return null;
  if (pointer.length === 0)
    return node;
  let token = pointer.shift();
  if (node && node.type === "object") {
    let propertyNode = node.properties.find((propertyNode2) => propertyNode2.keyNode.value === token);
    return propertyNode ? findNode(pointer, propertyNode.valueNode) : null;
  } else if (node && node.type === "array" && token.match(/^(0|[1-9][0-9]*)$/)) {
    let index = Number.parseInt(token), arrayItem = node.items[index];
    return arrayItem ? findNode(pointer, arrayItem) : null;
  }
  return null;
}
function parseJSONPointer(path3) {
  return path3 === "#" ? [] : path3[0] !== "#" || path3[1] !== "/" ? null : path3.substring(2).split(/\//).map(unescape2);
}
function unescape2(str) {
  return str.replace(/~1/g, "/").replace(/~0/g, "~");
}
var init_jsonLinks = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/services/jsonLinks.js"() {
    init_cjs_shims();
    init_jsonLanguageTypes();
  }
});

// ../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/jsonLanguageService.js
var jsonLanguageService_exports = {};
__export(jsonLanguageService_exports, {
  ClientCapabilities: () => ClientCapabilities,
  CodeAction: () => CodeAction,
  CodeActionContext: () => CodeActionContext,
  CodeActionKind: () => CodeActionKind,
  Color: () => Color,
  ColorInformation: () => ColorInformation,
  ColorPresentation: () => ColorPresentation,
  Command: () => Command,
  CompletionItem: () => CompletionItem,
  CompletionItemKind: () => CompletionItemKind,
  CompletionItemTag: () => CompletionItemTag,
  CompletionList: () => CompletionList,
  Diagnostic: () => Diagnostic,
  DiagnosticSeverity: () => DiagnosticSeverity,
  DocumentHighlight: () => DocumentHighlight,
  DocumentHighlightKind: () => DocumentHighlightKind,
  DocumentLink: () => DocumentLink,
  DocumentSymbol: () => DocumentSymbol,
  DocumentUri: () => DocumentUri,
  ErrorCode: () => ErrorCode,
  FoldingRange: () => FoldingRange,
  FoldingRangeKind: () => FoldingRangeKind,
  Hover: () => Hover,
  InsertTextFormat: () => InsertTextFormat,
  Location: () => Location,
  MarkedString: () => MarkedString,
  MarkupContent: () => MarkupContent,
  MarkupKind: () => MarkupKind,
  Position: () => Position,
  Range: () => Range,
  SchemaDraft: () => SchemaDraft,
  SelectionRange: () => SelectionRange,
  SymbolInformation: () => SymbolInformation,
  SymbolKind: () => SymbolKind,
  TextDocument: () => TextDocument2,
  TextDocumentEdit: () => TextDocumentEdit,
  TextEdit: () => TextEdit,
  VersionedTextDocumentIdentifier: () => VersionedTextDocumentIdentifier,
  WorkspaceEdit: () => WorkspaceEdit,
  getLanguageService: () => getLanguageService
});
function getLanguageService(params) {
  let promise = params.promiseConstructor || Promise, jsonSchemaService = new JSONSchemaService(params.schemaRequestService, params.workspaceContext, promise);
  jsonSchemaService.setSchemaContributions(schemaContributions);
  let jsonCompletion = new JSONCompletion(jsonSchemaService, params.contributions, promise, params.clientCapabilities), jsonHover = new JSONHover(jsonSchemaService, params.contributions, promise), jsonDocumentSymbols = new JSONDocumentSymbols(jsonSchemaService), jsonValidation = new JSONValidation(jsonSchemaService, promise);
  return {
    configure: (settings) => {
      jsonSchemaService.clearExternalSchemas(), settings.schemas?.forEach(jsonSchemaService.registerExternalSchema.bind(jsonSchemaService)), jsonValidation.configure(settings);
    },
    resetSchema: (uri) => jsonSchemaService.onResourceChange(uri),
    doValidation: jsonValidation.doValidation.bind(jsonValidation),
    getLanguageStatus: jsonValidation.getLanguageStatus.bind(jsonValidation),
    parseJSONDocument: (document2) => parse3(document2, { collectComments: !0 }),
    newJSONDocument: (root, diagnostics) => newJSONDocument(root, diagnostics),
    getMatchingSchemas: jsonSchemaService.getMatchingSchemas.bind(jsonSchemaService),
    doResolve: jsonCompletion.doResolve.bind(jsonCompletion),
    doComplete: jsonCompletion.doComplete.bind(jsonCompletion),
    findDocumentSymbols: jsonDocumentSymbols.findDocumentSymbols.bind(jsonDocumentSymbols),
    findDocumentSymbols2: jsonDocumentSymbols.findDocumentSymbols2.bind(jsonDocumentSymbols),
    findDocumentColors: jsonDocumentSymbols.findDocumentColors.bind(jsonDocumentSymbols),
    getColorPresentations: jsonDocumentSymbols.getColorPresentations.bind(jsonDocumentSymbols),
    doHover: jsonHover.doHover.bind(jsonHover),
    getFoldingRanges,
    getSelectionRanges,
    findDefinition: () => Promise.resolve([]),
    findLinks,
    format: (document2, range, options) => format3(document2, options, range),
    sort: (document2, options) => sort(document2, options)
  };
}
var init_jsonLanguageService = __esm({
  "../../node_modules/.pnpm/vscode-json-languageservice@5.3.11/node_modules/vscode-json-languageservice/lib/umd/jsonLanguageService.js"() {
    init_cjs_shims();
    init_jsonCompletion();
    init_jsonHover();
    init_jsonValidation();
    init_jsonDocumentSymbols();
    init_jsonParser();
    init_configuration();
    init_jsonSchemaService();
    init_jsonFolding();
    init_jsonSelectionRanges();
    init_sort();
    init_format2();
    init_jsonLinks();
    init_jsonLanguageTypes();
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/JSONValidator.js
var require_JSONValidator = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/JSONValidator.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.JSONValidator = void 0;
    var vscode_json_languageservice_1 = (init_jsonLanguageService(), __toCommonJS(jsonLanguageService_exports)), utils_1 = require_utils2(), JSONValidator = class {
      constructor(schemas) {
        this.validate = async (sourceCode, jsonString) => {
          let jsonTextDocument = vscode_json_languageservice_1.TextDocument.create("file:" + sourceCode.absolutePath, "json", 0, jsonString), jsonDocument = this.service.parseJSONDocument(jsonTextDocument);
          return (await this.service.doValidation(jsonTextDocument, jsonDocument, {
            schemaValidation: "error",
            trailingCommas: "ignore",
            comments: "ignore"
          })).map((diagnostic) => ({
            message: diagnostic.message,
            startIndex: jsonTextDocument.offsetAt(diagnostic.range.start),
            endIndex: jsonTextDocument.offsetAt(diagnostic.range.end)
          }));
        }, this.schemas = (0, utils_1.indexBy)((x) => x.uri, schemas), this.service = (0, vscode_json_languageservice_1.getLanguageService)({
          schemaRequestService: this.getSchemaForURI.bind(this),
          workspaceContext: {
            resolveRelativePath: (relativePath2, resource) => new URL(relativePath2, resource).toString()
          }
        }), this.service.configure({
          schemas: schemas.map((schemaDefinition) => ({
            uri: schemaDefinition.uri,
            fileMatch: schemaDefinition.fileMatch
          }))
        });
      }
      async getSchemaForURI(uri) {
        var _a38;
        let schema = (_a38 = this.schemas[uri]) === null || _a38 === void 0 ? void 0 : _a38.schema;
        return schema || `No schema for '${uri}' found`;
      }
    };
    exports.JSONValidator = JSONValidator;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/fixes/utils.js
var require_utils3 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/fixes/utils.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.flattenFixes = void 0;
    function flattenFixes(fix) {
      return Array.isArray(fix) ? fix.flatMap(flattenFixes) : [fix];
    }
    exports.flattenFixes = flattenFixes;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseAssignValue.js
var require_baseAssignValue = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseAssignValue.js"(exports, module) {
    init_cjs_shims();
    var defineProperty = require_defineProperty();
    function baseAssignValue(object, key, value) {
      key == "__proto__" && defineProperty ? defineProperty(object, key, {
        configurable: !0,
        enumerable: !0,
        value,
        writable: !0
      }) : object[key] = value;
    }
    module.exports = baseAssignValue;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_assignValue.js
var require_assignValue = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_assignValue.js"(exports, module) {
    init_cjs_shims();
    var baseAssignValue = require_baseAssignValue(), eq = require_eq(), objectProto = Object.prototype, hasOwnProperty = objectProto.hasOwnProperty;
    function assignValue(object, key, value) {
      var objValue = object[key];
      (!(hasOwnProperty.call(object, key) && eq(objValue, value)) || value === void 0 && !(key in object)) && baseAssignValue(object, key, value);
    }
    module.exports = assignValue;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseSet.js
var require_baseSet = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseSet.js"(exports, module) {
    init_cjs_shims();
    var assignValue = require_assignValue(), castPath = require_castPath(), isIndex = require_isIndex(), isObject4 = require_isObject(), toKey = require_toKey();
    function baseSet(object, path3, value, customizer) {
      if (!isObject4(object))
        return object;
      path3 = castPath(path3, object);
      for (var index = -1, length = path3.length, lastIndex = length - 1, nested = object; nested != null && ++index < length; ) {
        var key = toKey(path3[index]), newValue = value;
        if (key === "__proto__" || key === "constructor" || key === "prototype")
          return object;
        if (index != lastIndex) {
          var objValue = nested[key];
          newValue = customizer ? customizer(objValue, key, nested) : void 0, newValue === void 0 && (newValue = isObject4(objValue) ? objValue : isIndex(path3[index + 1]) ? [] : {});
        }
        assignValue(nested, key, newValue), nested = nested[key];
      }
      return object;
    }
    module.exports = baseSet;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/set.js
var require_set = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/set.js"(exports, module) {
    init_cjs_shims();
    var baseSet = require_baseSet();
    function set2(object, path3, value) {
      return object == null ? object : baseSet(object, path3, value);
    }
    module.exports = set2;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/last.js
var require_last = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/last.js"(exports, module) {
    init_cjs_shims();
    function last(array) {
      var length = array == null ? 0 : array.length;
      return length ? array[length - 1] : void 0;
    }
    module.exports = last;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseSlice.js
var require_baseSlice = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseSlice.js"(exports, module) {
    init_cjs_shims();
    function baseSlice(array, start, end) {
      var index = -1, length = array.length;
      start < 0 && (start = -start > length ? 0 : length + start), end = end > length ? length : end, end < 0 && (end += length), length = start > end ? 0 : end - start >>> 0, start >>>= 0;
      for (var result = Array(length); ++index < length; )
        result[index] = array[index + start];
      return result;
    }
    module.exports = baseSlice;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_parent.js
var require_parent = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_parent.js"(exports, module) {
    init_cjs_shims();
    var baseGet = require_baseGet(), baseSlice = require_baseSlice();
    function parent(object, path3) {
      return path3.length < 2 ? object : baseGet(object, baseSlice(path3, 0, -1));
    }
    module.exports = parent;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseUnset.js
var require_baseUnset = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseUnset.js"(exports, module) {
    init_cjs_shims();
    var castPath = require_castPath(), last = require_last(), parent = require_parent(), toKey = require_toKey();
    function baseUnset(object, path3) {
      return path3 = castPath(path3, object), object = parent(object, path3), object == null || delete object[toKey(last(path3))];
    }
    module.exports = baseUnset;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/unset.js
var require_unset = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/unset.js"(exports, module) {
    init_cjs_shims();
    var baseUnset = require_baseUnset();
    function unset(object, path3) {
      return object == null ? !0 : baseUnset(object, path3);
    }
    module.exports = unset;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/fixes/correctors/json-corrector.js
var require_json_corrector = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/fixes/correctors/json-corrector.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.JSONCorrector = void 0;
    var set_1 = __importDefault(require_set()), unset_1 = __importDefault(require_unset());
    function applyPatch(json, operation) {
      switch (operation.type) {
        case "add":
          return (0, set_1.default)(json, operation.path, operation.value);
        case "remove":
          return (0, unset_1.default)(json, operation.path), json;
      }
    }
    var JSONCorrector = class {
      constructor(source) {
        this.source = source, this.patches = [];
      }
      /**
       * corrector.fix is the data representation of all the changes to source.
       */
      get fix() {
        if (this.patches.length === 0)
          return [];
        let json = this.patches.reduce(applyPatch, JSON.parse(this.source));
        return {
          startIndex: 0,
          endIndex: this.source.length,
          insert: JSON.stringify(json, null, 2)
        };
      }
      /**
       * Add value at dot delited JSON path
       *
       * @example
       * corrector.add('missing.key', 'TO DO')
       */
      add(path3, value) {
        this.patches.push({
          type: "add",
          path: path3,
          value
        });
      }
      /**
       * Replace a value at dot delited JSON path.
       *
       * @example
       * corrector.replace('missing.key', 'TO DO')
       */
      replace(path3, value) {
        this.patches.push({
          type: "remove",
          path: path3
        }, {
          type: "add",
          path: path3,
          value
        });
      }
      /**
       * Remove key from JSON object
       *
       * @example
       * corrector.remove('unneeded.key')
       */
      remove(path3) {
        this.patches.push({
          type: "remove",
          path: path3
        });
      }
    };
    exports.JSONCorrector = JSONCorrector;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/fixes/correctors/string-corrector.js
var require_string_corrector = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/fixes/correctors/string-corrector.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.StringCorrector = void 0;
    var StringCorrector = class {
      constructor(source) {
        this.source = source, this.fix = [];
      }
      /**
       * insert text before the given index
       *
       * @example
       * corrector.insert(
       *   node.position.start,
       *   node.position.start,
       *   'prefix node with this content'
       * )
       *
       * corrector.insert(
       *   node.position.end,
       *   node.position.end,
       *   'suffix node with this content (since position.end is excluded)'
       * )
       */
      insert(index, text) {
        this.fix.push({
          startIndex: index,
          endIndex: index,
          insert: text
        });
      }
      /**
       * replace text between start (included) and end (excluded) with text.
       *
       * @example
       * corrector.replace(
       *   node.position.start,
       *   node.position.end,
       *   'ho ho ho',
       * );
       */
      replace(start, end, text) {
        this.fix.push({
          startIndex: start,
          endIndex: end,
          insert: text
        });
      }
      /**
       * remove text between start (included) and end (excluded)
       *
       * @example
       * corrector.remove(
       *   node.position.start,
       *   node.position.end,
       * )
       */
      remove(start, end) {
        this.fix.push({
          startIndex: start,
          endIndex: end,
          insert: ""
        });
      }
    };
    exports.StringCorrector = StringCorrector;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/fixes/correctors/index.js
var require_correctors = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/fixes/correctors/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.createCorrector = exports.StringCorrector = exports.JSONCorrector = void 0;
    var types_1 = require_types2(), json_corrector_1 = require_json_corrector();
    Object.defineProperty(exports, "JSONCorrector", { enumerable: !0, get: function() {
      return json_corrector_1.JSONCorrector;
    } });
    var string_corrector_1 = require_string_corrector();
    Object.defineProperty(exports, "StringCorrector", { enumerable: !0, get: function() {
      return string_corrector_1.StringCorrector;
    } });
    function createCorrector(sourceCodeType, source) {
      switch (sourceCodeType) {
        case types_1.SourceCodeType.JSON:
          return new json_corrector_1.JSONCorrector(source);
        case types_1.SourceCodeType.LiquidHtml:
          return new string_corrector_1.StringCorrector(source);
        default:
          return assertNever(sourceCodeType);
      }
    }
    exports.createCorrector = createCorrector;
    function assertNever(x) {
      throw new Error(`Case statement not exhausted: ${x}`);
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/fixes/autofix.js
var require_autofix = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/fixes/autofix.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.autofix = void 0;
    var correctors_1 = require_correctors(), utils_1 = require_utils3();
    async function autofix2(sourceCodes, offenses, applyFixes) {
      let fixableOffenses = offenses.filter((offense) => "fix" in offense && !!offense.fix), promises = [];
      for (let sourceCode of sourceCodes) {
        let sourceCodeOffenses = fixableOffenses.filter((offense) => offense.absolutePath === sourceCode.absolutePath);
        if (sourceCodeOffenses.length === 0)
          continue;
        let corrector = (0, correctors_1.createCorrector)(sourceCode.type, sourceCode.source);
        for (let offense of sourceCodeOffenses)
          offense.fix(corrector);
        promises.push(applyFixes(sourceCode, (0, utils_1.flattenFixes)(corrector.fix)));
      }
      await Promise.all(promises);
    }
    exports.autofix = autofix2;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/fixes/apply-fix-to-string.js
var require_apply_fix_to_string = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/fixes/apply-fix-to-string.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.applyFixToString = void 0;
    var utils_1 = require_utils3();
    function applyFixToString2(source, fix) {
      let newStr = source, offset = 0, sortedFixes = (0, utils_1.flattenFixes)(fix).sort((a, b) => a.startIndex - b.startIndex);
      for (let i = 0; i < sortedFixes.length - 1; i++) {
        let currentFix = sortedFixes[i], nextFix = sortedFixes[i + 1];
        if (currentFix.endIndex > nextFix.startIndex)
          throw new Error("Overlapping ranges are not allowed");
      }
      for (let fix2 of sortedFixes) {
        let startIndex = fix2.startIndex + offset, endIndex = fix2.endIndex + offset;
        if (startIndex < 0 || startIndex > newStr.length || endIndex < startIndex || endIndex > newStr.length)
          throw new Error("Fix description is going overboard");
        newStr = newStr.slice(0, startIndex) + fix2.insert + newStr.slice(endIndex), offset += fix2.insert.length - (endIndex - startIndex);
      }
      return newStr;
    }
    exports.applyFixToString = applyFixToString2;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/fixes/index.js
var require_fixes = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/fixes/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.applyFixToString = exports.autofix = exports.createCorrector = exports.JSONCorrector = exports.StringCorrector = exports.flattenFixes = void 0;
    var utils_1 = require_utils3();
    Object.defineProperty(exports, "flattenFixes", { enumerable: !0, get: function() {
      return utils_1.flattenFixes;
    } });
    var correctors_1 = require_correctors();
    Object.defineProperty(exports, "StringCorrector", { enumerable: !0, get: function() {
      return correctors_1.StringCorrector;
    } });
    Object.defineProperty(exports, "JSONCorrector", { enumerable: !0, get: function() {
      return correctors_1.JSONCorrector;
    } });
    Object.defineProperty(exports, "createCorrector", { enumerable: !0, get: function() {
      return correctors_1.createCorrector;
    } });
    var autofix_1 = require_autofix();
    Object.defineProperty(exports, "autofix", { enumerable: !0, get: function() {
      return autofix_1.autofix;
    } });
    var apply_fix_to_string_1 = require_apply_fix_to_string();
    Object.defineProperty(exports, "applyFixToString", { enumerable: !0, get: function() {
      return apply_fix_to_string_1.applyFixToString;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/app-block-valid-tags/index.js
var require_app_block_valid_tags = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/app-block-valid-tags/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.AppBlockValidTags = exports.ForbiddenTag = void 0;
    var types_1 = require_types2(), ForbiddenTag;
    (function(ForbiddenTag2) {
      ForbiddenTag2.JavaScript = "javascript", ForbiddenTag2.StyleSheet = "stylesheet", ForbiddenTag2.Include = "include", ForbiddenTag2.Layout = "layout", ForbiddenTag2.Section = "section", ForbiddenTag2.Sections = "sections";
    })(ForbiddenTag = exports.ForbiddenTag || (exports.ForbiddenTag = {}));
    var isForbiddenTag = (value) => Object.values(ForbiddenTag).includes(value), buildErrorMessage = (tag) => `Theme app extension blocks cannot contain '${tag}' tags`;
    exports.AppBlockValidTags = {
      meta: {
        code: "AppBlockValidTags",
        name: "App Block Valid Tags",
        docs: {
          description: "Identifies forbidden Liquid tags in theme app extension app block and app embed block code.",
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/app-block-valid-tags",
          recommended: !1
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema: {},
        targets: [types_1.ConfigTarget.ThemeAppExtension]
      },
      create(context) {
        let handleForbiddenTags = async (node) => {
          if (isForbiddenTag(node.name)) {
            let endIndex = node.blockEndPosition ? node.blockEndPosition.end : node.position.end, startIndex = node.blockStartPosition.start, message = buildErrorMessage(node.name);
            return context.report({ message, startIndex, endIndex });
          }
        };
        return {
          LiquidRawTag: handleForbiddenTags,
          LiquidTag: handleForbiddenTags
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/utils.js
var require_utils4 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/utils.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.isLiquidString = exports.hasAttributeValueOf = exports.valueIncludes = exports.isValuedHtmlAttribute = exports.isHtmlAttribute = exports.isAttr = exports.isHtmlTag = exports.isLiquidBranch = exports.isNodeOfType = void 0;
    var liquid_html_parser_1 = require_dist();
    function isNodeOfType(type, node) {
      return node?.type === type;
    }
    exports.isNodeOfType = isNodeOfType;
    function isLiquidBranch(node) {
      return isNodeOfType(liquid_html_parser_1.NodeTypes.LiquidBranch, node);
    }
    exports.isLiquidBranch = isLiquidBranch;
    function isHtmlTag(node, name) {
      return node.name.length === 1 && node.name[0].type === liquid_html_parser_1.NodeTypes.TextNode && node.name[0].value === name && !!node.blockEndPosition;
    }
    exports.isHtmlTag = isHtmlTag;
    function isAttr(attr, name) {
      return attr.name.length === 1 && isNodeOfType(liquid_html_parser_1.NodeTypes.TextNode, attr.name[0]) && attr.name[0].value === name;
    }
    exports.isAttr = isAttr;
    function isHtmlAttribute(attr) {
      return [
        liquid_html_parser_1.NodeTypes.AttrUnquoted,
        liquid_html_parser_1.NodeTypes.AttrDoubleQuoted,
        liquid_html_parser_1.NodeTypes.AttrSingleQuoted,
        liquid_html_parser_1.NodeTypes.AttrEmpty
      ].some((type) => isNodeOfType(type, attr));
    }
    exports.isHtmlAttribute = isHtmlAttribute;
    function isValuedHtmlAttribute(attr) {
      return [liquid_html_parser_1.NodeTypes.AttrUnquoted, liquid_html_parser_1.NodeTypes.AttrDoubleQuoted, liquid_html_parser_1.NodeTypes.AttrSingleQuoted].some((type) => isNodeOfType(type, attr));
    }
    exports.isValuedHtmlAttribute = isValuedHtmlAttribute;
    function valueIncludes(attr, word) {
      let regex = new RegExp(`(^|\\s)${word}(\\s|$)`, "g");
      return attr.value.filter((node) => isNodeOfType(liquid_html_parser_1.NodeTypes.TextNode, node)).some((valueNode) => regex.test(valueNode.value));
    }
    exports.valueIncludes = valueIncludes;
    function hasAttributeValueOf(attr, value) {
      return attr.value.length === 1 && isNodeOfType(liquid_html_parser_1.NodeTypes.TextNode, attr.value[0]) && attr.value[0].value === value;
    }
    exports.hasAttributeValueOf = hasAttributeValueOf;
    function isLiquidString(node) {
      return node.type === liquid_html_parser_1.NodeTypes.String;
    }
    exports.isLiquidString = isLiquidString;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/asset-preload/index.js
var require_asset_preload = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/asset-preload/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.AssetPreload = void 0;
    var liquid_html_parser_1 = require_dist(), types_1 = require_types2(), utils_1 = require_utils4();
    function isPreload(attr) {
      return (0, utils_1.isAttr)(attr, "rel") && attr.value.some((node) => node.type === liquid_html_parser_1.NodeTypes.TextNode && node.value === "preload");
    }
    exports.AssetPreload = {
      meta: {
        code: "AssetPreload",
        name: "Prevent Manual Preloading of Assets",
        docs: {
          description: "This check is aimed at discouraging the manual preloading of assets and encourages the use of appropriate Shopify filters.",
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/asset-preload",
          recommended: !0
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.WARNING,
        schema: {},
        targets: []
      },
      create(context) {
        return {
          async HtmlVoidElement(node) {
            var _a38;
            let preloadLinkAttr = node.attributes.find((attr) => (0, utils_1.isValuedHtmlAttribute)(attr) && isPreload(attr));
            if (node.name === "link" && preloadLinkAttr) {
              let asAttr = node.attributes.filter(utils_1.isValuedHtmlAttribute).find((attr) => (0, utils_1.isAttr)(attr, "as")), assetType = (_a38 = asAttr?.value.find((node2) => (0, utils_1.isNodeOfType)(liquid_html_parser_1.NodeTypes.TextNode, node2))) === null || _a38 === void 0 ? void 0 : _a38.value, message = "";
              assetType === "style" ? message = "For better performance, prefer using the preload argument of the stylesheet_tag filter" : assetType === "image" ? message = "For better performance, prefer using the preload argument of the image_tag filter" : message = "For better performance, prefer using the preload_tag filter", context.report({
                message,
                startIndex: node.position.start,
                endIndex: node.position.end
              });
            }
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/json.js
var require_json2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/json.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.parseJSON = void 0;
    var utils_1 = require_utils2(), jsonc_parser_1 = (init_main(), __toCommonJS(main_exports)), PARSE_OPTS = {
      disallowComments: !1,
      allowTrailingComma: !0,
      allowEmptyContent: !1
    };
    function parseJSON(source, defaultValue) {
      try {
        let errors2 = [], result = (0, jsonc_parser_1.parse)(source, errors2, PARSE_OPTS);
        if (errors2.length)
          throw errors2[0];
        return result;
      } catch (error) {
        return defaultValue !== void 0 ? defaultValue : (0, utils_1.asError)(error);
      }
    }
    exports.parseJSON = parseJSON;
  }
});

// ../../node_modules/.pnpm/cross-fetch@4.0.0/node_modules/cross-fetch/dist/node-ponyfill.js
var require_node_ponyfill = __commonJS({
  "../../node_modules/.pnpm/cross-fetch@4.0.0/node_modules/cross-fetch/dist/node-ponyfill.js"(exports, module) {
    init_cjs_shims();
    var nodeFetch = require_lib2(), realFetch = nodeFetch.default || nodeFetch, fetch3 = function(url, options) {
      return /^\/\//.test(url) && (url = "https:" + url), realFetch.call(this, url, options);
    };
    fetch3.ponyfill = !0;
    module.exports = exports = fetch3;
    exports.fetch = fetch3;
    exports.Headers = nodeFetch.Headers;
    exports.Request = nodeFetch.Request;
    exports.Response = nodeFetch.Response;
    exports.default = fetch3;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/utils/file-utils.js
var require_file_utils = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/utils/file-utils.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.hasLocalAssetSizeExceededThreshold = exports.hasRemoteAssetSizeExceededThreshold = exports.getFileSize = exports.doesFileExceedThreshold = exports.doesFileExist = void 0;
    var cross_fetch_1 = require_node_ponyfill();
    async function doesFileExist(context, relativePath2) {
      let absolutePath = context.absolutePath(relativePath2);
      return await context.fileExists(absolutePath);
    }
    exports.doesFileExist = doesFileExist;
    async function doesFileExceedThreshold(context, relativePath2, thresholdInBytes) {
      let absolutePath = context.absolutePath(relativePath2);
      if (!context.fileSize)
        return [!1, 0];
      let fileSize2 = await context.fileSize(absolutePath);
      return [fileSize2 > thresholdInBytes, fileSize2];
    }
    exports.doesFileExceedThreshold = doesFileExceedThreshold;
    async function getFileSize(url) {
      try {
        let response = await (0, cross_fetch_1.fetch)(url, { method: "HEAD" });
        if (!response.ok)
          throw new Error(`HTTP error! status: ${response.status}`);
        let fileSize2 = response.headers.get("Content-Length");
        return fileSize2 === null ? 0 : parseFloat(fileSize2);
      } catch {
        return 0;
      }
    }
    exports.getFileSize = getFileSize;
    async function hasRemoteAssetSizeExceededThreshold(url, thresholdInBytes) {
      return await getFileSize(url) > thresholdInBytes;
    }
    exports.hasRemoteAssetSizeExceededThreshold = hasRemoteAssetSizeExceededThreshold;
    async function hasLocalAssetSizeExceededThreshold(context, relativePath2, thresholdInBytes) {
      if (!await doesFileExist(context, relativePath2))
        return !1;
      let [fileExceedsThreshold, _fileSize] = await doesFileExceedThreshold(context, relativePath2, thresholdInBytes);
      return fileExceedsThreshold;
    }
    exports.hasLocalAssetSizeExceededThreshold = hasLocalAssetSizeExceededThreshold;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/asset-size-app-block-css/index.js
var require_asset_size_app_block_css = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/asset-size-app-block-css/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.AssetSizeAppBlockCSS = void 0;
    var json_1 = require_json2(), types_1 = require_types2(), utils_1 = require_utils2(), file_utils_1 = require_file_utils(), schema = {
      thresholdInBytes: types_1.SchemaProp.number(1e5)
    };
    exports.AssetSizeAppBlockCSS = {
      meta: {
        code: "AssetSizeAppBlockCSS",
        name: "Asset Size App Block CSS",
        docs: {
          description: "This check is aimed at preventing large CSS bundles from being included via Theme App Extensions.",
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/asset-size-app-block-css",
          recommended: !0
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema,
        targets: [types_1.ConfigTarget.ThemeAppExtension]
      },
      create(context) {
        return context.fileSize ? {
          async LiquidRawTag(node) {
            if (node.name !== "schema")
              return;
            let schema2 = (0, json_1.parseJSON)(node.body.value);
            if ((0, utils_1.isError)(schema2))
              return;
            let stylesheet = schema2.stylesheet;
            if (!stylesheet)
              return;
            let relativePath2 = `assets/${stylesheet}`, thresholdInBytes = context.settings.thresholdInBytes, startIndex = node.body.position.start + node.body.value.indexOf(stylesheet), endIndex = startIndex + stylesheet.length;
            if (!await (0, file_utils_1.doesFileExist)(context, relativePath2)) {
              context.report({
                message: `'${stylesheet}' does not exist.`,
                startIndex,
                endIndex
              });
              return;
            }
            let [fileExceedsThreshold, fileSize2] = await (0, file_utils_1.doesFileExceedThreshold)(context, relativePath2, thresholdInBytes);
            fileExceedsThreshold && context.report({
              message: `The file size for '${stylesheet}' (${fileSize2} B) exceeds the configured threshold (${thresholdInBytes} B)`,
              startIndex,
              endIndex
            });
          }
        } : {};
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/asset-size-app-block-javascript/index.js
var require_asset_size_app_block_javascript = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/asset-size-app-block-javascript/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.AssetSizeAppBlockJavaScript = void 0;
    var json_1 = require_json2(), types_1 = require_types2(), utils_1 = require_utils2(), file_utils_1 = require_file_utils(), schema = {
      thresholdInBytes: types_1.SchemaProp.number(1e4)
    };
    exports.AssetSizeAppBlockJavaScript = {
      meta: {
        code: "AssetSizeAppBlockJavaScript",
        name: "Asset Size App Block JavaScript",
        docs: {
          description: "This check is aimed at preventing large JavaScript bundles from being included via Theme App Extensions.",
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/asset-size-app-block-javascript",
          recommended: !0
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema,
        targets: [types_1.ConfigTarget.ThemeAppExtension]
      },
      create(context) {
        return context.fileSize ? {
          async LiquidRawTag(node) {
            if (node.name !== "schema")
              return;
            let schema2 = (0, json_1.parseJSON)(node.body.value);
            if ((0, utils_1.isError)(schema2))
              return;
            let javascript = schema2.javascript;
            if (!javascript)
              return;
            let relativePath2 = `assets/${javascript}`, thresholdInBytes = context.settings.thresholdInBytes, startIndex = node.body.position.start + node.body.value.indexOf(javascript), endIndex = startIndex + javascript.length;
            if (!await (0, file_utils_1.doesFileExist)(context, relativePath2)) {
              context.report({
                message: `'${javascript}' does not exist.`,
                startIndex,
                endIndex
              });
              return;
            }
            let [fileExceedsThreshold, fileSize2] = await (0, file_utils_1.doesFileExceedThreshold)(context, relativePath2, thresholdInBytes);
            fileExceedsThreshold && context.report({
              message: `The file size for '${javascript}' (${fileSize2} B) exceeds the configured threshold (${thresholdInBytes} B)`,
              startIndex,
              endIndex
            });
          }
        } : {};
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/asset-size-css/index.js
var require_asset_size_css = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/asset-size-css/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.AssetSizeCSS = void 0;
    var liquid_html_parser_1 = require_dist(), types_1 = require_types2(), utils_1 = require_utils2(), file_utils_1 = require_file_utils(), utils_2 = require_utils4(), schema = {
      thresholdInBytes: types_1.SchemaProp.number(1e5)
    };
    function isTextNode(node) {
      return node.type === liquid_html_parser_1.NodeTypes.TextNode;
    }
    function isLiquidVariableOutput(node) {
      return node.type === liquid_html_parser_1.NodeTypes.LiquidVariableOutput;
    }
    function isLiquidVariable(node) {
      return typeof node != "string" && node.type === liquid_html_parser_1.NodeTypes.LiquidVariable;
    }
    function isString2(node) {
      return node.type === liquid_html_parser_1.NodeTypes.String;
    }
    exports.AssetSizeCSS = {
      meta: {
        code: "AssetSizeCSS",
        aliases: ["AssetSizeCSSStylesheetTag"],
        name: "Prevent Large CSS bundles",
        docs: {
          description: "This check is aimed at preventing large CSS bundles for speed.",
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/asset-size-css",
          recommended: !1
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema,
        targets: []
      },
      create(context) {
        if (!context.fileSize)
          return {};
        let thresholdInBytes = context.settings.thresholdInBytes;
        async function checkRemoteAssetSize(url, position) {
          await (0, file_utils_1.hasRemoteAssetSizeExceededThreshold)(url, thresholdInBytes) && context.report({
            message: `The CSS file size exceeds the threshold of ${thresholdInBytes} bytes`,
            startIndex: position.start,
            endIndex: position.end
          });
        }
        async function checkThemeAssetSize(srcValue, position) {
          await (0, file_utils_1.hasLocalAssetSizeExceededThreshold)(context, `assets/${srcValue}`, thresholdInBytes) && context.report({
            message: `The CSS file size exceeds the threshold of ${thresholdInBytes} bytes`,
            startIndex: position.start,
            endIndex: position.end
          });
        }
        return {
          async HtmlVoidElement(node) {
            if (node.name !== "link" || !node.attributes.filter(utils_2.isValuedHtmlAttribute).find((attr) => (0, utils_2.isAttr)(attr, "rel") && (0, utils_2.valueIncludes)(attr, "stylesheet")))
              return;
            let href = node.attributes.filter(utils_2.isValuedHtmlAttribute).find((attr) => (0, utils_2.isAttr)(attr, "href"));
            if (href && href.value.length === 1) {
              if (isTextNode(href.value[0]) && /(https?:)?\/\//.test(href.value[0].value)) {
                let url = href.value[0].value;
                await checkRemoteAssetSize(url, href.attributePosition);
              }
              if (isLiquidVariableOutput(href.value[0]) && isLiquidVariable(href.value[0].markup) && isString2(href.value[0].markup.expression) && href.value[0].markup.filters.length === 1 && href.value[0].markup.filters[0].name === "asset_url") {
                let assetName = href.value[0].markup.expression.value;
                await checkThemeAssetSize(assetName, href.attributePosition);
              }
            }
          },
          async LiquidFilter(node, ancestors) {
            if (node.name !== "stylesheet_tag")
              return;
            let liquidVariableParent = (0, utils_1.last)(ancestors);
            if (!(!liquidVariableParent || !(0, utils_2.isNodeOfType)(liquid_html_parser_1.NodeTypes.LiquidVariable, liquidVariableParent)) && liquidVariableParent.expression.type === liquid_html_parser_1.NodeTypes.String) {
              if (liquidVariableParent.expression.value[0].length == 1 && liquidVariableParent.filters.length == 1 && /(https?:)?\/\//.test(liquidVariableParent.expression.value)) {
                let url = liquidVariableParent.expression.value;
                await checkRemoteAssetSize(url, liquidVariableParent.expression.position);
              }
              if (liquidVariableParent.expression.value[0].length == 1 && liquidVariableParent.filters.length == 2 && liquidVariableParent.filters[0].name === "asset_url" && liquidVariableParent.filters[1].name === "stylesheet_tag") {
                let css = liquidVariableParent.expression.value;
                await checkThemeAssetSize(css, liquidVariableParent.position);
              }
            }
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/asset-size-javascript/index.js
var require_asset_size_javascript = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/asset-size-javascript/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.AssetSizeJavaScript = void 0;
    var liquid_html_parser_1 = require_dist(), types_1 = require_types2(), utils_1 = require_utils2(), file_utils_1 = require_file_utils(), utils_2 = require_utils4(), schema = {
      thresholdInBytes: types_1.SchemaProp.number(1e4)
    };
    function isTextNode(node) {
      return node.type === liquid_html_parser_1.NodeTypes.TextNode;
    }
    function isLiquidVariableOutput(node) {
      return node.type === liquid_html_parser_1.NodeTypes.LiquidVariableOutput;
    }
    function isLiquidVariable(node) {
      return typeof node != "string" && node.type === liquid_html_parser_1.NodeTypes.LiquidVariable;
    }
    function isString2(node) {
      return node.type === liquid_html_parser_1.NodeTypes.String;
    }
    exports.AssetSizeJavaScript = {
      meta: {
        code: "AssetSizeJavaScript",
        name: "Prevent Large JavaScript bundles",
        docs: {
          description: "This check is aimed at preventing large JavaScript bundles for speed.",
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/asset-size-javascript",
          recommended: !1
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema,
        targets: []
      },
      create(context) {
        if (!context.fileSize)
          return {};
        let thresholdInBytes = context.settings.thresholdInBytes;
        async function checkRemoteAssetSize(url, position) {
          await (0, file_utils_1.hasRemoteAssetSizeExceededThreshold)(url, thresholdInBytes) && context.report({
            message: `JavaScript on every page load exceeds compressed size threshold (${thresholdInBytes} Bytes), consider using the import on interaction pattern.`,
            startIndex: position.start,
            endIndex: position.end
          });
        }
        async function checkThemeAssetSize(srcValue, position) {
          await (0, file_utils_1.hasLocalAssetSizeExceededThreshold)(context, `assets/${srcValue}`, thresholdInBytes) && context.report({
            message: `JavaScript on every page load exceeds compressed size threshold (${thresholdInBytes} Bytes), consider using the import on interaction pattern.`,
            startIndex: position.start,
            endIndex: position.end
          });
        }
        return {
          async HtmlRawNode(node) {
            if (node.name !== "script")
              return;
            let src = node.attributes.filter(utils_2.isValuedHtmlAttribute).find((attr) => (0, utils_2.isAttr)(attr, "src"));
            if (src && src.value.length === 1) {
              if (isTextNode(src.value[0]) && /(https?:)?\/\//.test(src.value[0].value)) {
                let url = src.value[0].value;
                await checkRemoteAssetSize(url, src.attributePosition);
              }
              if (isLiquidVariableOutput(src.value[0]) && isLiquidVariable(src.value[0].markup) && isString2(src.value[0].markup.expression) && src.value[0].markup.filters.length === 1 && src.value[0].markup.filters[0].name === "asset_url") {
                let assetName = src.value[0].markup.expression.value;
                await checkThemeAssetSize(assetName, src.attributePosition);
              }
            }
          },
          async LiquidFilter(node, ancestors) {
            if (node.name !== "script_tag")
              return;
            let liquidVariableParent = (0, utils_1.last)(ancestors);
            if (!(!liquidVariableParent || !(0, utils_2.isNodeOfType)(liquid_html_parser_1.NodeTypes.LiquidVariable, liquidVariableParent)) && liquidVariableParent.expression.type === liquid_html_parser_1.NodeTypes.String) {
              if (liquidVariableParent.expression.value[0].length == 1 && liquidVariableParent.filters.length == 1 && /(https?:)?\/\//.test(liquidVariableParent.expression.value)) {
                let url = liquidVariableParent.expression.value;
                await checkRemoteAssetSize(url, liquidVariableParent.expression.position);
              }
              if (liquidVariableParent.expression.value[0].length == 1 && liquidVariableParent.filters.length == 2 && liquidVariableParent.filters[0].name === "asset_url" && liquidVariableParent.filters[1].name === "script_tag") {
                let js = liquidVariableParent.expression.value;
                await checkThemeAssetSize(js, liquidVariableParent.position);
              }
            }
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/cdn-preconnect/index.js
var require_cdn_preconnect = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/cdn-preconnect/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.CdnPreconnect = void 0;
    var types_1 = require_types2(), utils_1 = require_utils4();
    exports.CdnPreconnect = {
      meta: {
        code: "CdnPreconnect",
        name: "CDN Preconnect",
        docs: {
          description: "This check is aimed at signaling the redundant preconnect to Shopify's CDN",
          recommended: !0,
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/cdn-preconnect"
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema: {},
        targets: []
      },
      create(context) {
        return {
          async HtmlVoidElement(node) {
            node.name !== "link" || !node.attributes.filter(utils_1.isValuedHtmlAttribute).some((attr) => (0, utils_1.isAttr)(attr, "rel") && (0, utils_1.valueIncludes)(attr, "preconnect")) || !node.attributes.filter(utils_1.isValuedHtmlAttribute).some((attr) => (0, utils_1.isAttr)(attr, "href") && (0, utils_1.valueIncludes)(attr, ".+cdn.shopify.com.+")) || context.report({
              message: "Preconnecting to cdn.shopify.com is unnecessary and can lead to worse performance",
              startIndex: node.position.start,
              endIndex: node.position.end
            });
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/content-for-header-modification/index.js
var require_content_for_header_modification = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/content-for-header-modification/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ContentForHeaderModification = void 0;
    var liquid_html_parser_1 = require_dist(), types_1 = require_types2(), utils_1 = require_utils4();
    function isLiquidTagAssign(node) {
      return node.name === "assign" && typeof node.markup != "string";
    }
    function isLiquidTagCapture(node) {
      return node.name === "capture" && typeof node.markup != "string";
    }
    function isLiquidTagEcho(node) {
      return node.name === "echo" && typeof node.markup != "string";
    }
    exports.ContentForHeaderModification = {
      meta: {
        code: "ContentForHeaderModification",
        name: "Do not depend on the content of content_for_header",
        docs: {
          description: "Do not rely on the content of content_for_header as it might change in the future, which could cause your Liquid code behavior to change.",
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/content-for-header-modification",
          recommended: !0
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema: {},
        targets: []
      },
      create(context) {
        function checkContentForHeader(node, position) {
          (0, utils_1.isNodeOfType)(liquid_html_parser_1.NodeTypes.VariableLookup, node) && node.name === "content_for_header" && context.report({
            message: "Do not rely on the content of `content_for_header`",
            startIndex: position.start,
            endIndex: position.end
          });
        }
        return {
          async LiquidTag(node) {
            if (isLiquidTagAssign(node))
              checkContentForHeader(node.markup.value.expression, node.position);
            else if (isLiquidTagEcho(node))
              checkContentForHeader(node.markup.expression, node.position);
            else if (isLiquidTagCapture(node) && node.children)
              for (let child of node.children)
                child.type === liquid_html_parser_1.NodeTypes.LiquidVariableOutput && typeof child.markup != "string" && checkContentForHeader(child.markup.expression, child.position);
          },
          async LiquidVariableOutput(node) {
            typeof node.markup != "string" && node.markup.filters.length && checkContentForHeader(node.markup.expression, node.position);
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/deprecate-bgsizes/index.js
var require_deprecate_bgsizes = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/deprecate-bgsizes/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.DeprecateBgsizes = void 0;
    var types_1 = require_types2(), utils_1 = require_utils4();
    exports.DeprecateBgsizes = {
      meta: {
        code: "DeprecateBgsizes",
        name: "Deprecate Bgsizes",
        docs: {
          description: "This check is aimed at discouraging the use of the lazySizes bgset plugin.",
          recommended: !0,
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/deprecate-bgsizes"
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.WARNING,
        schema: {},
        targets: []
      },
      create(context) {
        return {
          async HtmlElement(node) {
            let classAttributeWithLazyload = node.attributes.filter(utils_1.isValuedHtmlAttribute).find((attr) => (0, utils_1.isAttr)(attr, "class") && (0, utils_1.valueIncludes)(attr, "lazyload"));
            if (classAttributeWithLazyload) {
              let attr = classAttributeWithLazyload;
              context.report({
                message: 'Use the native loading="lazy" attribute instead of lazysizes',
                startIndex: attr.attributePosition.start,
                endIndex: attr.attributePosition.end
              });
            }
            let dataBgsetAttr = node.attributes.find((attr) => (0, utils_1.isValuedHtmlAttribute)(attr) && (0, utils_1.isAttr)(attr, "data-bgset"));
            dataBgsetAttr && context.report({
              message: "Use the CSS imageset attribute instead of data-bgset",
              startIndex: dataBgsetAttr.position.start,
              endIndex: dataBgsetAttr.position.end
            });
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/deprecate-lazysizes/index.js
var require_deprecate_lazysizes = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/deprecate-lazysizes/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.DeprecateLazysizes = void 0;
    var types_1 = require_types2(), utils_1 = require_utils4();
    function showsLazysizesUsage(attr) {
      return (0, utils_1.isAttr)(attr, "data-srcset") || (0, utils_1.isAttr)(attr, "data-sizes");
    }
    exports.DeprecateLazysizes = {
      meta: {
        code: "DeprecateLazysizes",
        name: "Deprecate Lazysizes",
        docs: {
          description: "This check is aimed at discouraging the use of the lazysizes JavaScript library",
          recommended: !0,
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/deprecate-lazysizes"
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.WARNING,
        schema: {},
        targets: []
      },
      create(context) {
        return {
          async HtmlVoidElement(node) {
            if (node.name !== "img")
              return;
            let attributes = node.attributes.filter(utils_1.isHtmlAttribute), hasSrc = attributes.some((attr) => (0, utils_1.isAttr)(attr, "src")), hasNativeLoading = attributes.some((attr) => (0, utils_1.isAttr)(attr, "loading"));
            hasSrc && hasNativeLoading || !node.attributes.filter(utils_1.isValuedHtmlAttribute).some((attr) => (0, utils_1.isAttr)(attr, "class") && (0, utils_1.valueIncludes)(attr, "lazyload")) || !node.attributes.filter(utils_1.isValuedHtmlAttribute).some(showsLazysizesUsage) || context.report({
              message: 'Use the native loading="lazy" attribute instead of lazysizes',
              startIndex: node.position.start,
              endIndex: node.position.end
            });
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/deprecated-filter/fixes.js
var require_fixes2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/deprecated-filter/fixes.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.suggestImageUrlFix = exports.suggestImgUrlFix = exports.suggestImgTagFix = exports.fixHexToRgba = void 0;
    var liquid_html_parser_1 = require_dist(), utils_1 = require_utils4(), MAX_SIZE = 5760, NAMED_SIZES = {
      pico: 16,
      icon: 32,
      thumb: 50,
      small: 100,
      compact: 160,
      medium: 240,
      large: 480,
      grande: 600,
      original: 1024
    };
    function fixHexToRgba(node) {
      if (node.args.length > 1)
        return;
      let { start, end } = getFilterSourceStartAndEnd(node), alpha = getExpressionArgumentValue(node, 0), fixedFilter;
      return alpha ? fixedFilter = ` color_to_rgb | color_modify: 'alpha', ${alpha}` : fixedFilter = " color_to_rgb", (corrector) => corrector.replace(start, end, fixedFilter);
    }
    exports.fixHexToRgba = fixHexToRgba;
    function suggestImgTagFix(node) {
      let message = "Replace 'img_tag' with 'image_tag'.", alt = getExpressionArgumentValue(node, 0), cssClass = getExpressionArgumentValue(node, 1), sizeStr = getExpressionArgumentValue(node, 2), { width, height } = getImageSize(sizeStr, { width: -1, height: -1 }), { start, end } = getFilterSourceStartAndEnd(node), imageUrlParameters = ensureImageValue({ width, height }), imageTagParameters = {
        width,
        height,
        alt: strValue(alt),
        class: strValue(cssClass)
      }, imageUrlFilter = buildFilterString("image_url", imageUrlParameters), imageTagFilter = buildFilterString("image_tag", imageTagParameters);
      return [
        {
          message,
          fix: (corrector) => {
            let insert2 = `${imageUrlFilter} |${imageTagFilter}`;
            corrector.replace(start, end, insert2);
          }
        }
      ];
    }
    exports.suggestImgTagFix = suggestImgTagFix;
    function suggestImgUrlFix(node) {
      let message = "Replace 'img_url' with 'image_url'.", cropNode = getNamedArgumentNode(node, "crop"), formatNode = getNamedArgumentNode(node, "format"), scaleNode = getNamedArgumentNode(node, "scale"), sizeStr = getExpressionArgumentValue(node, 0), sizeNode = node.args.at(0);
      if (isVariableLookup(scaleNode?.value) || isVariableLookup(sizeNode))
        return;
      let { width, height } = ensureImageValue(scaleImage(node, getImageSize(sizeStr))), { start, end } = getFilterSourceStartAndEnd(node), parameters = { width, height };
      return isStringLiteral(cropNode?.value) && (parameters.crop = strValue(cropNode.value.value)), isStringLiteral(formatNode?.value) && (parameters.format = strValue(formatNode.value.value)), isVariableLookup(formatNode?.value) && (parameters.format = formatNode.value.name), [
        {
          message,
          fix: (corrector) => {
            let insert2 = buildFilterString("image_url", parameters);
            corrector.replace(start, end, insert2);
          }
        }
      ];
    }
    exports.suggestImgUrlFix = suggestImgUrlFix;
    function suggestImageUrlFix(filter, node) {
      let message = `Replace '${filter}' with 'image_url'.`, sizeStr = getExpressionArgumentValue(node, 0), { width, height } = ensureImageValue(getImageSize(sizeStr)), { start, end } = getFilterSourceStartAndEnd(node);
      return [
        {
          message,
          fix: (corrector) => {
            let insert2 = buildFilterString("image_url", { width, height });
            corrector.replace(start, end, insert2);
          }
        }
      ];
    }
    exports.suggestImageUrlFix = suggestImageUrlFix;
    function getImageSize(size, imageSize = { width: 100, height: 100 }) {
      if (!size)
        return { ...imageSize };
      if (size in NAMED_SIZES) {
        let s = NAMED_SIZES[size];
        return { width: s, height: s };
      }
      let [width, height] = size.split("x").map((s) => parseInt(s));
      return ensureImageSizeLimit({ width, height });
    }
    function scaleImage(node, imageSize) {
      let scale = parseInt(getNamedArgumentValue(node, "scale") || "0") || 1;
      return ensureImageSizeLimit({
        width: imageSize.width * scale,
        height: imageSize.height * scale
      });
    }
    function ensureImageSizeLimit(imageSize) {
      return {
        width: Math.min(imageSize.width, MAX_SIZE),
        height: Math.min(imageSize.height, MAX_SIZE)
      };
    }
    function ensureImageValue(imageSize) {
      let { width, height } = imageSize;
      return (!height || height === -1) && (!width || width === -1) && (width = 100), { width, height };
    }
    function getExpressionArgumentValue(node, index) {
      let arg = node.args.at(index);
      if (isNumberLiteral(arg) || isStringLiteral(arg))
        return arg.value;
    }
    function getNamedArgumentValue(node, propertyName) {
      let argumentNode = getNamedArgumentNode(node, propertyName), valueNode = argumentNode?.value;
      if (isNumberLiteral(valueNode) || isStringLiteral(valueNode))
        return valueNode.value;
    }
    function getNamedArgumentNode(node, argName) {
      return node.args.find((arg) => (0, utils_1.isNodeOfType)(liquid_html_parser_1.NodeTypes.NamedArgument, arg) && arg.name === argName);
    }
    function buildFilterString(filter, filterParameters) {
      let parameters = Object.entries(filterParameters).filter(([_key, value]) => value && value !== -1).map(([key, value]) => `${key}: ${value}`).join(", ");
      return parameters ? ` ${filter}: ${parameters}` : ` ${filter}`;
    }
    function getFilterSourceStartAndEnd(node) {
      let position = node.position, pipePosition = node.source.slice(position.start).indexOf("|");
      return {
        start: position.start + pipePosition + 1,
        end: position.end
      };
    }
    function strValue(value) {
      return value ? `'${value}'` : null;
    }
    function isVariableLookup(exp) {
      return (0, utils_1.isNodeOfType)(liquid_html_parser_1.NodeTypes.VariableLookup, exp);
    }
    function isStringLiteral(exp) {
      return (0, utils_1.isNodeOfType)(liquid_html_parser_1.NodeTypes.String, exp);
    }
    function isNumberLiteral(exp) {
      return (0, utils_1.isNodeOfType)(liquid_html_parser_1.NodeTypes.Number, exp);
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/deprecated-filter/index.js
var require_deprecated_filter = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/deprecated-filter/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.DeprecatedFilter = void 0;
    var types_1 = require_types2(), fixes_1 = require_fixes2();
    exports.DeprecatedFilter = {
      meta: {
        code: "DeprecatedFilter",
        aliases: ["DeprecatedFilters"],
        name: "Deprecated Filter",
        docs: {
          description: "Discourages using deprecated filters in themes.",
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/deprecated-filter",
          recommended: !0
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.WARNING,
        schema: {},
        targets: []
      },
      create(context) {
        return context.themeDocset ? {
          LiquidFilter: async (node) => {
            let filters = await context.themeDocset.filters(), deprecatedFilter = filters.find((f) => f.deprecated && f.name === node.name);
            if (!deprecatedFilter)
              return;
            let recommendedFilterName = findRecommendedAlternative(deprecatedFilter), recommendedFilter = filters.find((f) => f.name === recommendedFilterName), message = deprecatedFilterMessage(deprecatedFilter, recommendedFilter), suggest = deprecatedFilterSuggestion(node), fix = deprecatedFilterFix(node);
            context.report({
              message,
              suggest,
              fix,
              startIndex: node.position.start + 1,
              endIndex: node.position.end
            });
          }
        } : {};
      }
    };
    function deprecatedFilterSuggestion(node) {
      let filter = node.name;
      switch (filter) {
        case "img_tag":
          return (0, fixes_1.suggestImgTagFix)(node);
        case "img_url":
          return (0, fixes_1.suggestImgUrlFix)(node);
        case "article_img_url":
        case "collection_img_url":
        case "product_img_url":
          return (0, fixes_1.suggestImageUrlFix)(filter, node);
        case "currency_selector":
          return;
      }
    }
    function deprecatedFilterFix(node) {
      if (node.name === "hex_to_rgba")
        return (0, fixes_1.fixHexToRgba)(node);
    }
    function deprecatedFilterMessage(deprecated2, recommended) {
      return recommended ? `Deprecated filter '${deprecated2.name}', consider using '${recommended.name}'.` : `Deprecated filter '${deprecated2.name}'.`;
    }
    function findRecommendedAlternative(deprecatedFilter) {
      let reason = deprecatedFilter.deprecation_reason, match2 = reason?.match(/replaced by \[`(.+?)`\]/);
      return match2?.[1];
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/deprecated-tag/index.js
var require_deprecated_tag = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/deprecated-tag/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.DeprecatedTag = void 0;
    var types_1 = require_types2();
    exports.DeprecatedTag = {
      meta: {
        code: "DeprecatedTag",
        aliases: ["DeprecatedTags"],
        name: "Deprecated Tag",
        docs: {
          description: "This check is aimed at eliminating the use of deprecated tags.",
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/deprecated-tag",
          recommended: !0
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.WARNING,
        schema: {},
        targets: []
      },
      create(context) {
        return {
          async LiquidTag(node) {
            if (node.name === "include") {
              let includeStartIndex = node.source.substring(node.position.start).indexOf("include"), includeEndIndex = includeStartIndex + 7, includeStart = node.position.start + includeStartIndex, includeEnd = node.position.start + includeEndIndex;
              context.report({
                message: "Use the 'render' tag instead of 'include'",
                startIndex: includeStart,
                endIndex: includeEnd,
                suggest: [
                  {
                    message: "Replace 'include' with 'render'",
                    fix: (corrector) => {
                      corrector.replace(includeStart, includeEnd, "render");
                    }
                  }
                ]
              });
            }
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/img-width-and-height/index.js
var require_img_width_and_height = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/img-width-and-height/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ImgWidthAndHeight = void 0;
    var types_1 = require_types2(), utils_1 = require_utils4();
    exports.ImgWidthAndHeight = {
      meta: {
        code: "ImgWidthAndHeight",
        name: "Width and height attributes on image tags",
        docs: {
          description: "This check is aimed at eliminating content layout shift in themes by enforcing the use of the width and height attributes on img tags.",
          recommended: !0,
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/img-width-and-height"
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema: {},
        targets: []
      },
      create(context) {
        return {
          async HtmlVoidElement(node) {
            if (node.name === "img") {
              let widthAttr = node.attributes.find((attr) => (0, utils_1.isValuedHtmlAttribute)(attr) && (0, utils_1.isAttr)(attr, "width")), heightAttr = node.attributes.find((attr) => (0, utils_1.isValuedHtmlAttribute)(attr) && (0, utils_1.isAttr)(attr, "height")), missingAttributes = [];
              if (widthAttr || missingAttributes.push("width"), heightAttr || missingAttributes.push("height"), missingAttributes.length > 0) {
                let attributeWord = missingAttributes.length === 1 ? "attribute" : "attributes";
                context.report({
                  message: `Missing ${missingAttributes.join(" and ")} ${attributeWord} on img tag`,
                  startIndex: node.position.start,
                  endIndex: node.position.end
                });
              }
            }
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/json-syntax-error/index.js
var require_json_syntax_error = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/json-syntax-error/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.JSONSyntaxError = void 0;
    var types_1 = require_types2(), utils_1 = require_utils2();
    function cleanErrorMessage(error) {
      return ("rawMessage" in error ? error.rawMessage : error.message).replace(/\s+at \d+:\d+/, "");
    }
    exports.JSONSyntaxError = {
      meta: {
        code: "JSONSyntaxError",
        name: "Enforce valid JSON",
        docs: {
          description: "This check exists to prevent invalid JSON files in themes.",
          recommended: !0,
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/valid-json"
        },
        type: types_1.SourceCodeType.JSON,
        severity: types_1.Severity.ERROR,
        schema: {},
        targets: [],
        deprecated: !0
      },
      create(context) {
        if (context.validateJSON)
          return {};
        let error = context.file.ast;
        return (0, utils_1.isError)(error) ? {
          async onCodePathStart(file) {
            if ("line" in error && typeof error.line == "number" && "column" in error && typeof error.column == "number") {
              let { line, column } = error, startIndex = (0, utils_1.getOffset)(file.source, line, column), endIndex = (0, utils_1.getOffset)(file.source, line, column) + 1;
              context.report({
                message: cleanErrorMessage(error),
                startIndex,
                endIndex
              });
            } else
              context.report({
                message: cleanErrorMessage(error),
                startIndex: 0,
                endIndex: file.source.length
              });
          }
        } : {};
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/liquid-html-syntax-error/index.js
var require_liquid_html_syntax_error = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/liquid-html-syntax-error/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.LiquidHTMLSyntaxError = void 0;
    var types_1 = require_types2(), utils_1 = require_utils2();
    function isParsingErrorWithLocation(error) {
      return "name" in error && error.name === "LiquidHTMLParsingError" && "loc" in error;
    }
    function cleanErrorMessage(message, highlight) {
      return message.replace(/Line \d+, col \d+:\s+/, "SyntaxError: ").replace(/(?!<expected ".+",) not .*/, ` not "${highlight}"`);
    }
    exports.LiquidHTMLSyntaxError = {
      meta: {
        code: "LiquidHTMLSyntaxError",
        aliases: ["SyntaxError", "HtmlParsingError"],
        name: "Prevent LiquidHTML Syntax Errors",
        docs: {
          description: "This check exists to inform the user of Liquid HTML syntax errors.",
          recommended: !0
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema: {},
        targets: []
      },
      create(context) {
        let error = context.file.ast;
        return (0, utils_1.isError)(error) ? {
          async onCodePathStart(file) {
            if (isParsingErrorWithLocation(error)) {
              let { start, end } = error.loc, startIndex = (0, utils_1.getOffset)(file.source, start.line, start.column), endIndex = (0, utils_1.getOffset)(file.source, end.line, end.column);
              startIndex === endIndex && (endIndex += 1);
              let highlight = file.source.slice(startIndex, endIndex);
              context.report({
                message: cleanErrorMessage(error.message, highlight),
                startIndex,
                endIndex
              });
            } else
              context.report({
                message: error.message,
                startIndex: 0,
                endIndex: file.source.length
              });
          }
        } : {};
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/matching-translations/index.js
var require_matching_translations = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/matching-translations/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.MatchingTranslations = void 0;
    var types_1 = require_types2(), PLURALIZATION_KEYS = /* @__PURE__ */ new Set(["zero", "one", "two", "few", "many", "other"]);
    exports.MatchingTranslations = {
      meta: {
        code: "MatchingTranslations",
        name: "Translation files should have the same keys",
        docs: {
          description: "TODO",
          recommended: !0,
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/matching-translations"
        },
        type: types_1.SourceCodeType.JSON,
        severity: types_1.Severity.ERROR,
        schema: {},
        targets: []
      },
      create(context) {
        let defaultTranslations = /* @__PURE__ */ new Set(), missingTranslations = /* @__PURE__ */ new Set(), nodesByPath = /* @__PURE__ */ new Map(), file = context.file, absolutePath = file.absolutePath, relativePath2 = context.relativePath(absolutePath), ast = file.ast, isLocaleFile = relativePath2.startsWith("locales/"), isDefaultTranslationsFile = absolutePath.endsWith(".default.json") || absolutePath.endsWith(".default.schema.json"), isSchemaTranslationFile = absolutePath.endsWith(".schema.json");
        if (!isLocaleFile || isDefaultTranslationsFile || ast instanceof Error)
          return {};
        let hasDefaultTranslations = () => defaultTranslations.size > 0, isTerminalNode = ({ type }) => type === "Literal", isPluralizationNode = (node) => PLURALIZATION_KEYS.has(node.key.value), isShopifyPath = (path3) => path3.startsWith("shopify."), hasDefaultTranslation = (translationPath) => {
          var _a38;
          return (_a38 = defaultTranslations.has(translationPath)) !== null && _a38 !== void 0 ? _a38 : !1;
        }, isPluralizationPath = (path3) => [...PLURALIZATION_KEYS].some((key) => path3.endsWith(key)), jsonPaths = (json) => Object.keys(json).reduce((acc, key) => {
          if (typeof json[key] != "object")
            return acc.concat(key);
          let childJson = json[key], childPaths = jsonPaths(childJson);
          return acc.concat(childPaths.map((path3) => `${key}.${path3}`));
        }, []), objectPath = (nodes) => nodes.filter((node) => node.type === "Property").reduce((acc, val) => acc.concat(val.key.value), []).join("."), countCommonParts = (arrayA, arrayB) => {
          let minLength = Math.min(arrayA.length, arrayB.length);
          for (let i = 0; i < minLength; i++)
            if (arrayA[i] !== arrayB[i])
              return i;
          return minLength;
        }, closestTranslationKey = (translationKey) => {
          var _a38;
          let translationKeyParts = translationKey.split("."), closestMatch = "", maxCommonParts = 0;
          for (let path3 of nodesByPath.keys()) {
            let pathParts = path3.split("."), commonParts = countCommonParts(pathParts, translationKeyParts);
            commonParts > maxCommonParts && (maxCommonParts = commonParts, closestMatch = path3);
          }
          return (_a38 = nodesByPath.get(closestMatch)) !== null && _a38 !== void 0 ? _a38 : ast;
        };
        return {
          async onCodePathStart() {
            let defaultTranslationPaths = await (isSchemaTranslationFile ? context.getDefaultSchemaTranslations : context.getDefaultTranslations)().then(jsonPaths);
            defaultTranslationPaths.forEach(Set.prototype.add, defaultTranslations), defaultTranslationPaths.forEach(Set.prototype.add, missingTranslations);
          },
          async Property(node, ancestors) {
            let path3 = objectPath(ancestors.concat(node));
            if (nodesByPath.set(path3, node), !!hasDefaultTranslations() && !isPluralizationNode(node) && isTerminalNode(node.value) && !isShopifyPath(path3)) {
              if (hasDefaultTranslation(path3)) {
                missingTranslations.delete(path3);
                return;
              }
              context.report({
                message: `A default translation for '${path3}' does not exist`,
                startIndex: node.loc.start.offset,
                endIndex: node.loc.end.offset,
                suggest: [
                  {
                    message: "Delete unneeded translation key",
                    fix(corrector) {
                      corrector.remove(path3);
                    }
                  }
                ]
              });
            }
          },
          async onCodePathEnd() {
            missingTranslations.forEach((path3) => {
              let closest = closestTranslationKey(path3);
              isPluralizationPath(path3) || isShopifyPath(path3) || context.report({
                message: `The translation for '${path3}' is missing`,
                startIndex: closest.loc.start.offset,
                endIndex: closest.loc.end.offset,
                fix(corrector) {
                  corrector.add(path3, "TODO");
                }
              });
            });
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/missing-asset/index.js
var require_missing_asset = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/missing-asset/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.MissingAsset = void 0;
    var types_1 = require_types2(), file_utils_1 = require_file_utils(), utils_1 = require_utils4();
    exports.MissingAsset = {
      meta: {
        code: "MissingAsset",
        name: "Avoid rendering missing asset files",
        docs: {
          description: "Reports missing asset files",
          recommended: !0,
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/missing-asset"
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema: {},
        targets: []
      },
      create(context) {
        return {
          async LiquidVariable(node) {
            if (node.filters.length === 0 || node.filters[0].name !== "asset_url" || !(0, utils_1.isLiquidString)(node.expression))
              return;
            let expression = node.expression, originalAssetPath = `assets/${expression.value}`, assetPath = originalAssetPath, fileExists3 = await (0, file_utils_1.doesFileExist)(context, assetPath);
            fileExists3 || assetPath.endsWith(".scss.css") && (assetPath = assetPath.replace(".scss.css", ".scss.liquid"), fileExists3 = await (0, file_utils_1.doesFileExist)(context, assetPath), fileExists3) || (assetPath.endsWith(".js") || assetPath.endsWith(".css")) && (assetPath += ".liquid", fileExists3 = await (0, file_utils_1.doesFileExist)(context, assetPath), fileExists3) || context.report({
              message: `'${originalAssetPath}' does not exist`,
              startIndex: expression.position.start,
              endIndex: expression.position.end
            });
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/missing-template/index.js
var require_missing_template = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/missing-template/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.MissingTemplate = void 0;
    var liquid_html_parser_1 = require_dist(), minimatch_1 = require_cjs(), types_1 = require_types2(), file_utils_1 = require_file_utils(), schema = {
      ignoreMissing: types_1.SchemaProp.array(types_1.SchemaProp.string(), [])
    };
    exports.MissingTemplate = {
      meta: {
        code: "MissingTemplate",
        name: "Avoid rendering missing templates",
        docs: {
          description: "Reports missing include/render/section liquid file",
          recommended: !0,
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/missing-template"
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema,
        targets: []
      },
      create(context) {
        let isNamedLiquidTag = (tag) => typeof tag.markup != "string";
        function isIgnored(relativePath2) {
          return context.settings.ignoreMissing.some((pattern) => (0, minimatch_1.minimatch)(relativePath2, pattern));
        }
        async function maybeReportMissing(relativePath2, { position }) {
          await (0, file_utils_1.doesFileExist)(context, relativePath2) || isIgnored(relativePath2) || context.report({
            message: `'${relativePath2}' does not exist`,
            startIndex: position.start,
            endIndex: position.end
          });
        }
        return {
          async RenderMarkup(node) {
            if (node.snippet.type === liquid_html_parser_1.NodeTypes.VariableLookup)
              return;
            let snippet = node.snippet, relativePath2 = `snippets/${snippet.value}.liquid`;
            await maybeReportMissing(relativePath2, snippet);
          },
          async LiquidTag(node) {
            if (!isNamedLiquidTag(node) || node.name !== liquid_html_parser_1.NamedTags.section)
              return;
            let markup = node.markup, relativePath2 = `sections/${markup.value}.liquid`;
            await maybeReportMissing(relativePath2, markup);
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/pagination-size/index.js
var require_pagination_size = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/pagination-size/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.PaginationSize = void 0;
    var liquid_html_parser_1 = require_dist(), types_1 = require_types2(), utils_1 = require_utils2(), utils_2 = require_utils4(), json_1 = require_json2(), schema = {
      minSize: types_1.SchemaProp.number(1),
      maxSize: types_1.SchemaProp.number(50)
    };
    exports.PaginationSize = {
      meta: {
        code: "PaginationSize",
        name: "Ensure paginate tags are used with performant sizes",
        docs: {
          description: "This check is aimed at keeping response times low.",
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/pagination-size",
          recommended: !0
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.WARNING,
        schema,
        targets: []
      },
      create(context) {
        let minSize = context.settings.minSize, maxSize = context.settings.maxSize, schemaSettings = [], pageSizeLookups = [];
        function checkPageSize(pageSizeNode, value, message = `Pagination size must be a positive integer between ${minSize} and ${maxSize}.`) {
          minSize <= value && value <= maxSize || context.report({
            message,
            startIndex: pageSizeNode.position.start,
            endIndex: pageSizeNode.position.end
          });
        }
        return {
          async LiquidTag(node) {
            if (typeof node.markup == "string" || node.name !== "paginate")
              return;
            let pageSizeNode = node.markup.pageSize;
            (0, utils_2.isNodeOfType)(liquid_html_parser_1.NodeTypes.VariableLookup, pageSizeNode) ? pageSizeLookups.push(pageSizeNode) : (0, utils_2.isNodeOfType)(liquid_html_parser_1.NodeTypes.Number, pageSizeNode) && checkPageSize(pageSizeNode, Number(pageSizeNode.value));
          },
          async LiquidRawTag(node) {
            if (node.name === "schema") {
              let schema2 = (0, json_1.parseJSON)(node.body.value);
              if ((0, utils_1.isError)(schema2))
                return;
              schema2.settings && Array.isArray(schema2.settings) && (schemaSettings = schema2.settings);
            }
          },
          async onCodePathEnd() {
            pageSizeLookups.forEach((pageSizeVariableLookup) => {
              let lastLookup = (0, utils_1.last)(pageSizeVariableLookup.lookups);
              if (lastLookup === void 0 || lastLookup.type !== liquid_html_parser_1.NodeTypes.String)
                return;
              let settingId = lastLookup.value, setting = schemaSettings.find((setting2) => setting2.id === settingId);
              if (setting !== void 0) {
                if (setting.default === void 0) {
                  context.report({
                    message: "Default pagination size should be defined in the section settings.",
                    startIndex: pageSizeVariableLookup.position.start,
                    endIndex: pageSizeVariableLookup.position.end
                  });
                  return;
                }
                checkPageSize(pageSizeVariableLookup, setting.default, `This setting's default value should be between ${minSize} and ${maxSize} but is currently ${setting.default}.`);
              }
            });
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/parser-blocking-script/suggestions.js
var require_suggestions = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/parser-blocking-script/suggestions.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.scriptTagSuggestion = exports.liquidFilterSuggestion = void 0;
    var utils_1 = require_utils2(), suggestionMessage = (attr) => `Use an HTML script tag with the ${attr} attribute instead`, liquidFilterSuggestion = (attr, node, parentNode, grandParentNode) => ({
      message: suggestionMessage(attr),
      fix(corrector) {
        var _a38, _b;
        let url = `{{ ${node.source.slice(parentNode.expression.position.start, (_b = (_a38 = (0, utils_1.last)(parentNode.filters, -1)) === null || _a38 === void 0 ? void 0 : _a38.position.end) !== null && _b !== void 0 ? _b : node.position.start)} }}`;
        corrector.replace(grandParentNode.position.start, grandParentNode.position.end, `<script src="${url}" ${attr}></script>`);
      }
    });
    exports.liquidFilterSuggestion = liquidFilterSuggestion;
    var scriptTagSuggestion = (attr, node) => ({
      message: suggestionMessage(attr),
      fix(corrector) {
        corrector.insert(node.blockStartPosition.end - 1, ` ${attr}`);
      }
    });
    exports.scriptTagSuggestion = scriptTagSuggestion;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/parser-blocking-script/index.js
var require_parser_blocking_script = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/parser-blocking-script/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ParserBlockingScript = void 0;
    var liquid_html_parser_1 = require_dist(), types_1 = require_types2(), utils_1 = require_utils2(), utils_2 = require_utils4(), suggestions_1 = require_suggestions();
    exports.ParserBlockingScript = {
      meta: {
        code: "ParserBlockingScript",
        aliases: ["ParserBlockingScriptTag"],
        name: "Avoid parser blocking scripts",
        docs: {
          description: "They are bad ok?",
          recommended: !0,
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/parser-blocking-javascript"
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema: {},
        targets: []
      },
      create(context) {
        return {
          // {{ 'asset' | asset_url | script_tag }}
          LiquidFilter: async (node, ancestors) => {
            if (node.name !== "script_tag")
              return;
            let offset = node.source.slice(node.position.start, node.position.end).indexOf("script_tag"), parentNode = (0, utils_1.last)(ancestors), grandParentNode = (0, utils_1.last)(ancestors, -1);
            context.report({
              message: "The script_tag filter is parser-blocking. Use a <script> tag with async or defer for better performance",
              startIndex: node.position.start + offset,
              endIndex: node.position.end,
              suggest: grandParentNode && grandParentNode.type === liquid_html_parser_1.NodeTypes.LiquidVariableOutput && parentNode && parentNode.type === liquid_html_parser_1.NodeTypes.LiquidVariable && (0, utils_1.last)(parentNode.filters) === node ? [
                (0, suggestions_1.liquidFilterSuggestion)("defer", node, parentNode, grandParentNode),
                (0, suggestions_1.liquidFilterSuggestion)("async", node, parentNode, grandParentNode)
              ] : void 0
            });
          },
          // <script src="...">
          HtmlRawNode: async (node) => {
            if (node.name !== "script" || !node.attributes.filter(utils_2.isValuedHtmlAttribute).some((attr) => (0, utils_2.isAttr)(attr, "src")))
              return;
            let hasDeferOrAsync = node.attributes.filter(utils_2.isHtmlAttribute).some((attr) => (0, utils_2.isAttr)(attr, "async") || (0, utils_2.isAttr)(attr, "defer")), isTypeModule = node.attributes.filter(utils_2.isValuedHtmlAttribute).some((attr) => (0, utils_2.isAttr)(attr, "type") && ((0, utils_2.hasAttributeValueOf)(attr, "module") || (0, utils_2.hasAttributeValueOf)(attr, "importmap")));
            hasDeferOrAsync || isTypeModule || context.report({
              message: "Avoid parser blocking scripts by adding `defer` or `async` on this tag",
              startIndex: node.position.start,
              endIndex: node.position.end,
              suggest: [(0, suggestions_1.scriptTagSuggestion)("defer", node), (0, suggestions_1.scriptTagSuggestion)("async", node)]
            });
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/remote-asset/index.js
var require_remote_asset = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/remote-asset/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.RemoteAsset = void 0;
    var types_1 = require_types2(), utils_1 = require_utils4(), utils_2 = require_utils2(), RESOURCE_TAGS = ["img", "link", "source", "script"], SHOPIFY_CDN_DOMAINS = ["fonts.shopifycdn.com", "cdn.shopify.com"], TAGNAMES = ["stylesheet_tag", "script_tag", "image_tag", "img_tag"], DEPRECATED = ["product_img_url", "article_img_url", "collection_img_url", "img_url"], NON_DEPRECATED = [
      "asset_url",
      "image_url",
      "asset_img_url",
      "file_img_url",
      "file_url",
      "global_asset_url",
      "shopify_asset_url",
      "external_video_url",
      "font_url"
    ], LIQUID_OBJECT = "canonical_url";
    function isLiquidVariableOutput(node) {
      return node.type === types_1.LiquidHtmlNodeTypes.LiquidVariableOutput;
    }
    function isLiquidVariable(node) {
      return typeof node != "string" && node.type === types_1.LiquidHtmlNodeTypes.LiquidVariable;
    }
    function isUrlHostedbyShopify(url) {
      let urlObj = new URL(url);
      return SHOPIFY_CDN_DOMAINS.includes(urlObj.hostname);
    }
    function valueIsDefinitelyNotShopifyHosted(attr) {
      return attr.value.some((node) => {
        if (node.type === types_1.LiquidHtmlNodeTypes.TextNode && /^(https?:)?\/\//.test(node.value) && !isUrlHostedbyShopify(node.value))
          return !0;
        if (isLiquidVariableOutput(node)) {
          let variable = node.markup;
          if (isLiquidVariable(variable)) {
            let expression = variable.expression;
            if (expression.type === types_1.LiquidHtmlNodeTypes.String && /^https?:\/\//.test(expression.value) && !isUrlHostedbyShopify(expression.value))
              return !0;
          }
        }
        return !1;
      });
    }
    function valueIsShopifyHosted(attr) {
      let ASSET_URL_FILTER_NAMES = [...DEPRECATED, ...NON_DEPRECATED], ASSET_URL_OBJECT_NAMES = [LIQUID_OBJECT];
      return attr.value.some((node) => !isLiquidVariableOutput(node) || !isLiquidVariable(node.markup) ? !1 : !!(node.markup.filters.some((filter) => ASSET_URL_FILTER_NAMES.includes(filter.name)) || (0, utils_1.isNodeOfType)(types_1.LiquidHtmlNodeTypes.VariableLookup, node.markup.expression) && node.markup.expression.name && ASSET_URL_OBJECT_NAMES.includes(node.markup.expression.name)));
    }
    exports.RemoteAsset = {
      meta: {
        code: "RemoteAsset",
        aliases: ["AssetUrlFilters"],
        name: "Remote Asset",
        docs: {
          description: "This check is aimed at eliminating unnecessary HTTP connections.",
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/remote-asset",
          recommended: !0
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.WARNING,
        schema: {},
        targets: []
      },
      create(context) {
        function checkHtmlNode(node) {
          if (!RESOURCE_TAGS.includes(node.name))
            return;
          let urlAttribute = node.attributes.filter(utils_1.isValuedHtmlAttribute).find((attr) => (0, utils_1.isAttr)(attr, "src") || (0, utils_1.isAttr)(attr, "href"));
          if (!urlAttribute || urlAttribute.value.filter((node2) => node2.type === types_1.LiquidHtmlNodeTypes.TextNode).some((textNode) => isUrlHostedbyShopify(textNode.value)))
            return;
          if (valueIsDefinitelyNotShopifyHosted(urlAttribute)) {
            context.report({
              message: "Asset should be served by the Shopify CDN for better performance.",
              startIndex: urlAttribute.position.start,
              endIndex: urlAttribute.position.end
            });
            return;
          }
          valueIsShopifyHosted(urlAttribute) || context.report({
            message: "Use one of the asset_url filters to serve assets for better performance.",
            startIndex: urlAttribute.position.start,
            endIndex: urlAttribute.position.end
          });
        }
        function checkLiquidFilter(node, ancestors) {
          let tagName = node.name;
          if (!TAGNAMES.includes(tagName))
            return;
          let parentNode = (0, utils_2.last)(ancestors);
          if (!parentNode || !(0, utils_1.isNodeOfType)(types_1.LiquidHtmlNodeTypes.LiquidVariable, parentNode) || parentNode.filters.some((filter) => DEPRECATED.includes(filter.name) || NON_DEPRECATED.includes(filter.name)))
            return;
          let urlNode = parentNode.expression;
          urlNode.type === types_1.LiquidHtmlNodeTypes.String && !isUrlHostedbyShopify(urlNode.value) && context.report({
            message: "Asset should be served by the Shopify CDN for better performance.",
            startIndex: urlNode.position.start,
            endIndex: urlNode.position.end
          }), context.report({
            message: "Use one of the asset_url filters to serve assets for better performance.",
            startIndex: parentNode.expression.position.start,
            endIndex: node.position.end
          });
        }
        return {
          async HtmlVoidElement(node) {
            checkHtmlNode(node);
          },
          async HtmlRawNode(node) {
            checkHtmlNode(node);
          },
          async LiquidFilter(node, ancestors) {
            checkLiquidFilter(node, ancestors);
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/required-layout-theme-object/index.js
var require_required_layout_theme_object = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/required-layout-theme-object/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.RequiredLayoutThemeObject = void 0;
    var types_1 = require_types2(), utils_1 = require_utils4();
    exports.RequiredLayoutThemeObject = {
      meta: {
        code: "RequiredLayoutThemeObject",
        name: "Prevent missing required objects in theme.liquid",
        docs: {
          description: "This check prevents missing {{ content_for_header }} and {{ content_for_layout }} objects in layout/theme.liquid.",
          recommended: !0,
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/required-layout-theme-object"
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema: {},
        targets: [types_1.ConfigTarget.All, types_1.ConfigTarget.Recommended]
      },
      create(context) {
        if (context.relativePath(context.file.absolutePath) !== "layout/theme.liquid")
          return {};
        let requiredObjects = ["content_for_header", "content_for_layout"], foundObjects = /* @__PURE__ */ new Set(), headTag, bodyTag;
        function checkVariableUsage(node) {
          node.name && requiredObjects.includes(node.name) && foundObjects.add(node.name);
        }
        return {
          async VariableLookup(node) {
            checkVariableUsage(node);
          },
          async HtmlElement(node) {
            (0, utils_1.isHtmlTag)(node, "head") ? headTag = node : (0, utils_1.isHtmlTag)(node, "body") && (bodyTag = node);
          },
          async onCodePathEnd() {
            var _a38, _b;
            for (let requiredObject of requiredObjects)
              if (!foundObjects.has(requiredObject)) {
                let message = `The required object '{{ ${requiredObject} }}' is missing in layout/theme.liquid`, insertionNode = requiredObject === "content_for_header" ? headTag : bodyTag, fixInsertPosition = insertionNode?.blockEndPosition.start;
                context.report({
                  message,
                  startIndex: (_a38 = insertionNode?.position.start) !== null && _a38 !== void 0 ? _a38 : 0,
                  endIndex: (_b = insertionNode?.position.end) !== null && _b !== void 0 ? _b : 0,
                  fix: fixInsertPosition !== void 0 ? (corrector) => corrector.insert(fixInsertPosition, `{{ ${requiredObject} }}`) : void 0
                });
              }
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/translation-key-exists/index.js
var require_translation_key_exists = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/translation-key-exists/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.TranslationKeyExists = void 0;
    var json_1 = require_json2(), types_1 = require_types2(), utils_1 = require_utils2();
    function keyExists(key, pointer) {
      for (let token of key.split(".")) {
        if (typeof pointer != "object" || !pointer.hasOwnProperty(token))
          return !1;
        pointer = pointer[token];
      }
      return !0;
    }
    exports.TranslationKeyExists = {
      meta: {
        code: "TranslationKeyExists",
        name: "Reports missing translation keys",
        docs: {
          description: "Reports missing translation keys",
          recommended: !0,
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/translation-key-exists"
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema: {},
        targets: []
      },
      create(context) {
        let nodes = [], schemaLocales;
        return {
          async LiquidVariable(node) {
            node.expression.type === "String" && node.filters.some(({ name }) => ["t", "translate"].includes(name)) && nodes.push({
              translationKey: node.expression.value,
              startIndex: node.expression.position.start,
              endIndex: node.expression.position.end
            });
          },
          async LiquidRawTag(node) {
            var _a38;
            if (node.name !== "schema" || node.body.kind !== "json")
              return;
            let defaultLocale = await context.getDefaultLocale(), schema = (0, json_1.parseJSON)(node.body.value);
            (0, utils_1.isError)(schema) && schema instanceof SyntaxError || (schemaLocales = (_a38 = schema.locales) === null || _a38 === void 0 ? void 0 : _a38[defaultLocale]);
          },
          async onCodePathEnd() {
            var _a38;
            let defaultTranslations = await context.getDefaultTranslations(), defaultLocale = await context.getDefaultLocale(), systemTranslations = await ((_a38 = context.themeDocset) === null || _a38 === void 0 ? void 0 : _a38.systemTranslations()), systemTranslationsKeys = Object.keys(systemTranslations ?? {});
            !defaultTranslations && systemTranslationsKeys.length === 0 || nodes.forEach(({ translationKey, startIndex, endIndex }) => {
              if (keyExists(translationKey, defaultTranslations) || keyExists(translationKey, schemaLocales) || systemTranslationsKeys.includes(translationKey))
                return;
              let message = `'${translationKey}' does not have a matching entry in 'locales/${defaultLocale}.default.json'`;
              schemaLocales && (message += ` or '${context.relativePath(context.file.absolutePath)}'`), context.report({
                message,
                startIndex,
                endIndex
              });
            });
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/unclosed-html-element/index.js
var require_unclosed_html_element = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/unclosed-html-element/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.UnclosedHTMLElement = void 0;
    var liquid_html_parser_1 = require_dist(), types_1 = require_types2(), utils_1 = require_utils2(), utils_2 = require_utils4();
    exports.UnclosedHTMLElement = {
      meta: {
        code: "UnclosedHTMLElement",
        aliases: ["UnclosedHTMLElement"],
        name: "Unclosed HTML Element",
        docs: {
          description: "Warns you of unbalanced HTML tags in branching code",
          recommended: !0,
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/unclosed-html-element"
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.WARNING,
        schema: {},
        targets: []
      },
      create(context) {
        let stacksByGrandparent = /* @__PURE__ */ new Map();
        return {
          async HtmlElement(node, ancestors) {
            if (isClosed(node))
              return;
            let [branch, index] = (0, utils_1.findLastAndIndex)(ancestors, utils_2.isLiquidBranch);
            if (!branch)
              return;
            let parent = ancestors[index - 1], grandparent = ancestors[index - 2];
            if (!parent || !grandparent || parent.type !== liquid_html_parser_1.NodeTypes.LiquidTag)
              return;
            stacksByGrandparent.has(grandparent) || stacksByGrandparent.set(grandparent, {
              open: /* @__PURE__ */ new Map(),
              close: /* @__PURE__ */ new Map(),
              identifiers: /* @__PURE__ */ new Set()
            });
            let stacks = stacksByGrandparent.get(grandparent), identifier = getConditionIdentifier(branch, parent);
            stacks.identifiers.add(identifier), stacks.open.has(identifier) || stacks.open.set(identifier, []), stacks.open.get(identifier).push(node);
          },
          async HtmlDanglingMarkerClose(node, ancestors) {
            let [branch, index] = (0, utils_1.findLastAndIndex)(ancestors, utils_2.isLiquidBranch);
            if (!branch)
              return;
            let parent = ancestors[index - 1], grandparent = ancestors[index - 2];
            if (!parent || !grandparent || parent.type !== liquid_html_parser_1.NodeTypes.LiquidTag)
              return;
            stacksByGrandparent.has(grandparent) || stacksByGrandparent.set(grandparent, {
              open: /* @__PURE__ */ new Map(),
              close: /* @__PURE__ */ new Map(),
              identifiers: /* @__PURE__ */ new Set()
            });
            let stacks = stacksByGrandparent.get(grandparent), identifier = getConditionIdentifier(branch, parent);
            stacks.identifiers.add(identifier), stacks.close.has(identifier) || stacks.close.set(identifier, []), stacks.close.get(identifier).push(node);
          },
          async onCodePathEnd() {
            var _a38, _b;
            for (let [grandparent, stacks] of stacksByGrandparent)
              for (let identifier of stacks.identifiers) {
                let openNodes = (_a38 = stacks.open.get(identifier)) !== null && _a38 !== void 0 ? _a38 : [], closeNodes = (_b = stacks.close.get(identifier)) !== null && _b !== void 0 ? _b : [], nodes = [].concat(openNodes, closeNodes).sort((a, b) => a.position.start - b.position.start), stack = [];
                for (let node of nodes)
                  node.type === liquid_html_parser_1.NodeTypes.HtmlElement ? stack.push(node) : stack.length > 0 && getName2(node) === getName2(stack.at(-1)) && stack.at(-1).type === liquid_html_parser_1.NodeTypes.HtmlElement && node.type === liquid_html_parser_1.NodeTypes.HtmlDanglingMarkerClose ? stack.pop() : stack.push(node);
                for (let node of stack)
                  node.type === liquid_html_parser_1.NodeTypes.HtmlDanglingMarkerClose ? context.report({
                    message: `Closing tag does not have a matching opening tag for condition \`${identifier}\` in ${grandparent.type} '${getName2(grandparent)}'`,
                    startIndex: node.position.start,
                    endIndex: node.position.end
                  }) : context.report({
                    message: `Opening tag does not have a matching closing tag for condition \`${identifier}\` in ${grandparent.type} '${getName2(grandparent)}'`,
                    startIndex: node.blockStartPosition.start,
                    endIndex: node.blockStartPosition.end
                  });
              }
          }
        };
      }
    };
    function isClosed(node) {
      return node.blockEndPosition.start !== node.blockEndPosition.end;
    }
    function getConditionIdentifier(branch, parent) {
      if (branch.name === null)
        switch (parent.name) {
          case liquid_html_parser_1.NamedTags.if:
            return getConditionIdentifierForMarkup(parent.markup);
          case liquid_html_parser_1.NamedTags.unless:
            return negateIdentifier(getConditionIdentifierForMarkup(parent.markup));
          default:
            return "??";
        }
      switch (branch.name) {
        case "else":
          switch (parent.name) {
            case liquid_html_parser_1.NamedTags.if:
              return negateIdentifier(getConditionIdentifierForMarkup(parent.markup));
            case liquid_html_parser_1.NamedTags.unless:
              return getConditionIdentifierForMarkup(parent.markup);
            case liquid_html_parser_1.NamedTags.case:
              return `case ${getConditionIdentifierForMarkup(parent.markup)}`;
            default:
              return "??";
          }
        case liquid_html_parser_1.NamedTags.elsif:
          return getConditionIdentifierForMarkup(branch.markup);
        case liquid_html_parser_1.NamedTags.when:
          return parent.name !== liquid_html_parser_1.NamedTags.case ? "??" : `case ${getConditionIdentifierForMarkup(parent.markup)} == ${getConditionIdentifierForWhenMarkup(branch.markup)}`;
        default:
          return "??";
      }
    }
    function getConditionIdentifierForWhenMarkup(conditions) {
      return typeof conditions == "string" ? conditions : conditions.map(getConditionIdentifierForMarkup).join(" or ");
    }
    function getConditionIdentifierForMarkup(condition) {
      var _a38;
      if (typeof condition == "string")
        return condition;
      switch (condition.type) {
        case liquid_html_parser_1.NodeTypes.String:
          return "'" + condition.value + "'";
        case liquid_html_parser_1.NodeTypes.LiquidLiteral:
          return condition.value === null ? "null" : condition.value.toString();
        case liquid_html_parser_1.NodeTypes.Number:
          return condition.value;
        case liquid_html_parser_1.NodeTypes.VariableLookup:
          return `${(_a38 = condition.name) !== null && _a38 !== void 0 ? _a38 : ""}${condition.lookups.map((expression) => `[${getConditionIdentifierForMarkup(expression)}]`)}`;
        case liquid_html_parser_1.NodeTypes.Range:
          return `(${getConditionIdentifierForMarkup(condition.start)}..${getConditionIdentifierForMarkup(condition.end)})`;
        case liquid_html_parser_1.NodeTypes.Comparison:
          return [
            getConditionIdentifierForMarkup(condition.left),
            condition.comparator,
            getConditionIdentifierForMarkup(condition.right)
          ].join(" ");
        case liquid_html_parser_1.NodeTypes.LogicalExpression:
          return [
            getConditionIdentifierForMarkup(condition.left),
            condition.relation,
            getConditionIdentifierForMarkup(condition.right)
          ].join(" ");
        default:
          return (0, utils_1.assertNever)(condition);
      }
    }
    function negateIdentifier(conditionIdentifier) {
      return conditionIdentifier.startsWith("-") ? conditionIdentifier.slice(1) : `-${conditionIdentifier}`;
    }
    function getName2(node) {
      return node.type === liquid_html_parser_1.NodeTypes.HtmlElement || node.type === liquid_html_parser_1.NodeTypes.HtmlDanglingMarkerClose ? node.name.length === 0 ? "" : node.source.slice(node.name.at(0).position.start, node.name.at(-1).position.end) : node.type === liquid_html_parser_1.NodeTypes.LiquidTag ? node.name : node.type;
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/undefined-object/index.js
var require_undefined_object = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/undefined-object/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.UndefinedObject = void 0;
    var liquid_html_parser_1 = require_dist(), types_1 = require_types2(), utils_1 = require_utils2();
    exports.UndefinedObject = {
      meta: {
        code: "UndefinedObject",
        name: "Undefined Object",
        docs: {
          description: "This check exists to identify references to undefined Liquid objects.",
          recommended: !0,
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/undefined-object"
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.WARNING,
        schema: {},
        targets: []
      },
      create(context) {
        let relativePath2 = context.relativePath(context.file.absolutePath);
        if (relativePath2.startsWith("snippets/"))
          return {};
        if (!context.themeDocset)
          return {};
        let themeDocset = context.themeDocset, variableScopes = /* @__PURE__ */ new Map(), variables = [];
        function indexVariableScope(variableName, scope) {
          var _a38;
          if (!variableName)
            return;
          let indexedScope = (_a38 = variableScopes.get(variableName)) !== null && _a38 !== void 0 ? _a38 : [];
          variableScopes.set(variableName, indexedScope.concat(scope));
        }
        return {
          async LiquidTag(node) {
            var _a38, _b, _c, _d;
            isLiquidTagAssign(node) && indexVariableScope(node.markup.name, {
              start: node.blockStartPosition.end
            }), isLiquidTagCapture(node) && indexVariableScope(node.markup.name, {
              start: (_a38 = node.blockEndPosition) === null || _a38 === void 0 ? void 0 : _a38.end
            }), ["form", "paginate"].includes(node.name) && indexVariableScope(node.name, {
              start: node.blockStartPosition.end,
              end: (_b = node.blockEndPosition) === null || _b === void 0 ? void 0 : _b.start
            }), node.name === "layout" && indexVariableScope("none", {
              start: node.position.start,
              end: node.position.end
            }), (isLiquidTagIncrement(node) || isLiquidTagDecrement(node)) && node.markup.name !== null && indexVariableScope(node.markup.name, {
              start: node.position.start
            }), (isLiquidForTag(node) || isLiquidTableRowTag(node)) && (indexVariableScope(node.markup.variableName, {
              start: node.blockStartPosition.end,
              end: (_c = node.blockEndPosition) === null || _c === void 0 ? void 0 : _c.start
            }), indexVariableScope(node.name === "for" ? "forloop" : "tablerowloop", {
              start: node.blockStartPosition.end,
              end: (_d = node.blockEndPosition) === null || _d === void 0 ? void 0 : _d.start
            }));
          },
          async VariableLookup(node, ancestors) {
            let parent = (0, utils_1.last)(ancestors);
            isLiquidTag(parent) && isLiquidTagCapture(parent) || variables.push(node);
          },
          async onCodePathEnd() {
            (await globalObjects(themeDocset, relativePath2)).forEach((obj) => variableScopes.set(obj.name, [])), variables.forEach((variable) => {
              !variable.name || isDefined2(variable.name, variable.position, variableScopes) || context.report({
                message: `Unknown object '${variable.name}' used.`,
                startIndex: variable.position.start,
                endIndex: variable.position.end
              });
            });
          }
        };
      }
    };
    async function globalObjects(themeDocset, relativePath2) {
      let objects = await themeDocset.objects(), contextualObjects = getContextualObjects(relativePath2);
      return objects.filter(({ access: access2, name }) => contextualObjects.includes(name) || !access2 || access2.global === !0 || access2.template.length > 0);
    }
    function getContextualObjects(relativePath2) {
      return relativePath2.startsWith("layout/checkout.liquid") ? [
        "locale",
        "direction",
        "skip_to_content_link",
        "checkout_html_classes",
        "checkout_stylesheets",
        "checkout_scripts",
        "content_for_logo",
        "breadcrumb",
        "order_summary_toggle",
        "content_for_order_summary",
        "alternative_payment_methods",
        "content_for_footer",
        "tracking_code"
      ] : relativePath2.startsWith("sections/") ? ["section", "predictive_search", "recommendations", "comment"] : relativePath2.startsWith("blocks/") ? ["app", "section", "block"] : relativePath2.startsWith("snippets/") ? ["app"] : [];
    }
    function isDefined2(variableName, variablePosition, scopedVariables) {
      let scopes = scopedVariables.get(variableName);
      return scopes ? scopes.length === 0 ? !0 : scopes.some((scope) => isDefinedInScope(variablePosition, scope)) : !1;
    }
    function isDefinedInScope(variablePosition, scope) {
      let start = variablePosition.start, isVariableAfterScopeStart = !scope.start || start > scope.start, isVariableBeforeScopeEnd = !scope.end || start < scope.end;
      return isVariableAfterScopeStart && isVariableBeforeScopeEnd;
    }
    function isLiquidTag(node) {
      return node?.type === liquid_html_parser_1.NodeTypes.LiquidTag;
    }
    function isLiquidTagCapture(node) {
      return node.name === liquid_html_parser_1.NamedTags.capture;
    }
    function isLiquidTagAssign(node) {
      return node.name === liquid_html_parser_1.NamedTags.assign && typeof node.markup != "string";
    }
    function isLiquidForTag(node) {
      return node.name === liquid_html_parser_1.NamedTags.for && typeof node.markup != "string";
    }
    function isLiquidTableRowTag(node) {
      return node.name === liquid_html_parser_1.NamedTags.tablerow && typeof node.markup != "string";
    }
    function isLiquidTagIncrement(node) {
      return node.name === liquid_html_parser_1.NamedTags.increment && typeof node.markup != "string";
    }
    function isLiquidTagDecrement(node) {
      return node.name === liquid_html_parser_1.NamedTags.decrement && typeof node.markup != "string";
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/unknown-filter/index.js
var require_unknown_filter = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/unknown-filter/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.UnknownFilter = void 0;
    var types_1 = require_types2();
    exports.UnknownFilter = {
      meta: {
        code: "UnknownFilter",
        name: "Prevent use of unknown filters",
        docs: {
          description: "This check is aimed at preventing the use of unknown filters.",
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/unknown-filter",
          recommended: !0
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema: {},
        targets: []
      },
      create(context) {
        return context.themeDocset ? {
          async LiquidFilter(node) {
            (await context.themeDocset.filters()).some((filter) => filter.name === node.name) || context.report({
              message: `Unknown filter '${node.name}' used.`,
              startIndex: node.position.start + 1,
              endIndex: node.position.end
            });
          }
        } : {};
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/unused-assign/index.js
var require_unused_assign = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/unused-assign/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.UnusedAssign = void 0;
    var liquid_html_parser_1 = require_dist(), types_1 = require_types2();
    exports.UnusedAssign = {
      meta: {
        code: "UnusedAssign",
        name: "Prevent unused assigns",
        docs: {
          description: "This check exists to prevent bloat in themes by surfacing variable definitions that are not used.",
          recommended: !0,
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/unused-assign"
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.WARNING,
        schema: {},
        targets: []
      },
      create(context) {
        let assignedVariables = /* @__PURE__ */ new Map(), usedVariables = /* @__PURE__ */ new Set();
        function checkVariableUsage(node) {
          node.type === liquid_html_parser_1.NodeTypes.VariableLookup && usedVariables.add(node.name);
        }
        return {
          async LiquidTag(node) {
            (isLiquidTagAssign(node) || isLiquidTagCapture(node) && node.markup.name) && assignedVariables.set(node.markup.name, node);
          },
          async VariableLookup(node, ancestors) {
            let parentNode = ancestors.at(-1);
            parentNode && isLiquidTagCapture(parentNode) || checkVariableUsage(node);
          },
          async onCodePathEnd() {
            for (let [variable, node] of assignedVariables.entries())
              !usedVariables.has(variable) && !variable.startsWith("_") && context.report({
                message: `The variable '${variable}' is assigned but not used`,
                startIndex: node.position.start,
                endIndex: node.position.end,
                suggest: [
                  {
                    message: `Remove the unused variable '${variable}'`,
                    fix: (corrector) => corrector.remove(node.position.start, node.position.end)
                  }
                ]
              });
          }
        };
      }
    };
    function isLiquidTagAssign(node) {
      return node.name === "assign" && typeof node.markup != "string";
    }
    function isLiquidTagCapture(node) {
      return node.type == liquid_html_parser_1.NodeTypes.LiquidTag && node.name === "capture" && typeof node.markup != "string";
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/valid-html-translation/index.js
var require_valid_html_translation = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/valid-html-translation/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ValidHTMLTranslation = void 0;
    var types_1 = require_types2(), liquid_html_parser_1 = require_dist();
    exports.ValidHTMLTranslation = {
      meta: {
        code: "ValidHTMLTranslation",
        name: "Valid HTML Translation",
        docs: {
          description: "This check exists to prevent invalid HTML inside translations.",
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/valid-html-translation",
          recommended: !0
        },
        type: types_1.SourceCodeType.JSON,
        severity: types_1.Severity.WARNING,
        schema: {},
        targets: []
      },
      create(context) {
        return context.relativePath(context.file.absolutePath).startsWith("locales/") ? {
          async Literal(node) {
            let htmlRegex = /<[^>]+>/;
            if (!(typeof node.value != "string" || !htmlRegex.test(node.value)))
              try {
                (0, liquid_html_parser_1.toLiquidHtmlAST)(node.value);
              } catch (error) {
                let loc = node.loc, problem = {
                  message: `${error}.`,
                  startIndex: loc.start.offset,
                  endIndex: loc.end.offset
                };
                context.report(problem);
              }
          }
        } : {};
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/valid-schema/index.js
var require_valid_schema = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/valid-schema/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ValidSchema = void 0;
    var types_1 = require_types2();
    exports.ValidSchema = {
      meta: {
        code: "ValidSchema",
        name: "Prevent invalid JSON in {% schema %} tags",
        docs: {
          description: "This check is aimed at eliminating JSON errors in schema tags.",
          recommended: !0,
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/valid-schema"
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema: {},
        targets: []
      },
      create(context) {
        return {
          async LiquidRawTag(node) {
            if (node.name !== "schema" || node.body.kind !== "json" || !context.validateJSON)
              return;
            let jsonString = node.source.slice(node.blockStartPosition.end, node.blockEndPosition.start), problems = await context.validateJSON(context.file, jsonString);
            if (problems)
              for (let problem of problems)
                context.report({
                  message: problem.message,
                  startIndex: node.blockStartPosition.end + problem.startIndex,
                  endIndex: node.blockStartPosition.end + problem.endIndex
                });
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/valid-json/index.js
var require_valid_json = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/valid-json/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ValidJSON = void 0;
    var types_1 = require_types2();
    exports.ValidJSON = {
      meta: {
        code: "ValidJSON",
        aliases: ["ValidJson"],
        name: "Enforce valid JSON",
        docs: {
          description: "This check exists to prevent invalid JSON files in themes. Will check against schema if available.",
          recommended: !0,
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/valid-json"
        },
        type: types_1.SourceCodeType.JSON,
        severity: types_1.Severity.ERROR,
        schema: {},
        targets: []
      },
      create(context) {
        if (!context.validateJSON)
          return {};
        let validateJSON = context.validateJSON;
        return {
          async onCodePathStart(file) {
            let problems = await validateJSON(file, file.source);
            if (problems)
              for (let problem of problems)
                context.report(problem);
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_castSlice.js
var require_castSlice = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_castSlice.js"(exports, module) {
    init_cjs_shims();
    var baseSlice = require_baseSlice();
    function castSlice(array, start, end) {
      var length = array.length;
      return end = end === void 0 ? length : end, !start && end >= length ? array : baseSlice(array, start, end);
    }
    module.exports = castSlice;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hasUnicode.js
var require_hasUnicode = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hasUnicode.js"(exports, module) {
    init_cjs_shims();
    var rsAstralRange = "\\ud800-\\udfff", rsComboMarksRange = "\\u0300-\\u036f", reComboHalfMarksRange = "\\ufe20-\\ufe2f", rsComboSymbolsRange = "\\u20d0-\\u20ff", rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange, rsVarRange = "\\ufe0e\\ufe0f", rsZWJ = "\\u200d", reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + "]");
    function hasUnicode(string) {
      return reHasUnicode.test(string);
    }
    module.exports = hasUnicode;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_asciiToArray.js
var require_asciiToArray = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_asciiToArray.js"(exports, module) {
    init_cjs_shims();
    function asciiToArray(string) {
      return string.split("");
    }
    module.exports = asciiToArray;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_unicodeToArray.js
var require_unicodeToArray = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_unicodeToArray.js"(exports, module) {
    init_cjs_shims();
    var rsAstralRange = "\\ud800-\\udfff", rsComboMarksRange = "\\u0300-\\u036f", reComboHalfMarksRange = "\\ufe20-\\ufe2f", rsComboSymbolsRange = "\\u20d0-\\u20ff", rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange, rsVarRange = "\\ufe0e\\ufe0f", rsAstral = "[" + rsAstralRange + "]", rsCombo = "[" + rsComboRange + "]", rsFitz = "\\ud83c[\\udffb-\\udfff]", rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")", rsNonAstral = "[^" + rsAstralRange + "]", rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}", rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]", rsZWJ = "\\u200d", reOptMod = rsModifier + "?", rsOptVar = "[" + rsVarRange + "]?", rsOptJoin = "(?:" + rsZWJ + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*", rsSeq = rsOptVar + reOptMod + rsOptJoin, rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")", reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
    function unicodeToArray(string) {
      return string.match(reUnicode) || [];
    }
    module.exports = unicodeToArray;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_stringToArray.js
var require_stringToArray = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_stringToArray.js"(exports, module) {
    init_cjs_shims();
    var asciiToArray = require_asciiToArray(), hasUnicode = require_hasUnicode(), unicodeToArray = require_unicodeToArray();
    function stringToArray(string) {
      return hasUnicode(string) ? unicodeToArray(string) : asciiToArray(string);
    }
    module.exports = stringToArray;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_createCaseFirst.js
var require_createCaseFirst = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_createCaseFirst.js"(exports, module) {
    init_cjs_shims();
    var castSlice = require_castSlice(), hasUnicode = require_hasUnicode(), stringToArray = require_stringToArray(), toString2 = require_toString();
    function createCaseFirst(methodName) {
      return function(string) {
        string = toString2(string);
        var strSymbols = hasUnicode(string) ? stringToArray(string) : void 0, chr = strSymbols ? strSymbols[0] : string.charAt(0), trailing = strSymbols ? castSlice(strSymbols, 1).join("") : string.slice(1);
        return chr[methodName]() + trailing;
      };
    }
    module.exports = createCaseFirst;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/upperFirst.js
var require_upperFirst = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/upperFirst.js"(exports, module) {
    init_cjs_shims();
    var createCaseFirst = require_createCaseFirst(), upperFirst = createCaseFirst("toUpperCase");
    module.exports = upperFirst;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/capitalize.js
var require_capitalize = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/capitalize.js"(exports, module) {
    init_cjs_shims();
    var toString2 = require_toString(), upperFirst = require_upperFirst();
    function capitalize2(string) {
      return upperFirst(toString2(string).toLowerCase());
    }
    module.exports = capitalize2;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arrayReduce.js
var require_arrayReduce = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arrayReduce.js"(exports, module) {
    init_cjs_shims();
    function arrayReduce(array, iteratee, accumulator, initAccum) {
      var index = -1, length = array == null ? 0 : array.length;
      for (initAccum && length && (accumulator = array[++index]); ++index < length; )
        accumulator = iteratee(accumulator, array[index], index, array);
      return accumulator;
    }
    module.exports = arrayReduce;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_basePropertyOf.js
var require_basePropertyOf = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_basePropertyOf.js"(exports, module) {
    init_cjs_shims();
    function basePropertyOf(object) {
      return function(key) {
        return object?.[key];
      };
    }
    module.exports = basePropertyOf;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_deburrLetter.js
var require_deburrLetter = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_deburrLetter.js"(exports, module) {
    init_cjs_shims();
    var basePropertyOf = require_basePropertyOf(), deburredLetters = {
      // Latin-1 Supplement block.
      \u00C0: "A",
      \u00C1: "A",
      \u00C2: "A",
      \u00C3: "A",
      \u00C4: "A",
      \u00C5: "A",
      \u00E0: "a",
      \u00E1: "a",
      \u00E2: "a",
      \u00E3: "a",
      \u00E4: "a",
      \u00E5: "a",
      \u00C7: "C",
      \u00E7: "c",
      \u00D0: "D",
      \u00F0: "d",
      \u00C8: "E",
      \u00C9: "E",
      \u00CA: "E",
      \u00CB: "E",
      \u00E8: "e",
      \u00E9: "e",
      \u00EA: "e",
      \u00EB: "e",
      \u00CC: "I",
      \u00CD: "I",
      \u00CE: "I",
      \u00CF: "I",
      \u00EC: "i",
      \u00ED: "i",
      \u00EE: "i",
      \u00EF: "i",
      \u00D1: "N",
      \u00F1: "n",
      \u00D2: "O",
      \u00D3: "O",
      \u00D4: "O",
      \u00D5: "O",
      \u00D6: "O",
      \u00D8: "O",
      \u00F2: "o",
      \u00F3: "o",
      \u00F4: "o",
      \u00F5: "o",
      \u00F6: "o",
      \u00F8: "o",
      \u00D9: "U",
      \u00DA: "U",
      \u00DB: "U",
      \u00DC: "U",
      \u00F9: "u",
      \u00FA: "u",
      \u00FB: "u",
      \u00FC: "u",
      \u00DD: "Y",
      \u00FD: "y",
      \u00FF: "y",
      \u00C6: "Ae",
      \u00E6: "ae",
      \u00DE: "Th",
      \u00FE: "th",
      \u00DF: "ss",
      // Latin Extended-A block.
      \u0100: "A",
      \u0102: "A",
      \u0104: "A",
      \u0101: "a",
      \u0103: "a",
      \u0105: "a",
      \u0106: "C",
      \u0108: "C",
      \u010A: "C",
      \u010C: "C",
      \u0107: "c",
      \u0109: "c",
      \u010B: "c",
      \u010D: "c",
      \u010E: "D",
      \u0110: "D",
      \u010F: "d",
      \u0111: "d",
      \u0112: "E",
      \u0114: "E",
      \u0116: "E",
      \u0118: "E",
      \u011A: "E",
      \u0113: "e",
      \u0115: "e",
      \u0117: "e",
      \u0119: "e",
      \u011B: "e",
      \u011C: "G",
      \u011E: "G",
      \u0120: "G",
      \u0122: "G",
      \u011D: "g",
      \u011F: "g",
      \u0121: "g",
      \u0123: "g",
      \u0124: "H",
      \u0126: "H",
      \u0125: "h",
      \u0127: "h",
      \u0128: "I",
      \u012A: "I",
      \u012C: "I",
      \u012E: "I",
      \u0130: "I",
      \u0129: "i",
      \u012B: "i",
      \u012D: "i",
      \u012F: "i",
      \u0131: "i",
      \u0134: "J",
      \u0135: "j",
      \u0136: "K",
      \u0137: "k",
      \u0138: "k",
      \u0139: "L",
      \u013B: "L",
      \u013D: "L",
      \u013F: "L",
      \u0141: "L",
      \u013A: "l",
      \u013C: "l",
      \u013E: "l",
      \u0140: "l",
      \u0142: "l",
      \u0143: "N",
      \u0145: "N",
      \u0147: "N",
      \u014A: "N",
      \u0144: "n",
      \u0146: "n",
      \u0148: "n",
      \u014B: "n",
      \u014C: "O",
      \u014E: "O",
      \u0150: "O",
      \u014D: "o",
      \u014F: "o",
      \u0151: "o",
      \u0154: "R",
      \u0156: "R",
      \u0158: "R",
      \u0155: "r",
      \u0157: "r",
      \u0159: "r",
      \u015A: "S",
      \u015C: "S",
      \u015E: "S",
      \u0160: "S",
      \u015B: "s",
      \u015D: "s",
      \u015F: "s",
      \u0161: "s",
      \u0162: "T",
      \u0164: "T",
      \u0166: "T",
      \u0163: "t",
      \u0165: "t",
      \u0167: "t",
      \u0168: "U",
      \u016A: "U",
      \u016C: "U",
      \u016E: "U",
      \u0170: "U",
      \u0172: "U",
      \u0169: "u",
      \u016B: "u",
      \u016D: "u",
      \u016F: "u",
      \u0171: "u",
      \u0173: "u",
      \u0174: "W",
      \u0175: "w",
      \u0176: "Y",
      \u0177: "y",
      \u0178: "Y",
      \u0179: "Z",
      \u017B: "Z",
      \u017D: "Z",
      \u017A: "z",
      \u017C: "z",
      \u017E: "z",
      \u0132: "IJ",
      \u0133: "ij",
      \u0152: "Oe",
      \u0153: "oe",
      \u0149: "'n",
      \u017F: "s"
    }, deburrLetter = basePropertyOf(deburredLetters);
    module.exports = deburrLetter;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/deburr.js
var require_deburr = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/deburr.js"(exports, module) {
    init_cjs_shims();
    var deburrLetter = require_deburrLetter(), toString2 = require_toString(), reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, rsComboMarksRange = "\\u0300-\\u036f", reComboHalfMarksRange = "\\ufe20-\\ufe2f", rsComboSymbolsRange = "\\u20d0-\\u20ff", rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange, rsCombo = "[" + rsComboRange + "]", reComboMark = RegExp(rsCombo, "g");
    function deburr(string) {
      return string = toString2(string), string && string.replace(reLatin, deburrLetter).replace(reComboMark, "");
    }
    module.exports = deburr;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_asciiWords.js
var require_asciiWords = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_asciiWords.js"(exports, module) {
    init_cjs_shims();
    var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
    function asciiWords(string) {
      return string.match(reAsciiWord) || [];
    }
    module.exports = asciiWords;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hasUnicodeWord.js
var require_hasUnicodeWord = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_hasUnicodeWord.js"(exports, module) {
    init_cjs_shims();
    var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
    function hasUnicodeWord(string) {
      return reHasUnicodeWord.test(string);
    }
    module.exports = hasUnicodeWord;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_unicodeWords.js
var require_unicodeWords = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_unicodeWords.js"(exports, module) {
    init_cjs_shims();
    var rsAstralRange = "\\ud800-\\udfff", rsComboMarksRange = "\\u0300-\\u036f", reComboHalfMarksRange = "\\ufe20-\\ufe2f", rsComboSymbolsRange = "\\u20d0-\\u20ff", rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange, rsDingbatRange = "\\u2700-\\u27bf", rsLowerRange = "a-z\\xdf-\\xf6\\xf8-\\xff", rsMathOpRange = "\\xac\\xb1\\xd7\\xf7", rsNonCharRange = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", rsPunctuationRange = "\\u2000-\\u206f", rsSpaceRange = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", rsUpperRange = "A-Z\\xc0-\\xd6\\xd8-\\xde", rsVarRange = "\\ufe0e\\ufe0f", rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange, rsApos = "['\u2019]", rsBreak = "[" + rsBreakRange + "]", rsCombo = "[" + rsComboRange + "]", rsDigits = "\\d+", rsDingbat = "[" + rsDingbatRange + "]", rsLower = "[" + rsLowerRange + "]", rsMisc = "[^" + rsAstralRange + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + "]", rsFitz = "\\ud83c[\\udffb-\\udfff]", rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")", rsNonAstral = "[^" + rsAstralRange + "]", rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}", rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]", rsUpper = "[" + rsUpperRange + "]", rsZWJ = "\\u200d", rsMiscLower = "(?:" + rsLower + "|" + rsMisc + ")", rsMiscUpper = "(?:" + rsUpper + "|" + rsMisc + ")", rsOptContrLower = "(?:" + rsApos + "(?:d|ll|m|re|s|t|ve))?", rsOptContrUpper = "(?:" + rsApos + "(?:D|LL|M|RE|S|T|VE))?", reOptMod = rsModifier + "?", rsOptVar = "[" + rsVarRange + "]?", rsOptJoin = "(?:" + rsZWJ + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*", rsOrdLower = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", rsOrdUpper = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", rsSeq = rsOptVar + reOptMod + rsOptJoin, rsEmoji = "(?:" + [rsDingbat, rsRegional, rsSurrPair].join("|") + ")" + rsSeq, reUnicodeWord = RegExp([
      rsUpper + "?" + rsLower + "+" + rsOptContrLower + "(?=" + [rsBreak, rsUpper, "$"].join("|") + ")",
      rsMiscUpper + "+" + rsOptContrUpper + "(?=" + [rsBreak, rsUpper + rsMiscLower, "$"].join("|") + ")",
      rsUpper + "?" + rsMiscLower + "+" + rsOptContrLower,
      rsUpper + "+" + rsOptContrUpper,
      rsOrdUpper,
      rsOrdLower,
      rsDigits,
      rsEmoji
    ].join("|"), "g");
    function unicodeWords(string) {
      return string.match(reUnicodeWord) || [];
    }
    module.exports = unicodeWords;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/words.js
var require_words = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/words.js"(exports, module) {
    init_cjs_shims();
    var asciiWords = require_asciiWords(), hasUnicodeWord = require_hasUnicodeWord(), toString2 = require_toString(), unicodeWords = require_unicodeWords();
    function words(string, pattern, guard) {
      return string = toString2(string), pattern = guard ? void 0 : pattern, pattern === void 0 ? hasUnicodeWord(string) ? unicodeWords(string) : asciiWords(string) : string.match(pattern) || [];
    }
    module.exports = words;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_createCompounder.js
var require_createCompounder = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_createCompounder.js"(exports, module) {
    init_cjs_shims();
    var arrayReduce = require_arrayReduce(), deburr = require_deburr(), words = require_words(), rsApos = "['\u2019]", reApos = RegExp(rsApos, "g");
    function createCompounder(callback) {
      return function(string) {
        return arrayReduce(words(deburr(string).replace(reApos, "")), callback, "");
      };
    }
    module.exports = createCompounder;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/camelCase.js
var require_camelCase = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/camelCase.js"(exports, module) {
    init_cjs_shims();
    var capitalize2 = require_capitalize(), createCompounder = require_createCompounder(), camelCase2 = createCompounder(function(result, word, index) {
      return word = word.toLowerCase(), result + (index ? capitalize2(word) : word);
    });
    module.exports = camelCase2;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/kebabCase.js
var require_kebabCase = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/kebabCase.js"(exports, module) {
    init_cjs_shims();
    var createCompounder = require_createCompounder(), kebabCase = createCompounder(function(result, word, index) {
      return result + (index ? "-" : "") + word.toLowerCase();
    });
    module.exports = kebabCase;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/snakeCase.js
var require_snakeCase = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/snakeCase.js"(exports, module) {
    init_cjs_shims();
    var createCompounder = require_createCompounder(), snakeCase = createCompounder(function(result, word, index) {
      return result + (index ? "_" : "") + word.toLowerCase();
    });
    module.exports = snakeCase;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/variable-name/index.js
var require_variable_name = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/variable-name/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.VariableName = void 0;
    var liquid_html_parser_1 = require_dist(), types_1 = require_types2(), camelCase_1 = __importDefault(require_camelCase()), kebabCase_1 = __importDefault(require_kebabCase()), snakeCase_1 = __importDefault(require_snakeCase()), pascalCase = (string) => {
      let camelCased = (0, camelCase_1.default)(string);
      return camelCased.charAt(0).toUpperCase() + camelCased.slice(1);
    }, isLiquidTagAssign = (node) => node.name === "assign" && typeof node.markup != "string", isLiquidTagCapture = (node) => node.type == liquid_html_parser_1.NodeTypes.LiquidTag && node.name === "capture" && typeof node.markup != "string", formatTypes = {
      camelCase: camelCase_1.default,
      PascalCase: pascalCase,
      snake_case: snakeCase_1.default,
      "kebab-case": kebabCase_1.default
    }, schema = {
      format: types_1.SchemaProp.string("snake_case")
    };
    exports.VariableName = {
      meta: {
        code: "VariableName",
        name: "Invalid variable naming format",
        docs: {
          description: "This check is aimed at using certain variable naming conventions",
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/variable-name",
          recommended: !0
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.WARNING,
        schema,
        targets: []
      },
      create(context) {
        let formatter = (node) => {
          if (!node.markup.name)
            return {
              valid: !1
            };
          let suggestion = formatTypes[context.settings.format].call(null, node.markup.name);
          return {
            valid: node.markup.name === suggestion,
            suggestion
          };
        }, reportHandler = (node) => context.report({
          message: `The variable '${node.markup.name}' uses wrong naming format`,
          startIndex: node.markup.position.start,
          endIndex: node.markup.position.end,
          suggest: [
            {
              message: `Change variable '${node.markup.name}' to '${formatter(node).suggestion}'`,
              fix: (corrector) => {
                let { position, name, source } = node.markup;
                return corrector.replace(position.start, position.end, source.slice(position.start, position.end).replace(name, formatter(node).suggestion));
              }
            }
          ]
        });
        return {
          async LiquidTag(node) {
            (isLiquidTagAssign(node) || isLiquidTagCapture(node) && node.markup.name) && (formatter(node).valid || reportHandler(node));
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/valid-static-block-type/index.js
var require_valid_static_block_type = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/valid-static-block-type/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ValidStaticBlockType = void 0;
    var types_1 = require_types2(), file_utils_1 = require_file_utils();
    exports.ValidStaticBlockType = {
      meta: {
        code: "ValidStaticBlockType",
        name: "Prevent use of type that is not valid for static blocks",
        docs: {
          description: "This check is aimed at preventing the use of an invalid type for blocks rendered statically.",
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/valid-static-block-type",
          recommended: !0
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema: {},
        targets: []
      },
      create(context) {
        let typeRegex = /type:\s*["'](\S+)["']/;
        return {
          async LiquidTag(node) {
            if (node.name !== "content_for")
              return;
            let [blockType] = node.markup.split(",");
            if (blockType.replace(/["']/g, "") !== "block")
              return;
            let typeValueMatch = typeRegex.exec(node.markup);
            if (typeValueMatch == null)
              return;
            let [entireTypeTerm, filteredTypeValue] = typeValueMatch, relativePath2 = `blocks/${filteredTypeValue}.liquid`;
            if (!await (0, file_utils_1.doesFileExist)(context, relativePath2)) {
              let contentForBlockStartIndex = node.source.substring(node.position.start).indexOf(blockType), typeParamIndex = typeValueMatch.index + contentForBlockStartIndex, typeParamValueLength = entireTypeTerm.length, typeParamValueEndIndex = typeParamIndex + typeParamValueLength;
              context.report({
                message: `The type '${filteredTypeValue}' is not valid, use a type that exists in the blocks directory`,
                startIndex: node.position.start + typeParamIndex,
                endIndex: node.position.start + typeParamValueEndIndex,
                suggest: []
              });
            }
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/unique-static-block-id/index.js
var require_unique_static_block_id = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/unique-static-block-id/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.UniqueStaticBlockId = void 0;
    var types_1 = require_types2();
    exports.UniqueStaticBlockId = {
      meta: {
        code: "UniqueStaticBlockId",
        name: "Prevent use of duplicated ids for blocks rendered statically",
        docs: {
          description: "This check is aimed at preventing the use of duplicated ids for blocks rendered statically.",
          url: "https://shopify.dev/docs/themes/tools/theme-check/checks/unique-static-block-id",
          recommended: !0
        },
        type: types_1.SourceCodeType.LiquidHtml,
        severity: types_1.Severity.ERROR,
        schema: {},
        targets: []
      },
      create(context) {
        let usedIds = /* @__PURE__ */ new Set(), idRegex = /id:\s*["'](\S+)["']/;
        return {
          async LiquidTag(node) {
            if (node.name !== "content_for")
              return;
            let [blockType] = node.markup.split(",");
            if (blockType.replace(/["']/g, "") !== "block")
              return;
            let idValueMatch = idRegex.exec(node.markup);
            if (idValueMatch == null)
              return;
            let [entireIdTerm, filteredIdValue] = idValueMatch;
            if (usedIds.has(filteredIdValue)) {
              let contentForBlockStartIndex = node.source.substring(node.position.start).indexOf(blockType), idParamIndex = idValueMatch.index + contentForBlockStartIndex, idParamValueLength = entireIdTerm.length, idParamValueEndIndex = idParamIndex + idParamValueLength;
              context.report({
                message: `The id '${filteredIdValue}' is already being used by another static block`,
                startIndex: node.position.start + idParamIndex,
                endIndex: node.position.start + idParamValueEndIndex,
                suggest: []
              });
            } else
              usedIds.add(filteredIdValue);
          }
        };
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/index.js
var require_checks = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/checks/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.recommended = exports.allChecks = void 0;
    var types_1 = require_types2(), app_block_valid_tags_1 = require_app_block_valid_tags(), asset_preload_1 = require_asset_preload(), asset_size_app_block_css_1 = require_asset_size_app_block_css(), asset_size_app_block_javascript_1 = require_asset_size_app_block_javascript(), asset_size_css_1 = require_asset_size_css(), asset_size_javascript_1 = require_asset_size_javascript(), cdn_preconnect_1 = require_cdn_preconnect(), content_for_header_modification_1 = require_content_for_header_modification(), deprecate_bgsizes_1 = require_deprecate_bgsizes(), deprecate_lazysizes_1 = require_deprecate_lazysizes(), deprecated_filter_1 = require_deprecated_filter(), deprecated_tag_1 = require_deprecated_tag(), img_width_and_height_1 = require_img_width_and_height(), json_syntax_error_1 = require_json_syntax_error(), liquid_html_syntax_error_1 = require_liquid_html_syntax_error(), matching_translations_1 = require_matching_translations(), missing_asset_1 = require_missing_asset(), missing_template_1 = require_missing_template(), pagination_size_1 = require_pagination_size(), parser_blocking_script_1 = require_parser_blocking_script(), remote_asset_1 = require_remote_asset(), required_layout_theme_object_1 = require_required_layout_theme_object(), translation_key_exists_1 = require_translation_key_exists(), unclosed_html_element_1 = require_unclosed_html_element(), undefined_object_1 = require_undefined_object(), unknown_filter_1 = require_unknown_filter(), unused_assign_1 = require_unused_assign(), valid_html_translation_1 = require_valid_html_translation(), valid_schema_1 = require_valid_schema(), valid_json_1 = require_valid_json(), variable_name_1 = require_variable_name(), valid_static_block_type_1 = require_valid_static_block_type(), unique_static_block_id_1 = require_unique_static_block_id();
    exports.allChecks = [
      app_block_valid_tags_1.AppBlockValidTags,
      asset_preload_1.AssetPreload,
      asset_size_app_block_css_1.AssetSizeAppBlockCSS,
      asset_size_app_block_javascript_1.AssetSizeAppBlockJavaScript,
      asset_size_css_1.AssetSizeCSS,
      asset_size_javascript_1.AssetSizeJavaScript,
      cdn_preconnect_1.CdnPreconnect,
      content_for_header_modification_1.ContentForHeaderModification,
      deprecate_bgsizes_1.DeprecateBgsizes,
      deprecate_lazysizes_1.DeprecateLazysizes,
      deprecated_filter_1.DeprecatedFilter,
      deprecated_tag_1.DeprecatedTag,
      img_width_and_height_1.ImgWidthAndHeight,
      json_syntax_error_1.JSONSyntaxError,
      liquid_html_syntax_error_1.LiquidHTMLSyntaxError,
      matching_translations_1.MatchingTranslations,
      missing_asset_1.MissingAsset,
      missing_template_1.MissingTemplate,
      pagination_size_1.PaginationSize,
      parser_blocking_script_1.ParserBlockingScript,
      remote_asset_1.RemoteAsset,
      required_layout_theme_object_1.RequiredLayoutThemeObject,
      translation_key_exists_1.TranslationKeyExists,
      unclosed_html_element_1.UnclosedHTMLElement,
      undefined_object_1.UndefinedObject,
      unknown_filter_1.UnknownFilter,
      unused_assign_1.UnusedAssign,
      valid_html_translation_1.ValidHTMLTranslation,
      valid_schema_1.ValidSchema,
      valid_json_1.ValidJSON,
      variable_name_1.VariableName,
      valid_static_block_type_1.ValidStaticBlockType,
      unique_static_block_id_1.UniqueStaticBlockId
    ];
    exports.recommended = exports.allChecks.filter((check2) => {
      let isRecommended = check2.meta.docs.recommended, isValidTarget = !check2.meta.targets || !check2.meta.targets.length || check2.meta.targets.includes(types_1.ConfigTarget.Recommended);
      return isRecommended && isValidTarget;
    });
  }
});

// ../../node_modules/.pnpm/json-to-ast@2.1.0/node_modules/json-to-ast/build.js
var require_build = __commonJS({
  "../../node_modules/.pnpm/json-to-ast@2.1.0/node_modules/json-to-ast/build.js"(exports, module) {
    init_cjs_shims();
    (function(global2, factory) {
      typeof exports == "object" && typeof module < "u" ? module.exports = factory() : typeof define == "function" && define.amd ? define(factory) : global2.jsonToAst = factory();
    })(exports, function() {
      "use strict";
      var commonjsGlobal = typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
      function createCommonjsModule(fn, module2) {
        return module2 = { exports: {} }, fn(module2, module2.exports), module2.exports;
      }
      var graphemeSplitter = createCommonjsModule(function(module2) {
        function GraphemeSplitter() {
          var CR = 0, LF = 1, Control = 2, Extend = 3, Regional_Indicator = 4, SpacingMark = 5, L = 6, V = 7, T = 8, LV = 9, LVT = 10, Other = 11, Prepend = 12, E_Base = 13, E_Modifier = 14, ZWJ = 15, Glue_After_Zwj = 16, E_Base_GAZ = 17, NotBreak = 0, BreakStart = 1, Break = 2, BreakLastRegional = 3, BreakPenultimateRegional = 4;
          function isSurrogate(str, pos) {
            return 55296 <= str.charCodeAt(pos) && str.charCodeAt(pos) <= 56319 && 56320 <= str.charCodeAt(pos + 1) && str.charCodeAt(pos + 1) <= 57343;
          }
          function codePointAt(str, idx) {
            idx === void 0 && (idx = 0);
            var code = str.charCodeAt(idx);
            if (55296 <= code && code <= 56319 && idx < str.length - 1) {
              var hi = code, low = str.charCodeAt(idx + 1);
              return 56320 <= low && low <= 57343 ? (hi - 55296) * 1024 + (low - 56320) + 65536 : hi;
            }
            if (56320 <= code && code <= 57343 && idx >= 1) {
              var hi = str.charCodeAt(idx - 1), low = code;
              return 55296 <= hi && hi <= 56319 ? (hi - 55296) * 1024 + (low - 56320) + 65536 : low;
            }
            return code;
          }
          function shouldBreak(start, mid, end) {
            var all = [start].concat(mid).concat([end]), previous = all[all.length - 2], next = end, eModifierIndex = all.lastIndexOf(E_Modifier);
            if (eModifierIndex > 1 && all.slice(1, eModifierIndex).every(function(c) {
              return c == Extend;
            }) && [Extend, E_Base, E_Base_GAZ].indexOf(start) == -1)
              return Break;
            var rIIndex = all.lastIndexOf(Regional_Indicator);
            if (rIIndex > 0 && all.slice(1, rIIndex).every(function(c) {
              return c == Regional_Indicator;
            }) && [Prepend, Regional_Indicator].indexOf(previous) == -1)
              return all.filter(function(c) {
                return c == Regional_Indicator;
              }).length % 2 == 1 ? BreakLastRegional : BreakPenultimateRegional;
            if (previous == CR && next == LF)
              return NotBreak;
            if (previous == Control || previous == CR || previous == LF)
              return next == E_Modifier && mid.every(function(c) {
                return c == Extend;
              }) ? Break : BreakStart;
            if (next == Control || next == CR || next == LF)
              return BreakStart;
            if (previous == L && (next == L || next == V || next == LV || next == LVT))
              return NotBreak;
            if ((previous == LV || previous == V) && (next == V || next == T))
              return NotBreak;
            if ((previous == LVT || previous == T) && next == T)
              return NotBreak;
            if (next == Extend || next == ZWJ)
              return NotBreak;
            if (next == SpacingMark)
              return NotBreak;
            if (previous == Prepend)
              return NotBreak;
            var previousNonExtendIndex = all.indexOf(Extend) != -1 ? all.lastIndexOf(Extend) - 1 : all.length - 2;
            return [E_Base, E_Base_GAZ].indexOf(all[previousNonExtendIndex]) != -1 && all.slice(previousNonExtendIndex + 1, -1).every(function(c) {
              return c == Extend;
            }) && next == E_Modifier || previous == ZWJ && [Glue_After_Zwj, E_Base_GAZ].indexOf(next) != -1 ? NotBreak : mid.indexOf(Regional_Indicator) != -1 ? Break : previous == Regional_Indicator && next == Regional_Indicator ? NotBreak : BreakStart;
          }
          this.nextBreak = function(string, index) {
            if (index === void 0 && (index = 0), index < 0)
              return 0;
            if (index >= string.length - 1)
              return string.length;
            for (var prev = getGraphemeBreakProperty(codePointAt(string, index)), mid = [], i = index + 1; i < string.length; i++)
              if (!isSurrogate(string, i - 1)) {
                var next = getGraphemeBreakProperty(codePointAt(string, i));
                if (shouldBreak(prev, mid, next))
                  return i;
                mid.push(next);
              }
            return string.length;
          }, this.splitGraphemes = function(str) {
            for (var res = [], index = 0, brk; (brk = this.nextBreak(str, index)) < str.length; )
              res.push(str.slice(index, brk)), index = brk;
            return index < str.length && res.push(str.slice(index)), res;
          }, this.iterateGraphemes = function(str) {
            var index = 0, res = {
              next: function() {
                var value, brk;
                return (brk = this.nextBreak(str, index)) < str.length ? (value = str.slice(index, brk), index = brk, { value, done: !1 }) : index < str.length ? (value = str.slice(index), index = str.length, { value, done: !1 }) : { value: void 0, done: !0 };
              }.bind(this)
            };
            return typeof Symbol < "u" && Symbol.iterator && (res[Symbol.iterator] = function() {
              return res;
            }), res;
          }, this.countGraphemes = function(str) {
            for (var count = 0, index = 0, brk; (brk = this.nextBreak(str, index)) < str.length; )
              index = brk, count++;
            return index < str.length && count++, count;
          };
          function getGraphemeBreakProperty(code) {
            return 1536 <= code && code <= 1541 || // Cf   [6] ARABIC NUMBER SIGN..ARABIC NUMBER MARK ABOVE
            code == 1757 || // Cf       ARABIC END OF AYAH
            code == 1807 || // Cf       SYRIAC ABBREVIATION MARK
            code == 2274 || // Cf       ARABIC DISPUTED END OF AYAH
            code == 3406 || // Lo       MALAYALAM LETTER DOT REPH
            code == 69821 || // Cf       KAITHI NUMBER SIGN
            70082 <= code && code <= 70083 || // Lo   [2] SHARADA SIGN JIHVAMULIYA..SHARADA SIGN UPADHMANIYA
            code == 72250 || // Lo       ZANABAZAR SQUARE CLUSTER-INITIAL LETTER RA
            72326 <= code && code <= 72329 || // Lo   [4] SOYOMBO CLUSTER-INITIAL LETTER RA..SOYOMBO CLUSTER-INITIAL LETTER SA
            code == 73030 ? Prepend : code == 13 ? CR : code == 10 ? LF : 0 <= code && code <= 9 || // Cc  [10] <control-0000>..<control-0009>
            11 <= code && code <= 12 || // Cc   [2] <control-000B>..<control-000C>
            14 <= code && code <= 31 || // Cc  [18] <control-000E>..<control-001F>
            127 <= code && code <= 159 || // Cc  [33] <control-007F>..<control-009F>
            code == 173 || // Cf       SOFT HYPHEN
            code == 1564 || // Cf       ARABIC LETTER MARK
            code == 6158 || // Cf       MONGOLIAN VOWEL SEPARATOR
            code == 8203 || // Cf       ZERO WIDTH SPACE
            8206 <= code && code <= 8207 || // Cf   [2] LEFT-TO-RIGHT MARK..RIGHT-TO-LEFT MARK
            code == 8232 || // Zl       LINE SEPARATOR
            code == 8233 || // Zp       PARAGRAPH SEPARATOR
            8234 <= code && code <= 8238 || // Cf   [5] LEFT-TO-RIGHT EMBEDDING..RIGHT-TO-LEFT OVERRIDE
            8288 <= code && code <= 8292 || // Cf   [5] WORD JOINER..INVISIBLE PLUS
            code == 8293 || // Cn       <reserved-2065>
            8294 <= code && code <= 8303 || // Cf  [10] LEFT-TO-RIGHT ISOLATE..NOMINAL DIGIT SHAPES
            55296 <= code && code <= 57343 || // Cs [2048] <surrogate-D800>..<surrogate-DFFF>
            code == 65279 || // Cf       ZERO WIDTH NO-BREAK SPACE
            65520 <= code && code <= 65528 || // Cn   [9] <reserved-FFF0>..<reserved-FFF8>
            65529 <= code && code <= 65531 || // Cf   [3] INTERLINEAR ANNOTATION ANCHOR..INTERLINEAR ANNOTATION TERMINATOR
            113824 <= code && code <= 113827 || // Cf   [4] SHORTHAND FORMAT LETTER OVERLAP..SHORTHAND FORMAT UP STEP
            119155 <= code && code <= 119162 || // Cf   [8] MUSICAL SYMBOL BEGIN BEAM..MUSICAL SYMBOL END PHRASE
            code == 917504 || // Cn       <reserved-E0000>
            code == 917505 || // Cf       LANGUAGE TAG
            917506 <= code && code <= 917535 || // Cn  [30] <reserved-E0002>..<reserved-E001F>
            917632 <= code && code <= 917759 || // Cn [128] <reserved-E0080>..<reserved-E00FF>
            918e3 <= code && code <= 921599 ? Control : 768 <= code && code <= 879 || // Mn [112] COMBINING GRAVE ACCENT..COMBINING LATIN SMALL LETTER X
            1155 <= code && code <= 1159 || // Mn   [5] COMBINING CYRILLIC TITLO..COMBINING CYRILLIC POKRYTIE
            1160 <= code && code <= 1161 || // Me   [2] COMBINING CYRILLIC HUNDRED THOUSANDS SIGN..COMBINING CYRILLIC MILLIONS SIGN
            1425 <= code && code <= 1469 || // Mn  [45] HEBREW ACCENT ETNAHTA..HEBREW POINT METEG
            code == 1471 || // Mn       HEBREW POINT RAFE
            1473 <= code && code <= 1474 || // Mn   [2] HEBREW POINT SHIN DOT..HEBREW POINT SIN DOT
            1476 <= code && code <= 1477 || // Mn   [2] HEBREW MARK UPPER DOT..HEBREW MARK LOWER DOT
            code == 1479 || // Mn       HEBREW POINT QAMATS QATAN
            1552 <= code && code <= 1562 || // Mn  [11] ARABIC SIGN SALLALLAHOU ALAYHE WASSALLAM..ARABIC SMALL KASRA
            1611 <= code && code <= 1631 || // Mn  [21] ARABIC FATHATAN..ARABIC WAVY HAMZA BELOW
            code == 1648 || // Mn       ARABIC LETTER SUPERSCRIPT ALEF
            1750 <= code && code <= 1756 || // Mn   [7] ARABIC SMALL HIGH LIGATURE SAD WITH LAM WITH ALEF MAKSURA..ARABIC SMALL HIGH SEEN
            1759 <= code && code <= 1764 || // Mn   [6] ARABIC SMALL HIGH ROUNDED ZERO..ARABIC SMALL HIGH MADDA
            1767 <= code && code <= 1768 || // Mn   [2] ARABIC SMALL HIGH YEH..ARABIC SMALL HIGH NOON
            1770 <= code && code <= 1773 || // Mn   [4] ARABIC EMPTY CENTRE LOW STOP..ARABIC SMALL LOW MEEM
            code == 1809 || // Mn       SYRIAC LETTER SUPERSCRIPT ALAPH
            1840 <= code && code <= 1866 || // Mn  [27] SYRIAC PTHAHA ABOVE..SYRIAC BARREKH
            1958 <= code && code <= 1968 || // Mn  [11] THAANA ABAFILI..THAANA SUKUN
            2027 <= code && code <= 2035 || // Mn   [9] NKO COMBINING SHORT HIGH TONE..NKO COMBINING DOUBLE DOT ABOVE
            2070 <= code && code <= 2073 || // Mn   [4] SAMARITAN MARK IN..SAMARITAN MARK DAGESH
            2075 <= code && code <= 2083 || // Mn   [9] SAMARITAN MARK EPENTHETIC YUT..SAMARITAN VOWEL SIGN A
            2085 <= code && code <= 2087 || // Mn   [3] SAMARITAN VOWEL SIGN SHORT A..SAMARITAN VOWEL SIGN U
            2089 <= code && code <= 2093 || // Mn   [5] SAMARITAN VOWEL SIGN LONG I..SAMARITAN MARK NEQUDAA
            2137 <= code && code <= 2139 || // Mn   [3] MANDAIC AFFRICATION MARK..MANDAIC GEMINATION MARK
            2260 <= code && code <= 2273 || // Mn  [14] ARABIC SMALL HIGH WORD AR-RUB..ARABIC SMALL HIGH SIGN SAFHA
            2275 <= code && code <= 2306 || // Mn  [32] ARABIC TURNED DAMMA BELOW..DEVANAGARI SIGN ANUSVARA
            code == 2362 || // Mn       DEVANAGARI VOWEL SIGN OE
            code == 2364 || // Mn       DEVANAGARI SIGN NUKTA
            2369 <= code && code <= 2376 || // Mn   [8] DEVANAGARI VOWEL SIGN U..DEVANAGARI VOWEL SIGN AI
            code == 2381 || // Mn       DEVANAGARI SIGN VIRAMA
            2385 <= code && code <= 2391 || // Mn   [7] DEVANAGARI STRESS SIGN UDATTA..DEVANAGARI VOWEL SIGN UUE
            2402 <= code && code <= 2403 || // Mn   [2] DEVANAGARI VOWEL SIGN VOCALIC L..DEVANAGARI VOWEL SIGN VOCALIC LL
            code == 2433 || // Mn       BENGALI SIGN CANDRABINDU
            code == 2492 || // Mn       BENGALI SIGN NUKTA
            code == 2494 || // Mc       BENGALI VOWEL SIGN AA
            2497 <= code && code <= 2500 || // Mn   [4] BENGALI VOWEL SIGN U..BENGALI VOWEL SIGN VOCALIC RR
            code == 2509 || // Mn       BENGALI SIGN VIRAMA
            code == 2519 || // Mc       BENGALI AU LENGTH MARK
            2530 <= code && code <= 2531 || // Mn   [2] BENGALI VOWEL SIGN VOCALIC L..BENGALI VOWEL SIGN VOCALIC LL
            2561 <= code && code <= 2562 || // Mn   [2] GURMUKHI SIGN ADAK BINDI..GURMUKHI SIGN BINDI
            code == 2620 || // Mn       GURMUKHI SIGN NUKTA
            2625 <= code && code <= 2626 || // Mn   [2] GURMUKHI VOWEL SIGN U..GURMUKHI VOWEL SIGN UU
            2631 <= code && code <= 2632 || // Mn   [2] GURMUKHI VOWEL SIGN EE..GURMUKHI VOWEL SIGN AI
            2635 <= code && code <= 2637 || // Mn   [3] GURMUKHI VOWEL SIGN OO..GURMUKHI SIGN VIRAMA
            code == 2641 || // Mn       GURMUKHI SIGN UDAAT
            2672 <= code && code <= 2673 || // Mn   [2] GURMUKHI TIPPI..GURMUKHI ADDAK
            code == 2677 || // Mn       GURMUKHI SIGN YAKASH
            2689 <= code && code <= 2690 || // Mn   [2] GUJARATI SIGN CANDRABINDU..GUJARATI SIGN ANUSVARA
            code == 2748 || // Mn       GUJARATI SIGN NUKTA
            2753 <= code && code <= 2757 || // Mn   [5] GUJARATI VOWEL SIGN U..GUJARATI VOWEL SIGN CANDRA E
            2759 <= code && code <= 2760 || // Mn   [2] GUJARATI VOWEL SIGN E..GUJARATI VOWEL SIGN AI
            code == 2765 || // Mn       GUJARATI SIGN VIRAMA
            2786 <= code && code <= 2787 || // Mn   [2] GUJARATI VOWEL SIGN VOCALIC L..GUJARATI VOWEL SIGN VOCALIC LL
            2810 <= code && code <= 2815 || // Mn   [6] GUJARATI SIGN SUKUN..GUJARATI SIGN TWO-CIRCLE NUKTA ABOVE
            code == 2817 || // Mn       ORIYA SIGN CANDRABINDU
            code == 2876 || // Mn       ORIYA SIGN NUKTA
            code == 2878 || // Mc       ORIYA VOWEL SIGN AA
            code == 2879 || // Mn       ORIYA VOWEL SIGN I
            2881 <= code && code <= 2884 || // Mn   [4] ORIYA VOWEL SIGN U..ORIYA VOWEL SIGN VOCALIC RR
            code == 2893 || // Mn       ORIYA SIGN VIRAMA
            code == 2902 || // Mn       ORIYA AI LENGTH MARK
            code == 2903 || // Mc       ORIYA AU LENGTH MARK
            2914 <= code && code <= 2915 || // Mn   [2] ORIYA VOWEL SIGN VOCALIC L..ORIYA VOWEL SIGN VOCALIC LL
            code == 2946 || // Mn       TAMIL SIGN ANUSVARA
            code == 3006 || // Mc       TAMIL VOWEL SIGN AA
            code == 3008 || // Mn       TAMIL VOWEL SIGN II
            code == 3021 || // Mn       TAMIL SIGN VIRAMA
            code == 3031 || // Mc       TAMIL AU LENGTH MARK
            code == 3072 || // Mn       TELUGU SIGN COMBINING CANDRABINDU ABOVE
            3134 <= code && code <= 3136 || // Mn   [3] TELUGU VOWEL SIGN AA..TELUGU VOWEL SIGN II
            3142 <= code && code <= 3144 || // Mn   [3] TELUGU VOWEL SIGN E..TELUGU VOWEL SIGN AI
            3146 <= code && code <= 3149 || // Mn   [4] TELUGU VOWEL SIGN O..TELUGU SIGN VIRAMA
            3157 <= code && code <= 3158 || // Mn   [2] TELUGU LENGTH MARK..TELUGU AI LENGTH MARK
            3170 <= code && code <= 3171 || // Mn   [2] TELUGU VOWEL SIGN VOCALIC L..TELUGU VOWEL SIGN VOCALIC LL
            code == 3201 || // Mn       KANNADA SIGN CANDRABINDU
            code == 3260 || // Mn       KANNADA SIGN NUKTA
            code == 3263 || // Mn       KANNADA VOWEL SIGN I
            code == 3266 || // Mc       KANNADA VOWEL SIGN UU
            code == 3270 || // Mn       KANNADA VOWEL SIGN E
            3276 <= code && code <= 3277 || // Mn   [2] KANNADA VOWEL SIGN AU..KANNADA SIGN VIRAMA
            3285 <= code && code <= 3286 || // Mc   [2] KANNADA LENGTH MARK..KANNADA AI LENGTH MARK
            3298 <= code && code <= 3299 || // Mn   [2] KANNADA VOWEL SIGN VOCALIC L..KANNADA VOWEL SIGN VOCALIC LL
            3328 <= code && code <= 3329 || // Mn   [2] MALAYALAM SIGN COMBINING ANUSVARA ABOVE..MALAYALAM SIGN CANDRABINDU
            3387 <= code && code <= 3388 || // Mn   [2] MALAYALAM SIGN VERTICAL BAR VIRAMA..MALAYALAM SIGN CIRCULAR VIRAMA
            code == 3390 || // Mc       MALAYALAM VOWEL SIGN AA
            3393 <= code && code <= 3396 || // Mn   [4] MALAYALAM VOWEL SIGN U..MALAYALAM VOWEL SIGN VOCALIC RR
            code == 3405 || // Mn       MALAYALAM SIGN VIRAMA
            code == 3415 || // Mc       MALAYALAM AU LENGTH MARK
            3426 <= code && code <= 3427 || // Mn   [2] MALAYALAM VOWEL SIGN VOCALIC L..MALAYALAM VOWEL SIGN VOCALIC LL
            code == 3530 || // Mn       SINHALA SIGN AL-LAKUNA
            code == 3535 || // Mc       SINHALA VOWEL SIGN AELA-PILLA
            3538 <= code && code <= 3540 || // Mn   [3] SINHALA VOWEL SIGN KETTI IS-PILLA..SINHALA VOWEL SIGN KETTI PAA-PILLA
            code == 3542 || // Mn       SINHALA VOWEL SIGN DIGA PAA-PILLA
            code == 3551 || // Mc       SINHALA VOWEL SIGN GAYANUKITTA
            code == 3633 || // Mn       THAI CHARACTER MAI HAN-AKAT
            3636 <= code && code <= 3642 || // Mn   [7] THAI CHARACTER SARA I..THAI CHARACTER PHINTHU
            3655 <= code && code <= 3662 || // Mn   [8] THAI CHARACTER MAITAIKHU..THAI CHARACTER YAMAKKAN
            code == 3761 || // Mn       LAO VOWEL SIGN MAI KAN
            3764 <= code && code <= 3769 || // Mn   [6] LAO VOWEL SIGN I..LAO VOWEL SIGN UU
            3771 <= code && code <= 3772 || // Mn   [2] LAO VOWEL SIGN MAI KON..LAO SEMIVOWEL SIGN LO
            3784 <= code && code <= 3789 || // Mn   [6] LAO TONE MAI EK..LAO NIGGAHITA
            3864 <= code && code <= 3865 || // Mn   [2] TIBETAN ASTROLOGICAL SIGN -KHYUD PA..TIBETAN ASTROLOGICAL SIGN SDONG TSHUGS
            code == 3893 || // Mn       TIBETAN MARK NGAS BZUNG NYI ZLA
            code == 3895 || // Mn       TIBETAN MARK NGAS BZUNG SGOR RTAGS
            code == 3897 || // Mn       TIBETAN MARK TSA -PHRU
            3953 <= code && code <= 3966 || // Mn  [14] TIBETAN VOWEL SIGN AA..TIBETAN SIGN RJES SU NGA RO
            3968 <= code && code <= 3972 || // Mn   [5] TIBETAN VOWEL SIGN REVERSED I..TIBETAN MARK HALANTA
            3974 <= code && code <= 3975 || // Mn   [2] TIBETAN SIGN LCI RTAGS..TIBETAN SIGN YANG RTAGS
            3981 <= code && code <= 3991 || // Mn  [11] TIBETAN SUBJOINED SIGN LCE TSA CAN..TIBETAN SUBJOINED LETTER JA
            3993 <= code && code <= 4028 || // Mn  [36] TIBETAN SUBJOINED LETTER NYA..TIBETAN SUBJOINED LETTER FIXED-FORM RA
            code == 4038 || // Mn       TIBETAN SYMBOL PADMA GDAN
            4141 <= code && code <= 4144 || // Mn   [4] MYANMAR VOWEL SIGN I..MYANMAR VOWEL SIGN UU
            4146 <= code && code <= 4151 || // Mn   [6] MYANMAR VOWEL SIGN AI..MYANMAR SIGN DOT BELOW
            4153 <= code && code <= 4154 || // Mn   [2] MYANMAR SIGN VIRAMA..MYANMAR SIGN ASAT
            4157 <= code && code <= 4158 || // Mn   [2] MYANMAR CONSONANT SIGN MEDIAL WA..MYANMAR CONSONANT SIGN MEDIAL HA
            4184 <= code && code <= 4185 || // Mn   [2] MYANMAR VOWEL SIGN VOCALIC L..MYANMAR VOWEL SIGN VOCALIC LL
            4190 <= code && code <= 4192 || // Mn   [3] MYANMAR CONSONANT SIGN MON MEDIAL NA..MYANMAR CONSONANT SIGN MON MEDIAL LA
            4209 <= code && code <= 4212 || // Mn   [4] MYANMAR VOWEL SIGN GEBA KAREN I..MYANMAR VOWEL SIGN KAYAH EE
            code == 4226 || // Mn       MYANMAR CONSONANT SIGN SHAN MEDIAL WA
            4229 <= code && code <= 4230 || // Mn   [2] MYANMAR VOWEL SIGN SHAN E ABOVE..MYANMAR VOWEL SIGN SHAN FINAL Y
            code == 4237 || // Mn       MYANMAR SIGN SHAN COUNCIL EMPHATIC TONE
            code == 4253 || // Mn       MYANMAR VOWEL SIGN AITON AI
            4957 <= code && code <= 4959 || // Mn   [3] ETHIOPIC COMBINING GEMINATION AND VOWEL LENGTH MARK..ETHIOPIC COMBINING GEMINATION MARK
            5906 <= code && code <= 5908 || // Mn   [3] TAGALOG VOWEL SIGN I..TAGALOG SIGN VIRAMA
            5938 <= code && code <= 5940 || // Mn   [3] HANUNOO VOWEL SIGN I..HANUNOO SIGN PAMUDPOD
            5970 <= code && code <= 5971 || // Mn   [2] BUHID VOWEL SIGN I..BUHID VOWEL SIGN U
            6002 <= code && code <= 6003 || // Mn   [2] TAGBANWA VOWEL SIGN I..TAGBANWA VOWEL SIGN U
            6068 <= code && code <= 6069 || // Mn   [2] KHMER VOWEL INHERENT AQ..KHMER VOWEL INHERENT AA
            6071 <= code && code <= 6077 || // Mn   [7] KHMER VOWEL SIGN I..KHMER VOWEL SIGN UA
            code == 6086 || // Mn       KHMER SIGN NIKAHIT
            6089 <= code && code <= 6099 || // Mn  [11] KHMER SIGN MUUSIKATOAN..KHMER SIGN BATHAMASAT
            code == 6109 || // Mn       KHMER SIGN ATTHACAN
            6155 <= code && code <= 6157 || // Mn   [3] MONGOLIAN FREE VARIATION SELECTOR ONE..MONGOLIAN FREE VARIATION SELECTOR THREE
            6277 <= code && code <= 6278 || // Mn   [2] MONGOLIAN LETTER ALI GALI BALUDA..MONGOLIAN LETTER ALI GALI THREE BALUDA
            code == 6313 || // Mn       MONGOLIAN LETTER ALI GALI DAGALGA
            6432 <= code && code <= 6434 || // Mn   [3] LIMBU VOWEL SIGN A..LIMBU VOWEL SIGN U
            6439 <= code && code <= 6440 || // Mn   [2] LIMBU VOWEL SIGN E..LIMBU VOWEL SIGN O
            code == 6450 || // Mn       LIMBU SMALL LETTER ANUSVARA
            6457 <= code && code <= 6459 || // Mn   [3] LIMBU SIGN MUKPHRENG..LIMBU SIGN SA-I
            6679 <= code && code <= 6680 || // Mn   [2] BUGINESE VOWEL SIGN I..BUGINESE VOWEL SIGN U
            code == 6683 || // Mn       BUGINESE VOWEL SIGN AE
            code == 6742 || // Mn       TAI THAM CONSONANT SIGN MEDIAL LA
            6744 <= code && code <= 6750 || // Mn   [7] TAI THAM SIGN MAI KANG LAI..TAI THAM CONSONANT SIGN SA
            code == 6752 || // Mn       TAI THAM SIGN SAKOT
            code == 6754 || // Mn       TAI THAM VOWEL SIGN MAI SAT
            6757 <= code && code <= 6764 || // Mn   [8] TAI THAM VOWEL SIGN I..TAI THAM VOWEL SIGN OA BELOW
            6771 <= code && code <= 6780 || // Mn  [10] TAI THAM VOWEL SIGN OA ABOVE..TAI THAM SIGN KHUEN-LUE KARAN
            code == 6783 || // Mn       TAI THAM COMBINING CRYPTOGRAMMIC DOT
            6832 <= code && code <= 6845 || // Mn  [14] COMBINING DOUBLED CIRCUMFLEX ACCENT..COMBINING PARENTHESES BELOW
            code == 6846 || // Me       COMBINING PARENTHESES OVERLAY
            6912 <= code && code <= 6915 || // Mn   [4] BALINESE SIGN ULU RICEM..BALINESE SIGN SURANG
            code == 6964 || // Mn       BALINESE SIGN REREKAN
            6966 <= code && code <= 6970 || // Mn   [5] BALINESE VOWEL SIGN ULU..BALINESE VOWEL SIGN RA REPA
            code == 6972 || // Mn       BALINESE VOWEL SIGN LA LENGA
            code == 6978 || // Mn       BALINESE VOWEL SIGN PEPET
            7019 <= code && code <= 7027 || // Mn   [9] BALINESE MUSICAL SYMBOL COMBINING TEGEH..BALINESE MUSICAL SYMBOL COMBINING GONG
            7040 <= code && code <= 7041 || // Mn   [2] SUNDANESE SIGN PANYECEK..SUNDANESE SIGN PANGLAYAR
            7074 <= code && code <= 7077 || // Mn   [4] SUNDANESE CONSONANT SIGN PANYAKRA..SUNDANESE VOWEL SIGN PANYUKU
            7080 <= code && code <= 7081 || // Mn   [2] SUNDANESE VOWEL SIGN PAMEPET..SUNDANESE VOWEL SIGN PANEULEUNG
            7083 <= code && code <= 7085 || // Mn   [3] SUNDANESE SIGN VIRAMA..SUNDANESE CONSONANT SIGN PASANGAN WA
            code == 7142 || // Mn       BATAK SIGN TOMPI
            7144 <= code && code <= 7145 || // Mn   [2] BATAK VOWEL SIGN PAKPAK E..BATAK VOWEL SIGN EE
            code == 7149 || // Mn       BATAK VOWEL SIGN KARO O
            7151 <= code && code <= 7153 || // Mn   [3] BATAK VOWEL SIGN U FOR SIMALUNGUN SA..BATAK CONSONANT SIGN H
            7212 <= code && code <= 7219 || // Mn   [8] LEPCHA VOWEL SIGN E..LEPCHA CONSONANT SIGN T
            7222 <= code && code <= 7223 || // Mn   [2] LEPCHA SIGN RAN..LEPCHA SIGN NUKTA
            7376 <= code && code <= 7378 || // Mn   [3] VEDIC TONE KARSHANA..VEDIC TONE PRENKHA
            7380 <= code && code <= 7392 || // Mn  [13] VEDIC SIGN YAJURVEDIC MIDLINE SVARITA..VEDIC TONE RIGVEDIC KASHMIRI INDEPENDENT SVARITA
            7394 <= code && code <= 7400 || // Mn   [7] VEDIC SIGN VISARGA SVARITA..VEDIC SIGN VISARGA ANUDATTA WITH TAIL
            code == 7405 || // Mn       VEDIC SIGN TIRYAK
            code == 7412 || // Mn       VEDIC TONE CANDRA ABOVE
            7416 <= code && code <= 7417 || // Mn   [2] VEDIC TONE RING ABOVE..VEDIC TONE DOUBLE RING ABOVE
            7616 <= code && code <= 7673 || // Mn  [58] COMBINING DOTTED GRAVE ACCENT..COMBINING WIDE INVERTED BRIDGE BELOW
            7675 <= code && code <= 7679 || // Mn   [5] COMBINING DELETION MARK..COMBINING RIGHT ARROWHEAD AND DOWN ARROWHEAD BELOW
            code == 8204 || // Cf       ZERO WIDTH NON-JOINER
            8400 <= code && code <= 8412 || // Mn  [13] COMBINING LEFT HARPOON ABOVE..COMBINING FOUR DOTS ABOVE
            8413 <= code && code <= 8416 || // Me   [4] COMBINING ENCLOSING CIRCLE..COMBINING ENCLOSING CIRCLE BACKSLASH
            code == 8417 || // Mn       COMBINING LEFT RIGHT ARROW ABOVE
            8418 <= code && code <= 8420 || // Me   [3] COMBINING ENCLOSING SCREEN..COMBINING ENCLOSING UPWARD POINTING TRIANGLE
            8421 <= code && code <= 8432 || // Mn  [12] COMBINING REVERSE SOLIDUS OVERLAY..COMBINING ASTERISK ABOVE
            11503 <= code && code <= 11505 || // Mn   [3] COPTIC COMBINING NI ABOVE..COPTIC COMBINING SPIRITUS LENIS
            code == 11647 || // Mn       TIFINAGH CONSONANT JOINER
            11744 <= code && code <= 11775 || // Mn  [32] COMBINING CYRILLIC LETTER BE..COMBINING CYRILLIC LETTER IOTIFIED BIG YUS
            12330 <= code && code <= 12333 || // Mn   [4] IDEOGRAPHIC LEVEL TONE MARK..IDEOGRAPHIC ENTERING TONE MARK
            12334 <= code && code <= 12335 || // Mc   [2] HANGUL SINGLE DOT TONE MARK..HANGUL DOUBLE DOT TONE MARK
            12441 <= code && code <= 12442 || // Mn   [2] COMBINING KATAKANA-HIRAGANA VOICED SOUND MARK..COMBINING KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK
            code == 42607 || // Mn       COMBINING CYRILLIC VZMET
            42608 <= code && code <= 42610 || // Me   [3] COMBINING CYRILLIC TEN MILLIONS SIGN..COMBINING CYRILLIC THOUSAND MILLIONS SIGN
            42612 <= code && code <= 42621 || // Mn  [10] COMBINING CYRILLIC LETTER UKRAINIAN IE..COMBINING CYRILLIC PAYEROK
            42654 <= code && code <= 42655 || // Mn   [2] COMBINING CYRILLIC LETTER EF..COMBINING CYRILLIC LETTER IOTIFIED E
            42736 <= code && code <= 42737 || // Mn   [2] BAMUM COMBINING MARK KOQNDON..BAMUM COMBINING MARK TUKWENTIS
            code == 43010 || // Mn       SYLOTI NAGRI SIGN DVISVARA
            code == 43014 || // Mn       SYLOTI NAGRI SIGN HASANTA
            code == 43019 || // Mn       SYLOTI NAGRI SIGN ANUSVARA
            43045 <= code && code <= 43046 || // Mn   [2] SYLOTI NAGRI VOWEL SIGN U..SYLOTI NAGRI VOWEL SIGN E
            43204 <= code && code <= 43205 || // Mn   [2] SAURASHTRA SIGN VIRAMA..SAURASHTRA SIGN CANDRABINDU
            43232 <= code && code <= 43249 || // Mn  [18] COMBINING DEVANAGARI DIGIT ZERO..COMBINING DEVANAGARI SIGN AVAGRAHA
            43302 <= code && code <= 43309 || // Mn   [8] KAYAH LI VOWEL UE..KAYAH LI TONE CALYA PLOPHU
            43335 <= code && code <= 43345 || // Mn  [11] REJANG VOWEL SIGN I..REJANG CONSONANT SIGN R
            43392 <= code && code <= 43394 || // Mn   [3] JAVANESE SIGN PANYANGGA..JAVANESE SIGN LAYAR
            code == 43443 || // Mn       JAVANESE SIGN CECAK TELU
            43446 <= code && code <= 43449 || // Mn   [4] JAVANESE VOWEL SIGN WULU..JAVANESE VOWEL SIGN SUKU MENDUT
            code == 43452 || // Mn       JAVANESE VOWEL SIGN PEPET
            code == 43493 || // Mn       MYANMAR SIGN SHAN SAW
            43561 <= code && code <= 43566 || // Mn   [6] CHAM VOWEL SIGN AA..CHAM VOWEL SIGN OE
            43569 <= code && code <= 43570 || // Mn   [2] CHAM VOWEL SIGN AU..CHAM VOWEL SIGN UE
            43573 <= code && code <= 43574 || // Mn   [2] CHAM CONSONANT SIGN LA..CHAM CONSONANT SIGN WA
            code == 43587 || // Mn       CHAM CONSONANT SIGN FINAL NG
            code == 43596 || // Mn       CHAM CONSONANT SIGN FINAL M
            code == 43644 || // Mn       MYANMAR SIGN TAI LAING TONE-2
            code == 43696 || // Mn       TAI VIET MAI KANG
            43698 <= code && code <= 43700 || // Mn   [3] TAI VIET VOWEL I..TAI VIET VOWEL U
            43703 <= code && code <= 43704 || // Mn   [2] TAI VIET MAI KHIT..TAI VIET VOWEL IA
            43710 <= code && code <= 43711 || // Mn   [2] TAI VIET VOWEL AM..TAI VIET TONE MAI EK
            code == 43713 || // Mn       TAI VIET TONE MAI THO
            43756 <= code && code <= 43757 || // Mn   [2] MEETEI MAYEK VOWEL SIGN UU..MEETEI MAYEK VOWEL SIGN AAI
            code == 43766 || // Mn       MEETEI MAYEK VIRAMA
            code == 44005 || // Mn       MEETEI MAYEK VOWEL SIGN ANAP
            code == 44008 || // Mn       MEETEI MAYEK VOWEL SIGN UNAP
            code == 44013 || // Mn       MEETEI MAYEK APUN IYEK
            code == 64286 || // Mn       HEBREW POINT JUDEO-SPANISH VARIKA
            65024 <= code && code <= 65039 || // Mn  [16] VARIATION SELECTOR-1..VARIATION SELECTOR-16
            65056 <= code && code <= 65071 || // Mn  [16] COMBINING LIGATURE LEFT HALF..COMBINING CYRILLIC TITLO RIGHT HALF
            65438 <= code && code <= 65439 || // Lm   [2] HALFWIDTH KATAKANA VOICED SOUND MARK..HALFWIDTH KATAKANA SEMI-VOICED SOUND MARK
            code == 66045 || // Mn       PHAISTOS DISC SIGN COMBINING OBLIQUE STROKE
            code == 66272 || // Mn       COPTIC EPACT THOUSANDS MARK
            66422 <= code && code <= 66426 || // Mn   [5] COMBINING OLD PERMIC LETTER AN..COMBINING OLD PERMIC LETTER SII
            68097 <= code && code <= 68099 || // Mn   [3] KHAROSHTHI VOWEL SIGN I..KHAROSHTHI VOWEL SIGN VOCALIC R
            68101 <= code && code <= 68102 || // Mn   [2] KHAROSHTHI VOWEL SIGN E..KHAROSHTHI VOWEL SIGN O
            68108 <= code && code <= 68111 || // Mn   [4] KHAROSHTHI VOWEL LENGTH MARK..KHAROSHTHI SIGN VISARGA
            68152 <= code && code <= 68154 || // Mn   [3] KHAROSHTHI SIGN BAR ABOVE..KHAROSHTHI SIGN DOT BELOW
            code == 68159 || // Mn       KHAROSHTHI VIRAMA
            68325 <= code && code <= 68326 || // Mn   [2] MANICHAEAN ABBREVIATION MARK ABOVE..MANICHAEAN ABBREVIATION MARK BELOW
            code == 69633 || // Mn       BRAHMI SIGN ANUSVARA
            69688 <= code && code <= 69702 || // Mn  [15] BRAHMI VOWEL SIGN AA..BRAHMI VIRAMA
            69759 <= code && code <= 69761 || // Mn   [3] BRAHMI NUMBER JOINER..KAITHI SIGN ANUSVARA
            69811 <= code && code <= 69814 || // Mn   [4] KAITHI VOWEL SIGN U..KAITHI VOWEL SIGN AI
            69817 <= code && code <= 69818 || // Mn   [2] KAITHI SIGN VIRAMA..KAITHI SIGN NUKTA
            69888 <= code && code <= 69890 || // Mn   [3] CHAKMA SIGN CANDRABINDU..CHAKMA SIGN VISARGA
            69927 <= code && code <= 69931 || // Mn   [5] CHAKMA VOWEL SIGN A..CHAKMA VOWEL SIGN UU
            69933 <= code && code <= 69940 || // Mn   [8] CHAKMA VOWEL SIGN AI..CHAKMA MAAYYAA
            code == 70003 || // Mn       MAHAJANI SIGN NUKTA
            70016 <= code && code <= 70017 || // Mn   [2] SHARADA SIGN CANDRABINDU..SHARADA SIGN ANUSVARA
            70070 <= code && code <= 70078 || // Mn   [9] SHARADA VOWEL SIGN U..SHARADA VOWEL SIGN O
            70090 <= code && code <= 70092 || // Mn   [3] SHARADA SIGN NUKTA..SHARADA EXTRA SHORT VOWEL MARK
            70191 <= code && code <= 70193 || // Mn   [3] KHOJKI VOWEL SIGN U..KHOJKI VOWEL SIGN AI
            code == 70196 || // Mn       KHOJKI SIGN ANUSVARA
            70198 <= code && code <= 70199 || // Mn   [2] KHOJKI SIGN NUKTA..KHOJKI SIGN SHADDA
            code == 70206 || // Mn       KHOJKI SIGN SUKUN
            code == 70367 || // Mn       KHUDAWADI SIGN ANUSVARA
            70371 <= code && code <= 70378 || // Mn   [8] KHUDAWADI VOWEL SIGN U..KHUDAWADI SIGN VIRAMA
            70400 <= code && code <= 70401 || // Mn   [2] GRANTHA SIGN COMBINING ANUSVARA ABOVE..GRANTHA SIGN CANDRABINDU
            code == 70460 || // Mn       GRANTHA SIGN NUKTA
            code == 70462 || // Mc       GRANTHA VOWEL SIGN AA
            code == 70464 || // Mn       GRANTHA VOWEL SIGN II
            code == 70487 || // Mc       GRANTHA AU LENGTH MARK
            70502 <= code && code <= 70508 || // Mn   [7] COMBINING GRANTHA DIGIT ZERO..COMBINING GRANTHA DIGIT SIX
            70512 <= code && code <= 70516 || // Mn   [5] COMBINING GRANTHA LETTER A..COMBINING GRANTHA LETTER PA
            70712 <= code && code <= 70719 || // Mn   [8] NEWA VOWEL SIGN U..NEWA VOWEL SIGN AI
            70722 <= code && code <= 70724 || // Mn   [3] NEWA SIGN VIRAMA..NEWA SIGN ANUSVARA
            code == 70726 || // Mn       NEWA SIGN NUKTA
            code == 70832 || // Mc       TIRHUTA VOWEL SIGN AA
            70835 <= code && code <= 70840 || // Mn   [6] TIRHUTA VOWEL SIGN U..TIRHUTA VOWEL SIGN VOCALIC LL
            code == 70842 || // Mn       TIRHUTA VOWEL SIGN SHORT E
            code == 70845 || // Mc       TIRHUTA VOWEL SIGN SHORT O
            70847 <= code && code <= 70848 || // Mn   [2] TIRHUTA SIGN CANDRABINDU..TIRHUTA SIGN ANUSVARA
            70850 <= code && code <= 70851 || // Mn   [2] TIRHUTA SIGN VIRAMA..TIRHUTA SIGN NUKTA
            code == 71087 || // Mc       SIDDHAM VOWEL SIGN AA
            71090 <= code && code <= 71093 || // Mn   [4] SIDDHAM VOWEL SIGN U..SIDDHAM VOWEL SIGN VOCALIC RR
            71100 <= code && code <= 71101 || // Mn   [2] SIDDHAM SIGN CANDRABINDU..SIDDHAM SIGN ANUSVARA
            71103 <= code && code <= 71104 || // Mn   [2] SIDDHAM SIGN VIRAMA..SIDDHAM SIGN NUKTA
            71132 <= code && code <= 71133 || // Mn   [2] SIDDHAM VOWEL SIGN ALTERNATE U..SIDDHAM VOWEL SIGN ALTERNATE UU
            71219 <= code && code <= 71226 || // Mn   [8] MODI VOWEL SIGN U..MODI VOWEL SIGN AI
            code == 71229 || // Mn       MODI SIGN ANUSVARA
            71231 <= code && code <= 71232 || // Mn   [2] MODI SIGN VIRAMA..MODI SIGN ARDHACANDRA
            code == 71339 || // Mn       TAKRI SIGN ANUSVARA
            code == 71341 || // Mn       TAKRI VOWEL SIGN AA
            71344 <= code && code <= 71349 || // Mn   [6] TAKRI VOWEL SIGN U..TAKRI VOWEL SIGN AU
            code == 71351 || // Mn       TAKRI SIGN NUKTA
            71453 <= code && code <= 71455 || // Mn   [3] AHOM CONSONANT SIGN MEDIAL LA..AHOM CONSONANT SIGN MEDIAL LIGATING RA
            71458 <= code && code <= 71461 || // Mn   [4] AHOM VOWEL SIGN I..AHOM VOWEL SIGN UU
            71463 <= code && code <= 71467 || // Mn   [5] AHOM VOWEL SIGN AW..AHOM SIGN KILLER
            72193 <= code && code <= 72198 || // Mn   [6] ZANABAZAR SQUARE VOWEL SIGN I..ZANABAZAR SQUARE VOWEL SIGN O
            72201 <= code && code <= 72202 || // Mn   [2] ZANABAZAR SQUARE VOWEL SIGN REVERSED I..ZANABAZAR SQUARE VOWEL LENGTH MARK
            72243 <= code && code <= 72248 || // Mn   [6] ZANABAZAR SQUARE FINAL CONSONANT MARK..ZANABAZAR SQUARE SIGN ANUSVARA
            72251 <= code && code <= 72254 || // Mn   [4] ZANABAZAR SQUARE CLUSTER-FINAL LETTER YA..ZANABAZAR SQUARE CLUSTER-FINAL LETTER VA
            code == 72263 || // Mn       ZANABAZAR SQUARE SUBJOINER
            72273 <= code && code <= 72278 || // Mn   [6] SOYOMBO VOWEL SIGN I..SOYOMBO VOWEL SIGN OE
            72281 <= code && code <= 72283 || // Mn   [3] SOYOMBO VOWEL SIGN VOCALIC R..SOYOMBO VOWEL LENGTH MARK
            72330 <= code && code <= 72342 || // Mn  [13] SOYOMBO FINAL CONSONANT SIGN G..SOYOMBO SIGN ANUSVARA
            72344 <= code && code <= 72345 || // Mn   [2] SOYOMBO GEMINATION MARK..SOYOMBO SUBJOINER
            72752 <= code && code <= 72758 || // Mn   [7] BHAIKSUKI VOWEL SIGN I..BHAIKSUKI VOWEL SIGN VOCALIC L
            72760 <= code && code <= 72765 || // Mn   [6] BHAIKSUKI VOWEL SIGN E..BHAIKSUKI SIGN ANUSVARA
            code == 72767 || // Mn       BHAIKSUKI SIGN VIRAMA
            72850 <= code && code <= 72871 || // Mn  [22] MARCHEN SUBJOINED LETTER KA..MARCHEN SUBJOINED LETTER ZA
            72874 <= code && code <= 72880 || // Mn   [7] MARCHEN SUBJOINED LETTER RA..MARCHEN VOWEL SIGN AA
            72882 <= code && code <= 72883 || // Mn   [2] MARCHEN VOWEL SIGN U..MARCHEN VOWEL SIGN E
            72885 <= code && code <= 72886 || // Mn   [2] MARCHEN SIGN ANUSVARA..MARCHEN SIGN CANDRABINDU
            73009 <= code && code <= 73014 || // Mn   [6] MASARAM GONDI VOWEL SIGN AA..MASARAM GONDI VOWEL SIGN VOCALIC R
            code == 73018 || // Mn       MASARAM GONDI VOWEL SIGN E
            73020 <= code && code <= 73021 || // Mn   [2] MASARAM GONDI VOWEL SIGN AI..MASARAM GONDI VOWEL SIGN O
            73023 <= code && code <= 73029 || // Mn   [7] MASARAM GONDI VOWEL SIGN AU..MASARAM GONDI VIRAMA
            code == 73031 || // Mn       MASARAM GONDI RA-KARA
            92912 <= code && code <= 92916 || // Mn   [5] BASSA VAH COMBINING HIGH TONE..BASSA VAH COMBINING HIGH-LOW TONE
            92976 <= code && code <= 92982 || // Mn   [7] PAHAWH HMONG MARK CIM TUB..PAHAWH HMONG MARK CIM TAUM
            94095 <= code && code <= 94098 || // Mn   [4] MIAO TONE RIGHT..MIAO TONE BELOW
            113821 <= code && code <= 113822 || // Mn   [2] DUPLOYAN THICK LETTER SELECTOR..DUPLOYAN DOUBLE MARK
            code == 119141 || // Mc       MUSICAL SYMBOL COMBINING STEM
            119143 <= code && code <= 119145 || // Mn   [3] MUSICAL SYMBOL COMBINING TREMOLO-1..MUSICAL SYMBOL COMBINING TREMOLO-3
            119150 <= code && code <= 119154 || // Mc   [5] MUSICAL SYMBOL COMBINING FLAG-1..MUSICAL SYMBOL COMBINING FLAG-5
            119163 <= code && code <= 119170 || // Mn   [8] MUSICAL SYMBOL COMBINING ACCENT..MUSICAL SYMBOL COMBINING LOURE
            119173 <= code && code <= 119179 || // Mn   [7] MUSICAL SYMBOL COMBINING DOIT..MUSICAL SYMBOL COMBINING TRIPLE TONGUE
            119210 <= code && code <= 119213 || // Mn   [4] MUSICAL SYMBOL COMBINING DOWN BOW..MUSICAL SYMBOL COMBINING SNAP PIZZICATO
            119362 <= code && code <= 119364 || // Mn   [3] COMBINING GREEK MUSICAL TRISEME..COMBINING GREEK MUSICAL PENTASEME
            121344 <= code && code <= 121398 || // Mn  [55] SIGNWRITING HEAD RIM..SIGNWRITING AIR SUCKING IN
            121403 <= code && code <= 121452 || // Mn  [50] SIGNWRITING MOUTH CLOSED NEUTRAL..SIGNWRITING EXCITEMENT
            code == 121461 || // Mn       SIGNWRITING UPPER BODY TILTING FROM HIP JOINTS
            code == 121476 || // Mn       SIGNWRITING LOCATION HEAD NECK
            121499 <= code && code <= 121503 || // Mn   [5] SIGNWRITING FILL MODIFIER-2..SIGNWRITING FILL MODIFIER-6
            121505 <= code && code <= 121519 || // Mn  [15] SIGNWRITING ROTATION MODIFIER-2..SIGNWRITING ROTATION MODIFIER-16
            122880 <= code && code <= 122886 || // Mn   [7] COMBINING GLAGOLITIC LETTER AZU..COMBINING GLAGOLITIC LETTER ZHIVETE
            122888 <= code && code <= 122904 || // Mn  [17] COMBINING GLAGOLITIC LETTER ZEMLJA..COMBINING GLAGOLITIC LETTER HERU
            122907 <= code && code <= 122913 || // Mn   [7] COMBINING GLAGOLITIC LETTER SHTA..COMBINING GLAGOLITIC LETTER YATI
            122915 <= code && code <= 122916 || // Mn   [2] COMBINING GLAGOLITIC LETTER YU..COMBINING GLAGOLITIC LETTER SMALL YUS
            122918 <= code && code <= 122922 || // Mn   [5] COMBINING GLAGOLITIC LETTER YO..COMBINING GLAGOLITIC LETTER FITA
            125136 <= code && code <= 125142 || // Mn   [7] MENDE KIKAKUI COMBINING NUMBER TEENS..MENDE KIKAKUI COMBINING NUMBER MILLIONS
            125252 <= code && code <= 125258 || // Mn   [7] ADLAM ALIF LENGTHENER..ADLAM NUKTA
            917536 <= code && code <= 917631 || // Cf  [96] TAG SPACE..CANCEL TAG
            917760 <= code && code <= 917999 ? Extend : 127462 <= code && code <= 127487 ? Regional_Indicator : code == 2307 || // Mc       DEVANAGARI SIGN VISARGA
            code == 2363 || // Mc       DEVANAGARI VOWEL SIGN OOE
            2366 <= code && code <= 2368 || // Mc   [3] DEVANAGARI VOWEL SIGN AA..DEVANAGARI VOWEL SIGN II
            2377 <= code && code <= 2380 || // Mc   [4] DEVANAGARI VOWEL SIGN CANDRA O..DEVANAGARI VOWEL SIGN AU
            2382 <= code && code <= 2383 || // Mc   [2] DEVANAGARI VOWEL SIGN PRISHTHAMATRA E..DEVANAGARI VOWEL SIGN AW
            2434 <= code && code <= 2435 || // Mc   [2] BENGALI SIGN ANUSVARA..BENGALI SIGN VISARGA
            2495 <= code && code <= 2496 || // Mc   [2] BENGALI VOWEL SIGN I..BENGALI VOWEL SIGN II
            2503 <= code && code <= 2504 || // Mc   [2] BENGALI VOWEL SIGN E..BENGALI VOWEL SIGN AI
            2507 <= code && code <= 2508 || // Mc   [2] BENGALI VOWEL SIGN O..BENGALI VOWEL SIGN AU
            code == 2563 || // Mc       GURMUKHI SIGN VISARGA
            2622 <= code && code <= 2624 || // Mc   [3] GURMUKHI VOWEL SIGN AA..GURMUKHI VOWEL SIGN II
            code == 2691 || // Mc       GUJARATI SIGN VISARGA
            2750 <= code && code <= 2752 || // Mc   [3] GUJARATI VOWEL SIGN AA..GUJARATI VOWEL SIGN II
            code == 2761 || // Mc       GUJARATI VOWEL SIGN CANDRA O
            2763 <= code && code <= 2764 || // Mc   [2] GUJARATI VOWEL SIGN O..GUJARATI VOWEL SIGN AU
            2818 <= code && code <= 2819 || // Mc   [2] ORIYA SIGN ANUSVARA..ORIYA SIGN VISARGA
            code == 2880 || // Mc       ORIYA VOWEL SIGN II
            2887 <= code && code <= 2888 || // Mc   [2] ORIYA VOWEL SIGN E..ORIYA VOWEL SIGN AI
            2891 <= code && code <= 2892 || // Mc   [2] ORIYA VOWEL SIGN O..ORIYA VOWEL SIGN AU
            code == 3007 || // Mc       TAMIL VOWEL SIGN I
            3009 <= code && code <= 3010 || // Mc   [2] TAMIL VOWEL SIGN U..TAMIL VOWEL SIGN UU
            3014 <= code && code <= 3016 || // Mc   [3] TAMIL VOWEL SIGN E..TAMIL VOWEL SIGN AI
            3018 <= code && code <= 3020 || // Mc   [3] TAMIL VOWEL SIGN O..TAMIL VOWEL SIGN AU
            3073 <= code && code <= 3075 || // Mc   [3] TELUGU SIGN CANDRABINDU..TELUGU SIGN VISARGA
            3137 <= code && code <= 3140 || // Mc   [4] TELUGU VOWEL SIGN U..TELUGU VOWEL SIGN VOCALIC RR
            3202 <= code && code <= 3203 || // Mc   [2] KANNADA SIGN ANUSVARA..KANNADA SIGN VISARGA
            code == 3262 || // Mc       KANNADA VOWEL SIGN AA
            3264 <= code && code <= 3265 || // Mc   [2] KANNADA VOWEL SIGN II..KANNADA VOWEL SIGN U
            3267 <= code && code <= 3268 || // Mc   [2] KANNADA VOWEL SIGN VOCALIC R..KANNADA VOWEL SIGN VOCALIC RR
            3271 <= code && code <= 3272 || // Mc   [2] KANNADA VOWEL SIGN EE..KANNADA VOWEL SIGN AI
            3274 <= code && code <= 3275 || // Mc   [2] KANNADA VOWEL SIGN O..KANNADA VOWEL SIGN OO
            3330 <= code && code <= 3331 || // Mc   [2] MALAYALAM SIGN ANUSVARA..MALAYALAM SIGN VISARGA
            3391 <= code && code <= 3392 || // Mc   [2] MALAYALAM VOWEL SIGN I..MALAYALAM VOWEL SIGN II
            3398 <= code && code <= 3400 || // Mc   [3] MALAYALAM VOWEL SIGN E..MALAYALAM VOWEL SIGN AI
            3402 <= code && code <= 3404 || // Mc   [3] MALAYALAM VOWEL SIGN O..MALAYALAM VOWEL SIGN AU
            3458 <= code && code <= 3459 || // Mc   [2] SINHALA SIGN ANUSVARAYA..SINHALA SIGN VISARGAYA
            3536 <= code && code <= 3537 || // Mc   [2] SINHALA VOWEL SIGN KETTI AEDA-PILLA..SINHALA VOWEL SIGN DIGA AEDA-PILLA
            3544 <= code && code <= 3550 || // Mc   [7] SINHALA VOWEL SIGN GAETTA-PILLA..SINHALA VOWEL SIGN KOMBUVA HAA GAYANUKITTA
            3570 <= code && code <= 3571 || // Mc   [2] SINHALA VOWEL SIGN DIGA GAETTA-PILLA..SINHALA VOWEL SIGN DIGA GAYANUKITTA
            code == 3635 || // Lo       THAI CHARACTER SARA AM
            code == 3763 || // Lo       LAO VOWEL SIGN AM
            3902 <= code && code <= 3903 || // Mc   [2] TIBETAN SIGN YAR TSHES..TIBETAN SIGN MAR TSHES
            code == 3967 || // Mc       TIBETAN SIGN RNAM BCAD
            code == 4145 || // Mc       MYANMAR VOWEL SIGN E
            4155 <= code && code <= 4156 || // Mc   [2] MYANMAR CONSONANT SIGN MEDIAL YA..MYANMAR CONSONANT SIGN MEDIAL RA
            4182 <= code && code <= 4183 || // Mc   [2] MYANMAR VOWEL SIGN VOCALIC R..MYANMAR VOWEL SIGN VOCALIC RR
            code == 4228 || // Mc       MYANMAR VOWEL SIGN SHAN E
            code == 6070 || // Mc       KHMER VOWEL SIGN AA
            6078 <= code && code <= 6085 || // Mc   [8] KHMER VOWEL SIGN OE..KHMER VOWEL SIGN AU
            6087 <= code && code <= 6088 || // Mc   [2] KHMER SIGN REAHMUK..KHMER SIGN YUUKALEAPINTU
            6435 <= code && code <= 6438 || // Mc   [4] LIMBU VOWEL SIGN EE..LIMBU VOWEL SIGN AU
            6441 <= code && code <= 6443 || // Mc   [3] LIMBU SUBJOINED LETTER YA..LIMBU SUBJOINED LETTER WA
            6448 <= code && code <= 6449 || // Mc   [2] LIMBU SMALL LETTER KA..LIMBU SMALL LETTER NGA
            6451 <= code && code <= 6456 || // Mc   [6] LIMBU SMALL LETTER TA..LIMBU SMALL LETTER LA
            6681 <= code && code <= 6682 || // Mc   [2] BUGINESE VOWEL SIGN E..BUGINESE VOWEL SIGN O
            code == 6741 || // Mc       TAI THAM CONSONANT SIGN MEDIAL RA
            code == 6743 || // Mc       TAI THAM CONSONANT SIGN LA TANG LAI
            6765 <= code && code <= 6770 || // Mc   [6] TAI THAM VOWEL SIGN OY..TAI THAM VOWEL SIGN THAM AI
            code == 6916 || // Mc       BALINESE SIGN BISAH
            code == 6965 || // Mc       BALINESE VOWEL SIGN TEDUNG
            code == 6971 || // Mc       BALINESE VOWEL SIGN RA REPA TEDUNG
            6973 <= code && code <= 6977 || // Mc   [5] BALINESE VOWEL SIGN LA LENGA TEDUNG..BALINESE VOWEL SIGN TALING REPA TEDUNG
            6979 <= code && code <= 6980 || // Mc   [2] BALINESE VOWEL SIGN PEPET TEDUNG..BALINESE ADEG ADEG
            code == 7042 || // Mc       SUNDANESE SIGN PANGWISAD
            code == 7073 || // Mc       SUNDANESE CONSONANT SIGN PAMINGKAL
            7078 <= code && code <= 7079 || // Mc   [2] SUNDANESE VOWEL SIGN PANAELAENG..SUNDANESE VOWEL SIGN PANOLONG
            code == 7082 || // Mc       SUNDANESE SIGN PAMAAEH
            code == 7143 || // Mc       BATAK VOWEL SIGN E
            7146 <= code && code <= 7148 || // Mc   [3] BATAK VOWEL SIGN I..BATAK VOWEL SIGN O
            code == 7150 || // Mc       BATAK VOWEL SIGN U
            7154 <= code && code <= 7155 || // Mc   [2] BATAK PANGOLAT..BATAK PANONGONAN
            7204 <= code && code <= 7211 || // Mc   [8] LEPCHA SUBJOINED LETTER YA..LEPCHA VOWEL SIGN UU
            7220 <= code && code <= 7221 || // Mc   [2] LEPCHA CONSONANT SIGN NYIN-DO..LEPCHA CONSONANT SIGN KANG
            code == 7393 || // Mc       VEDIC TONE ATHARVAVEDIC INDEPENDENT SVARITA
            7410 <= code && code <= 7411 || // Mc   [2] VEDIC SIGN ARDHAVISARGA..VEDIC SIGN ROTATED ARDHAVISARGA
            code == 7415 || // Mc       VEDIC SIGN ATIKRAMA
            43043 <= code && code <= 43044 || // Mc   [2] SYLOTI NAGRI VOWEL SIGN A..SYLOTI NAGRI VOWEL SIGN I
            code == 43047 || // Mc       SYLOTI NAGRI VOWEL SIGN OO
            43136 <= code && code <= 43137 || // Mc   [2] SAURASHTRA SIGN ANUSVARA..SAURASHTRA SIGN VISARGA
            43188 <= code && code <= 43203 || // Mc  [16] SAURASHTRA CONSONANT SIGN HAARU..SAURASHTRA VOWEL SIGN AU
            43346 <= code && code <= 43347 || // Mc   [2] REJANG CONSONANT SIGN H..REJANG VIRAMA
            code == 43395 || // Mc       JAVANESE SIGN WIGNYAN
            43444 <= code && code <= 43445 || // Mc   [2] JAVANESE VOWEL SIGN TARUNG..JAVANESE VOWEL SIGN TOLONG
            43450 <= code && code <= 43451 || // Mc   [2] JAVANESE VOWEL SIGN TALING..JAVANESE VOWEL SIGN DIRGA MURE
            43453 <= code && code <= 43456 || // Mc   [4] JAVANESE CONSONANT SIGN KERET..JAVANESE PANGKON
            43567 <= code && code <= 43568 || // Mc   [2] CHAM VOWEL SIGN O..CHAM VOWEL SIGN AI
            43571 <= code && code <= 43572 || // Mc   [2] CHAM CONSONANT SIGN YA..CHAM CONSONANT SIGN RA
            code == 43597 || // Mc       CHAM CONSONANT SIGN FINAL H
            code == 43755 || // Mc       MEETEI MAYEK VOWEL SIGN II
            43758 <= code && code <= 43759 || // Mc   [2] MEETEI MAYEK VOWEL SIGN AU..MEETEI MAYEK VOWEL SIGN AAU
            code == 43765 || // Mc       MEETEI MAYEK VOWEL SIGN VISARGA
            44003 <= code && code <= 44004 || // Mc   [2] MEETEI MAYEK VOWEL SIGN ONAP..MEETEI MAYEK VOWEL SIGN INAP
            44006 <= code && code <= 44007 || // Mc   [2] MEETEI MAYEK VOWEL SIGN YENAP..MEETEI MAYEK VOWEL SIGN SOUNAP
            44009 <= code && code <= 44010 || // Mc   [2] MEETEI MAYEK VOWEL SIGN CHEINAP..MEETEI MAYEK VOWEL SIGN NUNG
            code == 44012 || // Mc       MEETEI MAYEK LUM IYEK
            code == 69632 || // Mc       BRAHMI SIGN CANDRABINDU
            code == 69634 || // Mc       BRAHMI SIGN VISARGA
            code == 69762 || // Mc       KAITHI SIGN VISARGA
            69808 <= code && code <= 69810 || // Mc   [3] KAITHI VOWEL SIGN AA..KAITHI VOWEL SIGN II
            69815 <= code && code <= 69816 || // Mc   [2] KAITHI VOWEL SIGN O..KAITHI VOWEL SIGN AU
            code == 69932 || // Mc       CHAKMA VOWEL SIGN E
            code == 70018 || // Mc       SHARADA SIGN VISARGA
            70067 <= code && code <= 70069 || // Mc   [3] SHARADA VOWEL SIGN AA..SHARADA VOWEL SIGN II
            70079 <= code && code <= 70080 || // Mc   [2] SHARADA VOWEL SIGN AU..SHARADA SIGN VIRAMA
            70188 <= code && code <= 70190 || // Mc   [3] KHOJKI VOWEL SIGN AA..KHOJKI VOWEL SIGN II
            70194 <= code && code <= 70195 || // Mc   [2] KHOJKI VOWEL SIGN O..KHOJKI VOWEL SIGN AU
            code == 70197 || // Mc       KHOJKI SIGN VIRAMA
            70368 <= code && code <= 70370 || // Mc   [3] KHUDAWADI VOWEL SIGN AA..KHUDAWADI VOWEL SIGN II
            70402 <= code && code <= 70403 || // Mc   [2] GRANTHA SIGN ANUSVARA..GRANTHA SIGN VISARGA
            code == 70463 || // Mc       GRANTHA VOWEL SIGN I
            70465 <= code && code <= 70468 || // Mc   [4] GRANTHA VOWEL SIGN U..GRANTHA VOWEL SIGN VOCALIC RR
            70471 <= code && code <= 70472 || // Mc   [2] GRANTHA VOWEL SIGN EE..GRANTHA VOWEL SIGN AI
            70475 <= code && code <= 70477 || // Mc   [3] GRANTHA VOWEL SIGN OO..GRANTHA SIGN VIRAMA
            70498 <= code && code <= 70499 || // Mc   [2] GRANTHA VOWEL SIGN VOCALIC L..GRANTHA VOWEL SIGN VOCALIC LL
            70709 <= code && code <= 70711 || // Mc   [3] NEWA VOWEL SIGN AA..NEWA VOWEL SIGN II
            70720 <= code && code <= 70721 || // Mc   [2] NEWA VOWEL SIGN O..NEWA VOWEL SIGN AU
            code == 70725 || // Mc       NEWA SIGN VISARGA
            70833 <= code && code <= 70834 || // Mc   [2] TIRHUTA VOWEL SIGN I..TIRHUTA VOWEL SIGN II
            code == 70841 || // Mc       TIRHUTA VOWEL SIGN E
            70843 <= code && code <= 70844 || // Mc   [2] TIRHUTA VOWEL SIGN AI..TIRHUTA VOWEL SIGN O
            code == 70846 || // Mc       TIRHUTA VOWEL SIGN AU
            code == 70849 || // Mc       TIRHUTA SIGN VISARGA
            71088 <= code && code <= 71089 || // Mc   [2] SIDDHAM VOWEL SIGN I..SIDDHAM VOWEL SIGN II
            71096 <= code && code <= 71099 || // Mc   [4] SIDDHAM VOWEL SIGN E..SIDDHAM VOWEL SIGN AU
            code == 71102 || // Mc       SIDDHAM SIGN VISARGA
            71216 <= code && code <= 71218 || // Mc   [3] MODI VOWEL SIGN AA..MODI VOWEL SIGN II
            71227 <= code && code <= 71228 || // Mc   [2] MODI VOWEL SIGN O..MODI VOWEL SIGN AU
            code == 71230 || // Mc       MODI SIGN VISARGA
            code == 71340 || // Mc       TAKRI SIGN VISARGA
            71342 <= code && code <= 71343 || // Mc   [2] TAKRI VOWEL SIGN I..TAKRI VOWEL SIGN II
            code == 71350 || // Mc       TAKRI SIGN VIRAMA
            71456 <= code && code <= 71457 || // Mc   [2] AHOM VOWEL SIGN A..AHOM VOWEL SIGN AA
            code == 71462 || // Mc       AHOM VOWEL SIGN E
            72199 <= code && code <= 72200 || // Mc   [2] ZANABAZAR SQUARE VOWEL SIGN AI..ZANABAZAR SQUARE VOWEL SIGN AU
            code == 72249 || // Mc       ZANABAZAR SQUARE SIGN VISARGA
            72279 <= code && code <= 72280 || // Mc   [2] SOYOMBO VOWEL SIGN AI..SOYOMBO VOWEL SIGN AU
            code == 72343 || // Mc       SOYOMBO SIGN VISARGA
            code == 72751 || // Mc       BHAIKSUKI VOWEL SIGN AA
            code == 72766 || // Mc       BHAIKSUKI SIGN VISARGA
            code == 72873 || // Mc       MARCHEN SUBJOINED LETTER YA
            code == 72881 || // Mc       MARCHEN VOWEL SIGN I
            code == 72884 || // Mc       MARCHEN VOWEL SIGN O
            94033 <= code && code <= 94078 || // Mc  [46] MIAO SIGN ASPIRATION..MIAO VOWEL SIGN NG
            code == 119142 || // Mc       MUSICAL SYMBOL COMBINING SPRECHGESANG STEM
            code == 119149 ? SpacingMark : 4352 <= code && code <= 4447 || // Lo  [96] HANGUL CHOSEONG KIYEOK..HANGUL CHOSEONG FILLER
            43360 <= code && code <= 43388 ? L : 4448 <= code && code <= 4519 || // Lo  [72] HANGUL JUNGSEONG FILLER..HANGUL JUNGSEONG O-YAE
            55216 <= code && code <= 55238 ? V : 4520 <= code && code <= 4607 || // Lo  [88] HANGUL JONGSEONG KIYEOK..HANGUL JONGSEONG SSANGNIEUN
            55243 <= code && code <= 55291 ? T : code == 44032 || // Lo       HANGUL SYLLABLE GA
            code == 44060 || // Lo       HANGUL SYLLABLE GAE
            code == 44088 || // Lo       HANGUL SYLLABLE GYA
            code == 44116 || // Lo       HANGUL SYLLABLE GYAE
            code == 44144 || // Lo       HANGUL SYLLABLE GEO
            code == 44172 || // Lo       HANGUL SYLLABLE GE
            code == 44200 || // Lo       HANGUL SYLLABLE GYEO
            code == 44228 || // Lo       HANGUL SYLLABLE GYE
            code == 44256 || // Lo       HANGUL SYLLABLE GO
            code == 44284 || // Lo       HANGUL SYLLABLE GWA
            code == 44312 || // Lo       HANGUL SYLLABLE GWAE
            code == 44340 || // Lo       HANGUL SYLLABLE GOE
            code == 44368 || // Lo       HANGUL SYLLABLE GYO
            code == 44396 || // Lo       HANGUL SYLLABLE GU
            code == 44424 || // Lo       HANGUL SYLLABLE GWEO
            code == 44452 || // Lo       HANGUL SYLLABLE GWE
            code == 44480 || // Lo       HANGUL SYLLABLE GWI
            code == 44508 || // Lo       HANGUL SYLLABLE GYU
            code == 44536 || // Lo       HANGUL SYLLABLE GEU
            code == 44564 || // Lo       HANGUL SYLLABLE GYI
            code == 44592 || // Lo       HANGUL SYLLABLE GI
            code == 44620 || // Lo       HANGUL SYLLABLE GGA
            code == 44648 || // Lo       HANGUL SYLLABLE GGAE
            code == 44676 || // Lo       HANGUL SYLLABLE GGYA
            code == 44704 || // Lo       HANGUL SYLLABLE GGYAE
            code == 44732 || // Lo       HANGUL SYLLABLE GGEO
            code == 44760 || // Lo       HANGUL SYLLABLE GGE
            code == 44788 || // Lo       HANGUL SYLLABLE GGYEO
            code == 44816 || // Lo       HANGUL SYLLABLE GGYE
            code == 44844 || // Lo       HANGUL SYLLABLE GGO
            code == 44872 || // Lo       HANGUL SYLLABLE GGWA
            code == 44900 || // Lo       HANGUL SYLLABLE GGWAE
            code == 44928 || // Lo       HANGUL SYLLABLE GGOE
            code == 44956 || // Lo       HANGUL SYLLABLE GGYO
            code == 44984 || // Lo       HANGUL SYLLABLE GGU
            code == 45012 || // Lo       HANGUL SYLLABLE GGWEO
            code == 45040 || // Lo       HANGUL SYLLABLE GGWE
            code == 45068 || // Lo       HANGUL SYLLABLE GGWI
            code == 45096 || // Lo       HANGUL SYLLABLE GGYU
            code == 45124 || // Lo       HANGUL SYLLABLE GGEU
            code == 45152 || // Lo       HANGUL SYLLABLE GGYI
            code == 45180 || // Lo       HANGUL SYLLABLE GGI
            code == 45208 || // Lo       HANGUL SYLLABLE NA
            code == 45236 || // Lo       HANGUL SYLLABLE NAE
            code == 45264 || // Lo       HANGUL SYLLABLE NYA
            code == 45292 || // Lo       HANGUL SYLLABLE NYAE
            code == 45320 || // Lo       HANGUL SYLLABLE NEO
            code == 45348 || // Lo       HANGUL SYLLABLE NE
            code == 45376 || // Lo       HANGUL SYLLABLE NYEO
            code == 45404 || // Lo       HANGUL SYLLABLE NYE
            code == 45432 || // Lo       HANGUL SYLLABLE NO
            code == 45460 || // Lo       HANGUL SYLLABLE NWA
            code == 45488 || // Lo       HANGUL SYLLABLE NWAE
            code == 45516 || // Lo       HANGUL SYLLABLE NOE
            code == 45544 || // Lo       HANGUL SYLLABLE NYO
            code == 45572 || // Lo       HANGUL SYLLABLE NU
            code == 45600 || // Lo       HANGUL SYLLABLE NWEO
            code == 45628 || // Lo       HANGUL SYLLABLE NWE
            code == 45656 || // Lo       HANGUL SYLLABLE NWI
            code == 45684 || // Lo       HANGUL SYLLABLE NYU
            code == 45712 || // Lo       HANGUL SYLLABLE NEU
            code == 45740 || // Lo       HANGUL SYLLABLE NYI
            code == 45768 || // Lo       HANGUL SYLLABLE NI
            code == 45796 || // Lo       HANGUL SYLLABLE DA
            code == 45824 || // Lo       HANGUL SYLLABLE DAE
            code == 45852 || // Lo       HANGUL SYLLABLE DYA
            code == 45880 || // Lo       HANGUL SYLLABLE DYAE
            code == 45908 || // Lo       HANGUL SYLLABLE DEO
            code == 45936 || // Lo       HANGUL SYLLABLE DE
            code == 45964 || // Lo       HANGUL SYLLABLE DYEO
            code == 45992 || // Lo       HANGUL SYLLABLE DYE
            code == 46020 || // Lo       HANGUL SYLLABLE DO
            code == 46048 || // Lo       HANGUL SYLLABLE DWA
            code == 46076 || // Lo       HANGUL SYLLABLE DWAE
            code == 46104 || // Lo       HANGUL SYLLABLE DOE
            code == 46132 || // Lo       HANGUL SYLLABLE DYO
            code == 46160 || // Lo       HANGUL SYLLABLE DU
            code == 46188 || // Lo       HANGUL SYLLABLE DWEO
            code == 46216 || // Lo       HANGUL SYLLABLE DWE
            code == 46244 || // Lo       HANGUL SYLLABLE DWI
            code == 46272 || // Lo       HANGUL SYLLABLE DYU
            code == 46300 || // Lo       HANGUL SYLLABLE DEU
            code == 46328 || // Lo       HANGUL SYLLABLE DYI
            code == 46356 || // Lo       HANGUL SYLLABLE DI
            code == 46384 || // Lo       HANGUL SYLLABLE DDA
            code == 46412 || // Lo       HANGUL SYLLABLE DDAE
            code == 46440 || // Lo       HANGUL SYLLABLE DDYA
            code == 46468 || // Lo       HANGUL SYLLABLE DDYAE
            code == 46496 || // Lo       HANGUL SYLLABLE DDEO
            code == 46524 || // Lo       HANGUL SYLLABLE DDE
            code == 46552 || // Lo       HANGUL SYLLABLE DDYEO
            code == 46580 || // Lo       HANGUL SYLLABLE DDYE
            code == 46608 || // Lo       HANGUL SYLLABLE DDO
            code == 46636 || // Lo       HANGUL SYLLABLE DDWA
            code == 46664 || // Lo       HANGUL SYLLABLE DDWAE
            code == 46692 || // Lo       HANGUL SYLLABLE DDOE
            code == 46720 || // Lo       HANGUL SYLLABLE DDYO
            code == 46748 || // Lo       HANGUL SYLLABLE DDU
            code == 46776 || // Lo       HANGUL SYLLABLE DDWEO
            code == 46804 || // Lo       HANGUL SYLLABLE DDWE
            code == 46832 || // Lo       HANGUL SYLLABLE DDWI
            code == 46860 || // Lo       HANGUL SYLLABLE DDYU
            code == 46888 || // Lo       HANGUL SYLLABLE DDEU
            code == 46916 || // Lo       HANGUL SYLLABLE DDYI
            code == 46944 || // Lo       HANGUL SYLLABLE DDI
            code == 46972 || // Lo       HANGUL SYLLABLE RA
            code == 47e3 || // Lo       HANGUL SYLLABLE RAE
            code == 47028 || // Lo       HANGUL SYLLABLE RYA
            code == 47056 || // Lo       HANGUL SYLLABLE RYAE
            code == 47084 || // Lo       HANGUL SYLLABLE REO
            code == 47112 || // Lo       HANGUL SYLLABLE RE
            code == 47140 || // Lo       HANGUL SYLLABLE RYEO
            code == 47168 || // Lo       HANGUL SYLLABLE RYE
            code == 47196 || // Lo       HANGUL SYLLABLE RO
            code == 47224 || // Lo       HANGUL SYLLABLE RWA
            code == 47252 || // Lo       HANGUL SYLLABLE RWAE
            code == 47280 || // Lo       HANGUL SYLLABLE ROE
            code == 47308 || // Lo       HANGUL SYLLABLE RYO
            code == 47336 || // Lo       HANGUL SYLLABLE RU
            code == 47364 || // Lo       HANGUL SYLLABLE RWEO
            code == 47392 || // Lo       HANGUL SYLLABLE RWE
            code == 47420 || // Lo       HANGUL SYLLABLE RWI
            code == 47448 || // Lo       HANGUL SYLLABLE RYU
            code == 47476 || // Lo       HANGUL SYLLABLE REU
            code == 47504 || // Lo       HANGUL SYLLABLE RYI
            code == 47532 || // Lo       HANGUL SYLLABLE RI
            code == 47560 || // Lo       HANGUL SYLLABLE MA
            code == 47588 || // Lo       HANGUL SYLLABLE MAE
            code == 47616 || // Lo       HANGUL SYLLABLE MYA
            code == 47644 || // Lo       HANGUL SYLLABLE MYAE
            code == 47672 || // Lo       HANGUL SYLLABLE MEO
            code == 47700 || // Lo       HANGUL SYLLABLE ME
            code == 47728 || // Lo       HANGUL SYLLABLE MYEO
            code == 47756 || // Lo       HANGUL SYLLABLE MYE
            code == 47784 || // Lo       HANGUL SYLLABLE MO
            code == 47812 || // Lo       HANGUL SYLLABLE MWA
            code == 47840 || // Lo       HANGUL SYLLABLE MWAE
            code == 47868 || // Lo       HANGUL SYLLABLE MOE
            code == 47896 || // Lo       HANGUL SYLLABLE MYO
            code == 47924 || // Lo       HANGUL SYLLABLE MU
            code == 47952 || // Lo       HANGUL SYLLABLE MWEO
            code == 47980 || // Lo       HANGUL SYLLABLE MWE
            code == 48008 || // Lo       HANGUL SYLLABLE MWI
            code == 48036 || // Lo       HANGUL SYLLABLE MYU
            code == 48064 || // Lo       HANGUL SYLLABLE MEU
            code == 48092 || // Lo       HANGUL SYLLABLE MYI
            code == 48120 || // Lo       HANGUL SYLLABLE MI
            code == 48148 || // Lo       HANGUL SYLLABLE BA
            code == 48176 || // Lo       HANGUL SYLLABLE BAE
            code == 48204 || // Lo       HANGUL SYLLABLE BYA
            code == 48232 || // Lo       HANGUL SYLLABLE BYAE
            code == 48260 || // Lo       HANGUL SYLLABLE BEO
            code == 48288 || // Lo       HANGUL SYLLABLE BE
            code == 48316 || // Lo       HANGUL SYLLABLE BYEO
            code == 48344 || // Lo       HANGUL SYLLABLE BYE
            code == 48372 || // Lo       HANGUL SYLLABLE BO
            code == 48400 || // Lo       HANGUL SYLLABLE BWA
            code == 48428 || // Lo       HANGUL SYLLABLE BWAE
            code == 48456 || // Lo       HANGUL SYLLABLE BOE
            code == 48484 || // Lo       HANGUL SYLLABLE BYO
            code == 48512 || // Lo       HANGUL SYLLABLE BU
            code == 48540 || // Lo       HANGUL SYLLABLE BWEO
            code == 48568 || // Lo       HANGUL SYLLABLE BWE
            code == 48596 || // Lo       HANGUL SYLLABLE BWI
            code == 48624 || // Lo       HANGUL SYLLABLE BYU
            code == 48652 || // Lo       HANGUL SYLLABLE BEU
            code == 48680 || // Lo       HANGUL SYLLABLE BYI
            code == 48708 || // Lo       HANGUL SYLLABLE BI
            code == 48736 || // Lo       HANGUL SYLLABLE BBA
            code == 48764 || // Lo       HANGUL SYLLABLE BBAE
            code == 48792 || // Lo       HANGUL SYLLABLE BBYA
            code == 48820 || // Lo       HANGUL SYLLABLE BBYAE
            code == 48848 || // Lo       HANGUL SYLLABLE BBEO
            code == 48876 || // Lo       HANGUL SYLLABLE BBE
            code == 48904 || // Lo       HANGUL SYLLABLE BBYEO
            code == 48932 || // Lo       HANGUL SYLLABLE BBYE
            code == 48960 || // Lo       HANGUL SYLLABLE BBO
            code == 48988 || // Lo       HANGUL SYLLABLE BBWA
            code == 49016 || // Lo       HANGUL SYLLABLE BBWAE
            code == 49044 || // Lo       HANGUL SYLLABLE BBOE
            code == 49072 || // Lo       HANGUL SYLLABLE BBYO
            code == 49100 || // Lo       HANGUL SYLLABLE BBU
            code == 49128 || // Lo       HANGUL SYLLABLE BBWEO
            code == 49156 || // Lo       HANGUL SYLLABLE BBWE
            code == 49184 || // Lo       HANGUL SYLLABLE BBWI
            code == 49212 || // Lo       HANGUL SYLLABLE BBYU
            code == 49240 || // Lo       HANGUL SYLLABLE BBEU
            code == 49268 || // Lo       HANGUL SYLLABLE BBYI
            code == 49296 || // Lo       HANGUL SYLLABLE BBI
            code == 49324 || // Lo       HANGUL SYLLABLE SA
            code == 49352 || // Lo       HANGUL SYLLABLE SAE
            code == 49380 || // Lo       HANGUL SYLLABLE SYA
            code == 49408 || // Lo       HANGUL SYLLABLE SYAE
            code == 49436 || // Lo       HANGUL SYLLABLE SEO
            code == 49464 || // Lo       HANGUL SYLLABLE SE
            code == 49492 || // Lo       HANGUL SYLLABLE SYEO
            code == 49520 || // Lo       HANGUL SYLLABLE SYE
            code == 49548 || // Lo       HANGUL SYLLABLE SO
            code == 49576 || // Lo       HANGUL SYLLABLE SWA
            code == 49604 || // Lo       HANGUL SYLLABLE SWAE
            code == 49632 || // Lo       HANGUL SYLLABLE SOE
            code == 49660 || // Lo       HANGUL SYLLABLE SYO
            code == 49688 || // Lo       HANGUL SYLLABLE SU
            code == 49716 || // Lo       HANGUL SYLLABLE SWEO
            code == 49744 || // Lo       HANGUL SYLLABLE SWE
            code == 49772 || // Lo       HANGUL SYLLABLE SWI
            code == 49800 || // Lo       HANGUL SYLLABLE SYU
            code == 49828 || // Lo       HANGUL SYLLABLE SEU
            code == 49856 || // Lo       HANGUL SYLLABLE SYI
            code == 49884 || // Lo       HANGUL SYLLABLE SI
            code == 49912 || // Lo       HANGUL SYLLABLE SSA
            code == 49940 || // Lo       HANGUL SYLLABLE SSAE
            code == 49968 || // Lo       HANGUL SYLLABLE SSYA
            code == 49996 || // Lo       HANGUL SYLLABLE SSYAE
            code == 50024 || // Lo       HANGUL SYLLABLE SSEO
            code == 50052 || // Lo       HANGUL SYLLABLE SSE
            code == 50080 || // Lo       HANGUL SYLLABLE SSYEO
            code == 50108 || // Lo       HANGUL SYLLABLE SSYE
            code == 50136 || // Lo       HANGUL SYLLABLE SSO
            code == 50164 || // Lo       HANGUL SYLLABLE SSWA
            code == 50192 || // Lo       HANGUL SYLLABLE SSWAE
            code == 50220 || // Lo       HANGUL SYLLABLE SSOE
            code == 50248 || // Lo       HANGUL SYLLABLE SSYO
            code == 50276 || // Lo       HANGUL SYLLABLE SSU
            code == 50304 || // Lo       HANGUL SYLLABLE SSWEO
            code == 50332 || // Lo       HANGUL SYLLABLE SSWE
            code == 50360 || // Lo       HANGUL SYLLABLE SSWI
            code == 50388 || // Lo       HANGUL SYLLABLE SSYU
            code == 50416 || // Lo       HANGUL SYLLABLE SSEU
            code == 50444 || // Lo       HANGUL SYLLABLE SSYI
            code == 50472 || // Lo       HANGUL SYLLABLE SSI
            code == 50500 || // Lo       HANGUL SYLLABLE A
            code == 50528 || // Lo       HANGUL SYLLABLE AE
            code == 50556 || // Lo       HANGUL SYLLABLE YA
            code == 50584 || // Lo       HANGUL SYLLABLE YAE
            code == 50612 || // Lo       HANGUL SYLLABLE EO
            code == 50640 || // Lo       HANGUL SYLLABLE E
            code == 50668 || // Lo       HANGUL SYLLABLE YEO
            code == 50696 || // Lo       HANGUL SYLLABLE YE
            code == 50724 || // Lo       HANGUL SYLLABLE O
            code == 50752 || // Lo       HANGUL SYLLABLE WA
            code == 50780 || // Lo       HANGUL SYLLABLE WAE
            code == 50808 || // Lo       HANGUL SYLLABLE OE
            code == 50836 || // Lo       HANGUL SYLLABLE YO
            code == 50864 || // Lo       HANGUL SYLLABLE U
            code == 50892 || // Lo       HANGUL SYLLABLE WEO
            code == 50920 || // Lo       HANGUL SYLLABLE WE
            code == 50948 || // Lo       HANGUL SYLLABLE WI
            code == 50976 || // Lo       HANGUL SYLLABLE YU
            code == 51004 || // Lo       HANGUL SYLLABLE EU
            code == 51032 || // Lo       HANGUL SYLLABLE YI
            code == 51060 || // Lo       HANGUL SYLLABLE I
            code == 51088 || // Lo       HANGUL SYLLABLE JA
            code == 51116 || // Lo       HANGUL SYLLABLE JAE
            code == 51144 || // Lo       HANGUL SYLLABLE JYA
            code == 51172 || // Lo       HANGUL SYLLABLE JYAE
            code == 51200 || // Lo       HANGUL SYLLABLE JEO
            code == 51228 || // Lo       HANGUL SYLLABLE JE
            code == 51256 || // Lo       HANGUL SYLLABLE JYEO
            code == 51284 || // Lo       HANGUL SYLLABLE JYE
            code == 51312 || // Lo       HANGUL SYLLABLE JO
            code == 51340 || // Lo       HANGUL SYLLABLE JWA
            code == 51368 || // Lo       HANGUL SYLLABLE JWAE
            code == 51396 || // Lo       HANGUL SYLLABLE JOE
            code == 51424 || // Lo       HANGUL SYLLABLE JYO
            code == 51452 || // Lo       HANGUL SYLLABLE JU
            code == 51480 || // Lo       HANGUL SYLLABLE JWEO
            code == 51508 || // Lo       HANGUL SYLLABLE JWE
            code == 51536 || // Lo       HANGUL SYLLABLE JWI
            code == 51564 || // Lo       HANGUL SYLLABLE JYU
            code == 51592 || // Lo       HANGUL SYLLABLE JEU
            code == 51620 || // Lo       HANGUL SYLLABLE JYI
            code == 51648 || // Lo       HANGUL SYLLABLE JI
            code == 51676 || // Lo       HANGUL SYLLABLE JJA
            code == 51704 || // Lo       HANGUL SYLLABLE JJAE
            code == 51732 || // Lo       HANGUL SYLLABLE JJYA
            code == 51760 || // Lo       HANGUL SYLLABLE JJYAE
            code == 51788 || // Lo       HANGUL SYLLABLE JJEO
            code == 51816 || // Lo       HANGUL SYLLABLE JJE
            code == 51844 || // Lo       HANGUL SYLLABLE JJYEO
            code == 51872 || // Lo       HANGUL SYLLABLE JJYE
            code == 51900 || // Lo       HANGUL SYLLABLE JJO
            code == 51928 || // Lo       HANGUL SYLLABLE JJWA
            code == 51956 || // Lo       HANGUL SYLLABLE JJWAE
            code == 51984 || // Lo       HANGUL SYLLABLE JJOE
            code == 52012 || // Lo       HANGUL SYLLABLE JJYO
            code == 52040 || // Lo       HANGUL SYLLABLE JJU
            code == 52068 || // Lo       HANGUL SYLLABLE JJWEO
            code == 52096 || // Lo       HANGUL SYLLABLE JJWE
            code == 52124 || // Lo       HANGUL SYLLABLE JJWI
            code == 52152 || // Lo       HANGUL SYLLABLE JJYU
            code == 52180 || // Lo       HANGUL SYLLABLE JJEU
            code == 52208 || // Lo       HANGUL SYLLABLE JJYI
            code == 52236 || // Lo       HANGUL SYLLABLE JJI
            code == 52264 || // Lo       HANGUL SYLLABLE CA
            code == 52292 || // Lo       HANGUL SYLLABLE CAE
            code == 52320 || // Lo       HANGUL SYLLABLE CYA
            code == 52348 || // Lo       HANGUL SYLLABLE CYAE
            code == 52376 || // Lo       HANGUL SYLLABLE CEO
            code == 52404 || // Lo       HANGUL SYLLABLE CE
            code == 52432 || // Lo       HANGUL SYLLABLE CYEO
            code == 52460 || // Lo       HANGUL SYLLABLE CYE
            code == 52488 || // Lo       HANGUL SYLLABLE CO
            code == 52516 || // Lo       HANGUL SYLLABLE CWA
            code == 52544 || // Lo       HANGUL SYLLABLE CWAE
            code == 52572 || // Lo       HANGUL SYLLABLE COE
            code == 52600 || // Lo       HANGUL SYLLABLE CYO
            code == 52628 || // Lo       HANGUL SYLLABLE CU
            code == 52656 || // Lo       HANGUL SYLLABLE CWEO
            code == 52684 || // Lo       HANGUL SYLLABLE CWE
            code == 52712 || // Lo       HANGUL SYLLABLE CWI
            code == 52740 || // Lo       HANGUL SYLLABLE CYU
            code == 52768 || // Lo       HANGUL SYLLABLE CEU
            code == 52796 || // Lo       HANGUL SYLLABLE CYI
            code == 52824 || // Lo       HANGUL SYLLABLE CI
            code == 52852 || // Lo       HANGUL SYLLABLE KA
            code == 52880 || // Lo       HANGUL SYLLABLE KAE
            code == 52908 || // Lo       HANGUL SYLLABLE KYA
            code == 52936 || // Lo       HANGUL SYLLABLE KYAE
            code == 52964 || // Lo       HANGUL SYLLABLE KEO
            code == 52992 || // Lo       HANGUL SYLLABLE KE
            code == 53020 || // Lo       HANGUL SYLLABLE KYEO
            code == 53048 || // Lo       HANGUL SYLLABLE KYE
            code == 53076 || // Lo       HANGUL SYLLABLE KO
            code == 53104 || // Lo       HANGUL SYLLABLE KWA
            code == 53132 || // Lo       HANGUL SYLLABLE KWAE
            code == 53160 || // Lo       HANGUL SYLLABLE KOE
            code == 53188 || // Lo       HANGUL SYLLABLE KYO
            code == 53216 || // Lo       HANGUL SYLLABLE KU
            code == 53244 || // Lo       HANGUL SYLLABLE KWEO
            code == 53272 || // Lo       HANGUL SYLLABLE KWE
            code == 53300 || // Lo       HANGUL SYLLABLE KWI
            code == 53328 || // Lo       HANGUL SYLLABLE KYU
            code == 53356 || // Lo       HANGUL SYLLABLE KEU
            code == 53384 || // Lo       HANGUL SYLLABLE KYI
            code == 53412 || // Lo       HANGUL SYLLABLE KI
            code == 53440 || // Lo       HANGUL SYLLABLE TA
            code == 53468 || // Lo       HANGUL SYLLABLE TAE
            code == 53496 || // Lo       HANGUL SYLLABLE TYA
            code == 53524 || // Lo       HANGUL SYLLABLE TYAE
            code == 53552 || // Lo       HANGUL SYLLABLE TEO
            code == 53580 || // Lo       HANGUL SYLLABLE TE
            code == 53608 || // Lo       HANGUL SYLLABLE TYEO
            code == 53636 || // Lo       HANGUL SYLLABLE TYE
            code == 53664 || // Lo       HANGUL SYLLABLE TO
            code == 53692 || // Lo       HANGUL SYLLABLE TWA
            code == 53720 || // Lo       HANGUL SYLLABLE TWAE
            code == 53748 || // Lo       HANGUL SYLLABLE TOE
            code == 53776 || // Lo       HANGUL SYLLABLE TYO
            code == 53804 || // Lo       HANGUL SYLLABLE TU
            code == 53832 || // Lo       HANGUL SYLLABLE TWEO
            code == 53860 || // Lo       HANGUL SYLLABLE TWE
            code == 53888 || // Lo       HANGUL SYLLABLE TWI
            code == 53916 || // Lo       HANGUL SYLLABLE TYU
            code == 53944 || // Lo       HANGUL SYLLABLE TEU
            code == 53972 || // Lo       HANGUL SYLLABLE TYI
            code == 54e3 || // Lo       HANGUL SYLLABLE TI
            code == 54028 || // Lo       HANGUL SYLLABLE PA
            code == 54056 || // Lo       HANGUL SYLLABLE PAE
            code == 54084 || // Lo       HANGUL SYLLABLE PYA
            code == 54112 || // Lo       HANGUL SYLLABLE PYAE
            code == 54140 || // Lo       HANGUL SYLLABLE PEO
            code == 54168 || // Lo       HANGUL SYLLABLE PE
            code == 54196 || // Lo       HANGUL SYLLABLE PYEO
            code == 54224 || // Lo       HANGUL SYLLABLE PYE
            code == 54252 || // Lo       HANGUL SYLLABLE PO
            code == 54280 || // Lo       HANGUL SYLLABLE PWA
            code == 54308 || // Lo       HANGUL SYLLABLE PWAE
            code == 54336 || // Lo       HANGUL SYLLABLE POE
            code == 54364 || // Lo       HANGUL SYLLABLE PYO
            code == 54392 || // Lo       HANGUL SYLLABLE PU
            code == 54420 || // Lo       HANGUL SYLLABLE PWEO
            code == 54448 || // Lo       HANGUL SYLLABLE PWE
            code == 54476 || // Lo       HANGUL SYLLABLE PWI
            code == 54504 || // Lo       HANGUL SYLLABLE PYU
            code == 54532 || // Lo       HANGUL SYLLABLE PEU
            code == 54560 || // Lo       HANGUL SYLLABLE PYI
            code == 54588 || // Lo       HANGUL SYLLABLE PI
            code == 54616 || // Lo       HANGUL SYLLABLE HA
            code == 54644 || // Lo       HANGUL SYLLABLE HAE
            code == 54672 || // Lo       HANGUL SYLLABLE HYA
            code == 54700 || // Lo       HANGUL SYLLABLE HYAE
            code == 54728 || // Lo       HANGUL SYLLABLE HEO
            code == 54756 || // Lo       HANGUL SYLLABLE HE
            code == 54784 || // Lo       HANGUL SYLLABLE HYEO
            code == 54812 || // Lo       HANGUL SYLLABLE HYE
            code == 54840 || // Lo       HANGUL SYLLABLE HO
            code == 54868 || // Lo       HANGUL SYLLABLE HWA
            code == 54896 || // Lo       HANGUL SYLLABLE HWAE
            code == 54924 || // Lo       HANGUL SYLLABLE HOE
            code == 54952 || // Lo       HANGUL SYLLABLE HYO
            code == 54980 || // Lo       HANGUL SYLLABLE HU
            code == 55008 || // Lo       HANGUL SYLLABLE HWEO
            code == 55036 || // Lo       HANGUL SYLLABLE HWE
            code == 55064 || // Lo       HANGUL SYLLABLE HWI
            code == 55092 || // Lo       HANGUL SYLLABLE HYU
            code == 55120 || // Lo       HANGUL SYLLABLE HEU
            code == 55148 || // Lo       HANGUL SYLLABLE HYI
            code == 55176 ? LV : 44033 <= code && code <= 44059 || // Lo  [27] HANGUL SYLLABLE GAG..HANGUL SYLLABLE GAH
            44061 <= code && code <= 44087 || // Lo  [27] HANGUL SYLLABLE GAEG..HANGUL SYLLABLE GAEH
            44089 <= code && code <= 44115 || // Lo  [27] HANGUL SYLLABLE GYAG..HANGUL SYLLABLE GYAH
            44117 <= code && code <= 44143 || // Lo  [27] HANGUL SYLLABLE GYAEG..HANGUL SYLLABLE GYAEH
            44145 <= code && code <= 44171 || // Lo  [27] HANGUL SYLLABLE GEOG..HANGUL SYLLABLE GEOH
            44173 <= code && code <= 44199 || // Lo  [27] HANGUL SYLLABLE GEG..HANGUL SYLLABLE GEH
            44201 <= code && code <= 44227 || // Lo  [27] HANGUL SYLLABLE GYEOG..HANGUL SYLLABLE GYEOH
            44229 <= code && code <= 44255 || // Lo  [27] HANGUL SYLLABLE GYEG..HANGUL SYLLABLE GYEH
            44257 <= code && code <= 44283 || // Lo  [27] HANGUL SYLLABLE GOG..HANGUL SYLLABLE GOH
            44285 <= code && code <= 44311 || // Lo  [27] HANGUL SYLLABLE GWAG..HANGUL SYLLABLE GWAH
            44313 <= code && code <= 44339 || // Lo  [27] HANGUL SYLLABLE GWAEG..HANGUL SYLLABLE GWAEH
            44341 <= code && code <= 44367 || // Lo  [27] HANGUL SYLLABLE GOEG..HANGUL SYLLABLE GOEH
            44369 <= code && code <= 44395 || // Lo  [27] HANGUL SYLLABLE GYOG..HANGUL SYLLABLE GYOH
            44397 <= code && code <= 44423 || // Lo  [27] HANGUL SYLLABLE GUG..HANGUL SYLLABLE GUH
            44425 <= code && code <= 44451 || // Lo  [27] HANGUL SYLLABLE GWEOG..HANGUL SYLLABLE GWEOH
            44453 <= code && code <= 44479 || // Lo  [27] HANGUL SYLLABLE GWEG..HANGUL SYLLABLE GWEH
            44481 <= code && code <= 44507 || // Lo  [27] HANGUL SYLLABLE GWIG..HANGUL SYLLABLE GWIH
            44509 <= code && code <= 44535 || // Lo  [27] HANGUL SYLLABLE GYUG..HANGUL SYLLABLE GYUH
            44537 <= code && code <= 44563 || // Lo  [27] HANGUL SYLLABLE GEUG..HANGUL SYLLABLE GEUH
            44565 <= code && code <= 44591 || // Lo  [27] HANGUL SYLLABLE GYIG..HANGUL SYLLABLE GYIH
            44593 <= code && code <= 44619 || // Lo  [27] HANGUL SYLLABLE GIG..HANGUL SYLLABLE GIH
            44621 <= code && code <= 44647 || // Lo  [27] HANGUL SYLLABLE GGAG..HANGUL SYLLABLE GGAH
            44649 <= code && code <= 44675 || // Lo  [27] HANGUL SYLLABLE GGAEG..HANGUL SYLLABLE GGAEH
            44677 <= code && code <= 44703 || // Lo  [27] HANGUL SYLLABLE GGYAG..HANGUL SYLLABLE GGYAH
            44705 <= code && code <= 44731 || // Lo  [27] HANGUL SYLLABLE GGYAEG..HANGUL SYLLABLE GGYAEH
            44733 <= code && code <= 44759 || // Lo  [27] HANGUL SYLLABLE GGEOG..HANGUL SYLLABLE GGEOH
            44761 <= code && code <= 44787 || // Lo  [27] HANGUL SYLLABLE GGEG..HANGUL SYLLABLE GGEH
            44789 <= code && code <= 44815 || // Lo  [27] HANGUL SYLLABLE GGYEOG..HANGUL SYLLABLE GGYEOH
            44817 <= code && code <= 44843 || // Lo  [27] HANGUL SYLLABLE GGYEG..HANGUL SYLLABLE GGYEH
            44845 <= code && code <= 44871 || // Lo  [27] HANGUL SYLLABLE GGOG..HANGUL SYLLABLE GGOH
            44873 <= code && code <= 44899 || // Lo  [27] HANGUL SYLLABLE GGWAG..HANGUL SYLLABLE GGWAH
            44901 <= code && code <= 44927 || // Lo  [27] HANGUL SYLLABLE GGWAEG..HANGUL SYLLABLE GGWAEH
            44929 <= code && code <= 44955 || // Lo  [27] HANGUL SYLLABLE GGOEG..HANGUL SYLLABLE GGOEH
            44957 <= code && code <= 44983 || // Lo  [27] HANGUL SYLLABLE GGYOG..HANGUL SYLLABLE GGYOH
            44985 <= code && code <= 45011 || // Lo  [27] HANGUL SYLLABLE GGUG..HANGUL SYLLABLE GGUH
            45013 <= code && code <= 45039 || // Lo  [27] HANGUL SYLLABLE GGWEOG..HANGUL SYLLABLE GGWEOH
            45041 <= code && code <= 45067 || // Lo  [27] HANGUL SYLLABLE GGWEG..HANGUL SYLLABLE GGWEH
            45069 <= code && code <= 45095 || // Lo  [27] HANGUL SYLLABLE GGWIG..HANGUL SYLLABLE GGWIH
            45097 <= code && code <= 45123 || // Lo  [27] HANGUL SYLLABLE GGYUG..HANGUL SYLLABLE GGYUH
            45125 <= code && code <= 45151 || // Lo  [27] HANGUL SYLLABLE GGEUG..HANGUL SYLLABLE GGEUH
            45153 <= code && code <= 45179 || // Lo  [27] HANGUL SYLLABLE GGYIG..HANGUL SYLLABLE GGYIH
            45181 <= code && code <= 45207 || // Lo  [27] HANGUL SYLLABLE GGIG..HANGUL SYLLABLE GGIH
            45209 <= code && code <= 45235 || // Lo  [27] HANGUL SYLLABLE NAG..HANGUL SYLLABLE NAH
            45237 <= code && code <= 45263 || // Lo  [27] HANGUL SYLLABLE NAEG..HANGUL SYLLABLE NAEH
            45265 <= code && code <= 45291 || // Lo  [27] HANGUL SYLLABLE NYAG..HANGUL SYLLABLE NYAH
            45293 <= code && code <= 45319 || // Lo  [27] HANGUL SYLLABLE NYAEG..HANGUL SYLLABLE NYAEH
            45321 <= code && code <= 45347 || // Lo  [27] HANGUL SYLLABLE NEOG..HANGUL SYLLABLE NEOH
            45349 <= code && code <= 45375 || // Lo  [27] HANGUL SYLLABLE NEG..HANGUL SYLLABLE NEH
            45377 <= code && code <= 45403 || // Lo  [27] HANGUL SYLLABLE NYEOG..HANGUL SYLLABLE NYEOH
            45405 <= code && code <= 45431 || // Lo  [27] HANGUL SYLLABLE NYEG..HANGUL SYLLABLE NYEH
            45433 <= code && code <= 45459 || // Lo  [27] HANGUL SYLLABLE NOG..HANGUL SYLLABLE NOH
            45461 <= code && code <= 45487 || // Lo  [27] HANGUL SYLLABLE NWAG..HANGUL SYLLABLE NWAH
            45489 <= code && code <= 45515 || // Lo  [27] HANGUL SYLLABLE NWAEG..HANGUL SYLLABLE NWAEH
            45517 <= code && code <= 45543 || // Lo  [27] HANGUL SYLLABLE NOEG..HANGUL SYLLABLE NOEH
            45545 <= code && code <= 45571 || // Lo  [27] HANGUL SYLLABLE NYOG..HANGUL SYLLABLE NYOH
            45573 <= code && code <= 45599 || // Lo  [27] HANGUL SYLLABLE NUG..HANGUL SYLLABLE NUH
            45601 <= code && code <= 45627 || // Lo  [27] HANGUL SYLLABLE NWEOG..HANGUL SYLLABLE NWEOH
            45629 <= code && code <= 45655 || // Lo  [27] HANGUL SYLLABLE NWEG..HANGUL SYLLABLE NWEH
            45657 <= code && code <= 45683 || // Lo  [27] HANGUL SYLLABLE NWIG..HANGUL SYLLABLE NWIH
            45685 <= code && code <= 45711 || // Lo  [27] HANGUL SYLLABLE NYUG..HANGUL SYLLABLE NYUH
            45713 <= code && code <= 45739 || // Lo  [27] HANGUL SYLLABLE NEUG..HANGUL SYLLABLE NEUH
            45741 <= code && code <= 45767 || // Lo  [27] HANGUL SYLLABLE NYIG..HANGUL SYLLABLE NYIH
            45769 <= code && code <= 45795 || // Lo  [27] HANGUL SYLLABLE NIG..HANGUL SYLLABLE NIH
            45797 <= code && code <= 45823 || // Lo  [27] HANGUL SYLLABLE DAG..HANGUL SYLLABLE DAH
            45825 <= code && code <= 45851 || // Lo  [27] HANGUL SYLLABLE DAEG..HANGUL SYLLABLE DAEH
            45853 <= code && code <= 45879 || // Lo  [27] HANGUL SYLLABLE DYAG..HANGUL SYLLABLE DYAH
            45881 <= code && code <= 45907 || // Lo  [27] HANGUL SYLLABLE DYAEG..HANGUL SYLLABLE DYAEH
            45909 <= code && code <= 45935 || // Lo  [27] HANGUL SYLLABLE DEOG..HANGUL SYLLABLE DEOH
            45937 <= code && code <= 45963 || // Lo  [27] HANGUL SYLLABLE DEG..HANGUL SYLLABLE DEH
            45965 <= code && code <= 45991 || // Lo  [27] HANGUL SYLLABLE DYEOG..HANGUL SYLLABLE DYEOH
            45993 <= code && code <= 46019 || // Lo  [27] HANGUL SYLLABLE DYEG..HANGUL SYLLABLE DYEH
            46021 <= code && code <= 46047 || // Lo  [27] HANGUL SYLLABLE DOG..HANGUL SYLLABLE DOH
            46049 <= code && code <= 46075 || // Lo  [27] HANGUL SYLLABLE DWAG..HANGUL SYLLABLE DWAH
            46077 <= code && code <= 46103 || // Lo  [27] HANGUL SYLLABLE DWAEG..HANGUL SYLLABLE DWAEH
            46105 <= code && code <= 46131 || // Lo  [27] HANGUL SYLLABLE DOEG..HANGUL SYLLABLE DOEH
            46133 <= code && code <= 46159 || // Lo  [27] HANGUL SYLLABLE DYOG..HANGUL SYLLABLE DYOH
            46161 <= code && code <= 46187 || // Lo  [27] HANGUL SYLLABLE DUG..HANGUL SYLLABLE DUH
            46189 <= code && code <= 46215 || // Lo  [27] HANGUL SYLLABLE DWEOG..HANGUL SYLLABLE DWEOH
            46217 <= code && code <= 46243 || // Lo  [27] HANGUL SYLLABLE DWEG..HANGUL SYLLABLE DWEH
            46245 <= code && code <= 46271 || // Lo  [27] HANGUL SYLLABLE DWIG..HANGUL SYLLABLE DWIH
            46273 <= code && code <= 46299 || // Lo  [27] HANGUL SYLLABLE DYUG..HANGUL SYLLABLE DYUH
            46301 <= code && code <= 46327 || // Lo  [27] HANGUL SYLLABLE DEUG..HANGUL SYLLABLE DEUH
            46329 <= code && code <= 46355 || // Lo  [27] HANGUL SYLLABLE DYIG..HANGUL SYLLABLE DYIH
            46357 <= code && code <= 46383 || // Lo  [27] HANGUL SYLLABLE DIG..HANGUL SYLLABLE DIH
            46385 <= code && code <= 46411 || // Lo  [27] HANGUL SYLLABLE DDAG..HANGUL SYLLABLE DDAH
            46413 <= code && code <= 46439 || // Lo  [27] HANGUL SYLLABLE DDAEG..HANGUL SYLLABLE DDAEH
            46441 <= code && code <= 46467 || // Lo  [27] HANGUL SYLLABLE DDYAG..HANGUL SYLLABLE DDYAH
            46469 <= code && code <= 46495 || // Lo  [27] HANGUL SYLLABLE DDYAEG..HANGUL SYLLABLE DDYAEH
            46497 <= code && code <= 46523 || // Lo  [27] HANGUL SYLLABLE DDEOG..HANGUL SYLLABLE DDEOH
            46525 <= code && code <= 46551 || // Lo  [27] HANGUL SYLLABLE DDEG..HANGUL SYLLABLE DDEH
            46553 <= code && code <= 46579 || // Lo  [27] HANGUL SYLLABLE DDYEOG..HANGUL SYLLABLE DDYEOH
            46581 <= code && code <= 46607 || // Lo  [27] HANGUL SYLLABLE DDYEG..HANGUL SYLLABLE DDYEH
            46609 <= code && code <= 46635 || // Lo  [27] HANGUL SYLLABLE DDOG..HANGUL SYLLABLE DDOH
            46637 <= code && code <= 46663 || // Lo  [27] HANGUL SYLLABLE DDWAG..HANGUL SYLLABLE DDWAH
            46665 <= code && code <= 46691 || // Lo  [27] HANGUL SYLLABLE DDWAEG..HANGUL SYLLABLE DDWAEH
            46693 <= code && code <= 46719 || // Lo  [27] HANGUL SYLLABLE DDOEG..HANGUL SYLLABLE DDOEH
            46721 <= code && code <= 46747 || // Lo  [27] HANGUL SYLLABLE DDYOG..HANGUL SYLLABLE DDYOH
            46749 <= code && code <= 46775 || // Lo  [27] HANGUL SYLLABLE DDUG..HANGUL SYLLABLE DDUH
            46777 <= code && code <= 46803 || // Lo  [27] HANGUL SYLLABLE DDWEOG..HANGUL SYLLABLE DDWEOH
            46805 <= code && code <= 46831 || // Lo  [27] HANGUL SYLLABLE DDWEG..HANGUL SYLLABLE DDWEH
            46833 <= code && code <= 46859 || // Lo  [27] HANGUL SYLLABLE DDWIG..HANGUL SYLLABLE DDWIH
            46861 <= code && code <= 46887 || // Lo  [27] HANGUL SYLLABLE DDYUG..HANGUL SYLLABLE DDYUH
            46889 <= code && code <= 46915 || // Lo  [27] HANGUL SYLLABLE DDEUG..HANGUL SYLLABLE DDEUH
            46917 <= code && code <= 46943 || // Lo  [27] HANGUL SYLLABLE DDYIG..HANGUL SYLLABLE DDYIH
            46945 <= code && code <= 46971 || // Lo  [27] HANGUL SYLLABLE DDIG..HANGUL SYLLABLE DDIH
            46973 <= code && code <= 46999 || // Lo  [27] HANGUL SYLLABLE RAG..HANGUL SYLLABLE RAH
            47001 <= code && code <= 47027 || // Lo  [27] HANGUL SYLLABLE RAEG..HANGUL SYLLABLE RAEH
            47029 <= code && code <= 47055 || // Lo  [27] HANGUL SYLLABLE RYAG..HANGUL SYLLABLE RYAH
            47057 <= code && code <= 47083 || // Lo  [27] HANGUL SYLLABLE RYAEG..HANGUL SYLLABLE RYAEH
            47085 <= code && code <= 47111 || // Lo  [27] HANGUL SYLLABLE REOG..HANGUL SYLLABLE REOH
            47113 <= code && code <= 47139 || // Lo  [27] HANGUL SYLLABLE REG..HANGUL SYLLABLE REH
            47141 <= code && code <= 47167 || // Lo  [27] HANGUL SYLLABLE RYEOG..HANGUL SYLLABLE RYEOH
            47169 <= code && code <= 47195 || // Lo  [27] HANGUL SYLLABLE RYEG..HANGUL SYLLABLE RYEH
            47197 <= code && code <= 47223 || // Lo  [27] HANGUL SYLLABLE ROG..HANGUL SYLLABLE ROH
            47225 <= code && code <= 47251 || // Lo  [27] HANGUL SYLLABLE RWAG..HANGUL SYLLABLE RWAH
            47253 <= code && code <= 47279 || // Lo  [27] HANGUL SYLLABLE RWAEG..HANGUL SYLLABLE RWAEH
            47281 <= code && code <= 47307 || // Lo  [27] HANGUL SYLLABLE ROEG..HANGUL SYLLABLE ROEH
            47309 <= code && code <= 47335 || // Lo  [27] HANGUL SYLLABLE RYOG..HANGUL SYLLABLE RYOH
            47337 <= code && code <= 47363 || // Lo  [27] HANGUL SYLLABLE RUG..HANGUL SYLLABLE RUH
            47365 <= code && code <= 47391 || // Lo  [27] HANGUL SYLLABLE RWEOG..HANGUL SYLLABLE RWEOH
            47393 <= code && code <= 47419 || // Lo  [27] HANGUL SYLLABLE RWEG..HANGUL SYLLABLE RWEH
            47421 <= code && code <= 47447 || // Lo  [27] HANGUL SYLLABLE RWIG..HANGUL SYLLABLE RWIH
            47449 <= code && code <= 47475 || // Lo  [27] HANGUL SYLLABLE RYUG..HANGUL SYLLABLE RYUH
            47477 <= code && code <= 47503 || // Lo  [27] HANGUL SYLLABLE REUG..HANGUL SYLLABLE REUH
            47505 <= code && code <= 47531 || // Lo  [27] HANGUL SYLLABLE RYIG..HANGUL SYLLABLE RYIH
            47533 <= code && code <= 47559 || // Lo  [27] HANGUL SYLLABLE RIG..HANGUL SYLLABLE RIH
            47561 <= code && code <= 47587 || // Lo  [27] HANGUL SYLLABLE MAG..HANGUL SYLLABLE MAH
            47589 <= code && code <= 47615 || // Lo  [27] HANGUL SYLLABLE MAEG..HANGUL SYLLABLE MAEH
            47617 <= code && code <= 47643 || // Lo  [27] HANGUL SYLLABLE MYAG..HANGUL SYLLABLE MYAH
            47645 <= code && code <= 47671 || // Lo  [27] HANGUL SYLLABLE MYAEG..HANGUL SYLLABLE MYAEH
            47673 <= code && code <= 47699 || // Lo  [27] HANGUL SYLLABLE MEOG..HANGUL SYLLABLE MEOH
            47701 <= code && code <= 47727 || // Lo  [27] HANGUL SYLLABLE MEG..HANGUL SYLLABLE MEH
            47729 <= code && code <= 47755 || // Lo  [27] HANGUL SYLLABLE MYEOG..HANGUL SYLLABLE MYEOH
            47757 <= code && code <= 47783 || // Lo  [27] HANGUL SYLLABLE MYEG..HANGUL SYLLABLE MYEH
            47785 <= code && code <= 47811 || // Lo  [27] HANGUL SYLLABLE MOG..HANGUL SYLLABLE MOH
            47813 <= code && code <= 47839 || // Lo  [27] HANGUL SYLLABLE MWAG..HANGUL SYLLABLE MWAH
            47841 <= code && code <= 47867 || // Lo  [27] HANGUL SYLLABLE MWAEG..HANGUL SYLLABLE MWAEH
            47869 <= code && code <= 47895 || // Lo  [27] HANGUL SYLLABLE MOEG..HANGUL SYLLABLE MOEH
            47897 <= code && code <= 47923 || // Lo  [27] HANGUL SYLLABLE MYOG..HANGUL SYLLABLE MYOH
            47925 <= code && code <= 47951 || // Lo  [27] HANGUL SYLLABLE MUG..HANGUL SYLLABLE MUH
            47953 <= code && code <= 47979 || // Lo  [27] HANGUL SYLLABLE MWEOG..HANGUL SYLLABLE MWEOH
            47981 <= code && code <= 48007 || // Lo  [27] HANGUL SYLLABLE MWEG..HANGUL SYLLABLE MWEH
            48009 <= code && code <= 48035 || // Lo  [27] HANGUL SYLLABLE MWIG..HANGUL SYLLABLE MWIH
            48037 <= code && code <= 48063 || // Lo  [27] HANGUL SYLLABLE MYUG..HANGUL SYLLABLE MYUH
            48065 <= code && code <= 48091 || // Lo  [27] HANGUL SYLLABLE MEUG..HANGUL SYLLABLE MEUH
            48093 <= code && code <= 48119 || // Lo  [27] HANGUL SYLLABLE MYIG..HANGUL SYLLABLE MYIH
            48121 <= code && code <= 48147 || // Lo  [27] HANGUL SYLLABLE MIG..HANGUL SYLLABLE MIH
            48149 <= code && code <= 48175 || // Lo  [27] HANGUL SYLLABLE BAG..HANGUL SYLLABLE BAH
            48177 <= code && code <= 48203 || // Lo  [27] HANGUL SYLLABLE BAEG..HANGUL SYLLABLE BAEH
            48205 <= code && code <= 48231 || // Lo  [27] HANGUL SYLLABLE BYAG..HANGUL SYLLABLE BYAH
            48233 <= code && code <= 48259 || // Lo  [27] HANGUL SYLLABLE BYAEG..HANGUL SYLLABLE BYAEH
            48261 <= code && code <= 48287 || // Lo  [27] HANGUL SYLLABLE BEOG..HANGUL SYLLABLE BEOH
            48289 <= code && code <= 48315 || // Lo  [27] HANGUL SYLLABLE BEG..HANGUL SYLLABLE BEH
            48317 <= code && code <= 48343 || // Lo  [27] HANGUL SYLLABLE BYEOG..HANGUL SYLLABLE BYEOH
            48345 <= code && code <= 48371 || // Lo  [27] HANGUL SYLLABLE BYEG..HANGUL SYLLABLE BYEH
            48373 <= code && code <= 48399 || // Lo  [27] HANGUL SYLLABLE BOG..HANGUL SYLLABLE BOH
            48401 <= code && code <= 48427 || // Lo  [27] HANGUL SYLLABLE BWAG..HANGUL SYLLABLE BWAH
            48429 <= code && code <= 48455 || // Lo  [27] HANGUL SYLLABLE BWAEG..HANGUL SYLLABLE BWAEH
            48457 <= code && code <= 48483 || // Lo  [27] HANGUL SYLLABLE BOEG..HANGUL SYLLABLE BOEH
            48485 <= code && code <= 48511 || // Lo  [27] HANGUL SYLLABLE BYOG..HANGUL SYLLABLE BYOH
            48513 <= code && code <= 48539 || // Lo  [27] HANGUL SYLLABLE BUG..HANGUL SYLLABLE BUH
            48541 <= code && code <= 48567 || // Lo  [27] HANGUL SYLLABLE BWEOG..HANGUL SYLLABLE BWEOH
            48569 <= code && code <= 48595 || // Lo  [27] HANGUL SYLLABLE BWEG..HANGUL SYLLABLE BWEH
            48597 <= code && code <= 48623 || // Lo  [27] HANGUL SYLLABLE BWIG..HANGUL SYLLABLE BWIH
            48625 <= code && code <= 48651 || // Lo  [27] HANGUL SYLLABLE BYUG..HANGUL SYLLABLE BYUH
            48653 <= code && code <= 48679 || // Lo  [27] HANGUL SYLLABLE BEUG..HANGUL SYLLABLE BEUH
            48681 <= code && code <= 48707 || // Lo  [27] HANGUL SYLLABLE BYIG..HANGUL SYLLABLE BYIH
            48709 <= code && code <= 48735 || // Lo  [27] HANGUL SYLLABLE BIG..HANGUL SYLLABLE BIH
            48737 <= code && code <= 48763 || // Lo  [27] HANGUL SYLLABLE BBAG..HANGUL SYLLABLE BBAH
            48765 <= code && code <= 48791 || // Lo  [27] HANGUL SYLLABLE BBAEG..HANGUL SYLLABLE BBAEH
            48793 <= code && code <= 48819 || // Lo  [27] HANGUL SYLLABLE BBYAG..HANGUL SYLLABLE BBYAH
            48821 <= code && code <= 48847 || // Lo  [27] HANGUL SYLLABLE BBYAEG..HANGUL SYLLABLE BBYAEH
            48849 <= code && code <= 48875 || // Lo  [27] HANGUL SYLLABLE BBEOG..HANGUL SYLLABLE BBEOH
            48877 <= code && code <= 48903 || // Lo  [27] HANGUL SYLLABLE BBEG..HANGUL SYLLABLE BBEH
            48905 <= code && code <= 48931 || // Lo  [27] HANGUL SYLLABLE BBYEOG..HANGUL SYLLABLE BBYEOH
            48933 <= code && code <= 48959 || // Lo  [27] HANGUL SYLLABLE BBYEG..HANGUL SYLLABLE BBYEH
            48961 <= code && code <= 48987 || // Lo  [27] HANGUL SYLLABLE BBOG..HANGUL SYLLABLE BBOH
            48989 <= code && code <= 49015 || // Lo  [27] HANGUL SYLLABLE BBWAG..HANGUL SYLLABLE BBWAH
            49017 <= code && code <= 49043 || // Lo  [27] HANGUL SYLLABLE BBWAEG..HANGUL SYLLABLE BBWAEH
            49045 <= code && code <= 49071 || // Lo  [27] HANGUL SYLLABLE BBOEG..HANGUL SYLLABLE BBOEH
            49073 <= code && code <= 49099 || // Lo  [27] HANGUL SYLLABLE BBYOG..HANGUL SYLLABLE BBYOH
            49101 <= code && code <= 49127 || // Lo  [27] HANGUL SYLLABLE BBUG..HANGUL SYLLABLE BBUH
            49129 <= code && code <= 49155 || // Lo  [27] HANGUL SYLLABLE BBWEOG..HANGUL SYLLABLE BBWEOH
            49157 <= code && code <= 49183 || // Lo  [27] HANGUL SYLLABLE BBWEG..HANGUL SYLLABLE BBWEH
            49185 <= code && code <= 49211 || // Lo  [27] HANGUL SYLLABLE BBWIG..HANGUL SYLLABLE BBWIH
            49213 <= code && code <= 49239 || // Lo  [27] HANGUL SYLLABLE BBYUG..HANGUL SYLLABLE BBYUH
            49241 <= code && code <= 49267 || // Lo  [27] HANGUL SYLLABLE BBEUG..HANGUL SYLLABLE BBEUH
            49269 <= code && code <= 49295 || // Lo  [27] HANGUL SYLLABLE BBYIG..HANGUL SYLLABLE BBYIH
            49297 <= code && code <= 49323 || // Lo  [27] HANGUL SYLLABLE BBIG..HANGUL SYLLABLE BBIH
            49325 <= code && code <= 49351 || // Lo  [27] HANGUL SYLLABLE SAG..HANGUL SYLLABLE SAH
            49353 <= code && code <= 49379 || // Lo  [27] HANGUL SYLLABLE SAEG..HANGUL SYLLABLE SAEH
            49381 <= code && code <= 49407 || // Lo  [27] HANGUL SYLLABLE SYAG..HANGUL SYLLABLE SYAH
            49409 <= code && code <= 49435 || // Lo  [27] HANGUL SYLLABLE SYAEG..HANGUL SYLLABLE SYAEH
            49437 <= code && code <= 49463 || // Lo  [27] HANGUL SYLLABLE SEOG..HANGUL SYLLABLE SEOH
            49465 <= code && code <= 49491 || // Lo  [27] HANGUL SYLLABLE SEG..HANGUL SYLLABLE SEH
            49493 <= code && code <= 49519 || // Lo  [27] HANGUL SYLLABLE SYEOG..HANGUL SYLLABLE SYEOH
            49521 <= code && code <= 49547 || // Lo  [27] HANGUL SYLLABLE SYEG..HANGUL SYLLABLE SYEH
            49549 <= code && code <= 49575 || // Lo  [27] HANGUL SYLLABLE SOG..HANGUL SYLLABLE SOH
            49577 <= code && code <= 49603 || // Lo  [27] HANGUL SYLLABLE SWAG..HANGUL SYLLABLE SWAH
            49605 <= code && code <= 49631 || // Lo  [27] HANGUL SYLLABLE SWAEG..HANGUL SYLLABLE SWAEH
            49633 <= code && code <= 49659 || // Lo  [27] HANGUL SYLLABLE SOEG..HANGUL SYLLABLE SOEH
            49661 <= code && code <= 49687 || // Lo  [27] HANGUL SYLLABLE SYOG..HANGUL SYLLABLE SYOH
            49689 <= code && code <= 49715 || // Lo  [27] HANGUL SYLLABLE SUG..HANGUL SYLLABLE SUH
            49717 <= code && code <= 49743 || // Lo  [27] HANGUL SYLLABLE SWEOG..HANGUL SYLLABLE SWEOH
            49745 <= code && code <= 49771 || // Lo  [27] HANGUL SYLLABLE SWEG..HANGUL SYLLABLE SWEH
            49773 <= code && code <= 49799 || // Lo  [27] HANGUL SYLLABLE SWIG..HANGUL SYLLABLE SWIH
            49801 <= code && code <= 49827 || // Lo  [27] HANGUL SYLLABLE SYUG..HANGUL SYLLABLE SYUH
            49829 <= code && code <= 49855 || // Lo  [27] HANGUL SYLLABLE SEUG..HANGUL SYLLABLE SEUH
            49857 <= code && code <= 49883 || // Lo  [27] HANGUL SYLLABLE SYIG..HANGUL SYLLABLE SYIH
            49885 <= code && code <= 49911 || // Lo  [27] HANGUL SYLLABLE SIG..HANGUL SYLLABLE SIH
            49913 <= code && code <= 49939 || // Lo  [27] HANGUL SYLLABLE SSAG..HANGUL SYLLABLE SSAH
            49941 <= code && code <= 49967 || // Lo  [27] HANGUL SYLLABLE SSAEG..HANGUL SYLLABLE SSAEH
            49969 <= code && code <= 49995 || // Lo  [27] HANGUL SYLLABLE SSYAG..HANGUL SYLLABLE SSYAH
            49997 <= code && code <= 50023 || // Lo  [27] HANGUL SYLLABLE SSYAEG..HANGUL SYLLABLE SSYAEH
            50025 <= code && code <= 50051 || // Lo  [27] HANGUL SYLLABLE SSEOG..HANGUL SYLLABLE SSEOH
            50053 <= code && code <= 50079 || // Lo  [27] HANGUL SYLLABLE SSEG..HANGUL SYLLABLE SSEH
            50081 <= code && code <= 50107 || // Lo  [27] HANGUL SYLLABLE SSYEOG..HANGUL SYLLABLE SSYEOH
            50109 <= code && code <= 50135 || // Lo  [27] HANGUL SYLLABLE SSYEG..HANGUL SYLLABLE SSYEH
            50137 <= code && code <= 50163 || // Lo  [27] HANGUL SYLLABLE SSOG..HANGUL SYLLABLE SSOH
            50165 <= code && code <= 50191 || // Lo  [27] HANGUL SYLLABLE SSWAG..HANGUL SYLLABLE SSWAH
            50193 <= code && code <= 50219 || // Lo  [27] HANGUL SYLLABLE SSWAEG..HANGUL SYLLABLE SSWAEH
            50221 <= code && code <= 50247 || // Lo  [27] HANGUL SYLLABLE SSOEG..HANGUL SYLLABLE SSOEH
            50249 <= code && code <= 50275 || // Lo  [27] HANGUL SYLLABLE SSYOG..HANGUL SYLLABLE SSYOH
            50277 <= code && code <= 50303 || // Lo  [27] HANGUL SYLLABLE SSUG..HANGUL SYLLABLE SSUH
            50305 <= code && code <= 50331 || // Lo  [27] HANGUL SYLLABLE SSWEOG..HANGUL SYLLABLE SSWEOH
            50333 <= code && code <= 50359 || // Lo  [27] HANGUL SYLLABLE SSWEG..HANGUL SYLLABLE SSWEH
            50361 <= code && code <= 50387 || // Lo  [27] HANGUL SYLLABLE SSWIG..HANGUL SYLLABLE SSWIH
            50389 <= code && code <= 50415 || // Lo  [27] HANGUL SYLLABLE SSYUG..HANGUL SYLLABLE SSYUH
            50417 <= code && code <= 50443 || // Lo  [27] HANGUL SYLLABLE SSEUG..HANGUL SYLLABLE SSEUH
            50445 <= code && code <= 50471 || // Lo  [27] HANGUL SYLLABLE SSYIG..HANGUL SYLLABLE SSYIH
            50473 <= code && code <= 50499 || // Lo  [27] HANGUL SYLLABLE SSIG..HANGUL SYLLABLE SSIH
            50501 <= code && code <= 50527 || // Lo  [27] HANGUL SYLLABLE AG..HANGUL SYLLABLE AH
            50529 <= code && code <= 50555 || // Lo  [27] HANGUL SYLLABLE AEG..HANGUL SYLLABLE AEH
            50557 <= code && code <= 50583 || // Lo  [27] HANGUL SYLLABLE YAG..HANGUL SYLLABLE YAH
            50585 <= code && code <= 50611 || // Lo  [27] HANGUL SYLLABLE YAEG..HANGUL SYLLABLE YAEH
            50613 <= code && code <= 50639 || // Lo  [27] HANGUL SYLLABLE EOG..HANGUL SYLLABLE EOH
            50641 <= code && code <= 50667 || // Lo  [27] HANGUL SYLLABLE EG..HANGUL SYLLABLE EH
            50669 <= code && code <= 50695 || // Lo  [27] HANGUL SYLLABLE YEOG..HANGUL SYLLABLE YEOH
            50697 <= code && code <= 50723 || // Lo  [27] HANGUL SYLLABLE YEG..HANGUL SYLLABLE YEH
            50725 <= code && code <= 50751 || // Lo  [27] HANGUL SYLLABLE OG..HANGUL SYLLABLE OH
            50753 <= code && code <= 50779 || // Lo  [27] HANGUL SYLLABLE WAG..HANGUL SYLLABLE WAH
            50781 <= code && code <= 50807 || // Lo  [27] HANGUL SYLLABLE WAEG..HANGUL SYLLABLE WAEH
            50809 <= code && code <= 50835 || // Lo  [27] HANGUL SYLLABLE OEG..HANGUL SYLLABLE OEH
            50837 <= code && code <= 50863 || // Lo  [27] HANGUL SYLLABLE YOG..HANGUL SYLLABLE YOH
            50865 <= code && code <= 50891 || // Lo  [27] HANGUL SYLLABLE UG..HANGUL SYLLABLE UH
            50893 <= code && code <= 50919 || // Lo  [27] HANGUL SYLLABLE WEOG..HANGUL SYLLABLE WEOH
            50921 <= code && code <= 50947 || // Lo  [27] HANGUL SYLLABLE WEG..HANGUL SYLLABLE WEH
            50949 <= code && code <= 50975 || // Lo  [27] HANGUL SYLLABLE WIG..HANGUL SYLLABLE WIH
            50977 <= code && code <= 51003 || // Lo  [27] HANGUL SYLLABLE YUG..HANGUL SYLLABLE YUH
            51005 <= code && code <= 51031 || // Lo  [27] HANGUL SYLLABLE EUG..HANGUL SYLLABLE EUH
            51033 <= code && code <= 51059 || // Lo  [27] HANGUL SYLLABLE YIG..HANGUL SYLLABLE YIH
            51061 <= code && code <= 51087 || // Lo  [27] HANGUL SYLLABLE IG..HANGUL SYLLABLE IH
            51089 <= code && code <= 51115 || // Lo  [27] HANGUL SYLLABLE JAG..HANGUL SYLLABLE JAH
            51117 <= code && code <= 51143 || // Lo  [27] HANGUL SYLLABLE JAEG..HANGUL SYLLABLE JAEH
            51145 <= code && code <= 51171 || // Lo  [27] HANGUL SYLLABLE JYAG..HANGUL SYLLABLE JYAH
            51173 <= code && code <= 51199 || // Lo  [27] HANGUL SYLLABLE JYAEG..HANGUL SYLLABLE JYAEH
            51201 <= code && code <= 51227 || // Lo  [27] HANGUL SYLLABLE JEOG..HANGUL SYLLABLE JEOH
            51229 <= code && code <= 51255 || // Lo  [27] HANGUL SYLLABLE JEG..HANGUL SYLLABLE JEH
            51257 <= code && code <= 51283 || // Lo  [27] HANGUL SYLLABLE JYEOG..HANGUL SYLLABLE JYEOH
            51285 <= code && code <= 51311 || // Lo  [27] HANGUL SYLLABLE JYEG..HANGUL SYLLABLE JYEH
            51313 <= code && code <= 51339 || // Lo  [27] HANGUL SYLLABLE JOG..HANGUL SYLLABLE JOH
            51341 <= code && code <= 51367 || // Lo  [27] HANGUL SYLLABLE JWAG..HANGUL SYLLABLE JWAH
            51369 <= code && code <= 51395 || // Lo  [27] HANGUL SYLLABLE JWAEG..HANGUL SYLLABLE JWAEH
            51397 <= code && code <= 51423 || // Lo  [27] HANGUL SYLLABLE JOEG..HANGUL SYLLABLE JOEH
            51425 <= code && code <= 51451 || // Lo  [27] HANGUL SYLLABLE JYOG..HANGUL SYLLABLE JYOH
            51453 <= code && code <= 51479 || // Lo  [27] HANGUL SYLLABLE JUG..HANGUL SYLLABLE JUH
            51481 <= code && code <= 51507 || // Lo  [27] HANGUL SYLLABLE JWEOG..HANGUL SYLLABLE JWEOH
            51509 <= code && code <= 51535 || // Lo  [27] HANGUL SYLLABLE JWEG..HANGUL SYLLABLE JWEH
            51537 <= code && code <= 51563 || // Lo  [27] HANGUL SYLLABLE JWIG..HANGUL SYLLABLE JWIH
            51565 <= code && code <= 51591 || // Lo  [27] HANGUL SYLLABLE JYUG..HANGUL SYLLABLE JYUH
            51593 <= code && code <= 51619 || // Lo  [27] HANGUL SYLLABLE JEUG..HANGUL SYLLABLE JEUH
            51621 <= code && code <= 51647 || // Lo  [27] HANGUL SYLLABLE JYIG..HANGUL SYLLABLE JYIH
            51649 <= code && code <= 51675 || // Lo  [27] HANGUL SYLLABLE JIG..HANGUL SYLLABLE JIH
            51677 <= code && code <= 51703 || // Lo  [27] HANGUL SYLLABLE JJAG..HANGUL SYLLABLE JJAH
            51705 <= code && code <= 51731 || // Lo  [27] HANGUL SYLLABLE JJAEG..HANGUL SYLLABLE JJAEH
            51733 <= code && code <= 51759 || // Lo  [27] HANGUL SYLLABLE JJYAG..HANGUL SYLLABLE JJYAH
            51761 <= code && code <= 51787 || // Lo  [27] HANGUL SYLLABLE JJYAEG..HANGUL SYLLABLE JJYAEH
            51789 <= code && code <= 51815 || // Lo  [27] HANGUL SYLLABLE JJEOG..HANGUL SYLLABLE JJEOH
            51817 <= code && code <= 51843 || // Lo  [27] HANGUL SYLLABLE JJEG..HANGUL SYLLABLE JJEH
            51845 <= code && code <= 51871 || // Lo  [27] HANGUL SYLLABLE JJYEOG..HANGUL SYLLABLE JJYEOH
            51873 <= code && code <= 51899 || // Lo  [27] HANGUL SYLLABLE JJYEG..HANGUL SYLLABLE JJYEH
            51901 <= code && code <= 51927 || // Lo  [27] HANGUL SYLLABLE JJOG..HANGUL SYLLABLE JJOH
            51929 <= code && code <= 51955 || // Lo  [27] HANGUL SYLLABLE JJWAG..HANGUL SYLLABLE JJWAH
            51957 <= code && code <= 51983 || // Lo  [27] HANGUL SYLLABLE JJWAEG..HANGUL SYLLABLE JJWAEH
            51985 <= code && code <= 52011 || // Lo  [27] HANGUL SYLLABLE JJOEG..HANGUL SYLLABLE JJOEH
            52013 <= code && code <= 52039 || // Lo  [27] HANGUL SYLLABLE JJYOG..HANGUL SYLLABLE JJYOH
            52041 <= code && code <= 52067 || // Lo  [27] HANGUL SYLLABLE JJUG..HANGUL SYLLABLE JJUH
            52069 <= code && code <= 52095 || // Lo  [27] HANGUL SYLLABLE JJWEOG..HANGUL SYLLABLE JJWEOH
            52097 <= code && code <= 52123 || // Lo  [27] HANGUL SYLLABLE JJWEG..HANGUL SYLLABLE JJWEH
            52125 <= code && code <= 52151 || // Lo  [27] HANGUL SYLLABLE JJWIG..HANGUL SYLLABLE JJWIH
            52153 <= code && code <= 52179 || // Lo  [27] HANGUL SYLLABLE JJYUG..HANGUL SYLLABLE JJYUH
            52181 <= code && code <= 52207 || // Lo  [27] HANGUL SYLLABLE JJEUG..HANGUL SYLLABLE JJEUH
            52209 <= code && code <= 52235 || // Lo  [27] HANGUL SYLLABLE JJYIG..HANGUL SYLLABLE JJYIH
            52237 <= code && code <= 52263 || // Lo  [27] HANGUL SYLLABLE JJIG..HANGUL SYLLABLE JJIH
            52265 <= code && code <= 52291 || // Lo  [27] HANGUL SYLLABLE CAG..HANGUL SYLLABLE CAH
            52293 <= code && code <= 52319 || // Lo  [27] HANGUL SYLLABLE CAEG..HANGUL SYLLABLE CAEH
            52321 <= code && code <= 52347 || // Lo  [27] HANGUL SYLLABLE CYAG..HANGUL SYLLABLE CYAH
            52349 <= code && code <= 52375 || // Lo  [27] HANGUL SYLLABLE CYAEG..HANGUL SYLLABLE CYAEH
            52377 <= code && code <= 52403 || // Lo  [27] HANGUL SYLLABLE CEOG..HANGUL SYLLABLE CEOH
            52405 <= code && code <= 52431 || // Lo  [27] HANGUL SYLLABLE CEG..HANGUL SYLLABLE CEH
            52433 <= code && code <= 52459 || // Lo  [27] HANGUL SYLLABLE CYEOG..HANGUL SYLLABLE CYEOH
            52461 <= code && code <= 52487 || // Lo  [27] HANGUL SYLLABLE CYEG..HANGUL SYLLABLE CYEH
            52489 <= code && code <= 52515 || // Lo  [27] HANGUL SYLLABLE COG..HANGUL SYLLABLE COH
            52517 <= code && code <= 52543 || // Lo  [27] HANGUL SYLLABLE CWAG..HANGUL SYLLABLE CWAH
            52545 <= code && code <= 52571 || // Lo  [27] HANGUL SYLLABLE CWAEG..HANGUL SYLLABLE CWAEH
            52573 <= code && code <= 52599 || // Lo  [27] HANGUL SYLLABLE COEG..HANGUL SYLLABLE COEH
            52601 <= code && code <= 52627 || // Lo  [27] HANGUL SYLLABLE CYOG..HANGUL SYLLABLE CYOH
            52629 <= code && code <= 52655 || // Lo  [27] HANGUL SYLLABLE CUG..HANGUL SYLLABLE CUH
            52657 <= code && code <= 52683 || // Lo  [27] HANGUL SYLLABLE CWEOG..HANGUL SYLLABLE CWEOH
            52685 <= code && code <= 52711 || // Lo  [27] HANGUL SYLLABLE CWEG..HANGUL SYLLABLE CWEH
            52713 <= code && code <= 52739 || // Lo  [27] HANGUL SYLLABLE CWIG..HANGUL SYLLABLE CWIH
            52741 <= code && code <= 52767 || // Lo  [27] HANGUL SYLLABLE CYUG..HANGUL SYLLABLE CYUH
            52769 <= code && code <= 52795 || // Lo  [27] HANGUL SYLLABLE CEUG..HANGUL SYLLABLE CEUH
            52797 <= code && code <= 52823 || // Lo  [27] HANGUL SYLLABLE CYIG..HANGUL SYLLABLE CYIH
            52825 <= code && code <= 52851 || // Lo  [27] HANGUL SYLLABLE CIG..HANGUL SYLLABLE CIH
            52853 <= code && code <= 52879 || // Lo  [27] HANGUL SYLLABLE KAG..HANGUL SYLLABLE KAH
            52881 <= code && code <= 52907 || // Lo  [27] HANGUL SYLLABLE KAEG..HANGUL SYLLABLE KAEH
            52909 <= code && code <= 52935 || // Lo  [27] HANGUL SYLLABLE KYAG..HANGUL SYLLABLE KYAH
            52937 <= code && code <= 52963 || // Lo  [27] HANGUL SYLLABLE KYAEG..HANGUL SYLLABLE KYAEH
            52965 <= code && code <= 52991 || // Lo  [27] HANGUL SYLLABLE KEOG..HANGUL SYLLABLE KEOH
            52993 <= code && code <= 53019 || // Lo  [27] HANGUL SYLLABLE KEG..HANGUL SYLLABLE KEH
            53021 <= code && code <= 53047 || // Lo  [27] HANGUL SYLLABLE KYEOG..HANGUL SYLLABLE KYEOH
            53049 <= code && code <= 53075 || // Lo  [27] HANGUL SYLLABLE KYEG..HANGUL SYLLABLE KYEH
            53077 <= code && code <= 53103 || // Lo  [27] HANGUL SYLLABLE KOG..HANGUL SYLLABLE KOH
            53105 <= code && code <= 53131 || // Lo  [27] HANGUL SYLLABLE KWAG..HANGUL SYLLABLE KWAH
            53133 <= code && code <= 53159 || // Lo  [27] HANGUL SYLLABLE KWAEG..HANGUL SYLLABLE KWAEH
            53161 <= code && code <= 53187 || // Lo  [27] HANGUL SYLLABLE KOEG..HANGUL SYLLABLE KOEH
            53189 <= code && code <= 53215 || // Lo  [27] HANGUL SYLLABLE KYOG..HANGUL SYLLABLE KYOH
            53217 <= code && code <= 53243 || // Lo  [27] HANGUL SYLLABLE KUG..HANGUL SYLLABLE KUH
            53245 <= code && code <= 53271 || // Lo  [27] HANGUL SYLLABLE KWEOG..HANGUL SYLLABLE KWEOH
            53273 <= code && code <= 53299 || // Lo  [27] HANGUL SYLLABLE KWEG..HANGUL SYLLABLE KWEH
            53301 <= code && code <= 53327 || // Lo  [27] HANGUL SYLLABLE KWIG..HANGUL SYLLABLE KWIH
            53329 <= code && code <= 53355 || // Lo  [27] HANGUL SYLLABLE KYUG..HANGUL SYLLABLE KYUH
            53357 <= code && code <= 53383 || // Lo  [27] HANGUL SYLLABLE KEUG..HANGUL SYLLABLE KEUH
            53385 <= code && code <= 53411 || // Lo  [27] HANGUL SYLLABLE KYIG..HANGUL SYLLABLE KYIH
            53413 <= code && code <= 53439 || // Lo  [27] HANGUL SYLLABLE KIG..HANGUL SYLLABLE KIH
            53441 <= code && code <= 53467 || // Lo  [27] HANGUL SYLLABLE TAG..HANGUL SYLLABLE TAH
            53469 <= code && code <= 53495 || // Lo  [27] HANGUL SYLLABLE TAEG..HANGUL SYLLABLE TAEH
            53497 <= code && code <= 53523 || // Lo  [27] HANGUL SYLLABLE TYAG..HANGUL SYLLABLE TYAH
            53525 <= code && code <= 53551 || // Lo  [27] HANGUL SYLLABLE TYAEG..HANGUL SYLLABLE TYAEH
            53553 <= code && code <= 53579 || // Lo  [27] HANGUL SYLLABLE TEOG..HANGUL SYLLABLE TEOH
            53581 <= code && code <= 53607 || // Lo  [27] HANGUL SYLLABLE TEG..HANGUL SYLLABLE TEH
            53609 <= code && code <= 53635 || // Lo  [27] HANGUL SYLLABLE TYEOG..HANGUL SYLLABLE TYEOH
            53637 <= code && code <= 53663 || // Lo  [27] HANGUL SYLLABLE TYEG..HANGUL SYLLABLE TYEH
            53665 <= code && code <= 53691 || // Lo  [27] HANGUL SYLLABLE TOG..HANGUL SYLLABLE TOH
            53693 <= code && code <= 53719 || // Lo  [27] HANGUL SYLLABLE TWAG..HANGUL SYLLABLE TWAH
            53721 <= code && code <= 53747 || // Lo  [27] HANGUL SYLLABLE TWAEG..HANGUL SYLLABLE TWAEH
            53749 <= code && code <= 53775 || // Lo  [27] HANGUL SYLLABLE TOEG..HANGUL SYLLABLE TOEH
            53777 <= code && code <= 53803 || // Lo  [27] HANGUL SYLLABLE TYOG..HANGUL SYLLABLE TYOH
            53805 <= code && code <= 53831 || // Lo  [27] HANGUL SYLLABLE TUG..HANGUL SYLLABLE TUH
            53833 <= code && code <= 53859 || // Lo  [27] HANGUL SYLLABLE TWEOG..HANGUL SYLLABLE TWEOH
            53861 <= code && code <= 53887 || // Lo  [27] HANGUL SYLLABLE TWEG..HANGUL SYLLABLE TWEH
            53889 <= code && code <= 53915 || // Lo  [27] HANGUL SYLLABLE TWIG..HANGUL SYLLABLE TWIH
            53917 <= code && code <= 53943 || // Lo  [27] HANGUL SYLLABLE TYUG..HANGUL SYLLABLE TYUH
            53945 <= code && code <= 53971 || // Lo  [27] HANGUL SYLLABLE TEUG..HANGUL SYLLABLE TEUH
            53973 <= code && code <= 53999 || // Lo  [27] HANGUL SYLLABLE TYIG..HANGUL SYLLABLE TYIH
            54001 <= code && code <= 54027 || // Lo  [27] HANGUL SYLLABLE TIG..HANGUL SYLLABLE TIH
            54029 <= code && code <= 54055 || // Lo  [27] HANGUL SYLLABLE PAG..HANGUL SYLLABLE PAH
            54057 <= code && code <= 54083 || // Lo  [27] HANGUL SYLLABLE PAEG..HANGUL SYLLABLE PAEH
            54085 <= code && code <= 54111 || // Lo  [27] HANGUL SYLLABLE PYAG..HANGUL SYLLABLE PYAH
            54113 <= code && code <= 54139 || // Lo  [27] HANGUL SYLLABLE PYAEG..HANGUL SYLLABLE PYAEH
            54141 <= code && code <= 54167 || // Lo  [27] HANGUL SYLLABLE PEOG..HANGUL SYLLABLE PEOH
            54169 <= code && code <= 54195 || // Lo  [27] HANGUL SYLLABLE PEG..HANGUL SYLLABLE PEH
            54197 <= code && code <= 54223 || // Lo  [27] HANGUL SYLLABLE PYEOG..HANGUL SYLLABLE PYEOH
            54225 <= code && code <= 54251 || // Lo  [27] HANGUL SYLLABLE PYEG..HANGUL SYLLABLE PYEH
            54253 <= code && code <= 54279 || // Lo  [27] HANGUL SYLLABLE POG..HANGUL SYLLABLE POH
            54281 <= code && code <= 54307 || // Lo  [27] HANGUL SYLLABLE PWAG..HANGUL SYLLABLE PWAH
            54309 <= code && code <= 54335 || // Lo  [27] HANGUL SYLLABLE PWAEG..HANGUL SYLLABLE PWAEH
            54337 <= code && code <= 54363 || // Lo  [27] HANGUL SYLLABLE POEG..HANGUL SYLLABLE POEH
            54365 <= code && code <= 54391 || // Lo  [27] HANGUL SYLLABLE PYOG..HANGUL SYLLABLE PYOH
            54393 <= code && code <= 54419 || // Lo  [27] HANGUL SYLLABLE PUG..HANGUL SYLLABLE PUH
            54421 <= code && code <= 54447 || // Lo  [27] HANGUL SYLLABLE PWEOG..HANGUL SYLLABLE PWEOH
            54449 <= code && code <= 54475 || // Lo  [27] HANGUL SYLLABLE PWEG..HANGUL SYLLABLE PWEH
            54477 <= code && code <= 54503 || // Lo  [27] HANGUL SYLLABLE PWIG..HANGUL SYLLABLE PWIH
            54505 <= code && code <= 54531 || // Lo  [27] HANGUL SYLLABLE PYUG..HANGUL SYLLABLE PYUH
            54533 <= code && code <= 54559 || // Lo  [27] HANGUL SYLLABLE PEUG..HANGUL SYLLABLE PEUH
            54561 <= code && code <= 54587 || // Lo  [27] HANGUL SYLLABLE PYIG..HANGUL SYLLABLE PYIH
            54589 <= code && code <= 54615 || // Lo  [27] HANGUL SYLLABLE PIG..HANGUL SYLLABLE PIH
            54617 <= code && code <= 54643 || // Lo  [27] HANGUL SYLLABLE HAG..HANGUL SYLLABLE HAH
            54645 <= code && code <= 54671 || // Lo  [27] HANGUL SYLLABLE HAEG..HANGUL SYLLABLE HAEH
            54673 <= code && code <= 54699 || // Lo  [27] HANGUL SYLLABLE HYAG..HANGUL SYLLABLE HYAH
            54701 <= code && code <= 54727 || // Lo  [27] HANGUL SYLLABLE HYAEG..HANGUL SYLLABLE HYAEH
            54729 <= code && code <= 54755 || // Lo  [27] HANGUL SYLLABLE HEOG..HANGUL SYLLABLE HEOH
            54757 <= code && code <= 54783 || // Lo  [27] HANGUL SYLLABLE HEG..HANGUL SYLLABLE HEH
            54785 <= code && code <= 54811 || // Lo  [27] HANGUL SYLLABLE HYEOG..HANGUL SYLLABLE HYEOH
            54813 <= code && code <= 54839 || // Lo  [27] HANGUL SYLLABLE HYEG..HANGUL SYLLABLE HYEH
            54841 <= code && code <= 54867 || // Lo  [27] HANGUL SYLLABLE HOG..HANGUL SYLLABLE HOH
            54869 <= code && code <= 54895 || // Lo  [27] HANGUL SYLLABLE HWAG..HANGUL SYLLABLE HWAH
            54897 <= code && code <= 54923 || // Lo  [27] HANGUL SYLLABLE HWAEG..HANGUL SYLLABLE HWAEH
            54925 <= code && code <= 54951 || // Lo  [27] HANGUL SYLLABLE HOEG..HANGUL SYLLABLE HOEH
            54953 <= code && code <= 54979 || // Lo  [27] HANGUL SYLLABLE HYOG..HANGUL SYLLABLE HYOH
            54981 <= code && code <= 55007 || // Lo  [27] HANGUL SYLLABLE HUG..HANGUL SYLLABLE HUH
            55009 <= code && code <= 55035 || // Lo  [27] HANGUL SYLLABLE HWEOG..HANGUL SYLLABLE HWEOH
            55037 <= code && code <= 55063 || // Lo  [27] HANGUL SYLLABLE HWEG..HANGUL SYLLABLE HWEH
            55065 <= code && code <= 55091 || // Lo  [27] HANGUL SYLLABLE HWIG..HANGUL SYLLABLE HWIH
            55093 <= code && code <= 55119 || // Lo  [27] HANGUL SYLLABLE HYUG..HANGUL SYLLABLE HYUH
            55121 <= code && code <= 55147 || // Lo  [27] HANGUL SYLLABLE HEUG..HANGUL SYLLABLE HEUH
            55149 <= code && code <= 55175 || // Lo  [27] HANGUL SYLLABLE HYIG..HANGUL SYLLABLE HYIH
            55177 <= code && code <= 55203 ? LVT : code == 9757 || // So       WHITE UP POINTING INDEX
            code == 9977 || // So       PERSON WITH BALL
            9994 <= code && code <= 9997 || // So   [4] RAISED FIST..WRITING HAND
            code == 127877 || // So       FATHER CHRISTMAS
            127938 <= code && code <= 127940 || // So   [3] SNOWBOARDER..SURFER
            code == 127943 || // So       HORSE RACING
            127946 <= code && code <= 127948 || // So   [3] SWIMMER..GOLFER
            128066 <= code && code <= 128067 || // So   [2] EAR..NOSE
            128070 <= code && code <= 128080 || // So  [11] WHITE UP POINTING BACKHAND INDEX..OPEN HANDS SIGN
            code == 128110 || // So       POLICE OFFICER
            128112 <= code && code <= 128120 || // So   [9] BRIDE WITH VEIL..PRINCESS
            code == 128124 || // So       BABY ANGEL
            128129 <= code && code <= 128131 || // So   [3] INFORMATION DESK PERSON..DANCER
            128133 <= code && code <= 128135 || // So   [3] NAIL POLISH..HAIRCUT
            code == 128170 || // So       FLEXED BICEPS
            128372 <= code && code <= 128373 || // So   [2] MAN IN BUSINESS SUIT LEVITATING..SLEUTH OR SPY
            code == 128378 || // So       MAN DANCING
            code == 128400 || // So       RAISED HAND WITH FINGERS SPLAYED
            128405 <= code && code <= 128406 || // So   [2] REVERSED HAND WITH MIDDLE FINGER EXTENDED..RAISED HAND WITH PART BETWEEN MIDDLE AND RING FINGERS
            128581 <= code && code <= 128583 || // So   [3] FACE WITH NO GOOD GESTURE..PERSON BOWING DEEPLY
            128587 <= code && code <= 128591 || // So   [5] HAPPY PERSON RAISING ONE HAND..PERSON WITH FOLDED HANDS
            code == 128675 || // So       ROWBOAT
            128692 <= code && code <= 128694 || // So   [3] BICYCLIST..PEDESTRIAN
            code == 128704 || // So       BATH
            code == 128716 || // So       SLEEPING ACCOMMODATION
            129304 <= code && code <= 129308 || // So   [5] SIGN OF THE HORNS..RIGHT-FACING FIST
            129310 <= code && code <= 129311 || // So   [2] HAND WITH INDEX AND MIDDLE FINGERS CROSSED..I LOVE YOU HAND SIGN
            code == 129318 || // So       FACE PALM
            129328 <= code && code <= 129337 || // So  [10] PREGNANT WOMAN..JUGGLING
            129341 <= code && code <= 129342 || // So   [2] WATER POLO..HANDBALL
            129489 <= code && code <= 129501 ? E_Base : 127995 <= code && code <= 127999 ? E_Modifier : code == 8205 ? ZWJ : code == 9792 || // So       FEMALE SIGN
            code == 9794 || // So       MALE SIGN
            9877 <= code && code <= 9878 || // So   [2] STAFF OF AESCULAPIUS..SCALES
            code == 9992 || // So       AIRPLANE
            code == 10084 || // So       HEAVY BLACK HEART
            code == 127752 || // So       RAINBOW
            code == 127806 || // So       EAR OF RICE
            code == 127859 || // So       COOKING
            code == 127891 || // So       GRADUATION CAP
            code == 127908 || // So       MICROPHONE
            code == 127912 || // So       ARTIST PALETTE
            code == 127979 || // So       SCHOOL
            code == 127981 || // So       FACTORY
            code == 128139 || // So       KISS MARK
            128187 <= code && code <= 128188 || // So   [2] PERSONAL COMPUTER..BRIEFCASE
            code == 128295 || // So       WRENCH
            code == 128300 || // So       MICROSCOPE
            code == 128488 || // So       LEFT SPEECH BUBBLE
            code == 128640 || // So       ROCKET
            code == 128658 ? Glue_After_Zwj : 128102 <= code && code <= 128105 ? E_Base_GAZ : Other;
          }
          return this;
        }
        module2.exports && (module2.exports = GraphemeSplitter);
      }), splitter = new graphemeSplitter(), substring = function(str, start, end) {
        for (var iterator = splitter.iterateGraphemes(str.substring(start)), value = "", pos = 0; pos < end - start; pos++) {
          var next = iterator.next();
          if (value += next.value, next.done)
            break;
        }
        return value;
      }, location2 = function(startLine, startColumn, startOffset, endLine, endColumn, endOffset, source) {
        return {
          start: {
            line: startLine,
            column: startColumn,
            offset: startOffset
          },
          end: {
            line: endLine,
            column: endColumn,
            offset: endOffset
          },
          source: source || null
        };
      }, build2 = createCommonjsModule(function(module2, exports2) {
        (function(global2, factory) {
          module2.exports = factory();
        })(commonjsGlobal, function() {
          "use strict";
          "use strict";
          var res = "", cache2, repeatString = repeat2;
          function repeat2(str, num) {
            if (typeof str != "string")
              throw new TypeError("expected a string");
            if (num === 1)
              return str;
            if (num === 2)
              return str + str;
            var max = str.length * num;
            if (cache2 !== str || typeof cache2 > "u")
              cache2 = str, res = "";
            else if (res.length >= max)
              return res.substr(0, max);
            for (; max > res.length && num > 1; )
              num & 1 && (res += str), num >>= 1, str += str;
            return res += str, res = res.substr(0, max), res;
          }
          var padStart = function(string, maxLength, fillString) {
            if (string == null || maxLength == null)
              return string;
            var result = String(string), targetLen = typeof maxLength == "number" ? maxLength : parseInt(maxLength, 10);
            if (isNaN(targetLen) || !isFinite(targetLen))
              return result;
            var length = result.length;
            if (length >= targetLen)
              return result;
            var fill = fillString == null ? "" : String(fillString);
            fill === "" && (fill = " ");
            for (var fillLen = targetLen - length; fill.length < fillLen; )
              fill += fill;
            var truncated = fill.length > fillLen ? fill.substr(0, fillLen) : fill;
            return truncated + result;
          }, _extends = Object.assign || function(target) {
            for (var i = 1; i < arguments.length; i++) {
              var source = arguments[i];
              for (var key in source)
                Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
            }
            return target;
          };
          function printLine(line, position, maxNumLength, settings) {
            var num = String(position), formattedNum = padStart(num, maxNumLength, " "), tabReplacement = repeatString(" ", settings.tabSize);
            return formattedNum + " | " + line.replace(/\t/g, tabReplacement);
          }
          function printLines(lines, start, end, maxNumLength, settings) {
            return lines.slice(start, end).map(function(line, i) {
              return printLine(line, start + i + 1, maxNumLength, settings);
            }).join(`
`);
          }
          var defaultSettings2 = {
            extraLines: 2,
            tabSize: 4
          }, index = function(input, linePos, columnPos, settings) {
            settings = _extends({}, defaultSettings2, settings);
            var lines = input.split(/\r\n?|\n|\f/), startLinePos = Math.max(1, linePos - settings.extraLines) - 1, endLinePos = Math.min(linePos + settings.extraLines, lines.length), maxNumLength = String(endLinePos).length, prevLines = printLines(lines, startLinePos, linePos, maxNumLength, settings), targetLineBeforeCursor = printLine(lines[linePos - 1].substring(0, columnPos - 1), linePos, maxNumLength, settings), cursorLine = repeatString(" ", targetLineBeforeCursor.length) + "^", nextLines = printLines(lines, linePos, endLinePos, maxNumLength, settings);
            return [prevLines, cursorLine, nextLines].filter(Boolean).join(`
`);
          };
          return index;
        });
      }), errorStack = new Error().stack, createError2 = function(props) {
        var error2 = Object.create(SyntaxError.prototype);
        return Object.assign(error2, props, {
          name: "SyntaxError"
        }), Object.defineProperty(error2, "stack", {
          get: function() {
            return errorStack ? errorStack.replace(/^(.+\n){1,3}/, String(error2) + `
`) : "";
          }
        }), error2;
      }, error = function(message, input, source, line, column) {
        throw createError2({
          message: line ? message + `
` + build2(input, line, column) : message,
          rawMessage: message,
          source,
          line,
          column
        });
      }, parseErrorTypes = {
        unexpectedEnd: function() {
          return "Unexpected end of input";
        },
        unexpectedToken: function(token) {
          for (var _len = arguments.length, position = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++)
            position[_key - 1] = arguments[_key];
          return "Unexpected token <" + token + "> at " + position.filter(Boolean).join(":");
        }
      }, tokenizeErrorTypes = {
        unexpectedSymbol: function(symbol) {
          for (var _len = arguments.length, position = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++)
            position[_key - 1] = arguments[_key];
          return "Unexpected symbol <" + symbol + "> at " + position.filter(Boolean).join(":");
        }
      }, tokenTypes = {
        LEFT_BRACE: 0,
        // {
        RIGHT_BRACE: 1,
        // }
        LEFT_BRACKET: 2,
        // [
        RIGHT_BRACKET: 3,
        // ]
        COLON: 4,
        // :
        COMMA: 5,
        // ,
        STRING: 6,
        //
        NUMBER: 7,
        //
        TRUE: 8,
        // true
        FALSE: 9,
        // false
        NULL: 10
        // null
      }, punctuatorTokensMap = {
        // Lexeme: Token
        "{": tokenTypes.LEFT_BRACE,
        "}": tokenTypes.RIGHT_BRACE,
        "[": tokenTypes.LEFT_BRACKET,
        "]": tokenTypes.RIGHT_BRACKET,
        ":": tokenTypes.COLON,
        ",": tokenTypes.COMMA
      }, keywordTokensMap = {
        // Lexeme: Token
        true: tokenTypes.TRUE,
        false: tokenTypes.FALSE,
        null: tokenTypes.NULL
      }, stringStates = {
        _START_: 0,
        START_QUOTE_OR_CHAR: 1,
        ESCAPE: 2
      }, escapes$1 = {
        '"': 0,
        // Quotation mask
        "\\": 1,
        // Reverse solidus
        "/": 2,
        // Solidus
        b: 3,
        // Backspace
        f: 4,
        // Form feed
        n: 5,
        // New line
        r: 6,
        // Carriage return
        t: 7,
        // Horizontal tab
        u: 8
        // 4 hexadecimal digits
      }, numberStates = {
        _START_: 0,
        MINUS: 1,
        ZERO: 2,
        DIGIT: 3,
        POINT: 4,
        DIGIT_FRACTION: 5,
        EXP: 6,
        EXP_DIGIT_OR_SIGN: 7
      };
      function isDigit1to9(char) {
        return char >= "1" && char <= "9";
      }
      function isDigit2(char) {
        return char >= "0" && char <= "9";
      }
      function isHex(char) {
        return isDigit2(char) || char >= "a" && char <= "f" || char >= "A" && char <= "F";
      }
      function isExp(char) {
        return char === "e" || char === "E";
      }
      function parseWhitespace(input, index, line, column) {
        var char = input.charAt(index);
        if (char === "\r")
          index++, line++, column = 1, input.charAt(index) === `
` && index++;
        else if (char === `
`)
          index++, line++, column = 1;
        else if (char === "	" || char === " ")
          index++, column++;
        else
          return null;
        return {
          index,
          line,
          column
        };
      }
      function parseChar(input, index, line, column) {
        var char = input.charAt(index);
        return char in punctuatorTokensMap ? {
          type: punctuatorTokensMap[char],
          line,
          column: column + 1,
          index: index + 1,
          value: null
        } : null;
      }
      function parseKeyword(input, index, line, column) {
        for (var name in keywordTokensMap)
          if (keywordTokensMap.hasOwnProperty(name) && input.substr(index, name.length) === name)
            return {
              type: keywordTokensMap[name],
              line,
              column: column + name.length,
              index: index + name.length,
              value: name
            };
        return null;
      }
      function parseString$1(input, index, line, column) {
        for (var startIndex = index, state = stringStates._START_; index < input.length; ) {
          var char = input.charAt(index);
          switch (state) {
            case stringStates._START_: {
              if (char === '"')
                index++, state = stringStates.START_QUOTE_OR_CHAR;
              else
                return null;
              break;
            }
            case stringStates.START_QUOTE_OR_CHAR: {
              if (char === "\\")
                index++, state = stringStates.ESCAPE;
              else {
                if (char === '"')
                  return index++, {
                    type: tokenTypes.STRING,
                    line,
                    column: column + index - startIndex,
                    index,
                    value: input.slice(startIndex, index)
                  };
                index++;
              }
              break;
            }
            case stringStates.ESCAPE: {
              if (char in escapes$1) {
                if (index++, char === "u")
                  for (var i = 0; i < 4; i++) {
                    var curChar = input.charAt(index);
                    if (curChar && isHex(curChar))
                      index++;
                    else
                      return null;
                  }
                state = stringStates.START_QUOTE_OR_CHAR;
              } else
                return null;
              break;
            }
          }
        }
      }
      function parseNumber(input, index, line, column) {
        var startIndex = index, passedValueIndex = index, state = numberStates._START_;
        iterator:
          for (; index < input.length; ) {
            var char = input.charAt(index);
            switch (state) {
              case numberStates._START_: {
                if (char === "-")
                  state = numberStates.MINUS;
                else if (char === "0")
                  passedValueIndex = index + 1, state = numberStates.ZERO;
                else if (isDigit1to9(char))
                  passedValueIndex = index + 1, state = numberStates.DIGIT;
                else
                  return null;
                break;
              }
              case numberStates.MINUS: {
                if (char === "0")
                  passedValueIndex = index + 1, state = numberStates.ZERO;
                else if (isDigit1to9(char))
                  passedValueIndex = index + 1, state = numberStates.DIGIT;
                else
                  return null;
                break;
              }
              case numberStates.ZERO: {
                if (char === ".")
                  state = numberStates.POINT;
                else if (isExp(char))
                  state = numberStates.EXP;
                else
                  break iterator;
                break;
              }
              case numberStates.DIGIT: {
                if (isDigit2(char))
                  passedValueIndex = index + 1;
                else if (char === ".")
                  state = numberStates.POINT;
                else if (isExp(char))
                  state = numberStates.EXP;
                else
                  break iterator;
                break;
              }
              case numberStates.POINT: {
                if (isDigit2(char))
                  passedValueIndex = index + 1, state = numberStates.DIGIT_FRACTION;
                else
                  break iterator;
                break;
              }
              case numberStates.DIGIT_FRACTION: {
                if (isDigit2(char))
                  passedValueIndex = index + 1;
                else if (isExp(char))
                  state = numberStates.EXP;
                else
                  break iterator;
                break;
              }
              case numberStates.EXP: {
                if (char === "+" || char === "-")
                  state = numberStates.EXP_DIGIT_OR_SIGN;
                else if (isDigit2(char))
                  passedValueIndex = index + 1, state = numberStates.EXP_DIGIT_OR_SIGN;
                else
                  break iterator;
                break;
              }
              case numberStates.EXP_DIGIT_OR_SIGN: {
                if (isDigit2(char))
                  passedValueIndex = index + 1;
                else
                  break iterator;
                break;
              }
            }
            index++;
          }
        return passedValueIndex > 0 ? {
          type: tokenTypes.NUMBER,
          line,
          column: column + passedValueIndex - startIndex,
          index: passedValueIndex,
          value: input.slice(startIndex, passedValueIndex)
        } : null;
      }
      var tokenize2 = function(input, settings) {
        for (var line = 1, column = 1, index = 0, tokens = []; index < input.length; ) {
          var args = [input, index, line, column], whitespace = parseWhitespace.apply(void 0, args);
          if (whitespace) {
            index = whitespace.index, line = whitespace.line, column = whitespace.column;
            continue;
          }
          var matched = parseChar.apply(void 0, args) || parseKeyword.apply(void 0, args) || parseString$1.apply(void 0, args) || parseNumber.apply(void 0, args);
          if (matched) {
            var token = {
              type: matched.type,
              value: matched.value,
              loc: location2(line, column, index, matched.line, matched.column, matched.index, settings.source)
            };
            tokens.push(token), index = matched.index, line = matched.line, column = matched.column;
          } else
            error(tokenizeErrorTypes.unexpectedSymbol(substring(input, index, index + 1), settings.source, line, column), input, settings.source, line, column);
        }
        return tokens;
      }, objectStates = {
        _START_: 0,
        OPEN_OBJECT: 1,
        PROPERTY: 2,
        COMMA: 3
      }, propertyStates = {
        _START_: 0,
        KEY: 1,
        COLON: 2
      }, arrayStates = {
        _START_: 0,
        OPEN_ARRAY: 1,
        VALUE: 2,
        COMMA: 3
      }, defaultSettings = {
        loc: !0,
        source: null
      };
      function errorEof(input, tokenList, settings) {
        var loc = tokenList.length > 0 ? tokenList[tokenList.length - 1].loc.end : { line: 1, column: 1 };
        error(parseErrorTypes.unexpectedEnd(), input, settings.source, loc.line, loc.column);
      }
      function parseHexEscape(hexCode) {
        for (var charCode = 0, i = 0; i < 4; i++)
          charCode = charCode * 16 + parseInt(hexCode[i], 16);
        return String.fromCharCode(charCode);
      }
      var escapes = {
        b: "\b",
        // Backspace
        f: "\f",
        // Form feed
        n: `
`,
        // New line
        r: "\r",
        // Carriage return
        t: "	"
        // Horizontal tab
      }, passEscapes = ['"', "\\", "/"];
      function parseString(string) {
        for (var result = "", i = 0; i < string.length; i++) {
          var char = string.charAt(i);
          if (char === "\\") {
            i++;
            var nextChar = string.charAt(i);
            if (nextChar === "u")
              result += parseHexEscape(string.substr(i + 1, 4)), i += 4;
            else if (passEscapes.indexOf(nextChar) !== -1)
              result += nextChar;
            else if (nextChar in escapes)
              result += escapes[nextChar];
            else
              break;
          } else
            result += char;
        }
        return result;
      }
      function parseObject(input, tokenList, index, settings) {
        for (var startToken = void 0, object = {
          type: "Object",
          children: []
        }, state = objectStates._START_; index < tokenList.length; ) {
          var token = tokenList[index];
          switch (state) {
            case objectStates._START_: {
              if (token.type === tokenTypes.LEFT_BRACE)
                startToken = token, state = objectStates.OPEN_OBJECT, index++;
              else
                return null;
              break;
            }
            case objectStates.OPEN_OBJECT: {
              if (token.type === tokenTypes.RIGHT_BRACE)
                return settings.loc && (object.loc = location2(startToken.loc.start.line, startToken.loc.start.column, startToken.loc.start.offset, token.loc.end.line, token.loc.end.column, token.loc.end.offset, settings.source)), {
                  value: object,
                  index: index + 1
                };
              var property = parseProperty(input, tokenList, index, settings);
              object.children.push(property.value), state = objectStates.PROPERTY, index = property.index;
              break;
            }
            case objectStates.PROPERTY: {
              if (token.type === tokenTypes.RIGHT_BRACE)
                return settings.loc && (object.loc = location2(startToken.loc.start.line, startToken.loc.start.column, startToken.loc.start.offset, token.loc.end.line, token.loc.end.column, token.loc.end.offset, settings.source)), {
                  value: object,
                  index: index + 1
                };
              token.type === tokenTypes.COMMA ? (state = objectStates.COMMA, index++) : error(parseErrorTypes.unexpectedToken(substring(input, token.loc.start.offset, token.loc.end.offset), settings.source, token.loc.start.line, token.loc.start.column), input, settings.source, token.loc.start.line, token.loc.start.column);
              break;
            }
            case objectStates.COMMA: {
              var _property = parseProperty(input, tokenList, index, settings);
              _property ? (index = _property.index, object.children.push(_property.value), state = objectStates.PROPERTY) : error(parseErrorTypes.unexpectedToken(substring(input, token.loc.start.offset, token.loc.end.offset), settings.source, token.loc.start.line, token.loc.start.column), input, settings.source, token.loc.start.line, token.loc.start.column);
              break;
            }
          }
        }
        errorEof(input, tokenList, settings);
      }
      function parseProperty(input, tokenList, index, settings) {
        for (var startToken = void 0, property = {
          type: "Property",
          key: null,
          value: null
        }, state = propertyStates._START_; index < tokenList.length; ) {
          var token = tokenList[index];
          switch (state) {
            case propertyStates._START_: {
              if (token.type === tokenTypes.STRING) {
                var key = {
                  type: "Identifier",
                  value: parseString(input.slice(token.loc.start.offset + 1, token.loc.end.offset - 1)),
                  raw: token.value
                };
                settings.loc && (key.loc = token.loc), startToken = token, property.key = key, state = propertyStates.KEY, index++;
              } else
                return null;
              break;
            }
            case propertyStates.KEY: {
              token.type === tokenTypes.COLON ? (state = propertyStates.COLON, index++) : error(parseErrorTypes.unexpectedToken(substring(input, token.loc.start.offset, token.loc.end.offset), settings.source, token.loc.start.line, token.loc.start.column), input, settings.source, token.loc.start.line, token.loc.start.column);
              break;
            }
            case propertyStates.COLON: {
              var value = parseValue(input, tokenList, index, settings);
              return property.value = value.value, settings.loc && (property.loc = location2(startToken.loc.start.line, startToken.loc.start.column, startToken.loc.start.offset, value.value.loc.end.line, value.value.loc.end.column, value.value.loc.end.offset, settings.source)), {
                value: property,
                index: value.index
              };
            }
          }
        }
      }
      function parseArray(input, tokenList, index, settings) {
        for (var startToken = void 0, array = {
          type: "Array",
          children: []
        }, state = arrayStates._START_, token = void 0; index < tokenList.length; )
          switch (token = tokenList[index], state) {
            case arrayStates._START_: {
              if (token.type === tokenTypes.LEFT_BRACKET)
                startToken = token, state = arrayStates.OPEN_ARRAY, index++;
              else
                return null;
              break;
            }
            case arrayStates.OPEN_ARRAY: {
              if (token.type === tokenTypes.RIGHT_BRACKET)
                return settings.loc && (array.loc = location2(startToken.loc.start.line, startToken.loc.start.column, startToken.loc.start.offset, token.loc.end.line, token.loc.end.column, token.loc.end.offset, settings.source)), {
                  value: array,
                  index: index + 1
                };
              var value = parseValue(input, tokenList, index, settings);
              index = value.index, array.children.push(value.value), state = arrayStates.VALUE;
              break;
            }
            case arrayStates.VALUE: {
              if (token.type === tokenTypes.RIGHT_BRACKET)
                return settings.loc && (array.loc = location2(startToken.loc.start.line, startToken.loc.start.column, startToken.loc.start.offset, token.loc.end.line, token.loc.end.column, token.loc.end.offset, settings.source)), {
                  value: array,
                  index: index + 1
                };
              token.type === tokenTypes.COMMA ? (state = arrayStates.COMMA, index++) : error(parseErrorTypes.unexpectedToken(substring(input, token.loc.start.offset, token.loc.end.offset), settings.source, token.loc.start.line, token.loc.start.column), input, settings.source, token.loc.start.line, token.loc.start.column);
              break;
            }
            case arrayStates.COMMA: {
              var _value = parseValue(input, tokenList, index, settings);
              index = _value.index, array.children.push(_value.value), state = arrayStates.VALUE;
              break;
            }
          }
        errorEof(input, tokenList, settings);
      }
      function parseLiteral(input, tokenList, index, settings) {
        var token = tokenList[index], value = null;
        switch (token.type) {
          case tokenTypes.STRING: {
            value = parseString(input.slice(token.loc.start.offset + 1, token.loc.end.offset - 1));
            break;
          }
          case tokenTypes.NUMBER: {
            value = Number(token.value);
            break;
          }
          case tokenTypes.TRUE: {
            value = !0;
            break;
          }
          case tokenTypes.FALSE: {
            value = !1;
            break;
          }
          case tokenTypes.NULL: {
            value = null;
            break;
          }
          default:
            return null;
        }
        var literal = {
          type: "Literal",
          value,
          raw: token.value
        };
        return settings.loc && (literal.loc = token.loc), {
          value: literal,
          index: index + 1
        };
      }
      function parseValue(input, tokenList, index, settings) {
        var token = tokenList[index], value = parseLiteral.apply(void 0, arguments) || parseObject.apply(void 0, arguments) || parseArray.apply(void 0, arguments);
        if (value)
          return value;
        error(parseErrorTypes.unexpectedToken(substring(input, token.loc.start.offset, token.loc.end.offset), settings.source, token.loc.start.line, token.loc.start.column), input, settings.source, token.loc.start.line, token.loc.start.column);
      }
      var parse$1 = function(input, settings) {
        settings = Object.assign({}, defaultSettings, settings);
        var tokenList = tokenize2(input, settings);
        tokenList.length === 0 && errorEof(input, tokenList, settings);
        var value = parseValue(input, tokenList, 0, settings);
        if (value.index === tokenList.length)
          return value.value;
        var token = tokenList[value.index];
        error(parseErrorTypes.unexpectedToken(substring(input, token.loc.start.offset, token.loc.end.offset), settings.source, token.loc.start.line, token.loc.start.column), input, settings.source, token.loc.start.line, token.loc.start.column);
      };
      return parse$1;
    });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/to-source-code.js
var require_to_source_code = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/to-source-code.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.toSourceCode = exports.toJSONAST = exports.toLiquidHTMLAST = void 0;
    var liquid_html_parser_1 = require_dist(), json_to_ast_1 = __importDefault(require_build()), types_1 = require_types2(), error_1 = require_error();
    function toLiquidHTMLAST(source) {
      try {
        return (0, liquid_html_parser_1.toLiquidHtmlAST)(source);
      } catch (error) {
        return (0, error_1.asError)(error);
      }
    }
    exports.toLiquidHTMLAST = toLiquidHTMLAST;
    function toJSONAST(source) {
      try {
        return (0, json_to_ast_1.default)(source);
      } catch (error) {
        return (0, error_1.asError)(error);
      }
    }
    exports.toJSONAST = toJSONAST;
    function toSourceCode(absolutePath, source, version2) {
      return absolutePath.endsWith(".liquid") ? {
        absolutePath: normalize(absolutePath),
        source,
        type: types_1.SourceCodeType.LiquidHtml,
        ast: toLiquidHTMLAST(source),
        version: version2
      } : {
        absolutePath: normalize(absolutePath),
        source,
        type: types_1.SourceCodeType.JSON,
        ast: toJSONAST(source),
        version: version2
      };
    }
    exports.toSourceCode = toSourceCode;
    function normalize(path3) {
      return path3.replace(/\\/g, "/");
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/index.js
var require_dist2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-common@2.8.0/node_modules/@shopify/theme-check-common/dist/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: !0, value: v });
    } : function(o, v) {
      o.default = v;
    }), __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null)
        for (var k in mod)
          k !== "default" && Object.prototype.hasOwnProperty.call(mod, k) && __createBinding(result, mod, k);
      return __setModuleDefault(result, mod), result;
    }, __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p) && __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.check = void 0;
    var types_1 = require_types2(), visitors_1 = require_visitors(), disabled_checks_1 = require_disabled_checks(), path3 = __importStar(require_path()), utils_1 = require_utils2(), ignore_1 = require_ignore(), AugmentedThemeDocset_1 = require_AugmentedThemeDocset(), JSONValidator_1 = require_JSONValidator();
    __exportStar(require_AugmentedThemeDocset(), exports);
    __exportStar(require_fixes(), exports);
    __exportStar(require_types2(), exports);
    __exportStar(require_checks(), exports);
    __exportStar(require_to_source_code(), exports);
    __exportStar(require_json2(), exports);
    __exportStar(require_ignore(), exports);
    __exportStar(require_error(), exports);
    __exportStar(require_types3(), exports);
    __exportStar(require_memo(), exports);
    __exportStar(require_indexBy(), exports);
    var defaultErrorHandler = (_error) => {
    };
    async function check2(sourceCodes, config2, dependencies) {
      let pipelines = [], offenses = [], { DisabledChecksVisitor, isDisabled } = (0, disabled_checks_1.createDisabledChecksModule)(), validateJSON;
      if (dependencies.themeDocset && !dependencies.themeDocset.isAugmented && (dependencies.themeDocset = new AugmentedThemeDocset_1.AugmentedThemeDocset(dependencies.themeDocset)), dependencies.jsonValidationSet) {
        let jsonValidator = new JSONValidator_1.JSONValidator(await dependencies.jsonValidationSet.schemas(config2.context));
        validateJSON = jsonValidator.validate.bind(jsonValidator);
      }
      for (let type of Object.values(types_1.SourceCodeType))
        switch (type) {
          case types_1.SourceCodeType.JSON: {
            let files = filesOfType(type, sourceCodes), checkDefs = checksOfType(type, config2.checks);
            for (let file of files)
              for (let checkDef of checkDefs) {
                if ((0, ignore_1.isIgnored)(file.absolutePath, config2, checkDef))
                  continue;
                let check3 = createCheck(checkDef, file, config2, offenses, dependencies, validateJSON);
                pipelines.push(checkJSONFile(check3, file));
              }
            break;
          }
          case types_1.SourceCodeType.LiquidHtml: {
            let files = filesOfType(type, sourceCodes), checkDefs = [DisabledChecksVisitor, ...checksOfType(type, config2.checks)];
            for (let file of files)
              for (let checkDef of checkDefs) {
                if ((0, ignore_1.isIgnored)(file.absolutePath, config2, checkDef))
                  continue;
                let check3 = createCheck(checkDef, file, config2, offenses, dependencies, validateJSON);
                pipelines.push(checkLiquidFile(check3, file));
              }
            break;
          }
        }
      let onRejected = config2.onError || defaultErrorHandler;
      return await Promise.all(pipelines.map((pipeline3) => pipeline3.catch(onRejected))), offenses.filter((offense) => !isDisabled(offense));
    }
    exports.check = check2;
    function createContext(check3, file, offenses, config2, dependencies, validateJSON) {
      let checkSettings = config2.settings[check3.meta.code];
      return {
        ...dependencies,
        validateJSON,
        settings: createSettings(checkSettings, check3.meta.schema),
        absolutePath: (relativePath2) => path3.join(config2.root, relativePath2),
        relativePath: (absolutePath) => path3.relative(absolutePath, config2.root),
        report(problem) {
          var _a38;
          offenses.push({
            type: check3.meta.type,
            check: check3.meta.code,
            message: problem.message,
            absolutePath: file.absolutePath,
            severity: (_a38 = checkSettings?.severity) !== null && _a38 !== void 0 ? _a38 : check3.meta.severity,
            start: (0, utils_1.getPosition)(file.source, problem.startIndex),
            end: (0, utils_1.getPosition)(file.source, problem.endIndex),
            fix: problem.fix,
            suggest: problem.suggest
          });
        },
        file
      };
    }
    function createSettings(checkSettings, schema) {
      var _a38;
      let settings = {};
      for (let [key, schemaProp] of Object.entries(schema))
        settings[key] = (_a38 = checkSettings?.[key]) !== null && _a38 !== void 0 ? _a38 : schemaProp.defaultValue();
      return settings;
    }
    function checksOfType(type, checks) {
      return checks.filter((def) => def.meta.type === type);
    }
    function createCheck(check3, file, config2, offenses, dependencies, validateJSON) {
      let context = createContext(check3, file, offenses, config2, dependencies, validateJSON);
      return check3.create(context);
    }
    function filesOfType(type, sourceCodes) {
      return sourceCodes.filter((file) => file.type === type);
    }
    async function checkJSONFile(check3, file) {
      check3.onCodePathStart && await check3.onCodePathStart(file), !(file.ast instanceof Error) && (Object.keys(check3).length > 0 && await (0, visitors_1.visitJSON)(file.ast, check3), check3.onCodePathEnd && await check3.onCodePathEnd(file));
    }
    async function checkLiquidFile(check3, file) {
      check3.onCodePathStart && await check3.onCodePathStart(file), !(file.ast instanceof Error) && (Object.keys(check3).length > 0 && await (0, visitors_1.visitLiquid)(file.ast, check3), check3.onCodePathEnd && await check3.onCodePathEnd(file));
    }
  }
});

// ../../node_modules/.pnpm/env-paths@2.2.1/node_modules/env-paths/index.js
var require_env_paths = __commonJS({
  "../../node_modules/.pnpm/env-paths@2.2.1/node_modules/env-paths/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var path3 = __require("path"), os = __require("os"), homedir = os.homedir(), tmpdir = os.tmpdir(), { env } = process, macos = (name) => {
      let library = path3.join(homedir, "Library");
      return {
        data: path3.join(library, "Application Support", name),
        config: path3.join(library, "Preferences", name),
        cache: path3.join(library, "Caches", name),
        log: path3.join(library, "Logs", name),
        temp: path3.join(tmpdir, name)
      };
    }, windows = (name) => {
      let appData = env.APPDATA || path3.join(homedir, "AppData", "Roaming"), localAppData = env.LOCALAPPDATA || path3.join(homedir, "AppData", "Local");
      return {
        // Data/config/cache/log are invented by me as Windows isn't opinionated about this
        data: path3.join(localAppData, name, "Data"),
        config: path3.join(appData, name, "Config"),
        cache: path3.join(localAppData, name, "Cache"),
        log: path3.join(localAppData, name, "Log"),
        temp: path3.join(tmpdir, name)
      };
    }, linux = (name) => {
      let username2 = path3.basename(homedir);
      return {
        data: path3.join(env.XDG_DATA_HOME || path3.join(homedir, ".local", "share"), name),
        config: path3.join(env.XDG_CONFIG_HOME || path3.join(homedir, ".config"), name),
        cache: path3.join(env.XDG_CACHE_HOME || path3.join(homedir, ".cache"), name),
        // https://wiki.debian.org/XDGBaseDirectorySpecification#state
        log: path3.join(env.XDG_STATE_HOME || path3.join(homedir, ".local", "state"), name),
        temp: path3.join(tmpdir, username2, name)
      };
    }, envPaths = (name, options) => {
      if (typeof name != "string")
        throw new TypeError(`Expected string, got ${typeof name}`);
      return options = Object.assign({ suffix: "nodejs" }, options), options.suffix && (name += `-${options.suffix}`), process.platform === "darwin" ? macos(name) : process.platform === "win32" ? windows(name) : linux(name);
    };
    module.exports = envPaths;
    module.exports.default = envPaths;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-docs-updater@2.8.0/node_modules/@shopify/theme-check-docs-updater/dist/utils.js
var require_utils5 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-docs-updater@2.8.0/node_modules/@shopify/theme-check-docs-updater/dist/utils.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.memoize = exports.memo = exports.tap = exports.identity = exports.noop = void 0;
    var noop = () => {
    };
    exports.noop = noop;
    var identity = (x) => x;
    exports.identity = identity;
    var tap = (tappingFunction) => (x) => (tappingFunction(x), x);
    exports.tap = tap;
    function memo(fn) {
      let cachedValue;
      return (...args) => (cachedValue || (cachedValue = fn(...args)), cachedValue);
    }
    exports.memo = memo;
    function memoize(fn, keyFn) {
      let cache2 = {};
      return (arg) => {
        let key = keyFn(arg);
        return cache2[key] || (cache2[key] = fn(arg)), cache2[key];
      };
    }
    exports.memoize = memoize;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-docs-updater@2.8.0/node_modules/@shopify/theme-check-docs-updater/dist/themeLiquidDocsDownloader.js
var require_themeLiquidDocsDownloader = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-docs-updater@2.8.0/node_modules/@shopify/theme-check-docs-updater/dist/themeLiquidDocsDownloader.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.downloadThemeLiquidDocs = exports.exists = exports.schemaUrl = exports.schemaPath = exports.resourceUrl = exports.resourcePath = exports.download = exports.downloadResource = exports.downloadSchema = exports.Manifests = exports.Resources = exports.ThemeLiquidDocsSchemaRoot = exports.ThemeLiquidDocsRoot = exports.root = void 0;
    var env_paths_1 = __importDefault(require_env_paths()), node_fetch_1 = __importDefault(require_lib2()), promises_1 = __importDefault(__require("node:fs/promises")), node_path_1 = __importDefault(__require("node:path")), utils_1 = require_utils5(), paths = (0, env_paths_1.default)("theme-liquid-docs");
    exports.root = paths.cache;
    exports.ThemeLiquidDocsRoot = "https://raw.githubusercontent.com/Shopify/theme-liquid-docs/main";
    exports.ThemeLiquidDocsSchemaRoot = `${exports.ThemeLiquidDocsRoot}/schemas`;
    exports.Resources = [
      "filters",
      "objects",
      "tags",
      "shopify_system_translations",
      "manifest_theme",
      "manifest_theme_app_extension"
    ];
    exports.Manifests = {
      app: "manifest_theme_app_extension",
      theme: "manifest_theme"
    };
    var THEME_LIQUID_DOCS = {
      filters: "data/filters.json",
      objects: "data/objects.json",
      tags: "data/tags.json",
      latest: "data/latest.json",
      shopify_system_translations: "data/shopify_system_translations.json",
      manifest_theme: "schemas/manifest_theme.json",
      manifest_theme_app_extension: "schemas/manifest_theme_app_extension.json"
    };
    async function downloadSchema(relativeUri2, destination = exports.root, log = utils_1.noop) {
      let remotePath = schemaUrl(relativeUri2), localPath = schemaPath(relativeUri2, destination), text = await download(remotePath, log);
      return await promises_1.default.writeFile(localPath, text, "utf8"), text;
    }
    exports.downloadSchema = downloadSchema;
    async function downloadResource(resource, destination = exports.root, log = utils_1.noop) {
      let remotePath = resourceUrl(resource), localPath = resourcePath(resource, destination), text = await download(remotePath, log);
      return await promises_1.default.writeFile(localPath, text, "utf8"), text;
    }
    exports.downloadResource = downloadResource;
    async function download(path3, log) {
      return path3.startsWith("file:") ? await promises_1.default.readFile(path3.replace(/^file:/, ""), "utf8").then((0, utils_1.tap)(() => log(`Using local file: ${path3}`))).catch((error) => {
        throw log(`Failed to read local file: ${path3}`), error;
      }) : (await (0, node_fetch_1.default)(path3)).text();
    }
    exports.download = download;
    function resourcePath(resource, destination = exports.root) {
      return node_path_1.default.join(destination, `${resource}.json`);
    }
    exports.resourcePath = resourcePath;
    function resourceUrl(resource) {
      let relativePath2 = THEME_LIQUID_DOCS[resource];
      return `${process.env.SHOPIFY_TLD_ROOT ? `file:${process.env.SHOPIFY_TLD_ROOT}` : exports.ThemeLiquidDocsRoot}/${relativePath2}`;
    }
    exports.resourceUrl = resourceUrl;
    function schemaPath(relativeUri2, destination = exports.root) {
      return node_path_1.default.resolve(destination, node_path_1.default.basename(relativeUri2));
    }
    exports.schemaPath = schemaPath;
    function schemaUrl(relativeUri2) {
      return `${process.env.SHOPIFY_TLD_ROOT ? `file:${process.env.SHOPIFY_TLD_ROOT}` : exports.ThemeLiquidDocsRoot}/schemas/${relativeUri2}`;
    }
    exports.schemaUrl = schemaUrl;
    async function exists(path3) {
      try {
        return await promises_1.default.stat(path3), !0;
      } catch {
        return !1;
      }
    }
    exports.exists = exists;
    async function downloadThemeLiquidDocs(destination, log) {
      await exists(destination) || await promises_1.default.mkdir(destination);
      let resources = ["latest"].concat(exports.Resources), resourceContents = await Promise.all(resources.map((file) => downloadResource(file, destination, log).then((0, utils_1.tap)(() => log(`Successfully downloaded latest resource:
	${resourceUrl(file)}
	> ${resourcePath(file, destination)}`))).catch((error) => {
        throw log(`Failed to download latest resource:
	${resourceUrl(file)} to
	${resourcePath(file, destination)}
${error}`), error;
      }))), relativeUris = Object.values(exports.Manifests).map((resource) => resources.indexOf(resource)).map((index) => resourceContents[index]).map((manifest) => JSON.parse(manifest)).flatMap((manifest) => manifest.schemas.map((schema) => schema.uri));
      await Promise.all(unique(relativeUris).map((uri) => downloadSchema(uri, destination, log).then((0, utils_1.tap)(() => log(`Successfully downloaded schema:
	${schemaUrl(uri)}
	> ${schemaPath(uri, destination)}`))).catch((error) => {
        throw log(`Failed to download schema: ${uri}, ${error}`), error;
      })));
    }
    exports.downloadThemeLiquidDocs = downloadThemeLiquidDocs;
    function unique(array) {
      return [...new Set(array).values()];
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-docs-updater@2.8.0/node_modules/@shopify/theme-check-docs-updater/dist/themeLiquidDocsManager.js
var require_themeLiquidDocsManager = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-docs-updater@2.8.0/node_modules/@shopify/theme-check-docs-updater/dist/themeLiquidDocsManager.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ThemeLiquidDocsManager = void 0;
    var promises_1 = __importDefault(__require("node:fs/promises")), node_path_1 = __importDefault(__require("node:path")), themeLiquidDocsDownloader_1 = require_themeLiquidDocsDownloader(), utils_1 = require_utils5(), ThemeLiquidDocsManager = class {
      constructor(log = utils_1.noop) {
        this.log = log, this.filters = (0, utils_1.memo)(async () => findSuitableResource(this.loaders("filters"), JSON.parse, [], this.log)), this.objects = (0, utils_1.memo)(async () => findSuitableResource(this.loaders("objects"), JSON.parse, [], this.log)), this.tags = (0, utils_1.memo)(async () => findSuitableResource(this.loaders("tags"), JSON.parse, [], this.log)), this.systemTranslations = (0, utils_1.memo)(async () => findSuitableResource(this.loaders("shopify_system_translations"), JSON.parse, {}, this.log)), this.schemas = (0, utils_1.memoize)((mode) => findSuitableResource(this.loaders(themeLiquidDocsDownloader_1.Manifests[mode]), JSON.parse, {
          schemas: []
        }, this.log).then((manifest) => Promise.all(manifest.schemas.map(async (schemaDefinition) => ({
          uri: `${themeLiquidDocsDownloader_1.ThemeLiquidDocsSchemaRoot}/${schemaDefinition.uri}`,
          fileMatch: schemaDefinition.fileMatch,
          schema: await findSuitableResource(this.schemaLoaders(schemaDefinition.uri), utils_1.identity, "", this.log)
        })))), utils_1.identity), this.setup = (0, utils_1.memo)(async () => {
          try {
            await (0, themeLiquidDocsDownloader_1.exists)(themeLiquidDocsDownloader_1.root) || await promises_1.default.mkdir(themeLiquidDocsDownloader_1.root, { recursive: !0 });
            let local = await this.latestRevision();
            await (0, themeLiquidDocsDownloader_1.downloadResource)("latest", themeLiquidDocsDownloader_1.root, this.log);
            let remote = await this.latestRevision();
            local !== remote && await (0, themeLiquidDocsDownloader_1.downloadThemeLiquidDocs)(themeLiquidDocsDownloader_1.root, this.log);
          } catch (error) {
            error instanceof Error && this.log(`Failed to setup with the following error: ${error.message}`);
            return;
          }
        });
      }
      async latestRevision() {
        var _a38;
        return (_a38 = (await findSuitableResource([loader(() => this.load("latest"), "loadLatestRevision")], JSON.parse, {}, this.log)).revision) !== null && _a38 !== void 0 ? _a38 : "";
      }
      async loadResource(name) {
        return await this.setup(), this.load(name).then((0, utils_1.tap)(() => this.log(`Loaded resource from ${(0, themeLiquidDocsDownloader_1.resourcePath)(name)}`)));
      }
      async load(name) {
        return promises_1.default.readFile((0, themeLiquidDocsDownloader_1.resourcePath)(name), "utf8");
      }
      async loadSchema(relativeUri2) {
        return promises_1.default.readFile((0, themeLiquidDocsDownloader_1.schemaPath)(relativeUri2), "utf8").then((0, utils_1.tap)(() => this.log(`Loaded schema from ${(0, themeLiquidDocsDownloader_1.schemaPath)(relativeUri2)}`)));
      }
      loaders(name) {
        return [
          loader(() => this.loadResource(name), `loadResource(${name})`),
          loader(() => fallbackResource(name, this.log), `fallbackResource(${name})`)
        ];
      }
      schemaLoaders(relativeUri2) {
        return [
          loader(() => this.loadSchema(relativeUri2), `loadSchema(${relativeUri2})`),
          loader(() => fallbackSchema(relativeUri2, this.log), `fallbackSchema(${relativeUri2})`)
        ];
      }
    };
    exports.ThemeLiquidDocsManager = ThemeLiquidDocsManager;
    function loader(fn, loaderName) {
      return Object.assign(fn, { loaderName });
    }
    async function findSuitableResource(dataLoaders, transform2, defaultValue, log) {
      for (let loader2 of dataLoaders)
        try {
          return transform2(await loader2());
        } catch (e) {
          log(`Failed to load or transform ${loader2.loaderName} with the following error:
${e instanceof Error ? e.message : e}`);
          continue;
        }
      return defaultValue;
    }
    function dataRoot() {
      return node_path_1.default.resolve(__dirname, "./data");
    }
    async function fallbackResource(name, log) {
      let sourcePath = node_path_1.default.resolve(dataRoot(), `${name}.json`);
      return promises_1.default.readFile(sourcePath, "utf8").then((0, utils_1.tap)(() => log(`Loaded fallback resource
	${name} from
	${sourcePath}`)));
    }
    async function fallbackSchema(relativeUri2, log) {
      let sourcePath = node_path_1.default.resolve(dataRoot(), node_path_1.default.basename(relativeUri2));
      return promises_1.default.readFile(sourcePath, "utf8").then((0, utils_1.tap)(() => log(`Loaded fallback schema
	${relativeUri2} from
	${sourcePath}`)));
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-docs-updater@2.8.0/node_modules/@shopify/theme-check-docs-updater/dist/index.js
var require_dist3 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-docs-updater@2.8.0/node_modules/@shopify/theme-check-docs-updater/dist/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.root = exports.downloadThemeLiquidDocs = exports.downloadResource = exports.Resources = exports.ThemeLiquidDocsManager = void 0;
    var themeLiquidDocsManager_1 = require_themeLiquidDocsManager();
    Object.defineProperty(exports, "ThemeLiquidDocsManager", { enumerable: !0, get: function() {
      return themeLiquidDocsManager_1.ThemeLiquidDocsManager;
    } });
    var themeLiquidDocsDownloader_1 = require_themeLiquidDocsDownloader();
    Object.defineProperty(exports, "Resources", { enumerable: !0, get: function() {
      return themeLiquidDocsDownloader_1.Resources;
    } });
    Object.defineProperty(exports, "downloadResource", { enumerable: !0, get: function() {
      return themeLiquidDocsDownloader_1.downloadResource;
    } });
    Object.defineProperty(exports, "downloadThemeLiquidDocs", { enumerable: !0, get: function() {
      return themeLiquidDocsDownloader_1.downloadThemeLiquidDocs;
    } });
    Object.defineProperty(exports, "root", { enumerable: !0, get: function() {
      return themeLiquidDocsDownloader_1.root;
    } });
  }
});

// ../../node_modules/.pnpm/minimatch@5.1.6/node_modules/minimatch/lib/path.js
var require_path2 = __commonJS({
  "../../node_modules/.pnpm/minimatch@5.1.6/node_modules/minimatch/lib/path.js"(exports, module) {
    init_cjs_shims();
    var isWindows = typeof process == "object" && process && process.platform === "win32";
    module.exports = isWindows ? { sep: "\\" } : { sep: "/" };
  }
});

// ../../node_modules/.pnpm/minimatch@5.1.6/node_modules/minimatch/minimatch.js
var require_minimatch = __commonJS({
  "../../node_modules/.pnpm/minimatch@5.1.6/node_modules/minimatch/minimatch.js"(exports, module) {
    init_cjs_shims();
    var minimatch = module.exports = (p, pattern, options = {}) => (assertValidPattern(pattern), !options.nocomment && pattern.charAt(0) === "#" ? !1 : new Minimatch(pattern, options).match(p));
    module.exports = minimatch;
    var path3 = require_path2();
    minimatch.sep = path3.sep;
    var GLOBSTAR = Symbol("globstar **");
    minimatch.GLOBSTAR = GLOBSTAR;
    var expand = require_brace_expansion(), plTypes = {
      "!": { open: "(?:(?!(?:", close: "))[^/]*?)" },
      "?": { open: "(?:", close: ")?" },
      "+": { open: "(?:", close: ")+" },
      "*": { open: "(?:", close: ")*" },
      "@": { open: "(?:", close: ")" }
    }, qmark = "[^/]", star = qmark + "*?", twoStarDot = "(?:(?!(?:\\/|^)(?:\\.{1,2})($|\\/)).)*?", twoStarNoDot = "(?:(?!(?:\\/|^)\\.).)*?", charSet = (s) => s.split("").reduce((set2, c) => (set2[c] = !0, set2), {}), reSpecials = charSet("().*{}+?[]^$\\!"), addPatternStartSet = charSet("[.("), slashSplit = /\/+/;
    minimatch.filter = (pattern, options = {}) => (p, i, list2) => minimatch(p, pattern, options);
    var ext = (a, b = {}) => {
      let t7 = {};
      return Object.keys(a).forEach((k) => t7[k] = a[k]), Object.keys(b).forEach((k) => t7[k] = b[k]), t7;
    };
    minimatch.defaults = (def) => {
      if (!def || typeof def != "object" || !Object.keys(def).length)
        return minimatch;
      let orig = minimatch, m = (p, pattern, options) => orig(p, pattern, ext(def, options));
      return m.Minimatch = class extends orig.Minimatch {
        constructor(pattern, options) {
          super(pattern, ext(def, options));
        }
      }, m.Minimatch.defaults = (options) => orig.defaults(ext(def, options)).Minimatch, m.filter = (pattern, options) => orig.filter(pattern, ext(def, options)), m.defaults = (options) => orig.defaults(ext(def, options)), m.makeRe = (pattern, options) => orig.makeRe(pattern, ext(def, options)), m.braceExpand = (pattern, options) => orig.braceExpand(pattern, ext(def, options)), m.match = (list2, pattern, options) => orig.match(list2, pattern, ext(def, options)), m;
    };
    minimatch.braceExpand = (pattern, options) => braceExpand(pattern, options);
    var braceExpand = (pattern, options = {}) => (assertValidPattern(pattern), options.nobrace || !/\{(?:(?!\{).)*\}/.test(pattern) ? [pattern] : expand(pattern)), MAX_PATTERN_LENGTH = 1024 * 64, assertValidPattern = (pattern) => {
      if (typeof pattern != "string")
        throw new TypeError("invalid pattern");
      if (pattern.length > MAX_PATTERN_LENGTH)
        throw new TypeError("pattern is too long");
    }, SUBPARSE = Symbol("subparse");
    minimatch.makeRe = (pattern, options) => new Minimatch(pattern, options || {}).makeRe();
    minimatch.match = (list2, pattern, options = {}) => {
      let mm = new Minimatch(pattern, options);
      return list2 = list2.filter((f) => mm.match(f)), mm.options.nonull && !list2.length && list2.push(pattern), list2;
    };
    var globUnescape = (s) => s.replace(/\\(.)/g, "$1"), charUnescape = (s) => s.replace(/\\([^-\]])/g, "$1"), regExpEscape = (s) => s.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&"), braExpEscape = (s) => s.replace(/[[\]\\]/g, "\\$&"), Minimatch = class {
      constructor(pattern, options) {
        assertValidPattern(pattern), options || (options = {}), this.options = options, this.set = [], this.pattern = pattern, this.windowsPathsNoEscape = !!options.windowsPathsNoEscape || options.allowWindowsEscape === !1, this.windowsPathsNoEscape && (this.pattern = this.pattern.replace(/\\/g, "/")), this.regexp = null, this.negate = !1, this.comment = !1, this.empty = !1, this.partial = !!options.partial, this.make();
      }
      debug() {
      }
      make() {
        let pattern = this.pattern, options = this.options;
        if (!options.nocomment && pattern.charAt(0) === "#") {
          this.comment = !0;
          return;
        }
        if (!pattern) {
          this.empty = !0;
          return;
        }
        this.parseNegate();
        let set2 = this.globSet = this.braceExpand();
        options.debug && (this.debug = (...args) => console.error(...args)), this.debug(this.pattern, set2), set2 = this.globParts = set2.map((s) => s.split(slashSplit)), this.debug(this.pattern, set2), set2 = set2.map((s, si, set3) => s.map(this.parse, this)), this.debug(this.pattern, set2), set2 = set2.filter((s) => s.indexOf(!1) === -1), this.debug(this.pattern, set2), this.set = set2;
      }
      parseNegate() {
        if (this.options.nonegate)
          return;
        let pattern = this.pattern, negate = !1, negateOffset = 0;
        for (let i = 0; i < pattern.length && pattern.charAt(i) === "!"; i++)
          negate = !negate, negateOffset++;
        negateOffset && (this.pattern = pattern.slice(negateOffset)), this.negate = negate;
      }
      // set partial to true to test if, for example,
      // "/a/b" matches the start of "/*/b/*/d"
      // Partial means, if you run out of file before you run
      // out of pattern, then that's fine, as long as all
      // the parts match.
      matchOne(file, pattern, partial) {
        var options = this.options;
        this.debug(
          "matchOne",
          { this: this, file, pattern }
        ), this.debug("matchOne", file.length, pattern.length);
        for (var fi = 0, pi = 0, fl = file.length, pl = pattern.length; fi < fl && pi < pl; fi++, pi++) {
          this.debug("matchOne loop");
          var p = pattern[pi], f = file[fi];
          if (this.debug(pattern, p, f), p === !1)
            return !1;
          if (p === GLOBSTAR) {
            this.debug("GLOBSTAR", [pattern, p, f]);
            var fr = fi, pr = pi + 1;
            if (pr === pl) {
              for (this.debug("** at the end"); fi < fl; fi++)
                if (file[fi] === "." || file[fi] === ".." || !options.dot && file[fi].charAt(0) === ".")
                  return !1;
              return !0;
            }
            for (; fr < fl; ) {
              var swallowee = file[fr];
              if (this.debug(`
globstar while`, file, fr, pattern, pr, swallowee), this.matchOne(file.slice(fr), pattern.slice(pr), partial))
                return this.debug("globstar found match!", fr, fl, swallowee), !0;
              if (swallowee === "." || swallowee === ".." || !options.dot && swallowee.charAt(0) === ".") {
                this.debug("dot detected!", file, fr, pattern, pr);
                break;
              }
              this.debug("globstar swallow a segment, and continue"), fr++;
            }
            return !!(partial && (this.debug(`
>>> no match, partial?`, file, fr, pattern, pr), fr === fl));
          }
          var hit;
          if (typeof p == "string" ? (hit = f === p, this.debug("string match", p, f, hit)) : (hit = f.match(p), this.debug("pattern match", p, f, hit)), !hit)
            return !1;
        }
        if (fi === fl && pi === pl)
          return !0;
        if (fi === fl)
          return partial;
        if (pi === pl)
          return fi === fl - 1 && file[fi] === "";
        throw new Error("wtf?");
      }
      braceExpand() {
        return braceExpand(this.pattern, this.options);
      }
      parse(pattern, isSub) {
        assertValidPattern(pattern);
        let options = this.options;
        if (pattern === "**")
          if (options.noglobstar)
            pattern = "*";
          else
            return GLOBSTAR;
        if (pattern === "")
          return "";
        let re = "", hasMagic = !1, escaping = !1, patternListStack = [], negativeLists = [], stateChar, inClass = !1, reClassStart = -1, classStart = -1, cs, pl, sp, dotTravAllowed = pattern.charAt(0) === ".", dotFileAllowed = options.dot || dotTravAllowed, patternStart = () => dotTravAllowed ? "" : dotFileAllowed ? "(?!(?:^|\\/)\\.{1,2}(?:$|\\/))" : "(?!\\.)", subPatternStart = (p) => p.charAt(0) === "." ? "" : options.dot ? "(?!(?:^|\\/)\\.{1,2}(?:$|\\/))" : "(?!\\.)", clearStateChar = () => {
          if (stateChar) {
            switch (stateChar) {
              case "*":
                re += star, hasMagic = !0;
                break;
              case "?":
                re += qmark, hasMagic = !0;
                break;
              default:
                re += "\\" + stateChar;
                break;
            }
            this.debug("clearStateChar %j %j", stateChar, re), stateChar = !1;
          }
        };
        for (let i = 0, c; i < pattern.length && (c = pattern.charAt(i)); i++) {
          if (this.debug("%s	%s %s %j", pattern, i, re, c), escaping) {
            if (c === "/")
              return !1;
            reSpecials[c] && (re += "\\"), re += c, escaping = !1;
            continue;
          }
          switch (c) {
            case "/":
              return !1;
            case "\\":
              if (inClass && pattern.charAt(i + 1) === "-") {
                re += c;
                continue;
              }
              clearStateChar(), escaping = !0;
              continue;
            case "?":
            case "*":
            case "+":
            case "@":
            case "!":
              if (this.debug("%s	%s %s %j <-- stateChar", pattern, i, re, c), inClass) {
                this.debug("  in class"), c === "!" && i === classStart + 1 && (c = "^"), re += c;
                continue;
              }
              this.debug("call clearStateChar %j", stateChar), clearStateChar(), stateChar = c, options.noext && clearStateChar();
              continue;
            case "(": {
              if (inClass) {
                re += "(";
                continue;
              }
              if (!stateChar) {
                re += "\\(";
                continue;
              }
              let plEntry = {
                type: stateChar,
                start: i - 1,
                reStart: re.length,
                open: plTypes[stateChar].open,
                close: plTypes[stateChar].close
              };
              this.debug(this.pattern, "	", plEntry), patternListStack.push(plEntry), re += plEntry.open, plEntry.start === 0 && plEntry.type !== "!" && (dotTravAllowed = !0, re += subPatternStart(pattern.slice(i + 1))), this.debug("plType %j %j", stateChar, re), stateChar = !1;
              continue;
            }
            case ")": {
              let plEntry = patternListStack[patternListStack.length - 1];
              if (inClass || !plEntry) {
                re += "\\)";
                continue;
              }
              patternListStack.pop(), clearStateChar(), hasMagic = !0, pl = plEntry, re += pl.close, pl.type === "!" && negativeLists.push(Object.assign(pl, { reEnd: re.length }));
              continue;
            }
            case "|": {
              let plEntry = patternListStack[patternListStack.length - 1];
              if (inClass || !plEntry) {
                re += "\\|";
                continue;
              }
              clearStateChar(), re += "|", plEntry.start === 0 && plEntry.type !== "!" && (dotTravAllowed = !0, re += subPatternStart(pattern.slice(i + 1)));
              continue;
            }
            case "[":
              if (clearStateChar(), inClass) {
                re += "\\" + c;
                continue;
              }
              inClass = !0, classStart = i, reClassStart = re.length, re += c;
              continue;
            case "]":
              if (i === classStart + 1 || !inClass) {
                re += "\\" + c;
                continue;
              }
              cs = pattern.substring(classStart + 1, i);
              try {
                RegExp("[" + braExpEscape(charUnescape(cs)) + "]"), re += c;
              } catch {
                re = re.substring(0, reClassStart) + "(?:$.)";
              }
              hasMagic = !0, inClass = !1;
              continue;
            default:
              clearStateChar(), reSpecials[c] && !(c === "^" && inClass) && (re += "\\"), re += c;
              break;
          }
        }
        for (inClass && (cs = pattern.slice(classStart + 1), sp = this.parse(cs, SUBPARSE), re = re.substring(0, reClassStart) + "\\[" + sp[0], hasMagic = hasMagic || sp[1]), pl = patternListStack.pop(); pl; pl = patternListStack.pop()) {
          let tail;
          tail = re.slice(pl.reStart + pl.open.length), this.debug("setting tail", re, pl), tail = tail.replace(/((?:\\{2}){0,64})(\\?)\|/g, (_2, $1, $2) => ($2 || ($2 = "\\"), $1 + $1 + $2 + "|")), this.debug(`tail=%j
   %s`, tail, tail, pl, re);
          let t7 = pl.type === "*" ? star : pl.type === "?" ? qmark : "\\" + pl.type;
          hasMagic = !0, re = re.slice(0, pl.reStart) + t7 + "\\(" + tail;
        }
        clearStateChar(), escaping && (re += "\\\\");
        let addPatternStart = addPatternStartSet[re.charAt(0)];
        for (let n = negativeLists.length - 1; n > -1; n--) {
          let nl = negativeLists[n], nlBefore = re.slice(0, nl.reStart), nlFirst = re.slice(nl.reStart, nl.reEnd - 8), nlAfter = re.slice(nl.reEnd), nlLast = re.slice(nl.reEnd - 8, nl.reEnd) + nlAfter, closeParensBefore = nlBefore.split(")").length, openParensBefore = nlBefore.split("(").length - closeParensBefore, cleanAfter = nlAfter;
          for (let i = 0; i < openParensBefore; i++)
            cleanAfter = cleanAfter.replace(/\)[+*?]?/, "");
          nlAfter = cleanAfter;
          let dollar = nlAfter === "" && isSub !== SUBPARSE ? "(?:$|\\/)" : "";
          re = nlBefore + nlFirst + nlAfter + dollar + nlLast;
        }
        if (re !== "" && hasMagic && (re = "(?=.)" + re), addPatternStart && (re = patternStart() + re), isSub === SUBPARSE)
          return [re, hasMagic];
        if (options.nocase && !hasMagic && (hasMagic = pattern.toUpperCase() !== pattern.toLowerCase()), !hasMagic)
          return globUnescape(pattern);
        let flags = options.nocase ? "i" : "";
        try {
          return Object.assign(new RegExp("^" + re + "$", flags), {
            _glob: pattern,
            _src: re
          });
        } catch {
          return new RegExp("$.");
        }
      }
      makeRe() {
        if (this.regexp || this.regexp === !1)
          return this.regexp;
        let set2 = this.set;
        if (!set2.length)
          return this.regexp = !1, this.regexp;
        let options = this.options, twoStar = options.noglobstar ? star : options.dot ? twoStarDot : twoStarNoDot, flags = options.nocase ? "i" : "", re = set2.map((pattern) => (pattern = pattern.map(
          (p) => typeof p == "string" ? regExpEscape(p) : p === GLOBSTAR ? GLOBSTAR : p._src
        ).reduce((set3, p) => (set3[set3.length - 1] === GLOBSTAR && p === GLOBSTAR || set3.push(p), set3), []), pattern.forEach((p, i) => {
          p !== GLOBSTAR || pattern[i - 1] === GLOBSTAR || (i === 0 ? pattern.length > 1 ? pattern[i + 1] = "(?:\\/|" + twoStar + "\\/)?" + pattern[i + 1] : pattern[i] = twoStar : i === pattern.length - 1 ? pattern[i - 1] += "(?:\\/|" + twoStar + ")?" : (pattern[i - 1] += "(?:\\/|\\/" + twoStar + "\\/)" + pattern[i + 1], pattern[i + 1] = GLOBSTAR));
        }), pattern.filter((p) => p !== GLOBSTAR).join("/"))).join("|");
        re = "^(?:" + re + ")$", this.negate && (re = "^(?!" + re + ").*$");
        try {
          this.regexp = new RegExp(re, flags);
        } catch {
          this.regexp = !1;
        }
        return this.regexp;
      }
      match(f, partial = this.partial) {
        if (this.debug("match", f, this.pattern), this.comment)
          return !1;
        if (this.empty)
          return f === "";
        if (f === "/" && partial)
          return !0;
        let options = this.options;
        path3.sep !== "/" && (f = f.split(path3.sep).join("/")), f = f.split(slashSplit), this.debug(this.pattern, "split", f);
        let set2 = this.set;
        this.debug(this.pattern, "set", set2);
        let filename;
        for (let i = f.length - 1; i >= 0 && (filename = f[i], !filename); i--)
          ;
        for (let i = 0; i < set2.length; i++) {
          let pattern = set2[i], file = f;
          if (options.matchBase && pattern.length === 1 && (file = [filename]), this.matchOne(file, pattern, partial))
            return options.flipNegate ? !0 : !this.negate;
        }
        return options.flipNegate ? !1 : this.negate;
      }
      static defaults(def) {
        return minimatch.defaults(def).Minimatch;
      }
    };
    minimatch.Minimatch = Minimatch;
  }
});

// ../../node_modules/.pnpm/glob@8.1.0/node_modules/glob/common.js
var require_common2 = __commonJS({
  "../../node_modules/.pnpm/glob@8.1.0/node_modules/glob/common.js"(exports) {
    init_cjs_shims();
    exports.setopts = setopts;
    exports.ownProp = ownProp;
    exports.makeAbs = makeAbs;
    exports.finish = finish;
    exports.mark = mark;
    exports.isIgnored = isIgnored;
    exports.childrenIgnored = childrenIgnored;
    function ownProp(obj, field) {
      return Object.prototype.hasOwnProperty.call(obj, field);
    }
    var fs6 = __require("fs"), path3 = __require("path"), minimatch = require_minimatch(), isAbsolute = __require("path").isAbsolute, Minimatch = minimatch.Minimatch;
    function alphasort(a, b) {
      return a.localeCompare(b, "en");
    }
    function setupIgnores(self2, options) {
      self2.ignore = options.ignore || [], Array.isArray(self2.ignore) || (self2.ignore = [self2.ignore]), self2.ignore.length && (self2.ignore = self2.ignore.map(ignoreMap));
    }
    function ignoreMap(pattern) {
      var gmatcher = null;
      if (pattern.slice(-3) === "/**") {
        var gpattern = pattern.replace(/(\/\*\*)+$/, "");
        gmatcher = new Minimatch(gpattern, { dot: !0 });
      }
      return {
        matcher: new Minimatch(pattern, { dot: !0 }),
        gmatcher
      };
    }
    function setopts(self2, pattern, options) {
      if (options || (options = {}), options.matchBase && pattern.indexOf("/") === -1) {
        if (options.noglobstar)
          throw new Error("base matching requires globstar");
        pattern = "**/" + pattern;
      }
      self2.windowsPathsNoEscape = !!options.windowsPathsNoEscape || options.allowWindowsEscape === !1, self2.windowsPathsNoEscape && (pattern = pattern.replace(/\\/g, "/")), self2.silent = !!options.silent, self2.pattern = pattern, self2.strict = options.strict !== !1, self2.realpath = !!options.realpath, self2.realpathCache = options.realpathCache || /* @__PURE__ */ Object.create(null), self2.follow = !!options.follow, self2.dot = !!options.dot, self2.mark = !!options.mark, self2.nodir = !!options.nodir, self2.nodir && (self2.mark = !0), self2.sync = !!options.sync, self2.nounique = !!options.nounique, self2.nonull = !!options.nonull, self2.nosort = !!options.nosort, self2.nocase = !!options.nocase, self2.stat = !!options.stat, self2.noprocess = !!options.noprocess, self2.absolute = !!options.absolute, self2.fs = options.fs || fs6, self2.maxLength = options.maxLength || 1 / 0, self2.cache = options.cache || /* @__PURE__ */ Object.create(null), self2.statCache = options.statCache || /* @__PURE__ */ Object.create(null), self2.symlinks = options.symlinks || /* @__PURE__ */ Object.create(null), setupIgnores(self2, options), self2.changedCwd = !1;
      var cwd2 = process.cwd();
      ownProp(options, "cwd") ? (self2.cwd = path3.resolve(options.cwd), self2.changedCwd = self2.cwd !== cwd2) : self2.cwd = path3.resolve(cwd2), self2.root = options.root || path3.resolve(self2.cwd, "/"), self2.root = path3.resolve(self2.root), self2.cwdAbs = isAbsolute(self2.cwd) ? self2.cwd : makeAbs(self2, self2.cwd), self2.nomount = !!options.nomount, process.platform === "win32" && (self2.root = self2.root.replace(/\\/g, "/"), self2.cwd = self2.cwd.replace(/\\/g, "/"), self2.cwdAbs = self2.cwdAbs.replace(/\\/g, "/")), options.nonegate = !0, options.nocomment = !0, self2.minimatch = new Minimatch(pattern, options), self2.options = self2.minimatch.options;
    }
    function finish(self2) {
      for (var nou = self2.nounique, all = nou ? [] : /* @__PURE__ */ Object.create(null), i = 0, l = self2.matches.length; i < l; i++) {
        var matches = self2.matches[i];
        if (!matches || Object.keys(matches).length === 0) {
          if (self2.nonull) {
            var literal = self2.minimatch.globSet[i];
            nou ? all.push(literal) : all[literal] = !0;
          }
        } else {
          var m = Object.keys(matches);
          nou ? all.push.apply(all, m) : m.forEach(function(m2) {
            all[m2] = !0;
          });
        }
      }
      if (nou || (all = Object.keys(all)), self2.nosort || (all = all.sort(alphasort)), self2.mark) {
        for (var i = 0; i < all.length; i++)
          all[i] = self2._mark(all[i]);
        self2.nodir && (all = all.filter(function(e) {
          var notDir = !/\/$/.test(e), c = self2.cache[e] || self2.cache[makeAbs(self2, e)];
          return notDir && c && (notDir = c !== "DIR" && !Array.isArray(c)), notDir;
        }));
      }
      self2.ignore.length && (all = all.filter(function(m2) {
        return !isIgnored(self2, m2);
      })), self2.found = all;
    }
    function mark(self2, p) {
      var abs = makeAbs(self2, p), c = self2.cache[abs], m = p;
      if (c) {
        var isDir = c === "DIR" || Array.isArray(c), slash = p.slice(-1) === "/";
        if (isDir && !slash ? m += "/" : !isDir && slash && (m = m.slice(0, -1)), m !== p) {
          var mabs = makeAbs(self2, m);
          self2.statCache[mabs] = self2.statCache[abs], self2.cache[mabs] = self2.cache[abs];
        }
      }
      return m;
    }
    function makeAbs(self2, f) {
      var abs = f;
      return f.charAt(0) === "/" ? abs = path3.join(self2.root, f) : isAbsolute(f) || f === "" ? abs = f : self2.changedCwd ? abs = path3.resolve(self2.cwd, f) : abs = path3.resolve(f), process.platform === "win32" && (abs = abs.replace(/\\/g, "/")), abs;
    }
    function isIgnored(self2, path4) {
      return self2.ignore.length ? self2.ignore.some(function(item) {
        return item.matcher.match(path4) || !!(item.gmatcher && item.gmatcher.match(path4));
      }) : !1;
    }
    function childrenIgnored(self2, path4) {
      return self2.ignore.length ? self2.ignore.some(function(item) {
        return !!(item.gmatcher && item.gmatcher.match(path4));
      }) : !1;
    }
  }
});

// ../../node_modules/.pnpm/glob@8.1.0/node_modules/glob/sync.js
var require_sync = __commonJS({
  "../../node_modules/.pnpm/glob@8.1.0/node_modules/glob/sync.js"(exports, module) {
    init_cjs_shims();
    module.exports = globSync;
    globSync.GlobSync = GlobSync;
    var rp = require_fs(), minimatch = require_minimatch(), Minimatch = minimatch.Minimatch, Glob = require_glob2().Glob, util2 = __require("util"), path3 = __require("path"), assert = __require("assert"), isAbsolute = __require("path").isAbsolute, common = require_common2(), setopts = common.setopts, ownProp = common.ownProp, childrenIgnored = common.childrenIgnored, isIgnored = common.isIgnored;
    function globSync(pattern, options) {
      if (typeof options == "function" || arguments.length === 3)
        throw new TypeError(`callback provided to sync glob
See: https://github.com/isaacs/node-glob/issues/167`);
      return new GlobSync(pattern, options).found;
    }
    function GlobSync(pattern, options) {
      if (!pattern)
        throw new Error("must provide pattern");
      if (typeof options == "function" || arguments.length === 3)
        throw new TypeError(`callback provided to sync glob
See: https://github.com/isaacs/node-glob/issues/167`);
      if (!(this instanceof GlobSync))
        return new GlobSync(pattern, options);
      if (setopts(this, pattern, options), this.noprocess)
        return this;
      var n = this.minimatch.set.length;
      this.matches = new Array(n);
      for (var i = 0; i < n; i++)
        this._process(this.minimatch.set[i], i, !1);
      this._finish();
    }
    GlobSync.prototype._finish = function() {
      if (assert.ok(this instanceof GlobSync), this.realpath) {
        var self2 = this;
        this.matches.forEach(function(matchset, index) {
          var set2 = self2.matches[index] = /* @__PURE__ */ Object.create(null);
          for (var p in matchset)
            try {
              p = self2._makeAbs(p);
              var real = rp.realpathSync(p, self2.realpathCache);
              set2[real] = !0;
            } catch (er) {
              if (er.syscall === "stat")
                set2[self2._makeAbs(p)] = !0;
              else
                throw er;
            }
        });
      }
      common.finish(this);
    };
    GlobSync.prototype._process = function(pattern, index, inGlobStar) {
      assert.ok(this instanceof GlobSync);
      for (var n = 0; typeof pattern[n] == "string"; )
        n++;
      var prefix;
      switch (n) {
        case pattern.length:
          this._processSimple(pattern.join("/"), index);
          return;
        case 0:
          prefix = null;
          break;
        default:
          prefix = pattern.slice(0, n).join("/");
          break;
      }
      var remain = pattern.slice(n), read;
      prefix === null ? read = "." : ((isAbsolute(prefix) || isAbsolute(pattern.map(function(p) {
        return typeof p == "string" ? p : "[*]";
      }).join("/"))) && (!prefix || !isAbsolute(prefix)) && (prefix = "/" + prefix), read = prefix);
      var abs = this._makeAbs(read);
      if (!childrenIgnored(this, read)) {
        var isGlobStar = remain[0] === minimatch.GLOBSTAR;
        isGlobStar ? this._processGlobStar(prefix, read, abs, remain, index, inGlobStar) : this._processReaddir(prefix, read, abs, remain, index, inGlobStar);
      }
    };
    GlobSync.prototype._processReaddir = function(prefix, read, abs, remain, index, inGlobStar) {
      var entries = this._readdir(abs, inGlobStar);
      if (entries) {
        for (var pn = remain[0], negate = !!this.minimatch.negate, rawGlob = pn._glob, dotOk = this.dot || rawGlob.charAt(0) === ".", matchedEntries = [], i = 0; i < entries.length; i++) {
          var e = entries[i];
          if (e.charAt(0) !== "." || dotOk) {
            var m;
            negate && !prefix ? m = !e.match(pn) : m = e.match(pn), m && matchedEntries.push(e);
          }
        }
        var len = matchedEntries.length;
        if (len !== 0) {
          if (remain.length === 1 && !this.mark && !this.stat) {
            this.matches[index] || (this.matches[index] = /* @__PURE__ */ Object.create(null));
            for (var i = 0; i < len; i++) {
              var e = matchedEntries[i];
              prefix && (prefix.slice(-1) !== "/" ? e = prefix + "/" + e : e = prefix + e), e.charAt(0) === "/" && !this.nomount && (e = path3.join(this.root, e)), this._emitMatch(index, e);
            }
            return;
          }
          remain.shift();
          for (var i = 0; i < len; i++) {
            var e = matchedEntries[i], newPattern;
            prefix ? newPattern = [prefix, e] : newPattern = [e], this._process(newPattern.concat(remain), index, inGlobStar);
          }
        }
      }
    };
    GlobSync.prototype._emitMatch = function(index, e) {
      if (!isIgnored(this, e)) {
        var abs = this._makeAbs(e);
        if (this.mark && (e = this._mark(e)), this.absolute && (e = abs), !this.matches[index][e]) {
          if (this.nodir) {
            var c = this.cache[abs];
            if (c === "DIR" || Array.isArray(c))
              return;
          }
          this.matches[index][e] = !0, this.stat && this._stat(e);
        }
      }
    };
    GlobSync.prototype._readdirInGlobStar = function(abs) {
      if (this.follow)
        return this._readdir(abs, !1);
      var entries, lstat, stat;
      try {
        lstat = this.fs.lstatSync(abs);
      } catch (er) {
        if (er.code === "ENOENT")
          return null;
      }
      var isSym = lstat && lstat.isSymbolicLink();
      return this.symlinks[abs] = isSym, !isSym && lstat && !lstat.isDirectory() ? this.cache[abs] = "FILE" : entries = this._readdir(abs, !1), entries;
    };
    GlobSync.prototype._readdir = function(abs, inGlobStar) {
      var entries;
      if (inGlobStar && !ownProp(this.symlinks, abs))
        return this._readdirInGlobStar(abs);
      if (ownProp(this.cache, abs)) {
        var c = this.cache[abs];
        if (!c || c === "FILE")
          return null;
        if (Array.isArray(c))
          return c;
      }
      try {
        return this._readdirEntries(abs, this.fs.readdirSync(abs));
      } catch (er) {
        return this._readdirError(abs, er), null;
      }
    };
    GlobSync.prototype._readdirEntries = function(abs, entries) {
      if (!this.mark && !this.stat)
        for (var i = 0; i < entries.length; i++) {
          var e = entries[i];
          abs === "/" ? e = abs + e : e = abs + "/" + e, this.cache[e] = !0;
        }
      return this.cache[abs] = entries, entries;
    };
    GlobSync.prototype._readdirError = function(f, er) {
      switch (er.code) {
        case "ENOTSUP":
        case "ENOTDIR":
          var abs = this._makeAbs(f);
          if (this.cache[abs] = "FILE", abs === this.cwdAbs) {
            var error = new Error(er.code + " invalid cwd " + this.cwd);
            throw error.path = this.cwd, error.code = er.code, error;
          }
          break;
        case "ENOENT":
        case "ELOOP":
        case "ENAMETOOLONG":
        case "UNKNOWN":
          this.cache[this._makeAbs(f)] = !1;
          break;
        default:
          if (this.cache[this._makeAbs(f)] = !1, this.strict)
            throw er;
          this.silent || console.error("glob error", er);
          break;
      }
    };
    GlobSync.prototype._processGlobStar = function(prefix, read, abs, remain, index, inGlobStar) {
      var entries = this._readdir(abs, inGlobStar);
      if (entries) {
        var remainWithoutGlobStar = remain.slice(1), gspref = prefix ? [prefix] : [], noGlobStar = gspref.concat(remainWithoutGlobStar);
        this._process(noGlobStar, index, !1);
        var len = entries.length, isSym = this.symlinks[abs];
        if (!(isSym && inGlobStar))
          for (var i = 0; i < len; i++) {
            var e = entries[i];
            if (!(e.charAt(0) === "." && !this.dot)) {
              var instead = gspref.concat(entries[i], remainWithoutGlobStar);
              this._process(instead, index, !0);
              var below = gspref.concat(entries[i], remain);
              this._process(below, index, !0);
            }
          }
      }
    };
    GlobSync.prototype._processSimple = function(prefix, index) {
      var exists = this._stat(prefix);
      if (this.matches[index] || (this.matches[index] = /* @__PURE__ */ Object.create(null)), !!exists) {
        if (prefix && isAbsolute(prefix) && !this.nomount) {
          var trail = /[\/\\]$/.test(prefix);
          prefix.charAt(0) === "/" ? prefix = path3.join(this.root, prefix) : (prefix = path3.resolve(this.root, prefix), trail && (prefix += "/"));
        }
        process.platform === "win32" && (prefix = prefix.replace(/\\/g, "/")), this._emitMatch(index, prefix);
      }
    };
    GlobSync.prototype._stat = function(f) {
      var abs = this._makeAbs(f), needDir = f.slice(-1) === "/";
      if (f.length > this.maxLength)
        return !1;
      if (!this.stat && ownProp(this.cache, abs)) {
        var c = this.cache[abs];
        if (Array.isArray(c) && (c = "DIR"), !needDir || c === "DIR")
          return c;
        if (needDir && c === "FILE")
          return !1;
      }
      var exists, stat = this.statCache[abs];
      if (!stat) {
        var lstat;
        try {
          lstat = this.fs.lstatSync(abs);
        } catch (er) {
          if (er && (er.code === "ENOENT" || er.code === "ENOTDIR"))
            return this.statCache[abs] = !1, !1;
        }
        if (lstat && lstat.isSymbolicLink())
          try {
            stat = this.fs.statSync(abs);
          } catch {
            stat = lstat;
          }
        else
          stat = lstat;
      }
      this.statCache[abs] = stat;
      var c = !0;
      return stat && (c = stat.isDirectory() ? "DIR" : "FILE"), this.cache[abs] = this.cache[abs] || c, needDir && c === "FILE" ? !1 : c;
    };
    GlobSync.prototype._mark = function(p) {
      return common.mark(this, p);
    };
    GlobSync.prototype._makeAbs = function(f) {
      return common.makeAbs(this, f);
    };
  }
});

// ../../node_modules/.pnpm/glob@8.1.0/node_modules/glob/glob.js
var require_glob2 = __commonJS({
  "../../node_modules/.pnpm/glob@8.1.0/node_modules/glob/glob.js"(exports, module) {
    init_cjs_shims();
    module.exports = glob2;
    var rp = require_fs(), minimatch = require_minimatch(), Minimatch = minimatch.Minimatch, inherits = require_inherits(), EE = __require("events").EventEmitter, path3 = __require("path"), assert = __require("assert"), isAbsolute = __require("path").isAbsolute, globSync = require_sync(), common = require_common2(), setopts = common.setopts, ownProp = common.ownProp, inflight = require_inflight(), util2 = __require("util"), childrenIgnored = common.childrenIgnored, isIgnored = common.isIgnored, once = require_once();
    function glob2(pattern, options, cb) {
      if (typeof options == "function" && (cb = options, options = {}), options || (options = {}), options.sync) {
        if (cb)
          throw new TypeError("callback provided to sync glob");
        return globSync(pattern, options);
      }
      return new Glob(pattern, options, cb);
    }
    glob2.sync = globSync;
    var GlobSync = glob2.GlobSync = globSync.GlobSync;
    glob2.glob = glob2;
    function extend(origin, add) {
      if (add === null || typeof add != "object")
        return origin;
      for (var keys = Object.keys(add), i = keys.length; i--; )
        origin[keys[i]] = add[keys[i]];
      return origin;
    }
    glob2.hasMagic = function(pattern, options_) {
      var options = extend({}, options_);
      options.noprocess = !0;
      var g = new Glob(pattern, options), set2 = g.minimatch.set;
      if (!pattern)
        return !1;
      if (set2.length > 1)
        return !0;
      for (var j = 0; j < set2[0].length; j++)
        if (typeof set2[0][j] != "string")
          return !0;
      return !1;
    };
    glob2.Glob = Glob;
    inherits(Glob, EE);
    function Glob(pattern, options, cb) {
      if (typeof options == "function" && (cb = options, options = null), options && options.sync) {
        if (cb)
          throw new TypeError("callback provided to sync glob");
        return new GlobSync(pattern, options);
      }
      if (!(this instanceof Glob))
        return new Glob(pattern, options, cb);
      setopts(this, pattern, options), this._didRealPath = !1;
      var n = this.minimatch.set.length;
      this.matches = new Array(n), typeof cb == "function" && (cb = once(cb), this.on("error", cb), this.on("end", function(matches) {
        cb(null, matches);
      }));
      var self2 = this;
      if (this._processing = 0, this._emitQueue = [], this._processQueue = [], this.paused = !1, this.noprocess)
        return this;
      if (n === 0)
        return done();
      for (var sync = !0, i = 0; i < n; i++)
        this._process(this.minimatch.set[i], i, !1, done);
      sync = !1;
      function done() {
        --self2._processing, self2._processing <= 0 && (sync ? process.nextTick(function() {
          self2._finish();
        }) : self2._finish());
      }
    }
    Glob.prototype._finish = function() {
      if (assert(this instanceof Glob), !this.aborted) {
        if (this.realpath && !this._didRealpath)
          return this._realpath();
        common.finish(this), this.emit("end", this.found);
      }
    };
    Glob.prototype._realpath = function() {
      if (this._didRealpath)
        return;
      this._didRealpath = !0;
      var n = this.matches.length;
      if (n === 0)
        return this._finish();
      for (var self2 = this, i = 0; i < this.matches.length; i++)
        this._realpathSet(i, next);
      function next() {
        --n === 0 && self2._finish();
      }
    };
    Glob.prototype._realpathSet = function(index, cb) {
      var matchset = this.matches[index];
      if (!matchset)
        return cb();
      var found = Object.keys(matchset), self2 = this, n = found.length;
      if (n === 0)
        return cb();
      var set2 = this.matches[index] = /* @__PURE__ */ Object.create(null);
      found.forEach(function(p, i) {
        p = self2._makeAbs(p), rp.realpath(p, self2.realpathCache, function(er, real) {
          er ? er.syscall === "stat" ? set2[p] = !0 : self2.emit("error", er) : set2[real] = !0, --n === 0 && (self2.matches[index] = set2, cb());
        });
      });
    };
    Glob.prototype._mark = function(p) {
      return common.mark(this, p);
    };
    Glob.prototype._makeAbs = function(f) {
      return common.makeAbs(this, f);
    };
    Glob.prototype.abort = function() {
      this.aborted = !0, this.emit("abort");
    };
    Glob.prototype.pause = function() {
      this.paused || (this.paused = !0, this.emit("pause"));
    };
    Glob.prototype.resume = function() {
      if (this.paused) {
        if (this.emit("resume"), this.paused = !1, this._emitQueue.length) {
          var eq = this._emitQueue.slice(0);
          this._emitQueue.length = 0;
          for (var i = 0; i < eq.length; i++) {
            var e = eq[i];
            this._emitMatch(e[0], e[1]);
          }
        }
        if (this._processQueue.length) {
          var pq = this._processQueue.slice(0);
          this._processQueue.length = 0;
          for (var i = 0; i < pq.length; i++) {
            var p = pq[i];
            this._processing--, this._process(p[0], p[1], p[2], p[3]);
          }
        }
      }
    };
    Glob.prototype._process = function(pattern, index, inGlobStar, cb) {
      if (assert(this instanceof Glob), assert(typeof cb == "function"), !this.aborted) {
        if (this._processing++, this.paused) {
          this._processQueue.push([pattern, index, inGlobStar, cb]);
          return;
        }
        for (var n = 0; typeof pattern[n] == "string"; )
          n++;
        var prefix;
        switch (n) {
          case pattern.length:
            this._processSimple(pattern.join("/"), index, cb);
            return;
          case 0:
            prefix = null;
            break;
          default:
            prefix = pattern.slice(0, n).join("/");
            break;
        }
        var remain = pattern.slice(n), read;
        prefix === null ? read = "." : ((isAbsolute(prefix) || isAbsolute(pattern.map(function(p) {
          return typeof p == "string" ? p : "[*]";
        }).join("/"))) && (!prefix || !isAbsolute(prefix)) && (prefix = "/" + prefix), read = prefix);
        var abs = this._makeAbs(read);
        if (childrenIgnored(this, read))
          return cb();
        var isGlobStar = remain[0] === minimatch.GLOBSTAR;
        isGlobStar ? this._processGlobStar(prefix, read, abs, remain, index, inGlobStar, cb) : this._processReaddir(prefix, read, abs, remain, index, inGlobStar, cb);
      }
    };
    Glob.prototype._processReaddir = function(prefix, read, abs, remain, index, inGlobStar, cb) {
      var self2 = this;
      this._readdir(abs, inGlobStar, function(er, entries) {
        return self2._processReaddir2(prefix, read, abs, remain, index, inGlobStar, entries, cb);
      });
    };
    Glob.prototype._processReaddir2 = function(prefix, read, abs, remain, index, inGlobStar, entries, cb) {
      if (!entries)
        return cb();
      for (var pn = remain[0], negate = !!this.minimatch.negate, rawGlob = pn._glob, dotOk = this.dot || rawGlob.charAt(0) === ".", matchedEntries = [], i = 0; i < entries.length; i++) {
        var e = entries[i];
        if (e.charAt(0) !== "." || dotOk) {
          var m;
          negate && !prefix ? m = !e.match(pn) : m = e.match(pn), m && matchedEntries.push(e);
        }
      }
      var len = matchedEntries.length;
      if (len === 0)
        return cb();
      if (remain.length === 1 && !this.mark && !this.stat) {
        this.matches[index] || (this.matches[index] = /* @__PURE__ */ Object.create(null));
        for (var i = 0; i < len; i++) {
          var e = matchedEntries[i];
          prefix && (prefix !== "/" ? e = prefix + "/" + e : e = prefix + e), e.charAt(0) === "/" && !this.nomount && (e = path3.join(this.root, e)), this._emitMatch(index, e);
        }
        return cb();
      }
      remain.shift();
      for (var i = 0; i < len; i++) {
        var e = matchedEntries[i], newPattern;
        prefix && (prefix !== "/" ? e = prefix + "/" + e : e = prefix + e), this._process([e].concat(remain), index, inGlobStar, cb);
      }
      cb();
    };
    Glob.prototype._emitMatch = function(index, e) {
      if (!this.aborted && !isIgnored(this, e)) {
        if (this.paused) {
          this._emitQueue.push([index, e]);
          return;
        }
        var abs = isAbsolute(e) ? e : this._makeAbs(e);
        if (this.mark && (e = this._mark(e)), this.absolute && (e = abs), !this.matches[index][e]) {
          if (this.nodir) {
            var c = this.cache[abs];
            if (c === "DIR" || Array.isArray(c))
              return;
          }
          this.matches[index][e] = !0;
          var st = this.statCache[abs];
          st && this.emit("stat", e, st), this.emit("match", e);
        }
      }
    };
    Glob.prototype._readdirInGlobStar = function(abs, cb) {
      if (this.aborted)
        return;
      if (this.follow)
        return this._readdir(abs, !1, cb);
      var lstatkey = "lstat\0" + abs, self2 = this, lstatcb = inflight(lstatkey, lstatcb_);
      lstatcb && self2.fs.lstat(abs, lstatcb);
      function lstatcb_(er, lstat) {
        if (er && er.code === "ENOENT")
          return cb();
        var isSym = lstat && lstat.isSymbolicLink();
        self2.symlinks[abs] = isSym, !isSym && lstat && !lstat.isDirectory() ? (self2.cache[abs] = "FILE", cb()) : self2._readdir(abs, !1, cb);
      }
    };
    Glob.prototype._readdir = function(abs, inGlobStar, cb) {
      if (!this.aborted && (cb = inflight("readdir\0" + abs + "\0" + inGlobStar, cb), !!cb)) {
        if (inGlobStar && !ownProp(this.symlinks, abs))
          return this._readdirInGlobStar(abs, cb);
        if (ownProp(this.cache, abs)) {
          var c = this.cache[abs];
          if (!c || c === "FILE")
            return cb();
          if (Array.isArray(c))
            return cb(null, c);
        }
        var self2 = this;
        self2.fs.readdir(abs, readdirCb(this, abs, cb));
      }
    };
    function readdirCb(self2, abs, cb) {
      return function(er, entries) {
        er ? self2._readdirError(abs, er, cb) : self2._readdirEntries(abs, entries, cb);
      };
    }
    Glob.prototype._readdirEntries = function(abs, entries, cb) {
      if (!this.aborted) {
        if (!this.mark && !this.stat)
          for (var i = 0; i < entries.length; i++) {
            var e = entries[i];
            abs === "/" ? e = abs + e : e = abs + "/" + e, this.cache[e] = !0;
          }
        return this.cache[abs] = entries, cb(null, entries);
      }
    };
    Glob.prototype._readdirError = function(f, er, cb) {
      if (!this.aborted) {
        switch (er.code) {
          case "ENOTSUP":
          case "ENOTDIR":
            var abs = this._makeAbs(f);
            if (this.cache[abs] = "FILE", abs === this.cwdAbs) {
              var error = new Error(er.code + " invalid cwd " + this.cwd);
              error.path = this.cwd, error.code = er.code, this.emit("error", error), this.abort();
            }
            break;
          case "ENOENT":
          case "ELOOP":
          case "ENAMETOOLONG":
          case "UNKNOWN":
            this.cache[this._makeAbs(f)] = !1;
            break;
          default:
            this.cache[this._makeAbs(f)] = !1, this.strict && (this.emit("error", er), this.abort()), this.silent || console.error("glob error", er);
            break;
        }
        return cb();
      }
    };
    Glob.prototype._processGlobStar = function(prefix, read, abs, remain, index, inGlobStar, cb) {
      var self2 = this;
      this._readdir(abs, inGlobStar, function(er, entries) {
        self2._processGlobStar2(prefix, read, abs, remain, index, inGlobStar, entries, cb);
      });
    };
    Glob.prototype._processGlobStar2 = function(prefix, read, abs, remain, index, inGlobStar, entries, cb) {
      if (!entries)
        return cb();
      var remainWithoutGlobStar = remain.slice(1), gspref = prefix ? [prefix] : [], noGlobStar = gspref.concat(remainWithoutGlobStar);
      this._process(noGlobStar, index, !1, cb);
      var isSym = this.symlinks[abs], len = entries.length;
      if (isSym && inGlobStar)
        return cb();
      for (var i = 0; i < len; i++) {
        var e = entries[i];
        if (!(e.charAt(0) === "." && !this.dot)) {
          var instead = gspref.concat(entries[i], remainWithoutGlobStar);
          this._process(instead, index, !0, cb);
          var below = gspref.concat(entries[i], remain);
          this._process(below, index, !0, cb);
        }
      }
      cb();
    };
    Glob.prototype._processSimple = function(prefix, index, cb) {
      var self2 = this;
      this._stat(prefix, function(er, exists) {
        self2._processSimple2(prefix, index, er, exists, cb);
      });
    };
    Glob.prototype._processSimple2 = function(prefix, index, er, exists, cb) {
      if (this.matches[index] || (this.matches[index] = /* @__PURE__ */ Object.create(null)), !exists)
        return cb();
      if (prefix && isAbsolute(prefix) && !this.nomount) {
        var trail = /[\/\\]$/.test(prefix);
        prefix.charAt(0) === "/" ? prefix = path3.join(this.root, prefix) : (prefix = path3.resolve(this.root, prefix), trail && (prefix += "/"));
      }
      process.platform === "win32" && (prefix = prefix.replace(/\\/g, "/")), this._emitMatch(index, prefix), cb();
    };
    Glob.prototype._stat = function(f, cb) {
      var abs = this._makeAbs(f), needDir = f.slice(-1) === "/";
      if (f.length > this.maxLength)
        return cb();
      if (!this.stat && ownProp(this.cache, abs)) {
        var c = this.cache[abs];
        if (Array.isArray(c) && (c = "DIR"), !needDir || c === "DIR")
          return cb(null, c);
        if (needDir && c === "FILE")
          return cb();
      }
      var exists, stat = this.statCache[abs];
      if (stat !== void 0) {
        if (stat === !1)
          return cb(null, stat);
        var type = stat.isDirectory() ? "DIR" : "FILE";
        return needDir && type === "FILE" ? cb() : cb(null, type, stat);
      }
      var self2 = this, statcb = inflight("stat\0" + abs, lstatcb_);
      statcb && self2.fs.lstat(abs, statcb);
      function lstatcb_(er, lstat) {
        if (lstat && lstat.isSymbolicLink())
          return self2.fs.stat(abs, function(er2, stat2) {
            er2 ? self2._stat2(f, abs, null, lstat, cb) : self2._stat2(f, abs, er2, stat2, cb);
          });
        self2._stat2(f, abs, er, lstat, cb);
      }
    };
    Glob.prototype._stat2 = function(f, abs, er, stat, cb) {
      if (er && (er.code === "ENOENT" || er.code === "ENOTDIR"))
        return this.statCache[abs] = !1, cb();
      var needDir = f.slice(-1) === "/";
      if (this.statCache[abs] = stat, abs.slice(-1) === "/" && stat && !stat.isDirectory())
        return cb(null, !1, stat);
      var c = !0;
      return stat && (c = stat.isDirectory() ? "DIR" : "FILE"), this.cache[abs] = this.cache[abs] || c, needDir && c === "FILE" ? cb() : cb(null, c, stat);
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/autofix.js
var require_autofix2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/autofix.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.autofix = exports.saveToDiskFixApplicator = void 0;
    var promises_1 = __require("fs/promises"), theme_check_common_1 = require_dist2(), saveToDiskFixApplicator2 = async (sourceCode, fix) => {
      let updatedSource = (0, theme_check_common_1.applyFixToString)(sourceCode.source, fix);
      await (0, promises_1.writeFile)(sourceCode.absolutePath, updatedSource, "utf8");
    };
    exports.saveToDiskFixApplicator = saveToDiskFixApplicator2;
    async function autofix2(sourceCodes, offenses) {
      await (0, theme_check_common_1.autofix)(sourceCodes, offenses, exports.saveToDiskFixApplicator);
    }
    exports.autofix = autofix2;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/identity.js
var require_identity = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/identity.js"(exports) {
    "use strict";
    init_cjs_shims();
    var ALIAS = Symbol.for("yaml.alias"), DOC = Symbol.for("yaml.document"), MAP = Symbol.for("yaml.map"), PAIR = Symbol.for("yaml.pair"), SCALAR = Symbol.for("yaml.scalar"), SEQ = Symbol.for("yaml.seq"), NODE_TYPE = Symbol.for("yaml.node.type"), isAlias = (node) => !!node && typeof node == "object" && node[NODE_TYPE] === ALIAS, isDocument = (node) => !!node && typeof node == "object" && node[NODE_TYPE] === DOC, isMap = (node) => !!node && typeof node == "object" && node[NODE_TYPE] === MAP, isPair = (node) => !!node && typeof node == "object" && node[NODE_TYPE] === PAIR, isScalar = (node) => !!node && typeof node == "object" && node[NODE_TYPE] === SCALAR, isSeq = (node) => !!node && typeof node == "object" && node[NODE_TYPE] === SEQ;
    function isCollection(node) {
      if (node && typeof node == "object")
        switch (node[NODE_TYPE]) {
          case MAP:
          case SEQ:
            return !0;
        }
      return !1;
    }
    function isNode(node) {
      if (node && typeof node == "object")
        switch (node[NODE_TYPE]) {
          case ALIAS:
          case MAP:
          case SCALAR:
          case SEQ:
            return !0;
        }
      return !1;
    }
    var hasAnchor = (node) => (isScalar(node) || isCollection(node)) && !!node.anchor;
    exports.ALIAS = ALIAS;
    exports.DOC = DOC;
    exports.MAP = MAP;
    exports.NODE_TYPE = NODE_TYPE;
    exports.PAIR = PAIR;
    exports.SCALAR = SCALAR;
    exports.SEQ = SEQ;
    exports.hasAnchor = hasAnchor;
    exports.isAlias = isAlias;
    exports.isCollection = isCollection;
    exports.isDocument = isDocument;
    exports.isMap = isMap;
    exports.isNode = isNode;
    exports.isPair = isPair;
    exports.isScalar = isScalar;
    exports.isSeq = isSeq;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/visit.js
var require_visit = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/visit.js"(exports) {
    "use strict";
    init_cjs_shims();
    var identity = require_identity(), BREAK = Symbol("break visit"), SKIP = Symbol("skip children"), REMOVE = Symbol("remove node");
    function visit3(node, visitor) {
      let visitor_ = initVisitor(visitor);
      identity.isDocument(node) ? visit_(null, node.contents, visitor_, Object.freeze([node])) === REMOVE && (node.contents = null) : visit_(null, node, visitor_, Object.freeze([]));
    }
    visit3.BREAK = BREAK;
    visit3.SKIP = SKIP;
    visit3.REMOVE = REMOVE;
    function visit_(key, node, visitor, path3) {
      let ctrl = callVisitor(key, node, visitor, path3);
      if (identity.isNode(ctrl) || identity.isPair(ctrl))
        return replaceNode(key, path3, ctrl), visit_(key, ctrl, visitor, path3);
      if (typeof ctrl != "symbol") {
        if (identity.isCollection(node)) {
          path3 = Object.freeze(path3.concat(node));
          for (let i = 0; i < node.items.length; ++i) {
            let ci = visit_(i, node.items[i], visitor, path3);
            if (typeof ci == "number")
              i = ci - 1;
            else {
              if (ci === BREAK)
                return BREAK;
              ci === REMOVE && (node.items.splice(i, 1), i -= 1);
            }
          }
        } else if (identity.isPair(node)) {
          path3 = Object.freeze(path3.concat(node));
          let ck = visit_("key", node.key, visitor, path3);
          if (ck === BREAK)
            return BREAK;
          ck === REMOVE && (node.key = null);
          let cv = visit_("value", node.value, visitor, path3);
          if (cv === BREAK)
            return BREAK;
          cv === REMOVE && (node.value = null);
        }
      }
      return ctrl;
    }
    async function visitAsync(node, visitor) {
      let visitor_ = initVisitor(visitor);
      identity.isDocument(node) ? await visitAsync_(null, node.contents, visitor_, Object.freeze([node])) === REMOVE && (node.contents = null) : await visitAsync_(null, node, visitor_, Object.freeze([]));
    }
    visitAsync.BREAK = BREAK;
    visitAsync.SKIP = SKIP;
    visitAsync.REMOVE = REMOVE;
    async function visitAsync_(key, node, visitor, path3) {
      let ctrl = await callVisitor(key, node, visitor, path3);
      if (identity.isNode(ctrl) || identity.isPair(ctrl))
        return replaceNode(key, path3, ctrl), visitAsync_(key, ctrl, visitor, path3);
      if (typeof ctrl != "symbol") {
        if (identity.isCollection(node)) {
          path3 = Object.freeze(path3.concat(node));
          for (let i = 0; i < node.items.length; ++i) {
            let ci = await visitAsync_(i, node.items[i], visitor, path3);
            if (typeof ci == "number")
              i = ci - 1;
            else {
              if (ci === BREAK)
                return BREAK;
              ci === REMOVE && (node.items.splice(i, 1), i -= 1);
            }
          }
        } else if (identity.isPair(node)) {
          path3 = Object.freeze(path3.concat(node));
          let ck = await visitAsync_("key", node.key, visitor, path3);
          if (ck === BREAK)
            return BREAK;
          ck === REMOVE && (node.key = null);
          let cv = await visitAsync_("value", node.value, visitor, path3);
          if (cv === BREAK)
            return BREAK;
          cv === REMOVE && (node.value = null);
        }
      }
      return ctrl;
    }
    function initVisitor(visitor) {
      return typeof visitor == "object" && (visitor.Collection || visitor.Node || visitor.Value) ? Object.assign({
        Alias: visitor.Node,
        Map: visitor.Node,
        Scalar: visitor.Node,
        Seq: visitor.Node
      }, visitor.Value && {
        Map: visitor.Value,
        Scalar: visitor.Value,
        Seq: visitor.Value
      }, visitor.Collection && {
        Map: visitor.Collection,
        Seq: visitor.Collection
      }, visitor) : visitor;
    }
    function callVisitor(key, node, visitor, path3) {
      if (typeof visitor == "function")
        return visitor(key, node, path3);
      if (identity.isMap(node))
        return visitor.Map?.(key, node, path3);
      if (identity.isSeq(node))
        return visitor.Seq?.(key, node, path3);
      if (identity.isPair(node))
        return visitor.Pair?.(key, node, path3);
      if (identity.isScalar(node))
        return visitor.Scalar?.(key, node, path3);
      if (identity.isAlias(node))
        return visitor.Alias?.(key, node, path3);
    }
    function replaceNode(key, path3, node) {
      let parent = path3[path3.length - 1];
      if (identity.isCollection(parent))
        parent.items[key] = node;
      else if (identity.isPair(parent))
        key === "key" ? parent.key = node : parent.value = node;
      else if (identity.isDocument(parent))
        parent.contents = node;
      else {
        let pt = identity.isAlias(parent) ? "alias" : "scalar";
        throw new Error(`Cannot replace node with ${pt} parent`);
      }
    }
    exports.visit = visit3;
    exports.visitAsync = visitAsync;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/doc/directives.js
var require_directives = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/doc/directives.js"(exports) {
    "use strict";
    init_cjs_shims();
    var identity = require_identity(), visit3 = require_visit(), escapeChars = {
      "!": "%21",
      ",": "%2C",
      "[": "%5B",
      "]": "%5D",
      "{": "%7B",
      "}": "%7D"
    }, escapeTagName = (tn) => tn.replace(/[!,[\]{}]/g, (ch) => escapeChars[ch]), Directives = class _Directives {
      constructor(yaml, tags) {
        this.docStart = null, this.docEnd = !1, this.yaml = Object.assign({}, _Directives.defaultYaml, yaml), this.tags = Object.assign({}, _Directives.defaultTags, tags);
      }
      clone() {
        let copy = new _Directives(this.yaml, this.tags);
        return copy.docStart = this.docStart, copy;
      }
      /**
       * During parsing, get a Directives instance for the current document and
       * update the stream state according to the current version's spec.
       */
      atDocument() {
        let res = new _Directives(this.yaml, this.tags);
        switch (this.yaml.version) {
          case "1.1":
            this.atNextDocument = !0;
            break;
          case "1.2":
            this.atNextDocument = !1, this.yaml = {
              explicit: _Directives.defaultYaml.explicit,
              version: "1.2"
            }, this.tags = Object.assign({}, _Directives.defaultTags);
            break;
        }
        return res;
      }
      /**
       * @param onError - May be called even if the action was successful
       * @returns `true` on success
       */
      add(line, onError) {
        this.atNextDocument && (this.yaml = { explicit: _Directives.defaultYaml.explicit, version: "1.1" }, this.tags = Object.assign({}, _Directives.defaultTags), this.atNextDocument = !1);
        let parts = line.trim().split(/[ \t]+/), name = parts.shift();
        switch (name) {
          case "%TAG": {
            if (parts.length !== 2 && (onError(0, "%TAG directive should contain exactly two parts"), parts.length < 2))
              return !1;
            let [handle, prefix] = parts;
            return this.tags[handle] = prefix, !0;
          }
          case "%YAML": {
            if (this.yaml.explicit = !0, parts.length !== 1)
              return onError(0, "%YAML directive should contain exactly one part"), !1;
            let [version2] = parts;
            if (version2 === "1.1" || version2 === "1.2")
              return this.yaml.version = version2, !0;
            {
              let isValid = /^\d+\.\d+$/.test(version2);
              return onError(6, `Unsupported YAML version ${version2}`, isValid), !1;
            }
          }
          default:
            return onError(0, `Unknown directive ${name}`, !0), !1;
        }
      }
      /**
       * Resolves a tag, matching handles to those defined in %TAG directives.
       *
       * @returns Resolved tag, which may also be the non-specific tag `'!'` or a
       *   `'!local'` tag, or `null` if unresolvable.
       */
      tagName(source, onError) {
        if (source === "!")
          return "!";
        if (source[0] !== "!")
          return onError(`Not a valid tag: ${source}`), null;
        if (source[1] === "<") {
          let verbatim = source.slice(2, -1);
          return verbatim === "!" || verbatim === "!!" ? (onError(`Verbatim tags aren't resolved, so ${source} is invalid.`), null) : (source[source.length - 1] !== ">" && onError("Verbatim tags must end with a >"), verbatim);
        }
        let [, handle, suffix] = source.match(/^(.*!)([^!]*)$/);
        suffix || onError(`The ${source} tag has no suffix`);
        let prefix = this.tags[handle];
        return prefix ? prefix + decodeURIComponent(suffix) : handle === "!" ? source : (onError(`Could not resolve tag: ${source}`), null);
      }
      /**
       * Given a fully resolved tag, returns its printable string form,
       * taking into account current tag prefixes and defaults.
       */
      tagString(tag) {
        for (let [handle, prefix] of Object.entries(this.tags))
          if (tag.startsWith(prefix))
            return handle + escapeTagName(tag.substring(prefix.length));
        return tag[0] === "!" ? tag : `!<${tag}>`;
      }
      toString(doc) {
        let lines = this.yaml.explicit ? [`%YAML ${this.yaml.version || "1.2"}`] : [], tagEntries = Object.entries(this.tags), tagNames;
        if (doc && tagEntries.length > 0 && identity.isNode(doc.contents)) {
          let tags = {};
          visit3.visit(doc.contents, (_key, node) => {
            identity.isNode(node) && node.tag && (tags[node.tag] = !0);
          }), tagNames = Object.keys(tags);
        } else
          tagNames = [];
        for (let [handle, prefix] of tagEntries)
          handle === "!!" && prefix === "tag:yaml.org,2002:" || (!doc || tagNames.some((tn) => tn.startsWith(prefix))) && lines.push(`%TAG ${handle} ${prefix}`);
        return lines.join(`
`);
      }
    };
    Directives.defaultYaml = { explicit: !1, version: "1.2" };
    Directives.defaultTags = { "!!": "tag:yaml.org,2002:" };
    exports.Directives = Directives;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/doc/anchors.js
var require_anchors = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/doc/anchors.js"(exports) {
    "use strict";
    init_cjs_shims();
    var identity = require_identity(), visit3 = require_visit();
    function anchorIsValid(anchor) {
      if (/[\x00-\x19\s,[\]{}]/.test(anchor)) {
        let msg = `Anchor must not contain whitespace or control characters: ${JSON.stringify(anchor)}`;
        throw new Error(msg);
      }
      return !0;
    }
    function anchorNames(root) {
      let anchors = /* @__PURE__ */ new Set();
      return visit3.visit(root, {
        Value(_key, node) {
          node.anchor && anchors.add(node.anchor);
        }
      }), anchors;
    }
    function findNewAnchor(prefix, exclude) {
      for (let i = 1; ; ++i) {
        let name = `${prefix}${i}`;
        if (!exclude.has(name))
          return name;
      }
    }
    function createNodeAnchors(doc, prefix) {
      let aliasObjects = [], sourceObjects = /* @__PURE__ */ new Map(), prevAnchors = null;
      return {
        onAnchor: (source) => {
          aliasObjects.push(source), prevAnchors || (prevAnchors = anchorNames(doc));
          let anchor = findNewAnchor(prefix, prevAnchors);
          return prevAnchors.add(anchor), anchor;
        },
        /**
         * With circular references, the source node is only resolved after all
         * of its child nodes are. This is why anchors are set only after all of
         * the nodes have been created.
         */
        setAnchors: () => {
          for (let source of aliasObjects) {
            let ref = sourceObjects.get(source);
            if (typeof ref == "object" && ref.anchor && (identity.isScalar(ref.node) || identity.isCollection(ref.node)))
              ref.node.anchor = ref.anchor;
            else {
              let error = new Error("Failed to resolve repeated object (this should not happen)");
              throw error.source = source, error;
            }
          }
        },
        sourceObjects
      };
    }
    exports.anchorIsValid = anchorIsValid;
    exports.anchorNames = anchorNames;
    exports.createNodeAnchors = createNodeAnchors;
    exports.findNewAnchor = findNewAnchor;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/doc/applyReviver.js
var require_applyReviver = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/doc/applyReviver.js"(exports) {
    "use strict";
    init_cjs_shims();
    function applyReviver(reviver, obj, key, val) {
      if (val && typeof val == "object")
        if (Array.isArray(val))
          for (let i = 0, len = val.length; i < len; ++i) {
            let v0 = val[i], v1 = applyReviver(reviver, val, String(i), v0);
            v1 === void 0 ? delete val[i] : v1 !== v0 && (val[i] = v1);
          }
        else if (val instanceof Map)
          for (let k of Array.from(val.keys())) {
            let v0 = val.get(k), v1 = applyReviver(reviver, val, k, v0);
            v1 === void 0 ? val.delete(k) : v1 !== v0 && val.set(k, v1);
          }
        else if (val instanceof Set)
          for (let v0 of Array.from(val)) {
            let v1 = applyReviver(reviver, val, v0, v0);
            v1 === void 0 ? val.delete(v0) : v1 !== v0 && (val.delete(v0), val.add(v1));
          }
        else
          for (let [k, v0] of Object.entries(val)) {
            let v1 = applyReviver(reviver, val, k, v0);
            v1 === void 0 ? delete val[k] : v1 !== v0 && (val[k] = v1);
          }
      return reviver.call(obj, key, val);
    }
    exports.applyReviver = applyReviver;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/toJS.js
var require_toJS = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/toJS.js"(exports) {
    "use strict";
    init_cjs_shims();
    var identity = require_identity();
    function toJS(value, arg, ctx) {
      if (Array.isArray(value))
        return value.map((v, i) => toJS(v, String(i), ctx));
      if (value && typeof value.toJSON == "function") {
        if (!ctx || !identity.hasAnchor(value))
          return value.toJSON(arg, ctx);
        let data = { aliasCount: 0, count: 1, res: void 0 };
        ctx.anchors.set(value, data), ctx.onCreate = (res2) => {
          data.res = res2, delete ctx.onCreate;
        };
        let res = value.toJSON(arg, ctx);
        return ctx.onCreate && ctx.onCreate(res), res;
      }
      return typeof value == "bigint" && !ctx?.keep ? Number(value) : value;
    }
    exports.toJS = toJS;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/Node.js
var require_Node = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/Node.js"(exports) {
    "use strict";
    init_cjs_shims();
    var applyReviver = require_applyReviver(), identity = require_identity(), toJS = require_toJS(), NodeBase = class {
      constructor(type) {
        Object.defineProperty(this, identity.NODE_TYPE, { value: type });
      }
      /** Create a copy of this node.  */
      clone() {
        let copy = Object.create(Object.getPrototypeOf(this), Object.getOwnPropertyDescriptors(this));
        return this.range && (copy.range = this.range.slice()), copy;
      }
      /** A plain JavaScript representation of this node. */
      toJS(doc, { mapAsMap, maxAliasCount, onAnchor, reviver } = {}) {
        if (!identity.isDocument(doc))
          throw new TypeError("A document argument is required");
        let ctx = {
          anchors: /* @__PURE__ */ new Map(),
          doc,
          keep: !0,
          mapAsMap: mapAsMap === !0,
          mapKeyWarned: !1,
          maxAliasCount: typeof maxAliasCount == "number" ? maxAliasCount : 100
        }, res = toJS.toJS(this, "", ctx);
        if (typeof onAnchor == "function")
          for (let { count, res: res2 } of ctx.anchors.values())
            onAnchor(res2, count);
        return typeof reviver == "function" ? applyReviver.applyReviver(reviver, { "": res }, "", res) : res;
      }
    };
    exports.NodeBase = NodeBase;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/Alias.js
var require_Alias = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/Alias.js"(exports) {
    "use strict";
    init_cjs_shims();
    var anchors = require_anchors(), visit3 = require_visit(), identity = require_identity(), Node2 = require_Node(), toJS = require_toJS(), Alias = class extends Node2.NodeBase {
      constructor(source) {
        super(identity.ALIAS), this.source = source, Object.defineProperty(this, "tag", {
          set() {
            throw new Error("Alias nodes cannot have tags");
          }
        });
      }
      /**
       * Resolve the value of this alias within `doc`, finding the last
       * instance of the `source` anchor before this node.
       */
      resolve(doc) {
        let found;
        return visit3.visit(doc, {
          Node: (_key, node) => {
            if (node === this)
              return visit3.visit.BREAK;
            node.anchor === this.source && (found = node);
          }
        }), found;
      }
      toJSON(_arg, ctx) {
        if (!ctx)
          return { source: this.source };
        let { anchors: anchors2, doc, maxAliasCount } = ctx, source = this.resolve(doc);
        if (!source) {
          let msg = `Unresolved alias (the anchor must be set before the alias): ${this.source}`;
          throw new ReferenceError(msg);
        }
        let data = anchors2.get(source);
        if (data || (toJS.toJS(source, null, ctx), data = anchors2.get(source)), !data || data.res === void 0) {
          let msg = "This should not happen: Alias anchor was not resolved?";
          throw new ReferenceError(msg);
        }
        if (maxAliasCount >= 0 && (data.count += 1, data.aliasCount === 0 && (data.aliasCount = getAliasCount(doc, source, anchors2)), data.count * data.aliasCount > maxAliasCount)) {
          let msg = "Excessive alias count indicates a resource exhaustion attack";
          throw new ReferenceError(msg);
        }
        return data.res;
      }
      toString(ctx, _onComment, _onChompKeep) {
        let src = `*${this.source}`;
        if (ctx) {
          if (anchors.anchorIsValid(this.source), ctx.options.verifyAliasOrder && !ctx.anchors.has(this.source)) {
            let msg = `Unresolved alias (the anchor must be set before the alias): ${this.source}`;
            throw new Error(msg);
          }
          if (ctx.implicitKey)
            return `${src} `;
        }
        return src;
      }
    };
    function getAliasCount(doc, node, anchors2) {
      if (identity.isAlias(node)) {
        let source = node.resolve(doc), anchor = anchors2 && source && anchors2.get(source);
        return anchor ? anchor.count * anchor.aliasCount : 0;
      } else if (identity.isCollection(node)) {
        let count = 0;
        for (let item of node.items) {
          let c = getAliasCount(doc, item, anchors2);
          c > count && (count = c);
        }
        return count;
      } else if (identity.isPair(node)) {
        let kc = getAliasCount(doc, node.key, anchors2), vc = getAliasCount(doc, node.value, anchors2);
        return Math.max(kc, vc);
      }
      return 1;
    }
    exports.Alias = Alias;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/Scalar.js
var require_Scalar = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/Scalar.js"(exports) {
    "use strict";
    init_cjs_shims();
    var identity = require_identity(), Node2 = require_Node(), toJS = require_toJS(), isScalarValue = (value) => !value || typeof value != "function" && typeof value != "object", Scalar = class extends Node2.NodeBase {
      constructor(value) {
        super(identity.SCALAR), this.value = value;
      }
      toJSON(arg, ctx) {
        return ctx?.keep ? this.value : toJS.toJS(this.value, arg, ctx);
      }
      toString() {
        return String(this.value);
      }
    };
    Scalar.BLOCK_FOLDED = "BLOCK_FOLDED";
    Scalar.BLOCK_LITERAL = "BLOCK_LITERAL";
    Scalar.PLAIN = "PLAIN";
    Scalar.QUOTE_DOUBLE = "QUOTE_DOUBLE";
    Scalar.QUOTE_SINGLE = "QUOTE_SINGLE";
    exports.Scalar = Scalar;
    exports.isScalarValue = isScalarValue;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/doc/createNode.js
var require_createNode = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/doc/createNode.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Alias = require_Alias(), identity = require_identity(), Scalar = require_Scalar(), defaultTagPrefix = "tag:yaml.org,2002:";
    function findTagObject(value, tagName, tags) {
      if (tagName) {
        let match2 = tags.filter((t7) => t7.tag === tagName), tagObj = match2.find((t7) => !t7.format) ?? match2[0];
        if (!tagObj)
          throw new Error(`Tag ${tagName} not found`);
        return tagObj;
      }
      return tags.find((t7) => t7.identify?.(value) && !t7.format);
    }
    function createNode(value, tagName, ctx) {
      if (identity.isDocument(value) && (value = value.contents), identity.isNode(value))
        return value;
      if (identity.isPair(value)) {
        let map = ctx.schema[identity.MAP].createNode?.(ctx.schema, null, ctx);
        return map.items.push(value), map;
      }
      (value instanceof String || value instanceof Number || value instanceof Boolean || typeof BigInt < "u" && value instanceof BigInt) && (value = value.valueOf());
      let { aliasDuplicateObjects, onAnchor, onTagObj, schema, sourceObjects } = ctx, ref;
      if (aliasDuplicateObjects && value && typeof value == "object") {
        if (ref = sourceObjects.get(value), ref)
          return ref.anchor || (ref.anchor = onAnchor(value)), new Alias.Alias(ref.anchor);
        ref = { anchor: null, node: null }, sourceObjects.set(value, ref);
      }
      tagName?.startsWith("!!") && (tagName = defaultTagPrefix + tagName.slice(2));
      let tagObj = findTagObject(value, tagName, schema.tags);
      if (!tagObj) {
        if (value && typeof value.toJSON == "function" && (value = value.toJSON()), !value || typeof value != "object") {
          let node2 = new Scalar.Scalar(value);
          return ref && (ref.node = node2), node2;
        }
        tagObj = value instanceof Map ? schema[identity.MAP] : Symbol.iterator in Object(value) ? schema[identity.SEQ] : schema[identity.MAP];
      }
      onTagObj && (onTagObj(tagObj), delete ctx.onTagObj);
      let node = tagObj?.createNode ? tagObj.createNode(ctx.schema, value, ctx) : typeof tagObj?.nodeClass?.from == "function" ? tagObj.nodeClass.from(ctx.schema, value, ctx) : new Scalar.Scalar(value);
      return tagName ? node.tag = tagName : tagObj.default || (node.tag = tagObj.tag), ref && (ref.node = node), node;
    }
    exports.createNode = createNode;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/Collection.js
var require_Collection = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/Collection.js"(exports) {
    "use strict";
    init_cjs_shims();
    var createNode = require_createNode(), identity = require_identity(), Node2 = require_Node();
    function collectionFromPath(schema, path3, value) {
      let v = value;
      for (let i = path3.length - 1; i >= 0; --i) {
        let k = path3[i];
        if (typeof k == "number" && Number.isInteger(k) && k >= 0) {
          let a = [];
          a[k] = v, v = a;
        } else
          v = /* @__PURE__ */ new Map([[k, v]]);
      }
      return createNode.createNode(v, void 0, {
        aliasDuplicateObjects: !1,
        keepUndefined: !1,
        onAnchor: () => {
          throw new Error("This should not happen, please report a bug.");
        },
        schema,
        sourceObjects: /* @__PURE__ */ new Map()
      });
    }
    var isEmptyPath = (path3) => path3 == null || typeof path3 == "object" && !!path3[Symbol.iterator]().next().done, Collection = class extends Node2.NodeBase {
      constructor(type, schema) {
        super(type), Object.defineProperty(this, "schema", {
          value: schema,
          configurable: !0,
          enumerable: !1,
          writable: !0
        });
      }
      /**
       * Create a copy of this collection.
       *
       * @param schema - If defined, overwrites the original's schema
       */
      clone(schema) {
        let copy = Object.create(Object.getPrototypeOf(this), Object.getOwnPropertyDescriptors(this));
        return schema && (copy.schema = schema), copy.items = copy.items.map((it) => identity.isNode(it) || identity.isPair(it) ? it.clone(schema) : it), this.range && (copy.range = this.range.slice()), copy;
      }
      /**
       * Adds a value to the collection. For `!!map` and `!!omap` the value must
       * be a Pair instance or a `{ key, value }` object, which may not have a key
       * that already exists in the map.
       */
      addIn(path3, value) {
        if (isEmptyPath(path3))
          this.add(value);
        else {
          let [key, ...rest] = path3, node = this.get(key, !0);
          if (identity.isCollection(node))
            node.addIn(rest, value);
          else if (node === void 0 && this.schema)
            this.set(key, collectionFromPath(this.schema, rest, value));
          else
            throw new Error(`Expected YAML collection at ${key}. Remaining path: ${rest}`);
        }
      }
      /**
       * Removes a value from the collection.
       * @returns `true` if the item was found and removed.
       */
      deleteIn(path3) {
        let [key, ...rest] = path3;
        if (rest.length === 0)
          return this.delete(key);
        let node = this.get(key, !0);
        if (identity.isCollection(node))
          return node.deleteIn(rest);
        throw new Error(`Expected YAML collection at ${key}. Remaining path: ${rest}`);
      }
      /**
       * Returns item at `key`, or `undefined` if not found. By default unwraps
       * scalar values from their surrounding node; to disable set `keepScalar` to
       * `true` (collections are always returned intact).
       */
      getIn(path3, keepScalar) {
        let [key, ...rest] = path3, node = this.get(key, !0);
        return rest.length === 0 ? !keepScalar && identity.isScalar(node) ? node.value : node : identity.isCollection(node) ? node.getIn(rest, keepScalar) : void 0;
      }
      hasAllNullValues(allowScalar) {
        return this.items.every((node) => {
          if (!identity.isPair(node))
            return !1;
          let n = node.value;
          return n == null || allowScalar && identity.isScalar(n) && n.value == null && !n.commentBefore && !n.comment && !n.tag;
        });
      }
      /**
       * Checks if the collection includes a value with the key `key`.
       */
      hasIn(path3) {
        let [key, ...rest] = path3;
        if (rest.length === 0)
          return this.has(key);
        let node = this.get(key, !0);
        return identity.isCollection(node) ? node.hasIn(rest) : !1;
      }
      /**
       * Sets a value in this collection. For `!!set`, `value` needs to be a
       * boolean to add/remove the item from the set.
       */
      setIn(path3, value) {
        let [key, ...rest] = path3;
        if (rest.length === 0)
          this.set(key, value);
        else {
          let node = this.get(key, !0);
          if (identity.isCollection(node))
            node.setIn(rest, value);
          else if (node === void 0 && this.schema)
            this.set(key, collectionFromPath(this.schema, rest, value));
          else
            throw new Error(`Expected YAML collection at ${key}. Remaining path: ${rest}`);
        }
      }
    };
    Collection.maxFlowStringSingleLineLength = 60;
    exports.Collection = Collection;
    exports.collectionFromPath = collectionFromPath;
    exports.isEmptyPath = isEmptyPath;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/stringify/stringifyComment.js
var require_stringifyComment = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/stringify/stringifyComment.js"(exports) {
    "use strict";
    init_cjs_shims();
    var stringifyComment = (str) => str.replace(/^(?!$)(?: $)?/gm, "#");
    function indentComment(comment, indent) {
      return /^\n+$/.test(comment) ? comment.substring(1) : indent ? comment.replace(/^(?! *$)/gm, indent) : comment;
    }
    var lineComment = (str, indent, comment) => str.endsWith(`
`) ? indentComment(comment, indent) : comment.includes(`
`) ? `
` + indentComment(comment, indent) : (str.endsWith(" ") ? "" : " ") + comment;
    exports.indentComment = indentComment;
    exports.lineComment = lineComment;
    exports.stringifyComment = stringifyComment;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/stringify/foldFlowLines.js
var require_foldFlowLines = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/stringify/foldFlowLines.js"(exports) {
    "use strict";
    init_cjs_shims();
    var FOLD_FLOW = "flow", FOLD_BLOCK = "block", FOLD_QUOTED = "quoted";
    function foldFlowLines(text, indent, mode = "flow", { indentAtStart, lineWidth = 80, minContentWidth = 20, onFold, onOverflow } = {}) {
      if (!lineWidth || lineWidth < 0)
        return text;
      let endStep = Math.max(1 + minContentWidth, 1 + lineWidth - indent.length);
      if (text.length <= endStep)
        return text;
      let folds = [], escapedFolds = {}, end = lineWidth - indent.length;
      typeof indentAtStart == "number" && (indentAtStart > lineWidth - Math.max(2, minContentWidth) ? folds.push(0) : end = lineWidth - indentAtStart);
      let split, prev, overflow = !1, i = -1, escStart = -1, escEnd = -1;
      mode === FOLD_BLOCK && (i = consumeMoreIndentedLines(text, i), i !== -1 && (end = i + endStep));
      for (let ch; ch = text[i += 1]; ) {
        if (mode === FOLD_QUOTED && ch === "\\") {
          switch (escStart = i, text[i + 1]) {
            case "x":
              i += 3;
              break;
            case "u":
              i += 5;
              break;
            case "U":
              i += 9;
              break;
            default:
              i += 1;
          }
          escEnd = i;
        }
        if (ch === `
`)
          mode === FOLD_BLOCK && (i = consumeMoreIndentedLines(text, i)), end = i + endStep, split = void 0;
        else {
          if (ch === " " && prev && prev !== " " && prev !== `
` && prev !== "	") {
            let next = text[i + 1];
            next && next !== " " && next !== `
` && next !== "	" && (split = i);
          }
          if (i >= end)
            if (split)
              folds.push(split), end = split + endStep, split = void 0;
            else if (mode === FOLD_QUOTED) {
              for (; prev === " " || prev === "	"; )
                prev = ch, ch = text[i += 1], overflow = !0;
              let j = i > escEnd + 1 ? i - 2 : escStart - 1;
              if (escapedFolds[j])
                return text;
              folds.push(j), escapedFolds[j] = !0, end = j + endStep, split = void 0;
            } else
              overflow = !0;
        }
        prev = ch;
      }
      if (overflow && onOverflow && onOverflow(), folds.length === 0)
        return text;
      onFold && onFold();
      let res = text.slice(0, folds[0]);
      for (let i2 = 0; i2 < folds.length; ++i2) {
        let fold = folds[i2], end2 = folds[i2 + 1] || text.length;
        fold === 0 ? res = `
${indent}${text.slice(0, end2)}` : (mode === FOLD_QUOTED && escapedFolds[fold] && (res += `${text[fold]}\\`), res += `
${indent}${text.slice(fold + 1, end2)}`);
      }
      return res;
    }
    function consumeMoreIndentedLines(text, i) {
      let ch = text[i + 1];
      for (; ch === " " || ch === "	"; ) {
        do
          ch = text[i += 1];
        while (ch && ch !== `
`);
        ch = text[i + 1];
      }
      return i;
    }
    exports.FOLD_BLOCK = FOLD_BLOCK;
    exports.FOLD_FLOW = FOLD_FLOW;
    exports.FOLD_QUOTED = FOLD_QUOTED;
    exports.foldFlowLines = foldFlowLines;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/stringify/stringifyString.js
var require_stringifyString = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/stringify/stringifyString.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Scalar = require_Scalar(), foldFlowLines = require_foldFlowLines(), getFoldOptions = (ctx, isBlock) => ({
      indentAtStart: isBlock ? ctx.indent.length : ctx.indentAtStart,
      lineWidth: ctx.options.lineWidth,
      minContentWidth: ctx.options.minContentWidth
    }), containsDocumentMarker = (str) => /^(%|---|\.\.\.)/m.test(str);
    function lineLengthOverLimit(str, lineWidth, indentLength) {
      if (!lineWidth || lineWidth < 0)
        return !1;
      let limit = lineWidth - indentLength, strLen = str.length;
      if (strLen <= limit)
        return !1;
      for (let i = 0, start = 0; i < strLen; ++i)
        if (str[i] === `
`) {
          if (i - start > limit)
            return !0;
          if (start = i + 1, strLen - start <= limit)
            return !1;
        }
      return !0;
    }
    function doubleQuotedString(value, ctx) {
      let json = JSON.stringify(value);
      if (ctx.options.doubleQuotedAsJSON)
        return json;
      let { implicitKey } = ctx, minMultiLineLength = ctx.options.doubleQuotedMinMultiLineLength, indent = ctx.indent || (containsDocumentMarker(value) ? "  " : ""), str = "", start = 0;
      for (let i = 0, ch = json[i]; ch; ch = json[++i])
        if (ch === " " && json[i + 1] === "\\" && json[i + 2] === "n" && (str += json.slice(start, i) + "\\ ", i += 1, start = i, ch = "\\"), ch === "\\")
          switch (json[i + 1]) {
            case "u":
              {
                str += json.slice(start, i);
                let code = json.substr(i + 2, 4);
                switch (code) {
                  case "0000":
                    str += "\\0";
                    break;
                  case "0007":
                    str += "\\a";
                    break;
                  case "000b":
                    str += "\\v";
                    break;
                  case "001b":
                    str += "\\e";
                    break;
                  case "0085":
                    str += "\\N";
                    break;
                  case "00a0":
                    str += "\\_";
                    break;
                  case "2028":
                    str += "\\L";
                    break;
                  case "2029":
                    str += "\\P";
                    break;
                  default:
                    code.substr(0, 2) === "00" ? str += "\\x" + code.substr(2) : str += json.substr(i, 6);
                }
                i += 5, start = i + 1;
              }
              break;
            case "n":
              if (implicitKey || json[i + 2] === '"' || json.length < minMultiLineLength)
                i += 1;
              else {
                for (str += json.slice(start, i) + `

`; json[i + 2] === "\\" && json[i + 3] === "n" && json[i + 4] !== '"'; )
                  str += `
`, i += 2;
                str += indent, json[i + 2] === " " && (str += "\\"), i += 1, start = i + 1;
              }
              break;
            default:
              i += 1;
          }
      return str = start ? str + json.slice(start) : json, implicitKey ? str : foldFlowLines.foldFlowLines(str, indent, foldFlowLines.FOLD_QUOTED, getFoldOptions(ctx, !1));
    }
    function singleQuotedString(value, ctx) {
      if (ctx.options.singleQuote === !1 || ctx.implicitKey && value.includes(`
`) || /[ \t]\n|\n[ \t]/.test(value))
        return doubleQuotedString(value, ctx);
      let indent = ctx.indent || (containsDocumentMarker(value) ? "  " : ""), res = "'" + value.replace(/'/g, "''").replace(/\n+/g, `$&
${indent}`) + "'";
      return ctx.implicitKey ? res : foldFlowLines.foldFlowLines(res, indent, foldFlowLines.FOLD_FLOW, getFoldOptions(ctx, !1));
    }
    function quotedString(value, ctx) {
      let { singleQuote } = ctx.options, qs;
      if (singleQuote === !1)
        qs = doubleQuotedString;
      else {
        let hasDouble = value.includes('"'), hasSingle = value.includes("'");
        hasDouble && !hasSingle ? qs = singleQuotedString : hasSingle && !hasDouble ? qs = doubleQuotedString : qs = singleQuote ? singleQuotedString : doubleQuotedString;
      }
      return qs(value, ctx);
    }
    var blockEndNewlines;
    try {
      blockEndNewlines = new RegExp(`(^|(?<!
))
+(?!
|$)`, "g");
    } catch {
      blockEndNewlines = /\n+(?!\n|$)/g;
    }
    function blockString({ comment, type, value }, ctx, onComment, onChompKeep) {
      let { blockQuote, commentString: commentString2, lineWidth } = ctx.options;
      if (!blockQuote || /\n[\t ]+$/.test(value) || /^\s*$/.test(value))
        return quotedString(value, ctx);
      let indent = ctx.indent || (ctx.forceBlockIndent || containsDocumentMarker(value) ? "  " : ""), literal = blockQuote === "literal" ? !0 : blockQuote === "folded" || type === Scalar.Scalar.BLOCK_FOLDED ? !1 : type === Scalar.Scalar.BLOCK_LITERAL ? !0 : !lineLengthOverLimit(value, lineWidth, indent.length);
      if (!value)
        return literal ? `|
` : `>
`;
      let chomp, endStart;
      for (endStart = value.length; endStart > 0; --endStart) {
        let ch = value[endStart - 1];
        if (ch !== `
` && ch !== "	" && ch !== " ")
          break;
      }
      let end = value.substring(endStart), endNlPos = end.indexOf(`
`);
      endNlPos === -1 ? chomp = "-" : value === end || endNlPos !== end.length - 1 ? (chomp = "+", onChompKeep && onChompKeep()) : chomp = "", end && (value = value.slice(0, -end.length), end[end.length - 1] === `
` && (end = end.slice(0, -1)), end = end.replace(blockEndNewlines, `$&${indent}`));
      let startWithSpace = !1, startEnd, startNlPos = -1;
      for (startEnd = 0; startEnd < value.length; ++startEnd) {
        let ch = value[startEnd];
        if (ch === " ")
          startWithSpace = !0;
        else if (ch === `
`)
          startNlPos = startEnd;
        else
          break;
      }
      let start = value.substring(0, startNlPos < startEnd ? startNlPos + 1 : startEnd);
      start && (value = value.substring(start.length), start = start.replace(/\n+/g, `$&${indent}`));
      let header2 = (literal ? "|" : ">") + (startWithSpace ? indent ? "2" : "1" : "") + chomp;
      if (comment && (header2 += " " + commentString2(comment.replace(/ ?[\r\n]+/g, " ")), onComment && onComment()), literal)
        return value = value.replace(/\n+/g, `$&${indent}`), `${header2}
${indent}${start}${value}${end}`;
      value = value.replace(/\n+/g, `
$&`).replace(/(?:^|\n)([\t ].*)(?:([\n\t ]*)\n(?![\n\t ]))?/g, "$1$2").replace(/\n+/g, `$&${indent}`);
      let body = foldFlowLines.foldFlowLines(`${start}${value}${end}`, indent, foldFlowLines.FOLD_BLOCK, getFoldOptions(ctx, !0));
      return `${header2}
${indent}${body}`;
    }
    function plainString(item, ctx, onComment, onChompKeep) {
      let { type, value } = item, { actualString, implicitKey, indent, indentStep, inFlow } = ctx;
      if (implicitKey && value.includes(`
`) || inFlow && /[[\]{},]/.test(value))
        return quotedString(value, ctx);
      if (!value || /^[\n\t ,[\]{}#&*!|>'"%@`]|^[?-]$|^[?-][ \t]|[\n:][ \t]|[ \t]\n|[\n\t ]#|[\n\t :]$/.test(value))
        return implicitKey || inFlow || !value.includes(`
`) ? quotedString(value, ctx) : blockString(item, ctx, onComment, onChompKeep);
      if (!implicitKey && !inFlow && type !== Scalar.Scalar.PLAIN && value.includes(`
`))
        return blockString(item, ctx, onComment, onChompKeep);
      if (containsDocumentMarker(value)) {
        if (indent === "")
          return ctx.forceBlockIndent = !0, blockString(item, ctx, onComment, onChompKeep);
        if (implicitKey && indent === indentStep)
          return quotedString(value, ctx);
      }
      let str = value.replace(/\n+/g, `$&
${indent}`);
      if (actualString) {
        let test = (tag) => tag.default && tag.tag !== "tag:yaml.org,2002:str" && tag.test?.test(str), { compat, tags } = ctx.doc.schema;
        if (tags.some(test) || compat?.some(test))
          return quotedString(value, ctx);
      }
      return implicitKey ? str : foldFlowLines.foldFlowLines(str, indent, foldFlowLines.FOLD_FLOW, getFoldOptions(ctx, !1));
    }
    function stringifyString(item, ctx, onComment, onChompKeep) {
      let { implicitKey, inFlow } = ctx, ss = typeof item.value == "string" ? item : Object.assign({}, item, { value: String(item.value) }), { type } = item;
      type !== Scalar.Scalar.QUOTE_DOUBLE && /[\x00-\x08\x0b-\x1f\x7f-\x9f\u{D800}-\u{DFFF}]/u.test(ss.value) && (type = Scalar.Scalar.QUOTE_DOUBLE);
      let _stringify = (_type) => {
        switch (_type) {
          case Scalar.Scalar.BLOCK_FOLDED:
          case Scalar.Scalar.BLOCK_LITERAL:
            return implicitKey || inFlow ? quotedString(ss.value, ctx) : blockString(ss, ctx, onComment, onChompKeep);
          case Scalar.Scalar.QUOTE_DOUBLE:
            return doubleQuotedString(ss.value, ctx);
          case Scalar.Scalar.QUOTE_SINGLE:
            return singleQuotedString(ss.value, ctx);
          case Scalar.Scalar.PLAIN:
            return plainString(ss, ctx, onComment, onChompKeep);
          default:
            return null;
        }
      }, res = _stringify(type);
      if (res === null) {
        let { defaultKeyType, defaultStringType } = ctx.options, t7 = implicitKey && defaultKeyType || defaultStringType;
        if (res = _stringify(t7), res === null)
          throw new Error(`Unsupported default string type ${t7}`);
      }
      return res;
    }
    exports.stringifyString = stringifyString;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/stringify/stringify.js
var require_stringify = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/stringify/stringify.js"(exports) {
    "use strict";
    init_cjs_shims();
    var anchors = require_anchors(), identity = require_identity(), stringifyComment = require_stringifyComment(), stringifyString = require_stringifyString();
    function createStringifyContext(doc, options) {
      let opt = Object.assign({
        blockQuote: !0,
        commentString: stringifyComment.stringifyComment,
        defaultKeyType: null,
        defaultStringType: "PLAIN",
        directives: null,
        doubleQuotedAsJSON: !1,
        doubleQuotedMinMultiLineLength: 40,
        falseStr: "false",
        flowCollectionPadding: !0,
        indentSeq: !0,
        lineWidth: 80,
        minContentWidth: 20,
        nullStr: "null",
        simpleKeys: !1,
        singleQuote: null,
        trueStr: "true",
        verifyAliasOrder: !0
      }, doc.schema.toStringOptions, options), inFlow;
      switch (opt.collectionStyle) {
        case "block":
          inFlow = !1;
          break;
        case "flow":
          inFlow = !0;
          break;
        default:
          inFlow = null;
      }
      return {
        anchors: /* @__PURE__ */ new Set(),
        doc,
        flowCollectionPadding: opt.flowCollectionPadding ? " " : "",
        indent: "",
        indentStep: typeof opt.indent == "number" ? " ".repeat(opt.indent) : "  ",
        inFlow,
        options: opt
      };
    }
    function getTagObject(tags, item) {
      if (item.tag) {
        let match2 = tags.filter((t7) => t7.tag === item.tag);
        if (match2.length > 0)
          return match2.find((t7) => t7.format === item.format) ?? match2[0];
      }
      let tagObj, obj;
      if (identity.isScalar(item)) {
        obj = item.value;
        let match2 = tags.filter((t7) => t7.identify?.(obj));
        tagObj = match2.find((t7) => t7.format === item.format) ?? match2.find((t7) => !t7.format);
      } else
        obj = item, tagObj = tags.find((t7) => t7.nodeClass && obj instanceof t7.nodeClass);
      if (!tagObj) {
        let name = obj?.constructor?.name ?? typeof obj;
        throw new Error(`Tag not resolved for ${name} value`);
      }
      return tagObj;
    }
    function stringifyProps(node, tagObj, { anchors: anchors$1, doc }) {
      if (!doc.directives)
        return "";
      let props = [], anchor = (identity.isScalar(node) || identity.isCollection(node)) && node.anchor;
      anchor && anchors.anchorIsValid(anchor) && (anchors$1.add(anchor), props.push(`&${anchor}`));
      let tag = node.tag ? node.tag : tagObj.default ? null : tagObj.tag;
      return tag && props.push(doc.directives.tagString(tag)), props.join(" ");
    }
    function stringify(item, ctx, onComment, onChompKeep) {
      if (identity.isPair(item))
        return item.toString(ctx, onComment, onChompKeep);
      if (identity.isAlias(item)) {
        if (ctx.doc.directives)
          return item.toString(ctx);
        if (ctx.resolvedAliases?.has(item))
          throw new TypeError("Cannot stringify circular structure without alias nodes");
        ctx.resolvedAliases ? ctx.resolvedAliases.add(item) : ctx.resolvedAliases = /* @__PURE__ */ new Set([item]), item = item.resolve(ctx.doc);
      }
      let tagObj, node = identity.isNode(item) ? item : ctx.doc.createNode(item, { onTagObj: (o) => tagObj = o });
      tagObj || (tagObj = getTagObject(ctx.doc.schema.tags, node));
      let props = stringifyProps(node, tagObj, ctx);
      props.length > 0 && (ctx.indentAtStart = (ctx.indentAtStart ?? 0) + props.length + 1);
      let str = typeof tagObj.stringify == "function" ? tagObj.stringify(node, ctx, onComment, onChompKeep) : identity.isScalar(node) ? stringifyString.stringifyString(node, ctx, onComment, onChompKeep) : node.toString(ctx, onComment, onChompKeep);
      return props ? identity.isScalar(node) || str[0] === "{" || str[0] === "[" ? `${props} ${str}` : `${props}
${ctx.indent}${str}` : str;
    }
    exports.createStringifyContext = createStringifyContext;
    exports.stringify = stringify;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/stringify/stringifyPair.js
var require_stringifyPair = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/stringify/stringifyPair.js"(exports) {
    "use strict";
    init_cjs_shims();
    var identity = require_identity(), Scalar = require_Scalar(), stringify = require_stringify(), stringifyComment = require_stringifyComment();
    function stringifyPair({ key, value }, ctx, onComment, onChompKeep) {
      let { allNullValues, doc, indent, indentStep, options: { commentString: commentString2, indentSeq, simpleKeys } } = ctx, keyComment = identity.isNode(key) && key.comment || null;
      if (simpleKeys) {
        if (keyComment)
          throw new Error("With simple keys, key nodes cannot have comments");
        if (identity.isCollection(key)) {
          let msg = "With simple keys, collection cannot be used as a key value";
          throw new Error(msg);
        }
      }
      let explicitKey = !simpleKeys && (!key || keyComment && value == null && !ctx.inFlow || identity.isCollection(key) || (identity.isScalar(key) ? key.type === Scalar.Scalar.BLOCK_FOLDED || key.type === Scalar.Scalar.BLOCK_LITERAL : typeof key == "object"));
      ctx = Object.assign({}, ctx, {
        allNullValues: !1,
        implicitKey: !explicitKey && (simpleKeys || !allNullValues),
        indent: indent + indentStep
      });
      let keyCommentDone = !1, chompKeep = !1, str = stringify.stringify(key, ctx, () => keyCommentDone = !0, () => chompKeep = !0);
      if (!explicitKey && !ctx.inFlow && str.length > 1024) {
        if (simpleKeys)
          throw new Error("With simple keys, single line scalar must not span more than 1024 characters");
        explicitKey = !0;
      }
      if (ctx.inFlow) {
        if (allNullValues || value == null)
          return keyCommentDone && onComment && onComment(), str === "" ? "?" : explicitKey ? `? ${str}` : str;
      } else if (allNullValues && !simpleKeys || value == null && explicitKey)
        return str = `? ${str}`, keyComment && !keyCommentDone ? str += stringifyComment.lineComment(str, ctx.indent, commentString2(keyComment)) : chompKeep && onChompKeep && onChompKeep(), str;
      keyCommentDone && (keyComment = null), explicitKey ? (keyComment && (str += stringifyComment.lineComment(str, ctx.indent, commentString2(keyComment))), str = `? ${str}
${indent}:`) : (str = `${str}:`, keyComment && (str += stringifyComment.lineComment(str, ctx.indent, commentString2(keyComment))));
      let vsb, vcb, valueComment;
      identity.isNode(value) ? (vsb = !!value.spaceBefore, vcb = value.commentBefore, valueComment = value.comment) : (vsb = !1, vcb = null, valueComment = null, value && typeof value == "object" && (value = doc.createNode(value))), ctx.implicitKey = !1, !explicitKey && !keyComment && identity.isScalar(value) && (ctx.indentAtStart = str.length + 1), chompKeep = !1, !indentSeq && indentStep.length >= 2 && !ctx.inFlow && !explicitKey && identity.isSeq(value) && !value.flow && !value.tag && !value.anchor && (ctx.indent = ctx.indent.substring(2));
      let valueCommentDone = !1, valueStr = stringify.stringify(value, ctx, () => valueCommentDone = !0, () => chompKeep = !0), ws = " ";
      if (keyComment || vsb || vcb) {
        if (ws = vsb ? `
` : "", vcb) {
          let cs = commentString2(vcb);
          ws += `
${stringifyComment.indentComment(cs, ctx.indent)}`;
        }
        valueStr === "" && !ctx.inFlow ? ws === `
` && (ws = `

`) : ws += `
${ctx.indent}`;
      } else if (!explicitKey && identity.isCollection(value)) {
        let vs0 = valueStr[0], nl0 = valueStr.indexOf(`
`), hasNewline = nl0 !== -1, flow = ctx.inFlow ?? value.flow ?? value.items.length === 0;
        if (hasNewline || !flow) {
          let hasPropsLine = !1;
          if (hasNewline && (vs0 === "&" || vs0 === "!")) {
            let sp0 = valueStr.indexOf(" ");
            vs0 === "&" && sp0 !== -1 && sp0 < nl0 && valueStr[sp0 + 1] === "!" && (sp0 = valueStr.indexOf(" ", sp0 + 1)), (sp0 === -1 || nl0 < sp0) && (hasPropsLine = !0);
          }
          hasPropsLine || (ws = `
${ctx.indent}`);
        }
      } else
        (valueStr === "" || valueStr[0] === `
`) && (ws = "");
      return str += ws + valueStr, ctx.inFlow ? valueCommentDone && onComment && onComment() : valueComment && !valueCommentDone ? str += stringifyComment.lineComment(str, ctx.indent, commentString2(valueComment)) : chompKeep && onChompKeep && onChompKeep(), str;
    }
    exports.stringifyPair = stringifyPair;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/log.js
var require_log = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/log.js"(exports) {
    "use strict";
    init_cjs_shims();
    function debug4(logLevel, ...messages) {
      logLevel === "debug" && console.log(...messages);
    }
    function warn(logLevel, warning) {
      (logLevel === "debug" || logLevel === "warn") && (typeof process < "u" && process.emitWarning ? process.emitWarning(warning) : console.warn(warning));
    }
    exports.debug = debug4;
    exports.warn = warn;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/addPairToJSMap.js
var require_addPairToJSMap = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/addPairToJSMap.js"(exports) {
    "use strict";
    init_cjs_shims();
    var log = require_log(), stringify = require_stringify(), identity = require_identity(), Scalar = require_Scalar(), toJS = require_toJS(), MERGE_KEY = "<<";
    function addPairToJSMap(ctx, map, { key, value }) {
      if (ctx?.doc.schema.merge && isMergeKey(key))
        if (value = identity.isAlias(value) ? value.resolve(ctx.doc) : value, identity.isSeq(value))
          for (let it of value.items)
            mergeToJSMap(ctx, map, it);
        else if (Array.isArray(value))
          for (let it of value)
            mergeToJSMap(ctx, map, it);
        else
          mergeToJSMap(ctx, map, value);
      else {
        let jsKey = toJS.toJS(key, "", ctx);
        if (map instanceof Map)
          map.set(jsKey, toJS.toJS(value, jsKey, ctx));
        else if (map instanceof Set)
          map.add(jsKey);
        else {
          let stringKey = stringifyKey(key, jsKey, ctx), jsValue = toJS.toJS(value, stringKey, ctx);
          stringKey in map ? Object.defineProperty(map, stringKey, {
            value: jsValue,
            writable: !0,
            enumerable: !0,
            configurable: !0
          }) : map[stringKey] = jsValue;
        }
      }
      return map;
    }
    var isMergeKey = (key) => key === MERGE_KEY || identity.isScalar(key) && key.value === MERGE_KEY && (!key.type || key.type === Scalar.Scalar.PLAIN);
    function mergeToJSMap(ctx, map, value) {
      let source = ctx && identity.isAlias(value) ? value.resolve(ctx.doc) : value;
      if (!identity.isMap(source))
        throw new Error("Merge sources must be maps or map aliases");
      let srcMap = source.toJSON(null, ctx, Map);
      for (let [key, value2] of srcMap)
        map instanceof Map ? map.has(key) || map.set(key, value2) : map instanceof Set ? map.add(key) : Object.prototype.hasOwnProperty.call(map, key) || Object.defineProperty(map, key, {
          value: value2,
          writable: !0,
          enumerable: !0,
          configurable: !0
        });
      return map;
    }
    function stringifyKey(key, jsKey, ctx) {
      if (jsKey === null)
        return "";
      if (typeof jsKey != "object")
        return String(jsKey);
      if (identity.isNode(key) && ctx?.doc) {
        let strCtx = stringify.createStringifyContext(ctx.doc, {});
        strCtx.anchors = /* @__PURE__ */ new Set();
        for (let node of ctx.anchors.keys())
          strCtx.anchors.add(node.anchor);
        strCtx.inFlow = !0, strCtx.inStringifyKey = !0;
        let strKey = key.toString(strCtx);
        if (!ctx.mapKeyWarned) {
          let jsonStr = JSON.stringify(strKey);
          jsonStr.length > 40 && (jsonStr = jsonStr.substring(0, 36) + '..."'), log.warn(ctx.doc.options.logLevel, `Keys with collection values will be stringified due to JS Object restrictions: ${jsonStr}. Set mapAsMap: true to use object keys.`), ctx.mapKeyWarned = !0;
        }
        return strKey;
      }
      return JSON.stringify(jsKey);
    }
    exports.addPairToJSMap = addPairToJSMap;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/Pair.js
var require_Pair = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/Pair.js"(exports) {
    "use strict";
    init_cjs_shims();
    var createNode = require_createNode(), stringifyPair = require_stringifyPair(), addPairToJSMap = require_addPairToJSMap(), identity = require_identity();
    function createPair(key, value, ctx) {
      let k = createNode.createNode(key, void 0, ctx), v = createNode.createNode(value, void 0, ctx);
      return new Pair(k, v);
    }
    var Pair = class _Pair {
      constructor(key, value = null) {
        Object.defineProperty(this, identity.NODE_TYPE, { value: identity.PAIR }), this.key = key, this.value = value;
      }
      clone(schema) {
        let { key, value } = this;
        return identity.isNode(key) && (key = key.clone(schema)), identity.isNode(value) && (value = value.clone(schema)), new _Pair(key, value);
      }
      toJSON(_2, ctx) {
        let pair = ctx?.mapAsMap ? /* @__PURE__ */ new Map() : {};
        return addPairToJSMap.addPairToJSMap(ctx, pair, this);
      }
      toString(ctx, onComment, onChompKeep) {
        return ctx?.doc ? stringifyPair.stringifyPair(this, ctx, onComment, onChompKeep) : JSON.stringify(this);
      }
    };
    exports.Pair = Pair;
    exports.createPair = createPair;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/stringify/stringifyCollection.js
var require_stringifyCollection = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/stringify/stringifyCollection.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Collection = require_Collection(), identity = require_identity(), stringify = require_stringify(), stringifyComment = require_stringifyComment();
    function stringifyCollection(collection, ctx, options) {
      return (ctx.inFlow ?? collection.flow ? stringifyFlowCollection : stringifyBlockCollection)(collection, ctx, options);
    }
    function stringifyBlockCollection({ comment, items }, ctx, { blockItemPrefix, flowChars, itemIndent, onChompKeep, onComment }) {
      let { indent, options: { commentString: commentString2 } } = ctx, itemCtx = Object.assign({}, ctx, { indent: itemIndent, type: null }), chompKeep = !1, lines = [];
      for (let i = 0; i < items.length; ++i) {
        let item = items[i], comment2 = null;
        if (identity.isNode(item))
          !chompKeep && item.spaceBefore && lines.push(""), addCommentBefore(ctx, lines, item.commentBefore, chompKeep), item.comment && (comment2 = item.comment);
        else if (identity.isPair(item)) {
          let ik = identity.isNode(item.key) ? item.key : null;
          ik && (!chompKeep && ik.spaceBefore && lines.push(""), addCommentBefore(ctx, lines, ik.commentBefore, chompKeep));
        }
        chompKeep = !1;
        let str2 = stringify.stringify(item, itemCtx, () => comment2 = null, () => chompKeep = !0);
        comment2 && (str2 += stringifyComment.lineComment(str2, itemIndent, commentString2(comment2))), chompKeep && comment2 && (chompKeep = !1), lines.push(blockItemPrefix + str2);
      }
      let str;
      if (lines.length === 0)
        str = flowChars.start + flowChars.end;
      else {
        str = lines[0];
        for (let i = 1; i < lines.length; ++i) {
          let line = lines[i];
          str += line ? `
${indent}${line}` : `
`;
        }
      }
      return comment ? (str += `
` + stringifyComment.indentComment(commentString2(comment), indent), onComment && onComment()) : chompKeep && onChompKeep && onChompKeep(), str;
    }
    function stringifyFlowCollection({ comment, items }, ctx, { flowChars, itemIndent, onComment }) {
      let { indent, indentStep, flowCollectionPadding: fcPadding, options: { commentString: commentString2 } } = ctx;
      itemIndent += indentStep;
      let itemCtx = Object.assign({}, ctx, {
        indent: itemIndent,
        inFlow: !0,
        type: null
      }), reqNewline = !1, linesAtValue = 0, lines = [];
      for (let i = 0; i < items.length; ++i) {
        let item = items[i], comment2 = null;
        if (identity.isNode(item))
          item.spaceBefore && lines.push(""), addCommentBefore(ctx, lines, item.commentBefore, !1), item.comment && (comment2 = item.comment);
        else if (identity.isPair(item)) {
          let ik = identity.isNode(item.key) ? item.key : null;
          ik && (ik.spaceBefore && lines.push(""), addCommentBefore(ctx, lines, ik.commentBefore, !1), ik.comment && (reqNewline = !0));
          let iv = identity.isNode(item.value) ? item.value : null;
          iv ? (iv.comment && (comment2 = iv.comment), iv.commentBefore && (reqNewline = !0)) : item.value == null && ik?.comment && (comment2 = ik.comment);
        }
        comment2 && (reqNewline = !0);
        let str2 = stringify.stringify(item, itemCtx, () => comment2 = null);
        i < items.length - 1 && (str2 += ","), comment2 && (str2 += stringifyComment.lineComment(str2, itemIndent, commentString2(comment2))), !reqNewline && (lines.length > linesAtValue || str2.includes(`
`)) && (reqNewline = !0), lines.push(str2), linesAtValue = lines.length;
      }
      let str, { start, end } = flowChars;
      if (lines.length === 0)
        str = start + end;
      else if (reqNewline || (reqNewline = lines.reduce((sum, line) => sum + line.length + 2, 2) > Collection.Collection.maxFlowStringSingleLineLength), reqNewline) {
        str = start;
        for (let line of lines)
          str += line ? `
${indentStep}${indent}${line}` : `
`;
        str += `
${indent}${end}`;
      } else
        str = `${start}${fcPadding}${lines.join(" ")}${fcPadding}${end}`;
      return comment && (str += stringifyComment.lineComment(str, indent, commentString2(comment)), onComment && onComment()), str;
    }
    function addCommentBefore({ indent, options: { commentString: commentString2 } }, lines, comment, chompKeep) {
      if (comment && chompKeep && (comment = comment.replace(/^\n+/, "")), comment) {
        let ic = stringifyComment.indentComment(commentString2(comment), indent);
        lines.push(ic.trimStart());
      }
    }
    exports.stringifyCollection = stringifyCollection;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/YAMLMap.js
var require_YAMLMap = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/YAMLMap.js"(exports) {
    "use strict";
    init_cjs_shims();
    var stringifyCollection = require_stringifyCollection(), addPairToJSMap = require_addPairToJSMap(), Collection = require_Collection(), identity = require_identity(), Pair = require_Pair(), Scalar = require_Scalar();
    function findPair(items, key) {
      let k = identity.isScalar(key) ? key.value : key;
      for (let it of items)
        if (identity.isPair(it) && (it.key === key || it.key === k || identity.isScalar(it.key) && it.key.value === k))
          return it;
    }
    var YAMLMap = class extends Collection.Collection {
      static get tagName() {
        return "tag:yaml.org,2002:map";
      }
      constructor(schema) {
        super(identity.MAP, schema), this.items = [];
      }
      /**
       * A generic collection parsing method that can be extended
       * to other node classes that inherit from YAMLMap
       */
      static from(schema, obj, ctx) {
        let { keepUndefined, replacer } = ctx, map = new this(schema), add = (key, value) => {
          if (typeof replacer == "function")
            value = replacer.call(obj, key, value);
          else if (Array.isArray(replacer) && !replacer.includes(key))
            return;
          (value !== void 0 || keepUndefined) && map.items.push(Pair.createPair(key, value, ctx));
        };
        if (obj instanceof Map)
          for (let [key, value] of obj)
            add(key, value);
        else if (obj && typeof obj == "object")
          for (let key of Object.keys(obj))
            add(key, obj[key]);
        return typeof schema.sortMapEntries == "function" && map.items.sort(schema.sortMapEntries), map;
      }
      /**
       * Adds a value to the collection.
       *
       * @param overwrite - If not set `true`, using a key that is already in the
       *   collection will throw. Otherwise, overwrites the previous value.
       */
      add(pair, overwrite) {
        let _pair;
        identity.isPair(pair) ? _pair = pair : !pair || typeof pair != "object" || !("key" in pair) ? _pair = new Pair.Pair(pair, pair?.value) : _pair = new Pair.Pair(pair.key, pair.value);
        let prev = findPair(this.items, _pair.key), sortEntries = this.schema?.sortMapEntries;
        if (prev) {
          if (!overwrite)
            throw new Error(`Key ${_pair.key} already set`);
          identity.isScalar(prev.value) && Scalar.isScalarValue(_pair.value) ? prev.value.value = _pair.value : prev.value = _pair.value;
        } else if (sortEntries) {
          let i = this.items.findIndex((item) => sortEntries(_pair, item) < 0);
          i === -1 ? this.items.push(_pair) : this.items.splice(i, 0, _pair);
        } else
          this.items.push(_pair);
      }
      delete(key) {
        let it = findPair(this.items, key);
        return it ? this.items.splice(this.items.indexOf(it), 1).length > 0 : !1;
      }
      get(key, keepScalar) {
        let node = findPair(this.items, key)?.value;
        return (!keepScalar && identity.isScalar(node) ? node.value : node) ?? void 0;
      }
      has(key) {
        return !!findPair(this.items, key);
      }
      set(key, value) {
        this.add(new Pair.Pair(key, value), !0);
      }
      /**
       * @param ctx - Conversion context, originally set in Document#toJS()
       * @param {Class} Type - If set, forces the returned collection type
       * @returns Instance of Type, Map, or Object
       */
      toJSON(_2, ctx, Type) {
        let map = Type ? new Type() : ctx?.mapAsMap ? /* @__PURE__ */ new Map() : {};
        ctx?.onCreate && ctx.onCreate(map);
        for (let item of this.items)
          addPairToJSMap.addPairToJSMap(ctx, map, item);
        return map;
      }
      toString(ctx, onComment, onChompKeep) {
        if (!ctx)
          return JSON.stringify(this);
        for (let item of this.items)
          if (!identity.isPair(item))
            throw new Error(`Map items must all be pairs; found ${JSON.stringify(item)} instead`);
        return !ctx.allNullValues && this.hasAllNullValues(!1) && (ctx = Object.assign({}, ctx, { allNullValues: !0 })), stringifyCollection.stringifyCollection(this, ctx, {
          blockItemPrefix: "",
          flowChars: { start: "{", end: "}" },
          itemIndent: ctx.indent || "",
          onChompKeep,
          onComment
        });
      }
    };
    exports.YAMLMap = YAMLMap;
    exports.findPair = findPair;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/common/map.js
var require_map = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/common/map.js"(exports) {
    "use strict";
    init_cjs_shims();
    var identity = require_identity(), YAMLMap = require_YAMLMap(), map = {
      collection: "map",
      default: !0,
      nodeClass: YAMLMap.YAMLMap,
      tag: "tag:yaml.org,2002:map",
      resolve(map2, onError) {
        return identity.isMap(map2) || onError("Expected a mapping for this tag"), map2;
      },
      createNode: (schema, obj, ctx) => YAMLMap.YAMLMap.from(schema, obj, ctx)
    };
    exports.map = map;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/YAMLSeq.js
var require_YAMLSeq = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/nodes/YAMLSeq.js"(exports) {
    "use strict";
    init_cjs_shims();
    var createNode = require_createNode(), stringifyCollection = require_stringifyCollection(), Collection = require_Collection(), identity = require_identity(), Scalar = require_Scalar(), toJS = require_toJS(), YAMLSeq = class extends Collection.Collection {
      static get tagName() {
        return "tag:yaml.org,2002:seq";
      }
      constructor(schema) {
        super(identity.SEQ, schema), this.items = [];
      }
      add(value) {
        this.items.push(value);
      }
      /**
       * Removes a value from the collection.
       *
       * `key` must contain a representation of an integer for this to succeed.
       * It may be wrapped in a `Scalar`.
       *
       * @returns `true` if the item was found and removed.
       */
      delete(key) {
        let idx = asItemIndex(key);
        return typeof idx != "number" ? !1 : this.items.splice(idx, 1).length > 0;
      }
      get(key, keepScalar) {
        let idx = asItemIndex(key);
        if (typeof idx != "number")
          return;
        let it = this.items[idx];
        return !keepScalar && identity.isScalar(it) ? it.value : it;
      }
      /**
       * Checks if the collection includes a value with the key `key`.
       *
       * `key` must contain a representation of an integer for this to succeed.
       * It may be wrapped in a `Scalar`.
       */
      has(key) {
        let idx = asItemIndex(key);
        return typeof idx == "number" && idx < this.items.length;
      }
      /**
       * Sets a value in this collection. For `!!set`, `value` needs to be a
       * boolean to add/remove the item from the set.
       *
       * If `key` does not contain a representation of an integer, this will throw.
       * It may be wrapped in a `Scalar`.
       */
      set(key, value) {
        let idx = asItemIndex(key);
        if (typeof idx != "number")
          throw new Error(`Expected a valid index, not ${key}.`);
        let prev = this.items[idx];
        identity.isScalar(prev) && Scalar.isScalarValue(value) ? prev.value = value : this.items[idx] = value;
      }
      toJSON(_2, ctx) {
        let seq = [];
        ctx?.onCreate && ctx.onCreate(seq);
        let i = 0;
        for (let item of this.items)
          seq.push(toJS.toJS(item, String(i++), ctx));
        return seq;
      }
      toString(ctx, onComment, onChompKeep) {
        return ctx ? stringifyCollection.stringifyCollection(this, ctx, {
          blockItemPrefix: "- ",
          flowChars: { start: "[", end: "]" },
          itemIndent: (ctx.indent || "") + "  ",
          onChompKeep,
          onComment
        }) : JSON.stringify(this);
      }
      static from(schema, obj, ctx) {
        let { replacer } = ctx, seq = new this(schema);
        if (obj && Symbol.iterator in Object(obj)) {
          let i = 0;
          for (let it of obj) {
            if (typeof replacer == "function") {
              let key = obj instanceof Set ? it : String(i++);
              it = replacer.call(obj, key, it);
            }
            seq.items.push(createNode.createNode(it, void 0, ctx));
          }
        }
        return seq;
      }
    };
    function asItemIndex(key) {
      let idx = identity.isScalar(key) ? key.value : key;
      return idx && typeof idx == "string" && (idx = Number(idx)), typeof idx == "number" && Number.isInteger(idx) && idx >= 0 ? idx : null;
    }
    exports.YAMLSeq = YAMLSeq;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/common/seq.js
var require_seq = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/common/seq.js"(exports) {
    "use strict";
    init_cjs_shims();
    var identity = require_identity(), YAMLSeq = require_YAMLSeq(), seq = {
      collection: "seq",
      default: !0,
      nodeClass: YAMLSeq.YAMLSeq,
      tag: "tag:yaml.org,2002:seq",
      resolve(seq2, onError) {
        return identity.isSeq(seq2) || onError("Expected a sequence for this tag"), seq2;
      },
      createNode: (schema, obj, ctx) => YAMLSeq.YAMLSeq.from(schema, obj, ctx)
    };
    exports.seq = seq;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/common/string.js
var require_string = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/common/string.js"(exports) {
    "use strict";
    init_cjs_shims();
    var stringifyString = require_stringifyString(), string = {
      identify: (value) => typeof value == "string",
      default: !0,
      tag: "tag:yaml.org,2002:str",
      resolve: (str) => str,
      stringify(item, ctx, onComment, onChompKeep) {
        return ctx = Object.assign({ actualString: !0 }, ctx), stringifyString.stringifyString(item, ctx, onComment, onChompKeep);
      }
    };
    exports.string = string;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/common/null.js
var require_null = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/common/null.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Scalar = require_Scalar(), nullTag = {
      identify: (value) => value == null,
      createNode: () => new Scalar.Scalar(null),
      default: !0,
      tag: "tag:yaml.org,2002:null",
      test: /^(?:~|[Nn]ull|NULL)?$/,
      resolve: () => new Scalar.Scalar(null),
      stringify: ({ source }, ctx) => typeof source == "string" && nullTag.test.test(source) ? source : ctx.options.nullStr
    };
    exports.nullTag = nullTag;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/core/bool.js
var require_bool = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/core/bool.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Scalar = require_Scalar(), boolTag = {
      identify: (value) => typeof value == "boolean",
      default: !0,
      tag: "tag:yaml.org,2002:bool",
      test: /^(?:[Tt]rue|TRUE|[Ff]alse|FALSE)$/,
      resolve: (str) => new Scalar.Scalar(str[0] === "t" || str[0] === "T"),
      stringify({ source, value }, ctx) {
        if (source && boolTag.test.test(source)) {
          let sv = source[0] === "t" || source[0] === "T";
          if (value === sv)
            return source;
        }
        return value ? ctx.options.trueStr : ctx.options.falseStr;
      }
    };
    exports.boolTag = boolTag;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/stringify/stringifyNumber.js
var require_stringifyNumber = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/stringify/stringifyNumber.js"(exports) {
    "use strict";
    init_cjs_shims();
    function stringifyNumber({ format: format4, minFractionDigits, tag, value }) {
      if (typeof value == "bigint")
        return String(value);
      let num = typeof value == "number" ? value : Number(value);
      if (!isFinite(num))
        return isNaN(num) ? ".nan" : num < 0 ? "-.inf" : ".inf";
      let n = JSON.stringify(value);
      if (!format4 && minFractionDigits && (!tag || tag === "tag:yaml.org,2002:float") && /^\d/.test(n)) {
        let i = n.indexOf(".");
        i < 0 && (i = n.length, n += ".");
        let d = minFractionDigits - (n.length - i - 1);
        for (; d-- > 0; )
          n += "0";
      }
      return n;
    }
    exports.stringifyNumber = stringifyNumber;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/core/float.js
var require_float = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/core/float.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Scalar = require_Scalar(), stringifyNumber = require_stringifyNumber(), floatNaN = {
      identify: (value) => typeof value == "number",
      default: !0,
      tag: "tag:yaml.org,2002:float",
      test: /^(?:[-+]?\.(?:inf|Inf|INF|nan|NaN|NAN))$/,
      resolve: (str) => str.slice(-3).toLowerCase() === "nan" ? NaN : str[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY,
      stringify: stringifyNumber.stringifyNumber
    }, floatExp = {
      identify: (value) => typeof value == "number",
      default: !0,
      tag: "tag:yaml.org,2002:float",
      format: "EXP",
      test: /^[-+]?(?:\.[0-9]+|[0-9]+(?:\.[0-9]*)?)[eE][-+]?[0-9]+$/,
      resolve: (str) => parseFloat(str),
      stringify(node) {
        let num = Number(node.value);
        return isFinite(num) ? num.toExponential() : stringifyNumber.stringifyNumber(node);
      }
    }, float = {
      identify: (value) => typeof value == "number",
      default: !0,
      tag: "tag:yaml.org,2002:float",
      test: /^[-+]?(?:\.[0-9]+|[0-9]+\.[0-9]*)$/,
      resolve(str) {
        let node = new Scalar.Scalar(parseFloat(str)), dot = str.indexOf(".");
        return dot !== -1 && str[str.length - 1] === "0" && (node.minFractionDigits = str.length - dot - 1), node;
      },
      stringify: stringifyNumber.stringifyNumber
    };
    exports.float = float;
    exports.floatExp = floatExp;
    exports.floatNaN = floatNaN;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/core/int.js
var require_int = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/core/int.js"(exports) {
    "use strict";
    init_cjs_shims();
    var stringifyNumber = require_stringifyNumber(), intIdentify = (value) => typeof value == "bigint" || Number.isInteger(value), intResolve = (str, offset, radix, { intAsBigInt }) => intAsBigInt ? BigInt(str) : parseInt(str.substring(offset), radix);
    function intStringify(node, radix, prefix) {
      let { value } = node;
      return intIdentify(value) && value >= 0 ? prefix + value.toString(radix) : stringifyNumber.stringifyNumber(node);
    }
    var intOct = {
      identify: (value) => intIdentify(value) && value >= 0,
      default: !0,
      tag: "tag:yaml.org,2002:int",
      format: "OCT",
      test: /^0o[0-7]+$/,
      resolve: (str, _onError, opt) => intResolve(str, 2, 8, opt),
      stringify: (node) => intStringify(node, 8, "0o")
    }, int = {
      identify: intIdentify,
      default: !0,
      tag: "tag:yaml.org,2002:int",
      test: /^[-+]?[0-9]+$/,
      resolve: (str, _onError, opt) => intResolve(str, 0, 10, opt),
      stringify: stringifyNumber.stringifyNumber
    }, intHex = {
      identify: (value) => intIdentify(value) && value >= 0,
      default: !0,
      tag: "tag:yaml.org,2002:int",
      format: "HEX",
      test: /^0x[0-9a-fA-F]+$/,
      resolve: (str, _onError, opt) => intResolve(str, 2, 16, opt),
      stringify: (node) => intStringify(node, 16, "0x")
    };
    exports.int = int;
    exports.intHex = intHex;
    exports.intOct = intOct;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/core/schema.js
var require_schema = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/core/schema.js"(exports) {
    "use strict";
    init_cjs_shims();
    var map = require_map(), _null = require_null(), seq = require_seq(), string = require_string(), bool = require_bool(), float = require_float(), int = require_int(), schema = [
      map.map,
      seq.seq,
      string.string,
      _null.nullTag,
      bool.boolTag,
      int.intOct,
      int.int,
      int.intHex,
      float.floatNaN,
      float.floatExp,
      float.float
    ];
    exports.schema = schema;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/json/schema.js
var require_schema2 = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/json/schema.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Scalar = require_Scalar(), map = require_map(), seq = require_seq();
    function intIdentify(value) {
      return typeof value == "bigint" || Number.isInteger(value);
    }
    var stringifyJSON = ({ value }) => JSON.stringify(value), jsonScalars = [
      {
        identify: (value) => typeof value == "string",
        default: !0,
        tag: "tag:yaml.org,2002:str",
        resolve: (str) => str,
        stringify: stringifyJSON
      },
      {
        identify: (value) => value == null,
        createNode: () => new Scalar.Scalar(null),
        default: !0,
        tag: "tag:yaml.org,2002:null",
        test: /^null$/,
        resolve: () => null,
        stringify: stringifyJSON
      },
      {
        identify: (value) => typeof value == "boolean",
        default: !0,
        tag: "tag:yaml.org,2002:bool",
        test: /^true|false$/,
        resolve: (str) => str === "true",
        stringify: stringifyJSON
      },
      {
        identify: intIdentify,
        default: !0,
        tag: "tag:yaml.org,2002:int",
        test: /^-?(?:0|[1-9][0-9]*)$/,
        resolve: (str, _onError, { intAsBigInt }) => intAsBigInt ? BigInt(str) : parseInt(str, 10),
        stringify: ({ value }) => intIdentify(value) ? value.toString() : JSON.stringify(value)
      },
      {
        identify: (value) => typeof value == "number",
        default: !0,
        tag: "tag:yaml.org,2002:float",
        test: /^-?(?:0|[1-9][0-9]*)(?:\.[0-9]*)?(?:[eE][-+]?[0-9]+)?$/,
        resolve: (str) => parseFloat(str),
        stringify: stringifyJSON
      }
    ], jsonError = {
      default: !0,
      tag: "",
      test: /^/,
      resolve(str, onError) {
        return onError(`Unresolved plain scalar ${JSON.stringify(str)}`), str;
      }
    }, schema = [map.map, seq.seq].concat(jsonScalars, jsonError);
    exports.schema = schema;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/binary.js
var require_binary = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/binary.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Scalar = require_Scalar(), stringifyString = require_stringifyString(), binary = {
      identify: (value) => value instanceof Uint8Array,
      default: !1,
      tag: "tag:yaml.org,2002:binary",
      /**
       * Returns a Buffer in node and an Uint8Array in browsers
       *
       * To use the resulting buffer as an image, you'll want to do something like:
       *
       *   const blob = new Blob([buffer], { type: 'image/jpeg' })
       *   document.querySelector('#photo').src = URL.createObjectURL(blob)
       */
      resolve(src, onError) {
        if (typeof Buffer == "function")
          return Buffer.from(src, "base64");
        if (typeof atob == "function") {
          let str = atob(src.replace(/[\n\r]/g, "")), buffer = new Uint8Array(str.length);
          for (let i = 0; i < str.length; ++i)
            buffer[i] = str.charCodeAt(i);
          return buffer;
        } else
          return onError("This environment does not support reading binary tags; either Buffer or atob is required"), src;
      },
      stringify({ comment, type, value }, ctx, onComment, onChompKeep) {
        let buf = value, str;
        if (typeof Buffer == "function")
          str = buf instanceof Buffer ? buf.toString("base64") : Buffer.from(buf.buffer).toString("base64");
        else if (typeof btoa == "function") {
          let s = "";
          for (let i = 0; i < buf.length; ++i)
            s += String.fromCharCode(buf[i]);
          str = btoa(s);
        } else
          throw new Error("This environment does not support writing binary tags; either Buffer or btoa is required");
        if (type || (type = Scalar.Scalar.BLOCK_LITERAL), type !== Scalar.Scalar.QUOTE_DOUBLE) {
          let lineWidth = Math.max(ctx.options.lineWidth - ctx.indent.length, ctx.options.minContentWidth), n = Math.ceil(str.length / lineWidth), lines = new Array(n);
          for (let i = 0, o = 0; i < n; ++i, o += lineWidth)
            lines[i] = str.substr(o, lineWidth);
          str = lines.join(type === Scalar.Scalar.BLOCK_LITERAL ? `
` : " ");
        }
        return stringifyString.stringifyString({ comment, type, value: str }, ctx, onComment, onChompKeep);
      }
    };
    exports.binary = binary;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/pairs.js
var require_pairs = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/pairs.js"(exports) {
    "use strict";
    init_cjs_shims();
    var identity = require_identity(), Pair = require_Pair(), Scalar = require_Scalar(), YAMLSeq = require_YAMLSeq();
    function resolvePairs(seq, onError) {
      if (identity.isSeq(seq))
        for (let i = 0; i < seq.items.length; ++i) {
          let item = seq.items[i];
          if (!identity.isPair(item)) {
            if (identity.isMap(item)) {
              item.items.length > 1 && onError("Each pair must have its own sequence indicator");
              let pair = item.items[0] || new Pair.Pair(new Scalar.Scalar(null));
              if (item.commentBefore && (pair.key.commentBefore = pair.key.commentBefore ? `${item.commentBefore}
${pair.key.commentBefore}` : item.commentBefore), item.comment) {
                let cn = pair.value ?? pair.key;
                cn.comment = cn.comment ? `${item.comment}
${cn.comment}` : item.comment;
              }
              item = pair;
            }
            seq.items[i] = identity.isPair(item) ? item : new Pair.Pair(item);
          }
        }
      else
        onError("Expected a sequence for this tag");
      return seq;
    }
    function createPairs(schema, iterable, ctx) {
      let { replacer } = ctx, pairs2 = new YAMLSeq.YAMLSeq(schema);
      pairs2.tag = "tag:yaml.org,2002:pairs";
      let i = 0;
      if (iterable && Symbol.iterator in Object(iterable))
        for (let it of iterable) {
          typeof replacer == "function" && (it = replacer.call(iterable, String(i++), it));
          let key, value;
          if (Array.isArray(it))
            if (it.length === 2)
              key = it[0], value = it[1];
            else
              throw new TypeError(`Expected [key, value] tuple: ${it}`);
          else if (it && it instanceof Object) {
            let keys = Object.keys(it);
            if (keys.length === 1)
              key = keys[0], value = it[key];
            else
              throw new TypeError(`Expected tuple with one key, not ${keys.length} keys`);
          } else
            key = it;
          pairs2.items.push(Pair.createPair(key, value, ctx));
        }
      return pairs2;
    }
    var pairs = {
      collection: "seq",
      default: !1,
      tag: "tag:yaml.org,2002:pairs",
      resolve: resolvePairs,
      createNode: createPairs
    };
    exports.createPairs = createPairs;
    exports.pairs = pairs;
    exports.resolvePairs = resolvePairs;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/omap.js
var require_omap = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/omap.js"(exports) {
    "use strict";
    init_cjs_shims();
    var identity = require_identity(), toJS = require_toJS(), YAMLMap = require_YAMLMap(), YAMLSeq = require_YAMLSeq(), pairs = require_pairs(), YAMLOMap = class _YAMLOMap extends YAMLSeq.YAMLSeq {
      constructor() {
        super(), this.add = YAMLMap.YAMLMap.prototype.add.bind(this), this.delete = YAMLMap.YAMLMap.prototype.delete.bind(this), this.get = YAMLMap.YAMLMap.prototype.get.bind(this), this.has = YAMLMap.YAMLMap.prototype.has.bind(this), this.set = YAMLMap.YAMLMap.prototype.set.bind(this), this.tag = _YAMLOMap.tag;
      }
      /**
       * If `ctx` is given, the return type is actually `Map<unknown, unknown>`,
       * but TypeScript won't allow widening the signature of a child method.
       */
      toJSON(_2, ctx) {
        if (!ctx)
          return super.toJSON(_2);
        let map = /* @__PURE__ */ new Map();
        ctx?.onCreate && ctx.onCreate(map);
        for (let pair of this.items) {
          let key, value;
          if (identity.isPair(pair) ? (key = toJS.toJS(pair.key, "", ctx), value = toJS.toJS(pair.value, key, ctx)) : key = toJS.toJS(pair, "", ctx), map.has(key))
            throw new Error("Ordered maps must not include duplicate keys");
          map.set(key, value);
        }
        return map;
      }
      static from(schema, iterable, ctx) {
        let pairs$1 = pairs.createPairs(schema, iterable, ctx), omap2 = new this();
        return omap2.items = pairs$1.items, omap2;
      }
    };
    YAMLOMap.tag = "tag:yaml.org,2002:omap";
    var omap = {
      collection: "seq",
      identify: (value) => value instanceof Map,
      nodeClass: YAMLOMap,
      default: !1,
      tag: "tag:yaml.org,2002:omap",
      resolve(seq, onError) {
        let pairs$1 = pairs.resolvePairs(seq, onError), seenKeys = [];
        for (let { key } of pairs$1.items)
          identity.isScalar(key) && (seenKeys.includes(key.value) ? onError(`Ordered maps must not include duplicate keys: ${key.value}`) : seenKeys.push(key.value));
        return Object.assign(new YAMLOMap(), pairs$1);
      },
      createNode: (schema, iterable, ctx) => YAMLOMap.from(schema, iterable, ctx)
    };
    exports.YAMLOMap = YAMLOMap;
    exports.omap = omap;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/bool.js
var require_bool2 = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/bool.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Scalar = require_Scalar();
    function boolStringify({ value, source }, ctx) {
      return source && (value ? trueTag : falseTag).test.test(source) ? source : value ? ctx.options.trueStr : ctx.options.falseStr;
    }
    var trueTag = {
      identify: (value) => value === !0,
      default: !0,
      tag: "tag:yaml.org,2002:bool",
      test: /^(?:Y|y|[Yy]es|YES|[Tt]rue|TRUE|[Oo]n|ON)$/,
      resolve: () => new Scalar.Scalar(!0),
      stringify: boolStringify
    }, falseTag = {
      identify: (value) => value === !1,
      default: !0,
      tag: "tag:yaml.org,2002:bool",
      test: /^(?:N|n|[Nn]o|NO|[Ff]alse|FALSE|[Oo]ff|OFF)$/i,
      resolve: () => new Scalar.Scalar(!1),
      stringify: boolStringify
    };
    exports.falseTag = falseTag;
    exports.trueTag = trueTag;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/float.js
var require_float2 = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/float.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Scalar = require_Scalar(), stringifyNumber = require_stringifyNumber(), floatNaN = {
      identify: (value) => typeof value == "number",
      default: !0,
      tag: "tag:yaml.org,2002:float",
      test: /^[-+]?\.(?:inf|Inf|INF|nan|NaN|NAN)$/,
      resolve: (str) => str.slice(-3).toLowerCase() === "nan" ? NaN : str[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY,
      stringify: stringifyNumber.stringifyNumber
    }, floatExp = {
      identify: (value) => typeof value == "number",
      default: !0,
      tag: "tag:yaml.org,2002:float",
      format: "EXP",
      test: /^[-+]?(?:[0-9][0-9_]*)?(?:\.[0-9_]*)?[eE][-+]?[0-9]+$/,
      resolve: (str) => parseFloat(str.replace(/_/g, "")),
      stringify(node) {
        let num = Number(node.value);
        return isFinite(num) ? num.toExponential() : stringifyNumber.stringifyNumber(node);
      }
    }, float = {
      identify: (value) => typeof value == "number",
      default: !0,
      tag: "tag:yaml.org,2002:float",
      test: /^[-+]?(?:[0-9][0-9_]*)?\.[0-9_]*$/,
      resolve(str) {
        let node = new Scalar.Scalar(parseFloat(str.replace(/_/g, ""))), dot = str.indexOf(".");
        if (dot !== -1) {
          let f = str.substring(dot + 1).replace(/_/g, "");
          f[f.length - 1] === "0" && (node.minFractionDigits = f.length);
        }
        return node;
      },
      stringify: stringifyNumber.stringifyNumber
    };
    exports.float = float;
    exports.floatExp = floatExp;
    exports.floatNaN = floatNaN;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/int.js
var require_int2 = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/int.js"(exports) {
    "use strict";
    init_cjs_shims();
    var stringifyNumber = require_stringifyNumber(), intIdentify = (value) => typeof value == "bigint" || Number.isInteger(value);
    function intResolve(str, offset, radix, { intAsBigInt }) {
      let sign = str[0];
      if ((sign === "-" || sign === "+") && (offset += 1), str = str.substring(offset).replace(/_/g, ""), intAsBigInt) {
        switch (radix) {
          case 2:
            str = `0b${str}`;
            break;
          case 8:
            str = `0o${str}`;
            break;
          case 16:
            str = `0x${str}`;
            break;
        }
        let n2 = BigInt(str);
        return sign === "-" ? BigInt(-1) * n2 : n2;
      }
      let n = parseInt(str, radix);
      return sign === "-" ? -1 * n : n;
    }
    function intStringify(node, radix, prefix) {
      let { value } = node;
      if (intIdentify(value)) {
        let str = value.toString(radix);
        return value < 0 ? "-" + prefix + str.substr(1) : prefix + str;
      }
      return stringifyNumber.stringifyNumber(node);
    }
    var intBin = {
      identify: intIdentify,
      default: !0,
      tag: "tag:yaml.org,2002:int",
      format: "BIN",
      test: /^[-+]?0b[0-1_]+$/,
      resolve: (str, _onError, opt) => intResolve(str, 2, 2, opt),
      stringify: (node) => intStringify(node, 2, "0b")
    }, intOct = {
      identify: intIdentify,
      default: !0,
      tag: "tag:yaml.org,2002:int",
      format: "OCT",
      test: /^[-+]?0[0-7_]+$/,
      resolve: (str, _onError, opt) => intResolve(str, 1, 8, opt),
      stringify: (node) => intStringify(node, 8, "0")
    }, int = {
      identify: intIdentify,
      default: !0,
      tag: "tag:yaml.org,2002:int",
      test: /^[-+]?[0-9][0-9_]*$/,
      resolve: (str, _onError, opt) => intResolve(str, 0, 10, opt),
      stringify: stringifyNumber.stringifyNumber
    }, intHex = {
      identify: intIdentify,
      default: !0,
      tag: "tag:yaml.org,2002:int",
      format: "HEX",
      test: /^[-+]?0x[0-9a-fA-F_]+$/,
      resolve: (str, _onError, opt) => intResolve(str, 2, 16, opt),
      stringify: (node) => intStringify(node, 16, "0x")
    };
    exports.int = int;
    exports.intBin = intBin;
    exports.intHex = intHex;
    exports.intOct = intOct;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/set.js
var require_set2 = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/set.js"(exports) {
    "use strict";
    init_cjs_shims();
    var identity = require_identity(), Pair = require_Pair(), YAMLMap = require_YAMLMap(), YAMLSet = class _YAMLSet extends YAMLMap.YAMLMap {
      constructor(schema) {
        super(schema), this.tag = _YAMLSet.tag;
      }
      add(key) {
        let pair;
        identity.isPair(key) ? pair = key : key && typeof key == "object" && "key" in key && "value" in key && key.value === null ? pair = new Pair.Pair(key.key, null) : pair = new Pair.Pair(key, null), YAMLMap.findPair(this.items, pair.key) || this.items.push(pair);
      }
      /**
       * If `keepPair` is `true`, returns the Pair matching `key`.
       * Otherwise, returns the value of that Pair's key.
       */
      get(key, keepPair) {
        let pair = YAMLMap.findPair(this.items, key);
        return !keepPair && identity.isPair(pair) ? identity.isScalar(pair.key) ? pair.key.value : pair.key : pair;
      }
      set(key, value) {
        if (typeof value != "boolean")
          throw new Error(`Expected boolean value for set(key, value) in a YAML set, not ${typeof value}`);
        let prev = YAMLMap.findPair(this.items, key);
        prev && !value ? this.items.splice(this.items.indexOf(prev), 1) : !prev && value && this.items.push(new Pair.Pair(key));
      }
      toJSON(_2, ctx) {
        return super.toJSON(_2, ctx, Set);
      }
      toString(ctx, onComment, onChompKeep) {
        if (!ctx)
          return JSON.stringify(this);
        if (this.hasAllNullValues(!0))
          return super.toString(Object.assign({}, ctx, { allNullValues: !0 }), onComment, onChompKeep);
        throw new Error("Set items must all have null values");
      }
      static from(schema, iterable, ctx) {
        let { replacer } = ctx, set3 = new this(schema);
        if (iterable && Symbol.iterator in Object(iterable))
          for (let value of iterable)
            typeof replacer == "function" && (value = replacer.call(iterable, value, value)), set3.items.push(Pair.createPair(value, null, ctx));
        return set3;
      }
    };
    YAMLSet.tag = "tag:yaml.org,2002:set";
    var set2 = {
      collection: "map",
      identify: (value) => value instanceof Set,
      nodeClass: YAMLSet,
      default: !1,
      tag: "tag:yaml.org,2002:set",
      createNode: (schema, iterable, ctx) => YAMLSet.from(schema, iterable, ctx),
      resolve(map, onError) {
        if (identity.isMap(map)) {
          if (map.hasAllNullValues(!0))
            return Object.assign(new YAMLSet(), map);
          onError("Set items must all have null values");
        } else
          onError("Expected a mapping for this tag");
        return map;
      }
    };
    exports.YAMLSet = YAMLSet;
    exports.set = set2;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/timestamp.js
var require_timestamp = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/timestamp.js"(exports) {
    "use strict";
    init_cjs_shims();
    var stringifyNumber = require_stringifyNumber();
    function parseSexagesimal(str, asBigInt) {
      let sign = str[0], parts = sign === "-" || sign === "+" ? str.substring(1) : str, num = (n) => asBigInt ? BigInt(n) : Number(n), res = parts.replace(/_/g, "").split(":").reduce((res2, p) => res2 * num(60) + num(p), num(0));
      return sign === "-" ? num(-1) * res : res;
    }
    function stringifySexagesimal(node) {
      let { value } = node, num = (n) => n;
      if (typeof value == "bigint")
        num = (n) => BigInt(n);
      else if (isNaN(value) || !isFinite(value))
        return stringifyNumber.stringifyNumber(node);
      let sign = "";
      value < 0 && (sign = "-", value *= num(-1));
      let _60 = num(60), parts = [value % _60];
      return value < 60 ? parts.unshift(0) : (value = (value - parts[0]) / _60, parts.unshift(value % _60), value >= 60 && (value = (value - parts[0]) / _60, parts.unshift(value))), sign + parts.map((n) => String(n).padStart(2, "0")).join(":").replace(/000000\d*$/, "");
    }
    var intTime = {
      identify: (value) => typeof value == "bigint" || Number.isInteger(value),
      default: !0,
      tag: "tag:yaml.org,2002:int",
      format: "TIME",
      test: /^[-+]?[0-9][0-9_]*(?::[0-5]?[0-9])+$/,
      resolve: (str, _onError, { intAsBigInt }) => parseSexagesimal(str, intAsBigInt),
      stringify: stringifySexagesimal
    }, floatTime = {
      identify: (value) => typeof value == "number",
      default: !0,
      tag: "tag:yaml.org,2002:float",
      format: "TIME",
      test: /^[-+]?[0-9][0-9_]*(?::[0-5]?[0-9])+\.[0-9_]*$/,
      resolve: (str) => parseSexagesimal(str, !1),
      stringify: stringifySexagesimal
    }, timestamp = {
      identify: (value) => value instanceof Date,
      default: !0,
      tag: "tag:yaml.org,2002:timestamp",
      // If the time zone is omitted, the timestamp is assumed to be specified in UTC. The time part
      // may be omitted altogether, resulting in a date format. In such a case, the time part is
      // assumed to be 00:00:00Z (start of day, UTC).
      test: RegExp("^([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})(?:(?:t|T|[ \\t]+)([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2}(\\.[0-9]+)?)(?:[ \\t]*(Z|[-+][012]?[0-9](?::[0-9]{2})?))?)?$"),
      resolve(str) {
        let match2 = str.match(timestamp.test);
        if (!match2)
          throw new Error("!!timestamp expects a date, starting with yyyy-mm-dd");
        let [, year, month, day, hour, minute, second] = match2.map(Number), millisec = match2[7] ? Number((match2[7] + "00").substr(1, 3)) : 0, date = Date.UTC(year, month - 1, day, hour || 0, minute || 0, second || 0, millisec), tz = match2[8];
        if (tz && tz !== "Z") {
          let d = parseSexagesimal(tz, !1);
          Math.abs(d) < 30 && (d *= 60), date -= 6e4 * d;
        }
        return new Date(date);
      },
      stringify: ({ value }) => value.toISOString().replace(/((T00:00)?:00)?\.000Z$/, "")
    };
    exports.floatTime = floatTime;
    exports.intTime = intTime;
    exports.timestamp = timestamp;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/schema.js
var require_schema3 = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/yaml-1.1/schema.js"(exports) {
    "use strict";
    init_cjs_shims();
    var map = require_map(), _null = require_null(), seq = require_seq(), string = require_string(), binary = require_binary(), bool = require_bool2(), float = require_float2(), int = require_int2(), omap = require_omap(), pairs = require_pairs(), set2 = require_set2(), timestamp = require_timestamp(), schema = [
      map.map,
      seq.seq,
      string.string,
      _null.nullTag,
      bool.trueTag,
      bool.falseTag,
      int.intBin,
      int.intOct,
      int.int,
      int.intHex,
      float.floatNaN,
      float.floatExp,
      float.float,
      binary.binary,
      omap.omap,
      pairs.pairs,
      set2.set,
      timestamp.intTime,
      timestamp.floatTime,
      timestamp.timestamp
    ];
    exports.schema = schema;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/tags.js
var require_tags = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/tags.js"(exports) {
    "use strict";
    init_cjs_shims();
    var map = require_map(), _null = require_null(), seq = require_seq(), string = require_string(), bool = require_bool(), float = require_float(), int = require_int(), schema = require_schema(), schema$1 = require_schema2(), binary = require_binary(), omap = require_omap(), pairs = require_pairs(), schema$2 = require_schema3(), set2 = require_set2(), timestamp = require_timestamp(), schemas = /* @__PURE__ */ new Map([
      ["core", schema.schema],
      ["failsafe", [map.map, seq.seq, string.string]],
      ["json", schema$1.schema],
      ["yaml11", schema$2.schema],
      ["yaml-1.1", schema$2.schema]
    ]), tagsByName = {
      binary: binary.binary,
      bool: bool.boolTag,
      float: float.float,
      floatExp: float.floatExp,
      floatNaN: float.floatNaN,
      floatTime: timestamp.floatTime,
      int: int.int,
      intHex: int.intHex,
      intOct: int.intOct,
      intTime: timestamp.intTime,
      map: map.map,
      null: _null.nullTag,
      omap: omap.omap,
      pairs: pairs.pairs,
      seq: seq.seq,
      set: set2.set,
      timestamp: timestamp.timestamp
    }, coreKnownTags = {
      "tag:yaml.org,2002:binary": binary.binary,
      "tag:yaml.org,2002:omap": omap.omap,
      "tag:yaml.org,2002:pairs": pairs.pairs,
      "tag:yaml.org,2002:set": set2.set,
      "tag:yaml.org,2002:timestamp": timestamp.timestamp
    };
    function getTags(customTags, schemaName) {
      let tags = schemas.get(schemaName);
      if (!tags)
        if (Array.isArray(customTags))
          tags = [];
        else {
          let keys = Array.from(schemas.keys()).filter((key) => key !== "yaml11").map((key) => JSON.stringify(key)).join(", ");
          throw new Error(`Unknown schema "${schemaName}"; use one of ${keys} or define customTags array`);
        }
      if (Array.isArray(customTags))
        for (let tag of customTags)
          tags = tags.concat(tag);
      else
        typeof customTags == "function" && (tags = customTags(tags.slice()));
      return tags.map((tag) => {
        if (typeof tag != "string")
          return tag;
        let tagObj = tagsByName[tag];
        if (tagObj)
          return tagObj;
        let keys = Object.keys(tagsByName).map((key) => JSON.stringify(key)).join(", ");
        throw new Error(`Unknown custom tag "${tag}"; use one of ${keys}`);
      });
    }
    exports.coreKnownTags = coreKnownTags;
    exports.getTags = getTags;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/Schema.js
var require_Schema = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/schema/Schema.js"(exports) {
    "use strict";
    init_cjs_shims();
    var identity = require_identity(), map = require_map(), seq = require_seq(), string = require_string(), tags = require_tags(), sortMapEntriesByKey = (a, b) => a.key < b.key ? -1 : a.key > b.key ? 1 : 0, Schema = class _Schema {
      constructor({ compat, customTags, merge, resolveKnownTags, schema, sortMapEntries, toStringDefaults }) {
        this.compat = Array.isArray(compat) ? tags.getTags(compat, "compat") : compat ? tags.getTags(null, compat) : null, this.merge = !!merge, this.name = typeof schema == "string" && schema || "core", this.knownTags = resolveKnownTags ? tags.coreKnownTags : {}, this.tags = tags.getTags(customTags, this.name), this.toStringOptions = toStringDefaults ?? null, Object.defineProperty(this, identity.MAP, { value: map.map }), Object.defineProperty(this, identity.SCALAR, { value: string.string }), Object.defineProperty(this, identity.SEQ, { value: seq.seq }), this.sortMapEntries = typeof sortMapEntries == "function" ? sortMapEntries : sortMapEntries === !0 ? sortMapEntriesByKey : null;
      }
      clone() {
        let copy = Object.create(_Schema.prototype, Object.getOwnPropertyDescriptors(this));
        return copy.tags = this.tags.slice(), copy;
      }
    };
    exports.Schema = Schema;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/stringify/stringifyDocument.js
var require_stringifyDocument = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/stringify/stringifyDocument.js"(exports) {
    "use strict";
    init_cjs_shims();
    var identity = require_identity(), stringify = require_stringify(), stringifyComment = require_stringifyComment();
    function stringifyDocument(doc, options) {
      let lines = [], hasDirectives = options.directives === !0;
      if (options.directives !== !1 && doc.directives) {
        let dir = doc.directives.toString(doc);
        dir ? (lines.push(dir), hasDirectives = !0) : doc.directives.docStart && (hasDirectives = !0);
      }
      hasDirectives && lines.push("---");
      let ctx = stringify.createStringifyContext(doc, options), { commentString: commentString2 } = ctx.options;
      if (doc.commentBefore) {
        lines.length !== 1 && lines.unshift("");
        let cs = commentString2(doc.commentBefore);
        lines.unshift(stringifyComment.indentComment(cs, ""));
      }
      let chompKeep = !1, contentComment = null;
      if (doc.contents) {
        if (identity.isNode(doc.contents)) {
          if (doc.contents.spaceBefore && hasDirectives && lines.push(""), doc.contents.commentBefore) {
            let cs = commentString2(doc.contents.commentBefore);
            lines.push(stringifyComment.indentComment(cs, ""));
          }
          ctx.forceBlockIndent = !!doc.comment, contentComment = doc.contents.comment;
        }
        let onChompKeep = contentComment ? void 0 : () => chompKeep = !0, body = stringify.stringify(doc.contents, ctx, () => contentComment = null, onChompKeep);
        contentComment && (body += stringifyComment.lineComment(body, "", commentString2(contentComment))), (body[0] === "|" || body[0] === ">") && lines[lines.length - 1] === "---" ? lines[lines.length - 1] = `--- ${body}` : lines.push(body);
      } else
        lines.push(stringify.stringify(doc.contents, ctx));
      if (doc.directives?.docEnd)
        if (doc.comment) {
          let cs = commentString2(doc.comment);
          cs.includes(`
`) ? (lines.push("..."), lines.push(stringifyComment.indentComment(cs, ""))) : lines.push(`... ${cs}`);
        } else
          lines.push("...");
      else {
        let dc = doc.comment;
        dc && chompKeep && (dc = dc.replace(/^\n+/, "")), dc && ((!chompKeep || contentComment) && lines[lines.length - 1] !== "" && lines.push(""), lines.push(stringifyComment.indentComment(commentString2(dc), "")));
      }
      return lines.join(`
`) + `
`;
    }
    exports.stringifyDocument = stringifyDocument;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/doc/Document.js
var require_Document = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/doc/Document.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Alias = require_Alias(), Collection = require_Collection(), identity = require_identity(), Pair = require_Pair(), toJS = require_toJS(), Schema = require_Schema(), stringifyDocument = require_stringifyDocument(), anchors = require_anchors(), applyReviver = require_applyReviver(), createNode = require_createNode(), directives = require_directives(), Document = class _Document {
      constructor(value, replacer, options) {
        this.commentBefore = null, this.comment = null, this.errors = [], this.warnings = [], Object.defineProperty(this, identity.NODE_TYPE, { value: identity.DOC });
        let _replacer = null;
        typeof replacer == "function" || Array.isArray(replacer) ? _replacer = replacer : options === void 0 && replacer && (options = replacer, replacer = void 0);
        let opt = Object.assign({
          intAsBigInt: !1,
          keepSourceTokens: !1,
          logLevel: "warn",
          prettyErrors: !0,
          strict: !0,
          uniqueKeys: !0,
          version: "1.2"
        }, options);
        this.options = opt;
        let { version: version2 } = opt;
        options?._directives ? (this.directives = options._directives.atDocument(), this.directives.yaml.explicit && (version2 = this.directives.yaml.version)) : this.directives = new directives.Directives({ version: version2 }), this.setSchema(version2, options), this.contents = value === void 0 ? null : this.createNode(value, _replacer, options);
      }
      /**
       * Create a deep copy of this Document and its contents.
       *
       * Custom Node values that inherit from `Object` still refer to their original instances.
       */
      clone() {
        let copy = Object.create(_Document.prototype, {
          [identity.NODE_TYPE]: { value: identity.DOC }
        });
        return copy.commentBefore = this.commentBefore, copy.comment = this.comment, copy.errors = this.errors.slice(), copy.warnings = this.warnings.slice(), copy.options = Object.assign({}, this.options), this.directives && (copy.directives = this.directives.clone()), copy.schema = this.schema.clone(), copy.contents = identity.isNode(this.contents) ? this.contents.clone(copy.schema) : this.contents, this.range && (copy.range = this.range.slice()), copy;
      }
      /** Adds a value to the document. */
      add(value) {
        assertCollection(this.contents) && this.contents.add(value);
      }
      /** Adds a value to the document. */
      addIn(path3, value) {
        assertCollection(this.contents) && this.contents.addIn(path3, value);
      }
      /**
       * Create a new `Alias` node, ensuring that the target `node` has the required anchor.
       *
       * If `node` already has an anchor, `name` is ignored.
       * Otherwise, the `node.anchor` value will be set to `name`,
       * or if an anchor with that name is already present in the document,
       * `name` will be used as a prefix for a new unique anchor.
       * If `name` is undefined, the generated anchor will use 'a' as a prefix.
       */
      createAlias(node, name) {
        if (!node.anchor) {
          let prev = anchors.anchorNames(this);
          node.anchor = // eslint-disable-next-line @typescript-eslint/prefer-nullish-coalescing
          !name || prev.has(name) ? anchors.findNewAnchor(name || "a", prev) : name;
        }
        return new Alias.Alias(node.anchor);
      }
      createNode(value, replacer, options) {
        let _replacer;
        if (typeof replacer == "function")
          value = replacer.call({ "": value }, "", value), _replacer = replacer;
        else if (Array.isArray(replacer)) {
          let keyToStr = (v) => typeof v == "number" || v instanceof String || v instanceof Number, asStr = replacer.filter(keyToStr).map(String);
          asStr.length > 0 && (replacer = replacer.concat(asStr)), _replacer = replacer;
        } else
          options === void 0 && replacer && (options = replacer, replacer = void 0);
        let { aliasDuplicateObjects, anchorPrefix, flow, keepUndefined, onTagObj, tag } = options ?? {}, { onAnchor, setAnchors, sourceObjects } = anchors.createNodeAnchors(
          this,
          // eslint-disable-next-line @typescript-eslint/prefer-nullish-coalescing
          anchorPrefix || "a"
        ), ctx = {
          aliasDuplicateObjects: aliasDuplicateObjects ?? !0,
          keepUndefined: keepUndefined ?? !1,
          onAnchor,
          onTagObj,
          replacer: _replacer,
          schema: this.schema,
          sourceObjects
        }, node = createNode.createNode(value, tag, ctx);
        return flow && identity.isCollection(node) && (node.flow = !0), setAnchors(), node;
      }
      /**
       * Convert a key and a value into a `Pair` using the current schema,
       * recursively wrapping all values as `Scalar` or `Collection` nodes.
       */
      createPair(key, value, options = {}) {
        let k = this.createNode(key, null, options), v = this.createNode(value, null, options);
        return new Pair.Pair(k, v);
      }
      /**
       * Removes a value from the document.
       * @returns `true` if the item was found and removed.
       */
      delete(key) {
        return assertCollection(this.contents) ? this.contents.delete(key) : !1;
      }
      /**
       * Removes a value from the document.
       * @returns `true` if the item was found and removed.
       */
      deleteIn(path3) {
        return Collection.isEmptyPath(path3) ? this.contents == null ? !1 : (this.contents = null, !0) : assertCollection(this.contents) ? this.contents.deleteIn(path3) : !1;
      }
      /**
       * Returns item at `key`, or `undefined` if not found. By default unwraps
       * scalar values from their surrounding node; to disable set `keepScalar` to
       * `true` (collections are always returned intact).
       */
      get(key, keepScalar) {
        return identity.isCollection(this.contents) ? this.contents.get(key, keepScalar) : void 0;
      }
      /**
       * Returns item at `path`, or `undefined` if not found. By default unwraps
       * scalar values from their surrounding node; to disable set `keepScalar` to
       * `true` (collections are always returned intact).
       */
      getIn(path3, keepScalar) {
        return Collection.isEmptyPath(path3) ? !keepScalar && identity.isScalar(this.contents) ? this.contents.value : this.contents : identity.isCollection(this.contents) ? this.contents.getIn(path3, keepScalar) : void 0;
      }
      /**
       * Checks if the document includes a value with the key `key`.
       */
      has(key) {
        return identity.isCollection(this.contents) ? this.contents.has(key) : !1;
      }
      /**
       * Checks if the document includes a value at `path`.
       */
      hasIn(path3) {
        return Collection.isEmptyPath(path3) ? this.contents !== void 0 : identity.isCollection(this.contents) ? this.contents.hasIn(path3) : !1;
      }
      /**
       * Sets a value in this document. For `!!set`, `value` needs to be a
       * boolean to add/remove the item from the set.
       */
      set(key, value) {
        this.contents == null ? this.contents = Collection.collectionFromPath(this.schema, [key], value) : assertCollection(this.contents) && this.contents.set(key, value);
      }
      /**
       * Sets a value in this document. For `!!set`, `value` needs to be a
       * boolean to add/remove the item from the set.
       */
      setIn(path3, value) {
        Collection.isEmptyPath(path3) ? this.contents = value : this.contents == null ? this.contents = Collection.collectionFromPath(this.schema, Array.from(path3), value) : assertCollection(this.contents) && this.contents.setIn(path3, value);
      }
      /**
       * Change the YAML version and schema used by the document.
       * A `null` version disables support for directives, explicit tags, anchors, and aliases.
       * It also requires the `schema` option to be given as a `Schema` instance value.
       *
       * Overrides all previously set schema options.
       */
      setSchema(version2, options = {}) {
        typeof version2 == "number" && (version2 = String(version2));
        let opt;
        switch (version2) {
          case "1.1":
            this.directives ? this.directives.yaml.version = "1.1" : this.directives = new directives.Directives({ version: "1.1" }), opt = { merge: !0, resolveKnownTags: !1, schema: "yaml-1.1" };
            break;
          case "1.2":
          case "next":
            this.directives ? this.directives.yaml.version = version2 : this.directives = new directives.Directives({ version: version2 }), opt = { merge: !1, resolveKnownTags: !0, schema: "core" };
            break;
          case null:
            this.directives && delete this.directives, opt = null;
            break;
          default: {
            let sv = JSON.stringify(version2);
            throw new Error(`Expected '1.1', '1.2' or null as first argument, but found: ${sv}`);
          }
        }
        if (options.schema instanceof Object)
          this.schema = options.schema;
        else if (opt)
          this.schema = new Schema.Schema(Object.assign(opt, options));
        else
          throw new Error("With a null YAML version, the { schema: Schema } option is required");
      }
      // json & jsonArg are only used from toJSON()
      toJS({ json, jsonArg, mapAsMap, maxAliasCount, onAnchor, reviver } = {}) {
        let ctx = {
          anchors: /* @__PURE__ */ new Map(),
          doc: this,
          keep: !json,
          mapAsMap: mapAsMap === !0,
          mapKeyWarned: !1,
          maxAliasCount: typeof maxAliasCount == "number" ? maxAliasCount : 100
        }, res = toJS.toJS(this.contents, jsonArg ?? "", ctx);
        if (typeof onAnchor == "function")
          for (let { count, res: res2 } of ctx.anchors.values())
            onAnchor(res2, count);
        return typeof reviver == "function" ? applyReviver.applyReviver(reviver, { "": res }, "", res) : res;
      }
      /**
       * A JSON representation of the document `contents`.
       *
       * @param jsonArg Used by `JSON.stringify` to indicate the array index or
       *   property name.
       */
      toJSON(jsonArg, onAnchor) {
        return this.toJS({ json: !0, jsonArg, mapAsMap: !1, onAnchor });
      }
      /** A YAML representation of the document. */
      toString(options = {}) {
        if (this.errors.length > 0)
          throw new Error("Document with errors cannot be stringified");
        if ("indent" in options && (!Number.isInteger(options.indent) || Number(options.indent) <= 0)) {
          let s = JSON.stringify(options.indent);
          throw new Error(`"indent" option must be a positive integer, not ${s}`);
        }
        return stringifyDocument.stringifyDocument(this, options);
      }
    };
    function assertCollection(contents) {
      if (identity.isCollection(contents))
        return !0;
      throw new Error("Expected a YAML collection as document contents");
    }
    exports.Document = Document;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/errors.js
var require_errors3 = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/errors.js"(exports) {
    "use strict";
    init_cjs_shims();
    var YAMLError = class extends Error {
      constructor(name, pos, code, message) {
        super(), this.name = name, this.code = code, this.message = message, this.pos = pos;
      }
    }, YAMLParseError = class extends YAMLError {
      constructor(pos, code, message) {
        super("YAMLParseError", pos, code, message);
      }
    }, YAMLWarning = class extends YAMLError {
      constructor(pos, code, message) {
        super("YAMLWarning", pos, code, message);
      }
    }, prettifyError = (src, lc) => (error) => {
      if (error.pos[0] === -1)
        return;
      error.linePos = error.pos.map((pos) => lc.linePos(pos));
      let { line, col } = error.linePos[0];
      error.message += ` at line ${line}, column ${col}`;
      let ci = col - 1, lineStr = src.substring(lc.lineStarts[line - 1], lc.lineStarts[line]).replace(/[\n\r]+$/, "");
      if (ci >= 60 && lineStr.length > 80) {
        let trimStart = Math.min(ci - 39, lineStr.length - 79);
        lineStr = "\u2026" + lineStr.substring(trimStart), ci -= trimStart - 1;
      }
      if (lineStr.length > 80 && (lineStr = lineStr.substring(0, 79) + "\u2026"), line > 1 && /^ *$/.test(lineStr.substring(0, ci))) {
        let prev = src.substring(lc.lineStarts[line - 2], lc.lineStarts[line - 1]);
        prev.length > 80 && (prev = prev.substring(0, 79) + `\u2026
`), lineStr = prev + lineStr;
      }
      if (/[^ ]/.test(lineStr)) {
        let count = 1, end = error.linePos[1];
        end && end.line === line && end.col > col && (count = Math.max(1, Math.min(end.col - col, 80 - ci)));
        let pointer = " ".repeat(ci) + "^".repeat(count);
        error.message += `:

${lineStr}
${pointer}
`;
      }
    };
    exports.YAMLError = YAMLError;
    exports.YAMLParseError = YAMLParseError;
    exports.YAMLWarning = YAMLWarning;
    exports.prettifyError = prettifyError;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/resolve-props.js
var require_resolve_props = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/resolve-props.js"(exports) {
    "use strict";
    init_cjs_shims();
    function resolveProps(tokens, { flow, indicator, next, offset, onError, startOnNewline }) {
      let spaceBefore = !1, atNewline = startOnNewline, hasSpace = startOnNewline, comment = "", commentSep = "", hasNewline = !1, hasNewlineAfterProp = !1, reqSpace = !1, anchor = null, tag = null, comma = null, found = null, start = null;
      for (let token of tokens)
        switch (reqSpace && (token.type !== "space" && token.type !== "newline" && token.type !== "comma" && onError(token.offset, "MISSING_CHAR", "Tags and anchors must be separated from the next token by white space"), reqSpace = !1), token.type) {
          case "space":
            !flow && atNewline && indicator !== "doc-start" && token.source[0] === "	" && onError(token, "TAB_AS_INDENT", "Tabs are not allowed as indentation"), hasSpace = !0;
            break;
          case "comment": {
            hasSpace || onError(token, "MISSING_CHAR", "Comments must be separated from other tokens by white space characters");
            let cb = token.source.substring(1) || " ";
            comment ? comment += commentSep + cb : comment = cb, commentSep = "", atNewline = !1;
            break;
          }
          case "newline":
            atNewline ? comment ? comment += token.source : spaceBefore = !0 : commentSep += token.source, atNewline = !0, hasNewline = !0, (anchor || tag) && (hasNewlineAfterProp = !0), hasSpace = !0;
            break;
          case "anchor":
            anchor && onError(token, "MULTIPLE_ANCHORS", "A node can have at most one anchor"), token.source.endsWith(":") && onError(token.offset + token.source.length - 1, "BAD_ALIAS", "Anchor ending in : is ambiguous", !0), anchor = token, start === null && (start = token.offset), atNewline = !1, hasSpace = !1, reqSpace = !0;
            break;
          case "tag": {
            tag && onError(token, "MULTIPLE_TAGS", "A node can have at most one tag"), tag = token, start === null && (start = token.offset), atNewline = !1, hasSpace = !1, reqSpace = !0;
            break;
          }
          case indicator:
            (anchor || tag) && onError(token, "BAD_PROP_ORDER", `Anchors and tags must be after the ${token.source} indicator`), found && onError(token, "UNEXPECTED_TOKEN", `Unexpected ${token.source} in ${flow ?? "collection"}`), found = token, atNewline = !1, hasSpace = !1;
            break;
          case "comma":
            if (flow) {
              comma && onError(token, "UNEXPECTED_TOKEN", `Unexpected , in ${flow}`), comma = token, atNewline = !1, hasSpace = !1;
              break;
            }
          default:
            onError(token, "UNEXPECTED_TOKEN", `Unexpected ${token.type} token`), atNewline = !1, hasSpace = !1;
        }
      let last = tokens[tokens.length - 1], end = last ? last.offset + last.source.length : offset;
      return reqSpace && next && next.type !== "space" && next.type !== "newline" && next.type !== "comma" && (next.type !== "scalar" || next.source !== "") && onError(next.offset, "MISSING_CHAR", "Tags and anchors must be separated from the next token by white space"), {
        comma,
        found,
        spaceBefore,
        comment,
        hasNewline,
        hasNewlineAfterProp,
        anchor,
        tag,
        end,
        start: start ?? end
      };
    }
    exports.resolveProps = resolveProps;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/util-contains-newline.js
var require_util_contains_newline = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/util-contains-newline.js"(exports) {
    "use strict";
    init_cjs_shims();
    function containsNewline(key) {
      if (!key)
        return null;
      switch (key.type) {
        case "alias":
        case "scalar":
        case "double-quoted-scalar":
        case "single-quoted-scalar":
          if (key.source.includes(`
`))
            return !0;
          if (key.end) {
            for (let st of key.end)
              if (st.type === "newline")
                return !0;
          }
          return !1;
        case "flow-collection":
          for (let it of key.items) {
            for (let st of it.start)
              if (st.type === "newline")
                return !0;
            if (it.sep) {
              for (let st of it.sep)
                if (st.type === "newline")
                  return !0;
            }
            if (containsNewline(it.key) || containsNewline(it.value))
              return !0;
          }
          return !1;
        default:
          return !0;
      }
    }
    exports.containsNewline = containsNewline;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/util-flow-indent-check.js
var require_util_flow_indent_check = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/util-flow-indent-check.js"(exports) {
    "use strict";
    init_cjs_shims();
    var utilContainsNewline = require_util_contains_newline();
    function flowIndentCheck(indent, fc, onError) {
      if (fc?.type === "flow-collection") {
        let end = fc.end[0];
        end.indent === indent && (end.source === "]" || end.source === "}") && utilContainsNewline.containsNewline(fc) && onError(end, "BAD_INDENT", "Flow end indicator should be more indented than parent", !0);
      }
    }
    exports.flowIndentCheck = flowIndentCheck;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/util-map-includes.js
var require_util_map_includes = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/util-map-includes.js"(exports) {
    "use strict";
    init_cjs_shims();
    var identity = require_identity();
    function mapIncludes(ctx, items, search) {
      let { uniqueKeys } = ctx.options;
      if (uniqueKeys === !1)
        return !1;
      let isEqual = typeof uniqueKeys == "function" ? uniqueKeys : (a, b) => a === b || identity.isScalar(a) && identity.isScalar(b) && a.value === b.value && !(a.value === "<<" && ctx.schema.merge);
      return items.some((pair) => isEqual(pair.key, search));
    }
    exports.mapIncludes = mapIncludes;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/resolve-block-map.js
var require_resolve_block_map = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/resolve-block-map.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Pair = require_Pair(), YAMLMap = require_YAMLMap(), resolveProps = require_resolve_props(), utilContainsNewline = require_util_contains_newline(), utilFlowIndentCheck = require_util_flow_indent_check(), utilMapIncludes = require_util_map_includes(), startColMsg = "All mapping items must start at the same column";
    function resolveBlockMap({ composeNode, composeEmptyNode }, ctx, bm, onError, tag) {
      let NodeClass = tag?.nodeClass ?? YAMLMap.YAMLMap, map = new NodeClass(ctx.schema);
      ctx.atRoot && (ctx.atRoot = !1);
      let offset = bm.offset, commentEnd = null;
      for (let collItem of bm.items) {
        let { start, key, sep: sep3, value } = collItem, keyProps = resolveProps.resolveProps(start, {
          indicator: "explicit-key-ind",
          next: key ?? sep3?.[0],
          offset,
          onError,
          startOnNewline: !0
        }), implicitKey = !keyProps.found;
        if (implicitKey) {
          if (key && (key.type === "block-seq" ? onError(offset, "BLOCK_AS_IMPLICIT_KEY", "A block sequence may not be used as an implicit map key") : "indent" in key && key.indent !== bm.indent && onError(offset, "BAD_INDENT", startColMsg)), !keyProps.anchor && !keyProps.tag && !sep3) {
            commentEnd = keyProps.end, keyProps.comment && (map.comment ? map.comment += `
` + keyProps.comment : map.comment = keyProps.comment);
            continue;
          }
          (keyProps.hasNewlineAfterProp || utilContainsNewline.containsNewline(key)) && onError(key ?? start[start.length - 1], "MULTILINE_IMPLICIT_KEY", "Implicit keys need to be on a single line");
        } else
          keyProps.found?.indent !== bm.indent && onError(offset, "BAD_INDENT", startColMsg);
        let keyStart = keyProps.end, keyNode = key ? composeNode(ctx, key, keyProps, onError) : composeEmptyNode(ctx, keyStart, start, null, keyProps, onError);
        ctx.schema.compat && utilFlowIndentCheck.flowIndentCheck(bm.indent, key, onError), utilMapIncludes.mapIncludes(ctx, map.items, keyNode) && onError(keyStart, "DUPLICATE_KEY", "Map keys must be unique");
        let valueProps = resolveProps.resolveProps(sep3 ?? [], {
          indicator: "map-value-ind",
          next: value,
          offset: keyNode.range[2],
          onError,
          startOnNewline: !key || key.type === "block-scalar"
        });
        if (offset = valueProps.end, valueProps.found) {
          implicitKey && (value?.type === "block-map" && !valueProps.hasNewline && onError(offset, "BLOCK_AS_IMPLICIT_KEY", "Nested mappings are not allowed in compact mappings"), ctx.options.strict && keyProps.start < valueProps.found.offset - 1024 && onError(keyNode.range, "KEY_OVER_1024_CHARS", "The : indicator must be at most 1024 chars after the start of an implicit block mapping key"));
          let valueNode = value ? composeNode(ctx, value, valueProps, onError) : composeEmptyNode(ctx, offset, sep3, null, valueProps, onError);
          ctx.schema.compat && utilFlowIndentCheck.flowIndentCheck(bm.indent, value, onError), offset = valueNode.range[2];
          let pair = new Pair.Pair(keyNode, valueNode);
          ctx.options.keepSourceTokens && (pair.srcToken = collItem), map.items.push(pair);
        } else {
          implicitKey && onError(keyNode.range, "MISSING_CHAR", "Implicit map keys need to be followed by map values"), valueProps.comment && (keyNode.comment ? keyNode.comment += `
` + valueProps.comment : keyNode.comment = valueProps.comment);
          let pair = new Pair.Pair(keyNode);
          ctx.options.keepSourceTokens && (pair.srcToken = collItem), map.items.push(pair);
        }
      }
      return commentEnd && commentEnd < offset && onError(commentEnd, "IMPOSSIBLE", "Map comment with trailing content"), map.range = [bm.offset, offset, commentEnd ?? offset], map;
    }
    exports.resolveBlockMap = resolveBlockMap;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/resolve-block-seq.js
var require_resolve_block_seq = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/resolve-block-seq.js"(exports) {
    "use strict";
    init_cjs_shims();
    var YAMLSeq = require_YAMLSeq(), resolveProps = require_resolve_props(), utilFlowIndentCheck = require_util_flow_indent_check();
    function resolveBlockSeq({ composeNode, composeEmptyNode }, ctx, bs, onError, tag) {
      let NodeClass = tag?.nodeClass ?? YAMLSeq.YAMLSeq, seq = new NodeClass(ctx.schema);
      ctx.atRoot && (ctx.atRoot = !1);
      let offset = bs.offset, commentEnd = null;
      for (let { start, value } of bs.items) {
        let props = resolveProps.resolveProps(start, {
          indicator: "seq-item-ind",
          next: value,
          offset,
          onError,
          startOnNewline: !0
        });
        if (!props.found)
          if (props.anchor || props.tag || value)
            value && value.type === "block-seq" ? onError(props.end, "BAD_INDENT", "All sequence items must start at the same column") : onError(offset, "MISSING_CHAR", "Sequence item without - indicator");
          else {
            commentEnd = props.end, props.comment && (seq.comment = props.comment);
            continue;
          }
        let node = value ? composeNode(ctx, value, props, onError) : composeEmptyNode(ctx, props.end, start, null, props, onError);
        ctx.schema.compat && utilFlowIndentCheck.flowIndentCheck(bs.indent, value, onError), offset = node.range[2], seq.items.push(node);
      }
      return seq.range = [bs.offset, offset, commentEnd ?? offset], seq;
    }
    exports.resolveBlockSeq = resolveBlockSeq;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/resolve-end.js
var require_resolve_end = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/resolve-end.js"(exports) {
    "use strict";
    init_cjs_shims();
    function resolveEnd(end, offset, reqSpace, onError) {
      let comment = "";
      if (end) {
        let hasSpace = !1, sep3 = "";
        for (let token of end) {
          let { source, type } = token;
          switch (type) {
            case "space":
              hasSpace = !0;
              break;
            case "comment": {
              reqSpace && !hasSpace && onError(token, "MISSING_CHAR", "Comments must be separated from other tokens by white space characters");
              let cb = source.substring(1) || " ";
              comment ? comment += sep3 + cb : comment = cb, sep3 = "";
              break;
            }
            case "newline":
              comment && (sep3 += source), hasSpace = !0;
              break;
            default:
              onError(token, "UNEXPECTED_TOKEN", `Unexpected ${type} at node end`);
          }
          offset += source.length;
        }
      }
      return { comment, offset };
    }
    exports.resolveEnd = resolveEnd;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/resolve-flow-collection.js
var require_resolve_flow_collection = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/resolve-flow-collection.js"(exports) {
    "use strict";
    init_cjs_shims();
    var identity = require_identity(), Pair = require_Pair(), YAMLMap = require_YAMLMap(), YAMLSeq = require_YAMLSeq(), resolveEnd = require_resolve_end(), resolveProps = require_resolve_props(), utilContainsNewline = require_util_contains_newline(), utilMapIncludes = require_util_map_includes(), blockMsg = "Block collections are not allowed within flow collections", isBlock = (token) => token && (token.type === "block-map" || token.type === "block-seq");
    function resolveFlowCollection({ composeNode, composeEmptyNode }, ctx, fc, onError, tag) {
      let isMap = fc.start.source === "{", fcName = isMap ? "flow map" : "flow sequence", NodeClass = tag?.nodeClass ?? (isMap ? YAMLMap.YAMLMap : YAMLSeq.YAMLSeq), coll = new NodeClass(ctx.schema);
      coll.flow = !0;
      let atRoot = ctx.atRoot;
      atRoot && (ctx.atRoot = !1);
      let offset = fc.offset + fc.start.source.length;
      for (let i = 0; i < fc.items.length; ++i) {
        let collItem = fc.items[i], { start, key, sep: sep3, value } = collItem, props = resolveProps.resolveProps(start, {
          flow: fcName,
          indicator: "explicit-key-ind",
          next: key ?? sep3?.[0],
          offset,
          onError,
          startOnNewline: !1
        });
        if (!props.found) {
          if (!props.anchor && !props.tag && !sep3 && !value) {
            i === 0 && props.comma ? onError(props.comma, "UNEXPECTED_TOKEN", `Unexpected , in ${fcName}`) : i < fc.items.length - 1 && onError(props.start, "UNEXPECTED_TOKEN", `Unexpected empty item in ${fcName}`), props.comment && (coll.comment ? coll.comment += `
` + props.comment : coll.comment = props.comment), offset = props.end;
            continue;
          }
          !isMap && ctx.options.strict && utilContainsNewline.containsNewline(key) && onError(
            key,
            // checked by containsNewline()
            "MULTILINE_IMPLICIT_KEY",
            "Implicit keys of flow sequence pairs need to be on a single line"
          );
        }
        if (i === 0)
          props.comma && onError(props.comma, "UNEXPECTED_TOKEN", `Unexpected , in ${fcName}`);
        else if (props.comma || onError(props.start, "MISSING_CHAR", `Missing , between ${fcName} items`), props.comment) {
          let prevItemComment = "";
          loop:
            for (let st of start)
              switch (st.type) {
                case "comma":
                case "space":
                  break;
                case "comment":
                  prevItemComment = st.source.substring(1);
                  break loop;
                default:
                  break loop;
              }
          if (prevItemComment) {
            let prev = coll.items[coll.items.length - 1];
            identity.isPair(prev) && (prev = prev.value ?? prev.key), prev.comment ? prev.comment += `
` + prevItemComment : prev.comment = prevItemComment, props.comment = props.comment.substring(prevItemComment.length + 1);
          }
        }
        if (!isMap && !sep3 && !props.found) {
          let valueNode = value ? composeNode(ctx, value, props, onError) : composeEmptyNode(ctx, props.end, sep3, null, props, onError);
          coll.items.push(valueNode), offset = valueNode.range[2], isBlock(value) && onError(valueNode.range, "BLOCK_IN_FLOW", blockMsg);
        } else {
          let keyStart = props.end, keyNode = key ? composeNode(ctx, key, props, onError) : composeEmptyNode(ctx, keyStart, start, null, props, onError);
          isBlock(key) && onError(keyNode.range, "BLOCK_IN_FLOW", blockMsg);
          let valueProps = resolveProps.resolveProps(sep3 ?? [], {
            flow: fcName,
            indicator: "map-value-ind",
            next: value,
            offset: keyNode.range[2],
            onError,
            startOnNewline: !1
          });
          if (valueProps.found) {
            if (!isMap && !props.found && ctx.options.strict) {
              if (sep3)
                for (let st of sep3) {
                  if (st === valueProps.found)
                    break;
                  if (st.type === "newline") {
                    onError(st, "MULTILINE_IMPLICIT_KEY", "Implicit keys of flow sequence pairs need to be on a single line");
                    break;
                  }
                }
              props.start < valueProps.found.offset - 1024 && onError(valueProps.found, "KEY_OVER_1024_CHARS", "The : indicator must be at most 1024 chars after the start of an implicit flow sequence key");
            }
          } else
            value && ("source" in value && value.source && value.source[0] === ":" ? onError(value, "MISSING_CHAR", `Missing space after : in ${fcName}`) : onError(valueProps.start, "MISSING_CHAR", `Missing , or : between ${fcName} items`));
          let valueNode = value ? composeNode(ctx, value, valueProps, onError) : valueProps.found ? composeEmptyNode(ctx, valueProps.end, sep3, null, valueProps, onError) : null;
          valueNode ? isBlock(value) && onError(valueNode.range, "BLOCK_IN_FLOW", blockMsg) : valueProps.comment && (keyNode.comment ? keyNode.comment += `
` + valueProps.comment : keyNode.comment = valueProps.comment);
          let pair = new Pair.Pair(keyNode, valueNode);
          if (ctx.options.keepSourceTokens && (pair.srcToken = collItem), isMap) {
            let map = coll;
            utilMapIncludes.mapIncludes(ctx, map.items, keyNode) && onError(keyStart, "DUPLICATE_KEY", "Map keys must be unique"), map.items.push(pair);
          } else {
            let map = new YAMLMap.YAMLMap(ctx.schema);
            map.flow = !0, map.items.push(pair), coll.items.push(map);
          }
          offset = valueNode ? valueNode.range[2] : valueProps.end;
        }
      }
      let expectedEnd = isMap ? "}" : "]", [ce, ...ee] = fc.end, cePos = offset;
      if (ce && ce.source === expectedEnd)
        cePos = ce.offset + ce.source.length;
      else {
        let name = fcName[0].toUpperCase() + fcName.substring(1), msg = atRoot ? `${name} must end with a ${expectedEnd}` : `${name} in block collection must be sufficiently indented and end with a ${expectedEnd}`;
        onError(offset, atRoot ? "MISSING_CHAR" : "BAD_INDENT", msg), ce && ce.source.length !== 1 && ee.unshift(ce);
      }
      if (ee.length > 0) {
        let end = resolveEnd.resolveEnd(ee, cePos, ctx.options.strict, onError);
        end.comment && (coll.comment ? coll.comment += `
` + end.comment : coll.comment = end.comment), coll.range = [fc.offset, cePos, end.offset];
      } else
        coll.range = [fc.offset, cePos, cePos];
      return coll;
    }
    exports.resolveFlowCollection = resolveFlowCollection;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/compose-collection.js
var require_compose_collection = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/compose-collection.js"(exports) {
    "use strict";
    init_cjs_shims();
    var identity = require_identity(), Scalar = require_Scalar(), YAMLMap = require_YAMLMap(), YAMLSeq = require_YAMLSeq(), resolveBlockMap = require_resolve_block_map(), resolveBlockSeq = require_resolve_block_seq(), resolveFlowCollection = require_resolve_flow_collection();
    function resolveCollection(CN, ctx, token, onError, tagName, tag) {
      let coll = token.type === "block-map" ? resolveBlockMap.resolveBlockMap(CN, ctx, token, onError, tag) : token.type === "block-seq" ? resolveBlockSeq.resolveBlockSeq(CN, ctx, token, onError, tag) : resolveFlowCollection.resolveFlowCollection(CN, ctx, token, onError, tag), Coll = coll.constructor;
      return tagName === "!" || tagName === Coll.tagName ? (coll.tag = Coll.tagName, coll) : (tagName && (coll.tag = tagName), coll);
    }
    function composeCollection(CN, ctx, token, tagToken, onError) {
      let tagName = tagToken ? ctx.directives.tagName(tagToken.source, (msg) => onError(tagToken, "TAG_RESOLVE_FAILED", msg)) : null, expType = token.type === "block-map" ? "map" : token.type === "block-seq" ? "seq" : token.start.source === "{" ? "map" : "seq";
      if (!tagToken || !tagName || tagName === "!" || tagName === YAMLMap.YAMLMap.tagName && expType === "map" || tagName === YAMLSeq.YAMLSeq.tagName && expType === "seq" || !expType)
        return resolveCollection(CN, ctx, token, onError, tagName);
      let tag = ctx.schema.tags.find((t7) => t7.tag === tagName && t7.collection === expType);
      if (!tag) {
        let kt = ctx.schema.knownTags[tagName];
        if (kt && kt.collection === expType)
          ctx.schema.tags.push(Object.assign({}, kt, { default: !1 })), tag = kt;
        else
          return kt?.collection ? onError(tagToken, "BAD_COLLECTION_TYPE", `${kt.tag} used for ${expType} collection, but expects ${kt.collection}`, !0) : onError(tagToken, "TAG_RESOLVE_FAILED", `Unresolved tag: ${tagName}`, !0), resolveCollection(CN, ctx, token, onError, tagName);
      }
      let coll = resolveCollection(CN, ctx, token, onError, tagName, tag), res = tag.resolve?.(coll, (msg) => onError(tagToken, "TAG_RESOLVE_FAILED", msg), ctx.options) ?? coll, node = identity.isNode(res) ? res : new Scalar.Scalar(res);
      return node.range = coll.range, node.tag = tagName, tag?.format && (node.format = tag.format), node;
    }
    exports.composeCollection = composeCollection;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/resolve-block-scalar.js
var require_resolve_block_scalar = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/resolve-block-scalar.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Scalar = require_Scalar();
    function resolveBlockScalar(scalar, strict, onError) {
      let start = scalar.offset, header2 = parseBlockScalarHeader(scalar, strict, onError);
      if (!header2)
        return { value: "", type: null, comment: "", range: [start, start, start] };
      let type = header2.mode === ">" ? Scalar.Scalar.BLOCK_FOLDED : Scalar.Scalar.BLOCK_LITERAL, lines = scalar.source ? splitLines(scalar.source) : [], chompStart = lines.length;
      for (let i = lines.length - 1; i >= 0; --i) {
        let content = lines[i][1];
        if (content === "" || content === "\r")
          chompStart = i;
        else
          break;
      }
      if (chompStart === 0) {
        let value2 = header2.chomp === "+" && lines.length > 0 ? `
`.repeat(Math.max(1, lines.length - 1)) : "", end2 = start + header2.length;
        return scalar.source && (end2 += scalar.source.length), { value: value2, type, comment: header2.comment, range: [start, end2, end2] };
      }
      let trimIndent = scalar.indent + header2.indent, offset = scalar.offset + header2.length, contentStart = 0;
      for (let i = 0; i < chompStart; ++i) {
        let [indent, content] = lines[i];
        if (content === "" || content === "\r")
          header2.indent === 0 && indent.length > trimIndent && (trimIndent = indent.length);
        else {
          if (indent.length < trimIndent) {
            let message = "Block scalars with more-indented leading empty lines must use an explicit indentation indicator";
            onError(offset + indent.length, "MISSING_CHAR", message);
          }
          header2.indent === 0 && (trimIndent = indent.length), contentStart = i;
          break;
        }
        offset += indent.length + content.length + 1;
      }
      for (let i = lines.length - 1; i >= chompStart; --i)
        lines[i][0].length > trimIndent && (chompStart = i + 1);
      let value = "", sep3 = "", prevMoreIndented = !1;
      for (let i = 0; i < contentStart; ++i)
        value += lines[i][0].slice(trimIndent) + `
`;
      for (let i = contentStart; i < chompStart; ++i) {
        let [indent, content] = lines[i];
        offset += indent.length + content.length + 1;
        let crlf = content[content.length - 1] === "\r";
        if (crlf && (content = content.slice(0, -1)), content && indent.length < trimIndent) {
          let message = `Block scalar lines must not be less indented than their ${header2.indent ? "explicit indentation indicator" : "first line"}`;
          onError(offset - content.length - (crlf ? 2 : 1), "BAD_INDENT", message), indent = "";
        }
        type === Scalar.Scalar.BLOCK_LITERAL ? (value += sep3 + indent.slice(trimIndent) + content, sep3 = `
`) : indent.length > trimIndent || content[0] === "	" ? (sep3 === " " ? sep3 = `
` : !prevMoreIndented && sep3 === `
` && (sep3 = `

`), value += sep3 + indent.slice(trimIndent) + content, sep3 = `
`, prevMoreIndented = !0) : content === "" ? sep3 === `
` ? value += `
` : sep3 = `
` : (value += sep3 + content, sep3 = " ", prevMoreIndented = !1);
      }
      switch (header2.chomp) {
        case "-":
          break;
        case "+":
          for (let i = chompStart; i < lines.length; ++i)
            value += `
` + lines[i][0].slice(trimIndent);
          value[value.length - 1] !== `
` && (value += `
`);
          break;
        default:
          value += `
`;
      }
      let end = start + header2.length + scalar.source.length;
      return { value, type, comment: header2.comment, range: [start, end, end] };
    }
    function parseBlockScalarHeader({ offset, props }, strict, onError) {
      if (props[0].type !== "block-scalar-header")
        return onError(props[0], "IMPOSSIBLE", "Block scalar header not found"), null;
      let { source } = props[0], mode = source[0], indent = 0, chomp = "", error = -1;
      for (let i = 1; i < source.length; ++i) {
        let ch = source[i];
        if (!chomp && (ch === "-" || ch === "+"))
          chomp = ch;
        else {
          let n = Number(ch);
          !indent && n ? indent = n : error === -1 && (error = offset + i);
        }
      }
      error !== -1 && onError(error, "UNEXPECTED_TOKEN", `Block scalar header includes extra characters: ${source}`);
      let hasSpace = !1, comment = "", length = source.length;
      for (let i = 1; i < props.length; ++i) {
        let token = props[i];
        switch (token.type) {
          case "space":
            hasSpace = !0;
          case "newline":
            length += token.source.length;
            break;
          case "comment":
            strict && !hasSpace && onError(token, "MISSING_CHAR", "Comments must be separated from other tokens by white space characters"), length += token.source.length, comment = token.source.substring(1);
            break;
          case "error":
            onError(token, "UNEXPECTED_TOKEN", token.message), length += token.source.length;
            break;
          default: {
            let message = `Unexpected token in block scalar header: ${token.type}`;
            onError(token, "UNEXPECTED_TOKEN", message);
            let ts = token.source;
            ts && typeof ts == "string" && (length += ts.length);
          }
        }
      }
      return { mode, indent, chomp, comment, length };
    }
    function splitLines(source) {
      let split = source.split(/\n( *)/), first = split[0], m = first.match(/^( *)/), lines = [m?.[1] ? [m[1], first.slice(m[1].length)] : ["", first]];
      for (let i = 1; i < split.length; i += 2)
        lines.push([split[i], split[i + 1]]);
      return lines;
    }
    exports.resolveBlockScalar = resolveBlockScalar;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/resolve-flow-scalar.js
var require_resolve_flow_scalar = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/resolve-flow-scalar.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Scalar = require_Scalar(), resolveEnd = require_resolve_end();
    function resolveFlowScalar(scalar, strict, onError) {
      let { offset, type, source, end } = scalar, _type, value, _onError = (rel, code, msg) => onError(offset + rel, code, msg);
      switch (type) {
        case "scalar":
          _type = Scalar.Scalar.PLAIN, value = plainValue(source, _onError);
          break;
        case "single-quoted-scalar":
          _type = Scalar.Scalar.QUOTE_SINGLE, value = singleQuotedValue(source, _onError);
          break;
        case "double-quoted-scalar":
          _type = Scalar.Scalar.QUOTE_DOUBLE, value = doubleQuotedValue(source, _onError);
          break;
        default:
          return onError(scalar, "UNEXPECTED_TOKEN", `Expected a flow scalar value, but found: ${type}`), {
            value: "",
            type: null,
            comment: "",
            range: [offset, offset + source.length, offset + source.length]
          };
      }
      let valueEnd = offset + source.length, re = resolveEnd.resolveEnd(end, valueEnd, strict, onError);
      return {
        value,
        type: _type,
        comment: re.comment,
        range: [offset, valueEnd, re.offset]
      };
    }
    function plainValue(source, onError) {
      let badChar = "";
      switch (source[0]) {
        case "	":
          badChar = "a tab character";
          break;
        case ",":
          badChar = "flow indicator character ,";
          break;
        case "%":
          badChar = "directive indicator character %";
          break;
        case "|":
        case ">": {
          badChar = `block scalar indicator ${source[0]}`;
          break;
        }
        case "@":
        case "`": {
          badChar = `reserved character ${source[0]}`;
          break;
        }
      }
      return badChar && onError(0, "BAD_SCALAR_START", `Plain value cannot start with ${badChar}`), foldLines(source);
    }
    function singleQuotedValue(source, onError) {
      return (source[source.length - 1] !== "'" || source.length === 1) && onError(source.length, "MISSING_CHAR", "Missing closing 'quote"), foldLines(source.slice(1, -1)).replace(/''/g, "'");
    }
    function foldLines(source) {
      let first, line;
      try {
        first = new RegExp(`(.*?)(?<![ 	])[ 	]*\r?
`, "sy"), line = new RegExp(`[ 	]*(.*?)(?:(?<![ 	])[ 	]*)?\r?
`, "sy");
      } catch {
        first = /(.*?)[ \t]*\r?\n/sy, line = /[ \t]*(.*?)[ \t]*\r?\n/sy;
      }
      let match2 = first.exec(source);
      if (!match2)
        return source;
      let res = match2[1], sep3 = " ", pos = first.lastIndex;
      for (line.lastIndex = pos; match2 = line.exec(source); )
        match2[1] === "" ? sep3 === `
` ? res += sep3 : sep3 = `
` : (res += sep3 + match2[1], sep3 = " "), pos = line.lastIndex;
      let last = /[ \t]*(.*)/sy;
      return last.lastIndex = pos, match2 = last.exec(source), res + sep3 + (match2?.[1] ?? "");
    }
    function doubleQuotedValue(source, onError) {
      let res = "";
      for (let i = 1; i < source.length - 1; ++i) {
        let ch = source[i];
        if (!(ch === "\r" && source[i + 1] === `
`))
          if (ch === `
`) {
            let { fold, offset } = foldNewline(source, i);
            res += fold, i = offset;
          } else if (ch === "\\") {
            let next = source[++i], cc = escapeCodes[next];
            if (cc)
              res += cc;
            else if (next === `
`)
              for (next = source[i + 1]; next === " " || next === "	"; )
                next = source[++i + 1];
            else if (next === "\r" && source[i + 1] === `
`)
              for (next = source[++i + 1]; next === " " || next === "	"; )
                next = source[++i + 1];
            else if (next === "x" || next === "u" || next === "U") {
              let length = { x: 2, u: 4, U: 8 }[next];
              res += parseCharCode(source, i + 1, length, onError), i += length;
            } else {
              let raw = source.substr(i - 1, 2);
              onError(i - 1, "BAD_DQ_ESCAPE", `Invalid escape sequence ${raw}`), res += raw;
            }
          } else if (ch === " " || ch === "	") {
            let wsStart = i, next = source[i + 1];
            for (; next === " " || next === "	"; )
              next = source[++i + 1];
            next !== `
` && !(next === "\r" && source[i + 2] === `
`) && (res += i > wsStart ? source.slice(wsStart, i + 1) : ch);
          } else
            res += ch;
      }
      return (source[source.length - 1] !== '"' || source.length === 1) && onError(source.length, "MISSING_CHAR", 'Missing closing "quote'), res;
    }
    function foldNewline(source, offset) {
      let fold = "", ch = source[offset + 1];
      for (; (ch === " " || ch === "	" || ch === `
` || ch === "\r") && !(ch === "\r" && source[offset + 2] !== `
`); )
        ch === `
` && (fold += `
`), offset += 1, ch = source[offset + 1];
      return fold || (fold = " "), { fold, offset };
    }
    var escapeCodes = {
      0: "\0",
      a: "\x07",
      b: "\b",
      e: "\x1B",
      f: "\f",
      n: `
`,
      r: "\r",
      t: "	",
      v: "\v",
      N: "\x85",
      _: "\xA0",
      L: "\u2028",
      P: "\u2029",
      " ": " ",
      '"': '"',
      "/": "/",
      "\\": "\\",
      "	": "	"
    };
    function parseCharCode(source, offset, length, onError) {
      let cc = source.substr(offset, length), code = cc.length === length && /^[0-9a-fA-F]+$/.test(cc) ? parseInt(cc, 16) : NaN;
      if (isNaN(code)) {
        let raw = source.substr(offset - 2, length + 2);
        return onError(offset - 2, "BAD_DQ_ESCAPE", `Invalid escape sequence ${raw}`), raw;
      }
      return String.fromCodePoint(code);
    }
    exports.resolveFlowScalar = resolveFlowScalar;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/compose-scalar.js
var require_compose_scalar = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/compose-scalar.js"(exports) {
    "use strict";
    init_cjs_shims();
    var identity = require_identity(), Scalar = require_Scalar(), resolveBlockScalar = require_resolve_block_scalar(), resolveFlowScalar = require_resolve_flow_scalar();
    function composeScalar(ctx, token, tagToken, onError) {
      let { value, type, comment, range } = token.type === "block-scalar" ? resolveBlockScalar.resolveBlockScalar(token, ctx.options.strict, onError) : resolveFlowScalar.resolveFlowScalar(token, ctx.options.strict, onError), tagName = tagToken ? ctx.directives.tagName(tagToken.source, (msg) => onError(tagToken, "TAG_RESOLVE_FAILED", msg)) : null, tag = tagToken && tagName ? findScalarTagByName(ctx.schema, value, tagName, tagToken, onError) : token.type === "scalar" ? findScalarTagByTest(ctx, value, token, onError) : ctx.schema[identity.SCALAR], scalar;
      try {
        let res = tag.resolve(value, (msg) => onError(tagToken ?? token, "TAG_RESOLVE_FAILED", msg), ctx.options);
        scalar = identity.isScalar(res) ? res : new Scalar.Scalar(res);
      } catch (error) {
        let msg = error instanceof Error ? error.message : String(error);
        onError(tagToken ?? token, "TAG_RESOLVE_FAILED", msg), scalar = new Scalar.Scalar(value);
      }
      return scalar.range = range, scalar.source = value, type && (scalar.type = type), tagName && (scalar.tag = tagName), tag.format && (scalar.format = tag.format), comment && (scalar.comment = comment), scalar;
    }
    function findScalarTagByName(schema, value, tagName, tagToken, onError) {
      if (tagName === "!")
        return schema[identity.SCALAR];
      let matchWithTest = [];
      for (let tag of schema.tags)
        if (!tag.collection && tag.tag === tagName)
          if (tag.default && tag.test)
            matchWithTest.push(tag);
          else
            return tag;
      for (let tag of matchWithTest)
        if (tag.test?.test(value))
          return tag;
      let kt = schema.knownTags[tagName];
      return kt && !kt.collection ? (schema.tags.push(Object.assign({}, kt, { default: !1, test: void 0 })), kt) : (onError(tagToken, "TAG_RESOLVE_FAILED", `Unresolved tag: ${tagName}`, tagName !== "tag:yaml.org,2002:str"), schema[identity.SCALAR]);
    }
    function findScalarTagByTest({ directives, schema }, value, token, onError) {
      let tag = schema.tags.find((tag2) => tag2.default && tag2.test?.test(value)) || schema[identity.SCALAR];
      if (schema.compat) {
        let compat = schema.compat.find((tag2) => tag2.default && tag2.test?.test(value)) ?? schema[identity.SCALAR];
        if (tag.tag !== compat.tag) {
          let ts = directives.tagString(tag.tag), cs = directives.tagString(compat.tag), msg = `Value may be parsed as either ${ts} or ${cs}`;
          onError(token, "TAG_RESOLVE_FAILED", msg, !0);
        }
      }
      return tag;
    }
    exports.composeScalar = composeScalar;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/util-empty-scalar-position.js
var require_util_empty_scalar_position = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/util-empty-scalar-position.js"(exports) {
    "use strict";
    init_cjs_shims();
    function emptyScalarPosition(offset, before, pos) {
      if (before) {
        pos === null && (pos = before.length);
        for (let i = pos - 1; i >= 0; --i) {
          let st = before[i];
          switch (st.type) {
            case "space":
            case "comment":
            case "newline":
              offset -= st.source.length;
              continue;
          }
          for (st = before[++i]; st?.type === "space"; )
            offset += st.source.length, st = before[++i];
          break;
        }
      }
      return offset;
    }
    exports.emptyScalarPosition = emptyScalarPosition;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/compose-node.js
var require_compose_node = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/compose-node.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Alias = require_Alias(), composeCollection = require_compose_collection(), composeScalar = require_compose_scalar(), resolveEnd = require_resolve_end(), utilEmptyScalarPosition = require_util_empty_scalar_position(), CN = { composeNode, composeEmptyNode };
    function composeNode(ctx, token, props, onError) {
      let { spaceBefore, comment, anchor, tag } = props, node, isSrcToken = !0;
      switch (token.type) {
        case "alias":
          node = composeAlias(ctx, token, onError), (anchor || tag) && onError(token, "ALIAS_PROPS", "An alias node must not specify any properties");
          break;
        case "scalar":
        case "single-quoted-scalar":
        case "double-quoted-scalar":
        case "block-scalar":
          node = composeScalar.composeScalar(ctx, token, tag, onError), anchor && (node.anchor = anchor.source.substring(1));
          break;
        case "block-map":
        case "block-seq":
        case "flow-collection":
          node = composeCollection.composeCollection(CN, ctx, token, tag, onError), anchor && (node.anchor = anchor.source.substring(1));
          break;
        default: {
          let message = token.type === "error" ? token.message : `Unsupported token (type: ${token.type})`;
          onError(token, "UNEXPECTED_TOKEN", message), node = composeEmptyNode(ctx, token.offset, void 0, null, props, onError), isSrcToken = !1;
        }
      }
      return anchor && node.anchor === "" && onError(anchor, "BAD_ALIAS", "Anchor cannot be an empty string"), spaceBefore && (node.spaceBefore = !0), comment && (token.type === "scalar" && token.source === "" ? node.comment = comment : node.commentBefore = comment), ctx.options.keepSourceTokens && isSrcToken && (node.srcToken = token), node;
    }
    function composeEmptyNode(ctx, offset, before, pos, { spaceBefore, comment, anchor, tag, end }, onError) {
      let token = {
        type: "scalar",
        offset: utilEmptyScalarPosition.emptyScalarPosition(offset, before, pos),
        indent: -1,
        source: ""
      }, node = composeScalar.composeScalar(ctx, token, tag, onError);
      return anchor && (node.anchor = anchor.source.substring(1), node.anchor === "" && onError(anchor, "BAD_ALIAS", "Anchor cannot be an empty string")), spaceBefore && (node.spaceBefore = !0), comment && (node.comment = comment, node.range[2] = end), node;
    }
    function composeAlias({ options }, { offset, source, end }, onError) {
      let alias = new Alias.Alias(source.substring(1));
      alias.source === "" && onError(offset, "BAD_ALIAS", "Alias cannot be an empty string"), alias.source.endsWith(":") && onError(offset + source.length - 1, "BAD_ALIAS", "Alias ending in : is ambiguous", !0);
      let valueEnd = offset + source.length, re = resolveEnd.resolveEnd(end, valueEnd, options.strict, onError);
      return alias.range = [offset, valueEnd, re.offset], re.comment && (alias.comment = re.comment), alias;
    }
    exports.composeEmptyNode = composeEmptyNode;
    exports.composeNode = composeNode;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/compose-doc.js
var require_compose_doc = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/compose-doc.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Document = require_Document(), composeNode = require_compose_node(), resolveEnd = require_resolve_end(), resolveProps = require_resolve_props();
    function composeDoc(options, directives, { offset, start, value, end }, onError) {
      let opts = Object.assign({ _directives: directives }, options), doc = new Document.Document(void 0, opts), ctx = {
        atRoot: !0,
        directives: doc.directives,
        options: doc.options,
        schema: doc.schema
      }, props = resolveProps.resolveProps(start, {
        indicator: "doc-start",
        next: value ?? end?.[0],
        offset,
        onError,
        startOnNewline: !0
      });
      props.found && (doc.directives.docStart = !0, value && (value.type === "block-map" || value.type === "block-seq") && !props.hasNewline && onError(props.end, "MISSING_CHAR", "Block collection cannot start on same line with directives-end marker")), doc.contents = value ? composeNode.composeNode(ctx, value, props, onError) : composeNode.composeEmptyNode(ctx, props.end, start, null, props, onError);
      let contentEnd = doc.contents.range[2], re = resolveEnd.resolveEnd(end, contentEnd, !1, onError);
      return re.comment && (doc.comment = re.comment), doc.range = [offset, contentEnd, re.offset], doc;
    }
    exports.composeDoc = composeDoc;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/composer.js
var require_composer = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/compose/composer.js"(exports) {
    "use strict";
    init_cjs_shims();
    var directives = require_directives(), Document = require_Document(), errors2 = require_errors3(), identity = require_identity(), composeDoc = require_compose_doc(), resolveEnd = require_resolve_end();
    function getErrorPos(src) {
      if (typeof src == "number")
        return [src, src + 1];
      if (Array.isArray(src))
        return src.length === 2 ? src : [src[0], src[1]];
      let { offset, source } = src;
      return [offset, offset + (typeof source == "string" ? source.length : 1)];
    }
    function parsePrelude(prelude) {
      let comment = "", atComment = !1, afterEmptyLine = !1;
      for (let i = 0; i < prelude.length; ++i) {
        let source = prelude[i];
        switch (source[0]) {
          case "#":
            comment += (comment === "" ? "" : afterEmptyLine ? `

` : `
`) + (source.substring(1) || " "), atComment = !0, afterEmptyLine = !1;
            break;
          case "%":
            prelude[i + 1]?.[0] !== "#" && (i += 1), atComment = !1;
            break;
          default:
            atComment || (afterEmptyLine = !0), atComment = !1;
        }
      }
      return { comment, afterEmptyLine };
    }
    var Composer = class {
      constructor(options = {}) {
        this.doc = null, this.atDirectives = !1, this.prelude = [], this.errors = [], this.warnings = [], this.onError = (source, code, message, warning) => {
          let pos = getErrorPos(source);
          warning ? this.warnings.push(new errors2.YAMLWarning(pos, code, message)) : this.errors.push(new errors2.YAMLParseError(pos, code, message));
        }, this.directives = new directives.Directives({ version: options.version || "1.2" }), this.options = options;
      }
      decorate(doc, afterDoc) {
        let { comment, afterEmptyLine } = parsePrelude(this.prelude);
        if (comment) {
          let dc = doc.contents;
          if (afterDoc)
            doc.comment = doc.comment ? `${doc.comment}
${comment}` : comment;
          else if (afterEmptyLine || doc.directives.docStart || !dc)
            doc.commentBefore = comment;
          else if (identity.isCollection(dc) && !dc.flow && dc.items.length > 0) {
            let it = dc.items[0];
            identity.isPair(it) && (it = it.key);
            let cb = it.commentBefore;
            it.commentBefore = cb ? `${comment}
${cb}` : comment;
          } else {
            let cb = dc.commentBefore;
            dc.commentBefore = cb ? `${comment}
${cb}` : comment;
          }
        }
        afterDoc ? (Array.prototype.push.apply(doc.errors, this.errors), Array.prototype.push.apply(doc.warnings, this.warnings)) : (doc.errors = this.errors, doc.warnings = this.warnings), this.prelude = [], this.errors = [], this.warnings = [];
      }
      /**
       * Current stream status information.
       *
       * Mostly useful at the end of input for an empty stream.
       */
      streamInfo() {
        return {
          comment: parsePrelude(this.prelude).comment,
          directives: this.directives,
          errors: this.errors,
          warnings: this.warnings
        };
      }
      /**
       * Compose tokens into documents.
       *
       * @param forceDoc - If the stream contains no document, still emit a final document including any comments and directives that would be applied to a subsequent document.
       * @param endOffset - Should be set if `forceDoc` is also set, to set the document range end and to indicate errors correctly.
       */
      *compose(tokens, forceDoc = !1, endOffset = -1) {
        for (let token of tokens)
          yield* this.next(token);
        yield* this.end(forceDoc, endOffset);
      }
      /** Advance the composer by one CST token. */
      *next(token) {
        switch (process.env.LOG_STREAM && console.dir(token, { depth: null }), token.type) {
          case "directive":
            this.directives.add(token.source, (offset, message, warning) => {
              let pos = getErrorPos(token);
              pos[0] += offset, this.onError(pos, "BAD_DIRECTIVE", message, warning);
            }), this.prelude.push(token.source), this.atDirectives = !0;
            break;
          case "document": {
            let doc = composeDoc.composeDoc(this.options, this.directives, token, this.onError);
            this.atDirectives && !doc.directives.docStart && this.onError(token, "MISSING_CHAR", "Missing directives-end/doc-start indicator line"), this.decorate(doc, !1), this.doc && (yield this.doc), this.doc = doc, this.atDirectives = !1;
            break;
          }
          case "byte-order-mark":
          case "space":
            break;
          case "comment":
          case "newline":
            this.prelude.push(token.source);
            break;
          case "error": {
            let msg = token.source ? `${token.message}: ${JSON.stringify(token.source)}` : token.message, error = new errors2.YAMLParseError(getErrorPos(token), "UNEXPECTED_TOKEN", msg);
            this.atDirectives || !this.doc ? this.errors.push(error) : this.doc.errors.push(error);
            break;
          }
          case "doc-end": {
            if (!this.doc) {
              let msg = "Unexpected doc-end without preceding document";
              this.errors.push(new errors2.YAMLParseError(getErrorPos(token), "UNEXPECTED_TOKEN", msg));
              break;
            }
            this.doc.directives.docEnd = !0;
            let end = resolveEnd.resolveEnd(token.end, token.offset + token.source.length, this.doc.options.strict, this.onError);
            if (this.decorate(this.doc, !0), end.comment) {
              let dc = this.doc.comment;
              this.doc.comment = dc ? `${dc}
${end.comment}` : end.comment;
            }
            this.doc.range[2] = end.offset;
            break;
          }
          default:
            this.errors.push(new errors2.YAMLParseError(getErrorPos(token), "UNEXPECTED_TOKEN", `Unsupported token ${token.type}`));
        }
      }
      /**
       * Call at end of input to yield any remaining document.
       *
       * @param forceDoc - If the stream contains no document, still emit a final document including any comments and directives that would be applied to a subsequent document.
       * @param endOffset - Should be set if `forceDoc` is also set, to set the document range end and to indicate errors correctly.
       */
      *end(forceDoc = !1, endOffset = -1) {
        if (this.doc)
          this.decorate(this.doc, !0), yield this.doc, this.doc = null;
        else if (forceDoc) {
          let opts = Object.assign({ _directives: this.directives }, this.options), doc = new Document.Document(void 0, opts);
          this.atDirectives && this.onError(endOffset, "MISSING_CHAR", "Missing directives-end indicator line"), doc.range = [0, endOffset, endOffset], this.decorate(doc, !1), yield doc;
        }
      }
    };
    exports.Composer = Composer;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/parse/cst-scalar.js
var require_cst_scalar = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/parse/cst-scalar.js"(exports) {
    "use strict";
    init_cjs_shims();
    var resolveBlockScalar = require_resolve_block_scalar(), resolveFlowScalar = require_resolve_flow_scalar(), errors2 = require_errors3(), stringifyString = require_stringifyString();
    function resolveAsScalar(token, strict = !0, onError) {
      if (token) {
        let _onError = (pos, code, message) => {
          let offset = typeof pos == "number" ? pos : Array.isArray(pos) ? pos[0] : pos.offset;
          if (onError)
            onError(offset, code, message);
          else
            throw new errors2.YAMLParseError([offset, offset + 1], code, message);
        };
        switch (token.type) {
          case "scalar":
          case "single-quoted-scalar":
          case "double-quoted-scalar":
            return resolveFlowScalar.resolveFlowScalar(token, strict, _onError);
          case "block-scalar":
            return resolveBlockScalar.resolveBlockScalar(token, strict, _onError);
        }
      }
      return null;
    }
    function createScalarToken(value, context) {
      let { implicitKey = !1, indent, inFlow = !1, offset = -1, type = "PLAIN" } = context, source = stringifyString.stringifyString({ type, value }, {
        implicitKey,
        indent: indent > 0 ? " ".repeat(indent) : "",
        inFlow,
        options: { blockQuote: !0, lineWidth: -1 }
      }), end = context.end ?? [
        { type: "newline", offset: -1, indent, source: `
` }
      ];
      switch (source[0]) {
        case "|":
        case ">": {
          let he = source.indexOf(`
`), head = source.substring(0, he), body = source.substring(he + 1) + `
`, props = [
            { type: "block-scalar-header", offset, indent, source: head }
          ];
          return addEndtoBlockProps(props, end) || props.push({ type: "newline", offset: -1, indent, source: `
` }), { type: "block-scalar", offset, indent, props, source: body };
        }
        case '"':
          return { type: "double-quoted-scalar", offset, indent, source, end };
        case "'":
          return { type: "single-quoted-scalar", offset, indent, source, end };
        default:
          return { type: "scalar", offset, indent, source, end };
      }
    }
    function setScalarValue(token, value, context = {}) {
      let { afterKey = !1, implicitKey = !1, inFlow = !1, type } = context, indent = "indent" in token ? token.indent : null;
      if (afterKey && typeof indent == "number" && (indent += 2), !type)
        switch (token.type) {
          case "single-quoted-scalar":
            type = "QUOTE_SINGLE";
            break;
          case "double-quoted-scalar":
            type = "QUOTE_DOUBLE";
            break;
          case "block-scalar": {
            let header2 = token.props[0];
            if (header2.type !== "block-scalar-header")
              throw new Error("Invalid block scalar header");
            type = header2.source[0] === ">" ? "BLOCK_FOLDED" : "BLOCK_LITERAL";
            break;
          }
          default:
            type = "PLAIN";
        }
      let source = stringifyString.stringifyString({ type, value }, {
        implicitKey: implicitKey || indent === null,
        indent: indent !== null && indent > 0 ? " ".repeat(indent) : "",
        inFlow,
        options: { blockQuote: !0, lineWidth: -1 }
      });
      switch (source[0]) {
        case "|":
        case ">":
          setBlockScalarValue(token, source);
          break;
        case '"':
          setFlowScalarValue(token, source, "double-quoted-scalar");
          break;
        case "'":
          setFlowScalarValue(token, source, "single-quoted-scalar");
          break;
        default:
          setFlowScalarValue(token, source, "scalar");
      }
    }
    function setBlockScalarValue(token, source) {
      let he = source.indexOf(`
`), head = source.substring(0, he), body = source.substring(he + 1) + `
`;
      if (token.type === "block-scalar") {
        let header2 = token.props[0];
        if (header2.type !== "block-scalar-header")
          throw new Error("Invalid block scalar header");
        header2.source = head, token.source = body;
      } else {
        let { offset } = token, indent = "indent" in token ? token.indent : -1, props = [
          { type: "block-scalar-header", offset, indent, source: head }
        ];
        addEndtoBlockProps(props, "end" in token ? token.end : void 0) || props.push({ type: "newline", offset: -1, indent, source: `
` });
        for (let key of Object.keys(token))
          key !== "type" && key !== "offset" && delete token[key];
        Object.assign(token, { type: "block-scalar", indent, props, source: body });
      }
    }
    function addEndtoBlockProps(props, end) {
      if (end)
        for (let st of end)
          switch (st.type) {
            case "space":
            case "comment":
              props.push(st);
              break;
            case "newline":
              return props.push(st), !0;
          }
      return !1;
    }
    function setFlowScalarValue(token, source, type) {
      switch (token.type) {
        case "scalar":
        case "double-quoted-scalar":
        case "single-quoted-scalar":
          token.type = type, token.source = source;
          break;
        case "block-scalar": {
          let end = token.props.slice(1), oa = source.length;
          token.props[0].type === "block-scalar-header" && (oa -= token.props[0].source.length);
          for (let tok of end)
            tok.offset += oa;
          delete token.props, Object.assign(token, { type, source, end });
          break;
        }
        case "block-map":
        case "block-seq": {
          let nl = { type: "newline", offset: token.offset + source.length, indent: token.indent, source: `
` };
          delete token.items, Object.assign(token, { type, source, end: [nl] });
          break;
        }
        default: {
          let indent = "indent" in token ? token.indent : -1, end = "end" in token && Array.isArray(token.end) ? token.end.filter((st) => st.type === "space" || st.type === "comment" || st.type === "newline") : [];
          for (let key of Object.keys(token))
            key !== "type" && key !== "offset" && delete token[key];
          Object.assign(token, { type, indent, source, end });
        }
      }
    }
    exports.createScalarToken = createScalarToken;
    exports.resolveAsScalar = resolveAsScalar;
    exports.setScalarValue = setScalarValue;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/parse/cst-stringify.js
var require_cst_stringify = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/parse/cst-stringify.js"(exports) {
    "use strict";
    init_cjs_shims();
    var stringify = (cst) => "type" in cst ? stringifyToken(cst) : stringifyItem(cst);
    function stringifyToken(token) {
      switch (token.type) {
        case "block-scalar": {
          let res = "";
          for (let tok of token.props)
            res += stringifyToken(tok);
          return res + token.source;
        }
        case "block-map":
        case "block-seq": {
          let res = "";
          for (let item of token.items)
            res += stringifyItem(item);
          return res;
        }
        case "flow-collection": {
          let res = token.start.source;
          for (let item of token.items)
            res += stringifyItem(item);
          for (let st of token.end)
            res += st.source;
          return res;
        }
        case "document": {
          let res = stringifyItem(token);
          if (token.end)
            for (let st of token.end)
              res += st.source;
          return res;
        }
        default: {
          let res = token.source;
          if ("end" in token && token.end)
            for (let st of token.end)
              res += st.source;
          return res;
        }
      }
    }
    function stringifyItem({ start, key, sep: sep3, value }) {
      let res = "";
      for (let st of start)
        res += st.source;
      if (key && (res += stringifyToken(key)), sep3)
        for (let st of sep3)
          res += st.source;
      return value && (res += stringifyToken(value)), res;
    }
    exports.stringify = stringify;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/parse/cst-visit.js
var require_cst_visit = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/parse/cst-visit.js"(exports) {
    "use strict";
    init_cjs_shims();
    var BREAK = Symbol("break visit"), SKIP = Symbol("skip children"), REMOVE = Symbol("remove item");
    function visit3(cst, visitor) {
      "type" in cst && cst.type === "document" && (cst = { start: cst.start, value: cst.value }), _visit(Object.freeze([]), cst, visitor);
    }
    visit3.BREAK = BREAK;
    visit3.SKIP = SKIP;
    visit3.REMOVE = REMOVE;
    visit3.itemAtPath = (cst, path3) => {
      let item = cst;
      for (let [field, index] of path3) {
        let tok = item?.[field];
        if (tok && "items" in tok)
          item = tok.items[index];
        else
          return;
      }
      return item;
    };
    visit3.parentCollection = (cst, path3) => {
      let parent = visit3.itemAtPath(cst, path3.slice(0, -1)), field = path3[path3.length - 1][0], coll = parent?.[field];
      if (coll && "items" in coll)
        return coll;
      throw new Error("Parent collection not found");
    };
    function _visit(path3, item, visitor) {
      let ctrl = visitor(item, path3);
      if (typeof ctrl == "symbol")
        return ctrl;
      for (let field of ["key", "value"]) {
        let token = item[field];
        if (token && "items" in token) {
          for (let i = 0; i < token.items.length; ++i) {
            let ci = _visit(Object.freeze(path3.concat([[field, i]])), token.items[i], visitor);
            if (typeof ci == "number")
              i = ci - 1;
            else {
              if (ci === BREAK)
                return BREAK;
              ci === REMOVE && (token.items.splice(i, 1), i -= 1);
            }
          }
          typeof ctrl == "function" && field === "key" && (ctrl = ctrl(item, path3));
        }
      }
      return typeof ctrl == "function" ? ctrl(item, path3) : ctrl;
    }
    exports.visit = visit3;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/parse/cst.js
var require_cst = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/parse/cst.js"(exports) {
    "use strict";
    init_cjs_shims();
    var cstScalar = require_cst_scalar(), cstStringify = require_cst_stringify(), cstVisit = require_cst_visit(), BOM = "\uFEFF", DOCUMENT = "", FLOW_END = "", SCALAR = "", isCollection = (token) => !!token && "items" in token, isScalar = (token) => !!token && (token.type === "scalar" || token.type === "single-quoted-scalar" || token.type === "double-quoted-scalar" || token.type === "block-scalar");
    function prettyToken(token) {
      switch (token) {
        case BOM:
          return "<BOM>";
        case DOCUMENT:
          return "<DOC>";
        case FLOW_END:
          return "<FLOW_END>";
        case SCALAR:
          return "<SCALAR>";
        default:
          return JSON.stringify(token);
      }
    }
    function tokenType(source) {
      switch (source) {
        case BOM:
          return "byte-order-mark";
        case DOCUMENT:
          return "doc-mode";
        case FLOW_END:
          return "flow-error-end";
        case SCALAR:
          return "scalar";
        case "---":
          return "doc-start";
        case "...":
          return "doc-end";
        case "":
        case `
`:
        case `\r
`:
          return "newline";
        case "-":
          return "seq-item-ind";
        case "?":
          return "explicit-key-ind";
        case ":":
          return "map-value-ind";
        case "{":
          return "flow-map-start";
        case "}":
          return "flow-map-end";
        case "[":
          return "flow-seq-start";
        case "]":
          return "flow-seq-end";
        case ",":
          return "comma";
      }
      switch (source[0]) {
        case " ":
        case "	":
          return "space";
        case "#":
          return "comment";
        case "%":
          return "directive-line";
        case "*":
          return "alias";
        case "&":
          return "anchor";
        case "!":
          return "tag";
        case "'":
          return "single-quoted-scalar";
        case '"':
          return "double-quoted-scalar";
        case "|":
        case ">":
          return "block-scalar-header";
      }
      return null;
    }
    exports.createScalarToken = cstScalar.createScalarToken;
    exports.resolveAsScalar = cstScalar.resolveAsScalar;
    exports.setScalarValue = cstScalar.setScalarValue;
    exports.stringify = cstStringify.stringify;
    exports.visit = cstVisit.visit;
    exports.BOM = BOM;
    exports.DOCUMENT = DOCUMENT;
    exports.FLOW_END = FLOW_END;
    exports.SCALAR = SCALAR;
    exports.isCollection = isCollection;
    exports.isScalar = isScalar;
    exports.prettyToken = prettyToken;
    exports.tokenType = tokenType;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/parse/lexer.js
var require_lexer = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/parse/lexer.js"(exports) {
    "use strict";
    init_cjs_shims();
    var cst = require_cst();
    function isEmpty2(ch) {
      switch (ch) {
        case void 0:
        case " ":
        case `
`:
        case "\r":
        case "	":
          return !0;
        default:
          return !1;
      }
    }
    var hexDigits = "0123456789ABCDEFabcdef".split(""), tagChars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-#;/?:@&=+$_.!~*'()".split(""), invalidFlowScalarChars = ",[]{}".split(""), invalidAnchorChars = ` ,[]{}
\r	`.split(""), isNotAnchorChar = (ch) => !ch || invalidAnchorChars.includes(ch), Lexer = class {
      constructor() {
        this.atEnd = !1, this.blockScalarIndent = -1, this.blockScalarKeep = !1, this.buffer = "", this.flowKey = !1, this.flowLevel = 0, this.indentNext = 0, this.indentValue = 0, this.lineEndPos = null, this.next = null, this.pos = 0;
      }
      /**
       * Generate YAML tokens from the `source` string. If `incomplete`,
       * a part of the last line may be left as a buffer for the next call.
       *
       * @returns A generator of lexical tokens
       */
      *lex(source, incomplete = !1) {
        source && (this.buffer = this.buffer ? this.buffer + source : source, this.lineEndPos = null), this.atEnd = !incomplete;
        let next = this.next ?? "stream";
        for (; next && (incomplete || this.hasChars(1)); )
          next = yield* this.parseNext(next);
      }
      atLineEnd() {
        let i = this.pos, ch = this.buffer[i];
        for (; ch === " " || ch === "	"; )
          ch = this.buffer[++i];
        return !ch || ch === "#" || ch === `
` ? !0 : ch === "\r" ? this.buffer[i + 1] === `
` : !1;
      }
      charAt(n) {
        return this.buffer[this.pos + n];
      }
      continueScalar(offset) {
        let ch = this.buffer[offset];
        if (this.indentNext > 0) {
          let indent = 0;
          for (; ch === " "; )
            ch = this.buffer[++indent + offset];
          if (ch === "\r") {
            let next = this.buffer[indent + offset + 1];
            if (next === `
` || !next && !this.atEnd)
              return offset + indent + 1;
          }
          return ch === `
` || indent >= this.indentNext || !ch && !this.atEnd ? offset + indent : -1;
        }
        if (ch === "-" || ch === ".") {
          let dt = this.buffer.substr(offset, 3);
          if ((dt === "---" || dt === "...") && isEmpty2(this.buffer[offset + 3]))
            return -1;
        }
        return offset;
      }
      getLine() {
        let end = this.lineEndPos;
        return (typeof end != "number" || end !== -1 && end < this.pos) && (end = this.buffer.indexOf(`
`, this.pos), this.lineEndPos = end), end === -1 ? this.atEnd ? this.buffer.substring(this.pos) : null : (this.buffer[end - 1] === "\r" && (end -= 1), this.buffer.substring(this.pos, end));
      }
      hasChars(n) {
        return this.pos + n <= this.buffer.length;
      }
      setNext(state) {
        return this.buffer = this.buffer.substring(this.pos), this.pos = 0, this.lineEndPos = null, this.next = state, null;
      }
      peek(n) {
        return this.buffer.substr(this.pos, n);
      }
      *parseNext(next) {
        switch (next) {
          case "stream":
            return yield* this.parseStream();
          case "line-start":
            return yield* this.parseLineStart();
          case "block-start":
            return yield* this.parseBlockStart();
          case "doc":
            return yield* this.parseDocument();
          case "flow":
            return yield* this.parseFlowCollection();
          case "quoted-scalar":
            return yield* this.parseQuotedScalar();
          case "block-scalar":
            return yield* this.parseBlockScalar();
          case "plain-scalar":
            return yield* this.parsePlainScalar();
        }
      }
      *parseStream() {
        let line = this.getLine();
        if (line === null)
          return this.setNext("stream");
        if (line[0] === cst.BOM && (yield* this.pushCount(1), line = line.substring(1)), line[0] === "%") {
          let dirEnd = line.length, cs = line.indexOf("#");
          if (cs !== -1) {
            let ch = line[cs - 1];
            (ch === " " || ch === "	") && (dirEnd = cs - 1);
          }
          for (; ; ) {
            let ch = line[dirEnd - 1];
            if (ch === " " || ch === "	")
              dirEnd -= 1;
            else
              break;
          }
          let n = (yield* this.pushCount(dirEnd)) + (yield* this.pushSpaces(!0));
          return yield* this.pushCount(line.length - n), this.pushNewline(), "stream";
        }
        if (this.atLineEnd()) {
          let sp = yield* this.pushSpaces(!0);
          return yield* this.pushCount(line.length - sp), yield* this.pushNewline(), "stream";
        }
        return yield cst.DOCUMENT, yield* this.parseLineStart();
      }
      *parseLineStart() {
        let ch = this.charAt(0);
        if (!ch && !this.atEnd)
          return this.setNext("line-start");
        if (ch === "-" || ch === ".") {
          if (!this.atEnd && !this.hasChars(4))
            return this.setNext("line-start");
          let s = this.peek(3);
          if (s === "---" && isEmpty2(this.charAt(3)))
            return yield* this.pushCount(3), this.indentValue = 0, this.indentNext = 0, "doc";
          if (s === "..." && isEmpty2(this.charAt(3)))
            return yield* this.pushCount(3), "stream";
        }
        return this.indentValue = yield* this.pushSpaces(!1), this.indentNext > this.indentValue && !isEmpty2(this.charAt(1)) && (this.indentNext = this.indentValue), yield* this.parseBlockStart();
      }
      *parseBlockStart() {
        let [ch0, ch1] = this.peek(2);
        if (!ch1 && !this.atEnd)
          return this.setNext("block-start");
        if ((ch0 === "-" || ch0 === "?" || ch0 === ":") && isEmpty2(ch1)) {
          let n = (yield* this.pushCount(1)) + (yield* this.pushSpaces(!0));
          return this.indentNext = this.indentValue + 1, this.indentValue += n, yield* this.parseBlockStart();
        }
        return "doc";
      }
      *parseDocument() {
        yield* this.pushSpaces(!0);
        let line = this.getLine();
        if (line === null)
          return this.setNext("doc");
        let n = yield* this.pushIndicators();
        switch (line[n]) {
          case "#":
            yield* this.pushCount(line.length - n);
          case void 0:
            return yield* this.pushNewline(), yield* this.parseLineStart();
          case "{":
          case "[":
            return yield* this.pushCount(1), this.flowKey = !1, this.flowLevel = 1, "flow";
          case "}":
          case "]":
            return yield* this.pushCount(1), "doc";
          case "*":
            return yield* this.pushUntil(isNotAnchorChar), "doc";
          case '"':
          case "'":
            return yield* this.parseQuotedScalar();
          case "|":
          case ">":
            return n += yield* this.parseBlockScalarHeader(), n += yield* this.pushSpaces(!0), yield* this.pushCount(line.length - n), yield* this.pushNewline(), yield* this.parseBlockScalar();
          default:
            return yield* this.parsePlainScalar();
        }
      }
      *parseFlowCollection() {
        let nl, sp, indent = -1;
        do
          nl = yield* this.pushNewline(), nl > 0 ? (sp = yield* this.pushSpaces(!1), this.indentValue = indent = sp) : sp = 0, sp += yield* this.pushSpaces(!0);
        while (nl + sp > 0);
        let line = this.getLine();
        if (line === null)
          return this.setNext("flow");
        if ((indent !== -1 && indent < this.indentNext && line[0] !== "#" || indent === 0 && (line.startsWith("---") || line.startsWith("...")) && isEmpty2(line[3])) && !(indent === this.indentNext - 1 && this.flowLevel === 1 && (line[0] === "]" || line[0] === "}")))
          return this.flowLevel = 0, yield cst.FLOW_END, yield* this.parseLineStart();
        let n = 0;
        for (; line[n] === ","; )
          n += yield* this.pushCount(1), n += yield* this.pushSpaces(!0), this.flowKey = !1;
        switch (n += yield* this.pushIndicators(), line[n]) {
          case void 0:
            return "flow";
          case "#":
            return yield* this.pushCount(line.length - n), "flow";
          case "{":
          case "[":
            return yield* this.pushCount(1), this.flowKey = !1, this.flowLevel += 1, "flow";
          case "}":
          case "]":
            return yield* this.pushCount(1), this.flowKey = !0, this.flowLevel -= 1, this.flowLevel ? "flow" : "doc";
          case "*":
            return yield* this.pushUntil(isNotAnchorChar), "flow";
          case '"':
          case "'":
            return this.flowKey = !0, yield* this.parseQuotedScalar();
          case ":": {
            let next = this.charAt(1);
            if (this.flowKey || isEmpty2(next) || next === ",")
              return this.flowKey = !1, yield* this.pushCount(1), yield* this.pushSpaces(!0), "flow";
          }
          default:
            return this.flowKey = !1, yield* this.parsePlainScalar();
        }
      }
      *parseQuotedScalar() {
        let quote = this.charAt(0), end = this.buffer.indexOf(quote, this.pos + 1);
        if (quote === "'")
          for (; end !== -1 && this.buffer[end + 1] === "'"; )
            end = this.buffer.indexOf("'", end + 2);
        else
          for (; end !== -1; ) {
            let n = 0;
            for (; this.buffer[end - 1 - n] === "\\"; )
              n += 1;
            if (n % 2 === 0)
              break;
            end = this.buffer.indexOf('"', end + 1);
          }
        let qb = this.buffer.substring(0, end), nl = qb.indexOf(`
`, this.pos);
        if (nl !== -1) {
          for (; nl !== -1; ) {
            let cs = this.continueScalar(nl + 1);
            if (cs === -1)
              break;
            nl = qb.indexOf(`
`, cs);
          }
          nl !== -1 && (end = nl - (qb[nl - 1] === "\r" ? 2 : 1));
        }
        if (end === -1) {
          if (!this.atEnd)
            return this.setNext("quoted-scalar");
          end = this.buffer.length;
        }
        return yield* this.pushToIndex(end + 1, !1), this.flowLevel ? "flow" : "doc";
      }
      *parseBlockScalarHeader() {
        this.blockScalarIndent = -1, this.blockScalarKeep = !1;
        let i = this.pos;
        for (; ; ) {
          let ch = this.buffer[++i];
          if (ch === "+")
            this.blockScalarKeep = !0;
          else if (ch > "0" && ch <= "9")
            this.blockScalarIndent = Number(ch) - 1;
          else if (ch !== "-")
            break;
        }
        return yield* this.pushUntil((ch) => isEmpty2(ch) || ch === "#");
      }
      *parseBlockScalar() {
        let nl = this.pos - 1, indent = 0, ch;
        loop:
          for (let i = this.pos; ch = this.buffer[i]; ++i)
            switch (ch) {
              case " ":
                indent += 1;
                break;
              case `
`:
                nl = i, indent = 0;
                break;
              case "\r": {
                let next = this.buffer[i + 1];
                if (!next && !this.atEnd)
                  return this.setNext("block-scalar");
                if (next === `
`)
                  break;
              }
              default:
                break loop;
            }
        if (!ch && !this.atEnd)
          return this.setNext("block-scalar");
        if (indent >= this.indentNext) {
          this.blockScalarIndent === -1 ? this.indentNext = indent : this.indentNext += this.blockScalarIndent;
          do {
            let cs = this.continueScalar(nl + 1);
            if (cs === -1)
              break;
            nl = this.buffer.indexOf(`
`, cs);
          } while (nl !== -1);
          if (nl === -1) {
            if (!this.atEnd)
              return this.setNext("block-scalar");
            nl = this.buffer.length;
          }
        }
        if (!this.blockScalarKeep)
          do {
            let i = nl - 1, ch2 = this.buffer[i];
            ch2 === "\r" && (ch2 = this.buffer[--i]);
            let lastChar = i;
            for (; ch2 === " " || ch2 === "	"; )
              ch2 = this.buffer[--i];
            if (ch2 === `
` && i >= this.pos && i + 1 + indent > lastChar)
              nl = i;
            else
              break;
          } while (!0);
        return yield cst.SCALAR, yield* this.pushToIndex(nl + 1, !0), yield* this.parseLineStart();
      }
      *parsePlainScalar() {
        let inFlow = this.flowLevel > 0, end = this.pos - 1, i = this.pos - 1, ch;
        for (; ch = this.buffer[++i]; )
          if (ch === ":") {
            let next = this.buffer[i + 1];
            if (isEmpty2(next) || inFlow && next === ",")
              break;
            end = i;
          } else if (isEmpty2(ch)) {
            let next = this.buffer[i + 1];
            if (ch === "\r" && (next === `
` ? (i += 1, ch = `
`, next = this.buffer[i + 1]) : end = i), next === "#" || inFlow && invalidFlowScalarChars.includes(next))
              break;
            if (ch === `
`) {
              let cs = this.continueScalar(i + 1);
              if (cs === -1)
                break;
              i = Math.max(i, cs - 2);
            }
          } else {
            if (inFlow && invalidFlowScalarChars.includes(ch))
              break;
            end = i;
          }
        return !ch && !this.atEnd ? this.setNext("plain-scalar") : (yield cst.SCALAR, yield* this.pushToIndex(end + 1, !0), inFlow ? "flow" : "doc");
      }
      *pushCount(n) {
        return n > 0 ? (yield this.buffer.substr(this.pos, n), this.pos += n, n) : 0;
      }
      *pushToIndex(i, allowEmpty) {
        let s = this.buffer.slice(this.pos, i);
        return s ? (yield s, this.pos += s.length, s.length) : (allowEmpty && (yield ""), 0);
      }
      *pushIndicators() {
        switch (this.charAt(0)) {
          case "!":
            return (yield* this.pushTag()) + (yield* this.pushSpaces(!0)) + (yield* this.pushIndicators());
          case "&":
            return (yield* this.pushUntil(isNotAnchorChar)) + (yield* this.pushSpaces(!0)) + (yield* this.pushIndicators());
          case "-":
          case "?":
          case ":": {
            let inFlow = this.flowLevel > 0, ch1 = this.charAt(1);
            if (isEmpty2(ch1) || inFlow && invalidFlowScalarChars.includes(ch1))
              return inFlow ? this.flowKey && (this.flowKey = !1) : this.indentNext = this.indentValue + 1, (yield* this.pushCount(1)) + (yield* this.pushSpaces(!0)) + (yield* this.pushIndicators());
          }
        }
        return 0;
      }
      *pushTag() {
        if (this.charAt(1) === "<") {
          let i = this.pos + 2, ch = this.buffer[i];
          for (; !isEmpty2(ch) && ch !== ">"; )
            ch = this.buffer[++i];
          return yield* this.pushToIndex(ch === ">" ? i + 1 : i, !1);
        } else {
          let i = this.pos + 1, ch = this.buffer[i];
          for (; ch; )
            if (tagChars.includes(ch))
              ch = this.buffer[++i];
            else if (ch === "%" && hexDigits.includes(this.buffer[i + 1]) && hexDigits.includes(this.buffer[i + 2]))
              ch = this.buffer[i += 3];
            else
              break;
          return yield* this.pushToIndex(i, !1);
        }
      }
      *pushNewline() {
        let ch = this.buffer[this.pos];
        return ch === `
` ? yield* this.pushCount(1) : ch === "\r" && this.charAt(1) === `
` ? yield* this.pushCount(2) : 0;
      }
      *pushSpaces(allowTabs) {
        let i = this.pos - 1, ch;
        do
          ch = this.buffer[++i];
        while (ch === " " || allowTabs && ch === "	");
        let n = i - this.pos;
        return n > 0 && (yield this.buffer.substr(this.pos, n), this.pos = i), n;
      }
      *pushUntil(test) {
        let i = this.pos, ch = this.buffer[i];
        for (; !test(ch); )
          ch = this.buffer[++i];
        return yield* this.pushToIndex(i, !1);
      }
    };
    exports.Lexer = Lexer;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/parse/line-counter.js
var require_line_counter = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/parse/line-counter.js"(exports) {
    "use strict";
    init_cjs_shims();
    var LineCounter = class {
      constructor() {
        this.lineStarts = [], this.addNewLine = (offset) => this.lineStarts.push(offset), this.linePos = (offset) => {
          let low = 0, high = this.lineStarts.length;
          for (; low < high; ) {
            let mid = low + high >> 1;
            this.lineStarts[mid] < offset ? low = mid + 1 : high = mid;
          }
          if (this.lineStarts[low] === offset)
            return { line: low + 1, col: 1 };
          if (low === 0)
            return { line: 0, col: offset };
          let start = this.lineStarts[low - 1];
          return { line: low, col: offset - start + 1 };
        };
      }
    };
    exports.LineCounter = LineCounter;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/parse/parser.js
var require_parser = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/parse/parser.js"(exports) {
    "use strict";
    init_cjs_shims();
    var cst = require_cst(), lexer = require_lexer();
    function includesToken(list2, type) {
      for (let i = 0; i < list2.length; ++i)
        if (list2[i].type === type)
          return !0;
      return !1;
    }
    function findNonEmptyIndex(list2) {
      for (let i = 0; i < list2.length; ++i)
        switch (list2[i].type) {
          case "space":
          case "comment":
          case "newline":
            break;
          default:
            return i;
        }
      return -1;
    }
    function isFlowToken(token) {
      switch (token?.type) {
        case "alias":
        case "scalar":
        case "single-quoted-scalar":
        case "double-quoted-scalar":
        case "flow-collection":
          return !0;
        default:
          return !1;
      }
    }
    function getPrevProps(parent) {
      switch (parent.type) {
        case "document":
          return parent.start;
        case "block-map": {
          let it = parent.items[parent.items.length - 1];
          return it.sep ?? it.start;
        }
        case "block-seq":
          return parent.items[parent.items.length - 1].start;
        default:
          return [];
      }
    }
    function getFirstKeyStartProps(prev) {
      if (prev.length === 0)
        return [];
      let i = prev.length;
      loop:
        for (; --i >= 0; )
          switch (prev[i].type) {
            case "doc-start":
            case "explicit-key-ind":
            case "map-value-ind":
            case "seq-item-ind":
            case "newline":
              break loop;
          }
      for (; prev[++i]?.type === "space"; )
        ;
      return prev.splice(i, prev.length);
    }
    function fixFlowSeqItems(fc) {
      if (fc.start.type === "flow-seq-start")
        for (let it of fc.items)
          it.sep && !it.value && !includesToken(it.start, "explicit-key-ind") && !includesToken(it.sep, "map-value-ind") && (it.key && (it.value = it.key), delete it.key, isFlowToken(it.value) ? it.value.end ? Array.prototype.push.apply(it.value.end, it.sep) : it.value.end = it.sep : Array.prototype.push.apply(it.start, it.sep), delete it.sep);
    }
    var Parser = class {
      /**
       * @param onNewLine - If defined, called separately with the start position of
       *   each new line (in `parse()`, including the start of input).
       */
      constructor(onNewLine) {
        this.atNewLine = !0, this.atScalar = !1, this.indent = 0, this.offset = 0, this.onKeyLine = !1, this.stack = [], this.source = "", this.type = "", this.lexer = new lexer.Lexer(), this.onNewLine = onNewLine;
      }
      /**
       * Parse `source` as a YAML stream.
       * If `incomplete`, a part of the last line may be left as a buffer for the next call.
       *
       * Errors are not thrown, but yielded as `{ type: 'error', message }` tokens.
       *
       * @returns A generator of tokens representing each directive, document, and other structure.
       */
      *parse(source, incomplete = !1) {
        this.onNewLine && this.offset === 0 && this.onNewLine(0);
        for (let lexeme of this.lexer.lex(source, incomplete))
          yield* this.next(lexeme);
        incomplete || (yield* this.end());
      }
      /**
       * Advance the parser by the `source` of one lexical token.
       */
      *next(source) {
        if (this.source = source, process.env.LOG_TOKENS && console.log("|", cst.prettyToken(source)), this.atScalar) {
          this.atScalar = !1, yield* this.step(), this.offset += source.length;
          return;
        }
        let type = cst.tokenType(source);
        if (type)
          if (type === "scalar")
            this.atNewLine = !1, this.atScalar = !0, this.type = "scalar";
          else {
            switch (this.type = type, yield* this.step(), type) {
              case "newline":
                this.atNewLine = !0, this.indent = 0, this.onNewLine && this.onNewLine(this.offset + source.length);
                break;
              case "space":
                this.atNewLine && source[0] === " " && (this.indent += source.length);
                break;
              case "explicit-key-ind":
              case "map-value-ind":
              case "seq-item-ind":
                this.atNewLine && (this.indent += source.length);
                break;
              case "doc-mode":
              case "flow-error-end":
                return;
              default:
                this.atNewLine = !1;
            }
            this.offset += source.length;
          }
        else {
          let message = `Not a YAML token: ${source}`;
          yield* this.pop({ type: "error", offset: this.offset, message, source }), this.offset += source.length;
        }
      }
      /** Call at end of input to push out any remaining constructions */
      *end() {
        for (; this.stack.length > 0; )
          yield* this.pop();
      }
      get sourceToken() {
        return {
          type: this.type,
          offset: this.offset,
          indent: this.indent,
          source: this.source
        };
      }
      *step() {
        let top = this.peek(1);
        if (this.type === "doc-end" && (!top || top.type !== "doc-end")) {
          for (; this.stack.length > 0; )
            yield* this.pop();
          this.stack.push({
            type: "doc-end",
            offset: this.offset,
            source: this.source
          });
          return;
        }
        if (!top)
          return yield* this.stream();
        switch (top.type) {
          case "document":
            return yield* this.document(top);
          case "alias":
          case "scalar":
          case "single-quoted-scalar":
          case "double-quoted-scalar":
            return yield* this.scalar(top);
          case "block-scalar":
            return yield* this.blockScalar(top);
          case "block-map":
            return yield* this.blockMap(top);
          case "block-seq":
            return yield* this.blockSequence(top);
          case "flow-collection":
            return yield* this.flowCollection(top);
          case "doc-end":
            return yield* this.documentEnd(top);
        }
        yield* this.pop();
      }
      peek(n) {
        return this.stack[this.stack.length - n];
      }
      *pop(error) {
        let token = error ?? this.stack.pop();
        if (token)
          if (this.stack.length === 0)
            yield token;
          else {
            let top = this.peek(1);
            switch (token.type === "block-scalar" ? token.indent = "indent" in top ? top.indent : 0 : token.type === "flow-collection" && top.type === "document" && (token.indent = 0), token.type === "flow-collection" && fixFlowSeqItems(token), top.type) {
              case "document":
                top.value = token;
                break;
              case "block-scalar":
                top.props.push(token);
                break;
              case "block-map": {
                let it = top.items[top.items.length - 1];
                if (it.value) {
                  top.items.push({ start: [], key: token, sep: [] }), this.onKeyLine = !0;
                  return;
                } else if (it.sep)
                  it.value = token;
                else {
                  Object.assign(it, { key: token, sep: [] }), this.onKeyLine = !includesToken(it.start, "explicit-key-ind");
                  return;
                }
                break;
              }
              case "block-seq": {
                let it = top.items[top.items.length - 1];
                it.value ? top.items.push({ start: [], value: token }) : it.value = token;
                break;
              }
              case "flow-collection": {
                let it = top.items[top.items.length - 1];
                !it || it.value ? top.items.push({ start: [], key: token, sep: [] }) : it.sep ? it.value = token : Object.assign(it, { key: token, sep: [] });
                return;
              }
              default:
                yield* this.pop(), yield* this.pop(token);
            }
            if ((top.type === "document" || top.type === "block-map" || top.type === "block-seq") && (token.type === "block-map" || token.type === "block-seq")) {
              let last = token.items[token.items.length - 1];
              last && !last.sep && !last.value && last.start.length > 0 && findNonEmptyIndex(last.start) === -1 && (token.indent === 0 || last.start.every((st) => st.type !== "comment" || st.indent < token.indent)) && (top.type === "document" ? top.end = last.start : top.items.push({ start: last.start }), token.items.splice(-1, 1));
            }
          }
        else {
          let message = "Tried to pop an empty stack";
          yield { type: "error", offset: this.offset, source: "", message };
        }
      }
      *stream() {
        switch (this.type) {
          case "directive-line":
            yield { type: "directive", offset: this.offset, source: this.source };
            return;
          case "byte-order-mark":
          case "space":
          case "comment":
          case "newline":
            yield this.sourceToken;
            return;
          case "doc-mode":
          case "doc-start": {
            let doc = {
              type: "document",
              offset: this.offset,
              start: []
            };
            this.type === "doc-start" && doc.start.push(this.sourceToken), this.stack.push(doc);
            return;
          }
        }
        yield {
          type: "error",
          offset: this.offset,
          message: `Unexpected ${this.type} token in YAML stream`,
          source: this.source
        };
      }
      *document(doc) {
        if (doc.value)
          return yield* this.lineEnd(doc);
        switch (this.type) {
          case "doc-start": {
            findNonEmptyIndex(doc.start) !== -1 ? (yield* this.pop(), yield* this.step()) : doc.start.push(this.sourceToken);
            return;
          }
          case "anchor":
          case "tag":
          case "space":
          case "comment":
          case "newline":
            doc.start.push(this.sourceToken);
            return;
        }
        let bv = this.startBlockValue(doc);
        bv ? this.stack.push(bv) : yield {
          type: "error",
          offset: this.offset,
          message: `Unexpected ${this.type} token in YAML document`,
          source: this.source
        };
      }
      *scalar(scalar) {
        if (this.type === "map-value-ind") {
          let prev = getPrevProps(this.peek(2)), start = getFirstKeyStartProps(prev), sep3;
          scalar.end ? (sep3 = scalar.end, sep3.push(this.sourceToken), delete scalar.end) : sep3 = [this.sourceToken];
          let map = {
            type: "block-map",
            offset: scalar.offset,
            indent: scalar.indent,
            items: [{ start, key: scalar, sep: sep3 }]
          };
          this.onKeyLine = !0, this.stack[this.stack.length - 1] = map;
        } else
          yield* this.lineEnd(scalar);
      }
      *blockScalar(scalar) {
        switch (this.type) {
          case "space":
          case "comment":
          case "newline":
            scalar.props.push(this.sourceToken);
            return;
          case "scalar":
            if (scalar.source = this.source, this.atNewLine = !0, this.indent = 0, this.onNewLine) {
              let nl = this.source.indexOf(`
`) + 1;
              for (; nl !== 0; )
                this.onNewLine(this.offset + nl), nl = this.source.indexOf(`
`, nl) + 1;
            }
            yield* this.pop();
            break;
          default:
            yield* this.pop(), yield* this.step();
        }
      }
      *blockMap(map) {
        let it = map.items[map.items.length - 1];
        switch (this.type) {
          case "newline":
            if (this.onKeyLine = !1, it.value) {
              let end = "end" in it.value ? it.value.end : void 0;
              (Array.isArray(end) ? end[end.length - 1] : void 0)?.type === "comment" ? end?.push(this.sourceToken) : map.items.push({ start: [this.sourceToken] });
            } else
              it.sep ? it.sep.push(this.sourceToken) : it.start.push(this.sourceToken);
            return;
          case "space":
          case "comment":
            if (it.value)
              map.items.push({ start: [this.sourceToken] });
            else if (it.sep)
              it.sep.push(this.sourceToken);
            else {
              if (this.atIndentedComment(it.start, map.indent)) {
                let end = map.items[map.items.length - 2]?.value?.end;
                if (Array.isArray(end)) {
                  Array.prototype.push.apply(end, it.start), end.push(this.sourceToken), map.items.pop();
                  return;
                }
              }
              it.start.push(this.sourceToken);
            }
            return;
        }
        if (this.indent >= map.indent) {
          let atNextItem = !this.onKeyLine && this.indent === map.indent && it.sep, start = [];
          if (atNextItem && it.sep && !it.value) {
            let nl = [];
            for (let i = 0; i < it.sep.length; ++i) {
              let st = it.sep[i];
              switch (st.type) {
                case "newline":
                  nl.push(i);
                  break;
                case "space":
                  break;
                case "comment":
                  st.indent > map.indent && (nl.length = 0);
                  break;
                default:
                  nl.length = 0;
              }
            }
            nl.length >= 2 && (start = it.sep.splice(nl[1]));
          }
          switch (this.type) {
            case "anchor":
            case "tag":
              atNextItem || it.value ? (start.push(this.sourceToken), map.items.push({ start }), this.onKeyLine = !0) : it.sep ? it.sep.push(this.sourceToken) : it.start.push(this.sourceToken);
              return;
            case "explicit-key-ind":
              !it.sep && !includesToken(it.start, "explicit-key-ind") ? it.start.push(this.sourceToken) : atNextItem || it.value ? (start.push(this.sourceToken), map.items.push({ start })) : this.stack.push({
                type: "block-map",
                offset: this.offset,
                indent: this.indent,
                items: [{ start: [this.sourceToken] }]
              }), this.onKeyLine = !0;
              return;
            case "map-value-ind":
              if (includesToken(it.start, "explicit-key-ind"))
                if (it.sep)
                  if (it.value)
                    map.items.push({ start: [], key: null, sep: [this.sourceToken] });
                  else if (includesToken(it.sep, "map-value-ind"))
                    this.stack.push({
                      type: "block-map",
                      offset: this.offset,
                      indent: this.indent,
                      items: [{ start, key: null, sep: [this.sourceToken] }]
                    });
                  else if (isFlowToken(it.key) && !includesToken(it.sep, "newline")) {
                    let start2 = getFirstKeyStartProps(it.start), key = it.key, sep3 = it.sep;
                    sep3.push(this.sourceToken), delete it.key, delete it.sep, this.stack.push({
                      type: "block-map",
                      offset: this.offset,
                      indent: this.indent,
                      items: [{ start: start2, key, sep: sep3 }]
                    });
                  } else
                    start.length > 0 ? it.sep = it.sep.concat(start, this.sourceToken) : it.sep.push(this.sourceToken);
                else if (includesToken(it.start, "newline"))
                  Object.assign(it, { key: null, sep: [this.sourceToken] });
                else {
                  let start2 = getFirstKeyStartProps(it.start);
                  this.stack.push({
                    type: "block-map",
                    offset: this.offset,
                    indent: this.indent,
                    items: [{ start: start2, key: null, sep: [this.sourceToken] }]
                  });
                }
              else
                it.sep ? it.value || atNextItem ? map.items.push({ start, key: null, sep: [this.sourceToken] }) : includesToken(it.sep, "map-value-ind") ? this.stack.push({
                  type: "block-map",
                  offset: this.offset,
                  indent: this.indent,
                  items: [{ start: [], key: null, sep: [this.sourceToken] }]
                }) : it.sep.push(this.sourceToken) : Object.assign(it, { key: null, sep: [this.sourceToken] });
              this.onKeyLine = !0;
              return;
            case "alias":
            case "scalar":
            case "single-quoted-scalar":
            case "double-quoted-scalar": {
              let fs6 = this.flowScalar(this.type);
              atNextItem || it.value ? (map.items.push({ start, key: fs6, sep: [] }), this.onKeyLine = !0) : it.sep ? this.stack.push(fs6) : (Object.assign(it, { key: fs6, sep: [] }), this.onKeyLine = !0);
              return;
            }
            default: {
              let bv = this.startBlockValue(map);
              if (bv) {
                atNextItem && bv.type !== "block-seq" && includesToken(it.start, "explicit-key-ind") && map.items.push({ start }), this.stack.push(bv);
                return;
              }
            }
          }
        }
        yield* this.pop(), yield* this.step();
      }
      *blockSequence(seq) {
        let it = seq.items[seq.items.length - 1];
        switch (this.type) {
          case "newline":
            if (it.value) {
              let end = "end" in it.value ? it.value.end : void 0;
              (Array.isArray(end) ? end[end.length - 1] : void 0)?.type === "comment" ? end?.push(this.sourceToken) : seq.items.push({ start: [this.sourceToken] });
            } else
              it.start.push(this.sourceToken);
            return;
          case "space":
          case "comment":
            if (it.value)
              seq.items.push({ start: [this.sourceToken] });
            else {
              if (this.atIndentedComment(it.start, seq.indent)) {
                let end = seq.items[seq.items.length - 2]?.value?.end;
                if (Array.isArray(end)) {
                  Array.prototype.push.apply(end, it.start), end.push(this.sourceToken), seq.items.pop();
                  return;
                }
              }
              it.start.push(this.sourceToken);
            }
            return;
          case "anchor":
          case "tag":
            if (it.value || this.indent <= seq.indent)
              break;
            it.start.push(this.sourceToken);
            return;
          case "seq-item-ind":
            if (this.indent !== seq.indent)
              break;
            it.value || includesToken(it.start, "seq-item-ind") ? seq.items.push({ start: [this.sourceToken] }) : it.start.push(this.sourceToken);
            return;
        }
        if (this.indent > seq.indent) {
          let bv = this.startBlockValue(seq);
          if (bv) {
            this.stack.push(bv);
            return;
          }
        }
        yield* this.pop(), yield* this.step();
      }
      *flowCollection(fc) {
        let it = fc.items[fc.items.length - 1];
        if (this.type === "flow-error-end") {
          let top;
          do
            yield* this.pop(), top = this.peek(1);
          while (top && top.type === "flow-collection");
        } else if (fc.end.length === 0) {
          switch (this.type) {
            case "comma":
            case "explicit-key-ind":
              !it || it.sep ? fc.items.push({ start: [this.sourceToken] }) : it.start.push(this.sourceToken);
              return;
            case "map-value-ind":
              !it || it.value ? fc.items.push({ start: [], key: null, sep: [this.sourceToken] }) : it.sep ? it.sep.push(this.sourceToken) : Object.assign(it, { key: null, sep: [this.sourceToken] });
              return;
            case "space":
            case "comment":
            case "newline":
            case "anchor":
            case "tag":
              !it || it.value ? fc.items.push({ start: [this.sourceToken] }) : it.sep ? it.sep.push(this.sourceToken) : it.start.push(this.sourceToken);
              return;
            case "alias":
            case "scalar":
            case "single-quoted-scalar":
            case "double-quoted-scalar": {
              let fs6 = this.flowScalar(this.type);
              !it || it.value ? fc.items.push({ start: [], key: fs6, sep: [] }) : it.sep ? this.stack.push(fs6) : Object.assign(it, { key: fs6, sep: [] });
              return;
            }
            case "flow-map-end":
            case "flow-seq-end":
              fc.end.push(this.sourceToken);
              return;
          }
          let bv = this.startBlockValue(fc);
          bv ? this.stack.push(bv) : (yield* this.pop(), yield* this.step());
        } else {
          let parent = this.peek(2);
          if (parent.type === "block-map" && (this.type === "map-value-ind" && parent.indent === fc.indent || this.type === "newline" && !parent.items[parent.items.length - 1].sep))
            yield* this.pop(), yield* this.step();
          else if (this.type === "map-value-ind" && parent.type !== "flow-collection") {
            let prev = getPrevProps(parent), start = getFirstKeyStartProps(prev);
            fixFlowSeqItems(fc);
            let sep3 = fc.end.splice(1, fc.end.length);
            sep3.push(this.sourceToken);
            let map = {
              type: "block-map",
              offset: fc.offset,
              indent: fc.indent,
              items: [{ start, key: fc, sep: sep3 }]
            };
            this.onKeyLine = !0, this.stack[this.stack.length - 1] = map;
          } else
            yield* this.lineEnd(fc);
        }
      }
      flowScalar(type) {
        if (this.onNewLine) {
          let nl = this.source.indexOf(`
`) + 1;
          for (; nl !== 0; )
            this.onNewLine(this.offset + nl), nl = this.source.indexOf(`
`, nl) + 1;
        }
        return {
          type,
          offset: this.offset,
          indent: this.indent,
          source: this.source
        };
      }
      startBlockValue(parent) {
        switch (this.type) {
          case "alias":
          case "scalar":
          case "single-quoted-scalar":
          case "double-quoted-scalar":
            return this.flowScalar(this.type);
          case "block-scalar-header":
            return {
              type: "block-scalar",
              offset: this.offset,
              indent: this.indent,
              props: [this.sourceToken],
              source: ""
            };
          case "flow-map-start":
          case "flow-seq-start":
            return {
              type: "flow-collection",
              offset: this.offset,
              indent: this.indent,
              start: this.sourceToken,
              items: [],
              end: []
            };
          case "seq-item-ind":
            return {
              type: "block-seq",
              offset: this.offset,
              indent: this.indent,
              items: [{ start: [this.sourceToken] }]
            };
          case "explicit-key-ind": {
            this.onKeyLine = !0;
            let prev = getPrevProps(parent), start = getFirstKeyStartProps(prev);
            return start.push(this.sourceToken), {
              type: "block-map",
              offset: this.offset,
              indent: this.indent,
              items: [{ start }]
            };
          }
          case "map-value-ind": {
            this.onKeyLine = !0;
            let prev = getPrevProps(parent), start = getFirstKeyStartProps(prev);
            return {
              type: "block-map",
              offset: this.offset,
              indent: this.indent,
              items: [{ start, key: null, sep: [this.sourceToken] }]
            };
          }
        }
        return null;
      }
      atIndentedComment(start, indent) {
        return this.type !== "comment" || this.indent <= indent ? !1 : start.every((st) => st.type === "newline" || st.type === "space");
      }
      *documentEnd(docEnd) {
        this.type !== "doc-mode" && (docEnd.end ? docEnd.end.push(this.sourceToken) : docEnd.end = [this.sourceToken], this.type === "newline" && (yield* this.pop()));
      }
      *lineEnd(token) {
        switch (this.type) {
          case "comma":
          case "doc-start":
          case "doc-end":
          case "flow-seq-end":
          case "flow-map-end":
          case "map-value-ind":
            yield* this.pop(), yield* this.step();
            break;
          case "newline":
            this.onKeyLine = !1;
          case "space":
          case "comment":
          default:
            token.end ? token.end.push(this.sourceToken) : token.end = [this.sourceToken], this.type === "newline" && (yield* this.pop());
        }
      }
    };
    exports.Parser = Parser;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/public-api.js
var require_public_api = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/public-api.js"(exports) {
    "use strict";
    init_cjs_shims();
    var composer = require_composer(), Document = require_Document(), errors2 = require_errors3(), log = require_log(), lineCounter = require_line_counter(), parser = require_parser();
    function parseOptions(options) {
      let prettyErrors = options.prettyErrors !== !1;
      return { lineCounter: options.lineCounter || prettyErrors && new lineCounter.LineCounter() || null, prettyErrors };
    }
    function parseAllDocuments(source, options = {}) {
      let { lineCounter: lineCounter2, prettyErrors } = parseOptions(options), parser$1 = new parser.Parser(lineCounter2?.addNewLine), composer$1 = new composer.Composer(options), docs = Array.from(composer$1.compose(parser$1.parse(source)));
      if (prettyErrors && lineCounter2)
        for (let doc of docs)
          doc.errors.forEach(errors2.prettifyError(source, lineCounter2)), doc.warnings.forEach(errors2.prettifyError(source, lineCounter2));
      return docs.length > 0 ? docs : Object.assign([], { empty: !0 }, composer$1.streamInfo());
    }
    function parseDocument(source, options = {}) {
      let { lineCounter: lineCounter2, prettyErrors } = parseOptions(options), parser$1 = new parser.Parser(lineCounter2?.addNewLine), composer$1 = new composer.Composer(options), doc = null;
      for (let _doc of composer$1.compose(parser$1.parse(source), !0, source.length))
        if (!doc)
          doc = _doc;
        else if (doc.options.logLevel !== "silent") {
          doc.errors.push(new errors2.YAMLParseError(_doc.range.slice(0, 2), "MULTIPLE_DOCS", "Source contains multiple documents; please use YAML.parseAllDocuments()"));
          break;
        }
      return prettyErrors && lineCounter2 && (doc.errors.forEach(errors2.prettifyError(source, lineCounter2)), doc.warnings.forEach(errors2.prettifyError(source, lineCounter2))), doc;
    }
    function parse4(src, reviver, options) {
      let _reviver;
      typeof reviver == "function" ? _reviver = reviver : options === void 0 && reviver && typeof reviver == "object" && (options = reviver);
      let doc = parseDocument(src, options);
      if (!doc)
        return null;
      if (doc.warnings.forEach((warning) => log.warn(doc.options.logLevel, warning)), doc.errors.length > 0) {
        if (doc.options.logLevel !== "silent")
          throw doc.errors[0];
        doc.errors = [];
      }
      return doc.toJS(Object.assign({ reviver: _reviver }, options));
    }
    function stringify(value, replacer, options) {
      let _replacer = null;
      if (typeof replacer == "function" || Array.isArray(replacer) ? _replacer = replacer : options === void 0 && replacer && (options = replacer), typeof options == "string" && (options = options.length), typeof options == "number") {
        let indent = Math.round(options);
        options = indent < 1 ? void 0 : indent > 8 ? { indent: 8 } : { indent };
      }
      if (value === void 0) {
        let { keepUndefined } = options ?? replacer ?? {};
        if (!keepUndefined)
          return;
      }
      return new Document.Document(value, _replacer, options).toString(options);
    }
    exports.parse = parse4;
    exports.parseAllDocuments = parseAllDocuments;
    exports.parseDocument = parseDocument;
    exports.stringify = stringify;
  }
});

// ../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/index.js
var require_dist4 = __commonJS({
  "../../node_modules/.pnpm/yaml@2.3.2/node_modules/yaml/dist/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var composer = require_composer(), Document = require_Document(), Schema = require_Schema(), errors2 = require_errors3(), Alias = require_Alias(), identity = require_identity(), Pair = require_Pair(), Scalar = require_Scalar(), YAMLMap = require_YAMLMap(), YAMLSeq = require_YAMLSeq(), cst = require_cst(), lexer = require_lexer(), lineCounter = require_line_counter(), parser = require_parser(), publicApi = require_public_api(), visit3 = require_visit();
    exports.Composer = composer.Composer;
    exports.Document = Document.Document;
    exports.Schema = Schema.Schema;
    exports.YAMLError = errors2.YAMLError;
    exports.YAMLParseError = errors2.YAMLParseError;
    exports.YAMLWarning = errors2.YAMLWarning;
    exports.Alias = Alias.Alias;
    exports.isAlias = identity.isAlias;
    exports.isCollection = identity.isCollection;
    exports.isDocument = identity.isDocument;
    exports.isMap = identity.isMap;
    exports.isNode = identity.isNode;
    exports.isPair = identity.isPair;
    exports.isScalar = identity.isScalar;
    exports.isSeq = identity.isSeq;
    exports.Pair = Pair.Pair;
    exports.Scalar = Scalar.Scalar;
    exports.YAMLMap = YAMLMap.YAMLMap;
    exports.YAMLSeq = YAMLSeq.YAMLSeq;
    exports.CST = cst;
    exports.Lexer = lexer.Lexer;
    exports.LineCounter = lineCounter.LineCounter;
    exports.Parser = parser.Parser;
    exports.parse = publicApi.parse;
    exports.parseAllDocuments = publicApi.parseAllDocuments;
    exports.parseDocument = publicApi.parseDocument;
    exports.stringify = publicApi.stringify;
    exports.visit = visit3.visit;
    exports.visitAsync = visit3.visitAsync;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/types.js
var require_types4 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/types.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ConvenienceSeverities = exports.LegacyIdentifiers = exports.ModernIdentifiers = void 0;
    var theme_check_common_1 = require_dist2();
    exports.ModernIdentifiers = [
      "theme-check:nothing",
      "theme-check:recommended",
      "theme-check:theme-app-extension",
      "theme-check:all"
    ];
    exports.LegacyIdentifiers = new Map(Object.entries({
      default: "theme-check:recommended",
      nothing: "theme-check:nothing",
      theme_app_extensions: "theme-check:theme-app-extension"
    }));
    exports.ConvenienceSeverities = {
      // legacy
      suggestion: theme_check_common_1.Severity.WARNING,
      style: theme_check_common_1.Severity.INFO,
      // the numerical values are not user friendly
      error: theme_check_common_1.Severity.ERROR,
      warning: theme_check_common_1.Severity.WARNING,
      info: theme_check_common_1.Severity.INFO
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/resolve/read-yaml.js
var require_read_yaml = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/resolve/read-yaml.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.readYamlConfigDescription = void 0;
    var theme_check_common_1 = require_dist2(), yaml_1 = require_dist4(), node_path_1 = __importDefault(__require("node:path")), promises_1 = __importDefault(__require("node:fs/promises")), node_fs_1 = __require("node:fs"), types_1 = require_types4(), UnresolvedAliasError = class extends Error {
      constructor(message, alias) {
        super(message), this.name = "UnresolvedAliasError", this.message = `YAML parsing error: Unresolved alias *${alias}.
Did you forget to wrap your ignore statement in quotes? '*${alias}'
${message}`;
      }
    };
    function parseYamlFile(absolutePath, contents) {
      try {
        let result = contents.trim() === "" ? {} : (0, yaml_1.parse)(contents);
        if (!isPlainObject(result))
          throw new Error(`Expecting parsed contents of config file at path '${absolutePath}' to be a plain object`);
        return result;
      } catch (error) {
        if (error instanceof Error && error.name === "ReferenceError" && error.message.includes("Unresolved alias") && /: .*$/m.test(error.message)) {
          let alias = /: .*$/m.exec(error.message)[0].slice(2);
          throw new UnresolvedAliasError(error.message, alias);
        } else
          throw error;
      }
    }
    async function readYamlConfigDescription(absolutePath, isRootConfig = !1) {
      let root = node_path_1.default.dirname(absolutePath), contents = await promises_1.default.readFile(absolutePath, "utf8"), yamlFile = parseYamlFile(absolutePath, contents), config2 = {
        checkSettings: {},
        ignore: [],
        extends: [],
        require: []
      };
      yamlFile.root && (config2.root = yamlFile.root, delete yamlFile.root), yamlFile.ignore && (config2.ignore = asArray(yamlFile.ignore), delete yamlFile.ignore), yamlFile.require && (config2.require = asArray(yamlFile.require).map((pathLike) => resolvePath2(root, pathLike)).filter(isString2), delete yamlFile.require), yamlFile.extends ? (config2.extends = asArray(yamlFile.extends).map((pathLike) => resolveExtends(root, pathLike)).filter(isString2), delete yamlFile.extends) : isRootConfig && (config2.extends = [resolveExtends(root, "theme-check:recommended")]), yamlFile.context && (theme_check_common_1.Modes.includes(yamlFile.context) && (config2.context = yamlFile.context), delete yamlFile.context), yamlFile.include_categories && delete yamlFile.include_categories, yamlFile.exclude_categories && delete yamlFile.exclude_categories;
      for (let [checkName, settings] of Object.entries(yamlFile)) {
        if (!isPlainObject(settings))
          throw new Error(`Expected a plain object value for ${checkName} but got ${typeof settings}`);
        config2.checkSettings[checkName] = resolveSettings(settings);
      }
      return config2;
    }
    exports.readYamlConfigDescription = readYamlConfigDescription;
    function resolveExtends(root, pathLike) {
      return pathLike.startsWith(":") || types_1.LegacyIdentifiers.has(pathLike) ? types_1.LegacyIdentifiers.get(pathLike.replace(/^:/, "")) : pathLike.startsWith("theme-check:") ? pathLike : resolvePath2(root, pathLike);
    }
    function resolvePath2(root, pathLike) {
      return node_path_1.default.isAbsolute(pathLike) ? pathLike : pathLike.startsWith(".") ? node_path_1.default.resolve(root, pathLike) : (0, node_fs_1.realpathSync)(__require.resolve(pathLike, { paths: getAncestorNodeModules(root) }));
    }
    function resolveSettings(settings) {
      let resolvedSettings = {
        enabled: settings.enabled || !0
      };
      for (let [key, value] of Object.entries(settings))
        resolvedSettings[toCamelCase(key)] = value;
      return settings.ignore !== void 0 && Array.isArray(settings.ignore) && settings.ignore.every(isString2) && (resolvedSettings.ignore = settings.ignore), settings.severity !== void 0 && (resolvedSettings.severity = resolveSeverity(settings.severity)), resolvedSettings;
    }
    function resolveSeverity(severity) {
      if (isConvenienceSeverity(severity))
        return types_1.ConvenienceSeverities[severity];
      if (isSeverity(severity))
        return severity;
      throw new Error(`Unsupported severity: ${severity}. Try one of ${Object.keys(types_1.ConvenienceSeverities)}`);
    }
    function isConvenienceSeverity(severity) {
      return typeof severity == "string" && severity in types_1.ConvenienceSeverities;
    }
    function isSeverity(severity) {
      return typeof severity == "number" && severity in theme_check_common_1.Severity;
    }
    function toCamelCase(maybeSnakeCaseStr) {
      return maybeSnakeCaseStr.replace(/_([a-z])/g, (_2, letter) => letter.toUpperCase());
    }
    function isPlainObject(thing) {
      return Object.prototype.toString.call(thing) === "[object Object]";
    }
    function isString2(thing) {
      return typeof thing == "string";
    }
    function asArray(thing) {
      return Array.isArray(thing) ? thing : [thing];
    }
    function getAncestorNodeModules(dir) {
      let root = node_path_1.default.parse(dir).root, nodeModulesPaths = [];
      for (; dir !== root; )
        nodeModulesPaths.push(node_path_1.default.join(dir, "node_modules")), dir = node_path_1.default.dirname(dir);
      return nodeModulesPaths;
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/resolve/merge-fragments.js
var require_merge_fragments = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/resolve/merge-fragments.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.mergeFragments = void 0;
    function mergeFragments(baseConfigs, config2) {
      var _a38;
      return {
        // we use the last one defined
        root: selectLatest(baseConfigs.map((b) => b.root), config2.root),
        // when we're done, there's nothing left to extend
        extends: [],
        // we merge the ignore configs by concatenation
        ignore: baseConfigs.flatMap((b) => b.ignore).concat(config2.ignore),
        // we merge the require configs by concatenation
        require: baseConfigs.flatMap((b) => b.require).concat(config2.require),
        // we merge deep the settings
        checkSettings: baseConfigs.map((b) => b.checkSettings).concat(config2.checkSettings).reduce(mergeDeep),
        // We use the last one defined, or default to 'theme'
        context: (_a38 = selectLatest(baseConfigs.map((b) => b.context), config2.context)) !== null && _a38 !== void 0 ? _a38 : "theme"
      };
    }
    exports.mergeFragments = mergeFragments;
    function selectLatest(base, curr) {
      return base.concat(curr).filter(Boolean).pop();
    }
    function mergeDeep(target, source) {
      let output = { ...target };
      for (let key in source)
        Object.prototype.hasOwnProperty.call(source, key) && (isObject4(target[key]) && isObject4(source[key]) ? output[key] = mergeDeep(target[key], source[key]) : output[key] = source[key]);
      return output;
    }
    function isObject4(item) {
      return item !== null && typeof item == "object" && !Array.isArray(item);
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/resolve/resolve-config.js
var require_resolve_config = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/resolve/resolve-config.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.resolveConfig = void 0;
    var node_path_1 = __importDefault(__require("node:path")), read_yaml_1 = require_read_yaml(), merge_fragments_1 = require_merge_fragments(), types_1 = require_types4(), modernConfigsPath = () => node_path_1.default.resolve(__dirname, "./configs");
    async function resolveConfig(configPath, isRootConfig = !1) {
      if (isModernIdentifier(configPath)) {
        let modernConfigPath = node_path_1.default.join(modernConfigsPath(), configPath.replace(/^theme-check:/, "") + ".yml");
        return resolveConfig(modernConfigPath);
      }
      let current = await (0, read_yaml_1.readYamlConfigDescription)(configPath, isRootConfig), baseConfigs = await Promise.all(current.extends.map((extend) => resolveConfig(extend)));
      return (0, merge_fragments_1.mergeFragments)(baseConfigs, current);
    }
    exports.resolveConfig = resolveConfig;
    function isModernIdentifier(thing) {
      return types_1.ModernIdentifiers.includes(thing);
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/resolve/index.js
var require_resolve = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/resolve/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.resolveConfig = void 0;
    var resolve_config_1 = require_resolve_config();
    Object.defineProperty(exports, "resolveConfig", { enumerable: !0, get: function() {
      return resolve_config_1.resolveConfig;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/file-utils.js
var require_file_utils2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/file-utils.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.fileSize = exports.fileExists = void 0;
    var promises_1 = __importDefault(__require("node:fs/promises"));
    async function fileExists3(path3) {
      try {
        return await promises_1.default.stat(path3), !0;
      } catch {
        return !1;
      }
    }
    exports.fileExists = fileExists3;
    var fileSize2 = async (path3) => {
      try {
        return (await promises_1.default.stat(path3)).size;
      } catch (error) {
        return (process.env.SHOPIFY_FLAG_VERBOSE || process.argv.includes("--verbose")) && console.error(`Failed to get file size: ${error}`), 0;
      }
    };
    exports.fileSize = fileSize2;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/installation-location.js
var require_installation_location = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/installation-location.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.thisNodeModuleRoot = void 0;
    var node_path_1 = __importDefault(__require("node:path")), node_os_1 = __importDefault(__require("node:os")), thisNodeModuleRoot = () => node_os_1.default.tmpdir();
    exports.thisNodeModuleRoot = thisNodeModuleRoot;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/load-third-party-checks.js
var require_load_third_party_checks = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/load-third-party-checks.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.findThirdPartyChecks = exports.loadThirdPartyChecks = void 0;
    var glob_1 = __importDefault(require_glob2()), node_util_1 = __require("node:util"), asyncGlob = (0, node_util_1.promisify)(glob_1.default);
    function loadThirdPartyChecks(modulePaths = []) {
      let checks = /* @__PURE__ */ new Set();
      for (let modulePath2 of modulePaths)
        try {
          let moduleChecks = __require(
            /* webpackIgnore: true */
            modulePath2
          ).checks;
          if (!Array.isArray(moduleChecks))
            throw new Error(`Expected the 'checks' export to be an array and got ${typeof moduleChecks}`);
          for (let check2 of moduleChecks)
            isCheckDefinition(check2) ? checks.add(check2) : console.error(`Expected ${check2} to be a CheckDefinition, but it looks like it isn't`);
        } catch (e) {
          console.error(`Error loading ${modulePath2}, ignoring it.
${e}`);
        }
      return [...checks];
    }
    exports.loadThirdPartyChecks = loadThirdPartyChecks;
    async function findThirdPartyChecks(nodeModuleRoot) {
      let paths = [
        globJoin(nodeModuleRoot.replace(/\\/g, "/"), "/node_modules/theme-check-*/"),
        globJoin(nodeModuleRoot.replace(/\\/g, "/"), "/node_modules/@*/theme-check-*/")
      ];
      return (await Promise.all(paths.map((path3) => asyncGlob(path3)))).flat().filter((x) => !/\@shopify\/theme-check-(node|common|browser|docs-updater)/.test(x) && !/theme-check-vscode/.test(x));
    }
    exports.findThirdPartyChecks = findThirdPartyChecks;
    function globJoin(...parts) {
      return parts.flatMap((x) => x.replace(/\\/g, "/").replace(/\/+$/, "")).join("/");
    }
    function isObjLiteral(thing) {
      return thing !== null && typeof thing == "object";
    }
    function isCheckDefinition(thing) {
      return isObjLiteral(thing) && "meta" in thing && "create" in thing && isObjLiteral(thing.meta) && "code" in thing.meta;
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/load-config-description.js
var require_load_config_description = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/load-config-description.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.resolveRoot = exports.loadConfigDescription = void 0;
    var theme_check_common_1 = require_dist2(), node_path_1 = __importDefault(__require("node:path")), file_utils_1 = require_file_utils2(), installation_location_1 = require_installation_location(), load_third_party_checks_1 = require_load_third_party_checks(), flatten = (arrs) => arrs.flat();
    async function loadConfigDescription(configDescription, root) {
      var _a38;
      let nodeModuleRoot = await findNodeModuleRoot(root), thirdPartyChecksPaths = await Promise.all([
        (0, load_third_party_checks_1.findThirdPartyChecks)((0, installation_location_1.thisNodeModuleRoot)()),
        (0, load_third_party_checks_1.findThirdPartyChecks)(nodeModuleRoot)
      ]).then(flatten), thirdPartyChecks = (0, load_third_party_checks_1.loadThirdPartyChecks)([
        ...configDescription.require,
        ...thirdPartyChecksPaths
      ]), checks = theme_check_common_1.allChecks.concat(thirdPartyChecks).filter(isEnabledBy(configDescription));
      return {
        settings: unaliasedSettings(configDescription.checkSettings, checks),
        context: (_a38 = configDescription.context) !== null && _a38 !== void 0 ? _a38 : "theme",
        checks,
        ignore: configDescription.ignore,
        root: resolveRoot(root, configDescription.root)
      };
    }
    exports.loadConfigDescription = loadConfigDescription;
    function resolveRoot(root, pathLike) {
      if (pathLike === void 0)
        return root;
      if (node_path_1.default.isAbsolute(pathLike))
        throw new Error('the "root" property can only be relative');
      return node_path_1.default.resolve(root, pathLike);
    }
    exports.resolveRoot = resolveRoot;
    var isEnabledBy = (config2) => (checkDefinition) => {
      var _a38;
      let checkSettings = (_a38 = config2.checkSettings[checkDefinition.meta.code]) !== null && _a38 !== void 0 ? _a38 : aliasedSettings(config2, checkDefinition);
      return checkSettings ? checkSettings.enabled : !1;
    };
    function aliasedSettings(config2, checkDefinition) {
      if (!checkDefinition.meta.aliases)
        return;
      let usedAlias = checkDefinition.meta.aliases.find((alias) => config2.checkSettings[alias]);
      if (usedAlias)
        return config2.checkSettings[usedAlias];
    }
    function unaliasedSettings(settings, checks) {
      return Object.fromEntries(Object.entries(settings).map(([code, value]) => [unaliasedCode(code, checks), value]));
    }
    function unaliasedCode(code, checks) {
      let check2 = checks.find((check3) => {
        var _a38;
        return check3.meta.code === code || ((_a38 = check3.meta.aliases) === null || _a38 === void 0 ? void 0 : _a38.find((alias) => alias === code));
      });
      return check2?.meta.code;
    }
    async function isNodeModuleRoot(root) {
      if (node_path_1.default.dirname(root) === root)
        return !0;
      let [isNodeModuleRoot2, isGitRoot] = await Promise.all([
        (0, file_utils_1.fileExists)(node_path_1.default.join(root, "node_modules")),
        (0, file_utils_1.fileExists)(node_path_1.default.join(root, ".git"))
      ]);
      return isNodeModuleRoot2 || isGitRoot;
    }
    async function findNodeModuleRoot(root) {
      let curr = root;
      for (; !await isNodeModuleRoot(curr); )
        curr = node_path_1.default.dirname(curr);
      return curr;
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/validation.js
var require_validation = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/validation.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.validateConfig = void 0;
    var node_assert_1 = __require("node:assert");
    function validateConfig(config2) {
      for (let check2 of config2.checks) {
        let settings = config2.settings[check2.meta.code];
        (0, node_assert_1.strict)(settings, `Unexpected missing settings for ${check2.meta.code} in validateConfig call`), validateSettings(check2.meta.code, check2.meta.schema, settings, !0);
      }
    }
    exports.validateConfig = validateConfig;
    function validateSettings(checkCode, schema, settings, isTopLevel) {
      for (let key in schema) {
        let schemaProp = schema[key], settingValue = settings[key];
        validateValue(key, settingValue, schemaProp);
      }
      isTopLevel && validateCommonCheckSettings(settings), validateSuperfluousSettings(checkCode, schema, settings);
    }
    function validateCommonCheckSettings(settings) {
      let { severity, enabled, ignore } = settings;
      severity === void 0 || assertType("severity", "number", typeof severity), assertType("enabled", "boolean", typeof enabled), ignore === void 0 || assertArray("ignore", ignore);
    }
    function validateSuperfluousSettings(checkCode, schema, settings) {
      let commonCheckSettingsKeys = ["enabled", "severity", "ignore"];
      for (let key in settings)
        !(key in schema) && !commonCheckSettingsKeys.includes(key) && console.error(`Unexpected setting: ${key} for check ${checkCode} found in configuration`);
    }
    function validateValue(key, value, schemaProp) {
      let { type, optional, defaultValue, properties, itemType } = schemaProp.options;
      if (value === void 0) {
        if (optional !== !0 && defaultValue === void 0)
          throw new Error(`Missing required setting: ${key}`);
        return;
      }
      if (!(defaultValue !== void 0 && value === defaultValue))
        switch (type) {
          case "string":
          case "number":
          case "boolean": {
            assertType(key, type, typeof value);
            break;
          }
          case "object": {
            if (typeof value != "object" || value === null || Array.isArray(value))
              throw new Error(`Invalid type for setting ${key}: expected object, got ${typeof value}`);
            for (let nestedKey in properties)
              validateValue(nestedKey, value[nestedKey], properties[nestedKey]);
            break;
          }
          case "array": {
            if (assertArray(key, value), itemType)
              for (let item of value)
                validateValue(key, item, itemType);
            break;
          }
          default:
            throw new Error(`Unexpected setting type: ${type}`);
        }
    }
    function assertType(key, expectedType, actualType) {
      node_assert_1.strict.strictEqual(actualType, expectedType, `Invalid type for setting ${key}: expected ${expectedType}, got ${actualType}`);
    }
    function assertArray(key, thing) {
      node_assert_1.strict.ok(Array.isArray(thing), `Invalid type for setting ${key}: expected array, got ${typeof thing}`);
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/load-config.js
var require_load_config = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/load-config.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.loadConfig = void 0;
    var resolve_1 = require_resolve(), load_config_description_1 = require_load_config_description(), validation_1 = require_validation();
    async function loadConfig2(configPath, root) {
      if (!root)
        throw new Error("loadConfig cannot be called without a root argument");
      let configDescription = await (0, resolve_1.resolveConfig)(configPath ?? "theme-check:recommended", !0), config2 = await (0, load_config_description_1.loadConfigDescription)(configDescription, root);
      return (0, validation_1.validateConfig)(config2), config2;
    }
    exports.loadConfig = loadConfig2;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/find-config-path.js
var require_find_config_path = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/find-config-path.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.findConfigPath = void 0;
    var node_path_1 = __importDefault(__require("node:path")), file_utils_1 = require_file_utils2(), DiscoverableConfigFileNames = [".theme-check.yml"];
    function findConfigPath(root) {
      let paths = DiscoverableConfigFileNames.map((file) => node_path_1.default.join(root, file));
      return find(paths, file_utils_1.fileExists);
    }
    exports.findConfigPath = findConfigPath;
    async function find(array, pred) {
      for (let el of array)
        if (await pred(el))
          return el;
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/index.js
var require_config = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/config/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.findConfigPath = exports.loadConfig = void 0;
    var load_config_1 = require_load_config();
    Object.defineProperty(exports, "loadConfig", { enumerable: !0, get: function() {
      return load_config_1.loadConfig;
    } });
    var find_config_path_1 = require_find_config_path();
    Object.defineProperty(exports, "findConfigPath", { enumerable: !0, get: function() {
      return find_config_path_1.findConfigPath;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/find-root.js
var require_find_root = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/find-root.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: !0, value: v });
    } : function(o, v) {
      o.default = v;
    }), __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null)
        for (var k in mod)
          k !== "default" && Object.prototype.hasOwnProperty.call(mod, k) && __createBinding(result, mod, k);
      return __setModuleDefault(result, mod), result;
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.findRoot = exports.reusableFindRoot = void 0;
    var path3 = __importStar(__require("path")), file_utils_1 = require_file_utils2();
    async function isRoot(dir, path4) {
      return or(
        (0, file_utils_1.fileExists)(path4.join(dir, "shopify.extension.toml")),
        // for theme-app-extensions
        (0, file_utils_1.fileExists)(path4.join(dir, ".theme-check.yml")),
        (0, file_utils_1.fileExists)(path4.join(dir, ".git")),
        // zip files and TAEs might not have config files, but they should have a
        // snippets directory but in case they do specify a .theme-check.yml a
        // couple of directories up, we should respect that
        and((0, file_utils_1.fileExists)(path4.join(dir, "snippets")), not((0, file_utils_1.fileExists)(path4.join(path4.dirname(dir), ".theme-check.yml"))), not((0, file_utils_1.fileExists)(path4.join(path4.dirname(path4.dirname(dir)), ".theme-check.yml"))))
      );
    }
    async function and(...promises) {
      return (await Promise.all(promises)).reduce((a, b) => a && b, !0);
    }
    async function or(...promises) {
      return (await Promise.all(promises)).reduce((a, b) => a || b, !1);
    }
    async function not(ap) {
      return !await ap;
    }
    var FilePathHandler = {
      join(base, ...paths) {
        return path3.join(base, ...paths);
      },
      dirname(pathStr) {
        return path3.dirname(pathStr);
      },
      asPath(pathStr) {
        return pathStr;
      }
    };
    async function reusableFindRoot(curr, path4) {
      if (await isRoot(curr, path4))
        return curr;
      let dir = path4.dirname(curr);
      return dir === curr ? curr : reusableFindRoot(dir, path4);
    }
    exports.reusableFindRoot = reusableFindRoot;
    async function findRoot(curr) {
      return reusableFindRoot(curr, FilePathHandler);
    }
    exports.findRoot = findRoot;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/index.js
var require_dist5 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-check-node@2.8.0/node_modules/@shopify/theme-check-node/dist/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p) && __createBinding(exports2, m, p);
    }, __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.getTheme = exports.themeCheckRun = exports.checkAndAutofix = exports.check = exports.toSourceCode = exports.loadConfig = exports.reusableFindRoot = exports.findRoot = void 0;
    var theme_check_common_1 = require_dist2(), theme_check_docs_updater_1 = require_dist3(), promises_1 = __importDefault(__require("node:fs/promises")), node_path_1 = __importDefault(__require("node:path")), node_util_1 = __require("node:util"), glob2 = require_glob2(), autofix_1 = require_autofix2(), config_1 = require_config(), file_utils_1 = require_file_utils2(), defaultLocale = "en", asyncGlob = (0, node_util_1.promisify)(glob2);
    __exportStar(require_dist2(), exports);
    __exportStar(require_types4(), exports);
    var find_root_1 = require_find_root();
    Object.defineProperty(exports, "findRoot", { enumerable: !0, get: function() {
      return find_root_1.findRoot;
    } });
    Object.defineProperty(exports, "reusableFindRoot", { enumerable: !0, get: function() {
      return find_root_1.reusableFindRoot;
    } });
    var loadConfig2 = async (configPath, root) => (configPath ?? (configPath = await (0, config_1.findConfigPath)(root)), (0, config_1.loadConfig)(configPath, root));
    exports.loadConfig = loadConfig2;
    async function toSourceCode(absolutePath) {
      try {
        let source = await promises_1.default.readFile(absolutePath, "utf8");
        return (0, theme_check_common_1.toSourceCode)(absolutePath, source);
      } catch {
        return;
      }
    }
    exports.toSourceCode = toSourceCode;
    async function check2(root, configPath) {
      return (await themeCheckRun2(root, configPath)).offenses;
    }
    exports.check = check2;
    async function checkAndAutofix(root, configPath) {
      let { theme, offenses } = await themeCheckRun2(root, configPath);
      await (0, autofix_1.autofix)(theme, offenses);
    }
    exports.checkAndAutofix = checkAndAutofix;
    async function themeCheckRun2(root, configPath, log = () => {
    }) {
      var _a38, _b;
      let { theme, config: config2 } = await getThemeAndConfig(root, configPath), defaultTranslationsFile = theme.find((sc) => sc.absolutePath.endsWith("default.json")), defaultTranslations = (0, theme_check_common_1.parseJSON)((_a38 = defaultTranslationsFile?.source) !== null && _a38 !== void 0 ? _a38 : "{}", {}), defaultSchemaTranslationsFile = theme.find((sc) => sc.absolutePath.endsWith("default.schema.json")), defaultSchemaTranslations = (0, theme_check_common_1.parseJSON)((_b = defaultSchemaTranslationsFile?.source) !== null && _b !== void 0 ? _b : "{}", {}), themeLiquidDocsManager = new theme_check_docs_updater_1.ThemeLiquidDocsManager(log), offenses = await (0, theme_check_common_1.check)(theme, config2, {
        fileExists: file_utils_1.fileExists,
        fileSize: file_utils_1.fileSize,
        themeDocset: themeLiquidDocsManager,
        jsonValidationSet: themeLiquidDocsManager,
        getDefaultTranslations: async () => defaultTranslations,
        getDefaultLocale: async () => {
          var _a39;
          return defaultTranslationsFile && ((_a39 = defaultTranslationsFile.absolutePath.match(/locales\/(.*)\.default\.json$/)) === null || _a39 === void 0 ? void 0 : _a39[1]) || defaultLocale;
        },
        getDefaultSchemaTranslations: async () => defaultSchemaTranslations,
        getDefaultSchemaLocale: async () => {
          var _a39;
          return defaultSchemaTranslationsFile && ((_a39 = defaultSchemaTranslationsFile.absolutePath.match(/locales\/(.*)\.default\.schema\.json$/)) === null || _a39 === void 0 ? void 0 : _a39[1]) || defaultLocale;
        }
      });
      return {
        theme,
        config: config2,
        offenses
      };
    }
    exports.themeCheckRun = themeCheckRun2;
    async function getThemeAndConfig(root, configPath) {
      let config2 = await (0, exports.loadConfig)(configPath, root);
      return {
        theme: await getTheme(config2),
        config: config2
      };
    }
    async function getTheme(config2) {
      let normalizedGlob = node_path_1.default.normalize(node_path_1.default.join(config2.root, "**/*.{liquid,json}")).replace(/\\/g, "/"), paths = await asyncGlob(normalizedGlob).then((result) => (
        // Global ignored paths should not be part of the theme
        result.filter((filePath) => !(0, theme_check_common_1.isIgnored)(filePath, config2))
      ));
      return (await Promise.all(paths.map(toSourceCode))).filter((x) => x !== void 0);
    }
    exports.getTheme = getTheme;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/types.js
var require_types5 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/types.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/utils/debounce.js
var require_debounce = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/utils/debounce.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.debounce = void 0;
    function debounce(fn, ms) {
      let timeoutId = null, force = !1, debouncedFn = (...args) => {
        timeoutId !== null && force || (timeoutId !== null && clearTimeout(timeoutId), timeoutId = setTimeout(async () => {
          await Promise.resolve(fn(...args)), timeoutId = null, force = !1;
        }, ms));
      };
      return debouncedFn.force = (...args) => {
        debouncedFn(...args), force = !0;
      }, debouncedFn;
    }
    exports.debounce = debounce;
  }
});

// ../../node_modules/.pnpm/vscode-uri@3.0.8/node_modules/vscode-uri/lib/umd/index.js
var require_umd = __commonJS({
  "../../node_modules/.pnpm/vscode-uri@3.0.8/node_modules/vscode-uri/lib/umd/index.js"(exports, module) {
    init_cjs_shims();
    (function(t7, e) {
      if (typeof exports == "object" && typeof module == "object")
        module.exports = e();
      else if (typeof define == "function" && define.amd)
        define([], e);
      else {
        var r2 = e();
        for (var n in r2)
          (typeof exports == "object" ? exports : t7)[n] = r2[n];
      }
    })(exports, () => (() => {
      "use strict";
      var t7 = { 470: (t8) => {
        function e2(t9) {
          if (typeof t9 != "string")
            throw new TypeError("Path must be a string. Received " + JSON.stringify(t9));
        }
        function r3(t9, e3) {
          for (var r4, n3 = "", i = 0, o = -1, s = 0, a = 0; a <= t9.length; ++a) {
            if (a < t9.length)
              r4 = t9.charCodeAt(a);
            else {
              if (r4 === 47)
                break;
              r4 = 47;
            }
            if (r4 === 47) {
              if (!(o === a - 1 || s === 1))
                if (o !== a - 1 && s === 2) {
                  if (n3.length < 2 || i !== 2 || n3.charCodeAt(n3.length - 1) !== 46 || n3.charCodeAt(n3.length - 2) !== 46) {
                    if (n3.length > 2) {
                      var h = n3.lastIndexOf("/");
                      if (h !== n3.length - 1) {
                        h === -1 ? (n3 = "", i = 0) : i = (n3 = n3.slice(0, h)).length - 1 - n3.lastIndexOf("/"), o = a, s = 0;
                        continue;
                      }
                    } else if (n3.length === 2 || n3.length === 1) {
                      n3 = "", i = 0, o = a, s = 0;
                      continue;
                    }
                  }
                  e3 && (n3.length > 0 ? n3 += "/.." : n3 = "..", i = 2);
                } else
                  n3.length > 0 ? n3 += "/" + t9.slice(o + 1, a) : n3 = t9.slice(o + 1, a), i = a - o - 1;
              o = a, s = 0;
            } else
              r4 === 46 && s !== -1 ? ++s : s = -1;
          }
          return n3;
        }
        var n2 = { resolve: function() {
          for (var t9, n3 = "", i = !1, o = arguments.length - 1; o >= -1 && !i; o--) {
            var s;
            o >= 0 ? s = arguments[o] : (t9 === void 0 && (t9 = process.cwd()), s = t9), e2(s), s.length !== 0 && (n3 = s + "/" + n3, i = s.charCodeAt(0) === 47);
          }
          return n3 = r3(n3, !i), i ? n3.length > 0 ? "/" + n3 : "/" : n3.length > 0 ? n3 : ".";
        }, normalize: function(t9) {
          if (e2(t9), t9.length === 0)
            return ".";
          var n3 = t9.charCodeAt(0) === 47, i = t9.charCodeAt(t9.length - 1) === 47;
          return (t9 = r3(t9, !n3)).length !== 0 || n3 || (t9 = "."), t9.length > 0 && i && (t9 += "/"), n3 ? "/" + t9 : t9;
        }, isAbsolute: function(t9) {
          return e2(t9), t9.length > 0 && t9.charCodeAt(0) === 47;
        }, join: function() {
          if (arguments.length === 0)
            return ".";
          for (var t9, r4 = 0; r4 < arguments.length; ++r4) {
            var i = arguments[r4];
            e2(i), i.length > 0 && (t9 === void 0 ? t9 = i : t9 += "/" + i);
          }
          return t9 === void 0 ? "." : n2.normalize(t9);
        }, relative: function(t9, r4) {
          if (e2(t9), e2(r4), t9 === r4 || (t9 = n2.resolve(t9)) === (r4 = n2.resolve(r4)))
            return "";
          for (var i = 1; i < t9.length && t9.charCodeAt(i) === 47; ++i)
            ;
          for (var o = t9.length, s = o - i, a = 1; a < r4.length && r4.charCodeAt(a) === 47; ++a)
            ;
          for (var h = r4.length - a, c = s < h ? s : h, f = -1, u = 0; u <= c; ++u) {
            if (u === c) {
              if (h > c) {
                if (r4.charCodeAt(a + u) === 47)
                  return r4.slice(a + u + 1);
                if (u === 0)
                  return r4.slice(a + u);
              } else
                s > c && (t9.charCodeAt(i + u) === 47 ? f = u : u === 0 && (f = 0));
              break;
            }
            var l = t9.charCodeAt(i + u);
            if (l !== r4.charCodeAt(a + u))
              break;
            l === 47 && (f = u);
          }
          var d = "";
          for (u = i + f + 1; u <= o; ++u)
            u !== o && t9.charCodeAt(u) !== 47 || (d.length === 0 ? d += ".." : d += "/..");
          return d.length > 0 ? d + r4.slice(a + f) : (a += f, r4.charCodeAt(a) === 47 && ++a, r4.slice(a));
        }, _makeLong: function(t9) {
          return t9;
        }, dirname: function(t9) {
          if (e2(t9), t9.length === 0)
            return ".";
          for (var r4 = t9.charCodeAt(0), n3 = r4 === 47, i = -1, o = !0, s = t9.length - 1; s >= 1; --s)
            if ((r4 = t9.charCodeAt(s)) === 47) {
              if (!o) {
                i = s;
                break;
              }
            } else
              o = !1;
          return i === -1 ? n3 ? "/" : "." : n3 && i === 1 ? "//" : t9.slice(0, i);
        }, basename: function(t9, r4) {
          if (r4 !== void 0 && typeof r4 != "string")
            throw new TypeError('"ext" argument must be a string');
          e2(t9);
          var n3, i = 0, o = -1, s = !0;
          if (r4 !== void 0 && r4.length > 0 && r4.length <= t9.length) {
            if (r4.length === t9.length && r4 === t9)
              return "";
            var a = r4.length - 1, h = -1;
            for (n3 = t9.length - 1; n3 >= 0; --n3) {
              var c = t9.charCodeAt(n3);
              if (c === 47) {
                if (!s) {
                  i = n3 + 1;
                  break;
                }
              } else
                h === -1 && (s = !1, h = n3 + 1), a >= 0 && (c === r4.charCodeAt(a) ? --a == -1 && (o = n3) : (a = -1, o = h));
            }
            return i === o ? o = h : o === -1 && (o = t9.length), t9.slice(i, o);
          }
          for (n3 = t9.length - 1; n3 >= 0; --n3)
            if (t9.charCodeAt(n3) === 47) {
              if (!s) {
                i = n3 + 1;
                break;
              }
            } else
              o === -1 && (s = !1, o = n3 + 1);
          return o === -1 ? "" : t9.slice(i, o);
        }, extname: function(t9) {
          e2(t9);
          for (var r4 = -1, n3 = 0, i = -1, o = !0, s = 0, a = t9.length - 1; a >= 0; --a) {
            var h = t9.charCodeAt(a);
            if (h !== 47)
              i === -1 && (o = !1, i = a + 1), h === 46 ? r4 === -1 ? r4 = a : s !== 1 && (s = 1) : r4 !== -1 && (s = -1);
            else if (!o) {
              n3 = a + 1;
              break;
            }
          }
          return r4 === -1 || i === -1 || s === 0 || s === 1 && r4 === i - 1 && r4 === n3 + 1 ? "" : t9.slice(r4, i);
        }, format: function(t9) {
          if (t9 === null || typeof t9 != "object")
            throw new TypeError('The "pathObject" argument must be of type Object. Received type ' + typeof t9);
          return function(t10, e3) {
            var r4 = e3.dir || e3.root, n3 = e3.base || (e3.name || "") + (e3.ext || "");
            return r4 ? r4 === e3.root ? r4 + n3 : r4 + "/" + n3 : n3;
          }(0, t9);
        }, parse: function(t9) {
          e2(t9);
          var r4 = { root: "", dir: "", base: "", ext: "", name: "" };
          if (t9.length === 0)
            return r4;
          var n3, i = t9.charCodeAt(0), o = i === 47;
          o ? (r4.root = "/", n3 = 1) : n3 = 0;
          for (var s = -1, a = 0, h = -1, c = !0, f = t9.length - 1, u = 0; f >= n3; --f)
            if ((i = t9.charCodeAt(f)) !== 47)
              h === -1 && (c = !1, h = f + 1), i === 46 ? s === -1 ? s = f : u !== 1 && (u = 1) : s !== -1 && (u = -1);
            else if (!c) {
              a = f + 1;
              break;
            }
          return s === -1 || h === -1 || u === 0 || u === 1 && s === h - 1 && s === a + 1 ? h !== -1 && (r4.base = r4.name = a === 0 && o ? t9.slice(1, h) : t9.slice(a, h)) : (a === 0 && o ? (r4.name = t9.slice(1, s), r4.base = t9.slice(1, h)) : (r4.name = t9.slice(a, s), r4.base = t9.slice(a, h)), r4.ext = t9.slice(s, h)), a > 0 ? r4.dir = t9.slice(0, a - 1) : o && (r4.dir = "/"), r4;
        }, sep: "/", delimiter: ":", win32: null, posix: null };
        n2.posix = n2, t8.exports = n2;
      }, 674: (t8, e2) => {
        if (Object.defineProperty(e2, "__esModule", { value: !0 }), e2.isWindows = void 0, typeof process == "object")
          e2.isWindows = process.platform === "win32";
        else if (typeof navigator == "object") {
          let t9 = navigator.userAgent;
          e2.isWindows = t9.indexOf("Windows") >= 0;
        }
      }, 796: (t8, e2, r3) => {
        Object.defineProperty(e2, "__esModule", { value: !0 }), e2.uriToFsPath = e2.URI = void 0;
        let n2 = r3(674), i = /^\w[\w\d+.-]*$/, o = /^\//, s = /^\/\//;
        function a(t9, e3) {
          if (!t9.scheme && e3)
            throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t9.authority}", path: "${t9.path}", query: "${t9.query}", fragment: "${t9.fragment}"}`);
          if (t9.scheme && !i.test(t9.scheme))
            throw new Error("[UriError]: Scheme contains illegal characters.");
          if (t9.path) {
            if (t9.authority) {
              if (!o.test(t9.path))
                throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character');
            } else if (s.test(t9.path))
              throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")');
          }
        }
        let h = "", c = "/", f = /^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;
        class u {
          static isUri(t9) {
            return t9 instanceof u || !!t9 && typeof t9.authority == "string" && typeof t9.fragment == "string" && typeof t9.path == "string" && typeof t9.query == "string" && typeof t9.scheme == "string" && typeof t9.fsPath == "string" && typeof t9.with == "function" && typeof t9.toString == "function";
          }
          scheme;
          authority;
          path;
          query;
          fragment;
          constructor(t9, e3, r4, n3, i2, o2 = !1) {
            typeof t9 == "object" ? (this.scheme = t9.scheme || h, this.authority = t9.authority || h, this.path = t9.path || h, this.query = t9.query || h, this.fragment = t9.fragment || h) : (this.scheme = /* @__PURE__ */ function(t10, e4) {
              return t10 || e4 ? t10 : "file";
            }(t9, o2), this.authority = e3 || h, this.path = function(t10, e4) {
              switch (t10) {
                case "https":
                case "http":
                case "file":
                  e4 ? e4[0] !== c && (e4 = c + e4) : e4 = c;
              }
              return e4;
            }(this.scheme, r4 || h), this.query = n3 || h, this.fragment = i2 || h, a(this, o2));
          }
          get fsPath() {
            return v(this, !1);
          }
          with(t9) {
            if (!t9)
              return this;
            let { scheme: e3, authority: r4, path: n3, query: i2, fragment: o2 } = t9;
            return e3 === void 0 ? e3 = this.scheme : e3 === null && (e3 = h), r4 === void 0 ? r4 = this.authority : r4 === null && (r4 = h), n3 === void 0 ? n3 = this.path : n3 === null && (n3 = h), i2 === void 0 ? i2 = this.query : i2 === null && (i2 = h), o2 === void 0 ? o2 = this.fragment : o2 === null && (o2 = h), e3 === this.scheme && r4 === this.authority && n3 === this.path && i2 === this.query && o2 === this.fragment ? this : new d(e3, r4, n3, i2, o2);
          }
          static parse(t9, e3 = !1) {
            let r4 = f.exec(t9);
            return r4 ? new d(r4[2] || h, w(r4[4] || h), w(r4[5] || h), w(r4[7] || h), w(r4[9] || h), e3) : new d(h, h, h, h, h);
          }
          static file(t9) {
            let e3 = h;
            if (n2.isWindows && (t9 = t9.replace(/\\/g, c)), t9[0] === c && t9[1] === c) {
              let r4 = t9.indexOf(c, 2);
              r4 === -1 ? (e3 = t9.substring(2), t9 = c) : (e3 = t9.substring(2, r4), t9 = t9.substring(r4) || c);
            }
            return new d("file", e3, t9, h, h);
          }
          static from(t9) {
            let e3 = new d(t9.scheme, t9.authority, t9.path, t9.query, t9.fragment);
            return a(e3, !0), e3;
          }
          toString(t9 = !1) {
            return y(this, t9);
          }
          toJSON() {
            return this;
          }
          static revive(t9) {
            if (t9) {
              if (t9 instanceof u)
                return t9;
              {
                let e3 = new d(t9);
                return e3._formatted = t9.external, e3._fsPath = t9._sep === l ? t9.fsPath : null, e3;
              }
            }
            return t9;
          }
        }
        e2.URI = u;
        let l = n2.isWindows ? 1 : void 0;
        class d extends u {
          _formatted = null;
          _fsPath = null;
          get fsPath() {
            return this._fsPath || (this._fsPath = v(this, !1)), this._fsPath;
          }
          toString(t9 = !1) {
            return t9 ? y(this, !0) : (this._formatted || (this._formatted = y(this, !1)), this._formatted);
          }
          toJSON() {
            let t9 = { $mid: 1 };
            return this._fsPath && (t9.fsPath = this._fsPath, t9._sep = l), this._formatted && (t9.external = this._formatted), this.path && (t9.path = this.path), this.scheme && (t9.scheme = this.scheme), this.authority && (t9.authority = this.authority), this.query && (t9.query = this.query), this.fragment && (t9.fragment = this.fragment), t9;
          }
        }
        let p = { 58: "%3A", 47: "%2F", 63: "%3F", 35: "%23", 91: "%5B", 93: "%5D", 64: "%40", 33: "%21", 36: "%24", 38: "%26", 39: "%27", 40: "%28", 41: "%29", 42: "%2A", 43: "%2B", 44: "%2C", 59: "%3B", 61: "%3D", 32: "%20" };
        function g(t9, e3, r4) {
          let n3, i2 = -1;
          for (let o2 = 0; o2 < t9.length; o2++) {
            let s2 = t9.charCodeAt(o2);
            if (s2 >= 97 && s2 <= 122 || s2 >= 65 && s2 <= 90 || s2 >= 48 && s2 <= 57 || s2 === 45 || s2 === 46 || s2 === 95 || s2 === 126 || e3 && s2 === 47 || r4 && s2 === 91 || r4 && s2 === 93 || r4 && s2 === 58)
              i2 !== -1 && (n3 += encodeURIComponent(t9.substring(i2, o2)), i2 = -1), n3 !== void 0 && (n3 += t9.charAt(o2));
            else {
              n3 === void 0 && (n3 = t9.substr(0, o2));
              let e4 = p[s2];
              e4 !== void 0 ? (i2 !== -1 && (n3 += encodeURIComponent(t9.substring(i2, o2)), i2 = -1), n3 += e4) : i2 === -1 && (i2 = o2);
            }
          }
          return i2 !== -1 && (n3 += encodeURIComponent(t9.substring(i2))), n3 !== void 0 ? n3 : t9;
        }
        function m(t9) {
          let e3;
          for (let r4 = 0; r4 < t9.length; r4++) {
            let n3 = t9.charCodeAt(r4);
            n3 === 35 || n3 === 63 ? (e3 === void 0 && (e3 = t9.substr(0, r4)), e3 += p[n3]) : e3 !== void 0 && (e3 += t9[r4]);
          }
          return e3 !== void 0 ? e3 : t9;
        }
        function v(t9, e3) {
          let r4;
          return r4 = t9.authority && t9.path.length > 1 && t9.scheme === "file" ? `//${t9.authority}${t9.path}` : t9.path.charCodeAt(0) === 47 && (t9.path.charCodeAt(1) >= 65 && t9.path.charCodeAt(1) <= 90 || t9.path.charCodeAt(1) >= 97 && t9.path.charCodeAt(1) <= 122) && t9.path.charCodeAt(2) === 58 ? e3 ? t9.path.substr(1) : t9.path[1].toLowerCase() + t9.path.substr(2) : t9.path, n2.isWindows && (r4 = r4.replace(/\//g, "\\")), r4;
        }
        function y(t9, e3) {
          let r4 = e3 ? m : g, n3 = "", { scheme: i2, authority: o2, path: s2, query: a2, fragment: h2 } = t9;
          if (i2 && (n3 += i2, n3 += ":"), (o2 || i2 === "file") && (n3 += c, n3 += c), o2) {
            let t10 = o2.indexOf("@");
            if (t10 !== -1) {
              let e4 = o2.substr(0, t10);
              o2 = o2.substr(t10 + 1), t10 = e4.lastIndexOf(":"), t10 === -1 ? n3 += r4(e4, !1, !1) : (n3 += r4(e4.substr(0, t10), !1, !1), n3 += ":", n3 += r4(e4.substr(t10 + 1), !1, !0)), n3 += "@";
            }
            o2 = o2.toLowerCase(), t10 = o2.lastIndexOf(":"), t10 === -1 ? n3 += r4(o2, !1, !0) : (n3 += r4(o2.substr(0, t10), !1, !0), n3 += o2.substr(t10));
          }
          if (s2) {
            if (s2.length >= 3 && s2.charCodeAt(0) === 47 && s2.charCodeAt(2) === 58) {
              let t10 = s2.charCodeAt(1);
              t10 >= 65 && t10 <= 90 && (s2 = `/${String.fromCharCode(t10 + 32)}:${s2.substr(3)}`);
            } else if (s2.length >= 2 && s2.charCodeAt(1) === 58) {
              let t10 = s2.charCodeAt(0);
              t10 >= 65 && t10 <= 90 && (s2 = `${String.fromCharCode(t10 + 32)}:${s2.substr(2)}`);
            }
            n3 += r4(s2, !0, !1);
          }
          return a2 && (n3 += "?", n3 += r4(a2, !1, !1)), h2 && (n3 += "#", n3 += e3 ? h2 : g(h2, !1, !1)), n3;
        }
        function b(t9) {
          try {
            return decodeURIComponent(t9);
          } catch {
            return t9.length > 3 ? t9.substr(0, 3) + b(t9.substr(3)) : t9;
          }
        }
        e2.uriToFsPath = v;
        let C = /(%[0-9A-Za-z][0-9A-Za-z])+/g;
        function w(t9) {
          return t9.match(C) ? t9.replace(C, (t10) => b(t10)) : t9;
        }
      }, 679: function(t8, e2, r3) {
        var n2 = this && this.__createBinding || (Object.create ? function(t9, e3, r4, n3) {
          n3 === void 0 && (n3 = r4);
          var i2 = Object.getOwnPropertyDescriptor(e3, r4);
          i2 && !("get" in i2 ? !e3.__esModule : i2.writable || i2.configurable) || (i2 = { enumerable: !0, get: function() {
            return e3[r4];
          } }), Object.defineProperty(t9, n3, i2);
        } : function(t9, e3, r4, n3) {
          n3 === void 0 && (n3 = r4), t9[n3] = e3[r4];
        }), i = this && this.__setModuleDefault || (Object.create ? function(t9, e3) {
          Object.defineProperty(t9, "default", { enumerable: !0, value: e3 });
        } : function(t9, e3) {
          t9.default = e3;
        }), o = this && this.__importStar || function(t9) {
          if (t9 && t9.__esModule)
            return t9;
          var e3 = {};
          if (t9 != null)
            for (var r4 in t9)
              r4 !== "default" && Object.prototype.hasOwnProperty.call(t9, r4) && n2(e3, t9, r4);
          return i(e3, t9), e3;
        };
        Object.defineProperty(e2, "__esModule", { value: !0 }), e2.Utils = void 0;
        let s = o(r3(470)), a = s.posix || s, h = "/";
        var c;
        (function(t9) {
          t9.joinPath = function(t10, ...e3) {
            return t10.with({ path: a.join(t10.path, ...e3) });
          }, t9.resolvePath = function(t10, ...e3) {
            let r4 = t10.path, n3 = !1;
            r4[0] !== h && (r4 = h + r4, n3 = !0);
            let i2 = a.resolve(r4, ...e3);
            return n3 && i2[0] === h && !t10.authority && (i2 = i2.substring(1)), t10.with({ path: i2 });
          }, t9.dirname = function(t10) {
            if (t10.path.length === 0 || t10.path === h)
              return t10;
            let e3 = a.dirname(t10.path);
            return e3.length === 1 && e3.charCodeAt(0) === 46 && (e3 = ""), t10.with({ path: e3 });
          }, t9.basename = function(t10) {
            return a.basename(t10.path);
          }, t9.extname = function(t10) {
            return a.extname(t10.path);
          };
        })(c || (e2.Utils = c = {}));
      } }, e = {};
      function r2(n2) {
        var i = e[n2];
        if (i !== void 0)
          return i.exports;
        var o = e[n2] = { exports: {} };
        return t7[n2].call(o.exports, o, o.exports, r2), o.exports;
      }
      var n = {};
      return (() => {
        var t8 = n;
        Object.defineProperty(t8, "__esModule", { value: !0 }), t8.Utils = t8.URI = void 0;
        let e2 = r2(796);
        Object.defineProperty(t8, "URI", { enumerable: !0, get: function() {
          return e2.URI;
        } });
        let i = r2(679);
        Object.defineProperty(t8, "Utils", { enumerable: !0, get: function() {
          return i.Utils;
        } });
      })(), n;
    })());
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/utils/paths.js
var require_paths = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/utils/paths.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.toAbsolutePath = void 0;
    var vscode_uri_1 = require_umd();
    function toAbsolutePath(uriString) {
      return vscode_uri_1.URI.parse(uriString).path;
    }
    exports.toAbsolutePath = toAbsolutePath;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/utils/array.js
var require_array2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/utils/array.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.findLast = void 0;
    function findLast(array, pred) {
      for (let i = array.length - 1; i >= 0; i--)
        if (pred(array[i]))
          return array[i];
    }
    exports.findLast = findLast;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/utils/node.js
var require_node = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/utils/node.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.isLiquidVariableOutput = exports.isNamedLiquidTag = exports.isHtmlAttribute = exports.getCompoundName = exports.isNamedHtmlElementNode = exports.isAttrEmpty = exports.isTextNode = exports.HtmlAttributeTypes = exports.HtmlElementTypes = void 0;
    var liquid_html_parser_1 = require_dist();
    exports.HtmlElementTypes = [
      liquid_html_parser_1.NodeTypes.HtmlElement,
      liquid_html_parser_1.NodeTypes.HtmlDanglingMarkerClose,
      liquid_html_parser_1.NodeTypes.HtmlSelfClosingElement,
      liquid_html_parser_1.NodeTypes.HtmlVoidElement,
      liquid_html_parser_1.NodeTypes.HtmlRawNode
    ];
    exports.HtmlAttributeTypes = [
      liquid_html_parser_1.NodeTypes.AttrUnquoted,
      liquid_html_parser_1.NodeTypes.AttrDoubleQuoted,
      liquid_html_parser_1.NodeTypes.AttrSingleQuoted,
      liquid_html_parser_1.NodeTypes.AttrEmpty
    ];
    function isTextNode(node) {
      return node.type === liquid_html_parser_1.NodeTypes.TextNode;
    }
    exports.isTextNode = isTextNode;
    function isAttrEmpty(node) {
      return node.type === liquid_html_parser_1.NodeTypes.AttrEmpty;
    }
    exports.isAttrEmpty = isAttrEmpty;
    function isNamedHtmlElementNode(node) {
      return exports.HtmlElementTypes.includes(node.type);
    }
    exports.isNamedHtmlElementNode = isNamedHtmlElementNode;
    function getCompoundName(node) {
      if (typeof node.name == "string")
        return node.name;
      let names = node.name;
      return names.length === 0 || names.length > 1 || !isTextNode(names[0]) ? "unknown" : names[0].value;
    }
    exports.getCompoundName = getCompoundName;
    function isHtmlAttribute(node) {
      return exports.HtmlAttributeTypes.some((type) => node.type === type);
    }
    exports.isHtmlAttribute = isHtmlAttribute;
    function isNamedLiquidTag(node, name) {
      return node.type === liquid_html_parser_1.NodeTypes.LiquidTag && node.name === name && typeof node.markup != "string";
    }
    exports.isNamedLiquidTag = isNamedLiquidTag;
    function isLiquidVariableOutput(node) {
      return node.type === liquid_html_parser_1.NodeTypes.LiquidVariableOutput && typeof node.markup != "string";
    }
    exports.isLiquidVariableOutput = isLiquidVariableOutput;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/utils/index.js
var require_utils6 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/utils/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p) && __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.memoize = exports.memo = void 0;
    var theme_check_common_1 = require_dist2();
    Object.defineProperty(exports, "memo", { enumerable: !0, get: function() {
      return theme_check_common_1.memo;
    } });
    Object.defineProperty(exports, "memoize", { enumerable: !0, get: function() {
      return theme_check_common_1.memoize;
    } });
    __exportStar(require_debounce(), exports);
    __exportStar(require_paths(), exports);
    __exportStar(require_array2(), exports);
    __exportStar(require_node(), exports);
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/utils/is.js
var require_is = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/utils/is.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.thenable = exports.typedArray = exports.stringArray = exports.array = exports.func = exports.error = exports.number = exports.string = exports.boolean = void 0;
    function boolean(value) {
      return value === !0 || value === !1;
    }
    exports.boolean = boolean;
    function string(value) {
      return typeof value == "string" || value instanceof String;
    }
    exports.string = string;
    function number(value) {
      return typeof value == "number" || value instanceof Number;
    }
    exports.number = number;
    function error(value) {
      return value instanceof Error;
    }
    exports.error = error;
    function func(value) {
      return typeof value == "function";
    }
    exports.func = func;
    function array(value) {
      return Array.isArray(value);
    }
    exports.array = array;
    function stringArray(value) {
      return array(value) && value.every((elem) => string(elem));
    }
    exports.stringArray = stringArray;
    function typedArray(value, check2) {
      return Array.isArray(value) && value.every(check2);
    }
    exports.typedArray = typedArray;
    function thenable(value) {
      return value && func(value.then);
    }
    exports.thenable = thenable;
  }
});

// ../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/is.js
var require_is2 = __commonJS({
  "../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/is.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.stringArray = exports.array = exports.func = exports.error = exports.number = exports.string = exports.boolean = void 0;
    function boolean(value) {
      return value === !0 || value === !1;
    }
    exports.boolean = boolean;
    function string(value) {
      return typeof value == "string" || value instanceof String;
    }
    exports.string = string;
    function number(value) {
      return typeof value == "number" || value instanceof Number;
    }
    exports.number = number;
    function error(value) {
      return value instanceof Error;
    }
    exports.error = error;
    function func(value) {
      return typeof value == "function";
    }
    exports.func = func;
    function array(value) {
      return Array.isArray(value);
    }
    exports.array = array;
    function stringArray(value) {
      return array(value) && value.every((elem) => string(elem));
    }
    exports.stringArray = stringArray;
  }
});

// ../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/messages.js
var require_messages = __commonJS({
  "../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/messages.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.Message = exports.NotificationType9 = exports.NotificationType8 = exports.NotificationType7 = exports.NotificationType6 = exports.NotificationType5 = exports.NotificationType4 = exports.NotificationType3 = exports.NotificationType2 = exports.NotificationType1 = exports.NotificationType0 = exports.NotificationType = exports.RequestType9 = exports.RequestType8 = exports.RequestType7 = exports.RequestType6 = exports.RequestType5 = exports.RequestType4 = exports.RequestType3 = exports.RequestType2 = exports.RequestType1 = exports.RequestType = exports.RequestType0 = exports.AbstractMessageSignature = exports.ParameterStructures = exports.ResponseError = exports.ErrorCodes = void 0;
    var is = require_is2(), ErrorCodes;
    (function(ErrorCodes2) {
      ErrorCodes2.ParseError = -32700, ErrorCodes2.InvalidRequest = -32600, ErrorCodes2.MethodNotFound = -32601, ErrorCodes2.InvalidParams = -32602, ErrorCodes2.InternalError = -32603, ErrorCodes2.jsonrpcReservedErrorRangeStart = -32099, ErrorCodes2.serverErrorStart = -32099, ErrorCodes2.MessageWriteError = -32099, ErrorCodes2.MessageReadError = -32098, ErrorCodes2.PendingResponseRejected = -32097, ErrorCodes2.ConnectionInactive = -32096, ErrorCodes2.ServerNotInitialized = -32002, ErrorCodes2.UnknownErrorCode = -32001, ErrorCodes2.jsonrpcReservedErrorRangeEnd = -32e3, ErrorCodes2.serverErrorEnd = -32e3;
    })(ErrorCodes = exports.ErrorCodes || (exports.ErrorCodes = {}));
    var ResponseError = class _ResponseError extends Error {
      constructor(code, message, data) {
        super(message), this.code = is.number(code) ? code : ErrorCodes.UnknownErrorCode, this.data = data, Object.setPrototypeOf(this, _ResponseError.prototype);
      }
      toJson() {
        let result = {
          code: this.code,
          message: this.message
        };
        return this.data !== void 0 && (result.data = this.data), result;
      }
    };
    exports.ResponseError = ResponseError;
    var ParameterStructures = class _ParameterStructures {
      constructor(kind) {
        this.kind = kind;
      }
      static is(value) {
        return value === _ParameterStructures.auto || value === _ParameterStructures.byName || value === _ParameterStructures.byPosition;
      }
      toString() {
        return this.kind;
      }
    };
    exports.ParameterStructures = ParameterStructures;
    ParameterStructures.auto = new ParameterStructures("auto");
    ParameterStructures.byPosition = new ParameterStructures("byPosition");
    ParameterStructures.byName = new ParameterStructures("byName");
    var AbstractMessageSignature = class {
      constructor(method, numberOfParams) {
        this.method = method, this.numberOfParams = numberOfParams;
      }
      get parameterStructures() {
        return ParameterStructures.auto;
      }
    };
    exports.AbstractMessageSignature = AbstractMessageSignature;
    var RequestType0 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 0);
      }
    };
    exports.RequestType0 = RequestType0;
    var RequestType = class extends AbstractMessageSignature {
      constructor(method, _parameterStructures = ParameterStructures.auto) {
        super(method, 1), this._parameterStructures = _parameterStructures;
      }
      get parameterStructures() {
        return this._parameterStructures;
      }
    };
    exports.RequestType = RequestType;
    var RequestType1 = class extends AbstractMessageSignature {
      constructor(method, _parameterStructures = ParameterStructures.auto) {
        super(method, 1), this._parameterStructures = _parameterStructures;
      }
      get parameterStructures() {
        return this._parameterStructures;
      }
    };
    exports.RequestType1 = RequestType1;
    var RequestType2 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 2);
      }
    };
    exports.RequestType2 = RequestType2;
    var RequestType3 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 3);
      }
    };
    exports.RequestType3 = RequestType3;
    var RequestType4 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 4);
      }
    };
    exports.RequestType4 = RequestType4;
    var RequestType5 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 5);
      }
    };
    exports.RequestType5 = RequestType5;
    var RequestType6 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 6);
      }
    };
    exports.RequestType6 = RequestType6;
    var RequestType7 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 7);
      }
    };
    exports.RequestType7 = RequestType7;
    var RequestType8 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 8);
      }
    };
    exports.RequestType8 = RequestType8;
    var RequestType9 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 9);
      }
    };
    exports.RequestType9 = RequestType9;
    var NotificationType = class extends AbstractMessageSignature {
      constructor(method, _parameterStructures = ParameterStructures.auto) {
        super(method, 1), this._parameterStructures = _parameterStructures;
      }
      get parameterStructures() {
        return this._parameterStructures;
      }
    };
    exports.NotificationType = NotificationType;
    var NotificationType0 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 0);
      }
    };
    exports.NotificationType0 = NotificationType0;
    var NotificationType1 = class extends AbstractMessageSignature {
      constructor(method, _parameterStructures = ParameterStructures.auto) {
        super(method, 1), this._parameterStructures = _parameterStructures;
      }
      get parameterStructures() {
        return this._parameterStructures;
      }
    };
    exports.NotificationType1 = NotificationType1;
    var NotificationType2 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 2);
      }
    };
    exports.NotificationType2 = NotificationType2;
    var NotificationType3 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 3);
      }
    };
    exports.NotificationType3 = NotificationType3;
    var NotificationType4 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 4);
      }
    };
    exports.NotificationType4 = NotificationType4;
    var NotificationType5 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 5);
      }
    };
    exports.NotificationType5 = NotificationType5;
    var NotificationType6 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 6);
      }
    };
    exports.NotificationType6 = NotificationType6;
    var NotificationType7 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 7);
      }
    };
    exports.NotificationType7 = NotificationType7;
    var NotificationType8 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 8);
      }
    };
    exports.NotificationType8 = NotificationType8;
    var NotificationType9 = class extends AbstractMessageSignature {
      constructor(method) {
        super(method, 9);
      }
    };
    exports.NotificationType9 = NotificationType9;
    var Message;
    (function(Message2) {
      function isRequest(message) {
        let candidate = message;
        return candidate && is.string(candidate.method) && (is.string(candidate.id) || is.number(candidate.id));
      }
      Message2.isRequest = isRequest;
      function isNotification(message) {
        let candidate = message;
        return candidate && is.string(candidate.method) && message.id === void 0;
      }
      Message2.isNotification = isNotification;
      function isResponse(message) {
        let candidate = message;
        return candidate && (candidate.result !== void 0 || !!candidate.error) && (is.string(candidate.id) || is.number(candidate.id) || candidate.id === null);
      }
      Message2.isResponse = isResponse;
    })(Message = exports.Message || (exports.Message = {}));
  }
});

// ../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/linkedMap.js
var require_linkedMap = __commonJS({
  "../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/linkedMap.js"(exports) {
    "use strict";
    init_cjs_shims();
    var _a38;
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.LRUCache = exports.LinkedMap = exports.Touch = void 0;
    var Touch;
    (function(Touch2) {
      Touch2.None = 0, Touch2.First = 1, Touch2.AsOld = Touch2.First, Touch2.Last = 2, Touch2.AsNew = Touch2.Last;
    })(Touch = exports.Touch || (exports.Touch = {}));
    var LinkedMap = class {
      constructor() {
        this[_a38] = "LinkedMap", this._map = /* @__PURE__ */ new Map(), this._head = void 0, this._tail = void 0, this._size = 0, this._state = 0;
      }
      clear() {
        this._map.clear(), this._head = void 0, this._tail = void 0, this._size = 0, this._state++;
      }
      isEmpty() {
        return !this._head && !this._tail;
      }
      get size() {
        return this._size;
      }
      get first() {
        return this._head?.value;
      }
      get last() {
        return this._tail?.value;
      }
      has(key) {
        return this._map.has(key);
      }
      get(key, touch = Touch.None) {
        let item = this._map.get(key);
        if (item)
          return touch !== Touch.None && this.touch(item, touch), item.value;
      }
      set(key, value, touch = Touch.None) {
        let item = this._map.get(key);
        if (item)
          item.value = value, touch !== Touch.None && this.touch(item, touch);
        else {
          switch (item = { key, value, next: void 0, previous: void 0 }, touch) {
            case Touch.None:
              this.addItemLast(item);
              break;
            case Touch.First:
              this.addItemFirst(item);
              break;
            case Touch.Last:
              this.addItemLast(item);
              break;
            default:
              this.addItemLast(item);
              break;
          }
          this._map.set(key, item), this._size++;
        }
        return this;
      }
      delete(key) {
        return !!this.remove(key);
      }
      remove(key) {
        let item = this._map.get(key);
        if (item)
          return this._map.delete(key), this.removeItem(item), this._size--, item.value;
      }
      shift() {
        if (!this._head && !this._tail)
          return;
        if (!this._head || !this._tail)
          throw new Error("Invalid list");
        let item = this._head;
        return this._map.delete(item.key), this.removeItem(item), this._size--, item.value;
      }
      forEach(callbackfn, thisArg) {
        let state = this._state, current = this._head;
        for (; current; ) {
          if (thisArg ? callbackfn.bind(thisArg)(current.value, current.key, this) : callbackfn(current.value, current.key, this), this._state !== state)
            throw new Error("LinkedMap got modified during iteration.");
          current = current.next;
        }
      }
      keys() {
        let state = this._state, current = this._head, iterator = {
          [Symbol.iterator]: () => iterator,
          next: () => {
            if (this._state !== state)
              throw new Error("LinkedMap got modified during iteration.");
            if (current) {
              let result = { value: current.key, done: !1 };
              return current = current.next, result;
            } else
              return { value: void 0, done: !0 };
          }
        };
        return iterator;
      }
      values() {
        let state = this._state, current = this._head, iterator = {
          [Symbol.iterator]: () => iterator,
          next: () => {
            if (this._state !== state)
              throw new Error("LinkedMap got modified during iteration.");
            if (current) {
              let result = { value: current.value, done: !1 };
              return current = current.next, result;
            } else
              return { value: void 0, done: !0 };
          }
        };
        return iterator;
      }
      entries() {
        let state = this._state, current = this._head, iterator = {
          [Symbol.iterator]: () => iterator,
          next: () => {
            if (this._state !== state)
              throw new Error("LinkedMap got modified during iteration.");
            if (current) {
              let result = { value: [current.key, current.value], done: !1 };
              return current = current.next, result;
            } else
              return { value: void 0, done: !0 };
          }
        };
        return iterator;
      }
      [(_a38 = Symbol.toStringTag, Symbol.iterator)]() {
        return this.entries();
      }
      trimOld(newSize) {
        if (newSize >= this.size)
          return;
        if (newSize === 0) {
          this.clear();
          return;
        }
        let current = this._head, currentSize = this.size;
        for (; current && currentSize > newSize; )
          this._map.delete(current.key), current = current.next, currentSize--;
        this._head = current, this._size = currentSize, current && (current.previous = void 0), this._state++;
      }
      addItemFirst(item) {
        if (!this._head && !this._tail)
          this._tail = item;
        else if (this._head)
          item.next = this._head, this._head.previous = item;
        else
          throw new Error("Invalid list");
        this._head = item, this._state++;
      }
      addItemLast(item) {
        if (!this._head && !this._tail)
          this._head = item;
        else if (this._tail)
          item.previous = this._tail, this._tail.next = item;
        else
          throw new Error("Invalid list");
        this._tail = item, this._state++;
      }
      removeItem(item) {
        if (item === this._head && item === this._tail)
          this._head = void 0, this._tail = void 0;
        else if (item === this._head) {
          if (!item.next)
            throw new Error("Invalid list");
          item.next.previous = void 0, this._head = item.next;
        } else if (item === this._tail) {
          if (!item.previous)
            throw new Error("Invalid list");
          item.previous.next = void 0, this._tail = item.previous;
        } else {
          let next = item.next, previous = item.previous;
          if (!next || !previous)
            throw new Error("Invalid list");
          next.previous = previous, previous.next = next;
        }
        item.next = void 0, item.previous = void 0, this._state++;
      }
      touch(item, touch) {
        if (!this._head || !this._tail)
          throw new Error("Invalid list");
        if (!(touch !== Touch.First && touch !== Touch.Last)) {
          if (touch === Touch.First) {
            if (item === this._head)
              return;
            let next = item.next, previous = item.previous;
            item === this._tail ? (previous.next = void 0, this._tail = previous) : (next.previous = previous, previous.next = next), item.previous = void 0, item.next = this._head, this._head.previous = item, this._head = item, this._state++;
          } else if (touch === Touch.Last) {
            if (item === this._tail)
              return;
            let next = item.next, previous = item.previous;
            item === this._head ? (next.previous = void 0, this._head = next) : (next.previous = previous, previous.next = next), item.next = void 0, item.previous = this._tail, this._tail.next = item, this._tail = item, this._state++;
          }
        }
      }
      toJSON() {
        let data = [];
        return this.forEach((value, key) => {
          data.push([key, value]);
        }), data;
      }
      fromJSON(data) {
        this.clear();
        for (let [key, value] of data)
          this.set(key, value);
      }
    };
    exports.LinkedMap = LinkedMap;
    var LRUCache = class extends LinkedMap {
      constructor(limit, ratio = 1) {
        super(), this._limit = limit, this._ratio = Math.min(Math.max(0, ratio), 1);
      }
      get limit() {
        return this._limit;
      }
      set limit(limit) {
        this._limit = limit, this.checkTrim();
      }
      get ratio() {
        return this._ratio;
      }
      set ratio(ratio) {
        this._ratio = Math.min(Math.max(0, ratio), 1), this.checkTrim();
      }
      get(key, touch = Touch.AsNew) {
        return super.get(key, touch);
      }
      peek(key) {
        return super.get(key, Touch.None);
      }
      set(key, value) {
        return super.set(key, value, Touch.Last), this.checkTrim(), this;
      }
      checkTrim() {
        this.size > this._limit && this.trimOld(Math.round(this._limit * this._ratio));
      }
    };
    exports.LRUCache = LRUCache;
  }
});

// ../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/disposable.js
var require_disposable = __commonJS({
  "../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/disposable.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.Disposable = void 0;
    var Disposable;
    (function(Disposable2) {
      function create(func) {
        return {
          dispose: func
        };
      }
      Disposable2.create = create;
    })(Disposable = exports.Disposable || (exports.Disposable = {}));
  }
});

// ../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/ral.js
var require_ral = __commonJS({
  "../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/ral.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var _ral;
    function RAL() {
      if (_ral === void 0)
        throw new Error("No runtime abstraction layer installed");
      return _ral;
    }
    (function(RAL2) {
      function install2(ral) {
        if (ral === void 0)
          throw new Error("No runtime abstraction layer provided");
        _ral = ral;
      }
      RAL2.install = install2;
    })(RAL || (RAL = {}));
    exports.default = RAL;
  }
});

// ../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/events.js
var require_events = __commonJS({
  "../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/events.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.Emitter = exports.Event = void 0;
    var ral_1 = require_ral(), Event2;
    (function(Event3) {
      let _disposable = { dispose() {
      } };
      Event3.None = function() {
        return _disposable;
      };
    })(Event2 = exports.Event || (exports.Event = {}));
    var CallbackList = class {
      add(callback, context = null, bucket) {
        this._callbacks || (this._callbacks = [], this._contexts = []), this._callbacks.push(callback), this._contexts.push(context), Array.isArray(bucket) && bucket.push({ dispose: () => this.remove(callback, context) });
      }
      remove(callback, context = null) {
        if (!this._callbacks)
          return;
        let foundCallbackWithDifferentContext = !1;
        for (let i = 0, len = this._callbacks.length; i < len; i++)
          if (this._callbacks[i] === callback)
            if (this._contexts[i] === context) {
              this._callbacks.splice(i, 1), this._contexts.splice(i, 1);
              return;
            } else
              foundCallbackWithDifferentContext = !0;
        if (foundCallbackWithDifferentContext)
          throw new Error("When adding a listener with a context, you should remove it with the same context");
      }
      invoke(...args) {
        if (!this._callbacks)
          return [];
        let ret = [], callbacks = this._callbacks.slice(0), contexts = this._contexts.slice(0);
        for (let i = 0, len = callbacks.length; i < len; i++)
          try {
            ret.push(callbacks[i].apply(contexts[i], args));
          } catch (e) {
            (0, ral_1.default)().console.error(e);
          }
        return ret;
      }
      isEmpty() {
        return !this._callbacks || this._callbacks.length === 0;
      }
      dispose() {
        this._callbacks = void 0, this._contexts = void 0;
      }
    }, Emitter = class _Emitter {
      constructor(_options) {
        this._options = _options;
      }
      /**
       * For the public to allow to subscribe
       * to events from this Emitter
       */
      get event() {
        return this._event || (this._event = (listener, thisArgs, disposables) => {
          this._callbacks || (this._callbacks = new CallbackList()), this._options && this._options.onFirstListenerAdd && this._callbacks.isEmpty() && this._options.onFirstListenerAdd(this), this._callbacks.add(listener, thisArgs);
          let result = {
            dispose: () => {
              this._callbacks && (this._callbacks.remove(listener, thisArgs), result.dispose = _Emitter._noop, this._options && this._options.onLastListenerRemove && this._callbacks.isEmpty() && this._options.onLastListenerRemove(this));
            }
          };
          return Array.isArray(disposables) && disposables.push(result), result;
        }), this._event;
      }
      /**
       * To be kept private to fire an event to
       * subscribers
       */
      fire(event) {
        this._callbacks && this._callbacks.invoke.call(this._callbacks, event);
      }
      dispose() {
        this._callbacks && (this._callbacks.dispose(), this._callbacks = void 0);
      }
    };
    exports.Emitter = Emitter;
    Emitter._noop = function() {
    };
  }
});

// ../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/cancellation.js
var require_cancellation = __commonJS({
  "../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/cancellation.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.CancellationTokenSource = exports.CancellationToken = void 0;
    var ral_1 = require_ral(), Is3 = require_is2(), events_1 = require_events(), CancellationToken;
    (function(CancellationToken2) {
      CancellationToken2.None = Object.freeze({
        isCancellationRequested: !1,
        onCancellationRequested: events_1.Event.None
      }), CancellationToken2.Cancelled = Object.freeze({
        isCancellationRequested: !0,
        onCancellationRequested: events_1.Event.None
      });
      function is(value) {
        let candidate = value;
        return candidate && (candidate === CancellationToken2.None || candidate === CancellationToken2.Cancelled || Is3.boolean(candidate.isCancellationRequested) && !!candidate.onCancellationRequested);
      }
      CancellationToken2.is = is;
    })(CancellationToken = exports.CancellationToken || (exports.CancellationToken = {}));
    var shortcutEvent = Object.freeze(function(callback, context) {
      let handle = (0, ral_1.default)().timer.setTimeout(callback.bind(context), 0);
      return { dispose() {
        handle.dispose();
      } };
    }), MutableToken = class {
      constructor() {
        this._isCancelled = !1;
      }
      cancel() {
        this._isCancelled || (this._isCancelled = !0, this._emitter && (this._emitter.fire(void 0), this.dispose()));
      }
      get isCancellationRequested() {
        return this._isCancelled;
      }
      get onCancellationRequested() {
        return this._isCancelled ? shortcutEvent : (this._emitter || (this._emitter = new events_1.Emitter()), this._emitter.event);
      }
      dispose() {
        this._emitter && (this._emitter.dispose(), this._emitter = void 0);
      }
    }, CancellationTokenSource = class {
      get token() {
        return this._token || (this._token = new MutableToken()), this._token;
      }
      cancel() {
        this._token ? this._token.cancel() : this._token = CancellationToken.Cancelled;
      }
      dispose() {
        this._token ? this._token instanceof MutableToken && this._token.dispose() : this._token = CancellationToken.None;
      }
    };
    exports.CancellationTokenSource = CancellationTokenSource;
  }
});

// ../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/sharedArrayCancellation.js
var require_sharedArrayCancellation = __commonJS({
  "../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/sharedArrayCancellation.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.SharedArrayReceiverStrategy = exports.SharedArraySenderStrategy = void 0;
    var cancellation_1 = require_cancellation(), CancellationState;
    (function(CancellationState2) {
      CancellationState2.Continue = 0, CancellationState2.Cancelled = 1;
    })(CancellationState || (CancellationState = {}));
    var SharedArraySenderStrategy = class {
      constructor() {
        this.buffers = /* @__PURE__ */ new Map();
      }
      enableCancellation(request2) {
        if (request2.id === null)
          return;
        let buffer = new SharedArrayBuffer(4), data = new Int32Array(buffer, 0, 1);
        data[0] = CancellationState.Continue, this.buffers.set(request2.id, buffer), request2.$cancellationData = buffer;
      }
      async sendCancellation(_conn, id) {
        let buffer = this.buffers.get(id);
        if (buffer === void 0)
          return;
        let data = new Int32Array(buffer, 0, 1);
        Atomics.store(data, 0, CancellationState.Cancelled);
      }
      cleanup(id) {
        this.buffers.delete(id);
      }
      dispose() {
        this.buffers.clear();
      }
    };
    exports.SharedArraySenderStrategy = SharedArraySenderStrategy;
    var SharedArrayBufferCancellationToken = class {
      constructor(buffer) {
        this.data = new Int32Array(buffer, 0, 1);
      }
      get isCancellationRequested() {
        return Atomics.load(this.data, 0) === CancellationState.Cancelled;
      }
      get onCancellationRequested() {
        throw new Error("Cancellation over SharedArrayBuffer doesn't support cancellation events");
      }
    }, SharedArrayBufferCancellationTokenSource = class {
      constructor(buffer) {
        this.token = new SharedArrayBufferCancellationToken(buffer);
      }
      cancel() {
      }
      dispose() {
      }
    }, SharedArrayReceiverStrategy = class {
      constructor() {
        this.kind = "request";
      }
      createCancellationTokenSource(request2) {
        let buffer = request2.$cancellationData;
        return buffer === void 0 ? new cancellation_1.CancellationTokenSource() : new SharedArrayBufferCancellationTokenSource(buffer);
      }
    };
    exports.SharedArrayReceiverStrategy = SharedArrayReceiverStrategy;
  }
});

// ../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/semaphore.js
var require_semaphore = __commonJS({
  "../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/semaphore.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.Semaphore = void 0;
    var ral_1 = require_ral(), Semaphore = class {
      constructor(capacity = 1) {
        if (capacity <= 0)
          throw new Error("Capacity must be greater than 0");
        this._capacity = capacity, this._active = 0, this._waiting = [];
      }
      lock(thunk) {
        return new Promise((resolve2, reject) => {
          this._waiting.push({ thunk, resolve: resolve2, reject }), this.runNext();
        });
      }
      get active() {
        return this._active;
      }
      runNext() {
        this._waiting.length === 0 || this._active === this._capacity || (0, ral_1.default)().timer.setImmediate(() => this.doRunNext());
      }
      doRunNext() {
        if (this._waiting.length === 0 || this._active === this._capacity)
          return;
        let next = this._waiting.shift();
        if (this._active++, this._active > this._capacity)
          throw new Error("To many thunks active");
        try {
          let result = next.thunk();
          result instanceof Promise ? result.then((value) => {
            this._active--, next.resolve(value), this.runNext();
          }, (err2) => {
            this._active--, next.reject(err2), this.runNext();
          }) : (this._active--, next.resolve(result), this.runNext());
        } catch (err2) {
          this._active--, next.reject(err2), this.runNext();
        }
      }
    };
    exports.Semaphore = Semaphore;
  }
});

// ../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/messageReader.js
var require_messageReader = __commonJS({
  "../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/messageReader.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ReadableStreamMessageReader = exports.AbstractMessageReader = exports.MessageReader = void 0;
    var ral_1 = require_ral(), Is3 = require_is2(), events_1 = require_events(), semaphore_1 = require_semaphore(), MessageReader;
    (function(MessageReader2) {
      function is(value) {
        let candidate = value;
        return candidate && Is3.func(candidate.listen) && Is3.func(candidate.dispose) && Is3.func(candidate.onError) && Is3.func(candidate.onClose) && Is3.func(candidate.onPartialMessage);
      }
      MessageReader2.is = is;
    })(MessageReader = exports.MessageReader || (exports.MessageReader = {}));
    var AbstractMessageReader = class {
      constructor() {
        this.errorEmitter = new events_1.Emitter(), this.closeEmitter = new events_1.Emitter(), this.partialMessageEmitter = new events_1.Emitter();
      }
      dispose() {
        this.errorEmitter.dispose(), this.closeEmitter.dispose();
      }
      get onError() {
        return this.errorEmitter.event;
      }
      fireError(error) {
        this.errorEmitter.fire(this.asError(error));
      }
      get onClose() {
        return this.closeEmitter.event;
      }
      fireClose() {
        this.closeEmitter.fire(void 0);
      }
      get onPartialMessage() {
        return this.partialMessageEmitter.event;
      }
      firePartialMessage(info2) {
        this.partialMessageEmitter.fire(info2);
      }
      asError(error) {
        return error instanceof Error ? error : new Error(`Reader received error. Reason: ${Is3.string(error.message) ? error.message : "unknown"}`);
      }
    };
    exports.AbstractMessageReader = AbstractMessageReader;
    var ResolvedMessageReaderOptions;
    (function(ResolvedMessageReaderOptions2) {
      function fromOptions(options) {
        let charset, result, contentDecoder, contentDecoders = /* @__PURE__ */ new Map(), contentTypeDecoder, contentTypeDecoders = /* @__PURE__ */ new Map();
        if (options === void 0 || typeof options == "string")
          charset = options ?? "utf-8";
        else {
          if (charset = options.charset ?? "utf-8", options.contentDecoder !== void 0 && (contentDecoder = options.contentDecoder, contentDecoders.set(contentDecoder.name, contentDecoder)), options.contentDecoders !== void 0)
            for (let decoder of options.contentDecoders)
              contentDecoders.set(decoder.name, decoder);
          if (options.contentTypeDecoder !== void 0 && (contentTypeDecoder = options.contentTypeDecoder, contentTypeDecoders.set(contentTypeDecoder.name, contentTypeDecoder)), options.contentTypeDecoders !== void 0)
            for (let decoder of options.contentTypeDecoders)
              contentTypeDecoders.set(decoder.name, decoder);
        }
        return contentTypeDecoder === void 0 && (contentTypeDecoder = (0, ral_1.default)().applicationJson.decoder, contentTypeDecoders.set(contentTypeDecoder.name, contentTypeDecoder)), { charset, contentDecoder, contentDecoders, contentTypeDecoder, contentTypeDecoders };
      }
      ResolvedMessageReaderOptions2.fromOptions = fromOptions;
    })(ResolvedMessageReaderOptions || (ResolvedMessageReaderOptions = {}));
    var ReadableStreamMessageReader = class extends AbstractMessageReader {
      constructor(readable, options) {
        super(), this.readable = readable, this.options = ResolvedMessageReaderOptions.fromOptions(options), this.buffer = (0, ral_1.default)().messageBuffer.create(this.options.charset), this._partialMessageTimeout = 1e4, this.nextMessageLength = -1, this.messageToken = 0, this.readSemaphore = new semaphore_1.Semaphore(1);
      }
      set partialMessageTimeout(timeout) {
        this._partialMessageTimeout = timeout;
      }
      get partialMessageTimeout() {
        return this._partialMessageTimeout;
      }
      listen(callback) {
        this.nextMessageLength = -1, this.messageToken = 0, this.partialMessageTimer = void 0, this.callback = callback;
        let result = this.readable.onData((data) => {
          this.onData(data);
        });
        return this.readable.onError((error) => this.fireError(error)), this.readable.onClose(() => this.fireClose()), result;
      }
      onData(data) {
        for (this.buffer.append(data); ; ) {
          if (this.nextMessageLength === -1) {
            let headers = this.buffer.tryReadHeaders(!0);
            if (!headers)
              return;
            let contentLength = headers.get("content-length");
            if (!contentLength) {
              this.fireError(new Error("Header must provide a Content-Length property."));
              return;
            }
            let length = parseInt(contentLength);
            if (isNaN(length)) {
              this.fireError(new Error("Content-Length value must be a number."));
              return;
            }
            this.nextMessageLength = length;
          }
          let body = this.buffer.tryReadBody(this.nextMessageLength);
          if (body === void 0) {
            this.setPartialMessageTimer();
            return;
          }
          this.clearPartialMessageTimer(), this.nextMessageLength = -1, this.readSemaphore.lock(async () => {
            let bytes = this.options.contentDecoder !== void 0 ? await this.options.contentDecoder.decode(body) : body, message = await this.options.contentTypeDecoder.decode(bytes, this.options);
            this.callback(message);
          }).catch((error) => {
            this.fireError(error);
          });
        }
      }
      clearPartialMessageTimer() {
        this.partialMessageTimer && (this.partialMessageTimer.dispose(), this.partialMessageTimer = void 0);
      }
      setPartialMessageTimer() {
        this.clearPartialMessageTimer(), !(this._partialMessageTimeout <= 0) && (this.partialMessageTimer = (0, ral_1.default)().timer.setTimeout((token, timeout) => {
          this.partialMessageTimer = void 0, token === this.messageToken && (this.firePartialMessage({ messageToken: token, waitingTime: timeout }), this.setPartialMessageTimer());
        }, this._partialMessageTimeout, this.messageToken, this._partialMessageTimeout));
      }
    };
    exports.ReadableStreamMessageReader = ReadableStreamMessageReader;
  }
});

// ../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/messageWriter.js
var require_messageWriter = __commonJS({
  "../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/messageWriter.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.WriteableStreamMessageWriter = exports.AbstractMessageWriter = exports.MessageWriter = void 0;
    var ral_1 = require_ral(), Is3 = require_is2(), semaphore_1 = require_semaphore(), events_1 = require_events(), ContentLength = "Content-Length: ", CRLF = `\r
`, MessageWriter;
    (function(MessageWriter2) {
      function is(value) {
        let candidate = value;
        return candidate && Is3.func(candidate.dispose) && Is3.func(candidate.onClose) && Is3.func(candidate.onError) && Is3.func(candidate.write);
      }
      MessageWriter2.is = is;
    })(MessageWriter = exports.MessageWriter || (exports.MessageWriter = {}));
    var AbstractMessageWriter = class {
      constructor() {
        this.errorEmitter = new events_1.Emitter(), this.closeEmitter = new events_1.Emitter();
      }
      dispose() {
        this.errorEmitter.dispose(), this.closeEmitter.dispose();
      }
      get onError() {
        return this.errorEmitter.event;
      }
      fireError(error, message, count) {
        this.errorEmitter.fire([this.asError(error), message, count]);
      }
      get onClose() {
        return this.closeEmitter.event;
      }
      fireClose() {
        this.closeEmitter.fire(void 0);
      }
      asError(error) {
        return error instanceof Error ? error : new Error(`Writer received error. Reason: ${Is3.string(error.message) ? error.message : "unknown"}`);
      }
    };
    exports.AbstractMessageWriter = AbstractMessageWriter;
    var ResolvedMessageWriterOptions;
    (function(ResolvedMessageWriterOptions2) {
      function fromOptions(options) {
        return options === void 0 || typeof options == "string" ? { charset: options ?? "utf-8", contentTypeEncoder: (0, ral_1.default)().applicationJson.encoder } : { charset: options.charset ?? "utf-8", contentEncoder: options.contentEncoder, contentTypeEncoder: options.contentTypeEncoder ?? (0, ral_1.default)().applicationJson.encoder };
      }
      ResolvedMessageWriterOptions2.fromOptions = fromOptions;
    })(ResolvedMessageWriterOptions || (ResolvedMessageWriterOptions = {}));
    var WriteableStreamMessageWriter = class extends AbstractMessageWriter {
      constructor(writable, options) {
        super(), this.writable = writable, this.options = ResolvedMessageWriterOptions.fromOptions(options), this.errorCount = 0, this.writeSemaphore = new semaphore_1.Semaphore(1), this.writable.onError((error) => this.fireError(error)), this.writable.onClose(() => this.fireClose());
      }
      async write(msg) {
        return this.writeSemaphore.lock(async () => this.options.contentTypeEncoder.encode(msg, this.options).then((buffer) => this.options.contentEncoder !== void 0 ? this.options.contentEncoder.encode(buffer) : buffer).then((buffer) => {
          let headers = [];
          return headers.push(ContentLength, buffer.byteLength.toString(), CRLF), headers.push(CRLF), this.doWrite(msg, headers, buffer);
        }, (error) => {
          throw this.fireError(error), error;
        }));
      }
      async doWrite(msg, headers, data) {
        try {
          return await this.writable.write(headers.join(""), "ascii"), this.writable.write(data);
        } catch (error) {
          return this.handleError(error, msg), Promise.reject(error);
        }
      }
      handleError(error, msg) {
        this.errorCount++, this.fireError(error, msg, this.errorCount);
      }
      end() {
        this.writable.end();
      }
    };
    exports.WriteableStreamMessageWriter = WriteableStreamMessageWriter;
  }
});

// ../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/messageBuffer.js
var require_messageBuffer = __commonJS({
  "../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/messageBuffer.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.AbstractMessageBuffer = void 0;
    var CR = 13, LF = 10, CRLF = `\r
`, AbstractMessageBuffer = class {
      constructor(encoding = "utf-8") {
        this._encoding = encoding, this._chunks = [], this._totalLength = 0;
      }
      get encoding() {
        return this._encoding;
      }
      append(chunk) {
        let toAppend = typeof chunk == "string" ? this.fromString(chunk, this._encoding) : chunk;
        this._chunks.push(toAppend), this._totalLength += toAppend.byteLength;
      }
      tryReadHeaders(lowerCaseKeys = !1) {
        if (this._chunks.length === 0)
          return;
        let state = 0, chunkIndex = 0, offset = 0, chunkBytesRead = 0;
        row:
          for (; chunkIndex < this._chunks.length; ) {
            let chunk = this._chunks[chunkIndex];
            for (offset = 0; offset < chunk.length; ) {
              switch (chunk[offset]) {
                case CR:
                  switch (state) {
                    case 0:
                      state = 1;
                      break;
                    case 2:
                      state = 3;
                      break;
                    default:
                      state = 0;
                  }
                  break;
                case LF:
                  switch (state) {
                    case 1:
                      state = 2;
                      break;
                    case 3:
                      state = 4, offset++;
                      break row;
                    default:
                      state = 0;
                  }
                  break;
                default:
                  state = 0;
              }
              offset++;
            }
            chunkBytesRead += chunk.byteLength, chunkIndex++;
          }
        if (state !== 4)
          return;
        let buffer = this._read(chunkBytesRead + offset), result = /* @__PURE__ */ new Map(), headers = this.toString(buffer, "ascii").split(CRLF);
        if (headers.length < 2)
          return result;
        for (let i = 0; i < headers.length - 2; i++) {
          let header2 = headers[i], index = header2.indexOf(":");
          if (index === -1)
            throw new Error("Message header must separate key and value using :");
          let key = header2.substr(0, index), value = header2.substr(index + 1).trim();
          result.set(lowerCaseKeys ? key.toLowerCase() : key, value);
        }
        return result;
      }
      tryReadBody(length) {
        if (!(this._totalLength < length))
          return this._read(length);
      }
      get numberOfBytes() {
        return this._totalLength;
      }
      _read(byteCount) {
        if (byteCount === 0)
          return this.emptyBuffer();
        if (byteCount > this._totalLength)
          throw new Error("Cannot read so many bytes!");
        if (this._chunks[0].byteLength === byteCount) {
          let chunk = this._chunks[0];
          return this._chunks.shift(), this._totalLength -= byteCount, this.asNative(chunk);
        }
        if (this._chunks[0].byteLength > byteCount) {
          let chunk = this._chunks[0], result2 = this.asNative(chunk, byteCount);
          return this._chunks[0] = chunk.slice(byteCount), this._totalLength -= byteCount, result2;
        }
        let result = this.allocNative(byteCount), resultOffset = 0, chunkIndex = 0;
        for (; byteCount > 0; ) {
          let chunk = this._chunks[chunkIndex];
          if (chunk.byteLength > byteCount) {
            let chunkPart = chunk.slice(0, byteCount);
            result.set(chunkPart, resultOffset), resultOffset += byteCount, this._chunks[chunkIndex] = chunk.slice(byteCount), this._totalLength -= byteCount, byteCount -= byteCount;
          } else
            result.set(chunk, resultOffset), resultOffset += chunk.byteLength, this._chunks.shift(), this._totalLength -= chunk.byteLength, byteCount -= chunk.byteLength;
        }
        return result;
      }
    };
    exports.AbstractMessageBuffer = AbstractMessageBuffer;
  }
});

// ../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/connection.js
var require_connection = __commonJS({
  "../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/connection.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.createMessageConnection = exports.ConnectionOptions = exports.MessageStrategy = exports.CancellationStrategy = exports.CancellationSenderStrategy = exports.CancellationReceiverStrategy = exports.RequestCancellationReceiverStrategy = exports.IdCancellationReceiverStrategy = exports.ConnectionStrategy = exports.ConnectionError = exports.ConnectionErrors = exports.LogTraceNotification = exports.SetTraceNotification = exports.TraceFormat = exports.TraceValues = exports.Trace = exports.NullLogger = exports.ProgressType = exports.ProgressToken = void 0;
    var ral_1 = require_ral(), Is3 = require_is2(), messages_1 = require_messages(), linkedMap_1 = require_linkedMap(), events_1 = require_events(), cancellation_1 = require_cancellation(), CancelNotification;
    (function(CancelNotification2) {
      CancelNotification2.type = new messages_1.NotificationType("$/cancelRequest");
    })(CancelNotification || (CancelNotification = {}));
    var ProgressToken;
    (function(ProgressToken2) {
      function is(value) {
        return typeof value == "string" || typeof value == "number";
      }
      ProgressToken2.is = is;
    })(ProgressToken = exports.ProgressToken || (exports.ProgressToken = {}));
    var ProgressNotification;
    (function(ProgressNotification2) {
      ProgressNotification2.type = new messages_1.NotificationType("$/progress");
    })(ProgressNotification || (ProgressNotification = {}));
    var ProgressType = class {
      constructor() {
      }
    };
    exports.ProgressType = ProgressType;
    var StarRequestHandler;
    (function(StarRequestHandler2) {
      function is(value) {
        return Is3.func(value);
      }
      StarRequestHandler2.is = is;
    })(StarRequestHandler || (StarRequestHandler = {}));
    exports.NullLogger = Object.freeze({
      error: () => {
      },
      warn: () => {
      },
      info: () => {
      },
      log: () => {
      }
    });
    var Trace;
    (function(Trace2) {
      Trace2[Trace2.Off = 0] = "Off", Trace2[Trace2.Messages = 1] = "Messages", Trace2[Trace2.Compact = 2] = "Compact", Trace2[Trace2.Verbose = 3] = "Verbose";
    })(Trace = exports.Trace || (exports.Trace = {}));
    var TraceValues;
    (function(TraceValues2) {
      TraceValues2.Off = "off", TraceValues2.Messages = "messages", TraceValues2.Compact = "compact", TraceValues2.Verbose = "verbose";
    })(TraceValues = exports.TraceValues || (exports.TraceValues = {}));
    (function(Trace2) {
      function fromString(value) {
        if (!Is3.string(value))
          return Trace2.Off;
        switch (value = value.toLowerCase(), value) {
          case "off":
            return Trace2.Off;
          case "messages":
            return Trace2.Messages;
          case "compact":
            return Trace2.Compact;
          case "verbose":
            return Trace2.Verbose;
          default:
            return Trace2.Off;
        }
      }
      Trace2.fromString = fromString;
      function toString2(value) {
        switch (value) {
          case Trace2.Off:
            return "off";
          case Trace2.Messages:
            return "messages";
          case Trace2.Compact:
            return "compact";
          case Trace2.Verbose:
            return "verbose";
          default:
            return "off";
        }
      }
      Trace2.toString = toString2;
    })(Trace = exports.Trace || (exports.Trace = {}));
    var TraceFormat;
    (function(TraceFormat2) {
      TraceFormat2.Text = "text", TraceFormat2.JSON = "json";
    })(TraceFormat = exports.TraceFormat || (exports.TraceFormat = {}));
    (function(TraceFormat2) {
      function fromString(value) {
        return Is3.string(value) ? (value = value.toLowerCase(), value === "json" ? TraceFormat2.JSON : TraceFormat2.Text) : TraceFormat2.Text;
      }
      TraceFormat2.fromString = fromString;
    })(TraceFormat = exports.TraceFormat || (exports.TraceFormat = {}));
    var SetTraceNotification;
    (function(SetTraceNotification2) {
      SetTraceNotification2.type = new messages_1.NotificationType("$/setTrace");
    })(SetTraceNotification = exports.SetTraceNotification || (exports.SetTraceNotification = {}));
    var LogTraceNotification;
    (function(LogTraceNotification2) {
      LogTraceNotification2.type = new messages_1.NotificationType("$/logTrace");
    })(LogTraceNotification = exports.LogTraceNotification || (exports.LogTraceNotification = {}));
    var ConnectionErrors;
    (function(ConnectionErrors2) {
      ConnectionErrors2[ConnectionErrors2.Closed = 1] = "Closed", ConnectionErrors2[ConnectionErrors2.Disposed = 2] = "Disposed", ConnectionErrors2[ConnectionErrors2.AlreadyListening = 3] = "AlreadyListening";
    })(ConnectionErrors = exports.ConnectionErrors || (exports.ConnectionErrors = {}));
    var ConnectionError = class _ConnectionError extends Error {
      constructor(code, message) {
        super(message), this.code = code, Object.setPrototypeOf(this, _ConnectionError.prototype);
      }
    };
    exports.ConnectionError = ConnectionError;
    var ConnectionStrategy;
    (function(ConnectionStrategy2) {
      function is(value) {
        let candidate = value;
        return candidate && Is3.func(candidate.cancelUndispatched);
      }
      ConnectionStrategy2.is = is;
    })(ConnectionStrategy = exports.ConnectionStrategy || (exports.ConnectionStrategy = {}));
    var IdCancellationReceiverStrategy;
    (function(IdCancellationReceiverStrategy2) {
      function is(value) {
        let candidate = value;
        return candidate && (candidate.kind === void 0 || candidate.kind === "id") && Is3.func(candidate.createCancellationTokenSource) && (candidate.dispose === void 0 || Is3.func(candidate.dispose));
      }
      IdCancellationReceiverStrategy2.is = is;
    })(IdCancellationReceiverStrategy = exports.IdCancellationReceiverStrategy || (exports.IdCancellationReceiverStrategy = {}));
    var RequestCancellationReceiverStrategy;
    (function(RequestCancellationReceiverStrategy2) {
      function is(value) {
        let candidate = value;
        return candidate && candidate.kind === "request" && Is3.func(candidate.createCancellationTokenSource) && (candidate.dispose === void 0 || Is3.func(candidate.dispose));
      }
      RequestCancellationReceiverStrategy2.is = is;
    })(RequestCancellationReceiverStrategy = exports.RequestCancellationReceiverStrategy || (exports.RequestCancellationReceiverStrategy = {}));
    var CancellationReceiverStrategy;
    (function(CancellationReceiverStrategy2) {
      CancellationReceiverStrategy2.Message = Object.freeze({
        createCancellationTokenSource(_2) {
          return new cancellation_1.CancellationTokenSource();
        }
      });
      function is(value) {
        return IdCancellationReceiverStrategy.is(value) || RequestCancellationReceiverStrategy.is(value);
      }
      CancellationReceiverStrategy2.is = is;
    })(CancellationReceiverStrategy = exports.CancellationReceiverStrategy || (exports.CancellationReceiverStrategy = {}));
    var CancellationSenderStrategy;
    (function(CancellationSenderStrategy2) {
      CancellationSenderStrategy2.Message = Object.freeze({
        sendCancellation(conn, id) {
          return conn.sendNotification(CancelNotification.type, { id });
        },
        cleanup(_2) {
        }
      });
      function is(value) {
        let candidate = value;
        return candidate && Is3.func(candidate.sendCancellation) && Is3.func(candidate.cleanup);
      }
      CancellationSenderStrategy2.is = is;
    })(CancellationSenderStrategy = exports.CancellationSenderStrategy || (exports.CancellationSenderStrategy = {}));
    var CancellationStrategy;
    (function(CancellationStrategy2) {
      CancellationStrategy2.Message = Object.freeze({
        receiver: CancellationReceiverStrategy.Message,
        sender: CancellationSenderStrategy.Message
      });
      function is(value) {
        let candidate = value;
        return candidate && CancellationReceiverStrategy.is(candidate.receiver) && CancellationSenderStrategy.is(candidate.sender);
      }
      CancellationStrategy2.is = is;
    })(CancellationStrategy = exports.CancellationStrategy || (exports.CancellationStrategy = {}));
    var MessageStrategy;
    (function(MessageStrategy2) {
      function is(value) {
        let candidate = value;
        return candidate && Is3.func(candidate.handleMessage);
      }
      MessageStrategy2.is = is;
    })(MessageStrategy = exports.MessageStrategy || (exports.MessageStrategy = {}));
    var ConnectionOptions;
    (function(ConnectionOptions2) {
      function is(value) {
        let candidate = value;
        return candidate && (CancellationStrategy.is(candidate.cancellationStrategy) || ConnectionStrategy.is(candidate.connectionStrategy) || MessageStrategy.is(candidate.messageStrategy));
      }
      ConnectionOptions2.is = is;
    })(ConnectionOptions = exports.ConnectionOptions || (exports.ConnectionOptions = {}));
    var ConnectionState;
    (function(ConnectionState2) {
      ConnectionState2[ConnectionState2.New = 1] = "New", ConnectionState2[ConnectionState2.Listening = 2] = "Listening", ConnectionState2[ConnectionState2.Closed = 3] = "Closed", ConnectionState2[ConnectionState2.Disposed = 4] = "Disposed";
    })(ConnectionState || (ConnectionState = {}));
    function createMessageConnection(messageReader, messageWriter, _logger, options) {
      let logger = _logger !== void 0 ? _logger : exports.NullLogger, sequenceNumber = 0, notificationSequenceNumber = 0, unknownResponseSequenceNumber = 0, version2 = "2.0", starRequestHandler, requestHandlers = /* @__PURE__ */ new Map(), starNotificationHandler, notificationHandlers = /* @__PURE__ */ new Map(), progressHandlers = /* @__PURE__ */ new Map(), timer, messageQueue = new linkedMap_1.LinkedMap(), responsePromises = /* @__PURE__ */ new Map(), knownCanceledRequests = /* @__PURE__ */ new Set(), requestTokens = /* @__PURE__ */ new Map(), trace = Trace.Off, traceFormat = TraceFormat.Text, tracer, state = ConnectionState.New, errorEmitter = new events_1.Emitter(), closeEmitter = new events_1.Emitter(), unhandledNotificationEmitter = new events_1.Emitter(), unhandledProgressEmitter = new events_1.Emitter(), disposeEmitter = new events_1.Emitter(), cancellationStrategy = options && options.cancellationStrategy ? options.cancellationStrategy : CancellationStrategy.Message;
      function createRequestQueueKey(id) {
        if (id === null)
          throw new Error("Can't send requests with id null since the response can't be correlated.");
        return "req-" + id.toString();
      }
      function createResponseQueueKey(id) {
        return id === null ? "res-unknown-" + (++unknownResponseSequenceNumber).toString() : "res-" + id.toString();
      }
      function createNotificationQueueKey() {
        return "not-" + (++notificationSequenceNumber).toString();
      }
      function addMessageToQueue(queue, message) {
        messages_1.Message.isRequest(message) ? queue.set(createRequestQueueKey(message.id), message) : messages_1.Message.isResponse(message) ? queue.set(createResponseQueueKey(message.id), message) : queue.set(createNotificationQueueKey(), message);
      }
      function cancelUndispatched(_message) {
      }
      function isListening() {
        return state === ConnectionState.Listening;
      }
      function isClosed() {
        return state === ConnectionState.Closed;
      }
      function isDisposed() {
        return state === ConnectionState.Disposed;
      }
      function closeHandler() {
        (state === ConnectionState.New || state === ConnectionState.Listening) && (state = ConnectionState.Closed, closeEmitter.fire(void 0));
      }
      function readErrorHandler(error) {
        errorEmitter.fire([error, void 0, void 0]);
      }
      function writeErrorHandler(data) {
        errorEmitter.fire(data);
      }
      messageReader.onClose(closeHandler), messageReader.onError(readErrorHandler), messageWriter.onClose(closeHandler), messageWriter.onError(writeErrorHandler);
      function triggerMessageQueue() {
        timer || messageQueue.size === 0 || (timer = (0, ral_1.default)().timer.setImmediate(() => {
          timer = void 0, processMessageQueue();
        }));
      }
      function handleMessage(message) {
        messages_1.Message.isRequest(message) ? handleRequest(message) : messages_1.Message.isNotification(message) ? handleNotification(message) : messages_1.Message.isResponse(message) ? handleResponse(message) : handleInvalidMessage(message);
      }
      function processMessageQueue() {
        if (messageQueue.size === 0)
          return;
        let message = messageQueue.shift();
        try {
          let messageStrategy = options?.messageStrategy;
          MessageStrategy.is(messageStrategy) ? messageStrategy.handleMessage(message, handleMessage) : handleMessage(message);
        } finally {
          triggerMessageQueue();
        }
      }
      let callback = (message) => {
        try {
          if (messages_1.Message.isNotification(message) && message.method === CancelNotification.type.method) {
            let cancelId = message.params.id, key = createRequestQueueKey(cancelId), toCancel = messageQueue.get(key);
            if (messages_1.Message.isRequest(toCancel)) {
              let strategy = options?.connectionStrategy, response = strategy && strategy.cancelUndispatched ? strategy.cancelUndispatched(toCancel, cancelUndispatched) : void 0;
              if (response && (response.error !== void 0 || response.result !== void 0)) {
                messageQueue.delete(key), requestTokens.delete(cancelId), response.id = toCancel.id, traceSendingResponse(response, message.method, Date.now()), messageWriter.write(response).catch(() => logger.error("Sending response for canceled message failed."));
                return;
              }
            }
            let cancellationToken = requestTokens.get(cancelId);
            if (cancellationToken !== void 0) {
              cancellationToken.cancel(), traceReceivedNotification(message);
              return;
            } else
              knownCanceledRequests.add(cancelId);
          }
          addMessageToQueue(messageQueue, message);
        } finally {
          triggerMessageQueue();
        }
      };
      function handleRequest(requestMessage) {
        if (isDisposed())
          return;
        function reply(resultOrError, method, startTime2) {
          let message = {
            jsonrpc: version2,
            id: requestMessage.id
          };
          resultOrError instanceof messages_1.ResponseError ? message.error = resultOrError.toJson() : message.result = resultOrError === void 0 ? null : resultOrError, traceSendingResponse(message, method, startTime2), messageWriter.write(message).catch(() => logger.error("Sending response failed."));
        }
        function replyError(error, method, startTime2) {
          let message = {
            jsonrpc: version2,
            id: requestMessage.id,
            error: error.toJson()
          };
          traceSendingResponse(message, method, startTime2), messageWriter.write(message).catch(() => logger.error("Sending response failed."));
        }
        function replySuccess(result, method, startTime2) {
          result === void 0 && (result = null);
          let message = {
            jsonrpc: version2,
            id: requestMessage.id,
            result
          };
          traceSendingResponse(message, method, startTime2), messageWriter.write(message).catch(() => logger.error("Sending response failed."));
        }
        traceReceivedRequest(requestMessage);
        let element = requestHandlers.get(requestMessage.method), type, requestHandler;
        element && (type = element.type, requestHandler = element.handler);
        let startTime = Date.now();
        if (requestHandler || starRequestHandler) {
          let tokenKey = requestMessage.id ?? String(Date.now()), cancellationSource = IdCancellationReceiverStrategy.is(cancellationStrategy.receiver) ? cancellationStrategy.receiver.createCancellationTokenSource(tokenKey) : cancellationStrategy.receiver.createCancellationTokenSource(requestMessage);
          requestMessage.id !== null && knownCanceledRequests.has(requestMessage.id) && cancellationSource.cancel(), requestMessage.id !== null && requestTokens.set(tokenKey, cancellationSource);
          try {
            let handlerResult;
            if (requestHandler)
              if (requestMessage.params === void 0) {
                if (type !== void 0 && type.numberOfParams !== 0) {
                  replyError(new messages_1.ResponseError(messages_1.ErrorCodes.InvalidParams, `Request ${requestMessage.method} defines ${type.numberOfParams} params but received none.`), requestMessage.method, startTime);
                  return;
                }
                handlerResult = requestHandler(cancellationSource.token);
              } else if (Array.isArray(requestMessage.params)) {
                if (type !== void 0 && type.parameterStructures === messages_1.ParameterStructures.byName) {
                  replyError(new messages_1.ResponseError(messages_1.ErrorCodes.InvalidParams, `Request ${requestMessage.method} defines parameters by name but received parameters by position`), requestMessage.method, startTime);
                  return;
                }
                handlerResult = requestHandler(...requestMessage.params, cancellationSource.token);
              } else {
                if (type !== void 0 && type.parameterStructures === messages_1.ParameterStructures.byPosition) {
                  replyError(new messages_1.ResponseError(messages_1.ErrorCodes.InvalidParams, `Request ${requestMessage.method} defines parameters by position but received parameters by name`), requestMessage.method, startTime);
                  return;
                }
                handlerResult = requestHandler(requestMessage.params, cancellationSource.token);
              }
            else
              starRequestHandler && (handlerResult = starRequestHandler(requestMessage.method, requestMessage.params, cancellationSource.token));
            let promise = handlerResult;
            handlerResult ? promise.then ? promise.then((resultOrError) => {
              requestTokens.delete(tokenKey), reply(resultOrError, requestMessage.method, startTime);
            }, (error) => {
              requestTokens.delete(tokenKey), error instanceof messages_1.ResponseError ? replyError(error, requestMessage.method, startTime) : error && Is3.string(error.message) ? replyError(new messages_1.ResponseError(messages_1.ErrorCodes.InternalError, `Request ${requestMessage.method} failed with message: ${error.message}`), requestMessage.method, startTime) : replyError(new messages_1.ResponseError(messages_1.ErrorCodes.InternalError, `Request ${requestMessage.method} failed unexpectedly without providing any details.`), requestMessage.method, startTime);
            }) : (requestTokens.delete(tokenKey), reply(handlerResult, requestMessage.method, startTime)) : (requestTokens.delete(tokenKey), replySuccess(handlerResult, requestMessage.method, startTime));
          } catch (error) {
            requestTokens.delete(tokenKey), error instanceof messages_1.ResponseError ? reply(error, requestMessage.method, startTime) : error && Is3.string(error.message) ? replyError(new messages_1.ResponseError(messages_1.ErrorCodes.InternalError, `Request ${requestMessage.method} failed with message: ${error.message}`), requestMessage.method, startTime) : replyError(new messages_1.ResponseError(messages_1.ErrorCodes.InternalError, `Request ${requestMessage.method} failed unexpectedly without providing any details.`), requestMessage.method, startTime);
          }
        } else
          replyError(new messages_1.ResponseError(messages_1.ErrorCodes.MethodNotFound, `Unhandled method ${requestMessage.method}`), requestMessage.method, startTime);
      }
      function handleResponse(responseMessage) {
        if (!isDisposed())
          if (responseMessage.id === null)
            responseMessage.error ? logger.error(`Received response message without id: Error is: 
${JSON.stringify(responseMessage.error, void 0, 4)}`) : logger.error("Received response message without id. No further error information provided.");
          else {
            let key = responseMessage.id, responsePromise = responsePromises.get(key);
            if (traceReceivedResponse(responseMessage, responsePromise), responsePromise !== void 0) {
              responsePromises.delete(key);
              try {
                if (responseMessage.error) {
                  let error = responseMessage.error;
                  responsePromise.reject(new messages_1.ResponseError(error.code, error.message, error.data));
                } else if (responseMessage.result !== void 0)
                  responsePromise.resolve(responseMessage.result);
                else
                  throw new Error("Should never happen.");
              } catch (error) {
                error.message ? logger.error(`Response handler '${responsePromise.method}' failed with message: ${error.message}`) : logger.error(`Response handler '${responsePromise.method}' failed unexpectedly.`);
              }
            }
          }
      }
      function handleNotification(message) {
        if (isDisposed())
          return;
        let type, notificationHandler;
        if (message.method === CancelNotification.type.method) {
          let cancelId = message.params.id;
          knownCanceledRequests.delete(cancelId), traceReceivedNotification(message);
          return;
        } else {
          let element = notificationHandlers.get(message.method);
          element && (notificationHandler = element.handler, type = element.type);
        }
        if (notificationHandler || starNotificationHandler)
          try {
            if (traceReceivedNotification(message), notificationHandler)
              if (message.params === void 0)
                type !== void 0 && type.numberOfParams !== 0 && type.parameterStructures !== messages_1.ParameterStructures.byName && logger.error(`Notification ${message.method} defines ${type.numberOfParams} params but received none.`), notificationHandler();
              else if (Array.isArray(message.params)) {
                let params = message.params;
                message.method === ProgressNotification.type.method && params.length === 2 && ProgressToken.is(params[0]) ? notificationHandler({ token: params[0], value: params[1] }) : (type !== void 0 && (type.parameterStructures === messages_1.ParameterStructures.byName && logger.error(`Notification ${message.method} defines parameters by name but received parameters by position`), type.numberOfParams !== message.params.length && logger.error(`Notification ${message.method} defines ${type.numberOfParams} params but received ${params.length} arguments`)), notificationHandler(...params));
              } else
                type !== void 0 && type.parameterStructures === messages_1.ParameterStructures.byPosition && logger.error(`Notification ${message.method} defines parameters by position but received parameters by name`), notificationHandler(message.params);
            else
              starNotificationHandler && starNotificationHandler(message.method, message.params);
          } catch (error) {
            error.message ? logger.error(`Notification handler '${message.method}' failed with message: ${error.message}`) : logger.error(`Notification handler '${message.method}' failed unexpectedly.`);
          }
        else
          unhandledNotificationEmitter.fire(message);
      }
      function handleInvalidMessage(message) {
        if (!message) {
          logger.error("Received empty message.");
          return;
        }
        logger.error(`Received message which is neither a response nor a notification message:
${JSON.stringify(message, null, 4)}`);
        let responseMessage = message;
        if (Is3.string(responseMessage.id) || Is3.number(responseMessage.id)) {
          let key = responseMessage.id, responseHandler = responsePromises.get(key);
          responseHandler && responseHandler.reject(new Error("The received response has neither a result nor an error property."));
        }
      }
      function stringifyTrace(params) {
        if (params != null)
          switch (trace) {
            case Trace.Verbose:
              return JSON.stringify(params, null, 4);
            case Trace.Compact:
              return JSON.stringify(params);
            default:
              return;
          }
      }
      function traceSendingRequest(message) {
        if (!(trace === Trace.Off || !tracer))
          if (traceFormat === TraceFormat.Text) {
            let data;
            (trace === Trace.Verbose || trace === Trace.Compact) && message.params && (data = `Params: ${stringifyTrace(message.params)}

`), tracer.log(`Sending request '${message.method} - (${message.id})'.`, data);
          } else
            logLSPMessage("send-request", message);
      }
      function traceSendingNotification(message) {
        if (!(trace === Trace.Off || !tracer))
          if (traceFormat === TraceFormat.Text) {
            let data;
            (trace === Trace.Verbose || trace === Trace.Compact) && (message.params ? data = `Params: ${stringifyTrace(message.params)}

` : data = `No parameters provided.

`), tracer.log(`Sending notification '${message.method}'.`, data);
          } else
            logLSPMessage("send-notification", message);
      }
      function traceSendingResponse(message, method, startTime) {
        if (!(trace === Trace.Off || !tracer))
          if (traceFormat === TraceFormat.Text) {
            let data;
            (trace === Trace.Verbose || trace === Trace.Compact) && (message.error && message.error.data ? data = `Error data: ${stringifyTrace(message.error.data)}

` : message.result ? data = `Result: ${stringifyTrace(message.result)}

` : message.error === void 0 && (data = `No result returned.

`)), tracer.log(`Sending response '${method} - (${message.id})'. Processing request took ${Date.now() - startTime}ms`, data);
          } else
            logLSPMessage("send-response", message);
      }
      function traceReceivedRequest(message) {
        if (!(trace === Trace.Off || !tracer))
          if (traceFormat === TraceFormat.Text) {
            let data;
            (trace === Trace.Verbose || trace === Trace.Compact) && message.params && (data = `Params: ${stringifyTrace(message.params)}

`), tracer.log(`Received request '${message.method} - (${message.id})'.`, data);
          } else
            logLSPMessage("receive-request", message);
      }
      function traceReceivedNotification(message) {
        if (!(trace === Trace.Off || !tracer || message.method === LogTraceNotification.type.method))
          if (traceFormat === TraceFormat.Text) {
            let data;
            (trace === Trace.Verbose || trace === Trace.Compact) && (message.params ? data = `Params: ${stringifyTrace(message.params)}

` : data = `No parameters provided.

`), tracer.log(`Received notification '${message.method}'.`, data);
          } else
            logLSPMessage("receive-notification", message);
      }
      function traceReceivedResponse(message, responsePromise) {
        if (!(trace === Trace.Off || !tracer))
          if (traceFormat === TraceFormat.Text) {
            let data;
            if ((trace === Trace.Verbose || trace === Trace.Compact) && (message.error && message.error.data ? data = `Error data: ${stringifyTrace(message.error.data)}

` : message.result ? data = `Result: ${stringifyTrace(message.result)}

` : message.error === void 0 && (data = `No result returned.

`)), responsePromise) {
              let error = message.error ? ` Request failed: ${message.error.message} (${message.error.code}).` : "";
              tracer.log(`Received response '${responsePromise.method} - (${message.id})' in ${Date.now() - responsePromise.timerStart}ms.${error}`, data);
            } else
              tracer.log(`Received response ${message.id} without active response promise.`, data);
          } else
            logLSPMessage("receive-response", message);
      }
      function logLSPMessage(type, message) {
        if (!tracer || trace === Trace.Off)
          return;
        let lspMessage = {
          isLSPMessage: !0,
          type,
          message,
          timestamp: Date.now()
        };
        tracer.log(lspMessage);
      }
      function throwIfClosedOrDisposed() {
        if (isClosed())
          throw new ConnectionError(ConnectionErrors.Closed, "Connection is closed.");
        if (isDisposed())
          throw new ConnectionError(ConnectionErrors.Disposed, "Connection is disposed.");
      }
      function throwIfListening() {
        if (isListening())
          throw new ConnectionError(ConnectionErrors.AlreadyListening, "Connection is already listening");
      }
      function throwIfNotListening() {
        if (!isListening())
          throw new Error("Call listen() first.");
      }
      function undefinedToNull(param) {
        return param === void 0 ? null : param;
      }
      function nullToUndefined(param) {
        if (param !== null)
          return param;
      }
      function isNamedParam(param) {
        return param != null && !Array.isArray(param) && typeof param == "object";
      }
      function computeSingleParam(parameterStructures, param) {
        switch (parameterStructures) {
          case messages_1.ParameterStructures.auto:
            return isNamedParam(param) ? nullToUndefined(param) : [undefinedToNull(param)];
          case messages_1.ParameterStructures.byName:
            if (!isNamedParam(param))
              throw new Error("Received parameters by name but param is not an object literal.");
            return nullToUndefined(param);
          case messages_1.ParameterStructures.byPosition:
            return [undefinedToNull(param)];
          default:
            throw new Error(`Unknown parameter structure ${parameterStructures.toString()}`);
        }
      }
      function computeMessageParams(type, params) {
        let result, numberOfParams = type.numberOfParams;
        switch (numberOfParams) {
          case 0:
            result = void 0;
            break;
          case 1:
            result = computeSingleParam(type.parameterStructures, params[0]);
            break;
          default:
            result = [];
            for (let i = 0; i < params.length && i < numberOfParams; i++)
              result.push(undefinedToNull(params[i]));
            if (params.length < numberOfParams)
              for (let i = params.length; i < numberOfParams; i++)
                result.push(null);
            break;
        }
        return result;
      }
      let connection = {
        sendNotification: (type, ...args) => {
          throwIfClosedOrDisposed();
          let method, messageParams;
          if (Is3.string(type)) {
            method = type;
            let first = args[0], paramStart = 0, parameterStructures = messages_1.ParameterStructures.auto;
            messages_1.ParameterStructures.is(first) && (paramStart = 1, parameterStructures = first);
            let paramEnd = args.length, numberOfParams = paramEnd - paramStart;
            switch (numberOfParams) {
              case 0:
                messageParams = void 0;
                break;
              case 1:
                messageParams = computeSingleParam(parameterStructures, args[paramStart]);
                break;
              default:
                if (parameterStructures === messages_1.ParameterStructures.byName)
                  throw new Error(`Received ${numberOfParams} parameters for 'by Name' notification parameter structure.`);
                messageParams = args.slice(paramStart, paramEnd).map((value) => undefinedToNull(value));
                break;
            }
          } else {
            let params = args;
            method = type.method, messageParams = computeMessageParams(type, params);
          }
          let notificationMessage = {
            jsonrpc: version2,
            method,
            params: messageParams
          };
          return traceSendingNotification(notificationMessage), messageWriter.write(notificationMessage).catch((error) => {
            throw logger.error("Sending notification failed."), error;
          });
        },
        onNotification: (type, handler) => {
          throwIfClosedOrDisposed();
          let method;
          return Is3.func(type) ? starNotificationHandler = type : handler && (Is3.string(type) ? (method = type, notificationHandlers.set(type, { type: void 0, handler })) : (method = type.method, notificationHandlers.set(type.method, { type, handler }))), {
            dispose: () => {
              method !== void 0 ? notificationHandlers.delete(method) : starNotificationHandler = void 0;
            }
          };
        },
        onProgress: (_type, token, handler) => {
          if (progressHandlers.has(token))
            throw new Error(`Progress handler for token ${token} already registered`);
          return progressHandlers.set(token, handler), {
            dispose: () => {
              progressHandlers.delete(token);
            }
          };
        },
        sendProgress: (_type, token, value) => connection.sendNotification(ProgressNotification.type, { token, value }),
        onUnhandledProgress: unhandledProgressEmitter.event,
        sendRequest: (type, ...args) => {
          throwIfClosedOrDisposed(), throwIfNotListening();
          let method, messageParams, token;
          if (Is3.string(type)) {
            method = type;
            let first = args[0], last = args[args.length - 1], paramStart = 0, parameterStructures = messages_1.ParameterStructures.auto;
            messages_1.ParameterStructures.is(first) && (paramStart = 1, parameterStructures = first);
            let paramEnd = args.length;
            cancellation_1.CancellationToken.is(last) && (paramEnd = paramEnd - 1, token = last);
            let numberOfParams = paramEnd - paramStart;
            switch (numberOfParams) {
              case 0:
                messageParams = void 0;
                break;
              case 1:
                messageParams = computeSingleParam(parameterStructures, args[paramStart]);
                break;
              default:
                if (parameterStructures === messages_1.ParameterStructures.byName)
                  throw new Error(`Received ${numberOfParams} parameters for 'by Name' request parameter structure.`);
                messageParams = args.slice(paramStart, paramEnd).map((value) => undefinedToNull(value));
                break;
            }
          } else {
            let params = args;
            method = type.method, messageParams = computeMessageParams(type, params);
            let numberOfParams = type.numberOfParams;
            token = cancellation_1.CancellationToken.is(params[numberOfParams]) ? params[numberOfParams] : void 0;
          }
          let id = sequenceNumber++, disposable;
          token && (disposable = token.onCancellationRequested(() => {
            let p = cancellationStrategy.sender.sendCancellation(connection, id);
            return p === void 0 ? (logger.log(`Received no promise from cancellation strategy when cancelling id ${id}`), Promise.resolve()) : p.catch(() => {
              logger.log(`Sending cancellation messages for id ${id} failed`);
            });
          }));
          let requestMessage = {
            jsonrpc: version2,
            id,
            method,
            params: messageParams
          };
          return traceSendingRequest(requestMessage), typeof cancellationStrategy.sender.enableCancellation == "function" && cancellationStrategy.sender.enableCancellation(requestMessage), new Promise(async (resolve2, reject) => {
            let resolveWithCleanup = (r2) => {
              resolve2(r2), cancellationStrategy.sender.cleanup(id), disposable?.dispose();
            }, rejectWithCleanup = (r2) => {
              reject(r2), cancellationStrategy.sender.cleanup(id), disposable?.dispose();
            }, responsePromise = { method, timerStart: Date.now(), resolve: resolveWithCleanup, reject: rejectWithCleanup };
            try {
              await messageWriter.write(requestMessage), responsePromises.set(id, responsePromise);
            } catch (error) {
              throw logger.error("Sending request failed."), responsePromise.reject(new messages_1.ResponseError(messages_1.ErrorCodes.MessageWriteError, error.message ? error.message : "Unknown reason")), error;
            }
          });
        },
        onRequest: (type, handler) => {
          throwIfClosedOrDisposed();
          let method = null;
          return StarRequestHandler.is(type) ? (method = void 0, starRequestHandler = type) : Is3.string(type) ? (method = null, handler !== void 0 && (method = type, requestHandlers.set(type, { handler, type: void 0 }))) : handler !== void 0 && (method = type.method, requestHandlers.set(type.method, { type, handler })), {
            dispose: () => {
              method !== null && (method !== void 0 ? requestHandlers.delete(method) : starRequestHandler = void 0);
            }
          };
        },
        hasPendingResponse: () => responsePromises.size > 0,
        trace: async (_value, _tracer, sendNotificationOrTraceOptions) => {
          let _sendNotification = !1, _traceFormat = TraceFormat.Text;
          sendNotificationOrTraceOptions !== void 0 && (Is3.boolean(sendNotificationOrTraceOptions) ? _sendNotification = sendNotificationOrTraceOptions : (_sendNotification = sendNotificationOrTraceOptions.sendNotification || !1, _traceFormat = sendNotificationOrTraceOptions.traceFormat || TraceFormat.Text)), trace = _value, traceFormat = _traceFormat, trace === Trace.Off ? tracer = void 0 : tracer = _tracer, _sendNotification && !isClosed() && !isDisposed() && await connection.sendNotification(SetTraceNotification.type, { value: Trace.toString(_value) });
        },
        onError: errorEmitter.event,
        onClose: closeEmitter.event,
        onUnhandledNotification: unhandledNotificationEmitter.event,
        onDispose: disposeEmitter.event,
        end: () => {
          messageWriter.end();
        },
        dispose: () => {
          if (isDisposed())
            return;
          state = ConnectionState.Disposed, disposeEmitter.fire(void 0);
          let error = new messages_1.ResponseError(messages_1.ErrorCodes.PendingResponseRejected, "Pending response rejected since connection got disposed");
          for (let promise of responsePromises.values())
            promise.reject(error);
          responsePromises = /* @__PURE__ */ new Map(), requestTokens = /* @__PURE__ */ new Map(), knownCanceledRequests = /* @__PURE__ */ new Set(), messageQueue = new linkedMap_1.LinkedMap(), Is3.func(messageWriter.dispose) && messageWriter.dispose(), Is3.func(messageReader.dispose) && messageReader.dispose();
        },
        listen: () => {
          throwIfClosedOrDisposed(), throwIfListening(), state = ConnectionState.Listening, messageReader.listen(callback);
        },
        inspect: () => {
          (0, ral_1.default)().console.log("inspect");
        }
      };
      return connection.onNotification(LogTraceNotification.type, (params) => {
        if (trace === Trace.Off || !tracer)
          return;
        let verbose = trace === Trace.Verbose || trace === Trace.Compact;
        tracer.log(params.message, verbose ? params.verbose : void 0);
      }), connection.onNotification(ProgressNotification.type, (params) => {
        let handler = progressHandlers.get(params.token);
        handler ? handler(params.value) : unhandledProgressEmitter.fire(params);
      }), connection;
    }
    exports.createMessageConnection = createMessageConnection;
  }
});

// ../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/api.js
var require_api = __commonJS({
  "../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/common/api.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ProgressType = exports.ProgressToken = exports.createMessageConnection = exports.NullLogger = exports.ConnectionOptions = exports.ConnectionStrategy = exports.AbstractMessageBuffer = exports.WriteableStreamMessageWriter = exports.AbstractMessageWriter = exports.MessageWriter = exports.ReadableStreamMessageReader = exports.AbstractMessageReader = exports.MessageReader = exports.SharedArrayReceiverStrategy = exports.SharedArraySenderStrategy = exports.CancellationToken = exports.CancellationTokenSource = exports.Emitter = exports.Event = exports.Disposable = exports.LRUCache = exports.Touch = exports.LinkedMap = exports.ParameterStructures = exports.NotificationType9 = exports.NotificationType8 = exports.NotificationType7 = exports.NotificationType6 = exports.NotificationType5 = exports.NotificationType4 = exports.NotificationType3 = exports.NotificationType2 = exports.NotificationType1 = exports.NotificationType0 = exports.NotificationType = exports.ErrorCodes = exports.ResponseError = exports.RequestType9 = exports.RequestType8 = exports.RequestType7 = exports.RequestType6 = exports.RequestType5 = exports.RequestType4 = exports.RequestType3 = exports.RequestType2 = exports.RequestType1 = exports.RequestType0 = exports.RequestType = exports.Message = exports.RAL = void 0;
    exports.MessageStrategy = exports.CancellationStrategy = exports.CancellationSenderStrategy = exports.CancellationReceiverStrategy = exports.ConnectionError = exports.ConnectionErrors = exports.LogTraceNotification = exports.SetTraceNotification = exports.TraceFormat = exports.TraceValues = exports.Trace = void 0;
    var messages_1 = require_messages();
    Object.defineProperty(exports, "Message", { enumerable: !0, get: function() {
      return messages_1.Message;
    } });
    Object.defineProperty(exports, "RequestType", { enumerable: !0, get: function() {
      return messages_1.RequestType;
    } });
    Object.defineProperty(exports, "RequestType0", { enumerable: !0, get: function() {
      return messages_1.RequestType0;
    } });
    Object.defineProperty(exports, "RequestType1", { enumerable: !0, get: function() {
      return messages_1.RequestType1;
    } });
    Object.defineProperty(exports, "RequestType2", { enumerable: !0, get: function() {
      return messages_1.RequestType2;
    } });
    Object.defineProperty(exports, "RequestType3", { enumerable: !0, get: function() {
      return messages_1.RequestType3;
    } });
    Object.defineProperty(exports, "RequestType4", { enumerable: !0, get: function() {
      return messages_1.RequestType4;
    } });
    Object.defineProperty(exports, "RequestType5", { enumerable: !0, get: function() {
      return messages_1.RequestType5;
    } });
    Object.defineProperty(exports, "RequestType6", { enumerable: !0, get: function() {
      return messages_1.RequestType6;
    } });
    Object.defineProperty(exports, "RequestType7", { enumerable: !0, get: function() {
      return messages_1.RequestType7;
    } });
    Object.defineProperty(exports, "RequestType8", { enumerable: !0, get: function() {
      return messages_1.RequestType8;
    } });
    Object.defineProperty(exports, "RequestType9", { enumerable: !0, get: function() {
      return messages_1.RequestType9;
    } });
    Object.defineProperty(exports, "ResponseError", { enumerable: !0, get: function() {
      return messages_1.ResponseError;
    } });
    Object.defineProperty(exports, "ErrorCodes", { enumerable: !0, get: function() {
      return messages_1.ErrorCodes;
    } });
    Object.defineProperty(exports, "NotificationType", { enumerable: !0, get: function() {
      return messages_1.NotificationType;
    } });
    Object.defineProperty(exports, "NotificationType0", { enumerable: !0, get: function() {
      return messages_1.NotificationType0;
    } });
    Object.defineProperty(exports, "NotificationType1", { enumerable: !0, get: function() {
      return messages_1.NotificationType1;
    } });
    Object.defineProperty(exports, "NotificationType2", { enumerable: !0, get: function() {
      return messages_1.NotificationType2;
    } });
    Object.defineProperty(exports, "NotificationType3", { enumerable: !0, get: function() {
      return messages_1.NotificationType3;
    } });
    Object.defineProperty(exports, "NotificationType4", { enumerable: !0, get: function() {
      return messages_1.NotificationType4;
    } });
    Object.defineProperty(exports, "NotificationType5", { enumerable: !0, get: function() {
      return messages_1.NotificationType5;
    } });
    Object.defineProperty(exports, "NotificationType6", { enumerable: !0, get: function() {
      return messages_1.NotificationType6;
    } });
    Object.defineProperty(exports, "NotificationType7", { enumerable: !0, get: function() {
      return messages_1.NotificationType7;
    } });
    Object.defineProperty(exports, "NotificationType8", { enumerable: !0, get: function() {
      return messages_1.NotificationType8;
    } });
    Object.defineProperty(exports, "NotificationType9", { enumerable: !0, get: function() {
      return messages_1.NotificationType9;
    } });
    Object.defineProperty(exports, "ParameterStructures", { enumerable: !0, get: function() {
      return messages_1.ParameterStructures;
    } });
    var linkedMap_1 = require_linkedMap();
    Object.defineProperty(exports, "LinkedMap", { enumerable: !0, get: function() {
      return linkedMap_1.LinkedMap;
    } });
    Object.defineProperty(exports, "LRUCache", { enumerable: !0, get: function() {
      return linkedMap_1.LRUCache;
    } });
    Object.defineProperty(exports, "Touch", { enumerable: !0, get: function() {
      return linkedMap_1.Touch;
    } });
    var disposable_1 = require_disposable();
    Object.defineProperty(exports, "Disposable", { enumerable: !0, get: function() {
      return disposable_1.Disposable;
    } });
    var events_1 = require_events();
    Object.defineProperty(exports, "Event", { enumerable: !0, get: function() {
      return events_1.Event;
    } });
    Object.defineProperty(exports, "Emitter", { enumerable: !0, get: function() {
      return events_1.Emitter;
    } });
    var cancellation_1 = require_cancellation();
    Object.defineProperty(exports, "CancellationTokenSource", { enumerable: !0, get: function() {
      return cancellation_1.CancellationTokenSource;
    } });
    Object.defineProperty(exports, "CancellationToken", { enumerable: !0, get: function() {
      return cancellation_1.CancellationToken;
    } });
    var sharedArrayCancellation_1 = require_sharedArrayCancellation();
    Object.defineProperty(exports, "SharedArraySenderStrategy", { enumerable: !0, get: function() {
      return sharedArrayCancellation_1.SharedArraySenderStrategy;
    } });
    Object.defineProperty(exports, "SharedArrayReceiverStrategy", { enumerable: !0, get: function() {
      return sharedArrayCancellation_1.SharedArrayReceiverStrategy;
    } });
    var messageReader_1 = require_messageReader();
    Object.defineProperty(exports, "MessageReader", { enumerable: !0, get: function() {
      return messageReader_1.MessageReader;
    } });
    Object.defineProperty(exports, "AbstractMessageReader", { enumerable: !0, get: function() {
      return messageReader_1.AbstractMessageReader;
    } });
    Object.defineProperty(exports, "ReadableStreamMessageReader", { enumerable: !0, get: function() {
      return messageReader_1.ReadableStreamMessageReader;
    } });
    var messageWriter_1 = require_messageWriter();
    Object.defineProperty(exports, "MessageWriter", { enumerable: !0, get: function() {
      return messageWriter_1.MessageWriter;
    } });
    Object.defineProperty(exports, "AbstractMessageWriter", { enumerable: !0, get: function() {
      return messageWriter_1.AbstractMessageWriter;
    } });
    Object.defineProperty(exports, "WriteableStreamMessageWriter", { enumerable: !0, get: function() {
      return messageWriter_1.WriteableStreamMessageWriter;
    } });
    var messageBuffer_1 = require_messageBuffer();
    Object.defineProperty(exports, "AbstractMessageBuffer", { enumerable: !0, get: function() {
      return messageBuffer_1.AbstractMessageBuffer;
    } });
    var connection_1 = require_connection();
    Object.defineProperty(exports, "ConnectionStrategy", { enumerable: !0, get: function() {
      return connection_1.ConnectionStrategy;
    } });
    Object.defineProperty(exports, "ConnectionOptions", { enumerable: !0, get: function() {
      return connection_1.ConnectionOptions;
    } });
    Object.defineProperty(exports, "NullLogger", { enumerable: !0, get: function() {
      return connection_1.NullLogger;
    } });
    Object.defineProperty(exports, "createMessageConnection", { enumerable: !0, get: function() {
      return connection_1.createMessageConnection;
    } });
    Object.defineProperty(exports, "ProgressToken", { enumerable: !0, get: function() {
      return connection_1.ProgressToken;
    } });
    Object.defineProperty(exports, "ProgressType", { enumerable: !0, get: function() {
      return connection_1.ProgressType;
    } });
    Object.defineProperty(exports, "Trace", { enumerable: !0, get: function() {
      return connection_1.Trace;
    } });
    Object.defineProperty(exports, "TraceValues", { enumerable: !0, get: function() {
      return connection_1.TraceValues;
    } });
    Object.defineProperty(exports, "TraceFormat", { enumerable: !0, get: function() {
      return connection_1.TraceFormat;
    } });
    Object.defineProperty(exports, "SetTraceNotification", { enumerable: !0, get: function() {
      return connection_1.SetTraceNotification;
    } });
    Object.defineProperty(exports, "LogTraceNotification", { enumerable: !0, get: function() {
      return connection_1.LogTraceNotification;
    } });
    Object.defineProperty(exports, "ConnectionErrors", { enumerable: !0, get: function() {
      return connection_1.ConnectionErrors;
    } });
    Object.defineProperty(exports, "ConnectionError", { enumerable: !0, get: function() {
      return connection_1.ConnectionError;
    } });
    Object.defineProperty(exports, "CancellationReceiverStrategy", { enumerable: !0, get: function() {
      return connection_1.CancellationReceiverStrategy;
    } });
    Object.defineProperty(exports, "CancellationSenderStrategy", { enumerable: !0, get: function() {
      return connection_1.CancellationSenderStrategy;
    } });
    Object.defineProperty(exports, "CancellationStrategy", { enumerable: !0, get: function() {
      return connection_1.CancellationStrategy;
    } });
    Object.defineProperty(exports, "MessageStrategy", { enumerable: !0, get: function() {
      return connection_1.MessageStrategy;
    } });
    var ral_1 = require_ral();
    exports.RAL = ral_1.default;
  }
});

// ../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/node/ril.js
var require_ril = __commonJS({
  "../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/node/ril.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var util_1 = __require("util"), api_1 = require_api(), MessageBuffer = class _MessageBuffer extends api_1.AbstractMessageBuffer {
      constructor(encoding = "utf-8") {
        super(encoding);
      }
      emptyBuffer() {
        return _MessageBuffer.emptyBuffer;
      }
      fromString(value, encoding) {
        return Buffer.from(value, encoding);
      }
      toString(value, encoding) {
        return value instanceof Buffer ? value.toString(encoding) : new util_1.TextDecoder(encoding).decode(value);
      }
      asNative(buffer, length) {
        return length === void 0 ? buffer instanceof Buffer ? buffer : Buffer.from(buffer) : buffer instanceof Buffer ? buffer.slice(0, length) : Buffer.from(buffer, 0, length);
      }
      allocNative(length) {
        return Buffer.allocUnsafe(length);
      }
    };
    MessageBuffer.emptyBuffer = Buffer.allocUnsafe(0);
    var ReadableStreamWrapper = class {
      constructor(stream2) {
        this.stream = stream2;
      }
      onClose(listener) {
        return this.stream.on("close", listener), api_1.Disposable.create(() => this.stream.off("close", listener));
      }
      onError(listener) {
        return this.stream.on("error", listener), api_1.Disposable.create(() => this.stream.off("error", listener));
      }
      onEnd(listener) {
        return this.stream.on("end", listener), api_1.Disposable.create(() => this.stream.off("end", listener));
      }
      onData(listener) {
        return this.stream.on("data", listener), api_1.Disposable.create(() => this.stream.off("data", listener));
      }
    }, WritableStreamWrapper = class {
      constructor(stream2) {
        this.stream = stream2;
      }
      onClose(listener) {
        return this.stream.on("close", listener), api_1.Disposable.create(() => this.stream.off("close", listener));
      }
      onError(listener) {
        return this.stream.on("error", listener), api_1.Disposable.create(() => this.stream.off("error", listener));
      }
      onEnd(listener) {
        return this.stream.on("end", listener), api_1.Disposable.create(() => this.stream.off("end", listener));
      }
      write(data, encoding) {
        return new Promise((resolve2, reject) => {
          let callback = (error) => {
            error == null ? resolve2() : reject(error);
          };
          typeof data == "string" ? this.stream.write(data, encoding, callback) : this.stream.write(data, callback);
        });
      }
      end() {
        this.stream.end();
      }
    }, _ril = Object.freeze({
      messageBuffer: Object.freeze({
        create: (encoding) => new MessageBuffer(encoding)
      }),
      applicationJson: Object.freeze({
        encoder: Object.freeze({
          name: "application/json",
          encode: (msg, options) => {
            try {
              return Promise.resolve(Buffer.from(JSON.stringify(msg, void 0, 0), options.charset));
            } catch (err2) {
              return Promise.reject(err2);
            }
          }
        }),
        decoder: Object.freeze({
          name: "application/json",
          decode: (buffer, options) => {
            try {
              return buffer instanceof Buffer ? Promise.resolve(JSON.parse(buffer.toString(options.charset))) : Promise.resolve(JSON.parse(new util_1.TextDecoder(options.charset).decode(buffer)));
            } catch (err2) {
              return Promise.reject(err2);
            }
          }
        })
      }),
      stream: Object.freeze({
        asReadableStream: (stream2) => new ReadableStreamWrapper(stream2),
        asWritableStream: (stream2) => new WritableStreamWrapper(stream2)
      }),
      console,
      timer: Object.freeze({
        setTimeout(callback, ms, ...args) {
          let handle = setTimeout(callback, ms, ...args);
          return { dispose: () => clearTimeout(handle) };
        },
        setImmediate(callback, ...args) {
          let handle = setImmediate(callback, ...args);
          return { dispose: () => clearImmediate(handle) };
        },
        setInterval(callback, ms, ...args) {
          let handle = setInterval(callback, ms, ...args);
          return { dispose: () => clearInterval(handle) };
        }
      })
    });
    function RIL() {
      return _ril;
    }
    (function(RIL2) {
      function install2() {
        api_1.RAL.install(_ril);
      }
      RIL2.install = install2;
    })(RIL || (RIL = {}));
    exports.default = RIL;
  }
});

// ../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/node/main.js
var require_main3 = __commonJS({
  "../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/lib/node/main.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p) && __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.createMessageConnection = exports.createServerSocketTransport = exports.createClientSocketTransport = exports.createServerPipeTransport = exports.createClientPipeTransport = exports.generateRandomPipeName = exports.StreamMessageWriter = exports.StreamMessageReader = exports.SocketMessageWriter = exports.SocketMessageReader = exports.PortMessageWriter = exports.PortMessageReader = exports.IPCMessageWriter = exports.IPCMessageReader = void 0;
    var ril_1 = require_ril();
    ril_1.default.install();
    var path3 = __require("path"), os = __require("os"), crypto_1 = __require("crypto"), net_1 = __require("net"), api_1 = require_api();
    __exportStar(require_api(), exports);
    var IPCMessageReader = class extends api_1.AbstractMessageReader {
      constructor(process2) {
        super(), this.process = process2;
        let eventEmitter = this.process;
        eventEmitter.on("error", (error) => this.fireError(error)), eventEmitter.on("close", () => this.fireClose());
      }
      listen(callback) {
        return this.process.on("message", callback), api_1.Disposable.create(() => this.process.off("message", callback));
      }
    };
    exports.IPCMessageReader = IPCMessageReader;
    var IPCMessageWriter = class extends api_1.AbstractMessageWriter {
      constructor(process2) {
        super(), this.process = process2, this.errorCount = 0;
        let eventEmitter = this.process;
        eventEmitter.on("error", (error) => this.fireError(error)), eventEmitter.on("close", () => this.fireClose);
      }
      write(msg) {
        try {
          return typeof this.process.send == "function" && this.process.send(msg, void 0, void 0, (error) => {
            error ? (this.errorCount++, this.handleError(error, msg)) : this.errorCount = 0;
          }), Promise.resolve();
        } catch (error) {
          return this.handleError(error, msg), Promise.reject(error);
        }
      }
      handleError(error, msg) {
        this.errorCount++, this.fireError(error, msg, this.errorCount);
      }
      end() {
      }
    };
    exports.IPCMessageWriter = IPCMessageWriter;
    var PortMessageReader = class extends api_1.AbstractMessageReader {
      constructor(port) {
        super(), this.onData = new api_1.Emitter(), port.on("close", () => this.fireClose), port.on("error", (error) => this.fireError(error)), port.on("message", (message) => {
          this.onData.fire(message);
        });
      }
      listen(callback) {
        return this.onData.event(callback);
      }
    };
    exports.PortMessageReader = PortMessageReader;
    var PortMessageWriter = class extends api_1.AbstractMessageWriter {
      constructor(port) {
        super(), this.port = port, this.errorCount = 0, port.on("close", () => this.fireClose()), port.on("error", (error) => this.fireError(error));
      }
      write(msg) {
        try {
          return this.port.postMessage(msg), Promise.resolve();
        } catch (error) {
          return this.handleError(error, msg), Promise.reject(error);
        }
      }
      handleError(error, msg) {
        this.errorCount++, this.fireError(error, msg, this.errorCount);
      }
      end() {
      }
    };
    exports.PortMessageWriter = PortMessageWriter;
    var SocketMessageReader = class extends api_1.ReadableStreamMessageReader {
      constructor(socket, encoding = "utf-8") {
        super((0, ril_1.default)().stream.asReadableStream(socket), encoding);
      }
    };
    exports.SocketMessageReader = SocketMessageReader;
    var SocketMessageWriter = class extends api_1.WriteableStreamMessageWriter {
      constructor(socket, options) {
        super((0, ril_1.default)().stream.asWritableStream(socket), options), this.socket = socket;
      }
      dispose() {
        super.dispose(), this.socket.destroy();
      }
    };
    exports.SocketMessageWriter = SocketMessageWriter;
    var StreamMessageReader = class extends api_1.ReadableStreamMessageReader {
      constructor(readable, encoding) {
        super((0, ril_1.default)().stream.asReadableStream(readable), encoding);
      }
    };
    exports.StreamMessageReader = StreamMessageReader;
    var StreamMessageWriter = class extends api_1.WriteableStreamMessageWriter {
      constructor(writable, options) {
        super((0, ril_1.default)().stream.asWritableStream(writable), options);
      }
    };
    exports.StreamMessageWriter = StreamMessageWriter;
    var XDG_RUNTIME_DIR = process.env.XDG_RUNTIME_DIR, safeIpcPathLengths = /* @__PURE__ */ new Map([
      ["linux", 107],
      ["darwin", 103]
    ]);
    function generateRandomPipeName() {
      let randomSuffix = (0, crypto_1.randomBytes)(21).toString("hex");
      if (process.platform === "win32")
        return `\\\\.\\pipe\\vscode-jsonrpc-${randomSuffix}-sock`;
      let result;
      XDG_RUNTIME_DIR ? result = path3.join(XDG_RUNTIME_DIR, `vscode-ipc-${randomSuffix}.sock`) : result = path3.join(os.tmpdir(), `vscode-${randomSuffix}.sock`);
      let limit = safeIpcPathLengths.get(process.platform);
      return limit !== void 0 && result.length > limit && (0, ril_1.default)().console.warn(`WARNING: IPC handle "${result}" is longer than ${limit} characters.`), result;
    }
    exports.generateRandomPipeName = generateRandomPipeName;
    function createClientPipeTransport(pipeName, encoding = "utf-8") {
      let connectResolve, connected = new Promise((resolve2, _reject) => {
        connectResolve = resolve2;
      });
      return new Promise((resolve2, reject) => {
        let server = (0, net_1.createServer)((socket) => {
          server.close(), connectResolve([
            new SocketMessageReader(socket, encoding),
            new SocketMessageWriter(socket, encoding)
          ]);
        });
        server.on("error", reject), server.listen(pipeName, () => {
          server.removeListener("error", reject), resolve2({
            onConnected: () => connected
          });
        });
      });
    }
    exports.createClientPipeTransport = createClientPipeTransport;
    function createServerPipeTransport(pipeName, encoding = "utf-8") {
      let socket = (0, net_1.createConnection)(pipeName);
      return [
        new SocketMessageReader(socket, encoding),
        new SocketMessageWriter(socket, encoding)
      ];
    }
    exports.createServerPipeTransport = createServerPipeTransport;
    function createClientSocketTransport(port, encoding = "utf-8") {
      let connectResolve, connected = new Promise((resolve2, _reject) => {
        connectResolve = resolve2;
      });
      return new Promise((resolve2, reject) => {
        let server = (0, net_1.createServer)((socket) => {
          server.close(), connectResolve([
            new SocketMessageReader(socket, encoding),
            new SocketMessageWriter(socket, encoding)
          ]);
        });
        server.on("error", reject), server.listen(port, "127.0.0.1", () => {
          server.removeListener("error", reject), resolve2({
            onConnected: () => connected
          });
        });
      });
    }
    exports.createClientSocketTransport = createClientSocketTransport;
    function createServerSocketTransport(port, encoding = "utf-8") {
      let socket = (0, net_1.createConnection)(port, "127.0.0.1");
      return [
        new SocketMessageReader(socket, encoding),
        new SocketMessageWriter(socket, encoding)
      ];
    }
    exports.createServerSocketTransport = createServerSocketTransport;
    function isReadableStream(value) {
      let candidate = value;
      return candidate.read !== void 0 && candidate.addListener !== void 0;
    }
    function isWritableStream(value) {
      let candidate = value;
      return candidate.write !== void 0 && candidate.addListener !== void 0;
    }
    function createMessageConnection(input, output, logger, options) {
      logger || (logger = api_1.NullLogger);
      let reader = isReadableStream(input) ? new StreamMessageReader(input) : input, writer = isWritableStream(output) ? new StreamMessageWriter(output) : output;
      return api_1.ConnectionStrategy.is(options) && (options = { connectionStrategy: options }), (0, api_1.createMessageConnection)(reader, writer, logger, options);
    }
    exports.createMessageConnection = createMessageConnection;
  }
});

// ../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/node.js
var require_node2 = __commonJS({
  "../../node_modules/.pnpm/vscode-jsonrpc@8.1.0/node_modules/vscode-jsonrpc/node.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = require_main3();
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-types@3.17.3/node_modules/vscode-languageserver-types/lib/umd/main.js
var main_exports2 = {};
__export(main_exports2, {
  AnnotatedTextEdit: () => AnnotatedTextEdit2,
  ChangeAnnotation: () => ChangeAnnotation2,
  ChangeAnnotationIdentifier: () => ChangeAnnotationIdentifier2,
  CodeAction: () => CodeAction2,
  CodeActionContext: () => CodeActionContext2,
  CodeActionKind: () => CodeActionKind2,
  CodeActionTriggerKind: () => CodeActionTriggerKind2,
  CodeDescription: () => CodeDescription2,
  CodeLens: () => CodeLens2,
  Color: () => Color2,
  ColorInformation: () => ColorInformation2,
  ColorPresentation: () => ColorPresentation2,
  Command: () => Command2,
  CompletionItem: () => CompletionItem2,
  CompletionItemKind: () => CompletionItemKind2,
  CompletionItemLabelDetails: () => CompletionItemLabelDetails2,
  CompletionItemTag: () => CompletionItemTag2,
  CompletionList: () => CompletionList2,
  CreateFile: () => CreateFile2,
  DeleteFile: () => DeleteFile2,
  Diagnostic: () => Diagnostic2,
  DiagnosticRelatedInformation: () => DiagnosticRelatedInformation2,
  DiagnosticSeverity: () => DiagnosticSeverity2,
  DiagnosticTag: () => DiagnosticTag2,
  DocumentHighlight: () => DocumentHighlight2,
  DocumentHighlightKind: () => DocumentHighlightKind2,
  DocumentLink: () => DocumentLink2,
  DocumentSymbol: () => DocumentSymbol2,
  DocumentUri: () => DocumentUri2,
  EOL: () => EOL,
  FoldingRange: () => FoldingRange2,
  FoldingRangeKind: () => FoldingRangeKind2,
  FormattingOptions: () => FormattingOptions2,
  Hover: () => Hover2,
  InlayHint: () => InlayHint2,
  InlayHintKind: () => InlayHintKind2,
  InlayHintLabelPart: () => InlayHintLabelPart2,
  InlineValueContext: () => InlineValueContext2,
  InlineValueEvaluatableExpression: () => InlineValueEvaluatableExpression2,
  InlineValueText: () => InlineValueText2,
  InlineValueVariableLookup: () => InlineValueVariableLookup2,
  InsertReplaceEdit: () => InsertReplaceEdit2,
  InsertTextFormat: () => InsertTextFormat2,
  InsertTextMode: () => InsertTextMode2,
  Location: () => Location2,
  LocationLink: () => LocationLink2,
  MarkedString: () => MarkedString2,
  MarkupContent: () => MarkupContent2,
  MarkupKind: () => MarkupKind2,
  OptionalVersionedTextDocumentIdentifier: () => OptionalVersionedTextDocumentIdentifier2,
  ParameterInformation: () => ParameterInformation2,
  Position: () => Position2,
  Range: () => Range2,
  RenameFile: () => RenameFile2,
  SelectionRange: () => SelectionRange2,
  SemanticTokenModifiers: () => SemanticTokenModifiers2,
  SemanticTokenTypes: () => SemanticTokenTypes2,
  SemanticTokens: () => SemanticTokens2,
  SignatureInformation: () => SignatureInformation2,
  SymbolInformation: () => SymbolInformation2,
  SymbolKind: () => SymbolKind2,
  SymbolTag: () => SymbolTag2,
  TextDocument: () => TextDocument3,
  TextDocumentEdit: () => TextDocumentEdit2,
  TextDocumentIdentifier: () => TextDocumentIdentifier2,
  TextDocumentItem: () => TextDocumentItem2,
  TextEdit: () => TextEdit2,
  URI: () => URI3,
  VersionedTextDocumentIdentifier: () => VersionedTextDocumentIdentifier2,
  WorkspaceChange: () => WorkspaceChange,
  WorkspaceEdit: () => WorkspaceEdit2,
  WorkspaceFolder: () => WorkspaceFolder2,
  WorkspaceSymbol: () => WorkspaceSymbol2,
  integer: () => integer2,
  uinteger: () => uinteger2
});
var DocumentUri2, URI3, integer2, uinteger2, Position2, Range2, Location2, LocationLink2, Color2, ColorInformation2, ColorPresentation2, FoldingRangeKind2, FoldingRange2, DiagnosticRelatedInformation2, DiagnosticSeverity2, DiagnosticTag2, CodeDescription2, Diagnostic2, Command2, TextEdit2, ChangeAnnotation2, ChangeAnnotationIdentifier2, AnnotatedTextEdit2, TextDocumentEdit2, CreateFile2, RenameFile2, DeleteFile2, WorkspaceEdit2, TextEditChangeImpl, ChangeAnnotations, WorkspaceChange, TextDocumentIdentifier2, VersionedTextDocumentIdentifier2, OptionalVersionedTextDocumentIdentifier2, TextDocumentItem2, MarkupKind2, MarkupContent2, CompletionItemKind2, InsertTextFormat2, CompletionItemTag2, InsertReplaceEdit2, InsertTextMode2, CompletionItemLabelDetails2, CompletionItem2, CompletionList2, MarkedString2, Hover2, ParameterInformation2, SignatureInformation2, DocumentHighlightKind2, DocumentHighlight2, SymbolKind2, SymbolTag2, SymbolInformation2, WorkspaceSymbol2, DocumentSymbol2, CodeActionKind2, CodeActionTriggerKind2, CodeActionContext2, CodeAction2, CodeLens2, FormattingOptions2, DocumentLink2, SelectionRange2, SemanticTokenTypes2, SemanticTokenModifiers2, SemanticTokens2, InlineValueText2, InlineValueVariableLookup2, InlineValueEvaluatableExpression2, InlineValueContext2, InlayHintKind2, InlayHintLabelPart2, InlayHint2, WorkspaceFolder2, EOL, TextDocument3, FullTextDocument3, Is2, init_main4 = __esm({
  "../../node_modules/.pnpm/vscode-languageserver-types@3.17.3/node_modules/vscode-languageserver-types/lib/umd/main.js"() {
    "use strict";
    init_cjs_shims();
    (function(DocumentUri3) {
      function is(value) {
        return typeof value == "string";
      }
      DocumentUri3.is = is;
    })(DocumentUri2 || (DocumentUri2 = {}));
    (function(URI4) {
      function is(value) {
        return typeof value == "string";
      }
      URI4.is = is;
    })(URI3 || (URI3 = {}));
    (function(integer3) {
      integer3.MIN_VALUE = -2147483648, integer3.MAX_VALUE = 2147483647;
      function is(value) {
        return typeof value == "number" && integer3.MIN_VALUE <= value && value <= integer3.MAX_VALUE;
      }
      integer3.is = is;
    })(integer2 || (integer2 = {}));
    (function(uinteger3) {
      uinteger3.MIN_VALUE = 0, uinteger3.MAX_VALUE = 2147483647;
      function is(value) {
        return typeof value == "number" && uinteger3.MIN_VALUE <= value && value <= uinteger3.MAX_VALUE;
      }
      uinteger3.is = is;
    })(uinteger2 || (uinteger2 = {}));
    (function(Position3) {
      function create(line, character) {
        return line === Number.MAX_VALUE && (line = uinteger2.MAX_VALUE), character === Number.MAX_VALUE && (character = uinteger2.MAX_VALUE), { line, character };
      }
      Position3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.objectLiteral(candidate) && Is2.uinteger(candidate.line) && Is2.uinteger(candidate.character);
      }
      Position3.is = is;
    })(Position2 || (Position2 = {}));
    (function(Range3) {
      function create(one, two, three, four) {
        if (Is2.uinteger(one) && Is2.uinteger(two) && Is2.uinteger(three) && Is2.uinteger(four))
          return { start: Position2.create(one, two), end: Position2.create(three, four) };
        if (Position2.is(one) && Position2.is(two))
          return { start: one, end: two };
        throw new Error("Range#create called with invalid arguments[".concat(one, ", ").concat(two, ", ").concat(three, ", ").concat(four, "]"));
      }
      Range3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.objectLiteral(candidate) && Position2.is(candidate.start) && Position2.is(candidate.end);
      }
      Range3.is = is;
    })(Range2 || (Range2 = {}));
    (function(Location3) {
      function create(uri, range) {
        return { uri, range };
      }
      Location3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.objectLiteral(candidate) && Range2.is(candidate.range) && (Is2.string(candidate.uri) || Is2.undefined(candidate.uri));
      }
      Location3.is = is;
    })(Location2 || (Location2 = {}));
    (function(LocationLink3) {
      function create(targetUri, targetRange, targetSelectionRange, originSelectionRange) {
        return { targetUri, targetRange, targetSelectionRange, originSelectionRange };
      }
      LocationLink3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.objectLiteral(candidate) && Range2.is(candidate.targetRange) && Is2.string(candidate.targetUri) && Range2.is(candidate.targetSelectionRange) && (Range2.is(candidate.originSelectionRange) || Is2.undefined(candidate.originSelectionRange));
      }
      LocationLink3.is = is;
    })(LocationLink2 || (LocationLink2 = {}));
    (function(Color3) {
      function create(red, green, blue, alpha) {
        return {
          red,
          green,
          blue,
          alpha
        };
      }
      Color3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.objectLiteral(candidate) && Is2.numberRange(candidate.red, 0, 1) && Is2.numberRange(candidate.green, 0, 1) && Is2.numberRange(candidate.blue, 0, 1) && Is2.numberRange(candidate.alpha, 0, 1);
      }
      Color3.is = is;
    })(Color2 || (Color2 = {}));
    (function(ColorInformation3) {
      function create(range, color) {
        return {
          range,
          color
        };
      }
      ColorInformation3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.objectLiteral(candidate) && Range2.is(candidate.range) && Color2.is(candidate.color);
      }
      ColorInformation3.is = is;
    })(ColorInformation2 || (ColorInformation2 = {}));
    (function(ColorPresentation3) {
      function create(label, textEdit, additionalTextEdits) {
        return {
          label,
          textEdit,
          additionalTextEdits
        };
      }
      ColorPresentation3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.objectLiteral(candidate) && Is2.string(candidate.label) && (Is2.undefined(candidate.textEdit) || TextEdit2.is(candidate)) && (Is2.undefined(candidate.additionalTextEdits) || Is2.typedArray(candidate.additionalTextEdits, TextEdit2.is));
      }
      ColorPresentation3.is = is;
    })(ColorPresentation2 || (ColorPresentation2 = {}));
    (function(FoldingRangeKind3) {
      FoldingRangeKind3.Comment = "comment", FoldingRangeKind3.Imports = "imports", FoldingRangeKind3.Region = "region";
    })(FoldingRangeKind2 || (FoldingRangeKind2 = {}));
    (function(FoldingRange3) {
      function create(startLine, endLine, startCharacter, endCharacter, kind, collapsedText) {
        var result = {
          startLine,
          endLine
        };
        return Is2.defined(startCharacter) && (result.startCharacter = startCharacter), Is2.defined(endCharacter) && (result.endCharacter = endCharacter), Is2.defined(kind) && (result.kind = kind), Is2.defined(collapsedText) && (result.collapsedText = collapsedText), result;
      }
      FoldingRange3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.objectLiteral(candidate) && Is2.uinteger(candidate.startLine) && Is2.uinteger(candidate.startLine) && (Is2.undefined(candidate.startCharacter) || Is2.uinteger(candidate.startCharacter)) && (Is2.undefined(candidate.endCharacter) || Is2.uinteger(candidate.endCharacter)) && (Is2.undefined(candidate.kind) || Is2.string(candidate.kind));
      }
      FoldingRange3.is = is;
    })(FoldingRange2 || (FoldingRange2 = {}));
    (function(DiagnosticRelatedInformation3) {
      function create(location2, message) {
        return {
          location: location2,
          message
        };
      }
      DiagnosticRelatedInformation3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.defined(candidate) && Location2.is(candidate.location) && Is2.string(candidate.message);
      }
      DiagnosticRelatedInformation3.is = is;
    })(DiagnosticRelatedInformation2 || (DiagnosticRelatedInformation2 = {}));
    (function(DiagnosticSeverity3) {
      DiagnosticSeverity3.Error = 1, DiagnosticSeverity3.Warning = 2, DiagnosticSeverity3.Information = 3, DiagnosticSeverity3.Hint = 4;
    })(DiagnosticSeverity2 || (DiagnosticSeverity2 = {}));
    (function(DiagnosticTag3) {
      DiagnosticTag3.Unnecessary = 1, DiagnosticTag3.Deprecated = 2;
    })(DiagnosticTag2 || (DiagnosticTag2 = {}));
    (function(CodeDescription3) {
      function is(value) {
        var candidate = value;
        return Is2.objectLiteral(candidate) && Is2.string(candidate.href);
      }
      CodeDescription3.is = is;
    })(CodeDescription2 || (CodeDescription2 = {}));
    (function(Diagnostic3) {
      function create(range, message, severity, code, source, relatedInformation) {
        var result = { range, message };
        return Is2.defined(severity) && (result.severity = severity), Is2.defined(code) && (result.code = code), Is2.defined(source) && (result.source = source), Is2.defined(relatedInformation) && (result.relatedInformation = relatedInformation), result;
      }
      Diagnostic3.create = create;
      function is(value) {
        var _a38, candidate = value;
        return Is2.defined(candidate) && Range2.is(candidate.range) && Is2.string(candidate.message) && (Is2.number(candidate.severity) || Is2.undefined(candidate.severity)) && (Is2.integer(candidate.code) || Is2.string(candidate.code) || Is2.undefined(candidate.code)) && (Is2.undefined(candidate.codeDescription) || Is2.string((_a38 = candidate.codeDescription) === null || _a38 === void 0 ? void 0 : _a38.href)) && (Is2.string(candidate.source) || Is2.undefined(candidate.source)) && (Is2.undefined(candidate.relatedInformation) || Is2.typedArray(candidate.relatedInformation, DiagnosticRelatedInformation2.is));
      }
      Diagnostic3.is = is;
    })(Diagnostic2 || (Diagnostic2 = {}));
    (function(Command11) {
      function create(title, command) {
        for (var args = [], _i = 2; _i < arguments.length; _i++)
          args[_i - 2] = arguments[_i];
        var result = { title, command };
        return Is2.defined(args) && args.length > 0 && (result.arguments = args), result;
      }
      Command11.create = create;
      function is(value) {
        var candidate = value;
        return Is2.defined(candidate) && Is2.string(candidate.title) && Is2.string(candidate.command);
      }
      Command11.is = is;
    })(Command2 || (Command2 = {}));
    (function(TextEdit3) {
      function replace(range, newText) {
        return { range, newText };
      }
      TextEdit3.replace = replace;
      function insert2(position, newText) {
        return { range: { start: position, end: position }, newText };
      }
      TextEdit3.insert = insert2;
      function del(range) {
        return { range, newText: "" };
      }
      TextEdit3.del = del;
      function is(value) {
        var candidate = value;
        return Is2.objectLiteral(candidate) && Is2.string(candidate.newText) && Range2.is(candidate.range);
      }
      TextEdit3.is = is;
    })(TextEdit2 || (TextEdit2 = {}));
    (function(ChangeAnnotation3) {
      function create(label, needsConfirmation, description) {
        var result = { label };
        return needsConfirmation !== void 0 && (result.needsConfirmation = needsConfirmation), description !== void 0 && (result.description = description), result;
      }
      ChangeAnnotation3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.objectLiteral(candidate) && Is2.string(candidate.label) && (Is2.boolean(candidate.needsConfirmation) || candidate.needsConfirmation === void 0) && (Is2.string(candidate.description) || candidate.description === void 0);
      }
      ChangeAnnotation3.is = is;
    })(ChangeAnnotation2 || (ChangeAnnotation2 = {}));
    (function(ChangeAnnotationIdentifier3) {
      function is(value) {
        var candidate = value;
        return Is2.string(candidate);
      }
      ChangeAnnotationIdentifier3.is = is;
    })(ChangeAnnotationIdentifier2 || (ChangeAnnotationIdentifier2 = {}));
    (function(AnnotatedTextEdit3) {
      function replace(range, newText, annotation) {
        return { range, newText, annotationId: annotation };
      }
      AnnotatedTextEdit3.replace = replace;
      function insert2(position, newText, annotation) {
        return { range: { start: position, end: position }, newText, annotationId: annotation };
      }
      AnnotatedTextEdit3.insert = insert2;
      function del(range, annotation) {
        return { range, newText: "", annotationId: annotation };
      }
      AnnotatedTextEdit3.del = del;
      function is(value) {
        var candidate = value;
        return TextEdit2.is(candidate) && (ChangeAnnotation2.is(candidate.annotationId) || ChangeAnnotationIdentifier2.is(candidate.annotationId));
      }
      AnnotatedTextEdit3.is = is;
    })(AnnotatedTextEdit2 || (AnnotatedTextEdit2 = {}));
    (function(TextDocumentEdit3) {
      function create(textDocument, edits) {
        return { textDocument, edits };
      }
      TextDocumentEdit3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.defined(candidate) && OptionalVersionedTextDocumentIdentifier2.is(candidate.textDocument) && Array.isArray(candidate.edits);
      }
      TextDocumentEdit3.is = is;
    })(TextDocumentEdit2 || (TextDocumentEdit2 = {}));
    (function(CreateFile3) {
      function create(uri, options, annotation) {
        var result = {
          kind: "create",
          uri
        };
        return options !== void 0 && (options.overwrite !== void 0 || options.ignoreIfExists !== void 0) && (result.options = options), annotation !== void 0 && (result.annotationId = annotation), result;
      }
      CreateFile3.create = create;
      function is(value) {
        var candidate = value;
        return candidate && candidate.kind === "create" && Is2.string(candidate.uri) && (candidate.options === void 0 || (candidate.options.overwrite === void 0 || Is2.boolean(candidate.options.overwrite)) && (candidate.options.ignoreIfExists === void 0 || Is2.boolean(candidate.options.ignoreIfExists))) && (candidate.annotationId === void 0 || ChangeAnnotationIdentifier2.is(candidate.annotationId));
      }
      CreateFile3.is = is;
    })(CreateFile2 || (CreateFile2 = {}));
    (function(RenameFile3) {
      function create(oldUri, newUri, options, annotation) {
        var result = {
          kind: "rename",
          oldUri,
          newUri
        };
        return options !== void 0 && (options.overwrite !== void 0 || options.ignoreIfExists !== void 0) && (result.options = options), annotation !== void 0 && (result.annotationId = annotation), result;
      }
      RenameFile3.create = create;
      function is(value) {
        var candidate = value;
        return candidate && candidate.kind === "rename" && Is2.string(candidate.oldUri) && Is2.string(candidate.newUri) && (candidate.options === void 0 || (candidate.options.overwrite === void 0 || Is2.boolean(candidate.options.overwrite)) && (candidate.options.ignoreIfExists === void 0 || Is2.boolean(candidate.options.ignoreIfExists))) && (candidate.annotationId === void 0 || ChangeAnnotationIdentifier2.is(candidate.annotationId));
      }
      RenameFile3.is = is;
    })(RenameFile2 || (RenameFile2 = {}));
    (function(DeleteFile3) {
      function create(uri, options, annotation) {
        var result = {
          kind: "delete",
          uri
        };
        return options !== void 0 && (options.recursive !== void 0 || options.ignoreIfNotExists !== void 0) && (result.options = options), annotation !== void 0 && (result.annotationId = annotation), result;
      }
      DeleteFile3.create = create;
      function is(value) {
        var candidate = value;
        return candidate && candidate.kind === "delete" && Is2.string(candidate.uri) && (candidate.options === void 0 || (candidate.options.recursive === void 0 || Is2.boolean(candidate.options.recursive)) && (candidate.options.ignoreIfNotExists === void 0 || Is2.boolean(candidate.options.ignoreIfNotExists))) && (candidate.annotationId === void 0 || ChangeAnnotationIdentifier2.is(candidate.annotationId));
      }
      DeleteFile3.is = is;
    })(DeleteFile2 || (DeleteFile2 = {}));
    (function(WorkspaceEdit3) {
      function is(value) {
        var candidate = value;
        return candidate && (candidate.changes !== void 0 || candidate.documentChanges !== void 0) && (candidate.documentChanges === void 0 || candidate.documentChanges.every(function(change) {
          return Is2.string(change.kind) ? CreateFile2.is(change) || RenameFile2.is(change) || DeleteFile2.is(change) : TextDocumentEdit2.is(change);
        }));
      }
      WorkspaceEdit3.is = is;
    })(WorkspaceEdit2 || (WorkspaceEdit2 = {}));
    TextEditChangeImpl = /** @class */
    function() {
      function TextEditChangeImpl2(edits, changeAnnotations) {
        this.edits = edits, this.changeAnnotations = changeAnnotations;
      }
      return TextEditChangeImpl2.prototype.insert = function(position, newText, annotation) {
        var edit, id;
        if (annotation === void 0 ? edit = TextEdit2.insert(position, newText) : ChangeAnnotationIdentifier2.is(annotation) ? (id = annotation, edit = AnnotatedTextEdit2.insert(position, newText, annotation)) : (this.assertChangeAnnotations(this.changeAnnotations), id = this.changeAnnotations.manage(annotation), edit = AnnotatedTextEdit2.insert(position, newText, id)), this.edits.push(edit), id !== void 0)
          return id;
      }, TextEditChangeImpl2.prototype.replace = function(range, newText, annotation) {
        var edit, id;
        if (annotation === void 0 ? edit = TextEdit2.replace(range, newText) : ChangeAnnotationIdentifier2.is(annotation) ? (id = annotation, edit = AnnotatedTextEdit2.replace(range, newText, annotation)) : (this.assertChangeAnnotations(this.changeAnnotations), id = this.changeAnnotations.manage(annotation), edit = AnnotatedTextEdit2.replace(range, newText, id)), this.edits.push(edit), id !== void 0)
          return id;
      }, TextEditChangeImpl2.prototype.delete = function(range, annotation) {
        var edit, id;
        if (annotation === void 0 ? edit = TextEdit2.del(range) : ChangeAnnotationIdentifier2.is(annotation) ? (id = annotation, edit = AnnotatedTextEdit2.del(range, annotation)) : (this.assertChangeAnnotations(this.changeAnnotations), id = this.changeAnnotations.manage(annotation), edit = AnnotatedTextEdit2.del(range, id)), this.edits.push(edit), id !== void 0)
          return id;
      }, TextEditChangeImpl2.prototype.add = function(edit) {
        this.edits.push(edit);
      }, TextEditChangeImpl2.prototype.all = function() {
        return this.edits;
      }, TextEditChangeImpl2.prototype.clear = function() {
        this.edits.splice(0, this.edits.length);
      }, TextEditChangeImpl2.prototype.assertChangeAnnotations = function(value) {
        if (value === void 0)
          throw new Error("Text edit change is not configured to manage change annotations.");
      }, TextEditChangeImpl2;
    }(), ChangeAnnotations = /** @class */
    function() {
      function ChangeAnnotations2(annotations) {
        this._annotations = annotations === void 0 ? /* @__PURE__ */ Object.create(null) : annotations, this._counter = 0, this._size = 0;
      }
      return ChangeAnnotations2.prototype.all = function() {
        return this._annotations;
      }, Object.defineProperty(ChangeAnnotations2.prototype, "size", {
        get: function() {
          return this._size;
        },
        enumerable: !1,
        configurable: !0
      }), ChangeAnnotations2.prototype.manage = function(idOrAnnotation, annotation) {
        var id;
        if (ChangeAnnotationIdentifier2.is(idOrAnnotation) ? id = idOrAnnotation : (id = this.nextId(), annotation = idOrAnnotation), this._annotations[id] !== void 0)
          throw new Error("Id ".concat(id, " is already in use."));
        if (annotation === void 0)
          throw new Error("No annotation provided for id ".concat(id));
        return this._annotations[id] = annotation, this._size++, id;
      }, ChangeAnnotations2.prototype.nextId = function() {
        return this._counter++, this._counter.toString();
      }, ChangeAnnotations2;
    }(), WorkspaceChange = /** @class */
    function() {
      function WorkspaceChange2(workspaceEdit) {
        var _this = this;
        this._textEditChanges = /* @__PURE__ */ Object.create(null), workspaceEdit !== void 0 ? (this._workspaceEdit = workspaceEdit, workspaceEdit.documentChanges ? (this._changeAnnotations = new ChangeAnnotations(workspaceEdit.changeAnnotations), workspaceEdit.changeAnnotations = this._changeAnnotations.all(), workspaceEdit.documentChanges.forEach(function(change) {
          if (TextDocumentEdit2.is(change)) {
            var textEditChange = new TextEditChangeImpl(change.edits, _this._changeAnnotations);
            _this._textEditChanges[change.textDocument.uri] = textEditChange;
          }
        })) : workspaceEdit.changes && Object.keys(workspaceEdit.changes).forEach(function(key) {
          var textEditChange = new TextEditChangeImpl(workspaceEdit.changes[key]);
          _this._textEditChanges[key] = textEditChange;
        })) : this._workspaceEdit = {};
      }
      return Object.defineProperty(WorkspaceChange2.prototype, "edit", {
        /**
         * Returns the underlying {@link WorkspaceEdit} literal
         * use to be returned from a workspace edit operation like rename.
         */
        get: function() {
          return this.initDocumentChanges(), this._changeAnnotations !== void 0 && (this._changeAnnotations.size === 0 ? this._workspaceEdit.changeAnnotations = void 0 : this._workspaceEdit.changeAnnotations = this._changeAnnotations.all()), this._workspaceEdit;
        },
        enumerable: !1,
        configurable: !0
      }), WorkspaceChange2.prototype.getTextEditChange = function(key) {
        if (OptionalVersionedTextDocumentIdentifier2.is(key)) {
          if (this.initDocumentChanges(), this._workspaceEdit.documentChanges === void 0)
            throw new Error("Workspace edit is not configured for document changes.");
          var textDocument = { uri: key.uri, version: key.version }, result = this._textEditChanges[textDocument.uri];
          if (!result) {
            var edits = [], textDocumentEdit = {
              textDocument,
              edits
            };
            this._workspaceEdit.documentChanges.push(textDocumentEdit), result = new TextEditChangeImpl(edits, this._changeAnnotations), this._textEditChanges[textDocument.uri] = result;
          }
          return result;
        } else {
          if (this.initChanges(), this._workspaceEdit.changes === void 0)
            throw new Error("Workspace edit is not configured for normal text edit changes.");
          var result = this._textEditChanges[key];
          if (!result) {
            var edits = [];
            this._workspaceEdit.changes[key] = edits, result = new TextEditChangeImpl(edits), this._textEditChanges[key] = result;
          }
          return result;
        }
      }, WorkspaceChange2.prototype.initDocumentChanges = function() {
        this._workspaceEdit.documentChanges === void 0 && this._workspaceEdit.changes === void 0 && (this._changeAnnotations = new ChangeAnnotations(), this._workspaceEdit.documentChanges = [], this._workspaceEdit.changeAnnotations = this._changeAnnotations.all());
      }, WorkspaceChange2.prototype.initChanges = function() {
        this._workspaceEdit.documentChanges === void 0 && this._workspaceEdit.changes === void 0 && (this._workspaceEdit.changes = /* @__PURE__ */ Object.create(null));
      }, WorkspaceChange2.prototype.createFile = function(uri, optionsOrAnnotation, options) {
        if (this.initDocumentChanges(), this._workspaceEdit.documentChanges === void 0)
          throw new Error("Workspace edit is not configured for document changes.");
        var annotation;
        ChangeAnnotation2.is(optionsOrAnnotation) || ChangeAnnotationIdentifier2.is(optionsOrAnnotation) ? annotation = optionsOrAnnotation : options = optionsOrAnnotation;
        var operation, id;
        if (annotation === void 0 ? operation = CreateFile2.create(uri, options) : (id = ChangeAnnotationIdentifier2.is(annotation) ? annotation : this._changeAnnotations.manage(annotation), operation = CreateFile2.create(uri, options, id)), this._workspaceEdit.documentChanges.push(operation), id !== void 0)
          return id;
      }, WorkspaceChange2.prototype.renameFile = function(oldUri, newUri, optionsOrAnnotation, options) {
        if (this.initDocumentChanges(), this._workspaceEdit.documentChanges === void 0)
          throw new Error("Workspace edit is not configured for document changes.");
        var annotation;
        ChangeAnnotation2.is(optionsOrAnnotation) || ChangeAnnotationIdentifier2.is(optionsOrAnnotation) ? annotation = optionsOrAnnotation : options = optionsOrAnnotation;
        var operation, id;
        if (annotation === void 0 ? operation = RenameFile2.create(oldUri, newUri, options) : (id = ChangeAnnotationIdentifier2.is(annotation) ? annotation : this._changeAnnotations.manage(annotation), operation = RenameFile2.create(oldUri, newUri, options, id)), this._workspaceEdit.documentChanges.push(operation), id !== void 0)
          return id;
      }, WorkspaceChange2.prototype.deleteFile = function(uri, optionsOrAnnotation, options) {
        if (this.initDocumentChanges(), this._workspaceEdit.documentChanges === void 0)
          throw new Error("Workspace edit is not configured for document changes.");
        var annotation;
        ChangeAnnotation2.is(optionsOrAnnotation) || ChangeAnnotationIdentifier2.is(optionsOrAnnotation) ? annotation = optionsOrAnnotation : options = optionsOrAnnotation;
        var operation, id;
        if (annotation === void 0 ? operation = DeleteFile2.create(uri, options) : (id = ChangeAnnotationIdentifier2.is(annotation) ? annotation : this._changeAnnotations.manage(annotation), operation = DeleteFile2.create(uri, options, id)), this._workspaceEdit.documentChanges.push(operation), id !== void 0)
          return id;
      }, WorkspaceChange2;
    }();
    (function(TextDocumentIdentifier3) {
      function create(uri) {
        return { uri };
      }
      TextDocumentIdentifier3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.defined(candidate) && Is2.string(candidate.uri);
      }
      TextDocumentIdentifier3.is = is;
    })(TextDocumentIdentifier2 || (TextDocumentIdentifier2 = {}));
    (function(VersionedTextDocumentIdentifier3) {
      function create(uri, version2) {
        return { uri, version: version2 };
      }
      VersionedTextDocumentIdentifier3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.defined(candidate) && Is2.string(candidate.uri) && Is2.integer(candidate.version);
      }
      VersionedTextDocumentIdentifier3.is = is;
    })(VersionedTextDocumentIdentifier2 || (VersionedTextDocumentIdentifier2 = {}));
    (function(OptionalVersionedTextDocumentIdentifier3) {
      function create(uri, version2) {
        return { uri, version: version2 };
      }
      OptionalVersionedTextDocumentIdentifier3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.defined(candidate) && Is2.string(candidate.uri) && (candidate.version === null || Is2.integer(candidate.version));
      }
      OptionalVersionedTextDocumentIdentifier3.is = is;
    })(OptionalVersionedTextDocumentIdentifier2 || (OptionalVersionedTextDocumentIdentifier2 = {}));
    (function(TextDocumentItem3) {
      function create(uri, languageId, version2, text) {
        return { uri, languageId, version: version2, text };
      }
      TextDocumentItem3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.defined(candidate) && Is2.string(candidate.uri) && Is2.string(candidate.languageId) && Is2.integer(candidate.version) && Is2.string(candidate.text);
      }
      TextDocumentItem3.is = is;
    })(TextDocumentItem2 || (TextDocumentItem2 = {}));
    (function(MarkupKind3) {
      MarkupKind3.PlainText = "plaintext", MarkupKind3.Markdown = "markdown";
      function is(value) {
        var candidate = value;
        return candidate === MarkupKind3.PlainText || candidate === MarkupKind3.Markdown;
      }
      MarkupKind3.is = is;
    })(MarkupKind2 || (MarkupKind2 = {}));
    (function(MarkupContent3) {
      function is(value) {
        var candidate = value;
        return Is2.objectLiteral(value) && MarkupKind2.is(candidate.kind) && Is2.string(candidate.value);
      }
      MarkupContent3.is = is;
    })(MarkupContent2 || (MarkupContent2 = {}));
    (function(CompletionItemKind3) {
      CompletionItemKind3.Text = 1, CompletionItemKind3.Method = 2, CompletionItemKind3.Function = 3, CompletionItemKind3.Constructor = 4, CompletionItemKind3.Field = 5, CompletionItemKind3.Variable = 6, CompletionItemKind3.Class = 7, CompletionItemKind3.Interface = 8, CompletionItemKind3.Module = 9, CompletionItemKind3.Property = 10, CompletionItemKind3.Unit = 11, CompletionItemKind3.Value = 12, CompletionItemKind3.Enum = 13, CompletionItemKind3.Keyword = 14, CompletionItemKind3.Snippet = 15, CompletionItemKind3.Color = 16, CompletionItemKind3.File = 17, CompletionItemKind3.Reference = 18, CompletionItemKind3.Folder = 19, CompletionItemKind3.EnumMember = 20, CompletionItemKind3.Constant = 21, CompletionItemKind3.Struct = 22, CompletionItemKind3.Event = 23, CompletionItemKind3.Operator = 24, CompletionItemKind3.TypeParameter = 25;
    })(CompletionItemKind2 || (CompletionItemKind2 = {}));
    (function(InsertTextFormat3) {
      InsertTextFormat3.PlainText = 1, InsertTextFormat3.Snippet = 2;
    })(InsertTextFormat2 || (InsertTextFormat2 = {}));
    (function(CompletionItemTag3) {
      CompletionItemTag3.Deprecated = 1;
    })(CompletionItemTag2 || (CompletionItemTag2 = {}));
    (function(InsertReplaceEdit3) {
      function create(newText, insert2, replace) {
        return { newText, insert: insert2, replace };
      }
      InsertReplaceEdit3.create = create;
      function is(value) {
        var candidate = value;
        return candidate && Is2.string(candidate.newText) && Range2.is(candidate.insert) && Range2.is(candidate.replace);
      }
      InsertReplaceEdit3.is = is;
    })(InsertReplaceEdit2 || (InsertReplaceEdit2 = {}));
    (function(InsertTextMode3) {
      InsertTextMode3.asIs = 1, InsertTextMode3.adjustIndentation = 2;
    })(InsertTextMode2 || (InsertTextMode2 = {}));
    (function(CompletionItemLabelDetails3) {
      function is(value) {
        var candidate = value;
        return candidate && (Is2.string(candidate.detail) || candidate.detail === void 0) && (Is2.string(candidate.description) || candidate.description === void 0);
      }
      CompletionItemLabelDetails3.is = is;
    })(CompletionItemLabelDetails2 || (CompletionItemLabelDetails2 = {}));
    (function(CompletionItem3) {
      function create(label) {
        return { label };
      }
      CompletionItem3.create = create;
    })(CompletionItem2 || (CompletionItem2 = {}));
    (function(CompletionList3) {
      function create(items, isIncomplete) {
        return { items: items || [], isIncomplete: !!isIncomplete };
      }
      CompletionList3.create = create;
    })(CompletionList2 || (CompletionList2 = {}));
    (function(MarkedString3) {
      function fromPlainText(plainText) {
        return plainText.replace(/[\\`*_{}[\]()#+\-.!]/g, "\\$&");
      }
      MarkedString3.fromPlainText = fromPlainText;
      function is(value) {
        var candidate = value;
        return Is2.string(candidate) || Is2.objectLiteral(candidate) && Is2.string(candidate.language) && Is2.string(candidate.value);
      }
      MarkedString3.is = is;
    })(MarkedString2 || (MarkedString2 = {}));
    (function(Hover3) {
      function is(value) {
        var candidate = value;
        return !!candidate && Is2.objectLiteral(candidate) && (MarkupContent2.is(candidate.contents) || MarkedString2.is(candidate.contents) || Is2.typedArray(candidate.contents, MarkedString2.is)) && (value.range === void 0 || Range2.is(value.range));
      }
      Hover3.is = is;
    })(Hover2 || (Hover2 = {}));
    (function(ParameterInformation3) {
      function create(label, documentation) {
        return documentation ? { label, documentation } : { label };
      }
      ParameterInformation3.create = create;
    })(ParameterInformation2 || (ParameterInformation2 = {}));
    (function(SignatureInformation3) {
      function create(label, documentation) {
        for (var parameters = [], _i = 2; _i < arguments.length; _i++)
          parameters[_i - 2] = arguments[_i];
        var result = { label };
        return Is2.defined(documentation) && (result.documentation = documentation), Is2.defined(parameters) ? result.parameters = parameters : result.parameters = [], result;
      }
      SignatureInformation3.create = create;
    })(SignatureInformation2 || (SignatureInformation2 = {}));
    (function(DocumentHighlightKind3) {
      DocumentHighlightKind3.Text = 1, DocumentHighlightKind3.Read = 2, DocumentHighlightKind3.Write = 3;
    })(DocumentHighlightKind2 || (DocumentHighlightKind2 = {}));
    (function(DocumentHighlight3) {
      function create(range, kind) {
        var result = { range };
        return Is2.number(kind) && (result.kind = kind), result;
      }
      DocumentHighlight3.create = create;
    })(DocumentHighlight2 || (DocumentHighlight2 = {}));
    (function(SymbolKind3) {
      SymbolKind3.File = 1, SymbolKind3.Module = 2, SymbolKind3.Namespace = 3, SymbolKind3.Package = 4, SymbolKind3.Class = 5, SymbolKind3.Method = 6, SymbolKind3.Property = 7, SymbolKind3.Field = 8, SymbolKind3.Constructor = 9, SymbolKind3.Enum = 10, SymbolKind3.Interface = 11, SymbolKind3.Function = 12, SymbolKind3.Variable = 13, SymbolKind3.Constant = 14, SymbolKind3.String = 15, SymbolKind3.Number = 16, SymbolKind3.Boolean = 17, SymbolKind3.Array = 18, SymbolKind3.Object = 19, SymbolKind3.Key = 20, SymbolKind3.Null = 21, SymbolKind3.EnumMember = 22, SymbolKind3.Struct = 23, SymbolKind3.Event = 24, SymbolKind3.Operator = 25, SymbolKind3.TypeParameter = 26;
    })(SymbolKind2 || (SymbolKind2 = {}));
    (function(SymbolTag3) {
      SymbolTag3.Deprecated = 1;
    })(SymbolTag2 || (SymbolTag2 = {}));
    (function(SymbolInformation3) {
      function create(name, kind, range, uri, containerName) {
        var result = {
          name,
          kind,
          location: { uri, range }
        };
        return containerName && (result.containerName = containerName), result;
      }
      SymbolInformation3.create = create;
    })(SymbolInformation2 || (SymbolInformation2 = {}));
    (function(WorkspaceSymbol3) {
      function create(name, kind, uri, range) {
        return range !== void 0 ? { name, kind, location: { uri, range } } : { name, kind, location: { uri } };
      }
      WorkspaceSymbol3.create = create;
    })(WorkspaceSymbol2 || (WorkspaceSymbol2 = {}));
    (function(DocumentSymbol3) {
      function create(name, detail, kind, range, selectionRange, children) {
        var result = {
          name,
          detail,
          kind,
          range,
          selectionRange
        };
        return children !== void 0 && (result.children = children), result;
      }
      DocumentSymbol3.create = create;
      function is(value) {
        var candidate = value;
        return candidate && Is2.string(candidate.name) && Is2.number(candidate.kind) && Range2.is(candidate.range) && Range2.is(candidate.selectionRange) && (candidate.detail === void 0 || Is2.string(candidate.detail)) && (candidate.deprecated === void 0 || Is2.boolean(candidate.deprecated)) && (candidate.children === void 0 || Array.isArray(candidate.children)) && (candidate.tags === void 0 || Array.isArray(candidate.tags));
      }
      DocumentSymbol3.is = is;
    })(DocumentSymbol2 || (DocumentSymbol2 = {}));
    (function(CodeActionKind3) {
      CodeActionKind3.Empty = "", CodeActionKind3.QuickFix = "quickfix", CodeActionKind3.Refactor = "refactor", CodeActionKind3.RefactorExtract = "refactor.extract", CodeActionKind3.RefactorInline = "refactor.inline", CodeActionKind3.RefactorRewrite = "refactor.rewrite", CodeActionKind3.Source = "source", CodeActionKind3.SourceOrganizeImports = "source.organizeImports", CodeActionKind3.SourceFixAll = "source.fixAll";
    })(CodeActionKind2 || (CodeActionKind2 = {}));
    (function(CodeActionTriggerKind3) {
      CodeActionTriggerKind3.Invoked = 1, CodeActionTriggerKind3.Automatic = 2;
    })(CodeActionTriggerKind2 || (CodeActionTriggerKind2 = {}));
    (function(CodeActionContext3) {
      function create(diagnostics, only, triggerKind) {
        var result = { diagnostics };
        return only != null && (result.only = only), triggerKind != null && (result.triggerKind = triggerKind), result;
      }
      CodeActionContext3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.defined(candidate) && Is2.typedArray(candidate.diagnostics, Diagnostic2.is) && (candidate.only === void 0 || Is2.typedArray(candidate.only, Is2.string)) && (candidate.triggerKind === void 0 || candidate.triggerKind === CodeActionTriggerKind2.Invoked || candidate.triggerKind === CodeActionTriggerKind2.Automatic);
      }
      CodeActionContext3.is = is;
    })(CodeActionContext2 || (CodeActionContext2 = {}));
    (function(CodeAction3) {
      function create(title, kindOrCommandOrEdit, kind) {
        var result = { title }, checkKind = !0;
        return typeof kindOrCommandOrEdit == "string" ? (checkKind = !1, result.kind = kindOrCommandOrEdit) : Command2.is(kindOrCommandOrEdit) ? result.command = kindOrCommandOrEdit : result.edit = kindOrCommandOrEdit, checkKind && kind !== void 0 && (result.kind = kind), result;
      }
      CodeAction3.create = create;
      function is(value) {
        var candidate = value;
        return candidate && Is2.string(candidate.title) && (candidate.diagnostics === void 0 || Is2.typedArray(candidate.diagnostics, Diagnostic2.is)) && (candidate.kind === void 0 || Is2.string(candidate.kind)) && (candidate.edit !== void 0 || candidate.command !== void 0) && (candidate.command === void 0 || Command2.is(candidate.command)) && (candidate.isPreferred === void 0 || Is2.boolean(candidate.isPreferred)) && (candidate.edit === void 0 || WorkspaceEdit2.is(candidate.edit));
      }
      CodeAction3.is = is;
    })(CodeAction2 || (CodeAction2 = {}));
    (function(CodeLens3) {
      function create(range, data) {
        var result = { range };
        return Is2.defined(data) && (result.data = data), result;
      }
      CodeLens3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.defined(candidate) && Range2.is(candidate.range) && (Is2.undefined(candidate.command) || Command2.is(candidate.command));
      }
      CodeLens3.is = is;
    })(CodeLens2 || (CodeLens2 = {}));
    (function(FormattingOptions3) {
      function create(tabSize, insertSpaces) {
        return { tabSize, insertSpaces };
      }
      FormattingOptions3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.defined(candidate) && Is2.uinteger(candidate.tabSize) && Is2.boolean(candidate.insertSpaces);
      }
      FormattingOptions3.is = is;
    })(FormattingOptions2 || (FormattingOptions2 = {}));
    (function(DocumentLink3) {
      function create(range, target, data) {
        return { range, target, data };
      }
      DocumentLink3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.defined(candidate) && Range2.is(candidate.range) && (Is2.undefined(candidate.target) || Is2.string(candidate.target));
      }
      DocumentLink3.is = is;
    })(DocumentLink2 || (DocumentLink2 = {}));
    (function(SelectionRange3) {
      function create(range, parent) {
        return { range, parent };
      }
      SelectionRange3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.objectLiteral(candidate) && Range2.is(candidate.range) && (candidate.parent === void 0 || SelectionRange3.is(candidate.parent));
      }
      SelectionRange3.is = is;
    })(SelectionRange2 || (SelectionRange2 = {}));
    (function(SemanticTokenTypes3) {
      SemanticTokenTypes3.namespace = "namespace", SemanticTokenTypes3.type = "type", SemanticTokenTypes3.class = "class", SemanticTokenTypes3.enum = "enum", SemanticTokenTypes3.interface = "interface", SemanticTokenTypes3.struct = "struct", SemanticTokenTypes3.typeParameter = "typeParameter", SemanticTokenTypes3.parameter = "parameter", SemanticTokenTypes3.variable = "variable", SemanticTokenTypes3.property = "property", SemanticTokenTypes3.enumMember = "enumMember", SemanticTokenTypes3.event = "event", SemanticTokenTypes3.function = "function", SemanticTokenTypes3.method = "method", SemanticTokenTypes3.macro = "macro", SemanticTokenTypes3.keyword = "keyword", SemanticTokenTypes3.modifier = "modifier", SemanticTokenTypes3.comment = "comment", SemanticTokenTypes3.string = "string", SemanticTokenTypes3.number = "number", SemanticTokenTypes3.regexp = "regexp", SemanticTokenTypes3.operator = "operator", SemanticTokenTypes3.decorator = "decorator";
    })(SemanticTokenTypes2 || (SemanticTokenTypes2 = {}));
    (function(SemanticTokenModifiers3) {
      SemanticTokenModifiers3.declaration = "declaration", SemanticTokenModifiers3.definition = "definition", SemanticTokenModifiers3.readonly = "readonly", SemanticTokenModifiers3.static = "static", SemanticTokenModifiers3.deprecated = "deprecated", SemanticTokenModifiers3.abstract = "abstract", SemanticTokenModifiers3.async = "async", SemanticTokenModifiers3.modification = "modification", SemanticTokenModifiers3.documentation = "documentation", SemanticTokenModifiers3.defaultLibrary = "defaultLibrary";
    })(SemanticTokenModifiers2 || (SemanticTokenModifiers2 = {}));
    (function(SemanticTokens3) {
      function is(value) {
        var candidate = value;
        return Is2.objectLiteral(candidate) && (candidate.resultId === void 0 || typeof candidate.resultId == "string") && Array.isArray(candidate.data) && (candidate.data.length === 0 || typeof candidate.data[0] == "number");
      }
      SemanticTokens3.is = is;
    })(SemanticTokens2 || (SemanticTokens2 = {}));
    (function(InlineValueText3) {
      function create(range, text) {
        return { range, text };
      }
      InlineValueText3.create = create;
      function is(value) {
        var candidate = value;
        return candidate != null && Range2.is(candidate.range) && Is2.string(candidate.text);
      }
      InlineValueText3.is = is;
    })(InlineValueText2 || (InlineValueText2 = {}));
    (function(InlineValueVariableLookup3) {
      function create(range, variableName, caseSensitiveLookup) {
        return { range, variableName, caseSensitiveLookup };
      }
      InlineValueVariableLookup3.create = create;
      function is(value) {
        var candidate = value;
        return candidate != null && Range2.is(candidate.range) && Is2.boolean(candidate.caseSensitiveLookup) && (Is2.string(candidate.variableName) || candidate.variableName === void 0);
      }
      InlineValueVariableLookup3.is = is;
    })(InlineValueVariableLookup2 || (InlineValueVariableLookup2 = {}));
    (function(InlineValueEvaluatableExpression3) {
      function create(range, expression) {
        return { range, expression };
      }
      InlineValueEvaluatableExpression3.create = create;
      function is(value) {
        var candidate = value;
        return candidate != null && Range2.is(candidate.range) && (Is2.string(candidate.expression) || candidate.expression === void 0);
      }
      InlineValueEvaluatableExpression3.is = is;
    })(InlineValueEvaluatableExpression2 || (InlineValueEvaluatableExpression2 = {}));
    (function(InlineValueContext3) {
      function create(frameId, stoppedLocation) {
        return { frameId, stoppedLocation };
      }
      InlineValueContext3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.defined(candidate) && Range2.is(value.stoppedLocation);
      }
      InlineValueContext3.is = is;
    })(InlineValueContext2 || (InlineValueContext2 = {}));
    (function(InlayHintKind3) {
      InlayHintKind3.Type = 1, InlayHintKind3.Parameter = 2;
      function is(value) {
        return value === 1 || value === 2;
      }
      InlayHintKind3.is = is;
    })(InlayHintKind2 || (InlayHintKind2 = {}));
    (function(InlayHintLabelPart3) {
      function create(value) {
        return { value };
      }
      InlayHintLabelPart3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.objectLiteral(candidate) && (candidate.tooltip === void 0 || Is2.string(candidate.tooltip) || MarkupContent2.is(candidate.tooltip)) && (candidate.location === void 0 || Location2.is(candidate.location)) && (candidate.command === void 0 || Command2.is(candidate.command));
      }
      InlayHintLabelPart3.is = is;
    })(InlayHintLabelPart2 || (InlayHintLabelPart2 = {}));
    (function(InlayHint3) {
      function create(position, label, kind) {
        var result = { position, label };
        return kind !== void 0 && (result.kind = kind), result;
      }
      InlayHint3.create = create;
      function is(value) {
        var candidate = value;
        return Is2.objectLiteral(candidate) && Position2.is(candidate.position) && (Is2.string(candidate.label) || Is2.typedArray(candidate.label, InlayHintLabelPart2.is)) && (candidate.kind === void 0 || InlayHintKind2.is(candidate.kind)) && candidate.textEdits === void 0 || Is2.typedArray(candidate.textEdits, TextEdit2.is) && (candidate.tooltip === void 0 || Is2.string(candidate.tooltip) || MarkupContent2.is(candidate.tooltip)) && (candidate.paddingLeft === void 0 || Is2.boolean(candidate.paddingLeft)) && (candidate.paddingRight === void 0 || Is2.boolean(candidate.paddingRight));
      }
      InlayHint3.is = is;
    })(InlayHint2 || (InlayHint2 = {}));
    (function(WorkspaceFolder3) {
      function is(value) {
        var candidate = value;
        return Is2.objectLiteral(candidate) && URI3.is(candidate.uri) && Is2.string(candidate.name);
      }
      WorkspaceFolder3.is = is;
    })(WorkspaceFolder2 || (WorkspaceFolder2 = {}));
    EOL = [`
`, `\r
`, "\r"];
    (function(TextDocument5) {
      function create(uri, languageId, version2, content) {
        return new FullTextDocument3(uri, languageId, version2, content);
      }
      TextDocument5.create = create;
      function is(value) {
        var candidate = value;
        return !!(Is2.defined(candidate) && Is2.string(candidate.uri) && (Is2.undefined(candidate.languageId) || Is2.string(candidate.languageId)) && Is2.uinteger(candidate.lineCount) && Is2.func(candidate.getText) && Is2.func(candidate.positionAt) && Is2.func(candidate.offsetAt));
      }
      TextDocument5.is = is;
      function applyEdits2(document2, edits) {
        for (var text = document2.getText(), sortedEdits = mergeSort3(edits, function(a, b) {
          var diff2 = a.range.start.line - b.range.start.line;
          return diff2 === 0 ? a.range.start.character - b.range.start.character : diff2;
        }), lastModifiedOffset = text.length, i = sortedEdits.length - 1; i >= 0; i--) {
          var e = sortedEdits[i], startOffset = document2.offsetAt(e.range.start), endOffset = document2.offsetAt(e.range.end);
          if (endOffset <= lastModifiedOffset)
            text = text.substring(0, startOffset) + e.newText + text.substring(endOffset, text.length);
          else
            throw new Error("Overlapping edit");
          lastModifiedOffset = startOffset;
        }
        return text;
      }
      TextDocument5.applyEdits = applyEdits2;
      function mergeSort3(data, compare2) {
        if (data.length <= 1)
          return data;
        var p = data.length / 2 | 0, left = data.slice(0, p), right = data.slice(p);
        mergeSort3(left, compare2), mergeSort3(right, compare2);
        for (var leftIdx = 0, rightIdx = 0, i = 0; leftIdx < left.length && rightIdx < right.length; ) {
          var ret = compare2(left[leftIdx], right[rightIdx]);
          ret <= 0 ? data[i++] = left[leftIdx++] : data[i++] = right[rightIdx++];
        }
        for (; leftIdx < left.length; )
          data[i++] = left[leftIdx++];
        for (; rightIdx < right.length; )
          data[i++] = right[rightIdx++];
        return data;
      }
    })(TextDocument3 || (TextDocument3 = {}));
    FullTextDocument3 = /** @class */
    function() {
      function FullTextDocument5(uri, languageId, version2, content) {
        this._uri = uri, this._languageId = languageId, this._version = version2, this._content = content, this._lineOffsets = void 0;
      }
      return Object.defineProperty(FullTextDocument5.prototype, "uri", {
        get: function() {
          return this._uri;
        },
        enumerable: !1,
        configurable: !0
      }), Object.defineProperty(FullTextDocument5.prototype, "languageId", {
        get: function() {
          return this._languageId;
        },
        enumerable: !1,
        configurable: !0
      }), Object.defineProperty(FullTextDocument5.prototype, "version", {
        get: function() {
          return this._version;
        },
        enumerable: !1,
        configurable: !0
      }), FullTextDocument5.prototype.getText = function(range) {
        if (range) {
          var start = this.offsetAt(range.start), end = this.offsetAt(range.end);
          return this._content.substring(start, end);
        }
        return this._content;
      }, FullTextDocument5.prototype.update = function(event, version2) {
        this._content = event.text, this._version = version2, this._lineOffsets = void 0;
      }, FullTextDocument5.prototype.getLineOffsets = function() {
        if (this._lineOffsets === void 0) {
          for (var lineOffsets = [], text = this._content, isLineStart = !0, i = 0; i < text.length; i++) {
            isLineStart && (lineOffsets.push(i), isLineStart = !1);
            var ch = text.charAt(i);
            isLineStart = ch === "\r" || ch === `
`, ch === "\r" && i + 1 < text.length && text.charAt(i + 1) === `
` && i++;
          }
          isLineStart && text.length > 0 && lineOffsets.push(text.length), this._lineOffsets = lineOffsets;
        }
        return this._lineOffsets;
      }, FullTextDocument5.prototype.positionAt = function(offset) {
        offset = Math.max(Math.min(offset, this._content.length), 0);
        var lineOffsets = this.getLineOffsets(), low = 0, high = lineOffsets.length;
        if (high === 0)
          return Position2.create(0, offset);
        for (; low < high; ) {
          var mid = Math.floor((low + high) / 2);
          lineOffsets[mid] > offset ? high = mid : low = mid + 1;
        }
        var line = low - 1;
        return Position2.create(line, offset - lineOffsets[line]);
      }, FullTextDocument5.prototype.offsetAt = function(position) {
        var lineOffsets = this.getLineOffsets();
        if (position.line >= lineOffsets.length)
          return this._content.length;
        if (position.line < 0)
          return 0;
        var lineOffset = lineOffsets[position.line], nextLineOffset = position.line + 1 < lineOffsets.length ? lineOffsets[position.line + 1] : this._content.length;
        return Math.max(Math.min(lineOffset + position.character, nextLineOffset), lineOffset);
      }, Object.defineProperty(FullTextDocument5.prototype, "lineCount", {
        get: function() {
          return this.getLineOffsets().length;
        },
        enumerable: !1,
        configurable: !0
      }), FullTextDocument5;
    }();
    (function(Is3) {
      var toString2 = Object.prototype.toString;
      function defined(value) {
        return typeof value < "u";
      }
      Is3.defined = defined;
      function undefined2(value) {
        return typeof value > "u";
      }
      Is3.undefined = undefined2;
      function boolean(value) {
        return value === !0 || value === !1;
      }
      Is3.boolean = boolean;
      function string(value) {
        return toString2.call(value) === "[object String]";
      }
      Is3.string = string;
      function number(value) {
        return toString2.call(value) === "[object Number]";
      }
      Is3.number = number;
      function numberRange(value, min, max) {
        return toString2.call(value) === "[object Number]" && min <= value && value <= max;
      }
      Is3.numberRange = numberRange;
      function integer3(value) {
        return toString2.call(value) === "[object Number]" && -2147483648 <= value && value <= 2147483647;
      }
      Is3.integer = integer3;
      function uinteger3(value) {
        return toString2.call(value) === "[object Number]" && 0 <= value && value <= 2147483647;
      }
      Is3.uinteger = uinteger3;
      function func(value) {
        return toString2.call(value) === "[object Function]";
      }
      Is3.func = func;
      function objectLiteral(value) {
        return value !== null && typeof value == "object";
      }
      Is3.objectLiteral = objectLiteral;
      function typedArray(value, check2) {
        return Array.isArray(value) && value.every(check2);
      }
      Is3.typedArray = typedArray;
    })(Is2 || (Is2 = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/messages.js
var require_messages2 = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/messages.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ProtocolNotificationType = exports.ProtocolNotificationType0 = exports.ProtocolRequestType = exports.ProtocolRequestType0 = exports.RegistrationType = exports.MessageDirection = void 0;
    var vscode_jsonrpc_1 = require_main3(), MessageDirection;
    (function(MessageDirection2) {
      MessageDirection2.clientToServer = "clientToServer", MessageDirection2.serverToClient = "serverToClient", MessageDirection2.both = "both";
    })(MessageDirection = exports.MessageDirection || (exports.MessageDirection = {}));
    var RegistrationType = class {
      constructor(method) {
        this.method = method;
      }
    };
    exports.RegistrationType = RegistrationType;
    var ProtocolRequestType0 = class extends vscode_jsonrpc_1.RequestType0 {
      constructor(method) {
        super(method);
      }
    };
    exports.ProtocolRequestType0 = ProtocolRequestType0;
    var ProtocolRequestType = class extends vscode_jsonrpc_1.RequestType {
      constructor(method) {
        super(method, vscode_jsonrpc_1.ParameterStructures.byName);
      }
    };
    exports.ProtocolRequestType = ProtocolRequestType;
    var ProtocolNotificationType0 = class extends vscode_jsonrpc_1.NotificationType0 {
      constructor(method) {
        super(method);
      }
    };
    exports.ProtocolNotificationType0 = ProtocolNotificationType0;
    var ProtocolNotificationType = class extends vscode_jsonrpc_1.NotificationType {
      constructor(method) {
        super(method, vscode_jsonrpc_1.ParameterStructures.byName);
      }
    };
    exports.ProtocolNotificationType = ProtocolNotificationType;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/utils/is.js
var require_is3 = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/utils/is.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.objectLiteral = exports.typedArray = exports.stringArray = exports.array = exports.func = exports.error = exports.number = exports.string = exports.boolean = void 0;
    function boolean(value) {
      return value === !0 || value === !1;
    }
    exports.boolean = boolean;
    function string(value) {
      return typeof value == "string" || value instanceof String;
    }
    exports.string = string;
    function number(value) {
      return typeof value == "number" || value instanceof Number;
    }
    exports.number = number;
    function error(value) {
      return value instanceof Error;
    }
    exports.error = error;
    function func(value) {
      return typeof value == "function";
    }
    exports.func = func;
    function array(value) {
      return Array.isArray(value);
    }
    exports.array = array;
    function stringArray(value) {
      return array(value) && value.every((elem) => string(elem));
    }
    exports.stringArray = stringArray;
    function typedArray(value, check2) {
      return Array.isArray(value) && value.every(check2);
    }
    exports.typedArray = typedArray;
    function objectLiteral(value) {
      return value !== null && typeof value == "object";
    }
    exports.objectLiteral = objectLiteral;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.implementation.js
var require_protocol_implementation = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.implementation.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ImplementationRequest = void 0;
    var messages_1 = require_messages2(), ImplementationRequest;
    (function(ImplementationRequest2) {
      ImplementationRequest2.method = "textDocument/implementation", ImplementationRequest2.messageDirection = messages_1.MessageDirection.clientToServer, ImplementationRequest2.type = new messages_1.ProtocolRequestType(ImplementationRequest2.method);
    })(ImplementationRequest = exports.ImplementationRequest || (exports.ImplementationRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.typeDefinition.js
var require_protocol_typeDefinition = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.typeDefinition.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.TypeDefinitionRequest = void 0;
    var messages_1 = require_messages2(), TypeDefinitionRequest;
    (function(TypeDefinitionRequest2) {
      TypeDefinitionRequest2.method = "textDocument/typeDefinition", TypeDefinitionRequest2.messageDirection = messages_1.MessageDirection.clientToServer, TypeDefinitionRequest2.type = new messages_1.ProtocolRequestType(TypeDefinitionRequest2.method);
    })(TypeDefinitionRequest = exports.TypeDefinitionRequest || (exports.TypeDefinitionRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.workspaceFolder.js
var require_protocol_workspaceFolder = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.workspaceFolder.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.DidChangeWorkspaceFoldersNotification = exports.WorkspaceFoldersRequest = void 0;
    var messages_1 = require_messages2(), WorkspaceFoldersRequest;
    (function(WorkspaceFoldersRequest2) {
      WorkspaceFoldersRequest2.method = "workspace/workspaceFolders", WorkspaceFoldersRequest2.messageDirection = messages_1.MessageDirection.serverToClient, WorkspaceFoldersRequest2.type = new messages_1.ProtocolRequestType0(WorkspaceFoldersRequest2.method);
    })(WorkspaceFoldersRequest = exports.WorkspaceFoldersRequest || (exports.WorkspaceFoldersRequest = {}));
    var DidChangeWorkspaceFoldersNotification;
    (function(DidChangeWorkspaceFoldersNotification2) {
      DidChangeWorkspaceFoldersNotification2.method = "workspace/didChangeWorkspaceFolders", DidChangeWorkspaceFoldersNotification2.messageDirection = messages_1.MessageDirection.clientToServer, DidChangeWorkspaceFoldersNotification2.type = new messages_1.ProtocolNotificationType(DidChangeWorkspaceFoldersNotification2.method);
    })(DidChangeWorkspaceFoldersNotification = exports.DidChangeWorkspaceFoldersNotification || (exports.DidChangeWorkspaceFoldersNotification = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.configuration.js
var require_protocol_configuration = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.configuration.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ConfigurationRequest = void 0;
    var messages_1 = require_messages2(), ConfigurationRequest;
    (function(ConfigurationRequest2) {
      ConfigurationRequest2.method = "workspace/configuration", ConfigurationRequest2.messageDirection = messages_1.MessageDirection.serverToClient, ConfigurationRequest2.type = new messages_1.ProtocolRequestType(ConfigurationRequest2.method);
    })(ConfigurationRequest = exports.ConfigurationRequest || (exports.ConfigurationRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.colorProvider.js
var require_protocol_colorProvider = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.colorProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ColorPresentationRequest = exports.DocumentColorRequest = void 0;
    var messages_1 = require_messages2(), DocumentColorRequest;
    (function(DocumentColorRequest2) {
      DocumentColorRequest2.method = "textDocument/documentColor", DocumentColorRequest2.messageDirection = messages_1.MessageDirection.clientToServer, DocumentColorRequest2.type = new messages_1.ProtocolRequestType(DocumentColorRequest2.method);
    })(DocumentColorRequest = exports.DocumentColorRequest || (exports.DocumentColorRequest = {}));
    var ColorPresentationRequest;
    (function(ColorPresentationRequest2) {
      ColorPresentationRequest2.method = "textDocument/colorPresentation", ColorPresentationRequest2.messageDirection = messages_1.MessageDirection.clientToServer, ColorPresentationRequest2.type = new messages_1.ProtocolRequestType(ColorPresentationRequest2.method);
    })(ColorPresentationRequest = exports.ColorPresentationRequest || (exports.ColorPresentationRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.foldingRange.js
var require_protocol_foldingRange = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.foldingRange.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.FoldingRangeRequest = void 0;
    var messages_1 = require_messages2(), FoldingRangeRequest;
    (function(FoldingRangeRequest2) {
      FoldingRangeRequest2.method = "textDocument/foldingRange", FoldingRangeRequest2.messageDirection = messages_1.MessageDirection.clientToServer, FoldingRangeRequest2.type = new messages_1.ProtocolRequestType(FoldingRangeRequest2.method);
    })(FoldingRangeRequest = exports.FoldingRangeRequest || (exports.FoldingRangeRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.declaration.js
var require_protocol_declaration = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.declaration.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.DeclarationRequest = void 0;
    var messages_1 = require_messages2(), DeclarationRequest;
    (function(DeclarationRequest2) {
      DeclarationRequest2.method = "textDocument/declaration", DeclarationRequest2.messageDirection = messages_1.MessageDirection.clientToServer, DeclarationRequest2.type = new messages_1.ProtocolRequestType(DeclarationRequest2.method);
    })(DeclarationRequest = exports.DeclarationRequest || (exports.DeclarationRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.selectionRange.js
var require_protocol_selectionRange = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.selectionRange.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.SelectionRangeRequest = void 0;
    var messages_1 = require_messages2(), SelectionRangeRequest;
    (function(SelectionRangeRequest2) {
      SelectionRangeRequest2.method = "textDocument/selectionRange", SelectionRangeRequest2.messageDirection = messages_1.MessageDirection.clientToServer, SelectionRangeRequest2.type = new messages_1.ProtocolRequestType(SelectionRangeRequest2.method);
    })(SelectionRangeRequest = exports.SelectionRangeRequest || (exports.SelectionRangeRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.progress.js
var require_protocol_progress = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.progress.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.WorkDoneProgressCancelNotification = exports.WorkDoneProgressCreateRequest = exports.WorkDoneProgress = void 0;
    var vscode_jsonrpc_1 = require_main3(), messages_1 = require_messages2(), WorkDoneProgress;
    (function(WorkDoneProgress2) {
      WorkDoneProgress2.type = new vscode_jsonrpc_1.ProgressType();
      function is(value) {
        return value === WorkDoneProgress2.type;
      }
      WorkDoneProgress2.is = is;
    })(WorkDoneProgress = exports.WorkDoneProgress || (exports.WorkDoneProgress = {}));
    var WorkDoneProgressCreateRequest;
    (function(WorkDoneProgressCreateRequest2) {
      WorkDoneProgressCreateRequest2.method = "window/workDoneProgress/create", WorkDoneProgressCreateRequest2.messageDirection = messages_1.MessageDirection.serverToClient, WorkDoneProgressCreateRequest2.type = new messages_1.ProtocolRequestType(WorkDoneProgressCreateRequest2.method);
    })(WorkDoneProgressCreateRequest = exports.WorkDoneProgressCreateRequest || (exports.WorkDoneProgressCreateRequest = {}));
    var WorkDoneProgressCancelNotification;
    (function(WorkDoneProgressCancelNotification2) {
      WorkDoneProgressCancelNotification2.method = "window/workDoneProgress/cancel", WorkDoneProgressCancelNotification2.messageDirection = messages_1.MessageDirection.clientToServer, WorkDoneProgressCancelNotification2.type = new messages_1.ProtocolNotificationType(WorkDoneProgressCancelNotification2.method);
    })(WorkDoneProgressCancelNotification = exports.WorkDoneProgressCancelNotification || (exports.WorkDoneProgressCancelNotification = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.callHierarchy.js
var require_protocol_callHierarchy = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.callHierarchy.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.CallHierarchyOutgoingCallsRequest = exports.CallHierarchyIncomingCallsRequest = exports.CallHierarchyPrepareRequest = void 0;
    var messages_1 = require_messages2(), CallHierarchyPrepareRequest;
    (function(CallHierarchyPrepareRequest2) {
      CallHierarchyPrepareRequest2.method = "textDocument/prepareCallHierarchy", CallHierarchyPrepareRequest2.messageDirection = messages_1.MessageDirection.clientToServer, CallHierarchyPrepareRequest2.type = new messages_1.ProtocolRequestType(CallHierarchyPrepareRequest2.method);
    })(CallHierarchyPrepareRequest = exports.CallHierarchyPrepareRequest || (exports.CallHierarchyPrepareRequest = {}));
    var CallHierarchyIncomingCallsRequest;
    (function(CallHierarchyIncomingCallsRequest2) {
      CallHierarchyIncomingCallsRequest2.method = "callHierarchy/incomingCalls", CallHierarchyIncomingCallsRequest2.messageDirection = messages_1.MessageDirection.clientToServer, CallHierarchyIncomingCallsRequest2.type = new messages_1.ProtocolRequestType(CallHierarchyIncomingCallsRequest2.method);
    })(CallHierarchyIncomingCallsRequest = exports.CallHierarchyIncomingCallsRequest || (exports.CallHierarchyIncomingCallsRequest = {}));
    var CallHierarchyOutgoingCallsRequest;
    (function(CallHierarchyOutgoingCallsRequest2) {
      CallHierarchyOutgoingCallsRequest2.method = "callHierarchy/outgoingCalls", CallHierarchyOutgoingCallsRequest2.messageDirection = messages_1.MessageDirection.clientToServer, CallHierarchyOutgoingCallsRequest2.type = new messages_1.ProtocolRequestType(CallHierarchyOutgoingCallsRequest2.method);
    })(CallHierarchyOutgoingCallsRequest = exports.CallHierarchyOutgoingCallsRequest || (exports.CallHierarchyOutgoingCallsRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.semanticTokens.js
var require_protocol_semanticTokens = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.semanticTokens.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.SemanticTokensRefreshRequest = exports.SemanticTokensRangeRequest = exports.SemanticTokensDeltaRequest = exports.SemanticTokensRequest = exports.SemanticTokensRegistrationType = exports.TokenFormat = void 0;
    var messages_1 = require_messages2(), TokenFormat;
    (function(TokenFormat2) {
      TokenFormat2.Relative = "relative";
    })(TokenFormat = exports.TokenFormat || (exports.TokenFormat = {}));
    var SemanticTokensRegistrationType;
    (function(SemanticTokensRegistrationType2) {
      SemanticTokensRegistrationType2.method = "textDocument/semanticTokens", SemanticTokensRegistrationType2.type = new messages_1.RegistrationType(SemanticTokensRegistrationType2.method);
    })(SemanticTokensRegistrationType = exports.SemanticTokensRegistrationType || (exports.SemanticTokensRegistrationType = {}));
    var SemanticTokensRequest;
    (function(SemanticTokensRequest2) {
      SemanticTokensRequest2.method = "textDocument/semanticTokens/full", SemanticTokensRequest2.messageDirection = messages_1.MessageDirection.clientToServer, SemanticTokensRequest2.type = new messages_1.ProtocolRequestType(SemanticTokensRequest2.method), SemanticTokensRequest2.registrationMethod = SemanticTokensRegistrationType.method;
    })(SemanticTokensRequest = exports.SemanticTokensRequest || (exports.SemanticTokensRequest = {}));
    var SemanticTokensDeltaRequest;
    (function(SemanticTokensDeltaRequest2) {
      SemanticTokensDeltaRequest2.method = "textDocument/semanticTokens/full/delta", SemanticTokensDeltaRequest2.messageDirection = messages_1.MessageDirection.clientToServer, SemanticTokensDeltaRequest2.type = new messages_1.ProtocolRequestType(SemanticTokensDeltaRequest2.method), SemanticTokensDeltaRequest2.registrationMethod = SemanticTokensRegistrationType.method;
    })(SemanticTokensDeltaRequest = exports.SemanticTokensDeltaRequest || (exports.SemanticTokensDeltaRequest = {}));
    var SemanticTokensRangeRequest;
    (function(SemanticTokensRangeRequest2) {
      SemanticTokensRangeRequest2.method = "textDocument/semanticTokens/range", SemanticTokensRangeRequest2.messageDirection = messages_1.MessageDirection.clientToServer, SemanticTokensRangeRequest2.type = new messages_1.ProtocolRequestType(SemanticTokensRangeRequest2.method), SemanticTokensRangeRequest2.registrationMethod = SemanticTokensRegistrationType.method;
    })(SemanticTokensRangeRequest = exports.SemanticTokensRangeRequest || (exports.SemanticTokensRangeRequest = {}));
    var SemanticTokensRefreshRequest;
    (function(SemanticTokensRefreshRequest2) {
      SemanticTokensRefreshRequest2.method = "workspace/semanticTokens/refresh", SemanticTokensRefreshRequest2.messageDirection = messages_1.MessageDirection.serverToClient, SemanticTokensRefreshRequest2.type = new messages_1.ProtocolRequestType0(SemanticTokensRefreshRequest2.method);
    })(SemanticTokensRefreshRequest = exports.SemanticTokensRefreshRequest || (exports.SemanticTokensRefreshRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.showDocument.js
var require_protocol_showDocument = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.showDocument.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ShowDocumentRequest = void 0;
    var messages_1 = require_messages2(), ShowDocumentRequest;
    (function(ShowDocumentRequest2) {
      ShowDocumentRequest2.method = "window/showDocument", ShowDocumentRequest2.messageDirection = messages_1.MessageDirection.serverToClient, ShowDocumentRequest2.type = new messages_1.ProtocolRequestType(ShowDocumentRequest2.method);
    })(ShowDocumentRequest = exports.ShowDocumentRequest || (exports.ShowDocumentRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.linkedEditingRange.js
var require_protocol_linkedEditingRange = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.linkedEditingRange.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.LinkedEditingRangeRequest = void 0;
    var messages_1 = require_messages2(), LinkedEditingRangeRequest;
    (function(LinkedEditingRangeRequest2) {
      LinkedEditingRangeRequest2.method = "textDocument/linkedEditingRange", LinkedEditingRangeRequest2.messageDirection = messages_1.MessageDirection.clientToServer, LinkedEditingRangeRequest2.type = new messages_1.ProtocolRequestType(LinkedEditingRangeRequest2.method);
    })(LinkedEditingRangeRequest = exports.LinkedEditingRangeRequest || (exports.LinkedEditingRangeRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.fileOperations.js
var require_protocol_fileOperations = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.fileOperations.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.WillDeleteFilesRequest = exports.DidDeleteFilesNotification = exports.DidRenameFilesNotification = exports.WillRenameFilesRequest = exports.DidCreateFilesNotification = exports.WillCreateFilesRequest = exports.FileOperationPatternKind = void 0;
    var messages_1 = require_messages2(), FileOperationPatternKind;
    (function(FileOperationPatternKind2) {
      FileOperationPatternKind2.file = "file", FileOperationPatternKind2.folder = "folder";
    })(FileOperationPatternKind = exports.FileOperationPatternKind || (exports.FileOperationPatternKind = {}));
    var WillCreateFilesRequest;
    (function(WillCreateFilesRequest2) {
      WillCreateFilesRequest2.method = "workspace/willCreateFiles", WillCreateFilesRequest2.messageDirection = messages_1.MessageDirection.clientToServer, WillCreateFilesRequest2.type = new messages_1.ProtocolRequestType(WillCreateFilesRequest2.method);
    })(WillCreateFilesRequest = exports.WillCreateFilesRequest || (exports.WillCreateFilesRequest = {}));
    var DidCreateFilesNotification;
    (function(DidCreateFilesNotification2) {
      DidCreateFilesNotification2.method = "workspace/didCreateFiles", DidCreateFilesNotification2.messageDirection = messages_1.MessageDirection.clientToServer, DidCreateFilesNotification2.type = new messages_1.ProtocolNotificationType(DidCreateFilesNotification2.method);
    })(DidCreateFilesNotification = exports.DidCreateFilesNotification || (exports.DidCreateFilesNotification = {}));
    var WillRenameFilesRequest;
    (function(WillRenameFilesRequest2) {
      WillRenameFilesRequest2.method = "workspace/willRenameFiles", WillRenameFilesRequest2.messageDirection = messages_1.MessageDirection.clientToServer, WillRenameFilesRequest2.type = new messages_1.ProtocolRequestType(WillRenameFilesRequest2.method);
    })(WillRenameFilesRequest = exports.WillRenameFilesRequest || (exports.WillRenameFilesRequest = {}));
    var DidRenameFilesNotification;
    (function(DidRenameFilesNotification2) {
      DidRenameFilesNotification2.method = "workspace/didRenameFiles", DidRenameFilesNotification2.messageDirection = messages_1.MessageDirection.clientToServer, DidRenameFilesNotification2.type = new messages_1.ProtocolNotificationType(DidRenameFilesNotification2.method);
    })(DidRenameFilesNotification = exports.DidRenameFilesNotification || (exports.DidRenameFilesNotification = {}));
    var DidDeleteFilesNotification;
    (function(DidDeleteFilesNotification2) {
      DidDeleteFilesNotification2.method = "workspace/didDeleteFiles", DidDeleteFilesNotification2.messageDirection = messages_1.MessageDirection.clientToServer, DidDeleteFilesNotification2.type = new messages_1.ProtocolNotificationType(DidDeleteFilesNotification2.method);
    })(DidDeleteFilesNotification = exports.DidDeleteFilesNotification || (exports.DidDeleteFilesNotification = {}));
    var WillDeleteFilesRequest;
    (function(WillDeleteFilesRequest2) {
      WillDeleteFilesRequest2.method = "workspace/willDeleteFiles", WillDeleteFilesRequest2.messageDirection = messages_1.MessageDirection.clientToServer, WillDeleteFilesRequest2.type = new messages_1.ProtocolRequestType(WillDeleteFilesRequest2.method);
    })(WillDeleteFilesRequest = exports.WillDeleteFilesRequest || (exports.WillDeleteFilesRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.moniker.js
var require_protocol_moniker = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.moniker.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.MonikerRequest = exports.MonikerKind = exports.UniquenessLevel = void 0;
    var messages_1 = require_messages2(), UniquenessLevel;
    (function(UniquenessLevel2) {
      UniquenessLevel2.document = "document", UniquenessLevel2.project = "project", UniquenessLevel2.group = "group", UniquenessLevel2.scheme = "scheme", UniquenessLevel2.global = "global";
    })(UniquenessLevel = exports.UniquenessLevel || (exports.UniquenessLevel = {}));
    var MonikerKind;
    (function(MonikerKind2) {
      MonikerKind2.$import = "import", MonikerKind2.$export = "export", MonikerKind2.local = "local";
    })(MonikerKind = exports.MonikerKind || (exports.MonikerKind = {}));
    var MonikerRequest;
    (function(MonikerRequest2) {
      MonikerRequest2.method = "textDocument/moniker", MonikerRequest2.messageDirection = messages_1.MessageDirection.clientToServer, MonikerRequest2.type = new messages_1.ProtocolRequestType(MonikerRequest2.method);
    })(MonikerRequest = exports.MonikerRequest || (exports.MonikerRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.typeHierarchy.js
var require_protocol_typeHierarchy = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.typeHierarchy.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.TypeHierarchySubtypesRequest = exports.TypeHierarchySupertypesRequest = exports.TypeHierarchyPrepareRequest = void 0;
    var messages_1 = require_messages2(), TypeHierarchyPrepareRequest;
    (function(TypeHierarchyPrepareRequest2) {
      TypeHierarchyPrepareRequest2.method = "textDocument/prepareTypeHierarchy", TypeHierarchyPrepareRequest2.messageDirection = messages_1.MessageDirection.clientToServer, TypeHierarchyPrepareRequest2.type = new messages_1.ProtocolRequestType(TypeHierarchyPrepareRequest2.method);
    })(TypeHierarchyPrepareRequest = exports.TypeHierarchyPrepareRequest || (exports.TypeHierarchyPrepareRequest = {}));
    var TypeHierarchySupertypesRequest;
    (function(TypeHierarchySupertypesRequest2) {
      TypeHierarchySupertypesRequest2.method = "typeHierarchy/supertypes", TypeHierarchySupertypesRequest2.messageDirection = messages_1.MessageDirection.clientToServer, TypeHierarchySupertypesRequest2.type = new messages_1.ProtocolRequestType(TypeHierarchySupertypesRequest2.method);
    })(TypeHierarchySupertypesRequest = exports.TypeHierarchySupertypesRequest || (exports.TypeHierarchySupertypesRequest = {}));
    var TypeHierarchySubtypesRequest;
    (function(TypeHierarchySubtypesRequest2) {
      TypeHierarchySubtypesRequest2.method = "typeHierarchy/subtypes", TypeHierarchySubtypesRequest2.messageDirection = messages_1.MessageDirection.clientToServer, TypeHierarchySubtypesRequest2.type = new messages_1.ProtocolRequestType(TypeHierarchySubtypesRequest2.method);
    })(TypeHierarchySubtypesRequest = exports.TypeHierarchySubtypesRequest || (exports.TypeHierarchySubtypesRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.inlineValue.js
var require_protocol_inlineValue = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.inlineValue.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.InlineValueRefreshRequest = exports.InlineValueRequest = void 0;
    var messages_1 = require_messages2(), InlineValueRequest;
    (function(InlineValueRequest2) {
      InlineValueRequest2.method = "textDocument/inlineValue", InlineValueRequest2.messageDirection = messages_1.MessageDirection.clientToServer, InlineValueRequest2.type = new messages_1.ProtocolRequestType(InlineValueRequest2.method);
    })(InlineValueRequest = exports.InlineValueRequest || (exports.InlineValueRequest = {}));
    var InlineValueRefreshRequest;
    (function(InlineValueRefreshRequest2) {
      InlineValueRefreshRequest2.method = "workspace/inlineValue/refresh", InlineValueRefreshRequest2.messageDirection = messages_1.MessageDirection.serverToClient, InlineValueRefreshRequest2.type = new messages_1.ProtocolRequestType0(InlineValueRefreshRequest2.method);
    })(InlineValueRefreshRequest = exports.InlineValueRefreshRequest || (exports.InlineValueRefreshRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.inlayHint.js
var require_protocol_inlayHint = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.inlayHint.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.InlayHintRefreshRequest = exports.InlayHintResolveRequest = exports.InlayHintRequest = void 0;
    var messages_1 = require_messages2(), InlayHintRequest;
    (function(InlayHintRequest2) {
      InlayHintRequest2.method = "textDocument/inlayHint", InlayHintRequest2.messageDirection = messages_1.MessageDirection.clientToServer, InlayHintRequest2.type = new messages_1.ProtocolRequestType(InlayHintRequest2.method);
    })(InlayHintRequest = exports.InlayHintRequest || (exports.InlayHintRequest = {}));
    var InlayHintResolveRequest;
    (function(InlayHintResolveRequest2) {
      InlayHintResolveRequest2.method = "inlayHint/resolve", InlayHintResolveRequest2.messageDirection = messages_1.MessageDirection.clientToServer, InlayHintResolveRequest2.type = new messages_1.ProtocolRequestType(InlayHintResolveRequest2.method);
    })(InlayHintResolveRequest = exports.InlayHintResolveRequest || (exports.InlayHintResolveRequest = {}));
    var InlayHintRefreshRequest;
    (function(InlayHintRefreshRequest2) {
      InlayHintRefreshRequest2.method = "workspace/inlayHint/refresh", InlayHintRefreshRequest2.messageDirection = messages_1.MessageDirection.serverToClient, InlayHintRefreshRequest2.type = new messages_1.ProtocolRequestType0(InlayHintRefreshRequest2.method);
    })(InlayHintRefreshRequest = exports.InlayHintRefreshRequest || (exports.InlayHintRefreshRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.diagnostic.js
var require_protocol_diagnostic = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.diagnostic.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.DiagnosticRefreshRequest = exports.WorkspaceDiagnosticRequest = exports.DocumentDiagnosticRequest = exports.DocumentDiagnosticReportKind = exports.DiagnosticServerCancellationData = void 0;
    var vscode_jsonrpc_1 = require_main3(), Is3 = require_is3(), messages_1 = require_messages2(), DiagnosticServerCancellationData;
    (function(DiagnosticServerCancellationData2) {
      function is(value) {
        let candidate = value;
        return candidate && Is3.boolean(candidate.retriggerRequest);
      }
      DiagnosticServerCancellationData2.is = is;
    })(DiagnosticServerCancellationData = exports.DiagnosticServerCancellationData || (exports.DiagnosticServerCancellationData = {}));
    var DocumentDiagnosticReportKind;
    (function(DocumentDiagnosticReportKind2) {
      DocumentDiagnosticReportKind2.Full = "full", DocumentDiagnosticReportKind2.Unchanged = "unchanged";
    })(DocumentDiagnosticReportKind = exports.DocumentDiagnosticReportKind || (exports.DocumentDiagnosticReportKind = {}));
    var DocumentDiagnosticRequest;
    (function(DocumentDiagnosticRequest2) {
      DocumentDiagnosticRequest2.method = "textDocument/diagnostic", DocumentDiagnosticRequest2.messageDirection = messages_1.MessageDirection.clientToServer, DocumentDiagnosticRequest2.type = new messages_1.ProtocolRequestType(DocumentDiagnosticRequest2.method), DocumentDiagnosticRequest2.partialResult = new vscode_jsonrpc_1.ProgressType();
    })(DocumentDiagnosticRequest = exports.DocumentDiagnosticRequest || (exports.DocumentDiagnosticRequest = {}));
    var WorkspaceDiagnosticRequest;
    (function(WorkspaceDiagnosticRequest2) {
      WorkspaceDiagnosticRequest2.method = "workspace/diagnostic", WorkspaceDiagnosticRequest2.messageDirection = messages_1.MessageDirection.clientToServer, WorkspaceDiagnosticRequest2.type = new messages_1.ProtocolRequestType(WorkspaceDiagnosticRequest2.method), WorkspaceDiagnosticRequest2.partialResult = new vscode_jsonrpc_1.ProgressType();
    })(WorkspaceDiagnosticRequest = exports.WorkspaceDiagnosticRequest || (exports.WorkspaceDiagnosticRequest = {}));
    var DiagnosticRefreshRequest;
    (function(DiagnosticRefreshRequest2) {
      DiagnosticRefreshRequest2.method = "workspace/diagnostic/refresh", DiagnosticRefreshRequest2.messageDirection = messages_1.MessageDirection.serverToClient, DiagnosticRefreshRequest2.type = new messages_1.ProtocolRequestType0(DiagnosticRefreshRequest2.method);
    })(DiagnosticRefreshRequest = exports.DiagnosticRefreshRequest || (exports.DiagnosticRefreshRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.notebook.js
var require_protocol_notebook = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.notebook.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.DidCloseNotebookDocumentNotification = exports.DidSaveNotebookDocumentNotification = exports.DidChangeNotebookDocumentNotification = exports.NotebookCellArrayChange = exports.DidOpenNotebookDocumentNotification = exports.NotebookDocumentSyncRegistrationType = exports.NotebookDocument = exports.NotebookCell = exports.ExecutionSummary = exports.NotebookCellKind = void 0;
    var vscode_languageserver_types_1 = (init_main4(), __toCommonJS(main_exports2)), Is3 = require_is3(), messages_1 = require_messages2(), NotebookCellKind;
    (function(NotebookCellKind2) {
      NotebookCellKind2.Markup = 1, NotebookCellKind2.Code = 2;
      function is(value) {
        return value === 1 || value === 2;
      }
      NotebookCellKind2.is = is;
    })(NotebookCellKind = exports.NotebookCellKind || (exports.NotebookCellKind = {}));
    var ExecutionSummary;
    (function(ExecutionSummary2) {
      function create(executionOrder, success) {
        let result = { executionOrder };
        return (success === !0 || success === !1) && (result.success = success), result;
      }
      ExecutionSummary2.create = create;
      function is(value) {
        let candidate = value;
        return Is3.objectLiteral(candidate) && vscode_languageserver_types_1.uinteger.is(candidate.executionOrder) && (candidate.success === void 0 || Is3.boolean(candidate.success));
      }
      ExecutionSummary2.is = is;
      function equals3(one, other) {
        return one === other ? !0 : one == null || other === null || other === void 0 ? !1 : one.executionOrder === other.executionOrder && one.success === other.success;
      }
      ExecutionSummary2.equals = equals3;
    })(ExecutionSummary = exports.ExecutionSummary || (exports.ExecutionSummary = {}));
    var NotebookCell;
    (function(NotebookCell2) {
      function create(kind, document2) {
        return { kind, document: document2 };
      }
      NotebookCell2.create = create;
      function is(value) {
        let candidate = value;
        return Is3.objectLiteral(candidate) && NotebookCellKind.is(candidate.kind) && vscode_languageserver_types_1.DocumentUri.is(candidate.document) && (candidate.metadata === void 0 || Is3.objectLiteral(candidate.metadata));
      }
      NotebookCell2.is = is;
      function diff2(one, two) {
        let result = /* @__PURE__ */ new Set();
        return one.document !== two.document && result.add("document"), one.kind !== two.kind && result.add("kind"), one.executionSummary !== two.executionSummary && result.add("executionSummary"), (one.metadata !== void 0 || two.metadata !== void 0) && !equalsMetadata(one.metadata, two.metadata) && result.add("metadata"), (one.executionSummary !== void 0 || two.executionSummary !== void 0) && !ExecutionSummary.equals(one.executionSummary, two.executionSummary) && result.add("executionSummary"), result;
      }
      NotebookCell2.diff = diff2;
      function equalsMetadata(one, other) {
        if (one === other)
          return !0;
        if (one == null || other === null || other === void 0 || typeof one != typeof other || typeof one != "object")
          return !1;
        let oneArray = Array.isArray(one), otherArray = Array.isArray(other);
        if (oneArray !== otherArray)
          return !1;
        if (oneArray && otherArray) {
          if (one.length !== other.length)
            return !1;
          for (let i = 0; i < one.length; i++)
            if (!equalsMetadata(one[i], other[i]))
              return !1;
        }
        if (Is3.objectLiteral(one) && Is3.objectLiteral(other)) {
          let oneKeys = Object.keys(one), otherKeys = Object.keys(other);
          if (oneKeys.length !== otherKeys.length || (oneKeys.sort(), otherKeys.sort(), !equalsMetadata(oneKeys, otherKeys)))
            return !1;
          for (let i = 0; i < oneKeys.length; i++) {
            let prop = oneKeys[i];
            if (!equalsMetadata(one[prop], other[prop]))
              return !1;
          }
        }
        return !0;
      }
    })(NotebookCell = exports.NotebookCell || (exports.NotebookCell = {}));
    var NotebookDocument;
    (function(NotebookDocument2) {
      function create(uri, notebookType, version2, cells) {
        return { uri, notebookType, version: version2, cells };
      }
      NotebookDocument2.create = create;
      function is(value) {
        let candidate = value;
        return Is3.objectLiteral(candidate) && Is3.string(candidate.uri) && vscode_languageserver_types_1.integer.is(candidate.version) && Is3.typedArray(candidate.cells, NotebookCell.is);
      }
      NotebookDocument2.is = is;
    })(NotebookDocument = exports.NotebookDocument || (exports.NotebookDocument = {}));
    var NotebookDocumentSyncRegistrationType;
    (function(NotebookDocumentSyncRegistrationType2) {
      NotebookDocumentSyncRegistrationType2.method = "notebookDocument/sync", NotebookDocumentSyncRegistrationType2.messageDirection = messages_1.MessageDirection.clientToServer, NotebookDocumentSyncRegistrationType2.type = new messages_1.RegistrationType(NotebookDocumentSyncRegistrationType2.method);
    })(NotebookDocumentSyncRegistrationType = exports.NotebookDocumentSyncRegistrationType || (exports.NotebookDocumentSyncRegistrationType = {}));
    var DidOpenNotebookDocumentNotification;
    (function(DidOpenNotebookDocumentNotification2) {
      DidOpenNotebookDocumentNotification2.method = "notebookDocument/didOpen", DidOpenNotebookDocumentNotification2.messageDirection = messages_1.MessageDirection.clientToServer, DidOpenNotebookDocumentNotification2.type = new messages_1.ProtocolNotificationType(DidOpenNotebookDocumentNotification2.method), DidOpenNotebookDocumentNotification2.registrationMethod = NotebookDocumentSyncRegistrationType.method;
    })(DidOpenNotebookDocumentNotification = exports.DidOpenNotebookDocumentNotification || (exports.DidOpenNotebookDocumentNotification = {}));
    var NotebookCellArrayChange;
    (function(NotebookCellArrayChange2) {
      function is(value) {
        let candidate = value;
        return Is3.objectLiteral(candidate) && vscode_languageserver_types_1.uinteger.is(candidate.start) && vscode_languageserver_types_1.uinteger.is(candidate.deleteCount) && (candidate.cells === void 0 || Is3.typedArray(candidate.cells, NotebookCell.is));
      }
      NotebookCellArrayChange2.is = is;
      function create(start, deleteCount, cells) {
        let result = { start, deleteCount };
        return cells !== void 0 && (result.cells = cells), result;
      }
      NotebookCellArrayChange2.create = create;
    })(NotebookCellArrayChange = exports.NotebookCellArrayChange || (exports.NotebookCellArrayChange = {}));
    var DidChangeNotebookDocumentNotification;
    (function(DidChangeNotebookDocumentNotification2) {
      DidChangeNotebookDocumentNotification2.method = "notebookDocument/didChange", DidChangeNotebookDocumentNotification2.messageDirection = messages_1.MessageDirection.clientToServer, DidChangeNotebookDocumentNotification2.type = new messages_1.ProtocolNotificationType(DidChangeNotebookDocumentNotification2.method), DidChangeNotebookDocumentNotification2.registrationMethod = NotebookDocumentSyncRegistrationType.method;
    })(DidChangeNotebookDocumentNotification = exports.DidChangeNotebookDocumentNotification || (exports.DidChangeNotebookDocumentNotification = {}));
    var DidSaveNotebookDocumentNotification;
    (function(DidSaveNotebookDocumentNotification2) {
      DidSaveNotebookDocumentNotification2.method = "notebookDocument/didSave", DidSaveNotebookDocumentNotification2.messageDirection = messages_1.MessageDirection.clientToServer, DidSaveNotebookDocumentNotification2.type = new messages_1.ProtocolNotificationType(DidSaveNotebookDocumentNotification2.method), DidSaveNotebookDocumentNotification2.registrationMethod = NotebookDocumentSyncRegistrationType.method;
    })(DidSaveNotebookDocumentNotification = exports.DidSaveNotebookDocumentNotification || (exports.DidSaveNotebookDocumentNotification = {}));
    var DidCloseNotebookDocumentNotification;
    (function(DidCloseNotebookDocumentNotification2) {
      DidCloseNotebookDocumentNotification2.method = "notebookDocument/didClose", DidCloseNotebookDocumentNotification2.messageDirection = messages_1.MessageDirection.clientToServer, DidCloseNotebookDocumentNotification2.type = new messages_1.ProtocolNotificationType(DidCloseNotebookDocumentNotification2.method), DidCloseNotebookDocumentNotification2.registrationMethod = NotebookDocumentSyncRegistrationType.method;
    })(DidCloseNotebookDocumentNotification = exports.DidCloseNotebookDocumentNotification || (exports.DidCloseNotebookDocumentNotification = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.js
var require_protocol = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/protocol.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.WorkspaceSymbolRequest = exports.CodeActionResolveRequest = exports.CodeActionRequest = exports.DocumentSymbolRequest = exports.DocumentHighlightRequest = exports.ReferencesRequest = exports.DefinitionRequest = exports.SignatureHelpRequest = exports.SignatureHelpTriggerKind = exports.HoverRequest = exports.CompletionResolveRequest = exports.CompletionRequest = exports.CompletionTriggerKind = exports.PublishDiagnosticsNotification = exports.WatchKind = exports.RelativePattern = exports.FileChangeType = exports.DidChangeWatchedFilesNotification = exports.WillSaveTextDocumentWaitUntilRequest = exports.WillSaveTextDocumentNotification = exports.TextDocumentSaveReason = exports.DidSaveTextDocumentNotification = exports.DidCloseTextDocumentNotification = exports.DidChangeTextDocumentNotification = exports.TextDocumentContentChangeEvent = exports.DidOpenTextDocumentNotification = exports.TextDocumentSyncKind = exports.TelemetryEventNotification = exports.LogMessageNotification = exports.ShowMessageRequest = exports.ShowMessageNotification = exports.MessageType = exports.DidChangeConfigurationNotification = exports.ExitNotification = exports.ShutdownRequest = exports.InitializedNotification = exports.InitializeErrorCodes = exports.InitializeRequest = exports.WorkDoneProgressOptions = exports.TextDocumentRegistrationOptions = exports.StaticRegistrationOptions = exports.PositionEncodingKind = exports.FailureHandlingKind = exports.ResourceOperationKind = exports.UnregistrationRequest = exports.RegistrationRequest = exports.DocumentSelector = exports.NotebookCellTextDocumentFilter = exports.NotebookDocumentFilter = exports.TextDocumentFilter = void 0;
    exports.TypeHierarchySubtypesRequest = exports.TypeHierarchyPrepareRequest = exports.MonikerRequest = exports.MonikerKind = exports.UniquenessLevel = exports.WillDeleteFilesRequest = exports.DidDeleteFilesNotification = exports.WillRenameFilesRequest = exports.DidRenameFilesNotification = exports.WillCreateFilesRequest = exports.DidCreateFilesNotification = exports.FileOperationPatternKind = exports.LinkedEditingRangeRequest = exports.ShowDocumentRequest = exports.SemanticTokensRegistrationType = exports.SemanticTokensRefreshRequest = exports.SemanticTokensRangeRequest = exports.SemanticTokensDeltaRequest = exports.SemanticTokensRequest = exports.TokenFormat = exports.CallHierarchyPrepareRequest = exports.CallHierarchyOutgoingCallsRequest = exports.CallHierarchyIncomingCallsRequest = exports.WorkDoneProgressCancelNotification = exports.WorkDoneProgressCreateRequest = exports.WorkDoneProgress = exports.SelectionRangeRequest = exports.DeclarationRequest = exports.FoldingRangeRequest = exports.ColorPresentationRequest = exports.DocumentColorRequest = exports.ConfigurationRequest = exports.DidChangeWorkspaceFoldersNotification = exports.WorkspaceFoldersRequest = exports.TypeDefinitionRequest = exports.ImplementationRequest = exports.ApplyWorkspaceEditRequest = exports.ExecuteCommandRequest = exports.PrepareRenameRequest = exports.RenameRequest = exports.PrepareSupportDefaultBehavior = exports.DocumentOnTypeFormattingRequest = exports.DocumentRangeFormattingRequest = exports.DocumentFormattingRequest = exports.DocumentLinkResolveRequest = exports.DocumentLinkRequest = exports.CodeLensRefreshRequest = exports.CodeLensResolveRequest = exports.CodeLensRequest = exports.WorkspaceSymbolResolveRequest = void 0;
    exports.DidCloseNotebookDocumentNotification = exports.DidSaveNotebookDocumentNotification = exports.DidChangeNotebookDocumentNotification = exports.NotebookCellArrayChange = exports.DidOpenNotebookDocumentNotification = exports.NotebookDocumentSyncRegistrationType = exports.NotebookDocument = exports.NotebookCell = exports.ExecutionSummary = exports.NotebookCellKind = exports.DiagnosticRefreshRequest = exports.WorkspaceDiagnosticRequest = exports.DocumentDiagnosticRequest = exports.DocumentDiagnosticReportKind = exports.DiagnosticServerCancellationData = exports.InlayHintRefreshRequest = exports.InlayHintResolveRequest = exports.InlayHintRequest = exports.InlineValueRefreshRequest = exports.InlineValueRequest = exports.TypeHierarchySupertypesRequest = void 0;
    var messages_1 = require_messages2(), vscode_languageserver_types_1 = (init_main4(), __toCommonJS(main_exports2)), Is3 = require_is3(), protocol_implementation_1 = require_protocol_implementation();
    Object.defineProperty(exports, "ImplementationRequest", { enumerable: !0, get: function() {
      return protocol_implementation_1.ImplementationRequest;
    } });
    var protocol_typeDefinition_1 = require_protocol_typeDefinition();
    Object.defineProperty(exports, "TypeDefinitionRequest", { enumerable: !0, get: function() {
      return protocol_typeDefinition_1.TypeDefinitionRequest;
    } });
    var protocol_workspaceFolder_1 = require_protocol_workspaceFolder();
    Object.defineProperty(exports, "WorkspaceFoldersRequest", { enumerable: !0, get: function() {
      return protocol_workspaceFolder_1.WorkspaceFoldersRequest;
    } });
    Object.defineProperty(exports, "DidChangeWorkspaceFoldersNotification", { enumerable: !0, get: function() {
      return protocol_workspaceFolder_1.DidChangeWorkspaceFoldersNotification;
    } });
    var protocol_configuration_1 = require_protocol_configuration();
    Object.defineProperty(exports, "ConfigurationRequest", { enumerable: !0, get: function() {
      return protocol_configuration_1.ConfigurationRequest;
    } });
    var protocol_colorProvider_1 = require_protocol_colorProvider();
    Object.defineProperty(exports, "DocumentColorRequest", { enumerable: !0, get: function() {
      return protocol_colorProvider_1.DocumentColorRequest;
    } });
    Object.defineProperty(exports, "ColorPresentationRequest", { enumerable: !0, get: function() {
      return protocol_colorProvider_1.ColorPresentationRequest;
    } });
    var protocol_foldingRange_1 = require_protocol_foldingRange();
    Object.defineProperty(exports, "FoldingRangeRequest", { enumerable: !0, get: function() {
      return protocol_foldingRange_1.FoldingRangeRequest;
    } });
    var protocol_declaration_1 = require_protocol_declaration();
    Object.defineProperty(exports, "DeclarationRequest", { enumerable: !0, get: function() {
      return protocol_declaration_1.DeclarationRequest;
    } });
    var protocol_selectionRange_1 = require_protocol_selectionRange();
    Object.defineProperty(exports, "SelectionRangeRequest", { enumerable: !0, get: function() {
      return protocol_selectionRange_1.SelectionRangeRequest;
    } });
    var protocol_progress_1 = require_protocol_progress();
    Object.defineProperty(exports, "WorkDoneProgress", { enumerable: !0, get: function() {
      return protocol_progress_1.WorkDoneProgress;
    } });
    Object.defineProperty(exports, "WorkDoneProgressCreateRequest", { enumerable: !0, get: function() {
      return protocol_progress_1.WorkDoneProgressCreateRequest;
    } });
    Object.defineProperty(exports, "WorkDoneProgressCancelNotification", { enumerable: !0, get: function() {
      return protocol_progress_1.WorkDoneProgressCancelNotification;
    } });
    var protocol_callHierarchy_1 = require_protocol_callHierarchy();
    Object.defineProperty(exports, "CallHierarchyIncomingCallsRequest", { enumerable: !0, get: function() {
      return protocol_callHierarchy_1.CallHierarchyIncomingCallsRequest;
    } });
    Object.defineProperty(exports, "CallHierarchyOutgoingCallsRequest", { enumerable: !0, get: function() {
      return protocol_callHierarchy_1.CallHierarchyOutgoingCallsRequest;
    } });
    Object.defineProperty(exports, "CallHierarchyPrepareRequest", { enumerable: !0, get: function() {
      return protocol_callHierarchy_1.CallHierarchyPrepareRequest;
    } });
    var protocol_semanticTokens_1 = require_protocol_semanticTokens();
    Object.defineProperty(exports, "TokenFormat", { enumerable: !0, get: function() {
      return protocol_semanticTokens_1.TokenFormat;
    } });
    Object.defineProperty(exports, "SemanticTokensRequest", { enumerable: !0, get: function() {
      return protocol_semanticTokens_1.SemanticTokensRequest;
    } });
    Object.defineProperty(exports, "SemanticTokensDeltaRequest", { enumerable: !0, get: function() {
      return protocol_semanticTokens_1.SemanticTokensDeltaRequest;
    } });
    Object.defineProperty(exports, "SemanticTokensRangeRequest", { enumerable: !0, get: function() {
      return protocol_semanticTokens_1.SemanticTokensRangeRequest;
    } });
    Object.defineProperty(exports, "SemanticTokensRefreshRequest", { enumerable: !0, get: function() {
      return protocol_semanticTokens_1.SemanticTokensRefreshRequest;
    } });
    Object.defineProperty(exports, "SemanticTokensRegistrationType", { enumerable: !0, get: function() {
      return protocol_semanticTokens_1.SemanticTokensRegistrationType;
    } });
    var protocol_showDocument_1 = require_protocol_showDocument();
    Object.defineProperty(exports, "ShowDocumentRequest", { enumerable: !0, get: function() {
      return protocol_showDocument_1.ShowDocumentRequest;
    } });
    var protocol_linkedEditingRange_1 = require_protocol_linkedEditingRange();
    Object.defineProperty(exports, "LinkedEditingRangeRequest", { enumerable: !0, get: function() {
      return protocol_linkedEditingRange_1.LinkedEditingRangeRequest;
    } });
    var protocol_fileOperations_1 = require_protocol_fileOperations();
    Object.defineProperty(exports, "FileOperationPatternKind", { enumerable: !0, get: function() {
      return protocol_fileOperations_1.FileOperationPatternKind;
    } });
    Object.defineProperty(exports, "DidCreateFilesNotification", { enumerable: !0, get: function() {
      return protocol_fileOperations_1.DidCreateFilesNotification;
    } });
    Object.defineProperty(exports, "WillCreateFilesRequest", { enumerable: !0, get: function() {
      return protocol_fileOperations_1.WillCreateFilesRequest;
    } });
    Object.defineProperty(exports, "DidRenameFilesNotification", { enumerable: !0, get: function() {
      return protocol_fileOperations_1.DidRenameFilesNotification;
    } });
    Object.defineProperty(exports, "WillRenameFilesRequest", { enumerable: !0, get: function() {
      return protocol_fileOperations_1.WillRenameFilesRequest;
    } });
    Object.defineProperty(exports, "DidDeleteFilesNotification", { enumerable: !0, get: function() {
      return protocol_fileOperations_1.DidDeleteFilesNotification;
    } });
    Object.defineProperty(exports, "WillDeleteFilesRequest", { enumerable: !0, get: function() {
      return protocol_fileOperations_1.WillDeleteFilesRequest;
    } });
    var protocol_moniker_1 = require_protocol_moniker();
    Object.defineProperty(exports, "UniquenessLevel", { enumerable: !0, get: function() {
      return protocol_moniker_1.UniquenessLevel;
    } });
    Object.defineProperty(exports, "MonikerKind", { enumerable: !0, get: function() {
      return protocol_moniker_1.MonikerKind;
    } });
    Object.defineProperty(exports, "MonikerRequest", { enumerable: !0, get: function() {
      return protocol_moniker_1.MonikerRequest;
    } });
    var protocol_typeHierarchy_1 = require_protocol_typeHierarchy();
    Object.defineProperty(exports, "TypeHierarchyPrepareRequest", { enumerable: !0, get: function() {
      return protocol_typeHierarchy_1.TypeHierarchyPrepareRequest;
    } });
    Object.defineProperty(exports, "TypeHierarchySubtypesRequest", { enumerable: !0, get: function() {
      return protocol_typeHierarchy_1.TypeHierarchySubtypesRequest;
    } });
    Object.defineProperty(exports, "TypeHierarchySupertypesRequest", { enumerable: !0, get: function() {
      return protocol_typeHierarchy_1.TypeHierarchySupertypesRequest;
    } });
    var protocol_inlineValue_1 = require_protocol_inlineValue();
    Object.defineProperty(exports, "InlineValueRequest", { enumerable: !0, get: function() {
      return protocol_inlineValue_1.InlineValueRequest;
    } });
    Object.defineProperty(exports, "InlineValueRefreshRequest", { enumerable: !0, get: function() {
      return protocol_inlineValue_1.InlineValueRefreshRequest;
    } });
    var protocol_inlayHint_1 = require_protocol_inlayHint();
    Object.defineProperty(exports, "InlayHintRequest", { enumerable: !0, get: function() {
      return protocol_inlayHint_1.InlayHintRequest;
    } });
    Object.defineProperty(exports, "InlayHintResolveRequest", { enumerable: !0, get: function() {
      return protocol_inlayHint_1.InlayHintResolveRequest;
    } });
    Object.defineProperty(exports, "InlayHintRefreshRequest", { enumerable: !0, get: function() {
      return protocol_inlayHint_1.InlayHintRefreshRequest;
    } });
    var protocol_diagnostic_1 = require_protocol_diagnostic();
    Object.defineProperty(exports, "DiagnosticServerCancellationData", { enumerable: !0, get: function() {
      return protocol_diagnostic_1.DiagnosticServerCancellationData;
    } });
    Object.defineProperty(exports, "DocumentDiagnosticReportKind", { enumerable: !0, get: function() {
      return protocol_diagnostic_1.DocumentDiagnosticReportKind;
    } });
    Object.defineProperty(exports, "DocumentDiagnosticRequest", { enumerable: !0, get: function() {
      return protocol_diagnostic_1.DocumentDiagnosticRequest;
    } });
    Object.defineProperty(exports, "WorkspaceDiagnosticRequest", { enumerable: !0, get: function() {
      return protocol_diagnostic_1.WorkspaceDiagnosticRequest;
    } });
    Object.defineProperty(exports, "DiagnosticRefreshRequest", { enumerable: !0, get: function() {
      return protocol_diagnostic_1.DiagnosticRefreshRequest;
    } });
    var protocol_notebook_1 = require_protocol_notebook();
    Object.defineProperty(exports, "NotebookCellKind", { enumerable: !0, get: function() {
      return protocol_notebook_1.NotebookCellKind;
    } });
    Object.defineProperty(exports, "ExecutionSummary", { enumerable: !0, get: function() {
      return protocol_notebook_1.ExecutionSummary;
    } });
    Object.defineProperty(exports, "NotebookCell", { enumerable: !0, get: function() {
      return protocol_notebook_1.NotebookCell;
    } });
    Object.defineProperty(exports, "NotebookDocument", { enumerable: !0, get: function() {
      return protocol_notebook_1.NotebookDocument;
    } });
    Object.defineProperty(exports, "NotebookDocumentSyncRegistrationType", { enumerable: !0, get: function() {
      return protocol_notebook_1.NotebookDocumentSyncRegistrationType;
    } });
    Object.defineProperty(exports, "DidOpenNotebookDocumentNotification", { enumerable: !0, get: function() {
      return protocol_notebook_1.DidOpenNotebookDocumentNotification;
    } });
    Object.defineProperty(exports, "NotebookCellArrayChange", { enumerable: !0, get: function() {
      return protocol_notebook_1.NotebookCellArrayChange;
    } });
    Object.defineProperty(exports, "DidChangeNotebookDocumentNotification", { enumerable: !0, get: function() {
      return protocol_notebook_1.DidChangeNotebookDocumentNotification;
    } });
    Object.defineProperty(exports, "DidSaveNotebookDocumentNotification", { enumerable: !0, get: function() {
      return protocol_notebook_1.DidSaveNotebookDocumentNotification;
    } });
    Object.defineProperty(exports, "DidCloseNotebookDocumentNotification", { enumerable: !0, get: function() {
      return protocol_notebook_1.DidCloseNotebookDocumentNotification;
    } });
    var TextDocumentFilter;
    (function(TextDocumentFilter2) {
      function is(value) {
        let candidate = value;
        return Is3.string(candidate.language) || Is3.string(candidate.scheme) || Is3.string(candidate.pattern);
      }
      TextDocumentFilter2.is = is;
    })(TextDocumentFilter = exports.TextDocumentFilter || (exports.TextDocumentFilter = {}));
    var NotebookDocumentFilter;
    (function(NotebookDocumentFilter2) {
      function is(value) {
        let candidate = value;
        return Is3.objectLiteral(candidate) && (Is3.string(candidate.notebookType) || Is3.string(candidate.scheme) || Is3.string(candidate.pattern));
      }
      NotebookDocumentFilter2.is = is;
    })(NotebookDocumentFilter = exports.NotebookDocumentFilter || (exports.NotebookDocumentFilter = {}));
    var NotebookCellTextDocumentFilter;
    (function(NotebookCellTextDocumentFilter2) {
      function is(value) {
        let candidate = value;
        return Is3.objectLiteral(candidate) && (Is3.string(candidate.notebook) || NotebookDocumentFilter.is(candidate.notebook)) && (candidate.language === void 0 || Is3.string(candidate.language));
      }
      NotebookCellTextDocumentFilter2.is = is;
    })(NotebookCellTextDocumentFilter = exports.NotebookCellTextDocumentFilter || (exports.NotebookCellTextDocumentFilter = {}));
    var DocumentSelector;
    (function(DocumentSelector2) {
      function is(value) {
        if (!Array.isArray(value))
          return !1;
        for (let elem of value)
          if (!Is3.string(elem) && !TextDocumentFilter.is(elem) && !NotebookCellTextDocumentFilter.is(elem))
            return !1;
        return !0;
      }
      DocumentSelector2.is = is;
    })(DocumentSelector = exports.DocumentSelector || (exports.DocumentSelector = {}));
    var RegistrationRequest;
    (function(RegistrationRequest2) {
      RegistrationRequest2.method = "client/registerCapability", RegistrationRequest2.messageDirection = messages_1.MessageDirection.serverToClient, RegistrationRequest2.type = new messages_1.ProtocolRequestType(RegistrationRequest2.method);
    })(RegistrationRequest = exports.RegistrationRequest || (exports.RegistrationRequest = {}));
    var UnregistrationRequest;
    (function(UnregistrationRequest2) {
      UnregistrationRequest2.method = "client/unregisterCapability", UnregistrationRequest2.messageDirection = messages_1.MessageDirection.serverToClient, UnregistrationRequest2.type = new messages_1.ProtocolRequestType(UnregistrationRequest2.method);
    })(UnregistrationRequest = exports.UnregistrationRequest || (exports.UnregistrationRequest = {}));
    var ResourceOperationKind;
    (function(ResourceOperationKind2) {
      ResourceOperationKind2.Create = "create", ResourceOperationKind2.Rename = "rename", ResourceOperationKind2.Delete = "delete";
    })(ResourceOperationKind = exports.ResourceOperationKind || (exports.ResourceOperationKind = {}));
    var FailureHandlingKind;
    (function(FailureHandlingKind2) {
      FailureHandlingKind2.Abort = "abort", FailureHandlingKind2.Transactional = "transactional", FailureHandlingKind2.TextOnlyTransactional = "textOnlyTransactional", FailureHandlingKind2.Undo = "undo";
    })(FailureHandlingKind = exports.FailureHandlingKind || (exports.FailureHandlingKind = {}));
    var PositionEncodingKind;
    (function(PositionEncodingKind2) {
      PositionEncodingKind2.UTF8 = "utf-8", PositionEncodingKind2.UTF16 = "utf-16", PositionEncodingKind2.UTF32 = "utf-32";
    })(PositionEncodingKind = exports.PositionEncodingKind || (exports.PositionEncodingKind = {}));
    var StaticRegistrationOptions;
    (function(StaticRegistrationOptions2) {
      function hasId(value) {
        let candidate = value;
        return candidate && Is3.string(candidate.id) && candidate.id.length > 0;
      }
      StaticRegistrationOptions2.hasId = hasId;
    })(StaticRegistrationOptions = exports.StaticRegistrationOptions || (exports.StaticRegistrationOptions = {}));
    var TextDocumentRegistrationOptions;
    (function(TextDocumentRegistrationOptions2) {
      function is(value) {
        let candidate = value;
        return candidate && (candidate.documentSelector === null || DocumentSelector.is(candidate.documentSelector));
      }
      TextDocumentRegistrationOptions2.is = is;
    })(TextDocumentRegistrationOptions = exports.TextDocumentRegistrationOptions || (exports.TextDocumentRegistrationOptions = {}));
    var WorkDoneProgressOptions;
    (function(WorkDoneProgressOptions2) {
      function is(value) {
        let candidate = value;
        return Is3.objectLiteral(candidate) && (candidate.workDoneProgress === void 0 || Is3.boolean(candidate.workDoneProgress));
      }
      WorkDoneProgressOptions2.is = is;
      function hasWorkDoneProgress(value) {
        let candidate = value;
        return candidate && Is3.boolean(candidate.workDoneProgress);
      }
      WorkDoneProgressOptions2.hasWorkDoneProgress = hasWorkDoneProgress;
    })(WorkDoneProgressOptions = exports.WorkDoneProgressOptions || (exports.WorkDoneProgressOptions = {}));
    var InitializeRequest;
    (function(InitializeRequest2) {
      InitializeRequest2.method = "initialize", InitializeRequest2.messageDirection = messages_1.MessageDirection.clientToServer, InitializeRequest2.type = new messages_1.ProtocolRequestType(InitializeRequest2.method);
    })(InitializeRequest = exports.InitializeRequest || (exports.InitializeRequest = {}));
    var InitializeErrorCodes;
    (function(InitializeErrorCodes2) {
      InitializeErrorCodes2.unknownProtocolVersion = 1;
    })(InitializeErrorCodes = exports.InitializeErrorCodes || (exports.InitializeErrorCodes = {}));
    var InitializedNotification;
    (function(InitializedNotification2) {
      InitializedNotification2.method = "initialized", InitializedNotification2.messageDirection = messages_1.MessageDirection.clientToServer, InitializedNotification2.type = new messages_1.ProtocolNotificationType(InitializedNotification2.method);
    })(InitializedNotification = exports.InitializedNotification || (exports.InitializedNotification = {}));
    var ShutdownRequest;
    (function(ShutdownRequest2) {
      ShutdownRequest2.method = "shutdown", ShutdownRequest2.messageDirection = messages_1.MessageDirection.clientToServer, ShutdownRequest2.type = new messages_1.ProtocolRequestType0(ShutdownRequest2.method);
    })(ShutdownRequest = exports.ShutdownRequest || (exports.ShutdownRequest = {}));
    var ExitNotification;
    (function(ExitNotification2) {
      ExitNotification2.method = "exit", ExitNotification2.messageDirection = messages_1.MessageDirection.clientToServer, ExitNotification2.type = new messages_1.ProtocolNotificationType0(ExitNotification2.method);
    })(ExitNotification = exports.ExitNotification || (exports.ExitNotification = {}));
    var DidChangeConfigurationNotification;
    (function(DidChangeConfigurationNotification2) {
      DidChangeConfigurationNotification2.method = "workspace/didChangeConfiguration", DidChangeConfigurationNotification2.messageDirection = messages_1.MessageDirection.clientToServer, DidChangeConfigurationNotification2.type = new messages_1.ProtocolNotificationType(DidChangeConfigurationNotification2.method);
    })(DidChangeConfigurationNotification = exports.DidChangeConfigurationNotification || (exports.DidChangeConfigurationNotification = {}));
    var MessageType;
    (function(MessageType2) {
      MessageType2.Error = 1, MessageType2.Warning = 2, MessageType2.Info = 3, MessageType2.Log = 4;
    })(MessageType = exports.MessageType || (exports.MessageType = {}));
    var ShowMessageNotification;
    (function(ShowMessageNotification2) {
      ShowMessageNotification2.method = "window/showMessage", ShowMessageNotification2.messageDirection = messages_1.MessageDirection.serverToClient, ShowMessageNotification2.type = new messages_1.ProtocolNotificationType(ShowMessageNotification2.method);
    })(ShowMessageNotification = exports.ShowMessageNotification || (exports.ShowMessageNotification = {}));
    var ShowMessageRequest;
    (function(ShowMessageRequest2) {
      ShowMessageRequest2.method = "window/showMessageRequest", ShowMessageRequest2.messageDirection = messages_1.MessageDirection.serverToClient, ShowMessageRequest2.type = new messages_1.ProtocolRequestType(ShowMessageRequest2.method);
    })(ShowMessageRequest = exports.ShowMessageRequest || (exports.ShowMessageRequest = {}));
    var LogMessageNotification;
    (function(LogMessageNotification2) {
      LogMessageNotification2.method = "window/logMessage", LogMessageNotification2.messageDirection = messages_1.MessageDirection.serverToClient, LogMessageNotification2.type = new messages_1.ProtocolNotificationType(LogMessageNotification2.method);
    })(LogMessageNotification = exports.LogMessageNotification || (exports.LogMessageNotification = {}));
    var TelemetryEventNotification;
    (function(TelemetryEventNotification2) {
      TelemetryEventNotification2.method = "telemetry/event", TelemetryEventNotification2.messageDirection = messages_1.MessageDirection.serverToClient, TelemetryEventNotification2.type = new messages_1.ProtocolNotificationType(TelemetryEventNotification2.method);
    })(TelemetryEventNotification = exports.TelemetryEventNotification || (exports.TelemetryEventNotification = {}));
    var TextDocumentSyncKind;
    (function(TextDocumentSyncKind2) {
      TextDocumentSyncKind2.None = 0, TextDocumentSyncKind2.Full = 1, TextDocumentSyncKind2.Incremental = 2;
    })(TextDocumentSyncKind = exports.TextDocumentSyncKind || (exports.TextDocumentSyncKind = {}));
    var DidOpenTextDocumentNotification;
    (function(DidOpenTextDocumentNotification2) {
      DidOpenTextDocumentNotification2.method = "textDocument/didOpen", DidOpenTextDocumentNotification2.messageDirection = messages_1.MessageDirection.clientToServer, DidOpenTextDocumentNotification2.type = new messages_1.ProtocolNotificationType(DidOpenTextDocumentNotification2.method);
    })(DidOpenTextDocumentNotification = exports.DidOpenTextDocumentNotification || (exports.DidOpenTextDocumentNotification = {}));
    var TextDocumentContentChangeEvent;
    (function(TextDocumentContentChangeEvent2) {
      function isIncremental(event) {
        let candidate = event;
        return candidate != null && typeof candidate.text == "string" && candidate.range !== void 0 && (candidate.rangeLength === void 0 || typeof candidate.rangeLength == "number");
      }
      TextDocumentContentChangeEvent2.isIncremental = isIncremental;
      function isFull(event) {
        let candidate = event;
        return candidate != null && typeof candidate.text == "string" && candidate.range === void 0 && candidate.rangeLength === void 0;
      }
      TextDocumentContentChangeEvent2.isFull = isFull;
    })(TextDocumentContentChangeEvent = exports.TextDocumentContentChangeEvent || (exports.TextDocumentContentChangeEvent = {}));
    var DidChangeTextDocumentNotification;
    (function(DidChangeTextDocumentNotification2) {
      DidChangeTextDocumentNotification2.method = "textDocument/didChange", DidChangeTextDocumentNotification2.messageDirection = messages_1.MessageDirection.clientToServer, DidChangeTextDocumentNotification2.type = new messages_1.ProtocolNotificationType(DidChangeTextDocumentNotification2.method);
    })(DidChangeTextDocumentNotification = exports.DidChangeTextDocumentNotification || (exports.DidChangeTextDocumentNotification = {}));
    var DidCloseTextDocumentNotification;
    (function(DidCloseTextDocumentNotification2) {
      DidCloseTextDocumentNotification2.method = "textDocument/didClose", DidCloseTextDocumentNotification2.messageDirection = messages_1.MessageDirection.clientToServer, DidCloseTextDocumentNotification2.type = new messages_1.ProtocolNotificationType(DidCloseTextDocumentNotification2.method);
    })(DidCloseTextDocumentNotification = exports.DidCloseTextDocumentNotification || (exports.DidCloseTextDocumentNotification = {}));
    var DidSaveTextDocumentNotification;
    (function(DidSaveTextDocumentNotification2) {
      DidSaveTextDocumentNotification2.method = "textDocument/didSave", DidSaveTextDocumentNotification2.messageDirection = messages_1.MessageDirection.clientToServer, DidSaveTextDocumentNotification2.type = new messages_1.ProtocolNotificationType(DidSaveTextDocumentNotification2.method);
    })(DidSaveTextDocumentNotification = exports.DidSaveTextDocumentNotification || (exports.DidSaveTextDocumentNotification = {}));
    var TextDocumentSaveReason;
    (function(TextDocumentSaveReason2) {
      TextDocumentSaveReason2.Manual = 1, TextDocumentSaveReason2.AfterDelay = 2, TextDocumentSaveReason2.FocusOut = 3;
    })(TextDocumentSaveReason = exports.TextDocumentSaveReason || (exports.TextDocumentSaveReason = {}));
    var WillSaveTextDocumentNotification;
    (function(WillSaveTextDocumentNotification2) {
      WillSaveTextDocumentNotification2.method = "textDocument/willSave", WillSaveTextDocumentNotification2.messageDirection = messages_1.MessageDirection.clientToServer, WillSaveTextDocumentNotification2.type = new messages_1.ProtocolNotificationType(WillSaveTextDocumentNotification2.method);
    })(WillSaveTextDocumentNotification = exports.WillSaveTextDocumentNotification || (exports.WillSaveTextDocumentNotification = {}));
    var WillSaveTextDocumentWaitUntilRequest;
    (function(WillSaveTextDocumentWaitUntilRequest2) {
      WillSaveTextDocumentWaitUntilRequest2.method = "textDocument/willSaveWaitUntil", WillSaveTextDocumentWaitUntilRequest2.messageDirection = messages_1.MessageDirection.clientToServer, WillSaveTextDocumentWaitUntilRequest2.type = new messages_1.ProtocolRequestType(WillSaveTextDocumentWaitUntilRequest2.method);
    })(WillSaveTextDocumentWaitUntilRequest = exports.WillSaveTextDocumentWaitUntilRequest || (exports.WillSaveTextDocumentWaitUntilRequest = {}));
    var DidChangeWatchedFilesNotification;
    (function(DidChangeWatchedFilesNotification2) {
      DidChangeWatchedFilesNotification2.method = "workspace/didChangeWatchedFiles", DidChangeWatchedFilesNotification2.messageDirection = messages_1.MessageDirection.clientToServer, DidChangeWatchedFilesNotification2.type = new messages_1.ProtocolNotificationType(DidChangeWatchedFilesNotification2.method);
    })(DidChangeWatchedFilesNotification = exports.DidChangeWatchedFilesNotification || (exports.DidChangeWatchedFilesNotification = {}));
    var FileChangeType;
    (function(FileChangeType2) {
      FileChangeType2.Created = 1, FileChangeType2.Changed = 2, FileChangeType2.Deleted = 3;
    })(FileChangeType = exports.FileChangeType || (exports.FileChangeType = {}));
    var RelativePattern;
    (function(RelativePattern2) {
      function is(value) {
        let candidate = value;
        return Is3.objectLiteral(candidate) && (vscode_languageserver_types_1.URI.is(candidate.baseUri) || vscode_languageserver_types_1.WorkspaceFolder.is(candidate.baseUri)) && Is3.string(candidate.pattern);
      }
      RelativePattern2.is = is;
    })(RelativePattern = exports.RelativePattern || (exports.RelativePattern = {}));
    var WatchKind;
    (function(WatchKind2) {
      WatchKind2.Create = 1, WatchKind2.Change = 2, WatchKind2.Delete = 4;
    })(WatchKind = exports.WatchKind || (exports.WatchKind = {}));
    var PublishDiagnosticsNotification;
    (function(PublishDiagnosticsNotification2) {
      PublishDiagnosticsNotification2.method = "textDocument/publishDiagnostics", PublishDiagnosticsNotification2.messageDirection = messages_1.MessageDirection.serverToClient, PublishDiagnosticsNotification2.type = new messages_1.ProtocolNotificationType(PublishDiagnosticsNotification2.method);
    })(PublishDiagnosticsNotification = exports.PublishDiagnosticsNotification || (exports.PublishDiagnosticsNotification = {}));
    var CompletionTriggerKind;
    (function(CompletionTriggerKind2) {
      CompletionTriggerKind2.Invoked = 1, CompletionTriggerKind2.TriggerCharacter = 2, CompletionTriggerKind2.TriggerForIncompleteCompletions = 3;
    })(CompletionTriggerKind = exports.CompletionTriggerKind || (exports.CompletionTriggerKind = {}));
    var CompletionRequest;
    (function(CompletionRequest2) {
      CompletionRequest2.method = "textDocument/completion", CompletionRequest2.messageDirection = messages_1.MessageDirection.clientToServer, CompletionRequest2.type = new messages_1.ProtocolRequestType(CompletionRequest2.method);
    })(CompletionRequest = exports.CompletionRequest || (exports.CompletionRequest = {}));
    var CompletionResolveRequest;
    (function(CompletionResolveRequest2) {
      CompletionResolveRequest2.method = "completionItem/resolve", CompletionResolveRequest2.messageDirection = messages_1.MessageDirection.clientToServer, CompletionResolveRequest2.type = new messages_1.ProtocolRequestType(CompletionResolveRequest2.method);
    })(CompletionResolveRequest = exports.CompletionResolveRequest || (exports.CompletionResolveRequest = {}));
    var HoverRequest;
    (function(HoverRequest2) {
      HoverRequest2.method = "textDocument/hover", HoverRequest2.messageDirection = messages_1.MessageDirection.clientToServer, HoverRequest2.type = new messages_1.ProtocolRequestType(HoverRequest2.method);
    })(HoverRequest = exports.HoverRequest || (exports.HoverRequest = {}));
    var SignatureHelpTriggerKind;
    (function(SignatureHelpTriggerKind2) {
      SignatureHelpTriggerKind2.Invoked = 1, SignatureHelpTriggerKind2.TriggerCharacter = 2, SignatureHelpTriggerKind2.ContentChange = 3;
    })(SignatureHelpTriggerKind = exports.SignatureHelpTriggerKind || (exports.SignatureHelpTriggerKind = {}));
    var SignatureHelpRequest;
    (function(SignatureHelpRequest2) {
      SignatureHelpRequest2.method = "textDocument/signatureHelp", SignatureHelpRequest2.messageDirection = messages_1.MessageDirection.clientToServer, SignatureHelpRequest2.type = new messages_1.ProtocolRequestType(SignatureHelpRequest2.method);
    })(SignatureHelpRequest = exports.SignatureHelpRequest || (exports.SignatureHelpRequest = {}));
    var DefinitionRequest;
    (function(DefinitionRequest2) {
      DefinitionRequest2.method = "textDocument/definition", DefinitionRequest2.messageDirection = messages_1.MessageDirection.clientToServer, DefinitionRequest2.type = new messages_1.ProtocolRequestType(DefinitionRequest2.method);
    })(DefinitionRequest = exports.DefinitionRequest || (exports.DefinitionRequest = {}));
    var ReferencesRequest;
    (function(ReferencesRequest2) {
      ReferencesRequest2.method = "textDocument/references", ReferencesRequest2.messageDirection = messages_1.MessageDirection.clientToServer, ReferencesRequest2.type = new messages_1.ProtocolRequestType(ReferencesRequest2.method);
    })(ReferencesRequest = exports.ReferencesRequest || (exports.ReferencesRequest = {}));
    var DocumentHighlightRequest;
    (function(DocumentHighlightRequest2) {
      DocumentHighlightRequest2.method = "textDocument/documentHighlight", DocumentHighlightRequest2.messageDirection = messages_1.MessageDirection.clientToServer, DocumentHighlightRequest2.type = new messages_1.ProtocolRequestType(DocumentHighlightRequest2.method);
    })(DocumentHighlightRequest = exports.DocumentHighlightRequest || (exports.DocumentHighlightRequest = {}));
    var DocumentSymbolRequest;
    (function(DocumentSymbolRequest2) {
      DocumentSymbolRequest2.method = "textDocument/documentSymbol", DocumentSymbolRequest2.messageDirection = messages_1.MessageDirection.clientToServer, DocumentSymbolRequest2.type = new messages_1.ProtocolRequestType(DocumentSymbolRequest2.method);
    })(DocumentSymbolRequest = exports.DocumentSymbolRequest || (exports.DocumentSymbolRequest = {}));
    var CodeActionRequest;
    (function(CodeActionRequest2) {
      CodeActionRequest2.method = "textDocument/codeAction", CodeActionRequest2.messageDirection = messages_1.MessageDirection.clientToServer, CodeActionRequest2.type = new messages_1.ProtocolRequestType(CodeActionRequest2.method);
    })(CodeActionRequest = exports.CodeActionRequest || (exports.CodeActionRequest = {}));
    var CodeActionResolveRequest;
    (function(CodeActionResolveRequest2) {
      CodeActionResolveRequest2.method = "codeAction/resolve", CodeActionResolveRequest2.messageDirection = messages_1.MessageDirection.clientToServer, CodeActionResolveRequest2.type = new messages_1.ProtocolRequestType(CodeActionResolveRequest2.method);
    })(CodeActionResolveRequest = exports.CodeActionResolveRequest || (exports.CodeActionResolveRequest = {}));
    var WorkspaceSymbolRequest;
    (function(WorkspaceSymbolRequest2) {
      WorkspaceSymbolRequest2.method = "workspace/symbol", WorkspaceSymbolRequest2.messageDirection = messages_1.MessageDirection.clientToServer, WorkspaceSymbolRequest2.type = new messages_1.ProtocolRequestType(WorkspaceSymbolRequest2.method);
    })(WorkspaceSymbolRequest = exports.WorkspaceSymbolRequest || (exports.WorkspaceSymbolRequest = {}));
    var WorkspaceSymbolResolveRequest;
    (function(WorkspaceSymbolResolveRequest2) {
      WorkspaceSymbolResolveRequest2.method = "workspaceSymbol/resolve", WorkspaceSymbolResolveRequest2.messageDirection = messages_1.MessageDirection.clientToServer, WorkspaceSymbolResolveRequest2.type = new messages_1.ProtocolRequestType(WorkspaceSymbolResolveRequest2.method);
    })(WorkspaceSymbolResolveRequest = exports.WorkspaceSymbolResolveRequest || (exports.WorkspaceSymbolResolveRequest = {}));
    var CodeLensRequest;
    (function(CodeLensRequest2) {
      CodeLensRequest2.method = "textDocument/codeLens", CodeLensRequest2.messageDirection = messages_1.MessageDirection.clientToServer, CodeLensRequest2.type = new messages_1.ProtocolRequestType(CodeLensRequest2.method);
    })(CodeLensRequest = exports.CodeLensRequest || (exports.CodeLensRequest = {}));
    var CodeLensResolveRequest;
    (function(CodeLensResolveRequest2) {
      CodeLensResolveRequest2.method = "codeLens/resolve", CodeLensResolveRequest2.messageDirection = messages_1.MessageDirection.clientToServer, CodeLensResolveRequest2.type = new messages_1.ProtocolRequestType(CodeLensResolveRequest2.method);
    })(CodeLensResolveRequest = exports.CodeLensResolveRequest || (exports.CodeLensResolveRequest = {}));
    var CodeLensRefreshRequest;
    (function(CodeLensRefreshRequest2) {
      CodeLensRefreshRequest2.method = "workspace/codeLens/refresh", CodeLensRefreshRequest2.messageDirection = messages_1.MessageDirection.serverToClient, CodeLensRefreshRequest2.type = new messages_1.ProtocolRequestType0(CodeLensRefreshRequest2.method);
    })(CodeLensRefreshRequest = exports.CodeLensRefreshRequest || (exports.CodeLensRefreshRequest = {}));
    var DocumentLinkRequest;
    (function(DocumentLinkRequest2) {
      DocumentLinkRequest2.method = "textDocument/documentLink", DocumentLinkRequest2.messageDirection = messages_1.MessageDirection.clientToServer, DocumentLinkRequest2.type = new messages_1.ProtocolRequestType(DocumentLinkRequest2.method);
    })(DocumentLinkRequest = exports.DocumentLinkRequest || (exports.DocumentLinkRequest = {}));
    var DocumentLinkResolveRequest;
    (function(DocumentLinkResolveRequest2) {
      DocumentLinkResolveRequest2.method = "documentLink/resolve", DocumentLinkResolveRequest2.messageDirection = messages_1.MessageDirection.clientToServer, DocumentLinkResolveRequest2.type = new messages_1.ProtocolRequestType(DocumentLinkResolveRequest2.method);
    })(DocumentLinkResolveRequest = exports.DocumentLinkResolveRequest || (exports.DocumentLinkResolveRequest = {}));
    var DocumentFormattingRequest;
    (function(DocumentFormattingRequest2) {
      DocumentFormattingRequest2.method = "textDocument/formatting", DocumentFormattingRequest2.messageDirection = messages_1.MessageDirection.clientToServer, DocumentFormattingRequest2.type = new messages_1.ProtocolRequestType(DocumentFormattingRequest2.method);
    })(DocumentFormattingRequest = exports.DocumentFormattingRequest || (exports.DocumentFormattingRequest = {}));
    var DocumentRangeFormattingRequest;
    (function(DocumentRangeFormattingRequest2) {
      DocumentRangeFormattingRequest2.method = "textDocument/rangeFormatting", DocumentRangeFormattingRequest2.messageDirection = messages_1.MessageDirection.clientToServer, DocumentRangeFormattingRequest2.type = new messages_1.ProtocolRequestType(DocumentRangeFormattingRequest2.method);
    })(DocumentRangeFormattingRequest = exports.DocumentRangeFormattingRequest || (exports.DocumentRangeFormattingRequest = {}));
    var DocumentOnTypeFormattingRequest;
    (function(DocumentOnTypeFormattingRequest2) {
      DocumentOnTypeFormattingRequest2.method = "textDocument/onTypeFormatting", DocumentOnTypeFormattingRequest2.messageDirection = messages_1.MessageDirection.clientToServer, DocumentOnTypeFormattingRequest2.type = new messages_1.ProtocolRequestType(DocumentOnTypeFormattingRequest2.method);
    })(DocumentOnTypeFormattingRequest = exports.DocumentOnTypeFormattingRequest || (exports.DocumentOnTypeFormattingRequest = {}));
    var PrepareSupportDefaultBehavior;
    (function(PrepareSupportDefaultBehavior2) {
      PrepareSupportDefaultBehavior2.Identifier = 1;
    })(PrepareSupportDefaultBehavior = exports.PrepareSupportDefaultBehavior || (exports.PrepareSupportDefaultBehavior = {}));
    var RenameRequest;
    (function(RenameRequest2) {
      RenameRequest2.method = "textDocument/rename", RenameRequest2.messageDirection = messages_1.MessageDirection.clientToServer, RenameRequest2.type = new messages_1.ProtocolRequestType(RenameRequest2.method);
    })(RenameRequest = exports.RenameRequest || (exports.RenameRequest = {}));
    var PrepareRenameRequest;
    (function(PrepareRenameRequest2) {
      PrepareRenameRequest2.method = "textDocument/prepareRename", PrepareRenameRequest2.messageDirection = messages_1.MessageDirection.clientToServer, PrepareRenameRequest2.type = new messages_1.ProtocolRequestType(PrepareRenameRequest2.method);
    })(PrepareRenameRequest = exports.PrepareRenameRequest || (exports.PrepareRenameRequest = {}));
    var ExecuteCommandRequest;
    (function(ExecuteCommandRequest2) {
      ExecuteCommandRequest2.method = "workspace/executeCommand", ExecuteCommandRequest2.messageDirection = messages_1.MessageDirection.clientToServer, ExecuteCommandRequest2.type = new messages_1.ProtocolRequestType(ExecuteCommandRequest2.method);
    })(ExecuteCommandRequest = exports.ExecuteCommandRequest || (exports.ExecuteCommandRequest = {}));
    var ApplyWorkspaceEditRequest;
    (function(ApplyWorkspaceEditRequest2) {
      ApplyWorkspaceEditRequest2.method = "workspace/applyEdit", ApplyWorkspaceEditRequest2.messageDirection = messages_1.MessageDirection.serverToClient, ApplyWorkspaceEditRequest2.type = new messages_1.ProtocolRequestType("workspace/applyEdit");
    })(ApplyWorkspaceEditRequest = exports.ApplyWorkspaceEditRequest || (exports.ApplyWorkspaceEditRequest = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/connection.js
var require_connection2 = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/connection.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.createProtocolConnection = void 0;
    var vscode_jsonrpc_1 = require_main3();
    function createProtocolConnection(input, output, logger, options) {
      return vscode_jsonrpc_1.ConnectionStrategy.is(options) && (options = { connectionStrategy: options }), (0, vscode_jsonrpc_1.createMessageConnection)(input, output, logger, options);
    }
    exports.createProtocolConnection = createProtocolConnection;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/api.js
var require_api2 = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/common/api.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p) && __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.LSPErrorCodes = exports.createProtocolConnection = void 0;
    __exportStar(require_main3(), exports);
    __exportStar((init_main4(), __toCommonJS(main_exports2)), exports);
    __exportStar(require_messages2(), exports);
    __exportStar(require_protocol(), exports);
    var connection_1 = require_connection2();
    Object.defineProperty(exports, "createProtocolConnection", { enumerable: !0, get: function() {
      return connection_1.createProtocolConnection;
    } });
    var LSPErrorCodes;
    (function(LSPErrorCodes2) {
      LSPErrorCodes2.lspReservedErrorRangeStart = -32899, LSPErrorCodes2.RequestFailed = -32803, LSPErrorCodes2.ServerCancelled = -32802, LSPErrorCodes2.ContentModified = -32801, LSPErrorCodes2.RequestCancelled = -32800, LSPErrorCodes2.lspReservedErrorRangeEnd = -32800;
    })(LSPErrorCodes = exports.LSPErrorCodes || (exports.LSPErrorCodes = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/node/main.js
var require_main4 = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/lib/node/main.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p) && __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.createProtocolConnection = void 0;
    var node_1 = require_node2();
    __exportStar(require_node2(), exports);
    __exportStar(require_api2(), exports);
    function createProtocolConnection(input, output, logger, options) {
      return (0, node_1.createMessageConnection)(input, output, logger, options);
    }
    exports.createProtocolConnection = createProtocolConnection;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/utils/uuid.js
var require_uuid = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/utils/uuid.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.generateUuid = exports.parse = exports.isUUID = exports.v4 = exports.empty = void 0;
    var ValueUUID = class {
      constructor(_value) {
        this._value = _value;
      }
      asHex() {
        return this._value;
      }
      equals(other) {
        return this.asHex() === other.asHex();
      }
    }, V4UUID = class _V4UUID extends ValueUUID {
      constructor() {
        super([
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          "-",
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          "-",
          "4",
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          "-",
          _V4UUID._oneOf(_V4UUID._timeHighBits),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          "-",
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex(),
          _V4UUID._randomHex()
        ].join(""));
      }
      static _oneOf(array) {
        return array[Math.floor(array.length * Math.random())];
      }
      static _randomHex() {
        return _V4UUID._oneOf(_V4UUID._chars);
      }
    };
    V4UUID._chars = ["0", "1", "2", "3", "4", "5", "6", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f"];
    V4UUID._timeHighBits = ["8", "9", "a", "b"];
    exports.empty = new ValueUUID("00000000-0000-0000-0000-000000000000");
    function v4() {
      return new V4UUID();
    }
    exports.v4 = v4;
    var _UUIDPattern = /^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;
    function isUUID(value) {
      return _UUIDPattern.test(value);
    }
    exports.isUUID = isUUID;
    function parse4(value) {
      if (!isUUID(value))
        throw new Error("invalid uuid");
      return new ValueUUID(value);
    }
    exports.parse = parse4;
    function generateUuid() {
      return v4().asHex();
    }
    exports.generateUuid = generateUuid;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/progress.js
var require_progress = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/progress.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.attachPartialResult = exports.ProgressFeature = exports.attachWorkDone = void 0;
    var vscode_languageserver_protocol_1 = require_main4(), uuid_1 = require_uuid(), WorkDoneProgressReporterImpl = class _WorkDoneProgressReporterImpl {
      constructor(_connection, _token) {
        this._connection = _connection, this._token = _token, _WorkDoneProgressReporterImpl.Instances.set(this._token, this);
      }
      begin(title, percentage, message, cancellable) {
        let param = {
          kind: "begin",
          title,
          percentage,
          message,
          cancellable
        };
        this._connection.sendProgress(vscode_languageserver_protocol_1.WorkDoneProgress.type, this._token, param);
      }
      report(arg0, arg1) {
        let param = {
          kind: "report"
        };
        typeof arg0 == "number" ? (param.percentage = arg0, arg1 !== void 0 && (param.message = arg1)) : param.message = arg0, this._connection.sendProgress(vscode_languageserver_protocol_1.WorkDoneProgress.type, this._token, param);
      }
      done() {
        _WorkDoneProgressReporterImpl.Instances.delete(this._token), this._connection.sendProgress(vscode_languageserver_protocol_1.WorkDoneProgress.type, this._token, { kind: "end" });
      }
    };
    WorkDoneProgressReporterImpl.Instances = /* @__PURE__ */ new Map();
    var WorkDoneProgressServerReporterImpl = class extends WorkDoneProgressReporterImpl {
      constructor(connection, token) {
        super(connection, token), this._source = new vscode_languageserver_protocol_1.CancellationTokenSource();
      }
      get token() {
        return this._source.token;
      }
      done() {
        this._source.dispose(), super.done();
      }
      cancel() {
        this._source.cancel();
      }
    }, NullProgressReporter = class {
      constructor() {
      }
      begin() {
      }
      report() {
      }
      done() {
      }
    }, NullProgressServerReporter = class extends NullProgressReporter {
      constructor() {
        super(), this._source = new vscode_languageserver_protocol_1.CancellationTokenSource();
      }
      get token() {
        return this._source.token;
      }
      done() {
        this._source.dispose();
      }
      cancel() {
        this._source.cancel();
      }
    };
    function attachWorkDone(connection, params) {
      if (params === void 0 || params.workDoneToken === void 0)
        return new NullProgressReporter();
      let token = params.workDoneToken;
      return delete params.workDoneToken, new WorkDoneProgressReporterImpl(connection, token);
    }
    exports.attachWorkDone = attachWorkDone;
    var ProgressFeature = (Base) => class extends Base {
      constructor() {
        super(), this._progressSupported = !1;
      }
      initialize(capabilities) {
        super.initialize(capabilities), capabilities?.window?.workDoneProgress === !0 && (this._progressSupported = !0, this.connection.onNotification(vscode_languageserver_protocol_1.WorkDoneProgressCancelNotification.type, (params) => {
          let progress = WorkDoneProgressReporterImpl.Instances.get(params.token);
          (progress instanceof WorkDoneProgressServerReporterImpl || progress instanceof NullProgressServerReporter) && progress.cancel();
        }));
      }
      attachWorkDoneProgress(token) {
        return token === void 0 ? new NullProgressReporter() : new WorkDoneProgressReporterImpl(this.connection, token);
      }
      createWorkDoneProgress() {
        if (this._progressSupported) {
          let token = (0, uuid_1.generateUuid)();
          return this.connection.sendRequest(vscode_languageserver_protocol_1.WorkDoneProgressCreateRequest.type, { token }).then(() => new WorkDoneProgressServerReporterImpl(this.connection, token));
        } else
          return Promise.resolve(new NullProgressServerReporter());
      }
    };
    exports.ProgressFeature = ProgressFeature;
    var ResultProgress;
    (function(ResultProgress2) {
      ResultProgress2.type = new vscode_languageserver_protocol_1.ProgressType();
    })(ResultProgress || (ResultProgress = {}));
    var ResultProgressReporterImpl = class {
      constructor(_connection, _token) {
        this._connection = _connection, this._token = _token;
      }
      report(data) {
        this._connection.sendProgress(ResultProgress.type, this._token, data);
      }
    };
    function attachPartialResult(connection, params) {
      if (params === void 0 || params.partialResultToken === void 0)
        return;
      let token = params.partialResultToken;
      return delete params.partialResultToken, new ResultProgressReporterImpl(connection, token);
    }
    exports.attachPartialResult = attachPartialResult;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/configuration.js
var require_configuration = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/configuration.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ConfigurationFeature = void 0;
    var vscode_languageserver_protocol_1 = require_main4(), Is3 = require_is(), ConfigurationFeature = (Base) => class extends Base {
      getConfiguration(arg) {
        return arg ? Is3.string(arg) ? this._getConfiguration({ section: arg }) : this._getConfiguration(arg) : this._getConfiguration({});
      }
      _getConfiguration(arg) {
        let params = {
          items: Array.isArray(arg) ? arg : [arg]
        };
        return this.connection.sendRequest(vscode_languageserver_protocol_1.ConfigurationRequest.type, params).then((result) => Array.isArray(result) ? Array.isArray(arg) ? result : result[0] : Array.isArray(arg) ? [] : null);
      }
    };
    exports.ConfigurationFeature = ConfigurationFeature;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/workspaceFolder.js
var require_workspaceFolder = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/workspaceFolder.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.WorkspaceFoldersFeature = void 0;
    var vscode_languageserver_protocol_1 = require_main4(), WorkspaceFoldersFeature = (Base) => class extends Base {
      constructor() {
        super(), this._notificationIsAutoRegistered = !1;
      }
      initialize(capabilities) {
        super.initialize(capabilities);
        let workspaceCapabilities = capabilities.workspace;
        workspaceCapabilities && workspaceCapabilities.workspaceFolders && (this._onDidChangeWorkspaceFolders = new vscode_languageserver_protocol_1.Emitter(), this.connection.onNotification(vscode_languageserver_protocol_1.DidChangeWorkspaceFoldersNotification.type, (params) => {
          this._onDidChangeWorkspaceFolders.fire(params.event);
        }));
      }
      fillServerCapabilities(capabilities) {
        super.fillServerCapabilities(capabilities);
        let changeNotifications = capabilities.workspace?.workspaceFolders?.changeNotifications;
        this._notificationIsAutoRegistered = changeNotifications === !0 || typeof changeNotifications == "string";
      }
      getWorkspaceFolders() {
        return this.connection.sendRequest(vscode_languageserver_protocol_1.WorkspaceFoldersRequest.type);
      }
      get onDidChangeWorkspaceFolders() {
        if (!this._onDidChangeWorkspaceFolders)
          throw new Error("Client doesn't support sending workspace folder change events.");
        return !this._notificationIsAutoRegistered && !this._unregistration && (this._unregistration = this.connection.client.register(vscode_languageserver_protocol_1.DidChangeWorkspaceFoldersNotification.type)), this._onDidChangeWorkspaceFolders.event;
      }
    };
    exports.WorkspaceFoldersFeature = WorkspaceFoldersFeature;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/callHierarchy.js
var require_callHierarchy = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/callHierarchy.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.CallHierarchyFeature = void 0;
    var vscode_languageserver_protocol_1 = require_main4(), CallHierarchyFeature = (Base) => class extends Base {
      get callHierarchy() {
        return {
          onPrepare: (handler) => this.connection.onRequest(vscode_languageserver_protocol_1.CallHierarchyPrepareRequest.type, (params, cancel) => handler(params, cancel, this.attachWorkDoneProgress(params), void 0)),
          onIncomingCalls: (handler) => {
            let type = vscode_languageserver_protocol_1.CallHierarchyIncomingCallsRequest.type;
            return this.connection.onRequest(type, (params, cancel) => handler(params, cancel, this.attachWorkDoneProgress(params), this.attachPartialResultProgress(type, params)));
          },
          onOutgoingCalls: (handler) => {
            let type = vscode_languageserver_protocol_1.CallHierarchyOutgoingCallsRequest.type;
            return this.connection.onRequest(type, (params, cancel) => handler(params, cancel, this.attachWorkDoneProgress(params), this.attachPartialResultProgress(type, params)));
          }
        };
      }
    };
    exports.CallHierarchyFeature = CallHierarchyFeature;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/semanticTokens.js
var require_semanticTokens = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/semanticTokens.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.SemanticTokensBuilder = exports.SemanticTokensDiff = exports.SemanticTokensFeature = void 0;
    var vscode_languageserver_protocol_1 = require_main4(), SemanticTokensFeature = (Base) => class extends Base {
      get semanticTokens() {
        return {
          refresh: () => this.connection.sendRequest(vscode_languageserver_protocol_1.SemanticTokensRefreshRequest.type),
          on: (handler) => {
            let type = vscode_languageserver_protocol_1.SemanticTokensRequest.type;
            return this.connection.onRequest(type, (params, cancel) => handler(params, cancel, this.attachWorkDoneProgress(params), this.attachPartialResultProgress(type, params)));
          },
          onDelta: (handler) => {
            let type = vscode_languageserver_protocol_1.SemanticTokensDeltaRequest.type;
            return this.connection.onRequest(type, (params, cancel) => handler(params, cancel, this.attachWorkDoneProgress(params), this.attachPartialResultProgress(type, params)));
          },
          onRange: (handler) => {
            let type = vscode_languageserver_protocol_1.SemanticTokensRangeRequest.type;
            return this.connection.onRequest(type, (params, cancel) => handler(params, cancel, this.attachWorkDoneProgress(params), this.attachPartialResultProgress(type, params)));
          }
        };
      }
    };
    exports.SemanticTokensFeature = SemanticTokensFeature;
    var SemanticTokensDiff = class {
      constructor(originalSequence, modifiedSequence) {
        this.originalSequence = originalSequence, this.modifiedSequence = modifiedSequence;
      }
      computeDiff() {
        let originalLength = this.originalSequence.length, modifiedLength = this.modifiedSequence.length, startIndex = 0;
        for (; startIndex < modifiedLength && startIndex < originalLength && this.originalSequence[startIndex] === this.modifiedSequence[startIndex]; )
          startIndex++;
        if (startIndex < modifiedLength && startIndex < originalLength) {
          let originalEndIndex = originalLength - 1, modifiedEndIndex = modifiedLength - 1;
          for (; originalEndIndex >= startIndex && modifiedEndIndex >= startIndex && this.originalSequence[originalEndIndex] === this.modifiedSequence[modifiedEndIndex]; )
            originalEndIndex--, modifiedEndIndex--;
          (originalEndIndex < startIndex || modifiedEndIndex < startIndex) && (originalEndIndex++, modifiedEndIndex++);
          let deleteCount = originalEndIndex - startIndex + 1, newData = this.modifiedSequence.slice(startIndex, modifiedEndIndex + 1);
          return newData.length === 1 && newData[0] === this.originalSequence[originalEndIndex] ? [
            { start: startIndex, deleteCount: deleteCount - 1 }
          ] : [
            { start: startIndex, deleteCount, data: newData }
          ];
        } else
          return startIndex < modifiedLength ? [
            { start: startIndex, deleteCount: 0, data: this.modifiedSequence.slice(startIndex) }
          ] : startIndex < originalLength ? [
            { start: startIndex, deleteCount: originalLength - startIndex }
          ] : [];
      }
    };
    exports.SemanticTokensDiff = SemanticTokensDiff;
    var SemanticTokensBuilder = class {
      constructor() {
        this._prevData = void 0, this.initialize();
      }
      initialize() {
        this._id = Date.now(), this._prevLine = 0, this._prevChar = 0, this._data = [], this._dataLen = 0;
      }
      push(line, char, length, tokenType, tokenModifiers) {
        let pushLine = line, pushChar = char;
        this._dataLen > 0 && (pushLine -= this._prevLine, pushLine === 0 && (pushChar -= this._prevChar)), this._data[this._dataLen++] = pushLine, this._data[this._dataLen++] = pushChar, this._data[this._dataLen++] = length, this._data[this._dataLen++] = tokenType, this._data[this._dataLen++] = tokenModifiers, this._prevLine = line, this._prevChar = char;
      }
      get id() {
        return this._id.toString();
      }
      previousResult(id) {
        this.id === id && (this._prevData = this._data), this.initialize();
      }
      build() {
        return this._prevData = void 0, {
          resultId: this.id,
          data: this._data
        };
      }
      canBuildEdits() {
        return this._prevData !== void 0;
      }
      buildEdits() {
        return this._prevData !== void 0 ? {
          resultId: this.id,
          edits: new SemanticTokensDiff(this._prevData, this._data).computeDiff()
        } : this.build();
      }
    };
    exports.SemanticTokensBuilder = SemanticTokensBuilder;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/showDocument.js
var require_showDocument = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/showDocument.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ShowDocumentFeature = void 0;
    var vscode_languageserver_protocol_1 = require_main4(), ShowDocumentFeature = (Base) => class extends Base {
      showDocument(params) {
        return this.connection.sendRequest(vscode_languageserver_protocol_1.ShowDocumentRequest.type, params);
      }
    };
    exports.ShowDocumentFeature = ShowDocumentFeature;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/fileOperations.js
var require_fileOperations = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/fileOperations.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.FileOperationsFeature = void 0;
    var vscode_languageserver_protocol_1 = require_main4(), FileOperationsFeature = (Base) => class extends Base {
      onDidCreateFiles(handler) {
        return this.connection.onNotification(vscode_languageserver_protocol_1.DidCreateFilesNotification.type, (params) => {
          handler(params);
        });
      }
      onDidRenameFiles(handler) {
        return this.connection.onNotification(vscode_languageserver_protocol_1.DidRenameFilesNotification.type, (params) => {
          handler(params);
        });
      }
      onDidDeleteFiles(handler) {
        return this.connection.onNotification(vscode_languageserver_protocol_1.DidDeleteFilesNotification.type, (params) => {
          handler(params);
        });
      }
      onWillCreateFiles(handler) {
        return this.connection.onRequest(vscode_languageserver_protocol_1.WillCreateFilesRequest.type, (params, cancel) => handler(params, cancel));
      }
      onWillRenameFiles(handler) {
        return this.connection.onRequest(vscode_languageserver_protocol_1.WillRenameFilesRequest.type, (params, cancel) => handler(params, cancel));
      }
      onWillDeleteFiles(handler) {
        return this.connection.onRequest(vscode_languageserver_protocol_1.WillDeleteFilesRequest.type, (params, cancel) => handler(params, cancel));
      }
    };
    exports.FileOperationsFeature = FileOperationsFeature;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/linkedEditingRange.js
var require_linkedEditingRange = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/linkedEditingRange.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.LinkedEditingRangeFeature = void 0;
    var vscode_languageserver_protocol_1 = require_main4(), LinkedEditingRangeFeature = (Base) => class extends Base {
      onLinkedEditingRange(handler) {
        return this.connection.onRequest(vscode_languageserver_protocol_1.LinkedEditingRangeRequest.type, (params, cancel) => handler(params, cancel, this.attachWorkDoneProgress(params), void 0));
      }
    };
    exports.LinkedEditingRangeFeature = LinkedEditingRangeFeature;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/typeHierarchy.js
var require_typeHierarchy = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/typeHierarchy.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.TypeHierarchyFeature = void 0;
    var vscode_languageserver_protocol_1 = require_main4(), TypeHierarchyFeature = (Base) => class extends Base {
      get typeHierarchy() {
        return {
          onPrepare: (handler) => this.connection.onRequest(vscode_languageserver_protocol_1.TypeHierarchyPrepareRequest.type, (params, cancel) => handler(params, cancel, this.attachWorkDoneProgress(params), void 0)),
          onSupertypes: (handler) => {
            let type = vscode_languageserver_protocol_1.TypeHierarchySupertypesRequest.type;
            return this.connection.onRequest(type, (params, cancel) => handler(params, cancel, this.attachWorkDoneProgress(params), this.attachPartialResultProgress(type, params)));
          },
          onSubtypes: (handler) => {
            let type = vscode_languageserver_protocol_1.TypeHierarchySubtypesRequest.type;
            return this.connection.onRequest(type, (params, cancel) => handler(params, cancel, this.attachWorkDoneProgress(params), this.attachPartialResultProgress(type, params)));
          }
        };
      }
    };
    exports.TypeHierarchyFeature = TypeHierarchyFeature;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/inlineValue.js
var require_inlineValue = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/inlineValue.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.InlineValueFeature = void 0;
    var vscode_languageserver_protocol_1 = require_main4(), InlineValueFeature = (Base) => class extends Base {
      get inlineValue() {
        return {
          refresh: () => this.connection.sendRequest(vscode_languageserver_protocol_1.InlineValueRefreshRequest.type),
          on: (handler) => this.connection.onRequest(vscode_languageserver_protocol_1.InlineValueRequest.type, (params, cancel) => handler(params, cancel, this.attachWorkDoneProgress(params)))
        };
      }
    };
    exports.InlineValueFeature = InlineValueFeature;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/inlayHint.js
var require_inlayHint = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/inlayHint.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.InlayHintFeature = void 0;
    var vscode_languageserver_protocol_1 = require_main4(), InlayHintFeature = (Base) => class extends Base {
      get inlayHint() {
        return {
          refresh: () => this.connection.sendRequest(vscode_languageserver_protocol_1.InlayHintRefreshRequest.type),
          on: (handler) => this.connection.onRequest(vscode_languageserver_protocol_1.InlayHintRequest.type, (params, cancel) => handler(params, cancel, this.attachWorkDoneProgress(params))),
          resolve: (handler) => this.connection.onRequest(vscode_languageserver_protocol_1.InlayHintResolveRequest.type, (params, cancel) => handler(params, cancel))
        };
      }
    };
    exports.InlayHintFeature = InlayHintFeature;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/diagnostic.js
var require_diagnostic = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/diagnostic.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.DiagnosticFeature = void 0;
    var vscode_languageserver_protocol_1 = require_main4(), DiagnosticFeature = (Base) => class extends Base {
      get diagnostics() {
        return {
          refresh: () => this.connection.sendRequest(vscode_languageserver_protocol_1.DiagnosticRefreshRequest.type),
          on: (handler) => this.connection.onRequest(vscode_languageserver_protocol_1.DocumentDiagnosticRequest.type, (params, cancel) => handler(params, cancel, this.attachWorkDoneProgress(params), this.attachPartialResultProgress(vscode_languageserver_protocol_1.DocumentDiagnosticRequest.partialResult, params))),
          onWorkspace: (handler) => this.connection.onRequest(vscode_languageserver_protocol_1.WorkspaceDiagnosticRequest.type, (params, cancel) => handler(params, cancel, this.attachWorkDoneProgress(params), this.attachPartialResultProgress(vscode_languageserver_protocol_1.WorkspaceDiagnosticRequest.partialResult, params)))
        };
      }
    };
    exports.DiagnosticFeature = DiagnosticFeature;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/textDocuments.js
var require_textDocuments = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/textDocuments.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.TextDocuments = void 0;
    var vscode_languageserver_protocol_1 = require_main4(), TextDocuments = class {
      /**
       * Create a new text document manager.
       */
      constructor(configuration) {
        this._configuration = configuration, this._syncedDocuments = /* @__PURE__ */ new Map(), this._onDidChangeContent = new vscode_languageserver_protocol_1.Emitter(), this._onDidOpen = new vscode_languageserver_protocol_1.Emitter(), this._onDidClose = new vscode_languageserver_protocol_1.Emitter(), this._onDidSave = new vscode_languageserver_protocol_1.Emitter(), this._onWillSave = new vscode_languageserver_protocol_1.Emitter();
      }
      /**
       * An event that fires when a text document managed by this manager
       * has been opened.
       */
      get onDidOpen() {
        return this._onDidOpen.event;
      }
      /**
       * An event that fires when a text document managed by this manager
       * has been opened or the content changes.
       */
      get onDidChangeContent() {
        return this._onDidChangeContent.event;
      }
      /**
       * An event that fires when a text document managed by this manager
       * will be saved.
       */
      get onWillSave() {
        return this._onWillSave.event;
      }
      /**
       * Sets a handler that will be called if a participant wants to provide
       * edits during a text document save.
       */
      onWillSaveWaitUntil(handler) {
        this._willSaveWaitUntil = handler;
      }
      /**
       * An event that fires when a text document managed by this manager
       * has been saved.
       */
      get onDidSave() {
        return this._onDidSave.event;
      }
      /**
       * An event that fires when a text document managed by this manager
       * has been closed.
       */
      get onDidClose() {
        return this._onDidClose.event;
      }
      /**
       * Returns the document for the given URI. Returns undefined if
       * the document is not managed by this instance.
       *
       * @param uri The text document's URI to retrieve.
       * @return the text document or `undefined`.
       */
      get(uri) {
        return this._syncedDocuments.get(uri);
      }
      /**
       * Returns all text documents managed by this instance.
       *
       * @return all text documents.
       */
      all() {
        return Array.from(this._syncedDocuments.values());
      }
      /**
       * Returns the URIs of all text documents managed by this instance.
       *
       * @return the URI's of all text documents.
       */
      keys() {
        return Array.from(this._syncedDocuments.keys());
      }
      /**
       * Listens for `low level` notification on the given connection to
       * update the text documents managed by this instance.
       *
       * Please note that the connection only provides handlers not an event model. Therefore
       * listening on a connection will overwrite the following handlers on a connection:
       * `onDidOpenTextDocument`, `onDidChangeTextDocument`, `onDidCloseTextDocument`,
       * `onWillSaveTextDocument`, `onWillSaveTextDocumentWaitUntil` and `onDidSaveTextDocument`.
       *
       * Use the corresponding events on the TextDocuments instance instead.
       *
       * @param connection The connection to listen on.
       */
      listen(connection) {
        connection.__textDocumentSync = vscode_languageserver_protocol_1.TextDocumentSyncKind.Incremental;
        let disposables = [];
        return disposables.push(connection.onDidOpenTextDocument((event) => {
          let td = event.textDocument, document2 = this._configuration.create(td.uri, td.languageId, td.version, td.text);
          this._syncedDocuments.set(td.uri, document2);
          let toFire = Object.freeze({ document: document2 });
          this._onDidOpen.fire(toFire), this._onDidChangeContent.fire(toFire);
        })), disposables.push(connection.onDidChangeTextDocument((event) => {
          let td = event.textDocument, changes = event.contentChanges;
          if (changes.length === 0)
            return;
          let { version: version2 } = td;
          if (version2 == null)
            throw new Error(`Received document change event for ${td.uri} without valid version identifier`);
          let syncedDocument = this._syncedDocuments.get(td.uri);
          syncedDocument !== void 0 && (syncedDocument = this._configuration.update(syncedDocument, changes, version2), this._syncedDocuments.set(td.uri, syncedDocument), this._onDidChangeContent.fire(Object.freeze({ document: syncedDocument })));
        })), disposables.push(connection.onDidCloseTextDocument((event) => {
          let syncedDocument = this._syncedDocuments.get(event.textDocument.uri);
          syncedDocument !== void 0 && (this._syncedDocuments.delete(event.textDocument.uri), this._onDidClose.fire(Object.freeze({ document: syncedDocument })));
        })), disposables.push(connection.onWillSaveTextDocument((event) => {
          let syncedDocument = this._syncedDocuments.get(event.textDocument.uri);
          syncedDocument !== void 0 && this._onWillSave.fire(Object.freeze({ document: syncedDocument, reason: event.reason }));
        })), disposables.push(connection.onWillSaveTextDocumentWaitUntil((event, token) => {
          let syncedDocument = this._syncedDocuments.get(event.textDocument.uri);
          return syncedDocument !== void 0 && this._willSaveWaitUntil ? this._willSaveWaitUntil(Object.freeze({ document: syncedDocument, reason: event.reason }), token) : [];
        })), disposables.push(connection.onDidSaveTextDocument((event) => {
          let syncedDocument = this._syncedDocuments.get(event.textDocument.uri);
          syncedDocument !== void 0 && this._onDidSave.fire(Object.freeze({ document: syncedDocument }));
        })), vscode_languageserver_protocol_1.Disposable.create(() => {
          disposables.forEach((disposable) => disposable.dispose());
        });
      }
    };
    exports.TextDocuments = TextDocuments;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/notebook.js
var require_notebook = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/notebook.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.NotebookDocuments = exports.NotebookSyncFeature = void 0;
    var vscode_languageserver_protocol_1 = require_main4(), textDocuments_1 = require_textDocuments(), NotebookSyncFeature = (Base) => class extends Base {
      get synchronization() {
        return {
          onDidOpenNotebookDocument: (handler) => this.connection.onNotification(vscode_languageserver_protocol_1.DidOpenNotebookDocumentNotification.type, (params) => {
            handler(params);
          }),
          onDidChangeNotebookDocument: (handler) => this.connection.onNotification(vscode_languageserver_protocol_1.DidChangeNotebookDocumentNotification.type, (params) => {
            handler(params);
          }),
          onDidSaveNotebookDocument: (handler) => this.connection.onNotification(vscode_languageserver_protocol_1.DidSaveNotebookDocumentNotification.type, (params) => {
            handler(params);
          }),
          onDidCloseNotebookDocument: (handler) => this.connection.onNotification(vscode_languageserver_protocol_1.DidCloseNotebookDocumentNotification.type, (params) => {
            handler(params);
          })
        };
      }
    };
    exports.NotebookSyncFeature = NotebookSyncFeature;
    var CellTextDocumentConnection = class _CellTextDocumentConnection {
      onDidOpenTextDocument(handler) {
        return this.openHandler = handler, vscode_languageserver_protocol_1.Disposable.create(() => {
          this.openHandler = void 0;
        });
      }
      openTextDocument(params) {
        this.openHandler && this.openHandler(params);
      }
      onDidChangeTextDocument(handler) {
        return this.changeHandler = handler, vscode_languageserver_protocol_1.Disposable.create(() => {
          this.changeHandler = handler;
        });
      }
      changeTextDocument(params) {
        this.changeHandler && this.changeHandler(params);
      }
      onDidCloseTextDocument(handler) {
        return this.closeHandler = handler, vscode_languageserver_protocol_1.Disposable.create(() => {
          this.closeHandler = void 0;
        });
      }
      closeTextDocument(params) {
        this.closeHandler && this.closeHandler(params);
      }
      onWillSaveTextDocument() {
        return _CellTextDocumentConnection.NULL_DISPOSE;
      }
      onWillSaveTextDocumentWaitUntil() {
        return _CellTextDocumentConnection.NULL_DISPOSE;
      }
      onDidSaveTextDocument() {
        return _CellTextDocumentConnection.NULL_DISPOSE;
      }
    };
    CellTextDocumentConnection.NULL_DISPOSE = Object.freeze({ dispose: () => {
    } });
    var NotebookDocuments = class {
      constructor(configurationOrTextDocuments) {
        configurationOrTextDocuments instanceof textDocuments_1.TextDocuments ? this._cellTextDocuments = configurationOrTextDocuments : this._cellTextDocuments = new textDocuments_1.TextDocuments(configurationOrTextDocuments), this.notebookDocuments = /* @__PURE__ */ new Map(), this.notebookCellMap = /* @__PURE__ */ new Map(), this._onDidOpen = new vscode_languageserver_protocol_1.Emitter(), this._onDidChange = new vscode_languageserver_protocol_1.Emitter(), this._onDidSave = new vscode_languageserver_protocol_1.Emitter(), this._onDidClose = new vscode_languageserver_protocol_1.Emitter();
      }
      get cellTextDocuments() {
        return this._cellTextDocuments;
      }
      getCellTextDocument(cell) {
        return this._cellTextDocuments.get(cell.document);
      }
      getNotebookDocument(uri) {
        return this.notebookDocuments.get(uri);
      }
      getNotebookCell(uri) {
        let value = this.notebookCellMap.get(uri);
        return value && value[0];
      }
      findNotebookDocumentForCell(cell) {
        let key = typeof cell == "string" ? cell : cell.document, value = this.notebookCellMap.get(key);
        return value && value[1];
      }
      get onDidOpen() {
        return this._onDidOpen.event;
      }
      get onDidSave() {
        return this._onDidSave.event;
      }
      get onDidChange() {
        return this._onDidChange.event;
      }
      get onDidClose() {
        return this._onDidClose.event;
      }
      /**
       * Listens for `low level` notification on the given connection to
       * update the notebook documents managed by this instance.
       *
       * Please note that the connection only provides handlers not an event model. Therefore
       * listening on a connection will overwrite the following handlers on a connection:
       * `onDidOpenNotebookDocument`, `onDidChangeNotebookDocument`, `onDidSaveNotebookDocument`,
       *  and `onDidCloseNotebookDocument`.
       *
       * @param connection The connection to listen on.
       */
      listen(connection) {
        let cellTextDocumentConnection = new CellTextDocumentConnection(), disposables = [];
        return disposables.push(this.cellTextDocuments.listen(cellTextDocumentConnection)), disposables.push(connection.notebooks.synchronization.onDidOpenNotebookDocument((params) => {
          this.notebookDocuments.set(params.notebookDocument.uri, params.notebookDocument);
          for (let cellTextDocument of params.cellTextDocuments)
            cellTextDocumentConnection.openTextDocument({ textDocument: cellTextDocument });
          this.updateCellMap(params.notebookDocument), this._onDidOpen.fire(params.notebookDocument);
        })), disposables.push(connection.notebooks.synchronization.onDidChangeNotebookDocument((params) => {
          let notebookDocument = this.notebookDocuments.get(params.notebookDocument.uri);
          if (notebookDocument === void 0)
            return;
          notebookDocument.version = params.notebookDocument.version;
          let oldMetadata = notebookDocument.metadata, metadataChanged = !1, change = params.change;
          change.metadata !== void 0 && (metadataChanged = !0, notebookDocument.metadata = change.metadata);
          let opened = [], closed = [], data = [], text = [];
          if (change.cells !== void 0) {
            let changedCells = change.cells;
            if (changedCells.structure !== void 0) {
              let array = changedCells.structure.array;
              if (notebookDocument.cells.splice(array.start, array.deleteCount, ...array.cells !== void 0 ? array.cells : []), changedCells.structure.didOpen !== void 0)
                for (let open2 of changedCells.structure.didOpen)
                  cellTextDocumentConnection.openTextDocument({ textDocument: open2 }), opened.push(open2.uri);
              if (changedCells.structure.didClose)
                for (let close of changedCells.structure.didClose)
                  cellTextDocumentConnection.closeTextDocument({ textDocument: close }), closed.push(close.uri);
            }
            if (changedCells.data !== void 0) {
              let cellUpdates = new Map(changedCells.data.map((cell) => [cell.document, cell]));
              for (let i = 0; i <= notebookDocument.cells.length; i++) {
                let change2 = cellUpdates.get(notebookDocument.cells[i].document);
                if (change2 !== void 0) {
                  let old = notebookDocument.cells.splice(i, 1, change2);
                  if (data.push({ old: old[0], new: change2 }), cellUpdates.delete(change2.document), cellUpdates.size === 0)
                    break;
                }
              }
            }
            if (changedCells.textContent !== void 0)
              for (let cellTextDocument of changedCells.textContent)
                cellTextDocumentConnection.changeTextDocument({ textDocument: cellTextDocument.document, contentChanges: cellTextDocument.changes }), text.push(cellTextDocument.document.uri);
          }
          this.updateCellMap(notebookDocument);
          let changeEvent = { notebookDocument };
          metadataChanged && (changeEvent.metadata = { old: oldMetadata, new: notebookDocument.metadata });
          let added = [];
          for (let open2 of opened)
            added.push(this.getNotebookCell(open2));
          let removed = [];
          for (let close of closed)
            removed.push(this.getNotebookCell(close));
          let textContent = [];
          for (let change2 of text)
            textContent.push(this.getNotebookCell(change2));
          (added.length > 0 || removed.length > 0 || data.length > 0 || textContent.length > 0) && (changeEvent.cells = { added, removed, changed: { data, textContent } }), (changeEvent.metadata !== void 0 || changeEvent.cells !== void 0) && this._onDidChange.fire(changeEvent);
        })), disposables.push(connection.notebooks.synchronization.onDidSaveNotebookDocument((params) => {
          let notebookDocument = this.notebookDocuments.get(params.notebookDocument.uri);
          notebookDocument !== void 0 && this._onDidSave.fire(notebookDocument);
        })), disposables.push(connection.notebooks.synchronization.onDidCloseNotebookDocument((params) => {
          let notebookDocument = this.notebookDocuments.get(params.notebookDocument.uri);
          if (notebookDocument !== void 0) {
            this._onDidClose.fire(notebookDocument);
            for (let cellTextDocument of params.cellTextDocuments)
              cellTextDocumentConnection.closeTextDocument({ textDocument: cellTextDocument });
            this.notebookDocuments.delete(params.notebookDocument.uri);
            for (let cell of notebookDocument.cells)
              this.notebookCellMap.delete(cell.document);
          }
        })), vscode_languageserver_protocol_1.Disposable.create(() => {
          disposables.forEach((disposable) => disposable.dispose());
        });
      }
      updateCellMap(notebookDocument) {
        for (let cell of notebookDocument.cells)
          this.notebookCellMap.set(cell.document, [cell, notebookDocument]);
      }
    };
    exports.NotebookDocuments = NotebookDocuments;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/moniker.js
var require_moniker = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/moniker.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.MonikerFeature = void 0;
    var vscode_languageserver_protocol_1 = require_main4(), MonikerFeature = (Base) => class extends Base {
      get moniker() {
        return {
          on: (handler) => {
            let type = vscode_languageserver_protocol_1.MonikerRequest.type;
            return this.connection.onRequest(type, (params, cancel) => handler(params, cancel, this.attachWorkDoneProgress(params), this.attachPartialResultProgress(type, params)));
          }
        };
      }
    };
    exports.MonikerFeature = MonikerFeature;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/server.js
var require_server = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/server.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.createConnection = exports.combineFeatures = exports.combineNotebooksFeatures = exports.combineLanguagesFeatures = exports.combineWorkspaceFeatures = exports.combineWindowFeatures = exports.combineClientFeatures = exports.combineTracerFeatures = exports.combineTelemetryFeatures = exports.combineConsoleFeatures = exports._NotebooksImpl = exports._LanguagesImpl = exports.BulkUnregistration = exports.BulkRegistration = exports.ErrorMessageTracker = void 0;
    var vscode_languageserver_protocol_1 = require_main4(), Is3 = require_is(), UUID = require_uuid(), progress_1 = require_progress(), configuration_1 = require_configuration(), workspaceFolder_1 = require_workspaceFolder(), callHierarchy_1 = require_callHierarchy(), semanticTokens_1 = require_semanticTokens(), showDocument_1 = require_showDocument(), fileOperations_1 = require_fileOperations(), linkedEditingRange_1 = require_linkedEditingRange(), typeHierarchy_1 = require_typeHierarchy(), inlineValue_1 = require_inlineValue(), inlayHint_1 = require_inlayHint(), diagnostic_1 = require_diagnostic(), notebook_1 = require_notebook(), moniker_1 = require_moniker();
    function null2Undefined(value) {
      if (value !== null)
        return value;
    }
    var ErrorMessageTracker = class {
      constructor() {
        this._messages = /* @__PURE__ */ Object.create(null);
      }
      /**
       * Add a message to the tracker.
       *
       * @param message The message to add.
       */
      add(message) {
        let count = this._messages[message];
        count || (count = 0), count++, this._messages[message] = count;
      }
      /**
       * Send all tracked messages to the connection's window.
       *
       * @param connection The connection established between client and server.
       */
      sendErrors(connection) {
        Object.keys(this._messages).forEach((message) => {
          connection.window.showErrorMessage(message);
        });
      }
    };
    exports.ErrorMessageTracker = ErrorMessageTracker;
    var RemoteConsoleImpl = class {
      constructor() {
      }
      rawAttach(connection) {
        this._rawConnection = connection;
      }
      attach(connection) {
        this._connection = connection;
      }
      get connection() {
        if (!this._connection)
          throw new Error("Remote is not attached to a connection yet.");
        return this._connection;
      }
      fillServerCapabilities(_capabilities) {
      }
      initialize(_capabilities) {
      }
      error(message) {
        this.send(vscode_languageserver_protocol_1.MessageType.Error, message);
      }
      warn(message) {
        this.send(vscode_languageserver_protocol_1.MessageType.Warning, message);
      }
      info(message) {
        this.send(vscode_languageserver_protocol_1.MessageType.Info, message);
      }
      log(message) {
        this.send(vscode_languageserver_protocol_1.MessageType.Log, message);
      }
      send(type, message) {
        this._rawConnection && this._rawConnection.sendNotification(vscode_languageserver_protocol_1.LogMessageNotification.type, { type, message }).catch(() => {
          (0, vscode_languageserver_protocol_1.RAL)().console.error("Sending log message failed");
        });
      }
    }, _RemoteWindowImpl = class {
      constructor() {
      }
      attach(connection) {
        this._connection = connection;
      }
      get connection() {
        if (!this._connection)
          throw new Error("Remote is not attached to a connection yet.");
        return this._connection;
      }
      initialize(_capabilities) {
      }
      fillServerCapabilities(_capabilities) {
      }
      showErrorMessage(message, ...actions) {
        let params = { type: vscode_languageserver_protocol_1.MessageType.Error, message, actions };
        return this.connection.sendRequest(vscode_languageserver_protocol_1.ShowMessageRequest.type, params).then(null2Undefined);
      }
      showWarningMessage(message, ...actions) {
        let params = { type: vscode_languageserver_protocol_1.MessageType.Warning, message, actions };
        return this.connection.sendRequest(vscode_languageserver_protocol_1.ShowMessageRequest.type, params).then(null2Undefined);
      }
      showInformationMessage(message, ...actions) {
        let params = { type: vscode_languageserver_protocol_1.MessageType.Info, message, actions };
        return this.connection.sendRequest(vscode_languageserver_protocol_1.ShowMessageRequest.type, params).then(null2Undefined);
      }
    }, RemoteWindowImpl = (0, showDocument_1.ShowDocumentFeature)((0, progress_1.ProgressFeature)(_RemoteWindowImpl)), BulkRegistration;
    (function(BulkRegistration2) {
      function create() {
        return new BulkRegistrationImpl();
      }
      BulkRegistration2.create = create;
    })(BulkRegistration = exports.BulkRegistration || (exports.BulkRegistration = {}));
    var BulkRegistrationImpl = class {
      constructor() {
        this._registrations = [], this._registered = /* @__PURE__ */ new Set();
      }
      add(type, registerOptions) {
        let method = Is3.string(type) ? type : type.method;
        if (this._registered.has(method))
          throw new Error(`${method} is already added to this registration`);
        let id = UUID.generateUuid();
        this._registrations.push({
          id,
          method,
          registerOptions: registerOptions || {}
        }), this._registered.add(method);
      }
      asRegistrationParams() {
        return {
          registrations: this._registrations
        };
      }
    }, BulkUnregistration;
    (function(BulkUnregistration2) {
      function create() {
        return new BulkUnregistrationImpl(void 0, []);
      }
      BulkUnregistration2.create = create;
    })(BulkUnregistration = exports.BulkUnregistration || (exports.BulkUnregistration = {}));
    var BulkUnregistrationImpl = class {
      constructor(_connection, unregistrations) {
        this._connection = _connection, this._unregistrations = /* @__PURE__ */ new Map(), unregistrations.forEach((unregistration) => {
          this._unregistrations.set(unregistration.method, unregistration);
        });
      }
      get isAttached() {
        return !!this._connection;
      }
      attach(connection) {
        this._connection = connection;
      }
      add(unregistration) {
        this._unregistrations.set(unregistration.method, unregistration);
      }
      dispose() {
        let unregistrations = [];
        for (let unregistration of this._unregistrations.values())
          unregistrations.push(unregistration);
        let params = {
          unregisterations: unregistrations
        };
        this._connection.sendRequest(vscode_languageserver_protocol_1.UnregistrationRequest.type, params).catch(() => {
          this._connection.console.info("Bulk unregistration failed.");
        });
      }
      disposeSingle(arg) {
        let method = Is3.string(arg) ? arg : arg.method, unregistration = this._unregistrations.get(method);
        if (!unregistration)
          return !1;
        let params = {
          unregisterations: [unregistration]
        };
        return this._connection.sendRequest(vscode_languageserver_protocol_1.UnregistrationRequest.type, params).then(() => {
          this._unregistrations.delete(method);
        }, (_error) => {
          this._connection.console.info(`Un-registering request handler for ${unregistration.id} failed.`);
        }), !0;
      }
    }, RemoteClientImpl = class {
      attach(connection) {
        this._connection = connection;
      }
      get connection() {
        if (!this._connection)
          throw new Error("Remote is not attached to a connection yet.");
        return this._connection;
      }
      initialize(_capabilities) {
      }
      fillServerCapabilities(_capabilities) {
      }
      register(typeOrRegistrations, registerOptionsOrType, registerOptions) {
        return typeOrRegistrations instanceof BulkRegistrationImpl ? this.registerMany(typeOrRegistrations) : typeOrRegistrations instanceof BulkUnregistrationImpl ? this.registerSingle1(typeOrRegistrations, registerOptionsOrType, registerOptions) : this.registerSingle2(typeOrRegistrations, registerOptionsOrType);
      }
      registerSingle1(unregistration, type, registerOptions) {
        let method = Is3.string(type) ? type : type.method, id = UUID.generateUuid(), params = {
          registrations: [{ id, method, registerOptions: registerOptions || {} }]
        };
        return unregistration.isAttached || unregistration.attach(this.connection), this.connection.sendRequest(vscode_languageserver_protocol_1.RegistrationRequest.type, params).then((_result) => (unregistration.add({ id, method }), unregistration), (_error) => (this.connection.console.info(`Registering request handler for ${method} failed.`), Promise.reject(_error)));
      }
      registerSingle2(type, registerOptions) {
        let method = Is3.string(type) ? type : type.method, id = UUID.generateUuid(), params = {
          registrations: [{ id, method, registerOptions: registerOptions || {} }]
        };
        return this.connection.sendRequest(vscode_languageserver_protocol_1.RegistrationRequest.type, params).then((_result) => vscode_languageserver_protocol_1.Disposable.create(() => {
          this.unregisterSingle(id, method).catch(() => {
            this.connection.console.info(`Un-registering capability with id ${id} failed.`);
          });
        }), (_error) => (this.connection.console.info(`Registering request handler for ${method} failed.`), Promise.reject(_error)));
      }
      unregisterSingle(id, method) {
        let params = {
          unregisterations: [{ id, method }]
        };
        return this.connection.sendRequest(vscode_languageserver_protocol_1.UnregistrationRequest.type, params).catch(() => {
          this.connection.console.info(`Un-registering request handler for ${id} failed.`);
        });
      }
      registerMany(registrations) {
        let params = registrations.asRegistrationParams();
        return this.connection.sendRequest(vscode_languageserver_protocol_1.RegistrationRequest.type, params).then(() => new BulkUnregistrationImpl(this._connection, params.registrations.map((registration) => ({ id: registration.id, method: registration.method }))), (_error) => (this.connection.console.info("Bulk registration failed."), Promise.reject(_error)));
      }
    }, _RemoteWorkspaceImpl = class {
      constructor() {
      }
      attach(connection) {
        this._connection = connection;
      }
      get connection() {
        if (!this._connection)
          throw new Error("Remote is not attached to a connection yet.");
        return this._connection;
      }
      initialize(_capabilities) {
      }
      fillServerCapabilities(_capabilities) {
      }
      applyEdit(paramOrEdit) {
        function isApplyWorkspaceEditParams(value) {
          return value && !!value.edit;
        }
        let params = isApplyWorkspaceEditParams(paramOrEdit) ? paramOrEdit : { edit: paramOrEdit };
        return this.connection.sendRequest(vscode_languageserver_protocol_1.ApplyWorkspaceEditRequest.type, params);
      }
    }, RemoteWorkspaceImpl = (0, fileOperations_1.FileOperationsFeature)((0, workspaceFolder_1.WorkspaceFoldersFeature)((0, configuration_1.ConfigurationFeature)(_RemoteWorkspaceImpl))), TracerImpl = class {
      constructor() {
        this._trace = vscode_languageserver_protocol_1.Trace.Off;
      }
      attach(connection) {
        this._connection = connection;
      }
      get connection() {
        if (!this._connection)
          throw new Error("Remote is not attached to a connection yet.");
        return this._connection;
      }
      initialize(_capabilities) {
      }
      fillServerCapabilities(_capabilities) {
      }
      set trace(value) {
        this._trace = value;
      }
      log(message, verbose) {
        this._trace !== vscode_languageserver_protocol_1.Trace.Off && this.connection.sendNotification(vscode_languageserver_protocol_1.LogTraceNotification.type, {
          message,
          verbose: this._trace === vscode_languageserver_protocol_1.Trace.Verbose ? verbose : void 0
        }).catch(() => {
        });
      }
    }, TelemetryImpl = class {
      constructor() {
      }
      attach(connection) {
        this._connection = connection;
      }
      get connection() {
        if (!this._connection)
          throw new Error("Remote is not attached to a connection yet.");
        return this._connection;
      }
      initialize(_capabilities) {
      }
      fillServerCapabilities(_capabilities) {
      }
      logEvent(data) {
        this.connection.sendNotification(vscode_languageserver_protocol_1.TelemetryEventNotification.type, data).catch(() => {
          this.connection.console.log("Sending TelemetryEventNotification failed");
        });
      }
    }, _LanguagesImpl = class {
      constructor() {
      }
      attach(connection) {
        this._connection = connection;
      }
      get connection() {
        if (!this._connection)
          throw new Error("Remote is not attached to a connection yet.");
        return this._connection;
      }
      initialize(_capabilities) {
      }
      fillServerCapabilities(_capabilities) {
      }
      attachWorkDoneProgress(params) {
        return (0, progress_1.attachWorkDone)(this.connection, params);
      }
      attachPartialResultProgress(_type, params) {
        return (0, progress_1.attachPartialResult)(this.connection, params);
      }
    };
    exports._LanguagesImpl = _LanguagesImpl;
    var LanguagesImpl = (0, moniker_1.MonikerFeature)((0, diagnostic_1.DiagnosticFeature)((0, inlayHint_1.InlayHintFeature)((0, inlineValue_1.InlineValueFeature)((0, typeHierarchy_1.TypeHierarchyFeature)((0, linkedEditingRange_1.LinkedEditingRangeFeature)((0, semanticTokens_1.SemanticTokensFeature)((0, callHierarchy_1.CallHierarchyFeature)(_LanguagesImpl)))))))), _NotebooksImpl = class {
      constructor() {
      }
      attach(connection) {
        this._connection = connection;
      }
      get connection() {
        if (!this._connection)
          throw new Error("Remote is not attached to a connection yet.");
        return this._connection;
      }
      initialize(_capabilities) {
      }
      fillServerCapabilities(_capabilities) {
      }
      attachWorkDoneProgress(params) {
        return (0, progress_1.attachWorkDone)(this.connection, params);
      }
      attachPartialResultProgress(_type, params) {
        return (0, progress_1.attachPartialResult)(this.connection, params);
      }
    };
    exports._NotebooksImpl = _NotebooksImpl;
    var NotebooksImpl = (0, notebook_1.NotebookSyncFeature)(_NotebooksImpl);
    function combineConsoleFeatures(one, two) {
      return function(Base) {
        return two(one(Base));
      };
    }
    exports.combineConsoleFeatures = combineConsoleFeatures;
    function combineTelemetryFeatures(one, two) {
      return function(Base) {
        return two(one(Base));
      };
    }
    exports.combineTelemetryFeatures = combineTelemetryFeatures;
    function combineTracerFeatures(one, two) {
      return function(Base) {
        return two(one(Base));
      };
    }
    exports.combineTracerFeatures = combineTracerFeatures;
    function combineClientFeatures(one, two) {
      return function(Base) {
        return two(one(Base));
      };
    }
    exports.combineClientFeatures = combineClientFeatures;
    function combineWindowFeatures(one, two) {
      return function(Base) {
        return two(one(Base));
      };
    }
    exports.combineWindowFeatures = combineWindowFeatures;
    function combineWorkspaceFeatures(one, two) {
      return function(Base) {
        return two(one(Base));
      };
    }
    exports.combineWorkspaceFeatures = combineWorkspaceFeatures;
    function combineLanguagesFeatures(one, two) {
      return function(Base) {
        return two(one(Base));
      };
    }
    exports.combineLanguagesFeatures = combineLanguagesFeatures;
    function combineNotebooksFeatures(one, two) {
      return function(Base) {
        return two(one(Base));
      };
    }
    exports.combineNotebooksFeatures = combineNotebooksFeatures;
    function combineFeatures(one, two) {
      function combine(one2, two2, func) {
        return one2 && two2 ? func(one2, two2) : one2 || two2;
      }
      return {
        __brand: "features",
        console: combine(one.console, two.console, combineConsoleFeatures),
        tracer: combine(one.tracer, two.tracer, combineTracerFeatures),
        telemetry: combine(one.telemetry, two.telemetry, combineTelemetryFeatures),
        client: combine(one.client, two.client, combineClientFeatures),
        window: combine(one.window, two.window, combineWindowFeatures),
        workspace: combine(one.workspace, two.workspace, combineWorkspaceFeatures),
        languages: combine(one.languages, two.languages, combineLanguagesFeatures),
        notebooks: combine(one.notebooks, two.notebooks, combineNotebooksFeatures)
      };
    }
    exports.combineFeatures = combineFeatures;
    function createConnection(connectionFactory, watchDog, factories) {
      let logger = factories && factories.console ? new (factories.console(RemoteConsoleImpl))() : new RemoteConsoleImpl(), connection = connectionFactory(logger);
      logger.rawAttach(connection);
      let tracer = factories && factories.tracer ? new (factories.tracer(TracerImpl))() : new TracerImpl(), telemetry = factories && factories.telemetry ? new (factories.telemetry(TelemetryImpl))() : new TelemetryImpl(), client = factories && factories.client ? new (factories.client(RemoteClientImpl))() : new RemoteClientImpl(), remoteWindow = factories && factories.window ? new (factories.window(RemoteWindowImpl))() : new RemoteWindowImpl(), workspace = factories && factories.workspace ? new (factories.workspace(RemoteWorkspaceImpl))() : new RemoteWorkspaceImpl(), languages = factories && factories.languages ? new (factories.languages(LanguagesImpl))() : new LanguagesImpl(), notebooks = factories && factories.notebooks ? new (factories.notebooks(NotebooksImpl))() : new NotebooksImpl(), allRemotes = [logger, tracer, telemetry, client, remoteWindow, workspace, languages, notebooks];
      function asPromise(value) {
        return value instanceof Promise ? value : Is3.thenable(value) ? new Promise((resolve2, reject) => {
          value.then((resolved) => resolve2(resolved), (error) => reject(error));
        }) : Promise.resolve(value);
      }
      let shutdownHandler, initializeHandler, exitHandler, protocolConnection = {
        listen: () => connection.listen(),
        sendRequest: (type, ...params) => connection.sendRequest(Is3.string(type) ? type : type.method, ...params),
        onRequest: (type, handler) => connection.onRequest(type, handler),
        sendNotification: (type, param) => {
          let method = Is3.string(type) ? type : type.method;
          return arguments.length === 1 ? connection.sendNotification(method) : connection.sendNotification(method, param);
        },
        onNotification: (type, handler) => connection.onNotification(type, handler),
        onProgress: connection.onProgress,
        sendProgress: connection.sendProgress,
        onInitialize: (handler) => (initializeHandler = handler, {
          dispose: () => {
            initializeHandler = void 0;
          }
        }),
        onInitialized: (handler) => connection.onNotification(vscode_languageserver_protocol_1.InitializedNotification.type, handler),
        onShutdown: (handler) => (shutdownHandler = handler, {
          dispose: () => {
            shutdownHandler = void 0;
          }
        }),
        onExit: (handler) => (exitHandler = handler, {
          dispose: () => {
            exitHandler = void 0;
          }
        }),
        get console() {
          return logger;
        },
        get telemetry() {
          return telemetry;
        },
        get tracer() {
          return tracer;
        },
        get client() {
          return client;
        },
        get window() {
          return remoteWindow;
        },
        get workspace() {
          return workspace;
        },
        get languages() {
          return languages;
        },
        get notebooks() {
          return notebooks;
        },
        onDidChangeConfiguration: (handler) => connection.onNotification(vscode_languageserver_protocol_1.DidChangeConfigurationNotification.type, handler),
        onDidChangeWatchedFiles: (handler) => connection.onNotification(vscode_languageserver_protocol_1.DidChangeWatchedFilesNotification.type, handler),
        __textDocumentSync: void 0,
        onDidOpenTextDocument: (handler) => connection.onNotification(vscode_languageserver_protocol_1.DidOpenTextDocumentNotification.type, handler),
        onDidChangeTextDocument: (handler) => connection.onNotification(vscode_languageserver_protocol_1.DidChangeTextDocumentNotification.type, handler),
        onDidCloseTextDocument: (handler) => connection.onNotification(vscode_languageserver_protocol_1.DidCloseTextDocumentNotification.type, handler),
        onWillSaveTextDocument: (handler) => connection.onNotification(vscode_languageserver_protocol_1.WillSaveTextDocumentNotification.type, handler),
        onWillSaveTextDocumentWaitUntil: (handler) => connection.onRequest(vscode_languageserver_protocol_1.WillSaveTextDocumentWaitUntilRequest.type, handler),
        onDidSaveTextDocument: (handler) => connection.onNotification(vscode_languageserver_protocol_1.DidSaveTextDocumentNotification.type, handler),
        sendDiagnostics: (params) => connection.sendNotification(vscode_languageserver_protocol_1.PublishDiagnosticsNotification.type, params),
        onHover: (handler) => connection.onRequest(vscode_languageserver_protocol_1.HoverRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), void 0)),
        onCompletion: (handler) => connection.onRequest(vscode_languageserver_protocol_1.CompletionRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), (0, progress_1.attachPartialResult)(connection, params))),
        onCompletionResolve: (handler) => connection.onRequest(vscode_languageserver_protocol_1.CompletionResolveRequest.type, handler),
        onSignatureHelp: (handler) => connection.onRequest(vscode_languageserver_protocol_1.SignatureHelpRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), void 0)),
        onDeclaration: (handler) => connection.onRequest(vscode_languageserver_protocol_1.DeclarationRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), (0, progress_1.attachPartialResult)(connection, params))),
        onDefinition: (handler) => connection.onRequest(vscode_languageserver_protocol_1.DefinitionRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), (0, progress_1.attachPartialResult)(connection, params))),
        onTypeDefinition: (handler) => connection.onRequest(vscode_languageserver_protocol_1.TypeDefinitionRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), (0, progress_1.attachPartialResult)(connection, params))),
        onImplementation: (handler) => connection.onRequest(vscode_languageserver_protocol_1.ImplementationRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), (0, progress_1.attachPartialResult)(connection, params))),
        onReferences: (handler) => connection.onRequest(vscode_languageserver_protocol_1.ReferencesRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), (0, progress_1.attachPartialResult)(connection, params))),
        onDocumentHighlight: (handler) => connection.onRequest(vscode_languageserver_protocol_1.DocumentHighlightRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), (0, progress_1.attachPartialResult)(connection, params))),
        onDocumentSymbol: (handler) => connection.onRequest(vscode_languageserver_protocol_1.DocumentSymbolRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), (0, progress_1.attachPartialResult)(connection, params))),
        onWorkspaceSymbol: (handler) => connection.onRequest(vscode_languageserver_protocol_1.WorkspaceSymbolRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), (0, progress_1.attachPartialResult)(connection, params))),
        onWorkspaceSymbolResolve: (handler) => connection.onRequest(vscode_languageserver_protocol_1.WorkspaceSymbolResolveRequest.type, handler),
        onCodeAction: (handler) => connection.onRequest(vscode_languageserver_protocol_1.CodeActionRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), (0, progress_1.attachPartialResult)(connection, params))),
        onCodeActionResolve: (handler) => connection.onRequest(vscode_languageserver_protocol_1.CodeActionResolveRequest.type, (params, cancel) => handler(params, cancel)),
        onCodeLens: (handler) => connection.onRequest(vscode_languageserver_protocol_1.CodeLensRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), (0, progress_1.attachPartialResult)(connection, params))),
        onCodeLensResolve: (handler) => connection.onRequest(vscode_languageserver_protocol_1.CodeLensResolveRequest.type, (params, cancel) => handler(params, cancel)),
        onDocumentFormatting: (handler) => connection.onRequest(vscode_languageserver_protocol_1.DocumentFormattingRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), void 0)),
        onDocumentRangeFormatting: (handler) => connection.onRequest(vscode_languageserver_protocol_1.DocumentRangeFormattingRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), void 0)),
        onDocumentOnTypeFormatting: (handler) => connection.onRequest(vscode_languageserver_protocol_1.DocumentOnTypeFormattingRequest.type, (params, cancel) => handler(params, cancel)),
        onRenameRequest: (handler) => connection.onRequest(vscode_languageserver_protocol_1.RenameRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), void 0)),
        onPrepareRename: (handler) => connection.onRequest(vscode_languageserver_protocol_1.PrepareRenameRequest.type, (params, cancel) => handler(params, cancel)),
        onDocumentLinks: (handler) => connection.onRequest(vscode_languageserver_protocol_1.DocumentLinkRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), (0, progress_1.attachPartialResult)(connection, params))),
        onDocumentLinkResolve: (handler) => connection.onRequest(vscode_languageserver_protocol_1.DocumentLinkResolveRequest.type, (params, cancel) => handler(params, cancel)),
        onDocumentColor: (handler) => connection.onRequest(vscode_languageserver_protocol_1.DocumentColorRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), (0, progress_1.attachPartialResult)(connection, params))),
        onColorPresentation: (handler) => connection.onRequest(vscode_languageserver_protocol_1.ColorPresentationRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), (0, progress_1.attachPartialResult)(connection, params))),
        onFoldingRanges: (handler) => connection.onRequest(vscode_languageserver_protocol_1.FoldingRangeRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), (0, progress_1.attachPartialResult)(connection, params))),
        onSelectionRanges: (handler) => connection.onRequest(vscode_languageserver_protocol_1.SelectionRangeRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), (0, progress_1.attachPartialResult)(connection, params))),
        onExecuteCommand: (handler) => connection.onRequest(vscode_languageserver_protocol_1.ExecuteCommandRequest.type, (params, cancel) => handler(params, cancel, (0, progress_1.attachWorkDone)(connection, params), void 0)),
        dispose: () => connection.dispose()
      };
      for (let remote of allRemotes)
        remote.attach(protocolConnection);
      return connection.onRequest(vscode_languageserver_protocol_1.InitializeRequest.type, (params) => {
        watchDog.initialize(params), Is3.string(params.trace) && (tracer.trace = vscode_languageserver_protocol_1.Trace.fromString(params.trace));
        for (let remote of allRemotes)
          remote.initialize(params.capabilities);
        if (initializeHandler) {
          let result = initializeHandler(params, new vscode_languageserver_protocol_1.CancellationTokenSource().token, (0, progress_1.attachWorkDone)(connection, params), void 0);
          return asPromise(result).then((value) => {
            if (value instanceof vscode_languageserver_protocol_1.ResponseError)
              return value;
            let result2 = value;
            result2 || (result2 = { capabilities: {} });
            let capabilities = result2.capabilities;
            capabilities || (capabilities = {}, result2.capabilities = capabilities), capabilities.textDocumentSync === void 0 || capabilities.textDocumentSync === null ? capabilities.textDocumentSync = Is3.number(protocolConnection.__textDocumentSync) ? protocolConnection.__textDocumentSync : vscode_languageserver_protocol_1.TextDocumentSyncKind.None : !Is3.number(capabilities.textDocumentSync) && !Is3.number(capabilities.textDocumentSync.change) && (capabilities.textDocumentSync.change = Is3.number(protocolConnection.__textDocumentSync) ? protocolConnection.__textDocumentSync : vscode_languageserver_protocol_1.TextDocumentSyncKind.None);
            for (let remote of allRemotes)
              remote.fillServerCapabilities(capabilities);
            return result2;
          });
        } else {
          let result = { capabilities: { textDocumentSync: vscode_languageserver_protocol_1.TextDocumentSyncKind.None } };
          for (let remote of allRemotes)
            remote.fillServerCapabilities(result.capabilities);
          return result;
        }
      }), connection.onRequest(vscode_languageserver_protocol_1.ShutdownRequest.type, () => {
        if (watchDog.shutdownReceived = !0, shutdownHandler)
          return shutdownHandler(new vscode_languageserver_protocol_1.CancellationTokenSource().token);
      }), connection.onNotification(vscode_languageserver_protocol_1.ExitNotification.type, () => {
        try {
          exitHandler && exitHandler();
        } finally {
          watchDog.shutdownReceived ? watchDog.exit(0) : watchDog.exit(1);
        }
      }), connection.onNotification(vscode_languageserver_protocol_1.SetTraceNotification.type, (params) => {
        tracer.trace = vscode_languageserver_protocol_1.Trace.fromString(params.value);
      }), protocolConnection;
    }
    exports.createConnection = createConnection;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/node/files.js
var require_files = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/node/files.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.resolveModulePath = exports.FileSystem = exports.resolveGlobalYarnPath = exports.resolveGlobalNodePath = exports.resolve = exports.uriToFilePath = void 0;
    var url = __require("url"), path3 = __require("path"), fs6 = __require("fs"), child_process_1 = __require("child_process");
    function uriToFilePath(uri) {
      let parsed = url.parse(uri);
      if (parsed.protocol !== "file:" || !parsed.path)
        return;
      let segments = parsed.path.split("/");
      for (var i = 0, len = segments.length; i < len; i++)
        segments[i] = decodeURIComponent(segments[i]);
      if (process.platform === "win32" && segments.length > 1) {
        let first = segments[0], second = segments[1];
        first.length === 0 && second.length > 1 && second[1] === ":" && segments.shift();
      }
      return path3.normalize(segments.join("/"));
    }
    exports.uriToFilePath = uriToFilePath;
    function isWindows() {
      return process.platform === "win32";
    }
    function resolve2(moduleName, nodePath2, cwd2, tracer) {
      let nodePathKey = "NODE_PATH", app = [
        "var p = process;",
        "p.on('message',function(m){",
        "if(m.c==='e'){",
        "p.exit(0);",
        "}",
        "else if(m.c==='rs'){",
        "try{",
        "var r=require.resolve(m.a);",
        "p.send({c:'r',s:true,r:r});",
        "}",
        "catch(err){",
        "p.send({c:'r',s:false});",
        "}",
        "}",
        "});"
      ].join("");
      return new Promise((resolve3, reject) => {
        let env = process.env, newEnv = /* @__PURE__ */ Object.create(null);
        Object.keys(env).forEach((key) => newEnv[key] = env[key]), nodePath2 && fs6.existsSync(nodePath2) && (newEnv[nodePathKey] ? newEnv[nodePathKey] = nodePath2 + path3.delimiter + newEnv[nodePathKey] : newEnv[nodePathKey] = nodePath2, tracer && tracer(`NODE_PATH value is: ${newEnv[nodePathKey]}`)), newEnv.ELECTRON_RUN_AS_NODE = "1";
        try {
          let cp3 = (0, child_process_1.fork)("", [], {
            cwd: cwd2,
            env: newEnv,
            execArgv: ["-e", app]
          });
          if (cp3.pid === void 0) {
            reject(new Error(`Starting process to resolve node module  ${moduleName} failed`));
            return;
          }
          cp3.on("error", (error) => {
            reject(error);
          }), cp3.on("message", (message2) => {
            message2.c === "r" && (cp3.send({ c: "e" }), message2.s ? resolve3(message2.r) : reject(new Error(`Failed to resolve module: ${moduleName}`)));
          });
          let message = {
            c: "rs",
            a: moduleName
          };
          cp3.send(message);
        } catch (error) {
          reject(error);
        }
      });
    }
    exports.resolve = resolve2;
    function resolveGlobalNodePath(tracer) {
      let npmCommand = "npm", env = /* @__PURE__ */ Object.create(null);
      Object.keys(process.env).forEach((key) => env[key] = process.env[key]), env.NO_UPDATE_NOTIFIER = "true";
      let options = {
        encoding: "utf8",
        env
      };
      isWindows() && (npmCommand = "npm.cmd", options.shell = !0);
      let handler = () => {
      };
      try {
        process.on("SIGPIPE", handler);
        let stdout = (0, child_process_1.spawnSync)(npmCommand, ["config", "get", "prefix"], options).stdout;
        if (!stdout) {
          tracer && tracer("'npm config get prefix' didn't return a value.");
          return;
        }
        let prefix = stdout.trim();
        return tracer && tracer(`'npm config get prefix' value is: ${prefix}`), prefix.length > 0 ? isWindows() ? path3.join(prefix, "node_modules") : path3.join(prefix, "lib", "node_modules") : void 0;
      } catch {
        return;
      } finally {
        process.removeListener("SIGPIPE", handler);
      }
    }
    exports.resolveGlobalNodePath = resolveGlobalNodePath;
    function resolveGlobalYarnPath(tracer) {
      let yarnCommand = "yarn", options = {
        encoding: "utf8"
      };
      isWindows() && (yarnCommand = "yarn.cmd", options.shell = !0);
      let handler = () => {
      };
      try {
        process.on("SIGPIPE", handler);
        let results = (0, child_process_1.spawnSync)(yarnCommand, ["global", "dir", "--json"], options), stdout = results.stdout;
        if (!stdout) {
          tracer && (tracer("'yarn global dir' didn't return a value."), results.stderr && tracer(results.stderr));
          return;
        }
        let lines = stdout.trim().split(/\r?\n/);
        for (let line of lines)
          try {
            let yarn = JSON.parse(line);
            if (yarn.type === "log")
              return path3.join(yarn.data, "node_modules");
          } catch {
          }
        return;
      } catch {
        return;
      } finally {
        process.removeListener("SIGPIPE", handler);
      }
    }
    exports.resolveGlobalYarnPath = resolveGlobalYarnPath;
    var FileSystem;
    (function(FileSystem2) {
      let _isCaseSensitive;
      function isCaseSensitive() {
        return _isCaseSensitive !== void 0 || (process.platform === "win32" ? _isCaseSensitive = !1 : _isCaseSensitive = !fs6.existsSync(__filename.toUpperCase()) || !fs6.existsSync(__filename.toLowerCase())), _isCaseSensitive;
      }
      FileSystem2.isCaseSensitive = isCaseSensitive;
      function isParent(parent, child) {
        return isCaseSensitive() ? path3.normalize(child).indexOf(path3.normalize(parent)) === 0 : path3.normalize(child).toLowerCase().indexOf(path3.normalize(parent).toLowerCase()) === 0;
      }
      FileSystem2.isParent = isParent;
    })(FileSystem = exports.FileSystem || (exports.FileSystem = {}));
    function resolveModulePath(workspaceRoot, moduleName, nodePath2, tracer) {
      return nodePath2 ? (path3.isAbsolute(nodePath2) || (nodePath2 = path3.join(workspaceRoot, nodePath2)), resolve2(moduleName, nodePath2, nodePath2, tracer).then((value) => FileSystem.isParent(nodePath2, value) ? value : Promise.reject(new Error(`Failed to load ${moduleName} from node path location.`))).then(void 0, (_error) => resolve2(moduleName, resolveGlobalNodePath(tracer), workspaceRoot, tracer))) : resolve2(moduleName, resolveGlobalNodePath(tracer), workspaceRoot, tracer);
    }
    exports.resolveModulePath = resolveModulePath;
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/node.js
var require_node3 = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver-protocol@3.17.3/node_modules/vscode-languageserver-protocol/node.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = require_main4();
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/api.js
var require_api3 = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/common/api.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p) && __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ProposedFeatures = exports.NotebookDocuments = exports.TextDocuments = exports.SemanticTokensBuilder = void 0;
    var semanticTokens_1 = require_semanticTokens();
    Object.defineProperty(exports, "SemanticTokensBuilder", { enumerable: !0, get: function() {
      return semanticTokens_1.SemanticTokensBuilder;
    } });
    __exportStar(require_main4(), exports);
    var textDocuments_1 = require_textDocuments();
    Object.defineProperty(exports, "TextDocuments", { enumerable: !0, get: function() {
      return textDocuments_1.TextDocuments;
    } });
    var notebook_1 = require_notebook();
    Object.defineProperty(exports, "NotebookDocuments", { enumerable: !0, get: function() {
      return notebook_1.NotebookDocuments;
    } });
    __exportStar(require_server(), exports);
    var ProposedFeatures;
    (function(ProposedFeatures2) {
      ProposedFeatures2.all = {
        __brand: "features"
      };
    })(ProposedFeatures = exports.ProposedFeatures || (exports.ProposedFeatures = {}));
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/node/main.js
var require_main5 = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/lib/node/main.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p) && __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.createConnection = exports.Files = void 0;
    var Is3 = require_is(), server_1 = require_server(), fm = require_files(), node_1 = require_node3();
    __exportStar(require_node3(), exports);
    __exportStar(require_api3(), exports);
    var Files;
    (function(Files2) {
      Files2.uriToFilePath = fm.uriToFilePath, Files2.resolveGlobalNodePath = fm.resolveGlobalNodePath, Files2.resolveGlobalYarnPath = fm.resolveGlobalYarnPath, Files2.resolve = fm.resolve, Files2.resolveModulePath = fm.resolveModulePath;
    })(Files = exports.Files || (exports.Files = {}));
    var _protocolConnection;
    function endProtocolConnection() {
      if (_protocolConnection !== void 0)
        try {
          _protocolConnection.end();
        } catch {
        }
    }
    var _shutdownReceived = !1, exitTimer;
    function setupExitTimer() {
      let argName = "--clientProcessId";
      function runTimer(value) {
        try {
          let processId = parseInt(value);
          isNaN(processId) || (exitTimer = setInterval(() => {
            try {
              process.kill(processId, 0);
            } catch {
              endProtocolConnection(), process.exit(_shutdownReceived ? 0 : 1);
            }
          }, 3e3));
        } catch {
        }
      }
      for (let i = 2; i < process.argv.length; i++) {
        let arg = process.argv[i];
        if (arg === argName && i + 1 < process.argv.length) {
          runTimer(process.argv[i + 1]);
          return;
        } else {
          let args = arg.split("=");
          args[0] === argName && runTimer(args[1]);
        }
      }
    }
    setupExitTimer();
    var watchDog = {
      initialize: (params) => {
        let processId = params.processId;
        Is3.number(processId) && exitTimer === void 0 && setInterval(() => {
          try {
            process.kill(processId, 0);
          } catch {
            process.exit(_shutdownReceived ? 0 : 1);
          }
        }, 3e3);
      },
      get shutdownReceived() {
        return _shutdownReceived;
      },
      set shutdownReceived(value) {
        _shutdownReceived = value;
      },
      exit: (code) => {
        endProtocolConnection(), process.exit(code);
      }
    };
    function createConnection(arg1, arg2, arg3, arg4) {
      let factories, input, output, options;
      return arg1 !== void 0 && arg1.__brand === "features" && (factories = arg1, arg1 = arg2, arg2 = arg3, arg3 = arg4), node_1.ConnectionStrategy.is(arg1) || node_1.ConnectionOptions.is(arg1) ? options = arg1 : (input = arg1, output = arg2, options = arg3), _createConnection(input, output, options, factories);
    }
    exports.createConnection = createConnection;
    function _createConnection(input, output, options, factories) {
      if (!input && !output && process.argv.length > 2) {
        let port, pipeName, argv = process.argv.slice(2);
        for (let i = 0; i < argv.length; i++) {
          let arg = argv[i];
          if (arg === "--node-ipc") {
            input = new node_1.IPCMessageReader(process), output = new node_1.IPCMessageWriter(process);
            break;
          } else if (arg === "--stdio") {
            input = process.stdin, output = process.stdout;
            break;
          } else if (arg === "--socket") {
            port = parseInt(argv[i + 1]);
            break;
          } else if (arg === "--pipe") {
            pipeName = argv[i + 1];
            break;
          } else {
            var args = arg.split("=");
            if (args[0] === "--socket") {
              port = parseInt(args[1]);
              break;
            } else if (args[0] === "--pipe") {
              pipeName = args[1];
              break;
            }
          }
        }
        if (port) {
          let transport = (0, node_1.createServerSocketTransport)(port);
          input = transport[0], output = transport[1];
        } else if (pipeName) {
          let transport = (0, node_1.createServerPipeTransport)(pipeName);
          input = transport[0], output = transport[1];
        }
      }
      var commandLineMessage = "Use arguments of createConnection or set command line parameters: '--node-ipc', '--stdio' or '--socket={number}'";
      if (!input)
        throw new Error("Connection input stream is not set. " + commandLineMessage);
      if (!output)
        throw new Error("Connection output stream is not set. " + commandLineMessage);
      if (Is3.func(input.read) && Is3.func(input.on)) {
        let inputStream = input;
        inputStream.on("end", () => {
          endProtocolConnection(), process.exit(_shutdownReceived ? 0 : 1);
        }), inputStream.on("close", () => {
          endProtocolConnection(), process.exit(_shutdownReceived ? 0 : 1);
        });
      }
      let connectionFactory = (logger) => (0, node_1.createProtocolConnection)(input, output, logger, options);
      return (0, server_1.createConnection)(connectionFactory, watchDog, factories);
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/ClientCapabilities.js
var require_ClientCapabilities = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/ClientCapabilities.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ClientCapabilities = void 0;
    var ClientCapabilities2 = class {
      constructor() {
        this.capabilities = {}, this.initializationOptions = {};
      }
      setup(capabilities, initializationOptions = {}) {
        this.capabilities = capabilities, this.initializationOptions = initializationOptions;
      }
      get hasWorkspaceConfigurationSupport() {
        var _a38, _b;
        return !!(!((_b = (_a38 = this.capabilities) === null || _a38 === void 0 ? void 0 : _a38.workspace) === null || _b === void 0) && _b.configuration);
      }
      get hasApplyEditSupport() {
        var _a38, _b;
        return !!(!((_b = (_a38 = this.capabilities) === null || _a38 === void 0 ? void 0 : _a38.workspace) === null || _b === void 0) && _b.applyEdit);
      }
      get hasDidChangeConfigurationDynamicRegistrationSupport() {
        var _a38, _b, _c;
        return !!(!((_c = (_b = (_a38 = this.capabilities) === null || _a38 === void 0 ? void 0 : _a38.workspace) === null || _b === void 0 ? void 0 : _b.didChangeConfiguration) === null || _c === void 0) && _c.dynamicRegistration);
      }
      initializationOption(key, defaultValue) {
        var _a38;
        let direct = (_a38 = this.initializationOptions) === null || _a38 === void 0 ? void 0 : _a38[key];
        if (direct !== void 0)
          return direct;
        let nested = pathGet(this.initializationOptions, key);
        return nested !== void 0 ? nested : defaultValue;
      }
    };
    exports.ClientCapabilities = ClientCapabilities2;
    function pathGet(obj, key) {
      return key.split(".").reduce((acc, subpath) => acc?.[subpath], obj);
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/commands/BaseExecuteCommandProvider.js
var require_BaseExecuteCommandProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/commands/BaseExecuteCommandProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.BaseExecuteCommandProvider = void 0;
    var BaseExecuteCommandProvider = class {
      constructor(documentManager, diagnosticsManager, clientCapabilities, connection) {
        this.documentManager = documentManager, this.diagnosticsManager = diagnosticsManager, this.clientCapabilities = clientCapabilities, this.connection = connection;
      }
    };
    exports.BaseExecuteCommandProvider = BaseExecuteCommandProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/commands/providers/ApplyFixesProvider.js
var require_ApplyFixesProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/commands/providers/ApplyFixesProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.applyFixCommand = exports.ApplyFixesProvider = void 0;
    var theme_check_common_1 = require_dist2(), vscode_languageserver_1 = require_main5(), BaseExecuteCommandProvider_1 = require_BaseExecuteCommandProvider(), ApplyFixesProvider = class extends BaseExecuteCommandProvider_1.BaseExecuteCommandProvider {
      async execute(uri, version2, ids) {
        if (!this.clientCapabilities.hasApplyEditSupport)
          return;
        let diagnostics = this.diagnosticsManager.get(uri), document2 = this.documentManager.get(uri);
        if (!document2 || !diagnostics || document2.version !== version2 || diagnostics.version !== version2)
          return;
        let anomalies = ids.map((id) => diagnostics.anomalies[id]).filter((anomaly) => !!anomaly.offense.fix), fixes = anomalies.map((anomaly) => anomaly.offense.fix), corrector = (0, theme_check_common_1.createCorrector)(document2.type, document2.source);
        for (let collectFixes of fixes)
          collectFixes(corrector);
        let { textDocument } = document2, textDocumentEdit = vscode_languageserver_1.TextDocumentEdit.create({ uri: textDocument.uri, version: textDocument.version }, toTextEdits(document2.textDocument, corrector.fix));
        await this.connection.sendRequest(vscode_languageserver_1.ApplyWorkspaceEditRequest.type, {
          edit: {
            documentChanges: [textDocumentEdit]
          }
        });
        let offenses = diagnostics.anomalies.map((a) => a.offense), fixedOffenses = anomalies.map((a) => a.offense), remainingOffenses = offenses.filter((offense) => !fixedOffenses.includes(offense));
        this.diagnosticsManager.set(uri, diagnostics.version, remainingOffenses);
      }
    };
    exports.ApplyFixesProvider = ApplyFixesProvider;
    ApplyFixesProvider.command = "themeCheck/applyFixes";
    function applyFixCommand(uri, version2, ids) {
      return vscode_languageserver_1.Command.create("applyFixes", ApplyFixesProvider.command, uri, version2, ids);
    }
    exports.applyFixCommand = applyFixCommand;
    function toTextEdit(document2, fixDesc) {
      return {
        newText: fixDesc.insert,
        range: {
          start: document2.positionAt(fixDesc.startIndex),
          end: document2.positionAt(fixDesc.endIndex)
        }
      };
    }
    function toTextEdits(document2, fix) {
      return (0, theme_check_common_1.flattenFixes)(fix).map((fixDesc) => toTextEdit(document2, fixDesc));
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/commands/providers/ApplySuggestionProvider.js
var require_ApplySuggestionProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/commands/providers/ApplySuggestionProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.applySuggestionCommand = exports.ApplySuggestionProvider = void 0;
    var theme_check_common_1 = require_dist2(), vscode_languageserver_1 = require_main5(), BaseExecuteCommandProvider_1 = require_BaseExecuteCommandProvider(), ApplySuggestionProvider = class extends BaseExecuteCommandProvider_1.BaseExecuteCommandProvider {
      async execute(uri, version2, anomalyId, suggestionIndex) {
        var _a38;
        if (!this.clientCapabilities.hasApplyEditSupport)
          return;
        let diagnostics = this.diagnosticsManager.get(uri), document2 = this.documentManager.get(uri);
        if (!document2 || !diagnostics || document2.version !== version2 || diagnostics.version !== version2)
          return;
        let anomaly = diagnostics.anomalies[anomalyId];
        if (!anomaly)
          return;
        let offense = anomaly.offense, suggestion = (_a38 = offense.suggest) === null || _a38 === void 0 ? void 0 : _a38[suggestionIndex];
        if (!suggestion)
          return;
        let corrector = (0, theme_check_common_1.createCorrector)(document2.type, document2.source);
        suggestion.fix(corrector);
        let { textDocument } = document2, textDocumentEdit = vscode_languageserver_1.TextDocumentEdit.create({ uri: textDocument.uri, version: textDocument.version }, toTextEdits(document2.textDocument, corrector.fix));
        await this.connection.sendRequest(vscode_languageserver_1.ApplyWorkspaceEditRequest.type, {
          label: `Apply suggestion: ${suggestion.message}`,
          edit: {
            documentChanges: [textDocumentEdit]
          }
        });
        let offenses = diagnostics.anomalies.map((a) => a.offense), fixedOffense = offense, remainingOffenses = offenses.filter((offense2) => offense2 !== fixedOffense);
        this.diagnosticsManager.set(uri, diagnostics.version, remainingOffenses);
      }
    };
    exports.ApplySuggestionProvider = ApplySuggestionProvider;
    ApplySuggestionProvider.command = "themeCheck/applySuggestion";
    function applySuggestionCommand(uri, version2, anomalyId, suggestionIndex) {
      return vscode_languageserver_1.Command.create("applySuggestion", ApplySuggestionProvider.command, uri, version2, anomalyId, suggestionIndex);
    }
    exports.applySuggestionCommand = applySuggestionCommand;
    function toTextEdits(document2, fix) {
      return (0, theme_check_common_1.flattenFixes)(fix).map((fixDesc) => toTextEdit(document2, fixDesc));
    }
    function toTextEdit(document2, fixDesc) {
      return {
        newText: fixDesc.insert,
        range: {
          start: document2.positionAt(fixDesc.startIndex),
          end: document2.positionAt(fixDesc.endIndex)
        }
      };
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/commands/providers/RunChecksProvider.js
var require_RunChecksProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/commands/providers/RunChecksProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.RunChecksProvider = void 0;
    var BaseExecuteCommandProvider_1 = require_BaseExecuteCommandProvider(), RunChecksProvider = class extends BaseExecuteCommandProvider_1.BaseExecuteCommandProvider {
      constructor(documentManager, diagnosticsManager, clientCapabilities, connection, runChecks) {
        super(documentManager, diagnosticsManager, clientCapabilities, connection), this.documentManager = documentManager, this.diagnosticsManager = diagnosticsManager, this.clientCapabilities = clientCapabilities, this.connection = connection, this.runChecks = runChecks;
      }
      async execute() {
        let triggerURIs = this.documentManager.openDocuments.map((sourceCode) => sourceCode.uri);
        this.runChecks(triggerURIs);
      }
    };
    exports.RunChecksProvider = RunChecksProvider;
    RunChecksProvider.command = "themeCheck/runChecks";
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/commands/providers/index.js
var require_providers = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/commands/providers/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.RunChecksProvider = exports.ApplySuggestionProvider = exports.applySuggestionCommand = exports.ApplyFixesProvider = exports.applyFixCommand = void 0;
    var ApplyFixesProvider_1 = require_ApplyFixesProvider();
    Object.defineProperty(exports, "applyFixCommand", { enumerable: !0, get: function() {
      return ApplyFixesProvider_1.applyFixCommand;
    } });
    Object.defineProperty(exports, "ApplyFixesProvider", { enumerable: !0, get: function() {
      return ApplyFixesProvider_1.ApplyFixesProvider;
    } });
    var ApplySuggestionProvider_1 = require_ApplySuggestionProvider();
    Object.defineProperty(exports, "applySuggestionCommand", { enumerable: !0, get: function() {
      return ApplySuggestionProvider_1.applySuggestionCommand;
    } });
    Object.defineProperty(exports, "ApplySuggestionProvider", { enumerable: !0, get: function() {
      return ApplySuggestionProvider_1.ApplySuggestionProvider;
    } });
    var RunChecksProvider_1 = require_RunChecksProvider();
    Object.defineProperty(exports, "RunChecksProvider", { enumerable: !0, get: function() {
      return RunChecksProvider_1.RunChecksProvider;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/commands/ExecuteCommandProvider.js
var require_ExecuteCommandProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/commands/ExecuteCommandProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ExecuteCommandProvider = exports.Commands = void 0;
    var providers_1 = require_providers();
    exports.Commands = [
      providers_1.ApplyFixesProvider.command,
      providers_1.ApplySuggestionProvider.command,
      providers_1.RunChecksProvider.command
    ];
    function isKnownCommand(command) {
      return exports.Commands.includes(command);
    }
    var ExecuteCommandProvider = class {
      constructor(documentManager, diagnosticsManager, clientCapabilities, runChecks, connection) {
        this.commands = {
          [providers_1.ApplyFixesProvider.command]: new providers_1.ApplyFixesProvider(documentManager, diagnosticsManager, clientCapabilities, connection),
          [providers_1.ApplySuggestionProvider.command]: new providers_1.ApplySuggestionProvider(documentManager, diagnosticsManager, clientCapabilities, connection),
          [providers_1.RunChecksProvider.command]: new providers_1.RunChecksProvider(documentManager, diagnosticsManager, clientCapabilities, connection, runChecks)
        };
      }
      async execute(params) {
        var _a38;
        if (!isKnownCommand(params.command))
          return;
        let provider = this.commands[params.command], args = (_a38 = params.arguments) !== null && _a38 !== void 0 ? _a38 : [];
        await provider.execute(...args);
      }
    };
    exports.ExecuteCommandProvider = ExecuteCommandProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/commands/index.js
var require_commands = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/commands/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.applyFixCommand = exports.Commands = exports.ExecuteCommandProvider = void 0;
    var ExecuteCommandProvider_1 = require_ExecuteCommandProvider();
    Object.defineProperty(exports, "ExecuteCommandProvider", { enumerable: !0, get: function() {
      return ExecuteCommandProvider_1.ExecuteCommandProvider;
    } });
    Object.defineProperty(exports, "Commands", { enumerable: !0, get: function() {
      return ExecuteCommandProvider_1.Commands;
    } });
    var providers_1 = require_providers();
    Object.defineProperty(exports, "applyFixCommand", { enumerable: !0, get: function() {
      return providers_1.applyFixCommand;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/codeActions/BaseCodeActionsProvider.js
var require_BaseCodeActionsProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/codeActions/BaseCodeActionsProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.BaseCodeActionsProvider = void 0;
    var BaseCodeActionsProvider = class {
      constructor(documentManager, diagnosticsManager) {
        this.documentManager = documentManager, this.diagnosticsManager = diagnosticsManager;
      }
      get kind() {
        return this.constructor.kind;
      }
    };
    exports.BaseCodeActionsProvider = BaseCodeActionsProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/codeActions/providers/utils.js
var require_utils7 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/codeActions/providers/utils.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.isFixable = exports.isInRange = exports.toCodeAction = void 0;
    var vscode_languageserver_1 = require_main5();
    function toCodeAction(title, command, diagnostics, kind, isPreferred = !1) {
      let codeAction = vscode_languageserver_1.CodeAction.create(title, command, kind);
      return codeAction.diagnostics = diagnostics, codeAction.isPreferred = isPreferred, codeAction;
    }
    exports.toCodeAction = toCodeAction;
    function isInRange({ offense }, start, end) {
      let offenseStart = offense.start.index;
      return !(offense.end.index < start || offenseStart > end);
    }
    exports.isInRange = isInRange;
    function isFixable(anomaly) {
      let { offense } = anomaly;
      return "fix" in offense && offense.fix !== void 0;
    }
    exports.isFixable = isFixable;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/codeActions/providers/FixProvider.js
var require_FixProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/codeActions/providers/FixProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.FixProvider = void 0;
    var vscode_languageserver_1 = require_main5(), commands_1 = require_commands(), BaseCodeActionsProvider_1 = require_BaseCodeActionsProvider(), utils_1 = require_utils7(), FixProvider = class extends BaseCodeActionsProvider_1.BaseCodeActionsProvider {
      codeActions(params) {
        let { uri } = params.textDocument, document2 = this.documentManager.get(uri), diagnostics = this.diagnosticsManager.get(uri);
        if (!document2 || !diagnostics)
          return [];
        let { textDocument } = document2, { anomalies, version: version2 } = diagnostics, start = textDocument.offsetAt(params.range.start), end = textDocument.offsetAt(params.range.end), fixableAnomalies = anomalies.filter(utils_1.isFixable), anomaliesUnderCursor = fixableAnomalies.filter((anomaly) => (0, utils_1.isInRange)(anomaly, start, end));
        return anomaliesUnderCursor.length === 0 ? [] : [
          ...quickfixCursorActions(uri, version2, anomaliesUnderCursor),
          ...quickfixSameTypeActions(uri, version2, anomaliesUnderCursor, fixableAnomalies),
          ...quickfixAllAction(uri, version2, fixableAnomalies)
        ];
      }
    };
    exports.FixProvider = FixProvider;
    FixProvider.kind = vscode_languageserver_1.CodeActionKind.QuickFix;
    function quickfixCursorActions(uri, version2, anomaliesUnderCursor) {
      return anomaliesUnderCursor.map(({ offense, diagnostic, id }) => (0, utils_1.toCodeAction)(`Fix this ${offense.check} problem: ${offense.message}`, (0, commands_1.applyFixCommand)(uri, version2, [id]), [diagnostic], FixProvider.kind, !0));
    }
    function quickfixSameTypeActions(uri, version2, anomaliesUnderCursor, fixableAnomalies) {
      let checks = new Set(anomaliesUnderCursor.map((anomaly) => anomaly.offense.check));
      return Array.from(checks).flatMap((check2) => {
        let checkAnomalies = fixableAnomalies.filter(({ offense }) => offense.check === check2);
        if (checkAnomalies.length < 2)
          return [];
        let ids = checkAnomalies.map((a) => a.id), diagnostics = checkAnomalies.map((a) => a.diagnostic);
        return (0, utils_1.toCodeAction)(`Fix all ${check2} problems`, (0, commands_1.applyFixCommand)(uri, version2, ids), diagnostics, FixProvider.kind);
      });
    }
    function quickfixAllAction(uri, version2, fixableAnomalies) {
      let ids = fixableAnomalies.map((a) => a.id), diagnostics = fixableAnomalies.map((a) => a.diagnostic);
      return new Set(diagnostics.map((a) => a.code)).size < 2 ? [] : [
        (0, utils_1.toCodeAction)("Fix all auto-fixable problems", (0, commands_1.applyFixCommand)(uri, version2, ids), diagnostics, FixProvider.kind)
      ];
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/codeActions/providers/FixAllProvider.js
var require_FixAllProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/codeActions/providers/FixAllProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.FixAllProvider = void 0;
    var vscode_languageserver_1 = require_main5(), commands_1 = require_commands(), BaseCodeActionsProvider_1 = require_BaseCodeActionsProvider(), utils_1 = require_utils7(), FixAllProvider = class extends BaseCodeActionsProvider_1.BaseCodeActionsProvider {
      codeActions(params) {
        let { uri } = params.textDocument, document2 = this.documentManager.get(uri), diagnostics = this.diagnosticsManager.get(uri);
        if (!document2 || !diagnostics)
          return [];
        let { anomalies, version: version2 } = diagnostics, fixableAnomalies = anomalies.filter(utils_1.isFixable);
        return fixableAnomalies.length === 0 ? [] : quickfixAllAction(uri, version2, fixableAnomalies);
      }
    };
    exports.FixAllProvider = FixAllProvider;
    FixAllProvider.kind = vscode_languageserver_1.CodeActionKind.SourceFixAll;
    function quickfixAllAction(uri, version2, fixableAnomalies) {
      let ids = fixableAnomalies.map((a) => a.id), diagnostics = fixableAnomalies.map((a) => a.diagnostic);
      return [
        (0, utils_1.toCodeAction)("Fix all auto-fixable problems", (0, commands_1.applyFixCommand)(uri, version2, ids), diagnostics, FixAllProvider.kind)
      ];
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/codeActions/providers/SuggestionProvider.js
var require_SuggestionProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/codeActions/providers/SuggestionProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.SuggestionProvider = void 0;
    var vscode_languageserver_1 = require_main5(), providers_1 = require_providers(), BaseCodeActionsProvider_1 = require_BaseCodeActionsProvider(), utils_1 = require_utils7(), SuggestionProvider = class extends BaseCodeActionsProvider_1.BaseCodeActionsProvider {
      codeActions(params) {
        let { uri } = params.textDocument, document2 = this.documentManager.get(uri), diagnostics = this.diagnosticsManager.get(uri);
        if (!document2 || !diagnostics)
          return [];
        let { textDocument } = document2, { anomalies, version: version2 } = diagnostics, start = textDocument.offsetAt(params.range.start), end = textDocument.offsetAt(params.range.end), anomaliesUnderCursor = anomalies.filter(isSuggestible).filter((anomaly) => (0, utils_1.isInRange)(anomaly, start, end));
        return anomaliesUnderCursor.length === 0 ? [] : quickfixCursorActions(uri, version2, anomaliesUnderCursor);
      }
    };
    exports.SuggestionProvider = SuggestionProvider;
    SuggestionProvider.kind = vscode_languageserver_1.CodeActionKind.QuickFix;
    function quickfixCursorActions(uri, version2, anomaliesUnderCursor) {
      return anomaliesUnderCursor.flatMap(({ offense, diagnostic, id }) => offense.suggest.map((suggestion, suggestionId) => (0, utils_1.toCodeAction)(`Suggestion: ${suggestion.message}`, (0, providers_1.applySuggestionCommand)(uri, version2, id, suggestionId), [diagnostic], SuggestionProvider.kind)));
    }
    function isSuggestible(anomaly) {
      let { offense } = anomaly;
      return "suggest" in offense && offense.suggest !== void 0;
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/codeActions/providers/index.js
var require_providers2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/codeActions/providers/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.SuggestionProvider = exports.FixAllProvider = exports.FixProvider = void 0;
    var FixProvider_1 = require_FixProvider();
    Object.defineProperty(exports, "FixProvider", { enumerable: !0, get: function() {
      return FixProvider_1.FixProvider;
    } });
    var FixAllProvider_1 = require_FixAllProvider();
    Object.defineProperty(exports, "FixAllProvider", { enumerable: !0, get: function() {
      return FixAllProvider_1.FixAllProvider;
    } });
    var SuggestionProvider_1 = require_SuggestionProvider();
    Object.defineProperty(exports, "SuggestionProvider", { enumerable: !0, get: function() {
      return SuggestionProvider_1.SuggestionProvider;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/codeActions/CodeActionsProvider.js
var require_CodeActionsProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/codeActions/CodeActionsProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.CodeActionsProvider = exports.CodeActionKinds = void 0;
    var providers_1 = require_providers2();
    exports.CodeActionKinds = Array.from(/* @__PURE__ */ new Set([providers_1.FixAllProvider.kind, providers_1.FixProvider.kind, providers_1.SuggestionProvider.kind]));
    var CodeActionsProvider = class {
      constructor(documentManager, diagnosticsManager) {
        this.providers = [
          new providers_1.FixAllProvider(documentManager, diagnosticsManager),
          new providers_1.FixProvider(documentManager, diagnosticsManager),
          new providers_1.SuggestionProvider(documentManager, diagnosticsManager)
        ];
      }
      codeActions(params) {
        let only = params.context.only;
        return this.providers.filter((provider) => !only || only.some((kind) => provider.kind.startsWith(kind))).flatMap((provider) => provider.codeActions(params));
      }
    };
    exports.CodeActionsProvider = CodeActionsProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/codeActions/index.js
var require_codeActions = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/codeActions/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.CodeActionKinds = exports.CodeActionsProvider = void 0;
    var CodeActionsProvider_1 = require_CodeActionsProvider();
    Object.defineProperty(exports, "CodeActionsProvider", { enumerable: !0, get: function() {
      return CodeActionsProvider_1.CodeActionsProvider;
    } });
    Object.defineProperty(exports, "CodeActionKinds", { enumerable: !0, get: function() {
      return CodeActionsProvider_1.CodeActionKinds;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/settings/index.js
var require_settings = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/settings/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.isInputSetting = exports.isSettingsCategory = void 0;
    function isSettingsCategory(x) {
      return "settings" in x;
    }
    exports.isSettingsCategory = isSettingsCategory;
    function isInputSetting(x) {
      return "id" in x && "type" in x && "label" in x;
    }
    exports.isInputSetting = isInputSetting;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/visitor.js
var require_visitor = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/visitor.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.findCurrentNode = exports.forEachChildNodes = exports.visit = void 0;
    function isNode(x) {
      return x !== null && typeof x == "object" && typeof x.type == "string";
    }
    function visit3(node, visitor) {
      let results = [], stack = [{ node, lineage: [] }], pushStack = (node2, lineage) => stack.push({ node: node2, lineage });
      for (; stack.length > 0; ) {
        let { node: node2, lineage } = stack.pop(), visitNode = visitor[node2.type], result = visitNode ? visitNode(node2, lineage) : void 0;
        Array.isArray(result) ? results.push(...result) : result !== void 0 && results.push(result), forEachChildNodes(node2, lineage.concat(node2), pushStack);
      }
      return results;
    }
    exports.visit = visit3;
    function forEachChildNodes(node, lineage, execute) {
      for (let value of Object.values(node))
        if (Array.isArray(value))
          for (let i = value.length - 1; i >= 0; i--)
            execute(value[i], lineage);
        else
          isNode(value) && execute(value, lineage);
    }
    exports.forEachChildNodes = forEachChildNodes;
    function findCurrentNode(ast, cursorPosition) {
      let prev, current = ast, ancestors = [];
      for (; current !== prev; )
        prev = current, forEachChildNodes(current, ancestors.concat(current), (child, lineage) => {
          isCovered(child, cursorPosition) && size(child) <= size(current) && (current = child, ancestors = lineage);
        });
      return [current, ancestors];
    }
    exports.findCurrentNode = findCurrentNode;
    function isCovered(node, offset) {
      return node.position.start <= offset && offset <= node.position.end;
    }
    function size(node) {
      return node.position.end - node.position.start;
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/TypeSystem.js
var require_TypeSystem = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/TypeSystem.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.isArrayType = exports.docsetEntryReturnType = exports.TypeSystem = void 0;
    var liquid_html_parser_1 = require_dist(), theme_check_common_1 = require_dist2(), settings_1 = require_settings(), utils_1 = require_utils6(), visitor_1 = require_visitor(), TypeSystem = class {
      constructor(themeDocset, getThemeSettingsSchemaForURI) {
        this.themeDocset = themeDocset, this.getThemeSettingsSchemaForURI = getThemeSettingsSchemaForURI, this.objectMap = async (uri, ast) => {
          var _a38, _b, _c;
          let [objectMap, themeSettingProperties] = await Promise.all([
            this._objectMap(),
            this.themeSettingProperties(uri)
          ]), result = {
            ...objectMap,
            settings: {
              ...(_a38 = objectMap.settings) !== null && _a38 !== void 0 ? _a38 : {},
              properties: themeSettingProperties
            }
          };
          if (/[\/\\]sections[\/\\]/.test(uri) && result.section) {
            result.section = JSON.parse(JSON.stringify(result.section));
            let settings = (_b = result.section.properties) === null || _b === void 0 ? void 0 : _b.find((x) => x.name === "settings");
            if (!settings || !settings.return_type)
              return result;
            settings.return_type = [{ type: "section_settings", name: "" }], result.section_settings = {
              name: "section_settings",
              access: {
                global: !1,
                parents: [],
                template: []
              },
              properties: schemaSettingsAsProperties(ast),
              return_type: []
            };
          }
          if (/[\/\\]blocks[\/\\]/.test(uri) && result.block) {
            result.block = JSON.parse(JSON.stringify(result.block));
            let settings = (_c = result.block.properties) === null || _c === void 0 ? void 0 : _c.find((x) => x.name === "settings");
            if (!settings || !settings.return_type)
              return result;
            settings.return_type = [{ type: "block_settings", name: "" }], result.block_settings = {
              name: "block_settings",
              access: {
                global: !1,
                parents: [],
                template: []
              },
              properties: schemaSettingsAsProperties(ast),
              return_type: []
            };
          }
          return result;
        }, this._objectMap = (0, utils_1.memo)(async () => (await this.objectEntries()).reduce((map, entry) => (map[entry.name] = entry, map), {})), this.filtersMap = (0, utils_1.memo)(async () => (await this.filterEntries()).reduce((map, entry) => (map[entry.name] = entry, map), {})), this.filterEntries = (0, utils_1.memo)(async () => this.themeDocset.filters()), this.objectEntries = (0, utils_1.memo)(async () => this.themeDocset.objects()), this.seedSymbolsTable = async (uri) => {
          let [globalVariables, contextualVariables] = await Promise.all([
            this.globalVariables(),
            this.contextualVariables(uri)
          ]);
          return globalVariables.concat(contextualVariables).reduce((table, objectEntry) => {
            var _a38, _b;
            return (_a38 = table[_b = objectEntry.name]) !== null && _a38 !== void 0 || (table[_b] = []), table[objectEntry.name].push({
              identifier: objectEntry.name,
              type: objectEntryType(objectEntry),
              range: [0]
            }), table;
          }, {});
        }, this.globalVariables = (0, utils_1.memo)(async () => (await this.objectEntries()).filter((entry) => !entry.access || entry.access.global === !0 || entry.access.template.length > 0)), this.contextualVariables = async (uri) => {
          let entries = await this.objectEntries(), contextualEntries = getContextualEntries(uri);
          return entries.filter((entry) => contextualEntries.includes(entry.name));
        };
      }
      async inferType(thing, partialAst, uri) {
        let [objectMap, filtersMap, symbolsTable] = await Promise.all([
          this.objectMap(uri, partialAst),
          this.filtersMap(),
          this.symbolsTable(partialAst, uri)
        ]);
        return inferType(thing, symbolsTable, objectMap, filtersMap);
      }
      async availableVariables(partialAst, partial, node, uri) {
        let [objectMap, filtersMap, symbolsTable] = await Promise.all([
          this.objectMap(uri, partialAst),
          this.filtersMap(),
          this.symbolsTable(partialAst, uri)
        ]);
        return Object.entries(symbolsTable).filter(([key, typeRanges]) => key.startsWith(partial) && typeRanges.some((typeRange) => isCorrectTypeRange(typeRange, node))).map(([identifier, typeRanges]) => {
          var _a38;
          let typeRange = (0, utils_1.findLast)(typeRanges, (typeRange2) => isCorrectTypeRange(typeRange2, node)), type = resolveTypeRangeType(typeRange.type, symbolsTable, objectMap, filtersMap);
          return {
            entry: { ...(_a38 = objectMap[isArrayType(type) ? type.valueType : type]) !== null && _a38 !== void 0 ? _a38 : {}, name: identifier },
            type
          };
        });
      }
      async themeSettingProperties(uri) {
        let categories = (await this.getThemeSettingsSchemaForURI(uri)).filter(settings_1.isSettingsCategory), result = [];
        for (let category of categories) {
          let inputSettings = category.settings.filter(settings_1.isInputSetting);
          for (let setting of inputSettings)
            result.push({
              name: setting.id,
              summary: "",
              description: "",
              return_type: settingReturnType(setting),
              access: {
                global: !1,
                parents: [],
                template: []
              }
            });
        }
        return result;
      }
      async symbolsTable(partialAst, uri) {
        let seedSymbolsTable = await this.seedSymbolsTable(uri);
        return buildSymbolsTable(partialAst, seedSymbolsTable);
      }
    };
    exports.TypeSystem = TypeSystem;
    var SECTION_FILE_REGEX = /sections[\/\\][^.\\\/]*\.liquid$/, BLOCK_FILE_REGEX = /blocks[\/\\][^.\\\/]*\.liquid$/, SNIPPET_FILE_REGEX = /snippets[\/\\][^.\\\/]*\.liquid$/, LAYOUT_FILE_REGEX = /layout[\/\\]checkout\.liquid$/;
    function getContextualEntries(uri) {
      let absolutePath = (0, utils_1.toAbsolutePath)(uri);
      return LAYOUT_FILE_REGEX.test(absolutePath) ? [
        "locale",
        "direction",
        "skip_to_content_link",
        "checkout_html_classes",
        "checkout_stylesheets",
        "checkout_scripts",
        "content_for_logo",
        "breadcrumb",
        "order_summary_toggle",
        "content_for_order_summary",
        "alternative_payment_methods",
        "content_for_footer",
        "tracking_code"
      ] : SECTION_FILE_REGEX.test(absolutePath) ? ["section", "predictive_search", "recommendations", "comment"] : BLOCK_FILE_REGEX.test(absolutePath) ? ["app", "section", "block"] : SNIPPET_FILE_REGEX.test(absolutePath) ? ["app"] : [];
    }
    var Untyped = "untyped", String2 = "string", arrayType = (valueType) => ({
      kind: "array",
      valueType
    }), lazyVariable = (node, offset) => ({
      kind: liquid_html_parser_1.NodeTypes.LiquidVariable,
      node,
      offset
    }), LazyDeconstructedExpression = (node, offset) => ({
      kind: "deconstructed",
      node,
      offset
    });
    function buildSymbolsTable(partialAst, seedSymbolsTable) {
      return (0, visitor_1.visit)(partialAst, {
        // {% assign x = foo.x | filter %}
        AssignMarkup(node) {
          return {
            identifier: node.name,
            type: lazyVariable(node.value, node.position.start),
            range: [node.position.end]
          };
        },
        // This also covers tablerow
        ForMarkup(node, ancestors) {
          var _a38;
          let parentNode = ancestors.at(-1);
          return {
            identifier: node.variableName,
            type: LazyDeconstructedExpression(node.collection, node.position.start),
            range: [parentNode.blockStartPosition.end, end((_a38 = parentNode.blockEndPosition) === null || _a38 === void 0 ? void 0 : _a38.end)]
          };
        },
        // {% capture foo %}
        //   ...
        // {% endcapture}
        LiquidTag(node) {
          var _a38, _b;
          if (node.name === "capture" && typeof node.markup != "string")
            return {
              identifier: node.markup.name,
              type: String2,
              range: [node.position.end]
            };
          if (["form", "paginate"].includes(node.name))
            return {
              identifier: node.name,
              type: node.name,
              range: [node.blockStartPosition.end, end((_a38 = node.blockEndPosition) === null || _a38 === void 0 ? void 0 : _a38.end)]
            };
          if (["for", "tablerow"].includes(node.name))
            return {
              identifier: node.name + "loop",
              type: node.name + "loop",
              range: [node.blockStartPosition.end, end((_b = node.blockEndPosition) === null || _b === void 0 ? void 0 : _b.end)]
            };
          if (isLiquidTagIncrement(node) || isLiquidTagDecrement(node))
            return node.markup.name === null ? void 0 : {
              identifier: node.markup.name,
              type: "number",
              range: [node.position.start]
            };
          if (node.name === "layout")
            return {
              identifier: "none",
              type: "keyword",
              range: [node.position.start, node.position.end]
            };
        }
      }).sort(({ range: [startA] }, { range: [startB] }) => startA - startB).reduce((table, typeRange) => {
        var _a38, _b;
        return (_a38 = table[_b = typeRange.identifier]) !== null && _a38 !== void 0 || (table[_b] = []), table[typeRange.identifier].push(typeRange), table;
      }, seedSymbolsTable);
    }
    function resolveTypeRangeType(typeRangeType, symbolsTable, objectMap, filtersMap) {
      if (typeof typeRangeType == "string")
        return typeRangeType;
      switch (typeRangeType.kind) {
        case "array":
          return typeRangeType;
        case "deconstructed": {
          let arrayType2 = inferType(typeRangeType.node, symbolsTable, objectMap, filtersMap);
          return typeof arrayType2 == "string" ? Untyped : arrayType2.valueType;
        }
        default:
          return inferType(typeRangeType.node, symbolsTable, objectMap, filtersMap);
      }
    }
    function inferType(thing, symbolsTable, objectMap, filtersMap) {
      var _a38, _b;
      if (typeof thing == "string")
        return (_b = (_a38 = objectMap[thing]) === null || _a38 === void 0 ? void 0 : _a38.name) !== null && _b !== void 0 ? _b : Untyped;
      switch (thing.type) {
        case liquid_html_parser_1.NodeTypes.Number:
          return "number";
        case liquid_html_parser_1.NodeTypes.String:
          return "string";
        case liquid_html_parser_1.NodeTypes.LiquidLiteral:
          return "boolean";
        case liquid_html_parser_1.NodeTypes.Range:
          return arrayType("number");
        case liquid_html_parser_1.NodeTypes.AssignMarkup:
          return inferType(thing.value, symbolsTable, objectMap, filtersMap);
        case liquid_html_parser_1.NodeTypes.VariableLookup:
          return inferLookupType(thing, symbolsTable, objectMap, filtersMap);
        case liquid_html_parser_1.NodeTypes.LiquidVariable:
          if (thing.filters.length > 0) {
            let lastFilter = thing.filters.at(-1), filterEntry = filtersMap[lastFilter.name];
            return filterEntry ? filterEntryReturnType(filterEntry) : Untyped;
          } else
            return inferType(thing.expression, symbolsTable, objectMap, filtersMap);
        default:
          return Untyped;
      }
    }
    function inferLookupType(thing, symbolsTable, objectMap, filtersMap) {
      let node = thing;
      if (node.name === null)
        return Untyped;
      let curr = inferIdentifierType(node, symbolsTable, objectMap, filtersMap);
      for (let lookup3 of node.lookups)
        if (isArrayType(curr) ? curr = inferArrayTypeLookupType(curr, lookup3) : curr = inferPseudoTypePropertyType(curr, lookup3, objectMap), curr === Untyped)
          return Untyped;
      return curr;
    }
    function inferIdentifierType(node, symbolsTable, objectMap, filtersMap) {
      let identifier = node.name;
      if (!identifier)
        return Untyped;
      let typeRanges = symbolsTable[identifier];
      if (!typeRanges)
        return Untyped;
      let typeRange = (0, utils_1.findLast)(typeRanges, (tr) => isCorrectTypeRange(tr, node));
      return typeRange ? resolveTypeRangeType(typeRange.type, symbolsTable, objectMap, filtersMap) : Untyped;
    }
    function inferArrayTypeLookupType(curr, lookup3) {
      if (lookup3.type === liquid_html_parser_1.NodeTypes.Number || lookup3.type === liquid_html_parser_1.NodeTypes.VariableLookup)
        return curr.valueType;
      if (lookup3.type === liquid_html_parser_1.NodeTypes.String)
        switch (lookup3.value) {
          case "first":
          case "last":
            return curr.valueType;
          case "size":
            return "number";
          default:
            return Untyped;
        }
      else
        return Untyped;
    }
    function inferPseudoTypePropertyType(curr, lookup3, objectMap) {
      var _a38;
      let parentEntry = objectMap[curr];
      if (!parentEntry || lookup3.type !== liquid_html_parser_1.NodeTypes.String)
        return Untyped;
      let propertyName = lookup3.value, property = (_a38 = parentEntry.properties) === null || _a38 === void 0 ? void 0 : _a38.find((property2) => property2.name === propertyName);
      return property ? objectEntryType(property) : Untyped;
    }
    function filterEntryReturnType(entry) {
      return docsetEntryReturnType(entry, "string");
    }
    function objectEntryType(entry) {
      return docsetEntryReturnType(entry, entry.name);
    }
    function docsetEntryReturnType(entry, defaultValue) {
      let returnTypes = entry.return_type;
      if (returnTypes && returnTypes.length > 0) {
        let returnType = returnTypes[0];
        return isArrayReturnType(returnType) ? arrayType(returnType.array_value) : returnType.type;
      }
      return defaultValue;
    }
    exports.docsetEntryReturnType = docsetEntryReturnType;
    function isArrayReturnType(rt) {
      return rt.type === "array";
    }
    function isArrayType(thing) {
      return typeof thing != "string";
    }
    exports.isArrayType = isArrayType;
    function isCorrectTypeRange(typeRange, node) {
      let [start, end2] = typeRange.range;
      return end2 && node.position.start > end2 ? !1 : node.position.start > start;
    }
    function end(offset) {
      if (offset !== -1)
        return offset;
    }
    function isLiquidTagIncrement(node) {
      return node.name === liquid_html_parser_1.NamedTags.increment && typeof node.markup != "string";
    }
    function isLiquidTagDecrement(node) {
      return node.name === liquid_html_parser_1.NamedTags.decrement && typeof node.markup != "string";
    }
    function settingReturnType(setting) {
      switch (setting.type) {
        case "checkbox":
          return [{ type: "boolean", name: "" }];
        case "range":
        case "number":
          return [{ type: "number", name: "" }];
        case "radio":
        case "select":
        case "text":
        case "textarea":
          return [{ type: "string", name: "" }];
        case "article":
          return [{ type: "article", name: "" }];
        case "blog":
          return [{ type: "blog", name: "" }];
        case "collection":
          return [{ type: "collection", name: "" }];
        case "collection_list":
          return [{ type: "array", array_value: "collection" }];
        case "color":
          return [{ type: "color", name: "" }];
        case "color_background":
          return [{ type: "string", name: "" }];
        case "color_scheme":
          return [{ type: "color_scheme", name: "" }];
        case "color_scheme_group":
          return [];
        case "font_picker":
          return [{ type: "font", name: "" }];
        case "html":
          return [{ type: "string", name: "" }];
        case "image_picker":
          return [{ type: "image", name: "" }];
        case "inline_richtext":
          return [{ type: "string", name: "" }];
        case "link_list":
          return [{ type: "linklist", name: "" }];
        case "liquid":
          return [{ type: "string", name: "" }];
        case "page":
          return [{ type: "page", name: "" }];
        case "product":
          return [{ type: "product", name: "" }];
        case "product_list":
          return [{ type: "array", array_value: "product" }];
        case "richtext":
          return [{ type: "string", name: "" }];
        case "text_alignment":
          return [{ type: "string", name: "" }];
        case "url":
          return [{ type: "string", name: "" }];
        case "video":
          return [{ type: "video", name: "" }];
        case "video_url":
          return [{ type: "string", name: "" }];
        default:
          return [];
      }
    }
    function schemaSettingsAsProperties(ast) {
      if (ast.type !== liquid_html_parser_1.NodeTypes.Document)
        return [];
      try {
        let source = ast._source, start = /\{%\s*schema\s*%\}/m.exec(source), end2 = /\{%\s*endschema\s*%\}/m.exec(source);
        if (!start || !end2)
          return [];
        let schema = source.slice(start.index + start[0].length, end2.index), json = (0, theme_check_common_1.parseJSON)(schema);
        if ((0, theme_check_common_1.isError)(json) || !("settings" in json) || !Array.isArray(json.settings))
          return [];
        let result = [], inputSettings = json.settings.filter(settings_1.isInputSetting);
        for (let setting of inputSettings)
          result.push({
            name: setting.id,
            summary: "",
            description: "",
            return_type: settingReturnType(setting),
            access: {
              global: !1,
              parents: [],
              template: []
            }
          });
        return result;
      } catch {
        return [];
      }
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/params/fix.js
var require_fix = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/params/fix.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.fix = exports.CURSOR = void 0;
    exports.CURSOR = "\u2588";
    var SINGLE_QUOTE = "'", DOUBLE_QUOTE = '"', HTML_TOKENS = ["<", ">"], SHOULD_IGNORE_HTML_TOKENS = [SINGLE_QUOTE, DOUBLE_QUOTE, "{{", "{%"], QUOTES = [SINGLE_QUOTE, DOUBLE_QUOTE], CONTROL_TOKENS = ["{{", "{%", "<"], TokenPairs = {
      "'": "'",
      '"': '"',
      "{{": "}}",
      "{%": "%}",
      "<": ">",
      "[": "]",
      "(": ")"
    };
    function fix(source, position = source.length) {
      return new Fixer(source, position).fix();
    }
    exports.fix = fix;
    var Fixer = class {
      constructor(source, position) {
        this.tokens = [], this.stack = [], this.cursor = 0, this.markup = source.slice(0, position);
      }
      /**
       * This is cool, so bear with me.
       *
       * We'll scan the entire string up to the cursor position and turn that
       * into a list of tokens
       *
       * input:
       *   `<a href="hi'" other="{{ 'there'`
       *
       * output:
       *   - <
       *   - "
       *   - '
       *   - "
       *   - "
       *   - {{
       *   - '
       *   - '
       *   - }}
       *   - "
       *
       * Then we take that output, and we turn it into a stack
       * (open tokens push, close tokens pop)
       *
       * stack evolution:
       *   - <         # open tag
       *   - < "       # add quote
       *   - < "       # (single quote is ignored)
       *   - <         # close quote
       *   - < "       # open new quote
       *   - < " {{    # open liquid variable output
       *   - < " {{ '  # open liquid string in variable output
       *   - < " {{    # close liquid string in variable output
       *
       * then we pop the close characters of that stack onto the string and
       * have a fixed string
       *
       *   - <a href="hi'" other="{{ 'there'      # start
       *   - <a href="hi'" other="{{ 'there'}}    # pop close {{
       *   - <a href="hi'" other="{{ 'there'}}"   # pop close "
       *   - <a href="hi'" other="{{ 'there'}}">  # pop close <
       *
       * And there we go, we have a fixed string.
       */
      fix() {
        this.scanTokens(), this.buildStack();
        let markup = this.markup;
        for (this.shouldIncludeCursorPlaceholder() && (markup += exports.CURSOR); this.stack.length !== 0; )
          markup += this.stack.pop();
        return markup;
      }
      buildStack() {
        for (let token of this.tokens)
          if (this.shouldPanic(token))
            for (; token !== this.stack.pop(); )
              ;
          else if (!this.shouldSkipToken(token))
            if (this.isClosingToken(token))
              this.stack.pop();
            else {
              let closingToken = TokenPairs[token];
              closingToken && this.stack.push(closingToken);
            }
      }
      isClosingToken(token) {
        return this.current === token;
      }
      shouldPanic(token) {
        return QUOTES.includes(this.current) && this.stack.at(-2) === token;
      }
      shouldSkipToken(token) {
        let current = this.current, isInTextContext = !current, isInStringContext = QUOTES.includes(current), isInLiquidContext = this.stack.includes("}}") || this.stack.includes("%}");
        return isInTextContext && !CONTROL_TOKENS.includes(token) || isInStringContext && !CONTROL_TOKENS.includes(token) && !QUOTES.includes(token) || isInLiquidContext && token === "<" || current === SINGLE_QUOTE && token === DOUBLE_QUOTE || current === DOUBLE_QUOTE && token === SINGLE_QUOTE || SHOULD_IGNORE_HTML_TOKENS.includes(current) && HTML_TOKENS.includes(token);
      }
      scanTokens() {
        for (; !this.isAtEnd(); ) {
          let character = this.peek();
          switch (character) {
            case DOUBLE_QUOTE:
            case SINGLE_QUOTE:
            case "(":
            case ")":
            case "[":
            case "]": {
              this.pushToken(character);
              break;
            }
            case "{": {
              this.matchNext("%") ? this.pushToken("{%") : this.matchNext("{") && this.pushToken("{{");
              break;
            }
            case "%": {
              this.matchNext("}") && this.pushToken("%}");
              break;
            }
            case "}": {
              this.matchNext("}") && this.pushToken("}}");
              break;
            }
            case "<": {
              this.testNext(/[a-z{\/]/i) && this.pushToken("<");
              break;
            }
            case ">": {
              this.pushToken(">");
              break;
            }
            default:
          }
          this.advance();
        }
      }
      shouldIncludeCursorPlaceholder() {
        var _a38, _b;
        let prevCharacter = (_a38 = this.markup.at(-1)) !== null && _a38 !== void 0 ? _a38 : "", prevPrevCharacter = (_b = this.markup.at(-2)) !== null && _b !== void 0 ? _b : "", isInLiquidContext = this.stack.includes("%}") || this.stack.includes("}}"), isInHtmlContext = this.current === ">", isInStringContext = QUOTES.includes(this.current);
        return isInStringContext && this.stack.at(-2) === ">" && QUOTES.includes(prevCharacter) || isInHtmlContext && (/\s/.test(prevCharacter) || prevCharacter === "<" || prevPrevCharacter === "<" && prevCharacter === "/" || prevPrevCharacter === "%" && prevCharacter === "}") || isInLiquidContext && (!isInStringContext && [" ", "	", `
`, ".", "{", "[", ","].includes(prevCharacter) || isInStringContext && prevPrevCharacter === "[");
      }
      get current() {
        return this.stack.at(-1);
      }
      advance() {
        this.cursor += 1;
      }
      matchNext(character) {
        return this.peekNext() !== character ? !1 : (this.cursor++, !0);
      }
      testNext(regex) {
        return regex.test(this.peekNext());
      }
      peek(cursor = this.cursor) {
        return this.markup[cursor];
      }
      peekNext(cursor = this.cursor) {
        return this.markup[cursor + 1];
      }
      pushToken(token) {
        this.tokens.push(token);
      }
      isAtEnd() {
        return this.cursor >= this.markup.length;
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/params/LiquidCompletionParams.js
var require_LiquidCompletionParams = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/params/LiquidCompletionParams.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.createLiquidCompletionParams = void 0;
    var liquid_html_parser_1 = require_dist(), fix_1 = require_fix();
    function createLiquidCompletionParams(sourceCode, params) {
      let { textDocument } = sourceCode, cursor = textDocument.offsetAt(params.position), completionContext = getCompletionContext(sourceCode, cursor);
      return {
        ...params,
        completionContext
      };
    }
    exports.createLiquidCompletionParams = createLiquidCompletionParams;
    function getCompletionContext(sourceCode, cursor) {
      let partialAst = parsePartial(sourceCode, cursor);
      if (!partialAst)
        return;
      let [node, ancestors] = findCurrentNode(partialAst, cursor);
      return {
        partialAst,
        ancestors,
        node
      };
    }
    function parsePartial(sourceCode, cursorPosition) {
      let fixedSource;
      try {
        fixedSource = (0, fix_1.fix)(sourceCode.source, cursorPosition);
        let ast = (0, liquid_html_parser_1.toLiquidHtmlAST)(fixedSource, {
          allowUnclosedDocumentNode: !0,
          mode: "completion"
        });
        return ast._source = sourceCode.source, ast;
      } catch {
        return;
      }
    }
    var Finder = class {
      constructor(ast) {
        this.stack = [ast];
      }
      get current() {
        return last(this.stack);
      }
      get parent() {
        return this.stack.at(-2);
      }
      set current(node) {
        this.stack.push(node);
      }
    };
    function findCurrentNode(partialAst, cursor) {
      let finder = new Finder(partialAst), current = { ...partialAst };
      for (; finder.current !== void 0 && current !== finder.current; )
        switch (current = finder.current, current.type) {
          case liquid_html_parser_1.NodeTypes.Document: {
            hasNonEmptyArrayProperty(current, "children") && (finder.current = last(current.children));
            break;
          }
          case liquid_html_parser_1.NodeTypes.HtmlRawNode:
          case liquid_html_parser_1.NodeTypes.HtmlVoidElement:
          case liquid_html_parser_1.NodeTypes.HtmlDanglingMarkerClose:
          case liquid_html_parser_1.NodeTypes.HtmlSelfClosingElement:
          case liquid_html_parser_1.NodeTypes.HtmlElement: {
            isCompletedTag(current) ? finder.current = void 0 : hasNonEmptyArrayProperty(current, "children") ? finder.current = last(current.children) : hasNonEmptyArrayProperty(current, "attributes") ? finder.current = last(current.attributes) : hasNonEmptyArrayProperty(current, "name") && isCoveredExcluded(cursor, current.blockStartPosition) ? finder.current = last(current.name) : typeof current.name == "string" && isCoveredExcluded(cursor, current.blockStartPosition) || (finder.current = void 0);
            break;
          }
          case liquid_html_parser_1.NodeTypes.LiquidTag: {
            isLiquidLiquidTag(finder.parent) || isCoveredExcluded(cursor, current.blockStartPosition) ? hasNonNullProperty(current, "markup") && typeof current.markup != "string" && (finder.current = Array.isArray(current.markup) ? current.markup.at(-1) : current.markup) : isIncompleteBlockTag(current) ? finder.current = last(current.children) : finder.current = void 0;
            break;
          }
          case liquid_html_parser_1.NodeTypes.LiquidBranch:
            isCovered(cursor, current.blockStartPosition) && typeof current.markup != "string" ? finder.current = Array.isArray(current.markup) ? current.markup.at(-1) : current.markup : hasNonEmptyArrayProperty(current, "children") ? finder.current = last(current.children) : finder.current = void 0;
            break;
          case liquid_html_parser_1.NodeTypes.LiquidRawTag:
            break;
          case liquid_html_parser_1.NodeTypes.AttrDoubleQuoted:
          case liquid_html_parser_1.NodeTypes.AttrSingleQuoted:
          case liquid_html_parser_1.NodeTypes.AttrEmpty:
          case liquid_html_parser_1.NodeTypes.AttrUnquoted: {
            let lastNameNode = last(current.name);
            isCovered(cursor, lastNameNode.position) ? finder.current = lastNameNode : current.type !== liquid_html_parser_1.NodeTypes.AttrEmpty && isCovered(cursor, current.attributePosition) && isNotEmpty(current.value) ? finder.current = last(current.value) : finder.current = void 0;
            break;
          }
          case liquid_html_parser_1.NodeTypes.YAMLFrontmatter:
          case liquid_html_parser_1.NodeTypes.HtmlDoctype:
          case liquid_html_parser_1.NodeTypes.HtmlComment:
          case liquid_html_parser_1.NodeTypes.RawMarkup:
            break;
          case liquid_html_parser_1.NodeTypes.LiquidVariableOutput: {
            typeof current.markup != "string" && (finder.current = current.markup);
            break;
          }
          case liquid_html_parser_1.NodeTypes.LiquidVariable: {
            isNotEmpty(current.filters) ? finder.current = last(current.filters) : finder.current = current.expression;
            break;
          }
          case liquid_html_parser_1.NodeTypes.LiquidFilter: {
            isNotEmpty(current.args) && (finder.current = last(current.args));
            break;
          }
          case liquid_html_parser_1.NodeTypes.VariableLookup: {
            hasNonEmptyArrayProperty(current, "lookups") && last(current.lookups).type === liquid_html_parser_1.NodeTypes.VariableLookup && (finder.current = last(current.lookups));
            break;
          }
          case liquid_html_parser_1.NodeTypes.AssignMarkup: {
            finder.current = current.value;
            break;
          }
          case liquid_html_parser_1.NodeTypes.ForMarkup: {
            isCovered(cursor, current.collection.position) ? finder.current = current.collection : isNotEmpty(current.args) && isCovered(cursor, last(current.args).position) && (finder.current = last(current.args));
            break;
          }
          case liquid_html_parser_1.NodeTypes.NamedArgument: {
            isCovered(cursor, current.value.position) && (finder.current = current.value);
            break;
          }
          case liquid_html_parser_1.NodeTypes.Comparison: {
            finder.current = current.right;
            break;
          }
          case liquid_html_parser_1.NodeTypes.LogicalExpression: {
            finder.current = current.right;
            break;
          }
          case liquid_html_parser_1.NodeTypes.CycleMarkup: {
            isNotEmpty(current.args) && (finder.current = last(current.args));
            break;
          }
          case liquid_html_parser_1.NodeTypes.PaginateMarkup: {
            isNotEmpty(current.args) ? finder.current = last(current.args) : isCovered(cursor, current.collection.position) ? finder.current = current.collection : isCovered(cursor, current.pageSize.position) && (finder.current = current.pageSize);
            break;
          }
          case liquid_html_parser_1.NodeTypes.RenderMarkup: {
            isNotEmpty(current.args) ? finder.current = last(current.args) : current.variable && isCovered(cursor, current.variable.position) && (finder.current = current.variable);
            break;
          }
          case liquid_html_parser_1.NodeTypes.RenderVariableExpression: {
            finder.current = current.name;
            break;
          }
          case liquid_html_parser_1.NodeTypes.Range: {
            finder.current = current.end;
            break;
          }
          case liquid_html_parser_1.NodeTypes.TextNode:
          case liquid_html_parser_1.NodeTypes.LiquidLiteral:
          case liquid_html_parser_1.NodeTypes.String:
          case liquid_html_parser_1.NodeTypes.Number:
            break;
          default:
            return assertNever(current);
        }
      return [finder.stack.pop(), finder.stack];
    }
    function hasNonNullProperty(thing, property) {
      return thing !== null && property in thing && !!thing[property];
    }
    function isIncompleteBlockTag(thing) {
      return hasNonEmptyArrayProperty(thing, "children") && (!hasNonNullProperty(thing, "blockEndPosition") || thing.blockEndPosition.start === -1 && thing.blockEndPosition.end === -1);
    }
    function isCompletedTag(thing) {
      return hasNonNullProperty(thing, "blockEndPosition") && thing.blockEndPosition.start !== -1 && thing.blockEndPosition.end !== -1;
    }
    function hasNonEmptyArrayProperty(thing, property) {
      return thing !== null && property in thing && Array.isArray(thing[property]) && !isEmpty2(thing[property]);
    }
    function isLiquidLiquidTag(node) {
      return node ? node.type === liquid_html_parser_1.NodeTypes.LiquidTag && node.name === "liquid" : !1;
    }
    function isCoveredExcluded(cursor, position) {
      return position.start <= cursor && cursor < position.end;
    }
    function isCovered(cursor, position) {
      return position.start <= cursor && cursor <= position.end;
    }
    function isNotEmpty(x) {
      return x.length > 0;
    }
    function isEmpty2(x) {
      return x.length === 0;
    }
    function last(x) {
      return x[x.length - 1];
    }
    function assertNever(x) {
      throw new Error(`This function should never be called, but was called with ${x}`);
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/params/index.js
var require_params = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/params/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.CURSOR = exports.createLiquidCompletionParams = void 0;
    var LiquidCompletionParams_1 = require_LiquidCompletionParams();
    Object.defineProperty(exports, "createLiquidCompletionParams", { enumerable: !0, get: function() {
      return LiquidCompletionParams_1.createLiquidCompletionParams;
    } });
    var fix_1 = require_fix();
    Object.defineProperty(exports, "CURSOR", { enumerable: !0, get: function() {
      return fix_1.CURSOR;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/docset/MarkdownRenderer.js
var require_MarkdownRenderer = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/docset/MarkdownRenderer.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.renderHtmlEntry = exports.render = void 0;
    var TypeSystem_1 = require_TypeSystem(), HORIZONTAL_SEPARATOR = `

---

`;
    function render3(entry, returnType, docsetEntryType) {
      return [title(entry, returnType), docsetEntryBody(entry, returnType, docsetEntryType)].filter(Boolean).join(`
`);
    }
    exports.render = render3;
    function renderHtmlEntry(entry, parentEntry) {
      return [title(entry, "untyped"), htmlEntryBody(entry, parentEntry)].join(`
`);
    }
    exports.renderHtmlEntry = renderHtmlEntry;
    function title(entry, returnType) {
      return returnType = returnType ?? (0, TypeSystem_1.docsetEntryReturnType)(entry, "untyped"), (0, TypeSystem_1.isArrayType)(returnType) ? `### ${entry.name}: \`${returnType.valueType}[]\`` : returnType !== "untyped" ? `### ${entry.name}: \`${returnType}\`` : `### ${entry.name}`;
    }
    function sanitize(s) {
      return s?.replace(/(^|\n+)&gt;/g, " ").replace(/&gt;/g, ">").replace(/&lt;/g, "<").replace(/\]\(\//g, "](https://shopify.dev/").trim();
    }
    function docsetEntryBody(entry, returnType, docsetEntryType) {
      return [
        entry.deprecation_reason,
        entry.summary,
        entry.description,
        shopifyDevReference(entry, returnType, docsetEntryType)
      ].map(sanitize).filter(Boolean).join(HORIZONTAL_SEPARATOR);
    }
    function htmlEntryBody(entry, parentEntry) {
      return [description(entry), references(entry), references(parentEntry)].filter(Boolean).join(HORIZONTAL_SEPARATOR);
    }
    function description(entry) {
      return !entry.description || typeof entry.description == "string" ? entry.description : entry.description.value;
    }
    var shopifyDevRoot = "https://shopify.dev/docs/api/liquid";
    function shopifyDevReference(entry, returnType, docsetEntryType) {
      switch (docsetEntryType) {
        case "tag":
          return entry.name === "else" && "category" in entry ? `[Shopify Reference](${shopifyDevRoot}/tags/${entry.category}-${entry.name})` : "category" in entry ? `[Shopify Reference](${shopifyDevRoot}/tags/${entry.name})` : void 0;
        case "object":
          return returnType ? (0, TypeSystem_1.isArrayType)(returnType) ? `[Shopify Reference](${shopifyDevRoot}/objects/${returnType.valueType})` : "access" in entry ? `[Shopify Reference](${shopifyDevRoot}/objects/${returnType})` : void 0 : `[Shopify Reference](${shopifyDevRoot}/objects/${entry.name})`;
        case "filter":
          return "category" in entry ? `[Shopify Reference](${shopifyDevRoot}/filters/${entry.name})` : void 0;
        default:
          return;
      }
    }
    function references(entry) {
      if (!(!entry || !("references" in entry) || !entry.references || entry.references.length === 0)) {
        if (entry.references.length === 1) {
          let [ref] = entry.references;
          return `[${ref.name}](${ref.url})`;
        }
        return ["#### Learn more", entry.references.map((ref) => `- [${ref.name}](${ref.url})`)].join(`

`);
      }
    }
  }
});

// ../../node_modules/.pnpm/@vscode+web-custom-data@0.4.9/node_modules/@vscode/web-custom-data/data/browsers.html-data.json
var require_browsers_html_data = __commonJS({
  "../../node_modules/.pnpm/@vscode+web-custom-data@0.4.9/node_modules/@vscode/web-custom-data/data/browsers.html-data.json"(exports, module) {
    module.exports = {
      version: 1.1,
      tags: [
        {
          name: "html",
          description: {
            kind: "markdown",
            value: "The html element represents the root of an HTML document."
          },
          attributes: [
            {
              name: "manifest",
              description: {
                kind: "markdown",
                value: "Specifies the URI of a resource manifest indicating resources that should be cached locally. See [Using the application cache](https://developer.mozilla.org/en-US/docs/Web/HTML/Using_the_application_cache) for details."
              }
            },
            {
              name: "version",
              description: 'Specifies the version of the HTML [Document Type Definition](https://developer.mozilla.org/en-US/docs/Glossary/DTD "Document Type Definition: In HTML, the doctype is the required "<!DOCTYPE html>" preamble found at the top of all documents. Its sole purpose is to prevent a browser from switching into so-called \u201Cquirks mode\u201D when rendering a document; that is, the "<!DOCTYPE html>" doctype ensures that the browser makes a best-effort attempt at following the relevant specifications, rather than using a different rendering mode that is incompatible with some specifications.") that governs the current document. This attribute is not needed, because it is redundant with the version information in the document type declaration.'
            },
            {
              name: "xmlns",
              description: 'Specifies the XML Namespace of the document. Default value is `"http://www.w3.org/1999/xhtml"`. This is required in documents parsed with XML parsers, and optional in text/html documents.'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/html"
            }
          ]
        },
        {
          name: "head",
          description: {
            kind: "markdown",
            value: "The head element represents a collection of metadata for the Document."
          },
          attributes: [
            {
              name: "profile",
              description: "The URIs of one or more metadata profiles, separated by white space."
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/head"
            }
          ]
        },
        {
          name: "title",
          description: {
            kind: "markdown",
            value: "The title element represents the document's title or name. Authors should use titles that identify their documents even when they are used out of context, for example in a user's history or bookmarks, or in search results. The document's title is often different from its first heading, since the first heading does not have to stand alone when taken out of context."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/title"
            }
          ]
        },
        {
          name: "base",
          description: {
            kind: "markdown",
            value: "The base element allows authors to specify the document base URL for the purposes of resolving relative URLs, and the name of the default browsing context for the purposes of following hyperlinks. The element does not represent any content beyond this information."
          },
          void: !0,
          attributes: [
            {
              name: "href",
              description: {
                kind: "markdown",
                value: "The base URL to be used throughout the document for relative URL addresses. If this attribute is specified, this element must come before any other elements with attributes whose values are URLs. Absolute and relative URLs are allowed."
              }
            },
            {
              name: "target",
              valueSet: "target",
              description: {
                kind: "markdown",
                value: "A name or keyword indicating the default location to display the result when hyperlinks or forms cause navigation, for elements that do not have an explicit target reference. It is a name of, or keyword for, a _browsing context_ (for example: tab, window, or inline frame). The following keywords have special meanings:\n\n*   `_self`: Load the result into the same browsing context as the current one. This value is the default if the attribute is not specified.\n*   `_blank`: Load the result into a new unnamed browsing context.\n*   `_parent`: Load the result into the parent browsing context of the current one. If there is no parent, this option behaves the same way as `_self`.\n*   `_top`: Load the result into the top-level browsing context (that is, the browsing context that is an ancestor of the current one, and has no parent). If there is no parent, this option behaves the same way as `_self`.\n\nIf this attribute is specified, this element must come before any other elements with attributes whose values are URLs."
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/base"
            }
          ]
        },
        {
          name: "link",
          description: {
            kind: "markdown",
            value: "The link element allows authors to link their document to other resources."
          },
          void: !0,
          attributes: [
            {
              name: "href",
              description: {
                kind: "markdown",
                value: 'This attribute specifies the [URL](https://developer.mozilla.org/en-US/docs/Glossary/URL "URL: Uniform Resource Locator (URL) is a text string specifying where a resource can be found on the Internet.") of the linked resource. A URL can be absolute or relative.'
              }
            },
            {
              name: "crossorigin",
              valueSet: "xo",
              description: {
                kind: "markdown",
                value: 'This enumerated attribute indicates whether [CORS](https://developer.mozilla.org/en-US/docs/Glossary/CORS "CORS: CORS (Cross-Origin Resource Sharing) is a system, consisting of transmitting HTTP headers, that determines whether browsers block frontend JavaScript code from accessing responses for cross-origin requests.") must be used when fetching the resource. [CORS-enabled images](https://developer.mozilla.org/en-US/docs/Web/HTML/CORS_Enabled_Image) can be reused in the [`<canvas>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/canvas "Use the HTML <canvas> element with either the canvas scripting API or the WebGL API to draw graphics and animations.") element without being _tainted_. The allowed values are:\n\n`anonymous`\n\nA cross-origin request (i.e. with an [`Origin`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Origin "The Origin request header indicates where a fetch originates from. It doesn\'t include any path information, but only the server name. It is sent with CORS requests, as well as with POST requests. It is similar to the Referer header, but, unlike this header, it doesn\'t disclose the whole path.") HTTP header) is performed, but no credential is sent (i.e. no cookie, X.509 certificate, or HTTP Basic authentication). If the server does not give credentials to the origin site (by not setting the [`Access-Control-Allow-Origin`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Access-Control-Allow-Origin "The Access-Control-Allow-Origin response header indicates whether the response can be shared with requesting code from the given origin.") HTTP header) the image will be tainted and its usage restricted.\n\n`use-credentials`\n\nA cross-origin request (i.e. with an `Origin` HTTP header) is performed along with a credential sent (i.e. a cookie, certificate, and/or HTTP Basic authentication is performed). If the server does not give credentials to the origin site (through [`Access-Control-Allow-Credentials`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Access-Control-Allow-Credentials "The Access-Control-Allow-Credentials response header tells browsers whether to expose the response to frontend JavaScript code when the request\'s credentials mode (Request.credentials) is "include".") HTTP header), the resource will be _tainted_ and its usage restricted.\n\nIf the attribute is not present, the resource is fetched without a [CORS](https://developer.mozilla.org/en-US/docs/Glossary/CORS "CORS: CORS (Cross-Origin Resource Sharing) is a system, consisting of transmitting HTTP headers, that determines whether browsers block frontend JavaScript code from accessing responses for cross-origin requests.") request (i.e. without sending the `Origin` HTTP header), preventing its non-tainted usage. If invalid, it is handled as if the enumerated keyword **anonymous** was used. See [CORS settings attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/CORS_settings_attributes) for additional information.'
              }
            },
            {
              name: "rel",
              description: {
                kind: "markdown",
                value: "This attribute names a relationship of the linked document to the current document. The attribute must be a space-separated list of the [link types values](https://developer.mozilla.org/en-US/docs/Web/HTML/Link_types)."
              }
            },
            {
              name: "media",
              description: {
                kind: "markdown",
                value: "This attribute specifies the media that the linked resource applies to. Its value must be a media type / [media query](https://developer.mozilla.org/en-US/docs/Web/CSS/Media_queries). This attribute is mainly useful when linking to external stylesheets \u2014 it allows the user agent to pick the best adapted one for the device it runs on.\n\n**Notes:**\n\n*   In HTML 4, this can only be a simple white-space-separated list of media description literals, i.e., [media types and groups](https://developer.mozilla.org/en-US/docs/Web/CSS/@media), where defined and allowed as values for this attribute, such as `print`, `screen`, `aural`, `braille`. HTML5 extended this to any kind of [media queries](https://developer.mozilla.org/en-US/docs/Web/CSS/Media_queries), which are a superset of the allowed values of HTML 4.\n*   Browsers not supporting [CSS3 Media Queries](https://developer.mozilla.org/en-US/docs/Web/CSS/Media_queries) won't necessarily recognize the adequate link; do not forget to set fallback links, the restricted set of media queries defined in HTML 4."
              }
            },
            {
              name: "hreflang",
              description: {
                kind: "markdown",
                value: "This attribute indicates the language of the linked resource. It is purely advisory. Allowed values are determined by [BCP47](https://www.ietf.org/rfc/bcp/bcp47.txt). Use this attribute only if the [`href`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/a#attr-href) attribute is present."
              }
            },
            {
              name: "type",
              description: {
                kind: "markdown",
                value: 'This attribute is used to define the type of the content linked to. The value of the attribute should be a MIME type such as **text/html**, **text/css**, and so on. The common use of this attribute is to define the type of stylesheet being referenced (such as **text/css**), but given that CSS is the only stylesheet language used on the web, not only is it possible to omit the `type` attribute, but is actually now recommended practice. It is also used on `rel="preload"` link types, to make sure the browser only downloads file types that it supports.'
              }
            },
            {
              name: "sizes",
              description: {
                kind: "markdown",
                value: "This attribute defines the sizes of the icons for visual media contained in the resource. It must be present only if the [`rel`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/link#attr-rel) contains a value of `icon` or a non-standard type such as Apple's `apple-touch-icon`. It may have the following values:\n\n*   `any`, meaning that the icon can be scaled to any size as it is in a vector format, like `image/svg+xml`.\n*   a white-space separated list of sizes, each in the format `_<width in pixels>_x_<height in pixels>_` or `_<width in pixels>_X_<height in pixels>_`. Each of these sizes must be contained in the resource.\n\n**Note:** Most icon formats are only able to store one single icon; therefore most of the time the [`sizes`](https://developer.mozilla.org/en-US/docs/Web/HTML/Global_attributes#attr-sizes) contains only one entry. MS's ICO format does, as well as Apple's ICNS. ICO is more ubiquitous; you should definitely use it."
              }
            },
            {
              name: "as",
              description: 'This attribute is only used when `rel="preload"` or `rel="prefetch"` has been set on the `<link>` element. It specifies the type of content being loaded by the `<link>`, which is necessary for content prioritization, request matching, application of correct [content security policy](https://developer.mozilla.org/en-US/docs/Web/HTTP/CSP), and setting of correct [`Accept`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Accept "The Accept request HTTP header advertises which content types, expressed as MIME types, the client is able to understand. Using content negotiation, the server then selects one of the proposals, uses it and informs the client of its choice with the Content-Type response header. Browsers set adequate values for this header depending on\xA0the context where the request is done: when fetching a CSS stylesheet a different value is set for the request than when fetching an image,\xA0video or a script.") request header.'
            },
            {
              name: "importance",
              description: "Indicates the relative importance of the resource. Priority hints are delegated using the values:"
            },
            {
              name: "importance",
              description: '**`auto`**: Indicates\xA0**no\xA0preference**. The browser may use its own heuristics to decide the priority of the resource.\n\n**`high`**: Indicates to the\xA0browser\xA0that the resource is of\xA0**high** priority.\n\n**`low`**:\xA0Indicates to the\xA0browser\xA0that the resource is of\xA0**low** priority.\n\n**Note:** The `importance` attribute may only be used for the `<link>` element if `rel="preload"` or `rel="prefetch"` is present.'
            },
            {
              name: "integrity",
              description: "Contains inline metadata \u2014 a base64-encoded cryptographic hash of the resource (file) you\u2019re telling the browser to fetch. The browser can use this to verify that the fetched resource has been delivered free of unexpected manipulation. See [Subresource Integrity](https://developer.mozilla.org/en-US/docs/Web/Security/Subresource_Integrity)."
            },
            {
              name: "referrerpolicy",
              description: 'A string indicating which referrer to use when fetching the resource:\n\n*   `no-referrer` means that the [`Referer`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer "The Referer request header contains the address of the previous web page from which a link to the currently requested page was followed. The Referer header allows servers to identify where people are visiting them from and may use that data for analytics, logging, or optimized caching, for example.") header will not be sent.\n*   `no-referrer-when-downgrade` means that no [`Referer`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer "The Referer request header contains the address of the previous web page from which a link to the currently requested page was followed. The Referer header allows servers to identify where people are visiting them from and may use that data for analytics, logging, or optimized caching, for example.") header will be sent when navigating to an origin without TLS (HTTPS). This is a user agent\u2019s default behavior, if no policy is otherwise specified.\n*   `origin` means that the referrer will be the origin of the page, which is roughly the scheme, the host, and the port.\n*   `origin-when-cross-origin` means that navigating to other origins will be limited to the scheme, the host, and the port, while navigating on the same origin will include the referrer\'s path.\n*   `unsafe-url` means that the referrer will include the origin and the path (but not the fragment, password, or username). This case is unsafe because it can leak origins and paths from TLS-protected resources to insecure origins.'
            },
            {
              name: "title",
              description: 'The `title` attribute has special semantics on the `<link>` element. When used on a `<link rel="stylesheet">` it defines a [preferred or an alternate stylesheet](https://developer.mozilla.org/en-US/docs/Web/CSS/Alternative_style_sheets). Incorrectly using it may [cause the stylesheet to be ignored](https://developer.mozilla.org/en-US/docs/Correctly_Using_Titles_With_External_Stylesheets).'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/link"
            }
          ]
        },
        {
          name: "meta",
          description: {
            kind: "markdown",
            value: "The meta element represents various kinds of metadata that cannot be expressed using the title, base, link, style, and script elements."
          },
          void: !0,
          attributes: [
            {
              name: "name",
              description: {
                kind: "markdown",
                value: `This attribute defines the name of a piece of document-level metadata. It should not be set if one of the attributes [\`itemprop\`](https://developer.mozilla.org/en-US/docs/Web/HTML/Global_attributes#attr-itemprop), [\`http-equiv\`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-http-equiv) or [\`charset\`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-charset) is also set.

This metadata name is associated with the value contained by the [\`content\`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-content) attribute. The possible values for the name attribute are:

*   \`application-name\` which defines the name of the application running in the web page.
    
    **Note:**
    
    *   Browsers may use this to identify the application. It is different from the [\`<title>\`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/title "The HTML Title element (<title>) defines the document's title that is shown in a browser's title bar or a page's tab.") element, which usually contain the application name, but may also contain information like the document name or a status.
    *   Simple web pages shouldn't define an application-name.
    
*   \`author\` which defines the name of the document's author.
*   \`description\` which contains a short and accurate summary of the content of the page. Several browsers, like Firefox and Opera, use this as the default description of bookmarked pages.
*   \`generator\` which contains the identifier of the software that generated the page.
*   \`keywords\` which contains words relevant to the page's content separated by commas.
*   \`referrer\` which controls the [\`Referer\` HTTP header](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer) attached to requests sent from the document:
    
    Values for the \`content\` attribute of \`<meta name="referrer">\`
    
    \`no-referrer\`
    
    Do not send a HTTP \`Referrer\` header.
    
    \`origin\`
    
    Send the [origin](https://developer.mozilla.org/en-US/docs/Glossary/Origin) of the document.
    
    \`no-referrer-when-downgrade\`
    
    Send the [origin](https://developer.mozilla.org/en-US/docs/Glossary/Origin) as a referrer to URLs as secure as the current page, (https\u2192https), but does not send a referrer to less secure URLs (https\u2192http). This is the default behaviour.
    
    \`origin-when-cross-origin\`
    
    Send the full URL (stripped of parameters) for same-origin requests, but only send the [origin](https://developer.mozilla.org/en-US/docs/Glossary/Origin) for other cases.
    
    \`same-origin\`
    
    A referrer will be sent for [same-site origins](https://developer.mozilla.org/en-US/docs/Web/Security/Same-origin_policy), but cross-origin requests will contain no referrer information.
    
    \`strict-origin\`
    
    Only send the origin of the document as the referrer to a-priori as-much-secure destination (HTTPS->HTTPS), but don't send it to a less secure destination (HTTPS->HTTP).
    
    \`strict-origin-when-cross-origin\`
    
    Send a full URL when performing a same-origin request, only send the origin of the document to a-priori as-much-secure destination (HTTPS->HTTPS), and send no header to a less secure destination (HTTPS->HTTP).
    
    \`unsafe-URL\`
    
    Send the full URL (stripped of parameters) for same-origin or cross-origin requests.
    
    **Notes:**
    
    *   Some browsers support the deprecated values of \`always\`, \`default\`, and \`never\` for referrer.
    *   Dynamically inserting \`<meta name="referrer">\` (with [\`document.write\`](https://developer.mozilla.org/en-US/docs/Web/API/Document/write) or [\`appendChild\`](https://developer.mozilla.org/en-US/docs/Web/API/Node/appendChild)) makes the referrer behaviour unpredictable.
    *   When several conflicting policies are defined, the no-referrer policy is applied.
    

This attribute may also have a value taken from the extended list defined on [WHATWG Wiki MetaExtensions page](https://wiki.whatwg.org/wiki/MetaExtensions). Although none have been formally accepted yet, a few commonly used names are:

*   \`creator\` which defines the name of the creator of the document, such as an organization or institution. If there are more than one, several [\`<meta>\`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta "The HTML <meta> element represents metadata that cannot be represented by other HTML meta-related elements, like <base>, <link>, <script>, <style> or <title>.") elements should be used.
*   \`googlebot\`, a synonym of \`robots\`, is only followed by Googlebot (the indexing crawler for Google).
*   \`publisher\` which defines the name of the document's publisher.
*   \`robots\` which defines the behaviour that cooperative crawlers, or "robots", should use with the page. It is a comma-separated list of the values below:
    
    Values for the content of \`<meta name="robots">\`
    
    Value
    
    Description
    
    Used by
    
    \`index\`
    
    Allows the robot to index the page (default).
    
    All
    
    \`noindex\`
    
    Requests the robot to not index the page.
    
    All
    
    \`follow\`
    
    Allows the robot to follow the links on the page (default).
    
    All
    
    \`nofollow\`
    
    Requests the robot to not follow the links on the page.
    
    All
    
    \`none\`
    
    Equivalent to \`noindex, nofollow\`
    
    [Google](https://support.google.com/webmasters/answer/79812)
    
    \`noodp\`
    
    Prevents using the [Open Directory Project](https://www.dmoz.org/) description, if any, as the page description in search engine results.
    
    [Google](https://support.google.com/webmasters/answer/35624#nodmoz), [Yahoo](https://help.yahoo.com/kb/search-for-desktop/meta-tags-robotstxt-yahoo-search-sln2213.html#cont5), [Bing](https://www.bing.com/webmaster/help/which-robots-metatags-does-bing-support-5198d240)
    
    \`noarchive\`
    
    Requests the search engine not to cache the page content.
    
    [Google](https://developers.google.com/webmasters/control-crawl-index/docs/robots_meta_tag#valid-indexing--serving-directives), [Yahoo](https://help.yahoo.com/kb/search-for-desktop/SLN2213.html), [Bing](https://www.bing.com/webmaster/help/which-robots-metatags-does-bing-support-5198d240)
    
    \`nosnippet\`
    
    Prevents displaying any description of the page in search engine results.
    
    [Google](https://developers.google.com/webmasters/control-crawl-index/docs/robots_meta_tag#valid-indexing--serving-directives), [Bing](https://www.bing.com/webmaster/help/which-robots-metatags-does-bing-support-5198d240)
    
    \`noimageindex\`
    
    Requests this page not to appear as the referring page of an indexed image.
    
    [Google](https://developers.google.com/webmasters/control-crawl-index/docs/robots_meta_tag#valid-indexing--serving-directives)
    
    \`nocache\`
    
    Synonym of \`noarchive\`.
    
    [Bing](https://www.bing.com/webmaster/help/which-robots-metatags-does-bing-support-5198d240)
    
    **Notes:**
    
    *   Only cooperative robots follow these rules. Do not expect to prevent e-mail harvesters with them.
    *   The robot still needs to access the page in order to read these rules. To prevent bandwidth consumption, use a _[robots.txt](https://developer.mozilla.org/en-US/docs/Glossary/robots.txt "robots.txt: Robots.txt is a file which is usually placed in the root of any website. It decides whether\xA0crawlers are permitted or forbidden access to the web site.")_ file.
    *   If you want to remove a page, \`noindex\` will work, but only after the robot visits the page again. Ensure that the \`robots.txt\` file is not preventing revisits.
    *   Some values are mutually exclusive, like \`index\` and \`noindex\`, or \`follow\` and \`nofollow\`. In these cases the robot's behaviour is undefined and may vary between them.
    *   Some crawler robots, like Google, Yahoo and Bing, support the same values for the HTTP header \`X-Robots-Tag\`; this allows non-HTML documents like images to use these rules.
    
*   \`slurp\`, is a synonym of \`robots\`, but only for Slurp - the crawler for Yahoo Search.
*   \`viewport\`, which gives hints about the size of the initial size of the [viewport](https://developer.mozilla.org/en-US/docs/Glossary/viewport "viewport: A viewport represents a polygonal (normally rectangular) area in computer graphics that is currently being viewed. In web browser terms, it refers to the part of the document you're viewing which is currently visible in its window (or the screen, if the document is being viewed in full screen mode). Content outside the viewport is not visible onscreen until scrolled into view."). Used by mobile devices only.
    
    Values for the content of \`<meta name="viewport">\`
    
    Value
    
    Possible subvalues
    
    Description
    
    \`width\`
    
    A positive integer number, or the text \`device-width\`
    
    Defines the pixel width of the viewport that you want the web site to be rendered at.
    
    \`height\`
    
    A positive integer, or the text \`device-height\`
    
    Defines the height of the viewport. Not used by any browser.
    
    \`initial-scale\`
    
    A positive number between \`0.0\` and \`10.0\`
    
    Defines the ratio between the device width (\`device-width\` in portrait mode or \`device-height\` in landscape mode) and the viewport size.
    
    \`maximum-scale\`
    
    A positive number between \`0.0\` and \`10.0\`
    
    Defines the maximum amount to zoom in. It must be greater or equal to the \`minimum-scale\` or the behaviour is undefined. Browser settings can ignore this rule and iOS10+ ignores it by default.
    
    \`minimum-scale\`
    
    A positive number between \`0.0\` and \`10.0\`
    
    Defines the minimum zoom level. It must be smaller or equal to the \`maximum-scale\` or the behaviour is undefined. Browser settings can ignore this rule and iOS10+ ignores it by default.
    
    \`user-scalable\`
    
    \`yes\` or \`no\`
    
    If set to \`no\`, the user is not able to zoom in the webpage. The default is \`yes\`. Browser settings can ignore this rule, and iOS10+ ignores it by default.
    
    Specification
    
    Status
    
    Comment
    
    [CSS Device Adaptation  
    The definition of '<meta name="viewport">' in that specification.](https://drafts.csswg.org/css-device-adapt/#viewport-meta)
    
    Working Draft
    
    Non-normatively describes the Viewport META element
    
    See also: [\`@viewport\`](https://developer.mozilla.org/en-US/docs/Web/CSS/@viewport "The @viewport CSS at-rule lets you configure the viewport through which the document is viewed. It's primarily used for mobile devices, but is also used by desktop browsers that support features like "snap to edge" (such as Microsoft Edge).")
    
    **Notes:**
    
    *   Though unstandardized, this declaration is respected by most mobile browsers due to de-facto dominance.
    *   The default values may vary between devices and browsers.
    *   To learn about this declaration in Firefox for Mobile, see [this article](https://developer.mozilla.org/en-US/docs/Mobile/Viewport_meta_tag "Mobile/Viewport meta tag").`
              }
            },
            {
              name: "http-equiv",
              description: {
                kind: "markdown",
                value: 'Defines a pragma directive. The attribute is named `**http-equiv**(alent)` because all the allowed values are names of particular HTTP headers:\n\n*   `"content-language"`  \n    Defines the default language of the page. It can be overridden by the [lang](https://developer.mozilla.org/en-US/docs/Web/HTML/Global_attributes/lang) attribute on any element.\n    \n    **Warning:** Do not use this value, as it is obsolete. Prefer the `lang` attribute on the [`<html>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/html "The HTML <html> element represents the root (top-level element) of an HTML document, so it is also referred to as the root element. All other elements must be descendants of this element.") element.\n    \n*   `"content-security-policy"`  \n    Allows page authors to define a [content policy](https://developer.mozilla.org/en-US/docs/Web/Security/CSP/CSP_policy_directives) for the current page. Content policies mostly specify allowed server origins and script endpoints which help guard against cross-site scripting attacks.\n*   `"content-type"`  \n    Defines the [MIME type](https://developer.mozilla.org/en-US/docs/Glossary/MIME_type) of the document, followed by its character encoding. It follows the same syntax as the HTTP `content-type` entity-header field, but as it is inside a HTML page, most values other than `text/html` are impossible. Therefore the valid syntax for its `content` is the string \'`text/html`\' followed by a character set with the following syntax: \'`; charset=_IANAcharset_`\', where `IANAcharset` is the _preferred MIME name_ for a character set as [defined by the IANA.](https://www.iana.org/assignments/character-sets)\n    \n    **Warning:** Do not use this value, as it is obsolete. Use the [`charset`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-charset) attribute on the [`<meta>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta "The HTML <meta> element represents metadata that cannot be represented by other HTML meta-related elements, like <base>, <link>, <script>, <style> or <title>.") element.\n    \n    **Note:** As [`<meta>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta "The HTML <meta> element represents metadata that cannot be represented by other HTML meta-related elements, like <base>, <link>, <script>, <style> or <title>.") can\'t change documents\' types in XHTML or HTML5\'s XHTML serialization, never set the MIME type to an XHTML MIME type with `<meta>`.\n    \n*   `"refresh"`  \n    This instruction specifies:\n    *   The number of seconds until the page should be reloaded - only if the [`content`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-content) attribute contains a positive integer.\n    *   The number of seconds until the page should redirect to another - only if the [`content`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-content) attribute contains a positive integer followed by the string \'`;url=`\', and a valid URL.\n*   `"set-cookie"`  \n    Defines a [cookie](https://developer.mozilla.org/en-US/docs/cookie) for the page. Its content must follow the syntax defined in the [IETF HTTP Cookie Specification](https://tools.ietf.org/html/draft-ietf-httpstate-cookie-14).\n    \n    **Warning:** Do not use this instruction, as it is obsolete. Use the HTTP header [`Set-Cookie`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Set-Cookie) instead.'
              }
            },
            {
              name: "content",
              description: {
                kind: "markdown",
                value: "This attribute contains the value for the [`http-equiv`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-http-equiv) or [`name`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-name) attribute, depending on which is used."
              }
            },
            {
              name: "charset",
              description: {
                kind: "markdown",
                value: 'This attribute declares the page\'s character encoding. It must contain a [standard IANA MIME name for character encodings](https://www.iana.org/assignments/character-sets). Although the standard doesn\'t request a specific encoding, it suggests:\n\n*   Authors are encouraged to use [`UTF-8`](https://developer.mozilla.org/en-US/docs/Glossary/UTF-8).\n*   Authors should not use ASCII-incompatible encodings to avoid security risk: browsers not supporting them may interpret harmful content as HTML. This happens with the `JIS_C6226-1983`, `JIS_X0212-1990`, `HZ-GB-2312`, `JOHAB`, the ISO-2022 family and the EBCDIC family.\n\n**Note:** ASCII-incompatible encodings are those that don\'t map the 8-bit code points `0x20` to `0x7E` to the `0x0020` to `0x007E` Unicode code points)\n\n*   Authors **must not** use `CESU-8`, `UTF-7`, `BOCU-1` and/or `SCSU` as [cross-site scripting](https://developer.mozilla.org/en-US/docs/Glossary/Cross-site_scripting) attacks with these encodings have been demonstrated.\n*   Authors should not use `UTF-32` because not all HTML5 encoding algorithms can distinguish it from `UTF-16`.\n\n**Notes:**\n\n*   The declared character encoding must match the one the page was saved with to avoid garbled characters and security holes.\n*   The [`<meta>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta "The HTML <meta> element represents metadata that cannot be represented by other HTML meta-related elements, like <base>, <link>, <script>, <style> or <title>.") element declaring the encoding must be inside the [`<head>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/head "The HTML <head> element provides general information (metadata) about the document, including its title and links to its\xA0scripts and style sheets.") element and **within the first 1024 bytes** of the HTML as some browsers only look at those bytes before choosing an encoding.\n*   This [`<meta>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta "The HTML <meta> element represents metadata that cannot be represented by other HTML meta-related elements, like <base>, <link>, <script>, <style> or <title>.") element is only one part of the [algorithm to determine a page\'s character set](https://www.whatwg.org/specs/web-apps/current-work/multipage/parsing.html#encoding-sniffing-algorithm "Algorithm charset page"). The [`Content-Type` header](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Content-Type) and any [Byte-Order Marks](https://developer.mozilla.org/en-US/docs/Glossary/Byte-Order_Mark "The definition of that term (Byte-Order Marks) has not been written yet; please consider contributing it!") override this element.\n*   It is strongly recommended to define the character encoding. If a page\'s encoding is undefined, cross-scripting techniques are possible, such as the [`UTF-7` fallback cross-scripting technique](https://code.google.com/p/doctype-mirror/wiki/ArticleUtf7).\n*   The [`<meta>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta "The HTML <meta> element represents metadata that cannot be represented by other HTML meta-related elements, like <base>, <link>, <script>, <style> or <title>.") element with a `charset` attribute is a synonym for the pre-HTML5 `<meta http-equiv="Content-Type" content="text/html; charset=_IANAcharset_">`, where _`IANAcharset`_ contains the value of the equivalent [`charset`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-charset) attribute. This syntax is still allowed, although no longer recommended.'
              }
            },
            {
              name: "scheme",
              description: "This attribute defines the scheme in which metadata is described. A scheme is a context leading to the correct interpretations of the [`content`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/meta#attr-content) value, like a format.\n\n**Warning:** Do not use this value, as it is obsolete. There is no replacement as there was no real usage for it."
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/meta"
            }
          ]
        },
        {
          name: "style",
          description: {
            kind: "markdown",
            value: "The style element allows authors to embed style information in their documents. The style element is one of several inputs to the styling processing model. The element does not represent content for the user."
          },
          attributes: [
            {
              name: "media",
              description: {
                kind: "markdown",
                value: "This attribute defines which media the style should be applied to. Its value is a [media query](https://developer.mozilla.org/en-US/docs/Web/Guide/CSS/Media_queries), which defaults to `all` if the attribute is missing."
              }
            },
            {
              name: "nonce",
              description: {
                kind: "markdown",
                value: "A cryptographic nonce (number used once) used to whitelist inline styles in a [style-src Content-Security-Policy](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Content-Security-Policy/style-src). The server must generate a unique nonce value each time it transmits a policy. It is critical to provide a nonce that cannot be guessed as bypassing a resource\u2019s policy is otherwise trivial."
              }
            },
            {
              name: "type",
              description: {
                kind: "markdown",
                value: "This attribute defines the styling language as a MIME type (charset should not be specified). This attribute is optional and defaults to `text/css` if it is not specified \u2014 there is very little reason to include this in modern web documents."
              }
            },
            {
              name: "scoped",
              valueSet: "v"
            },
            {
              name: "title",
              description: "This attribute specifies [alternative style sheet](https://developer.mozilla.org/en-US/docs/Web/CSS/Alternative_style_sheets) sets."
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/style"
            }
          ]
        },
        {
          name: "body",
          description: {
            kind: "markdown",
            value: "The body element represents the content of the document."
          },
          attributes: [
            {
              name: "onafterprint",
              description: {
                kind: "markdown",
                value: "Function to call after the user has printed the document."
              }
            },
            {
              name: "onbeforeprint",
              description: {
                kind: "markdown",
                value: "Function to call when the user requests printing of the document."
              }
            },
            {
              name: "onbeforeunload",
              description: {
                kind: "markdown",
                value: "Function to call when the document is about to be unloaded."
              }
            },
            {
              name: "onhashchange",
              description: {
                kind: "markdown",
                value: "Function to call when the fragment identifier part (starting with the hash (`'#'`) character) of the document's current address has changed."
              }
            },
            {
              name: "onlanguagechange",
              description: {
                kind: "markdown",
                value: "Function to call when the preferred languages changed."
              }
            },
            {
              name: "onmessage",
              description: {
                kind: "markdown",
                value: "Function to call when the document has received a message."
              }
            },
            {
              name: "onoffline",
              description: {
                kind: "markdown",
                value: "Function to call when network communication has failed."
              }
            },
            {
              name: "ononline",
              description: {
                kind: "markdown",
                value: "Function to call when network communication has been restored."
              }
            },
            {
              name: "onpagehide"
            },
            {
              name: "onpageshow"
            },
            {
              name: "onpopstate",
              description: {
                kind: "markdown",
                value: "Function to call when the user has navigated session history."
              }
            },
            {
              name: "onstorage",
              description: {
                kind: "markdown",
                value: "Function to call when the storage area has changed."
              }
            },
            {
              name: "onunload",
              description: {
                kind: "markdown",
                value: "Function to call when the document is going away."
              }
            },
            {
              name: "alink",
              description: 'Color of text for hyperlinks when selected. _This method is non-conforming, use CSS [`color`](https://developer.mozilla.org/en-US/docs/Web/CSS/color "The color CSS property sets the foreground color value of an element\'s text and text decorations, and sets the currentcolor value.") property in conjunction with the [`:active`](https://developer.mozilla.org/en-US/docs/Web/CSS/:active "The :active CSS pseudo-class represents an element (such as a button) that is being activated by the user.") pseudo-class instead._'
            },
            {
              name: "background",
              description: 'URI of a image to use as a background. _This method is non-conforming, use CSS [`background`](https://developer.mozilla.org/en-US/docs/Web/CSS/background "The background shorthand CSS property sets all background style properties at once, such as color, image, origin and size, or repeat method.") property on the element instead._'
            },
            {
              name: "bgcolor",
              description: 'Background color for the document. _This method is non-conforming, use CSS [`background-color`](https://developer.mozilla.org/en-US/docs/Web/CSS/background-color "The background-color CSS property sets the background color of an element.") property on the element instead._'
            },
            {
              name: "bottommargin",
              description: 'The margin of the bottom of the body. _This method is non-conforming, use CSS [`margin-bottom`](https://developer.mozilla.org/en-US/docs/Web/CSS/margin-bottom "The margin-bottom CSS property sets the margin area on the bottom of an element. A positive value places it farther from its neighbors, while a negative value places it closer.") property on the element instead._'
            },
            {
              name: "leftmargin",
              description: 'The margin of the left of the body. _This method is non-conforming, use CSS [`margin-left`](https://developer.mozilla.org/en-US/docs/Web/CSS/margin-left "The margin-left CSS property sets the margin area on the left side of an element. A positive value places it farther from its neighbors, while a negative value places it closer.") property on the element instead._'
            },
            {
              name: "link",
              description: 'Color of text for unvisited hypertext links. _This method is non-conforming, use CSS [`color`](https://developer.mozilla.org/en-US/docs/Web/CSS/color "The color CSS property sets the foreground color value of an element\'s text and text decorations, and sets the currentcolor value.") property in conjunction with the [`:link`](https://developer.mozilla.org/en-US/docs/Web/CSS/:link "The :link CSS pseudo-class represents an element that has not yet been visited. It matches every unvisited <a>, <area>, or <link> element that has an href attribute.") pseudo-class instead._'
            },
            {
              name: "onblur",
              description: "Function to call when the document loses focus."
            },
            {
              name: "onerror",
              description: "Function to call when the document fails to load properly."
            },
            {
              name: "onfocus",
              description: "Function to call when the document receives focus."
            },
            {
              name: "onload",
              description: "Function to call when the document has finished loading."
            },
            {
              name: "onredo",
              description: "Function to call when the user has moved forward in undo transaction history."
            },
            {
              name: "onresize",
              description: "Function to call when the document has been resized."
            },
            {
              name: "onundo",
              description: "Function to call when the user has moved backward in undo transaction history."
            },
            {
              name: "rightmargin",
              description: 'The margin of the right of the body. _This method is non-conforming, use CSS [`margin-right`](https://developer.mozilla.org/en-US/docs/Web/CSS/margin-right "The margin-right CSS property sets the margin area on the right side of an element. A positive value places it farther from its neighbors, while a negative value places it closer.") property on the element instead._'
            },
            {
              name: "text",
              description: 'Foreground color of text. _This method is non-conforming, use CSS [`color`](https://developer.mozilla.org/en-US/docs/Web/CSS/color "The color CSS property sets the foreground color value of an element\'s text and text decorations, and sets the currentcolor value.") property on the element instead._'
            },
            {
              name: "topmargin",
              description: 'The margin of the top of the body. _This method is non-conforming, use CSS [`margin-top`](https://developer.mozilla.org/en-US/docs/Web/CSS/margin-top "The margin-top CSS property sets the margin area on the top of an element. A positive value places it farther from its neighbors, while a negative value places it closer.") property on the element instead._'
            },
            {
              name: "vlink",
              description: 'Color of text for visited hypertext links. _This method is non-conforming, use CSS [`color`](https://developer.mozilla.org/en-US/docs/Web/CSS/color "The color CSS property sets the foreground color value of an element\'s text and text decorations, and sets the currentcolor value.") property in conjunction with the [`:visited`](https://developer.mozilla.org/en-US/docs/Web/CSS/:visited "The :visited CSS pseudo-class represents links that the user has already visited. For privacy reasons, the styles that can be modified using this selector are very limited.") pseudo-class instead._'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/body"
            }
          ]
        },
        {
          name: "article",
          description: {
            kind: "markdown",
            value: "The article element represents a complete, or self-contained, composition in a document, page, application, or site and that is, in principle, independently distributable or reusable, e.g. in syndication. This could be a forum post, a magazine or newspaper article, a blog entry, a user-submitted comment, an interactive widget or gadget, or any other independent item of content. Each article should be identified, typically by including a heading (h1\u2013h6 element) as a child of the article element."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/article"
            }
          ]
        },
        {
          name: "section",
          description: {
            kind: "markdown",
            value: "The section element represents a generic section of a document or application. A section, in this context, is a thematic grouping of content. Each section should be identified, typically by including a heading ( h1- h6 element) as a child of the section element."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/section"
            }
          ]
        },
        {
          name: "nav",
          description: {
            kind: "markdown",
            value: "The nav element represents a section of a page that links to other pages or to parts within the page: a section with navigation links."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/nav"
            }
          ]
        },
        {
          name: "aside",
          description: {
            kind: "markdown",
            value: "The aside element represents a section of a page that consists of content that is tangentially related to the content around the aside element, and which could be considered separate from that content. Such sections are often represented as sidebars in printed typography."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/aside"
            }
          ]
        },
        {
          name: "h1",
          description: {
            kind: "markdown",
            value: "The h1 element represents a section heading."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/Heading_Elements"
            }
          ]
        },
        {
          name: "h2",
          description: {
            kind: "markdown",
            value: "The h2 element represents a section heading."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/Heading_Elements"
            }
          ]
        },
        {
          name: "h3",
          description: {
            kind: "markdown",
            value: "The h3 element represents a section heading."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/Heading_Elements"
            }
          ]
        },
        {
          name: "h4",
          description: {
            kind: "markdown",
            value: "The h4 element represents a section heading."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/Heading_Elements"
            }
          ]
        },
        {
          name: "h5",
          description: {
            kind: "markdown",
            value: "The h5 element represents a section heading."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/Heading_Elements"
            }
          ]
        },
        {
          name: "h6",
          description: {
            kind: "markdown",
            value: "The h6 element represents a section heading."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/Heading_Elements"
            }
          ]
        },
        {
          name: "header",
          description: {
            kind: "markdown",
            value: "The header element represents introductory content for its nearest ancestor sectioning content or sectioning root element. A header typically contains a group of introductory or navigational aids. When the nearest ancestor sectioning content or sectioning root element is the body element, then it applies to the whole page."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/header"
            }
          ]
        },
        {
          name: "footer",
          description: {
            kind: "markdown",
            value: "The footer element represents a footer for its nearest ancestor sectioning content or sectioning root element. A footer typically contains information about its section such as who wrote it, links to related documents, copyright data, and the like."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/footer"
            }
          ]
        },
        {
          name: "address",
          description: {
            kind: "markdown",
            value: "The address element represents the contact information for its nearest article or body element ancestor. If that is the body element, then the contact information applies to the document as a whole."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/address"
            }
          ]
        },
        {
          name: "p",
          description: {
            kind: "markdown",
            value: "The p element represents a paragraph."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/p"
            }
          ]
        },
        {
          name: "hr",
          description: {
            kind: "markdown",
            value: "The hr element represents a paragraph-level thematic break, e.g. a scene change in a story, or a transition to another topic within a section of a reference book."
          },
          void: !0,
          attributes: [
            {
              name: "align",
              description: "Sets the alignment of the rule on the page. If no value is specified, the default value is `left`."
            },
            {
              name: "color",
              description: "Sets the color of the rule through color name or hexadecimal value."
            },
            {
              name: "noshade",
              description: "Sets the rule to have no shading."
            },
            {
              name: "size",
              description: "Sets the height, in pixels, of the rule."
            },
            {
              name: "width",
              description: "Sets the length of the rule on the page through a pixel or percentage value."
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/hr"
            }
          ]
        },
        {
          name: "pre",
          description: {
            kind: "markdown",
            value: "The pre element represents a block of preformatted text, in which structure is represented by typographic conventions rather than by elements."
          },
          attributes: [
            {
              name: "cols",
              description: 'Contains the _preferred_ count of characters that a line should have. It was a non-standard synonym of [`width`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/pre#attr-width). To achieve such an effect, use CSS [`width`](https://developer.mozilla.org/en-US/docs/Web/CSS/width "The width CSS property sets an element\'s width. By default it sets the width of the content area, but if box-sizing is set to border-box, it sets the width of the border area.") instead.'
            },
            {
              name: "width",
              description: 'Contains the _preferred_ count of characters that a line should have. Though technically still implemented, this attribute has no visual effect; to achieve such an effect, use CSS [`width`](https://developer.mozilla.org/en-US/docs/Web/CSS/width "The width CSS property sets an element\'s width. By default it sets the width of the content area, but if box-sizing is set to border-box, it sets the width of the border area.") instead.'
            },
            {
              name: "wrap",
              description: 'Is a _hint_ indicating how the overflow must happen. In modern browser this hint is ignored and no visual effect results in its present; to achieve such an effect, use CSS [`white-space`](https://developer.mozilla.org/en-US/docs/Web/CSS/white-space "The white-space CSS property sets how white space inside an element is handled.") instead.'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/pre"
            }
          ]
        },
        {
          name: "blockquote",
          description: {
            kind: "markdown",
            value: "The blockquote element represents content that is quoted from another source, optionally with a citation which must be within a footer or cite element, and optionally with in-line changes such as annotations and abbreviations."
          },
          attributes: [
            {
              name: "cite",
              description: {
                kind: "markdown",
                value: "A URL that designates a source document or message for the information quoted. This attribute is intended to point to information explaining the context or the reference for the quote."
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/blockquote"
            }
          ]
        },
        {
          name: "ol",
          description: {
            kind: "markdown",
            value: "The ol element represents a list of items, where the items have been intentionally ordered, such that changing the order would change the meaning of the document."
          },
          attributes: [
            {
              name: "reversed",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "This Boolean attribute specifies that the items of the list are specified in reversed order."
              }
            },
            {
              name: "start",
              description: {
                kind: "markdown",
                value: 'This integer attribute specifies the start value for numbering the individual list items. Although the ordering type of list elements might be Roman numerals, such as XXXI, or letters, the value of start is always represented as a number. To start numbering elements from the letter "C", use `<ol start="3">`.\n\n**Note**: This attribute was deprecated in HTML4, but reintroduced in HTML5.'
              }
            },
            {
              name: "type",
              valueSet: "lt",
              description: {
                kind: "markdown",
                value: "Indicates the numbering type:\n\n*   `'a'` indicates lowercase letters,\n*   `'A'` indicates uppercase letters,\n*   `'i'` indicates lowercase Roman numerals,\n*   `'I'` indicates uppercase Roman numerals,\n*   and `'1'` indicates numbers (default).\n\nThe type set is used for the entire list unless a different [`type`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/li#attr-type) attribute is used within an enclosed [`<li>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/li \"The HTML <li> element is used to represent an item in a list. It must be contained in a parent element: an ordered list (<ol>), an unordered list (<ul>), or a menu (<menu>). In menus and unordered lists, list items are usually displayed using bullet points. In ordered lists, they are usually displayed with an ascending counter on the left, such as a number or letter.\") element.\n\n**Note:** This attribute was deprecated in HTML4, but reintroduced in HTML5.\n\nUnless the value of the list number matters (e.g. in legal or technical documents where items are to be referenced by their number/letter), the CSS [`list-style-type`](https://developer.mozilla.org/en-US/docs/Web/CSS/list-style-type \"The list-style-type CSS property sets the marker (such as a disc, character, or custom counter style) of a list item element.\") property should be used instead."
              }
            },
            {
              name: "compact",
              description: 'This Boolean attribute hints that the list should be rendered in a compact style. The interpretation of this attribute depends on the user agent and it doesn\'t work in all browsers.\n\n**Warning:** Do not use this attribute, as it has been deprecated: the [`<ol>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/ol "The HTML <ol> element represents an ordered list of items, typically rendered as a numbered list.") element should be styled using [CSS](https://developer.mozilla.org/en-US/docs/CSS). To give an effect similar to the `compact` attribute, the [CSS](https://developer.mozilla.org/en-US/docs/CSS) property [`line-height`](https://developer.mozilla.org/en-US/docs/Web/CSS/line-height "The line-height CSS property sets the amount of space used for lines, such as in text. On block-level elements, it specifies the minimum height of line boxes within the element. On non-replaced inline elements, it specifies the height that is used to calculate line box height.") can be used with a value of `80%`.'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/ol"
            }
          ]
        },
        {
          name: "ul",
          description: {
            kind: "markdown",
            value: "The ul element represents a list of items, where the order of the items is not important \u2014 that is, where changing the order would not materially change the meaning of the document."
          },
          attributes: [
            {
              name: "compact",
              description: 'This Boolean attribute hints that the list should be rendered in a compact style. The interpretation of this attribute depends on the user agent and it doesn\'t work in all browsers.\n\n**Usage note:\xA0**Do not use this attribute, as it has been deprecated: the [`<ul>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/ul "The HTML <ul> element represents an unordered list of items, typically rendered as a bulleted list.") element should be styled using [CSS](https://developer.mozilla.org/en-US/docs/CSS). To give a similar effect as the `compact` attribute, the [CSS](https://developer.mozilla.org/en-US/docs/CSS) property [line-height](https://developer.mozilla.org/en-US/docs/CSS/line-height) can be used with a value of `80%`.'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/ul"
            }
          ]
        },
        {
          name: "li",
          description: {
            kind: "markdown",
            value: "The li element represents a list item. If its parent element is an ol, ul, or menu element, then the element is an item of the parent element's list, as defined for those elements. Otherwise, the list item has no defined list-related relationship to any other li element."
          },
          attributes: [
            {
              name: "value",
              description: {
                kind: "markdown",
                value: 'This integer attribute indicates the current ordinal value of the list item as defined by the [`<ol>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/ol "The HTML <ol> element represents an ordered list of items, typically rendered as a numbered list.") element. The only allowed value for this attribute is a number, even if the list is displayed with Roman numerals or letters. List items that follow this one continue numbering from the value set. The **value** attribute has no meaning for unordered lists ([`<ul>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/ul "The HTML <ul> element represents an unordered list of items, typically rendered as a bulleted list.")) or for menus ([`<menu>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/menu "The HTML <menu> element represents a group of commands that a user can perform or activate. This includes both list menus, which might appear across the top of a screen, as well as context menus, such as those that might appear underneath a button after it has been clicked.")).\n\n**Note**: This attribute was deprecated in HTML4, but reintroduced in HTML5.\n\n**Note:** Prior to Gecko\xA09.0, negative values were incorrectly converted to 0. Starting in Gecko\xA09.0 all integer values are correctly parsed.'
              }
            },
            {
              name: "type",
              description: 'This character attribute indicates the numbering type:\n\n*   `a`: lowercase letters\n*   `A`: uppercase letters\n*   `i`: lowercase Roman numerals\n*   `I`: uppercase Roman numerals\n*   `1`: numbers\n\nThis type overrides the one used by its parent [`<ol>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/ol "The HTML <ol> element represents an ordered list of items, typically rendered as a numbered list.") element, if any.\n\n**Usage note:** This attribute has been deprecated: use the CSS [`list-style-type`](https://developer.mozilla.org/en-US/docs/Web/CSS/list-style-type "The list-style-type CSS property sets the marker (such as a disc, character, or custom counter style) of a list item element.") property instead.'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/li"
            }
          ]
        },
        {
          name: "dl",
          description: {
            kind: "markdown",
            value: "The dl element represents an association list consisting of zero or more name-value groups (a description list). A name-value group consists of one or more names (dt elements) followed by one or more values (dd elements), ignoring any nodes other than dt and dd elements. Within a single dl element, there should not be more than one dt element for each name."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/dl"
            }
          ]
        },
        {
          name: "dt",
          description: {
            kind: "markdown",
            value: "The dt element represents the term, or name, part of a term-description group in a description list (dl element)."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/dt"
            }
          ]
        },
        {
          name: "dd",
          description: {
            kind: "markdown",
            value: "The dd element represents the description, definition, or value, part of a term-description group in a description list (dl element)."
          },
          attributes: [
            {
              name: "nowrap",
              description: "If the value of this attribute is set to `yes`, the definition text will not wrap. The default value is `no`."
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/dd"
            }
          ]
        },
        {
          name: "figure",
          description: {
            kind: "markdown",
            value: "The figure element represents some flow content, optionally with a caption, that is self-contained (like a complete sentence) and is typically referenced as a single unit from the main flow of the document."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/figure"
            }
          ]
        },
        {
          name: "figcaption",
          description: {
            kind: "markdown",
            value: "The figcaption element represents a caption or legend for the rest of the contents of the figcaption element's parent figure element, if any."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/figcaption"
            }
          ]
        },
        {
          name: "main",
          description: {
            kind: "markdown",
            value: "The main element represents the main content of the body of a document or application. The main content area consists of content that is directly related to or expands upon the central topic of a document or central functionality of an application."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/main"
            }
          ]
        },
        {
          name: "div",
          description: {
            kind: "markdown",
            value: "The div element has no special meaning at all. It represents its children. It can be used with the class, lang, and title attributes to mark up semantics common to a group of consecutive elements."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/div"
            }
          ]
        },
        {
          name: "a",
          description: {
            kind: "markdown",
            value: "If the a element has an href attribute, then it represents a hyperlink (a hypertext anchor) labeled by its contents."
          },
          attributes: [
            {
              name: "href",
              description: {
                kind: "markdown",
                value: 'Contains a URL or a URL fragment that the hyperlink points to.\nA URL fragment is a name preceded by a hash mark (`#`), which specifies an internal target location (an [`id`](https://developer.mozilla.org/en-US/docs/Web/HTML/Global_attributes#attr-id) of an HTML element) within the current document. URLs are not restricted to Web (HTTP)-based documents, but can use any protocol supported by the browser. For example, [`file:`](https://en.wikipedia.org/wiki/File_URI_scheme), `ftp:`, and `mailto:` work in most browsers.\n\n**Note:** You can use `href="#top"` or the empty fragment `href="#"` to link to the top of the current page. [This behavior is specified by HTML5](https://www.w3.org/TR/html5/single-page.html#scroll-to-fragid).'
              }
            },
            {
              name: "target",
              valueSet: "target",
              description: {
                kind: "markdown",
                value: 'Specifies where to display the linked URL. It is a name of, or keyword for, a _browsing context_: a tab, window, or `<iframe>`. The following keywords have special meanings:\n\n*   `_self`: Load the URL into the same browsing context as the current one. This is the default behavior.\n*   `_blank`: Load the URL into a new browsing context. This is usually a tab, but users can configure browsers to use new windows instead.\n*   `_parent`: Load the URL into the parent browsing context of the current one. If there is no parent, this behaves the same way as `_self`.\n*   `_top`: Load the URL into the top-level browsing context (that is, the "highest" browsing context that is an ancestor of the current one, and has no parent). If there is no parent, this behaves the same way as `_self`.\n\n**Note:** When using `target`, consider adding `rel="noreferrer"` to avoid exploitation of the `window.opener` API.\n\n**Note:** Linking to another page using `target="_blank"` will run the new page on the same process as your page. If the new page is executing expensive JS, your page\'s performance may suffer. To avoid this use `rel="noopener"`.'
              }
            },
            {
              name: "download",
              description: {
                kind: "markdown",
                value: "This attribute instructs browsers to download a URL instead of navigating to it, so the user will be prompted to save it as a local file. If the attribute has a value, it is used as the pre-filled file name in the Save prompt (the user can still change the file name if they want). There are no restrictions on allowed values, though `/` and `\\` are converted to underscores. Most file systems limit some punctuation in file names, and browsers will adjust the suggested name accordingly.\n\n**Notes:**\n\n*   This attribute only works for [same-origin URLs](https://developer.mozilla.org/en-US/docs/Web/Security/Same-origin_policy).\n*   Although HTTP(s) URLs need to be in the same-origin, [`blob:` URLs](https://developer.mozilla.org/en-US/docs/Web/API/URL.createObjectURL) and [`data:` URLs](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/Data_URIs) are allowed so that content generated by JavaScript, such as pictures created in an image-editor Web app, can be downloaded.\n*   If the HTTP header [`Content-Disposition:`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Content-Disposition) gives a different filename than this attribute, the HTTP header takes priority over this attribute.\n*   If `Content-Disposition:` is set to `inline`, Firefox prioritizes `Content-Disposition`, like the filename case, while Chrome prioritizes the `download` attribute."
              }
            },
            {
              name: "ping",
              description: {
                kind: "markdown",
                value: 'Contains a space-separated list of URLs to which, when the hyperlink is followed, [`POST`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Methods/POST "The HTTP POST method sends data to the server. The type of the body of the request is indicated by the Content-Type header.") requests with the body `PING` will be sent by the browser (in the background). Typically used for tracking.'
              }
            },
            {
              name: "rel",
              description: {
                kind: "markdown",
                value: "Specifies the relationship of the target object to the link object. The value is a space-separated list of [link types](https://developer.mozilla.org/en-US/docs/Web/HTML/Link_types)."
              }
            },
            {
              name: "hreflang",
              description: {
                kind: "markdown",
                value: 'This attribute indicates the human language of the linked resource. It is purely advisory, with no built-in functionality. Allowed values are determined by [BCP47](https://www.ietf.org/rfc/bcp/bcp47.txt "Tags for Identifying Languages").'
              }
            },
            {
              name: "type",
              description: {
                kind: "markdown",
                value: 'Specifies the media type in the form of a [MIME type](https://developer.mozilla.org/en-US/docs/Glossary/MIME_type "MIME type: A\xA0MIME type\xA0(now properly called "media type", but\xA0also sometimes "content type") is a string sent along\xA0with a file indicating the type of the file (describing the content format, for example, a sound file might be labeled\xA0audio/ogg, or an image file\xA0image/png).") for the linked URL. It is purely advisory, with no built-in functionality.'
              }
            },
            {
              name: "referrerpolicy",
              description: "Indicates which [referrer](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer) to send when fetching the URL:\n\n*   `'no-referrer'` means the `Referer:` header will not be sent.\n*   `'no-referrer-when-downgrade'` means no `Referer:` header will be sent when navigating to an origin without HTTPS. This is the default behavior.\n*   `'origin'` means the referrer will be the [origin](https://developer.mozilla.org/en-US/docs/Glossary/Origin) of the page, not including information after the domain.\n*   `'origin-when-cross-origin'` meaning that navigations to other origins will be limited to the scheme, the host and the port, while navigations on the same origin will include the referrer's path.\n*   `'strict-origin-when-cross-origin'`\n*   `'unsafe-url'` means the referrer will include the origin and path, but not the fragment, password, or username. This is unsafe because it can leak data from secure URLs to insecure ones."
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/a"
            }
          ]
        },
        {
          name: "em",
          description: {
            kind: "markdown",
            value: "The em element represents stress emphasis of its contents."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/em"
            }
          ]
        },
        {
          name: "strong",
          description: {
            kind: "markdown",
            value: "The strong element represents strong importance, seriousness, or urgency for its contents."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/strong"
            }
          ]
        },
        {
          name: "small",
          description: {
            kind: "markdown",
            value: "The small element represents side comments such as small print."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/small"
            }
          ]
        },
        {
          name: "s",
          description: {
            kind: "markdown",
            value: "The s element represents contents that are no longer accurate or no longer relevant."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/s"
            }
          ]
        },
        {
          name: "cite",
          description: {
            kind: "markdown",
            value: "The cite element represents a reference to a creative work. It must include the title of the work or the name of the author(person, people or organization) or an URL reference, or a reference in abbreviated form as per the conventions used for the addition of citation metadata."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/cite"
            }
          ]
        },
        {
          name: "q",
          description: {
            kind: "markdown",
            value: "The q element represents some phrasing content quoted from another source."
          },
          attributes: [
            {
              name: "cite",
              description: {
                kind: "markdown",
                value: "The value of this attribute is a URL that designates a source document or message for the information quoted. This attribute is intended to point to information explaining the context or the reference for the quote."
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/q"
            }
          ]
        },
        {
          name: "dfn",
          description: {
            kind: "markdown",
            value: "The dfn element represents the defining instance of a term. The paragraph, description list group, or section that is the nearest ancestor of the dfn element must also contain the definition(s) for the term given by the dfn element."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/dfn"
            }
          ]
        },
        {
          name: "abbr",
          description: {
            kind: "markdown",
            value: "The abbr element represents an abbreviation or acronym, optionally with its expansion. The title attribute may be used to provide an expansion of the abbreviation. The attribute, if specified, must contain an expansion of the abbreviation, and nothing else."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/abbr"
            }
          ]
        },
        {
          name: "ruby",
          description: {
            kind: "markdown",
            value: "The ruby element allows one or more spans of phrasing content to be marked with ruby annotations. Ruby annotations are short runs of text presented alongside base text, primarily used in East Asian typography as a guide for pronunciation or to include other annotations. In Japanese, this form of typography is also known as furigana. Ruby text can appear on either side, and sometimes both sides, of the base text, and it is possible to control its position using CSS. A more complete introduction to ruby can be found in the Use Cases & Exploratory Approaches for Ruby Markup document as well as in CSS Ruby Module Level 1. [RUBY-UC] [CSSRUBY]"
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/ruby"
            }
          ]
        },
        {
          name: "rb",
          description: {
            kind: "markdown",
            value: "The rb element marks the base text component of a ruby annotation. When it is the child of a ruby element, it doesn't represent anything itself, but its parent ruby element uses it as part of determining what it represents."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/rb"
            }
          ]
        },
        {
          name: "rt",
          description: {
            kind: "markdown",
            value: "The rt element marks the ruby text component of a ruby annotation. When it is the child of a ruby element or of an rtc element that is itself the child of a ruby element, it doesn't represent anything itself, but its ancestor ruby element uses it as part of determining what it represents."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/rt"
            }
          ]
        },
        {
          name: "rp",
          description: {
            kind: "markdown",
            value: "The rp element is used to provide fallback text to be shown by user agents that don't support ruby annotations. One widespread convention is to provide parentheses around the ruby text component of a ruby annotation."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/rp"
            }
          ]
        },
        {
          name: "time",
          description: {
            kind: "markdown",
            value: "The time element represents its contents, along with a machine-readable form of those contents in the datetime attribute. The kind of content is limited to various kinds of dates, times, time-zone offsets, and durations, as described below."
          },
          attributes: [
            {
              name: "datetime",
              description: {
                kind: "markdown",
                value: "This attribute indicates the time and/or date of the element and must be in one of the formats described below."
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/time"
            }
          ]
        },
        {
          name: "code",
          description: {
            kind: "markdown",
            value: "The code element represents a fragment of computer code. This could be an XML element name, a file name, a computer program, or any other string that a computer would recognize."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/code"
            }
          ]
        },
        {
          name: "var",
          description: {
            kind: "markdown",
            value: "The var element represents a variable. This could be an actual variable in a mathematical expression or programming context, an identifier representing a constant, a symbol identifying a physical quantity, a function parameter, or just be a term used as a placeholder in prose."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/var"
            }
          ]
        },
        {
          name: "samp",
          description: {
            kind: "markdown",
            value: "The samp element represents sample or quoted output from another program or computing system."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/samp"
            }
          ]
        },
        {
          name: "kbd",
          description: {
            kind: "markdown",
            value: "The kbd element represents user input (typically keyboard input, although it may also be used to represent other input, such as voice commands)."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/kbd"
            }
          ]
        },
        {
          name: "sub",
          description: {
            kind: "markdown",
            value: "The sub element represents a subscript."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/sub"
            }
          ]
        },
        {
          name: "sup",
          description: {
            kind: "markdown",
            value: "The sup element represents a superscript."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/sup"
            }
          ]
        },
        {
          name: "i",
          description: {
            kind: "markdown",
            value: "The i element represents a span of text in an alternate voice or mood, or otherwise offset from the normal prose in a manner indicating a different quality of text, such as a taxonomic designation, a technical term, an idiomatic phrase from another language, transliteration, a thought, or a ship name in Western texts."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/i"
            }
          ]
        },
        {
          name: "b",
          description: {
            kind: "markdown",
            value: "The b element represents a span of text to which attention is being drawn for utilitarian purposes without conveying any extra importance and with no implication of an alternate voice or mood, such as key words in a document abstract, product names in a review, actionable words in interactive text-driven software, or an article lede."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/b"
            }
          ]
        },
        {
          name: "u",
          description: {
            kind: "markdown",
            value: "The u element represents a span of text with an unarticulated, though explicitly rendered, non-textual annotation, such as labeling the text as being a proper name in Chinese text (a Chinese proper name mark), or labeling the text as being misspelt."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/u"
            }
          ]
        },
        {
          name: "mark",
          description: {
            kind: "markdown",
            value: "The mark element represents a run of text in one document marked or highlighted for reference purposes, due to its relevance in another context. When used in a quotation or other block of text referred to from the prose, it indicates a highlight that was not originally present but which has been added to bring the reader's attention to a part of the text that might not have been considered important by the original author when the block was originally written, but which is now under previously unexpected scrutiny. When used in the main prose of a document, it indicates a part of the document that has been highlighted due to its likely relevance to the user's current activity."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/mark"
            }
          ]
        },
        {
          name: "bdi",
          description: {
            kind: "markdown",
            value: "The bdi element represents a span of text that is to be isolated from its surroundings for the purposes of bidirectional text formatting. [BIDI]"
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/bdi"
            }
          ]
        },
        {
          name: "bdo",
          description: {
            kind: "markdown",
            value: "The bdo element represents explicit text directionality formatting control for its children. It allows authors to override the Unicode bidirectional algorithm by explicitly specifying a direction override. [BIDI]"
          },
          attributes: [
            {
              name: "dir",
              description: "The direction in which text should be rendered in this element's contents. Possible values are:\n\n*   `ltr`: Indicates that the text should go in a left-to-right direction.\n*   `rtl`: Indicates that the text should go in a right-to-left direction."
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/bdo"
            }
          ]
        },
        {
          name: "span",
          description: {
            kind: "markdown",
            value: "The span element doesn't mean anything on its own, but can be useful when used together with the global attributes, e.g. class, lang, or dir. It represents its children."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/span"
            }
          ]
        },
        {
          name: "br",
          description: {
            kind: "markdown",
            value: "The br element represents a line break."
          },
          void: !0,
          attributes: [
            {
              name: "clear",
              description: "Indicates where to begin the next line after the break."
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/br"
            }
          ]
        },
        {
          name: "wbr",
          description: {
            kind: "markdown",
            value: "The wbr element represents a line break opportunity."
          },
          void: !0,
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/wbr"
            }
          ]
        },
        {
          name: "ins",
          description: {
            kind: "markdown",
            value: "The ins element represents an addition to the document."
          },
          attributes: [
            {
              name: "cite",
              description: "This attribute defines the URI of a resource that explains the change, such as a link to meeting minutes or a ticket in a troubleshooting system."
            },
            {
              name: "datetime",
              description: 'This attribute indicates the time and date of the change and must be a valid date with an optional time string. If the value cannot be parsed as a date with an optional time string, the element does not have an associated time stamp. For the format of the string without a time, see [Format of a valid date string](https://developer.mozilla.org/en-US/docs/Web/HTML/Date_and_time_formats#Format_of_a_valid_date_string "Certain HTML elements use date and/or time values. The formats of the strings that specify these are described in this article.") in [Date and time formats used in HTML](https://developer.mozilla.org/en-US/docs/Web/HTML/Date_and_time_formats "Certain HTML elements use date and/or time values. The formats of the strings that specify these are described in this article."). The format of the string if it includes both date and time is covered in [Format of a valid local date and time string](https://developer.mozilla.org/en-US/docs/Web/HTML/Date_and_time_formats#Format_of_a_valid_local_date_and_time_string "Certain HTML elements use date and/or time values. The formats of the strings that specify these are described in this article.") in [Date and time formats used in HTML](https://developer.mozilla.org/en-US/docs/Web/HTML/Date_and_time_formats "Certain HTML elements use date and/or time values. The formats of the strings that specify these are described in this article.").'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/ins"
            }
          ]
        },
        {
          name: "del",
          description: {
            kind: "markdown",
            value: "The del element represents a removal from the document."
          },
          attributes: [
            {
              name: "cite",
              description: {
                kind: "markdown",
                value: "A URI for a resource that explains the change (for example, meeting minutes)."
              }
            },
            {
              name: "datetime",
              description: {
                kind: "markdown",
                value: 'This attribute indicates the time and date of the change and must be a valid date string with an optional time. If the value cannot be parsed as a date with an optional time string, the element does not have an associated time stamp. For the format of the string without a time, see [Format of a valid date string](https://developer.mozilla.org/en-US/docs/Web/HTML/Date_and_time_formats#Format_of_a_valid_date_string "Certain HTML elements use date and/or time values. The formats of the strings that specify these are described in this article.") in [Date and time formats used in HTML](https://developer.mozilla.org/en-US/docs/Web/HTML/Date_and_time_formats "Certain HTML elements use date and/or time values. The formats of the strings that specify these are described in this article."). The format of the string if it includes both date and time is covered in [Format of a valid local date and time string](https://developer.mozilla.org/en-US/docs/Web/HTML/Date_and_time_formats#Format_of_a_valid_local_date_and_time_string "Certain HTML elements use date and/or time values. The formats of the strings that specify these are described in this article.") in [Date and time formats used in HTML](https://developer.mozilla.org/en-US/docs/Web/HTML/Date_and_time_formats "Certain HTML elements use date and/or time values. The formats of the strings that specify these are described in this article.").'
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/del"
            }
          ]
        },
        {
          name: "picture",
          description: {
            kind: "markdown",
            value: "The picture element is a container which provides multiple sources to its contained img element to allow authors to declaratively control or give hints to the user agent about which image resource to use, based on the screen pixel density, viewport size, image format, and other factors. It represents its children."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/picture"
            }
          ]
        },
        {
          name: "img",
          description: {
            kind: "markdown",
            value: "An img element represents an image."
          },
          void: !0,
          attributes: [
            {
              name: "alt",
              description: {
                kind: "markdown",
                value: 'This attribute defines an alternative text description of the image.\n\n**Note:** Browsers do not always display the image referenced by the element. This is the case for non-graphical browsers (including those used by people with visual impairments), if the user chooses not to display images, or if the browser cannot display the image because it is invalid or an [unsupported type](#Supported_image_formats). In these cases, the browser may replace the image with the text defined in this element\'s `alt` attribute. You should, for these reasons and others, provide a useful value for `alt` whenever possible.\n\n**Note:** Omitting this attribute altogether indicates that the image is a key part of the content, and no textual equivalent is available. Setting this attribute to an empty string (`alt=""`) indicates that this image is _not_ a key part of the content (decorative), and that non-visual browsers may omit it from rendering.'
              }
            },
            {
              name: "src",
              description: {
                kind: "markdown",
                value: "The image URL. This attribute is mandatory for the `<img>` element. On browsers supporting `srcset`, `src` is treated like a candidate image with a pixel density descriptor `1x` unless an image with this pixel density descriptor is already defined in `srcset,` or unless `srcset` contains '`w`' descriptors."
              }
            },
            {
              name: "srcset",
              description: {
                kind: "markdown",
                value: "A list of one or more strings separated by commas indicating a set of possible image sources for the user agent to use. Each string is composed of:\n\n1.  a URL to an image,\n2.  optionally, whitespace followed by one of:\n    *   A width descriptor, or a positive integer directly followed by '`w`'. The width descriptor is divided by the source size given in the `sizes` attribute to calculate the effective pixel density.\n    *   A pixel density descriptor, which is a positive floating point number directly followed by '`x`'.\n\nIf no descriptor is specified, the source is assigned the default descriptor: `1x`.\n\nIt is incorrect to mix width descriptors and pixel density descriptors in the same `srcset` attribute. Duplicate descriptors (for instance, two sources in the same `srcset` which are both described with '`2x`') are also invalid.\n\nThe user agent selects any one of the available sources at its discretion. This provides them with significant leeway to tailor their selection based on things like user preferences or bandwidth conditions. See our [Responsive images](https://developer.mozilla.org/en-US/docs/Learn/HTML/Multimedia_and_embedding/Responsive_images) tutorial for an example."
              }
            },
            {
              name: "crossorigin",
              valueSet: "xo",
              description: {
                kind: "markdown",
                value: 'This enumerated attribute indicates if the fetching of the related image must be done using CORS or not. [CORS-enabled images](https://developer.mozilla.org/en-US/docs/CORS_Enabled_Image) can be reused in the [`<canvas>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/canvas "Use the HTML <canvas> element with either the canvas scripting API or the WebGL API to draw graphics and animations.") element without being "[tainted](https://developer.mozilla.org/en-US/docs/Web/HTML/CORS_enabled_image#What_is_a_tainted_canvas)." The allowed values are:\n`anonymous`\n\nA cross-origin request (i.e., with `Origin:` HTTP header) is performed, but no credential is sent (i.e., no cookie, X.509 certificate, or HTTP Basic authentication). If the server does not give credentials to the origin site (by not setting the [`Access-Control-Allow-Origin`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Access-Control-Allow-Origin "The Access-Control-Allow-Origin response header indicates whether the response can be shared with requesting code from the given origin.") HTTP header), the image will be tainted and its usage restricted.\n\n`use-credentials`\n\nA cross-origin request (i.e., with the [`Origin`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Origin "The Origin request header indicates where a fetch originates from. It doesn\'t include any path information, but only the server name. It is sent with CORS requests, as well as with POST requests. It is similar to the Referer header, but, unlike this header, it doesn\'t disclose the whole path.") HTTP header) performed along with credentials sent (i.e., a cookie, certificate, or HTTP Basic authentication). If the server does not give credentials to the origin site (through the `Access-Control-Allow-Credentials` HTTP header), the image will be tainted and its usage restricted.\n\nIf the attribute is not present, the resource is fetched without a CORS request (i.e., without sending the `Origin` HTTP header), preventing its non-tainted usage in [`<canvas>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/canvas "Use the HTML <canvas> element with either the canvas scripting API or the WebGL API to draw graphics and animations.") elements. If invalid, it is handled as if the `anonymous` value was used. See [CORS settings attributes](https://developer.mozilla.org/en-US/docs/HTML/CORS_settings_attributes) for additional information.'
              }
            },
            {
              name: "usemap",
              description: {
                kind: "markdown",
                value: 'The partial URL (starting with \'#\') of an [image map](https://developer.mozilla.org/en-US/docs/HTML/Element/map) associated with the element.\n\n**Note:** You cannot use this attribute if the `<img>` element is a descendant of an [`<a>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/a "The HTML <a> element (or anchor element) creates a hyperlink to other web pages, files, locations within the same page, email addresses, or any other URL.") or [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button "The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.") element.'
              }
            },
            {
              name: "ismap",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: 'This Boolean attribute indicates that the image is part of a server-side map. If so, the precise coordinates of a click are sent to the server.\n\n**Note:** This attribute is allowed only if the `<img>` element is a descendant of an [`<a>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/a "The HTML <a> element (or anchor element) creates a hyperlink to other web pages, files, locations within the same page, email addresses, or any other URL.") element with a valid [`href`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/a#attr-href) attribute.'
              }
            },
            {
              name: "width",
              description: {
                kind: "markdown",
                value: "The intrinsic width of the image in pixels."
              }
            },
            {
              name: "height",
              description: {
                kind: "markdown",
                value: "The intrinsic height of the image in pixels."
              }
            },
            {
              name: "decoding",
              valueSet: "decoding",
              description: {
                kind: "markdown",
                value: `Provides an image decoding hint to the browser. The allowed values are:
\`sync\`

Decode the image synchronously for atomic presentation with other content.

\`async\`

Decode the image asynchronously to reduce delay in presenting other content.

\`auto\`

Default mode, which indicates no preference for the decoding mode. The browser decides what is best for the user.`
              }
            },
            {
              name: "loading",
              valueSet: "loading",
              description: {
                kind: "markdown",
                value: "Indicates how the browser should load the image."
              }
            },
            {
              name: "referrerpolicy",
              valueSet: "referrerpolicy",
              description: {
                kind: "markdown",
                value: "A string indicating which referrer to use when fetching the resource:\n\n*   `no-referrer:` The [`Referer`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer \"The Referer request header contains the address of the previous web page from which a link to the currently requested page was followed. The Referer header allows servers to identify where people are visiting them from and may use that data for analytics, logging, or optimized caching, for example.\") header will not be sent.\n*   `no-referrer-when-downgrade:` No `Referer` header will be sent when navigating to an origin without TLS (HTTPS). This is a user agent\u2019s default behavior if no policy is otherwise specified.\n*   `origin:` The `Referer` header will include the page of origin's scheme, the host, and the port.\n*   `origin-when-cross-origin:` Navigating to other origins will limit the included referral data to the scheme, the host and the port, while navigating from the same origin will include the referrer's full path.\n*   `unsafe-url:` The `Referer` header will include the origin and the path, but not the fragment, password, or username. This case is unsafe because it can leak origins and paths from TLS-protected resources to insecure origins."
              }
            },
            {
              name: "sizes",
              description: {
                kind: "markdown",
                value: "A list of one or more strings separated by commas indicating a set of source sizes. Each source size consists of:\n\n1.  a media condition. This must be omitted for the last item.\n2.  a source size value.\n\nSource size values specify the intended display size of the image. User agents use the current source size to select one of the sources supplied by the `srcset` attribute, when those sources are described using width ('`w`') descriptors. The selected source size affects the intrinsic size of the image (the image\u2019s display size if no CSS styling is applied). If the `srcset` attribute is absent, or contains no values with a width (`w`) descriptor, then the `sizes` attribute has no effect."
              }
            },
            {
              name: "importance",
              description: "Indicates the relative importance of the resource. Priority hints are delegated using the values:"
            },
            {
              name: "importance",
              description: "`auto`: Indicates\xA0**no\xA0preference**. The browser may use its own heuristics to decide the priority of the image.\n\n`high`: Indicates to the\xA0browser\xA0that the image is of\xA0**high** priority.\n\n`low`:\xA0Indicates to the\xA0browser\xA0that the image is of\xA0**low** priority."
            },
            {
              name: "intrinsicsize",
              description: "This attribute tells the browser to ignore the actual intrinsic size of the image and pretend it\u2019s the size specified in the attribute. Specifically, the image would raster at these dimensions and `naturalWidth`/`naturalHeight` on images would return the values specified in this attribute. [Explainer](https://github.com/ojanvafai/intrinsicsize-attribute), [examples](https://googlechrome.github.io/samples/intrinsic-size/index.html)"
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/img"
            }
          ]
        },
        {
          name: "iframe",
          description: {
            kind: "markdown",
            value: "The iframe element represents a nested browsing context."
          },
          attributes: [
            {
              name: "src",
              description: {
                kind: "markdown",
                value: 'The URL of the page to embed. Use a value of `about:blank` to embed an empty page that conforms to the [same-origin policy](https://developer.mozilla.org/en-US/docs/Web/Security/Same-origin_policy#Inherited_origins). Also note that programatically removing an `<iframe>`\'s src attribute (e.g. via [`Element.removeAttribute()`](https://developer.mozilla.org/en-US/docs/Web/API/Element/removeAttribute "The Element method removeAttribute() removes the attribute with the specified name from the element.")) causes `about:blank` to be loaded in the frame in Firefox (from version 65), Chromium-based browsers, and Safari/iOS.'
              }
            },
            {
              name: "srcdoc",
              description: {
                kind: "markdown",
                value: "Inline HTML to embed, overriding the `src` attribute. If a browser does not support the `srcdoc` attribute, it will fall back to the URL in the `src` attribute."
              }
            },
            {
              name: "name",
              description: {
                kind: "markdown",
                value: 'A targetable name for the embedded browsing context. This can be used in the `target` attribute of the [`<a>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/a "The HTML <a> element (or anchor element) creates a hyperlink to other web pages, files, locations within the same page, email addresses, or any other URL."), [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form "The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server."), or [`<base>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/base "The HTML <base> element specifies the base URL to use for all relative URLs contained within a document. There can be only one <base> element in a document.") elements; the `formtarget` attribute of the [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input "The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.") or [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button "The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.") elements; or the `windowName` parameter in the [`window.open()`](https://developer.mozilla.org/en-US/docs/Web/API/Window/open "The\xA0Window interface\'s open() method loads the specified resource into the browsing context (window, <iframe> or tab) with the specified name. If the name doesn\'t exist, then a new window is opened and the specified resource is loaded into its browsing context.") method.'
              }
            },
            {
              name: "sandbox",
              valueSet: "sb",
              description: {
                kind: "markdown",
                value: 'Applies extra restrictions to the content in the frame. The value of the attribute can either be empty to apply all restrictions, or space-separated tokens to lift particular restrictions:\n\n*   `allow-forms`: Allows the resource to submit forms. If this keyword is not used, form submission is blocked.\n*   `allow-modals`: Lets the resource [open modal windows](https://html.spec.whatwg.org/multipage/origin.html#sandboxed-modals-flag).\n*   `allow-orientation-lock`: Lets the resource [lock the screen orientation](https://developer.mozilla.org/en-US/docs/Web/API/Screen/lockOrientation).\n*   `allow-pointer-lock`: Lets the resource use the [Pointer Lock API](https://developer.mozilla.org/en-US/docs/WebAPI/Pointer_Lock).\n*   `allow-popups`: Allows popups (such as `window.open()`, `target="_blank"`, or `showModalDialog()`). If this keyword is not used, the popup will silently fail to open.\n*   `allow-popups-to-escape-sandbox`: Lets the sandboxed document open new windows without those windows inheriting the sandboxing. For example, this can safely sandbox an advertisement without forcing the same restrictions upon the page the ad links to.\n*   `allow-presentation`: Lets the resource start a [presentation session](https://developer.mozilla.org/en-US/docs/Web/API/PresentationRequest).\n*   `allow-same-origin`: If this token is not used, the resource is treated as being from a special origin that always fails the [same-origin policy](https://developer.mozilla.org/en-US/docs/Glossary/same-origin_policy "same-origin policy: The same-origin policy is a critical security mechanism that restricts how a document or script loaded from one origin can interact with a resource from another origin.").\n*   `allow-scripts`: Lets the resource run scripts (but not create popup windows).\n*   `allow-storage-access-by-user-activation` : Lets the resource request access to the parent\'s storage capabilities with the [Storage Access API](https://developer.mozilla.org/en-US/docs/Web/API/Storage_Access_API).\n*   `allow-top-navigation`: Lets the resource navigate the top-level browsing context (the one named `_top`).\n*   `allow-top-navigation-by-user-activation`: Lets the resource navigate the top-level browsing context, but only if initiated by a user gesture.\n\n**Notes about sandboxing:**\n\n*   When the embedded document has the same origin as the embedding page, it is **strongly discouraged** to use both `allow-scripts` and `allow-same-origin`, as that lets the embedded document remove the `sandbox` attribute \u2014 making it no more secure than not using the `sandbox` attribute at all.\n*   Sandboxing is useless if the attacker can display content outside a sandboxed `iframe` \u2014 such as if the viewer opens the frame in a new tab. Such content should be also served from a _separate origin_ to limit potential damage.\n*   The `sandbox` attribute is unsupported in Internet Explorer 9 and earlier.'
              }
            },
            {
              name: "seamless",
              valueSet: "v"
            },
            {
              name: "allowfullscreen",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: 'Set to `true` if the `<iframe>` can activate fullscreen mode by calling the [`requestFullscreen()`](https://developer.mozilla.org/en-US/docs/Web/API/Element/requestFullscreen "The Element.requestFullscreen() method issues an asynchronous request to make the element be displayed in full-screen mode.") method.\nThis attribute is considered a legacy attribute and redefined as `allow="fullscreen"`.'
              }
            },
            {
              name: "width",
              description: {
                kind: "markdown",
                value: "The width of the frame in CSS pixels. Default is `300`."
              }
            },
            {
              name: "height",
              description: {
                kind: "markdown",
                value: "The height of the frame in CSS pixels. Default is `150`."
              }
            },
            {
              name: "allow",
              description: "Specifies a [feature policy](https://developer.mozilla.org/en-US/docs/Web/HTTP/Feature_Policy) for the `<iframe>`."
            },
            {
              name: "allowpaymentrequest",
              description: "Set to `true` if a cross-origin `<iframe>` should be allowed to invoke the [Payment Request API](https://developer.mozilla.org/en-US/docs/Web/API/Payment_Request_API)."
            },
            {
              name: "allowpaymentrequest",
              description: 'This attribute is considered a legacy attribute and redefined as `allow="payment"`.'
            },
            {
              name: "csp",
              description: 'A [Content Security Policy](https://developer.mozilla.org/en-US/docs/Web/HTTP/CSP) enforced for the embedded resource. See [`HTMLIFrameElement.csp`](https://developer.mozilla.org/en-US/docs/Web/API/HTMLIFrameElement/csp "The csp property of the HTMLIFrameElement interface specifies the Content Security Policy that an embedded document must agree to enforce upon itself.") for details.'
            },
            {
              name: "importance",
              description: `The download priority of the resource in the \`<iframe>\`'s \`src\` attribute. Allowed values:

\`auto\` (default)

No preference. The browser uses its own heuristics to decide the priority of the resource.

\`high\`

The resource should be downloaded before other lower-priority page resources.

\`low\`

The resource should be downloaded after other higher-priority page resources.`
            },
            {
              name: "referrerpolicy",
              description: 'Indicates which [referrer](https://developer.mozilla.org/en-US/docs/Web/API/Document/referrer) to send when fetching the frame\'s resource:\n\n*   `no-referrer`: The [`Referer`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer "The Referer request header contains the address of the previous web page from which a link to the currently requested page was followed. The Referer header allows servers to identify where people are visiting them from and may use that data for analytics, logging, or optimized caching, for example.") header will not be sent.\n*   `no-referrer-when-downgrade` (default): The [`Referer`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer "The Referer request header contains the address of the previous web page from which a link to the currently requested page was followed. The Referer header allows servers to identify where people are visiting them from and may use that data for analytics, logging, or optimized caching, for example.") header will not be sent to [origin](https://developer.mozilla.org/en-US/docs/Glossary/origin "origin: Web content\'s origin is defined by the scheme (protocol), host (domain), and port of the URL used to access it. Two objects have the same origin only when the scheme, host, and port all match.")s without [TLS](https://developer.mozilla.org/en-US/docs/Glossary/TLS "TLS: Transport Layer Security (TLS), previously known as Secure Sockets Layer (SSL), is a protocol used by applications to communicate securely across a network, preventing tampering with and eavesdropping on email, web browsing, messaging, and other protocols.") ([HTTPS](https://developer.mozilla.org/en-US/docs/Glossary/HTTPS "HTTPS: HTTPS (HTTP Secure) is an encrypted version of the HTTP protocol. It usually uses SSL or TLS to encrypt all communication between a client and a server. This secure connection allows clients to safely exchange sensitive data with a server, for example for banking activities or online shopping.")).\n*   `origin`: The sent referrer will be limited to the origin of the referring page: its [scheme](https://developer.mozilla.org/en-US/docs/Archive/Mozilla/URIScheme), [host](https://developer.mozilla.org/en-US/docs/Glossary/host "host: A host is a device connected to the Internet (or a local network). Some hosts called servers offer additional services like serving webpages or storing files and emails."), and [port](https://developer.mozilla.org/en-US/docs/Glossary/port "port: For a computer connected to a network with an IP address, a port is a communication endpoint. Ports are designated by numbers, and below 1024 each port is associated by default with a specific protocol.").\n*   `origin-when-cross-origin`: The referrer sent to other origins will be limited to the scheme, the host, and the port. Navigations on the same origin will still include the path.\n*   `same-origin`: A referrer will be sent for [same origin](https://developer.mozilla.org/en-US/docs/Glossary/Same-origin_policy "same origin: The same-origin policy is a critical security mechanism that restricts how a document or script loaded from one origin can interact with a resource from another origin."), but cross-origin requests will contain no referrer information.\n*   `strict-origin`: Only send the origin of the document as the referrer when the protocol security level stays the same (HTTPS\u2192HTTPS), but don\'t send it to a less secure destination (HTTPS\u2192HTTP).\n*   `strict-origin-when-cross-origin`: Send a full URL when performing a same-origin request, only send the origin when the protocol security level stays the same (HTTPS\u2192HTTPS), and send no header to a less secure destination (HTTPS\u2192HTTP).\n*   `unsafe-url`: The referrer will include the origin _and_ the path (but not the [fragment](https://developer.mozilla.org/en-US/docs/Web/API/HTMLHyperlinkElementUtils/hash), [password](https://developer.mozilla.org/en-US/docs/Web/API/HTMLHyperlinkElementUtils/password), or [username](https://developer.mozilla.org/en-US/docs/Web/API/HTMLHyperlinkElementUtils/username)). **This value is unsafe**, because it leaks origins and paths from TLS-protected resources to insecure origins.'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/iframe"
            }
          ]
        },
        {
          name: "embed",
          description: {
            kind: "markdown",
            value: "The embed element provides an integration point for an external (typically non-HTML) application or interactive content."
          },
          void: !0,
          attributes: [
            {
              name: "src",
              description: {
                kind: "markdown",
                value: "The URL\xA0of the resource being embedded."
              }
            },
            {
              name: "type",
              description: {
                kind: "markdown",
                value: "The MIME\xA0type to use to select the plug-in to instantiate."
              }
            },
            {
              name: "width",
              description: {
                kind: "markdown",
                value: "The displayed width of the resource, in [CSS pixels](https://drafts.csswg.org/css-values/#px). This must be an absolute value; percentages are _not_ allowed."
              }
            },
            {
              name: "height",
              description: {
                kind: "markdown",
                value: "The displayed height of the resource, in [CSS pixels](https://drafts.csswg.org/css-values/#px). This must be an absolute value; percentages are _not_ allowed."
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/embed"
            }
          ]
        },
        {
          name: "object",
          description: {
            kind: "markdown",
            value: "The object element can represent an external resource, which, depending on the type of the resource, will either be treated as an image, as a nested browsing context, or as an external resource to be processed by a plugin."
          },
          attributes: [
            {
              name: "data",
              description: {
                kind: "markdown",
                value: "The address of the resource as a valid URL. At least one of **data** and **type** must be defined."
              }
            },
            {
              name: "type",
              description: {
                kind: "markdown",
                value: "The [content type](https://developer.mozilla.org/en-US/docs/Glossary/Content_type) of the resource specified by **data**. At least one of **data** and **type** must be defined."
              }
            },
            {
              name: "typemustmatch",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "This Boolean attribute indicates if the **type** attribute and the actual [content type](https://developer.mozilla.org/en-US/docs/Glossary/Content_type) of the resource must match to be used."
              }
            },
            {
              name: "name",
              description: {
                kind: "markdown",
                value: "The name of valid browsing context (HTML5), or the name of the control (HTML 4)."
              }
            },
            {
              name: "usemap",
              description: {
                kind: "markdown",
                value: "A hash-name reference to a [`<map>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/map \"The HTML <map> element is used with <area> elements to define an image map (a clickable link area).\") element; that is a '#' followed by the value of a [`name`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/map#attr-name) of a map element."
              }
            },
            {
              name: "form",
              description: {
                kind: "markdown",
                value: 'The form element, if any, that the object element is associated with (its _form owner_). The value of the attribute must be an ID of a [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form "The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.") element in the same document.'
              }
            },
            {
              name: "width",
              description: {
                kind: "markdown",
                value: "The width of the display resource, in [CSS pixels](https://drafts.csswg.org/css-values/#px). -- (Absolute values only. [NO percentages](https://html.spec.whatwg.org/multipage/embedded-content.html#dimension-attributes))"
              }
            },
            {
              name: "height",
              description: {
                kind: "markdown",
                value: "The height of the displayed resource, in [CSS pixels](https://drafts.csswg.org/css-values/#px). -- (Absolute values only. [NO percentages](https://html.spec.whatwg.org/multipage/embedded-content.html#dimension-attributes))"
              }
            },
            {
              name: "archive",
              description: "A space-separated list of URIs for archives of resources for the object."
            },
            {
              name: "border",
              description: "The width of a border around the control, in pixels."
            },
            {
              name: "classid",
              description: "The URI of the object's implementation. It can be used together with, or in place of, the **data** attribute."
            },
            {
              name: "codebase",
              description: "The base path used to resolve relative URIs specified by **classid**, **data**, or **archive**. If not specified, the default is the base URI of the current document."
            },
            {
              name: "codetype",
              description: "The content type of the data specified by **classid**."
            },
            {
              name: "declare",
              description: "The presence of this Boolean attribute makes this element a declaration only. The object must be instantiated by a subsequent `<object>` element. In HTML5, repeat the <object> element completely each that that the resource is reused."
            },
            {
              name: "standby",
              description: "A message that the browser can show while loading the object's implementation and data."
            },
            {
              name: "tabindex",
              description: "The position of the element in the tabbing navigation order for the current document."
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/object"
            }
          ]
        },
        {
          name: "param",
          description: {
            kind: "markdown",
            value: "The param element defines parameters for plugins invoked by object elements. It does not represent anything on its own."
          },
          void: !0,
          attributes: [
            {
              name: "name",
              description: {
                kind: "markdown",
                value: "Name of the parameter."
              }
            },
            {
              name: "value",
              description: {
                kind: "markdown",
                value: "Specifies the value of the parameter."
              }
            },
            {
              name: "type",
              description: 'Only used if the `valuetype` is set to "ref". Specifies the MIME type of values found at the URI specified by value.'
            },
            {
              name: "valuetype",
              description: `Specifies the type of the \`value\` attribute. Possible values are:

*   data: Default value. The value is passed to the object's implementation as a string.
*   ref: The value is a URI to a resource where run-time values are stored.
*   object: An ID of another [\`<object>\`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/object "The HTML <object> element represents an external resource, which can be treated as an image, a nested browsing context, or a resource to be handled by a plugin.") in the same document.`
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/param"
            }
          ]
        },
        {
          name: "video",
          description: {
            kind: "markdown",
            value: "A video element is used for playing videos or movies, and audio files with captions."
          },
          attributes: [
            {
              name: "src"
            },
            {
              name: "crossorigin",
              valueSet: "xo"
            },
            {
              name: "poster"
            },
            {
              name: "preload",
              valueSet: "pl"
            },
            {
              name: "autoplay",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: 'A Boolean attribute; if specified, the video automatically begins to play back as soon as it can do so without stopping to finish loading the data.\n**Note**: Sites that automatically play audio (or video with an audio track) can be an unpleasant experience for users, so it should be avoided when possible. If you must offer autoplay functionality, you should make it opt-in (requiring a user to specifically enable it). However, this can be useful when creating media elements whose source will be set at a later time, under user control.\n\nTo disable video autoplay, `autoplay="false"` will not work; the video will autoplay if the attribute is there in the `<video>` tag at all. To remove autoplay the attribute needs to be removed altogether.\n\nIn some browsers (e.g. Chrome 70.0) autoplay is not working if no `muted` attribute is present.'
              }
            },
            {
              name: "mediagroup"
            },
            {
              name: "loop",
              valueSet: "v"
            },
            {
              name: "muted",
              valueSet: "v"
            },
            {
              name: "controls",
              valueSet: "v"
            },
            {
              name: "width"
            },
            {
              name: "height"
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/video"
            }
          ]
        },
        {
          name: "audio",
          description: {
            kind: "markdown",
            value: "An audio element represents a sound or audio stream."
          },
          attributes: [
            {
              name: "src",
              description: {
                kind: "markdown",
                value: 'The URL of the audio to embed. This is subject to [HTTP access controls](https://developer.mozilla.org/en-US/docs/HTTP_access_control). This is optional; you may instead use the [`<source>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/source "The HTML <source> element specifies multiple media resources for the <picture>, the <audio> element, or the <video> element.") element within the audio block to specify the audio to embed.'
              }
            },
            {
              name: "crossorigin",
              valueSet: "xo",
              description: {
                kind: "markdown",
                value: 'This enumerated attribute indicates whether to use CORS to fetch the related image. [CORS-enabled resources](https://developer.mozilla.org/en-US/docs/CORS_Enabled_Image) can be reused in the [`<canvas>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/canvas "Use the HTML <canvas> element with either the canvas scripting API or the WebGL API to draw graphics and animations.") element without being _tainted_. The allowed values are:\n\nanonymous\n\nSends a cross-origin request without a credential. In other words, it sends the `Origin:` HTTP header without a cookie, X.509 certificate, or performing HTTP Basic authentication. If the server does not give credentials to the origin site (by not setting the `Access-Control-Allow-Origin:` HTTP header), the image will be _tainted_, and its usage restricted.\n\nuse-credentials\n\nSends a cross-origin request with a credential. In other words, it sends the `Origin:` HTTP header with a cookie, a certificate, or performing HTTP Basic authentication. If the server does not give credentials to the origin site (through `Access-Control-Allow-Credentials:` HTTP header), the image will be _tainted_ and its usage restricted.\n\nWhen not present, the resource is fetched without a CORS request (i.e. without sending the `Origin:` HTTP header), preventing its non-tainted used in [`<canvas>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/canvas "Use the HTML <canvas> element with either the canvas scripting API or the WebGL API to draw graphics and animations.") elements. If invalid, it is handled as if the enumerated keyword **anonymous** was used. See [CORS settings attributes](https://developer.mozilla.org/en-US/docs/HTML/CORS_settings_attributes) for additional information.'
              }
            },
            {
              name: "preload",
              valueSet: "pl",
              description: {
                kind: "markdown",
                value: "This enumerated attribute is intended to provide a hint to the browser about what the author thinks will lead to the best user experience. It may have one of the following values:\n\n*   `none`: Indicates that the audio should not be preloaded.\n*   `metadata`: Indicates that only audio metadata (e.g. length) is fetched.\n*   `auto`: Indicates that the whole audio file can be downloaded, even if the user is not expected to use it.\n*   _empty string_: A synonym of the `auto` value.\n\nIf not set, `preload`'s default value is browser-defined (i.e. each browser may have its own default value). The spec advises it to be set to `metadata`.\n\n**Usage notes:**\n\n*   The `autoplay` attribute has precedence over\xA0`preload`. If `autoplay` is specified, the browser would obviously need to start downloading the audio for playback.\n*   The browser is not forced by the specification to follow the value of this attribute; it is a mere hint."
              }
            },
            {
              name: "autoplay",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: `A Boolean attribute:\xA0if specified, the audio will automatically begin playback as soon as it can do so, without waiting for the entire audio file to finish downloading.

**Note**: Sites that automatically play audio (or videos with an audio track) can be an unpleasant experience for users, so should be avoided when possible. If you must offer autoplay functionality, you should make it opt-in (requiring a user to specifically enable it). However, this can be useful when creating media elements whose source will be set at a later time, under user control.`
              }
            },
            {
              name: "mediagroup"
            },
            {
              name: "loop",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "A Boolean attribute:\xA0if specified, the audio player will\xA0automatically seek back to the start\xA0upon reaching the end of the audio."
              }
            },
            {
              name: "muted",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "A Boolean attribute that indicates whether the audio will be initially silenced. Its default value is `false`."
              }
            },
            {
              name: "controls",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "If this attribute is present, the browser will offer controls to allow the user to control audio playback, including volume, seeking, and pause/resume playback."
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/audio"
            }
          ]
        },
        {
          name: "source",
          description: {
            kind: "markdown",
            value: "The source element allows authors to specify multiple alternative media resources for media elements. It does not represent anything on its own."
          },
          void: !0,
          attributes: [
            {
              name: "src",
              description: {
                kind: "markdown",
                value: 'Required for [`<audio>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/audio "The HTML <audio> element is used to embed sound content in documents. It may contain one or more audio sources, represented using the src attribute or the <source> element:\xA0the browser will choose the most suitable one. It can also be the destination for streamed media, using a MediaStream.") and [`<video>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/video "The HTML Video element (<video>) embeds a media player which supports video playback into the document."), address of the media resource. The value of this attribute is ignored when the `<source>` element is placed inside a [`<picture>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/picture "The HTML <picture> element contains zero or more <source> elements and one <img> element to provide versions of an image for different display/device scenarios.") element.'
              }
            },
            {
              name: "type",
              description: {
                kind: "markdown",
                value: "The MIME-type of the resource, optionally with a `codecs` parameter. See [RFC 4281](https://tools.ietf.org/html/rfc4281) for information about how to specify codecs."
              }
            },
            {
              name: "sizes",
              description: 'Is a list of source sizes that describes the final rendered width of the image represented by the source. Each source size consists of a comma-separated list of media condition-length pairs. This information is used by the browser to determine, before laying the page out, which image defined in [`srcset`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/source#attr-srcset) to use.  \nThe `sizes` attribute has an effect only when the [`<source>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/source "The HTML <source> element specifies multiple media resources for the <picture>, the <audio> element, or the <video> element.") element is the direct child of a [`<picture>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/picture "The HTML <picture> element contains zero or more <source> elements and one <img> element to provide versions of an image for different display/device scenarios.") element.'
            },
            {
              name: "srcset",
              description: "A list of one or more strings separated by commas indicating a set of possible images represented by the source for the browser to use. Each string is composed of:\n\n1.  one URL to an image,\n2.  a width descriptor, that is a positive integer directly followed by `'w'`. The default value, if missing, is the infinity.\n3.  a pixel density descriptor, that is a positive floating number directly followed by `'x'`. The default value, if missing, is `1x`.\n\nEach string in the list must have at least a width descriptor or a pixel density descriptor to be valid. Among the list, there must be only one string containing the same tuple of width descriptor and pixel density descriptor.  \nThe browser chooses the most adequate image to display at a given point of time.  \nThe `srcset` attribute has an effect only when the [`<source>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/source \"The HTML <source> element specifies multiple media resources for the <picture>, the <audio> element, or the <video> element.\") element is the direct child of a [`<picture>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/picture \"The HTML <picture> element contains zero or more <source> elements and one <img> element to provide versions of an image for different display/device scenarios.\") element."
            },
            {
              name: "media",
              description: '[Media query](https://developer.mozilla.org/en-US/docs/CSS/Media_queries) of the resource\'s intended media; this should be used only in a [`<picture>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/picture "The HTML <picture> element contains zero or more <source> elements and one <img> element to provide versions of an image for different display/device scenarios.") element.'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/source"
            }
          ]
        },
        {
          name: "track",
          description: {
            kind: "markdown",
            value: "The track element allows authors to specify explicit external timed text tracks for media elements. It does not represent anything on its own."
          },
          void: !0,
          attributes: [
            {
              name: "default",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "This attribute indicates that the track should be enabled unless the user's preferences indicate that another track is more appropriate. This may only be used on one `track` element per media element."
              }
            },
            {
              name: "kind",
              valueSet: "tk",
              description: {
                kind: "markdown",
                value: "How the text track is meant to be used. If omitted the default kind is `subtitles`. If the attribute is not present, it will use the `subtitles`. If the attribute contains an invalid value, it will use `metadata`. (Versions of Chrome earlier than 52 treated an invalid value as `subtitles`.)\xA0The following keywords are allowed:\n\n*   `subtitles`\n    *   Subtitles provide translation of content that cannot be understood by the viewer. For example dialogue or text that is not English in an English language film.\n    *   Subtitles may contain additional content, usually extra background information. For example the text at the beginning of the Star Wars films, or the date, time, and location of a scene.\n*   `captions`\n    *   Closed captions provide a transcription and possibly a translation of audio.\n    *   It may include important non-verbal information such as music cues or sound effects. It may indicate the cue's source (e.g. music, text, character).\n    *   Suitable for users who are deaf or when the sound is muted.\n*   `descriptions`\n    *   Textual description of the video content.\n    *   Suitable for users who are blind or where the video cannot be seen.\n*   `chapters`\n    *   Chapter titles are intended to be used when the user is navigating the media resource.\n*   `metadata`\n    *   Tracks used by scripts. Not visible to the user."
              }
            },
            {
              name: "label",
              description: {
                kind: "markdown",
                value: "A user-readable title of the text track which is used by the browser when listing available text tracks."
              }
            },
            {
              name: "src",
              description: {
                kind: "markdown",
                value: 'Address of the track (`.vtt` file). Must be a valid URL. This attribute must be specified and its URL value must have the same origin as the document \u2014 unless the [`<audio>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/audio "The HTML <audio> element is used to embed sound content in documents. It may contain one or more audio sources, represented using the src attribute or the <source> element:\xA0the browser will choose the most suitable one. It can also be the destination for streamed media, using a MediaStream.") or [`<video>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/video "The HTML Video element (<video>) embeds a media player which supports video playback into the document.") parent element of the `track` element has a [`crossorigin`](https://developer.mozilla.org/en-US/docs/Web/HTML/CORS_settings_attributes) attribute.'
              }
            },
            {
              name: "srclang",
              description: {
                kind: "markdown",
                value: "Language of the track text data. It must be a valid [BCP 47](https://r12a.github.io/app-subtags/) language tag. If the `kind` attribute is set to\xA0`subtitles,` then `srclang` must be defined."
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/track"
            }
          ]
        },
        {
          name: "map",
          description: {
            kind: "markdown",
            value: "The map element, in conjunction with an img element and any area element descendants, defines an image map. The element represents its children."
          },
          attributes: [
            {
              name: "name",
              description: {
                kind: "markdown",
                value: "The name attribute gives the map a name so that it can be referenced. The attribute must be present and must have a non-empty value with no space characters. The value of the name attribute must not be a compatibility-caseless match for the value of the name attribute of another map element in the same document. If the id attribute is also specified, both attributes must have the same value."
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/map"
            }
          ]
        },
        {
          name: "area",
          description: {
            kind: "markdown",
            value: "The area element represents either a hyperlink with some text and a corresponding area on an image map, or a dead area on an image map."
          },
          void: !0,
          attributes: [
            {
              name: "alt"
            },
            {
              name: "coords"
            },
            {
              name: "shape",
              valueSet: "sh"
            },
            {
              name: "href"
            },
            {
              name: "target",
              valueSet: "target"
            },
            {
              name: "download"
            },
            {
              name: "ping"
            },
            {
              name: "rel"
            },
            {
              name: "hreflang"
            },
            {
              name: "type"
            },
            {
              name: "accesskey",
              description: "Specifies a keyboard navigation accelerator for the element. Pressing ALT or a similar key in association with the specified character selects the form control correlated with that key sequence. Page designers are forewarned to avoid key sequences already bound to browsers. This attribute is global since HTML5."
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/area"
            }
          ]
        },
        {
          name: "table",
          description: {
            kind: "markdown",
            value: "The table element represents data with more than one dimension, in the form of a table."
          },
          attributes: [
            {
              name: "border"
            },
            {
              name: "align",
              description: 'This enumerated attribute indicates how the table must be aligned inside the containing document. It may have the following values:\n\n*   left: the table is displayed on the left side of the document;\n*   center: the table is displayed in the center of the document;\n*   right: the table is displayed on the right side of the document.\n\n**Usage Note**\n\n*   **Do not use this attribute**, as it has been deprecated. The [`<table>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/table "The HTML <table> element represents tabular data \u2014 that is, information presented in a two-dimensional table comprised of rows and columns of cells containing data.") element should be styled using [CSS](https://developer.mozilla.org/en-US/docs/CSS). Set [`margin-left`](https://developer.mozilla.org/en-US/docs/Web/CSS/margin-left "The margin-left CSS property sets the margin area on the left side of an element. A positive value places it farther from its neighbors, while a negative value places it closer.") and [`margin-right`](https://developer.mozilla.org/en-US/docs/Web/CSS/margin-right "The margin-right CSS property sets the margin area on the right side of an element. A positive value places it farther from its neighbors, while a negative value places it closer.") to `auto` or [`margin`](https://developer.mozilla.org/en-US/docs/Web/CSS/margin "The margin CSS property sets the margin area on all four sides of an element. It is a shorthand for margin-top, margin-right, margin-bottom, and margin-left.") to `0 auto` to achieve an effect that is similar to the align attribute.\n*   Prior to Firefox 4, Firefox also supported the `middle`, `absmiddle`, and `abscenter` values as synonyms of `center`, in quirks mode only.'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/table"
            }
          ]
        },
        {
          name: "caption",
          description: {
            kind: "markdown",
            value: "The caption element represents the title of the table that is its parent, if it has a parent and that is a table element."
          },
          attributes: [
            {
              name: "align",
              description: `This enumerated attribute indicates how the caption must be aligned with respect to the table. It may have one of the following values:

\`left\`

The caption is displayed to the left of the table.

\`top\`

The caption is displayed above the table.

\`right\`

The caption is displayed to the right of the table.

\`bottom\`

The caption is displayed below the table.

**Usage note:** Do not use this attribute, as it has been deprecated. The [\`<caption>\`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/caption "The HTML Table Caption element (<caption>) specifies the caption (or title) of a table, and if used is always the first child of a <table>.") element should be styled using the [CSS](https://developer.mozilla.org/en-US/docs/CSS) properties [\`caption-side\`](https://developer.mozilla.org/en-US/docs/Web/CSS/caption-side "The caption-side CSS property puts the content of a table's <caption> on the specified side. The values are relative to the writing-mode of the table.") and [\`text-align\`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.").`
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/caption"
            }
          ]
        },
        {
          name: "colgroup",
          description: {
            kind: "markdown",
            value: "The colgroup element represents a group of one or more columns in the table that is its parent, if it has a parent and that is a table element."
          },
          attributes: [
            {
              name: "span"
            },
            {
              name: "align",
              description: 'This enumerated attribute specifies how horizontal alignment of each column cell content will be handled. Possible values are:\n\n*   `left`, aligning the content to the left of the cell\n*   `center`, centering the content in the cell\n*   `right`, aligning the content to the right of the cell\n*   `justify`, inserting spaces into the textual content so that the content is justified in the cell\n*   `char`, aligning the textual content on a special character with a minimal offset, defined by the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col#attr-char) and [`charoff`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col#attr-charoff) attributes Unimplemented (see [bug\xA02212](https://bugzilla.mozilla.org/show_bug.cgi?id=2212 "character alignment not implemented (align=char, charoff=, text-align:<string>)")).\n\nIf this attribute is not set, the `left` value is assumed. The descendant [`<col>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col "The HTML <col> element defines a column within a table and is used for defining common semantics on all common cells. It is generally found within a <colgroup> element.") elements may override this value using their own [`align`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col#attr-align) attribute.\n\n**Note:** Do not use this attribute as it is obsolete (not supported) in the latest standard.\n\n*   To achieve the same effect as the `left`, `center`, `right` or `justify` values:\n    *   Do not try to set the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.") property on a selector giving a [`<colgroup>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/colgroup "The HTML <colgroup> element defines a group of columns within a table.") element. Because [`<td>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td "The HTML <td> element defines a cell of a table that contains data. It participates in the table model.") elements are not descendant of the [`<colgroup>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/colgroup "The HTML <colgroup> element defines a group of columns within a table.") element, they won\'t inherit it.\n    *   If the table doesn\'t use a [`colspan`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td#attr-colspan) attribute, use one `td:nth-child(an+b)` CSS selector per column, where a is the total number of the columns in the table and b is the ordinal position of this column in the table. Only after this selector the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.") property can be used.\n    *   If the table does use a [`colspan`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td#attr-colspan) attribute, the effect can be achieved by combining adequate CSS attribute selectors like `[colspan=n]`, though this is not trivial.\n*   To achieve the same effect as the `char` value, in CSS3, you can use the value of the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/colgroup#attr-char) as the value of the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.") property Unimplemented.'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/colgroup"
            }
          ]
        },
        {
          name: "col",
          description: {
            kind: "markdown",
            value: "If a col element has a parent and that is a colgroup element that itself has a parent that is a table element, then the col element represents one or more columns in the column group represented by that colgroup."
          },
          void: !0,
          attributes: [
            {
              name: "span"
            },
            {
              name: "align",
              description: 'This enumerated attribute specifies how horizontal alignment of each column cell content will be handled. Possible values are:\n\n*   `left`, aligning the content to the left of the cell\n*   `center`, centering the content in the cell\n*   `right`, aligning the content to the right of the cell\n*   `justify`, inserting spaces into the textual content so that the content is justified in the cell\n*   `char`, aligning the textual content on a special character with a minimal offset, defined by the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col#attr-char) and [`charoff`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col#attr-charoff) attributes Unimplemented (see [bug\xA02212](https://bugzilla.mozilla.org/show_bug.cgi?id=2212 "character alignment not implemented (align=char, charoff=, text-align:<string>)")).\n\nIf this attribute is not set, its value is inherited from the [`align`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/colgroup#attr-align) of the [`<colgroup>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/colgroup "The HTML <colgroup> element defines a group of columns within a table.") element this `<col>` element belongs too. If there are none, the `left` value is assumed.\n\n**Note:** Do not use this attribute as it is obsolete (not supported) in the latest standard.\n\n*   To achieve the same effect as the `left`, `center`, `right` or `justify` values:\n    *   Do not try to set the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.") property on a selector giving a [`<col>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col "The HTML <col> element defines a column within a table and is used for defining common semantics on all common cells. It is generally found within a <colgroup> element.") element. Because [`<td>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td "The HTML <td> element defines a cell of a table that contains data. It participates in the table model.") elements are not descendant of the [`<col>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col "The HTML <col> element defines a column within a table and is used for defining common semantics on all common cells. It is generally found within a <colgroup> element.") element, they won\'t inherit it.\n    *   If the table doesn\'t use a [`colspan`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td#attr-colspan) attribute, use the `td:nth-child(an+b)` CSS selector. Set `a` to zero and `b` to the position of the column in the table, e.g. `td:nth-child(2) { text-align: right; }` to right-align the second column.\n    *   If the table does use a [`colspan`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td#attr-colspan) attribute, the effect can be achieved by combining adequate CSS attribute selectors like `[colspan=n]`, though this is not trivial.\n*   To achieve the same effect as the `char` value, in CSS3, you can use the value of the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/col#attr-char) as the value of the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.") property Unimplemented.'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/col"
            }
          ]
        },
        {
          name: "tbody",
          description: {
            kind: "markdown",
            value: "The tbody element represents a block of rows that consist of a body of data for the parent table element, if the tbody element has a parent and it is a table."
          },
          attributes: [
            {
              name: "align",
              description: 'This enumerated attribute specifies how horizontal alignment of each cell content will be handled. Possible values are:\n\n*   `left`, aligning the content to the left of the cell\n*   `center`, centering the content in the cell\n*   `right`, aligning the content to the right of the cell\n*   `justify`, inserting spaces into the textual content so that the content is justified in the cell\n*   `char`, aligning the textual content on a special character with a minimal offset, defined by the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tbody#attr-char) and [`charoff`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tbody#attr-charoff) attributes.\n\nIf this attribute is not set, the `left` value is assumed.\n\n**Note:** Do not use this attribute as it is obsolete (not supported) in the latest standard.\n\n*   To achieve the same effect as the `left`, `center`, `right` or `justify` values, use the CSS [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.") property on it.\n*   To achieve the same effect as the `char` value, in CSS3, you can use the value of the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tbody#attr-char) as the value of the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.") property Unimplemented.'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/tbody"
            }
          ]
        },
        {
          name: "thead",
          description: {
            kind: "markdown",
            value: "The thead element represents the block of rows that consist of the column labels (headers) for the parent table element, if the thead element has a parent and it is a table."
          },
          attributes: [
            {
              name: "align",
              description: 'This enumerated attribute specifies how horizontal alignment of each cell content will be handled. Possible values are:\n\n*   `left`, aligning the content to the left of the cell\n*   `center`, centering the content in the cell\n*   `right`, aligning the content to the right of the cell\n*   `justify`, inserting spaces into the textual content so that the content is justified in the cell\n*   `char`, aligning the textual content on a special character with a minimal offset, defined by the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/thead#attr-char) and [`charoff`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/thead#attr-charoff) attributes Unimplemented (see [bug\xA02212](https://bugzilla.mozilla.org/show_bug.cgi?id=2212 "character alignment not implemented (align=char, charoff=, text-align:<string>)")).\n\nIf this attribute is not set, the `left` value is assumed.\n\n**Note:** Do not use this attribute as it is obsolete (not supported) in the latest standard.\n\n*   To achieve the same effect as the `left`, `center`, `right` or `justify` values, use the CSS [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.") property on it.\n*   To achieve the same effect as the `char` value, in CSS3, you can use the value of the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/thead#attr-char) as the value of the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.") property Unimplemented.'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/thead"
            }
          ]
        },
        {
          name: "tfoot",
          description: {
            kind: "markdown",
            value: "The tfoot element represents the block of rows that consist of the column summaries (footers) for the parent table element, if the tfoot element has a parent and it is a table."
          },
          attributes: [
            {
              name: "align",
              description: 'This enumerated attribute specifies how horizontal alignment of each cell content will be handled. Possible values are:\n\n*   `left`, aligning the content to the left of the cell\n*   `center`, centering the content in the cell\n*   `right`, aligning the content to the right of the cell\n*   `justify`, inserting spaces into the textual content so that the content is justified in the cell\n*   `char`, aligning the textual content on a special character with a minimal offset, defined by the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tbody#attr-char) and [`charoff`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tbody#attr-charoff) attributes Unimplemented (see [bug\xA02212](https://bugzilla.mozilla.org/show_bug.cgi?id=2212 "character alignment not implemented (align=char, charoff=, text-align:<string>)")).\n\nIf this attribute is not set, the `left` value is assumed.\n\n**Note:** Do not use this attribute as it is obsolete (not supported) in the latest standard.\n\n*   To achieve the same effect as the `left`, `center`, `right` or `justify` values, use the CSS [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.") property on it.\n*   To achieve the same effect as the `char` value, in CSS3, you can use the value of the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tfoot#attr-char) as the value of the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.") property Unimplemented.'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/tfoot"
            }
          ]
        },
        {
          name: "tr",
          description: {
            kind: "markdown",
            value: "The tr element represents a row of cells in a table."
          },
          attributes: [
            {
              name: "align",
              description: 'A [`DOMString`](https://developer.mozilla.org/en-US/docs/Web/API/DOMString "DOMString is a UTF-16 String. As JavaScript already uses such strings, DOMString is mapped directly to a String.") which specifies how the cell\'s context should be aligned horizontally within the cells in the row; this is shorthand for using `align` on every cell in the row individually. Possible values are:\n\n`left`\n\nAlign the content of each cell at its left edge.\n\n`center`\n\nCenter the contents of each cell between their left and right edges.\n\n`right`\n\nAlign the content of each cell at its right edge.\n\n`justify`\n\nWiden whitespaces within the text of each cell so that the text fills the full width of each cell (full justification).\n\n`char`\n\nAlign each cell in the row on a specific character (such that each row in the column that is configured this way will horizontally align its cells on that character). This uses the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tr#attr-char) and [`charoff`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/tr#attr-charoff) to establish the alignment character (typically "." or "," when aligning numerical data) and the number of characters that should follow the alignment character. This alignment type was never widely supported.\n\nIf no value is expressly set for `align`, the parent node\'s value is inherited.\n\nInstead of using the obsolete `align` attribute, you should instead use the CSS [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.") property to establish `left`, `center`, `right`, or `justify` alignment for the row\'s cells. To apply character-based alignment, set the CSS [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.") property to the alignment character (such as `"."` or `","`).'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/tr"
            }
          ]
        },
        {
          name: "td",
          description: {
            kind: "markdown",
            value: "The td element represents a data cell in a table."
          },
          attributes: [
            {
              name: "colspan"
            },
            {
              name: "rowspan"
            },
            {
              name: "headers"
            },
            {
              name: "abbr",
              description: `This attribute contains a short abbreviated description of the cell's content. Some user-agents, such as speech readers, may present this description before the content itself.

**Note:** Do not use this attribute as it is obsolete in the latest standard. Alternatively, you can put the abbreviated description inside the cell and place the long content in the **title** attribute.`
            },
            {
              name: "align",
              description: 'This enumerated attribute specifies how the cell content\'s horizontal alignment will be handled. Possible values are:\n\n*   `left`: The content is aligned to the left of the cell.\n*   `center`: The content is centered in the cell.\n*   `right`: The content is aligned to the right of the cell.\n*   `justify` (with text only): The content is stretched out inside the cell so that it covers its entire width.\n*   `char` (with text only): The content is aligned to a character inside the `<th>` element with minimal offset. This character is defined by the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td#attr-char) and [`charoff`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td#attr-charoff) attributes Unimplemented (see [bug\xA02212](https://bugzilla.mozilla.org/show_bug.cgi?id=2212 "character alignment not implemented (align=char, charoff=, text-align:<string>)")).\n\nThe default value when this attribute is not specified is `left`.\n\n**Note:** Do not use this attribute as it is obsolete in the latest standard.\n\n*   To achieve the same effect as the `left`, `center`, `right` or `justify` values, apply the CSS [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.") property to the element.\n*   To achieve the same effect as the `char` value, give the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.") property the same value you would use for the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td#attr-char). Unimplemented in CSS3.'
            },
            {
              name: "axis",
              description: "This attribute contains a list of space-separated strings. Each string is the `id` of a group of cells that this header applies to.\n\n**Note:** Do not use this attribute as it is obsolete in the latest standard."
            },
            {
              name: "bgcolor",
              description: `This attribute defines the background color of each cell in a column. It consists of a 6-digit hexadecimal code as defined in [sRGB](https://www.w3.org/Graphics/Color/sRGB) and is prefixed by '#'. This attribute may be used with one of sixteen predefined color strings:

\xA0

\`black\` = "#000000"

\xA0

\`green\` = "#008000"

\xA0

\`silver\` = "#C0C0C0"

\xA0

\`lime\` = "#00FF00"

\xA0

\`gray\` = "#808080"

\xA0

\`olive\` = "#808000"

\xA0

\`white\` = "#FFFFFF"

\xA0

\`yellow\` = "#FFFF00"

\xA0

\`maroon\` = "#800000"

\xA0

\`navy\` = "#000080"

\xA0

\`red\` = "#FF0000"

\xA0

\`blue\` = "#0000FF"

\xA0

\`purple\` = "#800080"

\xA0

\`teal\` = "#008080"

\xA0

\`fuchsia\` = "#FF00FF"

\xA0

\`aqua\` = "#00FFFF"

**Note:** Do not use this attribute, as it is non-standard and only implemented in some versions of Microsoft Internet Explorer: The [\`<td>\`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/td "The HTML <td> element defines a cell of a table that contains data. It participates in the table model.") element should be styled using [CSS](https://developer.mozilla.org/en-US/docs/CSS). To create a similar effect use the [\`background-color\`](https://developer.mozilla.org/en-US/docs/Web/CSS/background-color "The background-color CSS property sets the background color of an element.") property in [CSS](https://developer.mozilla.org/en-US/docs/CSS) instead.`
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/td"
            }
          ]
        },
        {
          name: "th",
          description: {
            kind: "markdown",
            value: "The th element represents a header cell in a table."
          },
          attributes: [
            {
              name: "colspan"
            },
            {
              name: "rowspan"
            },
            {
              name: "headers"
            },
            {
              name: "scope",
              valueSet: "s"
            },
            {
              name: "sorted"
            },
            {
              name: "abbr",
              description: {
                kind: "markdown",
                value: "This attribute contains a short abbreviated description of the cell's content. Some user-agents, such as speech readers, may present this description before the content itself."
              }
            },
            {
              name: "align",
              description: 'This enumerated attribute specifies how the cell content\'s horizontal alignment will be handled. Possible values are:\n\n*   `left`: The content is aligned to the left of the cell.\n*   `center`: The content is centered in the cell.\n*   `right`: The content is aligned to the right of the cell.\n*   `justify` (with text only): The content is stretched out inside the cell so that it covers its entire width.\n*   `char` (with text only): The content is aligned to a character inside the `<th>` element with minimal offset. This character is defined by the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/th#attr-char) and [`charoff`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/th#attr-charoff) attributes.\n\nThe default value when this attribute is not specified is `left`.\n\n**Note:** Do not use this attribute as it is obsolete in the latest standard.\n\n*   To achieve the same effect as the `left`, `center`, `right` or `justify` values, apply the CSS [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.") property to the element.\n*   To achieve the same effect as the `char` value, give the [`text-align`](https://developer.mozilla.org/en-US/docs/Web/CSS/text-align "The text-align CSS property sets the horizontal alignment of an inline or table-cell box. This means it works like vertical-align but in the horizontal direction.") property the same value you would use for the [`char`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/th#attr-char). Unimplemented in CSS3.'
            },
            {
              name: "axis",
              description: "This attribute contains a list of space-separated strings. Each string is the `id` of a group of cells that this header applies to.\n\n**Note:** Do not use this attribute as it is obsolete in the latest standard: use the [`scope`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/th#attr-scope) attribute instead."
            },
            {
              name: "bgcolor",
              description: `This attribute defines the background color of each cell in a column. It consists of a 6-digit hexadecimal code as defined in [sRGB](https://www.w3.org/Graphics/Color/sRGB) and is prefixed by '#'. This attribute may be used with one of sixteen predefined color strings:

\xA0

\`black\` = "#000000"

\xA0

\`green\` = "#008000"

\xA0

\`silver\` = "#C0C0C0"

\xA0

\`lime\` = "#00FF00"

\xA0

\`gray\` = "#808080"

\xA0

\`olive\` = "#808000"

\xA0

\`white\` = "#FFFFFF"

\xA0

\`yellow\` = "#FFFF00"

\xA0

\`maroon\` = "#800000"

\xA0

\`navy\` = "#000080"

\xA0

\`red\` = "#FF0000"

\xA0

\`blue\` = "#0000FF"

\xA0

\`purple\` = "#800080"

\xA0

\`teal\` = "#008080"

\xA0

\`fuchsia\` = "#FF00FF"

\xA0

\`aqua\` = "#00FFFF"

**Note:** Do not use this attribute, as it is non-standard and only implemented in some versions of Microsoft Internet Explorer: The [\`<th>\`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/th "The HTML <th> element defines a cell as header of a group of table cells. The exact nature of this group is defined by the scope and headers attributes.") element should be styled using [CSS](https://developer.mozilla.org/en-US/docs/Web/CSS). To create a similar effect use the [\`background-color\`](https://developer.mozilla.org/en-US/docs/Web/CSS/background-color "The background-color CSS property sets the background color of an element.") property in [CSS](https://developer.mozilla.org/en-US/docs/Web/CSS) instead.`
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/th"
            }
          ]
        },
        {
          name: "form",
          description: {
            kind: "markdown",
            value: "The form element represents a collection of form-associated elements, some of which can represent editable values that can be submitted to a server for processing."
          },
          attributes: [
            {
              name: "accept-charset",
              description: {
                kind: "markdown",
                value: 'A space- or comma-delimited list of character encodings that the server accepts. The browser uses them in the order in which they are listed. The default value, the reserved string `"UNKNOWN"`, indicates the same encoding as that of the document containing the form element.  \nIn previous versions of HTML, the different character encodings could be delimited by spaces or commas. In HTML5, only spaces are allowed as delimiters.'
              }
            },
            {
              name: "action",
              description: {
                kind: "markdown",
                value: 'The URI of a program that processes the form information. This value can be overridden by a [`formaction`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button#attr-formaction) attribute on a [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button "The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.") or [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input "The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.") element.'
              }
            },
            {
              name: "autocomplete",
              valueSet: "o",
              description: {
                kind: "markdown",
                value: "Indicates whether input elements can by default have their values automatically completed by the browser. This setting can be overridden by an `autocomplete` attribute on an element belonging to the form. Possible values are:\n\n*   `off`: The user must explicitly enter a value into each field for every use, or the document provides its own auto-completion method; the browser does not automatically complete entries.\n*   `on`: The browser can automatically complete values based on values that the user has previously entered in the form.\n\nFor most modern browsers (including Firefox 38+, Google Chrome 34+, IE 11+) setting the autocomplete attribute will not prevent a browser's password manager from asking the user if they want to store login fields (username and password), if the user permits the storage the browser will autofill the login the next time the user visits the page. See [The autocomplete attribute and login fields](https://developer.mozilla.org/en-US/docs/Web/Security/Securing_your_site/Turning_off_form_autocompletion#The_autocomplete_attribute_and_login_fields).\n**Note:** If you set `autocomplete` to `off` in a form because the document provides its own auto-completion, then you should also set `autocomplete` to `off` for each of the form's `input` elements that the document can auto-complete. For details, see the note regarding Google Chrome in the [Browser Compatibility chart](#compatChart)."
              }
            },
            {
              name: "enctype",
              valueSet: "et",
              description: {
                kind: "markdown",
                value: 'When the value of the `method` attribute is `post`, enctype is the [MIME type](https://en.wikipedia.org/wiki/Mime_type) of content that is used to submit the form to the server. Possible values are:\n\n*   `application/x-www-form-urlencoded`: The default value if the attribute is not specified.\n*   `multipart/form-data`: The value used for an [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input "The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.") element with the `type` attribute set to "file".\n*   `text/plain`: (HTML5)\n\nThis value can be overridden by a [`formenctype`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button#attr-formenctype) attribute on a [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button "The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.") or [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input "The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.") element.'
              }
            },
            {
              name: "method",
              valueSet: "m",
              description: {
                kind: "markdown",
                value: 'The [HTTP](https://developer.mozilla.org/en-US/docs/Web/HTTP) method that the browser uses to submit the form. Possible values are:\n\n*   `post`: Corresponds to the HTTP [POST method](https://www.w3.org/Protocols/rfc2616/rfc2616-sec9.html#sec9.5) ; form data are included in the body of the form and sent to the server.\n*   `get`: Corresponds to the HTTP [GET method](https://www.w3.org/Protocols/rfc2616/rfc2616-sec9.html#sec9.3); form data are appended to the `action` attribute URI with a \'?\' as separator, and the resulting URI is sent to the server. Use this method when the form has no side-effects and contains only ASCII characters.\n*   `dialog`: Use when the form is inside a\xA0[`<dialog>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/dialog "The HTML <dialog> element represents a dialog box or other interactive component, such as an inspector or window.") element to close the dialog when submitted.\n\nThis value can be overridden by a [`formmethod`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button#attr-formmethod) attribute on a [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button "The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.") or [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input "The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.") element.'
              }
            },
            {
              name: "name",
              description: {
                kind: "markdown",
                value: "The name of the form. In HTML 4, its use is deprecated (`id` should be used instead). It must be unique among the forms in a document and not just an empty string in HTML 5."
              }
            },
            {
              name: "novalidate",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: 'This Boolean attribute indicates that the form is not to be validated when submitted. If this attribute is not specified (and therefore the form is validated), this default setting can be overridden by a [`formnovalidate`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button#attr-formnovalidate) attribute on a [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button "The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.") or [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input "The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.") element belonging to the form.'
              }
            },
            {
              name: "target",
              valueSet: "target",
              description: {
                kind: "markdown",
                value: 'A name or keyword indicating where to display the response that is received after submitting the form. In HTML 4, this is the name/keyword for a frame. In HTML5, it is a name/keyword for a _browsing context_ (for example, tab, window, or inline frame). The following keywords have special meanings:\n\n*   `_self`: Load the response into the same HTML 4 frame (or HTML5 browsing context) as the current one. This value is the default if the attribute is not specified.\n*   `_blank`: Load the response into a new unnamed HTML 4 window or HTML5 browsing context.\n*   `_parent`: Load the response into the HTML 4 frameset parent of the current frame, or HTML5 parent browsing context of the current one. If there is no parent, this option behaves the same way as `_self`.\n*   `_top`: HTML 4: Load the response into the full original window, and cancel all other frames. HTML5: Load the response into the top-level browsing context (i.e., the browsing context that is an ancestor of the current one, and has no parent). If there is no parent, this option behaves the same way as `_self`.\n*   _iframename_: The response is displayed in a named [`<iframe>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/iframe "The HTML Inline Frame element (<iframe>) represents a nested browsing context, embedding another HTML page into the current one.").\n\nHTML5: This value can be overridden by a [`formtarget`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button#attr-formtarget) attribute on a [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button "The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.") or [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input "The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.") element.'
              }
            },
            {
              name: "accept",
              description: 'A comma-separated list of content types that the server accepts.\n\n**Usage note:** This attribute has been removed in HTML5 and should no longer be used. Instead, use the [`accept`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#attr-accept) attribute of the specific [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input "The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.") element.'
            },
            {
              name: "autocapitalize",
              description: "This is a nonstandard attribute used by iOS Safari Mobile which controls whether and how the text value for textual form control descendants should be automatically capitalized as it is entered/edited by the user. If the `autocapitalize` attribute is specified on an individual form control descendant, it trumps the form-wide `autocapitalize` setting. The non-deprecated values are available in iOS 5 and later. The default value is `sentences`. Possible values are:\n\n*   `none`: Completely disables automatic capitalization\n*   `sentences`: Automatically capitalize the first letter of sentences.\n*   `words`: Automatically capitalize the first letter of words.\n*   `characters`: Automatically capitalize all characters.\n*   `on`: Deprecated since iOS 5.\n*   `off`: Deprecated since iOS 5."
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/form"
            }
          ]
        },
        {
          name: "label",
          description: {
            kind: "markdown",
            value: "The label element represents a caption in a user interface. The caption can be associated with a specific form control, known as the label element's labeled control, either using the for attribute, or by putting the form control inside the label element itself."
          },
          attributes: [
            {
              name: "form",
              description: {
                kind: "markdown",
                value: 'The [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form "The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.") element with which the label is associated (its _form owner_). If specified, the value of the attribute is the `id` of a [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form "The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.") element in the same document. This lets you place label elements anywhere within a document, not just as descendants of their form elements.'
              }
            },
            {
              name: "for",
              description: {
                kind: "markdown",
                value: "The [`id`](https://developer.mozilla.org/en-US/docs/Web/HTML/Global_attributes#attr-id) of a [labelable](https://developer.mozilla.org/en-US/docs/Web/Guide/HTML/Content_categories#Form_labelable) form-related element in the same document as the `<label>` element. The first element in the document with an `id` matching the value of the `for` attribute is the _labeled control_ for this label element, if it is a labelable element. If it is\xA0not labelable then the `for` attribute has no effect. If there are other elements which also match the `id` value, later in the document, they are not considered.\n\n**Note**: A `<label>` element can have both a `for` attribute and a contained control element, as long as the `for` attribute points to the contained control element."
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/label"
            }
          ]
        },
        {
          name: "input",
          description: {
            kind: "markdown",
            value: "The input element represents a typed data field, usually with a form control to allow the user to edit the data."
          },
          void: !0,
          attributes: [
            {
              name: "accept"
            },
            {
              name: "alt"
            },
            {
              name: "autocomplete",
              valueSet: "inputautocomplete"
            },
            {
              name: "autofocus",
              valueSet: "v"
            },
            {
              name: "checked",
              valueSet: "v"
            },
            {
              name: "dirname"
            },
            {
              name: "disabled",
              valueSet: "v"
            },
            {
              name: "form"
            },
            {
              name: "formaction"
            },
            {
              name: "formenctype",
              valueSet: "et"
            },
            {
              name: "formmethod",
              valueSet: "fm"
            },
            {
              name: "formnovalidate",
              valueSet: "v"
            },
            {
              name: "formtarget"
            },
            {
              name: "height"
            },
            {
              name: "inputmode",
              valueSet: "im"
            },
            {
              name: "list"
            },
            {
              name: "max"
            },
            {
              name: "maxlength"
            },
            {
              name: "min"
            },
            {
              name: "minlength"
            },
            {
              name: "multiple",
              valueSet: "v"
            },
            {
              name: "name"
            },
            {
              name: "pattern"
            },
            {
              name: "placeholder"
            },
            {
              name: "readonly",
              valueSet: "v"
            },
            {
              name: "required",
              valueSet: "v"
            },
            {
              name: "size"
            },
            {
              name: "src"
            },
            {
              name: "step"
            },
            {
              name: "type",
              valueSet: "t"
            },
            {
              name: "value"
            },
            {
              name: "width"
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/input"
            }
          ]
        },
        {
          name: "button",
          description: {
            kind: "markdown",
            value: "The button element represents a button labeled by its contents."
          },
          attributes: [
            {
              name: "autofocus",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "This Boolean attribute lets you specify that the button should have input focus when the page loads, unless the user overrides it, for example by typing in a different control. Only one form-associated element in a document can have this attribute specified."
              }
            },
            {
              name: "disabled",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: 'This Boolean attribute indicates that the user cannot interact with the button. If this attribute is not specified, the button inherits its setting from the containing element, for example [`<fieldset>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/fieldset "The HTML <fieldset> element is used to group several controls as well as labels (<label>) within a web form."); if there is no containing element with the **disabled** attribute set, then the button is enabled.\n\nFirefox will, unlike other browsers, by default, [persist the dynamic disabled state](https://stackoverflow.com/questions/5985839/bug-with-firefox-disabled-attribute-of-input-not-resetting-when-refreshing) of a [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button "The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.") across page loads. Use the [`autocomplete`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button#attr-autocomplete) attribute to control this feature.'
              }
            },
            {
              name: "form",
              description: {
                kind: "markdown",
                value: 'The form element that the button is associated with (its _form owner_). The value of the attribute must be the **id** attribute of a [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form "The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.") element in the same document. If this attribute is not specified, the `<button>` element will be associated to an ancestor [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form "The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.") element, if one exists. This attribute enables you to associate `<button>` elements to [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form "The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.") elements anywhere within a document, not just as descendants of [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form "The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.") elements.'
              }
            },
            {
              name: "formaction",
              description: {
                kind: "markdown",
                value: "The URI of a program that processes the information submitted by the button. If specified, it overrides the [`action`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form#attr-action) attribute of the button's form owner."
              }
            },
            {
              name: "formenctype",
              valueSet: "et",
              description: {
                kind: "markdown",
                value: 'If the button is a submit button, this attribute specifies the type of content that is used to submit the form to the server. Possible values are:\n\n*   `application/x-www-form-urlencoded`: The default value if the attribute is not specified.\n*   `multipart/form-data`: Use this value if you are using an [`<input>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input "The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.") element with the [`type`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#attr-type) attribute set to `file`.\n*   `text/plain`\n\nIf this attribute is specified, it overrides the [`enctype`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form#attr-enctype) attribute of the button\'s form owner.'
              }
            },
            {
              name: "formmethod",
              valueSet: "fm",
              description: {
                kind: "markdown",
                value: "If the button is a submit button, this attribute specifies the HTTP method that the browser uses to submit the form. Possible values are:\n\n*   `post`: The data from the form are included in the body of the form and sent to the server.\n*   `get`: The data from the form are appended to the **form** attribute URI, with a '?' as a separator, and the resulting URI is sent to the server. Use this method when the form has no side-effects and contains only ASCII characters.\n\nIf specified, this attribute overrides the [`method`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form#attr-method) attribute of the button's form owner."
              }
            },
            {
              name: "formnovalidate",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "If the button is a submit button, this Boolean attribute specifies that the form is not to be validated when it is submitted. If this attribute is specified, it overrides the [`novalidate`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form#attr-novalidate) attribute of the button's form owner."
              }
            },
            {
              name: "formtarget",
              description: {
                kind: "markdown",
                value: "If the button is a submit button, this attribute is a name or keyword indicating where to display the response that is received after submitting the form. This is a name of, or keyword for, a _browsing context_ (for example, tab, window, or inline frame). If this attribute is specified, it overrides the [`target`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form#attr-target) attribute of the button's form owner. The following keywords have special meanings:\n\n*   `_self`: Load the response into the same browsing context as the current one. This value is the default if the attribute is not specified.\n*   `_blank`: Load the response into a new unnamed browsing context.\n*   `_parent`: Load the response into the parent browsing context of the current one. If there is no parent, this option behaves the same way as `_self`.\n*   `_top`: Load the response into the top-level browsing context (that is, the browsing context that is an ancestor of the current one, and has no parent). If there is no parent, this option behaves the same way as `_self`."
              }
            },
            {
              name: "name",
              description: {
                kind: "markdown",
                value: "The name of the button, which is submitted with the form data."
              }
            },
            {
              name: "type",
              valueSet: "bt",
              description: {
                kind: "markdown",
                value: "The type of the button. Possible values are:\n\n*   `submit`: The button submits the form data to the server. This is the default if the attribute is not specified, or if the attribute is dynamically changed to an empty or invalid value.\n*   `reset`: The button resets all the controls to their initial values.\n*   `button`: The button has no default behavior. It can have client-side scripts associated with the element's events, which are triggered when the events occur."
              }
            },
            {
              name: "value",
              description: {
                kind: "markdown",
                value: "The initial value of the button. It defines the value associated with the button which is submitted with the form data. This value is passed to the server in params when the form is submitted."
              }
            },
            {
              name: "autocomplete",
              description: 'The use of this attribute on a [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button "The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.") is nonstandard and Firefox-specific. By default, unlike other browsers, [Firefox persists the dynamic disabled state](https://stackoverflow.com/questions/5985839/bug-with-firefox-disabled-attribute-of-input-not-resetting-when-refreshing) of a [`<button>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button "The HTML <button> element represents a clickable button, which can be used in forms or anywhere in a document that needs simple, standard button functionality.") across page loads. Setting the value of this attribute to `off` (i.e. `autocomplete="off"`) disables this feature. See [bug\xA0654072](https://bugzilla.mozilla.org/show_bug.cgi?id=654072 "if disabled state is changed with javascript, the normal state doesn\'t return after refreshing the page").'
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/button"
            }
          ]
        },
        {
          name: "select",
          description: {
            kind: "markdown",
            value: "The select element represents a control for selecting amongst a set of options."
          },
          attributes: [
            {
              name: "autocomplete",
              valueSet: "inputautocomplete",
              description: {
                kind: "markdown",
                value: 'A [`DOMString`](https://developer.mozilla.org/en-US/docs/Web/API/DOMString "DOMString is a UTF-16 String. As JavaScript already uses such strings, DOMString is mapped directly to a String.") providing a hint for a [user agent\'s](https://developer.mozilla.org/en-US/docs/Glossary/user_agent "user agent\'s: A user agent is a computer program representing a person, for example, a browser in a Web context.") autocomplete feature. See [The HTML autocomplete attribute](https://developer.mozilla.org/en-US/docs/Web/HTML/Attributes/autocomplete) for a complete list of values and details on how to use autocomplete.'
              }
            },
            {
              name: "autofocus",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "This Boolean attribute lets you specify that a form control should have input focus when the page loads. Only one form element in a document can have the `autofocus` attribute."
              }
            },
            {
              name: "disabled",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "This Boolean attribute indicates that the user cannot interact with the control. If this attribute is not specified, the control inherits its setting from the containing element, for example `fieldset`; if there is no containing element with the `disabled` attribute set, then the control is enabled."
              }
            },
            {
              name: "form",
              description: {
                kind: "markdown",
                value: 'This attribute lets you specify the form element to\xA0which\xA0the select element is associated\xA0(that is, its "form owner"). If this attribute is specified, its value must be the same as the `id` of a form element in the same document. This enables you to place select elements anywhere within a document, not just as descendants of their form elements.'
              }
            },
            {
              name: "multiple",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "This Boolean attribute indicates that multiple options can be selected in the list. If it is not specified, then only one option can be selected at a time. When `multiple` is specified, most browsers will show a scrolling list box instead of a single line dropdown."
              }
            },
            {
              name: "name",
              description: {
                kind: "markdown",
                value: "This attribute is used to specify the name of the control."
              }
            },
            {
              name: "required",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "A Boolean attribute indicating that an option with a non-empty string value must be selected."
              }
            },
            {
              name: "size",
              description: {
                kind: "markdown",
                value: "If the control is presented as a scrolling list box (e.g. when `multiple` is specified), this attribute represents the number of rows in the list that should be visible at one time. Browsers are not required to present a select element as a scrolled list box. The default value is 0.\n\n**Note:** According to the HTML5 specification, the default value for size should be 1; however, in practice, this has been found to break some web sites, and no other browser currently does that, so Mozilla has opted to continue to return 0 for the time being with Firefox."
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/select"
            }
          ]
        },
        {
          name: "datalist",
          description: {
            kind: "markdown",
            value: "The datalist element represents a set of option elements that represent predefined options for other controls. In the rendering, the datalist element represents nothing and it, along with its children, should be hidden."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/datalist"
            }
          ]
        },
        {
          name: "optgroup",
          description: {
            kind: "markdown",
            value: "The optgroup element represents a group of option elements with a common label."
          },
          attributes: [
            {
              name: "disabled",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "If this Boolean attribute is set, none of the items in this option group is selectable. Often browsers grey out such control and it won't receive any browsing events, like mouse clicks or focus-related ones."
              }
            },
            {
              name: "label",
              description: {
                kind: "markdown",
                value: "The name of the group of options, which the browser can use when labeling the options in the user interface. This attribute is mandatory if this element is used."
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/optgroup"
            }
          ]
        },
        {
          name: "option",
          description: {
            kind: "markdown",
            value: "The option element represents an option in a select element or as part of a list of suggestions in a datalist element."
          },
          attributes: [
            {
              name: "disabled",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: 'If this Boolean attribute is set, this option is not checkable. Often browsers grey out such control and it won\'t receive any browsing event, like mouse clicks or focus-related ones. If this attribute is not set, the element can still be disabled if one of its ancestors is a disabled [`<optgroup>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/optgroup "The HTML <optgroup> element creates a grouping of options within a <select> element.") element.'
              }
            },
            {
              name: "label",
              description: {
                kind: "markdown",
                value: "This attribute is text for the label indicating the meaning of the option. If the `label` attribute isn't defined, its value is that of the element text content."
              }
            },
            {
              name: "selected",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: 'If present, this Boolean attribute indicates that the option is initially selected. If the `<option>` element is the descendant of a [`<select>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/select "The HTML <select> element represents a control that provides a menu of options") element whose [`multiple`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/select#attr-multiple) attribute is not set, only one single `<option>` of this [`<select>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/select "The HTML <select> element represents a control that provides a menu of options") element may have the `selected` attribute.'
              }
            },
            {
              name: "value",
              description: {
                kind: "markdown",
                value: "The content of this attribute represents the value to be submitted with the form, should this option be selected.\xA0If this attribute is omitted, the value is taken from the text content of the option element."
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/option"
            }
          ]
        },
        {
          name: "textarea",
          description: {
            kind: "markdown",
            value: "The textarea element represents a multiline plain text edit control for the element's raw value. The contents of the control represent the control's default value."
          },
          attributes: [
            {
              name: "autocomplete",
              valueSet: "inputautocomplete",
              description: {
                kind: "markdown",
                value: 'This attribute indicates whether the value of the control can be automatically completed by the browser. Possible values are:\n\n*   `off`: The user must explicitly enter a value into this field for every use, or the document provides its own auto-completion method; the browser does not automatically complete the entry.\n*   `on`: The browser can automatically complete the value based on values that the user has entered during previous uses.\n\nIf the `autocomplete` attribute is not specified on a `<textarea>` element, then the browser uses the `autocomplete` attribute value of the `<textarea>` element\'s form owner. The form owner is either the [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form "The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.") element that this `<textarea>` element is a descendant of or the form element whose `id` is specified by the `form` attribute of the input element. For more information, see the [`autocomplete`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form#attr-autocomplete) attribute in [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form "The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.").'
              }
            },
            {
              name: "autofocus",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "This Boolean attribute lets you specify that a form control should have input focus when the page loads. Only one form-associated element in a document can have this attribute specified."
              }
            },
            {
              name: "cols",
              description: {
                kind: "markdown",
                value: "The visible width of the text control, in average character widths. If it is specified, it must be a positive integer. If it is not specified, the default value is `20`."
              }
            },
            {
              name: "dirname"
            },
            {
              name: "disabled",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: 'This Boolean attribute indicates that the user cannot interact with the control. If this attribute is not specified, the control inherits its setting from the containing element, for example [`<fieldset>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/fieldset "The HTML <fieldset> element is used to group several controls as well as labels (<label>) within a web form."); if there is no containing element when the `disabled` attribute is set, the control is enabled.'
              }
            },
            {
              name: "form",
              description: {
                kind: "markdown",
                value: 'The form element that the `<textarea>` element is associated with (its "form owner"). The value of the attribute must be the `id` of a form element in the same document. If this attribute is not specified, the `<textarea>` element must be a descendant of a form element. This attribute enables you to place `<textarea>` elements anywhere within a document, not just as descendants of form elements.'
              }
            },
            {
              name: "inputmode",
              valueSet: "im"
            },
            {
              name: "maxlength",
              description: {
                kind: "markdown",
                value: "The maximum number of characters (unicode code points) that the user can enter. If this value isn't specified, the user can enter an unlimited number of characters."
              }
            },
            {
              name: "minlength",
              description: {
                kind: "markdown",
                value: "The minimum number of characters (unicode code points) required that the user should enter."
              }
            },
            {
              name: "name",
              description: {
                kind: "markdown",
                value: "The name of the control."
              }
            },
            {
              name: "placeholder",
              description: {
                kind: "markdown",
                value: 'A hint to the user of what can be entered in the control. Carriage returns or line-feeds within the placeholder text must be treated as line breaks when rendering the hint.\n\n**Note:** Placeholders should only be used to show an example of the type of data that should be entered into a form; they are _not_ a substitute for a proper [`<label>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/label "The HTML <label> element represents a caption for an item in a user interface.") element tied to the input. See [Labels and placeholders](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Labels_and_placeholders "The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.") in [<input>: The Input (Form Input) element](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input "The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.") for a full explanation.'
              }
            },
            {
              name: "readonly",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "This Boolean attribute indicates that the user cannot modify the value of the control. Unlike the `disabled` attribute, the `readonly` attribute does not prevent the user from clicking or selecting in the control. The value of a read-only control is still submitted with the form."
              }
            },
            {
              name: "required",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "This attribute specifies that the user must fill in a value before submitting a form."
              }
            },
            {
              name: "rows",
              description: {
                kind: "markdown",
                value: "The number of visible text lines for the control."
              }
            },
            {
              name: "wrap",
              valueSet: "w",
              description: {
                kind: "markdown",
                value: "Indicates how the control wraps text. Possible values are:\n\n*   `hard`: The browser automatically inserts line breaks (CR+LF) so that each line has no more than the width of the control; the `cols` attribute must also be specified for this to take effect.\n*   `soft`: The browser ensures that all line breaks in the value consist of a CR+LF pair, but does not insert any additional line breaks.\n*   `off` : Like `soft` but changes appearance to `white-space: pre` so line segments exceeding `cols` are not wrapped and the `<textarea>` becomes horizontally scrollable.\n\nIf this attribute is not specified, `soft` is its default value."
              }
            },
            {
              name: "autocapitalize",
              description: "This is a non-standard attribute supported by WebKit on iOS (therefore nearly all browsers running on iOS, including Safari, Firefox, and Chrome), which controls whether and how the text value should be automatically capitalized as it is entered/edited by the user. The non-deprecated values are available in iOS 5 and later. Possible values are:\n\n*   `none`: Completely disables automatic capitalization.\n*   `sentences`: Automatically capitalize the first letter of sentences.\n*   `words`: Automatically capitalize the first letter of words.\n*   `characters`: Automatically capitalize all characters.\n*   `on`: Deprecated since iOS 5.\n*   `off`: Deprecated since iOS 5."
            },
            {
              name: "spellcheck",
              description: "Specifies whether the `<textarea>` is subject to spell checking by the underlying browser/OS. the value can be:\n\n*   `true`: Indicates that the element needs to have its spelling and grammar checked.\n*   `default` : Indicates that the element is to act according to a default behavior, possibly based on the parent element's own `spellcheck` value.\n*   `false` : Indicates that the element should not be spell checked."
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/textarea"
            }
          ]
        },
        {
          name: "output",
          description: {
            kind: "markdown",
            value: "The output element represents the result of a calculation performed by the application, or the result of a user action."
          },
          attributes: [
            {
              name: "for",
              description: {
                kind: "markdown",
                value: "A space-separated list of other elements\u2019 [`id`](https://developer.mozilla.org/en-US/docs/Web/HTML/Global_attributes/id)s, indicating that those elements contributed input values to (or otherwise affected) the calculation."
              }
            },
            {
              name: "form",
              description: {
                kind: "markdown",
                value: 'The [form element](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form) that this element is associated with (its "form owner"). The value of the attribute must be an `id` of a form element in the same document. If this attribute is not specified, the output element must be a descendant of a form element. This attribute enables you to place output elements anywhere within a document, not just as descendants of their form elements.'
              }
            },
            {
              name: "name",
              description: {
                kind: "markdown",
                value: 'The name of the element, exposed in the [`HTMLFormElement`](https://developer.mozilla.org/en-US/docs/Web/API/HTMLFormElement "The HTMLFormElement interface represents a <form> element in the DOM; it allows access to and in some cases modification of aspects of the form, as well as access to its component elements.") API.'
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/output"
            }
          ]
        },
        {
          name: "progress",
          description: {
            kind: "markdown",
            value: "The progress element represents the completion progress of a task. The progress is either indeterminate, indicating that progress is being made but that it is not clear how much more work remains to be done before the task is complete (e.g. because the task is waiting for a remote host to respond), or the progress is a number in the range zero to a maximum, giving the fraction of work that has so far been completed."
          },
          attributes: [
            {
              name: "value",
              description: {
                kind: "markdown",
                value: "This attribute specifies how much of the task that has been completed. It must be a valid floating point number between 0 and `max`, or between 0 and 1 if `max` is omitted. If there is no `value` attribute, the progress bar is indeterminate; this indicates that an activity is ongoing with no indication of how long it is expected to take."
              }
            },
            {
              name: "max",
              description: {
                kind: "markdown",
                value: "This attribute describes how much work the task indicated by the `progress` element requires. The `max` attribute, if present, must have a value greater than zero and be a valid floating point number. The default value is 1."
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/progress"
            }
          ]
        },
        {
          name: "meter",
          description: {
            kind: "markdown",
            value: "The meter element represents a scalar measurement within a known range, or a fractional value; for example disk usage, the relevance of a query result, or the fraction of a voting population to have selected a particular candidate."
          },
          attributes: [
            {
              name: "value",
              description: {
                kind: "markdown",
                value: "The current numeric value. This must be between the minimum and maximum values (`min` attribute and `max` attribute) if they are specified. If unspecified or malformed, the value is 0. If specified, but not within the range given by the `min` attribute and `max` attribute, the value is equal to the nearest end of the range.\n\n**Usage note:** Unless the `value` attribute is between `0` and `1` (inclusive), the `min` and `max` attributes should define the range so that the `value` attribute's value is within it."
              }
            },
            {
              name: "min",
              description: {
                kind: "markdown",
                value: "The lower numeric bound of the measured range. This must be less than the maximum value (`max` attribute), if specified. If unspecified, the minimum value is 0."
              }
            },
            {
              name: "max",
              description: {
                kind: "markdown",
                value: "The upper numeric bound of the measured range. This must be greater than the minimum value (`min` attribute), if specified. If unspecified, the maximum value is 1."
              }
            },
            {
              name: "low",
              description: {
                kind: "markdown",
                value: "The upper numeric bound of the low end of the measured range. This must be greater than the minimum value (`min` attribute), and it also must be less than the high value and maximum value (`high` attribute and `max` attribute, respectively), if any are specified. If unspecified, or if less than the minimum value, the `low` value is equal to the minimum value."
              }
            },
            {
              name: "high",
              description: {
                kind: "markdown",
                value: "The lower numeric bound of the high end of the measured range. This must be less than the maximum value (`max` attribute), and it also must be greater than the low value and minimum value (`low` attribute and **min** attribute, respectively), if any are specified. If unspecified, or if greater than the maximum value, the `high` value is equal to the maximum value."
              }
            },
            {
              name: "optimum",
              description: {
                kind: "markdown",
                value: "This attribute indicates the optimal numeric value. It must be within the range (as defined by the `min` attribute and `max` attribute). When used with the `low` attribute and `high` attribute, it gives an indication where along the range is considered preferable. For example, if it is between the `min` attribute and the `low` attribute, then the lower range is considered preferred."
              }
            },
            {
              name: "form",
              description: "This attribute associates the element with a `form` element that has ownership of the `meter` element. For example, a `meter` might be displaying a range corresponding to an `input` element of `type` _number_. This attribute is only used if the `meter` element is being used as a form-associated element; even then, it may be omitted if the element appears as a descendant of a `form` element."
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/meter"
            }
          ]
        },
        {
          name: "fieldset",
          description: {
            kind: "markdown",
            value: "The fieldset element represents a set of form controls optionally grouped under a common name."
          },
          attributes: [
            {
              name: "disabled",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "If this Boolean attribute is set, all form controls that are descendants of the `<fieldset>`, are disabled, meaning they are not editable and won't be submitted along with the `<form>`. They won't receive any browsing events, like mouse clicks or focus-related events. By default browsers display such controls grayed out. Note that form elements inside the [`<legend>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/legend \"The HTML <legend> element represents a caption for the content of its parent <fieldset>.\") element won't be disabled."
              }
            },
            {
              name: "form",
              description: {
                kind: "markdown",
                value: 'This attribute takes the value of the `id` attribute of a [`<form>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/form "The HTML <form> element represents a document section that contains interactive controls for submitting information to a web server.") element you want the `<fieldset>` to be part of, even if it is not inside the form.'
              }
            },
            {
              name: "name",
              description: {
                kind: "markdown",
                value: 'The name associated with the group.\n\n**Note**: The caption for the fieldset is given by the first [`<legend>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/legend "The HTML <legend> element represents a caption for the content of its parent <fieldset>.") element nested inside it.'
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/fieldset"
            }
          ]
        },
        {
          name: "legend",
          description: {
            kind: "markdown",
            value: "The legend element represents a caption for the rest of the contents of the legend element's parent fieldset element, if any."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/legend"
            }
          ]
        },
        {
          name: "details",
          description: {
            kind: "markdown",
            value: "The details element represents a disclosure widget from which the user can obtain additional information or controls."
          },
          attributes: [
            {
              name: "open",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: "This Boolean attribute indicates whether or not the details \u2014 that is, the contents of the `<details>` element \u2014 are currently visible. The default, `false`, means the details are not visible."
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/details"
            }
          ]
        },
        {
          name: "summary",
          description: {
            kind: "markdown",
            value: "The summary element represents a summary, caption, or legend for the rest of the contents of the summary element's parent details element, if any."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/summary"
            }
          ]
        },
        {
          name: "dialog",
          description: {
            kind: "markdown",
            value: "The dialog element represents a part of an application that a user interacts with to perform a task, for example a dialog box, inspector, or window."
          },
          attributes: [
            {
              name: "open",
              description: "Indicates that the dialog is active and available for interaction. When the `open` attribute is not set, the dialog shouldn't be shown to the user."
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/dialog"
            }
          ]
        },
        {
          name: "script",
          description: {
            kind: "markdown",
            value: "The script element allows authors to include dynamic script and data blocks in their documents. The element does not represent content for the user."
          },
          attributes: [
            {
              name: "src",
              description: {
                kind: "markdown",
                value: "This attribute specifies the URI of an external script; this can be used as an alternative to embedding a script directly within a document.\n\nIf a `script` element has a `src` attribute specified, it should not have a script embedded inside its tags."
              }
            },
            {
              name: "type",
              description: {
                kind: "markdown",
                value: 'This attribute indicates the type of script represented. The value of this attribute will be in one of the following categories:\n\n*   **Omitted or a JavaScript MIME type:** For HTML5-compliant browsers this indicates the script is JavaScript. HTML5 specification urges authors to omit the attribute rather than provide a redundant MIME type. In earlier browsers, this identified the scripting language of the embedded or imported (via the `src` attribute) code. JavaScript MIME types are [listed in the specification](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types#JavaScript_types).\n*   **`module`:** For HTML5-compliant browsers the code is treated as a JavaScript module. The processing of the script contents is not affected by the `charset` and `defer` attributes. For information on using `module`, see [ES6 in Depth: Modules](https://hacks.mozilla.org/2015/08/es6-in-depth-modules/). Code may behave differently when the `module` keyword is used.\n*   **Any other value:** The embedded content is treated as a data block which won\'t be processed by the browser. Developers must use a valid MIME type that is not a JavaScript MIME type to denote data blocks. The `src` attribute will be ignored.\n\n**Note:** in Firefox you could specify the version of JavaScript contained in a `<script>` element by including a non-standard `version` parameter inside the `type` attribute \u2014 for example `type="text/javascript;version=1.8"`. This has been removed in Firefox 59 (see [bug\xA01428745](https://bugzilla.mozilla.org/show_bug.cgi?id=1428745 "FIXED: Remove support for version parameter from script loader")).'
              }
            },
            {
              name: "charset"
            },
            {
              name: "async",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: `This is a Boolean attribute indicating that the browser should, if possible, load the script asynchronously.

This attribute must not be used if the \`src\` attribute is absent (i.e. for inline scripts). If it is included in this case it will have no effect.

Browsers usually assume the worst case scenario and load scripts synchronously, (i.e. \`async="false"\`) during HTML parsing.

Dynamically inserted scripts (using [\`document.createElement()\`](https://developer.mozilla.org/en-US/docs/Web/API/Document/createElement "In an HTML document, the document.createElement() method creates the HTML element specified by tagName, or an HTMLUnknownElement if tagName isn't recognized.")) load asynchronously by default, so to turn on synchronous loading (i.e. scripts load in the order they were inserted) set \`async="false"\`.

See [Browser compatibility](#Browser_compatibility) for notes on browser support. See also [Async scripts for asm.js](https://developer.mozilla.org/en-US/docs/Games/Techniques/Async_scripts).`
              }
            },
            {
              name: "defer",
              valueSet: "v",
              description: {
                kind: "markdown",
                value: 'This Boolean attribute is set to indicate to a browser that the script is meant to be executed after the document has been parsed, but before firing [`DOMContentLoaded`](https://developer.mozilla.org/en-US/docs/Web/Events/DOMContentLoaded "/en-US/docs/Web/Events/DOMContentLoaded").\n\nScripts with the `defer` attribute will prevent the `DOMContentLoaded` event from firing until the script has loaded and finished evaluating.\n\nThis attribute must not be used if the `src` attribute is absent (i.e. for inline scripts), in this case it would have no effect.\n\nTo achieve a similar effect for dynamically inserted scripts use `async="false"` instead. Scripts with the `defer` attribute will execute in the order in which they appear in the document.'
              }
            },
            {
              name: "crossorigin",
              valueSet: "xo",
              description: {
                kind: "markdown",
                value: 'Normal `script` elements pass minimal information to the [`window.onerror`](https://developer.mozilla.org/en-US/docs/Web/API/GlobalEventHandlers/onerror "The onerror property of the GlobalEventHandlers mixin is an EventHandler that processes error events.") for scripts which do not pass the standard [CORS](https://developer.mozilla.org/en-US/docs/Glossary/CORS "CORS: CORS (Cross-Origin Resource Sharing) is a system, consisting of transmitting HTTP headers, that determines whether browsers block frontend JavaScript code from accessing responses for cross-origin requests.") checks. To allow error logging for sites which use a separate domain for static media, use this attribute. See [CORS settings attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/CORS_settings_attributes) for a more descriptive explanation of its valid arguments.'
              }
            },
            {
              name: "nonce",
              description: {
                kind: "markdown",
                value: "A cryptographic nonce (number used once) to list the allowed inline scripts in a [script-src Content-Security-Policy](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Content-Security-Policy/script-src). The server must generate a unique nonce value each time it transmits a policy. It is critical to provide a nonce that cannot be guessed as bypassing a resource's policy is otherwise trivial."
              }
            },
            {
              name: "integrity",
              description: "This attribute contains inline metadata that a user agent can use to verify that a fetched resource has been delivered free of unexpected manipulation. See [Subresource Integrity](https://developer.mozilla.org/en-US/docs/Web/Security/Subresource_Integrity)."
            },
            {
              name: "nomodule",
              description: "This Boolean attribute is set to indicate that the script should not be executed in browsers that support [ES2015 modules](https://hacks.mozilla.org/2015/08/es6-in-depth-modules/) \u2014 in effect, this can be used to serve fallback scripts to older browsers that do not support modular JavaScript code."
            },
            {
              name: "referrerpolicy",
              description: 'Indicates which [referrer](https://developer.mozilla.org/en-US/docs/Web/API/Document/referrer) to send when fetching the script, or resources fetched by the script:\n\n*   `no-referrer`: The [`Referer`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer "The Referer request header contains the address of the previous web page from which a link to the currently requested page was followed. The Referer header allows servers to identify where people are visiting them from and may use that data for analytics, logging, or optimized caching, for example.") header will not be sent.\n*   `no-referrer-when-downgrade` (default): The [`Referer`](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Referer "The Referer request header contains the address of the previous web page from which a link to the currently requested page was followed. The Referer header allows servers to identify where people are visiting them from and may use that data for analytics, logging, or optimized caching, for example.") header will not be sent to [origin](https://developer.mozilla.org/en-US/docs/Glossary/origin "origin: Web content\'s origin is defined by the scheme (protocol), host (domain), and port of the URL used to access it. Two objects have the same origin only when the scheme, host, and port all match.")s without [TLS](https://developer.mozilla.org/en-US/docs/Glossary/TLS "TLS: Transport Layer Security (TLS), previously known as Secure Sockets Layer (SSL), is a protocol used by applications to communicate securely across a network, preventing tampering with and eavesdropping on email, web browsing, messaging, and other protocols.") ([HTTPS](https://developer.mozilla.org/en-US/docs/Glossary/HTTPS "HTTPS: HTTPS (HTTP Secure) is an encrypted version of the HTTP protocol. It usually uses SSL or TLS to encrypt all communication between a client and a server. This secure connection allows clients to safely exchange sensitive data with a server, for example for banking activities or online shopping.")).\n*   `origin`: The sent referrer will be limited to the origin of the referring page: its [scheme](https://developer.mozilla.org/en-US/docs/Archive/Mozilla/URIScheme), [host](https://developer.mozilla.org/en-US/docs/Glossary/host "host: A host is a device connected to the Internet (or a local network). Some hosts called servers offer additional services like serving webpages or storing files and emails."), and [port](https://developer.mozilla.org/en-US/docs/Glossary/port "port: For a computer connected to a network with an IP address, a port is a communication endpoint. Ports are designated by numbers, and below 1024 each port is associated by default with a specific protocol.").\n*   `origin-when-cross-origin`: The referrer sent to other origins will be limited to the scheme, the host, and the port. Navigations on the same origin will still include the path.\n*   `same-origin`: A referrer will be sent for [same origin](https://developer.mozilla.org/en-US/docs/Glossary/Same-origin_policy "same origin: The same-origin policy is a critical security mechanism that restricts how a document or script loaded from one origin can interact with a resource from another origin."), but cross-origin requests will contain no referrer information.\n*   `strict-origin`: Only send the origin of the document as the referrer when the protocol security level stays the same (e.g. HTTPS\u2192HTTPS), but don\'t send it to a less secure destination (e.g. HTTPS\u2192HTTP).\n*   `strict-origin-when-cross-origin`: Send a full URL when performing a same-origin request, but only send the origin when the protocol security level stays the same (e.g.HTTPS\u2192HTTPS), and send no header to a less secure destination (e.g. HTTPS\u2192HTTP).\n*   `unsafe-url`: The referrer will include the origin _and_ the path (but not the [fragment](https://developer.mozilla.org/en-US/docs/Web/API/HTMLHyperlinkElementUtils/hash), [password](https://developer.mozilla.org/en-US/docs/Web/API/HTMLHyperlinkElementUtils/password), or [username](https://developer.mozilla.org/en-US/docs/Web/API/HTMLHyperlinkElementUtils/username)). **This value is unsafe**, because it leaks origins and paths from TLS-protected resources to insecure origins.\n\n**Note**: An empty string value (`""`) is both the default value, and a fallback value if `referrerpolicy` is not supported. If `referrerpolicy` is not explicitly specified on the `<script>` element, it will adopt a higher-level referrer policy, i.e. one set on the whole document or domain. If a higher-level policy is not available,\xA0the empty string is treated as being equivalent to `no-referrer-when-downgrade`.'
            },
            {
              name: "text",
              description: "Like the `textContent` attribute, this attribute sets the text content of the element. Unlike the `textContent` attribute, however, this attribute is evaluated as executable code after the node is inserted into the DOM."
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/script"
            }
          ]
        },
        {
          name: "noscript",
          description: {
            kind: "markdown",
            value: "The noscript element represents nothing if scripting is enabled, and represents its children if scripting is disabled. It is used to present different markup to user agents that support scripting and those that don't support scripting, by affecting how the document is parsed."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/noscript"
            }
          ]
        },
        {
          name: "template",
          description: {
            kind: "markdown",
            value: "The template element is used to declare fragments of HTML that can be cloned and inserted in the document by script."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/template"
            }
          ]
        },
        {
          name: "canvas",
          description: {
            kind: "markdown",
            value: "The canvas element provides scripts with a resolution-dependent bitmap canvas, which can be used for rendering graphs, game graphics, art, or other visual images on the fly."
          },
          attributes: [
            {
              name: "width",
              description: {
                kind: "markdown",
                value: "The width of the coordinate space in CSS pixels. Defaults to 300."
              }
            },
            {
              name: "height",
              description: {
                kind: "markdown",
                value: "The height of the coordinate space in CSS pixels. Defaults to 150."
              }
            },
            {
              name: "moz-opaque",
              description: "Lets the canvas know whether or not translucency will be a factor. If the canvas knows there's no translucency, painting performance can be optimized. This is only supported by Mozilla-based browsers; use the standardized [`canvas.getContext('2d', { alpha: false })`](https://developer.mozilla.org/en-US/docs/Web/API/HTMLCanvasElement/getContext \"The HTMLCanvasElement.getContext() method returns a drawing context on the canvas, or null if the context identifier is not supported.\") instead."
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/canvas"
            }
          ]
        },
        {
          name: "slot",
          description: {
            kind: "markdown",
            value: "The slot element is a placeholder inside a web component that you can fill with your own markup, which lets you create separate DOM trees and present them together."
          },
          attributes: [
            {
              name: "name",
              description: {
                kind: "markdown",
                value: "The slot's name.\nA **named slot** is a `<slot>` element with a `name` attribute."
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/slot"
            }
          ]
        },
        {
          name: "data",
          description: {
            kind: "markdown",
            value: "The data element links a given piece of content with a machine-readable translation."
          },
          attributes: [
            {
              name: "value",
              description: {
                kind: "markdown",
                value: "This attribute specifies the machine-readable translation of the content of the element."
              }
            }
          ],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/data"
            }
          ]
        },
        {
          name: "hgroup",
          description: {
            kind: "markdown",
            value: "The hgroup element represents a heading and related content. It groups a single h1\u2013h6 element with one or more p."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/hgroup"
            }
          ]
        },
        {
          name: "menu",
          description: {
            kind: "markdown",
            value: "The menu element represents an unordered list of interactive items."
          },
          attributes: [],
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Element/menu"
            }
          ]
        }
      ],
      globalAttributes: [
        {
          name: "accesskey",
          description: {
            kind: "markdown",
            value: "Provides a hint for generating a keyboard shortcut for the current element. This attribute consists of a space-separated list of characters. The browser should use the first one that exists on the computer keyboard layout."
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/accesskey"
            }
          ]
        },
        {
          name: "autocapitalize",
          description: {
            kind: "markdown",
            value: "Controls whether and how text input is automatically capitalized as it is entered/edited by the user. It can have the following values:\n\n*   `off` or `none`, no autocapitalization is applied (all letters default to lowercase)\n*   `on` or `sentences`, the first letter of each sentence defaults to a capital letter; all other letters default to lowercase\n*   `words`, the first letter of each word defaults to a capital letter; all other letters default to lowercase\n*   `characters`, all letters should default to uppercase"
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/autocapitalize"
            }
          ]
        },
        {
          name: "class",
          description: {
            kind: "markdown",
            value: 'A space-separated list of the classes of the element. Classes allows CSS and JavaScript to select and access specific elements via the [class selectors](https://developer.mozilla.org/docs/Web/CSS/Class_selectors) or functions like the method [`Document.getElementsByClassName()`](https://developer.mozilla.org/docs/Web/API/Document/getElementsByClassName "returns an array-like object of all child elements which have all of the given class names.").'
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/class"
            }
          ]
        },
        {
          name: "contenteditable",
          description: {
            kind: "markdown",
            value: "An enumerated attribute indicating if the element should be editable by the user. If so, the browser modifies its widget to allow editing. The attribute must take one of the following values:\n\n*   `true` or the _empty string_, which indicates that the element must be editable;\n*   `false`, which indicates that the element must not be editable."
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/contenteditable"
            }
          ]
        },
        {
          name: "contextmenu",
          description: {
            kind: "markdown",
            value: 'The `[**id**](#attr-id)` of a [`<menu>`](https://developer.mozilla.org/docs/Web/HTML/Element/menu "The HTML <menu> element represents a group of commands that a user can perform or activate. This includes both list menus, which might appear across the top of a screen, as well as context menus, such as those that might appear underneath a button after it has been clicked.") to use as the contextual menu for this element.'
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/contextmenu"
            }
          ]
        },
        {
          name: "dir",
          description: {
            kind: "markdown",
            value: "An enumerated attribute indicating the directionality of the element's text. It can have the following values:\n\n*   `ltr`, which means _left to right_ and is to be used for languages that are written from the left to the right (like English);\n*   `rtl`, which means _right to left_ and is to be used for languages that are written from the right to the left (like Arabic);\n*   `auto`, which lets the user agent decide. It uses a basic algorithm as it parses the characters inside the element until it finds a character with a strong directionality, then it applies that directionality to the whole element."
          },
          valueSet: "d",
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/dir"
            }
          ]
        },
        {
          name: "draggable",
          description: {
            kind: "markdown",
            value: "An enumerated attribute indicating whether the element can be dragged, using the [Drag and Drop API](https://developer.mozilla.org/docs/DragDrop/Drag_and_Drop). It can have the following values:\n\n*   `true`, which indicates that the element may be dragged\n*   `false`, which indicates that the element may not be dragged."
          },
          valueSet: "b",
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/draggable"
            }
          ]
        },
        {
          name: "dropzone",
          description: {
            kind: "markdown",
            value: "An enumerated attribute indicating what types of content can be dropped on an element, using the [Drag and Drop API](https://developer.mozilla.org/docs/DragDrop/Drag_and_Drop). It can have the following values:\n\n*   `copy`, which indicates that dropping will create a copy of the element that was dragged\n*   `move`, which indicates that the element that was dragged will be moved to this new location.\n*   `link`, will create a link to the dragged data."
          }
        },
        {
          name: "exportparts",
          description: {
            kind: "markdown",
            value: "Used to transitively export shadow parts from a nested shadow tree into a containing light tree."
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/exportparts"
            }
          ]
        },
        {
          name: "hidden",
          description: {
            kind: "markdown",
            value: "A Boolean attribute indicates that the element is not yet, or is no longer, _relevant_. For example, it can be used to hide elements of the page that can't be used until the login process has been completed. The browser won't render such elements. This attribute must not be used to hide content that could legitimately be shown."
          },
          valueSet: "v",
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/hidden"
            }
          ]
        },
        {
          name: "id",
          description: {
            kind: "markdown",
            value: "Defines a unique identifier (ID) which must be unique in the whole document. Its purpose is to identify the element when linking (using a fragment identifier), scripting, or styling (with CSS)."
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/id"
            }
          ]
        },
        {
          name: "inputmode",
          description: {
            kind: "markdown",
            value: 'Provides a hint to browsers as to the type of virtual keyboard configuration to use when editing this element or its contents. Used primarily on [`<input>`](https://developer.mozilla.org/docs/Web/HTML/Element/input "The HTML <input> element is used to create interactive controls for web-based forms in order to accept data from the user; a wide variety of types of input data and control widgets are available, depending on the device and user agent.") elements, but is usable on any element while in `[contenteditable](https://developer.mozilla.org/docs/Web/HTML/Global_attributes#attr-contenteditable)` mode.'
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/inputmode"
            }
          ]
        },
        {
          name: "is",
          description: {
            kind: "markdown",
            value: "Allows you to specify that a standard HTML element should behave like a registered custom built-in element (see [Using custom elements](https://developer.mozilla.org/docs/Web/Web_Components/Using_custom_elements) for more details)."
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/is"
            }
          ]
        },
        {
          name: "itemid",
          description: {
            kind: "markdown",
            value: "The unique, global identifier of an item."
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/itemid"
            }
          ]
        },
        {
          name: "itemprop",
          description: {
            kind: "markdown",
            value: "Used to add properties to an item. Every HTML element may have an `itemprop` attribute specified, where an `itemprop` consists of a name and value pair."
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/itemprop"
            }
          ]
        },
        {
          name: "itemref",
          description: {
            kind: "markdown",
            value: "Properties that are not descendants of an element with the `itemscope` attribute can be associated with the item using an `itemref`. It provides a list of element ids (not `itemid`s) with additional properties elsewhere in the document."
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/itemref"
            }
          ]
        },
        {
          name: "itemscope",
          description: {
            kind: "markdown",
            value: "`itemscope` (usually) works along with `[itemtype](https://developer.mozilla.org/docs/Web/HTML/Global_attributes#attr-itemtype)` to specify that the HTML contained in a block is about a particular item. `itemscope` creates the Item and defines the scope of the `itemtype` associated with it. `itemtype` is a valid URL of a vocabulary (such as [schema.org](https://schema.org/)) that describes the item and its properties context."
          },
          valueSet: "v",
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/itemscope"
            }
          ]
        },
        {
          name: "itemtype",
          description: {
            kind: "markdown",
            value: "Specifies the URL of the vocabulary that will be used to define `itemprop`s (item properties) in the data structure. `[itemscope](https://developer.mozilla.org/docs/Web/HTML/Global_attributes#attr-itemscope)` is used to set the scope of where in the data structure the vocabulary set by `itemtype` will be active."
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/itemtype"
            }
          ]
        },
        {
          name: "lang",
          description: {
            kind: "markdown",
            value: "Helps define the language of an element: the language that non-editable elements are in, or the language that editable elements should be written in by the user. The attribute contains one \u201Clanguage tag\u201D (made of hyphen-separated \u201Clanguage subtags\u201D) in the format defined in [_Tags for Identifying Languages (BCP47)_](https://www.ietf.org/rfc/bcp/bcp47.txt). [**xml:lang**](#attr-xml:lang) has priority over it."
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/lang"
            }
          ]
        },
        {
          name: "part",
          description: {
            kind: "markdown",
            value: 'A space-separated list of the part names of the element. Part names allows CSS to select and style specific elements in a shadow tree via the [`::part`](https://developer.mozilla.org/docs/Web/CSS/::part "The ::part CSS pseudo-element represents any element within a shadow tree that has a matching part attribute.") pseudo-element.'
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/part"
            }
          ]
        },
        {
          name: "role",
          valueSet: "roles"
        },
        {
          name: "slot",
          description: {
            kind: "markdown",
            value: "Assigns a slot in a [shadow DOM](https://developer.mozilla.org/docs/Web/Web_Components/Shadow_DOM) shadow tree to an element: An element with a `slot` attribute is assigned to the slot created by the [`<slot>`](https://developer.mozilla.org/docs/Web/HTML/Element/slot \"The HTML <slot> element\u2014part of the Web Components technology suite\u2014is a placeholder inside a web component that you can fill with your own markup, which lets you create separate DOM trees and present them together.\") element whose `[name](https://developer.mozilla.org/docs/Web/HTML/Element/slot#attr-name)` attribute's value matches that `slot` attribute's value."
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/slot"
            }
          ]
        },
        {
          name: "spellcheck",
          description: {
            kind: "markdown",
            value: "An enumerated attribute defines whether the element may be checked for spelling errors. It may have the following values:\n\n*   `true`, which indicates that the element should be, if possible, checked for spelling errors;\n*   `false`, which indicates that the element should not be checked for spelling errors."
          },
          valueSet: "b",
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/spellcheck"
            }
          ]
        },
        {
          name: "style",
          description: {
            kind: "markdown",
            value: 'Contains [CSS](https://developer.mozilla.org/docs/Web/CSS) styling declarations to be applied to the element. Note that it is recommended for styles to be defined in a separate file or files. This attribute and the [`<style>`](https://developer.mozilla.org/docs/Web/HTML/Element/style "The HTML <style> element contains style information for a document, or part of a document.") element have mainly the purpose of allowing for quick styling, for example for testing purposes.'
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/style"
            }
          ]
        },
        {
          name: "tabindex",
          description: {
            kind: "markdown",
            value: `An integer attribute indicating if the element can take input focus (is _focusable_), if it should participate to sequential keyboard navigation, and if so, at what position. It can take several values:

*   a _negative value_ means that the element should be focusable, but should not be reachable via sequential keyboard navigation;
*   \`0\` means that the element should be focusable and reachable via sequential keyboard navigation, but its relative order is defined by the platform convention;
*   a _positive value_ means that the element should be focusable and reachable via sequential keyboard navigation; the order in which the elements are focused is the increasing value of the [**tabindex**](#attr-tabindex). If several elements share the same tabindex, their relative order follows their relative positions in the document.`
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/tabindex"
            }
          ]
        },
        {
          name: "title",
          description: {
            kind: "markdown",
            value: "Contains a text representing advisory information related to the element it belongs to. Such information can typically, but not necessarily, be presented to the user as a tooltip."
          },
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/title"
            }
          ]
        },
        {
          name: "translate",
          description: {
            kind: "markdown",
            value: "An enumerated attribute that is used to specify whether an element's attribute values and the values of its [`Text`](https://developer.mozilla.org/docs/Web/API/Text \"The Text interface represents the textual content of Element or Attr. If an element has no markup within its content, it has a single child implementing Text that contains the element's text. However, if the element contains markup, it is parsed into information items and Text nodes that form its children.\") node children are to be translated when the page is localized, or whether to leave them unchanged. It can have the following values:\n\n*   empty string and `yes`, which indicates that the element will be translated.\n*   `no`, which indicates that the element will not be translated."
          },
          valueSet: "y",
          references: [
            {
              name: "MDN Reference",
              url: "https://developer.mozilla.org/docs/Web/HTML/Global_attributes/translate"
            }
          ]
        },
        {
          name: "onabort",
          description: {
            kind: "markdown",
            value: "The loading of a resource has been aborted."
          }
        },
        {
          name: "onblur",
          description: {
            kind: "markdown",
            value: "An element has lost focus (does not bubble)."
          }
        },
        {
          name: "oncanplay",
          description: {
            kind: "markdown",
            value: "The user agent can play the media, but estimates that not enough data has been loaded to play the media up to its end without having to stop for further buffering of content."
          }
        },
        {
          name: "oncanplaythrough",
          description: {
            kind: "markdown",
            value: "The user agent can play the media up to its end without having to stop for further buffering of content."
          }
        },
        {
          name: "onchange",
          description: {
            kind: "markdown",
            value: "The change event is fired for <input>, <select>, and <textarea> elements when a change to the element's value is committed by the user."
          }
        },
        {
          name: "onclick",
          description: {
            kind: "markdown",
            value: "A pointing device button has been pressed and released on an element."
          }
        },
        {
          name: "oncontextmenu",
          description: {
            kind: "markdown",
            value: "The right button of the mouse is clicked (before the context menu is displayed)."
          }
        },
        {
          name: "ondblclick",
          description: {
            kind: "markdown",
            value: "A pointing device button is clicked twice on an element."
          }
        },
        {
          name: "ondrag",
          description: {
            kind: "markdown",
            value: "An element or text selection is being dragged (every 350ms)."
          }
        },
        {
          name: "ondragend",
          description: {
            kind: "markdown",
            value: "A drag operation is being ended (by releasing a mouse button or hitting the escape key)."
          }
        },
        {
          name: "ondragenter",
          description: {
            kind: "markdown",
            value: "A dragged element or text selection enters a valid drop target."
          }
        },
        {
          name: "ondragleave",
          description: {
            kind: "markdown",
            value: "A dragged element or text selection leaves a valid drop target."
          }
        },
        {
          name: "ondragover",
          description: {
            kind: "markdown",
            value: "An element or text selection is being dragged over a valid drop target (every 350ms)."
          }
        },
        {
          name: "ondragstart",
          description: {
            kind: "markdown",
            value: "The user starts dragging an element or text selection."
          }
        },
        {
          name: "ondrop",
          description: {
            kind: "markdown",
            value: "An element is dropped on a valid drop target."
          }
        },
        {
          name: "ondurationchange",
          description: {
            kind: "markdown",
            value: "The duration attribute has been updated."
          }
        },
        {
          name: "onemptied",
          description: {
            kind: "markdown",
            value: "The media has become empty; for example, this event is sent if the media has already been loaded (or partially loaded), and the load() method is called to reload it."
          }
        },
        {
          name: "onended",
          description: {
            kind: "markdown",
            value: "Playback has stopped because the end of the media was reached."
          }
        },
        {
          name: "onerror",
          description: {
            kind: "markdown",
            value: "A resource failed to load."
          }
        },
        {
          name: "onfocus",
          description: {
            kind: "markdown",
            value: "An element has received focus (does not bubble)."
          }
        },
        {
          name: "onformchange"
        },
        {
          name: "onforminput"
        },
        {
          name: "oninput",
          description: {
            kind: "markdown",
            value: "The value of an element changes or the content of an element with the attribute contenteditable is modified."
          }
        },
        {
          name: "oninvalid",
          description: {
            kind: "markdown",
            value: "A submittable element has been checked and doesn't satisfy its constraints."
          }
        },
        {
          name: "onkeydown",
          description: {
            kind: "markdown",
            value: "A key is pressed down."
          }
        },
        {
          name: "onkeypress",
          description: {
            kind: "markdown",
            value: "A key is pressed down and that key normally produces a character value (use input instead)."
          }
        },
        {
          name: "onkeyup",
          description: {
            kind: "markdown",
            value: "A key is released."
          }
        },
        {
          name: "onload",
          description: {
            kind: "markdown",
            value: "A resource and its dependent resources have finished loading."
          }
        },
        {
          name: "onloadeddata",
          description: {
            kind: "markdown",
            value: "The first frame of the media has finished loading."
          }
        },
        {
          name: "onloadedmetadata",
          description: {
            kind: "markdown",
            value: "The metadata has been loaded."
          }
        },
        {
          name: "onloadstart",
          description: {
            kind: "markdown",
            value: "Progress has begun."
          }
        },
        {
          name: "onmousedown",
          description: {
            kind: "markdown",
            value: "A pointing device button (usually a mouse) is pressed on an element."
          }
        },
        {
          name: "onmousemove",
          description: {
            kind: "markdown",
            value: "A pointing device is moved over an element."
          }
        },
        {
          name: "onmouseout",
          description: {
            kind: "markdown",
            value: "A pointing device is moved off the element that has the listener attached or off one of its children."
          }
        },
        {
          name: "onmouseover",
          description: {
            kind: "markdown",
            value: "A pointing device is moved onto the element that has the listener attached or onto one of its children."
          }
        },
        {
          name: "onmouseup",
          description: {
            kind: "markdown",
            value: "A pointing device button is released over an element."
          }
        },
        {
          name: "onmousewheel"
        },
        {
          name: "onmouseenter",
          description: {
            kind: "markdown",
            value: "A pointing device is moved onto the element that has the listener attached."
          }
        },
        {
          name: "onmouseleave",
          description: {
            kind: "markdown",
            value: "A pointing device is moved off the element that has the listener attached."
          }
        },
        {
          name: "onpause",
          description: {
            kind: "markdown",
            value: "Playback has been paused."
          }
        },
        {
          name: "onplay",
          description: {
            kind: "markdown",
            value: "Playback has begun."
          }
        },
        {
          name: "onplaying",
          description: {
            kind: "markdown",
            value: "Playback is ready to start after having been paused or delayed due to lack of data."
          }
        },
        {
          name: "onprogress",
          description: {
            kind: "markdown",
            value: "In progress."
          }
        },
        {
          name: "onratechange",
          description: {
            kind: "markdown",
            value: "The playback rate has changed."
          }
        },
        {
          name: "onreset",
          description: {
            kind: "markdown",
            value: "A form is reset."
          }
        },
        {
          name: "onresize",
          description: {
            kind: "markdown",
            value: "The document view has been resized."
          }
        },
        {
          name: "onreadystatechange",
          description: {
            kind: "markdown",
            value: "The readyState attribute of a document has changed."
          }
        },
        {
          name: "onscroll",
          description: {
            kind: "markdown",
            value: "The document view or an element has been scrolled."
          }
        },
        {
          name: "onseeked",
          description: {
            kind: "markdown",
            value: "A seek operation completed."
          }
        },
        {
          name: "onseeking",
          description: {
            kind: "markdown",
            value: "A seek operation began."
          }
        },
        {
          name: "onselect",
          description: {
            kind: "markdown",
            value: "Some text is being selected."
          }
        },
        {
          name: "onshow",
          description: {
            kind: "markdown",
            value: "A contextmenu event was fired on/bubbled to an element that has a contextmenu attribute"
          }
        },
        {
          name: "onstalled",
          description: {
            kind: "markdown",
            value: "The user agent is trying to fetch media data, but data is unexpectedly not forthcoming."
          }
        },
        {
          name: "onsubmit",
          description: {
            kind: "markdown",
            value: "A form is submitted."
          }
        },
        {
          name: "onsuspend",
          description: {
            kind: "markdown",
            value: "Media data loading has been suspended."
          }
        },
        {
          name: "ontimeupdate",
          description: {
            kind: "markdown",
            value: "The time indicated by the currentTime attribute has been updated."
          }
        },
        {
          name: "onvolumechange",
          description: {
            kind: "markdown",
            value: "The volume has changed."
          }
        },
        {
          name: "onwaiting",
          description: {
            kind: "markdown",
            value: "Playback has stopped because of a temporary lack of data."
          }
        },
        {
          name: "onpointercancel",
          description: {
            kind: "markdown",
            value: "The pointer is unlikely to produce any more events."
          }
        },
        {
          name: "onpointerdown",
          description: {
            kind: "markdown",
            value: "The pointer enters the active buttons state."
          }
        },
        {
          name: "onpointerenter",
          description: {
            kind: "markdown",
            value: "Pointing device is moved inside the hit-testing boundary."
          }
        },
        {
          name: "onpointerleave",
          description: {
            kind: "markdown",
            value: "Pointing device is moved out of the hit-testing boundary."
          }
        },
        {
          name: "onpointerlockchange",
          description: {
            kind: "markdown",
            value: "The pointer was locked or released."
          }
        },
        {
          name: "onpointerlockerror",
          description: {
            kind: "markdown",
            value: "It was impossible to lock the pointer for technical reasons or because the permission was denied."
          }
        },
        {
          name: "onpointermove",
          description: {
            kind: "markdown",
            value: "The pointer changed coordinates."
          }
        },
        {
          name: "onpointerout",
          description: {
            kind: "markdown",
            value: "The pointing device moved out of hit-testing boundary or leaves detectable hover range."
          }
        },
        {
          name: "onpointerover",
          description: {
            kind: "markdown",
            value: "The pointing device is moved into the hit-testing boundary."
          }
        },
        {
          name: "onpointerup",
          description: {
            kind: "markdown",
            value: "The pointer leaves the active buttons state."
          }
        },
        {
          name: "aria-activedescendant",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-activedescendant"
            }
          ],
          description: {
            kind: "markdown",
            value: "Identifies the currently active element when DOM focus is on a [`composite`](https://www.w3.org/TR/wai-aria-1.1/#composite) widget, [`textbox`](https://www.w3.org/TR/wai-aria-1.1/#textbox), [`group`](https://www.w3.org/TR/wai-aria-1.1/#group), or [`application`](https://www.w3.org/TR/wai-aria-1.1/#application)."
          }
        },
        {
          name: "aria-atomic",
          valueSet: "b",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-atomic"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates whether [assistive technologies](https://www.w3.org/TR/wai-aria-1.1/#dfn-assistive-technology) will present all, or only parts of, the changed region based on the change notifications defined by the [`aria-relevant`](https://www.w3.org/TR/wai-aria-1.1/#aria-relevant) attribute."
          }
        },
        {
          name: "aria-autocomplete",
          valueSet: "autocomplete",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-autocomplete"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates whether inputting text could trigger display of one or more predictions of the user's intended value for an input and specifies how predictions would be presented if they are made."
          }
        },
        {
          name: "aria-busy",
          valueSet: "b",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-busy"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates an element is being modified and that assistive technologies _MAY_ want to wait until the modifications are complete before exposing them to the user."
          }
        },
        {
          name: "aria-checked",
          valueSet: "tristate",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-checked"
            }
          ],
          description: {
            kind: "markdown",
            value: 'Indicates the current "checked" [state](https://www.w3.org/TR/wai-aria-1.1/#dfn-state) of checkboxes, radio buttons, and other [widgets](https://www.w3.org/TR/wai-aria-1.1/#dfn-widget). See related [`aria-pressed`](https://www.w3.org/TR/wai-aria-1.1/#aria-pressed) and [`aria-selected`](https://www.w3.org/TR/wai-aria-1.1/#aria-selected).'
          }
        },
        {
          name: "aria-colcount",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-colcount"
            }
          ],
          description: {
            kind: "markdown",
            value: "Defines the total number of columns in a [`table`](https://www.w3.org/TR/wai-aria-1.1/#table), [`grid`](https://www.w3.org/TR/wai-aria-1.1/#grid), or [`treegrid`](https://www.w3.org/TR/wai-aria-1.1/#treegrid). See related [`aria-colindex`](https://www.w3.org/TR/wai-aria-1.1/#aria-colindex)."
          }
        },
        {
          name: "aria-colindex",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-colindex"
            }
          ],
          description: {
            kind: "markdown",
            value: "Defines an [element's](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) column index or position with respect to the total number of columns within a [`table`](https://www.w3.org/TR/wai-aria-1.1/#table), [`grid`](https://www.w3.org/TR/wai-aria-1.1/#grid), or [`treegrid`](https://www.w3.org/TR/wai-aria-1.1/#treegrid). See related [`aria-colcount`](https://www.w3.org/TR/wai-aria-1.1/#aria-colcount) and [`aria-colspan`](https://www.w3.org/TR/wai-aria-1.1/#aria-colspan)."
          }
        },
        {
          name: "aria-colspan",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-colspan"
            }
          ],
          description: {
            kind: "markdown",
            value: "Defines the number of columns spanned by a cell or gridcell within a [`table`](https://www.w3.org/TR/wai-aria-1.1/#table), [`grid`](https://www.w3.org/TR/wai-aria-1.1/#grid), or [`treegrid`](https://www.w3.org/TR/wai-aria-1.1/#treegrid). See related [`aria-colindex`](https://www.w3.org/TR/wai-aria-1.1/#aria-colindex) and [`aria-rowspan`](https://www.w3.org/TR/wai-aria-1.1/#aria-rowspan)."
          }
        },
        {
          name: "aria-controls",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-controls"
            }
          ],
          description: {
            kind: "markdown",
            value: "Identifies the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) (or elements) whose contents or presence are controlled by the current element. See related [`aria-owns`](https://www.w3.org/TR/wai-aria-1.1/#aria-owns)."
          }
        },
        {
          name: "aria-current",
          valueSet: "current",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-current"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) that represents the current item within a container or set of related elements."
          }
        },
        {
          name: "aria-describedby",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-describedby"
            }
          ],
          description: {
            kind: "markdown",
            value: "Identifies the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) (or elements) that describes the [object](https://www.w3.org/TR/wai-aria-1.1/#dfn-object). See related [`aria-labelledby`](https://www.w3.org/TR/wai-aria-1.1/#aria-labelledby)."
          }
        },
        {
          name: "aria-disabled",
          valueSet: "b",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-disabled"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates that the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) is [perceivable](https://www.w3.org/TR/wai-aria-1.1/#dfn-perceivable) but disabled, so it is not editable or otherwise [operable](https://www.w3.org/TR/wai-aria-1.1/#dfn-operable). See related [`aria-hidden`](https://www.w3.org/TR/wai-aria-1.1/#aria-hidden) and [`aria-readonly`](https://www.w3.org/TR/wai-aria-1.1/#aria-readonly)."
          }
        },
        {
          name: "aria-dropeffect",
          valueSet: "dropeffect",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-dropeffect"
            }
          ],
          description: {
            kind: "markdown",
            value: "\\[Deprecated in ARIA 1.1\\] Indicates what functions can be performed when a dragged object is released on the drop target."
          }
        },
        {
          name: "aria-errormessage",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-errormessage"
            }
          ],
          description: {
            kind: "markdown",
            value: "Identifies the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) that provides an error message for the [object](https://www.w3.org/TR/wai-aria-1.1/#dfn-object). See related [`aria-invalid`](https://www.w3.org/TR/wai-aria-1.1/#aria-invalid) and [`aria-describedby`](https://www.w3.org/TR/wai-aria-1.1/#aria-describedby)."
          }
        },
        {
          name: "aria-expanded",
          valueSet: "u",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-expanded"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates whether the element, or another grouping element it controls, is currently expanded or collapsed."
          }
        },
        {
          name: "aria-flowto",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-flowto"
            }
          ],
          description: {
            kind: "markdown",
            value: "Identifies the next [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) (or elements) in an alternate reading order of content which, at the user's discretion, allows assistive technology to override the general default of reading in document source order."
          }
        },
        {
          name: "aria-grabbed",
          valueSet: "u",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-grabbed"
            }
          ],
          description: {
            kind: "markdown",
            value: `\\[Deprecated in ARIA 1.1\\] Indicates an element's "grabbed" [state](https://www.w3.org/TR/wai-aria-1.1/#dfn-state) in a drag-and-drop operation.`
          }
        },
        {
          name: "aria-haspopup",
          valueSet: "haspopup",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-haspopup"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates the availability and type of interactive popup element, such as menu or dialog, that can be triggered by an [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element)."
          }
        },
        {
          name: "aria-hidden",
          valueSet: "b",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-hidden"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates whether the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) is exposed to an accessibility API. See related [`aria-disabled`](https://www.w3.org/TR/wai-aria-1.1/#aria-disabled)."
          }
        },
        {
          name: "aria-invalid",
          valueSet: "invalid",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-invalid"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates the entered value does not conform to the format expected by the application. See related [`aria-errormessage`](https://www.w3.org/TR/wai-aria-1.1/#aria-errormessage)."
          }
        },
        {
          name: "aria-label",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-label"
            }
          ],
          description: {
            kind: "markdown",
            value: "Defines a string value that labels the current element. See related [`aria-labelledby`](https://www.w3.org/TR/wai-aria-1.1/#aria-labelledby)."
          }
        },
        {
          name: "aria-labelledby",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-labelledby"
            }
          ],
          description: {
            kind: "markdown",
            value: "Identifies the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) (or elements) that labels the current element. See related [`aria-describedby`](https://www.w3.org/TR/wai-aria-1.1/#aria-describedby)."
          }
        },
        {
          name: "aria-level",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-level"
            }
          ],
          description: {
            kind: "markdown",
            value: "Defines the hierarchical level of an [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) within a structure."
          }
        },
        {
          name: "aria-live",
          valueSet: "live",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-live"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates that an [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) will be updated, and describes the types of updates the [user agents](https://www.w3.org/TR/wai-aria-1.1/#dfn-user-agent), [assistive technologies](https://www.w3.org/TR/wai-aria-1.1/#dfn-assistive-technology), and user can expect from the [live region](https://www.w3.org/TR/wai-aria-1.1/#dfn-live-region)."
          }
        },
        {
          name: "aria-modal",
          valueSet: "b",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-modal"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates whether an [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) is modal when displayed."
          }
        },
        {
          name: "aria-multiline",
          valueSet: "b",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-multiline"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates whether a text box accepts multiple lines of input or only a single line."
          }
        },
        {
          name: "aria-multiselectable",
          valueSet: "b",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-multiselectable"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates that the user may select more than one item from the current selectable descendants."
          }
        },
        {
          name: "aria-orientation",
          valueSet: "orientation",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-orientation"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates whether the element's orientation is horizontal, vertical, or unknown/ambiguous."
          }
        },
        {
          name: "aria-owns",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-owns"
            }
          ],
          description: {
            kind: "markdown",
            value: "Identifies an [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) (or elements) in order to define a visual, functional, or contextual parent/child [relationship](https://www.w3.org/TR/wai-aria-1.1/#dfn-relationship) between DOM elements where the DOM hierarchy cannot be used to represent the relationship. See related [`aria-controls`](https://www.w3.org/TR/wai-aria-1.1/#aria-controls)."
          }
        },
        {
          name: "aria-placeholder",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-placeholder"
            }
          ],
          description: {
            kind: "markdown",
            value: "Defines a short hint (a word or short phrase) intended to aid the user with data entry when the control has no value. A hint could be a sample value or a brief description of the expected format."
          }
        },
        {
          name: "aria-posinset",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-posinset"
            }
          ],
          description: {
            kind: "markdown",
            value: "Defines an [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element)'s number or position in the current set of listitems or treeitems. Not required if all elements in the set are present in the DOM. See related [`aria-setsize`](https://www.w3.org/TR/wai-aria-1.1/#aria-setsize)."
          }
        },
        {
          name: "aria-pressed",
          valueSet: "tristate",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-pressed"
            }
          ],
          description: {
            kind: "markdown",
            value: 'Indicates the current "pressed" [state](https://www.w3.org/TR/wai-aria-1.1/#dfn-state) of toggle buttons. See related [`aria-checked`](https://www.w3.org/TR/wai-aria-1.1/#aria-checked) and [`aria-selected`](https://www.w3.org/TR/wai-aria-1.1/#aria-selected).'
          }
        },
        {
          name: "aria-readonly",
          valueSet: "b",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-readonly"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates that the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) is not editable, but is otherwise [operable](https://www.w3.org/TR/wai-aria-1.1/#dfn-operable). See related [`aria-disabled`](https://www.w3.org/TR/wai-aria-1.1/#aria-disabled)."
          }
        },
        {
          name: "aria-relevant",
          valueSet: "relevant",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-relevant"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates what notifications the user agent will trigger when the accessibility tree within a live region is modified. See related [`aria-atomic`](https://www.w3.org/TR/wai-aria-1.1/#aria-atomic)."
          }
        },
        {
          name: "aria-required",
          valueSet: "b",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-required"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates that user input is required on the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) before a form may be submitted."
          }
        },
        {
          name: "aria-roledescription",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-roledescription"
            }
          ],
          description: {
            kind: "markdown",
            value: "Defines a human-readable, author-localized description for the [role](https://www.w3.org/TR/wai-aria-1.1/#dfn-role) of an [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element)."
          }
        },
        {
          name: "aria-rowcount",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-rowcount"
            }
          ],
          description: {
            kind: "markdown",
            value: "Defines the total number of rows in a [`table`](https://www.w3.org/TR/wai-aria-1.1/#table), [`grid`](https://www.w3.org/TR/wai-aria-1.1/#grid), or [`treegrid`](https://www.w3.org/TR/wai-aria-1.1/#treegrid). See related [`aria-rowindex`](https://www.w3.org/TR/wai-aria-1.1/#aria-rowindex)."
          }
        },
        {
          name: "aria-rowindex",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-rowindex"
            }
          ],
          description: {
            kind: "markdown",
            value: "Defines an [element's](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) row index or position with respect to the total number of rows within a [`table`](https://www.w3.org/TR/wai-aria-1.1/#table), [`grid`](https://www.w3.org/TR/wai-aria-1.1/#grid), or [`treegrid`](https://www.w3.org/TR/wai-aria-1.1/#treegrid). See related [`aria-rowcount`](https://www.w3.org/TR/wai-aria-1.1/#aria-rowcount) and [`aria-rowspan`](https://www.w3.org/TR/wai-aria-1.1/#aria-rowspan)."
          }
        },
        {
          name: "aria-rowspan",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-rowspan"
            }
          ],
          description: {
            kind: "markdown",
            value: "Defines the number of rows spanned by a cell or gridcell within a [`table`](https://www.w3.org/TR/wai-aria-1.1/#table), [`grid`](https://www.w3.org/TR/wai-aria-1.1/#grid), or [`treegrid`](https://www.w3.org/TR/wai-aria-1.1/#treegrid). See related [`aria-rowindex`](https://www.w3.org/TR/wai-aria-1.1/#aria-rowindex) and [`aria-colspan`](https://www.w3.org/TR/wai-aria-1.1/#aria-colspan)."
          }
        },
        {
          name: "aria-selected",
          valueSet: "u",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-selected"
            }
          ],
          description: {
            kind: "markdown",
            value: 'Indicates the current "selected" [state](https://www.w3.org/TR/wai-aria-1.1/#dfn-state) of various [widgets](https://www.w3.org/TR/wai-aria-1.1/#dfn-widget). See related [`aria-checked`](https://www.w3.org/TR/wai-aria-1.1/#aria-checked) and [`aria-pressed`](https://www.w3.org/TR/wai-aria-1.1/#aria-pressed).'
          }
        },
        {
          name: "aria-setsize",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-setsize"
            }
          ],
          description: {
            kind: "markdown",
            value: "Defines the number of items in the current set of listitems or treeitems. Not required if all elements in the set are present in the DOM. See related [`aria-posinset`](https://www.w3.org/TR/wai-aria-1.1/#aria-posinset)."
          }
        },
        {
          name: "aria-sort",
          valueSet: "sort",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-sort"
            }
          ],
          description: {
            kind: "markdown",
            value: "Indicates if items in a table or grid are sorted in ascending or descending order."
          }
        },
        {
          name: "aria-valuemax",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-valuemax"
            }
          ],
          description: {
            kind: "markdown",
            value: "Defines the maximum allowed value for a range [widget](https://www.w3.org/TR/wai-aria-1.1/#dfn-widget)."
          }
        },
        {
          name: "aria-valuemin",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-valuemin"
            }
          ],
          description: {
            kind: "markdown",
            value: "Defines the minimum allowed value for a range [widget](https://www.w3.org/TR/wai-aria-1.1/#dfn-widget)."
          }
        },
        {
          name: "aria-valuenow",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-valuenow"
            }
          ],
          description: {
            kind: "markdown",
            value: "Defines the current value for a range [widget](https://www.w3.org/TR/wai-aria-1.1/#dfn-widget). See related [`aria-valuetext`](https://www.w3.org/TR/wai-aria-1.1/#aria-valuetext)."
          }
        },
        {
          name: "aria-valuetext",
          references: [
            {
              name: "WAI-ARIA Reference",
              url: "https://www.w3.org/TR/wai-aria-1.1/#aria-valuetext"
            }
          ],
          description: {
            kind: "markdown",
            value: "Defines the human readable text alternative of [`aria-valuenow`](https://www.w3.org/TR/wai-aria-1.1/#aria-valuenow) for a range [widget](https://www.w3.org/TR/wai-aria-1.1/#dfn-widget)."
          }
        },
        {
          name: "aria-details",
          description: {
            kind: "markdown",
            value: "Identifies the [element](https://www.w3.org/TR/wai-aria-1.1/#dfn-element) that provides a detailed, extended description for the [object](https://www.w3.org/TR/wai-aria-1.1/#dfn-object). See related [`aria-describedby`](https://www.w3.org/TR/wai-aria-1.1/#aria-describedby)."
          }
        },
        {
          name: "aria-keyshortcuts",
          description: {
            kind: "markdown",
            value: "Indicates keyboard shortcuts that an author has implemented to activate or give focus to an element."
          }
        }
      ],
      valueSets: [
        {
          name: "b",
          values: [
            {
              name: "true"
            },
            {
              name: "false"
            }
          ]
        },
        {
          name: "u",
          values: [
            {
              name: "true"
            },
            {
              name: "false"
            },
            {
              name: "undefined"
            }
          ]
        },
        {
          name: "o",
          values: [
            {
              name: "on"
            },
            {
              name: "off"
            }
          ]
        },
        {
          name: "y",
          values: [
            {
              name: "yes"
            },
            {
              name: "no"
            }
          ]
        },
        {
          name: "w",
          values: [
            {
              name: "soft"
            },
            {
              name: "hard"
            }
          ]
        },
        {
          name: "d",
          values: [
            {
              name: "ltr"
            },
            {
              name: "rtl"
            },
            {
              name: "auto"
            }
          ]
        },
        {
          name: "m",
          values: [
            {
              name: "get",
              description: {
                kind: "markdown",
                value: "Corresponds to the HTTP [GET method](https://www.w3.org/Protocols/rfc2616/rfc2616-sec9.html#sec9.3); form data are appended to the `action` attribute URI with a '?' as separator, and the resulting URI is sent to the server. Use this method when the form has no side-effects and contains only ASCII characters."
              }
            },
            {
              name: "post",
              description: {
                kind: "markdown",
                value: "Corresponds to the HTTP [POST method](https://www.w3.org/Protocols/rfc2616/rfc2616-sec9.html#sec9.5); form data are included in the body of the form and sent to the server."
              }
            },
            {
              name: "dialog",
              description: {
                kind: "markdown",
                value: "Use when the form is inside a [`<dialog>`](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/dialog) element to close the dialog when submitted."
              }
            }
          ]
        },
        {
          name: "fm",
          values: [
            {
              name: "get"
            },
            {
              name: "post"
            }
          ]
        },
        {
          name: "s",
          values: [
            {
              name: "row"
            },
            {
              name: "col"
            },
            {
              name: "rowgroup"
            },
            {
              name: "colgroup"
            }
          ]
        },
        {
          name: "t",
          values: [
            {
              name: "hidden"
            },
            {
              name: "text"
            },
            {
              name: "search"
            },
            {
              name: "tel"
            },
            {
              name: "url"
            },
            {
              name: "email"
            },
            {
              name: "password"
            },
            {
              name: "datetime"
            },
            {
              name: "date"
            },
            {
              name: "month"
            },
            {
              name: "week"
            },
            {
              name: "time"
            },
            {
              name: "datetime-local"
            },
            {
              name: "number"
            },
            {
              name: "range"
            },
            {
              name: "color"
            },
            {
              name: "checkbox"
            },
            {
              name: "radio"
            },
            {
              name: "file"
            },
            {
              name: "submit"
            },
            {
              name: "image"
            },
            {
              name: "reset"
            },
            {
              name: "button"
            }
          ]
        },
        {
          name: "im",
          values: [
            {
              name: "verbatim"
            },
            {
              name: "latin"
            },
            {
              name: "latin-name"
            },
            {
              name: "latin-prose"
            },
            {
              name: "full-width-latin"
            },
            {
              name: "kana"
            },
            {
              name: "kana-name"
            },
            {
              name: "katakana"
            },
            {
              name: "numeric"
            },
            {
              name: "tel"
            },
            {
              name: "email"
            },
            {
              name: "url"
            }
          ]
        },
        {
          name: "bt",
          values: [
            {
              name: "button"
            },
            {
              name: "submit"
            },
            {
              name: "reset"
            },
            {
              name: "menu"
            }
          ]
        },
        {
          name: "lt",
          values: [
            {
              name: "1"
            },
            {
              name: "a"
            },
            {
              name: "A"
            },
            {
              name: "i"
            },
            {
              name: "I"
            }
          ]
        },
        {
          name: "mt",
          values: [
            {
              name: "context"
            },
            {
              name: "toolbar"
            }
          ]
        },
        {
          name: "mit",
          values: [
            {
              name: "command"
            },
            {
              name: "checkbox"
            },
            {
              name: "radio"
            }
          ]
        },
        {
          name: "et",
          values: [
            {
              name: "application/x-www-form-urlencoded"
            },
            {
              name: "multipart/form-data"
            },
            {
              name: "text/plain"
            }
          ]
        },
        {
          name: "tk",
          values: [
            {
              name: "subtitles"
            },
            {
              name: "captions"
            },
            {
              name: "descriptions"
            },
            {
              name: "chapters"
            },
            {
              name: "metadata"
            }
          ]
        },
        {
          name: "pl",
          values: [
            {
              name: "none"
            },
            {
              name: "metadata"
            },
            {
              name: "auto"
            }
          ]
        },
        {
          name: "sh",
          values: [
            {
              name: "circle"
            },
            {
              name: "default"
            },
            {
              name: "poly"
            },
            {
              name: "rect"
            }
          ]
        },
        {
          name: "xo",
          values: [
            {
              name: "anonymous"
            },
            {
              name: "use-credentials"
            }
          ]
        },
        {
          name: "target",
          values: [
            {
              name: "_self"
            },
            {
              name: "_blank"
            },
            {
              name: "_parent"
            },
            {
              name: "_top"
            }
          ]
        },
        {
          name: "sb",
          values: [
            {
              name: "allow-forms"
            },
            {
              name: "allow-modals"
            },
            {
              name: "allow-pointer-lock"
            },
            {
              name: "allow-popups"
            },
            {
              name: "allow-popups-to-escape-sandbox"
            },
            {
              name: "allow-same-origin"
            },
            {
              name: "allow-scripts"
            },
            {
              name: "allow-top-navigation"
            }
          ]
        },
        {
          name: "tristate",
          values: [
            {
              name: "true"
            },
            {
              name: "false"
            },
            {
              name: "mixed"
            },
            {
              name: "undefined"
            }
          ]
        },
        {
          name: "inputautocomplete",
          values: [
            {
              name: "additional-name"
            },
            {
              name: "address-level1"
            },
            {
              name: "address-level2"
            },
            {
              name: "address-level3"
            },
            {
              name: "address-level4"
            },
            {
              name: "address-line1"
            },
            {
              name: "address-line2"
            },
            {
              name: "address-line3"
            },
            {
              name: "bday"
            },
            {
              name: "bday-year"
            },
            {
              name: "bday-day"
            },
            {
              name: "bday-month"
            },
            {
              name: "billing"
            },
            {
              name: "cc-additional-name"
            },
            {
              name: "cc-csc"
            },
            {
              name: "cc-exp"
            },
            {
              name: "cc-exp-month"
            },
            {
              name: "cc-exp-year"
            },
            {
              name: "cc-family-name"
            },
            {
              name: "cc-given-name"
            },
            {
              name: "cc-name"
            },
            {
              name: "cc-number"
            },
            {
              name: "cc-type"
            },
            {
              name: "country"
            },
            {
              name: "country-name"
            },
            {
              name: "current-password"
            },
            {
              name: "email"
            },
            {
              name: "family-name"
            },
            {
              name: "fax"
            },
            {
              name: "given-name"
            },
            {
              name: "home"
            },
            {
              name: "honorific-prefix"
            },
            {
              name: "honorific-suffix"
            },
            {
              name: "impp"
            },
            {
              name: "language"
            },
            {
              name: "mobile"
            },
            {
              name: "name"
            },
            {
              name: "new-password"
            },
            {
              name: "nickname"
            },
            {
              name: "off"
            },
            {
              name: "on"
            },
            {
              name: "organization"
            },
            {
              name: "organization-title"
            },
            {
              name: "pager"
            },
            {
              name: "photo"
            },
            {
              name: "postal-code"
            },
            {
              name: "sex"
            },
            {
              name: "shipping"
            },
            {
              name: "street-address"
            },
            {
              name: "tel-area-code"
            },
            {
              name: "tel"
            },
            {
              name: "tel-country-code"
            },
            {
              name: "tel-extension"
            },
            {
              name: "tel-local"
            },
            {
              name: "tel-local-prefix"
            },
            {
              name: "tel-local-suffix"
            },
            {
              name: "tel-national"
            },
            {
              name: "transaction-amount"
            },
            {
              name: "transaction-currency"
            },
            {
              name: "url"
            },
            {
              name: "username"
            },
            {
              name: "work"
            }
          ]
        },
        {
          name: "autocomplete",
          values: [
            {
              name: "inline"
            },
            {
              name: "list"
            },
            {
              name: "both"
            },
            {
              name: "none"
            }
          ]
        },
        {
          name: "current",
          values: [
            {
              name: "page"
            },
            {
              name: "step"
            },
            {
              name: "location"
            },
            {
              name: "date"
            },
            {
              name: "time"
            },
            {
              name: "true"
            },
            {
              name: "false"
            }
          ]
        },
        {
          name: "dropeffect",
          values: [
            {
              name: "copy"
            },
            {
              name: "move"
            },
            {
              name: "link"
            },
            {
              name: "execute"
            },
            {
              name: "popup"
            },
            {
              name: "none"
            }
          ]
        },
        {
          name: "invalid",
          values: [
            {
              name: "grammar"
            },
            {
              name: "false"
            },
            {
              name: "spelling"
            },
            {
              name: "true"
            }
          ]
        },
        {
          name: "live",
          values: [
            {
              name: "off"
            },
            {
              name: "polite"
            },
            {
              name: "assertive"
            }
          ]
        },
        {
          name: "orientation",
          values: [
            {
              name: "vertical"
            },
            {
              name: "horizontal"
            },
            {
              name: "undefined"
            }
          ]
        },
        {
          name: "relevant",
          values: [
            {
              name: "additions"
            },
            {
              name: "removals"
            },
            {
              name: "text"
            },
            {
              name: "all"
            },
            {
              name: "additions text"
            }
          ]
        },
        {
          name: "sort",
          values: [
            {
              name: "ascending"
            },
            {
              name: "descending"
            },
            {
              name: "none"
            },
            {
              name: "other"
            }
          ]
        },
        {
          name: "roles",
          values: [
            {
              name: "alert"
            },
            {
              name: "alertdialog"
            },
            {
              name: "button"
            },
            {
              name: "checkbox"
            },
            {
              name: "dialog"
            },
            {
              name: "gridcell"
            },
            {
              name: "link"
            },
            {
              name: "log"
            },
            {
              name: "marquee"
            },
            {
              name: "menuitem"
            },
            {
              name: "menuitemcheckbox"
            },
            {
              name: "menuitemradio"
            },
            {
              name: "option"
            },
            {
              name: "progressbar"
            },
            {
              name: "radio"
            },
            {
              name: "scrollbar"
            },
            {
              name: "searchbox"
            },
            {
              name: "slider"
            },
            {
              name: "spinbutton"
            },
            {
              name: "status"
            },
            {
              name: "switch"
            },
            {
              name: "tab"
            },
            {
              name: "tabpanel"
            },
            {
              name: "textbox"
            },
            {
              name: "timer"
            },
            {
              name: "tooltip"
            },
            {
              name: "treeitem"
            },
            {
              name: "combobox"
            },
            {
              name: "grid"
            },
            {
              name: "listbox"
            },
            {
              name: "menu"
            },
            {
              name: "menubar"
            },
            {
              name: "radiogroup"
            },
            {
              name: "tablist"
            },
            {
              name: "tree"
            },
            {
              name: "treegrid"
            },
            {
              name: "application"
            },
            {
              name: "article"
            },
            {
              name: "cell"
            },
            {
              name: "columnheader"
            },
            {
              name: "definition"
            },
            {
              name: "directory"
            },
            {
              name: "document"
            },
            {
              name: "feed"
            },
            {
              name: "figure"
            },
            {
              name: "group"
            },
            {
              name: "heading"
            },
            {
              name: "img"
            },
            {
              name: "list"
            },
            {
              name: "listitem"
            },
            {
              name: "math"
            },
            {
              name: "none"
            },
            {
              name: "note"
            },
            {
              name: "presentation"
            },
            {
              name: "region"
            },
            {
              name: "row"
            },
            {
              name: "rowgroup"
            },
            {
              name: "rowheader"
            },
            {
              name: "separator"
            },
            {
              name: "table"
            },
            {
              name: "term"
            },
            {
              name: "text"
            },
            {
              name: "toolbar"
            },
            {
              name: "banner"
            },
            {
              name: "complementary"
            },
            {
              name: "contentinfo"
            },
            {
              name: "form"
            },
            {
              name: "main"
            },
            {
              name: "navigation"
            },
            {
              name: "region"
            },
            {
              name: "search"
            },
            {
              name: "doc-abstract"
            },
            {
              name: "doc-acknowledgments"
            },
            {
              name: "doc-afterword"
            },
            {
              name: "doc-appendix"
            },
            {
              name: "doc-backlink"
            },
            {
              name: "doc-biblioentry"
            },
            {
              name: "doc-bibliography"
            },
            {
              name: "doc-biblioref"
            },
            {
              name: "doc-chapter"
            },
            {
              name: "doc-colophon"
            },
            {
              name: "doc-conclusion"
            },
            {
              name: "doc-cover"
            },
            {
              name: "doc-credit"
            },
            {
              name: "doc-credits"
            },
            {
              name: "doc-dedication"
            },
            {
              name: "doc-endnote"
            },
            {
              name: "doc-endnotes"
            },
            {
              name: "doc-epigraph"
            },
            {
              name: "doc-epilogue"
            },
            {
              name: "doc-errata"
            },
            {
              name: "doc-example"
            },
            {
              name: "doc-footnote"
            },
            {
              name: "doc-foreword"
            },
            {
              name: "doc-glossary"
            },
            {
              name: "doc-glossref"
            },
            {
              name: "doc-index"
            },
            {
              name: "doc-introduction"
            },
            {
              name: "doc-noteref"
            },
            {
              name: "doc-notice"
            },
            {
              name: "doc-pagebreak"
            },
            {
              name: "doc-pagelist"
            },
            {
              name: "doc-part"
            },
            {
              name: "doc-preface"
            },
            {
              name: "doc-prologue"
            },
            {
              name: "doc-pullquote"
            },
            {
              name: "doc-qna"
            },
            {
              name: "doc-subtitle"
            },
            {
              name: "doc-tip"
            },
            {
              name: "doc-toc"
            }
          ]
        },
        {
          name: "metanames",
          values: [
            {
              name: "application-name"
            },
            {
              name: "author"
            },
            {
              name: "description"
            },
            {
              name: "format-detection"
            },
            {
              name: "generator"
            },
            {
              name: "keywords"
            },
            {
              name: "publisher"
            },
            {
              name: "referrer"
            },
            {
              name: "robots"
            },
            {
              name: "theme-color"
            },
            {
              name: "viewport"
            }
          ]
        },
        {
          name: "haspopup",
          values: [
            {
              name: "false",
              description: {
                kind: "markdown",
                value: "(default) Indicates the element does not have a popup."
              }
            },
            {
              name: "true",
              description: {
                kind: "markdown",
                value: "Indicates the popup is a menu."
              }
            },
            {
              name: "menu",
              description: {
                kind: "markdown",
                value: "Indicates the popup is a menu."
              }
            },
            {
              name: "listbox",
              description: {
                kind: "markdown",
                value: "Indicates the popup is a listbox."
              }
            },
            {
              name: "tree",
              description: {
                kind: "markdown",
                value: "Indicates the popup is a tree."
              }
            },
            {
              name: "grid",
              description: {
                kind: "markdown",
                value: "Indicates the popup is a grid."
              }
            },
            {
              name: "dialog",
              description: {
                kind: "markdown",
                value: "Indicates the popup is a dialog."
              }
            }
          ]
        },
        {
          name: "decoding",
          values: [
            {
              name: "sync"
            },
            {
              name: "async"
            },
            {
              name: "auto"
            }
          ]
        },
        {
          name: "loading",
          values: [
            {
              name: "eager",
              description: {
                kind: "markdown",
                value: "Loads the image immediately, regardless of whether or not the image is currently within the visible viewport (this is the default value)."
              }
            },
            {
              name: "lazy",
              description: {
                kind: "markdown",
                value: "Defers loading the image until it reaches a calculated distance from the viewport, as defined by the browser. The intent is to avoid the network and storage bandwidth needed to handle the image until it's reasonably certain that it will be needed. This generally improves the performance of the content in most typical use cases."
              }
            }
          ]
        },
        {
          name: "referrerpolicy",
          values: [
            {
              name: "no-referrer"
            },
            {
              name: "no-referrer-when-downgrade"
            },
            {
              name: "origin"
            },
            {
              name: "origin-when-cross-origin"
            },
            {
              name: "same-origin"
            },
            {
              name: "strict-origin"
            },
            {
              name: "strict-origin-when-cross-origin"
            },
            {
              name: "unsafe-url"
            }
          ]
        }
      ]
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/docset/HtmlDocset.js
var require_HtmlDocset = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/docset/HtmlDocset.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: !0, value: v });
    } : function(o, v) {
      o.default = v;
    }), __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null)
        for (var k in mod)
          k !== "default" && Object.prototype.hasOwnProperty.call(mod, k) && __createBinding(result, mod, k);
      return __setModuleDefault(result, mod), result;
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.HtmlData = void 0;
    var htmlData = __importStar(require_browsers_html_data());
    exports.HtmlData = htmlData;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/docset/index.js
var require_docset = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/docset/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p) && __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.renderHtmlEntry = exports.render = void 0;
    var MarkdownRenderer_1 = require_MarkdownRenderer();
    Object.defineProperty(exports, "render", { enumerable: !0, get: function() {
      return MarkdownRenderer_1.render;
    } });
    Object.defineProperty(exports, "renderHtmlEntry", { enumerable: !0, get: function() {
      return MarkdownRenderer_1.renderHtmlEntry;
    } });
    __exportStar(require_HtmlDocset(), exports);
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/common/CompletionItemProperties.js
var require_CompletionItemProperties = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/common/CompletionItemProperties.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.createCompletionItem = void 0;
    var vscode_languageserver_1 = require_main5(), docset_1 = require_docset(), SortTokens;
    (function(SortTokens2) {
      SortTokens2.normal = "", SortTokens2.deprioritized = "{", SortTokens2.deprecated = "|", SortTokens2.deprecatedAndDeprioritized = "}";
    })(SortTokens || (SortTokens = {}));
    function createCompletionItem(entry, extraProperties = {}, docsetEntryType, entryType) {
      let sortToken = entry.deprecated ? entry.deprioritized ? SortTokens.deprecatedAndDeprioritized : SortTokens.deprecated : entry.deprioritized ? SortTokens.deprioritized : SortTokens.normal;
      return {
        label: entry.name,
        sortText: `${sortToken}${entry.name}`,
        ...documentationProperties(entry, docsetEntryType, entryType),
        ...deprecatedProperties(entry),
        ...extraProperties
      };
    }
    exports.createCompletionItem = createCompletionItem;
    function documentationProperties(entry, docsetEntryType, entryType) {
      return {
        documentation: {
          kind: "markdown",
          value: (0, docset_1.render)(entry, entryType, docsetEntryType)
        }
      };
    }
    function deprecatedProperties(entry) {
      return entry.deprecated ? {
        tags: [vscode_languageserver_1.CompletionItemTag.Deprecated]
      } : {};
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/common/index.js
var require_common3 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/common/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.sortByName = exports.createCompletionItem = void 0;
    var CompletionItemProperties_1 = require_CompletionItemProperties();
    Object.defineProperty(exports, "createCompletionItem", { enumerable: !0, get: function() {
      return CompletionItemProperties_1.createCompletionItem;
    } });
    function sortByName({ name: nameA }, { name: nameB }) {
      return nameA < nameB ? -1 : nameA > nameB ? 1 : 0;
    }
    exports.sortByName = sortByName;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/HtmlTagCompletionProvider.js
var require_HtmlTagCompletionProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/HtmlTagCompletionProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.HtmlTagCompletionProvider = void 0;
    var liquid_html_parser_1 = require_dist(), vscode_languageserver_1 = require_main5(), docset_1 = require_docset(), utils_1 = require_utils6(), params_1 = require_params(), common_1 = require_common3(), HtmlTagCompletionProvider = class {
      constructor() {
      }
      async completions(params) {
        if (!params.completionContext)
          return [];
        let { node, ancestors } = params.completionContext, parentNode = ancestors.at(-1), grandParentNode = ancestors.at(-2);
        if (node && node.type === liquid_html_parser_1.NodeTypes.HtmlVoidElement)
          return docset_1.HtmlData.tags.filter((tag) => tag.name === node.name).map(toCompletionItem);
        if (!node || !parentNode || !(0, utils_1.isTextNode)(node) || !canComplete(node, parentNode))
          return [];
        let partial = node.value.replace(params_1.CURSOR, "");
        return getOptions(partial, parentNode, grandParentNode).sort(common_1.sortByName).map(toCompletionItem);
      }
    };
    exports.HtmlTagCompletionProvider = HtmlTagCompletionProvider;
    function canComplete(node, parentNode) {
      return isElementOrDanglingClose(parentNode) && parentNode.name.includes(node) && parentNode.name.length === 1;
    }
    function getOptions(partial, parentNode, grandParentNode) {
      if (parentNode.type === liquid_html_parser_1.NodeTypes.HtmlDanglingMarkerClose)
        return grandParentCloseOption(grandParentNode);
      let grandParentName = getGrandParentName(grandParentNode);
      return docset_1.HtmlData.tags.filter((tag) => tag.name.startsWith(partial)).concat(grandParentName && partial === "" ? {
        name: "/" + grandParentName,
        description: "",
        attributes: [],
        references: []
      } : []);
    }
    function toCompletionItem(tag) {
      return {
        label: tag.name,
        kind: vscode_languageserver_1.CompletionItemKind.Property,
        documentation: {
          kind: "markdown",
          value: (0, docset_1.renderHtmlEntry)(tag)
        }
      };
    }
    function grandParentCloseOption(grandParentNode) {
      var _a38;
      let grandParentName = getGrandParentName(grandParentNode);
      return grandParentName ? [
        (_a38 = docset_1.HtmlData.tags.find((tag) => tag.name === grandParentName)) !== null && _a38 !== void 0 ? _a38 : {
          name: grandParentName,
          description: "",
          attributes: [],
          references: []
        }
      ] : [];
    }
    function getGrandParentName(grandParentNode) {
      if (grandParentNode && grandParentNode.type === liquid_html_parser_1.NodeTypes.HtmlElement && grandParentNode.name.length === 1 && (0, utils_1.isTextNode)(grandParentNode.name[0]))
        return grandParentNode.name[0].value.replace(params_1.CURSOR, "");
    }
    function isElementOrDanglingClose(node) {
      return [liquid_html_parser_1.NodeTypes.HtmlElement, liquid_html_parser_1.NodeTypes.HtmlDanglingMarkerClose].includes(node.type);
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/HtmlAttributeCompletionProvider.js
var require_HtmlAttributeCompletionProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/HtmlAttributeCompletionProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.HtmlAttributeCompletionProvider = void 0;
    var vscode_languageserver_1 = require_main5(), docset_1 = require_docset(), utils_1 = require_utils6(), params_1 = require_params(), common_1 = require_common3(), HtmlAttributeCompletionProvider = class {
      constructor() {
      }
      async completions(params) {
        if (!params.completionContext)
          return [];
        let { node, ancestors } = params.completionContext, parentNode = (0, utils_1.findLast)(ancestors, utils_1.isAttrEmpty), grandParentNode = (0, utils_1.findLast)(ancestors, utils_1.isNamedHtmlElementNode);
        if (!node || !parentNode || !grandParentNode)
          return [];
        if (!(0, utils_1.isTextNode)(node) || !(0, utils_1.isAttrEmpty)(parentNode) || !(0, utils_1.isNamedHtmlElementNode)(grandParentNode))
          return [];
        let grandParentNodeName = (0, utils_1.getCompoundName)(grandParentNode), partial = node.value.replace(params_1.CURSOR, "");
        return getOptions(partial, grandParentNodeName).sort(common_1.sortByName).map(toCompletionItem);
      }
    };
    exports.HtmlAttributeCompletionProvider = HtmlAttributeCompletionProvider;
    function getOptions(partial, parentNodeName) {
      var _a38;
      let tag = docset_1.HtmlData.tags.find((tag2) => tag2.name === parentNodeName);
      return [...(_a38 = tag?.attributes) !== null && _a38 !== void 0 ? _a38 : [], ...docset_1.HtmlData.globalAttributes].filter((x) => x.name.startsWith(partial));
    }
    function toCompletionItem(tag) {
      return {
        label: tag.name,
        kind: vscode_languageserver_1.CompletionItemKind.Value,
        documentation: {
          kind: "markdown",
          value: (0, docset_1.renderHtmlEntry)(tag)
        }
      };
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/HtmlAttributeValueCompletionProvider.js
var require_HtmlAttributeValueCompletionProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/HtmlAttributeValueCompletionProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.HtmlAttributeValueCompletionProvider = void 0;
    var vscode_languageserver_1 = require_main5(), docset_1 = require_docset(), utils_1 = require_utils6(), params_1 = require_params(), common_1 = require_common3(), HtmlAttributeValueCompletionProvider = class {
      constructor() {
      }
      async completions(params) {
        var _a38, _b;
        if (!params.completionContext)
          return [];
        let { node, ancestors } = params.completionContext, attributeNode = (0, utils_1.findLast)(ancestors, utils_1.isHtmlAttribute), tagNode = (0, utils_1.findLast)(ancestors, utils_1.isNamedHtmlElementNode);
        if (!node || !attributeNode || !tagNode || !(0, utils_1.isTextNode)(node) || !(0, utils_1.isHtmlAttribute)(attributeNode) || !(0, utils_1.isNamedHtmlElementNode)(tagNode) || (0, utils_1.isAttrEmpty)(attributeNode) || !attributeNode.value.includes(node))
          return [];
        let tagName = (0, utils_1.getCompoundName)(tagNode), attrName = (0, utils_1.getCompoundName)(attributeNode), partial = node.value.replace(params_1.CURSOR, ""), tagEntry = docset_1.HtmlData.tags.find((tag) => tag.name === tagName), attribute = (_a38 = docset_1.HtmlData.globalAttributes.find((attr) => attr.name === attrName)) !== null && _a38 !== void 0 ? _a38 : tagEntry?.attributes.find((attr) => attr.name === attrName), valueSetName = attribute?.valueSet, valueSetEntry = docset_1.HtmlData.valueSets.find((valueSet) => valueSet.name === valueSetName);
        return ((_b = valueSetEntry?.values) !== null && _b !== void 0 ? _b : []).filter((value) => value.name.startsWith(partial)).sort(common_1.sortByName).map((option) => toCompletionItem(option, attribute && "references" in attribute ? attribute : tagEntry));
      }
    };
    exports.HtmlAttributeValueCompletionProvider = HtmlAttributeValueCompletionProvider;
    function toCompletionItem(value, parentEntry) {
      return {
        label: value.name,
        kind: vscode_languageserver_1.CompletionItemKind.Value,
        documentation: {
          kind: "markdown",
          value: (0, docset_1.renderHtmlEntry)(value, parentEntry)
        }
      };
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/FilterCompletionProvider.js
var require_FilterCompletionProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/FilterCompletionProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.FilterCompletionProvider = void 0;
    var liquid_html_parser_1 = require_dist(), vscode_languageserver_1 = require_main5(), TypeSystem_1 = require_TypeSystem(), utils_1 = require_utils6(), params_1 = require_params(), common_1 = require_common3(), FilterCompletionProvider = class {
      constructor(typeSystem) {
        this.typeSystem = typeSystem, this.options = (0, utils_1.memoize)(async (inputType) => {
          let filterEntries = await this.typeSystem.filterEntries(), options = filterEntries.filter((entry) => {
            var _a38;
            return (_a38 = entry.syntax) === null || _a38 === void 0 ? void 0 : _a38.startsWith(inputType);
          }).sort(common_1.sortByName);
          if (inputType === "variable") {
            let entriesWithoutSyntax = filterEntries.filter((entry) => !entry.syntax);
            return options.concat(entriesWithoutSyntax).sort(common_1.sortByName);
          }
          if (options.length === 0)
            return filterEntries.sort(common_1.sortByName);
          let untypedOptions = await this.options("variable");
          return [...options, ...untypedOptions.map(deprioritized)];
        }, (inputType) => inputType);
      }
      async completions(params) {
        if (!params.completionContext)
          return [];
        let { partialAst, node, ancestors } = params.completionContext;
        if (!node || node.type !== liquid_html_parser_1.NodeTypes.LiquidFilter)
          return [];
        if (node.args.length > 0)
          return [];
        let parentVariable = ancestors.at(-1);
        if (!parentVariable || parentVariable.type !== liquid_html_parser_1.NodeTypes.LiquidVariable || parentVariable.filters.at(-1) !== node)
          return [];
        parentVariable = { ...parentVariable }, parentVariable.filters = parentVariable.filters.slice(0, -1);
        let inputType = await this.typeSystem.inferType(parentVariable, partialAst, params.textDocument.uri), partial = node.name.replace(params_1.CURSOR, ""), options = await this.options((0, TypeSystem_1.isArrayType)(inputType) ? "array" : inputType);
        return completionItems(options, partial);
      }
    };
    exports.FilterCompletionProvider = FilterCompletionProvider;
    function deprioritized(entry) {
      return { ...entry, deprioritized: !0 };
    }
    function completionItems(options, partial) {
      return options.filter(({ name }) => name.startsWith(partial)).map(toPropertyCompletionItem);
    }
    function toPropertyCompletionItem(entry) {
      return (0, common_1.createCompletionItem)(entry, {
        kind: vscode_languageserver_1.CompletionItemKind.Function
      }, "filter");
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/LiquidTagsCompletionProvider.js
var require_LiquidTagsCompletionProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/LiquidTagsCompletionProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.LiquidTagsCompletionProvider = void 0;
    var liquid_html_parser_1 = require_dist(), vscode_languageserver_1 = require_main5(), utils_1 = require_utils6(), params_1 = require_params(), common_1 = require_common3(), LiquidTagsCompletionProvider = class {
      constructor(themeDocset) {
        this.themeDocset = themeDocset;
      }
      async completions(params) {
        if (!params.completionContext)
          return [];
        let { node, ancestors } = params.completionContext;
        if (!node || node.type !== liquid_html_parser_1.NodeTypes.LiquidTag)
          return [];
        if (typeof node.markup != "string" || node.markup !== "")
          return [];
        let partial = node.name.replace(params_1.CURSOR, ""), blockParent = findParentNode(partial, ancestors);
        return (await this.themeDocset.tags()).filter(({ name }) => name.startsWith(partial)).sort(common_1.sortByName).map((tag) => (0, common_1.createCompletionItem)(tag, { kind: vscode_languageserver_1.CompletionItemKind.Keyword }, "tag")).concat(blockParent && `end${blockParent.name}`.startsWith(partial) ? {
          label: `end${blockParent.name}`,
          kind: vscode_languageserver_1.CompletionItemKind.Keyword,
          sortText: `!end${blockParent.name}`
          // we want this first.
        } : []);
      }
    };
    exports.LiquidTagsCompletionProvider = LiquidTagsCompletionProvider;
    function findParentNode(partial, ancestors) {
      if (!"end".startsWith(partial))
        return;
      let potentialParentName = partial.replace(/^e(nd?)?/, ""), parentNode = ancestors.at(-1), grandParentNode = ancestors.at(-2);
      if (parentNode && parentNode.type === "LiquidBranch" && grandParentNode && grandParentNode.type === "LiquidTag" && grandParentNode.name.startsWith(potentialParentName))
        return grandParentNode;
      if (parentNode && parentNode.type === "LiquidTag" && parentNode.name.startsWith(potentialParentName))
        return parentNode;
      let previousNode;
      if (parentNode && "children" in parentNode && Array.isArray(parentNode.children) && (previousNode = (0, utils_1.findLast)(parentNode.children, (node) => node.type === "LiquidTag" && node.name.startsWith(potentialParentName) && (liquid_html_parser_1.BLOCKS.includes(node.name) || liquid_html_parser_1.RAW_TAGS.includes(node.name)))))
        return previousNode;
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/ObjectAttributeCompletionProvider.js
var require_ObjectAttributeCompletionProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/ObjectAttributeCompletionProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ObjectAttributeCompletionProvider = void 0;
    var liquid_html_parser_1 = require_dist(), vscode_languageserver_1 = require_main5(), TypeSystem_1 = require_TypeSystem(), params_1 = require_params(), common_1 = require_common3(), ArrayCoreProperties = ["size", "first", "last"], StringCoreProperties = ["size"], ObjectAttributeCompletionProvider = class {
      constructor(typeSystem, getThemeSettingsSchema) {
        this.typeSystem = typeSystem, this.getThemeSettingsSchema = getThemeSettingsSchema;
      }
      async completions(params) {
        var _a38;
        if (!params.completionContext)
          return [];
        let { partialAst, node } = params.completionContext;
        if (!node || node.type !== liquid_html_parser_1.NodeTypes.VariableLookup)
          return [];
        if (node.lookups.length === 0)
          return [];
        let lastLookup = node.lookups.at(-1);
        if (lastLookup.type !== liquid_html_parser_1.NodeTypes.String)
          return [];
        let partial = lastLookup.value.replace(params_1.CURSOR, ""), parentLookup = { ...node };
        parentLookup.lookups = [...parentLookup.lookups], parentLookup.lookups.pop();
        let parentType = await this.typeSystem.inferType(parentLookup, partialAst, params.textDocument.uri);
        if ((0, TypeSystem_1.isArrayType)(parentType))
          return completionItems(ArrayCoreProperties.map((name) => ({ name })), partial);
        if (parentType === "string")
          return completionItems(StringCoreProperties.map((name) => ({ name })), partial);
        let parentTypeProperties = ((_a38 = (await this.typeSystem.objectMap(params.textDocument.uri, partialAst))[parentType]) === null || _a38 === void 0 ? void 0 : _a38.properties) || [];
        return completionItems(parentTypeProperties, partial);
      }
    };
    exports.ObjectAttributeCompletionProvider = ObjectAttributeCompletionProvider;
    function completionItems(options, partial) {
      return options.filter(({ name }) => name.startsWith(partial)).sort(common_1.sortByName).map(toPropertyCompletionItem);
    }
    function toPropertyCompletionItem(object) {
      return (0, common_1.createCompletionItem)(object, { kind: vscode_languageserver_1.CompletionItemKind.Variable });
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/ObjectCompletionProvider.js
var require_ObjectCompletionProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/ObjectCompletionProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ObjectCompletionProvider = void 0;
    var liquid_html_parser_1 = require_dist(), vscode_languageserver_1 = require_main5(), params_1 = require_params(), common_1 = require_common3(), ObjectCompletionProvider = class {
      constructor(typeSystem) {
        this.typeSystem = typeSystem;
      }
      async completions(params) {
        if (!params.completionContext)
          return [];
        let { partialAst, node } = params.completionContext;
        if (!node || node.type !== liquid_html_parser_1.NodeTypes.VariableLookup)
          return [];
        if (!node.name || node.lookups.length > 0)
          return [];
        let partial = node.name.replace(params_1.CURSOR, "");
        return (await this.typeSystem.availableVariables(partialAst, partial, node, params.textDocument.uri)).map(({ entry, type }) => (0, common_1.createCompletionItem)(entry, { kind: vscode_languageserver_1.CompletionItemKind.Variable }, "object", type));
      }
    };
    exports.ObjectCompletionProvider = ObjectCompletionProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/translations.js
var require_translations = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/translations.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.paramsString = exports.extractParams = exports.translationOptions = exports.toOptions = exports.isPluralizedTranslation = exports.translationValue = exports.renderTranslation = exports.renderKey = exports.useBufferOrInjectedSchemaTranslations = exports.useBufferOrInjectedTranslations = exports.PluralizedTranslationKeys = void 0;
    var theme_check_common_1 = require_dist2();
    exports.PluralizedTranslationKeys = ["one", "few", "many", "two", "zero", "other"];
    async function useBufferOrInjectedTranslations(getDefaultTranslationsFactory, theme, rootURI) {
      let injectedGetDefaultTranslations = getDefaultTranslationsFactory(rootURI), defaultTranslationsSourceCode = theme.find((sourceCode) => sourceCode.type === theme_check_common_1.SourceCodeType.JSON && sourceCode.absolutePath.match(/locales/) && sourceCode.absolutePath.match(/default\.json/));
      return parseDefaultTranslations(defaultTranslationsSourceCode) || await injectedGetDefaultTranslations();
    }
    exports.useBufferOrInjectedTranslations = useBufferOrInjectedTranslations;
    async function useBufferOrInjectedSchemaTranslations(getDefaultTranslationsFactory, theme, rootURI) {
      let injectedGetDefaultTranslations = getDefaultTranslationsFactory(rootURI), defaultTranslationsSourceCode = theme.find((sourceCode) => sourceCode.type === theme_check_common_1.SourceCodeType.JSON && sourceCode.absolutePath.match(/locales/) && sourceCode.absolutePath.match(/default\.schema\.json/));
      return parseDefaultTranslations(defaultTranslationsSourceCode) || await injectedGetDefaultTranslations();
    }
    exports.useBufferOrInjectedSchemaTranslations = useBufferOrInjectedSchemaTranslations;
    function parseDefaultTranslations(sourceCode) {
      if (!sourceCode)
        return;
      let translations = (0, theme_check_common_1.parseJSON)(sourceCode.source);
      return (0, theme_check_common_1.isError)(translations) ? void 0 : translations;
    }
    function renderKey(translation, key) {
      if (translation[key])
        return `\`${key}:\` ${translation[key]}`;
    }
    exports.renderKey = renderKey;
    function renderTranslation(translation) {
      return typeof translation == "string" ? translation : [
        renderKey(translation, "zero"),
        renderKey(translation, "one"),
        renderKey(translation, "two"),
        renderKey(translation, "few"),
        renderKey(translation, "many"),
        renderKey(translation, "other")
      ].filter(Boolean).join(`

---

`);
    }
    exports.renderTranslation = renderTranslation;
    function translationValue(path3, translations) {
      let parts = path3.split("."), current = translations;
      for (let key of parts) {
        if (!current || typeof current == "string")
          return;
        current = current[key];
      }
      return current;
    }
    exports.translationValue = translationValue;
    function isPluralizedTranslation(translations) {
      return Object.keys(translations).every((key) => exports.PluralizedTranslationKeys.includes(key));
    }
    exports.isPluralizedTranslation = isPluralizedTranslation;
    function toOptions(prefix, translations) {
      return Object.entries(translations).flatMap(([path3, translation]) => typeof translation == "string" || isPluralizedTranslation(translation) ? [{ path: prefix.concat(path3), translation }] : toOptions(prefix.concat(path3), translation));
    }
    exports.toOptions = toOptions;
    function translationOptions(translations) {
      return toOptions([], translations);
    }
    exports.translationOptions = translationOptions;
    function extractParams(value) {
      let regex = /\{\{([^}]+?)\}\}/g, results = [], current;
      for (; (current = regex.exec(value)) !== null; )
        results.push(current[1].trim());
      return results;
    }
    exports.extractParams = extractParams;
    function paramsString(params) {
      return params.length === 0 ? "" : ": " + params.map((param) => `${param}: ${param}`).join(", ");
    }
    exports.paramsString = paramsString;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/TranslationCompletionProvider.js
var require_TranslationCompletionProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/TranslationCompletionProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.TranslationCompletionProvider = void 0;
    var liquid_html_parser_1 = require_dist(), vscode_languageserver_1 = require_main5(), translations_1 = require_translations(), visitor_1 = require_visitor(), TranslationCompletionProvider = class {
      constructor(documentManager, getTranslationsForURI) {
        this.documentManager = documentManager, this.getTranslationsForURI = getTranslationsForURI;
      }
      async completions(params) {
        if (!params.completionContext)
          return [];
        let { node, ancestors } = params.completionContext, parentNode = ancestors.at(-1), document2 = this.documentManager.get(params.textDocument.uri);
        if (!node || node.type !== liquid_html_parser_1.NodeTypes.String || !parentNode || parentNode.type !== liquid_html_parser_1.NodeTypes.LiquidVariable || !document2)
          return [];
        let ast = document2.ast, textDocument = document2.textDocument, translations = await this.getTranslationsForURI(params.textDocument.uri), partial = node.value, options = (0, translations_1.translationOptions)(translations).filter((option) => {
          var _a38;
          return !(!((_a38 = option.path[0]) === null || _a38 === void 0) && _a38.startsWith("shopify")) || partial.startsWith("shopify");
        }), [_currentNode, realAncestors] = ast instanceof Error ? [null, []] : (0, visitor_1.findCurrentNode)(ast, textDocument.offsetAt(params.position)), realParentNode = realAncestors.at(-1), shouldAppendTranslateFilter = realParentNode?.type === liquid_html_parser_1.NodeTypes.LiquidVariable && realParentNode?.filters.length === 0, quote = node.single ? "'" : '"', postFix = quote + " | t", replaceRange;
        shouldAppendTranslateFilter ? (postFix = quote + " | t", replaceRange = {
          start: textDocument.positionAt(node.position.start + 1),
          end: textDocument.positionAt(node.position.end)
          // including quote
        }) : (postFix = "", replaceRange = {
          start: textDocument.positionAt(node.position.start + 1),
          end: textDocument.positionAt(node.position.end - 1)
          // excluding quote
        });
        let insertTextStartIndex = partial.lastIndexOf(".") + 1;
        return options.map(({ path: path3, translation }) => {
          var _a38;
          let params2 = (0, translations_1.extractParams)(typeof translation == "string" ? translation : (_a38 = Object.values(translation)[0]) !== null && _a38 !== void 0 ? _a38 : ""), parameters = (0, translations_1.paramsString)(params2);
          return {
            label: quote + path3.join(".") + quote + " | t",
            insertText: path3.join(".").slice(insertTextStartIndex),
            kind: vscode_languageserver_1.CompletionItemKind.Field,
            textEdit: vscode_languageserver_1.TextEdit.replace(replaceRange, path3.join(".") + postFix + (shouldAppendTranslateFilter ? parameters : "")),
            documentation: {
              kind: "markdown",
              value: (0, translations_1.renderTranslation)(translation)
            }
          };
        });
      }
    };
    exports.TranslationCompletionProvider = TranslationCompletionProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/RenderSnippetCompletionProvider.js
var require_RenderSnippetCompletionProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/RenderSnippetCompletionProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.RenderSnippetCompletionProvider = void 0;
    var liquid_html_parser_1 = require_dist(), vscode_languageserver_1 = require_main5(), RenderSnippetCompletionProvider = class {
      constructor(getSnippetNamesForURI = async () => []) {
        this.getSnippetNamesForURI = getSnippetNamesForURI;
      }
      async completions(params) {
        if (!params.completionContext)
          return [];
        let { node } = params.completionContext;
        if (!node || node.type !== liquid_html_parser_1.NodeTypes.RenderMarkup || node.snippet.type !== liquid_html_parser_1.NodeTypes.String)
          return [];
        let options = await this.getSnippetNamesForURI(params.textDocument.uri), partial = node.snippet.value;
        return options.filter((option) => option.startsWith(partial)).map((option) => ({
          label: option,
          kind: vscode_languageserver_1.CompletionItemKind.Snippet,
          documentation: {
            kind: "markdown",
            value: `snippets/${option}.liquid`
          }
        }));
      }
    };
    exports.RenderSnippetCompletionProvider = RenderSnippetCompletionProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/index.js
var require_providers3 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/providers/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.RenderSnippetCompletionProvider = exports.TranslationCompletionProvider = exports.ObjectCompletionProvider = exports.ObjectAttributeCompletionProvider = exports.LiquidTagsCompletionProvider = exports.FilterCompletionProvider = exports.HtmlAttributeValueCompletionProvider = exports.HtmlAttributeCompletionProvider = exports.HtmlTagCompletionProvider = void 0;
    var HtmlTagCompletionProvider_1 = require_HtmlTagCompletionProvider();
    Object.defineProperty(exports, "HtmlTagCompletionProvider", { enumerable: !0, get: function() {
      return HtmlTagCompletionProvider_1.HtmlTagCompletionProvider;
    } });
    var HtmlAttributeCompletionProvider_1 = require_HtmlAttributeCompletionProvider();
    Object.defineProperty(exports, "HtmlAttributeCompletionProvider", { enumerable: !0, get: function() {
      return HtmlAttributeCompletionProvider_1.HtmlAttributeCompletionProvider;
    } });
    var HtmlAttributeValueCompletionProvider_1 = require_HtmlAttributeValueCompletionProvider();
    Object.defineProperty(exports, "HtmlAttributeValueCompletionProvider", { enumerable: !0, get: function() {
      return HtmlAttributeValueCompletionProvider_1.HtmlAttributeValueCompletionProvider;
    } });
    var FilterCompletionProvider_1 = require_FilterCompletionProvider();
    Object.defineProperty(exports, "FilterCompletionProvider", { enumerable: !0, get: function() {
      return FilterCompletionProvider_1.FilterCompletionProvider;
    } });
    var LiquidTagsCompletionProvider_1 = require_LiquidTagsCompletionProvider();
    Object.defineProperty(exports, "LiquidTagsCompletionProvider", { enumerable: !0, get: function() {
      return LiquidTagsCompletionProvider_1.LiquidTagsCompletionProvider;
    } });
    var ObjectAttributeCompletionProvider_1 = require_ObjectAttributeCompletionProvider();
    Object.defineProperty(exports, "ObjectAttributeCompletionProvider", { enumerable: !0, get: function() {
      return ObjectAttributeCompletionProvider_1.ObjectAttributeCompletionProvider;
    } });
    var ObjectCompletionProvider_1 = require_ObjectCompletionProvider();
    Object.defineProperty(exports, "ObjectCompletionProvider", { enumerable: !0, get: function() {
      return ObjectCompletionProvider_1.ObjectCompletionProvider;
    } });
    var TranslationCompletionProvider_1 = require_TranslationCompletionProvider();
    Object.defineProperty(exports, "TranslationCompletionProvider", { enumerable: !0, get: function() {
      return TranslationCompletionProvider_1.TranslationCompletionProvider;
    } });
    var RenderSnippetCompletionProvider_1 = require_RenderSnippetCompletionProvider();
    Object.defineProperty(exports, "RenderSnippetCompletionProvider", { enumerable: !0, get: function() {
      return RenderSnippetCompletionProvider_1.RenderSnippetCompletionProvider;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/CompletionsProvider.js
var require_CompletionsProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/CompletionsProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.CompletionsProvider = void 0;
    var theme_check_common_1 = require_dist2(), TypeSystem_1 = require_TypeSystem(), params_1 = require_params(), providers_1 = require_providers3(), CompletionsProvider = class {
      constructor({ documentManager, themeDocset, getTranslationsForURI = async () => ({}), getSnippetNamesForURI = async () => [], getThemeSettingsSchemaForURI = async () => [], log = () => {
      } }) {
        this.providers = [], this.documentManager = documentManager, this.themeDocset = themeDocset, this.log = log;
        let typeSystem = new TypeSystem_1.TypeSystem(themeDocset, getThemeSettingsSchemaForURI);
        this.providers = [
          new providers_1.HtmlTagCompletionProvider(),
          new providers_1.HtmlAttributeCompletionProvider(),
          new providers_1.HtmlAttributeValueCompletionProvider(),
          new providers_1.LiquidTagsCompletionProvider(themeDocset),
          new providers_1.ObjectCompletionProvider(typeSystem),
          new providers_1.ObjectAttributeCompletionProvider(typeSystem, getThemeSettingsSchemaForURI),
          new providers_1.FilterCompletionProvider(typeSystem),
          new providers_1.TranslationCompletionProvider(documentManager, getTranslationsForURI),
          new providers_1.RenderSnippetCompletionProvider(getSnippetNamesForURI)
        ];
      }
      async completions(params) {
        let uri = params.textDocument.uri, document2 = this.documentManager.get(uri);
        if (document2?.type !== theme_check_common_1.SourceCodeType.LiquidHtml)
          return [];
        try {
          let liquidParams = (0, params_1.createLiquidCompletionParams)(document2, params), promises = this.providers.map((p) => p.completions(liquidParams));
          return (await Promise.all(promises)).flat();
        } catch (err2) {
          return this.log(`[SERVER] CompletionsProvider error: ${err2}`), [];
        }
      }
    };
    exports.CompletionsProvider = CompletionsProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/index.js
var require_completions = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/completions/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.CompletionsProvider = void 0;
    var CompletionsProvider_1 = require_CompletionsProvider();
    Object.defineProperty(exports, "CompletionsProvider", { enumerable: !0, get: function() {
      return CompletionsProvider_1.CompletionsProvider;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/diagnostics/offenseToDiagnostic.js
var require_offenseToDiagnostic = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/diagnostics/offenseToDiagnostic.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.offenseToDiagnostic = void 0;
    var vscode_languageserver_1 = require_main5(), theme_check_common_1 = require_dist2(), checkToDocsUrl = theme_check_common_1.allChecks.reduce((acc, checkDescription) => {
      let url = checkDescription.meta.docs.url, code = checkDescription.meta.code;
      return url !== void 0 && (acc[code] = url), acc;
    }, {});
    function offenseToDiagnostic(offense) {
      let diagnostic = vscode_languageserver_1.Diagnostic.create(diagnosticRange(offense), offense.message, diagnosticSeverity(offense), offense.check, "theme-check"), url = checkToDocsUrl[offense.check];
      return url && (diagnostic.codeDescription = { href: url }), diagnostic;
    }
    exports.offenseToDiagnostic = offenseToDiagnostic;
    function diagnosticRange({ start, end }) {
      return {
        start: {
          line: start.line,
          character: start.character
        },
        end: {
          line: end.line,
          character: end.character
        }
      };
    }
    function diagnosticSeverity(offense) {
      switch (offense.severity) {
        case theme_check_common_1.Severity.INFO:
          return vscode_languageserver_1.DiagnosticSeverity.Information;
        case theme_check_common_1.Severity.WARNING:
          return vscode_languageserver_1.DiagnosticSeverity.Warning;
        case theme_check_common_1.Severity.ERROR:
          return vscode_languageserver_1.DiagnosticSeverity.Error;
        default:
          return (0, theme_check_common_1.assertNever)(offense.severity);
      }
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/diagnostics/DiagnosticsManager.js
var require_DiagnosticsManager = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/diagnostics/DiagnosticsManager.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.DiagnosticsManager = void 0;
    var offenseToDiagnostic_1 = require_offenseToDiagnostic(), DiagnosticsManager = class {
      constructor(connection) {
        this.connection = connection, this.diagnostics = /* @__PURE__ */ new Map();
      }
      get(uri) {
        return this.diagnostics.get(uri);
      }
      set(uri, version2, offenses) {
        let anomalies = offenses.map((offense, index) => ({
          offense,
          diagnostic: (0, offenseToDiagnostic_1.offenseToDiagnostic)(offense),
          id: index
        }));
        this.diagnostics.set(uri, {
          uri,
          version: version2,
          anomalies
        }), this.connection.sendDiagnostics({
          uri,
          version: version2,
          diagnostics: anomalies.map((a) => a.diagnostic)
        });
      }
      clear(uri) {
        this.diagnostics.delete(uri), this.connection.sendDiagnostics({
          uri,
          version: void 0,
          diagnostics: []
        });
      }
    };
    exports.DiagnosticsManager = DiagnosticsManager;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/diagnostics/runChecks.js
var require_runChecks = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/diagnostics/runChecks.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.makeRunChecks = void 0;
    var theme_check_common_1 = require_dist2(), translations_1 = require_translations(), vscode_uri_1 = require_umd();
    function makeRunChecks(documentManager, diagnosticsManager, { loadConfig: loadConfig2, findRootURI, fileSize: fileSize2, fileExists: fileExists3, getDefaultTranslationsFactory, getDefaultLocaleFactory, getDefaultSchemaTranslationsFactory, getDefaultSchemaLocaleFactory, themeDocset, jsonValidationSet }) {
      return async function(triggerURIs) {
        let rootURIs = await Promise.all(triggerURIs.map(findRootURI)), deduplicatedRootURIs = new Set(rootURIs);
        await Promise.all([...deduplicatedRootURIs].map(runChecksForRoot));
        return;
        async function runChecksForRoot(configFileRoot) {
          let configFileRootURI = vscode_uri_1.URI.parse(configFileRoot), config2 = await loadConfig2(configFileRoot), rootURI = configFileRootURI.with({
            path: config2.root
          }), theme = documentManager.theme(rootURI.toString()), [defaultTranslations, defaultSchemaTranslations] = await Promise.all([
            (0, translations_1.useBufferOrInjectedTranslations)(getDefaultTranslationsFactory, theme, rootURI.toString()),
            (0, translations_1.useBufferOrInjectedSchemaTranslations)(getDefaultSchemaTranslationsFactory, theme, rootURI.toString())
          ]), offenses = await (0, theme_check_common_1.check)(theme, config2, {
            fileExists: fileExists3,
            fileSize: fileSize2,
            getDefaultLocale: getDefaultLocaleFactory(rootURI.toString()),
            getDefaultSchemaLocale: getDefaultSchemaLocaleFactory(rootURI.toString()),
            getDefaultTranslations: async () => defaultTranslations,
            getDefaultSchemaTranslations: async () => defaultSchemaTranslations,
            jsonValidationSet,
            themeDocset
          });
          for (let sourceCode of theme) {
            let sourceCodeOffenses = offenses.filter((offense) => offense.absolutePath === sourceCode.absolutePath);
            diagnosticsManager.set(sourceCode.uri, sourceCode.version, sourceCodeOffenses);
          }
        }
      };
    }
    exports.makeRunChecks = makeRunChecks;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/diagnostics/index.js
var require_diagnostics = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/diagnostics/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.makeRunChecks = exports.DiagnosticsManager = void 0;
    var DiagnosticsManager_1 = require_DiagnosticsManager();
    Object.defineProperty(exports, "DiagnosticsManager", { enumerable: !0, get: function() {
      return DiagnosticsManager_1.DiagnosticsManager;
    } });
    var runChecks_1 = require_runChecks();
    Object.defineProperty(exports, "makeRunChecks", { enumerable: !0, get: function() {
      return runChecks_1.makeRunChecks;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/documentLinks/DocumentLinksProvider.js
var require_DocumentLinksProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/documentLinks/DocumentLinksProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.DocumentLinksProvider = void 0;
    var liquid_html_parser_1 = require_dist(), theme_check_common_1 = require_dist2(), vscode_languageserver_1 = require_main5(), vscode_uri_1 = require_umd(), visitor_1 = require_visitor(), DocumentLinksProvider = class {
      constructor(documentManager) {
        this.documentManager = documentManager;
      }
      async documentLinks(uriString, rootUri) {
        let sourceCode = this.documentManager.get(uriString);
        if (!sourceCode || sourceCode.type !== theme_check_common_1.SourceCodeType.LiquidHtml || sourceCode.ast instanceof Error)
          return [];
        let visitor = documentLinksVisitor(sourceCode.textDocument, vscode_uri_1.URI.parse(rootUri));
        return (0, visitor_1.visit)(sourceCode.ast, visitor);
      }
    };
    exports.DocumentLinksProvider = DocumentLinksProvider;
    function documentLinksVisitor(textDocument, root) {
      return {
        LiquidTag(node) {
          if ((node.name === "render" || node.name === "include") && typeof node.markup != "string" && isLiquidString(node.markup.snippet)) {
            let snippet = node.markup.snippet;
            return vscode_languageserver_1.DocumentLink.create(range(textDocument, snippet), vscode_uri_1.Utils.resolvePath(root, "snippets", snippet.value + ".liquid").toString());
          }
          if (node.name === "section" && typeof node.markup != "string" && isLiquidString(node.markup)) {
            let sectionName = node.markup;
            return vscode_languageserver_1.DocumentLink.create(range(textDocument, sectionName), vscode_uri_1.Utils.resolvePath(root, "sections", sectionName.value + ".liquid").toString());
          }
        },
        // {{ 'theme.js' | asset_url }}
        LiquidVariable(node) {
          if (node.filters.length === 0 || node.filters[0].name !== "asset_url" || !isLiquidString(node.expression))
            return;
          let expression = node.expression;
          return vscode_languageserver_1.DocumentLink.create(range(textDocument, node.expression), vscode_uri_1.Utils.resolvePath(root, "assets", expression.value).toString());
        }
      };
    }
    function range(textDocument, node) {
      let start = textDocument.positionAt(node.position.start), end = textDocument.positionAt(node.position.end);
      return vscode_languageserver_1.Range.create(start, end);
    }
    function isLiquidString(node) {
      return node.type === liquid_html_parser_1.NodeTypes.String;
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/documentLinks/index.js
var require_documentLinks = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/documentLinks/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.DocumentLinksProvider = void 0;
    var DocumentLinksProvider_1 = require_DocumentLinksProvider();
    Object.defineProperty(exports, "DocumentLinksProvider", { enumerable: !0, get: function() {
      return DocumentLinksProvider_1.DocumentLinksProvider;
    } });
  }
});

// ../../node_modules/.pnpm/vscode-languageserver-textdocument@1.0.11/node_modules/vscode-languageserver-textdocument/lib/umd/main.js
var main_exports3 = {};
__export(main_exports3, {
  TextDocument: () => TextDocument4
});
function mergeSort2(data, compare2) {
  if (data.length <= 1)
    return data;
  let p = data.length / 2 | 0, left = data.slice(0, p), right = data.slice(p);
  mergeSort2(left, compare2), mergeSort2(right, compare2);
  let leftIdx = 0, rightIdx = 0, i = 0;
  for (; leftIdx < left.length && rightIdx < right.length; )
    compare2(left[leftIdx], right[rightIdx]) <= 0 ? data[i++] = left[leftIdx++] : data[i++] = right[rightIdx++];
  for (; leftIdx < left.length; )
    data[i++] = left[leftIdx++];
  for (; rightIdx < right.length; )
    data[i++] = right[rightIdx++];
  return data;
}
function computeLineOffsets2(text, isAtLineStart, textOffset = 0) {
  let result = isAtLineStart ? [textOffset] : [];
  for (let i = 0; i < text.length; i++) {
    let ch = text.charCodeAt(i);
    (ch === 13 || ch === 10) && (ch === 13 && i + 1 < text.length && text.charCodeAt(i + 1) === 10 && i++, result.push(textOffset + i + 1));
  }
  return result;
}
function getWellformedRange2(range) {
  let start = range.start, end = range.end;
  return start.line > end.line || start.line === end.line && start.character > end.character ? { start: end, end: start } : range;
}
function getWellformedEdit2(textEdit) {
  let range = getWellformedRange2(textEdit.range);
  return range !== textEdit.range ? { newText: textEdit.newText, range } : textEdit;
}
var FullTextDocument4, TextDocument4, init_main5 = __esm({
  "../../node_modules/.pnpm/vscode-languageserver-textdocument@1.0.11/node_modules/vscode-languageserver-textdocument/lib/umd/main.js"() {
    "use strict";
    init_cjs_shims();
    FullTextDocument4 = class _FullTextDocument {
      constructor(uri, languageId, version2, content) {
        this._uri = uri, this._languageId = languageId, this._version = version2, this._content = content, this._lineOffsets = void 0;
      }
      get uri() {
        return this._uri;
      }
      get languageId() {
        return this._languageId;
      }
      get version() {
        return this._version;
      }
      getText(range) {
        if (range) {
          let start = this.offsetAt(range.start), end = this.offsetAt(range.end);
          return this._content.substring(start, end);
        }
        return this._content;
      }
      update(changes, version2) {
        for (let change of changes)
          if (_FullTextDocument.isIncremental(change)) {
            let range = getWellformedRange2(change.range), startOffset = this.offsetAt(range.start), endOffset = this.offsetAt(range.end);
            this._content = this._content.substring(0, startOffset) + change.text + this._content.substring(endOffset, this._content.length);
            let startLine = Math.max(range.start.line, 0), endLine = Math.max(range.end.line, 0), lineOffsets = this._lineOffsets, addedLineOffsets = computeLineOffsets2(change.text, !1, startOffset);
            if (endLine - startLine === addedLineOffsets.length)
              for (let i = 0, len = addedLineOffsets.length; i < len; i++)
                lineOffsets[i + startLine + 1] = addedLineOffsets[i];
            else
              addedLineOffsets.length < 1e4 ? lineOffsets.splice(startLine + 1, endLine - startLine, ...addedLineOffsets) : this._lineOffsets = lineOffsets = lineOffsets.slice(0, startLine + 1).concat(addedLineOffsets, lineOffsets.slice(endLine + 1));
            let diff2 = change.text.length - (endOffset - startOffset);
            if (diff2 !== 0)
              for (let i = startLine + 1 + addedLineOffsets.length, len = lineOffsets.length; i < len; i++)
                lineOffsets[i] = lineOffsets[i] + diff2;
          } else if (_FullTextDocument.isFull(change))
            this._content = change.text, this._lineOffsets = void 0;
          else
            throw new Error("Unknown change event received");
        this._version = version2;
      }
      getLineOffsets() {
        return this._lineOffsets === void 0 && (this._lineOffsets = computeLineOffsets2(this._content, !0)), this._lineOffsets;
      }
      positionAt(offset) {
        offset = Math.max(Math.min(offset, this._content.length), 0);
        let lineOffsets = this.getLineOffsets(), low = 0, high = lineOffsets.length;
        if (high === 0)
          return { line: 0, character: offset };
        for (; low < high; ) {
          let mid = Math.floor((low + high) / 2);
          lineOffsets[mid] > offset ? high = mid : low = mid + 1;
        }
        let line = low - 1;
        return { line, character: offset - lineOffsets[line] };
      }
      offsetAt(position) {
        let lineOffsets = this.getLineOffsets();
        if (position.line >= lineOffsets.length)
          return this._content.length;
        if (position.line < 0)
          return 0;
        let lineOffset = lineOffsets[position.line], nextLineOffset = position.line + 1 < lineOffsets.length ? lineOffsets[position.line + 1] : this._content.length;
        return Math.max(Math.min(lineOffset + position.character, nextLineOffset), lineOffset);
      }
      get lineCount() {
        return this.getLineOffsets().length;
      }
      static isIncremental(event) {
        let candidate = event;
        return candidate != null && typeof candidate.text == "string" && candidate.range !== void 0 && (candidate.rangeLength === void 0 || typeof candidate.rangeLength == "number");
      }
      static isFull(event) {
        let candidate = event;
        return candidate != null && typeof candidate.text == "string" && candidate.range === void 0 && candidate.rangeLength === void 0;
      }
    };
    (function(TextDocument5) {
      function create(uri, languageId, version2, content) {
        return new FullTextDocument4(uri, languageId, version2, content);
      }
      TextDocument5.create = create;
      function update2(document2, changes, version2) {
        if (document2 instanceof FullTextDocument4)
          return document2.update(changes, version2), document2;
        throw new Error("TextDocument.update: document must be created by TextDocument.create");
      }
      TextDocument5.update = update2;
      function applyEdits2(document2, edits) {
        let text = document2.getText(), sortedEdits = mergeSort2(edits.map(getWellformedEdit2), (a, b) => {
          let diff2 = a.range.start.line - b.range.start.line;
          return diff2 === 0 ? a.range.start.character - b.range.start.character : diff2;
        }), lastModifiedOffset = 0, spans = [];
        for (let e of sortedEdits) {
          let startOffset = document2.offsetAt(e.range.start);
          if (startOffset < lastModifiedOffset)
            throw new Error("Overlapping edit");
          startOffset > lastModifiedOffset && spans.push(text.substring(lastModifiedOffset, startOffset)), e.newText.length && spans.push(e.newText), lastModifiedOffset = document2.offsetAt(e.range.end);
        }
        return spans.push(text.substr(lastModifiedOffset)), spans.join("");
      }
      TextDocument5.applyEdits = applyEdits2;
    })(TextDocument4 || (TextDocument4 = {}));
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/documents/DocumentManager.js
var require_DocumentManager = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/documents/DocumentManager.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.DocumentManager = void 0;
    var theme_check_common_1 = require_dist2(), vscode_languageserver_textdocument_1 = (init_main5(), __toCommonJS(main_exports3)), utils_1 = require_utils6(), DocumentManager = class {
      constructor() {
        this.sourceCodes = /* @__PURE__ */ new Map();
      }
      open(uri, source, version2) {
        return this.set(uri, source, version2);
      }
      change(uri, source, version2) {
        return this.set(uri, source, version2);
      }
      close(uri) {
        return this.sourceCodes.delete(uri);
      }
      theme(root) {
        return [...this.sourceCodes.entries()].filter(([uri]) => uri.startsWith(root)).map(([, sourceCode]) => sourceCode);
      }
      get openDocuments() {
        return [...this.sourceCodes.values()];
      }
      get(uri) {
        return this.sourceCodes.get(uri);
      }
      set(uri, source, version2) {
        var _a38;
        let absolutePath = (0, utils_1.toAbsolutePath)(uri);
        if (!/\.(json|liquid)$/.test(absolutePath) || /\.(s?css|js).liquid$/.test(absolutePath))
          return;
        let sourceCode = (0, theme_check_common_1.toSourceCode)(absolutePath, source, version2);
        this.sourceCodes.set(uri, {
          ...sourceCode,
          textDocument: vscode_languageserver_textdocument_1.TextDocument.create(uri, sourceCode.type, (_a38 = sourceCode.version) !== null && _a38 !== void 0 ? _a38 : 0, sourceCode.source),
          uri
        });
      }
    };
    exports.DocumentManager = DocumentManager;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/documents/index.js
var require_documents = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/documents/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.DocumentManager = void 0;
    var DocumentManager_1 = require_DocumentManager();
    Object.defineProperty(exports, "DocumentManager", { enumerable: !0, get: function() {
      return DocumentManager_1.DocumentManager;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/formatting/OnTypeFormattingProvider.js
var require_OnTypeFormattingProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/formatting/OnTypeFormattingProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.OnTypeFormattingProvider = void 0;
    var vscode_languageserver_protocol_1 = require_main4(), OnTypeFormattingProvider = class {
      constructor(documentManager) {
        this.documentManager = documentManager;
      }
      /**
       * This very complex piece of code here exists to provide a good autoclosing UX.
       *
       * The story is kind of long so here goes...
       *
       * What we want:
       * 1. Basic autoclosing of {{, {% with the corresponding pair (and spaces)
       *   - user types: {{
       *   - user sees: {{ | }} (with cursor position at |)
       * 2. Autoclosing of {{- with -}}, {%- with -%}
       *   - user types: {{-
       *   - user sees: {{- | -}} (with cursor at |)
       * 3. User adds whitespace stripping on one side of the braces of an existing tag
       *   - user types: - at | in `{{| drop }}`
       *   - user sees: {{- drop }}
       *
       * Why we can't do it with autoclosingPairs:
       *   - VS Code's settings accepts autoclosingPairs and autocloseBefore
       *     - autoclosingPairs is a set of pairs that should be autoclosed (e.g. ['{%', '%}'])
       *     - autocloseBefore is a character set of 'allowed next characters' that would cause a closing pair
       *   - If we put a space (' ') the autoclosingPairs set, then (3) from above becomes funky:
       *     - assume autoclosingPairs = {|}, {{|}}, {{ | }}
       *     - user types: a space at | in `{{| drop }}`
       *     - user sees: {{   }}drop }}
       *   - This happens because the space is an autocloseBefore character, it sees a space after the cursor
       *     so it closes '{{ ' with ' }}' at the cursor position, resulting in '{{  }}drop }}'
       *   - Something similar happens if we include the `-` in the autoclosing pairs
       *   - This is annoying!
       *
       * So our solution is the following:
       * 1. We change the pairs to include the closing space (this way our cursor remains where we want it to be)
       *    - {{| }}
       *    - {%| %}
       * 2. We add this OnTypeFormattingProvider that does the following "fixes":
       *    - {{| }}   into {{ | }}
       *    - {{ -| }} into {{- | -}}
       *    - {%| %}   into {% | %}
       *    - {% -| %} into {%- | -%}
       *
       * This lets us avoid the unnecessary close and accomplish 1, 2 and 3 :)
       *
       * Fallback for editor.onTypeFormatting: false is to let the user type the `-` on both sides manually
       */
      async onTypeFormatting(params) {
        let document2 = this.documentManager.get(params.textDocument.uri);
        if (!document2)
          return null;
        let textDocument = document2.textDocument, ch = params.ch, { line, character } = params.position;
        if (ch === " " && character <= 2 || character <= 1)
          return null;
        let currentLineRange = vscode_languageserver_protocol_1.Range.create(vscode_languageserver_protocol_1.Position.create(line, 0), vscode_languageserver_protocol_1.Position.create(line + 1, 0)), currentLine = textDocument.getText(currentLineRange), charIdx = ch === " " ? character - 2 : character - 1;
        switch (currentLine.at(charIdx)) {
          case "{":
          case "%": {
            let chars = currentLine.slice(charIdx - 1, charIdx + 4);
            if (chars === "{{ }}" || chars === "{% %}")
              return [vscode_languageserver_protocol_1.TextEdit.insert(vscode_languageserver_protocol_1.Position.create(line, charIdx + 1), " ")];
          }
          case "-": {
            if (charIdx < 3)
              return null;
            let chars = currentLine.slice(charIdx - 3, charIdx + 4);
            if (chars === "{{ - }}" || chars === "{% - %}")
              return [
                // Start with
                //   {{ - }}
                //     ^ start replace
                //       ^ end replace (excluded)
                // Replace with '- ', get
                //   {{- }}
                vscode_languageserver_protocol_1.TextEdit.replace(vscode_languageserver_protocol_1.Range.create(vscode_languageserver_protocol_1.Position.create(line, charIdx - 1), vscode_languageserver_protocol_1.Position.create(line, charIdx + 1)), "- "),
                // Start with
                //   {{ - }}
                //      ^ char
                //        ^ insertion point
                // Insert ' ' , get
                //   {{ - -}}
                // Both together and you get {{- -}} with your cursor in the middle
                vscode_languageserver_protocol_1.TextEdit.insert(vscode_languageserver_protocol_1.Position.create(line, charIdx + 2), "-")
              ];
          }
        }
        return null;
      }
    };
    exports.OnTypeFormattingProvider = OnTypeFormattingProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/formatting/index.js
var require_formatting = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/formatting/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.OnTypeFormattingProvider = void 0;
    var OnTypeFormattingProvider_1 = require_OnTypeFormattingProvider();
    Object.defineProperty(exports, "OnTypeFormattingProvider", { enumerable: !0, get: function() {
      return OnTypeFormattingProvider_1.OnTypeFormattingProvider;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/LiquidTagHoverProvider.js
var require_LiquidTagHoverProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/LiquidTagHoverProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.LiquidTagHoverProvider = void 0;
    var liquid_html_parser_1 = require_dist(), docset_1 = require_docset(), LiquidTagHoverProvider = class {
      constructor(themeDocset) {
        this.themeDocset = themeDocset;
      }
      async hover(currentNode) {
        if (currentNode.type !== liquid_html_parser_1.NodeTypes.LiquidTag && currentNode.type !== liquid_html_parser_1.NodeTypes.LiquidRawTag && currentNode.type !== liquid_html_parser_1.NodeTypes.LiquidBranch)
          return null;
        let name = currentNode.name, entry = (await this.themeDocset.tags()).find((entry2) => entry2.name === name);
        return entry ? {
          contents: {
            kind: "markdown",
            value: (0, docset_1.render)(entry, void 0, "tag")
          }
        } : null;
      }
    };
    exports.LiquidTagHoverProvider = LiquidTagHoverProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/LiquidFilterHoverProvider.js
var require_LiquidFilterHoverProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/LiquidFilterHoverProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.LiquidFilterHoverProvider = void 0;
    var liquid_html_parser_1 = require_dist(), docset_1 = require_docset(), LiquidFilterHoverProvider = class {
      constructor(themeDocset) {
        this.themeDocset = themeDocset;
      }
      async hover(currentNode) {
        if (currentNode.type !== liquid_html_parser_1.NodeTypes.LiquidFilter)
          return null;
        let name = currentNode.name, entry = (await this.themeDocset.filters()).find((entry2) => entry2.name === name);
        return entry ? {
          contents: {
            kind: "markdown",
            value: (0, docset_1.render)(entry, void 0, "filter")
          }
        } : null;
      }
    };
    exports.LiquidFilterHoverProvider = LiquidFilterHoverProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/LiquidObjectHoverProvider.js
var require_LiquidObjectHoverProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/LiquidObjectHoverProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.LiquidObjectHoverProvider = void 0;
    var liquid_html_parser_1 = require_dist(), TypeSystem_1 = require_TypeSystem(), docset_1 = require_docset(), LiquidObjectHoverProvider = class {
      constructor(typeSystem) {
        this.typeSystem = typeSystem;
      }
      async hover(currentNode, ancestors, params) {
        var _a38;
        if (currentNode.type !== liquid_html_parser_1.NodeTypes.VariableLookup && currentNode.type !== liquid_html_parser_1.NodeTypes.AssignMarkup || !currentNode.name)
          return null;
        let node = currentNode;
        node.type === liquid_html_parser_1.NodeTypes.VariableLookup && (node = {
          ...currentNode,
          lookups: []
        });
        let type = await this.typeSystem.inferType(node, ancestors[0], params.textDocument.uri), objectMap = await this.typeSystem.objectMap(params.textDocument.uri, ancestors[0]), entry = objectMap[(0, TypeSystem_1.isArrayType)(type) ? type.valueType : type];
        if (type === "untyped")
          return null;
        if (!entry) {
          let entryByName = (_a38 = objectMap[currentNode.name]) !== null && _a38 !== void 0 ? _a38 : {};
          return {
            contents: {
              kind: "markdown",
              value: (0, docset_1.render)({
                ...entryByName,
                name: currentNode.name
              }, type, "object")
            }
          };
        }
        return {
          contents: {
            kind: "markdown",
            value: (0, docset_1.render)({ ...entry, name: currentNode.name }, type, "object")
          }
        };
      }
    };
    exports.LiquidObjectHoverProvider = LiquidObjectHoverProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/LiquidObjectAttributeHoverProvider.js
var require_LiquidObjectAttributeHoverProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/LiquidObjectAttributeHoverProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.LiquidObjectAttributeHoverProvider = void 0;
    var liquid_html_parser_1 = require_dist(), TypeSystem_1 = require_TypeSystem(), docset_1 = require_docset(), LiquidObjectAttributeHoverProvider = class {
      constructor(typeSystem) {
        this.typeSystem = typeSystem;
      }
      async hover(currentNode, ancestors, params) {
        var _a38;
        let parentNode = ancestors.at(-1);
        if (currentNode.type !== liquid_html_parser_1.NodeTypes.String || !parentNode || parentNode.type !== liquid_html_parser_1.NodeTypes.VariableLookup || !parentNode.lookups.includes(currentNode))
          return null;
        let lookupIndex = parentNode.lookups.findIndex((lookup3) => lookup3 === currentNode), node = {
          ...parentNode,
          lookups: parentNode.lookups.slice(0, lookupIndex)
        }, parentType = await this.typeSystem.inferType(node, ancestors[0], params.textDocument.uri);
        if ((0, TypeSystem_1.isArrayType)(parentType))
          return null;
        let objectMap = await this.typeSystem.objectMap(params.textDocument.uri, ancestors[0]);
        if (!objectMap[parentType])
          return null;
        let entry = (((_a38 = objectMap[parentType]) === null || _a38 === void 0 ? void 0 : _a38.properties) || []).find((p) => p.name === currentNode.value);
        return entry ? {
          contents: {
            kind: "markdown",
            value: (0, docset_1.render)(entry)
          }
        } : null;
      }
    };
    exports.LiquidObjectAttributeHoverProvider = LiquidObjectAttributeHoverProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/HtmlTagHoverProvider.js
var require_HtmlTagHoverProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/HtmlTagHoverProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.HtmlTagHoverProvider = void 0;
    var docset_1 = require_docset(), utils_1 = require_utils6(), HtmlTagHoverProvider = class {
      async hover(currentNode, ancestors) {
        let name, parentNode = ancestors.at(-1);
        if ((0, utils_1.isNamedHtmlElementNode)(currentNode) && typeof currentNode.name == "string" ? name = currentNode.name : (0, utils_1.isTextNode)(currentNode) && parentNode && (0, utils_1.isNamedHtmlElementNode)(parentNode) && typeof parentNode.name != "string" && parentNode.name.includes(currentNode) && parentNode.name.length === 1 && (name = currentNode.value), !name)
          return null;
        let entry = docset_1.HtmlData.tags.find((tag) => tag.name === name);
        return entry ? {
          contents: {
            kind: "markdown",
            value: (0, docset_1.renderHtmlEntry)(entry)
          }
        } : null;
      }
    };
    exports.HtmlTagHoverProvider = HtmlTagHoverProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/HtmlAttributeHoverProvider.js
var require_HtmlAttributeHoverProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/HtmlAttributeHoverProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.HtmlAttributeHoverProvider = void 0;
    var docset_1 = require_docset(), utils_1 = require_utils6(), HtmlAttributeHoverProvider = class {
      async hover(currentNode, ancestors) {
        var _a38;
        let attributeNode = ancestors.at(-1), tagNode = (0, utils_1.findLast)(ancestors, utils_1.isNamedHtmlElementNode);
        if (!attributeNode || !tagNode || !(0, utils_1.isTextNode)(currentNode) || !(0, utils_1.isHtmlAttribute)(attributeNode) || !attributeNode.name.includes(currentNode) || attributeNode.name.length > 1 || !(0, utils_1.isNamedHtmlElementNode)(tagNode))
          return null;
        let name = currentNode.value, tagName = (0, utils_1.getCompoundName)(tagNode), tagEntry = docset_1.HtmlData.tags.find((tag) => tag.name === tagName), tagEntryAttributes = tagEntry?.attributes || [], attribute = (_a38 = docset_1.HtmlData.globalAttributes.find((attr) => attr.name === name)) !== null && _a38 !== void 0 ? _a38 : tagEntryAttributes.find((attr) => attr.name === name);
        return attribute ? {
          contents: {
            kind: "markdown",
            value: (0, docset_1.renderHtmlEntry)(attribute, "references" in attribute ? void 0 : tagEntry)
          }
        } : null;
      }
    };
    exports.HtmlAttributeHoverProvider = HtmlAttributeHoverProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/HtmlAttributeValueHoverProvider.js
var require_HtmlAttributeValueHoverProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/HtmlAttributeValueHoverProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.HtmlAttributeValueHoverProvider = void 0;
    var liquid_html_parser_1 = require_dist(), docset_1 = require_docset(), utils_1 = require_utils6(), HtmlAttributeValueHoverProvider = class {
      async hover(currentNode, ancestors) {
        var _a38;
        let attributeNode = (0, utils_1.findLast)(ancestors, utils_1.isHtmlAttribute), tagNode = (0, utils_1.findLast)(ancestors, utils_1.isNamedHtmlElementNode);
        if (!(0, utils_1.isTextNode)(currentNode) || !attributeNode || !tagNode || !(0, utils_1.isHtmlAttribute)(attributeNode) || !(0, utils_1.isNamedHtmlElementNode)(tagNode) || attributeNode.type === liquid_html_parser_1.NodeTypes.AttrEmpty || attributeNode.value.length !== 1 || !attributeNode.value.includes(currentNode))
          return null;
        let valueName = currentNode.value, attrName = (0, utils_1.getCompoundName)(attributeNode), tagName = (0, utils_1.getCompoundName)(tagNode), tagEntry = docset_1.HtmlData.tags.find((tag) => tag.name === tagName), attribute = (_a38 = docset_1.HtmlData.globalAttributes.find((attr) => attr.name === attrName)) !== null && _a38 !== void 0 ? _a38 : tagEntry?.attributes.find((attr) => attr.name === attrName), valueSetName = attribute?.valueSet, valueSetEntry = docset_1.HtmlData.valueSets.find((valueSet) => valueSet.name === valueSetName), valueEntry = valueSetEntry?.values.find((value) => value.name === valueName);
        return valueEntry ? {
          contents: {
            kind: "markdown",
            value: (0, docset_1.renderHtmlEntry)(valueEntry, attribute?.references ? attribute : tagEntry)
          }
        } : null;
      }
    };
    exports.HtmlAttributeValueHoverProvider = HtmlAttributeValueHoverProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/TranslationHoverProvider.js
var require_TranslationHoverProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/TranslationHoverProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.TranslationHoverProvider = void 0;
    var liquid_html_parser_1 = require_dist(), translations_1 = require_translations(), TranslationHoverProvider = class {
      constructor(getTranslationsForUri, documentManager) {
        this.getTranslationsForUri = getTranslationsForUri, this.documentManager = documentManager;
      }
      async hover(currentNode, ancestors, params) {
        var _a38;
        let parentNode = ancestors.at(-1);
        if (currentNode.type !== liquid_html_parser_1.NodeTypes.String || !parentNode || parentNode.type !== liquid_html_parser_1.NodeTypes.LiquidVariable || !parentNode.filters[0] || !["t", "translate"].includes(parentNode.filters[0].name))
          return null;
        let translations = await this.getTranslationsForUri(params.textDocument.uri), translation = (0, translations_1.translationValue)(currentNode.value, translations), document2 = (_a38 = this.documentManager.get(params.textDocument.uri)) === null || _a38 === void 0 ? void 0 : _a38.textDocument;
        return !translation || !document2 ? null : {
          contents: {
            kind: "markdown",
            value: (0, translations_1.renderTranslation)(translation)
          },
          range: {
            start: document2.positionAt(currentNode.position.start),
            end: document2.positionAt(currentNode.position.end)
          }
        };
      }
    };
    exports.TranslationHoverProvider = TranslationHoverProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/index.js
var require_providers4 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/providers/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.TranslationHoverProvider = exports.HtmlAttributeValueHoverProvider = exports.HtmlAttributeHoverProvider = exports.HtmlTagHoverProvider = exports.LiquidObjectAttributeHoverProvider = exports.LiquidObjectHoverProvider = exports.LiquidFilterHoverProvider = exports.LiquidTagHoverProvider = void 0;
    var LiquidTagHoverProvider_1 = require_LiquidTagHoverProvider();
    Object.defineProperty(exports, "LiquidTagHoverProvider", { enumerable: !0, get: function() {
      return LiquidTagHoverProvider_1.LiquidTagHoverProvider;
    } });
    var LiquidFilterHoverProvider_1 = require_LiquidFilterHoverProvider();
    Object.defineProperty(exports, "LiquidFilterHoverProvider", { enumerable: !0, get: function() {
      return LiquidFilterHoverProvider_1.LiquidFilterHoverProvider;
    } });
    var LiquidObjectHoverProvider_1 = require_LiquidObjectHoverProvider();
    Object.defineProperty(exports, "LiquidObjectHoverProvider", { enumerable: !0, get: function() {
      return LiquidObjectHoverProvider_1.LiquidObjectHoverProvider;
    } });
    var LiquidObjectAttributeHoverProvider_1 = require_LiquidObjectAttributeHoverProvider();
    Object.defineProperty(exports, "LiquidObjectAttributeHoverProvider", { enumerable: !0, get: function() {
      return LiquidObjectAttributeHoverProvider_1.LiquidObjectAttributeHoverProvider;
    } });
    var HtmlTagHoverProvider_1 = require_HtmlTagHoverProvider();
    Object.defineProperty(exports, "HtmlTagHoverProvider", { enumerable: !0, get: function() {
      return HtmlTagHoverProvider_1.HtmlTagHoverProvider;
    } });
    var HtmlAttributeHoverProvider_1 = require_HtmlAttributeHoverProvider();
    Object.defineProperty(exports, "HtmlAttributeHoverProvider", { enumerable: !0, get: function() {
      return HtmlAttributeHoverProvider_1.HtmlAttributeHoverProvider;
    } });
    var HtmlAttributeValueHoverProvider_1 = require_HtmlAttributeValueHoverProvider();
    Object.defineProperty(exports, "HtmlAttributeValueHoverProvider", { enumerable: !0, get: function() {
      return HtmlAttributeValueHoverProvider_1.HtmlAttributeValueHoverProvider;
    } });
    var TranslationHoverProvider_1 = require_TranslationHoverProvider();
    Object.defineProperty(exports, "TranslationHoverProvider", { enumerable: !0, get: function() {
      return TranslationHoverProvider_1.TranslationHoverProvider;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/HoverProvider.js
var require_HoverProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/HoverProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.HoverProvider = void 0;
    var theme_check_common_1 = require_dist2(), TypeSystem_1 = require_TypeSystem(), providers_1 = require_providers4(), HtmlAttributeValueHoverProvider_1 = require_HtmlAttributeValueHoverProvider(), visitor_1 = require_visitor(), HoverProvider = class {
      constructor(documentManager, themeDocset, getTranslationsForURI = async () => ({}), getSettingsSchemaForURI = async () => []) {
        this.documentManager = documentManager, this.themeDocset = themeDocset, this.getTranslationsForURI = getTranslationsForURI, this.getSettingsSchemaForURI = getSettingsSchemaForURI, this.providers = [];
        let typeSystem = new TypeSystem_1.TypeSystem(themeDocset, getSettingsSchemaForURI);
        this.providers = [
          new providers_1.LiquidTagHoverProvider(themeDocset),
          new providers_1.LiquidFilterHoverProvider(themeDocset),
          new providers_1.LiquidObjectHoverProvider(typeSystem),
          new providers_1.LiquidObjectAttributeHoverProvider(typeSystem),
          new providers_1.HtmlTagHoverProvider(),
          new providers_1.HtmlAttributeHoverProvider(),
          new HtmlAttributeValueHoverProvider_1.HtmlAttributeValueHoverProvider(),
          new providers_1.TranslationHoverProvider(getTranslationsForURI, documentManager)
        ];
      }
      async hover(params) {
        var _a38;
        let uri = params.textDocument.uri, document2 = this.documentManager.get(uri);
        if (document2?.type !== theme_check_common_1.SourceCodeType.LiquidHtml || document2.ast instanceof Error)
          return null;
        let [currentNode, ancestors] = (0, visitor_1.findCurrentNode)(document2.ast, document2.textDocument.offsetAt(params.position)), promises = this.providers.map((p) => p.hover(currentNode, ancestors, params));
        return (_a38 = (await Promise.all(promises)).find(Boolean)) !== null && _a38 !== void 0 ? _a38 : null;
      }
    };
    exports.HoverProvider = HoverProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/index.js
var require_hover = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/hover/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.HoverProvider = void 0;
    var HoverProvider_1 = require_HoverProvider();
    Object.defineProperty(exports, "HoverProvider", { enumerable: !0, get: function() {
      return HoverProvider_1.HoverProvider;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/json/TranslationFileContributions.js
var require_TranslationFileContributions = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/json/TranslationFileContributions.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.contextualizedLabel = exports.fileMatch = exports.TranslationFileContributions = void 0;
    var theme_check_common_1 = require_dist2(), translations_1 = require_translations();
    function nodeAtLocation(ast, location2) {
      return location2.reduce((value, segment) => {
        var _a38;
        if (value && typeof value != "string")
          switch (value.type) {
            case "Object":
              return (_a38 = value.children.find((child) => child.key.value === segment)) === null || _a38 === void 0 ? void 0 : _a38.value;
            case "Array":
              return typeof segment != "number" ? void 0 : value.children[segment];
            case "Identifier":
              return;
            case "Literal":
              return;
            case "Property":
              return;
          }
      }, ast);
    }
    var nothing = void 0, TranslationFileContributions = class {
      constructor(documentManager) {
        this.documentManager = documentManager, this.filePatterns = [/^.*\/locales\/[^\/]*\.json$/];
      }
      getInfoContribution(uri, location2) {
        if (!fileMatch(uri, this.filePatterns))
          return nothing;
        let doc = this.documentManager.get(uri);
        if (!doc || location2.length === 0 || doc.type !== theme_check_common_1.SourceCodeType.JSON)
          return nothing;
        let ast = doc.ast;
        if (ast instanceof Error)
          return nothing;
        let node = nodeAtLocation(ast, location2);
        switch (!0) {
          case ["zero", "one", "two", "few", "many", "other"].includes(location2.at(-1)):
            return !node || node.type !== "Literal" || typeof node.value != "string" ? Promise.resolve(["Pluralized translations should have a string value"]) : Promise.resolve([contextualizedLabel(uri, location2.slice(0, -1), node.value)]);
          case location2.at(-1).toString().endsWith("_html"):
            return !node || node.type !== "Literal" || typeof node.value != "string" ? Promise.resolve(["Translations ending in '_html' should have a string value"]) : Promise.resolve([
              contextualizedLabel(uri, location2, node.value),
              "The '_html' suffix prevents the HTML content from being escaped."
            ]);
          default:
            return !node || node.type !== "Literal" || typeof node.value != "string" ? Promise.resolve([`Translation group: ${location2.join(".")}`]) : Promise.resolve([contextualizedLabel(uri, location2, node.value)]);
        }
      }
      async collectDefaultCompletions(uri, result) {
      }
      async collectPropertyCompletions(uri, location2, currentWord, addValue, isLast, result) {
      }
      async collectValueCompletions(uri, location2, propertyKey, result) {
      }
    };
    exports.TranslationFileContributions = TranslationFileContributions;
    function fileMatch(uri, patterns) {
      return patterns.some((pattern) => pattern.test(uri));
    }
    exports.fileMatch = fileMatch;
    function contextualizedLabel(uri, str, value) {
      if (uri.includes(".schema"))
        return marked(`"t:${str.join(".")}"`, "json");
      {
        let params = (0, translations_1.extractParams)(value);
        return marked(`{{ '${str.join(".")}' | t${(0, translations_1.paramsString)(params)} }}`, "liquid");
      }
    }
    exports.contextualizedLabel = contextualizedLabel;
    function marked(value, language = "liquid") {
      return { language, value };
    }
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/json/fileMatch.js
var require_fileMatch = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/json/fileMatch.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.uriMatch = void 0;
    function uriMatch(uri, patterns) {
      return patterns.some((pattern) => pattern.test(uri));
    }
    exports.uriMatch = uriMatch;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/json/SchemaTranslationContributions.js
var require_SchemaTranslationContributions = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/json/SchemaTranslationContributions.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.findSchemaNode = exports.SchemaTranslationContributions = void 0;
    var theme_check_common_1 = require_dist2(), vscode_languageserver_protocol_1 = require_main4(), translations_1 = require_translations(), visitor_1 = require_visitor(), fileMatch_1 = require_fileMatch(), SchemaTranslationContributions = class {
      constructor(documentManager, getDefaultSchemaTranslations) {
        this.documentManager = documentManager, this.getDefaultSchemaTranslations = getDefaultSchemaTranslations, this.uriPatterns = [/^.*\/(sections|blocks)\/[^\/]*\.liquid$/];
      }
      /**
       * Because the API for JSONWorkerContribution is slightly weird, we need to
       * return undefined (not Promise<undefined>) for this contribution to be
       * skipped and fallbacks to go through. It's not typed properly either.
       */
      getInfoContribution(uri, location2) {
        if (!(0, fileMatch_1.uriMatch)(uri, this.uriPatterns))
          return;
        let doc = this.documentManager.get(uri);
        if (!doc || location2.length === 0 || doc.ast instanceof Error || doc.type !== theme_check_common_1.SourceCodeType.LiquidHtml)
          return;
        let schema = findSchemaNode(doc.ast);
        if (!schema)
          return;
        let jsonString = schema.source.slice(schema.blockStartPosition.end, schema.blockEndPosition.start), jsonDocument = (0, theme_check_common_1.parseJSON)(jsonString);
        if ((0, theme_check_common_1.isError)(jsonDocument))
          return;
        let label = location2.reduce((acc, val) => acc?.[val], jsonDocument);
        if (!(!label || typeof label != "string" || !label.startsWith("t:")))
          return this.getDefaultSchemaTranslations(uri).then((translations) => {
            let path3 = label.slice(2), value = (0, translations_1.translationValue)(path3, translations);
            if (value)
              return [(0, translations_1.renderTranslation)(value)];
          });
      }
      async collectValueCompletions(uri, location2, propertyKey, result) {
        if (!(0, fileMatch_1.uriMatch)(uri, this.uriPatterns))
          return;
        let doc = this.documentManager.get(uri);
        if (!doc || doc.ast instanceof Error || doc.type !== theme_check_common_1.SourceCodeType.LiquidHtml)
          return;
        let schema = findSchemaNode(doc.ast);
        if (!schema)
          return;
        let jsonString = schema.source.slice(schema.blockStartPosition.end, schema.blockEndPosition.start), jsonDocument = (0, theme_check_common_1.parseJSON)(jsonString);
        if (!jsonDocument)
          return;
        let label = location2.concat(propertyKey).reduce((acc, val) => acc?.[val], jsonDocument);
        if (!label || typeof label != "string" || !label.startsWith("t:"))
          return;
        let items = await this.recommendTranslations(uri, label);
        for (let item of items)
          result.add(item);
      }
      // These are only there to satisfy the TS interface
      async collectDefaultCompletions(_uri, _result) {
      }
      // prettier-ignore
      async collectPropertyCompletions(_uri, _location, _currentWord, _addValue, _isLast, _result) {
      }
      async recommendTranslations(uri, label) {
        var _a38;
        let partial = (_a38 = /^t:(.*)/.exec(label)) === null || _a38 === void 0 ? void 0 : _a38[1];
        if (!partial && partial !== "")
          return [];
        let translations = await this.getDefaultSchemaTranslations(uri);
        return (0, translations_1.translationOptions)(translations).map((option) => {
          let tLabel = `t:${option.path.join(".")}`;
          return {
            label: tLabel,
            kind: vscode_languageserver_protocol_1.CompletionItemKind.Value,
            filterText: `"${tLabel}"`,
            insertText: `"${tLabel}"`,
            insertTextFormat: 1,
            documentation: {
              kind: "markdown",
              value: (0, translations_1.renderTranslation)(option.translation)
            }
          };
        });
      }
    };
    exports.SchemaTranslationContributions = SchemaTranslationContributions;
    function findSchemaNode(ast) {
      return (0, visitor_1.visit)(ast, {
        LiquidRawTag(node) {
          if (node.name === "schema")
            return node;
        }
      })[0];
    }
    exports.findSchemaNode = findSchemaNode;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/json/JSONLanguageService.js
var require_JSONLanguageService = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/json/JSONLanguageService.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.JSONLanguageService = void 0;
    var liquid_html_parser_1 = require_dist(), theme_check_common_1 = require_dist2(), vscode_json_languageservice_1 = (init_jsonLanguageService(), __toCommonJS(jsonLanguageService_exports)), vscode_languageserver_textdocument_1 = (init_main5(), __toCommonJS(main_exports3)), visitor_1 = require_visitor(), TranslationFileContributions_1 = require_TranslationFileContributions(), SchemaTranslationContributions_1 = require_SchemaTranslationContributions(), JSONLanguageService = class {
      constructor(documentManager, jsonValidationSet, getDefaultSchemaTranslations, getModeForURI) {
        this.documentManager = documentManager, this.jsonValidationSet = jsonValidationSet, this.getDefaultSchemaTranslations = getDefaultSchemaTranslations, this.getModeForURI = getModeForURI, this.services = Object.fromEntries(theme_check_common_1.Modes.map((mode) => [mode, null])), this.schemas = {};
      }
      async setup(clientCapabilities) {
        await Promise.all(theme_check_common_1.Modes.map(async (mode) => {
          let schemas = await this.jsonValidationSet.schemas(mode);
          for (let schema of schemas)
            this.schemas[schema.uri] = schema;
          if (!schemas.length)
            return;
          let service = (0, vscode_json_languageservice_1.getLanguageService)({
            clientCapabilities,
            // Map URIs to schemas without making network requests. Removes the
            // network dependency.
            schemaRequestService: this.getSchemaForURI.bind(this),
            // This is how we make sure that our "$ref": "./inputSettings.json" in
            // our JSON schemas resolve correctly.
            workspaceContext: {
              resolveRelativePath: (relativePath2, resource) => new URL(relativePath2, resource).toString()
            },
            // Custom non-JSON schema completion & hover contributions
            contributions: [
              new TranslationFileContributions_1.TranslationFileContributions(this.documentManager),
              new SchemaTranslationContributions_1.SchemaTranslationContributions(this.documentManager, this.getDefaultSchemaTranslations)
            ]
          });
          service.configure({
            // This is what we use to map file names to JSON schemas. Without
            // this, we'd need folks to use the `$schema` field in their JSON
            // blobs. That ain't fun nor is going to happen.
            schemas: schemas.map((schemaDefinition) => ({
              uri: schemaDefinition.uri,
              fileMatch: schemaDefinition.fileMatch
            }))
          }), this.services[mode] = service;
        }));
      }
      async completions(params) {
        let mode = await this.getModeForURI(params.textDocument.uri), service = this.services[mode];
        if (!service)
          return null;
        let documents = this.getDocuments(params, service);
        if (!documents)
          return null;
        let [jsonTextDocument, jsonDocument] = documents;
        return service.doComplete(jsonTextDocument, params.position, jsonDocument);
      }
      async hover(params) {
        let mode = await this.getModeForURI(params.textDocument.uri), service = this.services[mode];
        if (!service)
          return null;
        let documents = this.getDocuments(params, service);
        if (!documents)
          return null;
        let [jsonTextDocument, jsonDocument] = documents;
        return service.doHover(jsonTextDocument, params.position, jsonDocument);
      }
      getDocuments(params, service) {
        let document2 = this.documentManager.get(params.textDocument.uri);
        if (!document2)
          return null;
        switch (document2.type) {
          case theme_check_common_1.SourceCodeType.JSON: {
            let jsonTextDocument = document2.textDocument, jsonDocument = service.parseJSONDocument(jsonTextDocument);
            return [jsonTextDocument, jsonDocument];
          }
          case theme_check_common_1.SourceCodeType.LiquidHtml: {
            if (document2.ast instanceof Error)
              return null;
            let textDocument = document2.textDocument, offset = textDocument.offsetAt(params.position), [_2, ancestors] = (0, visitor_1.findCurrentNode)(document2.ast, offset), schema = ancestors.find((node) => node.type === liquid_html_parser_1.NodeTypes.LiquidRawTag && node.name === "schema");
            if (!schema)
              return null;
            let schemaLineNumber = textDocument.positionAt(schema.blockStartPosition.end).line, jsonString = Array(schemaLineNumber).fill(`
`).join("") + schema.source.slice(schema.blockStartPosition.end, schema.blockEndPosition.start), jsonTextDocument = vscode_languageserver_textdocument_1.TextDocument.create(textDocument.uri, "json", textDocument.version, jsonString), jsonDocument = service.parseJSONDocument(jsonTextDocument);
            return [jsonTextDocument, jsonDocument];
          }
        }
      }
      async getSchemaForURI(uri) {
        var _a38;
        let schema = (_a38 = this.schemas[uri]) === null || _a38 === void 0 ? void 0 : _a38.schema;
        return schema || `Could not get schema for '${uri}'`;
      }
    };
    exports.JSONLanguageService = JSONLanguageService;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/package.json
var require_package2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/package.json"(exports, module) {
    module.exports = {
      name: "@shopify/theme-language-server-common",
      version: "1.11.4",
      main: "dist/index.js",
      types: "dist/index.d.ts",
      author: "CP Clermont <cp.clermont@shopify.com>",
      homepage: "https://github.com/Shopify/theme-tools/tree/main/packages/theme-language-server-common#readme",
      repository: {
        type: "git",
        url: "https://github.com/shopify/theme-tools.git",
        directory: "packages/theme-language-server-common"
      },
      bugs: {
        url: "https://github.com/shopify/theme-tools/issues"
      },
      license: "MIT",
      publishConfig: {
        access: "public",
        "@shopify:registry": "https://registry.npmjs.org"
      },
      scripts: {
        build: "yarn build:ts",
        "build:ci": "yarn build",
        "build:ts": "tsc -b src/tsconfig.build.json",
        dev: "tsc -b src --watch",
        test: "vitest",
        "type-check": "tsc --noEmit -p src/tsconfig.json"
      },
      dependencies: {
        "@shopify/liquid-html-parser": "^2.0.3",
        "@shopify/theme-check-common": "2.8.0",
        "@vscode/web-custom-data": "^0.4.6",
        "vscode-json-languageservice": "^5.3.10",
        "vscode-languageserver": "^8.0.2",
        "vscode-languageserver-textdocument": "^1.0.8",
        "vscode-uri": "^3.0.7"
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/version.js
var require_version2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/version.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.VERSION = void 0;
    var package_json_1 = __importDefault(require_package2());
    exports.VERSION = package_json_1.default.version;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/server/Configuration.js
var require_Configuration = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/server/Configuration.js"(exports) {
    "use strict";
    init_cjs_shims();
    var _a38, _b, _c;
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.Configuration = exports.ConfigurationKeys = exports.CHECK_ON_CHANGE = exports.CHECK_ON_SAVE = exports.CHECK_ON_OPEN = void 0;
    var theme_check_common_1 = require_dist2(), vscode_languageserver_1 = require_main5();
    exports.CHECK_ON_OPEN = "themeCheck.checkOnOpen";
    exports.CHECK_ON_SAVE = "themeCheck.checkOnSave";
    exports.CHECK_ON_CHANGE = "themeCheck.checkOnChange";
    exports.ConfigurationKeys = [exports.CHECK_ON_OPEN, exports.CHECK_ON_SAVE, exports.CHECK_ON_CHANGE];
    var Configuration = class {
      constructor(connection, capabilities) {
        this.connection = connection, this.capabilities = capabilities, this[_a38] = !0, this[_b] = !0, this[_c] = !0, this.fetchConfiguration = (0, theme_check_common_1.memo)(async () => {
          if (!this.capabilities.hasWorkspaceConfigurationSupport)
            return;
          let configs = await this.connection.workspace.getConfiguration(exports.ConfigurationKeys.map((key) => ({ section: key })));
          for (let i = 0; i < exports.ConfigurationKeys.length; i++) {
            let key = exports.ConfigurationKeys[i];
            configs[i] !== null && (this[key] = configs[i]);
          }
        }), this.registerDidChangeCapability = (0, theme_check_common_1.memo)(async () => {
          if (this.capabilities.hasDidChangeConfigurationDynamicRegistrationSupport)
            return this.connection.client.register(vscode_languageserver_1.DidChangeConfigurationNotification.type);
        }), this.connection = connection, this.capabilities = capabilities;
      }
      setup() {
        this[exports.CHECK_ON_OPEN] = this.capabilities.initializationOption(exports.CHECK_ON_OPEN, !0), this[exports.CHECK_ON_SAVE] = this.capabilities.initializationOption(exports.CHECK_ON_SAVE, !0), this[exports.CHECK_ON_CHANGE] = this.capabilities.initializationOption(exports.CHECK_ON_CHANGE, !0);
      }
      async shouldCheckOnOpen() {
        return await this.fetchConfiguration(), this[exports.CHECK_ON_OPEN];
      }
      async shouldCheckOnSave() {
        return await this.fetchConfiguration(), this[exports.CHECK_ON_SAVE];
      }
      async shouldCheckOnChange() {
        return await this.fetchConfiguration(), this[exports.CHECK_ON_CHANGE];
      }
      clearCache() {
        this.fetchConfiguration.clearCache();
      }
    };
    exports.Configuration = Configuration;
    _a38 = exports.CHECK_ON_OPEN, _b = exports.CHECK_ON_SAVE, _c = exports.CHECK_ON_CHANGE;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/server/startServer.js
var require_startServer = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/server/startServer.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.startServer = void 0;
    var theme_check_common_1 = require_dist2(), vscode_languageserver_1 = require_main5(), vscode_uri_1 = require_umd(), ClientCapabilities_1 = require_ClientCapabilities(), codeActions_1 = require_codeActions(), commands_1 = require_commands(), completions_1 = require_completions(), diagnostics_1 = require_diagnostics(), documentLinks_1 = require_documentLinks(), documents_1 = require_documents(), formatting_1 = require_formatting(), hover_1 = require_hover(), JSONLanguageService_1 = require_JSONLanguageService(), translations_1 = require_translations(), utils_1 = require_utils6(), version_1 = require_version2(), Configuration_1 = require_Configuration(), defaultLogger = () => {
    };
    function startServer2(connection, { fileExists: fileExists3, fileSize: fileSize2, filesForURI, findRootURI: findConfigurationRootURI, getDefaultLocaleFactory, getDefaultTranslationsFactory, getDefaultSchemaLocaleFactory, getDefaultSchemaTranslationsFactory, getThemeSettingsSchemaForRootURI, loadConfig: loadConfig2, log = defaultLogger, jsonValidationSet, themeDocset: remoteThemeDocset }) {
      let clientCapabilities = new ClientCapabilities_1.ClientCapabilities(), configuration = new Configuration_1.Configuration(connection, clientCapabilities), documentManager = new documents_1.DocumentManager(), diagnosticsManager = new diagnostics_1.DiagnosticsManager(connection), documentLinksProvider = new documentLinks_1.DocumentLinksProvider(documentManager), codeActionsProvider = new codeActions_1.CodeActionsProvider(documentManager, diagnosticsManager), onTypeFormattingProvider = new formatting_1.OnTypeFormattingProvider(documentManager), findThemeRootURI = async (uri) => {
        let rootUri = await findConfigurationRootURI(uri), config2 = await loadConfig2(rootUri);
        return vscode_uri_1.URI.parse(rootUri).with({
          path: config2.root
        }).toString();
      }, themeDocset = new theme_check_common_1.AugmentedThemeDocset(remoteThemeDocset), runChecks = (0, utils_1.debounce)((0, diagnostics_1.makeRunChecks)(documentManager, diagnosticsManager, {
        fileExists: fileExists3,
        fileSize: fileSize2,
        findRootURI: findConfigurationRootURI,
        getDefaultLocaleFactory,
        getDefaultTranslationsFactory,
        getDefaultSchemaLocaleFactory,
        getDefaultSchemaTranslationsFactory,
        loadConfig: loadConfig2,
        themeDocset,
        jsonValidationSet
      }), 100), getTranslationsForURI = async (uri) => {
        let rootURI = await findThemeRootURI(uri), theme = documentManager.theme(rootURI), [defaultTranslations, shopifyTranslations] = await Promise.all([
          (0, translations_1.useBufferOrInjectedTranslations)(getDefaultTranslationsFactory, theme, rootURI),
          themeDocset.systemTranslations()
        ]);
        return { ...shopifyTranslations, ...defaultTranslations };
      }, getSchemaTranslationsForURI = async (uri) => {
        let rootURI = await findThemeRootURI(uri), theme = documentManager.theme(rootURI);
        return (0, translations_1.useBufferOrInjectedSchemaTranslations)(getDefaultSchemaTranslationsFactory, theme, rootURI);
      }, getSnippetNamesForURI = async (uri) => filesForURI ? (await filesForURI(uri)).filter((x) => x.startsWith("snippets")).map((x) => x.replace(/\\/g, "/").replace(/^snippets\//, "").replace(/\..*$/, "")) : [], getThemeSettingsSchemaForURI = async (uri) => {
        let rootUri = await findThemeRootURI(uri);
        return getThemeSettingsSchemaForRootURI(rootUri);
      }, getModeForURI = async (uri) => {
        let rootUri = await findConfigurationRootURI(uri);
        return (await loadConfig2(rootUri)).context;
      }, jsonLanguageService = new JSONLanguageService_1.JSONLanguageService(documentManager, jsonValidationSet, getSchemaTranslationsForURI, getModeForURI), completionsProvider = new completions_1.CompletionsProvider({
        documentManager,
        themeDocset,
        getTranslationsForURI,
        getSnippetNamesForURI,
        getThemeSettingsSchemaForURI,
        log
      }), hoverProvider = new hover_1.HoverProvider(documentManager, themeDocset, getTranslationsForURI, getThemeSettingsSchemaForURI), executeCommandProvider = new commands_1.ExecuteCommandProvider(documentManager, diagnosticsManager, clientCapabilities, runChecks, connection);
      connection.onInitialize((params) => {
        clientCapabilities.setup(params.capabilities, params.initializationOptions), jsonLanguageService.setup(params.capabilities), configuration.setup();
        let fileOperationRegistrationOptions = {
          filters: [
            {
              scheme: "file",
              pattern: {
                glob: "**/*.{liquid,json}"
              }
            }
          ]
        };
        return {
          capabilities: {
            textDocumentSync: {
              change: vscode_languageserver_1.TextDocumentSyncKind.Full,
              save: !0,
              openClose: !0
            },
            codeActionProvider: {
              codeActionKinds: [...codeActions_1.CodeActionKinds]
            },
            completionProvider: {
              triggerCharacters: [".", "{{ ", "{% ", "<", "/", "[", '"', "'", ":"]
            },
            documentOnTypeFormattingProvider: {
              firstTriggerCharacter: " ",
              moreTriggerCharacter: ["{", "%", "-"]
            },
            documentLinkProvider: {
              resolveProvider: !1,
              workDoneProgress: !1
            },
            executeCommandProvider: {
              commands: [...commands_1.Commands]
            },
            hoverProvider: {
              workDoneProgress: !1
            },
            workspace: {
              fileOperations: {
                didRename: fileOperationRegistrationOptions,
                didCreate: fileOperationRegistrationOptions,
                didDelete: fileOperationRegistrationOptions
              }
            }
          },
          serverInfo: {
            name: "theme-language-server",
            version: version_1.VERSION
          }
        };
      }), connection.onInitialized(() => {
        log("[SERVER] Let's roll!"), configuration.fetchConfiguration(), configuration.registerDidChangeCapability();
      }), connection.onDidChangeConfiguration((_params) => {
        configuration.clearCache();
      }), connection.onDidOpenTextDocument(async (params) => {
        let { uri, text, version: version2 } = params.textDocument;
        documentManager.open(uri, text, version2), await configuration.shouldCheckOnOpen() && runChecks([uri]);
      }), connection.onDidChangeTextDocument(async (params) => {
        let { uri, version: version2 } = params.textDocument;
        documentManager.change(uri, params.contentChanges[0].text, version2), await configuration.shouldCheckOnChange() ? runChecks([uri]) : diagnosticsManager.clear(params.textDocument.uri);
      }), connection.onDidSaveTextDocument(async (params) => {
        let { uri } = params.textDocument;
        await configuration.shouldCheckOnSave() && runChecks([uri]);
      }), connection.onDidCloseTextDocument((params) => {
        let { uri } = params.textDocument;
        documentManager.close(uri), diagnosticsManager.clear(uri);
      }), connection.onDocumentLinks(async (params) => {
        let { uri } = params.textDocument, rootUri = await findThemeRootURI(uri);
        return documentLinksProvider.documentLinks(uri, rootUri);
      }), connection.onCodeAction(async (params) => codeActionsProvider.codeActions(params)), connection.onExecuteCommand(async (params) => {
        await executeCommandProvider.execute(params);
      }), connection.onCompletion(async (params) => {
        var _a38;
        return (_a38 = await jsonLanguageService.completions(params)) !== null && _a38 !== void 0 ? _a38 : await completionsProvider.completions(params);
      }), connection.onHover(async (params) => {
        var _a38;
        return (_a38 = await jsonLanguageService.hover(params)) !== null && _a38 !== void 0 ? _a38 : await hoverProvider.hover(params);
      }), connection.onDocumentOnTypeFormatting(async (params) => onTypeFormattingProvider.onTypeFormatting(params)), connection.workspace.onDidCreateFiles((params) => {
        let triggerUris = params.files.map((fileCreate) => fileCreate.uri);
        runChecks.force(triggerUris);
      }), connection.workspace.onDidRenameFiles((params) => {
        let triggerUris = params.files.map((fileRename) => fileRename.newUri);
        runChecks.force(triggerUris);
      }), connection.workspace.onDidDeleteFiles((params) => {
        let triggerUris = params.files.map((fileDelete) => fileDelete.uri);
        runChecks.force(triggerUris);
      }), connection.listen();
    }
    exports.startServer = startServer2;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/server/index.js
var require_server2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/server/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.startServer = void 0;
    var startServer_1 = require_startServer();
    Object.defineProperty(exports, "startServer", { enumerable: !0, get: function() {
      return startServer_1.startServer;
    } });
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/index.js
var require_dist6 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-common@1.11.4/node_modules/@shopify/theme-language-server-common/dist/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p) && __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.allChecks = exports.recommendedChecks = exports.startServer = exports.memo = exports.debounce = void 0;
    var theme_check_common_1 = require_dist2();
    Object.defineProperty(exports, "allChecks", { enumerable: !0, get: function() {
      return theme_check_common_1.allChecks;
    } });
    Object.defineProperty(exports, "recommendedChecks", { enumerable: !0, get: function() {
      return theme_check_common_1.recommended;
    } });
    __exportStar(require_types5(), exports);
    var utils_1 = require_utils6();
    Object.defineProperty(exports, "debounce", { enumerable: !0, get: function() {
      return utils_1.debounce;
    } });
    Object.defineProperty(exports, "memo", { enumerable: !0, get: function() {
      return utils_1.memo;
    } });
    var server_1 = require_server2();
    Object.defineProperty(exports, "startServer", { enumerable: !0, get: function() {
      return server_1.startServer;
    } });
  }
});

// ../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/node.js
var require_node4 = __commonJS({
  "../../node_modules/.pnpm/vscode-languageserver@8.1.0/node_modules/vscode-languageserver/node.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = require_main5();
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-node@1.11.4/node_modules/@shopify/theme-language-server-node/dist/dependencies.js
var require_dependencies = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-node@1.11.4/node_modules/@shopify/theme-language-server-node/dist/dependencies.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: !0, value: v });
    } : function(o, v) {
      o.default = v;
    }), __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null)
        for (var k in mod)
          k !== "default" && Object.prototype.hasOwnProperty.call(mod, k) && __createBinding(result, mod, k);
      return __setModuleDefault(result, mod), result;
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.getThemeSettingsSchemaForRootURI = exports.getDefaultSchemaLocaleFactory = exports.getDefaultLocaleFactory = exports.getDefaultSchemaTranslationsFactory = exports.getDefaultTranslationsFactory = exports.getDefaultTranslationsFactoryFactory = exports.loadConfig = exports.fileSize = exports.fileExists = exports.findRootURI = exports.filesForURI = void 0;
    var theme_check_node_1 = require_dist5(), glob_1 = require_glob2(), fs6 = __importStar(__require("node:fs/promises")), node_path_1 = __require("node:path"), node_util_1 = __require("node:util"), vscode_uri_1 = require_umd(), glob2 = (0, node_util_1.promisify)(glob_1.glob);
    function parse4(uri) {
      return vscode_uri_1.URI.parse(uri);
    }
    function asPath(uri) {
      return uri.path;
    }
    function asFsPath(uriOrPath) {
      return vscode_uri_1.URI.isUri(uriOrPath) ? uriOrPath.fsPath : vscode_uri_1.URI.file(uriOrPath).fsPath;
    }
    var UriPathHandler = {
      join(base, ...paths) {
        return asFsPath(vscode_uri_1.Utils.joinPath(base, ...paths));
      },
      dirname(uri) {
        return vscode_uri_1.Utils.dirname(uri);
      },
      asPath(uri) {
        return asFsPath(uri);
      }
    };
    async function findRoot(curr) {
      return (0, theme_check_node_1.reusableFindRoot)(curr, UriPathHandler);
    }
    var filesForURI = async function(uriString) {
      let config2 = await (0, exports.loadConfig)(uriString), rootPath = asFsPath(config2.root);
      return glob2("**/*.{liquid,json}", { cwd: rootPath, ignore: "node_modules/**" });
    };
    exports.filesForURI = filesForURI;
    var findRootURI = async function(uriString) {
      let uri = parse4(uriString);
      return (await findRoot(uri)).toString();
    };
    exports.findRootURI = findRootURI;
    var fileExists3 = async function(path3) {
      try {
        return await fs6.stat(asFsPath(path3)), !0;
      } catch {
        return !1;
      }
    };
    exports.fileExists = fileExists3;
    var fileSize2 = async function(absolutePath) {
      try {
        return (await fs6.stat(asFsPath(absolutePath))).size;
      } catch (e) {
        throw new Error(`Failed to get file size: ${e}`);
      }
    };
    exports.fileSize = fileSize2;
    var hasThemeAppExtensionConfig = (0, theme_check_node_1.memoize)(async (rootPath) => (await glob2("*.extension.toml", { cwd: rootPath })).length > 0, (x) => x), loadConfig2 = async function(uriString) {
      let fileUri = parse4(uriString), rootUri = await findRoot(fileUri), rootPath = asFsPath(rootUri), configUri = vscode_uri_1.Utils.joinPath(rootUri, ".theme-check.yml"), configPath = asFsPath(configUri), [configExists, isDefinitelyThemeAppExtension] = await Promise.all([
        (0, exports.fileExists)(configPath),
        hasThemeAppExtensionConfig(rootPath)
      ]);
      return configExists ? (0, theme_check_node_1.loadConfig)(configPath, rootPath).then(normalizeRoot) : isDefinitelyThemeAppExtension ? (0, theme_check_node_1.loadConfig)("theme-check:theme-app-extension", rootPath).then(normalizeRoot) : (0, theme_check_node_1.loadConfig)(void 0, rootPath).then(normalizeRoot);
    };
    exports.loadConfig = loadConfig2;
    var getDefaultTranslationsFactoryFactory = (postfix = ".default.json") => (rootURI) => {
      let root = parse4(rootURI);
      return cached(async () => {
        try {
          let defaultLocale = await getDefaultLocale(root, postfix), defaultTranslationsFileUri = vscode_uri_1.Utils.joinPath(root, "locales", `${defaultLocale}${postfix}`), defaultTranslationsFile = await fs6.readFile(asFsPath(defaultTranslationsFileUri), "utf8"), translations = (0, theme_check_node_1.parseJSON)(defaultTranslationsFile);
          return (0, theme_check_node_1.isError)(translations) ? {} : translations;
        } catch {
          return {};
        }
      });
    };
    exports.getDefaultTranslationsFactoryFactory = getDefaultTranslationsFactoryFactory;
    exports.getDefaultTranslationsFactory = (0, exports.getDefaultTranslationsFactoryFactory)(".default.json");
    exports.getDefaultSchemaTranslationsFactory = (0, exports.getDefaultTranslationsFactoryFactory)(".default.schema.json");
    var getDefaultLocaleFactoryFactory = (postfix = ".default.json") => (rootURI) => {
      let root = parse4(rootURI);
      return cached(() => getDefaultLocale(root, postfix));
    };
    exports.getDefaultLocaleFactory = getDefaultLocaleFactoryFactory(".default.json");
    exports.getDefaultSchemaLocaleFactory = getDefaultLocaleFactoryFactory(".default.schema.json");
    async function getDefaultLocale(rootURI, postfix = ".default.json") {
      try {
        let localesFolder = vscode_uri_1.Utils.joinPath(rootURI, "locales"), file = (await fs6.readdir(asFsPath(localesFolder), {
          encoding: "utf8",
          withFileTypes: !0
        })).find((dirent) => dirent.isFile() && dirent.name.endsWith(postfix));
        return file ? (0, node_path_1.basename)(file.name, postfix) : "en";
      } catch {
        return "en";
      }
    }
    function cached(fn) {
      let cachedPromise;
      return async (...args) => (cachedPromise || (cachedPromise = fn(...args)), cachedPromise);
    }
    function normalizeRoot(config2) {
      return config2.root = asPath(vscode_uri_1.URI.file(config2.root)), config2;
    }
    var getThemeSettingsSchemaForRootURI = async (rootUriString) => {
      try {
        let rootURI = parse4(rootUriString), settingsSchemaFilePath = vscode_uri_1.Utils.joinPath(rootURI, "config/settings_schema.json"), contents = await fs6.readFile(asFsPath(settingsSchemaFilePath), "utf8"), json = (0, theme_check_node_1.parseJSON)(contents);
        if ((0, theme_check_node_1.isError)(json) || !Array.isArray(json))
          throw new Error("Settings JSON file not in correct format");
        return json;
      } catch (error) {
        return console.error(error), [];
      }
    };
    exports.getThemeSettingsSchemaForRootURI = getThemeSettingsSchemaForRootURI;
  }
});

// ../../node_modules/.pnpm/@shopify+theme-language-server-node@1.11.4/node_modules/@shopify/theme-language-server-node/dist/index.js
var require_dist7 = __commonJS({
  "../../node_modules/.pnpm/@shopify+theme-language-server-node@1.11.4/node_modules/@shopify/theme-language-server-node/dist/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.startServer = void 0;
    var theme_language_server_common_1 = require_dist6(), theme_check_docs_updater_1 = require_dist3(), node_process_1 = __require("node:process"), node_1 = require_node4(), dependencies_1 = require_dependencies();
    function startServer2() {
      let connection = (0, node_1.createConnection)(node_process_1.stdin, node_process_1.stdout), log = (message) => console.error(message), themeLiquidDocsManager = new theme_check_docs_updater_1.ThemeLiquidDocsManager(log);
      (0, theme_language_server_common_1.startServer)(connection, {
        // Using console.error to not interfere with messages sent on STDIN/OUT
        log,
        getDefaultTranslationsFactory: dependencies_1.getDefaultTranslationsFactory,
        getDefaultLocaleFactory: dependencies_1.getDefaultLocaleFactory,
        getDefaultSchemaLocaleFactory: dependencies_1.getDefaultSchemaLocaleFactory,
        getDefaultSchemaTranslationsFactory: dependencies_1.getDefaultSchemaTranslationsFactory,
        getThemeSettingsSchemaForRootURI: dependencies_1.getThemeSettingsSchemaForRootURI,
        findRootURI: dependencies_1.findRootURI,
        fileExists: dependencies_1.fileExists,
        fileSize: dependencies_1.fileSize,
        filesForURI: dependencies_1.filesForURI,
        loadConfig: dependencies_1.loadConfig,
        themeDocset: themeLiquidDocsManager,
        jsonValidationSet: themeLiquidDocsManager
      });
    }
    exports.startServer = startServer2;
  }
});

// ../../node_modules/.pnpm/readdir-glob@1.1.3/node_modules/readdir-glob/index.js
var require_readdir_glob = __commonJS({
  "../../node_modules/.pnpm/readdir-glob@1.1.3/node_modules/readdir-glob/index.js"(exports, module) {
    init_cjs_shims();
    module.exports = readdirGlob;
    var fs6 = __require("fs"), { EventEmitter: EventEmitter3 } = __require("events"), { Minimatch } = require_minimatch(), { resolve: resolve2 } = __require("path");
    function readdir2(dir, strict) {
      return new Promise((resolve3, reject) => {
        fs6.readdir(dir, { withFileTypes: !0 }, (err2, files) => {
          if (err2)
            switch (err2.code) {
              case "ENOTDIR":
                strict ? reject(err2) : resolve3([]);
                break;
              case "ENOTSUP":
              case "ENOENT":
              case "ENAMETOOLONG":
              case "UNKNOWN":
                resolve3([]);
                break;
              case "ELOOP":
              default:
                reject(err2);
                break;
            }
          else
            resolve3(files);
        });
      });
    }
    function stat(file, followSymlinks) {
      return new Promise((resolve3, reject) => {
        (followSymlinks ? fs6.stat : fs6.lstat)(file, (err2, stats) => {
          if (err2)
            switch (err2.code) {
              case "ENOENT":
                resolve3(followSymlinks ? stat(file, !1) : null);
                break;
              default:
                resolve3(null);
                break;
            }
          else
            resolve3(stats);
        });
      });
    }
    async function* exploreWalkAsync(dir, path3, followSymlinks, useStat, shouldSkip, strict) {
      let files = await readdir2(path3 + dir, strict);
      for (let file of files) {
        let name = file.name;
        name === void 0 && (name = file, useStat = !0);
        let filename = dir + "/" + name, relative = filename.slice(1), absolute = path3 + "/" + relative, stats = null;
        (useStat || followSymlinks) && (stats = await stat(absolute, followSymlinks)), !stats && file.name !== void 0 && (stats = file), stats === null && (stats = { isDirectory: () => !1 }), stats.isDirectory() ? shouldSkip(relative) || (yield { relative, absolute, stats }, yield* exploreWalkAsync(filename, path3, followSymlinks, useStat, shouldSkip, !1)) : yield { relative, absolute, stats };
      }
    }
    async function* explore(path3, followSymlinks, useStat, shouldSkip) {
      yield* exploreWalkAsync("", path3, followSymlinks, useStat, shouldSkip, !0);
    }
    function readOptions(options) {
      return {
        pattern: options.pattern,
        dot: !!options.dot,
        noglobstar: !!options.noglobstar,
        matchBase: !!options.matchBase,
        nocase: !!options.nocase,
        ignore: options.ignore,
        skip: options.skip,
        follow: !!options.follow,
        stat: !!options.stat,
        nodir: !!options.nodir,
        mark: !!options.mark,
        silent: !!options.silent,
        absolute: !!options.absolute
      };
    }
    var ReaddirGlob = class extends EventEmitter3 {
      constructor(cwd2, options, cb) {
        if (super(), typeof options == "function" && (cb = options, options = null), this.options = readOptions(options || {}), this.matchers = [], this.options.pattern) {
          let matchers = Array.isArray(this.options.pattern) ? this.options.pattern : [this.options.pattern];
          this.matchers = matchers.map(
            (m) => new Minimatch(m, {
              dot: this.options.dot,
              noglobstar: this.options.noglobstar,
              matchBase: this.options.matchBase,
              nocase: this.options.nocase
            })
          );
        }
        if (this.ignoreMatchers = [], this.options.ignore) {
          let ignorePatterns = Array.isArray(this.options.ignore) ? this.options.ignore : [this.options.ignore];
          this.ignoreMatchers = ignorePatterns.map(
            (ignore) => new Minimatch(ignore, { dot: !0 })
          );
        }
        if (this.skipMatchers = [], this.options.skip) {
          let skipPatterns = Array.isArray(this.options.skip) ? this.options.skip : [this.options.skip];
          this.skipMatchers = skipPatterns.map(
            (skip) => new Minimatch(skip, { dot: !0 })
          );
        }
        this.iterator = explore(resolve2(cwd2 || "."), this.options.follow, this.options.stat, this._shouldSkipDirectory.bind(this)), this.paused = !1, this.inactive = !1, this.aborted = !1, cb && (this._matches = [], this.on("match", (match2) => this._matches.push(this.options.absolute ? match2.absolute : match2.relative)), this.on("error", (err2) => cb(err2)), this.on("end", () => cb(null, this._matches))), setTimeout(() => this._next(), 0);
      }
      _shouldSkipDirectory(relative) {
        return this.skipMatchers.some((m) => m.match(relative));
      }
      _fileMatches(relative, isDirectory2) {
        let file = relative + (isDirectory2 ? "/" : "");
        return (this.matchers.length === 0 || this.matchers.some((m) => m.match(file))) && !this.ignoreMatchers.some((m) => m.match(file)) && (!this.options.nodir || !isDirectory2);
      }
      _next() {
        !this.paused && !this.aborted ? this.iterator.next().then((obj) => {
          if (obj.done)
            this.emit("end");
          else {
            let isDirectory2 = obj.value.stats.isDirectory();
            if (this._fileMatches(obj.value.relative, isDirectory2)) {
              let relative = obj.value.relative, absolute = obj.value.absolute;
              this.options.mark && isDirectory2 && (relative += "/", absolute += "/"), this.options.stat ? this.emit("match", { relative, absolute, stat: obj.value.stats }) : this.emit("match", { relative, absolute });
            }
            this._next(this.iterator);
          }
        }).catch((err2) => {
          this.abort(), this.emit("error", err2), !err2.code && !this.options.silent && console.error(err2);
        }) : this.inactive = !0;
      }
      abort() {
        this.aborted = !0;
      }
      pause() {
        this.paused = !0;
      }
      resume() {
        this.paused = !1, this.inactive && (this.inactive = !1, this._next());
      }
    };
    function readdirGlob(pattern, options, cb) {
      return new ReaddirGlob(pattern, options, cb);
    }
    readdirGlob.ReaddirGlob = ReaddirGlob;
  }
});

// ../../node_modules/.pnpm/async@3.2.5/node_modules/async/dist/async.js
var require_async = __commonJS({
  "../../node_modules/.pnpm/async@3.2.5/node_modules/async/dist/async.js"(exports, module) {
    init_cjs_shims();
    (function(global2, factory) {
      typeof exports == "object" && typeof module < "u" ? factory(exports) : typeof define == "function" && define.amd ? define(["exports"], factory) : (global2 = typeof globalThis < "u" ? globalThis : global2 || self, factory(global2.async = {}));
    })(exports, function(exports2) {
      "use strict";
      function apply(fn, ...args) {
        return (...callArgs) => fn(...args, ...callArgs);
      }
      function initialParams(fn) {
        return function(...args) {
          var callback = args.pop();
          return fn.call(this, args, callback);
        };
      }
      var hasQueueMicrotask = typeof queueMicrotask == "function" && queueMicrotask, hasSetImmediate = typeof setImmediate == "function" && setImmediate, hasNextTick = typeof process == "object" && typeof process.nextTick == "function";
      function fallback(fn) {
        setTimeout(fn, 0);
      }
      function wrap(defer2) {
        return (fn, ...args) => defer2(() => fn(...args));
      }
      var _defer$1;
      hasQueueMicrotask ? _defer$1 = queueMicrotask : hasSetImmediate ? _defer$1 = setImmediate : hasNextTick ? _defer$1 = process.nextTick : _defer$1 = fallback;
      var setImmediate$1 = wrap(_defer$1);
      function asyncify(func) {
        return isAsync(func) ? function(...args) {
          let callback = args.pop(), promise = func.apply(this, args);
          return handlePromise(promise, callback);
        } : initialParams(function(args, callback) {
          var result;
          try {
            result = func.apply(this, args);
          } catch (e) {
            return callback(e);
          }
          if (result && typeof result.then == "function")
            return handlePromise(result, callback);
          callback(null, result);
        });
      }
      function handlePromise(promise, callback) {
        return promise.then((value) => {
          invokeCallback(callback, null, value);
        }, (err2) => {
          invokeCallback(callback, err2 && (err2 instanceof Error || err2.message) ? err2 : new Error(err2));
        });
      }
      function invokeCallback(callback, error, value) {
        try {
          callback(error, value);
        } catch (err2) {
          setImmediate$1((e) => {
            throw e;
          }, err2);
        }
      }
      function isAsync(fn) {
        return fn[Symbol.toStringTag] === "AsyncFunction";
      }
      function isAsyncGenerator(fn) {
        return fn[Symbol.toStringTag] === "AsyncGenerator";
      }
      function isAsyncIterable(obj) {
        return typeof obj[Symbol.asyncIterator] == "function";
      }
      function wrapAsync(asyncFn) {
        if (typeof asyncFn != "function")
          throw new Error("expected a function");
        return isAsync(asyncFn) ? asyncify(asyncFn) : asyncFn;
      }
      function awaitify(asyncFn, arity) {
        if (arity || (arity = asyncFn.length), !arity)
          throw new Error("arity is undefined");
        function awaitable(...args) {
          return typeof args[arity - 1] == "function" ? asyncFn.apply(this, args) : new Promise((resolve2, reject2) => {
            args[arity - 1] = (err2, ...cbArgs) => {
              if (err2)
                return reject2(err2);
              resolve2(cbArgs.length > 1 ? cbArgs : cbArgs[0]);
            }, asyncFn.apply(this, args);
          });
        }
        return awaitable;
      }
      function applyEach$1(eachfn) {
        return function(fns, ...callArgs) {
          return awaitify(function(callback) {
            var that = this;
            return eachfn(fns, (fn, cb) => {
              wrapAsync(fn).apply(that, callArgs.concat(cb));
            }, callback);
          });
        };
      }
      function _asyncMap(eachfn, arr, iteratee, callback) {
        arr = arr || [];
        var results = [], counter = 0, _iteratee = wrapAsync(iteratee);
        return eachfn(arr, (value, _2, iterCb) => {
          var index2 = counter++;
          _iteratee(value, (err2, v) => {
            results[index2] = v, iterCb(err2);
          });
        }, (err2) => {
          callback(err2, results);
        });
      }
      function isArrayLike(value) {
        return value && typeof value.length == "number" && value.length >= 0 && value.length % 1 === 0;
      }
      var breakLoop$1 = {};
      function once(fn) {
        function wrapper(...args) {
          if (fn !== null) {
            var callFn = fn;
            fn = null, callFn.apply(this, args);
          }
        }
        return Object.assign(wrapper, fn), wrapper;
      }
      function getIterator(coll) {
        return coll[Symbol.iterator] && coll[Symbol.iterator]();
      }
      function createArrayIterator(coll) {
        var i = -1, len = coll.length;
        return function() {
          return ++i < len ? { value: coll[i], key: i } : null;
        };
      }
      function createES2015Iterator(iterator) {
        var i = -1;
        return function() {
          var item = iterator.next();
          return item.done ? null : (i++, { value: item.value, key: i });
        };
      }
      function createObjectIterator(obj) {
        var okeys = obj ? Object.keys(obj) : [], i = -1, len = okeys.length;
        return function next() {
          var key = okeys[++i];
          return key === "__proto__" ? next() : i < len ? { value: obj[key], key } : null;
        };
      }
      function createIterator(coll) {
        if (isArrayLike(coll))
          return createArrayIterator(coll);
        var iterator = getIterator(coll);
        return iterator ? createES2015Iterator(iterator) : createObjectIterator(coll);
      }
      function onlyOnce(fn) {
        return function(...args) {
          if (fn === null)
            throw new Error("Callback was already called.");
          var callFn = fn;
          fn = null, callFn.apply(this, args);
        };
      }
      function asyncEachOfLimit(generator, limit, iteratee, callback) {
        let done = !1, canceled = !1, awaiting = !1, running = 0, idx = 0;
        function replenish() {
          running >= limit || awaiting || done || (awaiting = !0, generator.next().then(({ value, done: iterDone }) => {
            if (!(canceled || done)) {
              if (awaiting = !1, iterDone) {
                done = !0, running <= 0 && callback(null);
                return;
              }
              running++, iteratee(value, idx, iterateeCallback), idx++, replenish();
            }
          }).catch(handleError));
        }
        function iterateeCallback(err2, result) {
          if (running -= 1, !canceled) {
            if (err2)
              return handleError(err2);
            if (err2 === !1) {
              done = !0, canceled = !0;
              return;
            }
            if (result === breakLoop$1 || done && running <= 0)
              return done = !0, callback(null);
            replenish();
          }
        }
        function handleError(err2) {
          canceled || (awaiting = !1, done = !0, callback(err2));
        }
        replenish();
      }
      var eachOfLimit$2 = (limit) => (obj, iteratee, callback) => {
        if (callback = once(callback), limit <= 0)
          throw new RangeError("concurrency limit cannot be less than 1");
        if (!obj)
          return callback(null);
        if (isAsyncGenerator(obj))
          return asyncEachOfLimit(obj, limit, iteratee, callback);
        if (isAsyncIterable(obj))
          return asyncEachOfLimit(obj[Symbol.asyncIterator](), limit, iteratee, callback);
        var nextElem = createIterator(obj), done = !1, canceled = !1, running = 0, looping = !1;
        function iterateeCallback(err2, value) {
          if (!canceled)
            if (running -= 1, err2)
              done = !0, callback(err2);
            else if (err2 === !1)
              done = !0, canceled = !0;
            else {
              if (value === breakLoop$1 || done && running <= 0)
                return done = !0, callback(null);
              looping || replenish();
            }
        }
        function replenish() {
          for (looping = !0; running < limit && !done; ) {
            var elem = nextElem();
            if (elem === null) {
              done = !0, running <= 0 && callback(null);
              return;
            }
            running += 1, iteratee(elem.value, elem.key, onlyOnce(iterateeCallback));
          }
          looping = !1;
        }
        replenish();
      };
      function eachOfLimit(coll, limit, iteratee, callback) {
        return eachOfLimit$2(limit)(coll, wrapAsync(iteratee), callback);
      }
      var eachOfLimit$1 = awaitify(eachOfLimit, 4);
      function eachOfArrayLike(coll, iteratee, callback) {
        callback = once(callback);
        var index2 = 0, completed = 0, { length } = coll, canceled = !1;
        length === 0 && callback(null);
        function iteratorCallback(err2, value) {
          err2 === !1 && (canceled = !0), canceled !== !0 && (err2 ? callback(err2) : (++completed === length || value === breakLoop$1) && callback(null));
        }
        for (; index2 < length; index2++)
          iteratee(coll[index2], index2, onlyOnce(iteratorCallback));
      }
      function eachOfGeneric(coll, iteratee, callback) {
        return eachOfLimit$1(coll, 1 / 0, iteratee, callback);
      }
      function eachOf(coll, iteratee, callback) {
        var eachOfImplementation = isArrayLike(coll) ? eachOfArrayLike : eachOfGeneric;
        return eachOfImplementation(coll, wrapAsync(iteratee), callback);
      }
      var eachOf$1 = awaitify(eachOf, 3);
      function map(coll, iteratee, callback) {
        return _asyncMap(eachOf$1, coll, iteratee, callback);
      }
      var map$1 = awaitify(map, 3), applyEach = applyEach$1(map$1);
      function eachOfSeries(coll, iteratee, callback) {
        return eachOfLimit$1(coll, 1, iteratee, callback);
      }
      var eachOfSeries$1 = awaitify(eachOfSeries, 3);
      function mapSeries(coll, iteratee, callback) {
        return _asyncMap(eachOfSeries$1, coll, iteratee, callback);
      }
      var mapSeries$1 = awaitify(mapSeries, 3), applyEachSeries = applyEach$1(mapSeries$1);
      let PROMISE_SYMBOL = Symbol("promiseCallback");
      function promiseCallback() {
        let resolve2, reject2;
        function callback(err2, ...args) {
          if (err2)
            return reject2(err2);
          resolve2(args.length > 1 ? args : args[0]);
        }
        return callback[PROMISE_SYMBOL] = new Promise((res, rej) => {
          resolve2 = res, reject2 = rej;
        }), callback;
      }
      function auto(tasks, concurrency, callback) {
        typeof concurrency != "number" && (callback = concurrency, concurrency = null), callback = once(callback || promiseCallback());
        var numTasks = Object.keys(tasks).length;
        if (!numTasks)
          return callback(null);
        concurrency || (concurrency = numTasks);
        var results = {}, runningTasks = 0, canceled = !1, hasError = !1, listeners = /* @__PURE__ */ Object.create(null), readyTasks = [], readyToCheck = [], uncheckedDependencies = {};
        Object.keys(tasks).forEach((key) => {
          var task = tasks[key];
          if (!Array.isArray(task)) {
            enqueueTask(key, [task]), readyToCheck.push(key);
            return;
          }
          var dependencies = task.slice(0, task.length - 1), remainingDependencies = dependencies.length;
          if (remainingDependencies === 0) {
            enqueueTask(key, task), readyToCheck.push(key);
            return;
          }
          uncheckedDependencies[key] = remainingDependencies, dependencies.forEach((dependencyName) => {
            if (!tasks[dependencyName])
              throw new Error("async.auto task `" + key + "` has a non-existent dependency `" + dependencyName + "` in " + dependencies.join(", "));
            addListener(dependencyName, () => {
              remainingDependencies--, remainingDependencies === 0 && enqueueTask(key, task);
            });
          });
        }), checkForDeadlocks(), processQueue();
        function enqueueTask(key, task) {
          readyTasks.push(() => runTask(key, task));
        }
        function processQueue() {
          if (!canceled) {
            if (readyTasks.length === 0 && runningTasks === 0)
              return callback(null, results);
            for (; readyTasks.length && runningTasks < concurrency; ) {
              var run = readyTasks.shift();
              run();
            }
          }
        }
        function addListener(taskName, fn) {
          var taskListeners = listeners[taskName];
          taskListeners || (taskListeners = listeners[taskName] = []), taskListeners.push(fn);
        }
        function taskComplete(taskName) {
          var taskListeners = listeners[taskName] || [];
          taskListeners.forEach((fn) => fn()), processQueue();
        }
        function runTask(key, task) {
          if (!hasError) {
            var taskCallback = onlyOnce((err2, ...result) => {
              if (runningTasks--, err2 === !1) {
                canceled = !0;
                return;
              }
              if (result.length < 2 && ([result] = result), err2) {
                var safeResults = {};
                if (Object.keys(results).forEach((rkey) => {
                  safeResults[rkey] = results[rkey];
                }), safeResults[key] = result, hasError = !0, listeners = /* @__PURE__ */ Object.create(null), canceled)
                  return;
                callback(err2, safeResults);
              } else
                results[key] = result, taskComplete(key);
            });
            runningTasks++;
            var taskFn = wrapAsync(task[task.length - 1]);
            task.length > 1 ? taskFn(results, taskCallback) : taskFn(taskCallback);
          }
        }
        function checkForDeadlocks() {
          for (var currentTask, counter = 0; readyToCheck.length; )
            currentTask = readyToCheck.pop(), counter++, getDependents(currentTask).forEach((dependent) => {
              --uncheckedDependencies[dependent] === 0 && readyToCheck.push(dependent);
            });
          if (counter !== numTasks)
            throw new Error(
              "async.auto cannot execute tasks due to a recursive dependency"
            );
        }
        function getDependents(taskName) {
          var result = [];
          return Object.keys(tasks).forEach((key) => {
            let task = tasks[key];
            Array.isArray(task) && task.indexOf(taskName) >= 0 && result.push(key);
          }), result;
        }
        return callback[PROMISE_SYMBOL];
      }
      var FN_ARGS = /^(?:async\s+)?(?:function)?\s*\w*\s*\(\s*([^)]+)\s*\)(?:\s*{)/, ARROW_FN_ARGS = /^(?:async\s+)?\(?\s*([^)=]+)\s*\)?(?:\s*=>)/, FN_ARG_SPLIT = /,/, FN_ARG = /(=.+)?(\s*)$/;
      function stripComments3(string) {
        let stripped = "", index2 = 0, endBlockComment = string.indexOf("*/");
        for (; index2 < string.length; )
          if (string[index2] === "/" && string[index2 + 1] === "/") {
            let endIndex = string.indexOf(`
`, index2);
            index2 = endIndex === -1 ? string.length : endIndex;
          } else if (endBlockComment !== -1 && string[index2] === "/" && string[index2 + 1] === "*") {
            let endIndex = string.indexOf("*/", index2);
            endIndex !== -1 ? (index2 = endIndex + 2, endBlockComment = string.indexOf("*/", index2)) : (stripped += string[index2], index2++);
          } else
            stripped += string[index2], index2++;
        return stripped;
      }
      function parseParams(func) {
        let src = stripComments3(func.toString()), match2 = src.match(FN_ARGS);
        if (match2 || (match2 = src.match(ARROW_FN_ARGS)), !match2)
          throw new Error(`could not parse args in autoInject
Source:
` + src);
        let [, args] = match2;
        return args.replace(/\s/g, "").split(FN_ARG_SPLIT).map((arg) => arg.replace(FN_ARG, "").trim());
      }
      function autoInject(tasks, callback) {
        var newTasks = {};
        return Object.keys(tasks).forEach((key) => {
          var taskFn = tasks[key], params, fnIsAsync = isAsync(taskFn), hasNoDeps = !fnIsAsync && taskFn.length === 1 || fnIsAsync && taskFn.length === 0;
          if (Array.isArray(taskFn))
            params = [...taskFn], taskFn = params.pop(), newTasks[key] = params.concat(params.length > 0 ? newTask : taskFn);
          else if (hasNoDeps)
            newTasks[key] = taskFn;
          else {
            if (params = parseParams(taskFn), taskFn.length === 0 && !fnIsAsync && params.length === 0)
              throw new Error("autoInject task functions require explicit parameters.");
            fnIsAsync || params.pop(), newTasks[key] = params.concat(newTask);
          }
          function newTask(results, taskCb) {
            var newArgs = params.map((name) => results[name]);
            newArgs.push(taskCb), wrapAsync(taskFn)(...newArgs);
          }
        }), auto(newTasks, callback);
      }
      class DLL {
        constructor() {
          this.head = this.tail = null, this.length = 0;
        }
        removeLink(node) {
          return node.prev ? node.prev.next = node.next : this.head = node.next, node.next ? node.next.prev = node.prev : this.tail = node.prev, node.prev = node.next = null, this.length -= 1, node;
        }
        empty() {
          for (; this.head; )
            this.shift();
          return this;
        }
        insertAfter(node, newNode) {
          newNode.prev = node, newNode.next = node.next, node.next ? node.next.prev = newNode : this.tail = newNode, node.next = newNode, this.length += 1;
        }
        insertBefore(node, newNode) {
          newNode.prev = node.prev, newNode.next = node, node.prev ? node.prev.next = newNode : this.head = newNode, node.prev = newNode, this.length += 1;
        }
        unshift(node) {
          this.head ? this.insertBefore(this.head, node) : setInitial(this, node);
        }
        push(node) {
          this.tail ? this.insertAfter(this.tail, node) : setInitial(this, node);
        }
        shift() {
          return this.head && this.removeLink(this.head);
        }
        pop() {
          return this.tail && this.removeLink(this.tail);
        }
        toArray() {
          return [...this];
        }
        *[Symbol.iterator]() {
          for (var cur = this.head; cur; )
            yield cur.data, cur = cur.next;
        }
        remove(testFn) {
          for (var curr = this.head; curr; ) {
            var { next } = curr;
            testFn(curr) && this.removeLink(curr), curr = next;
          }
          return this;
        }
      }
      function setInitial(dll, node) {
        dll.length = 1, dll.head = dll.tail = node;
      }
      function queue$1(worker, concurrency, payload) {
        if (concurrency == null)
          concurrency = 1;
        else if (concurrency === 0)
          throw new RangeError("Concurrency must not be zero");
        var _worker = wrapAsync(worker), numRunning = 0, workersList = [];
        let events = {
          error: [],
          drain: [],
          saturated: [],
          unsaturated: [],
          empty: []
        };
        function on(event, handler) {
          events[event].push(handler);
        }
        function once2(event, handler) {
          let handleAndRemove = (...args) => {
            off(event, handleAndRemove), handler(...args);
          };
          events[event].push(handleAndRemove);
        }
        function off(event, handler) {
          if (!event)
            return Object.keys(events).forEach((ev) => events[ev] = []);
          if (!handler)
            return events[event] = [];
          events[event] = events[event].filter((ev) => ev !== handler);
        }
        function trigger(event, ...args) {
          events[event].forEach((handler) => handler(...args));
        }
        var processingScheduled = !1;
        function _insert(data, insertAtFront, rejectOnError, callback) {
          if (callback != null && typeof callback != "function")
            throw new Error("task callback must be a function");
          q.started = !0;
          var res, rej;
          function promiseCallback2(err2, ...args) {
            if (err2)
              return rejectOnError ? rej(err2) : res();
            if (args.length <= 1)
              return res(args[0]);
            res(args);
          }
          var item = q._createTaskItem(
            data,
            rejectOnError ? promiseCallback2 : callback || promiseCallback2
          );
          if (insertAtFront ? q._tasks.unshift(item) : q._tasks.push(item), processingScheduled || (processingScheduled = !0, setImmediate$1(() => {
            processingScheduled = !1, q.process();
          })), rejectOnError || !callback)
            return new Promise((resolve2, reject2) => {
              res = resolve2, rej = reject2;
            });
        }
        function _createCB(tasks) {
          return function(err2, ...args) {
            numRunning -= 1;
            for (var i = 0, l = tasks.length; i < l; i++) {
              var task = tasks[i], index2 = workersList.indexOf(task);
              index2 === 0 ? workersList.shift() : index2 > 0 && workersList.splice(index2, 1), task.callback(err2, ...args), err2 != null && trigger("error", err2, task.data);
            }
            numRunning <= q.concurrency - q.buffer && trigger("unsaturated"), q.idle() && trigger("drain"), q.process();
          };
        }
        function _maybeDrain(data) {
          return data.length === 0 && q.idle() ? (setImmediate$1(() => trigger("drain")), !0) : !1;
        }
        let eventMethod = (name) => (handler) => {
          if (!handler)
            return new Promise((resolve2, reject2) => {
              once2(name, (err2, data) => {
                if (err2)
                  return reject2(err2);
                resolve2(data);
              });
            });
          off(name), on(name, handler);
        };
        var isProcessing = !1, q = {
          _tasks: new DLL(),
          _createTaskItem(data, callback) {
            return {
              data,
              callback
            };
          },
          *[Symbol.iterator]() {
            yield* q._tasks[Symbol.iterator]();
          },
          concurrency,
          payload,
          buffer: concurrency / 4,
          started: !1,
          paused: !1,
          push(data, callback) {
            return Array.isArray(data) ? _maybeDrain(data) ? void 0 : data.map((datum) => _insert(datum, !1, !1, callback)) : _insert(data, !1, !1, callback);
          },
          pushAsync(data, callback) {
            return Array.isArray(data) ? _maybeDrain(data) ? void 0 : data.map((datum) => _insert(datum, !1, !0, callback)) : _insert(data, !1, !0, callback);
          },
          kill() {
            off(), q._tasks.empty();
          },
          unshift(data, callback) {
            return Array.isArray(data) ? _maybeDrain(data) ? void 0 : data.map((datum) => _insert(datum, !0, !1, callback)) : _insert(data, !0, !1, callback);
          },
          unshiftAsync(data, callback) {
            return Array.isArray(data) ? _maybeDrain(data) ? void 0 : data.map((datum) => _insert(datum, !0, !0, callback)) : _insert(data, !0, !0, callback);
          },
          remove(testFn) {
            q._tasks.remove(testFn);
          },
          process() {
            if (!isProcessing) {
              for (isProcessing = !0; !q.paused && numRunning < q.concurrency && q._tasks.length; ) {
                var tasks = [], data = [], l = q._tasks.length;
                q.payload && (l = Math.min(l, q.payload));
                for (var i = 0; i < l; i++) {
                  var node = q._tasks.shift();
                  tasks.push(node), workersList.push(node), data.push(node.data);
                }
                numRunning += 1, q._tasks.length === 0 && trigger("empty"), numRunning === q.concurrency && trigger("saturated");
                var cb = onlyOnce(_createCB(tasks));
                _worker(data, cb);
              }
              isProcessing = !1;
            }
          },
          length() {
            return q._tasks.length;
          },
          running() {
            return numRunning;
          },
          workersList() {
            return workersList;
          },
          idle() {
            return q._tasks.length + numRunning === 0;
          },
          pause() {
            q.paused = !0;
          },
          resume() {
            q.paused !== !1 && (q.paused = !1, setImmediate$1(q.process));
          }
        };
        return Object.defineProperties(q, {
          saturated: {
            writable: !1,
            value: eventMethod("saturated")
          },
          unsaturated: {
            writable: !1,
            value: eventMethod("unsaturated")
          },
          empty: {
            writable: !1,
            value: eventMethod("empty")
          },
          drain: {
            writable: !1,
            value: eventMethod("drain")
          },
          error: {
            writable: !1,
            value: eventMethod("error")
          }
        }), q;
      }
      function cargo$1(worker, payload) {
        return queue$1(worker, 1, payload);
      }
      function cargo(worker, concurrency, payload) {
        return queue$1(worker, concurrency, payload);
      }
      function reduce(coll, memo, iteratee, callback) {
        callback = once(callback);
        var _iteratee = wrapAsync(iteratee);
        return eachOfSeries$1(coll, (x, i, iterCb) => {
          _iteratee(memo, x, (err2, v) => {
            memo = v, iterCb(err2);
          });
        }, (err2) => callback(err2, memo));
      }
      var reduce$1 = awaitify(reduce, 4);
      function seq(...functions) {
        var _functions = functions.map(wrapAsync);
        return function(...args) {
          var that = this, cb = args[args.length - 1];
          return typeof cb == "function" ? args.pop() : cb = promiseCallback(), reduce$1(
            _functions,
            args,
            (newargs, fn, iterCb) => {
              fn.apply(that, newargs.concat((err2, ...nextargs) => {
                iterCb(err2, nextargs);
              }));
            },
            (err2, results) => cb(err2, ...results)
          ), cb[PROMISE_SYMBOL];
        };
      }
      function compose(...args) {
        return seq(...args.reverse());
      }
      function mapLimit2(coll, limit, iteratee, callback) {
        return _asyncMap(eachOfLimit$2(limit), coll, iteratee, callback);
      }
      var mapLimit$1 = awaitify(mapLimit2, 4);
      function concatLimit(coll, limit, iteratee, callback) {
        var _iteratee = wrapAsync(iteratee);
        return mapLimit$1(coll, limit, (val, iterCb) => {
          _iteratee(val, (err2, ...args) => err2 ? iterCb(err2) : iterCb(err2, args));
        }, (err2, mapResults) => {
          for (var result = [], i = 0; i < mapResults.length; i++)
            mapResults[i] && (result = result.concat(...mapResults[i]));
          return callback(err2, result);
        });
      }
      var concatLimit$1 = awaitify(concatLimit, 4);
      function concat(coll, iteratee, callback) {
        return concatLimit$1(coll, 1 / 0, iteratee, callback);
      }
      var concat$1 = awaitify(concat, 3);
      function concatSeries(coll, iteratee, callback) {
        return concatLimit$1(coll, 1, iteratee, callback);
      }
      var concatSeries$1 = awaitify(concatSeries, 3);
      function constant$1(...args) {
        return function(...ignoredArgs) {
          var callback = ignoredArgs.pop();
          return callback(null, ...args);
        };
      }
      function _createTester(check2, getResult) {
        return (eachfn, arr, _iteratee, cb) => {
          var testPassed = !1, testResult;
          let iteratee = wrapAsync(_iteratee);
          eachfn(arr, (value, _2, callback) => {
            iteratee(value, (err2, result) => {
              if (err2 || err2 === !1)
                return callback(err2);
              if (check2(result) && !testResult)
                return testPassed = !0, testResult = getResult(!0, value), callback(null, breakLoop$1);
              callback();
            });
          }, (err2) => {
            if (err2)
              return cb(err2);
            cb(null, testPassed ? testResult : getResult(!1));
          });
        };
      }
      function detect(coll, iteratee, callback) {
        return _createTester((bool) => bool, (res, item) => item)(eachOf$1, coll, iteratee, callback);
      }
      var detect$1 = awaitify(detect, 3);
      function detectLimit(coll, limit, iteratee, callback) {
        return _createTester((bool) => bool, (res, item) => item)(eachOfLimit$2(limit), coll, iteratee, callback);
      }
      var detectLimit$1 = awaitify(detectLimit, 4);
      function detectSeries(coll, iteratee, callback) {
        return _createTester((bool) => bool, (res, item) => item)(eachOfLimit$2(1), coll, iteratee, callback);
      }
      var detectSeries$1 = awaitify(detectSeries, 3);
      function consoleFunc(name) {
        return (fn, ...args) => wrapAsync(fn)(...args, (err2, ...resultArgs) => {
          typeof console == "object" && (err2 ? console.error && console.error(err2) : console[name] && resultArgs.forEach((x) => console[name](x)));
        });
      }
      var dir = consoleFunc("dir");
      function doWhilst(iteratee, test, callback) {
        callback = onlyOnce(callback);
        var _fn = wrapAsync(iteratee), _test = wrapAsync(test), results;
        function next(err2, ...args) {
          if (err2)
            return callback(err2);
          err2 !== !1 && (results = args, _test(...args, check2));
        }
        function check2(err2, truth) {
          if (err2)
            return callback(err2);
          if (err2 !== !1) {
            if (!truth)
              return callback(null, ...results);
            _fn(next);
          }
        }
        return check2(null, !0);
      }
      var doWhilst$1 = awaitify(doWhilst, 3);
      function doUntil(iteratee, test, callback) {
        let _test = wrapAsync(test);
        return doWhilst$1(iteratee, (...args) => {
          let cb = args.pop();
          _test(...args, (err2, truth) => cb(err2, !truth));
        }, callback);
      }
      function _withoutIndex(iteratee) {
        return (value, index2, callback) => iteratee(value, callback);
      }
      function eachLimit$2(coll, iteratee, callback) {
        return eachOf$1(coll, _withoutIndex(wrapAsync(iteratee)), callback);
      }
      var each = awaitify(eachLimit$2, 3);
      function eachLimit(coll, limit, iteratee, callback) {
        return eachOfLimit$2(limit)(coll, _withoutIndex(wrapAsync(iteratee)), callback);
      }
      var eachLimit$1 = awaitify(eachLimit, 4);
      function eachSeries(coll, iteratee, callback) {
        return eachLimit$1(coll, 1, iteratee, callback);
      }
      var eachSeries$1 = awaitify(eachSeries, 3);
      function ensureAsync(fn) {
        return isAsync(fn) ? fn : function(...args) {
          var callback = args.pop(), sync = !0;
          args.push((...innerArgs) => {
            sync ? setImmediate$1(() => callback(...innerArgs)) : callback(...innerArgs);
          }), fn.apply(this, args), sync = !1;
        };
      }
      function every(coll, iteratee, callback) {
        return _createTester((bool) => !bool, (res) => !res)(eachOf$1, coll, iteratee, callback);
      }
      var every$1 = awaitify(every, 3);
      function everyLimit(coll, limit, iteratee, callback) {
        return _createTester((bool) => !bool, (res) => !res)(eachOfLimit$2(limit), coll, iteratee, callback);
      }
      var everyLimit$1 = awaitify(everyLimit, 4);
      function everySeries(coll, iteratee, callback) {
        return _createTester((bool) => !bool, (res) => !res)(eachOfSeries$1, coll, iteratee, callback);
      }
      var everySeries$1 = awaitify(everySeries, 3);
      function filterArray2(eachfn, arr, iteratee, callback) {
        var truthValues = new Array(arr.length);
        eachfn(arr, (x, index2, iterCb) => {
          iteratee(x, (err2, v) => {
            truthValues[index2] = !!v, iterCb(err2);
          });
        }, (err2) => {
          if (err2)
            return callback(err2);
          for (var results = [], i = 0; i < arr.length; i++)
            truthValues[i] && results.push(arr[i]);
          callback(null, results);
        });
      }
      function filterGeneric(eachfn, coll, iteratee, callback) {
        var results = [];
        eachfn(coll, (x, index2, iterCb) => {
          iteratee(x, (err2, v) => {
            if (err2)
              return iterCb(err2);
            v && results.push({ index: index2, value: x }), iterCb(err2);
          });
        }, (err2) => {
          if (err2)
            return callback(err2);
          callback(null, results.sort((a, b) => a.index - b.index).map((v) => v.value));
        });
      }
      function _filter(eachfn, coll, iteratee, callback) {
        var filter2 = isArrayLike(coll) ? filterArray2 : filterGeneric;
        return filter2(eachfn, coll, wrapAsync(iteratee), callback);
      }
      function filter(coll, iteratee, callback) {
        return _filter(eachOf$1, coll, iteratee, callback);
      }
      var filter$1 = awaitify(filter, 3);
      function filterLimit(coll, limit, iteratee, callback) {
        return _filter(eachOfLimit$2(limit), coll, iteratee, callback);
      }
      var filterLimit$1 = awaitify(filterLimit, 4);
      function filterSeries(coll, iteratee, callback) {
        return _filter(eachOfSeries$1, coll, iteratee, callback);
      }
      var filterSeries$1 = awaitify(filterSeries, 3);
      function forever(fn, errback) {
        var done = onlyOnce(errback), task = wrapAsync(ensureAsync(fn));
        function next(err2) {
          if (err2)
            return done(err2);
          err2 !== !1 && task(next);
        }
        return next();
      }
      var forever$1 = awaitify(forever, 2);
      function groupByLimit(coll, limit, iteratee, callback) {
        var _iteratee = wrapAsync(iteratee);
        return mapLimit$1(coll, limit, (val, iterCb) => {
          _iteratee(val, (err2, key) => err2 ? iterCb(err2) : iterCb(err2, { key, val }));
        }, (err2, mapResults) => {
          for (var result = {}, { hasOwnProperty } = Object.prototype, i = 0; i < mapResults.length; i++)
            if (mapResults[i]) {
              var { key } = mapResults[i], { val } = mapResults[i];
              hasOwnProperty.call(result, key) ? result[key].push(val) : result[key] = [val];
            }
          return callback(err2, result);
        });
      }
      var groupByLimit$1 = awaitify(groupByLimit, 4);
      function groupBy2(coll, iteratee, callback) {
        return groupByLimit$1(coll, 1 / 0, iteratee, callback);
      }
      function groupBySeries(coll, iteratee, callback) {
        return groupByLimit$1(coll, 1, iteratee, callback);
      }
      var log = consoleFunc("log");
      function mapValuesLimit(obj, limit, iteratee, callback) {
        callback = once(callback);
        var newObj = {}, _iteratee = wrapAsync(iteratee);
        return eachOfLimit$2(limit)(obj, (val, key, next) => {
          _iteratee(val, key, (err2, result) => {
            if (err2)
              return next(err2);
            newObj[key] = result, next(err2);
          });
        }, (err2) => callback(err2, newObj));
      }
      var mapValuesLimit$1 = awaitify(mapValuesLimit, 4);
      function mapValues(obj, iteratee, callback) {
        return mapValuesLimit$1(obj, 1 / 0, iteratee, callback);
      }
      function mapValuesSeries(obj, iteratee, callback) {
        return mapValuesLimit$1(obj, 1, iteratee, callback);
      }
      function memoize(fn, hasher = (v) => v) {
        var memo = /* @__PURE__ */ Object.create(null), queues = /* @__PURE__ */ Object.create(null), _fn = wrapAsync(fn), memoized = initialParams((args, callback) => {
          var key = hasher(...args);
          key in memo ? setImmediate$1(() => callback(null, ...memo[key])) : key in queues ? queues[key].push(callback) : (queues[key] = [callback], _fn(...args, (err2, ...resultArgs) => {
            err2 || (memo[key] = resultArgs);
            var q = queues[key];
            delete queues[key];
            for (var i = 0, l = q.length; i < l; i++)
              q[i](err2, ...resultArgs);
          }));
        });
        return memoized.memo = memo, memoized.unmemoized = fn, memoized;
      }
      var _defer;
      hasNextTick ? _defer = process.nextTick : hasSetImmediate ? _defer = setImmediate : _defer = fallback;
      var nextTick = wrap(_defer), _parallel = awaitify((eachfn, tasks, callback) => {
        var results = isArrayLike(tasks) ? [] : {};
        eachfn(tasks, (task, key, taskCb) => {
          wrapAsync(task)((err2, ...result) => {
            result.length < 2 && ([result] = result), results[key] = result, taskCb(err2);
          });
        }, (err2) => callback(err2, results));
      }, 3);
      function parallel(tasks, callback) {
        return _parallel(eachOf$1, tasks, callback);
      }
      function parallelLimit(tasks, limit, callback) {
        return _parallel(eachOfLimit$2(limit), tasks, callback);
      }
      function queue(worker, concurrency) {
        var _worker = wrapAsync(worker);
        return queue$1((items, cb) => {
          _worker(items[0], cb);
        }, concurrency, 1);
      }
      class Heap {
        constructor() {
          this.heap = [], this.pushCount = Number.MIN_SAFE_INTEGER;
        }
        get length() {
          return this.heap.length;
        }
        empty() {
          return this.heap = [], this;
        }
        percUp(index2) {
          let p;
          for (; index2 > 0 && smaller(this.heap[index2], this.heap[p = parent(index2)]); ) {
            let t7 = this.heap[index2];
            this.heap[index2] = this.heap[p], this.heap[p] = t7, index2 = p;
          }
        }
        percDown(index2) {
          let l;
          for (; (l = leftChi(index2)) < this.heap.length && (l + 1 < this.heap.length && smaller(this.heap[l + 1], this.heap[l]) && (l = l + 1), !smaller(this.heap[index2], this.heap[l])); ) {
            let t7 = this.heap[index2];
            this.heap[index2] = this.heap[l], this.heap[l] = t7, index2 = l;
          }
        }
        push(node) {
          node.pushCount = ++this.pushCount, this.heap.push(node), this.percUp(this.heap.length - 1);
        }
        unshift(node) {
          return this.heap.push(node);
        }
        shift() {
          let [top] = this.heap;
          return this.heap[0] = this.heap[this.heap.length - 1], this.heap.pop(), this.percDown(0), top;
        }
        toArray() {
          return [...this];
        }
        *[Symbol.iterator]() {
          for (let i = 0; i < this.heap.length; i++)
            yield this.heap[i].data;
        }
        remove(testFn) {
          let j = 0;
          for (let i = 0; i < this.heap.length; i++)
            testFn(this.heap[i]) || (this.heap[j] = this.heap[i], j++);
          this.heap.splice(j);
          for (let i = parent(this.heap.length - 1); i >= 0; i--)
            this.percDown(i);
          return this;
        }
      }
      function leftChi(i) {
        return (i << 1) + 1;
      }
      function parent(i) {
        return (i + 1 >> 1) - 1;
      }
      function smaller(x, y) {
        return x.priority !== y.priority ? x.priority < y.priority : x.pushCount < y.pushCount;
      }
      function priorityQueue(worker, concurrency) {
        var q = queue(worker, concurrency), {
          push: push2,
          pushAsync
        } = q;
        q._tasks = new Heap(), q._createTaskItem = ({ data, priority }, callback) => ({
          data,
          priority,
          callback
        });
        function createDataItems(tasks, priority) {
          return Array.isArray(tasks) ? tasks.map((data) => ({ data, priority })) : { data: tasks, priority };
        }
        return q.push = function(data, priority = 0, callback) {
          return push2(createDataItems(data, priority), callback);
        }, q.pushAsync = function(data, priority = 0, callback) {
          return pushAsync(createDataItems(data, priority), callback);
        }, delete q.unshift, delete q.unshiftAsync, q;
      }
      function race(tasks, callback) {
        if (callback = once(callback), !Array.isArray(tasks))
          return callback(new TypeError("First argument to race must be an array of functions"));
        if (!tasks.length)
          return callback();
        for (var i = 0, l = tasks.length; i < l; i++)
          wrapAsync(tasks[i])(callback);
      }
      var race$1 = awaitify(race, 2);
      function reduceRight(array, memo, iteratee, callback) {
        var reversed = [...array].reverse();
        return reduce$1(reversed, memo, iteratee, callback);
      }
      function reflect(fn) {
        var _fn = wrapAsync(fn);
        return initialParams(function(args, reflectCallback) {
          return args.push((error, ...cbArgs) => {
            let retVal = {};
            if (error && (retVal.error = error), cbArgs.length > 0) {
              var value = cbArgs;
              cbArgs.length <= 1 && ([value] = cbArgs), retVal.value = value;
            }
            reflectCallback(null, retVal);
          }), _fn.apply(this, args);
        });
      }
      function reflectAll(tasks) {
        var results;
        return Array.isArray(tasks) ? results = tasks.map(reflect) : (results = {}, Object.keys(tasks).forEach((key) => {
          results[key] = reflect.call(this, tasks[key]);
        })), results;
      }
      function reject$2(eachfn, arr, _iteratee, callback) {
        let iteratee = wrapAsync(_iteratee);
        return _filter(eachfn, arr, (value, cb) => {
          iteratee(value, (err2, v) => {
            cb(err2, !v);
          });
        }, callback);
      }
      function reject(coll, iteratee, callback) {
        return reject$2(eachOf$1, coll, iteratee, callback);
      }
      var reject$1 = awaitify(reject, 3);
      function rejectLimit(coll, limit, iteratee, callback) {
        return reject$2(eachOfLimit$2(limit), coll, iteratee, callback);
      }
      var rejectLimit$1 = awaitify(rejectLimit, 4);
      function rejectSeries(coll, iteratee, callback) {
        return reject$2(eachOfSeries$1, coll, iteratee, callback);
      }
      var rejectSeries$1 = awaitify(rejectSeries, 3);
      function constant(value) {
        return function() {
          return value;
        };
      }
      let DEFAULT_TIMES = 5, DEFAULT_INTERVAL = 0;
      function retry(opts, task, callback) {
        var options = {
          times: DEFAULT_TIMES,
          intervalFunc: constant(DEFAULT_INTERVAL)
        };
        if (arguments.length < 3 && typeof opts == "function" ? (callback = task || promiseCallback(), task = opts) : (parseTimes(options, opts), callback = callback || promiseCallback()), typeof task != "function")
          throw new Error("Invalid arguments for async.retry");
        var _task = wrapAsync(task), attempt = 1;
        function retryAttempt() {
          _task((err2, ...args) => {
            err2 !== !1 && (err2 && attempt++ < options.times && (typeof options.errorFilter != "function" || options.errorFilter(err2)) ? setTimeout(retryAttempt, options.intervalFunc(attempt - 1)) : callback(err2, ...args));
          });
        }
        return retryAttempt(), callback[PROMISE_SYMBOL];
      }
      function parseTimes(acc, t7) {
        if (typeof t7 == "object")
          acc.times = +t7.times || DEFAULT_TIMES, acc.intervalFunc = typeof t7.interval == "function" ? t7.interval : constant(+t7.interval || DEFAULT_INTERVAL), acc.errorFilter = t7.errorFilter;
        else if (typeof t7 == "number" || typeof t7 == "string")
          acc.times = +t7 || DEFAULT_TIMES;
        else
          throw new Error("Invalid arguments for async.retry");
      }
      function retryable(opts, task) {
        task || (task = opts, opts = null);
        let arity = opts && opts.arity || task.length;
        isAsync(task) && (arity += 1);
        var _task = wrapAsync(task);
        return initialParams((args, callback) => {
          (args.length < arity - 1 || callback == null) && (args.push(callback), callback = promiseCallback());
          function taskFn(cb) {
            _task(...args, cb);
          }
          return opts ? retry(opts, taskFn, callback) : retry(taskFn, callback), callback[PROMISE_SYMBOL];
        });
      }
      function series(tasks, callback) {
        return _parallel(eachOfSeries$1, tasks, callback);
      }
      function some(coll, iteratee, callback) {
        return _createTester(Boolean, (res) => res)(eachOf$1, coll, iteratee, callback);
      }
      var some$1 = awaitify(some, 3);
      function someLimit(coll, limit, iteratee, callback) {
        return _createTester(Boolean, (res) => res)(eachOfLimit$2(limit), coll, iteratee, callback);
      }
      var someLimit$1 = awaitify(someLimit, 4);
      function someSeries(coll, iteratee, callback) {
        return _createTester(Boolean, (res) => res)(eachOfSeries$1, coll, iteratee, callback);
      }
      var someSeries$1 = awaitify(someSeries, 3);
      function sortBy3(coll, iteratee, callback) {
        var _iteratee = wrapAsync(iteratee);
        return map$1(coll, (x, iterCb) => {
          _iteratee(x, (err2, criteria) => {
            if (err2)
              return iterCb(err2);
            iterCb(err2, { value: x, criteria });
          });
        }, (err2, results) => {
          if (err2)
            return callback(err2);
          callback(null, results.sort(comparator).map((v) => v.value));
        });
        function comparator(left, right) {
          var a = left.criteria, b = right.criteria;
          return a < b ? -1 : a > b ? 1 : 0;
        }
      }
      var sortBy$1 = awaitify(sortBy3, 3);
      function timeout(asyncFn, milliseconds, info2) {
        var fn = wrapAsync(asyncFn);
        return initialParams((args, callback) => {
          var timedOut = !1, timer;
          function timeoutCallback() {
            var name = asyncFn.name || "anonymous", error = new Error('Callback function "' + name + '" timed out.');
            error.code = "ETIMEDOUT", info2 && (error.info = info2), timedOut = !0, callback(error);
          }
          args.push((...cbArgs) => {
            timedOut || (callback(...cbArgs), clearTimeout(timer));
          }), timer = setTimeout(timeoutCallback, milliseconds), fn(...args);
        });
      }
      function range(size) {
        for (var result = Array(size); size--; )
          result[size] = size;
        return result;
      }
      function timesLimit(count, limit, iteratee, callback) {
        var _iteratee = wrapAsync(iteratee);
        return mapLimit$1(range(count), limit, _iteratee, callback);
      }
      function times(n, iteratee, callback) {
        return timesLimit(n, 1 / 0, iteratee, callback);
      }
      function timesSeries(n, iteratee, callback) {
        return timesLimit(n, 1, iteratee, callback);
      }
      function transform2(coll, accumulator, iteratee, callback) {
        arguments.length <= 3 && typeof accumulator == "function" && (callback = iteratee, iteratee = accumulator, accumulator = Array.isArray(coll) ? [] : {}), callback = once(callback || promiseCallback());
        var _iteratee = wrapAsync(iteratee);
        return eachOf$1(coll, (v, k, cb) => {
          _iteratee(accumulator, v, k, cb);
        }, (err2) => callback(err2, accumulator)), callback[PROMISE_SYMBOL];
      }
      function tryEach(tasks, callback) {
        var error = null, result;
        return eachSeries$1(tasks, (task, taskCb) => {
          wrapAsync(task)((err2, ...args) => {
            if (err2 === !1)
              return taskCb(err2);
            args.length < 2 ? [result] = args : result = args, error = err2, taskCb(err2 ? null : {});
          });
        }, () => callback(error, result));
      }
      var tryEach$1 = awaitify(tryEach);
      function unmemoize(fn) {
        return (...args) => (fn.unmemoized || fn)(...args);
      }
      function whilst(test, iteratee, callback) {
        callback = onlyOnce(callback);
        var _fn = wrapAsync(iteratee), _test = wrapAsync(test), results = [];
        function next(err2, ...rest) {
          if (err2)
            return callback(err2);
          results = rest, err2 !== !1 && _test(check2);
        }
        function check2(err2, truth) {
          if (err2)
            return callback(err2);
          if (err2 !== !1) {
            if (!truth)
              return callback(null, ...results);
            _fn(next);
          }
        }
        return _test(check2);
      }
      var whilst$1 = awaitify(whilst, 3);
      function until(test, iteratee, callback) {
        let _test = wrapAsync(test);
        return whilst$1((cb) => _test((err2, truth) => cb(err2, !truth)), iteratee, callback);
      }
      function waterfall(tasks, callback) {
        if (callback = once(callback), !Array.isArray(tasks))
          return callback(new Error("First argument to waterfall must be an array of functions"));
        if (!tasks.length)
          return callback();
        var taskIndex = 0;
        function nextTask(args) {
          var task = wrapAsync(tasks[taskIndex++]);
          task(...args, onlyOnce(next));
        }
        function next(err2, ...args) {
          if (err2 !== !1) {
            if (err2 || taskIndex === tasks.length)
              return callback(err2, ...args);
            nextTask(args);
          }
        }
        nextTask([]);
      }
      var waterfall$1 = awaitify(waterfall), index = {
        apply,
        applyEach,
        applyEachSeries,
        asyncify,
        auto,
        autoInject,
        cargo: cargo$1,
        cargoQueue: cargo,
        compose,
        concat: concat$1,
        concatLimit: concatLimit$1,
        concatSeries: concatSeries$1,
        constant: constant$1,
        detect: detect$1,
        detectLimit: detectLimit$1,
        detectSeries: detectSeries$1,
        dir,
        doUntil,
        doWhilst: doWhilst$1,
        each,
        eachLimit: eachLimit$1,
        eachOf: eachOf$1,
        eachOfLimit: eachOfLimit$1,
        eachOfSeries: eachOfSeries$1,
        eachSeries: eachSeries$1,
        ensureAsync,
        every: every$1,
        everyLimit: everyLimit$1,
        everySeries: everySeries$1,
        filter: filter$1,
        filterLimit: filterLimit$1,
        filterSeries: filterSeries$1,
        forever: forever$1,
        groupBy: groupBy2,
        groupByLimit: groupByLimit$1,
        groupBySeries,
        log,
        map: map$1,
        mapLimit: mapLimit$1,
        mapSeries: mapSeries$1,
        mapValues,
        mapValuesLimit: mapValuesLimit$1,
        mapValuesSeries,
        memoize,
        nextTick,
        parallel,
        parallelLimit,
        priorityQueue,
        queue,
        race: race$1,
        reduce: reduce$1,
        reduceRight,
        reflect,
        reflectAll,
        reject: reject$1,
        rejectLimit: rejectLimit$1,
        rejectSeries: rejectSeries$1,
        retry,
        retryable,
        seq,
        series,
        setImmediate: setImmediate$1,
        some: some$1,
        someLimit: someLimit$1,
        someSeries: someSeries$1,
        sortBy: sortBy$1,
        timeout,
        times,
        timesLimit,
        timesSeries,
        transform: transform2,
        tryEach: tryEach$1,
        unmemoize,
        until,
        waterfall: waterfall$1,
        whilst: whilst$1,
        // aliases
        all: every$1,
        allLimit: everyLimit$1,
        allSeries: everySeries$1,
        any: some$1,
        anyLimit: someLimit$1,
        anySeries: someSeries$1,
        find: detect$1,
        findLimit: detectLimit$1,
        findSeries: detectSeries$1,
        flatMap: concat$1,
        flatMapLimit: concatLimit$1,
        flatMapSeries: concatSeries$1,
        forEach: each,
        forEachSeries: eachSeries$1,
        forEachLimit: eachLimit$1,
        forEachOf: eachOf$1,
        forEachOfSeries: eachOfSeries$1,
        forEachOfLimit: eachOfLimit$1,
        inject: reduce$1,
        foldl: reduce$1,
        foldr: reduceRight,
        select: filter$1,
        selectLimit: filterLimit$1,
        selectSeries: filterSeries$1,
        wrapSync: asyncify,
        during: whilst$1,
        doDuring: doWhilst$1
      };
      exports2.all = every$1, exports2.allLimit = everyLimit$1, exports2.allSeries = everySeries$1, exports2.any = some$1, exports2.anyLimit = someLimit$1, exports2.anySeries = someSeries$1, exports2.apply = apply, exports2.applyEach = applyEach, exports2.applyEachSeries = applyEachSeries, exports2.asyncify = asyncify, exports2.auto = auto, exports2.autoInject = autoInject, exports2.cargo = cargo$1, exports2.cargoQueue = cargo, exports2.compose = compose, exports2.concat = concat$1, exports2.concatLimit = concatLimit$1, exports2.concatSeries = concatSeries$1, exports2.constant = constant$1, exports2.default = index, exports2.detect = detect$1, exports2.detectLimit = detectLimit$1, exports2.detectSeries = detectSeries$1, exports2.dir = dir, exports2.doDuring = doWhilst$1, exports2.doUntil = doUntil, exports2.doWhilst = doWhilst$1, exports2.during = whilst$1, exports2.each = each, exports2.eachLimit = eachLimit$1, exports2.eachOf = eachOf$1, exports2.eachOfLimit = eachOfLimit$1, exports2.eachOfSeries = eachOfSeries$1, exports2.eachSeries = eachSeries$1, exports2.ensureAsync = ensureAsync, exports2.every = every$1, exports2.everyLimit = everyLimit$1, exports2.everySeries = everySeries$1, exports2.filter = filter$1, exports2.filterLimit = filterLimit$1, exports2.filterSeries = filterSeries$1, exports2.find = detect$1, exports2.findLimit = detectLimit$1, exports2.findSeries = detectSeries$1, exports2.flatMap = concat$1, exports2.flatMapLimit = concatLimit$1, exports2.flatMapSeries = concatSeries$1, exports2.foldl = reduce$1, exports2.foldr = reduceRight, exports2.forEach = each, exports2.forEachLimit = eachLimit$1, exports2.forEachOf = eachOf$1, exports2.forEachOfLimit = eachOfLimit$1, exports2.forEachOfSeries = eachOfSeries$1, exports2.forEachSeries = eachSeries$1, exports2.forever = forever$1, exports2.groupBy = groupBy2, exports2.groupByLimit = groupByLimit$1, exports2.groupBySeries = groupBySeries, exports2.inject = reduce$1, exports2.log = log, exports2.map = map$1, exports2.mapLimit = mapLimit$1, exports2.mapSeries = mapSeries$1, exports2.mapValues = mapValues, exports2.mapValuesLimit = mapValuesLimit$1, exports2.mapValuesSeries = mapValuesSeries, exports2.memoize = memoize, exports2.nextTick = nextTick, exports2.parallel = parallel, exports2.parallelLimit = parallelLimit, exports2.priorityQueue = priorityQueue, exports2.queue = queue, exports2.race = race$1, exports2.reduce = reduce$1, exports2.reduceRight = reduceRight, exports2.reflect = reflect, exports2.reflectAll = reflectAll, exports2.reject = reject$1, exports2.rejectLimit = rejectLimit$1, exports2.rejectSeries = rejectSeries$1, exports2.retry = retry, exports2.retryable = retryable, exports2.select = filter$1, exports2.selectLimit = filterLimit$1, exports2.selectSeries = filterSeries$1, exports2.seq = seq, exports2.series = series, exports2.setImmediate = setImmediate$1, exports2.some = some$1, exports2.someLimit = someLimit$1, exports2.someSeries = someSeries$1, exports2.sortBy = sortBy$1, exports2.timeout = timeout, exports2.times = times, exports2.timesLimit = timesLimit, exports2.timesSeries = timesSeries, exports2.transform = transform2, exports2.tryEach = tryEach$1, exports2.unmemoize = unmemoize, exports2.until = until, exports2.waterfall = waterfall$1, exports2.whilst = whilst$1, exports2.wrapSync = asyncify, Object.defineProperty(exports2, "__esModule", { value: !0 });
    });
  }
});

// ../../node_modules/.pnpm/process-nextick-args@2.0.1/node_modules/process-nextick-args/index.js
var require_process_nextick_args = __commonJS({
  "../../node_modules/.pnpm/process-nextick-args@2.0.1/node_modules/process-nextick-args/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    typeof process > "u" || !process.version || process.version.indexOf("v0.") === 0 || process.version.indexOf("v1.") === 0 && process.version.indexOf("v1.8.") !== 0 ? module.exports = { nextTick } : module.exports = process;
    function nextTick(fn, arg1, arg2, arg3) {
      if (typeof fn != "function")
        throw new TypeError('"callback" argument must be a function');
      var len = arguments.length, args, i;
      switch (len) {
        case 0:
        case 1:
          return process.nextTick(fn);
        case 2:
          return process.nextTick(function() {
            fn.call(null, arg1);
          });
        case 3:
          return process.nextTick(function() {
            fn.call(null, arg1, arg2);
          });
        case 4:
          return process.nextTick(function() {
            fn.call(null, arg1, arg2, arg3);
          });
        default:
          for (args = new Array(len - 1), i = 0; i < args.length; )
            args[i++] = arguments[i];
          return process.nextTick(function() {
            fn.apply(null, args);
          });
      }
    }
  }
});

// ../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/lib/internal/streams/stream.js
var require_stream = __commonJS({
  "../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/lib/internal/streams/stream.js"(exports, module) {
    init_cjs_shims();
    module.exports = __require("stream");
  }
});

// ../../node_modules/.pnpm/safe-buffer@5.1.2/node_modules/safe-buffer/index.js
var require_safe_buffer = __commonJS({
  "../../node_modules/.pnpm/safe-buffer@5.1.2/node_modules/safe-buffer/index.js"(exports, module) {
    init_cjs_shims();
    var buffer = __require("buffer"), Buffer2 = buffer.Buffer;
    function copyProps(src, dst) {
      for (var key in src)
        dst[key] = src[key];
    }
    Buffer2.from && Buffer2.alloc && Buffer2.allocUnsafe && Buffer2.allocUnsafeSlow ? module.exports = buffer : (copyProps(buffer, exports), exports.Buffer = SafeBuffer);
    function SafeBuffer(arg, encodingOrOffset, length) {
      return Buffer2(arg, encodingOrOffset, length);
    }
    copyProps(Buffer2, SafeBuffer);
    SafeBuffer.from = function(arg, encodingOrOffset, length) {
      if (typeof arg == "number")
        throw new TypeError("Argument must not be a number");
      return Buffer2(arg, encodingOrOffset, length);
    };
    SafeBuffer.alloc = function(size, fill, encoding) {
      if (typeof size != "number")
        throw new TypeError("Argument must be a number");
      var buf = Buffer2(size);
      return fill !== void 0 ? typeof encoding == "string" ? buf.fill(fill, encoding) : buf.fill(fill) : buf.fill(0), buf;
    };
    SafeBuffer.allocUnsafe = function(size) {
      if (typeof size != "number")
        throw new TypeError("Argument must be a number");
      return Buffer2(size);
    };
    SafeBuffer.allocUnsafeSlow = function(size) {
      if (typeof size != "number")
        throw new TypeError("Argument must be a number");
      return buffer.SlowBuffer(size);
    };
  }
});

// ../../node_modules/.pnpm/core-util-is@1.0.3/node_modules/core-util-is/lib/util.js
var require_util2 = __commonJS({
  "../../node_modules/.pnpm/core-util-is@1.0.3/node_modules/core-util-is/lib/util.js"(exports) {
    init_cjs_shims();
    function isArray(arg) {
      return Array.isArray ? Array.isArray(arg) : objectToString(arg) === "[object Array]";
    }
    exports.isArray = isArray;
    function isBoolean2(arg) {
      return typeof arg == "boolean";
    }
    exports.isBoolean = isBoolean2;
    function isNull(arg) {
      return arg === null;
    }
    exports.isNull = isNull;
    function isNullOrUndefined(arg) {
      return arg == null;
    }
    exports.isNullOrUndefined = isNullOrUndefined;
    function isNumber2(arg) {
      return typeof arg == "number";
    }
    exports.isNumber = isNumber2;
    function isString2(arg) {
      return typeof arg == "string";
    }
    exports.isString = isString2;
    function isSymbol(arg) {
      return typeof arg == "symbol";
    }
    exports.isSymbol = isSymbol;
    function isUndefined(arg) {
      return arg === void 0;
    }
    exports.isUndefined = isUndefined;
    function isRegExp(re) {
      return objectToString(re) === "[object RegExp]";
    }
    exports.isRegExp = isRegExp;
    function isObject4(arg) {
      return typeof arg == "object" && arg !== null;
    }
    exports.isObject = isObject4;
    function isDate(d) {
      return objectToString(d) === "[object Date]";
    }
    exports.isDate = isDate;
    function isError2(e) {
      return objectToString(e) === "[object Error]" || e instanceof Error;
    }
    exports.isError = isError2;
    function isFunction(arg) {
      return typeof arg == "function";
    }
    exports.isFunction = isFunction;
    function isPrimitive(arg) {
      return arg === null || typeof arg == "boolean" || typeof arg == "number" || typeof arg == "string" || typeof arg == "symbol" || // ES6 symbol
      typeof arg > "u";
    }
    exports.isPrimitive = isPrimitive;
    exports.isBuffer = __require("buffer").Buffer.isBuffer;
    function objectToString(o) {
      return Object.prototype.toString.call(o);
    }
  }
});

// ../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/lib/internal/streams/BufferList.js
var require_BufferList = __commonJS({
  "../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/lib/internal/streams/BufferList.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor))
        throw new TypeError("Cannot call a class as a function");
    }
    var Buffer2 = require_safe_buffer().Buffer, util2 = __require("util");
    function copyBuffer(src, target, offset) {
      src.copy(target, offset);
    }
    module.exports = function() {
      function BufferList() {
        _classCallCheck(this, BufferList), this.head = null, this.tail = null, this.length = 0;
      }
      return BufferList.prototype.push = function(v) {
        var entry = { data: v, next: null };
        this.length > 0 ? this.tail.next = entry : this.head = entry, this.tail = entry, ++this.length;
      }, BufferList.prototype.unshift = function(v) {
        var entry = { data: v, next: this.head };
        this.length === 0 && (this.tail = entry), this.head = entry, ++this.length;
      }, BufferList.prototype.shift = function() {
        if (this.length !== 0) {
          var ret = this.head.data;
          return this.length === 1 ? this.head = this.tail = null : this.head = this.head.next, --this.length, ret;
        }
      }, BufferList.prototype.clear = function() {
        this.head = this.tail = null, this.length = 0;
      }, BufferList.prototype.join = function(s) {
        if (this.length === 0)
          return "";
        for (var p = this.head, ret = "" + p.data; p = p.next; )
          ret += s + p.data;
        return ret;
      }, BufferList.prototype.concat = function(n) {
        if (this.length === 0)
          return Buffer2.alloc(0);
        for (var ret = Buffer2.allocUnsafe(n >>> 0), p = this.head, i = 0; p; )
          copyBuffer(p.data, ret, i), i += p.data.length, p = p.next;
        return ret;
      }, BufferList;
    }();
    util2 && util2.inspect && util2.inspect.custom && (module.exports.prototype[util2.inspect.custom] = function() {
      var obj = util2.inspect({ length: this.length });
      return this.constructor.name + " " + obj;
    });
  }
});

// ../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/lib/internal/streams/destroy.js
var require_destroy = __commonJS({
  "../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/lib/internal/streams/destroy.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var pna = require_process_nextick_args();
    function destroy(err2, cb) {
      var _this = this, readableDestroyed = this._readableState && this._readableState.destroyed, writableDestroyed = this._writableState && this._writableState.destroyed;
      return readableDestroyed || writableDestroyed ? (cb ? cb(err2) : err2 && (this._writableState ? this._writableState.errorEmitted || (this._writableState.errorEmitted = !0, pna.nextTick(emitErrorNT, this, err2)) : pna.nextTick(emitErrorNT, this, err2)), this) : (this._readableState && (this._readableState.destroyed = !0), this._writableState && (this._writableState.destroyed = !0), this._destroy(err2 || null, function(err3) {
        !cb && err3 ? _this._writableState ? _this._writableState.errorEmitted || (_this._writableState.errorEmitted = !0, pna.nextTick(emitErrorNT, _this, err3)) : pna.nextTick(emitErrorNT, _this, err3) : cb && cb(err3);
      }), this);
    }
    function undestroy() {
      this._readableState && (this._readableState.destroyed = !1, this._readableState.reading = !1, this._readableState.ended = !1, this._readableState.endEmitted = !1), this._writableState && (this._writableState.destroyed = !1, this._writableState.ended = !1, this._writableState.ending = !1, this._writableState.finalCalled = !1, this._writableState.prefinished = !1, this._writableState.finished = !1, this._writableState.errorEmitted = !1);
    }
    function emitErrorNT(self2, err2) {
      self2.emit("error", err2);
    }
    module.exports = {
      destroy,
      undestroy
    };
  }
});

// ../../node_modules/.pnpm/util-deprecate@1.0.2/node_modules/util-deprecate/node.js
var require_node5 = __commonJS({
  "../../node_modules/.pnpm/util-deprecate@1.0.2/node_modules/util-deprecate/node.js"(exports, module) {
    init_cjs_shims();
    module.exports = __require("util").deprecate;
  }
});

// ../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/lib/_stream_writable.js
var require_stream_writable = __commonJS({
  "../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/lib/_stream_writable.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var pna = require_process_nextick_args();
    module.exports = Writable3;
    function CorkedRequest(state) {
      var _this = this;
      this.next = null, this.entry = null, this.finish = function() {
        onCorkedFinish(_this, state);
      };
    }
    var asyncWrite = !process.browser && ["v0.10", "v0.9."].indexOf(process.version.slice(0, 5)) > -1 ? setImmediate : pna.nextTick, Duplex;
    Writable3.WritableState = WritableState;
    var util2 = Object.create(require_util2());
    util2.inherits = require_inherits();
    var internalUtil = {
      deprecate: require_node5()
    }, Stream = require_stream(), Buffer2 = require_safe_buffer().Buffer, OurUint8Array = (typeof global < "u" ? global : typeof window < "u" ? window : typeof self < "u" ? self : {}).Uint8Array || function() {
    };
    function _uint8ArrayToBuffer(chunk) {
      return Buffer2.from(chunk);
    }
    function _isUint8Array(obj) {
      return Buffer2.isBuffer(obj) || obj instanceof OurUint8Array;
    }
    var destroyImpl = require_destroy();
    util2.inherits(Writable3, Stream);
    function nop() {
    }
    function WritableState(options, stream2) {
      Duplex = Duplex || require_stream_duplex(), options = options || {};
      var isDuplex = stream2 instanceof Duplex;
      this.objectMode = !!options.objectMode, isDuplex && (this.objectMode = this.objectMode || !!options.writableObjectMode);
      var hwm = options.highWaterMark, writableHwm = options.writableHighWaterMark, defaultHwm = this.objectMode ? 16 : 16 * 1024;
      hwm || hwm === 0 ? this.highWaterMark = hwm : isDuplex && (writableHwm || writableHwm === 0) ? this.highWaterMark = writableHwm : this.highWaterMark = defaultHwm, this.highWaterMark = Math.floor(this.highWaterMark), this.finalCalled = !1, this.needDrain = !1, this.ending = !1, this.ended = !1, this.finished = !1, this.destroyed = !1;
      var noDecode = options.decodeStrings === !1;
      this.decodeStrings = !noDecode, this.defaultEncoding = options.defaultEncoding || "utf8", this.length = 0, this.writing = !1, this.corked = 0, this.sync = !0, this.bufferProcessing = !1, this.onwrite = function(er) {
        onwrite(stream2, er);
      }, this.writecb = null, this.writelen = 0, this.bufferedRequest = null, this.lastBufferedRequest = null, this.pendingcb = 0, this.prefinished = !1, this.errorEmitted = !1, this.bufferedRequestCount = 0, this.corkedRequestsFree = new CorkedRequest(this);
    }
    WritableState.prototype.getBuffer = function() {
      for (var current = this.bufferedRequest, out = []; current; )
        out.push(current), current = current.next;
      return out;
    };
    (function() {
      try {
        Object.defineProperty(WritableState.prototype, "buffer", {
          get: internalUtil.deprecate(function() {
            return this.getBuffer();
          }, "_writableState.buffer is deprecated. Use _writableState.getBuffer instead.", "DEP0003")
        });
      } catch {
      }
    })();
    var realHasInstance;
    typeof Symbol == "function" && Symbol.hasInstance && typeof Function.prototype[Symbol.hasInstance] == "function" ? (realHasInstance = Function.prototype[Symbol.hasInstance], Object.defineProperty(Writable3, Symbol.hasInstance, {
      value: function(object) {
        return realHasInstance.call(this, object) ? !0 : this !== Writable3 ? !1 : object && object._writableState instanceof WritableState;
      }
    })) : realHasInstance = function(object) {
      return object instanceof this;
    };
    function Writable3(options) {
      if (Duplex = Duplex || require_stream_duplex(), !realHasInstance.call(Writable3, this) && !(this instanceof Duplex))
        return new Writable3(options);
      this._writableState = new WritableState(options, this), this.writable = !0, options && (typeof options.write == "function" && (this._write = options.write), typeof options.writev == "function" && (this._writev = options.writev), typeof options.destroy == "function" && (this._destroy = options.destroy), typeof options.final == "function" && (this._final = options.final)), Stream.call(this);
    }
    Writable3.prototype.pipe = function() {
      this.emit("error", new Error("Cannot pipe, not readable"));
    };
    function writeAfterEnd(stream2, cb) {
      var er = new Error("write after end");
      stream2.emit("error", er), pna.nextTick(cb, er);
    }
    function validChunk(stream2, state, chunk, cb) {
      var valid2 = !0, er = !1;
      return chunk === null ? er = new TypeError("May not write null values to stream") : typeof chunk != "string" && chunk !== void 0 && !state.objectMode && (er = new TypeError("Invalid non-string/buffer chunk")), er && (stream2.emit("error", er), pna.nextTick(cb, er), valid2 = !1), valid2;
    }
    Writable3.prototype.write = function(chunk, encoding, cb) {
      var state = this._writableState, ret = !1, isBuf = !state.objectMode && _isUint8Array(chunk);
      return isBuf && !Buffer2.isBuffer(chunk) && (chunk = _uint8ArrayToBuffer(chunk)), typeof encoding == "function" && (cb = encoding, encoding = null), isBuf ? encoding = "buffer" : encoding || (encoding = state.defaultEncoding), typeof cb != "function" && (cb = nop), state.ended ? writeAfterEnd(this, cb) : (isBuf || validChunk(this, state, chunk, cb)) && (state.pendingcb++, ret = writeOrBuffer(this, state, isBuf, chunk, encoding, cb)), ret;
    };
    Writable3.prototype.cork = function() {
      var state = this._writableState;
      state.corked++;
    };
    Writable3.prototype.uncork = function() {
      var state = this._writableState;
      state.corked && (state.corked--, !state.writing && !state.corked && !state.bufferProcessing && state.bufferedRequest && clearBuffer(this, state));
    };
    Writable3.prototype.setDefaultEncoding = function(encoding) {
      if (typeof encoding == "string" && (encoding = encoding.toLowerCase()), !(["hex", "utf8", "utf-8", "ascii", "binary", "base64", "ucs2", "ucs-2", "utf16le", "utf-16le", "raw"].indexOf((encoding + "").toLowerCase()) > -1))
        throw new TypeError("Unknown encoding: " + encoding);
      return this._writableState.defaultEncoding = encoding, this;
    };
    function decodeChunk(state, chunk, encoding) {
      return !state.objectMode && state.decodeStrings !== !1 && typeof chunk == "string" && (chunk = Buffer2.from(chunk, encoding)), chunk;
    }
    Object.defineProperty(Writable3.prototype, "writableHighWaterMark", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: !1,
      get: function() {
        return this._writableState.highWaterMark;
      }
    });
    function writeOrBuffer(stream2, state, isBuf, chunk, encoding, cb) {
      if (!isBuf) {
        var newChunk = decodeChunk(state, chunk, encoding);
        chunk !== newChunk && (isBuf = !0, encoding = "buffer", chunk = newChunk);
      }
      var len = state.objectMode ? 1 : chunk.length;
      state.length += len;
      var ret = state.length < state.highWaterMark;
      if (ret || (state.needDrain = !0), state.writing || state.corked) {
        var last = state.lastBufferedRequest;
        state.lastBufferedRequest = {
          chunk,
          encoding,
          isBuf,
          callback: cb,
          next: null
        }, last ? last.next = state.lastBufferedRequest : state.bufferedRequest = state.lastBufferedRequest, state.bufferedRequestCount += 1;
      } else
        doWrite(stream2, state, !1, len, chunk, encoding, cb);
      return ret;
    }
    function doWrite(stream2, state, writev, len, chunk, encoding, cb) {
      state.writelen = len, state.writecb = cb, state.writing = !0, state.sync = !0, writev ? stream2._writev(chunk, state.onwrite) : stream2._write(chunk, encoding, state.onwrite), state.sync = !1;
    }
    function onwriteError(stream2, state, sync, er, cb) {
      --state.pendingcb, sync ? (pna.nextTick(cb, er), pna.nextTick(finishMaybe, stream2, state), stream2._writableState.errorEmitted = !0, stream2.emit("error", er)) : (cb(er), stream2._writableState.errorEmitted = !0, stream2.emit("error", er), finishMaybe(stream2, state));
    }
    function onwriteStateUpdate(state) {
      state.writing = !1, state.writecb = null, state.length -= state.writelen, state.writelen = 0;
    }
    function onwrite(stream2, er) {
      var state = stream2._writableState, sync = state.sync, cb = state.writecb;
      if (onwriteStateUpdate(state), er)
        onwriteError(stream2, state, sync, er, cb);
      else {
        var finished = needFinish(state);
        !finished && !state.corked && !state.bufferProcessing && state.bufferedRequest && clearBuffer(stream2, state), sync ? asyncWrite(afterWrite, stream2, state, finished, cb) : afterWrite(stream2, state, finished, cb);
      }
    }
    function afterWrite(stream2, state, finished, cb) {
      finished || onwriteDrain(stream2, state), state.pendingcb--, cb(), finishMaybe(stream2, state);
    }
    function onwriteDrain(stream2, state) {
      state.length === 0 && state.needDrain && (state.needDrain = !1, stream2.emit("drain"));
    }
    function clearBuffer(stream2, state) {
      state.bufferProcessing = !0;
      var entry = state.bufferedRequest;
      if (stream2._writev && entry && entry.next) {
        var l = state.bufferedRequestCount, buffer = new Array(l), holder = state.corkedRequestsFree;
        holder.entry = entry;
        for (var count = 0, allBuffers = !0; entry; )
          buffer[count] = entry, entry.isBuf || (allBuffers = !1), entry = entry.next, count += 1;
        buffer.allBuffers = allBuffers, doWrite(stream2, state, !0, state.length, buffer, "", holder.finish), state.pendingcb++, state.lastBufferedRequest = null, holder.next ? (state.corkedRequestsFree = holder.next, holder.next = null) : state.corkedRequestsFree = new CorkedRequest(state), state.bufferedRequestCount = 0;
      } else {
        for (; entry; ) {
          var chunk = entry.chunk, encoding = entry.encoding, cb = entry.callback, len = state.objectMode ? 1 : chunk.length;
          if (doWrite(stream2, state, !1, len, chunk, encoding, cb), entry = entry.next, state.bufferedRequestCount--, state.writing)
            break;
        }
        entry === null && (state.lastBufferedRequest = null);
      }
      state.bufferedRequest = entry, state.bufferProcessing = !1;
    }
    Writable3.prototype._write = function(chunk, encoding, cb) {
      cb(new Error("_write() is not implemented"));
    };
    Writable3.prototype._writev = null;
    Writable3.prototype.end = function(chunk, encoding, cb) {
      var state = this._writableState;
      typeof chunk == "function" ? (cb = chunk, chunk = null, encoding = null) : typeof encoding == "function" && (cb = encoding, encoding = null), chunk != null && this.write(chunk, encoding), state.corked && (state.corked = 1, this.uncork()), state.ending || endWritable(this, state, cb);
    };
    function needFinish(state) {
      return state.ending && state.length === 0 && state.bufferedRequest === null && !state.finished && !state.writing;
    }
    function callFinal(stream2, state) {
      stream2._final(function(err2) {
        state.pendingcb--, err2 && stream2.emit("error", err2), state.prefinished = !0, stream2.emit("prefinish"), finishMaybe(stream2, state);
      });
    }
    function prefinish(stream2, state) {
      !state.prefinished && !state.finalCalled && (typeof stream2._final == "function" ? (state.pendingcb++, state.finalCalled = !0, pna.nextTick(callFinal, stream2, state)) : (state.prefinished = !0, stream2.emit("prefinish")));
    }
    function finishMaybe(stream2, state) {
      var need = needFinish(state);
      return need && (prefinish(stream2, state), state.pendingcb === 0 && (state.finished = !0, stream2.emit("finish"))), need;
    }
    function endWritable(stream2, state, cb) {
      state.ending = !0, finishMaybe(stream2, state), cb && (state.finished ? pna.nextTick(cb) : stream2.once("finish", cb)), state.ended = !0, stream2.writable = !1;
    }
    function onCorkedFinish(corkReq, state, err2) {
      var entry = corkReq.entry;
      for (corkReq.entry = null; entry; ) {
        var cb = entry.callback;
        state.pendingcb--, cb(err2), entry = entry.next;
      }
      state.corkedRequestsFree.next = corkReq;
    }
    Object.defineProperty(Writable3.prototype, "destroyed", {
      get: function() {
        return this._writableState === void 0 ? !1 : this._writableState.destroyed;
      },
      set: function(value) {
        this._writableState && (this._writableState.destroyed = value);
      }
    });
    Writable3.prototype.destroy = destroyImpl.destroy;
    Writable3.prototype._undestroy = destroyImpl.undestroy;
    Writable3.prototype._destroy = function(err2, cb) {
      this.end(), cb(err2);
    };
  }
});

// ../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/lib/_stream_duplex.js
var require_stream_duplex = __commonJS({
  "../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/lib/_stream_duplex.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var pna = require_process_nextick_args(), objectKeys = Object.keys || function(obj) {
      var keys2 = [];
      for (var key in obj)
        keys2.push(key);
      return keys2;
    };
    module.exports = Duplex;
    var util2 = Object.create(require_util2());
    util2.inherits = require_inherits();
    var Readable = require_stream_readable(), Writable3 = require_stream_writable();
    util2.inherits(Duplex, Readable);
    for (keys = objectKeys(Writable3.prototype), v = 0; v < keys.length; v++)
      method = keys[v], Duplex.prototype[method] || (Duplex.prototype[method] = Writable3.prototype[method]);
    var keys, method, v;
    function Duplex(options) {
      if (!(this instanceof Duplex))
        return new Duplex(options);
      Readable.call(this, options), Writable3.call(this, options), options && options.readable === !1 && (this.readable = !1), options && options.writable === !1 && (this.writable = !1), this.allowHalfOpen = !0, options && options.allowHalfOpen === !1 && (this.allowHalfOpen = !1), this.once("end", onend);
    }
    Object.defineProperty(Duplex.prototype, "writableHighWaterMark", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: !1,
      get: function() {
        return this._writableState.highWaterMark;
      }
    });
    function onend() {
      this.allowHalfOpen || this._writableState.ended || pna.nextTick(onEndNT, this);
    }
    function onEndNT(self2) {
      self2.end();
    }
    Object.defineProperty(Duplex.prototype, "destroyed", {
      get: function() {
        return this._readableState === void 0 || this._writableState === void 0 ? !1 : this._readableState.destroyed && this._writableState.destroyed;
      },
      set: function(value) {
        this._readableState === void 0 || this._writableState === void 0 || (this._readableState.destroyed = value, this._writableState.destroyed = value);
      }
    });
    Duplex.prototype._destroy = function(err2, cb) {
      this.push(null), this.end(), pna.nextTick(cb, err2);
    };
  }
});

// ../../node_modules/.pnpm/string_decoder@1.1.1/node_modules/string_decoder/lib/string_decoder.js
var require_string_decoder = __commonJS({
  "../../node_modules/.pnpm/string_decoder@1.1.1/node_modules/string_decoder/lib/string_decoder.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Buffer2 = require_safe_buffer().Buffer, isEncoding = Buffer2.isEncoding || function(encoding) {
      switch (encoding = "" + encoding, encoding && encoding.toLowerCase()) {
        case "hex":
        case "utf8":
        case "utf-8":
        case "ascii":
        case "binary":
        case "base64":
        case "ucs2":
        case "ucs-2":
        case "utf16le":
        case "utf-16le":
        case "raw":
          return !0;
        default:
          return !1;
      }
    };
    function _normalizeEncoding(enc) {
      if (!enc)
        return "utf8";
      for (var retried; ; )
        switch (enc) {
          case "utf8":
          case "utf-8":
            return "utf8";
          case "ucs2":
          case "ucs-2":
          case "utf16le":
          case "utf-16le":
            return "utf16le";
          case "latin1":
          case "binary":
            return "latin1";
          case "base64":
          case "ascii":
          case "hex":
            return enc;
          default:
            if (retried)
              return;
            enc = ("" + enc).toLowerCase(), retried = !0;
        }
    }
    function normalizeEncoding(enc) {
      var nenc = _normalizeEncoding(enc);
      if (typeof nenc != "string" && (Buffer2.isEncoding === isEncoding || !isEncoding(enc)))
        throw new Error("Unknown encoding: " + enc);
      return nenc || enc;
    }
    exports.StringDecoder = StringDecoder;
    function StringDecoder(encoding) {
      this.encoding = normalizeEncoding(encoding);
      var nb;
      switch (this.encoding) {
        case "utf16le":
          this.text = utf16Text, this.end = utf16End, nb = 4;
          break;
        case "utf8":
          this.fillLast = utf8FillLast, nb = 4;
          break;
        case "base64":
          this.text = base64Text, this.end = base64End, nb = 3;
          break;
        default:
          this.write = simpleWrite, this.end = simpleEnd;
          return;
      }
      this.lastNeed = 0, this.lastTotal = 0, this.lastChar = Buffer2.allocUnsafe(nb);
    }
    StringDecoder.prototype.write = function(buf) {
      if (buf.length === 0)
        return "";
      var r2, i;
      if (this.lastNeed) {
        if (r2 = this.fillLast(buf), r2 === void 0)
          return "";
        i = this.lastNeed, this.lastNeed = 0;
      } else
        i = 0;
      return i < buf.length ? r2 ? r2 + this.text(buf, i) : this.text(buf, i) : r2 || "";
    };
    StringDecoder.prototype.end = utf8End;
    StringDecoder.prototype.text = utf8Text;
    StringDecoder.prototype.fillLast = function(buf) {
      if (this.lastNeed <= buf.length)
        return buf.copy(this.lastChar, this.lastTotal - this.lastNeed, 0, this.lastNeed), this.lastChar.toString(this.encoding, 0, this.lastTotal);
      buf.copy(this.lastChar, this.lastTotal - this.lastNeed, 0, buf.length), this.lastNeed -= buf.length;
    };
    function utf8CheckByte(byte) {
      return byte <= 127 ? 0 : byte >> 5 === 6 ? 2 : byte >> 4 === 14 ? 3 : byte >> 3 === 30 ? 4 : byte >> 6 === 2 ? -1 : -2;
    }
    function utf8CheckIncomplete(self2, buf, i) {
      var j = buf.length - 1;
      if (j < i)
        return 0;
      var nb = utf8CheckByte(buf[j]);
      return nb >= 0 ? (nb > 0 && (self2.lastNeed = nb - 1), nb) : --j < i || nb === -2 ? 0 : (nb = utf8CheckByte(buf[j]), nb >= 0 ? (nb > 0 && (self2.lastNeed = nb - 2), nb) : --j < i || nb === -2 ? 0 : (nb = utf8CheckByte(buf[j]), nb >= 0 ? (nb > 0 && (nb === 2 ? nb = 0 : self2.lastNeed = nb - 3), nb) : 0));
    }
    function utf8CheckExtraBytes(self2, buf, p) {
      if ((buf[0] & 192) !== 128)
        return self2.lastNeed = 0, "\uFFFD";
      if (self2.lastNeed > 1 && buf.length > 1) {
        if ((buf[1] & 192) !== 128)
          return self2.lastNeed = 1, "\uFFFD";
        if (self2.lastNeed > 2 && buf.length > 2 && (buf[2] & 192) !== 128)
          return self2.lastNeed = 2, "\uFFFD";
      }
    }
    function utf8FillLast(buf) {
      var p = this.lastTotal - this.lastNeed, r2 = utf8CheckExtraBytes(this, buf, p);
      if (r2 !== void 0)
        return r2;
      if (this.lastNeed <= buf.length)
        return buf.copy(this.lastChar, p, 0, this.lastNeed), this.lastChar.toString(this.encoding, 0, this.lastTotal);
      buf.copy(this.lastChar, p, 0, buf.length), this.lastNeed -= buf.length;
    }
    function utf8Text(buf, i) {
      var total = utf8CheckIncomplete(this, buf, i);
      if (!this.lastNeed)
        return buf.toString("utf8", i);
      this.lastTotal = total;
      var end = buf.length - (total - this.lastNeed);
      return buf.copy(this.lastChar, 0, end), buf.toString("utf8", i, end);
    }
    function utf8End(buf) {
      var r2 = buf && buf.length ? this.write(buf) : "";
      return this.lastNeed ? r2 + "\uFFFD" : r2;
    }
    function utf16Text(buf, i) {
      if ((buf.length - i) % 2 === 0) {
        var r2 = buf.toString("utf16le", i);
        if (r2) {
          var c = r2.charCodeAt(r2.length - 1);
          if (c >= 55296 && c <= 56319)
            return this.lastNeed = 2, this.lastTotal = 4, this.lastChar[0] = buf[buf.length - 2], this.lastChar[1] = buf[buf.length - 1], r2.slice(0, -1);
        }
        return r2;
      }
      return this.lastNeed = 1, this.lastTotal = 2, this.lastChar[0] = buf[buf.length - 1], buf.toString("utf16le", i, buf.length - 1);
    }
    function utf16End(buf) {
      var r2 = buf && buf.length ? this.write(buf) : "";
      if (this.lastNeed) {
        var end = this.lastTotal - this.lastNeed;
        return r2 + this.lastChar.toString("utf16le", 0, end);
      }
      return r2;
    }
    function base64Text(buf, i) {
      var n = (buf.length - i) % 3;
      return n === 0 ? buf.toString("base64", i) : (this.lastNeed = 3 - n, this.lastTotal = 3, n === 1 ? this.lastChar[0] = buf[buf.length - 1] : (this.lastChar[0] = buf[buf.length - 2], this.lastChar[1] = buf[buf.length - 1]), buf.toString("base64", i, buf.length - n));
    }
    function base64End(buf) {
      var r2 = buf && buf.length ? this.write(buf) : "";
      return this.lastNeed ? r2 + this.lastChar.toString("base64", 0, 3 - this.lastNeed) : r2;
    }
    function simpleWrite(buf) {
      return buf.toString(this.encoding);
    }
    function simpleEnd(buf) {
      return buf && buf.length ? this.write(buf) : "";
    }
  }
});

// ../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/lib/_stream_readable.js
var require_stream_readable = __commonJS({
  "../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/lib/_stream_readable.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var pna = require_process_nextick_args();
    module.exports = Readable;
    var isArray = require_isarray(), Duplex;
    Readable.ReadableState = ReadableState;
    var EE = __require("events").EventEmitter, EElistenerCount = function(emitter, type) {
      return emitter.listeners(type).length;
    }, Stream = require_stream(), Buffer2 = require_safe_buffer().Buffer, OurUint8Array = (typeof global < "u" ? global : typeof window < "u" ? window : typeof self < "u" ? self : {}).Uint8Array || function() {
    };
    function _uint8ArrayToBuffer(chunk) {
      return Buffer2.from(chunk);
    }
    function _isUint8Array(obj) {
      return Buffer2.isBuffer(obj) || obj instanceof OurUint8Array;
    }
    var util2 = Object.create(require_util2());
    util2.inherits = require_inherits();
    var debugUtil = __require("util"), debug4 = void 0;
    debugUtil && debugUtil.debuglog ? debug4 = debugUtil.debuglog("stream") : debug4 = function() {
    };
    var BufferList = require_BufferList(), destroyImpl = require_destroy(), StringDecoder;
    util2.inherits(Readable, Stream);
    var kProxyEvents = ["error", "close", "destroy", "pause", "resume"];
    function prependListener(emitter, event, fn) {
      if (typeof emitter.prependListener == "function")
        return emitter.prependListener(event, fn);
      !emitter._events || !emitter._events[event] ? emitter.on(event, fn) : isArray(emitter._events[event]) ? emitter._events[event].unshift(fn) : emitter._events[event] = [fn, emitter._events[event]];
    }
    function ReadableState(options, stream2) {
      Duplex = Duplex || require_stream_duplex(), options = options || {};
      var isDuplex = stream2 instanceof Duplex;
      this.objectMode = !!options.objectMode, isDuplex && (this.objectMode = this.objectMode || !!options.readableObjectMode);
      var hwm = options.highWaterMark, readableHwm = options.readableHighWaterMark, defaultHwm = this.objectMode ? 16 : 16 * 1024;
      hwm || hwm === 0 ? this.highWaterMark = hwm : isDuplex && (readableHwm || readableHwm === 0) ? this.highWaterMark = readableHwm : this.highWaterMark = defaultHwm, this.highWaterMark = Math.floor(this.highWaterMark), this.buffer = new BufferList(), this.length = 0, this.pipes = null, this.pipesCount = 0, this.flowing = null, this.ended = !1, this.endEmitted = !1, this.reading = !1, this.sync = !0, this.needReadable = !1, this.emittedReadable = !1, this.readableListening = !1, this.resumeScheduled = !1, this.destroyed = !1, this.defaultEncoding = options.defaultEncoding || "utf8", this.awaitDrain = 0, this.readingMore = !1, this.decoder = null, this.encoding = null, options.encoding && (StringDecoder || (StringDecoder = require_string_decoder().StringDecoder), this.decoder = new StringDecoder(options.encoding), this.encoding = options.encoding);
    }
    function Readable(options) {
      if (Duplex = Duplex || require_stream_duplex(), !(this instanceof Readable))
        return new Readable(options);
      this._readableState = new ReadableState(options, this), this.readable = !0, options && (typeof options.read == "function" && (this._read = options.read), typeof options.destroy == "function" && (this._destroy = options.destroy)), Stream.call(this);
    }
    Object.defineProperty(Readable.prototype, "destroyed", {
      get: function() {
        return this._readableState === void 0 ? !1 : this._readableState.destroyed;
      },
      set: function(value) {
        this._readableState && (this._readableState.destroyed = value);
      }
    });
    Readable.prototype.destroy = destroyImpl.destroy;
    Readable.prototype._undestroy = destroyImpl.undestroy;
    Readable.prototype._destroy = function(err2, cb) {
      this.push(null), cb(err2);
    };
    Readable.prototype.push = function(chunk, encoding) {
      var state = this._readableState, skipChunkCheck;
      return state.objectMode ? skipChunkCheck = !0 : typeof chunk == "string" && (encoding = encoding || state.defaultEncoding, encoding !== state.encoding && (chunk = Buffer2.from(chunk, encoding), encoding = ""), skipChunkCheck = !0), readableAddChunk(this, chunk, encoding, !1, skipChunkCheck);
    };
    Readable.prototype.unshift = function(chunk) {
      return readableAddChunk(this, chunk, null, !0, !1);
    };
    function readableAddChunk(stream2, chunk, encoding, addToFront, skipChunkCheck) {
      var state = stream2._readableState;
      if (chunk === null)
        state.reading = !1, onEofChunk(stream2, state);
      else {
        var er;
        skipChunkCheck || (er = chunkInvalid(state, chunk)), er ? stream2.emit("error", er) : state.objectMode || chunk && chunk.length > 0 ? (typeof chunk != "string" && !state.objectMode && Object.getPrototypeOf(chunk) !== Buffer2.prototype && (chunk = _uint8ArrayToBuffer(chunk)), addToFront ? state.endEmitted ? stream2.emit("error", new Error("stream.unshift() after end event")) : addChunk(stream2, state, chunk, !0) : state.ended ? stream2.emit("error", new Error("stream.push() after EOF")) : (state.reading = !1, state.decoder && !encoding ? (chunk = state.decoder.write(chunk), state.objectMode || chunk.length !== 0 ? addChunk(stream2, state, chunk, !1) : maybeReadMore(stream2, state)) : addChunk(stream2, state, chunk, !1))) : addToFront || (state.reading = !1);
      }
      return needMoreData(state);
    }
    function addChunk(stream2, state, chunk, addToFront) {
      state.flowing && state.length === 0 && !state.sync ? (stream2.emit("data", chunk), stream2.read(0)) : (state.length += state.objectMode ? 1 : chunk.length, addToFront ? state.buffer.unshift(chunk) : state.buffer.push(chunk), state.needReadable && emitReadable(stream2)), maybeReadMore(stream2, state);
    }
    function chunkInvalid(state, chunk) {
      var er;
      return !_isUint8Array(chunk) && typeof chunk != "string" && chunk !== void 0 && !state.objectMode && (er = new TypeError("Invalid non-string/buffer chunk")), er;
    }
    function needMoreData(state) {
      return !state.ended && (state.needReadable || state.length < state.highWaterMark || state.length === 0);
    }
    Readable.prototype.isPaused = function() {
      return this._readableState.flowing === !1;
    };
    Readable.prototype.setEncoding = function(enc) {
      return StringDecoder || (StringDecoder = require_string_decoder().StringDecoder), this._readableState.decoder = new StringDecoder(enc), this._readableState.encoding = enc, this;
    };
    var MAX_HWM = 8388608;
    function computeNewHighWaterMark(n) {
      return n >= MAX_HWM ? n = MAX_HWM : (n--, n |= n >>> 1, n |= n >>> 2, n |= n >>> 4, n |= n >>> 8, n |= n >>> 16, n++), n;
    }
    function howMuchToRead(n, state) {
      return n <= 0 || state.length === 0 && state.ended ? 0 : state.objectMode ? 1 : n !== n ? state.flowing && state.length ? state.buffer.head.data.length : state.length : (n > state.highWaterMark && (state.highWaterMark = computeNewHighWaterMark(n)), n <= state.length ? n : state.ended ? state.length : (state.needReadable = !0, 0));
    }
    Readable.prototype.read = function(n) {
      debug4("read", n), n = parseInt(n, 10);
      var state = this._readableState, nOrig = n;
      if (n !== 0 && (state.emittedReadable = !1), n === 0 && state.needReadable && (state.length >= state.highWaterMark || state.ended))
        return debug4("read: emitReadable", state.length, state.ended), state.length === 0 && state.ended ? endReadable(this) : emitReadable(this), null;
      if (n = howMuchToRead(n, state), n === 0 && state.ended)
        return state.length === 0 && endReadable(this), null;
      var doRead = state.needReadable;
      debug4("need readable", doRead), (state.length === 0 || state.length - n < state.highWaterMark) && (doRead = !0, debug4("length less than watermark", doRead)), state.ended || state.reading ? (doRead = !1, debug4("reading or ended", doRead)) : doRead && (debug4("do read"), state.reading = !0, state.sync = !0, state.length === 0 && (state.needReadable = !0), this._read(state.highWaterMark), state.sync = !1, state.reading || (n = howMuchToRead(nOrig, state)));
      var ret;
      return n > 0 ? ret = fromList(n, state) : ret = null, ret === null ? (state.needReadable = !0, n = 0) : state.length -= n, state.length === 0 && (state.ended || (state.needReadable = !0), nOrig !== n && state.ended && endReadable(this)), ret !== null && this.emit("data", ret), ret;
    };
    function onEofChunk(stream2, state) {
      if (!state.ended) {
        if (state.decoder) {
          var chunk = state.decoder.end();
          chunk && chunk.length && (state.buffer.push(chunk), state.length += state.objectMode ? 1 : chunk.length);
        }
        state.ended = !0, emitReadable(stream2);
      }
    }
    function emitReadable(stream2) {
      var state = stream2._readableState;
      state.needReadable = !1, state.emittedReadable || (debug4("emitReadable", state.flowing), state.emittedReadable = !0, state.sync ? pna.nextTick(emitReadable_, stream2) : emitReadable_(stream2));
    }
    function emitReadable_(stream2) {
      debug4("emit readable"), stream2.emit("readable"), flow(stream2);
    }
    function maybeReadMore(stream2, state) {
      state.readingMore || (state.readingMore = !0, pna.nextTick(maybeReadMore_, stream2, state));
    }
    function maybeReadMore_(stream2, state) {
      for (var len = state.length; !state.reading && !state.flowing && !state.ended && state.length < state.highWaterMark && (debug4("maybeReadMore read 0"), stream2.read(0), len !== state.length); )
        len = state.length;
      state.readingMore = !1;
    }
    Readable.prototype._read = function(n) {
      this.emit("error", new Error("_read() is not implemented"));
    };
    Readable.prototype.pipe = function(dest, pipeOpts) {
      var src = this, state = this._readableState;
      switch (state.pipesCount) {
        case 0:
          state.pipes = dest;
          break;
        case 1:
          state.pipes = [state.pipes, dest];
          break;
        default:
          state.pipes.push(dest);
          break;
      }
      state.pipesCount += 1, debug4("pipe count=%d opts=%j", state.pipesCount, pipeOpts);
      var doEnd = (!pipeOpts || pipeOpts.end !== !1) && dest !== process.stdout && dest !== process.stderr, endFn = doEnd ? onend : unpipe;
      state.endEmitted ? pna.nextTick(endFn) : src.once("end", endFn), dest.on("unpipe", onunpipe);
      function onunpipe(readable, unpipeInfo) {
        debug4("onunpipe"), readable === src && unpipeInfo && unpipeInfo.hasUnpiped === !1 && (unpipeInfo.hasUnpiped = !0, cleanup2());
      }
      function onend() {
        debug4("onend"), dest.end();
      }
      var ondrain = pipeOnDrain(src);
      dest.on("drain", ondrain);
      var cleanedUp = !1;
      function cleanup2() {
        debug4("cleanup"), dest.removeListener("close", onclose), dest.removeListener("finish", onfinish), dest.removeListener("drain", ondrain), dest.removeListener("error", onerror), dest.removeListener("unpipe", onunpipe), src.removeListener("end", onend), src.removeListener("end", unpipe), src.removeListener("data", ondata), cleanedUp = !0, state.awaitDrain && (!dest._writableState || dest._writableState.needDrain) && ondrain();
      }
      var increasedAwaitDrain = !1;
      src.on("data", ondata);
      function ondata(chunk) {
        debug4("ondata"), increasedAwaitDrain = !1;
        var ret = dest.write(chunk);
        ret === !1 && !increasedAwaitDrain && ((state.pipesCount === 1 && state.pipes === dest || state.pipesCount > 1 && indexOf(state.pipes, dest) !== -1) && !cleanedUp && (debug4("false write response, pause", state.awaitDrain), state.awaitDrain++, increasedAwaitDrain = !0), src.pause());
      }
      function onerror(er) {
        debug4("onerror", er), unpipe(), dest.removeListener("error", onerror), EElistenerCount(dest, "error") === 0 && dest.emit("error", er);
      }
      prependListener(dest, "error", onerror);
      function onclose() {
        dest.removeListener("finish", onfinish), unpipe();
      }
      dest.once("close", onclose);
      function onfinish() {
        debug4("onfinish"), dest.removeListener("close", onclose), unpipe();
      }
      dest.once("finish", onfinish);
      function unpipe() {
        debug4("unpipe"), src.unpipe(dest);
      }
      return dest.emit("pipe", src), state.flowing || (debug4("pipe resume"), src.resume()), dest;
    };
    function pipeOnDrain(src) {
      return function() {
        var state = src._readableState;
        debug4("pipeOnDrain", state.awaitDrain), state.awaitDrain && state.awaitDrain--, state.awaitDrain === 0 && EElistenerCount(src, "data") && (state.flowing = !0, flow(src));
      };
    }
    Readable.prototype.unpipe = function(dest) {
      var state = this._readableState, unpipeInfo = { hasUnpiped: !1 };
      if (state.pipesCount === 0)
        return this;
      if (state.pipesCount === 1)
        return dest && dest !== state.pipes ? this : (dest || (dest = state.pipes), state.pipes = null, state.pipesCount = 0, state.flowing = !1, dest && dest.emit("unpipe", this, unpipeInfo), this);
      if (!dest) {
        var dests = state.pipes, len = state.pipesCount;
        state.pipes = null, state.pipesCount = 0, state.flowing = !1;
        for (var i = 0; i < len; i++)
          dests[i].emit("unpipe", this, { hasUnpiped: !1 });
        return this;
      }
      var index = indexOf(state.pipes, dest);
      return index === -1 ? this : (state.pipes.splice(index, 1), state.pipesCount -= 1, state.pipesCount === 1 && (state.pipes = state.pipes[0]), dest.emit("unpipe", this, unpipeInfo), this);
    };
    Readable.prototype.on = function(ev, fn) {
      var res = Stream.prototype.on.call(this, ev, fn);
      if (ev === "data")
        this._readableState.flowing !== !1 && this.resume();
      else if (ev === "readable") {
        var state = this._readableState;
        !state.endEmitted && !state.readableListening && (state.readableListening = state.needReadable = !0, state.emittedReadable = !1, state.reading ? state.length && emitReadable(this) : pna.nextTick(nReadingNextTick, this));
      }
      return res;
    };
    Readable.prototype.addListener = Readable.prototype.on;
    function nReadingNextTick(self2) {
      debug4("readable nexttick read 0"), self2.read(0);
    }
    Readable.prototype.resume = function() {
      var state = this._readableState;
      return state.flowing || (debug4("resume"), state.flowing = !0, resume(this, state)), this;
    };
    function resume(stream2, state) {
      state.resumeScheduled || (state.resumeScheduled = !0, pna.nextTick(resume_, stream2, state));
    }
    function resume_(stream2, state) {
      state.reading || (debug4("resume read 0"), stream2.read(0)), state.resumeScheduled = !1, state.awaitDrain = 0, stream2.emit("resume"), flow(stream2), state.flowing && !state.reading && stream2.read(0);
    }
    Readable.prototype.pause = function() {
      return debug4("call pause flowing=%j", this._readableState.flowing), this._readableState.flowing !== !1 && (debug4("pause"), this._readableState.flowing = !1, this.emit("pause")), this;
    };
    function flow(stream2) {
      var state = stream2._readableState;
      for (debug4("flow", state.flowing); state.flowing && stream2.read() !== null; )
        ;
    }
    Readable.prototype.wrap = function(stream2) {
      var _this = this, state = this._readableState, paused = !1;
      stream2.on("end", function() {
        if (debug4("wrapped end"), state.decoder && !state.ended) {
          var chunk = state.decoder.end();
          chunk && chunk.length && _this.push(chunk);
        }
        _this.push(null);
      }), stream2.on("data", function(chunk) {
        if (debug4("wrapped data"), state.decoder && (chunk = state.decoder.write(chunk)), !(state.objectMode && chunk == null) && !(!state.objectMode && (!chunk || !chunk.length))) {
          var ret = _this.push(chunk);
          ret || (paused = !0, stream2.pause());
        }
      });
      for (var i in stream2)
        this[i] === void 0 && typeof stream2[i] == "function" && (this[i] = /* @__PURE__ */ function(method) {
          return function() {
            return stream2[method].apply(stream2, arguments);
          };
        }(i));
      for (var n = 0; n < kProxyEvents.length; n++)
        stream2.on(kProxyEvents[n], this.emit.bind(this, kProxyEvents[n]));
      return this._read = function(n2) {
        debug4("wrapped _read", n2), paused && (paused = !1, stream2.resume());
      }, this;
    };
    Object.defineProperty(Readable.prototype, "readableHighWaterMark", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: !1,
      get: function() {
        return this._readableState.highWaterMark;
      }
    });
    Readable._fromList = fromList;
    function fromList(n, state) {
      if (state.length === 0)
        return null;
      var ret;
      return state.objectMode ? ret = state.buffer.shift() : !n || n >= state.length ? (state.decoder ? ret = state.buffer.join("") : state.buffer.length === 1 ? ret = state.buffer.head.data : ret = state.buffer.concat(state.length), state.buffer.clear()) : ret = fromListPartial(n, state.buffer, state.decoder), ret;
    }
    function fromListPartial(n, list2, hasStrings) {
      var ret;
      return n < list2.head.data.length ? (ret = list2.head.data.slice(0, n), list2.head.data = list2.head.data.slice(n)) : n === list2.head.data.length ? ret = list2.shift() : ret = hasStrings ? copyFromBufferString(n, list2) : copyFromBuffer(n, list2), ret;
    }
    function copyFromBufferString(n, list2) {
      var p = list2.head, c = 1, ret = p.data;
      for (n -= ret.length; p = p.next; ) {
        var str = p.data, nb = n > str.length ? str.length : n;
        if (nb === str.length ? ret += str : ret += str.slice(0, n), n -= nb, n === 0) {
          nb === str.length ? (++c, p.next ? list2.head = p.next : list2.head = list2.tail = null) : (list2.head = p, p.data = str.slice(nb));
          break;
        }
        ++c;
      }
      return list2.length -= c, ret;
    }
    function copyFromBuffer(n, list2) {
      var ret = Buffer2.allocUnsafe(n), p = list2.head, c = 1;
      for (p.data.copy(ret), n -= p.data.length; p = p.next; ) {
        var buf = p.data, nb = n > buf.length ? buf.length : n;
        if (buf.copy(ret, ret.length - n, 0, nb), n -= nb, n === 0) {
          nb === buf.length ? (++c, p.next ? list2.head = p.next : list2.head = list2.tail = null) : (list2.head = p, p.data = buf.slice(nb));
          break;
        }
        ++c;
      }
      return list2.length -= c, ret;
    }
    function endReadable(stream2) {
      var state = stream2._readableState;
      if (state.length > 0)
        throw new Error('"endReadable()" called on non-empty stream');
      state.endEmitted || (state.ended = !0, pna.nextTick(endReadableNT, state, stream2));
    }
    function endReadableNT(state, stream2) {
      !state.endEmitted && state.length === 0 && (state.endEmitted = !0, stream2.readable = !1, stream2.emit("end"));
    }
    function indexOf(xs, x) {
      for (var i = 0, l = xs.length; i < l; i++)
        if (xs[i] === x)
          return i;
      return -1;
    }
  }
});

// ../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/lib/_stream_transform.js
var require_stream_transform = __commonJS({
  "../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/lib/_stream_transform.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = Transform;
    var Duplex = require_stream_duplex(), util2 = Object.create(require_util2());
    util2.inherits = require_inherits();
    util2.inherits(Transform, Duplex);
    function afterTransform(er, data) {
      var ts = this._transformState;
      ts.transforming = !1;
      var cb = ts.writecb;
      if (!cb)
        return this.emit("error", new Error("write callback called multiple times"));
      ts.writechunk = null, ts.writecb = null, data != null && this.push(data), cb(er);
      var rs = this._readableState;
      rs.reading = !1, (rs.needReadable || rs.length < rs.highWaterMark) && this._read(rs.highWaterMark);
    }
    function Transform(options) {
      if (!(this instanceof Transform))
        return new Transform(options);
      Duplex.call(this, options), this._transformState = {
        afterTransform: afterTransform.bind(this),
        needTransform: !1,
        transforming: !1,
        writecb: null,
        writechunk: null,
        writeencoding: null
      }, this._readableState.needReadable = !0, this._readableState.sync = !1, options && (typeof options.transform == "function" && (this._transform = options.transform), typeof options.flush == "function" && (this._flush = options.flush)), this.on("prefinish", prefinish);
    }
    function prefinish() {
      var _this = this;
      typeof this._flush == "function" ? this._flush(function(er, data) {
        done(_this, er, data);
      }) : done(this, null, null);
    }
    Transform.prototype.push = function(chunk, encoding) {
      return this._transformState.needTransform = !1, Duplex.prototype.push.call(this, chunk, encoding);
    };
    Transform.prototype._transform = function(chunk, encoding, cb) {
      throw new Error("_transform() is not implemented");
    };
    Transform.prototype._write = function(chunk, encoding, cb) {
      var ts = this._transformState;
      if (ts.writecb = cb, ts.writechunk = chunk, ts.writeencoding = encoding, !ts.transforming) {
        var rs = this._readableState;
        (ts.needTransform || rs.needReadable || rs.length < rs.highWaterMark) && this._read(rs.highWaterMark);
      }
    };
    Transform.prototype._read = function(n) {
      var ts = this._transformState;
      ts.writechunk !== null && ts.writecb && !ts.transforming ? (ts.transforming = !0, this._transform(ts.writechunk, ts.writeencoding, ts.afterTransform)) : ts.needTransform = !0;
    };
    Transform.prototype._destroy = function(err2, cb) {
      var _this2 = this;
      Duplex.prototype._destroy.call(this, err2, function(err22) {
        cb(err22), _this2.emit("close");
      });
    };
    function done(stream2, er, data) {
      if (er)
        return stream2.emit("error", er);
      if (data != null && stream2.push(data), stream2._writableState.length)
        throw new Error("Calling transform done when ws.length != 0");
      if (stream2._transformState.transforming)
        throw new Error("Calling transform done when still transforming");
      return stream2.push(null);
    }
  }
});

// ../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/lib/_stream_passthrough.js
var require_stream_passthrough = __commonJS({
  "../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/lib/_stream_passthrough.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = PassThrough2;
    var Transform = require_stream_transform(), util2 = Object.create(require_util2());
    util2.inherits = require_inherits();
    util2.inherits(PassThrough2, Transform);
    function PassThrough2(options) {
      if (!(this instanceof PassThrough2))
        return new PassThrough2(options);
      Transform.call(this, options);
    }
    PassThrough2.prototype._transform = function(chunk, encoding, cb) {
      cb(null, chunk);
    };
  }
});

// ../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/readable.js
var require_readable = __commonJS({
  "../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/readable.js"(exports, module) {
    init_cjs_shims();
    var Stream = __require("stream");
    process.env.READABLE_STREAM === "disable" && Stream ? (module.exports = Stream, exports = module.exports = Stream.Readable, exports.Readable = Stream.Readable, exports.Writable = Stream.Writable, exports.Duplex = Stream.Duplex, exports.Transform = Stream.Transform, exports.PassThrough = Stream.PassThrough, exports.Stream = Stream) : (exports = module.exports = require_stream_readable(), exports.Stream = Stream || exports, exports.Readable = exports, exports.Writable = require_stream_writable(), exports.Duplex = require_stream_duplex(), exports.Transform = require_stream_transform(), exports.PassThrough = require_stream_passthrough());
  }
});

// ../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/passthrough.js
var require_passthrough = __commonJS({
  "../../node_modules/.pnpm/readable-stream@2.3.8/node_modules/readable-stream/passthrough.js"(exports, module) {
    init_cjs_shims();
    module.exports = require_readable().PassThrough;
  }
});

// ../../node_modules/.pnpm/lazystream@1.0.1/node_modules/lazystream/lib/lazystream.js
var require_lazystream = __commonJS({
  "../../node_modules/.pnpm/lazystream@1.0.1/node_modules/lazystream/lib/lazystream.js"(exports, module) {
    init_cjs_shims();
    var util2 = __require("util"), PassThrough2 = require_passthrough();
    module.exports = {
      Readable,
      Writable: Writable3
    };
    util2.inherits(Readable, PassThrough2);
    util2.inherits(Writable3, PassThrough2);
    function beforeFirstCall(instance, method, callback) {
      instance[method] = function() {
        return delete instance[method], callback.apply(this, arguments), this[method].apply(this, arguments);
      };
    }
    function Readable(fn, options) {
      if (!(this instanceof Readable))
        return new Readable(fn, options);
      PassThrough2.call(this, options), beforeFirstCall(this, "_read", function() {
        var source = fn.call(this, options), emit = this.emit.bind(this, "error");
        source.on("error", emit), source.pipe(this);
      }), this.emit("readable");
    }
    function Writable3(fn, options) {
      if (!(this instanceof Writable3))
        return new Writable3(fn, options);
      PassThrough2.call(this, options), beforeFirstCall(this, "_write", function() {
        var destination = fn.call(this, options), emit = this.emit.bind(this, "error");
        destination.on("error", emit), this.pipe(destination);
      }), this.emit("writable");
    }
  }
});

// ../../node_modules/.pnpm/lodash.defaults@4.2.0/node_modules/lodash.defaults/index.js
var require_lodash = __commonJS({
  "../../node_modules/.pnpm/lodash.defaults@4.2.0/node_modules/lodash.defaults/index.js"(exports, module) {
    init_cjs_shims();
    var MAX_SAFE_INTEGER = 9007199254740991, argsTag = "[object Arguments]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", reIsUint = /^(?:0|[1-9]\d*)$/;
    function apply(func, thisArg, args) {
      switch (args.length) {
        case 0:
          return func.call(thisArg);
        case 1:
          return func.call(thisArg, args[0]);
        case 2:
          return func.call(thisArg, args[0], args[1]);
        case 3:
          return func.call(thisArg, args[0], args[1], args[2]);
      }
      return func.apply(thisArg, args);
    }
    function baseTimes(n, iteratee) {
      for (var index = -1, result = Array(n); ++index < n; )
        result[index] = iteratee(index);
      return result;
    }
    var objectProto = Object.prototype, hasOwnProperty = objectProto.hasOwnProperty, objectToString = objectProto.toString, propertyIsEnumerable = objectProto.propertyIsEnumerable, nativeMax = Math.max;
    function arrayLikeKeys(value, inherited) {
      var result = isArray(value) || isArguments(value) ? baseTimes(value.length, String) : [], length = result.length, skipIndexes = !!length;
      for (var key in value)
        (inherited || hasOwnProperty.call(value, key)) && !(skipIndexes && (key == "length" || isIndex(key, length))) && result.push(key);
      return result;
    }
    function assignInDefaults(objValue, srcValue, key, object) {
      return objValue === void 0 || eq(objValue, objectProto[key]) && !hasOwnProperty.call(object, key) ? srcValue : objValue;
    }
    function assignValue(object, key, value) {
      var objValue = object[key];
      (!(hasOwnProperty.call(object, key) && eq(objValue, value)) || value === void 0 && !(key in object)) && (object[key] = value);
    }
    function baseKeysIn(object) {
      if (!isObject4(object))
        return nativeKeysIn(object);
      var isProto = isPrototype(object), result = [];
      for (var key in object)
        key == "constructor" && (isProto || !hasOwnProperty.call(object, key)) || result.push(key);
      return result;
    }
    function baseRest(func, start) {
      return start = nativeMax(start === void 0 ? func.length - 1 : start, 0), function() {
        for (var args = arguments, index = -1, length = nativeMax(args.length - start, 0), array = Array(length); ++index < length; )
          array[index] = args[start + index];
        index = -1;
        for (var otherArgs = Array(start + 1); ++index < start; )
          otherArgs[index] = args[index];
        return otherArgs[start] = array, apply(func, this, otherArgs);
      };
    }
    function copyObject(source, props, object, customizer) {
      object || (object = {});
      for (var index = -1, length = props.length; ++index < length; ) {
        var key = props[index], newValue = customizer ? customizer(object[key], source[key], key, object, source) : void 0;
        assignValue(object, key, newValue === void 0 ? source[key] : newValue);
      }
      return object;
    }
    function createAssigner(assigner) {
      return baseRest(function(object, sources2) {
        var index = -1, length = sources2.length, customizer = length > 1 ? sources2[length - 1] : void 0, guard = length > 2 ? sources2[2] : void 0;
        for (customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : void 0, guard && isIterateeCall(sources2[0], sources2[1], guard) && (customizer = length < 3 ? void 0 : customizer, length = 1), object = Object(object); ++index < length; ) {
          var source = sources2[index];
          source && assigner(object, source, index, customizer);
        }
        return object;
      });
    }
    function isIndex(value, length) {
      return length = length ?? MAX_SAFE_INTEGER, !!length && (typeof value == "number" || reIsUint.test(value)) && value > -1 && value % 1 == 0 && value < length;
    }
    function isIterateeCall(value, index, object) {
      if (!isObject4(object))
        return !1;
      var type = typeof index;
      return (type == "number" ? isArrayLike(object) && isIndex(index, object.length) : type == "string" && index in object) ? eq(object[index], value) : !1;
    }
    function isPrototype(value) {
      var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto;
      return value === proto;
    }
    function nativeKeysIn(object) {
      var result = [];
      if (object != null)
        for (var key in Object(object))
          result.push(key);
      return result;
    }
    function eq(value, other) {
      return value === other || value !== value && other !== other;
    }
    function isArguments(value) {
      return isArrayLikeObject(value) && hasOwnProperty.call(value, "callee") && (!propertyIsEnumerable.call(value, "callee") || objectToString.call(value) == argsTag);
    }
    var isArray = Array.isArray;
    function isArrayLike(value) {
      return value != null && isLength(value.length) && !isFunction(value);
    }
    function isArrayLikeObject(value) {
      return isObjectLike(value) && isArrayLike(value);
    }
    function isFunction(value) {
      var tag = isObject4(value) ? objectToString.call(value) : "";
      return tag == funcTag || tag == genTag;
    }
    function isLength(value) {
      return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
    }
    function isObject4(value) {
      var type = typeof value;
      return !!value && (type == "object" || type == "function");
    }
    function isObjectLike(value) {
      return !!value && typeof value == "object";
    }
    var assignInWith = createAssigner(function(object, source, srcIndex, customizer) {
      copyObject(source, keysIn(source), object, customizer);
    }), defaults = baseRest(function(args) {
      return args.push(void 0, assignInDefaults), apply(assignInWith, void 0, args);
    });
    function keysIn(object) {
      return isArrayLike(object) ? arrayLikeKeys(object, !0) : baseKeysIn(object);
    }
    module.exports = defaults;
  }
});

// ../../node_modules/.pnpm/lodash.flatten@4.4.0/node_modules/lodash.flatten/index.js
var require_lodash2 = __commonJS({
  "../../node_modules/.pnpm/lodash.flatten@4.4.0/node_modules/lodash.flatten/index.js"(exports, module) {
    init_cjs_shims();
    var MAX_SAFE_INTEGER = 9007199254740991, argsTag = "[object Arguments]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", freeGlobal = typeof global == "object" && global && global.Object === Object && global, freeSelf = typeof self == "object" && self && self.Object === Object && self, root = freeGlobal || freeSelf || Function("return this")();
    function arrayPush(array, values) {
      for (var index = -1, length = values.length, offset = array.length; ++index < length; )
        array[offset + index] = values[index];
      return array;
    }
    var objectProto = Object.prototype, hasOwnProperty = objectProto.hasOwnProperty, objectToString = objectProto.toString, Symbol2 = root.Symbol, propertyIsEnumerable = objectProto.propertyIsEnumerable, spreadableSymbol = Symbol2 ? Symbol2.isConcatSpreadable : void 0;
    function baseFlatten(array, depth, predicate, isStrict, result) {
      var index = -1, length = array.length;
      for (predicate || (predicate = isFlattenable), result || (result = []); ++index < length; ) {
        var value = array[index];
        depth > 0 && predicate(value) ? depth > 1 ? baseFlatten(value, depth - 1, predicate, isStrict, result) : arrayPush(result, value) : isStrict || (result[result.length] = value);
      }
      return result;
    }
    function isFlattenable(value) {
      return isArray(value) || isArguments(value) || !!(spreadableSymbol && value && value[spreadableSymbol]);
    }
    function flatten(array) {
      var length = array ? array.length : 0;
      return length ? baseFlatten(array, 1) : [];
    }
    function isArguments(value) {
      return isArrayLikeObject(value) && hasOwnProperty.call(value, "callee") && (!propertyIsEnumerable.call(value, "callee") || objectToString.call(value) == argsTag);
    }
    var isArray = Array.isArray;
    function isArrayLike(value) {
      return value != null && isLength(value.length) && !isFunction(value);
    }
    function isArrayLikeObject(value) {
      return isObjectLike(value) && isArrayLike(value);
    }
    function isFunction(value) {
      var tag = isObject4(value) ? objectToString.call(value) : "";
      return tag == funcTag || tag == genTag;
    }
    function isLength(value) {
      return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
    }
    function isObject4(value) {
      var type = typeof value;
      return !!value && (type == "object" || type == "function");
    }
    function isObjectLike(value) {
      return !!value && typeof value == "object";
    }
    module.exports = flatten;
  }
});

// ../../node_modules/.pnpm/lodash.difference@4.5.0/node_modules/lodash.difference/index.js
var require_lodash3 = __commonJS({
  "../../node_modules/.pnpm/lodash.difference@4.5.0/node_modules/lodash.difference/index.js"(exports, module) {
    init_cjs_shims();
    var LARGE_ARRAY_SIZE = 200, HASH_UNDEFINED = "__lodash_hash_undefined__", MAX_SAFE_INTEGER = 9007199254740991, argsTag = "[object Arguments]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", reRegExpChar = /[\\^$.*+?()[\]{}|]/g, reIsHostCtor = /^\[object .+?Constructor\]$/, freeGlobal = typeof global == "object" && global && global.Object === Object && global, freeSelf = typeof self == "object" && self && self.Object === Object && self, root = freeGlobal || freeSelf || Function("return this")();
    function apply(func, thisArg, args) {
      switch (args.length) {
        case 0:
          return func.call(thisArg);
        case 1:
          return func.call(thisArg, args[0]);
        case 2:
          return func.call(thisArg, args[0], args[1]);
        case 3:
          return func.call(thisArg, args[0], args[1], args[2]);
      }
      return func.apply(thisArg, args);
    }
    function arrayIncludes(array, value) {
      var length = array ? array.length : 0;
      return !!length && baseIndexOf(array, value, 0) > -1;
    }
    function arrayIncludesWith(array, value, comparator) {
      for (var index = -1, length = array ? array.length : 0; ++index < length; )
        if (comparator(value, array[index]))
          return !0;
      return !1;
    }
    function arrayMap(array, iteratee) {
      for (var index = -1, length = array ? array.length : 0, result = Array(length); ++index < length; )
        result[index] = iteratee(array[index], index, array);
      return result;
    }
    function arrayPush(array, values) {
      for (var index = -1, length = values.length, offset = array.length; ++index < length; )
        array[offset + index] = values[index];
      return array;
    }
    function baseFindIndex(array, predicate, fromIndex, fromRight) {
      for (var length = array.length, index = fromIndex + (fromRight ? 1 : -1); fromRight ? index-- : ++index < length; )
        if (predicate(array[index], index, array))
          return index;
      return -1;
    }
    function baseIndexOf(array, value, fromIndex) {
      if (value !== value)
        return baseFindIndex(array, baseIsNaN, fromIndex);
      for (var index = fromIndex - 1, length = array.length; ++index < length; )
        if (array[index] === value)
          return index;
      return -1;
    }
    function baseIsNaN(value) {
      return value !== value;
    }
    function baseUnary(func) {
      return function(value) {
        return func(value);
      };
    }
    function cacheHas(cache2, key) {
      return cache2.has(key);
    }
    function getValue(object, key) {
      return object?.[key];
    }
    function isHostObject(value) {
      var result = !1;
      if (value != null && typeof value.toString != "function")
        try {
          result = !!(value + "");
        } catch {
        }
      return result;
    }
    var arrayProto = Array.prototype, funcProto = Function.prototype, objectProto = Object.prototype, coreJsData = root["__core-js_shared__"], maskSrcKey = function() {
      var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
      return uid ? "Symbol(src)_1." + uid : "";
    }(), funcToString = funcProto.toString, hasOwnProperty = objectProto.hasOwnProperty, objectToString = objectProto.toString, reIsNative = RegExp(
      "^" + funcToString.call(hasOwnProperty).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
    ), Symbol2 = root.Symbol, propertyIsEnumerable = objectProto.propertyIsEnumerable, splice = arrayProto.splice, spreadableSymbol = Symbol2 ? Symbol2.isConcatSpreadable : void 0, nativeMax = Math.max, Map2 = getNative(root, "Map"), nativeCreate = getNative(Object, "create");
    function Hash(entries) {
      var index = -1, length = entries ? entries.length : 0;
      for (this.clear(); ++index < length; ) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function hashClear() {
      this.__data__ = nativeCreate ? nativeCreate(null) : {};
    }
    function hashDelete(key) {
      return this.has(key) && delete this.__data__[key];
    }
    function hashGet(key) {
      var data = this.__data__;
      if (nativeCreate) {
        var result = data[key];
        return result === HASH_UNDEFINED ? void 0 : result;
      }
      return hasOwnProperty.call(data, key) ? data[key] : void 0;
    }
    function hashHas(key) {
      var data = this.__data__;
      return nativeCreate ? data[key] !== void 0 : hasOwnProperty.call(data, key);
    }
    function hashSet(key, value) {
      var data = this.__data__;
      return data[key] = nativeCreate && value === void 0 ? HASH_UNDEFINED : value, this;
    }
    Hash.prototype.clear = hashClear;
    Hash.prototype.delete = hashDelete;
    Hash.prototype.get = hashGet;
    Hash.prototype.has = hashHas;
    Hash.prototype.set = hashSet;
    function ListCache(entries) {
      var index = -1, length = entries ? entries.length : 0;
      for (this.clear(); ++index < length; ) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function listCacheClear() {
      this.__data__ = [];
    }
    function listCacheDelete(key) {
      var data = this.__data__, index = assocIndexOf(data, key);
      if (index < 0)
        return !1;
      var lastIndex = data.length - 1;
      return index == lastIndex ? data.pop() : splice.call(data, index, 1), !0;
    }
    function listCacheGet(key) {
      var data = this.__data__, index = assocIndexOf(data, key);
      return index < 0 ? void 0 : data[index][1];
    }
    function listCacheHas(key) {
      return assocIndexOf(this.__data__, key) > -1;
    }
    function listCacheSet(key, value) {
      var data = this.__data__, index = assocIndexOf(data, key);
      return index < 0 ? data.push([key, value]) : data[index][1] = value, this;
    }
    ListCache.prototype.clear = listCacheClear;
    ListCache.prototype.delete = listCacheDelete;
    ListCache.prototype.get = listCacheGet;
    ListCache.prototype.has = listCacheHas;
    ListCache.prototype.set = listCacheSet;
    function MapCache(entries) {
      var index = -1, length = entries ? entries.length : 0;
      for (this.clear(); ++index < length; ) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function mapCacheClear() {
      this.__data__ = {
        hash: new Hash(),
        map: new (Map2 || ListCache)(),
        string: new Hash()
      };
    }
    function mapCacheDelete(key) {
      return getMapData(this, key).delete(key);
    }
    function mapCacheGet(key) {
      return getMapData(this, key).get(key);
    }
    function mapCacheHas(key) {
      return getMapData(this, key).has(key);
    }
    function mapCacheSet(key, value) {
      return getMapData(this, key).set(key, value), this;
    }
    MapCache.prototype.clear = mapCacheClear;
    MapCache.prototype.delete = mapCacheDelete;
    MapCache.prototype.get = mapCacheGet;
    MapCache.prototype.has = mapCacheHas;
    MapCache.prototype.set = mapCacheSet;
    function SetCache(values) {
      var index = -1, length = values ? values.length : 0;
      for (this.__data__ = new MapCache(); ++index < length; )
        this.add(values[index]);
    }
    function setCacheAdd(value) {
      return this.__data__.set(value, HASH_UNDEFINED), this;
    }
    function setCacheHas(value) {
      return this.__data__.has(value);
    }
    SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
    SetCache.prototype.has = setCacheHas;
    function assocIndexOf(array, key) {
      for (var length = array.length; length--; )
        if (eq(array[length][0], key))
          return length;
      return -1;
    }
    function baseDifference(array, values, iteratee, comparator) {
      var index = -1, includes = arrayIncludes, isCommon = !0, length = array.length, result = [], valuesLength = values.length;
      if (!length)
        return result;
      iteratee && (values = arrayMap(values, baseUnary(iteratee))), comparator ? (includes = arrayIncludesWith, isCommon = !1) : values.length >= LARGE_ARRAY_SIZE && (includes = cacheHas, isCommon = !1, values = new SetCache(values));
      outer:
        for (; ++index < length; ) {
          var value = array[index], computed = iteratee ? iteratee(value) : value;
          if (value = comparator || value !== 0 ? value : 0, isCommon && computed === computed) {
            for (var valuesIndex = valuesLength; valuesIndex--; )
              if (values[valuesIndex] === computed)
                continue outer;
            result.push(value);
          } else
            includes(values, computed, comparator) || result.push(value);
        }
      return result;
    }
    function baseFlatten(array, depth, predicate, isStrict, result) {
      var index = -1, length = array.length;
      for (predicate || (predicate = isFlattenable), result || (result = []); ++index < length; ) {
        var value = array[index];
        depth > 0 && predicate(value) ? depth > 1 ? baseFlatten(value, depth - 1, predicate, isStrict, result) : arrayPush(result, value) : isStrict || (result[result.length] = value);
      }
      return result;
    }
    function baseIsNative(value) {
      if (!isObject4(value) || isMasked(value))
        return !1;
      var pattern = isFunction(value) || isHostObject(value) ? reIsNative : reIsHostCtor;
      return pattern.test(toSource(value));
    }
    function baseRest(func, start) {
      return start = nativeMax(start === void 0 ? func.length - 1 : start, 0), function() {
        for (var args = arguments, index = -1, length = nativeMax(args.length - start, 0), array = Array(length); ++index < length; )
          array[index] = args[start + index];
        index = -1;
        for (var otherArgs = Array(start + 1); ++index < start; )
          otherArgs[index] = args[index];
        return otherArgs[start] = array, apply(func, this, otherArgs);
      };
    }
    function getMapData(map, key) {
      var data = map.__data__;
      return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
    }
    function getNative(object, key) {
      var value = getValue(object, key);
      return baseIsNative(value) ? value : void 0;
    }
    function isFlattenable(value) {
      return isArray(value) || isArguments(value) || !!(spreadableSymbol && value && value[spreadableSymbol]);
    }
    function isKeyable(value) {
      var type = typeof value;
      return type == "string" || type == "number" || type == "symbol" || type == "boolean" ? value !== "__proto__" : value === null;
    }
    function isMasked(func) {
      return !!maskSrcKey && maskSrcKey in func;
    }
    function toSource(func) {
      if (func != null) {
        try {
          return funcToString.call(func);
        } catch {
        }
        try {
          return func + "";
        } catch {
        }
      }
      return "";
    }
    var difference2 = baseRest(function(array, values) {
      return isArrayLikeObject(array) ? baseDifference(array, baseFlatten(values, 1, isArrayLikeObject, !0)) : [];
    });
    function eq(value, other) {
      return value === other || value !== value && other !== other;
    }
    function isArguments(value) {
      return isArrayLikeObject(value) && hasOwnProperty.call(value, "callee") && (!propertyIsEnumerable.call(value, "callee") || objectToString.call(value) == argsTag);
    }
    var isArray = Array.isArray;
    function isArrayLike(value) {
      return value != null && isLength(value.length) && !isFunction(value);
    }
    function isArrayLikeObject(value) {
      return isObjectLike(value) && isArrayLike(value);
    }
    function isFunction(value) {
      var tag = isObject4(value) ? objectToString.call(value) : "";
      return tag == funcTag || tag == genTag;
    }
    function isLength(value) {
      return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
    }
    function isObject4(value) {
      var type = typeof value;
      return !!value && (type == "object" || type == "function");
    }
    function isObjectLike(value) {
      return !!value && typeof value == "object";
    }
    module.exports = difference2;
  }
});

// ../../node_modules/.pnpm/lodash.union@4.6.0/node_modules/lodash.union/index.js
var require_lodash4 = __commonJS({
  "../../node_modules/.pnpm/lodash.union@4.6.0/node_modules/lodash.union/index.js"(exports, module) {
    init_cjs_shims();
    var LARGE_ARRAY_SIZE = 200, HASH_UNDEFINED = "__lodash_hash_undefined__", INFINITY = 1 / 0, MAX_SAFE_INTEGER = 9007199254740991, argsTag = "[object Arguments]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", reRegExpChar = /[\\^$.*+?()[\]{}|]/g, reIsHostCtor = /^\[object .+?Constructor\]$/, freeGlobal = typeof global == "object" && global && global.Object === Object && global, freeSelf = typeof self == "object" && self && self.Object === Object && self, root = freeGlobal || freeSelf || Function("return this")();
    function apply(func, thisArg, args) {
      switch (args.length) {
        case 0:
          return func.call(thisArg);
        case 1:
          return func.call(thisArg, args[0]);
        case 2:
          return func.call(thisArg, args[0], args[1]);
        case 3:
          return func.call(thisArg, args[0], args[1], args[2]);
      }
      return func.apply(thisArg, args);
    }
    function arrayIncludes(array, value) {
      var length = array ? array.length : 0;
      return !!length && baseIndexOf(array, value, 0) > -1;
    }
    function arrayIncludesWith(array, value, comparator) {
      for (var index = -1, length = array ? array.length : 0; ++index < length; )
        if (comparator(value, array[index]))
          return !0;
      return !1;
    }
    function arrayPush(array, values) {
      for (var index = -1, length = values.length, offset = array.length; ++index < length; )
        array[offset + index] = values[index];
      return array;
    }
    function baseFindIndex(array, predicate, fromIndex, fromRight) {
      for (var length = array.length, index = fromIndex + (fromRight ? 1 : -1); fromRight ? index-- : ++index < length; )
        if (predicate(array[index], index, array))
          return index;
      return -1;
    }
    function baseIndexOf(array, value, fromIndex) {
      if (value !== value)
        return baseFindIndex(array, baseIsNaN, fromIndex);
      for (var index = fromIndex - 1, length = array.length; ++index < length; )
        if (array[index] === value)
          return index;
      return -1;
    }
    function baseIsNaN(value) {
      return value !== value;
    }
    function cacheHas(cache2, key) {
      return cache2.has(key);
    }
    function getValue(object, key) {
      return object?.[key];
    }
    function isHostObject(value) {
      var result = !1;
      if (value != null && typeof value.toString != "function")
        try {
          result = !!(value + "");
        } catch {
        }
      return result;
    }
    function setToArray(set2) {
      var index = -1, result = Array(set2.size);
      return set2.forEach(function(value) {
        result[++index] = value;
      }), result;
    }
    var arrayProto = Array.prototype, funcProto = Function.prototype, objectProto = Object.prototype, coreJsData = root["__core-js_shared__"], maskSrcKey = function() {
      var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
      return uid ? "Symbol(src)_1." + uid : "";
    }(), funcToString = funcProto.toString, hasOwnProperty = objectProto.hasOwnProperty, objectToString = objectProto.toString, reIsNative = RegExp(
      "^" + funcToString.call(hasOwnProperty).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
    ), Symbol2 = root.Symbol, propertyIsEnumerable = objectProto.propertyIsEnumerable, splice = arrayProto.splice, spreadableSymbol = Symbol2 ? Symbol2.isConcatSpreadable : void 0, nativeMax = Math.max, Map2 = getNative(root, "Map"), Set2 = getNative(root, "Set"), nativeCreate = getNative(Object, "create");
    function Hash(entries) {
      var index = -1, length = entries ? entries.length : 0;
      for (this.clear(); ++index < length; ) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function hashClear() {
      this.__data__ = nativeCreate ? nativeCreate(null) : {};
    }
    function hashDelete(key) {
      return this.has(key) && delete this.__data__[key];
    }
    function hashGet(key) {
      var data = this.__data__;
      if (nativeCreate) {
        var result = data[key];
        return result === HASH_UNDEFINED ? void 0 : result;
      }
      return hasOwnProperty.call(data, key) ? data[key] : void 0;
    }
    function hashHas(key) {
      var data = this.__data__;
      return nativeCreate ? data[key] !== void 0 : hasOwnProperty.call(data, key);
    }
    function hashSet(key, value) {
      var data = this.__data__;
      return data[key] = nativeCreate && value === void 0 ? HASH_UNDEFINED : value, this;
    }
    Hash.prototype.clear = hashClear;
    Hash.prototype.delete = hashDelete;
    Hash.prototype.get = hashGet;
    Hash.prototype.has = hashHas;
    Hash.prototype.set = hashSet;
    function ListCache(entries) {
      var index = -1, length = entries ? entries.length : 0;
      for (this.clear(); ++index < length; ) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function listCacheClear() {
      this.__data__ = [];
    }
    function listCacheDelete(key) {
      var data = this.__data__, index = assocIndexOf(data, key);
      if (index < 0)
        return !1;
      var lastIndex = data.length - 1;
      return index == lastIndex ? data.pop() : splice.call(data, index, 1), !0;
    }
    function listCacheGet(key) {
      var data = this.__data__, index = assocIndexOf(data, key);
      return index < 0 ? void 0 : data[index][1];
    }
    function listCacheHas(key) {
      return assocIndexOf(this.__data__, key) > -1;
    }
    function listCacheSet(key, value) {
      var data = this.__data__, index = assocIndexOf(data, key);
      return index < 0 ? data.push([key, value]) : data[index][1] = value, this;
    }
    ListCache.prototype.clear = listCacheClear;
    ListCache.prototype.delete = listCacheDelete;
    ListCache.prototype.get = listCacheGet;
    ListCache.prototype.has = listCacheHas;
    ListCache.prototype.set = listCacheSet;
    function MapCache(entries) {
      var index = -1, length = entries ? entries.length : 0;
      for (this.clear(); ++index < length; ) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function mapCacheClear() {
      this.__data__ = {
        hash: new Hash(),
        map: new (Map2 || ListCache)(),
        string: new Hash()
      };
    }
    function mapCacheDelete(key) {
      return getMapData(this, key).delete(key);
    }
    function mapCacheGet(key) {
      return getMapData(this, key).get(key);
    }
    function mapCacheHas(key) {
      return getMapData(this, key).has(key);
    }
    function mapCacheSet(key, value) {
      return getMapData(this, key).set(key, value), this;
    }
    MapCache.prototype.clear = mapCacheClear;
    MapCache.prototype.delete = mapCacheDelete;
    MapCache.prototype.get = mapCacheGet;
    MapCache.prototype.has = mapCacheHas;
    MapCache.prototype.set = mapCacheSet;
    function SetCache(values) {
      var index = -1, length = values ? values.length : 0;
      for (this.__data__ = new MapCache(); ++index < length; )
        this.add(values[index]);
    }
    function setCacheAdd(value) {
      return this.__data__.set(value, HASH_UNDEFINED), this;
    }
    function setCacheHas(value) {
      return this.__data__.has(value);
    }
    SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
    SetCache.prototype.has = setCacheHas;
    function assocIndexOf(array, key) {
      for (var length = array.length; length--; )
        if (eq(array[length][0], key))
          return length;
      return -1;
    }
    function baseFlatten(array, depth, predicate, isStrict, result) {
      var index = -1, length = array.length;
      for (predicate || (predicate = isFlattenable), result || (result = []); ++index < length; ) {
        var value = array[index];
        depth > 0 && predicate(value) ? depth > 1 ? baseFlatten(value, depth - 1, predicate, isStrict, result) : arrayPush(result, value) : isStrict || (result[result.length] = value);
      }
      return result;
    }
    function baseIsNative(value) {
      if (!isObject4(value) || isMasked(value))
        return !1;
      var pattern = isFunction(value) || isHostObject(value) ? reIsNative : reIsHostCtor;
      return pattern.test(toSource(value));
    }
    function baseRest(func, start) {
      return start = nativeMax(start === void 0 ? func.length - 1 : start, 0), function() {
        for (var args = arguments, index = -1, length = nativeMax(args.length - start, 0), array = Array(length); ++index < length; )
          array[index] = args[start + index];
        index = -1;
        for (var otherArgs = Array(start + 1); ++index < start; )
          otherArgs[index] = args[index];
        return otherArgs[start] = array, apply(func, this, otherArgs);
      };
    }
    function baseUniq(array, iteratee, comparator) {
      var index = -1, includes = arrayIncludes, length = array.length, isCommon = !0, result = [], seen = result;
      if (comparator)
        isCommon = !1, includes = arrayIncludesWith;
      else if (length >= LARGE_ARRAY_SIZE) {
        var set2 = iteratee ? null : createSet(array);
        if (set2)
          return setToArray(set2);
        isCommon = !1, includes = cacheHas, seen = new SetCache();
      } else
        seen = iteratee ? [] : result;
      outer:
        for (; ++index < length; ) {
          var value = array[index], computed = iteratee ? iteratee(value) : value;
          if (value = comparator || value !== 0 ? value : 0, isCommon && computed === computed) {
            for (var seenIndex = seen.length; seenIndex--; )
              if (seen[seenIndex] === computed)
                continue outer;
            iteratee && seen.push(computed), result.push(value);
          } else
            includes(seen, computed, comparator) || (seen !== result && seen.push(computed), result.push(value));
        }
      return result;
    }
    var createSet = Set2 && 1 / setToArray(new Set2([, -0]))[1] == INFINITY ? function(values) {
      return new Set2(values);
    } : noop;
    function getMapData(map, key) {
      var data = map.__data__;
      return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
    }
    function getNative(object, key) {
      var value = getValue(object, key);
      return baseIsNative(value) ? value : void 0;
    }
    function isFlattenable(value) {
      return isArray(value) || isArguments(value) || !!(spreadableSymbol && value && value[spreadableSymbol]);
    }
    function isKeyable(value) {
      var type = typeof value;
      return type == "string" || type == "number" || type == "symbol" || type == "boolean" ? value !== "__proto__" : value === null;
    }
    function isMasked(func) {
      return !!maskSrcKey && maskSrcKey in func;
    }
    function toSource(func) {
      if (func != null) {
        try {
          return funcToString.call(func);
        } catch {
        }
        try {
          return func + "";
        } catch {
        }
      }
      return "";
    }
    var union = baseRest(function(arrays) {
      return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, !0));
    });
    function eq(value, other) {
      return value === other || value !== value && other !== other;
    }
    function isArguments(value) {
      return isArrayLikeObject(value) && hasOwnProperty.call(value, "callee") && (!propertyIsEnumerable.call(value, "callee") || objectToString.call(value) == argsTag);
    }
    var isArray = Array.isArray;
    function isArrayLike(value) {
      return value != null && isLength(value.length) && !isFunction(value);
    }
    function isArrayLikeObject(value) {
      return isObjectLike(value) && isArrayLike(value);
    }
    function isFunction(value) {
      var tag = isObject4(value) ? objectToString.call(value) : "";
      return tag == funcTag || tag == genTag;
    }
    function isLength(value) {
      return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
    }
    function isObject4(value) {
      var type = typeof value;
      return !!value && (type == "object" || type == "function");
    }
    function isObjectLike(value) {
      return !!value && typeof value == "object";
    }
    function noop() {
    }
    module.exports = union;
  }
});

// ../../node_modules/.pnpm/lodash.isplainobject@4.0.6/node_modules/lodash.isplainobject/index.js
var require_lodash5 = __commonJS({
  "../../node_modules/.pnpm/lodash.isplainobject@4.0.6/node_modules/lodash.isplainobject/index.js"(exports, module) {
    init_cjs_shims();
    var objectTag = "[object Object]";
    function isHostObject(value) {
      var result = !1;
      if (value != null && typeof value.toString != "function")
        try {
          result = !!(value + "");
        } catch {
        }
      return result;
    }
    function overArg(func, transform2) {
      return function(arg) {
        return func(transform2(arg));
      };
    }
    var funcProto = Function.prototype, objectProto = Object.prototype, funcToString = funcProto.toString, hasOwnProperty = objectProto.hasOwnProperty, objectCtorString = funcToString.call(Object), objectToString = objectProto.toString, getPrototype = overArg(Object.getPrototypeOf, Object);
    function isObjectLike(value) {
      return !!value && typeof value == "object";
    }
    function isPlainObject(value) {
      if (!isObjectLike(value) || objectToString.call(value) != objectTag || isHostObject(value))
        return !1;
      var proto = getPrototype(value);
      if (proto === null)
        return !0;
      var Ctor = hasOwnProperty.call(proto, "constructor") && proto.constructor;
      return typeof Ctor == "function" && Ctor instanceof Ctor && funcToString.call(Ctor) == objectCtorString;
    }
    module.exports = isPlainObject;
  }
});

// ../../node_modules/.pnpm/archiver-utils@2.1.0/node_modules/archiver-utils/file.js
var require_file = __commonJS({
  "../../node_modules/.pnpm/archiver-utils@2.1.0/node_modules/archiver-utils/file.js"(exports, module) {
    init_cjs_shims();
    var fs6 = require_graceful_fs(), path3 = __require("path"), flatten = require_lodash2(), difference2 = require_lodash3(), union = require_lodash4(), isPlainObject = require_lodash5(), glob2 = require_glob(), file = module.exports = {}, pathSeparatorRe = /[\/\\]/g, processPatterns = function(patterns, fn) {
      var result = [];
      return flatten(patterns).forEach(function(pattern) {
        var exclusion = pattern.indexOf("!") === 0;
        exclusion && (pattern = pattern.slice(1));
        var matches = fn(pattern);
        exclusion ? result = difference2(result, matches) : result = union(result, matches);
      }), result;
    };
    file.exists = function() {
      var filepath = path3.join.apply(path3, arguments);
      return fs6.existsSync(filepath);
    };
    file.expand = function(...args) {
      var options = isPlainObject(args[0]) ? args.shift() : {}, patterns = Array.isArray(args[0]) ? args[0] : args;
      if (patterns.length === 0)
        return [];
      var matches = processPatterns(patterns, function(pattern) {
        return glob2.sync(pattern, options);
      });
      return options.filter && (matches = matches.filter(function(filepath) {
        filepath = path3.join(options.cwd || "", filepath);
        try {
          return typeof options.filter == "function" ? options.filter(filepath) : fs6.statSync(filepath)[options.filter]();
        } catch {
          return !1;
        }
      })), matches;
    };
    file.expandMapping = function(patterns, destBase, options) {
      options = Object.assign({
        rename: function(destBase2, destPath) {
          return path3.join(destBase2 || "", destPath);
        }
      }, options);
      var files = [], fileByDest = {};
      return file.expand(options, patterns).forEach(function(src) {
        var destPath = src;
        options.flatten && (destPath = path3.basename(destPath)), options.ext && (destPath = destPath.replace(/(\.[^\/]*)?$/, options.ext));
        var dest = options.rename(destBase, destPath, options);
        options.cwd && (src = path3.join(options.cwd, src)), dest = dest.replace(pathSeparatorRe, "/"), src = src.replace(pathSeparatorRe, "/"), fileByDest[dest] ? fileByDest[dest].src.push(src) : (files.push({
          src: [src],
          dest
        }), fileByDest[dest] = files[files.length - 1]);
      }), files;
    };
    file.normalizeFilesArray = function(data) {
      var files = [];
      return data.forEach(function(obj) {
        var prop;
        ("src" in obj || "dest" in obj) && files.push(obj);
      }), files.length === 0 ? [] : (files = _(files).chain().forEach(function(obj) {
        !("src" in obj) || !obj.src || (Array.isArray(obj.src) ? obj.src = flatten(obj.src) : obj.src = [obj.src]);
      }).map(function(obj) {
        var expandOptions = Object.assign({}, obj);
        if (delete expandOptions.src, delete expandOptions.dest, obj.expand)
          return file.expandMapping(obj.src, obj.dest, expandOptions).map(function(mapObj) {
            var result2 = Object.assign({}, obj);
            return result2.orig = Object.assign({}, obj), result2.src = mapObj.src, result2.dest = mapObj.dest, ["expand", "cwd", "flatten", "rename", "ext"].forEach(function(prop) {
              delete result2[prop];
            }), result2;
          });
        var result = Object.assign({}, obj);
        return result.orig = Object.assign({}, obj), "src" in result && Object.defineProperty(result, "src", {
          enumerable: !0,
          get: function fn() {
            var src;
            return "result" in fn || (src = obj.src, src = Array.isArray(src) ? flatten(src) : [src], fn.result = file.expand(expandOptions, src)), fn.result;
          }
        }), "dest" in result && (result.dest = obj.dest), result;
      }).flatten().value(), files);
    };
  }
});

// ../../node_modules/.pnpm/archiver-utils@2.1.0/node_modules/archiver-utils/index.js
var require_archiver_utils = __commonJS({
  "../../node_modules/.pnpm/archiver-utils@2.1.0/node_modules/archiver-utils/index.js"(exports, module) {
    init_cjs_shims();
    var fs6 = require_graceful_fs(), path3 = __require("path"), nutil = __require("util"), lazystream = require_lazystream(), normalizePath2 = require_normalize_path(), defaults = require_lodash(), Stream = __require("stream").Stream, PassThrough2 = require_readable().PassThrough, utils = module.exports = {};
    utils.file = require_file();
    utils.collectStream = function(source, callback) {
      var collection = [], size = 0;
      source.on("error", callback), source.on("data", function(chunk) {
        collection.push(chunk), size += chunk.length;
      }), source.on("end", function() {
        var buf = new Buffer(size), offset = 0;
        collection.forEach(function(data) {
          data.copy(buf, offset), offset += data.length;
        }), callback(null, buf);
      });
    };
    utils.dateify = function(dateish) {
      return dateish = dateish || /* @__PURE__ */ new Date(), dateish instanceof Date ? dateish = dateish : typeof dateish == "string" ? dateish = new Date(dateish) : dateish = /* @__PURE__ */ new Date(), dateish;
    };
    utils.defaults = function(object, source, guard) {
      var args = arguments;
      return args[0] = args[0] || {}, defaults(...args);
    };
    utils.isStream = function(source) {
      return source instanceof Stream;
    };
    utils.lazyReadStream = function(filepath) {
      return new lazystream.Readable(function() {
        return fs6.createReadStream(filepath);
      });
    };
    utils.normalizeInputSource = function(source) {
      if (source === null)
        return new Buffer(0);
      if (typeof source == "string")
        return new Buffer(source);
      if (utils.isStream(source) && !source._readableState) {
        var normalized = new PassThrough2();
        return source.pipe(normalized), normalized;
      }
      return source;
    };
    utils.sanitizePath = function(filepath) {
      return normalizePath2(filepath, !1).replace(/^\w+:/, "").replace(/^(\.\.\/|\/)+/, "");
    };
    utils.trailingSlashIt = function(str) {
      return str.slice(-1) !== "/" ? str + "/" : str;
    };
    utils.unixifyPath = function(filepath) {
      return normalizePath2(filepath, !1).replace(/^\w+:/, "");
    };
    utils.walkdir = function(dirpath, base, callback) {
      var results = [];
      typeof base == "function" && (callback = base, base = dirpath), fs6.readdir(dirpath, function(err2, list2) {
        var i = 0, file, filepath;
        if (err2)
          return callback(err2);
        (function next() {
          if (file = list2[i++], !file)
            return callback(null, results);
          filepath = path3.join(dirpath, file), fs6.stat(filepath, function(err3, stats) {
            results.push({
              path: filepath,
              relative: path3.relative(base, filepath).replace(/\\/g, "/"),
              stats
            }), stats && stats.isDirectory() ? utils.walkdir(filepath, base, function(err4, res) {
              res.forEach(function(dirEntry) {
                results.push(dirEntry);
              }), next();
            }) : next();
          });
        })();
      });
    };
  }
});

// ../../node_modules/.pnpm/archiver@5.3.2/node_modules/archiver/lib/error.js
var require_error2 = __commonJS({
  "../../node_modules/.pnpm/archiver@5.3.2/node_modules/archiver/lib/error.js"(exports, module) {
    init_cjs_shims();
    var util2 = __require("util"), ERROR_CODES = {
      ABORTED: "archive was aborted",
      DIRECTORYDIRPATHREQUIRED: "diretory dirpath argument must be a non-empty string value",
      DIRECTORYFUNCTIONINVALIDDATA: "invalid data returned by directory custom data function",
      ENTRYNAMEREQUIRED: "entry name must be a non-empty string value",
      FILEFILEPATHREQUIRED: "file filepath argument must be a non-empty string value",
      FINALIZING: "archive already finalizing",
      QUEUECLOSED: "queue closed",
      NOENDMETHOD: "no suitable finalize/end method defined by module",
      DIRECTORYNOTSUPPORTED: "support for directory entries not defined by module",
      FORMATSET: "archive format already set",
      INPUTSTEAMBUFFERREQUIRED: "input source must be valid Stream or Buffer instance",
      MODULESET: "module already set",
      SYMLINKNOTSUPPORTED: "support for symlink entries not defined by module",
      SYMLINKFILEPATHREQUIRED: "symlink filepath argument must be a non-empty string value",
      SYMLINKTARGETREQUIRED: "symlink target argument must be a non-empty string value",
      ENTRYNOTSUPPORTED: "entry not supported"
    };
    function ArchiverError(code, data) {
      Error.captureStackTrace(this, this.constructor), this.message = ERROR_CODES[code] || code, this.code = code, this.data = data;
    }
    util2.inherits(ArchiverError, Error);
    exports = module.exports = ArchiverError;
  }
});

// ../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/internal/streams/stream.js
var require_stream2 = __commonJS({
  "../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/internal/streams/stream.js"(exports, module) {
    init_cjs_shims();
    module.exports = __require("stream");
  }
});

// ../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/internal/streams/buffer_list.js
var require_buffer_list = __commonJS({
  "../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/internal/streams/buffer_list.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);
      if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        enumerableOnly && (symbols = symbols.filter(function(sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        })), keys.push.apply(keys, symbols);
      }
      return keys;
    }
    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};
        i % 2 ? ownKeys(Object(source), !0).forEach(function(key) {
          _defineProperty(target, key, source[key]);
        }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
      return target;
    }
    function _defineProperty(obj, key, value) {
      return key = _toPropertyKey(key), key in obj ? Object.defineProperty(obj, key, { value, enumerable: !0, configurable: !0, writable: !0 }) : obj[key] = value, obj;
    }
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor))
        throw new TypeError("Cannot call a class as a function");
    }
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || !1, descriptor.configurable = !0, "value" in descriptor && (descriptor.writable = !0), Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor);
      }
    }
    function _createClass(Constructor, protoProps, staticProps) {
      return protoProps && _defineProperties(Constructor.prototype, protoProps), staticProps && _defineProperties(Constructor, staticProps), Object.defineProperty(Constructor, "prototype", { writable: !1 }), Constructor;
    }
    function _toPropertyKey(arg) {
      var key = _toPrimitive(arg, "string");
      return typeof key == "symbol" ? key : String(key);
    }
    function _toPrimitive(input, hint) {
      if (typeof input != "object" || input === null)
        return input;
      var prim = input[Symbol.toPrimitive];
      if (prim !== void 0) {
        var res = prim.call(input, hint || "default");
        if (typeof res != "object")
          return res;
        throw new TypeError("@@toPrimitive must return a primitive value.");
      }
      return (hint === "string" ? String : Number)(input);
    }
    var _require = __require("buffer"), Buffer2 = _require.Buffer, _require2 = __require("util"), inspect = _require2.inspect, custom = inspect && inspect.custom || "inspect";
    function copyBuffer(src, target, offset) {
      Buffer2.prototype.copy.call(src, target, offset);
    }
    module.exports = /* @__PURE__ */ function() {
      function BufferList() {
        _classCallCheck(this, BufferList), this.head = null, this.tail = null, this.length = 0;
      }
      return _createClass(BufferList, [{
        key: "push",
        value: function(v) {
          var entry = {
            data: v,
            next: null
          };
          this.length > 0 ? this.tail.next = entry : this.head = entry, this.tail = entry, ++this.length;
        }
      }, {
        key: "unshift",
        value: function(v) {
          var entry = {
            data: v,
            next: this.head
          };
          this.length === 0 && (this.tail = entry), this.head = entry, ++this.length;
        }
      }, {
        key: "shift",
        value: function() {
          if (this.length !== 0) {
            var ret = this.head.data;
            return this.length === 1 ? this.head = this.tail = null : this.head = this.head.next, --this.length, ret;
          }
        }
      }, {
        key: "clear",
        value: function() {
          this.head = this.tail = null, this.length = 0;
        }
      }, {
        key: "join",
        value: function(s) {
          if (this.length === 0)
            return "";
          for (var p = this.head, ret = "" + p.data; p = p.next; )
            ret += s + p.data;
          return ret;
        }
      }, {
        key: "concat",
        value: function(n) {
          if (this.length === 0)
            return Buffer2.alloc(0);
          for (var ret = Buffer2.allocUnsafe(n >>> 0), p = this.head, i = 0; p; )
            copyBuffer(p.data, ret, i), i += p.data.length, p = p.next;
          return ret;
        }
        // Consumes a specified amount of bytes or characters from the buffered data.
      }, {
        key: "consume",
        value: function(n, hasStrings) {
          var ret;
          return n < this.head.data.length ? (ret = this.head.data.slice(0, n), this.head.data = this.head.data.slice(n)) : n === this.head.data.length ? ret = this.shift() : ret = hasStrings ? this._getString(n) : this._getBuffer(n), ret;
        }
      }, {
        key: "first",
        value: function() {
          return this.head.data;
        }
        // Consumes a specified amount of characters from the buffered data.
      }, {
        key: "_getString",
        value: function(n) {
          var p = this.head, c = 1, ret = p.data;
          for (n -= ret.length; p = p.next; ) {
            var str = p.data, nb = n > str.length ? str.length : n;
            if (nb === str.length ? ret += str : ret += str.slice(0, n), n -= nb, n === 0) {
              nb === str.length ? (++c, p.next ? this.head = p.next : this.head = this.tail = null) : (this.head = p, p.data = str.slice(nb));
              break;
            }
            ++c;
          }
          return this.length -= c, ret;
        }
        // Consumes a specified amount of bytes from the buffered data.
      }, {
        key: "_getBuffer",
        value: function(n) {
          var ret = Buffer2.allocUnsafe(n), p = this.head, c = 1;
          for (p.data.copy(ret), n -= p.data.length; p = p.next; ) {
            var buf = p.data, nb = n > buf.length ? buf.length : n;
            if (buf.copy(ret, ret.length - n, 0, nb), n -= nb, n === 0) {
              nb === buf.length ? (++c, p.next ? this.head = p.next : this.head = this.tail = null) : (this.head = p, p.data = buf.slice(nb));
              break;
            }
            ++c;
          }
          return this.length -= c, ret;
        }
        // Make sure the linked list only shows the minimal necessary information.
      }, {
        key: custom,
        value: function(_2, options) {
          return inspect(this, _objectSpread(_objectSpread({}, options), {}, {
            // Only inspect one level.
            depth: 0,
            // It should not recurse.
            customInspect: !1
          }));
        }
      }]), BufferList;
    }();
  }
});

// ../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/internal/streams/destroy.js
var require_destroy2 = __commonJS({
  "../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/internal/streams/destroy.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    function destroy(err2, cb) {
      var _this = this, readableDestroyed = this._readableState && this._readableState.destroyed, writableDestroyed = this._writableState && this._writableState.destroyed;
      return readableDestroyed || writableDestroyed ? (cb ? cb(err2) : err2 && (this._writableState ? this._writableState.errorEmitted || (this._writableState.errorEmitted = !0, process.nextTick(emitErrorNT, this, err2)) : process.nextTick(emitErrorNT, this, err2)), this) : (this._readableState && (this._readableState.destroyed = !0), this._writableState && (this._writableState.destroyed = !0), this._destroy(err2 || null, function(err3) {
        !cb && err3 ? _this._writableState ? _this._writableState.errorEmitted ? process.nextTick(emitCloseNT, _this) : (_this._writableState.errorEmitted = !0, process.nextTick(emitErrorAndCloseNT, _this, err3)) : process.nextTick(emitErrorAndCloseNT, _this, err3) : cb ? (process.nextTick(emitCloseNT, _this), cb(err3)) : process.nextTick(emitCloseNT, _this);
      }), this);
    }
    function emitErrorAndCloseNT(self2, err2) {
      emitErrorNT(self2, err2), emitCloseNT(self2);
    }
    function emitCloseNT(self2) {
      self2._writableState && !self2._writableState.emitClose || self2._readableState && !self2._readableState.emitClose || self2.emit("close");
    }
    function undestroy() {
      this._readableState && (this._readableState.destroyed = !1, this._readableState.reading = !1, this._readableState.ended = !1, this._readableState.endEmitted = !1), this._writableState && (this._writableState.destroyed = !1, this._writableState.ended = !1, this._writableState.ending = !1, this._writableState.finalCalled = !1, this._writableState.prefinished = !1, this._writableState.finished = !1, this._writableState.errorEmitted = !1);
    }
    function emitErrorNT(self2, err2) {
      self2.emit("error", err2);
    }
    function errorOrDestroy(stream2, err2) {
      var rState = stream2._readableState, wState = stream2._writableState;
      rState && rState.autoDestroy || wState && wState.autoDestroy ? stream2.destroy(err2) : stream2.emit("error", err2);
    }
    module.exports = {
      destroy,
      undestroy,
      errorOrDestroy
    };
  }
});

// ../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/errors.js
var require_errors4 = __commonJS({
  "../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/errors.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var codes = {};
    function createErrorType(code, message, Base) {
      Base || (Base = Error);
      function getMessage(arg1, arg2, arg3) {
        return typeof message == "string" ? message : message(arg1, arg2, arg3);
      }
      class NodeError extends Base {
        constructor(arg1, arg2, arg3) {
          super(getMessage(arg1, arg2, arg3));
        }
      }
      NodeError.prototype.name = Base.name, NodeError.prototype.code = code, codes[code] = NodeError;
    }
    function oneOf(expected, thing) {
      if (Array.isArray(expected)) {
        let len = expected.length;
        return expected = expected.map((i) => String(i)), len > 2 ? `one of ${thing} ${expected.slice(0, len - 1).join(", ")}, or ` + expected[len - 1] : len === 2 ? `one of ${thing} ${expected[0]} or ${expected[1]}` : `of ${thing} ${expected[0]}`;
      } else
        return `of ${thing} ${String(expected)}`;
    }
    function startsWith2(str, search, pos) {
      return str.substr(!pos || pos < 0 ? 0 : +pos, search.length) === search;
    }
    function endsWith2(str, search, this_len) {
      return (this_len === void 0 || this_len > str.length) && (this_len = str.length), str.substring(this_len - search.length, this_len) === search;
    }
    function includes(str, search, start) {
      return typeof start != "number" && (start = 0), start + search.length > str.length ? !1 : str.indexOf(search, start) !== -1;
    }
    createErrorType("ERR_INVALID_OPT_VALUE", function(name, value) {
      return 'The value "' + value + '" is invalid for option "' + name + '"';
    }, TypeError);
    createErrorType("ERR_INVALID_ARG_TYPE", function(name, expected, actual) {
      let determiner;
      typeof expected == "string" && startsWith2(expected, "not ") ? (determiner = "must not be", expected = expected.replace(/^not /, "")) : determiner = "must be";
      let msg;
      if (endsWith2(name, " argument"))
        msg = `The ${name} ${determiner} ${oneOf(expected, "type")}`;
      else {
        let type = includes(name, ".") ? "property" : "argument";
        msg = `The "${name}" ${type} ${determiner} ${oneOf(expected, "type")}`;
      }
      return msg += `. Received type ${typeof actual}`, msg;
    }, TypeError);
    createErrorType("ERR_STREAM_PUSH_AFTER_EOF", "stream.push() after EOF");
    createErrorType("ERR_METHOD_NOT_IMPLEMENTED", function(name) {
      return "The " + name + " method is not implemented";
    });
    createErrorType("ERR_STREAM_PREMATURE_CLOSE", "Premature close");
    createErrorType("ERR_STREAM_DESTROYED", function(name) {
      return "Cannot call " + name + " after a stream was destroyed";
    });
    createErrorType("ERR_MULTIPLE_CALLBACK", "Callback called multiple times");
    createErrorType("ERR_STREAM_CANNOT_PIPE", "Cannot pipe, not readable");
    createErrorType("ERR_STREAM_WRITE_AFTER_END", "write after end");
    createErrorType("ERR_STREAM_NULL_VALUES", "May not write null values to stream", TypeError);
    createErrorType("ERR_UNKNOWN_ENCODING", function(arg) {
      return "Unknown encoding: " + arg;
    }, TypeError);
    createErrorType("ERR_STREAM_UNSHIFT_AFTER_END_EVENT", "stream.unshift() after end event");
    module.exports.codes = codes;
  }
});

// ../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/internal/streams/state.js
var require_state = __commonJS({
  "../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/internal/streams/state.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var ERR_INVALID_OPT_VALUE = require_errors4().codes.ERR_INVALID_OPT_VALUE;
    function highWaterMarkFrom(options, isDuplex, duplexKey) {
      return options.highWaterMark != null ? options.highWaterMark : isDuplex ? options[duplexKey] : null;
    }
    function getHighWaterMark(state, options, duplexKey, isDuplex) {
      var hwm = highWaterMarkFrom(options, isDuplex, duplexKey);
      if (hwm != null) {
        if (!(isFinite(hwm) && Math.floor(hwm) === hwm) || hwm < 0) {
          var name = isDuplex ? duplexKey : "highWaterMark";
          throw new ERR_INVALID_OPT_VALUE(name, hwm);
        }
        return Math.floor(hwm);
      }
      return state.objectMode ? 16 : 16 * 1024;
    }
    module.exports = {
      getHighWaterMark
    };
  }
});

// ../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/_stream_writable.js
var require_stream_writable2 = __commonJS({
  "../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/_stream_writable.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = Writable3;
    function CorkedRequest(state) {
      var _this = this;
      this.next = null, this.entry = null, this.finish = function() {
        onCorkedFinish(_this, state);
      };
    }
    var Duplex;
    Writable3.WritableState = WritableState;
    var internalUtil = {
      deprecate: require_node5()
    }, Stream = require_stream2(), Buffer2 = __require("buffer").Buffer, OurUint8Array = (typeof global < "u" ? global : typeof window < "u" ? window : typeof self < "u" ? self : {}).Uint8Array || function() {
    };
    function _uint8ArrayToBuffer(chunk) {
      return Buffer2.from(chunk);
    }
    function _isUint8Array(obj) {
      return Buffer2.isBuffer(obj) || obj instanceof OurUint8Array;
    }
    var destroyImpl = require_destroy2(), _require = require_state(), getHighWaterMark = _require.getHighWaterMark, _require$codes = require_errors4().codes, ERR_INVALID_ARG_TYPE = _require$codes.ERR_INVALID_ARG_TYPE, ERR_METHOD_NOT_IMPLEMENTED = _require$codes.ERR_METHOD_NOT_IMPLEMENTED, ERR_MULTIPLE_CALLBACK = _require$codes.ERR_MULTIPLE_CALLBACK, ERR_STREAM_CANNOT_PIPE = _require$codes.ERR_STREAM_CANNOT_PIPE, ERR_STREAM_DESTROYED = _require$codes.ERR_STREAM_DESTROYED, ERR_STREAM_NULL_VALUES = _require$codes.ERR_STREAM_NULL_VALUES, ERR_STREAM_WRITE_AFTER_END = _require$codes.ERR_STREAM_WRITE_AFTER_END, ERR_UNKNOWN_ENCODING = _require$codes.ERR_UNKNOWN_ENCODING, errorOrDestroy = destroyImpl.errorOrDestroy;
    require_inherits()(Writable3, Stream);
    function nop() {
    }
    function WritableState(options, stream2, isDuplex) {
      Duplex = Duplex || require_stream_duplex2(), options = options || {}, typeof isDuplex != "boolean" && (isDuplex = stream2 instanceof Duplex), this.objectMode = !!options.objectMode, isDuplex && (this.objectMode = this.objectMode || !!options.writableObjectMode), this.highWaterMark = getHighWaterMark(this, options, "writableHighWaterMark", isDuplex), this.finalCalled = !1, this.needDrain = !1, this.ending = !1, this.ended = !1, this.finished = !1, this.destroyed = !1;
      var noDecode = options.decodeStrings === !1;
      this.decodeStrings = !noDecode, this.defaultEncoding = options.defaultEncoding || "utf8", this.length = 0, this.writing = !1, this.corked = 0, this.sync = !0, this.bufferProcessing = !1, this.onwrite = function(er) {
        onwrite(stream2, er);
      }, this.writecb = null, this.writelen = 0, this.bufferedRequest = null, this.lastBufferedRequest = null, this.pendingcb = 0, this.prefinished = !1, this.errorEmitted = !1, this.emitClose = options.emitClose !== !1, this.autoDestroy = !!options.autoDestroy, this.bufferedRequestCount = 0, this.corkedRequestsFree = new CorkedRequest(this);
    }
    WritableState.prototype.getBuffer = function() {
      for (var current = this.bufferedRequest, out = []; current; )
        out.push(current), current = current.next;
      return out;
    };
    (function() {
      try {
        Object.defineProperty(WritableState.prototype, "buffer", {
          get: internalUtil.deprecate(function() {
            return this.getBuffer();
          }, "_writableState.buffer is deprecated. Use _writableState.getBuffer instead.", "DEP0003")
        });
      } catch {
      }
    })();
    var realHasInstance;
    typeof Symbol == "function" && Symbol.hasInstance && typeof Function.prototype[Symbol.hasInstance] == "function" ? (realHasInstance = Function.prototype[Symbol.hasInstance], Object.defineProperty(Writable3, Symbol.hasInstance, {
      value: function(object) {
        return realHasInstance.call(this, object) ? !0 : this !== Writable3 ? !1 : object && object._writableState instanceof WritableState;
      }
    })) : realHasInstance = function(object) {
      return object instanceof this;
    };
    function Writable3(options) {
      Duplex = Duplex || require_stream_duplex2();
      var isDuplex = this instanceof Duplex;
      if (!isDuplex && !realHasInstance.call(Writable3, this))
        return new Writable3(options);
      this._writableState = new WritableState(options, this, isDuplex), this.writable = !0, options && (typeof options.write == "function" && (this._write = options.write), typeof options.writev == "function" && (this._writev = options.writev), typeof options.destroy == "function" && (this._destroy = options.destroy), typeof options.final == "function" && (this._final = options.final)), Stream.call(this);
    }
    Writable3.prototype.pipe = function() {
      errorOrDestroy(this, new ERR_STREAM_CANNOT_PIPE());
    };
    function writeAfterEnd(stream2, cb) {
      var er = new ERR_STREAM_WRITE_AFTER_END();
      errorOrDestroy(stream2, er), process.nextTick(cb, er);
    }
    function validChunk(stream2, state, chunk, cb) {
      var er;
      return chunk === null ? er = new ERR_STREAM_NULL_VALUES() : typeof chunk != "string" && !state.objectMode && (er = new ERR_INVALID_ARG_TYPE("chunk", ["string", "Buffer"], chunk)), er ? (errorOrDestroy(stream2, er), process.nextTick(cb, er), !1) : !0;
    }
    Writable3.prototype.write = function(chunk, encoding, cb) {
      var state = this._writableState, ret = !1, isBuf = !state.objectMode && _isUint8Array(chunk);
      return isBuf && !Buffer2.isBuffer(chunk) && (chunk = _uint8ArrayToBuffer(chunk)), typeof encoding == "function" && (cb = encoding, encoding = null), isBuf ? encoding = "buffer" : encoding || (encoding = state.defaultEncoding), typeof cb != "function" && (cb = nop), state.ending ? writeAfterEnd(this, cb) : (isBuf || validChunk(this, state, chunk, cb)) && (state.pendingcb++, ret = writeOrBuffer(this, state, isBuf, chunk, encoding, cb)), ret;
    };
    Writable3.prototype.cork = function() {
      this._writableState.corked++;
    };
    Writable3.prototype.uncork = function() {
      var state = this._writableState;
      state.corked && (state.corked--, !state.writing && !state.corked && !state.bufferProcessing && state.bufferedRequest && clearBuffer(this, state));
    };
    Writable3.prototype.setDefaultEncoding = function(encoding) {
      if (typeof encoding == "string" && (encoding = encoding.toLowerCase()), !(["hex", "utf8", "utf-8", "ascii", "binary", "base64", "ucs2", "ucs-2", "utf16le", "utf-16le", "raw"].indexOf((encoding + "").toLowerCase()) > -1))
        throw new ERR_UNKNOWN_ENCODING(encoding);
      return this._writableState.defaultEncoding = encoding, this;
    };
    Object.defineProperty(Writable3.prototype, "writableBuffer", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: !1,
      get: function() {
        return this._writableState && this._writableState.getBuffer();
      }
    });
    function decodeChunk(state, chunk, encoding) {
      return !state.objectMode && state.decodeStrings !== !1 && typeof chunk == "string" && (chunk = Buffer2.from(chunk, encoding)), chunk;
    }
    Object.defineProperty(Writable3.prototype, "writableHighWaterMark", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: !1,
      get: function() {
        return this._writableState.highWaterMark;
      }
    });
    function writeOrBuffer(stream2, state, isBuf, chunk, encoding, cb) {
      if (!isBuf) {
        var newChunk = decodeChunk(state, chunk, encoding);
        chunk !== newChunk && (isBuf = !0, encoding = "buffer", chunk = newChunk);
      }
      var len = state.objectMode ? 1 : chunk.length;
      state.length += len;
      var ret = state.length < state.highWaterMark;
      if (ret || (state.needDrain = !0), state.writing || state.corked) {
        var last = state.lastBufferedRequest;
        state.lastBufferedRequest = {
          chunk,
          encoding,
          isBuf,
          callback: cb,
          next: null
        }, last ? last.next = state.lastBufferedRequest : state.bufferedRequest = state.lastBufferedRequest, state.bufferedRequestCount += 1;
      } else
        doWrite(stream2, state, !1, len, chunk, encoding, cb);
      return ret;
    }
    function doWrite(stream2, state, writev, len, chunk, encoding, cb) {
      state.writelen = len, state.writecb = cb, state.writing = !0, state.sync = !0, state.destroyed ? state.onwrite(new ERR_STREAM_DESTROYED("write")) : writev ? stream2._writev(chunk, state.onwrite) : stream2._write(chunk, encoding, state.onwrite), state.sync = !1;
    }
    function onwriteError(stream2, state, sync, er, cb) {
      --state.pendingcb, sync ? (process.nextTick(cb, er), process.nextTick(finishMaybe, stream2, state), stream2._writableState.errorEmitted = !0, errorOrDestroy(stream2, er)) : (cb(er), stream2._writableState.errorEmitted = !0, errorOrDestroy(stream2, er), finishMaybe(stream2, state));
    }
    function onwriteStateUpdate(state) {
      state.writing = !1, state.writecb = null, state.length -= state.writelen, state.writelen = 0;
    }
    function onwrite(stream2, er) {
      var state = stream2._writableState, sync = state.sync, cb = state.writecb;
      if (typeof cb != "function")
        throw new ERR_MULTIPLE_CALLBACK();
      if (onwriteStateUpdate(state), er)
        onwriteError(stream2, state, sync, er, cb);
      else {
        var finished = needFinish(state) || stream2.destroyed;
        !finished && !state.corked && !state.bufferProcessing && state.bufferedRequest && clearBuffer(stream2, state), sync ? process.nextTick(afterWrite, stream2, state, finished, cb) : afterWrite(stream2, state, finished, cb);
      }
    }
    function afterWrite(stream2, state, finished, cb) {
      finished || onwriteDrain(stream2, state), state.pendingcb--, cb(), finishMaybe(stream2, state);
    }
    function onwriteDrain(stream2, state) {
      state.length === 0 && state.needDrain && (state.needDrain = !1, stream2.emit("drain"));
    }
    function clearBuffer(stream2, state) {
      state.bufferProcessing = !0;
      var entry = state.bufferedRequest;
      if (stream2._writev && entry && entry.next) {
        var l = state.bufferedRequestCount, buffer = new Array(l), holder = state.corkedRequestsFree;
        holder.entry = entry;
        for (var count = 0, allBuffers = !0; entry; )
          buffer[count] = entry, entry.isBuf || (allBuffers = !1), entry = entry.next, count += 1;
        buffer.allBuffers = allBuffers, doWrite(stream2, state, !0, state.length, buffer, "", holder.finish), state.pendingcb++, state.lastBufferedRequest = null, holder.next ? (state.corkedRequestsFree = holder.next, holder.next = null) : state.corkedRequestsFree = new CorkedRequest(state), state.bufferedRequestCount = 0;
      } else {
        for (; entry; ) {
          var chunk = entry.chunk, encoding = entry.encoding, cb = entry.callback, len = state.objectMode ? 1 : chunk.length;
          if (doWrite(stream2, state, !1, len, chunk, encoding, cb), entry = entry.next, state.bufferedRequestCount--, state.writing)
            break;
        }
        entry === null && (state.lastBufferedRequest = null);
      }
      state.bufferedRequest = entry, state.bufferProcessing = !1;
    }
    Writable3.prototype._write = function(chunk, encoding, cb) {
      cb(new ERR_METHOD_NOT_IMPLEMENTED("_write()"));
    };
    Writable3.prototype._writev = null;
    Writable3.prototype.end = function(chunk, encoding, cb) {
      var state = this._writableState;
      return typeof chunk == "function" ? (cb = chunk, chunk = null, encoding = null) : typeof encoding == "function" && (cb = encoding, encoding = null), chunk != null && this.write(chunk, encoding), state.corked && (state.corked = 1, this.uncork()), state.ending || endWritable(this, state, cb), this;
    };
    Object.defineProperty(Writable3.prototype, "writableLength", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: !1,
      get: function() {
        return this._writableState.length;
      }
    });
    function needFinish(state) {
      return state.ending && state.length === 0 && state.bufferedRequest === null && !state.finished && !state.writing;
    }
    function callFinal(stream2, state) {
      stream2._final(function(err2) {
        state.pendingcb--, err2 && errorOrDestroy(stream2, err2), state.prefinished = !0, stream2.emit("prefinish"), finishMaybe(stream2, state);
      });
    }
    function prefinish(stream2, state) {
      !state.prefinished && !state.finalCalled && (typeof stream2._final == "function" && !state.destroyed ? (state.pendingcb++, state.finalCalled = !0, process.nextTick(callFinal, stream2, state)) : (state.prefinished = !0, stream2.emit("prefinish")));
    }
    function finishMaybe(stream2, state) {
      var need = needFinish(state);
      if (need && (prefinish(stream2, state), state.pendingcb === 0 && (state.finished = !0, stream2.emit("finish"), state.autoDestroy))) {
        var rState = stream2._readableState;
        (!rState || rState.autoDestroy && rState.endEmitted) && stream2.destroy();
      }
      return need;
    }
    function endWritable(stream2, state, cb) {
      state.ending = !0, finishMaybe(stream2, state), cb && (state.finished ? process.nextTick(cb) : stream2.once("finish", cb)), state.ended = !0, stream2.writable = !1;
    }
    function onCorkedFinish(corkReq, state, err2) {
      var entry = corkReq.entry;
      for (corkReq.entry = null; entry; ) {
        var cb = entry.callback;
        state.pendingcb--, cb(err2), entry = entry.next;
      }
      state.corkedRequestsFree.next = corkReq;
    }
    Object.defineProperty(Writable3.prototype, "destroyed", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: !1,
      get: function() {
        return this._writableState === void 0 ? !1 : this._writableState.destroyed;
      },
      set: function(value) {
        this._writableState && (this._writableState.destroyed = value);
      }
    });
    Writable3.prototype.destroy = destroyImpl.destroy;
    Writable3.prototype._undestroy = destroyImpl.undestroy;
    Writable3.prototype._destroy = function(err2, cb) {
      cb(err2);
    };
  }
});

// ../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/_stream_duplex.js
var require_stream_duplex2 = __commonJS({
  "../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/_stream_duplex.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var objectKeys = Object.keys || function(obj) {
      var keys2 = [];
      for (var key in obj)
        keys2.push(key);
      return keys2;
    };
    module.exports = Duplex;
    var Readable = require_stream_readable2(), Writable3 = require_stream_writable2();
    require_inherits()(Duplex, Readable);
    for (keys = objectKeys(Writable3.prototype), v = 0; v < keys.length; v++)
      method = keys[v], Duplex.prototype[method] || (Duplex.prototype[method] = Writable3.prototype[method]);
    var keys, method, v;
    function Duplex(options) {
      if (!(this instanceof Duplex))
        return new Duplex(options);
      Readable.call(this, options), Writable3.call(this, options), this.allowHalfOpen = !0, options && (options.readable === !1 && (this.readable = !1), options.writable === !1 && (this.writable = !1), options.allowHalfOpen === !1 && (this.allowHalfOpen = !1, this.once("end", onend)));
    }
    Object.defineProperty(Duplex.prototype, "writableHighWaterMark", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: !1,
      get: function() {
        return this._writableState.highWaterMark;
      }
    });
    Object.defineProperty(Duplex.prototype, "writableBuffer", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: !1,
      get: function() {
        return this._writableState && this._writableState.getBuffer();
      }
    });
    Object.defineProperty(Duplex.prototype, "writableLength", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: !1,
      get: function() {
        return this._writableState.length;
      }
    });
    function onend() {
      this._writableState.ended || process.nextTick(onEndNT, this);
    }
    function onEndNT(self2) {
      self2.end();
    }
    Object.defineProperty(Duplex.prototype, "destroyed", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: !1,
      get: function() {
        return this._readableState === void 0 || this._writableState === void 0 ? !1 : this._readableState.destroyed && this._writableState.destroyed;
      },
      set: function(value) {
        this._readableState === void 0 || this._writableState === void 0 || (this._readableState.destroyed = value, this._writableState.destroyed = value);
      }
    });
  }
});

// ../../node_modules/.pnpm/safe-buffer@5.2.1/node_modules/safe-buffer/index.js
var require_safe_buffer2 = __commonJS({
  "../../node_modules/.pnpm/safe-buffer@5.2.1/node_modules/safe-buffer/index.js"(exports, module) {
    init_cjs_shims();
    var buffer = __require("buffer"), Buffer2 = buffer.Buffer;
    function copyProps(src, dst) {
      for (var key in src)
        dst[key] = src[key];
    }
    Buffer2.from && Buffer2.alloc && Buffer2.allocUnsafe && Buffer2.allocUnsafeSlow ? module.exports = buffer : (copyProps(buffer, exports), exports.Buffer = SafeBuffer);
    function SafeBuffer(arg, encodingOrOffset, length) {
      return Buffer2(arg, encodingOrOffset, length);
    }
    SafeBuffer.prototype = Object.create(Buffer2.prototype);
    copyProps(Buffer2, SafeBuffer);
    SafeBuffer.from = function(arg, encodingOrOffset, length) {
      if (typeof arg == "number")
        throw new TypeError("Argument must not be a number");
      return Buffer2(arg, encodingOrOffset, length);
    };
    SafeBuffer.alloc = function(size, fill, encoding) {
      if (typeof size != "number")
        throw new TypeError("Argument must be a number");
      var buf = Buffer2(size);
      return fill !== void 0 ? typeof encoding == "string" ? buf.fill(fill, encoding) : buf.fill(fill) : buf.fill(0), buf;
    };
    SafeBuffer.allocUnsafe = function(size) {
      if (typeof size != "number")
        throw new TypeError("Argument must be a number");
      return Buffer2(size);
    };
    SafeBuffer.allocUnsafeSlow = function(size) {
      if (typeof size != "number")
        throw new TypeError("Argument must be a number");
      return buffer.SlowBuffer(size);
    };
  }
});

// ../../node_modules/.pnpm/string_decoder@1.3.0/node_modules/string_decoder/lib/string_decoder.js
var require_string_decoder2 = __commonJS({
  "../../node_modules/.pnpm/string_decoder@1.3.0/node_modules/string_decoder/lib/string_decoder.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Buffer2 = require_safe_buffer2().Buffer, isEncoding = Buffer2.isEncoding || function(encoding) {
      switch (encoding = "" + encoding, encoding && encoding.toLowerCase()) {
        case "hex":
        case "utf8":
        case "utf-8":
        case "ascii":
        case "binary":
        case "base64":
        case "ucs2":
        case "ucs-2":
        case "utf16le":
        case "utf-16le":
        case "raw":
          return !0;
        default:
          return !1;
      }
    };
    function _normalizeEncoding(enc) {
      if (!enc)
        return "utf8";
      for (var retried; ; )
        switch (enc) {
          case "utf8":
          case "utf-8":
            return "utf8";
          case "ucs2":
          case "ucs-2":
          case "utf16le":
          case "utf-16le":
            return "utf16le";
          case "latin1":
          case "binary":
            return "latin1";
          case "base64":
          case "ascii":
          case "hex":
            return enc;
          default:
            if (retried)
              return;
            enc = ("" + enc).toLowerCase(), retried = !0;
        }
    }
    function normalizeEncoding(enc) {
      var nenc = _normalizeEncoding(enc);
      if (typeof nenc != "string" && (Buffer2.isEncoding === isEncoding || !isEncoding(enc)))
        throw new Error("Unknown encoding: " + enc);
      return nenc || enc;
    }
    exports.StringDecoder = StringDecoder;
    function StringDecoder(encoding) {
      this.encoding = normalizeEncoding(encoding);
      var nb;
      switch (this.encoding) {
        case "utf16le":
          this.text = utf16Text, this.end = utf16End, nb = 4;
          break;
        case "utf8":
          this.fillLast = utf8FillLast, nb = 4;
          break;
        case "base64":
          this.text = base64Text, this.end = base64End, nb = 3;
          break;
        default:
          this.write = simpleWrite, this.end = simpleEnd;
          return;
      }
      this.lastNeed = 0, this.lastTotal = 0, this.lastChar = Buffer2.allocUnsafe(nb);
    }
    StringDecoder.prototype.write = function(buf) {
      if (buf.length === 0)
        return "";
      var r2, i;
      if (this.lastNeed) {
        if (r2 = this.fillLast(buf), r2 === void 0)
          return "";
        i = this.lastNeed, this.lastNeed = 0;
      } else
        i = 0;
      return i < buf.length ? r2 ? r2 + this.text(buf, i) : this.text(buf, i) : r2 || "";
    };
    StringDecoder.prototype.end = utf8End;
    StringDecoder.prototype.text = utf8Text;
    StringDecoder.prototype.fillLast = function(buf) {
      if (this.lastNeed <= buf.length)
        return buf.copy(this.lastChar, this.lastTotal - this.lastNeed, 0, this.lastNeed), this.lastChar.toString(this.encoding, 0, this.lastTotal);
      buf.copy(this.lastChar, this.lastTotal - this.lastNeed, 0, buf.length), this.lastNeed -= buf.length;
    };
    function utf8CheckByte(byte) {
      return byte <= 127 ? 0 : byte >> 5 === 6 ? 2 : byte >> 4 === 14 ? 3 : byte >> 3 === 30 ? 4 : byte >> 6 === 2 ? -1 : -2;
    }
    function utf8CheckIncomplete(self2, buf, i) {
      var j = buf.length - 1;
      if (j < i)
        return 0;
      var nb = utf8CheckByte(buf[j]);
      return nb >= 0 ? (nb > 0 && (self2.lastNeed = nb - 1), nb) : --j < i || nb === -2 ? 0 : (nb = utf8CheckByte(buf[j]), nb >= 0 ? (nb > 0 && (self2.lastNeed = nb - 2), nb) : --j < i || nb === -2 ? 0 : (nb = utf8CheckByte(buf[j]), nb >= 0 ? (nb > 0 && (nb === 2 ? nb = 0 : self2.lastNeed = nb - 3), nb) : 0));
    }
    function utf8CheckExtraBytes(self2, buf, p) {
      if ((buf[0] & 192) !== 128)
        return self2.lastNeed = 0, "\uFFFD";
      if (self2.lastNeed > 1 && buf.length > 1) {
        if ((buf[1] & 192) !== 128)
          return self2.lastNeed = 1, "\uFFFD";
        if (self2.lastNeed > 2 && buf.length > 2 && (buf[2] & 192) !== 128)
          return self2.lastNeed = 2, "\uFFFD";
      }
    }
    function utf8FillLast(buf) {
      var p = this.lastTotal - this.lastNeed, r2 = utf8CheckExtraBytes(this, buf, p);
      if (r2 !== void 0)
        return r2;
      if (this.lastNeed <= buf.length)
        return buf.copy(this.lastChar, p, 0, this.lastNeed), this.lastChar.toString(this.encoding, 0, this.lastTotal);
      buf.copy(this.lastChar, p, 0, buf.length), this.lastNeed -= buf.length;
    }
    function utf8Text(buf, i) {
      var total = utf8CheckIncomplete(this, buf, i);
      if (!this.lastNeed)
        return buf.toString("utf8", i);
      this.lastTotal = total;
      var end = buf.length - (total - this.lastNeed);
      return buf.copy(this.lastChar, 0, end), buf.toString("utf8", i, end);
    }
    function utf8End(buf) {
      var r2 = buf && buf.length ? this.write(buf) : "";
      return this.lastNeed ? r2 + "\uFFFD" : r2;
    }
    function utf16Text(buf, i) {
      if ((buf.length - i) % 2 === 0) {
        var r2 = buf.toString("utf16le", i);
        if (r2) {
          var c = r2.charCodeAt(r2.length - 1);
          if (c >= 55296 && c <= 56319)
            return this.lastNeed = 2, this.lastTotal = 4, this.lastChar[0] = buf[buf.length - 2], this.lastChar[1] = buf[buf.length - 1], r2.slice(0, -1);
        }
        return r2;
      }
      return this.lastNeed = 1, this.lastTotal = 2, this.lastChar[0] = buf[buf.length - 1], buf.toString("utf16le", i, buf.length - 1);
    }
    function utf16End(buf) {
      var r2 = buf && buf.length ? this.write(buf) : "";
      if (this.lastNeed) {
        var end = this.lastTotal - this.lastNeed;
        return r2 + this.lastChar.toString("utf16le", 0, end);
      }
      return r2;
    }
    function base64Text(buf, i) {
      var n = (buf.length - i) % 3;
      return n === 0 ? buf.toString("base64", i) : (this.lastNeed = 3 - n, this.lastTotal = 3, n === 1 ? this.lastChar[0] = buf[buf.length - 1] : (this.lastChar[0] = buf[buf.length - 2], this.lastChar[1] = buf[buf.length - 1]), buf.toString("base64", i, buf.length - n));
    }
    function base64End(buf) {
      var r2 = buf && buf.length ? this.write(buf) : "";
      return this.lastNeed ? r2 + this.lastChar.toString("base64", 0, 3 - this.lastNeed) : r2;
    }
    function simpleWrite(buf) {
      return buf.toString(this.encoding);
    }
    function simpleEnd(buf) {
      return buf && buf.length ? this.write(buf) : "";
    }
  }
});

// ../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/internal/streams/end-of-stream.js
var require_end_of_stream2 = __commonJS({
  "../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/internal/streams/end-of-stream.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var ERR_STREAM_PREMATURE_CLOSE = require_errors4().codes.ERR_STREAM_PREMATURE_CLOSE;
    function once(callback) {
      var called = !1;
      return function() {
        if (!called) {
          called = !0;
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++)
            args[_key] = arguments[_key];
          callback.apply(this, args);
        }
      };
    }
    function noop() {
    }
    function isRequest(stream2) {
      return stream2.setHeader && typeof stream2.abort == "function";
    }
    function eos(stream2, opts, callback) {
      if (typeof opts == "function")
        return eos(stream2, null, opts);
      opts || (opts = {}), callback = once(callback || noop);
      var readable = opts.readable || opts.readable !== !1 && stream2.readable, writable = opts.writable || opts.writable !== !1 && stream2.writable, onlegacyfinish = function() {
        stream2.writable || onfinish();
      }, writableEnded = stream2._writableState && stream2._writableState.finished, onfinish = function() {
        writable = !1, writableEnded = !0, readable || callback.call(stream2);
      }, readableEnded = stream2._readableState && stream2._readableState.endEmitted, onend = function() {
        readable = !1, readableEnded = !0, writable || callback.call(stream2);
      }, onerror = function(err2) {
        callback.call(stream2, err2);
      }, onclose = function() {
        var err2;
        if (readable && !readableEnded)
          return (!stream2._readableState || !stream2._readableState.ended) && (err2 = new ERR_STREAM_PREMATURE_CLOSE()), callback.call(stream2, err2);
        if (writable && !writableEnded)
          return (!stream2._writableState || !stream2._writableState.ended) && (err2 = new ERR_STREAM_PREMATURE_CLOSE()), callback.call(stream2, err2);
      }, onrequest = function() {
        stream2.req.on("finish", onfinish);
      };
      return isRequest(stream2) ? (stream2.on("complete", onfinish), stream2.on("abort", onclose), stream2.req ? onrequest() : stream2.on("request", onrequest)) : writable && !stream2._writableState && (stream2.on("end", onlegacyfinish), stream2.on("close", onlegacyfinish)), stream2.on("end", onend), stream2.on("finish", onfinish), opts.error !== !1 && stream2.on("error", onerror), stream2.on("close", onclose), function() {
        stream2.removeListener("complete", onfinish), stream2.removeListener("abort", onclose), stream2.removeListener("request", onrequest), stream2.req && stream2.req.removeListener("finish", onfinish), stream2.removeListener("end", onlegacyfinish), stream2.removeListener("close", onlegacyfinish), stream2.removeListener("finish", onfinish), stream2.removeListener("end", onend), stream2.removeListener("error", onerror), stream2.removeListener("close", onclose);
      };
    }
    module.exports = eos;
  }
});

// ../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/internal/streams/async_iterator.js
var require_async_iterator = __commonJS({
  "../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/internal/streams/async_iterator.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var _Object$setPrototypeO;
    function _defineProperty(obj, key, value) {
      return key = _toPropertyKey(key), key in obj ? Object.defineProperty(obj, key, { value, enumerable: !0, configurable: !0, writable: !0 }) : obj[key] = value, obj;
    }
    function _toPropertyKey(arg) {
      var key = _toPrimitive(arg, "string");
      return typeof key == "symbol" ? key : String(key);
    }
    function _toPrimitive(input, hint) {
      if (typeof input != "object" || input === null)
        return input;
      var prim = input[Symbol.toPrimitive];
      if (prim !== void 0) {
        var res = prim.call(input, hint || "default");
        if (typeof res != "object")
          return res;
        throw new TypeError("@@toPrimitive must return a primitive value.");
      }
      return (hint === "string" ? String : Number)(input);
    }
    var finished = require_end_of_stream2(), kLastResolve = Symbol("lastResolve"), kLastReject = Symbol("lastReject"), kError = Symbol("error"), kEnded = Symbol("ended"), kLastPromise = Symbol("lastPromise"), kHandlePromise = Symbol("handlePromise"), kStream = Symbol("stream");
    function createIterResult(value, done) {
      return {
        value,
        done
      };
    }
    function readAndResolve(iter) {
      var resolve2 = iter[kLastResolve];
      if (resolve2 !== null) {
        var data = iter[kStream].read();
        data !== null && (iter[kLastPromise] = null, iter[kLastResolve] = null, iter[kLastReject] = null, resolve2(createIterResult(data, !1)));
      }
    }
    function onReadable(iter) {
      process.nextTick(readAndResolve, iter);
    }
    function wrapForNext(lastPromise, iter) {
      return function(resolve2, reject) {
        lastPromise.then(function() {
          if (iter[kEnded]) {
            resolve2(createIterResult(void 0, !0));
            return;
          }
          iter[kHandlePromise](resolve2, reject);
        }, reject);
      };
    }
    var AsyncIteratorPrototype = Object.getPrototypeOf(function() {
    }), ReadableStreamAsyncIteratorPrototype = Object.setPrototypeOf((_Object$setPrototypeO = {
      get stream() {
        return this[kStream];
      },
      next: function() {
        var _this = this, error = this[kError];
        if (error !== null)
          return Promise.reject(error);
        if (this[kEnded])
          return Promise.resolve(createIterResult(void 0, !0));
        if (this[kStream].destroyed)
          return new Promise(function(resolve2, reject) {
            process.nextTick(function() {
              _this[kError] ? reject(_this[kError]) : resolve2(createIterResult(void 0, !0));
            });
          });
        var lastPromise = this[kLastPromise], promise;
        if (lastPromise)
          promise = new Promise(wrapForNext(lastPromise, this));
        else {
          var data = this[kStream].read();
          if (data !== null)
            return Promise.resolve(createIterResult(data, !1));
          promise = new Promise(this[kHandlePromise]);
        }
        return this[kLastPromise] = promise, promise;
      }
    }, _defineProperty(_Object$setPrototypeO, Symbol.asyncIterator, function() {
      return this;
    }), _defineProperty(_Object$setPrototypeO, "return", function() {
      var _this2 = this;
      return new Promise(function(resolve2, reject) {
        _this2[kStream].destroy(null, function(err2) {
          if (err2) {
            reject(err2);
            return;
          }
          resolve2(createIterResult(void 0, !0));
        });
      });
    }), _Object$setPrototypeO), AsyncIteratorPrototype), createReadableStreamAsyncIterator = function(stream2) {
      var _Object$create, iterator = Object.create(ReadableStreamAsyncIteratorPrototype, (_Object$create = {}, _defineProperty(_Object$create, kStream, {
        value: stream2,
        writable: !0
      }), _defineProperty(_Object$create, kLastResolve, {
        value: null,
        writable: !0
      }), _defineProperty(_Object$create, kLastReject, {
        value: null,
        writable: !0
      }), _defineProperty(_Object$create, kError, {
        value: null,
        writable: !0
      }), _defineProperty(_Object$create, kEnded, {
        value: stream2._readableState.endEmitted,
        writable: !0
      }), _defineProperty(_Object$create, kHandlePromise, {
        value: function(resolve2, reject) {
          var data = iterator[kStream].read();
          data ? (iterator[kLastPromise] = null, iterator[kLastResolve] = null, iterator[kLastReject] = null, resolve2(createIterResult(data, !1))) : (iterator[kLastResolve] = resolve2, iterator[kLastReject] = reject);
        },
        writable: !0
      }), _Object$create));
      return iterator[kLastPromise] = null, finished(stream2, function(err2) {
        if (err2 && err2.code !== "ERR_STREAM_PREMATURE_CLOSE") {
          var reject = iterator[kLastReject];
          reject !== null && (iterator[kLastPromise] = null, iterator[kLastResolve] = null, iterator[kLastReject] = null, reject(err2)), iterator[kError] = err2;
          return;
        }
        var resolve2 = iterator[kLastResolve];
        resolve2 !== null && (iterator[kLastPromise] = null, iterator[kLastResolve] = null, iterator[kLastReject] = null, resolve2(createIterResult(void 0, !0))), iterator[kEnded] = !0;
      }), stream2.on("readable", onReadable.bind(null, iterator)), iterator;
    };
    module.exports = createReadableStreamAsyncIterator;
  }
});

// ../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/internal/streams/from.js
var require_from = __commonJS({
  "../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/internal/streams/from.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    function asyncGeneratorStep(gen, resolve2, reject, _next, _throw, key, arg) {
      try {
        var info2 = gen[key](arg), value = info2.value;
      } catch (error) {
        reject(error);
        return;
      }
      info2.done ? resolve2(value) : Promise.resolve(value).then(_next, _throw);
    }
    function _asyncToGenerator(fn) {
      return function() {
        var self2 = this, args = arguments;
        return new Promise(function(resolve2, reject) {
          var gen = fn.apply(self2, args);
          function _next(value) {
            asyncGeneratorStep(gen, resolve2, reject, _next, _throw, "next", value);
          }
          function _throw(err2) {
            asyncGeneratorStep(gen, resolve2, reject, _next, _throw, "throw", err2);
          }
          _next(void 0);
        });
      };
    }
    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);
      if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        enumerableOnly && (symbols = symbols.filter(function(sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        })), keys.push.apply(keys, symbols);
      }
      return keys;
    }
    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};
        i % 2 ? ownKeys(Object(source), !0).forEach(function(key) {
          _defineProperty(target, key, source[key]);
        }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
      return target;
    }
    function _defineProperty(obj, key, value) {
      return key = _toPropertyKey(key), key in obj ? Object.defineProperty(obj, key, { value, enumerable: !0, configurable: !0, writable: !0 }) : obj[key] = value, obj;
    }
    function _toPropertyKey(arg) {
      var key = _toPrimitive(arg, "string");
      return typeof key == "symbol" ? key : String(key);
    }
    function _toPrimitive(input, hint) {
      if (typeof input != "object" || input === null)
        return input;
      var prim = input[Symbol.toPrimitive];
      if (prim !== void 0) {
        var res = prim.call(input, hint || "default");
        if (typeof res != "object")
          return res;
        throw new TypeError("@@toPrimitive must return a primitive value.");
      }
      return (hint === "string" ? String : Number)(input);
    }
    var ERR_INVALID_ARG_TYPE = require_errors4().codes.ERR_INVALID_ARG_TYPE;
    function from(Readable, iterable, opts) {
      var iterator;
      if (iterable && typeof iterable.next == "function")
        iterator = iterable;
      else if (iterable && iterable[Symbol.asyncIterator])
        iterator = iterable[Symbol.asyncIterator]();
      else if (iterable && iterable[Symbol.iterator])
        iterator = iterable[Symbol.iterator]();
      else
        throw new ERR_INVALID_ARG_TYPE("iterable", ["Iterable"], iterable);
      var readable = new Readable(_objectSpread({
        objectMode: !0
      }, opts)), reading = !1;
      readable._read = function() {
        reading || (reading = !0, next());
      };
      function next() {
        return _next2.apply(this, arguments);
      }
      function _next2() {
        return _next2 = _asyncToGenerator(function* () {
          try {
            var _yield$iterator$next = yield iterator.next(), value = _yield$iterator$next.value, done = _yield$iterator$next.done;
            done ? readable.push(null) : readable.push(yield value) ? next() : reading = !1;
          } catch (err2) {
            readable.destroy(err2);
          }
        }), _next2.apply(this, arguments);
      }
      return readable;
    }
    module.exports = from;
  }
});

// ../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/_stream_readable.js
var require_stream_readable2 = __commonJS({
  "../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/_stream_readable.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = Readable;
    var Duplex;
    Readable.ReadableState = ReadableState;
    var EE = __require("events").EventEmitter, EElistenerCount = function(emitter, type) {
      return emitter.listeners(type).length;
    }, Stream = require_stream2(), Buffer2 = __require("buffer").Buffer, OurUint8Array = (typeof global < "u" ? global : typeof window < "u" ? window : typeof self < "u" ? self : {}).Uint8Array || function() {
    };
    function _uint8ArrayToBuffer(chunk) {
      return Buffer2.from(chunk);
    }
    function _isUint8Array(obj) {
      return Buffer2.isBuffer(obj) || obj instanceof OurUint8Array;
    }
    var debugUtil = __require("util"), debug4;
    debugUtil && debugUtil.debuglog ? debug4 = debugUtil.debuglog("stream") : debug4 = function() {
    };
    var BufferList = require_buffer_list(), destroyImpl = require_destroy2(), _require = require_state(), getHighWaterMark = _require.getHighWaterMark, _require$codes = require_errors4().codes, ERR_INVALID_ARG_TYPE = _require$codes.ERR_INVALID_ARG_TYPE, ERR_STREAM_PUSH_AFTER_EOF = _require$codes.ERR_STREAM_PUSH_AFTER_EOF, ERR_METHOD_NOT_IMPLEMENTED = _require$codes.ERR_METHOD_NOT_IMPLEMENTED, ERR_STREAM_UNSHIFT_AFTER_END_EVENT = _require$codes.ERR_STREAM_UNSHIFT_AFTER_END_EVENT, StringDecoder, createReadableStreamAsyncIterator, from;
    require_inherits()(Readable, Stream);
    var errorOrDestroy = destroyImpl.errorOrDestroy, kProxyEvents = ["error", "close", "destroy", "pause", "resume"];
    function prependListener(emitter, event, fn) {
      if (typeof emitter.prependListener == "function")
        return emitter.prependListener(event, fn);
      !emitter._events || !emitter._events[event] ? emitter.on(event, fn) : Array.isArray(emitter._events[event]) ? emitter._events[event].unshift(fn) : emitter._events[event] = [fn, emitter._events[event]];
    }
    function ReadableState(options, stream2, isDuplex) {
      Duplex = Duplex || require_stream_duplex2(), options = options || {}, typeof isDuplex != "boolean" && (isDuplex = stream2 instanceof Duplex), this.objectMode = !!options.objectMode, isDuplex && (this.objectMode = this.objectMode || !!options.readableObjectMode), this.highWaterMark = getHighWaterMark(this, options, "readableHighWaterMark", isDuplex), this.buffer = new BufferList(), this.length = 0, this.pipes = null, this.pipesCount = 0, this.flowing = null, this.ended = !1, this.endEmitted = !1, this.reading = !1, this.sync = !0, this.needReadable = !1, this.emittedReadable = !1, this.readableListening = !1, this.resumeScheduled = !1, this.paused = !0, this.emitClose = options.emitClose !== !1, this.autoDestroy = !!options.autoDestroy, this.destroyed = !1, this.defaultEncoding = options.defaultEncoding || "utf8", this.awaitDrain = 0, this.readingMore = !1, this.decoder = null, this.encoding = null, options.encoding && (StringDecoder || (StringDecoder = require_string_decoder2().StringDecoder), this.decoder = new StringDecoder(options.encoding), this.encoding = options.encoding);
    }
    function Readable(options) {
      if (Duplex = Duplex || require_stream_duplex2(), !(this instanceof Readable))
        return new Readable(options);
      var isDuplex = this instanceof Duplex;
      this._readableState = new ReadableState(options, this, isDuplex), this.readable = !0, options && (typeof options.read == "function" && (this._read = options.read), typeof options.destroy == "function" && (this._destroy = options.destroy)), Stream.call(this);
    }
    Object.defineProperty(Readable.prototype, "destroyed", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: !1,
      get: function() {
        return this._readableState === void 0 ? !1 : this._readableState.destroyed;
      },
      set: function(value) {
        this._readableState && (this._readableState.destroyed = value);
      }
    });
    Readable.prototype.destroy = destroyImpl.destroy;
    Readable.prototype._undestroy = destroyImpl.undestroy;
    Readable.prototype._destroy = function(err2, cb) {
      cb(err2);
    };
    Readable.prototype.push = function(chunk, encoding) {
      var state = this._readableState, skipChunkCheck;
      return state.objectMode ? skipChunkCheck = !0 : typeof chunk == "string" && (encoding = encoding || state.defaultEncoding, encoding !== state.encoding && (chunk = Buffer2.from(chunk, encoding), encoding = ""), skipChunkCheck = !0), readableAddChunk(this, chunk, encoding, !1, skipChunkCheck);
    };
    Readable.prototype.unshift = function(chunk) {
      return readableAddChunk(this, chunk, null, !0, !1);
    };
    function readableAddChunk(stream2, chunk, encoding, addToFront, skipChunkCheck) {
      debug4("readableAddChunk", chunk);
      var state = stream2._readableState;
      if (chunk === null)
        state.reading = !1, onEofChunk(stream2, state);
      else {
        var er;
        if (skipChunkCheck || (er = chunkInvalid(state, chunk)), er)
          errorOrDestroy(stream2, er);
        else if (state.objectMode || chunk && chunk.length > 0)
          if (typeof chunk != "string" && !state.objectMode && Object.getPrototypeOf(chunk) !== Buffer2.prototype && (chunk = _uint8ArrayToBuffer(chunk)), addToFront)
            state.endEmitted ? errorOrDestroy(stream2, new ERR_STREAM_UNSHIFT_AFTER_END_EVENT()) : addChunk(stream2, state, chunk, !0);
          else if (state.ended)
            errorOrDestroy(stream2, new ERR_STREAM_PUSH_AFTER_EOF());
          else {
            if (state.destroyed)
              return !1;
            state.reading = !1, state.decoder && !encoding ? (chunk = state.decoder.write(chunk), state.objectMode || chunk.length !== 0 ? addChunk(stream2, state, chunk, !1) : maybeReadMore(stream2, state)) : addChunk(stream2, state, chunk, !1);
          }
        else
          addToFront || (state.reading = !1, maybeReadMore(stream2, state));
      }
      return !state.ended && (state.length < state.highWaterMark || state.length === 0);
    }
    function addChunk(stream2, state, chunk, addToFront) {
      state.flowing && state.length === 0 && !state.sync ? (state.awaitDrain = 0, stream2.emit("data", chunk)) : (state.length += state.objectMode ? 1 : chunk.length, addToFront ? state.buffer.unshift(chunk) : state.buffer.push(chunk), state.needReadable && emitReadable(stream2)), maybeReadMore(stream2, state);
    }
    function chunkInvalid(state, chunk) {
      var er;
      return !_isUint8Array(chunk) && typeof chunk != "string" && chunk !== void 0 && !state.objectMode && (er = new ERR_INVALID_ARG_TYPE("chunk", ["string", "Buffer", "Uint8Array"], chunk)), er;
    }
    Readable.prototype.isPaused = function() {
      return this._readableState.flowing === !1;
    };
    Readable.prototype.setEncoding = function(enc) {
      StringDecoder || (StringDecoder = require_string_decoder2().StringDecoder);
      var decoder = new StringDecoder(enc);
      this._readableState.decoder = decoder, this._readableState.encoding = this._readableState.decoder.encoding;
      for (var p = this._readableState.buffer.head, content = ""; p !== null; )
        content += decoder.write(p.data), p = p.next;
      return this._readableState.buffer.clear(), content !== "" && this._readableState.buffer.push(content), this._readableState.length = content.length, this;
    };
    var MAX_HWM = 1073741824;
    function computeNewHighWaterMark(n) {
      return n >= MAX_HWM ? n = MAX_HWM : (n--, n |= n >>> 1, n |= n >>> 2, n |= n >>> 4, n |= n >>> 8, n |= n >>> 16, n++), n;
    }
    function howMuchToRead(n, state) {
      return n <= 0 || state.length === 0 && state.ended ? 0 : state.objectMode ? 1 : n !== n ? state.flowing && state.length ? state.buffer.head.data.length : state.length : (n > state.highWaterMark && (state.highWaterMark = computeNewHighWaterMark(n)), n <= state.length ? n : state.ended ? state.length : (state.needReadable = !0, 0));
    }
    Readable.prototype.read = function(n) {
      debug4("read", n), n = parseInt(n, 10);
      var state = this._readableState, nOrig = n;
      if (n !== 0 && (state.emittedReadable = !1), n === 0 && state.needReadable && ((state.highWaterMark !== 0 ? state.length >= state.highWaterMark : state.length > 0) || state.ended))
        return debug4("read: emitReadable", state.length, state.ended), state.length === 0 && state.ended ? endReadable(this) : emitReadable(this), null;
      if (n = howMuchToRead(n, state), n === 0 && state.ended)
        return state.length === 0 && endReadable(this), null;
      var doRead = state.needReadable;
      debug4("need readable", doRead), (state.length === 0 || state.length - n < state.highWaterMark) && (doRead = !0, debug4("length less than watermark", doRead)), state.ended || state.reading ? (doRead = !1, debug4("reading or ended", doRead)) : doRead && (debug4("do read"), state.reading = !0, state.sync = !0, state.length === 0 && (state.needReadable = !0), this._read(state.highWaterMark), state.sync = !1, state.reading || (n = howMuchToRead(nOrig, state)));
      var ret;
      return n > 0 ? ret = fromList(n, state) : ret = null, ret === null ? (state.needReadable = state.length <= state.highWaterMark, n = 0) : (state.length -= n, state.awaitDrain = 0), state.length === 0 && (state.ended || (state.needReadable = !0), nOrig !== n && state.ended && endReadable(this)), ret !== null && this.emit("data", ret), ret;
    };
    function onEofChunk(stream2, state) {
      if (debug4("onEofChunk"), !state.ended) {
        if (state.decoder) {
          var chunk = state.decoder.end();
          chunk && chunk.length && (state.buffer.push(chunk), state.length += state.objectMode ? 1 : chunk.length);
        }
        state.ended = !0, state.sync ? emitReadable(stream2) : (state.needReadable = !1, state.emittedReadable || (state.emittedReadable = !0, emitReadable_(stream2)));
      }
    }
    function emitReadable(stream2) {
      var state = stream2._readableState;
      debug4("emitReadable", state.needReadable, state.emittedReadable), state.needReadable = !1, state.emittedReadable || (debug4("emitReadable", state.flowing), state.emittedReadable = !0, process.nextTick(emitReadable_, stream2));
    }
    function emitReadable_(stream2) {
      var state = stream2._readableState;
      debug4("emitReadable_", state.destroyed, state.length, state.ended), !state.destroyed && (state.length || state.ended) && (stream2.emit("readable"), state.emittedReadable = !1), state.needReadable = !state.flowing && !state.ended && state.length <= state.highWaterMark, flow(stream2);
    }
    function maybeReadMore(stream2, state) {
      state.readingMore || (state.readingMore = !0, process.nextTick(maybeReadMore_, stream2, state));
    }
    function maybeReadMore_(stream2, state) {
      for (; !state.reading && !state.ended && (state.length < state.highWaterMark || state.flowing && state.length === 0); ) {
        var len = state.length;
        if (debug4("maybeReadMore read 0"), stream2.read(0), len === state.length)
          break;
      }
      state.readingMore = !1;
    }
    Readable.prototype._read = function(n) {
      errorOrDestroy(this, new ERR_METHOD_NOT_IMPLEMENTED("_read()"));
    };
    Readable.prototype.pipe = function(dest, pipeOpts) {
      var src = this, state = this._readableState;
      switch (state.pipesCount) {
        case 0:
          state.pipes = dest;
          break;
        case 1:
          state.pipes = [state.pipes, dest];
          break;
        default:
          state.pipes.push(dest);
          break;
      }
      state.pipesCount += 1, debug4("pipe count=%d opts=%j", state.pipesCount, pipeOpts);
      var doEnd = (!pipeOpts || pipeOpts.end !== !1) && dest !== process.stdout && dest !== process.stderr, endFn = doEnd ? onend : unpipe;
      state.endEmitted ? process.nextTick(endFn) : src.once("end", endFn), dest.on("unpipe", onunpipe);
      function onunpipe(readable, unpipeInfo) {
        debug4("onunpipe"), readable === src && unpipeInfo && unpipeInfo.hasUnpiped === !1 && (unpipeInfo.hasUnpiped = !0, cleanup2());
      }
      function onend() {
        debug4("onend"), dest.end();
      }
      var ondrain = pipeOnDrain(src);
      dest.on("drain", ondrain);
      var cleanedUp = !1;
      function cleanup2() {
        debug4("cleanup"), dest.removeListener("close", onclose), dest.removeListener("finish", onfinish), dest.removeListener("drain", ondrain), dest.removeListener("error", onerror), dest.removeListener("unpipe", onunpipe), src.removeListener("end", onend), src.removeListener("end", unpipe), src.removeListener("data", ondata), cleanedUp = !0, state.awaitDrain && (!dest._writableState || dest._writableState.needDrain) && ondrain();
      }
      src.on("data", ondata);
      function ondata(chunk) {
        debug4("ondata");
        var ret = dest.write(chunk);
        debug4("dest.write", ret), ret === !1 && ((state.pipesCount === 1 && state.pipes === dest || state.pipesCount > 1 && indexOf(state.pipes, dest) !== -1) && !cleanedUp && (debug4("false write response, pause", state.awaitDrain), state.awaitDrain++), src.pause());
      }
      function onerror(er) {
        debug4("onerror", er), unpipe(), dest.removeListener("error", onerror), EElistenerCount(dest, "error") === 0 && errorOrDestroy(dest, er);
      }
      prependListener(dest, "error", onerror);
      function onclose() {
        dest.removeListener("finish", onfinish), unpipe();
      }
      dest.once("close", onclose);
      function onfinish() {
        debug4("onfinish"), dest.removeListener("close", onclose), unpipe();
      }
      dest.once("finish", onfinish);
      function unpipe() {
        debug4("unpipe"), src.unpipe(dest);
      }
      return dest.emit("pipe", src), state.flowing || (debug4("pipe resume"), src.resume()), dest;
    };
    function pipeOnDrain(src) {
      return function() {
        var state = src._readableState;
        debug4("pipeOnDrain", state.awaitDrain), state.awaitDrain && state.awaitDrain--, state.awaitDrain === 0 && EElistenerCount(src, "data") && (state.flowing = !0, flow(src));
      };
    }
    Readable.prototype.unpipe = function(dest) {
      var state = this._readableState, unpipeInfo = {
        hasUnpiped: !1
      };
      if (state.pipesCount === 0)
        return this;
      if (state.pipesCount === 1)
        return dest && dest !== state.pipes ? this : (dest || (dest = state.pipes), state.pipes = null, state.pipesCount = 0, state.flowing = !1, dest && dest.emit("unpipe", this, unpipeInfo), this);
      if (!dest) {
        var dests = state.pipes, len = state.pipesCount;
        state.pipes = null, state.pipesCount = 0, state.flowing = !1;
        for (var i = 0; i < len; i++)
          dests[i].emit("unpipe", this, {
            hasUnpiped: !1
          });
        return this;
      }
      var index = indexOf(state.pipes, dest);
      return index === -1 ? this : (state.pipes.splice(index, 1), state.pipesCount -= 1, state.pipesCount === 1 && (state.pipes = state.pipes[0]), dest.emit("unpipe", this, unpipeInfo), this);
    };
    Readable.prototype.on = function(ev, fn) {
      var res = Stream.prototype.on.call(this, ev, fn), state = this._readableState;
      return ev === "data" ? (state.readableListening = this.listenerCount("readable") > 0, state.flowing !== !1 && this.resume()) : ev === "readable" && !state.endEmitted && !state.readableListening && (state.readableListening = state.needReadable = !0, state.flowing = !1, state.emittedReadable = !1, debug4("on readable", state.length, state.reading), state.length ? emitReadable(this) : state.reading || process.nextTick(nReadingNextTick, this)), res;
    };
    Readable.prototype.addListener = Readable.prototype.on;
    Readable.prototype.removeListener = function(ev, fn) {
      var res = Stream.prototype.removeListener.call(this, ev, fn);
      return ev === "readable" && process.nextTick(updateReadableListening, this), res;
    };
    Readable.prototype.removeAllListeners = function(ev) {
      var res = Stream.prototype.removeAllListeners.apply(this, arguments);
      return (ev === "readable" || ev === void 0) && process.nextTick(updateReadableListening, this), res;
    };
    function updateReadableListening(self2) {
      var state = self2._readableState;
      state.readableListening = self2.listenerCount("readable") > 0, state.resumeScheduled && !state.paused ? state.flowing = !0 : self2.listenerCount("data") > 0 && self2.resume();
    }
    function nReadingNextTick(self2) {
      debug4("readable nexttick read 0"), self2.read(0);
    }
    Readable.prototype.resume = function() {
      var state = this._readableState;
      return state.flowing || (debug4("resume"), state.flowing = !state.readableListening, resume(this, state)), state.paused = !1, this;
    };
    function resume(stream2, state) {
      state.resumeScheduled || (state.resumeScheduled = !0, process.nextTick(resume_, stream2, state));
    }
    function resume_(stream2, state) {
      debug4("resume", state.reading), state.reading || stream2.read(0), state.resumeScheduled = !1, stream2.emit("resume"), flow(stream2), state.flowing && !state.reading && stream2.read(0);
    }
    Readable.prototype.pause = function() {
      return debug4("call pause flowing=%j", this._readableState.flowing), this._readableState.flowing !== !1 && (debug4("pause"), this._readableState.flowing = !1, this.emit("pause")), this._readableState.paused = !0, this;
    };
    function flow(stream2) {
      var state = stream2._readableState;
      for (debug4("flow", state.flowing); state.flowing && stream2.read() !== null; )
        ;
    }
    Readable.prototype.wrap = function(stream2) {
      var _this = this, state = this._readableState, paused = !1;
      stream2.on("end", function() {
        if (debug4("wrapped end"), state.decoder && !state.ended) {
          var chunk = state.decoder.end();
          chunk && chunk.length && _this.push(chunk);
        }
        _this.push(null);
      }), stream2.on("data", function(chunk) {
        if (debug4("wrapped data"), state.decoder && (chunk = state.decoder.write(chunk)), !(state.objectMode && chunk == null) && !(!state.objectMode && (!chunk || !chunk.length))) {
          var ret = _this.push(chunk);
          ret || (paused = !0, stream2.pause());
        }
      });
      for (var i in stream2)
        this[i] === void 0 && typeof stream2[i] == "function" && (this[i] = /* @__PURE__ */ function(method) {
          return function() {
            return stream2[method].apply(stream2, arguments);
          };
        }(i));
      for (var n = 0; n < kProxyEvents.length; n++)
        stream2.on(kProxyEvents[n], this.emit.bind(this, kProxyEvents[n]));
      return this._read = function(n2) {
        debug4("wrapped _read", n2), paused && (paused = !1, stream2.resume());
      }, this;
    };
    typeof Symbol == "function" && (Readable.prototype[Symbol.asyncIterator] = function() {
      return createReadableStreamAsyncIterator === void 0 && (createReadableStreamAsyncIterator = require_async_iterator()), createReadableStreamAsyncIterator(this);
    });
    Object.defineProperty(Readable.prototype, "readableHighWaterMark", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: !1,
      get: function() {
        return this._readableState.highWaterMark;
      }
    });
    Object.defineProperty(Readable.prototype, "readableBuffer", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: !1,
      get: function() {
        return this._readableState && this._readableState.buffer;
      }
    });
    Object.defineProperty(Readable.prototype, "readableFlowing", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: !1,
      get: function() {
        return this._readableState.flowing;
      },
      set: function(state) {
        this._readableState && (this._readableState.flowing = state);
      }
    });
    Readable._fromList = fromList;
    Object.defineProperty(Readable.prototype, "readableLength", {
      // making it explicit this property is not enumerable
      // because otherwise some prototype manipulation in
      // userland will fail
      enumerable: !1,
      get: function() {
        return this._readableState.length;
      }
    });
    function fromList(n, state) {
      if (state.length === 0)
        return null;
      var ret;
      return state.objectMode ? ret = state.buffer.shift() : !n || n >= state.length ? (state.decoder ? ret = state.buffer.join("") : state.buffer.length === 1 ? ret = state.buffer.first() : ret = state.buffer.concat(state.length), state.buffer.clear()) : ret = state.buffer.consume(n, state.decoder), ret;
    }
    function endReadable(stream2) {
      var state = stream2._readableState;
      debug4("endReadable", state.endEmitted), state.endEmitted || (state.ended = !0, process.nextTick(endReadableNT, state, stream2));
    }
    function endReadableNT(state, stream2) {
      if (debug4("endReadableNT", state.endEmitted, state.length), !state.endEmitted && state.length === 0 && (state.endEmitted = !0, stream2.readable = !1, stream2.emit("end"), state.autoDestroy)) {
        var wState = stream2._writableState;
        (!wState || wState.autoDestroy && wState.finished) && stream2.destroy();
      }
    }
    typeof Symbol == "function" && (Readable.from = function(iterable, opts) {
      return from === void 0 && (from = require_from()), from(Readable, iterable, opts);
    });
    function indexOf(xs, x) {
      for (var i = 0, l = xs.length; i < l; i++)
        if (xs[i] === x)
          return i;
      return -1;
    }
  }
});

// ../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/_stream_transform.js
var require_stream_transform2 = __commonJS({
  "../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/_stream_transform.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = Transform;
    var _require$codes = require_errors4().codes, ERR_METHOD_NOT_IMPLEMENTED = _require$codes.ERR_METHOD_NOT_IMPLEMENTED, ERR_MULTIPLE_CALLBACK = _require$codes.ERR_MULTIPLE_CALLBACK, ERR_TRANSFORM_ALREADY_TRANSFORMING = _require$codes.ERR_TRANSFORM_ALREADY_TRANSFORMING, ERR_TRANSFORM_WITH_LENGTH_0 = _require$codes.ERR_TRANSFORM_WITH_LENGTH_0, Duplex = require_stream_duplex2();
    require_inherits()(Transform, Duplex);
    function afterTransform(er, data) {
      var ts = this._transformState;
      ts.transforming = !1;
      var cb = ts.writecb;
      if (cb === null)
        return this.emit("error", new ERR_MULTIPLE_CALLBACK());
      ts.writechunk = null, ts.writecb = null, data != null && this.push(data), cb(er);
      var rs = this._readableState;
      rs.reading = !1, (rs.needReadable || rs.length < rs.highWaterMark) && this._read(rs.highWaterMark);
    }
    function Transform(options) {
      if (!(this instanceof Transform))
        return new Transform(options);
      Duplex.call(this, options), this._transformState = {
        afterTransform: afterTransform.bind(this),
        needTransform: !1,
        transforming: !1,
        writecb: null,
        writechunk: null,
        writeencoding: null
      }, this._readableState.needReadable = !0, this._readableState.sync = !1, options && (typeof options.transform == "function" && (this._transform = options.transform), typeof options.flush == "function" && (this._flush = options.flush)), this.on("prefinish", prefinish);
    }
    function prefinish() {
      var _this = this;
      typeof this._flush == "function" && !this._readableState.destroyed ? this._flush(function(er, data) {
        done(_this, er, data);
      }) : done(this, null, null);
    }
    Transform.prototype.push = function(chunk, encoding) {
      return this._transformState.needTransform = !1, Duplex.prototype.push.call(this, chunk, encoding);
    };
    Transform.prototype._transform = function(chunk, encoding, cb) {
      cb(new ERR_METHOD_NOT_IMPLEMENTED("_transform()"));
    };
    Transform.prototype._write = function(chunk, encoding, cb) {
      var ts = this._transformState;
      if (ts.writecb = cb, ts.writechunk = chunk, ts.writeencoding = encoding, !ts.transforming) {
        var rs = this._readableState;
        (ts.needTransform || rs.needReadable || rs.length < rs.highWaterMark) && this._read(rs.highWaterMark);
      }
    };
    Transform.prototype._read = function(n) {
      var ts = this._transformState;
      ts.writechunk !== null && !ts.transforming ? (ts.transforming = !0, this._transform(ts.writechunk, ts.writeencoding, ts.afterTransform)) : ts.needTransform = !0;
    };
    Transform.prototype._destroy = function(err2, cb) {
      Duplex.prototype._destroy.call(this, err2, function(err22) {
        cb(err22);
      });
    };
    function done(stream2, er, data) {
      if (er)
        return stream2.emit("error", er);
      if (data != null && stream2.push(data), stream2._writableState.length)
        throw new ERR_TRANSFORM_WITH_LENGTH_0();
      if (stream2._transformState.transforming)
        throw new ERR_TRANSFORM_ALREADY_TRANSFORMING();
      return stream2.push(null);
    }
  }
});

// ../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/_stream_passthrough.js
var require_stream_passthrough2 = __commonJS({
  "../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/_stream_passthrough.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = PassThrough2;
    var Transform = require_stream_transform2();
    require_inherits()(PassThrough2, Transform);
    function PassThrough2(options) {
      if (!(this instanceof PassThrough2))
        return new PassThrough2(options);
      Transform.call(this, options);
    }
    PassThrough2.prototype._transform = function(chunk, encoding, cb) {
      cb(null, chunk);
    };
  }
});

// ../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/internal/streams/pipeline.js
var require_pipeline = __commonJS({
  "../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/lib/internal/streams/pipeline.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var eos;
    function once(callback) {
      var called = !1;
      return function() {
        called || (called = !0, callback.apply(void 0, arguments));
      };
    }
    var _require$codes = require_errors4().codes, ERR_MISSING_ARGS = _require$codes.ERR_MISSING_ARGS, ERR_STREAM_DESTROYED = _require$codes.ERR_STREAM_DESTROYED;
    function noop(err2) {
      if (err2)
        throw err2;
    }
    function isRequest(stream2) {
      return stream2.setHeader && typeof stream2.abort == "function";
    }
    function destroyer(stream2, reading, writing, callback) {
      callback = once(callback);
      var closed = !1;
      stream2.on("close", function() {
        closed = !0;
      }), eos === void 0 && (eos = require_end_of_stream2()), eos(stream2, {
        readable: reading,
        writable: writing
      }, function(err2) {
        if (err2)
          return callback(err2);
        closed = !0, callback();
      });
      var destroyed = !1;
      return function(err2) {
        if (!closed && !destroyed) {
          if (destroyed = !0, isRequest(stream2))
            return stream2.abort();
          if (typeof stream2.destroy == "function")
            return stream2.destroy();
          callback(err2 || new ERR_STREAM_DESTROYED("pipe"));
        }
      };
    }
    function call(fn) {
      fn();
    }
    function pipe(from, to) {
      return from.pipe(to);
    }
    function popCallback(streams) {
      return !streams.length || typeof streams[streams.length - 1] != "function" ? noop : streams.pop();
    }
    function pipeline3() {
      for (var _len = arguments.length, streams = new Array(_len), _key = 0; _key < _len; _key++)
        streams[_key] = arguments[_key];
      var callback = popCallback(streams);
      if (Array.isArray(streams[0]) && (streams = streams[0]), streams.length < 2)
        throw new ERR_MISSING_ARGS("streams");
      var error, destroys = streams.map(function(stream2, i) {
        var reading = i < streams.length - 1, writing = i > 0;
        return destroyer(stream2, reading, writing, function(err2) {
          error || (error = err2), err2 && destroys.forEach(call), !reading && (destroys.forEach(call), callback(error));
        });
      });
      return streams.reduce(pipe);
    }
    module.exports = pipeline3;
  }
});

// ../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/readable.js
var require_readable2 = __commonJS({
  "../../node_modules/.pnpm/readable-stream@3.6.2/node_modules/readable-stream/readable.js"(exports, module) {
    init_cjs_shims();
    var Stream = __require("stream");
    process.env.READABLE_STREAM === "disable" && Stream ? (module.exports = Stream.Readable, Object.assign(module.exports, Stream), module.exports.Stream = Stream) : (exports = module.exports = require_stream_readable2(), exports.Stream = Stream || exports, exports.Readable = exports, exports.Writable = require_stream_writable2(), exports.Duplex = require_stream_duplex2(), exports.Transform = require_stream_transform2(), exports.PassThrough = require_stream_passthrough2(), exports.finished = require_end_of_stream2(), exports.pipeline = require_pipeline());
  }
});

// ../../node_modules/.pnpm/archiver@5.3.2/node_modules/archiver/lib/core.js
var require_core = __commonJS({
  "../../node_modules/.pnpm/archiver@5.3.2/node_modules/archiver/lib/core.js"(exports, module) {
    init_cjs_shims();
    var fs6 = __require("fs"), glob2 = require_readdir_glob(), async = require_async(), path3 = __require("path"), util2 = require_archiver_utils(), inherits = __require("util").inherits, ArchiverError = require_error2(), Transform = require_readable2().Transform, win32 = process.platform === "win32", Archiver = function(format4, options) {
      if (!(this instanceof Archiver))
        return new Archiver(format4, options);
      typeof format4 != "string" && (options = format4, format4 = "zip"), options = this.options = util2.defaults(options, {
        highWaterMark: 1024 * 1024,
        statConcurrency: 4
      }), Transform.call(this, options), this._format = !1, this._module = !1, this._pending = 0, this._pointer = 0, this._entriesCount = 0, this._entriesProcessedCount = 0, this._fsEntriesTotalBytes = 0, this._fsEntriesProcessedBytes = 0, this._queue = async.queue(this._onQueueTask.bind(this), 1), this._queue.drain(this._onQueueDrain.bind(this)), this._statQueue = async.queue(this._onStatQueueTask.bind(this), options.statConcurrency), this._statQueue.drain(this._onQueueDrain.bind(this)), this._state = {
        aborted: !1,
        finalize: !1,
        finalizing: !1,
        finalized: !1,
        modulePiped: !1
      }, this._streams = [];
    };
    inherits(Archiver, Transform);
    Archiver.prototype._abort = function() {
      this._state.aborted = !0, this._queue.kill(), this._statQueue.kill(), this._queue.idle() && this._shutdown();
    };
    Archiver.prototype._append = function(filepath, data) {
      data = data || {};
      var task = {
        source: null,
        filepath
      };
      data.name || (data.name = filepath), data.sourcePath = filepath, task.data = data, this._entriesCount++, data.stats && data.stats instanceof fs6.Stats ? (task = this._updateQueueTaskWithStats(task, data.stats), task && (data.stats.size && (this._fsEntriesTotalBytes += data.stats.size), this._queue.push(task))) : this._statQueue.push(task);
    };
    Archiver.prototype._finalize = function() {
      this._state.finalizing || this._state.finalized || this._state.aborted || (this._state.finalizing = !0, this._moduleFinalize(), this._state.finalizing = !1, this._state.finalized = !0);
    };
    Archiver.prototype._maybeFinalize = function() {
      return this._state.finalizing || this._state.finalized || this._state.aborted ? !1 : this._state.finalize && this._pending === 0 && this._queue.idle() && this._statQueue.idle() ? (this._finalize(), !0) : !1;
    };
    Archiver.prototype._moduleAppend = function(source, data, callback) {
      if (this._state.aborted) {
        callback();
        return;
      }
      this._module.append(source, data, function(err2) {
        if (this._task = null, this._state.aborted) {
          this._shutdown();
          return;
        }
        if (err2) {
          this.emit("error", err2), setImmediate(callback);
          return;
        }
        this.emit("entry", data), this._entriesProcessedCount++, data.stats && data.stats.size && (this._fsEntriesProcessedBytes += data.stats.size), this.emit("progress", {
          entries: {
            total: this._entriesCount,
            processed: this._entriesProcessedCount
          },
          fs: {
            totalBytes: this._fsEntriesTotalBytes,
            processedBytes: this._fsEntriesProcessedBytes
          }
        }), setImmediate(callback);
      }.bind(this));
    };
    Archiver.prototype._moduleFinalize = function() {
      typeof this._module.finalize == "function" ? this._module.finalize() : typeof this._module.end == "function" ? this._module.end() : this.emit("error", new ArchiverError("NOENDMETHOD"));
    };
    Archiver.prototype._modulePipe = function() {
      this._module.on("error", this._onModuleError.bind(this)), this._module.pipe(this), this._state.modulePiped = !0;
    };
    Archiver.prototype._moduleSupports = function(key) {
      return !this._module.supports || !this._module.supports[key] ? !1 : this._module.supports[key];
    };
    Archiver.prototype._moduleUnpipe = function() {
      this._module.unpipe(this), this._state.modulePiped = !1;
    };
    Archiver.prototype._normalizeEntryData = function(data, stats) {
      data = util2.defaults(data, {
        type: "file",
        name: null,
        date: null,
        mode: null,
        prefix: null,
        sourcePath: null,
        stats: !1
      }), stats && data.stats === !1 && (data.stats = stats);
      var isDir = data.type === "directory";
      return data.name && (typeof data.prefix == "string" && data.prefix !== "" && (data.name = data.prefix + "/" + data.name, data.prefix = null), data.name = util2.sanitizePath(data.name), data.type !== "symlink" && data.name.slice(-1) === "/" ? (isDir = !0, data.type = "directory") : isDir && (data.name += "/")), typeof data.mode == "number" ? win32 ? data.mode &= 511 : data.mode &= 4095 : data.stats && data.mode === null ? (win32 ? data.mode = data.stats.mode & 511 : data.mode = data.stats.mode & 4095, win32 && isDir && (data.mode = 493)) : data.mode === null && (data.mode = isDir ? 493 : 420), data.stats && data.date === null ? data.date = data.stats.mtime : data.date = util2.dateify(data.date), data;
    };
    Archiver.prototype._onModuleError = function(err2) {
      this.emit("error", err2);
    };
    Archiver.prototype._onQueueDrain = function() {
      this._state.finalizing || this._state.finalized || this._state.aborted || this._state.finalize && this._pending === 0 && this._queue.idle() && this._statQueue.idle() && this._finalize();
    };
    Archiver.prototype._onQueueTask = function(task, callback) {
      var fullCallback = () => {
        task.data.callback && task.data.callback(), callback();
      };
      if (this._state.finalizing || this._state.finalized || this._state.aborted) {
        fullCallback();
        return;
      }
      this._task = task, this._moduleAppend(task.source, task.data, fullCallback);
    };
    Archiver.prototype._onStatQueueTask = function(task, callback) {
      if (this._state.finalizing || this._state.finalized || this._state.aborted) {
        callback();
        return;
      }
      fs6.lstat(task.filepath, function(err2, stats) {
        if (this._state.aborted) {
          setImmediate(callback);
          return;
        }
        if (err2) {
          this._entriesCount--, this.emit("warning", err2), setImmediate(callback);
          return;
        }
        task = this._updateQueueTaskWithStats(task, stats), task && (stats.size && (this._fsEntriesTotalBytes += stats.size), this._queue.push(task)), setImmediate(callback);
      }.bind(this));
    };
    Archiver.prototype._shutdown = function() {
      this._moduleUnpipe(), this.end();
    };
    Archiver.prototype._transform = function(chunk, encoding, callback) {
      chunk && (this._pointer += chunk.length), callback(null, chunk);
    };
    Archiver.prototype._updateQueueTaskWithStats = function(task, stats) {
      if (stats.isFile())
        task.data.type = "file", task.data.sourceType = "stream", task.source = util2.lazyReadStream(task.filepath);
      else if (stats.isDirectory() && this._moduleSupports("directory"))
        task.data.name = util2.trailingSlashIt(task.data.name), task.data.type = "directory", task.data.sourcePath = util2.trailingSlashIt(task.filepath), task.data.sourceType = "buffer", task.source = Buffer.concat([]);
      else if (stats.isSymbolicLink() && this._moduleSupports("symlink")) {
        var linkPath = fs6.readlinkSync(task.filepath), dirName = path3.dirname(task.filepath);
        task.data.type = "symlink", task.data.linkname = path3.relative(dirName, path3.resolve(dirName, linkPath)), task.data.sourceType = "buffer", task.source = Buffer.concat([]);
      } else
        return stats.isDirectory() ? this.emit("warning", new ArchiverError("DIRECTORYNOTSUPPORTED", task.data)) : stats.isSymbolicLink() ? this.emit("warning", new ArchiverError("SYMLINKNOTSUPPORTED", task.data)) : this.emit("warning", new ArchiverError("ENTRYNOTSUPPORTED", task.data)), null;
      return task.data = this._normalizeEntryData(task.data, stats), task;
    };
    Archiver.prototype.abort = function() {
      return this._state.aborted || this._state.finalized ? this : (this._abort(), this);
    };
    Archiver.prototype.append = function(source, data) {
      if (this._state.finalize || this._state.aborted)
        return this.emit("error", new ArchiverError("QUEUECLOSED")), this;
      if (data = this._normalizeEntryData(data), typeof data.name != "string" || data.name.length === 0)
        return this.emit("error", new ArchiverError("ENTRYNAMEREQUIRED")), this;
      if (data.type === "directory" && !this._moduleSupports("directory"))
        return this.emit("error", new ArchiverError("DIRECTORYNOTSUPPORTED", { name: data.name })), this;
      if (source = util2.normalizeInputSource(source), Buffer.isBuffer(source))
        data.sourceType = "buffer";
      else if (util2.isStream(source))
        data.sourceType = "stream";
      else
        return this.emit("error", new ArchiverError("INPUTSTEAMBUFFERREQUIRED", { name: data.name })), this;
      return this._entriesCount++, this._queue.push({
        data,
        source
      }), this;
    };
    Archiver.prototype.directory = function(dirpath, destpath, data) {
      if (this._state.finalize || this._state.aborted)
        return this.emit("error", new ArchiverError("QUEUECLOSED")), this;
      if (typeof dirpath != "string" || dirpath.length === 0)
        return this.emit("error", new ArchiverError("DIRECTORYDIRPATHREQUIRED")), this;
      this._pending++, destpath === !1 ? destpath = "" : typeof destpath != "string" && (destpath = dirpath);
      var dataFunction = !1;
      typeof data == "function" ? (dataFunction = data, data = {}) : typeof data != "object" && (data = {});
      var globOptions = {
        stat: !0,
        dot: !0
      };
      function onGlobEnd() {
        this._pending--, this._maybeFinalize();
      }
      function onGlobError(err2) {
        this.emit("error", err2);
      }
      function onGlobMatch(match2) {
        globber.pause();
        var ignoreMatch = !1, entryData = Object.assign({}, data);
        entryData.name = match2.relative, entryData.prefix = destpath, entryData.stats = match2.stat, entryData.callback = globber.resume.bind(globber);
        try {
          if (dataFunction) {
            if (entryData = dataFunction(entryData), entryData === !1)
              ignoreMatch = !0;
            else if (typeof entryData != "object")
              throw new ArchiverError("DIRECTORYFUNCTIONINVALIDDATA", { dirpath });
          }
        } catch (e) {
          this.emit("error", e);
          return;
        }
        if (ignoreMatch) {
          globber.resume();
          return;
        }
        this._append(match2.absolute, entryData);
      }
      var globber = glob2(dirpath, globOptions);
      return globber.on("error", onGlobError.bind(this)), globber.on("match", onGlobMatch.bind(this)), globber.on("end", onGlobEnd.bind(this)), this;
    };
    Archiver.prototype.file = function(filepath, data) {
      return this._state.finalize || this._state.aborted ? (this.emit("error", new ArchiverError("QUEUECLOSED")), this) : typeof filepath != "string" || filepath.length === 0 ? (this.emit("error", new ArchiverError("FILEFILEPATHREQUIRED")), this) : (this._append(filepath, data), this);
    };
    Archiver.prototype.glob = function(pattern, options, data) {
      this._pending++, options = util2.defaults(options, {
        stat: !0,
        pattern
      });
      function onGlobEnd() {
        this._pending--, this._maybeFinalize();
      }
      function onGlobError(err2) {
        this.emit("error", err2);
      }
      function onGlobMatch(match2) {
        globber.pause();
        var entryData = Object.assign({}, data);
        entryData.callback = globber.resume.bind(globber), entryData.stats = match2.stat, entryData.name = match2.relative, this._append(match2.absolute, entryData);
      }
      var globber = glob2(options.cwd || ".", options);
      return globber.on("error", onGlobError.bind(this)), globber.on("match", onGlobMatch.bind(this)), globber.on("end", onGlobEnd.bind(this)), this;
    };
    Archiver.prototype.finalize = function() {
      if (this._state.aborted) {
        var abortedError = new ArchiverError("ABORTED");
        return this.emit("error", abortedError), Promise.reject(abortedError);
      }
      if (this._state.finalize) {
        var finalizingError = new ArchiverError("FINALIZING");
        return this.emit("error", finalizingError), Promise.reject(finalizingError);
      }
      this._state.finalize = !0, this._pending === 0 && this._queue.idle() && this._statQueue.idle() && this._finalize();
      var self2 = this;
      return new Promise(function(resolve2, reject) {
        var errored;
        self2._module.on("end", function() {
          errored || resolve2();
        }), self2._module.on("error", function(err2) {
          errored = !0, reject(err2);
        });
      });
    };
    Archiver.prototype.setFormat = function(format4) {
      return this._format ? (this.emit("error", new ArchiverError("FORMATSET")), this) : (this._format = format4, this);
    };
    Archiver.prototype.setModule = function(module2) {
      return this._state.aborted ? (this.emit("error", new ArchiverError("ABORTED")), this) : this._state.module ? (this.emit("error", new ArchiverError("MODULESET")), this) : (this._module = module2, this._modulePipe(), this);
    };
    Archiver.prototype.symlink = function(filepath, target, mode) {
      if (this._state.finalize || this._state.aborted)
        return this.emit("error", new ArchiverError("QUEUECLOSED")), this;
      if (typeof filepath != "string" || filepath.length === 0)
        return this.emit("error", new ArchiverError("SYMLINKFILEPATHREQUIRED")), this;
      if (typeof target != "string" || target.length === 0)
        return this.emit("error", new ArchiverError("SYMLINKTARGETREQUIRED", { filepath })), this;
      if (!this._moduleSupports("symlink"))
        return this.emit("error", new ArchiverError("SYMLINKNOTSUPPORTED", { filepath })), this;
      var data = {};
      return data.type = "symlink", data.name = filepath.replace(/\\/g, "/"), data.linkname = target.replace(/\\/g, "/"), data.sourceType = "buffer", typeof mode == "number" && (data.mode = mode), this._entriesCount++, this._queue.push({
        data,
        source: Buffer.concat([])
      }), this;
    };
    Archiver.prototype.pointer = function() {
      return this._pointer;
    };
    Archiver.prototype.use = function(plugin) {
      return this._streams.push(plugin), this;
    };
    module.exports = Archiver;
  }
});

// ../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/archivers/archive-entry.js
var require_archive_entry = __commonJS({
  "../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/archivers/archive-entry.js"(exports, module) {
    init_cjs_shims();
    var ArchiveEntry = module.exports = function() {
    };
    ArchiveEntry.prototype.getName = function() {
    };
    ArchiveEntry.prototype.getSize = function() {
    };
    ArchiveEntry.prototype.getLastModifiedDate = function() {
    };
    ArchiveEntry.prototype.isDirectory = function() {
    };
  }
});

// ../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/archivers/zip/util.js
var require_util3 = __commonJS({
  "../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/archivers/zip/util.js"(exports, module) {
    init_cjs_shims();
    var util2 = module.exports = {};
    util2.dateToDos = function(d, forceLocalTime) {
      forceLocalTime = forceLocalTime || !1;
      var year = forceLocalTime ? d.getFullYear() : d.getUTCFullYear();
      if (year < 1980)
        return 2162688;
      if (year >= 2044)
        return 2141175677;
      var val = {
        year,
        month: forceLocalTime ? d.getMonth() : d.getUTCMonth(),
        date: forceLocalTime ? d.getDate() : d.getUTCDate(),
        hours: forceLocalTime ? d.getHours() : d.getUTCHours(),
        minutes: forceLocalTime ? d.getMinutes() : d.getUTCMinutes(),
        seconds: forceLocalTime ? d.getSeconds() : d.getUTCSeconds()
      };
      return val.year - 1980 << 25 | val.month + 1 << 21 | val.date << 16 | val.hours << 11 | val.minutes << 5 | val.seconds / 2;
    };
    util2.dosToDate = function(dos) {
      return new Date((dos >> 25 & 127) + 1980, (dos >> 21 & 15) - 1, dos >> 16 & 31, dos >> 11 & 31, dos >> 5 & 63, (dos & 31) << 1);
    };
    util2.fromDosTime = function(buf) {
      return util2.dosToDate(buf.readUInt32LE(0));
    };
    util2.getEightBytes = function(v) {
      var buf = Buffer.alloc(8);
      return buf.writeUInt32LE(v % 4294967296, 0), buf.writeUInt32LE(v / 4294967296 | 0, 4), buf;
    };
    util2.getShortBytes = function(v) {
      var buf = Buffer.alloc(2);
      return buf.writeUInt16LE((v & 65535) >>> 0, 0), buf;
    };
    util2.getShortBytesValue = function(buf, offset) {
      return buf.readUInt16LE(offset);
    };
    util2.getLongBytes = function(v) {
      var buf = Buffer.alloc(4);
      return buf.writeUInt32LE((v & 4294967295) >>> 0, 0), buf;
    };
    util2.getLongBytesValue = function(buf, offset) {
      return buf.readUInt32LE(offset);
    };
    util2.toDosTime = function(d) {
      return util2.getLongBytes(util2.dateToDos(d));
    };
  }
});

// ../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/archivers/zip/general-purpose-bit.js
var require_general_purpose_bit = __commonJS({
  "../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/archivers/zip/general-purpose-bit.js"(exports, module) {
    init_cjs_shims();
    var zipUtil = require_util3(), DATA_DESCRIPTOR_FLAG = 8, ENCRYPTION_FLAG = 1, NUMBER_OF_SHANNON_FANO_TREES_FLAG = 4, SLIDING_DICTIONARY_SIZE_FLAG = 2, STRONG_ENCRYPTION_FLAG = 64, UFT8_NAMES_FLAG = 2048, GeneralPurposeBit = module.exports = function() {
      return this instanceof GeneralPurposeBit ? (this.descriptor = !1, this.encryption = !1, this.utf8 = !1, this.numberOfShannonFanoTrees = 0, this.strongEncryption = !1, this.slidingDictionarySize = 0, this) : new GeneralPurposeBit();
    };
    GeneralPurposeBit.prototype.encode = function() {
      return zipUtil.getShortBytes(
        (this.descriptor ? DATA_DESCRIPTOR_FLAG : 0) | (this.utf8 ? UFT8_NAMES_FLAG : 0) | (this.encryption ? ENCRYPTION_FLAG : 0) | (this.strongEncryption ? STRONG_ENCRYPTION_FLAG : 0)
      );
    };
    GeneralPurposeBit.prototype.parse = function(buf, offset) {
      var flag = zipUtil.getShortBytesValue(buf, offset), gbp = new GeneralPurposeBit();
      return gbp.useDataDescriptor((flag & DATA_DESCRIPTOR_FLAG) !== 0), gbp.useUTF8ForNames((flag & UFT8_NAMES_FLAG) !== 0), gbp.useStrongEncryption((flag & STRONG_ENCRYPTION_FLAG) !== 0), gbp.useEncryption((flag & ENCRYPTION_FLAG) !== 0), gbp.setSlidingDictionarySize(flag & SLIDING_DICTIONARY_SIZE_FLAG ? 8192 : 4096), gbp.setNumberOfShannonFanoTrees(flag & NUMBER_OF_SHANNON_FANO_TREES_FLAG ? 3 : 2), gbp;
    };
    GeneralPurposeBit.prototype.setNumberOfShannonFanoTrees = function(n) {
      this.numberOfShannonFanoTrees = n;
    };
    GeneralPurposeBit.prototype.getNumberOfShannonFanoTrees = function() {
      return this.numberOfShannonFanoTrees;
    };
    GeneralPurposeBit.prototype.setSlidingDictionarySize = function(n) {
      this.slidingDictionarySize = n;
    };
    GeneralPurposeBit.prototype.getSlidingDictionarySize = function() {
      return this.slidingDictionarySize;
    };
    GeneralPurposeBit.prototype.useDataDescriptor = function(b) {
      this.descriptor = b;
    };
    GeneralPurposeBit.prototype.usesDataDescriptor = function() {
      return this.descriptor;
    };
    GeneralPurposeBit.prototype.useEncryption = function(b) {
      this.encryption = b;
    };
    GeneralPurposeBit.prototype.usesEncryption = function() {
      return this.encryption;
    };
    GeneralPurposeBit.prototype.useStrongEncryption = function(b) {
      this.strongEncryption = b;
    };
    GeneralPurposeBit.prototype.usesStrongEncryption = function() {
      return this.strongEncryption;
    };
    GeneralPurposeBit.prototype.useUTF8ForNames = function(b) {
      this.utf8 = b;
    };
    GeneralPurposeBit.prototype.usesUTF8ForNames = function() {
      return this.utf8;
    };
  }
});

// ../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/archivers/zip/unix-stat.js
var require_unix_stat = __commonJS({
  "../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/archivers/zip/unix-stat.js"(exports, module) {
    init_cjs_shims();
    module.exports = {
      /**
       * Bits used for permissions (and sticky bit)
       */
      PERM_MASK: 4095,
      // 07777
      /**
       * Bits used to indicate the filesystem object type.
       */
      FILE_TYPE_FLAG: 61440,
      // 0170000
      /**
       * Indicates symbolic links.
       */
      LINK_FLAG: 40960,
      // 0120000
      /**
       * Indicates plain files.
       */
      FILE_FLAG: 32768,
      // 0100000
      /**
       * Indicates directories.
       */
      DIR_FLAG: 16384,
      // 040000
      // ----------------------------------------------------------
      // somewhat arbitrary choices that are quite common for shared
      // installations
      // -----------------------------------------------------------
      /**
       * Default permissions for symbolic links.
       */
      DEFAULT_LINK_PERM: 511,
      // 0777
      /**
       * Default permissions for directories.
       */
      DEFAULT_DIR_PERM: 493,
      // 0755
      /**
       * Default permissions for plain files.
       */
      DEFAULT_FILE_PERM: 420
      // 0644
    };
  }
});

// ../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/archivers/zip/constants.js
var require_constants = __commonJS({
  "../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/archivers/zip/constants.js"(exports, module) {
    init_cjs_shims();
    module.exports = {
      WORD: 4,
      DWORD: 8,
      EMPTY: Buffer.alloc(0),
      SHORT: 2,
      SHORT_MASK: 65535,
      SHORT_SHIFT: 16,
      SHORT_ZERO: Buffer.from(Array(2)),
      LONG: 4,
      LONG_ZERO: Buffer.from(Array(4)),
      MIN_VERSION_INITIAL: 10,
      MIN_VERSION_DATA_DESCRIPTOR: 20,
      MIN_VERSION_ZIP64: 45,
      VERSION_MADEBY: 45,
      METHOD_STORED: 0,
      METHOD_DEFLATED: 8,
      PLATFORM_UNIX: 3,
      PLATFORM_FAT: 0,
      SIG_LFH: 67324752,
      SIG_DD: 134695760,
      SIG_CFH: 33639248,
      SIG_EOCD: 101010256,
      SIG_ZIP64_EOCD: 101075792,
      SIG_ZIP64_EOCD_LOC: 117853008,
      ZIP64_MAGIC_SHORT: 65535,
      ZIP64_MAGIC: 4294967295,
      ZIP64_EXTRA_ID: 1,
      ZLIB_NO_COMPRESSION: 0,
      ZLIB_BEST_SPEED: 1,
      ZLIB_BEST_COMPRESSION: 9,
      ZLIB_DEFAULT_COMPRESSION: -1,
      MODE_MASK: 4095,
      DEFAULT_FILE_MODE: 33188,
      // 010644 = -rw-r--r-- = S_IFREG | S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH
      DEFAULT_DIR_MODE: 16877,
      // 040755 = drwxr-xr-x = S_IFDIR | S_IRWXU | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH
      EXT_FILE_ATTR_DIR: 1106051088,
      // 010173200020 = drwxr-xr-x = (((S_IFDIR | 0755) << 16) | S_DOS_D)
      EXT_FILE_ATTR_FILE: 2175008800,
      // 020151000040 = -rw-r--r-- = (((S_IFREG | 0644) << 16) | S_DOS_A) >>> 0
      // Unix file types
      S_IFMT: 61440,
      // 0170000 type of file mask
      S_IFIFO: 4096,
      // 010000 named pipe (fifo)
      S_IFCHR: 8192,
      // 020000 character special
      S_IFDIR: 16384,
      // 040000 directory
      S_IFBLK: 24576,
      // 060000 block special
      S_IFREG: 32768,
      // 0100000 regular
      S_IFLNK: 40960,
      // 0120000 symbolic link
      S_IFSOCK: 49152,
      // 0140000 socket
      // DOS file type flags
      S_DOS_A: 32,
      // 040 Archive
      S_DOS_D: 16,
      // 020 Directory
      S_DOS_V: 8,
      // 010 Volume
      S_DOS_S: 4,
      // 04 System
      S_DOS_H: 2,
      // 02 Hidden
      S_DOS_R: 1
      // 01 Read Only
    };
  }
});

// ../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/archivers/zip/zip-archive-entry.js
var require_zip_archive_entry = __commonJS({
  "../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/archivers/zip/zip-archive-entry.js"(exports, module) {
    init_cjs_shims();
    var inherits = __require("util").inherits, normalizePath2 = require_normalize_path(), ArchiveEntry = require_archive_entry(), GeneralPurposeBit = require_general_purpose_bit(), UnixStat = require_unix_stat(), constants = require_constants(), zipUtil = require_util3(), ZipArchiveEntry = module.exports = function(name) {
      if (!(this instanceof ZipArchiveEntry))
        return new ZipArchiveEntry(name);
      ArchiveEntry.call(this), this.platform = constants.PLATFORM_FAT, this.method = -1, this.name = null, this.size = 0, this.csize = 0, this.gpb = new GeneralPurposeBit(), this.crc = 0, this.time = -1, this.minver = constants.MIN_VERSION_INITIAL, this.mode = -1, this.extra = null, this.exattr = 0, this.inattr = 0, this.comment = null, name && this.setName(name);
    };
    inherits(ZipArchiveEntry, ArchiveEntry);
    ZipArchiveEntry.prototype.getCentralDirectoryExtra = function() {
      return this.getExtra();
    };
    ZipArchiveEntry.prototype.getComment = function() {
      return this.comment !== null ? this.comment : "";
    };
    ZipArchiveEntry.prototype.getCompressedSize = function() {
      return this.csize;
    };
    ZipArchiveEntry.prototype.getCrc = function() {
      return this.crc;
    };
    ZipArchiveEntry.prototype.getExternalAttributes = function() {
      return this.exattr;
    };
    ZipArchiveEntry.prototype.getExtra = function() {
      return this.extra !== null ? this.extra : constants.EMPTY;
    };
    ZipArchiveEntry.prototype.getGeneralPurposeBit = function() {
      return this.gpb;
    };
    ZipArchiveEntry.prototype.getInternalAttributes = function() {
      return this.inattr;
    };
    ZipArchiveEntry.prototype.getLastModifiedDate = function() {
      return this.getTime();
    };
    ZipArchiveEntry.prototype.getLocalFileDataExtra = function() {
      return this.getExtra();
    };
    ZipArchiveEntry.prototype.getMethod = function() {
      return this.method;
    };
    ZipArchiveEntry.prototype.getName = function() {
      return this.name;
    };
    ZipArchiveEntry.prototype.getPlatform = function() {
      return this.platform;
    };
    ZipArchiveEntry.prototype.getSize = function() {
      return this.size;
    };
    ZipArchiveEntry.prototype.getTime = function() {
      return this.time !== -1 ? zipUtil.dosToDate(this.time) : -1;
    };
    ZipArchiveEntry.prototype.getTimeDos = function() {
      return this.time !== -1 ? this.time : 0;
    };
    ZipArchiveEntry.prototype.getUnixMode = function() {
      return this.platform !== constants.PLATFORM_UNIX ? 0 : this.getExternalAttributes() >> constants.SHORT_SHIFT & constants.SHORT_MASK;
    };
    ZipArchiveEntry.prototype.getVersionNeededToExtract = function() {
      return this.minver;
    };
    ZipArchiveEntry.prototype.setComment = function(comment) {
      Buffer.byteLength(comment) !== comment.length && this.getGeneralPurposeBit().useUTF8ForNames(!0), this.comment = comment;
    };
    ZipArchiveEntry.prototype.setCompressedSize = function(size) {
      if (size < 0)
        throw new Error("invalid entry compressed size");
      this.csize = size;
    };
    ZipArchiveEntry.prototype.setCrc = function(crc) {
      if (crc < 0)
        throw new Error("invalid entry crc32");
      this.crc = crc;
    };
    ZipArchiveEntry.prototype.setExternalAttributes = function(attr) {
      this.exattr = attr >>> 0;
    };
    ZipArchiveEntry.prototype.setExtra = function(extra) {
      this.extra = extra;
    };
    ZipArchiveEntry.prototype.setGeneralPurposeBit = function(gpb) {
      if (!(gpb instanceof GeneralPurposeBit))
        throw new Error("invalid entry GeneralPurposeBit");
      this.gpb = gpb;
    };
    ZipArchiveEntry.prototype.setInternalAttributes = function(attr) {
      this.inattr = attr;
    };
    ZipArchiveEntry.prototype.setMethod = function(method) {
      if (method < 0)
        throw new Error("invalid entry compression method");
      this.method = method;
    };
    ZipArchiveEntry.prototype.setName = function(name, prependSlash = !1) {
      name = normalizePath2(name, !1).replace(/^\w+:/, "").replace(/^(\.\.\/|\/)+/, ""), prependSlash && (name = `/${name}`), Buffer.byteLength(name) !== name.length && this.getGeneralPurposeBit().useUTF8ForNames(!0), this.name = name;
    };
    ZipArchiveEntry.prototype.setPlatform = function(platform2) {
      this.platform = platform2;
    };
    ZipArchiveEntry.prototype.setSize = function(size) {
      if (size < 0)
        throw new Error("invalid entry size");
      this.size = size;
    };
    ZipArchiveEntry.prototype.setTime = function(time, forceLocalTime) {
      if (!(time instanceof Date))
        throw new Error("invalid entry time");
      this.time = zipUtil.dateToDos(time, forceLocalTime);
    };
    ZipArchiveEntry.prototype.setUnixMode = function(mode) {
      mode |= this.isDirectory() ? constants.S_IFDIR : constants.S_IFREG;
      var extattr = 0;
      extattr |= mode << constants.SHORT_SHIFT | (this.isDirectory() ? constants.S_DOS_D : constants.S_DOS_A), this.setExternalAttributes(extattr), this.mode = mode & constants.MODE_MASK, this.platform = constants.PLATFORM_UNIX;
    };
    ZipArchiveEntry.prototype.setVersionNeededToExtract = function(minver) {
      this.minver = minver;
    };
    ZipArchiveEntry.prototype.isDirectory = function() {
      return this.getName().slice(-1) === "/";
    };
    ZipArchiveEntry.prototype.isUnixSymlink = function() {
      return (this.getUnixMode() & UnixStat.FILE_TYPE_FLAG) === UnixStat.LINK_FLAG;
    };
    ZipArchiveEntry.prototype.isZip64 = function() {
      return this.csize > constants.ZIP64_MAGIC || this.size > constants.ZIP64_MAGIC;
    };
  }
});

// ../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/util/index.js
var require_util4 = __commonJS({
  "../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/util/index.js"(exports, module) {
    init_cjs_shims();
    var Stream = __require("stream").Stream, PassThrough2 = require_readable2().PassThrough, util2 = module.exports = {};
    util2.isStream = function(source) {
      return source instanceof Stream;
    };
    util2.normalizeInputSource = function(source) {
      if (source === null)
        return Buffer.alloc(0);
      if (typeof source == "string")
        return Buffer.from(source);
      if (util2.isStream(source) && !source._readableState) {
        var normalized = new PassThrough2();
        return source.pipe(normalized), normalized;
      }
      return source;
    };
  }
});

// ../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/archivers/archive-output-stream.js
var require_archive_output_stream = __commonJS({
  "../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/archivers/archive-output-stream.js"(exports, module) {
    init_cjs_shims();
    var inherits = __require("util").inherits, Transform = require_readable2().Transform, ArchiveEntry = require_archive_entry(), util2 = require_util4(), ArchiveOutputStream = module.exports = function(options) {
      if (!(this instanceof ArchiveOutputStream))
        return new ArchiveOutputStream(options);
      Transform.call(this, options), this.offset = 0, this._archive = {
        finish: !1,
        finished: !1,
        processing: !1
      };
    };
    inherits(ArchiveOutputStream, Transform);
    ArchiveOutputStream.prototype._appendBuffer = function(zae, source, callback) {
    };
    ArchiveOutputStream.prototype._appendStream = function(zae, source, callback) {
    };
    ArchiveOutputStream.prototype._emitErrorCallback = function(err2) {
      err2 && this.emit("error", err2);
    };
    ArchiveOutputStream.prototype._finish = function(ae) {
    };
    ArchiveOutputStream.prototype._normalizeEntry = function(ae) {
    };
    ArchiveOutputStream.prototype._transform = function(chunk, encoding, callback) {
      callback(null, chunk);
    };
    ArchiveOutputStream.prototype.entry = function(ae, source, callback) {
      if (source = source || null, typeof callback != "function" && (callback = this._emitErrorCallback.bind(this)), !(ae instanceof ArchiveEntry)) {
        callback(new Error("not a valid instance of ArchiveEntry"));
        return;
      }
      if (this._archive.finish || this._archive.finished) {
        callback(new Error("unacceptable entry after finish"));
        return;
      }
      if (this._archive.processing) {
        callback(new Error("already processing an entry"));
        return;
      }
      if (this._archive.processing = !0, this._normalizeEntry(ae), this._entry = ae, source = util2.normalizeInputSource(source), Buffer.isBuffer(source))
        this._appendBuffer(ae, source, callback);
      else if (util2.isStream(source))
        this._appendStream(ae, source, callback);
      else {
        this._archive.processing = !1, callback(new Error("input source must be valid Stream or Buffer instance"));
        return;
      }
      return this;
    };
    ArchiveOutputStream.prototype.finish = function() {
      if (this._archive.processing) {
        this._archive.finish = !0;
        return;
      }
      this._finish();
    };
    ArchiveOutputStream.prototype.getBytesWritten = function() {
      return this.offset;
    };
    ArchiveOutputStream.prototype.write = function(chunk, cb) {
      return chunk && (this.offset += chunk.length), Transform.prototype.write.call(this, chunk, cb);
    };
  }
});

// ../../node_modules/.pnpm/buffer-crc32@0.2.13/node_modules/buffer-crc32/index.js
var require_buffer_crc32 = __commonJS({
  "../../node_modules/.pnpm/buffer-crc32@0.2.13/node_modules/buffer-crc32/index.js"(exports, module) {
    init_cjs_shims();
    var Buffer2 = __require("buffer").Buffer, CRC_TABLE = [
      0,
      1996959894,
      3993919788,
      2567524794,
      124634137,
      1886057615,
      3915621685,
      2657392035,
      249268274,
      2044508324,
      3772115230,
      2547177864,
      162941995,
      2125561021,
      3887607047,
      2428444049,
      498536548,
      1789927666,
      4089016648,
      2227061214,
      450548861,
      1843258603,
      4107580753,
      2211677639,
      325883990,
      1684777152,
      4251122042,
      2321926636,
      335633487,
      1661365465,
      4195302755,
      2366115317,
      997073096,
      1281953886,
      3579855332,
      2724688242,
      1006888145,
      1258607687,
      3524101629,
      2768942443,
      901097722,
      1119000684,
      3686517206,
      2898065728,
      853044451,
      1172266101,
      3705015759,
      2882616665,
      651767980,
      1373503546,
      3369554304,
      3218104598,
      565507253,
      1454621731,
      3485111705,
      3099436303,
      671266974,
      1594198024,
      3322730930,
      2970347812,
      795835527,
      1483230225,
      3244367275,
      3060149565,
      1994146192,
      31158534,
      2563907772,
      4023717930,
      1907459465,
      112637215,
      2680153253,
      3904427059,
      2013776290,
      251722036,
      2517215374,
      3775830040,
      2137656763,
      141376813,
      2439277719,
      3865271297,
      1802195444,
      476864866,
      2238001368,
      4066508878,
      1812370925,
      453092731,
      2181625025,
      4111451223,
      1706088902,
      314042704,
      2344532202,
      4240017532,
      1658658271,
      366619977,
      2362670323,
      4224994405,
      1303535960,
      984961486,
      2747007092,
      3569037538,
      1256170817,
      1037604311,
      2765210733,
      3554079995,
      1131014506,
      879679996,
      2909243462,
      3663771856,
      1141124467,
      855842277,
      2852801631,
      3708648649,
      1342533948,
      654459306,
      3188396048,
      3373015174,
      1466479909,
      544179635,
      3110523913,
      3462522015,
      1591671054,
      702138776,
      2966460450,
      3352799412,
      1504918807,
      783551873,
      3082640443,
      3233442989,
      3988292384,
      2596254646,
      62317068,
      1957810842,
      3939845945,
      2647816111,
      81470997,
      1943803523,
      3814918930,
      2489596804,
      225274430,
      2053790376,
      3826175755,
      2466906013,
      167816743,
      2097651377,
      4027552580,
      2265490386,
      503444072,
      1762050814,
      4150417245,
      2154129355,
      426522225,
      1852507879,
      4275313526,
      2312317920,
      282753626,
      1742555852,
      4189708143,
      2394877945,
      397917763,
      1622183637,
      3604390888,
      2714866558,
      953729732,
      1340076626,
      3518719985,
      2797360999,
      1068828381,
      1219638859,
      3624741850,
      2936675148,
      906185462,
      1090812512,
      3747672003,
      2825379669,
      829329135,
      1181335161,
      3412177804,
      3160834842,
      628085408,
      1382605366,
      3423369109,
      3138078467,
      570562233,
      1426400815,
      3317316542,
      2998733608,
      733239954,
      1555261956,
      3268935591,
      3050360625,
      752459403,
      1541320221,
      2607071920,
      3965973030,
      1969922972,
      40735498,
      2617837225,
      3943577151,
      1913087877,
      83908371,
      2512341634,
      3803740692,
      2075208622,
      213261112,
      2463272603,
      3855990285,
      2094854071,
      198958881,
      2262029012,
      4057260610,
      1759359992,
      534414190,
      2176718541,
      4139329115,
      1873836001,
      414664567,
      2282248934,
      4279200368,
      1711684554,
      285281116,
      2405801727,
      4167216745,
      1634467795,
      376229701,
      2685067896,
      3608007406,
      1308918612,
      956543938,
      2808555105,
      3495958263,
      1231636301,
      1047427035,
      2932959818,
      3654703836,
      1088359270,
      936918e3,
      2847714899,
      3736837829,
      1202900863,
      817233897,
      3183342108,
      3401237130,
      1404277552,
      615818150,
      3134207493,
      3453421203,
      1423857449,
      601450431,
      3009837614,
      3294710456,
      1567103746,
      711928724,
      3020668471,
      3272380065,
      1510334235,
      755167117
    ];
    typeof Int32Array < "u" && (CRC_TABLE = new Int32Array(CRC_TABLE));
    function ensureBuffer(input) {
      if (Buffer2.isBuffer(input))
        return input;
      var hasNewBufferAPI = typeof Buffer2.alloc == "function" && typeof Buffer2.from == "function";
      if (typeof input == "number")
        return hasNewBufferAPI ? Buffer2.alloc(input) : new Buffer2(input);
      if (typeof input == "string")
        return hasNewBufferAPI ? Buffer2.from(input) : new Buffer2(input);
      throw new Error("input must be buffer, number, or string, received " + typeof input);
    }
    function bufferizeInt(num) {
      var tmp = ensureBuffer(4);
      return tmp.writeInt32BE(num, 0), tmp;
    }
    function _crc32(buf, previous) {
      buf = ensureBuffer(buf), Buffer2.isBuffer(previous) && (previous = previous.readUInt32BE(0));
      for (var crc = ~~previous ^ -1, n = 0; n < buf.length; n++)
        crc = CRC_TABLE[(crc ^ buf[n]) & 255] ^ crc >>> 8;
      return crc ^ -1;
    }
    function crc32() {
      return bufferizeInt(_crc32.apply(null, arguments));
    }
    crc32.signed = function() {
      return _crc32.apply(null, arguments);
    };
    crc32.unsigned = function() {
      return _crc32.apply(null, arguments) >>> 0;
    };
    module.exports = crc32;
  }
});

// ../../node_modules/.pnpm/crc-32@1.2.2/node_modules/crc-32/crc32.js
var require_crc32 = __commonJS({
  "../../node_modules/.pnpm/crc-32@1.2.2/node_modules/crc-32/crc32.js"(exports) {
    init_cjs_shims();
    var CRC32;
    (function(factory) {
      typeof DO_NOT_EXPORT_CRC > "u" ? typeof exports == "object" ? factory(exports) : typeof define == "function" && define.amd ? define(function() {
        var module2 = {};
        return factory(module2), module2;
      }) : factory(CRC32 = {}) : factory(CRC32 = {});
    })(function(CRC322) {
      CRC322.version = "1.2.2";
      function signed_crc_table() {
        for (var c = 0, table = new Array(256), n = 0; n != 256; ++n)
          c = n, c = c & 1 ? -306674912 ^ c >>> 1 : c >>> 1, c = c & 1 ? -306674912 ^ c >>> 1 : c >>> 1, c = c & 1 ? -306674912 ^ c >>> 1 : c >>> 1, c = c & 1 ? -306674912 ^ c >>> 1 : c >>> 1, c = c & 1 ? -306674912 ^ c >>> 1 : c >>> 1, c = c & 1 ? -306674912 ^ c >>> 1 : c >>> 1, c = c & 1 ? -306674912 ^ c >>> 1 : c >>> 1, c = c & 1 ? -306674912 ^ c >>> 1 : c >>> 1, table[n] = c;
        return typeof Int32Array < "u" ? new Int32Array(table) : table;
      }
      var T0 = signed_crc_table();
      function slice_by_16_tables(T) {
        var c = 0, v = 0, n = 0, table = typeof Int32Array < "u" ? new Int32Array(4096) : new Array(4096);
        for (n = 0; n != 256; ++n)
          table[n] = T[n];
        for (n = 0; n != 256; ++n)
          for (v = T[n], c = 256 + n; c < 4096; c += 256)
            v = table[c] = v >>> 8 ^ T[v & 255];
        var out = [];
        for (n = 1; n != 16; ++n)
          out[n - 1] = typeof Int32Array < "u" ? table.subarray(n * 256, n * 256 + 256) : table.slice(n * 256, n * 256 + 256);
        return out;
      }
      var TT = slice_by_16_tables(T0), T1 = TT[0], T2 = TT[1], T3 = TT[2], T4 = TT[3], T5 = TT[4], T6 = TT[5], T7 = TT[6], T8 = TT[7], T9 = TT[8], Ta = TT[9], Tb = TT[10], Tc = TT[11], Td = TT[12], Te = TT[13], Tf = TT[14];
      function crc32_bstr(bstr, seed) {
        for (var C = seed ^ -1, i = 0, L = bstr.length; i < L; )
          C = C >>> 8 ^ T0[(C ^ bstr.charCodeAt(i++)) & 255];
        return ~C;
      }
      function crc32_buf(B, seed) {
        for (var C = seed ^ -1, L = B.length - 15, i = 0; i < L; )
          C = Tf[B[i++] ^ C & 255] ^ Te[B[i++] ^ C >> 8 & 255] ^ Td[B[i++] ^ C >> 16 & 255] ^ Tc[B[i++] ^ C >>> 24] ^ Tb[B[i++]] ^ Ta[B[i++]] ^ T9[B[i++]] ^ T8[B[i++]] ^ T7[B[i++]] ^ T6[B[i++]] ^ T5[B[i++]] ^ T4[B[i++]] ^ T3[B[i++]] ^ T2[B[i++]] ^ T1[B[i++]] ^ T0[B[i++]];
        for (L += 15; i < L; )
          C = C >>> 8 ^ T0[(C ^ B[i++]) & 255];
        return ~C;
      }
      function crc32_str(str, seed) {
        for (var C = seed ^ -1, i = 0, L = str.length, c = 0, d = 0; i < L; )
          c = str.charCodeAt(i++), c < 128 ? C = C >>> 8 ^ T0[(C ^ c) & 255] : c < 2048 ? (C = C >>> 8 ^ T0[(C ^ (192 | c >> 6 & 31)) & 255], C = C >>> 8 ^ T0[(C ^ (128 | c & 63)) & 255]) : c >= 55296 && c < 57344 ? (c = (c & 1023) + 64, d = str.charCodeAt(i++) & 1023, C = C >>> 8 ^ T0[(C ^ (240 | c >> 8 & 7)) & 255], C = C >>> 8 ^ T0[(C ^ (128 | c >> 2 & 63)) & 255], C = C >>> 8 ^ T0[(C ^ (128 | d >> 6 & 15 | (c & 3) << 4)) & 255], C = C >>> 8 ^ T0[(C ^ (128 | d & 63)) & 255]) : (C = C >>> 8 ^ T0[(C ^ (224 | c >> 12 & 15)) & 255], C = C >>> 8 ^ T0[(C ^ (128 | c >> 6 & 63)) & 255], C = C >>> 8 ^ T0[(C ^ (128 | c & 63)) & 255]);
        return ~C;
      }
      CRC322.table = T0, CRC322.bstr = crc32_bstr, CRC322.buf = crc32_buf, CRC322.str = crc32_str;
    });
  }
});

// ../../node_modules/.pnpm/crc32-stream@4.0.3/node_modules/crc32-stream/lib/crc32-stream.js
var require_crc32_stream = __commonJS({
  "../../node_modules/.pnpm/crc32-stream@4.0.3/node_modules/crc32-stream/lib/crc32-stream.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var { Transform } = require_readable2(), crc32 = require_crc32(), CRC32Stream = class extends Transform {
      constructor(options) {
        super(options), this.checksum = Buffer.allocUnsafe(4), this.checksum.writeInt32BE(0, 0), this.rawSize = 0;
      }
      _transform(chunk, encoding, callback) {
        chunk && (this.checksum = crc32.buf(chunk, this.checksum) >>> 0, this.rawSize += chunk.length), callback(null, chunk);
      }
      digest(encoding) {
        let checksum2 = Buffer.allocUnsafe(4);
        return checksum2.writeUInt32BE(this.checksum >>> 0, 0), encoding ? checksum2.toString(encoding) : checksum2;
      }
      hex() {
        return this.digest("hex").toUpperCase();
      }
      size() {
        return this.rawSize;
      }
    };
    module.exports = CRC32Stream;
  }
});

// ../../node_modules/.pnpm/crc32-stream@4.0.3/node_modules/crc32-stream/lib/deflate-crc32-stream.js
var require_deflate_crc32_stream = __commonJS({
  "../../node_modules/.pnpm/crc32-stream@4.0.3/node_modules/crc32-stream/lib/deflate-crc32-stream.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var { DeflateRaw } = __require("zlib"), crc32 = require_crc32(), DeflateCRC32Stream = class extends DeflateRaw {
      constructor(options) {
        super(options), this.checksum = Buffer.allocUnsafe(4), this.checksum.writeInt32BE(0, 0), this.rawSize = 0, this.compressedSize = 0;
      }
      push(chunk, encoding) {
        return chunk && (this.compressedSize += chunk.length), super.push(chunk, encoding);
      }
      _transform(chunk, encoding, callback) {
        chunk && (this.checksum = crc32.buf(chunk, this.checksum) >>> 0, this.rawSize += chunk.length), super._transform(chunk, encoding, callback);
      }
      digest(encoding) {
        let checksum2 = Buffer.allocUnsafe(4);
        return checksum2.writeUInt32BE(this.checksum >>> 0, 0), encoding ? checksum2.toString(encoding) : checksum2;
      }
      hex() {
        return this.digest("hex").toUpperCase();
      }
      size(compressed = !1) {
        return compressed ? this.compressedSize : this.rawSize;
      }
    };
    module.exports = DeflateCRC32Stream;
  }
});

// ../../node_modules/.pnpm/crc32-stream@4.0.3/node_modules/crc32-stream/lib/index.js
var require_lib5 = __commonJS({
  "../../node_modules/.pnpm/crc32-stream@4.0.3/node_modules/crc32-stream/lib/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = {
      CRC32Stream: require_crc32_stream(),
      DeflateCRC32Stream: require_deflate_crc32_stream()
    };
  }
});

// ../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/archivers/zip/zip-archive-output-stream.js
var require_zip_archive_output_stream = __commonJS({
  "../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/archivers/zip/zip-archive-output-stream.js"(exports, module) {
    init_cjs_shims();
    var inherits = __require("util").inherits, crc32 = require_buffer_crc32(), { CRC32Stream } = require_lib5(), { DeflateCRC32Stream } = require_lib5(), ArchiveOutputStream = require_archive_output_stream(), ZipArchiveEntry = require_zip_archive_entry(), GeneralPurposeBit = require_general_purpose_bit(), constants = require_constants(), util2 = require_util4(), zipUtil = require_util3(), ZipArchiveOutputStream = module.exports = function(options) {
      if (!(this instanceof ZipArchiveOutputStream))
        return new ZipArchiveOutputStream(options);
      options = this.options = this._defaults(options), ArchiveOutputStream.call(this, options), this._entry = null, this._entries = [], this._archive = {
        centralLength: 0,
        centralOffset: 0,
        comment: "",
        finish: !1,
        finished: !1,
        processing: !1,
        forceZip64: options.forceZip64,
        forceLocalTime: options.forceLocalTime
      };
    };
    inherits(ZipArchiveOutputStream, ArchiveOutputStream);
    ZipArchiveOutputStream.prototype._afterAppend = function(ae) {
      this._entries.push(ae), ae.getGeneralPurposeBit().usesDataDescriptor() && this._writeDataDescriptor(ae), this._archive.processing = !1, this._entry = null, this._archive.finish && !this._archive.finished && this._finish();
    };
    ZipArchiveOutputStream.prototype._appendBuffer = function(ae, source, callback) {
      source.length === 0 && ae.setMethod(constants.METHOD_STORED);
      var method = ae.getMethod();
      if (method === constants.METHOD_STORED && (ae.setSize(source.length), ae.setCompressedSize(source.length), ae.setCrc(crc32.unsigned(source))), this._writeLocalFileHeader(ae), method === constants.METHOD_STORED) {
        this.write(source), this._afterAppend(ae), callback(null, ae);
        return;
      } else if (method === constants.METHOD_DEFLATED) {
        this._smartStream(ae, callback).end(source);
        return;
      } else {
        callback(new Error("compression method " + method + " not implemented"));
        return;
      }
    };
    ZipArchiveOutputStream.prototype._appendStream = function(ae, source, callback) {
      ae.getGeneralPurposeBit().useDataDescriptor(!0), ae.setVersionNeededToExtract(constants.MIN_VERSION_DATA_DESCRIPTOR), this._writeLocalFileHeader(ae);
      var smart = this._smartStream(ae, callback);
      source.once("error", function(err2) {
        smart.emit("error", err2), smart.end();
      }), source.pipe(smart);
    };
    ZipArchiveOutputStream.prototype._defaults = function(o) {
      return typeof o != "object" && (o = {}), typeof o.zlib != "object" && (o.zlib = {}), typeof o.zlib.level != "number" && (o.zlib.level = constants.ZLIB_BEST_SPEED), o.forceZip64 = !!o.forceZip64, o.forceLocalTime = !!o.forceLocalTime, o;
    };
    ZipArchiveOutputStream.prototype._finish = function() {
      this._archive.centralOffset = this.offset, this._entries.forEach(function(ae) {
        this._writeCentralFileHeader(ae);
      }.bind(this)), this._archive.centralLength = this.offset - this._archive.centralOffset, this.isZip64() && this._writeCentralDirectoryZip64(), this._writeCentralDirectoryEnd(), this._archive.processing = !1, this._archive.finish = !0, this._archive.finished = !0, this.end();
    };
    ZipArchiveOutputStream.prototype._normalizeEntry = function(ae) {
      ae.getMethod() === -1 && ae.setMethod(constants.METHOD_DEFLATED), ae.getMethod() === constants.METHOD_DEFLATED && (ae.getGeneralPurposeBit().useDataDescriptor(!0), ae.setVersionNeededToExtract(constants.MIN_VERSION_DATA_DESCRIPTOR)), ae.getTime() === -1 && ae.setTime(/* @__PURE__ */ new Date(), this._archive.forceLocalTime), ae._offsets = {
        file: 0,
        data: 0,
        contents: 0
      };
    };
    ZipArchiveOutputStream.prototype._smartStream = function(ae, callback) {
      var deflate = ae.getMethod() === constants.METHOD_DEFLATED, process2 = deflate ? new DeflateCRC32Stream(this.options.zlib) : new CRC32Stream(), error = null;
      function handleStuff() {
        var digest = process2.digest().readUInt32BE(0);
        ae.setCrc(digest), ae.setSize(process2.size()), ae.setCompressedSize(process2.size(!0)), this._afterAppend(ae), callback(error, ae);
      }
      return process2.once("end", handleStuff.bind(this)), process2.once("error", function(err2) {
        error = err2;
      }), process2.pipe(this, { end: !1 }), process2;
    };
    ZipArchiveOutputStream.prototype._writeCentralDirectoryEnd = function() {
      var records = this._entries.length, size = this._archive.centralLength, offset = this._archive.centralOffset;
      this.isZip64() && (records = constants.ZIP64_MAGIC_SHORT, size = constants.ZIP64_MAGIC, offset = constants.ZIP64_MAGIC), this.write(zipUtil.getLongBytes(constants.SIG_EOCD)), this.write(constants.SHORT_ZERO), this.write(constants.SHORT_ZERO), this.write(zipUtil.getShortBytes(records)), this.write(zipUtil.getShortBytes(records)), this.write(zipUtil.getLongBytes(size)), this.write(zipUtil.getLongBytes(offset));
      var comment = this.getComment(), commentLength = Buffer.byteLength(comment);
      this.write(zipUtil.getShortBytes(commentLength)), this.write(comment);
    };
    ZipArchiveOutputStream.prototype._writeCentralDirectoryZip64 = function() {
      this.write(zipUtil.getLongBytes(constants.SIG_ZIP64_EOCD)), this.write(zipUtil.getEightBytes(44)), this.write(zipUtil.getShortBytes(constants.MIN_VERSION_ZIP64)), this.write(zipUtil.getShortBytes(constants.MIN_VERSION_ZIP64)), this.write(constants.LONG_ZERO), this.write(constants.LONG_ZERO), this.write(zipUtil.getEightBytes(this._entries.length)), this.write(zipUtil.getEightBytes(this._entries.length)), this.write(zipUtil.getEightBytes(this._archive.centralLength)), this.write(zipUtil.getEightBytes(this._archive.centralOffset)), this.write(zipUtil.getLongBytes(constants.SIG_ZIP64_EOCD_LOC)), this.write(constants.LONG_ZERO), this.write(zipUtil.getEightBytes(this._archive.centralOffset + this._archive.centralLength)), this.write(zipUtil.getLongBytes(1));
    };
    ZipArchiveOutputStream.prototype._writeCentralFileHeader = function(ae) {
      var gpb = ae.getGeneralPurposeBit(), method = ae.getMethod(), offsets = ae._offsets, size = ae.getSize(), compressedSize = ae.getCompressedSize();
      if (ae.isZip64() || offsets.file > constants.ZIP64_MAGIC) {
        size = constants.ZIP64_MAGIC, compressedSize = constants.ZIP64_MAGIC, ae.setVersionNeededToExtract(constants.MIN_VERSION_ZIP64);
        var extraBuf = Buffer.concat([
          zipUtil.getShortBytes(constants.ZIP64_EXTRA_ID),
          zipUtil.getShortBytes(24),
          zipUtil.getEightBytes(ae.getSize()),
          zipUtil.getEightBytes(ae.getCompressedSize()),
          zipUtil.getEightBytes(offsets.file)
        ], 28);
        ae.setExtra(extraBuf);
      }
      this.write(zipUtil.getLongBytes(constants.SIG_CFH)), this.write(zipUtil.getShortBytes(ae.getPlatform() << 8 | constants.VERSION_MADEBY)), this.write(zipUtil.getShortBytes(ae.getVersionNeededToExtract())), this.write(gpb.encode()), this.write(zipUtil.getShortBytes(method)), this.write(zipUtil.getLongBytes(ae.getTimeDos())), this.write(zipUtil.getLongBytes(ae.getCrc())), this.write(zipUtil.getLongBytes(compressedSize)), this.write(zipUtil.getLongBytes(size));
      var name = ae.getName(), comment = ae.getComment(), extra = ae.getCentralDirectoryExtra();
      gpb.usesUTF8ForNames() && (name = Buffer.from(name), comment = Buffer.from(comment)), this.write(zipUtil.getShortBytes(name.length)), this.write(zipUtil.getShortBytes(extra.length)), this.write(zipUtil.getShortBytes(comment.length)), this.write(constants.SHORT_ZERO), this.write(zipUtil.getShortBytes(ae.getInternalAttributes())), this.write(zipUtil.getLongBytes(ae.getExternalAttributes())), offsets.file > constants.ZIP64_MAGIC ? this.write(zipUtil.getLongBytes(constants.ZIP64_MAGIC)) : this.write(zipUtil.getLongBytes(offsets.file)), this.write(name), this.write(extra), this.write(comment);
    };
    ZipArchiveOutputStream.prototype._writeDataDescriptor = function(ae) {
      this.write(zipUtil.getLongBytes(constants.SIG_DD)), this.write(zipUtil.getLongBytes(ae.getCrc())), ae.isZip64() ? (this.write(zipUtil.getEightBytes(ae.getCompressedSize())), this.write(zipUtil.getEightBytes(ae.getSize()))) : (this.write(zipUtil.getLongBytes(ae.getCompressedSize())), this.write(zipUtil.getLongBytes(ae.getSize())));
    };
    ZipArchiveOutputStream.prototype._writeLocalFileHeader = function(ae) {
      var gpb = ae.getGeneralPurposeBit(), method = ae.getMethod(), name = ae.getName(), extra = ae.getLocalFileDataExtra();
      ae.isZip64() && (gpb.useDataDescriptor(!0), ae.setVersionNeededToExtract(constants.MIN_VERSION_ZIP64)), gpb.usesUTF8ForNames() && (name = Buffer.from(name)), ae._offsets.file = this.offset, this.write(zipUtil.getLongBytes(constants.SIG_LFH)), this.write(zipUtil.getShortBytes(ae.getVersionNeededToExtract())), this.write(gpb.encode()), this.write(zipUtil.getShortBytes(method)), this.write(zipUtil.getLongBytes(ae.getTimeDos())), ae._offsets.data = this.offset, gpb.usesDataDescriptor() ? (this.write(constants.LONG_ZERO), this.write(constants.LONG_ZERO), this.write(constants.LONG_ZERO)) : (this.write(zipUtil.getLongBytes(ae.getCrc())), this.write(zipUtil.getLongBytes(ae.getCompressedSize())), this.write(zipUtil.getLongBytes(ae.getSize()))), this.write(zipUtil.getShortBytes(name.length)), this.write(zipUtil.getShortBytes(extra.length)), this.write(name), this.write(extra), ae._offsets.contents = this.offset;
    };
    ZipArchiveOutputStream.prototype.getComment = function(comment) {
      return this._archive.comment !== null ? this._archive.comment : "";
    };
    ZipArchiveOutputStream.prototype.isZip64 = function() {
      return this._archive.forceZip64 || this._entries.length > constants.ZIP64_MAGIC_SHORT || this._archive.centralLength > constants.ZIP64_MAGIC || this._archive.centralOffset > constants.ZIP64_MAGIC;
    };
    ZipArchiveOutputStream.prototype.setComment = function(comment) {
      this._archive.comment = comment;
    };
  }
});

// ../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/compress-commons.js
var require_compress_commons = __commonJS({
  "../../node_modules/.pnpm/compress-commons@4.1.2/node_modules/compress-commons/lib/compress-commons.js"(exports, module) {
    init_cjs_shims();
    module.exports = {
      ArchiveEntry: require_archive_entry(),
      ZipArchiveEntry: require_zip_archive_entry(),
      ArchiveOutputStream: require_archive_output_stream(),
      ZipArchiveOutputStream: require_zip_archive_output_stream()
    };
  }
});

// ../../node_modules/.pnpm/archiver-utils@3.0.4/node_modules/archiver-utils/file.js
var require_file2 = __commonJS({
  "../../node_modules/.pnpm/archiver-utils@3.0.4/node_modules/archiver-utils/file.js"(exports, module) {
    init_cjs_shims();
    var fs6 = require_graceful_fs(), path3 = __require("path"), flatten = require_lodash2(), difference2 = require_lodash3(), union = require_lodash4(), isPlainObject = require_lodash5(), glob2 = require_glob(), file = module.exports = {}, pathSeparatorRe = /[\/\\]/g, processPatterns = function(patterns, fn) {
      var result = [];
      return flatten(patterns).forEach(function(pattern) {
        var exclusion = pattern.indexOf("!") === 0;
        exclusion && (pattern = pattern.slice(1));
        var matches = fn(pattern);
        exclusion ? result = difference2(result, matches) : result = union(result, matches);
      }), result;
    };
    file.exists = function() {
      var filepath = path3.join.apply(path3, arguments);
      return fs6.existsSync(filepath);
    };
    file.expand = function(...args) {
      var options = isPlainObject(args[0]) ? args.shift() : {}, patterns = Array.isArray(args[0]) ? args[0] : args;
      if (patterns.length === 0)
        return [];
      var matches = processPatterns(patterns, function(pattern) {
        return glob2.sync(pattern, options);
      });
      return options.filter && (matches = matches.filter(function(filepath) {
        filepath = path3.join(options.cwd || "", filepath);
        try {
          return typeof options.filter == "function" ? options.filter(filepath) : fs6.statSync(filepath)[options.filter]();
        } catch {
          return !1;
        }
      })), matches;
    };
    file.expandMapping = function(patterns, destBase, options) {
      options = Object.assign({
        rename: function(destBase2, destPath) {
          return path3.join(destBase2 || "", destPath);
        }
      }, options);
      var files = [], fileByDest = {};
      return file.expand(options, patterns).forEach(function(src) {
        var destPath = src;
        options.flatten && (destPath = path3.basename(destPath)), options.ext && (destPath = destPath.replace(/(\.[^\/]*)?$/, options.ext));
        var dest = options.rename(destBase, destPath, options);
        options.cwd && (src = path3.join(options.cwd, src)), dest = dest.replace(pathSeparatorRe, "/"), src = src.replace(pathSeparatorRe, "/"), fileByDest[dest] ? fileByDest[dest].src.push(src) : (files.push({
          src: [src],
          dest
        }), fileByDest[dest] = files[files.length - 1]);
      }), files;
    };
    file.normalizeFilesArray = function(data) {
      var files = [];
      return data.forEach(function(obj) {
        var prop;
        ("src" in obj || "dest" in obj) && files.push(obj);
      }), files.length === 0 ? [] : (files = _(files).chain().forEach(function(obj) {
        !("src" in obj) || !obj.src || (Array.isArray(obj.src) ? obj.src = flatten(obj.src) : obj.src = [obj.src]);
      }).map(function(obj) {
        var expandOptions = Object.assign({}, obj);
        if (delete expandOptions.src, delete expandOptions.dest, obj.expand)
          return file.expandMapping(obj.src, obj.dest, expandOptions).map(function(mapObj) {
            var result2 = Object.assign({}, obj);
            return result2.orig = Object.assign({}, obj), result2.src = mapObj.src, result2.dest = mapObj.dest, ["expand", "cwd", "flatten", "rename", "ext"].forEach(function(prop) {
              delete result2[prop];
            }), result2;
          });
        var result = Object.assign({}, obj);
        return result.orig = Object.assign({}, obj), "src" in result && Object.defineProperty(result, "src", {
          enumerable: !0,
          get: function fn() {
            var src;
            return "result" in fn || (src = obj.src, src = Array.isArray(src) ? flatten(src) : [src], fn.result = file.expand(expandOptions, src)), fn.result;
          }
        }), "dest" in result && (result.dest = obj.dest), result;
      }).flatten().value(), files);
    };
  }
});

// ../../node_modules/.pnpm/archiver-utils@3.0.4/node_modules/archiver-utils/index.js
var require_archiver_utils2 = __commonJS({
  "../../node_modules/.pnpm/archiver-utils@3.0.4/node_modules/archiver-utils/index.js"(exports, module) {
    init_cjs_shims();
    var fs6 = require_graceful_fs(), path3 = __require("path"), lazystream = require_lazystream(), normalizePath2 = require_normalize_path(), defaults = require_lodash(), Stream = __require("stream").Stream, PassThrough2 = require_readable2().PassThrough, utils = module.exports = {};
    utils.file = require_file2();
    utils.collectStream = function(source, callback) {
      var collection = [], size = 0;
      source.on("error", callback), source.on("data", function(chunk) {
        collection.push(chunk), size += chunk.length;
      }), source.on("end", function() {
        var buf = Buffer.alloc(size), offset = 0;
        collection.forEach(function(data) {
          data.copy(buf, offset), offset += data.length;
        }), callback(null, buf);
      });
    };
    utils.dateify = function(dateish) {
      return dateish = dateish || /* @__PURE__ */ new Date(), dateish instanceof Date ? dateish = dateish : typeof dateish == "string" ? dateish = new Date(dateish) : dateish = /* @__PURE__ */ new Date(), dateish;
    };
    utils.defaults = function(object, source, guard) {
      var args = arguments;
      return args[0] = args[0] || {}, defaults(...args);
    };
    utils.isStream = function(source) {
      return source instanceof Stream;
    };
    utils.lazyReadStream = function(filepath) {
      return new lazystream.Readable(function() {
        return fs6.createReadStream(filepath);
      });
    };
    utils.normalizeInputSource = function(source) {
      return source === null ? Buffer.alloc(0) : typeof source == "string" ? Buffer.from(source) : utils.isStream(source) ? source.pipe(new PassThrough2()) : source;
    };
    utils.sanitizePath = function(filepath) {
      return normalizePath2(filepath, !1).replace(/^\w+:/, "").replace(/^(\.\.\/|\/)+/, "");
    };
    utils.trailingSlashIt = function(str) {
      return str.slice(-1) !== "/" ? str + "/" : str;
    };
    utils.unixifyPath = function(filepath) {
      return normalizePath2(filepath, !1).replace(/^\w+:/, "");
    };
    utils.walkdir = function(dirpath, base, callback) {
      var results = [];
      typeof base == "function" && (callback = base, base = dirpath), fs6.readdir(dirpath, function(err2, list2) {
        var i = 0, file, filepath;
        if (err2)
          return callback(err2);
        (function next() {
          if (file = list2[i++], !file)
            return callback(null, results);
          filepath = path3.join(dirpath, file), fs6.stat(filepath, function(err3, stats) {
            results.push({
              path: filepath,
              relative: path3.relative(base, filepath).replace(/\\/g, "/"),
              stats
            }), stats && stats.isDirectory() ? utils.walkdir(filepath, base, function(err4, res) {
              res.forEach(function(dirEntry) {
                results.push(dirEntry);
              }), next();
            }) : next();
          });
        })();
      });
    };
  }
});

// ../../node_modules/.pnpm/zip-stream@4.1.1/node_modules/zip-stream/index.js
var require_zip_stream = __commonJS({
  "../../node_modules/.pnpm/zip-stream@4.1.1/node_modules/zip-stream/index.js"(exports, module) {
    init_cjs_shims();
    var inherits = __require("util").inherits, ZipArchiveOutputStream = require_compress_commons().ZipArchiveOutputStream, ZipArchiveEntry = require_compress_commons().ZipArchiveEntry, util2 = require_archiver_utils2(), ZipStream = module.exports = function(options) {
      if (!(this instanceof ZipStream))
        return new ZipStream(options);
      options = this.options = options || {}, options.zlib = options.zlib || {}, ZipArchiveOutputStream.call(this, options), typeof options.level == "number" && options.level >= 0 && (options.zlib.level = options.level, delete options.level), !options.forceZip64 && typeof options.zlib.level == "number" && options.zlib.level === 0 && (options.store = !0), options.namePrependSlash = options.namePrependSlash || !1, options.comment && options.comment.length > 0 && this.setComment(options.comment);
    };
    inherits(ZipStream, ZipArchiveOutputStream);
    ZipStream.prototype._normalizeFileData = function(data) {
      data = util2.defaults(data, {
        type: "file",
        name: null,
        namePrependSlash: this.options.namePrependSlash,
        linkname: null,
        date: null,
        mode: null,
        store: this.options.store,
        comment: ""
      });
      var isDir = data.type === "directory", isSymlink = data.type === "symlink";
      return data.name && (data.name = util2.sanitizePath(data.name), !isSymlink && data.name.slice(-1) === "/" ? (isDir = !0, data.type = "directory") : isDir && (data.name += "/")), (isDir || isSymlink) && (data.store = !0), data.date = util2.dateify(data.date), data;
    };
    ZipStream.prototype.entry = function(source, data, callback) {
      if (typeof callback != "function" && (callback = this._emitErrorCallback.bind(this)), data = this._normalizeFileData(data), data.type !== "file" && data.type !== "directory" && data.type !== "symlink") {
        callback(new Error(data.type + " entries not currently supported"));
        return;
      }
      if (typeof data.name != "string" || data.name.length === 0) {
        callback(new Error("entry name must be a non-empty string value"));
        return;
      }
      if (data.type === "symlink" && typeof data.linkname != "string") {
        callback(new Error("entry linkname must be a non-empty string value when type equals symlink"));
        return;
      }
      var entry = new ZipArchiveEntry(data.name);
      return entry.setTime(data.date, this.options.forceLocalTime), data.namePrependSlash && entry.setName(data.name, !0), data.store && entry.setMethod(0), data.comment.length > 0 && entry.setComment(data.comment), data.type === "symlink" && typeof data.mode != "number" && (data.mode = 40960), typeof data.mode == "number" && (data.type === "symlink" && (data.mode |= 40960), entry.setUnixMode(data.mode)), data.type === "symlink" && typeof data.linkname == "string" && (source = Buffer.from(data.linkname)), ZipArchiveOutputStream.prototype.entry.call(this, entry, source, callback);
    };
    ZipStream.prototype.finalize = function() {
      this.finish();
    };
  }
});

// ../../node_modules/.pnpm/archiver@5.3.2/node_modules/archiver/lib/plugins/zip.js
var require_zip = __commonJS({
  "../../node_modules/.pnpm/archiver@5.3.2/node_modules/archiver/lib/plugins/zip.js"(exports, module) {
    init_cjs_shims();
    var engine = require_zip_stream(), util2 = require_archiver_utils(), Zip = function(options) {
      if (!(this instanceof Zip))
        return new Zip(options);
      options = this.options = util2.defaults(options, {
        comment: "",
        forceUTC: !1,
        namePrependSlash: !1,
        store: !1
      }), this.supports = {
        directory: !0,
        symlink: !0
      }, this.engine = new engine(options);
    };
    Zip.prototype.append = function(source, data, callback) {
      this.engine.entry(source, data, callback);
    };
    Zip.prototype.finalize = function() {
      this.engine.finalize();
    };
    Zip.prototype.on = function() {
      return this.engine.on.apply(this.engine, arguments);
    };
    Zip.prototype.pipe = function() {
      return this.engine.pipe.apply(this.engine, arguments);
    };
    Zip.prototype.unpipe = function() {
      return this.engine.unpipe.apply(this.engine, arguments);
    };
    module.exports = Zip;
  }
});

// ../../node_modules/.pnpm/bl@4.1.0/node_modules/bl/BufferList.js
var require_BufferList2 = __commonJS({
  "../../node_modules/.pnpm/bl@4.1.0/node_modules/bl/BufferList.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var { Buffer: Buffer2 } = __require("buffer"), symbol = Symbol.for("BufferList");
    function BufferList(buf) {
      if (!(this instanceof BufferList))
        return new BufferList(buf);
      BufferList._init.call(this, buf);
    }
    BufferList._init = function(buf) {
      Object.defineProperty(this, symbol, { value: !0 }), this._bufs = [], this.length = 0, buf && this.append(buf);
    };
    BufferList.prototype._new = function(buf) {
      return new BufferList(buf);
    };
    BufferList.prototype._offset = function(offset) {
      if (offset === 0)
        return [0, 0];
      let tot = 0;
      for (let i = 0; i < this._bufs.length; i++) {
        let _t = tot + this._bufs[i].length;
        if (offset < _t || i === this._bufs.length - 1)
          return [i, offset - tot];
        tot = _t;
      }
    };
    BufferList.prototype._reverseOffset = function(blOffset) {
      let bufferId = blOffset[0], offset = blOffset[1];
      for (let i = 0; i < bufferId; i++)
        offset += this._bufs[i].length;
      return offset;
    };
    BufferList.prototype.get = function(index) {
      if (index > this.length || index < 0)
        return;
      let offset = this._offset(index);
      return this._bufs[offset[0]][offset[1]];
    };
    BufferList.prototype.slice = function(start, end) {
      return typeof start == "number" && start < 0 && (start += this.length), typeof end == "number" && end < 0 && (end += this.length), this.copy(null, 0, start, end);
    };
    BufferList.prototype.copy = function(dst, dstStart, srcStart, srcEnd) {
      if ((typeof srcStart != "number" || srcStart < 0) && (srcStart = 0), (typeof srcEnd != "number" || srcEnd > this.length) && (srcEnd = this.length), srcStart >= this.length || srcEnd <= 0)
        return dst || Buffer2.alloc(0);
      let copy2 = !!dst, off = this._offset(srcStart), len = srcEnd - srcStart, bytes = len, bufoff = copy2 && dstStart || 0, start = off[1];
      if (srcStart === 0 && srcEnd === this.length) {
        if (!copy2)
          return this._bufs.length === 1 ? this._bufs[0] : Buffer2.concat(this._bufs, this.length);
        for (let i = 0; i < this._bufs.length; i++)
          this._bufs[i].copy(dst, bufoff), bufoff += this._bufs[i].length;
        return dst;
      }
      if (bytes <= this._bufs[off[0]].length - start)
        return copy2 ? this._bufs[off[0]].copy(dst, dstStart, start, start + bytes) : this._bufs[off[0]].slice(start, start + bytes);
      copy2 || (dst = Buffer2.allocUnsafe(len));
      for (let i = off[0]; i < this._bufs.length; i++) {
        let l = this._bufs[i].length - start;
        if (bytes > l)
          this._bufs[i].copy(dst, bufoff, start), bufoff += l;
        else {
          this._bufs[i].copy(dst, bufoff, start, start + bytes), bufoff += l;
          break;
        }
        bytes -= l, start && (start = 0);
      }
      return dst.length > bufoff ? dst.slice(0, bufoff) : dst;
    };
    BufferList.prototype.shallowSlice = function(start, end) {
      if (start = start || 0, end = typeof end != "number" ? this.length : end, start < 0 && (start += this.length), end < 0 && (end += this.length), start === end)
        return this._new();
      let startOffset = this._offset(start), endOffset = this._offset(end), buffers = this._bufs.slice(startOffset[0], endOffset[0] + 1);
      return endOffset[1] === 0 ? buffers.pop() : buffers[buffers.length - 1] = buffers[buffers.length - 1].slice(0, endOffset[1]), startOffset[1] !== 0 && (buffers[0] = buffers[0].slice(startOffset[1])), this._new(buffers);
    };
    BufferList.prototype.toString = function(encoding, start, end) {
      return this.slice(start, end).toString(encoding);
    };
    BufferList.prototype.consume = function(bytes) {
      if (bytes = Math.trunc(bytes), Number.isNaN(bytes) || bytes <= 0)
        return this;
      for (; this._bufs.length; )
        if (bytes >= this._bufs[0].length)
          bytes -= this._bufs[0].length, this.length -= this._bufs[0].length, this._bufs.shift();
        else {
          this._bufs[0] = this._bufs[0].slice(bytes), this.length -= bytes;
          break;
        }
      return this;
    };
    BufferList.prototype.duplicate = function() {
      let copy = this._new();
      for (let i = 0; i < this._bufs.length; i++)
        copy.append(this._bufs[i]);
      return copy;
    };
    BufferList.prototype.append = function(buf) {
      if (buf == null)
        return this;
      if (buf.buffer)
        this._appendBuffer(Buffer2.from(buf.buffer, buf.byteOffset, buf.byteLength));
      else if (Array.isArray(buf))
        for (let i = 0; i < buf.length; i++)
          this.append(buf[i]);
      else if (this._isBufferList(buf))
        for (let i = 0; i < buf._bufs.length; i++)
          this.append(buf._bufs[i]);
      else
        typeof buf == "number" && (buf = buf.toString()), this._appendBuffer(Buffer2.from(buf));
      return this;
    };
    BufferList.prototype._appendBuffer = function(buf) {
      this._bufs.push(buf), this.length += buf.length;
    };
    BufferList.prototype.indexOf = function(search, offset, encoding) {
      if (encoding === void 0 && typeof offset == "string" && (encoding = offset, offset = void 0), typeof search == "function" || Array.isArray(search))
        throw new TypeError('The "value" argument must be one of type string, Buffer, BufferList, or Uint8Array.');
      if (typeof search == "number" ? search = Buffer2.from([search]) : typeof search == "string" ? search = Buffer2.from(search, encoding) : this._isBufferList(search) ? search = search.slice() : Array.isArray(search.buffer) ? search = Buffer2.from(search.buffer, search.byteOffset, search.byteLength) : Buffer2.isBuffer(search) || (search = Buffer2.from(search)), offset = Number(offset || 0), isNaN(offset) && (offset = 0), offset < 0 && (offset = this.length + offset), offset < 0 && (offset = 0), search.length === 0)
        return offset > this.length ? this.length : offset;
      let blOffset = this._offset(offset), blIndex = blOffset[0], buffOffset = blOffset[1];
      for (; blIndex < this._bufs.length; blIndex++) {
        let buff = this._bufs[blIndex];
        for (; buffOffset < buff.length; )
          if (buff.length - buffOffset >= search.length) {
            let nativeSearchResult = buff.indexOf(search, buffOffset);
            if (nativeSearchResult !== -1)
              return this._reverseOffset([blIndex, nativeSearchResult]);
            buffOffset = buff.length - search.length + 1;
          } else {
            let revOffset = this._reverseOffset([blIndex, buffOffset]);
            if (this._match(revOffset, search))
              return revOffset;
            buffOffset++;
          }
        buffOffset = 0;
      }
      return -1;
    };
    BufferList.prototype._match = function(offset, search) {
      if (this.length - offset < search.length)
        return !1;
      for (let searchOffset = 0; searchOffset < search.length; searchOffset++)
        if (this.get(offset + searchOffset) !== search[searchOffset])
          return !1;
      return !0;
    };
    (function() {
      let methods = {
        readDoubleBE: 8,
        readDoubleLE: 8,
        readFloatBE: 4,
        readFloatLE: 4,
        readInt32BE: 4,
        readInt32LE: 4,
        readUInt32BE: 4,
        readUInt32LE: 4,
        readInt16BE: 2,
        readInt16LE: 2,
        readUInt16BE: 2,
        readUInt16LE: 2,
        readInt8: 1,
        readUInt8: 1,
        readIntBE: null,
        readIntLE: null,
        readUIntBE: null,
        readUIntLE: null
      };
      for (let m in methods)
        (function(m2) {
          methods[m2] === null ? BufferList.prototype[m2] = function(offset, byteLength) {
            return this.slice(offset, offset + byteLength)[m2](0, byteLength);
          } : BufferList.prototype[m2] = function(offset = 0) {
            return this.slice(offset, offset + methods[m2])[m2](0);
          };
        })(m);
    })();
    BufferList.prototype._isBufferList = function(b) {
      return b instanceof BufferList || BufferList.isBufferList(b);
    };
    BufferList.isBufferList = function(b) {
      return b != null && b[symbol];
    };
    module.exports = BufferList;
  }
});

// ../../node_modules/.pnpm/bl@4.1.0/node_modules/bl/bl.js
var require_bl = __commonJS({
  "../../node_modules/.pnpm/bl@4.1.0/node_modules/bl/bl.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var DuplexStream = require_readable2().Duplex, inherits = require_inherits(), BufferList = require_BufferList2();
    function BufferListStream(callback) {
      if (!(this instanceof BufferListStream))
        return new BufferListStream(callback);
      if (typeof callback == "function") {
        this._callback = callback;
        let piper = function(err2) {
          this._callback && (this._callback(err2), this._callback = null);
        }.bind(this);
        this.on("pipe", function(src) {
          src.on("error", piper);
        }), this.on("unpipe", function(src) {
          src.removeListener("error", piper);
        }), callback = null;
      }
      BufferList._init.call(this, callback), DuplexStream.call(this);
    }
    inherits(BufferListStream, DuplexStream);
    Object.assign(BufferListStream.prototype, BufferList.prototype);
    BufferListStream.prototype._new = function(callback) {
      return new BufferListStream(callback);
    };
    BufferListStream.prototype._write = function(buf, encoding, callback) {
      this._appendBuffer(buf), typeof callback == "function" && callback();
    };
    BufferListStream.prototype._read = function(size) {
      if (!this.length)
        return this.push(null);
      size = Math.min(size, this.length), this.push(this.slice(0, size)), this.consume(size);
    };
    BufferListStream.prototype.end = function(chunk) {
      DuplexStream.prototype.end.call(this, chunk), this._callback && (this._callback(null, this.slice()), this._callback = null);
    };
    BufferListStream.prototype._destroy = function(err2, cb) {
      this._bufs.length = 0, this.length = 0, cb(err2);
    };
    BufferListStream.prototype._isBufferList = function(b) {
      return b instanceof BufferListStream || b instanceof BufferList || BufferListStream.isBufferList(b);
    };
    BufferListStream.isBufferList = BufferList.isBufferList;
    module.exports = BufferListStream;
    module.exports.BufferListStream = BufferListStream;
    module.exports.BufferList = BufferList;
  }
});

// ../../node_modules/.pnpm/tar-stream@2.2.0/node_modules/tar-stream/headers.js
var require_headers = __commonJS({
  "../../node_modules/.pnpm/tar-stream@2.2.0/node_modules/tar-stream/headers.js"(exports) {
    init_cjs_shims();
    var alloc = Buffer.alloc, ZEROS = "0000000000000000000", SEVENS = "7777777777777777777", ZERO_OFFSET = 48, USTAR_MAGIC = Buffer.from("ustar\0", "binary"), USTAR_VER = Buffer.from("00", "binary"), GNU_MAGIC = Buffer.from("ustar ", "binary"), GNU_VER = Buffer.from(" \0", "binary"), MASK = parseInt("7777", 8), MAGIC_OFFSET = 257, VERSION_OFFSET = 263, clamp = function(index, len, defaultValue) {
      return typeof index != "number" ? defaultValue : (index = ~~index, index >= len ? len : index >= 0 || (index += len, index >= 0) ? index : 0);
    }, toType = function(flag) {
      switch (flag) {
        case 0:
          return "file";
        case 1:
          return "link";
        case 2:
          return "symlink";
        case 3:
          return "character-device";
        case 4:
          return "block-device";
        case 5:
          return "directory";
        case 6:
          return "fifo";
        case 7:
          return "contiguous-file";
        case 72:
          return "pax-header";
        case 55:
          return "pax-global-header";
        case 27:
          return "gnu-long-link-path";
        case 28:
        case 30:
          return "gnu-long-path";
      }
      return null;
    }, toTypeflag = function(flag) {
      switch (flag) {
        case "file":
          return 0;
        case "link":
          return 1;
        case "symlink":
          return 2;
        case "character-device":
          return 3;
        case "block-device":
          return 4;
        case "directory":
          return 5;
        case "fifo":
          return 6;
        case "contiguous-file":
          return 7;
        case "pax-header":
          return 72;
      }
      return 0;
    }, indexOf = function(block, num, offset, end) {
      for (; offset < end; offset++)
        if (block[offset] === num)
          return offset;
      return end;
    }, cksum = function(block) {
      for (var sum = 256, i = 0; i < 148; i++)
        sum += block[i];
      for (var j = 156; j < 512; j++)
        sum += block[j];
      return sum;
    }, encodeOct = function(val, n) {
      return val = val.toString(8), val.length > n ? SEVENS.slice(0, n) + " " : ZEROS.slice(0, n - val.length) + val + " ";
    };
    function parse256(buf) {
      var positive;
      if (buf[0] === 128)
        positive = !0;
      else if (buf[0] === 255)
        positive = !1;
      else
        return null;
      for (var tuple = [], i = buf.length - 1; i > 0; i--) {
        var byte = buf[i];
        positive ? tuple.push(byte) : tuple.push(255 - byte);
      }
      var sum = 0, l = tuple.length;
      for (i = 0; i < l; i++)
        sum += tuple[i] * Math.pow(256, i);
      return positive ? sum : -1 * sum;
    }
    var decodeOct = function(val, offset, length) {
      if (val = val.slice(offset, offset + length), offset = 0, val[offset] & 128)
        return parse256(val);
      for (; offset < val.length && val[offset] === 32; )
        offset++;
      for (var end = clamp(indexOf(val, 32, offset, val.length), val.length, val.length); offset < end && val[offset] === 0; )
        offset++;
      return end === offset ? 0 : parseInt(val.slice(offset, end).toString(), 8);
    }, decodeStr = function(val, offset, length, encoding) {
      return val.slice(offset, indexOf(val, 0, offset, offset + length)).toString(encoding);
    }, addLength = function(str) {
      var len = Buffer.byteLength(str), digits = Math.floor(Math.log(len) / Math.log(10)) + 1;
      return len + digits >= Math.pow(10, digits) && digits++, len + digits + str;
    };
    exports.decodeLongPath = function(buf, encoding) {
      return decodeStr(buf, 0, buf.length, encoding);
    };
    exports.encodePax = function(opts) {
      var result = "";
      opts.name && (result += addLength(" path=" + opts.name + `
`)), opts.linkname && (result += addLength(" linkpath=" + opts.linkname + `
`));
      var pax = opts.pax;
      if (pax)
        for (var key in pax)
          result += addLength(" " + key + "=" + pax[key] + `
`);
      return Buffer.from(result);
    };
    exports.decodePax = function(buf) {
      for (var result = {}; buf.length; ) {
        for (var i = 0; i < buf.length && buf[i] !== 32; )
          i++;
        var len = parseInt(buf.slice(0, i).toString(), 10);
        if (!len)
          return result;
        var b = buf.slice(i + 1, len - 1).toString(), keyIndex = b.indexOf("=");
        if (keyIndex === -1)
          return result;
        result[b.slice(0, keyIndex)] = b.slice(keyIndex + 1), buf = buf.slice(len);
      }
      return result;
    };
    exports.encode = function(opts) {
      var buf = alloc(512), name = opts.name, prefix = "";
      if (opts.typeflag === 5 && name[name.length - 1] !== "/" && (name += "/"), Buffer.byteLength(name) !== name.length)
        return null;
      for (; Buffer.byteLength(name) > 100; ) {
        var i = name.indexOf("/");
        if (i === -1)
          return null;
        prefix += prefix ? "/" + name.slice(0, i) : name.slice(0, i), name = name.slice(i + 1);
      }
      return Buffer.byteLength(name) > 100 || Buffer.byteLength(prefix) > 155 || opts.linkname && Buffer.byteLength(opts.linkname) > 100 ? null : (buf.write(name), buf.write(encodeOct(opts.mode & MASK, 6), 100), buf.write(encodeOct(opts.uid, 6), 108), buf.write(encodeOct(opts.gid, 6), 116), buf.write(encodeOct(opts.size, 11), 124), buf.write(encodeOct(opts.mtime.getTime() / 1e3 | 0, 11), 136), buf[156] = ZERO_OFFSET + toTypeflag(opts.type), opts.linkname && buf.write(opts.linkname, 157), USTAR_MAGIC.copy(buf, MAGIC_OFFSET), USTAR_VER.copy(buf, VERSION_OFFSET), opts.uname && buf.write(opts.uname, 265), opts.gname && buf.write(opts.gname, 297), buf.write(encodeOct(opts.devmajor || 0, 6), 329), buf.write(encodeOct(opts.devminor || 0, 6), 337), prefix && buf.write(prefix, 345), buf.write(encodeOct(cksum(buf), 6), 148), buf);
    };
    exports.decode = function(buf, filenameEncoding, allowUnknownFormat) {
      var typeflag = buf[156] === 0 ? 0 : buf[156] - ZERO_OFFSET, name = decodeStr(buf, 0, 100, filenameEncoding), mode = decodeOct(buf, 100, 8), uid = decodeOct(buf, 108, 8), gid = decodeOct(buf, 116, 8), size = decodeOct(buf, 124, 12), mtime = decodeOct(buf, 136, 12), type = toType(typeflag), linkname = buf[157] === 0 ? null : decodeStr(buf, 157, 100, filenameEncoding), uname = decodeStr(buf, 265, 32), gname = decodeStr(buf, 297, 32), devmajor = decodeOct(buf, 329, 8), devminor = decodeOct(buf, 337, 8), c = cksum(buf);
      if (c === 8 * 32)
        return null;
      if (c !== decodeOct(buf, 148, 8))
        throw new Error("Invalid tar header. Maybe the tar is corrupted or it needs to be gunzipped?");
      if (USTAR_MAGIC.compare(buf, MAGIC_OFFSET, MAGIC_OFFSET + 6) === 0)
        buf[345] && (name = decodeStr(buf, 345, 155, filenameEncoding) + "/" + name);
      else if (!(GNU_MAGIC.compare(buf, MAGIC_OFFSET, MAGIC_OFFSET + 6) === 0 && GNU_VER.compare(buf, VERSION_OFFSET, VERSION_OFFSET + 2) === 0)) {
        if (!allowUnknownFormat)
          throw new Error("Invalid tar header: unknown format.");
      }
      return typeflag === 0 && name && name[name.length - 1] === "/" && (typeflag = 5), {
        name,
        mode,
        uid,
        gid,
        size,
        mtime: new Date(1e3 * mtime),
        type,
        linkname,
        uname,
        gname,
        devmajor,
        devminor
      };
    };
  }
});

// ../../node_modules/.pnpm/tar-stream@2.2.0/node_modules/tar-stream/extract.js
var require_extract = __commonJS({
  "../../node_modules/.pnpm/tar-stream@2.2.0/node_modules/tar-stream/extract.js"(exports, module) {
    init_cjs_shims();
    var util2 = __require("util"), bl = require_bl(), headers = require_headers(), Writable3 = require_readable2().Writable, PassThrough2 = require_readable2().PassThrough, noop = function() {
    }, overflow = function(size) {
      return size &= 511, size && 512 - size;
    }, emptyStream = function(self2, offset) {
      var s = new Source(self2, offset);
      return s.end(), s;
    }, mixinPax = function(header2, pax) {
      return pax.path && (header2.name = pax.path), pax.linkpath && (header2.linkname = pax.linkpath), pax.size && (header2.size = parseInt(pax.size, 10)), header2.pax = pax, header2;
    }, Source = function(self2, offset) {
      this._parent = self2, this.offset = offset, PassThrough2.call(this, { autoDestroy: !1 });
    };
    util2.inherits(Source, PassThrough2);
    Source.prototype.destroy = function(err2) {
      this._parent.destroy(err2);
    };
    var Extract = function(opts) {
      if (!(this instanceof Extract))
        return new Extract(opts);
      Writable3.call(this, opts), opts = opts || {}, this._offset = 0, this._buffer = bl(), this._missing = 0, this._partial = !1, this._onparse = noop, this._header = null, this._stream = null, this._overflow = null, this._cb = null, this._locked = !1, this._destroyed = !1, this._pax = null, this._paxGlobal = null, this._gnuLongPath = null, this._gnuLongLinkPath = null;
      var self2 = this, b = self2._buffer, oncontinue = function() {
        self2._continue();
      }, onunlock = function(err2) {
        if (self2._locked = !1, err2)
          return self2.destroy(err2);
        self2._stream || oncontinue();
      }, onstreamend = function() {
        self2._stream = null;
        var drain = overflow(self2._header.size);
        drain ? self2._parse(drain, ondrain) : self2._parse(512, onheader), self2._locked || oncontinue();
      }, ondrain = function() {
        self2._buffer.consume(overflow(self2._header.size)), self2._parse(512, onheader), oncontinue();
      }, onpaxglobalheader = function() {
        var size = self2._header.size;
        self2._paxGlobal = headers.decodePax(b.slice(0, size)), b.consume(size), onstreamend();
      }, onpaxheader = function() {
        var size = self2._header.size;
        self2._pax = headers.decodePax(b.slice(0, size)), self2._paxGlobal && (self2._pax = Object.assign({}, self2._paxGlobal, self2._pax)), b.consume(size), onstreamend();
      }, ongnulongpath = function() {
        var size = self2._header.size;
        this._gnuLongPath = headers.decodeLongPath(b.slice(0, size), opts.filenameEncoding), b.consume(size), onstreamend();
      }, ongnulonglinkpath = function() {
        var size = self2._header.size;
        this._gnuLongLinkPath = headers.decodeLongPath(b.slice(0, size), opts.filenameEncoding), b.consume(size), onstreamend();
      }, onheader = function() {
        var offset = self2._offset, header2;
        try {
          header2 = self2._header = headers.decode(b.slice(0, 512), opts.filenameEncoding, opts.allowUnknownFormat);
        } catch (err2) {
          self2.emit("error", err2);
        }
        if (b.consume(512), !header2) {
          self2._parse(512, onheader), oncontinue();
          return;
        }
        if (header2.type === "gnu-long-path") {
          self2._parse(header2.size, ongnulongpath), oncontinue();
          return;
        }
        if (header2.type === "gnu-long-link-path") {
          self2._parse(header2.size, ongnulonglinkpath), oncontinue();
          return;
        }
        if (header2.type === "pax-global-header") {
          self2._parse(header2.size, onpaxglobalheader), oncontinue();
          return;
        }
        if (header2.type === "pax-header") {
          self2._parse(header2.size, onpaxheader), oncontinue();
          return;
        }
        if (self2._gnuLongPath && (header2.name = self2._gnuLongPath, self2._gnuLongPath = null), self2._gnuLongLinkPath && (header2.linkname = self2._gnuLongLinkPath, self2._gnuLongLinkPath = null), self2._pax && (self2._header = header2 = mixinPax(header2, self2._pax), self2._pax = null), self2._locked = !0, !header2.size || header2.type === "directory") {
          self2._parse(512, onheader), self2.emit("entry", header2, emptyStream(self2, offset), onunlock);
          return;
        }
        self2._stream = new Source(self2, offset), self2.emit("entry", header2, self2._stream, onunlock), self2._parse(header2.size, onstreamend), oncontinue();
      };
      this._onheader = onheader, this._parse(512, onheader);
    };
    util2.inherits(Extract, Writable3);
    Extract.prototype.destroy = function(err2) {
      this._destroyed || (this._destroyed = !0, err2 && this.emit("error", err2), this.emit("close"), this._stream && this._stream.emit("close"));
    };
    Extract.prototype._parse = function(size, onparse) {
      this._destroyed || (this._offset += size, this._missing = size, onparse === this._onheader && (this._partial = !1), this._onparse = onparse);
    };
    Extract.prototype._continue = function() {
      if (!this._destroyed) {
        var cb = this._cb;
        this._cb = noop, this._overflow ? this._write(this._overflow, void 0, cb) : cb();
      }
    };
    Extract.prototype._write = function(data, enc, cb) {
      if (!this._destroyed) {
        var s = this._stream, b = this._buffer, missing = this._missing;
        if (data.length && (this._partial = !0), data.length < missing)
          return this._missing -= data.length, this._overflow = null, s ? s.write(data, cb) : (b.append(data), cb());
        this._cb = cb, this._missing = 0;
        var overflow2 = null;
        data.length > missing && (overflow2 = data.slice(missing), data = data.slice(0, missing)), s ? s.end(data) : b.append(data), this._overflow = overflow2, this._onparse();
      }
    };
    Extract.prototype._final = function(cb) {
      if (this._partial)
        return this.destroy(new Error("Unexpected end of data"));
      cb();
    };
    module.exports = Extract;
  }
});

// ../../node_modules/.pnpm/fs-constants@1.0.0/node_modules/fs-constants/index.js
var require_fs_constants = __commonJS({
  "../../node_modules/.pnpm/fs-constants@1.0.0/node_modules/fs-constants/index.js"(exports, module) {
    init_cjs_shims();
    module.exports = __require("fs").constants || __require("constants");
  }
});

// ../../node_modules/.pnpm/tar-stream@2.2.0/node_modules/tar-stream/pack.js
var require_pack = __commonJS({
  "../../node_modules/.pnpm/tar-stream@2.2.0/node_modules/tar-stream/pack.js"(exports, module) {
    init_cjs_shims();
    var constants = require_fs_constants(), eos = require_end_of_stream(), inherits = require_inherits(), alloc = Buffer.alloc, Readable = require_readable2().Readable, Writable3 = require_readable2().Writable, StringDecoder = __require("string_decoder").StringDecoder, headers = require_headers(), DMODE = parseInt("755", 8), FMODE = parseInt("644", 8), END_OF_TAR = alloc(1024), noop = function() {
    }, overflow = function(self2, size) {
      size &= 511, size && self2.push(END_OF_TAR.slice(0, 512 - size));
    };
    function modeToType(mode) {
      switch (mode & constants.S_IFMT) {
        case constants.S_IFBLK:
          return "block-device";
        case constants.S_IFCHR:
          return "character-device";
        case constants.S_IFDIR:
          return "directory";
        case constants.S_IFIFO:
          return "fifo";
        case constants.S_IFLNK:
          return "symlink";
      }
      return "file";
    }
    var Sink = function(to) {
      Writable3.call(this), this.written = 0, this._to = to, this._destroyed = !1;
    };
    inherits(Sink, Writable3);
    Sink.prototype._write = function(data, enc, cb) {
      if (this.written += data.length, this._to.push(data))
        return cb();
      this._to._drain = cb;
    };
    Sink.prototype.destroy = function() {
      this._destroyed || (this._destroyed = !0, this.emit("close"));
    };
    var LinkSink = function() {
      Writable3.call(this), this.linkname = "", this._decoder = new StringDecoder("utf-8"), this._destroyed = !1;
    };
    inherits(LinkSink, Writable3);
    LinkSink.prototype._write = function(data, enc, cb) {
      this.linkname += this._decoder.write(data), cb();
    };
    LinkSink.prototype.destroy = function() {
      this._destroyed || (this._destroyed = !0, this.emit("close"));
    };
    var Void = function() {
      Writable3.call(this), this._destroyed = !1;
    };
    inherits(Void, Writable3);
    Void.prototype._write = function(data, enc, cb) {
      cb(new Error("No body allowed for this entry"));
    };
    Void.prototype.destroy = function() {
      this._destroyed || (this._destroyed = !0, this.emit("close"));
    };
    var Pack = function(opts) {
      if (!(this instanceof Pack))
        return new Pack(opts);
      Readable.call(this, opts), this._drain = noop, this._finalized = !1, this._finalizing = !1, this._destroyed = !1, this._stream = null;
    };
    inherits(Pack, Readable);
    Pack.prototype.entry = function(header2, buffer, callback) {
      if (this._stream)
        throw new Error("already piping an entry");
      if (!(this._finalized || this._destroyed)) {
        typeof buffer == "function" && (callback = buffer, buffer = null), callback || (callback = noop);
        var self2 = this;
        if ((!header2.size || header2.type === "symlink") && (header2.size = 0), header2.type || (header2.type = modeToType(header2.mode)), header2.mode || (header2.mode = header2.type === "directory" ? DMODE : FMODE), header2.uid || (header2.uid = 0), header2.gid || (header2.gid = 0), header2.mtime || (header2.mtime = /* @__PURE__ */ new Date()), typeof buffer == "string" && (buffer = Buffer.from(buffer)), Buffer.isBuffer(buffer)) {
          header2.size = buffer.length, this._encode(header2);
          var ok2 = this.push(buffer);
          return overflow(self2, header2.size), ok2 ? process.nextTick(callback) : this._drain = callback, new Void();
        }
        if (header2.type === "symlink" && !header2.linkname) {
          var linkSink = new LinkSink();
          return eos(linkSink, function(err2) {
            if (err2)
              return self2.destroy(), callback(err2);
            header2.linkname = linkSink.linkname, self2._encode(header2), callback();
          }), linkSink;
        }
        if (this._encode(header2), header2.type !== "file" && header2.type !== "contiguous-file")
          return process.nextTick(callback), new Void();
        var sink = new Sink(this);
        return this._stream = sink, eos(sink, function(err2) {
          if (self2._stream = null, err2)
            return self2.destroy(), callback(err2);
          if (sink.written !== header2.size)
            return self2.destroy(), callback(new Error("size mismatch"));
          overflow(self2, header2.size), self2._finalizing && self2.finalize(), callback();
        }), sink;
      }
    };
    Pack.prototype.finalize = function() {
      if (this._stream) {
        this._finalizing = !0;
        return;
      }
      this._finalized || (this._finalized = !0, this.push(END_OF_TAR), this.push(null));
    };
    Pack.prototype.destroy = function(err2) {
      this._destroyed || (this._destroyed = !0, err2 && this.emit("error", err2), this.emit("close"), this._stream && this._stream.destroy && this._stream.destroy());
    };
    Pack.prototype._encode = function(header2) {
      if (!header2.pax) {
        var buf = headers.encode(header2);
        if (buf) {
          this.push(buf);
          return;
        }
      }
      this._encodePax(header2);
    };
    Pack.prototype._encodePax = function(header2) {
      var paxHeader = headers.encodePax({
        name: header2.name,
        linkname: header2.linkname,
        pax: header2.pax
      }), newHeader = {
        name: "PaxHeader",
        mode: header2.mode,
        uid: header2.uid,
        gid: header2.gid,
        size: paxHeader.length,
        mtime: header2.mtime,
        type: "pax-header",
        linkname: header2.linkname && "PaxHeader",
        uname: header2.uname,
        gname: header2.gname,
        devmajor: header2.devmajor,
        devminor: header2.devminor
      };
      this.push(headers.encode(newHeader)), this.push(paxHeader), overflow(this, paxHeader.length), newHeader.size = header2.size, newHeader.type = header2.type, this.push(headers.encode(newHeader));
    };
    Pack.prototype._read = function(n) {
      var drain = this._drain;
      this._drain = noop, drain();
    };
    module.exports = Pack;
  }
});

// ../../node_modules/.pnpm/tar-stream@2.2.0/node_modules/tar-stream/index.js
var require_tar_stream = __commonJS({
  "../../node_modules/.pnpm/tar-stream@2.2.0/node_modules/tar-stream/index.js"(exports) {
    init_cjs_shims();
    exports.extract = require_extract();
    exports.pack = require_pack();
  }
});

// ../../node_modules/.pnpm/archiver@5.3.2/node_modules/archiver/lib/plugins/tar.js
var require_tar = __commonJS({
  "../../node_modules/.pnpm/archiver@5.3.2/node_modules/archiver/lib/plugins/tar.js"(exports, module) {
    init_cjs_shims();
    var zlib = __require("zlib"), engine = require_tar_stream(), util2 = require_archiver_utils(), Tar = function(options) {
      if (!(this instanceof Tar))
        return new Tar(options);
      options = this.options = util2.defaults(options, {
        gzip: !1
      }), typeof options.gzipOptions != "object" && (options.gzipOptions = {}), this.supports = {
        directory: !0,
        symlink: !0
      }, this.engine = engine.pack(options), this.compressor = !1, options.gzip && (this.compressor = zlib.createGzip(options.gzipOptions), this.compressor.on("error", this._onCompressorError.bind(this)));
    };
    Tar.prototype._onCompressorError = function(err2) {
      this.engine.emit("error", err2);
    };
    Tar.prototype.append = function(source, data, callback) {
      var self2 = this;
      data.mtime = data.date;
      function append(err2, sourceBuffer) {
        if (err2) {
          callback(err2);
          return;
        }
        self2.engine.entry(data, sourceBuffer, function(err3) {
          callback(err3, data);
        });
      }
      if (data.sourceType === "buffer")
        append(null, source);
      else if (data.sourceType === "stream" && data.stats) {
        data.size = data.stats.size;
        var entry = self2.engine.entry(data, function(err2) {
          callback(err2, data);
        });
        source.pipe(entry);
      } else
        data.sourceType === "stream" && util2.collectStream(source, append);
    };
    Tar.prototype.finalize = function() {
      this.engine.finalize();
    };
    Tar.prototype.on = function() {
      return this.engine.on.apply(this.engine, arguments);
    };
    Tar.prototype.pipe = function(destination, options) {
      return this.compressor ? this.engine.pipe.apply(this.engine, [this.compressor]).pipe(destination, options) : this.engine.pipe.apply(this.engine, arguments);
    };
    Tar.prototype.unpipe = function() {
      return this.compressor ? this.compressor.unpipe.apply(this.compressor, arguments) : this.engine.unpipe.apply(this.engine, arguments);
    };
    module.exports = Tar;
  }
});

// ../../node_modules/.pnpm/archiver@5.3.2/node_modules/archiver/lib/plugins/json.js
var require_json3 = __commonJS({
  "../../node_modules/.pnpm/archiver@5.3.2/node_modules/archiver/lib/plugins/json.js"(exports, module) {
    init_cjs_shims();
    var inherits = __require("util").inherits, Transform = require_readable2().Transform, crc32 = require_buffer_crc32(), util2 = require_archiver_utils(), Json = function(options) {
      if (!(this instanceof Json))
        return new Json(options);
      options = this.options = util2.defaults(options, {}), Transform.call(this, options), this.supports = {
        directory: !0,
        symlink: !0
      }, this.files = [];
    };
    inherits(Json, Transform);
    Json.prototype._transform = function(chunk, encoding, callback) {
      callback(null, chunk);
    };
    Json.prototype._writeStringified = function() {
      var fileString = JSON.stringify(this.files);
      this.write(fileString);
    };
    Json.prototype.append = function(source, data, callback) {
      var self2 = this;
      data.crc32 = 0;
      function onend(err2, sourceBuffer) {
        if (err2) {
          callback(err2);
          return;
        }
        data.size = sourceBuffer.length || 0, data.crc32 = crc32.unsigned(sourceBuffer), self2.files.push(data), callback(null, data);
      }
      data.sourceType === "buffer" ? onend(null, source) : data.sourceType === "stream" && util2.collectStream(source, onend);
    };
    Json.prototype.finalize = function() {
      this._writeStringified(), this.end();
    };
    module.exports = Json;
  }
});

// ../../node_modules/.pnpm/archiver@5.3.2/node_modules/archiver/index.js
var require_archiver = __commonJS({
  "../../node_modules/.pnpm/archiver@5.3.2/node_modules/archiver/index.js"(exports, module) {
    init_cjs_shims();
    var Archiver = require_core(), formats2 = {}, vending = function(format4, options) {
      return vending.create(format4, options);
    };
    vending.create = function(format4, options) {
      if (formats2[format4]) {
        var instance = new Archiver(format4, options);
        return instance.setFormat(format4), instance.setModule(new formats2[format4](options)), instance;
      } else
        throw new Error("create(" + format4 + "): format not registered");
    };
    vending.registerFormat = function(format4, module2) {
      if (formats2[format4])
        throw new Error("register(" + format4 + "): format already registered");
      if (typeof module2 != "function")
        throw new Error("register(" + format4 + "): format module invalid");
      if (typeof module2.prototype.append != "function" || typeof module2.prototype.finalize != "function")
        throw new Error("register(" + format4 + "): format module missing methods");
      formats2[format4] = module2;
    };
    vending.isRegisteredFormat = function(format4) {
      return !!formats2[format4];
    };
    vending.registerFormat("zip", require_zip());
    vending.registerFormat("tar", require_tar());
    vending.registerFormat("json", require_json3());
    module.exports = vending;
  }
});

// ../../node_modules/.pnpm/@bugsnag+node@7.23.0/node_modules/@bugsnag/node/dist/bugsnag.js
var require_bugsnag = __commonJS({
  "../../node_modules/.pnpm/@bugsnag+node@7.23.0/node_modules/@bugsnag/node/dist/bugsnag.js"(exports, module) {
    init_cjs_shims();
    (function(f) {
      if (typeof exports == "object" && typeof module < "u")
        module.exports = f();
      else if (typeof define == "function" && define.amd)
        define([], f);
      else {
        var g;
        typeof window < "u" ? g = window : typeof global < "u" ? g = global : typeof self < "u" ? g = self : g = this, g.bugsnag = f();
      }
    })(function() {
      var define2, module2, exports2, Breadcrumb = /* @__PURE__ */ function() {
        function Breadcrumb2(message, metadata2, type, timestamp) {
          timestamp === void 0 && (timestamp = /* @__PURE__ */ new Date()), this.type = type, this.message = message, this.metadata = metadata2, this.timestamp = timestamp;
        }
        var _proto = Breadcrumb2.prototype;
        return _proto.toJSON = function() {
          return {
            type: this.type,
            name: this.message,
            timestamp: this.timestamp,
            metaData: this.metadata
          };
        }, Breadcrumb2;
      }(), _$Breadcrumb_1 = Breadcrumb, _$breadcrumbTypes_6 = ["navigation", "request", "process", "log", "user", "state", "error", "manual"], _$reduce_16 = function(arr, fn, accum) {
        for (var val = accum, i = 0, len = arr.length; i < len; i++)
          val = fn(val, arr[i], i, arr);
        return val;
      }, _$filter_11 = function(arr, fn) {
        return _$reduce_16(arr, function(accum, item, i, arr2) {
          return fn(item, i, arr2) ? accum.concat(item) : accum;
        }, []);
      }, _$includes_12 = function(arr, x) {
        return _$reduce_16(arr, function(accum, item, i, arr2) {
          return accum === !0 || item === x;
        }, !1);
      }, _$isArray_13 = function(obj) {
        return Object.prototype.toString.call(obj) === "[object Array]";
      }, _hasDontEnumBug = !{
        toString: null
      }.propertyIsEnumerable("toString"), _dontEnums = ["toString", "toLocaleString", "valueOf", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "constructor"], _$keys_14 = function(obj) {
        var result = [], prop;
        for (prop in obj)
          Object.prototype.hasOwnProperty.call(obj, prop) && result.push(prop);
        if (!_hasDontEnumBug)
          return result;
        for (var i = 0, len = _dontEnums.length; i < len; i++)
          Object.prototype.hasOwnProperty.call(obj, _dontEnums[i]) && result.push(_dontEnums[i]);
        return result;
      }, _$intRange_25 = function(min, max) {
        return min === void 0 && (min = 1), max === void 0 && (max = 1 / 0), function(value) {
          return typeof value == "number" && parseInt("" + value, 10) === value && value >= min && value <= max;
        };
      }, _$listOfFunctions_26 = function(value) {
        return typeof value == "function" || _$isArray_13(value) && _$filter_11(value, function(f) {
          return typeof f == "function";
        }).length === value.length;
      }, _$stringWithLength_27 = function(value) {
        return typeof value == "string" && !!value.length;
      }, _$config_3 = {}, defaultErrorTypes = function() {
        return {
          unhandledExceptions: !0,
          unhandledRejections: !0
        };
      };
      _$config_3.schema = {
        apiKey: {
          defaultValue: function() {
            return null;
          },
          message: "is required",
          validate: _$stringWithLength_27
        },
        appVersion: {
          defaultValue: function() {
          },
          message: "should be a string",
          validate: function(value) {
            return value === void 0 || _$stringWithLength_27(value);
          }
        },
        appType: {
          defaultValue: function() {
          },
          message: "should be a string",
          validate: function(value) {
            return value === void 0 || _$stringWithLength_27(value);
          }
        },
        autoDetectErrors: {
          defaultValue: function() {
            return !0;
          },
          message: "should be true|false",
          validate: function(value) {
            return value === !0 || value === !1;
          }
        },
        enabledErrorTypes: {
          defaultValue: function() {
            return defaultErrorTypes();
          },
          message: "should be an object containing the flags { unhandledExceptions:true|false, unhandledRejections:true|false }",
          allowPartialObject: !0,
          validate: function(value) {
            if (typeof value != "object" || !value)
              return !1;
            var providedKeys = _$keys_14(value), defaultKeys = _$keys_14(defaultErrorTypes());
            return !(_$filter_11(providedKeys, function(k) {
              return _$includes_12(defaultKeys, k);
            }).length < providedKeys.length || _$filter_11(_$keys_14(value), function(k) {
              return typeof value[k] != "boolean";
            }).length > 0);
          }
        },
        onError: {
          defaultValue: function() {
            return [];
          },
          message: "should be a function or array of functions",
          validate: _$listOfFunctions_26
        },
        onSession: {
          defaultValue: function() {
            return [];
          },
          message: "should be a function or array of functions",
          validate: _$listOfFunctions_26
        },
        onBreadcrumb: {
          defaultValue: function() {
            return [];
          },
          message: "should be a function or array of functions",
          validate: _$listOfFunctions_26
        },
        endpoints: {
          defaultValue: function() {
            return {
              notify: "https://notify.bugsnag.com",
              sessions: "https://sessions.bugsnag.com"
            };
          },
          message: "should be an object containing endpoint URLs { notify, sessions }",
          validate: function(val) {
            return (
              // first, ensure it's an object
              val && typeof val == "object" && // notify and sessions must always be set
              _$stringWithLength_27(val.notify) && _$stringWithLength_27(val.sessions) && // ensure no keys other than notify/session are set on endpoints object
              _$filter_11(_$keys_14(val), function(k) {
                return !_$includes_12(["notify", "sessions"], k);
              }).length === 0
            );
          }
        },
        autoTrackSessions: {
          defaultValue: function(val) {
            return !0;
          },
          message: "should be true|false",
          validate: function(val) {
            return val === !0 || val === !1;
          }
        },
        enabledReleaseStages: {
          defaultValue: function() {
            return null;
          },
          message: "should be an array of strings",
          validate: function(value) {
            return value === null || _$isArray_13(value) && _$filter_11(value, function(f) {
              return typeof f == "string";
            }).length === value.length;
          }
        },
        releaseStage: {
          defaultValue: function() {
            return "production";
          },
          message: "should be a string",
          validate: function(value) {
            return typeof value == "string" && value.length;
          }
        },
        maxBreadcrumbs: {
          defaultValue: function() {
            return 25;
          },
          message: "should be a number \u2264100",
          validate: function(value) {
            return _$intRange_25(0, 100)(value);
          }
        },
        enabledBreadcrumbTypes: {
          defaultValue: function() {
            return _$breadcrumbTypes_6;
          },
          message: "should be null or a list of available breadcrumb types (" + _$breadcrumbTypes_6.join(",") + ")",
          validate: function(value) {
            return value === null || _$isArray_13(value) && _$reduce_16(value, function(accum, maybeType) {
              return accum === !1 ? accum : _$includes_12(_$breadcrumbTypes_6, maybeType);
            }, !0);
          }
        },
        context: {
          defaultValue: function() {
          },
          message: "should be a string",
          validate: function(value) {
            return value === void 0 || typeof value == "string";
          }
        },
        user: {
          defaultValue: function() {
            return {};
          },
          message: "should be an object with { id, email, name } properties",
          validate: function(value) {
            return value === null || value && _$reduce_16(_$keys_14(value), function(accum, key) {
              return accum && _$includes_12(["id", "email", "name"], key);
            }, !0);
          }
        },
        metadata: {
          defaultValue: function() {
            return {};
          },
          message: "should be an object",
          validate: function(value) {
            return typeof value == "object" && value !== null;
          }
        },
        logger: {
          defaultValue: function() {
          },
          message: "should be null or an object with methods { debug, info, warn, error }",
          validate: function(value) {
            return !value || value && _$reduce_16(["debug", "info", "warn", "error"], function(accum, method) {
              return accum && typeof value[method] == "function";
            }, !0);
          }
        },
        redactedKeys: {
          defaultValue: function() {
            return ["password"];
          },
          message: "should be an array of strings|regexes",
          validate: function(value) {
            return _$isArray_13(value) && value.length === _$filter_11(value, function(s) {
              return typeof s == "string" || s && typeof s.test == "function";
            }).length;
          }
        },
        plugins: {
          defaultValue: function() {
            return [];
          },
          message: "should be an array of plugin objects",
          validate: function(value) {
            return _$isArray_13(value) && value.length === _$filter_11(value, function(p) {
              return p && typeof p == "object" && typeof p.load == "function";
            }).length;
          }
        },
        featureFlags: {
          defaultValue: function() {
            return [];
          },
          message: 'should be an array of objects that have a "name" property',
          validate: function(value) {
            return _$isArray_13(value) && value.length === _$filter_11(value, function(feature) {
              return feature && typeof feature == "object" && typeof feature.name == "string";
            }).length;
          }
        }
      };
      var _$errorStackParser_9 = require_error_stack_parser(), _$assign_10 = function(target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];
          for (var key in source)
            Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
        }
        return target;
      }, _$map_15 = function(arr, fn) {
        return _$reduce_16(arr, function(accum, item, i, arr2) {
          return accum.concat(fn(item, i, arr2));
        }, []);
      }, _$safeJsonStringify_31 = function(data, replacer, space, opts) {
        var redactedKeys = opts && opts.redactedKeys ? opts.redactedKeys : [], redactedPaths = opts && opts.redactedPaths ? opts.redactedPaths : [];
        return JSON.stringify(prepareObjForSerialization(data, redactedKeys, redactedPaths), replacer, space);
      }, MAX_DEPTH = 20, MAX_EDGES = 25e3, MIN_PRESERVED_DEPTH = 8, REPLACEMENT_NODE = "...";
      function isError2(o) {
        return o instanceof Error || /^\[object (Error|(Dom)?Exception)\]$/.test(Object.prototype.toString.call(o));
      }
      function throwsMessage(err2) {
        return "[Throws: " + (err2 ? err2.message : "?") + "]";
      }
      function find(haystack, needle) {
        for (var i = 0, len = haystack.length; i < len; i++)
          if (haystack[i] === needle)
            return !0;
        return !1;
      }
      function isDescendent(paths, path4) {
        for (var i = 0, len = paths.length; i < len; i++)
          if (path4.indexOf(paths[i]) === 0)
            return !0;
        return !1;
      }
      function shouldRedact(patterns, key) {
        for (var i = 0, len = patterns.length; i < len; i++)
          if (typeof patterns[i] == "string" && patterns[i].toLowerCase() === key.toLowerCase() || patterns[i] && typeof patterns[i].test == "function" && patterns[i].test(key))
            return !0;
        return !1;
      }
      function __isArray_31(obj) {
        return Object.prototype.toString.call(obj) === "[object Array]";
      }
      function safelyGetProp(obj, prop) {
        try {
          return obj[prop];
        } catch (err2) {
          return throwsMessage(err2);
        }
      }
      function prepareObjForSerialization(obj, redactedKeys, redactedPaths) {
        var seen = [], edges = 0;
        function visit3(obj2, path4) {
          function edgesExceeded() {
            return path4.length > MIN_PRESERVED_DEPTH && edges > MAX_EDGES;
          }
          if (edges++, path4.length > MAX_DEPTH || edgesExceeded())
            return REPLACEMENT_NODE;
          if (obj2 === null || typeof obj2 != "object")
            return obj2;
          if (find(seen, obj2))
            return "[Circular]";
          if (seen.push(obj2), typeof obj2.toJSON == "function")
            try {
              edges--;
              var fResult = visit3(obj2.toJSON(), path4);
              return seen.pop(), fResult;
            } catch (err2) {
              return throwsMessage(err2);
            }
          var er = isError2(obj2);
          if (er) {
            edges--;
            var eResult = visit3({
              name: obj2.name,
              message: obj2.message
            }, path4);
            return seen.pop(), eResult;
          }
          if (__isArray_31(obj2)) {
            for (var aResult = [], i = 0, len = obj2.length; i < len; i++) {
              if (edgesExceeded()) {
                aResult.push(REPLACEMENT_NODE);
                break;
              }
              aResult.push(visit3(obj2[i], path4.concat("[]")));
            }
            return seen.pop(), aResult;
          }
          var result = {};
          try {
            for (var prop in obj2)
              if (Object.prototype.hasOwnProperty.call(obj2, prop)) {
                if (isDescendent(redactedPaths, path4.join(".")) && shouldRedact(redactedKeys, prop)) {
                  result[prop] = "[REDACTED]";
                  continue;
                }
                if (edgesExceeded()) {
                  result[prop] = REPLACEMENT_NODE;
                  break;
                }
                result[prop] = visit3(safelyGetProp(obj2, prop), path4.concat(prop));
              }
          } catch {
          }
          return seen.pop(), result;
        }
        return visit3(obj, []);
      }
      function add(existingFeatures, existingFeatureKeys, name2, variant) {
        if (typeof name2 == "string") {
          variant === void 0 ? variant = null : variant !== null && typeof variant != "string" && (variant = _$safeJsonStringify_31(variant));
          var existingIndex = existingFeatureKeys[name2];
          if (typeof existingIndex == "number") {
            existingFeatures[existingIndex] = {
              name: name2,
              variant
            };
            return;
          }
          existingFeatures.push({
            name: name2,
            variant
          }), existingFeatureKeys[name2] = existingFeatures.length - 1;
        }
      }
      function merge(existingFeatures, newFeatures, existingFeatureKeys) {
        if (_$isArray_13(newFeatures)) {
          for (var i = 0; i < newFeatures.length; ++i) {
            var feature = newFeatures[i];
            feature === null || typeof feature != "object" || add(existingFeatures, existingFeatureKeys, feature.name, feature.variant);
          }
          return existingFeatures;
        }
      }
      function toEventApi(featureFlags) {
        return _$map_15(_$filter_11(featureFlags, Boolean), function(_ref) {
          var name2 = _ref.name, variant = _ref.variant, flag = {
            featureFlag: name2
          };
          return typeof variant == "string" && (flag.variant = variant), flag;
        });
      }
      function clear(features, featuresIndex, name2) {
        var existingIndex = featuresIndex[name2];
        typeof existingIndex == "number" && (features[existingIndex] = null, delete featuresIndex[name2]);
      }
      var _$featureFlagDelegate_17 = {
        add,
        clear,
        merge,
        toEventApi
      }, _$hasStack_18 = function(err2) {
        return !!err2 && (!!err2.stack || !!err2.stacktrace || !!err2["opera#sourceloc"]) && typeof (err2.stack || err2.stacktrace || err2["opera#sourceloc"]) == "string" && err2.stack !== err2.name + ": " + err2.message;
      }, _$iserror_19 = require_iserror(), __add_21 = function(state, section, keyOrObj, maybeVal) {
        var _updates;
        if (section) {
          var updates;
          if (keyOrObj === null)
            return __clear_21(state, section);
          typeof keyOrObj == "object" && (updates = keyOrObj), typeof keyOrObj == "string" && (updates = (_updates = {}, _updates[keyOrObj] = maybeVal, _updates)), updates && (section === "__proto__" || section === "constructor" || section === "prototype" || (state[section] || (state[section] = {}), state[section] = _$assign_10({}, state[section], updates)));
        }
      }, get2 = function(state, section, key) {
        if (typeof section == "string") {
          if (!key)
            return state[section];
          if (state[section])
            return state[section][key];
        }
      }, __clear_21 = function(state, section, key) {
        if (typeof section == "string") {
          if (!key) {
            delete state[section];
            return;
          }
          section === "__proto__" || section === "constructor" || section === "prototype" || state[section] && delete state[section][key];
        }
      }, _$metadataDelegate_21 = {
        add: __add_21,
        get: get2,
        clear: __clear_21
      }, StackGenerator = require_stack_generator(), Event2 = /* @__PURE__ */ function() {
        function Event3(errorClass, errorMessage2, stacktrace, handledState, originalError) {
          stacktrace === void 0 && (stacktrace = []), handledState === void 0 && (handledState = defaultHandledState()), this.apiKey = void 0, this.context = void 0, this.groupingHash = void 0, this.originalError = originalError, this._handledState = handledState, this.severity = this._handledState.severity, this.unhandled = this._handledState.unhandled, this.app = {}, this.device = {}, this.request = {}, this.breadcrumbs = [], this.threads = [], this._metadata = {}, this._features = [], this._featuresIndex = {}, this._user = {}, this._session = void 0, this.errors = [createBugsnagError(errorClass, errorMessage2, Event3.__type, stacktrace)];
        }
        var _proto = Event3.prototype;
        return _proto.addMetadata = function(section, keyOrObj, maybeVal) {
          return _$metadataDelegate_21.add(this._metadata, section, keyOrObj, maybeVal);
        }, _proto.getMetadata = function(section, key) {
          return _$metadataDelegate_21.get(this._metadata, section, key);
        }, _proto.clearMetadata = function(section, key) {
          return _$metadataDelegate_21.clear(this._metadata, section, key);
        }, _proto.addFeatureFlag = function(name2, variant) {
          variant === void 0 && (variant = null), _$featureFlagDelegate_17.add(this._features, this._featuresIndex, name2, variant);
        }, _proto.addFeatureFlags = function(featureFlags) {
          _$featureFlagDelegate_17.merge(this._features, featureFlags, this._featuresIndex);
        }, _proto.getFeatureFlags = function() {
          return _$featureFlagDelegate_17.toEventApi(this._features);
        }, _proto.clearFeatureFlag = function(name2) {
          _$featureFlagDelegate_17.clear(this._features, this._featuresIndex, name2);
        }, _proto.clearFeatureFlags = function() {
          this._features = [], this._featuresIndex = {};
        }, _proto.getUser = function() {
          return this._user;
        }, _proto.setUser = function(id, email, name2) {
          this._user = {
            id,
            email,
            name: name2
          };
        }, _proto.toJSON = function() {
          return {
            payloadVersion: "4",
            exceptions: _$map_15(this.errors, function(er) {
              return _$assign_10({}, er, {
                message: er.errorMessage
              });
            }),
            severity: this.severity,
            unhandled: this._handledState.unhandled,
            severityReason: this._handledState.severityReason,
            app: this.app,
            device: this.device,
            request: this.request,
            breadcrumbs: this.breadcrumbs,
            context: this.context,
            groupingHash: this.groupingHash,
            metaData: this._metadata,
            user: this._user,
            session: this._session,
            featureFlags: this.getFeatureFlags()
          };
        }, Event3;
      }(), formatStackframe = function(frame) {
        var f = {
          file: frame.fileName,
          method: normaliseFunctionName(frame.functionName),
          lineNumber: frame.lineNumber,
          columnNumber: frame.columnNumber,
          code: void 0,
          inProject: void 0
        };
        return f.lineNumber > -1 && !f.file && !f.method && (f.file = "global code"), f;
      }, normaliseFunctionName = function(name2) {
        return /^global code$/i.test(name2) ? "global code" : name2;
      }, defaultHandledState = function() {
        return {
          unhandled: !1,
          severity: "warning",
          severityReason: {
            type: "handledException"
          }
        };
      }, ensureString = function(str) {
        return typeof str == "string" ? str : "";
      };
      function createBugsnagError(errorClass, errorMessage2, type, stacktrace) {
        return {
          errorClass: ensureString(errorClass),
          errorMessage: ensureString(errorMessage2),
          type,
          stacktrace: _$reduce_16(stacktrace, function(accum, frame) {
            var f = formatStackframe(frame);
            try {
              return JSON.stringify(f) === "{}" ? accum : accum.concat(f);
            } catch {
              return accum;
            }
          }, [])
        };
      }
      function getCauseStack(error) {
        return error.cause ? [error].concat(getCauseStack(error.cause)) : [error];
      }
      Event2.getStacktrace = function(error, errorFramesToSkip, backtraceFramesToSkip) {
        if (_$hasStack_18(error))
          return _$errorStackParser_9.parse(error).slice(errorFramesToSkip);
        try {
          return _$filter_11(StackGenerator.backtrace(), function(frame) {
            return (frame.functionName || "").indexOf("StackGenerator$$") === -1;
          }).slice(1 + backtraceFramesToSkip);
        } catch {
          return [];
        }
      }, Event2.create = function(maybeError, tolerateNonErrors, handledState, component, errorFramesToSkip, logger) {
        errorFramesToSkip === void 0 && (errorFramesToSkip = 0);
        var _normaliseError = normaliseError(maybeError, tolerateNonErrors, component, logger), error = _normaliseError[0], internalFrames = _normaliseError[1], event;
        try {
          var stacktrace = Event2.getStacktrace(
            error,
            // if an error was created/throw in the normaliseError() function, we need to
            // tell the getStacktrace() function to skip the number of frames we know will
            // be from our own functions. This is added to the number of frames deep we
            // were told about
            internalFrames > 0 ? 1 + internalFrames + errorFramesToSkip : 0,
            // if there's no stacktrace, the callstack may be walked to generated one.
            // this is how many frames should be removed because they come from our library
            1 + errorFramesToSkip
          );
          event = new Event2(error.name, error.message, stacktrace, handledState, maybeError);
        } catch {
          event = new Event2(error.name, error.message, [], handledState, maybeError);
        }
        if (error.name === "InvalidError" && event.addMetadata("" + component, "non-error parameter", makeSerialisable(maybeError)), error.cause) {
          var _event$errors, causes = getCauseStack(error).slice(1), normalisedCauses = _$map_15(causes, function(cause) {
            var stacktrace2 = _$iserror_19(cause) && _$hasStack_18(cause) ? _$errorStackParser_9.parse(cause) : [], _normaliseError2 = normaliseError(cause, !0, "error cause"), error2 = _normaliseError2[0];
            return error2.name === "InvalidError" && event.addMetadata("error cause", makeSerialisable(cause)), createBugsnagError(error2.name, error2.message, Event2.__type, stacktrace2);
          });
          (_event$errors = event.errors).push.apply(_event$errors, normalisedCauses);
        }
        return event;
      };
      var makeSerialisable = function(err2) {
        return err2 === null ? "null" : err2 === void 0 ? "undefined" : err2;
      }, normaliseError = function(maybeError, tolerateNonErrors, component, logger) {
        var error, internalFrames = 0, createAndLogInputError = function(reason) {
          var verb = component === "error cause" ? "was" : "received";
          logger && logger.warn(component + " " + verb + ' a non-error: "' + reason + '"');
          var err2 = new Error(component + " " + verb + ' a non-error. See "' + component + '" tab for more detail.');
          return err2.name = "InvalidError", err2;
        };
        if (!tolerateNonErrors)
          _$iserror_19(maybeError) ? error = maybeError : (error = createAndLogInputError(typeof maybeError), internalFrames += 2);
        else
          switch (typeof maybeError) {
            case "string":
            case "number":
            case "boolean":
              error = new Error(String(maybeError)), internalFrames += 1;
              break;
            case "function":
              error = createAndLogInputError("function"), internalFrames += 2;
              break;
            case "object":
              maybeError !== null && _$iserror_19(maybeError) ? error = maybeError : maybeError !== null && hasNecessaryFields(maybeError) ? (error = new Error(maybeError.message || maybeError.errorMessage), error.name = maybeError.name || maybeError.errorClass, internalFrames += 1) : (error = createAndLogInputError(maybeError === null ? "null" : "unsupported object"), internalFrames += 2);
              break;
            default:
              error = createAndLogInputError("nothing"), internalFrames += 2;
          }
        if (!_$hasStack_18(error))
          try {
            throw error;
          } catch (e) {
            _$hasStack_18(e) && (error = e, internalFrames = 1);
          }
        return [error, internalFrames];
      };
      Event2.__type = "browserjs";
      var hasNecessaryFields = function(error) {
        return (typeof error.name == "string" || typeof error.errorClass == "string") && (typeof error.message == "string" || typeof error.errorMessage == "string");
      }, _$Event_4 = Event2, _$asyncEvery_5 = function(arr, fn, cb) {
        var index = 0, next = function() {
          if (index >= arr.length)
            return cb(null, !0);
          fn(arr[index], function(err2, result) {
            if (err2)
              return cb(err2);
            if (result === !1)
              return cb(null, !1);
            index++, next();
          });
        };
        next();
      }, _$callbackRunner_7 = function(callbacks, event, onCallbackError, cb) {
        var runMaybeAsyncCallback = function(fn, cb2) {
          if (typeof fn != "function")
            return cb2(null);
          try {
            if (fn.length !== 2) {
              var ret = fn(event);
              return ret && typeof ret.then == "function" ? ret.then(
                // resolve
                function(val) {
                  return setTimeout(function() {
                    return cb2(null, val);
                  });
                },
                // reject
                function(err2) {
                  setTimeout(function() {
                    return onCallbackError(err2), cb2(null, !0);
                  });
                }
              ) : cb2(null, ret);
            }
            fn(event, function(err2, result) {
              if (err2)
                return onCallbackError(err2), cb2(null);
              cb2(null, result);
            });
          } catch (e) {
            onCallbackError(e), cb2(null);
          }
        };
        _$asyncEvery_5(callbacks, runMaybeAsyncCallback, cb);
      }, _$syncCallbackRunner_24 = function(callbacks, callbackArg, callbackType, logger) {
        for (var ignore = !1, cbs = callbacks.slice(); !ignore && cbs.length; )
          try {
            ignore = cbs.pop()(callbackArg) === !1;
          } catch (e) {
            logger.error("Error occurred in " + callbackType + " callback, continuing anyway\u2026"), logger.error(e);
          }
        return ignore;
      }, _$pad_30 = function(num, size) {
        var s = "000000000" + num;
        return s.substr(s.length - size);
      }, os = __require("os"), padding = 2, pid = _$pad_30(process.pid.toString(36), padding), hostname2 = os.hostname(), length = hostname2.length, hostId = _$pad_30(hostname2.split("").reduce(function(prev, char) {
        return +prev + char.charCodeAt(0);
      }, +length + 36).toString(36), padding), _$fingerprint_29 = function() {
        return pid + hostId;
      }, c = 0, blockSize = 4, base = 36, discreteValues = Math.pow(base, blockSize);
      function randomBlock() {
        return _$pad_30((Math.random() * discreteValues << 0).toString(base), blockSize);
      }
      function safeCounter() {
        return c = c < discreteValues ? c : 0, c++, c - 1;
      }
      function cuid() {
        var letter = "c", timestamp = (/* @__PURE__ */ new Date()).getTime().toString(base), counter = _$pad_30(safeCounter().toString(base), blockSize), print = _$fingerprint_29(), random = randomBlock() + randomBlock();
        return letter + timestamp + counter + print + random;
      }
      cuid.fingerprint = _$fingerprint_29;
      var _$cuid_28 = cuid, Session2 = /* @__PURE__ */ function() {
        function Session3() {
          this.id = _$cuid_28(), this.startedAt = /* @__PURE__ */ new Date(), this._handled = 0, this._unhandled = 0, this._user = {}, this.app = {}, this.device = {};
        }
        var _proto = Session3.prototype;
        return _proto.getUser = function() {
          return this._user;
        }, _proto.setUser = function(id, email, name2) {
          this._user = {
            id,
            email,
            name: name2
          };
        }, _proto.toJSON = function() {
          return {
            id: this.id,
            startedAt: this.startedAt,
            events: {
              handled: this._handled,
              unhandled: this._unhandled
            }
          };
        }, _proto._track = function(event) {
          this[event._handledState.unhandled ? "_unhandled" : "_handled"] += 1;
        }, Session3;
      }(), _$Session_32 = Session2, __add_2 = _$featureFlagDelegate_17.add, __clear_2 = _$featureFlagDelegate_17.clear, __merge_2 = _$featureFlagDelegate_17.merge, noop = function() {
      }, Client = /* @__PURE__ */ function() {
        function Client2(configuration, schema2, internalPlugins2, notifier) {
          var _this = this;
          schema2 === void 0 && (schema2 = _$config_3.schema), internalPlugins2 === void 0 && (internalPlugins2 = []), this._notifier = notifier, this._config = {}, this._schema = schema2, this._delivery = {
            sendSession: noop,
            sendEvent: noop
          }, this._logger = {
            debug: noop,
            info: noop,
            warn: noop,
            error: noop
          }, this._plugins = {}, this._breadcrumbs = [], this._session = null, this._metadata = {}, this._featuresIndex = {}, this._features = [], this._context = void 0, this._user = {}, this._cbs = {
            e: [],
            s: [],
            sp: [],
            b: []
          }, this.Client = Client2, this.Event = _$Event_4, this.Breadcrumb = _$Breadcrumb_1, this.Session = _$Session_32, this._config = this._configure(configuration, internalPlugins2), _$map_15(internalPlugins2.concat(this._config.plugins), function(pl) {
            pl && _this._loadPlugin(pl);
          }), this._depth = 1;
          var self2 = this, notify = this.notify;
          this.notify = function() {
            return notify.apply(self2, arguments);
          };
        }
        var _proto = Client2.prototype;
        return _proto.addMetadata = function(section, keyOrObj, maybeVal) {
          return _$metadataDelegate_21.add(this._metadata, section, keyOrObj, maybeVal);
        }, _proto.getMetadata = function(section, key) {
          return _$metadataDelegate_21.get(this._metadata, section, key);
        }, _proto.clearMetadata = function(section, key) {
          return _$metadataDelegate_21.clear(this._metadata, section, key);
        }, _proto.addFeatureFlag = function(name2, variant) {
          variant === void 0 && (variant = null), __add_2(this._features, this._featuresIndex, name2, variant);
        }, _proto.addFeatureFlags = function(featureFlags) {
          __merge_2(this._features, featureFlags, this._featuresIndex);
        }, _proto.clearFeatureFlag = function(name2) {
          __clear_2(this._features, this._featuresIndex, name2);
        }, _proto.clearFeatureFlags = function() {
          this._features = [], this._featuresIndex = {};
        }, _proto.getContext = function() {
          return this._context;
        }, _proto.setContext = function(c2) {
          this._context = c2;
        }, _proto._configure = function(opts, internalPlugins2) {
          var schema2 = _$reduce_16(internalPlugins2, function(schema3, plugin) {
            return plugin && plugin.configSchema ? _$assign_10({}, schema3, plugin.configSchema) : schema3;
          }, this._schema), _reduce = _$reduce_16(_$keys_14(schema2), function(accum, key) {
            var defaultValue = schema2[key].defaultValue(opts[key]);
            if (opts[key] !== void 0) {
              var valid2 = schema2[key].validate(opts[key]);
              valid2 ? schema2[key].allowPartialObject ? accum.config[key] = _$assign_10(defaultValue, opts[key]) : accum.config[key] = opts[key] : (accum.errors[key] = schema2[key].message, accum.config[key] = defaultValue);
            } else
              accum.config[key] = defaultValue;
            return accum;
          }, {
            errors: {},
            config: {}
          }), errors2 = _reduce.errors, config2 = _reduce.config;
          if (schema2.apiKey) {
            if (!config2.apiKey)
              throw new Error("No Bugsnag API Key set");
            /^[0-9a-f]{32}$/i.test(config2.apiKey) || (errors2.apiKey = "should be a string of 32 hexadecimal characters");
          }
          return this._metadata = _$assign_10({}, config2.metadata), __merge_2(this._features, config2.featureFlags, this._featuresIndex), this._user = _$assign_10({}, config2.user), this._context = config2.context, config2.logger && (this._logger = config2.logger), config2.onError && (this._cbs.e = this._cbs.e.concat(config2.onError)), config2.onBreadcrumb && (this._cbs.b = this._cbs.b.concat(config2.onBreadcrumb)), config2.onSession && (this._cbs.s = this._cbs.s.concat(config2.onSession)), _$keys_14(errors2).length && this._logger.warn(generateConfigErrorMessage(errors2, opts)), config2;
        }, _proto.getUser = function() {
          return this._user;
        }, _proto.setUser = function(id, email, name2) {
          this._user = {
            id,
            email,
            name: name2
          };
        }, _proto._loadPlugin = function(plugin) {
          var result = plugin.load(this);
          return plugin.name && (this._plugins["~" + plugin.name + "~"] = result), this;
        }, _proto.getPlugin = function(name2) {
          return this._plugins["~" + name2 + "~"];
        }, _proto._setDelivery = function(d) {
          this._delivery = d(this);
        }, _proto.startSession = function() {
          var session = new _$Session_32();
          session.app.releaseStage = this._config.releaseStage, session.app.version = this._config.appVersion, session.app.type = this._config.appType, session._user = _$assign_10({}, this._user);
          var ignore = _$syncCallbackRunner_24(this._cbs.s, session, "onSession", this._logger);
          return ignore ? (this._logger.debug("Session not started due to onSession callback"), this) : this._sessionDelegate.startSession(this, session);
        }, _proto.addOnError = function(fn, front) {
          front === void 0 && (front = !1), this._cbs.e[front ? "unshift" : "push"](fn);
        }, _proto.removeOnError = function(fn) {
          this._cbs.e = _$filter_11(this._cbs.e, function(f) {
            return f !== fn;
          });
        }, _proto._addOnSessionPayload = function(fn) {
          this._cbs.sp.push(fn);
        }, _proto.addOnSession = function(fn) {
          this._cbs.s.push(fn);
        }, _proto.removeOnSession = function(fn) {
          this._cbs.s = _$filter_11(this._cbs.s, function(f) {
            return f !== fn;
          });
        }, _proto.addOnBreadcrumb = function(fn, front) {
          front === void 0 && (front = !1), this._cbs.b[front ? "unshift" : "push"](fn);
        }, _proto.removeOnBreadcrumb = function(fn) {
          this._cbs.b = _$filter_11(this._cbs.b, function(f) {
            return f !== fn;
          });
        }, _proto.pauseSession = function() {
          return this._sessionDelegate.pauseSession(this);
        }, _proto.resumeSession = function() {
          return this._sessionDelegate.resumeSession(this);
        }, _proto.leaveBreadcrumb = function(message, metadata2, type) {
          if (message = typeof message == "string" ? message : "", type = typeof type == "string" && _$includes_12(_$breadcrumbTypes_6, type) ? type : "manual", metadata2 = typeof metadata2 == "object" && metadata2 !== null ? metadata2 : {}, !!message) {
            var crumb = new _$Breadcrumb_1(message, metadata2, type), ignore = _$syncCallbackRunner_24(this._cbs.b, crumb, "onBreadcrumb", this._logger);
            if (ignore) {
              this._logger.debug("Breadcrumb not attached due to onBreadcrumb callback");
              return;
            }
            this._breadcrumbs.push(crumb), this._breadcrumbs.length > this._config.maxBreadcrumbs && (this._breadcrumbs = this._breadcrumbs.slice(this._breadcrumbs.length - this._config.maxBreadcrumbs));
          }
        }, _proto._isBreadcrumbTypeEnabled = function(type) {
          var types = this._config.enabledBreadcrumbTypes;
          return types === null || _$includes_12(types, type);
        }, _proto.notify = function(maybeError, onError, postReportCallback) {
          postReportCallback === void 0 && (postReportCallback = noop);
          var event = _$Event_4.create(maybeError, !0, void 0, "notify()", this._depth + 1, this._logger);
          this._notify(event, onError, postReportCallback);
        }, _proto._notify = function(event, onError, postReportCallback) {
          var _this2 = this;
          if (postReportCallback === void 0 && (postReportCallback = noop), event.app = _$assign_10({}, event.app, {
            releaseStage: this._config.releaseStage,
            version: this._config.appVersion,
            type: this._config.appType
          }), event.context = event.context || this._context, event._metadata = _$assign_10({}, event._metadata, this._metadata), event._user = _$assign_10({}, event._user, this._user), event.breadcrumbs = this._breadcrumbs.slice(), __merge_2(event._features, this._features, event._featuresIndex), this._config.enabledReleaseStages !== null && !_$includes_12(this._config.enabledReleaseStages, this._config.releaseStage))
            return this._logger.warn("Event not sent due to releaseStage/enabledReleaseStages configuration"), postReportCallback(null, event);
          var originalSeverity = event.severity, onCallbackError = function(err2) {
            _this2._logger.error("Error occurred in onError callback, continuing anyway\u2026"), _this2._logger.error(err2);
          }, callbacks = [].concat(this._cbs.e).concat(onError);
          _$callbackRunner_7(callbacks, event, onCallbackError, function(err2, shouldSend) {
            if (err2 && onCallbackError(err2), !shouldSend)
              return _this2._logger.debug("Event not sent due to onError callback"), postReportCallback(null, event);
            _this2._isBreadcrumbTypeEnabled("error") && Client2.prototype.leaveBreadcrumb.call(_this2, event.errors[0].errorClass, {
              errorClass: event.errors[0].errorClass,
              errorMessage: event.errors[0].errorMessage,
              severity: event.severity
            }, "error"), originalSeverity !== event.severity && (event._handledState.severityReason = {
              type: "userCallbackSetSeverity"
            }), event.unhandled !== event._handledState.unhandled && (event._handledState.severityReason.unhandledOverridden = !0, event._handledState.unhandled = event.unhandled), _this2._session && (_this2._session._track(event), event._session = _this2._session), _this2._delivery.sendEvent({
              apiKey: event.apiKey || _this2._config.apiKey,
              notifier: _this2._notifier,
              events: [event]
            }, function(err3) {
              return postReportCallback(err3, event);
            });
          });
        }, Client2;
      }(), generateConfigErrorMessage = function(errors2, rawInput) {
        var er = new Error(`Invalid configuration
` + _$map_15(_$keys_14(errors2), function(key) {
          return "  - " + key + " " + errors2[key] + ", got " + stringify(rawInput[key]);
        }).join(`

`));
        return er;
      }, stringify = function(val) {
        switch (typeof val) {
          case "string":
          case "number":
          case "object":
            return JSON.stringify(val);
          default:
            return String(val);
        }
      }, _$Client_2 = Client, _$jsonPayload_20 = {}, EVENT_REDACTION_PATHS = ["events.[].metaData", "events.[].breadcrumbs.[].metaData", "events.[].request"];
      _$jsonPayload_20.event = function(event, redactedKeys) {
        var payload = _$safeJsonStringify_31(event, null, null, {
          redactedPaths: EVENT_REDACTION_PATHS,
          redactedKeys
        });
        return payload.length > 1e6 && (event.events[0]._metadata = {
          notifier: `WARNING!
Serialized payload was ` + payload.length / 1e6 + `MB (limit = 1MB)
metadata was removed`
        }, payload = _$safeJsonStringify_31(event, null, null, {
          redactedPaths: EVENT_REDACTION_PATHS,
          redactedKeys
        })), payload;
      }, _$jsonPayload_20.session = function(session, redactedKeys) {
        var payload = _$safeJsonStringify_31(session, null, null);
        return payload;
      };
      var http3 = __require("http"), https = __require("https"), ___require_34 = __require("url"), parse4 = ___require_34.parse, _$request_34 = function(_ref, cb) {
        var url2 = _ref.url, headers = _ref.headers, body = _ref.body, agent = _ref.agent, didError = !1, onError = function(err2) {
          didError || (didError = !0, cb(err2));
        }, parsedUrl = parse4(url2), secure = parsedUrl.protocol === "https:", transport = secure ? https : http3, req = transport.request({
          method: "POST",
          hostname: parsedUrl.hostname,
          port: parsedUrl.port,
          path: parsedUrl.path,
          headers,
          agent
        });
        req.on("error", onError), req.on("response", function(res) {
          bufferResponse(res, function(err2, body2) {
            if (err2)
              return onError(err2);
            if (res.statusCode < 200 || res.statusCode >= 300)
              return onError(new Error("Bad statusCode from API: " + res.statusCode + `
` + body2));
            cb(null, body2);
          });
        }), req.write(body), req.end();
      }, bufferResponse = function(stream2, cb) {
        var data = "";
        stream2.on("error", cb), stream2.setEncoding("utf8"), stream2.on("data", function(d) {
          data += d;
        }), stream2.on("end", function() {
          return cb(null, data);
        });
      }, _$delivery_33 = function(client) {
        return {
          sendEvent: function(event, cb) {
            cb === void 0 && (cb = function() {
            });
            var body = _$jsonPayload_20.event(event, client._config.redactedKeys), _cb = function(err2) {
              err2 && client._logger.error(`Event failed to send\u2026
` + (err2 && err2.stack ? err2.stack : err2), err2), body.length > 1e6 && client._logger.warn("Event oversized (" + (body.length / 1e6).toFixed(2) + " MB)"), cb(err2);
            };
            try {
              _$request_34({
                url: client._config.endpoints.notify,
                headers: {
                  "Content-Type": "application/json",
                  "Bugsnag-Api-Key": event.apiKey || client._config.apiKey,
                  "Bugsnag-Payload-Version": "4",
                  "Bugsnag-Sent-At": (/* @__PURE__ */ new Date()).toISOString()
                },
                body,
                agent: client._config.agent
              }, function(err2, body2) {
                return _cb(err2);
              });
            } catch (e) {
              _cb(e);
            }
          },
          sendSession: function(session, cb) {
            cb === void 0 && (cb = function() {
            });
            var _cb = function(err2) {
              err2 && client._logger.error(`Session failed to send\u2026
` + (err2 && err2.stack ? err2.stack : err2), err2), cb(err2);
            };
            try {
              _$request_34({
                url: client._config.endpoints.sessions,
                headers: {
                  "Content-Type": "application/json",
                  "Bugsnag-Api-Key": client._config.apiKey,
                  "Bugsnag-Payload-Version": "1",
                  "Bugsnag-Sent-At": (/* @__PURE__ */ new Date()).toISOString()
                },
                body: _$jsonPayload_20.session(session, client._config.redactedKeys),
                agent: client._config.agent
              }, function(err2) {
                return _cb(err2);
              });
            } catch (e) {
              _cb(e);
            }
          }
        };
      };
      function _extends() {
        return _extends = Object.assign ? Object.assign.bind() : function(target) {
          for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source)
              Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
          }
          return target;
        }, _extends.apply(this, arguments);
      }
      var schema = _$config_3.schema, __os_35 = __require("os"), _require2 = __require("util"), inspect = _require2.inspect, _$config_35 = {
        appType: _extends({}, schema.appType, {
          defaultValue: function() {
            return "node";
          }
        }),
        projectRoot: {
          defaultValue: function() {
            return process.cwd();
          },
          validate: function(value) {
            return value === null || _$stringWithLength_27(value);
          },
          message: "should be string"
        },
        hostname: {
          defaultValue: function() {
            return __os_35.hostname();
          },
          message: "should be a string",
          validate: function(value) {
            return value === null || _$stringWithLength_27(value);
          }
        },
        logger: _extends({}, schema.logger, {
          defaultValue: function() {
            return getPrefixedConsole();
          }
        }),
        releaseStage: _extends({}, schema.releaseStage, {
          defaultValue: function() {
            return process.env.NODE_ENV || "production";
          }
        }),
        agent: {
          defaultValue: function() {
          },
          message: "should be an HTTP(s) agent",
          validate: function(value) {
            return value === void 0 || isAgent(value);
          }
        },
        onUncaughtException: {
          defaultValue: function() {
            return function(err2, event, logger) {
              logger.error("Uncaught exception" + getContext(event) + `, the process will now terminate\u2026
` + printError(err2)), process.exit(1);
            };
          },
          message: "should be a function",
          validate: function(value) {
            return typeof value == "function";
          }
        },
        onUnhandledRejection: {
          defaultValue: function() {
            return function(err2, event, logger) {
              logger.error("Unhandled rejection" + getContext(event) + `\u2026
` + printError(err2));
            };
          },
          message: "should be a function",
          validate: function(value) {
            return typeof value == "function";
          }
        }
      }, printError = function(err2) {
        return err2 && err2.stack ? err2.stack : inspect(err2);
      }, getPrefixedConsole = function() {
        return ["debug", "info", "warn", "error"].reduce(function(accum, method) {
          var consoleMethod = console[method] || console.log;
          return accum[method] = consoleMethod.bind(console, "[bugsnag]"), accum;
        }, {});
      }, getContext = function(event) {
        return event.request && Object.keys(event.request).length ? " at " + event.request.httpMethod + " " + (event.request.path || event.request.url) : "";
      }, isAgent = function(value) {
        return typeof value == "object" && value !== null || typeof value == "boolean";
      }, appStart = /* @__PURE__ */ new Date(), reset = function() {
        appStart = /* @__PURE__ */ new Date();
      }, _$app_37 = {
        name: "appDuration",
        load: function(client) {
          return client.addOnError(function(event) {
            var now = /* @__PURE__ */ new Date();
            event.app.duration = now - appStart;
          }, !0), {
            reset
          };
        }
      }, _$nodeFallbackStack_22 = {};
      _$nodeFallbackStack_22.getStack = function() {
        return new Error().stack.split(`
`).slice(3).join(`
`);
      }, _$nodeFallbackStack_22.maybeUseFallbackStack = function(err2, fallbackStack) {
        var lines = err2.stack.split(`
`);
        return (lines.length === 1 || lines.length === 2 && /at Error \(native\)/.test(lines[1])) && (err2.stack = lines[0] + `
` + fallbackStack), err2;
      };
      var _$contextualize_38 = {}, domain = __require("domain"), getStack = _$nodeFallbackStack_22.getStack, maybeUseFallbackStack = _$nodeFallbackStack_22.maybeUseFallbackStack;
      _$contextualize_38 = {
        name: "contextualize",
        load: function(client) {
          var contextualize = function(fn, onError) {
            var fallbackStack = getStack(), dom = domain.create();
            dom.on("error", function(err2) {
              err2.stack && maybeUseFallbackStack(err2, fallbackStack);
              var event = client.Event.create(err2, !0, {
                severity: "error",
                unhandled: !0,
                severityReason: {
                  type: "unhandledException"
                }
              }, "contextualize()", 1);
              client._notify(event, onError, function(e, event2) {
                e && client._logger.error("Failed to send event to Bugsnag"), client._config.onUncaughtException(err2, event2, client._logger);
              });
            }), process.nextTick(function() {
              return dom.run(fn);
            });
          };
          return contextualize;
        }
      }, _$contextualize_38.default = _$contextualize_38;
      var _$intercept_39 = {}, __getStack_39 = _$nodeFallbackStack_22.getStack, __maybeUseFallbackStack_39 = _$nodeFallbackStack_22.maybeUseFallbackStack;
      _$intercept_39 = {
        name: "intercept",
        load: function(client) {
          var intercept = function(onError, cb) {
            onError === void 0 && (onError = function() {
            }), typeof cb != "function" && (cb = onError, onError = function() {
            });
            var fallbackStack = __getStack_39();
            return function(err2) {
              if (err2) {
                err2.stack && __maybeUseFallbackStack_39(err2, fallbackStack);
                var event = client.Event.create(err2, !0, {
                  severity: "warning",
                  unhandled: !1,
                  severityReason: {
                    type: "callbackErrorIntercept"
                  }
                }, "intercept()", 1);
                client._notify(event, onError);
                return;
              }
              for (var _len = arguments.length, data = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++)
                data[_key - 1] = arguments[_key];
              cb.apply(void 0, data);
            };
          };
          return intercept;
        }
      }, _$intercept_39.default = _$intercept_39;
      function ___extends_40() {
        return ___extends_40 = Object.assign ? Object.assign.bind() : function(target) {
          for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source)
              Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
          }
          return target;
        }, ___extends_40.apply(this, arguments);
      }
      var __os_40 = __require("os"), _$device_40 = {
        load: function(client) {
          var device = {
            osName: __os_40.platform() + " (" + __os_40.arch() + ")",
            osVersion: __os_40.release(),
            totalMemory: __os_40.totalmem(),
            hostname: client._config.hostname,
            runtimeVersions: {
              node: process.versions.node
            }
          };
          client._addOnSessionPayload(function(sp) {
            sp.device = ___extends_40({}, sp.device, device);
          }), client.addOnError(function(event) {
            event.device = ___extends_40({}, event.device, device, {
              freeMemory: __os_40.freemem(),
              time: /* @__PURE__ */ new Date()
            });
          }, !0);
        }
      }, ___require_23 = __require("path"), join6 = ___require_23.join, resolve2 = ___require_23.resolve, _$pathNormalizer_23 = function(p) {
        return join6(resolve2(p), "/");
      }, _$inProject_41 = {
        load: function(client) {
          return client.addOnError(function(event) {
            if (client._config.projectRoot) {
              var projectRoot = _$pathNormalizer_23(client._config.projectRoot), allFrames = event.errors.reduce(function(accum, er) {
                return accum.concat(er.stacktrace);
              }, []);
              allFrames.map(function(stackframe) {
                stackframe.inProject = typeof stackframe.file == "string" && stackframe.file.indexOf(projectRoot) === 0 && !/\/node_modules\//.test(stackframe.file);
              });
            }
          });
        }
      };
      function ___extends_42() {
        return ___extends_42 = Object.assign ? Object.assign.bind() : function(target) {
          for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source)
              Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
          }
          return target;
        }, ___extends_42.apply(this, arguments);
      }
      function _inheritsLoose(subClass, superClass) {
        subClass.prototype = Object.create(superClass.prototype), subClass.prototype.constructor = subClass, _setPrototypeOf(subClass, superClass);
      }
      function _setPrototypeOf(o, p) {
        return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(o2, p2) {
          return o2.__proto__ = p2, o2;
        }, _setPrototypeOf(o, p);
      }
      var SURROUNDING_LINES = 3, MAX_LINE_LENGTH = 200, ___require_42 = __require("fs"), createReadStream = ___require_42.createReadStream, ___require2_42 = __require("stream"), Writable3 = ___require2_42.Writable, pump = require_pump(), byline = require_byline(), path3 = __require("path"), _$surroundingCode_42 = {
        load: function(client) {
          if (client._config.sendCode) {
            var loadSurroundingCode = function(stackframe, cache2) {
              return new Promise(function(resolve3, reject) {
                try {
                  if (!stackframe.lineNumber || !stackframe.file)
                    return resolve3(stackframe);
                  var file = path3.resolve(client._config.projectRoot, stackframe.file), cacheKey = file + "@" + stackframe.lineNumber;
                  if (cacheKey in cache2)
                    return stackframe.code = cache2[cacheKey], resolve3(stackframe);
                  getSurroundingCode(file, stackframe.lineNumber, function(err2, code) {
                    return err2 || (stackframe.code = cache2[cacheKey] = code), resolve3(stackframe);
                  });
                } catch {
                  return resolve3(stackframe);
                }
              });
            };
            client.addOnError(function(event) {
              return new Promise(function(resolve3, reject) {
                var cache2 = /* @__PURE__ */ Object.create(null), allFrames = event.errors.reduce(function(accum, er) {
                  return accum.concat(er.stacktrace);
                }, []);
                pMapSeries(allFrames.map(function(stackframe) {
                  return function() {
                    return loadSurroundingCode(stackframe, cache2);
                  };
                })).then(resolve3).catch(reject);
              });
            });
          }
        },
        configSchema: {
          sendCode: {
            defaultValue: function() {
              return !0;
            },
            validate: function(value) {
              return value === !0 || value === !1;
            },
            message: "should be true or false"
          }
        }
      }, getSurroundingCode = function(file, lineNumber, cb) {
        var start = lineNumber - SURROUNDING_LINES, end = lineNumber + SURROUNDING_LINES, reader = createReadStream(file, {
          encoding: "utf8"
        }), splitter = new byline.LineStream({
          keepEmptyLines: !0
        }), slicer = new CodeRange({
          start,
          end
        });
        slicer.on("done", function() {
          return reader.destroy();
        }), pump(reader, splitter, slicer, function(err2) {
          if (err2 && err2.message !== "premature close")
            return cb(err2);
          cb(null, slicer.getCode());
        });
      }, CodeRange = /* @__PURE__ */ function(_Writable) {
        _inheritsLoose(CodeRange2, _Writable);
        function CodeRange2(opts) {
          var _this;
          return _this = _Writable.call(this, ___extends_42({}, opts, {
            decodeStrings: !1
          })) || this, _this._start = opts.start, _this._end = opts.end, _this._n = 0, _this._code = {}, _this;
        }
        var _proto = CodeRange2.prototype;
        return _proto._write = function(chunk, enc, cb) {
          return this._n++, this._n < this._start ? cb(null) : this._n <= this._end ? (this._code[String(this._n)] = chunk.length <= MAX_LINE_LENGTH ? chunk : chunk.substr(0, MAX_LINE_LENGTH), cb(null)) : (this.emit("done"), cb(null));
        }, _proto.getCode = function() {
          return this._code;
        }, CodeRange2;
      }(Writable3), pMapSeries = function(ps) {
        return new Promise(function(resolve3, reject) {
          var res = [];
          ps.reduce(function(accum, p) {
            return accum.then(function(r2) {
              return res.push(r2), p();
            });
          }, Promise.resolve()).then(function(r2) {
            res.push(r2);
          }).then(function() {
            resolve3(res.slice(1));
          });
        });
      }, _handler, _$uncaughtException_43 = {
        load: function(client) {
          client._config.autoDetectErrors && client._config.enabledErrorTypes.unhandledExceptions && (_handler = function(err2) {
            var event = client.Event.create(err2, !1, {
              severity: "error",
              unhandled: !0,
              severityReason: {
                type: "unhandledException"
              }
            }, "uncaughtException handler", 1);
            client._notify(event, function() {
            }, function(e, event2) {
              e && client._logger.error("Failed to send event to Bugsnag"), client._config.onUncaughtException(err2, event2, client._logger);
            });
          }, process.on("uncaughtException", _handler));
        },
        destroy: function() {
          process.removeListener("uncaughtException", _handler);
        }
      }, ___handler_44, _$unhandledRejection_44 = {
        load: function(client) {
          !client._config.autoDetectErrors || !client._config.enabledErrorTypes.unhandledRejections || (___handler_44 = function(err2) {
            var event = client.Event.create(err2, !1, {
              severity: "error",
              unhandled: !0,
              severityReason: {
                type: "unhandledPromiseRejection"
              }
            }, "unhandledRejection handler", 1);
            return new Promise(function(resolve3) {
              client._notify(event, function() {
              }, function(e, event2) {
                e && client._logger.error("Failed to send event to Bugsnag"), client._config.onUnhandledRejection(err2, event2, client._logger), resolve3();
              });
            });
          }, process.prependListener ? process.prependListener("unhandledRejection", ___handler_44) : process.on("unhandledRejection", ___handler_44));
        },
        destroy: function() {
          process.removeListener("unhandledRejection", ___handler_44);
        }
      }, _$cloneClient_8 = {}, onCloneCallbacks = [];
      _$cloneClient_8 = function(client) {
        var clone = new client.Client({}, {}, [], client._notifier);
        return clone._config = client._config, clone._breadcrumbs = client._breadcrumbs.slice(), clone._metadata = _$assign_10({}, client._metadata), clone._features = [].concat(client._features), clone._featuresIndex = _$assign_10({}, client._featuresIndex), clone._user = _$assign_10({}, client._user), clone._context = client._context, clone._cbs = {
          e: client._cbs.e.slice(),
          s: client._cbs.s.slice(),
          sp: client._cbs.sp.slice(),
          b: client._cbs.b.slice()
        }, clone._logger = client._logger, clone._delivery = client._delivery, clone._sessionDelegate = client._sessionDelegate, onCloneCallbacks.forEach(function(callback) {
          callback(clone);
        }), clone;
      }, _$cloneClient_8.registerCallback = function(callback) {
        onCloneCallbacks.push(callback);
      };
      var _$Backoff_45 = Backoff;
      function Backoff(opts) {
        opts = opts || {}, this.ms = opts.min || 100, this.max = opts.max || 1e4, this.factor = opts.factor || 2, this.jitter = opts.jitter > 0 && opts.jitter <= 1 ? opts.jitter : 0, this.attempts = 0;
      }
      Backoff.prototype.duration = function() {
        var ms = this.ms * Math.pow(this.factor, this.attempts++);
        if (this.jitter) {
          var rand = Math.random(), deviation = Math.floor(rand * this.jitter * ms);
          ms = Math.floor(rand * 10) & 1 ? ms + deviation : ms - deviation;
        }
        return Math.min(ms, this.max) | 0;
      }, Backoff.prototype.reset = function() {
        this.attempts = 0;
      };
      function _assertThisInitialized(self2) {
        if (self2 === void 0)
          throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        return self2;
      }
      function ___inheritsLoose_47(subClass, superClass) {
        subClass.prototype = Object.create(superClass.prototype), subClass.prototype.constructor = subClass, ___setPrototypeOf_47(subClass, superClass);
      }
      function ___setPrototypeOf_47(o, p) {
        return ___setPrototypeOf_47 = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(o2, p2) {
          return o2.__proto__ = p2, o2;
        }, ___setPrototypeOf_47(o, p);
      }
      var DEFAULT_SUMMARY_INTERVAL = 10 * 1e3, Emitter = __require("events").EventEmitter, _$tracker_47 = /* @__PURE__ */ function(_Emitter) {
        ___inheritsLoose_47(SessionTracker, _Emitter);
        function SessionTracker(intervalLength) {
          var _this;
          return _this = _Emitter.call(this) || this, _this._sessions = /* @__PURE__ */ new Map(), _this._interval = null, _this._intervalLength = intervalLength || DEFAULT_SUMMARY_INTERVAL, _this._summarize = _this._summarize.bind(_assertThisInitialized(_this)), _this;
        }
        var _proto = SessionTracker.prototype;
        return _proto.start = function() {
          this._interval || (this._interval = setInterval(this._summarize, this._intervalLength).unref());
        }, _proto.stop = function() {
          clearInterval(this._interval), this._interval = null;
        }, _proto.track = function(session) {
          var key = dateToMsKey(session.startedAt), cur = this._sessions.get(key);
          return this._sessions.set(key, typeof cur > "u" ? 1 : cur + 1), session;
        }, _proto._summarize = function() {
          var _this2 = this, summary = [];
          this._sessions.forEach(function(val, key) {
            summary.push({
              startedAt: key,
              sessionsStarted: val
            }), _this2._sessions.delete(key);
          }), summary.length && this.emit("summary", summary);
        }, SessionTracker;
      }(Emitter), dateToMsKey = function(d) {
        var dk = new Date(d);
        return dk.setSeconds(0), dk.setMilliseconds(0), dk.toISOString();
      }, _$session_46 = {
        load: function(client) {
          var sessionTracker = new _$tracker_47(client._config.sessionSummaryInterval);
          sessionTracker.on("summary", sendSessionSummary(client)), sessionTracker.start(), client._sessionDelegate = {
            startSession: function(client2, session) {
              var sessionClient = _$cloneClient_8(client2);
              return sessionClient._session = session, sessionClient._pausedSession = null, sessionTracker.track(sessionClient._session), sessionClient;
            },
            pauseSession: function(client2) {
              client2._pausedSession = client2._session, client2._session = null;
            },
            resumeSession: function(client2) {
              return client2._session ? client2 : client2._pausedSession ? (client2._session = client2._pausedSession, client2._pausedSession = null, client2) : client2.startSession();
            }
          };
        },
        configSchema: {
          sessionSummaryInterval: {
            defaultValue: function() {
            },
            validate: function(value) {
              return value === void 0 || _$intRange_25()(value);
            },
            message: "should be a positive integer"
          }
        }
      }, sendSessionSummary = function(client) {
        return function(sessionCounts) {
          if (client._config.enabledReleaseStages !== null && !client._config.enabledReleaseStages.includes(client._config.releaseStage)) {
            client._logger.warn("Session not sent due to releaseStage/enabledReleaseStages configuration");
            return;
          }
          if (!sessionCounts.length)
            return;
          var backoff = new _$Backoff_45({
            min: 1e3,
            max: 1e4
          }), maxAttempts = 10;
          req(handleRes);
          function handleRes(err2) {
            if (!err2) {
              var sessionCount = sessionCounts.reduce(function(accum, s) {
                return accum + s.sessionsStarted;
              }, 0);
              return client._logger.debug(sessionCount + " session(s) reported");
            }
            if (backoff.attempts === 10) {
              client._logger.error("Session delivery failed, max retries exceeded", err2);
              return;
            }
            client._logger.debug("Session delivery failed, retry #" + (backoff.attempts + 1) + "/" + maxAttempts, err2), setTimeout(function() {
              return req(handleRes);
            }, backoff.duration());
          }
          function req(cb) {
            var payload = {
              notifier: client._notifier,
              device: {},
              app: {
                releaseStage: client._config.releaseStage,
                version: client._config.appVersion,
                type: client._config.appType
              },
              sessionCounts
            }, ignore = _$syncCallbackRunner_24(client._cbs.sp, payload, "onSessionPayload", client._logger);
            if (ignore)
              return client._logger.debug("Session not sent due to onSessionPayload callback"), cb(null);
            client._delivery.sendSession(payload, cb);
          }
        };
      }, _$pathNormaliser_48 = {
        load: function(client) {
          client.addOnError(function(event) {
            var allFrames = event.errors.reduce(function(accum, er) {
              return accum.concat(er.stacktrace);
            }, []);
            allFrames.forEach(function(stackframe) {
              typeof stackframe.file == "string" && (stackframe.file = stackframe.file.replace(/\\/g, "/"));
            });
          });
        }
      }, _$stripProjectRoot_49 = {
        load: function(client) {
          return client.addOnError(function(event) {
            if (client._config.projectRoot) {
              var projectRoot = _$pathNormalizer_23(client._config.projectRoot), allFrames = event.errors.reduce(function(accum, er) {
                return accum.concat(er.stacktrace);
              }, []);
              allFrames.map(function(stackframe) {
                typeof stackframe.file == "string" && stackframe.file.indexOf(projectRoot) === 0 && (stackframe.file = stackframe.file.replace(projectRoot, ""));
              });
            }
          });
        }
      }, _$notifier_36 = {};
      function ___extends_36() {
        return ___extends_36 = Object.assign ? Object.assign.bind() : function(target) {
          for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source)
              Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
          }
          return target;
        }, ___extends_36.apply(this, arguments);
      }
      var name = "Bugsnag Node", version2 = "7.23.0", url = "https://github.com/bugsnag/bugsnag-js";
      _$Event_4.__type = "nodejs";
      var __schema_36 = ___extends_36({}, _$config_3.schema, _$config_35);
      delete __schema_36.enabledBreadcrumbTypes;
      var internalPlugins = [_$app_37, _$surroundingCode_42, _$inProject_41, _$stripProjectRoot_49, _$session_46, _$device_40, _$uncaughtException_43, _$unhandledRejection_44, _$intercept_39, _$contextualize_38, _$pathNormaliser_48], Bugsnag2 = {
        _client: null,
        createClient: function(opts) {
          typeof opts == "string" && (opts = {
            apiKey: opts
          }), opts || (opts = {});
          var bugsnag = new _$Client_2(opts, __schema_36, internalPlugins, {
            name,
            version: version2,
            url
          });
          return bugsnag._setDelivery(_$delivery_33), bugsnag._logger.debug("Loaded!"), bugsnag.leaveBreadcrumb = function() {
            bugsnag._logger.warn("Breadcrumbs are not supported in Node.js yet");
          }, bugsnag._config.enabledBreadcrumbTypes = [], bugsnag;
        },
        start: function(opts) {
          return Bugsnag2._client ? (Bugsnag2._client._logger.warn("Bugsnag.start() was called more than once. Ignoring."), Bugsnag2._client) : (Bugsnag2._client = Bugsnag2.createClient(opts), Bugsnag2._client);
        },
        isStarted: function() {
          return Bugsnag2._client != null;
        }
      };
      return Object.keys(_$Client_2.prototype).forEach(function(m) {
        /^_/.test(m) || (Bugsnag2[m] = function() {
          if (!Bugsnag2._client)
            return console.error("Bugsnag." + m + "() was called before Bugsnag.start()");
          Bugsnag2._client._depth += 1;
          var ret = Bugsnag2._client[m].apply(Bugsnag2._client, arguments);
          return Bugsnag2._client._depth -= 1, ret;
        });
      }), _$notifier_36 = Bugsnag2, _$notifier_36.Client = _$Client_2, _$notifier_36.Event = _$Event_4, _$notifier_36.Session = _$Session_32, _$notifier_36.Breadcrumb = _$Breadcrumb_1, _$notifier_36.default = Bugsnag2, _$notifier_36;
    });
  }
});

// ../../node_modules/.pnpm/emoji-regex@10.3.0/node_modules/emoji-regex/index.js
var require_emoji_regex = __commonJS({
  "../../node_modules/.pnpm/emoji-regex@10.3.0/node_modules/emoji-regex/index.js"(exports, module) {
    init_cjs_shims();
    module.exports = () => /[#*0-9]\uFE0F?\u20E3|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26AA\u26B0\u26B1\u26BD\u26BE\u26C4\u26C8\u26CF\u26D1\u26E9\u26F0-\u26F5\u26F7\u26F8\u26FA\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2757\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B55\u3030\u303D\u3297\u3299]\uFE0F?|[\u261D\u270C\u270D](?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?|[\u270A\u270B](?:\uD83C[\uDFFB-\uDFFF])?|[\u23E9-\u23EC\u23F0\u23F3\u25FD\u2693\u26A1\u26AB\u26C5\u26CE\u26D4\u26EA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2795-\u2797\u27B0\u27BF\u2B50]|\u26D3\uFE0F?(?:\u200D\uD83D\uDCA5)?|\u26F9(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|\u2764\uFE0F?(?:\u200D(?:\uD83D\uDD25|\uD83E\uDE79))?|\uD83C(?:[\uDC04\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]\uFE0F?|[\uDF85\uDFC2\uDFC7](?:\uD83C[\uDFFB-\uDFFF])?|[\uDFC4\uDFCA](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDFCB\uDFCC](?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF43\uDF45-\uDF4A\uDF4C-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uDDE6\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF]|\uDDE7\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF]|\uDDE8\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF]|\uDDE9\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF]|\uDDEA\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA]|\uDDEB\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7]|\uDDEC\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE]|\uDDED\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA]|\uDDEE\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9]|\uDDEF\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5]|\uDDF0\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF]|\uDDF1\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE]|\uDDF2\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF]|\uDDF3\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF]|\uDDF4\uD83C\uDDF2|\uDDF5\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE]|\uDDF6\uD83C\uDDE6|\uDDF7\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC]|\uDDF8\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF]|\uDDF9\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF]|\uDDFA\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF]|\uDDFB\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA]|\uDDFC\uD83C[\uDDEB\uDDF8]|\uDDFD\uD83C\uDDF0|\uDDFE\uD83C[\uDDEA\uDDF9]|\uDDFF\uD83C[\uDDE6\uDDF2\uDDFC]|\uDF44(?:\u200D\uD83D\uDFEB)?|\uDF4B(?:\u200D\uD83D\uDFE9)?|\uDFC3(?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D(?:[\u2640\u2642]\uFE0F?(?:\u200D\u27A1\uFE0F?)?|\u27A1\uFE0F?))?|\uDFF3\uFE0F?(?:\u200D(?:\u26A7\uFE0F?|\uD83C\uDF08))?|\uDFF4(?:\u200D\u2620\uFE0F?|\uDB40\uDC67\uDB40\uDC62\uDB40(?:\uDC65\uDB40\uDC6E\uDB40\uDC67|\uDC73\uDB40\uDC63\uDB40\uDC74|\uDC77\uDB40\uDC6C\uDB40\uDC73)\uDB40\uDC7F)?)|\uD83D(?:[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3]\uFE0F?|[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC](?:\uD83C[\uDFFB-\uDFFF])?|[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4\uDEB5](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDD74\uDD90](?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?|[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC25\uDC27-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE41\uDE43\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEDC-\uDEDF\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB\uDFF0]|\uDC08(?:\u200D\u2B1B)?|\uDC15(?:\u200D\uD83E\uDDBA)?|\uDC26(?:\u200D(?:\u2B1B|\uD83D\uDD25))?|\uDC3B(?:\u200D\u2744\uFE0F?)?|\uDC41\uFE0F?(?:\u200D\uD83D\uDDE8\uFE0F?)?|\uDC68(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D(?:[\uDC68\uDC69]\u200D\uD83D(?:\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?)|[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?)|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]))|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFC-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB\uDFFD-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB-\uDFFD\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?\uDC68\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D\uDC68\uD83C[\uDFFB-\uDFFE])))?))?|\uDC69(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:\uDC8B\u200D\uD83D)?[\uDC68\uDC69]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D(?:[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?|\uDC69\u200D\uD83D(?:\uDC66(?:\u200D\uD83D\uDC66)?|\uDC67(?:\u200D\uD83D[\uDC66\uDC67])?))|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]))|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFC-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB\uDFFD-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB-\uDFFD\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D\uD83D(?:[\uDC68\uDC69]|\uDC8B\u200D\uD83D[\uDC68\uDC69])\uD83C[\uDFFB-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83D[\uDC68\uDC69]\uD83C[\uDFFB-\uDFFE])))?))?|\uDC6F(?:\u200D[\u2640\u2642]\uFE0F?)?|\uDD75(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|\uDE2E(?:\u200D\uD83D\uDCA8)?|\uDE35(?:\u200D\uD83D\uDCAB)?|\uDE36(?:\u200D\uD83C\uDF2B\uFE0F?)?|\uDE42(?:\u200D[\u2194\u2195]\uFE0F?)?|\uDEB6(?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D(?:[\u2640\u2642]\uFE0F?(?:\u200D\u27A1\uFE0F?)?|\u27A1\uFE0F?))?)|\uD83E(?:[\uDD0C\uDD0F\uDD18-\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5\uDEC3-\uDEC5\uDEF0\uDEF2-\uDEF8](?:\uD83C[\uDFFB-\uDFFF])?|[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD\uDDCF\uDDD4\uDDD6-\uDDDD](?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDDDE\uDDDF](?:\u200D[\u2640\u2642]\uFE0F?)?|[\uDD0D\uDD0E\uDD10-\uDD17\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCC\uDDD0\uDDE0-\uDDFF\uDE70-\uDE7C\uDE80-\uDE88\uDE90-\uDEBD\uDEBF-\uDEC2\uDECE-\uDEDB\uDEE0-\uDEE8]|\uDD3C(?:\u200D[\u2640\u2642]\uFE0F?|\uD83C[\uDFFB-\uDFFF])?|\uDDCE(?:\uD83C[\uDFFB-\uDFFF])?(?:\u200D(?:[\u2640\u2642]\uFE0F?(?:\u200D\u27A1\uFE0F?)?|\u27A1\uFE0F?))?|\uDDD1(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1|\uDDD1\u200D\uD83E\uDDD2(?:\u200D\uD83E\uDDD2)?|\uDDD2(?:\u200D\uD83E\uDDD2)?))|\uD83C(?:\uDFFB(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFC-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFC(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB\uDFFD-\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFD(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFE(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB-\uDFFD\uDFFF]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?|\uDFFF(?:\u200D(?:[\u2695\u2696\u2708]\uFE0F?|\u2764\uFE0F?\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1\uD83C[\uDFFB-\uDFFE]|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E(?:[\uDDAF\uDDBC\uDDBD](?:\u200D\u27A1\uFE0F?)?|[\uDDB0-\uDDB3]|\uDD1D\u200D\uD83E\uDDD1\uD83C[\uDFFB-\uDFFF])))?))?|\uDEF1(?:\uD83C(?:\uDFFB(?:\u200D\uD83E\uDEF2\uD83C[\uDFFC-\uDFFF])?|\uDFFC(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB\uDFFD-\uDFFF])?|\uDFFD(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])?|\uDFFE(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB-\uDFFD\uDFFF])?|\uDFFF(?:\u200D\uD83E\uDEF2\uD83C[\uDFFB-\uDFFE])?))?)/g;
  }
});

// ../../node_modules/.pnpm/stream-shift@1.0.3/node_modules/stream-shift/index.js
var require_stream_shift = __commonJS({
  "../../node_modules/.pnpm/stream-shift@1.0.3/node_modules/stream-shift/index.js"(exports, module) {
    init_cjs_shims();
    module.exports = shift;
    function shift(stream2) {
      var rs = stream2._readableState;
      return rs ? rs.objectMode || typeof stream2._duplexState == "number" ? stream2.read() : stream2.read(getStateLength(rs)) : null;
    }
    function getStateLength(state) {
      if (state.buffer.length) {
        var idx = state.bufferIndex || 0;
        if (state.buffer.head)
          return state.buffer.head.data.length;
        if (state.buffer.length - idx > 0 && state.buffer[idx])
          return state.buffer[idx].length;
      }
      return state.length;
    }
  }
});

// ../../node_modules/.pnpm/duplexify@3.7.1/node_modules/duplexify/index.js
var require_duplexify = __commonJS({
  "../../node_modules/.pnpm/duplexify@3.7.1/node_modules/duplexify/index.js"(exports, module) {
    init_cjs_shims();
    var stream2 = require_readable(), eos = require_end_of_stream(), inherits = require_inherits(), shift = require_stream_shift(), SIGNAL_FLUSH = Buffer.from && Buffer.from !== Uint8Array.from ? Buffer.from([0]) : new Buffer([0]), onuncork = function(self2, fn) {
      self2._corked ? self2.once("uncork", fn) : fn();
    }, autoDestroy = function(self2, err2) {
      self2._autoDestroy && self2.destroy(err2);
    }, destroyer = function(self2, end2) {
      return function(err2) {
        err2 ? autoDestroy(self2, err2.message === "premature close" ? null : err2) : end2 && !self2._ended && self2.end();
      };
    }, end = function(ws, fn) {
      if (!ws || ws._writableState && ws._writableState.finished)
        return fn();
      if (ws._writableState)
        return ws.end(fn);
      ws.end(), fn();
    }, toStreams2 = function(rs) {
      return new stream2.Readable({ objectMode: !0, highWaterMark: 16 }).wrap(rs);
    }, Duplexify = function(writable, readable, opts) {
      if (!(this instanceof Duplexify))
        return new Duplexify(writable, readable, opts);
      stream2.Duplex.call(this, opts), this._writable = null, this._readable = null, this._readable2 = null, this._autoDestroy = !opts || opts.autoDestroy !== !1, this._forwardDestroy = !opts || opts.destroy !== !1, this._forwardEnd = !opts || opts.end !== !1, this._corked = 1, this._ondrain = null, this._drained = !1, this._forwarding = !1, this._unwrite = null, this._unread = null, this._ended = !1, this.destroyed = !1, writable && this.setWritable(writable), readable && this.setReadable(readable);
    };
    inherits(Duplexify, stream2.Duplex);
    Duplexify.obj = function(writable, readable, opts) {
      return opts || (opts = {}), opts.objectMode = !0, opts.highWaterMark = 16, new Duplexify(writable, readable, opts);
    };
    Duplexify.prototype.cork = function() {
      ++this._corked === 1 && this.emit("cork");
    };
    Duplexify.prototype.uncork = function() {
      this._corked && --this._corked === 0 && this.emit("uncork");
    };
    Duplexify.prototype.setWritable = function(writable) {
      if (this._unwrite && this._unwrite(), this.destroyed) {
        writable && writable.destroy && writable.destroy();
        return;
      }
      if (writable === null || writable === !1) {
        this.end();
        return;
      }
      var self2 = this, unend = eos(writable, { writable: !0, readable: !1 }, destroyer(this, this._forwardEnd)), ondrain = function() {
        var ondrain2 = self2._ondrain;
        self2._ondrain = null, ondrain2 && ondrain2();
      }, clear = function() {
        self2._writable.removeListener("drain", ondrain), unend();
      };
      this._unwrite && process.nextTick(ondrain), this._writable = writable, this._writable.on("drain", ondrain), this._unwrite = clear, this.uncork();
    };
    Duplexify.prototype.setReadable = function(readable) {
      if (this._unread && this._unread(), this.destroyed) {
        readable && readable.destroy && readable.destroy();
        return;
      }
      if (readable === null || readable === !1) {
        this.push(null), this.resume();
        return;
      }
      var self2 = this, unend = eos(readable, { writable: !1, readable: !0 }, destroyer(this)), onreadable = function() {
        self2._forward();
      }, onend = function() {
        self2.push(null);
      }, clear = function() {
        self2._readable2.removeListener("readable", onreadable), self2._readable2.removeListener("end", onend), unend();
      };
      this._drained = !0, this._readable = readable, this._readable2 = readable._readableState ? readable : toStreams2(readable), this._readable2.on("readable", onreadable), this._readable2.on("end", onend), this._unread = clear, this._forward();
    };
    Duplexify.prototype._read = function() {
      this._drained = !0, this._forward();
    };
    Duplexify.prototype._forward = function() {
      if (!(this._forwarding || !this._readable2 || !this._drained)) {
        this._forwarding = !0;
        for (var data; this._drained && (data = shift(this._readable2)) !== null; )
          this.destroyed || (this._drained = this.push(data));
        this._forwarding = !1;
      }
    };
    Duplexify.prototype.destroy = function(err2) {
      if (!this.destroyed) {
        this.destroyed = !0;
        var self2 = this;
        process.nextTick(function() {
          self2._destroy(err2);
        });
      }
    };
    Duplexify.prototype._destroy = function(err2) {
      if (err2) {
        var ondrain = this._ondrain;
        this._ondrain = null, ondrain ? ondrain(err2) : this.emit("error", err2);
      }
      this._forwardDestroy && (this._readable && this._readable.destroy && this._readable.destroy(), this._writable && this._writable.destroy && this._writable.destroy()), this.emit("close");
    };
    Duplexify.prototype._write = function(data, enc, cb) {
      if (this.destroyed)
        return cb();
      if (this._corked)
        return onuncork(this, this._write.bind(this, data, enc, cb));
      if (data === SIGNAL_FLUSH)
        return this._finish(cb);
      if (!this._writable)
        return cb();
      this._writable.write(data) === !1 ? this._ondrain = cb : cb();
    };
    Duplexify.prototype._finish = function(cb) {
      var self2 = this;
      this.emit("preend"), onuncork(this, function() {
        end(self2._forwardEnd && self2._writable, function() {
          self2._writableState.prefinished === !1 && (self2._writableState.prefinished = !0), self2.emit("prefinish"), onuncork(self2, cb);
        });
      });
    };
    Duplexify.prototype.end = function(data, enc, cb) {
      return typeof data == "function" ? this.end(null, null, data) : typeof enc == "function" ? this.end(data, null, enc) : (this._ended = !0, data && this.write(data), this._writableState.ending || this.write(SIGNAL_FLUSH), stream2.Writable.prototype.end.call(this, cb));
    };
    module.exports = Duplexify;
  }
});

// ../../node_modules/.pnpm/xtend@4.0.2/node_modules/xtend/immutable.js
var require_immutable = __commonJS({
  "../../node_modules/.pnpm/xtend@4.0.2/node_modules/xtend/immutable.js"(exports, module) {
    init_cjs_shims();
    module.exports = extend;
    var hasOwnProperty = Object.prototype.hasOwnProperty;
    function extend() {
      for (var target = {}, i = 0; i < arguments.length; i++) {
        var source = arguments[i];
        for (var key in source)
          hasOwnProperty.call(source, key) && (target[key] = source[key]);
      }
      return target;
    }
  }
});

// ../../node_modules/.pnpm/through2@2.0.5/node_modules/through2/through2.js
var require_through2 = __commonJS({
  "../../node_modules/.pnpm/through2@2.0.5/node_modules/through2/through2.js"(exports, module) {
    init_cjs_shims();
    var Transform = require_readable().Transform, inherits = __require("util").inherits, xtend = require_immutable();
    function DestroyableTransform(opts) {
      Transform.call(this, opts), this._destroyed = !1;
    }
    inherits(DestroyableTransform, Transform);
    DestroyableTransform.prototype.destroy = function(err2) {
      if (!this._destroyed) {
        this._destroyed = !0;
        var self2 = this;
        process.nextTick(function() {
          err2 && self2.emit("error", err2), self2.emit("close");
        });
      }
    };
    function noop(chunk, enc, callback) {
      callback(null, chunk);
    }
    function through2(construct) {
      return function(options, transform2, flush) {
        return typeof options == "function" && (flush = transform2, transform2 = options, options = {}), typeof transform2 != "function" && (transform2 = noop), typeof flush != "function" && (flush = null), construct(options, transform2, flush);
      };
    }
    module.exports = through2(function(options, transform2, flush) {
      var t22 = new DestroyableTransform(options);
      return t22._transform = transform2, flush && (t22._flush = flush), t22;
    });
    module.exports.ctor = through2(function(options, transform2, flush) {
      function Through2(override) {
        if (!(this instanceof Through2))
          return new Through2(override);
        this.options = xtend(options, override), DestroyableTransform.call(this, this.options);
      }
      return inherits(Through2, DestroyableTransform), Through2.prototype._transform = transform2, flush && (Through2.prototype._flush = flush), Through2;
    });
    module.exports.obj = through2(function(options, transform2, flush) {
      var t22 = new DestroyableTransform(xtend({ objectMode: !0, highWaterMark: 16 }, options));
      return t22._transform = transform2, flush && (t22._flush = flush), t22;
    });
  }
});

// ../../node_modules/.pnpm/peek-stream@1.1.3/node_modules/peek-stream/index.js
var require_peek_stream = __commonJS({
  "../../node_modules/.pnpm/peek-stream@1.1.3/node_modules/peek-stream/index.js"(exports, module) {
    init_cjs_shims();
    var duplexify = require_duplexify(), through = require_through2(), bufferFrom = require_buffer_from(), isObject4 = function(data) {
      return !Buffer.isBuffer(data) && typeof data != "string";
    }, peek = function(opts, onpeek) {
      if (typeof opts == "number" && (opts = { maxBuffer: opts }), typeof opts == "function")
        return peek(null, opts);
      opts || (opts = {});
      var maxBuffer = typeof opts.maxBuffer == "number" ? opts.maxBuffer : 65535, strict = opts.strict, newline = opts.newline !== !1, buffer = [], bufferSize = 0, dup = duplexify.obj(), peeker = through.obj({ highWaterMark: 1 }, function(data, enc, cb) {
        if (isObject4(data))
          return ready(data, null, cb);
        if (Buffer.isBuffer(data) || (data = bufferFrom(data)), newline) {
          var nl = Array.prototype.indexOf.call(data, 10);
          if (nl > 0 && data[nl - 1] === 13 && nl--, nl > -1)
            return buffer.push(data.slice(0, nl)), ready(Buffer.concat(buffer), data.slice(nl), cb);
        }
        if (buffer.push(data), bufferSize += data.length, bufferSize < maxBuffer)
          return cb();
        if (strict)
          return cb(new Error("No newline found"));
        ready(Buffer.concat(buffer), null, cb);
      }), onpreend = function() {
        if (strict)
          return dup.destroy(new Error("No newline found"));
        dup.cork(), ready(Buffer.concat(buffer), null, function(err2) {
          if (err2)
            return dup.destroy(err2);
          dup.uncork();
        });
      }, ready = function(data, overflow, cb) {
        dup.removeListener("preend", onpreend), onpeek(data, function(err2, parser) {
          if (err2)
            return cb(err2);
          dup.setWritable(parser), dup.setReadable(parser), data && parser.write(data), overflow && parser.write(overflow), overflow = buffer = peeker = null, cb();
        });
      };
      return dup.on("preend", onpreend), dup.setWritable(peeker), dup;
    };
    module.exports = peek;
  }
});

// ../../node_modules/.pnpm/pump@2.0.1/node_modules/pump/index.js
var require_pump2 = __commonJS({
  "../../node_modules/.pnpm/pump@2.0.1/node_modules/pump/index.js"(exports, module) {
    init_cjs_shims();
    var once = require_once(), eos = require_end_of_stream(), fs6 = __require("fs"), noop = function() {
    }, ancient = /^v?\.0/.test(process.version), isFn = function(fn) {
      return typeof fn == "function";
    }, isFS = function(stream2) {
      return !ancient || !fs6 ? !1 : (stream2 instanceof (fs6.ReadStream || noop) || stream2 instanceof (fs6.WriteStream || noop)) && isFn(stream2.close);
    }, isRequest = function(stream2) {
      return stream2.setHeader && isFn(stream2.abort);
    }, destroyer = function(stream2, reading, writing, callback) {
      callback = once(callback);
      var closed = !1;
      stream2.on("close", function() {
        closed = !0;
      }), eos(stream2, { readable: reading, writable: writing }, function(err2) {
        if (err2)
          return callback(err2);
        closed = !0, callback();
      });
      var destroyed = !1;
      return function(err2) {
        if (!closed && !destroyed) {
          if (destroyed = !0, isFS(stream2))
            return stream2.close(noop);
          if (isRequest(stream2))
            return stream2.abort();
          if (isFn(stream2.destroy))
            return stream2.destroy();
          callback(err2 || new Error("stream was destroyed"));
        }
      };
    }, call = function(fn) {
      fn();
    }, pipe = function(from, to) {
      return from.pipe(to);
    }, pump = function() {
      var streams = Array.prototype.slice.call(arguments), callback = isFn(streams[streams.length - 1] || noop) && streams.pop() || noop;
      if (Array.isArray(streams[0]) && (streams = streams[0]), streams.length < 2)
        throw new Error("pump requires two streams per minimum");
      var error, destroys = streams.map(function(stream2, i) {
        var reading = i < streams.length - 1, writing = i > 0;
        return destroyer(stream2, reading, writing, function(err2) {
          error || (error = err2), err2 && destroys.forEach(call), !reading && (destroys.forEach(call), callback(error));
        });
      });
      streams.reduce(pipe);
    };
    module.exports = pump;
  }
});

// ../../node_modules/.pnpm/pumpify@1.5.1/node_modules/pumpify/index.js
var require_pumpify = __commonJS({
  "../../node_modules/.pnpm/pumpify@1.5.1/node_modules/pumpify/index.js"(exports, module) {
    init_cjs_shims();
    var pump = require_pump2(), inherits = require_inherits(), Duplexify = require_duplexify(), toArray = function(args) {
      return args.length ? Array.isArray(args[0]) ? args[0] : Array.prototype.slice.call(args) : [];
    }, define2 = function(opts) {
      var Pumpify = function() {
        var streams = toArray(arguments);
        if (!(this instanceof Pumpify))
          return new Pumpify(streams);
        Duplexify.call(this, null, null, opts), streams.length && this.setPipeline(streams);
      };
      return inherits(Pumpify, Duplexify), Pumpify.prototype.setPipeline = function() {
        var streams = toArray(arguments), self2 = this, ended = !1, w = streams[0], r2 = streams[streams.length - 1];
        r2 = r2.readable ? r2 : null, w = w.writable ? w : null;
        var onclose = function() {
          streams[0].emit("error", new Error("stream was destroyed"));
        };
        if (this.on("close", onclose), this.on("prefinish", function() {
          ended || self2.cork();
        }), pump(streams, function(err2) {
          if (self2.removeListener("close", onclose), err2)
            return self2.destroy(err2.message === "premature close" ? null : err2);
          ended = !0, self2._autoDestroy === !1 && (self2._autoDestroy = !0), self2.uncork();
        }), this.destroyed)
          return onclose();
        this.setWritable(w), this.setReadable(r2);
      }, Pumpify;
    };
    module.exports = define2({ autoDestroy: !1, destroy: !1 });
    module.exports.obj = define2({ autoDestroy: !1, destroy: !1, objectMode: !0, highWaterMark: 16 });
    module.exports.ctor = define2;
  }
});

// ../../node_modules/.pnpm/is-gzip@1.0.0/node_modules/is-gzip/index.js
var require_is_gzip = __commonJS({
  "../../node_modules/.pnpm/is-gzip@1.0.0/node_modules/is-gzip/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = function(buf) {
      return !buf || buf.length < 3 ? !1 : buf[0] === 31 && buf[1] === 139 && buf[2] === 8;
    };
  }
});

// ../../node_modules/.pnpm/is-deflate@1.0.0/node_modules/is-deflate/index.js
var require_is_deflate = __commonJS({
  "../../node_modules/.pnpm/is-deflate@1.0.0/node_modules/is-deflate/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = function(buf) {
      return !buf || buf.length < 2 ? !1 : buf[0] === 120 && (buf[1] === 1 || buf[1] === 156 || buf[1] === 218);
    };
  }
});

// ../../node_modules/.pnpm/gunzip-maybe@1.4.2/node_modules/gunzip-maybe/index.js
var require_gunzip_maybe = __commonJS({
  "../../node_modules/.pnpm/gunzip-maybe@1.4.2/node_modules/gunzip-maybe/index.js"(exports, module) {
    init_cjs_shims();
    var zlib = __require("zlib"), peek = require_peek_stream(), through = require_through2(), pumpify = require_pumpify(), isGzip = require_is_gzip(), isDeflate = require_is_deflate(), isCompressed = function(data) {
      return isGzip(data) ? 1 : isDeflate(data) ? 2 : 0;
    }, gunzip = function(maxRecursion) {
      return maxRecursion === void 0 && (maxRecursion = 3), peek({ newline: !1, maxBuffer: 10 }, function(data, swap) {
        if (maxRecursion < 0)
          return swap(new Error("Maximum recursion reached"));
        switch (isCompressed(data)) {
          case 1:
            swap(null, pumpify(zlib.createGunzip(), gunzip(maxRecursion - 1)));
            break;
          case 2:
            swap(null, pumpify(zlib.createInflate(), gunzip(maxRecursion - 1)));
            break;
          default:
            swap(null, through());
        }
      });
    };
    module.exports = gunzip;
  }
});

// ../../node_modules/.pnpm/chownr@1.1.4/node_modules/chownr/chownr.js
var require_chownr = __commonJS({
  "../../node_modules/.pnpm/chownr@1.1.4/node_modules/chownr/chownr.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var fs6 = __require("fs"), path3 = __require("path"), LCHOWN = fs6.lchown ? "lchown" : "chown", LCHOWNSYNC = fs6.lchownSync ? "lchownSync" : "chownSync", needEISDIRHandled = fs6.lchown && !process.version.match(/v1[1-9]+\./) && !process.version.match(/v10\.[6-9]/), lchownSync = (path4, uid, gid) => {
      try {
        return fs6[LCHOWNSYNC](path4, uid, gid);
      } catch (er) {
        if (er.code !== "ENOENT")
          throw er;
      }
    }, chownSync = (path4, uid, gid) => {
      try {
        return fs6.chownSync(path4, uid, gid);
      } catch (er) {
        if (er.code !== "ENOENT")
          throw er;
      }
    }, handleEISDIR = needEISDIRHandled ? (path4, uid, gid, cb) => (er) => {
      !er || er.code !== "EISDIR" ? cb(er) : fs6.chown(path4, uid, gid, cb);
    } : (_2, __, ___, cb) => cb, handleEISDirSync = needEISDIRHandled ? (path4, uid, gid) => {
      try {
        return lchownSync(path4, uid, gid);
      } catch (er) {
        if (er.code !== "EISDIR")
          throw er;
        chownSync(path4, uid, gid);
      }
    } : (path4, uid, gid) => lchownSync(path4, uid, gid), nodeVersion = process.version, readdir2 = (path4, options, cb) => fs6.readdir(path4, options, cb), readdirSync3 = (path4, options) => fs6.readdirSync(path4, options);
    /^v4\./.test(nodeVersion) && (readdir2 = (path4, options, cb) => fs6.readdir(path4, cb));
    var chown = (cpath, uid, gid, cb) => {
      fs6[LCHOWN](cpath, uid, gid, handleEISDIR(cpath, uid, gid, (er) => {
        cb(er && er.code !== "ENOENT" ? er : null);
      }));
    }, chownrKid = (p, child, uid, gid, cb) => {
      if (typeof child == "string")
        return fs6.lstat(path3.resolve(p, child), (er, stats) => {
          if (er)
            return cb(er.code !== "ENOENT" ? er : null);
          stats.name = child, chownrKid(p, stats, uid, gid, cb);
        });
      if (child.isDirectory())
        chownr(path3.resolve(p, child.name), uid, gid, (er) => {
          if (er)
            return cb(er);
          let cpath = path3.resolve(p, child.name);
          chown(cpath, uid, gid, cb);
        });
      else {
        let cpath = path3.resolve(p, child.name);
        chown(cpath, uid, gid, cb);
      }
    }, chownr = (p, uid, gid, cb) => {
      readdir2(p, { withFileTypes: !0 }, (er, children) => {
        if (er) {
          if (er.code === "ENOENT")
            return cb();
          if (er.code !== "ENOTDIR" && er.code !== "ENOTSUP")
            return cb(er);
        }
        if (er || !children.length)
          return chown(p, uid, gid, cb);
        let len = children.length, errState = null, then = (er2) => {
          if (!errState) {
            if (er2)
              return cb(errState = er2);
            if (--len === 0)
              return chown(p, uid, gid, cb);
          }
        };
        children.forEach((child) => chownrKid(p, child, uid, gid, then));
      });
    }, chownrKidSync = (p, child, uid, gid) => {
      if (typeof child == "string")
        try {
          let stats = fs6.lstatSync(path3.resolve(p, child));
          stats.name = child, child = stats;
        } catch (er) {
          if (er.code === "ENOENT")
            return;
          throw er;
        }
      child.isDirectory() && chownrSync(path3.resolve(p, child.name), uid, gid), handleEISDirSync(path3.resolve(p, child.name), uid, gid);
    }, chownrSync = (p, uid, gid) => {
      let children;
      try {
        children = readdirSync3(p, { withFileTypes: !0 });
      } catch (er) {
        if (er.code === "ENOENT")
          return;
        if (er.code === "ENOTDIR" || er.code === "ENOTSUP")
          return handleEISDirSync(p, uid, gid);
        throw er;
      }
      return children && children.length && children.forEach((child) => chownrKidSync(p, child, uid, gid)), handleEISDirSync(p, uid, gid);
    };
    module.exports = chownr;
    chownr.sync = chownrSync;
  }
});

// ../../node_modules/.pnpm/mkdirp-classic@0.5.3/node_modules/mkdirp-classic/index.js
var require_mkdirp_classic = __commonJS({
  "../../node_modules/.pnpm/mkdirp-classic@0.5.3/node_modules/mkdirp-classic/index.js"(exports, module) {
    init_cjs_shims();
    var path3 = __require("path"), fs6 = __require("fs"), _0777 = parseInt("0777", 8);
    module.exports = mkdirP.mkdirp = mkdirP.mkdirP = mkdirP;
    function mkdirP(p, opts, f, made) {
      typeof opts == "function" ? (f = opts, opts = {}) : (!opts || typeof opts != "object") && (opts = { mode: opts });
      var mode = opts.mode, xfs = opts.fs || fs6;
      mode === void 0 && (mode = _0777 & ~process.umask()), made || (made = null);
      var cb = f || function() {
      };
      p = path3.resolve(p), xfs.mkdir(p, mode, function(er) {
        if (!er)
          return made = made || p, cb(null, made);
        switch (er.code) {
          case "ENOENT":
            mkdirP(path3.dirname(p), opts, function(er2, made2) {
              er2 ? cb(er2, made2) : mkdirP(p, opts, cb, made2);
            });
            break;
          default:
            xfs.stat(p, function(er2, stat) {
              er2 || !stat.isDirectory() ? cb(er, made) : cb(null, made);
            });
            break;
        }
      });
    }
    mkdirP.sync = function sync(p, opts, made) {
      (!opts || typeof opts != "object") && (opts = { mode: opts });
      var mode = opts.mode, xfs = opts.fs || fs6;
      mode === void 0 && (mode = _0777 & ~process.umask()), made || (made = null), p = path3.resolve(p);
      try {
        xfs.mkdirSync(p, mode), made = made || p;
      } catch (err0) {
        switch (err0.code) {
          case "ENOENT":
            made = sync(path3.dirname(p), opts, made), sync(p, opts, made);
            break;
          default:
            var stat;
            try {
              stat = xfs.statSync(p);
            } catch {
              throw err0;
            }
            if (!stat.isDirectory())
              throw err0;
            break;
        }
      }
      return made;
    };
  }
});

// ../../node_modules/.pnpm/tar-fs@2.1.1/node_modules/tar-fs/index.js
var require_tar_fs = __commonJS({
  "../../node_modules/.pnpm/tar-fs@2.1.1/node_modules/tar-fs/index.js"(exports) {
    init_cjs_shims();
    var chownr = require_chownr(), tar = require_tar_stream(), pump = require_pump(), mkdirp = require_mkdirp_classic(), fs6 = __require("fs"), path3 = __require("path"), os = __require("os"), win32 = os.platform() === "win32", noop = function() {
    }, echo = function(name) {
      return name;
    }, normalize = win32 ? function(name) {
      return name.replace(/\\/g, "/").replace(/[:?<>|]/g, "_");
    } : echo, statAll = function(fs7, stat, cwd2, ignore, entries, sort2) {
      var queue = entries || ["."];
      return function(callback) {
        if (!queue.length)
          return callback();
        var next = queue.shift(), nextAbs = path3.join(cwd2, next);
        stat.call(fs7, nextAbs, function(err2, stat2) {
          if (err2)
            return callback(err2);
          if (!stat2.isDirectory())
            return callback(null, next, stat2);
          fs7.readdir(nextAbs, function(err3, files) {
            if (err3)
              return callback(err3);
            sort2 && files.sort();
            for (var i = 0; i < files.length; i++)
              ignore(path3.join(cwd2, next, files[i])) || queue.push(path3.join(next, files[i]));
            callback(null, next, stat2);
          });
        });
      };
    }, strip = function(map, level) {
      return function(header2) {
        header2.name = header2.name.split("/").slice(level).join("/");
        var linkname = header2.linkname;
        return linkname && (header2.type === "link" || path3.isAbsolute(linkname)) && (header2.linkname = linkname.split("/").slice(level).join("/")), map(header2);
      };
    };
    exports.pack = function(cwd2, opts) {
      cwd2 || (cwd2 = "."), opts || (opts = {});
      var xfs = opts.fs || fs6, ignore = opts.ignore || opts.filter || noop, map = opts.map || noop, mapStream = opts.mapStream || echo, statNext = statAll(xfs, opts.dereference ? xfs.stat : xfs.lstat, cwd2, ignore, opts.entries, opts.sort), strict = opts.strict !== !1, umask = typeof opts.umask == "number" ? ~opts.umask : ~processUmask(), dmode = typeof opts.dmode == "number" ? opts.dmode : 0, fmode = typeof opts.fmode == "number" ? opts.fmode : 0, pack = opts.pack || tar.pack(), finish = opts.finish || noop;
      opts.strip && (map = strip(map, opts.strip)), opts.readable && (dmode |= parseInt(555, 8), fmode |= parseInt(444, 8)), opts.writable && (dmode |= parseInt(333, 8), fmode |= parseInt(222, 8));
      var onsymlink = function(filename, header2) {
        xfs.readlink(path3.join(cwd2, filename), function(err2, linkname) {
          if (err2)
            return pack.destroy(err2);
          header2.linkname = normalize(linkname), pack.entry(header2, onnextentry);
        });
      }, onstat = function(err2, filename, stat) {
        if (err2)
          return pack.destroy(err2);
        if (!filename)
          return opts.finalize !== !1 && pack.finalize(), finish(pack);
        if (stat.isSocket())
          return onnextentry();
        var header2 = {
          name: normalize(filename),
          mode: (stat.mode | (stat.isDirectory() ? dmode : fmode)) & umask,
          mtime: stat.mtime,
          size: stat.size,
          type: "file",
          uid: stat.uid,
          gid: stat.gid
        };
        if (stat.isDirectory())
          return header2.size = 0, header2.type = "directory", header2 = map(header2) || header2, pack.entry(header2, onnextentry);
        if (stat.isSymbolicLink())
          return header2.size = 0, header2.type = "symlink", header2 = map(header2) || header2, onsymlink(filename, header2);
        if (header2 = map(header2) || header2, !stat.isFile())
          return strict ? pack.destroy(new Error("unsupported type for " + filename)) : onnextentry();
        var entry = pack.entry(header2, onnextentry);
        if (entry) {
          var rs = mapStream(xfs.createReadStream(path3.join(cwd2, filename), { start: 0, end: header2.size > 0 ? header2.size - 1 : header2.size }), header2);
          rs.on("error", function(err3) {
            entry.destroy(err3);
          }), pump(rs, entry);
        }
      }, onnextentry = function(err2) {
        if (err2)
          return pack.destroy(err2);
        statNext(onstat);
      };
      return onnextentry(), pack;
    };
    var head = function(list2) {
      return list2.length ? list2[list2.length - 1] : null;
    }, processGetuid = function() {
      return process.getuid ? process.getuid() : -1;
    }, processUmask = function() {
      return process.umask ? process.umask() : 0;
    };
    exports.extract = function(cwd2, opts) {
      cwd2 || (cwd2 = "."), opts || (opts = {});
      var xfs = opts.fs || fs6, ignore = opts.ignore || opts.filter || noop, map = opts.map || noop, mapStream = opts.mapStream || echo, own = opts.chown !== !1 && !win32 && processGetuid() === 0, extract2 = opts.extract || tar.extract(), stack = [], now = /* @__PURE__ */ new Date(), umask = typeof opts.umask == "number" ? ~opts.umask : ~processUmask(), dmode = typeof opts.dmode == "number" ? opts.dmode : 0, fmode = typeof opts.fmode == "number" ? opts.fmode : 0, strict = opts.strict !== !1;
      opts.strip && (map = strip(map, opts.strip)), opts.readable && (dmode |= parseInt(555, 8), fmode |= parseInt(444, 8)), opts.writable && (dmode |= parseInt(333, 8), fmode |= parseInt(222, 8));
      var utimesParent = function(name, cb) {
        for (var top; (top = head(stack)) && name.slice(0, top[0].length) !== top[0]; )
          stack.pop();
        if (!top)
          return cb();
        xfs.utimes(top[0], now, top[1], cb);
      }, utimes = function(name, header2, cb) {
        if (opts.utimes === !1)
          return cb();
        if (header2.type === "directory")
          return xfs.utimes(name, now, header2.mtime, cb);
        if (header2.type === "symlink")
          return utimesParent(name, cb);
        xfs.utimes(name, now, header2.mtime, function(err2) {
          if (err2)
            return cb(err2);
          utimesParent(name, cb);
        });
      }, chperm = function(name, header2, cb) {
        var link2 = header2.type === "symlink", chmod2 = link2 ? xfs.lchmod : xfs.chmod, chown = link2 ? xfs.lchown : xfs.chown;
        if (!chmod2)
          return cb();
        var mode = (header2.mode | (header2.type === "directory" ? dmode : fmode)) & umask;
        chown && own ? chown.call(xfs, name, header2.uid, header2.gid, onchown) : onchown(null);
        function onchown(err2) {
          if (err2)
            return cb(err2);
          if (!chmod2)
            return cb();
          chmod2.call(xfs, name, mode, cb);
        }
      };
      return extract2.on("entry", function(header2, stream2, next) {
        header2 = map(header2) || header2, header2.name = normalize(header2.name);
        var name = path3.join(cwd2, path3.join("/", header2.name));
        if (ignore(name, header2))
          return stream2.resume(), next();
        var stat = function(err2) {
          if (err2)
            return next(err2);
          utimes(name, header2, function(err3) {
            if (err3)
              return next(err3);
            if (win32)
              return next();
            chperm(name, header2, next);
          });
        }, onsymlink = function() {
          if (win32)
            return next();
          xfs.unlink(name, function() {
            xfs.symlink(header2.linkname, name, stat);
          });
        }, onlink = function() {
          if (win32)
            return next();
          xfs.unlink(name, function() {
            var srcpath = path3.join(cwd2, path3.join("/", header2.linkname));
            xfs.link(srcpath, name, function(err2) {
              if (err2 && err2.code === "EPERM" && opts.hardlinkAsFilesFallback)
                return stream2 = xfs.createReadStream(srcpath), onfile();
              stat(err2);
            });
          });
        }, onfile = function() {
          var ws = xfs.createWriteStream(name), rs = mapStream(stream2, header2);
          ws.on("error", function(err2) {
            rs.destroy(err2);
          }), pump(rs, ws, function(err2) {
            if (err2)
              return next(err2);
            ws.on("close", stat);
          });
        };
        if (header2.type === "directory")
          return stack.push([name, header2.mtime]), mkdirfix(name, {
            fs: xfs,
            own,
            uid: header2.uid,
            gid: header2.gid
          }, stat);
        var dir = path3.dirname(name);
        validate5(xfs, dir, path3.join(cwd2, "."), function(err2, valid2) {
          if (err2)
            return next(err2);
          if (!valid2)
            return next(new Error(dir + " is not a valid path"));
          mkdirfix(dir, {
            fs: xfs,
            own,
            uid: header2.uid,
            gid: header2.gid
          }, function(err3) {
            if (err3)
              return next(err3);
            switch (header2.type) {
              case "file":
                return onfile();
              case "link":
                return onlink();
              case "symlink":
                return onsymlink();
            }
            if (strict)
              return next(new Error("unsupported type for " + name + " (" + header2.type + ")"));
            stream2.resume(), next();
          });
        });
      }), opts.finish && extract2.on("finish", opts.finish), extract2;
    };
    function validate5(fs7, name, root, cb) {
      if (name === root)
        return cb(null, !0);
      fs7.lstat(name, function(err2, st) {
        if (err2 && err2.code !== "ENOENT")
          return cb(err2);
        if (err2 || st.isDirectory())
          return validate5(fs7, path3.join(name, ".."), root, cb);
        cb(null, !1);
      });
    }
    function mkdirfix(name, opts, cb) {
      mkdirp(name, { fs: opts.fs }, function(err2, made) {
        !err2 && made && opts.own ? chownr(made, opts.uid, opts.gid, cb) : cb(err2);
      });
    }
  }
});

// ../../node_modules/.pnpm/deepmerge@4.3.1/node_modules/deepmerge/dist/cjs.js
var require_cjs2 = __commonJS({
  "../../node_modules/.pnpm/deepmerge@4.3.1/node_modules/deepmerge/dist/cjs.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var isMergeableObject = function(value) {
      return isNonNullObject(value) && !isSpecial(value);
    };
    function isNonNullObject(value) {
      return !!value && typeof value == "object";
    }
    function isSpecial(value) {
      var stringValue = Object.prototype.toString.call(value);
      return stringValue === "[object RegExp]" || stringValue === "[object Date]" || isReactElement(value);
    }
    var canUseSymbol = typeof Symbol == "function" && Symbol.for, REACT_ELEMENT_TYPE = canUseSymbol ? Symbol.for("react.element") : 60103;
    function isReactElement(value) {
      return value.$$typeof === REACT_ELEMENT_TYPE;
    }
    function emptyTarget(val) {
      return Array.isArray(val) ? [] : {};
    }
    function cloneUnlessOtherwiseSpecified(value, options) {
      return options.clone !== !1 && options.isMergeableObject(value) ? deepmerge(emptyTarget(value), value, options) : value;
    }
    function defaultArrayMerge(target, source, options) {
      return target.concat(source).map(function(element) {
        return cloneUnlessOtherwiseSpecified(element, options);
      });
    }
    function getMergeFunction(key, options) {
      if (!options.customMerge)
        return deepmerge;
      var customMerge = options.customMerge(key);
      return typeof customMerge == "function" ? customMerge : deepmerge;
    }
    function getEnumerableOwnPropertySymbols(target) {
      return Object.getOwnPropertySymbols ? Object.getOwnPropertySymbols(target).filter(function(symbol) {
        return Object.propertyIsEnumerable.call(target, symbol);
      }) : [];
    }
    function getKeys(target) {
      return Object.keys(target).concat(getEnumerableOwnPropertySymbols(target));
    }
    function propertyIsOnObject(object, property) {
      try {
        return property in object;
      } catch {
        return !1;
      }
    }
    function propertyIsUnsafe(target, key) {
      return propertyIsOnObject(target, key) && !(Object.hasOwnProperty.call(target, key) && Object.propertyIsEnumerable.call(target, key));
    }
    function mergeObject(target, source, options) {
      var destination = {};
      return options.isMergeableObject(target) && getKeys(target).forEach(function(key) {
        destination[key] = cloneUnlessOtherwiseSpecified(target[key], options);
      }), getKeys(source).forEach(function(key) {
        propertyIsUnsafe(target, key) || (propertyIsOnObject(target, key) && options.isMergeableObject(source[key]) ? destination[key] = getMergeFunction(key, options)(target[key], source[key], options) : destination[key] = cloneUnlessOtherwiseSpecified(source[key], options));
      }), destination;
    }
    function deepmerge(target, source, options) {
      options = options || {}, options.arrayMerge = options.arrayMerge || defaultArrayMerge, options.isMergeableObject = options.isMergeableObject || isMergeableObject, options.cloneUnlessOtherwiseSpecified = cloneUnlessOtherwiseSpecified;
      var sourceIsArray = Array.isArray(source), targetIsArray = Array.isArray(target), sourceAndTargetTypesMatch = sourceIsArray === targetIsArray;
      return sourceAndTargetTypesMatch ? sourceIsArray ? options.arrayMerge(target, source, options) : mergeObject(target, source, options) : cloneUnlessOtherwiseSpecified(source, options);
    }
    deepmerge.all = function(array, options) {
      if (!Array.isArray(array))
        throw new Error("first argument should be an array");
      return array.reduce(function(prev, next) {
        return deepmerge(prev, next, options);
      }, {});
    };
    var deepmerge_1 = deepmerge;
    module.exports = deepmerge_1;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_basePickBy.js
var require_basePickBy = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_basePickBy.js"(exports, module) {
    init_cjs_shims();
    var baseGet = require_baseGet(), baseSet = require_baseSet(), castPath = require_castPath();
    function basePickBy(object, paths, predicate) {
      for (var index = -1, length = paths.length, result = {}; ++index < length; ) {
        var path3 = paths[index], value = baseGet(object, path3);
        predicate(value, path3) && baseSet(result, castPath(path3, object), value);
      }
      return result;
    }
    module.exports = basePickBy;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getPrototype.js
var require_getPrototype = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getPrototype.js"(exports, module) {
    init_cjs_shims();
    var overArg = require_overArg(), getPrototype = overArg(Object.getPrototypeOf, Object);
    module.exports = getPrototype;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getSymbolsIn.js
var require_getSymbolsIn = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getSymbolsIn.js"(exports, module) {
    init_cjs_shims();
    var arrayPush = require_arrayPush(), getPrototype = require_getPrototype(), getSymbols = require_getSymbols(), stubArray = require_stubArray(), nativeGetSymbols = Object.getOwnPropertySymbols, getSymbolsIn = nativeGetSymbols ? function(object) {
      for (var result = []; object; )
        arrayPush(result, getSymbols(object)), object = getPrototype(object);
      return result;
    } : stubArray;
    module.exports = getSymbolsIn;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_nativeKeysIn.js
var require_nativeKeysIn = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_nativeKeysIn.js"(exports, module) {
    init_cjs_shims();
    function nativeKeysIn(object) {
      var result = [];
      if (object != null)
        for (var key in Object(object))
          result.push(key);
      return result;
    }
    module.exports = nativeKeysIn;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseKeysIn.js
var require_baseKeysIn = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseKeysIn.js"(exports, module) {
    init_cjs_shims();
    var isObject4 = require_isObject(), isPrototype = require_isPrototype(), nativeKeysIn = require_nativeKeysIn(), objectProto = Object.prototype, hasOwnProperty = objectProto.hasOwnProperty;
    function baseKeysIn(object) {
      if (!isObject4(object))
        return nativeKeysIn(object);
      var isProto = isPrototype(object), result = [];
      for (var key in object)
        key == "constructor" && (isProto || !hasOwnProperty.call(object, key)) || result.push(key);
      return result;
    }
    module.exports = baseKeysIn;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/keysIn.js
var require_keysIn = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/keysIn.js"(exports, module) {
    init_cjs_shims();
    var arrayLikeKeys = require_arrayLikeKeys(), baseKeysIn = require_baseKeysIn(), isArrayLike = require_isArrayLike();
    function keysIn(object) {
      return isArrayLike(object) ? arrayLikeKeys(object, !0) : baseKeysIn(object);
    }
    module.exports = keysIn;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getAllKeysIn.js
var require_getAllKeysIn = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_getAllKeysIn.js"(exports, module) {
    init_cjs_shims();
    var baseGetAllKeys = require_baseGetAllKeys(), getSymbolsIn = require_getSymbolsIn(), keysIn = require_keysIn();
    function getAllKeysIn(object) {
      return baseGetAllKeys(object, keysIn, getSymbolsIn);
    }
    module.exports = getAllKeysIn;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/pickBy.js
var require_pickBy = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/pickBy.js"(exports, module) {
    init_cjs_shims();
    var arrayMap = require_arrayMap(), baseIteratee = require_baseIteratee(), basePickBy = require_basePickBy(), getAllKeysIn = require_getAllKeysIn();
    function pickBy3(object, predicate) {
      if (object == null)
        return {};
      var props = arrayMap(getAllKeysIn(object), function(prop) {
        return [prop];
      });
      return predicate = baseIteratee(predicate), basePickBy(object, props, function(value, path3) {
        return predicate(value, path3[0]);
      });
    }
    module.exports = pickBy3;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/mapValues.js
var require_mapValues = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/mapValues.js"(exports, module) {
    init_cjs_shims();
    var baseAssignValue = require_baseAssignValue(), baseForOwn = require_baseForOwn(), baseIteratee = require_baseIteratee();
    function mapValues(object, iteratee) {
      var result = {};
      return iteratee = baseIteratee(iteratee, 3), baseForOwn(object, function(value, key, object2) {
        baseAssignValue(result, key, iteratee(value, key, object2));
      }), result;
    }
    module.exports = mapValues;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isEqual.js
var require_isEqual = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isEqual.js"(exports, module) {
    init_cjs_shims();
    var baseIsEqual = require_baseIsEqual();
    function isEqual(value, other) {
      return baseIsEqual(value, other);
    }
    module.exports = isEqual;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/differenceWith.js
var require_differenceWith = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/differenceWith.js"(exports, module) {
    init_cjs_shims();
    var baseDifference = require_baseDifference(), baseFlatten = require_baseFlatten(), baseRest = require_baseRest(), isArrayLikeObject = require_isArrayLikeObject(), last = require_last(), differenceWith2 = baseRest(function(array, values) {
      var comparator = last(values);
      return isArrayLikeObject(comparator) && (comparator = void 0), isArrayLikeObject(array) ? baseDifference(array, baseFlatten(values, 1, isArrayLikeObject, !0), void 0, comparator) : [];
    });
    module.exports = differenceWith2;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/fromPairs.js
var require_fromPairs = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/fromPairs.js"(exports, module) {
    init_cjs_shims();
    function fromPairs2(pairs) {
      for (var index = -1, length = pairs == null ? 0 : pairs.length, result = {}; ++index < length; ) {
        var pair = pairs[index];
        result[pair[0]] = pair[1];
      }
      return result;
    }
    module.exports = fromPairs2;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseToPairs.js
var require_baseToPairs = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseToPairs.js"(exports, module) {
    init_cjs_shims();
    var arrayMap = require_arrayMap();
    function baseToPairs(object, props) {
      return arrayMap(props, function(key) {
        return [key, object[key]];
      });
    }
    module.exports = baseToPairs;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_setToPairs.js
var require_setToPairs = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_setToPairs.js"(exports, module) {
    init_cjs_shims();
    function setToPairs(set2) {
      var index = -1, result = Array(set2.size);
      return set2.forEach(function(value) {
        result[++index] = [value, value];
      }), result;
    }
    module.exports = setToPairs;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_createToPairs.js
var require_createToPairs = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_createToPairs.js"(exports, module) {
    init_cjs_shims();
    var baseToPairs = require_baseToPairs(), getTag = require_getTag(), mapToArray = require_mapToArray(), setToPairs = require_setToPairs(), mapTag = "[object Map]", setTag = "[object Set]";
    function createToPairs(keysFunc) {
      return function(object) {
        var tag = getTag(object);
        return tag == mapTag ? mapToArray(object) : tag == setTag ? setToPairs(object) : baseToPairs(object, keysFunc(object));
      };
    }
    module.exports = createToPairs;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/toPairs.js
var require_toPairs = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/toPairs.js"(exports, module) {
    init_cjs_shims();
    var createToPairs = require_createToPairs(), keys = require_keys(), toPairs2 = createToPairs(keys);
    module.exports = toPairs2;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isEmpty.js
var require_isEmpty = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/isEmpty.js"(exports, module) {
    init_cjs_shims();
    var baseKeys = require_baseKeys(), getTag = require_getTag(), isArguments = require_isArguments(), isArray = require_isArray(), isArrayLike = require_isArrayLike(), isBuffer = require_isBuffer(), isPrototype = require_isPrototype(), isTypedArray = require_isTypedArray(), mapTag = "[object Map]", setTag = "[object Set]", objectProto = Object.prototype, hasOwnProperty = objectProto.hasOwnProperty;
    function isEmpty2(value) {
      if (value == null)
        return !0;
      if (isArrayLike(value) && (isArray(value) || typeof value == "string" || typeof value.splice == "function" || isBuffer(value) || isTypedArray(value) || isArguments(value)))
        return !value.length;
      var tag = getTag(value);
      if (tag == mapTag || tag == setTag)
        return !value.size;
      if (isPrototype(value))
        return !baseKeys(value).length;
      for (var key in value)
        if (hasOwnProperty.call(value, key))
          return !1;
      return !0;
    }
    module.exports = isEmpty2;
  }
});

// ../../node_modules/.pnpm/graphql-tag@2.12.6_graphql@16.8.1/node_modules/graphql-tag/lib/graphql-tag.umd.js
var require_graphql_tag_umd = __commonJS({
  "../../node_modules/.pnpm/graphql-tag@2.12.6_graphql@16.8.1/node_modules/graphql-tag/lib/graphql-tag.umd.js"(exports, module) {
    init_cjs_shims();
    (function(global2, factory) {
      typeof exports == "object" && typeof module < "u" ? factory(exports, (init_tslib_es6(), __toCommonJS(tslib_es6_exports)), require_graphql()) : typeof define == "function" && define.amd ? define(["exports", "tslib", "graphql"], factory) : (global2 = typeof globalThis < "u" ? globalThis : global2 || self, factory(global2["graphql-tag"] = {}, global2.tslib, global2.graphql));
    })(exports, function(exports2, tslib, graphql) {
      "use strict";
      var docCache = /* @__PURE__ */ new Map(), fragmentSourceMap = /* @__PURE__ */ new Map(), printFragmentWarnings = !0, experimentalFragmentVariables = !1;
      function normalize(string) {
        return string.replace(/[\s,]+/g, " ").trim();
      }
      function cacheKeyFromLoc(loc) {
        return normalize(loc.source.body.substring(loc.start, loc.end));
      }
      function processFragments(ast) {
        var seenKeys = /* @__PURE__ */ new Set(), definitions = [];
        return ast.definitions.forEach(function(fragmentDefinition) {
          if (fragmentDefinition.kind === "FragmentDefinition") {
            var fragmentName = fragmentDefinition.name.value, sourceKey = cacheKeyFromLoc(fragmentDefinition.loc), sourceKeySet = fragmentSourceMap.get(fragmentName);
            sourceKeySet && !sourceKeySet.has(sourceKey) ? printFragmentWarnings && console.warn("Warning: fragment with name " + fragmentName + ` already exists.
graphql-tag enforces all fragment names across your application to be unique; read more about
this in the docs: http://dev.apollodata.com/core/fragments.html#unique-names`) : sourceKeySet || fragmentSourceMap.set(fragmentName, sourceKeySet = /* @__PURE__ */ new Set()), sourceKeySet.add(sourceKey), seenKeys.has(sourceKey) || (seenKeys.add(sourceKey), definitions.push(fragmentDefinition));
          } else
            definitions.push(fragmentDefinition);
        }), tslib.__assign(tslib.__assign({}, ast), { definitions });
      }
      function stripLoc(doc) {
        var workSet = new Set(doc.definitions);
        workSet.forEach(function(node) {
          node.loc && delete node.loc, Object.keys(node).forEach(function(key) {
            var value = node[key];
            value && typeof value == "object" && workSet.add(value);
          });
        });
        var loc = doc.loc;
        return loc && (delete loc.startToken, delete loc.endToken), doc;
      }
      function parseDocument(source) {
        var cacheKey = normalize(source);
        if (!docCache.has(cacheKey)) {
          var parsed = graphql.parse(source, {
            experimentalFragmentVariables,
            allowLegacyFragmentVariables: experimentalFragmentVariables
          });
          if (!parsed || parsed.kind !== "Document")
            throw new Error("Not a valid GraphQL document.");
          docCache.set(cacheKey, stripLoc(processFragments(parsed)));
        }
        return docCache.get(cacheKey);
      }
      function gql2(literals) {
        for (var args = [], _i = 1; _i < arguments.length; _i++)
          args[_i - 1] = arguments[_i];
        typeof literals == "string" && (literals = [literals]);
        var result = literals[0];
        return args.forEach(function(arg, i) {
          arg && arg.kind === "Document" ? result += arg.loc.source.body : result += arg, result += literals[i + 1];
        }), parseDocument(result);
      }
      function resetCaches() {
        docCache.clear(), fragmentSourceMap.clear();
      }
      function disableFragmentWarnings() {
        printFragmentWarnings = !1;
      }
      function enableExperimentalFragmentVariables() {
        experimentalFragmentVariables = !0;
      }
      function disableExperimentalFragmentVariables() {
        experimentalFragmentVariables = !1;
      }
      var extras = {
        gql: gql2,
        resetCaches,
        disableFragmentWarnings,
        enableExperimentalFragmentVariables,
        disableExperimentalFragmentVariables
      };
      (function(gql_1) {
        gql_1.gql = extras.gql, gql_1.resetCaches = extras.resetCaches, gql_1.disableFragmentWarnings = extras.disableFragmentWarnings, gql_1.enableExperimentalFragmentVariables = extras.enableExperimentalFragmentVariables, gql_1.disableExperimentalFragmentVariables = extras.disableExperimentalFragmentVariables;
      })(gql2 || (gql2 = {})), gql2.default = gql2;
      var gql$1 = gql2;
      exports2.default = gql$1, exports2.disableExperimentalFragmentVariables = disableExperimentalFragmentVariables, exports2.disableFragmentWarnings = disableFragmentWarnings, exports2.enableExperimentalFragmentVariables = enableExperimentalFragmentVariables, exports2.gql = gql2, exports2.resetCaches = resetCaches, Object.defineProperty(exports2, "__esModule", { value: !0 });
    });
  }
});

// ../../node_modules/.pnpm/graphql-tag@2.12.6_graphql@16.8.1/node_modules/graphql-tag/main.js
var require_main6 = __commonJS({
  "../../node_modules/.pnpm/graphql-tag@2.12.6_graphql@16.8.1/node_modules/graphql-tag/main.js"(exports, module) {
    init_cjs_shims();
    module.exports = require_graphql_tag_umd().gql;
  }
});

// ../../node_modules/.pnpm/@luckycatfactory+esbuild-graphql-loader@3.8.1_esbuild@0.19.8_graphql-tag@2.12.6_graphql@16.8.1/node_modules/@luckycatfactory/esbuild-graphql-loader/lib/index.js
var require_lib6 = __commonJS({
  "../../node_modules/.pnpm/@luckycatfactory+esbuild-graphql-loader@3.8.1_esbuild@0.19.8_graphql-tag@2.12.6_graphql@16.8.1/node_modules/@luckycatfactory/esbuild-graphql-loader/lib/index.js"(exports) {
    init_cjs_shims();
    var __create = Object.create, __defProp = Object.defineProperty, __getProtoOf = Object.getPrototypeOf, __hasOwnProp = Object.prototype.hasOwnProperty, __getOwnPropNames = Object.getOwnPropertyNames, __getOwnPropDesc = Object.getOwnPropertyDescriptor, __markAsModule = (target) => __defProp(target, "__esModule", { value: !0 }), __export2 = (target, all) => {
      __markAsModule(target);
      for (var name in all)
        __defProp(target, name, { get: all[name], enumerable: !0 });
    }, __exportStar = (target, module2, desc) => {
      if (__markAsModule(target), module2 && typeof module2 == "object" || typeof module2 == "function")
        for (let key of __getOwnPropNames(module2))
          !__hasOwnProp.call(target, key) && key !== "default" && __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
      return target;
    }, __toModule = (module2) => module2 && module2.__esModule ? module2 : __exportStar(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", { value: module2, enumerable: !0 }), module2);
    __export2(exports, {
      default: () => src_default2,
      generateContentsFromGraphqlString: () => generateContentsFromGraphqlString,
      generateGraphQLString: () => generateGraphQLString
    });
    var fs6 = __toModule(__require("fs")), graphql_tag = __toModule(require_main6()), readline = __toModule(__require("readline")), path3 = __toModule(__require("path")), generateDocumentNodeString = (graphqlDocument, mapDocumentNode) => {
      let documentNodeToUse = mapDocumentNode ? mapDocumentNode(graphqlDocument) : graphqlDocument;
      return JSON.stringify(documentNodeToUse, (key, value) => value === void 0 ? "__undefined" : value).replace(/"__undefined"/g, "undefined");
    }, topologicallySortParsedFiles = (parsedFiles, cache2) => {
      let visitedFiles = /* @__PURE__ */ new Set(), sorted = [], visitFile = (file) => {
        visitedFiles.has(file) || (visitedFiles.add(file), file.imports.forEach((importFileEntry) => {
          let importedFile = cache2[importFileEntry.absolutePath];
          visitFile(importedFile);
        }), sorted.unshift(file));
      };
      return parsedFiles.forEach(visitFile), sorted;
    }, parseGraphQLFile = (filePath) => new Promise((resolve2) => {
      let readInterface = readline.default.createInterface({
        input: fs6.default.createReadStream(filePath)
      }), body = "", imports = [], hasExhaustedImports = !1, parseImportAndCapture = (importCommentPrefix, line) => {
        let relativePath2 = line.replace(importCommentPrefix, ""), relativePathWithoutQuotations = relativePath2.replace(/"|'/g, ""), absolutePath = path3.default.join(path3.default.dirname(filePath), relativePathWithoutQuotations);
        imports.push({
          absolutePath,
          relativePath: relativePath2
        });
      };
      readInterface.on("line", (line) => {
        line.startsWith("#import ") ? parseImportAndCapture("#import ", line) : line.startsWith("# import ") ? parseImportAndCapture("# import ", line) : hasExhaustedImports ? body += line + `
` : line[0] !== "#" && line !== "" && (hasExhaustedImports = !0, body += line + `
`);
      }), readInterface.on("close", () => {
        resolve2({ body: body.trim(), filePath, imports });
      });
    }), generateGraphQLString = (entryPointPath) => {
      let cache2 = {}, parsePromises = [], seenImportPaths = /* @__PURE__ */ new Set(), visitAndParse = (filePath) => cache2[filePath] ? Promise.resolve(null) : new Promise((resolve2) => {
        parseGraphQLFile(filePath).then((parsedFile) => {
          cache2[parsedFile.filePath] = parsedFile, parsedFile.imports.forEach((importEntry) => {
            seenImportPaths.has(importEntry.absolutePath) || (seenImportPaths.add(importEntry.absolutePath), parsePromises.push(visitAndParse(importEntry.absolutePath)));
          });
          let nextPromise = parsePromises.shift();
          return nextPromise ? nextPromise.then(resolve2) : resolve2(null);
        });
      });
      return visitAndParse(entryPointPath).then(() => topologicallySortParsedFiles(Object.values(cache2), cache2).reduce((accumulator, file) => file.body + `

` + accumulator, ""));
    }, generateDocumentNodeStringForOperationDefinition = (operationDefinition, fragments, mapDocumentNode) => {
      let operationDocument = {
        kind: "Document",
        definitions: [operationDefinition, ...fragments]
      };
      return generateDocumentNodeString(operationDocument, mapDocumentNode);
    }, collectAllFragmentDefinitions = (documentNode) => ((nodes, accumulator) => (nodes.forEach((node) => {
      node.kind === "FragmentDefinition" && (accumulator[node.name.value] = node);
    }), accumulator))(documentNode.definitions, {}), collectAllFragmentReferences = (node, allFragments) => {
      let references = [], handleSelectionNode = (selection) => {
        if (selection.kind === "FragmentSpread") {
          let fragment = allFragments[selection.name.value], innerFragmentReferences = collectAllFragmentReferences(fragment, allFragments);
          references.push(...innerFragmentReferences, selection.name.value);
        }
      };
      return node.kind === "OperationDefinition" ? node.selectionSet.selections.forEach((selection) => {
        var _a38;
        selection.kind === "Field" && ((_a38 = selection.selectionSet) == null || _a38.selections.forEach(handleSelectionNode));
      }) : node.selectionSet.selections.forEach(handleSelectionNode), references;
    }, generateContentsFromGraphqlString = (graphqlString, mapDocumentNode) => {
      let graphqlDocument = graphql_tag.default(graphqlString), documentNodeAsString = generateDocumentNodeString(graphqlDocument, mapDocumentNode), allFragments = collectAllFragmentDefinitions(graphqlDocument), lines = graphqlDocument.definitions.reduce((accumulator, definition) => {
        if (definition.kind === "OperationDefinition" && definition.name && definition.name.value) {
          let name = definition.name.value, fragments = collectAllFragmentReferences(definition, allFragments).map((fragmentForOperation) => {
            let fragment = allFragments[fragmentForOperation];
            if (!fragment)
              throw new Error(`Expected to find fragment definition for ${fragmentForOperation}`);
            return fragment;
          }), operationDocumentString = generateDocumentNodeStringForOperationDefinition(definition, fragments, mapDocumentNode);
          accumulator.push(`export const ${name} = ${operationDocumentString};`);
        }
        return accumulator;
      }, [`const documentNode = ${documentNodeAsString};`]);
      return lines.push("export default documentNode;"), lines.join(`
`);
    }, graphqlLoaderPlugin2 = (options = {}) => ({
      name: "graphql-loader",
      setup(build2) {
        build2.onLoad({ filter: options.filterRegex || /\.graphql$|\.gql$/ }, (args) => generateGraphQLString(args.path).then((graphqlString) => ({
          contents: generateContentsFromGraphqlString(graphqlString, options.mapDocumentNode)
        })));
      }
    }), src_default2 = graphqlLoaderPlugin2;
  }
});

// ../../node_modules/.pnpm/retry@0.12.0/node_modules/retry/lib/retry_operation.js
var require_retry_operation = __commonJS({
  "../../node_modules/.pnpm/retry@0.12.0/node_modules/retry/lib/retry_operation.js"(exports, module) {
    init_cjs_shims();
    function RetryOperation(timeouts, options) {
      typeof options == "boolean" && (options = { forever: options }), this._originalTimeouts = JSON.parse(JSON.stringify(timeouts)), this._timeouts = timeouts, this._options = options || {}, this._maxRetryTime = options && options.maxRetryTime || 1 / 0, this._fn = null, this._errors = [], this._attempts = 1, this._operationTimeout = null, this._operationTimeoutCb = null, this._timeout = null, this._operationStart = null, this._options.forever && (this._cachedTimeouts = this._timeouts.slice(0));
    }
    module.exports = RetryOperation;
    RetryOperation.prototype.reset = function() {
      this._attempts = 1, this._timeouts = this._originalTimeouts;
    };
    RetryOperation.prototype.stop = function() {
      this._timeout && clearTimeout(this._timeout), this._timeouts = [], this._cachedTimeouts = null;
    };
    RetryOperation.prototype.retry = function(err2) {
      if (this._timeout && clearTimeout(this._timeout), !err2)
        return !1;
      var currentTime = (/* @__PURE__ */ new Date()).getTime();
      if (err2 && currentTime - this._operationStart >= this._maxRetryTime)
        return this._errors.unshift(new Error("RetryOperation timeout occurred")), !1;
      this._errors.push(err2);
      var timeout = this._timeouts.shift();
      if (timeout === void 0)
        if (this._cachedTimeouts)
          this._errors.splice(this._errors.length - 1, this._errors.length), this._timeouts = this._cachedTimeouts.slice(0), timeout = this._timeouts.shift();
        else
          return !1;
      var self2 = this, timer = setTimeout(function() {
        self2._attempts++, self2._operationTimeoutCb && (self2._timeout = setTimeout(function() {
          self2._operationTimeoutCb(self2._attempts);
        }, self2._operationTimeout), self2._options.unref && self2._timeout.unref()), self2._fn(self2._attempts);
      }, timeout);
      return this._options.unref && timer.unref(), !0;
    };
    RetryOperation.prototype.attempt = function(fn, timeoutOps) {
      this._fn = fn, timeoutOps && (timeoutOps.timeout && (this._operationTimeout = timeoutOps.timeout), timeoutOps.cb && (this._operationTimeoutCb = timeoutOps.cb));
      var self2 = this;
      this._operationTimeoutCb && (this._timeout = setTimeout(function() {
        self2._operationTimeoutCb();
      }, self2._operationTimeout)), this._operationStart = (/* @__PURE__ */ new Date()).getTime(), this._fn(this._attempts);
    };
    RetryOperation.prototype.try = function(fn) {
      console.log("Using RetryOperation.try() is deprecated"), this.attempt(fn);
    };
    RetryOperation.prototype.start = function(fn) {
      console.log("Using RetryOperation.start() is deprecated"), this.attempt(fn);
    };
    RetryOperation.prototype.start = RetryOperation.prototype.try;
    RetryOperation.prototype.errors = function() {
      return this._errors;
    };
    RetryOperation.prototype.attempts = function() {
      return this._attempts;
    };
    RetryOperation.prototype.mainError = function() {
      if (this._errors.length === 0)
        return null;
      for (var counts = {}, mainError = null, mainErrorCount = 0, i = 0; i < this._errors.length; i++) {
        var error = this._errors[i], message = error.message, count = (counts[message] || 0) + 1;
        counts[message] = count, count >= mainErrorCount && (mainError = error, mainErrorCount = count);
      }
      return mainError;
    };
  }
});

// ../../node_modules/.pnpm/retry@0.12.0/node_modules/retry/lib/retry.js
var require_retry = __commonJS({
  "../../node_modules/.pnpm/retry@0.12.0/node_modules/retry/lib/retry.js"(exports) {
    init_cjs_shims();
    var RetryOperation = require_retry_operation();
    exports.operation = function(options) {
      var timeouts = exports.timeouts(options);
      return new RetryOperation(timeouts, {
        forever: options && options.forever,
        unref: options && options.unref,
        maxRetryTime: options && options.maxRetryTime
      });
    };
    exports.timeouts = function(options) {
      if (options instanceof Array)
        return [].concat(options);
      var opts = {
        retries: 10,
        factor: 2,
        minTimeout: 1 * 1e3,
        maxTimeout: 1 / 0,
        randomize: !1
      };
      for (var key in options)
        opts[key] = options[key];
      if (opts.minTimeout > opts.maxTimeout)
        throw new Error("minTimeout is greater than maxTimeout");
      for (var timeouts = [], i = 0; i < opts.retries; i++)
        timeouts.push(this.createTimeout(i, opts));
      return options && options.forever && !timeouts.length && timeouts.push(this.createTimeout(i, opts)), timeouts.sort(function(a, b) {
        return a - b;
      }), timeouts;
    };
    exports.createTimeout = function(attempt, opts) {
      var random = opts.randomize ? Math.random() + 1 : 1, timeout = Math.round(random * opts.minTimeout * Math.pow(opts.factor, attempt));
      return timeout = Math.min(timeout, opts.maxTimeout), timeout;
    };
    exports.wrap = function(obj, options, methods) {
      if (options instanceof Array && (methods = options, options = null), !methods) {
        methods = [];
        for (var key in obj)
          typeof obj[key] == "function" && methods.push(key);
      }
      for (var i = 0; i < methods.length; i++) {
        var method = methods[i], original = obj[method];
        obj[method] = function(original2) {
          var op = exports.operation(options), args = Array.prototype.slice.call(arguments, 1), callback = args.pop();
          args.push(function(err2) {
            op.retry(err2) || (err2 && (arguments[0] = op.mainError()), callback.apply(this, arguments));
          }), op.attempt(function() {
            original2.apply(obj, args);
          });
        }.bind(obj, original), obj[method].options = options;
      }
    };
  }
});

// ../../node_modules/.pnpm/retry@0.12.0/node_modules/retry/index.js
var require_retry2 = __commonJS({
  "../../node_modules/.pnpm/retry@0.12.0/node_modules/retry/index.js"(exports, module) {
    init_cjs_shims();
    module.exports = require_retry();
  }
});

// ../../node_modules/.pnpm/proper-lockfile@4.1.2/node_modules/proper-lockfile/lib/mtime-precision.js
var require_mtime_precision = __commonJS({
  "../../node_modules/.pnpm/proper-lockfile@4.1.2/node_modules/proper-lockfile/lib/mtime-precision.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var cacheSymbol = Symbol();
    function probe(file, fs6, callback) {
      let cachedPrecision = fs6[cacheSymbol];
      if (cachedPrecision)
        return fs6.stat(file, (err2, stat) => {
          if (err2)
            return callback(err2);
          callback(null, stat.mtime, cachedPrecision);
        });
      let mtime = new Date(Math.ceil(Date.now() / 1e3) * 1e3 + 5);
      fs6.utimes(file, mtime, mtime, (err2) => {
        if (err2)
          return callback(err2);
        fs6.stat(file, (err3, stat) => {
          if (err3)
            return callback(err3);
          let precision = stat.mtime.getTime() % 1e3 === 0 ? "s" : "ms";
          Object.defineProperty(fs6, cacheSymbol, { value: precision }), callback(null, stat.mtime, precision);
        });
      });
    }
    function getMtime(precision) {
      let now = Date.now();
      return precision === "s" && (now = Math.ceil(now / 1e3) * 1e3), new Date(now);
    }
    module.exports.probe = probe;
    module.exports.getMtime = getMtime;
  }
});

// ../../node_modules/.pnpm/proper-lockfile@4.1.2/node_modules/proper-lockfile/lib/lockfile.js
var require_lockfile = __commonJS({
  "../../node_modules/.pnpm/proper-lockfile@4.1.2/node_modules/proper-lockfile/lib/lockfile.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var path3 = __require("path"), fs6 = require_graceful_fs(), retry = require_retry2(), onExit = require_signal_exit(), mtimePrecision = require_mtime_precision(), locks = {};
    function getLockFile(file, options) {
      return options.lockfilePath || `${file}.lock`;
    }
    function resolveCanonicalPath(file, options, callback) {
      if (!options.realpath)
        return callback(null, path3.resolve(file));
      options.fs.realpath(file, callback);
    }
    function acquireLock(file, options, callback) {
      let lockfilePath = getLockFile(file, options);
      options.fs.mkdir(lockfilePath, (err2) => {
        if (!err2)
          return mtimePrecision.probe(lockfilePath, options.fs, (err3, mtime, mtimePrecision2) => {
            if (err3)
              return options.fs.rmdir(lockfilePath, () => {
              }), callback(err3);
            callback(null, mtime, mtimePrecision2);
          });
        if (err2.code !== "EEXIST")
          return callback(err2);
        if (options.stale <= 0)
          return callback(Object.assign(new Error("Lock file is already being held"), { code: "ELOCKED", file }));
        options.fs.stat(lockfilePath, (err3, stat) => {
          if (err3)
            return err3.code === "ENOENT" ? acquireLock(file, { ...options, stale: 0 }, callback) : callback(err3);
          if (!isLockStale(stat, options))
            return callback(Object.assign(new Error("Lock file is already being held"), { code: "ELOCKED", file }));
          removeLock(file, options, (err4) => {
            if (err4)
              return callback(err4);
            acquireLock(file, { ...options, stale: 0 }, callback);
          });
        });
      });
    }
    function isLockStale(stat, options) {
      return stat.mtime.getTime() < Date.now() - options.stale;
    }
    function removeLock(file, options, callback) {
      options.fs.rmdir(getLockFile(file, options), (err2) => {
        if (err2 && err2.code !== "ENOENT")
          return callback(err2);
        callback();
      });
    }
    function updateLock(file, options) {
      let lock2 = locks[file];
      lock2.updateTimeout || (lock2.updateDelay = lock2.updateDelay || options.update, lock2.updateTimeout = setTimeout(() => {
        lock2.updateTimeout = null, options.fs.stat(lock2.lockfilePath, (err2, stat) => {
          let isOverThreshold = lock2.lastUpdate + options.stale < Date.now();
          if (err2)
            return err2.code === "ENOENT" || isOverThreshold ? setLockAsCompromised(file, lock2, Object.assign(err2, { code: "ECOMPROMISED" })) : (lock2.updateDelay = 1e3, updateLock(file, options));
          if (!(lock2.mtime.getTime() === stat.mtime.getTime()))
            return setLockAsCompromised(
              file,
              lock2,
              Object.assign(
                new Error("Unable to update lock within the stale threshold"),
                { code: "ECOMPROMISED" }
              )
            );
          let mtime = mtimePrecision.getMtime(lock2.mtimePrecision);
          options.fs.utimes(lock2.lockfilePath, mtime, mtime, (err3) => {
            let isOverThreshold2 = lock2.lastUpdate + options.stale < Date.now();
            if (!lock2.released) {
              if (err3)
                return err3.code === "ENOENT" || isOverThreshold2 ? setLockAsCompromised(file, lock2, Object.assign(err3, { code: "ECOMPROMISED" })) : (lock2.updateDelay = 1e3, updateLock(file, options));
              lock2.mtime = mtime, lock2.lastUpdate = Date.now(), lock2.updateDelay = null, updateLock(file, options);
            }
          });
        });
      }, lock2.updateDelay), lock2.updateTimeout.unref && lock2.updateTimeout.unref());
    }
    function setLockAsCompromised(file, lock2, err2) {
      lock2.released = !0, lock2.updateTimeout && clearTimeout(lock2.updateTimeout), locks[file] === lock2 && delete locks[file], lock2.options.onCompromised(err2);
    }
    function lock(file, options, callback) {
      options = {
        stale: 1e4,
        update: null,
        realpath: !0,
        retries: 0,
        fs: fs6,
        onCompromised: (err2) => {
          throw err2;
        },
        ...options
      }, options.retries = options.retries || 0, options.retries = typeof options.retries == "number" ? { retries: options.retries } : options.retries, options.stale = Math.max(options.stale || 0, 2e3), options.update = options.update == null ? options.stale / 2 : options.update || 0, options.update = Math.max(Math.min(options.update, options.stale / 2), 1e3), resolveCanonicalPath(file, options, (err2, file2) => {
        if (err2)
          return callback(err2);
        let operation = retry.operation(options.retries);
        operation.attempt(() => {
          acquireLock(file2, options, (err3, mtime, mtimePrecision2) => {
            if (operation.retry(err3))
              return;
            if (err3)
              return callback(operation.mainError());
            let lock2 = locks[file2] = {
              lockfilePath: getLockFile(file2, options),
              mtime,
              mtimePrecision: mtimePrecision2,
              options,
              lastUpdate: Date.now()
            };
            updateLock(file2, options), callback(null, (releasedCallback) => {
              if (lock2.released)
                return releasedCallback && releasedCallback(Object.assign(new Error("Lock is already released"), { code: "ERELEASED" }));
              unlock(file2, { ...options, realpath: !1 }, releasedCallback);
            });
          });
        });
      });
    }
    function unlock(file, options, callback) {
      options = {
        fs: fs6,
        realpath: !0,
        ...options
      }, resolveCanonicalPath(file, options, (err2, file2) => {
        if (err2)
          return callback(err2);
        let lock2 = locks[file2];
        if (!lock2)
          return callback(Object.assign(new Error("Lock is not acquired/owned by you"), { code: "ENOTACQUIRED" }));
        lock2.updateTimeout && clearTimeout(lock2.updateTimeout), lock2.released = !0, delete locks[file2], removeLock(file2, options, callback);
      });
    }
    function check2(file, options, callback) {
      options = {
        stale: 1e4,
        realpath: !0,
        fs: fs6,
        ...options
      }, options.stale = Math.max(options.stale || 0, 2e3), resolveCanonicalPath(file, options, (err2, file2) => {
        if (err2)
          return callback(err2);
        options.fs.stat(getLockFile(file2, options), (err3, stat) => err3 ? err3.code === "ENOENT" ? callback(null, !1) : callback(err3) : callback(null, !isLockStale(stat, options)));
      });
    }
    function getLocks() {
      return locks;
    }
    onExit(() => {
      for (let file in locks) {
        let options = locks[file].options;
        try {
          options.fs.rmdirSync(getLockFile(file, options));
        } catch {
        }
      }
    });
    module.exports.lock = lock;
    module.exports.unlock = unlock;
    module.exports.check = check2;
    module.exports.getLocks = getLocks;
  }
});

// ../../node_modules/.pnpm/proper-lockfile@4.1.2/node_modules/proper-lockfile/lib/adapter.js
var require_adapter = __commonJS({
  "../../node_modules/.pnpm/proper-lockfile@4.1.2/node_modules/proper-lockfile/lib/adapter.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var fs6 = require_graceful_fs();
    function createSyncFs(fs7) {
      let methods = ["mkdir", "realpath", "stat", "rmdir", "utimes"], newFs = { ...fs7 };
      return methods.forEach((method) => {
        newFs[method] = (...args) => {
          let callback = args.pop(), ret;
          try {
            ret = fs7[`${method}Sync`](...args);
          } catch (err2) {
            return callback(err2);
          }
          callback(null, ret);
        };
      }), newFs;
    }
    function toPromise(method) {
      return (...args) => new Promise((resolve2, reject) => {
        args.push((err2, result) => {
          err2 ? reject(err2) : resolve2(result);
        }), method(...args);
      });
    }
    function toSync(method) {
      return (...args) => {
        let err2, result;
        if (args.push((_err, _result) => {
          err2 = _err, result = _result;
        }), method(...args), err2)
          throw err2;
        return result;
      };
    }
    function toSyncOptions(options) {
      if (options = { ...options }, options.fs = createSyncFs(options.fs || fs6), typeof options.retries == "number" && options.retries > 0 || options.retries && typeof options.retries.retries == "number" && options.retries.retries > 0)
        throw Object.assign(new Error("Cannot use retries with the sync api"), { code: "ESYNC" });
      return options;
    }
    module.exports = {
      toPromise,
      toSync,
      toSyncOptions
    };
  }
});

// ../../node_modules/.pnpm/proper-lockfile@4.1.2/node_modules/proper-lockfile/index.js
var require_proper_lockfile = __commonJS({
  "../../node_modules/.pnpm/proper-lockfile@4.1.2/node_modules/proper-lockfile/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var lockfile2 = require_lockfile(), { toPromise, toSync, toSyncOptions } = require_adapter();
    async function lock(file, options) {
      let release2 = await toPromise(lockfile2.lock)(file, options);
      return toPromise(release2);
    }
    function lockSync(file, options) {
      let release2 = toSync(lockfile2.lock)(file, toSyncOptions(options));
      return toSync(release2);
    }
    function unlock(file, options) {
      return toPromise(lockfile2.unlock)(file, options);
    }
    function unlockSync(file, options) {
      return toSync(lockfile2.unlock)(file, toSyncOptions(options));
    }
    function check2(file, options) {
      return toPromise(lockfile2.check)(file, options);
    }
    function checkSync(file, options) {
      return toSync(lockfile2.check)(file, toSyncOptions(options));
    }
    module.exports = lock;
    module.exports.lock = lock;
    module.exports.unlock = unlock;
    module.exports.lockSync = lockSync;
    module.exports.unlockSync = unlockSync;
    module.exports.check = check2;
    module.exports.checkSync = checkSync;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arrayAggregator.js
var require_arrayAggregator = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_arrayAggregator.js"(exports, module) {
    init_cjs_shims();
    function arrayAggregator(array, setter, iteratee, accumulator) {
      for (var index = -1, length = array == null ? 0 : array.length; ++index < length; ) {
        var value = array[index];
        setter(accumulator, value, iteratee(value), array);
      }
      return accumulator;
    }
    module.exports = arrayAggregator;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseAggregator.js
var require_baseAggregator = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_baseAggregator.js"(exports, module) {
    init_cjs_shims();
    var baseEach = require_baseEach();
    function baseAggregator(collection, setter, iteratee, accumulator) {
      return baseEach(collection, function(value, key, collection2) {
        setter(accumulator, value, iteratee(value), collection2);
      }), accumulator;
    }
    module.exports = baseAggregator;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_createAggregator.js
var require_createAggregator = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/_createAggregator.js"(exports, module) {
    init_cjs_shims();
    var arrayAggregator = require_arrayAggregator(), baseAggregator = require_baseAggregator(), baseIteratee = require_baseIteratee(), isArray = require_isArray();
    function createAggregator(setter, initializer) {
      return function(collection, iteratee) {
        var func = isArray(collection) ? arrayAggregator : baseAggregator, accumulator = initializer ? initializer() : {};
        return func(collection, setter, baseIteratee(iteratee, 2), accumulator);
      };
    }
    module.exports = createAggregator;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/groupBy.js
var require_groupBy = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/groupBy.js"(exports, module) {
    init_cjs_shims();
    var baseAssignValue = require_baseAssignValue(), createAggregator = require_createAggregator(), objectProto = Object.prototype, hasOwnProperty = objectProto.hasOwnProperty, groupBy2 = createAggregator(function(result, value, key) {
      hasOwnProperty.call(result, key) ? result[key].push(value) : baseAssignValue(result, key, [value]);
    });
    module.exports = groupBy2;
  }
});

// ../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/partition.js
var require_partition = __commonJS({
  "../../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/partition.js"(exports, module) {
    init_cjs_shims();
    var createAggregator = require_createAggregator(), partition2 = createAggregator(function(result, value, key) {
      result[key ? 0 : 1].push(value);
    }, function() {
      return [[], []];
    });
    module.exports = partition2;
  }
});

// ../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/to-json.js
var require_to_json = __commonJS({
  "../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/to-json.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.getDeepKeys = exports.toJSON = void 0;
    var nonJsonTypes = ["function", "symbol", "undefined"], protectedProps = ["constructor", "prototype", "__proto__"], objectPrototype = Object.getPrototypeOf({});
    function toJSON() {
      let pojo = {}, error = this;
      for (let key of getDeepKeys(error))
        if (typeof key == "string") {
          let value = error[key], type = typeof value;
          nonJsonTypes.includes(type) || (pojo[key] = value);
        }
      return pojo;
    }
    exports.toJSON = toJSON;
    function getDeepKeys(obj, omit = []) {
      let keys = [];
      for (; obj && obj !== objectPrototype; )
        keys = keys.concat(Object.getOwnPropertyNames(obj), Object.getOwnPropertySymbols(obj)), obj = Object.getPrototypeOf(obj);
      let uniqueKeys = new Set(keys);
      for (let key of omit.concat(protectedProps))
        uniqueKeys.delete(key);
      return uniqueKeys;
    }
    exports.getDeepKeys = getDeepKeys;
  }
});

// ../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/isomorphic.node.js
var require_isomorphic_node = __commonJS({
  "../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/isomorphic.node.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.addInspectMethod = exports.format = void 0;
    var util2 = __require("util"), to_json_1 = require_to_json(), inspectMethod = util2.inspect.custom || Symbol.for("nodejs.util.inspect.custom");
    exports.format = util2.format;
    function addInspectMethod(newError) {
      newError[inspectMethod] = inspect;
    }
    exports.addInspectMethod = addInspectMethod;
    function inspect() {
      let pojo = {}, error = this;
      for (let key of to_json_1.getDeepKeys(error)) {
        let value = error[key];
        pojo[key] = value;
      }
      return delete pojo[inspectMethod], pojo;
    }
  }
});

// ../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/stack.js
var require_stack = __commonJS({
  "../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/stack.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.lazyJoinStacks = exports.joinStacks = exports.isWritableStack = exports.isLazyStack = void 0;
    var newline = /\r?\n/, onoCall = /\bono[ @]/;
    function isLazyStack(stackProp) {
      return !!(stackProp && stackProp.configurable && typeof stackProp.get == "function");
    }
    exports.isLazyStack = isLazyStack;
    function isWritableStack(stackProp) {
      return !!// If there is no stack property, then it's writable, since assigning it will create it
      (!stackProp || stackProp.writable || typeof stackProp.set == "function");
    }
    exports.isWritableStack = isWritableStack;
    function joinStacks(newError, originalError) {
      let newStack = popStack(newError.stack), originalStack = originalError ? originalError.stack : void 0;
      return newStack && originalStack ? newStack + `

` + originalStack : newStack || originalStack;
    }
    exports.joinStacks = joinStacks;
    function lazyJoinStacks(lazyStack, newError, originalError) {
      originalError ? Object.defineProperty(newError, "stack", {
        get: () => {
          let newStack = lazyStack.get.apply(newError);
          return joinStacks({ stack: newStack }, originalError);
        },
        enumerable: !1,
        configurable: !0
      }) : lazyPopStack(newError, lazyStack);
    }
    exports.lazyJoinStacks = lazyJoinStacks;
    function popStack(stack) {
      if (stack) {
        let lines = stack.split(newline), onoStart;
        for (let i = 0; i < lines.length; i++) {
          let line = lines[i];
          if (onoCall.test(line))
            onoStart === void 0 && (onoStart = i);
          else if (onoStart !== void 0) {
            lines.splice(onoStart, i - onoStart);
            break;
          }
        }
        if (lines.length > 0)
          return lines.join(`
`);
      }
      return stack;
    }
    function lazyPopStack(error, lazyStack) {
      Object.defineProperty(error, "stack", {
        get: () => popStack(lazyStack.get.apply(error)),
        enumerable: !1,
        configurable: !0
      });
    }
  }
});

// ../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/extend-error.js
var require_extend_error = __commonJS({
  "../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/extend-error.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.extendError = void 0;
    var isomorphic_node_1 = require_isomorphic_node(), stack_1 = require_stack(), to_json_1 = require_to_json(), protectedProps = ["name", "message", "stack"];
    function extendError(error, originalError, props) {
      let onoError = error;
      return extendStack(onoError, originalError), originalError && typeof originalError == "object" && mergeErrors(onoError, originalError), onoError.toJSON = to_json_1.toJSON, isomorphic_node_1.addInspectMethod && isomorphic_node_1.addInspectMethod(onoError), props && typeof props == "object" && Object.assign(onoError, props), onoError;
    }
    exports.extendError = extendError;
    function extendStack(newError, originalError) {
      let stackProp = Object.getOwnPropertyDescriptor(newError, "stack");
      stack_1.isLazyStack(stackProp) ? stack_1.lazyJoinStacks(stackProp, newError, originalError) : stack_1.isWritableStack(stackProp) && (newError.stack = stack_1.joinStacks(newError, originalError));
    }
    function mergeErrors(newError, originalError) {
      let keys = to_json_1.getDeepKeys(originalError, protectedProps), _newError = newError, _originalError = originalError;
      for (let key of keys)
        if (_newError[key] === void 0)
          try {
            _newError[key] = _originalError[key];
          } catch {
          }
    }
  }
});

// ../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/normalize.js
var require_normalize = __commonJS({
  "../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/normalize.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.normalizeArgs = exports.normalizeOptions = void 0;
    var isomorphic_node_1 = require_isomorphic_node();
    function normalizeOptions(options) {
      return options = options || {}, {
        concatMessages: options.concatMessages === void 0 ? !0 : !!options.concatMessages,
        format: options.format === void 0 ? isomorphic_node_1.format : typeof options.format == "function" ? options.format : !1
      };
    }
    exports.normalizeOptions = normalizeOptions;
    function normalizeArgs(args, options) {
      let originalError, props, formatArgs, message = "";
      return typeof args[0] == "string" ? formatArgs = args : typeof args[1] == "string" ? (args[0] instanceof Error ? originalError = args[0] : props = args[0], formatArgs = args.slice(1)) : (originalError = args[0], props = args[1], formatArgs = args.slice(2)), formatArgs.length > 0 && (options.format ? message = options.format.apply(void 0, formatArgs) : message = formatArgs.join(" ")), options.concatMessages && originalError && originalError.message && (message += (message ? ` 
` : "") + originalError.message), { originalError, props, message };
    }
    exports.normalizeArgs = normalizeArgs;
  }
});

// ../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/constructor.js
var require_constructor = __commonJS({
  "../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/constructor.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.Ono = void 0;
    var extend_error_1 = require_extend_error(), normalize_1 = require_normalize(), to_json_1 = require_to_json(), constructor = Ono;
    exports.Ono = constructor;
    function Ono(ErrorConstructor, options) {
      options = normalize_1.normalizeOptions(options);
      function ono(...args) {
        let { originalError, props, message } = normalize_1.normalizeArgs(args, options), newError = new ErrorConstructor(message);
        return extend_error_1.extendError(newError, originalError, props);
      }
      return ono[Symbol.species] = ErrorConstructor, ono;
    }
    Ono.toJSON = function(error) {
      return to_json_1.toJSON.call(error);
    };
    Ono.extend = function(error, originalError, props) {
      return props || originalError instanceof Error ? extend_error_1.extendError(error, originalError, props) : originalError ? extend_error_1.extendError(error, void 0, originalError) : extend_error_1.extendError(error);
    };
  }
});

// ../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/singleton.js
var require_singleton = __commonJS({
  "../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/singleton.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ono = void 0;
    var constructor_1 = require_constructor(), singleton = ono;
    exports.ono = singleton;
    ono.error = new constructor_1.Ono(Error);
    ono.eval = new constructor_1.Ono(EvalError);
    ono.range = new constructor_1.Ono(RangeError);
    ono.reference = new constructor_1.Ono(ReferenceError);
    ono.syntax = new constructor_1.Ono(SyntaxError);
    ono.type = new constructor_1.Ono(TypeError);
    ono.uri = new constructor_1.Ono(URIError);
    var onoMap = ono;
    function ono(...args) {
      let originalError = args[0];
      if (typeof originalError == "object" && typeof originalError.name == "string") {
        for (let typedOno of Object.values(onoMap))
          if (typeof typedOno == "function" && typedOno.name === "ono") {
            let species = typedOno[Symbol.species];
            if (species && species !== Error && (originalError instanceof species || originalError.name === species.name))
              return typedOno.apply(void 0, args);
          }
      }
      return ono.error.apply(void 0, args);
    }
  }
});

// ../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/types.js
var require_types6 = __commonJS({
  "../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/types.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var util_1 = __require("util");
  }
});

// ../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/index.js
var require_cjs3 = __commonJS({
  "../../node_modules/.pnpm/@jsdevtools+ono@7.1.3/node_modules/@jsdevtools/ono/cjs/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), Object.defineProperty(o, k2, { enumerable: !0, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __exportStar = exports && exports.__exportStar || function(m, exports2) {
      for (var p in m)
        p !== "default" && !exports2.hasOwnProperty(p) && __createBinding(exports2, m, p);
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.ono = void 0;
    var singleton_1 = require_singleton();
    Object.defineProperty(exports, "ono", { enumerable: !0, get: function() {
      return singleton_1.ono;
    } });
    var constructor_1 = require_constructor();
    Object.defineProperty(exports, "Ono", { enumerable: !0, get: function() {
      return constructor_1.Ono;
    } });
    __exportStar(require_types6(), exports);
    exports.default = singleton_1.ono;
    typeof module == "object" && typeof module.exports == "object" && (module.exports = Object.assign(module.exports.default, module.exports));
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/util/convert-path-to-posix.js
var require_convert_path_to_posix = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/util/convert-path-to-posix.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var path_1 = __importDefault(__require("path"));
    function convertPathToPosix(filePath) {
      return filePath.startsWith("\\\\?\\") ? filePath : filePath.split(path_1.default?.win32?.sep).join(path_1.default?.posix?.sep ?? "/");
    }
    exports.default = convertPathToPosix;
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/util/is-windows.js
var require_is_windows = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/util/is-windows.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.isWindows = void 0;
    var isWindowsConst = /^win/.test(globalThis.process ? globalThis.process.platform : ""), isWindows = () => isWindowsConst;
    exports.isWindows = isWindows;
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/util/url.js
var require_url = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/util/url.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: !0, value: v });
    } : function(o, v) {
      o.default = v;
    }), __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null)
        for (var k in mod)
          k !== "default" && Object.prototype.hasOwnProperty.call(mod, k) && __createBinding(result, mod, k);
      return __setModuleDefault(result, mod), result;
    }, __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.relative = exports.safePointerToPath = exports.toFileSystemPath = exports.fromFileSystemPath = exports.isFileSystemPath = exports.isHttp = exports.stripHash = exports.getHash = exports.stripQuery = exports.getExtension = exports.getProtocol = exports.cwd = exports.resolve = exports.parse = void 0;
    var convert_path_to_posix_1 = __importDefault(require_convert_path_to_posix()), path_1 = __importStar(__require("path")), forwardSlashPattern = /\//g, protocolPattern = /^(\w{2,}):\/\//i, jsonPointerSlash = /~1/g, jsonPointerTilde = /~0/g, path_2 = __require("path"), is_windows_1 = require_is_windows(), urlEncodePatterns = [
      [/\?/g, "%3F"],
      [/#/g, "%23"]
    ], urlDecodePatterns = [/%23/g, "#", /%24/g, "$", /%26/g, "&", /%2C/g, ",", /%40/g, "@"], parse4 = (u) => new URL(u);
    exports.parse = parse4;
    function resolve2(from, to) {
      let fromUrl = new URL((0, convert_path_to_posix_1.default)(from), "resolve://"), resolvedUrl = new URL((0, convert_path_to_posix_1.default)(to), fromUrl), endSpaces = to.match(/(\s*)$/)?.[1] || "";
      if (resolvedUrl.protocol === "resolve:") {
        let { pathname, search, hash } = resolvedUrl;
        return pathname + search + hash + endSpaces;
      }
      return resolvedUrl.toString() + endSpaces;
    }
    exports.resolve = resolve2;
    function cwd2() {
      if (typeof window < "u")
        return location.href;
      let path3 = process.cwd(), lastChar = path3.slice(-1);
      return lastChar === "/" || lastChar === "\\" ? path3 : path3 + "/";
    }
    exports.cwd = cwd2;
    function getProtocol(path3) {
      let match2 = protocolPattern.exec(path3 || "");
      if (match2)
        return match2[1].toLowerCase();
    }
    exports.getProtocol = getProtocol;
    function getExtension(path3) {
      let lastDot = path3.lastIndexOf(".");
      return lastDot >= 0 ? stripQuery(path3.substr(lastDot).toLowerCase()) : "";
    }
    exports.getExtension = getExtension;
    function stripQuery(path3) {
      let queryIndex = path3.indexOf("?");
      return queryIndex >= 0 && (path3 = path3.substr(0, queryIndex)), path3;
    }
    exports.stripQuery = stripQuery;
    function getHash(path3) {
      if (!path3)
        return "#";
      let hashIndex = path3.indexOf("#");
      return hashIndex >= 0 ? path3.substring(hashIndex) : "#";
    }
    exports.getHash = getHash;
    function stripHash(path3) {
      if (!path3)
        return "";
      let hashIndex = path3.indexOf("#");
      return hashIndex >= 0 && (path3 = path3.substring(0, hashIndex)), path3;
    }
    exports.stripHash = stripHash;
    function isHttp(path3) {
      let protocol = getProtocol(path3);
      return protocol === "http" || protocol === "https" ? !0 : protocol === void 0 ? typeof window < "u" : !1;
    }
    exports.isHttp = isHttp;
    function isFileSystemPath(path3) {
      if (typeof window < "u" || process.browser)
        return !1;
      let protocol = getProtocol(path3);
      return protocol === void 0 || protocol === "file";
    }
    exports.isFileSystemPath = isFileSystemPath;
    function fromFileSystemPath(path3) {
      if ((0, is_windows_1.isWindows)()) {
        let projectDir = cwd2(), upperPath = path3.toUpperCase(), posixUpper = (0, convert_path_to_posix_1.default)(projectDir).toUpperCase(), hasProjectDir = upperPath.includes(posixUpper), hasProjectUri = upperPath.includes(posixUpper), isAbsolutePath = path_1.win32?.isAbsolute(path3) || path3.startsWith("http://") || path3.startsWith("https://") || path3.startsWith("file://");
        !(hasProjectDir || hasProjectUri || isAbsolutePath) && !projectDir.startsWith("http") && (path3 = (0, path_2.join)(projectDir, path3)), path3 = (0, convert_path_to_posix_1.default)(path3);
      }
      path3 = encodeURI(path3);
      for (let pattern of urlEncodePatterns)
        path3 = path3.replace(pattern[0], pattern[1]);
      return path3;
    }
    exports.fromFileSystemPath = fromFileSystemPath;
    function toFileSystemPath(path3, keepFileProtocol) {
      path3 = decodeURI(path3);
      for (let i = 0; i < urlDecodePatterns.length; i += 2)
        path3 = path3.replace(urlDecodePatterns[i], urlDecodePatterns[i + 1]);
      let isFileUrl = path3.substr(0, 7).toLowerCase() === "file://";
      return isFileUrl && (path3 = path3[7] === "/" ? path3.substr(8) : path3.substr(7), (0, is_windows_1.isWindows)() && path3[1] === "/" && (path3 = path3[0] + ":" + path3.substr(1)), keepFileProtocol ? path3 = "file:///" + path3 : (isFileUrl = !1, path3 = (0, is_windows_1.isWindows)() ? path3 : "/" + path3)), (0, is_windows_1.isWindows)() && !isFileUrl && (path3 = path3.replace(forwardSlashPattern, "\\"), path3.substr(1, 2) === ":\\" && (path3 = path3[0].toUpperCase() + path3.substr(1))), path3;
    }
    exports.toFileSystemPath = toFileSystemPath;
    function safePointerToPath(pointer) {
      return pointer.length <= 1 || pointer[0] !== "#" || pointer[1] !== "/" ? [] : pointer.slice(2).split("/").map((value) => decodeURIComponent(value).replace(jsonPointerSlash, "/").replace(jsonPointerTilde, "~"));
    }
    exports.safePointerToPath = safePointerToPath;
    function relative(from, to) {
      if (!isFileSystemPath(from) || !isFileSystemPath(to))
        return resolve2(from, to);
      let fromDir = path_1.default.dirname(stripHash(from)), toPath = stripHash(to);
      return path_1.default.relative(fromDir, toPath) + getHash(to);
    }
    exports.relative = relative;
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/util/errors.js
var require_errors5 = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/util/errors.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.normalizeError = exports.isHandledError = exports.InvalidPointerError = exports.TimeoutError = exports.MissingPointerError = exports.UnmatchedResolverError = exports.ResolverError = exports.UnmatchedParserError = exports.ParserError = exports.JSONParserErrorGroup = exports.JSONParserError = void 0;
    var ono_1 = require_cjs3(), url_js_1 = require_url(), JSONParserError = class extends Error {
      constructor(message, source) {
        super(), this.code = "EUNKNOWN", this.name = "JSONParserError", this.message = message, this.source = source, this.path = null, ono_1.Ono.extend(this);
      }
      get footprint() {
        return `${this.path}+${this.source}+${this.code}+${this.message}`;
      }
    };
    exports.JSONParserError = JSONParserError;
    var JSONParserErrorGroup = class _JSONParserErrorGroup extends Error {
      constructor(parser) {
        super(), this.files = parser, this.name = "JSONParserErrorGroup", this.message = `${this.errors.length} error${this.errors.length > 1 ? "s" : ""} occurred while reading '${(0, url_js_1.toFileSystemPath)(parser.$refs._root$Ref.path)}'`, ono_1.Ono.extend(this);
      }
      static getParserErrors(parser) {
        let errors2 = [];
        for (let $ref of Object.values(parser.$refs._$refs))
          $ref.errors && errors2.push(...$ref.errors);
        return errors2;
      }
      get errors() {
        return _JSONParserErrorGroup.getParserErrors(this.files);
      }
    };
    exports.JSONParserErrorGroup = JSONParserErrorGroup;
    var ParserError = class extends JSONParserError {
      constructor(message, source) {
        super(`Error parsing ${source}: ${message}`, source), this.code = "EPARSER", this.name = "ParserError";
      }
    };
    exports.ParserError = ParserError;
    var UnmatchedParserError = class extends JSONParserError {
      constructor(source) {
        super(`Could not find parser for "${source}"`, source), this.code = "EUNMATCHEDPARSER", this.name = "UnmatchedParserError";
      }
    };
    exports.UnmatchedParserError = UnmatchedParserError;
    var ResolverError = class extends JSONParserError {
      constructor(ex, source) {
        super(ex.message || `Error reading file "${source}"`, source), this.code = "ERESOLVER", this.name = "ResolverError", "code" in ex && (this.ioErrorCode = String(ex.code));
      }
    };
    exports.ResolverError = ResolverError;
    var UnmatchedResolverError = class extends JSONParserError {
      constructor(source) {
        super(`Could not find resolver for "${source}"`, source), this.code = "EUNMATCHEDRESOLVER", this.name = "UnmatchedResolverError";
      }
    };
    exports.UnmatchedResolverError = UnmatchedResolverError;
    var MissingPointerError = class extends JSONParserError {
      constructor(token, path3) {
        super(`Token "${token}" does not exist.`, (0, url_js_1.stripHash)(path3)), this.code = "EUNMATCHEDRESOLVER", this.name = "MissingPointerError";
      }
    };
    exports.MissingPointerError = MissingPointerError;
    var TimeoutError = class extends JSONParserError {
      constructor(timeout) {
        super(`Dereferencing timeout reached: ${timeout}ms`), this.code = "ETIMEOUT", this.name = "TimeoutError";
      }
    };
    exports.TimeoutError = TimeoutError;
    var InvalidPointerError = class extends JSONParserError {
      constructor(pointer, path3) {
        super(`Invalid $ref pointer "${pointer}". Pointers must begin with "#/"`, (0, url_js_1.stripHash)(path3)), this.code = "EUNMATCHEDRESOLVER", this.name = "InvalidPointerError";
      }
    };
    exports.InvalidPointerError = InvalidPointerError;
    function isHandledError(err2) {
      return err2 instanceof JSONParserError || err2 instanceof JSONParserErrorGroup;
    }
    exports.isHandledError = isHandledError;
    function normalizeError(err2) {
      return err2.path === null && (err2.path = []), err2;
    }
    exports.normalizeError = normalizeError;
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/pointer.js
var require_pointer = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/pointer.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: !0, value: v });
    } : function(o, v) {
      o.default = v;
    }), __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null)
        for (var k in mod)
          k !== "default" && Object.prototype.hasOwnProperty.call(mod, k) && __createBinding(result, mod, k);
      return __setModuleDefault(result, mod), result;
    }, __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var ref_js_1 = __importDefault(require_ref()), url = __importStar(require_url()), errors_js_1 = require_errors5(), slashes = /\//g, tildes = /~/g, escapedSlash = /~1/g, escapedTilde = /~0/g, safeDecodeURIComponent = (encodedURIComponent) => {
      try {
        return decodeURIComponent(encodedURIComponent);
      } catch {
        return encodedURIComponent;
      }
    }, Pointer = class _Pointer {
      constructor($ref, path3, friendlyPath) {
        this.$ref = $ref, this.path = path3, this.originalPath = friendlyPath || path3, this.value = void 0, this.circular = !1, this.indirections = 0;
      }
      /**
       * Resolves the value of a nested property within the given object.
       *
       * @param obj - The object that will be crawled
       * @param options
       * @param pathFromRoot - the path of place that initiated resolving
       *
       * @returns
       * Returns a JSON pointer whose {@link Pointer#value} is the resolved value.
       * If resolving this value required resolving other JSON references, then
       * the {@link Pointer#$ref} and {@link Pointer#path} will reflect the resolution path
       * of the resolved value.
       */
      resolve(obj, options, pathFromRoot) {
        let tokens = _Pointer.parse(this.path, this.originalPath);
        this.value = unwrapOrThrow(obj);
        for (let i = 0; i < tokens.length; i++) {
          if (resolveIf$Ref(this, options, pathFromRoot) && (this.path = _Pointer.join(this.path, tokens.slice(i))), typeof this.value == "object" && this.value !== null && !isRootPath(pathFromRoot) && "$ref" in this.value)
            return this;
          let token = tokens[i];
          if (this.value[token] === void 0 || this.value[token] === null && i === tokens.length - 1) {
            let didFindSubstringSlashMatch = !1;
            for (let j = tokens.length - 1; j > i; j--) {
              let joinedToken = tokens.slice(i, j + 1).join("/");
              if (this.value[joinedToken] !== void 0) {
                this.value = this.value[joinedToken], i = j, didFindSubstringSlashMatch = !0;
                break;
              }
            }
            if (didFindSubstringSlashMatch)
              continue;
            throw this.value = null, new errors_js_1.MissingPointerError(token, decodeURI(this.originalPath));
          } else
            this.value = this.value[token];
        }
        return (!this.value || this.value.$ref && url.resolve(this.path, this.value.$ref) !== pathFromRoot) && resolveIf$Ref(this, options, pathFromRoot), this;
      }
      /**
       * Sets the value of a nested property within the given object.
       *
       * @param obj - The object that will be crawled
       * @param value - the value to assign
       * @param options
       *
       * @returns
       * Returns the modified object, or an entirely new object if the entire object is overwritten.
       */
      set(obj, value, options) {
        let tokens = _Pointer.parse(this.path), token;
        if (tokens.length === 0)
          return this.value = value, value;
        this.value = unwrapOrThrow(obj);
        for (let i = 0; i < tokens.length - 1; i++)
          resolveIf$Ref(this, options), token = tokens[i], this.value && this.value[token] !== void 0 ? this.value = this.value[token] : this.value = setValue(this, token, {});
        return resolveIf$Ref(this, options), token = tokens[tokens.length - 1], setValue(this, token, value), obj;
      }
      /**
       * Parses a JSON pointer (or a path containing a JSON pointer in the hash)
       * and returns an array of the pointer's tokens.
       * (e.g. "schema.json#/definitions/person/name" => ["definitions", "person", "name"])
       *
       * The pointer is parsed according to RFC 6901
       * {@link https://tools.ietf.org/html/rfc6901#section-3}
       *
       * @param path
       * @param [originalPath]
       * @returns
       */
      static parse(path3, originalPath) {
        let pointer = url.getHash(path3).substring(1);
        if (!pointer)
          return [];
        let split = pointer.split("/");
        for (let i = 0; i < split.length; i++)
          split[i] = safeDecodeURIComponent(split[i].replace(escapedSlash, "/").replace(escapedTilde, "~"));
        if (split[0] !== "")
          throw new errors_js_1.InvalidPointerError(split, originalPath === void 0 ? path3 : originalPath);
        return split.slice(1);
      }
      /**
       * Creates a JSON pointer path, by joining one or more tokens to a base path.
       *
       * @param base - The base path (e.g. "schema.json#/definitions/person")
       * @param tokens - The token(s) to append (e.g. ["name", "first"])
       * @returns
       */
      static join(base, tokens) {
        base.indexOf("#") === -1 && (base += "#"), tokens = Array.isArray(tokens) ? tokens : [tokens];
        for (let i = 0; i < tokens.length; i++) {
          let token = tokens[i];
          base += "/" + encodeURIComponent(token.replace(tildes, "~0").replace(slashes, "~1"));
        }
        return base;
      }
    };
    function resolveIf$Ref(pointer, options, pathFromRoot) {
      if (ref_js_1.default.isAllowed$Ref(pointer.value, options)) {
        let $refPath = url.resolve(pointer.path, pointer.value.$ref);
        if ($refPath === pointer.path && !isRootPath(pathFromRoot))
          pointer.circular = !0;
        else {
          let resolved = pointer.$ref.$refs._resolve($refPath, pointer.path, options);
          return resolved === null ? !1 : (pointer.indirections += resolved.indirections + 1, ref_js_1.default.isExtended$Ref(pointer.value) ? (pointer.value = ref_js_1.default.dereference(pointer.value, resolved.value), !1) : (pointer.$ref = resolved.$ref, pointer.path = resolved.path, pointer.value = resolved.value, !0));
        }
      }
    }
    exports.default = Pointer;
    function setValue(pointer, token, value) {
      if (pointer.value && typeof pointer.value == "object")
        token === "-" && Array.isArray(pointer.value) ? pointer.value.push(value) : pointer.value[token] = value;
      else
        throw new errors_js_1.JSONParserError(`Error assigning $ref pointer "${pointer.path}". 
Cannot set "${token}" of a non-object.`);
      return value;
    }
    function unwrapOrThrow(value) {
      if ((0, errors_js_1.isHandledError)(value))
        throw value;
      return value;
    }
    function isRootPath(pathFromRoot) {
      return typeof pathFromRoot == "string" && Pointer.parse(pathFromRoot).length == 0;
    }
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/ref.js
var require_ref = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/ref.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var pointer_js_1 = __importDefault(require_pointer()), errors_js_1 = require_errors5(), url_js_1 = require_url(), $Ref = class _$Ref {
      constructor($refs) {
        this.errors = [], this.$refs = $refs;
      }
      /**
       * Pushes an error to errors array.
       *
       * @param err - The error to be pushed
       * @returns
       */
      addError(err2) {
        this.errors === void 0 && (this.errors = []);
        let existingErrors = this.errors.map(({ footprint }) => footprint);
        "errors" in err2 && Array.isArray(err2.errors) ? this.errors.push(...err2.errors.map(errors_js_1.normalizeError).filter(({ footprint }) => !existingErrors.includes(footprint))) : (!("footprint" in err2) || !existingErrors.includes(err2.footprint)) && this.errors.push((0, errors_js_1.normalizeError)(err2));
      }
      /**
       * Determines whether the given JSON reference exists within this {@link $Ref#value}.
       *
       * @param path - The full path being resolved, optionally with a JSON pointer in the hash
       * @param options
       * @returns
       */
      exists(path3, options) {
        try {
          return this.resolve(path3, options), !0;
        } catch {
          return !1;
        }
      }
      /**
       * Resolves the given JSON reference within this {@link $Ref#value} and returns the resolved value.
       *
       * @param path - The full path being resolved, optionally with a JSON pointer in the hash
       * @param options
       * @returns - Returns the resolved value
       */
      get(path3, options) {
        return this.resolve(path3, options)?.value;
      }
      /**
       * Resolves the given JSON reference within this {@link $Ref#value}.
       *
       * @param path - The full path being resolved, optionally with a JSON pointer in the hash
       * @param options
       * @param friendlyPath - The original user-specified path (used for error messages)
       * @param pathFromRoot - The path of `obj` from the schema root
       * @returns
       */
      resolve(path3, options, friendlyPath, pathFromRoot) {
        let pointer = new pointer_js_1.default(this, path3, friendlyPath);
        try {
          return pointer.resolve(this.value, options, pathFromRoot);
        } catch (err2) {
          if (!options || !options.continueOnError || !(0, errors_js_1.isHandledError)(err2))
            throw err2;
          return err2.path === null && (err2.path = (0, url_js_1.safePointerToPath)((0, url_js_1.getHash)(pathFromRoot))), err2 instanceof errors_js_1.InvalidPointerError && (err2.source = decodeURI((0, url_js_1.stripHash)(pathFromRoot))), this.addError(err2), null;
        }
      }
      /**
       * Sets the value of a nested property within this {@link $Ref#value}.
       * If the property, or any of its parents don't exist, they will be created.
       *
       * @param path - The full path of the property to set, optionally with a JSON pointer in the hash
       * @param value - The value to assign
       */
      set(path3, value) {
        let pointer = new pointer_js_1.default(this, path3);
        this.value = pointer.set(this.value, value);
      }
      /**
       * Determines whether the given value is a JSON reference.
       *
       * @param value - The value to inspect
       * @returns
       */
      static is$Ref(value) {
        return !!value && typeof value == "object" && value !== null && "$ref" in value && typeof value.$ref == "string" && value.$ref.length > 0;
      }
      /**
       * Determines whether the given value is an external JSON reference.
       *
       * @param value - The value to inspect
       * @returns
       */
      static isExternal$Ref(value) {
        return _$Ref.is$Ref(value) && value.$ref[0] !== "#";
      }
      /**
       * Determines whether the given value is a JSON reference, and whether it is allowed by the options.
       * For example, if it references an external file, then options.resolve.external must be true.
       *
       * @param value - The value to inspect
       * @param options
       * @returns
       */
      static isAllowed$Ref(value, options) {
        if (this.is$Ref(value)) {
          if (value.$ref.substring(0, 2) === "#/" || value.$ref === "#")
            return !0;
          if (value.$ref[0] !== "#" && (!options || options.resolve?.external))
            return !0;
        }
      }
      /**
       * Determines whether the given value is a JSON reference that "extends" its resolved value.
       * That is, it has extra properties (in addition to "$ref"), so rather than simply pointing to
       * an existing value, this $ref actually creates a NEW value that is a shallow copy of the resolved
       * value, plus the extra properties.
       *
       * @example: {
         person: {
           properties: {
             firstName: { type: string }
             lastName: { type: string }
           }
         }
         employee: {
           properties: {
             $ref: #/person/properties
             salary: { type: number }
           }
         }
       }
       *  In this example, "employee" is an extended $ref, since it extends "person" with an additional
       *  property (salary).  The result is a NEW value that looks like this:
       *
       *  {
       *    properties: {
       *      firstName: { type: string }
       *      lastName: { type: string }
       *      salary: { type: number }
       *    }
       *  }
       *
       * @param value - The value to inspect
       * @returns
       */
      static isExtended$Ref(value) {
        return _$Ref.is$Ref(value) && Object.keys(value).length > 1;
      }
      /**
       * Returns the resolved value of a JSON Reference.
       * If necessary, the resolved value is merged with the JSON Reference to create a new object
       *
       * @example: {
      person: {
        properties: {
          firstName: { type: string }
          lastName: { type: string }
        }
      }
      employee: {
        properties: {
          $ref: #/person/properties
          salary: { type: number }
        }
      }
      } When "person" and "employee" are merged, you end up with the following object:
       *
       *  {
       *    properties: {
       *      firstName: { type: string }
       *      lastName: { type: string }
       *      salary: { type: number }
       *    }
       *  }
       *
       * @param $ref - The JSON reference object (the one with the "$ref" property)
       * @param resolvedValue - The resolved value, which can be any type
       * @returns - Returns the dereferenced value
       */
      static dereference($ref, resolvedValue) {
        if (resolvedValue && typeof resolvedValue == "object" && _$Ref.isExtended$Ref($ref)) {
          let merged = {};
          for (let key of Object.keys($ref))
            key !== "$ref" && (merged[key] = $ref[key]);
          for (let key of Object.keys(resolvedValue))
            key in merged || (merged[key] = resolvedValue[key]);
          return merged;
        } else
          return resolvedValue;
      }
    };
    exports.default = $Ref;
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/refs.js
var require_refs = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/refs.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: !0, value: v });
    } : function(o, v) {
      o.default = v;
    }), __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null)
        for (var k in mod)
          k !== "default" && Object.prototype.hasOwnProperty.call(mod, k) && __createBinding(result, mod, k);
      return __setModuleDefault(result, mod), result;
    }, __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var ono_1 = require_cjs3(), ref_js_1 = __importDefault(require_ref()), url = __importStar(require_url()), convert_path_to_posix_1 = __importDefault(require_convert_path_to_posix()), $Refs = class {
      /**
       * Returns the paths/URLs of all the files in your schema (including the main schema file).
       *
       * See https://apitools.dev/json-schema-ref-parser/docs/refs.html#pathstypes
       *
       * @param types (optional) Optionally only return certain types of paths ("file", "http", etc.)
       */
      paths(...types) {
        return getPaths(this._$refs, types.flat()).map((path3) => (0, convert_path_to_posix_1.default)(path3.decoded));
      }
      /**
       * Returns a map of paths/URLs and their correspond values.
       *
       * See https://apitools.dev/json-schema-ref-parser/docs/refs.html#valuestypes
       *
       * @param types (optional) Optionally only return values from certain locations ("file", "http", etc.)
       */
      values(...types) {
        let $refs = this._$refs;
        return getPaths($refs, types.flat()).reduce((obj, path3) => (obj[(0, convert_path_to_posix_1.default)(path3.decoded)] = $refs[path3.encoded].value, obj), {});
      }
      /**
       * Returns `true` if the given path exists in the schema; otherwise, returns `false`
       *
       * See https://apitools.dev/json-schema-ref-parser/docs/refs.html#existsref
       *
       * @param $ref The JSON Reference path, optionally with a JSON Pointer in the hash
       */
      /**
       * Determines whether the given JSON reference exists.
       *
       * @param path - The path being resolved, optionally with a JSON pointer in the hash
       * @param [options]
       * @returns
       */
      exists(path3, options) {
        try {
          return this._resolve(path3, "", options), !0;
        } catch {
          return !1;
        }
      }
      /**
       * Resolves the given JSON reference and returns the resolved value.
       *
       * @param path - The path being resolved, with a JSON pointer in the hash
       * @param [options]
       * @returns - Returns the resolved value
       */
      get(path3, options) {
        return this._resolve(path3, "", options).value;
      }
      /**
       * Sets the value at the given path in the schema. If the property, or any of its parents, don't exist, they will be created.
       *
       * @param path The JSON Reference path, optionally with a JSON Pointer in the hash
       * @param value The value to assign. Can be anything (object, string, number, etc.)
       */
      set(path3, value) {
        let absPath = url.resolve(this._root$Ref.path, path3), withoutHash = url.stripHash(absPath), $ref = this._$refs[withoutHash];
        if (!$ref)
          throw (0, ono_1.ono)(`Error resolving $ref pointer "${path3}". 
"${withoutHash}" not found.`);
        $ref.set(absPath, value);
      }
      /**
       * Returns the specified {@link $Ref} object, or undefined.
       *
       * @param path - The path being resolved, optionally with a JSON pointer in the hash
       * @returns
       * @protected
       */
      _get$Ref(path3) {
        path3 = url.resolve(this._root$Ref.path, path3);
        let withoutHash = url.stripHash(path3);
        return this._$refs[withoutHash];
      }
      /**
       * Creates a new {@link $Ref} object and adds it to this {@link $Refs} object.
       *
       * @param path  - The file path or URL of the referenced file
       */
      _add(path3) {
        let withoutHash = url.stripHash(path3), $ref = new ref_js_1.default(this);
        return $ref.path = withoutHash, this._$refs[withoutHash] = $ref, this._root$Ref = this._root$Ref || $ref, $ref;
      }
      /**
       * Resolves the given JSON reference.
       *
       * @param path - The path being resolved, optionally with a JSON pointer in the hash
       * @param pathFromRoot - The path of `obj` from the schema root
       * @param [options]
       * @returns
       * @protected
       */
      _resolve(path3, pathFromRoot, options) {
        let absPath = url.resolve(this._root$Ref.path, path3), withoutHash = url.stripHash(absPath), $ref = this._$refs[withoutHash];
        if (!$ref)
          throw (0, ono_1.ono)(`Error resolving $ref pointer "${path3}". 
"${withoutHash}" not found.`);
        return $ref.resolve(absPath, options, path3, pathFromRoot);
      }
      constructor() {
        this._$refs = {}, this.toJSON = this.values, this.circular = !1, this._$refs = {}, this._root$Ref = null;
      }
    };
    exports.default = $Refs;
    function getPaths($refs, types) {
      let paths = Object.keys($refs);
      return types = Array.isArray(types[0]) ? types[0] : Array.prototype.slice.call(types), types.length > 0 && types[0] && (paths = paths.filter((key) => types.includes($refs[key].pathType))), paths.map((path3) => ({
        encoded: path3,
        decoded: $refs[path3].pathType === "file" ? url.toFileSystemPath(path3, !0) : path3
      }));
    }
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/util/plugins.js
var require_plugins = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/util/plugins.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.run = exports.sort = exports.filter = exports.all = void 0;
    function all(plugins) {
      return Object.keys(plugins || {}).filter((key) => typeof plugins[key] == "object").map((key) => (plugins[key].name = key, plugins[key]));
    }
    exports.all = all;
    function filter(plugins, method, file) {
      return plugins.filter((plugin) => !!getResult(plugin, method, file));
    }
    exports.filter = filter;
    function sort2(plugins) {
      for (let plugin of plugins)
        plugin.order = plugin.order || Number.MAX_SAFE_INTEGER;
      return plugins.sort((a, b) => a.order - b.order);
    }
    exports.sort = sort2;
    async function run(plugins, method, file, $refs) {
      let plugin, lastError, index = 0;
      return new Promise((resolve2, reject) => {
        runNextPlugin();
        function runNextPlugin() {
          if (plugin = plugins[index++], !plugin)
            return reject(lastError);
          try {
            let result = getResult(plugin, method, file, callback, $refs);
            if (result && typeof result.then == "function")
              result.then(onSuccess, onError);
            else if (result !== void 0)
              onSuccess(result);
            else if (index === plugins.length)
              throw new Error("No promise has been returned or callback has been called.");
          } catch (e) {
            onError(e);
          }
        }
        function callback(err2, result) {
          err2 ? onError(err2) : onSuccess(result);
        }
        function onSuccess(result) {
          resolve2({
            plugin,
            result
          });
        }
        function onError(error) {
          lastError = {
            plugin,
            error
          }, runNextPlugin();
        }
      });
    }
    exports.run = run;
    function getResult(obj, prop, file, callback, $refs) {
      let value = obj[prop];
      if (typeof value == "function")
        return value.apply(obj, [file, callback, $refs]);
      if (!callback) {
        if (value instanceof RegExp)
          return value.test(file.url);
        if (typeof value == "string")
          return value === file.extension;
        if (Array.isArray(value))
          return value.indexOf(file.extension) !== -1;
      }
      return value;
    }
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/parse.js
var require_parse = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/parse.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: !0, value: v });
    } : function(o, v) {
      o.default = v;
    }), __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null)
        for (var k in mod)
          k !== "default" && Object.prototype.hasOwnProperty.call(mod, k) && __createBinding(result, mod, k);
      return __setModuleDefault(result, mod), result;
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var ono_1 = require_cjs3(), url = __importStar(require_url()), plugins = __importStar(require_plugins()), errors_js_1 = require_errors5();
    async function parse4(path3, $refs, options) {
      let hashIndex = path3.indexOf("#"), hash = "";
      hashIndex >= 0 && (hash = path3.substring(hashIndex), path3 = path3.substring(0, hashIndex));
      let $ref = $refs._add(path3), file = {
        url: path3,
        hash,
        extension: url.getExtension(path3)
      };
      try {
        let resolver = await readFile5(file, options, $refs);
        $ref.pathType = resolver.plugin.name, file.data = resolver.result;
        let parser = await parseFile(file, options, $refs);
        return $ref.value = parser.result, parser.result;
      } catch (err2) {
        throw (0, errors_js_1.isHandledError)(err2) && ($ref.value = err2), err2;
      }
    }
    async function readFile5(file, options, $refs) {
      let resolvers = plugins.all(options.resolve);
      resolvers = plugins.filter(resolvers, "canRead", file), plugins.sort(resolvers);
      try {
        return await plugins.run(resolvers, "read", file, $refs);
      } catch (err2) {
        throw !err2 && options.continueOnError ? new errors_js_1.UnmatchedResolverError(file.url) : !err2 || !("error" in err2) ? ono_1.ono.syntax(`Unable to resolve $ref pointer "${file.url}"`) : err2.error instanceof errors_js_1.ResolverError ? err2.error : new errors_js_1.ResolverError(err2, file.url);
      }
    }
    async function parseFile(file, options, $refs) {
      let allParsers = plugins.all(options.parse), filteredParsers = plugins.filter(allParsers, "canParse", file), parsers = filteredParsers.length > 0 ? filteredParsers : allParsers;
      plugins.sort(parsers);
      try {
        let parser = await plugins.run(parsers, "parse", file, $refs);
        if (!parser.plugin.allowEmpty && isEmpty2(parser.result))
          throw ono_1.ono.syntax(`Error parsing "${file.url}" as ${parser.plugin.name}. 
Parsed value is empty`);
        return parser;
      } catch (err2) {
        throw !err2 && options.continueOnError ? new errors_js_1.UnmatchedParserError(file.url) : err2 && err2.message && err2.message.startsWith("Error parsing") ? err2 : !err2 || !("error" in err2) ? ono_1.ono.syntax(`Unable to parse ${file.url}`) : err2.error instanceof errors_js_1.ParserError ? err2.error : new errors_js_1.ParserError(err2.error.message, file.url);
      }
    }
    function isEmpty2(value) {
      return value === void 0 || typeof value == "object" && Object.keys(value).length === 0 || typeof value == "string" && value.trim().length === 0 || Buffer.isBuffer(value) && value.length === 0;
    }
    exports.default = parse4;
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/parsers/json.js
var require_json4 = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/parsers/json.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var errors_js_1 = require_errors5();
    exports.default = {
      /**
       * The order that this parser will run, in relation to other parsers.
       */
      order: 100,
      /**
       * Whether to allow "empty" files. This includes zero-byte files, as well as empty JSON objects.
       */
      allowEmpty: !0,
      /**
       * Determines whether this parser can parse a given file reference.
       * Parsers that match will be tried, in order, until one successfully parses the file.
       * Parsers that don't match will be skipped, UNLESS none of the parsers match, in which case
       * every parser will be tried.
       */
      canParse: ".json",
      /**
       * Allow JSON files with byte order marks (BOM)
       */
      allowBOM: !0,
      /**
       * Parses the given file as JSON
       */
      async parse(file) {
        let data = file.data;
        if (Buffer.isBuffer(data) && (data = data.toString()), typeof data == "string") {
          if (data.trim().length === 0)
            return;
          try {
            return JSON.parse(data);
          } catch (e) {
            if (this.allowBOM)
              try {
                let firstCurlyBrace = data.indexOf("{");
                return data = data.slice(firstCurlyBrace), JSON.parse(data);
              } catch (e2) {
                throw new errors_js_1.ParserError(e2.message, file.url);
              }
            throw new errors_js_1.ParserError(e.message, file.url);
          }
        } else
          return data;
      }
    };
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/common.js
var require_common4 = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/common.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    function isNothing(subject) {
      return typeof subject > "u" || subject === null;
    }
    function isObject4(subject) {
      return typeof subject == "object" && subject !== null;
    }
    function toArray(sequence) {
      return Array.isArray(sequence) ? sequence : isNothing(sequence) ? [] : [sequence];
    }
    function extend(target, source) {
      var index, length, key, sourceKeys;
      if (source)
        for (sourceKeys = Object.keys(source), index = 0, length = sourceKeys.length; index < length; index += 1)
          key = sourceKeys[index], target[key] = source[key];
      return target;
    }
    function repeat2(string, count) {
      var result = "", cycle;
      for (cycle = 0; cycle < count; cycle += 1)
        result += string;
      return result;
    }
    function isNegativeZero(number) {
      return number === 0 && Number.NEGATIVE_INFINITY === 1 / number;
    }
    module.exports.isNothing = isNothing;
    module.exports.isObject = isObject4;
    module.exports.toArray = toArray;
    module.exports.repeat = repeat2;
    module.exports.isNegativeZero = isNegativeZero;
    module.exports.extend = extend;
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/exception.js
var require_exception = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/exception.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    function formatError(exception, compact2) {
      var where = "", message = exception.reason || "(unknown reason)";
      return exception.mark ? (exception.mark.name && (where += 'in "' + exception.mark.name + '" '), where += "(" + (exception.mark.line + 1) + ":" + (exception.mark.column + 1) + ")", !compact2 && exception.mark.snippet && (where += `

` + exception.mark.snippet), message + " " + where) : message;
    }
    function YAMLException(reason, mark) {
      Error.call(this), this.name = "YAMLException", this.reason = reason, this.mark = mark, this.message = formatError(this, !1), Error.captureStackTrace ? Error.captureStackTrace(this, this.constructor) : this.stack = new Error().stack || "";
    }
    YAMLException.prototype = Object.create(Error.prototype);
    YAMLException.prototype.constructor = YAMLException;
    YAMLException.prototype.toString = function(compact2) {
      return this.name + ": " + formatError(this, compact2);
    };
    module.exports = YAMLException;
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/snippet.js
var require_snippet = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/snippet.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var common = require_common4();
    function getLine(buffer, lineStart, lineEnd, position, maxLineLength) {
      var head = "", tail = "", maxHalfLength = Math.floor(maxLineLength / 2) - 1;
      return position - lineStart > maxHalfLength && (head = " ... ", lineStart = position - maxHalfLength + head.length), lineEnd - position > maxHalfLength && (tail = " ...", lineEnd = position + maxHalfLength - tail.length), {
        str: head + buffer.slice(lineStart, lineEnd).replace(/\t/g, "\u2192") + tail,
        pos: position - lineStart + head.length
        // relative position
      };
    }
    function padStart(string, max) {
      return common.repeat(" ", max - string.length) + string;
    }
    function makeSnippet(mark, options) {
      if (options = Object.create(options || null), !mark.buffer)
        return null;
      options.maxLength || (options.maxLength = 79), typeof options.indent != "number" && (options.indent = 1), typeof options.linesBefore != "number" && (options.linesBefore = 3), typeof options.linesAfter != "number" && (options.linesAfter = 2);
      for (var re = /\r?\n|\r|\0/g, lineStarts = [0], lineEnds = [], match2, foundLineNo = -1; match2 = re.exec(mark.buffer); )
        lineEnds.push(match2.index), lineStarts.push(match2.index + match2[0].length), mark.position <= match2.index && foundLineNo < 0 && (foundLineNo = lineStarts.length - 2);
      foundLineNo < 0 && (foundLineNo = lineStarts.length - 1);
      var result = "", i, line, lineNoLength = Math.min(mark.line + options.linesAfter, lineEnds.length).toString().length, maxLineLength = options.maxLength - (options.indent + lineNoLength + 3);
      for (i = 1; i <= options.linesBefore && !(foundLineNo - i < 0); i++)
        line = getLine(
          mark.buffer,
          lineStarts[foundLineNo - i],
          lineEnds[foundLineNo - i],
          mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo - i]),
          maxLineLength
        ), result = common.repeat(" ", options.indent) + padStart((mark.line - i + 1).toString(), lineNoLength) + " | " + line.str + `
` + result;
      for (line = getLine(mark.buffer, lineStarts[foundLineNo], lineEnds[foundLineNo], mark.position, maxLineLength), result += common.repeat(" ", options.indent) + padStart((mark.line + 1).toString(), lineNoLength) + " | " + line.str + `
`, result += common.repeat("-", options.indent + lineNoLength + 3 + line.pos) + `^
`, i = 1; i <= options.linesAfter && !(foundLineNo + i >= lineEnds.length); i++)
        line = getLine(
          mark.buffer,
          lineStarts[foundLineNo + i],
          lineEnds[foundLineNo + i],
          mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo + i]),
          maxLineLength
        ), result += common.repeat(" ", options.indent) + padStart((mark.line + i + 1).toString(), lineNoLength) + " | " + line.str + `
`;
      return result.replace(/\n$/, "");
    }
    module.exports = makeSnippet;
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type.js
var require_type = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var YAMLException = require_exception(), TYPE_CONSTRUCTOR_OPTIONS = [
      "kind",
      "multi",
      "resolve",
      "construct",
      "instanceOf",
      "predicate",
      "represent",
      "representName",
      "defaultStyle",
      "styleAliases"
    ], YAML_NODE_KINDS = [
      "scalar",
      "sequence",
      "mapping"
    ];
    function compileStyleAliases(map) {
      var result = {};
      return map !== null && Object.keys(map).forEach(function(style) {
        map[style].forEach(function(alias) {
          result[String(alias)] = style;
        });
      }), result;
    }
    function Type(tag, options) {
      if (options = options || {}, Object.keys(options).forEach(function(name) {
        if (TYPE_CONSTRUCTOR_OPTIONS.indexOf(name) === -1)
          throw new YAMLException('Unknown option "' + name + '" is met in definition of "' + tag + '" YAML type.');
      }), this.options = options, this.tag = tag, this.kind = options.kind || null, this.resolve = options.resolve || function() {
        return !0;
      }, this.construct = options.construct || function(data) {
        return data;
      }, this.instanceOf = options.instanceOf || null, this.predicate = options.predicate || null, this.represent = options.represent || null, this.representName = options.representName || null, this.defaultStyle = options.defaultStyle || null, this.multi = options.multi || !1, this.styleAliases = compileStyleAliases(options.styleAliases || null), YAML_NODE_KINDS.indexOf(this.kind) === -1)
        throw new YAMLException('Unknown kind "' + this.kind + '" is specified for "' + tag + '" YAML type.');
    }
    module.exports = Type;
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema.js
var require_schema4 = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var YAMLException = require_exception(), Type = require_type();
    function compileList(schema, name) {
      var result = [];
      return schema[name].forEach(function(currentType) {
        var newIndex = result.length;
        result.forEach(function(previousType, previousIndex) {
          previousType.tag === currentType.tag && previousType.kind === currentType.kind && previousType.multi === currentType.multi && (newIndex = previousIndex);
        }), result[newIndex] = currentType;
      }), result;
    }
    function compileMap() {
      var result = {
        scalar: {},
        sequence: {},
        mapping: {},
        fallback: {},
        multi: {
          scalar: [],
          sequence: [],
          mapping: [],
          fallback: []
        }
      }, index, length;
      function collectType(type) {
        type.multi ? (result.multi[type.kind].push(type), result.multi.fallback.push(type)) : result[type.kind][type.tag] = result.fallback[type.tag] = type;
      }
      for (index = 0, length = arguments.length; index < length; index += 1)
        arguments[index].forEach(collectType);
      return result;
    }
    function Schema(definition) {
      return this.extend(definition);
    }
    Schema.prototype.extend = function(definition) {
      var implicit = [], explicit = [];
      if (definition instanceof Type)
        explicit.push(definition);
      else if (Array.isArray(definition))
        explicit = explicit.concat(definition);
      else if (definition && (Array.isArray(definition.implicit) || Array.isArray(definition.explicit)))
        definition.implicit && (implicit = implicit.concat(definition.implicit)), definition.explicit && (explicit = explicit.concat(definition.explicit));
      else
        throw new YAMLException("Schema.extend argument should be a Type, [ Type ], or a schema definition ({ implicit: [...], explicit: [...] })");
      implicit.forEach(function(type) {
        if (!(type instanceof Type))
          throw new YAMLException("Specified list of YAML types (or a single Type object) contains a non-Type object.");
        if (type.loadKind && type.loadKind !== "scalar")
          throw new YAMLException("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.");
        if (type.multi)
          throw new YAMLException("There is a multi type in the implicit list of a schema. Multi tags can only be listed as explicit.");
      }), explicit.forEach(function(type) {
        if (!(type instanceof Type))
          throw new YAMLException("Specified list of YAML types (or a single Type object) contains a non-Type object.");
      });
      var result = Object.create(Schema.prototype);
      return result.implicit = (this.implicit || []).concat(implicit), result.explicit = (this.explicit || []).concat(explicit), result.compiledImplicit = compileList(result, "implicit"), result.compiledExplicit = compileList(result, "explicit"), result.compiledTypeMap = compileMap(result.compiledImplicit, result.compiledExplicit), result;
    };
    module.exports = Schema;
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/str.js
var require_str = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/str.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Type = require_type();
    module.exports = new Type("tag:yaml.org,2002:str", {
      kind: "scalar",
      construct: function(data) {
        return data !== null ? data : "";
      }
    });
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/seq.js
var require_seq2 = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/seq.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Type = require_type();
    module.exports = new Type("tag:yaml.org,2002:seq", {
      kind: "sequence",
      construct: function(data) {
        return data !== null ? data : [];
      }
    });
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/map.js
var require_map2 = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/map.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Type = require_type();
    module.exports = new Type("tag:yaml.org,2002:map", {
      kind: "mapping",
      construct: function(data) {
        return data !== null ? data : {};
      }
    });
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/failsafe.js
var require_failsafe = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/failsafe.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Schema = require_schema4();
    module.exports = new Schema({
      explicit: [
        require_str(),
        require_seq2(),
        require_map2()
      ]
    });
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/null.js
var require_null2 = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/null.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Type = require_type();
    function resolveYamlNull(data) {
      if (data === null)
        return !0;
      var max = data.length;
      return max === 1 && data === "~" || max === 4 && (data === "null" || data === "Null" || data === "NULL");
    }
    function constructYamlNull() {
      return null;
    }
    function isNull(object) {
      return object === null;
    }
    module.exports = new Type("tag:yaml.org,2002:null", {
      kind: "scalar",
      resolve: resolveYamlNull,
      construct: constructYamlNull,
      predicate: isNull,
      represent: {
        canonical: function() {
          return "~";
        },
        lowercase: function() {
          return "null";
        },
        uppercase: function() {
          return "NULL";
        },
        camelcase: function() {
          return "Null";
        },
        empty: function() {
          return "";
        }
      },
      defaultStyle: "lowercase"
    });
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/bool.js
var require_bool3 = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/bool.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Type = require_type();
    function resolveYamlBoolean(data) {
      if (data === null)
        return !1;
      var max = data.length;
      return max === 4 && (data === "true" || data === "True" || data === "TRUE") || max === 5 && (data === "false" || data === "False" || data === "FALSE");
    }
    function constructYamlBoolean(data) {
      return data === "true" || data === "True" || data === "TRUE";
    }
    function isBoolean2(object) {
      return Object.prototype.toString.call(object) === "[object Boolean]";
    }
    module.exports = new Type("tag:yaml.org,2002:bool", {
      kind: "scalar",
      resolve: resolveYamlBoolean,
      construct: constructYamlBoolean,
      predicate: isBoolean2,
      represent: {
        lowercase: function(object) {
          return object ? "true" : "false";
        },
        uppercase: function(object) {
          return object ? "TRUE" : "FALSE";
        },
        camelcase: function(object) {
          return object ? "True" : "False";
        }
      },
      defaultStyle: "lowercase"
    });
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/int.js
var require_int3 = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/int.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var common = require_common4(), Type = require_type();
    function isHexCode(c) {
      return 48 <= c && c <= 57 || 65 <= c && c <= 70 || 97 <= c && c <= 102;
    }
    function isOctCode(c) {
      return 48 <= c && c <= 55;
    }
    function isDecCode(c) {
      return 48 <= c && c <= 57;
    }
    function resolveYamlInteger(data) {
      if (data === null)
        return !1;
      var max = data.length, index = 0, hasDigits = !1, ch;
      if (!max)
        return !1;
      if (ch = data[index], (ch === "-" || ch === "+") && (ch = data[++index]), ch === "0") {
        if (index + 1 === max)
          return !0;
        if (ch = data[++index], ch === "b") {
          for (index++; index < max; index++)
            if (ch = data[index], ch !== "_") {
              if (ch !== "0" && ch !== "1")
                return !1;
              hasDigits = !0;
            }
          return hasDigits && ch !== "_";
        }
        if (ch === "x") {
          for (index++; index < max; index++)
            if (ch = data[index], ch !== "_") {
              if (!isHexCode(data.charCodeAt(index)))
                return !1;
              hasDigits = !0;
            }
          return hasDigits && ch !== "_";
        }
        if (ch === "o") {
          for (index++; index < max; index++)
            if (ch = data[index], ch !== "_") {
              if (!isOctCode(data.charCodeAt(index)))
                return !1;
              hasDigits = !0;
            }
          return hasDigits && ch !== "_";
        }
      }
      if (ch === "_")
        return !1;
      for (; index < max; index++)
        if (ch = data[index], ch !== "_") {
          if (!isDecCode(data.charCodeAt(index)))
            return !1;
          hasDigits = !0;
        }
      return !(!hasDigits || ch === "_");
    }
    function constructYamlInteger(data) {
      var value = data, sign = 1, ch;
      if (value.indexOf("_") !== -1 && (value = value.replace(/_/g, "")), ch = value[0], (ch === "-" || ch === "+") && (ch === "-" && (sign = -1), value = value.slice(1), ch = value[0]), value === "0")
        return 0;
      if (ch === "0") {
        if (value[1] === "b")
          return sign * parseInt(value.slice(2), 2);
        if (value[1] === "x")
          return sign * parseInt(value.slice(2), 16);
        if (value[1] === "o")
          return sign * parseInt(value.slice(2), 8);
      }
      return sign * parseInt(value, 10);
    }
    function isInteger(object) {
      return Object.prototype.toString.call(object) === "[object Number]" && object % 1 === 0 && !common.isNegativeZero(object);
    }
    module.exports = new Type("tag:yaml.org,2002:int", {
      kind: "scalar",
      resolve: resolveYamlInteger,
      construct: constructYamlInteger,
      predicate: isInteger,
      represent: {
        binary: function(obj) {
          return obj >= 0 ? "0b" + obj.toString(2) : "-0b" + obj.toString(2).slice(1);
        },
        octal: function(obj) {
          return obj >= 0 ? "0o" + obj.toString(8) : "-0o" + obj.toString(8).slice(1);
        },
        decimal: function(obj) {
          return obj.toString(10);
        },
        /* eslint-disable max-len */
        hexadecimal: function(obj) {
          return obj >= 0 ? "0x" + obj.toString(16).toUpperCase() : "-0x" + obj.toString(16).toUpperCase().slice(1);
        }
      },
      defaultStyle: "decimal",
      styleAliases: {
        binary: [2, "bin"],
        octal: [8, "oct"],
        decimal: [10, "dec"],
        hexadecimal: [16, "hex"]
      }
    });
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/float.js
var require_float3 = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/float.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var common = require_common4(), Type = require_type(), YAML_FLOAT_PATTERN = new RegExp(
      // 2.5e4, 2.5 and integers
      "^(?:[-+]?(?:[0-9][0-9_]*)(?:\\.[0-9_]*)?(?:[eE][-+]?[0-9]+)?|\\.[0-9_]+(?:[eE][-+]?[0-9]+)?|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$"
    );
    function resolveYamlFloat(data) {
      return !(data === null || !YAML_FLOAT_PATTERN.test(data) || // Quick hack to not allow integers end with `_`
      // Probably should update regexp & check speed
      data[data.length - 1] === "_");
    }
    function constructYamlFloat(data) {
      var value, sign;
      return value = data.replace(/_/g, "").toLowerCase(), sign = value[0] === "-" ? -1 : 1, "+-".indexOf(value[0]) >= 0 && (value = value.slice(1)), value === ".inf" ? sign === 1 ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY : value === ".nan" ? NaN : sign * parseFloat(value, 10);
    }
    var SCIENTIFIC_WITHOUT_DOT = /^[-+]?[0-9]+e/;
    function representYamlFloat(object, style) {
      var res;
      if (isNaN(object))
        switch (style) {
          case "lowercase":
            return ".nan";
          case "uppercase":
            return ".NAN";
          case "camelcase":
            return ".NaN";
        }
      else if (Number.POSITIVE_INFINITY === object)
        switch (style) {
          case "lowercase":
            return ".inf";
          case "uppercase":
            return ".INF";
          case "camelcase":
            return ".Inf";
        }
      else if (Number.NEGATIVE_INFINITY === object)
        switch (style) {
          case "lowercase":
            return "-.inf";
          case "uppercase":
            return "-.INF";
          case "camelcase":
            return "-.Inf";
        }
      else if (common.isNegativeZero(object))
        return "-0.0";
      return res = object.toString(10), SCIENTIFIC_WITHOUT_DOT.test(res) ? res.replace("e", ".e") : res;
    }
    function isFloat(object) {
      return Object.prototype.toString.call(object) === "[object Number]" && (object % 1 !== 0 || common.isNegativeZero(object));
    }
    module.exports = new Type("tag:yaml.org,2002:float", {
      kind: "scalar",
      resolve: resolveYamlFloat,
      construct: constructYamlFloat,
      predicate: isFloat,
      represent: representYamlFloat,
      defaultStyle: "lowercase"
    });
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/json.js
var require_json5 = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/json.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = require_failsafe().extend({
      implicit: [
        require_null2(),
        require_bool3(),
        require_int3(),
        require_float3()
      ]
    });
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/core.js
var require_core2 = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/core.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = require_json5();
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/timestamp.js
var require_timestamp2 = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/timestamp.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Type = require_type(), YAML_DATE_REGEXP = new RegExp(
      "^([0-9][0-9][0-9][0-9])-([0-9][0-9])-([0-9][0-9])$"
    ), YAML_TIMESTAMP_REGEXP = new RegExp(
      "^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?$"
    );
    function resolveYamlTimestamp(data) {
      return data === null ? !1 : YAML_DATE_REGEXP.exec(data) !== null || YAML_TIMESTAMP_REGEXP.exec(data) !== null;
    }
    function constructYamlTimestamp(data) {
      var match2, year, month, day, hour, minute, second, fraction = 0, delta = null, tz_hour, tz_minute, date;
      if (match2 = YAML_DATE_REGEXP.exec(data), match2 === null && (match2 = YAML_TIMESTAMP_REGEXP.exec(data)), match2 === null)
        throw new Error("Date resolve error");
      if (year = +match2[1], month = +match2[2] - 1, day = +match2[3], !match2[4])
        return new Date(Date.UTC(year, month, day));
      if (hour = +match2[4], minute = +match2[5], second = +match2[6], match2[7]) {
        for (fraction = match2[7].slice(0, 3); fraction.length < 3; )
          fraction += "0";
        fraction = +fraction;
      }
      return match2[9] && (tz_hour = +match2[10], tz_minute = +(match2[11] || 0), delta = (tz_hour * 60 + tz_minute) * 6e4, match2[9] === "-" && (delta = -delta)), date = new Date(Date.UTC(year, month, day, hour, minute, second, fraction)), delta && date.setTime(date.getTime() - delta), date;
    }
    function representYamlTimestamp(object) {
      return object.toISOString();
    }
    module.exports = new Type("tag:yaml.org,2002:timestamp", {
      kind: "scalar",
      resolve: resolveYamlTimestamp,
      construct: constructYamlTimestamp,
      instanceOf: Date,
      represent: representYamlTimestamp
    });
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/merge.js
var require_merge = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/merge.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Type = require_type();
    function resolveYamlMerge(data) {
      return data === "<<" || data === null;
    }
    module.exports = new Type("tag:yaml.org,2002:merge", {
      kind: "scalar",
      resolve: resolveYamlMerge
    });
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/binary.js
var require_binary2 = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/binary.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Type = require_type(), BASE64_MAP = `ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=
\r`;
    function resolveYamlBinary(data) {
      if (data === null)
        return !1;
      var code, idx, bitlen = 0, max = data.length, map = BASE64_MAP;
      for (idx = 0; idx < max; idx++)
        if (code = map.indexOf(data.charAt(idx)), !(code > 64)) {
          if (code < 0)
            return !1;
          bitlen += 6;
        }
      return bitlen % 8 === 0;
    }
    function constructYamlBinary(data) {
      var idx, tailbits, input = data.replace(/[\r\n=]/g, ""), max = input.length, map = BASE64_MAP, bits = 0, result = [];
      for (idx = 0; idx < max; idx++)
        idx % 4 === 0 && idx && (result.push(bits >> 16 & 255), result.push(bits >> 8 & 255), result.push(bits & 255)), bits = bits << 6 | map.indexOf(input.charAt(idx));
      return tailbits = max % 4 * 6, tailbits === 0 ? (result.push(bits >> 16 & 255), result.push(bits >> 8 & 255), result.push(bits & 255)) : tailbits === 18 ? (result.push(bits >> 10 & 255), result.push(bits >> 2 & 255)) : tailbits === 12 && result.push(bits >> 4 & 255), new Uint8Array(result);
    }
    function representYamlBinary(object) {
      var result = "", bits = 0, idx, tail, max = object.length, map = BASE64_MAP;
      for (idx = 0; idx < max; idx++)
        idx % 3 === 0 && idx && (result += map[bits >> 18 & 63], result += map[bits >> 12 & 63], result += map[bits >> 6 & 63], result += map[bits & 63]), bits = (bits << 8) + object[idx];
      return tail = max % 3, tail === 0 ? (result += map[bits >> 18 & 63], result += map[bits >> 12 & 63], result += map[bits >> 6 & 63], result += map[bits & 63]) : tail === 2 ? (result += map[bits >> 10 & 63], result += map[bits >> 4 & 63], result += map[bits << 2 & 63], result += map[64]) : tail === 1 && (result += map[bits >> 2 & 63], result += map[bits << 4 & 63], result += map[64], result += map[64]), result;
    }
    function isBinary(obj) {
      return Object.prototype.toString.call(obj) === "[object Uint8Array]";
    }
    module.exports = new Type("tag:yaml.org,2002:binary", {
      kind: "scalar",
      resolve: resolveYamlBinary,
      construct: constructYamlBinary,
      predicate: isBinary,
      represent: representYamlBinary
    });
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/omap.js
var require_omap2 = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/omap.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Type = require_type(), _hasOwnProperty = Object.prototype.hasOwnProperty, _toString = Object.prototype.toString;
    function resolveYamlOmap(data) {
      if (data === null)
        return !0;
      var objectKeys = [], index, length, pair, pairKey, pairHasKey, object = data;
      for (index = 0, length = object.length; index < length; index += 1) {
        if (pair = object[index], pairHasKey = !1, _toString.call(pair) !== "[object Object]")
          return !1;
        for (pairKey in pair)
          if (_hasOwnProperty.call(pair, pairKey))
            if (!pairHasKey)
              pairHasKey = !0;
            else
              return !1;
        if (!pairHasKey)
          return !1;
        if (objectKeys.indexOf(pairKey) === -1)
          objectKeys.push(pairKey);
        else
          return !1;
      }
      return !0;
    }
    function constructYamlOmap(data) {
      return data !== null ? data : [];
    }
    module.exports = new Type("tag:yaml.org,2002:omap", {
      kind: "sequence",
      resolve: resolveYamlOmap,
      construct: constructYamlOmap
    });
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/pairs.js
var require_pairs2 = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/pairs.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Type = require_type(), _toString = Object.prototype.toString;
    function resolveYamlPairs(data) {
      if (data === null)
        return !0;
      var index, length, pair, keys, result, object = data;
      for (result = new Array(object.length), index = 0, length = object.length; index < length; index += 1) {
        if (pair = object[index], _toString.call(pair) !== "[object Object]" || (keys = Object.keys(pair), keys.length !== 1))
          return !1;
        result[index] = [keys[0], pair[keys[0]]];
      }
      return !0;
    }
    function constructYamlPairs(data) {
      if (data === null)
        return [];
      var index, length, pair, keys, result, object = data;
      for (result = new Array(object.length), index = 0, length = object.length; index < length; index += 1)
        pair = object[index], keys = Object.keys(pair), result[index] = [keys[0], pair[keys[0]]];
      return result;
    }
    module.exports = new Type("tag:yaml.org,2002:pairs", {
      kind: "sequence",
      resolve: resolveYamlPairs,
      construct: constructYamlPairs
    });
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/set.js
var require_set3 = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/set.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Type = require_type(), _hasOwnProperty = Object.prototype.hasOwnProperty;
    function resolveYamlSet(data) {
      if (data === null)
        return !0;
      var key, object = data;
      for (key in object)
        if (_hasOwnProperty.call(object, key) && object[key] !== null)
          return !1;
      return !0;
    }
    function constructYamlSet(data) {
      return data !== null ? data : {};
    }
    module.exports = new Type("tag:yaml.org,2002:set", {
      kind: "mapping",
      resolve: resolveYamlSet,
      construct: constructYamlSet
    });
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/default.js
var require_default = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/default.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = require_core2().extend({
      implicit: [
        require_timestamp2(),
        require_merge()
      ],
      explicit: [
        require_binary2(),
        require_omap2(),
        require_pairs2(),
        require_set3()
      ]
    });
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/loader.js
var require_loader = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/loader.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var common = require_common4(), YAMLException = require_exception(), makeSnippet = require_snippet(), DEFAULT_SCHEMA = require_default(), _hasOwnProperty = Object.prototype.hasOwnProperty, CONTEXT_FLOW_IN = 1, CONTEXT_FLOW_OUT = 2, CONTEXT_BLOCK_IN = 3, CONTEXT_BLOCK_OUT = 4, CHOMPING_CLIP = 1, CHOMPING_STRIP = 2, CHOMPING_KEEP = 3, PATTERN_NON_PRINTABLE = /[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/, PATTERN_NON_ASCII_LINE_BREAKS = /[\x85\u2028\u2029]/, PATTERN_FLOW_INDICATORS = /[,\[\]\{\}]/, PATTERN_TAG_HANDLE = /^(?:!|!!|![a-z\-]+!)$/i, PATTERN_TAG_URI = /^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i;
    function _class(obj) {
      return Object.prototype.toString.call(obj);
    }
    function is_EOL(c) {
      return c === 10 || c === 13;
    }
    function is_WHITE_SPACE(c) {
      return c === 9 || c === 32;
    }
    function is_WS_OR_EOL(c) {
      return c === 9 || c === 32 || c === 10 || c === 13;
    }
    function is_FLOW_INDICATOR(c) {
      return c === 44 || c === 91 || c === 93 || c === 123 || c === 125;
    }
    function fromHexCode(c) {
      var lc;
      return 48 <= c && c <= 57 ? c - 48 : (lc = c | 32, 97 <= lc && lc <= 102 ? lc - 97 + 10 : -1);
    }
    function escapedHexLen(c) {
      return c === 120 ? 2 : c === 117 ? 4 : c === 85 ? 8 : 0;
    }
    function fromDecimalCode(c) {
      return 48 <= c && c <= 57 ? c - 48 : -1;
    }
    function simpleEscapeSequence(c) {
      return c === 48 ? "\0" : c === 97 ? "\x07" : c === 98 ? "\b" : c === 116 || c === 9 ? "	" : c === 110 ? `
` : c === 118 ? "\v" : c === 102 ? "\f" : c === 114 ? "\r" : c === 101 ? "\x1B" : c === 32 ? " " : c === 34 ? '"' : c === 47 ? "/" : c === 92 ? "\\" : c === 78 ? "\x85" : c === 95 ? "\xA0" : c === 76 ? "\u2028" : c === 80 ? "\u2029" : "";
    }
    function charFromCodepoint(c) {
      return c <= 65535 ? String.fromCharCode(c) : String.fromCharCode(
        (c - 65536 >> 10) + 55296,
        (c - 65536 & 1023) + 56320
      );
    }
    var simpleEscapeCheck = new Array(256), simpleEscapeMap = new Array(256);
    for (i = 0; i < 256; i++)
      simpleEscapeCheck[i] = simpleEscapeSequence(i) ? 1 : 0, simpleEscapeMap[i] = simpleEscapeSequence(i);
    var i;
    function State(input, options) {
      this.input = input, this.filename = options.filename || null, this.schema = options.schema || DEFAULT_SCHEMA, this.onWarning = options.onWarning || null, this.legacy = options.legacy || !1, this.json = options.json || !1, this.listener = options.listener || null, this.implicitTypes = this.schema.compiledImplicit, this.typeMap = this.schema.compiledTypeMap, this.length = input.length, this.position = 0, this.line = 0, this.lineStart = 0, this.lineIndent = 0, this.firstTabInLine = -1, this.documents = [];
    }
    function generateError(state, message) {
      var mark = {
        name: state.filename,
        buffer: state.input.slice(0, -1),
        // omit trailing \0
        position: state.position,
        line: state.line,
        column: state.position - state.lineStart
      };
      return mark.snippet = makeSnippet(mark), new YAMLException(message, mark);
    }
    function throwError(state, message) {
      throw generateError(state, message);
    }
    function throwWarning(state, message) {
      state.onWarning && state.onWarning.call(null, generateError(state, message));
    }
    var directiveHandlers = {
      YAML: function(state, name, args) {
        var match2, major, minor;
        state.version !== null && throwError(state, "duplication of %YAML directive"), args.length !== 1 && throwError(state, "YAML directive accepts exactly one argument"), match2 = /^([0-9]+)\.([0-9]+)$/.exec(args[0]), match2 === null && throwError(state, "ill-formed argument of the YAML directive"), major = parseInt(match2[1], 10), minor = parseInt(match2[2], 10), major !== 1 && throwError(state, "unacceptable YAML version of the document"), state.version = args[0], state.checkLineBreaks = minor < 2, minor !== 1 && minor !== 2 && throwWarning(state, "unsupported YAML version of the document");
      },
      TAG: function(state, name, args) {
        var handle, prefix;
        args.length !== 2 && throwError(state, "TAG directive accepts exactly two arguments"), handle = args[0], prefix = args[1], PATTERN_TAG_HANDLE.test(handle) || throwError(state, "ill-formed tag handle (first argument) of the TAG directive"), _hasOwnProperty.call(state.tagMap, handle) && throwError(state, 'there is a previously declared suffix for "' + handle + '" tag handle'), PATTERN_TAG_URI.test(prefix) || throwError(state, "ill-formed tag prefix (second argument) of the TAG directive");
        try {
          prefix = decodeURIComponent(prefix);
        } catch {
          throwError(state, "tag prefix is malformed: " + prefix);
        }
        state.tagMap[handle] = prefix;
      }
    };
    function captureSegment(state, start, end, checkJson) {
      var _position, _length, _character, _result;
      if (start < end) {
        if (_result = state.input.slice(start, end), checkJson)
          for (_position = 0, _length = _result.length; _position < _length; _position += 1)
            _character = _result.charCodeAt(_position), _character === 9 || 32 <= _character && _character <= 1114111 || throwError(state, "expected valid JSON character");
        else
          PATTERN_NON_PRINTABLE.test(_result) && throwError(state, "the stream contains non-printable characters");
        state.result += _result;
      }
    }
    function mergeMappings(state, destination, source, overridableKeys) {
      var sourceKeys, key, index, quantity;
      for (common.isObject(source) || throwError(state, "cannot merge mappings; the provided source object is unacceptable"), sourceKeys = Object.keys(source), index = 0, quantity = sourceKeys.length; index < quantity; index += 1)
        key = sourceKeys[index], _hasOwnProperty.call(destination, key) || (destination[key] = source[key], overridableKeys[key] = !0);
    }
    function storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, startLine, startLineStart, startPos) {
      var index, quantity;
      if (Array.isArray(keyNode))
        for (keyNode = Array.prototype.slice.call(keyNode), index = 0, quantity = keyNode.length; index < quantity; index += 1)
          Array.isArray(keyNode[index]) && throwError(state, "nested arrays are not supported inside keys"), typeof keyNode == "object" && _class(keyNode[index]) === "[object Object]" && (keyNode[index] = "[object Object]");
      if (typeof keyNode == "object" && _class(keyNode) === "[object Object]" && (keyNode = "[object Object]"), keyNode = String(keyNode), _result === null && (_result = {}), keyTag === "tag:yaml.org,2002:merge")
        if (Array.isArray(valueNode))
          for (index = 0, quantity = valueNode.length; index < quantity; index += 1)
            mergeMappings(state, _result, valueNode[index], overridableKeys);
        else
          mergeMappings(state, _result, valueNode, overridableKeys);
      else
        !state.json && !_hasOwnProperty.call(overridableKeys, keyNode) && _hasOwnProperty.call(_result, keyNode) && (state.line = startLine || state.line, state.lineStart = startLineStart || state.lineStart, state.position = startPos || state.position, throwError(state, "duplicated mapping key")), keyNode === "__proto__" ? Object.defineProperty(_result, keyNode, {
          configurable: !0,
          enumerable: !0,
          writable: !0,
          value: valueNode
        }) : _result[keyNode] = valueNode, delete overridableKeys[keyNode];
      return _result;
    }
    function readLineBreak(state) {
      var ch;
      ch = state.input.charCodeAt(state.position), ch === 10 ? state.position++ : ch === 13 ? (state.position++, state.input.charCodeAt(state.position) === 10 && state.position++) : throwError(state, "a line break is expected"), state.line += 1, state.lineStart = state.position, state.firstTabInLine = -1;
    }
    function skipSeparationSpace(state, allowComments, checkIndent) {
      for (var lineBreaks = 0, ch = state.input.charCodeAt(state.position); ch !== 0; ) {
        for (; is_WHITE_SPACE(ch); )
          ch === 9 && state.firstTabInLine === -1 && (state.firstTabInLine = state.position), ch = state.input.charCodeAt(++state.position);
        if (allowComments && ch === 35)
          do
            ch = state.input.charCodeAt(++state.position);
          while (ch !== 10 && ch !== 13 && ch !== 0);
        if (is_EOL(ch))
          for (readLineBreak(state), ch = state.input.charCodeAt(state.position), lineBreaks++, state.lineIndent = 0; ch === 32; )
            state.lineIndent++, ch = state.input.charCodeAt(++state.position);
        else
          break;
      }
      return checkIndent !== -1 && lineBreaks !== 0 && state.lineIndent < checkIndent && throwWarning(state, "deficient indentation"), lineBreaks;
    }
    function testDocumentSeparator(state) {
      var _position = state.position, ch;
      return ch = state.input.charCodeAt(_position), !!((ch === 45 || ch === 46) && ch === state.input.charCodeAt(_position + 1) && ch === state.input.charCodeAt(_position + 2) && (_position += 3, ch = state.input.charCodeAt(_position), ch === 0 || is_WS_OR_EOL(ch)));
    }
    function writeFoldedLines(state, count) {
      count === 1 ? state.result += " " : count > 1 && (state.result += common.repeat(`
`, count - 1));
    }
    function readPlainScalar(state, nodeIndent, withinFlowCollection) {
      var preceding, following, captureStart, captureEnd, hasPendingContent, _line, _lineStart, _lineIndent, _kind = state.kind, _result = state.result, ch;
      if (ch = state.input.charCodeAt(state.position), is_WS_OR_EOL(ch) || is_FLOW_INDICATOR(ch) || ch === 35 || ch === 38 || ch === 42 || ch === 33 || ch === 124 || ch === 62 || ch === 39 || ch === 34 || ch === 37 || ch === 64 || ch === 96 || (ch === 63 || ch === 45) && (following = state.input.charCodeAt(state.position + 1), is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following)))
        return !1;
      for (state.kind = "scalar", state.result = "", captureStart = captureEnd = state.position, hasPendingContent = !1; ch !== 0; ) {
        if (ch === 58) {
          if (following = state.input.charCodeAt(state.position + 1), is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following))
            break;
        } else if (ch === 35) {
          if (preceding = state.input.charCodeAt(state.position - 1), is_WS_OR_EOL(preceding))
            break;
        } else {
          if (state.position === state.lineStart && testDocumentSeparator(state) || withinFlowCollection && is_FLOW_INDICATOR(ch))
            break;
          if (is_EOL(ch))
            if (_line = state.line, _lineStart = state.lineStart, _lineIndent = state.lineIndent, skipSeparationSpace(state, !1, -1), state.lineIndent >= nodeIndent) {
              hasPendingContent = !0, ch = state.input.charCodeAt(state.position);
              continue;
            } else {
              state.position = captureEnd, state.line = _line, state.lineStart = _lineStart, state.lineIndent = _lineIndent;
              break;
            }
        }
        hasPendingContent && (captureSegment(state, captureStart, captureEnd, !1), writeFoldedLines(state, state.line - _line), captureStart = captureEnd = state.position, hasPendingContent = !1), is_WHITE_SPACE(ch) || (captureEnd = state.position + 1), ch = state.input.charCodeAt(++state.position);
      }
      return captureSegment(state, captureStart, captureEnd, !1), state.result ? !0 : (state.kind = _kind, state.result = _result, !1);
    }
    function readSingleQuotedScalar(state, nodeIndent) {
      var ch, captureStart, captureEnd;
      if (ch = state.input.charCodeAt(state.position), ch !== 39)
        return !1;
      for (state.kind = "scalar", state.result = "", state.position++, captureStart = captureEnd = state.position; (ch = state.input.charCodeAt(state.position)) !== 0; )
        if (ch === 39)
          if (captureSegment(state, captureStart, state.position, !0), ch = state.input.charCodeAt(++state.position), ch === 39)
            captureStart = state.position, state.position++, captureEnd = state.position;
          else
            return !0;
        else
          is_EOL(ch) ? (captureSegment(state, captureStart, captureEnd, !0), writeFoldedLines(state, skipSeparationSpace(state, !1, nodeIndent)), captureStart = captureEnd = state.position) : state.position === state.lineStart && testDocumentSeparator(state) ? throwError(state, "unexpected end of the document within a single quoted scalar") : (state.position++, captureEnd = state.position);
      throwError(state, "unexpected end of the stream within a single quoted scalar");
    }
    function readDoubleQuotedScalar(state, nodeIndent) {
      var captureStart, captureEnd, hexLength, hexResult, tmp, ch;
      if (ch = state.input.charCodeAt(state.position), ch !== 34)
        return !1;
      for (state.kind = "scalar", state.result = "", state.position++, captureStart = captureEnd = state.position; (ch = state.input.charCodeAt(state.position)) !== 0; ) {
        if (ch === 34)
          return captureSegment(state, captureStart, state.position, !0), state.position++, !0;
        if (ch === 92) {
          if (captureSegment(state, captureStart, state.position, !0), ch = state.input.charCodeAt(++state.position), is_EOL(ch))
            skipSeparationSpace(state, !1, nodeIndent);
          else if (ch < 256 && simpleEscapeCheck[ch])
            state.result += simpleEscapeMap[ch], state.position++;
          else if ((tmp = escapedHexLen(ch)) > 0) {
            for (hexLength = tmp, hexResult = 0; hexLength > 0; hexLength--)
              ch = state.input.charCodeAt(++state.position), (tmp = fromHexCode(ch)) >= 0 ? hexResult = (hexResult << 4) + tmp : throwError(state, "expected hexadecimal character");
            state.result += charFromCodepoint(hexResult), state.position++;
          } else
            throwError(state, "unknown escape sequence");
          captureStart = captureEnd = state.position;
        } else
          is_EOL(ch) ? (captureSegment(state, captureStart, captureEnd, !0), writeFoldedLines(state, skipSeparationSpace(state, !1, nodeIndent)), captureStart = captureEnd = state.position) : state.position === state.lineStart && testDocumentSeparator(state) ? throwError(state, "unexpected end of the document within a double quoted scalar") : (state.position++, captureEnd = state.position);
      }
      throwError(state, "unexpected end of the stream within a double quoted scalar");
    }
    function readFlowCollection(state, nodeIndent) {
      var readNext = !0, _line, _lineStart, _pos, _tag = state.tag, _result, _anchor = state.anchor, following, terminator, isPair, isExplicitPair, isMapping, overridableKeys = /* @__PURE__ */ Object.create(null), keyNode, keyTag, valueNode, ch;
      if (ch = state.input.charCodeAt(state.position), ch === 91)
        terminator = 93, isMapping = !1, _result = [];
      else if (ch === 123)
        terminator = 125, isMapping = !0, _result = {};
      else
        return !1;
      for (state.anchor !== null && (state.anchorMap[state.anchor] = _result), ch = state.input.charCodeAt(++state.position); ch !== 0; ) {
        if (skipSeparationSpace(state, !0, nodeIndent), ch = state.input.charCodeAt(state.position), ch === terminator)
          return state.position++, state.tag = _tag, state.anchor = _anchor, state.kind = isMapping ? "mapping" : "sequence", state.result = _result, !0;
        readNext ? ch === 44 && throwError(state, "expected the node content, but found ','") : throwError(state, "missed comma between flow collection entries"), keyTag = keyNode = valueNode = null, isPair = isExplicitPair = !1, ch === 63 && (following = state.input.charCodeAt(state.position + 1), is_WS_OR_EOL(following) && (isPair = isExplicitPair = !0, state.position++, skipSeparationSpace(state, !0, nodeIndent))), _line = state.line, _lineStart = state.lineStart, _pos = state.position, composeNode(state, nodeIndent, CONTEXT_FLOW_IN, !1, !0), keyTag = state.tag, keyNode = state.result, skipSeparationSpace(state, !0, nodeIndent), ch = state.input.charCodeAt(state.position), (isExplicitPair || state.line === _line) && ch === 58 && (isPair = !0, ch = state.input.charCodeAt(++state.position), skipSeparationSpace(state, !0, nodeIndent), composeNode(state, nodeIndent, CONTEXT_FLOW_IN, !1, !0), valueNode = state.result), isMapping ? storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos) : isPair ? _result.push(storeMappingPair(state, null, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos)) : _result.push(keyNode), skipSeparationSpace(state, !0, nodeIndent), ch = state.input.charCodeAt(state.position), ch === 44 ? (readNext = !0, ch = state.input.charCodeAt(++state.position)) : readNext = !1;
      }
      throwError(state, "unexpected end of the stream within a flow collection");
    }
    function readBlockScalar(state, nodeIndent) {
      var captureStart, folding, chomping = CHOMPING_CLIP, didReadContent = !1, detectedIndent = !1, textIndent = nodeIndent, emptyLines = 0, atMoreIndented = !1, tmp, ch;
      if (ch = state.input.charCodeAt(state.position), ch === 124)
        folding = !1;
      else if (ch === 62)
        folding = !0;
      else
        return !1;
      for (state.kind = "scalar", state.result = ""; ch !== 0; )
        if (ch = state.input.charCodeAt(++state.position), ch === 43 || ch === 45)
          CHOMPING_CLIP === chomping ? chomping = ch === 43 ? CHOMPING_KEEP : CHOMPING_STRIP : throwError(state, "repeat of a chomping mode identifier");
        else if ((tmp = fromDecimalCode(ch)) >= 0)
          tmp === 0 ? throwError(state, "bad explicit indentation width of a block scalar; it cannot be less than one") : detectedIndent ? throwError(state, "repeat of an indentation width identifier") : (textIndent = nodeIndent + tmp - 1, detectedIndent = !0);
        else
          break;
      if (is_WHITE_SPACE(ch)) {
        do
          ch = state.input.charCodeAt(++state.position);
        while (is_WHITE_SPACE(ch));
        if (ch === 35)
          do
            ch = state.input.charCodeAt(++state.position);
          while (!is_EOL(ch) && ch !== 0);
      }
      for (; ch !== 0; ) {
        for (readLineBreak(state), state.lineIndent = 0, ch = state.input.charCodeAt(state.position); (!detectedIndent || state.lineIndent < textIndent) && ch === 32; )
          state.lineIndent++, ch = state.input.charCodeAt(++state.position);
        if (!detectedIndent && state.lineIndent > textIndent && (textIndent = state.lineIndent), is_EOL(ch)) {
          emptyLines++;
          continue;
        }
        if (state.lineIndent < textIndent) {
          chomping === CHOMPING_KEEP ? state.result += common.repeat(`
`, didReadContent ? 1 + emptyLines : emptyLines) : chomping === CHOMPING_CLIP && didReadContent && (state.result += `
`);
          break;
        }
        for (folding ? is_WHITE_SPACE(ch) ? (atMoreIndented = !0, state.result += common.repeat(`
`, didReadContent ? 1 + emptyLines : emptyLines)) : atMoreIndented ? (atMoreIndented = !1, state.result += common.repeat(`
`, emptyLines + 1)) : emptyLines === 0 ? didReadContent && (state.result += " ") : state.result += common.repeat(`
`, emptyLines) : state.result += common.repeat(`
`, didReadContent ? 1 + emptyLines : emptyLines), didReadContent = !0, detectedIndent = !0, emptyLines = 0, captureStart = state.position; !is_EOL(ch) && ch !== 0; )
          ch = state.input.charCodeAt(++state.position);
        captureSegment(state, captureStart, state.position, !1);
      }
      return !0;
    }
    function readBlockSequence(state, nodeIndent) {
      var _line, _tag = state.tag, _anchor = state.anchor, _result = [], following, detected = !1, ch;
      if (state.firstTabInLine !== -1)
        return !1;
      for (state.anchor !== null && (state.anchorMap[state.anchor] = _result), ch = state.input.charCodeAt(state.position); ch !== 0 && (state.firstTabInLine !== -1 && (state.position = state.firstTabInLine, throwError(state, "tab characters must not be used in indentation")), !(ch !== 45 || (following = state.input.charCodeAt(state.position + 1), !is_WS_OR_EOL(following)))); ) {
        if (detected = !0, state.position++, skipSeparationSpace(state, !0, -1) && state.lineIndent <= nodeIndent) {
          _result.push(null), ch = state.input.charCodeAt(state.position);
          continue;
        }
        if (_line = state.line, composeNode(state, nodeIndent, CONTEXT_BLOCK_IN, !1, !0), _result.push(state.result), skipSeparationSpace(state, !0, -1), ch = state.input.charCodeAt(state.position), (state.line === _line || state.lineIndent > nodeIndent) && ch !== 0)
          throwError(state, "bad indentation of a sequence entry");
        else if (state.lineIndent < nodeIndent)
          break;
      }
      return detected ? (state.tag = _tag, state.anchor = _anchor, state.kind = "sequence", state.result = _result, !0) : !1;
    }
    function readBlockMapping(state, nodeIndent, flowIndent) {
      var following, allowCompact, _line, _keyLine, _keyLineStart, _keyPos, _tag = state.tag, _anchor = state.anchor, _result = {}, overridableKeys = /* @__PURE__ */ Object.create(null), keyTag = null, keyNode = null, valueNode = null, atExplicitKey = !1, detected = !1, ch;
      if (state.firstTabInLine !== -1)
        return !1;
      for (state.anchor !== null && (state.anchorMap[state.anchor] = _result), ch = state.input.charCodeAt(state.position); ch !== 0; ) {
        if (!atExplicitKey && state.firstTabInLine !== -1 && (state.position = state.firstTabInLine, throwError(state, "tab characters must not be used in indentation")), following = state.input.charCodeAt(state.position + 1), _line = state.line, (ch === 63 || ch === 58) && is_WS_OR_EOL(following))
          ch === 63 ? (atExplicitKey && (storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos), keyTag = keyNode = valueNode = null), detected = !0, atExplicitKey = !0, allowCompact = !0) : atExplicitKey ? (atExplicitKey = !1, allowCompact = !0) : throwError(state, "incomplete explicit mapping pair; a key node is missed; or followed by a non-tabulated empty line"), state.position += 1, ch = following;
        else {
          if (_keyLine = state.line, _keyLineStart = state.lineStart, _keyPos = state.position, !composeNode(state, flowIndent, CONTEXT_FLOW_OUT, !1, !0))
            break;
          if (state.line === _line) {
            for (ch = state.input.charCodeAt(state.position); is_WHITE_SPACE(ch); )
              ch = state.input.charCodeAt(++state.position);
            if (ch === 58)
              ch = state.input.charCodeAt(++state.position), is_WS_OR_EOL(ch) || throwError(state, "a whitespace character is expected after the key-value separator within a block mapping"), atExplicitKey && (storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos), keyTag = keyNode = valueNode = null), detected = !0, atExplicitKey = !1, allowCompact = !1, keyTag = state.tag, keyNode = state.result;
            else if (detected)
              throwError(state, "can not read an implicit mapping pair; a colon is missed");
            else
              return state.tag = _tag, state.anchor = _anchor, !0;
          } else if (detected)
            throwError(state, "can not read a block mapping entry; a multiline key may not be an implicit key");
          else
            return state.tag = _tag, state.anchor = _anchor, !0;
        }
        if ((state.line === _line || state.lineIndent > nodeIndent) && (atExplicitKey && (_keyLine = state.line, _keyLineStart = state.lineStart, _keyPos = state.position), composeNode(state, nodeIndent, CONTEXT_BLOCK_OUT, !0, allowCompact) && (atExplicitKey ? keyNode = state.result : valueNode = state.result), atExplicitKey || (storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _keyLine, _keyLineStart, _keyPos), keyTag = keyNode = valueNode = null), skipSeparationSpace(state, !0, -1), ch = state.input.charCodeAt(state.position)), (state.line === _line || state.lineIndent > nodeIndent) && ch !== 0)
          throwError(state, "bad indentation of a mapping entry");
        else if (state.lineIndent < nodeIndent)
          break;
      }
      return atExplicitKey && storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos), detected && (state.tag = _tag, state.anchor = _anchor, state.kind = "mapping", state.result = _result), detected;
    }
    function readTagProperty(state) {
      var _position, isVerbatim = !1, isNamed = !1, tagHandle, tagName, ch;
      if (ch = state.input.charCodeAt(state.position), ch !== 33)
        return !1;
      if (state.tag !== null && throwError(state, "duplication of a tag property"), ch = state.input.charCodeAt(++state.position), ch === 60 ? (isVerbatim = !0, ch = state.input.charCodeAt(++state.position)) : ch === 33 ? (isNamed = !0, tagHandle = "!!", ch = state.input.charCodeAt(++state.position)) : tagHandle = "!", _position = state.position, isVerbatim) {
        do
          ch = state.input.charCodeAt(++state.position);
        while (ch !== 0 && ch !== 62);
        state.position < state.length ? (tagName = state.input.slice(_position, state.position), ch = state.input.charCodeAt(++state.position)) : throwError(state, "unexpected end of the stream within a verbatim tag");
      } else {
        for (; ch !== 0 && !is_WS_OR_EOL(ch); )
          ch === 33 && (isNamed ? throwError(state, "tag suffix cannot contain exclamation marks") : (tagHandle = state.input.slice(_position - 1, state.position + 1), PATTERN_TAG_HANDLE.test(tagHandle) || throwError(state, "named tag handle cannot contain such characters"), isNamed = !0, _position = state.position + 1)), ch = state.input.charCodeAt(++state.position);
        tagName = state.input.slice(_position, state.position), PATTERN_FLOW_INDICATORS.test(tagName) && throwError(state, "tag suffix cannot contain flow indicator characters");
      }
      tagName && !PATTERN_TAG_URI.test(tagName) && throwError(state, "tag name cannot contain such characters: " + tagName);
      try {
        tagName = decodeURIComponent(tagName);
      } catch {
        throwError(state, "tag name is malformed: " + tagName);
      }
      return isVerbatim ? state.tag = tagName : _hasOwnProperty.call(state.tagMap, tagHandle) ? state.tag = state.tagMap[tagHandle] + tagName : tagHandle === "!" ? state.tag = "!" + tagName : tagHandle === "!!" ? state.tag = "tag:yaml.org,2002:" + tagName : throwError(state, 'undeclared tag handle "' + tagHandle + '"'), !0;
    }
    function readAnchorProperty(state) {
      var _position, ch;
      if (ch = state.input.charCodeAt(state.position), ch !== 38)
        return !1;
      for (state.anchor !== null && throwError(state, "duplication of an anchor property"), ch = state.input.charCodeAt(++state.position), _position = state.position; ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch); )
        ch = state.input.charCodeAt(++state.position);
      return state.position === _position && throwError(state, "name of an anchor node must contain at least one character"), state.anchor = state.input.slice(_position, state.position), !0;
    }
    function readAlias(state) {
      var _position, alias, ch;
      if (ch = state.input.charCodeAt(state.position), ch !== 42)
        return !1;
      for (ch = state.input.charCodeAt(++state.position), _position = state.position; ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch); )
        ch = state.input.charCodeAt(++state.position);
      return state.position === _position && throwError(state, "name of an alias node must contain at least one character"), alias = state.input.slice(_position, state.position), _hasOwnProperty.call(state.anchorMap, alias) || throwError(state, 'unidentified alias "' + alias + '"'), state.result = state.anchorMap[alias], skipSeparationSpace(state, !0, -1), !0;
    }
    function composeNode(state, parentIndent, nodeContext, allowToSeek, allowCompact) {
      var allowBlockStyles, allowBlockScalars, allowBlockCollections, indentStatus = 1, atNewLine = !1, hasContent = !1, typeIndex, typeQuantity, typeList, type, flowIndent, blockIndent;
      if (state.listener !== null && state.listener("open", state), state.tag = null, state.anchor = null, state.kind = null, state.result = null, allowBlockStyles = allowBlockScalars = allowBlockCollections = CONTEXT_BLOCK_OUT === nodeContext || CONTEXT_BLOCK_IN === nodeContext, allowToSeek && skipSeparationSpace(state, !0, -1) && (atNewLine = !0, state.lineIndent > parentIndent ? indentStatus = 1 : state.lineIndent === parentIndent ? indentStatus = 0 : state.lineIndent < parentIndent && (indentStatus = -1)), indentStatus === 1)
        for (; readTagProperty(state) || readAnchorProperty(state); )
          skipSeparationSpace(state, !0, -1) ? (atNewLine = !0, allowBlockCollections = allowBlockStyles, state.lineIndent > parentIndent ? indentStatus = 1 : state.lineIndent === parentIndent ? indentStatus = 0 : state.lineIndent < parentIndent && (indentStatus = -1)) : allowBlockCollections = !1;
      if (allowBlockCollections && (allowBlockCollections = atNewLine || allowCompact), (indentStatus === 1 || CONTEXT_BLOCK_OUT === nodeContext) && (CONTEXT_FLOW_IN === nodeContext || CONTEXT_FLOW_OUT === nodeContext ? flowIndent = parentIndent : flowIndent = parentIndent + 1, blockIndent = state.position - state.lineStart, indentStatus === 1 ? allowBlockCollections && (readBlockSequence(state, blockIndent) || readBlockMapping(state, blockIndent, flowIndent)) || readFlowCollection(state, flowIndent) ? hasContent = !0 : (allowBlockScalars && readBlockScalar(state, flowIndent) || readSingleQuotedScalar(state, flowIndent) || readDoubleQuotedScalar(state, flowIndent) ? hasContent = !0 : readAlias(state) ? (hasContent = !0, (state.tag !== null || state.anchor !== null) && throwError(state, "alias node should not have any properties")) : readPlainScalar(state, flowIndent, CONTEXT_FLOW_IN === nodeContext) && (hasContent = !0, state.tag === null && (state.tag = "?")), state.anchor !== null && (state.anchorMap[state.anchor] = state.result)) : indentStatus === 0 && (hasContent = allowBlockCollections && readBlockSequence(state, blockIndent))), state.tag === null)
        state.anchor !== null && (state.anchorMap[state.anchor] = state.result);
      else if (state.tag === "?") {
        for (state.result !== null && state.kind !== "scalar" && throwError(state, 'unacceptable node kind for !<?> tag; it should be "scalar", not "' + state.kind + '"'), typeIndex = 0, typeQuantity = state.implicitTypes.length; typeIndex < typeQuantity; typeIndex += 1)
          if (type = state.implicitTypes[typeIndex], type.resolve(state.result)) {
            state.result = type.construct(state.result), state.tag = type.tag, state.anchor !== null && (state.anchorMap[state.anchor] = state.result);
            break;
          }
      } else if (state.tag !== "!") {
        if (_hasOwnProperty.call(state.typeMap[state.kind || "fallback"], state.tag))
          type = state.typeMap[state.kind || "fallback"][state.tag];
        else
          for (type = null, typeList = state.typeMap.multi[state.kind || "fallback"], typeIndex = 0, typeQuantity = typeList.length; typeIndex < typeQuantity; typeIndex += 1)
            if (state.tag.slice(0, typeList[typeIndex].tag.length) === typeList[typeIndex].tag) {
              type = typeList[typeIndex];
              break;
            }
        type || throwError(state, "unknown tag !<" + state.tag + ">"), state.result !== null && type.kind !== state.kind && throwError(state, "unacceptable node kind for !<" + state.tag + '> tag; it should be "' + type.kind + '", not "' + state.kind + '"'), type.resolve(state.result, state.tag) ? (state.result = type.construct(state.result, state.tag), state.anchor !== null && (state.anchorMap[state.anchor] = state.result)) : throwError(state, "cannot resolve a node with !<" + state.tag + "> explicit tag");
      }
      return state.listener !== null && state.listener("close", state), state.tag !== null || state.anchor !== null || hasContent;
    }
    function readDocument(state) {
      var documentStart = state.position, _position, directiveName, directiveArgs, hasDirectives = !1, ch;
      for (state.version = null, state.checkLineBreaks = state.legacy, state.tagMap = /* @__PURE__ */ Object.create(null), state.anchorMap = /* @__PURE__ */ Object.create(null); (ch = state.input.charCodeAt(state.position)) !== 0 && (skipSeparationSpace(state, !0, -1), ch = state.input.charCodeAt(state.position), !(state.lineIndent > 0 || ch !== 37)); ) {
        for (hasDirectives = !0, ch = state.input.charCodeAt(++state.position), _position = state.position; ch !== 0 && !is_WS_OR_EOL(ch); )
          ch = state.input.charCodeAt(++state.position);
        for (directiveName = state.input.slice(_position, state.position), directiveArgs = [], directiveName.length < 1 && throwError(state, "directive name must not be less than one character in length"); ch !== 0; ) {
          for (; is_WHITE_SPACE(ch); )
            ch = state.input.charCodeAt(++state.position);
          if (ch === 35) {
            do
              ch = state.input.charCodeAt(++state.position);
            while (ch !== 0 && !is_EOL(ch));
            break;
          }
          if (is_EOL(ch))
            break;
          for (_position = state.position; ch !== 0 && !is_WS_OR_EOL(ch); )
            ch = state.input.charCodeAt(++state.position);
          directiveArgs.push(state.input.slice(_position, state.position));
        }
        ch !== 0 && readLineBreak(state), _hasOwnProperty.call(directiveHandlers, directiveName) ? directiveHandlers[directiveName](state, directiveName, directiveArgs) : throwWarning(state, 'unknown document directive "' + directiveName + '"');
      }
      if (skipSeparationSpace(state, !0, -1), state.lineIndent === 0 && state.input.charCodeAt(state.position) === 45 && state.input.charCodeAt(state.position + 1) === 45 && state.input.charCodeAt(state.position + 2) === 45 ? (state.position += 3, skipSeparationSpace(state, !0, -1)) : hasDirectives && throwError(state, "directives end mark is expected"), composeNode(state, state.lineIndent - 1, CONTEXT_BLOCK_OUT, !1, !0), skipSeparationSpace(state, !0, -1), state.checkLineBreaks && PATTERN_NON_ASCII_LINE_BREAKS.test(state.input.slice(documentStart, state.position)) && throwWarning(state, "non-ASCII line breaks are interpreted as content"), state.documents.push(state.result), state.position === state.lineStart && testDocumentSeparator(state)) {
        state.input.charCodeAt(state.position) === 46 && (state.position += 3, skipSeparationSpace(state, !0, -1));
        return;
      }
      if (state.position < state.length - 1)
        throwError(state, "end of the stream or a document separator is expected");
      else
        return;
    }
    function loadDocuments(input, options) {
      input = String(input), options = options || {}, input.length !== 0 && (input.charCodeAt(input.length - 1) !== 10 && input.charCodeAt(input.length - 1) !== 13 && (input += `
`), input.charCodeAt(0) === 65279 && (input = input.slice(1)));
      var state = new State(input, options), nullpos = input.indexOf("\0");
      for (nullpos !== -1 && (state.position = nullpos, throwError(state, "null byte is not allowed in input")), state.input += "\0"; state.input.charCodeAt(state.position) === 32; )
        state.lineIndent += 1, state.position += 1;
      for (; state.position < state.length - 1; )
        readDocument(state);
      return state.documents;
    }
    function loadAll(input, iterator, options) {
      iterator !== null && typeof iterator == "object" && typeof options > "u" && (options = iterator, iterator = null);
      var documents = loadDocuments(input, options);
      if (typeof iterator != "function")
        return documents;
      for (var index = 0, length = documents.length; index < length; index += 1)
        iterator(documents[index]);
    }
    function load(input, options) {
      var documents = loadDocuments(input, options);
      if (documents.length !== 0) {
        if (documents.length === 1)
          return documents[0];
        throw new YAMLException("expected a single document in the stream, but found more");
      }
    }
    module.exports.loadAll = loadAll;
    module.exports.load = load;
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/dumper.js
var require_dumper = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/dumper.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var common = require_common4(), YAMLException = require_exception(), DEFAULT_SCHEMA = require_default(), _toString = Object.prototype.toString, _hasOwnProperty = Object.prototype.hasOwnProperty, CHAR_BOM = 65279, CHAR_TAB = 9, CHAR_LINE_FEED = 10, CHAR_CARRIAGE_RETURN = 13, CHAR_SPACE = 32, CHAR_EXCLAMATION = 33, CHAR_DOUBLE_QUOTE = 34, CHAR_SHARP = 35, CHAR_PERCENT = 37, CHAR_AMPERSAND = 38, CHAR_SINGLE_QUOTE = 39, CHAR_ASTERISK = 42, CHAR_COMMA = 44, CHAR_MINUS = 45, CHAR_COLON = 58, CHAR_EQUALS = 61, CHAR_GREATER_THAN = 62, CHAR_QUESTION = 63, CHAR_COMMERCIAL_AT = 64, CHAR_LEFT_SQUARE_BRACKET = 91, CHAR_RIGHT_SQUARE_BRACKET = 93, CHAR_GRAVE_ACCENT = 96, CHAR_LEFT_CURLY_BRACKET = 123, CHAR_VERTICAL_LINE = 124, CHAR_RIGHT_CURLY_BRACKET = 125, ESCAPE_SEQUENCES = {};
    ESCAPE_SEQUENCES[0] = "\\0";
    ESCAPE_SEQUENCES[7] = "\\a";
    ESCAPE_SEQUENCES[8] = "\\b";
    ESCAPE_SEQUENCES[9] = "\\t";
    ESCAPE_SEQUENCES[10] = "\\n";
    ESCAPE_SEQUENCES[11] = "\\v";
    ESCAPE_SEQUENCES[12] = "\\f";
    ESCAPE_SEQUENCES[13] = "\\r";
    ESCAPE_SEQUENCES[27] = "\\e";
    ESCAPE_SEQUENCES[34] = '\\"';
    ESCAPE_SEQUENCES[92] = "\\\\";
    ESCAPE_SEQUENCES[133] = "\\N";
    ESCAPE_SEQUENCES[160] = "\\_";
    ESCAPE_SEQUENCES[8232] = "\\L";
    ESCAPE_SEQUENCES[8233] = "\\P";
    var DEPRECATED_BOOLEANS_SYNTAX = [
      "y",
      "Y",
      "yes",
      "Yes",
      "YES",
      "on",
      "On",
      "ON",
      "n",
      "N",
      "no",
      "No",
      "NO",
      "off",
      "Off",
      "OFF"
    ], DEPRECATED_BASE60_SYNTAX = /^[-+]?[0-9_]+(?::[0-9_]+)+(?:\.[0-9_]*)?$/;
    function compileStyleMap(schema, map) {
      var result, keys, index, length, tag, style, type;
      if (map === null)
        return {};
      for (result = {}, keys = Object.keys(map), index = 0, length = keys.length; index < length; index += 1)
        tag = keys[index], style = String(map[tag]), tag.slice(0, 2) === "!!" && (tag = "tag:yaml.org,2002:" + tag.slice(2)), type = schema.compiledTypeMap.fallback[tag], type && _hasOwnProperty.call(type.styleAliases, style) && (style = type.styleAliases[style]), result[tag] = style;
      return result;
    }
    function encodeHex(character) {
      var string, handle, length;
      if (string = character.toString(16).toUpperCase(), character <= 255)
        handle = "x", length = 2;
      else if (character <= 65535)
        handle = "u", length = 4;
      else if (character <= 4294967295)
        handle = "U", length = 8;
      else
        throw new YAMLException("code point within a string may not be greater than 0xFFFFFFFF");
      return "\\" + handle + common.repeat("0", length - string.length) + string;
    }
    var QUOTING_TYPE_SINGLE = 1, QUOTING_TYPE_DOUBLE = 2;
    function State(options) {
      this.schema = options.schema || DEFAULT_SCHEMA, this.indent = Math.max(1, options.indent || 2), this.noArrayIndent = options.noArrayIndent || !1, this.skipInvalid = options.skipInvalid || !1, this.flowLevel = common.isNothing(options.flowLevel) ? -1 : options.flowLevel, this.styleMap = compileStyleMap(this.schema, options.styles || null), this.sortKeys = options.sortKeys || !1, this.lineWidth = options.lineWidth || 80, this.noRefs = options.noRefs || !1, this.noCompatMode = options.noCompatMode || !1, this.condenseFlow = options.condenseFlow || !1, this.quotingType = options.quotingType === '"' ? QUOTING_TYPE_DOUBLE : QUOTING_TYPE_SINGLE, this.forceQuotes = options.forceQuotes || !1, this.replacer = typeof options.replacer == "function" ? options.replacer : null, this.implicitTypes = this.schema.compiledImplicit, this.explicitTypes = this.schema.compiledExplicit, this.tag = null, this.result = "", this.duplicates = [], this.usedDuplicates = null;
    }
    function indentString(string, spaces) {
      for (var ind = common.repeat(" ", spaces), position = 0, next = -1, result = "", line, length = string.length; position < length; )
        next = string.indexOf(`
`, position), next === -1 ? (line = string.slice(position), position = length) : (line = string.slice(position, next + 1), position = next + 1), line.length && line !== `
` && (result += ind), result += line;
      return result;
    }
    function generateNextLine(state, level) {
      return `
` + common.repeat(" ", state.indent * level);
    }
    function testImplicitResolving(state, str) {
      var index, length, type;
      for (index = 0, length = state.implicitTypes.length; index < length; index += 1)
        if (type = state.implicitTypes[index], type.resolve(str))
          return !0;
      return !1;
    }
    function isWhitespace(c) {
      return c === CHAR_SPACE || c === CHAR_TAB;
    }
    function isPrintable(c) {
      return 32 <= c && c <= 126 || 161 <= c && c <= 55295 && c !== 8232 && c !== 8233 || 57344 <= c && c <= 65533 && c !== CHAR_BOM || 65536 <= c && c <= 1114111;
    }
    function isNsCharOrWhitespace(c) {
      return isPrintable(c) && c !== CHAR_BOM && c !== CHAR_CARRIAGE_RETURN && c !== CHAR_LINE_FEED;
    }
    function isPlainSafe(c, prev, inblock) {
      var cIsNsCharOrWhitespace = isNsCharOrWhitespace(c), cIsNsChar = cIsNsCharOrWhitespace && !isWhitespace(c);
      return (
        // ns-plain-safe
        (inblock ? (
          // c = flow-in
          cIsNsCharOrWhitespace
        ) : cIsNsCharOrWhitespace && c !== CHAR_COMMA && c !== CHAR_LEFT_SQUARE_BRACKET && c !== CHAR_RIGHT_SQUARE_BRACKET && c !== CHAR_LEFT_CURLY_BRACKET && c !== CHAR_RIGHT_CURLY_BRACKET) && c !== CHAR_SHARP && !(prev === CHAR_COLON && !cIsNsChar) || isNsCharOrWhitespace(prev) && !isWhitespace(prev) && c === CHAR_SHARP || prev === CHAR_COLON && cIsNsChar
      );
    }
    function isPlainSafeFirst(c) {
      return isPrintable(c) && c !== CHAR_BOM && !isWhitespace(c) && c !== CHAR_MINUS && c !== CHAR_QUESTION && c !== CHAR_COLON && c !== CHAR_COMMA && c !== CHAR_LEFT_SQUARE_BRACKET && c !== CHAR_RIGHT_SQUARE_BRACKET && c !== CHAR_LEFT_CURLY_BRACKET && c !== CHAR_RIGHT_CURLY_BRACKET && c !== CHAR_SHARP && c !== CHAR_AMPERSAND && c !== CHAR_ASTERISK && c !== CHAR_EXCLAMATION && c !== CHAR_VERTICAL_LINE && c !== CHAR_EQUALS && c !== CHAR_GREATER_THAN && c !== CHAR_SINGLE_QUOTE && c !== CHAR_DOUBLE_QUOTE && c !== CHAR_PERCENT && c !== CHAR_COMMERCIAL_AT && c !== CHAR_GRAVE_ACCENT;
    }
    function isPlainSafeLast(c) {
      return !isWhitespace(c) && c !== CHAR_COLON;
    }
    function codePointAt(string, pos) {
      var first = string.charCodeAt(pos), second;
      return first >= 55296 && first <= 56319 && pos + 1 < string.length && (second = string.charCodeAt(pos + 1), second >= 56320 && second <= 57343) ? (first - 55296) * 1024 + second - 56320 + 65536 : first;
    }
    function needIndentIndicator(string) {
      var leadingSpaceRe = /^\n* /;
      return leadingSpaceRe.test(string);
    }
    var STYLE_PLAIN = 1, STYLE_SINGLE = 2, STYLE_LITERAL = 3, STYLE_FOLDED = 4, STYLE_DOUBLE = 5;
    function chooseScalarStyle(string, singleLineOnly, indentPerLevel, lineWidth, testAmbiguousType, quotingType, forceQuotes, inblock) {
      var i, char = 0, prevChar = null, hasLineBreak = !1, hasFoldableLine = !1, shouldTrackWidth = lineWidth !== -1, previousLineBreak = -1, plain = isPlainSafeFirst(codePointAt(string, 0)) && isPlainSafeLast(codePointAt(string, string.length - 1));
      if (singleLineOnly || forceQuotes)
        for (i = 0; i < string.length; char >= 65536 ? i += 2 : i++) {
          if (char = codePointAt(string, i), !isPrintable(char))
            return STYLE_DOUBLE;
          plain = plain && isPlainSafe(char, prevChar, inblock), prevChar = char;
        }
      else {
        for (i = 0; i < string.length; char >= 65536 ? i += 2 : i++) {
          if (char = codePointAt(string, i), char === CHAR_LINE_FEED)
            hasLineBreak = !0, shouldTrackWidth && (hasFoldableLine = hasFoldableLine || // Foldable line = too long, and not more-indented.
            i - previousLineBreak - 1 > lineWidth && string[previousLineBreak + 1] !== " ", previousLineBreak = i);
          else if (!isPrintable(char))
            return STYLE_DOUBLE;
          plain = plain && isPlainSafe(char, prevChar, inblock), prevChar = char;
        }
        hasFoldableLine = hasFoldableLine || shouldTrackWidth && i - previousLineBreak - 1 > lineWidth && string[previousLineBreak + 1] !== " ";
      }
      return !hasLineBreak && !hasFoldableLine ? plain && !forceQuotes && !testAmbiguousType(string) ? STYLE_PLAIN : quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE : indentPerLevel > 9 && needIndentIndicator(string) ? STYLE_DOUBLE : forceQuotes ? quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE : hasFoldableLine ? STYLE_FOLDED : STYLE_LITERAL;
    }
    function writeScalar(state, string, level, iskey, inblock) {
      state.dump = function() {
        if (string.length === 0)
          return state.quotingType === QUOTING_TYPE_DOUBLE ? '""' : "''";
        if (!state.noCompatMode && (DEPRECATED_BOOLEANS_SYNTAX.indexOf(string) !== -1 || DEPRECATED_BASE60_SYNTAX.test(string)))
          return state.quotingType === QUOTING_TYPE_DOUBLE ? '"' + string + '"' : "'" + string + "'";
        var indent = state.indent * Math.max(1, level), lineWidth = state.lineWidth === -1 ? -1 : Math.max(Math.min(state.lineWidth, 40), state.lineWidth - indent), singleLineOnly = iskey || state.flowLevel > -1 && level >= state.flowLevel;
        function testAmbiguity(string2) {
          return testImplicitResolving(state, string2);
        }
        switch (chooseScalarStyle(
          string,
          singleLineOnly,
          state.indent,
          lineWidth,
          testAmbiguity,
          state.quotingType,
          state.forceQuotes && !iskey,
          inblock
        )) {
          case STYLE_PLAIN:
            return string;
          case STYLE_SINGLE:
            return "'" + string.replace(/'/g, "''") + "'";
          case STYLE_LITERAL:
            return "|" + blockHeader(string, state.indent) + dropEndingNewline(indentString(string, indent));
          case STYLE_FOLDED:
            return ">" + blockHeader(string, state.indent) + dropEndingNewline(indentString(foldString(string, lineWidth), indent));
          case STYLE_DOUBLE:
            return '"' + escapeString(string, lineWidth) + '"';
          default:
            throw new YAMLException("impossible error: invalid scalar style");
        }
      }();
    }
    function blockHeader(string, indentPerLevel) {
      var indentIndicator = needIndentIndicator(string) ? String(indentPerLevel) : "", clip = string[string.length - 1] === `
`, keep = clip && (string[string.length - 2] === `
` || string === `
`), chomp = keep ? "+" : clip ? "" : "-";
      return indentIndicator + chomp + `
`;
    }
    function dropEndingNewline(string) {
      return string[string.length - 1] === `
` ? string.slice(0, -1) : string;
    }
    function foldString(string, width) {
      for (var lineRe = /(\n+)([^\n]*)/g, result = function() {
        var nextLF = string.indexOf(`
`);
        return nextLF = nextLF !== -1 ? nextLF : string.length, lineRe.lastIndex = nextLF, foldLine(string.slice(0, nextLF), width);
      }(), prevMoreIndented = string[0] === `
` || string[0] === " ", moreIndented, match2; match2 = lineRe.exec(string); ) {
        var prefix = match2[1], line = match2[2];
        moreIndented = line[0] === " ", result += prefix + (!prevMoreIndented && !moreIndented && line !== "" ? `
` : "") + foldLine(line, width), prevMoreIndented = moreIndented;
      }
      return result;
    }
    function foldLine(line, width) {
      if (line === "" || line[0] === " ")
        return line;
      for (var breakRe = / [^ ]/g, match2, start = 0, end, curr = 0, next = 0, result = ""; match2 = breakRe.exec(line); )
        next = match2.index, next - start > width && (end = curr > start ? curr : next, result += `
` + line.slice(start, end), start = end + 1), curr = next;
      return result += `
`, line.length - start > width && curr > start ? result += line.slice(start, curr) + `
` + line.slice(curr + 1) : result += line.slice(start), result.slice(1);
    }
    function escapeString(string) {
      for (var result = "", char = 0, escapeSeq, i = 0; i < string.length; char >= 65536 ? i += 2 : i++)
        char = codePointAt(string, i), escapeSeq = ESCAPE_SEQUENCES[char], !escapeSeq && isPrintable(char) ? (result += string[i], char >= 65536 && (result += string[i + 1])) : result += escapeSeq || encodeHex(char);
      return result;
    }
    function writeFlowSequence(state, level, object) {
      var _result = "", _tag = state.tag, index, length, value;
      for (index = 0, length = object.length; index < length; index += 1)
        value = object[index], state.replacer && (value = state.replacer.call(object, String(index), value)), (writeNode(state, level, value, !1, !1) || typeof value > "u" && writeNode(state, level, null, !1, !1)) && (_result !== "" && (_result += "," + (state.condenseFlow ? "" : " ")), _result += state.dump);
      state.tag = _tag, state.dump = "[" + _result + "]";
    }
    function writeBlockSequence(state, level, object, compact2) {
      var _result = "", _tag = state.tag, index, length, value;
      for (index = 0, length = object.length; index < length; index += 1)
        value = object[index], state.replacer && (value = state.replacer.call(object, String(index), value)), (writeNode(state, level + 1, value, !0, !0, !1, !0) || typeof value > "u" && writeNode(state, level + 1, null, !0, !0, !1, !0)) && ((!compact2 || _result !== "") && (_result += generateNextLine(state, level)), state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0) ? _result += "-" : _result += "- ", _result += state.dump);
      state.tag = _tag, state.dump = _result || "[]";
    }
    function writeFlowMapping(state, level, object) {
      var _result = "", _tag = state.tag, objectKeyList = Object.keys(object), index, length, objectKey, objectValue, pairBuffer;
      for (index = 0, length = objectKeyList.length; index < length; index += 1)
        pairBuffer = "", _result !== "" && (pairBuffer += ", "), state.condenseFlow && (pairBuffer += '"'), objectKey = objectKeyList[index], objectValue = object[objectKey], state.replacer && (objectValue = state.replacer.call(object, objectKey, objectValue)), writeNode(state, level, objectKey, !1, !1) && (state.dump.length > 1024 && (pairBuffer += "? "), pairBuffer += state.dump + (state.condenseFlow ? '"' : "") + ":" + (state.condenseFlow ? "" : " "), writeNode(state, level, objectValue, !1, !1) && (pairBuffer += state.dump, _result += pairBuffer));
      state.tag = _tag, state.dump = "{" + _result + "}";
    }
    function writeBlockMapping(state, level, object, compact2) {
      var _result = "", _tag = state.tag, objectKeyList = Object.keys(object), index, length, objectKey, objectValue, explicitPair, pairBuffer;
      if (state.sortKeys === !0)
        objectKeyList.sort();
      else if (typeof state.sortKeys == "function")
        objectKeyList.sort(state.sortKeys);
      else if (state.sortKeys)
        throw new YAMLException("sortKeys must be a boolean or a function");
      for (index = 0, length = objectKeyList.length; index < length; index += 1)
        pairBuffer = "", (!compact2 || _result !== "") && (pairBuffer += generateNextLine(state, level)), objectKey = objectKeyList[index], objectValue = object[objectKey], state.replacer && (objectValue = state.replacer.call(object, objectKey, objectValue)), writeNode(state, level + 1, objectKey, !0, !0, !0) && (explicitPair = state.tag !== null && state.tag !== "?" || state.dump && state.dump.length > 1024, explicitPair && (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0) ? pairBuffer += "?" : pairBuffer += "? "), pairBuffer += state.dump, explicitPair && (pairBuffer += generateNextLine(state, level)), writeNode(state, level + 1, objectValue, !0, explicitPair) && (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0) ? pairBuffer += ":" : pairBuffer += ": ", pairBuffer += state.dump, _result += pairBuffer));
      state.tag = _tag, state.dump = _result || "{}";
    }
    function detectType(state, object, explicit) {
      var _result, typeList, index, length, type, style;
      for (typeList = explicit ? state.explicitTypes : state.implicitTypes, index = 0, length = typeList.length; index < length; index += 1)
        if (type = typeList[index], (type.instanceOf || type.predicate) && (!type.instanceOf || typeof object == "object" && object instanceof type.instanceOf) && (!type.predicate || type.predicate(object))) {
          if (explicit ? type.multi && type.representName ? state.tag = type.representName(object) : state.tag = type.tag : state.tag = "?", type.represent) {
            if (style = state.styleMap[type.tag] || type.defaultStyle, _toString.call(type.represent) === "[object Function]")
              _result = type.represent(object, style);
            else if (_hasOwnProperty.call(type.represent, style))
              _result = type.represent[style](object, style);
            else
              throw new YAMLException("!<" + type.tag + '> tag resolver accepts not "' + style + '" style');
            state.dump = _result;
          }
          return !0;
        }
      return !1;
    }
    function writeNode(state, level, object, block, compact2, iskey, isblockseq) {
      state.tag = null, state.dump = object, detectType(state, object, !1) || detectType(state, object, !0);
      var type = _toString.call(state.dump), inblock = block, tagStr;
      block && (block = state.flowLevel < 0 || state.flowLevel > level);
      var objectOrArray = type === "[object Object]" || type === "[object Array]", duplicateIndex, duplicate;
      if (objectOrArray && (duplicateIndex = state.duplicates.indexOf(object), duplicate = duplicateIndex !== -1), (state.tag !== null && state.tag !== "?" || duplicate || state.indent !== 2 && level > 0) && (compact2 = !1), duplicate && state.usedDuplicates[duplicateIndex])
        state.dump = "*ref_" + duplicateIndex;
      else {
        if (objectOrArray && duplicate && !state.usedDuplicates[duplicateIndex] && (state.usedDuplicates[duplicateIndex] = !0), type === "[object Object]")
          block && Object.keys(state.dump).length !== 0 ? (writeBlockMapping(state, level, state.dump, compact2), duplicate && (state.dump = "&ref_" + duplicateIndex + state.dump)) : (writeFlowMapping(state, level, state.dump), duplicate && (state.dump = "&ref_" + duplicateIndex + " " + state.dump));
        else if (type === "[object Array]")
          block && state.dump.length !== 0 ? (state.noArrayIndent && !isblockseq && level > 0 ? writeBlockSequence(state, level - 1, state.dump, compact2) : writeBlockSequence(state, level, state.dump, compact2), duplicate && (state.dump = "&ref_" + duplicateIndex + state.dump)) : (writeFlowSequence(state, level, state.dump), duplicate && (state.dump = "&ref_" + duplicateIndex + " " + state.dump));
        else if (type === "[object String]")
          state.tag !== "?" && writeScalar(state, state.dump, level, iskey, inblock);
        else {
          if (type === "[object Undefined]")
            return !1;
          if (state.skipInvalid)
            return !1;
          throw new YAMLException("unacceptable kind of an object to dump " + type);
        }
        state.tag !== null && state.tag !== "?" && (tagStr = encodeURI(
          state.tag[0] === "!" ? state.tag.slice(1) : state.tag
        ).replace(/!/g, "%21"), state.tag[0] === "!" ? tagStr = "!" + tagStr : tagStr.slice(0, 18) === "tag:yaml.org,2002:" ? tagStr = "!!" + tagStr.slice(18) : tagStr = "!<" + tagStr + ">", state.dump = tagStr + " " + state.dump);
      }
      return !0;
    }
    function getDuplicateReferences(object, state) {
      var objects = [], duplicatesIndexes = [], index, length;
      for (inspectNode(object, objects, duplicatesIndexes), index = 0, length = duplicatesIndexes.length; index < length; index += 1)
        state.duplicates.push(objects[duplicatesIndexes[index]]);
      state.usedDuplicates = new Array(length);
    }
    function inspectNode(object, objects, duplicatesIndexes) {
      var objectKeyList, index, length;
      if (object !== null && typeof object == "object")
        if (index = objects.indexOf(object), index !== -1)
          duplicatesIndexes.indexOf(index) === -1 && duplicatesIndexes.push(index);
        else if (objects.push(object), Array.isArray(object))
          for (index = 0, length = object.length; index < length; index += 1)
            inspectNode(object[index], objects, duplicatesIndexes);
        else
          for (objectKeyList = Object.keys(object), index = 0, length = objectKeyList.length; index < length; index += 1)
            inspectNode(object[objectKeyList[index]], objects, duplicatesIndexes);
    }
    function dump(input, options) {
      options = options || {};
      var state = new State(options);
      state.noRefs || getDuplicateReferences(input, state);
      var value = input;
      return state.replacer && (value = state.replacer.call({ "": value }, "", value)), writeNode(state, 0, value, !0, !0) ? state.dump + `
` : "";
    }
    module.exports.dump = dump;
  }
});

// ../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/index.js
var require_js_yaml = __commonJS({
  "../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var loader = require_loader(), dumper = require_dumper();
    function renamed(from, to) {
      return function() {
        throw new Error("Function yaml." + from + " is removed in js-yaml 4. Use yaml." + to + " instead, which is now safe by default.");
      };
    }
    module.exports.Type = require_type();
    module.exports.Schema = require_schema4();
    module.exports.FAILSAFE_SCHEMA = require_failsafe();
    module.exports.JSON_SCHEMA = require_json5();
    module.exports.CORE_SCHEMA = require_core2();
    module.exports.DEFAULT_SCHEMA = require_default();
    module.exports.load = loader.load;
    module.exports.loadAll = loader.loadAll;
    module.exports.dump = dumper.dump;
    module.exports.YAMLException = require_exception();
    module.exports.types = {
      binary: require_binary2(),
      float: require_float3(),
      map: require_map2(),
      null: require_null2(),
      pairs: require_pairs2(),
      set: require_set3(),
      timestamp: require_timestamp2(),
      bool: require_bool3(),
      int: require_int3(),
      merge: require_merge(),
      omap: require_omap2(),
      seq: require_seq2(),
      str: require_str()
    };
    module.exports.safeLoad = renamed("safeLoad", "load");
    module.exports.safeLoadAll = renamed("safeLoadAll", "loadAll");
    module.exports.safeDump = renamed("safeDump", "dump");
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/parsers/yaml.js
var require_yaml = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/parsers/yaml.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var errors_js_1 = require_errors5(), js_yaml_1 = __importDefault(require_js_yaml()), js_yaml_2 = require_js_yaml();
    exports.default = {
      /**
       * The order that this parser will run, in relation to other parsers.
       */
      order: 200,
      /**
       * Whether to allow "empty" files. This includes zero-byte files, as well as empty JSON objects.
       */
      allowEmpty: !0,
      /**
       * Determines whether this parser can parse a given file reference.
       * Parsers that match will be tried, in order, until one successfully parses the file.
       * Parsers that don't match will be skipped, UNLESS none of the parsers match, in which case
       * every parser will be tried.
       */
      canParse: [".yaml", ".yml", ".json"],
      // JSON is valid YAML
      /**
       * Parses the given file as YAML
       *
       * @param file           - An object containing information about the referenced file
       * @param file.url       - The full URL of the referenced file
       * @param file.extension - The lowercased file extension (e.g. ".txt", ".html", etc.)
       * @param file.data      - The file contents. This will be whatever data type was returned by the resolver
       * @returns
       */
      async parse(file) {
        let data = file.data;
        if (Buffer.isBuffer(data) && (data = data.toString()), typeof data == "string")
          try {
            return js_yaml_1.default.load(data, { schema: js_yaml_2.JSON_SCHEMA });
          } catch (e) {
            throw new errors_js_1.ParserError(e?.message || "Parser Error", file.url);
          }
        else
          return data;
      }
    };
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/parsers/text.js
var require_text = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/parsers/text.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var errors_js_1 = require_errors5(), TEXT_REGEXP = /\.(txt|htm|html|md|xml|js|min|map|css|scss|less|svg)$/i;
    exports.default = {
      /**
       * The order that this parser will run, in relation to other parsers.
       */
      order: 300,
      /**
       * Whether to allow "empty" files (zero bytes).
       */
      allowEmpty: !0,
      /**
       * The encoding that the text is expected to be in.
       */
      encoding: "utf8",
      /**
       * Determines whether this parser can parse a given file reference.
       * Parsers that return true will be tried, in order, until one successfully parses the file.
       * Parsers that return false will be skipped, UNLESS all parsers returned false, in which case
       * every parser will be tried.
       */
      canParse(file) {
        return (typeof file.data == "string" || Buffer.isBuffer(file.data)) && TEXT_REGEXP.test(file.url);
      },
      /**
       * Parses the given file as text
       */
      parse(file) {
        if (typeof file.data == "string")
          return file.data;
        if (Buffer.isBuffer(file.data))
          return file.data.toString(this.encoding);
        throw new errors_js_1.ParserError("data is not text", file.url);
      }
    };
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/parsers/binary.js
var require_binary3 = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/parsers/binary.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var BINARY_REGEXP = /\.(jpeg|jpg|gif|png|bmp|ico)$/i;
    exports.default = {
      /**
       * The order that this parser will run, in relation to other parsers.
       */
      order: 400,
      /**
       * Whether to allow "empty" files (zero bytes).
       */
      allowEmpty: !0,
      /**
       * Determines whether this parser can parse a given file reference.
       * Parsers that return true will be tried, in order, until one successfully parses the file.
       * Parsers that return false will be skipped, UNLESS all parsers returned false, in which case
       * every parser will be tried.
       */
      canParse(file) {
        return Buffer.isBuffer(file.data) && BINARY_REGEXP.test(file.url);
      },
      /**
       * Parses the given data as a Buffer (byte array).
       */
      parse(file) {
        return Buffer.isBuffer(file.data) ? file.data : Buffer.from(file.data);
      }
    };
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/resolvers/file.js
var require_file3 = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/resolvers/file.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: !0, value: v });
    } : function(o, v) {
      o.default = v;
    }), __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null)
        for (var k in mod)
          k !== "default" && Object.prototype.hasOwnProperty.call(mod, k) && __createBinding(result, mod, k);
      return __setModuleDefault(result, mod), result;
    }, __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var fs_1 = __importDefault(__require("fs")), ono_1 = require_cjs3(), url = __importStar(require_url()), errors_js_1 = require_errors5();
    exports.default = {
      /**
       * The order that this resolver will run, in relation to other resolvers.
       */
      order: 100,
      /**
       * Determines whether this resolver can read a given file reference.
       * Resolvers that return true will be tried, in order, until one successfully resolves the file.
       * Resolvers that return false will not be given a chance to resolve the file.
       */
      canRead(file) {
        return url.isFileSystemPath(file.url);
      },
      /**
       * Reads the given file and returns its raw contents as a Buffer.
       */
      async read(file) {
        let path3;
        try {
          path3 = url.toFileSystemPath(file.url);
        } catch (err2) {
          throw new errors_js_1.ResolverError(ono_1.ono.uri(err2, `Malformed URI: ${file.url}`), file.url);
        }
        try {
          return await fs_1.default.promises.readFile(path3);
        } catch (err2) {
          throw new errors_js_1.ResolverError((0, ono_1.ono)(err2, `Error opening file "${path3}"`), path3);
        }
      }
    };
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/resolvers/http.js
var require_http = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/resolvers/http.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: !0, value: v });
    } : function(o, v) {
      o.default = v;
    }), __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null)
        for (var k in mod)
          k !== "default" && Object.prototype.hasOwnProperty.call(mod, k) && __createBinding(result, mod, k);
      return __setModuleDefault(result, mod), result;
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var ono_1 = require_cjs3(), url = __importStar(require_url()), errors_js_1 = require_errors5();
    exports.default = {
      /**
       * The order that this resolver will run, in relation to other resolvers.
       */
      order: 200,
      /**
       * HTTP headers to send when downloading files.
       *
       * @example:
       * {
       *   "User-Agent": "JSON Schema $Ref Parser",
       *   Accept: "application/json"
       * }
       */
      headers: null,
      /**
       * HTTP request timeout (in milliseconds).
       */
      timeout: 5e3,
      // 5 seconds
      /**
       * The maximum number of HTTP redirects to follow.
       * To disable automatic following of redirects, set this to zero.
       */
      redirects: 5,
      /**
       * The `withCredentials` option of XMLHttpRequest.
       * Set this to `true` if you're downloading files from a CORS-enabled server that requires authentication
       */
      withCredentials: !1,
      /**
       * Determines whether this resolver can read a given file reference.
       * Resolvers that return true will be tried in order, until one successfully resolves the file.
       * Resolvers that return false will not be given a chance to resolve the file.
       */
      canRead(file) {
        return url.isHttp(file.url);
      },
      /**
       * Reads the given URL and returns its raw contents as a Buffer.
       */
      read(file) {
        let u = url.parse(file.url);
        return typeof window < "u" && !u.protocol && (u.protocol = url.parse(location.href).protocol), download(u, this);
      }
    };
    async function download(u, httpOptions, _redirects) {
      u = url.parse(u);
      let redirects = _redirects || [];
      redirects.push(u.href);
      try {
        let res = await get2(u, httpOptions);
        if (res.status >= 400)
          throw (0, ono_1.ono)({ status: res.status }, `HTTP ERROR ${res.status}`);
        if (res.status >= 300) {
          if (!Number.isNaN(httpOptions.redirects) && redirects.length > httpOptions.redirects)
            throw new errors_js_1.ResolverError((0, ono_1.ono)({ status: res.status }, `Error downloading ${redirects[0]}. 
Too many redirects: 
  ${redirects.join(` 
  `)}`));
          if (!("location" in res.headers) || !res.headers.location)
            throw (0, ono_1.ono)({ status: res.status }, `HTTP ${res.status} redirect with no location header`);
          {
            let redirectTo = url.resolve(u.href, res.headers.location);
            return download(redirectTo, httpOptions, redirects);
          }
        } else {
          if (res.body) {
            let buf = await res.arrayBuffer();
            return Buffer.from(buf);
          }
          return Buffer.alloc(0);
        }
      } catch (err2) {
        throw new errors_js_1.ResolverError((0, ono_1.ono)(err2, `Error downloading ${u.href}`), u.href);
      }
    }
    async function get2(u, httpOptions) {
      let controller, timeoutId;
      httpOptions.timeout && (controller = new AbortController(), timeoutId = setTimeout(() => controller.abort(), httpOptions.timeout));
      let response = await fetch(u, {
        method: "GET",
        headers: httpOptions.headers || {},
        credentials: httpOptions.withCredentials ? "include" : "same-origin",
        signal: controller ? controller.signal : null
      });
      return timeoutId && clearTimeout(timeoutId), response;
    }
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/options.js
var require_options = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/options.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.getNewOptions = exports.getJsonSchemaRefParserDefaultOptions = void 0;
    var json_js_1 = __importDefault(require_json4()), yaml_js_1 = __importDefault(require_yaml()), text_js_1 = __importDefault(require_text()), binary_js_1 = __importDefault(require_binary3()), file_js_1 = __importDefault(require_file3()), http_js_1 = __importDefault(require_http()), getJsonSchemaRefParserDefaultOptions = () => ({
      /**
       * Determines how different types of files will be parsed.
       *
       * You can add additional parsers of your own, replace an existing one with
       * your own implementation, or disable any parser by setting it to false.
       */
      parse: {
        json: { ...json_js_1.default },
        yaml: { ...yaml_js_1.default },
        text: { ...text_js_1.default },
        binary: { ...binary_js_1.default }
      },
      /**
       * Determines how JSON References will be resolved.
       *
       * You can add additional resolvers of your own, replace an existing one with
       * your own implementation, or disable any resolver by setting it to false.
       */
      resolve: {
        file: { ...file_js_1.default },
        http: { ...http_js_1.default },
        /**
         * Determines whether external $ref pointers will be resolved.
         * If this option is disabled, then none of above resolvers will be called.
         * Instead, external $ref pointers will simply be ignored.
         *
         * @type {boolean}
         */
        external: !0
      },
      /**
       * By default, JSON Schema $Ref Parser throws the first error it encounters. Setting `continueOnError` to `true`
       * causes it to keep processing as much as possible and then throw a single error that contains all errors
       * that were encountered.
       */
      continueOnError: !1,
      /**
       * Determines the types of JSON references that are allowed.
       */
      dereference: {
        /**
         * Dereference circular (recursive) JSON references?
         * If false, then a {@link ReferenceError} will be thrown if a circular reference is found.
         * If "ignore", then circular references will not be dereferenced.
         *
         * @type {boolean|string}
         */
        circular: !0,
        /**
         * A function, called for each path, which can return true to stop this path and all
         * subpaths from being dereferenced further. This is useful in schemas where some
         * subpaths contain literal $ref keys that should not be dereferenced.
         *
         * @type {function}
         */
        excludedPathMatcher: () => !1,
        referenceResolution: "relative"
      },
      mutateInputSchema: !0
    });
    exports.getJsonSchemaRefParserDefaultOptions = getJsonSchemaRefParserDefaultOptions;
    var getNewOptions = (options) => {
      let newOptions = (0, exports.getJsonSchemaRefParserDefaultOptions)();
      return options && merge(newOptions, options), newOptions;
    };
    exports.getNewOptions = getNewOptions;
    function merge(target, source) {
      if (isMergeable(source)) {
        let keys = Object.keys(source).filter((key) => !["__proto__", "constructor", "prototype"].includes(key));
        for (let i = 0; i < keys.length; i++) {
          let key = keys[i], sourceSetting = source[key], targetSetting = target[key];
          isMergeable(sourceSetting) ? target[key] = merge(targetSetting || {}, sourceSetting) : sourceSetting !== void 0 && (target[key] = sourceSetting);
        }
      }
      return target;
    }
    function isMergeable(val) {
      return val && typeof val == "object" && !Array.isArray(val) && !(val instanceof RegExp) && !(val instanceof Date);
    }
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/normalize-args.js
var require_normalize_args = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/normalize-args.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.normalizeArgs = void 0;
    var options_js_1 = require_options();
    function normalizeArgs(_args) {
      let path3, schema, options, callback, args = Array.prototype.slice.call(_args);
      typeof args[args.length - 1] == "function" && (callback = args.pop()), typeof args[0] == "string" ? (path3 = args[0], typeof args[2] == "object" ? (schema = args[1], options = args[2]) : (schema = void 0, options = args[1])) : (path3 = "", schema = args[0], options = args[1]);
      try {
        options = (0, options_js_1.getNewOptions)(options);
      } catch (e) {
        console.error(`JSON Schema Ref Parser: Error normalizing options: ${e}`);
      }
      return !options.mutateInputSchema && typeof schema == "object" && (schema = JSON.parse(JSON.stringify(schema))), {
        path: path3,
        schema,
        options,
        callback
      };
    }
    exports.normalizeArgs = normalizeArgs;
    exports.default = normalizeArgs;
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/resolve-external.js
var require_resolve_external = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/resolve-external.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: !0, value: v });
    } : function(o, v) {
      o.default = v;
    }), __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null)
        for (var k in mod)
          k !== "default" && Object.prototype.hasOwnProperty.call(mod, k) && __createBinding(result, mod, k);
      return __setModuleDefault(result, mod), result;
    }, __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var ref_js_1 = __importDefault(require_ref()), pointer_js_1 = __importDefault(require_pointer()), parse_js_1 = __importDefault(require_parse()), url = __importStar(require_url()), errors_js_1 = require_errors5();
    function resolveExternal(parser, options) {
      if (!options.resolve?.external)
        return Promise.resolve();
      try {
        let promises = crawl(parser.schema, parser.$refs._root$Ref.path + "#", parser.$refs, options);
        return Promise.all(promises);
      } catch (e) {
        return Promise.reject(e);
      }
    }
    function crawl(obj, path3, $refs, options, seen, external) {
      seen || (seen = /* @__PURE__ */ new Set());
      let promises = [];
      if (obj && typeof obj == "object" && !ArrayBuffer.isView(obj) && !seen.has(obj)) {
        seen.add(obj), ref_js_1.default.isExternal$Ref(obj) && promises.push(resolve$Ref(obj, path3, $refs, options));
        let keys = Object.keys(obj);
        for (let key of keys) {
          let keyPath = pointer_js_1.default.join(path3, key), value = obj[key];
          promises = promises.concat(crawl(value, keyPath, $refs, options, seen, external));
        }
      }
      return promises;
    }
    async function resolve$Ref($ref, path3, $refs, options) {
      let shouldResolveOnCwd = options.dereference?.externalReferenceResolution === "root", resolvedPath = url.resolve(shouldResolveOnCwd ? url.cwd() : path3, $ref.$ref), withoutHash = url.stripHash(resolvedPath), ref = $refs._$refs[withoutHash];
      if (ref)
        return Promise.resolve(ref.value);
      try {
        let result = await (0, parse_js_1.default)(resolvedPath, $refs, options), promises = crawl(result, withoutHash + "#", $refs, options, /* @__PURE__ */ new Set(), !0);
        return Promise.all(promises);
      } catch (err2) {
        if (!options?.continueOnError || !(0, errors_js_1.isHandledError)(err2))
          throw err2;
        return $refs._$refs[withoutHash] && (err2.source = decodeURI(url.stripHash(path3)), err2.path = url.safePointerToPath(url.getHash(path3))), [];
      }
    }
    exports.default = resolveExternal;
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/bundle.js
var require_bundle = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/bundle.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: !0, value: v });
    } : function(o, v) {
      o.default = v;
    }), __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null)
        for (var k in mod)
          k !== "default" && Object.prototype.hasOwnProperty.call(mod, k) && __createBinding(result, mod, k);
      return __setModuleDefault(result, mod), result;
    }, __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var ref_js_1 = __importDefault(require_ref()), pointer_js_1 = __importDefault(require_pointer()), url = __importStar(require_url());
    function bundle(parser, options) {
      let inventory = [];
      crawl(parser, "schema", parser.$refs._root$Ref.path + "#", "#", 0, inventory, parser.$refs, options), remap(inventory);
    }
    function crawl(parent, key, path3, pathFromRoot, indirections, inventory, $refs, options) {
      let obj = key === null ? parent : parent[key];
      if (obj && typeof obj == "object" && !ArrayBuffer.isView(obj))
        if (ref_js_1.default.isAllowed$Ref(obj))
          inventory$Ref(parent, key, path3, pathFromRoot, indirections, inventory, $refs, options);
        else {
          let keys = Object.keys(obj).sort((a, b) => a === "definitions" ? -1 : b === "definitions" ? 1 : a.length - b.length);
          for (let key2 of keys) {
            let keyPath = pointer_js_1.default.join(path3, key2), keyPathFromRoot = pointer_js_1.default.join(pathFromRoot, key2), value = obj[key2];
            ref_js_1.default.isAllowed$Ref(value) ? inventory$Ref(obj, key2, path3, keyPathFromRoot, indirections, inventory, $refs, options) : crawl(obj, key2, keyPath, keyPathFromRoot, indirections, inventory, $refs, options);
          }
        }
    }
    function inventory$Ref($refParent, $refKey, path3, pathFromRoot, indirections, inventory, $refs, options) {
      let $ref = $refKey === null ? $refParent : $refParent[$refKey], $refPath = url.resolve(path3, $ref.$ref), pointer = $refs._resolve($refPath, pathFromRoot, options);
      if (pointer === null)
        return;
      let depth = pointer_js_1.default.parse(pathFromRoot).length, file = url.stripHash(pointer.path), hash = url.getHash(pointer.path), external = file !== $refs._root$Ref.path, extended = ref_js_1.default.isExtended$Ref($ref);
      indirections += pointer.indirections;
      let existingEntry = findInInventory(inventory, $refParent, $refKey);
      if (existingEntry)
        if (depth < existingEntry.depth || indirections < existingEntry.indirections)
          removeFromInventory(inventory, existingEntry);
        else
          return;
      inventory.push({
        $ref,
        // The JSON Reference (e.g. {$ref: string})
        parent: $refParent,
        // The object that contains this $ref pointer
        key: $refKey,
        // The key in `parent` that is the $ref pointer
        pathFromRoot,
        // The path to the $ref pointer, from the JSON Schema root
        depth,
        // How far from the JSON Schema root is this $ref pointer?
        file,
        // The file that the $ref pointer resolves to
        hash,
        // The hash within `file` that the $ref pointer resolves to
        value: pointer.value,
        // The resolved value of the $ref pointer
        circular: pointer.circular,
        // Is this $ref pointer DIRECTLY circular? (i.e. it references itself)
        extended,
        // Does this $ref extend its resolved value? (i.e. it has extra properties, in addition to "$ref")
        external,
        // Does this $ref pointer point to a file other than the main JSON Schema file?
        indirections
        // The number of indirect references that were traversed to resolve the value
      }), (!existingEntry || external) && crawl(pointer.value, null, pointer.path, pathFromRoot, indirections + 1, inventory, $refs, options);
    }
    function remap(inventory) {
      inventory.sort((a, b) => {
        if (a.file !== b.file)
          return a.file < b.file ? -1 : 1;
        if (a.hash !== b.hash)
          return a.hash < b.hash ? -1 : 1;
        if (a.circular !== b.circular)
          return a.circular ? -1 : 1;
        if (a.extended !== b.extended)
          return a.extended ? 1 : -1;
        if (a.indirections !== b.indirections)
          return a.indirections - b.indirections;
        if (a.depth !== b.depth)
          return a.depth - b.depth;
        {
          let aDefinitionsIndex = a.pathFromRoot.lastIndexOf("/definitions"), bDefinitionsIndex = b.pathFromRoot.lastIndexOf("/definitions");
          return aDefinitionsIndex !== bDefinitionsIndex ? bDefinitionsIndex - aDefinitionsIndex : a.pathFromRoot.length - b.pathFromRoot.length;
        }
      });
      let file, hash, pathFromRoot;
      for (let entry of inventory)
        entry.external ? entry.file === file && entry.hash === hash ? entry.$ref.$ref = pathFromRoot : entry.file === file && entry.hash.indexOf(hash + "/") === 0 ? entry.$ref.$ref = pointer_js_1.default.join(pathFromRoot, pointer_js_1.default.parse(entry.hash.replace(hash, "#"))) : (file = entry.file, hash = entry.hash, pathFromRoot = entry.pathFromRoot, entry.$ref = entry.parent[entry.key] = ref_js_1.default.dereference(entry.$ref, entry.value), entry.circular && (entry.$ref.$ref = entry.pathFromRoot)) : entry.$ref.$ref = entry.hash;
    }
    function findInInventory(inventory, $refParent, $refKey) {
      for (let existingEntry of inventory)
        if (existingEntry && existingEntry.parent === $refParent && existingEntry.key === $refKey)
          return existingEntry;
    }
    function removeFromInventory(inventory, entry) {
      let index = inventory.indexOf(entry);
      inventory.splice(index, 1);
    }
    exports.default = bundle;
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/dereference.js
var require_dereference = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/dereference.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: !0, value: v });
    } : function(o, v) {
      o.default = v;
    }), __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null)
        for (var k in mod)
          k !== "default" && Object.prototype.hasOwnProperty.call(mod, k) && __createBinding(result, mod, k);
      return __setModuleDefault(result, mod), result;
    }, __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var ref_js_1 = __importDefault(require_ref()), pointer_js_1 = __importDefault(require_pointer()), ono_1 = require_cjs3(), url = __importStar(require_url()), errors_1 = require_errors5();
    exports.default = dereference;
    function dereference(parser, options) {
      let start = Date.now(), dereferenced = crawl(parser.schema, parser.$refs._root$Ref.path, "#", /* @__PURE__ */ new Set(), /* @__PURE__ */ new Set(), /* @__PURE__ */ new Map(), parser.$refs, options, start);
      parser.$refs.circular = dereferenced.circular, parser.schema = dereferenced.value;
    }
    function crawl(obj, path3, pathFromRoot, parents, processedObjects, dereferencedCache, $refs, options, startTime) {
      let dereferenced, result = {
        value: obj,
        circular: !1
      };
      if (options && options.timeoutMs && Date.now() - startTime > options.timeoutMs)
        throw new errors_1.TimeoutError(options.timeoutMs);
      let derefOptions = options.dereference || {}, isExcludedPath = derefOptions.excludedPathMatcher || (() => !1);
      if ((derefOptions?.circular === "ignore" || !processedObjects.has(obj)) && obj && typeof obj == "object" && !ArrayBuffer.isView(obj) && !isExcludedPath(pathFromRoot)) {
        if (parents.add(obj), processedObjects.add(obj), ref_js_1.default.isAllowed$Ref(obj, options))
          dereferenced = dereference$Ref(obj, path3, pathFromRoot, parents, processedObjects, dereferencedCache, $refs, options, startTime), result.circular = dereferenced.circular, result.value = dereferenced.value;
        else
          for (let key of Object.keys(obj)) {
            let keyPath = pointer_js_1.default.join(path3, key), keyPathFromRoot = pointer_js_1.default.join(pathFromRoot, key);
            if (isExcludedPath(keyPathFromRoot))
              continue;
            let value = obj[key], circular = !1;
            ref_js_1.default.isAllowed$Ref(value, options) ? (dereferenced = dereference$Ref(value, keyPath, keyPathFromRoot, parents, processedObjects, dereferencedCache, $refs, options, startTime), circular = dereferenced.circular, obj[key] !== dereferenced.value && (obj[key] = dereferenced.value, derefOptions?.onDereference?.(value.$ref, obj[key], obj, key))) : parents.has(value) ? circular = foundCircularReference(keyPath, $refs, options) : (dereferenced = crawl(value, keyPath, keyPathFromRoot, parents, processedObjects, dereferencedCache, $refs, options, startTime), circular = dereferenced.circular, obj[key] !== dereferenced.value && (obj[key] = dereferenced.value)), result.circular = result.circular || circular;
          }
        parents.delete(obj);
      }
      return result;
    }
    function dereference$Ref($ref, path3, pathFromRoot, parents, processedObjects, dereferencedCache, $refs, options, startTime) {
      let shouldResolveOnCwd = ref_js_1.default.isExternal$Ref($ref) && options?.dereference?.externalReferenceResolution === "root", $refPath = url.resolve(shouldResolveOnCwd ? url.cwd() : path3, $ref.$ref), cache2 = dereferencedCache.get($refPath);
      if (cache2) {
        let refKeys = Object.keys($ref);
        if (refKeys.length > 1) {
          let extraKeys = {};
          for (let key of refKeys)
            key !== "$ref" && !(key in cache2.value) && (extraKeys[key] = $ref[key]);
          return {
            circular: cache2.circular,
            value: Object.assign({}, cache2.value, extraKeys)
          };
        }
        return cache2;
      }
      let pointer = $refs._resolve($refPath, path3, options);
      if (pointer === null)
        return {
          circular: !1,
          value: null
        };
      let directCircular = pointer.circular, circular = directCircular || parents.has(pointer.value);
      circular && foundCircularReference(path3, $refs, options);
      let dereferencedValue = ref_js_1.default.dereference($ref, pointer.value);
      if (!circular) {
        let dereferenced = crawl(dereferencedValue, pointer.path, pathFromRoot, parents, processedObjects, dereferencedCache, $refs, options, startTime);
        circular = dereferenced.circular, dereferencedValue = dereferenced.value;
      }
      circular && !directCircular && options.dereference?.circular === "ignore" && (dereferencedValue = $ref), directCircular && (dereferencedValue.$ref = pathFromRoot);
      let dereferencedObject = {
        circular,
        value: dereferencedValue
      };
      return Object.keys($ref).length === 1 && dereferencedCache.set($refPath, dereferencedObject), dereferencedObject;
    }
    function foundCircularReference(keyPath, $refs, options) {
      if ($refs.circular = !0, !options.dereference.circular)
        throw ono_1.ono.reference(`Circular $ref pointer found at ${keyPath}`);
      return !0;
    }
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/util/next.js
var require_next = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/util/next.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    function makeNext() {
      return typeof process == "object" && typeof process.nextTick == "function" ? process.nextTick : typeof setImmediate == "function" ? setImmediate : function(f) {
        setTimeout(f, 0);
      };
    }
    exports.default = makeNext();
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/util/maybe.js
var require_maybe = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/util/maybe.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var next_js_1 = __importDefault(require_next());
    function maybe(cb, promise) {
      if (cb) {
        promise.then(function(result) {
          (0, next_js_1.default)(function() {
            cb(null, result);
          });
        }, function(err2) {
          (0, next_js_1.default)(function() {
            cb(err2);
          });
        });
        return;
      } else
        return promise;
    }
    exports.default = maybe;
  }
});

// ../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/index.js
var require_lib7 = __commonJS({
  "../../node_modules/.pnpm/@apidevtools+json-schema-ref-parser@11.6.4/node_modules/@apidevtools/json-schema-ref-parser/dist/lib/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m, k, k2) {
      k2 === void 0 && (k2 = k);
      var desc = Object.getOwnPropertyDescriptor(m, k);
      (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) && (desc = { enumerable: !0, get: function() {
        return m[k];
      } }), Object.defineProperty(o, k2, desc);
    } : function(o, m, k, k2) {
      k2 === void 0 && (k2 = k), o[k2] = m[k];
    }), __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: !0, value: v });
    } : function(o, v) {
      o.default = v;
    }), __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null)
        for (var k in mod)
          k !== "default" && Object.prototype.hasOwnProperty.call(mod, k) && __createBinding(result, mod, k);
      return __setModuleDefault(result, mod), result;
    }, __importDefault = exports && exports.__importDefault || function(mod) {
      return mod && mod.__esModule ? mod : { default: mod };
    };
    Object.defineProperty(exports, "__esModule", { value: !0 });
    exports.JSONParserErrorGroup = exports.isHandledError = exports.UnmatchedParserError = exports.ParserError = exports.ResolverError = exports.MissingPointerError = exports.InvalidPointerError = exports.JSONParserError = exports.UnmatchedResolverError = exports.dereference = exports.bundle = exports.resolve = exports.parse = exports.$RefParser = void 0;
    var refs_js_1 = __importDefault(require_refs()), parse_js_1 = __importDefault(require_parse()), normalize_args_js_1 = __importDefault(require_normalize_args()), resolve_external_js_1 = __importDefault(require_resolve_external()), bundle_js_1 = __importDefault(require_bundle()), dereference_js_1 = __importDefault(require_dereference()), url = __importStar(require_url()), errors_js_1 = require_errors5();
    Object.defineProperty(exports, "JSONParserError", { enumerable: !0, get: function() {
      return errors_js_1.JSONParserError;
    } });
    Object.defineProperty(exports, "InvalidPointerError", { enumerable: !0, get: function() {
      return errors_js_1.InvalidPointerError;
    } });
    Object.defineProperty(exports, "MissingPointerError", { enumerable: !0, get: function() {
      return errors_js_1.MissingPointerError;
    } });
    Object.defineProperty(exports, "ResolverError", { enumerable: !0, get: function() {
      return errors_js_1.ResolverError;
    } });
    Object.defineProperty(exports, "ParserError", { enumerable: !0, get: function() {
      return errors_js_1.ParserError;
    } });
    Object.defineProperty(exports, "UnmatchedParserError", { enumerable: !0, get: function() {
      return errors_js_1.UnmatchedParserError;
    } });
    Object.defineProperty(exports, "UnmatchedResolverError", { enumerable: !0, get: function() {
      return errors_js_1.UnmatchedResolverError;
    } });
    Object.defineProperty(exports, "isHandledError", { enumerable: !0, get: function() {
      return errors_js_1.isHandledError;
    } });
    Object.defineProperty(exports, "JSONParserErrorGroup", { enumerable: !0, get: function() {
      return errors_js_1.JSONParserErrorGroup;
    } });
    var ono_1 = require_cjs3(), maybe_js_1 = __importDefault(require_maybe()), $RefParser2 = class _$RefParser {
      constructor() {
        this.schema = null, this.$refs = new refs_js_1.default();
      }
      async parse() {
        let args = (0, normalize_args_js_1.default)(arguments), promise;
        if (!args.path && !args.schema) {
          let err2 = (0, ono_1.ono)(`Expected a file path, URL, or object. Got ${args.path || args.schema}`);
          return (0, maybe_js_1.default)(args.callback, Promise.reject(err2));
        }
        this.schema = null, this.$refs = new refs_js_1.default();
        let pathType = "http";
        if (url.isFileSystemPath(args.path))
          args.path = url.fromFileSystemPath(args.path), pathType = "file";
        else if (!args.path && args.schema && "$id" in args.schema && args.schema.$id) {
          let params = url.parse(args.schema.$id), port = params.protocol === "https:" ? 443 : 80;
          args.path = `${params.protocol}//${params.hostname}:${port}`;
        }
        if (args.path = url.resolve(url.cwd(), args.path), args.schema && typeof args.schema == "object") {
          let $ref = this.$refs._add(args.path);
          $ref.value = args.schema, $ref.pathType = pathType, promise = Promise.resolve(args.schema);
        } else
          promise = (0, parse_js_1.default)(args.path, this.$refs, args.options);
        try {
          let result = await promise;
          if (result !== null && typeof result == "object" && !Buffer.isBuffer(result))
            return this.schema = result, (0, maybe_js_1.default)(args.callback, Promise.resolve(this.schema));
          if (args.options.continueOnError)
            return this.schema = null, (0, maybe_js_1.default)(args.callback, Promise.resolve(this.schema));
          throw ono_1.ono.syntax(`"${this.$refs._root$Ref.path || result}" is not a valid JSON Schema`);
        } catch (err2) {
          return !args.options.continueOnError || !(0, errors_js_1.isHandledError)(err2) ? (0, maybe_js_1.default)(args.callback, Promise.reject(err2)) : (this.$refs._$refs[url.stripHash(args.path)] && this.$refs._$refs[url.stripHash(args.path)].addError(err2), (0, maybe_js_1.default)(args.callback, Promise.resolve(null)));
        }
      }
      static parse() {
        let parser = new _$RefParser();
        return parser.parse.apply(parser, arguments);
      }
      async resolve() {
        let args = (0, normalize_args_js_1.default)(arguments);
        try {
          return await this.parse(args.path, args.schema, args.options), await (0, resolve_external_js_1.default)(this, args.options), finalize(this), (0, maybe_js_1.default)(args.callback, Promise.resolve(this.$refs));
        } catch (err2) {
          return (0, maybe_js_1.default)(args.callback, Promise.reject(err2));
        }
      }
      static resolve() {
        let instance = new _$RefParser();
        return instance.resolve.apply(instance, arguments);
      }
      static bundle() {
        let instance = new _$RefParser();
        return instance.bundle.apply(instance, arguments);
      }
      async bundle() {
        let args = (0, normalize_args_js_1.default)(arguments);
        try {
          return await this.resolve(args.path, args.schema, args.options), (0, bundle_js_1.default)(this, args.options), finalize(this), (0, maybe_js_1.default)(args.callback, Promise.resolve(this.schema));
        } catch (err2) {
          return (0, maybe_js_1.default)(args.callback, Promise.reject(err2));
        }
      }
      static dereference() {
        let instance = new _$RefParser();
        return instance.dereference.apply(instance, arguments);
      }
      async dereference() {
        let args = (0, normalize_args_js_1.default)(arguments);
        try {
          return await this.resolve(args.path, args.schema, args.options), (0, dereference_js_1.default)(this, args.options), finalize(this), (0, maybe_js_1.default)(args.callback, Promise.resolve(this.schema));
        } catch (err2) {
          return (0, maybe_js_1.default)(args.callback, Promise.reject(err2));
        }
      }
    };
    exports.$RefParser = $RefParser2;
    exports.default = $RefParser2;
    function finalize(parser) {
      if (errors_js_1.JSONParserErrorGroup.getParserErrors(parser).length > 0)
        throw new errors_js_1.JSONParserErrorGroup(parser);
    }
    exports.parse = $RefParser2.parse;
    exports.resolve = $RefParser2.resolve;
    exports.bundle = $RefParser2.bundle;
    exports.dereference = $RefParser2.dereference;
  }
});

// ../../node_modules/.pnpm/liquidjs@10.9.2/node_modules/liquidjs/dist/liquid.node.cjs.js
var require_liquid_node_cjs = __commonJS({
  "../../node_modules/.pnpm/liquidjs@10.9.2/node_modules/liquidjs/dist/liquid.node.cjs.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var stream2 = __require("stream"), path3 = __require("path"), fs$1 = __require("fs"), Token = class {
      constructor(kind, input, begin, end, file) {
        this.kind = kind, this.input = input, this.begin = begin, this.end = end, this.file = file;
      }
      getText() {
        return this.input.slice(this.begin, this.end);
      }
      getPosition() {
        let [row, col] = [1, 1];
        for (let i = 0; i < this.begin; i++)
          this.input[i] === `
` ? (row++, col = 1) : col++;
        return [row, col];
      }
      size() {
        return this.end - this.begin;
      }
    }, Drop = class {
      liquidMethodMissing(key) {
      }
    }, toString$1 = Object.prototype.toString, toLowerCase = String.prototype.toLowerCase, hasOwnProperty = Object.hasOwnProperty;
    function isString2(value) {
      return typeof value == "string";
    }
    function isFunction(value) {
      return typeof value == "function";
    }
    function isPromise(val) {
      return val && isFunction(val.then);
    }
    function isIterator(val) {
      return val && isFunction(val.next) && isFunction(val.throw) && isFunction(val.return);
    }
    function escapeRegex(str) {
      return str.replace(/[-/\\^$*+?.()|[\]{}]/g, "\\$&");
    }
    function promisify(fn) {
      return function(...args) {
        return new Promise((resolve3, reject) => {
          fn(...args, (err2, result) => {
            err2 ? reject(err2) : resolve3(result);
          });
        });
      };
    }
    function stringify(value) {
      return value = toValue(value), isString2(value) ? value : isNil(value) ? "" : isArray(value) ? value.map((x) => stringify(x)).join("") : String(value);
    }
    function toValue(value) {
      return value instanceof Drop && isFunction(value.valueOf) ? value.valueOf() : value;
    }
    function isNumber2(value) {
      return typeof value == "number";
    }
    function toLiquid(value) {
      return value && isFunction(value.toLiquid) ? toLiquid(value.toLiquid()) : value;
    }
    function isNil(value) {
      return value == null;
    }
    function isUndefined(value) {
      return value === void 0;
    }
    function isArray(value) {
      return toString$1.call(value) === "[object Array]";
    }
    function isIterable(value) {
      return isObject4(value) && Symbol.iterator in value;
    }
    function forOwn(obj, iteratee) {
      obj = obj || {};
      for (let k in obj)
        if (hasOwnProperty.call(obj, k) && iteratee(obj[k], k, obj) === !1)
          break;
      return obj;
    }
    function last(arr) {
      return arr[arr.length - 1];
    }
    function isObject4(value) {
      let type = typeof value;
      return value !== null && (type === "object" || type === "function");
    }
    function range(start, stop, step = 1) {
      let arr = [];
      for (let i = start; i < stop; i += step)
        arr.push(i);
      return arr;
    }
    function padStart(str, length, ch = " ") {
      return pad(str, length, ch, (str2, ch2) => ch2 + str2);
    }
    function padEnd(str, length, ch = " ") {
      return pad(str, length, ch, (str2, ch2) => str2 + ch2);
    }
    function pad(str, length, ch, add) {
      str = String(str);
      let n = length - str.length;
      for (; n-- > 0; )
        str = add(str, ch);
      return str;
    }
    function identify(val) {
      return val;
    }
    function changeCase(str) {
      return [...str].some((ch) => ch >= "a" && ch <= "z") ? str.toUpperCase() : str.toLowerCase();
    }
    function ellipsis(str, N) {
      return str.length > N ? str.slice(0, N - 3) + "..." : str;
    }
    function caseInsensitiveCompare(a, b) {
      return a == null && b == null ? 0 : a == null ? 1 : b == null || (a = toLowerCase.call(a), b = toLowerCase.call(b), a < b) ? -1 : a > b ? 1 : 0;
    }
    function argumentsToValue(fn) {
      return (...args) => fn(...args.map(toValue));
    }
    function escapeRegExp(text) {
      return text.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
    }
    var TRAIT = "__liquidClass__", LiquidError = class extends Error {
      constructor(err2, token) {
        super(typeof err2 == "string" ? err2 : err2.message), this.context = "", typeof err2 != "string" && Object.defineProperty(this, "originalError", { value: err2, enumerable: !1 }), Object.defineProperty(this, "token", { value: token, enumerable: !1 }), Object.defineProperty(this, TRAIT, { value: "LiquidError", enumerable: !1 });
      }
      update() {
        Object.defineProperty(this, "context", { value: mkContext(this.token), enumerable: !1 }), this.message = mkMessage(this.message, this.token), this.stack = this.message + `
` + this.context + `
` + this.stack, this.originalError && (this.stack += `
From ` + this.originalError.stack);
      }
      static is(obj) {
        return obj?.[TRAIT] === "LiquidError";
      }
    }, TokenizationError = class extends LiquidError {
      constructor(message, token) {
        super(message, token), this.name = "TokenizationError", super.update();
      }
    }, ParseError = class extends LiquidError {
      constructor(err2, token) {
        super(err2, token), this.name = "ParseError", this.message = err2.message, super.update();
      }
    }, RenderError = class extends LiquidError {
      constructor(err2, tpl) {
        super(err2, tpl.token), this.name = "RenderError", this.message = err2.message, super.update();
      }
      static is(obj) {
        return obj.name === "RenderError";
      }
    }, UndefinedVariableError = class extends LiquidError {
      constructor(err2, token) {
        super(err2, token), this.name = "UndefinedVariableError", this.message = err2.message, super.update();
      }
    }, InternalUndefinedVariableError = class extends Error {
      constructor(variableName) {
        super(`undefined variable: ${variableName}`), this.name = "InternalUndefinedVariableError", this.variableName = variableName;
      }
    }, AssertionError = class extends Error {
      constructor(message) {
        super(message), this.name = "AssertionError", this.message = message + "";
      }
    };
    function mkContext(token) {
      let [line, col] = token.getPosition(), lines = token.input.split(`
`), begin = Math.max(line - 2, 1), end = Math.min(line + 3, lines.length);
      return range(begin, end + 1).map((lineNumber) => {
        let rowIndicator = lineNumber === line ? ">> " : "   ", num = padStart(String(lineNumber), String(end).length), text = `${rowIndicator}${num}| `, colIndicator = lineNumber === line ? `
` + padStart("^", col + text.length) : "";
        return text += lines[lineNumber - 1], text += colIndicator, text;
      }).join(`
`);
    }
    function mkMessage(msg, token) {
      token.file && (msg += `, file:${token.file}`);
      let [line, col] = token.getPosition();
      return msg += `, line:${line}, col:${col}`, msg;
    }
    var TYPES = [0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 4, 4, 4, 20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 20, 2, 8, 0, 0, 0, 0, 8, 0, 0, 0, 64, 0, 65, 0, 0, 33, 33, 33, 33, 33, 33, 33, 33, 33, 33, 0, 0, 2, 2, 2, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0], IDENTIFIER2 = 1, BLANK = 4, QUOTE = 8, INLINE_BLANK = 16, NUMBER = 32, SIGN = 64;
    TYPES[160] = TYPES[5760] = TYPES[6158] = TYPES[8192] = TYPES[8193] = TYPES[8194] = TYPES[8195] = TYPES[8196] = TYPES[8197] = TYPES[8198] = TYPES[8199] = TYPES[8200] = TYPES[8201] = TYPES[8202] = TYPES[8232] = TYPES[8233] = TYPES[8239] = TYPES[8287] = TYPES[12288] = BLANK;
    function assert(predicate, message) {
      if (!predicate) {
        let msg = typeof message == "function" ? message() : message || `expect ${predicate} to be true`;
        throw new AssertionError(msg);
      }
    }
    var NullDrop = class extends Drop {
      equals(value) {
        return isNil(toValue(value));
      }
      gt() {
        return !1;
      }
      geq() {
        return !1;
      }
      lt() {
        return !1;
      }
      leq() {
        return !1;
      }
      valueOf() {
        return null;
      }
    }, EmptyDrop = class _EmptyDrop extends Drop {
      equals(value) {
        return value instanceof _EmptyDrop ? !1 : (value = toValue(value), isString2(value) || isArray(value) ? value.length === 0 : isObject4(value) ? Object.keys(value).length === 0 : !1);
      }
      gt() {
        return !1;
      }
      geq() {
        return !1;
      }
      lt() {
        return !1;
      }
      leq() {
        return !1;
      }
      valueOf() {
        return "";
      }
    }, BlankDrop = class extends EmptyDrop {
      equals(value) {
        return value === !1 || isNil(toValue(value)) ? !0 : isString2(value) ? /^\s*$/.test(value) : super.equals(value);
      }
    }, ForloopDrop = class extends Drop {
      constructor(length, collection, variable) {
        super(), this.i = 0, this.length = length, this.name = `${variable}-${collection}`;
      }
      next() {
        this.i++;
      }
      index0() {
        return this.i;
      }
      index() {
        return this.i + 1;
      }
      first() {
        return this.i === 0;
      }
      last() {
        return this.i === this.length - 1;
      }
      rindex() {
        return this.length - this.i;
      }
      rindex0() {
        return this.length - this.i - 1;
      }
      valueOf() {
        return JSON.stringify(this);
      }
    }, BlockDrop = class extends Drop {
      constructor(superBlockRender = () => "") {
        super(), this.superBlockRender = superBlockRender;
      }
      /**
       * Provide parent access in child block by
       * {{ block.super }}
       */
      super() {
        return this.superBlockRender();
      }
    };
    function isComparable(arg) {
      return arg && isFunction(arg.equals);
    }
    var nil = new NullDrop(), literalValues = {
      true: !0,
      false: !1,
      nil,
      null: nil,
      empty: new EmptyDrop(),
      blank: new BlankDrop()
    };
    function createTrie(input) {
      let trie = {};
      for (let [name, data] of Object.entries(input)) {
        let node = trie;
        for (let i = 0; i < name.length; i++) {
          let c = name[i];
          node[c] = node[c] || {}, i === name.length - 1 && TYPES[name.charCodeAt(i)] & IDENTIFIER2 && (node[c].needBoundary = !0), node = node[c];
        }
        node.data = data, node.end = !0;
      }
      return trie;
    }
    async function toPromise(val) {
      if (!isIterator(val))
        return val;
      let value, done = !1, next = "next";
      do {
        let state = val[next](value);
        done = state.done, value = state.value, next = "next";
        try {
          isIterator(value) && (value = toPromise(value)), isPromise(value) && (value = await value);
        } catch (err2) {
          next = "throw", value = err2;
        }
      } while (!done);
      return value;
    }
    function toValueSync(val) {
      if (!isIterator(val))
        return val;
      let value, done = !1, next = "next";
      do {
        let state = val[next](value);
        if (done = state.done, value = state.value, next = "next", isIterator(value))
          try {
            value = toValueSync(value);
          } catch (err2) {
            next = "throw", value = err2;
          }
      } while (!done);
      return value;
    }
    function toEnumerable(val) {
      return val = toValue(val), isArray(val) ? val : isString2(val) && val.length > 0 ? [val] : isIterable(val) ? Array.from(val) : isObject4(val) ? Object.keys(val).map((key) => [key, val[key]]) : [];
    }
    function toArray(val) {
      return isNil(val) ? [] : isArray(val) ? val : [val];
    }
    var rFormat = /%([-_0^#:]+)?(\d+)?([EO])?(.)/, monthNames = [
      "January",
      "February",
      "March",
      "April",
      "May",
      "June",
      "July",
      "August",
      "September",
      "October",
      "November",
      "December"
    ], dayNames = [
      "Sunday",
      "Monday",
      "Tuesday",
      "Wednesday",
      "Thursday",
      "Friday",
      "Saturday"
    ], monthNamesShort = monthNames.map(abbr), dayNamesShort = dayNames.map(abbr);
    function abbr(str) {
      return str.slice(0, 3);
    }
    function daysInMonth(d) {
      return [31, isLeapYear(d) ? 29 : 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
    }
    function getDayOfYear(d) {
      let num = 0;
      for (let i = 0; i < d.getMonth(); ++i)
        num += daysInMonth(d)[i];
      return num + d.getDate();
    }
    function getWeekOfYear(d, startDay) {
      let now = getDayOfYear(d) + (startDay - d.getDay()), then = 7 - new Date(d.getFullYear(), 0, 1).getDay() + startDay;
      return String(Math.floor((now - then) / 7) + 1);
    }
    function isLeapYear(d) {
      let year = d.getFullYear();
      return !!(!(year & 3) && (year % 100 || year % 400 === 0 && year));
    }
    function getSuffix(d) {
      let date2 = d.getDate(), suffix = "th";
      switch (date2) {
        case 11:
        case 12:
        case 13:
          break;
        default:
          switch (date2 % 10) {
            case 1:
              suffix = "st";
              break;
            case 2:
              suffix = "nd";
              break;
            case 3:
              suffix = "rd";
              break;
          }
      }
      return suffix;
    }
    function century(d) {
      return parseInt(d.getFullYear().toString().substring(0, 2), 10);
    }
    var padWidths = {
      d: 2,
      e: 2,
      H: 2,
      I: 2,
      j: 3,
      k: 2,
      l: 2,
      L: 3,
      m: 2,
      M: 2,
      S: 2,
      U: 2,
      W: 2
    }, padChars = {
      a: " ",
      A: " ",
      b: " ",
      B: " ",
      c: " ",
      e: " ",
      k: " ",
      l: " ",
      p: " ",
      P: " "
    }, formatCodes = {
      a: (d) => dayNamesShort[d.getDay()],
      A: (d) => dayNames[d.getDay()],
      b: (d) => monthNamesShort[d.getMonth()],
      B: (d) => monthNames[d.getMonth()],
      c: (d) => d.toLocaleString(),
      C: (d) => century(d),
      d: (d) => d.getDate(),
      e: (d) => d.getDate(),
      H: (d) => d.getHours(),
      I: (d) => String(d.getHours() % 12 || 12),
      j: (d) => getDayOfYear(d),
      k: (d) => d.getHours(),
      l: (d) => String(d.getHours() % 12 || 12),
      L: (d) => d.getMilliseconds(),
      m: (d) => d.getMonth() + 1,
      M: (d) => d.getMinutes(),
      N: (d, opts) => {
        let width = Number(opts.width) || 9, str = String(d.getMilliseconds()).slice(0, width);
        return padEnd(str, width, "0");
      },
      p: (d) => d.getHours() < 12 ? "AM" : "PM",
      P: (d) => d.getHours() < 12 ? "am" : "pm",
      q: (d) => getSuffix(d),
      s: (d) => Math.round(d.getTime() / 1e3),
      S: (d) => d.getSeconds(),
      u: (d) => d.getDay() || 7,
      U: (d) => getWeekOfYear(d, 0),
      w: (d) => d.getDay(),
      W: (d) => getWeekOfYear(d, 1),
      x: (d) => d.toLocaleDateString(),
      X: (d) => d.toLocaleTimeString(),
      y: (d) => d.getFullYear().toString().slice(2, 4),
      Y: (d) => d.getFullYear(),
      z: (d, opts) => {
        let nOffset = Math.abs(d.getTimezoneOffset()), h = Math.floor(nOffset / 60), m = nOffset % 60;
        return (d.getTimezoneOffset() > 0 ? "-" : "+") + padStart(h, 2, "0") + (opts.flags[":"] ? ":" : "") + padStart(m, 2, "0");
      },
      t: () => "	",
      n: () => `
`,
      "%": () => "%"
    };
    formatCodes.h = formatCodes.b;
    function strftime(d, formatStr) {
      let output = "", remaining = formatStr, match2;
      for (; match2 = rFormat.exec(remaining); )
        output += remaining.slice(0, match2.index), remaining = remaining.slice(match2.index + match2[0].length), output += format4(d, match2);
      return output + remaining;
    }
    function format4(d, match2) {
      let [input, flagStr = "", width, modifier, conversion] = match2, convert = formatCodes[conversion];
      if (!convert)
        return input;
      let flags = {};
      for (let flag of flagStr)
        flags[flag] = !0;
      let ret = String(convert(d, { flags, width, modifier })), padChar = padChars[conversion] || "0", padWidth = width || padWidths[conversion] || 0;
      return flags["^"] ? ret = ret.toUpperCase() : flags["#"] && (ret = changeCase(ret)), flags._ ? padChar = " " : flags[0] && (padChar = "0"), flags["-"] && (padWidth = 0), padStart(ret, padWidth, padChar);
    }
    var OneMinute = 6e4, ISO8601_TIMEZONE_PATTERN = /([zZ]|([+-])(\d{2}):(\d{2}))$/, TimezoneDate = class _TimezoneDate {
      constructor(init4, timezoneOffset) {
        this.date = init4 instanceof _TimezoneDate ? init4.date : new Date(init4), this.timezoneOffset = timezoneOffset;
        let diff2 = (this.date.getTimezoneOffset() - this.timezoneOffset) * OneMinute, time = this.date.getTime() + diff2;
        this.displayDate = new Date(time);
      }
      getTime() {
        return this.displayDate.getTime();
      }
      getMilliseconds() {
        return this.displayDate.getMilliseconds();
      }
      getSeconds() {
        return this.displayDate.getSeconds();
      }
      getMinutes() {
        return this.displayDate.getMinutes();
      }
      getHours() {
        return this.displayDate.getHours();
      }
      getDay() {
        return this.displayDate.getDay();
      }
      getDate() {
        return this.displayDate.getDate();
      }
      getMonth() {
        return this.displayDate.getMonth();
      }
      getFullYear() {
        return this.displayDate.getFullYear();
      }
      toLocaleString(locale, init4) {
        return init4?.timeZone ? this.date.toLocaleString(locale, init4) : this.displayDate.toLocaleString(locale, init4);
      }
      toLocaleTimeString(locale) {
        return this.displayDate.toLocaleTimeString(locale);
      }
      toLocaleDateString(locale) {
        return this.displayDate.toLocaleDateString(locale);
      }
      getTimezoneOffset() {
        return this.timezoneOffset;
      }
      /**
       * Create a Date object fixed to it's declared Timezone. Both
       * - 2021-08-06T02:29:00.000Z and
       * - 2021-08-06T02:29:00.000+08:00
       * will always be displayed as
       * - 2021-08-06 02:29:00
       * regardless timezoneOffset in JavaScript realm
       *
       * The implementation hack:
       * Instead of calling `.getMonth()`/`.getUTCMonth()` respect to `preserveTimezones`,
       * we create a different Date to trick strftime, it's both simpler and more performant.
       * Given that a template is expected to be parsed fewer times than rendered.
       */
      static createDateFixedToTimezone(dateString) {
        let m = dateString.match(ISO8601_TIMEZONE_PATTERN);
        if (m && m[1] === "Z")
          return new _TimezoneDate(+new Date(dateString), 0);
        if (m && m[2] && m[3] && m[4]) {
          let [, , sign, hours, minutes] = m, offset2 = (sign === "+" ? -1 : 1) * (parseInt(hours, 10) * 60 + parseInt(minutes, 10));
          return new _TimezoneDate(+new Date(dateString), offset2);
        }
        return new Date(dateString);
      }
    }, DelimitedToken = class extends Token {
      constructor(kind, [contentBegin, contentEnd], input, begin, end, trimLeft2, trimRight2, file) {
        super(kind, input, begin, end, file), this.trimLeft = !1, this.trimRight = !1;
        let tl = input[contentBegin] === "-", tr = input[contentEnd - 1] === "-", l = tl ? contentBegin + 1 : contentBegin, r2 = tr ? contentEnd - 1 : contentEnd;
        for (; l < r2 && TYPES[input.charCodeAt(l)] & BLANK; )
          l++;
        for (; r2 > l && TYPES[input.charCodeAt(r2 - 1)] & BLANK; )
          r2--;
        this.contentRange = [l, r2], this.trimLeft = tl || trimLeft2, this.trimRight = tr || trimRight2;
      }
      get content() {
        return this.input.slice(this.contentRange[0], this.contentRange[1]);
      }
    }, TagToken = class extends DelimitedToken {
      constructor(input, begin, end, options, file) {
        let { trimTagLeft, trimTagRight, tagDelimiterLeft, tagDelimiterRight } = options, [valueBegin, valueEnd] = [begin + tagDelimiterLeft.length, end - tagDelimiterRight.length];
        super(exports.TokenKind.Tag, [valueBegin, valueEnd], input, begin, end, trimTagLeft, trimTagRight, file), this.tokenizer = new Tokenizer(input, options.operators, file, this.contentRange), this.name = this.tokenizer.readTagName(), this.tokenizer.assert(this.name, "illegal tag syntax, tag name expected"), this.tokenizer.skipBlank();
      }
      get args() {
        return this.tokenizer.input.slice(this.tokenizer.p, this.contentRange[1]);
      }
    }, OutputToken = class extends DelimitedToken {
      constructor(input, begin, end, options, file) {
        let { trimOutputLeft, trimOutputRight, outputDelimiterLeft, outputDelimiterRight } = options, valueRange = [begin + outputDelimiterLeft.length, end - outputDelimiterRight.length];
        super(exports.TokenKind.Output, valueRange, input, begin, end, trimOutputLeft, trimOutputRight, file);
      }
    }, HTMLToken = class extends Token {
      constructor(input, begin, end, file) {
        super(exports.TokenKind.HTML, input, begin, end, file), this.input = input, this.begin = begin, this.end = end, this.file = file, this.trimLeft = 0, this.trimRight = 0;
      }
      getContent() {
        return this.input.slice(this.begin + this.trimLeft, this.end - this.trimRight);
      }
    }, NumberToken = class extends Token {
      constructor(input, begin, end, file) {
        super(exports.TokenKind.Number, input, begin, end, file), this.input = input, this.begin = begin, this.end = end, this.file = file, this.content = Number(this.getText());
      }
    }, IdentifierToken = class extends Token {
      constructor(input, begin, end, file) {
        super(exports.TokenKind.Word, input, begin, end, file), this.input = input, this.begin = begin, this.end = end, this.file = file, this.content = this.getText();
      }
      isNumber(allowSign = !1) {
        let begin = allowSign && TYPES[this.input.charCodeAt(this.begin)] & SIGN ? this.begin + 1 : this.begin;
        for (let i = begin; i < this.end; i++)
          if (!(TYPES[this.input.charCodeAt(i)] & NUMBER))
            return !1;
        return !0;
      }
    }, LiteralToken = class extends Token {
      constructor(input, begin, end, file) {
        super(exports.TokenKind.Literal, input, begin, end, file), this.input = input, this.begin = begin, this.end = end, this.file = file, this.literal = this.getText(), this.content = literalValues[this.literal];
      }
    }, operatorPrecedences = {
      "==": 2,
      "!=": 2,
      ">": 2,
      "<": 2,
      ">=": 2,
      "<=": 2,
      contains: 2,
      not: 1,
      and: 0,
      or: 0
    }, operatorTypes = {
      "==": 0,
      "!=": 0,
      ">": 0,
      "<": 0,
      ">=": 0,
      "<=": 0,
      contains: 0,
      not: 1,
      and: 0,
      or: 0
      /* OperatorType.Binary */
    }, OperatorToken = class extends Token {
      constructor(input, begin, end, file) {
        super(exports.TokenKind.Operator, input, begin, end, file), this.input = input, this.begin = begin, this.end = end, this.file = file, this.operator = this.getText();
      }
      getPrecedence() {
        let key = this.getText();
        return key in operatorPrecedences ? operatorPrecedences[key] : 1;
      }
    }, PropertyAccessToken = class extends Token {
      constructor(variable, props, input, begin, end, file) {
        super(exports.TokenKind.PropertyAccess, input, begin, end, file), this.variable = variable, this.props = props;
      }
    }, FilterToken = class extends Token {
      constructor(name, args, input, begin, end, file) {
        super(exports.TokenKind.Filter, input, begin, end, file), this.name = name, this.args = args;
      }
    }, HashToken = class extends Token {
      constructor(input, begin, end, name, value, file) {
        super(exports.TokenKind.Hash, input, begin, end, file), this.input = input, this.begin = begin, this.end = end, this.name = name, this.value = value, this.file = file;
      }
    }, rHex = /[\da-fA-F]/, rOct = /[0-7]/, escapeChar = {
      b: "\b",
      f: "\f",
      n: `
`,
      r: "\r",
      t: "	",
      v: "\v"
    };
    function hexVal(c) {
      let code = c.charCodeAt(0);
      return code >= 97 ? code - 87 : code >= 65 ? code - 55 : code - 48;
    }
    function parseStringLiteral(str) {
      let ret = "";
      for (let i = 1; i < str.length - 1; i++) {
        if (str[i] !== "\\") {
          ret += str[i];
          continue;
        }
        if (escapeChar[str[i + 1]] !== void 0)
          ret += escapeChar[str[++i]];
        else if (str[i + 1] === "u") {
          let val = 0, j = i + 2;
          for (; j <= i + 5 && rHex.test(str[j]); )
            val = val * 16 + hexVal(str[j++]);
          i = j - 1, ret += String.fromCharCode(val);
        } else if (!rOct.test(str[i + 1]))
          ret += str[++i];
        else {
          let j = i + 1, val = 0;
          for (; j <= i + 3 && rOct.test(str[j]); )
            val = val * 8 + hexVal(str[j++]);
          i = j - 1, ret += String.fromCharCode(val);
        }
      }
      return ret;
    }
    var QuotedToken = class extends Token {
      constructor(input, begin, end, file) {
        super(exports.TokenKind.Quoted, input, begin, end, file), this.input = input, this.begin = begin, this.end = end, this.file = file, this.content = parseStringLiteral(this.getText());
      }
    }, RangeToken = class extends Token {
      constructor(input, begin, end, lhs, rhs, file) {
        super(exports.TokenKind.Range, input, begin, end, file), this.input = input, this.begin = begin, this.end = end, this.lhs = lhs, this.rhs = rhs, this.file = file;
      }
    }, LiquidTagToken = class extends DelimitedToken {
      constructor(input, begin, end, options, file) {
        super(exports.TokenKind.Tag, [begin, end], input, begin, end, !1, !1, file), this.tokenizer = new Tokenizer(input, options.operators, file, this.contentRange), this.name = this.tokenizer.readTagName(), this.tokenizer.assert(this.name, "illegal liquid tag syntax"), this.tokenizer.skipBlank(), this.args = this.tokenizer.remaining();
      }
    }, FilteredValueToken = class extends Token {
      constructor(initial, filters2, input, begin, end, file) {
        super(exports.TokenKind.FilteredValue, input, begin, end, file), this.initial = initial, this.filters = filters2, this.input = input, this.begin = begin, this.end = end, this.file = file;
      }
    }, SimpleEmitter = class {
      constructor() {
        this.buffer = "";
      }
      write(html) {
        this.buffer += stringify(html);
      }
    }, StreamedEmitter = class {
      constructor() {
        this.buffer = "", this.stream = new stream2.PassThrough();
      }
      write(html) {
        this.stream.write(stringify(html));
      }
      error(err2) {
        this.stream.emit("error", err2);
      }
      end() {
        this.stream.end();
      }
    }, KeepingTypeEmitter = class {
      constructor() {
        this.buffer = "";
      }
      write(html) {
        html = toValue(html), typeof html != "string" && this.buffer === "" ? this.buffer = html : this.buffer = stringify(this.buffer) + stringify(html);
      }
    }, Render = class {
      renderTemplatesToNodeStream(templates2, ctx) {
        let emitter = new StreamedEmitter();
        return Promise.resolve().then(() => toPromise(this.renderTemplates(templates2, ctx, emitter))).then(() => emitter.end(), (err2) => emitter.error(err2)), emitter.stream;
      }
      *renderTemplates(templates2, ctx, emitter) {
        emitter || (emitter = ctx.opts.keepOutputType ? new KeepingTypeEmitter() : new SimpleEmitter());
        for (let tpl of templates2)
          try {
            let html = yield tpl.render(ctx, emitter);
            if (html && emitter.write(html), emitter.break || emitter.continue)
              break;
          } catch (e) {
            throw RenderError.is(e) ? e : new RenderError(e, tpl);
          }
        return emitter.buffer;
      }
    }, Expression = class {
      constructor(tokens) {
        this.postfix = [...toPostfix(tokens)];
      }
      *evaluate(ctx, lenient) {
        assert(ctx, "unable to evaluate: context not defined");
        let operands = [];
        for (let token of this.postfix)
          if (isOperatorToken(token)) {
            let r2 = operands.pop(), result;
            if (operatorTypes[token.operator] === 1)
              result = yield ctx.opts.operators[token.operator](r2, ctx);
            else {
              let l = operands.pop();
              result = yield ctx.opts.operators[token.operator](l, r2, ctx);
            }
            operands.push(result);
          } else
            operands.push(yield evalToken(token, ctx, lenient && this.postfix.length === 1));
        return operands[0];
      }
      valid() {
        return !!this.postfix.length;
      }
    };
    function* evalToken(token, ctx, lenient = !1) {
      if (token) {
        if ("content" in token)
          return token.content;
        if (isPropertyAccessToken(token))
          return yield evalPropertyAccessToken(token, ctx, lenient);
        if (isRangeToken(token))
          return yield evalRangeToken(token, ctx);
      }
    }
    function* evalPropertyAccessToken(token, ctx, lenient) {
      let props = [], variable = yield evalToken(token.variable, ctx, lenient);
      for (let prop of token.props)
        props.push(yield evalToken(prop, ctx, !1));
      try {
        return token.variable ? yield ctx._getFromScope(variable, props) : yield ctx._get(props);
      } catch (e) {
        if (lenient && e.name === "InternalUndefinedVariableError")
          return null;
        throw new UndefinedVariableError(e, token);
      }
    }
    function evalQuotedToken(token) {
      return token.content;
    }
    function* evalRangeToken(token, ctx) {
      let low = yield evalToken(token.lhs, ctx), high = yield evalToken(token.rhs, ctx);
      return range(+low, +high + 1);
    }
    function* toPostfix(tokens) {
      let ops = [];
      for (let token of tokens)
        if (isOperatorToken(token)) {
          for (; ops.length && ops[ops.length - 1].getPrecedence() > token.getPrecedence(); )
            yield ops.pop();
          ops.push(token);
        } else
          yield token;
      for (; ops.length; )
        yield ops.pop();
    }
    function isTruthy2(val, ctx) {
      return !isFalsy(val, ctx);
    }
    function isFalsy(val, ctx) {
      return ctx.opts.jsTruthy ? !val : val === !1 || val === void 0 || val === null;
    }
    var defaultOperators = {
      "==": equal,
      "!=": (l, r2) => !equal(l, r2),
      ">": (l, r2) => isComparable(l) ? l.gt(r2) : isComparable(r2) ? r2.lt(l) : toValue(l) > toValue(r2),
      "<": (l, r2) => isComparable(l) ? l.lt(r2) : isComparable(r2) ? r2.gt(l) : toValue(l) < toValue(r2),
      ">=": (l, r2) => isComparable(l) ? l.geq(r2) : isComparable(r2) ? r2.leq(l) : toValue(l) >= toValue(r2),
      "<=": (l, r2) => isComparable(l) ? l.leq(r2) : isComparable(r2) ? r2.geq(l) : toValue(l) <= toValue(r2),
      contains: (l, r2) => (l = toValue(l), r2 = toValue(r2), l && isFunction(l.indexOf) ? l.indexOf(r2) > -1 : !1),
      not: (v, ctx) => isFalsy(toValue(v), ctx),
      and: (l, r2, ctx) => isTruthy2(toValue(l), ctx) && isTruthy2(toValue(r2), ctx),
      or: (l, r2, ctx) => isTruthy2(toValue(l), ctx) || isTruthy2(toValue(r2), ctx)
    };
    function equal(lhs, rhs) {
      return isComparable(lhs) ? lhs.equals(rhs) : isComparable(rhs) ? rhs.equals(lhs) : (lhs = toValue(lhs), rhs = toValue(rhs), isArray(lhs) ? isArray(rhs) && arrayEqual(lhs, rhs) : lhs === rhs);
    }
    function arrayEqual(lhs, rhs) {
      return lhs.length !== rhs.length ? !1 : !lhs.some((value, i) => !equal(value, rhs[i]));
    }
    var Node2 = class {
      constructor(key, value, next, prev) {
        this.key = key, this.value = value, this.next = next, this.prev = prev;
      }
    }, LRU = class {
      constructor(limit2, size2 = 0) {
        this.limit = limit2, this.size = size2, this.cache = {}, this.head = new Node2("HEAD", null, null, null), this.tail = new Node2("TAIL", null, null, null), this.head.next = this.tail, this.tail.prev = this.head;
      }
      write(key, value) {
        if (this.cache[key])
          this.cache[key].value = value;
        else {
          let node = new Node2(key, value, this.head.next, this.head);
          this.head.next.prev = node, this.head.next = node, this.cache[key] = node, this.size++, this.ensureLimit();
        }
      }
      read(key) {
        if (!this.cache[key])
          return;
        let { value } = this.cache[key];
        return this.remove(key), this.write(key, value), value;
      }
      remove(key) {
        let node = this.cache[key];
        node.prev.next = node.next, node.next.prev = node.prev, delete this.cache[key], this.size--;
      }
      clear() {
        this.head.next = this.tail, this.tail.prev = this.head, this.size = 0, this.cache = {};
      }
      ensureLimit() {
        this.size > this.limit && this.remove(this.tail.prev.key);
      }
    }, requireResolve = __require.resolve, statAsync = promisify(fs$1.stat), readFileAsync = promisify(fs$1.readFile);
    async function exists(filepath) {
      try {
        return await statAsync(filepath), !0;
      } catch {
        return !1;
      }
    }
    function readFile5(filepath) {
      return readFileAsync(filepath, "utf8");
    }
    function existsSync2(filepath) {
      try {
        return fs$1.statSync(filepath), !0;
      } catch {
        return !1;
      }
    }
    function readFileSync3(filepath) {
      return fs$1.readFileSync(filepath, "utf8");
    }
    function resolve2(root, file, ext) {
      return path3.extname(file) || (file += ext), path3.resolve(root, file);
    }
    function fallback(file) {
      try {
        return requireResolve(file);
      } catch {
      }
    }
    function dirname5(filepath) {
      return path3.dirname(filepath);
    }
    function contains3(root, file) {
      return root = path3.resolve(root), root = root.endsWith(path3.sep) ? root : root + path3.sep, file.startsWith(root);
    }
    var fs6 = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      exists,
      readFile: readFile5,
      existsSync: existsSync2,
      readFileSync: readFileSync3,
      resolve: resolve2,
      fallback,
      dirname: dirname5,
      contains: contains3,
      sep: path3.sep
    });
    function Default(value, defaultValue, ...args) {
      return value = toValue(value), isArray(value) || isString2(value) ? value.length ? value : defaultValue : value === !1 && new Map(args).get("allow_false") ? !1 : isFalsy(value, this.context) ? defaultValue : value;
    }
    function json(value, space = 0) {
      return JSON.stringify(value, null, space);
    }
    var raw = {
      raw: !0,
      handler: identify
    }, escapeMap = {
      "&": "&amp;",
      "<": "&lt;",
      ">": "&gt;",
      '"': "&#34;",
      "'": "&#39;"
    }, unescapeMap = {
      "&amp;": "&",
      "&lt;": "<",
      "&gt;": ">",
      "&#34;": '"',
      "&#39;": "'"
    };
    function escape2(str) {
      return stringify(str).replace(/&|<|>|"|'/g, (m) => escapeMap[m]);
    }
    function unescape3(str) {
      return stringify(str).replace(/&(amp|lt|gt|#34|#39);/g, (m) => unescapeMap[m]);
    }
    function escape_once(str) {
      return escape2(unescape3(stringify(str)));
    }
    function newline_to_br(v) {
      return stringify(v).replace(/\r?\n/gm, `<br />
`);
    }
    function strip_html(v) {
      return stringify(v).replace(/<script[\s\S]*?<\/script>|<style[\s\S]*?<\/style>|<.*?>|<!--[\s\S]*?-->/g, "");
    }
    var htmlFilters = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      escape: escape2,
      escape_once,
      newline_to_br,
      strip_html
    }), defaultOptions = {
      root: ["."],
      layouts: ["."],
      partials: ["."],
      relativeReference: !0,
      jekyllInclude: !1,
      cache: void 0,
      extname: "",
      fs: fs6,
      dynamicPartials: !0,
      jsTruthy: !1,
      dateFormat: "%A, %B %-e, %Y at %-l:%M %P %z",
      trimTagRight: !1,
      trimTagLeft: !1,
      trimOutputRight: !1,
      trimOutputLeft: !1,
      greedy: !0,
      tagDelimiterLeft: "{%",
      tagDelimiterRight: "%}",
      outputDelimiterLeft: "{{",
      outputDelimiterRight: "}}",
      preserveTimezones: !1,
      strictFilters: !1,
      strictVariables: !1,
      ownPropertyOnly: !0,
      lenientIf: !1,
      globals: {},
      keepOutputType: !1,
      operators: defaultOperators
    };
    function normalize(options) {
      if (options.hasOwnProperty("root") && (options.hasOwnProperty("partials") || (options.partials = options.root), options.hasOwnProperty("layouts") || (options.layouts = options.root)), options.hasOwnProperty("cache")) {
        let cache2;
        typeof options.cache == "number" ? cache2 = options.cache > 0 ? new LRU(options.cache) : void 0 : typeof options.cache == "object" ? cache2 = options.cache : cache2 = options.cache ? new LRU(1024) : void 0, options.cache = cache2;
      }
      return options = { ...defaultOptions, ...options.jekyllInclude ? { dynamicPartials: !1 } : {}, ...options }, (!options.fs.dirname || !options.fs.sep) && options.relativeReference && (console.warn("[LiquidJS] `fs.dirname` and `fs.sep` are required for relativeReference, set relativeReference to `false` to suppress this warning"), options.relativeReference = !1), options.root = normalizeDirectoryList(options.root), options.partials = normalizeDirectoryList(options.partials), options.layouts = normalizeDirectoryList(options.layouts), options.outputEscape = options.outputEscape && getOutputEscapeFunction(options.outputEscape), options;
    }
    function getOutputEscapeFunction(nameOrFunction) {
      return nameOrFunction === "escape" ? escape2 : nameOrFunction === "json" ? json : (assert(isFunction(nameOrFunction), "`outputEscape` need to be of type string or function"), nameOrFunction);
    }
    function normalizeDirectoryList(value) {
      let list2 = [];
      return isArray(value) && (list2 = value), isString2(value) && (list2 = [value]), list2;
    }
    function whiteSpaceCtrl(tokens, options) {
      let inRaw = !1;
      for (let i = 0; i < tokens.length; i++) {
        let token = tokens[i];
        isDelimitedToken(token) && (!inRaw && token.trimLeft && trimLeft(tokens[i - 1], options.greedy), isTagToken(token) && (token.name === "raw" ? inRaw = !0 : token.name === "endraw" && (inRaw = !1)), !inRaw && token.trimRight && trimRight(tokens[i + 1], options.greedy));
      }
    }
    function trimLeft(token, greedy) {
      if (!token || !isHTMLToken(token))
        return;
      let mask = greedy ? BLANK : INLINE_BLANK;
      for (; TYPES[token.input.charCodeAt(token.end - 1 - token.trimRight)] & mask; )
        token.trimRight++;
    }
    function trimRight(token, greedy) {
      if (!token || !isHTMLToken(token))
        return;
      let mask = greedy ? BLANK : INLINE_BLANK;
      for (; TYPES[token.input.charCodeAt(token.begin + token.trimLeft)] & mask; )
        token.trimLeft++;
      token.input.charAt(token.begin + token.trimLeft) === `
` && token.trimLeft++;
    }
    var Tokenizer = class {
      constructor(input, operators = defaultOptions.operators, file, range2) {
        this.input = input, this.file = file, this.range = range2, this.rawBeginAt = -1, this.p = range2 ? range2[0] : 0, this.N = range2 ? range2[1] : input.length, this.opTrie = createTrie(operators), this.literalTrie = createTrie(literalValues);
      }
      readExpression() {
        return new Expression(this.readExpressionTokens());
      }
      *readExpressionTokens() {
        for (; this.p < this.N; ) {
          let operator = this.readOperator();
          if (operator) {
            yield operator;
            continue;
          }
          let operand = this.readValue();
          if (operand) {
            yield operand;
            continue;
          }
          return;
        }
      }
      readOperator() {
        this.skipBlank();
        let end = this.matchTrie(this.opTrie);
        if (end !== -1)
          return new OperatorToken(this.input, this.p, this.p = end, this.file);
      }
      matchTrie(trie) {
        let node = trie, i = this.p, info2;
        for (; node[this.input[i]] && i < this.N; )
          node = node[this.input[i++]], node.end && (info2 = node);
        return !info2 || info2.needBoundary && this.peekType(i - this.p) & IDENTIFIER2 ? -1 : i;
      }
      readFilteredValue() {
        let begin = this.p, initial = this.readExpression();
        this.assert(initial.valid(), `invalid value expression: ${this.snapshot()}`);
        let filters2 = this.readFilters();
        return new FilteredValueToken(initial, filters2, this.input, begin, this.p, this.file);
      }
      readFilters() {
        let filters2 = [];
        for (; ; ) {
          let filter = this.readFilter();
          if (!filter)
            return filters2;
          filters2.push(filter);
        }
      }
      readFilter() {
        if (this.skipBlank(), this.end())
          return null;
        this.assert(this.peek() === "|", 'expected "|" before filter'), this.p++;
        let begin = this.p, name = this.readIdentifier();
        if (!name.size())
          return this.assert(this.end(), "expected filter name"), null;
        let args = [];
        if (this.skipBlank(), this.peek() === ":")
          do {
            ++this.p;
            let arg = this.readFilterArg();
            arg && args.push(arg), this.skipBlank(), this.assert(this.end() || this.peek() === "," || this.peek() === "|", () => `unexpected character ${this.snapshot()}`);
          } while (this.peek() === ",");
        else if (!(this.peek() === "|" || this.end()))
          throw this.error('expected ":" after filter name');
        return new FilterToken(name.getText(), args, this.input, begin, this.p, this.file);
      }
      readFilterArg() {
        let key = this.readValue();
        if (!key)
          return;
        if (this.skipBlank(), this.peek() !== ":")
          return key;
        ++this.p;
        let value = this.readValue();
        return [key.getText(), value];
      }
      readTopLevelTokens(options = defaultOptions) {
        let tokens = [];
        for (; this.p < this.N; ) {
          let token = this.readTopLevelToken(options);
          tokens.push(token);
        }
        return whiteSpaceCtrl(tokens, options), tokens;
      }
      readTopLevelToken(options) {
        let { tagDelimiterLeft, outputDelimiterLeft } = options;
        return this.rawBeginAt > -1 ? this.readEndrawOrRawContent(options) : this.match(tagDelimiterLeft) ? this.readTagToken(options) : this.match(outputDelimiterLeft) ? this.readOutputToken(options) : this.readHTMLToken([tagDelimiterLeft, outputDelimiterLeft]);
      }
      readHTMLToken(stopStrings) {
        let begin = this.p;
        for (; this.p < this.N && !stopStrings.some((str) => this.match(str)); )
          ++this.p;
        return new HTMLToken(this.input, begin, this.p, this.file);
      }
      readTagToken(options = defaultOptions) {
        let { file, input } = this, begin = this.p;
        if (this.readToDelimiter(options.tagDelimiterRight) === -1)
          throw this.error(`tag ${this.snapshot(begin)} not closed`, begin);
        let token = new TagToken(input, begin, this.p, options, file);
        return token.name === "raw" && (this.rawBeginAt = begin), token;
      }
      readToDelimiter(delimiter, respectQuoted = !1) {
        for (this.skipBlank(); this.p < this.N; ) {
          if (respectQuoted && this.peekType() & QUOTE) {
            this.readQuoted();
            continue;
          }
          if (++this.p, this.rmatch(delimiter))
            return this.p;
        }
        return -1;
      }
      readOutputToken(options = defaultOptions) {
        let { file, input } = this, { outputDelimiterRight } = options, begin = this.p;
        if (this.readToDelimiter(outputDelimiterRight, !0) === -1)
          throw this.error(`output ${this.snapshot(begin)} not closed`, begin);
        return new OutputToken(input, begin, this.p, options, file);
      }
      readEndrawOrRawContent(options) {
        let { tagDelimiterLeft, tagDelimiterRight } = options, begin = this.p, leftPos = this.readTo(tagDelimiterLeft) - tagDelimiterLeft.length;
        for (; this.p < this.N; ) {
          if (this.readIdentifier().getText() !== "endraw") {
            leftPos = this.readTo(tagDelimiterLeft) - tagDelimiterLeft.length;
            continue;
          }
          for (; this.p <= this.N; ) {
            if (this.rmatch(tagDelimiterRight)) {
              let end = this.p;
              return begin === leftPos ? (this.rawBeginAt = -1, new TagToken(this.input, begin, end, options, this.file)) : (this.p = leftPos, new HTMLToken(this.input, begin, leftPos, this.file));
            }
            if (this.rmatch(tagDelimiterLeft))
              break;
            this.p++;
          }
        }
        throw this.error(`raw ${this.snapshot(this.rawBeginAt)} not closed`, begin);
      }
      readLiquidTagTokens(options = defaultOptions) {
        let tokens = [];
        for (; this.p < this.N; ) {
          let token = this.readLiquidTagToken(options);
          token && tokens.push(token);
        }
        return tokens;
      }
      readLiquidTagToken(options) {
        if (this.skipBlank(), this.end())
          return;
        let begin = this.p;
        this.readToDelimiter(`
`);
        let end = this.p;
        return new LiquidTagToken(this.input, begin, end, options, this.file);
      }
      error(msg, pos = this.p) {
        return new TokenizationError(msg, new IdentifierToken(this.input, pos, this.N, this.file));
      }
      assert(pred, msg, pos) {
        if (!pred)
          throw this.error(typeof msg == "function" ? msg() : msg, pos);
      }
      snapshot(begin = this.p) {
        return JSON.stringify(ellipsis(this.input.slice(begin, this.N), 32));
      }
      /**
       * @deprecated use #readIdentifier instead
       */
      readWord() {
        return this.readIdentifier();
      }
      readIdentifier() {
        this.skipBlank();
        let begin = this.p;
        for (; !this.end() && this.peekType() & IDENTIFIER2; )
          ++this.p;
        return new IdentifierToken(this.input, begin, this.p, this.file);
      }
      readTagName() {
        return this.skipBlank(), this.input[this.p] === "#" ? this.input.slice(this.p, ++this.p) : this.readIdentifier().getText();
      }
      readHashes(jekyllStyle) {
        let hashes = [];
        for (; ; ) {
          let hash = this.readHash(jekyllStyle);
          if (!hash)
            return hashes;
          hashes.push(hash);
        }
      }
      readHash(jekyllStyle) {
        this.skipBlank(), this.peek() === "," && ++this.p;
        let begin = this.p, name = this.readIdentifier();
        if (!name.size())
          return;
        let value;
        this.skipBlank();
        let sep3 = jekyllStyle ? "=" : ":";
        return this.peek() === sep3 && (++this.p, value = this.readValue()), new HashToken(this.input, begin, this.p, name, value, this.file);
      }
      remaining() {
        return this.input.slice(this.p, this.N);
      }
      advance(step = 1) {
        this.p += step;
      }
      end() {
        return this.p >= this.N;
      }
      readTo(end) {
        for (; this.p < this.N; )
          if (++this.p, this.rmatch(end))
            return this.p;
        return -1;
      }
      readValue() {
        this.skipBlank();
        let begin = this.p, variable = this.readLiteral() || this.readQuoted() || this.readRange() || this.readNumber(), props = [];
        for (; ; ) {
          if (this.peek() === "[") {
            this.p++;
            let prop = this.readValue() || new IdentifierToken(this.input, this.p, this.p, this.file);
            this.assert(this.readTo("]") !== -1, "[ not closed"), props.push(prop);
            continue;
          }
          if (!variable && !props.length) {
            let prop = this.readIdentifier();
            if (prop.size()) {
              props.push(prop);
              continue;
            }
          }
          if (this.peek() === "." && this.peek(1) !== ".") {
            this.p++;
            let prop = this.readIdentifier();
            if (!prop.size())
              break;
            props.push(prop);
            continue;
          }
          break;
        }
        return props.length ? new PropertyAccessToken(variable, props, this.input, begin, this.p) : variable;
      }
      readNumber() {
        this.skipBlank();
        let decimalFound = !1, digitFound = !1, n = 0;
        for (this.peekType() & SIGN && n++; this.p + n <= this.N; )
          if (this.peekType(n) & NUMBER)
            digitFound = !0, n++;
          else if (this.peek(n) === "." && this.peek(n + 1) !== ".") {
            if (decimalFound || !digitFound)
              return;
            decimalFound = !0, n++;
          } else
            break;
        if (digitFound && !(this.peekType(n) & IDENTIFIER2)) {
          let num = new NumberToken(this.input, this.p, this.p + n, this.file);
          return this.advance(n), num;
        }
      }
      readLiteral() {
        this.skipBlank();
        let end = this.matchTrie(this.literalTrie);
        if (end === -1)
          return;
        let literal = new LiteralToken(this.input, this.p, end, this.file);
        return this.p = end, literal;
      }
      readRange() {
        this.skipBlank();
        let begin = this.p;
        if (this.peek() !== "(")
          return;
        ++this.p;
        let lhs = this.readValueOrThrow();
        this.p += 2;
        let rhs = this.readValueOrThrow();
        return ++this.p, new RangeToken(this.input, begin, this.p, lhs, rhs, this.file);
      }
      readValueOrThrow() {
        let value = this.readValue();
        return this.assert(value, () => `unexpected token ${this.snapshot()}, value expected`), value;
      }
      readQuoted() {
        this.skipBlank();
        let begin = this.p;
        if (!(this.peekType() & QUOTE))
          return;
        ++this.p;
        let escaped = !1;
        for (; this.p < this.N && (++this.p, !(this.input[this.p - 1] === this.input[begin] && !escaped)); )
          escaped ? escaped = !1 : this.input[this.p - 1] === "\\" && (escaped = !0);
        return new QuotedToken(this.input, begin, this.p, this.file);
      }
      *readFileNameTemplate(options) {
        let { outputDelimiterLeft } = options, htmlStopStrings = [",", " ", outputDelimiterLeft], htmlStopStringSet = new Set(htmlStopStrings);
        for (; this.p < this.N && !htmlStopStringSet.has(this.peek()); )
          yield this.match(outputDelimiterLeft) ? this.readOutputToken(options) : this.readHTMLToken(htmlStopStrings);
      }
      match(word) {
        for (let i = 0; i < word.length; i++)
          if (word[i] !== this.input[this.p + i])
            return !1;
        return !0;
      }
      rmatch(pattern) {
        for (let i = 0; i < pattern.length; i++)
          if (pattern[pattern.length - 1 - i] !== this.input[this.p - 1 - i])
            return !1;
        return !0;
      }
      peekType(n = 0) {
        return this.p + n >= this.N ? 0 : TYPES[this.input.charCodeAt(this.p + n)];
      }
      peek(n = 0) {
        return this.p + n >= this.N ? "" : this.input[this.p + n];
      }
      skipBlank() {
        for (; this.peekType() & BLANK; )
          ++this.p;
      }
    }, ParseStream = class {
      constructor(tokens, parseToken2) {
        this.handlers = {}, this.stopRequested = !1, this.tokens = tokens, this.parseToken = parseToken2;
      }
      on(name, cb) {
        return this.handlers[name] = cb, this;
      }
      trigger(event, arg) {
        let h = this.handlers[event];
        return h ? (h.call(this, arg), !0) : !1;
      }
      start() {
        this.trigger("start");
        let token;
        for (; !this.stopRequested && (token = this.tokens.shift()); ) {
          if (this.trigger("token", token) || isTagToken(token) && this.trigger(`tag:${token.name}`, token))
            continue;
          let template2 = this.parseToken(token, this.tokens);
          this.trigger("template", template2);
        }
        return this.stopRequested || this.trigger("end"), this;
      }
      stop() {
        return this.stopRequested = !0, this;
      }
    }, TemplateImpl = class {
      constructor(token) {
        this.token = token;
      }
    }, Tag = class extends TemplateImpl {
      constructor(token, remainTokens, liquid) {
        super(token), this.name = token.name, this.liquid = liquid, this.tokenizer = token.tokenizer;
      }
    }, Hash = class {
      constructor(markup, jekyllStyle) {
        this.hash = {};
        let tokenizer = new Tokenizer(markup, {});
        for (let hash of tokenizer.readHashes(jekyllStyle))
          this.hash[hash.name.content] = hash.value;
      }
      *render(ctx) {
        let hash = {};
        for (let key of Object.keys(this.hash))
          hash[key] = this.hash[key] === void 0 ? !0 : yield evalToken(this.hash[key], ctx);
        return hash;
      }
    };
    function createTagClass(options) {
      return class extends Tag {
        constructor(token, tokens, liquid) {
          super(token, tokens, liquid), isFunction(options.parse) && options.parse.call(this, token, tokens);
        }
        *render(ctx, emitter) {
          let hash = yield new Hash(this.token.args).render(ctx);
          return yield options.render.call(this, ctx, emitter, hash);
        }
      };
    }
    function isKeyValuePair(arr) {
      return isArray(arr);
    }
    var Filter2 = class {
      constructor(name, options, args, liquid) {
        this.name = name, this.handler = isFunction(options) ? options : isFunction(options?.handler) ? options.handler : identify, this.raw = !isFunction(options) && !!options?.raw, this.args = args, this.liquid = liquid;
      }
      *render(value, context) {
        let argv = [];
        for (let arg of this.args)
          isKeyValuePair(arg) ? argv.push([arg[0], yield evalToken(arg[1], context)]) : argv.push(yield evalToken(arg, context));
        return yield this.handler.apply({ context, liquid: this.liquid }, [value, ...argv]);
      }
    }, Value = class {
      /**
       * @param str the value to be valuated, eg.: "foobar" | truncate: 3
       */
      constructor(input, liquid) {
        this.filters = [];
        let token = typeof input == "string" ? new Tokenizer(input, liquid.options.operators).readFilteredValue() : input;
        this.initial = token.initial, this.filters = token.filters.map(({ name, args }) => new Filter2(name, this.getFilter(liquid, name), args, liquid));
      }
      *value(ctx, lenient) {
        lenient = lenient || ctx.opts.lenientIf && this.filters.length > 0 && this.filters[0].name === "default";
        let val = yield this.initial.evaluate(ctx, lenient);
        for (let filter of this.filters)
          val = yield filter.render(val, ctx);
        return val;
      }
      getFilter(liquid, name) {
        let impl = liquid.filters[name];
        return assert(impl || !liquid.options.strictFilters, () => `undefined filter: ${name}`), impl;
      }
    }, Output = class extends TemplateImpl {
      constructor(token, liquid) {
        super(token);
        let tokenizer = new Tokenizer(token.input, liquid.options.operators, token.file, token.contentRange);
        this.value = new Value(tokenizer.readFilteredValue(), liquid);
        let filters2 = this.value.filters, outputEscape = liquid.options.outputEscape;
        !filters2[filters2.length - 1]?.raw && outputEscape && filters2.push(new Filter2(toString.call(outputEscape), outputEscape, [], liquid));
      }
      *render(ctx, emitter) {
        let val = yield this.value.value(ctx, !1);
        emitter.write(val);
      }
    }, HTML = class extends TemplateImpl {
      constructor(token) {
        super(token), this.str = token.getContent();
      }
      *render(ctx, emitter) {
        emitter.write(this.str);
      }
    }, LookupType;
    (function(LookupType2) {
      LookupType2.Partials = "partials", LookupType2.Layouts = "layouts", LookupType2.Root = "root";
    })(LookupType || (LookupType = {}));
    var Loader = class {
      constructor(options) {
        if (this.options = options, options.relativeReference) {
          let sep3 = options.fs.sep;
          assert(sep3, "`fs.sep` is required for relative reference");
          let rRelativePath = new RegExp(["." + sep3, ".." + sep3, "./", "../"].map((prefix) => escapeRegex(prefix)).join("|"));
          this.shouldLoadRelative = (referencedFile) => rRelativePath.test(referencedFile);
        } else
          this.shouldLoadRelative = (referencedFile) => !1;
        this.contains = this.options.fs.contains || (() => !0);
      }
      *lookup(file, type, sync, currentFile) {
        let { fs: fs7 } = this.options, dirs = this.options[type];
        for (let filepath of this.candidates(file, dirs, currentFile, type !== LookupType.Root))
          if (sync ? fs7.existsSync(filepath) : yield fs7.exists(filepath))
            return filepath;
        throw this.lookupError(file, dirs);
      }
      *candidates(file, dirs, currentFile, enforceRoot) {
        let { fs: fs7, extname: extname2 } = this.options;
        if (this.shouldLoadRelative(file) && currentFile) {
          let referenced = fs7.resolve(this.dirname(currentFile), file, extname2);
          for (let dir of dirs)
            if (!enforceRoot || this.contains(dir, referenced)) {
              yield referenced;
              break;
            }
        }
        for (let dir of dirs) {
          let referenced = fs7.resolve(dir, file, extname2);
          (!enforceRoot || this.contains(dir, referenced)) && (yield referenced);
        }
        if (fs7.fallback !== void 0) {
          let filepath = fs7.fallback(file);
          filepath !== void 0 && (yield filepath);
        }
      }
      dirname(path4) {
        let fs7 = this.options.fs;
        return assert(fs7.dirname, "`fs.dirname` is required for relative reference"), fs7.dirname(path4);
      }
      lookupError(file, roots) {
        let err2 = new Error("ENOENT");
        return err2.message = `ENOENT: Failed to lookup "${file}" in "${roots}"`, err2.code = "ENOENT", err2;
      }
    }, Parser = class {
      constructor(liquid) {
        this.liquid = liquid, this.cache = this.liquid.options.cache, this.fs = this.liquid.options.fs, this.parseFile = this.cache ? this._parseFileCached : this._parseFile, this.loader = new Loader(this.liquid.options);
      }
      parse(html, filepath) {
        let tokens = new Tokenizer(html, this.liquid.options.operators, filepath).readTopLevelTokens(this.liquid.options);
        return this.parseTokens(tokens);
      }
      parseTokens(tokens) {
        let token, templates2 = [];
        for (; token = tokens.shift(); )
          templates2.push(this.parseToken(token, tokens));
        return templates2;
      }
      parseToken(token, remainTokens) {
        try {
          if (isTagToken(token)) {
            let TagClass = this.liquid.tags[token.name];
            return assert(TagClass, `tag "${token.name}" not found`), new TagClass(token, remainTokens, this.liquid);
          }
          return isOutputToken(token) ? new Output(token, this.liquid) : new HTML(token);
        } catch (e) {
          throw LiquidError.is(e) ? e : new ParseError(e, token);
        }
      }
      parseStream(tokens) {
        return new ParseStream(tokens, (token, tokens2) => this.parseToken(token, tokens2));
      }
      *_parseFileCached(file, sync, type = LookupType.Root, currentFile) {
        let cache2 = this.cache, key = this.loader.shouldLoadRelative(file) ? currentFile + "," + file : type + ":" + file, tpls = yield cache2.read(key);
        if (tpls)
          return tpls;
        let task = this._parseFile(file, sync, type, currentFile), taskOrTpl = sync ? yield task : toPromise(task);
        cache2.write(key, taskOrTpl);
        try {
          return yield taskOrTpl;
        } catch (err2) {
          throw cache2.remove(key), err2;
        }
      }
      *_parseFile(file, sync, type = LookupType.Root, currentFile) {
        let filepath = yield this.loader.lookup(file, type, sync, currentFile);
        return this.liquid.parse(sync ? this.fs.readFileSync(filepath) : yield this.fs.readFile(filepath), filepath);
      }
    };
    (function(TokenKind) {
      TokenKind[TokenKind.Number = 1] = "Number", TokenKind[TokenKind.Literal = 2] = "Literal", TokenKind[TokenKind.Tag = 4] = "Tag", TokenKind[TokenKind.Output = 8] = "Output", TokenKind[TokenKind.HTML = 16] = "HTML", TokenKind[TokenKind.Filter = 32] = "Filter", TokenKind[TokenKind.Hash = 64] = "Hash", TokenKind[TokenKind.PropertyAccess = 128] = "PropertyAccess", TokenKind[TokenKind.Word = 256] = "Word", TokenKind[TokenKind.Range = 512] = "Range", TokenKind[TokenKind.Quoted = 1024] = "Quoted", TokenKind[TokenKind.Operator = 2048] = "Operator", TokenKind[TokenKind.FilteredValue = 4096] = "FilteredValue", TokenKind[TokenKind.Delimited = 12] = "Delimited";
    })(exports.TokenKind || (exports.TokenKind = {}));
    function isDelimitedToken(val) {
      return !!(getKind(val) & exports.TokenKind.Delimited);
    }
    function isOperatorToken(val) {
      return getKind(val) === exports.TokenKind.Operator;
    }
    function isHTMLToken(val) {
      return getKind(val) === exports.TokenKind.HTML;
    }
    function isOutputToken(val) {
      return getKind(val) === exports.TokenKind.Output;
    }
    function isTagToken(val) {
      return getKind(val) === exports.TokenKind.Tag;
    }
    function isQuotedToken(val) {
      return getKind(val) === exports.TokenKind.Quoted;
    }
    function isLiteralToken(val) {
      return getKind(val) === exports.TokenKind.Literal;
    }
    function isNumberToken(val) {
      return getKind(val) === exports.TokenKind.Number;
    }
    function isPropertyAccessToken(val) {
      return getKind(val) === exports.TokenKind.PropertyAccess;
    }
    function isWordToken(val) {
      return getKind(val) === exports.TokenKind.Word;
    }
    function isRangeToken(val) {
      return getKind(val) === exports.TokenKind.Range;
    }
    function getKind(val) {
      return val ? val.kind : -1;
    }
    var typeGuards = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      isDelimitedToken,
      isOperatorToken,
      isHTMLToken,
      isOutputToken,
      isTagToken,
      isQuotedToken,
      isLiteralToken,
      isNumberToken,
      isPropertyAccessToken,
      isWordToken,
      isRangeToken
    }), __assign = function() {
      return __assign = Object.assign || function(t7) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
          s = arguments[i];
          for (var p in s)
            Object.prototype.hasOwnProperty.call(s, p) && (t7[p] = s[p]);
        }
        return t7;
      }, __assign.apply(this, arguments);
    }, Context = class {
      constructor(env = {}, opts = defaultOptions, renderOptions = {}) {
        this.scopes = [{}], this.registers = {}, this.sync = !!renderOptions.sync, this.opts = opts, this.globals = renderOptions.globals ?? opts.globals, this.environments = env, this.strictVariables = renderOptions.strictVariables ?? this.opts.strictVariables, this.ownPropertyOnly = renderOptions.ownPropertyOnly ?? opts.ownPropertyOnly;
      }
      getRegister(key) {
        return this.registers[key] = this.registers[key] || {};
      }
      setRegister(key, value) {
        return this.registers[key] = value;
      }
      saveRegister(...keys) {
        return keys.map((key) => [key, this.getRegister(key)]);
      }
      restoreRegister(keyValues) {
        return keyValues.forEach(([key, value]) => this.setRegister(key, value));
      }
      getAll() {
        return [this.globals, this.environments, ...this.scopes].reduce((ctx, val) => __assign(ctx, val), {});
      }
      /**
       * @deprecated use `_get()` or `getSync()` instead
       */
      get(paths) {
        return this.getSync(paths);
      }
      getSync(paths) {
        return toValueSync(this._get(paths));
      }
      *_get(paths) {
        let scope = this.findScope(paths[0]);
        return yield this._getFromScope(scope, paths);
      }
      /**
       * @deprecated use `_get()` instead
       */
      getFromScope(scope, paths) {
        return toValueSync(this._getFromScope(scope, paths));
      }
      *_getFromScope(scope, paths, strictVariables = this.strictVariables) {
        isString2(paths) && (paths = paths.split("."));
        for (let i = 0; i < paths.length; i++)
          if (scope = yield readProperty(scope, paths[i], this.ownPropertyOnly), strictVariables && isUndefined(scope))
            throw new InternalUndefinedVariableError(paths.slice(0, i + 1).join("."));
        return scope;
      }
      push(ctx) {
        return this.scopes.push(ctx);
      }
      pop() {
        return this.scopes.pop();
      }
      bottom() {
        return this.scopes[0];
      }
      findScope(key) {
        for (let i = this.scopes.length - 1; i >= 0; i--) {
          let candidate = this.scopes[i];
          if (key in candidate)
            return candidate;
        }
        return key in this.environments ? this.environments : this.globals;
      }
    };
    function readProperty(obj, key, ownPropertyOnly) {
      if (obj = toLiquid(obj), isNil(obj))
        return obj;
      if (isArray(obj) && key < 0)
        return obj[obj.length + +key];
      let value = readJSProperty(obj, key, ownPropertyOnly);
      return value === void 0 && obj instanceof Drop ? obj.liquidMethodMissing(key) : isFunction(value) ? value.call(obj) : key === "size" ? readSize(obj) : key === "first" ? readFirst(obj) : key === "last" ? readLast(obj) : value;
    }
    function readJSProperty(obj, key, ownPropertyOnly) {
      if (!(ownPropertyOnly && !Object.hasOwnProperty.call(obj, key) && !(obj instanceof Drop)))
        return obj[key];
    }
    function readFirst(obj) {
      return isArray(obj) ? obj[0] : obj.first;
    }
    function readLast(obj) {
      return isArray(obj) ? obj[obj.length - 1] : obj.last;
    }
    function readSize(obj) {
      if (obj.hasOwnProperty("size") || obj.size !== void 0)
        return obj.size;
      if (isArray(obj) || isString2(obj))
        return obj.length;
      if (typeof obj == "object")
        return Object.keys(obj).length;
    }
    var BlockMode;
    (function(BlockMode2) {
      BlockMode2[BlockMode2.OUTPUT = 0] = "OUTPUT", BlockMode2[BlockMode2.STORE = 1] = "STORE";
    })(BlockMode || (BlockMode = {}));
    var abs = argumentsToValue(Math.abs), at_least = argumentsToValue(Math.max), at_most = argumentsToValue(Math.min), ceil = argumentsToValue(Math.ceil), divided_by = argumentsToValue((dividend, divisor, integerArithmetic = !1) => integerArithmetic ? Math.floor(dividend / divisor) : dividend / divisor), floor = argumentsToValue(Math.floor), minus = argumentsToValue((v, arg) => v - arg), modulo = argumentsToValue((v, arg) => v % arg), times = argumentsToValue((v, arg) => v * arg);
    function round(v, arg = 0) {
      v = toValue(v), arg = toValue(arg);
      let amp = Math.pow(10, arg);
      return Math.round(v * amp) / amp;
    }
    function plus(v, arg) {
      return v = toValue(v), arg = toValue(arg), Number(v) + Number(arg);
    }
    var mathFilters = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      abs,
      at_least,
      at_most,
      ceil,
      divided_by,
      floor,
      minus,
      modulo,
      times,
      round,
      plus
    }), url_decode = (x) => stringify(x).split("+").map(decodeURIComponent).join(" "), url_encode = (x) => stringify(x).split(" ").map(encodeURIComponent).join("+"), urlFilters = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      url_decode,
      url_encode
    }), join6 = argumentsToValue((v, arg) => toArray(v).join(arg === void 0 ? " " : arg)), last$1 = argumentsToValue((v) => isArray(v) ? last(v) : ""), first = argumentsToValue((v) => isArray(v) ? v[0] : ""), reverse = argumentsToValue((v) => [...toArray(v)].reverse());
    function* sort2(arr, property) {
      let values = [];
      for (let item of toArray(toValue(arr)))
        values.push([
          item,
          property ? yield this.context._getFromScope(item, stringify(property).split("."), !1) : item
        ]);
      return values.sort((lhs, rhs) => {
        let lvalue = lhs[1], rvalue = rhs[1];
        return lvalue < rvalue ? -1 : lvalue > rvalue ? 1 : 0;
      }).map((tuple) => tuple[0]);
    }
    function sort_natural(input, property) {
      input = toValue(input);
      let propertyString = stringify(property), compare2 = property === void 0 ? caseInsensitiveCompare : (lhs, rhs) => caseInsensitiveCompare(lhs[propertyString], rhs[propertyString]);
      return [...toArray(input)].sort(compare2);
    }
    var size = (v) => v && v.length || 0;
    function* map(arr, property) {
      let results = [];
      for (let item of toArray(toValue(arr)))
        results.push(yield this.context._getFromScope(item, stringify(property), !1));
      return results;
    }
    function compact2(arr) {
      return arr = toValue(arr), toArray(arr).filter((x) => !isNil(toValue(x)));
    }
    function concat(v, arg = []) {
      return v = toValue(v), arg = toArray(arg).map((v2) => toValue(v2)), toArray(v).concat(arg);
    }
    function push2(v, arg) {
      return concat(v, [arg]);
    }
    function slice(v, begin, length = 1) {
      return v = toValue(v), isNil(v) ? [] : (isArray(v) || (v = stringify(v)), begin = begin < 0 ? v.length + begin : begin, v.slice(begin, begin + length));
    }
    function* where(arr, property, expected) {
      let values = [];
      arr = toArray(toValue(arr));
      for (let item of arr)
        values.push(yield this.context._getFromScope(item, stringify(property).split("."), !1));
      return arr.filter((_2, i) => expected === void 0 ? isTruthy2(values[i], this.context) : isComparable(expected) ? expected.equals(values[i]) : values[i] === expected);
    }
    function uniq2(arr) {
      arr = toValue(arr);
      let u = {};
      return (arr || []).filter((val) => hasOwnProperty.call(u, String(val)) ? !1 : (u[String(val)] = !0, !0));
    }
    function sample(v, count = 1) {
      if (v = toValue(v), isNil(v))
        return [];
      isArray(v) || (v = stringify(v));
      let shuffled = [...v].sort(() => Math.random() - 0.5);
      return count === 1 ? shuffled[0] : shuffled.slice(0, count);
    }
    var arrayFilters = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      join: join6,
      last: last$1,
      first,
      reverse,
      sort: sort2,
      sort_natural,
      size,
      map,
      compact: compact2,
      concat,
      push: push2,
      slice,
      where,
      uniq: uniq2,
      sample
    });
    function date(v, format5, timezoneOffset) {
      let opts = this.context.opts, date2;
      return v = toValue(v), format5 = toValue(format5), isNil(format5) ? format5 = opts.dateFormat : format5 = stringify(format5), v === "now" || v === "today" ? date2 = /* @__PURE__ */ new Date() : isNumber2(v) ? date2 = new Date(v * 1e3) : isString2(v) ? /^\d+$/.test(v) ? date2 = new Date(+v * 1e3) : opts.preserveTimezones ? date2 = TimezoneDate.createDateFixedToTimezone(v) : date2 = new Date(v) : date2 = v, isValidDate(date2) ? (timezoneOffset !== void 0 ? date2 = new TimezoneDate(date2, parseTimezoneOffset(date2, timezoneOffset)) : !(date2 instanceof TimezoneDate) && opts.timezoneOffset !== void 0 && (date2 = new TimezoneDate(date2, parseTimezoneOffset(date2, opts.timezoneOffset))), strftime(date2, format5)) : v;
    }
    function isValidDate(date2) {
      return (date2 instanceof Date || date2 instanceof TimezoneDate) && !isNaN(date2.getTime());
    }
    function parseTimezoneOffset(date2, timeZone) {
      if (isNumber2(timeZone))
        return timeZone;
      let utcDate = new Date(date2.toLocaleString("en-US", { timeZone: "UTC" })), tzDate = new Date(date2.toLocaleString("en-US", { timeZone }));
      return (utcDate.getTime() - tzDate.getTime()) / 6e4;
    }
    var dateFilters = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      date
    });
    function append(v, arg) {
      return assert(arguments.length === 2, "append expect 2 arguments"), stringify(v) + stringify(arg);
    }
    function prepend(v, arg) {
      return assert(arguments.length === 2, "prepend expect 2 arguments"), stringify(arg) + stringify(v);
    }
    function lstrip(v, chars) {
      return chars ? (chars = escapeRegExp(stringify(chars)), stringify(v).replace(new RegExp(`^[${chars}]+`, "g"), "")) : stringify(v).replace(/^\s+/, "");
    }
    function downcase(v) {
      return stringify(v).toLowerCase();
    }
    function upcase(str) {
      return stringify(str).toUpperCase();
    }
    function remove2(v, arg) {
      return stringify(v).split(String(arg)).join("");
    }
    function remove_first(v, l) {
      return stringify(v).replace(String(l), "");
    }
    function remove_last(v, l) {
      let str = stringify(v), pattern = String(l), index = str.lastIndexOf(pattern);
      return index === -1 ? str : str.substring(0, index) + str.substring(index + pattern.length);
    }
    function rstrip(str, chars) {
      return chars ? (chars = escapeRegExp(stringify(chars)), stringify(str).replace(new RegExp(`[${chars}]+$`, "g"), "")) : stringify(str).replace(/\s+$/, "");
    }
    function split(v, arg) {
      let arr = stringify(v).split(String(arg));
      for (; arr.length && arr[arr.length - 1] === ""; )
        arr.pop();
      return arr;
    }
    function strip(v, chars) {
      return chars ? (chars = escapeRegExp(stringify(chars)), stringify(v).replace(new RegExp(`^[${chars}]+`, "g"), "").replace(new RegExp(`[${chars}]+$`, "g"), "")) : stringify(v).trim();
    }
    function strip_newlines(v) {
      return stringify(v).replace(/\r?\n/gm, "");
    }
    function capitalize2(str) {
      return str = stringify(str), str.charAt(0).toUpperCase() + str.slice(1).toLowerCase();
    }
    function replace(v, pattern, replacement) {
      return stringify(v).split(String(pattern)).join(replacement);
    }
    function replace_first(v, arg1, arg2) {
      return stringify(v).replace(String(arg1), arg2);
    }
    function replace_last(v, arg1, arg2) {
      let str = stringify(v), pattern = String(arg1), index = str.lastIndexOf(pattern);
      if (index === -1)
        return str;
      let replacement = String(arg2);
      return str.substring(0, index) + replacement + str.substring(index + pattern.length);
    }
    function truncate(v, l = 50, o = "...") {
      return v = stringify(v), v.length <= l ? v : v.substring(0, l - o.length) + o;
    }
    function truncatewords(v, words = 15, o = "...") {
      let arr = stringify(v).split(/\s+/);
      words <= 0 && (words = 1);
      let ret = arr.slice(0, words).join(" ");
      return arr.length >= words && (ret += o), ret;
    }
    var stringFilters = /* @__PURE__ */ Object.freeze({
      __proto__: null,
      append,
      prepend,
      lstrip,
      downcase,
      upcase,
      remove: remove2,
      remove_first,
      remove_last,
      rstrip,
      split,
      strip,
      strip_newlines,
      capitalize: capitalize2,
      replace,
      replace_first,
      replace_last,
      truncate,
      truncatewords
    }), filters = {
      ...htmlFilters,
      ...mathFilters,
      ...urlFilters,
      ...arrayFilters,
      ...dateFilters,
      ...stringFilters,
      json,
      raw,
      default: Default
    }, AssignTag = class extends Tag {
      constructor(token, remainTokens, liquid) {
        super(token, remainTokens, liquid), this.key = this.tokenizer.readIdentifier().content, this.tokenizer.assert(this.key, "expected variable name"), this.tokenizer.skipBlank(), this.tokenizer.assert(this.tokenizer.peek() === "=", 'expected "="'), this.tokenizer.advance(), this.value = new Value(this.tokenizer.readFilteredValue(), this.liquid);
      }
      *render(ctx) {
        ctx.bottom()[this.key] = yield this.value.value(ctx, this.liquid.options.lenientIf);
      }
    }, MODIFIERS = ["offset", "limit", "reversed"], ForTag = class extends Tag {
      constructor(token, remainTokens, liquid) {
        super(token, remainTokens, liquid);
        let variable = this.tokenizer.readIdentifier(), inStr = this.tokenizer.readIdentifier(), collection = this.tokenizer.readValue();
        if (!variable.size() || inStr.content !== "in" || !collection)
          throw new Error(`illegal tag: ${token.getText()}`);
        this.variable = variable.content, this.collection = collection, this.hash = new Hash(this.tokenizer.remaining()), this.templates = [], this.elseTemplates = [];
        let p, stream3 = this.liquid.parser.parseStream(remainTokens).on("start", () => p = this.templates).on("tag:else", () => p = this.elseTemplates).on("tag:endfor", () => stream3.stop()).on("template", (tpl) => p.push(tpl)).on("end", () => {
          throw new Error(`tag ${token.getText()} not closed`);
        });
        stream3.start();
      }
      *render(ctx, emitter) {
        let r2 = this.liquid.renderer, collection = toEnumerable(yield evalToken(this.collection, ctx));
        if (!collection.length) {
          yield r2.renderTemplates(this.elseTemplates, ctx, emitter);
          return;
        }
        let continueKey = "continue-" + this.variable + "-" + this.collection.getText();
        ctx.push({ continue: ctx.getRegister(continueKey) });
        let hash = yield this.hash.render(ctx);
        ctx.pop(), collection = (this.liquid.options.orderedFilterParameters ? Object.keys(hash).filter((x) => MODIFIERS.includes(x)) : MODIFIERS.filter((x) => hash[x] !== void 0)).reduce((collection2, modifier) => modifier === "offset" ? offset(collection2, hash.offset) : modifier === "limit" ? limit(collection2, hash.limit) : reversed(collection2), collection), ctx.setRegister(continueKey, (hash.offset || 0) + collection.length);
        let scope = { forloop: new ForloopDrop(collection.length, this.collection.getText(), this.variable) };
        ctx.push(scope);
        for (let item of collection) {
          if (scope[this.variable] = item, yield r2.renderTemplates(this.templates, ctx, emitter), emitter.break) {
            emitter.break = !1;
            break;
          }
          emitter.continue = !1, scope.forloop.next();
        }
        ctx.pop();
      }
    };
    function reversed(arr) {
      return [...arr].reverse();
    }
    function offset(arr, count) {
      return arr.slice(count);
    }
    function limit(arr, count) {
      return arr.slice(0, count);
    }
    var CaptureTag = class extends Tag {
      constructor(tagToken, remainTokens, liquid) {
        for (super(tagToken, remainTokens, liquid), this.templates = [], this.variable = this.readVariableName(); remainTokens.length; ) {
          let token = remainTokens.shift();
          if (isTagToken(token) && token.name === "endcapture")
            return;
          this.templates.push(liquid.parser.parseToken(token, remainTokens));
        }
        throw new Error(`tag ${tagToken.getText()} not closed`);
      }
      *render(ctx) {
        let html = yield this.liquid.renderer.renderTemplates(this.templates, ctx);
        ctx.bottom()[this.variable] = html;
      }
      readVariableName() {
        let word = this.tokenizer.readIdentifier().content;
        if (word)
          return word;
        let quoted = this.tokenizer.readQuoted();
        if (quoted)
          return evalQuotedToken(quoted);
        throw this.tokenizer.error("invalid capture name");
      }
    }, CaseTag = class extends Tag {
      constructor(tagToken, remainTokens, liquid) {
        super(tagToken, remainTokens, liquid), this.branches = [], this.elseTemplates = [], this.value = new Value(this.tokenizer.readFilteredValue(), this.liquid), this.elseTemplates = [];
        let p = [], stream3 = this.liquid.parser.parseStream(remainTokens).on("tag:when", (token) => {
          p = [];
          let values = [];
          for (; !token.tokenizer.end(); )
            values.push(token.tokenizer.readValueOrThrow()), token.tokenizer.skipBlank(), token.tokenizer.peek() === "," ? token.tokenizer.readTo(",") : token.tokenizer.readTo("or");
          this.branches.push({
            values,
            templates: p
          });
        }).on("tag:else", () => p = this.elseTemplates).on("tag:endcase", () => stream3.stop()).on("template", (tpl) => p.push(tpl)).on("end", () => {
          throw new Error(`tag ${tagToken.getText()} not closed`);
        });
        stream3.start();
      }
      *render(ctx, emitter) {
        let r2 = this.liquid.renderer, target = toValue(yield this.value.value(ctx, ctx.opts.lenientIf)), branchHit = !1;
        for (let branch of this.branches)
          for (let valueToken of branch.values) {
            let value = yield evalToken(valueToken, ctx, ctx.opts.lenientIf);
            if (target === value) {
              yield r2.renderTemplates(branch.templates, ctx, emitter), branchHit = !0;
              break;
            }
          }
        branchHit || (yield r2.renderTemplates(this.elseTemplates, ctx, emitter));
      }
    }, CommentTag = class extends Tag {
      constructor(tagToken, remainTokens, liquid) {
        for (super(tagToken, remainTokens, liquid); remainTokens.length; ) {
          let token = remainTokens.shift();
          if (isTagToken(token) && token.name === "endcomment")
            return;
        }
        throw new Error(`tag ${tagToken.getText()} not closed`);
      }
      render() {
      }
    }, RenderTag = class extends Tag {
      constructor(token, remainTokens, liquid) {
        super(token, remainTokens, liquid);
        let tokenizer = this.tokenizer;
        for (this.file = parseFilePath(tokenizer, this.liquid), this.currentFile = token.file; !tokenizer.end(); ) {
          tokenizer.skipBlank();
          let begin = tokenizer.p, keyword = tokenizer.readIdentifier();
          if ((keyword.content === "with" || keyword.content === "for") && (tokenizer.skipBlank(), tokenizer.peek() !== ":")) {
            let value = tokenizer.readValue();
            if (value) {
              let beforeAs = tokenizer.p, asStr = tokenizer.readIdentifier(), alias;
              asStr.content === "as" ? alias = tokenizer.readIdentifier() : tokenizer.p = beforeAs, this[keyword.content] = { value, alias: alias && alias.content }, tokenizer.skipBlank(), tokenizer.peek() === "," && tokenizer.advance();
              continue;
            }
          }
          tokenizer.p = begin;
          break;
        }
        this.hash = new Hash(tokenizer.remaining());
      }
      *render(ctx, emitter) {
        let { liquid, hash } = this, filepath = yield renderFilePath(this.file, ctx, liquid);
        assert(filepath, () => `illegal file path "${filepath}"`);
        let childCtx = new Context({}, ctx.opts, { sync: ctx.sync, globals: ctx.globals, strictVariables: ctx.strictVariables }), scope = childCtx.bottom();
        if (__assign(scope, yield hash.render(ctx)), this.with) {
          let { value, alias } = this.with;
          scope[alias || filepath] = yield evalToken(value, ctx);
        }
        if (this.for) {
          let { value, alias } = this.for, collection = toEnumerable(yield evalToken(value, ctx));
          scope.forloop = new ForloopDrop(collection.length, value.getText(), alias);
          for (let item of collection) {
            scope[alias] = item;
            let templates2 = yield liquid._parsePartialFile(filepath, childCtx.sync, this.currentFile);
            yield liquid.renderer.renderTemplates(templates2, childCtx, emitter), scope.forloop.next();
          }
        } else {
          let templates2 = yield liquid._parsePartialFile(filepath, childCtx.sync, this.currentFile);
          yield liquid.renderer.renderTemplates(templates2, childCtx, emitter);
        }
      }
    };
    function parseFilePath(tokenizer, liquid) {
      if (liquid.options.dynamicPartials) {
        let file = tokenizer.readValue();
        if (tokenizer.assert(file, "illegal file path"), file.getText() === "none")
          return;
        if (isQuotedToken(file)) {
          let templates3 = liquid.parse(evalQuotedToken(file));
          return optimize(templates3);
        }
        return file;
      }
      let tokens = [...tokenizer.readFileNameTemplate(liquid.options)], templates2 = optimize(liquid.parser.parseTokens(tokens));
      return templates2 === "none" ? void 0 : templates2;
    }
    function optimize(templates2) {
      return templates2.length === 1 && isHTMLToken(templates2[0].token) ? templates2[0].token.getContent() : templates2;
    }
    function* renderFilePath(file, ctx, liquid) {
      return typeof file == "string" ? file : Array.isArray(file) ? liquid.renderer.renderTemplates(file, ctx) : yield evalToken(file, ctx);
    }
    var IncludeTag = class extends Tag {
      constructor(token, remainTokens, liquid) {
        super(token, remainTokens, liquid);
        let { tokenizer } = token;
        this.file = parseFilePath(tokenizer, this.liquid), this.currentFile = token.file;
        let begin = tokenizer.p;
        tokenizer.readIdentifier().content === "with" ? (tokenizer.skipBlank(), tokenizer.peek() !== ":" ? this.withVar = tokenizer.readValue() : tokenizer.p = begin) : tokenizer.p = begin, this.hash = new Hash(tokenizer.remaining(), this.liquid.options.jekyllInclude);
      }
      *render(ctx, emitter) {
        let { liquid, hash, withVar } = this, { renderer } = liquid, filepath = yield renderFilePath(this.file, ctx, liquid);
        assert(filepath, () => `illegal file path "${filepath}"`);
        let saved = ctx.saveRegister("blocks", "blockMode");
        ctx.setRegister("blocks", {}), ctx.setRegister("blockMode", BlockMode.OUTPUT);
        let scope = yield hash.render(ctx);
        withVar && (scope[filepath] = yield evalToken(withVar, ctx));
        let templates2 = yield liquid._parsePartialFile(filepath, ctx.sync, this.currentFile);
        ctx.push(ctx.opts.jekyllInclude ? { include: scope } : scope), yield renderer.renderTemplates(templates2, ctx, emitter), ctx.pop(), ctx.restoreRegister(saved);
      }
    }, DecrementTag = class extends Tag {
      constructor(token, remainTokens, liquid) {
        super(token, remainTokens, liquid), this.variable = this.tokenizer.readIdentifier().content;
      }
      render(context, emitter) {
        let scope = context.environments;
        isNumber2(scope[this.variable]) || (scope[this.variable] = 0), emitter.write(stringify(--scope[this.variable]));
      }
    }, CycleTag = class extends Tag {
      constructor(token, remainTokens, liquid) {
        super(token, remainTokens, liquid), this.candidates = [];
        let group = this.tokenizer.readValue();
        for (this.tokenizer.skipBlank(), group && (this.tokenizer.peek() === ":" ? (this.group = group, this.tokenizer.advance()) : this.candidates.push(group)); !this.tokenizer.end(); ) {
          let value = this.tokenizer.readValue();
          value && this.candidates.push(value), this.tokenizer.readTo(",");
        }
        this.tokenizer.assert(this.candidates.length, () => `empty candidates: "${token.getText()}"`);
      }
      *render(ctx, emitter) {
        let fingerprint = `cycle:${yield evalToken(this.group, ctx)}:` + this.candidates.join(","), groups = ctx.getRegister("cycle"), idx = groups[fingerprint];
        idx === void 0 && (idx = groups[fingerprint] = 0);
        let candidate = this.candidates[idx];
        return idx = (idx + 1) % this.candidates.length, groups[fingerprint] = idx, yield evalToken(candidate, ctx);
      }
    }, IfTag = class extends Tag {
      constructor(tagToken, remainTokens, liquid) {
        super(tagToken, remainTokens, liquid), this.branches = [], this.elseTemplates = [];
        let p;
        liquid.parser.parseStream(remainTokens).on("start", () => this.branches.push({
          value: new Value(tagToken.args, this.liquid),
          templates: p = []
        })).on("tag:elsif", (token) => this.branches.push({
          value: new Value(token.args, this.liquid),
          templates: p = []
        })).on("tag:else", () => p = this.elseTemplates).on("tag:endif", function() {
          this.stop();
        }).on("template", (tpl) => p.push(tpl)).on("end", () => {
          throw new Error(`tag ${tagToken.getText()} not closed`);
        }).start();
      }
      *render(ctx, emitter) {
        let r2 = this.liquid.renderer;
        for (let { value, templates: templates2 } of this.branches) {
          let v = yield value.value(ctx, ctx.opts.lenientIf);
          if (isTruthy2(v, ctx)) {
            yield r2.renderTemplates(templates2, ctx, emitter);
            return;
          }
        }
        yield r2.renderTemplates(this.elseTemplates, ctx, emitter);
      }
    }, IncrementTag = class extends Tag {
      constructor(token, remainTokens, liquid) {
        super(token, remainTokens, liquid), this.variable = this.tokenizer.readIdentifier().content;
      }
      render(context, emitter) {
        let scope = context.environments;
        isNumber2(scope[this.variable]) || (scope[this.variable] = 0);
        let val = scope[this.variable];
        scope[this.variable]++, emitter.write(stringify(val));
      }
    }, LayoutTag = class extends Tag {
      constructor(token, remainTokens, liquid) {
        super(token, remainTokens, liquid), this.file = parseFilePath(this.tokenizer, this.liquid), this.currentFile = token.file, this.args = new Hash(this.tokenizer.remaining()), this.templates = this.liquid.parser.parseTokens(remainTokens);
      }
      *render(ctx, emitter) {
        let { liquid, args, file } = this, { renderer } = liquid;
        if (file === void 0) {
          ctx.setRegister("blockMode", BlockMode.OUTPUT), yield renderer.renderTemplates(this.templates, ctx, emitter);
          return;
        }
        let filepath = yield renderFilePath(this.file, ctx, liquid);
        assert(filepath, () => `illegal file path "${filepath}"`);
        let templates2 = yield liquid._parseLayoutFile(filepath, ctx.sync, this.currentFile);
        ctx.setRegister("blockMode", BlockMode.STORE);
        let html = yield renderer.renderTemplates(this.templates, ctx), blocks2 = ctx.getRegister("blocks");
        blocks2[""] === void 0 && (blocks2[""] = (parent, emitter2) => emitter2.write(html)), ctx.setRegister("blockMode", BlockMode.OUTPUT), ctx.push(yield args.render(ctx)), yield renderer.renderTemplates(templates2, ctx, emitter), ctx.pop();
      }
    }, BlockTag = class extends Tag {
      constructor(token, remainTokens, liquid) {
        super(token, remainTokens, liquid), this.templates = [];
        let match2 = /\w+/.exec(token.args);
        for (this.block = match2 ? match2[0] : ""; remainTokens.length; ) {
          let token2 = remainTokens.shift();
          if (isTagToken(token2) && token2.name === "endblock")
            return;
          let template2 = liquid.parser.parseToken(token2, remainTokens);
          this.templates.push(template2);
        }
        throw new Error(`tag ${token.getText()} not closed`);
      }
      *render(ctx, emitter) {
        let blockRender = this.getBlockRender(ctx);
        ctx.getRegister("blockMode") === BlockMode.STORE ? ctx.getRegister("blocks")[this.block] = blockRender : yield blockRender(new BlockDrop(), emitter);
      }
      getBlockRender(ctx) {
        let { liquid, templates: templates2 } = this, renderChild = ctx.getRegister("blocks")[this.block], renderCurrent = function* (superBlock, emitter) {
          ctx.push({ block: superBlock }), yield liquid.renderer.renderTemplates(templates2, ctx, emitter), ctx.pop();
        };
        return renderChild ? (superBlock, emitter) => renderChild(new BlockDrop(() => renderCurrent(superBlock, emitter)), emitter) : renderCurrent;
      }
    }, RawTag = class extends Tag {
      constructor(tagToken, remainTokens, liquid) {
        for (super(tagToken, remainTokens, liquid), this.tokens = []; remainTokens.length; ) {
          let token = remainTokens.shift();
          if (isTagToken(token) && token.name === "endraw")
            return;
          this.tokens.push(token);
        }
        throw new Error(`tag ${tagToken.getText()} not closed`);
      }
      render() {
        return this.tokens.map((token) => token.getText()).join("");
      }
    }, TablerowloopDrop = class extends ForloopDrop {
      constructor(length, cols, collection, variable) {
        super(length, collection, variable), this.length = length, this.cols = cols;
      }
      row() {
        return Math.floor(this.i / this.cols) + 1;
      }
      col0() {
        return this.i % this.cols;
      }
      col() {
        return this.col0() + 1;
      }
      col_first() {
        return this.col0() === 0;
      }
      col_last() {
        return this.col() === this.cols;
      }
    }, TablerowTag = class extends Tag {
      constructor(tagToken, remainTokens, liquid) {
        super(tagToken, remainTokens, liquid);
        let variable = this.tokenizer.readIdentifier();
        this.tokenizer.skipBlank();
        let predicate = this.tokenizer.readIdentifier(), collectionToken = this.tokenizer.readValue();
        if (predicate.content !== "in" || !collectionToken)
          throw new Error(`illegal tag: ${tagToken.getText()}`);
        this.variable = variable.content, this.collection = collectionToken, this.args = new Hash(this.tokenizer.remaining()), this.templates = [];
        let p, stream3 = this.liquid.parser.parseStream(remainTokens).on("start", () => p = this.templates).on("tag:endtablerow", () => stream3.stop()).on("template", (tpl) => p.push(tpl)).on("end", () => {
          throw new Error(`tag ${tagToken.getText()} not closed`);
        });
        stream3.start();
      }
      *render(ctx, emitter) {
        let collection = toEnumerable(yield evalToken(this.collection, ctx)), args = yield this.args.render(ctx), offset2 = args.offset || 0, limit2 = args.limit === void 0 ? collection.length : args.limit;
        collection = collection.slice(offset2, offset2 + limit2);
        let cols = args.cols || collection.length, r2 = this.liquid.renderer, tablerowloop = new TablerowloopDrop(collection.length, cols, this.collection.getText(), this.variable), scope = { tablerowloop };
        ctx.push(scope);
        for (let idx = 0; idx < collection.length; idx++, tablerowloop.next())
          scope[this.variable] = collection[idx], tablerowloop.col0() === 0 && (tablerowloop.row() !== 1 && emitter.write("</tr>"), emitter.write(`<tr class="row${tablerowloop.row()}">`)), emitter.write(`<td class="col${tablerowloop.col()}">`), yield r2.renderTemplates(this.templates, ctx, emitter), emitter.write("</td>");
        collection.length && emitter.write("</tr>"), ctx.pop();
      }
    }, UnlessTag = class extends Tag {
      constructor(tagToken, remainTokens, liquid) {
        super(tagToken, remainTokens, liquid), this.branches = [], this.elseTemplates = [];
        let p;
        this.liquid.parser.parseStream(remainTokens).on("start", () => this.branches.push({
          value: new Value(tagToken.args, this.liquid),
          test: isFalsy,
          templates: p = []
        })).on("tag:elsif", (token) => this.branches.push({
          value: new Value(token.args, this.liquid),
          test: isTruthy2,
          templates: p = []
        })).on("tag:else", () => p = this.elseTemplates).on("tag:endunless", function() {
          this.stop();
        }).on("template", (tpl) => p.push(tpl)).on("end", () => {
          throw new Error(`tag ${tagToken.getText()} not closed`);
        }).start();
      }
      *render(ctx, emitter) {
        let r2 = this.liquid.renderer;
        for (let { value, test, templates: templates2 } of this.branches) {
          let v = yield value.value(ctx, ctx.opts.lenientIf);
          if (test(v, ctx)) {
            yield r2.renderTemplates(templates2, ctx, emitter);
            return;
          }
        }
        yield r2.renderTemplates(this.elseTemplates, ctx, emitter);
      }
    }, BreakTag = class extends Tag {
      render(ctx, emitter) {
        emitter.break = !0;
      }
    }, ContinueTag = class extends Tag {
      render(ctx, emitter) {
        emitter.continue = !0;
      }
    }, EchoTag = class extends Tag {
      constructor(token, remainTokens, liquid) {
        super(token, remainTokens, liquid), this.tokenizer.skipBlank(), this.tokenizer.end() || (this.value = new Value(this.tokenizer.readFilteredValue(), this.liquid));
      }
      *render(ctx, emitter) {
        if (!this.value)
          return;
        let val = yield this.value.value(ctx, !1);
        emitter.write(val);
      }
    }, LiquidTag = class extends Tag {
      constructor(token, remainTokens, liquid) {
        super(token, remainTokens, liquid);
        let tokens = this.tokenizer.readLiquidTagTokens(this.liquid.options);
        this.templates = this.liquid.parser.parseTokens(tokens);
      }
      *render(ctx, emitter) {
        yield this.liquid.renderer.renderTemplates(this.templates, ctx, emitter);
      }
    }, InlineCommentTag = class extends Tag {
      constructor(tagToken, remainTokens, liquid) {
        if (super(tagToken, remainTokens, liquid), tagToken.args.search(/\n\s*[^#\s]/g) !== -1)
          throw new Error("every line of an inline comment must start with a '#' character");
      }
      render() {
      }
    }, tags = {
      assign: AssignTag,
      for: ForTag,
      capture: CaptureTag,
      case: CaseTag,
      comment: CommentTag,
      include: IncludeTag,
      render: RenderTag,
      decrement: DecrementTag,
      increment: IncrementTag,
      cycle: CycleTag,
      if: IfTag,
      layout: LayoutTag,
      block: BlockTag,
      raw: RawTag,
      tablerow: TablerowTag,
      unless: UnlessTag,
      break: BreakTag,
      continue: ContinueTag,
      echo: EchoTag,
      liquid: LiquidTag,
      "#": InlineCommentTag
    }, Liquid2 = class _Liquid {
      constructor(opts = {}) {
        this.renderer = new Render(), this.filters = {}, this.tags = {}, this.options = normalize(opts), this.parser = new Parser(this), forOwn(tags, (conf, name) => this.registerTag(name, conf)), forOwn(filters, (handler, name) => this.registerFilter(name, handler));
      }
      parse(html, filepath) {
        return this.parser.parse(html, filepath);
      }
      _render(tpl, scope, renderOptions) {
        let ctx = scope instanceof Context ? scope : new Context(scope, this.options, renderOptions);
        return this.renderer.renderTemplates(tpl, ctx);
      }
      async render(tpl, scope, renderOptions) {
        return toPromise(this._render(tpl, scope, { ...renderOptions, sync: !1 }));
      }
      renderSync(tpl, scope, renderOptions) {
        return toValueSync(this._render(tpl, scope, { ...renderOptions, sync: !0 }));
      }
      renderToNodeStream(tpl, scope, renderOptions = {}) {
        let ctx = new Context(scope, this.options, renderOptions);
        return this.renderer.renderTemplatesToNodeStream(tpl, ctx);
      }
      _parseAndRender(html, scope, renderOptions) {
        let tpl = this.parse(html);
        return this._render(tpl, scope, renderOptions);
      }
      async parseAndRender(html, scope, renderOptions) {
        return toPromise(this._parseAndRender(html, scope, { ...renderOptions, sync: !1 }));
      }
      parseAndRenderSync(html, scope, renderOptions) {
        return toValueSync(this._parseAndRender(html, scope, { ...renderOptions, sync: !0 }));
      }
      _parsePartialFile(file, sync, currentFile) {
        return this.parser.parseFile(file, sync, LookupType.Partials, currentFile);
      }
      _parseLayoutFile(file, sync, currentFile) {
        return this.parser.parseFile(file, sync, LookupType.Layouts, currentFile);
      }
      _parseFile(file, sync, lookupType, currentFile) {
        return this.parser.parseFile(file, sync, lookupType, currentFile);
      }
      async parseFile(file, lookupType) {
        return toPromise(this.parser.parseFile(file, !1, lookupType));
      }
      parseFileSync(file, lookupType) {
        return toValueSync(this.parser.parseFile(file, !0, lookupType));
      }
      *_renderFile(file, ctx, renderFileOptions) {
        let templates2 = yield this._parseFile(file, renderFileOptions.sync, renderFileOptions.lookupType);
        return yield this._render(templates2, ctx, renderFileOptions);
      }
      async renderFile(file, ctx, renderFileOptions) {
        return toPromise(this._renderFile(file, ctx, { ...renderFileOptions, sync: !1 }));
      }
      renderFileSync(file, ctx, renderFileOptions) {
        return toValueSync(this._renderFile(file, ctx, { ...renderFileOptions, sync: !0 }));
      }
      async renderFileToNodeStream(file, scope, renderOptions) {
        let templates2 = await this.parseFile(file);
        return this.renderToNodeStream(templates2, scope, renderOptions);
      }
      _evalValue(str, scope) {
        let value = new Value(str, this), ctx = scope instanceof Context ? scope : new Context(scope, this.options);
        return value.value(ctx);
      }
      async evalValue(str, scope) {
        return toPromise(this._evalValue(str, scope));
      }
      evalValueSync(str, scope) {
        return toValueSync(this._evalValue(str, scope));
      }
      registerFilter(name, filter) {
        this.filters[name] = filter;
      }
      registerTag(name, tag) {
        this.tags[name] = isFunction(tag) ? tag : createTagClass(tag);
      }
      plugin(plugin) {
        return plugin.call(this, _Liquid);
      }
      express() {
        let self2 = this, firstCall = !0;
        return function(filePath, ctx, callback) {
          if (firstCall) {
            firstCall = !1;
            let dirs = normalizeDirectoryList(this.root);
            self2.options.root.unshift(...dirs), self2.options.layouts.unshift(...dirs), self2.options.partials.unshift(...dirs);
          }
          self2.renderFile(filePath, ctx).then((html) => callback(null, html), callback);
        };
      }
    }, version2 = "10.9.1";
    exports.AssertionError = AssertionError;
    exports.AssignTag = AssignTag;
    exports.BlockTag = BlockTag;
    exports.BreakTag = BreakTag;
    exports.CaptureTag = CaptureTag;
    exports.CaseTag = CaseTag;
    exports.CommentTag = CommentTag;
    exports.Context = Context;
    exports.ContinueTag = ContinueTag;
    exports.CycleTag = CycleTag;
    exports.DecrementTag = DecrementTag;
    exports.Drop = Drop;
    exports.EchoTag = EchoTag;
    exports.Expression = Expression;
    exports.Filter = Filter2;
    exports.ForTag = ForTag;
    exports.Hash = Hash;
    exports.IfTag = IfTag;
    exports.IncludeTag = IncludeTag;
    exports.IncrementTag = IncrementTag;
    exports.InlineCommentTag = InlineCommentTag;
    exports.LayoutTag = LayoutTag;
    exports.Liquid = Liquid2;
    exports.LiquidError = LiquidError;
    exports.LiquidTag = LiquidTag;
    exports.Output = Output;
    exports.ParseError = ParseError;
    exports.ParseStream = ParseStream;
    exports.RawTag = RawTag;
    exports.RenderError = RenderError;
    exports.RenderTag = RenderTag;
    exports.TablerowTag = TablerowTag;
    exports.Tag = Tag;
    exports.TagToken = TagToken;
    exports.TimezoneDate = TimezoneDate;
    exports.Token = Token;
    exports.TokenizationError = TokenizationError;
    exports.Tokenizer = Tokenizer;
    exports.TypeGuards = typeGuards;
    exports.UndefinedVariableError = UndefinedVariableError;
    exports.UnlessTag = UnlessTag;
    exports.Value = Value;
    exports.assert = assert;
    exports.createTrie = createTrie;
    exports.defaultOperators = defaultOperators;
    exports.defaultOptions = defaultOptions;
    exports.evalQuotedToken = evalQuotedToken;
    exports.evalToken = evalToken;
    exports.filters = filters;
    exports.isFalsy = isFalsy;
    exports.isTruthy = isTruthy2;
    exports.tags = tags;
    exports.toPromise = toPromise;
    exports.toValue = toValue;
    exports.toValueSync = toValueSync;
    exports.version = version2;
  }
});

// ../../node_modules/.pnpm/react-dom@18.2.0_react@18.2.0/node_modules/react-dom/cjs/react-dom-server-legacy.node.production.min.js
var require_react_dom_server_legacy_node_production_min = __commonJS({
  "../../node_modules/.pnpm/react-dom@18.2.0_react@18.2.0/node_modules/react-dom/cjs/react-dom-server-legacy.node.production.min.js"(exports) {
    "use strict";
    init_cjs_shims();
    var ea = require_react(), fa = __require("stream"), n = Object.prototype.hasOwnProperty, ha = /^[:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD][:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\-.0-9\u00B7\u0300-\u036F\u203F-\u2040]*$/, ia = {}, ja = {};
    function ka(a) {
      return n.call(ja, a) ? !0 : n.call(ia, a) ? !1 : ha.test(a) ? ja[a] = !0 : (ia[a] = !0, !1);
    }
    function q(a, b, c, d, f, e, g) {
      this.acceptsBooleans = b === 2 || b === 3 || b === 4, this.attributeName = d, this.attributeNamespace = f, this.mustUseProperty = c, this.propertyName = a, this.type = b, this.sanitizeURL = e, this.removeEmptyString = g;
    }
    var r2 = {};
    "children dangerouslySetInnerHTML defaultValue defaultChecked innerHTML suppressContentEditableWarning suppressHydrationWarning style".split(" ").forEach(function(a) {
      r2[a] = new q(a, 0, !1, a, null, !1, !1);
    });
    [["acceptCharset", "accept-charset"], ["className", "class"], ["htmlFor", "for"], ["httpEquiv", "http-equiv"]].forEach(function(a) {
      var b = a[0];
      r2[b] = new q(b, 1, !1, a[1], null, !1, !1);
    });
    ["contentEditable", "draggable", "spellCheck", "value"].forEach(function(a) {
      r2[a] = new q(a, 2, !1, a.toLowerCase(), null, !1, !1);
    });
    ["autoReverse", "externalResourcesRequired", "focusable", "preserveAlpha"].forEach(function(a) {
      r2[a] = new q(a, 2, !1, a, null, !1, !1);
    });
    "allowFullScreen async autoFocus autoPlay controls default defer disabled disablePictureInPicture disableRemotePlayback formNoValidate hidden loop noModule noValidate open playsInline readOnly required reversed scoped seamless itemScope".split(" ").forEach(function(a) {
      r2[a] = new q(a, 3, !1, a.toLowerCase(), null, !1, !1);
    });
    ["checked", "multiple", "muted", "selected"].forEach(function(a) {
      r2[a] = new q(a, 3, !0, a, null, !1, !1);
    });
    ["capture", "download"].forEach(function(a) {
      r2[a] = new q(a, 4, !1, a, null, !1, !1);
    });
    ["cols", "rows", "size", "span"].forEach(function(a) {
      r2[a] = new q(a, 6, !1, a, null, !1, !1);
    });
    ["rowSpan", "start"].forEach(function(a) {
      r2[a] = new q(a, 5, !1, a.toLowerCase(), null, !1, !1);
    });
    var la = /[\-:]([a-z])/g;
    function ma(a) {
      return a[1].toUpperCase();
    }
    "accent-height alignment-baseline arabic-form baseline-shift cap-height clip-path clip-rule color-interpolation color-interpolation-filters color-profile color-rendering dominant-baseline enable-background fill-opacity fill-rule flood-color flood-opacity font-family font-size font-size-adjust font-stretch font-style font-variant font-weight glyph-name glyph-orientation-horizontal glyph-orientation-vertical horiz-adv-x horiz-origin-x image-rendering letter-spacing lighting-color marker-end marker-mid marker-start overline-position overline-thickness paint-order panose-1 pointer-events rendering-intent shape-rendering stop-color stop-opacity strikethrough-position strikethrough-thickness stroke-dasharray stroke-dashoffset stroke-linecap stroke-linejoin stroke-miterlimit stroke-opacity stroke-width text-anchor text-decoration text-rendering underline-position underline-thickness unicode-bidi unicode-range units-per-em v-alphabetic v-hanging v-ideographic v-mathematical vector-effect vert-adv-y vert-origin-x vert-origin-y word-spacing writing-mode xmlns:xlink x-height".split(" ").forEach(function(a) {
      var b = a.replace(
        la,
        ma
      );
      r2[b] = new q(b, 1, !1, a, null, !1, !1);
    });
    "xlink:actuate xlink:arcrole xlink:role xlink:show xlink:title xlink:type".split(" ").forEach(function(a) {
      var b = a.replace(la, ma);
      r2[b] = new q(b, 1, !1, a, "http://www.w3.org/1999/xlink", !1, !1);
    });
    ["xml:base", "xml:lang", "xml:space"].forEach(function(a) {
      var b = a.replace(la, ma);
      r2[b] = new q(b, 1, !1, a, "http://www.w3.org/XML/1998/namespace", !1, !1);
    });
    ["tabIndex", "crossOrigin"].forEach(function(a) {
      r2[a] = new q(a, 1, !1, a.toLowerCase(), null, !1, !1);
    });
    r2.xlinkHref = new q("xlinkHref", 1, !1, "xlink:href", "http://www.w3.org/1999/xlink", !0, !1);
    ["src", "href", "action", "formAction"].forEach(function(a) {
      r2[a] = new q(a, 1, !1, a.toLowerCase(), null, !0, !0);
    });
    var t7 = {
      animationIterationCount: !0,
      aspectRatio: !0,
      borderImageOutset: !0,
      borderImageSlice: !0,
      borderImageWidth: !0,
      boxFlex: !0,
      boxFlexGroup: !0,
      boxOrdinalGroup: !0,
      columnCount: !0,
      columns: !0,
      flex: !0,
      flexGrow: !0,
      flexPositive: !0,
      flexShrink: !0,
      flexNegative: !0,
      flexOrder: !0,
      gridArea: !0,
      gridRow: !0,
      gridRowEnd: !0,
      gridRowSpan: !0,
      gridRowStart: !0,
      gridColumn: !0,
      gridColumnEnd: !0,
      gridColumnSpan: !0,
      gridColumnStart: !0,
      fontWeight: !0,
      lineClamp: !0,
      lineHeight: !0,
      opacity: !0,
      order: !0,
      orphans: !0,
      tabSize: !0,
      widows: !0,
      zIndex: !0,
      zoom: !0,
      fillOpacity: !0,
      floodOpacity: !0,
      stopOpacity: !0,
      strokeDasharray: !0,
      strokeDashoffset: !0,
      strokeMiterlimit: !0,
      strokeOpacity: !0,
      strokeWidth: !0
    }, na = ["Webkit", "ms", "Moz", "O"];
    Object.keys(t7).forEach(function(a) {
      na.forEach(function(b) {
        b = b + a.charAt(0).toUpperCase() + a.substring(1), t7[b] = t7[a];
      });
    });
    var oa = /["'&<>]/;
    function u(a) {
      if (typeof a == "boolean" || typeof a == "number")
        return "" + a;
      a = "" + a;
      var b = oa.exec(a);
      if (b) {
        var c = "", d, f = 0;
        for (d = b.index; d < a.length; d++) {
          switch (a.charCodeAt(d)) {
            case 34:
              b = "&quot;";
              break;
            case 38:
              b = "&amp;";
              break;
            case 39:
              b = "&#x27;";
              break;
            case 60:
              b = "&lt;";
              break;
            case 62:
              b = "&gt;";
              break;
            default:
              continue;
          }
          f !== d && (c += a.substring(f, d)), f = d + 1, c += b;
        }
        a = f !== d ? c + a.substring(f, d) : c;
      }
      return a;
    }
    var pa = /([A-Z])/g, qa = /^ms-/, ra = Array.isArray;
    function v(a, b) {
      return { insertionMode: a, selectedValue: b };
    }
    function sa(a, b, c) {
      switch (b) {
        case "select":
          return v(1, c.value != null ? c.value : c.defaultValue);
        case "svg":
          return v(2, null);
        case "math":
          return v(3, null);
        case "foreignObject":
          return v(1, null);
        case "table":
          return v(4, null);
        case "thead":
        case "tbody":
        case "tfoot":
          return v(5, null);
        case "colgroup":
          return v(7, null);
        case "tr":
          return v(6, null);
      }
      return 4 <= a.insertionMode || a.insertionMode === 0 ? v(1, null) : a;
    }
    var ta = /* @__PURE__ */ new Map();
    function ua(a, b, c) {
      if (typeof c != "object")
        throw Error("The `style` prop expects a mapping from style properties to values, not a string. For example, style={{marginRight: spacing + 'em'}} when using JSX.");
      b = !0;
      for (var d in c)
        if (n.call(c, d)) {
          var f = c[d];
          if (f != null && typeof f != "boolean" && f !== "") {
            if (d.indexOf("--") === 0) {
              var e = u(d);
              f = u(("" + f).trim());
            } else {
              e = d;
              var g = ta.get(e);
              g !== void 0 || (g = u(e.replace(pa, "-$1").toLowerCase().replace(qa, "-ms-")), ta.set(e, g)), e = g, f = typeof f == "number" ? f === 0 || n.call(
                t7,
                d
              ) ? "" + f : f + "px" : u(("" + f).trim());
            }
            b ? (b = !1, a.push(' style="', e, ":", f)) : a.push(";", e, ":", f);
          }
        }
      b || a.push('"');
    }
    function w(a, b, c, d) {
      switch (c) {
        case "style":
          ua(a, b, d);
          return;
        case "defaultValue":
        case "defaultChecked":
        case "innerHTML":
        case "suppressContentEditableWarning":
        case "suppressHydrationWarning":
          return;
      }
      if (!(2 < c.length) || c[0] !== "o" && c[0] !== "O" || c[1] !== "n" && c[1] !== "N") {
        if (b = r2.hasOwnProperty(c) ? r2[c] : null, b !== null) {
          switch (typeof d) {
            case "function":
            case "symbol":
              return;
            case "boolean":
              if (!b.acceptsBooleans)
                return;
          }
          switch (c = b.attributeName, b.type) {
            case 3:
              d && a.push(" ", c, '=""');
              break;
            case 4:
              d === !0 ? a.push(" ", c, '=""') : d !== !1 && a.push(" ", c, '="', u(d), '"');
              break;
            case 5:
              isNaN(d) || a.push(" ", c, '="', u(d), '"');
              break;
            case 6:
              !isNaN(d) && 1 <= d && a.push(" ", c, '="', u(d), '"');
              break;
            default:
              b.sanitizeURL && (d = "" + d), a.push(" ", c, '="', u(d), '"');
          }
        } else if (ka(c)) {
          switch (typeof d) {
            case "function":
            case "symbol":
              return;
            case "boolean":
              if (b = c.toLowerCase().slice(0, 5), b !== "data-" && b !== "aria-")
                return;
          }
          a.push(" ", c, '="', u(d), '"');
        }
      }
    }
    function x(a, b, c) {
      if (b != null) {
        if (c != null)
          throw Error("Can only set one of `children` or `props.dangerouslySetInnerHTML`.");
        if (typeof b != "object" || !("__html" in b))
          throw Error("`props.dangerouslySetInnerHTML` must be in the form `{__html: ...}`. Please visit https://reactjs.org/link/dangerously-set-inner-html for more information.");
        b = b.__html, b != null && a.push("" + b);
      }
    }
    function va(a) {
      var b = "";
      return ea.Children.forEach(a, function(a2) {
        a2 != null && (b += a2);
      }), b;
    }
    function wa(a, b, c, d) {
      a.push(z2(c));
      var f = c = null, e;
      for (e in b)
        if (n.call(b, e)) {
          var g = b[e];
          if (g != null)
            switch (e) {
              case "children":
                c = g;
                break;
              case "dangerouslySetInnerHTML":
                f = g;
                break;
              default:
                w(a, d, e, g);
            }
        }
      return a.push(">"), x(a, f, c), typeof c == "string" ? (a.push(u(c)), null) : c;
    }
    var xa = /^[a-zA-Z][a-zA-Z:_\.\-\d]*$/, ya = /* @__PURE__ */ new Map();
    function z2(a) {
      var b = ya.get(a);
      if (b === void 0) {
        if (!xa.test(a))
          throw Error("Invalid tag: " + a);
        b = "<" + a, ya.set(a, b);
      }
      return b;
    }
    function za(a, b, c, d, f) {
      switch (b) {
        case "select":
          a.push(z2("select"));
          var e = null, g = null;
          for (l in c)
            if (n.call(c, l)) {
              var h = c[l];
              if (h != null)
                switch (l) {
                  case "children":
                    e = h;
                    break;
                  case "dangerouslySetInnerHTML":
                    g = h;
                    break;
                  case "defaultValue":
                  case "value":
                    break;
                  default:
                    w(a, d, l, h);
                }
            }
          return a.push(">"), x(a, g, e), e;
        case "option":
          g = f.selectedValue, a.push(z2("option"));
          var k = h = null, m = null, l = null;
          for (e in c)
            if (n.call(c, e)) {
              var p = c[e];
              if (p != null)
                switch (e) {
                  case "children":
                    h = p;
                    break;
                  case "selected":
                    m = p;
                    break;
                  case "dangerouslySetInnerHTML":
                    l = p;
                    break;
                  case "value":
                    k = p;
                  default:
                    w(a, d, e, p);
                }
            }
          if (g != null)
            if (c = k !== null ? "" + k : va(h), ra(g)) {
              for (d = 0; d < g.length; d++)
                if ("" + g[d] === c) {
                  a.push(' selected=""');
                  break;
                }
            } else
              "" + g === c && a.push(' selected=""');
          else
            m && a.push(' selected=""');
          return a.push(">"), x(a, l, h), h;
        case "textarea":
          a.push(z2("textarea")), l = g = e = null;
          for (h in c)
            if (n.call(c, h) && (k = c[h], k != null))
              switch (h) {
                case "children":
                  l = k;
                  break;
                case "value":
                  e = k;
                  break;
                case "defaultValue":
                  g = k;
                  break;
                case "dangerouslySetInnerHTML":
                  throw Error("`dangerouslySetInnerHTML` does not make sense on <textarea>.");
                default:
                  w(a, d, h, k);
              }
          if (e === null && g !== null && (e = g), a.push(">"), l != null) {
            if (e != null)
              throw Error("If you supply `defaultValue` on a <textarea>, do not pass children.");
            if (ra(l) && 1 < l.length)
              throw Error("<textarea> can only have at most one child.");
            e = "" + l;
          }
          return typeof e == "string" && e[0] === `
` && a.push(`
`), e !== null && a.push(u("" + e)), null;
        case "input":
          a.push(z2("input")), k = l = h = e = null;
          for (g in c)
            if (n.call(c, g) && (m = c[g], m != null))
              switch (g) {
                case "children":
                case "dangerouslySetInnerHTML":
                  throw Error("input is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");
                case "defaultChecked":
                  k = m;
                  break;
                case "defaultValue":
                  h = m;
                  break;
                case "checked":
                  l = m;
                  break;
                case "value":
                  e = m;
                  break;
                default:
                  w(a, d, g, m);
              }
          return l !== null ? w(a, d, "checked", l) : k !== null && w(a, d, "checked", k), e !== null ? w(a, d, "value", e) : h !== null && w(a, d, "value", h), a.push("/>"), null;
        case "menuitem":
          a.push(z2("menuitem"));
          for (var B in c)
            if (n.call(c, B) && (e = c[B], e != null))
              switch (B) {
                case "children":
                case "dangerouslySetInnerHTML":
                  throw Error("menuitems cannot have `children` nor `dangerouslySetInnerHTML`.");
                default:
                  w(
                    a,
                    d,
                    B,
                    e
                  );
              }
          return a.push(">"), null;
        case "title":
          a.push(z2("title")), e = null;
          for (p in c)
            if (n.call(c, p) && (g = c[p], g != null))
              switch (p) {
                case "children":
                  e = g;
                  break;
                case "dangerouslySetInnerHTML":
                  throw Error("`dangerouslySetInnerHTML` does not make sense on <title>.");
                default:
                  w(a, d, p, g);
              }
          return a.push(">"), e;
        case "listing":
        case "pre":
          a.push(z2(b)), g = e = null;
          for (k in c)
            if (n.call(c, k) && (h = c[k], h != null))
              switch (k) {
                case "children":
                  e = h;
                  break;
                case "dangerouslySetInnerHTML":
                  g = h;
                  break;
                default:
                  w(a, d, k, h);
              }
          if (a.push(">"), g != null) {
            if (e != null)
              throw Error("Can only set one of `children` or `props.dangerouslySetInnerHTML`.");
            if (typeof g != "object" || !("__html" in g))
              throw Error("`props.dangerouslySetInnerHTML` must be in the form `{__html: ...}`. Please visit https://reactjs.org/link/dangerously-set-inner-html for more information.");
            c = g.__html, c != null && (typeof c == "string" && 0 < c.length && c[0] === `
` ? a.push(`
`, c) : a.push("" + c));
          }
          return typeof e == "string" && e[0] === `
` && a.push(`
`), e;
        case "area":
        case "base":
        case "br":
        case "col":
        case "embed":
        case "hr":
        case "img":
        case "keygen":
        case "link":
        case "meta":
        case "param":
        case "source":
        case "track":
        case "wbr":
          a.push(z2(b));
          for (var C in c)
            if (n.call(c, C) && (e = c[C], e != null))
              switch (C) {
                case "children":
                case "dangerouslySetInnerHTML":
                  throw Error(b + " is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");
                default:
                  w(a, d, C, e);
              }
          return a.push("/>"), null;
        case "annotation-xml":
        case "color-profile":
        case "font-face":
        case "font-face-src":
        case "font-face-uri":
        case "font-face-format":
        case "font-face-name":
        case "missing-glyph":
          return wa(a, c, b, d);
        case "html":
          return f.insertionMode === 0 && a.push("<!DOCTYPE html>"), wa(a, c, b, d);
        default:
          if (b.indexOf("-") === -1 && typeof c.is != "string")
            return wa(a, c, b, d);
          a.push(z2(b)), g = e = null;
          for (m in c)
            if (n.call(c, m) && (h = c[m], h != null))
              switch (m) {
                case "children":
                  e = h;
                  break;
                case "dangerouslySetInnerHTML":
                  g = h;
                  break;
                case "style":
                  ua(a, d, h);
                  break;
                case "suppressContentEditableWarning":
                case "suppressHydrationWarning":
                  break;
                default:
                  ka(m) && typeof h != "function" && typeof h != "symbol" && a.push(" ", m, '="', u(h), '"');
              }
          return a.push(">"), x(a, g, e), e;
      }
    }
    function Aa(a, b, c) {
      if (a.push('<!--$?--><template id="'), c === null)
        throw Error("An ID must have been assigned before we can complete the boundary.");
      return a.push(c), a.push('"></template>');
    }
    function Ba(a, b, c, d) {
      switch (c.insertionMode) {
        case 0:
        case 1:
          return a.push('<div hidden id="'), a.push(b.segmentPrefix), b = d.toString(16), a.push(b), a.push('">');
        case 2:
          return a.push('<svg aria-hidden="true" style="display:none" id="'), a.push(b.segmentPrefix), b = d.toString(16), a.push(b), a.push('">');
        case 3:
          return a.push('<math aria-hidden="true" style="display:none" id="'), a.push(b.segmentPrefix), b = d.toString(16), a.push(b), a.push('">');
        case 4:
          return a.push('<table hidden id="'), a.push(b.segmentPrefix), b = d.toString(16), a.push(b), a.push('">');
        case 5:
          return a.push('<table hidden><tbody id="'), a.push(b.segmentPrefix), b = d.toString(16), a.push(b), a.push('">');
        case 6:
          return a.push('<table hidden><tr id="'), a.push(b.segmentPrefix), b = d.toString(16), a.push(b), a.push('">');
        case 7:
          return a.push('<table hidden><colgroup id="'), a.push(b.segmentPrefix), b = d.toString(16), a.push(b), a.push('">');
        default:
          throw Error("Unknown insertion mode. This is a bug in React.");
      }
    }
    function Ca(a, b) {
      switch (b.insertionMode) {
        case 0:
        case 1:
          return a.push("</div>");
        case 2:
          return a.push("</svg>");
        case 3:
          return a.push("</math>");
        case 4:
          return a.push("</table>");
        case 5:
          return a.push("</tbody></table>");
        case 6:
          return a.push("</tr></table>");
        case 7:
          return a.push("</colgroup></table>");
        default:
          throw Error("Unknown insertion mode. This is a bug in React.");
      }
    }
    var Da = /[<\u2028\u2029]/g;
    function Ea(a) {
      return JSON.stringify(a).replace(Da, function(a2) {
        switch (a2) {
          case "<":
            return "\\u003c";
          case "\u2028":
            return "\\u2028";
          case "\u2029":
            return "\\u2029";
          default:
            throw Error("escapeJSStringsForInstructionScripts encountered a match it does not know how to replace. this means the match regex and the replacement characters are no longer in sync. This is a bug in React");
        }
      });
    }
    function Fa(a, b) {
      return b = b === void 0 ? "" : b, { bootstrapChunks: [], startInlineScript: "<script>", placeholderPrefix: b + "P:", segmentPrefix: b + "S:", boundaryPrefix: b + "B:", idPrefix: b, nextSuspenseID: 0, sentCompleteSegmentFunction: !1, sentCompleteBoundaryFunction: !1, sentClientRenderFunction: !1, generateStaticMarkup: a };
    }
    function Ga() {
      return { insertionMode: 1, selectedValue: null };
    }
    function Ha(a, b, c, d) {
      return c.generateStaticMarkup ? (a.push(u(b)), !1) : (b === "" ? a = d : (d && a.push("<!-- -->"), a.push(u(b)), a = !0), a);
    }
    var A = Object.assign, Ia = Symbol.for("react.element"), Ja = Symbol.for("react.portal"), Ka = Symbol.for("react.fragment"), La = Symbol.for("react.strict_mode"), Ma = Symbol.for("react.profiler"), Na = Symbol.for("react.provider"), Oa = Symbol.for("react.context"), Pa = Symbol.for("react.forward_ref"), Qa = Symbol.for("react.suspense"), Ra = Symbol.for("react.suspense_list"), Sa = Symbol.for("react.memo"), Ta = Symbol.for("react.lazy"), Ua = Symbol.for("react.scope"), Va = Symbol.for("react.debug_trace_mode"), Wa = Symbol.for("react.legacy_hidden"), Xa = Symbol.for("react.default_value"), Ya = Symbol.iterator;
    function Za(a) {
      if (a == null)
        return null;
      if (typeof a == "function")
        return a.displayName || a.name || null;
      if (typeof a == "string")
        return a;
      switch (a) {
        case Ka:
          return "Fragment";
        case Ja:
          return "Portal";
        case Ma:
          return "Profiler";
        case La:
          return "StrictMode";
        case Qa:
          return "Suspense";
        case Ra:
          return "SuspenseList";
      }
      if (typeof a == "object")
        switch (a.$$typeof) {
          case Oa:
            return (a.displayName || "Context") + ".Consumer";
          case Na:
            return (a._context.displayName || "Context") + ".Provider";
          case Pa:
            var b = a.render;
            return a = a.displayName, a || (a = b.displayName || b.name || "", a = a !== "" ? "ForwardRef(" + a + ")" : "ForwardRef"), a;
          case Sa:
            return b = a.displayName || null, b !== null ? b : Za(a.type) || "Memo";
          case Ta:
            b = a._payload, a = a._init;
            try {
              return Za(a(b));
            } catch {
            }
        }
      return null;
    }
    var $a = {};
    function ab(a, b) {
      if (a = a.contextTypes, !a)
        return $a;
      var c = {}, d;
      for (d in a)
        c[d] = b[d];
      return c;
    }
    var D = null;
    function E(a, b) {
      if (a !== b) {
        a.context._currentValue2 = a.parentValue, a = a.parent;
        var c = b.parent;
        if (a === null) {
          if (c !== null)
            throw Error("The stacks must reach the root at the same time. This is a bug in React.");
        } else {
          if (c === null)
            throw Error("The stacks must reach the root at the same time. This is a bug in React.");
          E(a, c);
        }
        b.context._currentValue2 = b.value;
      }
    }
    function bb(a) {
      a.context._currentValue2 = a.parentValue, a = a.parent, a !== null && bb(a);
    }
    function cb(a) {
      var b = a.parent;
      b !== null && cb(b), a.context._currentValue2 = a.value;
    }
    function db(a, b) {
      if (a.context._currentValue2 = a.parentValue, a = a.parent, a === null)
        throw Error("The depth must equal at least at zero before reaching the root. This is a bug in React.");
      a.depth === b.depth ? E(a, b) : db(a, b);
    }
    function eb(a, b) {
      var c = b.parent;
      if (c === null)
        throw Error("The depth must equal at least at zero before reaching the root. This is a bug in React.");
      a.depth === c.depth ? E(a, c) : eb(a, c), b.context._currentValue2 = b.value;
    }
    function F(a) {
      var b = D;
      b !== a && (b === null ? cb(a) : a === null ? bb(b) : b.depth === a.depth ? E(b, a) : b.depth > a.depth ? db(b, a) : eb(b, a), D = a);
    }
    var fb = { isMounted: function() {
      return !1;
    }, enqueueSetState: function(a, b) {
      a = a._reactInternals, a.queue !== null && a.queue.push(b);
    }, enqueueReplaceState: function(a, b) {
      a = a._reactInternals, a.replace = !0, a.queue = [b];
    }, enqueueForceUpdate: function() {
    } };
    function gb(a, b, c, d) {
      var f = a.state !== void 0 ? a.state : null;
      a.updater = fb, a.props = c, a.state = f;
      var e = { queue: [], replace: !1 };
      a._reactInternals = e;
      var g = b.contextType;
      if (a.context = typeof g == "object" && g !== null ? g._currentValue2 : d, g = b.getDerivedStateFromProps, typeof g == "function" && (g = g(c, f), f = g == null ? f : A({}, f, g), a.state = f), typeof b.getDerivedStateFromProps != "function" && typeof a.getSnapshotBeforeUpdate != "function" && (typeof a.UNSAFE_componentWillMount == "function" || typeof a.componentWillMount == "function"))
        if (b = a.state, typeof a.componentWillMount == "function" && a.componentWillMount(), typeof a.UNSAFE_componentWillMount == "function" && a.UNSAFE_componentWillMount(), b !== a.state && fb.enqueueReplaceState(a, a.state, null), e.queue !== null && 0 < e.queue.length)
          if (b = e.queue, g = e.replace, e.queue = null, e.replace = !1, g && b.length === 1)
            a.state = b[0];
          else {
            for (e = g ? b[0] : a.state, f = !0, g = g ? 1 : 0; g < b.length; g++) {
              var h = b[g];
              h = typeof h == "function" ? h.call(a, e, c, d) : h, h != null && (f ? (f = !1, e = A({}, e, h)) : A(e, h));
            }
            a.state = e;
          }
        else
          e.queue = null;
    }
    var hb = { id: 1, overflow: "" };
    function ib(a, b, c) {
      var d = a.id;
      a = a.overflow;
      var f = 32 - G(d) - 1;
      d &= ~(1 << f), c += 1;
      var e = 32 - G(b) + f;
      if (30 < e) {
        var g = f - f % 5;
        return e = (d & (1 << g) - 1).toString(32), d >>= g, f -= g, { id: 1 << 32 - G(b) + f | c << f | d, overflow: e + a };
      }
      return { id: 1 << e | c << f | d, overflow: a };
    }
    var G = Math.clz32 ? Math.clz32 : jb, kb = Math.log, lb = Math.LN2;
    function jb(a) {
      return a >>>= 0, a === 0 ? 32 : 31 - (kb(a) / lb | 0) | 0;
    }
    function mb(a, b) {
      return a === b && (a !== 0 || 1 / a === 1 / b) || a !== a && b !== b;
    }
    var nb = typeof Object.is == "function" ? Object.is : mb, H = null, ob = null, I = null, J = null, K = !1, L = !1, M = 0, N = null, O = 0;
    function P() {
      if (H === null)
        throw Error(`Invalid hook call. Hooks can only be called inside of the body of a function component. This could happen for one of the following reasons:
1. You might have mismatching versions of React and the renderer (such as React DOM)
2. You might be breaking the Rules of Hooks
3. You might have more than one copy of React in the same app
See https://reactjs.org/link/invalid-hook-call for tips about how to debug and fix this problem.`);
      return H;
    }
    function rb() {
      if (0 < O)
        throw Error("Rendered more hooks than during the previous render");
      return { memoizedState: null, queue: null, next: null };
    }
    function sb() {
      return J === null ? I === null ? (K = !1, I = J = rb()) : (K = !0, J = I) : J.next === null ? (K = !1, J = J.next = rb()) : (K = !0, J = J.next), J;
    }
    function tb() {
      ob = H = null, L = !1, I = null, O = 0, J = N = null;
    }
    function ub(a, b) {
      return typeof b == "function" ? b(a) : b;
    }
    function vb(a, b, c) {
      if (H = P(), J = sb(), K) {
        var d = J.queue;
        if (b = d.dispatch, N !== null && (c = N.get(d), c !== void 0)) {
          N.delete(d), d = J.memoizedState;
          do
            d = a(d, c.action), c = c.next;
          while (c !== null);
          return J.memoizedState = d, [d, b];
        }
        return [J.memoizedState, b];
      }
      return a = a === ub ? typeof b == "function" ? b() : b : c !== void 0 ? c(b) : b, J.memoizedState = a, a = J.queue = { last: null, dispatch: null }, a = a.dispatch = wb.bind(null, H, a), [J.memoizedState, a];
    }
    function xb(a, b) {
      if (H = P(), J = sb(), b = b === void 0 ? null : b, J !== null) {
        var c = J.memoizedState;
        if (c !== null && b !== null) {
          var d = c[1];
          a:
            if (d === null)
              d = !1;
            else {
              for (var f = 0; f < d.length && f < b.length; f++)
                if (!nb(b[f], d[f])) {
                  d = !1;
                  break a;
                }
              d = !0;
            }
          if (d)
            return c[0];
        }
      }
      return a = a(), J.memoizedState = [a, b], a;
    }
    function wb(a, b, c) {
      if (25 <= O)
        throw Error("Too many re-renders. React limits the number of renders to prevent an infinite loop.");
      if (a === H)
        if (L = !0, a = { action: c, next: null }, N === null && (N = /* @__PURE__ */ new Map()), c = N.get(b), c === void 0)
          N.set(b, a);
        else {
          for (b = c; b.next !== null; )
            b = b.next;
          b.next = a;
        }
    }
    function yb() {
      throw Error("startTransition cannot be called during server rendering.");
    }
    function Q() {
    }
    var zb = { readContext: function(a) {
      return a._currentValue2;
    }, useContext: function(a) {
      return P(), a._currentValue2;
    }, useMemo: xb, useReducer: vb, useRef: function(a) {
      H = P(), J = sb();
      var b = J.memoizedState;
      return b === null ? (a = { current: a }, J.memoizedState = a) : b;
    }, useState: function(a) {
      return vb(ub, a);
    }, useInsertionEffect: Q, useLayoutEffect: function() {
    }, useCallback: function(a, b) {
      return xb(function() {
        return a;
      }, b);
    }, useImperativeHandle: Q, useEffect: Q, useDebugValue: Q, useDeferredValue: function(a) {
      return P(), a;
    }, useTransition: function() {
      return P(), [!1, yb];
    }, useId: function() {
      var a = ob.treeContext, b = a.overflow;
      a = a.id, a = (a & ~(1 << 32 - G(a) - 1)).toString(32) + b;
      var c = R;
      if (c === null)
        throw Error("Invalid hook call. Hooks can only be called inside of the body of a function component.");
      return b = M++, a = ":" + c.idPrefix + "R" + a, 0 < b && (a += "H" + b.toString(32)), a + ":";
    }, useMutableSource: function(a, b) {
      return P(), b(a._source);
    }, useSyncExternalStore: function(a, b, c) {
      if (c === void 0)
        throw Error("Missing getServerSnapshot, which is required for server-rendered content. Will revert to client rendering.");
      return c();
    } }, R = null, Ab = ea.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentDispatcher;
    function Bb(a) {
      return console.error(a), null;
    }
    function S() {
    }
    function Cb(a, b, c, d, f, e, g, h, k) {
      var m = [], l = /* @__PURE__ */ new Set();
      return b = { destination: null, responseState: b, progressiveChunkSize: d === void 0 ? 12800 : d, status: 0, fatalError: null, nextSegmentId: 0, allPendingTasks: 0, pendingRootTasks: 0, completedRootSegment: null, abortableTasks: l, pingedTasks: m, clientRenderedBoundaries: [], completedBoundaries: [], partialBoundaries: [], onError: f === void 0 ? Bb : f, onAllReady: e === void 0 ? S : e, onShellReady: g === void 0 ? S : g, onShellError: h === void 0 ? S : h, onFatalError: k === void 0 ? S : k }, c = T(b, 0, null, c, !1, !1), c.parentFlushed = !0, a = Db(b, a, null, c, l, $a, null, hb), m.push(a), b;
    }
    function Db(a, b, c, d, f, e, g, h) {
      a.allPendingTasks++, c === null ? a.pendingRootTasks++ : c.pendingTasks++;
      var k = { node: b, ping: function() {
        var b2 = a.pingedTasks;
        b2.push(k), b2.length === 1 && Eb(a);
      }, blockedBoundary: c, blockedSegment: d, abortSet: f, legacyContext: e, context: g, treeContext: h };
      return f.add(k), k;
    }
    function T(a, b, c, d, f, e) {
      return { status: 0, id: -1, index: b, parentFlushed: !1, chunks: [], children: [], formatContext: d, boundary: c, lastPushedText: f, textEmbedded: e };
    }
    function U(a, b) {
      if (a = a.onError(b), a != null && typeof a != "string")
        throw Error('onError returned something with a type other than "string". onError should return a string and may return null or undefined but must not return anything else. It received something of type "' + typeof a + '" instead');
      return a;
    }
    function V(a, b) {
      var c = a.onShellError;
      c(b), c = a.onFatalError, c(b), a.destination !== null ? (a.status = 2, a.destination.destroy(b)) : (a.status = 1, a.fatalError = b);
    }
    function Fb(a, b, c, d, f) {
      for (H = {}, ob = b, M = 0, a = c(d, f); L; )
        L = !1, M = 0, O += 1, J = null, a = c(d, f);
      return tb(), a;
    }
    function Gb(a, b, c, d) {
      var f = c.render(), e = d.childContextTypes;
      if (e != null) {
        var g = b.legacyContext;
        if (typeof c.getChildContext != "function")
          d = g;
        else {
          c = c.getChildContext();
          for (var h in c)
            if (!(h in e))
              throw Error((Za(d) || "Unknown") + '.getChildContext(): key "' + h + '" is not defined in childContextTypes.');
          d = A({}, g, c);
        }
        b.legacyContext = d, W(a, b, f), b.legacyContext = g;
      } else
        W(a, b, f);
    }
    function Hb(a, b) {
      if (a && a.defaultProps) {
        b = A({}, b), a = a.defaultProps;
        for (var c in a)
          b[c] === void 0 && (b[c] = a[c]);
        return b;
      }
      return b;
    }
    function Ib(a, b, c, d, f) {
      if (typeof c == "function")
        if (c.prototype && c.prototype.isReactComponent) {
          f = ab(c, b.legacyContext);
          var e = c.contextType;
          e = new c(d, typeof e == "object" && e !== null ? e._currentValue2 : f), gb(e, c, d, f), Gb(a, b, e, c);
        } else {
          e = ab(c, b.legacyContext), f = Fb(a, b, c, d, e);
          var g = M !== 0;
          if (typeof f == "object" && f !== null && typeof f.render == "function" && f.$$typeof === void 0)
            gb(f, c, d, e), Gb(a, b, f, c);
          else if (g) {
            d = b.treeContext, b.treeContext = ib(d, 1, 0);
            try {
              W(a, b, f);
            } finally {
              b.treeContext = d;
            }
          } else
            W(a, b, f);
        }
      else if (typeof c == "string") {
        switch (f = b.blockedSegment, e = za(f.chunks, c, d, a.responseState, f.formatContext), f.lastPushedText = !1, g = f.formatContext, f.formatContext = sa(g, c, d), Jb(a, b, e), f.formatContext = g, c) {
          case "area":
          case "base":
          case "br":
          case "col":
          case "embed":
          case "hr":
          case "img":
          case "input":
          case "keygen":
          case "link":
          case "meta":
          case "param":
          case "source":
          case "track":
          case "wbr":
            break;
          default:
            f.chunks.push("</", c, ">");
        }
        f.lastPushedText = !1;
      } else {
        switch (c) {
          case Wa:
          case Va:
          case La:
          case Ma:
          case Ka:
            W(a, b, d.children);
            return;
          case Ra:
            W(a, b, d.children);
            return;
          case Ua:
            throw Error("ReactDOMServer does not yet support scope components.");
          case Qa:
            a: {
              c = b.blockedBoundary, f = b.blockedSegment, e = d.fallback, d = d.children, g = /* @__PURE__ */ new Set();
              var h = { id: null, rootSegmentID: -1, parentFlushed: !1, pendingTasks: 0, forceClientRender: !1, completedSegments: [], byteSize: 0, fallbackAbortableTasks: g, errorDigest: null }, k = T(a, f.chunks.length, h, f.formatContext, !1, !1);
              f.children.push(k), f.lastPushedText = !1;
              var m = T(a, 0, null, f.formatContext, !1, !1);
              m.parentFlushed = !0, b.blockedBoundary = h, b.blockedSegment = m;
              try {
                if (Jb(a, b, d), a.responseState.generateStaticMarkup || m.lastPushedText && m.textEmbedded && m.chunks.push("<!-- -->"), m.status = 1, X(h, m), h.pendingTasks === 0)
                  break a;
              } catch (l) {
                m.status = 4, h.forceClientRender = !0, h.errorDigest = U(a, l);
              } finally {
                b.blockedBoundary = c, b.blockedSegment = f;
              }
              b = Db(a, e, c, k, g, b.legacyContext, b.context, b.treeContext), a.pingedTasks.push(b);
            }
            return;
        }
        if (typeof c == "object" && c !== null)
          switch (c.$$typeof) {
            case Pa:
              if (d = Fb(a, b, c.render, d, f), M !== 0) {
                c = b.treeContext, b.treeContext = ib(c, 1, 0);
                try {
                  W(a, b, d);
                } finally {
                  b.treeContext = c;
                }
              } else
                W(a, b, d);
              return;
            case Sa:
              c = c.type, d = Hb(c, d), Ib(a, b, c, d, f);
              return;
            case Na:
              if (f = d.children, c = c._context, d = d.value, e = c._currentValue2, c._currentValue2 = d, g = D, D = d = { parent: g, depth: g === null ? 0 : g.depth + 1, context: c, parentValue: e, value: d }, b.context = d, W(a, b, f), a = D, a === null)
                throw Error("Tried to pop a Context at the root of the app. This is a bug in React.");
              d = a.parentValue, a.context._currentValue2 = d === Xa ? a.context._defaultValue : d, a = D = a.parent, b.context = a;
              return;
            case Oa:
              d = d.children, d = d(c._currentValue2), W(a, b, d);
              return;
            case Ta:
              f = c._init, c = f(c._payload), d = Hb(c, d), Ib(a, b, c, d, void 0);
              return;
          }
        throw Error("Element type is invalid: expected a string (for built-in components) or a class/function (for composite components) but got: " + ((c == null ? c : typeof c) + "."));
      }
    }
    function W(a, b, c) {
      if (b.node = c, typeof c == "object" && c !== null) {
        switch (c.$$typeof) {
          case Ia:
            Ib(a, b, c.type, c.props, c.ref);
            return;
          case Ja:
            throw Error("Portals are not currently supported by the server renderer. Render them conditionally so that they only appear on the client render.");
          case Ta:
            var d = c._init;
            c = d(c._payload), W(a, b, c);
            return;
        }
        if (ra(c)) {
          Kb(a, b, c);
          return;
        }
        if (c === null || typeof c != "object" ? d = null : (d = Ya && c[Ya] || c["@@iterator"], d = typeof d == "function" ? d : null), d && (d = d.call(c))) {
          if (c = d.next(), !c.done) {
            var f = [];
            do
              f.push(c.value), c = d.next();
            while (!c.done);
            Kb(a, b, f);
          }
          return;
        }
        throw a = Object.prototype.toString.call(c), Error("Objects are not valid as a React child (found: " + (a === "[object Object]" ? "object with keys {" + Object.keys(c).join(", ") + "}" : a) + "). If you meant to render a collection of children, use an array instead.");
      }
      typeof c == "string" ? (d = b.blockedSegment, d.lastPushedText = Ha(b.blockedSegment.chunks, c, a.responseState, d.lastPushedText)) : typeof c == "number" && (d = b.blockedSegment, d.lastPushedText = Ha(
        b.blockedSegment.chunks,
        "" + c,
        a.responseState,
        d.lastPushedText
      ));
    }
    function Kb(a, b, c) {
      for (var d = c.length, f = 0; f < d; f++) {
        var e = b.treeContext;
        b.treeContext = ib(e, d, f);
        try {
          Jb(a, b, c[f]);
        } finally {
          b.treeContext = e;
        }
      }
    }
    function Jb(a, b, c) {
      var d = b.blockedSegment.formatContext, f = b.legacyContext, e = b.context;
      try {
        return W(a, b, c);
      } catch (k) {
        if (tb(), typeof k == "object" && k !== null && typeof k.then == "function") {
          c = k;
          var g = b.blockedSegment, h = T(a, g.chunks.length, null, g.formatContext, g.lastPushedText, !0);
          g.children.push(h), g.lastPushedText = !1, a = Db(a, b.node, b.blockedBoundary, h, b.abortSet, b.legacyContext, b.context, b.treeContext).ping, c.then(a, a), b.blockedSegment.formatContext = d, b.legacyContext = f, b.context = e, F(e);
        } else
          throw b.blockedSegment.formatContext = d, b.legacyContext = f, b.context = e, F(e), k;
      }
    }
    function Lb(a) {
      var b = a.blockedBoundary;
      a = a.blockedSegment, a.status = 3, Mb(this, b, a);
    }
    function Nb(a, b, c) {
      var d = a.blockedBoundary;
      a.blockedSegment.status = 3, d === null ? (b.allPendingTasks--, b.status !== 2 && (b.status = 2, b.destination !== null && b.destination.push(null))) : (d.pendingTasks--, d.forceClientRender || (d.forceClientRender = !0, d.errorDigest = b.onError(c === void 0 ? Error("The render was aborted by the server without a reason.") : c), d.parentFlushed && b.clientRenderedBoundaries.push(d)), d.fallbackAbortableTasks.forEach(function(a2) {
        return Nb(a2, b, c);
      }), d.fallbackAbortableTasks.clear(), b.allPendingTasks--, b.allPendingTasks === 0 && (a = b.onAllReady, a()));
    }
    function X(a, b) {
      if (b.chunks.length === 0 && b.children.length === 1 && b.children[0].boundary === null) {
        var c = b.children[0];
        c.id = b.id, c.parentFlushed = !0, c.status === 1 && X(a, c);
      } else
        a.completedSegments.push(b);
    }
    function Mb(a, b, c) {
      if (b === null) {
        if (c.parentFlushed) {
          if (a.completedRootSegment !== null)
            throw Error("There can only be one root segment. This is a bug in React.");
          a.completedRootSegment = c;
        }
        a.pendingRootTasks--, a.pendingRootTasks === 0 && (a.onShellError = S, b = a.onShellReady, b());
      } else
        b.pendingTasks--, b.forceClientRender || (b.pendingTasks === 0 ? (c.parentFlushed && c.status === 1 && X(b, c), b.parentFlushed && a.completedBoundaries.push(b), b.fallbackAbortableTasks.forEach(Lb, a), b.fallbackAbortableTasks.clear()) : c.parentFlushed && c.status === 1 && (X(b, c), b.completedSegments.length === 1 && b.parentFlushed && a.partialBoundaries.push(b)));
      a.allPendingTasks--, a.allPendingTasks === 0 && (a = a.onAllReady, a());
    }
    function Eb(a) {
      if (a.status !== 2) {
        var b = D, c = Ab.current;
        Ab.current = zb;
        var d = R;
        R = a.responseState;
        try {
          var f = a.pingedTasks, e;
          for (e = 0; e < f.length; e++) {
            var g = f[e], h = a, k = g.blockedSegment;
            if (k.status === 0) {
              F(g.context);
              try {
                W(h, g, g.node), h.responseState.generateStaticMarkup || k.lastPushedText && k.textEmbedded && k.chunks.push("<!-- -->"), g.abortSet.delete(g), k.status = 1, Mb(h, g.blockedBoundary, k);
              } catch (y) {
                if (tb(), typeof y == "object" && y !== null && typeof y.then == "function") {
                  var m = g.ping;
                  y.then(m, m);
                } else {
                  g.abortSet.delete(g), k.status = 4;
                  var l = g.blockedBoundary, p = y, B = U(h, p);
                  if (l === null ? V(h, p) : (l.pendingTasks--, l.forceClientRender || (l.forceClientRender = !0, l.errorDigest = B, l.parentFlushed && h.clientRenderedBoundaries.push(l))), h.allPendingTasks--, h.allPendingTasks === 0) {
                    var C = h.onAllReady;
                    C();
                  }
                }
              } finally {
              }
            }
          }
          f.splice(0, e), a.destination !== null && Ob(a, a.destination);
        } catch (y) {
          U(a, y), V(a, y);
        } finally {
          R = d, Ab.current = c, c === zb && F(b);
        }
      }
    }
    function Y(a, b, c) {
      switch (c.parentFlushed = !0, c.status) {
        case 0:
          var d = c.id = a.nextSegmentId++;
          return c.lastPushedText = !1, c.textEmbedded = !1, a = a.responseState, b.push('<template id="'), b.push(a.placeholderPrefix), a = d.toString(16), b.push(a), b.push('"></template>');
        case 1:
          c.status = 2;
          var f = !0;
          d = c.chunks;
          var e = 0;
          c = c.children;
          for (var g = 0; g < c.length; g++) {
            for (f = c[g]; e < f.index; e++)
              b.push(d[e]);
            f = Z(a, b, f);
          }
          for (; e < d.length - 1; e++)
            b.push(d[e]);
          return e < d.length && (f = b.push(d[e])), f;
        default:
          throw Error("Aborted, errored or already flushed boundaries should not be flushed again. This is a bug in React.");
      }
    }
    function Z(a, b, c) {
      var d = c.boundary;
      if (d === null)
        return Y(a, b, c);
      if (d.parentFlushed = !0, d.forceClientRender)
        return a.responseState.generateStaticMarkup || (d = d.errorDigest, b.push("<!--$!-->"), b.push("<template"), d && (b.push(' data-dgst="'), d = u(d), b.push(d), b.push('"')), b.push("></template>")), Y(a, b, c), a = a.responseState.generateStaticMarkup ? !0 : b.push("<!--/$-->"), a;
      if (0 < d.pendingTasks) {
        d.rootSegmentID = a.nextSegmentId++, 0 < d.completedSegments.length && a.partialBoundaries.push(d);
        var f = a.responseState, e = f.nextSuspenseID++;
        return f = f.boundaryPrefix + e.toString(16), d = d.id = f, Aa(b, a.responseState, d), Y(a, b, c), b.push("<!--/$-->");
      }
      if (d.byteSize > a.progressiveChunkSize)
        return d.rootSegmentID = a.nextSegmentId++, a.completedBoundaries.push(d), Aa(b, a.responseState, d.id), Y(a, b, c), b.push("<!--/$-->");
      if (a.responseState.generateStaticMarkup || b.push("<!--$-->"), c = d.completedSegments, c.length !== 1)
        throw Error("A previously unvisited boundary must have exactly one root segment. This is a bug in React.");
      return Z(a, b, c[0]), a = a.responseState.generateStaticMarkup ? !0 : b.push("<!--/$-->"), a;
    }
    function Pb(a, b, c) {
      return Ba(b, a.responseState, c.formatContext, c.id), Z(a, b, c), Ca(b, c.formatContext);
    }
    function Qb(a, b, c) {
      for (var d = c.completedSegments, f = 0; f < d.length; f++)
        Rb(a, b, c, d[f]);
      if (d.length = 0, a = a.responseState, d = c.id, c = c.rootSegmentID, b.push(a.startInlineScript), a.sentCompleteBoundaryFunction ? b.push('$RC("') : (a.sentCompleteBoundaryFunction = !0, b.push('function $RC(a,b){a=document.getElementById(a);b=document.getElementById(b);b.parentNode.removeChild(b);if(a){a=a.previousSibling;var f=a.parentNode,c=a.nextSibling,e=0;do{if(c&&8===c.nodeType){var d=c.data;if("/$"===d)if(0===e)break;else e--;else"$"!==d&&"$?"!==d&&"$!"!==d||e++}d=c.nextSibling;f.removeChild(c);c=d}while(c);for(;b.firstChild;)f.insertBefore(b.firstChild,c);a.data="$";a._reactRetry&&a._reactRetry()}};$RC("')), d === null)
        throw Error("An ID must have been assigned before we can complete the boundary.");
      return c = c.toString(16), b.push(d), b.push('","'), b.push(a.segmentPrefix), b.push(c), b.push('")</script>');
    }
    function Rb(a, b, c, d) {
      if (d.status === 2)
        return !0;
      var f = d.id;
      if (f === -1) {
        if ((d.id = c.rootSegmentID) === -1)
          throw Error("A root segment ID must have been assigned by now. This is a bug in React.");
        return Pb(a, b, d);
      }
      return Pb(a, b, d), a = a.responseState, b.push(a.startInlineScript), a.sentCompleteSegmentFunction ? b.push('$RS("') : (a.sentCompleteSegmentFunction = !0, b.push('function $RS(a,b){a=document.getElementById(a);b=document.getElementById(b);for(a.parentNode.removeChild(a);a.firstChild;)b.parentNode.insertBefore(a.firstChild,b);b.parentNode.removeChild(b)};$RS("')), b.push(a.segmentPrefix), f = f.toString(16), b.push(f), b.push('","'), b.push(a.placeholderPrefix), b.push(f), b.push('")</script>');
    }
    function Ob(a, b) {
      try {
        var c = a.completedRootSegment;
        if (c !== null && a.pendingRootTasks === 0) {
          Z(a, b, c), a.completedRootSegment = null;
          var d = a.responseState.bootstrapChunks;
          for (c = 0; c < d.length - 1; c++)
            b.push(d[c]);
          c < d.length && b.push(d[c]);
        }
        var f = a.clientRenderedBoundaries, e;
        for (e = 0; e < f.length; e++) {
          var g = f[e];
          d = b;
          var h = a.responseState, k = g.id, m = g.errorDigest, l = g.errorMessage, p = g.errorComponentStack;
          if (d.push(h.startInlineScript), h.sentClientRenderFunction ? d.push('$RX("') : (h.sentClientRenderFunction = !0, d.push('function $RX(b,c,d,e){var a=document.getElementById(b);a&&(b=a.previousSibling,b.data="$!",a=a.dataset,c&&(a.dgst=c),d&&(a.msg=d),e&&(a.stck=e),b._reactRetry&&b._reactRetry())};$RX("')), k === null)
            throw Error("An ID must have been assigned before we can complete the boundary.");
          if (d.push(k), d.push('"'), m || l || p) {
            d.push(",");
            var B = Ea(m || "");
            d.push(B);
          }
          if (l || p) {
            d.push(",");
            var C = Ea(l || "");
            d.push(C);
          }
          if (p) {
            d.push(",");
            var y = Ea(p);
            d.push(y);
          }
          if (!d.push(")</script>")) {
            a.destination = null, e++, f.splice(0, e);
            return;
          }
        }
        f.splice(0, e);
        var aa = a.completedBoundaries;
        for (e = 0; e < aa.length; e++)
          if (!Qb(a, b, aa[e])) {
            a.destination = null, e++, aa.splice(0, e);
            return;
          }
        aa.splice(0, e);
        var ba = a.partialBoundaries;
        for (e = 0; e < ba.length; e++) {
          var pb = ba[e];
          a: {
            f = a, g = b;
            var ca = pb.completedSegments;
            for (h = 0; h < ca.length; h++)
              if (!Rb(f, g, pb, ca[h])) {
                h++, ca.splice(0, h);
                var qb = !1;
                break a;
              }
            ca.splice(0, h), qb = !0;
          }
          if (!qb) {
            a.destination = null, e++, ba.splice(0, e);
            return;
          }
        }
        ba.splice(0, e);
        var da = a.completedBoundaries;
        for (e = 0; e < da.length; e++)
          if (!Qb(a, b, da[e])) {
            a.destination = null, e++, da.splice(0, e);
            return;
          }
        da.splice(0, e);
      } finally {
        a.allPendingTasks === 0 && a.pingedTasks.length === 0 && a.clientRenderedBoundaries.length === 0 && a.completedBoundaries.length === 0 && b.push(null);
      }
    }
    function Sb(a, b) {
      if (a.status === 1)
        a.status = 2, b.destroy(a.fatalError);
      else if (a.status !== 2 && a.destination === null) {
        a.destination = b;
        try {
          Ob(a, b);
        } catch (c) {
          U(a, c), V(a, c);
        }
      }
    }
    function Tb(a, b) {
      try {
        var c = a.abortableTasks;
        c.forEach(function(c2) {
          return Nb(c2, a, b);
        }), c.clear(), a.destination !== null && Ob(a, a.destination);
      } catch (d) {
        U(a, d), V(a, d);
      }
    }
    function Ub() {
    }
    function Vb(a, b, c, d) {
      var f = !1, e = null, g = "", h = !1;
      if (a = Cb(a, Fa(c, b ? b.identifierPrefix : void 0), Ga(), 1 / 0, Ub, void 0, function() {
        h = !0;
      }, void 0, void 0), Eb(a), Tb(a, d), Sb(a, { push: function(a2) {
        return a2 !== null && (g += a2), !0;
      }, destroy: function(a2) {
        f = !0, e = a2;
      } }), f)
        throw e;
      if (!h)
        throw Error("A component suspended while responding to synchronous input. This will cause the UI to be replaced with a loading indicator. To fix, updates that suspend should be wrapped with startTransition.");
      return g;
    }
    function Wb(a, b) {
      a.prototype = Object.create(b.prototype), a.prototype.constructor = a, a.__proto__ = b;
    }
    var Xb = function(a) {
      function b() {
        var b2 = a.call(this, {}) || this;
        return b2.request = null, b2.startedFlowing = !1, b2;
      }
      Wb(b, a);
      var c = b.prototype;
      return c._destroy = function(a2, b2) {
        Tb(this.request), b2(a2);
      }, c._read = function() {
        this.startedFlowing && Sb(this.request, this);
      }, b;
    }(fa.Readable);
    function Yb() {
    }
    function Zb(a, b) {
      var c = new Xb(), d = Cb(a, Fa(!1, b ? b.identifierPrefix : void 0), Ga(), 1 / 0, Yb, function() {
        c.startedFlowing = !0, Sb(d, c);
      }, void 0, void 0);
      return c.request = d, Eb(d), c;
    }
    exports.renderToNodeStream = function(a, b) {
      return Zb(a, b);
    };
    exports.renderToStaticMarkup = function(a, b) {
      return Vb(a, b, !0, 'The server used "renderToStaticMarkup" which does not support Suspense. If you intended to have the server wait for the suspended component please switch to "renderToPipeableStream" which supports Suspense on the server');
    };
    exports.renderToStaticNodeStream = function(a, b) {
      return Zb(a, b);
    };
    exports.renderToString = function(a, b) {
      return Vb(a, b, !1, 'The server used "renderToString" which does not support Suspense. If you intended for this Suspense boundary to render the fallback content on the server consider throwing an Error somewhere within the Suspense boundary. If you intended to have the server wait for the suspended component please switch to "renderToPipeableStream" which supports Suspense on the server');
    };
    exports.version = "18.2.0";
  }
});

// ../../node_modules/.pnpm/react-dom@18.2.0_react@18.2.0/node_modules/react-dom/cjs/react-dom-server.node.production.min.js
var require_react_dom_server_node_production_min = __commonJS({
  "../../node_modules/.pnpm/react-dom@18.2.0_react@18.2.0/node_modules/react-dom/cjs/react-dom-server.node.production.min.js"(exports) {
    "use strict";
    init_cjs_shims();
    var aa = __require("util"), ba = require_react(), k = null, l = 0, q = !0;
    function r2(a, b) {
      if (typeof b == "string") {
        if (b.length !== 0)
          if (2048 < 3 * b.length)
            0 < l && (t7(a, k.subarray(0, l)), k = new Uint8Array(2048), l = 0), t7(a, u.encode(b));
          else {
            var c = k;
            0 < l && (c = k.subarray(l)), c = u.encodeInto(b, c);
            var d = c.read;
            l += c.written, d < b.length && (t7(a, k), k = new Uint8Array(2048), l = u.encodeInto(b.slice(d), k).written), l === 2048 && (t7(a, k), k = new Uint8Array(2048), l = 0);
          }
      } else
        b.byteLength !== 0 && (2048 < b.byteLength ? (0 < l && (t7(a, k.subarray(0, l)), k = new Uint8Array(2048), l = 0), t7(a, b)) : (c = k.length - l, c < b.byteLength && (c === 0 ? t7(
          a,
          k
        ) : (k.set(b.subarray(0, c), l), l += c, t7(a, k), b = b.subarray(c)), k = new Uint8Array(2048), l = 0), k.set(b, l), l += b.byteLength, l === 2048 && (t7(a, k), k = new Uint8Array(2048), l = 0)));
    }
    function t7(a, b) {
      a = a.write(b), q = q && a;
    }
    function w(a, b) {
      return r2(a, b), q;
    }
    function ca(a) {
      k && 0 < l && a.write(k.subarray(0, l)), k = null, l = 0, q = !0;
    }
    var u = new aa.TextEncoder();
    function x(a) {
      return u.encode(a);
    }
    var y = Object.prototype.hasOwnProperty, da = /^[:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD][:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\-.0-9\u00B7\u0300-\u036F\u203F-\u2040]*$/, ea = {}, fa = {};
    function ha(a) {
      return y.call(fa, a) ? !0 : y.call(ea, a) ? !1 : da.test(a) ? fa[a] = !0 : (ea[a] = !0, !1);
    }
    function z2(a, b, c, d, f, e, g) {
      this.acceptsBooleans = b === 2 || b === 3 || b === 4, this.attributeName = d, this.attributeNamespace = f, this.mustUseProperty = c, this.propertyName = a, this.type = b, this.sanitizeURL = e, this.removeEmptyString = g;
    }
    var A = {};
    "children dangerouslySetInnerHTML defaultValue defaultChecked innerHTML suppressContentEditableWarning suppressHydrationWarning style".split(" ").forEach(function(a) {
      A[a] = new z2(a, 0, !1, a, null, !1, !1);
    });
    [["acceptCharset", "accept-charset"], ["className", "class"], ["htmlFor", "for"], ["httpEquiv", "http-equiv"]].forEach(function(a) {
      var b = a[0];
      A[b] = new z2(b, 1, !1, a[1], null, !1, !1);
    });
    ["contentEditable", "draggable", "spellCheck", "value"].forEach(function(a) {
      A[a] = new z2(a, 2, !1, a.toLowerCase(), null, !1, !1);
    });
    ["autoReverse", "externalResourcesRequired", "focusable", "preserveAlpha"].forEach(function(a) {
      A[a] = new z2(a, 2, !1, a, null, !1, !1);
    });
    "allowFullScreen async autoFocus autoPlay controls default defer disabled disablePictureInPicture disableRemotePlayback formNoValidate hidden loop noModule noValidate open playsInline readOnly required reversed scoped seamless itemScope".split(" ").forEach(function(a) {
      A[a] = new z2(a, 3, !1, a.toLowerCase(), null, !1, !1);
    });
    ["checked", "multiple", "muted", "selected"].forEach(function(a) {
      A[a] = new z2(a, 3, !0, a, null, !1, !1);
    });
    ["capture", "download"].forEach(function(a) {
      A[a] = new z2(a, 4, !1, a, null, !1, !1);
    });
    ["cols", "rows", "size", "span"].forEach(function(a) {
      A[a] = new z2(a, 6, !1, a, null, !1, !1);
    });
    ["rowSpan", "start"].forEach(function(a) {
      A[a] = new z2(a, 5, !1, a.toLowerCase(), null, !1, !1);
    });
    var ia = /[\-:]([a-z])/g;
    function ja(a) {
      return a[1].toUpperCase();
    }
    "accent-height alignment-baseline arabic-form baseline-shift cap-height clip-path clip-rule color-interpolation color-interpolation-filters color-profile color-rendering dominant-baseline enable-background fill-opacity fill-rule flood-color flood-opacity font-family font-size font-size-adjust font-stretch font-style font-variant font-weight glyph-name glyph-orientation-horizontal glyph-orientation-vertical horiz-adv-x horiz-origin-x image-rendering letter-spacing lighting-color marker-end marker-mid marker-start overline-position overline-thickness paint-order panose-1 pointer-events rendering-intent shape-rendering stop-color stop-opacity strikethrough-position strikethrough-thickness stroke-dasharray stroke-dashoffset stroke-linecap stroke-linejoin stroke-miterlimit stroke-opacity stroke-width text-anchor text-decoration text-rendering underline-position underline-thickness unicode-bidi unicode-range units-per-em v-alphabetic v-hanging v-ideographic v-mathematical vector-effect vert-adv-y vert-origin-x vert-origin-y word-spacing writing-mode xmlns:xlink x-height".split(" ").forEach(function(a) {
      var b = a.replace(
        ia,
        ja
      );
      A[b] = new z2(b, 1, !1, a, null, !1, !1);
    });
    "xlink:actuate xlink:arcrole xlink:role xlink:show xlink:title xlink:type".split(" ").forEach(function(a) {
      var b = a.replace(ia, ja);
      A[b] = new z2(b, 1, !1, a, "http://www.w3.org/1999/xlink", !1, !1);
    });
    ["xml:base", "xml:lang", "xml:space"].forEach(function(a) {
      var b = a.replace(ia, ja);
      A[b] = new z2(b, 1, !1, a, "http://www.w3.org/XML/1998/namespace", !1, !1);
    });
    ["tabIndex", "crossOrigin"].forEach(function(a) {
      A[a] = new z2(a, 1, !1, a.toLowerCase(), null, !1, !1);
    });
    A.xlinkHref = new z2("xlinkHref", 1, !1, "xlink:href", "http://www.w3.org/1999/xlink", !0, !1);
    ["src", "href", "action", "formAction"].forEach(function(a) {
      A[a] = new z2(a, 1, !1, a.toLowerCase(), null, !0, !0);
    });
    var B = {
      animationIterationCount: !0,
      aspectRatio: !0,
      borderImageOutset: !0,
      borderImageSlice: !0,
      borderImageWidth: !0,
      boxFlex: !0,
      boxFlexGroup: !0,
      boxOrdinalGroup: !0,
      columnCount: !0,
      columns: !0,
      flex: !0,
      flexGrow: !0,
      flexPositive: !0,
      flexShrink: !0,
      flexNegative: !0,
      flexOrder: !0,
      gridArea: !0,
      gridRow: !0,
      gridRowEnd: !0,
      gridRowSpan: !0,
      gridRowStart: !0,
      gridColumn: !0,
      gridColumnEnd: !0,
      gridColumnSpan: !0,
      gridColumnStart: !0,
      fontWeight: !0,
      lineClamp: !0,
      lineHeight: !0,
      opacity: !0,
      order: !0,
      orphans: !0,
      tabSize: !0,
      widows: !0,
      zIndex: !0,
      zoom: !0,
      fillOpacity: !0,
      floodOpacity: !0,
      stopOpacity: !0,
      strokeDasharray: !0,
      strokeDashoffset: !0,
      strokeMiterlimit: !0,
      strokeOpacity: !0,
      strokeWidth: !0
    }, ka = ["Webkit", "ms", "Moz", "O"];
    Object.keys(B).forEach(function(a) {
      ka.forEach(function(b) {
        b = b + a.charAt(0).toUpperCase() + a.substring(1), B[b] = B[a];
      });
    });
    var la = /["'&<>]/;
    function F(a) {
      if (typeof a == "boolean" || typeof a == "number")
        return "" + a;
      a = "" + a;
      var b = la.exec(a);
      if (b) {
        var c = "", d, f = 0;
        for (d = b.index; d < a.length; d++) {
          switch (a.charCodeAt(d)) {
            case 34:
              b = "&quot;";
              break;
            case 38:
              b = "&amp;";
              break;
            case 39:
              b = "&#x27;";
              break;
            case 60:
              b = "&lt;";
              break;
            case 62:
              b = "&gt;";
              break;
            default:
              continue;
          }
          f !== d && (c += a.substring(f, d)), f = d + 1, c += b;
        }
        a = f !== d ? c + a.substring(f, d) : c;
      }
      return a;
    }
    var ma = /([A-Z])/g, pa = /^ms-/, qa = Array.isArray, ra = x("<script>"), sa = x("</script>"), ta = x('<script src="'), ua = x('<script type="module" src="'), va = x('" async=""></script>'), wa = /(<\/|<)(s)(cript)/gi;
    function xa(a, b, c, d) {
      return "" + b + (c === "s" ? "\\u0073" : "\\u0053") + d;
    }
    function G(a, b) {
      return { insertionMode: a, selectedValue: b };
    }
    function ya(a, b, c) {
      switch (b) {
        case "select":
          return G(1, c.value != null ? c.value : c.defaultValue);
        case "svg":
          return G(2, null);
        case "math":
          return G(3, null);
        case "foreignObject":
          return G(1, null);
        case "table":
          return G(4, null);
        case "thead":
        case "tbody":
        case "tfoot":
          return G(5, null);
        case "colgroup":
          return G(7, null);
        case "tr":
          return G(6, null);
      }
      return 4 <= a.insertionMode || a.insertionMode === 0 ? G(1, null) : a;
    }
    var za = x("<!-- -->");
    function Aa(a, b, c, d) {
      return b === "" ? d : (d && a.push(za), a.push(F(b)), !0);
    }
    var Ba = /* @__PURE__ */ new Map(), Ca = x(' style="'), Da = x(":"), Ea = x(";");
    function Fa(a, b, c) {
      if (typeof c != "object")
        throw Error("The `style` prop expects a mapping from style properties to values, not a string. For example, style={{marginRight: spacing + 'em'}} when using JSX.");
      b = !0;
      for (var d in c)
        if (y.call(c, d)) {
          var f = c[d];
          if (f != null && typeof f != "boolean" && f !== "") {
            if (d.indexOf("--") === 0) {
              var e = F(d);
              f = F(("" + f).trim());
            } else {
              e = d;
              var g = Ba.get(e);
              g !== void 0 || (g = x(F(e.replace(ma, "-$1").toLowerCase().replace(pa, "-ms-"))), Ba.set(e, g)), e = g, f = typeof f == "number" ? f === 0 || y.call(
                B,
                d
              ) ? "" + f : f + "px" : F(("" + f).trim());
            }
            b ? (b = !1, a.push(Ca, e, Da, f)) : a.push(Ea, e, Da, f);
          }
        }
      b || a.push(H);
    }
    var I = x(" "), J = x('="'), H = x('"'), Ga = x('=""');
    function K(a, b, c, d) {
      switch (c) {
        case "style":
          Fa(a, b, d);
          return;
        case "defaultValue":
        case "defaultChecked":
        case "innerHTML":
        case "suppressContentEditableWarning":
        case "suppressHydrationWarning":
          return;
      }
      if (!(2 < c.length) || c[0] !== "o" && c[0] !== "O" || c[1] !== "n" && c[1] !== "N") {
        if (b = A.hasOwnProperty(c) ? A[c] : null, b !== null) {
          switch (typeof d) {
            case "function":
            case "symbol":
              return;
            case "boolean":
              if (!b.acceptsBooleans)
                return;
          }
          switch (c = b.attributeName, b.type) {
            case 3:
              d && a.push(I, c, Ga);
              break;
            case 4:
              d === !0 ? a.push(I, c, Ga) : d !== !1 && a.push(I, c, J, F(d), H);
              break;
            case 5:
              isNaN(d) || a.push(I, c, J, F(d), H);
              break;
            case 6:
              !isNaN(d) && 1 <= d && a.push(I, c, J, F(d), H);
              break;
            default:
              b.sanitizeURL && (d = "" + d), a.push(I, c, J, F(d), H);
          }
        } else if (ha(c)) {
          switch (typeof d) {
            case "function":
            case "symbol":
              return;
            case "boolean":
              if (b = c.toLowerCase().slice(0, 5), b !== "data-" && b !== "aria-")
                return;
          }
          a.push(I, c, J, F(d), H);
        }
      }
    }
    var L = x(">"), Ha = x("/>");
    function M(a, b, c) {
      if (b != null) {
        if (c != null)
          throw Error("Can only set one of `children` or `props.dangerouslySetInnerHTML`.");
        if (typeof b != "object" || !("__html" in b))
          throw Error("`props.dangerouslySetInnerHTML` must be in the form `{__html: ...}`. Please visit https://reactjs.org/link/dangerously-set-inner-html for more information.");
        b = b.__html, b != null && a.push("" + b);
      }
    }
    function Ia(a) {
      var b = "";
      return ba.Children.forEach(a, function(a2) {
        a2 != null && (b += a2);
      }), b;
    }
    var Ja = x(' selected=""');
    function Ka(a, b, c, d) {
      a.push(N(c));
      var f = c = null, e;
      for (e in b)
        if (y.call(b, e)) {
          var g = b[e];
          if (g != null)
            switch (e) {
              case "children":
                c = g;
                break;
              case "dangerouslySetInnerHTML":
                f = g;
                break;
              default:
                K(a, d, e, g);
            }
        }
      return a.push(L), M(a, f, c), typeof c == "string" ? (a.push(F(c)), null) : c;
    }
    var La = x(`
`), Ma = /^[a-zA-Z][a-zA-Z:_\.\-\d]*$/, Na = /* @__PURE__ */ new Map();
    function N(a) {
      var b = Na.get(a);
      if (b === void 0) {
        if (!Ma.test(a))
          throw Error("Invalid tag: " + a);
        b = x("<" + a), Na.set(a, b);
      }
      return b;
    }
    var Oa = x("<!DOCTYPE html>");
    function Pa(a, b, c, d, f) {
      switch (b) {
        case "select":
          a.push(N("select"));
          var e = null, g = null;
          for (p in c)
            if (y.call(c, p)) {
              var h = c[p];
              if (h != null)
                switch (p) {
                  case "children":
                    e = h;
                    break;
                  case "dangerouslySetInnerHTML":
                    g = h;
                    break;
                  case "defaultValue":
                  case "value":
                    break;
                  default:
                    K(a, d, p, h);
                }
            }
          return a.push(L), M(a, g, e), e;
        case "option":
          g = f.selectedValue, a.push(N("option"));
          var m = h = null, n = null, p = null;
          for (e in c)
            if (y.call(c, e)) {
              var v = c[e];
              if (v != null)
                switch (e) {
                  case "children":
                    h = v;
                    break;
                  case "selected":
                    n = v;
                    break;
                  case "dangerouslySetInnerHTML":
                    p = v;
                    break;
                  case "value":
                    m = v;
                  default:
                    K(a, d, e, v);
                }
            }
          if (g != null)
            if (c = m !== null ? "" + m : Ia(h), qa(g)) {
              for (d = 0; d < g.length; d++)
                if ("" + g[d] === c) {
                  a.push(Ja);
                  break;
                }
            } else
              "" + g === c && a.push(Ja);
          else
            n && a.push(Ja);
          return a.push(L), M(a, p, h), h;
        case "textarea":
          a.push(N("textarea")), p = g = e = null;
          for (h in c)
            if (y.call(c, h) && (m = c[h], m != null))
              switch (h) {
                case "children":
                  p = m;
                  break;
                case "value":
                  e = m;
                  break;
                case "defaultValue":
                  g = m;
                  break;
                case "dangerouslySetInnerHTML":
                  throw Error("`dangerouslySetInnerHTML` does not make sense on <textarea>.");
                default:
                  K(a, d, h, m);
              }
          if (e === null && g !== null && (e = g), a.push(L), p != null) {
            if (e != null)
              throw Error("If you supply `defaultValue` on a <textarea>, do not pass children.");
            if (qa(p) && 1 < p.length)
              throw Error("<textarea> can only have at most one child.");
            e = "" + p;
          }
          return typeof e == "string" && e[0] === `
` && a.push(La), e !== null && a.push(F("" + e)), null;
        case "input":
          a.push(N("input")), m = p = h = e = null;
          for (g in c)
            if (y.call(c, g) && (n = c[g], n != null))
              switch (g) {
                case "children":
                case "dangerouslySetInnerHTML":
                  throw Error("input is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");
                case "defaultChecked":
                  m = n;
                  break;
                case "defaultValue":
                  h = n;
                  break;
                case "checked":
                  p = n;
                  break;
                case "value":
                  e = n;
                  break;
                default:
                  K(a, d, g, n);
              }
          return p !== null ? K(a, d, "checked", p) : m !== null && K(a, d, "checked", m), e !== null ? K(a, d, "value", e) : h !== null && K(a, d, "value", h), a.push(Ha), null;
        case "menuitem":
          a.push(N("menuitem"));
          for (var C in c)
            if (y.call(c, C) && (e = c[C], e != null))
              switch (C) {
                case "children":
                case "dangerouslySetInnerHTML":
                  throw Error("menuitems cannot have `children` nor `dangerouslySetInnerHTML`.");
                default:
                  K(a, d, C, e);
              }
          return a.push(L), null;
        case "title":
          a.push(N("title")), e = null;
          for (v in c)
            if (y.call(c, v) && (g = c[v], g != null))
              switch (v) {
                case "children":
                  e = g;
                  break;
                case "dangerouslySetInnerHTML":
                  throw Error("`dangerouslySetInnerHTML` does not make sense on <title>.");
                default:
                  K(a, d, v, g);
              }
          return a.push(L), e;
        case "listing":
        case "pre":
          a.push(N(b)), g = e = null;
          for (m in c)
            if (y.call(c, m) && (h = c[m], h != null))
              switch (m) {
                case "children":
                  e = h;
                  break;
                case "dangerouslySetInnerHTML":
                  g = h;
                  break;
                default:
                  K(a, d, m, h);
              }
          if (a.push(L), g != null) {
            if (e != null)
              throw Error("Can only set one of `children` or `props.dangerouslySetInnerHTML`.");
            if (typeof g != "object" || !("__html" in g))
              throw Error("`props.dangerouslySetInnerHTML` must be in the form `{__html: ...}`. Please visit https://reactjs.org/link/dangerously-set-inner-html for more information.");
            c = g.__html, c != null && (typeof c == "string" && 0 < c.length && c[0] === `
` ? a.push(La, c) : a.push("" + c));
          }
          return typeof e == "string" && e[0] === `
` && a.push(La), e;
        case "area":
        case "base":
        case "br":
        case "col":
        case "embed":
        case "hr":
        case "img":
        case "keygen":
        case "link":
        case "meta":
        case "param":
        case "source":
        case "track":
        case "wbr":
          a.push(N(b));
          for (var D in c)
            if (y.call(c, D) && (e = c[D], e != null))
              switch (D) {
                case "children":
                case "dangerouslySetInnerHTML":
                  throw Error(b + " is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");
                default:
                  K(a, d, D, e);
              }
          return a.push(Ha), null;
        case "annotation-xml":
        case "color-profile":
        case "font-face":
        case "font-face-src":
        case "font-face-uri":
        case "font-face-format":
        case "font-face-name":
        case "missing-glyph":
          return Ka(a, c, b, d);
        case "html":
          return f.insertionMode === 0 && a.push(Oa), Ka(
            a,
            c,
            b,
            d
          );
        default:
          if (b.indexOf("-") === -1 && typeof c.is != "string")
            return Ka(a, c, b, d);
          a.push(N(b)), g = e = null;
          for (n in c)
            if (y.call(c, n) && (h = c[n], h != null))
              switch (n) {
                case "children":
                  e = h;
                  break;
                case "dangerouslySetInnerHTML":
                  g = h;
                  break;
                case "style":
                  Fa(a, d, h);
                  break;
                case "suppressContentEditableWarning":
                case "suppressHydrationWarning":
                  break;
                default:
                  ha(n) && typeof h != "function" && typeof h != "symbol" && a.push(I, n, J, F(h), H);
              }
          return a.push(L), M(a, g, e), e;
      }
    }
    var Qa = x("</"), Ra = x(">"), Sa = x('<template id="'), Ta = x('"></template>'), Ua = x("<!--$-->"), Va = x('<!--$?--><template id="'), Wa = x('"></template>'), Xa = x("<!--$!-->"), Ya = x("<!--/$-->"), Za = x("<template"), $a = x('"'), ab = x(' data-dgst="');
    x(' data-msg="');
    x(' data-stck="');
    var bb = x("></template>");
    function cb(a, b, c) {
      if (r2(a, Va), c === null)
        throw Error("An ID must have been assigned before we can complete the boundary.");
      return r2(a, c), w(a, Wa);
    }
    var db = x('<div hidden id="'), eb = x('">'), fb = x("</div>"), gb = x('<svg aria-hidden="true" style="display:none" id="'), hb = x('">'), ib = x("</svg>"), jb = x('<math aria-hidden="true" style="display:none" id="'), kb = x('">'), lb = x("</math>"), mb = x('<table hidden id="'), nb = x('">'), ob = x("</table>"), pb = x('<table hidden><tbody id="'), qb = x('">'), rb = x("</tbody></table>"), sb = x('<table hidden><tr id="'), tb = x('">'), ub = x("</tr></table>"), vb = x('<table hidden><colgroup id="'), wb = x('">'), xb = x("</colgroup></table>");
    function yb(a, b, c, d) {
      switch (c.insertionMode) {
        case 0:
        case 1:
          return r2(a, db), r2(a, b.segmentPrefix), r2(a, d.toString(16)), w(a, eb);
        case 2:
          return r2(a, gb), r2(a, b.segmentPrefix), r2(a, d.toString(16)), w(a, hb);
        case 3:
          return r2(a, jb), r2(a, b.segmentPrefix), r2(a, d.toString(16)), w(a, kb);
        case 4:
          return r2(a, mb), r2(a, b.segmentPrefix), r2(a, d.toString(16)), w(a, nb);
        case 5:
          return r2(a, pb), r2(a, b.segmentPrefix), r2(a, d.toString(16)), w(a, qb);
        case 6:
          return r2(a, sb), r2(a, b.segmentPrefix), r2(a, d.toString(16)), w(a, tb);
        case 7:
          return r2(a, vb), r2(
            a,
            b.segmentPrefix
          ), r2(a, d.toString(16)), w(a, wb);
        default:
          throw Error("Unknown insertion mode. This is a bug in React.");
      }
    }
    function zb(a, b) {
      switch (b.insertionMode) {
        case 0:
        case 1:
          return w(a, fb);
        case 2:
          return w(a, ib);
        case 3:
          return w(a, lb);
        case 4:
          return w(a, ob);
        case 5:
          return w(a, rb);
        case 6:
          return w(a, ub);
        case 7:
          return w(a, xb);
        default:
          throw Error("Unknown insertion mode. This is a bug in React.");
      }
    }
    var Ab = x('function $RS(a,b){a=document.getElementById(a);b=document.getElementById(b);for(a.parentNode.removeChild(a);a.firstChild;)b.parentNode.insertBefore(a.firstChild,b);b.parentNode.removeChild(b)};$RS("'), Bb = x('$RS("'), Cb = x('","'), Db = x('")</script>'), Fb = x('function $RC(a,b){a=document.getElementById(a);b=document.getElementById(b);b.parentNode.removeChild(b);if(a){a=a.previousSibling;var f=a.parentNode,c=a.nextSibling,e=0;do{if(c&&8===c.nodeType){var d=c.data;if("/$"===d)if(0===e)break;else e--;else"$"!==d&&"$?"!==d&&"$!"!==d||e++}d=c.nextSibling;f.removeChild(c);c=d}while(c);for(;b.firstChild;)f.insertBefore(b.firstChild,c);a.data="$";a._reactRetry&&a._reactRetry()}};$RC("'), Gb = x('$RC("'), Hb = x('","'), Ib = x('")</script>'), Jb = x('function $RX(b,c,d,e){var a=document.getElementById(b);a&&(b=a.previousSibling,b.data="$!",a=a.dataset,c&&(a.dgst=c),d&&(a.msg=d),e&&(a.stck=e),b._reactRetry&&b._reactRetry())};$RX("'), Kb = x('$RX("'), Lb = x('"'), Mb = x(")</script>"), Nb = x(","), Ob = /[<\u2028\u2029]/g;
    function Pb(a) {
      return JSON.stringify(a).replace(Ob, function(a2) {
        switch (a2) {
          case "<":
            return "\\u003c";
          case "\u2028":
            return "\\u2028";
          case "\u2029":
            return "\\u2029";
          default:
            throw Error("escapeJSStringsForInstructionScripts encountered a match it does not know how to replace. this means the match regex and the replacement characters are no longer in sync. This is a bug in React");
        }
      });
    }
    var O = Object.assign, Qb = Symbol.for("react.element"), Rb = Symbol.for("react.portal"), Sb = Symbol.for("react.fragment"), Tb = Symbol.for("react.strict_mode"), Ub = Symbol.for("react.profiler"), Vb = Symbol.for("react.provider"), Wb = Symbol.for("react.context"), Xb = Symbol.for("react.forward_ref"), Yb = Symbol.for("react.suspense"), Zb = Symbol.for("react.suspense_list"), $b = Symbol.for("react.memo"), ac = Symbol.for("react.lazy"), bc = Symbol.for("react.scope"), cc = Symbol.for("react.debug_trace_mode"), dc = Symbol.for("react.legacy_hidden"), ec = Symbol.for("react.default_value"), fc = Symbol.iterator;
    function gc(a) {
      if (a == null)
        return null;
      if (typeof a == "function")
        return a.displayName || a.name || null;
      if (typeof a == "string")
        return a;
      switch (a) {
        case Sb:
          return "Fragment";
        case Rb:
          return "Portal";
        case Ub:
          return "Profiler";
        case Tb:
          return "StrictMode";
        case Yb:
          return "Suspense";
        case Zb:
          return "SuspenseList";
      }
      if (typeof a == "object")
        switch (a.$$typeof) {
          case Wb:
            return (a.displayName || "Context") + ".Consumer";
          case Vb:
            return (a._context.displayName || "Context") + ".Provider";
          case Xb:
            var b = a.render;
            return a = a.displayName, a || (a = b.displayName || b.name || "", a = a !== "" ? "ForwardRef(" + a + ")" : "ForwardRef"), a;
          case $b:
            return b = a.displayName || null, b !== null ? b : gc(a.type) || "Memo";
          case ac:
            b = a._payload, a = a._init;
            try {
              return gc(a(b));
            } catch {
            }
        }
      return null;
    }
    var hc = {};
    function ic(a, b) {
      if (a = a.contextTypes, !a)
        return hc;
      var c = {}, d;
      for (d in a)
        c[d] = b[d];
      return c;
    }
    var P = null;
    function Q(a, b) {
      if (a !== b) {
        a.context._currentValue = a.parentValue, a = a.parent;
        var c = b.parent;
        if (a === null) {
          if (c !== null)
            throw Error("The stacks must reach the root at the same time. This is a bug in React.");
        } else {
          if (c === null)
            throw Error("The stacks must reach the root at the same time. This is a bug in React.");
          Q(a, c);
        }
        b.context._currentValue = b.value;
      }
    }
    function jc(a) {
      a.context._currentValue = a.parentValue, a = a.parent, a !== null && jc(a);
    }
    function kc(a) {
      var b = a.parent;
      b !== null && kc(b), a.context._currentValue = a.value;
    }
    function lc(a, b) {
      if (a.context._currentValue = a.parentValue, a = a.parent, a === null)
        throw Error("The depth must equal at least at zero before reaching the root. This is a bug in React.");
      a.depth === b.depth ? Q(a, b) : lc(a, b);
    }
    function mc(a, b) {
      var c = b.parent;
      if (c === null)
        throw Error("The depth must equal at least at zero before reaching the root. This is a bug in React.");
      a.depth === c.depth ? Q(a, c) : mc(a, c), b.context._currentValue = b.value;
    }
    function nc(a) {
      var b = P;
      b !== a && (b === null ? kc(a) : a === null ? jc(b) : b.depth === a.depth ? Q(b, a) : b.depth > a.depth ? lc(b, a) : mc(b, a), P = a);
    }
    var oc = { isMounted: function() {
      return !1;
    }, enqueueSetState: function(a, b) {
      a = a._reactInternals, a.queue !== null && a.queue.push(b);
    }, enqueueReplaceState: function(a, b) {
      a = a._reactInternals, a.replace = !0, a.queue = [b];
    }, enqueueForceUpdate: function() {
    } };
    function pc(a, b, c, d) {
      var f = a.state !== void 0 ? a.state : null;
      a.updater = oc, a.props = c, a.state = f;
      var e = { queue: [], replace: !1 };
      a._reactInternals = e;
      var g = b.contextType;
      if (a.context = typeof g == "object" && g !== null ? g._currentValue : d, g = b.getDerivedStateFromProps, typeof g == "function" && (g = g(c, f), f = g == null ? f : O({}, f, g), a.state = f), typeof b.getDerivedStateFromProps != "function" && typeof a.getSnapshotBeforeUpdate != "function" && (typeof a.UNSAFE_componentWillMount == "function" || typeof a.componentWillMount == "function"))
        if (b = a.state, typeof a.componentWillMount == "function" && a.componentWillMount(), typeof a.UNSAFE_componentWillMount == "function" && a.UNSAFE_componentWillMount(), b !== a.state && oc.enqueueReplaceState(a, a.state, null), e.queue !== null && 0 < e.queue.length)
          if (b = e.queue, g = e.replace, e.queue = null, e.replace = !1, g && b.length === 1)
            a.state = b[0];
          else {
            for (e = g ? b[0] : a.state, f = !0, g = g ? 1 : 0; g < b.length; g++) {
              var h = b[g];
              h = typeof h == "function" ? h.call(a, e, c, d) : h, h != null && (f ? (f = !1, e = O({}, e, h)) : O(e, h));
            }
            a.state = e;
          }
        else
          e.queue = null;
    }
    var qc = { id: 1, overflow: "" };
    function rc(a, b, c) {
      var d = a.id;
      a = a.overflow;
      var f = 32 - sc(d) - 1;
      d &= ~(1 << f), c += 1;
      var e = 32 - sc(b) + f;
      if (30 < e) {
        var g = f - f % 5;
        return e = (d & (1 << g) - 1).toString(32), d >>= g, f -= g, { id: 1 << 32 - sc(b) + f | c << f | d, overflow: e + a };
      }
      return { id: 1 << e | c << f | d, overflow: a };
    }
    var sc = Math.clz32 ? Math.clz32 : tc, uc = Math.log, vc = Math.LN2;
    function tc(a) {
      return a >>>= 0, a === 0 ? 32 : 31 - (uc(a) / vc | 0) | 0;
    }
    function wc(a, b) {
      return a === b && (a !== 0 || 1 / a === 1 / b) || a !== a && b !== b;
    }
    var xc = typeof Object.is == "function" ? Object.is : wc, R = null, yc = null, zc = null, S = null, T = !1, Ac = !1, U = 0, V = null, Bc = 0;
    function W() {
      if (R === null)
        throw Error(`Invalid hook call. Hooks can only be called inside of the body of a function component. This could happen for one of the following reasons:
1. You might have mismatching versions of React and the renderer (such as React DOM)
2. You might be breaking the Rules of Hooks
3. You might have more than one copy of React in the same app
See https://reactjs.org/link/invalid-hook-call for tips about how to debug and fix this problem.`);
      return R;
    }
    function Cc() {
      if (0 < Bc)
        throw Error("Rendered more hooks than during the previous render");
      return { memoizedState: null, queue: null, next: null };
    }
    function Dc() {
      return S === null ? zc === null ? (T = !1, zc = S = Cc()) : (T = !0, S = zc) : S.next === null ? (T = !1, S = S.next = Cc()) : (T = !0, S = S.next), S;
    }
    function Ec() {
      yc = R = null, Ac = !1, zc = null, Bc = 0, S = V = null;
    }
    function Fc(a, b) {
      return typeof b == "function" ? b(a) : b;
    }
    function Gc(a, b, c) {
      if (R = W(), S = Dc(), T) {
        var d = S.queue;
        if (b = d.dispatch, V !== null && (c = V.get(d), c !== void 0)) {
          V.delete(d), d = S.memoizedState;
          do
            d = a(d, c.action), c = c.next;
          while (c !== null);
          return S.memoizedState = d, [d, b];
        }
        return [S.memoizedState, b];
      }
      return a = a === Fc ? typeof b == "function" ? b() : b : c !== void 0 ? c(b) : b, S.memoizedState = a, a = S.queue = { last: null, dispatch: null }, a = a.dispatch = Hc.bind(null, R, a), [S.memoizedState, a];
    }
    function Ic(a, b) {
      if (R = W(), S = Dc(), b = b === void 0 ? null : b, S !== null) {
        var c = S.memoizedState;
        if (c !== null && b !== null) {
          var d = c[1];
          a:
            if (d === null)
              d = !1;
            else {
              for (var f = 0; f < d.length && f < b.length; f++)
                if (!xc(b[f], d[f])) {
                  d = !1;
                  break a;
                }
              d = !0;
            }
          if (d)
            return c[0];
        }
      }
      return a = a(), S.memoizedState = [a, b], a;
    }
    function Hc(a, b, c) {
      if (25 <= Bc)
        throw Error("Too many re-renders. React limits the number of renders to prevent an infinite loop.");
      if (a === R)
        if (Ac = !0, a = { action: c, next: null }, V === null && (V = /* @__PURE__ */ new Map()), c = V.get(b), c === void 0)
          V.set(b, a);
        else {
          for (b = c; b.next !== null; )
            b = b.next;
          b.next = a;
        }
    }
    function Jc() {
      throw Error("startTransition cannot be called during server rendering.");
    }
    function Kc() {
    }
    var Mc = { readContext: function(a) {
      return a._currentValue;
    }, useContext: function(a) {
      return W(), a._currentValue;
    }, useMemo: Ic, useReducer: Gc, useRef: function(a) {
      R = W(), S = Dc();
      var b = S.memoizedState;
      return b === null ? (a = { current: a }, S.memoizedState = a) : b;
    }, useState: function(a) {
      return Gc(Fc, a);
    }, useInsertionEffect: Kc, useLayoutEffect: function() {
    }, useCallback: function(a, b) {
      return Ic(function() {
        return a;
      }, b);
    }, useImperativeHandle: Kc, useEffect: Kc, useDebugValue: Kc, useDeferredValue: function(a) {
      return W(), a;
    }, useTransition: function() {
      return W(), [!1, Jc];
    }, useId: function() {
      var a = yc.treeContext, b = a.overflow;
      a = a.id, a = (a & ~(1 << 32 - sc(a) - 1)).toString(32) + b;
      var c = Lc;
      if (c === null)
        throw Error("Invalid hook call. Hooks can only be called inside of the body of a function component.");
      return b = U++, a = ":" + c.idPrefix + "R" + a, 0 < b && (a += "H" + b.toString(32)), a + ":";
    }, useMutableSource: function(a, b) {
      return W(), b(a._source);
    }, useSyncExternalStore: function(a, b, c) {
      if (c === void 0)
        throw Error("Missing getServerSnapshot, which is required for server-rendered content. Will revert to client rendering.");
      return c();
    } }, Lc = null, Nc = ba.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentDispatcher;
    function Oc(a) {
      return console.error(a), null;
    }
    function X() {
    }
    function Pc(a, b) {
      var c = a.pingedTasks;
      c.push(b), c.length === 1 && setImmediate(function() {
        return Qc(a);
      });
    }
    function Rc(a, b, c, d, f, e, g, h) {
      a.allPendingTasks++, c === null ? a.pendingRootTasks++ : c.pendingTasks++;
      var m = { node: b, ping: function() {
        return Pc(a, m);
      }, blockedBoundary: c, blockedSegment: d, abortSet: f, legacyContext: e, context: g, treeContext: h };
      return f.add(m), m;
    }
    function Sc(a, b, c, d, f, e) {
      return { status: 0, id: -1, index: b, parentFlushed: !1, chunks: [], children: [], formatContext: d, boundary: c, lastPushedText: f, textEmbedded: e };
    }
    function Y(a, b) {
      if (a = a.onError(b), a != null && typeof a != "string")
        throw Error('onError returned something with a type other than "string". onError should return a string and may return null or undefined but must not return anything else. It received something of type "' + typeof a + '" instead');
      return a;
    }
    function Tc(a, b) {
      var c = a.onShellError;
      c(b), c = a.onFatalError, c(b), a.destination !== null ? (a.status = 2, a.destination.destroy(b)) : (a.status = 1, a.fatalError = b);
    }
    function Uc(a, b, c, d, f) {
      for (R = {}, yc = b, U = 0, a = c(d, f); Ac; )
        Ac = !1, U = 0, Bc += 1, S = null, a = c(d, f);
      return Ec(), a;
    }
    function Vc(a, b, c, d) {
      var f = c.render(), e = d.childContextTypes;
      if (e != null) {
        var g = b.legacyContext;
        if (typeof c.getChildContext != "function")
          d = g;
        else {
          c = c.getChildContext();
          for (var h in c)
            if (!(h in e))
              throw Error((gc(d) || "Unknown") + '.getChildContext(): key "' + h + '" is not defined in childContextTypes.');
          d = O({}, g, c);
        }
        b.legacyContext = d, Z(a, b, f), b.legacyContext = g;
      } else
        Z(a, b, f);
    }
    function Wc(a, b) {
      if (a && a.defaultProps) {
        b = O({}, b), a = a.defaultProps;
        for (var c in a)
          b[c] === void 0 && (b[c] = a[c]);
        return b;
      }
      return b;
    }
    function Xc(a, b, c, d, f) {
      if (typeof c == "function")
        if (c.prototype && c.prototype.isReactComponent) {
          f = ic(c, b.legacyContext);
          var e = c.contextType;
          e = new c(d, typeof e == "object" && e !== null ? e._currentValue : f), pc(e, c, d, f), Vc(a, b, e, c);
        } else {
          e = ic(c, b.legacyContext), f = Uc(a, b, c, d, e);
          var g = U !== 0;
          if (typeof f == "object" && f !== null && typeof f.render == "function" && f.$$typeof === void 0)
            pc(f, c, d, e), Vc(a, b, f, c);
          else if (g) {
            d = b.treeContext, b.treeContext = rc(d, 1, 0);
            try {
              Z(a, b, f);
            } finally {
              b.treeContext = d;
            }
          } else
            Z(a, b, f);
        }
      else if (typeof c == "string") {
        switch (f = b.blockedSegment, e = Pa(f.chunks, c, d, a.responseState, f.formatContext), f.lastPushedText = !1, g = f.formatContext, f.formatContext = ya(g, c, d), Yc(a, b, e), f.formatContext = g, c) {
          case "area":
          case "base":
          case "br":
          case "col":
          case "embed":
          case "hr":
          case "img":
          case "input":
          case "keygen":
          case "link":
          case "meta":
          case "param":
          case "source":
          case "track":
          case "wbr":
            break;
          default:
            f.chunks.push(Qa, c, Ra);
        }
        f.lastPushedText = !1;
      } else {
        switch (c) {
          case dc:
          case cc:
          case Tb:
          case Ub:
          case Sb:
            Z(a, b, d.children);
            return;
          case Zb:
            Z(
              a,
              b,
              d.children
            );
            return;
          case bc:
            throw Error("ReactDOMServer does not yet support scope components.");
          case Yb:
            a: {
              c = b.blockedBoundary, f = b.blockedSegment, e = d.fallback, d = d.children, g = /* @__PURE__ */ new Set();
              var h = { id: null, rootSegmentID: -1, parentFlushed: !1, pendingTasks: 0, forceClientRender: !1, completedSegments: [], byteSize: 0, fallbackAbortableTasks: g, errorDigest: null }, m = Sc(a, f.chunks.length, h, f.formatContext, !1, !1);
              f.children.push(m), f.lastPushedText = !1;
              var n = Sc(a, 0, null, f.formatContext, !1, !1);
              n.parentFlushed = !0, b.blockedBoundary = h, b.blockedSegment = n;
              try {
                if (Yc(a, b, d), n.lastPushedText && n.textEmbedded && n.chunks.push(za), n.status = 1, Zc(h, n), h.pendingTasks === 0)
                  break a;
              } catch (p) {
                n.status = 4, h.forceClientRender = !0, h.errorDigest = Y(a, p);
              } finally {
                b.blockedBoundary = c, b.blockedSegment = f;
              }
              b = Rc(a, e, c, m, g, b.legacyContext, b.context, b.treeContext), a.pingedTasks.push(b);
            }
            return;
        }
        if (typeof c == "object" && c !== null)
          switch (c.$$typeof) {
            case Xb:
              if (d = Uc(a, b, c.render, d, f), U !== 0) {
                c = b.treeContext, b.treeContext = rc(c, 1, 0);
                try {
                  Z(a, b, d);
                } finally {
                  b.treeContext = c;
                }
              } else
                Z(
                  a,
                  b,
                  d
                );
              return;
            case $b:
              c = c.type, d = Wc(c, d), Xc(a, b, c, d, f);
              return;
            case Vb:
              if (f = d.children, c = c._context, d = d.value, e = c._currentValue, c._currentValue = d, g = P, P = d = { parent: g, depth: g === null ? 0 : g.depth + 1, context: c, parentValue: e, value: d }, b.context = d, Z(a, b, f), a = P, a === null)
                throw Error("Tried to pop a Context at the root of the app. This is a bug in React.");
              d = a.parentValue, a.context._currentValue = d === ec ? a.context._defaultValue : d, a = P = a.parent, b.context = a;
              return;
            case Wb:
              d = d.children, d = d(c._currentValue), Z(a, b, d);
              return;
            case ac:
              f = c._init, c = f(c._payload), d = Wc(c, d), Xc(a, b, c, d, void 0);
              return;
          }
        throw Error("Element type is invalid: expected a string (for built-in components) or a class/function (for composite components) but got: " + ((c == null ? c : typeof c) + "."));
      }
    }
    function Z(a, b, c) {
      if (b.node = c, typeof c == "object" && c !== null) {
        switch (c.$$typeof) {
          case Qb:
            Xc(a, b, c.type, c.props, c.ref);
            return;
          case Rb:
            throw Error("Portals are not currently supported by the server renderer. Render them conditionally so that they only appear on the client render.");
          case ac:
            var d = c._init;
            c = d(c._payload), Z(a, b, c);
            return;
        }
        if (qa(c)) {
          $c(a, b, c);
          return;
        }
        if (c === null || typeof c != "object" ? d = null : (d = fc && c[fc] || c["@@iterator"], d = typeof d == "function" ? d : null), d && (d = d.call(c))) {
          if (c = d.next(), !c.done) {
            var f = [];
            do
              f.push(c.value), c = d.next();
            while (!c.done);
            $c(a, b, f);
          }
          return;
        }
        throw a = Object.prototype.toString.call(c), Error("Objects are not valid as a React child (found: " + (a === "[object Object]" ? "object with keys {" + Object.keys(c).join(", ") + "}" : a) + "). If you meant to render a collection of children, use an array instead.");
      }
      typeof c == "string" ? (d = b.blockedSegment, d.lastPushedText = Aa(b.blockedSegment.chunks, c, a.responseState, d.lastPushedText)) : typeof c == "number" && (d = b.blockedSegment, d.lastPushedText = Aa(
        b.blockedSegment.chunks,
        "" + c,
        a.responseState,
        d.lastPushedText
      ));
    }
    function $c(a, b, c) {
      for (var d = c.length, f = 0; f < d; f++) {
        var e = b.treeContext;
        b.treeContext = rc(e, d, f);
        try {
          Yc(a, b, c[f]);
        } finally {
          b.treeContext = e;
        }
      }
    }
    function Yc(a, b, c) {
      var d = b.blockedSegment.formatContext, f = b.legacyContext, e = b.context;
      try {
        return Z(a, b, c);
      } catch (m) {
        if (Ec(), typeof m == "object" && m !== null && typeof m.then == "function") {
          c = m;
          var g = b.blockedSegment, h = Sc(a, g.chunks.length, null, g.formatContext, g.lastPushedText, !0);
          g.children.push(h), g.lastPushedText = !1, a = Rc(a, b.node, b.blockedBoundary, h, b.abortSet, b.legacyContext, b.context, b.treeContext).ping, c.then(a, a), b.blockedSegment.formatContext = d, b.legacyContext = f, b.context = e, nc(e);
        } else
          throw b.blockedSegment.formatContext = d, b.legacyContext = f, b.context = e, nc(e), m;
      }
    }
    function ad(a) {
      var b = a.blockedBoundary;
      a = a.blockedSegment, a.status = 3, bd(this, b, a);
    }
    function cd(a, b, c) {
      var d = a.blockedBoundary;
      a.blockedSegment.status = 3, d === null ? (b.allPendingTasks--, b.status !== 2 && (b.status = 2, b.destination !== null && b.destination.end())) : (d.pendingTasks--, d.forceClientRender || (d.forceClientRender = !0, d.errorDigest = b.onError(c === void 0 ? Error("The render was aborted by the server without a reason.") : c), d.parentFlushed && b.clientRenderedBoundaries.push(d)), d.fallbackAbortableTasks.forEach(function(a2) {
        return cd(a2, b, c);
      }), d.fallbackAbortableTasks.clear(), b.allPendingTasks--, b.allPendingTasks === 0 && (a = b.onAllReady, a()));
    }
    function Zc(a, b) {
      if (b.chunks.length === 0 && b.children.length === 1 && b.children[0].boundary === null) {
        var c = b.children[0];
        c.id = b.id, c.parentFlushed = !0, c.status === 1 && Zc(a, c);
      } else
        a.completedSegments.push(b);
    }
    function bd(a, b, c) {
      if (b === null) {
        if (c.parentFlushed) {
          if (a.completedRootSegment !== null)
            throw Error("There can only be one root segment. This is a bug in React.");
          a.completedRootSegment = c;
        }
        a.pendingRootTasks--, a.pendingRootTasks === 0 && (a.onShellError = X, b = a.onShellReady, b());
      } else
        b.pendingTasks--, b.forceClientRender || (b.pendingTasks === 0 ? (c.parentFlushed && c.status === 1 && Zc(b, c), b.parentFlushed && a.completedBoundaries.push(b), b.fallbackAbortableTasks.forEach(ad, a), b.fallbackAbortableTasks.clear()) : c.parentFlushed && c.status === 1 && (Zc(b, c), b.completedSegments.length === 1 && b.parentFlushed && a.partialBoundaries.push(b)));
      a.allPendingTasks--, a.allPendingTasks === 0 && (a = a.onAllReady, a());
    }
    function Qc(a) {
      if (a.status !== 2) {
        var b = P, c = Nc.current;
        Nc.current = Mc;
        var d = Lc;
        Lc = a.responseState;
        try {
          var f = a.pingedTasks, e;
          for (e = 0; e < f.length; e++) {
            var g = f[e], h = a, m = g.blockedSegment;
            if (m.status === 0) {
              nc(g.context);
              try {
                Z(h, g, g.node), m.lastPushedText && m.textEmbedded && m.chunks.push(za), g.abortSet.delete(g), m.status = 1, bd(h, g.blockedBoundary, m);
              } catch (E) {
                if (Ec(), typeof E == "object" && E !== null && typeof E.then == "function") {
                  var n = g.ping;
                  E.then(n, n);
                } else {
                  g.abortSet.delete(g), m.status = 4;
                  var p = g.blockedBoundary, v = E, C = Y(h, v);
                  if (p === null ? Tc(h, v) : (p.pendingTasks--, p.forceClientRender || (p.forceClientRender = !0, p.errorDigest = C, p.parentFlushed && h.clientRenderedBoundaries.push(p))), h.allPendingTasks--, h.allPendingTasks === 0) {
                    var D = h.onAllReady;
                    D();
                  }
                }
              } finally {
              }
            }
          }
          f.splice(0, e), a.destination !== null && dd(a, a.destination);
        } catch (E) {
          Y(a, E), Tc(a, E);
        } finally {
          Lc = d, Nc.current = c, c === Mc && nc(b);
        }
      }
    }
    function ed(a, b, c) {
      switch (c.parentFlushed = !0, c.status) {
        case 0:
          var d = c.id = a.nextSegmentId++;
          return c.lastPushedText = !1, c.textEmbedded = !1, a = a.responseState, r2(b, Sa), r2(b, a.placeholderPrefix), a = d.toString(16), r2(b, a), w(b, Ta);
        case 1:
          c.status = 2;
          var f = !0;
          d = c.chunks;
          var e = 0;
          c = c.children;
          for (var g = 0; g < c.length; g++) {
            for (f = c[g]; e < f.index; e++)
              r2(b, d[e]);
            f = fd(a, b, f);
          }
          for (; e < d.length - 1; e++)
            r2(b, d[e]);
          return e < d.length && (f = w(b, d[e])), f;
        default:
          throw Error("Aborted, errored or already flushed boundaries should not be flushed again. This is a bug in React.");
      }
    }
    function fd(a, b, c) {
      var d = c.boundary;
      if (d === null)
        return ed(a, b, c);
      if (d.parentFlushed = !0, d.forceClientRender)
        d = d.errorDigest, w(b, Xa), r2(b, Za), d && (r2(b, ab), r2(b, F(d)), r2(b, $a)), w(b, bb), ed(a, b, c);
      else if (0 < d.pendingTasks) {
        d.rootSegmentID = a.nextSegmentId++, 0 < d.completedSegments.length && a.partialBoundaries.push(d);
        var f = a.responseState, e = f.nextSuspenseID++;
        f = x(f.boundaryPrefix + e.toString(16)), d = d.id = f, cb(b, a.responseState, d), ed(a, b, c);
      } else if (d.byteSize > a.progressiveChunkSize)
        d.rootSegmentID = a.nextSegmentId++, a.completedBoundaries.push(d), cb(b, a.responseState, d.id), ed(a, b, c);
      else {
        if (w(b, Ua), c = d.completedSegments, c.length !== 1)
          throw Error("A previously unvisited boundary must have exactly one root segment. This is a bug in React.");
        fd(a, b, c[0]);
      }
      return w(b, Ya);
    }
    function gd(a, b, c) {
      return yb(b, a.responseState, c.formatContext, c.id), fd(a, b, c), zb(b, c.formatContext);
    }
    function hd(a, b, c) {
      for (var d = c.completedSegments, f = 0; f < d.length; f++)
        id(a, b, c, d[f]);
      if (d.length = 0, a = a.responseState, d = c.id, c = c.rootSegmentID, r2(b, a.startInlineScript), a.sentCompleteBoundaryFunction ? r2(b, Gb) : (a.sentCompleteBoundaryFunction = !0, r2(b, Fb)), d === null)
        throw Error("An ID must have been assigned before we can complete the boundary.");
      return c = c.toString(16), r2(b, d), r2(b, Hb), r2(b, a.segmentPrefix), r2(b, c), w(b, Ib);
    }
    function id(a, b, c, d) {
      if (d.status === 2)
        return !0;
      var f = d.id;
      if (f === -1) {
        if ((d.id = c.rootSegmentID) === -1)
          throw Error("A root segment ID must have been assigned by now. This is a bug in React.");
        return gd(a, b, d);
      }
      return gd(a, b, d), a = a.responseState, r2(b, a.startInlineScript), a.sentCompleteSegmentFunction ? r2(b, Bb) : (a.sentCompleteSegmentFunction = !0, r2(b, Ab)), r2(b, a.segmentPrefix), f = f.toString(16), r2(b, f), r2(b, Cb), r2(b, a.placeholderPrefix), r2(b, f), w(b, Db);
    }
    function dd(a, b) {
      k = new Uint8Array(2048), l = 0, q = !0;
      try {
        var c = a.completedRootSegment;
        if (c !== null && a.pendingRootTasks === 0) {
          fd(a, b, c), a.completedRootSegment = null;
          var d = a.responseState.bootstrapChunks;
          for (c = 0; c < d.length - 1; c++)
            r2(b, d[c]);
          c < d.length && w(b, d[c]);
        }
        var f = a.clientRenderedBoundaries, e;
        for (e = 0; e < f.length; e++) {
          var g = f[e];
          d = b;
          var h = a.responseState, m = g.id, n = g.errorDigest, p = g.errorMessage, v = g.errorComponentStack;
          if (r2(d, h.startInlineScript), h.sentClientRenderFunction ? r2(d, Kb) : (h.sentClientRenderFunction = !0, r2(d, Jb)), m === null)
            throw Error("An ID must have been assigned before we can complete the boundary.");
          if (r2(d, m), r2(d, Lb), (n || p || v) && (r2(d, Nb), r2(d, Pb(n || ""))), (p || v) && (r2(d, Nb), r2(d, Pb(p || ""))), v && (r2(d, Nb), r2(d, Pb(v))), !w(d, Mb)) {
            a.destination = null, e++, f.splice(0, e);
            return;
          }
        }
        f.splice(0, e);
        var C = a.completedBoundaries;
        for (e = 0; e < C.length; e++)
          if (!hd(a, b, C[e])) {
            a.destination = null, e++, C.splice(0, e);
            return;
          }
        C.splice(0, e), ca(b), k = new Uint8Array(2048), l = 0, q = !0;
        var D = a.partialBoundaries;
        for (e = 0; e < D.length; e++) {
          var E = D[e];
          a: {
            f = a, g = b;
            var na = E.completedSegments;
            for (h = 0; h < na.length; h++)
              if (!id(f, g, E, na[h])) {
                h++, na.splice(0, h);
                var Eb = !1;
                break a;
              }
            na.splice(0, h), Eb = !0;
          }
          if (!Eb) {
            a.destination = null, e++, D.splice(0, e);
            return;
          }
        }
        D.splice(0, e);
        var oa = a.completedBoundaries;
        for (e = 0; e < oa.length; e++)
          if (!hd(a, b, oa[e])) {
            a.destination = null, e++, oa.splice(0, e);
            return;
          }
        oa.splice(0, e);
      } finally {
        ca(b), typeof b.flush == "function" && b.flush(), a.allPendingTasks === 0 && a.pingedTasks.length === 0 && a.clientRenderedBoundaries.length === 0 && a.completedBoundaries.length === 0 && b.end();
      }
    }
    function jd(a) {
      setImmediate(function() {
        return Qc(a);
      });
    }
    function kd(a, b) {
      if (a.status === 1)
        a.status = 2, b.destroy(a.fatalError);
      else if (a.status !== 2 && a.destination === null) {
        a.destination = b;
        try {
          dd(a, b);
        } catch (c) {
          Y(a, c), Tc(a, c);
        }
      }
    }
    function ld(a, b) {
      try {
        var c = a.abortableTasks;
        c.forEach(function(c2) {
          return cd(c2, a, b);
        }), c.clear(), a.destination !== null && dd(a, a.destination);
      } catch (d) {
        Y(a, d), Tc(a, d);
      }
    }
    function md(a, b) {
      return function() {
        return kd(b, a);
      };
    }
    function nd(a, b) {
      return function() {
        return ld(a, b);
      };
    }
    function od(a, b) {
      var c = b ? b.identifierPrefix : void 0, d = b ? b.nonce : void 0, f = b ? b.bootstrapScriptContent : void 0, e = b ? b.bootstrapScripts : void 0, g = b ? b.bootstrapModules : void 0;
      c = c === void 0 ? "" : c, d = d === void 0 ? ra : x('<script nonce="' + F(d) + '">');
      var h = [];
      if (f !== void 0 && h.push(d, ("" + f).replace(wa, xa), sa), e !== void 0)
        for (f = 0; f < e.length; f++)
          h.push(ta, F(e[f]), va);
      if (g !== void 0)
        for (e = 0; e < g.length; e++)
          h.push(ua, F(g[e]), va);
      g = {
        bootstrapChunks: h,
        startInlineScript: d,
        placeholderPrefix: x(c + "P:"),
        segmentPrefix: x(c + "S:"),
        boundaryPrefix: c + "B:",
        idPrefix: c,
        nextSuspenseID: 0,
        sentCompleteSegmentFunction: !1,
        sentCompleteBoundaryFunction: !1,
        sentClientRenderFunction: !1
      }, e = b ? b.namespaceURI : void 0, e = G(e === "http://www.w3.org/2000/svg" ? 2 : e === "http://www.w3.org/1998/Math/MathML" ? 3 : 0, null), f = b ? b.progressiveChunkSize : void 0, d = b ? b.onError : void 0, h = b ? b.onAllReady : void 0;
      var m = b ? b.onShellReady : void 0, n = b ? b.onShellError : void 0;
      return b = [], c = /* @__PURE__ */ new Set(), g = {
        destination: null,
        responseState: g,
        progressiveChunkSize: f === void 0 ? 12800 : f,
        status: 0,
        fatalError: null,
        nextSegmentId: 0,
        allPendingTasks: 0,
        pendingRootTasks: 0,
        completedRootSegment: null,
        abortableTasks: c,
        pingedTasks: b,
        clientRenderedBoundaries: [],
        completedBoundaries: [],
        partialBoundaries: [],
        onError: d === void 0 ? Oc : d,
        onAllReady: h === void 0 ? X : h,
        onShellReady: m === void 0 ? X : m,
        onShellError: n === void 0 ? X : n,
        onFatalError: X
      }, e = Sc(g, 0, null, e, !1, !1), e.parentFlushed = !0, a = Rc(g, a, null, e, c, hc, null, qc), b.push(a), g;
    }
    exports.renderToPipeableStream = function(a, b) {
      var c = od(a, b), d = !1;
      return jd(c), { pipe: function(a2) {
        if (d)
          throw Error("React currently only supports piping to one writable stream.");
        return d = !0, kd(c, a2), a2.on("drain", md(a2, c)), a2.on("error", nd(c, Error("The destination stream errored while writing data."))), a2.on("close", nd(c, Error("The destination stream closed early."))), a2;
      }, abort: function(a2) {
        ld(c, a2);
      } };
    };
    exports.version = "18.2.0";
  }
});

// ../../node_modules/.pnpm/react-dom@18.2.0_react@18.2.0/node_modules/react-dom/cjs/react-dom-server-legacy.node.development.js
var require_react_dom_server_legacy_node_development = __commonJS({
  "../../node_modules/.pnpm/react-dom@18.2.0_react@18.2.0/node_modules/react-dom/cjs/react-dom-server-legacy.node.development.js"(exports) {
    "use strict";
    init_cjs_shims();
    process.env.NODE_ENV !== "production" && function() {
      "use strict";
      var React12 = require_react(), stream2 = __require("stream"), ReactVersion = "18.2.0", ReactSharedInternals = React12.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
      function warn(format4) {
        {
          for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++)
            args[_key - 1] = arguments[_key];
          printWarning("warn", format4, args);
        }
      }
      function error(format4) {
        {
          for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++)
            args[_key2 - 1] = arguments[_key2];
          printWarning("error", format4, args);
        }
      }
      function printWarning(level, format4, args) {
        {
          var ReactDebugCurrentFrame2 = ReactSharedInternals.ReactDebugCurrentFrame, stack = ReactDebugCurrentFrame2.getStackAddendum();
          stack !== "" && (format4 += "%s", args = args.concat([stack]));
          var argsWithFormat = args.map(function(item) {
            return String(item);
          });
          argsWithFormat.unshift("Warning: " + format4), Function.prototype.apply.call(console[level], console, argsWithFormat);
        }
      }
      function scheduleWork(callback) {
        callback();
      }
      function beginWriting(destination) {
      }
      function writeChunk(destination, chunk) {
        writeChunkAndReturn(destination, chunk);
      }
      function writeChunkAndReturn(destination, chunk) {
        return destination.push(chunk);
      }
      function completeWriting(destination) {
      }
      function close(destination) {
        destination.push(null);
      }
      function stringToChunk(content) {
        return content;
      }
      function stringToPrecomputedChunk(content) {
        return content;
      }
      function closeWithError(destination, error2) {
        destination.destroy(error2);
      }
      function typeName(value) {
        {
          var hasToStringTag = typeof Symbol == "function" && Symbol.toStringTag, type = hasToStringTag && value[Symbol.toStringTag] || value.constructor.name || "Object";
          return type;
        }
      }
      function willCoercionThrow(value) {
        try {
          return testStringCoercion(value), !1;
        } catch {
          return !0;
        }
      }
      function testStringCoercion(value) {
        return "" + value;
      }
      function checkAttributeStringCoercion(value, attributeName) {
        if (willCoercionThrow(value))
          return error("The provided `%s` attribute is an unsupported type %s. This value must be coerced to a string before before using it here.", attributeName, typeName(value)), testStringCoercion(value);
      }
      function checkCSSPropertyStringCoercion(value, propName) {
        if (willCoercionThrow(value))
          return error("The provided `%s` CSS property is an unsupported type %s. This value must be coerced to a string before before using it here.", propName, typeName(value)), testStringCoercion(value);
      }
      function checkHtmlStringCoercion(value) {
        if (willCoercionThrow(value))
          return error("The provided HTML markup uses a value of unsupported type %s. This value must be coerced to a string before before using it here.", typeName(value)), testStringCoercion(value);
      }
      var hasOwnProperty = Object.prototype.hasOwnProperty, RESERVED = 0, STRING = 1, BOOLEANISH_STRING = 2, BOOLEAN = 3, OVERLOADED_BOOLEAN = 4, NUMERIC = 5, POSITIVE_NUMERIC = 6, ATTRIBUTE_NAME_START_CHAR = ":A-Z_a-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD", ATTRIBUTE_NAME_CHAR = ATTRIBUTE_NAME_START_CHAR + "\\-.0-9\\u00B7\\u0300-\\u036F\\u203F-\\u2040", VALID_ATTRIBUTE_NAME_REGEX = new RegExp("^[" + ATTRIBUTE_NAME_START_CHAR + "][" + ATTRIBUTE_NAME_CHAR + "]*$"), illegalAttributeNameCache = {}, validatedAttributeNameCache = {};
      function isAttributeNameSafe(attributeName) {
        return hasOwnProperty.call(validatedAttributeNameCache, attributeName) ? !0 : hasOwnProperty.call(illegalAttributeNameCache, attributeName) ? !1 : VALID_ATTRIBUTE_NAME_REGEX.test(attributeName) ? (validatedAttributeNameCache[attributeName] = !0, !0) : (illegalAttributeNameCache[attributeName] = !0, error("Invalid attribute name: `%s`", attributeName), !1);
      }
      function shouldRemoveAttributeWithWarning(name, value, propertyInfo, isCustomComponentTag) {
        if (propertyInfo !== null && propertyInfo.type === RESERVED)
          return !1;
        switch (typeof value) {
          case "function":
          case "symbol":
            return !0;
          case "boolean": {
            if (isCustomComponentTag)
              return !1;
            if (propertyInfo !== null)
              return !propertyInfo.acceptsBooleans;
            var prefix2 = name.toLowerCase().slice(0, 5);
            return prefix2 !== "data-" && prefix2 !== "aria-";
          }
          default:
            return !1;
        }
      }
      function getPropertyInfo(name) {
        return properties.hasOwnProperty(name) ? properties[name] : null;
      }
      function PropertyInfoRecord(name, type, mustUseProperty, attributeName, attributeNamespace, sanitizeURL2, removeEmptyString) {
        this.acceptsBooleans = type === BOOLEANISH_STRING || type === BOOLEAN || type === OVERLOADED_BOOLEAN, this.attributeName = attributeName, this.attributeNamespace = attributeNamespace, this.mustUseProperty = mustUseProperty, this.propertyName = name, this.type = type, this.sanitizeURL = sanitizeURL2, this.removeEmptyString = removeEmptyString;
      }
      var properties = {}, reservedProps = [
        "children",
        "dangerouslySetInnerHTML",
        // TODO: This prevents the assignment of defaultValue to regular
        // elements (not just inputs). Now that ReactDOMInput assigns to the
        // defaultValue property -- do we need this?
        "defaultValue",
        "defaultChecked",
        "innerHTML",
        "suppressContentEditableWarning",
        "suppressHydrationWarning",
        "style"
      ];
      reservedProps.forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          RESERVED,
          !1,
          // mustUseProperty
          name,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [["acceptCharset", "accept-charset"], ["className", "class"], ["htmlFor", "for"], ["httpEquiv", "http-equiv"]].forEach(function(_ref) {
        var name = _ref[0], attributeName = _ref[1];
        properties[name] = new PropertyInfoRecord(
          name,
          STRING,
          !1,
          // mustUseProperty
          attributeName,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), ["contentEditable", "draggable", "spellCheck", "value"].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          BOOLEANISH_STRING,
          !1,
          // mustUseProperty
          name.toLowerCase(),
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), ["autoReverse", "externalResourcesRequired", "focusable", "preserveAlpha"].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          BOOLEANISH_STRING,
          !1,
          // mustUseProperty
          name,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "allowFullScreen",
        "async",
        // Note: there is a special case that prevents it from being written to the DOM
        // on the client side because the browsers are inconsistent. Instead we call focus().
        "autoFocus",
        "autoPlay",
        "controls",
        "default",
        "defer",
        "disabled",
        "disablePictureInPicture",
        "disableRemotePlayback",
        "formNoValidate",
        "hidden",
        "loop",
        "noModule",
        "noValidate",
        "open",
        "playsInline",
        "readOnly",
        "required",
        "reversed",
        "scoped",
        "seamless",
        // Microdata
        "itemScope"
      ].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          BOOLEAN,
          !1,
          // mustUseProperty
          name.toLowerCase(),
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "checked",
        // Note: `option.selected` is not updated if `select.multiple` is
        // disabled with `removeAttribute`. We have special logic for handling this.
        "multiple",
        "muted",
        "selected"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          BOOLEAN,
          !0,
          // mustUseProperty
          name,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "capture",
        "download"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          OVERLOADED_BOOLEAN,
          !1,
          // mustUseProperty
          name,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "cols",
        "rows",
        "size",
        "span"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          POSITIVE_NUMERIC,
          !1,
          // mustUseProperty
          name,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), ["rowSpan", "start"].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          NUMERIC,
          !1,
          // mustUseProperty
          name.toLowerCase(),
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      });
      var CAMELIZE = /[\-\:]([a-z])/g, capitalize2 = function(token) {
        return token[1].toUpperCase();
      };
      [
        "accent-height",
        "alignment-baseline",
        "arabic-form",
        "baseline-shift",
        "cap-height",
        "clip-path",
        "clip-rule",
        "color-interpolation",
        "color-interpolation-filters",
        "color-profile",
        "color-rendering",
        "dominant-baseline",
        "enable-background",
        "fill-opacity",
        "fill-rule",
        "flood-color",
        "flood-opacity",
        "font-family",
        "font-size",
        "font-size-adjust",
        "font-stretch",
        "font-style",
        "font-variant",
        "font-weight",
        "glyph-name",
        "glyph-orientation-horizontal",
        "glyph-orientation-vertical",
        "horiz-adv-x",
        "horiz-origin-x",
        "image-rendering",
        "letter-spacing",
        "lighting-color",
        "marker-end",
        "marker-mid",
        "marker-start",
        "overline-position",
        "overline-thickness",
        "paint-order",
        "panose-1",
        "pointer-events",
        "rendering-intent",
        "shape-rendering",
        "stop-color",
        "stop-opacity",
        "strikethrough-position",
        "strikethrough-thickness",
        "stroke-dasharray",
        "stroke-dashoffset",
        "stroke-linecap",
        "stroke-linejoin",
        "stroke-miterlimit",
        "stroke-opacity",
        "stroke-width",
        "text-anchor",
        "text-decoration",
        "text-rendering",
        "underline-position",
        "underline-thickness",
        "unicode-bidi",
        "unicode-range",
        "units-per-em",
        "v-alphabetic",
        "v-hanging",
        "v-ideographic",
        "v-mathematical",
        "vector-effect",
        "vert-adv-y",
        "vert-origin-x",
        "vert-origin-y",
        "word-spacing",
        "writing-mode",
        "xmlns:xlink",
        "x-height"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(attributeName) {
        var name = attributeName.replace(CAMELIZE, capitalize2);
        properties[name] = new PropertyInfoRecord(
          name,
          STRING,
          !1,
          // mustUseProperty
          attributeName,
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "xlink:actuate",
        "xlink:arcrole",
        "xlink:role",
        "xlink:show",
        "xlink:title",
        "xlink:type"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(attributeName) {
        var name = attributeName.replace(CAMELIZE, capitalize2);
        properties[name] = new PropertyInfoRecord(
          name,
          STRING,
          !1,
          // mustUseProperty
          attributeName,
          "http://www.w3.org/1999/xlink",
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "xml:base",
        "xml:lang",
        "xml:space"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(attributeName) {
        var name = attributeName.replace(CAMELIZE, capitalize2);
        properties[name] = new PropertyInfoRecord(
          name,
          STRING,
          !1,
          // mustUseProperty
          attributeName,
          "http://www.w3.org/XML/1998/namespace",
          !1,
          // sanitizeURL
          !1
        );
      }), ["tabIndex", "crossOrigin"].forEach(function(attributeName) {
        properties[attributeName] = new PropertyInfoRecord(
          attributeName,
          STRING,
          !1,
          // mustUseProperty
          attributeName.toLowerCase(),
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      });
      var xlinkHref = "xlinkHref";
      properties[xlinkHref] = new PropertyInfoRecord(
        "xlinkHref",
        STRING,
        !1,
        // mustUseProperty
        "xlink:href",
        "http://www.w3.org/1999/xlink",
        !0,
        // sanitizeURL
        !1
      ), ["src", "href", "action", "formAction"].forEach(function(attributeName) {
        properties[attributeName] = new PropertyInfoRecord(
          attributeName,
          STRING,
          !1,
          // mustUseProperty
          attributeName.toLowerCase(),
          // attributeName
          null,
          // attributeNamespace
          !0,
          // sanitizeURL
          !0
        );
      });
      var isUnitlessNumber = {
        animationIterationCount: !0,
        aspectRatio: !0,
        borderImageOutset: !0,
        borderImageSlice: !0,
        borderImageWidth: !0,
        boxFlex: !0,
        boxFlexGroup: !0,
        boxOrdinalGroup: !0,
        columnCount: !0,
        columns: !0,
        flex: !0,
        flexGrow: !0,
        flexPositive: !0,
        flexShrink: !0,
        flexNegative: !0,
        flexOrder: !0,
        gridArea: !0,
        gridRow: !0,
        gridRowEnd: !0,
        gridRowSpan: !0,
        gridRowStart: !0,
        gridColumn: !0,
        gridColumnEnd: !0,
        gridColumnSpan: !0,
        gridColumnStart: !0,
        fontWeight: !0,
        lineClamp: !0,
        lineHeight: !0,
        opacity: !0,
        order: !0,
        orphans: !0,
        tabSize: !0,
        widows: !0,
        zIndex: !0,
        zoom: !0,
        // SVG-related properties
        fillOpacity: !0,
        floodOpacity: !0,
        stopOpacity: !0,
        strokeDasharray: !0,
        strokeDashoffset: !0,
        strokeMiterlimit: !0,
        strokeOpacity: !0,
        strokeWidth: !0
      };
      function prefixKey(prefix2, key) {
        return prefix2 + key.charAt(0).toUpperCase() + key.substring(1);
      }
      var prefixes = ["Webkit", "ms", "Moz", "O"];
      Object.keys(isUnitlessNumber).forEach(function(prop) {
        prefixes.forEach(function(prefix2) {
          isUnitlessNumber[prefixKey(prefix2, prop)] = isUnitlessNumber[prop];
        });
      });
      var hasReadOnlyValue = {
        button: !0,
        checkbox: !0,
        image: !0,
        hidden: !0,
        radio: !0,
        reset: !0,
        submit: !0
      };
      function checkControlledValueProps(tagName, props) {
        hasReadOnlyValue[props.type] || props.onChange || props.onInput || props.readOnly || props.disabled || props.value == null || error("You provided a `value` prop to a form field without an `onChange` handler. This will render a read-only field. If the field should be mutable use `defaultValue`. Otherwise, set either `onChange` or `readOnly`."), props.onChange || props.readOnly || props.disabled || props.checked == null || error("You provided a `checked` prop to a form field without an `onChange` handler. This will render a read-only field. If the field should be mutable use `defaultChecked`. Otherwise, set either `onChange` or `readOnly`.");
      }
      function isCustomComponent(tagName, props) {
        if (tagName.indexOf("-") === -1)
          return typeof props.is == "string";
        switch (tagName) {
          case "annotation-xml":
          case "color-profile":
          case "font-face":
          case "font-face-src":
          case "font-face-uri":
          case "font-face-format":
          case "font-face-name":
          case "missing-glyph":
            return !1;
          default:
            return !0;
        }
      }
      var ariaProperties = {
        "aria-current": 0,
        // state
        "aria-description": 0,
        "aria-details": 0,
        "aria-disabled": 0,
        // state
        "aria-hidden": 0,
        // state
        "aria-invalid": 0,
        // state
        "aria-keyshortcuts": 0,
        "aria-label": 0,
        "aria-roledescription": 0,
        // Widget Attributes
        "aria-autocomplete": 0,
        "aria-checked": 0,
        "aria-expanded": 0,
        "aria-haspopup": 0,
        "aria-level": 0,
        "aria-modal": 0,
        "aria-multiline": 0,
        "aria-multiselectable": 0,
        "aria-orientation": 0,
        "aria-placeholder": 0,
        "aria-pressed": 0,
        "aria-readonly": 0,
        "aria-required": 0,
        "aria-selected": 0,
        "aria-sort": 0,
        "aria-valuemax": 0,
        "aria-valuemin": 0,
        "aria-valuenow": 0,
        "aria-valuetext": 0,
        // Live Region Attributes
        "aria-atomic": 0,
        "aria-busy": 0,
        "aria-live": 0,
        "aria-relevant": 0,
        // Drag-and-Drop Attributes
        "aria-dropeffect": 0,
        "aria-grabbed": 0,
        // Relationship Attributes
        "aria-activedescendant": 0,
        "aria-colcount": 0,
        "aria-colindex": 0,
        "aria-colspan": 0,
        "aria-controls": 0,
        "aria-describedby": 0,
        "aria-errormessage": 0,
        "aria-flowto": 0,
        "aria-labelledby": 0,
        "aria-owns": 0,
        "aria-posinset": 0,
        "aria-rowcount": 0,
        "aria-rowindex": 0,
        "aria-rowspan": 0,
        "aria-setsize": 0
      }, warnedProperties = {}, rARIA = new RegExp("^(aria)-[" + ATTRIBUTE_NAME_CHAR + "]*$"), rARIACamel = new RegExp("^(aria)[A-Z][" + ATTRIBUTE_NAME_CHAR + "]*$");
      function validateProperty(tagName, name) {
        {
          if (hasOwnProperty.call(warnedProperties, name) && warnedProperties[name])
            return !0;
          if (rARIACamel.test(name)) {
            var ariaName = "aria-" + name.slice(4).toLowerCase(), correctName = ariaProperties.hasOwnProperty(ariaName) ? ariaName : null;
            if (correctName == null)
              return error("Invalid ARIA attribute `%s`. ARIA attributes follow the pattern aria-* and must be lowercase.", name), warnedProperties[name] = !0, !0;
            if (name !== correctName)
              return error("Invalid ARIA attribute `%s`. Did you mean `%s`?", name, correctName), warnedProperties[name] = !0, !0;
          }
          if (rARIA.test(name)) {
            var lowerCasedName = name.toLowerCase(), standardName = ariaProperties.hasOwnProperty(lowerCasedName) ? lowerCasedName : null;
            if (standardName == null)
              return warnedProperties[name] = !0, !1;
            if (name !== standardName)
              return error("Unknown ARIA attribute `%s`. Did you mean `%s`?", name, standardName), warnedProperties[name] = !0, !0;
          }
        }
        return !0;
      }
      function warnInvalidARIAProps(type, props) {
        {
          var invalidProps = [];
          for (var key in props) {
            var isValid = validateProperty(type, key);
            isValid || invalidProps.push(key);
          }
          var unknownPropString = invalidProps.map(function(prop) {
            return "`" + prop + "`";
          }).join(", ");
          invalidProps.length === 1 ? error("Invalid aria prop %s on <%s> tag. For details, see https://reactjs.org/link/invalid-aria-props", unknownPropString, type) : invalidProps.length > 1 && error("Invalid aria props %s on <%s> tag. For details, see https://reactjs.org/link/invalid-aria-props", unknownPropString, type);
        }
      }
      function validateProperties(type, props) {
        isCustomComponent(type, props) || warnInvalidARIAProps(type, props);
      }
      var didWarnValueNull = !1;
      function validateProperties$1(type, props) {
        {
          if (type !== "input" && type !== "textarea" && type !== "select")
            return;
          props != null && props.value === null && !didWarnValueNull && (didWarnValueNull = !0, type === "select" && props.multiple ? error("`value` prop on `%s` should not be null. Consider using an empty array when `multiple` is set to `true` to clear the component or `undefined` for uncontrolled components.", type) : error("`value` prop on `%s` should not be null. Consider using an empty string to clear the component or `undefined` for uncontrolled components.", type));
        }
      }
      var possibleStandardNames = {
        // HTML
        accept: "accept",
        acceptcharset: "acceptCharset",
        "accept-charset": "acceptCharset",
        accesskey: "accessKey",
        action: "action",
        allowfullscreen: "allowFullScreen",
        alt: "alt",
        as: "as",
        async: "async",
        autocapitalize: "autoCapitalize",
        autocomplete: "autoComplete",
        autocorrect: "autoCorrect",
        autofocus: "autoFocus",
        autoplay: "autoPlay",
        autosave: "autoSave",
        capture: "capture",
        cellpadding: "cellPadding",
        cellspacing: "cellSpacing",
        challenge: "challenge",
        charset: "charSet",
        checked: "checked",
        children: "children",
        cite: "cite",
        class: "className",
        classid: "classID",
        classname: "className",
        cols: "cols",
        colspan: "colSpan",
        content: "content",
        contenteditable: "contentEditable",
        contextmenu: "contextMenu",
        controls: "controls",
        controlslist: "controlsList",
        coords: "coords",
        crossorigin: "crossOrigin",
        dangerouslysetinnerhtml: "dangerouslySetInnerHTML",
        data: "data",
        datetime: "dateTime",
        default: "default",
        defaultchecked: "defaultChecked",
        defaultvalue: "defaultValue",
        defer: "defer",
        dir: "dir",
        disabled: "disabled",
        disablepictureinpicture: "disablePictureInPicture",
        disableremoteplayback: "disableRemotePlayback",
        download: "download",
        draggable: "draggable",
        enctype: "encType",
        enterkeyhint: "enterKeyHint",
        for: "htmlFor",
        form: "form",
        formmethod: "formMethod",
        formaction: "formAction",
        formenctype: "formEncType",
        formnovalidate: "formNoValidate",
        formtarget: "formTarget",
        frameborder: "frameBorder",
        headers: "headers",
        height: "height",
        hidden: "hidden",
        high: "high",
        href: "href",
        hreflang: "hrefLang",
        htmlfor: "htmlFor",
        httpequiv: "httpEquiv",
        "http-equiv": "httpEquiv",
        icon: "icon",
        id: "id",
        imagesizes: "imageSizes",
        imagesrcset: "imageSrcSet",
        innerhtml: "innerHTML",
        inputmode: "inputMode",
        integrity: "integrity",
        is: "is",
        itemid: "itemID",
        itemprop: "itemProp",
        itemref: "itemRef",
        itemscope: "itemScope",
        itemtype: "itemType",
        keyparams: "keyParams",
        keytype: "keyType",
        kind: "kind",
        label: "label",
        lang: "lang",
        list: "list",
        loop: "loop",
        low: "low",
        manifest: "manifest",
        marginwidth: "marginWidth",
        marginheight: "marginHeight",
        max: "max",
        maxlength: "maxLength",
        media: "media",
        mediagroup: "mediaGroup",
        method: "method",
        min: "min",
        minlength: "minLength",
        multiple: "multiple",
        muted: "muted",
        name: "name",
        nomodule: "noModule",
        nonce: "nonce",
        novalidate: "noValidate",
        open: "open",
        optimum: "optimum",
        pattern: "pattern",
        placeholder: "placeholder",
        playsinline: "playsInline",
        poster: "poster",
        preload: "preload",
        profile: "profile",
        radiogroup: "radioGroup",
        readonly: "readOnly",
        referrerpolicy: "referrerPolicy",
        rel: "rel",
        required: "required",
        reversed: "reversed",
        role: "role",
        rows: "rows",
        rowspan: "rowSpan",
        sandbox: "sandbox",
        scope: "scope",
        scoped: "scoped",
        scrolling: "scrolling",
        seamless: "seamless",
        selected: "selected",
        shape: "shape",
        size: "size",
        sizes: "sizes",
        span: "span",
        spellcheck: "spellCheck",
        src: "src",
        srcdoc: "srcDoc",
        srclang: "srcLang",
        srcset: "srcSet",
        start: "start",
        step: "step",
        style: "style",
        summary: "summary",
        tabindex: "tabIndex",
        target: "target",
        title: "title",
        type: "type",
        usemap: "useMap",
        value: "value",
        width: "width",
        wmode: "wmode",
        wrap: "wrap",
        // SVG
        about: "about",
        accentheight: "accentHeight",
        "accent-height": "accentHeight",
        accumulate: "accumulate",
        additive: "additive",
        alignmentbaseline: "alignmentBaseline",
        "alignment-baseline": "alignmentBaseline",
        allowreorder: "allowReorder",
        alphabetic: "alphabetic",
        amplitude: "amplitude",
        arabicform: "arabicForm",
        "arabic-form": "arabicForm",
        ascent: "ascent",
        attributename: "attributeName",
        attributetype: "attributeType",
        autoreverse: "autoReverse",
        azimuth: "azimuth",
        basefrequency: "baseFrequency",
        baselineshift: "baselineShift",
        "baseline-shift": "baselineShift",
        baseprofile: "baseProfile",
        bbox: "bbox",
        begin: "begin",
        bias: "bias",
        by: "by",
        calcmode: "calcMode",
        capheight: "capHeight",
        "cap-height": "capHeight",
        clip: "clip",
        clippath: "clipPath",
        "clip-path": "clipPath",
        clippathunits: "clipPathUnits",
        cliprule: "clipRule",
        "clip-rule": "clipRule",
        color: "color",
        colorinterpolation: "colorInterpolation",
        "color-interpolation": "colorInterpolation",
        colorinterpolationfilters: "colorInterpolationFilters",
        "color-interpolation-filters": "colorInterpolationFilters",
        colorprofile: "colorProfile",
        "color-profile": "colorProfile",
        colorrendering: "colorRendering",
        "color-rendering": "colorRendering",
        contentscripttype: "contentScriptType",
        contentstyletype: "contentStyleType",
        cursor: "cursor",
        cx: "cx",
        cy: "cy",
        d: "d",
        datatype: "datatype",
        decelerate: "decelerate",
        descent: "descent",
        diffuseconstant: "diffuseConstant",
        direction: "direction",
        display: "display",
        divisor: "divisor",
        dominantbaseline: "dominantBaseline",
        "dominant-baseline": "dominantBaseline",
        dur: "dur",
        dx: "dx",
        dy: "dy",
        edgemode: "edgeMode",
        elevation: "elevation",
        enablebackground: "enableBackground",
        "enable-background": "enableBackground",
        end: "end",
        exponent: "exponent",
        externalresourcesrequired: "externalResourcesRequired",
        fill: "fill",
        fillopacity: "fillOpacity",
        "fill-opacity": "fillOpacity",
        fillrule: "fillRule",
        "fill-rule": "fillRule",
        filter: "filter",
        filterres: "filterRes",
        filterunits: "filterUnits",
        floodopacity: "floodOpacity",
        "flood-opacity": "floodOpacity",
        floodcolor: "floodColor",
        "flood-color": "floodColor",
        focusable: "focusable",
        fontfamily: "fontFamily",
        "font-family": "fontFamily",
        fontsize: "fontSize",
        "font-size": "fontSize",
        fontsizeadjust: "fontSizeAdjust",
        "font-size-adjust": "fontSizeAdjust",
        fontstretch: "fontStretch",
        "font-stretch": "fontStretch",
        fontstyle: "fontStyle",
        "font-style": "fontStyle",
        fontvariant: "fontVariant",
        "font-variant": "fontVariant",
        fontweight: "fontWeight",
        "font-weight": "fontWeight",
        format: "format",
        from: "from",
        fx: "fx",
        fy: "fy",
        g1: "g1",
        g2: "g2",
        glyphname: "glyphName",
        "glyph-name": "glyphName",
        glyphorientationhorizontal: "glyphOrientationHorizontal",
        "glyph-orientation-horizontal": "glyphOrientationHorizontal",
        glyphorientationvertical: "glyphOrientationVertical",
        "glyph-orientation-vertical": "glyphOrientationVertical",
        glyphref: "glyphRef",
        gradienttransform: "gradientTransform",
        gradientunits: "gradientUnits",
        hanging: "hanging",
        horizadvx: "horizAdvX",
        "horiz-adv-x": "horizAdvX",
        horizoriginx: "horizOriginX",
        "horiz-origin-x": "horizOriginX",
        ideographic: "ideographic",
        imagerendering: "imageRendering",
        "image-rendering": "imageRendering",
        in2: "in2",
        in: "in",
        inlist: "inlist",
        intercept: "intercept",
        k1: "k1",
        k2: "k2",
        k3: "k3",
        k4: "k4",
        k: "k",
        kernelmatrix: "kernelMatrix",
        kernelunitlength: "kernelUnitLength",
        kerning: "kerning",
        keypoints: "keyPoints",
        keysplines: "keySplines",
        keytimes: "keyTimes",
        lengthadjust: "lengthAdjust",
        letterspacing: "letterSpacing",
        "letter-spacing": "letterSpacing",
        lightingcolor: "lightingColor",
        "lighting-color": "lightingColor",
        limitingconeangle: "limitingConeAngle",
        local: "local",
        markerend: "markerEnd",
        "marker-end": "markerEnd",
        markerheight: "markerHeight",
        markermid: "markerMid",
        "marker-mid": "markerMid",
        markerstart: "markerStart",
        "marker-start": "markerStart",
        markerunits: "markerUnits",
        markerwidth: "markerWidth",
        mask: "mask",
        maskcontentunits: "maskContentUnits",
        maskunits: "maskUnits",
        mathematical: "mathematical",
        mode: "mode",
        numoctaves: "numOctaves",
        offset: "offset",
        opacity: "opacity",
        operator: "operator",
        order: "order",
        orient: "orient",
        orientation: "orientation",
        origin: "origin",
        overflow: "overflow",
        overlineposition: "overlinePosition",
        "overline-position": "overlinePosition",
        overlinethickness: "overlineThickness",
        "overline-thickness": "overlineThickness",
        paintorder: "paintOrder",
        "paint-order": "paintOrder",
        panose1: "panose1",
        "panose-1": "panose1",
        pathlength: "pathLength",
        patterncontentunits: "patternContentUnits",
        patterntransform: "patternTransform",
        patternunits: "patternUnits",
        pointerevents: "pointerEvents",
        "pointer-events": "pointerEvents",
        points: "points",
        pointsatx: "pointsAtX",
        pointsaty: "pointsAtY",
        pointsatz: "pointsAtZ",
        prefix: "prefix",
        preservealpha: "preserveAlpha",
        preserveaspectratio: "preserveAspectRatio",
        primitiveunits: "primitiveUnits",
        property: "property",
        r: "r",
        radius: "radius",
        refx: "refX",
        refy: "refY",
        renderingintent: "renderingIntent",
        "rendering-intent": "renderingIntent",
        repeatcount: "repeatCount",
        repeatdur: "repeatDur",
        requiredextensions: "requiredExtensions",
        requiredfeatures: "requiredFeatures",
        resource: "resource",
        restart: "restart",
        result: "result",
        results: "results",
        rotate: "rotate",
        rx: "rx",
        ry: "ry",
        scale: "scale",
        security: "security",
        seed: "seed",
        shaperendering: "shapeRendering",
        "shape-rendering": "shapeRendering",
        slope: "slope",
        spacing: "spacing",
        specularconstant: "specularConstant",
        specularexponent: "specularExponent",
        speed: "speed",
        spreadmethod: "spreadMethod",
        startoffset: "startOffset",
        stddeviation: "stdDeviation",
        stemh: "stemh",
        stemv: "stemv",
        stitchtiles: "stitchTiles",
        stopcolor: "stopColor",
        "stop-color": "stopColor",
        stopopacity: "stopOpacity",
        "stop-opacity": "stopOpacity",
        strikethroughposition: "strikethroughPosition",
        "strikethrough-position": "strikethroughPosition",
        strikethroughthickness: "strikethroughThickness",
        "strikethrough-thickness": "strikethroughThickness",
        string: "string",
        stroke: "stroke",
        strokedasharray: "strokeDasharray",
        "stroke-dasharray": "strokeDasharray",
        strokedashoffset: "strokeDashoffset",
        "stroke-dashoffset": "strokeDashoffset",
        strokelinecap: "strokeLinecap",
        "stroke-linecap": "strokeLinecap",
        strokelinejoin: "strokeLinejoin",
        "stroke-linejoin": "strokeLinejoin",
        strokemiterlimit: "strokeMiterlimit",
        "stroke-miterlimit": "strokeMiterlimit",
        strokewidth: "strokeWidth",
        "stroke-width": "strokeWidth",
        strokeopacity: "strokeOpacity",
        "stroke-opacity": "strokeOpacity",
        suppresscontenteditablewarning: "suppressContentEditableWarning",
        suppresshydrationwarning: "suppressHydrationWarning",
        surfacescale: "surfaceScale",
        systemlanguage: "systemLanguage",
        tablevalues: "tableValues",
        targetx: "targetX",
        targety: "targetY",
        textanchor: "textAnchor",
        "text-anchor": "textAnchor",
        textdecoration: "textDecoration",
        "text-decoration": "textDecoration",
        textlength: "textLength",
        textrendering: "textRendering",
        "text-rendering": "textRendering",
        to: "to",
        transform: "transform",
        typeof: "typeof",
        u1: "u1",
        u2: "u2",
        underlineposition: "underlinePosition",
        "underline-position": "underlinePosition",
        underlinethickness: "underlineThickness",
        "underline-thickness": "underlineThickness",
        unicode: "unicode",
        unicodebidi: "unicodeBidi",
        "unicode-bidi": "unicodeBidi",
        unicoderange: "unicodeRange",
        "unicode-range": "unicodeRange",
        unitsperem: "unitsPerEm",
        "units-per-em": "unitsPerEm",
        unselectable: "unselectable",
        valphabetic: "vAlphabetic",
        "v-alphabetic": "vAlphabetic",
        values: "values",
        vectoreffect: "vectorEffect",
        "vector-effect": "vectorEffect",
        version: "version",
        vertadvy: "vertAdvY",
        "vert-adv-y": "vertAdvY",
        vertoriginx: "vertOriginX",
        "vert-origin-x": "vertOriginX",
        vertoriginy: "vertOriginY",
        "vert-origin-y": "vertOriginY",
        vhanging: "vHanging",
        "v-hanging": "vHanging",
        videographic: "vIdeographic",
        "v-ideographic": "vIdeographic",
        viewbox: "viewBox",
        viewtarget: "viewTarget",
        visibility: "visibility",
        vmathematical: "vMathematical",
        "v-mathematical": "vMathematical",
        vocab: "vocab",
        widths: "widths",
        wordspacing: "wordSpacing",
        "word-spacing": "wordSpacing",
        writingmode: "writingMode",
        "writing-mode": "writingMode",
        x1: "x1",
        x2: "x2",
        x: "x",
        xchannelselector: "xChannelSelector",
        xheight: "xHeight",
        "x-height": "xHeight",
        xlinkactuate: "xlinkActuate",
        "xlink:actuate": "xlinkActuate",
        xlinkarcrole: "xlinkArcrole",
        "xlink:arcrole": "xlinkArcrole",
        xlinkhref: "xlinkHref",
        "xlink:href": "xlinkHref",
        xlinkrole: "xlinkRole",
        "xlink:role": "xlinkRole",
        xlinkshow: "xlinkShow",
        "xlink:show": "xlinkShow",
        xlinktitle: "xlinkTitle",
        "xlink:title": "xlinkTitle",
        xlinktype: "xlinkType",
        "xlink:type": "xlinkType",
        xmlbase: "xmlBase",
        "xml:base": "xmlBase",
        xmllang: "xmlLang",
        "xml:lang": "xmlLang",
        xmlns: "xmlns",
        "xml:space": "xmlSpace",
        xmlnsxlink: "xmlnsXlink",
        "xmlns:xlink": "xmlnsXlink",
        xmlspace: "xmlSpace",
        y1: "y1",
        y2: "y2",
        y: "y",
        ychannelselector: "yChannelSelector",
        z: "z",
        zoomandpan: "zoomAndPan"
      }, validateProperty$1 = function() {
      };
      {
        var warnedProperties$1 = {}, EVENT_NAME_REGEX = /^on./, INVALID_EVENT_NAME_REGEX = /^on[^A-Z]/, rARIA$1 = new RegExp("^(aria)-[" + ATTRIBUTE_NAME_CHAR + "]*$"), rARIACamel$1 = new RegExp("^(aria)[A-Z][" + ATTRIBUTE_NAME_CHAR + "]*$");
        validateProperty$1 = function(tagName, name, value, eventRegistry) {
          if (hasOwnProperty.call(warnedProperties$1, name) && warnedProperties$1[name])
            return !0;
          var lowerCasedName = name.toLowerCase();
          if (lowerCasedName === "onfocusin" || lowerCasedName === "onfocusout")
            return error("React uses onFocus and onBlur instead of onFocusIn and onFocusOut. All React events are normalized to bubble, so onFocusIn and onFocusOut are not needed/supported by React."), warnedProperties$1[name] = !0, !0;
          if (eventRegistry != null) {
            var registrationNameDependencies = eventRegistry.registrationNameDependencies, possibleRegistrationNames = eventRegistry.possibleRegistrationNames;
            if (registrationNameDependencies.hasOwnProperty(name))
              return !0;
            var registrationName = possibleRegistrationNames.hasOwnProperty(lowerCasedName) ? possibleRegistrationNames[lowerCasedName] : null;
            if (registrationName != null)
              return error("Invalid event handler property `%s`. Did you mean `%s`?", name, registrationName), warnedProperties$1[name] = !0, !0;
            if (EVENT_NAME_REGEX.test(name))
              return error("Unknown event handler property `%s`. It will be ignored.", name), warnedProperties$1[name] = !0, !0;
          } else if (EVENT_NAME_REGEX.test(name))
            return INVALID_EVENT_NAME_REGEX.test(name) && error("Invalid event handler property `%s`. React events use the camelCase naming convention, for example `onClick`.", name), warnedProperties$1[name] = !0, !0;
          if (rARIA$1.test(name) || rARIACamel$1.test(name))
            return !0;
          if (lowerCasedName === "innerhtml")
            return error("Directly setting property `innerHTML` is not permitted. For more information, lookup documentation on `dangerouslySetInnerHTML`."), warnedProperties$1[name] = !0, !0;
          if (lowerCasedName === "aria")
            return error("The `aria` attribute is reserved for future use in React. Pass individual `aria-` attributes instead."), warnedProperties$1[name] = !0, !0;
          if (lowerCasedName === "is" && value !== null && value !== void 0 && typeof value != "string")
            return error("Received a `%s` for a string attribute `is`. If this is expected, cast the value to a string.", typeof value), warnedProperties$1[name] = !0, !0;
          if (typeof value == "number" && isNaN(value))
            return error("Received NaN for the `%s` attribute. If this is expected, cast the value to a string.", name), warnedProperties$1[name] = !0, !0;
          var propertyInfo = getPropertyInfo(name), isReserved = propertyInfo !== null && propertyInfo.type === RESERVED;
          if (possibleStandardNames.hasOwnProperty(lowerCasedName)) {
            var standardName = possibleStandardNames[lowerCasedName];
            if (standardName !== name)
              return error("Invalid DOM property `%s`. Did you mean `%s`?", name, standardName), warnedProperties$1[name] = !0, !0;
          } else if (!isReserved && name !== lowerCasedName)
            return error("React does not recognize the `%s` prop on a DOM element. If you intentionally want it to appear in the DOM as a custom attribute, spell it as lowercase `%s` instead. If you accidentally passed it from a parent component, remove it from the DOM element.", name, lowerCasedName), warnedProperties$1[name] = !0, !0;
          return typeof value == "boolean" && shouldRemoveAttributeWithWarning(name, value, propertyInfo, !1) ? (value ? error('Received `%s` for a non-boolean attribute `%s`.\n\nIf you want to write it to the DOM, pass a string instead: %s="%s" or %s={value.toString()}.', value, name, name, value, name) : error('Received `%s` for a non-boolean attribute `%s`.\n\nIf you want to write it to the DOM, pass a string instead: %s="%s" or %s={value.toString()}.\n\nIf you used to conditionally omit it with %s={condition && value}, pass %s={condition ? value : undefined} instead.', value, name, name, value, name, name, name), warnedProperties$1[name] = !0, !0) : isReserved ? !0 : shouldRemoveAttributeWithWarning(name, value, propertyInfo, !1) ? (warnedProperties$1[name] = !0, !1) : ((value === "false" || value === "true") && propertyInfo !== null && propertyInfo.type === BOOLEAN && (error("Received the string `%s` for the boolean attribute `%s`. %s Did you mean %s={%s}?", value, name, value === "false" ? "The browser will interpret it as a truthy value." : 'Although this works, it will not work as expected if you pass the string "false".', name, value), warnedProperties$1[name] = !0), !0);
        };
      }
      var warnUnknownProperties = function(type, props, eventRegistry) {
        {
          var unknownProps = [];
          for (var key in props) {
            var isValid = validateProperty$1(type, key, props[key], eventRegistry);
            isValid || unknownProps.push(key);
          }
          var unknownPropString = unknownProps.map(function(prop) {
            return "`" + prop + "`";
          }).join(", ");
          unknownProps.length === 1 ? error("Invalid value for prop %s on <%s> tag. Either remove it from the element, or pass a string or number value to keep it in the DOM. For details, see https://reactjs.org/link/attribute-behavior ", unknownPropString, type) : unknownProps.length > 1 && error("Invalid values for props %s on <%s> tag. Either remove them from the element, or pass a string or number value to keep them in the DOM. For details, see https://reactjs.org/link/attribute-behavior ", unknownPropString, type);
        }
      };
      function validateProperties$2(type, props, eventRegistry) {
        isCustomComponent(type, props) || warnUnknownProperties(type, props, eventRegistry);
      }
      var warnValidStyle = function() {
      };
      {
        var badVendoredStyleNamePattern = /^(?:webkit|moz|o)[A-Z]/, msPattern = /^-ms-/, hyphenPattern = /-(.)/g, badStyleValueWithSemicolonPattern = /;\s*$/, warnedStyleNames = {}, warnedStyleValues = {}, warnedForNaNValue = !1, warnedForInfinityValue = !1, camelize2 = function(string) {
          return string.replace(hyphenPattern, function(_2, character) {
            return character.toUpperCase();
          });
        }, warnHyphenatedStyleName = function(name) {
          warnedStyleNames.hasOwnProperty(name) && warnedStyleNames[name] || (warnedStyleNames[name] = !0, error(
            "Unsupported style property %s. Did you mean %s?",
            name,
            // As Andi Smith suggests
            // (http://www.andismith.com/blog/2012/02/modernizr-prefixed/), an `-ms` prefix
            // is converted to lowercase `ms`.
            camelize2(name.replace(msPattern, "ms-"))
          ));
        }, warnBadVendoredStyleName = function(name) {
          warnedStyleNames.hasOwnProperty(name) && warnedStyleNames[name] || (warnedStyleNames[name] = !0, error("Unsupported vendor-prefixed style property %s. Did you mean %s?", name, name.charAt(0).toUpperCase() + name.slice(1)));
        }, warnStyleValueWithSemicolon = function(name, value) {
          warnedStyleValues.hasOwnProperty(value) && warnedStyleValues[value] || (warnedStyleValues[value] = !0, error(`Style property values shouldn't contain a semicolon. Try "%s: %s" instead.`, name, value.replace(badStyleValueWithSemicolonPattern, "")));
        }, warnStyleValueIsNaN = function(name, value) {
          warnedForNaNValue || (warnedForNaNValue = !0, error("`NaN` is an invalid value for the `%s` css style property.", name));
        }, warnStyleValueIsInfinity = function(name, value) {
          warnedForInfinityValue || (warnedForInfinityValue = !0, error("`Infinity` is an invalid value for the `%s` css style property.", name));
        };
        warnValidStyle = function(name, value) {
          name.indexOf("-") > -1 ? warnHyphenatedStyleName(name) : badVendoredStyleNamePattern.test(name) ? warnBadVendoredStyleName(name) : badStyleValueWithSemicolonPattern.test(value) && warnStyleValueWithSemicolon(name, value), typeof value == "number" && (isNaN(value) ? warnStyleValueIsNaN(name, value) : isFinite(value) || warnStyleValueIsInfinity(name, value));
        };
      }
      var warnValidStyle$1 = warnValidStyle, matchHtmlRegExp = /["'&<>]/;
      function escapeHtml(string) {
        checkHtmlStringCoercion(string);
        var str = "" + string, match2 = matchHtmlRegExp.exec(str);
        if (!match2)
          return str;
        var escape2, html = "", index, lastIndex = 0;
        for (index = match2.index; index < str.length; index++) {
          switch (str.charCodeAt(index)) {
            case 34:
              escape2 = "&quot;";
              break;
            case 38:
              escape2 = "&amp;";
              break;
            case 39:
              escape2 = "&#x27;";
              break;
            case 60:
              escape2 = "&lt;";
              break;
            case 62:
              escape2 = "&gt;";
              break;
            default:
              continue;
          }
          lastIndex !== index && (html += str.substring(lastIndex, index)), lastIndex = index + 1, html += escape2;
        }
        return lastIndex !== index ? html + str.substring(lastIndex, index) : html;
      }
      function escapeTextForBrowser(text) {
        return typeof text == "boolean" || typeof text == "number" ? "" + text : escapeHtml(text);
      }
      var uppercasePattern = /([A-Z])/g, msPattern$1 = /^ms-/;
      function hyphenateStyleName(name) {
        return name.replace(uppercasePattern, "-$1").toLowerCase().replace(msPattern$1, "-ms-");
      }
      var isJavaScriptProtocol = /^[\u0000-\u001F ]*j[\r\n\t]*a[\r\n\t]*v[\r\n\t]*a[\r\n\t]*s[\r\n\t]*c[\r\n\t]*r[\r\n\t]*i[\r\n\t]*p[\r\n\t]*t[\r\n\t]*\:/i, didWarn = !1;
      function sanitizeURL(url) {
        !didWarn && isJavaScriptProtocol.test(url) && (didWarn = !0, error("A future version of React will block javascript: URLs as a security precaution. Use event handlers instead if you can. If you need to generate unsafe HTML try using dangerouslySetInnerHTML instead. React was passed %s.", JSON.stringify(url)));
      }
      var isArrayImpl = Array.isArray;
      function isArray(a) {
        return isArrayImpl(a);
      }
      var startInlineScript = "<script>", endInlineScript = "</script>", startScriptSrc = '<script src="', startModuleSrc = '<script type="module" src="', endAsyncScript = '" async=""></script>';
      function escapeBootstrapScriptContent(scriptText) {
        return checkHtmlStringCoercion(scriptText), ("" + scriptText).replace(scriptRegex, scriptReplacer);
      }
      var scriptRegex = /(<\/|<)(s)(cript)/gi, scriptReplacer = function(match2, prefix2, s, suffix) {
        return "" + prefix2 + (s === "s" ? "\\u0073" : "\\u0053") + suffix;
      };
      function createResponseState(identifierPrefix, nonce, bootstrapScriptContent, bootstrapScripts, bootstrapModules) {
        var idPrefix = identifierPrefix === void 0 ? "" : identifierPrefix, inlineScriptWithNonce = nonce === void 0 ? startInlineScript : '<script nonce="' + escapeTextForBrowser(nonce) + '">', bootstrapChunks = [];
        if (bootstrapScriptContent !== void 0 && bootstrapChunks.push(inlineScriptWithNonce, escapeBootstrapScriptContent(bootstrapScriptContent), endInlineScript), bootstrapScripts !== void 0)
          for (var i = 0; i < bootstrapScripts.length; i++)
            bootstrapChunks.push(startScriptSrc, escapeTextForBrowser(bootstrapScripts[i]), endAsyncScript);
        if (bootstrapModules !== void 0)
          for (var _i = 0; _i < bootstrapModules.length; _i++)
            bootstrapChunks.push(startModuleSrc, escapeTextForBrowser(bootstrapModules[_i]), endAsyncScript);
        return {
          bootstrapChunks,
          startInlineScript: inlineScriptWithNonce,
          placeholderPrefix: idPrefix + "P:",
          segmentPrefix: idPrefix + "S:",
          boundaryPrefix: idPrefix + "B:",
          idPrefix,
          nextSuspenseID: 0,
          sentCompleteSegmentFunction: !1,
          sentCompleteBoundaryFunction: !1,
          sentClientRenderFunction: !1
        };
      }
      var ROOT_HTML_MODE = 0, HTML_MODE = 1, SVG_MODE = 2, MATHML_MODE = 3, HTML_TABLE_MODE = 4, HTML_TABLE_BODY_MODE = 5, HTML_TABLE_ROW_MODE = 6, HTML_COLGROUP_MODE = 7;
      function createFormatContext(insertionMode, selectedValue) {
        return {
          insertionMode,
          selectedValue
        };
      }
      function getChildFormatContext(parentContext, type, props) {
        switch (type) {
          case "select":
            return createFormatContext(HTML_MODE, props.value != null ? props.value : props.defaultValue);
          case "svg":
            return createFormatContext(SVG_MODE, null);
          case "math":
            return createFormatContext(MATHML_MODE, null);
          case "foreignObject":
            return createFormatContext(HTML_MODE, null);
          case "table":
            return createFormatContext(HTML_TABLE_MODE, null);
          case "thead":
          case "tbody":
          case "tfoot":
            return createFormatContext(HTML_TABLE_BODY_MODE, null);
          case "colgroup":
            return createFormatContext(HTML_COLGROUP_MODE, null);
          case "tr":
            return createFormatContext(HTML_TABLE_ROW_MODE, null);
        }
        return parentContext.insertionMode >= HTML_TABLE_MODE || parentContext.insertionMode === ROOT_HTML_MODE ? createFormatContext(HTML_MODE, null) : parentContext;
      }
      var UNINITIALIZED_SUSPENSE_BOUNDARY_ID = null;
      function assignSuspenseBoundaryID(responseState) {
        var generatedID = responseState.nextSuspenseID++;
        return responseState.boundaryPrefix + generatedID.toString(16);
      }
      function makeId(responseState, treeId, localId) {
        var idPrefix = responseState.idPrefix, id = ":" + idPrefix + "R" + treeId;
        return localId > 0 && (id += "H" + localId.toString(32)), id + ":";
      }
      function encodeHTMLTextNode(text) {
        return escapeTextForBrowser(text);
      }
      var textSeparator = "<!-- -->";
      function pushTextInstance(target, text, responseState, textEmbedded) {
        return text === "" ? textEmbedded : (textEmbedded && target.push(textSeparator), target.push(encodeHTMLTextNode(text)), !0);
      }
      function pushSegmentFinale(target, responseState, lastPushedText, textEmbedded) {
        lastPushedText && textEmbedded && target.push(textSeparator);
      }
      var styleNameCache = /* @__PURE__ */ new Map();
      function processStyleName(styleName) {
        var chunk = styleNameCache.get(styleName);
        if (chunk !== void 0)
          return chunk;
        var result = escapeTextForBrowser(hyphenateStyleName(styleName));
        return styleNameCache.set(styleName, result), result;
      }
      var styleAttributeStart = ' style="', styleAssign = ":", styleSeparator = ";";
      function pushStyle(target, responseState, style) {
        if (typeof style != "object")
          throw new Error("The `style` prop expects a mapping from style properties to values, not a string. For example, style={{marginRight: spacing + 'em'}} when using JSX.");
        var isFirst = !0;
        for (var styleName in style)
          if (hasOwnProperty.call(style, styleName)) {
            var styleValue = style[styleName];
            if (!(styleValue == null || typeof styleValue == "boolean" || styleValue === "")) {
              var nameChunk = void 0, valueChunk = void 0, isCustomProperty = styleName.indexOf("--") === 0;
              isCustomProperty ? (nameChunk = escapeTextForBrowser(styleName), checkCSSPropertyStringCoercion(styleValue, styleName), valueChunk = escapeTextForBrowser(("" + styleValue).trim())) : (warnValidStyle$1(styleName, styleValue), nameChunk = processStyleName(styleName), typeof styleValue == "number" ? styleValue !== 0 && !hasOwnProperty.call(isUnitlessNumber, styleName) ? valueChunk = styleValue + "px" : valueChunk = "" + styleValue : (checkCSSPropertyStringCoercion(styleValue, styleName), valueChunk = escapeTextForBrowser(("" + styleValue).trim()))), isFirst ? (isFirst = !1, target.push(styleAttributeStart, nameChunk, styleAssign, valueChunk)) : target.push(styleSeparator, nameChunk, styleAssign, valueChunk);
            }
          }
        isFirst || target.push(attributeEnd);
      }
      var attributeSeparator = " ", attributeAssign = '="', attributeEnd = '"', attributeEmptyString = '=""';
      function pushAttribute(target, responseState, name, value) {
        switch (name) {
          case "style": {
            pushStyle(target, responseState, value);
            return;
          }
          case "defaultValue":
          case "defaultChecked":
          case "innerHTML":
          case "suppressContentEditableWarning":
          case "suppressHydrationWarning":
            return;
        }
        if (
          // shouldIgnoreAttribute
          // We have already filtered out null/undefined and reserved words.
          !(name.length > 2 && (name[0] === "o" || name[0] === "O") && (name[1] === "n" || name[1] === "N"))
        ) {
          var propertyInfo = getPropertyInfo(name);
          if (propertyInfo !== null) {
            switch (typeof value) {
              case "function":
              case "symbol":
                return;
              case "boolean":
                if (!propertyInfo.acceptsBooleans)
                  return;
            }
            var attributeName = propertyInfo.attributeName, attributeNameChunk = attributeName;
            switch (propertyInfo.type) {
              case BOOLEAN:
                value && target.push(attributeSeparator, attributeNameChunk, attributeEmptyString);
                return;
              case OVERLOADED_BOOLEAN:
                value === !0 ? target.push(attributeSeparator, attributeNameChunk, attributeEmptyString) : value === !1 || target.push(attributeSeparator, attributeNameChunk, attributeAssign, escapeTextForBrowser(value), attributeEnd);
                return;
              case NUMERIC:
                isNaN(value) || target.push(attributeSeparator, attributeNameChunk, attributeAssign, escapeTextForBrowser(value), attributeEnd);
                break;
              case POSITIVE_NUMERIC:
                !isNaN(value) && value >= 1 && target.push(attributeSeparator, attributeNameChunk, attributeAssign, escapeTextForBrowser(value), attributeEnd);
                break;
              default:
                propertyInfo.sanitizeURL && (checkAttributeStringCoercion(value, attributeName), value = "" + value, sanitizeURL(value)), target.push(attributeSeparator, attributeNameChunk, attributeAssign, escapeTextForBrowser(value), attributeEnd);
            }
          } else if (isAttributeNameSafe(name)) {
            switch (typeof value) {
              case "function":
              case "symbol":
                return;
              case "boolean": {
                var prefix2 = name.toLowerCase().slice(0, 5);
                if (prefix2 !== "data-" && prefix2 !== "aria-")
                  return;
              }
            }
            target.push(attributeSeparator, name, attributeAssign, escapeTextForBrowser(value), attributeEnd);
          }
        }
      }
      var endOfStartTag = ">", endOfStartTagSelfClosing = "/>";
      function pushInnerHTML(target, innerHTML, children) {
        if (innerHTML != null) {
          if (children != null)
            throw new Error("Can only set one of `children` or `props.dangerouslySetInnerHTML`.");
          if (typeof innerHTML != "object" || !("__html" in innerHTML))
            throw new Error("`props.dangerouslySetInnerHTML` must be in the form `{__html: ...}`. Please visit https://reactjs.org/link/dangerously-set-inner-html for more information.");
          var html = innerHTML.__html;
          html != null && (checkHtmlStringCoercion(html), target.push("" + html));
        }
      }
      var didWarnDefaultInputValue = !1, didWarnDefaultChecked = !1, didWarnDefaultSelectValue = !1, didWarnDefaultTextareaValue = !1, didWarnInvalidOptionChildren = !1, didWarnInvalidOptionInnerHTML = !1, didWarnSelectedSetOnOption = !1;
      function checkSelectProp(props, propName) {
        {
          var value = props[propName];
          if (value != null) {
            var array = isArray(value);
            props.multiple && !array ? error("The `%s` prop supplied to <select> must be an array if `multiple` is true.", propName) : !props.multiple && array && error("The `%s` prop supplied to <select> must be a scalar value if `multiple` is false.", propName);
          }
        }
      }
      function pushStartSelect(target, props, responseState) {
        checkControlledValueProps("select", props), checkSelectProp(props, "value"), checkSelectProp(props, "defaultValue"), props.value !== void 0 && props.defaultValue !== void 0 && !didWarnDefaultSelectValue && (error("Select elements must be either controlled or uncontrolled (specify either the value prop, or the defaultValue prop, but not both). Decide between using a controlled or uncontrolled select element and remove one of these props. More info: https://reactjs.org/link/controlled-components"), didWarnDefaultSelectValue = !0), target.push(startChunkForTag("select"));
        var children = null, innerHTML = null;
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
                children = propValue;
                break;
              case "dangerouslySetInnerHTML":
                innerHTML = propValue;
                break;
              case "defaultValue":
              case "value":
                break;
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        return target.push(endOfStartTag), pushInnerHTML(target, innerHTML, children), children;
      }
      function flattenOptionChildren(children) {
        var content = "";
        return React12.Children.forEach(children, function(child) {
          child != null && (content += child, !didWarnInvalidOptionChildren && typeof child != "string" && typeof child != "number" && (didWarnInvalidOptionChildren = !0, error("Cannot infer the option value of complex children. Pass a `value` prop or use a plain string as children to <option>.")));
        }), content;
      }
      var selectedMarkerAttribute = ' selected=""';
      function pushStartOption(target, props, responseState, formatContext) {
        var selectedValue = formatContext.selectedValue;
        target.push(startChunkForTag("option"));
        var children = null, value = null, selected = null, innerHTML = null;
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
                children = propValue;
                break;
              case "selected":
                selected = propValue, didWarnSelectedSetOnOption || (error("Use the `defaultValue` or `value` props on <select> instead of setting `selected` on <option>."), didWarnSelectedSetOnOption = !0);
                break;
              case "dangerouslySetInnerHTML":
                innerHTML = propValue;
                break;
              case "value":
                value = propValue;
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        if (selectedValue != null) {
          var stringValue;
          if (value !== null ? (checkAttributeStringCoercion(value, "value"), stringValue = "" + value) : (innerHTML !== null && (didWarnInvalidOptionInnerHTML || (didWarnInvalidOptionInnerHTML = !0, error("Pass a `value` prop if you set dangerouslyInnerHTML so React knows which value should be selected."))), stringValue = flattenOptionChildren(children)), isArray(selectedValue))
            for (var i = 0; i < selectedValue.length; i++) {
              checkAttributeStringCoercion(selectedValue[i], "value");
              var v = "" + selectedValue[i];
              if (v === stringValue) {
                target.push(selectedMarkerAttribute);
                break;
              }
            }
          else
            checkAttributeStringCoercion(selectedValue, "select.value"), "" + selectedValue === stringValue && target.push(selectedMarkerAttribute);
        } else
          selected && target.push(selectedMarkerAttribute);
        return target.push(endOfStartTag), pushInnerHTML(target, innerHTML, children), children;
      }
      function pushInput(target, props, responseState) {
        checkControlledValueProps("input", props), props.checked !== void 0 && props.defaultChecked !== void 0 && !didWarnDefaultChecked && (error("%s contains an input of type %s with both checked and defaultChecked props. Input elements must be either controlled or uncontrolled (specify either the checked prop, or the defaultChecked prop, but not both). Decide between using a controlled or uncontrolled input element and remove one of these props. More info: https://reactjs.org/link/controlled-components", "A component", props.type), didWarnDefaultChecked = !0), props.value !== void 0 && props.defaultValue !== void 0 && !didWarnDefaultInputValue && (error("%s contains an input of type %s with both value and defaultValue props. Input elements must be either controlled or uncontrolled (specify either the value prop, or the defaultValue prop, but not both). Decide between using a controlled or uncontrolled input element and remove one of these props. More info: https://reactjs.org/link/controlled-components", "A component", props.type), didWarnDefaultInputValue = !0), target.push(startChunkForTag("input"));
        var value = null, defaultValue = null, checked = null, defaultChecked = null;
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
              case "dangerouslySetInnerHTML":
                throw new Error("input is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");
              case "defaultChecked":
                defaultChecked = propValue;
                break;
              case "defaultValue":
                defaultValue = propValue;
                break;
              case "checked":
                checked = propValue;
                break;
              case "value":
                value = propValue;
                break;
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        return checked !== null ? pushAttribute(target, responseState, "checked", checked) : defaultChecked !== null && pushAttribute(target, responseState, "checked", defaultChecked), value !== null ? pushAttribute(target, responseState, "value", value) : defaultValue !== null && pushAttribute(target, responseState, "value", defaultValue), target.push(endOfStartTagSelfClosing), null;
      }
      function pushStartTextArea(target, props, responseState) {
        checkControlledValueProps("textarea", props), props.value !== void 0 && props.defaultValue !== void 0 && !didWarnDefaultTextareaValue && (error("Textarea elements must be either controlled or uncontrolled (specify either the value prop, or the defaultValue prop, but not both). Decide between using a controlled or uncontrolled textarea and remove one of these props. More info: https://reactjs.org/link/controlled-components"), didWarnDefaultTextareaValue = !0), target.push(startChunkForTag("textarea"));
        var value = null, defaultValue = null, children = null;
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
                children = propValue;
                break;
              case "value":
                value = propValue;
                break;
              case "defaultValue":
                defaultValue = propValue;
                break;
              case "dangerouslySetInnerHTML":
                throw new Error("`dangerouslySetInnerHTML` does not make sense on <textarea>.");
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        if (value === null && defaultValue !== null && (value = defaultValue), target.push(endOfStartTag), children != null) {
          if (error("Use the `defaultValue` or `value` props instead of setting children on <textarea>."), value != null)
            throw new Error("If you supply `defaultValue` on a <textarea>, do not pass children.");
          if (isArray(children)) {
            if (children.length > 1)
              throw new Error("<textarea> can only have at most one child.");
            checkHtmlStringCoercion(children[0]), value = "" + children[0];
          }
          checkHtmlStringCoercion(children), value = "" + children;
        }
        return typeof value == "string" && value[0] === `
` && target.push(leadingNewline), value !== null && (checkAttributeStringCoercion(value, "value"), target.push(encodeHTMLTextNode("" + value))), null;
      }
      function pushSelfClosing(target, props, tag, responseState) {
        target.push(startChunkForTag(tag));
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
              case "dangerouslySetInnerHTML":
                throw new Error(tag + " is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        return target.push(endOfStartTagSelfClosing), null;
      }
      function pushStartMenuItem(target, props, responseState) {
        target.push(startChunkForTag("menuitem"));
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
              case "dangerouslySetInnerHTML":
                throw new Error("menuitems cannot have `children` nor `dangerouslySetInnerHTML`.");
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        return target.push(endOfStartTag), null;
      }
      function pushStartTitle(target, props, responseState) {
        target.push(startChunkForTag("title"));
        var children = null;
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
                children = propValue;
                break;
              case "dangerouslySetInnerHTML":
                throw new Error("`dangerouslySetInnerHTML` does not make sense on <title>.");
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        target.push(endOfStartTag);
        {
          var child = Array.isArray(children) && children.length < 2 ? children[0] || null : children;
          Array.isArray(children) && children.length > 1 ? error("A title element received an array with more than 1 element as children. In browsers title Elements can only have Text Nodes as children. If the children being rendered output more than a single text node in aggregate the browser will display markup and comments as text in the title and hydration will likely fail and fall back to client rendering") : child != null && child.$$typeof != null ? error("A title element received a React element for children. In the browser title Elements can only have Text Nodes as children. If the children being rendered output more than a single text node in aggregate the browser will display markup and comments as text in the title and hydration will likely fail and fall back to client rendering") : child != null && typeof child != "string" && typeof child != "number" && error("A title element received a value that was not a string or number for children. In the browser title Elements can only have Text Nodes as children. If the children being rendered output more than a single text node in aggregate the browser will display markup and comments as text in the title and hydration will likely fail and fall back to client rendering");
        }
        return children;
      }
      function pushStartGenericElement(target, props, tag, responseState) {
        target.push(startChunkForTag(tag));
        var children = null, innerHTML = null;
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
                children = propValue;
                break;
              case "dangerouslySetInnerHTML":
                innerHTML = propValue;
                break;
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        return target.push(endOfStartTag), pushInnerHTML(target, innerHTML, children), typeof children == "string" ? (target.push(encodeHTMLTextNode(children)), null) : children;
      }
      function pushStartCustomElement(target, props, tag, responseState) {
        target.push(startChunkForTag(tag));
        var children = null, innerHTML = null;
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
                children = propValue;
                break;
              case "dangerouslySetInnerHTML":
                innerHTML = propValue;
                break;
              case "style":
                pushStyle(target, responseState, propValue);
                break;
              case "suppressContentEditableWarning":
              case "suppressHydrationWarning":
                break;
              default:
                isAttributeNameSafe(propKey) && typeof propValue != "function" && typeof propValue != "symbol" && target.push(attributeSeparator, propKey, attributeAssign, escapeTextForBrowser(propValue), attributeEnd);
                break;
            }
          }
        return target.push(endOfStartTag), pushInnerHTML(target, innerHTML, children), children;
      }
      var leadingNewline = `
`;
      function pushStartPreformattedElement(target, props, tag, responseState) {
        target.push(startChunkForTag(tag));
        var children = null, innerHTML = null;
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
                children = propValue;
                break;
              case "dangerouslySetInnerHTML":
                innerHTML = propValue;
                break;
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        if (target.push(endOfStartTag), innerHTML != null) {
          if (children != null)
            throw new Error("Can only set one of `children` or `props.dangerouslySetInnerHTML`.");
          if (typeof innerHTML != "object" || !("__html" in innerHTML))
            throw new Error("`props.dangerouslySetInnerHTML` must be in the form `{__html: ...}`. Please visit https://reactjs.org/link/dangerously-set-inner-html for more information.");
          var html = innerHTML.__html;
          html != null && (typeof html == "string" && html.length > 0 && html[0] === `
` ? target.push(leadingNewline, html) : (checkHtmlStringCoercion(html), target.push("" + html)));
        }
        return typeof children == "string" && children[0] === `
` && target.push(leadingNewline), children;
      }
      var VALID_TAG_REGEX = /^[a-zA-Z][a-zA-Z:_\.\-\d]*$/, validatedTagCache = /* @__PURE__ */ new Map();
      function startChunkForTag(tag) {
        var tagStartChunk = validatedTagCache.get(tag);
        if (tagStartChunk === void 0) {
          if (!VALID_TAG_REGEX.test(tag))
            throw new Error("Invalid tag: " + tag);
          tagStartChunk = "<" + tag, validatedTagCache.set(tag, tagStartChunk);
        }
        return tagStartChunk;
      }
      var DOCTYPE = "<!DOCTYPE html>";
      function pushStartInstance(target, type, props, responseState, formatContext) {
        switch (validateProperties(type, props), validateProperties$1(type, props), validateProperties$2(type, props, null), !props.suppressContentEditableWarning && props.contentEditable && props.children != null && error("A component is `contentEditable` and contains `children` managed by React. It is now your responsibility to guarantee that none of those nodes are unexpectedly modified or duplicated. This is probably not intentional."), formatContext.insertionMode !== SVG_MODE && formatContext.insertionMode !== MATHML_MODE && type.indexOf("-") === -1 && typeof props.is != "string" && type.toLowerCase() !== type && error("<%s /> is using incorrect casing. Use PascalCase for React components, or lowercase for HTML elements.", type), type) {
          case "select":
            return pushStartSelect(target, props, responseState);
          case "option":
            return pushStartOption(target, props, responseState, formatContext);
          case "textarea":
            return pushStartTextArea(target, props, responseState);
          case "input":
            return pushInput(target, props, responseState);
          case "menuitem":
            return pushStartMenuItem(target, props, responseState);
          case "title":
            return pushStartTitle(target, props, responseState);
          case "listing":
          case "pre":
            return pushStartPreformattedElement(target, props, type, responseState);
          case "area":
          case "base":
          case "br":
          case "col":
          case "embed":
          case "hr":
          case "img":
          case "keygen":
          case "link":
          case "meta":
          case "param":
          case "source":
          case "track":
          case "wbr":
            return pushSelfClosing(target, props, type, responseState);
          case "annotation-xml":
          case "color-profile":
          case "font-face":
          case "font-face-src":
          case "font-face-uri":
          case "font-face-format":
          case "font-face-name":
          case "missing-glyph":
            return pushStartGenericElement(target, props, type, responseState);
          case "html":
            return formatContext.insertionMode === ROOT_HTML_MODE && target.push(DOCTYPE), pushStartGenericElement(target, props, type, responseState);
          default:
            return type.indexOf("-") === -1 && typeof props.is != "string" ? pushStartGenericElement(target, props, type, responseState) : pushStartCustomElement(target, props, type, responseState);
        }
      }
      var endTag1 = "</", endTag2 = ">";
      function pushEndInstance(target, type, props) {
        switch (type) {
          case "area":
          case "base":
          case "br":
          case "col":
          case "embed":
          case "hr":
          case "img":
          case "input":
          case "keygen":
          case "link":
          case "meta":
          case "param":
          case "source":
          case "track":
          case "wbr":
            break;
          default:
            target.push(endTag1, type, endTag2);
        }
      }
      function writeCompletedRoot(destination, responseState) {
        for (var bootstrapChunks = responseState.bootstrapChunks, i = 0; i < bootstrapChunks.length - 1; i++)
          writeChunk(destination, bootstrapChunks[i]);
        return i < bootstrapChunks.length ? writeChunkAndReturn(destination, bootstrapChunks[i]) : !0;
      }
      var placeholder1 = '<template id="', placeholder2 = '"></template>';
      function writePlaceholder(destination, responseState, id) {
        writeChunk(destination, placeholder1), writeChunk(destination, responseState.placeholderPrefix);
        var formattedID = id.toString(16);
        return writeChunk(destination, formattedID), writeChunkAndReturn(destination, placeholder2);
      }
      var startCompletedSuspenseBoundary = "<!--$-->", startPendingSuspenseBoundary1 = '<!--$?--><template id="', startPendingSuspenseBoundary2 = '"></template>', startClientRenderedSuspenseBoundary = "<!--$!-->", endSuspenseBoundary = "<!--/$-->", clientRenderedSuspenseBoundaryError1 = "<template", clientRenderedSuspenseBoundaryErrorAttrInterstitial = '"', clientRenderedSuspenseBoundaryError1A = ' data-dgst="', clientRenderedSuspenseBoundaryError1B = ' data-msg="', clientRenderedSuspenseBoundaryError1C = ' data-stck="', clientRenderedSuspenseBoundaryError2 = "></template>";
      function writeStartCompletedSuspenseBoundary(destination, responseState) {
        return writeChunkAndReturn(destination, startCompletedSuspenseBoundary);
      }
      function writeStartPendingSuspenseBoundary(destination, responseState, id) {
        if (writeChunk(destination, startPendingSuspenseBoundary1), id === null)
          throw new Error("An ID must have been assigned before we can complete the boundary.");
        return writeChunk(destination, id), writeChunkAndReturn(destination, startPendingSuspenseBoundary2);
      }
      function writeStartClientRenderedSuspenseBoundary(destination, responseState, errorDigest, errorMesssage, errorComponentStack) {
        var result;
        return result = writeChunkAndReturn(destination, startClientRenderedSuspenseBoundary), writeChunk(destination, clientRenderedSuspenseBoundaryError1), errorDigest && (writeChunk(destination, clientRenderedSuspenseBoundaryError1A), writeChunk(destination, escapeTextForBrowser(errorDigest)), writeChunk(destination, clientRenderedSuspenseBoundaryErrorAttrInterstitial)), errorMesssage && (writeChunk(destination, clientRenderedSuspenseBoundaryError1B), writeChunk(destination, escapeTextForBrowser(errorMesssage)), writeChunk(destination, clientRenderedSuspenseBoundaryErrorAttrInterstitial)), errorComponentStack && (writeChunk(destination, clientRenderedSuspenseBoundaryError1C), writeChunk(destination, escapeTextForBrowser(errorComponentStack)), writeChunk(destination, clientRenderedSuspenseBoundaryErrorAttrInterstitial)), result = writeChunkAndReturn(destination, clientRenderedSuspenseBoundaryError2), result;
      }
      function writeEndCompletedSuspenseBoundary(destination, responseState) {
        return writeChunkAndReturn(destination, endSuspenseBoundary);
      }
      function writeEndPendingSuspenseBoundary(destination, responseState) {
        return writeChunkAndReturn(destination, endSuspenseBoundary);
      }
      function writeEndClientRenderedSuspenseBoundary(destination, responseState) {
        return writeChunkAndReturn(destination, endSuspenseBoundary);
      }
      var startSegmentHTML = '<div hidden id="', startSegmentHTML2 = '">', endSegmentHTML = "</div>", startSegmentSVG = '<svg aria-hidden="true" style="display:none" id="', startSegmentSVG2 = '">', endSegmentSVG = "</svg>", startSegmentMathML = '<math aria-hidden="true" style="display:none" id="', startSegmentMathML2 = '">', endSegmentMathML = "</math>", startSegmentTable = '<table hidden id="', startSegmentTable2 = '">', endSegmentTable = "</table>", startSegmentTableBody = '<table hidden><tbody id="', startSegmentTableBody2 = '">', endSegmentTableBody = "</tbody></table>", startSegmentTableRow = '<table hidden><tr id="', startSegmentTableRow2 = '">', endSegmentTableRow = "</tr></table>", startSegmentColGroup = '<table hidden><colgroup id="', startSegmentColGroup2 = '">', endSegmentColGroup = "</colgroup></table>";
      function writeStartSegment(destination, responseState, formatContext, id) {
        switch (formatContext.insertionMode) {
          case ROOT_HTML_MODE:
          case HTML_MODE:
            return writeChunk(destination, startSegmentHTML), writeChunk(destination, responseState.segmentPrefix), writeChunk(destination, id.toString(16)), writeChunkAndReturn(destination, startSegmentHTML2);
          case SVG_MODE:
            return writeChunk(destination, startSegmentSVG), writeChunk(destination, responseState.segmentPrefix), writeChunk(destination, id.toString(16)), writeChunkAndReturn(destination, startSegmentSVG2);
          case MATHML_MODE:
            return writeChunk(destination, startSegmentMathML), writeChunk(destination, responseState.segmentPrefix), writeChunk(destination, id.toString(16)), writeChunkAndReturn(destination, startSegmentMathML2);
          case HTML_TABLE_MODE:
            return writeChunk(destination, startSegmentTable), writeChunk(destination, responseState.segmentPrefix), writeChunk(destination, id.toString(16)), writeChunkAndReturn(destination, startSegmentTable2);
          case HTML_TABLE_BODY_MODE:
            return writeChunk(destination, startSegmentTableBody), writeChunk(destination, responseState.segmentPrefix), writeChunk(destination, id.toString(16)), writeChunkAndReturn(destination, startSegmentTableBody2);
          case HTML_TABLE_ROW_MODE:
            return writeChunk(destination, startSegmentTableRow), writeChunk(destination, responseState.segmentPrefix), writeChunk(destination, id.toString(16)), writeChunkAndReturn(destination, startSegmentTableRow2);
          case HTML_COLGROUP_MODE:
            return writeChunk(destination, startSegmentColGroup), writeChunk(destination, responseState.segmentPrefix), writeChunk(destination, id.toString(16)), writeChunkAndReturn(destination, startSegmentColGroup2);
          default:
            throw new Error("Unknown insertion mode. This is a bug in React.");
        }
      }
      function writeEndSegment(destination, formatContext) {
        switch (formatContext.insertionMode) {
          case ROOT_HTML_MODE:
          case HTML_MODE:
            return writeChunkAndReturn(destination, endSegmentHTML);
          case SVG_MODE:
            return writeChunkAndReturn(destination, endSegmentSVG);
          case MATHML_MODE:
            return writeChunkAndReturn(destination, endSegmentMathML);
          case HTML_TABLE_MODE:
            return writeChunkAndReturn(destination, endSegmentTable);
          case HTML_TABLE_BODY_MODE:
            return writeChunkAndReturn(destination, endSegmentTableBody);
          case HTML_TABLE_ROW_MODE:
            return writeChunkAndReturn(destination, endSegmentTableRow);
          case HTML_COLGROUP_MODE:
            return writeChunkAndReturn(destination, endSegmentColGroup);
          default:
            throw new Error("Unknown insertion mode. This is a bug in React.");
        }
      }
      var completeSegmentFunction = "function $RS(a,b){a=document.getElementById(a);b=document.getElementById(b);for(a.parentNode.removeChild(a);a.firstChild;)b.parentNode.insertBefore(a.firstChild,b);b.parentNode.removeChild(b)}", completeBoundaryFunction = 'function $RC(a,b){a=document.getElementById(a);b=document.getElementById(b);b.parentNode.removeChild(b);if(a){a=a.previousSibling;var f=a.parentNode,c=a.nextSibling,e=0;do{if(c&&8===c.nodeType){var d=c.data;if("/$"===d)if(0===e)break;else e--;else"$"!==d&&"$?"!==d&&"$!"!==d||e++}d=c.nextSibling;f.removeChild(c);c=d}while(c);for(;b.firstChild;)f.insertBefore(b.firstChild,c);a.data="$";a._reactRetry&&a._reactRetry()}}', clientRenderFunction = 'function $RX(b,c,d,e){var a=document.getElementById(b);a&&(b=a.previousSibling,b.data="$!",a=a.dataset,c&&(a.dgst=c),d&&(a.msg=d),e&&(a.stck=e),b._reactRetry&&b._reactRetry())}', completeSegmentScript1Full = completeSegmentFunction + ';$RS("', completeSegmentScript1Partial = '$RS("', completeSegmentScript2 = '","', completeSegmentScript3 = '")</script>';
      function writeCompletedSegmentInstruction(destination, responseState, contentSegmentID) {
        writeChunk(destination, responseState.startInlineScript), responseState.sentCompleteSegmentFunction ? writeChunk(destination, completeSegmentScript1Partial) : (responseState.sentCompleteSegmentFunction = !0, writeChunk(destination, completeSegmentScript1Full)), writeChunk(destination, responseState.segmentPrefix);
        var formattedID = contentSegmentID.toString(16);
        return writeChunk(destination, formattedID), writeChunk(destination, completeSegmentScript2), writeChunk(destination, responseState.placeholderPrefix), writeChunk(destination, formattedID), writeChunkAndReturn(destination, completeSegmentScript3);
      }
      var completeBoundaryScript1Full = completeBoundaryFunction + ';$RC("', completeBoundaryScript1Partial = '$RC("', completeBoundaryScript2 = '","', completeBoundaryScript3 = '")</script>';
      function writeCompletedBoundaryInstruction(destination, responseState, boundaryID, contentSegmentID) {
        if (writeChunk(destination, responseState.startInlineScript), responseState.sentCompleteBoundaryFunction ? writeChunk(destination, completeBoundaryScript1Partial) : (responseState.sentCompleteBoundaryFunction = !0, writeChunk(destination, completeBoundaryScript1Full)), boundaryID === null)
          throw new Error("An ID must have been assigned before we can complete the boundary.");
        var formattedContentID = contentSegmentID.toString(16);
        return writeChunk(destination, boundaryID), writeChunk(destination, completeBoundaryScript2), writeChunk(destination, responseState.segmentPrefix), writeChunk(destination, formattedContentID), writeChunkAndReturn(destination, completeBoundaryScript3);
      }
      var clientRenderScript1Full = clientRenderFunction + ';$RX("', clientRenderScript1Partial = '$RX("', clientRenderScript1A = '"', clientRenderScript2 = ")</script>", clientRenderErrorScriptArgInterstitial = ",";
      function writeClientRenderBoundaryInstruction(destination, responseState, boundaryID, errorDigest, errorMessage2, errorComponentStack) {
        if (writeChunk(destination, responseState.startInlineScript), responseState.sentClientRenderFunction ? writeChunk(destination, clientRenderScript1Partial) : (responseState.sentClientRenderFunction = !0, writeChunk(destination, clientRenderScript1Full)), boundaryID === null)
          throw new Error("An ID must have been assigned before we can complete the boundary.");
        return writeChunk(destination, boundaryID), writeChunk(destination, clientRenderScript1A), (errorDigest || errorMessage2 || errorComponentStack) && (writeChunk(destination, clientRenderErrorScriptArgInterstitial), writeChunk(destination, escapeJSStringsForInstructionScripts(errorDigest || ""))), (errorMessage2 || errorComponentStack) && (writeChunk(destination, clientRenderErrorScriptArgInterstitial), writeChunk(destination, escapeJSStringsForInstructionScripts(errorMessage2 || ""))), errorComponentStack && (writeChunk(destination, clientRenderErrorScriptArgInterstitial), writeChunk(destination, escapeJSStringsForInstructionScripts(errorComponentStack))), writeChunkAndReturn(destination, clientRenderScript2);
      }
      var regexForJSStringsInScripts = /[<\u2028\u2029]/g;
      function escapeJSStringsForInstructionScripts(input) {
        var escaped = JSON.stringify(input);
        return escaped.replace(regexForJSStringsInScripts, function(match2) {
          switch (match2) {
            case "<":
              return "\\u003c";
            case "\u2028":
              return "\\u2028";
            case "\u2029":
              return "\\u2029";
            default:
              throw new Error("escapeJSStringsForInstructionScripts encountered a match it does not know how to replace. this means the match regex and the replacement characters are no longer in sync. This is a bug in React");
          }
        });
      }
      function createResponseState$1(generateStaticMarkup, identifierPrefix) {
        var responseState = createResponseState(identifierPrefix, void 0);
        return {
          // Keep this in sync with ReactDOMServerFormatConfig
          bootstrapChunks: responseState.bootstrapChunks,
          startInlineScript: responseState.startInlineScript,
          placeholderPrefix: responseState.placeholderPrefix,
          segmentPrefix: responseState.segmentPrefix,
          boundaryPrefix: responseState.boundaryPrefix,
          idPrefix: responseState.idPrefix,
          nextSuspenseID: responseState.nextSuspenseID,
          sentCompleteSegmentFunction: responseState.sentCompleteSegmentFunction,
          sentCompleteBoundaryFunction: responseState.sentCompleteBoundaryFunction,
          sentClientRenderFunction: responseState.sentClientRenderFunction,
          // This is an extra field for the legacy renderer
          generateStaticMarkup
        };
      }
      function createRootFormatContext() {
        return {
          insertionMode: HTML_MODE,
          // We skip the root mode because we don't want to emit the DOCTYPE in legacy mode.
          selectedValue: null
        };
      }
      function pushTextInstance$1(target, text, responseState, textEmbedded) {
        return responseState.generateStaticMarkup ? (target.push(escapeTextForBrowser(text)), !1) : pushTextInstance(target, text, responseState, textEmbedded);
      }
      function pushSegmentFinale$1(target, responseState, lastPushedText, textEmbedded) {
        if (!responseState.generateStaticMarkup)
          return pushSegmentFinale(target, responseState, lastPushedText, textEmbedded);
      }
      function writeStartCompletedSuspenseBoundary$1(destination, responseState) {
        return responseState.generateStaticMarkup ? !0 : writeStartCompletedSuspenseBoundary(destination);
      }
      function writeStartClientRenderedSuspenseBoundary$1(destination, responseState, errorDigest, errorMessage2, errorComponentStack) {
        return responseState.generateStaticMarkup ? !0 : writeStartClientRenderedSuspenseBoundary(destination, responseState, errorDigest, errorMessage2, errorComponentStack);
      }
      function writeEndCompletedSuspenseBoundary$1(destination, responseState) {
        return responseState.generateStaticMarkup ? !0 : writeEndCompletedSuspenseBoundary(destination);
      }
      function writeEndClientRenderedSuspenseBoundary$1(destination, responseState) {
        return responseState.generateStaticMarkup ? !0 : writeEndClientRenderedSuspenseBoundary(destination);
      }
      var assign = Object.assign, REACT_ELEMENT_TYPE = Symbol.for("react.element"), REACT_PORTAL_TYPE = Symbol.for("react.portal"), REACT_FRAGMENT_TYPE = Symbol.for("react.fragment"), REACT_STRICT_MODE_TYPE = Symbol.for("react.strict_mode"), REACT_PROFILER_TYPE = Symbol.for("react.profiler"), REACT_PROVIDER_TYPE = Symbol.for("react.provider"), REACT_CONTEXT_TYPE = Symbol.for("react.context"), REACT_FORWARD_REF_TYPE = Symbol.for("react.forward_ref"), REACT_SUSPENSE_TYPE = Symbol.for("react.suspense"), REACT_SUSPENSE_LIST_TYPE = Symbol.for("react.suspense_list"), REACT_MEMO_TYPE = Symbol.for("react.memo"), REACT_LAZY_TYPE = Symbol.for("react.lazy"), REACT_SCOPE_TYPE = Symbol.for("react.scope"), REACT_DEBUG_TRACING_MODE_TYPE = Symbol.for("react.debug_trace_mode"), REACT_LEGACY_HIDDEN_TYPE = Symbol.for("react.legacy_hidden"), REACT_SERVER_CONTEXT_DEFAULT_VALUE_NOT_LOADED = Symbol.for("react.default_value"), MAYBE_ITERATOR_SYMBOL = Symbol.iterator, FAUX_ITERATOR_SYMBOL = "@@iterator";
      function getIteratorFn(maybeIterable) {
        if (maybeIterable === null || typeof maybeIterable != "object")
          return null;
        var maybeIterator = MAYBE_ITERATOR_SYMBOL && maybeIterable[MAYBE_ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL];
        return typeof maybeIterator == "function" ? maybeIterator : null;
      }
      function getWrappedName(outerType, innerType, wrapperName) {
        var displayName = outerType.displayName;
        if (displayName)
          return displayName;
        var functionName = innerType.displayName || innerType.name || "";
        return functionName !== "" ? wrapperName + "(" + functionName + ")" : wrapperName;
      }
      function getContextName(type) {
        return type.displayName || "Context";
      }
      function getComponentNameFromType(type) {
        if (type == null)
          return null;
        if (typeof type.tag == "number" && error("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue."), typeof type == "function")
          return type.displayName || type.name || null;
        if (typeof type == "string")
          return type;
        switch (type) {
          case REACT_FRAGMENT_TYPE:
            return "Fragment";
          case REACT_PORTAL_TYPE:
            return "Portal";
          case REACT_PROFILER_TYPE:
            return "Profiler";
          case REACT_STRICT_MODE_TYPE:
            return "StrictMode";
          case REACT_SUSPENSE_TYPE:
            return "Suspense";
          case REACT_SUSPENSE_LIST_TYPE:
            return "SuspenseList";
        }
        if (typeof type == "object")
          switch (type.$$typeof) {
            case REACT_CONTEXT_TYPE:
              var context = type;
              return getContextName(context) + ".Consumer";
            case REACT_PROVIDER_TYPE:
              var provider = type;
              return getContextName(provider._context) + ".Provider";
            case REACT_FORWARD_REF_TYPE:
              return getWrappedName(type, type.render, "ForwardRef");
            case REACT_MEMO_TYPE:
              var outerName = type.displayName || null;
              return outerName !== null ? outerName : getComponentNameFromType(type.type) || "Memo";
            case REACT_LAZY_TYPE: {
              var lazyComponent = type, payload = lazyComponent._payload, init4 = lazyComponent._init;
              try {
                return getComponentNameFromType(init4(payload));
              } catch {
                return null;
              }
            }
          }
        return null;
      }
      var disabledDepth = 0, prevLog, prevInfo, prevWarn, prevError, prevGroup, prevGroupCollapsed, prevGroupEnd;
      function disabledLog() {
      }
      disabledLog.__reactDisabledLog = !0;
      function disableLogs() {
        {
          if (disabledDepth === 0) {
            prevLog = console.log, prevInfo = console.info, prevWarn = console.warn, prevError = console.error, prevGroup = console.group, prevGroupCollapsed = console.groupCollapsed, prevGroupEnd = console.groupEnd;
            var props = {
              configurable: !0,
              enumerable: !0,
              value: disabledLog,
              writable: !0
            };
            Object.defineProperties(console, {
              info: props,
              log: props,
              warn: props,
              error: props,
              group: props,
              groupCollapsed: props,
              groupEnd: props
            });
          }
          disabledDepth++;
        }
      }
      function reenableLogs() {
        {
          if (disabledDepth--, disabledDepth === 0) {
            var props = {
              configurable: !0,
              enumerable: !0,
              writable: !0
            };
            Object.defineProperties(console, {
              log: assign({}, props, {
                value: prevLog
              }),
              info: assign({}, props, {
                value: prevInfo
              }),
              warn: assign({}, props, {
                value: prevWarn
              }),
              error: assign({}, props, {
                value: prevError
              }),
              group: assign({}, props, {
                value: prevGroup
              }),
              groupCollapsed: assign({}, props, {
                value: prevGroupCollapsed
              }),
              groupEnd: assign({}, props, {
                value: prevGroupEnd
              })
            });
          }
          disabledDepth < 0 && error("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
        }
      }
      var ReactCurrentDispatcher = ReactSharedInternals.ReactCurrentDispatcher, prefix;
      function describeBuiltInComponentFrame(name, source, ownerFn) {
        {
          if (prefix === void 0)
            try {
              throw Error();
            } catch (x) {
              var match2 = x.stack.trim().match(/\n( *(at )?)/);
              prefix = match2 && match2[1] || "";
            }
          return `
` + prefix + name;
        }
      }
      var reentry = !1, componentFrameCache;
      {
        var PossiblyWeakMap = typeof WeakMap == "function" ? WeakMap : Map;
        componentFrameCache = new PossiblyWeakMap();
      }
      function describeNativeComponentFrame(fn, construct) {
        if (!fn || reentry)
          return "";
        {
          var frame = componentFrameCache.get(fn);
          if (frame !== void 0)
            return frame;
        }
        var control;
        reentry = !0;
        var previousPrepareStackTrace = Error.prepareStackTrace;
        Error.prepareStackTrace = void 0;
        var previousDispatcher;
        previousDispatcher = ReactCurrentDispatcher.current, ReactCurrentDispatcher.current = null, disableLogs();
        try {
          if (construct) {
            var Fake = function() {
              throw Error();
            };
            if (Object.defineProperty(Fake.prototype, "props", {
              set: function() {
                throw Error();
              }
            }), typeof Reflect == "object" && Reflect.construct) {
              try {
                Reflect.construct(Fake, []);
              } catch (x) {
                control = x;
              }
              Reflect.construct(fn, [], Fake);
            } else {
              try {
                Fake.call();
              } catch (x) {
                control = x;
              }
              fn.call(Fake.prototype);
            }
          } else {
            try {
              throw Error();
            } catch (x) {
              control = x;
            }
            fn();
          }
        } catch (sample) {
          if (sample && control && typeof sample.stack == "string") {
            for (var sampleLines = sample.stack.split(`
`), controlLines = control.stack.split(`
`), s = sampleLines.length - 1, c = controlLines.length - 1; s >= 1 && c >= 0 && sampleLines[s] !== controlLines[c]; )
              c--;
            for (; s >= 1 && c >= 0; s--, c--)
              if (sampleLines[s] !== controlLines[c]) {
                if (s !== 1 || c !== 1)
                  do
                    if (s--, c--, c < 0 || sampleLines[s] !== controlLines[c]) {
                      var _frame = `
` + sampleLines[s].replace(" at new ", " at ");
                      return fn.displayName && _frame.includes("<anonymous>") && (_frame = _frame.replace("<anonymous>", fn.displayName)), typeof fn == "function" && componentFrameCache.set(fn, _frame), _frame;
                    }
                  while (s >= 1 && c >= 0);
                break;
              }
          }
        } finally {
          reentry = !1, ReactCurrentDispatcher.current = previousDispatcher, reenableLogs(), Error.prepareStackTrace = previousPrepareStackTrace;
        }
        var name = fn ? fn.displayName || fn.name : "", syntheticFrame = name ? describeBuiltInComponentFrame(name) : "";
        return typeof fn == "function" && componentFrameCache.set(fn, syntheticFrame), syntheticFrame;
      }
      function describeClassComponentFrame(ctor, source, ownerFn) {
        return describeNativeComponentFrame(ctor, !0);
      }
      function describeFunctionComponentFrame(fn, source, ownerFn) {
        return describeNativeComponentFrame(fn, !1);
      }
      function shouldConstruct(Component) {
        var prototype = Component.prototype;
        return !!(prototype && prototype.isReactComponent);
      }
      function describeUnknownElementTypeFrameInDEV(type, source, ownerFn) {
        if (type == null)
          return "";
        if (typeof type == "function")
          return describeNativeComponentFrame(type, shouldConstruct(type));
        if (typeof type == "string")
          return describeBuiltInComponentFrame(type);
        switch (type) {
          case REACT_SUSPENSE_TYPE:
            return describeBuiltInComponentFrame("Suspense");
          case REACT_SUSPENSE_LIST_TYPE:
            return describeBuiltInComponentFrame("SuspenseList");
        }
        if (typeof type == "object")
          switch (type.$$typeof) {
            case REACT_FORWARD_REF_TYPE:
              return describeFunctionComponentFrame(type.render);
            case REACT_MEMO_TYPE:
              return describeUnknownElementTypeFrameInDEV(type.type, source, ownerFn);
            case REACT_LAZY_TYPE: {
              var lazyComponent = type, payload = lazyComponent._payload, init4 = lazyComponent._init;
              try {
                return describeUnknownElementTypeFrameInDEV(init4(payload), source, ownerFn);
              } catch {
              }
            }
          }
        return "";
      }
      var loggedTypeFailures = {}, ReactDebugCurrentFrame = ReactSharedInternals.ReactDebugCurrentFrame;
      function setCurrentlyValidatingElement(element) {
        if (element) {
          var owner = element._owner, stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
          ReactDebugCurrentFrame.setExtraStackFrame(stack);
        } else
          ReactDebugCurrentFrame.setExtraStackFrame(null);
      }
      function checkPropTypes(typeSpecs, values, location2, componentName, element) {
        {
          var has2 = Function.call.bind(hasOwnProperty);
          for (var typeSpecName in typeSpecs)
            if (has2(typeSpecs, typeSpecName)) {
              var error$1 = void 0;
              try {
                if (typeof typeSpecs[typeSpecName] != "function") {
                  var err2 = Error((componentName || "React class") + ": " + location2 + " type `" + typeSpecName + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof typeSpecs[typeSpecName] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                  throw err2.name = "Invariant Violation", err2;
                }
                error$1 = typeSpecs[typeSpecName](values, typeSpecName, componentName, location2, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
              } catch (ex) {
                error$1 = ex;
              }
              error$1 && !(error$1 instanceof Error) && (setCurrentlyValidatingElement(element), error("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", componentName || "React class", location2, typeSpecName, typeof error$1), setCurrentlyValidatingElement(null)), error$1 instanceof Error && !(error$1.message in loggedTypeFailures) && (loggedTypeFailures[error$1.message] = !0, setCurrentlyValidatingElement(element), error("Failed %s type: %s", location2, error$1.message), setCurrentlyValidatingElement(null));
            }
        }
      }
      var warnedAboutMissingGetChildContext;
      warnedAboutMissingGetChildContext = {};
      var emptyContextObject = {};
      Object.freeze(emptyContextObject);
      function getMaskedContext(type, unmaskedContext) {
        {
          var contextTypes = type.contextTypes;
          if (!contextTypes)
            return emptyContextObject;
          var context = {};
          for (var key in contextTypes)
            context[key] = unmaskedContext[key];
          {
            var name = getComponentNameFromType(type) || "Unknown";
            checkPropTypes(contextTypes, context, "context", name);
          }
          return context;
        }
      }
      function processChildContext(instance, type, parentContext, childContextTypes) {
        {
          if (typeof instance.getChildContext != "function") {
            {
              var componentName = getComponentNameFromType(type) || "Unknown";
              warnedAboutMissingGetChildContext[componentName] || (warnedAboutMissingGetChildContext[componentName] = !0, error("%s.childContextTypes is specified but there is no getChildContext() method on the instance. You can either define getChildContext() on %s or remove childContextTypes from it.", componentName, componentName));
            }
            return parentContext;
          }
          var childContext = instance.getChildContext();
          for (var contextKey in childContext)
            if (!(contextKey in childContextTypes))
              throw new Error((getComponentNameFromType(type) || "Unknown") + '.getChildContext(): key "' + contextKey + '" is not defined in childContextTypes.');
          {
            var name = getComponentNameFromType(type) || "Unknown";
            checkPropTypes(childContextTypes, childContext, "child context", name);
          }
          return assign({}, parentContext, childContext);
        }
      }
      var rendererSigil;
      rendererSigil = {};
      var rootContextSnapshot = null, currentActiveSnapshot = null;
      function popNode(prev) {
        prev.context._currentValue2 = prev.parentValue;
      }
      function pushNode(next) {
        next.context._currentValue2 = next.value;
      }
      function popToNearestCommonAncestor(prev, next) {
        if (prev !== next) {
          popNode(prev);
          var parentPrev = prev.parent, parentNext = next.parent;
          if (parentPrev === null) {
            if (parentNext !== null)
              throw new Error("The stacks must reach the root at the same time. This is a bug in React.");
          } else {
            if (parentNext === null)
              throw new Error("The stacks must reach the root at the same time. This is a bug in React.");
            popToNearestCommonAncestor(parentPrev, parentNext);
          }
          pushNode(next);
        }
      }
      function popAllPrevious(prev) {
        popNode(prev);
        var parentPrev = prev.parent;
        parentPrev !== null && popAllPrevious(parentPrev);
      }
      function pushAllNext(next) {
        var parentNext = next.parent;
        parentNext !== null && pushAllNext(parentNext), pushNode(next);
      }
      function popPreviousToCommonLevel(prev, next) {
        popNode(prev);
        var parentPrev = prev.parent;
        if (parentPrev === null)
          throw new Error("The depth must equal at least at zero before reaching the root. This is a bug in React.");
        parentPrev.depth === next.depth ? popToNearestCommonAncestor(parentPrev, next) : popPreviousToCommonLevel(parentPrev, next);
      }
      function popNextToCommonLevel(prev, next) {
        var parentNext = next.parent;
        if (parentNext === null)
          throw new Error("The depth must equal at least at zero before reaching the root. This is a bug in React.");
        prev.depth === parentNext.depth ? popToNearestCommonAncestor(prev, parentNext) : popNextToCommonLevel(prev, parentNext), pushNode(next);
      }
      function switchContext(newSnapshot) {
        var prev = currentActiveSnapshot, next = newSnapshot;
        prev !== next && (prev === null ? pushAllNext(next) : next === null ? popAllPrevious(prev) : prev.depth === next.depth ? popToNearestCommonAncestor(prev, next) : prev.depth > next.depth ? popPreviousToCommonLevel(prev, next) : popNextToCommonLevel(prev, next), currentActiveSnapshot = next);
      }
      function pushProvider(context, nextValue) {
        var prevValue;
        prevValue = context._currentValue2, context._currentValue2 = nextValue, context._currentRenderer2 !== void 0 && context._currentRenderer2 !== null && context._currentRenderer2 !== rendererSigil && error("Detected multiple renderers concurrently rendering the same context provider. This is currently unsupported."), context._currentRenderer2 = rendererSigil;
        var prevNode = currentActiveSnapshot, newNode = {
          parent: prevNode,
          depth: prevNode === null ? 0 : prevNode.depth + 1,
          context,
          parentValue: prevValue,
          value: nextValue
        };
        return currentActiveSnapshot = newNode, newNode;
      }
      function popProvider(context) {
        var prevSnapshot = currentActiveSnapshot;
        if (prevSnapshot === null)
          throw new Error("Tried to pop a Context at the root of the app. This is a bug in React.");
        prevSnapshot.context !== context && error("The parent context is not the expected context. This is probably a bug in React.");
        {
          var _value = prevSnapshot.parentValue;
          _value === REACT_SERVER_CONTEXT_DEFAULT_VALUE_NOT_LOADED ? prevSnapshot.context._currentValue2 = prevSnapshot.context._defaultValue : prevSnapshot.context._currentValue2 = _value, context._currentRenderer2 !== void 0 && context._currentRenderer2 !== null && context._currentRenderer2 !== rendererSigil && error("Detected multiple renderers concurrently rendering the same context provider. This is currently unsupported."), context._currentRenderer2 = rendererSigil;
        }
        return currentActiveSnapshot = prevSnapshot.parent;
      }
      function getActiveContext() {
        return currentActiveSnapshot;
      }
      function readContext(context) {
        var value = context._currentValue2;
        return value;
      }
      function get2(key) {
        return key._reactInternals;
      }
      function set2(key, value) {
        key._reactInternals = value;
      }
      var didWarnAboutNoopUpdateForComponent = {}, didWarnAboutDeprecatedWillMount = {}, didWarnAboutUninitializedState, didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate, didWarnAboutLegacyLifecyclesAndDerivedState, didWarnAboutUndefinedDerivedState, warnOnUndefinedDerivedState, warnOnInvalidCallback, didWarnAboutDirectlyAssigningPropsToState, didWarnAboutContextTypeAndContextTypes, didWarnAboutInvalidateContextType;
      {
        didWarnAboutUninitializedState = /* @__PURE__ */ new Set(), didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate = /* @__PURE__ */ new Set(), didWarnAboutLegacyLifecyclesAndDerivedState = /* @__PURE__ */ new Set(), didWarnAboutDirectlyAssigningPropsToState = /* @__PURE__ */ new Set(), didWarnAboutUndefinedDerivedState = /* @__PURE__ */ new Set(), didWarnAboutContextTypeAndContextTypes = /* @__PURE__ */ new Set(), didWarnAboutInvalidateContextType = /* @__PURE__ */ new Set();
        var didWarnOnInvalidCallback = /* @__PURE__ */ new Set();
        warnOnInvalidCallback = function(callback, callerName) {
          if (!(callback === null || typeof callback == "function")) {
            var key = callerName + "_" + callback;
            didWarnOnInvalidCallback.has(key) || (didWarnOnInvalidCallback.add(key), error("%s(...): Expected the last optional `callback` argument to be a function. Instead received: %s.", callerName, callback));
          }
        }, warnOnUndefinedDerivedState = function(type, partialState) {
          if (partialState === void 0) {
            var componentName = getComponentNameFromType(type) || "Component";
            didWarnAboutUndefinedDerivedState.has(componentName) || (didWarnAboutUndefinedDerivedState.add(componentName), error("%s.getDerivedStateFromProps(): A valid state object (or null) must be returned. You have returned undefined.", componentName));
          }
        };
      }
      function warnNoop(publicInstance, callerName) {
        {
          var _constructor = publicInstance.constructor, componentName = _constructor && getComponentNameFromType(_constructor) || "ReactClass", warningKey = componentName + "." + callerName;
          if (didWarnAboutNoopUpdateForComponent[warningKey])
            return;
          error(`%s(...): Can only update a mounting component. This usually means you called %s() outside componentWillMount() on the server. This is a no-op.

Please check the code for the %s component.`, callerName, callerName, componentName), didWarnAboutNoopUpdateForComponent[warningKey] = !0;
        }
      }
      var classComponentUpdater = {
        isMounted: function(inst) {
          return !1;
        },
        enqueueSetState: function(inst, payload, callback) {
          var internals = get2(inst);
          internals.queue === null ? warnNoop(inst, "setState") : (internals.queue.push(payload), callback != null && warnOnInvalidCallback(callback, "setState"));
        },
        enqueueReplaceState: function(inst, payload, callback) {
          var internals = get2(inst);
          internals.replace = !0, internals.queue = [payload], callback != null && warnOnInvalidCallback(callback, "setState");
        },
        enqueueForceUpdate: function(inst, callback) {
          var internals = get2(inst);
          internals.queue === null ? warnNoop(inst, "forceUpdate") : callback != null && warnOnInvalidCallback(callback, "setState");
        }
      };
      function applyDerivedStateFromProps(instance, ctor, getDerivedStateFromProps, prevState, nextProps) {
        var partialState = getDerivedStateFromProps(nextProps, prevState);
        warnOnUndefinedDerivedState(ctor, partialState);
        var newState = partialState == null ? prevState : assign({}, prevState, partialState);
        return newState;
      }
      function constructClassInstance(ctor, props, maskedLegacyContext) {
        var context = emptyContextObject, contextType = ctor.contextType;
        if ("contextType" in ctor) {
          var isValid = (
            // Allow null for conditional declaration
            contextType === null || contextType !== void 0 && contextType.$$typeof === REACT_CONTEXT_TYPE && contextType._context === void 0
          );
          if (!isValid && !didWarnAboutInvalidateContextType.has(ctor)) {
            didWarnAboutInvalidateContextType.add(ctor);
            var addendum = "";
            contextType === void 0 ? addendum = " However, it is set to undefined. This can be caused by a typo or by mixing up named and default imports. This can also happen due to a circular dependency, so try moving the createContext() call to a separate file." : typeof contextType != "object" ? addendum = " However, it is set to a " + typeof contextType + "." : contextType.$$typeof === REACT_PROVIDER_TYPE ? addendum = " Did you accidentally pass the Context.Provider instead?" : contextType._context !== void 0 ? addendum = " Did you accidentally pass the Context.Consumer instead?" : addendum = " However, it is set to an object with keys {" + Object.keys(contextType).join(", ") + "}.", error("%s defines an invalid contextType. contextType should point to the Context object returned by React.createContext().%s", getComponentNameFromType(ctor) || "Component", addendum);
          }
        }
        typeof contextType == "object" && contextType !== null ? context = readContext(contextType) : context = maskedLegacyContext;
        var instance = new ctor(props, context);
        {
          if (typeof ctor.getDerivedStateFromProps == "function" && (instance.state === null || instance.state === void 0)) {
            var componentName = getComponentNameFromType(ctor) || "Component";
            didWarnAboutUninitializedState.has(componentName) || (didWarnAboutUninitializedState.add(componentName), error("`%s` uses `getDerivedStateFromProps` but its initial state is %s. This is not recommended. Instead, define the initial state by assigning an object to `this.state` in the constructor of `%s`. This ensures that `getDerivedStateFromProps` arguments have a consistent shape.", componentName, instance.state === null ? "null" : "undefined", componentName));
          }
          if (typeof ctor.getDerivedStateFromProps == "function" || typeof instance.getSnapshotBeforeUpdate == "function") {
            var foundWillMountName = null, foundWillReceivePropsName = null, foundWillUpdateName = null;
            if (typeof instance.componentWillMount == "function" && instance.componentWillMount.__suppressDeprecationWarning !== !0 ? foundWillMountName = "componentWillMount" : typeof instance.UNSAFE_componentWillMount == "function" && (foundWillMountName = "UNSAFE_componentWillMount"), typeof instance.componentWillReceiveProps == "function" && instance.componentWillReceiveProps.__suppressDeprecationWarning !== !0 ? foundWillReceivePropsName = "componentWillReceiveProps" : typeof instance.UNSAFE_componentWillReceiveProps == "function" && (foundWillReceivePropsName = "UNSAFE_componentWillReceiveProps"), typeof instance.componentWillUpdate == "function" && instance.componentWillUpdate.__suppressDeprecationWarning !== !0 ? foundWillUpdateName = "componentWillUpdate" : typeof instance.UNSAFE_componentWillUpdate == "function" && (foundWillUpdateName = "UNSAFE_componentWillUpdate"), foundWillMountName !== null || foundWillReceivePropsName !== null || foundWillUpdateName !== null) {
              var _componentName = getComponentNameFromType(ctor) || "Component", newApiName = typeof ctor.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
              didWarnAboutLegacyLifecyclesAndDerivedState.has(_componentName) || (didWarnAboutLegacyLifecyclesAndDerivedState.add(_componentName), error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

%s uses %s but also contains the following legacy lifecycles:%s%s%s

The above lifecycles should be removed. Learn more about this warning here:
https://reactjs.org/link/unsafe-component-lifecycles`, _componentName, newApiName, foundWillMountName !== null ? `
  ` + foundWillMountName : "", foundWillReceivePropsName !== null ? `
  ` + foundWillReceivePropsName : "", foundWillUpdateName !== null ? `
  ` + foundWillUpdateName : ""));
            }
          }
        }
        return instance;
      }
      function checkClassInstance(instance, ctor, newProps) {
        {
          var name = getComponentNameFromType(ctor) || "Component", renderPresent = instance.render;
          renderPresent || (ctor.prototype && typeof ctor.prototype.render == "function" ? error("%s(...): No `render` method found on the returned component instance: did you accidentally return an object from the constructor?", name) : error("%s(...): No `render` method found on the returned component instance: you may have forgotten to define `render`.", name)), instance.getInitialState && !instance.getInitialState.isReactClassApproved && !instance.state && error("getInitialState was defined on %s, a plain JavaScript class. This is only supported for classes created using React.createClass. Did you mean to define a state property instead?", name), instance.getDefaultProps && !instance.getDefaultProps.isReactClassApproved && error("getDefaultProps was defined on %s, a plain JavaScript class. This is only supported for classes created using React.createClass. Use a static property to define defaultProps instead.", name), instance.propTypes && error("propTypes was defined as an instance property on %s. Use a static property to define propTypes instead.", name), instance.contextType && error("contextType was defined as an instance property on %s. Use a static property to define contextType instead.", name), instance.contextTypes && error("contextTypes was defined as an instance property on %s. Use a static property to define contextTypes instead.", name), ctor.contextType && ctor.contextTypes && !didWarnAboutContextTypeAndContextTypes.has(ctor) && (didWarnAboutContextTypeAndContextTypes.add(ctor), error("%s declares both contextTypes and contextType static properties. The legacy contextTypes property will be ignored.", name)), typeof instance.componentShouldUpdate == "function" && error("%s has a method called componentShouldUpdate(). Did you mean shouldComponentUpdate()? The name is phrased as a question because the function is expected to return a value.", name), ctor.prototype && ctor.prototype.isPureReactComponent && typeof instance.shouldComponentUpdate < "u" && error("%s has a method called shouldComponentUpdate(). shouldComponentUpdate should not be used when extending React.PureComponent. Please extend React.Component if shouldComponentUpdate is used.", getComponentNameFromType(ctor) || "A pure component"), typeof instance.componentDidUnmount == "function" && error("%s has a method called componentDidUnmount(). But there is no such lifecycle method. Did you mean componentWillUnmount()?", name), typeof instance.componentDidReceiveProps == "function" && error("%s has a method called componentDidReceiveProps(). But there is no such lifecycle method. If you meant to update the state in response to changing props, use componentWillReceiveProps(). If you meant to fetch data or run side-effects or mutations after React has updated the UI, use componentDidUpdate().", name), typeof instance.componentWillRecieveProps == "function" && error("%s has a method called componentWillRecieveProps(). Did you mean componentWillReceiveProps()?", name), typeof instance.UNSAFE_componentWillRecieveProps == "function" && error("%s has a method called UNSAFE_componentWillRecieveProps(). Did you mean UNSAFE_componentWillReceiveProps()?", name);
          var hasMutatedProps = instance.props !== newProps;
          instance.props !== void 0 && hasMutatedProps && error("%s(...): When calling super() in `%s`, make sure to pass up the same props that your component's constructor was passed.", name, name), instance.defaultProps && error("Setting defaultProps as an instance property on %s is not supported and will be ignored. Instead, define defaultProps as a static property on %s.", name, name), typeof instance.getSnapshotBeforeUpdate == "function" && typeof instance.componentDidUpdate != "function" && !didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate.has(ctor) && (didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate.add(ctor), error("%s: getSnapshotBeforeUpdate() should be used with componentDidUpdate(). This component defines getSnapshotBeforeUpdate() only.", getComponentNameFromType(ctor))), typeof instance.getDerivedStateFromProps == "function" && error("%s: getDerivedStateFromProps() is defined as an instance method and will be ignored. Instead, declare it as a static method.", name), typeof instance.getDerivedStateFromError == "function" && error("%s: getDerivedStateFromError() is defined as an instance method and will be ignored. Instead, declare it as a static method.", name), typeof ctor.getSnapshotBeforeUpdate == "function" && error("%s: getSnapshotBeforeUpdate() is defined as a static method and will be ignored. Instead, declare it as an instance method.", name);
          var _state = instance.state;
          _state && (typeof _state != "object" || isArray(_state)) && error("%s.state: must be set to an object or null", name), typeof instance.getChildContext == "function" && typeof ctor.childContextTypes != "object" && error("%s.getChildContext(): childContextTypes must be defined in order to use getChildContext().", name);
        }
      }
      function callComponentWillMount(type, instance) {
        var oldState = instance.state;
        if (typeof instance.componentWillMount == "function") {
          if (instance.componentWillMount.__suppressDeprecationWarning !== !0) {
            var componentName = getComponentNameFromType(type) || "Unknown";
            didWarnAboutDeprecatedWillMount[componentName] || (warn(
              // keep this warning in sync with ReactStrictModeWarning.js
              `componentWillMount has been renamed, and is not recommended for use. See https://reactjs.org/link/unsafe-component-lifecycles for details.

* Move code from componentWillMount to componentDidMount (preferred in most cases) or the constructor.

Please update the following components: %s`,
              componentName
            ), didWarnAboutDeprecatedWillMount[componentName] = !0);
          }
          instance.componentWillMount();
        }
        typeof instance.UNSAFE_componentWillMount == "function" && instance.UNSAFE_componentWillMount(), oldState !== instance.state && (error("%s.componentWillMount(): Assigning directly to this.state is deprecated (except inside a component's constructor). Use setState instead.", getComponentNameFromType(type) || "Component"), classComponentUpdater.enqueueReplaceState(instance, instance.state, null));
      }
      function processUpdateQueue(internalInstance, inst, props, maskedLegacyContext) {
        if (internalInstance.queue !== null && internalInstance.queue.length > 0) {
          var oldQueue = internalInstance.queue, oldReplace = internalInstance.replace;
          if (internalInstance.queue = null, internalInstance.replace = !1, oldReplace && oldQueue.length === 1)
            inst.state = oldQueue[0];
          else {
            for (var nextState = oldReplace ? oldQueue[0] : inst.state, dontMutate = !0, i = oldReplace ? 1 : 0; i < oldQueue.length; i++) {
              var partial = oldQueue[i], partialState = typeof partial == "function" ? partial.call(inst, nextState, props, maskedLegacyContext) : partial;
              partialState != null && (dontMutate ? (dontMutate = !1, nextState = assign({}, nextState, partialState)) : assign(nextState, partialState));
            }
            inst.state = nextState;
          }
        } else
          internalInstance.queue = null;
      }
      function mountClassInstance(instance, ctor, newProps, maskedLegacyContext) {
        checkClassInstance(instance, ctor, newProps);
        var initialState = instance.state !== void 0 ? instance.state : null;
        instance.updater = classComponentUpdater, instance.props = newProps, instance.state = initialState;
        var internalInstance = {
          queue: [],
          replace: !1
        };
        set2(instance, internalInstance);
        var contextType = ctor.contextType;
        if (typeof contextType == "object" && contextType !== null ? instance.context = readContext(contextType) : instance.context = maskedLegacyContext, instance.state === newProps) {
          var componentName = getComponentNameFromType(ctor) || "Component";
          didWarnAboutDirectlyAssigningPropsToState.has(componentName) || (didWarnAboutDirectlyAssigningPropsToState.add(componentName), error("%s: It is not recommended to assign props directly to state because updates to props won't be reflected in state. In most cases, it is better to use props directly.", componentName));
        }
        var getDerivedStateFromProps = ctor.getDerivedStateFromProps;
        typeof getDerivedStateFromProps == "function" && (instance.state = applyDerivedStateFromProps(instance, ctor, getDerivedStateFromProps, initialState, newProps)), typeof ctor.getDerivedStateFromProps != "function" && typeof instance.getSnapshotBeforeUpdate != "function" && (typeof instance.UNSAFE_componentWillMount == "function" || typeof instance.componentWillMount == "function") && (callComponentWillMount(ctor, instance), processUpdateQueue(internalInstance, instance, newProps, maskedLegacyContext));
      }
      var emptyTreeContext = {
        id: 1,
        overflow: ""
      };
      function getTreeId(context) {
        var overflow = context.overflow, idWithLeadingBit = context.id, id = idWithLeadingBit & ~getLeadingBit(idWithLeadingBit);
        return id.toString(32) + overflow;
      }
      function pushTreeContext(baseContext, totalChildren, index) {
        var baseIdWithLeadingBit = baseContext.id, baseOverflow = baseContext.overflow, baseLength = getBitLength(baseIdWithLeadingBit) - 1, baseId = baseIdWithLeadingBit & ~(1 << baseLength), slot = index + 1, length = getBitLength(totalChildren) + baseLength;
        if (length > 30) {
          var numberOfOverflowBits = baseLength - baseLength % 5, newOverflowBits = (1 << numberOfOverflowBits) - 1, newOverflow = (baseId & newOverflowBits).toString(32), restOfBaseId = baseId >> numberOfOverflowBits, restOfBaseLength = baseLength - numberOfOverflowBits, restOfLength = getBitLength(totalChildren) + restOfBaseLength, restOfNewBits = slot << restOfBaseLength, id = restOfNewBits | restOfBaseId, overflow = newOverflow + baseOverflow;
          return {
            id: 1 << restOfLength | id,
            overflow
          };
        } else {
          var newBits = slot << baseLength, _id = newBits | baseId, _overflow = baseOverflow;
          return {
            id: 1 << length | _id,
            overflow: _overflow
          };
        }
      }
      function getBitLength(number) {
        return 32 - clz32(number);
      }
      function getLeadingBit(id) {
        return 1 << getBitLength(id) - 1;
      }
      var clz32 = Math.clz32 ? Math.clz32 : clz32Fallback, log = Math.log, LN2 = Math.LN2;
      function clz32Fallback(x) {
        var asUint = x >>> 0;
        return asUint === 0 ? 32 : 31 - (log(asUint) / LN2 | 0) | 0;
      }
      function is(x, y) {
        return x === y && (x !== 0 || 1 / x === 1 / y) || x !== x && y !== y;
      }
      var objectIs = typeof Object.is == "function" ? Object.is : is, currentlyRenderingComponent = null, currentlyRenderingTask = null, firstWorkInProgressHook = null, workInProgressHook = null, isReRender = !1, didScheduleRenderPhaseUpdate = !1, localIdCounter = 0, renderPhaseUpdates = null, numberOfReRenders = 0, RE_RENDER_LIMIT = 25, isInHookUserCodeInDev = !1, currentHookNameInDev;
      function resolveCurrentlyRenderingComponent() {
        if (currentlyRenderingComponent === null)
          throw new Error(`Invalid hook call. Hooks can only be called inside of the body of a function component. This could happen for one of the following reasons:
1. You might have mismatching versions of React and the renderer (such as React DOM)
2. You might be breaking the Rules of Hooks
3. You might have more than one copy of React in the same app
See https://reactjs.org/link/invalid-hook-call for tips about how to debug and fix this problem.`);
        return isInHookUserCodeInDev && error("Do not call Hooks inside useEffect(...), useMemo(...), or other built-in Hooks. You can only call Hooks at the top level of your React function. For more information, see https://reactjs.org/link/rules-of-hooks"), currentlyRenderingComponent;
      }
      function areHookInputsEqual(nextDeps, prevDeps) {
        if (prevDeps === null)
          return error("%s received a final argument during this render, but not during the previous render. Even though the final argument is optional, its type cannot change between renders.", currentHookNameInDev), !1;
        nextDeps.length !== prevDeps.length && error(`The final argument passed to %s changed size between renders. The order and size of this array must remain constant.

Previous: %s
Incoming: %s`, currentHookNameInDev, "[" + nextDeps.join(", ") + "]", "[" + prevDeps.join(", ") + "]");
        for (var i = 0; i < prevDeps.length && i < nextDeps.length; i++)
          if (!objectIs(nextDeps[i], prevDeps[i]))
            return !1;
        return !0;
      }
      function createHook() {
        if (numberOfReRenders > 0)
          throw new Error("Rendered more hooks than during the previous render");
        return {
          memoizedState: null,
          queue: null,
          next: null
        };
      }
      function createWorkInProgressHook() {
        return workInProgressHook === null ? firstWorkInProgressHook === null ? (isReRender = !1, firstWorkInProgressHook = workInProgressHook = createHook()) : (isReRender = !0, workInProgressHook = firstWorkInProgressHook) : workInProgressHook.next === null ? (isReRender = !1, workInProgressHook = workInProgressHook.next = createHook()) : (isReRender = !0, workInProgressHook = workInProgressHook.next), workInProgressHook;
      }
      function prepareToUseHooks(task, componentIdentity) {
        currentlyRenderingComponent = componentIdentity, currentlyRenderingTask = task, isInHookUserCodeInDev = !1, localIdCounter = 0;
      }
      function finishHooks(Component, props, children, refOrContext) {
        for (; didScheduleRenderPhaseUpdate; )
          didScheduleRenderPhaseUpdate = !1, localIdCounter = 0, numberOfReRenders += 1, workInProgressHook = null, children = Component(props, refOrContext);
        return resetHooksState(), children;
      }
      function checkDidRenderIdHook() {
        var didRenderIdHook = localIdCounter !== 0;
        return didRenderIdHook;
      }
      function resetHooksState() {
        isInHookUserCodeInDev = !1, currentlyRenderingComponent = null, currentlyRenderingTask = null, didScheduleRenderPhaseUpdate = !1, firstWorkInProgressHook = null, numberOfReRenders = 0, renderPhaseUpdates = null, workInProgressHook = null;
      }
      function readContext$1(context) {
        return isInHookUserCodeInDev && error("Context can only be read while React is rendering. In classes, you can read it in the render method or getDerivedStateFromProps. In function components, you can read it directly in the function body, but not inside Hooks like useReducer() or useMemo()."), readContext(context);
      }
      function useContext(context) {
        return currentHookNameInDev = "useContext", resolveCurrentlyRenderingComponent(), readContext(context);
      }
      function basicStateReducer(state, action) {
        return typeof action == "function" ? action(state) : action;
      }
      function useState4(initialState) {
        return currentHookNameInDev = "useState", useReducer(
          basicStateReducer,
          // useReducer has a special case to support lazy useState initializers
          initialState
        );
      }
      function useReducer(reducer, initialArg, init4) {
        if (reducer !== basicStateReducer && (currentHookNameInDev = "useReducer"), currentlyRenderingComponent = resolveCurrentlyRenderingComponent(), workInProgressHook = createWorkInProgressHook(), isReRender) {
          var queue = workInProgressHook.queue, dispatch = queue.dispatch;
          if (renderPhaseUpdates !== null) {
            var firstRenderPhaseUpdate = renderPhaseUpdates.get(queue);
            if (firstRenderPhaseUpdate !== void 0) {
              renderPhaseUpdates.delete(queue);
              var newState = workInProgressHook.memoizedState, update2 = firstRenderPhaseUpdate;
              do {
                var action = update2.action;
                isInHookUserCodeInDev = !0, newState = reducer(newState, action), isInHookUserCodeInDev = !1, update2 = update2.next;
              } while (update2 !== null);
              return workInProgressHook.memoizedState = newState, [newState, dispatch];
            }
          }
          return [workInProgressHook.memoizedState, dispatch];
        } else {
          isInHookUserCodeInDev = !0;
          var initialState;
          reducer === basicStateReducer ? initialState = typeof initialArg == "function" ? initialArg() : initialArg : initialState = init4 !== void 0 ? init4(initialArg) : initialArg, isInHookUserCodeInDev = !1, workInProgressHook.memoizedState = initialState;
          var _queue = workInProgressHook.queue = {
            last: null,
            dispatch: null
          }, _dispatch = _queue.dispatch = dispatchAction.bind(null, currentlyRenderingComponent, _queue);
          return [workInProgressHook.memoizedState, _dispatch];
        }
      }
      function useMemo2(nextCreate, deps) {
        currentlyRenderingComponent = resolveCurrentlyRenderingComponent(), workInProgressHook = createWorkInProgressHook();
        var nextDeps = deps === void 0 ? null : deps;
        if (workInProgressHook !== null) {
          var prevState = workInProgressHook.memoizedState;
          if (prevState !== null && nextDeps !== null) {
            var prevDeps = prevState[1];
            if (areHookInputsEqual(nextDeps, prevDeps))
              return prevState[0];
          }
        }
        isInHookUserCodeInDev = !0;
        var nextValue = nextCreate();
        return isInHookUserCodeInDev = !1, workInProgressHook.memoizedState = [nextValue, nextDeps], nextValue;
      }
      function useRef2(initialValue) {
        currentlyRenderingComponent = resolveCurrentlyRenderingComponent(), workInProgressHook = createWorkInProgressHook();
        var previousRef = workInProgressHook.memoizedState;
        if (previousRef === null) {
          var ref = {
            current: initialValue
          };
          return Object.seal(ref), workInProgressHook.memoizedState = ref, ref;
        } else
          return previousRef;
      }
      function useLayoutEffect(create, inputs) {
        currentHookNameInDev = "useLayoutEffect", error("useLayoutEffect does nothing on the server, because its effect cannot be encoded into the server renderer's output format. This will lead to a mismatch between the initial, non-hydrated UI and the intended UI. To avoid this, useLayoutEffect should only be used in components that render exclusively on the client. See https://reactjs.org/link/uselayouteffect-ssr for common fixes.");
      }
      function dispatchAction(componentIdentity, queue, action) {
        if (numberOfReRenders >= RE_RENDER_LIMIT)
          throw new Error("Too many re-renders. React limits the number of renders to prevent an infinite loop.");
        if (componentIdentity === currentlyRenderingComponent) {
          didScheduleRenderPhaseUpdate = !0;
          var update2 = {
            action,
            next: null
          };
          renderPhaseUpdates === null && (renderPhaseUpdates = /* @__PURE__ */ new Map());
          var firstRenderPhaseUpdate = renderPhaseUpdates.get(queue);
          if (firstRenderPhaseUpdate === void 0)
            renderPhaseUpdates.set(queue, update2);
          else {
            for (var lastRenderPhaseUpdate = firstRenderPhaseUpdate; lastRenderPhaseUpdate.next !== null; )
              lastRenderPhaseUpdate = lastRenderPhaseUpdate.next;
            lastRenderPhaseUpdate.next = update2;
          }
        }
      }
      function useCallback(callback, deps) {
        return useMemo2(function() {
          return callback;
        }, deps);
      }
      function useMutableSource(source, getSnapshot, subscribe) {
        return resolveCurrentlyRenderingComponent(), getSnapshot(source._source);
      }
      function useSyncExternalStore(subscribe, getSnapshot, getServerSnapshot) {
        if (getServerSnapshot === void 0)
          throw new Error("Missing getServerSnapshot, which is required for server-rendered content. Will revert to client rendering.");
        return getServerSnapshot();
      }
      function useDeferredValue(value) {
        return resolveCurrentlyRenderingComponent(), value;
      }
      function unsupportedStartTransition() {
        throw new Error("startTransition cannot be called during server rendering.");
      }
      function useTransition() {
        return resolveCurrentlyRenderingComponent(), [!1, unsupportedStartTransition];
      }
      function useId() {
        var task = currentlyRenderingTask, treeId = getTreeId(task.treeContext), responseState = currentResponseState;
        if (responseState === null)
          throw new Error("Invalid hook call. Hooks can only be called inside of the body of a function component.");
        var localId = localIdCounter++;
        return makeId(responseState, treeId, localId);
      }
      function noop() {
      }
      var Dispatcher = {
        readContext: readContext$1,
        useContext,
        useMemo: useMemo2,
        useReducer,
        useRef: useRef2,
        useState: useState4,
        useInsertionEffect: noop,
        useLayoutEffect,
        useCallback,
        // useImperativeHandle is not run in the server environment
        useImperativeHandle: noop,
        // Effects are not run in the server environment.
        useEffect: noop,
        // Debugging effect
        useDebugValue: noop,
        useDeferredValue,
        useTransition,
        useId,
        // Subscriptions are not setup in a server environment.
        useMutableSource,
        useSyncExternalStore
      }, currentResponseState = null;
      function setCurrentResponseState(responseState) {
        currentResponseState = responseState;
      }
      function getStackByComponentStackNode(componentStack) {
        try {
          var info2 = "", node = componentStack;
          do {
            switch (node.tag) {
              case 0:
                info2 += describeBuiltInComponentFrame(node.type, null, null);
                break;
              case 1:
                info2 += describeFunctionComponentFrame(node.type, null, null);
                break;
              case 2:
                info2 += describeClassComponentFrame(node.type, null, null);
                break;
            }
            node = node.parent;
          } while (node);
          return info2;
        } catch (x) {
          return `
Error generating stack: ` + x.message + `
` + x.stack;
        }
      }
      var ReactCurrentDispatcher$1 = ReactSharedInternals.ReactCurrentDispatcher, ReactDebugCurrentFrame$1 = ReactSharedInternals.ReactDebugCurrentFrame, PENDING = 0, COMPLETED = 1, FLUSHED = 2, ABORTED = 3, ERRORED = 4, OPEN = 0, CLOSING = 1, CLOSED = 2, DEFAULT_PROGRESSIVE_CHUNK_SIZE = 12800;
      function defaultErrorHandler(error2) {
        return console.error(error2), null;
      }
      function noop$1() {
      }
      function createRequest(children, responseState, rootFormatContext, progressiveChunkSize, onError2, onAllReady, onShellReady, onShellError, onFatalError) {
        var pingedTasks = [], abortSet = /* @__PURE__ */ new Set(), request2 = {
          destination: null,
          responseState,
          progressiveChunkSize: progressiveChunkSize === void 0 ? DEFAULT_PROGRESSIVE_CHUNK_SIZE : progressiveChunkSize,
          status: OPEN,
          fatalError: null,
          nextSegmentId: 0,
          allPendingTasks: 0,
          pendingRootTasks: 0,
          completedRootSegment: null,
          abortableTasks: abortSet,
          pingedTasks,
          clientRenderedBoundaries: [],
          completedBoundaries: [],
          partialBoundaries: [],
          onError: onError2 === void 0 ? defaultErrorHandler : onError2,
          onAllReady: onAllReady === void 0 ? noop$1 : onAllReady,
          onShellReady: onShellReady === void 0 ? noop$1 : onShellReady,
          onShellError: onShellError === void 0 ? noop$1 : onShellError,
          onFatalError: onFatalError === void 0 ? noop$1 : onFatalError
        }, rootSegment = createPendingSegment(
          request2,
          0,
          null,
          rootFormatContext,
          // Root segments are never embedded in Text on either edge
          !1,
          !1
        );
        rootSegment.parentFlushed = !0;
        var rootTask = createTask(request2, children, null, rootSegment, abortSet, emptyContextObject, rootContextSnapshot, emptyTreeContext);
        return pingedTasks.push(rootTask), request2;
      }
      function pingTask(request2, task) {
        var pingedTasks = request2.pingedTasks;
        pingedTasks.push(task), pingedTasks.length === 1 && scheduleWork(function() {
          return performWork(request2);
        });
      }
      function createSuspenseBoundary(request2, fallbackAbortableTasks) {
        return {
          id: UNINITIALIZED_SUSPENSE_BOUNDARY_ID,
          rootSegmentID: -1,
          parentFlushed: !1,
          pendingTasks: 0,
          forceClientRender: !1,
          completedSegments: [],
          byteSize: 0,
          fallbackAbortableTasks,
          errorDigest: null
        };
      }
      function createTask(request2, node, blockedBoundary, blockedSegment, abortSet, legacyContext, context, treeContext) {
        request2.allPendingTasks++, blockedBoundary === null ? request2.pendingRootTasks++ : blockedBoundary.pendingTasks++;
        var task = {
          node,
          ping: function() {
            return pingTask(request2, task);
          },
          blockedBoundary,
          blockedSegment,
          abortSet,
          legacyContext,
          context,
          treeContext
        };
        return task.componentStack = null, abortSet.add(task), task;
      }
      function createPendingSegment(request2, index, boundary, formatContext, lastPushedText, textEmbedded) {
        return {
          status: PENDING,
          id: -1,
          // lazily assigned later
          index,
          parentFlushed: !1,
          chunks: [],
          children: [],
          formatContext,
          boundary,
          lastPushedText,
          textEmbedded
        };
      }
      var currentTaskInDEV = null;
      function getCurrentStackInDEV() {
        return currentTaskInDEV === null || currentTaskInDEV.componentStack === null ? "" : getStackByComponentStackNode(currentTaskInDEV.componentStack);
      }
      function pushBuiltInComponentStackInDEV(task, type) {
        task.componentStack = {
          tag: 0,
          parent: task.componentStack,
          type
        };
      }
      function pushFunctionComponentStackInDEV(task, type) {
        task.componentStack = {
          tag: 1,
          parent: task.componentStack,
          type
        };
      }
      function pushClassComponentStackInDEV(task, type) {
        task.componentStack = {
          tag: 2,
          parent: task.componentStack,
          type
        };
      }
      function popComponentStackInDEV(task) {
        task.componentStack === null ? error("Unexpectedly popped too many stack frames. This is a bug in React.") : task.componentStack = task.componentStack.parent;
      }
      var lastBoundaryErrorComponentStackDev = null;
      function captureBoundaryErrorDetailsDev(boundary, error2) {
        {
          var errorMessage2;
          typeof error2 == "string" ? errorMessage2 = error2 : error2 && typeof error2.message == "string" ? errorMessage2 = error2.message : errorMessage2 = String(error2);
          var errorComponentStack = lastBoundaryErrorComponentStackDev || getCurrentStackInDEV();
          lastBoundaryErrorComponentStackDev = null, boundary.errorMessage = errorMessage2, boundary.errorComponentStack = errorComponentStack;
        }
      }
      function logRecoverableError(request2, error2) {
        var errorDigest = request2.onError(error2);
        if (errorDigest != null && typeof errorDigest != "string")
          throw new Error('onError returned something with a type other than "string". onError should return a string and may return null or undefined but must not return anything else. It received something of type "' + typeof errorDigest + '" instead');
        return errorDigest;
      }
      function fatalError(request2, error2) {
        var onShellError = request2.onShellError;
        onShellError(error2);
        var onFatalError = request2.onFatalError;
        onFatalError(error2), request2.destination !== null ? (request2.status = CLOSED, closeWithError(request2.destination, error2)) : (request2.status = CLOSING, request2.fatalError = error2);
      }
      function renderSuspenseBoundary(request2, task, props) {
        pushBuiltInComponentStackInDEV(task, "Suspense");
        var parentBoundary = task.blockedBoundary, parentSegment = task.blockedSegment, fallback = props.fallback, content = props.children, fallbackAbortSet = /* @__PURE__ */ new Set(), newBoundary = createSuspenseBoundary(request2, fallbackAbortSet), insertionIndex = parentSegment.chunks.length, boundarySegment = createPendingSegment(
          request2,
          insertionIndex,
          newBoundary,
          parentSegment.formatContext,
          // boundaries never require text embedding at their edges because comment nodes bound them
          !1,
          !1
        );
        parentSegment.children.push(boundarySegment), parentSegment.lastPushedText = !1;
        var contentRootSegment = createPendingSegment(
          request2,
          0,
          null,
          parentSegment.formatContext,
          // boundaries never require text embedding at their edges because comment nodes bound them
          !1,
          !1
        );
        contentRootSegment.parentFlushed = !0, task.blockedBoundary = newBoundary, task.blockedSegment = contentRootSegment;
        try {
          if (renderNode(request2, task, content), pushSegmentFinale$1(contentRootSegment.chunks, request2.responseState, contentRootSegment.lastPushedText, contentRootSegment.textEmbedded), contentRootSegment.status = COMPLETED, queueCompletedSegment(newBoundary, contentRootSegment), newBoundary.pendingTasks === 0) {
            popComponentStackInDEV(task);
            return;
          }
        } catch (error2) {
          contentRootSegment.status = ERRORED, newBoundary.forceClientRender = !0, newBoundary.errorDigest = logRecoverableError(request2, error2), captureBoundaryErrorDetailsDev(newBoundary, error2);
        } finally {
          task.blockedBoundary = parentBoundary, task.blockedSegment = parentSegment;
        }
        var suspendedFallbackTask = createTask(request2, fallback, parentBoundary, boundarySegment, fallbackAbortSet, task.legacyContext, task.context, task.treeContext);
        suspendedFallbackTask.componentStack = task.componentStack, request2.pingedTasks.push(suspendedFallbackTask), popComponentStackInDEV(task);
      }
      function renderHostElement(request2, task, type, props) {
        pushBuiltInComponentStackInDEV(task, type);
        var segment = task.blockedSegment, children = pushStartInstance(segment.chunks, type, props, request2.responseState, segment.formatContext);
        segment.lastPushedText = !1;
        var prevContext = segment.formatContext;
        segment.formatContext = getChildFormatContext(prevContext, type, props), renderNode(request2, task, children), segment.formatContext = prevContext, pushEndInstance(segment.chunks, type), segment.lastPushedText = !1, popComponentStackInDEV(task);
      }
      function shouldConstruct$1(Component) {
        return Component.prototype && Component.prototype.isReactComponent;
      }
      function renderWithHooks(request2, task, Component, props, secondArg) {
        var componentIdentity = {};
        prepareToUseHooks(task, componentIdentity);
        var result = Component(props, secondArg);
        return finishHooks(Component, props, result, secondArg);
      }
      function finishClassComponent(request2, task, instance, Component, props) {
        var nextChildren = instance.render();
        instance.props !== props && (didWarnAboutReassigningProps || error("It looks like %s is reassigning its own `this.props` while rendering. This is not supported and can lead to confusing bugs.", getComponentNameFromType(Component) || "a component"), didWarnAboutReassigningProps = !0);
        {
          var childContextTypes = Component.childContextTypes;
          if (childContextTypes != null) {
            var previousContext = task.legacyContext, mergedContext = processChildContext(instance, Component, previousContext, childContextTypes);
            task.legacyContext = mergedContext, renderNodeDestructive(request2, task, nextChildren), task.legacyContext = previousContext;
            return;
          }
        }
        renderNodeDestructive(request2, task, nextChildren);
      }
      function renderClassComponent(request2, task, Component, props) {
        pushClassComponentStackInDEV(task, Component);
        var maskedContext = getMaskedContext(Component, task.legacyContext), instance = constructClassInstance(Component, props, maskedContext);
        mountClassInstance(instance, Component, props, maskedContext), finishClassComponent(request2, task, instance, Component, props), popComponentStackInDEV(task);
      }
      var didWarnAboutBadClass = {}, didWarnAboutModulePatternComponent = {}, didWarnAboutContextTypeOnFunctionComponent = {}, didWarnAboutGetDerivedStateOnFunctionComponent = {}, didWarnAboutReassigningProps = !1, didWarnAboutGenerators = !1, didWarnAboutMaps = !1, hasWarnedAboutUsingContextAsConsumer = !1;
      function renderIndeterminateComponent(request2, task, Component, props) {
        var legacyContext;
        if (legacyContext = getMaskedContext(Component, task.legacyContext), pushFunctionComponentStackInDEV(task, Component), Component.prototype && typeof Component.prototype.render == "function") {
          var componentName = getComponentNameFromType(Component) || "Unknown";
          didWarnAboutBadClass[componentName] || (error("The <%s /> component appears to have a render method, but doesn't extend React.Component. This is likely to cause errors. Change %s to extend React.Component instead.", componentName, componentName), didWarnAboutBadClass[componentName] = !0);
        }
        var value = renderWithHooks(request2, task, Component, props, legacyContext), hasId = checkDidRenderIdHook();
        if (typeof value == "object" && value !== null && typeof value.render == "function" && value.$$typeof === void 0) {
          var _componentName = getComponentNameFromType(Component) || "Unknown";
          didWarnAboutModulePatternComponent[_componentName] || (error("The <%s /> component appears to be a function component that returns a class instance. Change %s to a class that extends React.Component instead. If you can't use a class try assigning the prototype on the function as a workaround. `%s.prototype = React.Component.prototype`. Don't use an arrow function since it cannot be called with `new` by React.", _componentName, _componentName, _componentName), didWarnAboutModulePatternComponent[_componentName] = !0);
        }
        if (
          // Run these checks in production only if the flag is off.
          // Eventually we'll delete this branch altogether.
          typeof value == "object" && value !== null && typeof value.render == "function" && value.$$typeof === void 0
        ) {
          {
            var _componentName2 = getComponentNameFromType(Component) || "Unknown";
            didWarnAboutModulePatternComponent[_componentName2] || (error("The <%s /> component appears to be a function component that returns a class instance. Change %s to a class that extends React.Component instead. If you can't use a class try assigning the prototype on the function as a workaround. `%s.prototype = React.Component.prototype`. Don't use an arrow function since it cannot be called with `new` by React.", _componentName2, _componentName2, _componentName2), didWarnAboutModulePatternComponent[_componentName2] = !0);
          }
          mountClassInstance(value, Component, props, legacyContext), finishClassComponent(request2, task, value, Component, props);
        } else if (validateFunctionComponentInDev(Component), hasId) {
          var prevTreeContext = task.treeContext, totalChildren = 1, index = 0;
          task.treeContext = pushTreeContext(prevTreeContext, totalChildren, index);
          try {
            renderNodeDestructive(request2, task, value);
          } finally {
            task.treeContext = prevTreeContext;
          }
        } else
          renderNodeDestructive(request2, task, value);
        popComponentStackInDEV(task);
      }
      function validateFunctionComponentInDev(Component) {
        {
          if (Component && Component.childContextTypes && error("%s(...): childContextTypes cannot be defined on a function component.", Component.displayName || Component.name || "Component"), typeof Component.getDerivedStateFromProps == "function") {
            var _componentName3 = getComponentNameFromType(Component) || "Unknown";
            didWarnAboutGetDerivedStateOnFunctionComponent[_componentName3] || (error("%s: Function components do not support getDerivedStateFromProps.", _componentName3), didWarnAboutGetDerivedStateOnFunctionComponent[_componentName3] = !0);
          }
          if (typeof Component.contextType == "object" && Component.contextType !== null) {
            var _componentName4 = getComponentNameFromType(Component) || "Unknown";
            didWarnAboutContextTypeOnFunctionComponent[_componentName4] || (error("%s: Function components do not support contextType.", _componentName4), didWarnAboutContextTypeOnFunctionComponent[_componentName4] = !0);
          }
        }
      }
      function resolveDefaultProps(Component, baseProps) {
        if (Component && Component.defaultProps) {
          var props = assign({}, baseProps), defaultProps = Component.defaultProps;
          for (var propName in defaultProps)
            props[propName] === void 0 && (props[propName] = defaultProps[propName]);
          return props;
        }
        return baseProps;
      }
      function renderForwardRef(request2, task, type, props, ref) {
        pushFunctionComponentStackInDEV(task, type.render);
        var children = renderWithHooks(request2, task, type.render, props, ref), hasId = checkDidRenderIdHook();
        if (hasId) {
          var prevTreeContext = task.treeContext, totalChildren = 1, index = 0;
          task.treeContext = pushTreeContext(prevTreeContext, totalChildren, index);
          try {
            renderNodeDestructive(request2, task, children);
          } finally {
            task.treeContext = prevTreeContext;
          }
        } else
          renderNodeDestructive(request2, task, children);
        popComponentStackInDEV(task);
      }
      function renderMemo(request2, task, type, props, ref) {
        var innerType = type.type, resolvedProps = resolveDefaultProps(innerType, props);
        renderElement(request2, task, innerType, resolvedProps, ref);
      }
      function renderContextConsumer(request2, task, context, props) {
        context._context === void 0 ? context !== context.Consumer && (hasWarnedAboutUsingContextAsConsumer || (hasWarnedAboutUsingContextAsConsumer = !0, error("Rendering <Context> directly is not supported and will be removed in a future major release. Did you mean to render <Context.Consumer> instead?"))) : context = context._context;
        var render3 = props.children;
        typeof render3 != "function" && error("A context consumer was rendered with multiple children, or a child that isn't a function. A context consumer expects a single child that is a function. If you did pass a function, make sure there is no trailing or leading whitespace around it.");
        var newValue = readContext(context), newChildren = render3(newValue);
        renderNodeDestructive(request2, task, newChildren);
      }
      function renderContextProvider(request2, task, type, props) {
        var context = type._context, value = props.value, children = props.children, prevSnapshot;
        prevSnapshot = task.context, task.context = pushProvider(context, value), renderNodeDestructive(request2, task, children), task.context = popProvider(context), prevSnapshot !== task.context && error("Popping the context provider did not return back to the original snapshot. This is a bug in React.");
      }
      function renderLazyComponent(request2, task, lazyComponent, props, ref) {
        pushBuiltInComponentStackInDEV(task, "Lazy");
        var payload = lazyComponent._payload, init4 = lazyComponent._init, Component = init4(payload), resolvedProps = resolveDefaultProps(Component, props);
        renderElement(request2, task, Component, resolvedProps, ref), popComponentStackInDEV(task);
      }
      function renderElement(request2, task, type, props, ref) {
        if (typeof type == "function")
          if (shouldConstruct$1(type)) {
            renderClassComponent(request2, task, type, props);
            return;
          } else {
            renderIndeterminateComponent(request2, task, type, props);
            return;
          }
        if (typeof type == "string") {
          renderHostElement(request2, task, type, props);
          return;
        }
        switch (type) {
          case REACT_LEGACY_HIDDEN_TYPE:
          case REACT_DEBUG_TRACING_MODE_TYPE:
          case REACT_STRICT_MODE_TYPE:
          case REACT_PROFILER_TYPE:
          case REACT_FRAGMENT_TYPE: {
            renderNodeDestructive(request2, task, props.children);
            return;
          }
          case REACT_SUSPENSE_LIST_TYPE: {
            pushBuiltInComponentStackInDEV(task, "SuspenseList"), renderNodeDestructive(request2, task, props.children), popComponentStackInDEV(task);
            return;
          }
          case REACT_SCOPE_TYPE:
            throw new Error("ReactDOMServer does not yet support scope components.");
          case REACT_SUSPENSE_TYPE: {
            renderSuspenseBoundary(request2, task, props);
            return;
          }
        }
        if (typeof type == "object" && type !== null)
          switch (type.$$typeof) {
            case REACT_FORWARD_REF_TYPE: {
              renderForwardRef(request2, task, type, props, ref);
              return;
            }
            case REACT_MEMO_TYPE: {
              renderMemo(request2, task, type, props, ref);
              return;
            }
            case REACT_PROVIDER_TYPE: {
              renderContextProvider(request2, task, type, props);
              return;
            }
            case REACT_CONTEXT_TYPE: {
              renderContextConsumer(request2, task, type, props);
              return;
            }
            case REACT_LAZY_TYPE: {
              renderLazyComponent(request2, task, type, props);
              return;
            }
          }
        var info2 = "";
        throw (type === void 0 || typeof type == "object" && type !== null && Object.keys(type).length === 0) && (info2 += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports."), new Error("Element type is invalid: expected a string (for built-in components) or a class/function (for composite components) " + ("but got: " + (type == null ? type : typeof type) + "." + info2));
      }
      function validateIterable(iterable, iteratorFn) {
        typeof Symbol == "function" && // $FlowFixMe Flow doesn't know about toStringTag
        iterable[Symbol.toStringTag] === "Generator" && (didWarnAboutGenerators || error("Using Generators as children is unsupported and will likely yield unexpected results because enumerating a generator mutates it. You may convert it to an array with `Array.from()` or the `[...spread]` operator before rendering. Keep in mind you might need to polyfill these features for older browsers."), didWarnAboutGenerators = !0), iterable.entries === iteratorFn && (didWarnAboutMaps || error("Using Maps as children is not supported. Use an array of keyed ReactElements instead."), didWarnAboutMaps = !0);
      }
      function renderNodeDestructive(request2, task, node) {
        try {
          return renderNodeDestructiveImpl(request2, task, node);
        } catch (x) {
          throw typeof x == "object" && x !== null && typeof x.then == "function" || (lastBoundaryErrorComponentStackDev = lastBoundaryErrorComponentStackDev !== null ? lastBoundaryErrorComponentStackDev : getCurrentStackInDEV()), x;
        }
      }
      function renderNodeDestructiveImpl(request2, task, node) {
        if (task.node = node, typeof node == "object" && node !== null) {
          switch (node.$$typeof) {
            case REACT_ELEMENT_TYPE: {
              var element = node, type = element.type, props = element.props, ref = element.ref;
              renderElement(request2, task, type, props, ref);
              return;
            }
            case REACT_PORTAL_TYPE:
              throw new Error("Portals are not currently supported by the server renderer. Render them conditionally so that they only appear on the client render.");
            case REACT_LAZY_TYPE: {
              var lazyNode = node, payload = lazyNode._payload, init4 = lazyNode._init, resolvedNode;
              try {
                resolvedNode = init4(payload);
              } catch (x) {
                throw typeof x == "object" && x !== null && typeof x.then == "function" && pushBuiltInComponentStackInDEV(task, "Lazy"), x;
              }
              renderNodeDestructive(request2, task, resolvedNode);
              return;
            }
          }
          if (isArray(node)) {
            renderChildrenArray(request2, task, node);
            return;
          }
          var iteratorFn = getIteratorFn(node);
          if (iteratorFn) {
            validateIterable(node, iteratorFn);
            var iterator = iteratorFn.call(node);
            if (iterator) {
              var step = iterator.next();
              if (!step.done) {
                var children = [];
                do
                  children.push(step.value), step = iterator.next();
                while (!step.done);
                renderChildrenArray(request2, task, children);
                return;
              }
              return;
            }
          }
          var childString = Object.prototype.toString.call(node);
          throw new Error("Objects are not valid as a React child (found: " + (childString === "[object Object]" ? "object with keys {" + Object.keys(node).join(", ") + "}" : childString) + "). If you meant to render a collection of children, use an array instead.");
        }
        if (typeof node == "string") {
          var segment = task.blockedSegment;
          segment.lastPushedText = pushTextInstance$1(task.blockedSegment.chunks, node, request2.responseState, segment.lastPushedText);
          return;
        }
        if (typeof node == "number") {
          var _segment = task.blockedSegment;
          _segment.lastPushedText = pushTextInstance$1(task.blockedSegment.chunks, "" + node, request2.responseState, _segment.lastPushedText);
          return;
        }
        typeof node == "function" && error("Functions are not valid as a React child. This may happen if you return a Component instead of <Component /> from render. Or maybe you meant to call this function rather than return it.");
      }
      function renderChildrenArray(request2, task, children) {
        for (var totalChildren = children.length, i = 0; i < totalChildren; i++) {
          var prevTreeContext = task.treeContext;
          task.treeContext = pushTreeContext(prevTreeContext, totalChildren, i);
          try {
            renderNode(request2, task, children[i]);
          } finally {
            task.treeContext = prevTreeContext;
          }
        }
      }
      function spawnNewSuspendedTask(request2, task, x) {
        var segment = task.blockedSegment, insertionIndex = segment.chunks.length, newSegment = createPendingSegment(
          request2,
          insertionIndex,
          null,
          segment.formatContext,
          // Adopt the parent segment's leading text embed
          segment.lastPushedText,
          // Assume we are text embedded at the trailing edge
          !0
        );
        segment.children.push(newSegment), segment.lastPushedText = !1;
        var newTask = createTask(request2, task.node, task.blockedBoundary, newSegment, task.abortSet, task.legacyContext, task.context, task.treeContext);
        task.componentStack !== null && (newTask.componentStack = task.componentStack.parent);
        var ping = newTask.ping;
        x.then(ping, ping);
      }
      function renderNode(request2, task, node) {
        var previousFormatContext = task.blockedSegment.formatContext, previousLegacyContext = task.legacyContext, previousContext = task.context, previousComponentStack = null;
        previousComponentStack = task.componentStack;
        try {
          return renderNodeDestructive(request2, task, node);
        } catch (x) {
          if (resetHooksState(), typeof x == "object" && x !== null && typeof x.then == "function") {
            spawnNewSuspendedTask(request2, task, x), task.blockedSegment.formatContext = previousFormatContext, task.legacyContext = previousLegacyContext, task.context = previousContext, switchContext(previousContext), task.componentStack = previousComponentStack;
            return;
          } else
            throw task.blockedSegment.formatContext = previousFormatContext, task.legacyContext = previousLegacyContext, task.context = previousContext, switchContext(previousContext), task.componentStack = previousComponentStack, x;
        }
      }
      function erroredTask(request2, boundary, segment, error2) {
        var errorDigest = logRecoverableError(request2, error2);
        if (boundary === null ? fatalError(request2, error2) : (boundary.pendingTasks--, boundary.forceClientRender || (boundary.forceClientRender = !0, boundary.errorDigest = errorDigest, captureBoundaryErrorDetailsDev(boundary, error2), boundary.parentFlushed && request2.clientRenderedBoundaries.push(boundary))), request2.allPendingTasks--, request2.allPendingTasks === 0) {
          var onAllReady = request2.onAllReady;
          onAllReady();
        }
      }
      function abortTaskSoft(task) {
        var request2 = this, boundary = task.blockedBoundary, segment = task.blockedSegment;
        segment.status = ABORTED, finishedTask(request2, boundary, segment);
      }
      function abortTask(task, request2, reason) {
        var boundary = task.blockedBoundary, segment = task.blockedSegment;
        if (segment.status = ABORTED, boundary === null)
          request2.allPendingTasks--, request2.status !== CLOSED && (request2.status = CLOSED, request2.destination !== null && close(request2.destination));
        else {
          if (boundary.pendingTasks--, !boundary.forceClientRender) {
            boundary.forceClientRender = !0;
            var _error = reason === void 0 ? new Error("The render was aborted by the server without a reason.") : reason;
            boundary.errorDigest = request2.onError(_error);
            {
              var errorPrefix = "The server did not finish this Suspense boundary: ";
              _error && typeof _error.message == "string" ? _error = errorPrefix + _error.message : _error = errorPrefix + String(_error);
              var previousTaskInDev = currentTaskInDEV;
              currentTaskInDEV = task;
              try {
                captureBoundaryErrorDetailsDev(boundary, _error);
              } finally {
                currentTaskInDEV = previousTaskInDev;
              }
            }
            boundary.parentFlushed && request2.clientRenderedBoundaries.push(boundary);
          }
          if (boundary.fallbackAbortableTasks.forEach(function(fallbackTask) {
            return abortTask(fallbackTask, request2, reason);
          }), boundary.fallbackAbortableTasks.clear(), request2.allPendingTasks--, request2.allPendingTasks === 0) {
            var onAllReady = request2.onAllReady;
            onAllReady();
          }
        }
      }
      function queueCompletedSegment(boundary, segment) {
        if (segment.chunks.length === 0 && segment.children.length === 1 && segment.children[0].boundary === null) {
          var childSegment = segment.children[0];
          childSegment.id = segment.id, childSegment.parentFlushed = !0, childSegment.status === COMPLETED && queueCompletedSegment(boundary, childSegment);
        } else {
          var completedSegments = boundary.completedSegments;
          completedSegments.push(segment);
        }
      }
      function finishedTask(request2, boundary, segment) {
        if (boundary === null) {
          if (segment.parentFlushed) {
            if (request2.completedRootSegment !== null)
              throw new Error("There can only be one root segment. This is a bug in React.");
            request2.completedRootSegment = segment;
          }
          if (request2.pendingRootTasks--, request2.pendingRootTasks === 0) {
            request2.onShellError = noop$1;
            var onShellReady = request2.onShellReady;
            onShellReady();
          }
        } else if (boundary.pendingTasks--, !boundary.forceClientRender) {
          if (boundary.pendingTasks === 0)
            segment.parentFlushed && segment.status === COMPLETED && queueCompletedSegment(boundary, segment), boundary.parentFlushed && request2.completedBoundaries.push(boundary), boundary.fallbackAbortableTasks.forEach(abortTaskSoft, request2), boundary.fallbackAbortableTasks.clear();
          else if (segment.parentFlushed && segment.status === COMPLETED) {
            queueCompletedSegment(boundary, segment);
            var completedSegments = boundary.completedSegments;
            completedSegments.length === 1 && boundary.parentFlushed && request2.partialBoundaries.push(boundary);
          }
        }
        if (request2.allPendingTasks--, request2.allPendingTasks === 0) {
          var onAllReady = request2.onAllReady;
          onAllReady();
        }
      }
      function retryTask(request2, task) {
        var segment = task.blockedSegment;
        if (segment.status === PENDING) {
          switchContext(task.context);
          var prevTaskInDEV = null;
          prevTaskInDEV = currentTaskInDEV, currentTaskInDEV = task;
          try {
            renderNodeDestructive(request2, task, task.node), pushSegmentFinale$1(segment.chunks, request2.responseState, segment.lastPushedText, segment.textEmbedded), task.abortSet.delete(task), segment.status = COMPLETED, finishedTask(request2, task.blockedBoundary, segment);
          } catch (x) {
            if (resetHooksState(), typeof x == "object" && x !== null && typeof x.then == "function") {
              var ping = task.ping;
              x.then(ping, ping);
            } else
              task.abortSet.delete(task), segment.status = ERRORED, erroredTask(request2, task.blockedBoundary, segment, x);
          } finally {
            currentTaskInDEV = prevTaskInDEV;
          }
        }
      }
      function performWork(request2) {
        if (request2.status !== CLOSED) {
          var prevContext = getActiveContext(), prevDispatcher = ReactCurrentDispatcher$1.current;
          ReactCurrentDispatcher$1.current = Dispatcher;
          var prevGetCurrentStackImpl;
          prevGetCurrentStackImpl = ReactDebugCurrentFrame$1.getCurrentStack, ReactDebugCurrentFrame$1.getCurrentStack = getCurrentStackInDEV;
          var prevResponseState = currentResponseState;
          setCurrentResponseState(request2.responseState);
          try {
            var pingedTasks = request2.pingedTasks, i;
            for (i = 0; i < pingedTasks.length; i++) {
              var task = pingedTasks[i];
              retryTask(request2, task);
            }
            pingedTasks.splice(0, i), request2.destination !== null && flushCompletedQueues(request2, request2.destination);
          } catch (error2) {
            logRecoverableError(request2, error2), fatalError(request2, error2);
          } finally {
            setCurrentResponseState(prevResponseState), ReactCurrentDispatcher$1.current = prevDispatcher, ReactDebugCurrentFrame$1.getCurrentStack = prevGetCurrentStackImpl, prevDispatcher === Dispatcher && switchContext(prevContext);
          }
        }
      }
      function flushSubtree(request2, destination, segment) {
        switch (segment.parentFlushed = !0, segment.status) {
          case PENDING: {
            var segmentID = segment.id = request2.nextSegmentId++;
            return segment.lastPushedText = !1, segment.textEmbedded = !1, writePlaceholder(destination, request2.responseState, segmentID);
          }
          case COMPLETED: {
            segment.status = FLUSHED;
            for (var r2 = !0, chunks = segment.chunks, chunkIdx = 0, children = segment.children, childIdx = 0; childIdx < children.length; childIdx++) {
              for (var nextChild = children[childIdx]; chunkIdx < nextChild.index; chunkIdx++)
                writeChunk(destination, chunks[chunkIdx]);
              r2 = flushSegment(request2, destination, nextChild);
            }
            for (; chunkIdx < chunks.length - 1; chunkIdx++)
              writeChunk(destination, chunks[chunkIdx]);
            return chunkIdx < chunks.length && (r2 = writeChunkAndReturn(destination, chunks[chunkIdx])), r2;
          }
          default:
            throw new Error("Aborted, errored or already flushed boundaries should not be flushed again. This is a bug in React.");
        }
      }
      function flushSegment(request2, destination, segment) {
        var boundary = segment.boundary;
        if (boundary === null)
          return flushSubtree(request2, destination, segment);
        if (boundary.parentFlushed = !0, boundary.forceClientRender)
          return writeStartClientRenderedSuspenseBoundary$1(destination, request2.responseState, boundary.errorDigest, boundary.errorMessage, boundary.errorComponentStack), flushSubtree(request2, destination, segment), writeEndClientRenderedSuspenseBoundary$1(destination, request2.responseState);
        if (boundary.pendingTasks > 0) {
          boundary.rootSegmentID = request2.nextSegmentId++, boundary.completedSegments.length > 0 && request2.partialBoundaries.push(boundary);
          var id = boundary.id = assignSuspenseBoundaryID(request2.responseState);
          return writeStartPendingSuspenseBoundary(destination, request2.responseState, id), flushSubtree(request2, destination, segment), writeEndPendingSuspenseBoundary(destination, request2.responseState);
        } else {
          if (boundary.byteSize > request2.progressiveChunkSize)
            return boundary.rootSegmentID = request2.nextSegmentId++, request2.completedBoundaries.push(boundary), writeStartPendingSuspenseBoundary(destination, request2.responseState, boundary.id), flushSubtree(request2, destination, segment), writeEndPendingSuspenseBoundary(destination, request2.responseState);
          writeStartCompletedSuspenseBoundary$1(destination, request2.responseState);
          var completedSegments = boundary.completedSegments;
          if (completedSegments.length !== 1)
            throw new Error("A previously unvisited boundary must have exactly one root segment. This is a bug in React.");
          var contentSegment = completedSegments[0];
          return flushSegment(request2, destination, contentSegment), writeEndCompletedSuspenseBoundary$1(destination, request2.responseState);
        }
      }
      function flushClientRenderedBoundary(request2, destination, boundary) {
        return writeClientRenderBoundaryInstruction(destination, request2.responseState, boundary.id, boundary.errorDigest, boundary.errorMessage, boundary.errorComponentStack);
      }
      function flushSegmentContainer(request2, destination, segment) {
        return writeStartSegment(destination, request2.responseState, segment.formatContext, segment.id), flushSegment(request2, destination, segment), writeEndSegment(destination, segment.formatContext);
      }
      function flushCompletedBoundary(request2, destination, boundary) {
        for (var completedSegments = boundary.completedSegments, i = 0; i < completedSegments.length; i++) {
          var segment = completedSegments[i];
          flushPartiallyCompletedSegment(request2, destination, boundary, segment);
        }
        return completedSegments.length = 0, writeCompletedBoundaryInstruction(destination, request2.responseState, boundary.id, boundary.rootSegmentID);
      }
      function flushPartialBoundary(request2, destination, boundary) {
        for (var completedSegments = boundary.completedSegments, i = 0; i < completedSegments.length; i++) {
          var segment = completedSegments[i];
          if (!flushPartiallyCompletedSegment(request2, destination, boundary, segment))
            return i++, completedSegments.splice(0, i), !1;
        }
        return completedSegments.splice(0, i), !0;
      }
      function flushPartiallyCompletedSegment(request2, destination, boundary, segment) {
        if (segment.status === FLUSHED)
          return !0;
        var segmentID = segment.id;
        if (segmentID === -1) {
          var rootSegmentID = segment.id = boundary.rootSegmentID;
          if (rootSegmentID === -1)
            throw new Error("A root segment ID must have been assigned by now. This is a bug in React.");
          return flushSegmentContainer(request2, destination, segment);
        } else
          return flushSegmentContainer(request2, destination, segment), writeCompletedSegmentInstruction(destination, request2.responseState, segmentID);
      }
      function flushCompletedQueues(request2, destination) {
        try {
          var completedRootSegment = request2.completedRootSegment;
          completedRootSegment !== null && request2.pendingRootTasks === 0 && (flushSegment(request2, destination, completedRootSegment), request2.completedRootSegment = null, writeCompletedRoot(destination, request2.responseState));
          var clientRenderedBoundaries = request2.clientRenderedBoundaries, i;
          for (i = 0; i < clientRenderedBoundaries.length; i++) {
            var boundary = clientRenderedBoundaries[i];
            if (!flushClientRenderedBoundary(request2, destination, boundary)) {
              request2.destination = null, i++, clientRenderedBoundaries.splice(0, i);
              return;
            }
          }
          clientRenderedBoundaries.splice(0, i);
          var completedBoundaries = request2.completedBoundaries;
          for (i = 0; i < completedBoundaries.length; i++) {
            var _boundary = completedBoundaries[i];
            if (!flushCompletedBoundary(request2, destination, _boundary)) {
              request2.destination = null, i++, completedBoundaries.splice(0, i);
              return;
            }
          }
          completedBoundaries.splice(0, i);
          var partialBoundaries = request2.partialBoundaries;
          for (i = 0; i < partialBoundaries.length; i++) {
            var _boundary2 = partialBoundaries[i];
            if (!flushPartialBoundary(request2, destination, _boundary2)) {
              request2.destination = null, i++, partialBoundaries.splice(0, i);
              return;
            }
          }
          partialBoundaries.splice(0, i);
          var largeBoundaries = request2.completedBoundaries;
          for (i = 0; i < largeBoundaries.length; i++) {
            var _boundary3 = largeBoundaries[i];
            if (!flushCompletedBoundary(request2, destination, _boundary3)) {
              request2.destination = null, i++, largeBoundaries.splice(0, i);
              return;
            }
          }
          largeBoundaries.splice(0, i);
        } finally {
          request2.allPendingTasks === 0 && request2.pingedTasks.length === 0 && request2.clientRenderedBoundaries.length === 0 && request2.completedBoundaries.length === 0 && (request2.abortableTasks.size !== 0 && error("There was still abortable task at the root when we closed. This is a bug in React."), close(destination));
        }
      }
      function startWork(request2) {
        scheduleWork(function() {
          return performWork(request2);
        });
      }
      function startFlowing(request2, destination) {
        if (request2.status === CLOSING) {
          request2.status = CLOSED, closeWithError(destination, request2.fatalError);
          return;
        }
        if (request2.status !== CLOSED && request2.destination === null) {
          request2.destination = destination;
          try {
            flushCompletedQueues(request2, destination);
          } catch (error2) {
            logRecoverableError(request2, error2), fatalError(request2, error2);
          }
        }
      }
      function abort2(request2, reason) {
        try {
          var abortableTasks = request2.abortableTasks;
          abortableTasks.forEach(function(task) {
            return abortTask(task, request2, reason);
          }), abortableTasks.clear(), request2.destination !== null && flushCompletedQueues(request2, request2.destination);
        } catch (error2) {
          logRecoverableError(request2, error2), fatalError(request2, error2);
        }
      }
      function onError() {
      }
      function renderToStringImpl(children, options, generateStaticMarkup, abortReason) {
        var didFatal = !1, fatalError2 = null, result = "", destination = {
          push: function(chunk) {
            return chunk !== null && (result += chunk), !0;
          },
          destroy: function(error2) {
            didFatal = !0, fatalError2 = error2;
          }
        }, readyToStream = !1;
        function onShellReady() {
          readyToStream = !0;
        }
        var request2 = createRequest(children, createResponseState$1(generateStaticMarkup, options ? options.identifierPrefix : void 0), createRootFormatContext(), 1 / 0, onError, void 0, onShellReady, void 0, void 0);
        if (startWork(request2), abort2(request2, abortReason), startFlowing(request2, destination), didFatal)
          throw fatalError2;
        if (!readyToStream)
          throw new Error("A component suspended while responding to synchronous input. This will cause the UI to be replaced with a loading indicator. To fix, updates that suspend should be wrapped with startTransition.");
        return result;
      }
      function _inheritsLoose(subClass, superClass) {
        subClass.prototype = Object.create(superClass.prototype), subClass.prototype.constructor = subClass, subClass.__proto__ = superClass;
      }
      var ReactMarkupReadableStream = /* @__PURE__ */ function(_Readable) {
        _inheritsLoose(ReactMarkupReadableStream2, _Readable);
        function ReactMarkupReadableStream2() {
          var _this;
          return _this = _Readable.call(this, {}) || this, _this.request = null, _this.startedFlowing = !1, _this;
        }
        var _proto = ReactMarkupReadableStream2.prototype;
        return _proto._destroy = function(err2, callback) {
          abort2(this.request), callback(err2);
        }, _proto._read = function(size) {
          this.startedFlowing && startFlowing(this.request, this);
        }, ReactMarkupReadableStream2;
      }(stream2.Readable);
      function onError$1() {
      }
      function renderToNodeStreamImpl(children, options, generateStaticMarkup) {
        function onAllReady() {
          destination.startedFlowing = !0, startFlowing(request2, destination);
        }
        var destination = new ReactMarkupReadableStream(), request2 = createRequest(children, createResponseState$1(!1, options ? options.identifierPrefix : void 0), createRootFormatContext(), 1 / 0, onError$1, onAllReady, void 0, void 0);
        return destination.request = request2, startWork(request2), destination;
      }
      function renderToNodeStream(children, options) {
        return error("renderToNodeStream is deprecated. Use renderToPipeableStream instead."), renderToNodeStreamImpl(children, options);
      }
      function renderToStaticNodeStream(children, options) {
        return renderToNodeStreamImpl(children, options);
      }
      function renderToString(children, options) {
        return renderToStringImpl(children, options, !1, 'The server used "renderToString" which does not support Suspense. If you intended for this Suspense boundary to render the fallback content on the server consider throwing an Error somewhere within the Suspense boundary. If you intended to have the server wait for the suspended component please switch to "renderToPipeableStream" which supports Suspense on the server');
      }
      function renderToStaticMarkup3(children, options) {
        return renderToStringImpl(children, options, !0, 'The server used "renderToStaticMarkup" which does not support Suspense. If you intended to have the server wait for the suspended component please switch to "renderToPipeableStream" which supports Suspense on the server');
      }
      exports.renderToNodeStream = renderToNodeStream, exports.renderToStaticMarkup = renderToStaticMarkup3, exports.renderToStaticNodeStream = renderToStaticNodeStream, exports.renderToString = renderToString, exports.version = ReactVersion;
    }();
  }
});

// ../../node_modules/.pnpm/react-dom@18.2.0_react@18.2.0/node_modules/react-dom/cjs/react-dom-server.node.development.js
var require_react_dom_server_node_development = __commonJS({
  "../../node_modules/.pnpm/react-dom@18.2.0_react@18.2.0/node_modules/react-dom/cjs/react-dom-server.node.development.js"(exports) {
    "use strict";
    init_cjs_shims();
    process.env.NODE_ENV !== "production" && function() {
      "use strict";
      var React12 = require_react(), util2 = __require("util"), ReactVersion = "18.2.0", ReactSharedInternals = React12.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
      function warn(format4) {
        {
          for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++)
            args[_key - 1] = arguments[_key];
          printWarning("warn", format4, args);
        }
      }
      function error(format4) {
        {
          for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++)
            args[_key2 - 1] = arguments[_key2];
          printWarning("error", format4, args);
        }
      }
      function printWarning(level, format4, args) {
        {
          var ReactDebugCurrentFrame2 = ReactSharedInternals.ReactDebugCurrentFrame, stack = ReactDebugCurrentFrame2.getStackAddendum();
          stack !== "" && (format4 += "%s", args = args.concat([stack]));
          var argsWithFormat = args.map(function(item) {
            return String(item);
          });
          argsWithFormat.unshift("Warning: " + format4), Function.prototype.apply.call(console[level], console, argsWithFormat);
        }
      }
      function scheduleWork(callback) {
        setImmediate(callback);
      }
      function flushBuffered(destination) {
        typeof destination.flush == "function" && destination.flush();
      }
      var VIEW_SIZE = 2048, currentView = null, writtenBytes = 0, destinationHasCapacity = !0;
      function beginWriting(destination) {
        currentView = new Uint8Array(VIEW_SIZE), writtenBytes = 0, destinationHasCapacity = !0;
      }
      function writeStringChunk(destination, stringChunk) {
        if (stringChunk.length !== 0) {
          if (stringChunk.length * 3 > VIEW_SIZE) {
            writtenBytes > 0 && (writeToDestination(destination, currentView.subarray(0, writtenBytes)), currentView = new Uint8Array(VIEW_SIZE), writtenBytes = 0), writeToDestination(destination, textEncoder.encode(stringChunk));
            return;
          }
          var target = currentView;
          writtenBytes > 0 && (target = currentView.subarray(writtenBytes));
          var _textEncoder$encodeIn = textEncoder.encodeInto(stringChunk, target), read = _textEncoder$encodeIn.read, written = _textEncoder$encodeIn.written;
          writtenBytes += written, read < stringChunk.length && (writeToDestination(destination, currentView), currentView = new Uint8Array(VIEW_SIZE), writtenBytes = textEncoder.encodeInto(stringChunk.slice(read), currentView).written), writtenBytes === VIEW_SIZE && (writeToDestination(destination, currentView), currentView = new Uint8Array(VIEW_SIZE), writtenBytes = 0);
        }
      }
      function writeViewChunk(destination, chunk) {
        if (chunk.byteLength !== 0) {
          if (chunk.byteLength > VIEW_SIZE) {
            writtenBytes > 0 && (writeToDestination(destination, currentView.subarray(0, writtenBytes)), currentView = new Uint8Array(VIEW_SIZE), writtenBytes = 0), writeToDestination(destination, chunk);
            return;
          }
          var bytesToWrite = chunk, allowableBytes = currentView.length - writtenBytes;
          allowableBytes < bytesToWrite.byteLength && (allowableBytes === 0 ? writeToDestination(destination, currentView) : (currentView.set(bytesToWrite.subarray(0, allowableBytes), writtenBytes), writtenBytes += allowableBytes, writeToDestination(destination, currentView), bytesToWrite = bytesToWrite.subarray(allowableBytes)), currentView = new Uint8Array(VIEW_SIZE), writtenBytes = 0), currentView.set(bytesToWrite, writtenBytes), writtenBytes += bytesToWrite.byteLength, writtenBytes === VIEW_SIZE && (writeToDestination(destination, currentView), currentView = new Uint8Array(VIEW_SIZE), writtenBytes = 0);
        }
      }
      function writeChunk(destination, chunk) {
        typeof chunk == "string" ? writeStringChunk(destination, chunk) : writeViewChunk(destination, chunk);
      }
      function writeToDestination(destination, view) {
        var currentHasCapacity = destination.write(view);
        destinationHasCapacity = destinationHasCapacity && currentHasCapacity;
      }
      function writeChunkAndReturn(destination, chunk) {
        return writeChunk(destination, chunk), destinationHasCapacity;
      }
      function completeWriting(destination) {
        currentView && writtenBytes > 0 && destination.write(currentView.subarray(0, writtenBytes)), currentView = null, writtenBytes = 0, destinationHasCapacity = !0;
      }
      function close(destination) {
        destination.end();
      }
      var textEncoder = new util2.TextEncoder();
      function stringToChunk(content) {
        return content;
      }
      function stringToPrecomputedChunk(content) {
        return textEncoder.encode(content);
      }
      function closeWithError(destination, error2) {
        destination.destroy(error2);
      }
      function typeName(value) {
        {
          var hasToStringTag = typeof Symbol == "function" && Symbol.toStringTag, type = hasToStringTag && value[Symbol.toStringTag] || value.constructor.name || "Object";
          return type;
        }
      }
      function willCoercionThrow(value) {
        try {
          return testStringCoercion(value), !1;
        } catch {
          return !0;
        }
      }
      function testStringCoercion(value) {
        return "" + value;
      }
      function checkAttributeStringCoercion(value, attributeName) {
        if (willCoercionThrow(value))
          return error("The provided `%s` attribute is an unsupported type %s. This value must be coerced to a string before before using it here.", attributeName, typeName(value)), testStringCoercion(value);
      }
      function checkCSSPropertyStringCoercion(value, propName) {
        if (willCoercionThrow(value))
          return error("The provided `%s` CSS property is an unsupported type %s. This value must be coerced to a string before before using it here.", propName, typeName(value)), testStringCoercion(value);
      }
      function checkHtmlStringCoercion(value) {
        if (willCoercionThrow(value))
          return error("The provided HTML markup uses a value of unsupported type %s. This value must be coerced to a string before before using it here.", typeName(value)), testStringCoercion(value);
      }
      var hasOwnProperty = Object.prototype.hasOwnProperty, RESERVED = 0, STRING = 1, BOOLEANISH_STRING = 2, BOOLEAN = 3, OVERLOADED_BOOLEAN = 4, NUMERIC = 5, POSITIVE_NUMERIC = 6, ATTRIBUTE_NAME_START_CHAR = ":A-Z_a-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD", ATTRIBUTE_NAME_CHAR = ATTRIBUTE_NAME_START_CHAR + "\\-.0-9\\u00B7\\u0300-\\u036F\\u203F-\\u2040", VALID_ATTRIBUTE_NAME_REGEX = new RegExp("^[" + ATTRIBUTE_NAME_START_CHAR + "][" + ATTRIBUTE_NAME_CHAR + "]*$"), illegalAttributeNameCache = {}, validatedAttributeNameCache = {};
      function isAttributeNameSafe(attributeName) {
        return hasOwnProperty.call(validatedAttributeNameCache, attributeName) ? !0 : hasOwnProperty.call(illegalAttributeNameCache, attributeName) ? !1 : VALID_ATTRIBUTE_NAME_REGEX.test(attributeName) ? (validatedAttributeNameCache[attributeName] = !0, !0) : (illegalAttributeNameCache[attributeName] = !0, error("Invalid attribute name: `%s`", attributeName), !1);
      }
      function shouldRemoveAttributeWithWarning(name, value, propertyInfo, isCustomComponentTag) {
        if (propertyInfo !== null && propertyInfo.type === RESERVED)
          return !1;
        switch (typeof value) {
          case "function":
          case "symbol":
            return !0;
          case "boolean": {
            if (isCustomComponentTag)
              return !1;
            if (propertyInfo !== null)
              return !propertyInfo.acceptsBooleans;
            var prefix2 = name.toLowerCase().slice(0, 5);
            return prefix2 !== "data-" && prefix2 !== "aria-";
          }
          default:
            return !1;
        }
      }
      function getPropertyInfo(name) {
        return properties.hasOwnProperty(name) ? properties[name] : null;
      }
      function PropertyInfoRecord(name, type, mustUseProperty, attributeName, attributeNamespace, sanitizeURL2, removeEmptyString) {
        this.acceptsBooleans = type === BOOLEANISH_STRING || type === BOOLEAN || type === OVERLOADED_BOOLEAN, this.attributeName = attributeName, this.attributeNamespace = attributeNamespace, this.mustUseProperty = mustUseProperty, this.propertyName = name, this.type = type, this.sanitizeURL = sanitizeURL2, this.removeEmptyString = removeEmptyString;
      }
      var properties = {}, reservedProps = [
        "children",
        "dangerouslySetInnerHTML",
        // TODO: This prevents the assignment of defaultValue to regular
        // elements (not just inputs). Now that ReactDOMInput assigns to the
        // defaultValue property -- do we need this?
        "defaultValue",
        "defaultChecked",
        "innerHTML",
        "suppressContentEditableWarning",
        "suppressHydrationWarning",
        "style"
      ];
      reservedProps.forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          RESERVED,
          !1,
          // mustUseProperty
          name,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [["acceptCharset", "accept-charset"], ["className", "class"], ["htmlFor", "for"], ["httpEquiv", "http-equiv"]].forEach(function(_ref) {
        var name = _ref[0], attributeName = _ref[1];
        properties[name] = new PropertyInfoRecord(
          name,
          STRING,
          !1,
          // mustUseProperty
          attributeName,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), ["contentEditable", "draggable", "spellCheck", "value"].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          BOOLEANISH_STRING,
          !1,
          // mustUseProperty
          name.toLowerCase(),
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), ["autoReverse", "externalResourcesRequired", "focusable", "preserveAlpha"].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          BOOLEANISH_STRING,
          !1,
          // mustUseProperty
          name,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "allowFullScreen",
        "async",
        // Note: there is a special case that prevents it from being written to the DOM
        // on the client side because the browsers are inconsistent. Instead we call focus().
        "autoFocus",
        "autoPlay",
        "controls",
        "default",
        "defer",
        "disabled",
        "disablePictureInPicture",
        "disableRemotePlayback",
        "formNoValidate",
        "hidden",
        "loop",
        "noModule",
        "noValidate",
        "open",
        "playsInline",
        "readOnly",
        "required",
        "reversed",
        "scoped",
        "seamless",
        // Microdata
        "itemScope"
      ].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          BOOLEAN,
          !1,
          // mustUseProperty
          name.toLowerCase(),
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "checked",
        // Note: `option.selected` is not updated if `select.multiple` is
        // disabled with `removeAttribute`. We have special logic for handling this.
        "multiple",
        "muted",
        "selected"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          BOOLEAN,
          !0,
          // mustUseProperty
          name,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "capture",
        "download"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          OVERLOADED_BOOLEAN,
          !1,
          // mustUseProperty
          name,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "cols",
        "rows",
        "size",
        "span"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          POSITIVE_NUMERIC,
          !1,
          // mustUseProperty
          name,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), ["rowSpan", "start"].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          NUMERIC,
          !1,
          // mustUseProperty
          name.toLowerCase(),
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      });
      var CAMELIZE = /[\-\:]([a-z])/g, capitalize2 = function(token) {
        return token[1].toUpperCase();
      };
      [
        "accent-height",
        "alignment-baseline",
        "arabic-form",
        "baseline-shift",
        "cap-height",
        "clip-path",
        "clip-rule",
        "color-interpolation",
        "color-interpolation-filters",
        "color-profile",
        "color-rendering",
        "dominant-baseline",
        "enable-background",
        "fill-opacity",
        "fill-rule",
        "flood-color",
        "flood-opacity",
        "font-family",
        "font-size",
        "font-size-adjust",
        "font-stretch",
        "font-style",
        "font-variant",
        "font-weight",
        "glyph-name",
        "glyph-orientation-horizontal",
        "glyph-orientation-vertical",
        "horiz-adv-x",
        "horiz-origin-x",
        "image-rendering",
        "letter-spacing",
        "lighting-color",
        "marker-end",
        "marker-mid",
        "marker-start",
        "overline-position",
        "overline-thickness",
        "paint-order",
        "panose-1",
        "pointer-events",
        "rendering-intent",
        "shape-rendering",
        "stop-color",
        "stop-opacity",
        "strikethrough-position",
        "strikethrough-thickness",
        "stroke-dasharray",
        "stroke-dashoffset",
        "stroke-linecap",
        "stroke-linejoin",
        "stroke-miterlimit",
        "stroke-opacity",
        "stroke-width",
        "text-anchor",
        "text-decoration",
        "text-rendering",
        "underline-position",
        "underline-thickness",
        "unicode-bidi",
        "unicode-range",
        "units-per-em",
        "v-alphabetic",
        "v-hanging",
        "v-ideographic",
        "v-mathematical",
        "vector-effect",
        "vert-adv-y",
        "vert-origin-x",
        "vert-origin-y",
        "word-spacing",
        "writing-mode",
        "xmlns:xlink",
        "x-height"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(attributeName) {
        var name = attributeName.replace(CAMELIZE, capitalize2);
        properties[name] = new PropertyInfoRecord(
          name,
          STRING,
          !1,
          // mustUseProperty
          attributeName,
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "xlink:actuate",
        "xlink:arcrole",
        "xlink:role",
        "xlink:show",
        "xlink:title",
        "xlink:type"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(attributeName) {
        var name = attributeName.replace(CAMELIZE, capitalize2);
        properties[name] = new PropertyInfoRecord(
          name,
          STRING,
          !1,
          // mustUseProperty
          attributeName,
          "http://www.w3.org/1999/xlink",
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "xml:base",
        "xml:lang",
        "xml:space"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(attributeName) {
        var name = attributeName.replace(CAMELIZE, capitalize2);
        properties[name] = new PropertyInfoRecord(
          name,
          STRING,
          !1,
          // mustUseProperty
          attributeName,
          "http://www.w3.org/XML/1998/namespace",
          !1,
          // sanitizeURL
          !1
        );
      }), ["tabIndex", "crossOrigin"].forEach(function(attributeName) {
        properties[attributeName] = new PropertyInfoRecord(
          attributeName,
          STRING,
          !1,
          // mustUseProperty
          attributeName.toLowerCase(),
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      });
      var xlinkHref = "xlinkHref";
      properties[xlinkHref] = new PropertyInfoRecord(
        "xlinkHref",
        STRING,
        !1,
        // mustUseProperty
        "xlink:href",
        "http://www.w3.org/1999/xlink",
        !0,
        // sanitizeURL
        !1
      ), ["src", "href", "action", "formAction"].forEach(function(attributeName) {
        properties[attributeName] = new PropertyInfoRecord(
          attributeName,
          STRING,
          !1,
          // mustUseProperty
          attributeName.toLowerCase(),
          // attributeName
          null,
          // attributeNamespace
          !0,
          // sanitizeURL
          !0
        );
      });
      var isUnitlessNumber = {
        animationIterationCount: !0,
        aspectRatio: !0,
        borderImageOutset: !0,
        borderImageSlice: !0,
        borderImageWidth: !0,
        boxFlex: !0,
        boxFlexGroup: !0,
        boxOrdinalGroup: !0,
        columnCount: !0,
        columns: !0,
        flex: !0,
        flexGrow: !0,
        flexPositive: !0,
        flexShrink: !0,
        flexNegative: !0,
        flexOrder: !0,
        gridArea: !0,
        gridRow: !0,
        gridRowEnd: !0,
        gridRowSpan: !0,
        gridRowStart: !0,
        gridColumn: !0,
        gridColumnEnd: !0,
        gridColumnSpan: !0,
        gridColumnStart: !0,
        fontWeight: !0,
        lineClamp: !0,
        lineHeight: !0,
        opacity: !0,
        order: !0,
        orphans: !0,
        tabSize: !0,
        widows: !0,
        zIndex: !0,
        zoom: !0,
        // SVG-related properties
        fillOpacity: !0,
        floodOpacity: !0,
        stopOpacity: !0,
        strokeDasharray: !0,
        strokeDashoffset: !0,
        strokeMiterlimit: !0,
        strokeOpacity: !0,
        strokeWidth: !0
      };
      function prefixKey(prefix2, key) {
        return prefix2 + key.charAt(0).toUpperCase() + key.substring(1);
      }
      var prefixes = ["Webkit", "ms", "Moz", "O"];
      Object.keys(isUnitlessNumber).forEach(function(prop) {
        prefixes.forEach(function(prefix2) {
          isUnitlessNumber[prefixKey(prefix2, prop)] = isUnitlessNumber[prop];
        });
      });
      var hasReadOnlyValue = {
        button: !0,
        checkbox: !0,
        image: !0,
        hidden: !0,
        radio: !0,
        reset: !0,
        submit: !0
      };
      function checkControlledValueProps(tagName, props) {
        hasReadOnlyValue[props.type] || props.onChange || props.onInput || props.readOnly || props.disabled || props.value == null || error("You provided a `value` prop to a form field without an `onChange` handler. This will render a read-only field. If the field should be mutable use `defaultValue`. Otherwise, set either `onChange` or `readOnly`."), props.onChange || props.readOnly || props.disabled || props.checked == null || error("You provided a `checked` prop to a form field without an `onChange` handler. This will render a read-only field. If the field should be mutable use `defaultChecked`. Otherwise, set either `onChange` or `readOnly`.");
      }
      function isCustomComponent(tagName, props) {
        if (tagName.indexOf("-") === -1)
          return typeof props.is == "string";
        switch (tagName) {
          case "annotation-xml":
          case "color-profile":
          case "font-face":
          case "font-face-src":
          case "font-face-uri":
          case "font-face-format":
          case "font-face-name":
          case "missing-glyph":
            return !1;
          default:
            return !0;
        }
      }
      var ariaProperties = {
        "aria-current": 0,
        // state
        "aria-description": 0,
        "aria-details": 0,
        "aria-disabled": 0,
        // state
        "aria-hidden": 0,
        // state
        "aria-invalid": 0,
        // state
        "aria-keyshortcuts": 0,
        "aria-label": 0,
        "aria-roledescription": 0,
        // Widget Attributes
        "aria-autocomplete": 0,
        "aria-checked": 0,
        "aria-expanded": 0,
        "aria-haspopup": 0,
        "aria-level": 0,
        "aria-modal": 0,
        "aria-multiline": 0,
        "aria-multiselectable": 0,
        "aria-orientation": 0,
        "aria-placeholder": 0,
        "aria-pressed": 0,
        "aria-readonly": 0,
        "aria-required": 0,
        "aria-selected": 0,
        "aria-sort": 0,
        "aria-valuemax": 0,
        "aria-valuemin": 0,
        "aria-valuenow": 0,
        "aria-valuetext": 0,
        // Live Region Attributes
        "aria-atomic": 0,
        "aria-busy": 0,
        "aria-live": 0,
        "aria-relevant": 0,
        // Drag-and-Drop Attributes
        "aria-dropeffect": 0,
        "aria-grabbed": 0,
        // Relationship Attributes
        "aria-activedescendant": 0,
        "aria-colcount": 0,
        "aria-colindex": 0,
        "aria-colspan": 0,
        "aria-controls": 0,
        "aria-describedby": 0,
        "aria-errormessage": 0,
        "aria-flowto": 0,
        "aria-labelledby": 0,
        "aria-owns": 0,
        "aria-posinset": 0,
        "aria-rowcount": 0,
        "aria-rowindex": 0,
        "aria-rowspan": 0,
        "aria-setsize": 0
      }, warnedProperties = {}, rARIA = new RegExp("^(aria)-[" + ATTRIBUTE_NAME_CHAR + "]*$"), rARIACamel = new RegExp("^(aria)[A-Z][" + ATTRIBUTE_NAME_CHAR + "]*$");
      function validateProperty(tagName, name) {
        {
          if (hasOwnProperty.call(warnedProperties, name) && warnedProperties[name])
            return !0;
          if (rARIACamel.test(name)) {
            var ariaName = "aria-" + name.slice(4).toLowerCase(), correctName = ariaProperties.hasOwnProperty(ariaName) ? ariaName : null;
            if (correctName == null)
              return error("Invalid ARIA attribute `%s`. ARIA attributes follow the pattern aria-* and must be lowercase.", name), warnedProperties[name] = !0, !0;
            if (name !== correctName)
              return error("Invalid ARIA attribute `%s`. Did you mean `%s`?", name, correctName), warnedProperties[name] = !0, !0;
          }
          if (rARIA.test(name)) {
            var lowerCasedName = name.toLowerCase(), standardName = ariaProperties.hasOwnProperty(lowerCasedName) ? lowerCasedName : null;
            if (standardName == null)
              return warnedProperties[name] = !0, !1;
            if (name !== standardName)
              return error("Unknown ARIA attribute `%s`. Did you mean `%s`?", name, standardName), warnedProperties[name] = !0, !0;
          }
        }
        return !0;
      }
      function warnInvalidARIAProps(type, props) {
        {
          var invalidProps = [];
          for (var key in props) {
            var isValid = validateProperty(type, key);
            isValid || invalidProps.push(key);
          }
          var unknownPropString = invalidProps.map(function(prop) {
            return "`" + prop + "`";
          }).join(", ");
          invalidProps.length === 1 ? error("Invalid aria prop %s on <%s> tag. For details, see https://reactjs.org/link/invalid-aria-props", unknownPropString, type) : invalidProps.length > 1 && error("Invalid aria props %s on <%s> tag. For details, see https://reactjs.org/link/invalid-aria-props", unknownPropString, type);
        }
      }
      function validateProperties(type, props) {
        isCustomComponent(type, props) || warnInvalidARIAProps(type, props);
      }
      var didWarnValueNull = !1;
      function validateProperties$1(type, props) {
        {
          if (type !== "input" && type !== "textarea" && type !== "select")
            return;
          props != null && props.value === null && !didWarnValueNull && (didWarnValueNull = !0, type === "select" && props.multiple ? error("`value` prop on `%s` should not be null. Consider using an empty array when `multiple` is set to `true` to clear the component or `undefined` for uncontrolled components.", type) : error("`value` prop on `%s` should not be null. Consider using an empty string to clear the component or `undefined` for uncontrolled components.", type));
        }
      }
      var possibleStandardNames = {
        // HTML
        accept: "accept",
        acceptcharset: "acceptCharset",
        "accept-charset": "acceptCharset",
        accesskey: "accessKey",
        action: "action",
        allowfullscreen: "allowFullScreen",
        alt: "alt",
        as: "as",
        async: "async",
        autocapitalize: "autoCapitalize",
        autocomplete: "autoComplete",
        autocorrect: "autoCorrect",
        autofocus: "autoFocus",
        autoplay: "autoPlay",
        autosave: "autoSave",
        capture: "capture",
        cellpadding: "cellPadding",
        cellspacing: "cellSpacing",
        challenge: "challenge",
        charset: "charSet",
        checked: "checked",
        children: "children",
        cite: "cite",
        class: "className",
        classid: "classID",
        classname: "className",
        cols: "cols",
        colspan: "colSpan",
        content: "content",
        contenteditable: "contentEditable",
        contextmenu: "contextMenu",
        controls: "controls",
        controlslist: "controlsList",
        coords: "coords",
        crossorigin: "crossOrigin",
        dangerouslysetinnerhtml: "dangerouslySetInnerHTML",
        data: "data",
        datetime: "dateTime",
        default: "default",
        defaultchecked: "defaultChecked",
        defaultvalue: "defaultValue",
        defer: "defer",
        dir: "dir",
        disabled: "disabled",
        disablepictureinpicture: "disablePictureInPicture",
        disableremoteplayback: "disableRemotePlayback",
        download: "download",
        draggable: "draggable",
        enctype: "encType",
        enterkeyhint: "enterKeyHint",
        for: "htmlFor",
        form: "form",
        formmethod: "formMethod",
        formaction: "formAction",
        formenctype: "formEncType",
        formnovalidate: "formNoValidate",
        formtarget: "formTarget",
        frameborder: "frameBorder",
        headers: "headers",
        height: "height",
        hidden: "hidden",
        high: "high",
        href: "href",
        hreflang: "hrefLang",
        htmlfor: "htmlFor",
        httpequiv: "httpEquiv",
        "http-equiv": "httpEquiv",
        icon: "icon",
        id: "id",
        imagesizes: "imageSizes",
        imagesrcset: "imageSrcSet",
        innerhtml: "innerHTML",
        inputmode: "inputMode",
        integrity: "integrity",
        is: "is",
        itemid: "itemID",
        itemprop: "itemProp",
        itemref: "itemRef",
        itemscope: "itemScope",
        itemtype: "itemType",
        keyparams: "keyParams",
        keytype: "keyType",
        kind: "kind",
        label: "label",
        lang: "lang",
        list: "list",
        loop: "loop",
        low: "low",
        manifest: "manifest",
        marginwidth: "marginWidth",
        marginheight: "marginHeight",
        max: "max",
        maxlength: "maxLength",
        media: "media",
        mediagroup: "mediaGroup",
        method: "method",
        min: "min",
        minlength: "minLength",
        multiple: "multiple",
        muted: "muted",
        name: "name",
        nomodule: "noModule",
        nonce: "nonce",
        novalidate: "noValidate",
        open: "open",
        optimum: "optimum",
        pattern: "pattern",
        placeholder: "placeholder",
        playsinline: "playsInline",
        poster: "poster",
        preload: "preload",
        profile: "profile",
        radiogroup: "radioGroup",
        readonly: "readOnly",
        referrerpolicy: "referrerPolicy",
        rel: "rel",
        required: "required",
        reversed: "reversed",
        role: "role",
        rows: "rows",
        rowspan: "rowSpan",
        sandbox: "sandbox",
        scope: "scope",
        scoped: "scoped",
        scrolling: "scrolling",
        seamless: "seamless",
        selected: "selected",
        shape: "shape",
        size: "size",
        sizes: "sizes",
        span: "span",
        spellcheck: "spellCheck",
        src: "src",
        srcdoc: "srcDoc",
        srclang: "srcLang",
        srcset: "srcSet",
        start: "start",
        step: "step",
        style: "style",
        summary: "summary",
        tabindex: "tabIndex",
        target: "target",
        title: "title",
        type: "type",
        usemap: "useMap",
        value: "value",
        width: "width",
        wmode: "wmode",
        wrap: "wrap",
        // SVG
        about: "about",
        accentheight: "accentHeight",
        "accent-height": "accentHeight",
        accumulate: "accumulate",
        additive: "additive",
        alignmentbaseline: "alignmentBaseline",
        "alignment-baseline": "alignmentBaseline",
        allowreorder: "allowReorder",
        alphabetic: "alphabetic",
        amplitude: "amplitude",
        arabicform: "arabicForm",
        "arabic-form": "arabicForm",
        ascent: "ascent",
        attributename: "attributeName",
        attributetype: "attributeType",
        autoreverse: "autoReverse",
        azimuth: "azimuth",
        basefrequency: "baseFrequency",
        baselineshift: "baselineShift",
        "baseline-shift": "baselineShift",
        baseprofile: "baseProfile",
        bbox: "bbox",
        begin: "begin",
        bias: "bias",
        by: "by",
        calcmode: "calcMode",
        capheight: "capHeight",
        "cap-height": "capHeight",
        clip: "clip",
        clippath: "clipPath",
        "clip-path": "clipPath",
        clippathunits: "clipPathUnits",
        cliprule: "clipRule",
        "clip-rule": "clipRule",
        color: "color",
        colorinterpolation: "colorInterpolation",
        "color-interpolation": "colorInterpolation",
        colorinterpolationfilters: "colorInterpolationFilters",
        "color-interpolation-filters": "colorInterpolationFilters",
        colorprofile: "colorProfile",
        "color-profile": "colorProfile",
        colorrendering: "colorRendering",
        "color-rendering": "colorRendering",
        contentscripttype: "contentScriptType",
        contentstyletype: "contentStyleType",
        cursor: "cursor",
        cx: "cx",
        cy: "cy",
        d: "d",
        datatype: "datatype",
        decelerate: "decelerate",
        descent: "descent",
        diffuseconstant: "diffuseConstant",
        direction: "direction",
        display: "display",
        divisor: "divisor",
        dominantbaseline: "dominantBaseline",
        "dominant-baseline": "dominantBaseline",
        dur: "dur",
        dx: "dx",
        dy: "dy",
        edgemode: "edgeMode",
        elevation: "elevation",
        enablebackground: "enableBackground",
        "enable-background": "enableBackground",
        end: "end",
        exponent: "exponent",
        externalresourcesrequired: "externalResourcesRequired",
        fill: "fill",
        fillopacity: "fillOpacity",
        "fill-opacity": "fillOpacity",
        fillrule: "fillRule",
        "fill-rule": "fillRule",
        filter: "filter",
        filterres: "filterRes",
        filterunits: "filterUnits",
        floodopacity: "floodOpacity",
        "flood-opacity": "floodOpacity",
        floodcolor: "floodColor",
        "flood-color": "floodColor",
        focusable: "focusable",
        fontfamily: "fontFamily",
        "font-family": "fontFamily",
        fontsize: "fontSize",
        "font-size": "fontSize",
        fontsizeadjust: "fontSizeAdjust",
        "font-size-adjust": "fontSizeAdjust",
        fontstretch: "fontStretch",
        "font-stretch": "fontStretch",
        fontstyle: "fontStyle",
        "font-style": "fontStyle",
        fontvariant: "fontVariant",
        "font-variant": "fontVariant",
        fontweight: "fontWeight",
        "font-weight": "fontWeight",
        format: "format",
        from: "from",
        fx: "fx",
        fy: "fy",
        g1: "g1",
        g2: "g2",
        glyphname: "glyphName",
        "glyph-name": "glyphName",
        glyphorientationhorizontal: "glyphOrientationHorizontal",
        "glyph-orientation-horizontal": "glyphOrientationHorizontal",
        glyphorientationvertical: "glyphOrientationVertical",
        "glyph-orientation-vertical": "glyphOrientationVertical",
        glyphref: "glyphRef",
        gradienttransform: "gradientTransform",
        gradientunits: "gradientUnits",
        hanging: "hanging",
        horizadvx: "horizAdvX",
        "horiz-adv-x": "horizAdvX",
        horizoriginx: "horizOriginX",
        "horiz-origin-x": "horizOriginX",
        ideographic: "ideographic",
        imagerendering: "imageRendering",
        "image-rendering": "imageRendering",
        in2: "in2",
        in: "in",
        inlist: "inlist",
        intercept: "intercept",
        k1: "k1",
        k2: "k2",
        k3: "k3",
        k4: "k4",
        k: "k",
        kernelmatrix: "kernelMatrix",
        kernelunitlength: "kernelUnitLength",
        kerning: "kerning",
        keypoints: "keyPoints",
        keysplines: "keySplines",
        keytimes: "keyTimes",
        lengthadjust: "lengthAdjust",
        letterspacing: "letterSpacing",
        "letter-spacing": "letterSpacing",
        lightingcolor: "lightingColor",
        "lighting-color": "lightingColor",
        limitingconeangle: "limitingConeAngle",
        local: "local",
        markerend: "markerEnd",
        "marker-end": "markerEnd",
        markerheight: "markerHeight",
        markermid: "markerMid",
        "marker-mid": "markerMid",
        markerstart: "markerStart",
        "marker-start": "markerStart",
        markerunits: "markerUnits",
        markerwidth: "markerWidth",
        mask: "mask",
        maskcontentunits: "maskContentUnits",
        maskunits: "maskUnits",
        mathematical: "mathematical",
        mode: "mode",
        numoctaves: "numOctaves",
        offset: "offset",
        opacity: "opacity",
        operator: "operator",
        order: "order",
        orient: "orient",
        orientation: "orientation",
        origin: "origin",
        overflow: "overflow",
        overlineposition: "overlinePosition",
        "overline-position": "overlinePosition",
        overlinethickness: "overlineThickness",
        "overline-thickness": "overlineThickness",
        paintorder: "paintOrder",
        "paint-order": "paintOrder",
        panose1: "panose1",
        "panose-1": "panose1",
        pathlength: "pathLength",
        patterncontentunits: "patternContentUnits",
        patterntransform: "patternTransform",
        patternunits: "patternUnits",
        pointerevents: "pointerEvents",
        "pointer-events": "pointerEvents",
        points: "points",
        pointsatx: "pointsAtX",
        pointsaty: "pointsAtY",
        pointsatz: "pointsAtZ",
        prefix: "prefix",
        preservealpha: "preserveAlpha",
        preserveaspectratio: "preserveAspectRatio",
        primitiveunits: "primitiveUnits",
        property: "property",
        r: "r",
        radius: "radius",
        refx: "refX",
        refy: "refY",
        renderingintent: "renderingIntent",
        "rendering-intent": "renderingIntent",
        repeatcount: "repeatCount",
        repeatdur: "repeatDur",
        requiredextensions: "requiredExtensions",
        requiredfeatures: "requiredFeatures",
        resource: "resource",
        restart: "restart",
        result: "result",
        results: "results",
        rotate: "rotate",
        rx: "rx",
        ry: "ry",
        scale: "scale",
        security: "security",
        seed: "seed",
        shaperendering: "shapeRendering",
        "shape-rendering": "shapeRendering",
        slope: "slope",
        spacing: "spacing",
        specularconstant: "specularConstant",
        specularexponent: "specularExponent",
        speed: "speed",
        spreadmethod: "spreadMethod",
        startoffset: "startOffset",
        stddeviation: "stdDeviation",
        stemh: "stemh",
        stemv: "stemv",
        stitchtiles: "stitchTiles",
        stopcolor: "stopColor",
        "stop-color": "stopColor",
        stopopacity: "stopOpacity",
        "stop-opacity": "stopOpacity",
        strikethroughposition: "strikethroughPosition",
        "strikethrough-position": "strikethroughPosition",
        strikethroughthickness: "strikethroughThickness",
        "strikethrough-thickness": "strikethroughThickness",
        string: "string",
        stroke: "stroke",
        strokedasharray: "strokeDasharray",
        "stroke-dasharray": "strokeDasharray",
        strokedashoffset: "strokeDashoffset",
        "stroke-dashoffset": "strokeDashoffset",
        strokelinecap: "strokeLinecap",
        "stroke-linecap": "strokeLinecap",
        strokelinejoin: "strokeLinejoin",
        "stroke-linejoin": "strokeLinejoin",
        strokemiterlimit: "strokeMiterlimit",
        "stroke-miterlimit": "strokeMiterlimit",
        strokewidth: "strokeWidth",
        "stroke-width": "strokeWidth",
        strokeopacity: "strokeOpacity",
        "stroke-opacity": "strokeOpacity",
        suppresscontenteditablewarning: "suppressContentEditableWarning",
        suppresshydrationwarning: "suppressHydrationWarning",
        surfacescale: "surfaceScale",
        systemlanguage: "systemLanguage",
        tablevalues: "tableValues",
        targetx: "targetX",
        targety: "targetY",
        textanchor: "textAnchor",
        "text-anchor": "textAnchor",
        textdecoration: "textDecoration",
        "text-decoration": "textDecoration",
        textlength: "textLength",
        textrendering: "textRendering",
        "text-rendering": "textRendering",
        to: "to",
        transform: "transform",
        typeof: "typeof",
        u1: "u1",
        u2: "u2",
        underlineposition: "underlinePosition",
        "underline-position": "underlinePosition",
        underlinethickness: "underlineThickness",
        "underline-thickness": "underlineThickness",
        unicode: "unicode",
        unicodebidi: "unicodeBidi",
        "unicode-bidi": "unicodeBidi",
        unicoderange: "unicodeRange",
        "unicode-range": "unicodeRange",
        unitsperem: "unitsPerEm",
        "units-per-em": "unitsPerEm",
        unselectable: "unselectable",
        valphabetic: "vAlphabetic",
        "v-alphabetic": "vAlphabetic",
        values: "values",
        vectoreffect: "vectorEffect",
        "vector-effect": "vectorEffect",
        version: "version",
        vertadvy: "vertAdvY",
        "vert-adv-y": "vertAdvY",
        vertoriginx: "vertOriginX",
        "vert-origin-x": "vertOriginX",
        vertoriginy: "vertOriginY",
        "vert-origin-y": "vertOriginY",
        vhanging: "vHanging",
        "v-hanging": "vHanging",
        videographic: "vIdeographic",
        "v-ideographic": "vIdeographic",
        viewbox: "viewBox",
        viewtarget: "viewTarget",
        visibility: "visibility",
        vmathematical: "vMathematical",
        "v-mathematical": "vMathematical",
        vocab: "vocab",
        widths: "widths",
        wordspacing: "wordSpacing",
        "word-spacing": "wordSpacing",
        writingmode: "writingMode",
        "writing-mode": "writingMode",
        x1: "x1",
        x2: "x2",
        x: "x",
        xchannelselector: "xChannelSelector",
        xheight: "xHeight",
        "x-height": "xHeight",
        xlinkactuate: "xlinkActuate",
        "xlink:actuate": "xlinkActuate",
        xlinkarcrole: "xlinkArcrole",
        "xlink:arcrole": "xlinkArcrole",
        xlinkhref: "xlinkHref",
        "xlink:href": "xlinkHref",
        xlinkrole: "xlinkRole",
        "xlink:role": "xlinkRole",
        xlinkshow: "xlinkShow",
        "xlink:show": "xlinkShow",
        xlinktitle: "xlinkTitle",
        "xlink:title": "xlinkTitle",
        xlinktype: "xlinkType",
        "xlink:type": "xlinkType",
        xmlbase: "xmlBase",
        "xml:base": "xmlBase",
        xmllang: "xmlLang",
        "xml:lang": "xmlLang",
        xmlns: "xmlns",
        "xml:space": "xmlSpace",
        xmlnsxlink: "xmlnsXlink",
        "xmlns:xlink": "xmlnsXlink",
        xmlspace: "xmlSpace",
        y1: "y1",
        y2: "y2",
        y: "y",
        ychannelselector: "yChannelSelector",
        z: "z",
        zoomandpan: "zoomAndPan"
      }, validateProperty$1 = function() {
      };
      {
        var warnedProperties$1 = {}, EVENT_NAME_REGEX = /^on./, INVALID_EVENT_NAME_REGEX = /^on[^A-Z]/, rARIA$1 = new RegExp("^(aria)-[" + ATTRIBUTE_NAME_CHAR + "]*$"), rARIACamel$1 = new RegExp("^(aria)[A-Z][" + ATTRIBUTE_NAME_CHAR + "]*$");
        validateProperty$1 = function(tagName, name, value, eventRegistry) {
          if (hasOwnProperty.call(warnedProperties$1, name) && warnedProperties$1[name])
            return !0;
          var lowerCasedName = name.toLowerCase();
          if (lowerCasedName === "onfocusin" || lowerCasedName === "onfocusout")
            return error("React uses onFocus and onBlur instead of onFocusIn and onFocusOut. All React events are normalized to bubble, so onFocusIn and onFocusOut are not needed/supported by React."), warnedProperties$1[name] = !0, !0;
          if (eventRegistry != null) {
            var registrationNameDependencies = eventRegistry.registrationNameDependencies, possibleRegistrationNames = eventRegistry.possibleRegistrationNames;
            if (registrationNameDependencies.hasOwnProperty(name))
              return !0;
            var registrationName = possibleRegistrationNames.hasOwnProperty(lowerCasedName) ? possibleRegistrationNames[lowerCasedName] : null;
            if (registrationName != null)
              return error("Invalid event handler property `%s`. Did you mean `%s`?", name, registrationName), warnedProperties$1[name] = !0, !0;
            if (EVENT_NAME_REGEX.test(name))
              return error("Unknown event handler property `%s`. It will be ignored.", name), warnedProperties$1[name] = !0, !0;
          } else if (EVENT_NAME_REGEX.test(name))
            return INVALID_EVENT_NAME_REGEX.test(name) && error("Invalid event handler property `%s`. React events use the camelCase naming convention, for example `onClick`.", name), warnedProperties$1[name] = !0, !0;
          if (rARIA$1.test(name) || rARIACamel$1.test(name))
            return !0;
          if (lowerCasedName === "innerhtml")
            return error("Directly setting property `innerHTML` is not permitted. For more information, lookup documentation on `dangerouslySetInnerHTML`."), warnedProperties$1[name] = !0, !0;
          if (lowerCasedName === "aria")
            return error("The `aria` attribute is reserved for future use in React. Pass individual `aria-` attributes instead."), warnedProperties$1[name] = !0, !0;
          if (lowerCasedName === "is" && value !== null && value !== void 0 && typeof value != "string")
            return error("Received a `%s` for a string attribute `is`. If this is expected, cast the value to a string.", typeof value), warnedProperties$1[name] = !0, !0;
          if (typeof value == "number" && isNaN(value))
            return error("Received NaN for the `%s` attribute. If this is expected, cast the value to a string.", name), warnedProperties$1[name] = !0, !0;
          var propertyInfo = getPropertyInfo(name), isReserved = propertyInfo !== null && propertyInfo.type === RESERVED;
          if (possibleStandardNames.hasOwnProperty(lowerCasedName)) {
            var standardName = possibleStandardNames[lowerCasedName];
            if (standardName !== name)
              return error("Invalid DOM property `%s`. Did you mean `%s`?", name, standardName), warnedProperties$1[name] = !0, !0;
          } else if (!isReserved && name !== lowerCasedName)
            return error("React does not recognize the `%s` prop on a DOM element. If you intentionally want it to appear in the DOM as a custom attribute, spell it as lowercase `%s` instead. If you accidentally passed it from a parent component, remove it from the DOM element.", name, lowerCasedName), warnedProperties$1[name] = !0, !0;
          return typeof value == "boolean" && shouldRemoveAttributeWithWarning(name, value, propertyInfo, !1) ? (value ? error('Received `%s` for a non-boolean attribute `%s`.\n\nIf you want to write it to the DOM, pass a string instead: %s="%s" or %s={value.toString()}.', value, name, name, value, name) : error('Received `%s` for a non-boolean attribute `%s`.\n\nIf you want to write it to the DOM, pass a string instead: %s="%s" or %s={value.toString()}.\n\nIf you used to conditionally omit it with %s={condition && value}, pass %s={condition ? value : undefined} instead.', value, name, name, value, name, name, name), warnedProperties$1[name] = !0, !0) : isReserved ? !0 : shouldRemoveAttributeWithWarning(name, value, propertyInfo, !1) ? (warnedProperties$1[name] = !0, !1) : ((value === "false" || value === "true") && propertyInfo !== null && propertyInfo.type === BOOLEAN && (error("Received the string `%s` for the boolean attribute `%s`. %s Did you mean %s={%s}?", value, name, value === "false" ? "The browser will interpret it as a truthy value." : 'Although this works, it will not work as expected if you pass the string "false".', name, value), warnedProperties$1[name] = !0), !0);
        };
      }
      var warnUnknownProperties = function(type, props, eventRegistry) {
        {
          var unknownProps = [];
          for (var key in props) {
            var isValid = validateProperty$1(type, key, props[key], eventRegistry);
            isValid || unknownProps.push(key);
          }
          var unknownPropString = unknownProps.map(function(prop) {
            return "`" + prop + "`";
          }).join(", ");
          unknownProps.length === 1 ? error("Invalid value for prop %s on <%s> tag. Either remove it from the element, or pass a string or number value to keep it in the DOM. For details, see https://reactjs.org/link/attribute-behavior ", unknownPropString, type) : unknownProps.length > 1 && error("Invalid values for props %s on <%s> tag. Either remove them from the element, or pass a string or number value to keep them in the DOM. For details, see https://reactjs.org/link/attribute-behavior ", unknownPropString, type);
        }
      };
      function validateProperties$2(type, props, eventRegistry) {
        isCustomComponent(type, props) || warnUnknownProperties(type, props, eventRegistry);
      }
      var warnValidStyle = function() {
      };
      {
        var badVendoredStyleNamePattern = /^(?:webkit|moz|o)[A-Z]/, msPattern = /^-ms-/, hyphenPattern = /-(.)/g, badStyleValueWithSemicolonPattern = /;\s*$/, warnedStyleNames = {}, warnedStyleValues = {}, warnedForNaNValue = !1, warnedForInfinityValue = !1, camelize2 = function(string) {
          return string.replace(hyphenPattern, function(_2, character) {
            return character.toUpperCase();
          });
        }, warnHyphenatedStyleName = function(name) {
          warnedStyleNames.hasOwnProperty(name) && warnedStyleNames[name] || (warnedStyleNames[name] = !0, error(
            "Unsupported style property %s. Did you mean %s?",
            name,
            // As Andi Smith suggests
            // (http://www.andismith.com/blog/2012/02/modernizr-prefixed/), an `-ms` prefix
            // is converted to lowercase `ms`.
            camelize2(name.replace(msPattern, "ms-"))
          ));
        }, warnBadVendoredStyleName = function(name) {
          warnedStyleNames.hasOwnProperty(name) && warnedStyleNames[name] || (warnedStyleNames[name] = !0, error("Unsupported vendor-prefixed style property %s. Did you mean %s?", name, name.charAt(0).toUpperCase() + name.slice(1)));
        }, warnStyleValueWithSemicolon = function(name, value) {
          warnedStyleValues.hasOwnProperty(value) && warnedStyleValues[value] || (warnedStyleValues[value] = !0, error(`Style property values shouldn't contain a semicolon. Try "%s: %s" instead.`, name, value.replace(badStyleValueWithSemicolonPattern, "")));
        }, warnStyleValueIsNaN = function(name, value) {
          warnedForNaNValue || (warnedForNaNValue = !0, error("`NaN` is an invalid value for the `%s` css style property.", name));
        }, warnStyleValueIsInfinity = function(name, value) {
          warnedForInfinityValue || (warnedForInfinityValue = !0, error("`Infinity` is an invalid value for the `%s` css style property.", name));
        };
        warnValidStyle = function(name, value) {
          name.indexOf("-") > -1 ? warnHyphenatedStyleName(name) : badVendoredStyleNamePattern.test(name) ? warnBadVendoredStyleName(name) : badStyleValueWithSemicolonPattern.test(value) && warnStyleValueWithSemicolon(name, value), typeof value == "number" && (isNaN(value) ? warnStyleValueIsNaN(name, value) : isFinite(value) || warnStyleValueIsInfinity(name, value));
        };
      }
      var warnValidStyle$1 = warnValidStyle, matchHtmlRegExp = /["'&<>]/;
      function escapeHtml(string) {
        checkHtmlStringCoercion(string);
        var str = "" + string, match2 = matchHtmlRegExp.exec(str);
        if (!match2)
          return str;
        var escape2, html = "", index, lastIndex = 0;
        for (index = match2.index; index < str.length; index++) {
          switch (str.charCodeAt(index)) {
            case 34:
              escape2 = "&quot;";
              break;
            case 38:
              escape2 = "&amp;";
              break;
            case 39:
              escape2 = "&#x27;";
              break;
            case 60:
              escape2 = "&lt;";
              break;
            case 62:
              escape2 = "&gt;";
              break;
            default:
              continue;
          }
          lastIndex !== index && (html += str.substring(lastIndex, index)), lastIndex = index + 1, html += escape2;
        }
        return lastIndex !== index ? html + str.substring(lastIndex, index) : html;
      }
      function escapeTextForBrowser(text) {
        return typeof text == "boolean" || typeof text == "number" ? "" + text : escapeHtml(text);
      }
      var uppercasePattern = /([A-Z])/g, msPattern$1 = /^ms-/;
      function hyphenateStyleName(name) {
        return name.replace(uppercasePattern, "-$1").toLowerCase().replace(msPattern$1, "-ms-");
      }
      var isJavaScriptProtocol = /^[\u0000-\u001F ]*j[\r\n\t]*a[\r\n\t]*v[\r\n\t]*a[\r\n\t]*s[\r\n\t]*c[\r\n\t]*r[\r\n\t]*i[\r\n\t]*p[\r\n\t]*t[\r\n\t]*\:/i, didWarn = !1;
      function sanitizeURL(url) {
        !didWarn && isJavaScriptProtocol.test(url) && (didWarn = !0, error("A future version of React will block javascript: URLs as a security precaution. Use event handlers instead if you can. If you need to generate unsafe HTML try using dangerouslySetInnerHTML instead. React was passed %s.", JSON.stringify(url)));
      }
      var isArrayImpl = Array.isArray;
      function isArray(a) {
        return isArrayImpl(a);
      }
      var startInlineScript = stringToPrecomputedChunk("<script>"), endInlineScript = stringToPrecomputedChunk("</script>"), startScriptSrc = stringToPrecomputedChunk('<script src="'), startModuleSrc = stringToPrecomputedChunk('<script type="module" src="'), endAsyncScript = stringToPrecomputedChunk('" async=""></script>');
      function escapeBootstrapScriptContent(scriptText) {
        return checkHtmlStringCoercion(scriptText), ("" + scriptText).replace(scriptRegex, scriptReplacer);
      }
      var scriptRegex = /(<\/|<)(s)(cript)/gi, scriptReplacer = function(match2, prefix2, s, suffix) {
        return "" + prefix2 + (s === "s" ? "\\u0073" : "\\u0053") + suffix;
      };
      function createResponseState(identifierPrefix, nonce, bootstrapScriptContent, bootstrapScripts, bootstrapModules) {
        var idPrefix = identifierPrefix === void 0 ? "" : identifierPrefix, inlineScriptWithNonce = nonce === void 0 ? startInlineScript : stringToPrecomputedChunk('<script nonce="' + escapeTextForBrowser(nonce) + '">'), bootstrapChunks = [];
        if (bootstrapScriptContent !== void 0 && bootstrapChunks.push(inlineScriptWithNonce, escapeBootstrapScriptContent(bootstrapScriptContent), endInlineScript), bootstrapScripts !== void 0)
          for (var i = 0; i < bootstrapScripts.length; i++)
            bootstrapChunks.push(startScriptSrc, escapeTextForBrowser(bootstrapScripts[i]), endAsyncScript);
        if (bootstrapModules !== void 0)
          for (var _i = 0; _i < bootstrapModules.length; _i++)
            bootstrapChunks.push(startModuleSrc, escapeTextForBrowser(bootstrapModules[_i]), endAsyncScript);
        return {
          bootstrapChunks,
          startInlineScript: inlineScriptWithNonce,
          placeholderPrefix: stringToPrecomputedChunk(idPrefix + "P:"),
          segmentPrefix: stringToPrecomputedChunk(idPrefix + "S:"),
          boundaryPrefix: idPrefix + "B:",
          idPrefix,
          nextSuspenseID: 0,
          sentCompleteSegmentFunction: !1,
          sentCompleteBoundaryFunction: !1,
          sentClientRenderFunction: !1
        };
      }
      var ROOT_HTML_MODE = 0, HTML_MODE = 1, SVG_MODE = 2, MATHML_MODE = 3, HTML_TABLE_MODE = 4, HTML_TABLE_BODY_MODE = 5, HTML_TABLE_ROW_MODE = 6, HTML_COLGROUP_MODE = 7;
      function createFormatContext(insertionMode, selectedValue) {
        return {
          insertionMode,
          selectedValue
        };
      }
      function createRootFormatContext(namespaceURI) {
        var insertionMode = namespaceURI === "http://www.w3.org/2000/svg" ? SVG_MODE : namespaceURI === "http://www.w3.org/1998/Math/MathML" ? MATHML_MODE : ROOT_HTML_MODE;
        return createFormatContext(insertionMode, null);
      }
      function getChildFormatContext(parentContext, type, props) {
        switch (type) {
          case "select":
            return createFormatContext(HTML_MODE, props.value != null ? props.value : props.defaultValue);
          case "svg":
            return createFormatContext(SVG_MODE, null);
          case "math":
            return createFormatContext(MATHML_MODE, null);
          case "foreignObject":
            return createFormatContext(HTML_MODE, null);
          case "table":
            return createFormatContext(HTML_TABLE_MODE, null);
          case "thead":
          case "tbody":
          case "tfoot":
            return createFormatContext(HTML_TABLE_BODY_MODE, null);
          case "colgroup":
            return createFormatContext(HTML_COLGROUP_MODE, null);
          case "tr":
            return createFormatContext(HTML_TABLE_ROW_MODE, null);
        }
        return parentContext.insertionMode >= HTML_TABLE_MODE || parentContext.insertionMode === ROOT_HTML_MODE ? createFormatContext(HTML_MODE, null) : parentContext;
      }
      var UNINITIALIZED_SUSPENSE_BOUNDARY_ID = null;
      function assignSuspenseBoundaryID(responseState) {
        var generatedID = responseState.nextSuspenseID++;
        return stringToPrecomputedChunk(responseState.boundaryPrefix + generatedID.toString(16));
      }
      function makeId(responseState, treeId, localId) {
        var idPrefix = responseState.idPrefix, id = ":" + idPrefix + "R" + treeId;
        return localId > 0 && (id += "H" + localId.toString(32)), id + ":";
      }
      function encodeHTMLTextNode(text) {
        return escapeTextForBrowser(text);
      }
      var textSeparator = stringToPrecomputedChunk("<!-- -->");
      function pushTextInstance(target, text, responseState, textEmbedded) {
        return text === "" ? textEmbedded : (textEmbedded && target.push(textSeparator), target.push(encodeHTMLTextNode(text)), !0);
      }
      function pushSegmentFinale(target, responseState, lastPushedText, textEmbedded) {
        lastPushedText && textEmbedded && target.push(textSeparator);
      }
      var styleNameCache = /* @__PURE__ */ new Map();
      function processStyleName(styleName) {
        var chunk = styleNameCache.get(styleName);
        if (chunk !== void 0)
          return chunk;
        var result = stringToPrecomputedChunk(escapeTextForBrowser(hyphenateStyleName(styleName)));
        return styleNameCache.set(styleName, result), result;
      }
      var styleAttributeStart = stringToPrecomputedChunk(' style="'), styleAssign = stringToPrecomputedChunk(":"), styleSeparator = stringToPrecomputedChunk(";");
      function pushStyle(target, responseState, style) {
        if (typeof style != "object")
          throw new Error("The `style` prop expects a mapping from style properties to values, not a string. For example, style={{marginRight: spacing + 'em'}} when using JSX.");
        var isFirst = !0;
        for (var styleName in style)
          if (hasOwnProperty.call(style, styleName)) {
            var styleValue = style[styleName];
            if (!(styleValue == null || typeof styleValue == "boolean" || styleValue === "")) {
              var nameChunk = void 0, valueChunk = void 0, isCustomProperty = styleName.indexOf("--") === 0;
              isCustomProperty ? (nameChunk = escapeTextForBrowser(styleName), checkCSSPropertyStringCoercion(styleValue, styleName), valueChunk = escapeTextForBrowser(("" + styleValue).trim())) : (warnValidStyle$1(styleName, styleValue), nameChunk = processStyleName(styleName), typeof styleValue == "number" ? styleValue !== 0 && !hasOwnProperty.call(isUnitlessNumber, styleName) ? valueChunk = styleValue + "px" : valueChunk = "" + styleValue : (checkCSSPropertyStringCoercion(styleValue, styleName), valueChunk = escapeTextForBrowser(("" + styleValue).trim()))), isFirst ? (isFirst = !1, target.push(styleAttributeStart, nameChunk, styleAssign, valueChunk)) : target.push(styleSeparator, nameChunk, styleAssign, valueChunk);
            }
          }
        isFirst || target.push(attributeEnd);
      }
      var attributeSeparator = stringToPrecomputedChunk(" "), attributeAssign = stringToPrecomputedChunk('="'), attributeEnd = stringToPrecomputedChunk('"'), attributeEmptyString = stringToPrecomputedChunk('=""');
      function pushAttribute(target, responseState, name, value) {
        switch (name) {
          case "style": {
            pushStyle(target, responseState, value);
            return;
          }
          case "defaultValue":
          case "defaultChecked":
          case "innerHTML":
          case "suppressContentEditableWarning":
          case "suppressHydrationWarning":
            return;
        }
        if (
          // shouldIgnoreAttribute
          // We have already filtered out null/undefined and reserved words.
          !(name.length > 2 && (name[0] === "o" || name[0] === "O") && (name[1] === "n" || name[1] === "N"))
        ) {
          var propertyInfo = getPropertyInfo(name);
          if (propertyInfo !== null) {
            switch (typeof value) {
              case "function":
              case "symbol":
                return;
              case "boolean":
                if (!propertyInfo.acceptsBooleans)
                  return;
            }
            var attributeName = propertyInfo.attributeName, attributeNameChunk = attributeName;
            switch (propertyInfo.type) {
              case BOOLEAN:
                value && target.push(attributeSeparator, attributeNameChunk, attributeEmptyString);
                return;
              case OVERLOADED_BOOLEAN:
                value === !0 ? target.push(attributeSeparator, attributeNameChunk, attributeEmptyString) : value === !1 || target.push(attributeSeparator, attributeNameChunk, attributeAssign, escapeTextForBrowser(value), attributeEnd);
                return;
              case NUMERIC:
                isNaN(value) || target.push(attributeSeparator, attributeNameChunk, attributeAssign, escapeTextForBrowser(value), attributeEnd);
                break;
              case POSITIVE_NUMERIC:
                !isNaN(value) && value >= 1 && target.push(attributeSeparator, attributeNameChunk, attributeAssign, escapeTextForBrowser(value), attributeEnd);
                break;
              default:
                propertyInfo.sanitizeURL && (checkAttributeStringCoercion(value, attributeName), value = "" + value, sanitizeURL(value)), target.push(attributeSeparator, attributeNameChunk, attributeAssign, escapeTextForBrowser(value), attributeEnd);
            }
          } else if (isAttributeNameSafe(name)) {
            switch (typeof value) {
              case "function":
              case "symbol":
                return;
              case "boolean": {
                var prefix2 = name.toLowerCase().slice(0, 5);
                if (prefix2 !== "data-" && prefix2 !== "aria-")
                  return;
              }
            }
            target.push(attributeSeparator, name, attributeAssign, escapeTextForBrowser(value), attributeEnd);
          }
        }
      }
      var endOfStartTag = stringToPrecomputedChunk(">"), endOfStartTagSelfClosing = stringToPrecomputedChunk("/>");
      function pushInnerHTML(target, innerHTML, children) {
        if (innerHTML != null) {
          if (children != null)
            throw new Error("Can only set one of `children` or `props.dangerouslySetInnerHTML`.");
          if (typeof innerHTML != "object" || !("__html" in innerHTML))
            throw new Error("`props.dangerouslySetInnerHTML` must be in the form `{__html: ...}`. Please visit https://reactjs.org/link/dangerously-set-inner-html for more information.");
          var html = innerHTML.__html;
          html != null && (checkHtmlStringCoercion(html), target.push("" + html));
        }
      }
      var didWarnDefaultInputValue = !1, didWarnDefaultChecked = !1, didWarnDefaultSelectValue = !1, didWarnDefaultTextareaValue = !1, didWarnInvalidOptionChildren = !1, didWarnInvalidOptionInnerHTML = !1, didWarnSelectedSetOnOption = !1;
      function checkSelectProp(props, propName) {
        {
          var value = props[propName];
          if (value != null) {
            var array = isArray(value);
            props.multiple && !array ? error("The `%s` prop supplied to <select> must be an array if `multiple` is true.", propName) : !props.multiple && array && error("The `%s` prop supplied to <select> must be a scalar value if `multiple` is false.", propName);
          }
        }
      }
      function pushStartSelect(target, props, responseState) {
        checkControlledValueProps("select", props), checkSelectProp(props, "value"), checkSelectProp(props, "defaultValue"), props.value !== void 0 && props.defaultValue !== void 0 && !didWarnDefaultSelectValue && (error("Select elements must be either controlled or uncontrolled (specify either the value prop, or the defaultValue prop, but not both). Decide between using a controlled or uncontrolled select element and remove one of these props. More info: https://reactjs.org/link/controlled-components"), didWarnDefaultSelectValue = !0), target.push(startChunkForTag("select"));
        var children = null, innerHTML = null;
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
                children = propValue;
                break;
              case "dangerouslySetInnerHTML":
                innerHTML = propValue;
                break;
              case "defaultValue":
              case "value":
                break;
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        return target.push(endOfStartTag), pushInnerHTML(target, innerHTML, children), children;
      }
      function flattenOptionChildren(children) {
        var content = "";
        return React12.Children.forEach(children, function(child) {
          child != null && (content += child, !didWarnInvalidOptionChildren && typeof child != "string" && typeof child != "number" && (didWarnInvalidOptionChildren = !0, error("Cannot infer the option value of complex children. Pass a `value` prop or use a plain string as children to <option>.")));
        }), content;
      }
      var selectedMarkerAttribute = stringToPrecomputedChunk(' selected=""');
      function pushStartOption(target, props, responseState, formatContext) {
        var selectedValue = formatContext.selectedValue;
        target.push(startChunkForTag("option"));
        var children = null, value = null, selected = null, innerHTML = null;
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
                children = propValue;
                break;
              case "selected":
                selected = propValue, didWarnSelectedSetOnOption || (error("Use the `defaultValue` or `value` props on <select> instead of setting `selected` on <option>."), didWarnSelectedSetOnOption = !0);
                break;
              case "dangerouslySetInnerHTML":
                innerHTML = propValue;
                break;
              case "value":
                value = propValue;
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        if (selectedValue != null) {
          var stringValue;
          if (value !== null ? (checkAttributeStringCoercion(value, "value"), stringValue = "" + value) : (innerHTML !== null && (didWarnInvalidOptionInnerHTML || (didWarnInvalidOptionInnerHTML = !0, error("Pass a `value` prop if you set dangerouslyInnerHTML so React knows which value should be selected."))), stringValue = flattenOptionChildren(children)), isArray(selectedValue))
            for (var i = 0; i < selectedValue.length; i++) {
              checkAttributeStringCoercion(selectedValue[i], "value");
              var v = "" + selectedValue[i];
              if (v === stringValue) {
                target.push(selectedMarkerAttribute);
                break;
              }
            }
          else
            checkAttributeStringCoercion(selectedValue, "select.value"), "" + selectedValue === stringValue && target.push(selectedMarkerAttribute);
        } else
          selected && target.push(selectedMarkerAttribute);
        return target.push(endOfStartTag), pushInnerHTML(target, innerHTML, children), children;
      }
      function pushInput(target, props, responseState) {
        checkControlledValueProps("input", props), props.checked !== void 0 && props.defaultChecked !== void 0 && !didWarnDefaultChecked && (error("%s contains an input of type %s with both checked and defaultChecked props. Input elements must be either controlled or uncontrolled (specify either the checked prop, or the defaultChecked prop, but not both). Decide between using a controlled or uncontrolled input element and remove one of these props. More info: https://reactjs.org/link/controlled-components", "A component", props.type), didWarnDefaultChecked = !0), props.value !== void 0 && props.defaultValue !== void 0 && !didWarnDefaultInputValue && (error("%s contains an input of type %s with both value and defaultValue props. Input elements must be either controlled or uncontrolled (specify either the value prop, or the defaultValue prop, but not both). Decide between using a controlled or uncontrolled input element and remove one of these props. More info: https://reactjs.org/link/controlled-components", "A component", props.type), didWarnDefaultInputValue = !0), target.push(startChunkForTag("input"));
        var value = null, defaultValue = null, checked = null, defaultChecked = null;
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
              case "dangerouslySetInnerHTML":
                throw new Error("input is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");
              case "defaultChecked":
                defaultChecked = propValue;
                break;
              case "defaultValue":
                defaultValue = propValue;
                break;
              case "checked":
                checked = propValue;
                break;
              case "value":
                value = propValue;
                break;
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        return checked !== null ? pushAttribute(target, responseState, "checked", checked) : defaultChecked !== null && pushAttribute(target, responseState, "checked", defaultChecked), value !== null ? pushAttribute(target, responseState, "value", value) : defaultValue !== null && pushAttribute(target, responseState, "value", defaultValue), target.push(endOfStartTagSelfClosing), null;
      }
      function pushStartTextArea(target, props, responseState) {
        checkControlledValueProps("textarea", props), props.value !== void 0 && props.defaultValue !== void 0 && !didWarnDefaultTextareaValue && (error("Textarea elements must be either controlled or uncontrolled (specify either the value prop, or the defaultValue prop, but not both). Decide between using a controlled or uncontrolled textarea and remove one of these props. More info: https://reactjs.org/link/controlled-components"), didWarnDefaultTextareaValue = !0), target.push(startChunkForTag("textarea"));
        var value = null, defaultValue = null, children = null;
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
                children = propValue;
                break;
              case "value":
                value = propValue;
                break;
              case "defaultValue":
                defaultValue = propValue;
                break;
              case "dangerouslySetInnerHTML":
                throw new Error("`dangerouslySetInnerHTML` does not make sense on <textarea>.");
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        if (value === null && defaultValue !== null && (value = defaultValue), target.push(endOfStartTag), children != null) {
          if (error("Use the `defaultValue` or `value` props instead of setting children on <textarea>."), value != null)
            throw new Error("If you supply `defaultValue` on a <textarea>, do not pass children.");
          if (isArray(children)) {
            if (children.length > 1)
              throw new Error("<textarea> can only have at most one child.");
            checkHtmlStringCoercion(children[0]), value = "" + children[0];
          }
          checkHtmlStringCoercion(children), value = "" + children;
        }
        return typeof value == "string" && value[0] === `
` && target.push(leadingNewline), value !== null && (checkAttributeStringCoercion(value, "value"), target.push(encodeHTMLTextNode("" + value))), null;
      }
      function pushSelfClosing(target, props, tag, responseState) {
        target.push(startChunkForTag(tag));
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
              case "dangerouslySetInnerHTML":
                throw new Error(tag + " is a self-closing tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        return target.push(endOfStartTagSelfClosing), null;
      }
      function pushStartMenuItem(target, props, responseState) {
        target.push(startChunkForTag("menuitem"));
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
              case "dangerouslySetInnerHTML":
                throw new Error("menuitems cannot have `children` nor `dangerouslySetInnerHTML`.");
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        return target.push(endOfStartTag), null;
      }
      function pushStartTitle(target, props, responseState) {
        target.push(startChunkForTag("title"));
        var children = null;
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
                children = propValue;
                break;
              case "dangerouslySetInnerHTML":
                throw new Error("`dangerouslySetInnerHTML` does not make sense on <title>.");
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        target.push(endOfStartTag);
        {
          var child = Array.isArray(children) && children.length < 2 ? children[0] || null : children;
          Array.isArray(children) && children.length > 1 ? error("A title element received an array with more than 1 element as children. In browsers title Elements can only have Text Nodes as children. If the children being rendered output more than a single text node in aggregate the browser will display markup and comments as text in the title and hydration will likely fail and fall back to client rendering") : child != null && child.$$typeof != null ? error("A title element received a React element for children. In the browser title Elements can only have Text Nodes as children. If the children being rendered output more than a single text node in aggregate the browser will display markup and comments as text in the title and hydration will likely fail and fall back to client rendering") : child != null && typeof child != "string" && typeof child != "number" && error("A title element received a value that was not a string or number for children. In the browser title Elements can only have Text Nodes as children. If the children being rendered output more than a single text node in aggregate the browser will display markup and comments as text in the title and hydration will likely fail and fall back to client rendering");
        }
        return children;
      }
      function pushStartGenericElement(target, props, tag, responseState) {
        target.push(startChunkForTag(tag));
        var children = null, innerHTML = null;
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
                children = propValue;
                break;
              case "dangerouslySetInnerHTML":
                innerHTML = propValue;
                break;
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        return target.push(endOfStartTag), pushInnerHTML(target, innerHTML, children), typeof children == "string" ? (target.push(encodeHTMLTextNode(children)), null) : children;
      }
      function pushStartCustomElement(target, props, tag, responseState) {
        target.push(startChunkForTag(tag));
        var children = null, innerHTML = null;
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
                children = propValue;
                break;
              case "dangerouslySetInnerHTML":
                innerHTML = propValue;
                break;
              case "style":
                pushStyle(target, responseState, propValue);
                break;
              case "suppressContentEditableWarning":
              case "suppressHydrationWarning":
                break;
              default:
                isAttributeNameSafe(propKey) && typeof propValue != "function" && typeof propValue != "symbol" && target.push(attributeSeparator, propKey, attributeAssign, escapeTextForBrowser(propValue), attributeEnd);
                break;
            }
          }
        return target.push(endOfStartTag), pushInnerHTML(target, innerHTML, children), children;
      }
      var leadingNewline = stringToPrecomputedChunk(`
`);
      function pushStartPreformattedElement(target, props, tag, responseState) {
        target.push(startChunkForTag(tag));
        var children = null, innerHTML = null;
        for (var propKey in props)
          if (hasOwnProperty.call(props, propKey)) {
            var propValue = props[propKey];
            if (propValue == null)
              continue;
            switch (propKey) {
              case "children":
                children = propValue;
                break;
              case "dangerouslySetInnerHTML":
                innerHTML = propValue;
                break;
              default:
                pushAttribute(target, responseState, propKey, propValue);
                break;
            }
          }
        if (target.push(endOfStartTag), innerHTML != null) {
          if (children != null)
            throw new Error("Can only set one of `children` or `props.dangerouslySetInnerHTML`.");
          if (typeof innerHTML != "object" || !("__html" in innerHTML))
            throw new Error("`props.dangerouslySetInnerHTML` must be in the form `{__html: ...}`. Please visit https://reactjs.org/link/dangerously-set-inner-html for more information.");
          var html = innerHTML.__html;
          html != null && (typeof html == "string" && html.length > 0 && html[0] === `
` ? target.push(leadingNewline, html) : (checkHtmlStringCoercion(html), target.push("" + html)));
        }
        return typeof children == "string" && children[0] === `
` && target.push(leadingNewline), children;
      }
      var VALID_TAG_REGEX = /^[a-zA-Z][a-zA-Z:_\.\-\d]*$/, validatedTagCache = /* @__PURE__ */ new Map();
      function startChunkForTag(tag) {
        var tagStartChunk = validatedTagCache.get(tag);
        if (tagStartChunk === void 0) {
          if (!VALID_TAG_REGEX.test(tag))
            throw new Error("Invalid tag: " + tag);
          tagStartChunk = stringToPrecomputedChunk("<" + tag), validatedTagCache.set(tag, tagStartChunk);
        }
        return tagStartChunk;
      }
      var DOCTYPE = stringToPrecomputedChunk("<!DOCTYPE html>");
      function pushStartInstance(target, type, props, responseState, formatContext) {
        switch (validateProperties(type, props), validateProperties$1(type, props), validateProperties$2(type, props, null), !props.suppressContentEditableWarning && props.contentEditable && props.children != null && error("A component is `contentEditable` and contains `children` managed by React. It is now your responsibility to guarantee that none of those nodes are unexpectedly modified or duplicated. This is probably not intentional."), formatContext.insertionMode !== SVG_MODE && formatContext.insertionMode !== MATHML_MODE && type.indexOf("-") === -1 && typeof props.is != "string" && type.toLowerCase() !== type && error("<%s /> is using incorrect casing. Use PascalCase for React components, or lowercase for HTML elements.", type), type) {
          case "select":
            return pushStartSelect(target, props, responseState);
          case "option":
            return pushStartOption(target, props, responseState, formatContext);
          case "textarea":
            return pushStartTextArea(target, props, responseState);
          case "input":
            return pushInput(target, props, responseState);
          case "menuitem":
            return pushStartMenuItem(target, props, responseState);
          case "title":
            return pushStartTitle(target, props, responseState);
          case "listing":
          case "pre":
            return pushStartPreformattedElement(target, props, type, responseState);
          case "area":
          case "base":
          case "br":
          case "col":
          case "embed":
          case "hr":
          case "img":
          case "keygen":
          case "link":
          case "meta":
          case "param":
          case "source":
          case "track":
          case "wbr":
            return pushSelfClosing(target, props, type, responseState);
          case "annotation-xml":
          case "color-profile":
          case "font-face":
          case "font-face-src":
          case "font-face-uri":
          case "font-face-format":
          case "font-face-name":
          case "missing-glyph":
            return pushStartGenericElement(target, props, type, responseState);
          case "html":
            return formatContext.insertionMode === ROOT_HTML_MODE && target.push(DOCTYPE), pushStartGenericElement(target, props, type, responseState);
          default:
            return type.indexOf("-") === -1 && typeof props.is != "string" ? pushStartGenericElement(target, props, type, responseState) : pushStartCustomElement(target, props, type, responseState);
        }
      }
      var endTag1 = stringToPrecomputedChunk("</"), endTag2 = stringToPrecomputedChunk(">");
      function pushEndInstance(target, type, props) {
        switch (type) {
          case "area":
          case "base":
          case "br":
          case "col":
          case "embed":
          case "hr":
          case "img":
          case "input":
          case "keygen":
          case "link":
          case "meta":
          case "param":
          case "source":
          case "track":
          case "wbr":
            break;
          default:
            target.push(endTag1, type, endTag2);
        }
      }
      function writeCompletedRoot(destination, responseState) {
        for (var bootstrapChunks = responseState.bootstrapChunks, i = 0; i < bootstrapChunks.length - 1; i++)
          writeChunk(destination, bootstrapChunks[i]);
        return i < bootstrapChunks.length ? writeChunkAndReturn(destination, bootstrapChunks[i]) : !0;
      }
      var placeholder1 = stringToPrecomputedChunk('<template id="'), placeholder2 = stringToPrecomputedChunk('"></template>');
      function writePlaceholder(destination, responseState, id) {
        writeChunk(destination, placeholder1), writeChunk(destination, responseState.placeholderPrefix);
        var formattedID = id.toString(16);
        return writeChunk(destination, formattedID), writeChunkAndReturn(destination, placeholder2);
      }
      var startCompletedSuspenseBoundary = stringToPrecomputedChunk("<!--$-->"), startPendingSuspenseBoundary1 = stringToPrecomputedChunk('<!--$?--><template id="'), startPendingSuspenseBoundary2 = stringToPrecomputedChunk('"></template>'), startClientRenderedSuspenseBoundary = stringToPrecomputedChunk("<!--$!-->"), endSuspenseBoundary = stringToPrecomputedChunk("<!--/$-->"), clientRenderedSuspenseBoundaryError1 = stringToPrecomputedChunk("<template"), clientRenderedSuspenseBoundaryErrorAttrInterstitial = stringToPrecomputedChunk('"'), clientRenderedSuspenseBoundaryError1A = stringToPrecomputedChunk(' data-dgst="'), clientRenderedSuspenseBoundaryError1B = stringToPrecomputedChunk(' data-msg="'), clientRenderedSuspenseBoundaryError1C = stringToPrecomputedChunk(' data-stck="'), clientRenderedSuspenseBoundaryError2 = stringToPrecomputedChunk("></template>");
      function writeStartCompletedSuspenseBoundary(destination, responseState) {
        return writeChunkAndReturn(destination, startCompletedSuspenseBoundary);
      }
      function writeStartPendingSuspenseBoundary(destination, responseState, id) {
        if (writeChunk(destination, startPendingSuspenseBoundary1), id === null)
          throw new Error("An ID must have been assigned before we can complete the boundary.");
        return writeChunk(destination, id), writeChunkAndReturn(destination, startPendingSuspenseBoundary2);
      }
      function writeStartClientRenderedSuspenseBoundary(destination, responseState, errorDigest, errorMesssage, errorComponentStack) {
        var result;
        return result = writeChunkAndReturn(destination, startClientRenderedSuspenseBoundary), writeChunk(destination, clientRenderedSuspenseBoundaryError1), errorDigest && (writeChunk(destination, clientRenderedSuspenseBoundaryError1A), writeChunk(destination, escapeTextForBrowser(errorDigest)), writeChunk(destination, clientRenderedSuspenseBoundaryErrorAttrInterstitial)), errorMesssage && (writeChunk(destination, clientRenderedSuspenseBoundaryError1B), writeChunk(destination, escapeTextForBrowser(errorMesssage)), writeChunk(destination, clientRenderedSuspenseBoundaryErrorAttrInterstitial)), errorComponentStack && (writeChunk(destination, clientRenderedSuspenseBoundaryError1C), writeChunk(destination, escapeTextForBrowser(errorComponentStack)), writeChunk(destination, clientRenderedSuspenseBoundaryErrorAttrInterstitial)), result = writeChunkAndReturn(destination, clientRenderedSuspenseBoundaryError2), result;
      }
      function writeEndCompletedSuspenseBoundary(destination, responseState) {
        return writeChunkAndReturn(destination, endSuspenseBoundary);
      }
      function writeEndPendingSuspenseBoundary(destination, responseState) {
        return writeChunkAndReturn(destination, endSuspenseBoundary);
      }
      function writeEndClientRenderedSuspenseBoundary(destination, responseState) {
        return writeChunkAndReturn(destination, endSuspenseBoundary);
      }
      var startSegmentHTML = stringToPrecomputedChunk('<div hidden id="'), startSegmentHTML2 = stringToPrecomputedChunk('">'), endSegmentHTML = stringToPrecomputedChunk("</div>"), startSegmentSVG = stringToPrecomputedChunk('<svg aria-hidden="true" style="display:none" id="'), startSegmentSVG2 = stringToPrecomputedChunk('">'), endSegmentSVG = stringToPrecomputedChunk("</svg>"), startSegmentMathML = stringToPrecomputedChunk('<math aria-hidden="true" style="display:none" id="'), startSegmentMathML2 = stringToPrecomputedChunk('">'), endSegmentMathML = stringToPrecomputedChunk("</math>"), startSegmentTable = stringToPrecomputedChunk('<table hidden id="'), startSegmentTable2 = stringToPrecomputedChunk('">'), endSegmentTable = stringToPrecomputedChunk("</table>"), startSegmentTableBody = stringToPrecomputedChunk('<table hidden><tbody id="'), startSegmentTableBody2 = stringToPrecomputedChunk('">'), endSegmentTableBody = stringToPrecomputedChunk("</tbody></table>"), startSegmentTableRow = stringToPrecomputedChunk('<table hidden><tr id="'), startSegmentTableRow2 = stringToPrecomputedChunk('">'), endSegmentTableRow = stringToPrecomputedChunk("</tr></table>"), startSegmentColGroup = stringToPrecomputedChunk('<table hidden><colgroup id="'), startSegmentColGroup2 = stringToPrecomputedChunk('">'), endSegmentColGroup = stringToPrecomputedChunk("</colgroup></table>");
      function writeStartSegment(destination, responseState, formatContext, id) {
        switch (formatContext.insertionMode) {
          case ROOT_HTML_MODE:
          case HTML_MODE:
            return writeChunk(destination, startSegmentHTML), writeChunk(destination, responseState.segmentPrefix), writeChunk(destination, id.toString(16)), writeChunkAndReturn(destination, startSegmentHTML2);
          case SVG_MODE:
            return writeChunk(destination, startSegmentSVG), writeChunk(destination, responseState.segmentPrefix), writeChunk(destination, id.toString(16)), writeChunkAndReturn(destination, startSegmentSVG2);
          case MATHML_MODE:
            return writeChunk(destination, startSegmentMathML), writeChunk(destination, responseState.segmentPrefix), writeChunk(destination, id.toString(16)), writeChunkAndReturn(destination, startSegmentMathML2);
          case HTML_TABLE_MODE:
            return writeChunk(destination, startSegmentTable), writeChunk(destination, responseState.segmentPrefix), writeChunk(destination, id.toString(16)), writeChunkAndReturn(destination, startSegmentTable2);
          case HTML_TABLE_BODY_MODE:
            return writeChunk(destination, startSegmentTableBody), writeChunk(destination, responseState.segmentPrefix), writeChunk(destination, id.toString(16)), writeChunkAndReturn(destination, startSegmentTableBody2);
          case HTML_TABLE_ROW_MODE:
            return writeChunk(destination, startSegmentTableRow), writeChunk(destination, responseState.segmentPrefix), writeChunk(destination, id.toString(16)), writeChunkAndReturn(destination, startSegmentTableRow2);
          case HTML_COLGROUP_MODE:
            return writeChunk(destination, startSegmentColGroup), writeChunk(destination, responseState.segmentPrefix), writeChunk(destination, id.toString(16)), writeChunkAndReturn(destination, startSegmentColGroup2);
          default:
            throw new Error("Unknown insertion mode. This is a bug in React.");
        }
      }
      function writeEndSegment(destination, formatContext) {
        switch (formatContext.insertionMode) {
          case ROOT_HTML_MODE:
          case HTML_MODE:
            return writeChunkAndReturn(destination, endSegmentHTML);
          case SVG_MODE:
            return writeChunkAndReturn(destination, endSegmentSVG);
          case MATHML_MODE:
            return writeChunkAndReturn(destination, endSegmentMathML);
          case HTML_TABLE_MODE:
            return writeChunkAndReturn(destination, endSegmentTable);
          case HTML_TABLE_BODY_MODE:
            return writeChunkAndReturn(destination, endSegmentTableBody);
          case HTML_TABLE_ROW_MODE:
            return writeChunkAndReturn(destination, endSegmentTableRow);
          case HTML_COLGROUP_MODE:
            return writeChunkAndReturn(destination, endSegmentColGroup);
          default:
            throw new Error("Unknown insertion mode. This is a bug in React.");
        }
      }
      var completeSegmentFunction = "function $RS(a,b){a=document.getElementById(a);b=document.getElementById(b);for(a.parentNode.removeChild(a);a.firstChild;)b.parentNode.insertBefore(a.firstChild,b);b.parentNode.removeChild(b)}", completeBoundaryFunction = 'function $RC(a,b){a=document.getElementById(a);b=document.getElementById(b);b.parentNode.removeChild(b);if(a){a=a.previousSibling;var f=a.parentNode,c=a.nextSibling,e=0;do{if(c&&8===c.nodeType){var d=c.data;if("/$"===d)if(0===e)break;else e--;else"$"!==d&&"$?"!==d&&"$!"!==d||e++}d=c.nextSibling;f.removeChild(c);c=d}while(c);for(;b.firstChild;)f.insertBefore(b.firstChild,c);a.data="$";a._reactRetry&&a._reactRetry()}}', clientRenderFunction = 'function $RX(b,c,d,e){var a=document.getElementById(b);a&&(b=a.previousSibling,b.data="$!",a=a.dataset,c&&(a.dgst=c),d&&(a.msg=d),e&&(a.stck=e),b._reactRetry&&b._reactRetry())}', completeSegmentScript1Full = stringToPrecomputedChunk(completeSegmentFunction + ';$RS("'), completeSegmentScript1Partial = stringToPrecomputedChunk('$RS("'), completeSegmentScript2 = stringToPrecomputedChunk('","'), completeSegmentScript3 = stringToPrecomputedChunk('")</script>');
      function writeCompletedSegmentInstruction(destination, responseState, contentSegmentID) {
        writeChunk(destination, responseState.startInlineScript), responseState.sentCompleteSegmentFunction ? writeChunk(destination, completeSegmentScript1Partial) : (responseState.sentCompleteSegmentFunction = !0, writeChunk(destination, completeSegmentScript1Full)), writeChunk(destination, responseState.segmentPrefix);
        var formattedID = contentSegmentID.toString(16);
        return writeChunk(destination, formattedID), writeChunk(destination, completeSegmentScript2), writeChunk(destination, responseState.placeholderPrefix), writeChunk(destination, formattedID), writeChunkAndReturn(destination, completeSegmentScript3);
      }
      var completeBoundaryScript1Full = stringToPrecomputedChunk(completeBoundaryFunction + ';$RC("'), completeBoundaryScript1Partial = stringToPrecomputedChunk('$RC("'), completeBoundaryScript2 = stringToPrecomputedChunk('","'), completeBoundaryScript3 = stringToPrecomputedChunk('")</script>');
      function writeCompletedBoundaryInstruction(destination, responseState, boundaryID, contentSegmentID) {
        if (writeChunk(destination, responseState.startInlineScript), responseState.sentCompleteBoundaryFunction ? writeChunk(destination, completeBoundaryScript1Partial) : (responseState.sentCompleteBoundaryFunction = !0, writeChunk(destination, completeBoundaryScript1Full)), boundaryID === null)
          throw new Error("An ID must have been assigned before we can complete the boundary.");
        var formattedContentID = contentSegmentID.toString(16);
        return writeChunk(destination, boundaryID), writeChunk(destination, completeBoundaryScript2), writeChunk(destination, responseState.segmentPrefix), writeChunk(destination, formattedContentID), writeChunkAndReturn(destination, completeBoundaryScript3);
      }
      var clientRenderScript1Full = stringToPrecomputedChunk(clientRenderFunction + ';$RX("'), clientRenderScript1Partial = stringToPrecomputedChunk('$RX("'), clientRenderScript1A = stringToPrecomputedChunk('"'), clientRenderScript2 = stringToPrecomputedChunk(")</script>"), clientRenderErrorScriptArgInterstitial = stringToPrecomputedChunk(",");
      function writeClientRenderBoundaryInstruction(destination, responseState, boundaryID, errorDigest, errorMessage2, errorComponentStack) {
        if (writeChunk(destination, responseState.startInlineScript), responseState.sentClientRenderFunction ? writeChunk(destination, clientRenderScript1Partial) : (responseState.sentClientRenderFunction = !0, writeChunk(destination, clientRenderScript1Full)), boundaryID === null)
          throw new Error("An ID must have been assigned before we can complete the boundary.");
        return writeChunk(destination, boundaryID), writeChunk(destination, clientRenderScript1A), (errorDigest || errorMessage2 || errorComponentStack) && (writeChunk(destination, clientRenderErrorScriptArgInterstitial), writeChunk(destination, escapeJSStringsForInstructionScripts(errorDigest || ""))), (errorMessage2 || errorComponentStack) && (writeChunk(destination, clientRenderErrorScriptArgInterstitial), writeChunk(destination, escapeJSStringsForInstructionScripts(errorMessage2 || ""))), errorComponentStack && (writeChunk(destination, clientRenderErrorScriptArgInterstitial), writeChunk(destination, escapeJSStringsForInstructionScripts(errorComponentStack))), writeChunkAndReturn(destination, clientRenderScript2);
      }
      var regexForJSStringsInScripts = /[<\u2028\u2029]/g;
      function escapeJSStringsForInstructionScripts(input) {
        var escaped = JSON.stringify(input);
        return escaped.replace(regexForJSStringsInScripts, function(match2) {
          switch (match2) {
            case "<":
              return "\\u003c";
            case "\u2028":
              return "\\u2028";
            case "\u2029":
              return "\\u2029";
            default:
              throw new Error("escapeJSStringsForInstructionScripts encountered a match it does not know how to replace. this means the match regex and the replacement characters are no longer in sync. This is a bug in React");
          }
        });
      }
      var assign = Object.assign, REACT_ELEMENT_TYPE = Symbol.for("react.element"), REACT_PORTAL_TYPE = Symbol.for("react.portal"), REACT_FRAGMENT_TYPE = Symbol.for("react.fragment"), REACT_STRICT_MODE_TYPE = Symbol.for("react.strict_mode"), REACT_PROFILER_TYPE = Symbol.for("react.profiler"), REACT_PROVIDER_TYPE = Symbol.for("react.provider"), REACT_CONTEXT_TYPE = Symbol.for("react.context"), REACT_FORWARD_REF_TYPE = Symbol.for("react.forward_ref"), REACT_SUSPENSE_TYPE = Symbol.for("react.suspense"), REACT_SUSPENSE_LIST_TYPE = Symbol.for("react.suspense_list"), REACT_MEMO_TYPE = Symbol.for("react.memo"), REACT_LAZY_TYPE = Symbol.for("react.lazy"), REACT_SCOPE_TYPE = Symbol.for("react.scope"), REACT_DEBUG_TRACING_MODE_TYPE = Symbol.for("react.debug_trace_mode"), REACT_LEGACY_HIDDEN_TYPE = Symbol.for("react.legacy_hidden"), REACT_SERVER_CONTEXT_DEFAULT_VALUE_NOT_LOADED = Symbol.for("react.default_value"), MAYBE_ITERATOR_SYMBOL = Symbol.iterator, FAUX_ITERATOR_SYMBOL = "@@iterator";
      function getIteratorFn(maybeIterable) {
        if (maybeIterable === null || typeof maybeIterable != "object")
          return null;
        var maybeIterator = MAYBE_ITERATOR_SYMBOL && maybeIterable[MAYBE_ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL];
        return typeof maybeIterator == "function" ? maybeIterator : null;
      }
      function getWrappedName(outerType, innerType, wrapperName) {
        var displayName = outerType.displayName;
        if (displayName)
          return displayName;
        var functionName = innerType.displayName || innerType.name || "";
        return functionName !== "" ? wrapperName + "(" + functionName + ")" : wrapperName;
      }
      function getContextName(type) {
        return type.displayName || "Context";
      }
      function getComponentNameFromType(type) {
        if (type == null)
          return null;
        if (typeof type.tag == "number" && error("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue."), typeof type == "function")
          return type.displayName || type.name || null;
        if (typeof type == "string")
          return type;
        switch (type) {
          case REACT_FRAGMENT_TYPE:
            return "Fragment";
          case REACT_PORTAL_TYPE:
            return "Portal";
          case REACT_PROFILER_TYPE:
            return "Profiler";
          case REACT_STRICT_MODE_TYPE:
            return "StrictMode";
          case REACT_SUSPENSE_TYPE:
            return "Suspense";
          case REACT_SUSPENSE_LIST_TYPE:
            return "SuspenseList";
        }
        if (typeof type == "object")
          switch (type.$$typeof) {
            case REACT_CONTEXT_TYPE:
              var context = type;
              return getContextName(context) + ".Consumer";
            case REACT_PROVIDER_TYPE:
              var provider = type;
              return getContextName(provider._context) + ".Provider";
            case REACT_FORWARD_REF_TYPE:
              return getWrappedName(type, type.render, "ForwardRef");
            case REACT_MEMO_TYPE:
              var outerName = type.displayName || null;
              return outerName !== null ? outerName : getComponentNameFromType(type.type) || "Memo";
            case REACT_LAZY_TYPE: {
              var lazyComponent = type, payload = lazyComponent._payload, init4 = lazyComponent._init;
              try {
                return getComponentNameFromType(init4(payload));
              } catch {
                return null;
              }
            }
          }
        return null;
      }
      var disabledDepth = 0, prevLog, prevInfo, prevWarn, prevError, prevGroup, prevGroupCollapsed, prevGroupEnd;
      function disabledLog() {
      }
      disabledLog.__reactDisabledLog = !0;
      function disableLogs() {
        {
          if (disabledDepth === 0) {
            prevLog = console.log, prevInfo = console.info, prevWarn = console.warn, prevError = console.error, prevGroup = console.group, prevGroupCollapsed = console.groupCollapsed, prevGroupEnd = console.groupEnd;
            var props = {
              configurable: !0,
              enumerable: !0,
              value: disabledLog,
              writable: !0
            };
            Object.defineProperties(console, {
              info: props,
              log: props,
              warn: props,
              error: props,
              group: props,
              groupCollapsed: props,
              groupEnd: props
            });
          }
          disabledDepth++;
        }
      }
      function reenableLogs() {
        {
          if (disabledDepth--, disabledDepth === 0) {
            var props = {
              configurable: !0,
              enumerable: !0,
              writable: !0
            };
            Object.defineProperties(console, {
              log: assign({}, props, {
                value: prevLog
              }),
              info: assign({}, props, {
                value: prevInfo
              }),
              warn: assign({}, props, {
                value: prevWarn
              }),
              error: assign({}, props, {
                value: prevError
              }),
              group: assign({}, props, {
                value: prevGroup
              }),
              groupCollapsed: assign({}, props, {
                value: prevGroupCollapsed
              }),
              groupEnd: assign({}, props, {
                value: prevGroupEnd
              })
            });
          }
          disabledDepth < 0 && error("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
        }
      }
      var ReactCurrentDispatcher = ReactSharedInternals.ReactCurrentDispatcher, prefix;
      function describeBuiltInComponentFrame(name, source, ownerFn) {
        {
          if (prefix === void 0)
            try {
              throw Error();
            } catch (x) {
              var match2 = x.stack.trim().match(/\n( *(at )?)/);
              prefix = match2 && match2[1] || "";
            }
          return `
` + prefix + name;
        }
      }
      var reentry = !1, componentFrameCache;
      {
        var PossiblyWeakMap = typeof WeakMap == "function" ? WeakMap : Map;
        componentFrameCache = new PossiblyWeakMap();
      }
      function describeNativeComponentFrame(fn, construct) {
        if (!fn || reentry)
          return "";
        {
          var frame = componentFrameCache.get(fn);
          if (frame !== void 0)
            return frame;
        }
        var control;
        reentry = !0;
        var previousPrepareStackTrace = Error.prepareStackTrace;
        Error.prepareStackTrace = void 0;
        var previousDispatcher;
        previousDispatcher = ReactCurrentDispatcher.current, ReactCurrentDispatcher.current = null, disableLogs();
        try {
          if (construct) {
            var Fake = function() {
              throw Error();
            };
            if (Object.defineProperty(Fake.prototype, "props", {
              set: function() {
                throw Error();
              }
            }), typeof Reflect == "object" && Reflect.construct) {
              try {
                Reflect.construct(Fake, []);
              } catch (x) {
                control = x;
              }
              Reflect.construct(fn, [], Fake);
            } else {
              try {
                Fake.call();
              } catch (x) {
                control = x;
              }
              fn.call(Fake.prototype);
            }
          } else {
            try {
              throw Error();
            } catch (x) {
              control = x;
            }
            fn();
          }
        } catch (sample) {
          if (sample && control && typeof sample.stack == "string") {
            for (var sampleLines = sample.stack.split(`
`), controlLines = control.stack.split(`
`), s = sampleLines.length - 1, c = controlLines.length - 1; s >= 1 && c >= 0 && sampleLines[s] !== controlLines[c]; )
              c--;
            for (; s >= 1 && c >= 0; s--, c--)
              if (sampleLines[s] !== controlLines[c]) {
                if (s !== 1 || c !== 1)
                  do
                    if (s--, c--, c < 0 || sampleLines[s] !== controlLines[c]) {
                      var _frame = `
` + sampleLines[s].replace(" at new ", " at ");
                      return fn.displayName && _frame.includes("<anonymous>") && (_frame = _frame.replace("<anonymous>", fn.displayName)), typeof fn == "function" && componentFrameCache.set(fn, _frame), _frame;
                    }
                  while (s >= 1 && c >= 0);
                break;
              }
          }
        } finally {
          reentry = !1, ReactCurrentDispatcher.current = previousDispatcher, reenableLogs(), Error.prepareStackTrace = previousPrepareStackTrace;
        }
        var name = fn ? fn.displayName || fn.name : "", syntheticFrame = name ? describeBuiltInComponentFrame(name) : "";
        return typeof fn == "function" && componentFrameCache.set(fn, syntheticFrame), syntheticFrame;
      }
      function describeClassComponentFrame(ctor, source, ownerFn) {
        return describeNativeComponentFrame(ctor, !0);
      }
      function describeFunctionComponentFrame(fn, source, ownerFn) {
        return describeNativeComponentFrame(fn, !1);
      }
      function shouldConstruct(Component) {
        var prototype = Component.prototype;
        return !!(prototype && prototype.isReactComponent);
      }
      function describeUnknownElementTypeFrameInDEV(type, source, ownerFn) {
        if (type == null)
          return "";
        if (typeof type == "function")
          return describeNativeComponentFrame(type, shouldConstruct(type));
        if (typeof type == "string")
          return describeBuiltInComponentFrame(type);
        switch (type) {
          case REACT_SUSPENSE_TYPE:
            return describeBuiltInComponentFrame("Suspense");
          case REACT_SUSPENSE_LIST_TYPE:
            return describeBuiltInComponentFrame("SuspenseList");
        }
        if (typeof type == "object")
          switch (type.$$typeof) {
            case REACT_FORWARD_REF_TYPE:
              return describeFunctionComponentFrame(type.render);
            case REACT_MEMO_TYPE:
              return describeUnknownElementTypeFrameInDEV(type.type, source, ownerFn);
            case REACT_LAZY_TYPE: {
              var lazyComponent = type, payload = lazyComponent._payload, init4 = lazyComponent._init;
              try {
                return describeUnknownElementTypeFrameInDEV(init4(payload), source, ownerFn);
              } catch {
              }
            }
          }
        return "";
      }
      var loggedTypeFailures = {}, ReactDebugCurrentFrame = ReactSharedInternals.ReactDebugCurrentFrame;
      function setCurrentlyValidatingElement(element) {
        if (element) {
          var owner = element._owner, stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
          ReactDebugCurrentFrame.setExtraStackFrame(stack);
        } else
          ReactDebugCurrentFrame.setExtraStackFrame(null);
      }
      function checkPropTypes(typeSpecs, values, location2, componentName, element) {
        {
          var has2 = Function.call.bind(hasOwnProperty);
          for (var typeSpecName in typeSpecs)
            if (has2(typeSpecs, typeSpecName)) {
              var error$1 = void 0;
              try {
                if (typeof typeSpecs[typeSpecName] != "function") {
                  var err2 = Error((componentName || "React class") + ": " + location2 + " type `" + typeSpecName + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof typeSpecs[typeSpecName] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                  throw err2.name = "Invariant Violation", err2;
                }
                error$1 = typeSpecs[typeSpecName](values, typeSpecName, componentName, location2, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
              } catch (ex) {
                error$1 = ex;
              }
              error$1 && !(error$1 instanceof Error) && (setCurrentlyValidatingElement(element), error("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", componentName || "React class", location2, typeSpecName, typeof error$1), setCurrentlyValidatingElement(null)), error$1 instanceof Error && !(error$1.message in loggedTypeFailures) && (loggedTypeFailures[error$1.message] = !0, setCurrentlyValidatingElement(element), error("Failed %s type: %s", location2, error$1.message), setCurrentlyValidatingElement(null));
            }
        }
      }
      var warnedAboutMissingGetChildContext;
      warnedAboutMissingGetChildContext = {};
      var emptyContextObject = {};
      Object.freeze(emptyContextObject);
      function getMaskedContext(type, unmaskedContext) {
        {
          var contextTypes = type.contextTypes;
          if (!contextTypes)
            return emptyContextObject;
          var context = {};
          for (var key in contextTypes)
            context[key] = unmaskedContext[key];
          {
            var name = getComponentNameFromType(type) || "Unknown";
            checkPropTypes(contextTypes, context, "context", name);
          }
          return context;
        }
      }
      function processChildContext(instance, type, parentContext, childContextTypes) {
        {
          if (typeof instance.getChildContext != "function") {
            {
              var componentName = getComponentNameFromType(type) || "Unknown";
              warnedAboutMissingGetChildContext[componentName] || (warnedAboutMissingGetChildContext[componentName] = !0, error("%s.childContextTypes is specified but there is no getChildContext() method on the instance. You can either define getChildContext() on %s or remove childContextTypes from it.", componentName, componentName));
            }
            return parentContext;
          }
          var childContext = instance.getChildContext();
          for (var contextKey in childContext)
            if (!(contextKey in childContextTypes))
              throw new Error((getComponentNameFromType(type) || "Unknown") + '.getChildContext(): key "' + contextKey + '" is not defined in childContextTypes.');
          {
            var name = getComponentNameFromType(type) || "Unknown";
            checkPropTypes(childContextTypes, childContext, "child context", name);
          }
          return assign({}, parentContext, childContext);
        }
      }
      var rendererSigil;
      rendererSigil = {};
      var rootContextSnapshot = null, currentActiveSnapshot = null;
      function popNode(prev) {
        prev.context._currentValue = prev.parentValue;
      }
      function pushNode(next) {
        next.context._currentValue = next.value;
      }
      function popToNearestCommonAncestor(prev, next) {
        if (prev !== next) {
          popNode(prev);
          var parentPrev = prev.parent, parentNext = next.parent;
          if (parentPrev === null) {
            if (parentNext !== null)
              throw new Error("The stacks must reach the root at the same time. This is a bug in React.");
          } else {
            if (parentNext === null)
              throw new Error("The stacks must reach the root at the same time. This is a bug in React.");
            popToNearestCommonAncestor(parentPrev, parentNext);
          }
          pushNode(next);
        }
      }
      function popAllPrevious(prev) {
        popNode(prev);
        var parentPrev = prev.parent;
        parentPrev !== null && popAllPrevious(parentPrev);
      }
      function pushAllNext(next) {
        var parentNext = next.parent;
        parentNext !== null && pushAllNext(parentNext), pushNode(next);
      }
      function popPreviousToCommonLevel(prev, next) {
        popNode(prev);
        var parentPrev = prev.parent;
        if (parentPrev === null)
          throw new Error("The depth must equal at least at zero before reaching the root. This is a bug in React.");
        parentPrev.depth === next.depth ? popToNearestCommonAncestor(parentPrev, next) : popPreviousToCommonLevel(parentPrev, next);
      }
      function popNextToCommonLevel(prev, next) {
        var parentNext = next.parent;
        if (parentNext === null)
          throw new Error("The depth must equal at least at zero before reaching the root. This is a bug in React.");
        prev.depth === parentNext.depth ? popToNearestCommonAncestor(prev, parentNext) : popNextToCommonLevel(prev, parentNext), pushNode(next);
      }
      function switchContext(newSnapshot) {
        var prev = currentActiveSnapshot, next = newSnapshot;
        prev !== next && (prev === null ? pushAllNext(next) : next === null ? popAllPrevious(prev) : prev.depth === next.depth ? popToNearestCommonAncestor(prev, next) : prev.depth > next.depth ? popPreviousToCommonLevel(prev, next) : popNextToCommonLevel(prev, next), currentActiveSnapshot = next);
      }
      function pushProvider(context, nextValue) {
        var prevValue;
        prevValue = context._currentValue, context._currentValue = nextValue, context._currentRenderer !== void 0 && context._currentRenderer !== null && context._currentRenderer !== rendererSigil && error("Detected multiple renderers concurrently rendering the same context provider. This is currently unsupported."), context._currentRenderer = rendererSigil;
        var prevNode = currentActiveSnapshot, newNode = {
          parent: prevNode,
          depth: prevNode === null ? 0 : prevNode.depth + 1,
          context,
          parentValue: prevValue,
          value: nextValue
        };
        return currentActiveSnapshot = newNode, newNode;
      }
      function popProvider(context) {
        var prevSnapshot = currentActiveSnapshot;
        if (prevSnapshot === null)
          throw new Error("Tried to pop a Context at the root of the app. This is a bug in React.");
        prevSnapshot.context !== context && error("The parent context is not the expected context. This is probably a bug in React.");
        {
          var value = prevSnapshot.parentValue;
          value === REACT_SERVER_CONTEXT_DEFAULT_VALUE_NOT_LOADED ? prevSnapshot.context._currentValue = prevSnapshot.context._defaultValue : prevSnapshot.context._currentValue = value, context._currentRenderer !== void 0 && context._currentRenderer !== null && context._currentRenderer !== rendererSigil && error("Detected multiple renderers concurrently rendering the same context provider. This is currently unsupported."), context._currentRenderer = rendererSigil;
        }
        return currentActiveSnapshot = prevSnapshot.parent;
      }
      function getActiveContext() {
        return currentActiveSnapshot;
      }
      function readContext(context) {
        var value = context._currentValue;
        return value;
      }
      function get2(key) {
        return key._reactInternals;
      }
      function set2(key, value) {
        key._reactInternals = value;
      }
      var didWarnAboutNoopUpdateForComponent = {}, didWarnAboutDeprecatedWillMount = {}, didWarnAboutUninitializedState, didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate, didWarnAboutLegacyLifecyclesAndDerivedState, didWarnAboutUndefinedDerivedState, warnOnUndefinedDerivedState, warnOnInvalidCallback, didWarnAboutDirectlyAssigningPropsToState, didWarnAboutContextTypeAndContextTypes, didWarnAboutInvalidateContextType;
      {
        didWarnAboutUninitializedState = /* @__PURE__ */ new Set(), didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate = /* @__PURE__ */ new Set(), didWarnAboutLegacyLifecyclesAndDerivedState = /* @__PURE__ */ new Set(), didWarnAboutDirectlyAssigningPropsToState = /* @__PURE__ */ new Set(), didWarnAboutUndefinedDerivedState = /* @__PURE__ */ new Set(), didWarnAboutContextTypeAndContextTypes = /* @__PURE__ */ new Set(), didWarnAboutInvalidateContextType = /* @__PURE__ */ new Set();
        var didWarnOnInvalidCallback = /* @__PURE__ */ new Set();
        warnOnInvalidCallback = function(callback, callerName) {
          if (!(callback === null || typeof callback == "function")) {
            var key = callerName + "_" + callback;
            didWarnOnInvalidCallback.has(key) || (didWarnOnInvalidCallback.add(key), error("%s(...): Expected the last optional `callback` argument to be a function. Instead received: %s.", callerName, callback));
          }
        }, warnOnUndefinedDerivedState = function(type, partialState) {
          if (partialState === void 0) {
            var componentName = getComponentNameFromType(type) || "Component";
            didWarnAboutUndefinedDerivedState.has(componentName) || (didWarnAboutUndefinedDerivedState.add(componentName), error("%s.getDerivedStateFromProps(): A valid state object (or null) must be returned. You have returned undefined.", componentName));
          }
        };
      }
      function warnNoop(publicInstance, callerName) {
        {
          var _constructor = publicInstance.constructor, componentName = _constructor && getComponentNameFromType(_constructor) || "ReactClass", warningKey = componentName + "." + callerName;
          if (didWarnAboutNoopUpdateForComponent[warningKey])
            return;
          error(`%s(...): Can only update a mounting component. This usually means you called %s() outside componentWillMount() on the server. This is a no-op.

Please check the code for the %s component.`, callerName, callerName, componentName), didWarnAboutNoopUpdateForComponent[warningKey] = !0;
        }
      }
      var classComponentUpdater = {
        isMounted: function(inst) {
          return !1;
        },
        enqueueSetState: function(inst, payload, callback) {
          var internals = get2(inst);
          internals.queue === null ? warnNoop(inst, "setState") : (internals.queue.push(payload), callback != null && warnOnInvalidCallback(callback, "setState"));
        },
        enqueueReplaceState: function(inst, payload, callback) {
          var internals = get2(inst);
          internals.replace = !0, internals.queue = [payload], callback != null && warnOnInvalidCallback(callback, "setState");
        },
        enqueueForceUpdate: function(inst, callback) {
          var internals = get2(inst);
          internals.queue === null ? warnNoop(inst, "forceUpdate") : callback != null && warnOnInvalidCallback(callback, "setState");
        }
      };
      function applyDerivedStateFromProps(instance, ctor, getDerivedStateFromProps, prevState, nextProps) {
        var partialState = getDerivedStateFromProps(nextProps, prevState);
        warnOnUndefinedDerivedState(ctor, partialState);
        var newState = partialState == null ? prevState : assign({}, prevState, partialState);
        return newState;
      }
      function constructClassInstance(ctor, props, maskedLegacyContext) {
        var context = emptyContextObject, contextType = ctor.contextType;
        if ("contextType" in ctor) {
          var isValid = (
            // Allow null for conditional declaration
            contextType === null || contextType !== void 0 && contextType.$$typeof === REACT_CONTEXT_TYPE && contextType._context === void 0
          );
          if (!isValid && !didWarnAboutInvalidateContextType.has(ctor)) {
            didWarnAboutInvalidateContextType.add(ctor);
            var addendum = "";
            contextType === void 0 ? addendum = " However, it is set to undefined. This can be caused by a typo or by mixing up named and default imports. This can also happen due to a circular dependency, so try moving the createContext() call to a separate file." : typeof contextType != "object" ? addendum = " However, it is set to a " + typeof contextType + "." : contextType.$$typeof === REACT_PROVIDER_TYPE ? addendum = " Did you accidentally pass the Context.Provider instead?" : contextType._context !== void 0 ? addendum = " Did you accidentally pass the Context.Consumer instead?" : addendum = " However, it is set to an object with keys {" + Object.keys(contextType).join(", ") + "}.", error("%s defines an invalid contextType. contextType should point to the Context object returned by React.createContext().%s", getComponentNameFromType(ctor) || "Component", addendum);
          }
        }
        typeof contextType == "object" && contextType !== null ? context = readContext(contextType) : context = maskedLegacyContext;
        var instance = new ctor(props, context);
        {
          if (typeof ctor.getDerivedStateFromProps == "function" && (instance.state === null || instance.state === void 0)) {
            var componentName = getComponentNameFromType(ctor) || "Component";
            didWarnAboutUninitializedState.has(componentName) || (didWarnAboutUninitializedState.add(componentName), error("`%s` uses `getDerivedStateFromProps` but its initial state is %s. This is not recommended. Instead, define the initial state by assigning an object to `this.state` in the constructor of `%s`. This ensures that `getDerivedStateFromProps` arguments have a consistent shape.", componentName, instance.state === null ? "null" : "undefined", componentName));
          }
          if (typeof ctor.getDerivedStateFromProps == "function" || typeof instance.getSnapshotBeforeUpdate == "function") {
            var foundWillMountName = null, foundWillReceivePropsName = null, foundWillUpdateName = null;
            if (typeof instance.componentWillMount == "function" && instance.componentWillMount.__suppressDeprecationWarning !== !0 ? foundWillMountName = "componentWillMount" : typeof instance.UNSAFE_componentWillMount == "function" && (foundWillMountName = "UNSAFE_componentWillMount"), typeof instance.componentWillReceiveProps == "function" && instance.componentWillReceiveProps.__suppressDeprecationWarning !== !0 ? foundWillReceivePropsName = "componentWillReceiveProps" : typeof instance.UNSAFE_componentWillReceiveProps == "function" && (foundWillReceivePropsName = "UNSAFE_componentWillReceiveProps"), typeof instance.componentWillUpdate == "function" && instance.componentWillUpdate.__suppressDeprecationWarning !== !0 ? foundWillUpdateName = "componentWillUpdate" : typeof instance.UNSAFE_componentWillUpdate == "function" && (foundWillUpdateName = "UNSAFE_componentWillUpdate"), foundWillMountName !== null || foundWillReceivePropsName !== null || foundWillUpdateName !== null) {
              var _componentName = getComponentNameFromType(ctor) || "Component", newApiName = typeof ctor.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
              didWarnAboutLegacyLifecyclesAndDerivedState.has(_componentName) || (didWarnAboutLegacyLifecyclesAndDerivedState.add(_componentName), error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

%s uses %s but also contains the following legacy lifecycles:%s%s%s

The above lifecycles should be removed. Learn more about this warning here:
https://reactjs.org/link/unsafe-component-lifecycles`, _componentName, newApiName, foundWillMountName !== null ? `
  ` + foundWillMountName : "", foundWillReceivePropsName !== null ? `
  ` + foundWillReceivePropsName : "", foundWillUpdateName !== null ? `
  ` + foundWillUpdateName : ""));
            }
          }
        }
        return instance;
      }
      function checkClassInstance(instance, ctor, newProps) {
        {
          var name = getComponentNameFromType(ctor) || "Component", renderPresent = instance.render;
          renderPresent || (ctor.prototype && typeof ctor.prototype.render == "function" ? error("%s(...): No `render` method found on the returned component instance: did you accidentally return an object from the constructor?", name) : error("%s(...): No `render` method found on the returned component instance: you may have forgotten to define `render`.", name)), instance.getInitialState && !instance.getInitialState.isReactClassApproved && !instance.state && error("getInitialState was defined on %s, a plain JavaScript class. This is only supported for classes created using React.createClass. Did you mean to define a state property instead?", name), instance.getDefaultProps && !instance.getDefaultProps.isReactClassApproved && error("getDefaultProps was defined on %s, a plain JavaScript class. This is only supported for classes created using React.createClass. Use a static property to define defaultProps instead.", name), instance.propTypes && error("propTypes was defined as an instance property on %s. Use a static property to define propTypes instead.", name), instance.contextType && error("contextType was defined as an instance property on %s. Use a static property to define contextType instead.", name), instance.contextTypes && error("contextTypes was defined as an instance property on %s. Use a static property to define contextTypes instead.", name), ctor.contextType && ctor.contextTypes && !didWarnAboutContextTypeAndContextTypes.has(ctor) && (didWarnAboutContextTypeAndContextTypes.add(ctor), error("%s declares both contextTypes and contextType static properties. The legacy contextTypes property will be ignored.", name)), typeof instance.componentShouldUpdate == "function" && error("%s has a method called componentShouldUpdate(). Did you mean shouldComponentUpdate()? The name is phrased as a question because the function is expected to return a value.", name), ctor.prototype && ctor.prototype.isPureReactComponent && typeof instance.shouldComponentUpdate < "u" && error("%s has a method called shouldComponentUpdate(). shouldComponentUpdate should not be used when extending React.PureComponent. Please extend React.Component if shouldComponentUpdate is used.", getComponentNameFromType(ctor) || "A pure component"), typeof instance.componentDidUnmount == "function" && error("%s has a method called componentDidUnmount(). But there is no such lifecycle method. Did you mean componentWillUnmount()?", name), typeof instance.componentDidReceiveProps == "function" && error("%s has a method called componentDidReceiveProps(). But there is no such lifecycle method. If you meant to update the state in response to changing props, use componentWillReceiveProps(). If you meant to fetch data or run side-effects or mutations after React has updated the UI, use componentDidUpdate().", name), typeof instance.componentWillRecieveProps == "function" && error("%s has a method called componentWillRecieveProps(). Did you mean componentWillReceiveProps()?", name), typeof instance.UNSAFE_componentWillRecieveProps == "function" && error("%s has a method called UNSAFE_componentWillRecieveProps(). Did you mean UNSAFE_componentWillReceiveProps()?", name);
          var hasMutatedProps = instance.props !== newProps;
          instance.props !== void 0 && hasMutatedProps && error("%s(...): When calling super() in `%s`, make sure to pass up the same props that your component's constructor was passed.", name, name), instance.defaultProps && error("Setting defaultProps as an instance property on %s is not supported and will be ignored. Instead, define defaultProps as a static property on %s.", name, name), typeof instance.getSnapshotBeforeUpdate == "function" && typeof instance.componentDidUpdate != "function" && !didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate.has(ctor) && (didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate.add(ctor), error("%s: getSnapshotBeforeUpdate() should be used with componentDidUpdate(). This component defines getSnapshotBeforeUpdate() only.", getComponentNameFromType(ctor))), typeof instance.getDerivedStateFromProps == "function" && error("%s: getDerivedStateFromProps() is defined as an instance method and will be ignored. Instead, declare it as a static method.", name), typeof instance.getDerivedStateFromError == "function" && error("%s: getDerivedStateFromError() is defined as an instance method and will be ignored. Instead, declare it as a static method.", name), typeof ctor.getSnapshotBeforeUpdate == "function" && error("%s: getSnapshotBeforeUpdate() is defined as a static method and will be ignored. Instead, declare it as an instance method.", name);
          var _state = instance.state;
          _state && (typeof _state != "object" || isArray(_state)) && error("%s.state: must be set to an object or null", name), typeof instance.getChildContext == "function" && typeof ctor.childContextTypes != "object" && error("%s.getChildContext(): childContextTypes must be defined in order to use getChildContext().", name);
        }
      }
      function callComponentWillMount(type, instance) {
        var oldState = instance.state;
        if (typeof instance.componentWillMount == "function") {
          if (instance.componentWillMount.__suppressDeprecationWarning !== !0) {
            var componentName = getComponentNameFromType(type) || "Unknown";
            didWarnAboutDeprecatedWillMount[componentName] || (warn(
              // keep this warning in sync with ReactStrictModeWarning.js
              `componentWillMount has been renamed, and is not recommended for use. See https://reactjs.org/link/unsafe-component-lifecycles for details.

* Move code from componentWillMount to componentDidMount (preferred in most cases) or the constructor.

Please update the following components: %s`,
              componentName
            ), didWarnAboutDeprecatedWillMount[componentName] = !0);
          }
          instance.componentWillMount();
        }
        typeof instance.UNSAFE_componentWillMount == "function" && instance.UNSAFE_componentWillMount(), oldState !== instance.state && (error("%s.componentWillMount(): Assigning directly to this.state is deprecated (except inside a component's constructor). Use setState instead.", getComponentNameFromType(type) || "Component"), classComponentUpdater.enqueueReplaceState(instance, instance.state, null));
      }
      function processUpdateQueue(internalInstance, inst, props, maskedLegacyContext) {
        if (internalInstance.queue !== null && internalInstance.queue.length > 0) {
          var oldQueue = internalInstance.queue, oldReplace = internalInstance.replace;
          if (internalInstance.queue = null, internalInstance.replace = !1, oldReplace && oldQueue.length === 1)
            inst.state = oldQueue[0];
          else {
            for (var nextState = oldReplace ? oldQueue[0] : inst.state, dontMutate = !0, i = oldReplace ? 1 : 0; i < oldQueue.length; i++) {
              var partial = oldQueue[i], partialState = typeof partial == "function" ? partial.call(inst, nextState, props, maskedLegacyContext) : partial;
              partialState != null && (dontMutate ? (dontMutate = !1, nextState = assign({}, nextState, partialState)) : assign(nextState, partialState));
            }
            inst.state = nextState;
          }
        } else
          internalInstance.queue = null;
      }
      function mountClassInstance(instance, ctor, newProps, maskedLegacyContext) {
        checkClassInstance(instance, ctor, newProps);
        var initialState = instance.state !== void 0 ? instance.state : null;
        instance.updater = classComponentUpdater, instance.props = newProps, instance.state = initialState;
        var internalInstance = {
          queue: [],
          replace: !1
        };
        set2(instance, internalInstance);
        var contextType = ctor.contextType;
        if (typeof contextType == "object" && contextType !== null ? instance.context = readContext(contextType) : instance.context = maskedLegacyContext, instance.state === newProps) {
          var componentName = getComponentNameFromType(ctor) || "Component";
          didWarnAboutDirectlyAssigningPropsToState.has(componentName) || (didWarnAboutDirectlyAssigningPropsToState.add(componentName), error("%s: It is not recommended to assign props directly to state because updates to props won't be reflected in state. In most cases, it is better to use props directly.", componentName));
        }
        var getDerivedStateFromProps = ctor.getDerivedStateFromProps;
        typeof getDerivedStateFromProps == "function" && (instance.state = applyDerivedStateFromProps(instance, ctor, getDerivedStateFromProps, initialState, newProps)), typeof ctor.getDerivedStateFromProps != "function" && typeof instance.getSnapshotBeforeUpdate != "function" && (typeof instance.UNSAFE_componentWillMount == "function" || typeof instance.componentWillMount == "function") && (callComponentWillMount(ctor, instance), processUpdateQueue(internalInstance, instance, newProps, maskedLegacyContext));
      }
      var emptyTreeContext = {
        id: 1,
        overflow: ""
      };
      function getTreeId(context) {
        var overflow = context.overflow, idWithLeadingBit = context.id, id = idWithLeadingBit & ~getLeadingBit(idWithLeadingBit);
        return id.toString(32) + overflow;
      }
      function pushTreeContext(baseContext, totalChildren, index) {
        var baseIdWithLeadingBit = baseContext.id, baseOverflow = baseContext.overflow, baseLength = getBitLength(baseIdWithLeadingBit) - 1, baseId = baseIdWithLeadingBit & ~(1 << baseLength), slot = index + 1, length = getBitLength(totalChildren) + baseLength;
        if (length > 30) {
          var numberOfOverflowBits = baseLength - baseLength % 5, newOverflowBits = (1 << numberOfOverflowBits) - 1, newOverflow = (baseId & newOverflowBits).toString(32), restOfBaseId = baseId >> numberOfOverflowBits, restOfBaseLength = baseLength - numberOfOverflowBits, restOfLength = getBitLength(totalChildren) + restOfBaseLength, restOfNewBits = slot << restOfBaseLength, id = restOfNewBits | restOfBaseId, overflow = newOverflow + baseOverflow;
          return {
            id: 1 << restOfLength | id,
            overflow
          };
        } else {
          var newBits = slot << baseLength, _id = newBits | baseId, _overflow = baseOverflow;
          return {
            id: 1 << length | _id,
            overflow: _overflow
          };
        }
      }
      function getBitLength(number) {
        return 32 - clz32(number);
      }
      function getLeadingBit(id) {
        return 1 << getBitLength(id) - 1;
      }
      var clz32 = Math.clz32 ? Math.clz32 : clz32Fallback, log = Math.log, LN2 = Math.LN2;
      function clz32Fallback(x) {
        var asUint = x >>> 0;
        return asUint === 0 ? 32 : 31 - (log(asUint) / LN2 | 0) | 0;
      }
      function is(x, y) {
        return x === y && (x !== 0 || 1 / x === 1 / y) || x !== x && y !== y;
      }
      var objectIs = typeof Object.is == "function" ? Object.is : is, currentlyRenderingComponent = null, currentlyRenderingTask = null, firstWorkInProgressHook = null, workInProgressHook = null, isReRender = !1, didScheduleRenderPhaseUpdate = !1, localIdCounter = 0, renderPhaseUpdates = null, numberOfReRenders = 0, RE_RENDER_LIMIT = 25, isInHookUserCodeInDev = !1, currentHookNameInDev;
      function resolveCurrentlyRenderingComponent() {
        if (currentlyRenderingComponent === null)
          throw new Error(`Invalid hook call. Hooks can only be called inside of the body of a function component. This could happen for one of the following reasons:
1. You might have mismatching versions of React and the renderer (such as React DOM)
2. You might be breaking the Rules of Hooks
3. You might have more than one copy of React in the same app
See https://reactjs.org/link/invalid-hook-call for tips about how to debug and fix this problem.`);
        return isInHookUserCodeInDev && error("Do not call Hooks inside useEffect(...), useMemo(...), or other built-in Hooks. You can only call Hooks at the top level of your React function. For more information, see https://reactjs.org/link/rules-of-hooks"), currentlyRenderingComponent;
      }
      function areHookInputsEqual(nextDeps, prevDeps) {
        if (prevDeps === null)
          return error("%s received a final argument during this render, but not during the previous render. Even though the final argument is optional, its type cannot change between renders.", currentHookNameInDev), !1;
        nextDeps.length !== prevDeps.length && error(`The final argument passed to %s changed size between renders. The order and size of this array must remain constant.

Previous: %s
Incoming: %s`, currentHookNameInDev, "[" + nextDeps.join(", ") + "]", "[" + prevDeps.join(", ") + "]");
        for (var i = 0; i < prevDeps.length && i < nextDeps.length; i++)
          if (!objectIs(nextDeps[i], prevDeps[i]))
            return !1;
        return !0;
      }
      function createHook() {
        if (numberOfReRenders > 0)
          throw new Error("Rendered more hooks than during the previous render");
        return {
          memoizedState: null,
          queue: null,
          next: null
        };
      }
      function createWorkInProgressHook() {
        return workInProgressHook === null ? firstWorkInProgressHook === null ? (isReRender = !1, firstWorkInProgressHook = workInProgressHook = createHook()) : (isReRender = !0, workInProgressHook = firstWorkInProgressHook) : workInProgressHook.next === null ? (isReRender = !1, workInProgressHook = workInProgressHook.next = createHook()) : (isReRender = !0, workInProgressHook = workInProgressHook.next), workInProgressHook;
      }
      function prepareToUseHooks(task, componentIdentity) {
        currentlyRenderingComponent = componentIdentity, currentlyRenderingTask = task, isInHookUserCodeInDev = !1, localIdCounter = 0;
      }
      function finishHooks(Component, props, children, refOrContext) {
        for (; didScheduleRenderPhaseUpdate; )
          didScheduleRenderPhaseUpdate = !1, localIdCounter = 0, numberOfReRenders += 1, workInProgressHook = null, children = Component(props, refOrContext);
        return resetHooksState(), children;
      }
      function checkDidRenderIdHook() {
        var didRenderIdHook = localIdCounter !== 0;
        return didRenderIdHook;
      }
      function resetHooksState() {
        isInHookUserCodeInDev = !1, currentlyRenderingComponent = null, currentlyRenderingTask = null, didScheduleRenderPhaseUpdate = !1, firstWorkInProgressHook = null, numberOfReRenders = 0, renderPhaseUpdates = null, workInProgressHook = null;
      }
      function readContext$1(context) {
        return isInHookUserCodeInDev && error("Context can only be read while React is rendering. In classes, you can read it in the render method or getDerivedStateFromProps. In function components, you can read it directly in the function body, but not inside Hooks like useReducer() or useMemo()."), readContext(context);
      }
      function useContext(context) {
        return currentHookNameInDev = "useContext", resolveCurrentlyRenderingComponent(), readContext(context);
      }
      function basicStateReducer(state, action) {
        return typeof action == "function" ? action(state) : action;
      }
      function useState4(initialState) {
        return currentHookNameInDev = "useState", useReducer(
          basicStateReducer,
          // useReducer has a special case to support lazy useState initializers
          initialState
        );
      }
      function useReducer(reducer, initialArg, init4) {
        if (reducer !== basicStateReducer && (currentHookNameInDev = "useReducer"), currentlyRenderingComponent = resolveCurrentlyRenderingComponent(), workInProgressHook = createWorkInProgressHook(), isReRender) {
          var queue = workInProgressHook.queue, dispatch = queue.dispatch;
          if (renderPhaseUpdates !== null) {
            var firstRenderPhaseUpdate = renderPhaseUpdates.get(queue);
            if (firstRenderPhaseUpdate !== void 0) {
              renderPhaseUpdates.delete(queue);
              var newState = workInProgressHook.memoizedState, update2 = firstRenderPhaseUpdate;
              do {
                var action = update2.action;
                isInHookUserCodeInDev = !0, newState = reducer(newState, action), isInHookUserCodeInDev = !1, update2 = update2.next;
              } while (update2 !== null);
              return workInProgressHook.memoizedState = newState, [newState, dispatch];
            }
          }
          return [workInProgressHook.memoizedState, dispatch];
        } else {
          isInHookUserCodeInDev = !0;
          var initialState;
          reducer === basicStateReducer ? initialState = typeof initialArg == "function" ? initialArg() : initialArg : initialState = init4 !== void 0 ? init4(initialArg) : initialArg, isInHookUserCodeInDev = !1, workInProgressHook.memoizedState = initialState;
          var _queue = workInProgressHook.queue = {
            last: null,
            dispatch: null
          }, _dispatch = _queue.dispatch = dispatchAction.bind(null, currentlyRenderingComponent, _queue);
          return [workInProgressHook.memoizedState, _dispatch];
        }
      }
      function useMemo2(nextCreate, deps) {
        currentlyRenderingComponent = resolveCurrentlyRenderingComponent(), workInProgressHook = createWorkInProgressHook();
        var nextDeps = deps === void 0 ? null : deps;
        if (workInProgressHook !== null) {
          var prevState = workInProgressHook.memoizedState;
          if (prevState !== null && nextDeps !== null) {
            var prevDeps = prevState[1];
            if (areHookInputsEqual(nextDeps, prevDeps))
              return prevState[0];
          }
        }
        isInHookUserCodeInDev = !0;
        var nextValue = nextCreate();
        return isInHookUserCodeInDev = !1, workInProgressHook.memoizedState = [nextValue, nextDeps], nextValue;
      }
      function useRef2(initialValue) {
        currentlyRenderingComponent = resolveCurrentlyRenderingComponent(), workInProgressHook = createWorkInProgressHook();
        var previousRef = workInProgressHook.memoizedState;
        if (previousRef === null) {
          var ref = {
            current: initialValue
          };
          return Object.seal(ref), workInProgressHook.memoizedState = ref, ref;
        } else
          return previousRef;
      }
      function useLayoutEffect(create, inputs) {
        currentHookNameInDev = "useLayoutEffect", error("useLayoutEffect does nothing on the server, because its effect cannot be encoded into the server renderer's output format. This will lead to a mismatch between the initial, non-hydrated UI and the intended UI. To avoid this, useLayoutEffect should only be used in components that render exclusively on the client. See https://reactjs.org/link/uselayouteffect-ssr for common fixes.");
      }
      function dispatchAction(componentIdentity, queue, action) {
        if (numberOfReRenders >= RE_RENDER_LIMIT)
          throw new Error("Too many re-renders. React limits the number of renders to prevent an infinite loop.");
        if (componentIdentity === currentlyRenderingComponent) {
          didScheduleRenderPhaseUpdate = !0;
          var update2 = {
            action,
            next: null
          };
          renderPhaseUpdates === null && (renderPhaseUpdates = /* @__PURE__ */ new Map());
          var firstRenderPhaseUpdate = renderPhaseUpdates.get(queue);
          if (firstRenderPhaseUpdate === void 0)
            renderPhaseUpdates.set(queue, update2);
          else {
            for (var lastRenderPhaseUpdate = firstRenderPhaseUpdate; lastRenderPhaseUpdate.next !== null; )
              lastRenderPhaseUpdate = lastRenderPhaseUpdate.next;
            lastRenderPhaseUpdate.next = update2;
          }
        }
      }
      function useCallback(callback, deps) {
        return useMemo2(function() {
          return callback;
        }, deps);
      }
      function useMutableSource(source, getSnapshot, subscribe) {
        return resolveCurrentlyRenderingComponent(), getSnapshot(source._source);
      }
      function useSyncExternalStore(subscribe, getSnapshot, getServerSnapshot) {
        if (getServerSnapshot === void 0)
          throw new Error("Missing getServerSnapshot, which is required for server-rendered content. Will revert to client rendering.");
        return getServerSnapshot();
      }
      function useDeferredValue(value) {
        return resolveCurrentlyRenderingComponent(), value;
      }
      function unsupportedStartTransition() {
        throw new Error("startTransition cannot be called during server rendering.");
      }
      function useTransition() {
        return resolveCurrentlyRenderingComponent(), [!1, unsupportedStartTransition];
      }
      function useId() {
        var task = currentlyRenderingTask, treeId = getTreeId(task.treeContext), responseState = currentResponseState;
        if (responseState === null)
          throw new Error("Invalid hook call. Hooks can only be called inside of the body of a function component.");
        var localId = localIdCounter++;
        return makeId(responseState, treeId, localId);
      }
      function noop() {
      }
      var Dispatcher = {
        readContext: readContext$1,
        useContext,
        useMemo: useMemo2,
        useReducer,
        useRef: useRef2,
        useState: useState4,
        useInsertionEffect: noop,
        useLayoutEffect,
        useCallback,
        // useImperativeHandle is not run in the server environment
        useImperativeHandle: noop,
        // Effects are not run in the server environment.
        useEffect: noop,
        // Debugging effect
        useDebugValue: noop,
        useDeferredValue,
        useTransition,
        useId,
        // Subscriptions are not setup in a server environment.
        useMutableSource,
        useSyncExternalStore
      }, currentResponseState = null;
      function setCurrentResponseState(responseState) {
        currentResponseState = responseState;
      }
      function getStackByComponentStackNode(componentStack) {
        try {
          var info2 = "", node = componentStack;
          do {
            switch (node.tag) {
              case 0:
                info2 += describeBuiltInComponentFrame(node.type, null, null);
                break;
              case 1:
                info2 += describeFunctionComponentFrame(node.type, null, null);
                break;
              case 2:
                info2 += describeClassComponentFrame(node.type, null, null);
                break;
            }
            node = node.parent;
          } while (node);
          return info2;
        } catch (x) {
          return `
Error generating stack: ` + x.message + `
` + x.stack;
        }
      }
      var ReactCurrentDispatcher$1 = ReactSharedInternals.ReactCurrentDispatcher, ReactDebugCurrentFrame$1 = ReactSharedInternals.ReactDebugCurrentFrame, PENDING = 0, COMPLETED = 1, FLUSHED = 2, ABORTED = 3, ERRORED = 4, OPEN = 0, CLOSING = 1, CLOSED = 2, DEFAULT_PROGRESSIVE_CHUNK_SIZE = 12800;
      function defaultErrorHandler(error2) {
        return console.error(error2), null;
      }
      function noop$1() {
      }
      function createRequest(children, responseState, rootFormatContext, progressiveChunkSize, onError, onAllReady, onShellReady, onShellError, onFatalError) {
        var pingedTasks = [], abortSet = /* @__PURE__ */ new Set(), request2 = {
          destination: null,
          responseState,
          progressiveChunkSize: progressiveChunkSize === void 0 ? DEFAULT_PROGRESSIVE_CHUNK_SIZE : progressiveChunkSize,
          status: OPEN,
          fatalError: null,
          nextSegmentId: 0,
          allPendingTasks: 0,
          pendingRootTasks: 0,
          completedRootSegment: null,
          abortableTasks: abortSet,
          pingedTasks,
          clientRenderedBoundaries: [],
          completedBoundaries: [],
          partialBoundaries: [],
          onError: onError === void 0 ? defaultErrorHandler : onError,
          onAllReady: onAllReady === void 0 ? noop$1 : onAllReady,
          onShellReady: onShellReady === void 0 ? noop$1 : onShellReady,
          onShellError: onShellError === void 0 ? noop$1 : onShellError,
          onFatalError: onFatalError === void 0 ? noop$1 : onFatalError
        }, rootSegment = createPendingSegment(
          request2,
          0,
          null,
          rootFormatContext,
          // Root segments are never embedded in Text on either edge
          !1,
          !1
        );
        rootSegment.parentFlushed = !0;
        var rootTask = createTask(request2, children, null, rootSegment, abortSet, emptyContextObject, rootContextSnapshot, emptyTreeContext);
        return pingedTasks.push(rootTask), request2;
      }
      function pingTask(request2, task) {
        var pingedTasks = request2.pingedTasks;
        pingedTasks.push(task), pingedTasks.length === 1 && scheduleWork(function() {
          return performWork(request2);
        });
      }
      function createSuspenseBoundary(request2, fallbackAbortableTasks) {
        return {
          id: UNINITIALIZED_SUSPENSE_BOUNDARY_ID,
          rootSegmentID: -1,
          parentFlushed: !1,
          pendingTasks: 0,
          forceClientRender: !1,
          completedSegments: [],
          byteSize: 0,
          fallbackAbortableTasks,
          errorDigest: null
        };
      }
      function createTask(request2, node, blockedBoundary, blockedSegment, abortSet, legacyContext, context, treeContext) {
        request2.allPendingTasks++, blockedBoundary === null ? request2.pendingRootTasks++ : blockedBoundary.pendingTasks++;
        var task = {
          node,
          ping: function() {
            return pingTask(request2, task);
          },
          blockedBoundary,
          blockedSegment,
          abortSet,
          legacyContext,
          context,
          treeContext
        };
        return task.componentStack = null, abortSet.add(task), task;
      }
      function createPendingSegment(request2, index, boundary, formatContext, lastPushedText, textEmbedded) {
        return {
          status: PENDING,
          id: -1,
          // lazily assigned later
          index,
          parentFlushed: !1,
          chunks: [],
          children: [],
          formatContext,
          boundary,
          lastPushedText,
          textEmbedded
        };
      }
      var currentTaskInDEV = null;
      function getCurrentStackInDEV() {
        return currentTaskInDEV === null || currentTaskInDEV.componentStack === null ? "" : getStackByComponentStackNode(currentTaskInDEV.componentStack);
      }
      function pushBuiltInComponentStackInDEV(task, type) {
        task.componentStack = {
          tag: 0,
          parent: task.componentStack,
          type
        };
      }
      function pushFunctionComponentStackInDEV(task, type) {
        task.componentStack = {
          tag: 1,
          parent: task.componentStack,
          type
        };
      }
      function pushClassComponentStackInDEV(task, type) {
        task.componentStack = {
          tag: 2,
          parent: task.componentStack,
          type
        };
      }
      function popComponentStackInDEV(task) {
        task.componentStack === null ? error("Unexpectedly popped too many stack frames. This is a bug in React.") : task.componentStack = task.componentStack.parent;
      }
      var lastBoundaryErrorComponentStackDev = null;
      function captureBoundaryErrorDetailsDev(boundary, error2) {
        {
          var errorMessage2;
          typeof error2 == "string" ? errorMessage2 = error2 : error2 && typeof error2.message == "string" ? errorMessage2 = error2.message : errorMessage2 = String(error2);
          var errorComponentStack = lastBoundaryErrorComponentStackDev || getCurrentStackInDEV();
          lastBoundaryErrorComponentStackDev = null, boundary.errorMessage = errorMessage2, boundary.errorComponentStack = errorComponentStack;
        }
      }
      function logRecoverableError(request2, error2) {
        var errorDigest = request2.onError(error2);
        if (errorDigest != null && typeof errorDigest != "string")
          throw new Error('onError returned something with a type other than "string". onError should return a string and may return null or undefined but must not return anything else. It received something of type "' + typeof errorDigest + '" instead');
        return errorDigest;
      }
      function fatalError(request2, error2) {
        var onShellError = request2.onShellError;
        onShellError(error2);
        var onFatalError = request2.onFatalError;
        onFatalError(error2), request2.destination !== null ? (request2.status = CLOSED, closeWithError(request2.destination, error2)) : (request2.status = CLOSING, request2.fatalError = error2);
      }
      function renderSuspenseBoundary(request2, task, props) {
        pushBuiltInComponentStackInDEV(task, "Suspense");
        var parentBoundary = task.blockedBoundary, parentSegment = task.blockedSegment, fallback = props.fallback, content = props.children, fallbackAbortSet = /* @__PURE__ */ new Set(), newBoundary = createSuspenseBoundary(request2, fallbackAbortSet), insertionIndex = parentSegment.chunks.length, boundarySegment = createPendingSegment(
          request2,
          insertionIndex,
          newBoundary,
          parentSegment.formatContext,
          // boundaries never require text embedding at their edges because comment nodes bound them
          !1,
          !1
        );
        parentSegment.children.push(boundarySegment), parentSegment.lastPushedText = !1;
        var contentRootSegment = createPendingSegment(
          request2,
          0,
          null,
          parentSegment.formatContext,
          // boundaries never require text embedding at their edges because comment nodes bound them
          !1,
          !1
        );
        contentRootSegment.parentFlushed = !0, task.blockedBoundary = newBoundary, task.blockedSegment = contentRootSegment;
        try {
          if (renderNode(request2, task, content), pushSegmentFinale(contentRootSegment.chunks, request2.responseState, contentRootSegment.lastPushedText, contentRootSegment.textEmbedded), contentRootSegment.status = COMPLETED, queueCompletedSegment(newBoundary, contentRootSegment), newBoundary.pendingTasks === 0) {
            popComponentStackInDEV(task);
            return;
          }
        } catch (error2) {
          contentRootSegment.status = ERRORED, newBoundary.forceClientRender = !0, newBoundary.errorDigest = logRecoverableError(request2, error2), captureBoundaryErrorDetailsDev(newBoundary, error2);
        } finally {
          task.blockedBoundary = parentBoundary, task.blockedSegment = parentSegment;
        }
        var suspendedFallbackTask = createTask(request2, fallback, parentBoundary, boundarySegment, fallbackAbortSet, task.legacyContext, task.context, task.treeContext);
        suspendedFallbackTask.componentStack = task.componentStack, request2.pingedTasks.push(suspendedFallbackTask), popComponentStackInDEV(task);
      }
      function renderHostElement(request2, task, type, props) {
        pushBuiltInComponentStackInDEV(task, type);
        var segment = task.blockedSegment, children = pushStartInstance(segment.chunks, type, props, request2.responseState, segment.formatContext);
        segment.lastPushedText = !1;
        var prevContext = segment.formatContext;
        segment.formatContext = getChildFormatContext(prevContext, type, props), renderNode(request2, task, children), segment.formatContext = prevContext, pushEndInstance(segment.chunks, type), segment.lastPushedText = !1, popComponentStackInDEV(task);
      }
      function shouldConstruct$1(Component) {
        return Component.prototype && Component.prototype.isReactComponent;
      }
      function renderWithHooks(request2, task, Component, props, secondArg) {
        var componentIdentity = {};
        prepareToUseHooks(task, componentIdentity);
        var result = Component(props, secondArg);
        return finishHooks(Component, props, result, secondArg);
      }
      function finishClassComponent(request2, task, instance, Component, props) {
        var nextChildren = instance.render();
        instance.props !== props && (didWarnAboutReassigningProps || error("It looks like %s is reassigning its own `this.props` while rendering. This is not supported and can lead to confusing bugs.", getComponentNameFromType(Component) || "a component"), didWarnAboutReassigningProps = !0);
        {
          var childContextTypes = Component.childContextTypes;
          if (childContextTypes != null) {
            var previousContext = task.legacyContext, mergedContext = processChildContext(instance, Component, previousContext, childContextTypes);
            task.legacyContext = mergedContext, renderNodeDestructive(request2, task, nextChildren), task.legacyContext = previousContext;
            return;
          }
        }
        renderNodeDestructive(request2, task, nextChildren);
      }
      function renderClassComponent(request2, task, Component, props) {
        pushClassComponentStackInDEV(task, Component);
        var maskedContext = getMaskedContext(Component, task.legacyContext), instance = constructClassInstance(Component, props, maskedContext);
        mountClassInstance(instance, Component, props, maskedContext), finishClassComponent(request2, task, instance, Component, props), popComponentStackInDEV(task);
      }
      var didWarnAboutBadClass = {}, didWarnAboutModulePatternComponent = {}, didWarnAboutContextTypeOnFunctionComponent = {}, didWarnAboutGetDerivedStateOnFunctionComponent = {}, didWarnAboutReassigningProps = !1, didWarnAboutGenerators = !1, didWarnAboutMaps = !1, hasWarnedAboutUsingContextAsConsumer = !1;
      function renderIndeterminateComponent(request2, task, Component, props) {
        var legacyContext;
        if (legacyContext = getMaskedContext(Component, task.legacyContext), pushFunctionComponentStackInDEV(task, Component), Component.prototype && typeof Component.prototype.render == "function") {
          var componentName = getComponentNameFromType(Component) || "Unknown";
          didWarnAboutBadClass[componentName] || (error("The <%s /> component appears to have a render method, but doesn't extend React.Component. This is likely to cause errors. Change %s to extend React.Component instead.", componentName, componentName), didWarnAboutBadClass[componentName] = !0);
        }
        var value = renderWithHooks(request2, task, Component, props, legacyContext), hasId = checkDidRenderIdHook();
        if (typeof value == "object" && value !== null && typeof value.render == "function" && value.$$typeof === void 0) {
          var _componentName = getComponentNameFromType(Component) || "Unknown";
          didWarnAboutModulePatternComponent[_componentName] || (error("The <%s /> component appears to be a function component that returns a class instance. Change %s to a class that extends React.Component instead. If you can't use a class try assigning the prototype on the function as a workaround. `%s.prototype = React.Component.prototype`. Don't use an arrow function since it cannot be called with `new` by React.", _componentName, _componentName, _componentName), didWarnAboutModulePatternComponent[_componentName] = !0);
        }
        if (
          // Run these checks in production only if the flag is off.
          // Eventually we'll delete this branch altogether.
          typeof value == "object" && value !== null && typeof value.render == "function" && value.$$typeof === void 0
        ) {
          {
            var _componentName2 = getComponentNameFromType(Component) || "Unknown";
            didWarnAboutModulePatternComponent[_componentName2] || (error("The <%s /> component appears to be a function component that returns a class instance. Change %s to a class that extends React.Component instead. If you can't use a class try assigning the prototype on the function as a workaround. `%s.prototype = React.Component.prototype`. Don't use an arrow function since it cannot be called with `new` by React.", _componentName2, _componentName2, _componentName2), didWarnAboutModulePatternComponent[_componentName2] = !0);
          }
          mountClassInstance(value, Component, props, legacyContext), finishClassComponent(request2, task, value, Component, props);
        } else if (validateFunctionComponentInDev(Component), hasId) {
          var prevTreeContext = task.treeContext, totalChildren = 1, index = 0;
          task.treeContext = pushTreeContext(prevTreeContext, totalChildren, index);
          try {
            renderNodeDestructive(request2, task, value);
          } finally {
            task.treeContext = prevTreeContext;
          }
        } else
          renderNodeDestructive(request2, task, value);
        popComponentStackInDEV(task);
      }
      function validateFunctionComponentInDev(Component) {
        {
          if (Component && Component.childContextTypes && error("%s(...): childContextTypes cannot be defined on a function component.", Component.displayName || Component.name || "Component"), typeof Component.getDerivedStateFromProps == "function") {
            var _componentName3 = getComponentNameFromType(Component) || "Unknown";
            didWarnAboutGetDerivedStateOnFunctionComponent[_componentName3] || (error("%s: Function components do not support getDerivedStateFromProps.", _componentName3), didWarnAboutGetDerivedStateOnFunctionComponent[_componentName3] = !0);
          }
          if (typeof Component.contextType == "object" && Component.contextType !== null) {
            var _componentName4 = getComponentNameFromType(Component) || "Unknown";
            didWarnAboutContextTypeOnFunctionComponent[_componentName4] || (error("%s: Function components do not support contextType.", _componentName4), didWarnAboutContextTypeOnFunctionComponent[_componentName4] = !0);
          }
        }
      }
      function resolveDefaultProps(Component, baseProps) {
        if (Component && Component.defaultProps) {
          var props = assign({}, baseProps), defaultProps = Component.defaultProps;
          for (var propName in defaultProps)
            props[propName] === void 0 && (props[propName] = defaultProps[propName]);
          return props;
        }
        return baseProps;
      }
      function renderForwardRef(request2, task, type, props, ref) {
        pushFunctionComponentStackInDEV(task, type.render);
        var children = renderWithHooks(request2, task, type.render, props, ref), hasId = checkDidRenderIdHook();
        if (hasId) {
          var prevTreeContext = task.treeContext, totalChildren = 1, index = 0;
          task.treeContext = pushTreeContext(prevTreeContext, totalChildren, index);
          try {
            renderNodeDestructive(request2, task, children);
          } finally {
            task.treeContext = prevTreeContext;
          }
        } else
          renderNodeDestructive(request2, task, children);
        popComponentStackInDEV(task);
      }
      function renderMemo(request2, task, type, props, ref) {
        var innerType = type.type, resolvedProps = resolveDefaultProps(innerType, props);
        renderElement(request2, task, innerType, resolvedProps, ref);
      }
      function renderContextConsumer(request2, task, context, props) {
        context._context === void 0 ? context !== context.Consumer && (hasWarnedAboutUsingContextAsConsumer || (hasWarnedAboutUsingContextAsConsumer = !0, error("Rendering <Context> directly is not supported and will be removed in a future major release. Did you mean to render <Context.Consumer> instead?"))) : context = context._context;
        var render3 = props.children;
        typeof render3 != "function" && error("A context consumer was rendered with multiple children, or a child that isn't a function. A context consumer expects a single child that is a function. If you did pass a function, make sure there is no trailing or leading whitespace around it.");
        var newValue = readContext(context), newChildren = render3(newValue);
        renderNodeDestructive(request2, task, newChildren);
      }
      function renderContextProvider(request2, task, type, props) {
        var context = type._context, value = props.value, children = props.children, prevSnapshot;
        prevSnapshot = task.context, task.context = pushProvider(context, value), renderNodeDestructive(request2, task, children), task.context = popProvider(context), prevSnapshot !== task.context && error("Popping the context provider did not return back to the original snapshot. This is a bug in React.");
      }
      function renderLazyComponent(request2, task, lazyComponent, props, ref) {
        pushBuiltInComponentStackInDEV(task, "Lazy");
        var payload = lazyComponent._payload, init4 = lazyComponent._init, Component = init4(payload), resolvedProps = resolveDefaultProps(Component, props);
        renderElement(request2, task, Component, resolvedProps, ref), popComponentStackInDEV(task);
      }
      function renderElement(request2, task, type, props, ref) {
        if (typeof type == "function")
          if (shouldConstruct$1(type)) {
            renderClassComponent(request2, task, type, props);
            return;
          } else {
            renderIndeterminateComponent(request2, task, type, props);
            return;
          }
        if (typeof type == "string") {
          renderHostElement(request2, task, type, props);
          return;
        }
        switch (type) {
          case REACT_LEGACY_HIDDEN_TYPE:
          case REACT_DEBUG_TRACING_MODE_TYPE:
          case REACT_STRICT_MODE_TYPE:
          case REACT_PROFILER_TYPE:
          case REACT_FRAGMENT_TYPE: {
            renderNodeDestructive(request2, task, props.children);
            return;
          }
          case REACT_SUSPENSE_LIST_TYPE: {
            pushBuiltInComponentStackInDEV(task, "SuspenseList"), renderNodeDestructive(request2, task, props.children), popComponentStackInDEV(task);
            return;
          }
          case REACT_SCOPE_TYPE:
            throw new Error("ReactDOMServer does not yet support scope components.");
          case REACT_SUSPENSE_TYPE: {
            renderSuspenseBoundary(request2, task, props);
            return;
          }
        }
        if (typeof type == "object" && type !== null)
          switch (type.$$typeof) {
            case REACT_FORWARD_REF_TYPE: {
              renderForwardRef(request2, task, type, props, ref);
              return;
            }
            case REACT_MEMO_TYPE: {
              renderMemo(request2, task, type, props, ref);
              return;
            }
            case REACT_PROVIDER_TYPE: {
              renderContextProvider(request2, task, type, props);
              return;
            }
            case REACT_CONTEXT_TYPE: {
              renderContextConsumer(request2, task, type, props);
              return;
            }
            case REACT_LAZY_TYPE: {
              renderLazyComponent(request2, task, type, props);
              return;
            }
          }
        var info2 = "";
        throw (type === void 0 || typeof type == "object" && type !== null && Object.keys(type).length === 0) && (info2 += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports."), new Error("Element type is invalid: expected a string (for built-in components) or a class/function (for composite components) " + ("but got: " + (type == null ? type : typeof type) + "." + info2));
      }
      function validateIterable(iterable, iteratorFn) {
        typeof Symbol == "function" && // $FlowFixMe Flow doesn't know about toStringTag
        iterable[Symbol.toStringTag] === "Generator" && (didWarnAboutGenerators || error("Using Generators as children is unsupported and will likely yield unexpected results because enumerating a generator mutates it. You may convert it to an array with `Array.from()` or the `[...spread]` operator before rendering. Keep in mind you might need to polyfill these features for older browsers."), didWarnAboutGenerators = !0), iterable.entries === iteratorFn && (didWarnAboutMaps || error("Using Maps as children is not supported. Use an array of keyed ReactElements instead."), didWarnAboutMaps = !0);
      }
      function renderNodeDestructive(request2, task, node) {
        try {
          return renderNodeDestructiveImpl(request2, task, node);
        } catch (x) {
          throw typeof x == "object" && x !== null && typeof x.then == "function" || (lastBoundaryErrorComponentStackDev = lastBoundaryErrorComponentStackDev !== null ? lastBoundaryErrorComponentStackDev : getCurrentStackInDEV()), x;
        }
      }
      function renderNodeDestructiveImpl(request2, task, node) {
        if (task.node = node, typeof node == "object" && node !== null) {
          switch (node.$$typeof) {
            case REACT_ELEMENT_TYPE: {
              var element = node, type = element.type, props = element.props, ref = element.ref;
              renderElement(request2, task, type, props, ref);
              return;
            }
            case REACT_PORTAL_TYPE:
              throw new Error("Portals are not currently supported by the server renderer. Render them conditionally so that they only appear on the client render.");
            case REACT_LAZY_TYPE: {
              var lazyNode = node, payload = lazyNode._payload, init4 = lazyNode._init, resolvedNode;
              try {
                resolvedNode = init4(payload);
              } catch (x) {
                throw typeof x == "object" && x !== null && typeof x.then == "function" && pushBuiltInComponentStackInDEV(task, "Lazy"), x;
              }
              renderNodeDestructive(request2, task, resolvedNode);
              return;
            }
          }
          if (isArray(node)) {
            renderChildrenArray(request2, task, node);
            return;
          }
          var iteratorFn = getIteratorFn(node);
          if (iteratorFn) {
            validateIterable(node, iteratorFn);
            var iterator = iteratorFn.call(node);
            if (iterator) {
              var step = iterator.next();
              if (!step.done) {
                var children = [];
                do
                  children.push(step.value), step = iterator.next();
                while (!step.done);
                renderChildrenArray(request2, task, children);
                return;
              }
              return;
            }
          }
          var childString = Object.prototype.toString.call(node);
          throw new Error("Objects are not valid as a React child (found: " + (childString === "[object Object]" ? "object with keys {" + Object.keys(node).join(", ") + "}" : childString) + "). If you meant to render a collection of children, use an array instead.");
        }
        if (typeof node == "string") {
          var segment = task.blockedSegment;
          segment.lastPushedText = pushTextInstance(task.blockedSegment.chunks, node, request2.responseState, segment.lastPushedText);
          return;
        }
        if (typeof node == "number") {
          var _segment = task.blockedSegment;
          _segment.lastPushedText = pushTextInstance(task.blockedSegment.chunks, "" + node, request2.responseState, _segment.lastPushedText);
          return;
        }
        typeof node == "function" && error("Functions are not valid as a React child. This may happen if you return a Component instead of <Component /> from render. Or maybe you meant to call this function rather than return it.");
      }
      function renderChildrenArray(request2, task, children) {
        for (var totalChildren = children.length, i = 0; i < totalChildren; i++) {
          var prevTreeContext = task.treeContext;
          task.treeContext = pushTreeContext(prevTreeContext, totalChildren, i);
          try {
            renderNode(request2, task, children[i]);
          } finally {
            task.treeContext = prevTreeContext;
          }
        }
      }
      function spawnNewSuspendedTask(request2, task, x) {
        var segment = task.blockedSegment, insertionIndex = segment.chunks.length, newSegment = createPendingSegment(
          request2,
          insertionIndex,
          null,
          segment.formatContext,
          // Adopt the parent segment's leading text embed
          segment.lastPushedText,
          // Assume we are text embedded at the trailing edge
          !0
        );
        segment.children.push(newSegment), segment.lastPushedText = !1;
        var newTask = createTask(request2, task.node, task.blockedBoundary, newSegment, task.abortSet, task.legacyContext, task.context, task.treeContext);
        task.componentStack !== null && (newTask.componentStack = task.componentStack.parent);
        var ping = newTask.ping;
        x.then(ping, ping);
      }
      function renderNode(request2, task, node) {
        var previousFormatContext = task.blockedSegment.formatContext, previousLegacyContext = task.legacyContext, previousContext = task.context, previousComponentStack = null;
        previousComponentStack = task.componentStack;
        try {
          return renderNodeDestructive(request2, task, node);
        } catch (x) {
          if (resetHooksState(), typeof x == "object" && x !== null && typeof x.then == "function") {
            spawnNewSuspendedTask(request2, task, x), task.blockedSegment.formatContext = previousFormatContext, task.legacyContext = previousLegacyContext, task.context = previousContext, switchContext(previousContext), task.componentStack = previousComponentStack;
            return;
          } else
            throw task.blockedSegment.formatContext = previousFormatContext, task.legacyContext = previousLegacyContext, task.context = previousContext, switchContext(previousContext), task.componentStack = previousComponentStack, x;
        }
      }
      function erroredTask(request2, boundary, segment, error2) {
        var errorDigest = logRecoverableError(request2, error2);
        if (boundary === null ? fatalError(request2, error2) : (boundary.pendingTasks--, boundary.forceClientRender || (boundary.forceClientRender = !0, boundary.errorDigest = errorDigest, captureBoundaryErrorDetailsDev(boundary, error2), boundary.parentFlushed && request2.clientRenderedBoundaries.push(boundary))), request2.allPendingTasks--, request2.allPendingTasks === 0) {
          var onAllReady = request2.onAllReady;
          onAllReady();
        }
      }
      function abortTaskSoft(task) {
        var request2 = this, boundary = task.blockedBoundary, segment = task.blockedSegment;
        segment.status = ABORTED, finishedTask(request2, boundary, segment);
      }
      function abortTask(task, request2, reason) {
        var boundary = task.blockedBoundary, segment = task.blockedSegment;
        if (segment.status = ABORTED, boundary === null)
          request2.allPendingTasks--, request2.status !== CLOSED && (request2.status = CLOSED, request2.destination !== null && close(request2.destination));
        else {
          if (boundary.pendingTasks--, !boundary.forceClientRender) {
            boundary.forceClientRender = !0;
            var _error = reason === void 0 ? new Error("The render was aborted by the server without a reason.") : reason;
            boundary.errorDigest = request2.onError(_error);
            {
              var errorPrefix = "The server did not finish this Suspense boundary: ";
              _error && typeof _error.message == "string" ? _error = errorPrefix + _error.message : _error = errorPrefix + String(_error);
              var previousTaskInDev = currentTaskInDEV;
              currentTaskInDEV = task;
              try {
                captureBoundaryErrorDetailsDev(boundary, _error);
              } finally {
                currentTaskInDEV = previousTaskInDev;
              }
            }
            boundary.parentFlushed && request2.clientRenderedBoundaries.push(boundary);
          }
          if (boundary.fallbackAbortableTasks.forEach(function(fallbackTask) {
            return abortTask(fallbackTask, request2, reason);
          }), boundary.fallbackAbortableTasks.clear(), request2.allPendingTasks--, request2.allPendingTasks === 0) {
            var onAllReady = request2.onAllReady;
            onAllReady();
          }
        }
      }
      function queueCompletedSegment(boundary, segment) {
        if (segment.chunks.length === 0 && segment.children.length === 1 && segment.children[0].boundary === null) {
          var childSegment = segment.children[0];
          childSegment.id = segment.id, childSegment.parentFlushed = !0, childSegment.status === COMPLETED && queueCompletedSegment(boundary, childSegment);
        } else {
          var completedSegments = boundary.completedSegments;
          completedSegments.push(segment);
        }
      }
      function finishedTask(request2, boundary, segment) {
        if (boundary === null) {
          if (segment.parentFlushed) {
            if (request2.completedRootSegment !== null)
              throw new Error("There can only be one root segment. This is a bug in React.");
            request2.completedRootSegment = segment;
          }
          if (request2.pendingRootTasks--, request2.pendingRootTasks === 0) {
            request2.onShellError = noop$1;
            var onShellReady = request2.onShellReady;
            onShellReady();
          }
        } else if (boundary.pendingTasks--, !boundary.forceClientRender) {
          if (boundary.pendingTasks === 0)
            segment.parentFlushed && segment.status === COMPLETED && queueCompletedSegment(boundary, segment), boundary.parentFlushed && request2.completedBoundaries.push(boundary), boundary.fallbackAbortableTasks.forEach(abortTaskSoft, request2), boundary.fallbackAbortableTasks.clear();
          else if (segment.parentFlushed && segment.status === COMPLETED) {
            queueCompletedSegment(boundary, segment);
            var completedSegments = boundary.completedSegments;
            completedSegments.length === 1 && boundary.parentFlushed && request2.partialBoundaries.push(boundary);
          }
        }
        if (request2.allPendingTasks--, request2.allPendingTasks === 0) {
          var onAllReady = request2.onAllReady;
          onAllReady();
        }
      }
      function retryTask(request2, task) {
        var segment = task.blockedSegment;
        if (segment.status === PENDING) {
          switchContext(task.context);
          var prevTaskInDEV = null;
          prevTaskInDEV = currentTaskInDEV, currentTaskInDEV = task;
          try {
            renderNodeDestructive(request2, task, task.node), pushSegmentFinale(segment.chunks, request2.responseState, segment.lastPushedText, segment.textEmbedded), task.abortSet.delete(task), segment.status = COMPLETED, finishedTask(request2, task.blockedBoundary, segment);
          } catch (x) {
            if (resetHooksState(), typeof x == "object" && x !== null && typeof x.then == "function") {
              var ping = task.ping;
              x.then(ping, ping);
            } else
              task.abortSet.delete(task), segment.status = ERRORED, erroredTask(request2, task.blockedBoundary, segment, x);
          } finally {
            currentTaskInDEV = prevTaskInDEV;
          }
        }
      }
      function performWork(request2) {
        if (request2.status !== CLOSED) {
          var prevContext = getActiveContext(), prevDispatcher = ReactCurrentDispatcher$1.current;
          ReactCurrentDispatcher$1.current = Dispatcher;
          var prevGetCurrentStackImpl;
          prevGetCurrentStackImpl = ReactDebugCurrentFrame$1.getCurrentStack, ReactDebugCurrentFrame$1.getCurrentStack = getCurrentStackInDEV;
          var prevResponseState = currentResponseState;
          setCurrentResponseState(request2.responseState);
          try {
            var pingedTasks = request2.pingedTasks, i;
            for (i = 0; i < pingedTasks.length; i++) {
              var task = pingedTasks[i];
              retryTask(request2, task);
            }
            pingedTasks.splice(0, i), request2.destination !== null && flushCompletedQueues(request2, request2.destination);
          } catch (error2) {
            logRecoverableError(request2, error2), fatalError(request2, error2);
          } finally {
            setCurrentResponseState(prevResponseState), ReactCurrentDispatcher$1.current = prevDispatcher, ReactDebugCurrentFrame$1.getCurrentStack = prevGetCurrentStackImpl, prevDispatcher === Dispatcher && switchContext(prevContext);
          }
        }
      }
      function flushSubtree(request2, destination, segment) {
        switch (segment.parentFlushed = !0, segment.status) {
          case PENDING: {
            var segmentID = segment.id = request2.nextSegmentId++;
            return segment.lastPushedText = !1, segment.textEmbedded = !1, writePlaceholder(destination, request2.responseState, segmentID);
          }
          case COMPLETED: {
            segment.status = FLUSHED;
            for (var r2 = !0, chunks = segment.chunks, chunkIdx = 0, children = segment.children, childIdx = 0; childIdx < children.length; childIdx++) {
              for (var nextChild = children[childIdx]; chunkIdx < nextChild.index; chunkIdx++)
                writeChunk(destination, chunks[chunkIdx]);
              r2 = flushSegment(request2, destination, nextChild);
            }
            for (; chunkIdx < chunks.length - 1; chunkIdx++)
              writeChunk(destination, chunks[chunkIdx]);
            return chunkIdx < chunks.length && (r2 = writeChunkAndReturn(destination, chunks[chunkIdx])), r2;
          }
          default:
            throw new Error("Aborted, errored or already flushed boundaries should not be flushed again. This is a bug in React.");
        }
      }
      function flushSegment(request2, destination, segment) {
        var boundary = segment.boundary;
        if (boundary === null)
          return flushSubtree(request2, destination, segment);
        if (boundary.parentFlushed = !0, boundary.forceClientRender)
          return writeStartClientRenderedSuspenseBoundary(destination, request2.responseState, boundary.errorDigest, boundary.errorMessage, boundary.errorComponentStack), flushSubtree(request2, destination, segment), writeEndClientRenderedSuspenseBoundary(destination, request2.responseState);
        if (boundary.pendingTasks > 0) {
          boundary.rootSegmentID = request2.nextSegmentId++, boundary.completedSegments.length > 0 && request2.partialBoundaries.push(boundary);
          var id = boundary.id = assignSuspenseBoundaryID(request2.responseState);
          return writeStartPendingSuspenseBoundary(destination, request2.responseState, id), flushSubtree(request2, destination, segment), writeEndPendingSuspenseBoundary(destination, request2.responseState);
        } else {
          if (boundary.byteSize > request2.progressiveChunkSize)
            return boundary.rootSegmentID = request2.nextSegmentId++, request2.completedBoundaries.push(boundary), writeStartPendingSuspenseBoundary(destination, request2.responseState, boundary.id), flushSubtree(request2, destination, segment), writeEndPendingSuspenseBoundary(destination, request2.responseState);
          writeStartCompletedSuspenseBoundary(destination, request2.responseState);
          var completedSegments = boundary.completedSegments;
          if (completedSegments.length !== 1)
            throw new Error("A previously unvisited boundary must have exactly one root segment. This is a bug in React.");
          var contentSegment = completedSegments[0];
          return flushSegment(request2, destination, contentSegment), writeEndCompletedSuspenseBoundary(destination, request2.responseState);
        }
      }
      function flushClientRenderedBoundary(request2, destination, boundary) {
        return writeClientRenderBoundaryInstruction(destination, request2.responseState, boundary.id, boundary.errorDigest, boundary.errorMessage, boundary.errorComponentStack);
      }
      function flushSegmentContainer(request2, destination, segment) {
        return writeStartSegment(destination, request2.responseState, segment.formatContext, segment.id), flushSegment(request2, destination, segment), writeEndSegment(destination, segment.formatContext);
      }
      function flushCompletedBoundary(request2, destination, boundary) {
        for (var completedSegments = boundary.completedSegments, i = 0; i < completedSegments.length; i++) {
          var segment = completedSegments[i];
          flushPartiallyCompletedSegment(request2, destination, boundary, segment);
        }
        return completedSegments.length = 0, writeCompletedBoundaryInstruction(destination, request2.responseState, boundary.id, boundary.rootSegmentID);
      }
      function flushPartialBoundary(request2, destination, boundary) {
        for (var completedSegments = boundary.completedSegments, i = 0; i < completedSegments.length; i++) {
          var segment = completedSegments[i];
          if (!flushPartiallyCompletedSegment(request2, destination, boundary, segment))
            return i++, completedSegments.splice(0, i), !1;
        }
        return completedSegments.splice(0, i), !0;
      }
      function flushPartiallyCompletedSegment(request2, destination, boundary, segment) {
        if (segment.status === FLUSHED)
          return !0;
        var segmentID = segment.id;
        if (segmentID === -1) {
          var rootSegmentID = segment.id = boundary.rootSegmentID;
          if (rootSegmentID === -1)
            throw new Error("A root segment ID must have been assigned by now. This is a bug in React.");
          return flushSegmentContainer(request2, destination, segment);
        } else
          return flushSegmentContainer(request2, destination, segment), writeCompletedSegmentInstruction(destination, request2.responseState, segmentID);
      }
      function flushCompletedQueues(request2, destination) {
        beginWriting();
        try {
          var completedRootSegment = request2.completedRootSegment;
          completedRootSegment !== null && request2.pendingRootTasks === 0 && (flushSegment(request2, destination, completedRootSegment), request2.completedRootSegment = null, writeCompletedRoot(destination, request2.responseState));
          var clientRenderedBoundaries = request2.clientRenderedBoundaries, i;
          for (i = 0; i < clientRenderedBoundaries.length; i++) {
            var boundary = clientRenderedBoundaries[i];
            if (!flushClientRenderedBoundary(request2, destination, boundary)) {
              request2.destination = null, i++, clientRenderedBoundaries.splice(0, i);
              return;
            }
          }
          clientRenderedBoundaries.splice(0, i);
          var completedBoundaries = request2.completedBoundaries;
          for (i = 0; i < completedBoundaries.length; i++) {
            var _boundary = completedBoundaries[i];
            if (!flushCompletedBoundary(request2, destination, _boundary)) {
              request2.destination = null, i++, completedBoundaries.splice(0, i);
              return;
            }
          }
          completedBoundaries.splice(0, i), completeWriting(destination), beginWriting(destination);
          var partialBoundaries = request2.partialBoundaries;
          for (i = 0; i < partialBoundaries.length; i++) {
            var _boundary2 = partialBoundaries[i];
            if (!flushPartialBoundary(request2, destination, _boundary2)) {
              request2.destination = null, i++, partialBoundaries.splice(0, i);
              return;
            }
          }
          partialBoundaries.splice(0, i);
          var largeBoundaries = request2.completedBoundaries;
          for (i = 0; i < largeBoundaries.length; i++) {
            var _boundary3 = largeBoundaries[i];
            if (!flushCompletedBoundary(request2, destination, _boundary3)) {
              request2.destination = null, i++, largeBoundaries.splice(0, i);
              return;
            }
          }
          largeBoundaries.splice(0, i);
        } finally {
          completeWriting(destination), flushBuffered(destination), request2.allPendingTasks === 0 && request2.pingedTasks.length === 0 && request2.clientRenderedBoundaries.length === 0 && request2.completedBoundaries.length === 0 && (request2.abortableTasks.size !== 0 && error("There was still abortable task at the root when we closed. This is a bug in React."), close(destination));
        }
      }
      function startWork(request2) {
        scheduleWork(function() {
          return performWork(request2);
        });
      }
      function startFlowing(request2, destination) {
        if (request2.status === CLOSING) {
          request2.status = CLOSED, closeWithError(destination, request2.fatalError);
          return;
        }
        if (request2.status !== CLOSED && request2.destination === null) {
          request2.destination = destination;
          try {
            flushCompletedQueues(request2, destination);
          } catch (error2) {
            logRecoverableError(request2, error2), fatalError(request2, error2);
          }
        }
      }
      function abort2(request2, reason) {
        try {
          var abortableTasks = request2.abortableTasks;
          abortableTasks.forEach(function(task) {
            return abortTask(task, request2, reason);
          }), abortableTasks.clear(), request2.destination !== null && flushCompletedQueues(request2, request2.destination);
        } catch (error2) {
          logRecoverableError(request2, error2), fatalError(request2, error2);
        }
      }
      function createDrainHandler(destination, request2) {
        return function() {
          return startFlowing(request2, destination);
        };
      }
      function createAbortHandler2(request2, reason) {
        return function() {
          return abort2(request2, reason);
        };
      }
      function createRequestImpl(children, options) {
        return createRequest(children, createResponseState(options ? options.identifierPrefix : void 0, options ? options.nonce : void 0, options ? options.bootstrapScriptContent : void 0, options ? options.bootstrapScripts : void 0, options ? options.bootstrapModules : void 0), createRootFormatContext(options ? options.namespaceURI : void 0), options ? options.progressiveChunkSize : void 0, options ? options.onError : void 0, options ? options.onAllReady : void 0, options ? options.onShellReady : void 0, options ? options.onShellError : void 0, void 0);
      }
      function renderToPipeableStream(children, options) {
        var request2 = createRequestImpl(children, options), hasStartedFlowing = !1;
        return startWork(request2), {
          pipe: function(destination) {
            if (hasStartedFlowing)
              throw new Error("React currently only supports piping to one writable stream.");
            return hasStartedFlowing = !0, startFlowing(request2, destination), destination.on("drain", createDrainHandler(destination, request2)), destination.on("error", createAbortHandler2(
              request2,
              // eslint-disable-next-line react-internal/prod-error-codes
              new Error("The destination stream errored while writing data.")
            )), destination.on("close", createAbortHandler2(
              request2,
              // eslint-disable-next-line react-internal/prod-error-codes
              new Error("The destination stream closed early.")
            )), destination;
          },
          abort: function(reason) {
            abort2(request2, reason);
          }
        };
      }
      exports.renderToPipeableStream = renderToPipeableStream, exports.version = ReactVersion;
    }();
  }
});

// ../../node_modules/.pnpm/react-dom@18.2.0_react@18.2.0/node_modules/react-dom/server.node.js
var require_server_node = __commonJS({
  "../../node_modules/.pnpm/react-dom@18.2.0_react@18.2.0/node_modules/react-dom/server.node.js"(exports) {
    "use strict";
    init_cjs_shims();
    var l, s;
    process.env.NODE_ENV === "production" ? (l = require_react_dom_server_legacy_node_production_min(), s = require_react_dom_server_node_production_min()) : (l = require_react_dom_server_legacy_node_development(), s = require_react_dom_server_node_development());
    exports.version = l.version;
    exports.renderToString = l.renderToString;
    exports.renderToStaticMarkup = l.renderToStaticMarkup;
    exports.renderToNodeStream = l.renderToNodeStream;
    exports.renderToStaticNodeStream = l.renderToStaticNodeStream;
    exports.renderToPipeableStream = s.renderToPipeableStream;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/configure.js
var require_configure = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/configure.js"(exports) {
    "use strict";
    init_cjs_shims();
    var DEFAULT_LOCALE = "en", SUPPORTED_LOCALES = ["cs", "da", "de", "en", "es", "fi", "fr", "it", "ja", "ko", "nb", "nl", "pl", "pt-BR", "pt-PT", "sv", "th", "tr", "vi", "zh-CN", "zh-TW"];
    exports.DEFAULT_LOCALE = DEFAULT_LOCALE;
    exports.SUPPORTED_LOCALES = SUPPORTED_LOCALES;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/types.js
var require_types7 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/types.js"(exports) {
    "use strict";
    init_cjs_shims();
    exports.Key = void 0;
    (function(Key) {
      Key[Key.Backspace = 8] = "Backspace", Key[Key.Tab = 9] = "Tab", Key[Key.Enter = 13] = "Enter", Key[Key.Shift = 16] = "Shift", Key[Key.Ctrl = 17] = "Ctrl", Key[Key.Alt = 18] = "Alt", Key[Key.Pause = 19] = "Pause", Key[Key.CapsLock = 20] = "CapsLock", Key[Key.Escape = 27] = "Escape", Key[Key.Space = 32] = "Space", Key[Key.PageUp = 33] = "PageUp", Key[Key.PageDown = 34] = "PageDown", Key[Key.End = 35] = "End", Key[Key.Home = 36] = "Home", Key[Key.LeftArrow = 37] = "LeftArrow", Key[Key.UpArrow = 38] = "UpArrow", Key[Key.RightArrow = 39] = "RightArrow", Key[Key.DownArrow = 40] = "DownArrow", Key[Key.Insert = 45] = "Insert", Key[Key.Delete = 46] = "Delete", Key[Key.Key0 = 48] = "Key0", Key[Key.Key1 = 49] = "Key1", Key[Key.Key2 = 50] = "Key2", Key[Key.Key3 = 51] = "Key3", Key[Key.Key4 = 52] = "Key4", Key[Key.Key5 = 53] = "Key5", Key[Key.Key6 = 54] = "Key6", Key[Key.Key7 = 55] = "Key7", Key[Key.Key8 = 56] = "Key8", Key[Key.Key9 = 57] = "Key9", Key[Key.KeyA = 65] = "KeyA", Key[Key.KeyB = 66] = "KeyB", Key[Key.KeyC = 67] = "KeyC", Key[Key.KeyD = 68] = "KeyD", Key[Key.KeyE = 69] = "KeyE", Key[Key.KeyF = 70] = "KeyF", Key[Key.KeyG = 71] = "KeyG", Key[Key.KeyH = 72] = "KeyH", Key[Key.KeyI = 73] = "KeyI", Key[Key.KeyJ = 74] = "KeyJ", Key[Key.KeyK = 75] = "KeyK", Key[Key.KeyL = 76] = "KeyL", Key[Key.KeyM = 77] = "KeyM", Key[Key.KeyN = 78] = "KeyN", Key[Key.KeyO = 79] = "KeyO", Key[Key.KeyP = 80] = "KeyP", Key[Key.KeyQ = 81] = "KeyQ", Key[Key.KeyR = 82] = "KeyR", Key[Key.KeyS = 83] = "KeyS", Key[Key.KeyT = 84] = "KeyT", Key[Key.KeyU = 85] = "KeyU", Key[Key.KeyV = 86] = "KeyV", Key[Key.KeyW = 87] = "KeyW", Key[Key.KeyX = 88] = "KeyX", Key[Key.KeyY = 89] = "KeyY", Key[Key.KeyZ = 90] = "KeyZ", Key[Key.LeftMeta = 91] = "LeftMeta", Key[Key.RightMeta = 92] = "RightMeta", Key[Key.Select = 93] = "Select", Key[Key.Numpad0 = 96] = "Numpad0", Key[Key.Numpad1 = 97] = "Numpad1", Key[Key.Numpad2 = 98] = "Numpad2", Key[Key.Numpad3 = 99] = "Numpad3", Key[Key.Numpad4 = 100] = "Numpad4", Key[Key.Numpad5 = 101] = "Numpad5", Key[Key.Numpad6 = 102] = "Numpad6", Key[Key.Numpad7 = 103] = "Numpad7", Key[Key.Numpad8 = 104] = "Numpad8", Key[Key.Numpad9 = 105] = "Numpad9", Key[Key.Multiply = 106] = "Multiply", Key[Key.Add = 107] = "Add", Key[Key.Subtract = 109] = "Subtract", Key[Key.Decimal = 110] = "Decimal", Key[Key.Divide = 111] = "Divide", Key[Key.F1 = 112] = "F1", Key[Key.F2 = 113] = "F2", Key[Key.F3 = 114] = "F3", Key[Key.F4 = 115] = "F4", Key[Key.F5 = 116] = "F5", Key[Key.F6 = 117] = "F6", Key[Key.F7 = 118] = "F7", Key[Key.F8 = 119] = "F8", Key[Key.F9 = 120] = "F9", Key[Key.F10 = 121] = "F10", Key[Key.F11 = 122] = "F11", Key[Key.F12 = 123] = "F12", Key[Key.NumLock = 144] = "NumLock", Key[Key.ScrollLock = 145] = "ScrollLock", Key[Key.Semicolon = 186] = "Semicolon", Key[Key.Equals = 187] = "Equals", Key[Key.Comma = 188] = "Comma", Key[Key.Dash = 189] = "Dash", Key[Key.Period = 190] = "Period", Key[Key.ForwardSlash = 191] = "ForwardSlash", Key[Key.GraveAccent = 192] = "GraveAccent", Key[Key.OpenBracket = 219] = "OpenBracket", Key[Key.BackSlash = 220] = "BackSlash", Key[Key.CloseBracket = 221] = "CloseBracket", Key[Key.SingleQuote = 222] = "SingleQuote";
    })(exports.Key || (exports.Key = {}));
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/shared.js
var require_shared = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/shared.js"(exports) {
    "use strict";
    init_cjs_shims();
    var scrollable = {
      props: {
        "data-polaris-scrollable": !0
      },
      selector: "[data-polaris-scrollable]"
    }, overlay = {
      props: {
        "data-polaris-overlay": !0
      },
      selector: "[data-polaris-overlay]"
    }, layer = {
      props: {
        "data-polaris-layer": !0
      },
      selector: "[data-polaris-layer]"
    }, unstyled2 = {
      props: {
        "data-polaris-unstyled": !0
      },
      selector: "[data-polaris-unstyled]"
    }, dataPolarisTopBar = {
      props: {
        "data-polaris-top-bar": !0
      },
      selector: "[data-polaris-top-bar]"
    }, headerCell = {
      props: {
        "data-polaris-header-cell": !0
      },
      selector: "[data-polaris-header-cell]"
    }, portal = {
      props: ["data-portal-id"],
      selector: "[data-portal-id]"
    }, DATA_ATTRIBUTE = {
      overlay,
      layer
    };
    exports.DATA_ATTRIBUTE = DATA_ATTRIBUTE;
    exports.dataPolarisTopBar = dataPolarisTopBar;
    exports.headerCell = headerCell;
    exports.layer = layer;
    exports.overlay = overlay;
    exports.portal = portal;
    exports.scrollable = scrollable;
    exports.unstyled = unstyled2;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/clamp.js
var require_clamp = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/clamp.js"(exports) {
    "use strict";
    init_cjs_shims();
    function clamp(number, min, max) {
      return number < min ? min : number > max ? max : number;
    }
    exports.clamp = clamp;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/roundNumberToDecimalPlaces.js
var require_roundNumberToDecimalPlaces = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/roundNumberToDecimalPlaces.js"(exports) {
    "use strict";
    init_cjs_shims();
    function roundNumberToDecimalPlaces(value, decimals) {
      let exponent = +`${value}e${decimals}`;
      return +`${Math.round(exponent)}e-${decimals}`;
    }
    exports.roundNumberToDecimalPlaces = roundNumberToDecimalPlaces;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/color-transformers.js
var require_color_transformers = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/color-transformers.js"(exports) {
    "use strict";
    init_cjs_shims();
    var clamp = require_clamp(), roundNumberToDecimalPlaces = require_roundNumberToDecimalPlaces();
    function rgbString(color) {
      let {
        red,
        green,
        blue
      } = color;
      return "alpha" in color ? `rgba(${red}, ${green}, ${blue}, ${color.alpha})` : `rgb(${red}, ${green}, ${blue})`;
    }
    var rgbaString = rgbString;
    function rgbToHex({
      red,
      green,
      blue
    }) {
      return `#${componentToHex(red)}${componentToHex(green)}${componentToHex(blue)}`;
    }
    function componentToHex(component) {
      let hex = component.toString(16);
      return hex.length === 1 ? `0${hex}` : hex;
    }
    function hsbToHex(color) {
      return rgbToHex(hsbToRgb(color));
    }
    function rgbFromHueAndChroma(hue, chroma) {
      let huePrime = hue / 60, hueDelta = 1 - Math.abs(huePrime % 2 - 1), intermediateValue = chroma * hueDelta, red = 0, green = 0, blue = 0;
      return huePrime >= 0 && huePrime <= 1 && (red = chroma, green = intermediateValue, blue = 0), huePrime >= 1 && huePrime <= 2 && (red = intermediateValue, green = chroma, blue = 0), huePrime >= 2 && huePrime <= 3 && (red = 0, green = chroma, blue = intermediateValue), huePrime >= 3 && huePrime <= 4 && (red = 0, green = intermediateValue, blue = chroma), huePrime >= 4 && huePrime <= 5 && (red = intermediateValue, green = 0, blue = chroma), huePrime >= 5 && huePrime <= 6 && (red = chroma, green = 0, blue = intermediateValue), {
        red,
        green,
        blue
      };
    }
    function hsbToRgb(color) {
      let {
        hue,
        saturation,
        brightness,
        alpha = 1
      } = color, chroma = brightness * saturation, {
        red,
        green,
        blue
      } = rgbFromHueAndChroma(hue, chroma), chromaBrightnessDelta = brightness - chroma;
      return red += chromaBrightnessDelta, green += chromaBrightnessDelta, blue += chromaBrightnessDelta, {
        red: Math.round(red * 255),
        green: Math.round(green * 255),
        blue: Math.round(blue * 255),
        alpha
      };
    }
    function hslToRgb(color) {
      let {
        hue,
        saturation,
        lightness,
        alpha = 1
      } = color, chroma = (1 - Math.abs(2 * (lightness / 100) - 1)) * (saturation / 100), {
        red,
        green,
        blue
      } = rgbFromHueAndChroma(hue, chroma), lightnessVal = lightness / 100 - chroma / 2;
      return red += lightnessVal, green += lightnessVal, blue += lightnessVal, {
        red: Math.round(red * 255),
        green: Math.round(green * 255),
        blue: Math.round(blue * 255),
        alpha
      };
    }
    function rgbToHsbl(color, type = "b") {
      let {
        alpha = 1
      } = color, red = color.red / 255, green = color.green / 255, blue = color.blue / 255, largestComponent = Math.max(red, green, blue), smallestComponent = Math.min(red, green, blue), delta = largestComponent - smallestComponent, lightness = (largestComponent + smallestComponent) / 2, saturation = 0;
      if (largestComponent === 0)
        saturation = 0;
      else if (type === "b")
        saturation = delta / largestComponent;
      else if (type === "l") {
        let baseSaturation = lightness > 0.5 ? delta / (2 - largestComponent - smallestComponent) : delta / (largestComponent + smallestComponent);
        saturation = isNaN(baseSaturation) ? 0 : baseSaturation;
      }
      let huePercentage = 0;
      switch (largestComponent) {
        case red:
          huePercentage = (green - blue) / delta + (green < blue ? 6 : 0);
          break;
        case green:
          huePercentage = (blue - red) / delta + 2;
          break;
        case blue:
          huePercentage = (red - green) / delta + 4;
      }
      let hue = huePercentage / 6 * 360, clampedHue = clamp.clamp(hue, 0, 360);
      return {
        hue: clampedHue ? roundNumberToDecimalPlaces.roundNumberToDecimalPlaces(clampedHue, 2) : 0,
        saturation: roundNumberToDecimalPlaces.roundNumberToDecimalPlaces(clamp.clamp(saturation, 0, 1), 4),
        brightness: roundNumberToDecimalPlaces.roundNumberToDecimalPlaces(clamp.clamp(largestComponent, 0, 1), 4),
        lightness: roundNumberToDecimalPlaces.roundNumberToDecimalPlaces(lightness, 4),
        alpha: roundNumberToDecimalPlaces.roundNumberToDecimalPlaces(alpha, 4)
      };
    }
    function rgbToHsb(color) {
      let {
        hue,
        saturation,
        brightness,
        alpha = 1
      } = rgbToHsbl(color, "b");
      return {
        hue,
        saturation,
        brightness,
        alpha
      };
    }
    function rgbToHsl(color) {
      let {
        hue,
        saturation: rawSaturation,
        lightness: rawLightness,
        alpha = 1
      } = rgbToHsbl(color, "l"), saturation = roundNumberToDecimalPlaces.roundNumberToDecimalPlaces(rawSaturation * 100, 2), lightness = roundNumberToDecimalPlaces.roundNumberToDecimalPlaces(rawLightness * 100, 2);
      return {
        hue,
        saturation,
        lightness,
        alpha
      };
    }
    function hexToRgb(color) {
      if (color.length === 4) {
        let repeatHex = (hex1, hex2) => color.slice(hex1, hex2).repeat(2), red2 = parseInt(repeatHex(1, 2), 16), green2 = parseInt(repeatHex(2, 3), 16), blue2 = parseInt(repeatHex(3, 4), 16);
        return {
          red: red2,
          green: green2,
          blue: blue2
        };
      }
      let red = parseInt(color.slice(1, 3), 16), green = parseInt(color.slice(3, 5), 16), blue = parseInt(color.slice(5, 7), 16);
      return {
        red,
        green,
        blue
      };
    }
    exports.hexToRgb = hexToRgb;
    exports.hsbToHex = hsbToHex;
    exports.hsbToRgb = hsbToRgb;
    exports.hslToRgb = hslToRgb;
    exports.rgbString = rgbString;
    exports.rgbToHex = rgbToHex;
    exports.rgbToHsb = rgbToHsb;
    exports.rgbToHsl = rgbToHsl;
    exports.rgbaString = rgbaString;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/within-content-context.js
var require_within_content_context = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/within-content-context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), WithinContentContext = /* @__PURE__ */ React12.createContext(!1);
    exports.WithinContentContext = WithinContentContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/target.js
var require_target = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/target.js"(exports) {
    "use strict";
    init_cjs_shims();
    var isServer = typeof window > "u" || typeof document > "u";
    exports.isServer = isServer;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-isomorphic-layout-effect.js
var require_use_isomorphic_layout_effect = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-isomorphic-layout-effect.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), target = require_target(), useIsomorphicLayoutEffect = target.isServer ? React12.useEffect : React12.useLayoutEffect;
    exports.useIsomorphicLayoutEffect = useIsomorphicLayoutEffect;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-event-listener.js
var require_use_event_listener = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-event-listener.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), useIsomorphicLayoutEffect = require_use_isomorphic_layout_effect();
    function useEventListener(eventName, handler, target, options) {
      let handlerRef = React12.useRef(handler), optionsRef = React12.useRef(options);
      useIsomorphicLayoutEffect.useIsomorphicLayoutEffect(() => {
        handlerRef.current = handler;
      }, [handler]), useIsomorphicLayoutEffect.useIsomorphicLayoutEffect(() => {
        optionsRef.current = options;
      }, [options]), React12.useEffect(() => {
        if (!(typeof eventName == "string" && target !== null))
          return;
        let targetElement;
        if (typeof target > "u")
          targetElement = window;
        else if ("current" in target) {
          if (target.current === null)
            return;
          targetElement = target.current;
        } else
          targetElement = target;
        let eventOptions = optionsRef.current, eventListener = (event) => handlerRef.current(event);
        return targetElement.addEventListener(eventName, eventListener, eventOptions), () => {
          targetElement.removeEventListener(eventName, eventListener, eventOptions);
        };
      }, [eventName, target]);
    }
    exports.useEventListener = useEventListener;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/breakpoints.js
var require_breakpoints = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/breakpoints.js"(exports) {
    "use strict";
    init_cjs_shims();
    var breakpointsAliases = ["xs", "sm", "md", "lg", "xl"], breakpoints = {
      "breakpoints-xs": {
        value: "0px",
        description: "Commonly used for sizing containers (e.g. max-width). See below for media query usage."
      },
      "breakpoints-sm": {
        value: "490px",
        description: "Commonly used for sizing containers (e.g. max-width). See below for media query usage."
      },
      "breakpoints-md": {
        value: "768px",
        description: "Commonly used for sizing containers (e.g. max-width). See below for media query usage."
      },
      "breakpoints-lg": {
        value: "1040px",
        description: "Commonly used for sizing containers (e.g. max-width). See below for media query usage."
      },
      "breakpoints-xl": {
        value: "1440px",
        description: "Commonly used for sizing containers (e.g. max-width). See below for media query usage."
      }
    };
    exports.breakpoints = breakpoints;
    exports.breakpointsAliases = breakpointsAliases;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/_virtual/_rollupPluginBabelHelpers.js
var require_rollupPluginBabelHelpers = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/_virtual/_rollupPluginBabelHelpers.js"(exports) {
    "use strict";
    init_cjs_shims();
    function _iterableToArrayLimit(arr, i) {
      var _i = arr == null ? null : typeof Symbol < "u" && arr[Symbol.iterator] || arr["@@iterator"];
      if (_i != null) {
        var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1;
        try {
          if (_x = (_i = _i.call(arr)).next, i === 0) {
            if (Object(_i) !== _i)
              return;
            _n = !1;
          } else
            for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0)
              ;
        } catch (err2) {
          _d = !0, _e = err2;
        } finally {
          try {
            if (!_n && _i.return != null && (_r = _i.return(), Object(_r) !== _r))
              return;
          } finally {
            if (_d)
              throw _e;
          }
        }
        return _arr;
      }
    }
    function _taggedTemplateLiteralLoose(strings, raw) {
      return raw || (raw = strings.slice(0)), strings.raw = raw, strings;
    }
    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
    }
    function _arrayWithHoles(arr) {
      if (Array.isArray(arr))
        return arr;
    }
    function _unsupportedIterableToArray(o, minLen) {
      if (o) {
        if (typeof o == "string")
          return _arrayLikeToArray(o, minLen);
        var n = Object.prototype.toString.call(o).slice(8, -1);
        if (n === "Object" && o.constructor && (n = o.constructor.name), n === "Map" || n === "Set")
          return Array.from(o);
        if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
          return _arrayLikeToArray(o, minLen);
      }
    }
    function _arrayLikeToArray(arr, len) {
      (len == null || len > arr.length) && (len = arr.length);
      for (var i = 0, arr2 = new Array(len); i < len; i++)
        arr2[i] = arr[i];
      return arr2;
    }
    function _nonIterableRest() {
      throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
    }
    exports.arrayLikeToArray = _arrayLikeToArray;
    exports.arrayWithHoles = _arrayWithHoles;
    exports.iterableToArrayLimit = _iterableToArrayLimit;
    exports.nonIterableRest = _nonIterableRest;
    exports.slicedToArray = _slicedToArray;
    exports.taggedTemplateLiteralLoose = _taggedTemplateLiteralLoose;
    exports.unsupportedIterableToArray = _unsupportedIterableToArray;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/utils.js
var require_utils8 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/utils.js"(exports) {
    "use strict";
    init_cjs_shims();
    var _rollupPluginBabelHelpers = require_rollupPluginBabelHelpers(), _templateObject, BASE_FONT_SIZE = 16, UNIT_PX = "px", UNIT_EM = "em", UNIT_REM = "rem", DIGIT_REGEX = new RegExp(String.raw(_templateObject || (_templateObject = _rollupPluginBabelHelpers.taggedTemplateLiteralLoose(["-?d+(?:.d+|d*)"], ["-?\\d+(?:\\.\\d+|\\d*)"])))), UNIT_REGEX = new RegExp(UNIT_PX + "|" + UNIT_EM + "|" + UNIT_REM);
    function getUnit(value) {
      value === void 0 && (value = "");
      var unit = value.match(new RegExp(DIGIT_REGEX.source + "(" + UNIT_REGEX.source + ")"));
      return unit && unit[1];
    }
    function toPx(value) {
      value === void 0 && (value = "");
      var unit = getUnit(value);
      if (!unit || unit === UNIT_PX)
        return value;
      if (unit === UNIT_EM || unit === UNIT_REM)
        return "" + parseFloat(value) * BASE_FONT_SIZE + UNIT_PX;
    }
    function toPxs(value) {
      return value.replace(new RegExp(DIGIT_REGEX.source + "(" + UNIT_EM + "|" + UNIT_REM + ")", "g"), function(emOrRem) {
        var _toPx;
        return (_toPx = toPx(emOrRem)) != null ? _toPx : emOrRem;
      });
    }
    function toEm(value, fontSize) {
      value === void 0 && (value = ""), fontSize === void 0 && (fontSize = BASE_FONT_SIZE);
      var unit = getUnit(value);
      if (!unit || unit === UNIT_EM)
        return value;
      if (unit === UNIT_PX)
        return "" + parseFloat(value) / fontSize + UNIT_EM;
      if (unit === UNIT_REM)
        return "" + parseFloat(value) * BASE_FONT_SIZE / fontSize + UNIT_EM;
    }
    function toRem(value) {
      value === void 0 && (value = "");
      var unit = getUnit(value);
      if (!unit || unit === UNIT_REM)
        return value;
      if (unit === UNIT_EM)
        return "" + parseFloat(value) + UNIT_REM;
      if (unit === UNIT_PX)
        return "" + parseFloat(value) / BASE_FONT_SIZE + UNIT_REM;
    }
    function rem(value) {
      return value.replace(new RegExp(DIGIT_REGEX.source + "(" + UNIT_PX + ")", "g"), function(px) {
        var _toRem;
        return (_toRem = toRem(px)) != null ? _toRem : px;
      });
    }
    function tokenGroupToRems(metaTokenGroup) {
      return Object.fromEntries(
        Object.entries(metaTokenGroup).map(function(_ref) {
          var _ref2 = _rollupPluginBabelHelpers.slicedToArray(_ref, 2), tokenName = _ref2[0], tokenProperties = _ref2[1];
          return [tokenName, Object.assign(Object.assign({}, tokenProperties), {}, {
            value: rem(tokenProperties.value)
          })];
        })
        // We loose the `metaTokenGroup` inference after transforming the object with
        // `Object.fromEntries()` and `Object.entries()`. Thus, we cast the result
        // back to `T` since we are simply converting the `value` from px to rem.
      );
    }
    function createVarName(tokenName) {
      return "--p-" + tokenName;
    }
    function createVar(tokenName) {
      return "var(" + createVarName(tokenName) + ")";
    }
    function getTokenNames(theme) {
      return Object.values(theme).flatMap(function(tokenGroup) {
        return Object.keys(tokenGroup);
      });
    }
    function getThemeVarNames(theme) {
      return getTokenNames(theme).map(createVarName);
    }
    function getMediaConditions(breakpoints) {
      var breakpointEntries = Object.entries(breakpoints), lastBreakpointIndex = breakpointEntries.length - 1;
      return Object.fromEntries(breakpointEntries.map(function(entry, index) {
        var _ref3 = entry, _ref4 = _rollupPluginBabelHelpers.slicedToArray(_ref3, 2), breakpointsTokenName = _ref4[0], breakpoint = _ref4[1], upMediaCondition = getUpMediaCondition(breakpoint), downMediaCondition = getDownMediaCondition(breakpoint), onlyMediaCondition = index === lastBreakpointIndex ? upMediaCondition : upMediaCondition + " and " + getDownMediaCondition(breakpointEntries[index + 1][1]);
        return [breakpointsTokenName, {
          // Media condition for the current breakpoint and up
          up: upMediaCondition,
          // Media condition for current breakpoint and down
          down: downMediaCondition,
          // Media condition for only the current breakpoint
          only: onlyMediaCondition
        }];
      }));
    }
    function getUpMediaCondition(breakpoint) {
      return "(min-width: " + toEm(breakpoint) + ")";
    }
    function getDownMediaCondition(breakpoint) {
      var _toPx2, offsetBreakpoint = parseFloat((_toPx2 = toPx(breakpoint)) != null ? _toPx2 : "") - 0.04;
      return "(max-width: " + toEm(offsetBreakpoint + "px") + ")";
    }
    var tokenGroupNamesToRems = ["border", "breakpoints", "font", "height", "shadow", "space", "text", "width"];
    function createMetaThemeBase(metaTheme) {
      return Object.fromEntries(Object.entries(metaTheme).map(function(_ref5) {
        var _ref6 = _rollupPluginBabelHelpers.slicedToArray(_ref5, 2), tokenGroupName = _ref6[0], tokenGroup = _ref6[1];
        return [tokenGroupName, tokenGroupNamesToRems.includes(tokenGroupName) ? tokenGroupToRems(tokenGroup) : tokenGroup];
      }));
    }
    exports.createMetaThemeBase = createMetaThemeBase;
    exports.createVar = createVar;
    exports.createVarName = createVarName;
    exports.getMediaConditions = getMediaConditions;
    exports.getThemeVarNames = getThemeVarNames;
    exports.getTokenNames = getTokenNames;
    exports.getUnit = getUnit;
    exports.rem = rem;
    exports.toEm = toEm;
    exports.toPx = toPx;
    exports.toPxs = toPxs;
    exports.toRem = toRem;
    exports.tokenGroupNamesToRems = tokenGroupNamesToRems;
    exports.tokenGroupToRems = tokenGroupToRems;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/size.js
var require_size = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/size.js"(exports) {
    "use strict";
    init_cjs_shims();
    var size = {
      0: "0px",
      "0165": "0.66px",
      "025": "1px",
      "050": "2px",
      100: "4px",
      150: "6px",
      200: "8px",
      275: "11px",
      300: "12px",
      325: "13px",
      350: "14px",
      400: "16px",
      450: "18px",
      500: "20px",
      550: "22px",
      600: "24px",
      700: "28px",
      750: "30px",
      800: "32px",
      900: "36px",
      1e3: "40px",
      1200: "48px",
      1600: "64px",
      2e3: "80px",
      2400: "96px",
      2800: "112px",
      3200: "128px"
    };
    exports.size = size;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/border.js
var require_border = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/border.js"(exports) {
    "use strict";
    init_cjs_shims();
    var size = require_size(), border = {
      "border-radius-0": {
        value: size.size[0]
      },
      "border-radius-050": {
        value: size.size["050"]
      },
      "border-radius-100": {
        value: size.size[100]
      },
      "border-radius-150": {
        value: size.size[150]
      },
      "border-radius-200": {
        value: size.size[200]
      },
      "border-radius-300": {
        value: size.size[300]
      },
      "border-radius-400": {
        value: size.size[400]
      },
      "border-radius-500": {
        value: size.size[500]
      },
      "border-radius-750": {
        value: size.size[750]
      },
      "border-radius-full": {
        value: "9999px"
      },
      "border-width-0": {
        value: size.size[0]
      },
      "border-width-0165": {
        value: size.size["0165"]
      },
      "border-width-025": {
        value: size.size["025"]
      },
      "border-width-050": {
        value: size.size["050"]
      },
      "border-width-100": {
        value: size.size[100]
      }
    };
    exports.border = border;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/colors.js
var require_colors = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/colors.js"(exports) {
    "use strict";
    init_cjs_shims();
    var gray = {
      1: "rgba(255, 255, 255, 1)",
      2: "rgba(253, 253, 253, 1)",
      3: "rgba(250, 250, 250, 1)",
      4: "rgba(247, 247, 247, 1)",
      5: "rgba(243, 243, 243, 1)",
      6: "rgba(241, 241, 241, 1)",
      7: "rgba(235, 235, 235, 1)",
      8: "rgba(227, 227, 227, 1)",
      9: "rgba(212, 212, 212, 1)",
      10: "rgba(204, 204, 204, 1)",
      11: "rgba(181, 181, 181, 1)",
      12: "rgba(138, 138, 138, 1)",
      13: "rgba(97, 97, 97, 1)",
      14: "rgba(74, 74, 74, 1)",
      15: "rgba(48, 48, 48, 1)",
      16: "rgba(26, 26, 26, 1)"
    }, azure = {
      1: "rgba(251, 253, 255, 1)",
      2: "rgba(242, 249, 255, 1)",
      3: "rgba(234, 244, 255, 1)",
      4: "rgba(224, 240, 255, 1)",
      5: "rgba(213, 235, 255, 1)",
      6: "rgba(202, 230, 255, 1)",
      7: "rgba(192, 225, 255, 1)",
      8: "rgba(168, 216, 255, 1)",
      9: "rgba(145, 208, 255, 1)",
      10: "rgba(81, 192, 255, 1)",
      11: "rgba(0, 148, 213, 1)",
      12: "rgba(0, 124, 180, 1)",
      13: "rgba(0, 103, 155, 1)",
      14: "rgba(0, 82, 124, 1)",
      15: "rgba(0, 58, 90, 1)",
      16: "rgba(0, 33, 51, 1)"
    }, blue = {
      1: "rgba(252, 253, 255, 1)",
      2: "rgba(246, 248, 255, 1)",
      3: "rgba(240, 242, 255, 1)",
      4: "rgba(234, 237, 255, 1)",
      5: "rgba(226, 231, 255, 1)",
      6: "rgba(219, 225, 255, 1)",
      7: "rgba(213, 220, 255, 1)",
      8: "rgba(197, 208, 255, 1)",
      9: "rgba(186, 199, 255, 1)",
      10: "rgba(151, 173, 255, 1)",
      11: "rgba(65, 136, 255, 1)",
      12: "rgba(0, 113, 233, 1)",
      13: "rgba(0, 91, 211, 1)",
      14: "rgba(0, 66, 153, 1)",
      15: "rgba(0, 46, 106, 1)",
      16: "rgba(0, 22, 51, 1)"
    }, green = {
      1: "rgba(248, 255, 251, 1)",
      2: "rgba(227, 255, 237, 1)",
      3: "rgba(205, 254, 225, 1)",
      4: "rgba(180, 254, 210, 1)",
      5: "rgba(146, 254, 194, 1)",
      6: "rgba(99, 253, 176, 1)",
      7: "rgba(56, 250, 163, 1)",
      8: "rgba(53, 238, 155, 1)",
      9: "rgba(50, 225, 147, 1)",
      10: "rgba(46, 211, 137, 1)",
      11: "rgba(50, 160, 110, 1)",
      12: "rgba(41, 132, 90, 1)",
      13: "rgba(19, 111, 69, 1)",
      14: "rgba(12, 81, 50, 1)",
      15: "rgba(8, 61, 37, 1)",
      16: "rgba(9, 42, 27, 1)"
    }, lime = {
      1: "rgba(250, 255, 250, 1)",
      2: "rgba(228, 255, 229, 1)",
      3: "rgba(208, 255, 209, 1)",
      4: "rgba(187, 254, 190, 1)",
      5: "rgba(157, 254, 160, 1)",
      6: "rgba(119, 254, 122, 1)",
      7: "rgba(56, 254, 62, 1)",
      8: "rgba(40, 242, 47, 1)",
      9: "rgba(37, 232, 43, 1)",
      10: "rgba(32, 207, 39, 1)",
      11: "rgba(24, 168, 29, 1)",
      12: "rgba(17, 135, 21, 1)",
      13: "rgba(12, 113, 15, 1)",
      14: "rgba(11, 85, 13, 1)",
      15: "rgba(3, 61, 5, 1)",
      16: "rgba(3, 33, 4, 1)"
    }, magenta = {
      1: "rgba(255, 253, 255, 1)",
      2: "rgba(255, 245, 255, 1)",
      3: "rgba(253, 239, 253, 1)",
      4: "rgba(254, 231, 254, 1)",
      5: "rgba(252, 223, 252, 1)",
      6: "rgba(251, 215, 251, 1)",
      7: "rgba(251, 207, 251, 1)",
      8: "rgba(249, 190, 249, 1)",
      9: "rgba(248, 177, 248, 1)",
      10: "rgba(246, 141, 246, 1)",
      11: "rgba(225, 86, 225, 1)",
      12: "rgba(197, 48, 197, 1)",
      13: "rgba(159, 38, 159, 1)",
      14: "rgba(121, 26, 121, 1)",
      15: "rgba(86, 16, 86, 1)",
      16: "rgba(52, 6, 52, 1)"
    }, orange = {
      1: "rgba(255, 253, 250, 1)",
      2: "rgba(255, 247, 238, 1)",
      3: "rgba(255, 241, 227, 1)",
      4: "rgba(255, 235, 213, 1)",
      5: "rgba(255, 228, 198, 1)",
      6: "rgba(255, 221, 182, 1)",
      7: "rgba(255, 214, 164, 1)",
      8: "rgba(255, 200, 121, 1)",
      9: "rgba(255, 184, 0, 1)",
      10: "rgba(229, 165, 0, 1)",
      11: "rgba(178, 132, 0, 1)",
      12: "rgba(149, 111, 0, 1)",
      13: "rgba(124, 88, 0, 1)",
      14: "rgba(94, 66, 0, 1)",
      15: "rgba(65, 45, 0, 1)",
      16: "rgba(37, 26, 0, 1)"
    }, purple = {
      1: "rgba(253, 253, 255, 1)",
      2: "rgba(248, 247, 255, 1)",
      3: "rgba(243, 241, 255, 1)",
      4: "rgba(239, 236, 255, 1)",
      5: "rgba(233, 229, 255, 1)",
      6: "rgba(228, 222, 255, 1)",
      7: "rgba(223, 217, 255, 1)",
      8: "rgba(212, 204, 255, 1)",
      9: "rgba(199, 188, 255, 1)",
      10: "rgba(170, 149, 255, 1)",
      11: "rgba(148, 116, 255, 1)",
      12: "rgba(128, 81, 255, 1)",
      13: "rgba(113, 38, 255, 1)",
      14: "rgba(87, 0, 209, 1)",
      15: "rgba(59, 0, 147, 1)",
      16: "rgba(28, 0, 79, 1)"
    }, red = {
      1: "rgba(255, 251, 251, 1)",
      2: "rgba(255, 246, 246, 1)",
      3: "rgba(255, 237, 236, 1)",
      4: "rgba(254, 233, 232, 1)",
      5: "rgba(254, 226, 225, 1)",
      6: "rgba(254, 218, 217, 1)",
      7: "rgba(254, 211, 209, 1)",
      8: "rgba(254, 195, 193, 1)",
      9: "rgba(253, 176, 172, 1)",
      10: "rgba(253, 129, 122, 1)",
      11: "rgba(239, 77, 47, 1)",
      12: "rgba(229, 28, 0, 1)",
      13: "rgba(181, 38, 11, 1)",
      14: "rgba(142, 31, 11, 1)",
      15: "rgba(95, 21, 7, 1)",
      16: "rgba(47, 10, 4, 1)"
    }, rose = {
      1: "rgba(255, 253, 253, 1)",
      2: "rgba(255, 246, 248, 1)",
      3: "rgba(255, 239, 243, 1)",
      4: "rgba(255, 232, 238, 1)",
      5: "rgba(255, 225, 232, 1)",
      6: "rgba(255, 217, 227, 1)",
      7: "rgba(254, 209, 221, 1)",
      8: "rgba(254, 193, 210, 1)",
      9: "rgba(254, 181, 202, 1)",
      10: "rgba(254, 142, 177, 1)",
      11: "rgba(253, 75, 146, 1)",
      12: "rgba(227, 12, 118, 1)",
      13: "rgba(185, 7, 95, 1)",
      14: "rgba(141, 4, 72, 1)",
      15: "rgba(100, 2, 49, 1)",
      16: "rgba(62, 1, 28, 1)"
    }, teal = {
      1: "rgba(248, 255, 254, 1)",
      2: "rgba(232, 252, 250, 1)",
      3: "rgba(215, 250, 247, 1)",
      4: "rgba(195, 247, 242, 1)",
      5: "rgba(170, 246, 239, 1)",
      6: "rgba(137, 245, 236, 1)",
      7: "rgba(112, 240, 229, 1)",
      8: "rgba(90, 230, 219, 1)",
      9: "rgba(44, 224, 212, 1)",
      10: "rgba(30, 199, 188, 1)",
      11: "rgba(0, 161, 152, 1)",
      12: "rgba(18, 131, 124, 1)",
      13: "rgba(12, 106, 100, 1)",
      14: "rgba(12, 83, 79, 1)",
      15: "rgba(3, 60, 57, 1)",
      16: "rgba(6, 44, 41, 1)"
    }, yellow = {
      1: "rgba(255, 253, 246, 1)",
      2: "rgba(255, 248, 219, 1)",
      3: "rgba(255, 244, 191, 1)",
      4: "rgba(255, 239, 157, 1)",
      5: "rgba(255, 235, 120, 1)",
      6: "rgba(255, 230, 0, 1)",
      7: "rgba(247, 223, 0, 1)",
      8: "rgba(234, 211, 0, 1)",
      9: "rgba(225, 203, 0, 1)",
      10: "rgba(197, 178, 0, 1)",
      11: "rgba(153, 138, 0, 1)",
      12: "rgba(130, 117, 0, 1)",
      13: "rgba(105, 95, 0, 1)",
      14: "rgba(79, 71, 0, 1)",
      15: "rgba(51, 46, 0, 1)",
      16: "rgba(31, 28, 0, 1)"
    }, blackAlpha = {
      1: "rgba(0, 0, 0, 0)",
      2: "rgba(0, 0, 0, 0.01)",
      3: "rgba(0, 0, 0, 0.02)",
      4: "rgba(0, 0, 0, 0.03)",
      5: "rgba(0, 0, 0, 0.05)",
      6: "rgba(0, 0, 0, 0.06)",
      7: "rgba(0, 0, 0, 0.08)",
      8: "rgba(0, 0, 0, 0.11)",
      9: "rgba(0, 0, 0, 0.17)",
      10: "rgba(0, 0, 0, 0.20)",
      11: "rgba(0, 0, 0, 0.29)",
      12: "rgba(0, 0, 0, 0.46)",
      13: "rgba(0, 0, 0, 0.62)",
      14: "rgba(0, 0, 0, 0.71)",
      15: "rgba(0, 0, 0, 0.81)",
      16: "rgba(0, 0, 0, 0.90)"
    }, whiteAlpha = {
      1: "rgba(255, 255, 255, 0)",
      2: "rgba(255, 255, 255, 0.01)",
      3: "rgba(255, 255, 255, 0.02)",
      4: "rgba(255, 255, 255, 0.03)",
      5: "rgba(255, 255, 255, 0.05)",
      6: "rgba(255, 255, 255, 0.06)",
      7: "rgba(255, 255, 255, 0.08)",
      8: "rgba(255, 255, 255, 0.11)",
      9: "rgba(255, 255, 255, 0.17)",
      10: "rgba(255, 255, 255, 0.20)",
      11: "rgba(255, 255, 255, 0.28)",
      12: "rgba(255, 255, 255, 0.46)",
      13: "rgba(255, 255, 255, 0.62)",
      14: "rgba(255, 255, 255, 0.71)",
      15: "rgba(255, 255, 255, 0.81)",
      16: "rgba(255, 255, 255, 0.90)"
    };
    exports.azure = azure;
    exports.blackAlpha = blackAlpha;
    exports.blue = blue;
    exports.gray = gray;
    exports.green = green;
    exports.lime = lime;
    exports.magenta = magenta;
    exports.orange = orange;
    exports.purple = purple;
    exports.red = red;
    exports.rose = rose;
    exports.teal = teal;
    exports.whiteAlpha = whiteAlpha;
    exports.yellow = yellow;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/color.js
var require_color = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/color.js"(exports) {
    "use strict";
    init_cjs_shims();
    var colors = require_colors(), color = {
      "color-scheme": {
        value: "light"
      },
      "color-bg": {
        value: colors.gray[6],
        description: "The default background color of the admin."
      },
      "color-bg-inverse": {
        value: colors.gray[16],
        description: "Use for high contrast page or component backgrounds."
      },
      "color-bg-surface": {
        value: colors.gray[1],
        description: "The background color for elements with the highest level of prominence, like a card."
      },
      "color-bg-surface-hover": {
        value: colors.gray[4],
        description: "The hover state color for elements with the highest level of prominence."
      },
      "color-bg-surface-active": {
        value: colors.gray[5],
        description: "The active state (on press) color for elements with the highest level of prominence."
      },
      "color-bg-surface-selected": {
        value: colors.gray[6],
        description: "The selected state color for elements with the highest level of prominence."
      },
      "color-bg-surface-disabled": {
        value: colors.blackAlpha[5],
        description: "The disabled state color for elements."
      },
      "color-bg-surface-secondary": {
        value: colors.gray[4],
        description: "The background color for elements with a secondary level of prominence."
      },
      "color-bg-surface-secondary-hover": {
        value: colors.gray[6],
        description: "The hover state color for elements with a secondary level of prominence."
      },
      "color-bg-surface-secondary-active": {
        value: colors.gray[7],
        description: "The active state (on press) color for elements with a secondary level of prominence."
      },
      "color-bg-surface-secondary-selected": {
        value: colors.gray[7],
        description: "The selected state color for elements with a secondary level of prominence."
      },
      "color-bg-surface-tertiary": {
        value: colors.gray[5],
        description: "The background color for elements with a third level of prominence."
      },
      "color-bg-surface-tertiary-hover": {
        value: colors.gray[7],
        description: "The hover state color for elements with a third level of prominence."
      },
      "color-bg-surface-tertiary-active": {
        value: colors.gray[8],
        description: "The active state (on press) color for elements with a third level of prominence."
      },
      "color-bg-surface-brand": {
        value: colors.gray[8],
        description: "Use to apply the key color to elements."
      },
      "color-bg-surface-brand-hover": {
        value: colors.gray[7],
        description: "The hover state color for key elements."
      },
      "color-bg-surface-brand-active": {
        value: colors.gray[6],
        description: "The active state (on press) color for key elements."
      },
      "color-bg-surface-brand-selected": {
        value: colors.gray[6],
        description: "The selected state color for key elements."
      },
      "color-bg-surface-info": {
        value: colors.azure[3],
        description: "Use for backgrounds communicating important information, like banners."
      },
      "color-bg-surface-info-hover": {
        value: colors.azure[4],
        description: "The hover state color for communicating important information."
      },
      "color-bg-surface-info-active": {
        value: colors.azure[6],
        description: "The active state (on press) color for communicating important information."
      },
      "color-bg-surface-success": {
        value: colors.green[3],
        description: "Use for backgrounds communicating success, like banners."
      },
      "color-bg-surface-success-hover": {
        value: colors.green[4],
        description: "The hover state color for communicating success."
      },
      "color-bg-surface-success-active": {
        value: colors.green[5],
        description: "The active state (on press) color for communicating success."
      },
      "color-bg-surface-caution": {
        value: colors.yellow[2],
        description: "Use for backgrounds communicating caution, like banners."
      },
      "color-bg-surface-caution-hover": {
        value: colors.yellow[3],
        description: "The hover state for communicating caution."
      },
      "color-bg-surface-caution-active": {
        value: colors.yellow[4],
        description: "The active state (on press) color for communicating caution."
      },
      "color-bg-surface-warning": {
        value: colors.orange[3],
        description: "Use for backgrounds communicating warning, like banners."
      },
      "color-bg-surface-warning-hover": {
        value: colors.orange[4],
        description: "The hover state color for communicating warning."
      },
      "color-bg-surface-warning-active": {
        value: colors.orange[5],
        description: "The active state (on press) color for communicating warning."
      },
      "color-bg-surface-critical": {
        value: colors.red[4],
        description: "Use for backgrounds communicating critical information, like banners or input errors."
      },
      "color-bg-surface-critical-hover": {
        value: colors.red[5],
        description: "The hover state color for communicating critical information."
      },
      "color-bg-surface-critical-active": {
        value: colors.red[6],
        description: "The active state (on press) color for communicating critical information."
      },
      "color-bg-surface-emphasis": {
        value: colors.blue[3],
        description: "Use for backgrounds indicating areas of focus in editors, such as the theme editor."
      },
      "color-bg-surface-emphasis-hover": {
        value: colors.blue[4],
        description: "The hover state color for elements indicating areas of focus in editors."
      },
      "color-bg-surface-emphasis-active": {
        value: colors.blue[5],
        description: "The active state (on press) color for elements indicating areas of focus in editors."
      },
      "color-bg-surface-magic": {
        value: colors.purple[2],
        description: "Use for backgrounds of elements suggested by magic AI."
      },
      "color-bg-surface-magic-hover": {
        value: colors.purple[3],
        description: "The hover state color for elements suggested by magic AI."
      },
      "color-bg-surface-magic-active": {
        value: colors.purple[5],
        description: "The active state (on press) color for elements suggested by magic AI."
      },
      "color-bg-surface-inverse": {
        value: colors.gray[15],
        description: "Use for elements on bg-inverse."
      },
      "color-bg-surface-transparent": {
        value: colors.blackAlpha[1],
        description: "Use for elements that need a fully transparent background."
      },
      "color-bg-fill": {
        value: colors.gray[1],
        description: "The background color of contained elements with a smaller surface area, like a button."
      },
      "color-bg-fill-hover": {
        value: colors.gray[3],
        description: "The hover state color of contained elements with a smaller surface area, like a button."
      },
      "color-bg-fill-active": {
        value: colors.gray[4],
        description: "The active state (on press) color of contained elements with a smaller surface area, like a button."
      },
      "color-bg-fill-selected": {
        value: colors.gray[10],
        description: "The selected state color of contained elements with a smaller surface area, like a button or checkbox."
      },
      "color-bg-fill-disabled": {
        value: colors.blackAlpha[5],
        description: "The disabled state color of contained elements with a smaller surface area, like a button."
      },
      "color-bg-fill-secondary": {
        value: colors.gray[6],
        description: "The background color of elements with a smaller surface area and a secondary level of prominence."
      },
      "color-bg-fill-secondary-hover": {
        value: colors.gray[7],
        description: "The hover state color of elements with a smaller surface area and a secondary level of prominence."
      },
      "color-bg-fill-secondary-active": {
        value: colors.gray[8],
        description: "The active state (on press) color of elements with a smaller surface area and a secondary level of prominence."
      },
      "color-bg-fill-tertiary": {
        value: colors.gray[8],
        description: "The background color of elements with a smaller surface area and a third level of prominence."
      },
      "color-bg-fill-tertiary-hover": {
        value: colors.gray[9],
        description: "The hover state color of elements with a smaller surface area and a third level of prominence."
      },
      "color-bg-fill-tertiary-active": {
        value: colors.gray[10],
        description: "The active state (on press) color of elements with a smaller surface area and a third level of prominence."
      },
      "color-bg-fill-brand": {
        value: colors.gray[15],
        description: "The background color of main actions, like primary buttons."
      },
      "color-bg-fill-brand-hover": {
        value: colors.gray[16],
        description: "The hover state color of main actions, like primary buttons."
      },
      "color-bg-fill-brand-active": {
        value: colors.gray[16],
        description: "The active state (on press) color of main actions, like primary buttons."
      },
      "color-bg-fill-brand-selected": {
        value: colors.gray[15],
        description: "The selected state color of main actions, like primary buttons."
      },
      "color-bg-fill-brand-disabled": {
        value: colors.blackAlpha[9],
        description: "The disabled state color of main actions, like primary buttons."
      },
      "color-bg-fill-info": {
        value: colors.azure[9],
        description: "Use for backgrounds communicating important information on elements with a smaller surface area, like a badge or button."
      },
      "color-bg-fill-info-hover": {
        value: colors.azure[10],
        description: "The hover state color for communicating important information on elements with a smaller surface area."
      },
      "color-bg-fill-info-active": {
        value: colors.azure[11],
        description: "The active state (on press) color for communicating important information on elements with a smaller surface area."
      },
      "color-bg-fill-info-secondary": {
        value: colors.azure[5],
        description: "Use for backgrounds communicating important information on elements with a smaller surface area, with a secondary level of prominence."
      },
      "color-bg-fill-success": {
        value: colors.green[12],
        description: "Use for backgrounds communicating success on elements with a smaller surface area, like a badge or a banner."
      },
      "color-bg-fill-success-hover": {
        value: colors.green[13],
        description: "The hover state color for communicating success on elements with a smaller surface area."
      },
      "color-bg-fill-success-active": {
        value: colors.green[14],
        description: "The active state (on press) color for communicating success on elements with a smaller surface area."
      },
      "color-bg-fill-success-secondary": {
        value: colors.green[4],
        description: "Use for backgrounds communicating success on elements with a smaller surface area, with a secondary level of prominence."
      },
      "color-bg-fill-warning": {
        value: colors.orange[9],
        description: "Use for backgrounds communicating warning on elements with a smaller surface area, like a badge or a banner."
      },
      "color-bg-fill-warning-hover": {
        value: colors.orange[10],
        description: "The hover state color for communicating warning on elements with a smaller surface area."
      },
      "color-bg-fill-warning-active": {
        value: colors.orange[11],
        description: "The active state (on press) color for communicating warning on elements with a smaller surface area."
      },
      "color-bg-fill-warning-secondary": {
        value: colors.orange[7],
        description: "Use for backgrounds communicating warning on elements with a smaller surface area, with a secondary level of prominence."
      },
      "color-bg-fill-caution": {
        value: colors.yellow[6],
        description: "Use for backgrounds communicating caution on elements with a smaller surface area, like a badge or a banner."
      },
      "color-bg-fill-caution-hover": {
        value: colors.yellow[8],
        description: "The hover state color for communicating caution on elements with a smaller surface area."
      },
      "color-bg-fill-caution-active": {
        value: colors.yellow[9],
        description: "The active state (on press) color for communicating caution on elements with a smaller surface area."
      },
      "color-bg-fill-caution-secondary": {
        value: colors.yellow[5],
        description: "Use for backgrounds communicating caution on elements with a smaller surface area, with a secondary level of prominence."
      },
      "color-bg-fill-critical": {
        value: colors.red[12],
        description: "Use for backgrounds communicating critical information on elements with a smaller surface area, like a badge or a banner."
      },
      "color-bg-fill-critical-hover": {
        value: colors.red[13],
        description: "The hover state color for communicating critical information on elements with a smaller surface area."
      },
      "color-bg-fill-critical-active": {
        value: colors.red[14],
        description: "The active state (on press) color for communicating critical information on elements with a smaller surface area."
      },
      "color-bg-fill-critical-selected": {
        value: colors.red[14],
        description: "The selected state color for communicating critical information on elements with a smaller surface area."
      },
      "color-bg-fill-critical-secondary": {
        value: colors.red[7],
        description: "Use for backgrounds communicating critical information on elements with a smaller surface area, with a secondary level of prominence."
      },
      "color-bg-fill-emphasis": {
        value: colors.blue[13],
        description: "Use for backgrounds indicating areas of focus in editors on elements with a smaller surface area, like a button or a badge."
      },
      "color-bg-fill-emphasis-hover": {
        value: colors.blue[14],
        description: "The hover state color for indicating areas of focus in editors on elements with a smaller surface area."
      },
      "color-bg-fill-emphasis-active": {
        value: colors.blue[15],
        description: "The active state (on press) color for indicating areas of focus in editors on elements with a smaller surface area."
      },
      "color-bg-fill-magic": {
        value: colors.purple[12],
        description: "The background color of elements suggested by magic AI, like a badge or a banner."
      },
      "color-bg-fill-magic-secondary": {
        value: colors.purple[5],
        description: "The background color of elements suggested by magic AI, with a secondary level of prominence."
      },
      "color-bg-fill-magic-secondary-hover": {
        value: colors.purple[6],
        description: "The hover state color of elements suggested by magic AI, with a secondary level of prominence."
      },
      "color-bg-fill-magic-secondary-active": {
        value: colors.purple[7],
        description: "The active state (on press) color of elements suggested by magic AI, with a secondary level of prominence."
      },
      "color-bg-fill-inverse": {
        value: colors.gray[15],
        description: "The background color of elements with a smaller surface area on an inverse background."
      },
      "color-bg-fill-inverse-hover": {
        value: colors.gray[14],
        description: "The hover state color of elements with a smaller surface area on an inverse background."
      },
      "color-bg-fill-inverse-active": {
        value: colors.gray[13],
        description: "The active state (on press) color of elements with a smaller surface area on an inverse background."
      },
      "color-bg-fill-transparent": {
        value: colors.blackAlpha[3],
        description: "The background color of elements that need to sit on different background colors, like tabs."
      },
      "color-bg-fill-transparent-hover": {
        value: colors.blackAlpha[5],
        description: "The hover state color of elements that need to sit on different background colors, like tabs."
      },
      "color-bg-fill-transparent-active": {
        value: colors.blackAlpha[7],
        description: "The active state (on press) color of elements that need to sit on different background colors, like tabs."
      },
      "color-bg-fill-transparent-selected": {
        value: colors.blackAlpha[7],
        description: "The selected state color of elements that need to sit on different background colors, like tabs."
      },
      "color-bg-fill-transparent-secondary": {
        value: colors.blackAlpha[6],
        description: "The background color of elements that need to sit on different background colors, with a secondary level of prominence."
      },
      "color-bg-fill-transparent-secondary-hover": {
        value: colors.blackAlpha[7],
        description: "The hover state color of elements that need to sit on different background colors, with a secondary level of prominence."
      },
      "color-bg-fill-transparent-secondary-active": {
        value: colors.blackAlpha[8],
        description: "The active state (on press) color of elements that need to sit on different background colors, with a secondary level of prominence."
      },
      "color-text": {
        value: colors.gray[15],
        description: "The default text color."
      },
      "color-text-secondary": {
        value: colors.gray[13],
        description: "Use for text with a secondary level of prominence."
      },
      "color-text-disabled": {
        value: colors.gray[11],
        description: "Use for text in a disabled state."
      },
      "color-text-link": {
        value: colors.blue[13],
        description: "Use for text links."
      },
      "color-text-link-hover": {
        value: colors.blue[14],
        description: "The hover state color for text links."
      },
      "color-text-link-active": {
        value: colors.blue[15],
        description: "The active state (on press) color for text links."
      },
      "color-text-brand": {
        value: colors.gray[14],
        description: "Use for text that needs to pull attention."
      },
      "color-text-brand-hover": {
        value: colors.gray[15],
        description: "The hover state color for text that needs to pull attention."
      },
      "color-text-brand-on-bg-fill": {
        value: colors.gray[1],
        description: "Use for text on bg-fill-brand, like primary buttons."
      },
      "color-text-brand-on-bg-fill-hover": {
        value: colors.gray[8],
        description: "The hover state color for text on bg-fill-brand-hover."
      },
      "color-text-brand-on-bg-fill-active": {
        value: colors.gray[10],
        description: "The active state (on press) color for text on bg-fill-brand."
      },
      "color-text-brand-on-bg-fill-disabled": {
        value: colors.gray[1],
        description: "The disabled state color for text on bg-fill-brand-disabled."
      },
      "color-text-info": {
        value: colors.azure[15],
        description: "Use for text communicating important information."
      },
      "color-text-info-hover": {
        value: colors.azure[15],
        description: "The hover state color for text communicating important information."
      },
      "color-text-info-active": {
        value: colors.azure[16],
        description: "The active state (on press) color for text communicating important information."
      },
      "color-text-info-secondary": {
        value: colors.azure[12],
        description: "Use for text communicating important information with a secondary level of prominence."
      },
      "color-text-info-on-bg-fill": {
        value: colors.azure[16],
        description: "Use for text and icons on bg-fill-info."
      },
      "color-text-success": {
        value: colors.green[14],
        description: "Use for text communicating success."
      },
      "color-text-success-hover": {
        value: colors.green[15],
        description: "The hover state color for text communicating success."
      },
      "color-text-success-active": {
        value: colors.green[16],
        description: "The active state (on press) color for text communicating success."
      },
      "color-text-success-secondary": {
        value: colors.green[12],
        description: "Use for text communicating success with a secondary level of prominence."
      },
      "color-text-success-on-bg-fill": {
        value: colors.green[1],
        description: "Use for text and icons on bg-fill-success."
      },
      "color-text-caution": {
        value: colors.yellow[14],
        description: "Use for text communicating caution."
      },
      "color-text-caution-hover": {
        value: colors.yellow[15],
        description: "The hover state color for text communicating caution."
      },
      "color-text-caution-active": {
        value: colors.yellow[16],
        description: "The active state (on press) color for text communicating caution."
      },
      "color-text-caution-secondary": {
        value: colors.yellow[12],
        description: "Use for text communicating caution with a secondary level of prominence."
      },
      "color-text-caution-on-bg-fill": {
        value: colors.yellow[15],
        description: "Use for text and icons on bg-fill-caution."
      },
      "color-text-warning": {
        value: colors.orange[14],
        description: "Use for text communicating warning."
      },
      "color-text-warning-hover": {
        value: colors.orange[15],
        description: "The hover state color for text communicating warning."
      },
      "color-text-warning-active": {
        value: colors.orange[16],
        description: "The active state (on press) color for text communicating warning."
      },
      "color-text-warning-secondary": {
        value: colors.orange[12],
        description: "Use for text communicating warning with a secondary level of prominence."
      },
      "color-text-warning-on-bg-fill": {
        value: colors.orange[16],
        description: "Use for text and icons on bg-fill-warning."
      },
      "color-text-critical": {
        value: colors.red[14],
        description: "Use for text communicating critical information."
      },
      "color-text-critical-hover": {
        value: colors.red[15],
        description: "The hover state color for text communicating critical information."
      },
      "color-text-critical-active": {
        value: colors.red[16],
        description: "The active state (on press) color for text communicating critical information."
      },
      "color-text-critical-secondary": {
        value: colors.red[12],
        description: "Use for text communicating critical information with a secondary level of prominence."
      },
      "color-text-critical-on-bg-fill": {
        value: colors.red[1],
        description: "Use for text and icons on bg-fill-critical."
      },
      "color-text-emphasis": {
        value: colors.blue[13],
        description: "Use for text indicating areas of focus in editors, like the theme editor."
      },
      "color-text-emphasis-hover": {
        value: colors.blue[14],
        description: "The hover state color for text indicating areas of focus."
      },
      "color-text-emphasis-active": {
        value: colors.blue[15],
        description: "The active state (on press) color for text indicating areas of focus."
      },
      "color-text-emphasis-on-bg-fill": {
        value: colors.blue[1],
        description: "Use for text and icons on bg-fill-emphasis."
      },
      "color-text-emphasis-on-bg-fill-hover": {
        value: colors.blue[5],
        description: "Use for text and icons on bg-fill-emphasis-hover."
      },
      "color-text-emphasis-on-bg-fill-active": {
        value: colors.blue[7],
        description: "Use for text and icons on bg-fill-emphasis-active."
      },
      "color-text-magic": {
        value: colors.purple[14],
        description: "Use for text suggested by magic AI."
      },
      "color-text-magic-secondary": {
        value: colors.purple[13],
        description: "Use for text suggested by magic AI with a secondary level of prominence."
      },
      "color-text-magic-on-bg-fill": {
        value: colors.purple[1],
        description: "Use for text and icons on bg-fill-magic."
      },
      "color-text-inverse": {
        value: colors.gray[8],
        description: "Use for text on an inverse background."
      },
      "color-text-inverse-secondary": {
        value: colors.gray[11],
        description: "Use for secondary text on an inverse background."
      },
      "color-text-link-inverse": {
        value: colors.blue[8],
        description: "Use for text links on an inverse background."
      },
      "color-border": {
        value: colors.gray[8],
        description: "The default color for borders on any element."
      },
      "color-border-hover": {
        value: colors.gray[10],
        description: "The hover color for borders on any element."
      },
      "color-border-disabled": {
        value: colors.gray[7],
        description: "The disabled color for borders on any element."
      },
      "color-border-secondary": {
        value: colors.gray[7],
        description: "The color for hr elements or any visual dividers."
      },
      "color-border-tertiary": {
        value: colors.gray[10],
        description: "The border color on any element. Pair with bg-surface-tertiary or bg-fill-tertiary."
      },
      "color-border-focus": {
        value: colors.blue[13],
        description: "The focus ring for any interactive element in a focused state."
      },
      "color-border-brand": {
        value: colors.gray[8],
        description: "Use for borders paired with brand colors."
      },
      "color-border-info": {
        value: colors.azure[8],
        description: "Use for borders communicating information."
      },
      "color-border-success": {
        value: colors.green[5],
        description: "Use for borders communicating success."
      },
      "color-border-caution": {
        value: colors.yellow[5],
        description: "Use for borders communicating caution."
      },
      "color-border-warning": {
        value: colors.orange[8],
        description: "Use for borders communicating warning."
      },
      "color-border-critical": {
        value: colors.red[8],
        description: "Use for borders communicating critical information."
      },
      "color-border-critical-secondary": {
        value: colors.red[14],
        description: "Use for borders communicating critical information, such as borders on invalid text fields."
      },
      "color-border-emphasis": {
        value: colors.blue[13],
        description: "Use for borders indicating areas of focus."
      },
      "color-border-emphasis-hover": {
        value: colors.blue[14],
        description: "The hover state color for borders indicating areas of focus."
      },
      "color-border-emphasis-active": {
        value: colors.blue[15],
        description: "The active state (on press) color for borders indicating areas of focus."
      },
      "color-border-magic": {
        value: colors.purple[6],
        description: "Use for borders suggested by magic AI."
      },
      "color-border-magic-secondary": {
        value: colors.purple[11],
        description: "Use for borders suggested by magic AI, such as borders on text fields."
      },
      "color-border-magic-secondary-hover": {
        value: colors.purple[12],
        description: "Use for borders suggested by magic AI, such as borders on text fields."
      },
      "color-border-inverse": {
        value: colors.gray[13],
        description: "Use for borders on an inverse background, such as borders on the global search."
      },
      "color-border-inverse-hover": {
        value: colors.gray[10],
        description: "The hover state color for borders on an inverse background."
      },
      "color-border-inverse-active": {
        value: colors.gray[8],
        description: "The active state (on press) color for borders on an inverse background."
      },
      "color-tooltip-tail-down-border-experimental": {
        value: colors.gray[9],
        description: "The border color for tooltip tails pointing down."
      },
      "color-tooltip-tail-up-border-experimental": {
        value: colors.gray[8],
        description: "The border color for tooltip tails pointing up."
      },
      "color-border-gradient-experimental": {
        value: "linear-gradient(to bottom, " + colors.gray[7] + ", " + colors.gray[10] + " 78%, " + colors.gray[11] + ")"
      },
      "color-border-gradient-hover-experimental": {
        value: "linear-gradient(to bottom, " + colors.gray[7] + ", " + colors.gray[10] + " 78%, " + colors.gray[11] + ")"
      },
      "color-border-gradient-selected-experimental": {
        value: "linear-gradient(to bottom, " + colors.gray[7] + ", " + colors.gray[10] + " 78%, " + colors.gray[11] + ")"
      },
      "color-border-gradient-active-experimental": {
        value: "linear-gradient(to bottom, " + colors.gray[7] + ", " + colors.gray[10] + " 78%, " + colors.gray[11] + ")"
      },
      "color-icon": {
        value: colors.gray[14],
        description: "The default color for icons."
      },
      "color-icon-hover": {
        value: colors.gray[15],
        description: "The hover state color for icons."
      },
      "color-icon-active": {
        value: colors.gray[16],
        description: "The active state (on press) color for icons."
      },
      "color-icon-disabled": {
        value: colors.gray[10],
        description: "The disabled state color for icons."
      },
      "color-icon-secondary": {
        value: colors.gray[12],
        description: "Use for secondary icons."
      },
      "color-icon-secondary-hover": {
        value: colors.gray[13],
        description: "The hover state color for secondary icons."
      },
      "color-icon-secondary-active": {
        value: colors.gray[14],
        description: "The active state (on press) color for secondary icons."
      },
      "color-icon-brand": {
        value: colors.gray[16],
        description: "Use for icons that need to pull more focus."
      },
      "color-icon-info": {
        value: colors.azure[11],
        description: "Use for icons communicating information."
      },
      "color-icon-success": {
        value: colors.green[12],
        description: "Use for icons communicating success."
      },
      "color-icon-caution": {
        value: colors.yellow[11],
        description: "Use for icons communicating caution."
      },
      "color-icon-warning": {
        value: colors.orange[11],
        description: "Use for icons communicating warning."
      },
      "color-icon-critical": {
        value: colors.red[11],
        description: "Use for icons communicating critical information."
      },
      "color-icon-emphasis": {
        value: colors.blue[13],
        description: "Use for icons indicating areas of focus in editors, like the theme editor."
      },
      "color-icon-emphasis-hover": {
        value: colors.blue[14],
        description: "The hover color for icons indicating areas of focus in editors."
      },
      "color-icon-emphasis-active": {
        value: colors.blue[15],
        description: "The active state (on press) color for icons indicating areas of focus in editors."
      },
      "color-icon-magic": {
        value: colors.purple[12],
        description: "Use for icons suggested by magic AI."
      },
      "color-icon-inverse": {
        value: colors.gray[8],
        description: "Use for icons on an inverse background."
      },
      "color-avatar-bg-fill": {
        value: colors.gray[11]
      },
      "color-avatar-five-bg-fill": {
        value: colors.rose[11]
      },
      "color-avatar-five-text-on-bg-fill": {
        value: colors.rose[2]
      },
      "color-avatar-four-bg-fill": {
        value: colors.azure[10]
      },
      "color-avatar-four-text-on-bg-fill": {
        value: colors.azure[16]
      },
      "color-avatar-one-bg-fill": {
        value: colors.magenta[12]
      },
      "color-avatar-one-text-on-bg-fill": {
        value: colors.magenta[3]
      },
      "color-avatar-seven-bg-fill": {
        value: colors.purple[11]
      },
      "color-avatar-seven-text-on-bg-fill": {
        value: colors.purple[2]
      },
      "color-avatar-six-bg-fill": {
        value: colors.lime[9]
      },
      "color-avatar-six-text-on-bg-fill": {
        value: colors.lime[15]
      },
      "color-avatar-text-on-bg-fill": {
        value: colors.gray[1]
      },
      "color-avatar-three-bg-fill": {
        value: colors.teal[9]
      },
      "color-avatar-three-text-on-bg-fill": {
        value: colors.teal[15]
      },
      "color-avatar-two-bg-fill": {
        value: colors.green[7]
      },
      "color-avatar-two-text-on-bg-fill": {
        value: colors.green[14]
      },
      "color-backdrop-bg": {
        value: colors.blackAlpha[14]
      },
      "color-button-gradient-bg-fill": {
        value: "linear-gradient(180deg, rgba(48, 48, 48, 0) 63.53%, rgba(255, 255, 255, 0.15) 100%)"
      },
      "color-checkbox-bg-surface-disabled": {
        value: colors.blackAlpha[7]
      },
      "color-checkbox-icon-disabled": {
        value: colors.gray[1]
      },
      "color-input-bg-surface": {
        value: colors.gray[2]
      },
      "color-input-bg-surface-hover": {
        value: colors.gray[3]
      },
      "color-input-bg-surface-active": {
        value: colors.gray[4]
      },
      "color-input-border": {
        value: colors.gray[12]
      },
      "color-input-border-hover": {
        value: colors.gray[13]
      },
      "color-input-border-active": {
        value: colors.gray[16]
      },
      "color-nav-bg": {
        value: colors.gray[7]
      },
      "color-nav-bg-surface": {
        value: colors.blackAlpha[3]
      },
      "color-nav-bg-surface-hover": {
        value: colors.gray[6]
      },
      "color-nav-bg-surface-active": {
        value: colors.gray[3]
      },
      "color-nav-bg-surface-selected": {
        value: colors.gray[3]
      },
      "color-radio-button-bg-surface-disabled": {
        value: colors.blackAlpha[7]
      },
      "color-radio-button-icon-disabled": {
        value: colors.gray[1]
      },
      "color-video-thumbnail-play-button-bg-fill-hover": {
        value: colors.blackAlpha[15]
      },
      "color-video-thumbnail-play-button-bg-fill": {
        value: colors.blackAlpha[14]
      },
      "color-video-thumbnail-play-button-text-on-bg-fill": {
        value: colors.gray[1]
      },
      "color-scrollbar-thumb-bg-hover": {
        value: colors.gray[12]
      }
    };
    exports.color = color;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/font.js
var require_font = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/font.js"(exports) {
    "use strict";
    init_cjs_shims();
    var size = require_size(), font = {
      "font-family-sans": {
        value: "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif"
      },
      "font-family-mono": {
        value: "ui-monospace, SFMono-Regular, 'SF Mono', Consolas, 'Liberation Mono', Menlo, monospace"
      },
      "font-size-275": {
        value: size.size[275]
      },
      "font-size-300": {
        value: size.size[300]
      },
      "font-size-325": {
        value: size.size[325]
      },
      "font-size-350": {
        value: size.size[350]
      },
      "font-size-400": {
        value: size.size[400]
      },
      "font-size-450": {
        value: size.size[450]
      },
      "font-size-500": {
        value: size.size[500]
      },
      "font-size-550": {
        value: size.size[550]
      },
      "font-size-600": {
        value: size.size[600]
      },
      "font-size-750": {
        value: size.size[750]
      },
      "font-size-800": {
        value: size.size[800]
      },
      "font-size-900": {
        value: size.size[900]
      },
      "font-size-1000": {
        value: size.size[1e3]
      },
      "font-weight-regular": {
        value: "450"
      },
      "font-weight-medium": {
        value: "550"
      },
      "font-weight-semibold": {
        value: "650"
      },
      "font-weight-bold": {
        value: "700"
      },
      "font-letter-spacing-densest": {
        value: "-0.54px"
      },
      "font-letter-spacing-denser": {
        value: "-0.3px"
      },
      "font-letter-spacing-dense": {
        value: "-0.2px"
      },
      "font-letter-spacing-normal": {
        value: "0px"
      },
      "font-line-height-300": {
        value: size.size[300]
      },
      "font-line-height-400": {
        value: size.size[400]
      },
      "font-line-height-500": {
        value: size.size[500]
      },
      "font-line-height-600": {
        value: size.size[600]
      },
      "font-line-height-700": {
        value: size.size[700]
      },
      "font-line-height-800": {
        value: size.size[800]
      },
      "font-line-height-1000": {
        value: size.size[1e3]
      },
      "font-line-height-1200": {
        value: size.size[1200]
      }
    };
    exports.font = font;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/height.js
var require_height = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/height.js"(exports) {
    "use strict";
    init_cjs_shims();
    var size = require_size(), height = {
      "height-0": {
        value: size.size[0]
      },
      "height-025": {
        value: size.size["025"]
      },
      "height-050": {
        value: size.size["050"]
      },
      "height-100": {
        value: size.size[100]
      },
      "height-150": {
        value: size.size[150]
      },
      "height-200": {
        value: size.size[200]
      },
      "height-300": {
        value: size.size[300]
      },
      "height-400": {
        value: size.size[400]
      },
      "height-500": {
        value: size.size[500]
      },
      "height-600": {
        value: size.size[600]
      },
      "height-700": {
        value: size.size[700]
      },
      "height-800": {
        value: size.size[800]
      },
      "height-900": {
        value: size.size[900]
      },
      "height-1000": {
        value: size.size[1e3]
      },
      "height-1200": {
        value: size.size[1200]
      },
      "height-1600": {
        value: size.size[1600]
      },
      "height-2000": {
        value: size.size[2e3]
      },
      "height-2400": {
        value: size.size[2400]
      },
      "height-2800": {
        value: size.size[2800]
      },
      "height-3200": {
        value: size.size[3200]
      }
    };
    exports.height = height;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/motion.js
var require_motion = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/motion.js"(exports) {
    "use strict";
    init_cjs_shims();
    var motion = {
      "motion-duration-0": {
        value: "0ms"
      },
      "motion-duration-50": {
        value: "50ms"
      },
      "motion-duration-100": {
        value: "100ms"
      },
      "motion-duration-150": {
        value: "150ms"
      },
      "motion-duration-200": {
        value: "200ms"
      },
      "motion-duration-250": {
        value: "250ms"
      },
      "motion-duration-300": {
        value: "300ms"
      },
      "motion-duration-350": {
        value: "350ms"
      },
      "motion-duration-400": {
        value: "400ms"
      },
      "motion-duration-450": {
        value: "450ms"
      },
      "motion-duration-500": {
        value: "500ms"
      },
      "motion-duration-5000": {
        value: "5000ms"
      },
      "motion-ease": {
        value: "cubic-bezier(0.25, 0.1, 0.25, 1)",
        description: "Responds quickly and finishes with control. A great default for any user interaction."
      },
      "motion-ease-in": {
        value: "cubic-bezier(0.42, 0, 1, 1)",
        description: "Starts slowly and finishes at top speed. Use sparingly."
      },
      "motion-ease-out": {
        value: "cubic-bezier(0.19, 0.91, 0.38, 1)",
        description: "Starts at top speed and finishes slowly. Use sparingly."
      },
      "motion-ease-in-out": {
        value: "cubic-bezier(0.42, 0, 0.58, 1)",
        description: "Starts and finishes with equal speed. A good default for transitions triggered by the system."
      },
      "motion-linear": {
        value: "cubic-bezier(0, 0, 1, 1)",
        description: "Moves with constant speed. Use for continuous and mechanical animations, such as rotating spinners."
      },
      "motion-keyframes-bounce": {
        value: "{ from, 65%, 85% { transform: scale(1) } 75% { transform: scale(0.85) } 82.5% { transform: scale(1.05) } }"
      },
      "motion-keyframes-fade-in": {
        value: "{ to { opacity: 1 } }"
      },
      "motion-keyframes-pulse": {
        value: "{ from, 75% { transform: scale(0.85); opacity: 1; } to { transform: scale(2.5); opacity: 0; } }"
      },
      "motion-keyframes-spin": {
        value: "{ to { transform: rotate(1turn) } }"
      },
      "motion-keyframes-appear-above": {
        value: "{ from { transform: translateY(var(--p-space-100)); opacity: 0; } to { transform: none; opacity: 1; } }"
      },
      "motion-keyframes-appear-below": {
        value: "{ from { transform: translateY(calc(var(--p-space-100) * -1)); opacity: 0; } to { transform: none; opacity: 1; } }"
      }
    };
    exports.motion = motion;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/shadow.js
var require_shadow = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/shadow.js"(exports) {
    "use strict";
    init_cjs_shims();
    var shadow = {
      "shadow-0": {
        value: "none"
      },
      "shadow-100": {
        value: "0px 1px 0px 0px rgba(26, 26, 26, 0.07)"
      },
      "shadow-200": {
        value: "0px 3px 1px -1px rgba(26, 26, 26, 0.07)"
      },
      "shadow-300": {
        value: "0px 4px 6px -2px rgba(26, 26, 26, 0.20)"
      },
      "shadow-400": {
        value: "0px 8px 16px -4px rgba(26, 26, 26, 0.22)"
      },
      "shadow-500": {
        value: "0px 12px 20px -8px rgba(26, 26, 26, 0.24)"
      },
      "shadow-600": {
        value: "0px 20px 20px -8px rgba(26, 26, 26, 0.28)"
      },
      "shadow-bevel-100": {
        value: "1px 0px 0px 0px rgba(0, 0, 0, 0.13) inset, -1px 0px 0px 0px rgba(0, 0, 0, 0.13) inset, 0px -1px 0px 0px rgba(0, 0, 0, 0.17) inset, 0px 1px 0px 0px rgba(204, 204, 204, 0.5) inset"
      },
      "shadow-inset-100": {
        value: "0px 1px 2px 0px rgba(26, 26, 26, 0.15) inset, 0px 1px 1px 0px rgba(26, 26, 26, 0.15) inset"
      },
      "shadow-inset-200": {
        value: "0px 2px 1px 0px rgba(26, 26, 26, 0.20) inset, 1px 0px 1px 0px rgba(26, 26, 26, 0.12) inset, -1px 0px 1px 0px rgba(26, 26, 26, 0.12) inset"
      },
      "shadow-button": {
        value: "0px -1px 0px 0px #b5b5b5 inset, 0px 0px 0px 1px rgba(0, 0, 0, 0.1) inset, 0px 0.5px 0px 1.5px #FFF inset"
      },
      "shadow-button-hover": {
        value: "0px 1px 0px 0px #EBEBEB inset, -1px 0px 0px 0px #EBEBEB inset, 1px 0px 0px 0px #EBEBEB inset, 0px -1px 0px 0px #CCC inset"
      },
      "shadow-button-inset": {
        value: "-1px 0px 1px 0px rgba(26, 26, 26, 0.122) inset, 1px 0px 1px 0px rgba(26, 26, 26, 0.122) inset, 0px 2px 1px 0px rgba(26, 26, 26, 0.2) inset"
      },
      "shadow-button-primary": {
        value: "0px -1px 0px 1px rgba(0, 0, 0, 0.8) inset, 0px 0px 0px 1px rgba(48, 48, 48, 1) inset, 0px 0.5px 0px 1.5px rgba(255, 255, 255, 0.25) inset;"
      },
      "shadow-button-primary-hover": {
        value: "0px 1px 0px 0px rgba(255, 255, 255, 0.24) inset, 1px 0px 0px 0px rgba(255, 255, 255, 0.20) inset, -1px 0px 0px 0px rgba(255, 255, 255, 0.20) inset, 0px -1px 0px 0px #000 inset, 0px -1px 0px 1px #1A1A1A"
      },
      "shadow-button-primary-inset": {
        value: "0px 3px 0px 0px rgb(0, 0, 0) inset"
      },
      "shadow-button-primary-critical": {
        value: "0px -1px 0px 1px rgba(142, 31, 11, 0.8) inset, 0px 0px 0px 1px rgba(181, 38, 11, 0.8) inset, 0px 0.5px 0px 1.5px rgba(255, 255, 255, 0.349) inset"
      },
      "shadow-button-primary-critical-hover": {
        value: "0px 1px 0px 0px rgba(255, 255, 255, 0.48) inset, 1px 0px 0px 0px rgba(255, 255, 255, 0.20) inset, -1px 0px 0px 0px rgba(255, 255, 255, 0.20) inset, 0px -1.5px 0px 0px rgba(0, 0, 0, 0.25) inset"
      },
      "shadow-button-primary-critical-inset": {
        value: "-1px 0px 1px 0px rgba(0, 0, 0, 0.2) inset, 1px 0px 1px 0px rgba(0, 0, 0, 0.2) inset, 0px 2px 0px 0px rgba(0, 0, 0, 0.6) inset"
      },
      "shadow-button-primary-success": {
        value: "0px -1px 0px 1px rgba(12, 81, 50, 0.8) inset, 0px 0px 0px 1px rgba(19, 111, 69, 0.8) inset, 0px 0.5px 0px 1.5px rgba(255, 255, 255, 0.251) inset"
      },
      "shadow-button-primary-success-hover": {
        value: "0px 1px 0px 0px rgba(255, 255, 255, 0.48) inset, 1px 0px 0px 0px rgba(255, 255, 255, 0.20) inset, -1px 0px 0px 0px rgba(255, 255, 255, 0.20) inset, 0px -1.5px 0px 0px rgba(0, 0, 0, 0.25) inset"
      },
      "shadow-button-primary-success-inset": {
        value: "-1px 0px 1px 0px rgba(0, 0, 0, 0.2) inset, 1px 0px 1px 0px rgba(0, 0, 0, 0.2) inset, 0px 2px 0px 0px rgba(0, 0, 0, 0.6) inset"
      },
      "shadow-border-inset": {
        value: "0px 0px 0px 1px rgba(0, 0, 0, 0.08) inset"
      }
    };
    exports.shadow = shadow;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/space.js
var require_space = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/space.js"(exports) {
    "use strict";
    init_cjs_shims();
    var size = require_size(), utils = require_utils8(), space = {
      "space-0": {
        value: size.size[0]
      },
      "space-025": {
        value: size.size["025"]
      },
      "space-050": {
        value: size.size["050"]
      },
      "space-100": {
        value: size.size[100]
      },
      "space-150": {
        value: size.size[150]
      },
      "space-200": {
        value: size.size[200]
      },
      "space-300": {
        value: size.size[300]
      },
      "space-400": {
        value: size.size[400]
      },
      "space-500": {
        value: size.size[500]
      },
      "space-600": {
        value: size.size[600]
      },
      "space-800": {
        value: size.size[800]
      },
      "space-1000": {
        value: size.size[1e3]
      },
      "space-1200": {
        value: size.size[1200]
      },
      "space-1600": {
        value: size.size[1600]
      },
      "space-2000": {
        value: size.size[2e3]
      },
      "space-2400": {
        value: size.size[2400]
      },
      "space-2800": {
        value: size.size[2800]
      },
      "space-3200": {
        value: size.size[3200]
      },
      "space-button-group-gap": {
        value: createVar("space-200")
      },
      "space-card-gap": {
        value: createVar("space-400")
      },
      "space-card-padding": {
        value: createVar("space-400")
      },
      "space-table-cell-padding": {
        value: createVar("space-150")
      }
    };
    function createVar(spaceTokenName) {
      return "var(" + utils.createVarName(spaceTokenName) + ")";
    }
    exports.space = space;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/text.js
var require_text2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/text.js"(exports) {
    "use strict";
    init_cjs_shims();
    var utils = require_utils8(), text = {
      // heading-3xl
      "text-heading-3xl-font-family": {
        value: utils.createVar("font-family-sans")
      },
      "text-heading-3xl-font-size": {
        value: utils.createVar("font-size-900")
      },
      "text-heading-3xl-font-weight": {
        value: utils.createVar("font-weight-bold")
      },
      "text-heading-3xl-font-letter-spacing": {
        value: utils.createVar("font-letter-spacing-densest")
      },
      "text-heading-3xl-font-line-height": {
        value: utils.createVar("font-line-height-1200")
      },
      // heading-2xl
      "text-heading-2xl-font-family": {
        value: utils.createVar("font-family-sans")
      },
      "text-heading-2xl-font-size": {
        value: utils.createVar("font-size-750")
      },
      "text-heading-2xl-font-weight": {
        value: utils.createVar("font-weight-bold")
      },
      "text-heading-2xl-font-letter-spacing": {
        value: utils.createVar("font-letter-spacing-denser")
      },
      "text-heading-2xl-font-line-height": {
        value: utils.createVar("font-line-height-1000")
      },
      // heading-xl
      "text-heading-xl-font-family": {
        value: utils.createVar("font-family-sans")
      },
      "text-heading-xl-font-size": {
        value: utils.createVar("font-size-600")
      },
      "text-heading-xl-font-weight": {
        value: utils.createVar("font-weight-bold")
      },
      "text-heading-xl-font-letter-spacing": {
        value: utils.createVar("font-letter-spacing-dense")
      },
      "text-heading-xl-font-line-height": {
        value: utils.createVar("font-line-height-800")
      },
      // heading-lg
      "text-heading-lg-font-family": {
        value: utils.createVar("font-family-sans")
      },
      "text-heading-lg-font-size": {
        value: utils.createVar("font-size-500")
      },
      "text-heading-lg-font-weight": {
        value: utils.createVar("font-weight-semibold")
      },
      "text-heading-lg-font-letter-spacing": {
        value: utils.createVar("font-letter-spacing-dense")
      },
      "text-heading-lg-font-line-height": {
        value: utils.createVar("font-line-height-600")
      },
      // heading-md
      "text-heading-md-font-family": {
        value: utils.createVar("font-family-sans")
      },
      "text-heading-md-font-size": {
        value: utils.createVar("font-size-350")
      },
      "text-heading-md-font-weight": {
        value: utils.createVar("font-weight-semibold")
      },
      "text-heading-md-font-letter-spacing": {
        value: utils.createVar("font-letter-spacing-normal")
      },
      "text-heading-md-font-line-height": {
        value: utils.createVar("font-line-height-500")
      },
      // heading-sm
      "text-heading-sm-font-family": {
        value: utils.createVar("font-family-sans")
      },
      "text-heading-sm-font-size": {
        value: utils.createVar("font-size-325")
      },
      "text-heading-sm-font-weight": {
        value: utils.createVar("font-weight-semibold")
      },
      "text-heading-sm-font-letter-spacing": {
        value: utils.createVar("font-letter-spacing-normal")
      },
      "text-heading-sm-font-line-height": {
        value: utils.createVar("font-line-height-500")
      },
      // heading-xs
      "text-heading-xs-font-family": {
        value: utils.createVar("font-family-sans")
      },
      "text-heading-xs-font-size": {
        value: utils.createVar("font-size-300")
      },
      "text-heading-xs-font-weight": {
        value: utils.createVar("font-weight-semibold")
      },
      "text-heading-xs-font-letter-spacing": {
        value: utils.createVar("font-letter-spacing-normal")
      },
      "text-heading-xs-font-line-height": {
        value: utils.createVar("font-line-height-400")
      },
      // body-lg
      "text-body-lg-font-family": {
        value: utils.createVar("font-family-sans")
      },
      "text-body-lg-font-size": {
        value: utils.createVar("font-size-350")
      },
      "text-body-lg-font-weight": {
        value: utils.createVar("font-weight-regular")
      },
      "text-body-lg-font-letter-spacing": {
        value: utils.createVar("font-letter-spacing-normal")
      },
      "text-body-lg-font-line-height": {
        value: utils.createVar("font-line-height-500")
      },
      // body-md
      "text-body-md-font-family": {
        value: utils.createVar("font-family-sans")
      },
      "text-body-md-font-size": {
        value: utils.createVar("font-size-325")
      },
      "text-body-md-font-weight": {
        value: utils.createVar("font-weight-regular")
      },
      "text-body-md-font-letter-spacing": {
        value: utils.createVar("font-letter-spacing-normal")
      },
      "text-body-md-font-line-height": {
        value: utils.createVar("font-line-height-500")
      },
      // body-sm
      "text-body-sm-font-family": {
        value: utils.createVar("font-family-sans")
      },
      "text-body-sm-font-size": {
        value: utils.createVar("font-size-300")
      },
      "text-body-sm-font-weight": {
        value: utils.createVar("font-weight-regular")
      },
      "text-body-sm-font-letter-spacing": {
        value: utils.createVar("font-letter-spacing-normal")
      },
      "text-body-sm-font-line-height": {
        value: utils.createVar("font-line-height-400")
      },
      // body-xs
      "text-body-xs-font-family": {
        value: utils.createVar("font-family-sans")
      },
      "text-body-xs-font-size": {
        value: utils.createVar("font-size-275")
      },
      "text-body-xs-font-weight": {
        value: utils.createVar("font-weight-regular")
      },
      "text-body-xs-font-letter-spacing": {
        value: utils.createVar("font-letter-spacing-normal")
      },
      "text-body-xs-font-line-height": {
        value: utils.createVar("font-line-height-300")
      }
    };
    exports.text = text;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/width.js
var require_width = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/width.js"(exports) {
    "use strict";
    init_cjs_shims();
    var size = require_size(), width = {
      "width-0": {
        value: size.size[0]
      },
      "width-025": {
        value: size.size["025"]
      },
      "width-050": {
        value: size.size["050"]
      },
      "width-100": {
        value: size.size[100]
      },
      "width-150": {
        value: size.size[150]
      },
      "width-200": {
        value: size.size[200]
      },
      "width-300": {
        value: size.size[300]
      },
      "width-400": {
        value: size.size[400]
      },
      "width-500": {
        value: size.size[500]
      },
      "width-600": {
        value: size.size[600]
      },
      "width-700": {
        value: size.size[700]
      },
      "width-800": {
        value: size.size[800]
      },
      "width-900": {
        value: size.size[900]
      },
      "width-1000": {
        value: size.size[1e3]
      },
      "width-1200": {
        value: size.size[1200]
      },
      "width-1600": {
        value: size.size[1600]
      },
      "width-2000": {
        value: size.size[2e3]
      },
      "width-2400": {
        value: size.size[2400]
      },
      "width-2800": {
        value: size.size[2800]
      },
      "width-3200": {
        value: size.size[3200]
      }
    };
    exports.width = width;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/zIndex.js
var require_zIndex = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/zIndex.js"(exports) {
    "use strict";
    init_cjs_shims();
    var zIndex = {
      "z-index-0": {
        value: "auto"
      },
      "z-index-1": {
        value: "100"
      },
      "z-index-2": {
        value: "400"
      },
      "z-index-3": {
        value: "510"
      },
      "z-index-4": {
        value: "512"
      },
      "z-index-5": {
        value: "513"
      },
      "z-index-6": {
        value: "514"
      },
      "z-index-7": {
        value: "515"
      },
      "z-index-8": {
        value: "516"
      },
      "z-index-9": {
        value: "517"
      },
      "z-index-10": {
        value: "518"
      },
      "z-index-11": {
        value: "519"
      },
      "z-index-12": {
        value: "520"
      }
    };
    exports.zIndex = zIndex;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/index.js
var require_base = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/base/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var utils = require_utils8(), border = require_border(), breakpoints = require_breakpoints(), color = require_color(), font = require_font(), height = require_height(), motion = require_motion(), shadow = require_shadow(), space = require_space(), text = require_text2(), width = require_width(), zIndex = require_zIndex(), metaThemeBase = utils.createMetaThemeBase({
      border: border.border,
      breakpoints: breakpoints.breakpoints,
      color: color.color,
      font: font.font,
      height: height.height,
      motion: motion.motion,
      shadow: shadow.shadow,
      space: space.space,
      text: text.text,
      width: width.width,
      zIndex: zIndex.zIndex
    });
    exports.metaThemeBase = metaThemeBase;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/utils.js
var require_utils9 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/utils.js"(exports) {
    "use strict";
    init_cjs_shims();
    var _rollupPluginBabelHelpers = require_rollupPluginBabelHelpers(), deepmerge = require_cjs2(), utils = require_utils8(), index = require_base();
    function createMetaThemePartial(metaThemePartial) {
      return Object.fromEntries(Object.entries(metaThemePartial).map(function(_ref) {
        var _ref2 = _rollupPluginBabelHelpers.slicedToArray(_ref, 2), tokenGroupName = _ref2[0], tokenGroup = _ref2[1];
        return [tokenGroupName, tokenGroup && utils.tokenGroupNamesToRems.includes(tokenGroupName) ? utils.tokenGroupToRems(tokenGroup) : tokenGroup];
      }));
    }
    function createMetaTheme(metaThemePartial) {
      return deepmerge(index.metaThemeBase, metaThemePartial);
    }
    function createThemeClassName(themeName) {
      return "p-theme-" + themeName;
    }
    function createIsTokenName(theme) {
      var tokenNames = new Set(utils.getTokenNames(theme));
      return function(tokenName) {
        return tokenNames.has(tokenName);
      };
    }
    createIsTokenName(index.metaThemeBase);
    exports.createIsTokenName = createIsTokenName;
    exports.createMetaTheme = createMetaTheme;
    exports.createMetaThemePartial = createMetaThemePartial;
    exports.createThemeClassName = createThemeClassName;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/constants.js
var require_constants2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/constants.js"(exports) {
    "use strict";
    init_cjs_shims();
    var themeNameLight = "light", themeNameDefault = themeNameLight, themeNames = [themeNameLight, "light-mobile", "light-high-contrast-experimental", "dark-experimental"];
    exports.themeNameDefault = themeNameDefault;
    exports.themeNameLight = themeNameLight;
    exports.themeNames = themeNames;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/light.js
var require_light = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/light.js"(exports) {
    "use strict";
    init_cjs_shims();
    var utils = require_utils9(), metaThemeLightPartial = utils.createMetaThemePartial({}), metaThemeLight = utils.createMetaTheme(metaThemeLightPartial);
    exports.metaThemeLight = metaThemeLight;
    exports.metaThemeLightPartial = metaThemeLightPartial;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/light-high-contrast.js
var require_light_high_contrast = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/light-high-contrast.js"(exports) {
    "use strict";
    init_cjs_shims();
    var colors = require_colors(), utils = require_utils9(), metaThemeLightHighContrastPartial = utils.createMetaThemePartial({
      color: {
        "color-text": {
          value: colors.gray[16]
        },
        "color-text-secondary": {
          value: colors.gray[16]
        },
        "color-text-brand": {
          value: colors.gray[16]
        },
        "color-icon-secondary": {
          value: colors.gray[14]
        },
        "color-border": {
          value: colors.gray[12]
        },
        "color-input-border": {
          value: colors.gray[14]
        },
        "color-border-secondary": {
          value: colors.gray[12]
        },
        "color-bg-surface-secondary": {
          value: colors.gray[6]
        }
      },
      shadow: {
        "shadow-bevel-100": {
          value: "0px 1px 0px 0px rgba(26, 26, 26, 0.07), 0px 1px 0px 0px rgba(208, 208, 208, 0.40) inset, 1px 0px 0px 0px #CCC inset, -1px 0px 0px 0px #CCC inset, 0px -1px 0px 0px #999 inset"
        }
      }
    }), metaThemeLightHighContrast = utils.createMetaTheme(metaThemeLightHighContrastPartial);
    exports.metaThemeLightHighContrast = metaThemeLightHighContrast;
    exports.metaThemeLightHighContrastPartial = metaThemeLightHighContrastPartial;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/light-mobile.js
var require_light_mobile = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/light-mobile.js"(exports) {
    "use strict";
    init_cjs_shims();
    var utils$1 = require_utils8(), utils = require_utils9(), buttonShadow = "0 0 0 " + utils$1.createVar("border-width-025") + " " + utils$1.createVar("color-border") + " inset", metaThemeLightMobilePartial = utils.createMetaThemePartial({
      color: {
        "color-button-gradient-bg-fill": {
          value: "none"
        }
      },
      shadow: {
        "shadow-100": {
          value: "none"
        },
        "shadow-bevel-100": {
          value: "none"
        },
        "shadow-button": {
          value: buttonShadow
        },
        "shadow-button-hover": {
          value: buttonShadow
        },
        "shadow-button-inset": {
          value: buttonShadow
        },
        "shadow-button-primary": {
          value: "none"
        },
        "shadow-button-primary-hover": {
          value: "none"
        },
        "shadow-button-primary-inset": {
          value: "none"
        },
        "shadow-button-primary-critical": {
          value: "none"
        },
        "shadow-button-primary-critical-hover": {
          value: "none"
        },
        "shadow-button-primary-critical-inset": {
          value: "none"
        },
        "shadow-button-primary-success": {
          value: "none"
        },
        "shadow-button-primary-success-hover": {
          value: "none"
        },
        "shadow-button-primary-success-inset": {
          value: "none"
        }
      },
      space: {
        "space-card-gap": {
          value: utils$1.createVar("space-200")
        }
      },
      text: {
        // heading-2xl
        "text-heading-2xl-font-size": {
          value: utils$1.createVar("font-size-800")
        },
        // heading-xl
        "text-heading-xl-font-size": {
          value: utils$1.createVar("font-size-550")
        },
        "text-heading-xl-font-line-height": {
          value: utils$1.createVar("font-line-height-700")
        },
        // heading-lg
        "text-heading-lg-font-size": {
          value: utils$1.createVar("font-size-450")
        },
        // heading-md
        "text-heading-md-font-size": {
          value: utils$1.createVar("font-size-400")
        },
        // heading-sm
        "text-heading-sm-font-size": {
          value: utils$1.createVar("font-size-350")
        },
        // body-lg
        "text-body-lg-font-size": {
          value: utils$1.createVar("font-size-450")
        },
        "text-body-lg-font-line-height": {
          value: utils$1.createVar("font-line-height-700")
        },
        // body-md
        "text-body-md-font-size": {
          value: utils$1.createVar("font-size-400")
        },
        "text-body-md-font-line-height": {
          value: utils$1.createVar("font-line-height-600")
        },
        // body-sm
        "text-body-sm-font-size": {
          value: utils$1.createVar("font-size-350")
        },
        "text-body-sm-font-line-height": {
          value: utils$1.createVar("font-line-height-500")
        },
        // body-xs
        "text-body-xs-font-size": {
          value: utils$1.createVar("font-size-300")
        },
        "text-body-xs-font-line-height": {
          value: utils$1.createVar("font-line-height-400")
        }
      }
    }), metaThemeLightMobile = utils.createMetaTheme(metaThemeLightMobilePartial);
    exports.metaThemeLightMobile = metaThemeLightMobile;
    exports.metaThemeLightMobilePartial = metaThemeLightMobilePartial;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/dark.js
var require_dark = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/dark.js"(exports) {
    "use strict";
    init_cjs_shims();
    var colors = require_colors(), utils = require_utils9(), metaThemeDarkPartial = utils.createMetaThemePartial({
      color: {
        "color-scheme": {
          value: "dark"
        },
        "color-bg": {
          value: colors.gray[16]
        },
        "color-bg-surface": {
          value: colors.gray[15]
        },
        "color-bg-fill": {
          value: colors.gray[15]
        },
        "color-icon": {
          value: colors.gray[8]
        },
        "color-icon-secondary": {
          value: colors.gray[12]
        },
        "color-text": {
          value: colors.gray[8]
        },
        "color-text-secondary": {
          value: colors.gray[11]
        },
        "color-bg-surface-secondary-active": {
          value: colors.gray[13]
        },
        "color-bg-surface-secondary-hover": {
          value: colors.gray[14]
        },
        "color-bg-fill-transparent": {
          value: colors.whiteAlpha[8]
        },
        "color-bg-fill-brand": {
          value: colors.gray[1]
        },
        "color-text-brand-on-bg-fill": {
          value: colors.gray[15]
        },
        "color-bg-surface-hover": {
          value: colors.gray[14]
        },
        "color-bg-fill-hover": {
          value: colors.gray[14]
        },
        "color-bg-fill-transparent-hover": {
          value: colors.whiteAlpha[9]
        },
        "color-bg-fill-brand-hover": {
          value: colors.gray[5]
        },
        "color-bg-surface-selected": {
          value: colors.gray[13]
        },
        "color-bg-fill-selected": {
          value: colors.gray[13]
        },
        "color-bg-fill-transparent-selected": {
          value: colors.whiteAlpha[11]
        },
        "color-bg-fill-brand-selected": {
          value: colors.gray[9]
        },
        "color-bg-surface-active": {
          value: colors.gray[13]
        },
        "color-bg-fill-active": {
          value: colors.gray[13]
        },
        "color-bg-fill-transparent-active": {
          value: colors.whiteAlpha[10]
        },
        "color-bg-fill-brand-active": {
          value: colors.gray[4]
        },
        "color-bg-surface-brand-selected": {
          value: colors.gray[14]
        },
        "color-border-secondary": {
          value: colors.gray[13]
        },
        "color-tooltip-tail-down-border-experimental": {
          value: "rgba(60, 60, 60, 1)"
        },
        "color-tooltip-tail-up-border-experimental": {
          value: "rgba(71, 71, 71, 1)"
        },
        "color-border-gradient-experimental": {
          value: "linear-gradient(to bottom, " + colors.whiteAlpha[9] + ", " + colors.whiteAlpha[4] + ")"
        },
        "color-border-gradient-hover-experimental": {
          value: "linear-gradient(to bottom, " + colors.whiteAlpha[9] + ", " + colors.whiteAlpha[4] + ")"
        },
        "color-border-gradient-selected-experimental": {
          value: "linear-gradient(to bottom, " + colors.blackAlpha[10] + ", " + colors.whiteAlpha[10] + ")"
        },
        "color-border-gradient-active-experimental": {
          value: "linear-gradient(to bottom, " + colors.whiteAlpha[10] + ", " + colors.whiteAlpha[4] + ")"
        }
      },
      shadow: {
        "shadow-bevel-100": {
          value: "1px 0px 0px 0px rgba(204, 204, 204, 0.08) inset, -1px 0px 0px 0px rgba(204, 204, 204, 0.08) inset, 0px -1px 0px 0px rgba(204, 204, 204, 0.08) inset, 0px 1px 0px 0px rgba(204, 204, 204, 0.16) inset"
        }
      }
    }), metaThemeDark = utils.createMetaTheme(metaThemeDarkPartial);
    exports.metaThemeDark = metaThemeDark;
    exports.metaThemeDarkPartial = metaThemeDarkPartial;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/index.js
var require_themes = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/src/themes/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var utils = require_utils9(), constants = require_constants2(), light = require_light(), lightHighContrast = require_light_high_contrast(), lightMobile = require_light_mobile(), dark = require_dark(), metaThemes = {
      light: light.metaThemeLight,
      "light-mobile": lightMobile.metaThemeLightMobile,
      "light-high-contrast-experimental": lightHighContrast.metaThemeLightHighContrast,
      "dark-experimental": dark.metaThemeDark
    }, metaThemePartials = {
      light: light.metaThemeLightPartial,
      "light-mobile": lightMobile.metaThemeLightMobilePartial,
      "light-high-contrast-experimental": lightHighContrast.metaThemeLightHighContrastPartial,
      "dark-experimental": dark.metaThemeDarkPartial
    }, metaThemeDefaultPartial = metaThemePartials[constants.themeNameDefault], metaThemeDefault = utils.createMetaTheme(metaThemeDefaultPartial);
    exports.createMetaTheme = utils.createMetaTheme;
    exports.metaThemeDefault = metaThemeDefault;
    exports.metaThemeDefaultPartial = metaThemeDefaultPartial;
    exports.metaThemePartials = metaThemePartials;
    exports.metaThemes = metaThemes;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/build/index.js
var require_build2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-tokens@8.10.0/node_modules/@shopify/polaris-tokens/dist/cjs/build/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var breakpoints = require_breakpoints(), utils = require_utils8(), index = require_themes(), constants = require_constants2(), utils$1 = require_utils9(), themes = {
      light: {
        border: {
          "border-radius-0": "0rem",
          "border-radius-050": "0.125rem",
          "border-radius-100": "0.25rem",
          "border-radius-150": "0.375rem",
          "border-radius-200": "0.5rem",
          "border-radius-300": "0.75rem",
          "border-radius-400": "1rem",
          "border-radius-500": "1.25rem",
          "border-radius-750": "1.875rem",
          "border-radius-full": "624.9375rem",
          "border-width-0": "0rem",
          "border-width-0165": "0.04125rem",
          "border-width-025": "0.0625rem",
          "border-width-050": "0.125rem",
          "border-width-100": "0.25rem"
        },
        breakpoints: {
          "breakpoints-xs": "0rem",
          "breakpoints-sm": "30.625rem",
          "breakpoints-md": "48rem",
          "breakpoints-lg": "65rem",
          "breakpoints-xl": "90rem"
        },
        color: {
          "color-scheme": "light",
          "color-bg": "rgba(241, 241, 241, 1)",
          "color-bg-inverse": "rgba(26, 26, 26, 1)",
          "color-bg-surface": "rgba(255, 255, 255, 1)",
          "color-bg-surface-hover": "rgba(247, 247, 247, 1)",
          "color-bg-surface-active": "rgba(243, 243, 243, 1)",
          "color-bg-surface-selected": "rgba(241, 241, 241, 1)",
          "color-bg-surface-disabled": "rgba(0, 0, 0, 0.05)",
          "color-bg-surface-secondary": "rgba(247, 247, 247, 1)",
          "color-bg-surface-secondary-hover": "rgba(241, 241, 241, 1)",
          "color-bg-surface-secondary-active": "rgba(235, 235, 235, 1)",
          "color-bg-surface-secondary-selected": "rgba(235, 235, 235, 1)",
          "color-bg-surface-tertiary": "rgba(243, 243, 243, 1)",
          "color-bg-surface-tertiary-hover": "rgba(235, 235, 235, 1)",
          "color-bg-surface-tertiary-active": "rgba(227, 227, 227, 1)",
          "color-bg-surface-brand": "rgba(227, 227, 227, 1)",
          "color-bg-surface-brand-hover": "rgba(235, 235, 235, 1)",
          "color-bg-surface-brand-active": "rgba(241, 241, 241, 1)",
          "color-bg-surface-brand-selected": "rgba(241, 241, 241, 1)",
          "color-bg-surface-info": "rgba(234, 244, 255, 1)",
          "color-bg-surface-info-hover": "rgba(224, 240, 255, 1)",
          "color-bg-surface-info-active": "rgba(202, 230, 255, 1)",
          "color-bg-surface-success": "rgba(205, 254, 225, 1)",
          "color-bg-surface-success-hover": "rgba(180, 254, 210, 1)",
          "color-bg-surface-success-active": "rgba(146, 254, 194, 1)",
          "color-bg-surface-caution": "rgba(255, 248, 219, 1)",
          "color-bg-surface-caution-hover": "rgba(255, 244, 191, 1)",
          "color-bg-surface-caution-active": "rgba(255, 239, 157, 1)",
          "color-bg-surface-warning": "rgba(255, 241, 227, 1)",
          "color-bg-surface-warning-hover": "rgba(255, 235, 213, 1)",
          "color-bg-surface-warning-active": "rgba(255, 228, 198, 1)",
          "color-bg-surface-critical": "rgba(254, 233, 232, 1)",
          "color-bg-surface-critical-hover": "rgba(254, 226, 225, 1)",
          "color-bg-surface-critical-active": "rgba(254, 218, 217, 1)",
          "color-bg-surface-emphasis": "rgba(240, 242, 255, 1)",
          "color-bg-surface-emphasis-hover": "rgba(234, 237, 255, 1)",
          "color-bg-surface-emphasis-active": "rgba(226, 231, 255, 1)",
          "color-bg-surface-magic": "rgba(248, 247, 255, 1)",
          "color-bg-surface-magic-hover": "rgba(243, 241, 255, 1)",
          "color-bg-surface-magic-active": "rgba(233, 229, 255, 1)",
          "color-bg-surface-inverse": "rgba(48, 48, 48, 1)",
          "color-bg-surface-transparent": "rgba(0, 0, 0, 0)",
          "color-bg-fill": "rgba(255, 255, 255, 1)",
          "color-bg-fill-hover": "rgba(250, 250, 250, 1)",
          "color-bg-fill-active": "rgba(247, 247, 247, 1)",
          "color-bg-fill-selected": "rgba(204, 204, 204, 1)",
          "color-bg-fill-disabled": "rgba(0, 0, 0, 0.05)",
          "color-bg-fill-secondary": "rgba(241, 241, 241, 1)",
          "color-bg-fill-secondary-hover": "rgba(235, 235, 235, 1)",
          "color-bg-fill-secondary-active": "rgba(227, 227, 227, 1)",
          "color-bg-fill-tertiary": "rgba(227, 227, 227, 1)",
          "color-bg-fill-tertiary-hover": "rgba(212, 212, 212, 1)",
          "color-bg-fill-tertiary-active": "rgba(204, 204, 204, 1)",
          "color-bg-fill-brand": "rgba(48, 48, 48, 1)",
          "color-bg-fill-brand-hover": "rgba(26, 26, 26, 1)",
          "color-bg-fill-brand-active": "rgba(26, 26, 26, 1)",
          "color-bg-fill-brand-selected": "rgba(48, 48, 48, 1)",
          "color-bg-fill-brand-disabled": "rgba(0, 0, 0, 0.17)",
          "color-bg-fill-info": "rgba(145, 208, 255, 1)",
          "color-bg-fill-info-hover": "rgba(81, 192, 255, 1)",
          "color-bg-fill-info-active": "rgba(0, 148, 213, 1)",
          "color-bg-fill-info-secondary": "rgba(213, 235, 255, 1)",
          "color-bg-fill-success": "rgba(41, 132, 90, 1)",
          "color-bg-fill-success-hover": "rgba(19, 111, 69, 1)",
          "color-bg-fill-success-active": "rgba(12, 81, 50, 1)",
          "color-bg-fill-success-secondary": "rgba(180, 254, 210, 1)",
          "color-bg-fill-warning": "rgba(255, 184, 0, 1)",
          "color-bg-fill-warning-hover": "rgba(229, 165, 0, 1)",
          "color-bg-fill-warning-active": "rgba(178, 132, 0, 1)",
          "color-bg-fill-warning-secondary": "rgba(255, 214, 164, 1)",
          "color-bg-fill-caution": "rgba(255, 230, 0, 1)",
          "color-bg-fill-caution-hover": "rgba(234, 211, 0, 1)",
          "color-bg-fill-caution-active": "rgba(225, 203, 0, 1)",
          "color-bg-fill-caution-secondary": "rgba(255, 235, 120, 1)",
          "color-bg-fill-critical": "rgba(229, 28, 0, 1)",
          "color-bg-fill-critical-hover": "rgba(181, 38, 11, 1)",
          "color-bg-fill-critical-active": "rgba(142, 31, 11, 1)",
          "color-bg-fill-critical-selected": "rgba(142, 31, 11, 1)",
          "color-bg-fill-critical-secondary": "rgba(254, 211, 209, 1)",
          "color-bg-fill-emphasis": "rgba(0, 91, 211, 1)",
          "color-bg-fill-emphasis-hover": "rgba(0, 66, 153, 1)",
          "color-bg-fill-emphasis-active": "rgba(0, 46, 106, 1)",
          "color-bg-fill-magic": "rgba(128, 81, 255, 1)",
          "color-bg-fill-magic-secondary": "rgba(233, 229, 255, 1)",
          "color-bg-fill-magic-secondary-hover": "rgba(228, 222, 255, 1)",
          "color-bg-fill-magic-secondary-active": "rgba(223, 217, 255, 1)",
          "color-bg-fill-inverse": "rgba(48, 48, 48, 1)",
          "color-bg-fill-inverse-hover": "rgba(74, 74, 74, 1)",
          "color-bg-fill-inverse-active": "rgba(97, 97, 97, 1)",
          "color-bg-fill-transparent": "rgba(0, 0, 0, 0.02)",
          "color-bg-fill-transparent-hover": "rgba(0, 0, 0, 0.05)",
          "color-bg-fill-transparent-active": "rgba(0, 0, 0, 0.08)",
          "color-bg-fill-transparent-selected": "rgba(0, 0, 0, 0.08)",
          "color-bg-fill-transparent-secondary": "rgba(0, 0, 0, 0.06)",
          "color-bg-fill-transparent-secondary-hover": "rgba(0, 0, 0, 0.08)",
          "color-bg-fill-transparent-secondary-active": "rgba(0, 0, 0, 0.11)",
          "color-text": "rgba(48, 48, 48, 1)",
          "color-text-secondary": "rgba(97, 97, 97, 1)",
          "color-text-disabled": "rgba(181, 181, 181, 1)",
          "color-text-link": "rgba(0, 91, 211, 1)",
          "color-text-link-hover": "rgba(0, 66, 153, 1)",
          "color-text-link-active": "rgba(0, 46, 106, 1)",
          "color-text-brand": "rgba(74, 74, 74, 1)",
          "color-text-brand-hover": "rgba(48, 48, 48, 1)",
          "color-text-brand-on-bg-fill": "rgba(255, 255, 255, 1)",
          "color-text-brand-on-bg-fill-hover": "rgba(227, 227, 227, 1)",
          "color-text-brand-on-bg-fill-active": "rgba(204, 204, 204, 1)",
          "color-text-brand-on-bg-fill-disabled": "rgba(255, 255, 255, 1)",
          "color-text-info": "rgba(0, 58, 90, 1)",
          "color-text-info-hover": "rgba(0, 58, 90, 1)",
          "color-text-info-active": "rgba(0, 33, 51, 1)",
          "color-text-info-secondary": "rgba(0, 124, 180, 1)",
          "color-text-info-on-bg-fill": "rgba(0, 33, 51, 1)",
          "color-text-success": "rgba(12, 81, 50, 1)",
          "color-text-success-hover": "rgba(8, 61, 37, 1)",
          "color-text-success-active": "rgba(9, 42, 27, 1)",
          "color-text-success-secondary": "rgba(41, 132, 90, 1)",
          "color-text-success-on-bg-fill": "rgba(248, 255, 251, 1)",
          "color-text-caution": "rgba(79, 71, 0, 1)",
          "color-text-caution-hover": "rgba(51, 46, 0, 1)",
          "color-text-caution-active": "rgba(31, 28, 0, 1)",
          "color-text-caution-secondary": "rgba(130, 117, 0, 1)",
          "color-text-caution-on-bg-fill": "rgba(51, 46, 0, 1)",
          "color-text-warning": "rgba(94, 66, 0, 1)",
          "color-text-warning-hover": "rgba(65, 45, 0, 1)",
          "color-text-warning-active": "rgba(37, 26, 0, 1)",
          "color-text-warning-secondary": "rgba(149, 111, 0, 1)",
          "color-text-warning-on-bg-fill": "rgba(37, 26, 0, 1)",
          "color-text-critical": "rgba(142, 31, 11, 1)",
          "color-text-critical-hover": "rgba(95, 21, 7, 1)",
          "color-text-critical-active": "rgba(47, 10, 4, 1)",
          "color-text-critical-secondary": "rgba(229, 28, 0, 1)",
          "color-text-critical-on-bg-fill": "rgba(255, 251, 251, 1)",
          "color-text-emphasis": "rgba(0, 91, 211, 1)",
          "color-text-emphasis-hover": "rgba(0, 66, 153, 1)",
          "color-text-emphasis-active": "rgba(0, 46, 106, 1)",
          "color-text-emphasis-on-bg-fill": "rgba(252, 253, 255, 1)",
          "color-text-emphasis-on-bg-fill-hover": "rgba(226, 231, 255, 1)",
          "color-text-emphasis-on-bg-fill-active": "rgba(213, 220, 255, 1)",
          "color-text-magic": "rgba(87, 0, 209, 1)",
          "color-text-magic-secondary": "rgba(113, 38, 255, 1)",
          "color-text-magic-on-bg-fill": "rgba(253, 253, 255, 1)",
          "color-text-inverse": "rgba(227, 227, 227, 1)",
          "color-text-inverse-secondary": "rgba(181, 181, 181, 1)",
          "color-text-link-inverse": "rgba(197, 208, 255, 1)",
          "color-border": "rgba(227, 227, 227, 1)",
          "color-border-hover": "rgba(204, 204, 204, 1)",
          "color-border-disabled": "rgba(235, 235, 235, 1)",
          "color-border-secondary": "rgba(235, 235, 235, 1)",
          "color-border-tertiary": "rgba(204, 204, 204, 1)",
          "color-border-focus": "rgba(0, 91, 211, 1)",
          "color-border-brand": "rgba(227, 227, 227, 1)",
          "color-border-info": "rgba(168, 216, 255, 1)",
          "color-border-success": "rgba(146, 254, 194, 1)",
          "color-border-caution": "rgba(255, 235, 120, 1)",
          "color-border-warning": "rgba(255, 200, 121, 1)",
          "color-border-critical": "rgba(254, 195, 193, 1)",
          "color-border-critical-secondary": "rgba(142, 31, 11, 1)",
          "color-border-emphasis": "rgba(0, 91, 211, 1)",
          "color-border-emphasis-hover": "rgba(0, 66, 153, 1)",
          "color-border-emphasis-active": "rgba(0, 46, 106, 1)",
          "color-border-magic": "rgba(228, 222, 255, 1)",
          "color-border-magic-secondary": "rgba(148, 116, 255, 1)",
          "color-border-magic-secondary-hover": "rgba(128, 81, 255, 1)",
          "color-border-inverse": "rgba(97, 97, 97, 1)",
          "color-border-inverse-hover": "rgba(204, 204, 204, 1)",
          "color-border-inverse-active": "rgba(227, 227, 227, 1)",
          "color-tooltip-tail-down-border-experimental": "rgba(212, 212, 212, 1)",
          "color-tooltip-tail-up-border-experimental": "rgba(227, 227, 227, 1)",
          "color-border-gradient-experimental": "linear-gradient(to bottom, rgba(235, 235, 235, 1), rgba(204, 204, 204, 1) 78%, rgba(181, 181, 181, 1))",
          "color-border-gradient-hover-experimental": "linear-gradient(to bottom, rgba(235, 235, 235, 1), rgba(204, 204, 204, 1) 78%, rgba(181, 181, 181, 1))",
          "color-border-gradient-selected-experimental": "linear-gradient(to bottom, rgba(235, 235, 235, 1), rgba(204, 204, 204, 1) 78%, rgba(181, 181, 181, 1))",
          "color-border-gradient-active-experimental": "linear-gradient(to bottom, rgba(235, 235, 235, 1), rgba(204, 204, 204, 1) 78%, rgba(181, 181, 181, 1))",
          "color-icon": "rgba(74, 74, 74, 1)",
          "color-icon-hover": "rgba(48, 48, 48, 1)",
          "color-icon-active": "rgba(26, 26, 26, 1)",
          "color-icon-disabled": "rgba(204, 204, 204, 1)",
          "color-icon-secondary": "rgba(138, 138, 138, 1)",
          "color-icon-secondary-hover": "rgba(97, 97, 97, 1)",
          "color-icon-secondary-active": "rgba(74, 74, 74, 1)",
          "color-icon-brand": "rgba(26, 26, 26, 1)",
          "color-icon-info": "rgba(0, 148, 213, 1)",
          "color-icon-success": "rgba(41, 132, 90, 1)",
          "color-icon-caution": "rgba(153, 138, 0, 1)",
          "color-icon-warning": "rgba(178, 132, 0, 1)",
          "color-icon-critical": "rgba(239, 77, 47, 1)",
          "color-icon-emphasis": "rgba(0, 91, 211, 1)",
          "color-icon-emphasis-hover": "rgba(0, 66, 153, 1)",
          "color-icon-emphasis-active": "rgba(0, 46, 106, 1)",
          "color-icon-magic": "rgba(128, 81, 255, 1)",
          "color-icon-inverse": "rgba(227, 227, 227, 1)",
          "color-avatar-bg-fill": "rgba(181, 181, 181, 1)",
          "color-avatar-five-bg-fill": "rgba(253, 75, 146, 1)",
          "color-avatar-five-text-on-bg-fill": "rgba(255, 246, 248, 1)",
          "color-avatar-four-bg-fill": "rgba(81, 192, 255, 1)",
          "color-avatar-four-text-on-bg-fill": "rgba(0, 33, 51, 1)",
          "color-avatar-one-bg-fill": "rgba(197, 48, 197, 1)",
          "color-avatar-one-text-on-bg-fill": "rgba(253, 239, 253, 1)",
          "color-avatar-seven-bg-fill": "rgba(148, 116, 255, 1)",
          "color-avatar-seven-text-on-bg-fill": "rgba(248, 247, 255, 1)",
          "color-avatar-six-bg-fill": "rgba(37, 232, 43, 1)",
          "color-avatar-six-text-on-bg-fill": "rgba(3, 61, 5, 1)",
          "color-avatar-text-on-bg-fill": "rgba(255, 255, 255, 1)",
          "color-avatar-three-bg-fill": "rgba(44, 224, 212, 1)",
          "color-avatar-three-text-on-bg-fill": "rgba(3, 60, 57, 1)",
          "color-avatar-two-bg-fill": "rgba(56, 250, 163, 1)",
          "color-avatar-two-text-on-bg-fill": "rgba(12, 81, 50, 1)",
          "color-backdrop-bg": "rgba(0, 0, 0, 0.71)",
          "color-button-gradient-bg-fill": "linear-gradient(180deg, rgba(48, 48, 48, 0) 63.53%, rgba(255, 255, 255, 0.15) 100%)",
          "color-checkbox-bg-surface-disabled": "rgba(0, 0, 0, 0.08)",
          "color-checkbox-icon-disabled": "rgba(255, 255, 255, 1)",
          "color-input-bg-surface": "rgba(253, 253, 253, 1)",
          "color-input-bg-surface-hover": "rgba(250, 250, 250, 1)",
          "color-input-bg-surface-active": "rgba(247, 247, 247, 1)",
          "color-input-border": "rgba(138, 138, 138, 1)",
          "color-input-border-hover": "rgba(97, 97, 97, 1)",
          "color-input-border-active": "rgba(26, 26, 26, 1)",
          "color-nav-bg": "rgba(235, 235, 235, 1)",
          "color-nav-bg-surface": "rgba(0, 0, 0, 0.02)",
          "color-nav-bg-surface-hover": "rgba(241, 241, 241, 1)",
          "color-nav-bg-surface-active": "rgba(250, 250, 250, 1)",
          "color-nav-bg-surface-selected": "rgba(250, 250, 250, 1)",
          "color-radio-button-bg-surface-disabled": "rgba(0, 0, 0, 0.08)",
          "color-radio-button-icon-disabled": "rgba(255, 255, 255, 1)",
          "color-video-thumbnail-play-button-bg-fill-hover": "rgba(0, 0, 0, 0.81)",
          "color-video-thumbnail-play-button-bg-fill": "rgba(0, 0, 0, 0.71)",
          "color-video-thumbnail-play-button-text-on-bg-fill": "rgba(255, 255, 255, 1)",
          "color-scrollbar-thumb-bg-hover": "rgba(138, 138, 138, 1)"
        },
        font: {
          "font-family-sans": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "font-family-mono": "ui-monospace, SFMono-Regular, 'SF Mono', Consolas, 'Liberation Mono', Menlo, monospace",
          "font-size-275": "0.6875rem",
          "font-size-300": "0.75rem",
          "font-size-325": "0.8125rem",
          "font-size-350": "0.875rem",
          "font-size-400": "1rem",
          "font-size-450": "1.125rem",
          "font-size-500": "1.25rem",
          "font-size-550": "1.375rem",
          "font-size-600": "1.5rem",
          "font-size-750": "1.875rem",
          "font-size-800": "2rem",
          "font-size-900": "2.25rem",
          "font-size-1000": "2.5rem",
          "font-weight-regular": "450",
          "font-weight-medium": "550",
          "font-weight-semibold": "650",
          "font-weight-bold": "700",
          "font-letter-spacing-densest": "-0.03375rem",
          "font-letter-spacing-denser": "-0.01875rem",
          "font-letter-spacing-dense": "-0.0125rem",
          "font-letter-spacing-normal": "0rem",
          "font-line-height-300": "0.75rem",
          "font-line-height-400": "1rem",
          "font-line-height-500": "1.25rem",
          "font-line-height-600": "1.5rem",
          "font-line-height-700": "1.75rem",
          "font-line-height-800": "2rem",
          "font-line-height-1000": "2.5rem",
          "font-line-height-1200": "3rem"
        },
        height: {
          "height-0": "0rem",
          "height-025": "0.0625rem",
          "height-050": "0.125rem",
          "height-100": "0.25rem",
          "height-150": "0.375rem",
          "height-200": "0.5rem",
          "height-300": "0.75rem",
          "height-400": "1rem",
          "height-500": "1.25rem",
          "height-600": "1.5rem",
          "height-700": "1.75rem",
          "height-800": "2rem",
          "height-900": "2.25rem",
          "height-1000": "2.5rem",
          "height-1200": "3rem",
          "height-1600": "4rem",
          "height-2000": "5rem",
          "height-2400": "6rem",
          "height-2800": "7rem",
          "height-3200": "8rem"
        },
        motion: {
          "motion-duration-0": "0ms",
          "motion-duration-50": "50ms",
          "motion-duration-100": "100ms",
          "motion-duration-150": "150ms",
          "motion-duration-200": "200ms",
          "motion-duration-250": "250ms",
          "motion-duration-300": "300ms",
          "motion-duration-350": "350ms",
          "motion-duration-400": "400ms",
          "motion-duration-450": "450ms",
          "motion-duration-500": "500ms",
          "motion-duration-5000": "5000ms",
          "motion-ease": "cubic-bezier(0.25, 0.1, 0.25, 1)",
          "motion-ease-in": "cubic-bezier(0.42, 0, 1, 1)",
          "motion-ease-out": "cubic-bezier(0.19, 0.91, 0.38, 1)",
          "motion-ease-in-out": "cubic-bezier(0.42, 0, 0.58, 1)",
          "motion-linear": "cubic-bezier(0, 0, 1, 1)",
          "motion-keyframes-bounce": "{ from, 65%, 85% { transform: scale(1) } 75% { transform: scale(0.85) } 82.5% { transform: scale(1.05) } }",
          "motion-keyframes-fade-in": "{ to { opacity: 1 } }",
          "motion-keyframes-pulse": "{ from, 75% { transform: scale(0.85); opacity: 1; } to { transform: scale(2.5); opacity: 0; } }",
          "motion-keyframes-spin": "{ to { transform: rotate(1turn) } }",
          "motion-keyframes-appear-above": "{ from { transform: translateY(var(--p-space-100)); opacity: 0; } to { transform: none; opacity: 1; } }",
          "motion-keyframes-appear-below": "{ from { transform: translateY(calc(var(--p-space-100) * -1)); opacity: 0; } to { transform: none; opacity: 1; } }"
        },
        shadow: {
          "shadow-0": "none",
          "shadow-100": "0rem 0.0625rem 0rem 0rem rgba(26, 26, 26, 0.07)",
          "shadow-200": "0rem 0.1875rem 0.0625rem -0.0625rem rgba(26, 26, 26, 0.07)",
          "shadow-300": "0rem 0.25rem 0.375rem -0.125rem rgba(26, 26, 26, 0.20)",
          "shadow-400": "0rem 0.5rem 1rem -0.25rem rgba(26, 26, 26, 0.22)",
          "shadow-500": "0rem 0.75rem 1.25rem -0.5rem rgba(26, 26, 26, 0.24)",
          "shadow-600": "0rem 1.25rem 1.25rem -0.5rem rgba(26, 26, 26, 0.28)",
          "shadow-bevel-100": "0.0625rem 0rem 0rem 0rem rgba(0, 0, 0, 0.13) inset, -0.0625rem 0rem 0rem 0rem rgba(0, 0, 0, 0.13) inset, 0rem -0.0625rem 0rem 0rem rgba(0, 0, 0, 0.17) inset, 0rem 0.0625rem 0rem 0rem rgba(204, 204, 204, 0.5) inset",
          "shadow-inset-100": "0rem 0.0625rem 0.125rem 0rem rgba(26, 26, 26, 0.15) inset, 0rem 0.0625rem 0.0625rem 0rem rgba(26, 26, 26, 0.15) inset",
          "shadow-inset-200": "0rem 0.125rem 0.0625rem 0rem rgba(26, 26, 26, 0.20) inset, 0.0625rem 0rem 0.0625rem 0rem rgba(26, 26, 26, 0.12) inset, -0.0625rem 0rem 0.0625rem 0rem rgba(26, 26, 26, 0.12) inset",
          "shadow-button": "0rem -0.0625rem 0rem 0rem #b5b5b5 inset, 0rem 0rem 0rem 0.0625rem rgba(0, 0, 0, 0.1) inset, 0rem 0.03125rem 0rem 0.09375rem #FFF inset",
          "shadow-button-hover": "0rem 0.0625rem 0rem 0rem #EBEBEB inset, -0.0625rem 0rem 0rem 0rem #EBEBEB inset, 0.0625rem 0rem 0rem 0rem #EBEBEB inset, 0rem -0.0625rem 0rem 0rem #CCC inset",
          "shadow-button-inset": "-0.0625rem 0rem 0.0625rem 0rem rgba(26, 26, 26, 0.122) inset, 0.0625rem 0rem 0.0625rem 0rem rgba(26, 26, 26, 0.122) inset, 0rem 0.125rem 0.0625rem 0rem rgba(26, 26, 26, 0.2) inset",
          "shadow-button-primary": "0rem -0.0625rem 0rem 0.0625rem rgba(0, 0, 0, 0.8) inset, 0rem 0rem 0rem 0.0625rem rgba(48, 48, 48, 1) inset, 0rem 0.03125rem 0rem 0.09375rem rgba(255, 255, 255, 0.25) inset;",
          "shadow-button-primary-hover": "0rem 0.0625rem 0rem 0rem rgba(255, 255, 255, 0.24) inset, 0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, -0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, 0rem -0.0625rem 0rem 0rem #000 inset, 0rem -0.0625rem 0rem 0.0625rem #1A1A1A",
          "shadow-button-primary-inset": "0rem 0.1875rem 0rem 0rem rgb(0, 0, 0) inset",
          "shadow-button-primary-critical": "0rem -0.0625rem 0rem 0.0625rem rgba(142, 31, 11, 0.8) inset, 0rem 0rem 0rem 0.0625rem rgba(181, 38, 11, 0.8) inset, 0rem 0.03125rem 0rem 0.09375rem rgba(255, 255, 255, 0.349) inset",
          "shadow-button-primary-critical-hover": "0rem 0.0625rem 0rem 0rem rgba(255, 255, 255, 0.48) inset, 0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, -0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, 0rem -0.09375rem 0rem 0rem rgba(0, 0, 0, 0.25) inset",
          "shadow-button-primary-critical-inset": "-0.0625rem 0rem 0.0625rem 0rem rgba(0, 0, 0, 0.2) inset, 0.0625rem 0rem 0.0625rem 0rem rgba(0, 0, 0, 0.2) inset, 0rem 0.125rem 0rem 0rem rgba(0, 0, 0, 0.6) inset",
          "shadow-button-primary-success": "0rem -0.0625rem 0rem 0.0625rem rgba(12, 81, 50, 0.8) inset, 0rem 0rem 0rem 0.0625rem rgba(19, 111, 69, 0.8) inset, 0rem 0.03125rem 0rem 0.09375rem rgba(255, 255, 255, 0.251) inset",
          "shadow-button-primary-success-hover": "0rem 0.0625rem 0rem 0rem rgba(255, 255, 255, 0.48) inset, 0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, -0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, 0rem -0.09375rem 0rem 0rem rgba(0, 0, 0, 0.25) inset",
          "shadow-button-primary-success-inset": "-0.0625rem 0rem 0.0625rem 0rem rgba(0, 0, 0, 0.2) inset, 0.0625rem 0rem 0.0625rem 0rem rgba(0, 0, 0, 0.2) inset, 0rem 0.125rem 0rem 0rem rgba(0, 0, 0, 0.6) inset",
          "shadow-border-inset": "0rem 0rem 0rem 0.0625rem rgba(0, 0, 0, 0.08) inset"
        },
        space: {
          "space-0": "0rem",
          "space-025": "0.0625rem",
          "space-050": "0.125rem",
          "space-100": "0.25rem",
          "space-150": "0.375rem",
          "space-200": "0.5rem",
          "space-300": "0.75rem",
          "space-400": "1rem",
          "space-500": "1.25rem",
          "space-600": "1.5rem",
          "space-800": "2rem",
          "space-1000": "2.5rem",
          "space-1200": "3rem",
          "space-1600": "4rem",
          "space-2000": "5rem",
          "space-2400": "6rem",
          "space-2800": "7rem",
          "space-3200": "8rem",
          "space-button-group-gap": "0.5rem",
          "space-card-gap": "1rem",
          "space-card-padding": "1rem",
          "space-table-cell-padding": "0.375rem"
        },
        text: {
          "text-heading-3xl-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-3xl-font-size": "2.25rem",
          "text-heading-3xl-font-weight": "700",
          "text-heading-3xl-font-letter-spacing": "-0.03375rem",
          "text-heading-3xl-font-line-height": "3rem",
          "text-heading-2xl-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-2xl-font-size": "1.875rem",
          "text-heading-2xl-font-weight": "700",
          "text-heading-2xl-font-letter-spacing": "-0.01875rem",
          "text-heading-2xl-font-line-height": "2.5rem",
          "text-heading-xl-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-xl-font-size": "1.5rem",
          "text-heading-xl-font-weight": "700",
          "text-heading-xl-font-letter-spacing": "-0.0125rem",
          "text-heading-xl-font-line-height": "2rem",
          "text-heading-lg-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-lg-font-size": "1.25rem",
          "text-heading-lg-font-weight": "650",
          "text-heading-lg-font-letter-spacing": "-0.0125rem",
          "text-heading-lg-font-line-height": "1.5rem",
          "text-heading-md-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-md-font-size": "0.875rem",
          "text-heading-md-font-weight": "650",
          "text-heading-md-font-letter-spacing": "0rem",
          "text-heading-md-font-line-height": "1.25rem",
          "text-heading-sm-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-sm-font-size": "0.8125rem",
          "text-heading-sm-font-weight": "650",
          "text-heading-sm-font-letter-spacing": "0rem",
          "text-heading-sm-font-line-height": "1.25rem",
          "text-heading-xs-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-xs-font-size": "0.75rem",
          "text-heading-xs-font-weight": "650",
          "text-heading-xs-font-letter-spacing": "0rem",
          "text-heading-xs-font-line-height": "1rem",
          "text-body-lg-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-body-lg-font-size": "0.875rem",
          "text-body-lg-font-weight": "450",
          "text-body-lg-font-letter-spacing": "0rem",
          "text-body-lg-font-line-height": "1.25rem",
          "text-body-md-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-body-md-font-size": "0.8125rem",
          "text-body-md-font-weight": "450",
          "text-body-md-font-letter-spacing": "0rem",
          "text-body-md-font-line-height": "1.25rem",
          "text-body-sm-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-body-sm-font-size": "0.75rem",
          "text-body-sm-font-weight": "450",
          "text-body-sm-font-letter-spacing": "0rem",
          "text-body-sm-font-line-height": "1rem",
          "text-body-xs-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-body-xs-font-size": "0.6875rem",
          "text-body-xs-font-weight": "450",
          "text-body-xs-font-letter-spacing": "0rem",
          "text-body-xs-font-line-height": "0.75rem"
        },
        width: {
          "width-0": "0rem",
          "width-025": "0.0625rem",
          "width-050": "0.125rem",
          "width-100": "0.25rem",
          "width-150": "0.375rem",
          "width-200": "0.5rem",
          "width-300": "0.75rem",
          "width-400": "1rem",
          "width-500": "1.25rem",
          "width-600": "1.5rem",
          "width-700": "1.75rem",
          "width-800": "2rem",
          "width-900": "2.25rem",
          "width-1000": "2.5rem",
          "width-1200": "3rem",
          "width-1600": "4rem",
          "width-2000": "5rem",
          "width-2400": "6rem",
          "width-2800": "7rem",
          "width-3200": "8rem"
        },
        zIndex: {
          "z-index-0": "auto",
          "z-index-1": "100",
          "z-index-2": "400",
          "z-index-3": "510",
          "z-index-4": "512",
          "z-index-5": "513",
          "z-index-6": "514",
          "z-index-7": "515",
          "z-index-8": "516",
          "z-index-9": "517",
          "z-index-10": "518",
          "z-index-11": "519",
          "z-index-12": "520"
        }
      },
      "light-mobile": {
        border: {
          "border-radius-0": "0rem",
          "border-radius-050": "0.125rem",
          "border-radius-100": "0.25rem",
          "border-radius-150": "0.375rem",
          "border-radius-200": "0.5rem",
          "border-radius-300": "0.75rem",
          "border-radius-400": "1rem",
          "border-radius-500": "1.25rem",
          "border-radius-750": "1.875rem",
          "border-radius-full": "624.9375rem",
          "border-width-0": "0rem",
          "border-width-0165": "0.04125rem",
          "border-width-025": "0.0625rem",
          "border-width-050": "0.125rem",
          "border-width-100": "0.25rem"
        },
        breakpoints: {
          "breakpoints-xs": "0rem",
          "breakpoints-sm": "30.625rem",
          "breakpoints-md": "48rem",
          "breakpoints-lg": "65rem",
          "breakpoints-xl": "90rem"
        },
        color: {
          "color-scheme": "light",
          "color-bg": "rgba(241, 241, 241, 1)",
          "color-bg-inverse": "rgba(26, 26, 26, 1)",
          "color-bg-surface": "rgba(255, 255, 255, 1)",
          "color-bg-surface-hover": "rgba(247, 247, 247, 1)",
          "color-bg-surface-active": "rgba(243, 243, 243, 1)",
          "color-bg-surface-selected": "rgba(241, 241, 241, 1)",
          "color-bg-surface-disabled": "rgba(0, 0, 0, 0.05)",
          "color-bg-surface-secondary": "rgba(247, 247, 247, 1)",
          "color-bg-surface-secondary-hover": "rgba(241, 241, 241, 1)",
          "color-bg-surface-secondary-active": "rgba(235, 235, 235, 1)",
          "color-bg-surface-secondary-selected": "rgba(235, 235, 235, 1)",
          "color-bg-surface-tertiary": "rgba(243, 243, 243, 1)",
          "color-bg-surface-tertiary-hover": "rgba(235, 235, 235, 1)",
          "color-bg-surface-tertiary-active": "rgba(227, 227, 227, 1)",
          "color-bg-surface-brand": "rgba(227, 227, 227, 1)",
          "color-bg-surface-brand-hover": "rgba(235, 235, 235, 1)",
          "color-bg-surface-brand-active": "rgba(241, 241, 241, 1)",
          "color-bg-surface-brand-selected": "rgba(241, 241, 241, 1)",
          "color-bg-surface-info": "rgba(234, 244, 255, 1)",
          "color-bg-surface-info-hover": "rgba(224, 240, 255, 1)",
          "color-bg-surface-info-active": "rgba(202, 230, 255, 1)",
          "color-bg-surface-success": "rgba(205, 254, 225, 1)",
          "color-bg-surface-success-hover": "rgba(180, 254, 210, 1)",
          "color-bg-surface-success-active": "rgba(146, 254, 194, 1)",
          "color-bg-surface-caution": "rgba(255, 248, 219, 1)",
          "color-bg-surface-caution-hover": "rgba(255, 244, 191, 1)",
          "color-bg-surface-caution-active": "rgba(255, 239, 157, 1)",
          "color-bg-surface-warning": "rgba(255, 241, 227, 1)",
          "color-bg-surface-warning-hover": "rgba(255, 235, 213, 1)",
          "color-bg-surface-warning-active": "rgba(255, 228, 198, 1)",
          "color-bg-surface-critical": "rgba(254, 233, 232, 1)",
          "color-bg-surface-critical-hover": "rgba(254, 226, 225, 1)",
          "color-bg-surface-critical-active": "rgba(254, 218, 217, 1)",
          "color-bg-surface-emphasis": "rgba(240, 242, 255, 1)",
          "color-bg-surface-emphasis-hover": "rgba(234, 237, 255, 1)",
          "color-bg-surface-emphasis-active": "rgba(226, 231, 255, 1)",
          "color-bg-surface-magic": "rgba(248, 247, 255, 1)",
          "color-bg-surface-magic-hover": "rgba(243, 241, 255, 1)",
          "color-bg-surface-magic-active": "rgba(233, 229, 255, 1)",
          "color-bg-surface-inverse": "rgba(48, 48, 48, 1)",
          "color-bg-surface-transparent": "rgba(0, 0, 0, 0)",
          "color-bg-fill": "rgba(255, 255, 255, 1)",
          "color-bg-fill-hover": "rgba(250, 250, 250, 1)",
          "color-bg-fill-active": "rgba(247, 247, 247, 1)",
          "color-bg-fill-selected": "rgba(204, 204, 204, 1)",
          "color-bg-fill-disabled": "rgba(0, 0, 0, 0.05)",
          "color-bg-fill-secondary": "rgba(241, 241, 241, 1)",
          "color-bg-fill-secondary-hover": "rgba(235, 235, 235, 1)",
          "color-bg-fill-secondary-active": "rgba(227, 227, 227, 1)",
          "color-bg-fill-tertiary": "rgba(227, 227, 227, 1)",
          "color-bg-fill-tertiary-hover": "rgba(212, 212, 212, 1)",
          "color-bg-fill-tertiary-active": "rgba(204, 204, 204, 1)",
          "color-bg-fill-brand": "rgba(48, 48, 48, 1)",
          "color-bg-fill-brand-hover": "rgba(26, 26, 26, 1)",
          "color-bg-fill-brand-active": "rgba(26, 26, 26, 1)",
          "color-bg-fill-brand-selected": "rgba(48, 48, 48, 1)",
          "color-bg-fill-brand-disabled": "rgba(0, 0, 0, 0.17)",
          "color-bg-fill-info": "rgba(145, 208, 255, 1)",
          "color-bg-fill-info-hover": "rgba(81, 192, 255, 1)",
          "color-bg-fill-info-active": "rgba(0, 148, 213, 1)",
          "color-bg-fill-info-secondary": "rgba(213, 235, 255, 1)",
          "color-bg-fill-success": "rgba(41, 132, 90, 1)",
          "color-bg-fill-success-hover": "rgba(19, 111, 69, 1)",
          "color-bg-fill-success-active": "rgba(12, 81, 50, 1)",
          "color-bg-fill-success-secondary": "rgba(180, 254, 210, 1)",
          "color-bg-fill-warning": "rgba(255, 184, 0, 1)",
          "color-bg-fill-warning-hover": "rgba(229, 165, 0, 1)",
          "color-bg-fill-warning-active": "rgba(178, 132, 0, 1)",
          "color-bg-fill-warning-secondary": "rgba(255, 214, 164, 1)",
          "color-bg-fill-caution": "rgba(255, 230, 0, 1)",
          "color-bg-fill-caution-hover": "rgba(234, 211, 0, 1)",
          "color-bg-fill-caution-active": "rgba(225, 203, 0, 1)",
          "color-bg-fill-caution-secondary": "rgba(255, 235, 120, 1)",
          "color-bg-fill-critical": "rgba(229, 28, 0, 1)",
          "color-bg-fill-critical-hover": "rgba(181, 38, 11, 1)",
          "color-bg-fill-critical-active": "rgba(142, 31, 11, 1)",
          "color-bg-fill-critical-selected": "rgba(142, 31, 11, 1)",
          "color-bg-fill-critical-secondary": "rgba(254, 211, 209, 1)",
          "color-bg-fill-emphasis": "rgba(0, 91, 211, 1)",
          "color-bg-fill-emphasis-hover": "rgba(0, 66, 153, 1)",
          "color-bg-fill-emphasis-active": "rgba(0, 46, 106, 1)",
          "color-bg-fill-magic": "rgba(128, 81, 255, 1)",
          "color-bg-fill-magic-secondary": "rgba(233, 229, 255, 1)",
          "color-bg-fill-magic-secondary-hover": "rgba(228, 222, 255, 1)",
          "color-bg-fill-magic-secondary-active": "rgba(223, 217, 255, 1)",
          "color-bg-fill-inverse": "rgba(48, 48, 48, 1)",
          "color-bg-fill-inverse-hover": "rgba(74, 74, 74, 1)",
          "color-bg-fill-inverse-active": "rgba(97, 97, 97, 1)",
          "color-bg-fill-transparent": "rgba(0, 0, 0, 0.02)",
          "color-bg-fill-transparent-hover": "rgba(0, 0, 0, 0.05)",
          "color-bg-fill-transparent-active": "rgba(0, 0, 0, 0.08)",
          "color-bg-fill-transparent-selected": "rgba(0, 0, 0, 0.08)",
          "color-bg-fill-transparent-secondary": "rgba(0, 0, 0, 0.06)",
          "color-bg-fill-transparent-secondary-hover": "rgba(0, 0, 0, 0.08)",
          "color-bg-fill-transparent-secondary-active": "rgba(0, 0, 0, 0.11)",
          "color-text": "rgba(48, 48, 48, 1)",
          "color-text-secondary": "rgba(97, 97, 97, 1)",
          "color-text-disabled": "rgba(181, 181, 181, 1)",
          "color-text-link": "rgba(0, 91, 211, 1)",
          "color-text-link-hover": "rgba(0, 66, 153, 1)",
          "color-text-link-active": "rgba(0, 46, 106, 1)",
          "color-text-brand": "rgba(74, 74, 74, 1)",
          "color-text-brand-hover": "rgba(48, 48, 48, 1)",
          "color-text-brand-on-bg-fill": "rgba(255, 255, 255, 1)",
          "color-text-brand-on-bg-fill-hover": "rgba(227, 227, 227, 1)",
          "color-text-brand-on-bg-fill-active": "rgba(204, 204, 204, 1)",
          "color-text-brand-on-bg-fill-disabled": "rgba(255, 255, 255, 1)",
          "color-text-info": "rgba(0, 58, 90, 1)",
          "color-text-info-hover": "rgba(0, 58, 90, 1)",
          "color-text-info-active": "rgba(0, 33, 51, 1)",
          "color-text-info-secondary": "rgba(0, 124, 180, 1)",
          "color-text-info-on-bg-fill": "rgba(0, 33, 51, 1)",
          "color-text-success": "rgba(12, 81, 50, 1)",
          "color-text-success-hover": "rgba(8, 61, 37, 1)",
          "color-text-success-active": "rgba(9, 42, 27, 1)",
          "color-text-success-secondary": "rgba(41, 132, 90, 1)",
          "color-text-success-on-bg-fill": "rgba(248, 255, 251, 1)",
          "color-text-caution": "rgba(79, 71, 0, 1)",
          "color-text-caution-hover": "rgba(51, 46, 0, 1)",
          "color-text-caution-active": "rgba(31, 28, 0, 1)",
          "color-text-caution-secondary": "rgba(130, 117, 0, 1)",
          "color-text-caution-on-bg-fill": "rgba(51, 46, 0, 1)",
          "color-text-warning": "rgba(94, 66, 0, 1)",
          "color-text-warning-hover": "rgba(65, 45, 0, 1)",
          "color-text-warning-active": "rgba(37, 26, 0, 1)",
          "color-text-warning-secondary": "rgba(149, 111, 0, 1)",
          "color-text-warning-on-bg-fill": "rgba(37, 26, 0, 1)",
          "color-text-critical": "rgba(142, 31, 11, 1)",
          "color-text-critical-hover": "rgba(95, 21, 7, 1)",
          "color-text-critical-active": "rgba(47, 10, 4, 1)",
          "color-text-critical-secondary": "rgba(229, 28, 0, 1)",
          "color-text-critical-on-bg-fill": "rgba(255, 251, 251, 1)",
          "color-text-emphasis": "rgba(0, 91, 211, 1)",
          "color-text-emphasis-hover": "rgba(0, 66, 153, 1)",
          "color-text-emphasis-active": "rgba(0, 46, 106, 1)",
          "color-text-emphasis-on-bg-fill": "rgba(252, 253, 255, 1)",
          "color-text-emphasis-on-bg-fill-hover": "rgba(226, 231, 255, 1)",
          "color-text-emphasis-on-bg-fill-active": "rgba(213, 220, 255, 1)",
          "color-text-magic": "rgba(87, 0, 209, 1)",
          "color-text-magic-secondary": "rgba(113, 38, 255, 1)",
          "color-text-magic-on-bg-fill": "rgba(253, 253, 255, 1)",
          "color-text-inverse": "rgba(227, 227, 227, 1)",
          "color-text-inverse-secondary": "rgba(181, 181, 181, 1)",
          "color-text-link-inverse": "rgba(197, 208, 255, 1)",
          "color-border": "rgba(227, 227, 227, 1)",
          "color-border-hover": "rgba(204, 204, 204, 1)",
          "color-border-disabled": "rgba(235, 235, 235, 1)",
          "color-border-secondary": "rgba(235, 235, 235, 1)",
          "color-border-tertiary": "rgba(204, 204, 204, 1)",
          "color-border-focus": "rgba(0, 91, 211, 1)",
          "color-border-brand": "rgba(227, 227, 227, 1)",
          "color-border-info": "rgba(168, 216, 255, 1)",
          "color-border-success": "rgba(146, 254, 194, 1)",
          "color-border-caution": "rgba(255, 235, 120, 1)",
          "color-border-warning": "rgba(255, 200, 121, 1)",
          "color-border-critical": "rgba(254, 195, 193, 1)",
          "color-border-critical-secondary": "rgba(142, 31, 11, 1)",
          "color-border-emphasis": "rgba(0, 91, 211, 1)",
          "color-border-emphasis-hover": "rgba(0, 66, 153, 1)",
          "color-border-emphasis-active": "rgba(0, 46, 106, 1)",
          "color-border-magic": "rgba(228, 222, 255, 1)",
          "color-border-magic-secondary": "rgba(148, 116, 255, 1)",
          "color-border-magic-secondary-hover": "rgba(128, 81, 255, 1)",
          "color-border-inverse": "rgba(97, 97, 97, 1)",
          "color-border-inverse-hover": "rgba(204, 204, 204, 1)",
          "color-border-inverse-active": "rgba(227, 227, 227, 1)",
          "color-tooltip-tail-down-border-experimental": "rgba(212, 212, 212, 1)",
          "color-tooltip-tail-up-border-experimental": "rgba(227, 227, 227, 1)",
          "color-border-gradient-experimental": "linear-gradient(to bottom, rgba(235, 235, 235, 1), rgba(204, 204, 204, 1) 78%, rgba(181, 181, 181, 1))",
          "color-border-gradient-hover-experimental": "linear-gradient(to bottom, rgba(235, 235, 235, 1), rgba(204, 204, 204, 1) 78%, rgba(181, 181, 181, 1))",
          "color-border-gradient-selected-experimental": "linear-gradient(to bottom, rgba(235, 235, 235, 1), rgba(204, 204, 204, 1) 78%, rgba(181, 181, 181, 1))",
          "color-border-gradient-active-experimental": "linear-gradient(to bottom, rgba(235, 235, 235, 1), rgba(204, 204, 204, 1) 78%, rgba(181, 181, 181, 1))",
          "color-icon": "rgba(74, 74, 74, 1)",
          "color-icon-hover": "rgba(48, 48, 48, 1)",
          "color-icon-active": "rgba(26, 26, 26, 1)",
          "color-icon-disabled": "rgba(204, 204, 204, 1)",
          "color-icon-secondary": "rgba(138, 138, 138, 1)",
          "color-icon-secondary-hover": "rgba(97, 97, 97, 1)",
          "color-icon-secondary-active": "rgba(74, 74, 74, 1)",
          "color-icon-brand": "rgba(26, 26, 26, 1)",
          "color-icon-info": "rgba(0, 148, 213, 1)",
          "color-icon-success": "rgba(41, 132, 90, 1)",
          "color-icon-caution": "rgba(153, 138, 0, 1)",
          "color-icon-warning": "rgba(178, 132, 0, 1)",
          "color-icon-critical": "rgba(239, 77, 47, 1)",
          "color-icon-emphasis": "rgba(0, 91, 211, 1)",
          "color-icon-emphasis-hover": "rgba(0, 66, 153, 1)",
          "color-icon-emphasis-active": "rgba(0, 46, 106, 1)",
          "color-icon-magic": "rgba(128, 81, 255, 1)",
          "color-icon-inverse": "rgba(227, 227, 227, 1)",
          "color-avatar-bg-fill": "rgba(181, 181, 181, 1)",
          "color-avatar-five-bg-fill": "rgba(253, 75, 146, 1)",
          "color-avatar-five-text-on-bg-fill": "rgba(255, 246, 248, 1)",
          "color-avatar-four-bg-fill": "rgba(81, 192, 255, 1)",
          "color-avatar-four-text-on-bg-fill": "rgba(0, 33, 51, 1)",
          "color-avatar-one-bg-fill": "rgba(197, 48, 197, 1)",
          "color-avatar-one-text-on-bg-fill": "rgba(253, 239, 253, 1)",
          "color-avatar-seven-bg-fill": "rgba(148, 116, 255, 1)",
          "color-avatar-seven-text-on-bg-fill": "rgba(248, 247, 255, 1)",
          "color-avatar-six-bg-fill": "rgba(37, 232, 43, 1)",
          "color-avatar-six-text-on-bg-fill": "rgba(3, 61, 5, 1)",
          "color-avatar-text-on-bg-fill": "rgba(255, 255, 255, 1)",
          "color-avatar-three-bg-fill": "rgba(44, 224, 212, 1)",
          "color-avatar-three-text-on-bg-fill": "rgba(3, 60, 57, 1)",
          "color-avatar-two-bg-fill": "rgba(56, 250, 163, 1)",
          "color-avatar-two-text-on-bg-fill": "rgba(12, 81, 50, 1)",
          "color-backdrop-bg": "rgba(0, 0, 0, 0.71)",
          "color-button-gradient-bg-fill": "none",
          "color-checkbox-bg-surface-disabled": "rgba(0, 0, 0, 0.08)",
          "color-checkbox-icon-disabled": "rgba(255, 255, 255, 1)",
          "color-input-bg-surface": "rgba(253, 253, 253, 1)",
          "color-input-bg-surface-hover": "rgba(250, 250, 250, 1)",
          "color-input-bg-surface-active": "rgba(247, 247, 247, 1)",
          "color-input-border": "rgba(138, 138, 138, 1)",
          "color-input-border-hover": "rgba(97, 97, 97, 1)",
          "color-input-border-active": "rgba(26, 26, 26, 1)",
          "color-nav-bg": "rgba(235, 235, 235, 1)",
          "color-nav-bg-surface": "rgba(0, 0, 0, 0.02)",
          "color-nav-bg-surface-hover": "rgba(241, 241, 241, 1)",
          "color-nav-bg-surface-active": "rgba(250, 250, 250, 1)",
          "color-nav-bg-surface-selected": "rgba(250, 250, 250, 1)",
          "color-radio-button-bg-surface-disabled": "rgba(0, 0, 0, 0.08)",
          "color-radio-button-icon-disabled": "rgba(255, 255, 255, 1)",
          "color-video-thumbnail-play-button-bg-fill-hover": "rgba(0, 0, 0, 0.81)",
          "color-video-thumbnail-play-button-bg-fill": "rgba(0, 0, 0, 0.71)",
          "color-video-thumbnail-play-button-text-on-bg-fill": "rgba(255, 255, 255, 1)",
          "color-scrollbar-thumb-bg-hover": "rgba(138, 138, 138, 1)"
        },
        font: {
          "font-family-sans": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "font-family-mono": "ui-monospace, SFMono-Regular, 'SF Mono', Consolas, 'Liberation Mono', Menlo, monospace",
          "font-size-275": "0.6875rem",
          "font-size-300": "0.75rem",
          "font-size-325": "0.8125rem",
          "font-size-350": "0.875rem",
          "font-size-400": "1rem",
          "font-size-450": "1.125rem",
          "font-size-500": "1.25rem",
          "font-size-550": "1.375rem",
          "font-size-600": "1.5rem",
          "font-size-750": "1.875rem",
          "font-size-800": "2rem",
          "font-size-900": "2.25rem",
          "font-size-1000": "2.5rem",
          "font-weight-regular": "450",
          "font-weight-medium": "550",
          "font-weight-semibold": "650",
          "font-weight-bold": "700",
          "font-letter-spacing-densest": "-0.03375rem",
          "font-letter-spacing-denser": "-0.01875rem",
          "font-letter-spacing-dense": "-0.0125rem",
          "font-letter-spacing-normal": "0rem",
          "font-line-height-300": "0.75rem",
          "font-line-height-400": "1rem",
          "font-line-height-500": "1.25rem",
          "font-line-height-600": "1.5rem",
          "font-line-height-700": "1.75rem",
          "font-line-height-800": "2rem",
          "font-line-height-1000": "2.5rem",
          "font-line-height-1200": "3rem"
        },
        height: {
          "height-0": "0rem",
          "height-025": "0.0625rem",
          "height-050": "0.125rem",
          "height-100": "0.25rem",
          "height-150": "0.375rem",
          "height-200": "0.5rem",
          "height-300": "0.75rem",
          "height-400": "1rem",
          "height-500": "1.25rem",
          "height-600": "1.5rem",
          "height-700": "1.75rem",
          "height-800": "2rem",
          "height-900": "2.25rem",
          "height-1000": "2.5rem",
          "height-1200": "3rem",
          "height-1600": "4rem",
          "height-2000": "5rem",
          "height-2400": "6rem",
          "height-2800": "7rem",
          "height-3200": "8rem"
        },
        motion: {
          "motion-duration-0": "0ms",
          "motion-duration-50": "50ms",
          "motion-duration-100": "100ms",
          "motion-duration-150": "150ms",
          "motion-duration-200": "200ms",
          "motion-duration-250": "250ms",
          "motion-duration-300": "300ms",
          "motion-duration-350": "350ms",
          "motion-duration-400": "400ms",
          "motion-duration-450": "450ms",
          "motion-duration-500": "500ms",
          "motion-duration-5000": "5000ms",
          "motion-ease": "cubic-bezier(0.25, 0.1, 0.25, 1)",
          "motion-ease-in": "cubic-bezier(0.42, 0, 1, 1)",
          "motion-ease-out": "cubic-bezier(0.19, 0.91, 0.38, 1)",
          "motion-ease-in-out": "cubic-bezier(0.42, 0, 0.58, 1)",
          "motion-linear": "cubic-bezier(0, 0, 1, 1)",
          "motion-keyframes-bounce": "{ from, 65%, 85% { transform: scale(1) } 75% { transform: scale(0.85) } 82.5% { transform: scale(1.05) } }",
          "motion-keyframes-fade-in": "{ to { opacity: 1 } }",
          "motion-keyframes-pulse": "{ from, 75% { transform: scale(0.85); opacity: 1; } to { transform: scale(2.5); opacity: 0; } }",
          "motion-keyframes-spin": "{ to { transform: rotate(1turn) } }",
          "motion-keyframes-appear-above": "{ from { transform: translateY(var(--p-space-100)); opacity: 0; } to { transform: none; opacity: 1; } }",
          "motion-keyframes-appear-below": "{ from { transform: translateY(calc(var(--p-space-100) * -1)); opacity: 0; } to { transform: none; opacity: 1; } }"
        },
        shadow: {
          "shadow-0": "none",
          "shadow-100": "none",
          "shadow-200": "0rem 0.1875rem 0.0625rem -0.0625rem rgba(26, 26, 26, 0.07)",
          "shadow-300": "0rem 0.25rem 0.375rem -0.125rem rgba(26, 26, 26, 0.20)",
          "shadow-400": "0rem 0.5rem 1rem -0.25rem rgba(26, 26, 26, 0.22)",
          "shadow-500": "0rem 0.75rem 1.25rem -0.5rem rgba(26, 26, 26, 0.24)",
          "shadow-600": "0rem 1.25rem 1.25rem -0.5rem rgba(26, 26, 26, 0.28)",
          "shadow-bevel-100": "none",
          "shadow-inset-100": "0rem 0.0625rem 0.125rem 0rem rgba(26, 26, 26, 0.15) inset, 0rem 0.0625rem 0.0625rem 0rem rgba(26, 26, 26, 0.15) inset",
          "shadow-inset-200": "0rem 0.125rem 0.0625rem 0rem rgba(26, 26, 26, 0.20) inset, 0.0625rem 0rem 0.0625rem 0rem rgba(26, 26, 26, 0.12) inset, -0.0625rem 0rem 0.0625rem 0rem rgba(26, 26, 26, 0.12) inset",
          "shadow-button": "0 0 0 var(--p-border-width-025) var(--p-color-border) inset",
          "shadow-button-hover": "0 0 0 var(--p-border-width-025) var(--p-color-border) inset",
          "shadow-button-inset": "0 0 0 var(--p-border-width-025) var(--p-color-border) inset",
          "shadow-button-primary": "none",
          "shadow-button-primary-hover": "none",
          "shadow-button-primary-inset": "none",
          "shadow-button-primary-critical": "none",
          "shadow-button-primary-critical-hover": "none",
          "shadow-button-primary-critical-inset": "none",
          "shadow-button-primary-success": "none",
          "shadow-button-primary-success-hover": "none",
          "shadow-button-primary-success-inset": "none",
          "shadow-border-inset": "0rem 0rem 0rem 0.0625rem rgba(0, 0, 0, 0.08) inset"
        },
        space: {
          "space-0": "0rem",
          "space-025": "0.0625rem",
          "space-050": "0.125rem",
          "space-100": "0.25rem",
          "space-150": "0.375rem",
          "space-200": "0.5rem",
          "space-300": "0.75rem",
          "space-400": "1rem",
          "space-500": "1.25rem",
          "space-600": "1.5rem",
          "space-800": "2rem",
          "space-1000": "2.5rem",
          "space-1200": "3rem",
          "space-1600": "4rem",
          "space-2000": "5rem",
          "space-2400": "6rem",
          "space-2800": "7rem",
          "space-3200": "8rem",
          "space-button-group-gap": "0.5rem",
          "space-card-gap": "0.5rem",
          "space-card-padding": "1rem",
          "space-table-cell-padding": "0.375rem"
        },
        text: {
          "text-heading-3xl-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-3xl-font-size": "2.25rem",
          "text-heading-3xl-font-weight": "700",
          "text-heading-3xl-font-letter-spacing": "-0.03375rem",
          "text-heading-3xl-font-line-height": "3rem",
          "text-heading-2xl-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-2xl-font-size": "2rem",
          "text-heading-2xl-font-weight": "700",
          "text-heading-2xl-font-letter-spacing": "-0.01875rem",
          "text-heading-2xl-font-line-height": "2.5rem",
          "text-heading-xl-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-xl-font-size": "1.375rem",
          "text-heading-xl-font-weight": "700",
          "text-heading-xl-font-letter-spacing": "-0.0125rem",
          "text-heading-xl-font-line-height": "1.75rem",
          "text-heading-lg-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-lg-font-size": "1.125rem",
          "text-heading-lg-font-weight": "650",
          "text-heading-lg-font-letter-spacing": "-0.0125rem",
          "text-heading-lg-font-line-height": "1.5rem",
          "text-heading-md-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-md-font-size": "1rem",
          "text-heading-md-font-weight": "650",
          "text-heading-md-font-letter-spacing": "0rem",
          "text-heading-md-font-line-height": "1.25rem",
          "text-heading-sm-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-sm-font-size": "0.875rem",
          "text-heading-sm-font-weight": "650",
          "text-heading-sm-font-letter-spacing": "0rem",
          "text-heading-sm-font-line-height": "1.25rem",
          "text-heading-xs-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-xs-font-size": "0.75rem",
          "text-heading-xs-font-weight": "650",
          "text-heading-xs-font-letter-spacing": "0rem",
          "text-heading-xs-font-line-height": "1rem",
          "text-body-lg-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-body-lg-font-size": "1.125rem",
          "text-body-lg-font-weight": "450",
          "text-body-lg-font-letter-spacing": "0rem",
          "text-body-lg-font-line-height": "1.75rem",
          "text-body-md-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-body-md-font-size": "1rem",
          "text-body-md-font-weight": "450",
          "text-body-md-font-letter-spacing": "0rem",
          "text-body-md-font-line-height": "1.5rem",
          "text-body-sm-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-body-sm-font-size": "0.875rem",
          "text-body-sm-font-weight": "450",
          "text-body-sm-font-letter-spacing": "0rem",
          "text-body-sm-font-line-height": "1.25rem",
          "text-body-xs-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-body-xs-font-size": "0.75rem",
          "text-body-xs-font-weight": "450",
          "text-body-xs-font-letter-spacing": "0rem",
          "text-body-xs-font-line-height": "1rem"
        },
        width: {
          "width-0": "0rem",
          "width-025": "0.0625rem",
          "width-050": "0.125rem",
          "width-100": "0.25rem",
          "width-150": "0.375rem",
          "width-200": "0.5rem",
          "width-300": "0.75rem",
          "width-400": "1rem",
          "width-500": "1.25rem",
          "width-600": "1.5rem",
          "width-700": "1.75rem",
          "width-800": "2rem",
          "width-900": "2.25rem",
          "width-1000": "2.5rem",
          "width-1200": "3rem",
          "width-1600": "4rem",
          "width-2000": "5rem",
          "width-2400": "6rem",
          "width-2800": "7rem",
          "width-3200": "8rem"
        },
        zIndex: {
          "z-index-0": "auto",
          "z-index-1": "100",
          "z-index-2": "400",
          "z-index-3": "510",
          "z-index-4": "512",
          "z-index-5": "513",
          "z-index-6": "514",
          "z-index-7": "515",
          "z-index-8": "516",
          "z-index-9": "517",
          "z-index-10": "518",
          "z-index-11": "519",
          "z-index-12": "520"
        }
      },
      "light-high-contrast-experimental": {
        border: {
          "border-radius-0": "0rem",
          "border-radius-050": "0.125rem",
          "border-radius-100": "0.25rem",
          "border-radius-150": "0.375rem",
          "border-radius-200": "0.5rem",
          "border-radius-300": "0.75rem",
          "border-radius-400": "1rem",
          "border-radius-500": "1.25rem",
          "border-radius-750": "1.875rem",
          "border-radius-full": "624.9375rem",
          "border-width-0": "0rem",
          "border-width-0165": "0.04125rem",
          "border-width-025": "0.0625rem",
          "border-width-050": "0.125rem",
          "border-width-100": "0.25rem"
        },
        breakpoints: {
          "breakpoints-xs": "0rem",
          "breakpoints-sm": "30.625rem",
          "breakpoints-md": "48rem",
          "breakpoints-lg": "65rem",
          "breakpoints-xl": "90rem"
        },
        color: {
          "color-scheme": "light",
          "color-bg": "rgba(241, 241, 241, 1)",
          "color-bg-inverse": "rgba(26, 26, 26, 1)",
          "color-bg-surface": "rgba(255, 255, 255, 1)",
          "color-bg-surface-hover": "rgba(247, 247, 247, 1)",
          "color-bg-surface-active": "rgba(243, 243, 243, 1)",
          "color-bg-surface-selected": "rgba(241, 241, 241, 1)",
          "color-bg-surface-disabled": "rgba(0, 0, 0, 0.05)",
          "color-bg-surface-secondary": "rgba(241, 241, 241, 1)",
          "color-bg-surface-secondary-hover": "rgba(241, 241, 241, 1)",
          "color-bg-surface-secondary-active": "rgba(235, 235, 235, 1)",
          "color-bg-surface-secondary-selected": "rgba(235, 235, 235, 1)",
          "color-bg-surface-tertiary": "rgba(243, 243, 243, 1)",
          "color-bg-surface-tertiary-hover": "rgba(235, 235, 235, 1)",
          "color-bg-surface-tertiary-active": "rgba(227, 227, 227, 1)",
          "color-bg-surface-brand": "rgba(227, 227, 227, 1)",
          "color-bg-surface-brand-hover": "rgba(235, 235, 235, 1)",
          "color-bg-surface-brand-active": "rgba(241, 241, 241, 1)",
          "color-bg-surface-brand-selected": "rgba(241, 241, 241, 1)",
          "color-bg-surface-info": "rgba(234, 244, 255, 1)",
          "color-bg-surface-info-hover": "rgba(224, 240, 255, 1)",
          "color-bg-surface-info-active": "rgba(202, 230, 255, 1)",
          "color-bg-surface-success": "rgba(205, 254, 225, 1)",
          "color-bg-surface-success-hover": "rgba(180, 254, 210, 1)",
          "color-bg-surface-success-active": "rgba(146, 254, 194, 1)",
          "color-bg-surface-caution": "rgba(255, 248, 219, 1)",
          "color-bg-surface-caution-hover": "rgba(255, 244, 191, 1)",
          "color-bg-surface-caution-active": "rgba(255, 239, 157, 1)",
          "color-bg-surface-warning": "rgba(255, 241, 227, 1)",
          "color-bg-surface-warning-hover": "rgba(255, 235, 213, 1)",
          "color-bg-surface-warning-active": "rgba(255, 228, 198, 1)",
          "color-bg-surface-critical": "rgba(254, 233, 232, 1)",
          "color-bg-surface-critical-hover": "rgba(254, 226, 225, 1)",
          "color-bg-surface-critical-active": "rgba(254, 218, 217, 1)",
          "color-bg-surface-emphasis": "rgba(240, 242, 255, 1)",
          "color-bg-surface-emphasis-hover": "rgba(234, 237, 255, 1)",
          "color-bg-surface-emphasis-active": "rgba(226, 231, 255, 1)",
          "color-bg-surface-magic": "rgba(248, 247, 255, 1)",
          "color-bg-surface-magic-hover": "rgba(243, 241, 255, 1)",
          "color-bg-surface-magic-active": "rgba(233, 229, 255, 1)",
          "color-bg-surface-inverse": "rgba(48, 48, 48, 1)",
          "color-bg-surface-transparent": "rgba(0, 0, 0, 0)",
          "color-bg-fill": "rgba(255, 255, 255, 1)",
          "color-bg-fill-hover": "rgba(250, 250, 250, 1)",
          "color-bg-fill-active": "rgba(247, 247, 247, 1)",
          "color-bg-fill-selected": "rgba(204, 204, 204, 1)",
          "color-bg-fill-disabled": "rgba(0, 0, 0, 0.05)",
          "color-bg-fill-secondary": "rgba(241, 241, 241, 1)",
          "color-bg-fill-secondary-hover": "rgba(235, 235, 235, 1)",
          "color-bg-fill-secondary-active": "rgba(227, 227, 227, 1)",
          "color-bg-fill-tertiary": "rgba(227, 227, 227, 1)",
          "color-bg-fill-tertiary-hover": "rgba(212, 212, 212, 1)",
          "color-bg-fill-tertiary-active": "rgba(204, 204, 204, 1)",
          "color-bg-fill-brand": "rgba(48, 48, 48, 1)",
          "color-bg-fill-brand-hover": "rgba(26, 26, 26, 1)",
          "color-bg-fill-brand-active": "rgba(26, 26, 26, 1)",
          "color-bg-fill-brand-selected": "rgba(48, 48, 48, 1)",
          "color-bg-fill-brand-disabled": "rgba(0, 0, 0, 0.17)",
          "color-bg-fill-info": "rgba(145, 208, 255, 1)",
          "color-bg-fill-info-hover": "rgba(81, 192, 255, 1)",
          "color-bg-fill-info-active": "rgba(0, 148, 213, 1)",
          "color-bg-fill-info-secondary": "rgba(213, 235, 255, 1)",
          "color-bg-fill-success": "rgba(41, 132, 90, 1)",
          "color-bg-fill-success-hover": "rgba(19, 111, 69, 1)",
          "color-bg-fill-success-active": "rgba(12, 81, 50, 1)",
          "color-bg-fill-success-secondary": "rgba(180, 254, 210, 1)",
          "color-bg-fill-warning": "rgba(255, 184, 0, 1)",
          "color-bg-fill-warning-hover": "rgba(229, 165, 0, 1)",
          "color-bg-fill-warning-active": "rgba(178, 132, 0, 1)",
          "color-bg-fill-warning-secondary": "rgba(255, 214, 164, 1)",
          "color-bg-fill-caution": "rgba(255, 230, 0, 1)",
          "color-bg-fill-caution-hover": "rgba(234, 211, 0, 1)",
          "color-bg-fill-caution-active": "rgba(225, 203, 0, 1)",
          "color-bg-fill-caution-secondary": "rgba(255, 235, 120, 1)",
          "color-bg-fill-critical": "rgba(229, 28, 0, 1)",
          "color-bg-fill-critical-hover": "rgba(181, 38, 11, 1)",
          "color-bg-fill-critical-active": "rgba(142, 31, 11, 1)",
          "color-bg-fill-critical-selected": "rgba(142, 31, 11, 1)",
          "color-bg-fill-critical-secondary": "rgba(254, 211, 209, 1)",
          "color-bg-fill-emphasis": "rgba(0, 91, 211, 1)",
          "color-bg-fill-emphasis-hover": "rgba(0, 66, 153, 1)",
          "color-bg-fill-emphasis-active": "rgba(0, 46, 106, 1)",
          "color-bg-fill-magic": "rgba(128, 81, 255, 1)",
          "color-bg-fill-magic-secondary": "rgba(233, 229, 255, 1)",
          "color-bg-fill-magic-secondary-hover": "rgba(228, 222, 255, 1)",
          "color-bg-fill-magic-secondary-active": "rgba(223, 217, 255, 1)",
          "color-bg-fill-inverse": "rgba(48, 48, 48, 1)",
          "color-bg-fill-inverse-hover": "rgba(74, 74, 74, 1)",
          "color-bg-fill-inverse-active": "rgba(97, 97, 97, 1)",
          "color-bg-fill-transparent": "rgba(0, 0, 0, 0.02)",
          "color-bg-fill-transparent-hover": "rgba(0, 0, 0, 0.05)",
          "color-bg-fill-transparent-active": "rgba(0, 0, 0, 0.08)",
          "color-bg-fill-transparent-selected": "rgba(0, 0, 0, 0.08)",
          "color-bg-fill-transparent-secondary": "rgba(0, 0, 0, 0.06)",
          "color-bg-fill-transparent-secondary-hover": "rgba(0, 0, 0, 0.08)",
          "color-bg-fill-transparent-secondary-active": "rgba(0, 0, 0, 0.11)",
          "color-text": "rgba(26, 26, 26, 1)",
          "color-text-secondary": "rgba(26, 26, 26, 1)",
          "color-text-disabled": "rgba(181, 181, 181, 1)",
          "color-text-link": "rgba(0, 91, 211, 1)",
          "color-text-link-hover": "rgba(0, 66, 153, 1)",
          "color-text-link-active": "rgba(0, 46, 106, 1)",
          "color-text-brand": "rgba(26, 26, 26, 1)",
          "color-text-brand-hover": "rgba(48, 48, 48, 1)",
          "color-text-brand-on-bg-fill": "rgba(255, 255, 255, 1)",
          "color-text-brand-on-bg-fill-hover": "rgba(227, 227, 227, 1)",
          "color-text-brand-on-bg-fill-active": "rgba(204, 204, 204, 1)",
          "color-text-brand-on-bg-fill-disabled": "rgba(255, 255, 255, 1)",
          "color-text-info": "rgba(0, 58, 90, 1)",
          "color-text-info-hover": "rgba(0, 58, 90, 1)",
          "color-text-info-active": "rgba(0, 33, 51, 1)",
          "color-text-info-secondary": "rgba(0, 124, 180, 1)",
          "color-text-info-on-bg-fill": "rgba(0, 33, 51, 1)",
          "color-text-success": "rgba(12, 81, 50, 1)",
          "color-text-success-hover": "rgba(8, 61, 37, 1)",
          "color-text-success-active": "rgba(9, 42, 27, 1)",
          "color-text-success-secondary": "rgba(41, 132, 90, 1)",
          "color-text-success-on-bg-fill": "rgba(248, 255, 251, 1)",
          "color-text-caution": "rgba(79, 71, 0, 1)",
          "color-text-caution-hover": "rgba(51, 46, 0, 1)",
          "color-text-caution-active": "rgba(31, 28, 0, 1)",
          "color-text-caution-secondary": "rgba(130, 117, 0, 1)",
          "color-text-caution-on-bg-fill": "rgba(51, 46, 0, 1)",
          "color-text-warning": "rgba(94, 66, 0, 1)",
          "color-text-warning-hover": "rgba(65, 45, 0, 1)",
          "color-text-warning-active": "rgba(37, 26, 0, 1)",
          "color-text-warning-secondary": "rgba(149, 111, 0, 1)",
          "color-text-warning-on-bg-fill": "rgba(37, 26, 0, 1)",
          "color-text-critical": "rgba(142, 31, 11, 1)",
          "color-text-critical-hover": "rgba(95, 21, 7, 1)",
          "color-text-critical-active": "rgba(47, 10, 4, 1)",
          "color-text-critical-secondary": "rgba(229, 28, 0, 1)",
          "color-text-critical-on-bg-fill": "rgba(255, 251, 251, 1)",
          "color-text-emphasis": "rgba(0, 91, 211, 1)",
          "color-text-emphasis-hover": "rgba(0, 66, 153, 1)",
          "color-text-emphasis-active": "rgba(0, 46, 106, 1)",
          "color-text-emphasis-on-bg-fill": "rgba(252, 253, 255, 1)",
          "color-text-emphasis-on-bg-fill-hover": "rgba(226, 231, 255, 1)",
          "color-text-emphasis-on-bg-fill-active": "rgba(213, 220, 255, 1)",
          "color-text-magic": "rgba(87, 0, 209, 1)",
          "color-text-magic-secondary": "rgba(113, 38, 255, 1)",
          "color-text-magic-on-bg-fill": "rgba(253, 253, 255, 1)",
          "color-text-inverse": "rgba(227, 227, 227, 1)",
          "color-text-inverse-secondary": "rgba(181, 181, 181, 1)",
          "color-text-link-inverse": "rgba(197, 208, 255, 1)",
          "color-border": "rgba(138, 138, 138, 1)",
          "color-border-hover": "rgba(204, 204, 204, 1)",
          "color-border-disabled": "rgba(235, 235, 235, 1)",
          "color-border-secondary": "rgba(138, 138, 138, 1)",
          "color-border-tertiary": "rgba(204, 204, 204, 1)",
          "color-border-focus": "rgba(0, 91, 211, 1)",
          "color-border-brand": "rgba(227, 227, 227, 1)",
          "color-border-info": "rgba(168, 216, 255, 1)",
          "color-border-success": "rgba(146, 254, 194, 1)",
          "color-border-caution": "rgba(255, 235, 120, 1)",
          "color-border-warning": "rgba(255, 200, 121, 1)",
          "color-border-critical": "rgba(254, 195, 193, 1)",
          "color-border-critical-secondary": "rgba(142, 31, 11, 1)",
          "color-border-emphasis": "rgba(0, 91, 211, 1)",
          "color-border-emphasis-hover": "rgba(0, 66, 153, 1)",
          "color-border-emphasis-active": "rgba(0, 46, 106, 1)",
          "color-border-magic": "rgba(228, 222, 255, 1)",
          "color-border-magic-secondary": "rgba(148, 116, 255, 1)",
          "color-border-magic-secondary-hover": "rgba(128, 81, 255, 1)",
          "color-border-inverse": "rgba(97, 97, 97, 1)",
          "color-border-inverse-hover": "rgba(204, 204, 204, 1)",
          "color-border-inverse-active": "rgba(227, 227, 227, 1)",
          "color-tooltip-tail-down-border-experimental": "rgba(212, 212, 212, 1)",
          "color-tooltip-tail-up-border-experimental": "rgba(227, 227, 227, 1)",
          "color-border-gradient-experimental": "linear-gradient(to bottom, rgba(235, 235, 235, 1), rgba(204, 204, 204, 1) 78%, rgba(181, 181, 181, 1))",
          "color-border-gradient-hover-experimental": "linear-gradient(to bottom, rgba(235, 235, 235, 1), rgba(204, 204, 204, 1) 78%, rgba(181, 181, 181, 1))",
          "color-border-gradient-selected-experimental": "linear-gradient(to bottom, rgba(235, 235, 235, 1), rgba(204, 204, 204, 1) 78%, rgba(181, 181, 181, 1))",
          "color-border-gradient-active-experimental": "linear-gradient(to bottom, rgba(235, 235, 235, 1), rgba(204, 204, 204, 1) 78%, rgba(181, 181, 181, 1))",
          "color-icon": "rgba(74, 74, 74, 1)",
          "color-icon-hover": "rgba(48, 48, 48, 1)",
          "color-icon-active": "rgba(26, 26, 26, 1)",
          "color-icon-disabled": "rgba(204, 204, 204, 1)",
          "color-icon-secondary": "rgba(74, 74, 74, 1)",
          "color-icon-secondary-hover": "rgba(97, 97, 97, 1)",
          "color-icon-secondary-active": "rgba(74, 74, 74, 1)",
          "color-icon-brand": "rgba(26, 26, 26, 1)",
          "color-icon-info": "rgba(0, 148, 213, 1)",
          "color-icon-success": "rgba(41, 132, 90, 1)",
          "color-icon-caution": "rgba(153, 138, 0, 1)",
          "color-icon-warning": "rgba(178, 132, 0, 1)",
          "color-icon-critical": "rgba(239, 77, 47, 1)",
          "color-icon-emphasis": "rgba(0, 91, 211, 1)",
          "color-icon-emphasis-hover": "rgba(0, 66, 153, 1)",
          "color-icon-emphasis-active": "rgba(0, 46, 106, 1)",
          "color-icon-magic": "rgba(128, 81, 255, 1)",
          "color-icon-inverse": "rgba(227, 227, 227, 1)",
          "color-avatar-bg-fill": "rgba(181, 181, 181, 1)",
          "color-avatar-five-bg-fill": "rgba(253, 75, 146, 1)",
          "color-avatar-five-text-on-bg-fill": "rgba(255, 246, 248, 1)",
          "color-avatar-four-bg-fill": "rgba(81, 192, 255, 1)",
          "color-avatar-four-text-on-bg-fill": "rgba(0, 33, 51, 1)",
          "color-avatar-one-bg-fill": "rgba(197, 48, 197, 1)",
          "color-avatar-one-text-on-bg-fill": "rgba(253, 239, 253, 1)",
          "color-avatar-seven-bg-fill": "rgba(148, 116, 255, 1)",
          "color-avatar-seven-text-on-bg-fill": "rgba(248, 247, 255, 1)",
          "color-avatar-six-bg-fill": "rgba(37, 232, 43, 1)",
          "color-avatar-six-text-on-bg-fill": "rgba(3, 61, 5, 1)",
          "color-avatar-text-on-bg-fill": "rgba(255, 255, 255, 1)",
          "color-avatar-three-bg-fill": "rgba(44, 224, 212, 1)",
          "color-avatar-three-text-on-bg-fill": "rgba(3, 60, 57, 1)",
          "color-avatar-two-bg-fill": "rgba(56, 250, 163, 1)",
          "color-avatar-two-text-on-bg-fill": "rgba(12, 81, 50, 1)",
          "color-backdrop-bg": "rgba(0, 0, 0, 0.71)",
          "color-button-gradient-bg-fill": "linear-gradient(180deg, rgba(48, 48, 48, 0) 63.53%, rgba(255, 255, 255, 0.15) 100%)",
          "color-checkbox-bg-surface-disabled": "rgba(0, 0, 0, 0.08)",
          "color-checkbox-icon-disabled": "rgba(255, 255, 255, 1)",
          "color-input-bg-surface": "rgba(253, 253, 253, 1)",
          "color-input-bg-surface-hover": "rgba(250, 250, 250, 1)",
          "color-input-bg-surface-active": "rgba(247, 247, 247, 1)",
          "color-input-border": "rgba(74, 74, 74, 1)",
          "color-input-border-hover": "rgba(97, 97, 97, 1)",
          "color-input-border-active": "rgba(26, 26, 26, 1)",
          "color-nav-bg": "rgba(235, 235, 235, 1)",
          "color-nav-bg-surface": "rgba(0, 0, 0, 0.02)",
          "color-nav-bg-surface-hover": "rgba(241, 241, 241, 1)",
          "color-nav-bg-surface-active": "rgba(250, 250, 250, 1)",
          "color-nav-bg-surface-selected": "rgba(250, 250, 250, 1)",
          "color-radio-button-bg-surface-disabled": "rgba(0, 0, 0, 0.08)",
          "color-radio-button-icon-disabled": "rgba(255, 255, 255, 1)",
          "color-video-thumbnail-play-button-bg-fill-hover": "rgba(0, 0, 0, 0.81)",
          "color-video-thumbnail-play-button-bg-fill": "rgba(0, 0, 0, 0.71)",
          "color-video-thumbnail-play-button-text-on-bg-fill": "rgba(255, 255, 255, 1)",
          "color-scrollbar-thumb-bg-hover": "rgba(138, 138, 138, 1)"
        },
        font: {
          "font-family-sans": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "font-family-mono": "ui-monospace, SFMono-Regular, 'SF Mono', Consolas, 'Liberation Mono', Menlo, monospace",
          "font-size-275": "0.6875rem",
          "font-size-300": "0.75rem",
          "font-size-325": "0.8125rem",
          "font-size-350": "0.875rem",
          "font-size-400": "1rem",
          "font-size-450": "1.125rem",
          "font-size-500": "1.25rem",
          "font-size-550": "1.375rem",
          "font-size-600": "1.5rem",
          "font-size-750": "1.875rem",
          "font-size-800": "2rem",
          "font-size-900": "2.25rem",
          "font-size-1000": "2.5rem",
          "font-weight-regular": "450",
          "font-weight-medium": "550",
          "font-weight-semibold": "650",
          "font-weight-bold": "700",
          "font-letter-spacing-densest": "-0.03375rem",
          "font-letter-spacing-denser": "-0.01875rem",
          "font-letter-spacing-dense": "-0.0125rem",
          "font-letter-spacing-normal": "0rem",
          "font-line-height-300": "0.75rem",
          "font-line-height-400": "1rem",
          "font-line-height-500": "1.25rem",
          "font-line-height-600": "1.5rem",
          "font-line-height-700": "1.75rem",
          "font-line-height-800": "2rem",
          "font-line-height-1000": "2.5rem",
          "font-line-height-1200": "3rem"
        },
        height: {
          "height-0": "0rem",
          "height-025": "0.0625rem",
          "height-050": "0.125rem",
          "height-100": "0.25rem",
          "height-150": "0.375rem",
          "height-200": "0.5rem",
          "height-300": "0.75rem",
          "height-400": "1rem",
          "height-500": "1.25rem",
          "height-600": "1.5rem",
          "height-700": "1.75rem",
          "height-800": "2rem",
          "height-900": "2.25rem",
          "height-1000": "2.5rem",
          "height-1200": "3rem",
          "height-1600": "4rem",
          "height-2000": "5rem",
          "height-2400": "6rem",
          "height-2800": "7rem",
          "height-3200": "8rem"
        },
        motion: {
          "motion-duration-0": "0ms",
          "motion-duration-50": "50ms",
          "motion-duration-100": "100ms",
          "motion-duration-150": "150ms",
          "motion-duration-200": "200ms",
          "motion-duration-250": "250ms",
          "motion-duration-300": "300ms",
          "motion-duration-350": "350ms",
          "motion-duration-400": "400ms",
          "motion-duration-450": "450ms",
          "motion-duration-500": "500ms",
          "motion-duration-5000": "5000ms",
          "motion-ease": "cubic-bezier(0.25, 0.1, 0.25, 1)",
          "motion-ease-in": "cubic-bezier(0.42, 0, 1, 1)",
          "motion-ease-out": "cubic-bezier(0.19, 0.91, 0.38, 1)",
          "motion-ease-in-out": "cubic-bezier(0.42, 0, 0.58, 1)",
          "motion-linear": "cubic-bezier(0, 0, 1, 1)",
          "motion-keyframes-bounce": "{ from, 65%, 85% { transform: scale(1) } 75% { transform: scale(0.85) } 82.5% { transform: scale(1.05) } }",
          "motion-keyframes-fade-in": "{ to { opacity: 1 } }",
          "motion-keyframes-pulse": "{ from, 75% { transform: scale(0.85); opacity: 1; } to { transform: scale(2.5); opacity: 0; } }",
          "motion-keyframes-spin": "{ to { transform: rotate(1turn) } }",
          "motion-keyframes-appear-above": "{ from { transform: translateY(var(--p-space-100)); opacity: 0; } to { transform: none; opacity: 1; } }",
          "motion-keyframes-appear-below": "{ from { transform: translateY(calc(var(--p-space-100) * -1)); opacity: 0; } to { transform: none; opacity: 1; } }"
        },
        shadow: {
          "shadow-0": "none",
          "shadow-100": "0rem 0.0625rem 0rem 0rem rgba(26, 26, 26, 0.07)",
          "shadow-200": "0rem 0.1875rem 0.0625rem -0.0625rem rgba(26, 26, 26, 0.07)",
          "shadow-300": "0rem 0.25rem 0.375rem -0.125rem rgba(26, 26, 26, 0.20)",
          "shadow-400": "0rem 0.5rem 1rem -0.25rem rgba(26, 26, 26, 0.22)",
          "shadow-500": "0rem 0.75rem 1.25rem -0.5rem rgba(26, 26, 26, 0.24)",
          "shadow-600": "0rem 1.25rem 1.25rem -0.5rem rgba(26, 26, 26, 0.28)",
          "shadow-bevel-100": "0rem 0.0625rem 0rem 0rem rgba(26, 26, 26, 0.07), 0rem 0.0625rem 0rem 0rem rgba(208, 208, 208, 0.40) inset, 0.0625rem 0rem 0rem 0rem #CCC inset, -0.0625rem 0rem 0rem 0rem #CCC inset, 0rem -0.0625rem 0rem 0rem #999 inset",
          "shadow-inset-100": "0rem 0.0625rem 0.125rem 0rem rgba(26, 26, 26, 0.15) inset, 0rem 0.0625rem 0.0625rem 0rem rgba(26, 26, 26, 0.15) inset",
          "shadow-inset-200": "0rem 0.125rem 0.0625rem 0rem rgba(26, 26, 26, 0.20) inset, 0.0625rem 0rem 0.0625rem 0rem rgba(26, 26, 26, 0.12) inset, -0.0625rem 0rem 0.0625rem 0rem rgba(26, 26, 26, 0.12) inset",
          "shadow-button": "0rem -0.0625rem 0rem 0rem #b5b5b5 inset, 0rem 0rem 0rem 0.0625rem rgba(0, 0, 0, 0.1) inset, 0rem 0.03125rem 0rem 0.09375rem #FFF inset",
          "shadow-button-hover": "0rem 0.0625rem 0rem 0rem #EBEBEB inset, -0.0625rem 0rem 0rem 0rem #EBEBEB inset, 0.0625rem 0rem 0rem 0rem #EBEBEB inset, 0rem -0.0625rem 0rem 0rem #CCC inset",
          "shadow-button-inset": "-0.0625rem 0rem 0.0625rem 0rem rgba(26, 26, 26, 0.122) inset, 0.0625rem 0rem 0.0625rem 0rem rgba(26, 26, 26, 0.122) inset, 0rem 0.125rem 0.0625rem 0rem rgba(26, 26, 26, 0.2) inset",
          "shadow-button-primary": "0rem -0.0625rem 0rem 0.0625rem rgba(0, 0, 0, 0.8) inset, 0rem 0rem 0rem 0.0625rem rgba(48, 48, 48, 1) inset, 0rem 0.03125rem 0rem 0.09375rem rgba(255, 255, 255, 0.25) inset;",
          "shadow-button-primary-hover": "0rem 0.0625rem 0rem 0rem rgba(255, 255, 255, 0.24) inset, 0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, -0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, 0rem -0.0625rem 0rem 0rem #000 inset, 0rem -0.0625rem 0rem 0.0625rem #1A1A1A",
          "shadow-button-primary-inset": "0rem 0.1875rem 0rem 0rem rgb(0, 0, 0) inset",
          "shadow-button-primary-critical": "0rem -0.0625rem 0rem 0.0625rem rgba(142, 31, 11, 0.8) inset, 0rem 0rem 0rem 0.0625rem rgba(181, 38, 11, 0.8) inset, 0rem 0.03125rem 0rem 0.09375rem rgba(255, 255, 255, 0.349) inset",
          "shadow-button-primary-critical-hover": "0rem 0.0625rem 0rem 0rem rgba(255, 255, 255, 0.48) inset, 0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, -0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, 0rem -0.09375rem 0rem 0rem rgba(0, 0, 0, 0.25) inset",
          "shadow-button-primary-critical-inset": "-0.0625rem 0rem 0.0625rem 0rem rgba(0, 0, 0, 0.2) inset, 0.0625rem 0rem 0.0625rem 0rem rgba(0, 0, 0, 0.2) inset, 0rem 0.125rem 0rem 0rem rgba(0, 0, 0, 0.6) inset",
          "shadow-button-primary-success": "0rem -0.0625rem 0rem 0.0625rem rgba(12, 81, 50, 0.8) inset, 0rem 0rem 0rem 0.0625rem rgba(19, 111, 69, 0.8) inset, 0rem 0.03125rem 0rem 0.09375rem rgba(255, 255, 255, 0.251) inset",
          "shadow-button-primary-success-hover": "0rem 0.0625rem 0rem 0rem rgba(255, 255, 255, 0.48) inset, 0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, -0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, 0rem -0.09375rem 0rem 0rem rgba(0, 0, 0, 0.25) inset",
          "shadow-button-primary-success-inset": "-0.0625rem 0rem 0.0625rem 0rem rgba(0, 0, 0, 0.2) inset, 0.0625rem 0rem 0.0625rem 0rem rgba(0, 0, 0, 0.2) inset, 0rem 0.125rem 0rem 0rem rgba(0, 0, 0, 0.6) inset",
          "shadow-border-inset": "0rem 0rem 0rem 0.0625rem rgba(0, 0, 0, 0.08) inset"
        },
        space: {
          "space-0": "0rem",
          "space-025": "0.0625rem",
          "space-050": "0.125rem",
          "space-100": "0.25rem",
          "space-150": "0.375rem",
          "space-200": "0.5rem",
          "space-300": "0.75rem",
          "space-400": "1rem",
          "space-500": "1.25rem",
          "space-600": "1.5rem",
          "space-800": "2rem",
          "space-1000": "2.5rem",
          "space-1200": "3rem",
          "space-1600": "4rem",
          "space-2000": "5rem",
          "space-2400": "6rem",
          "space-2800": "7rem",
          "space-3200": "8rem",
          "space-button-group-gap": "0.5rem",
          "space-card-gap": "1rem",
          "space-card-padding": "1rem",
          "space-table-cell-padding": "0.375rem"
        },
        text: {
          "text-heading-3xl-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-3xl-font-size": "2.25rem",
          "text-heading-3xl-font-weight": "700",
          "text-heading-3xl-font-letter-spacing": "-0.03375rem",
          "text-heading-3xl-font-line-height": "3rem",
          "text-heading-2xl-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-2xl-font-size": "1.875rem",
          "text-heading-2xl-font-weight": "700",
          "text-heading-2xl-font-letter-spacing": "-0.01875rem",
          "text-heading-2xl-font-line-height": "2.5rem",
          "text-heading-xl-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-xl-font-size": "1.5rem",
          "text-heading-xl-font-weight": "700",
          "text-heading-xl-font-letter-spacing": "-0.0125rem",
          "text-heading-xl-font-line-height": "2rem",
          "text-heading-lg-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-lg-font-size": "1.25rem",
          "text-heading-lg-font-weight": "650",
          "text-heading-lg-font-letter-spacing": "-0.0125rem",
          "text-heading-lg-font-line-height": "1.5rem",
          "text-heading-md-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-md-font-size": "0.875rem",
          "text-heading-md-font-weight": "650",
          "text-heading-md-font-letter-spacing": "0rem",
          "text-heading-md-font-line-height": "1.25rem",
          "text-heading-sm-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-sm-font-size": "0.8125rem",
          "text-heading-sm-font-weight": "650",
          "text-heading-sm-font-letter-spacing": "0rem",
          "text-heading-sm-font-line-height": "1.25rem",
          "text-heading-xs-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-xs-font-size": "0.75rem",
          "text-heading-xs-font-weight": "650",
          "text-heading-xs-font-letter-spacing": "0rem",
          "text-heading-xs-font-line-height": "1rem",
          "text-body-lg-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-body-lg-font-size": "0.875rem",
          "text-body-lg-font-weight": "450",
          "text-body-lg-font-letter-spacing": "0rem",
          "text-body-lg-font-line-height": "1.25rem",
          "text-body-md-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-body-md-font-size": "0.8125rem",
          "text-body-md-font-weight": "450",
          "text-body-md-font-letter-spacing": "0rem",
          "text-body-md-font-line-height": "1.25rem",
          "text-body-sm-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-body-sm-font-size": "0.75rem",
          "text-body-sm-font-weight": "450",
          "text-body-sm-font-letter-spacing": "0rem",
          "text-body-sm-font-line-height": "1rem",
          "text-body-xs-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-body-xs-font-size": "0.6875rem",
          "text-body-xs-font-weight": "450",
          "text-body-xs-font-letter-spacing": "0rem",
          "text-body-xs-font-line-height": "0.75rem"
        },
        width: {
          "width-0": "0rem",
          "width-025": "0.0625rem",
          "width-050": "0.125rem",
          "width-100": "0.25rem",
          "width-150": "0.375rem",
          "width-200": "0.5rem",
          "width-300": "0.75rem",
          "width-400": "1rem",
          "width-500": "1.25rem",
          "width-600": "1.5rem",
          "width-700": "1.75rem",
          "width-800": "2rem",
          "width-900": "2.25rem",
          "width-1000": "2.5rem",
          "width-1200": "3rem",
          "width-1600": "4rem",
          "width-2000": "5rem",
          "width-2400": "6rem",
          "width-2800": "7rem",
          "width-3200": "8rem"
        },
        zIndex: {
          "z-index-0": "auto",
          "z-index-1": "100",
          "z-index-2": "400",
          "z-index-3": "510",
          "z-index-4": "512",
          "z-index-5": "513",
          "z-index-6": "514",
          "z-index-7": "515",
          "z-index-8": "516",
          "z-index-9": "517",
          "z-index-10": "518",
          "z-index-11": "519",
          "z-index-12": "520"
        }
      },
      "dark-experimental": {
        border: {
          "border-radius-0": "0rem",
          "border-radius-050": "0.125rem",
          "border-radius-100": "0.25rem",
          "border-radius-150": "0.375rem",
          "border-radius-200": "0.5rem",
          "border-radius-300": "0.75rem",
          "border-radius-400": "1rem",
          "border-radius-500": "1.25rem",
          "border-radius-750": "1.875rem",
          "border-radius-full": "624.9375rem",
          "border-width-0": "0rem",
          "border-width-0165": "0.04125rem",
          "border-width-025": "0.0625rem",
          "border-width-050": "0.125rem",
          "border-width-100": "0.25rem"
        },
        breakpoints: {
          "breakpoints-xs": "0rem",
          "breakpoints-sm": "30.625rem",
          "breakpoints-md": "48rem",
          "breakpoints-lg": "65rem",
          "breakpoints-xl": "90rem"
        },
        color: {
          "color-scheme": "dark",
          "color-bg": "rgba(26, 26, 26, 1)",
          "color-bg-inverse": "rgba(26, 26, 26, 1)",
          "color-bg-surface": "rgba(48, 48, 48, 1)",
          "color-bg-surface-hover": "rgba(74, 74, 74, 1)",
          "color-bg-surface-active": "rgba(97, 97, 97, 1)",
          "color-bg-surface-selected": "rgba(97, 97, 97, 1)",
          "color-bg-surface-disabled": "rgba(0, 0, 0, 0.05)",
          "color-bg-surface-secondary": "rgba(247, 247, 247, 1)",
          "color-bg-surface-secondary-hover": "rgba(74, 74, 74, 1)",
          "color-bg-surface-secondary-active": "rgba(97, 97, 97, 1)",
          "color-bg-surface-secondary-selected": "rgba(235, 235, 235, 1)",
          "color-bg-surface-tertiary": "rgba(243, 243, 243, 1)",
          "color-bg-surface-tertiary-hover": "rgba(235, 235, 235, 1)",
          "color-bg-surface-tertiary-active": "rgba(227, 227, 227, 1)",
          "color-bg-surface-brand": "rgba(227, 227, 227, 1)",
          "color-bg-surface-brand-hover": "rgba(235, 235, 235, 1)",
          "color-bg-surface-brand-active": "rgba(241, 241, 241, 1)",
          "color-bg-surface-brand-selected": "rgba(74, 74, 74, 1)",
          "color-bg-surface-info": "rgba(234, 244, 255, 1)",
          "color-bg-surface-info-hover": "rgba(224, 240, 255, 1)",
          "color-bg-surface-info-active": "rgba(202, 230, 255, 1)",
          "color-bg-surface-success": "rgba(205, 254, 225, 1)",
          "color-bg-surface-success-hover": "rgba(180, 254, 210, 1)",
          "color-bg-surface-success-active": "rgba(146, 254, 194, 1)",
          "color-bg-surface-caution": "rgba(255, 248, 219, 1)",
          "color-bg-surface-caution-hover": "rgba(255, 244, 191, 1)",
          "color-bg-surface-caution-active": "rgba(255, 239, 157, 1)",
          "color-bg-surface-warning": "rgba(255, 241, 227, 1)",
          "color-bg-surface-warning-hover": "rgba(255, 235, 213, 1)",
          "color-bg-surface-warning-active": "rgba(255, 228, 198, 1)",
          "color-bg-surface-critical": "rgba(254, 233, 232, 1)",
          "color-bg-surface-critical-hover": "rgba(254, 226, 225, 1)",
          "color-bg-surface-critical-active": "rgba(254, 218, 217, 1)",
          "color-bg-surface-emphasis": "rgba(240, 242, 255, 1)",
          "color-bg-surface-emphasis-hover": "rgba(234, 237, 255, 1)",
          "color-bg-surface-emphasis-active": "rgba(226, 231, 255, 1)",
          "color-bg-surface-magic": "rgba(248, 247, 255, 1)",
          "color-bg-surface-magic-hover": "rgba(243, 241, 255, 1)",
          "color-bg-surface-magic-active": "rgba(233, 229, 255, 1)",
          "color-bg-surface-inverse": "rgba(48, 48, 48, 1)",
          "color-bg-surface-transparent": "rgba(0, 0, 0, 0)",
          "color-bg-fill": "rgba(48, 48, 48, 1)",
          "color-bg-fill-hover": "rgba(74, 74, 74, 1)",
          "color-bg-fill-active": "rgba(97, 97, 97, 1)",
          "color-bg-fill-selected": "rgba(97, 97, 97, 1)",
          "color-bg-fill-disabled": "rgba(0, 0, 0, 0.05)",
          "color-bg-fill-secondary": "rgba(241, 241, 241, 1)",
          "color-bg-fill-secondary-hover": "rgba(235, 235, 235, 1)",
          "color-bg-fill-secondary-active": "rgba(227, 227, 227, 1)",
          "color-bg-fill-tertiary": "rgba(227, 227, 227, 1)",
          "color-bg-fill-tertiary-hover": "rgba(212, 212, 212, 1)",
          "color-bg-fill-tertiary-active": "rgba(204, 204, 204, 1)",
          "color-bg-fill-brand": "rgba(255, 255, 255, 1)",
          "color-bg-fill-brand-hover": "rgba(243, 243, 243, 1)",
          "color-bg-fill-brand-active": "rgba(247, 247, 247, 1)",
          "color-bg-fill-brand-selected": "rgba(212, 212, 212, 1)",
          "color-bg-fill-brand-disabled": "rgba(0, 0, 0, 0.17)",
          "color-bg-fill-info": "rgba(145, 208, 255, 1)",
          "color-bg-fill-info-hover": "rgba(81, 192, 255, 1)",
          "color-bg-fill-info-active": "rgba(0, 148, 213, 1)",
          "color-bg-fill-info-secondary": "rgba(213, 235, 255, 1)",
          "color-bg-fill-success": "rgba(41, 132, 90, 1)",
          "color-bg-fill-success-hover": "rgba(19, 111, 69, 1)",
          "color-bg-fill-success-active": "rgba(12, 81, 50, 1)",
          "color-bg-fill-success-secondary": "rgba(180, 254, 210, 1)",
          "color-bg-fill-warning": "rgba(255, 184, 0, 1)",
          "color-bg-fill-warning-hover": "rgba(229, 165, 0, 1)",
          "color-bg-fill-warning-active": "rgba(178, 132, 0, 1)",
          "color-bg-fill-warning-secondary": "rgba(255, 214, 164, 1)",
          "color-bg-fill-caution": "rgba(255, 230, 0, 1)",
          "color-bg-fill-caution-hover": "rgba(234, 211, 0, 1)",
          "color-bg-fill-caution-active": "rgba(225, 203, 0, 1)",
          "color-bg-fill-caution-secondary": "rgba(255, 235, 120, 1)",
          "color-bg-fill-critical": "rgba(229, 28, 0, 1)",
          "color-bg-fill-critical-hover": "rgba(181, 38, 11, 1)",
          "color-bg-fill-critical-active": "rgba(142, 31, 11, 1)",
          "color-bg-fill-critical-selected": "rgba(142, 31, 11, 1)",
          "color-bg-fill-critical-secondary": "rgba(254, 211, 209, 1)",
          "color-bg-fill-emphasis": "rgba(0, 91, 211, 1)",
          "color-bg-fill-emphasis-hover": "rgba(0, 66, 153, 1)",
          "color-bg-fill-emphasis-active": "rgba(0, 46, 106, 1)",
          "color-bg-fill-magic": "rgba(128, 81, 255, 1)",
          "color-bg-fill-magic-secondary": "rgba(233, 229, 255, 1)",
          "color-bg-fill-magic-secondary-hover": "rgba(228, 222, 255, 1)",
          "color-bg-fill-magic-secondary-active": "rgba(223, 217, 255, 1)",
          "color-bg-fill-inverse": "rgba(48, 48, 48, 1)",
          "color-bg-fill-inverse-hover": "rgba(74, 74, 74, 1)",
          "color-bg-fill-inverse-active": "rgba(97, 97, 97, 1)",
          "color-bg-fill-transparent": "rgba(255, 255, 255, 0.11)",
          "color-bg-fill-transparent-hover": "rgba(255, 255, 255, 0.17)",
          "color-bg-fill-transparent-active": "rgba(255, 255, 255, 0.20)",
          "color-bg-fill-transparent-selected": "rgba(255, 255, 255, 0.28)",
          "color-bg-fill-transparent-secondary": "rgba(0, 0, 0, 0.06)",
          "color-bg-fill-transparent-secondary-hover": "rgba(0, 0, 0, 0.08)",
          "color-bg-fill-transparent-secondary-active": "rgba(0, 0, 0, 0.11)",
          "color-text": "rgba(227, 227, 227, 1)",
          "color-text-secondary": "rgba(181, 181, 181, 1)",
          "color-text-disabled": "rgba(181, 181, 181, 1)",
          "color-text-link": "rgba(0, 91, 211, 1)",
          "color-text-link-hover": "rgba(0, 66, 153, 1)",
          "color-text-link-active": "rgba(0, 46, 106, 1)",
          "color-text-brand": "rgba(74, 74, 74, 1)",
          "color-text-brand-hover": "rgba(48, 48, 48, 1)",
          "color-text-brand-on-bg-fill": "rgba(48, 48, 48, 1)",
          "color-text-brand-on-bg-fill-hover": "rgba(227, 227, 227, 1)",
          "color-text-brand-on-bg-fill-active": "rgba(204, 204, 204, 1)",
          "color-text-brand-on-bg-fill-disabled": "rgba(255, 255, 255, 1)",
          "color-text-info": "rgba(0, 58, 90, 1)",
          "color-text-info-hover": "rgba(0, 58, 90, 1)",
          "color-text-info-active": "rgba(0, 33, 51, 1)",
          "color-text-info-secondary": "rgba(0, 124, 180, 1)",
          "color-text-info-on-bg-fill": "rgba(0, 33, 51, 1)",
          "color-text-success": "rgba(12, 81, 50, 1)",
          "color-text-success-hover": "rgba(8, 61, 37, 1)",
          "color-text-success-active": "rgba(9, 42, 27, 1)",
          "color-text-success-secondary": "rgba(41, 132, 90, 1)",
          "color-text-success-on-bg-fill": "rgba(248, 255, 251, 1)",
          "color-text-caution": "rgba(79, 71, 0, 1)",
          "color-text-caution-hover": "rgba(51, 46, 0, 1)",
          "color-text-caution-active": "rgba(31, 28, 0, 1)",
          "color-text-caution-secondary": "rgba(130, 117, 0, 1)",
          "color-text-caution-on-bg-fill": "rgba(51, 46, 0, 1)",
          "color-text-warning": "rgba(94, 66, 0, 1)",
          "color-text-warning-hover": "rgba(65, 45, 0, 1)",
          "color-text-warning-active": "rgba(37, 26, 0, 1)",
          "color-text-warning-secondary": "rgba(149, 111, 0, 1)",
          "color-text-warning-on-bg-fill": "rgba(37, 26, 0, 1)",
          "color-text-critical": "rgba(142, 31, 11, 1)",
          "color-text-critical-hover": "rgba(95, 21, 7, 1)",
          "color-text-critical-active": "rgba(47, 10, 4, 1)",
          "color-text-critical-secondary": "rgba(229, 28, 0, 1)",
          "color-text-critical-on-bg-fill": "rgba(255, 251, 251, 1)",
          "color-text-emphasis": "rgba(0, 91, 211, 1)",
          "color-text-emphasis-hover": "rgba(0, 66, 153, 1)",
          "color-text-emphasis-active": "rgba(0, 46, 106, 1)",
          "color-text-emphasis-on-bg-fill": "rgba(252, 253, 255, 1)",
          "color-text-emphasis-on-bg-fill-hover": "rgba(226, 231, 255, 1)",
          "color-text-emphasis-on-bg-fill-active": "rgba(213, 220, 255, 1)",
          "color-text-magic": "rgba(87, 0, 209, 1)",
          "color-text-magic-secondary": "rgba(113, 38, 255, 1)",
          "color-text-magic-on-bg-fill": "rgba(253, 253, 255, 1)",
          "color-text-inverse": "rgba(227, 227, 227, 1)",
          "color-text-inverse-secondary": "rgba(181, 181, 181, 1)",
          "color-text-link-inverse": "rgba(197, 208, 255, 1)",
          "color-border": "rgba(227, 227, 227, 1)",
          "color-border-hover": "rgba(204, 204, 204, 1)",
          "color-border-disabled": "rgba(235, 235, 235, 1)",
          "color-border-secondary": "rgba(97, 97, 97, 1)",
          "color-border-tertiary": "rgba(204, 204, 204, 1)",
          "color-border-focus": "rgba(0, 91, 211, 1)",
          "color-border-brand": "rgba(227, 227, 227, 1)",
          "color-border-info": "rgba(168, 216, 255, 1)",
          "color-border-success": "rgba(146, 254, 194, 1)",
          "color-border-caution": "rgba(255, 235, 120, 1)",
          "color-border-warning": "rgba(255, 200, 121, 1)",
          "color-border-critical": "rgba(254, 195, 193, 1)",
          "color-border-critical-secondary": "rgba(142, 31, 11, 1)",
          "color-border-emphasis": "rgba(0, 91, 211, 1)",
          "color-border-emphasis-hover": "rgba(0, 66, 153, 1)",
          "color-border-emphasis-active": "rgba(0, 46, 106, 1)",
          "color-border-magic": "rgba(228, 222, 255, 1)",
          "color-border-magic-secondary": "rgba(148, 116, 255, 1)",
          "color-border-magic-secondary-hover": "rgba(128, 81, 255, 1)",
          "color-border-inverse": "rgba(97, 97, 97, 1)",
          "color-border-inverse-hover": "rgba(204, 204, 204, 1)",
          "color-border-inverse-active": "rgba(227, 227, 227, 1)",
          "color-tooltip-tail-down-border-experimental": "rgba(60, 60, 60, 1)",
          "color-tooltip-tail-up-border-experimental": "rgba(71, 71, 71, 1)",
          "color-border-gradient-experimental": "linear-gradient(to bottom, rgba(255, 255, 255, 0.17), rgba(255, 255, 255, 0.03))",
          "color-border-gradient-hover-experimental": "linear-gradient(to bottom, rgba(255, 255, 255, 0.17), rgba(255, 255, 255, 0.03))",
          "color-border-gradient-selected-experimental": "linear-gradient(to bottom, rgba(0, 0, 0, 0.20), rgba(255, 255, 255, 0.20))",
          "color-border-gradient-active-experimental": "linear-gradient(to bottom, rgba(255, 255, 255, 0.20), rgba(255, 255, 255, 0.03))",
          "color-icon": "rgba(227, 227, 227, 1)",
          "color-icon-hover": "rgba(48, 48, 48, 1)",
          "color-icon-active": "rgba(26, 26, 26, 1)",
          "color-icon-disabled": "rgba(204, 204, 204, 1)",
          "color-icon-secondary": "rgba(138, 138, 138, 1)",
          "color-icon-secondary-hover": "rgba(97, 97, 97, 1)",
          "color-icon-secondary-active": "rgba(74, 74, 74, 1)",
          "color-icon-brand": "rgba(26, 26, 26, 1)",
          "color-icon-info": "rgba(0, 148, 213, 1)",
          "color-icon-success": "rgba(41, 132, 90, 1)",
          "color-icon-caution": "rgba(153, 138, 0, 1)",
          "color-icon-warning": "rgba(178, 132, 0, 1)",
          "color-icon-critical": "rgba(239, 77, 47, 1)",
          "color-icon-emphasis": "rgba(0, 91, 211, 1)",
          "color-icon-emphasis-hover": "rgba(0, 66, 153, 1)",
          "color-icon-emphasis-active": "rgba(0, 46, 106, 1)",
          "color-icon-magic": "rgba(128, 81, 255, 1)",
          "color-icon-inverse": "rgba(227, 227, 227, 1)",
          "color-avatar-bg-fill": "rgba(181, 181, 181, 1)",
          "color-avatar-five-bg-fill": "rgba(253, 75, 146, 1)",
          "color-avatar-five-text-on-bg-fill": "rgba(255, 246, 248, 1)",
          "color-avatar-four-bg-fill": "rgba(81, 192, 255, 1)",
          "color-avatar-four-text-on-bg-fill": "rgba(0, 33, 51, 1)",
          "color-avatar-one-bg-fill": "rgba(197, 48, 197, 1)",
          "color-avatar-one-text-on-bg-fill": "rgba(253, 239, 253, 1)",
          "color-avatar-seven-bg-fill": "rgba(148, 116, 255, 1)",
          "color-avatar-seven-text-on-bg-fill": "rgba(248, 247, 255, 1)",
          "color-avatar-six-bg-fill": "rgba(37, 232, 43, 1)",
          "color-avatar-six-text-on-bg-fill": "rgba(3, 61, 5, 1)",
          "color-avatar-text-on-bg-fill": "rgba(255, 255, 255, 1)",
          "color-avatar-three-bg-fill": "rgba(44, 224, 212, 1)",
          "color-avatar-three-text-on-bg-fill": "rgba(3, 60, 57, 1)",
          "color-avatar-two-bg-fill": "rgba(56, 250, 163, 1)",
          "color-avatar-two-text-on-bg-fill": "rgba(12, 81, 50, 1)",
          "color-backdrop-bg": "rgba(0, 0, 0, 0.71)",
          "color-button-gradient-bg-fill": "linear-gradient(180deg, rgba(48, 48, 48, 0) 63.53%, rgba(255, 255, 255, 0.15) 100%)",
          "color-checkbox-bg-surface-disabled": "rgba(0, 0, 0, 0.08)",
          "color-checkbox-icon-disabled": "rgba(255, 255, 255, 1)",
          "color-input-bg-surface": "rgba(253, 253, 253, 1)",
          "color-input-bg-surface-hover": "rgba(250, 250, 250, 1)",
          "color-input-bg-surface-active": "rgba(247, 247, 247, 1)",
          "color-input-border": "rgba(138, 138, 138, 1)",
          "color-input-border-hover": "rgba(97, 97, 97, 1)",
          "color-input-border-active": "rgba(26, 26, 26, 1)",
          "color-nav-bg": "rgba(235, 235, 235, 1)",
          "color-nav-bg-surface": "rgba(0, 0, 0, 0.02)",
          "color-nav-bg-surface-hover": "rgba(241, 241, 241, 1)",
          "color-nav-bg-surface-active": "rgba(250, 250, 250, 1)",
          "color-nav-bg-surface-selected": "rgba(250, 250, 250, 1)",
          "color-radio-button-bg-surface-disabled": "rgba(0, 0, 0, 0.08)",
          "color-radio-button-icon-disabled": "rgba(255, 255, 255, 1)",
          "color-video-thumbnail-play-button-bg-fill-hover": "rgba(0, 0, 0, 0.81)",
          "color-video-thumbnail-play-button-bg-fill": "rgba(0, 0, 0, 0.71)",
          "color-video-thumbnail-play-button-text-on-bg-fill": "rgba(255, 255, 255, 1)",
          "color-scrollbar-thumb-bg-hover": "rgba(138, 138, 138, 1)"
        },
        font: {
          "font-family-sans": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "font-family-mono": "ui-monospace, SFMono-Regular, 'SF Mono', Consolas, 'Liberation Mono', Menlo, monospace",
          "font-size-275": "0.6875rem",
          "font-size-300": "0.75rem",
          "font-size-325": "0.8125rem",
          "font-size-350": "0.875rem",
          "font-size-400": "1rem",
          "font-size-450": "1.125rem",
          "font-size-500": "1.25rem",
          "font-size-550": "1.375rem",
          "font-size-600": "1.5rem",
          "font-size-750": "1.875rem",
          "font-size-800": "2rem",
          "font-size-900": "2.25rem",
          "font-size-1000": "2.5rem",
          "font-weight-regular": "450",
          "font-weight-medium": "550",
          "font-weight-semibold": "650",
          "font-weight-bold": "700",
          "font-letter-spacing-densest": "-0.03375rem",
          "font-letter-spacing-denser": "-0.01875rem",
          "font-letter-spacing-dense": "-0.0125rem",
          "font-letter-spacing-normal": "0rem",
          "font-line-height-300": "0.75rem",
          "font-line-height-400": "1rem",
          "font-line-height-500": "1.25rem",
          "font-line-height-600": "1.5rem",
          "font-line-height-700": "1.75rem",
          "font-line-height-800": "2rem",
          "font-line-height-1000": "2.5rem",
          "font-line-height-1200": "3rem"
        },
        height: {
          "height-0": "0rem",
          "height-025": "0.0625rem",
          "height-050": "0.125rem",
          "height-100": "0.25rem",
          "height-150": "0.375rem",
          "height-200": "0.5rem",
          "height-300": "0.75rem",
          "height-400": "1rem",
          "height-500": "1.25rem",
          "height-600": "1.5rem",
          "height-700": "1.75rem",
          "height-800": "2rem",
          "height-900": "2.25rem",
          "height-1000": "2.5rem",
          "height-1200": "3rem",
          "height-1600": "4rem",
          "height-2000": "5rem",
          "height-2400": "6rem",
          "height-2800": "7rem",
          "height-3200": "8rem"
        },
        motion: {
          "motion-duration-0": "0ms",
          "motion-duration-50": "50ms",
          "motion-duration-100": "100ms",
          "motion-duration-150": "150ms",
          "motion-duration-200": "200ms",
          "motion-duration-250": "250ms",
          "motion-duration-300": "300ms",
          "motion-duration-350": "350ms",
          "motion-duration-400": "400ms",
          "motion-duration-450": "450ms",
          "motion-duration-500": "500ms",
          "motion-duration-5000": "5000ms",
          "motion-ease": "cubic-bezier(0.25, 0.1, 0.25, 1)",
          "motion-ease-in": "cubic-bezier(0.42, 0, 1, 1)",
          "motion-ease-out": "cubic-bezier(0.19, 0.91, 0.38, 1)",
          "motion-ease-in-out": "cubic-bezier(0.42, 0, 0.58, 1)",
          "motion-linear": "cubic-bezier(0, 0, 1, 1)",
          "motion-keyframes-bounce": "{ from, 65%, 85% { transform: scale(1) } 75% { transform: scale(0.85) } 82.5% { transform: scale(1.05) } }",
          "motion-keyframes-fade-in": "{ to { opacity: 1 } }",
          "motion-keyframes-pulse": "{ from, 75% { transform: scale(0.85); opacity: 1; } to { transform: scale(2.5); opacity: 0; } }",
          "motion-keyframes-spin": "{ to { transform: rotate(1turn) } }",
          "motion-keyframes-appear-above": "{ from { transform: translateY(var(--p-space-100)); opacity: 0; } to { transform: none; opacity: 1; } }",
          "motion-keyframes-appear-below": "{ from { transform: translateY(calc(var(--p-space-100) * -1)); opacity: 0; } to { transform: none; opacity: 1; } }"
        },
        shadow: {
          "shadow-0": "none",
          "shadow-100": "0rem 0.0625rem 0rem 0rem rgba(26, 26, 26, 0.07)",
          "shadow-200": "0rem 0.1875rem 0.0625rem -0.0625rem rgba(26, 26, 26, 0.07)",
          "shadow-300": "0rem 0.25rem 0.375rem -0.125rem rgba(26, 26, 26, 0.20)",
          "shadow-400": "0rem 0.5rem 1rem -0.25rem rgba(26, 26, 26, 0.22)",
          "shadow-500": "0rem 0.75rem 1.25rem -0.5rem rgba(26, 26, 26, 0.24)",
          "shadow-600": "0rem 1.25rem 1.25rem -0.5rem rgba(26, 26, 26, 0.28)",
          "shadow-bevel-100": "0.0625rem 0rem 0rem 0rem rgba(204, 204, 204, 0.08) inset, -0.0625rem 0rem 0rem 0rem rgba(204, 204, 204, 0.08) inset, 0rem -0.0625rem 0rem 0rem rgba(204, 204, 204, 0.08) inset, 0rem 0.0625rem 0rem 0rem rgba(204, 204, 204, 0.16) inset",
          "shadow-inset-100": "0rem 0.0625rem 0.125rem 0rem rgba(26, 26, 26, 0.15) inset, 0rem 0.0625rem 0.0625rem 0rem rgba(26, 26, 26, 0.15) inset",
          "shadow-inset-200": "0rem 0.125rem 0.0625rem 0rem rgba(26, 26, 26, 0.20) inset, 0.0625rem 0rem 0.0625rem 0rem rgba(26, 26, 26, 0.12) inset, -0.0625rem 0rem 0.0625rem 0rem rgba(26, 26, 26, 0.12) inset",
          "shadow-button": "0rem -0.0625rem 0rem 0rem #b5b5b5 inset, 0rem 0rem 0rem 0.0625rem rgba(0, 0, 0, 0.1) inset, 0rem 0.03125rem 0rem 0.09375rem #FFF inset",
          "shadow-button-hover": "0rem 0.0625rem 0rem 0rem #EBEBEB inset, -0.0625rem 0rem 0rem 0rem #EBEBEB inset, 0.0625rem 0rem 0rem 0rem #EBEBEB inset, 0rem -0.0625rem 0rem 0rem #CCC inset",
          "shadow-button-inset": "-0.0625rem 0rem 0.0625rem 0rem rgba(26, 26, 26, 0.122) inset, 0.0625rem 0rem 0.0625rem 0rem rgba(26, 26, 26, 0.122) inset, 0rem 0.125rem 0.0625rem 0rem rgba(26, 26, 26, 0.2) inset",
          "shadow-button-primary": "0rem -0.0625rem 0rem 0.0625rem rgba(0, 0, 0, 0.8) inset, 0rem 0rem 0rem 0.0625rem rgba(48, 48, 48, 1) inset, 0rem 0.03125rem 0rem 0.09375rem rgba(255, 255, 255, 0.25) inset;",
          "shadow-button-primary-hover": "0rem 0.0625rem 0rem 0rem rgba(255, 255, 255, 0.24) inset, 0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, -0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, 0rem -0.0625rem 0rem 0rem #000 inset, 0rem -0.0625rem 0rem 0.0625rem #1A1A1A",
          "shadow-button-primary-inset": "0rem 0.1875rem 0rem 0rem rgb(0, 0, 0) inset",
          "shadow-button-primary-critical": "0rem -0.0625rem 0rem 0.0625rem rgba(142, 31, 11, 0.8) inset, 0rem 0rem 0rem 0.0625rem rgba(181, 38, 11, 0.8) inset, 0rem 0.03125rem 0rem 0.09375rem rgba(255, 255, 255, 0.349) inset",
          "shadow-button-primary-critical-hover": "0rem 0.0625rem 0rem 0rem rgba(255, 255, 255, 0.48) inset, 0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, -0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, 0rem -0.09375rem 0rem 0rem rgba(0, 0, 0, 0.25) inset",
          "shadow-button-primary-critical-inset": "-0.0625rem 0rem 0.0625rem 0rem rgba(0, 0, 0, 0.2) inset, 0.0625rem 0rem 0.0625rem 0rem rgba(0, 0, 0, 0.2) inset, 0rem 0.125rem 0rem 0rem rgba(0, 0, 0, 0.6) inset",
          "shadow-button-primary-success": "0rem -0.0625rem 0rem 0.0625rem rgba(12, 81, 50, 0.8) inset, 0rem 0rem 0rem 0.0625rem rgba(19, 111, 69, 0.8) inset, 0rem 0.03125rem 0rem 0.09375rem rgba(255, 255, 255, 0.251) inset",
          "shadow-button-primary-success-hover": "0rem 0.0625rem 0rem 0rem rgba(255, 255, 255, 0.48) inset, 0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, -0.0625rem 0rem 0rem 0rem rgba(255, 255, 255, 0.20) inset, 0rem -0.09375rem 0rem 0rem rgba(0, 0, 0, 0.25) inset",
          "shadow-button-primary-success-inset": "-0.0625rem 0rem 0.0625rem 0rem rgba(0, 0, 0, 0.2) inset, 0.0625rem 0rem 0.0625rem 0rem rgba(0, 0, 0, 0.2) inset, 0rem 0.125rem 0rem 0rem rgba(0, 0, 0, 0.6) inset",
          "shadow-border-inset": "0rem 0rem 0rem 0.0625rem rgba(0, 0, 0, 0.08) inset"
        },
        space: {
          "space-0": "0rem",
          "space-025": "0.0625rem",
          "space-050": "0.125rem",
          "space-100": "0.25rem",
          "space-150": "0.375rem",
          "space-200": "0.5rem",
          "space-300": "0.75rem",
          "space-400": "1rem",
          "space-500": "1.25rem",
          "space-600": "1.5rem",
          "space-800": "2rem",
          "space-1000": "2.5rem",
          "space-1200": "3rem",
          "space-1600": "4rem",
          "space-2000": "5rem",
          "space-2400": "6rem",
          "space-2800": "7rem",
          "space-3200": "8rem",
          "space-button-group-gap": "0.5rem",
          "space-card-gap": "1rem",
          "space-card-padding": "1rem",
          "space-table-cell-padding": "0.375rem"
        },
        text: {
          "text-heading-3xl-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-3xl-font-size": "2.25rem",
          "text-heading-3xl-font-weight": "700",
          "text-heading-3xl-font-letter-spacing": "-0.03375rem",
          "text-heading-3xl-font-line-height": "3rem",
          "text-heading-2xl-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-2xl-font-size": "1.875rem",
          "text-heading-2xl-font-weight": "700",
          "text-heading-2xl-font-letter-spacing": "-0.01875rem",
          "text-heading-2xl-font-line-height": "2.5rem",
          "text-heading-xl-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-xl-font-size": "1.5rem",
          "text-heading-xl-font-weight": "700",
          "text-heading-xl-font-letter-spacing": "-0.0125rem",
          "text-heading-xl-font-line-height": "2rem",
          "text-heading-lg-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-lg-font-size": "1.25rem",
          "text-heading-lg-font-weight": "650",
          "text-heading-lg-font-letter-spacing": "-0.0125rem",
          "text-heading-lg-font-line-height": "1.5rem",
          "text-heading-md-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-md-font-size": "0.875rem",
          "text-heading-md-font-weight": "650",
          "text-heading-md-font-letter-spacing": "0rem",
          "text-heading-md-font-line-height": "1.25rem",
          "text-heading-sm-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-sm-font-size": "0.8125rem",
          "text-heading-sm-font-weight": "650",
          "text-heading-sm-font-letter-spacing": "0rem",
          "text-heading-sm-font-line-height": "1.25rem",
          "text-heading-xs-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-heading-xs-font-size": "0.75rem",
          "text-heading-xs-font-weight": "650",
          "text-heading-xs-font-letter-spacing": "0rem",
          "text-heading-xs-font-line-height": "1rem",
          "text-body-lg-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-body-lg-font-size": "0.875rem",
          "text-body-lg-font-weight": "450",
          "text-body-lg-font-letter-spacing": "0rem",
          "text-body-lg-font-line-height": "1.25rem",
          "text-body-md-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-body-md-font-size": "0.8125rem",
          "text-body-md-font-weight": "450",
          "text-body-md-font-letter-spacing": "0rem",
          "text-body-md-font-line-height": "1.25rem",
          "text-body-sm-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-body-sm-font-size": "0.75rem",
          "text-body-sm-font-weight": "450",
          "text-body-sm-font-letter-spacing": "0rem",
          "text-body-sm-font-line-height": "1rem",
          "text-body-xs-font-family": "'Inter', -apple-system, BlinkMacSystemFont, 'San Francisco', 'Segoe UI', Roboto, 'Helvetica Neue', sans-serif",
          "text-body-xs-font-size": "0.6875rem",
          "text-body-xs-font-weight": "450",
          "text-body-xs-font-letter-spacing": "0rem",
          "text-body-xs-font-line-height": "0.75rem"
        },
        width: {
          "width-0": "0rem",
          "width-025": "0.0625rem",
          "width-050": "0.125rem",
          "width-100": "0.25rem",
          "width-150": "0.375rem",
          "width-200": "0.5rem",
          "width-300": "0.75rem",
          "width-400": "1rem",
          "width-500": "1.25rem",
          "width-600": "1.5rem",
          "width-700": "1.75rem",
          "width-800": "2rem",
          "width-900": "2.25rem",
          "width-1000": "2.5rem",
          "width-1200": "3rem",
          "width-1600": "4rem",
          "width-2000": "5rem",
          "width-2400": "6rem",
          "width-2800": "7rem",
          "width-3200": "8rem"
        },
        zIndex: {
          "z-index-0": "auto",
          "z-index-1": "100",
          "z-index-2": "400",
          "z-index-3": "510",
          "z-index-4": "512",
          "z-index-5": "513",
          "z-index-6": "514",
          "z-index-7": "515",
          "z-index-8": "516",
          "z-index-9": "517",
          "z-index-10": "518",
          "z-index-11": "519",
          "z-index-12": "520"
        }
      }
    }, themeDefault = themes[constants.themeNameDefault], isTokenName = utils$1.createIsTokenName(themes[constants.themeNameDefault]);
    exports.breakpointsAliases = breakpoints.breakpointsAliases;
    exports.createVar = utils.createVar;
    exports.createVarName = utils.createVarName;
    exports.getMediaConditions = utils.getMediaConditions;
    exports.getThemeVarNames = utils.getThemeVarNames;
    exports.toPx = utils.toPx;
    exports.toPxs = utils.toPxs;
    exports.toRem = utils.toRem;
    exports.metaThemeDefault = index.metaThemeDefault;
    exports.metaThemes = index.metaThemes;
    exports.themeNameDefault = constants.themeNameDefault;
    exports.themeNames = constants.themeNames;
    exports.createThemeClassName = utils$1.createThemeClassName;
    exports.isTokenName = isTokenName;
    exports.themeDefault = themeDefault;
    exports.themes = themes;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-theme.js
var require_use_theme = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-theme.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisTokens = require_build2();
    function getTheme(themeName) {
      return polarisTokens.themes[themeName];
    }
    var ThemeContext = /* @__PURE__ */ React12.createContext(null);
    function useTheme() {
      let theme = React12.useContext(ThemeContext);
      if (!theme)
        throw new Error("No theme was provided. Your application must be wrapped in an <AppProvider> component. See https://polaris.shopify.com/components/app-provider for implementation instructions.");
      return theme;
    }
    function UseTheme(props) {
      let theme = useTheme();
      return props.children(theme);
    }
    exports.ThemeContext = ThemeContext;
    exports.UseTheme = UseTheme;
    exports.getTheme = getTheme;
    exports.useTheme = useTheme;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-index-resource-state.js
var require_use_index_resource_state = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-index-resource-state.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react();
    exports.SelectionType = void 0;
    (function(SelectionType) {
      SelectionType.All = "all", SelectionType.Page = "page", SelectionType.Multi = "multi", SelectionType.Single = "single", SelectionType.Range = "range";
    })(exports.SelectionType || (exports.SelectionType = {}));
    function defaultResourceIDResolver(resource) {
      if ("id" in resource)
        return resource.id;
      throw new Error("Your resource does not directly contain an `id`. Pass a `resourceIDResolver` to `useIndexResourceState`");
    }
    function useIndexResourceState(resources, {
      selectedResources: initSelectedResources = [],
      allResourcesSelected: initAllResourcesSelected = !1,
      resourceIDResolver = defaultResourceIDResolver,
      resourceFilter = void 0
    } = {
      selectedResources: [],
      allResourcesSelected: !1,
      resourceIDResolver: defaultResourceIDResolver,
      resourceFilter: void 0
    }) {
      let [selectedResources, setSelectedResources] = React12.useState(initSelectedResources), [allResourcesSelected, setAllResourcesSelected] = React12.useState(initAllResourcesSelected), handleSelectionChange = React12.useCallback((selectionType, isSelecting, selection, _position) => {
        switch (selectionType === exports.SelectionType.All ? setAllResourcesSelected(isSelecting) : allResourcesSelected && setAllResourcesSelected(!1), selectionType) {
          case exports.SelectionType.Single:
            setSelectedResources((newSelectedResources) => isSelecting ? [...newSelectedResources, selection] : newSelectedResources.filter((id) => id !== selection));
            break;
          case exports.SelectionType.All:
          case exports.SelectionType.Page:
            if (resourceFilter) {
              let filteredResources = resources.filter(resourceFilter);
              setSelectedResources(isSelecting && selectedResources.length < filteredResources.length ? filteredResources.map(resourceIDResolver) : []);
            } else
              setSelectedResources(isSelecting ? resources.map(resourceIDResolver) : []);
            break;
          case exports.SelectionType.Multi:
            if (!selection)
              break;
            setSelectedResources((currentSelectedResources) => {
              let ids = [], filteredResources = resourceFilter ? resources.filter(resourceFilter) : resources;
              for (let i = selection[0]; i <= selection[1]; i++)
                if (filteredResources.includes(resources[i])) {
                  let id = resourceIDResolver(resources[i]);
                  (isSelecting && !currentSelectedResources.includes(id) || !isSelecting && currentSelectedResources.includes(id)) && ids.push(id);
                }
              return isSelecting ? [...currentSelectedResources, ...ids] : currentSelectedResources.filter((id) => !ids.includes(id));
            });
            break;
          case exports.SelectionType.Range:
            if (!selection)
              break;
            setSelectedResources((currentSelectedResources) => {
              let selectedIds = (resourceFilter ? resources.filter(resourceFilter) : resources).map(resourceIDResolver).slice(Number(selection[0]), Number(selection[1]) + 1), isIndeterminate = selectedIds.some((id) => selectedResources.includes(id));
              return !selectedIds.every((id) => selectedResources.includes(id)) && (isSelecting || isIndeterminate) ? [...(/* @__PURE__ */ new Set([...currentSelectedResources, ...selectedIds])).values()] : currentSelectedResources.filter((id) => !selectedIds.includes(id));
            });
            break;
        }
      }, [allResourcesSelected, resourceFilter, selectedResources, resources, resourceIDResolver]), clearSelection = React12.useCallback(() => {
        setSelectedResources([]), setAllResourcesSelected(!1);
      }, []), removeSelectedResources = React12.useCallback((removeResources) => {
        let newSelectedResources = [...selectedResources].filter((resource) => !removeResources.includes(resource));
        setSelectedResources(newSelectedResources), newSelectedResources.length === 0 && setAllResourcesSelected(!1);
      }, [selectedResources]);
      return {
        selectedResources,
        allResourcesSelected,
        handleSelectionChange,
        clearSelection,
        removeSelectedResources
      };
    }
    exports.useIndexResourceState = useIndexResourceState;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/breakpoints.js
var require_breakpoints2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/breakpoints.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisTokens = require_build2(), target = require_target(), useIsomorphicLayoutEffect = require_use_isomorphic_layout_effect(), Breakpoints = {
      // TODO: Update to smDown
      navigationBarCollapsed: "767.95px",
      // TODO: Update to lgDown
      stackedContent: "1039.95px"
    }, noWindowMatches = {
      media: "",
      addListener: noop,
      removeListener: noop,
      matches: !1,
      onchange: noop,
      addEventListener: noop,
      removeEventListener: noop,
      dispatchEvent: (_2) => !0
    };
    function noop() {
    }
    function navigationBarCollapsed() {
      return typeof window > "u" ? noWindowMatches : window.matchMedia(`(max-width: ${Breakpoints.navigationBarCollapsed})`);
    }
    function stackedContent() {
      return typeof window > "u" ? noWindowMatches : window.matchMedia(`(max-width: ${Breakpoints.stackedContent})`);
    }
    var breakpointsQueryEntries = getBreakpointsQueryEntries(polarisTokens.themeDefault.breakpoints);
    function getMatches(defaults, forceDefaults) {
      return !target.isServer && !forceDefaults ? Object.fromEntries(breakpointsQueryEntries.map(([directionAlias, query]) => [directionAlias, window.matchMedia(query).matches])) : Object.fromEntries(typeof defaults == "object" && defaults !== null ? breakpointsQueryEntries.map(([directionAlias]) => [directionAlias, defaults[directionAlias] ?? !1]) : breakpointsQueryEntries.map(([directionAlias]) => [directionAlias, defaults ?? !1]));
    }
    function useBreakpoints(options) {
      let [breakpoints, setBreakpoints] = React12.useState(getMatches(options?.defaults, !0));
      return useIsomorphicLayoutEffect.useIsomorphicLayoutEffect(() => {
        let mediaQueryLists = breakpointsQueryEntries.map(([_2, query]) => window.matchMedia(query)), handler = () => setBreakpoints(getMatches());
        return mediaQueryLists.forEach((mql) => {
          mql.addListener ? mql.addListener(handler) : mql.addEventListener("change", handler);
        }), handler(), () => {
          mediaQueryLists.forEach((mql) => {
            mql.removeListener ? mql.removeListener(handler) : mql.removeEventListener("change", handler);
          });
        };
      }, []), breakpoints;
    }
    function getBreakpointsQueryEntries(breakpoints) {
      return Object.entries(polarisTokens.getMediaConditions(breakpoints)).map(([breakpointsToken, mediaConditions]) => Object.entries(mediaConditions).map(([direction, mediaCondition]) => [`${breakpointsToken.split("-")[1]}${capitalize2(direction)}`, mediaCondition])).flat();
    }
    function capitalize2(str) {
      return str.charAt(0).toUpperCase() + str.slice(1);
    }
    exports.getBreakpointsQueryEntries = getBreakpointsQueryEntries;
    exports.navigationBarCollapsed = navigationBarCollapsed;
    exports.stackedContent = stackedContent;
    exports.useBreakpoints = useBreakpoints;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/AppProvider/AppProvider.scss.js
var require_AppProvider_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/AppProvider/AppProvider.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var AppProvider3 = {};
    exports.default = AppProvider3;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/AppProvider/global.scss.js
var require_global_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/AppProvider/global.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var global2 = {};
    exports.default = global2;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/features/context.js
var require_context = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/features/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), classNamePolarisSummerEditions2023 = "Polaris-Summer-Editions-2023", FeaturesContext = /* @__PURE__ */ React12.createContext(void 0);
    exports.FeaturesContext = FeaturesContext;
    exports.classNamePolarisSummerEditions2023 = classNamePolarisSummerEditions2023;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/debounce.js
var require_debounce2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/debounce.js"(exports) {
    "use strict";
    init_cjs_shims();
    function debounce(func, waitArg, options) {
      let lastArgs, lastThis, maxWait, result, timerId, lastCallTime, lastInvokeTime = 0, leading = !1, maxing = !1, trailing = !0, useRAF = !waitArg && waitArg !== 0;
      if (typeof func != "function")
        throw new TypeError("Expected a function");
      let wait = waitArg || 0;
      typeof options == "object" && (leading = !!options.leading, maxing = "maxWait" in options, maxWait = maxing ? Math.max(Number(options.maxWait) || 0, wait) : void 0, trailing = "trailing" in options ? !!options.trailing : trailing);
      function invokeFunc(time) {
        let args = lastArgs, thisArg = lastThis;
        return lastArgs = void 0, lastThis = void 0, lastInvokeTime = time, result = func.apply(thisArg, args), result;
      }
      function startTimer(pendingFunc, wait2) {
        return useRAF ? (cancelAnimationFrame(timerId), requestAnimationFrame(pendingFunc)) : setTimeout(pendingFunc, wait2);
      }
      function cancelTimer(id) {
        if (useRAF)
          return cancelAnimationFrame(id);
        clearTimeout(id);
      }
      function leadingEdge(time) {
        return lastInvokeTime = time, timerId = startTimer(timerExpired, wait), leading ? invokeFunc(time) : result;
      }
      function remainingWait(time) {
        let timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
        return maxing && maxWait ? Math.min(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
      }
      function shouldInvoke(time) {
        let timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
        return lastCallTime === void 0 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && maxWait && timeSinceLastInvoke >= maxWait;
      }
      function timerExpired() {
        let time = Date.now();
        if (shouldInvoke(time))
          return trailingEdge(time);
        timerId = startTimer(timerExpired, remainingWait(time));
      }
      function trailingEdge(time) {
        return timerId = void 0, trailing && lastArgs ? invokeFunc(time) : (lastArgs = lastThis = void 0, result);
      }
      function cancel() {
        timerId !== void 0 && cancelTimer(timerId), lastInvokeTime = 0, lastArgs = lastCallTime = lastThis = timerId = void 0;
      }
      function flush() {
        return timerId === void 0 ? result : trailingEdge(Date.now());
      }
      function pending() {
        return timerId !== void 0;
      }
      function debounced(...args) {
        let time = Date.now(), isInvoking = shouldInvoke(time);
        if (lastArgs = args, lastThis = this, lastCallTime = time, isInvoking) {
          if (timerId === void 0)
            return leadingEdge(lastCallTime);
          if (maxing)
            return timerId = startTimer(timerExpired, wait), invokeFunc(lastCallTime);
        }
        return timerId === void 0 && (timerId = startTimer(timerExpired, wait)), result;
      }
      return debounced.cancel = cancel, debounced.flush = flush, debounced.pending = pending, debounced;
    }
    exports.debounce = debounce;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/geometry.js
var require_geometry = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/geometry.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Rect = class _Rect {
      static get zero() {
        return new _Rect();
      }
      constructor({
        top = 0,
        left = 0,
        width = 0,
        height = 0
      } = {}) {
        this.top = top, this.left = left, this.width = width, this.height = height;
      }
      get center() {
        return {
          x: this.left + this.width / 2,
          y: this.top + this.height / 2
        };
      }
    };
    function getRectForNode(node) {
      if (!(node instanceof Element))
        return new Rect({
          width: window.innerWidth,
          height: window.innerHeight
        });
      let rect = node.getBoundingClientRect();
      return new Rect({
        top: rect.top,
        left: rect.left,
        width: rect.width,
        height: rect.height
      });
    }
    exports.Rect = Rect;
    exports.getRectForNode = getRectForNode;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/sticky-manager/sticky-manager.js
var require_sticky_manager = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/sticky-manager/sticky-manager.js"(exports) {
    "use strict";
    init_cjs_shims();
    var polarisTokens = require_build2(), debounce = require_debounce2(), shared = require_shared(), breakpoints = require_breakpoints2(), geometry = require_geometry(), SIXTY_FPS = 1e3 / 60, StickyManager = class {
      constructor(container) {
        this.stickyItems = [], this.stuckItems = [], this.container = null, this.topBarOffset = 0, this.handleResize = debounce.debounce(() => {
          this.manageStickyItems();
        }, SIXTY_FPS, {
          leading: !0,
          trailing: !0,
          maxWait: SIXTY_FPS
        }), this.handleScroll = debounce.debounce(() => {
          this.manageStickyItems();
        }, SIXTY_FPS, {
          leading: !0,
          trailing: !0,
          maxWait: SIXTY_FPS
        }), container && this.setContainer(container);
      }
      registerStickyItem(stickyItem) {
        this.stickyItems.push(stickyItem);
      }
      unregisterStickyItem(nodeToRemove) {
        let nodeIndex = this.stickyItems.findIndex(({
          stickyNode
        }) => nodeToRemove === stickyNode);
        this.stickyItems.splice(nodeIndex, 1);
      }
      setContainer(el) {
        this.container = el, isDocument(el) && this.setTopBarOffset(el), this.container.addEventListener("scroll", this.handleScroll), window.addEventListener("resize", this.handleResize), this.manageStickyItems();
      }
      removeScrollListener() {
        this.container && (this.container.removeEventListener("scroll", this.handleScroll), window.removeEventListener("resize", this.handleResize));
      }
      manageStickyItems() {
        if (this.stickyItems.length <= 0)
          return;
        let scrollTop = this.container ? scrollTopFor(this.container) : 0, containerTop = geometry.getRectForNode(this.container).top + this.topBarOffset;
        this.stickyItems.forEach((stickyItem) => {
          let {
            handlePositioning
          } = stickyItem, {
            sticky,
            top,
            left,
            width
          } = this.evaluateStickyItem(stickyItem, scrollTop, containerTop);
          this.updateStuckItems(stickyItem, sticky), handlePositioning(sticky, top, left, width);
        });
      }
      evaluateStickyItem(stickyItem, scrollTop, containerTop) {
        let {
          stickyNode,
          placeHolderNode,
          boundingElement,
          offset,
          disableWhenStacked
        } = stickyItem;
        if (disableWhenStacked && breakpoints.stackedContent().matches)
          return {
            sticky: !1,
            top: 0,
            left: 0,
            width: "auto"
          };
        let stickyOffset = offset ? this.getOffset(stickyNode) + parseInt(
          // Important: This will not update when the active theme changes.
          // Update this to `useTheme` once converted to a function component.
          polarisTokens.themeDefault.space["space-500"],
          10
        ) : this.getOffset(stickyNode), scrollPosition = scrollTop + stickyOffset, placeHolderNodeCurrentTop = placeHolderNode.getBoundingClientRect().top - containerTop + scrollTop, top = containerTop + stickyOffset, width = placeHolderNode.getBoundingClientRect().width, left = placeHolderNode.getBoundingClientRect().left, sticky;
        if (boundingElement == null)
          sticky = scrollPosition >= placeHolderNodeCurrentTop;
        else {
          let stickyItemHeight = stickyNode.getBoundingClientRect().height || stickyNode.firstElementChild?.getBoundingClientRect().height || 0, stickyItemBottomPosition = boundingElement.getBoundingClientRect().bottom - stickyItemHeight + scrollTop - containerTop;
          sticky = scrollPosition >= placeHolderNodeCurrentTop && scrollPosition < stickyItemBottomPosition;
        }
        return {
          sticky,
          top,
          left,
          width
        };
      }
      updateStuckItems(item, sticky) {
        let {
          stickyNode
        } = item;
        sticky && !this.isNodeStuck(stickyNode) ? this.addStuckItem(item) : !sticky && this.isNodeStuck(stickyNode) && this.removeStuckItem(item);
      }
      addStuckItem(stickyItem) {
        this.stuckItems.push(stickyItem);
      }
      removeStuckItem(stickyItem) {
        let {
          stickyNode: nodeToRemove
        } = stickyItem, nodeIndex = this.stuckItems.findIndex(({
          stickyNode
        }) => nodeToRemove === stickyNode);
        this.stuckItems.splice(nodeIndex, 1);
      }
      getOffset(node) {
        if (this.stuckItems.length === 0)
          return 0;
        let offset = 0, count = 0, stuckNodesLength = this.stuckItems.length, nodeRect = geometry.getRectForNode(node);
        for (; count < stuckNodesLength; ) {
          let stuckNode = this.stuckItems[count].stickyNode;
          if (stuckNode !== node) {
            let stuckNodeRect = geometry.getRectForNode(stuckNode);
            horizontallyOverlaps(nodeRect, stuckNodeRect) || (offset += geometry.getRectForNode(stuckNode).height);
          } else
            break;
          count++;
        }
        return offset;
      }
      isNodeStuck(node) {
        return this.stuckItems.findIndex(({
          stickyNode
        }) => node === stickyNode) >= 0;
      }
      setTopBarOffset(container) {
        let topbarElement = container.querySelector(`:not(${shared.scrollable.selector}) ${shared.dataPolarisTopBar.selector}`);
        this.topBarOffset = topbarElement ? topbarElement.clientHeight : 0;
      }
    };
    function isDocument(node) {
      return node === document;
    }
    function scrollTopFor(container) {
      return isDocument(container) ? document.body.scrollTop || document.documentElement.scrollTop : container.scrollTop;
    }
    function horizontallyOverlaps(rect1, rect2) {
      let rect1Left = rect1.left, rect1Right = rect1.left + rect1.width, rect2Left = rect2.left;
      return rect2.left + rect2.width < rect1Left || rect1Right < rect2Left;
    }
    exports.StickyManager = StickyManager;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/scroll-lock-manager/scroll-lock-manager.js
var require_scroll_lock_manager = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/scroll-lock-manager/scroll-lock-manager.js"(exports) {
    "use strict";
    init_cjs_shims();
    var target = require_target(), SCROLL_LOCKING_ATTRIBUTE = "data-lock-scrolling", SCROLL_LOCKING_HIDDEN_ATTRIBUTE = "data-lock-scrolling-hidden", SCROLL_LOCKING_WRAPPER_ATTRIBUTE = "data-lock-scrolling-wrapper", scrollPosition = 0;
    function isScrollBarVisible() {
      let {
        body
      } = document;
      return body.scrollHeight > body.clientHeight;
    }
    var ScrollLockManager = class {
      constructor() {
        this.scrollLocks = 0, this.locked = !1;
      }
      registerScrollLock() {
        this.scrollLocks += 1, this.handleScrollLocking();
      }
      unregisterScrollLock() {
        this.scrollLocks -= 1, this.handleScrollLocking();
      }
      handleScrollLocking() {
        if (target.isServer)
          return;
        let {
          scrollLocks
        } = this, {
          body
        } = document, wrapper = body.firstElementChild;
        scrollLocks === 0 ? (body.removeAttribute(SCROLL_LOCKING_ATTRIBUTE), body.removeAttribute(SCROLL_LOCKING_HIDDEN_ATTRIBUTE), wrapper && wrapper.removeAttribute(SCROLL_LOCKING_WRAPPER_ATTRIBUTE), window.scroll(0, scrollPosition), this.locked = !1) : scrollLocks > 0 && !this.locked && (scrollPosition = window.pageYOffset, body.setAttribute(SCROLL_LOCKING_ATTRIBUTE, ""), isScrollBarVisible() || body.setAttribute(SCROLL_LOCKING_HIDDEN_ATTRIBUTE, ""), wrapper && (wrapper.setAttribute(SCROLL_LOCKING_WRAPPER_ATTRIBUTE, ""), wrapper.scrollTop = scrollPosition), this.locked = !0);
      }
      resetScrollPosition() {
        scrollPosition = 0;
      }
    };
    exports.SCROLL_LOCKING_ATTRIBUTE = SCROLL_LOCKING_ATTRIBUTE;
    exports.ScrollLockManager = ScrollLockManager;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/get.js
var require_get2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/get.js"(exports) {
    "use strict";
    init_cjs_shims();
    var OBJECT_NOTATION_MATCHER = /\[(.*?)\]|(\w+)/g;
    function get2(obj, keypath, defaultValue) {
      if (obj == null)
        return;
      let keys = Array.isArray(keypath) ? keypath : getKeypath(keypath), acc = obj;
      for (let i = 0; i < keys.length; i++) {
        let val = acc[keys[i]];
        if (val === void 0)
          return defaultValue;
        acc = val;
      }
      return acc;
    }
    function getKeypath(str) {
      let path3 = [], result;
      for (; result = OBJECT_NOTATION_MATCHER.exec(str); ) {
        let [, first, second] = result;
        path3.push(first || second);
      }
      return path3;
    }
    exports.get = get2;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/merge.js
var require_merge2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/merge.js"(exports) {
    "use strict";
    init_cjs_shims();
    function merge(...objs) {
      let final = {};
      for (let obj of objs)
        final = mergeRecursively(final, obj);
      return final;
    }
    function mergeRecursively(inputObjA, objB) {
      let objA = Array.isArray(inputObjA) ? [...inputObjA] : {
        ...inputObjA
      };
      for (let key in objB)
        if (Object.prototype.hasOwnProperty.call(objB, key))
          isMergeableValue(objB[key]) && isMergeableValue(objA[key]) ? objA[key] = mergeRecursively(objA[key], objB[key]) : objA[key] = objB[key];
        else
          continue;
      return objA;
    }
    function isMergeableValue(value) {
      return value !== null && typeof value == "object";
    }
    exports.merge = merge;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/i18n/I18n.js
var require_I18n = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/i18n/I18n.js"(exports) {
    "use strict";
    init_cjs_shims();
    var get2 = require_get2(), merge = require_merge2(), REPLACE_REGEX = /{([^}]*)}/g, I18n = class {
      /**
       * @param translation A locale object or array of locale objects that overrides default translations. If specifying an array then your desired language dictionary should come first, followed by your fallback language dictionaries
       */
      constructor(translation) {
        this.translation = {}, this.translation = Array.isArray(translation) ? merge.merge(...translation.slice().reverse()) : translation;
      }
      translate(id, replacements) {
        let text = get2.get(this.translation, id, "");
        return text ? replacements ? text.replace(REPLACE_REGEX, (match2) => {
          let replacement = match2.substring(1, match2.length - 1);
          if (replacements[replacement] === void 0) {
            let replacementData = JSON.stringify(replacements);
            throw new Error(`Error in translation for key '${id}'. No replacement found for key '${replacement}'. The following replacements were passed: '${replacementData}'`);
          }
          return replacements[replacement];
        }) : text : "";
      }
      translationKeyExists(path3) {
        return !!get2.get(this.translation, path3);
      }
    };
    exports.I18n = I18n;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/i18n/context.js
var require_context2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/i18n/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), I18nContext = /* @__PURE__ */ React12.createContext(void 0);
    exports.I18nContext = I18nContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/scroll-lock-manager/context.js
var require_context3 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/scroll-lock-manager/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), ScrollLockManagerContext = /* @__PURE__ */ React12.createContext(void 0);
    exports.ScrollLockManagerContext = ScrollLockManagerContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/sticky-manager/context.js
var require_context4 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/sticky-manager/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), StickyManagerContext = /* @__PURE__ */ React12.createContext(void 0);
    exports.StickyManagerContext = StickyManagerContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/link/context.js
var require_context5 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/link/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), LinkContext = /* @__PURE__ */ React12.createContext(void 0);
    exports.LinkContext = LinkContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/media-query/context.js
var require_context6 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/media-query/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), MediaQueryContext = /* @__PURE__ */ React12.createContext(void 0);
    exports.MediaQueryContext = MediaQueryContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/EventListener/EventListener.js
var require_EventListener = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/EventListener/EventListener.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), EventListener = class extends React12.PureComponent {
      componentDidMount() {
        this.attachListener();
      }
      componentDidUpdate({
        passive,
        ...detachProps
      }) {
        this.detachListener(detachProps), this.attachListener();
      }
      componentWillUnmount() {
        this.detachListener();
      }
      render() {
        return null;
      }
      attachListener() {
        let {
          event,
          handler,
          capture,
          passive
        } = this.props;
        window.addEventListener(event, handler, {
          capture,
          passive
        });
      }
      detachListener(prevProps) {
        let {
          event,
          handler,
          capture
        } = prevProps || this.props;
        window.removeEventListener(event, handler, capture);
      }
    };
    exports.EventListener = EventListener;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/MediaQueryProvider/MediaQueryProvider.js
var require_MediaQueryProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/MediaQueryProvider/MediaQueryProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), debounce = require_debounce2(), breakpoints = require_breakpoints2(), context = require_context6(), EventListener = require_EventListener(), MediaQueryProvider = function({
      children
    }) {
      let [isNavigationCollapsed, setIsNavigationCollapsed] = React12.useState(breakpoints.navigationBarCollapsed().matches), handleResize = React12.useCallback(debounce.debounce(() => {
        isNavigationCollapsed !== breakpoints.navigationBarCollapsed().matches && setIsNavigationCollapsed(!isNavigationCollapsed);
      }, 40, {
        trailing: !0,
        leading: !0,
        maxWait: 40
      }), [isNavigationCollapsed]);
      React12.useEffect(() => {
        setIsNavigationCollapsed(breakpoints.navigationBarCollapsed().matches);
      }, []);
      let context$1 = React12.useMemo(() => ({
        isNavigationCollapsed
      }), [isNavigationCollapsed]);
      return /* @__PURE__ */ React12.createElement(context.MediaQueryContext.Provider, {
        value: context$1
      }, /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
        event: "resize",
        handler: handleResize
      }), children);
    };
    exports.MediaQueryProvider = MediaQueryProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-is-after-initial-mount.js
var require_use_is_after_initial_mount = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-is-after-initial-mount.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react();
    function useIsAfterInitialMount() {
      let [isAfterInitialMount, setIsAfterInitialMount] = React12.useState(!1);
      return React12.useEffect(() => {
        setIsAfterInitialMount(!0);
      }, []), isAfterInitialMount;
    }
    exports.useIsAfterInitialMount = useIsAfterInitialMount;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/portals/context.js
var require_context7 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/portals/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), PortalsManagerContext = /* @__PURE__ */ React12.createContext(void 0);
    exports.PortalsManagerContext = PortalsManagerContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/PortalsManager/components/PortalsContainer/PortalsContainer.js
var require_PortalsContainer = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/PortalsManager/components/PortalsContainer/PortalsContainer.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react();
    function PortalsContainerComponent(_props, ref) {
      return /* @__PURE__ */ React12.createElement("div", {
        id: "PolarisPortalsContainer",
        ref
      });
    }
    var PortalsContainer = /* @__PURE__ */ React12.forwardRef(PortalsContainerComponent);
    exports.PortalsContainer = PortalsContainer;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/PortalsManager/PortalsManager.js
var require_PortalsManager = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/PortalsManager/PortalsManager.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), useIsAfterInitialMount = require_use_is_after_initial_mount(), context = require_context7(), PortalsContainer = require_PortalsContainer();
    function PortalsManager({
      children,
      container
    }) {
      let isMounted = useIsAfterInitialMount.useIsAfterInitialMount(), ref = React12.useRef(null), contextValue = React12.useMemo(() => container ? {
        container
      } : isMounted ? {
        container: ref.current
      } : {
        container: null
      }, [container, isMounted]);
      return /* @__PURE__ */ React12.createElement(context.PortalsManagerContext.Provider, {
        value: contextValue
      }, children, container ? null : /* @__PURE__ */ React12.createElement(PortalsContainer.PortalsContainer, {
        ref
      }));
    }
    exports.PortalsManager = PortalsManager;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/focus-manager/context.js
var require_context8 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/focus-manager/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), FocusManagerContext = /* @__PURE__ */ React12.createContext(void 0);
    exports.FocusManagerContext = FocusManagerContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FocusManager/FocusManager.js
var require_FocusManager = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FocusManager/FocusManager.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), context = require_context8();
    function FocusManager({
      children
    }) {
      let [trapFocusList, setTrapFocusList] = React12.useState([]), add = React12.useCallback((id) => {
        setTrapFocusList((list2) => [...list2, id]);
      }, []), remove2 = React12.useCallback((id) => {
        let removed = !0;
        return setTrapFocusList((list2) => {
          let clone = [...list2], index = clone.indexOf(id);
          return index === -1 ? removed = !1 : clone.splice(index, 1), clone;
        }), removed;
      }, []), value = React12.useMemo(() => ({
        trapFocusList,
        add,
        remove: remove2
      }), [add, trapFocusList, remove2]);
      return /* @__PURE__ */ React12.createElement(context.FocusManagerContext.Provider, {
        value
      }, children);
    }
    exports.FocusManager = FocusManager;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/ephemeral-presence-manager/context.js
var require_context9 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/ephemeral-presence-manager/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), EphemeralPresenceManagerContext = /* @__PURE__ */ React12.createContext(void 0);
    exports.EphemeralPresenceManagerContext = EphemeralPresenceManagerContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/EphemeralPresenceManager/EphemeralPresenceManager.js
var require_EphemeralPresenceManager = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/EphemeralPresenceManager/EphemeralPresenceManager.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), context = require_context9(), defaultState = {
      tooltip: 0
    };
    function EphemeralPresenceManager({
      children
    }) {
      let [presenceCounter, setPresenceCounter] = React12.useState(defaultState), addPresence = React12.useCallback((key) => {
        setPresenceCounter((prevList) => ({
          ...prevList,
          [key]: prevList[key] + 1
        }));
      }, []), removePresence = React12.useCallback((key) => {
        setPresenceCounter((prevList) => ({
          ...prevList,
          [key]: prevList[key] - 1
        }));
      }, []), value = React12.useMemo(() => ({
        presenceList: Object.entries(presenceCounter).reduce((previousValue, currentValue) => {
          let [key, value2] = currentValue;
          return {
            ...previousValue,
            [key]: value2 >= 1
          };
        }, {}),
        presenceCounter,
        addPresence,
        removePresence
      }), [addPresence, removePresence, presenceCounter]);
      return /* @__PURE__ */ React12.createElement(context.EphemeralPresenceManagerContext.Provider, {
        value
      }, children);
    }
    exports.EphemeralPresenceManager = EphemeralPresenceManager;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/AppProvider/AppProvider.js
var require_AppProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/AppProvider/AppProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisTokens = require_build2(), useTheme = require_use_theme();
    require_AppProvider_scss();
    require_global_scss();
    var context = require_context(), stickyManager = require_sticky_manager(), scrollLockManager = require_scroll_lock_manager(), I18n = require_I18n(), context$1 = require_context2(), context$2 = require_context3(), context$3 = require_context4(), context$4 = require_context5(), MediaQueryProvider = require_MediaQueryProvider(), PortalsManager = require_PortalsManager(), FocusManager = require_FocusManager(), EphemeralPresenceManager = require_EphemeralPresenceManager(), MAX_SCROLLBAR_WIDTH = 20, SCROLLBAR_TEST_ELEMENT_PARENT_SIZE = 30, SCROLLBAR_TEST_ELEMENT_CHILD_SIZE = SCROLLBAR_TEST_ELEMENT_PARENT_SIZE + 10;
    function measureScrollbars() {
      let parentEl = document.createElement("div");
      parentEl.setAttribute("style", `position: absolute; opacity: 0; transform: translate3d(-9999px, -9999px, 0); pointer-events: none; width:${SCROLLBAR_TEST_ELEMENT_PARENT_SIZE}px; height:${SCROLLBAR_TEST_ELEMENT_PARENT_SIZE}px;`);
      let child = document.createElement("div");
      child.setAttribute("style", `width:100%; height: ${SCROLLBAR_TEST_ELEMENT_CHILD_SIZE}; overflow:scroll`), parentEl.appendChild(child), document.body.appendChild(parentEl);
      let scrollbarWidth = SCROLLBAR_TEST_ELEMENT_PARENT_SIZE - (parentEl.firstElementChild?.clientWidth ?? 0), scrollbarWidthWithSafetyHatch = Math.min(scrollbarWidth, MAX_SCROLLBAR_WIDTH);
      document.documentElement.style.setProperty("--pc-app-provider-scrollbar-width", `${scrollbarWidthWithSafetyHatch}px`), document.body.removeChild(parentEl);
    }
    var AppProvider3 = class extends React12.Component {
      constructor(props) {
        super(props), this.setBodyStyles = () => {
          document.body.style.backgroundColor = "var(--p-color-bg)", document.body.style.color = "var(--p-color-text)";
        }, this.setRootAttributes = () => {
          let activeThemeName = this.getThemeName();
          polarisTokens.themeNames.forEach((themeName) => {
            document.documentElement.classList.toggle(polarisTokens.createThemeClassName(themeName), themeName === activeThemeName);
          }), document.documentElement.classList.add(context.classNamePolarisSummerEditions2023);
        }, this.getThemeName = () => this.props.theme ?? polarisTokens.themeNameDefault, this.stickyManager = new stickyManager.StickyManager(), this.scrollLockManager = new scrollLockManager.ScrollLockManager();
        let {
          i18n,
          linkComponent
        } = this.props;
        this.state = {
          link: linkComponent,
          intl: new I18n.I18n(i18n)
        };
      }
      componentDidMount() {
        document != null && (this.stickyManager.setContainer(document), this.setBodyStyles(), this.setRootAttributes()), measureScrollbars();
      }
      componentDidUpdate({
        i18n: prevI18n,
        linkComponent: prevLinkComponent
      }) {
        let {
          i18n,
          linkComponent
        } = this.props;
        this.setRootAttributes(), !(i18n === prevI18n && linkComponent === prevLinkComponent) && this.setState({
          link: linkComponent,
          intl: new I18n.I18n(i18n)
        });
      }
      render() {
        let {
          children,
          features
        } = this.props, themeName = this.getThemeName(), {
          intl,
          link: link2
        } = this.state;
        return /* @__PURE__ */ React12.createElement(useTheme.ThemeContext.Provider, {
          value: useTheme.getTheme(themeName)
        }, /* @__PURE__ */ React12.createElement(context.FeaturesContext.Provider, {
          value: features
        }, /* @__PURE__ */ React12.createElement(context$1.I18nContext.Provider, {
          value: intl
        }, /* @__PURE__ */ React12.createElement(context$2.ScrollLockManagerContext.Provider, {
          value: this.scrollLockManager
        }, /* @__PURE__ */ React12.createElement(context$3.StickyManagerContext.Provider, {
          value: this.stickyManager
        }, /* @__PURE__ */ React12.createElement(context$4.LinkContext.Provider, {
          value: link2
        }, /* @__PURE__ */ React12.createElement(MediaQueryProvider.MediaQueryProvider, null, /* @__PURE__ */ React12.createElement(PortalsManager.PortalsManager, null, /* @__PURE__ */ React12.createElement(FocusManager.FocusManager, null, /* @__PURE__ */ React12.createElement(EphemeralPresenceManager.EphemeralPresenceManager, null, children))))))))));
      }
    };
    exports.AppProvider = AppProvider3;
  }
});

// ../../node_modules/.pnpm/object-assign@4.1.1/node_modules/object-assign/index.js
var require_object_assign = __commonJS({
  "../../node_modules/.pnpm/object-assign@4.1.1/node_modules/object-assign/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var getOwnPropertySymbols = Object.getOwnPropertySymbols, hasOwnProperty = Object.prototype.hasOwnProperty, propIsEnumerable = Object.prototype.propertyIsEnumerable;
    function toObject(val) {
      if (val == null)
        throw new TypeError("Object.assign cannot be called with null or undefined");
      return Object(val);
    }
    function shouldUseNative() {
      try {
        if (!Object.assign)
          return !1;
        var test1 = new String("abc");
        if (test1[5] = "de", Object.getOwnPropertyNames(test1)[0] === "5")
          return !1;
        for (var test2 = {}, i = 0; i < 10; i++)
          test2["_" + String.fromCharCode(i)] = i;
        var order2 = Object.getOwnPropertyNames(test2).map(function(n) {
          return test2[n];
        });
        if (order2.join("") !== "0123456789")
          return !1;
        var test3 = {};
        return "abcdefghijklmnopqrst".split("").forEach(function(letter) {
          test3[letter] = letter;
        }), Object.keys(Object.assign({}, test3)).join("") === "abcdefghijklmnopqrst";
      } catch {
        return !1;
      }
    }
    module.exports = shouldUseNative() ? Object.assign : function(target, source) {
      for (var from, to = toObject(target), symbols, s = 1; s < arguments.length; s++) {
        from = Object(arguments[s]);
        for (var key in from)
          hasOwnProperty.call(from, key) && (to[key] = from[key]);
        if (getOwnPropertySymbols) {
          symbols = getOwnPropertySymbols(from);
          for (var i = 0; i < symbols.length; i++)
            propIsEnumerable.call(from, symbols[i]) && (to[symbols[i]] = from[symbols[i]]);
        }
      }
      return to;
    };
  }
});

// ../../node_modules/.pnpm/react@17.0.2/node_modules/react/cjs/react.production.min.js
var require_react_production_min = __commonJS({
  "../../node_modules/.pnpm/react@17.0.2/node_modules/react/cjs/react.production.min.js"(exports) {
    "use strict";
    init_cjs_shims();
    var l = require_object_assign(), n = 60103, p = 60106;
    exports.Fragment = 60107;
    exports.StrictMode = 60108;
    exports.Profiler = 60114;
    var q = 60109, r2 = 60110, t7 = 60112;
    exports.Suspense = 60113;
    var u = 60115, v = 60116;
    typeof Symbol == "function" && Symbol.for && (w = Symbol.for, n = w("react.element"), p = w("react.portal"), exports.Fragment = w("react.fragment"), exports.StrictMode = w("react.strict_mode"), exports.Profiler = w("react.profiler"), q = w("react.provider"), r2 = w("react.context"), t7 = w("react.forward_ref"), exports.Suspense = w("react.suspense"), u = w("react.memo"), v = w("react.lazy"));
    var w, x = typeof Symbol == "function" && Symbol.iterator;
    function y(a) {
      return a === null || typeof a != "object" ? null : (a = x && a[x] || a["@@iterator"], typeof a == "function" ? a : null);
    }
    function z2(a) {
      for (var b = "https://reactjs.org/docs/error-decoder.html?invariant=" + a, c = 1; c < arguments.length; c++)
        b += "&args[]=" + encodeURIComponent(arguments[c]);
      return "Minified React error #" + a + "; visit " + b + " for the full message or use the non-minified dev environment for full errors and additional helpful warnings.";
    }
    var A = { isMounted: function() {
      return !1;
    }, enqueueForceUpdate: function() {
    }, enqueueReplaceState: function() {
    }, enqueueSetState: function() {
    } }, B = {};
    function C(a, b, c) {
      this.props = a, this.context = b, this.refs = B, this.updater = c || A;
    }
    C.prototype.isReactComponent = {};
    C.prototype.setState = function(a, b) {
      if (typeof a != "object" && typeof a != "function" && a != null)
        throw Error(z2(85));
      this.updater.enqueueSetState(this, a, b, "setState");
    };
    C.prototype.forceUpdate = function(a) {
      this.updater.enqueueForceUpdate(this, a, "forceUpdate");
    };
    function D() {
    }
    D.prototype = C.prototype;
    function E(a, b, c) {
      this.props = a, this.context = b, this.refs = B, this.updater = c || A;
    }
    var F = E.prototype = new D();
    F.constructor = E;
    l(F, C.prototype);
    F.isPureReactComponent = !0;
    var G = { current: null }, H = Object.prototype.hasOwnProperty, I = { key: !0, ref: !0, __self: !0, __source: !0 };
    function J(a, b, c) {
      var e, d = {}, k = null, h = null;
      if (b != null)
        for (e in b.ref !== void 0 && (h = b.ref), b.key !== void 0 && (k = "" + b.key), b)
          H.call(b, e) && !I.hasOwnProperty(e) && (d[e] = b[e]);
      var g = arguments.length - 2;
      if (g === 1)
        d.children = c;
      else if (1 < g) {
        for (var f = Array(g), m = 0; m < g; m++)
          f[m] = arguments[m + 2];
        d.children = f;
      }
      if (a && a.defaultProps)
        for (e in g = a.defaultProps, g)
          d[e] === void 0 && (d[e] = g[e]);
      return { $$typeof: n, type: a, key: k, ref: h, props: d, _owner: G.current };
    }
    function K(a, b) {
      return { $$typeof: n, type: a.type, key: b, ref: a.ref, props: a.props, _owner: a._owner };
    }
    function L(a) {
      return typeof a == "object" && a !== null && a.$$typeof === n;
    }
    function escape2(a) {
      var b = { "=": "=0", ":": "=2" };
      return "$" + a.replace(/[=:]/g, function(a2) {
        return b[a2];
      });
    }
    var M = /\/+/g;
    function N(a, b) {
      return typeof a == "object" && a !== null && a.key != null ? escape2("" + a.key) : b.toString(36);
    }
    function O(a, b, c, e, d) {
      var k = typeof a;
      (k === "undefined" || k === "boolean") && (a = null);
      var h = !1;
      if (a === null)
        h = !0;
      else
        switch (k) {
          case "string":
          case "number":
            h = !0;
            break;
          case "object":
            switch (a.$$typeof) {
              case n:
              case p:
                h = !0;
            }
        }
      if (h)
        return h = a, d = d(h), a = e === "" ? "." + N(h, 0) : e, Array.isArray(d) ? (c = "", a != null && (c = a.replace(M, "$&/") + "/"), O(d, b, c, "", function(a2) {
          return a2;
        })) : d != null && (L(d) && (d = K(d, c + (!d.key || h && h.key === d.key ? "" : ("" + d.key).replace(M, "$&/") + "/") + a)), b.push(d)), 1;
      if (h = 0, e = e === "" ? "." : e + ":", Array.isArray(a))
        for (var g = 0; g < a.length; g++) {
          k = a[g];
          var f = e + N(k, g);
          h += O(k, b, c, f, d);
        }
      else if (f = y(a), typeof f == "function")
        for (a = f.call(a), g = 0; !(k = a.next()).done; )
          k = k.value, f = e + N(k, g++), h += O(k, b, c, f, d);
      else if (k === "object")
        throw b = "" + a, Error(z2(31, b === "[object Object]" ? "object with keys {" + Object.keys(a).join(", ") + "}" : b));
      return h;
    }
    function P(a, b, c) {
      if (a == null)
        return a;
      var e = [], d = 0;
      return O(a, e, "", "", function(a2) {
        return b.call(c, a2, d++);
      }), e;
    }
    function Q(a) {
      if (a._status === -1) {
        var b = a._result;
        b = b(), a._status = 0, a._result = b, b.then(function(b2) {
          a._status === 0 && (b2 = b2.default, a._status = 1, a._result = b2);
        }, function(b2) {
          a._status === 0 && (a._status = 2, a._result = b2);
        });
      }
      if (a._status === 1)
        return a._result;
      throw a._result;
    }
    var R = { current: null };
    function S() {
      var a = R.current;
      if (a === null)
        throw Error(z2(321));
      return a;
    }
    var T = { ReactCurrentDispatcher: R, ReactCurrentBatchConfig: { transition: 0 }, ReactCurrentOwner: G, IsSomeRendererActing: { current: !1 }, assign: l };
    exports.Children = { map: P, forEach: function(a, b, c) {
      P(a, function() {
        b.apply(this, arguments);
      }, c);
    }, count: function(a) {
      var b = 0;
      return P(a, function() {
        b++;
      }), b;
    }, toArray: function(a) {
      return P(a, function(a2) {
        return a2;
      }) || [];
    }, only: function(a) {
      if (!L(a))
        throw Error(z2(143));
      return a;
    } };
    exports.Component = C;
    exports.PureComponent = E;
    exports.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = T;
    exports.cloneElement = function(a, b, c) {
      if (a == null)
        throw Error(z2(267, a));
      var e = l({}, a.props), d = a.key, k = a.ref, h = a._owner;
      if (b != null) {
        if (b.ref !== void 0 && (k = b.ref, h = G.current), b.key !== void 0 && (d = "" + b.key), a.type && a.type.defaultProps)
          var g = a.type.defaultProps;
        for (f in b)
          H.call(b, f) && !I.hasOwnProperty(f) && (e[f] = b[f] === void 0 && g !== void 0 ? g[f] : b[f]);
      }
      var f = arguments.length - 2;
      if (f === 1)
        e.children = c;
      else if (1 < f) {
        g = Array(f);
        for (var m = 0; m < f; m++)
          g[m] = arguments[m + 2];
        e.children = g;
      }
      return {
        $$typeof: n,
        type: a.type,
        key: d,
        ref: k,
        props: e,
        _owner: h
      };
    };
    exports.createContext = function(a, b) {
      return b === void 0 && (b = null), a = { $$typeof: r2, _calculateChangedBits: b, _currentValue: a, _currentValue2: a, _threadCount: 0, Provider: null, Consumer: null }, a.Provider = { $$typeof: q, _context: a }, a.Consumer = a;
    };
    exports.createElement = J;
    exports.createFactory = function(a) {
      var b = J.bind(null, a);
      return b.type = a, b;
    };
    exports.createRef = function() {
      return { current: null };
    };
    exports.forwardRef = function(a) {
      return { $$typeof: t7, render: a };
    };
    exports.isValidElement = L;
    exports.lazy = function(a) {
      return { $$typeof: v, _payload: { _status: -1, _result: a }, _init: Q };
    };
    exports.memo = function(a, b) {
      return { $$typeof: u, type: a, compare: b === void 0 ? null : b };
    };
    exports.useCallback = function(a, b) {
      return S().useCallback(a, b);
    };
    exports.useContext = function(a, b) {
      return S().useContext(a, b);
    };
    exports.useDebugValue = function() {
    };
    exports.useEffect = function(a, b) {
      return S().useEffect(a, b);
    };
    exports.useImperativeHandle = function(a, b, c) {
      return S().useImperativeHandle(a, b, c);
    };
    exports.useLayoutEffect = function(a, b) {
      return S().useLayoutEffect(a, b);
    };
    exports.useMemo = function(a, b) {
      return S().useMemo(a, b);
    };
    exports.useReducer = function(a, b, c) {
      return S().useReducer(a, b, c);
    };
    exports.useRef = function(a) {
      return S().useRef(a);
    };
    exports.useState = function(a) {
      return S().useState(a);
    };
    exports.version = "17.0.2";
  }
});

// ../../node_modules/.pnpm/react@17.0.2/node_modules/react/cjs/react.development.js
var require_react_development = __commonJS({
  "../../node_modules/.pnpm/react@17.0.2/node_modules/react/cjs/react.development.js"(exports) {
    "use strict";
    init_cjs_shims();
    process.env.NODE_ENV !== "production" && function() {
      "use strict";
      var _assign = require_object_assign(), ReactVersion = "17.0.2", REACT_ELEMENT_TYPE = 60103, REACT_PORTAL_TYPE = 60106;
      exports.Fragment = 60107, exports.StrictMode = 60108, exports.Profiler = 60114;
      var REACT_PROVIDER_TYPE = 60109, REACT_CONTEXT_TYPE = 60110, REACT_FORWARD_REF_TYPE = 60112;
      exports.Suspense = 60113;
      var REACT_SUSPENSE_LIST_TYPE = 60120, REACT_MEMO_TYPE = 60115, REACT_LAZY_TYPE = 60116, REACT_BLOCK_TYPE = 60121, REACT_SERVER_BLOCK_TYPE = 60122, REACT_FUNDAMENTAL_TYPE = 60117, REACT_SCOPE_TYPE = 60119, REACT_OPAQUE_ID_TYPE = 60128, REACT_DEBUG_TRACING_MODE_TYPE = 60129, REACT_OFFSCREEN_TYPE = 60130, REACT_LEGACY_HIDDEN_TYPE = 60131;
      if (typeof Symbol == "function" && Symbol.for) {
        var symbolFor = Symbol.for;
        REACT_ELEMENT_TYPE = symbolFor("react.element"), REACT_PORTAL_TYPE = symbolFor("react.portal"), exports.Fragment = symbolFor("react.fragment"), exports.StrictMode = symbolFor("react.strict_mode"), exports.Profiler = symbolFor("react.profiler"), REACT_PROVIDER_TYPE = symbolFor("react.provider"), REACT_CONTEXT_TYPE = symbolFor("react.context"), REACT_FORWARD_REF_TYPE = symbolFor("react.forward_ref"), exports.Suspense = symbolFor("react.suspense"), REACT_SUSPENSE_LIST_TYPE = symbolFor("react.suspense_list"), REACT_MEMO_TYPE = symbolFor("react.memo"), REACT_LAZY_TYPE = symbolFor("react.lazy"), REACT_BLOCK_TYPE = symbolFor("react.block"), REACT_SERVER_BLOCK_TYPE = symbolFor("react.server.block"), REACT_FUNDAMENTAL_TYPE = symbolFor("react.fundamental"), REACT_SCOPE_TYPE = symbolFor("react.scope"), REACT_OPAQUE_ID_TYPE = symbolFor("react.opaque.id"), REACT_DEBUG_TRACING_MODE_TYPE = symbolFor("react.debug_trace_mode"), REACT_OFFSCREEN_TYPE = symbolFor("react.offscreen"), REACT_LEGACY_HIDDEN_TYPE = symbolFor("react.legacy_hidden");
      }
      var MAYBE_ITERATOR_SYMBOL = typeof Symbol == "function" && Symbol.iterator, FAUX_ITERATOR_SYMBOL = "@@iterator";
      function getIteratorFn(maybeIterable) {
        if (maybeIterable === null || typeof maybeIterable != "object")
          return null;
        var maybeIterator = MAYBE_ITERATOR_SYMBOL && maybeIterable[MAYBE_ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL];
        return typeof maybeIterator == "function" ? maybeIterator : null;
      }
      var ReactCurrentDispatcher = {
        /**
         * @internal
         * @type {ReactComponent}
         */
        current: null
      }, ReactCurrentBatchConfig = {
        transition: 0
      }, ReactCurrentOwner = {
        /**
         * @internal
         * @type {ReactComponent}
         */
        current: null
      }, ReactDebugCurrentFrame = {}, currentExtraStackFrame = null;
      function setExtraStackFrame(stack) {
        currentExtraStackFrame = stack;
      }
      ReactDebugCurrentFrame.setExtraStackFrame = function(stack) {
        currentExtraStackFrame = stack;
      }, ReactDebugCurrentFrame.getCurrentStack = null, ReactDebugCurrentFrame.getStackAddendum = function() {
        var stack = "";
        currentExtraStackFrame && (stack += currentExtraStackFrame);
        var impl = ReactDebugCurrentFrame.getCurrentStack;
        return impl && (stack += impl() || ""), stack;
      };
      var IsSomeRendererActing = {
        current: !1
      }, ReactSharedInternals = {
        ReactCurrentDispatcher,
        ReactCurrentBatchConfig,
        ReactCurrentOwner,
        IsSomeRendererActing,
        // Used by renderers to avoid bundling object-assign twice in UMD bundles:
        assign: _assign
      };
      ReactSharedInternals.ReactDebugCurrentFrame = ReactDebugCurrentFrame;
      function warn(format4) {
        {
          for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++)
            args[_key - 1] = arguments[_key];
          printWarning("warn", format4, args);
        }
      }
      function error(format4) {
        {
          for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++)
            args[_key2 - 1] = arguments[_key2];
          printWarning("error", format4, args);
        }
      }
      function printWarning(level, format4, args) {
        {
          var ReactDebugCurrentFrame2 = ReactSharedInternals.ReactDebugCurrentFrame, stack = ReactDebugCurrentFrame2.getStackAddendum();
          stack !== "" && (format4 += "%s", args = args.concat([stack]));
          var argsWithFormat = args.map(function(item) {
            return "" + item;
          });
          argsWithFormat.unshift("Warning: " + format4), Function.prototype.apply.call(console[level], console, argsWithFormat);
        }
      }
      var didWarnStateUpdateForUnmountedComponent = {};
      function warnNoop(publicInstance, callerName) {
        {
          var _constructor = publicInstance.constructor, componentName = _constructor && (_constructor.displayName || _constructor.name) || "ReactClass", warningKey = componentName + "." + callerName;
          if (didWarnStateUpdateForUnmountedComponent[warningKey])
            return;
          error("Can't call %s on a component that is not yet mounted. This is a no-op, but it might indicate a bug in your application. Instead, assign to `this.state` directly or define a `state = {};` class property with the desired state in the %s component.", callerName, componentName), didWarnStateUpdateForUnmountedComponent[warningKey] = !0;
        }
      }
      var ReactNoopUpdateQueue = {
        /**
         * Checks whether or not this composite component is mounted.
         * @param {ReactClass} publicInstance The instance we want to test.
         * @return {boolean} True if mounted, false otherwise.
         * @protected
         * @final
         */
        isMounted: function(publicInstance) {
          return !1;
        },
        /**
         * Forces an update. This should only be invoked when it is known with
         * certainty that we are **not** in a DOM transaction.
         *
         * You may want to call this when you know that some deeper aspect of the
         * component's state has changed but `setState` was not called.
         *
         * This will not invoke `shouldComponentUpdate`, but it will invoke
         * `componentWillUpdate` and `componentDidUpdate`.
         *
         * @param {ReactClass} publicInstance The instance that should rerender.
         * @param {?function} callback Called after component is updated.
         * @param {?string} callerName name of the calling function in the public API.
         * @internal
         */
        enqueueForceUpdate: function(publicInstance, callback, callerName) {
          warnNoop(publicInstance, "forceUpdate");
        },
        /**
         * Replaces all of the state. Always use this or `setState` to mutate state.
         * You should treat `this.state` as immutable.
         *
         * There is no guarantee that `this.state` will be immediately updated, so
         * accessing `this.state` after calling this method may return the old value.
         *
         * @param {ReactClass} publicInstance The instance that should rerender.
         * @param {object} completeState Next state.
         * @param {?function} callback Called after component is updated.
         * @param {?string} callerName name of the calling function in the public API.
         * @internal
         */
        enqueueReplaceState: function(publicInstance, completeState, callback, callerName) {
          warnNoop(publicInstance, "replaceState");
        },
        /**
         * Sets a subset of the state. This only exists because _pendingState is
         * internal. This provides a merging strategy that is not available to deep
         * properties which is confusing. TODO: Expose pendingState or don't use it
         * during the merge.
         *
         * @param {ReactClass} publicInstance The instance that should rerender.
         * @param {object} partialState Next partial state to be merged with state.
         * @param {?function} callback Called after component is updated.
         * @param {?string} Name of the calling function in the public API.
         * @internal
         */
        enqueueSetState: function(publicInstance, partialState, callback, callerName) {
          warnNoop(publicInstance, "setState");
        }
      }, emptyObject = {};
      Object.freeze(emptyObject);
      function Component(props, context, updater) {
        this.props = props, this.context = context, this.refs = emptyObject, this.updater = updater || ReactNoopUpdateQueue;
      }
      Component.prototype.isReactComponent = {}, Component.prototype.setState = function(partialState, callback) {
        if (!(typeof partialState == "object" || typeof partialState == "function" || partialState == null))
          throw Error("setState(...): takes an object of state variables to update or a function which returns an object of state variables.");
        this.updater.enqueueSetState(this, partialState, callback, "setState");
      }, Component.prototype.forceUpdate = function(callback) {
        this.updater.enqueueForceUpdate(this, callback, "forceUpdate");
      };
      {
        var deprecatedAPIs = {
          isMounted: ["isMounted", "Instead, make sure to clean up subscriptions and pending requests in componentWillUnmount to prevent memory leaks."],
          replaceState: ["replaceState", "Refactor your code to use setState instead (see https://github.com/facebook/react/issues/3236)."]
        }, defineDeprecationWarning = function(methodName, info2) {
          Object.defineProperty(Component.prototype, methodName, {
            get: function() {
              warn("%s(...) is deprecated in plain JavaScript React classes. %s", info2[0], info2[1]);
            }
          });
        };
        for (var fnName in deprecatedAPIs)
          deprecatedAPIs.hasOwnProperty(fnName) && defineDeprecationWarning(fnName, deprecatedAPIs[fnName]);
      }
      function ComponentDummy() {
      }
      ComponentDummy.prototype = Component.prototype;
      function PureComponent(props, context, updater) {
        this.props = props, this.context = context, this.refs = emptyObject, this.updater = updater || ReactNoopUpdateQueue;
      }
      var pureComponentPrototype = PureComponent.prototype = new ComponentDummy();
      pureComponentPrototype.constructor = PureComponent, _assign(pureComponentPrototype, Component.prototype), pureComponentPrototype.isPureReactComponent = !0;
      function createRef() {
        var refObject = {
          current: null
        };
        return Object.seal(refObject), refObject;
      }
      function getWrappedName(outerType, innerType, wrapperName) {
        var functionName = innerType.displayName || innerType.name || "";
        return outerType.displayName || (functionName !== "" ? wrapperName + "(" + functionName + ")" : wrapperName);
      }
      function getContextName(type) {
        return type.displayName || "Context";
      }
      function getComponentName(type) {
        if (type == null)
          return null;
        if (typeof type.tag == "number" && error("Received an unexpected object in getComponentName(). This is likely a bug in React. Please file an issue."), typeof type == "function")
          return type.displayName || type.name || null;
        if (typeof type == "string")
          return type;
        switch (type) {
          case exports.Fragment:
            return "Fragment";
          case REACT_PORTAL_TYPE:
            return "Portal";
          case exports.Profiler:
            return "Profiler";
          case exports.StrictMode:
            return "StrictMode";
          case exports.Suspense:
            return "Suspense";
          case REACT_SUSPENSE_LIST_TYPE:
            return "SuspenseList";
        }
        if (typeof type == "object")
          switch (type.$$typeof) {
            case REACT_CONTEXT_TYPE:
              var context = type;
              return getContextName(context) + ".Consumer";
            case REACT_PROVIDER_TYPE:
              var provider = type;
              return getContextName(provider._context) + ".Provider";
            case REACT_FORWARD_REF_TYPE:
              return getWrappedName(type, type.render, "ForwardRef");
            case REACT_MEMO_TYPE:
              return getComponentName(type.type);
            case REACT_BLOCK_TYPE:
              return getComponentName(type._render);
            case REACT_LAZY_TYPE: {
              var lazyComponent = type, payload = lazyComponent._payload, init4 = lazyComponent._init;
              try {
                return getComponentName(init4(payload));
              } catch {
                return null;
              }
            }
          }
        return null;
      }
      var hasOwnProperty = Object.prototype.hasOwnProperty, RESERVED_PROPS = {
        key: !0,
        ref: !0,
        __self: !0,
        __source: !0
      }, specialPropKeyWarningShown, specialPropRefWarningShown, didWarnAboutStringRefs;
      didWarnAboutStringRefs = {};
      function hasValidRef(config2) {
        if (hasOwnProperty.call(config2, "ref")) {
          var getter = Object.getOwnPropertyDescriptor(config2, "ref").get;
          if (getter && getter.isReactWarning)
            return !1;
        }
        return config2.ref !== void 0;
      }
      function hasValidKey(config2) {
        if (hasOwnProperty.call(config2, "key")) {
          var getter = Object.getOwnPropertyDescriptor(config2, "key").get;
          if (getter && getter.isReactWarning)
            return !1;
        }
        return config2.key !== void 0;
      }
      function defineKeyPropWarningGetter(props, displayName) {
        var warnAboutAccessingKey = function() {
          specialPropKeyWarningShown || (specialPropKeyWarningShown = !0, error("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", displayName));
        };
        warnAboutAccessingKey.isReactWarning = !0, Object.defineProperty(props, "key", {
          get: warnAboutAccessingKey,
          configurable: !0
        });
      }
      function defineRefPropWarningGetter(props, displayName) {
        var warnAboutAccessingRef = function() {
          specialPropRefWarningShown || (specialPropRefWarningShown = !0, error("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", displayName));
        };
        warnAboutAccessingRef.isReactWarning = !0, Object.defineProperty(props, "ref", {
          get: warnAboutAccessingRef,
          configurable: !0
        });
      }
      function warnIfStringRefCannotBeAutoConverted(config2) {
        if (typeof config2.ref == "string" && ReactCurrentOwner.current && config2.__self && ReactCurrentOwner.current.stateNode !== config2.__self) {
          var componentName = getComponentName(ReactCurrentOwner.current.type);
          didWarnAboutStringRefs[componentName] || (error('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', componentName, config2.ref), didWarnAboutStringRefs[componentName] = !0);
        }
      }
      var ReactElement = function(type, key, ref, self2, source, owner, props) {
        var element = {
          // This tag allows us to uniquely identify this as a React Element
          $$typeof: REACT_ELEMENT_TYPE,
          // Built-in properties that belong on the element
          type,
          key,
          ref,
          props,
          // Record the component responsible for creating this element.
          _owner: owner
        };
        return element._store = {}, Object.defineProperty(element._store, "validated", {
          configurable: !1,
          enumerable: !1,
          writable: !0,
          value: !1
        }), Object.defineProperty(element, "_self", {
          configurable: !1,
          enumerable: !1,
          writable: !1,
          value: self2
        }), Object.defineProperty(element, "_source", {
          configurable: !1,
          enumerable: !1,
          writable: !1,
          value: source
        }), Object.freeze && (Object.freeze(element.props), Object.freeze(element)), element;
      };
      function createElement(type, config2, children) {
        var propName, props = {}, key = null, ref = null, self2 = null, source = null;
        if (config2 != null) {
          hasValidRef(config2) && (ref = config2.ref, warnIfStringRefCannotBeAutoConverted(config2)), hasValidKey(config2) && (key = "" + config2.key), self2 = config2.__self === void 0 ? null : config2.__self, source = config2.__source === void 0 ? null : config2.__source;
          for (propName in config2)
            hasOwnProperty.call(config2, propName) && !RESERVED_PROPS.hasOwnProperty(propName) && (props[propName] = config2[propName]);
        }
        var childrenLength = arguments.length - 2;
        if (childrenLength === 1)
          props.children = children;
        else if (childrenLength > 1) {
          for (var childArray = Array(childrenLength), i = 0; i < childrenLength; i++)
            childArray[i] = arguments[i + 2];
          Object.freeze && Object.freeze(childArray), props.children = childArray;
        }
        if (type && type.defaultProps) {
          var defaultProps = type.defaultProps;
          for (propName in defaultProps)
            props[propName] === void 0 && (props[propName] = defaultProps[propName]);
        }
        if (key || ref) {
          var displayName = typeof type == "function" ? type.displayName || type.name || "Unknown" : type;
          key && defineKeyPropWarningGetter(props, displayName), ref && defineRefPropWarningGetter(props, displayName);
        }
        return ReactElement(type, key, ref, self2, source, ReactCurrentOwner.current, props);
      }
      function cloneAndReplaceKey(oldElement, newKey) {
        var newElement = ReactElement(oldElement.type, newKey, oldElement.ref, oldElement._self, oldElement._source, oldElement._owner, oldElement.props);
        return newElement;
      }
      function cloneElement(element, config2, children) {
        if (element == null)
          throw Error("React.cloneElement(...): The argument must be a React element, but you passed " + element + ".");
        var propName, props = _assign({}, element.props), key = element.key, ref = element.ref, self2 = element._self, source = element._source, owner = element._owner;
        if (config2 != null) {
          hasValidRef(config2) && (ref = config2.ref, owner = ReactCurrentOwner.current), hasValidKey(config2) && (key = "" + config2.key);
          var defaultProps;
          element.type && element.type.defaultProps && (defaultProps = element.type.defaultProps);
          for (propName in config2)
            hasOwnProperty.call(config2, propName) && !RESERVED_PROPS.hasOwnProperty(propName) && (config2[propName] === void 0 && defaultProps !== void 0 ? props[propName] = defaultProps[propName] : props[propName] = config2[propName]);
        }
        var childrenLength = arguments.length - 2;
        if (childrenLength === 1)
          props.children = children;
        else if (childrenLength > 1) {
          for (var childArray = Array(childrenLength), i = 0; i < childrenLength; i++)
            childArray[i] = arguments[i + 2];
          props.children = childArray;
        }
        return ReactElement(element.type, key, ref, self2, source, owner, props);
      }
      function isValidElement(object) {
        return typeof object == "object" && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
      }
      var SEPARATOR = ".", SUBSEPARATOR = ":";
      function escape2(key) {
        var escapeRegex = /[=:]/g, escaperLookup = {
          "=": "=0",
          ":": "=2"
        }, escapedString = key.replace(escapeRegex, function(match2) {
          return escaperLookup[match2];
        });
        return "$" + escapedString;
      }
      var didWarnAboutMaps = !1, userProvidedKeyEscapeRegex = /\/+/g;
      function escapeUserProvidedKey(text) {
        return text.replace(userProvidedKeyEscapeRegex, "$&/");
      }
      function getElementKey(element, index) {
        return typeof element == "object" && element !== null && element.key != null ? escape2("" + element.key) : index.toString(36);
      }
      function mapIntoArray(children, array, escapedPrefix, nameSoFar, callback) {
        var type = typeof children;
        (type === "undefined" || type === "boolean") && (children = null);
        var invokeCallback = !1;
        if (children === null)
          invokeCallback = !0;
        else
          switch (type) {
            case "string":
            case "number":
              invokeCallback = !0;
              break;
            case "object":
              switch (children.$$typeof) {
                case REACT_ELEMENT_TYPE:
                case REACT_PORTAL_TYPE:
                  invokeCallback = !0;
              }
          }
        if (invokeCallback) {
          var _child = children, mappedChild = callback(_child), childKey = nameSoFar === "" ? SEPARATOR + getElementKey(_child, 0) : nameSoFar;
          if (Array.isArray(mappedChild)) {
            var escapedChildKey = "";
            childKey != null && (escapedChildKey = escapeUserProvidedKey(childKey) + "/"), mapIntoArray(mappedChild, array, escapedChildKey, "", function(c) {
              return c;
            });
          } else
            mappedChild != null && (isValidElement(mappedChild) && (mappedChild = cloneAndReplaceKey(
              mappedChild,
              // Keep both the (mapped) and old keys if they differ, just as
              // traverseAllChildren used to do for objects as children
              escapedPrefix + // $FlowFixMe Flow incorrectly thinks React.Portal doesn't have a key
              (mappedChild.key && (!_child || _child.key !== mappedChild.key) ? (
                // $FlowFixMe Flow incorrectly thinks existing element's key can be a number
                escapeUserProvidedKey("" + mappedChild.key) + "/"
              ) : "") + childKey
            )), array.push(mappedChild));
          return 1;
        }
        var child, nextName, subtreeCount = 0, nextNamePrefix = nameSoFar === "" ? SEPARATOR : nameSoFar + SUBSEPARATOR;
        if (Array.isArray(children))
          for (var i = 0; i < children.length; i++)
            child = children[i], nextName = nextNamePrefix + getElementKey(child, i), subtreeCount += mapIntoArray(child, array, escapedPrefix, nextName, callback);
        else {
          var iteratorFn = getIteratorFn(children);
          if (typeof iteratorFn == "function") {
            var iterableChildren = children;
            iteratorFn === iterableChildren.entries && (didWarnAboutMaps || warn("Using Maps as children is not supported. Use an array of keyed ReactElements instead."), didWarnAboutMaps = !0);
            for (var iterator = iteratorFn.call(iterableChildren), step, ii = 0; !(step = iterator.next()).done; )
              child = step.value, nextName = nextNamePrefix + getElementKey(child, ii++), subtreeCount += mapIntoArray(child, array, escapedPrefix, nextName, callback);
          } else if (type === "object") {
            var childrenString = "" + children;
            throw Error("Objects are not valid as a React child (found: " + (childrenString === "[object Object]" ? "object with keys {" + Object.keys(children).join(", ") + "}" : childrenString) + "). If you meant to render a collection of children, use an array instead.");
          }
        }
        return subtreeCount;
      }
      function mapChildren(children, func, context) {
        if (children == null)
          return children;
        var result = [], count = 0;
        return mapIntoArray(children, result, "", "", function(child) {
          return func.call(context, child, count++);
        }), result;
      }
      function countChildren(children) {
        var n = 0;
        return mapChildren(children, function() {
          n++;
        }), n;
      }
      function forEachChildren(children, forEachFunc, forEachContext) {
        mapChildren(children, function() {
          forEachFunc.apply(this, arguments);
        }, forEachContext);
      }
      function toArray(children) {
        return mapChildren(children, function(child) {
          return child;
        }) || [];
      }
      function onlyChild(children) {
        if (!isValidElement(children))
          throw Error("React.Children.only expected to receive a single React element child.");
        return children;
      }
      function createContext(defaultValue, calculateChangedBits) {
        calculateChangedBits === void 0 ? calculateChangedBits = null : calculateChangedBits !== null && typeof calculateChangedBits != "function" && error("createContext: Expected the optional second argument to be a function. Instead received: %s", calculateChangedBits);
        var context = {
          $$typeof: REACT_CONTEXT_TYPE,
          _calculateChangedBits: calculateChangedBits,
          // As a workaround to support multiple concurrent renderers, we categorize
          // some renderers as primary and others as secondary. We only expect
          // there to be two concurrent renderers at most: React Native (primary) and
          // Fabric (secondary); React DOM (primary) and React ART (secondary).
          // Secondary renderers store their context values on separate fields.
          _currentValue: defaultValue,
          _currentValue2: defaultValue,
          // Used to track how many concurrent renderers this context currently
          // supports within in a single renderer. Such as parallel server rendering.
          _threadCount: 0,
          // These are circular
          Provider: null,
          Consumer: null
        };
        context.Provider = {
          $$typeof: REACT_PROVIDER_TYPE,
          _context: context
        };
        var hasWarnedAboutUsingNestedContextConsumers = !1, hasWarnedAboutUsingConsumerProvider = !1, hasWarnedAboutDisplayNameOnConsumer = !1;
        {
          var Consumer = {
            $$typeof: REACT_CONTEXT_TYPE,
            _context: context,
            _calculateChangedBits: context._calculateChangedBits
          };
          Object.defineProperties(Consumer, {
            Provider: {
              get: function() {
                return hasWarnedAboutUsingConsumerProvider || (hasWarnedAboutUsingConsumerProvider = !0, error("Rendering <Context.Consumer.Provider> is not supported and will be removed in a future major release. Did you mean to render <Context.Provider> instead?")), context.Provider;
              },
              set: function(_Provider) {
                context.Provider = _Provider;
              }
            },
            _currentValue: {
              get: function() {
                return context._currentValue;
              },
              set: function(_currentValue) {
                context._currentValue = _currentValue;
              }
            },
            _currentValue2: {
              get: function() {
                return context._currentValue2;
              },
              set: function(_currentValue2) {
                context._currentValue2 = _currentValue2;
              }
            },
            _threadCount: {
              get: function() {
                return context._threadCount;
              },
              set: function(_threadCount) {
                context._threadCount = _threadCount;
              }
            },
            Consumer: {
              get: function() {
                return hasWarnedAboutUsingNestedContextConsumers || (hasWarnedAboutUsingNestedContextConsumers = !0, error("Rendering <Context.Consumer.Consumer> is not supported and will be removed in a future major release. Did you mean to render <Context.Consumer> instead?")), context.Consumer;
              }
            },
            displayName: {
              get: function() {
                return context.displayName;
              },
              set: function(displayName) {
                hasWarnedAboutDisplayNameOnConsumer || (warn("Setting `displayName` on Context.Consumer has no effect. You should set it directly on the context with Context.displayName = '%s'.", displayName), hasWarnedAboutDisplayNameOnConsumer = !0);
              }
            }
          }), context.Consumer = Consumer;
        }
        return context._currentRenderer = null, context._currentRenderer2 = null, context;
      }
      var Uninitialized = -1, Pending = 0, Resolved = 1, Rejected = 2;
      function lazyInitializer(payload) {
        if (payload._status === Uninitialized) {
          var ctor = payload._result, thenable = ctor(), pending = payload;
          pending._status = Pending, pending._result = thenable, thenable.then(function(moduleObject) {
            if (payload._status === Pending) {
              var defaultExport = moduleObject.default;
              defaultExport === void 0 && error(`lazy: Expected the result of a dynamic import() call. Instead received: %s

Your code should look like: 
  const MyComponent = lazy(() => import('./MyComponent'))`, moduleObject);
              var resolved = payload;
              resolved._status = Resolved, resolved._result = defaultExport;
            }
          }, function(error2) {
            if (payload._status === Pending) {
              var rejected = payload;
              rejected._status = Rejected, rejected._result = error2;
            }
          });
        }
        if (payload._status === Resolved)
          return payload._result;
        throw payload._result;
      }
      function lazy(ctor) {
        var payload = {
          // We use these fields to store the result.
          _status: -1,
          _result: ctor
        }, lazyType = {
          $$typeof: REACT_LAZY_TYPE,
          _payload: payload,
          _init: lazyInitializer
        };
        {
          var defaultProps, propTypes;
          Object.defineProperties(lazyType, {
            defaultProps: {
              configurable: !0,
              get: function() {
                return defaultProps;
              },
              set: function(newDefaultProps) {
                error("React.lazy(...): It is not supported to assign `defaultProps` to a lazy component import. Either specify them where the component is defined, or create a wrapping component around it."), defaultProps = newDefaultProps, Object.defineProperty(lazyType, "defaultProps", {
                  enumerable: !0
                });
              }
            },
            propTypes: {
              configurable: !0,
              get: function() {
                return propTypes;
              },
              set: function(newPropTypes) {
                error("React.lazy(...): It is not supported to assign `propTypes` to a lazy component import. Either specify them where the component is defined, or create a wrapping component around it."), propTypes = newPropTypes, Object.defineProperty(lazyType, "propTypes", {
                  enumerable: !0
                });
              }
            }
          });
        }
        return lazyType;
      }
      function forwardRef(render3) {
        render3 != null && render3.$$typeof === REACT_MEMO_TYPE ? error("forwardRef requires a render function but received a `memo` component. Instead of forwardRef(memo(...)), use memo(forwardRef(...)).") : typeof render3 != "function" ? error("forwardRef requires a render function but was given %s.", render3 === null ? "null" : typeof render3) : render3.length !== 0 && render3.length !== 2 && error("forwardRef render functions accept exactly two parameters: props and ref. %s", render3.length === 1 ? "Did you forget to use the ref parameter?" : "Any additional parameter will be undefined."), render3 != null && (render3.defaultProps != null || render3.propTypes != null) && error("forwardRef render functions do not support propTypes or defaultProps. Did you accidentally pass a React component?");
        var elementType = {
          $$typeof: REACT_FORWARD_REF_TYPE,
          render: render3
        };
        {
          var ownName;
          Object.defineProperty(elementType, "displayName", {
            enumerable: !1,
            configurable: !0,
            get: function() {
              return ownName;
            },
            set: function(name) {
              ownName = name, render3.displayName == null && (render3.displayName = name);
            }
          });
        }
        return elementType;
      }
      var enableScopeAPI = !1;
      function isValidElementType(type) {
        return !!(typeof type == "string" || typeof type == "function" || type === exports.Fragment || type === exports.Profiler || type === REACT_DEBUG_TRACING_MODE_TYPE || type === exports.StrictMode || type === exports.Suspense || type === REACT_SUSPENSE_LIST_TYPE || type === REACT_LEGACY_HIDDEN_TYPE || enableScopeAPI || typeof type == "object" && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_BLOCK_TYPE || type[0] === REACT_SERVER_BLOCK_TYPE));
      }
      function memo(type, compare2) {
        isValidElementType(type) || error("memo: The first argument must be a component. Instead received: %s", type === null ? "null" : typeof type);
        var elementType = {
          $$typeof: REACT_MEMO_TYPE,
          type,
          compare: compare2 === void 0 ? null : compare2
        };
        {
          var ownName;
          Object.defineProperty(elementType, "displayName", {
            enumerable: !1,
            configurable: !0,
            get: function() {
              return ownName;
            },
            set: function(name) {
              ownName = name, type.displayName == null && (type.displayName = name);
            }
          });
        }
        return elementType;
      }
      function resolveDispatcher() {
        var dispatcher = ReactCurrentDispatcher.current;
        if (dispatcher === null)
          throw Error(`Invalid hook call. Hooks can only be called inside of the body of a function component. This could happen for one of the following reasons:
1. You might have mismatching versions of React and the renderer (such as React DOM)
2. You might be breaking the Rules of Hooks
3. You might have more than one copy of React in the same app
See https://reactjs.org/link/invalid-hook-call for tips about how to debug and fix this problem.`);
        return dispatcher;
      }
      function useContext(Context, unstable_observedBits) {
        var dispatcher = resolveDispatcher();
        if (unstable_observedBits !== void 0 && error("useContext() second argument is reserved for future use in React. Passing it is not supported. You passed: %s.%s", unstable_observedBits, typeof unstable_observedBits == "number" && Array.isArray(arguments[2]) ? `

Did you call array.map(useContext)? Calling Hooks inside a loop is not supported. Learn more at https://reactjs.org/link/rules-of-hooks` : ""), Context._context !== void 0) {
          var realContext = Context._context;
          realContext.Consumer === Context ? error("Calling useContext(Context.Consumer) is not supported, may cause bugs, and will be removed in a future major release. Did you mean to call useContext(Context) instead?") : realContext.Provider === Context && error("Calling useContext(Context.Provider) is not supported. Did you mean to call useContext(Context) instead?");
        }
        return dispatcher.useContext(Context, unstable_observedBits);
      }
      function useState4(initialState) {
        var dispatcher = resolveDispatcher();
        return dispatcher.useState(initialState);
      }
      function useReducer(reducer, initialArg, init4) {
        var dispatcher = resolveDispatcher();
        return dispatcher.useReducer(reducer, initialArg, init4);
      }
      function useRef2(initialValue) {
        var dispatcher = resolveDispatcher();
        return dispatcher.useRef(initialValue);
      }
      function useEffect4(create, deps) {
        var dispatcher = resolveDispatcher();
        return dispatcher.useEffect(create, deps);
      }
      function useLayoutEffect(create, deps) {
        var dispatcher = resolveDispatcher();
        return dispatcher.useLayoutEffect(create, deps);
      }
      function useCallback(callback, deps) {
        var dispatcher = resolveDispatcher();
        return dispatcher.useCallback(callback, deps);
      }
      function useMemo2(create, deps) {
        var dispatcher = resolveDispatcher();
        return dispatcher.useMemo(create, deps);
      }
      function useImperativeHandle(ref, create, deps) {
        var dispatcher = resolveDispatcher();
        return dispatcher.useImperativeHandle(ref, create, deps);
      }
      function useDebugValue(value, formatterFn) {
        {
          var dispatcher = resolveDispatcher();
          return dispatcher.useDebugValue(value, formatterFn);
        }
      }
      var disabledDepth = 0, prevLog, prevInfo, prevWarn, prevError, prevGroup, prevGroupCollapsed, prevGroupEnd;
      function disabledLog() {
      }
      disabledLog.__reactDisabledLog = !0;
      function disableLogs() {
        {
          if (disabledDepth === 0) {
            prevLog = console.log, prevInfo = console.info, prevWarn = console.warn, prevError = console.error, prevGroup = console.group, prevGroupCollapsed = console.groupCollapsed, prevGroupEnd = console.groupEnd;
            var props = {
              configurable: !0,
              enumerable: !0,
              value: disabledLog,
              writable: !0
            };
            Object.defineProperties(console, {
              info: props,
              log: props,
              warn: props,
              error: props,
              group: props,
              groupCollapsed: props,
              groupEnd: props
            });
          }
          disabledDepth++;
        }
      }
      function reenableLogs() {
        {
          if (disabledDepth--, disabledDepth === 0) {
            var props = {
              configurable: !0,
              enumerable: !0,
              writable: !0
            };
            Object.defineProperties(console, {
              log: _assign({}, props, {
                value: prevLog
              }),
              info: _assign({}, props, {
                value: prevInfo
              }),
              warn: _assign({}, props, {
                value: prevWarn
              }),
              error: _assign({}, props, {
                value: prevError
              }),
              group: _assign({}, props, {
                value: prevGroup
              }),
              groupCollapsed: _assign({}, props, {
                value: prevGroupCollapsed
              }),
              groupEnd: _assign({}, props, {
                value: prevGroupEnd
              })
            });
          }
          disabledDepth < 0 && error("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
        }
      }
      var ReactCurrentDispatcher$1 = ReactSharedInternals.ReactCurrentDispatcher, prefix;
      function describeBuiltInComponentFrame(name, source, ownerFn) {
        {
          if (prefix === void 0)
            try {
              throw Error();
            } catch (x) {
              var match2 = x.stack.trim().match(/\n( *(at )?)/);
              prefix = match2 && match2[1] || "";
            }
          return `
` + prefix + name;
        }
      }
      var reentry = !1, componentFrameCache;
      {
        var PossiblyWeakMap = typeof WeakMap == "function" ? WeakMap : Map;
        componentFrameCache = new PossiblyWeakMap();
      }
      function describeNativeComponentFrame(fn, construct) {
        if (!fn || reentry)
          return "";
        {
          var frame = componentFrameCache.get(fn);
          if (frame !== void 0)
            return frame;
        }
        var control;
        reentry = !0;
        var previousPrepareStackTrace = Error.prepareStackTrace;
        Error.prepareStackTrace = void 0;
        var previousDispatcher;
        previousDispatcher = ReactCurrentDispatcher$1.current, ReactCurrentDispatcher$1.current = null, disableLogs();
        try {
          if (construct) {
            var Fake = function() {
              throw Error();
            };
            if (Object.defineProperty(Fake.prototype, "props", {
              set: function() {
                throw Error();
              }
            }), typeof Reflect == "object" && Reflect.construct) {
              try {
                Reflect.construct(Fake, []);
              } catch (x) {
                control = x;
              }
              Reflect.construct(fn, [], Fake);
            } else {
              try {
                Fake.call();
              } catch (x) {
                control = x;
              }
              fn.call(Fake.prototype);
            }
          } else {
            try {
              throw Error();
            } catch (x) {
              control = x;
            }
            fn();
          }
        } catch (sample) {
          if (sample && control && typeof sample.stack == "string") {
            for (var sampleLines = sample.stack.split(`
`), controlLines = control.stack.split(`
`), s = sampleLines.length - 1, c = controlLines.length - 1; s >= 1 && c >= 0 && sampleLines[s] !== controlLines[c]; )
              c--;
            for (; s >= 1 && c >= 0; s--, c--)
              if (sampleLines[s] !== controlLines[c]) {
                if (s !== 1 || c !== 1)
                  do
                    if (s--, c--, c < 0 || sampleLines[s] !== controlLines[c]) {
                      var _frame = `
` + sampleLines[s].replace(" at new ", " at ");
                      return typeof fn == "function" && componentFrameCache.set(fn, _frame), _frame;
                    }
                  while (s >= 1 && c >= 0);
                break;
              }
          }
        } finally {
          reentry = !1, ReactCurrentDispatcher$1.current = previousDispatcher, reenableLogs(), Error.prepareStackTrace = previousPrepareStackTrace;
        }
        var name = fn ? fn.displayName || fn.name : "", syntheticFrame = name ? describeBuiltInComponentFrame(name) : "";
        return typeof fn == "function" && componentFrameCache.set(fn, syntheticFrame), syntheticFrame;
      }
      function describeFunctionComponentFrame(fn, source, ownerFn) {
        return describeNativeComponentFrame(fn, !1);
      }
      function shouldConstruct(Component2) {
        var prototype = Component2.prototype;
        return !!(prototype && prototype.isReactComponent);
      }
      function describeUnknownElementTypeFrameInDEV(type, source, ownerFn) {
        if (type == null)
          return "";
        if (typeof type == "function")
          return describeNativeComponentFrame(type, shouldConstruct(type));
        if (typeof type == "string")
          return describeBuiltInComponentFrame(type);
        switch (type) {
          case exports.Suspense:
            return describeBuiltInComponentFrame("Suspense");
          case REACT_SUSPENSE_LIST_TYPE:
            return describeBuiltInComponentFrame("SuspenseList");
        }
        if (typeof type == "object")
          switch (type.$$typeof) {
            case REACT_FORWARD_REF_TYPE:
              return describeFunctionComponentFrame(type.render);
            case REACT_MEMO_TYPE:
              return describeUnknownElementTypeFrameInDEV(type.type, source, ownerFn);
            case REACT_BLOCK_TYPE:
              return describeFunctionComponentFrame(type._render);
            case REACT_LAZY_TYPE: {
              var lazyComponent = type, payload = lazyComponent._payload, init4 = lazyComponent._init;
              try {
                return describeUnknownElementTypeFrameInDEV(init4(payload), source, ownerFn);
              } catch {
              }
            }
          }
        return "";
      }
      var loggedTypeFailures = {}, ReactDebugCurrentFrame$1 = ReactSharedInternals.ReactDebugCurrentFrame;
      function setCurrentlyValidatingElement(element) {
        if (element) {
          var owner = element._owner, stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
          ReactDebugCurrentFrame$1.setExtraStackFrame(stack);
        } else
          ReactDebugCurrentFrame$1.setExtraStackFrame(null);
      }
      function checkPropTypes(typeSpecs, values, location2, componentName, element) {
        {
          var has2 = Function.call.bind(Object.prototype.hasOwnProperty);
          for (var typeSpecName in typeSpecs)
            if (has2(typeSpecs, typeSpecName)) {
              var error$1 = void 0;
              try {
                if (typeof typeSpecs[typeSpecName] != "function") {
                  var err2 = Error((componentName || "React class") + ": " + location2 + " type `" + typeSpecName + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof typeSpecs[typeSpecName] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                  throw err2.name = "Invariant Violation", err2;
                }
                error$1 = typeSpecs[typeSpecName](values, typeSpecName, componentName, location2, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
              } catch (ex) {
                error$1 = ex;
              }
              error$1 && !(error$1 instanceof Error) && (setCurrentlyValidatingElement(element), error("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", componentName || "React class", location2, typeSpecName, typeof error$1), setCurrentlyValidatingElement(null)), error$1 instanceof Error && !(error$1.message in loggedTypeFailures) && (loggedTypeFailures[error$1.message] = !0, setCurrentlyValidatingElement(element), error("Failed %s type: %s", location2, error$1.message), setCurrentlyValidatingElement(null));
            }
        }
      }
      function setCurrentlyValidatingElement$1(element) {
        if (element) {
          var owner = element._owner, stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
          setExtraStackFrame(stack);
        } else
          setExtraStackFrame(null);
      }
      var propTypesMisspellWarningShown;
      propTypesMisspellWarningShown = !1;
      function getDeclarationErrorAddendum() {
        if (ReactCurrentOwner.current) {
          var name = getComponentName(ReactCurrentOwner.current.type);
          if (name)
            return `

Check the render method of \`` + name + "`.";
        }
        return "";
      }
      function getSourceInfoErrorAddendum(source) {
        if (source !== void 0) {
          var fileName = source.fileName.replace(/^.*[\\\/]/, ""), lineNumber = source.lineNumber;
          return `

Check your code at ` + fileName + ":" + lineNumber + ".";
        }
        return "";
      }
      function getSourceInfoErrorAddendumForProps(elementProps) {
        return elementProps != null ? getSourceInfoErrorAddendum(elementProps.__source) : "";
      }
      var ownerHasKeyUseWarning = {};
      function getCurrentComponentErrorInfo(parentType) {
        var info2 = getDeclarationErrorAddendum();
        if (!info2) {
          var parentName = typeof parentType == "string" ? parentType : parentType.displayName || parentType.name;
          parentName && (info2 = `

Check the top-level render call using <` + parentName + ">.");
        }
        return info2;
      }
      function validateExplicitKey(element, parentType) {
        if (!(!element._store || element._store.validated || element.key != null)) {
          element._store.validated = !0;
          var currentComponentErrorInfo = getCurrentComponentErrorInfo(parentType);
          if (!ownerHasKeyUseWarning[currentComponentErrorInfo]) {
            ownerHasKeyUseWarning[currentComponentErrorInfo] = !0;
            var childOwner = "";
            element && element._owner && element._owner !== ReactCurrentOwner.current && (childOwner = " It was passed a child from " + getComponentName(element._owner.type) + "."), setCurrentlyValidatingElement$1(element), error('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', currentComponentErrorInfo, childOwner), setCurrentlyValidatingElement$1(null);
          }
        }
      }
      function validateChildKeys(node, parentType) {
        if (typeof node == "object") {
          if (Array.isArray(node))
            for (var i = 0; i < node.length; i++) {
              var child = node[i];
              isValidElement(child) && validateExplicitKey(child, parentType);
            }
          else if (isValidElement(node))
            node._store && (node._store.validated = !0);
          else if (node) {
            var iteratorFn = getIteratorFn(node);
            if (typeof iteratorFn == "function" && iteratorFn !== node.entries)
              for (var iterator = iteratorFn.call(node), step; !(step = iterator.next()).done; )
                isValidElement(step.value) && validateExplicitKey(step.value, parentType);
          }
        }
      }
      function validatePropTypes(element) {
        {
          var type = element.type;
          if (type == null || typeof type == "string")
            return;
          var propTypes;
          if (typeof type == "function")
            propTypes = type.propTypes;
          else if (typeof type == "object" && (type.$$typeof === REACT_FORWARD_REF_TYPE || // Note: Memo only checks outer props here.
          // Inner props are checked in the reconciler.
          type.$$typeof === REACT_MEMO_TYPE))
            propTypes = type.propTypes;
          else
            return;
          if (propTypes) {
            var name = getComponentName(type);
            checkPropTypes(propTypes, element.props, "prop", name, element);
          } else if (type.PropTypes !== void 0 && !propTypesMisspellWarningShown) {
            propTypesMisspellWarningShown = !0;
            var _name = getComponentName(type);
            error("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", _name || "Unknown");
          }
          typeof type.getDefaultProps == "function" && !type.getDefaultProps.isReactClassApproved && error("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
        }
      }
      function validateFragmentProps(fragment) {
        {
          for (var keys = Object.keys(fragment.props), i = 0; i < keys.length; i++) {
            var key = keys[i];
            if (key !== "children" && key !== "key") {
              setCurrentlyValidatingElement$1(fragment), error("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", key), setCurrentlyValidatingElement$1(null);
              break;
            }
          }
          fragment.ref !== null && (setCurrentlyValidatingElement$1(fragment), error("Invalid attribute `ref` supplied to `React.Fragment`."), setCurrentlyValidatingElement$1(null));
        }
      }
      function createElementWithValidation(type, props, children) {
        var validType = isValidElementType(type);
        if (!validType) {
          var info2 = "";
          (type === void 0 || typeof type == "object" && type !== null && Object.keys(type).length === 0) && (info2 += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
          var sourceInfo = getSourceInfoErrorAddendumForProps(props);
          sourceInfo ? info2 += sourceInfo : info2 += getDeclarationErrorAddendum();
          var typeString;
          type === null ? typeString = "null" : Array.isArray(type) ? typeString = "array" : type !== void 0 && type.$$typeof === REACT_ELEMENT_TYPE ? (typeString = "<" + (getComponentName(type.type) || "Unknown") + " />", info2 = " Did you accidentally export a JSX literal instead of a component?") : typeString = typeof type, error("React.createElement: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", typeString, info2);
        }
        var element = createElement.apply(this, arguments);
        if (element == null)
          return element;
        if (validType)
          for (var i = 2; i < arguments.length; i++)
            validateChildKeys(arguments[i], type);
        return type === exports.Fragment ? validateFragmentProps(element) : validatePropTypes(element), element;
      }
      var didWarnAboutDeprecatedCreateFactory = !1;
      function createFactoryWithValidation(type) {
        var validatedFactory = createElementWithValidation.bind(null, type);
        return validatedFactory.type = type, didWarnAboutDeprecatedCreateFactory || (didWarnAboutDeprecatedCreateFactory = !0, warn("React.createFactory() is deprecated and will be removed in a future major release. Consider using JSX or use React.createElement() directly instead.")), Object.defineProperty(validatedFactory, "type", {
          enumerable: !1,
          get: function() {
            return warn("Factory.type is deprecated. Access the class directly before passing it to createFactory."), Object.defineProperty(this, "type", {
              value: type
            }), type;
          }
        }), validatedFactory;
      }
      function cloneElementWithValidation(element, props, children) {
        for (var newElement = cloneElement.apply(this, arguments), i = 2; i < arguments.length; i++)
          validateChildKeys(arguments[i], newElement.type);
        return validatePropTypes(newElement), newElement;
      }
      try {
        var frozenObject = Object.freeze({});
      } catch {
      }
      var createElement$1 = createElementWithValidation, cloneElement$1 = cloneElementWithValidation, createFactory = createFactoryWithValidation, Children = {
        map: mapChildren,
        forEach: forEachChildren,
        count: countChildren,
        toArray,
        only: onlyChild
      };
      exports.Children = Children, exports.Component = Component, exports.PureComponent = PureComponent, exports.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = ReactSharedInternals, exports.cloneElement = cloneElement$1, exports.createContext = createContext, exports.createElement = createElement$1, exports.createFactory = createFactory, exports.createRef = createRef, exports.forwardRef = forwardRef, exports.isValidElement = isValidElement, exports.lazy = lazy, exports.memo = memo, exports.useCallback = useCallback, exports.useContext = useContext, exports.useDebugValue = useDebugValue, exports.useEffect = useEffect4, exports.useImperativeHandle = useImperativeHandle, exports.useLayoutEffect = useLayoutEffect, exports.useMemo = useMemo2, exports.useReducer = useReducer, exports.useRef = useRef2, exports.useState = useState4, exports.version = ReactVersion;
    }();
  }
});

// ../../node_modules/.pnpm/react@17.0.2/node_modules/react/index.js
var require_react2 = __commonJS({
  "../../node_modules/.pnpm/react@17.0.2/node_modules/react/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    process.env.NODE_ENV === "production" ? module.exports = require_react_production_min() : module.exports = require_react_development();
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AdjustIcon.svg.js
var require_AdjustIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AdjustIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgAdjustIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9.095 6.25a3.001 3.001 0 0 1 5.81 0h1.345a.75.75 0 0 1 0 1.5h-1.345a3.001 3.001 0 0 1-5.81 0h-5.345a.75.75 0 0 1 0-1.5h5.345Zm1.405.75a1.5 1.5 0 1 1 3 0 1.5 1.5 0 0 1-3 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8 16a3.001 3.001 0 0 0 2.905-2.25h5.345a.75.75 0 0 0 0-1.5h-5.345a3.001 3.001 0 0 0-5.81 0h-1.345a.75.75 0 0 0 0 1.5h1.345a3.001 3.001 0 0 0 2.905 2.25Zm1.5-3a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0Z"
      }));
    };
    SvgAdjustIcon.displayName = "AdjustIcon";
    exports.SvgAdjustIcon = SvgAdjustIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AffiliateIcon.svg.js
var require_AffiliateIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AffiliateIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgAffiliateIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M16.5 6a2.5 2.5 0 0 1-3.656 2.217l-2.896 2.896c.35.544.552 1.192.552 1.887v.023l1.148.128a2.501 2.501 0 1 1-.062 1.502l-1.419-.158v-.005a3.5 3.5 0 1 1-4.372-4.777l-.17-1.24a2.5 2.5 0 1 1 1.483-.231l.173 1.27a3.48 3.48 0 0 1 1.606.54l2.896-2.896a2.5 2.5 0 1 1 4.717-1.156Zm-1.5 0a1 1 0 1 1-2 0 1 1 0 0 1 2 0Zm-8 9a2 2 0 1 0 0-4 2 2 0 0 0 0 4Zm7 0a1 1 0 1 0 0-2 1 1 0 0 0 0 2Zm-7-9a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }));
    };
    SvgAffiliateIcon.displayName = "AffiliateIcon";
    exports.SvgAffiliateIcon = SvgAffiliateIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AirplaneIcon.svg.js
var require_AirplaneIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AirplaneIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgAirplaneIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15.259 12.25c1.35 0 2.192-1.465 1.512-2.632l-.294-.504a2.75 2.75 0 0 0-2.376-1.364h-1.612l-1.368-2.21a3.25 3.25 0 0 0-2.764-1.54h-.607a.75.75 0 0 0-.742.856l.413 2.894h-.133l-.205-.443a2.25 2.25 0 0 0-2.043-1.307h-1.29a.75.75 0 0 0-.734.905l1 4.75a.75.75 0 0 0 .734.595h2.671l-.413 2.894a.75.75 0 0 0 .742.856h.607a3.25 3.25 0 0 0 2.764-1.54l1.368-2.21h2.77Zm-4.534-4.5-.88-1.421a1.75 1.75 0 0 0-1.227-.81l.318 2.231h1.79Zm-2.726 1.5h-1.191a.75.75 0 0 1-.681-.436l-.406-.878a.75.75 0 0 0-.68-.436h-.367l.685 3.25h2.927a.75.75 0 0 1 .742.856l-.41 2.875a1.75 1.75 0 0 0 1.227-.81l1.589-2.566a.75.75 0 0 1 .637-.355h3.188a.25.25 0 0 0 .216-.376l-.294-.504a1.25 1.25 0 0 0-1.08-.62h-6.102Z"
      }));
    };
    SvgAirplaneIcon.displayName = "AirplaneIcon";
    exports.SvgAirplaneIcon = SvgAirplaneIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AlertBubbleIcon.svg.js
var require_AlertBubbleIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AlertBubbleIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgAlertBubbleIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 6a.75.75 0 0 1 .75.75v2.5a.75.75 0 0 1-1.5 0v-2.5a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 13a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 8.25a4.75 4.75 0 0 1 4.75-4.75h3.5a4.75 4.75 0 0 1 4.75 4.75v2.5a4.75 4.75 0 0 1-4.573 4.747l-1.335 1.714a.75.75 0 0 1-1.189-.006l-1.3-1.707a4.75 4.75 0 0 1-4.603-4.748v-2.5Zm4.75-3.25a3.25 3.25 0 0 0-3.25 3.25v2.5a3.25 3.25 0 0 0 3.25 3.25h.226a.75.75 0 0 1 .597.296l.934 1.225.96-1.232a.75.75 0 0 1 .591-.289h.192a3.25 3.25 0 0 0 3.25-3.25v-2.5a3.25 3.25 0 0 0-3.25-3.25h-3.5Z"
      }));
    };
    SvgAlertBubbleIcon.displayName = "AlertBubbleIcon";
    exports.SvgAlertBubbleIcon = SvgAlertBubbleIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AlertCircleIcon.svg.js
var require_AlertCircleIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AlertCircleIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgAlertCircleIcon3 = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 6a.75.75 0 0 1 .75.75v3.5a.75.75 0 0 1-1.5 0v-3.5a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 13a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-1.5 0a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Z"
      }));
    };
    SvgAlertCircleIcon3.displayName = "AlertCircleIcon";
    exports.SvgAlertCircleIcon = SvgAlertCircleIcon3;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AlertDiamondIcon.svg.js
var require_AlertDiamondIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AlertDiamondIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgAlertDiamondIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 6a.75.75 0 0 1 .75.75v3.5a.75.75 0 0 1-1.5 0v-3.5a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 13a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11.237 3.177a1.75 1.75 0 0 0-2.474 0l-5.586 5.585a1.75 1.75 0 0 0 0 2.475l5.586 5.586a1.75 1.75 0 0 0 2.474 0l5.586-5.586a1.75 1.75 0 0 0 0-2.475l-5.586-5.585Zm-1.414 1.06a.25.25 0 0 1 .354 0l5.586 5.586a.25.25 0 0 1 0 .354l-5.586 5.585a.25.25 0 0 1-.354 0l-5.586-5.585a.25.25 0 0 1 0-.354l5.586-5.586Z"
      }));
    };
    SvgAlertDiamondIcon.displayName = "AlertDiamondIcon";
    exports.SvgAlertDiamondIcon = SvgAlertDiamondIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AlertTriangleIcon.svg.js
var require_AlertTriangleIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AlertTriangleIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgAlertTriangleIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 6.75a.75.75 0 0 1 .75.75v3.5a.75.75 0 1 1-1.5 0v-3.5a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 13.5a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 3.5c-1.045 0-1.784.702-2.152 1.447a449.26 449.26 0 0 1-2.005 3.847l-.028.052a403.426 403.426 0 0 0-2.008 3.856c-.372.752-.478 1.75.093 2.614.57.863 1.542 1.184 2.464 1.184h7.272c.922 0 1.895-.32 2.464-1.184.57-.864.465-1.862.093-2.614-.21-.424-1.113-2.147-2.004-3.847l-.032-.061a429.497 429.497 0 0 1-2.005-3.847c-.368-.745-1.107-1.447-2.152-1.447Zm-.808 2.112c.404-.816 1.212-.816 1.616 0 .202.409 1.112 2.145 2.022 3.88a418.904 418.904 0 0 1 2.018 3.875c.404.817 0 1.633-1.212 1.633h-7.272c-1.212 0-1.617-.816-1.212-1.633.202-.408 1.113-2.147 2.023-3.883a421.932 421.932 0 0 0 2.017-3.872Z"
      }));
    };
    SvgAlertTriangleIcon.displayName = "AlertTriangleIcon";
    exports.SvgAlertTriangleIcon = SvgAlertTriangleIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AppExtensionIcon.svg.js
var require_AppExtensionIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AppExtensionIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgAppExtensionIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.28 8.78a.75.75 0 0 1-1.06-1.06l3.22-3.22h-1.19a.75.75 0 0 1 0-1.5h3a.75.75 0 0 1 .75.75v3a.75.75 0 1 1-1.5 0v-1.19l-3.22 3.22Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.75 3.5a2.25 2.25 0 0 0-2.25 2.25v2.75a1 1 0 0 0 1 1h4a1 1 0 0 0 1-1v-4a1 1 0 0 0-1-1h-2.75Zm-.75 2.25a.75.75 0 0 1 .75-.75h2.25v3h-3v-2.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 14.25a2.25 2.25 0 0 0 2.25 2.25h2.75a1 1 0 0 0 1-1v-4a1 1 0 0 0-1-1h-4a1 1 0 0 0-1 1v2.75Zm2.25.75a.75.75 0 0 1-.75-.75v-2.25h3v3h-2.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M14.25 16.5a2.25 2.25 0 0 0 2.25-2.25v-2.75a1 1 0 0 0-1-1h-4a1 1 0 0 0-1 1v4a1 1 0 0 0 1 1h2.75Zm.75-2.25a.75.75 0 0 1-.75.75h-2.25v-3h3v2.25Z"
      }));
    };
    SvgAppExtensionIcon.displayName = "AppExtensionIcon";
    exports.SvgAppExtensionIcon = SvgAppExtensionIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AppsFilledIcon.svg.js
var require_AppsFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AppsFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgAppsFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.5 3.625c.483 0 .875.392.875.875v1.125h1.125a.875.875 0 0 1 0 1.75h-1.125v1.125a.875.875 0 0 1-1.75 0v-1.125h-1.125a.875.875 0 0 1 0-1.75h1.125v-1.125c0-.483.392-.875.875-.875Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.75 3.75a2 2 0 0 0-2 2v2.75c0 .414.336.75.75.75h4a.75.75 0 0 0 .75-.75v-4a.75.75 0 0 0-.75-.75h-2.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.75 14.25a2 2 0 0 0 2 2h2.75a.75.75 0 0 0 .75-.75v-4a.75.75 0 0 0-.75-.75h-4a.75.75 0 0 0-.75.75v2.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.25 16.25a2 2 0 0 0 2-2v-2.75a.75.75 0 0 0-.75-.75h-4a.75.75 0 0 0-.75.75v4c0 .414.336.75.75.75h2.75Z"
      }));
    };
    SvgAppsFilledIcon.displayName = "AppsFilledIcon";
    exports.SvgAppsFilledIcon = SvgAppsFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AppsIcon.svg.js
var require_AppsIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AppsIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgAppsIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 5.75a2.25 2.25 0 0 1 2.25-2.25h2.75a1 1 0 0 1 1 1v4a1 1 0 0 1-1 1h-4a1 1 0 0 1-1-1v-2.75Zm2.25-.75a.75.75 0 0 0-.75.75v2.25h3v-3h-2.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 14.25a2.25 2.25 0 0 0 2.25 2.25h2.75a1 1 0 0 0 1-1v-4a1 1 0 0 0-1-1h-4a1 1 0 0 0-1 1v2.75Zm2.25.75a.75.75 0 0 1-.75-.75v-2.25h3v3h-2.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M14.25 16.5a2.25 2.25 0 0 0 2.25-2.25v-2.75a1 1 0 0 0-1-1h-4a1 1 0 0 0-1 1v4a1 1 0 0 0 1 1h2.75Zm.75-2.25a.75.75 0 0 1-.75.75h-2.25v-3h3v2.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.5 3.5a.75.75 0 0 1 .75.75v1.5h1.5a.75.75 0 0 1 0 1.5h-1.5v1.5a.75.75 0 0 1-1.5 0v-1.5h-1.5a.75.75 0 0 1 0-1.5h1.5v-1.5a.75.75 0 0 1 .75-.75Z"
      }));
    };
    SvgAppsIcon.displayName = "AppsIcon";
    exports.SvgAppsIcon = SvgAppsIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ArchiveIcon.svg.js
var require_ArchiveIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ArchiveIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgArchiveIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.25 10.75a.75.75 0 0 1 .75-.75h2a.75.75 0 0 1 0 1.5h-2a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.25 3.5a1.75 1.75 0 0 0-1.75 1.75v2c0 .595.297 1.12.75 1.436v5.064a2.75 2.75 0 0 0 2.75 2.75h6a2.75 2.75 0 0 0 2.75-2.75v-5.064c.453-.316.75-.841.75-1.436v-2a1.75 1.75 0 0 0-1.75-1.75h-9.5Zm9 5.5h-8.5v4.75c0 .69.56 1.25 1.25 1.25h6c.69 0 1.25-.56 1.25-1.25v-4.75Zm-9.25-3.75a.25.25 0 0 1 .25-.25h9.5a.25.25 0 0 1 .25.25v2a.25.25 0 0 1-.25.25h-9.5a.25.25 0 0 1-.25-.25v-2Z"
      }));
    };
    SvgArchiveIcon.displayName = "ArchiveIcon";
    exports.SvgArchiveIcon = SvgArchiveIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ArrowDownIcon.svg.js
var require_ArrowDownIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ArrowDownIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgArrowDownIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 3.5a.75.75 0 0 1 .75.75v9.69l2.72-2.72a.75.75 0 0 1 1.06 1.06l-4 4a.75.75 0 0 1-1.06 0l-4-4a.75.75 0 0 1 1.06-1.06l2.72 2.72v-9.69a.75.75 0 0 1 .75-.75Z"
      }));
    };
    SvgArrowDownIcon.displayName = "ArrowDownIcon";
    exports.SvgArrowDownIcon = SvgArrowDownIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ArrowLeftIcon.svg.js
var require_ArrowLeftIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ArrowLeftIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgArrowLeftIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M16.5 10a.75.75 0 0 1-.75.75h-9.69l2.72 2.72a.75.75 0 0 1-1.06 1.06l-4-4a.75.75 0 0 1 0-1.06l4-4a.75.75 0 1 1 1.06 1.06l-2.72 2.72h9.69a.75.75 0 0 1 .75.75Z"
      }));
    };
    SvgArrowLeftIcon.displayName = "ArrowLeftIcon";
    exports.SvgArrowLeftIcon = SvgArrowLeftIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ArrowRightIcon.svg.js
var require_ArrowRightIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ArrowRightIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgArrowRightIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 10a.75.75 0 0 1 .75-.75h9.69l-2.72-2.72a.75.75 0 1 1 1.06-1.06l4 4a.75.75 0 0 1 0 1.06l-4 4a.75.75 0 0 1-1.06-1.06l2.72-2.72h-9.69a.75.75 0 0 1-.75-.75Z"
      }));
    };
    SvgArrowRightIcon.displayName = "ArrowRightIcon";
    exports.SvgArrowRightIcon = SvgArrowRightIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ArrowUpIcon.svg.js
var require_ArrowUpIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ArrowUpIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgArrowUpIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 16.5a.75.75 0 0 1-.75-.75v-9.69l-2.72 2.72a.75.75 0 1 1-1.06-1.06l4-4a.75.75 0 0 1 1.06 0l4 4a.75.75 0 1 1-1.06 1.06l-2.72-2.72v9.69a.75.75 0 0 1-.75.75Z"
      }));
    };
    SvgArrowUpIcon.displayName = "ArrowUpIcon";
    exports.SvgArrowUpIcon = SvgArrowUpIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ArrowsInHorizontalIcon.svg.js
var require_ArrowsInHorizontalIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ArrowsInHorizontalIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgArrowsInHorizontalIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.25 8.25a.75.75 0 0 0 0-1.5h-4.69l1.22-1.22a.75.75 0 0 0-1.06-1.06l-2.5 2.5a.75.75 0 0 0 0 1.06l2.5 2.5a.75.75 0 1 0 1.06-1.06l-1.22-1.22h4.69Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.75 11.75a.75.75 0 0 0 0 1.5h4.69l-1.22 1.22a.75.75 0 1 0 1.06 1.06l2.5-2.5a.75.75 0 0 0 0-1.06l-2.5-2.5a.75.75 0 0 0-1.06 1.06l1.22 1.22h-4.69Z"
      }));
    };
    SvgArrowsInHorizontalIcon.displayName = "ArrowsInHorizontalIcon";
    exports.SvgArrowsInHorizontalIcon = SvgArrowsInHorizontalIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ArrowsOutHorizontalFilledIcon.svg.js
var require_ArrowsOutHorizontalFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ArrowsOutHorizontalFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgArrowsOutHorizontalFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4 4a1 1 0 0 1 1 1v4h5.336l-1.293-1.293a1 1 0 0 1 1.414-1.414l3 3a1 1 0 0 1 0 1.414l-3 3a1 1 0 0 1-1.414-1.414l1.293-1.293h-5.336v4a1 1 0 1 1-2 0v-10a1 1 0 0 1 1-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16 4a1 1 0 0 1 1 1v10a1 1 0 1 1-2 0v-10a1 1 0 0 1 1-1Z"
      }));
    };
    SvgArrowsOutHorizontalFilledIcon.displayName = "ArrowsOutHorizontalFilledIcon";
    exports.SvgArrowsOutHorizontalFilledIcon = SvgArrowsOutHorizontalFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ArrowsOutHorizontalIcon.svg.js
var require_ArrowsOutHorizontalIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ArrowsOutHorizontalIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgArrowsOutHorizontalIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.25 8a.75.75 0 0 0 0-1.5h-7.19l1.22-1.22a.75.75 0 0 0-1.06-1.06l-2.5 2.5a.75.75 0 0 0 0 1.06l2.5 2.5a.75.75 0 1 0 1.06-1.06l-1.22-1.22h7.19Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.75 13.5a.75.75 0 0 1 0-1.5h7.19l-1.22-1.22a.75.75 0 1 1 1.06-1.06l2.5 2.5a.75.75 0 0 1 0 1.06l-2.5 2.5a.75.75 0 1 1-1.06-1.06l1.22-1.22h-7.19Z"
      }));
    };
    SvgArrowsOutHorizontalIcon.displayName = "ArrowsOutHorizontalIcon";
    exports.SvgArrowsOutHorizontalIcon = SvgArrowsOutHorizontalIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AttachmentFilledIcon.svg.js
var require_AttachmentFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AttachmentFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgAttachmentFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4.666 9.677a4 4 0 0 0 0 5.657l.147.146a3.793 3.793 0 0 0 5.364 0 1 1 0 0 0-1.414-1.414c-.7.7-1.836.7-2.536 0l-.146-.146a2 2 0 0 1 0-2.829l5.015-5.015a1.993 1.993 0 1 1 2.819 2.82l-2.286 2.285a.567.567 0 1 1-.801-.801l2.25-2.25a1 1 0 1 0-1.414-1.415l-2.25 2.25a2.567 2.567 0 0 0 3.63 3.63l2.285-2.285a3.993 3.993 0 1 0-5.648-5.648l-5.015 5.015Z"
      }));
    };
    SvgAttachmentFilledIcon.displayName = "AttachmentFilledIcon";
    exports.SvgAttachmentFilledIcon = SvgAttachmentFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AttachmentIcon.svg.js
var require_AttachmentIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AttachmentIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgAttachmentIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4.843 9.854a3.75 3.75 0 0 0 0 5.303l.147.147a3.543 3.543 0 0 0 5.01 0 .75.75 0 0 0-1.06-1.061 2.043 2.043 0 0 1-2.89 0l-.146-.146a2.25 2.25 0 0 1 0-3.182l5.015-5.015a2.244 2.244 0 0 1 3.173 3.172l-2.286 2.286a.817.817 0 1 1-1.155-1.155l2.25-2.25a.75.75 0 1 0-1.06-1.061l-2.25 2.25a2.317 2.317 0 0 0 3.275 3.277l2.286-2.286a3.744 3.744 0 0 0-5.294-5.294l-5.015 5.015Z"
      }));
    };
    SvgAttachmentIcon.displayName = "AttachmentIcon";
    exports.SvgAttachmentIcon = SvgAttachmentIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AutomationFilledIcon.svg.js
var require_AutomationFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AutomationFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgAutomationFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8 4.176c0-.76.617-1.376 1.377-1.376h1.246c.76 0 1.376.616 1.376 1.376v.688c0 .19.126.396.358.517.146.076.287.159.424.248.221.144.465.152.632.056l.6-.347c.658-.38 1.5-.154 1.88.504l.622 1.08c.38.658.155 1.5-.503 1.88l-.648.373c-.163.094-.277.303-.269.56l.002.909v.41l-.35-.243a1.75 1.75 0 0 0-2.747 1.439v3.501c0 .76-.617 1.376-1.377 1.376h-1.246c-.76 0-1.376-.616-1.376-1.376v-.81c0-.192-.127-.397-.359-.518a5.104 5.104 0 0 1-.333-.19c-.22-.138-.458-.143-.621-.049l-.7.405c-.659.38-1.5.154-1.88-.504l-.624-1.08a1.375 1.375 0 0 1 .504-1.879l.653-.377c.167-.097.282-.311.268-.575a5.175 5.175 0 0 1-.004-.439c.008-.257-.106-.465-.27-.56l-.647-.374a1.376 1.376 0 0 1-.504-1.88l.624-1.079a1.376 1.376 0 0 1 1.88-.504l.6.347c.166.096.41.088.631-.056.137-.09.278-.172.423-.248.232-.121.359-.326.359-.517v-.688Zm2 7.324a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "m14.035 11.839 3.25 2.25a.5.5 0 0 1 0 .822l-3.25 2.25a.5.5 0 0 1-.785-.411v-4.5a.5.5 0 0 1 .785-.411Z"
      }));
    };
    SvgAutomationFilledIcon.displayName = "AutomationFilledIcon";
    exports.SvgAutomationFilledIcon = SvgAutomationFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AutomationIcon.svg.js
var require_AutomationIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AutomationIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgAutomationIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.377 2.5c-.926 0-1.676.75-1.676 1.676v.688c0 .056-.043.17-.198.251-.153.08-.303.168-.448.262-.147.097-.268.076-.318.048l-.6-.346a1.676 1.676 0 0 0-2.29.613l-.622 1.08a1.676 1.676 0 0 0 .613 2.289l.648.374c.048.028.124.12.119.29a5.484 5.484 0 0 0 .005.465c.009.175-.07.27-.119.299l-.653.377a1.676 1.676 0 0 0-.613 2.29l.623 1.08a1.676 1.676 0 0 0 2.29.613l.7-.405c.048-.028.166-.048.312.043.115.071.233.139.353.202.155.08.198.195.198.251v.811c0 .926.75 1.676 1.676 1.676h1.246c.926 0 1.676-.75 1.676-1.676v-.81a.75.75 0 0 0-1.5 0v.81a.176.176 0 0 1-.176.176h-1.246a.176.176 0 0 1-.176-.176v-.81c0-.73-.462-1.3-1.003-1.582a3.873 3.873 0 0 1-.255-.146c-.514-.32-1.23-.428-1.855-.068l-.7.405a.176.176 0 0 1-.241-.065l-.623-1.08a.176.176 0 0 1 .064-.24l.653-.377c.637-.368.899-1.062.867-1.677a3.97 3.97 0 0 1-.004-.337c.02-.604-.245-1.278-.868-1.638l-.648-.374a.176.176 0 0 1-.064-.24l.623-1.08a.176.176 0 0 1 .24-.064l.6.346c.638.368 1.37.247 1.888-.09a3.85 3.85 0 0 1 .323-.19c.54-.282 1.003-.852 1.003-1.58v-.688c0-.097.078-.176.176-.176h1.246c.097 0 .176.079.176.176v.688c0 .728.462 1.298 1.003 1.58.11.058.219.122.323.19.517.337 1.25.458 1.888.09l.6-.346a.176.176 0 0 1 .24.064l.623 1.08a.176.176 0 0 1-.064.24l-.648.374c-.623.36-.888 1.034-.868 1.638l.002.128c0 .082-.002.248-.006.309a.75.75 0 0 0 1.498.078 9.926 9.926 0 0 0 .005-.563c-.005-.171.07-.263.12-.291l.647-.374a1.676 1.676 0 0 0 .613-2.29l-.623-1.079a1.676 1.676 0 0 0-2.29-.613l-.6.346c-.049.028-.17.048-.318-.048a5.4 5.4 0 0 0-.448-.262c-.155-.081-.197-.195-.197-.251v-.688c0-.926-.75-1.676-1.676-1.676h-1.246Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 13a3 3 0 1 0 0-6 3 3 0 0 0 0 6Zm0-1.5a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.035 11.839a.5.5 0 0 0-.785.411v4.5a.5.5 0 0 0 .785.411l3.25-2.25a.5.5 0 0 0 0-.822l-3.25-2.25Z"
      }));
    };
    SvgAutomationIcon.displayName = "AutomationIcon";
    exports.SvgAutomationIcon = SvgAutomationIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BackspaceIcon.svg.js
var require_BackspaceIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BackspaceIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgBackspaceIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.03 7.47a.75.75 0 0 1 0 1.06l-1.47 1.47 1.47 1.47a.75.75 0 1 1-1.06 1.06l-1.47-1.47-1.47 1.47a.75.75 0 1 1-1.06-1.06l1.47-1.47-1.47-1.47a.75.75 0 0 1 1.06-1.06l1.47 1.47 1.47-1.47a.75.75 0 0 1 1.06 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.553 5.083a2.75 2.75 0 0 1 2.188-1.083h6.509a2.75 2.75 0 0 1 2.75 2.75v6.5a2.75 2.75 0 0 1-2.75 2.75h-6.51a2.75 2.75 0 0 1-2.187-1.083l-2.476-3.25a2.75 2.75 0 0 1 0-3.334l2.476-3.25Zm2.188.417c-.39 0-.758.182-.995.492l-2.476 3.25a1.25 1.25 0 0 0 0 1.516l2.476 3.25c.237.31.604.492.995.492h6.509c.69 0 1.25-.56 1.25-1.25v-6.5c0-.69-.56-1.25-1.25-1.25h-6.51Z"
      }));
    };
    SvgBackspaceIcon.displayName = "BackspaceIcon";
    exports.SvgBackspaceIcon = SvgBackspaceIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BankFilledIcon.svg.js
var require_BankFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BankFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgBankFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10.54 3.177a1.25 1.25 0 0 0-1.08 0l-5.25 2.51a1.25 1.25 0 0 0-.71 1.128v1.185c0 .69.56 1.25 1.25 1.25v3h-.25a1 1 0 0 0-1 1v1.5a1 1 0 0 0 1 1h11a1 1 0 0 0 1-1v-1.5a1 1 0 0 0-1-1h-.25v-3c.69 0 1.25-.56 1.25-1.25v-1.185c0-.481-.276-.92-.71-1.128l-5.25-2.51Zm1.71 6.073h1.5v3h-1.5v-3Zm-3 0h1.5v3h-1.5v-3Zm-3 0h1.5v3h-1.5v-3Z"
      }));
    };
    SvgBankFilledIcon.displayName = "BankFilledIcon";
    exports.SvgBankFilledIcon = SvgBankFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BankIcon.svg.js
var require_BankIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BankIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgBankIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10.54 3.177a1.25 1.25 0 0 0-1.08 0l-5.25 2.51a1.25 1.25 0 0 0-.71 1.128v1.185c0 .69.56 1.25 1.25 1.25v2.75h-.25a1 1 0 0 0-1 1v2a1 1 0 0 0 1 1h11a1 1 0 0 0 1-1v-2a1 1 0 0 0-1-1h-.25v-2.75c.69 0 1.25-.56 1.25-1.25v-1.185c0-.481-.276-.92-.71-1.128l-5.25-2.51Zm3.21 8.823v-2.75h-1.5v2.75h1.5Zm-3 0v-2.75h-1.5v2.75h1.5Zm-3 0v-2.75h-1.5v2.75h1.5Zm-2.75-5.027 5-2.392 5 2.392v.777h-10v-.777Zm0 7.527v-1h10v1h-10Z"
      }));
    };
    SvgBankIcon.displayName = "BankIcon";
    exports.SvgBankIcon = SvgBankIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BarcodeIcon.svg.js
var require_BarcodeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BarcodeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgBarcodeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.5 6.25a.75.75 0 0 1 .75-.75h.487a.75.75 0 1 0 0-1.5h-.487a2.25 2.25 0 0 0-2.25 2.25v.5a.75.75 0 0 0 1.5 0v-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.5 13.76c0 .414.336.75.75.75h.5a.75.75 0 0 1 0 1.5h-.5a2.25 2.25 0 0 1-2.25-2.25v-.5a.75.75 0 0 1 1.5 0v.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.75 5.5a.75.75 0 0 1 .75.75v.5a.75.75 0 0 0 1.5 0v-.5a2.25 2.25 0 0 0-2.25-2.25h-.5a.75.75 0 0 0 0 1.5h.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.5 13.76a.75.75 0 0 1-.75.75h-.5a.75.75 0 0 0 0 1.5h.5a2.25 2.25 0 0 0 2.25-2.25v-.5a.75.75 0 0 0-1.5 0v.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6 7.5a.5.5 0 0 1 1 0v5a.5.5 0 0 1-1 0v-5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.5 7a.5.5 0 0 0-.5.5v5a.5.5 0 0 0 1 0v-5a.5.5 0 0 0-.5-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8 7.625a.625.625 0 1 1 1.25 0v4.75a.625.625 0 1 1-1.25 0v-4.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13 7a1 1 0 0 0-1 1v4a1 1 0 1 0 2 0v-4a1 1 0 0 0-1-1Z"
      }));
    };
    SvgBarcodeIcon.displayName = "BarcodeIcon";
    exports.SvgBarcodeIcon = SvgBarcodeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BillFilledIcon.svg.js
var require_BillFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BillFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgBillFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.5 3.5a2 2 0 0 0-2 2v3.75c0 .414.336.75.75.75h2v5.769a.85.85 0 0 0 1.433.618l1.442-1.357 1.611 1.516a.75.75 0 0 0 1.028 0l1.611-1.516 1.442 1.357a.85.85 0 0 0 1.433-.618v-10.269a2 2 0 0 0-2-2h-8.494l.005.017a2.02 2.02 0 0 0-.261-.017Zm-.5 2a.5.5 0 0 1 1 0v3h-1v-3Zm4 1.75a.75.75 0 0 1 .75-.75h3.5a.75.75 0 0 1 0 1.5h-3.5a.75.75 0 0 1-.75-.75Zm.75 2.25a.75.75 0 0 0 0 1.5h3.5a.75.75 0 0 0 0-1.5h-3.5Z"
      }));
    };
    SvgBillFilledIcon.displayName = "BillFilledIcon";
    exports.SvgBillFilledIcon = SvgBillFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BillIcon.svg.js
var require_BillIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BillIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgBillIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.5 3.5a2 2 0 0 0-2 2v3.75c0 .414.336.75.75.75h2v5.769a.85.85 0 0 0 1.433.618l1.442-1.357 1.611 1.516a.75.75 0 0 0 1.028 0l1.611-1.516 1.442 1.357a.85.85 0 0 0 1.433-.618v-10.269a2 2 0 0 0-2-2h-8.494l.005.017a2.02 2.02 0 0 0-.261-.017Zm-.5 2a.5.5 0 0 1 1 0v3h-1v-3Zm2.75-.48-.006-.02h6.506a.5.5 0 0 1 .5.5v8.764l-.69-.649a1 1 0 0 0-1.37 0l-1.44 1.355-1.44-1.355a1 1 0 0 0-1.37 0l-.69.65v-9.245Zm2 1.48a.75.75 0 0 0 0 1.5h3a.75.75 0 0 0 0-1.5h-3Zm-.75 3.75a.75.75 0 0 1 .75-.75h3a.75.75 0 0 1 0 1.5h-3a.75.75 0 0 1-.75-.75Z"
      }));
    };
    SvgBillIcon.displayName = "BillIcon";
    exports.SvgBillIcon = SvgBillIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BlankFilledIcon.svg.js
var require_BlankFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BlankFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgBlankFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.5 6.25c0-1.519-1.231-2.75-2.75-2.75h-1c-.414 0-.75.336-.75.75s.336.75.75.75h1c.69 0 1.25.56 1.25 1.25v1c0 .414.336.75.75.75s.75-.336.75-.75v-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.25 16.5c-1.519 0-2.75-1.231-2.75-2.75v-1c0-.414.336-.75.75-.75s.75.336.75.75v1c0 .69.56 1.25 1.25 1.25h1c.414 0 .75.336.75.75s-.336.75-.75.75h-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.75 16.5c1.519 0 2.75-1.231 2.75-2.75v-1c0-.414-.336-.75-.75-.75s-.75.336-.75.75v1c0 .69-.56 1.25-1.25 1.25h-1c-.414 0-.75.336-.75.75s.336.75.75.75h1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.25 3.5c-1.519 0-2.75 1.231-2.75 2.75v1c0 .414.336.75.75.75s.75-.336.75-.75v-1c0-.69.56-1.25 1.25-1.25h1c.414 0 .75-.336.75-.75s-.336-.75-.75-.75h-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.25 6.5c-.966 0-1.75.784-1.75 1.75v3.5c0 .966.784 1.75 1.75 1.75h3.5c.966 0 1.75-.784 1.75-1.75v-3.5c0-.966-.784-1.75-1.75-1.75h-3.5Z"
      }));
    };
    SvgBlankFilledIcon.displayName = "BlankFilledIcon";
    exports.SvgBlankFilledIcon = SvgBlankFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BlankIcon.svg.js
var require_BlankIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BlankIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgBlankIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.75 3.5c1.519 0 2.75 1.231 2.75 2.75v1c0 .414-.336.75-.75.75s-.75-.336-.75-.75v-1c0-.69-.56-1.25-1.25-1.25h-1c-.414 0-.75-.336-.75-.75s.336-.75.75-.75h1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 13.75c0 1.519 1.231 2.75 2.75 2.75h1c.414 0 .75-.336.75-.75s-.336-.75-.75-.75h-1c-.69 0-1.25-.56-1.25-1.25v-1c0-.414-.336-.75-.75-.75s-.75.336-.75.75v1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.5 13.75c0 1.519-1.231 2.75-2.75 2.75h-1c-.414 0-.75-.336-.75-.75s.336-.75.75-.75h1c.69 0 1.25-.56 1.25-1.25v-1c0-.414.336-.75.75-.75s.75.336.75.75v1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 6.25c0-1.519 1.231-2.75 2.75-2.75h1c.414 0 .75.336.75.75s-.336.75-.75.75h-1c-.69 0-1.25.56-1.25 1.25v1c0 .414-.336.75-.75.75s-.75-.336-.75-.75v-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.25 6.5c-.966 0-1.75.784-1.75 1.75v3.5c0 .966.784 1.75 1.75 1.75h3.5c.966 0 1.75-.784 1.75-1.75v-3.5c0-.966-.784-1.75-1.75-1.75h-3.5Zm-.25 1.75c0-.138.112-.25.25-.25h3.5c.138 0 .25.112.25.25v3.5c0 .138-.112.25-.25.25h-3.5c-.138 0-.25-.112-.25-.25v-3.5Z"
      }));
    };
    SvgBlankIcon.displayName = "BlankIcon";
    exports.SvgBlankIcon = SvgBlankIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BlogIcon.svg.js
var require_BlogIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BlogIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgBlogIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.746 3.104a.5.5 0 0 0 0-.707l-1.06-1.061a.5.5 0 0 0-.707 0l-.957.957 1.767 1.768.957-.957Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "m15.082 4.768-1.768-1.768-3.699 3.7a2 2 0 0 0-.585 1.406l-.003.698a.25.25 0 0 0 .251.251l.698-.002a2 2 0 0 0 1.407-.586l3.7-3.7Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.5 4.75c0-.69.56-1.25 1.25-1.25h3.25a.75.75 0 0 0 0-1.5h-3.25a2.75 2.75 0 0 0-2.75 2.75v10.5a2.75 2.75 0 0 0 2.75 2.75h6.5a2.75 2.75 0 0 0 2.75-2.75v-7.25a.75.75 0 0 0-1.5 0v7.25c0 .69-.56 1.25-1.25 1.25h-6.5c-.69 0-1.25-.56-1.25-1.25v-10.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.75 10.5a.75.75 0 0 0 0 1.5h4.5a.75.75 0 0 0 0-1.5h-4.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7 14.25a.75.75 0 0 1 .75-.75h2.75a.75.75 0 0 1 0 1.5h-2.75a.75.75 0 0 1-.75-.75Z"
      }));
    };
    SvgBlogIcon.displayName = "BlogIcon";
    exports.SvgBlogIcon = SvgBlogIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BookIcon.svg.js
var require_BookIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BookIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgBookIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.25 6a.75.75 0 0 0 0 1.5h2.5a.75.75 0 1 0 0-1.5h-2.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.5 9.25a.75.75 0 0 1 .75-.75h2.5a.75.75 0 0 1 0 1.5h-2.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.75 3a1.75 1.75 0 0 0-1.75 1.75v10a2.25 2.25 0 0 0 2.25 2.25h9a.75.75 0 0 0 0-1.5h-.25v-1.668c.591-.281 1-.884 1-1.582v-7.5a1.75 1.75 0 0 0-1.75-1.75h-8.5Zm1.25 1.5h-1.25a.25.25 0 0 0-.25.25v7.878c.235-.083.487-.128.75-.128h.75v-8Zm1.5 8v-8h5.75a.25.25 0 0 1 .25.25v7.5a.25.25 0 0 1-.25.25h-5.75Zm-2.25 3a.75.75 0 0 1 0-1.5h7.25v1.5h-7.25Z"
      }));
    };
    SvgBookIcon.displayName = "BookIcon";
    exports.SvgBookIcon = SvgBookIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BookOpenIcon.svg.js
var require_BookOpenIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BookOpenIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgBookOpenIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.75 6a.75.75 0 0 0 0 1.5h.5a.75.75 0 0 0 0-1.5h-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.75 9a.75.75 0 0 0 0 1.5h.5a.75.75 0 0 0 0-1.5h-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.75 12a.75.75 0 0 0 0 1.5h.5a.75.75 0 0 0 0-1.5h-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12 6.75a.75.75 0 0 1 .75-.75h.5a.75.75 0 0 1 0 1.5h-.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12 9.75a.75.75 0 0 1 .75-.75h.5a.75.75 0 0 1 0 1.5h-.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.586 3.5c.87 0 1.714.273 2.414.771a4.164 4.164 0 0 1 2.414-.771h2.336c.966 0 1.75.784 1.75 1.75v9.5a1.75 1.75 0 0 1-1.75 1.75h-.238a9.25 9.25 0 0 0-3.161.557l-1.095.398a.75.75 0 0 1-.493.007l-1.46-.487a9.25 9.25 0 0 0-2.926-.475h-.127a1.75 1.75 0 0 1-1.75-1.75v-9.5c0-.966.784-1.75 1.75-1.75h2.336Zm-2.586 1.75a.25.25 0 0 1 .25-.25h2.336c.608 0 1.194.208 1.664.584v10.125l-.473-.157a10.75 10.75 0 0 0-3.4-.552h-.127a.25.25 0 0 1-.25-.25v-9.5Zm5.75 10.43v-10.096a2.664 2.664 0 0 1 1.664-.584h2.336a.25.25 0 0 1 .25.25v9.5a.25.25 0 0 1-.25.25h-.238a10.75 10.75 0 0 0-3.674.647l-.088.032Z"
      }));
    };
    SvgBookOpenIcon.displayName = "BookOpenIcon";
    exports.SvgBookOpenIcon = SvgBookOpenIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BugIcon.svg.js
var require_BugIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/BugIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgBugIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13.28 3.97a.75.75 0 0 1 0 1.06l-.793.794c.4.475.667 1.067.742 1.717.349.073.663.241.914.477l1.157-.868a.75.75 0 1 1 .9 1.2l-1.45 1.088v1.312h1.5a.75.75 0 0 1 0 1.5h-1.605a4.717 4.717 0 0 1-.33.987l1.885 1.413a.75.75 0 1 1-.9 1.2l-1.821-1.366a4.737 4.737 0 0 1-3.479 1.516 4.737 4.737 0 0 1-3.479-1.516l-1.821 1.366a.75.75 0 1 1-.9-1.2l1.884-1.413a4.712 4.712 0 0 1-.329-.987h-1.605a.75.75 0 0 1 0-1.5h1.5v-1.313l-1.45-1.087a.75.75 0 1 1 .9-1.2l1.157.868c.25-.236.565-.404.914-.477a3.24 3.24 0 0 1 .742-1.717l-.793-.794a.75.75 0 0 1 1.06-1.06l.953.953a3.24 3.24 0 0 1 1.267-.256c.45 0 .877.09 1.267.256l.953-.953a.75.75 0 0 1 1.06 0Zm-6.53 6.78v.5a3.251 3.251 0 0 0 2.5 3.163v-5.413h-2.083a.417.417 0 0 0-.417.417v1.333Zm6.5-1.333v1.833a3.251 3.251 0 0 1-2.5 3.163v-5.413h2.083c.23 0 .417.187.417.417Zm-3.25-3.25a1.75 1.75 0 0 1 1.7 1.333h-3.4a1.75 1.75 0 0 1 1.7-1.333Z"
      }));
    };
    SvgBugIcon.displayName = "BugIcon";
    exports.SvgBugIcon = SvgBugIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ButtonIcon.svg.js
var require_ButtonIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ButtonIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgButtonIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.75 4a3.75 3.75 0 0 0-3.75 3.75v2.5a3.75 3.75 0 0 0 3.75 3.75h1.5a.75.75 0 0 0 0-1.5h-1.5a2.25 2.25 0 0 1-2.25-2.25v-2.5a2.25 2.25 0 0 1 2.25-2.25h6.5a2.25 2.25 0 0 1 2.25 2.25v.5a.75.75 0 0 0 1.5 0v-.5a3.75 3.75 0 0 0-3.75-3.75h-6.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.464 8.464a.75.75 0 0 1 .78-.176l6.01 2.12a.75.75 0 0 1 .281 1.238l-1.237 1.238 1.414 1.414a.75.75 0 0 1 0 1.06l-.353.354a.75.75 0 0 1-1.06 0l-1.415-1.414-1.238 1.238a.75.75 0 0 1-1.237-.281l-2.121-6.01a.75.75 0 0 1 .176-.78Z"
      }));
    };
    SvgButtonIcon.displayName = "ButtonIcon";
    exports.SvgButtonIcon = SvgButtonIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ButtonPressIcon.svg.js
var require_ButtonPressIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ButtonPressIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgButtonPressIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.75 2.5a1.75 1.75 0 0 0-1.75 1.75v3.5c0 .966.784 1.75 1.75 1.75a.75.75 0 0 0 0-1.5.25.25 0 0 1-.25-.25v-3.5a.25.25 0 0 1 .25-.25h8.5a.25.25 0 0 1 .25.25v3.5a.25.25 0 0 1-.25.25h-.5a.75.75 0 0 0 0 1.5h.5a1.75 1.75 0 0 0 1.75-1.75v-3.5a1.75 1.75 0 0 0-1.75-1.75h-8.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9.75 5a2.25 2.25 0 0 0-2.25 2.25v3.58l-.57-.258a1.75 1.75 0 0 0-2.429 1.216l-.07.312a2.25 2.25 0 0 0 .497 1.962l2.456 2.834a1.75 1.75 0 0 0 1.323.604h4.465a1.75 1.75 0 0 0 1.72-1.423l.67-3.523a1.75 1.75 0 0 0-1.267-2.018l-2.295-.612v-2.674a2.25 2.25 0 0 0-2.25-2.25Zm-.75 2.25a.75.75 0 0 1 1.5 0v3.25c0 .34.229.637.557.725l2.851.76a.25.25 0 0 1 .181.288l-.67 3.524a.25.25 0 0 1-.247.203h-4.465a.25.25 0 0 1-.19-.086l-2.456-2.835a.75.75 0 0 1-.165-.654l.07-.312a.25.25 0 0 1 .346-.173l1.63.735a.75.75 0 0 0 1.058-.684v-4.741Z"
      }));
    };
    SvgButtonPressIcon.displayName = "ButtonPressIcon";
    exports.SvgButtonPressIcon = SvgButtonPressIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CalculatorIcon.svg.js
var require_CalculatorIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CalculatorIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCalculatorIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.5 6.25a1 1 0 0 1 1-1h5a1 1 0 0 1 1 1v3a1 1 0 0 1-1 1h-5a1 1 0 0 1-1-1v-3Zm1.5 2.5v-2h4v2h-4Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.5 11.75a.75.75 0 0 1 .75-.75h1.5a.75.75 0 0 1 0 1.5h-1.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.25 11a.75.75 0 0 0 0 1.5h1.5a.75.75 0 0 0 0-1.5h-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.5 14a.75.75 0 0 1 .75-.75h1.5a.75.75 0 0 1 0 1.5h-1.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.25 13.25a.75.75 0 0 0 0 1.5h1.5a.75.75 0 0 0 0-1.5h-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.75 3a2.75 2.75 0 0 0-2.75 2.75v8.5a2.75 2.75 0 0 0 2.75 2.75h6.5a2.75 2.75 0 0 0 2.75-2.75v-8.5a2.75 2.75 0 0 0-2.75-2.75h-6.5Zm-1.25 2.75c0-.69.56-1.25 1.25-1.25h6.5c.69 0 1.25.56 1.25 1.25v8.5c0 .69-.56 1.25-1.25 1.25h-6.5c-.69 0-1.25-.56-1.25-1.25v-8.5Z"
      }));
    };
    SvgCalculatorIcon.displayName = "CalculatorIcon";
    exports.SvgCalculatorIcon = SvgCalculatorIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CalendarCheckIcon.svg.js
var require_CalendarCheckIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CalendarCheckIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCalendarCheckIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.75 3.5a.75.75 0 0 0-1.5 0v.407a3.075 3.075 0 0 0-.702.252 3.75 3.75 0 0 0-1.64 1.639c-.226.444-.32.924-.365 1.47-.043.531-.043 1.187-.043 2v1.513c0 .79 0 1.428.041 1.944.042.532.131 1 .346 1.434a3.75 3.75 0 0 0 1.704 1.704c.435.215.902.304 1.434.346.517.041 1.154.041 1.944.041h.031a.75.75 0 0 0 0-1.5c-.829 0-1.406 0-1.856-.036-.442-.035-.696-.1-.89-.196a2.25 2.25 0 0 1-1.022-1.023c-.095-.193-.16-.447-.196-.889-.035-.45-.036-1.027-.036-1.856v-1.25h10v1.5a.75.75 0 0 0 1.5 0v-1.732c0-.813 0-1.469-.043-2-.045-.546-.14-1.026-.366-1.47a3.75 3.75 0 0 0-1.639-1.64 3.076 3.076 0 0 0-.702-.251v-.407a.75.75 0 0 0-1.5 0v.259c-.373-.009-.794-.009-1.268-.009h-1.964c-.474 0-.895 0-1.268.009v-.259Zm7.241 4.5a10.674 10.674 0 0 0-.03-.61c-.037-.453-.106-.714-.206-.911a2.25 2.25 0 0 0-.984-.984c-.197-.1-.458-.17-.912-.207-.462-.037-1.056-.038-1.909-.038h-1.9c-.852 0-1.447 0-1.91.038-.453.037-.714.107-.911.207a2.25 2.25 0 0 0-.984.984c-.1.197-.17.458-.207.912-.014.18-.023.38-.03.609h9.983Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M17.28 12.72a.75.75 0 0 1 0 1.06l-3.5 3.5a.75.75 0 0 1-1.06 0l-1.75-1.75a.75.75 0 1 1 1.06-1.06l1.22 1.22 2.97-2.97a.75.75 0 0 1 1.06 0Z"
      }));
    };
    SvgCalendarCheckIcon.displayName = "CalendarCheckIcon";
    exports.SvgCalendarCheckIcon = SvgCalendarCheckIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CalendarIcon.svg.js
var require_CalendarIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CalendarIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCalendarIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.75 3.5a.75.75 0 0 0-1.5 0v.407a3.075 3.075 0 0 0-.702.252 3.75 3.75 0 0 0-1.64 1.639c-.226.444-.32.924-.365 1.47-.043.531-.043 1.187-.043 2v1.464c0 .813 0 1.469.043 2 .045.546.14 1.026.366 1.47a3.75 3.75 0 0 0 1.639 1.64c.444.226.924.32 1.47.365.531.043 1.187.043 2 .043h3.383c.323 0 .542 0 .735-.02a3.75 3.75 0 0 0 3.344-3.344c.02-.193.02-.412.02-.735v-2.883c0-.813 0-1.469-.043-2-.045-.546-.14-1.026-.366-1.47a3.75 3.75 0 0 0-1.639-1.64 3.076 3.076 0 0 0-.702-.251v-.407a.75.75 0 0 0-1.5 0v.259c-.373-.009-.794-.009-1.268-.009h-1.964c-.474 0-.895 0-1.268.009v-.259Zm-1.521 1.995c.197-.1.458-.17.912-.207.462-.037 1.057-.038 1.909-.038h1.9c.853 0 1.447 0 1.91.038.453.037.714.107.912.207.423.216.767.56.983.984.1.197.17.458.207.912.014.18.024.38.029.609h-9.982c.006-.228.015-.429.03-.61.036-.453.106-.714.206-.911a2.25 2.25 0 0 1 .984-.984Zm-1.229 4.005v1.2c0 .853 0 1.447.038 1.91.037.453.107.714.207.912.216.423.56.767.984.983.197.1.458.17.912.207.462.037 1.057.038 1.909.038h3.306c.385 0 .52-.001.626-.012a2.25 2.25 0 0 0 2.006-2.006c.011-.106.012-.241.012-.626v-2.606h-10Z"
      }));
    };
    SvgCalendarIcon.displayName = "CalendarIcon";
    exports.SvgCalendarIcon = SvgCalendarIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CalendarTimeIcon.svg.js
var require_CalendarTimeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CalendarTimeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCalendarTimeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6 1.75a.75.75 0 0 1 .75.75v.528c.487-.028 1.07-.028 1.768-.028h2.482v-.5a.75.75 0 0 1 1.5 0v.604a3.041 3.041 0 0 1 2.25 2.936c0 .835-.678 1.513-1.513 1.513h-8.733c-.004.288-.004.617-.004.997v2.468c0 1.233 1 2.232 2.232 2.232a.75.75 0 0 1 0 1.5 3.732 3.732 0 0 1-3.732-3.732v-2.5c0-.813 0-1.469.043-2 .045-.546.14-1.026.366-1.47a3.75 3.75 0 0 1 1.841-1.733v-.815a.75.75 0 0 1 .75-.75Zm7.237 4.303h-8.61c.033-.13.072-.234.118-.324a2.25 2.25 0 0 1 .984-.984c.197-.1.458-.17.912-.207.462-.037 1.057-.038 1.909-.038h3.16c.85 0 1.54.69 1.54 1.54v.005a.015.015 0 0 1-.004.004.015.015 0 0 1-.004.003h-.005Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.25 12a.75.75 0 0 0-1.5 0v1.293c0 .331.132.65.366.884l.854.853a.75.75 0 1 0 1.06-1.06l-.78-.78v-1.19Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13.5 18a4.5 4.5 0 1 0 0-9 4.5 4.5 0 0 0 0 9Zm0-1.5a3 3 0 1 0 0-6 3 3 0 0 0 0 6Z"
      }));
    };
    SvgCalendarTimeIcon.displayName = "CalendarTimeIcon";
    exports.SvgCalendarTimeIcon = SvgCalendarTimeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CameraFlipIcon.svg.js
var require_CameraFlipIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CameraFlipIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCameraFlipIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.47 6.22a.75.75 0 0 1 1.06 0l1.5 1.5a.75.75 0 0 1 0 1.06l-1.5 1.5a.75.75 0 1 1-1.06-1.06l.185-.186a1.75 1.75 0 0 0 .345 3.466h.294c.804 0 1.456-.652 1.456-1.456a.75.75 0 0 1 1.5 0 2.956 2.956 0 0 1-2.956 2.956h-.294a3.25 3.25 0 0 1-.297-6.487l-.233-.233a.75.75 0 0 1 0-1.06Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.149 5.472a2.75 2.75 0 0 1 2.435-1.472h2.832a2.75 2.75 0 0 1 2.435 1.472l.346.658a.69.69 0 0 0 .612.37c1.21 0 2.191.981 2.191 2.191v4.559a2.75 2.75 0 0 1-2.75 2.75h-8.5a2.75 2.75 0 0 1-2.75-2.75v-4.559c0-1.21.981-2.191 2.191-2.191a.691.691 0 0 0 .612-.37l.346-.658Zm2.435.028c-.465 0-.89.258-1.107.669l-.346.658a2.191 2.191 0 0 1-1.94 1.173.691.691 0 0 0-.691.691v4.559c0 .69.56 1.25 1.25 1.25h8.5c.69 0 1.25-.56 1.25-1.25v-4.559a.691.691 0 0 0-.691-.691 2.191 2.191 0 0 1-1.94-1.173l-.346-.658a1.25 1.25 0 0 0-1.107-.669h-2.832Z"
      }));
    };
    SvgCameraFlipIcon.displayName = "CameraFlipIcon";
    exports.SvgCameraFlipIcon = SvgCameraFlipIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CameraIcon.svg.js
var require_CameraIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CameraIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCameraIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 7.25a3.25 3.25 0 1 0 0 6.5 3.25 3.25 0 0 0 0-6.5Zm-1.75 3.25a1.75 1.75 0 1 1 3.5 0 1.75 1.75 0 0 1-3.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.584 4a2.75 2.75 0 0 0-2.435 1.472l-.346.658a.691.691 0 0 1-.612.37c-1.21 0-2.191.981-2.191 2.191v4.559a2.75 2.75 0 0 0 2.75 2.75h8.5a2.75 2.75 0 0 0 2.75-2.75v-4.559c0-1.21-.981-2.191-2.191-2.191a.691.691 0 0 1-.612-.37l-.346-.658a2.75 2.75 0 0 0-2.435-1.472h-2.832Zm-1.107 2.169a1.25 1.25 0 0 1 1.107-.669h2.832c.465 0 .89.258 1.107.669l.345.658a2.191 2.191 0 0 0 1.94 1.173c.383 0 .692.31.692.691v4.559c0 .69-.56 1.25-1.25 1.25h-8.5c-.69 0-1.25-.56-1.25-1.25v-4.559c0-.381.31-.691.691-.691a2.19 2.19 0 0 0 1.94-1.173l.346-.658Z"
      }));
    };
    SvgCameraIcon.displayName = "CameraIcon";
    exports.SvgCameraIcon = SvgCameraIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CaretDownIcon.svg.js
var require_CaretDownIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CaretDownIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCaretDownIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.24 8.2a.75.75 0 0 1 1.06.04l2.7 2.908 2.7-2.908a.75.75 0 1 1 1.1 1.02l-3.25 3.5a.75.75 0 0 1-1.1 0l-3.25-3.5a.75.75 0 0 1 .04-1.06Z"
      }));
    };
    SvgCaretDownIcon.displayName = "CaretDownIcon";
    exports.SvgCaretDownIcon = SvgCaretDownIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CaretUpIcon.svg.js
var require_CaretUpIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CaretUpIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCaretUpIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.24 11.8a.75.75 0 0 0 1.06-.04l2.7-2.908 2.7 2.908a.75.75 0 1 0 1.1-1.02l-3.25-3.5a.75.75 0 0 0-1.1 0l-3.25 3.5a.75.75 0 0 0 .04 1.06Z"
      }));
    };
    SvgCaretUpIcon.displayName = "CaretUpIcon";
    exports.SvgCaretUpIcon = SvgCaretUpIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartAbandonedFilledIcon.svg.js
var require_CartAbandonedFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartAbandonedFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCartAbandonedFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M2.5 3.75a.75.75 0 0 1 .75-.75h1.612a1.75 1.75 0 0 1 1.732 1.5h9.656a.75.75 0 0 1 .748.808l-.358 4.653a2.75 2.75 0 0 1-2.742 2.539h-6.351l.093.78a.25.25 0 0 0 .248.22h6.362a.75.75 0 0 1 0 1.5h-6.362a1.75 1.75 0 0 1-1.738-1.543l-1.04-8.737a.25.25 0 0 0-.248-.22h-1.612a.75.75 0 0 1-.75-.75Zm6.708 2.458a.625.625 0 0 0 0 .884l1.408 1.408-1.408 1.408a.625.625 0 1 0 .884.884l1.408-1.408 1.408 1.408a.625.625 0 1 0 .884-.884l-1.408-1.408 1.408-1.408a.625.625 0 0 0-.884-.884l-1.408 1.408-1.408-1.408a.625.625 0 0 0-.884 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 17a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14 18a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }));
    };
    SvgCartAbandonedFilledIcon.displayName = "CartAbandonedFilledIcon";
    exports.SvgCartAbandonedFilledIcon = SvgCartAbandonedFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartAbandonedIcon.svg.js
var require_CartAbandonedIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartAbandonedIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCartAbandonedIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.25 3a.75.75 0 0 0 0 1.5h1.612a.25.25 0 0 1 .248.22l1.04 8.737a1.75 1.75 0 0 0 1.738 1.543h6.362a.75.75 0 0 0 0-1.5h-6.362a.25.25 0 0 1-.248-.22l-.093-.78h6.35a2.75 2.75 0 0 0 2.743-2.54l.358-4.652a.75.75 0 0 0-1.496-.116l-.358 4.654a1.25 1.25 0 0 1-1.246 1.154h-6.53l-.768-6.457a1.75 1.75 0 0 0-1.738-1.543h-1.612Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.87 5.12a.75.75 0 0 0 0 1.06l1.32 1.32-1.32 1.32a.75.75 0 1 0 1.06 1.06l1.32-1.32 1.32 1.32a.75.75 0 0 0 1.06-1.06l-1.32-1.32 1.32-1.32a.75.75 0 0 0-1.06-1.06l-1.32 1.32-1.32-1.32a.75.75 0 0 0-1.06 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 17a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15 17a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }));
    };
    SvgCartAbandonedIcon.displayName = "CartAbandonedIcon";
    exports.SvgCartAbandonedIcon = SvgCartAbandonedIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartDiscountIcon.svg.js
var require_CartDiscountIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartDiscountIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCartDiscountIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.25 3a.75.75 0 0 0 0 1.5h1.612a.25.25 0 0 1 .248.22l1.04 8.737a1.75 1.75 0 0 0 1.738 1.543h6.362a.75.75 0 0 0 0-1.5h-6.362a.25.25 0 0 1-.248-.22l-.093-.78h6.35a2.75 2.75 0 0 0 2.743-2.54l.358-4.652a.75.75 0 0 0-1.496-.116l-.358 4.654a1.25 1.25 0 0 1-1.246 1.154h-6.53l-.768-6.457a1.75 1.75 0 0 0-1.738-1.543h-1.612Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9 6.25a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.28 6.03a.75.75 0 0 0-1.06-1.06l-3.5 3.5a.75.75 0 0 0 1.06 1.06l3.5-3.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14 9.25a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 17a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15 17a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }));
    };
    SvgCartDiscountIcon.displayName = "CartDiscountIcon";
    exports.SvgCartDiscountIcon = SvgCartDiscountIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartDownFilledIcon.svg.js
var require_CartDownFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartDownFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCartDownFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.25 3a.75.75 0 0 0 0 1.5h1.612a.25.25 0 0 1 .248.22l1.04 8.737a1.75 1.75 0 0 0 1.738 1.543h6.362a.75.75 0 0 0 0-1.5h-6.362a.25.25 0 0 1-.248-.22l-.093-.78h6.35a2.75 2.75 0 0 0 2.743-2.54l.358-4.652a.75.75 0 0 0-.748-.808h-4.25v3.94l1.22-1.22a.75.75 0 1 1 1.06 1.06l-2.5 2.5a.75.75 0 0 1-1.06 0l-2.5-2.5a.75.75 0 0 1 1.06-1.06l1.22 1.22v-3.94h-3.906a1.75 1.75 0 0 0-1.732-1.5h-1.612Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 17a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15 17a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }));
    };
    SvgCartDownFilledIcon.displayName = "CartDownFilledIcon";
    exports.SvgCartDownFilledIcon = SvgCartDownFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartDownIcon.svg.js
var require_CartDownIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartDownIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCartDownIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.25 3a.75.75 0 0 0 0 1.5h1.612a.25.25 0 0 1 .248.22l1.04 8.737a1.75 1.75 0 0 0 1.738 1.543h6.362a.75.75 0 0 0 0-1.5h-6.362a.25.25 0 0 1-.248-.22l-.093-.78h6.35a2.75 2.75 0 0 0 2.743-2.54l.358-4.652a.75.75 0 0 0-1.496-.116l-.358 4.654a1.25 1.25 0 0 1-1.246 1.154h-6.53l-.768-6.457a1.75 1.75 0 0 0-1.738-1.543h-1.612Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12 3.75a.75.75 0 0 0-1.5 0v3.69l-1.22-1.22a.75.75 0 0 0-1.06 1.06l2.5 2.5a.75.75 0 0 0 1.06 0l2.5-2.5a.75.75 0 0 0-1.06-1.06l-1.22 1.22v-3.69Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 17a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15 17a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }));
    };
    SvgCartDownIcon.displayName = "CartDownIcon";
    exports.SvgCartDownIcon = SvgCartDownIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartFilledIcon.svg.js
var require_CartFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCartFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.25 3a.75.75 0 0 0 0 1.5h1.612a.25.25 0 0 1 .248.22l1.04 8.737a1.75 1.75 0 0 0 1.738 1.543h6.362a.75.75 0 0 0 0-1.5h-6.362a.25.25 0 0 1-.248-.22l-.093-.78h6.35a2.75 2.75 0 0 0 2.743-2.54l.358-4.652a.75.75 0 0 0-.748-.808h-9.656a1.75 1.75 0 0 0-1.732-1.5h-1.612Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9 18a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15 17a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }));
    };
    SvgCartFilledIcon.displayName = "CartFilledIcon";
    exports.SvgCartFilledIcon = SvgCartFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartIcon.svg.js
var require_CartIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCartIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M2.5 3.75a.75.75 0 0 1 .75-.75h1.612a1.75 1.75 0 0 1 1.732 1.5h9.656a.75.75 0 0 1 .748.808l-.358 4.653a2.75 2.75 0 0 1-2.742 2.539h-6.351l.093.78a.25.25 0 0 0 .248.22h6.362a.75.75 0 0 1 0 1.5h-6.362a1.75 1.75 0 0 1-1.738-1.543l-1.04-8.737a.25.25 0 0 0-.248-.22h-1.612a.75.75 0 0 1-.75-.75Zm4.868 7.25h6.53a1.25 1.25 0 0 0 1.246-1.154l.296-3.846h-8.667l.595 5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 17a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15 17a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }));
    };
    SvgCartIcon.displayName = "CartIcon";
    exports.SvgCartIcon = SvgCartIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartSaleIcon.svg.js
var require_CartSaleIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartSaleIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCartSaleIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4.25 3a.75.75 0 0 0 0 1.5h1.612a.25.25 0 0 1 .248.22l1.04 8.737a1.75 1.75 0 0 0 1.738 1.543h5.362a.75.75 0 0 0 0-1.5h-5.362a.25.25 0 0 1-.248-.22l-.093-.78h5.35a2.75 2.75 0 0 0 2.743-2.54l.358-4.652a.75.75 0 0 0-.748-.808h-8.656a1.75 1.75 0 0 0-1.732-1.5h-1.612Zm9.648 8h-5.53l-.595-5h7.667l-.296 3.846a1.25 1.25 0 0 1-1.246 1.154Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M2.75 6.5a.75.75 0 0 0 0 1.5h.5a.75.75 0 0 0 0-1.5h-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M2.75 9.5a.75.75 0 0 0 0 1.5h1.5a.75.75 0 0 0 0-1.5h-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M2 13.25a.75.75 0 0 1 .75-.75h2.5a.75.75 0 0 1 0 1.5h-2.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 17a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15 17a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }));
    };
    SvgCartSaleIcon.displayName = "CartSaleIcon";
    exports.SvgCartSaleIcon = SvgCartSaleIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartUpIcon.svg.js
var require_CartUpIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CartUpIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCartUpIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.25 3a.75.75 0 0 0 0 1.5h1.612a.25.25 0 0 1 .248.22l1.04 8.737a1.75 1.75 0 0 0 1.738 1.543h6.362a.75.75 0 0 0 0-1.5h-6.362a.25.25 0 0 1-.248-.22l-.093-.78h6.35a2.75 2.75 0 0 0 2.743-2.54l.358-4.652a.75.75 0 0 0-1.496-.116l-.358 4.654a1.25 1.25 0 0 1-1.246 1.154h-6.53l-.768-6.457a1.75 1.75 0 0 0-1.738-1.543h-1.612Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12 9.25a.75.75 0 0 1-1.5 0v-3.69l-1.22 1.22a.75.75 0 0 1-1.06-1.06l2.5-2.5a.75.75 0 0 1 1.06 0l2.5 2.5a.75.75 0 0 1-1.06 1.06l-1.22-1.22v3.69Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 17a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15 17a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }));
    };
    SvgCartUpIcon.displayName = "CartUpIcon";
    exports.SvgCartUpIcon = SvgCartUpIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CashDollarFilledIcon.svg.js
var require_CashDollarFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CashDollarFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCashDollarFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 17a7 7 0 1 0 0-14 7 7 0 0 0 0 14Zm-.5-10.5a.75.75 0 0 1 1.5 0v.25h.75a.75.75 0 0 1 0 1.5h-2.25a.5.5 0 0 0 0 1h1a2 2 0 1 1 0 4v.25a.75.75 0 0 1-1.5 0v-.25h-.75a.75.75 0 0 1 0-1.5h2.25a.5.5 0 0 0 0-1h-1a2 2 0 1 1 0-4v-.25Z"
      }));
    };
    SvgCashDollarFilledIcon.displayName = "CashDollarFilledIcon";
    exports.SvgCashDollarFilledIcon = SvgCashDollarFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CashDollarIcon.svg.js
var require_CashDollarIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CashDollarIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCashDollarIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.5 6.5a.75.75 0 0 1 1.5 0v.25h.75a.75.75 0 0 1 0 1.5h-2.25a.5.5 0 0 0 0 1h1a2 2 0 1 1 0 4v.25a.75.75 0 0 1-1.5 0v-.25h-.75a.75.75 0 0 1 0-1.5h2.25a.5.5 0 0 0 0-1h-1a2 2 0 1 1 0-4v-.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-1.5 0a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Z"
      }));
    };
    SvgCashDollarIcon.displayName = "CashDollarIcon";
    exports.SvgCashDollarIcon = SvgCashDollarIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CashEuroIcon.svg.js
var require_CashEuroIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CashEuroIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCashEuroIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.76 7.893c-.248.149-.579.533-.707 1.357h1.697a.75.75 0 0 1 0 1.5h-1.697c.128.823.46 1.207.708 1.357.309.185.684.137.959-.138a.75.75 0 1 1 1.06 1.061c-.725.726-1.85.927-2.79.363-.788-.472-1.304-1.385-1.449-2.643h-.291a.75.75 0 1 1 0-1.5h.291c.145-1.258.661-2.171 1.448-2.643.941-.565 2.066-.363 2.791.362a.75.75 0 0 1-1.06 1.061c-.275-.274-.65-.323-.96-.137Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 3a7 7 0 1 0 0 14 7 7 0 0 0 0-14Zm-5.5 7a5.5 5.5 0 1 1 11 0 5.5 5.5 0 0 1-11 0Z"
      }));
    };
    SvgCashEuroIcon.displayName = "CashEuroIcon";
    exports.SvgCashEuroIcon = SvgCashEuroIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CashPoundIcon.svg.js
var require_CashPoundIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CashPoundIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCashPoundIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 6a1.75 1.75 0 0 0-1.75 1.75v1.5h-.75a.75.75 0 0 0 0 1.5h.75v1h-.75a.75.75 0 0 0 0 1.5h4.5a.75.75 0 0 0 0-1.5h-2.25v-1h.75a.75.75 0 0 0 0-1.5h-.75v-1.5a.25.25 0 0 1 .25-.25h.75v.5a.75.75 0 0 0 1.5 0v-.75c0-.69-.56-1.25-1.25-1.25h-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 3a7 7 0 1 0 0 14 7 7 0 0 0 0-14Zm-5.5 7a5.5 5.5 0 1 1 11 0 5.5 5.5 0 0 1-11 0Z"
      }));
    };
    SvgCashPoundIcon.displayName = "CashPoundIcon";
    exports.SvgCashPoundIcon = SvgCashPoundIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CashRupeeIcon.svg.js
var require_CashRupeeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CashRupeeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCashRupeeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.889 13.893a.75.75 0 0 0-.246-1.032l-1.713-1.054a2.487 2.487 0 0 0 1.059-1.807h1.261a.75.75 0 0 0 0-1.5h-1.25v-.75h1.25a.75.75 0 0 0 0-1.5h-4.5a.75.75 0 1 0 0 1.5h1.75v.75h-1.75a.75.75 0 0 0 0 1.5h1.721a.989.989 0 0 1-.96.75c-.902 0-1.237 1.184-.468 1.657l2.814 1.732a.75.75 0 0 0 1.032-.246Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 3a7 7 0 1 0 0 14 7 7 0 0 0 0-14Zm-5.5 7a5.5 5.5 0 1 1 11 0 5.5 5.5 0 0 1-11 0Z"
      }));
    };
    SvgCashRupeeIcon.displayName = "CashRupeeIcon";
    exports.SvgCashRupeeIcon = SvgCashRupeeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CashYenIcon.svg.js
var require_CashYenIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CashYenIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCashYenIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.436 6.506a.75.75 0 0 1 1.058-.07l1.506 1.317 1.506-1.317a.75.75 0 0 1 .988 1.128l-1.744 1.526v.41h1.25a.75.75 0 0 1 0 1.5h-1.25v.5h1.25a.75.75 0 0 1 0 1.5h-1.25v.5a.75.75 0 0 1-1.5 0v-.5h-1.25a.75.75 0 0 1 0-1.5h1.25v-.5h-1.25a.75.75 0 0 1 0-1.5h1.25v-.41l-1.744-1.526a.75.75 0 0 1-.07-1.058Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 3a7 7 0 1 0 0 14 7 7 0 0 0 0-14Zm-5.5 7a5.5 5.5 0 1 1 11 0 5.5 5.5 0 0 1-11 0Z"
      }));
    };
    SvgCashYenIcon.displayName = "CashYenIcon";
    exports.SvgCashYenIcon = SvgCashYenIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CategoriesIcon.svg.js
var require_CategoriesIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CategoriesIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCategoriesIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.25 3.5a.75.75 0 0 0 0 1.5h5.5a.75.75 0 0 0 0-1.5h-5.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5 6.5a.75.75 0 0 1 .75-.75h8.5a.75.75 0 0 1 0 1.5h-8.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 10.75a2.75 2.75 0 0 1 2.75-2.75h7.5a2.75 2.75 0 0 1 2.75 2.75v3a2.75 2.75 0 0 1-2.75 2.75h-7.5a2.75 2.75 0 0 1-2.75-2.75v-3Zm2.75-1.25c-.69 0-1.25.56-1.25 1.25v3c0 .69.56 1.25 1.25 1.25h7.5c.69 0 1.25-.56 1.25-1.25v-3c0-.69-.56-1.25-1.25-1.25h-7.5Z"
      }));
    };
    SvgCategoriesIcon.displayName = "CategoriesIcon";
    exports.SvgCategoriesIcon = SvgCategoriesIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChannelsIcon.svg.js
var require_ChannelsIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChannelsIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChannelsIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.25 3.5a1 1 0 0 0-1 1v2a1 1 0 0 0 1 1h.25v1.5h-.25a2.75 2.75 0 0 0-2.75 2.75v2a2.75 2.75 0 0 0 2.75 2.75h2a2.75 2.75 0 0 0 2.75-2.75v-.25h1.5v.25a1 1 0 0 0 1 1h2a1 1 0 0 0 1-1v-2a1 1 0 0 0-1-1h-2a1 1 0 0 0-1 1v.25h-1.5v-.25c0-.487-.127-.944-.348-1.34l2.909-2.91h1.939a1 1 0 0 0 1-1v-2a1 1 0 0 0-1-1h-2a1 1 0 0 0-1 1v1.94l-2.91 2.908a2.738 2.738 0 0 0-1.34-.348h-.25v-1.5h.25a1 1 0 0 0 1-1v-2a1 1 0 0 0-1-1h-2Zm.5 1.5v1h1v-1h-1Zm-.5 5.5c-.69 0-1.25.56-1.25 1.25v2c0 .69.56 1.25 1.25 1.25h2c.69 0 1.25-.56 1.25-1.25v-2c0-.69-.56-1.25-1.25-1.25h-2Zm7.75-4.5v-1h1v1h-1Zm0 6.25v1h1v-1h-1Z"
      }));
    };
    SvgChannelsIcon.displayName = "ChannelsIcon";
    exports.SvgChannelsIcon = SvgChannelsIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartCohortIcon.svg.js
var require_ChartCohortIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartCohortIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChartCohortIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4.5 3.25c-.69 0-1.25.56-1.25 1.25v11c0 .69.56 1.25 1.25 1.25h3c.69 0 1.25-.56 1.25-1.25v-2.75h2.75c.69 0 1.25-.56 1.25-1.25v-2.75h2.75c.69 0 1.25-.56 1.25-1.25v-3c0-.69-.56-1.25-1.25-1.25h-11Zm4.25 8h2.5v-2.5h-2.5v2.5Zm-4 1.5v2.5h2.5v-2.5h-2.5Zm0-1.5h2.5v-2.5h-2.5v2.5Zm6.5-4h-2.5v-2.5h2.5v2.5Zm-6.5 0h2.5v-2.5h-2.5v2.5Zm10.5 0h-2.5v-2.5h2.5v2.5Z"
      }));
    };
    SvgChartCohortIcon.displayName = "ChartCohortIcon";
    exports.SvgChartCohortIcon = SvgChartCohortIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartDonutIcon.svg.js
var require_ChartDonutIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartDonutIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChartDonutIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17.938 9.003c.068.547-.386.997-.938.997a7 7 0 1 1-7-7v1.5a5.5 5.5 0 1 0 5.5 5.5h-2.5a3 3 0 1 1-3-3v-4c0-.552.45-1.007.997-.938a8 8 0 0 1 6.94 6.94Zm-1.613-.503a6.503 6.503 0 0 0-4.825-4.825v3.612a3.099 3.099 0 0 1 1.213 1.213h3.612Zm-6.325 3a1.5 1.5 0 1 1 0-3 1.5 1.5 0 0 1 0 3Z"
      }));
    };
    SvgChartDonutIcon.displayName = "ChartDonutIcon";
    exports.SvgChartDonutIcon = SvgChartDonutIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartFunnelIcon.svg.js
var require_ChartFunnelIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartFunnelIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChartFunnelIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.758 6.681a2.75 2.75 0 0 1 2.588-3.681h7.308a2.75 2.75 0 0 1 2.588 3.681l-3.06 8.5a2.75 2.75 0 0 1-2.588 1.819h-1.188a2.75 2.75 0 0 1-2.588-1.819l-3.06-8.5Zm2.588-2.181a1.25 1.25 0 0 0-1.176 1.673l.297.827h9.066l.298-.827a1.25 1.25 0 0 0-1.177-1.673h-7.308Zm.651 6.75-.99-2.75h7.986l-.99 2.75h-6.006Zm.54 1.5.693 1.923a1.25 1.25 0 0 0 1.176.827h1.188c.527 0 .998-.33 1.177-.827l.692-1.923h-4.926Z"
      }));
    };
    SvgChartFunnelIcon.displayName = "ChartFunnelIcon";
    exports.SvgChartFunnelIcon = SvgChartFunnelIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartHistogramFirstIcon.svg.js
var require_ChartHistogramFirstIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartHistogramFirstIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChartHistogramFirstIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.75 4.25a.75.75 0 0 0-1.5 0v11.5a.75.75 0 0 0 1.5 0v-11.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8 9a.75.75 0 0 1 .75.75v6a.75.75 0 0 1-1.5 0v-6a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.75 9.75a.75.75 0 0 0-1.5 0v6a.75.75 0 0 0 1.5 0v-6Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.75 9.75a.75.75 0 0 0-1.5 0v6a.75.75 0 0 0 1.5 0v-6Z"
      }));
    };
    SvgChartHistogramFirstIcon.displayName = "ChartHistogramFirstIcon";
    exports.SvgChartHistogramFirstIcon = SvgChartHistogramFirstIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartHistogramFirstLastIcon.svg.js
var require_ChartHistogramFirstLastIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartHistogramFirstLastIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChartHistogramFirstLastIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.75 4.25a.75.75 0 0 0-1.5 0v11.5a.75.75 0 0 0 1.5 0v-11.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.75 4.25a.75.75 0 0 0-1.5 0v11.5a.75.75 0 0 0 1.5 0v-11.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8 9a.75.75 0 0 1 .75.75v6a.75.75 0 0 1-1.5 0v-6a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.75 9.75a.75.75 0 0 0-1.5 0v6a.75.75 0 0 0 1.5 0v-6Z"
      }));
    };
    SvgChartHistogramFirstLastIcon.displayName = "ChartHistogramFirstLastIcon";
    exports.SvgChartHistogramFirstLastIcon = SvgChartHistogramFirstLastIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartHistogramFlatIcon.svg.js
var require_ChartHistogramFlatIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartHistogramFlatIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChartHistogramFlatIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 9.5a.75.75 0 0 1 .75.75v6a.75.75 0 0 1-1.5 0v-6a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M16 9.5a.75.75 0 0 1 .75.75v6a.75.75 0 0 1-1.5 0v-6a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8 9.5a.75.75 0 0 1 .75.75v6a.75.75 0 0 1-1.5 0v-6a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12 9.5a.75.75 0 0 1 .75.75v6a.75.75 0 0 1-1.5 0v-6a.75.75 0 0 1 .75-.75Z"
      }));
    };
    SvgChartHistogramFlatIcon.displayName = "ChartHistogramFlatIcon";
    exports.SvgChartHistogramFlatIcon = SvgChartHistogramFlatIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartHistogramFullIcon.svg.js
var require_ChartHistogramFullIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartHistogramFullIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChartHistogramFullIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.75 4.25a.75.75 0 0 0-1.5 0v11.5a.75.75 0 0 0 1.5 0v-11.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.75 4.25a.75.75 0 0 0-1.5 0v11.5a.75.75 0 0 0 1.5 0v-11.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8 3.5a.75.75 0 0 1 .75.75v11.5a.75.75 0 0 1-1.5 0v-11.5a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.75 4.25a.75.75 0 0 0-1.5 0v11.5a.75.75 0 0 0 1.5 0v-11.5Z"
      }));
    };
    SvgChartHistogramFullIcon.displayName = "ChartHistogramFullIcon";
    exports.SvgChartHistogramFullIcon = SvgChartHistogramFullIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartHistogramGrowthIcon.svg.js
var require_ChartHistogramGrowthIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartHistogramGrowthIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChartHistogramGrowthIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.75 4.25a.75.75 0 0 0-1.5 0v11.5a.75.75 0 0 0 1.5 0v-11.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.75 13.25a.75.75 0 0 0-1.5 0v2.5a.75.75 0 0 0 1.5 0v-2.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8 10a.75.75 0 0 1 .75.75v5a.75.75 0 0 1-1.5 0v-5a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.75 7.75a.75.75 0 0 0-1.5 0v8a.75.75 0 0 0 1.5 0v-8Z"
      }));
    };
    SvgChartHistogramGrowthIcon.displayName = "ChartHistogramGrowthIcon";
    exports.SvgChartHistogramGrowthIcon = SvgChartHistogramGrowthIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartHistogramLastIcon.svg.js
var require_ChartHistogramLastIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartHistogramLastIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChartHistogramLastIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 9.5a.75.75 0 0 1 .75.75v6a.75.75 0 0 1-1.5 0v-6a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12 9.5a.75.75 0 0 1 .75.75v6a.75.75 0 0 1-1.5 0v-6a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8 9.5a.75.75 0 0 1 .75.75v6a.75.75 0 0 1-1.5 0v-6a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M16 3a.75.75 0 0 1 .75.75v12.5a.75.75 0 0 1-1.5 0v-12.5a.75.75 0 0 1 .75-.75Z"
      }));
    };
    SvgChartHistogramLastIcon.displayName = "ChartHistogramLastIcon";
    exports.SvgChartHistogramLastIcon = SvgChartHistogramLastIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartHistogramSecondLastIcon.svg.js
var require_ChartHistogramSecondLastIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartHistogramSecondLastIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChartHistogramSecondLastIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 9.5a.75.75 0 0 1 .75.75v6a.75.75 0 0 1-1.5 0v-6a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M16 9.5a.75.75 0 0 1 .75.75v6a.75.75 0 0 1-1.5 0v-6a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8 9.5a.75.75 0 0 1 .75.75v6a.75.75 0 0 1-1.5 0v-6a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12 3a.75.75 0 0 1 .75.75v12.5a.75.75 0 0 1-1.5 0v-12.5a.75.75 0 0 1 .75-.75Z"
      }));
    };
    SvgChartHistogramSecondLastIcon.displayName = "ChartHistogramSecondLastIcon";
    exports.SvgChartHistogramSecondLastIcon = SvgChartHistogramSecondLastIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartHorizontalIcon.svg.js
var require_ChartHorizontalIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartHorizontalIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChartHorizontalIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11 5.452v.096c0 .182 0 .371-.034.544a1.75 1.75 0 0 1-1.375 1.374 2.824 2.824 0 0 1-.543.034h-3.596c-.182 0-.371 0-.543-.034a1.75 1.75 0 0 1-1.375-1.375 2.825 2.825 0 0 1-.034-.543v-.096c0-.182 0-.371.034-.543a1.75 1.75 0 0 1 1.375-1.375c.172-.035.361-.034.543-.034h3.596c.182 0 .371 0 .543.034a1.75 1.75 0 0 1 1.375 1.375c.035.172.034.361.034.543Zm-1.505-.253a.25.25 0 0 0-.194-.194 8.216 8.216 0 0 0-.3-.005h-3.501a8.216 8.216 0 0 0-.3.005.25.25 0 0 0-.195.194 8.217 8.217 0 0 0-.005.3 8.216 8.216 0 0 0 .005.302.25.25 0 0 0 .194.194l.053.003c.055.002.127.002.248.002h3.5a8.207 8.207 0 0 0 .3-.005.25.25 0 0 0 .195-.194 8.216 8.216 0 0 0 .005-.3 8.217 8.217 0 0 0-.005-.302Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M16.5 9.952v.096c0 .182 0 .371-.034.543a1.75 1.75 0 0 1-1.375 1.376 2.825 2.825 0 0 1-.543.033h-9.096c-.182 0-.371 0-.543-.034a1.75 1.75 0 0 1-1.375-1.374 2.826 2.826 0 0 1-.034-.544v-.096c0-.182 0-.371.034-.543a1.75 1.75 0 0 1 1.375-1.375c.172-.035.361-.034.543-.034h9.096c.182 0 .371 0 .543.034a1.75 1.75 0 0 1 1.375 1.375c.035.172.034.361.034.543Zm-1.505-.253a.25.25 0 0 0-.194-.194 8.221 8.221 0 0 0-.3-.005h-9.001a8.216 8.216 0 0 0-.3.005.25.25 0 0 0-.195.194 8.217 8.217 0 0 0-.005.3 8.221 8.221 0 0 0 .005.302.25.25 0 0 0 .194.194l.053.003c.055.002.127.002.248.002h9c.121 0 .193 0 .248-.002l.053-.003a.25.25 0 0 0 .194-.194l.003-.053a8.05 8.05 0 0 0 .002-.248c0-.121 0-.193-.002-.248l-.003-.053Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M14 14.5v-.048c0-.182 0-.371-.034-.543a1.75 1.75 0 0 0-1.375-1.375c-.172-.035-.361-.034-.543-.034h-6.596c-.182 0-.371 0-.543.034a1.75 1.75 0 0 0-1.375 1.375 2.826 2.826 0 0 0-.034.543v.096c0 .182 0 .371.034.543a1.75 1.75 0 0 0 1.375 1.376c.172.034.361.033.543.033h6.596c.182 0 .371 0 .543-.034a1.75 1.75 0 0 0 1.375-1.375c.035-.172.034-.36.034-.543v-.048Zm-1.7-.495a.25.25 0 0 1 .195.194l.003.053c.002.055.002.127.002.248s0 .194-.002.248l-.003.053a.25.25 0 0 1-.194.194l-.053.003a8.05 8.05 0 0 1-.248.002h-6.5c-.121 0-.193 0-.248-.002l-.053-.003a.25.25 0 0 1-.194-.194 8.221 8.221 0 0 1-.005-.3 8.217 8.217 0 0 1 .005-.302.25.25 0 0 1 .194-.194l.053-.003c.055-.002.127-.002.248-.002h6.5a8.05 8.05 0 0 1 .3.005h-.001.002Z"
      }));
    };
    SvgChartHorizontalIcon.displayName = "ChartHorizontalIcon";
    exports.SvgChartHorizontalIcon = SvgChartHorizontalIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartLineIcon.svg.js
var require_ChartLineIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartLineIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChartLineIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.447 4.5a.923.923 0 0 0-.908.757l-1.002 5.487a2.75 2.75 0 0 1-2.705 2.256h-.082a.75.75 0 0 1 0-1.5h.082a1.25 1.25 0 0 0 1.23-1.025l1.001-5.487a2.423 2.423 0 0 1 4.8.255l.716 9.612a.697.697 0 0 0 1.383.063l.52-3.12a2.75 2.75 0 0 1 2.712-2.298h.056a.75.75 0 0 1 0 1.5h-.056a1.25 1.25 0 0 0-1.233 1.044l-.52 3.12a2.197 2.197 0 0 1-4.358-.198l-.716-9.612a.923.923 0 0 0-.92-.854Z"
      }));
    };
    SvgChartLineIcon.displayName = "ChartLineIcon";
    exports.SvgChartLineIcon = SvgChartLineIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartPopularIcon.svg.js
var require_ChartPopularIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartPopularIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChartPopularIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M14.452 3.5h.096c.182 0 .371 0 .543.034a1.75 1.75 0 0 1 1.375 1.375c.035.172.034.361.034.543v9.096c0 .182 0 .371-.034.543a1.75 1.75 0 0 1-1.375 1.376 2.825 2.825 0 0 1-.543.033h-.096c-.182 0-.371 0-.543-.034a1.75 1.75 0 0 1-1.375-1.375 2.825 2.825 0 0 1-.034-.543v-9.096c0-.182 0-.371.034-.543a1.75 1.75 0 0 1 1.375-1.375c.172-.035.361-.034.543-.034Zm-.253 1.505a.25.25 0 0 0-.194.194l-.003.053a8.046 8.046 0 0 0-.002.248v9c0 .121 0 .194.002.248l.003.053a.25.25 0 0 0 .194.194l.053.003c.055.002.127.002.248.002s.193 0 .248-.002l.053-.003a.25.25 0 0 0 .194-.194l.003-.053a8.05 8.05 0 0 0 .002-.248v-9a8.046 8.046 0 0 0-.005-.3.25.25 0 0 0-.194-.195 8.217 8.217 0 0 0-.3-.005 8.221 8.221 0 0 0-.302.005Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.452 9h.096c.182 0 .371 0 .543.034a1.75 1.75 0 0 1 1.375 1.375c.035.172.034.361.034.543v3.596c0 .182 0 .371-.034.543a1.75 1.75 0 0 1-1.375 1.376 2.825 2.825 0 0 1-.543.033h-.096c-.182 0-.371 0-.543-.034a1.75 1.75 0 0 1-1.375-1.375 2.824 2.824 0 0 1-.034-.543v-3.596c0-.182 0-.371.034-.543a1.75 1.75 0 0 1 1.375-1.375c.172-.035.361-.034.543-.034Zm-.253 1.505a.25.25 0 0 0-.194.194 8.217 8.217 0 0 0-.005.3v3.501a8.221 8.221 0 0 0 .005.3.25.25 0 0 0 .194.195l.053.003c.055.002.127.002.248.002s.193 0 .248-.002l.053-.003a.25.25 0 0 0 .194-.194l.003-.053c.002-.054.002-.127.002-.248v-3.5a8.208 8.208 0 0 0-.005-.3.25.25 0 0 0-.194-.195 8.045 8.045 0 0 0-.3-.005 8.045 8.045 0 0 0-.302.005Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 6h-.048c-.182 0-.371 0-.543.034a1.75 1.75 0 0 0-1.375 1.375 2.824 2.824 0 0 0-.034.543v6.596c0 .182 0 .371.034.543a1.75 1.75 0 0 0 1.375 1.376c.172.034.361.033.543.033h.096c.182 0 .371 0 .543-.034a1.75 1.75 0 0 0 1.375-1.375c.035-.172.034-.36.034-.543v-6.596c0-.182 0-.371-.034-.543a1.75 1.75 0 0 0-1.375-1.375c-.172-.035-.361-.034-.543-.034h-.048Zm-.495 1.7a.25.25 0 0 1 .194-.195 8.216 8.216 0 0 1 .3-.005 8.217 8.217 0 0 1 .302.005.25.25 0 0 1 .194.194l.003.053c.002.055.002.127.002.248v6.5a8.05 8.05 0 0 1-.005.3.25.25 0 0 1-.194.195l-.053.003a8.046 8.046 0 0 1-.248.002c-.121 0-.193 0-.248-.002l-.053-.003a.25.25 0 0 1-.194-.194 8.221 8.221 0 0 1-.005-.3v-6.5a8.217 8.217 0 0 1 .005-.302v.002-.002Z"
      }));
    };
    SvgChartPopularIcon.displayName = "ChartPopularIcon";
    exports.SvgChartPopularIcon = SvgChartPopularIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartStackedIcon.svg.js
var require_ChartStackedIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartStackedIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChartStackedIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.25 5.75a2.25 2.25 0 0 0-2.25 2.25v4a2.25 2.25 0 0 0 2.25 2.25h9.5a2.25 2.25 0 0 0 2.25-2.25v-4a2.25 2.25 0 0 0-2.25-2.25h-9.5Zm-.75 2.25a.75.75 0 0 1 .75-.75h4.75v5.5h-4.75a.75.75 0 0 1-.75-.75v-4Zm8.5 4.75h1.75a.75.75 0 0 0 .75-.75v-4a.75.75 0 0 0-.75-.75h-1.75v5.5Z"
      }));
    };
    SvgChartStackedIcon.displayName = "ChartStackedIcon";
    exports.SvgChartStackedIcon = SvgChartStackedIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartVerticalFilledIcon.svg.js
var require_ChartVerticalFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartVerticalFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChartVerticalFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.971 4c-.204 0-.344 0-.465.024a1.25 1.25 0 0 0-.982.982c-.024.121-.024.26-.024.465v9.058c0 .204 0 .344.024.465.099.496.486.883.982.982a2.5 2.5 0 0 0 .465.024h.058c.204 0 .344 0 .465-.024a1.25 1.25 0 0 0 .982-.982 2.5 2.5 0 0 0 .024-.465v-9.058c0-.204 0-.344-.024-.465a1.25 1.25 0 0 0-.982-.982 2.504 2.504 0 0 0-.465-.024h-.058Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.471 9.5c-.204 0-.344 0-.465.024a1.25 1.25 0 0 0-.982.982c-.024.121-.024.26-.024.465v3.558c0 .204 0 .344.024.465.099.496.486.883.982.982a2.5 2.5 0 0 0 .465.024h.058c.204 0 .344 0 .465-.024a1.25 1.25 0 0 0 .982-.982c.024-.121.024-.26.024-.465v-3.558c0-.204 0-.344-.024-.465a1.25 1.25 0 0 0-.982-.982 2.503 2.503 0 0 0-.465-.024h-.058Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.471 6.5c-.204 0-.344 0-.465.024a1.25 1.25 0 0 0-.982.982c-.024.121-.024.26-.024.465v6.558c0 .204 0 .344.024.465.099.496.486.883.982.982.121.024.26.024.465.024h.058c.204 0 .344 0 .465-.024a1.25 1.25 0 0 0 .982-.982c.024-.121.024-.26.024-.465v-6.558c0-.204 0-.344-.024-.465a1.25 1.25 0 0 0-.982-.982 2.504 2.504 0 0 0-.465-.024h-.058Z"
      }));
    };
    SvgChartVerticalFilledIcon.displayName = "ChartVerticalFilledIcon";
    exports.SvgChartVerticalFilledIcon = SvgChartVerticalFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartVerticalIcon.svg.js
var require_ChartVerticalIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChartVerticalIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChartVerticalIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9.952 3.5h.096c.182 0 .371 0 .543.034a1.75 1.75 0 0 1 1.375 1.375c.035.172.034.361.034.543v9.096c0 .182 0 .371-.034.543a1.75 1.75 0 0 1-1.375 1.376 2.825 2.825 0 0 1-.543.033h-.096c-.182 0-.371 0-.543-.034a1.75 1.75 0 0 1-1.375-1.375 2.824 2.824 0 0 1-.034-.543v-9.096c0-.182 0-.371.034-.543a1.75 1.75 0 0 1 1.375-1.375c.172-.035.361-.034.543-.034Zm-.253 1.505a.25.25 0 0 0-.194.194 8.217 8.217 0 0 0-.005.3v9.001a8.221 8.221 0 0 0 .005.3.25.25 0 0 0 .194.195l.053.003c.055.002.127.002.248.002s.193 0 .248-.002l.053-.003a.25.25 0 0 0 .194-.194l.003-.053a8.05 8.05 0 0 0 .002-.248v-9a8.046 8.046 0 0 0-.005-.3.25.25 0 0 0-.194-.195 8.217 8.217 0 0 0-.3-.005 8.216 8.216 0 0 0-.302.005Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.452 9h.096c.182 0 .371 0 .543.034a1.75 1.75 0 0 1 1.375 1.375c.035.172.034.361.034.543v3.596c0 .182 0 .371-.034.543a1.75 1.75 0 0 1-1.375 1.376 2.825 2.825 0 0 1-.543.033h-.096c-.182 0-.371 0-.543-.034a1.75 1.75 0 0 1-1.375-1.375 2.824 2.824 0 0 1-.034-.543v-3.596c0-.182 0-.371.034-.543a1.75 1.75 0 0 1 1.375-1.375c.172-.035.361-.034.543-.034Zm-.253 1.505a.25.25 0 0 0-.194.194 8.217 8.217 0 0 0-.005.3v3.501a8.221 8.221 0 0 0 .005.3.25.25 0 0 0 .194.195l.053.003c.055.002.127.002.248.002s.193 0 .248-.002l.053-.003a.25.25 0 0 0 .194-.194l.003-.053c.002-.054.002-.127.002-.248v-3.5a8.208 8.208 0 0 0-.005-.3.25.25 0 0 0-.194-.195 8.045 8.045 0 0 0-.3-.005 8.045 8.045 0 0 0-.302.005Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M14.5 6h-.048c-.182 0-.371 0-.543.034a1.75 1.75 0 0 0-1.375 1.375 2.825 2.825 0 0 0-.034.543v6.596c0 .182 0 .371.034.543a1.75 1.75 0 0 0 1.375 1.376c.172.034.361.033.543.033h.096c.182 0 .371 0 .543-.034a1.75 1.75 0 0 0 1.375-1.375c.035-.172.034-.36.034-.543v-6.596c0-.182 0-.371-.034-.543a1.75 1.75 0 0 0-1.375-1.375c-.172-.035-.361-.034-.543-.034h-.048Zm-.495 1.7a.25.25 0 0 1 .194-.195 8.221 8.221 0 0 1 .3-.005 8.217 8.217 0 0 1 .302.005.25.25 0 0 1 .194.194l.003.053c.002.055.002.127.002.248v6.5a8.05 8.05 0 0 1-.005.3.25.25 0 0 1-.194.195l-.053.003a8.046 8.046 0 0 1-.248.002c-.121 0-.193 0-.248-.002l-.053-.003a.25.25 0 0 1-.194-.194l-.003-.053a8.05 8.05 0 0 1-.002-.248v-6.5c0-.121 0-.193.002-.248l.003-.053v.002-.002Z"
      }));
    };
    SvgChartVerticalIcon.displayName = "ChartVerticalIcon";
    exports.SvgChartVerticalIcon = SvgChartVerticalIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChatIcon.svg.js
var require_ChatIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChatIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChatIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7 15v-2.291a3 3 0 0 1-2.5-2.959v-1.25a3 3 0 0 1 3-3h5a3 3 0 0 1 3 3v1.25a3 3 0 0 1-3 3h-2.461l-3.039 2.25Zm3.534-.75h1.966a4.5 4.5 0 0 0 4.5-4.5v-1.25a4.5 4.5 0 0 0-4.5-4.5h-5a4.5 4.5 0 0 0-4.5 4.5v1.25a4.498 4.498 0 0 0 2.5 4.032v1.218a1.5 1.5 0 0 0 2.393 1.206l2.64-1.956Zm-4.534-6.5a.75.75 0 0 1 .75-.75h5.5a.75.75 0 0 1 0 1.5h-5.5a.75.75 0 0 1-.75-.75Zm.75 2a.75.75 0 0 0 0 1.5h3.5a.75.75 0 0 0 0-1.5h-3.5Z"
      }));
    };
    SvgChatIcon.displayName = "ChatIcon";
    exports.SvgChatIcon = SvgChatIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChatReferralIcon.svg.js
var require_ChatReferralIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChatReferralIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChatReferralIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.5 8.75a3.25 3.25 0 0 1 3.25-3.25h3.75a.75.75 0 0 0 0-1.5h-3.75a4.75 4.75 0 0 0-4.75 4.75v.75c0 2.1 1.362 3.88 3.25 4.508v1.992a.75.75 0 0 0 1.196.603l3.178-2.353h1.626a4.75 4.75 0 0 0 4.75-4.75.75.75 0 0 0-1.5 0 3.25 3.25 0 0 1-3.25 3.25h-1.873a.75.75 0 0 0-.447.147l-2.18 1.614v-1.081a.75.75 0 0 0-.61-.737 3.251 3.251 0 0 1-2.64-3.193v-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.75 4a.75.75 0 0 0 0 1.5h.69l-3.22 3.22a.75.75 0 0 0 1.06 1.06l3.22-3.22v.69a.75.75 0 0 0 1.5 0v-2.5a.75.75 0 0 0-.75-.75h-2.5Z"
      }));
    };
    SvgChatReferralIcon.displayName = "ChatReferralIcon";
    exports.SvgChatReferralIcon = SvgChatReferralIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CheckCircleIcon.svg.js
var require_CheckCircleIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CheckCircleIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCheckCircleIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.28 9.03a.75.75 0 0 0-1.06-1.06l-2.97 2.97-1.22-1.22a.75.75 0 0 0-1.06 1.06l1.75 1.75a.75.75 0 0 0 1.06 0l3.5-3.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-1.5 0a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Z"
      }));
    };
    SvgCheckCircleIcon.displayName = "CheckCircleIcon";
    exports.SvgCheckCircleIcon = SvgCheckCircleIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CheckIcon.svg.js
var require_CheckIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CheckIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCheckIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15.78 5.97a.75.75 0 0 1 0 1.06l-6.5 6.5a.75.75 0 0 1-1.06 0l-3.25-3.25a.75.75 0 1 1 1.06-1.06l2.72 2.72 5.97-5.97a.75.75 0 0 1 1.06 0Z"
      }));
    };
    SvgCheckIcon.displayName = "CheckIcon";
    exports.SvgCheckIcon = SvgCheckIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CheckSmallIcon.svg.js
var require_CheckSmallIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CheckSmallIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCheckSmallIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M14.03 7.22a.75.75 0 0 1 0 1.06l-4.5 4.5a.75.75 0 0 1-1.06 0l-2.25-2.25a.75.75 0 1 1 1.06-1.06l1.72 1.72 3.97-3.97a.75.75 0 0 1 1.06 0Z"
      }));
    };
    SvgCheckSmallIcon.displayName = "CheckSmallIcon";
    exports.SvgCheckSmallIcon = SvgCheckSmallIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CheckboxIcon.svg.js
var require_CheckboxIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CheckboxIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCheckboxIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.28 8.78a.75.75 0 0 0-1.06-1.06l-2.97 2.97-1.22-1.22a.75.75 0 0 0-1.06 1.06l1.75 1.75a.75.75 0 0 0 1.06 0l3.5-3.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.25 3.5a2.75 2.75 0 0 0-2.75 2.75v7.5a2.75 2.75 0 0 0 2.75 2.75h7.5a2.75 2.75 0 0 0 2.75-2.75v-7.5a2.75 2.75 0 0 0-2.75-2.75h-7.5Zm-1.25 2.75c0-.69.56-1.25 1.25-1.25h7.5c.69 0 1.25.56 1.25 1.25v7.5c0 .69-.56 1.25-1.25 1.25h-7.5c-.69 0-1.25-.56-1.25-1.25v-7.5Z"
      }));
    };
    SvgCheckboxIcon.displayName = "CheckboxIcon";
    exports.SvgCheckboxIcon = SvgCheckboxIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChevronDownIcon.svg.js
var require_ChevronDownIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChevronDownIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChevronDownIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.72 8.47a.75.75 0 0 1 1.06 0l3.47 3.47 3.47-3.47a.75.75 0 1 1 1.06 1.06l-4 4a.75.75 0 0 1-1.06 0l-4-4a.75.75 0 0 1 0-1.06Z"
      }));
    };
    SvgChevronDownIcon.displayName = "ChevronDownIcon";
    exports.SvgChevronDownIcon = SvgChevronDownIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChevronLeftIcon.svg.js
var require_ChevronLeftIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChevronLeftIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChevronLeftIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11.764 5.204a.75.75 0 0 1 .032 1.06l-3.516 3.736 3.516 3.736a.75.75 0 1 1-1.092 1.028l-4-4.25a.75.75 0 0 1 0-1.028l4-4.25a.75.75 0 0 1 1.06-.032Z"
      }));
    };
    SvgChevronLeftIcon.displayName = "ChevronLeftIcon";
    exports.SvgChevronLeftIcon = SvgChevronLeftIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChevronRightIcon.svg.js
var require_ChevronRightIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChevronRightIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChevronRightIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.72 14.53a.75.75 0 0 1 0-1.06l3.47-3.47-3.47-3.47a.75.75 0 0 1 1.06-1.06l4 4a.75.75 0 0 1 0 1.06l-4 4a.75.75 0 0 1-1.06 0Z"
      }));
    };
    SvgChevronRightIcon.displayName = "ChevronRightIcon";
    exports.SvgChevronRightIcon = SvgChevronRightIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChevronUpIcon.svg.js
var require_ChevronUpIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ChevronUpIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgChevronUpIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M14.53 12.28a.75.75 0 0 1-1.06 0l-3.47-3.47-3.47 3.47a.75.75 0 0 1-1.06-1.06l4-4a.75.75 0 0 1 1.06 0l4 4a.75.75 0 0 1 0 1.06Z"
      }));
    };
    SvgChevronUpIcon.displayName = "ChevronUpIcon";
    exports.SvgChevronUpIcon = SvgChevronUpIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CircleChevronDownIcon.svg.js
var require_CircleChevronDownIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CircleChevronDownIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCircleChevronDownIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.53 8.22a.75.75 0 0 0-1.06 1.06l3 3a.75.75 0 0 0 1.06 0l3-3a.75.75 0 0 0-1.06-1.06l-2.47 2.47-2.47-2.47Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-1.5 0a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Z"
      }));
    };
    SvgCircleChevronDownIcon.displayName = "CircleChevronDownIcon";
    exports.SvgCircleChevronDownIcon = SvgCircleChevronDownIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CircleChevronLeftIcon.svg.js
var require_CircleChevronLeftIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CircleChevronLeftIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCircleChevronLeftIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11.78 6.47a.75.75 0 0 1 0 1.06l-2.47 2.47 2.47 2.47a.75.75 0 1 1-1.06 1.06l-3-3a.75.75 0 0 1 0-1.06l3-3a.75.75 0 0 1 1.06 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 15.5a5.5 5.5 0 1 0 0-11 5.5 5.5 0 0 0 0 11Zm0 1.5a7 7 0 1 0 0-14 7 7 0 0 0 0 14Z"
      }));
    };
    SvgCircleChevronLeftIcon.displayName = "CircleChevronLeftIcon";
    exports.SvgCircleChevronLeftIcon = SvgCircleChevronLeftIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CircleChevronRightIcon.svg.js
var require_CircleChevronRightIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CircleChevronRightIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCircleChevronRightIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.22 12.47a.75.75 0 1 0 1.06 1.06l3-3a.75.75 0 0 0 .001-1.06l-3-3.012a.75.75 0 0 0-1.062 1.059l2.472 2.482-2.471 2.47Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-1.5 0a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Z"
      }));
    };
    SvgCircleChevronRightIcon.displayName = "CircleChevronRightIcon";
    exports.SvgCircleChevronRightIcon = SvgCircleChevronRightIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CircleChevronUpIcon.svg.js
var require_CircleChevronUpIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CircleChevronUpIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCircleChevronUpIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.47 11.78a.75.75 0 1 0 1.06-1.06l-3-3a.75.75 0 0 0-1.06 0l-3 3a.75.75 0 1 0 1.06 1.06l2.47-2.47 2.47 2.47Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-1.5 0a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Z"
      }));
    };
    SvgCircleChevronUpIcon.displayName = "CircleChevronUpIcon";
    exports.SvgCircleChevronUpIcon = SvgCircleChevronUpIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CircleDownIcon.svg.js
var require_CircleDownIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CircleDownIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCircleDownIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 6.5a.75.75 0 0 0-1.5 0v5.19l-1.22-1.22a.75.75 0 0 0-1.06 1.06l2.5 2.5a.75.75 0 0 0 1.06 0l2.5-2.5a.75.75 0 1 0-1.06-1.06l-1.22 1.22v-5.19Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-1.5 0a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Z"
      }));
    };
    SvgCircleDownIcon.displayName = "CircleDownIcon";
    exports.SvgCircleDownIcon = SvgCircleDownIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CircleLeftIcon.svg.js
var require_CircleLeftIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CircleLeftIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCircleLeftIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15.5 10a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Zm1.5 0a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-3.5.75a.75.75 0 0 0 0-1.5h-5.19l1.22-1.22a.75.75 0 0 0-1.06-1.06l-2.5 2.5a.75.75 0 0 0 0 1.06l2.5 2.5a.75.75 0 0 0 1.06-1.06l-1.22-1.22h5.19Z"
      }));
    };
    SvgCircleLeftIcon.displayName = "CircleLeftIcon";
    exports.SvgCircleLeftIcon = SvgCircleLeftIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CircleRightIcon.svg.js
var require_CircleRightIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CircleRightIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCircleRightIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.5 9.25a.75.75 0 0 0 0 1.5h5.19l-1.22 1.22a.75.75 0 1 0 1.06 1.06l2.5-2.5a.75.75 0 0 0 0-1.06l-2.5-2.5a.75.75 0 1 0-1.06 1.06l1.22 1.22h-5.19Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-1.5 0a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Z"
      }));
    };
    SvgCircleRightIcon.displayName = "CircleRightIcon";
    exports.SvgCircleRightIcon = SvgCircleRightIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CircleUpIcon.svg.js
var require_CircleUpIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CircleUpIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCircleUpIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 13.5a.75.75 0 0 1-1.5 0v-5.19l-1.22 1.22a.75.75 0 0 1-1.06-1.06l2.5-2.5a.75.75 0 0 1 1.06 0l2.5 2.5a.75.75 0 0 1-1.06 1.06l-1.22-1.22v5.19Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-1.5 0a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Z"
      }));
    };
    SvgCircleUpIcon.displayName = "CircleUpIcon";
    exports.SvgCircleUpIcon = SvgCircleUpIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ClipboardCheckFilledIcon.svg.js
var require_ClipboardCheckFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ClipboardCheckFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgClipboardCheckFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11.5 4.5h-3a.5.5 0 0 0-.5.5v1a.5.5 0 0 0 .5.5h3a.5.5 0 0 0 .5-.5v-1a.5.5 0 0 0-.5-.5Zm-3-1.5a2 2 0 0 0-1.985 1.75h-.265a2.25 2.25 0 0 0-2.25 2.25v7.75a2.25 2.25 0 0 0 2.25 2.25h7.5a2.25 2.25 0 0 0 2.25-2.25v-7.75a2.25 2.25 0 0 0-2.25-2.25h-.265a2 2 0 0 0-1.985-1.75h-3Zm4.78 7.28a.75.75 0 1 0-1.06-1.06l-2.97 2.97-1.22-1.22a.75.75 0 0 0-1.06 1.06l1.75 1.75a.75.75 0 0 0 1.06 0l3.5-3.5Z"
      }));
    };
    SvgClipboardCheckFilledIcon.displayName = "ClipboardCheckFilledIcon";
    exports.SvgClipboardCheckFilledIcon = SvgClipboardCheckFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ClipboardCheckIcon.svg.js
var require_ClipboardCheckIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ClipboardCheckIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgClipboardCheckIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.28 9.22a.75.75 0 0 1 0 1.06l-3.5 3.5a.75.75 0 0 1-1.06 0l-1.75-1.75a.75.75 0 1 1 1.06-1.06l1.22 1.22 2.97-2.97a.75.75 0 0 1 1.06 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.515 4.75a2 2 0 0 1 1.985-1.75h3a2 2 0 0 1 1.985 1.75h.265a2.25 2.25 0 0 1 2.25 2.25v7.75a2.25 2.25 0 0 1-2.25 2.25h-7.5a2.25 2.25 0 0 1-2.25-2.25v-7.75a2.25 2.25 0 0 1 2.25-2.25h.265Zm1.985-.25h3a.5.5 0 0 1 .5.5v1a.5.5 0 0 1-.5.5h-3a.5.5 0 0 1-.5-.5v-1a.5.5 0 0 1 .5-.5Zm-1.987 1.73.002.02h-.265a.75.75 0 0 0-.75.75v7.75c0 .414.336.75.75.75h7.5a.75.75 0 0 0 .75-.75v-7.75a.75.75 0 0 0-.75-.75h-.265a2 2 0 0 1-1.985 1.75h-3a2 2 0 0 1-1.987-1.77Z"
      }));
    };
    SvgClipboardCheckIcon.displayName = "ClipboardCheckIcon";
    exports.SvgClipboardCheckIcon = SvgClipboardCheckIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ClipboardChecklistIcon.svg.js
var require_ClipboardChecklistIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ClipboardChecklistIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgClipboardChecklistIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.75 10.25a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.75 14.25a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.75 10.25a.75.75 0 0 1 .75-.75h2a.75.75 0 0 1 0 1.5h-2a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.5 12.5a.75.75 0 0 0 0 1.5h2a.75.75 0 0 0 0-1.5h-2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.515 4.75a2 2 0 0 1 1.985-1.75h3a2 2 0 0 1 1.985 1.75h.265a2.25 2.25 0 0 1 2.25 2.25v7.75a2.25 2.25 0 0 1-2.25 2.25h-7.5a2.25 2.25 0 0 1-2.25-2.25v-7.75a2.25 2.25 0 0 1 2.25-2.25h.265Zm1.985-.25h3a.5.5 0 0 1 .5.5v1a.5.5 0 0 1-.5.5h-3a.5.5 0 0 1-.5-.5v-1a.5.5 0 0 1 .5-.5Zm-2.25 1.75h.265a2 2 0 0 0 1.985 1.75h3a2 2 0 0 0 1.985-1.75h.265a.75.75 0 0 1 .75.75v7.75a.75.75 0 0 1-.75.75h-7.5a.75.75 0 0 1-.75-.75v-7.75a.75.75 0 0 1 .75-.75Z"
      }));
    };
    SvgClipboardChecklistIcon.displayName = "ClipboardChecklistIcon";
    exports.SvgClipboardChecklistIcon = SvgClipboardChecklistIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ClipboardIcon.svg.js
var require_ClipboardIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ClipboardIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgClipboardIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.515 4.75a2 2 0 0 1 1.985-1.75h3a2 2 0 0 1 1.985 1.75h.265a2.25 2.25 0 0 1 2.25 2.25v7.75a2.25 2.25 0 0 1-2.25 2.25h-7.5a2.25 2.25 0 0 1-2.25-2.25v-7.75a2.25 2.25 0 0 1 2.25-2.25h.265Zm1.985-.25h3a.5.5 0 0 1 .5.5v1a.5.5 0 0 1-.5.5h-3a.5.5 0 0 1-.5-.5v-1a.5.5 0 0 1 .5-.5Zm-1.987 1.73.002.02h-.265a.75.75 0 0 0-.75.75v7.75c0 .414.336.75.75.75h7.5a.75.75 0 0 0 .75-.75v-7.75a.75.75 0 0 0-.75-.75h-.265a2 2 0 0 1-1.985 1.75h-3a2 2 0 0 1-1.987-1.77Z"
      }));
    };
    SvgClipboardIcon.displayName = "ClipboardIcon";
    exports.SvgClipboardIcon = SvgClipboardIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ClockIcon.svg.js
var require_ClockIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ClockIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgClockIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 6a.75.75 0 0 0-1.5 0v4c0 .199.079.39.22.53l2 2a.75.75 0 1 0 1.06-1.06l-1.78-1.78v-3.69Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-1.5 0a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Z"
      }));
    };
    SvgClockIcon.displayName = "ClockIcon";
    exports.SvgClockIcon = SvgClockIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CodeAddIcon.svg.js
var require_CodeAddIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CodeAddIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCodeAddIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.03 7.28a.75.75 0 0 0-1.06-1.06l-3.25 3.25a.75.75 0 0 0 0 1.06l3.25 3.25a.75.75 0 0 0 1.06-1.06l-2.72-2.72 2.72-2.72Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.97 13.78a.75.75 0 0 0 1.06 0l3.25-3.25a.75.75 0 0 0 0-1.06l-3.25-3.25a.75.75 0 1 0-1.06 1.06l2.72 2.72-2.72 2.72a.75.75 0 0 0 0 1.06Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 6.75a.75.75 0 0 1 .75.75v1.75h1.75a.75.75 0 0 1 0 1.5h-1.75v1.75a.75.75 0 0 1-1.5 0v-1.75h-1.75a.75.75 0 0 1 0-1.5h1.75v-1.75a.75.75 0 0 1 .75-.75Z"
      }));
    };
    SvgCodeAddIcon.displayName = "CodeAddIcon";
    exports.SvgCodeAddIcon = SvgCodeAddIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CodeIcon.svg.js
var require_CodeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CodeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCodeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.221 4.956a.75.75 0 0 0-1.442-.412l-3 10.5a.75.75 0 1 0 1.442.412l3-10.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.03 6.22a.75.75 0 0 1 0 1.06l-2.72 2.72 2.72 2.72a.75.75 0 0 1-1.06 1.06l-3.25-3.25a.75.75 0 0 1 0-1.06l3.25-3.25a.75.75 0 0 1 1.06 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.97 13.78a.75.75 0 0 1 0-1.06l2.72-2.72-2.72-2.72a.75.75 0 0 1 1.06-1.06l3.25 3.25a.75.75 0 0 1 0 1.06l-3.25 3.25a.75.75 0 0 1-1.06 0Z"
      }));
    };
    SvgCodeIcon.displayName = "CodeIcon";
    exports.SvgCodeIcon = SvgCodeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CollectionFeaturedIcon.svg.js
var require_CollectionFeaturedIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CollectionFeaturedIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCollectionFeaturedIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.5 6.5a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10.169 3a3.75 3.75 0 0 0-2.652 1.098l-3.883 3.883a2.75 2.75 0 0 0 0 3.89l2.672 2.672a2.5 2.5 0 0 0 3.536 0l4.206-4.206a3.25 3.25 0 0 0 .952-2.298v-2.289a2.75 2.75 0 0 0-2.75-2.75h-2.081Zm-1.591 2.159a2.25 2.25 0 0 1 1.59-.659h2.082c.69 0 1.25.56 1.25 1.25v2.289c0 .464-.184.909-.513 1.237l-4.206 4.206a1 1 0 0 1-1.414 0l-2.672-2.672a1.25 1.25 0 0 1 0-1.768l3.883-3.883Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M17.5 6.25a.75.75 0 0 0-1.5 0v3.029c0 .468-.188.917-.521 1.245l-.63.623a.75.75 0 0 0 1.053 1.067l.63-.622a3.25 3.25 0 0 0 .968-2.313v-3.029Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11.825 13.556a1.964 1.964 0 0 1 2.575-.142 1.964 1.964 0 0 1 2.575.142 1.9 1.9 0 0 1 0 2.724l-1.7 1.664a1.25 1.25 0 0 1-1.75 0l-1.7-1.664a1.9 1.9 0 0 1 0-2.724Zm1.05 1.072a.463.463 0 0 1 .639 0l.362.354a.75.75 0 0 0 1.049 0l.361-.354a.463.463 0 0 1 .64 0 .4.4 0 0 1 0 .58l-1.526 1.493-1.526-1.493a.4.4 0 0 1 0-.58Z"
      }));
    };
    SvgCollectionFeaturedIcon.displayName = "CollectionFeaturedIcon";
    exports.SvgCollectionFeaturedIcon = SvgCollectionFeaturedIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CollectionFilledIcon.svg.js
var require_CollectionFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CollectionFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCollectionFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.517 4.348a3.75 3.75 0 0 1 2.652-1.098h1.831a2.75 2.75 0 0 1 2.75 2.75v2.039a3.25 3.25 0 0 1-.952 2.298l-3.956 3.956a2.5 2.5 0 0 1-3.536 0l-2.422-2.422a2.75 2.75 0 0 1 0-3.89l3.633-3.633Zm3.983 3.152a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M17.5 6.25a.75.75 0 0 0-1.5 0v3.029c0 .468-.188.917-.521 1.245l-4.756 4.692a.75.75 0 1 0 1.054 1.068l4.755-4.692a3.25 3.25 0 0 0 .968-2.313v-3.029Z"
      }));
    };
    SvgCollectionFilledIcon.displayName = "CollectionFilledIcon";
    exports.SvgCollectionFilledIcon = SvgCollectionFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CollectionIcon.svg.js
var require_CollectionIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CollectionIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCollectionIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.5 7.5a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.517 4.098a3.75 3.75 0 0 1 2.652-1.098h2.081a2.75 2.75 0 0 1 2.75 2.75v2.289a3.25 3.25 0 0 1-.952 2.298l-4.206 4.206a2.5 2.5 0 0 1-3.536 0l-2.672-2.672a2.75 2.75 0 0 1 0-3.89l3.883-3.883Zm2.652.402a2.25 2.25 0 0 0-1.591.659l-3.883 3.883a1.25 1.25 0 0 0 0 1.768l2.672 2.672a1 1 0 0 0 1.414 0l4.206-4.206a1.75 1.75 0 0 0 .513-1.237v-2.289c0-.69-.56-1.25-1.25-1.25h-2.081Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.75 5.5a.75.75 0 0 1 .75.75v3.029a3.25 3.25 0 0 1-.968 2.313l-4.755 4.692a.75.75 0 1 1-1.054-1.068l4.756-4.692a1.75 1.75 0 0 0 .521-1.245v-3.029a.75.75 0 0 1 .75-.75Z"
      }));
    };
    SvgCollectionIcon.displayName = "CollectionIcon";
    exports.SvgCollectionIcon = SvgCollectionIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CollectionReferenceIcon.svg.js
var require_CollectionReferenceIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CollectionReferenceIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCollectionReferenceIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.5 6.5a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10.169 3a3.75 3.75 0 0 0-2.652 1.098l-3.883 3.883a2.75 2.75 0 0 0 0 3.89l2.672 2.672a2.5 2.5 0 0 0 3.536 0l4.206-4.206a3.25 3.25 0 0 0 .952-2.298v-2.289a2.75 2.75 0 0 0-2.75-2.75h-2.081Zm-1.591 2.159a2.25 2.25 0 0 1 1.59-.659h2.082c.69 0 1.25.56 1.25 1.25v2.289c0 .464-.184.909-.513 1.237l-4.206 4.206a1 1 0 0 1-1.414 0l-2.672-2.672a1.25 1.25 0 0 1 0-1.768l3.883-3.883Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M17.5 6.25a.75.75 0 0 0-1.5 0v2.964c0 .465-.184.91-.513 1.238l-.017.018a.75.75 0 1 0 1.06 1.06l.018-.017a3.25 3.25 0 0 0 .952-2.299v-2.964Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M17.53 16.47a.75.75 0 0 1-1.06 1.06l-2.22-2.22v1.19a.75.75 0 0 1-1.5 0v-3a.75.75 0 0 1 .75-.75h3a.75.75 0 1 1 0 1.5h-1.19l2.22 2.22Z"
      }));
    };
    SvgCollectionReferenceIcon.displayName = "CollectionReferenceIcon";
    exports.SvgCollectionReferenceIcon = SvgCollectionReferenceIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ColorIcon.svg.js
var require_ColorIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ColorIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgColorIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5 3a.75.75 0 0 0 0 1.5h2.69l-5.013 5.012a1.75 1.75 0 0 0 0 2.475l4.086 4.086a1.75 1.75 0 0 0 2.474 0l6.543-6.543a.75.75 0 0 0 0-1.06l-4.793-4.793-.013-.014-.444-.443a.75.75 0 0 0-.53-.22h-5Zm4.921 1.732.799.798.009.01 3.46 3.46-1.69 1.69-1.865-1.867a1.25 1.25 0 0 0-1.768 0l-1.293 1.293a1.25 1.25 0 0 0 0 1.768l1.866 1.866-1.262 1.262a.25.25 0 0 1-.354 0l-4.086-4.085a.25.25 0 0 1 0-.354l5.836-5.836a.25.25 0 0 1 .348-.005Zm.579 7.957.94-.94-1.69-1.688-.94.939 1.69 1.69Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M17 15a1.5 1.5 0 1 1-3 0c0-.53.614-2.122 1.057-3.2a.476.476 0 0 1 .886 0c.443 1.078 1.057 2.67 1.057 3.2Z"
      }));
    };
    SvgColorIcon.displayName = "ColorIcon";
    exports.SvgColorIcon = SvgColorIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ColorNoneIcon.svg.js
var require_ColorNoneIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ColorNoneIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgColorNoneIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "m9.524 3.67-.002.002-.004.003-.012.01-.042.036a17.321 17.321 0 0 0-.686.624c-.438.42-1.023 1.02-1.61 1.743-1.146 1.411-2.418 3.43-2.418 5.542 0 .69.118 1.342.335 1.937l1.223-1.224a4.322 4.322 0 0 1-.058-.713c0-1.566.978-3.237 2.082-4.596a17.879 17.879 0 0 1 1.668-1.78c.057.053.119.11.184.173.4.384.93.929 1.461 1.58l1.066-1.066a19.522 19.522 0 0 0-2.175-2.22l-.042-.036-.012-.01-.004-.003-.002-.001a.75.75 0 0 0-.953 0Zm.476.58.476-.58-.476.58Zm-.476-.58.476.58Zm0 0s0 .002.06.073Zm.06.073.416.507Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "m13.803 6.97-8.273 8.273-.002.002a.75.75 0 0 0 1.063 1.058l.308-.307a5.216 5.216 0 0 0 3.101 1.004c2 0 3.75-1.093 4.636-2.798a5.557 5.557 0 0 0 .614-2.572c0-1.099-.345-2.173-.836-3.15l.45-.45a.75.75 0 0 0-1.06-1.06Zm-3.803 8.53a3.74 3.74 0 0 1-2.023-.583l5.309-5.308c.287.671.464 1.356.464 2.021 0 .704-.164 1.339-.445 1.88a3.683 3.683 0 0 1-3.305 1.99Z"
      }));
    };
    SvgColorNoneIcon.displayName = "ColorNoneIcon";
    exports.SvgColorNoneIcon = SvgColorNoneIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CompassIcon.svg.js
var require_CompassIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CompassIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCompassIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13.28 6.72a.75.75 0 0 1 .19.742l-1.25 4.25a.75.75 0 0 1-.508.508l-4.25 1.25a.75.75 0 0 1-.932-.932l1.25-4.25a.75.75 0 0 1 .508-.508l4.25-1.25a.75.75 0 0 1 .742.19Zm-4.176 2.384-.747 2.539 2.539-.747-1.792-1.792Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3 10a7 7 0 1 1 14 0 7 7 0 0 1-14 0Zm7-5.5a5.5 5.5 0 1 0 0 11 5.5 5.5 0 0 0 0-11Z"
      }));
    };
    SvgCompassIcon.displayName = "CompassIcon";
    exports.SvgCompassIcon = SvgCompassIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ComposeIcon.svg.js
var require_ComposeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ComposeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgComposeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.666 3.603a.5.5 0 0 1 .707 0l1.06 1.061a.5.5 0 0 1 0 .707l-.957.957-1.767-1.767.957-.958Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "m13.002 5.268 1.767 1.767-3.83 3.831a2 2 0 0 1-1.348.585l-.772.025a.25.25 0 0 1-.258-.258l.025-.772a2 2 0 0 1 .585-1.348l3.83-3.83Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5 7.25a2.25 2.25 0 0 1 2.25-2.25h1.83a.75.75 0 1 0 0-1.5h-1.83a3.75 3.75 0 0 0-3.75 3.75v5.5a3.75 3.75 0 0 0 3.75 3.75h5.5a3.75 3.75 0 0 0 3.75-3.75v-1.83a.75.75 0 0 0-1.5 0v1.83a2.25 2.25 0 0 1-2.25 2.25h-5.5a2.25 2.25 0 0 1-2.25-2.25v-5.5Z"
      }));
    };
    SvgComposeIcon.displayName = "ComposeIcon";
    exports.SvgComposeIcon = SvgComposeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ConfettiIcon.svg.js
var require_ConfettiIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ConfettiIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgConfettiIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.029 3.033a.75.75 0 0 1 .5.935l-.703 2.313a.75.75 0 0 1-1.436-.436l.703-2.313a.75.75 0 0 1 .936-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16 3.75a.75.75 0 0 0-1.5 0v.25h-.25a.75.75 0 0 0 0 1.5h.25v.25a.75.75 0 0 0 1.5 0v-.25h.25a.75.75 0 0 0 0-1.5h-.25v-.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.306 7.746a1.75 1.75 0 0 0-2.834.521l-2.093 4.669a2.75 2.75 0 0 0 .565 3.07l.051.05a2.75 2.75 0 0 0 3.07.565l4.668-2.093a1.75 1.75 0 0 0 .521-2.834l-3.948-3.948Zm-1.465 1.135a.25.25 0 0 1 .405-.074l3.948 3.947a.25.25 0 0 1-.075.405l-4.668 2.093a1.25 1.25 0 0 1-1.395-.257l-.051-.05a1.25 1.25 0 0 1-.257-1.396l2.093-4.668Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.75 3a.75.75 0 0 1 .75.75v.25h.25a.75.75 0 1 1 0 1.5h-.25v.25a.75.75 0 0 1-1.5 0v-.25h-.25a.75.75 0 0 1 0-1.5h.25v-.25a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16 13.25a.75.75 0 0 0-1.5 0v.25h-.25a.75.75 0 0 0 0 1.5h.25v.25a.75.75 0 0 0 1.5 0v-.25h.25a.75.75 0 0 0 0-1.5h-.25v-.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.53 7.53a.75.75 0 0 0-1.06-1.06l-1 1a.75.75 0 0 0 1.06 1.06l1-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.578 11.032a.75.75 0 1 0-.413-1.442l-2.343.672a.75.75 0 1 0 .413 1.442l2.343-.672Z"
      }));
    };
    SvgConfettiIcon.displayName = "ConfettiIcon";
    exports.SvgConfettiIcon = SvgConfettiIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ConnectIcon.svg.js
var require_ConnectIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ConnectIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgConnectIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.95 11a1.5 1.5 0 1 1 0 1.5h-4.7a2.75 2.75 0 0 1-2.75-2.75v-3.5a2.75 2.75 0 0 1 2.75-2.75h5.5a.75.75 0 0 1 0 1.5h-5.5c-.69 0-1.25.56-1.25 1.25v3.5c0 .69.56 1.25 1.25 1.25h4.7Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14 16.25a2.75 2.75 0 0 0 2.75-2.75v-3.5a2.75 2.75 0 0 0-2.75-2.75h-4.7a1.5 1.5 0 1 0 0 1.5h4.7c.69 0 1.25.56 1.25 1.25v3.5c0 .69-.56 1.25-1.25 1.25h-5.5a.75.75 0 0 0 0 1.5h5.5Z"
      }));
    };
    SvgConnectIcon.displayName = "ConnectIcon";
    exports.SvgConnectIcon = SvgConnectIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ContentFilledIcon.svg.js
var require_ContentFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ContentFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgContentFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12 8a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.42 3.5h5.16c.535 0 .98 0 1.345.03.38.03.736.098 1.073.27a2.75 2.75 0 0 1 1.202 1.202c.172.337.24.693.27 1.073.03.365.03.81.03 1.345v1.91c0 .535 0 .98-.03 1.345-.03.38-.098.736-.27 1.073a2.751 2.751 0 0 1-1.201 1.202c-.338.172-.694.24-1.074.27a6.052 6.052 0 0 1-.288.017.744.744 0 0 1-.137.013h-6.08c-.535 0-.98 0-1.345-.03-.38-.03-.736-.098-1.073-.27a2.75 2.75 0 0 1-1.047-.934.75.75 0 0 1-.176-.31c-.157-.324-.22-.667-.25-1.031-.029-.365-.029-.81-.029-1.345v-1.91c0-.535 0-.98.03-1.345.03-.38.098-.736.27-1.073a2.75 2.75 0 0 1 1.202-1.202c.337-.172.693-.24 1.073-.27.365-.03.81-.03 1.345-.03Zm7.58 5.8-.001.533-.135-.192a1.75 1.75 0 0 0-2.778-.116l-1.086 1.303-2.411-2.893a1.75 1.75 0 0 0-2.68-.01l-.909 1.073v-1.548c0-.572 0-.957.025-1.253.023-.287.065-.424.111-.514a1.25 1.25 0 0 1 .547-.547c.09-.046.227-.088.514-.111.296-.024.68-.025 1.253-.025h5.1c.572 0 .957 0 1.252.025.288.023.425.065.516.111.235.12.426.311.546.547.046.09.088.227.111.514.024.296.025.68.025 1.253v1.85Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4 15.75a.75.75 0 0 1 .75-.75h5.5a.75.75 0 0 1 0 1.5h-5.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.75 15a.75.75 0 0 0 0 1.5h2.5a.75.75 0 0 0 0-1.5h-2.5Z"
      }));
    };
    SvgContentFilledIcon.displayName = "ContentFilledIcon";
    exports.SvgContentFilledIcon = SvgContentFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ContentIcon.svg.js
var require_ContentIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ContentIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgContentIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12 8a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.42 3.5h5.16c.535 0 .98 0 1.345.03.38.03.736.098 1.073.27a2.75 2.75 0 0 1 1.202 1.202c.172.337.24.693.27 1.073.03.365.03.81.03 1.345v1.91c0 .535 0 .98-.03 1.345-.03.38-.098.736-.27 1.073a2.751 2.751 0 0 1-1.201 1.202c-.338.172-.694.24-1.074.27-.365.03-.81.03-1.345.03h-5.16c-.535 0-.98 0-1.345-.03-.38-.03-.736-.098-1.073-.27a2.75 2.75 0 0 1-1.202-1.201c-.172-.338-.24-.694-.27-1.074-.03-.365-.03-.81-.03-1.345v-1.91c0-.535 0-.98.03-1.345.03-.38.098-.736.27-1.073a2.75 2.75 0 0 1 1.202-1.202c.337-.172.693-.24 1.073-.27.365-.03.81-.03 1.345-.03Zm-1.223 1.525c-.287.023-.424.065-.514.111a1.25 1.25 0 0 0-.547.547c-.046.09-.088.227-.111.514-.024.296-.025.68-.025 1.253v1.548l.908-1.073a1.75 1.75 0 0 1 2.68.01l2.412 2.894 1.086-1.304a1.75 1.75 0 0 1 2.778.116l.135.192.001-.533v-1.85c0-.572 0-.957-.025-1.253-.023-.287-.065-.424-.111-.514a1.25 1.25 0 0 0-.546-.547c-.091-.046-.228-.088-.515-.111-.296-.024-.68-.025-1.253-.025h-5.1c-.572 0-.957 0-1.253.025Zm-.514 6.589a1.25 1.25 0 0 1-.516-.49l1.886-2.23a.25.25 0 0 1 .383.001l2.38 2.855h-2.366c-.572 0-.957 0-1.253-.025-.287-.023-.424-.065-.514-.111Zm6.867.136h-.365l1.054-1.265a.25.25 0 0 1 .397.017l.751 1.073a1.274 1.274 0 0 1-.07.039c-.09.046-.227.088-.514.111-.296.024-.68.025-1.253.025Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4 15.75a.75.75 0 0 1 .75-.75h5.5a.75.75 0 0 1 0 1.5h-5.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.75 15a.75.75 0 0 0 0 1.5h2.5a.75.75 0 0 0 0-1.5h-2.5Z"
      }));
    };
    SvgContentIcon.displayName = "ContentIcon";
    exports.SvgContentIcon = SvgContentIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ContractFilledIcon.svg.js
var require_ContractFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ContractFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgContractFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4.5 3a2 2 0 0 0-2 2v3.75c0 .414.336.75.75.75h2v4.36a1.875 1.875 0 0 0 3.75 0v-.606c0-.416.338-.754.754-.754h5.246v-7.5a2 2 0 0 0-2-2h-8.5Zm13.25 10.75h-7.5v.11a3.125 3.125 0 0 1-3.002 3.122 1.842 1.842 0 0 1-.248.018h8.55a2.2 2.2 0 0 0 2.2-2.2v-1.05Zm-13.252-9.25a.5.5 0 0 0-.498.5v3h1v-3a.5.5 0 0 0-.5-.5h-.002Zm4.002 1.5a.75.75 0 0 0 0 1.5h3a.75.75 0 0 0 0-1.5h-3Zm-.75 3.75a.75.75 0 0 1 .75-.75h3a.75.75 0 0 1 0 1.5h-3a.75.75 0 0 1-.75-.75Z"
      }));
    };
    SvgContractFilledIcon.displayName = "ContractFilledIcon";
    exports.SvgContractFilledIcon = SvgContractFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ContractIcon.svg.js
var require_ContractIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ContractIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgContractIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8 7.5a.75.75 0 0 1 .75-.75h2.5a.75.75 0 0 1 0 1.5h-2.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.75 9.75a.75.75 0 0 0 0 1.5h2.5a.75.75 0 0 0 0-1.5h-2.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M2.5 5.75a2 2 0 0 1 2-2h8.5a2 2 0 0 1 2 2v7.5h2a.75.75 0 0 1 .75.75v1.5a2.25 2.25 0 0 1-2.25 2.25h-7.75a2.75 2.75 0 0 1-2.75-2.75v-4.75h-1.75a.75.75 0 0 1-.75-.75v-3.75Zm5.25 10.5c.69 0 1.25-.56 1.25-1.25v-1a.75.75 0 0 1 .75-.75h3.75v-7.5a.5.5 0 0 0-.5-.5h-6.563a1.982 1.982 0 0 1 .063.5v9.25c0 .69.56 1.25 1.25 1.25Zm2.75-1.5v.25c0 .45-.108.875-.3 1.25h5.3a.75.75 0 0 0 .75-.75v-.75h-5.75Zm-6.5-9a.5.5 0 0 1 .498-.5h.002a.5.5 0 0 1 .5.5v3h-1v-3Z"
      }));
    };
    SvgContractIcon.displayName = "ContractIcon";
    exports.SvgContractIcon = SvgContractIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CornerPillIcon.svg.js
var require_CornerPillIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CornerPillIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCornerPillIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12.25 5a7.25 7.25 0 0 0-7.25 7.25v3.5a.75.75 0 0 1-1.5 0v-3.5a8.75 8.75 0 0 1 8.75-8.75h3.5a.75.75 0 0 1 0 1.5h-3.5Z"
      }));
    };
    SvgCornerPillIcon.displayName = "CornerPillIcon";
    exports.SvgCornerPillIcon = SvgCornerPillIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CornerRoundIcon.svg.js
var require_CornerRoundIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CornerRoundIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCornerRoundIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.25 5a3.25 3.25 0 0 0-3.25 3.25v7.5a.75.75 0 0 1-1.5 0v-7.5a4.75 4.75 0 0 1 4.75-4.75h7.5a.75.75 0 0 1 0 1.5h-7.5Z"
      }));
    };
    SvgCornerRoundIcon.displayName = "CornerRoundIcon";
    exports.SvgCornerRoundIcon = SvgCornerRoundIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CornerSquareIcon.svg.js
var require_CornerSquareIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CornerSquareIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCornerSquareIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.25 5a.25.25 0 0 0-.25.25v10.5a.75.75 0 0 1-1.5 0v-10.5c0-.966.784-1.75 1.75-1.75h10.5a.75.75 0 0 1 0 1.5h-10.5Z"
      }));
    };
    SvgCornerSquareIcon.displayName = "CornerSquareIcon";
    exports.SvgCornerSquareIcon = SvgCornerSquareIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CreditCardCancelIcon.svg.js
var require_CreditCardCancelIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CreditCardCancelIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCreditCardCancelIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M2.75 7.25a2.75 2.75 0 0 1 2.75-2.75h9.5a2.75 2.75 0 0 1 2.75 2.75v2.5a.75.75 0 0 1-1.5 0v-.5h-12v3.5c0 .69.56 1.25 1.25 1.25h5.02a.75.75 0 0 1 0 1.5h-5.02a2.75 2.75 0 0 1-2.75-2.75v-5.5Zm12.25-1.25c.69 0 1.25.56 1.25 1.25h-12c0-.69.56-1.25 1.25-1.25h9.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.25 11.25a.75.75 0 0 0 0 1.5h2.75a.75.75 0 0 0 0-1.5h-2.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.78 11.72a.75.75 0 0 1 0 1.06l-.97.97.97.97a.75.75 0 1 1-1.06 1.06l-.97-.97-.97.97a.75.75 0 1 1-1.06-1.06l.97-.97-.97-.97a.75.75 0 1 1 1.06-1.06l.97.97.97-.97a.75.75 0 0 1 1.06 0Z"
      }));
    };
    SvgCreditCardCancelIcon.displayName = "CreditCardCancelIcon";
    exports.SvgCreditCardCancelIcon = SvgCreditCardCancelIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CreditCardIcon.svg.js
var require_CreditCardIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CreditCardIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCreditCardIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.25 11.25a.75.75 0 0 0 0 1.5h2.75a.75.75 0 0 0 0-1.5h-2.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M2.5 7.25a2.75 2.75 0 0 1 2.75-2.75h9.5a2.75 2.75 0 0 1 2.75 2.75v5.5a2.75 2.75 0 0 1-2.75 2.75h-9.5a2.75 2.75 0 0 1-2.75-2.75v-5.5Zm12.25-1.25c.69 0 1.25.56 1.25 1.25h-12c0-.69.56-1.25 1.25-1.25h9.5Zm1.25 3.25h-12v3.5c0 .69.56 1.25 1.25 1.25h9.5c.69 0 1.25-.56 1.25-1.25v-3.5Z"
      }));
    };
    SvgCreditCardIcon.displayName = "CreditCardIcon";
    exports.SvgCreditCardIcon = SvgCreditCardIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CreditCardPercentIcon.svg.js
var require_CreditCardPercentIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CreditCardPercentIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCreditCardPercentIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.25 4a2.75 2.75 0 0 0-2.75 2.75v6.5a2.75 2.75 0 0 0 2.75 2.75h5.104a.75.75 0 0 0 0-1.5h-5.104c-.69 0-1.25-.56-1.25-1.25v-4h12a.75.75 0 0 0 1.5 0v-2.5a2.75 2.75 0 0 0-2.75-2.75h-9.5Zm10.75 3.25v-.5c0-.69-.56-1.25-1.25-1.25h-9.5c-.69 0-1.25.56-1.25 1.25v.5h12Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.47 11.47a.75.75 0 1 1 1.06 1.06l-4 4a.75.75 0 1 1-1.06-1.06l4-4Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13 13a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M18 16a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.25 11.25a.75.75 0 0 0 0 1.5h2.75a.75.75 0 0 0 0-1.5h-2.75Z"
      }));
    };
    SvgCreditCardPercentIcon.displayName = "CreditCardPercentIcon";
    exports.SvgCreditCardPercentIcon = SvgCreditCardPercentIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CreditCardReaderChipIcon.svg.js
var require_CreditCardReaderChipIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CreditCardReaderChipIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCreditCardReaderChipIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.121 3.5h3.758c.395 0 .736 0 1.017.023.297.024.592.078.875.222.424.216.768.56.984.984.144.283.198.578.222.875.023.28.023.622.023 1.017v3.816a2.751 2.751 0 0 1 1.75 2.563v2a1.75 1.75 0 0 1-1.75 1.75h-10a1.75 1.75 0 0 1-1.75-1.75v-2a2.75 2.75 0 0 1 1.75-2.563v-3.816c0-.395 0-.736.023-1.017a2.29 2.29 0 0 1 .222-.875 2.25 2.25 0 0 1 .984-.984 2.29 2.29 0 0 1 .875-.222c.28-.023.622-.023 1.017-.023Zm.029 1.5h1.85v5h-3.5v-3.35c0-.432 0-.712.018-.924.017-.204.045-.28.064-.316a.75.75 0 0 1 .328-.328c.037-.02.112-.047.316-.064.212-.017.492-.018.924-.018Zm3.85 0v5h1.5v-3.35c0-.432 0-.712-.018-.924-.017-.204-.045-.28-.064-.316a.75.75 0 0 0-.327-.328c-.038-.02-.113-.047-.317-.064a10.44 10.44 0 0 0-.774-.018Zm-7.25 8c0-.69.56-1.25 1.25-1.25h8c.69 0 1.25.56 1.25 1.25v2a.25.25 0 0 1-.25.25h-10a.25.25 0 0 1-.25-.25v-2Z"
      }));
    };
    SvgCreditCardReaderChipIcon.displayName = "CreditCardReaderChipIcon";
    exports.SvgCreditCardReaderChipIcon = SvgCreditCardReaderChipIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CreditCardReaderIcon.svg.js
var require_CreditCardReaderIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CreditCardReaderIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCreditCardReaderIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.75 3.5a2.25 2.25 0 0 0-2.25 2.25v4.75a2.25 2.25 0 0 0 2.25 2.25h.32c-.046.243-.07.494-.07.75v.75a1 1 0 0 0 1 1h2.25v.75a.75.75 0 0 0 1.5 0v-.75h2.25a1 1 0 0 0 1-1v-.75a4.02 4.02 0 0 0-.07-.75h.32a2.25 2.25 0 0 0 2.25-2.25v-4.75a2.25 2.25 0 0 0-2.25-2.25h-8.5Zm6.75 10.25v-.25a2.5 2.5 0 0 0-5 0v.25h5Zm-2.5-4.25a3.996 3.996 0 0 0-3.308 1.75h-.942a.75.75 0 0 1-.75-.75v-2.25h10v2.25a.75.75 0 0 1-.75.75h-.942a3.996 3.996 0 0 0-3.308-1.75Zm5-3.25v-.5a.75.75 0 0 0-.75-.75h-8.5a.75.75 0 0 0-.75.75v.5h10Z"
      }));
    };
    SvgCreditCardReaderIcon.displayName = "CreditCardReaderIcon";
    exports.SvgCreditCardReaderIcon = SvgCreditCardReaderIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CreditCardReaderTapIcon.svg.js
var require_CreditCardReaderTapIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CreditCardReaderTapIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCreditCardReaderTapIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 4.25a3.25 3.25 0 0 0-3.25 3.25.75.75 0 0 1-1.5 0 4.75 4.75 0 0 1 9.5 0 .75.75 0 0 1-1.5 0 3.25 3.25 0 0 0-3.25-3.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.75 9a2.25 2.25 0 0 0-2.25 2.25v5c0 .414.336.75.75.75h9.5a.75.75 0 0 0 .75-.75v-5a2.25 2.25 0 0 0-2.25-2.25h-6.5Zm1.25 6.5h-2v-4.25a.75.75 0 0 1 .75-.75h1.25v5Zm2 0v-5h3.25a.75.75 0 0 1 .75.75v4.25h-4Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.25 7.5a.75.75 0 0 1 1.5 0 .75.75 0 0 0 1.5 0 2.25 2.25 0 0 0-4.5 0 .75.75 0 0 0 1.5 0Z"
      }));
    };
    SvgCreditCardReaderTapIcon.displayName = "CreditCardReaderTapIcon";
    exports.SvgCreditCardReaderTapIcon = SvgCreditCardReaderTapIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CreditCardSecureIcon.svg.js
var require_CreditCardSecureIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CreditCardSecureIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCreditCardSecureIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M2.5 6.75a2.75 2.75 0 0 1 2.75-2.75h9.5a2.75 2.75 0 0 1 2.75 2.75v1.25a.75.75 0 0 1-1.5 0v-1.25c0-.69-.56-1.25-1.25-1.25h-9.5c-.69 0-1.25.56-1.25 1.25v.5h8a1 1 0 1 1 0 2h-8v4c0 .69.56 1.25 1.25 1.25h4.052a.75.75 0 0 1 0 1.5h-4.052a2.75 2.75 0 0 1-2.75-2.75v-6.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.75 11.5a.75.75 0 0 0 0 1.5h2a.75.75 0 0 0 0-1.5h-2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13 12.25a1 1 0 0 0-1 1v2.75a1 1 0 0 0 1 1h4a1 1 0 0 0 1-1v-2.75a1 1 0 0 0-1-1v-.75a2 2 0 1 0-4 0v.75Zm2.5 0v-.75a.5.5 0 0 0-1 0v.75h1Z"
      }));
    };
    SvgCreditCardSecureIcon.displayName = "CreditCardSecureIcon";
    exports.SvgCreditCardSecureIcon = SvgCreditCardSecureIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CreditCardTapChipIcon.svg.js
var require_CreditCardTapChipIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CreditCardTapChipIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCreditCardTapChipIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 4.25a3.25 3.25 0 0 0-3.25 3.25.75.75 0 0 1-1.5 0 4.75 4.75 0 0 1 9.5 0 .75.75 0 0 1-1.5 0 3.25 3.25 0 0 0-3.25-3.25Zm-4 11.25v-4.25a.75.75 0 0 1 .75-.75h6.5a.75.75 0 0 1 .75.75v4.25h-8Zm-1.5-4.25v5c0 .414.336.75.75.75h9.5a.75.75 0 0 0 .75-.75v-5a2.25 2.25 0 0 0-2.25-2.25h-6.5a2.25 2.25 0 0 0-2.25 2.25Zm3.5 2a1 1 0 1 0 2 0v-.75a1 1 0 1 0-2 0v.75Zm1.25-5.75a.75.75 0 0 1 1.5 0 .75.75 0 0 0 1.5 0 2.25 2.25 0 0 0-4.5 0 .75.75 0 0 0 1.5 0Z"
      }));
    };
    SvgCreditCardTapChipIcon.displayName = "CreditCardTapChipIcon";
    exports.SvgCreditCardTapChipIcon = SvgCreditCardTapChipIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CurrencyConvertIcon.svg.js
var require_CurrencyConvertIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CurrencyConvertIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCurrencyConvertIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.25 7a.75.75 0 0 1 .75-.75h3.69l-.72-.72a.75.75 0 0 1 1.06-1.06l2 2a.75.75 0 0 1 0 1.06l-2 2a.75.75 0 1 1-1.06-1.06l.72-.72h-3.69a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.25 5.25a.75.75 0 0 0-1.5 0v.75h-.375a2.375 2.375 0 0 0 0 4.75h1.28a.875.875 0 1 1 0 1.75h-2.905a.75.75 0 0 0 0 1.5h1v.75a.75.75 0 0 0 1.5 0v-.75h.404a2.375 2.375 0 0 0 0-4.75h-1.279a.875.875 0 0 1 0-1.75h2.904a.75.75 0 1 0 0-1.5h-1.029v-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.81 13.75h3.69a.75.75 0 0 0 0-1.5h-3.69l.72-.72a.75.75 0 1 0-1.06-1.06l-2 2a.75.75 0 0 0 0 1.06l2 2a.75.75 0 1 0 1.06-1.06l-.72-.72Z"
      }));
    };
    SvgCurrencyConvertIcon.displayName = "CurrencyConvertIcon";
    exports.SvgCurrencyConvertIcon = SvgCurrencyConvertIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CursorBannerIcon.svg.js
var require_CursorBannerIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CursorBannerIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCursorBannerIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M15 7.25v4.25c0 .414.336.75.75.75s.75-.336.75-.75v-4.25c0-2.071-1.679-3.75-3.75-3.75h-5.5c-2.071 0-3.75 1.679-3.75 3.75v5.5c0 2.071 1.679 3.75 3.75 3.75h4.25c.414 0 .75-.336.75-.75s-.336-.75-.75-.75h-4.25c-1.243 0-2.25-1.007-2.25-2.25v-5.5c0-1.243 1.007-2.25 2.25-2.25h5.5c1.243 0 2.25 1.007 2.25 2.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14 10.75c0-.414-.336-.75-.75-.75h-6.25c-.552 0-1 .448-1 1v2c0 .552.448 1 1 1h3.68c.477 0 .887-.336.98-.804l.18-.892c.093-.468.503-.804.98-.804h.43c.414 0 .75-.336.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.19 12.584c-.17-.042-.35.008-.474.132s-.174.304-.132.474l1.122 4.51c.043.176.177.314.351.362.174.048.36-.001.487-.128l1.165-1.165.84.841c.196.196.512.196.708 0l.353-.353c.195-.196.195-.512 0-.707l-.84-.841 1.163-1.165c.128-.127.177-.313.129-.487-.049-.174-.187-.308-.361-.351l-4.51-1.122Z"
      }));
    };
    SvgCursorBannerIcon.displayName = "CursorBannerIcon";
    exports.SvgCursorBannerIcon = SvgCursorBannerIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CursorFilledIcon.svg.js
var require_CursorFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CursorFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCursorFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.75 3a.75.75 0 0 1 .75.75v2.5a.75.75 0 0 1-1.5 0v-2.5a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.28 5.22a.75.75 0 0 1 0 1.06l-1 1a.75.75 0 1 1-1.06-1.06l1-1a.75.75 0 0 1 1.06 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.28 12.22a.75.75 0 0 1 0 1.06l-1 1a.75.75 0 0 1-1.06-1.06l1-1a.75.75 0 0 1 1.06 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.25 10.5a.75.75 0 0 0 0-1.5h-2.5a.75.75 0 0 0 0 1.5h2.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.03 7.03a.75.75 0 0 1-1.06 0l-1.75-1.75a.75.75 0 0 1 1.06-1.06l1.75 1.75a.75.75 0 0 1 0 1.06Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.22 8.22a.75.75 0 0 1 .767-.181l7.5 2.5a.75.75 0 0 1 .293 1.241l-1.97 1.97 1.97 1.97a.75.75 0 1 1-1.06 1.06l-1.97-1.97-1.97 1.97a.75.75 0 0 1-1.241-.293l-2.5-7.5a.75.75 0 0 1 .18-.767Z"
      }));
    };
    SvgCursorFilledIcon.displayName = "CursorFilledIcon";
    exports.SvgCursorFilledIcon = SvgCursorFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CursorIcon.svg.js
var require_CursorIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CursorIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCursorIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.5 3.75a.75.75 0 0 0-1.5 0v2.5a.75.75 0 0 0 1.5 0v-2.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.28 6.28a.75.75 0 0 0-1.06-1.06l-1 1a.75.75 0 0 0 1.06 1.06l1-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.28 13.28a.75.75 0 0 0-1.06-1.06l-1 1a.75.75 0 1 0 1.06 1.06l1-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7 9.75a.75.75 0 0 1-.75.75h-2.5a.75.75 0 0 1 0-1.5h2.5a.75.75 0 0 1 .75.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.97 7.03a.75.75 0 0 0 1.06-1.06l-1.75-1.75a.75.75 0 0 0-1.06 1.06l1.75 1.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.22 8.22a.75.75 0 0 1 .767-.181l7.5 2.5a.75.75 0 0 1 .293 1.241l-1.97 1.97 1.97 1.97a.75.75 0 1 1-1.06 1.06l-1.97-1.97-1.97 1.97a.75.75 0 0 1-1.241-.293l-2.5-7.5a.75.75 0 0 1 .18-.767Zm4.998 5.001.002-.001.001-.002 1.64-1.64-4.925-1.642 1.642 4.926 1.64-1.64Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.5 3.75a.75.75 0 0 0-1.5 0v2.5a.75.75 0 0 0 1.5 0v-2.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.28 6.28a.75.75 0 0 0-1.06-1.06l-1 1a.75.75 0 0 0 1.06 1.06l1-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.28 13.28a.75.75 0 0 0-1.06-1.06l-1 1a.75.75 0 1 0 1.06 1.06l1-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7 9.75a.75.75 0 0 1-.75.75h-2.5a.75.75 0 0 1 0-1.5h2.5a.75.75 0 0 1 .75.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.97 7.03a.75.75 0 0 0 1.06-1.06l-1.75-1.75a.75.75 0 0 0-1.06 1.06l1.75 1.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.22 8.22a.75.75 0 0 1 .767-.181l7.5 2.5a.75.75 0 0 1 .293 1.241l-1.97 1.97 1.97 1.97a.75.75 0 1 1-1.06 1.06l-1.97-1.97-1.97 1.97a.75.75 0 0 1-1.241-.293l-2.5-7.5a.75.75 0 0 1 .18-.767Zm4.998 5.001.002-.001.001-.002 1.64-1.64-4.925-1.642 1.642 4.926 1.64-1.64Z"
      }));
    };
    SvgCursorIcon.displayName = "CursorIcon";
    exports.SvgCursorIcon = SvgCursorIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CursorOptionIcon.svg.js
var require_CursorOptionIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/CursorOptionIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgCursorOptionIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M15 7.25v4.25c0 .414.336.75.75.75s.75-.336.75-.75v-4.25c0-2.071-1.679-3.75-3.75-3.75h-5.5c-2.071 0-3.75 1.679-3.75 3.75v5.5c0 2.071 1.679 3.75 3.75 3.75h4.25c.414 0 .75-.336.75-.75s-.336-.75-.75-.75h-4.25c-1.243 0-2.25-1.007-2.25-2.25v-5.5c0-1.243 1.007-2.25 2.25-2.25h5.5c1.243 0 2.25 1.007 2.25 2.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.5 7.75c0 .552-.448 1-1 1s-1-.448-1-1 .448-1 1-1 1 .448 1 1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.5 11.25c0 .552-.448 1-1 1s-1-.448-1-1 .448-1 1-1 1 .448 1 1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.5 7c-.414 0-.75.336-.75.75s.336.75.75.75h2.25c.414 0 .75-.336.75-.75s-.336-.75-.75-.75h-2.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.75 11.25c0-.414.336-.75.75-.75h2.25c.414 0 .75.336.75.75s-.336.75-.75.75h-2.25c-.414 0-.75-.336-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.716 12.716c.124-.124.304-.174.474-.132l4.51 1.122c.175.043.314.178.362.351.048.174-.001.36-.129.487l-1.164 1.165.841.84c.195.196.195.512 0 .708l-.353.353c-.196.196-.512.196-.707 0l-.841-.84-1.165 1.164c-.127.127-.313.176-.487.128-.174-.048-.308-.186-.351-.361l-1.122-4.51c-.042-.171.008-.35.132-.475Z"
      }));
    };
    SvgCursorOptionIcon.displayName = "CursorOptionIcon";
    exports.SvgCursorOptionIcon = SvgCursorOptionIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DataPresentationIcon.svg.js
var require_DataPresentationIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DataPresentationIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDataPresentationIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.5 6.75a.75.75 0 0 0-1.5 0v3.5a.75.75 0 0 0 1.5 0v-3.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.25 8.5a.75.75 0 0 1 .75.75v1a.75.75 0 0 1-1.5 0v-1a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 8a.75.75 0 0 0-1.5 0v2.25a.75.75 0 0 0 1.5 0v-2.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.25 4.25a.75.75 0 0 1 .75-.75h12a.75.75 0 0 1 0 1.5v6a3 3 0 0 1-2.877 2.998l.588 1.765a.75.75 0 1 1-1.422.474l-.746-2.237h-3.086l-.746 2.237a.75.75 0 1 1-1.423-.474l.589-1.765a3 3 0 0 1-2.877-2.998v-6a.75.75 0 0 1-.75-.75Zm2.25.75h9v6a1.5 1.5 0 0 1-1.5 1.5h-6a1.5 1.5 0 0 1-1.5-1.5v-6Z"
      }));
    };
    SvgDataPresentationIcon.displayName = "DataPresentationIcon";
    exports.SvgDataPresentationIcon = SvgDataPresentationIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DataTableIcon.svg.js
var require_DataTableIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DataTableIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDataTableIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.5 16.5a2 2 0 0 1-2-2v-9a2 2 0 0 1 2-2h9a2 2 0 0 1 2 2v9a2 2 0 0 1-2 2h-9Zm3.25-11.5h2.5v2h-2.5v-2Zm-1.5 0h-1.75a.5.5 0 0 0-.5.5v1.5h2.25v-2Zm0 3.5h-2.25v6a.5.5 0 0 0 .5.5h1.75v-6.5Zm1.5 6.5v-6.5h2.5v6.5h-2.5Zm4-8v-2h1.75a.5.5 0 0 1 .5.5v1.5h-2.25Zm0 1.5v6.5h1.75a.5.5 0 0 0 .5-.5v-6h-2.25Z"
      }));
    };
    SvgDataTableIcon.displayName = "DataTableIcon";
    exports.SvgDataTableIcon = SvgDataTableIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DatabaseAddIcon.svg.js
var require_DatabaseAddIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DatabaseAddIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDatabaseAddIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5 11.997c.206.112.426.214.656.306 1.149.46 2.685.727 4.344.727 1.659 0 3.195-.268 4.344-.727.573-.23 1.087-.52 1.47-.883.384-.363.686-.85.686-1.44v-3.43c0-.59-.302-1.077-.687-1.44-.382-.362-.896-.654-1.469-.883-1.149-.46-2.685-.727-4.344-.727-1.659 0-3.195.268-4.344.727-.573.23-1.087.52-1.47.883-.384.363-.686.85-.686 1.44v6.9c0 .59.302 1.077.687 1.44.382.362.896.654 1.469.883 1.149.46 2.685.727 4.344.727a.75.75 0 0 0 0-1.5c-1.517 0-2.856-.247-3.787-.62-.468-.187-.797-.391-.996-.58-.197-.187-.217-.305-.217-.35v-1.453Zm.217-5.797c-.197.186-.217.305-.217.35 0 .045.02.164.217.35.2.189.528.393.996.58.931.373 2.27.62 3.787.62s2.855-.247 3.787-.62c.468-.187.797-.391.996-.58.197-.186.217-.305.217-.35 0-.045-.02-.164-.217-.35-.2-.189-.528-.393-.996-.58-.932-.373-2.27-.62-3.787-.62s-2.856.247-3.787.62c-.468.187-.797.391-.996.58Zm9.783 2.367a6.104 6.104 0 0 1-.656.306c-1.149.46-2.685.727-4.344.727-1.659 0-3.195-.268-4.344-.727a6.099 6.099 0 0 1-.656-.306v1.413c0 .045.02.163.217.35.2.189.528.393.996.58.931.373 2.27.62 3.787.62s2.855-.247 3.787-.62c.468-.187.797-.391.996-.58.197-.187.217-.305.217-.35v-1.413Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.5 15.25a.75.75 0 0 1 .75-.75h1.25v-1.25a.75.75 0 0 1 1.5 0v1.25h1.25a.75.75 0 0 1 0 1.5h-1.25v1.25a.75.75 0 0 1-1.5 0v-1.25h-1.25a.75.75 0 0 1-.75-.75Z"
      }));
    };
    SvgDatabaseAddIcon.displayName = "DatabaseAddIcon";
    exports.SvgDatabaseAddIcon = SvgDatabaseAddIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DatabaseIcon.svg.js
var require_DatabaseIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DatabaseIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDatabaseIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.217 6.2c-.197.186-.217.305-.217.35 0 .045.02.164.217.35.2.189.528.393.996.58.931.373 2.27.62 3.787.62s2.855-.247 3.787-.62c.468-.187.797-.391.996-.58.197-.186.217-.305.217-.35 0-.045-.02-.164-.217-.35-.2-.189-.528-.393-.996-.58-.932-.373-2.27-.62-3.787-.62s-2.856.247-3.787.62c-.468.187-.797.391-.996.58Zm9.783 2.367a6.104 6.104 0 0 1-.656.306c-1.149.46-2.685.727-4.344.727-1.659 0-3.195-.268-4.344-.727a6.099 6.099 0 0 1-.656-.306v1.413c0 .045.02.163.217.35.2.189.528.393.996.58.931.373 2.27.62 3.787.62s2.855-.247 3.787-.62c.468-.187.797-.391.996-.58.197-.187.217-.305.217-.35v-1.413Zm0 3.43a6.104 6.104 0 0 1-.656.306c-1.149.46-2.685.727-4.344.727-1.659 0-3.195-.268-4.344-.727a6.099 6.099 0 0 1-.656-.306v1.453c0 .045.02.164.217.35.2.189.528.393.996.58.931.373 2.27.62 3.787.62s2.855-.247 3.787-.62c.468-.187.797-.391.996-.58.197-.187.217-.305.217-.35v-1.453Zm1.5 1.453c0 .59-.302 1.077-.687 1.44-.382.362-.896.654-1.469.883-1.149.46-2.685.727-4.344.727-1.659 0-3.195-.268-4.344-.727-.573-.23-1.087-.52-1.47-.883-.384-.363-.686-.85-.686-1.44v-6.9c0-.59.302-1.077.687-1.44.382-.362.896-.654 1.469-.883 1.149-.46 2.685-.727 4.344-.727 1.659 0 3.195.268 4.344.727.573.23 1.087.52 1.47.883.384.363.686.85.686 1.44v6.9Z"
      }));
    };
    SvgDatabaseIcon.displayName = "DatabaseIcon";
    exports.SvgDatabaseIcon = SvgDatabaseIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DeleteIcon.svg.js
var require_DeleteIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DeleteIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDeleteIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.5 8.25a.75.75 0 0 1 .75.75v4.25a.75.75 0 0 1-1.5 0v-4.25a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.25 9a.75.75 0 0 0-1.5 0v4.25a.75.75 0 0 0 1.5 0v-4.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.25 5.25a2.75 2.75 0 0 1 5.5 0h3a.75.75 0 0 1 0 1.5h-.75v5.45c0 1.68 0 2.52-.327 3.162a3 3 0 0 1-1.311 1.311c-.642.327-1.482.327-3.162.327h-.4c-1.68 0-2.52 0-3.162-.327a3 3 0 0 1-1.311-1.311c-.327-.642-.327-1.482-.327-3.162v-5.45h-.75a.75.75 0 0 1 0-1.5h3Zm1.5 0a1.25 1.25 0 1 1 2.5 0h-2.5Zm-2.25 1.5h7v5.45c0 .865-.001 1.423-.036 1.848-.033.408-.09.559-.128.633a1.5 1.5 0 0 1-.655.655c-.074.038-.225.095-.633.128-.425.035-.983.036-1.848.036h-.4c-.865 0-1.423-.001-1.848-.036-.408-.033-.559-.09-.633-.128a1.5 1.5 0 0 1-.656-.655c-.037-.074-.094-.225-.127-.633-.035-.425-.036-.983-.036-1.848v-5.45Z"
      }));
    };
    SvgDeleteIcon.displayName = "DeleteIcon";
    exports.SvgDeleteIcon = SvgDeleteIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DeliveryFilledIcon.svg.js
var require_DeliveryFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DeliveryFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDeliveryFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4.75 4.5a.75.75 0 0 0 0 1.5h3.25a1 1 0 0 1 0 2h-4.75a.75.75 0 0 0 0 1.5h3a.75.75 0 0 1 0 1.5h-2.5a.75.75 0 0 0 0 1.5h.458a2.5 2.5 0 1 0 4.78.75h3.024a2.5 2.5 0 1 0 4.955-.153 1.75 1.75 0 0 0 1.033-1.597v-1.22a1.75 1.75 0 0 0-1.326-1.697l-1.682-.42a.25.25 0 0 1-.18-.174l-.426-1.494a2.75 2.75 0 0 0-2.645-1.995h-6.991Zm2.75 9a1 1 0 1 1-2 0 1 1 0 0 1 2 0Zm8 0a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }));
    };
    SvgDeliveryFilledIcon.displayName = "DeliveryFilledIcon";
    exports.SvgDeliveryFilledIcon = SvgDeliveryFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DeliveryIcon.svg.js
var require_DeliveryIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DeliveryIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDeliveryIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 5.25a.75.75 0 0 1 .75-.75h6.991a2.75 2.75 0 0 1 2.645 1.995l.427 1.494a.25.25 0 0 0 .18.173l1.681.421a1.75 1.75 0 0 1 1.326 1.698v1.219a1.75 1.75 0 0 1-1.032 1.597 2.5 2.5 0 1 1-4.955.153h-3.025a2.5 2.5 0 1 1-4.78-.75h-.458a.75.75 0 0 1 0-1.5h2.5c.03 0 .06.002.088.005a2.493 2.493 0 0 1 1.947.745h4.43a2.493 2.493 0 0 1 1.785-.75c.698 0 1.33.286 1.783.748a.25.25 0 0 0 .217-.248v-1.22a.25.25 0 0 0-.19-.242l-1.682-.42a1.75 1.75 0 0 1-1.258-1.217l-.427-1.494a1.25 1.25 0 0 0-1.202-.907h-6.991a.75.75 0 0 1-.75-.75Zm2.5 9.25a1 1 0 1 0 0-2 1 1 0 0 0 0 2Zm8 0a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.25 8a.75.75 0 0 0 0 1.5h5a.75.75 0 0 0 0-1.5h-5Z"
      }));
    };
    SvgDeliveryIcon.displayName = "DeliveryIcon";
    exports.SvgDeliveryIcon = SvgDeliveryIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DesktopIcon.svg.js
var require_DesktopIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DesktopIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDesktopIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 6.25a2.75 2.75 0 0 1 2.75-2.75h7.5a2.75 2.75 0 0 1 2.75 2.75v4.5a2.75 2.75 0 0 1-2.75 2.75h-1.25v1.5h.75a.75.75 0 0 1 0 1.5h-6.5a.75.75 0 0 1 0-1.5h.75v-1.5h-1.25a2.75 2.75 0 0 1-2.75-2.75v-4.5Zm5.5 7.25h2v1.5h-2v-1.5Zm-2.75-8.5c-.69 0-1.25.56-1.25 1.25v3.25h10v-3.25c0-.69-.56-1.25-1.25-1.25h-7.5Zm8.725 6c-.116.57-.62 1-1.225 1h-7.5a1.25 1.25 0 0 1-1.225-1h9.95Z"
      }));
    };
    SvgDesktopIcon.displayName = "DesktopIcon";
    exports.SvgDesktopIcon = SvgDesktopIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DisabledIcon.svg.js
var require_DisabledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DisabledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDisabledIcon3 = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-3.677 4.383a5.5 5.5 0 0 1-7.706-7.706l7.706 7.706Zm1.06-1.06-7.706-7.706a5.5 5.5 0 0 1 7.706 7.706Z"
      }));
    };
    SvgDisabledIcon3.displayName = "DisabledIcon";
    exports.SvgDisabledIcon = SvgDisabledIcon3;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DiscountCodeIcon.svg.js
var require_DiscountCodeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DiscountCodeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDiscountCodeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.25 5c0-.966.784-1.75 1.75-1.75h.5a.75.75 0 0 1 0 1.5h-.5a.25.25 0 0 0-.25.25v.5a.75.75 0 0 1-1.5 0v-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.78 7.22a.75.75 0 0 1 0 1.06l-4.5 4.5a.75.75 0 0 1-1.06-1.06l4.5-4.5a.75.75 0 0 1 1.06 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9 8a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12 13a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.25 15c0 .966.784 1.75 1.75 1.75h.5a.75.75 0 0 0 0-1.5h-.5a.25.25 0 0 1-.25-.25v-.5a.75.75 0 0 0-1.5 0v.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.75 15a1.75 1.75 0 0 1-1.75 1.75h-.5a.75.75 0 0 1 0-1.5h.5a.25.25 0 0 0 .25-.25v-.5a.75.75 0 0 1 1.5 0v.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.75 5a1.75 1.75 0 0 0-1.75-1.75h-.5a.75.75 0 0 0 0 1.5h.5a.25.25 0 0 1 .25.25v.5a.75.75 0 0 0 1.5 0v-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16 8.25a.75.75 0 0 1 .75.75v2a.75.75 0 0 1-1.5 0v-2a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 16.75a.75.75 0 0 0 0-1.5h-2a.75.75 0 0 0 0 1.5h2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4 8.25a.75.75 0 0 1 .75.75v2a.75.75 0 0 1-1.5 0v-2a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 4.75a.75.75 0 0 0 0-1.5h-2a.75.75 0 0 0 0 1.5h2Z"
      }));
    };
    SvgDiscountCodeIcon.displayName = "DiscountCodeIcon";
    exports.SvgDiscountCodeIcon = SvgDiscountCodeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DiscountFilledIcon.svg.js
var require_DiscountFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DiscountFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDiscountFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11.527 3.327c-.6-1.306-2.455-1.306-3.054 0a1.68 1.68 0 0 1-2.112.874c-1.347-.5-2.66.813-2.16 2.16a1.68 1.68 0 0 1-.874 2.112c-1.306.6-1.306 2.455 0 3.054a1.68 1.68 0 0 1 .874 2.112c-.5 1.347.813 2.659 2.16 2.16a1.68 1.68 0 0 1 2.112.874c.6 1.306 2.455 1.306 3.054 0a1.68 1.68 0 0 1 2.112-.874c1.347.499 2.66-.813 2.16-2.16a1.68 1.68 0 0 1 .874-2.112c1.306-.6 1.306-2.455 0-3.054a1.68 1.68 0 0 1-.874-2.112c.5-1.347-.813-2.66-2.16-2.16a1.68 1.68 0 0 1-2.112-.874Zm-2.527 4.923a1 1 0 1 1-2 0 1 1 0 0 1 2 0Zm3.53.53-4 4a.75.75 0 1 1-1.06-1.06l4-4a.75.75 0 1 1 1.06 1.06Zm.47 3.47a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }));
    };
    SvgDiscountFilledIcon.displayName = "DiscountFilledIcon";
    exports.SvgDiscountFilledIcon = SvgDiscountFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DiscountIcon.svg.js
var require_DiscountIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DiscountIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDiscountIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.78 8.28a.75.75 0 0 0-1.06-1.06l-4.5 4.5a.75.75 0 1 0 1.06 1.06l4.5-4.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9 8a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12 13a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12.094 3.514c-.822-1.79-3.366-1.79-4.188 0a.804.804 0 0 1-1.011.42c-1.848-.686-3.647 1.113-2.962 2.96a.804.804 0 0 1-.419 1.012c-1.79.822-1.79 3.366 0 4.188a.805.805 0 0 1 .42 1.011c-.686 1.848 1.113 3.647 2.96 2.962a.805.805 0 0 1 1.012.419c.822 1.79 3.366 1.79 4.188 0a.805.805 0 0 1 1.011-.42c1.848.686 3.647-1.113 2.962-2.96a.805.805 0 0 1 .419-1.012c1.79-.822 1.79-3.366 0-4.188a.805.805 0 0 1-.42-1.011c.686-1.848-1.113-3.647-2.96-2.962a.805.805 0 0 1-1.012-.419Zm-2.825.626a.804.804 0 0 1 1.462 0 2.304 2.304 0 0 0 2.896 1.2.804.804 0 0 1 1.034 1.034 2.304 2.304 0 0 0 1.199 2.895.804.804 0 0 1 0 1.462 2.304 2.304 0 0 0-1.2 2.896.805.805 0 0 1-1.034 1.034 2.304 2.304 0 0 0-2.895 1.199.804.804 0 0 1-1.462 0 2.304 2.304 0 0 0-2.896-1.2.804.804 0 0 1-1.033-1.034 2.305 2.305 0 0 0-1.2-2.895.804.804 0 0 1 0-1.462 2.304 2.304 0 0 0 1.2-2.896.804.804 0 0 1 1.033-1.033 2.304 2.304 0 0 0 2.896-1.2Z"
      }));
    };
    SvgDiscountIcon.displayName = "DiscountIcon";
    exports.SvgDiscountIcon = SvgDiscountIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DnsSettingsIcon.svg.js
var require_DnsSettingsIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DnsSettingsIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDnsSettingsIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8 6.5a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 5.25c0-.966.783-1.75 1.75-1.75h9.5c.966 0 1.75.784 1.75 1.75v2.5a1.75 1.75 0 0 1-1.75 1.75h-9.5a1.75 1.75 0 0 1-1.75-1.75v-2.5Zm1.75-.25a.25.25 0 0 0-.25.25v2.5c0 .138.112.25.25.25h9.5a.25.25 0 0 0 .25-.25v-2.5a.25.25 0 0 0-.25-.25h-9.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.25 12a.25.25 0 0 0-.25.25v2.5c0 .138.112.25.25.25h5a.75.75 0 0 1 0 1.5h-5a1.75 1.75 0 0 1-1.75-1.75v-2.5c0-.966.783-1.75 1.75-1.75h6.75a.75.75 0 0 1 0 1.5h-6.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7 14.5a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M16.878 13.839a2.257 2.257 0 0 1 0 .822l.327.19a.75.75 0 0 1-.75 1.298l-.328-.189a2.245 2.245 0 0 1-.712.412v.378a.75.75 0 0 1-1.5 0v-.378a2.248 2.248 0 0 1-.712-.412l-.328.19a.75.75 0 0 1-.75-1.3l.328-.188a2.26 2.26 0 0 1 0-.824l-.328-.189a.75.75 0 0 1 .75-1.299l.328.19a2.25 2.25 0 0 1 .712-.412v-.378a.75.75 0 0 1 1.5 0v.378c.263.093.504.234.712.412l.328-.19a.75.75 0 0 1 .75 1.3l-.327.189Zm-2.963.411c0-.133.035-.258.096-.367l.005-.008.004-.008a.75.75 0 0 1 1.289-.002l.006.01.006.01a.747.747 0 0 1 0 .73l-.006.01-.006.01a.75.75 0 0 1-1.29-.002l-.003-.008-.005-.008a.747.747 0 0 1-.096-.367Z"
      }));
    };
    SvgDnsSettingsIcon.displayName = "DnsSettingsIcon";
    exports.SvgDnsSettingsIcon = SvgDnsSettingsIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DockFloatingIcon.svg.js
var require_DockFloatingIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DockFloatingIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDockFloatingIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 10a1 1 0 0 0-1 1v2a1 1 0 0 0 1 1h2a1 1 0 0 0 1-1v-2a1 1 0 0 0-1-1h-2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.25 3.5a3.75 3.75 0 0 0-3.75 3.75v5.5a3.75 3.75 0 0 0 3.75 3.75h5.5a3.75 3.75 0 0 0 3.75-3.75v-5.5a3.75 3.75 0 0 0-3.75-3.75h-5.5Zm-2.25 3.75a2.25 2.25 0 0 1 2.25-2.25h5.5a2.25 2.25 0 0 1 2.25 2.25v5.5a2.25 2.25 0 0 1-2.25 2.25h-5.5a2.25 2.25 0 0 1-2.25-2.25v-5.5Z"
      }));
    };
    SvgDockFloatingIcon.displayName = "DockFloatingIcon";
    exports.SvgDockFloatingIcon = SvgDockFloatingIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DockSideIcon.svg.js
var require_DockSideIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DockSideIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDockSideIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 6a1 1 0 0 0-1 1v6a1 1 0 0 0 1 1h2a1 1 0 0 0 1-1v-6a1 1 0 0 0-1-1h-2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.25 3.5a3.75 3.75 0 0 0-3.75 3.75v5.5a3.75 3.75 0 0 0 3.75 3.75h5.5a3.75 3.75 0 0 0 3.75-3.75v-5.5a3.75 3.75 0 0 0-3.75-3.75h-5.5Zm-2.25 3.75a2.25 2.25 0 0 1 2.25-2.25h5.5a2.25 2.25 0 0 1 2.25 2.25v5.5a2.25 2.25 0 0 1-2.25 2.25h-5.5a2.25 2.25 0 0 1-2.25-2.25v-5.5Z"
      }));
    };
    SvgDockSideIcon.displayName = "DockSideIcon";
    exports.SvgDockSideIcon = SvgDockSideIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DomainFilledIcon.svg.js
var require_DomainFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DomainFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDomainFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M2.5 4.25a.75.75 0 0 1 .75-.75h11a.75.75 0 0 1 0 1.5h-10.25v8.25a.75.75 0 0 1-1.5 0v-9Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.565 11.46a.5.5 0 0 0-.606.605l1.122 4.51a.5.5 0 0 0 .838.234l1.165-1.165.84.841a.5.5 0 0 0 .708 0l.353-.353a.5.5 0 0 0 0-.707l-.84-.841 1.163-1.165a.5.5 0 0 0-.232-.838l-4.51-1.122Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5 6.75a.75.75 0 0 1 .75-.75h11a.75.75 0 0 1 .75.75v4.785c-.05-.018-.1-.033-.153-.046l-4.51-1.121a1.625 1.625 0 0 0-1.97 1.969l1.036 4.163h-6.153a.75.75 0 0 1-.75-.75v-9Zm11 1.75h-9.5v-1h9.5v1Z"
      }));
    };
    SvgDomainFilledIcon.displayName = "DomainFilledIcon";
    exports.SvgDomainFilledIcon = SvgDomainFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DomainIcon.svg.js
var require_DomainIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DomainIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDomainIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.25 3c-.414 0-.75.336-.75.75v9c0 .414.336.75.75.75s.75-.336.75-.75v-8.25h10.25c.414 0 .75-.336.75-.75s-.336-.75-.75-.75h-11Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5 6.25c0-.414.336-.75.75-.75h10.5c.414 0 .75.336.75.75v3.75c0 .414-.336.75-.75.75s-.75-.336-.75-.75v-.5h-9v5h4c.414 0 .75.336.75.75s-.336.75-.75.75h-4.75c-.414 0-.75-.336-.75-.75v-9Zm10.5.75v1h-9v-1h9Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.565 10.96c-.17-.043-.35.007-.474.131s-.174.304-.132.474l1.122 4.51c.043.176.177.314.351.362.174.048.36-.001.487-.128l1.165-1.165.84.841c.196.196.512.196.708 0l.353-.353c.196-.195.196-.512 0-.707l-.84-.841 1.163-1.165c.128-.127.177-.313.129-.487-.049-.174-.187-.308-.361-.351l-4.51-1.122Z"
      }));
    };
    SvgDomainIcon.displayName = "DomainIcon";
    exports.SvgDomainIcon = SvgDomainIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DomainLandingPageIcon.svg.js
var require_DomainLandingPageIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DomainLandingPageIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDomainLandingPageIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12 10c0-.36-.01-.711-.027-1.051-.635.034-1.297.051-1.973.051-.676 0-1.338-.017-1.973-.051a19.856 19.856 0 0 0 .026 2.499c.616.034 1.269.052 1.947.052a.75.75 0 1 1 0 1.5c-.604 0-1.193-.013-1.759-.04.106.582.244 1.103.412 1.547.44 1.161.95 1.493 1.347 1.493a.75.75 0 0 1 0 1.5 7.5 7.5 0 1 1 7.5-7.5.75.75 0 0 1-1.5 0c0-.55-.074-1.083-.213-1.59-.655.183-1.443.321-2.319.418.021.383.032.775.032 1.172a.75.75 0 0 1-1.5 0Zm-3.347-4.507c.44-1.161.95-1.493 1.347-1.493.396 0 .907.332 1.347 1.493.207.546.369 1.21.48 1.961-.577.03-1.19.046-1.827.046a35.3 35.3 0 0 1-1.827-.046c.111-.75.273-1.415.48-1.961Zm-1.402-.532c-.26.687-.452 1.493-.576 2.373-.724-.08-1.36-.188-1.88-.32a6.026 6.026 0 0 1 2.61-2.425 6.784 6.784 0 0 0-.154.372Zm-.72 3.867c-.875-.097-1.663-.235-2.318-.417a6.007 6.007 0 0 0-.163 2.367c.493.2 1.229.374 2.176.501l.314.04a21.13 21.13 0 0 1-.008-2.491Zm6.794-1.494c.724-.08 1.36-.188 1.88-.32a6.027 6.027 0 0 0-2.61-2.425c.056.122.107.247.154.372.26.687.452 1.493.576 2.373Zm-8.783 5.162a6.024 6.024 0 0 0 2.862 2.915 6.807 6.807 0 0 1-.153-.372c-.243-.64-.425-1.383-.55-2.193-.231-.024-.457-.05-.675-.08a14.799 14.799 0 0 1-1.484-.27Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "m14.81 13.75 2.47 2.47a.75.75 0 1 1-1.06 1.06l-2.47-2.47v1.19a.75.75 0 0 1-1.5 0v-3a.75.75 0 0 1 .75-.75h3a.75.75 0 0 1 0 1.5h-1.19Z"
      }));
    };
    SvgDomainLandingPageIcon.displayName = "DomainLandingPageIcon";
    exports.SvgDomainLandingPageIcon = SvgDomainLandingPageIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DomainNewIcon.svg.js
var require_DomainNewIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DomainNewIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDomainNewIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M2.25 2a.75.75 0 0 0-.75.75v9a.75.75 0 0 0 1.5 0v-8.25h10.25a.75.75 0 0 0 0-1.5h-11Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 5.25a.75.75 0 0 1 .75-.75h10.5a.75.75 0 0 1 .75.75v4.5a.75.75 0 0 1-1.5 0v-1.25h-9v5h3.25a.75.75 0 0 1 0 1.5h-4a.75.75 0 0 1-.75-.75v-9Zm10.5.75v1h-9v-1h9Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.5 14.25a.75.75 0 0 1 .75-.75h1.25v-1.25a.75.75 0 0 1 1.5 0v1.25h1.25a.75.75 0 0 1 0 1.5h-1.25v1.25a.75.75 0 0 1-1.5 0v-1.25h-1.25a.75.75 0 0 1-.75-.75Z"
      }));
    };
    SvgDomainNewIcon.displayName = "DomainNewIcon";
    exports.SvgDomainNewIcon = SvgDomainNewIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DomainRedirectIcon.svg.js
var require_DomainRedirectIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DomainRedirectIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDomainRedirectIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M1.5 2.75a.75.75 0 0 1 .75-.75h10.5a.75.75 0 0 1 0 1.5h-9.75v8.25a.75.75 0 0 1-1.5 0v-9Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4.75 4.5a.75.75 0 0 0-.75.75v9c0 .414.336.75.75.75h4.5a.75.75 0 0 0 0-1.5h-3.75v-5h9v.75a.75.75 0 0 0 1.5 0v-4a.75.75 0 0 0-.75-.75h-10.5Zm9.75 2.5v-1h-9v1h9Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.25 14.902a.75.75 0 0 1 0-1.5h3.243l-.841-.841a.75.75 0 0 1 1.06-1.061l2.122 2.121a.75.75 0 0 1 0 1.061l-2.122 2.121a.75.75 0 1 1-1.06-1.06l.84-.841h-3.242Z"
      }));
    };
    SvgDomainRedirectIcon.displayName = "DomainRedirectIcon";
    exports.SvgDomainRedirectIcon = SvgDomainRedirectIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DragDropIcon.svg.js
var require_DragDropIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DragDropIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDragDropIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.25 3.5a2.75 2.75 0 0 0-2.75 2.75.75.75 0 0 0 1.5 0c0-.69.56-1.25 1.25-1.25a.75.75 0 0 0 0-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 13.75a2.75 2.75 0 0 0 2.75 2.75.75.75 0 0 0 0-1.5c-.69 0-1.25-.56-1.25-1.25a.75.75 0 0 0-1.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.75 3.5a2.75 2.75 0 0 1 2.75 2.75.75.75 0 0 1-1.5 0c0-.69-.56-1.25-1.25-1.25a.75.75 0 0 1 0-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5 9a.75.75 0 0 0-1.5 0v2a.75.75 0 0 0 1.5 0v-2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.75 4.25a.75.75 0 0 1-.75.75h-2a.75.75 0 0 1 0-1.5h2a.75.75 0 0 1 .75.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.75 6a1.75 1.75 0 0 0-1.75 1.75v4.5c0 .966.784 1.75 1.75 1.75h1.25a.75.75 0 0 0 0-1.5h-1.25a.25.25 0 0 1-.25-.25v-4.5a.25.25 0 0 1 .25-.25h4.5a.25.25 0 0 1 .25.25v1.25a.75.75 0 0 0 1.5 0v-1.25a1.75 1.75 0 0 0-1.75-1.75h-4.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.065 10.46a.5.5 0 0 0-.606.605l1.122 4.51a.5.5 0 0 0 .838.234l1.165-1.165.84.841a.5.5 0 0 0 .708 0l.353-.353a.5.5 0 0 0 0-.707l-.84-.841 1.164-1.165a.5.5 0 0 0-.233-.838l-4.51-1.122Z"
      }));
    };
    SvgDragDropIcon.displayName = "DragDropIcon";
    exports.SvgDragDropIcon = SvgDragDropIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DragHandleIcon.svg.js
var require_DragHandleIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DragHandleIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDragHandleIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.5 4.5c-.552 0-1 .448-1 1v.5c0 .552.448 1 1 1h.5c.552 0 1-.448 1-1v-.5c0-.552-.448-1-1-1h-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.5 8.75c-.552 0-1 .448-1 1v.5c0 .552.448 1 1 1h.5c.552 0 1-.448 1-1v-.5c0-.552-.448-1-1-1h-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.5 14c0-.552.448-1 1-1h.5c.552 0 1 .448 1 1v.5c0 .552-.448 1-1 1h-.5c-.552 0-1-.448-1-1v-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12 4.5c-.552 0-1 .448-1 1v.5c0 .552.448 1 1 1h.5c.552 0 1-.448 1-1v-.5c0-.552-.448-1-1-1h-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 9.75c0-.552.448-1 1-1h.5c.552 0 1 .448 1 1v.5c0 .552-.448 1-1 1h-.5c-.552 0-1-.448-1-1v-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12 13c-.552 0-1 .448-1 1v.5c0 .552.448 1 1 1h.5c.552 0 1-.448 1-1v-.5c0-.552-.448-1-1-1h-.5Z"
      }));
    };
    SvgDragHandleIcon.displayName = "DragHandleIcon";
    exports.SvgDragHandleIcon = SvgDragHandleIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DuplicateIcon.svg.js
var require_DuplicateIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DuplicateIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgDuplicateIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.75 8.5a.75.75 0 0 1 .75.75v1.25h1.25a.75.75 0 0 1 0 1.5h-1.25v1.25a.75.75 0 0 1-1.5 0v-1.25h-1.25a.75.75 0 0 1 0-1.5h1.25v-1.25a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.75 3.5a2.75 2.75 0 0 0-2.74 2.51 2.75 2.75 0 0 0-2.51 2.74v5a2.75 2.75 0 0 0 2.75 2.75h5a2.75 2.75 0 0 0 2.74-2.51 2.75 2.75 0 0 0 2.51-2.74v-5a2.75 2.75 0 0 0-2.75-2.75h-5Zm2.5 2.5h-3.725c.116-.57.62-1 1.225-1h5c.69 0 1.25.56 1.25 1.25v5c0 .605-.43 1.11-1 1.225v-3.725a2.75 2.75 0 0 0-2.75-2.75Zm-5 1.5c-.69 0-1.25.56-1.25 1.25v5c0 .69.56 1.25 1.25 1.25h5c.69 0 1.25-.56 1.25-1.25v-5c0-.69-.56-1.25-1.25-1.25h-5Z"
      }));
    };
    SvgDuplicateIcon.displayName = "DuplicateIcon";
    exports.SvgDuplicateIcon = SvgDuplicateIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EditIcon.svg.js
var require_EditIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EditIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgEditIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15.655 4.344a2.695 2.695 0 0 0-3.81 0l-.599.599-.009-.009-1.06 1.06.008.01-5.88 5.88a2.75 2.75 0 0 0-.805 1.944v1.922a.75.75 0 0 0 .75.75h1.922a2.75 2.75 0 0 0 1.944-.806l7.54-7.539a2.695 2.695 0 0 0 0-3.81Zm-4.409 2.72-5.88 5.88a1.25 1.25 0 0 0-.366.884v1.172h1.172c.331 0 .65-.132.883-.366l5.88-5.88-1.689-1.69Zm2.75.629.599-.599a1.195 1.195 0 1 0-1.69-1.689l-.598.599 1.69 1.689Z"
      }));
    };
    SvgEditIcon.displayName = "EditIcon";
    exports.SvgEditIcon = SvgEditIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EmailFollowUpIcon.svg.js
var require_EmailFollowUpIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EmailFollowUpIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgEmailFollowUpIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3 7.25a2.75 2.75 0 0 1 2.75-2.75h8.5a2.75 2.75 0 0 1 2.75 2.75v2.5a.75.75 0 0 1-1.5 0v-2.5c0-.69-.56-1.25-1.25-1.25h-8.5c-.69 0-1.25.56-1.25 1.25v5.5c0 .69.56 1.25 1.25 1.25h4.25a.75.75 0 0 1 0 1.5h-4.25a2.75 2.75 0 0 1-2.75-2.75v-5.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.75 14.25a.75.75 0 0 1 .75-.75h2.94l-.72-.72a.75.75 0 1 1 1.06-1.06l2 2a.75.75 0 0 1 0 1.06l-2 2a.75.75 0 1 1-1.06-1.06l.72-.72h-2.94a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.567 7.57a.75.75 0 0 0-.634 1.36l3.538 1.651a1.25 1.25 0 0 0 1.058 0l3.538-1.651a.75.75 0 0 0-.634-1.36l-3.433 1.603-3.433-1.602Z"
      }));
    };
    SvgEmailFollowUpIcon.displayName = "EmailFollowUpIcon";
    exports.SvgEmailFollowUpIcon = SvgEmailFollowUpIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EmailIcon.svg.js
var require_EmailIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EmailIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgEmailIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.75 4.5c-1.519 0-2.75 1.231-2.75 2.75v5.5c0 1.519 1.231 2.75 2.75 2.75h8.5c1.519 0 2.75-1.231 2.75-2.75v-5.5c0-1.519-1.231-2.75-2.75-2.75h-8.5Zm-1.25 2.75c0-.69.56-1.25 1.25-1.25h8.5c.69 0 1.25.56 1.25 1.25v5.5c0 .69-.56 1.25-1.25 1.25h-8.5c-.69 0-1.25-.56-1.25-1.25v-5.5Zm2.067.32c-.375-.175-.821-.013-.997.363-.175.375-.013.821.363.997l3.538 1.651c.335.156.723.156 1.058 0l3.538-1.651c.376-.176.538-.622.363-.997-.175-.376-.622-.538-.997-.363l-3.433 1.602-3.433-1.602Z"
      }));
    };
    SvgEmailIcon.displayName = "EmailIcon";
    exports.SvgEmailIcon = SvgEmailIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EmailNewsletterIcon.svg.js
var require_EmailNewsletterIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EmailNewsletterIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgEmailNewsletterIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.5 6.5a.75.75 0 0 0 0 1.5h3a.75.75 0 0 0 0-1.5h-3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8 3.5a2.75 2.75 0 0 0-2.75 2.75v.5h-1.75a1 1 0 0 0-1 1v6a2.75 2.75 0 0 0 2.75 2.75h9.5a2.75 2.75 0 0 0 2.75-2.75v-6a1 1 0 0 0-1-1h-1.75v-.5a2.75 2.75 0 0 0-2.75-2.75h-4Zm2 7.849-3.25-2.167v-2.932c0-.69.56-1.25 1.25-1.25h4c.69 0 1.25.56 1.25 1.25v2.932l-3.25 2.167Zm6-2.198v4.599c0 .69-.56 1.25-1.25 1.25h-9.5c-.69 0-1.25-.56-1.25-1.25v-4.599l6 4 6-4Z"
      }));
    };
    SvgEmailNewsletterIcon.displayName = "EmailNewsletterIcon";
    exports.SvgEmailNewsletterIcon = SvgEmailNewsletterIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EnterIcon.svg.js
var require_EnterIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EnterIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgEnterIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9.75 3a2.25 2.25 0 0 0-2.25 2.25.75.75 0 0 0 1.5 0 .75.75 0 0 1 .75-.75h4a.75.75 0 0 1 .75.75v9.5a.75.75 0 0 1-.75.75h-4a.75.75 0 0 1-.75-.75.75.75 0 0 0-1.5 0 2.25 2.25 0 0 0 2.25 2.25h4a2.25 2.25 0 0 0 2.25-2.25v-9.5a2.25 2.25 0 0 0-2.25-2.25h-4Zm-5 6.25a.75.75 0 0 0 0 1.5h5.69l-.97.97a.75.75 0 1 0 1.06 1.06l2.25-2.25a.75.75 0 0 0 0-1.06l-2.25-2.25a.75.75 0 1 0-1.06 1.06l.97.97h-5.69Z"
      }));
    };
    SvgEnterIcon.displayName = "EnterIcon";
    exports.SvgEnterIcon = SvgEnterIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EnvelopeIcon.svg.js
var require_EnvelopeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EnvelopeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgEnvelopeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M6 9.5a.75.75 0 0 0 0 1.5h1a.75.75 0 0 0 0-1.5h-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.25 12.5a.75.75 0 0 1 .75-.75h3a.75.75 0 0 1 0 1.5h-3a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.25 4a2.75 2.75 0 0 0-2.75 2.75v6.5a2.75 2.75 0 0 0 2.75 2.75h9.5a2.75 2.75 0 0 0 2.75-2.75v-6.5a2.75 2.75 0 0 0-2.75-2.75h-9.5Zm7.184 1.5h-7.184c-.69 0-1.25.56-1.25 1.25v6.5c0 .69.56 1.25 1.25 1.25h7.184l-.5-.273a2.75 2.75 0 0 1-1.434-2.414v-3.626a2.75 2.75 0 0 1 1.433-2.414l.5-.273Zm3.566 7.552v-6.104a1 1 0 0 0-1.479-.878l-1.87 1.02a1.25 1.25 0 0 0-.651 1.097v3.626c0 .457.25.878.651 1.097l1.87 1.02a1 1 0 0 0 1.479-.878Z"
      }));
    };
    SvgEnvelopeIcon.displayName = "EnvelopeIcon";
    exports.SvgEnvelopeIcon = SvgEnvelopeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EnvelopeSoftPackIcon.svg.js
var require_EnvelopeSoftPackIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EnvelopeSoftPackIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgEnvelopeSoftPackIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.75 6a.75.75 0 0 0 0 1.5h2.5a.75.75 0 0 0 0-1.5h-2.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.5 11.25a.75.75 0 0 1 .75-.75h2.5a.75.75 0 0 1 0 1.5h-2.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.25 13a.75.75 0 0 0 0 1.5h4.5a.75.75 0 0 0 0-1.5h-4.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.75 3a2.75 2.75 0 0 0-2.75 2.75v8.5a2.75 2.75 0 0 0 2.75 2.75h6.5a2.75 2.75 0 0 0 2.75-2.75v-8.5a2.75 2.75 0 0 0-2.75-2.75h-6.5Zm-1.25 4.5h.75a.75.75 0 0 0 0-1.5h-.75v-.25c0-.69.56-1.25 1.25-1.25h6.5c.69 0 1.25.56 1.25 1.25v.25h-.75a.75.75 0 0 0 0 1.5h.75v6.75c0 .69-.56 1.25-1.25 1.25h-6.5c-.69 0-1.25-.56-1.25-1.25v-6.75Z"
      }));
    };
    SvgEnvelopeSoftPackIcon.displayName = "EnvelopeSoftPackIcon";
    exports.SvgEnvelopeSoftPackIcon = SvgEnvelopeSoftPackIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ExchangeIcon.svg.js
var require_ExchangeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ExchangeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgExchangeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15.5 11.364a2.501 2.501 0 1 1-1.5 0v-2.364a2.25 2.25 0 0 0-2.25-2.25h-.44l.47.47a.75.75 0 0 1-1.06 1.06l-1.75-1.75a.75.75 0 0 1 0-1.06l1.75-1.75a.75.75 0 1 1 1.06 1.06l-.47.47h.44a3.75 3.75 0 0 1 3.75 3.75v2.364Zm.25 2.386a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6 11v-2.364a2.501 2.501 0 1 0-1.5 0v2.364a3.75 3.75 0 0 0 3.75 3.75h.44l-.47.47a.75.75 0 1 0 1.06 1.06l1.75-1.75a.75.75 0 0 0 0-1.06l-1.75-1.75a.75.75 0 0 0-1.06 1.06l.47.47h-.44a2.25 2.25 0 0 1-2.25-2.25Zm.25-4.75a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }));
    };
    SvgExchangeIcon.displayName = "ExchangeIcon";
    exports.SvgExchangeIcon = SvgExchangeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ExitIcon.svg.js
var require_ExitIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ExitIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgExitIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.75 3a2.25 2.25 0 0 0-2.25 2.25.75.75 0 0 0 1.5 0 .75.75 0 0 1 .75-.75h4a.75.75 0 0 1 .75.75v9.5a.75.75 0 0 1-.75.75h-4a.75.75 0 0 1-.75-.75.75.75 0 0 0-1.5 0 2.25 2.25 0 0 0 2.25 2.25h4a2.25 2.25 0 0 0 2.25-2.25v-9.5a2.25 2.25 0 0 0-2.25-2.25h-4Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.25 10.75a.75.75 0 0 0 0-1.5h-5.69l.97-.97a.75.75 0 0 0-1.06-1.06l-2.25 2.25a.75.75 0 0 0 0 1.06l2.25 2.25a.75.75 0 0 0 1.06-1.06l-.97-.97h5.69Z"
      }));
    };
    SvgExitIcon.displayName = "ExitIcon";
    exports.SvgExitIcon = SvgExitIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ExportIcon.svg.js
var require_ExportIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ExportIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgExportIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 12.75a.75.75 0 0 1-1.5 0v-6.69l-1.72 1.72a.75.75 0 0 1-1.06-1.06l3-3a.75.75 0 0 1 1.06 0l3 3a.75.75 0 0 1-1.06 1.06l-1.72-1.72v6.69Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.5 13.75a.75.75 0 0 0-1.5 0v.76a.75.75 0 0 1-.75.75h-8.5a.75.75 0 0 1-.75-.75v-.76a.75.75 0 0 0-1.5 0v.76a2.25 2.25 0 0 0 2.25 2.25h8.5a2.25 2.25 0 0 0 2.25-2.25v-.76Z"
      }));
    };
    SvgExportIcon.displayName = "ExportIcon";
    exports.SvgExportIcon = SvgExportIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ExternalIcon.svg.js
var require_ExternalIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ExternalIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgExternalIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.75 3.5a.75.75 0 0 0 0 1.5h2.19l-4.97 4.97a.75.75 0 1 0 1.06 1.06l4.97-4.97v2.19a.75.75 0 0 0 1.5 0v-4a.75.75 0 0 0-.75-.75h-4Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15 10.967a.75.75 0 0 0-1.5 0v2.783c0 .69-.56 1.25-1.25 1.25h-6c-.69 0-1.25-.56-1.25-1.25v-6c0-.69.56-1.25 1.25-1.25h2.783a.75.75 0 0 0 0-1.5h-2.783a2.75 2.75 0 0 0-2.75 2.75v6a2.75 2.75 0 0 0 2.75 2.75h6a2.75 2.75 0 0 0 2.75-2.75v-2.783Z"
      }));
    };
    SvgExternalIcon.displayName = "ExternalIcon";
    exports.SvgExternalIcon = SvgExternalIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ExternalSmallIcon.svg.js
var require_ExternalSmallIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ExternalSmallIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgExternalSmallIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.75 4.5a.75.75 0 0 0 0 1.5h1.19l-2.72 2.72a.75.75 0 1 0 1.06 1.06l2.72-2.72v1.19a.75.75 0 0 0 1.5 0v-3a.75.75 0 0 0-.75-.75h-3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15 11.25a.75.75 0 0 0-1.5 0v1c0 .69-.56 1.25-1.25 1.25h-4.5c-.69 0-1.25-.56-1.25-1.25v-4.5c0-.69.56-1.25 1.25-1.25h1a.75.75 0 0 0 0-1.5h-1a2.75 2.75 0 0 0-2.75 2.75v4.5a2.75 2.75 0 0 0 2.75 2.75h4.5a2.75 2.75 0 0 0 2.75-2.75v-1Z"
      }));
    };
    SvgExternalSmallIcon.displayName = "ExternalSmallIcon";
    exports.SvgExternalSmallIcon = SvgExternalSmallIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EyeCheckMarkIcon.svg.js
var require_EyeCheckMarkIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EyeCheckMarkIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgEyeCheckMarkIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.779 9.165c-.221.453-.279.753-.279.835 0 .082.058.382.279.835.21.427.533.925.983 1.398.89.937 2.264 1.767 4.238 1.767a.75.75 0 0 1 0 1.5c-2.444 0-4.196-1.045-5.325-2.233a7.204 7.204 0 0 1-1.243-1.773c-.26-.532-.432-1.076-.432-1.494 0-.418.171-.962.432-1.494a7.205 7.205 0 0 1 1.243-1.773c1.13-1.188 2.88-2.233 5.325-2.233 2.432 0 4.12.972 5.224 2.1 1.083 1.107 1.6 2.355 1.754 2.968a.75.75 0 0 1-1.456.364c-.096-.387-.495-1.389-1.37-2.282-.853-.872-2.166-1.65-4.152-1.65-1.974 0-3.348.83-4.238 1.767-.45.472-.774.971-.983 1.398Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 13a3 3 0 1 0 0-6 3 3 0 0 0 0 6Zm0-1.5a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M18.28 12.78a.75.75 0 1 0-1.06-1.06l-2.97 2.97-1.22-1.22a.75.75 0 1 0-1.06 1.06l1.75 1.75a.75.75 0 0 0 1.06 0l3.5-3.5Z"
      }));
    };
    SvgEyeCheckMarkIcon.displayName = "EyeCheckMarkIcon";
    exports.SvgEyeCheckMarkIcon = SvgEyeCheckMarkIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EyeDropperIcon.svg.js
var require_EyeDropperIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EyeDropperIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgEyeDropperIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "m14.42 9.116 1.401-1.401a2.5 2.5 0 0 0-3.535-3.536l-.743.743-.007.007-.652.652-1.06-1.06a.75.75 0 1 0-1.061 1.06l1.06 1.06-5.644 5.645a2.5 2.5 0 1 0 3.535 3.535l5.645-5.644 1.06 1.06a.75.75 0 0 0 1.061-1.06l-1.06-1.06Zm-2.122 0-5.644 5.645a1 1 0 0 1-1.414-1.415l5.644-5.644 1.414 1.414Z"
      }));
    };
    SvgEyeDropperIcon.displayName = "EyeDropperIcon";
    exports.SvgEyeDropperIcon = SvgEyeDropperIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EyeFirstIcon.svg.js
var require_EyeFirstIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EyeFirstIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgEyeFirstIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "m8.8 8.69.7-.3v3.11h-1a.75.75 0 0 0 0 1.5h3.5a.75.75 0 0 0 0-1.5h-1v-3.5c0-.89-.92-1.5-1.74-1.14l-1.06.44a.75.75 0 0 0 .6 1.38Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 4a7.63 7.63 0 0 0-5.58 2.53 9.27 9.27 0 0 0-1.77 2.74c-.08.23-.15.49-.15.73s.07.5.15.73c.09.24.21.52.37.82.32.58.79 1.27 1.4 1.92a7.63 7.63 0 0 0 5.58 2.53 7.63 7.63 0 0 0 5.58-2.53 9.26 9.26 0 0 0 1.77-2.74c.08-.23.15-.49.15-.73s-.07-.5-.15-.73a9.27 9.27 0 0 0-1.77-2.74 7.63 7.63 0 0 0-5.58-2.53Zm-6 6 .07-.23a7.77 7.77 0 0 1 1.45-2.21 6.14 6.14 0 0 1 4.48-2.06c1.94 0 3.44.96 4.49 2.06a7.77 7.77 0 0 1 1.44 2.21l.07.23-.07.23a7.77 7.77 0 0 1-1.45 2.21 6.14 6.14 0 0 1-4.48 2.06 6.14 6.14 0 0 1-4.49-2.06 7.77 7.77 0 0 1-1.44-2.21l-.07-.23Z"
      }));
    };
    SvgEyeFirstIcon.displayName = "EyeFirstIcon";
    exports.SvgEyeFirstIcon = SvgEyeFirstIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EyeglassesIcon.svg.js
var require_EyeglassesIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/EyeglassesIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgEyeglassesIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13.47 5.03a.75.75 0 0 1 1.06-1.06l1.267 1.267c.265.264.438.607.494.978l.709 4.73v1.805a3.25 3.25 0 0 1-6.5 0v-.462a3.993 3.993 0 0 0-1 0v.462a3.25 3.25 0 0 1-6.5 0v-1.806l.712-4.718a1.75 1.75 0 0 1 .496-.995l1.262-1.261a.75.75 0 0 1 1.06 1.06l-1.261 1.262a.25.25 0 0 0-.071.143l-.002.01-.574 3.805h3.128c.52 0 .988.227 1.308.588a5.494 5.494 0 0 1 1.884 0c.32-.36.787-.588 1.308-.588h3.13l-.573-3.813a.25.25 0 0 0-.07-.14l-1.267-1.267Zm-1.22 6.72h3.25v1a1.75 1.75 0 1 1-3.5 0v-.75a.25.25 0 0 1 .25-.25Zm-4.5 0h-3.25v1a1.75 1.75 0 1 0 3.5 0v-.75a.25.25 0 0 0-.25-.25Z"
      }));
    };
    SvgEyeglassesIcon.displayName = "EyeglassesIcon";
    exports.SvgEyeglassesIcon = SvgEyeglassesIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FaviconIcon.svg.js
var require_FaviconIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FaviconIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgFaviconIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.5 8.5a.75.75 0 0 0-1.5 0v3a.75.75 0 0 0 1.5 0v-3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.5 9.25a.75.75 0 0 0 0 1.5.75.75 0 0 1 0 1.5 2.25 2.25 0 0 1 0-4.5.75.75 0 0 1 0 1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13 7.75a2.25 2.25 0 1 0 0 4.5 2.25 2.25 0 0 0 0-4.5Zm-.75 2.25a.75.75 0 1 1 1.5 0 .75.75 0 0 1-1.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13.58 4.5h-7.16c-.535 0-.98 0-1.345.03-.38.03-.736.098-1.073.27a2.75 2.75 0 0 0-1.202 1.202c-.172.337-.24.693-.27 1.073-.03.365-.03.81-.03 1.345v3.16c0 .535 0 .98.03 1.345.03.38.098.736.27 1.073a2.75 2.75 0 0 0 1.202 1.202c.337.172.693.24 1.073.27.365.03.81.03 1.345.03h7.16c.535 0 .98 0 1.345-.03.38-.03.736-.098 1.073-.27a2.751 2.751 0 0 0 1.202-1.201c.172-.338.24-.694.27-1.074.03-.365.03-.81.03-1.345v-3.16c0-.535 0-.98-.03-1.345-.03-.38-.098-.736-.27-1.073a2.75 2.75 0 0 0-1.201-1.202c-.338-.172-.694-.24-1.074-.27-.365-.03-.81-.03-1.345-.03Zm-8.897 1.636c.09-.046.227-.088.514-.111.296-.024.68-.025 1.253-.025h7.1c.572 0 .957 0 1.252.025.288.023.425.065.516.111.235.12.426.311.546.547.046.09.088.227.111.514.024.296.025.68.025 1.253v3.1c0 .572 0 .957-.025 1.252-.023.288-.065.425-.111.516a1.25 1.25 0 0 1-.546.546c-.091.046-.228.088-.515.111-.296.024-.68.025-1.253.025h-7.1c-.572 0-.957 0-1.253-.025-.287-.023-.424-.065-.514-.111a1.25 1.25 0 0 1-.547-.546c-.046-.091-.088-.228-.111-.515-.024-.296-.025-.68-.025-1.253v-3.1c0-.572 0-.957.025-1.253.023-.287.065-.424.111-.514a1.25 1.25 0 0 1 .547-.547Z"
      }));
    };
    SvgFaviconIcon.displayName = "FaviconIcon";
    exports.SvgFaviconIcon = SvgFaviconIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FileFilledIcon.svg.js
var require_FileFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FileFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgFileFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9.25 3h-3a1.75 1.75 0 0 0-1.75 1.75v10.5c0 .966.784 1.75 1.75 1.75h7.5a1.75 1.75 0 0 0 1.75-1.75v-6.045h-4.62a1.625 1.625 0 0 1-1.626-1.624l-.003-4.581Zm-2.225 11c0-.483.392-.875.875-.875h4.2a.875.875 0 0 1 0 1.75h-4.2a.875.875 0 0 1-.875-.875Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.214 7.955h-4.335a.375.375 0 0 1-.375-.375l-.003-4.322c.116.072.224.157.322.255l4.164 4.164c.086.085.162.178.227.278Z"
      }));
    };
    SvgFileFilledIcon.displayName = "FileFilledIcon";
    exports.SvgFileFilledIcon = SvgFileFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FileIcon.svg.js
var require_FileIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FileIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgFileIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8 12.5a1 1 0 1 0 0 2h4a1 1 0 1 0 0-2h-4Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.75 2.5a2.75 2.75 0 0 0-2.75 2.75v9.5a2.75 2.75 0 0 0 2.75 2.75h6.5a2.75 2.75 0 0 0 2.75-2.75v-6a.75.75 0 0 0-.22-.53l-5.5-5.5a.75.75 0 0 0-.53-.22h-3Zm-1.25 2.75c0-.69.56-1.25 1.25-1.25h2.25v3.75c0 .966.784 1.75 1.75 1.75h3.75v5.25c0 .69-.56 1.25-1.25 1.25h-6.5c-.69 0-1.25-.56-1.25-1.25v-9.5Zm7.94 2.75-2.94-2.94v2.69c0 .138.112.25.25.25h2.69Z"
      }));
    };
    SvgFileIcon.displayName = "FileIcon";
    exports.SvgFileIcon = SvgFileIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FilterIcon.svg.js
var require_FilterIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FilterIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgFilterIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3 6a.75.75 0 0 1 .75-.75h12.5a.75.75 0 0 1 0 1.5h-12.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.75 14a.75.75 0 0 1 .75-.75h5a.75.75 0 0 1 0 1.5h-5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.5 9.25a.75.75 0 0 0 0 1.5h9a.75.75 0 0 0 0-1.5h-9Z"
      }));
    };
    SvgFilterIcon.displayName = "FilterIcon";
    exports.SvgFilterIcon = SvgFilterIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FlagIcon.svg.js
var require_FlagIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FlagIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgFlagIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "m4.964 4.02.237-.127a4.808 4.808 0 0 1 5.392.592 2.09 2.09 0 0 0 2.25.304l.844-.397a1.973 1.973 0 0 1 2.813 1.786v5.044a2.37 2.37 0 0 1-1.361 2.145l-1.363.64a4.093 4.093 0 0 1-4.406-.595 2.832 2.832 0 0 0-3.176-.349l-1.194.637v2.05a.75.75 0 0 1-1.5 0v-11.5a.75.75 0 0 1 1.464-.23Zm.943 1.196a3.308 3.308 0 0 1 3.71.408 3.59 3.59 0 0 0 3.865.522l.843-.397a.473.473 0 0 1 .675.429v5.044a.87.87 0 0 1-.5.787l-1.362.642a2.593 2.593 0 0 1-2.792-.378 4.332 4.332 0 0 0-4.858-.533l-.488.26v-6.115a.31.31 0 0 1 .163-.272l.744-.397Z"
      }));
    };
    SvgFlagIcon.displayName = "FlagIcon";
    exports.SvgFlagIcon = SvgFlagIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FlowerFilledIcon.svg.js
var require_FlowerFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FlowerFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgFlowerFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.749 11.957c2.545-.294 4.501-2.066 4.501-4.207 0-2.347-2.35-4.25-5.25-4.25s-5.25 1.903-5.25 4.25c0 2.141 1.956 3.913 4.501 4.207a.763.763 0 0 0-.001.043v4.25a.75.75 0 0 0 1.5 0v-4.25l-.001-.043Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5 11.5c-.446 0-.872.083-1.265.235a3.5 3.5 0 0 0 4.53 4.53 3.5 3.5 0 0 0-3.265-4.765Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15 11.5c.446 0 .872.083 1.265.235a3.5 3.5 0 0 1-4.53 4.53 3.5 3.5 0 0 1 3.265-4.765Z"
      }));
    };
    SvgFlowerFilledIcon.displayName = "FlowerFilledIcon";
    exports.SvgFlowerFilledIcon = SvgFlowerFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FlowerIcon.svg.js
var require_FlowerIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FlowerIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgFlowerIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10.749 11.957c2.545-.294 4.501-2.066 4.501-4.207 0-2.347-2.35-4.25-5.25-4.25s-5.25 1.903-5.25 4.25c0 2.141 1.956 3.913 4.501 4.207a.763.763 0 0 0-.001.043v4.25a.75.75 0 0 0 1.5 0v-4.25l-.001-.043Zm-.749-1.457c2.383 0 3.75-1.512 3.75-2.75s-1.367-2.75-3.75-2.75-3.75 1.512-3.75 2.75 1.367 2.75 3.75 2.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.5 15c0 .446-.083.872-.235 1.265a3.5 3.5 0 0 1-4.53-4.53 3.5 3.5 0 0 1 4.765 3.265Zm-3.5-2a2 2 0 0 1 2 2 2 2 0 0 1-2-2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11.5 15c0 .446.083.872.235 1.265a3.5 3.5 0 0 0 4.53-4.53 3.5 3.5 0 0 0-4.765 3.265Zm3.5-2a2 2 0 0 0-2 2 2 2 0 0 0 2-2Z"
      }));
    };
    SvgFlowerIcon.displayName = "FlowerIcon";
    exports.SvgFlowerIcon = SvgFlowerIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FolderAddIcon.svg.js
var require_FolderAddIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FolderAddIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgFolderAddIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.75 5.5c-.69 0-1.25.56-1.25 1.25v6.5c0 .69.56 1.25 1.25 1.25h5.5a.75.75 0 0 1 0 1.5h-5.5a2.75 2.75 0 0 1-2.75-2.75v-6.5a2.75 2.75 0 0 1 2.75-2.75h1.514a2.75 2.75 0 0 1 2.46 1.52l.17.342a.25.25 0 0 0 .224.138h4.132a2.75 2.75 0 0 1 2.75 2.75v1.5a.75.75 0 0 1-1.5 0v-1.5c0-.69-.56-1.25-1.25-1.25h-4.132a1.75 1.75 0 0 1-1.565-.967l-.171-.342a1.25 1.25 0 0 0-1.118-.691h-1.514Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13 14.5a.75.75 0 0 1 .75-.75h1v-1a.75.75 0 0 1 1.5 0v1h1a.75.75 0 0 1 0 1.5h-1v1a.75.75 0 0 1-1.5 0v-1h-1a.75.75 0 0 1-.75-.75Z"
      }));
    };
    SvgFolderAddIcon.displayName = "FolderAddIcon";
    exports.SvgFolderAddIcon = SvgFolderAddIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FolderDownIcon.svg.js
var require_FolderDownIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FolderDownIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgFolderDownIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.5 6.75c0-.69.56-1.25 1.25-1.25h1.514c.473 0 .906.268 1.118.691l.17.342a1.75 1.75 0 0 0 1.566.967h4.132c.69 0 1.25.56 1.25 1.25v.5a.75.75 0 0 0 1.5 0v-.5a2.75 2.75 0 0 0-2.75-2.75h-4.132a.25.25 0 0 1-.224-.138l-.17-.342a2.75 2.75 0 0 0-2.46-1.52h-1.514a2.75 2.75 0 0 0-2.75 2.75v6.5a2.75 2.75 0 0 0 2.75 2.75h5a.75.75 0 0 0 0-1.5h-5c-.69 0-1.25-.56-1.25-1.25v-6.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16 11.5a.75.75 0 0 0-1.5 0v2.94l-.72-.72a.75.75 0 1 0-1.06 1.06l2 2a.75.75 0 0 0 1.06 0l2-2a.75.75 0 1 0-1.06-1.06l-.72.72v-2.94Z"
      }));
    };
    SvgFolderDownIcon.displayName = "FolderDownIcon";
    exports.SvgFolderDownIcon = SvgFolderDownIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FolderIcon.svg.js
var require_FolderIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FolderIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgFolderIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.75 5.5c-.69 0-1.25.56-1.25 1.25v6.5c0 .69.56 1.25 1.25 1.25h8.5c.69 0 1.25-.56 1.25-1.25v-4.5c0-.69-.56-1.25-1.25-1.25h-3.382a1.75 1.75 0 0 1-1.565-.967l-.171-.342a1.25 1.25 0 0 0-1.118-.691h-2.264Zm-2.75 1.25a2.75 2.75 0 0 1 2.75-2.75h2.264a2.75 2.75 0 0 1 2.46 1.52l.17.342a.25.25 0 0 0 .224.138h3.382a2.75 2.75 0 0 1 2.75 2.75v4.5a2.75 2.75 0 0 1-2.75 2.75h-8.5a2.75 2.75 0 0 1-2.75-2.75v-6.5Z"
      }));
    };
    SvgFolderIcon.displayName = "FolderIcon";
    exports.SvgFolderIcon = SvgFolderIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FolderRemoveIcon.svg.js
var require_FolderRemoveIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FolderRemoveIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgFolderRemoveIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.5 6.75c0-.69.56-1.25 1.25-1.25h1.514c.473 0 .906.268 1.118.691l.17.342a1.75 1.75 0 0 0 1.566.967h4.132c.69 0 1.25.56 1.25 1.25v.5a.75.75 0 0 0 1.5 0v-.5a2.75 2.75 0 0 0-2.75-2.75h-4.132a.25.25 0 0 1-.224-.138l-.17-.342a2.75 2.75 0 0 0-2.46-1.52h-1.514a2.75 2.75 0 0 0-2.75 2.75v6.5a2.75 2.75 0 0 0 2.75 2.75h7a.75.75 0 0 0 0-1.5h-7c-.69 0-1.25-.56-1.25-1.25v-6.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.75 11.5a.75.75 0 0 0 0 1.5h4.5a.75.75 0 0 0 0-1.5h-4.5Z"
      }));
    };
    SvgFolderRemoveIcon.displayName = "FolderRemoveIcon";
    exports.SvgFolderRemoveIcon = SvgFolderRemoveIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FolderUpIcon.svg.js
var require_FolderUpIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FolderUpIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgFolderUpIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.5 6.75c0-.69.56-1.25 1.25-1.25h1.514c.473 0 .906.268 1.118.691l.17.342a1.75 1.75 0 0 0 1.566.967h4.132c.69 0 1.25.56 1.25 1.25a.75.75 0 0 0 1.5 0 2.75 2.75 0 0 0-2.75-2.75h-4.132a.25.25 0 0 1-.224-.138l-.17-.342a2.75 2.75 0 0 0-2.46-1.52h-1.514a2.75 2.75 0 0 0-2.75 2.75v6.5a2.75 2.75 0 0 0 2.75 2.75h6a.75.75 0 0 0 0-1.5h-6c-.69 0-1.25-.56-1.25-1.25v-6.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.75 13.31v2.94a.75.75 0 0 1-1.5 0v-2.94l-.72.72a.75.75 0 1 1-1.06-1.06l2-2a.75.75 0 0 1 1.06 0l2 2a.75.75 0 1 1-1.06 1.06l-.72-.72Z"
      }));
    };
    SvgFolderUpIcon.displayName = "FolderUpIcon";
    exports.SvgFolderUpIcon = SvgFolderUpIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FoodIcon.svg.js
var require_FoodIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FoodIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgFoodIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.729 2.126c-1.118-.745-2.42-.876-3.229-.876a.75.75 0 0 0-.75.75c0 1.713.507 2.923 1.277 3.745a3.943 3.943 0 0 0-1.458.615c-1.235.867-1.569 2.303-1.569 3.64 0 1.386.478 3.14 1.29 4.53.782 1.336 2.055 2.618 3.746 2.47.698-.003 1.457-.09 1.964-.162.507.071 1.266.159 1.964.162 1.691.148 2.964-1.134 3.746-2.47.812-1.39 1.29-3.144 1.29-4.53 0-1.337-.334-2.773-1.57-3.64-.874-.614-2.076-.852-3.646-.694l1.073-1.475a.75.75 0 0 0-1.214-.882l-1.087 1.496c-.316-1.258-.99-2.12-1.827-2.679Zm.471 3.569c-.53-.076-1.104-.24-1.596-.569-.589-.392-1.14-1.068-1.304-2.32.53.075 1.104.24 1.596.568.589.392 1.14 1.068 1.304 2.32Zm-3.77 1.893c-.64.45-.93 1.264-.93 2.412 0 1.1.397 2.595 1.085 3.772.712 1.22 1.55 1.81 2.34 1.732a.744.744 0 0 1 .075-.004c.649 0 1.401-.09 1.892-.162a.757.757 0 0 1 .216 0c.491.072 1.243.162 1.892.162.025 0 .05.001.075.004.79.079 1.628-.513 2.34-1.732.688-1.177 1.085-2.672 1.085-3.772 0-1.148-.29-1.962-.93-2.412-.667-.467-1.954-.719-4.388-.11a.75.75 0 0 1-.364 0c-2.434-.609-3.721-.357-4.387.11Z"
      }));
    };
    SvgFoodIcon.displayName = "FoodIcon";
    exports.SvgFoodIcon = SvgFoodIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ForkliftIcon.svg.js
var require_ForkliftIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ForkliftIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgForkliftIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15 4.25a.75.75 0 0 0-1.5 0v3.98l-.8-2.001a2.75 2.75 0 0 0-2.554-1.729h-3.396a.75.75 0 0 0-.75.75v3.25h-1.75a.75.75 0 0 0-.75.75v3.159a2.5 2.5 0 1 0 4.636 1.841h2.479a2.501 2.501 0 0 0 4.835-1.25h1.8a.75.75 0 0 0 0-1.5h-2.25v-7.25Zm-8.589 10a.998.998 0 0 0 0-1.5.996.996 0 0 0-1.322 0 .998.998 0 0 0 0 1.5.996.996 0 0 0 1.322 0Zm-1.411-3.136a2.501 2.501 0 0 1 3.136 1.636h2.479a2.502 2.502 0 0 1 2.135-1.738v-.012h-3.25a.75.75 0 0 1-.256-.045l-2.626-.955h-1.618v1.114Zm7.338 1.636a1 1 0 1 1 1.323 1.498 1 1 0 0 1-1.322-1.498Zm-2.706-3.25h2.76l-1.085-2.714a1.25 1.25 0 0 0-1.161-.786h-2.646v2.725l2.132.775Z"
      }));
    };
    SvgForkliftIcon.displayName = "ForkliftIcon";
    exports.SvgForkliftIcon = SvgForkliftIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FormsIcon.svg.js
var require_FormsIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/FormsIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgFormsIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M14 4.5a.75.75 0 0 1 0 1.5c-.906 0-1.412.17-1.665.296-.032.016-.06.031-.085.046v7.343a.86.86 0 0 0 .068.034c.257.12.77.281 1.682.281a.75.75 0 0 1 0 1.5c-1.088 0-1.825-.191-2.318-.422a2.972 2.972 0 0 1-.182-.093 2.972 2.972 0 0 1-.182.093c-.493.23-1.23.422-2.318.422a.75.75 0 0 1 0-1.5c.912 0 1.425-.16 1.682-.28l.068-.035v-7.343a1.447 1.447 0 0 0-.085-.046c-.253-.127-.76-.296-1.665-.296a.75.75 0 0 1 0-1.5c1.094 0 1.838.205 2.335.454.059.03.114.06.165.089.051-.03.106-.06.165-.089.497-.248 1.24-.454 2.335-.454Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.5 9.25c0-.69.56-1.25 1.25-1.25h3.25a.75.75 0 0 0 0-1.5h-3.25a2.75 2.75 0 0 0-2.75 2.75v1.5a2.75 2.75 0 0 0 2.75 2.75h3.25a.75.75 0 0 0 0-1.5h-3.25c-.69 0-1.25-.56-1.25-1.25v-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.125 6.5a.75.75 0 0 0 0 1.5h.125c.69 0 1.25.56 1.25 1.25v1.5c0 .69-.56 1.25-1.25 1.25h-.125a.75.75 0 0 0 0 1.5h.125a2.75 2.75 0 0 0 2.75-2.75v-1.5a2.75 2.75 0 0 0-2.75-2.75h-.125Z"
      }));
    };
    SvgFormsIcon.displayName = "FormsIcon";
    exports.SvgFormsIcon = SvgFormsIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GamesIcon.svg.js
var require_GamesIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GamesIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgGamesIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13 8.25a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.75 11.5a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.25 7.25a.75.75 0 0 1 .75.75v.5h.5a.75.75 0 0 1 0 1.5h-.5v.5a.75.75 0 0 1-1.5 0v-.5h-.5a.75.75 0 0 1 0-1.5h.5v-.5a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12 3.75c-.69 0-1.25.56-1.25 1.25h1.5a4.75 4.75 0 0 1 4.75 4.75v3.343a2.907 2.907 0 0 1-5.685.855l-.332-1.077a.17.17 0 0 0-.163-.121h-1.64a.17.17 0 0 0-.163.12l-.332 1.078a2.907 2.907 0 0 1-5.685-.855v-3.343a4.75 4.75 0 0 1 4.75-4.75h1.5a2.75 2.75 0 0 1 2.75-2.75v1.5Zm-4.25 2.75a3.25 3.25 0 0 0-3.25 3.25v3.343a1.407 1.407 0 0 0 2.752.414l.331-1.078a1.67 1.67 0 0 1 1.597-1.179h1.64a1.67 1.67 0 0 1 1.597 1.18l.331 1.077a1.407 1.407 0 0 0 2.752-.414v-3.343a3.25 3.25 0 0 0-3.25-3.25h-4.5Z"
      }));
    };
    SvgGamesIcon.displayName = "GamesIcon";
    exports.SvgGamesIcon = SvgGamesIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GaugeIcon.svg.js
var require_GaugeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GaugeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgGaugeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.5 11.5a5.5 5.5 0 0 1 7.434-5.15l.456-.981a1.5 1.5 0 0 1 .234-.36 7 7 0 0 0-8.766 9.852.75.75 0 0 0 1.315-.722 5.472 5.472 0 0 1-.673-2.639Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "m15.084 6.689-.695 1.496a5.475 5.475 0 0 1 1.111 3.315c0 .958-.244 1.857-.673 2.64a.75.75 0 1 0 1.315.72 6.972 6.972 0 0 0 .858-3.36 6.976 6.976 0 0 0-1.916-4.811Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 16a2 2 0 0 0 1.485-3.34l2.945-6.344a.75.75 0 1 0-1.36-.632l-2.935 6.32a2 2 0 1 0-.135 3.995Zm0-1.5a.5.5 0 1 0 0-1 .5.5 0 0 0 0 1Z"
      }));
    };
    SvgGaugeIcon.displayName = "GaugeIcon";
    exports.SvgGaugeIcon = SvgGaugeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GiftCardFilledIcon.svg.js
var require_GiftCardFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GiftCardFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgGiftCardFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.5 4v2.25a.75.75 0 0 0 1.5 0v-2.25h5.5a2 2 0 0 1 2 2v3h-2.75a.75.75 0 0 0 0 1.5h2.75v3.5a2 2 0 0 1-2 2h-5.5v-2.5a.75.75 0 0 0-1.5 0v2.5h-4a2 2 0 0 1-2-2v-3.5h1.25a.75.75 0 0 0 0-1.5h-1.25v-3a2 2 0 0 1 2-2h4Zm-1.631 2.75c.83 0 1.585.486 1.928 1.242l.453.996.453-.996a2.119 2.119 0 0 1 4.047.88c0 1.171-.95 2.128-2.125 2.128h-.858c.595.51 1.256.924 1.84 1.008a.75.75 0 0 1-.213 1.485c-1.11-.16-2.128-.92-2.803-1.53-.121-.11-.235-.218-.341-.323-.106.105-.22.213-.34.322-.676.611-1.693 1.372-2.804 1.53a.75.75 0 0 1-.212-1.485c.583-.083 1.244-.497 1.839-1.007h-.858a2.128 2.128 0 0 1-2.125-2.128c0-1.168.946-2.122 2.119-2.122Zm.006 2.75h.96l-.403-.887a.619.619 0 0 0-1.182.259c0 .347.282.628.625.628Zm3.79 0h.96c.343 0 .625-.28.625-.628a.619.619 0 0 0-1.182-.26l-.403.888Z"
      }));
    };
    SvgGiftCardFilledIcon.displayName = "GiftCardFilledIcon";
    exports.SvgGiftCardFilledIcon = SvgGiftCardFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GiftCardIcon.svg.js
var require_GiftCardIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GiftCardIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgGiftCardIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15.5 5.5h-5.5v.75a.75.75 0 0 1-1.5 0v-.75h-4a.5.5 0 0 0-.5.5v3.043a.75.75 0 0 1 0 1.414v3.543a.5.5 0 0 0 .5.5h4v-1a.75.75 0 0 1 1.5 0v1h5.5a.5.5 0 0 0 .5-.5v-3.5h-1.25a.75.75 0 0 1 0-1.5h1.25v-3a.5.5 0 0 0-.5-.5Zm2 4.25v-3.75a2 2 0 0 0-2-2h-11a2 2 0 0 0-2 2v8a2 2 0 0 0 2 2h11a2 2 0 0 0 2-2v-4.25Zm-8.703-1.758a2.119 2.119 0 0 0-4.047.88c0 1.171.95 2.128 2.125 2.128h.858c-.595.51-1.256.924-1.84 1.008a.75.75 0 0 0 .213 1.485c1.11-.16 2.128-.92 2.803-1.53.121-.11.235-.218.341-.323.106.105.22.213.34.322.676.611 1.693 1.372 2.804 1.53a.75.75 0 0 0 .212-1.485c-.583-.083-1.244-.497-1.839-1.007h.858a2.128 2.128 0 0 0 2.125-2.128 2.119 2.119 0 0 0-4.047-.88l-.453.996-.453-.996Zm-.962 1.508h-.96a.628.628 0 0 1-.625-.628.619.619 0 0 1 1.182-.26l.403.888Zm3.79 0h-.96l.403-.887a.619.619 0 0 1 1.182.259.628.628 0 0 1-.625.628Z"
      }));
    };
    SvgGiftCardIcon.displayName = "GiftCardIcon";
    exports.SvgGiftCardIcon = SvgGiftCardIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GlobeAsiaFilledIcon.svg.js
var require_GlobeAsiaFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GlobeAsiaFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgGlobeAsiaFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3 10a7 7 0 1 1 14 0 7 7 0 0 1-14 0Zm7-5.5a5.502 5.502 0 0 0-5.424 4.584l.276.183a.75.75 0 0 0 1.016-.174l.262-.35a.75.75 0 0 1 1.334.303l.103.515a.857.857 0 0 0 1.554.307l.374-.561a1.25 1.25 0 0 1 1.04-.557h.184a.75.75 0 0 0 .728-.568l.121-.485c.068-.27.22-.5.425-.667l.007-.03h.03c.212-.158.473-.25.75-.25h.22a.75.75 0 0 0 .75-.75v-.023a5.48 5.48 0 0 0-3.75-1.477Zm4 5.18v-.254a.743.743 0 0 1 .152-.34l.938-1.173c.257.625.402 1.309.41 2.025l-.304.228a.757.757 0 0 1-1.196-.487Zm-6.186 5.369c.67.29 1.41.451 2.186.451 1.29 0 2.475-.444 3.412-1.186a2.523 2.523 0 0 0-1.963-.939h-.52c-.467 0-.906.22-1.186.592-.165.22-.384.395-.635.506l-1.294.575Z"
      }));
    };
    SvgGlobeAsiaFilledIcon.displayName = "GlobeAsiaFilledIcon";
    exports.SvgGlobeAsiaFilledIcon = SvgGlobeAsiaFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GlobeAsiaIcon.svg.js
var require_GlobeAsiaIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GlobeAsiaIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgGlobeAsiaIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 3a7 7 0 1 0 0 14 7 7 0 0 0 0-14Zm-5.31 5.56a5.502 5.502 0 0 1 8.56-2.998v.438a.25.25 0 0 1-.25.25h-.22a1.75 1.75 0 0 0-1.697 1.326l-.121.485a.25.25 0 0 1-.243.189h-.184a1.75 1.75 0 0 0-1.456.78l-.374.561a.357.357 0 0 1-.648-.128l-.103-.515c-.211-1.059-1.576-1.369-2.224-.505l-.262.35a.25.25 0 0 1-.34.058l-.437-.292Zm-.186 1.658a5.491 5.491 0 0 0 2.126 4.13.776.776 0 0 1 .065-.033l1.956-.87a.487.487 0 0 0 .192-.153 2.606 2.606 0 0 1 2.085-1.042h.521a3.65 3.65 0 0 1 2.772 1.276 5.48 5.48 0 0 0 1.147-2.325 1.763 1.763 0 0 1-2.083-.672c-.42-.63-.393-1.47.086-2.068l1.207-1.51a5.55 5.55 0 0 0-.057-.084 1.75 1.75 0 0 1-1.521.883h-.22a.25.25 0 0 0-.242.19l-.121.484a1.75 1.75 0 0 1-1.698 1.326h-.184a.25.25 0 0 0-.208.111l-.374.562a1.857 1.857 0 0 1-3.36-.637 1.75 1.75 0 0 1-2.089.432Zm10.78-1.748-.742.928a.258.258 0 0 0-.01.3.259.259 0 0 0 .364.068l.565-.424a5.468 5.468 0 0 0-.177-.872Zm-5.284 7.03a5.497 5.497 0 0 1-1.686-.263l.946-.42c.31-.139.58-.353.783-.625a1.11 1.11 0 0 1 .885-.442h.521c.647 0 1.256.291 1.662.787a5.475 5.475 0 0 1-3.111.963Z"
      }));
    };
    SvgGlobeAsiaIcon.displayName = "GlobeAsiaIcon";
    exports.SvgGlobeAsiaIcon = SvgGlobeAsiaIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GlobeEUFilledIcon.svg.js
var require_GlobeEUFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GlobeEUFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgGlobeEuFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 3a7 7 0 1 0 0 14 7 7 0 0 0 0-14Zm-2.53 11.884a5.477 5.477 0 0 0 2.53.616 5.481 5.481 0 0 0 3.796-1.52l-2.127.399a1.876 1.876 0 0 1-1.34-.253 1.917 1.917 0 0 0-2.371.27l-.489.488Zm7.745-6.636a5.517 5.517 0 0 0-3.018-3.292l-1.904.858a.922.922 0 0 0-.543.841c0 .612-.392 1.156-.973 1.35l-.75.25a1.537 1.537 0 0 0-1.03 1.71l.06.353a1.115 1.115 0 0 0 2.097.316l.122-.246a2.059 2.059 0 0 1 1.842-1.138h.507c.69 0 1.25.56 1.25 1.25v.375c0 .207.168.375.375.375a1 1 0 0 0 1-1v-.771c0-.543.347-1.025.862-1.197l.103-.034Z"
      }));
    };
    SvgGlobeEuFilledIcon.displayName = "GlobeEuFilledIcon";
    exports.SvgGlobeEuFilledIcon = SvgGlobeEuFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GlobeEUIcon.svg.js
var require_GlobeEUIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GlobeEUIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgGlobeEuIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3 10a7 7 0 1 1 14 0 7 7 0 0 1-14 0Zm7-5.5a5.5 5.5 0 0 0-3.391 9.83l.641-.641a2.918 2.918 0 0 1 3.61-.411.88.88 0 0 0 .625.118l3.259-.611a5.474 5.474 0 0 0 .702-3.56l-.018.006a.26.26 0 0 0-.178.248v.771a2 2 0 0 1-2 2c-.76 0-1.375-.616-1.375-1.375v-.375a.25.25 0 0 0-.25-.25h-.507a1.06 1.06 0 0 0-.947.585l-.123.246a2.115 2.115 0 0 1-3.978-.598l-.059-.353a2.537 2.537 0 0 1 1.7-2.824l.75-.25a.422.422 0 0 0 .289-.4c0-.757.443-1.443 1.132-1.753l.8-.361a5.557 5.557 0 0 0-.682-.042Zm2.769.747-2.27 1.023a.422.422 0 0 0-.249.385c0 .827-.53 1.562-1.314 1.824l-.75.25c-.484.161-.779.65-.695 1.154l.059.353a.615.615 0 0 0 1.157.174l.122-.245a2.559 2.559 0 0 1 2.29-1.415h.506c.966 0 1.75.784 1.75 1.75v.234a.5.5 0 0 0 .375-.484v-.771a1.76 1.76 0 0 1 1.204-1.67l.08-.028a5.522 5.522 0 0 0-2.265-2.534Zm-2.769 10.253c-.723 0-1.414-.14-2.046-.393l.357-.357a1.418 1.418 0 0 1 1.754-.2c.505.316 1.11.43 1.697.32l1.178-.22a5.48 5.48 0 0 1-2.94.85Z"
      }));
    };
    SvgGlobeEuIcon.displayName = "GlobeEuIcon";
    exports.SvgGlobeEuIcon = SvgGlobeEuIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GlobeFilledIcon.svg.js
var require_GlobeFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GlobeFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgGlobeFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3 10a7 7 0 1 1 14 0 7 7 0 0 1-14 0Zm2.019-2.335 1.89 1.89c.378.379.591.892.591 1.427v.518a1 1 0 0 0 1 1 1.5 1.5 0 0 1 1.5 1.5v1.5a5.502 5.502 0 0 0 5.216-3.75h-1.216a.25.25 0 0 1-.25-.25v-.5c0-.69-.56-1.25-1.25-1.25h-2.5a1.255 1.255 0 0 1-.764-2.248l.462-.357a.89.89 0 0 0 .347-.707v-.04c0-.747.606-1.353 1.353-1.353h.057c.193 0 .37-.069.509-.184a5.5 5.5 0 0 0-6.945 2.804Z"
      }));
    };
    SvgGlobeFilledIcon.displayName = "GlobeFilledIcon";
    exports.SvgGlobeFilledIcon = SvgGlobeFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GlobeIcon.svg.js
var require_GlobeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/GlobeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgGlobeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3 10a7 7 0 1 1 14 0 7 7 0 0 1-14 0Zm7-5.5a5.497 5.497 0 0 0-4.737 2.703l2 1.999c.472.472.737 1.113.737 1.78v.518a.5.5 0 0 0 .5.5 2 2 0 0 1 2 2v1.478a5.504 5.504 0 0 0 4.52-3.228h-1.02a.75.75 0 0 1-.75-.75v-.5a.75.75 0 0 0-.75-.75h-2.5a1.755 1.755 0 0 1-1.07-3.144l.463-.356a.393.393 0 0 0 .152-.312v-.04c0-.885.62-1.624 1.449-1.808a5.531 5.531 0 0 0-.994-.09Zm2.875.81a1.85 1.85 0 0 1-1.477.735.352.352 0 0 0-.353.353v.04c0 .587-.271 1.14-.736 1.499l-.462.356a.256.256 0 0 0 .153.457h2.5a2.25 2.25 0 0 1 2.236 2h.713a5.497 5.497 0 0 0-2.574-5.44Zm-8.375 4.69c0-.443.052-.875.152-1.288l1.55 1.55c.19.191.298.45.298.72v.518a2 2 0 0 0 2 2 .5.5 0 0 1 .5.5v1.41a5.502 5.502 0 0 1-4.5-5.41Z"
      }));
    };
    SvgGlobeIcon.displayName = "GlobeIcon";
    exports.SvgGlobeIcon = SvgGlobeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/HashtagDecimalIcon.svg.js
var require_HashtagDecimalIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/HashtagDecimalIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgHashtagDecimalIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13.629 3.511a.75.75 0 0 1 .61.868l-.413 2.371h2.174a.75.75 0 0 1 0 1.5h-2.434l-.61 3.5h2.544a.75.75 0 0 1 0 1.5h-2.804l-.457 2.629a.75.75 0 1 1-1.478-.257l.413-2.372h-3.478l-.457 2.629a.75.75 0 1 1-1.478-.257l.413-2.372h-2.174a.75.75 0 0 1 0-1.5h2.434l.61-3.5h-2.544a.75.75 0 0 1 0-1.5h2.804l.457-2.628a.75.75 0 1 1 1.478.257l-.413 2.371h3.478l.457-2.628a.75.75 0 0 1 .868-.61Zm-2.195 8.239h-3.477l.609-3.5h3.477l-.609 3.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.5 17a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3Z"
      }));
    };
    SvgHashtagDecimalIcon.displayName = "HashtagDecimalIcon";
    exports.SvgHashtagDecimalIcon = SvgHashtagDecimalIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/HashtagIcon.svg.js
var require_HashtagIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/HashtagIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgHashtagIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M14.239 4.379a.75.75 0 1 0-1.478-.257l-.457 2.628h-3.478l.413-2.371a.75.75 0 0 0-1.478-.257l-.457 2.628h-2.804a.75.75 0 0 0 0 1.5h2.543l-.609 3.5h-2.434a.75.75 0 0 0 0 1.5h2.174l-.413 2.372a.75.75 0 1 0 1.478.257l.457-2.629h3.478l-.413 2.372a.75.75 0 1 0 1.478.257l.457-2.629h2.804a.75.75 0 0 0 0-1.5h-2.543l.609-3.5h2.434a.75.75 0 0 0 0-1.5h-2.174l.413-2.371Zm-6.282 7.371h3.477l.61-3.5h-3.478l-.61 3.5Z"
      }));
    };
    SvgHashtagIcon.displayName = "HashtagIcon";
    exports.SvgHashtagIcon = SvgHashtagIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/HeartIcon.svg.js
var require_HeartIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/HeartIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgHeartIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.469 5.785c-.966-1.047-2.505-1.047-3.47 0-.998 1.081-.998 2.857 0 3.939l5.001 5.42 5.002-5.42c.997-1.082.997-2.858 0-3.939-.966-1.047-2.505-1.047-3.47 0l-.98 1.062a.75.75 0 0 1-1.103 0l-.98-1.062Zm-4.573-1.017c1.56-1.69 4.115-1.69 5.675 0l.429.464.429-.464c1.56-1.69 4.115-1.69 5.675 0 1.528 1.656 1.528 4.317 0 5.973l-5.185 5.62a1.25 1.25 0 0 1-1.838 0l-5.185-5.62c-1.528-1.656-1.528-4.317 0-5.973Z"
      }));
    };
    SvgHeartIcon.displayName = "HeartIcon";
    exports.SvgHeartIcon = SvgHeartIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/HideIcon.svg.js
var require_HideIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/HideIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgHideIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.977 4.751a7.598 7.598 0 0 0-1.977-.251c-2.444 0-4.196 1.045-5.325 2.233a7.188 7.188 0 0 0-1.243 1.773c-.26.532-.432 1.076-.432 1.494 0 .418.171.962.432 1.493.172.354.4.734.687 1.116l1.074-1.074a5.388 5.388 0 0 1-.414-.7c-.221-.453-.279-.753-.279-.835 0-.082.058-.382.279-.835a5.71 5.71 0 0 1 .983-1.398c.89-.937 2.264-1.767 4.238-1.767.24 0 .471.012.693.036l1.284-1.285Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4.25 14.6a.75.75 0 0 0 1.067 1.053l1.062-1.061c.975.543 2.177.908 3.621.908 2.45 0 4.142-1.05 5.24-2.242 1.078-1.17 1.588-2.476 1.738-3.076a.749.749 0 0 0 0-.364c-.15-.6-.66-1.906-1.738-3.076a7.245 7.245 0 0 0-.51-.502l.923-.923a.75.75 0 0 0-1.053-1.068l-.008.008-10.335 10.336-.008.007Zm5.75-.6c-.978 0-1.809-.204-2.506-.523l1.108-1.109a2.75 2.75 0 0 0 3.766-3.766l1.3-1.299c.169.147.325.3.469.455a6.387 6.387 0 0 1 1.332 2.242 6.387 6.387 0 0 1-1.332 2.242c-.86.933-2.17 1.758-4.137 1.758Zm0-2.75c-.087 0-.172-.01-.254-.026l1.478-1.478a1.25 1.25 0 0 1-1.224 1.504Z"
      }));
    };
    SvgHideIcon.displayName = "HideIcon";
    exports.SvgHideIcon = SvgHideIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/HomeFilledIcon.svg.js
var require_HomeFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/HomeFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgHomeFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M14 16h-2a1 1 0 0 1-1-1v-2.5a.5.5 0 0 0-.5-.5h-1a.5.5 0 0 0-.5.5v2.5a1 1 0 0 1-1 1h-2a2 2 0 0 1-2-2v-4.257a3 3 0 0 1 .879-2.122l3.707-3.707a2 2 0 0 1 2.828 0l3.707 3.707a3 3 0 0 1 .879 2.122v4.257a2 2 0 0 1-2 2Z"
      }));
    };
    SvgHomeFilledIcon.displayName = "HomeFilledIcon";
    exports.SvgHomeFilledIcon = SvgHomeFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/HomeIcon.svg.js
var require_HomeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/HomeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgHomeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.344 3.692a2.25 2.25 0 0 1 3.312 0l3.854 4.19a3.75 3.75 0 0 1 .99 2.538v3.33a2.75 2.75 0 0 1-2.75 2.75h-1.75a1.5 1.5 0 0 1-1.5-1.5v-2h-1v2a1.5 1.5 0 0 1-1.5 1.5h-1.75a2.75 2.75 0 0 1-2.75-2.75v-3.33c0-.94.353-1.847.99-2.539l3.854-4.189Zm2.208 1.016a.75.75 0 0 0-1.104 0l-3.854 4.189a2.25 2.25 0 0 0-.594 1.523v3.33c0 .69.56 1.25 1.25 1.25h1.75v-2a1.5 1.5 0 0 1 1.5-1.5h1a1.5 1.5 0 0 1 1.5 1.5v2h1.75c.69 0 1.25-.56 1.25-1.25v-3.33a2.25 2.25 0 0 0-.594-1.523l-3.854-4.19Z"
      }));
    };
    SvgHomeIcon.displayName = "HomeIcon";
    exports.SvgHomeIcon = SvgHomeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/IconsFilledIcon.svg.js
var require_IconsFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/IconsFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgIconsFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15.219 14.708c.47-.314.781-.85.781-1.458v-6.5a1.75 1.75 0 0 0-1.75-1.75h-4.587a3.5 3.5 0 1 0-5.663 3.95v4.3c0 .966.784 1.75 1.75 1.75h2.36l-.508.872a.75.75 0 0 0 .648 1.128h7a.75.75 0 0 0 .648-1.128l-.68-1.164Zm-5.219-8.208a3.5 3.5 0 0 1-4.5 3.355v3.395c0 .138.112.25.25.25h3.236l2.116-3.628a.75.75 0 0 1 1.296 0l2.055 3.524a.248.248 0 0 0 .047-.146v-6.5a.25.25 0 0 0-.25-.25h-4.25Z"
      }));
    };
    SvgIconsFilledIcon.displayName = "IconsFilledIcon";
    exports.SvgIconsFilledIcon = SvgIconsFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/IconsIcon.svg.js
var require_IconsIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/IconsIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgIconsIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.11 15h-2.36a1.75 1.75 0 0 1-1.75-1.75v-4.3a3.5 3.5 0 1 1 5.663-3.95h4.587c.966 0 1.75.784 1.75 1.75v6.5a1.75 1.75 0 0 1-.781 1.458l.679 1.164a.75.75 0 0 1-.648 1.128h-7a.75.75 0 0 1-.648-1.128l.509-.872Zm-1.61-6.5a2 2 0 1 0 0-4 2 2 0 0 0 0 4Zm0 1.5a3.5 3.5 0 0 0 3.5-3.5h4.25a.25.25 0 0 1 .25.25v6.5a.248.248 0 0 1-.047.146l-2.055-3.524a.75.75 0 0 0-1.296 0l-2.116 3.628h-3.236a.25.25 0 0 1-.25-.25v-3.395a3.5 3.5 0 0 0 1 .145Zm5.25 1.739 2.194 3.761h-4.388l2.194-3.761Z"
      }));
    };
    SvgIconsIcon.displayName = "IconsIcon";
    exports.SvgIconsIcon = SvgIconsIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/IdentityCardFilledIcon.svg.js
var require_IdentityCardFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/IdentityCardFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgIdentityCardFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.518 4h2.964c.813 0 1.469 0 2 .043.546.045 1.026.14 1.47.366a3.75 3.75 0 0 1 1.64 1.639c.226.444.32.924.365 1.47.043.531.043 1.187.043 2v.964c0 .813 0 1.469-.043 2-.045.546-.14 1.026-.366 1.47a3.75 3.75 0 0 1-1.639 1.64c-.444.226-.924.32-1.47.365-.531.043-1.187.043-2 .043h-2.964c-.813 0-1.469 0-2-.043-.546-.045-1.026-.14-1.47-.366a3.75 3.75 0 0 1-1.64-1.638c-.226-.445-.32-.925-.365-1.471-.043-.531-.043-1.187-.043-2v-.964c0-.813 0-1.469.043-2 .045-.546.14-1.026.366-1.47a3.75 3.75 0 0 1 1.639-1.64c.444-.226.924-.32 1.47-.365.531-.043 1.187-.043 2-.043Zm-2.643 5a2.125 2.125 0 1 1 4.25 0 2.125 2.125 0 0 1-4.25 0Zm-1.12 4.284c.018.035.037.073.058.111.217.367.534.665.916.86.197.1.458.17.912.207.443.036 1.007.038 1.804.038h3.961c.292 0 .45-.331.246-.54a6.503 6.503 0 0 0-7.709-1.196c-.192.102-.282.325-.187.52Zm6.995-2.284a.75.75 0 0 1 .75-.75h1.25a.75.75 0 0 1 0 1.5h-1.25a.75.75 0 0 1-.75-.75Zm.75-3a.75.75 0 0 0 0 1.5h1.25a.75.75 0 0 0 0-1.5h-1.25Z"
      }));
    };
    SvgIdentityCardFilledIcon.displayName = "IdentityCardFilledIcon";
    exports.SvgIdentityCardFilledIcon = SvgIdentityCardFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/IdentityCardIcon.svg.js
var require_IdentityCardIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/IdentityCardIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgIdentityCardIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.75 11a.75.75 0 0 1 .75-.75h1.25a.75.75 0 0 1 0 1.5h-1.25a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.5 8a.75.75 0 0 0 0 1.5h1.25a.75.75 0 0 0 0-1.5h-1.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8 11.5a2.5 2.5 0 1 0 0-5 2.5 2.5 0 0 0 0 5Zm0-1.5a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.518 4h2.964c.813 0 1.469 0 2 .043.546.045 1.026.14 1.47.366a3.75 3.75 0 0 1 1.64 1.639c.226.444.32.924.365 1.47.043.531.043 1.187.043 2v.964c0 .813 0 1.469-.043 2-.045.546-.14 1.026-.366 1.47a3.75 3.75 0 0 1-1.639 1.64c-.444.226-.924.32-1.47.365-.531.043-1.187.043-2 .043h-2.964c-.813 0-1.469 0-2-.043-.546-.045-1.026-.14-1.47-.366a3.75 3.75 0 0 1-1.64-1.638c-.226-.445-.32-.925-.365-1.471-.043-.531-.043-1.187-.043-2v-.964c0-.813 0-1.469.043-2 .045-.546.14-1.026.366-1.47a3.75 3.75 0 0 1 1.639-1.64c.444-.226.924-.32 1.47-.365.531-.043 1.187-.043 2-.043Zm-1.877 1.538c-.454.037-.715.107-.912.207a2.25 2.25 0 0 0-.984.984c-.1.197-.17.458-.207.912-.037.462-.038 1.057-.038 1.909v.9c0 .853 0 1.447.038 1.91.02.244.05.432.088.584a6.505 6.505 0 0 1 6.96.135 6.47 6.47 0 0 1 1.52 1.4c.09-.005.173-.01.253-.017.454-.037.715-.107.912-.207a2.25 2.25 0 0 0 .984-.984c.1-.197.17-.458.207-.912.037-.462.038-1.056.038-1.909v-.9c0-.852 0-1.447-.038-1.91-.037-.453-.107-.714-.207-.911a2.25 2.25 0 0 0-.984-.984c-.197-.1-.458-.17-.912-.207-.462-.037-1.056-.038-1.909-.038h-2.9c-.852 0-1.447 0-1.91.038Zm4.359 8.962a4.989 4.989 0 0 0-2.313-.953 4.999 4.999 0 0 0-3.147.6c.06.039.124.075.189.108.197.1.458.17.912.207.462.037 1.057.038 1.909.038h2.45Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8 8a1 1 0 1 0 0 2 1 1 0 0 0 0-2Zm-2.5 1a2.5 2.5 0 1 1 5 0 2.5 2.5 0 0 1-5 0Z"
      }));
    };
    SvgIdentityCardIcon.displayName = "IdentityCardIcon";
    exports.SvgIdentityCardIcon = SvgIdentityCardIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ImageAddIcon.svg.js
var require_ImageAddIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ImageAddIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgImageAddIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.018 3.5h1.964c.813 0 1.469 0 2 .043.546.045 1.026.14 1.47.366a3.75 3.75 0 0 1 1.64 1.639c.226.444.32.924.365 1.47.043.531.043 1.187.043 2v.232a.75.75 0 0 1-1.5 0v-.2c0-.852 0-1.447-.038-1.91-.037-.453-.107-.714-.207-.911a2.25 2.25 0 0 0-.984-.984c-.197-.1-.458-.17-.912-.207-.462-.037-1.056-.038-1.909-.038h-1.9c-.852 0-1.447 0-1.91.038-.453.037-.714.107-.911.207a2.25 2.25 0 0 0-.984.984c-.1.197-.17.458-.207.912-.037.462-.038 1.057-.038 1.909v1.39l1.013-1.013a1.75 1.75 0 0 1 2.474 0l2.763 2.762 1.47-1.47a.75.75 0 1 1 1.06 1.061l-2 2a.75.75 0 0 1-1.06 0l-3.293-3.293a.25.25 0 0 0-.354 0l-2.054 2.055c.005.113.011.218.02.317.036.454.106.715.206.912.216.424.56.768.984.984.197.1.458.17.912.207.462.037 1.057.038 1.909.038h1.2a.75.75 0 0 1 0 1.5h-1.232c-.813 0-1.469 0-2-.043-.546-.045-1.026-.14-1.47-.366a3.75 3.75 0 0 1-1.64-1.639c-.226-.444-.32-.924-.365-1.47a11.671 11.671 0 0 1-.03-.597.754.754 0 0 1-.006-.234c-.007-.348-.007-.736-.007-1.169v-1.964c0-.813 0-1.469.043-2 .045-.546.14-1.026.366-1.47a3.75 3.75 0 0 1 1.639-1.64c.444-.226.924-.32 1.47-.365.531-.043 1.187-.043 2-.043Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.5 9a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.75 11.25a.75.75 0 0 1 .75.75v1.75h1.75a.75.75 0 0 1 0 1.5h-1.75v1.75a.75.75 0 0 1-1.5 0v-1.75h-1.75a.75.75 0 0 1 0-1.5h1.75v-1.75a.75.75 0 0 1 .75-.75Z"
      }));
    };
    SvgImageAddIcon.displayName = "ImageAddIcon";
    exports.SvgImageAddIcon = SvgImageAddIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ImageAltIcon.svg.js
var require_ImageAltIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ImageAltIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgImageAltIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.678 6.929a.75.75 0 0 0-1.356 0l-2.25 4.75a.75.75 0 0 0 1.356.642l.389-.821h2.366l.39.821a.75.75 0 0 0 1.355-.642l-2.25-4.75Zm-.205 3.071-.473-.998-.473.998h.946Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.25 6.75a.75.75 0 0 1 .75.75v3.75h1.5a.75.75 0 0 1 0 1.5h-2.25a.75.75 0 0 1-.75-.75v-4.5a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13 6.75a.75.75 0 0 0 0 1.5h1v3.75a.75.75 0 0 0 1.5 0v-3.75h1a.75.75 0 0 0 0-1.5h-3.5Z"
      }));
    };
    SvgImageAltIcon.displayName = "ImageAltIcon";
    exports.SvgImageAltIcon = SvgImageAltIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ImageExploreIcon.svg.js
var require_ImageExploreIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ImageExploreIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgImageExploreIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.018 3.5h1.964c.813 0 1.469 0 2 .043.546.045 1.026.14 1.47.366a3.75 3.75 0 0 1 1.64 1.639c.226.444.32.924.365 1.47.043.531.043 1.187.043 2v.232a.75.75 0 0 1-1.5 0v-.2c0-.852 0-1.447-.038-1.91-.037-.453-.107-.714-.207-.911a2.25 2.25 0 0 0-.984-.984c-.197-.1-.458-.17-.912-.207-.462-.037-1.056-.038-1.909-.038h-1.9c-.852 0-1.447 0-1.91.038-.453.037-.714.107-.911.207a2.25 2.25 0 0 0-.984.984c-.1.197-.17.458-.207.912-.037.462-.038 1.057-.038 1.909v1.428l.723-.867a1.75 1.75 0 0 1 2.582-.117l1.225 1.226a.75.75 0 0 1-1.06 1.06l-1.226-1.225a.25.25 0 0 0-.369.016l-1.799 2.16a.746.746 0 0 1-.044.047l.006.081c.037.454.107.715.207.912.216.424.56.768.984.984.197.1.458.17.912.207.462.037 1.057.038 1.909.038h.2a.75.75 0 0 1 0 1.5h-.232c-.813 0-1.469 0-2-.043-.546-.045-1.026-.14-1.47-.366a3.75 3.75 0 0 1-1.64-1.639c-.226-.444-.32-.924-.365-1.47-.043-.531-.043-1.187-.043-2v-1.964c0-.813 0-1.469.043-2 .045-.546.14-1.026.366-1.47a3.75 3.75 0 0 1 1.639-1.64c.444-.226.924-.32 1.47-.365.531-.043 1.187-.043 2-.043Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.5 9a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10.25 13a2.75 2.75 0 1 1 5.152 1.34l1.128 1.13a.75.75 0 0 1-1.06 1.06l-1.13-1.129a2.75 2.75 0 0 1-4.09-2.402Zm2.75-1.25a1.25 1.25 0 1 0 0 2.5 1.25 1.25 0 0 0 0-2.5Z"
      }));
    };
    SvgImageExploreIcon.displayName = "ImageExploreIcon";
    exports.SvgImageExploreIcon = SvgImageExploreIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ImageIcon.svg.js
var require_ImageIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ImageIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgImageIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.5 9a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9.018 3.5h1.964c.813 0 1.469 0 2 .043.546.045 1.026.14 1.47.366a3.75 3.75 0 0 1 1.64 1.639c.226.444.32.924.365 1.47.043.531.043 1.187.043 2v1.964c0 .813 0 1.469-.043 2-.045.546-.14 1.026-.366 1.47a3.75 3.75 0 0 1-1.639 1.64c-.444.226-.924.32-1.47.365-.531.043-1.187.043-2 .043h-1.964c-.813 0-1.469 0-2-.043-.546-.045-1.026-.14-1.47-.366a3.75 3.75 0 0 1-1.64-1.639c-.226-.444-.32-.924-.365-1.47-.043-.531-.043-1.187-.043-2v-1.964c0-.813 0-1.469.043-2 .045-.546.14-1.026.366-1.47a3.75 3.75 0 0 1 1.639-1.64c.444-.226.924-.32 1.47-.365.531-.043 1.187-.043 2-.043Zm-1.877 1.538c-.454.037-.715.107-.912.207a2.25 2.25 0 0 0-.984.984c-.1.197-.17.458-.207.912-.037.462-.038 1.057-.038 1.909v1.428l.723-.867a1.75 1.75 0 0 1 2.582-.117l2.695 2.695 1.18-1.18a1.75 1.75 0 0 1 2.604.145l.216.27v-2.374c0-.852 0-1.447-.038-1.91-.037-.453-.107-.714-.207-.911a2.25 2.25 0 0 0-.984-.984c-.197-.1-.458-.17-.912-.207-.462-.037-1.056-.038-1.909-.038h-1.9c-.852 0-1.447 0-1.91.038Zm-2.103 7.821a7.12 7.12 0 0 1-.006-.08.746.746 0 0 0 .044-.049l1.8-2.159a.25.25 0 0 1 .368-.016l3.226 3.225a.75.75 0 0 0 1.06 0l1.71-1.71a.25.25 0 0 1 .372.021l1.213 1.516c-.021.06-.045.114-.07.165-.216.423-.56.767-.984.983-.197.1-.458.17-.912.207-.462.037-1.056.038-1.909.038h-1.9c-.852 0-1.447 0-1.91-.038-.453-.037-.714-.107-.911-.207a2.25 2.25 0 0 1-.984-.984c-.1-.197-.17-.458-.207-.912Z"
      }));
    };
    SvgImageIcon.displayName = "ImageIcon";
    exports.SvgImageIcon = SvgImageIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ImageWithTextOverlayIcon.svg.js
var require_ImageWithTextOverlayIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ImageWithTextOverlayIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgImageWithTextOverlayIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.018 3.5h1.964c.813 0 1.469 0 2 .043.546.045 1.026.14 1.47.366a3.75 3.75 0 0 1 1.64 1.639c.226.444.32.924.365 1.47.043.531.043 1.187.043 2v1.792a.75.75 0 0 1-1.5 0v-1.76c0-.852 0-1.447-.038-1.91-.037-.453-.107-.714-.207-.911a2.25 2.25 0 0 0-.984-.984c-.197-.1-.458-.17-.912-.207-.462-.037-1.056-.038-1.909-.038h-1.9c-.852 0-1.447 0-1.91.038-.453.037-.714.107-.911.207a2.25 2.25 0 0 0-.984.984c-.1.197-.17.458-.207.912-.037.462-.038 1.057-.038 1.909v1.428l.723-.867a1.75 1.75 0 0 1 2.582-.117l3.225 3.226a.75.75 0 0 1-1.06 1.06l-3.226-3.225a.25.25 0 0 0-.369.016l-1.799 2.16a.746.746 0 0 1-.044.047l.006.081c.037.454.107.715.207.912.216.424.56.768.984.984.197.1.458.17.912.207.462.037 1.057.038 1.909.038h1.68a.75.75 0 0 1 0 1.5h-1.712c-.813 0-1.469 0-2-.043-.546-.045-1.026-.14-1.47-.366a3.75 3.75 0 0 1-1.64-1.639c-.226-.444-.32-.924-.365-1.47-.043-.531-.043-1.187-.043-2v-1.964c0-.813 0-1.469.043-2 .045-.546.14-1.026.366-1.47a3.75 3.75 0 0 1 1.639-1.64c.444-.226.924-.32 1.47-.365.531-.043 1.187-.043 2-.043Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.5 9a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.5 13.25a.75.75 0 0 1 .75-.75h3.5a.75.75 0 0 1 0 1.5h-3.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.25 15a.75.75 0 0 0 0 1.5h2a.75.75 0 0 0 0-1.5h-2Z"
      }));
    };
    SvgImageWithTextOverlayIcon.displayName = "ImageWithTextOverlayIcon";
    exports.SvgImageWithTextOverlayIcon = SvgImageWithTextOverlayIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ImagesIcon.svg.js
var require_ImagesIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ImagesIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgImagesIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 10.25a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.01 6.01a2.75 2.75 0 0 1 2.74-2.51h5a2.75 2.75 0 0 1 2.75 2.75v5a2.75 2.75 0 0 1-2.51 2.74 2.75 2.75 0 0 1-2.74 2.51h-5a2.75 2.75 0 0 1-2.75-2.75v-5a2.75 2.75 0 0 1 2.51-2.74Zm-1.01 7.74v-.978l1.625-1.95a.25.25 0 0 1 .369-.017l3.226 3.225a.75.75 0 0 0 1.06 0l1.22-1.22v.94c0 .69-.56 1.25-1.25 1.25h-5c-.69 0-1.25-.56-1.25-1.25Zm7.5-5v1.94l-1.75 1.75-2.695-2.696a1.75 1.75 0 0 0-2.582.117l-.473.567v-1.678c0-.69.56-1.25 1.25-1.25h5c.69 0 1.25.56 1.25 1.25Zm-4.975-2.75h3.725a2.75 2.75 0 0 1 2.75 2.75v3.725c.57-.116 1-.62 1-1.225v-5c0-.69-.56-1.25-1.25-1.25h-5c-.605 0-1.11.43-1.225 1Z"
      }));
    };
    SvgImagesIcon.displayName = "ImagesIcon";
    exports.SvgImagesIcon = SvgImagesIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ImportIcon.svg.js
var require_ImportIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ImportIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgImportIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 4.25a.75.75 0 0 0-1.5 0v6.69l-1.72-1.72a.75.75 0 0 0-1.06 1.06l3 3a.75.75 0 0 0 1.06 0l3-3a.75.75 0 1 0-1.06-1.06l-1.72 1.72v-6.69Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.5 13.75a.75.75 0 0 0-1.5 0v.8a.75.75 0 0 1-.75.75h-8.5a.75.75 0 0 1-.75-.75v-.8a.75.75 0 0 0-1.5 0v.8a2.25 2.25 0 0 0 2.25 2.25h8.5a2.25 2.25 0 0 0 2.25-2.25v-.8Z"
      }));
    };
    SvgImportIcon.displayName = "ImportIcon";
    exports.SvgImportIcon = SvgImportIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/IncomingIcon.svg.js
var require_IncomingIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/IncomingIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgIncomingIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 10.25a.75.75 0 0 1 1.5 0v3.5c0 .69.56 1.25 1.25 1.25h7.5c.69 0 1.25-.56 1.25-1.25v-7.5c0-.69-.56-1.25-1.25-1.25h-3.5a.75.75 0 0 1 0-1.5h3.5a2.75 2.75 0 0 1 2.75 2.75v7.5a2.75 2.75 0 0 1-2.75 2.75h-7.5a2.75 2.75 0 0 1-2.75-2.75v-3.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.75 11.5a.75.75 0 0 1 0-1.5h2.19l-4.97-4.97a.75.75 0 0 1 1.06-1.06l4.97 4.97v-2.19a.75.75 0 0 1 1.5 0v4a.75.75 0 0 1-.75.75h-4Z"
      }));
    };
    SvgIncomingIcon.displayName = "IncomingIcon";
    exports.SvgIncomingIcon = SvgIncomingIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/InfoIcon.svg.js
var require_InfoIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/InfoIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgInfoIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 14a.75.75 0 0 1-.75-.75v-3.5a.75.75 0 0 1 1.5 0v3.5a.75.75 0 0 1-.75.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9 7a1 1 0 1 1 2 0 1 1 0 0 1-2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-1.5 0a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Z"
      }));
    };
    SvgInfoIcon.displayName = "InfoIcon";
    exports.SvgInfoIcon = SvgInfoIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/InventoryFilledIcon.svg.js
var require_InventoryFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/InventoryFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgInventoryFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.77 3.406a2.25 2.25 0 0 1 2.46 0l3.569 2.328a3.75 3.75 0 0 1 1.701 3.141v6.875c0 .69-.56 1.25-1.25 1.25h-10.5c-.69 0-1.25-.56-1.25-1.25v-6.875a3.75 3.75 0 0 1 1.702-3.141l3.569-2.328Zm.73 9.844a.5.5 0 0 0-.5-.5h-1.5a.5.5 0 0 0-.5.5v2a.5.5 0 0 0 .5.5h1.5a.5.5 0 0 0 .5-.5v-2Zm1.25-4.5a.5.5 0 0 1 .5.5v2a.5.5 0 0 1-.5.5h-1.5a.5.5 0 0 1-.5-.5v-2a.5.5 0 0 1 .5-.5h1.5Zm2.25 4.5a.5.5 0 0 0-.5-.5h-1.5a.5.5 0 0 0-.5.5v2a.5.5 0 0 0 .5.5h1.5a.5.5 0 0 0 .5-.5v-2Z"
      }));
    };
    SvgInventoryFilledIcon.displayName = "InventoryFilledIcon";
    exports.SvgInventoryFilledIcon = SvgInventoryFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/InventoryIcon.svg.js
var require_InventoryIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/InventoryIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgInventoryIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.265 2.952a2.25 2.25 0 0 0-2.53 0l-4.094 2.783a3.75 3.75 0 0 0-1.641 3.101v7.413a.75.75 0 0 0 1.5 0v-7.413c0-.745.369-1.441.985-1.86l4.093-2.784a.75.75 0 0 1 .844 0l4.093 2.784a2.25 2.25 0 0 1 .985 1.86v7.413a.75.75 0 0 0 1.5 0v-7.413a3.75 3.75 0 0 0-1.641-3.1l-4.094-2.784Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 16.968a1 1 0 0 1-.25.031h-3a1 1 0 0 1-1-1v-3.5a1 1 0 0 1 1-1h.75v-3a1 1 0 0 1 1-1h3a1 1 0 0 1 1 1v3h.75a1 1 0 0 1 1 1v3.5a1 1 0 0 1-1 1h-3a1 1 0 0 1-.25-.031Zm.75-3.969v2.5h2v-2.5h-2Zm-1.5 2.5v-2.5h-2v2.5h2Zm1.75-4v-2.5h-2v2.5h2Z"
      }));
    };
    SvgInventoryIcon.displayName = "InventoryIcon";
    exports.SvgInventoryIcon = SvgInventoryIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/InventoryUpdatedIcon.svg.js
var require_InventoryUpdatedIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/InventoryUpdatedIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgInventoryUpdatedIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.265 2.952a2.25 2.25 0 0 0-2.53 0l-4.094 2.783a3.75 3.75 0 0 0-1.641 3.101v7.413a.75.75 0 0 0 1.5 0v-7.413c0-.745.369-1.441.985-1.86l4.093-2.784a.75.75 0 0 1 .844 0l4.093 2.784a2.25 2.25 0 0 1 .985 1.86v7.413a.75.75 0 0 0 1.5 0v-7.413a3.75 3.75 0 0 0-1.641-3.1l-4.094-2.784Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.28 10.28a.75.75 0 0 0-1.06-1.061l-2.97 2.97-1.22-1.22a.75.75 0 1 0-1.06 1.06l1.75 1.75a.75.75 0 0 0 1.06 0l3.5-3.5Z"
      }));
    };
    SvgInventoryUpdatedIcon.displayName = "InventoryUpdatedIcon";
    exports.SvgInventoryUpdatedIcon = SvgInventoryUpdatedIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/IqIcon.svg.js
var require_IqIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/IqIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgIqIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.5 5.25a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10.128 12.5h-2.128a4.5 4.5 0 0 1-4.5-4.5v-.25a4.25 4.25 0 0 1 4.25-4.25h4a.75.75 0 0 1 0 1.5h-4a2.75 2.75 0 0 0-2.75 2.75v.25a3 3 0 0 0 3 3h2.128a2.251 2.251 0 1 1 0 1.5Zm1.372-.75a.75.75 0 1 1 1.5 0 .75.75 0 0 1-1.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12.25 16.25a4.5 4.5 0 1 0 0-9h-2.128a2.251 2.251 0 1 0 0 1.5h2.128a3 3 0 1 1 0 6h-3.75a.75.75 0 0 0 0 1.5h3.75Zm-4.25-9a.75.75 0 1 1 0 1.5.75.75 0 0 1 0-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.75 15.5a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }));
    };
    SvgIqIcon.displayName = "IqIcon";
    exports.SvgIqIcon = SvgIqIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/KeyIcon.svg.js
var require_KeyIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/KeyIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgKeyIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 7.75a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.85 2.75a4.35 4.35 0 0 0-4.35 4.35 3.401 3.401 0 0 0 2.5 3.28v3.435a2 2 0 0 0 .481 1.302l1.07 1.247a2 2 0 0 0 2.746.277l1.309-1.018a2.002 2.002 0 0 0 .376-2.776 2.004 2.004 0 0 0 .002-2.463 3.401 3.401 0 0 0 2.516-3.284 4.35 4.35 0 0 0-4.35-4.35h-2.3Zm2.835 11.69a.5.5 0 0 0-.042-.82l-.637-.397a.5.5 0 0 1 .041-.872l.582-.29a.5.5 0 0 0 .13-.802l-.613-.613a.5.5 0 0 1-.146-.353v-.793a.5.5 0 0 1 .5-.5h.6a1.9 1.9 0 0 0 1.9-1.9 2.85 2.85 0 0 0-2.85-2.85h-2.3a2.85 2.85 0 0 0-2.85 2.85c0 1.05.85 1.9 1.9 1.9h.1a.5.5 0 0 1 .5.5v4.315a.5.5 0 0 0 .12.325l1.07 1.248a.5.5 0 0 0 .686.07l1.31-1.019Z"
      }));
    };
    SvgKeyIcon.displayName = "KeyIcon";
    exports.SvgKeyIcon = SvgKeyIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/KeyboardHideIcon.svg.js
var require_KeyboardHideIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/KeyboardHideIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgKeyboardHideIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "m4.24 12.487-1.043 1.044a.81.81 0 0 0-.022.023 2.74 2.74 0 0 1-.675-1.804v-3.5a2.75 2.75 0 0 1 2.75-2.75h5.978l-1.5 1.5h-4.478c-.69 0-1.25.56-1.25 1.25v3.5c0 .276.09.53.24.737Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "m8.728 8-1.127 1.127a.75.75 0 0 1 .649-1.127h.478Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.5 11.25a.75.75 0 0 1 .75-.75h.5a.75.75 0 0 1 0 1.5h-.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.25 8a.75.75 0 0 0 0 1.5h.5a.75.75 0 0 0 0-1.5h-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M14.598 4.25a.276.276 0 0 1-.006.007l-10.335 10.335-.006.006a.75.75 0 0 0 1.066 1.055l1.154-1.153h8.279a2.75 2.75 0 0 0 2.75-2.75v-3.5a2.751 2.751 0 0 0-2.105-2.674l.258-.259a.75.75 0 0 0-1.055-1.066Zm.152 8.75h-6.78l1-1h2.28a.75.75 0 0 0 0-1.5h-.78l1-1h.28a.75.75 0 0 0 .71-.99l1.51-1.51h.78c.69 0 1.25.56 1.25 1.25v3.5c0 .69-.56 1.25-1.25 1.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.25 8a.75.75 0 1 0 0 1.5h.5a.75.75 0 0 0 0-1.5h-.5Z"
      }));
    };
    SvgKeyboardHideIcon.displayName = "KeyboardHideIcon";
    exports.SvgKeyboardHideIcon = SvgKeyboardHideIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/KeyboardIcon.svg.js
var require_KeyboardIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/KeyboardIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgKeyboardIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.75 10.5a.75.75 0 0 0 0 1.5h2.5a.75.75 0 0 0 0-1.5h-2.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.5 11.25a.75.75 0 0 1 .75-.75h.5a.75.75 0 0 1 0 1.5h-.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.25 10.5a.75.75 0 0 0 0 1.5h.5a.75.75 0 0 0 0-1.5h-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.5 8.75a.75.75 0 0 1 .75-.75h.5a.75.75 0 0 1 0 1.5h-.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.25 8a.75.75 0 0 0 0 1.5h.5a.75.75 0 0 0 0-1.5h-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.5 8.75a.75.75 0 0 1 .75-.75h.5a.75.75 0 0 1 0 1.5h-.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.25 8a.75.75 0 0 0 0 1.5h.5a.75.75 0 0 0 0-1.5h-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.25 5.5a2.75 2.75 0 0 0-2.75 2.75v3.5a2.75 2.75 0 0 0 2.75 2.75h9.5a2.75 2.75 0 0 0 2.75-2.75v-3.5a2.75 2.75 0 0 0-2.75-2.75h-9.5Zm-1.25 2.75c0-.69.56-1.25 1.25-1.25h9.5c.69 0 1.25.56 1.25 1.25v3.5c0 .69-.56 1.25-1.25 1.25h-9.5c-.69 0-1.25-.56-1.25-1.25v-3.5Z"
      }));
    };
    SvgKeyboardIcon.displayName = "KeyboardIcon";
    exports.SvgKeyboardIcon = SvgKeyboardIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LabelPrinterIcon.svg.js
var require_LabelPrinterIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LabelPrinterIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLabelPrinterIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M14 6.5a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.75 5.75a.75.75 0 0 0 0 1.5h3a.75.75 0 0 0 0-1.5h-3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.5 13.5a.75.75 0 0 1 .75-.75h1.5a.75.75 0 0 1 0 1.5h-1.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.25 10.25a.75.75 0 0 0 0 1.5h1.5a.75.75 0 0 0 0-1.5h-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M14 13.989v.511a2 2 0 0 1-2 2h-4a2 2 0 0 1-2-2v-.511a2.75 2.75 0 0 1-2.5-2.739v-5a2.75 2.75 0 0 1 2.75-2.75h7.5a2.75 2.75 0 0 1 2.75 2.75v5a2.75 2.75 0 0 1-2.5 2.739Zm-7.75-8.989c-.69 0-1.25.56-1.25 1.25v5c0 .605.43 1.11 1 1.225v-2.475a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v2.475c.57-.116 1-.62 1-1.225v-5c0-.69-.56-1.25-1.25-1.25h-7.5Zm1.75 4.5h4a.5.5 0 0 1 .5.5v4.5a.5.5 0 0 1-.5.5h-4a.5.5 0 0 1-.5-.5v-4.5a.5.5 0 0 1 .5-.5Z"
      }));
    };
    SvgLabelPrinterIcon.displayName = "LabelPrinterIcon";
    exports.SvgLabelPrinterIcon = SvgLabelPrinterIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LanguageFilledIcon.svg.js
var require_LanguageFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LanguageFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLanguageFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "m7.744 9.625-.744-2.046-.744 2.046h1.488Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.712 10.656c.301-.354.519-.737.679-1.109a5.454 5.454 0 0 0 .388-1.422h-2.134l.021.143c.054.339.16.798.368 1.28.16.37.377.754.678 1.108Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10.518 15.5h3.982a3.25 3.25 0 0 0 3.25-3.25v-6a3.25 3.25 0 0 0-3.25-3.25h-9a3.25 3.25 0 0 0-3.25 3.25v6a3.25 3.25 0 0 0 3.25 3.25h1.25v.75a1.25 1.25 0 0 0 2.134.884l1.634-1.634Zm-2.93-9.964a.625.625 0 0 0-1.175 0l-2 5.5a.625.625 0 0 0 1.174.428l.225-.618c.06.019.122.029.188.029h2.199l.214.589a.625.625 0 0 0 1.174-.428l-2-5.5Zm5.162-.161a.625.625 0 0 0-.625.625v.875h-1.875a.625.625 0 1 0 0 1.25h.136a6.711 6.711 0 0 0 .499 1.916c.202.47.484.964.874 1.423a4.399 4.399 0 0 1-1.166.481.625.625 0 1 0 .314 1.21 5.517 5.517 0 0 0 1.805-.82 5.518 5.518 0 0 0 1.805.82.625.625 0 1 0 .314-1.21 4.399 4.399 0 0 1-1.166-.48c.39-.46.672-.954.874-1.424a6.708 6.708 0 0 0 .499-1.916h.212a.625.625 0 1 0 0-1.25h-1.875v-.875a.625.625 0 0 0-.625-.625Z"
      }));
    };
    SvgLanguageFilledIcon.displayName = "LanguageFilledIcon";
    exports.SvgLanguageFilledIcon = SvgLanguageFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LanguageIcon.svg.js
var require_LanguageIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LanguageIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLanguageIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.705 5.494a.75.75 0 0 0-1.41 0l-2 5.5a.75.75 0 1 0 1.41.512l.187-.514a.743.743 0 0 0 .108.008h2.111l.184.506a.75.75 0 1 0 1.41-.512l-2-5.5Zm-.705 2.45.566 1.556h-1.132l.566-1.555Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15.25 8.25h-.1a6.831 6.831 0 0 1-.495 1.84 5.808 5.808 0 0 1-.795 1.334c.295.164.631.3 1.016.4a.75.75 0 0 1-.377 1.452 5.665 5.665 0 0 1-1.78-.793 5.666 5.666 0 0 1-1.78.793.75.75 0 1 1-.377-1.452c.385-.1.721-.236 1.016-.4a5.808 5.808 0 0 1-.794-1.334 6.831 6.831 0 0 1-.496-1.84h-.038a.75.75 0 1 1 0-1.5h1.75v-.75a.75.75 0 0 1 1.5 0v.75h1.75a.75.75 0 0 1 0 1.5Zm-3.447 0c.053.331.157.779.359 1.248.136.318.316.644.557.952.24-.308.42-.634.557-.952a5.38 5.38 0 0 0 .359-1.248h-1.832Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M14.5 15.75h-3.879l-1.56 1.56a1.5 1.5 0 0 1-2.561-1.06v-.5h-1a3.5 3.5 0 0 1-3.5-3.5v-6a3.5 3.5 0 0 1 3.5-3.5h9a3.5 3.5 0 0 1 3.5 3.5v6a3.5 3.5 0 0 1-3.5 3.5Zm-6.5.5 2-2h4.5a2 2 0 0 0 2-2v-6a2 2 0 0 0-2-2h-9a2 2 0 0 0-2 2v6a2 2 0 0 0 2 2h2.5v2Z"
      }));
    };
    SvgLanguageIcon.displayName = "LanguageIcon";
    exports.SvgLanguageIcon = SvgLanguageIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LanguageTranslateIcon.svg.js
var require_LanguageTranslateIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LanguageTranslateIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLanguageTranslateIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.955 3.994a.75.75 0 0 0-1.41 0l-2 5.5a.75.75 0 1 0 1.41.512l.187-.514a.756.756 0 0 0 .108.008h2.111l.184.506a.75.75 0 1 0 1.41-.512l-2-5.5Zm-.705 2.45.566 1.556h-1.132l.566-1.555Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.55 7.75v-1a.25.25 0 0 0-.25-.25h-1.49l.22.22a.75.75 0 1 1-1.06 1.06l-1.5-1.5a.75.75 0 0 1 0-1.06l1.5-1.5a.75.75 0 0 1 1.06 1.06l-.22.22h1.49c.966 0 1.75.783 1.75 1.75v1a.75.75 0 1 1-1.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.5 12.25v1c0 .138.112.25.25.25h1.49l-.22-.22a.75.75 0 1 1 1.06-1.06l1.5 1.5a.75.75 0 0 1 0 1.06l-1.5 1.5a.75.75 0 0 1-1.06-1.06l.22-.22h-1.49a1.75 1.75 0 0 1-1.75-1.75v-1a.75.75 0 1 1 1.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11.002 11.5h-.252a.75.75 0 0 1 0-1.5h1.75v-.25a.75.75 0 0 1 1.5 0v.25h1.75a.75.75 0 0 1 0 1.5h-.312a5.877 5.877 0 0 1-.4 1.945 5.13 5.13 0 0 1-.69 1.227c.293.161.634.3 1.03.402a.75.75 0 0 1-.376 1.452 5.676 5.676 0 0 1-1.782-.788 5.677 5.677 0 0 1-1.782.788.75.75 0 1 1-.376-1.452c.396-.103.737-.24 1.03-.402a5.115 5.115 0 0 1-.69-1.227 5.88 5.88 0 0 1-.4-1.945Zm2.935 0h-1.434a4.381 4.381 0 0 0 .295 1.394c.101.257.237.524.422.782.185-.258.32-.525.422-.782a4.386 4.386 0 0 0 .295-1.394Z"
      }));
    };
    SvgLanguageTranslateIcon.displayName = "LanguageTranslateIcon";
    exports.SvgLanguageTranslateIcon = SvgLanguageTranslateIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutBlockIcon.svg.js
var require_LayoutBlockIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutBlockIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLayoutBlockIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M5 6.25c0-.69.56-1.25 1.25-1.25h2a.75.75 0 0 0 0-1.5h-2a2.75 2.75 0 0 0-2.75 2.75v2a.75.75 0 0 0 1.5 0v-2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.75 5c.69 0 1.25.56 1.25 1.25v2a.75.75 0 0 0 1.5 0v-2a2.75 2.75 0 0 0-2.75-2.75h-2a.75.75 0 0 0 0 1.5h2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.75 15c.69 0 1.25-.56 1.25-1.25v-2a.75.75 0 0 1 1.5 0v2a2.75 2.75 0 0 1-2.75 2.75h-2a.75.75 0 0 1 0-1.5h2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.25 15c-.69 0-1.25-.56-1.25-1.25v-2a.75.75 0 0 0-1.5 0v2a2.75 2.75 0 0 0 2.75 2.75h2a.75.75 0 0 0 0-1.5h-2Z"
      }));
    };
    SvgLayoutBlockIcon.displayName = "LayoutBlockIcon";
    exports.SvgLayoutBlockIcon = SvgLayoutBlockIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutBuyButtonHorizontalIcon.svg.js
var require_LayoutBuyButtonHorizontalIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutBuyButtonHorizontalIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLayoutBuyButtonHorizontalIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 5.25c0-.966.784-1.75 1.75-1.75h1a.75.75 0 0 1 0 1.5h-1a.25.25 0 0 0-.25.25v1a.75.75 0 0 1-1.5 0v-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.5 7a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h2a2 2 0 0 0 2-2v-2a2 2 0 0 0-2-2h-2Zm2 1.5h-2a.5.5 0 0 0-.5.5v2a.5.5 0 0 0 .5.5h2a.5.5 0 0 0 .5-.5v-2a.5.5 0 0 0-.5-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 8.5a.75.75 0 0 1 .75-.75h3a.75.75 0 0 1 0 1.5h-3a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.75 10.75a.75.75 0 0 0 0 1.5h1.5a.75.75 0 0 0 0-1.5h-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 14.75c0 .966.784 1.75 1.75 1.75h1a.75.75 0 0 0 0-1.5h-1a.25.25 0 0 1-.25-.25v-1a.75.75 0 0 0-1.5 0v1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.75 3.5c.966 0 1.75.784 1.75 1.75v1a.75.75 0 0 1-1.5 0v-1a.25.25 0 0 0-.25-.25h-1a.75.75 0 0 1 0-1.5h1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.75 16.5a1.75 1.75 0 0 0 1.75-1.75v-1a.75.75 0 0 0-1.5 0v1a.25.25 0 0 1-.25.25h-1a.75.75 0 0 0 0 1.5h1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.75 4.25a.75.75 0 0 1-.75.75h-2a.75.75 0 0 1 0-1.5h2a.75.75 0 0 1 .75.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 16.5a.75.75 0 0 0 0-1.5h-2a.75.75 0 0 0 0 1.5h2Z"
      }));
    };
    SvgLayoutBuyButtonHorizontalIcon.displayName = "LayoutBuyButtonHorizontalIcon";
    exports.SvgLayoutBuyButtonHorizontalIcon = SvgLayoutBuyButtonHorizontalIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutBuyButtonIcon.svg.js
var require_LayoutBuyButtonIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutBuyButtonIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLayoutBuyButtonIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 5.25c0-.966.784-1.75 1.75-1.75h1a.75.75 0 0 1 0 1.5h-1a.25.25 0 0 0-.25.25v1a.75.75 0 0 1-1.5 0v-1Zm1.75 11.25a1.75 1.75 0 0 1-1.75-1.75v-1a.75.75 0 0 1 1.5 0v1c0 .138.112.25.25.25h1a.75.75 0 0 1 0 1.5h-1Zm11.25-11.25a1.75 1.75 0 0 0-1.75-1.75h-1a.75.75 0 0 0 0 1.5h1a.25.25 0 0 1 .25.25v1a.75.75 0 0 0 1.5 0v-1Zm0 9.5a1.75 1.75 0 0 1-1.75 1.75h-1a.75.75 0 0 1 0-1.5h1a.25.25 0 0 0 .25-.25v-1a.75.75 0 0 1 1.5 0v1Zm-5.5-9.75a.75.75 0 0 0 0-1.5h-2a.75.75 0 0 0 0 1.5h2Zm.75 10.75a.75.75 0 0 1-.75.75h-2a.75.75 0 0 1 0-1.5h2a.75.75 0 0 1 .75.75Zm-5.75-8.25a2.5 2.5 0 0 0 0 5h8a2.5 2.5 0 0 0 0-5h-8Zm-1 2.5a1 1 0 0 1 1-1h8a1 1 0 1 1 0 2h-8a1 1 0 0 1-1-1Z"
      }));
    };
    SvgLayoutBuyButtonIcon.displayName = "LayoutBuyButtonIcon";
    exports.SvgLayoutBuyButtonIcon = SvgLayoutBuyButtonIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutBuyButtonVerticalIcon.svg.js
var require_LayoutBuyButtonVerticalIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutBuyButtonVerticalIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLayoutBuyButtonVerticalIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.25 3.5a1.75 1.75 0 0 0-1.75 1.75v1a.75.75 0 0 0 1.5 0v-1a.25.25 0 0 1 .25-.25h1a.75.75 0 0 0 0-1.5h-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.5 5.25a1.75 1.75 0 0 0-1.75-1.75h-1a.75.75 0 0 0 0 1.5h1a.25.25 0 0 1 .25.25v1a.75.75 0 0 0 1.5 0v-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.5 14.75a1.75 1.75 0 0 1-1.75 1.75h-1a.75.75 0 0 1 0-1.5h1a.25.25 0 0 0 .25-.25v-1a.75.75 0 0 1 1.5 0v1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 14.75c0 .966.784 1.75 1.75 1.75h1a.75.75 0 0 0 0-1.5h-1a.25.25 0 0 1-.25-.25v-1a.75.75 0 0 0-1.5 0v1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.75 11.75a.75.75 0 0 1-.75-.75v-2a.75.75 0 0 1 1.5 0v2a.75.75 0 0 1-.75.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 11a.75.75 0 0 0 1.5 0v-2a.75.75 0 0 0-1.5 0v2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9 5.5a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h2a2 2 0 0 0 2-2v-2a2 2 0 0 0-2-2h-2Zm2 1.5h-2a.5.5 0 0 0-.5.5v2a.5.5 0 0 0 .5.5h2a.5.5 0 0 0 .5-.5v-2a.5.5 0 0 0-.5-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.75 13a.75.75 0 0 0 0 1.5h4.5a.75.75 0 0 0 0-1.5h-4.5Z"
      }));
    };
    SvgLayoutBuyButtonVerticalIcon.displayName = "LayoutBuyButtonVerticalIcon";
    exports.SvgLayoutBuyButtonVerticalIcon = SvgLayoutBuyButtonVerticalIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutColumn1Icon.svg.js
var require_LayoutColumn1Icon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutColumn1Icon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLayoutColumn1Icon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13 4.5h-6a1.5 1.5 0 0 0-1.5 1.5v8a1.5 1.5 0 0 0 1.5 1.5h6a1.5 1.5 0 0 0 1.5-1.5v-8a1.5 1.5 0 0 0-1.5-1.5Zm-6-1.5a3 3 0 0 0-3 3v8a3 3 0 0 0 3 3h6a3 3 0 0 0 3-3v-8a3 3 0 0 0-3-3h-6Z"
      }));
    };
    SvgLayoutColumn1Icon.displayName = "LayoutColumn1Icon";
    exports.SvgLayoutColumn1Icon = SvgLayoutColumn1Icon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutColumns2Icon.svg.js
var require_LayoutColumns2Icon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutColumns2Icon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLayoutColumns2Icon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3 6a3 3 0 0 1 3-3h8a3 3 0 0 1 3 3v8a3 3 0 0 1-3 3h-8a3 3 0 0 1-3-3v-8Zm7.75-1.5h3.25a1.5 1.5 0 0 1 1.5 1.5v8a1.5 1.5 0 0 1-1.5 1.5h-3.25v-11Zm-1.5 0h-3.25a1.5 1.5 0 0 0-1.5 1.5v8a1.5 1.5 0 0 0 1.5 1.5h3.25v-11Z"
      }));
    };
    SvgLayoutColumns2Icon.displayName = "LayoutColumns2Icon";
    exports.SvgLayoutColumns2Icon = SvgLayoutColumns2Icon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutColumns3Icon.svg.js
var require_LayoutColumns3Icon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutColumns3Icon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLayoutColumns3Icon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6 3a3 3 0 0 0-3 3v8a3 3 0 0 0 3 3h8a3 3 0 0 0 3-3v-8a3 3 0 0 0-3-3h-8Zm5.25 1.5h-2.5v11h2.5v-11Zm1.5 0v11h1.25a1.5 1.5 0 0 0 1.5-1.5v-8a1.5 1.5 0 0 0-1.5-1.5h-1.25Zm-6.75 0h1.25v11h-1.25a1.5 1.5 0 0 1-1.5-1.5v-8a1.5 1.5 0 0 1 1.5-1.5Z"
      }));
    };
    SvgLayoutColumns3Icon.displayName = "LayoutColumns3Icon";
    exports.SvgLayoutColumns3Icon = SvgLayoutColumns3Icon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutFooterIcon.svg.js
var require_LayoutFooterIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutFooterIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLayoutFooterIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 5.25c0-.966.784-1.75 1.75-1.75h.5a.75.75 0 0 1 0 1.5h-.5a.25.25 0 0 0-.25.25v.5a.75.75 0 0 1-1.5 0v-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 13.25c0-.966.784-1.75 1.75-1.75h9.5c.966 0 1.75.784 1.75 1.75v1.5a1.75 1.75 0 0 1-1.75 1.75h-9.5a1.75 1.75 0 0 1-1.75-1.75v-1.5Zm1.75-.25a.25.25 0 0 0-.25.25v1.5c0 .138.112.25.25.25h9.5a.25.25 0 0 0 .25-.25v-1.5a.25.25 0 0 0-.25-.25h-9.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 8.75c0 .966.784 1.75 1.75 1.75h.5a.75.75 0 0 0 0-1.5h-.5a.25.25 0 0 1-.25-.25v-.5a.75.75 0 0 0-1.5 0v.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.75 3.5c.966 0 1.75.784 1.75 1.75v.5a.75.75 0 0 1-1.5 0v-.5a.25.25 0 0 0-.25-.25h-.5a.75.75 0 0 1 0-1.5h.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.75 10.5a1.75 1.75 0 0 0 1.75-1.75v-.5a.75.75 0 0 0-1.5 0v.5a.25.25 0 0 1-.25.25h-.5a.75.75 0 0 0 0 1.5h.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.75 4.25a.75.75 0 0 1-.75.75h-2a.75.75 0 0 1 0-1.5h2a.75.75 0 0 1 .75.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 10.5a.75.75 0 0 0 0-1.5h-2a.75.75 0 0 0 0 1.5h2Z"
      }));
    };
    SvgLayoutFooterIcon.displayName = "LayoutFooterIcon";
    exports.SvgLayoutFooterIcon = SvgLayoutFooterIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutHeaderIcon.svg.js
var require_LayoutHeaderIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutHeaderIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLayoutHeaderIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 5.25c0-.966.784-1.75 1.75-1.75h9.5c.966 0 1.75.784 1.75 1.75v1.5a1.75 1.75 0 0 1-1.75 1.75h-9.5a1.75 1.75 0 0 1-1.75-1.75v-1.5Zm1.75-.25a.25.25 0 0 0-.25.25v1.5c0 .138.112.25.25.25h9.5a.25.25 0 0 0 .25-.25v-1.5a.25.25 0 0 0-.25-.25h-9.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 11.25c0-.966.784-1.75 1.75-1.75h.5a.75.75 0 0 1 0 1.5h-.5a.25.25 0 0 0-.25.25v.5a.75.75 0 0 1-1.5 0v-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 14.75c0 .966.784 1.75 1.75 1.75h.5a.75.75 0 0 0 0-1.5h-.5a.25.25 0 0 1-.25-.25v-.5a.75.75 0 0 0-1.5 0v.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.75 9.5c.966 0 1.75.784 1.75 1.75v.5a.75.75 0 0 1-1.5 0v-.5a.25.25 0 0 0-.25-.25h-.5a.75.75 0 0 1 0-1.5h.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.75 16.5a1.75 1.75 0 0 0 1.75-1.75v-.5a.75.75 0 0 0-1.5 0v.5a.25.25 0 0 1-.25.25h-.5a.75.75 0 0 0 0 1.5h.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.75 10.25a.75.75 0 0 1-.75.75h-2a.75.75 0 0 1 0-1.5h2a.75.75 0 0 1 .75.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 16.5a.75.75 0 0 0 0-1.5h-2a.75.75 0 0 0 0 1.5h2Z"
      }));
    };
    SvgLayoutHeaderIcon.displayName = "LayoutHeaderIcon";
    exports.SvgLayoutHeaderIcon = SvgLayoutHeaderIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutLogoBlockIcon.svg.js
var require_LayoutLogoBlockIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutLogoBlockIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLayoutLogoBlockIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 6.25a2.75 2.75 0 0 1 2.75-2.75.75.75 0 0 1 0 1.5c-.69 0-1.25.56-1.25 1.25a.75.75 0 0 1-1.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.25 16.5a2.75 2.75 0 0 1-2.75-2.75.75.75 0 0 1 1.5 0c0 .69.56 1.25 1.25 1.25a.75.75 0 0 1 0 1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.5 6.25a2.75 2.75 0 0 0-2.75-2.75.75.75 0 0 0 0 1.5c.69 0 1.25.56 1.25 1.25a.75.75 0 0 0 1.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.5 13.75a2.75 2.75 0 0 1-2.75 2.75.75.75 0 0 1 0-1.5c.69 0 1.25-.56 1.25-1.25a.75.75 0 0 1 1.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5 9a.75.75 0 0 0-1.5 0v2a.75.75 0 0 0 1.5 0v-2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.75 8.25a.75.75 0 0 1 .75.75v2a.75.75 0 0 1-1.5 0v-2a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 5a.75.75 0 0 0 0-1.5h-2a.75.75 0 0 0 0 1.5h2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.75 15.75a.75.75 0 0 1-.75.75h-2a.75.75 0 0 1 0-1.5h2a.75.75 0 0 1 .75.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6 9a3 3 0 0 1 3-3h2a3 3 0 0 1 3 3v2a3 3 0 0 1-3 3h-2a3 3 0 0 1-3-3v-2Zm3-1.5h2a1.5 1.5 0 0 1 1.5 1.5v2a1.5 1.5 0 0 1-1.5 1.5h-2a1.5 1.5 0 0 1-1.5-1.5v-2a1.5 1.5 0 0 1 1.5-1.5Z"
      }));
    };
    SvgLayoutLogoBlockIcon.displayName = "LayoutLogoBlockIcon";
    exports.SvgLayoutLogoBlockIcon = SvgLayoutLogoBlockIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutPopupIcon.svg.js
var require_LayoutPopupIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutPopupIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLayoutPopupIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.25 3.5a1.75 1.75 0 0 0-1.75 1.75v1.5a.75.75 0 0 0 1.5 0v-1.5a.25.25 0 0 1 .25-.25h1.5a.75.75 0 0 0 0-1.5h-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11.25 3.5a2.75 2.75 0 0 0-2.75 2.75v2.5a2.75 2.75 0 0 0 2.75 2.75h2.5a2.75 2.75 0 0 0 2.75-2.75v-2.5a2.75 2.75 0 0 0-2.75-2.75h-2.5Zm-1.25 2.75c0-.69.56-1.25 1.25-1.25h2.5c.69 0 1.25.56 1.25 1.25v2.5c0 .69-.56 1.25-1.25 1.25h-2.5c-.69 0-1.25-.56-1.25-1.25v-2.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.25 12.5a.75.75 0 0 1 .75.75v1.5c0 .138.112.25.25.25h1.5a.75.75 0 0 1 0 1.5h-1.5a1.75 1.75 0 0 1-1.75-1.75v-1.5a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.5 13.25a.75.75 0 0 0-1.5 0v1.5a.25.25 0 0 1-.25.25h-1.5a.75.75 0 0 0 0 1.5h1.5a1.75 1.75 0 0 0 1.75-1.75v-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.25 8.25a.75.75 0 0 1 .75.75v2a.75.75 0 0 1-1.5 0v-2a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9 15a.75.75 0 0 0 0 1.5h2a.75.75 0 0 0 0-1.5h-2Z"
      }));
    };
    SvgLayoutPopupIcon.displayName = "LayoutPopupIcon";
    exports.SvgLayoutPopupIcon = SvgLayoutPopupIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutRows2Icon.svg.js
var require_LayoutRows2Icon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutRows2Icon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLayoutRows2Icon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.25 3.5a3.75 3.75 0 0 0-3.75 3.75v5.5a3.75 3.75 0 0 0 3.75 3.75h5.5a3.75 3.75 0 0 0 3.75-3.75v-5.5a3.75 3.75 0 0 0-3.75-3.75h-5.5Zm-2.25 7.25v2a2.25 2.25 0 0 0 2.25 2.25h5.5a2.25 2.25 0 0 0 2.25-2.25v-2h-10Zm10-1.5v-2a2.25 2.25 0 0 0-2.25-2.25h-5.5a2.25 2.25 0 0 0-2.25 2.25v2h10Z"
      }));
    };
    SvgLayoutRows2Icon.displayName = "LayoutRows2Icon";
    exports.SvgLayoutRows2Icon = SvgLayoutRows2Icon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutSectionIcon.svg.js
var require_LayoutSectionIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutSectionIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLayoutSectionIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 5.25c0-.966.784-1.75 1.75-1.75h1a.75.75 0 0 1 0 1.5h-1a.25.25 0 0 0-.25.25v1a.75.75 0 0 1-1.5 0v-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 9.25c0-.966.784-1.75 1.75-1.75h9.5c.966 0 1.75.784 1.75 1.75v1.5a1.75 1.75 0 0 1-1.75 1.75h-9.5a1.75 1.75 0 0 1-1.75-1.75v-1.5Zm1.75-.25a.25.25 0 0 0-.25.25v1.5c0 .138.112.25.25.25h9.5a.25.25 0 0 0 .25-.25v-1.5a.25.25 0 0 0-.25-.25h-9.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 14.75c0 .966.784 1.75 1.75 1.75h1a.75.75 0 0 0 0-1.5h-1a.25.25 0 0 1-.25-.25v-1a.75.75 0 0 0-1.5 0v1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.75 3.5c.966 0 1.75.784 1.75 1.75v1a.75.75 0 0 1-1.5 0v-1a.25.25 0 0 0-.25-.25h-1a.75.75 0 0 1 0-1.5h1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.75 16.5a1.75 1.75 0 0 0 1.75-1.75v-1a.75.75 0 0 0-1.5 0v1a.25.25 0 0 1-.25.25h-1a.75.75 0 0 0 0 1.5h1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.75 4.25a.75.75 0 0 1-.75.75h-2a.75.75 0 0 1 0-1.5h2a.75.75 0 0 1 .75.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 16.5a.75.75 0 0 0 0-1.5h-2a.75.75 0 0 0 0 1.5h2Z"
      }));
    };
    SvgLayoutSectionIcon.displayName = "LayoutSectionIcon";
    exports.SvgLayoutSectionIcon = SvgLayoutSectionIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutSidebarLeftIcon.svg.js
var require_LayoutSidebarLeftIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutSidebarLeftIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLayoutSidebarLeftIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.25 16.5a1.75 1.75 0 0 1-1.75-1.75v-9.5c0-.966.784-1.75 1.75-1.75h1.5c.966 0 1.75.784 1.75 1.75v9.5a1.75 1.75 0 0 1-1.75 1.75h-1.5Zm-.25-1.75c0 .138.112.25.25.25h1.5a.25.25 0 0 0 .25-.25v-9.5a.25.25 0 0 0-.25-.25h-1.5a.25.25 0 0 0-.25.25v9.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.25 16.5a1.75 1.75 0 0 1-1.75-1.75v-.5a.75.75 0 0 1 1.5 0v.5c0 .138.112.25.25.25h.5a.75.75 0 0 1 0 1.5h-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.75 16.5a1.75 1.75 0 0 0 1.75-1.75v-.5a.75.75 0 0 0-1.5 0v.5a.25.25 0 0 1-.25.25h-.5a.75.75 0 0 0 0 1.5h.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.5 5.25c0-.966.784-1.75 1.75-1.75h.5a.75.75 0 0 1 0 1.5h-.5a.25.25 0 0 0-.25.25v.5a.75.75 0 0 1-1.5 0v-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.5 5.25a1.75 1.75 0 0 0-1.75-1.75h-.5a.75.75 0 0 0 0 1.5h.5a.25.25 0 0 1 .25.25v.5a.75.75 0 0 0 1.5 0v-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.25 8.25a.75.75 0 0 1 .75.75v2a.75.75 0 0 1-1.5 0v-2a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.5 9a.75.75 0 0 0-1.5 0v2a.75.75 0 0 0 1.5 0v-2Z"
      }));
    };
    SvgLayoutSidebarLeftIcon.displayName = "LayoutSidebarLeftIcon";
    exports.SvgLayoutSidebarLeftIcon = SvgLayoutSidebarLeftIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutSidebarRightIcon.svg.js
var require_LayoutSidebarRightIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LayoutSidebarRightIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLayoutSidebarRightIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13.75 16.5a1.75 1.75 0 0 1-1.75-1.75v-9.5c0-.966.784-1.75 1.75-1.75h1.5c.966 0 1.75.784 1.75 1.75v9.5a1.75 1.75 0 0 1-1.75 1.75h-1.5Zm-.25-1.75c0 .138.112.25.25.25h1.5a.25.25 0 0 0 .25-.25v-9.5a.25.25 0 0 0-.25-.25h-1.5a.25.25 0 0 0-.25.25v9.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.25 16.5a1.75 1.75 0 0 1-1.75-1.75v-.5a.75.75 0 0 1 1.5 0v.5c0 .138.112.25.25.25h.5a.75.75 0 0 1 0 1.5h-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.75 16.5a1.75 1.75 0 0 0 1.75-1.75v-.5a.75.75 0 0 0-1.5 0v.5a.25.25 0 0 1-.25.25h-.5a.75.75 0 0 0 0 1.5h.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 5.25c0-.966.784-1.75 1.75-1.75h.5a.75.75 0 0 1 0 1.5h-.5a.25.25 0 0 0-.25.25v.5a.75.75 0 0 1-1.5 0v-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.5 5.25a1.75 1.75 0 0 0-1.75-1.75h-.5a.75.75 0 0 0 0 1.5h.5a.25.25 0 0 1 .25.25v.5a.75.75 0 0 0 1.5 0v-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.25 8.25a.75.75 0 0 1 .75.75v2a.75.75 0 0 1-1.5 0v-2a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.5 9a.75.75 0 0 0-1.5 0v2a.75.75 0 0 0 1.5 0v-2Z"
      }));
    };
    SvgLayoutSidebarRightIcon.displayName = "LayoutSidebarRightIcon";
    exports.SvgLayoutSidebarRightIcon = SvgLayoutSidebarRightIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LightbulbIcon.svg.js
var require_LightbulbIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LightbulbIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLightbulbIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 2a.75.75 0 0 1 .75.75v.5a.75.75 0 0 1-1.5 0v-.5a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.58 4.167a.75.75 0 0 0-1.06 1.06l.353.354a.75.75 0 1 0 1.061-1.06l-.353-.354Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M2 9.75a.75.75 0 0 1 .75-.75h.5a.75.75 0 0 1 0 1.5h-.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16 9.75a.75.75 0 0 1 .75-.75h.5a.75.75 0 0 1 0 1.5h-.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.657 5.404a.75.75 0 0 0-1.06-1.06l-.354.353a.75.75 0 1 0 1.06 1.06l.354-.353Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.474 5.998a4.987 4.987 0 0 1 7.052 0c.95.95 1.46 2.103 1.46 3.298 0 1.194-.51 2.348-1.46 3.297a4.45 4.45 0 0 1-.053.053c-.473.455-.723.866-.723 1.24v1.114a2.5 2.5 0 0 1-2.5 2.5h-.5a2.5 2.5 0 0 1-2.5-2.5v-1.114c0-.374-.25-.785-.722-1.24a4.312 4.312 0 0 1-.054-.053c-.95-.95-1.46-2.103-1.46-3.297 0-1.195.51-2.349 1.46-3.298Zm5.992 1.06a3.487 3.487 0 0 0-4.932 0c-.705.707-1.02 1.492-1.02 2.238 0 .745.315 1.53 1.02 2.236l.034.033c.366.353.788.836 1.015 1.435h2.834c.227-.6.649-1.082 1.015-1.435l.034-.033c.705-.706 1.02-1.491 1.02-2.236 0-.746-.315-1.531-1.02-2.237Zm-1.216 7.442h-2.5v.5a1 1 0 0 0 1 1h.5a1 1 0 0 0 1-1v-.5Z"
      }));
    };
    SvgLightbulbIcon.displayName = "LightbulbIcon";
    exports.SvgLightbulbIcon = SvgLightbulbIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LinkIcon.svg.js
var require_LinkIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LinkIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLinkIcon3 = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15.842 4.175a3.746 3.746 0 0 0-5.298 0l-2.116 2.117a3.75 3.75 0 0 0 .01 5.313l.338.336a.75.75 0 1 0 1.057-1.064l-.339-.337a2.25 2.25 0 0 1-.005-3.187l2.116-2.117a2.246 2.246 0 1 1 3.173 3.18l-1.052 1.047a.75.75 0 0 0 1.058 1.064l1.052-1.047a3.746 3.746 0 0 0 .006-5.305Zm-11.664 11.67a3.75 3.75 0 0 0 5.304 0l2.121-2.121a3.75 3.75 0 0 0 0-5.303l-.362-.362a.75.75 0 0 0-1.06 1.06l.362.362a2.25 2.25 0 0 1 0 3.182l-2.122 2.122a2.25 2.25 0 1 1-3.182-3.182l1.07-1.07a.75.75 0 1 0-1.062-1.06l-1.069 1.069a3.75 3.75 0 0 0 0 5.303Z"
      }));
    };
    SvgLinkIcon3.displayName = "LinkIcon";
    exports.SvgLinkIcon = SvgLinkIcon3;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ListBulletedFilledIcon.svg.js
var require_ListBulletedFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ListBulletedFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgListBulletedFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4 6.5a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4 11.5a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.5 15a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.5 4a1 1 0 0 0 0 2h8.5a1 1 0 1 0 0-2h-8.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.5 10a1 1 0 0 1 1-1h8.5a1 1 0 1 1 0 2h-8.5a1 1 0 0 1-1-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.5 14a1 1 0 1 0 0 2h8.5a1 1 0 1 0 0-2h-8.5Z"
      }));
    };
    SvgListBulletedFilledIcon.displayName = "ListBulletedFilledIcon";
    exports.SvgListBulletedFilledIcon = SvgListBulletedFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ListBulletedIcon.svg.js
var require_ListBulletedIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ListBulletedIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgListBulletedIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4 6a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4 11a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5 15a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.25 4.25a.75.75 0 0 0 0 1.5h9a.75.75 0 0 0 0-1.5h-9Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.5 10a.75.75 0 0 1 .75-.75h9a.75.75 0 0 1 0 1.5h-9a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.25 14.25a.75.75 0 0 0 0 1.5h9a.75.75 0 0 0 0-1.5h-9Z"
      }));
    };
    SvgListBulletedIcon.displayName = "ListBulletedIcon";
    exports.SvgListBulletedIcon = SvgListBulletedIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ListNumberedIcon.svg.js
var require_ListNumberedIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ListNumberedIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgListNumberedIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7 5a.75.75 0 0 1 .75-.75h8.5a.75.75 0 0 1 0 1.5h-8.5a.75.75 0 0 1-.75-.75Zm0 5a.75.75 0 0 1 .75-.75h8.5a.75.75 0 0 1 0 1.5h-8.5a.75.75 0 0 1-.75-.75Zm0 5a.75.75 0 0 1 .75-.75h8.5a.75.75 0 0 1 0 1.5h-8.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "m3.75 3.38-.2.15a.5.5 0 1 1-.6-.8l.6-.45a.75.75 0 0 1 1.2.6v3h.5a.5.5 0 0 1 0 1h-2a.5.5 0 1 1 0-1h.5v-2.5Zm-1 5.87a1.5 1.5 0 1 1 3 0v.05a1.5 1.5 0 0 1-.503 1.122l-.932.828h.935a.5.5 0 0 1 0 1h-1.592c-.69 0-1.014-.852-.499-1.31l1.423-1.265a.5.5 0 0 0 .168-.375v-.05a.5.5 0 0 0-1 0 .5.5 0 0 1-1 0Zm.5 3.88a.5.5 0 0 0 0 1h1.188a.32.32 0 0 1 .312.32.506.506 0 0 1-.24.43h-.76a.5.5 0 0 0 0 1h.76c.145.088.24.252.24.43a.32.32 0 0 1-.312.32h-1.188a.5.5 0 0 0 0 1h1.188a1.32 1.32 0 0 0 1.312-1.32 1.51 1.51 0 0 0-.321-.93 1.51 1.51 0 0 0 .321-.93 1.32 1.32 0 0 0-1.312-1.32h-1.188Z"
      }));
    };
    SvgListNumberedIcon.displayName = "ListNumberedIcon";
    exports.SvgListNumberedIcon = SvgListNumberedIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LiveFilledIcon.svg.js
var require_LiveFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LiveFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLiveFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.523 6.28a5.25 5.25 0 0 0 0 7.425.75.75 0 1 1-1.06 1.06 6.75 6.75 0 0 1 0-9.545.75.75 0 0 1 1.06 1.06Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 7.5a2.5 2.5 0 1 0 0 5 2.5 2.5 0 0 0 0-5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.462 13.705a5.25 5.25 0 0 0 0-7.425.75.75 0 1 1 1.061-1.06 6.75 6.75 0 0 1 0 9.546.75.75 0 0 1-1.06-1.061Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.79 8.048a2.75 2.75 0 0 0 0 3.89.75.75 0 1 1-1.06 1.06 4.25 4.25 0 0 1 0-6.01.75.75 0 1 1 1.06 1.06Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.194 11.937a2.75 2.75 0 0 0 0-3.889.75.75 0 1 1 1.061-1.06 4.25 4.25 0 0 1 0 6.01.75.75 0 0 1-1.06-1.06Z"
      }));
    };
    SvgLiveFilledIcon.displayName = "LiveFilledIcon";
    exports.SvgLiveFilledIcon = SvgLiveFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LiveIcon.svg.js
var require_LiveIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LiveIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLiveIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.523 6.28a5.25 5.25 0 0 0 0 7.425.75.75 0 1 1-1.06 1.06 6.75 6.75 0 0 1 0-9.545.75.75 0 0 1 1.06 1.06Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.25 10a2.75 2.75 0 1 1 5.5 0 2.75 2.75 0 0 1-5.5 0Zm2.75-1.25a1.25 1.25 0 1 0 0 2.5 1.25 1.25 0 0 0 0-2.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.462 13.705a5.25 5.25 0 0 0 0-7.425.75.75 0 1 1 1.061-1.06 6.75 6.75 0 0 1 0 9.546.75.75 0 0 1-1.06-1.061Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.79 8.048a2.75 2.75 0 0 0 0 3.89.75.75 0 1 1-1.06 1.06 4.25 4.25 0 0 1 0-6.01.75.75 0 1 1 1.06 1.06Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.194 11.937a2.75 2.75 0 0 0 0-3.889.75.75 0 1 1 1.061-1.06 4.25 4.25 0 0 1 0 6.01.75.75 0 0 1-1.06-1.06Z"
      }));
    };
    SvgLiveIcon.displayName = "LiveIcon";
    exports.SvgLiveIcon = SvgLiveIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LocationFilledIcon.svg.js
var require_LocationFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LocationFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLocationFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M14.25 16h-3.077l.07-.061a17.427 17.427 0 0 0 1.707-1.758c1.224-1.46 2.55-3.574 2.55-5.954 0-3.167-2.328-5.477-5.5-5.477s-5.5 2.31-5.5 5.477c0 2.38 1.326 4.495 2.55 5.954a17.426 17.426 0 0 0 1.708 1.758l.069.061h-3.077a.75.75 0 0 0 0 1.5h8.5a.75.75 0 0 0 0-1.5Zm-4.25-5.5a2 2 0 1 0 0-4 2 2 0 0 0 0 4Z"
      }));
    };
    SvgLocationFilledIcon.displayName = "LocationFilledIcon";
    exports.SvgLocationFilledIcon = SvgLocationFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LocationIcon.svg.js
var require_LocationIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LocationIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLocationIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 11a2.5 2.5 0 1 0 0-5 2.5 2.5 0 0 0 0 5Zm0-1.5a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.827 16h-3.077a.75.75 0 0 0 0 1.5h8.5a.75.75 0 0 0 0-1.5h-3.077l.07-.061a17.427 17.427 0 0 0 1.707-1.758c1.224-1.46 2.55-3.574 2.55-5.954 0-3.167-2.328-5.477-5.5-5.477s-5.5 2.31-5.5 5.477c0 2.38 1.326 4.495 2.55 5.954a17.426 17.426 0 0 0 1.777 1.819Zm1.173-11.75c-2.35 0-4 1.646-4 3.977 0 1.846 1.049 3.618 2.2 4.99a15.919 15.919 0 0 0 1.8 1.816 15.92 15.92 0 0 0 1.8-1.817c1.151-1.371 2.2-3.143 2.2-4.99 0-2.33-1.65-3.976-4-3.976Z"
      }));
    };
    SvgLocationIcon.displayName = "LocationIcon";
    exports.SvgLocationIcon = SvgLocationIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LocationNoneIcon.svg.js
var require_LocationNoneIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LocationNoneIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLocationNoneIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M6 8.227c0-2.331 1.65-3.977 4-3.977.969 0 1.818.28 2.482.771l.987-.986a.762.762 0 0 1 .09-.077c-.941-.764-2.17-1.208-3.559-1.208-3.172 0-5.5 2.31-5.5 5.477 0 1.36.433 2.632 1.032 3.745l1.115-1.116c-.394-.832-.647-1.722-.647-2.63Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "m7.426 12.2-1.456 1.455a.75.75 0 0 0 1.06 1.061l.259-.258a17.59 17.59 0 0 0 2.035 1.964 10.9 10.9 0 0 0 .208.165l.013.01.004.002.001.001s.001.001.45-.6l-.449.601a.75.75 0 0 0 .898 0l-.449-.601.449.601.002-.002.004-.003.013-.01a4.83 4.83 0 0 0 .208-.164 17.427 17.427 0 0 0 2.273-2.242c1.225-1.458 2.551-3.573 2.551-5.953 0-.612-.087-1.193-.25-1.73l.34-.34a.75.75 0 0 0-1.022-1.097.833.833 0 0 1-.002-.003.805.805 0 0 1-.037.039m-.55 2.672-5.627 5.627a16.033 16.033 0 0 0 1.648 1.638 15.92 15.92 0 0 0 1.8-1.817c1.151-1.371 2.2-3.143 2.2-4.99a4.75 4.75 0 0 0-.022-.458Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "m14.53 5.096-7.104 7.103Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.76 6.118c.153.049.3.112.438.187l-3.393 3.393a2.486 2.486 0 0 1-.305-1.198 2.5 2.5 0 0 1 3.26-2.382Z"
      }));
    };
    SvgLocationNoneIcon.displayName = "LocationNoneIcon";
    exports.SvgLocationNoneIcon = SvgLocationNoneIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LockFilledIcon.svg.js
var require_LockFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LockFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLockFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.25 6.75v.345a3.001 3.001 0 0 0-2.25 2.905v4a3 3 0 0 0 3 3h6a3 3 0 0 0 3-3v-4a3.001 3.001 0 0 0-2.25-2.905v-.345a3.75 3.75 0 1 0-7.5 0Zm3.75-2.25a2.25 2.25 0 0 0-2.25 2.25v.25h4.5v-.25a2.25 2.25 0 0 0-2.25-2.25Zm1.5 7.25a1.5 1.5 0 0 1-.75 1.3v.45a.75.75 0 0 1-1.5 0v-.45a1.5 1.5 0 1 1 2.25-1.3Z"
      }));
    };
    SvgLockFilledIcon.displayName = "LockFilledIcon";
    exports.SvgLockFilledIcon = SvgLockFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LockIcon.svg.js
var require_LockIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LockIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLockIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 13.05a1.5 1.5 0 1 0-1.5 0v.45a.75.75 0 0 0 1.5 0v-.45Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.25 7.095v-.345a3.75 3.75 0 1 1 7.5 0v.345a3.001 3.001 0 0 1 2.25 2.905v4a3 3 0 0 1-3 3h-6a3 3 0 0 1-3-3v-4a3 3 0 0 1 2.25-2.905Zm1.5-.345a2.25 2.25 0 0 1 4.5 0v.25h-4.5v-.25Zm-2.25 3.25a1.5 1.5 0 0 1 1.5-1.5h6a1.5 1.5 0 0 1 1.5 1.5v4a1.5 1.5 0 0 1-1.5 1.5h-6a1.5 1.5 0 0 1-1.5-1.5v-4Z"
      }));
    };
    SvgLockIcon.displayName = "LockIcon";
    exports.SvgLockIcon = SvgLockIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoCriteoIcon.svg.js
var require_LogoCriteoIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoCriteoIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLogoCriteoIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 7.084a4.576 4.576 0 0 0-3.358-1.469c-2.567 0-4.642 1.864-4.642 4.394 0 2.529 2.079 4.372 4.646 4.372a4.592 4.592 0 0 0 3.359-1.468c.002 0 .003-.002.005-.004l.003-.005a.252.252 0 0 0-.034-.35l-1.203-1.01a.251.251 0 0 0-.333.018 2.603 2.603 0 0 1-1.801.74c-1.284 0-2.323-.963-2.323-2.297 0-1.335 1.04-2.311 2.323-2.311.673.004 1.322.27 1.801.74a.25.25 0 0 0 .333.013l1.203-1.005.009-.009a.247.247 0 0 0 .012-.35Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "m16.73 11.44 1.506 2.239a.348.348 0 0 1 .063.214c0 .206-.168.37-.374.37h-2.306a.428.428 0 0 1-.3-.126l-.883-1.107c-.35-.412-.804-.281-.804.245v.74c0 .14-.11.249-.248.249h-2.104a.246.246 0 0 1-.249-.249v-1.54c0-.063.055-.118.118-.122 1.217-.067 2.214-1.103 2.214-2.319 0-1.208-.99-2.264-2.214-2.332a.121.121 0 0 1-.118-.122v-1.586c0-.14.11-.249.249-.249h3.623c1.688 0 3.056 1.292 3.056 2.93 0 .955-.434 1.784-1.124 2.247h-.004a.372.372 0 0 0-.101.518Z"
      }));
    };
    SvgLogoCriteoIcon.displayName = "LogoCriteoIcon";
    exports.SvgLogoCriteoIcon = SvgLogoCriteoIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoFacebookIcon.svg.js
var require_LogoFacebookIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoFacebookIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLogoFacebookIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 3c-3.866 0-7 3.154-7 7.045 0 3.506 2.544 6.414 5.875 6.955v-4.187h-1.875v-2.186h1.875v-1.666c0-1.895 1.103-2.942 2.79-2.942.808 0 1.653.148 1.653.148v1.86h-.931c-.918 0-1.204.584-1.204 1.182v1.418h2.048l-.327 2.186h-1.72v4.177c3.302-.566 5.816-3.46 5.816-6.945 0-3.89-3.134-7.045-7-7.045Z"
      }));
    };
    SvgLogoFacebookIcon.displayName = "LogoFacebookIcon";
    exports.SvgLogoFacebookIcon = SvgLogoFacebookIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoGoogleIcon.svg.js
var require_LogoGoogleIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoGoogleIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLogoGoogleIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10.143 5.787c1.052 0 1.987.357 2.734 1.044l2.045-2.005c-1.24-1.132-2.85-1.826-4.78-1.826a7.146 7.146 0 0 0-6.376 3.863 6.802 6.802 0 0 0 0 6.274v.007a7.152 7.152 0 0 0 6.377 3.856c1.928 0 3.545-.624 4.727-1.693 1.35-1.222 2.13-3.016 2.13-5.148 0-.496-.046-.974-.13-1.432h-6.727v2.711h3.844a3.225 3.225 0 0 1-1.435 2.106c-.636.42-1.448.675-2.41.675-1.856 0-3.434-1.228-4-2.883h-.008l.009-.006a4.119 4.119 0 0 1-.227-1.33c0-.465.084-.91.227-1.33.565-1.655 2.143-2.883 4-2.883Z"
      }));
    };
    SvgLogoGoogleIcon.displayName = "LogoGoogleIcon";
    exports.SvgLogoGoogleIcon = SvgLogoGoogleIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoInstagramIcon.svg.js
var require_LogoInstagramIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoInstagramIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLogoInstagramIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 3c-1.901 0-2.14.008-2.886.042-.745.034-1.254.153-1.7.326-.466.175-.89.45-1.24.807-.355.35-.63.773-.807 1.24-.172.445-.29.954-.325 1.7-.034.746-.042.983-.042 2.885 0 1.902.008 2.14.042 2.886.034.745.153 1.254.326 1.7.175.466.45.89.807 1.24.35.355.773.63 1.24.807.445.172.954.29 1.7.325.746.034.984.042 2.885.042 1.901 0 2.14-.008 2.886-.042.745-.034 1.254-.153 1.7-.326.466-.175.89-.45 1.24-.807.355-.35.63-.773.807-1.24.172-.445.29-.954.325-1.7.034-.746.042-.984.042-2.885 0-1.901-.008-2.14-.042-2.886-.034-.745-.153-1.254-.326-1.7a3.432 3.432 0 0 0-.807-1.24 3.433 3.433 0 0 0-1.24-.807c-.445-.172-.954-.29-1.7-.325-.746-.034-.983-.042-2.885-.042Zm0 1.261c1.869 0 2.09.007 2.829.041.682.031 1.053.145 1.3.241.326.127.56.279.805.523.245.245.396.479.523.805.096.247.21.618.241 1.3.034.738.04.96.04 2.829 0 1.869-.006 2.09-.04 2.829-.031.682-.145 1.053-.241 1.3a2.173 2.173 0 0 1-.523.805c-.226.232-.501.41-.805.523-.247.096-.618.21-1.3.241-.738.034-.96.04-2.829.04-1.87 0-2.09-.006-2.829-.04-.682-.031-1.053-.145-1.3-.241a2.168 2.168 0 0 1-.805-.523 2.17 2.17 0 0 1-.523-.805c-.096-.247-.21-.618-.241-1.3-.034-.738-.04-.96-.04-2.829 0-1.869.006-2.09.04-2.829.031-.682.145-1.053.241-1.3.127-.326.279-.56.523-.805.226-.232.501-.41.805-.523.247-.096.618-.21 1.3-.241.738-.034.96-.04 2.829-.04Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 12.336a2.335 2.335 0 1 1 0-4.67 2.335 2.335 0 0 1 0 4.67Zm0-5.934a3.598 3.598 0 1 0 0 7.196 3.598 3.598 0 0 0 0-7.196Zm4.645-.065a.85.85 0 1 1-1.701 0 .85.85 0 0 1 1.7 0Z"
      }));
    };
    SvgLogoInstagramIcon.displayName = "LogoInstagramIcon";
    exports.SvgLogoInstagramIcon = SvgLogoInstagramIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoMetaIcon.svg.js
var require_LogoMetaIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoMetaIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLogoMetaIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M2 11.598c0 .92.186 1.729.564 2.345.464.755 1.212 1.257 2.396 1.257.997 0 1.755-.438 2.642-1.595.507-.66.763-1.06 1.776-2.818l.504-.874.124-.214.122.198 1.435 2.345c.482.79 1.11 1.668 1.646 2.162.697.645 1.329.796 2.04.796 1.146 0 1.827-.592 2.177-1.184.362-.613.574-1.388.574-2.444 0-1.775-.454-3.495-1.39-4.86-.854-1.247-1.97-1.912-3.143-1.912-.698 0-1.392.305-2.035.854-.435.37-.84.84-1.214 1.334-.46-.57-.89-1.006-1.305-1.338-.789-.63-1.544-.85-2.303-.85-1.312 0-2.455.836-3.247 2.031-.893 1.348-1.363 3.093-1.363 4.767Zm1.728.06c0 .598.134 1.057.31 1.335.23.364.572.518.922.518.45 0 .863-.11 1.657-1.185.449-.607.954-1.388 1.39-2.061.182-.283.352-.546.501-.77l.68-1.022a9.949 9.949 0 0 0-.823-1.029c-.41-.427-.94-.944-1.783-.944-.683 0-1.262.47-1.748 1.186-.686 1.014-1.106 2.523-1.106 3.973Zm8.113-2.316a29.206 29.206 0 0 0-.838-1.294l.142-.21c.747-1.088 1.412-1.698 2.239-1.698.763 0 1.458.494 1.994 1.304.755 1.14 1.098 2.737 1.098 4.175 0 1.01-.245 1.892-1.226 1.892-.387 0-.685-.15-1.11-.655-.33-.392-.895-1.225-1.888-2.843l-.41-.67Z"
      }));
    };
    SvgLogoMetaIcon.displayName = "LogoMetaIcon";
    exports.SvgLogoMetaIcon = SvgLogoMetaIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoPinterestIcon.svg.js
var require_LogoPinterestIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoPinterestIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLogoPinterestIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 8.347c0-2.787 2.153-5.347 6.208-5.347 3.26 0 5.792 2.184 5.792 5.103 0 3.045-2.042 5.495-4.875 5.495-.953 0-1.847-.465-2.153-1.014l-.586 2.1c-.212.767-.784 1.73-1.168 2.316a9.717 9.717 0 0 1-.643-.22c-.082-.699-.155-1.768.034-2.528.17-.69 1.101-4.392 1.101-4.392s-.28-.53-.28-1.311c0-1.23.756-2.146 1.699-2.146.802 0 1.188.566 1.188 1.244 0 .485-.21 1.123-.43 1.795-.124.378-.252.768-.348 1.147-.221.88.47 1.597 1.391 1.597 1.67 0 2.954-1.656 2.954-4.046 0-2.115-1.616-3.595-3.924-3.595-2.673 0-4.242 1.886-4.242 3.835 0 .76.31 1.573.7 2.016.076.088.087.164.064.254-.043.169-.118.456-.178.683l-.083.319c-.04.162-.136.195-.314.118-1.173-.514-1.907-2.127-1.907-3.423Z"
      }));
    };
    SvgLogoPinterestIcon.displayName = "LogoPinterestIcon";
    exports.SvgLogoPinterestIcon = SvgLogoPinterestIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoSnapchatIcon.svg.js
var require_LogoSnapchatIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoSnapchatIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLogoSnapchatIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13.907 7.292c-.113-1.671-.702-3.792-3.765-3.792s-3.651 2.12-3.765 3.792c-.04.597-.502.92-1.1.949-.31.015-1.093-.377-1.093.134 0 1.083 2.166 1.083 2.166 2.167 0 1.083-1.625 2.708-2.708 3.25-1.083.541.344.713 1.083 1.083.74.37 1.018 1.466 2.167 1.083 1.15-.383 2.167.542 3.25.542 1.083 0 2.101-.925 3.25-.542 1.15.383 1.427-.713 2.167-1.083.74-.37 2.166-.542 1.083-1.083-1.083-.542-2.708-2.167-2.708-3.25 0-1.084 2.166-1.084 2.166-2.167 0-.51-.782-.119-1.093-.134-.598-.03-1.06-.352-1.1-.949Z"
      }));
    };
    SvgLogoSnapchatIcon.displayName = "LogoSnapchatIcon";
    exports.SvgLogoSnapchatIcon = SvgLogoSnapchatIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoTiktokIcon.svg.js
var require_LogoTiktokIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoTiktokIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLogoTiktokIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M16 6.295c-1.92-.121-3.028-1.306-3.263-3.295l-2.306.008v8.367c.349 4.465-3.839 3.789-4.166 1.503-.167-1.192.432-1.875 1.502-2.232a6.841 6.841 0 0 1 1.109-.273v-2.362c-4.796.167-5.715 4.473-4.22 6.918 2.322 3.804 8.112 2.148 8.112-3.167v-4.176c1.138.683 2.117 1.048 3.232.942v-2.233Z"
      }));
    };
    SvgLogoTiktokIcon.displayName = "LogoTiktokIcon";
    exports.SvgLogoTiktokIcon = SvgLogoTiktokIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoTumblrIcon.svg.js
var require_LogoTumblrIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoTumblrIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLogoTumblrIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.358 13.637a.27.27 0 0 0-.276.012c-.626.411-1.26.62-1.887.62-.337 0-.626-.075-.885-.23-.176-.105-.34-.287-.399-.445-.057-.15-.056-.556-.055-1.117v-3.422h2.846a.27.27 0 0 0 .27-.27v-2.403a.27.27 0 0 0-.27-.27h-2.846v-2.843a.27.27 0 0 0-.27-.269h-1.916a.27.27 0 0 0-.268.237c-.08.658-.23 1.205-.445 1.626-.21.414-.493.775-.843 1.073-.28.239-.761.47-1.428.687a.27.27 0 0 0-.186.256v1.907c0 .148.12.269.27.269h1.56v4.451c0 .656.07 1.15.213 1.51.146.365.406.709.771 1.022.36.308.797.549 1.302.716.49.16.88.246 1.537.246a6.98 6.98 0 0 0 1.575-.171 8.334 8.334 0 0 0 1.617-.589.27.27 0 0 0 .155-.243v-2.123a.27.27 0 0 0-.142-.237Z"
      }));
    };
    SvgLogoTumblrIcon.displayName = "LogoTumblrIcon";
    exports.SvgLogoTumblrIcon = SvgLogoTumblrIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoTwitchIcon.svg.js
var require_LogoTwitchIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoTwitchIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLogoTwitchIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.5 5.75h-1v3h1v-3Zm-3.75 0h1v3h-1v-3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "m6.5 3-2.5 2.5v9h3v2.5l2.5-2.5h2l4.5-4.5v-7h-9.5Zm8.5 6.5-2 2h-2l-1.75 1.75v-1.75h-2.25v-7.5h8v5.5Z"
      }));
    };
    SvgLogoTwitchIcon.displayName = "LogoTwitchIcon";
    exports.SvgLogoTwitchIcon = SvgLogoTwitchIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoVimeoIcon.svg.js
var require_LogoVimeoIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoVimeoIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLogoVimeoIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.922 5.189c-.247-1.028-1.406-1.319-2.577-1.14-.6.094-2.628 1-3.32 3.171 1.223-.096 1.864.089 1.747 1.451-.05.57-.333 1.195-.652 1.794-.366.692-1.055 2.047-1.957 1.07-.812-.88-.75-2.561-.935-3.682-.105-.63-.214-1.413-.418-2.06-.174-.557-.576-1.226-1.068-1.373-.528-.155-1.18.09-1.563.319-1.192.707-2.084 1.682-3.107 2.522-.13.131-.053.242-.01.34.147.23.204.369.484.41.728.108 1.42-.686 1.901.142.295.504.387 1.056.575 1.6.25.727.445 1.516.651 2.35.35 1.411.776 3.52 1.982 4.04.614.262 1.538-.09 2.006-.371 1.268-.76 2.299-1.828 3.101-2.984 2.089-3.005 3.09-6.025 3.199-6.6a2.198 2.198 0 0 0-.04-.999Z"
      }));
    };
    SvgLogoVimeoIcon.displayName = "LogoVimeoIcon";
    exports.SvgLogoVimeoIcon = SvgLogoVimeoIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoXIcon.svg.js
var require_LogoXIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoXIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLogoXIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12.906 17h4l-5.302-7.814 5.302-6.186h-1.414l-4.523 5.252-3.563-5.252h-4.156l5.444 7.894-5.258 6.106h1.47l4.433-5.172 3.567 5.172Zm-7.275-12.75 7.931 11.5h.985l-7.803-11.5h-1.113Z"
      }));
    };
    SvgLogoXIcon.displayName = "LogoXIcon";
    exports.SvgLogoXIcon = SvgLogoXIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoYoutubeIcon.svg.js
var require_LogoYoutubeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LogoYoutubeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgLogoYoutubeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.86 7s-.14-.97-.56-1.4c-.53-.56-1.13-.56-1.4-.6-1.96-.14-4.9-.14-4.9-.14s-2.94 0-4.9.14c-.28.04-.87.04-1.4.6-.43.43-.56 1.4-.56 1.4s-.14 1.14-.14 2.28v1.07c0 1.14.14 2.28.14 2.28s.14.98.55 1.4c.54.56 1.24.55 1.55.6 1.12.11 4.76.15 4.76.15s2.94 0 4.9-.15c.27-.03.87-.04 1.4-.6.42-.42.56-1.4.56-1.4s.14-1.14.14-2.28v-1.07c0-1.14-.14-2.28-.14-2.28Zm-8.31 4.65v-3.96l3.78 1.98-3.78 1.98Z"
      }));
    };
    SvgLogoYoutubeIcon.displayName = "LogoYoutubeIcon";
    exports.SvgLogoYoutubeIcon = SvgLogoYoutubeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MagicIcon.svg.js
var require_MagicIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MagicIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMagicIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.702 4.253a.625.625 0 0 1 1.096 0l.196.358c.207.378.517.688.895.895l.358.196a.625.625 0 0 1 0 1.097l-.358.196a2.25 2.25 0 0 0-.895.894l-.196.359a.625.625 0 0 1-1.096 0l-.196-.359a2.25 2.25 0 0 0-.895-.894l-.358-.196a.625.625 0 0 1 0-1.097l.358-.196a2.25 2.25 0 0 0 .895-.895l.196-.358Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12.948 7.89c-.18-1.167-1.852-1.19-2.064-.029l-.03.164a3.756 3.756 0 0 1-3.088 3.031c-1.15.189-1.173 1.833-.03 2.054l.105.02a3.824 3.824 0 0 1 3.029 3.029l.032.165c.233 1.208 1.963 1.208 2.196 0l.025-.129a3.836 3.836 0 0 1 3.077-3.045c1.184-.216 1.12-1.928-.071-2.107a3.789 3.789 0 0 1-3.18-3.154Zm-.944 6.887a5.34 5.34 0 0 1 2.542-2.647 5.305 5.305 0 0 1-2.628-2.548 5.262 5.262 0 0 1-2.488 2.508 5.329 5.329 0 0 1 2.574 2.687Z"
      }));
    };
    SvgMagicIcon.displayName = "MagicIcon";
    exports.SvgMagicIcon = SvgMagicIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MarketsEuroFilledIcon.svg.js
var require_MarketsEuroFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MarketsEuroFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMarketsEuroFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 3a7 7 0 1 0 2.554 13.52 4.74 4.74 0 0 1-.911-1.27 5.5 5.5 0 0 1-1.643.25 5.477 5.477 0 0 1-2.53-.616l.488-.488a1.917 1.917 0 0 1 2.372-.27c.295.184.633.282.977.285l-.007-.022a2.25 2.25 0 0 1 0-4.278c.093-.303.207-.59.342-.86l-.017-.001h-.507c-.78 0-1.493.44-1.842 1.138l-.122.246a1.115 1.115 0 0 1-2.098-.316l-.058-.353a1.537 1.537 0 0 1 1.03-1.71l.75-.25c.58-.194.972-.738.972-1.35a.92.92 0 0 1 .543-.84l1.904-.859a5.521 5.521 0 0 1 2.328 1.916 4.206 4.206 0 0 1 1.707-.064 7 7 0 0 0-6.232-3.808Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.843 11.25c.185-.904.615-1.372 1.009-1.58a1.468 1.468 0 0 1 1.651.194.75.75 0 0 0 .994-1.124 2.968 2.968 0 0 0-3.349-.395c-.94.499-1.614 1.488-1.827 2.905h-.321a1 1 0 1 0 0 2h.321c.213 1.417.886 2.406 1.828 2.905a2.969 2.969 0 0 0 3.348-.395.75.75 0 0 0-.994-1.124 1.468 1.468 0 0 1-1.652.194c-.393-.208-.823-.676-1.008-1.58h2.157a1 1 0 1 0 0-2h-2.157Z"
      }));
    };
    SvgMarketsEuroFilledIcon.displayName = "MarketsEuroFilledIcon";
    exports.SvgMarketsEuroFilledIcon = SvgMarketsEuroFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MarketsEuroIcon.svg.js
var require_MarketsEuroIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MarketsEuroIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMarketsEuroIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 3a7 7 0 1 0 2.806 13.415 4.453 4.453 0 0 1-.924-1.245 5.49 5.49 0 0 1-1.882.33c-.723 0-1.414-.14-2.046-.393l.357-.357a1.418 1.418 0 0 1 1.754-.2c.5.312 1.098.428 1.678.324a5.61 5.61 0 0 1-.242-.687 2.004 2.004 0 0 1-1.375-1.238 2.918 2.918 0 0 0-2.876.74l-.641.641a5.5 5.5 0 0 1 4.074-9.788l-.8.36a1.923 1.923 0 0 0-1.133 1.753.422.422 0 0 1-.289.4l-.75.25a2.537 2.537 0 0 0-1.7 2.825l.06.353a2.115 2.115 0 0 0 3.977.598l.123-.246a1.06 1.06 0 0 1 .947-.585h.401c.154-.522.373-.997.651-1.413a1.749 1.749 0 0 0-.545-.087h-.507a2.56 2.56 0 0 0-2.289 1.415l-.122.245a.615.615 0 0 1-1.157-.174l-.06-.353a1.038 1.038 0 0 1 .696-1.154l.75-.25a1.922 1.922 0 0 0 1.314-1.824c0-.166.097-.317.249-.385l2.27-1.023a5.527 5.527 0 0 1 1.902 1.848 3.963 3.963 0 0 1 1.697-.006 7.001 7.001 0 0 0-6.368-4.089Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.843 11.25c.185-.904.615-1.372 1.009-1.58a1.468 1.468 0 0 1 1.651.194.75.75 0 0 0 .994-1.124 2.968 2.968 0 0 0-3.349-.395c-.94.499-1.614 1.488-1.827 2.905h-.321a1 1 0 1 0 0 2h.321c.213 1.417.886 2.406 1.828 2.905a2.969 2.969 0 0 0 3.348-.395.75.75 0 0 0-.994-1.124 1.468 1.468 0 0 1-1.652.194c-.393-.208-.823-.676-1.008-1.58h2.157a1 1 0 1 0 0-2h-2.157Z"
      }));
    };
    SvgMarketsEuroIcon.displayName = "MarketsEuroIcon";
    exports.SvgMarketsEuroIcon = SvgMarketsEuroIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MarketsFilledIcon.svg.js
var require_MarketsFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MarketsFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMarketsFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3 10a7 7 0 0 1 12.584-4.222 2 2 0 0 0-2.327 1.806 3.51 3.51 0 0 0-1.862 2.166h-1.395a1.255 1.255 0 0 1-.764-2.248l.462-.357a.89.89 0 0 0 .347-.707v-.04c0-.747.606-1.353 1.353-1.353h.057c.193 0 .37-.069.509-.184a5.5 5.5 0 0 0-6.945 2.804l1.89 1.89c.378.379.591.892.591 1.427v.518a1 1 0 0 0 1 1 1.5 1.5 0 0 1 1.5 1.5v1.5c.431 0 .85-.05 1.253-.143.028.546.277 1.035.658 1.379a7 7 0 0 1-8.911-6.736Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.25 7a.75.75 0 0 1 .75.75v.75h.75a.75.75 0 0 1 0 1.5h-2a.75.75 0 0 0 0 1.5h.5a2.25 2.25 0 0 1 .25 4.486v.264a.75.75 0 0 1-1.5 0v-.25h-.75a.75.75 0 0 1 0-1.5h2a.75.75 0 0 0 0-1.5h-.5a2.25 2.25 0 0 1-.25-4.486v-.764a.75.75 0 0 1 .75-.75Z"
      }));
    };
    SvgMarketsFilledIcon.displayName = "MarketsFilledIcon";
    exports.SvgMarketsFilledIcon = SvgMarketsFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MarketsIcon.svg.js
var require_MarketsIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MarketsIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMarketsIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3 10a7 7 0 0 1 12.584-4.222 2.013 2.013 0 0 0-1.604.427 5.528 5.528 0 0 0-1.105-.895 1.85 1.85 0 0 1-1.477.735.352.352 0 0 0-.353.353v.04c0 .587-.271 1.14-.736 1.499l-.462.356a.256.256 0 0 0 .153.457h1.877a3.482 3.482 0 0 0-.592 1.5h-1.285a1.755 1.755 0 0 1-1.07-3.144l.463-.356a.393.393 0 0 0 .152-.312v-.04c0-.885.62-1.624 1.449-1.808a5.497 5.497 0 0 0-5.73 2.613l1.999 1.999c.472.472.737 1.113.737 1.78v.518a.5.5 0 0 0 .5.5 2 2 0 0 1 2 2v1.478c.256-.024.508-.064.753-.121.028.546.277 1.035.658 1.379a7 7 0 0 1-8.911-6.736Zm1.5 0c0-.443.052-.875.152-1.288l1.55 1.55c.19.191.298.45.298.72v.518a2 2 0 0 0 2 2 .5.5 0 0 1 .5.5v1.41a5.502 5.502 0 0 1-4.5-5.41Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.25 7a.75.75 0 0 1 .75.75v.75h.75a.75.75 0 0 1 0 1.5h-2a.75.75 0 0 0 0 1.5h.5a2.25 2.25 0 0 1 .25 4.486v.264a.75.75 0 0 1-1.5 0v-.25h-.75a.75.75 0 0 1 0-1.5h2a.75.75 0 0 0 0-1.5h-.5a2.25 2.25 0 0 1-.25-4.486v-.764a.75.75 0 0 1 .75-.75Z"
      }));
    };
    SvgMarketsIcon.displayName = "MarketsIcon";
    exports.SvgMarketsIcon = SvgMarketsIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MarketsRupeeFilledIcon.svg.js
var require_MarketsRupeeFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MarketsRupeeFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMarketsRupeeFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3 10a7 7 0 0 1 13.54-2.5h-3.79c-.469 0-.9.161-1.24.431l.058-.234c.068-.27.22-.5.425-.667l.007-.03h.03c.212-.158.473-.25.75-.25h.22a.75.75 0 0 0 .75-.75v-.023a5.502 5.502 0 0 0-9.174 3.107l.276.183a.75.75 0 0 0 1.016-.174l.262-.35a.75.75 0 0 1 1.334.303l.103.515a.857.857 0 0 0 1.554.307l.374-.561a1.25 1.25 0 0 1 1.04-.557h.184a.75.75 0 0 0 .186-.023 1.991 1.991 0 0 0 .284 2.023 1.991 1.991 0 0 0-.439 1.25c0 .533.208 1.017.548 1.375h-.37c-.466 0-.905.22-1.185.592-.165.22-.384.395-.635.506l-1.294.575a5.51 5.51 0 0 0 3.731.232c.163.364.44.694.843.941l.357.22a7 7 0 0 1-9.745-6.441Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.889 16.643a.75.75 0 0 0-.246-1.032l-1.713-1.054a2.486 2.486 0 0 0 1.059-1.807h1.261a.75.75 0 0 0 0-1.5h-1.25v-1h1.25a.75.75 0 0 0 0-1.5h-4.5a.75.75 0 0 0 0 1.5h1.75v1h-1.75a.75.75 0 0 0 0 1.5h1.721a.989.989 0 0 1-.96.75c-.901 0-1.237 1.184-.468 1.657l2.814 1.732a.75.75 0 0 0 1.032-.246Z"
      }));
    };
    SvgMarketsRupeeFilledIcon.displayName = "MarketsRupeeFilledIcon";
    exports.SvgMarketsRupeeFilledIcon = SvgMarketsRupeeFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MarketsRupeeIcon.svg.js
var require_MarketsRupeeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MarketsRupeeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMarketsRupeeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3 10a7 7 0 0 1 13.54-2.5h-3.79a2 2 0 0 0-1.985 2.25h-.23a.25.25 0 0 0-.208.111l-.374.562a1.857 1.857 0 0 1-3.36-.637 1.75 1.75 0 0 1-2.089.432 5.491 5.491 0 0 0 2.126 4.13.776.776 0 0 1 .065-.033l1.956-.87a.487.487 0 0 0 .192-.153 2.606 2.606 0 0 1 1.923-1.037c.069.539.351 1.01.76 1.327a2.225 2.225 0 0 0-.06.168h-.537c-.35 0-.677.164-.886.442a1.987 1.987 0 0 1-.783.624l-.946.42a5.502 5.502 0 0 0 3.231.043c.163.365.44.694.843.942l.357.22a7 7 0 0 1-9.745-6.441Zm7-5.5a5.502 5.502 0 0 0-5.31 4.06l.439.291a.25.25 0 0 0 .339-.058l.262-.35c.648-.864 2.013-.554 2.224.505l.103.515a.357.357 0 0 0 .648.128l.374-.562a1.75 1.75 0 0 1 1.456-.779h.184a.25.25 0 0 0 .243-.19l.121-.484a1.75 1.75 0 0 1 1.698-1.326h.219a.25.25 0 0 0 .25-.25v-.438a5.475 5.475 0 0 0-3.25-1.062Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.889 16.643a.75.75 0 0 0-.246-1.032l-1.713-1.054a2.486 2.486 0 0 0 1.059-1.807h1.261a.75.75 0 0 0 0-1.5h-1.25v-1h1.25a.75.75 0 0 0 0-1.5h-4.5a.75.75 0 0 0 0 1.5h1.75v1h-1.75a.75.75 0 0 0 0 1.5h1.721a.989.989 0 0 1-.96.75c-.901 0-1.237 1.184-.468 1.657l2.814 1.732a.75.75 0 0 0 1.032-.246Z"
      }));
    };
    SvgMarketsRupeeIcon.displayName = "MarketsRupeeIcon";
    exports.SvgMarketsRupeeIcon = SvgMarketsRupeeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MarketsYenFilledIcon.svg.js
var require_MarketsYenFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MarketsYenFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMarketsYenFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 3a7 7 0 1 0 2.178 13.654 1.753 1.753 0 0 1-1.132-1.253 5.522 5.522 0 0 1-3.232-.352l1.294-.576c.251-.111.47-.286.635-.506.28-.373.719-.592 1.185-.592h.187a1.75 1.75 0 0 1 1.3-2.343l-.817-.715a1.749 1.749 0 0 1-.57-1.634.748.748 0 0 1-.309.067h-.184a1.25 1.25 0 0 0-1.04.557l-.374.561a.857.857 0 0 1-1.554-.307l-.103-.515a.75.75 0 0 0-1.334-.303l-.262.35a.75.75 0 0 1-1.016.174l-.276-.183a5.502 5.502 0 0 1 9.174-3.107v.023a.75.75 0 0 1-.75.75h-.22c-.277 0-.538.092-.75.25h-.03l-.008.03a1.248 1.248 0 0 0-.424.667l-.004.016a1.75 1.75 0 0 1 2.19-.146l.006.004c.05.035.097.072.142.112l.848.742.848-.742a1.758 1.758 0 0 1 .852-.407 7.026 7.026 0 0 0-2.7-3.188 6.967 6.967 0 0 0-3.75-1.088Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.186 8.506a.75.75 0 0 1 1.058-.07l1.506 1.317 1.506-1.317a.75.75 0 0 1 .988 1.128l-1.744 1.526v.91h1.25a.75.75 0 0 1 0 1.5h-1.25v.75h1.25a.75.75 0 0 1 0 1.5h-1.25v.5a.75.75 0 0 1-1.5 0v-.5h-1.25a.75.75 0 0 1 0-1.5h1.25v-.75h-1.25a.75.75 0 0 1 0-1.5h1.25v-.91l-1.744-1.526a.75.75 0 0 1-.07-1.058Z"
      }));
    };
    SvgMarketsYenFilledIcon.displayName = "MarketsYenFilledIcon";
    exports.SvgMarketsYenFilledIcon = SvgMarketsYenFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MarketsYenIcon.svg.js
var require_MarketsYenIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MarketsYenIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMarketsYenIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3 10a7 7 0 0 1 13.45-2.724 1.742 1.742 0 0 0-.852.407l-.848.742-.794-.695c-.02-.029.02.028 0 0l-.191-.156a1.75 1.75 0 0 0-2.62 2.124 1.75 1.75 0 0 1-.426.052h-.184a.25.25 0 0 0-.208.111l-.374.562a1.857 1.857 0 0 1-3.36-.637 1.75 1.75 0 0 1-2.089.432 5.491 5.491 0 0 0 2.126 4.13.776.776 0 0 1 .065-.033l1.956-.87a.487.487 0 0 0 .192-.153 2.606 2.606 0 0 1 2.085-1.042h.144a1.749 1.749 0 0 0 .242 1.5h-.386c-.348 0-.676.164-.885.442a1.987 1.987 0 0 1-.783.624l-.946.42a5.497 5.497 0 0 0 2.732.165 1.75 1.75 0 0 0 1.132 1.253 7 7 0 0 1-9.178-6.654Zm7-5.5a5.502 5.502 0 0 0-5.31 4.06l.439.291a.25.25 0 0 0 .339-.058l.262-.35c.648-.864 2.013-.554 2.224.505l.103.515a.357.357 0 0 0 .648.128l.374-.562a1.75 1.75 0 0 1 1.456-.779h.184a.25.25 0 0 0 .243-.19l.121-.484a1.75 1.75 0 0 1 1.698-1.326h.219a.25.25 0 0 0 .25-.25v-.438a5.475 5.475 0 0 0-3.25-1.062Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.186 8.506a.75.75 0 0 1 1.058-.07l1.506 1.317 1.506-1.317a.75.75 0 0 1 .988 1.128l-1.744 1.526v.91h1.25a.75.75 0 0 1 0 1.5h-1.25v.75h1.25a.75.75 0 0 1 0 1.5h-1.25v.5a.75.75 0 0 1-1.5 0v-.5h-1.25a.75.75 0 0 1 0-1.5h1.25v-.75h-1.25a.75.75 0 0 1 0-1.5h1.25v-.91l-1.744-1.526a.75.75 0 0 1-.07-1.058Z"
      }));
    };
    SvgMarketsYenIcon.displayName = "MarketsYenIcon";
    exports.SvgMarketsYenIcon = SvgMarketsYenIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MaximizeIcon.svg.js
var require_MaximizeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MaximizeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMaximizeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.75 3.5a.75.75 0 0 0 0 1.5h1.19l-3.22 3.22a.75.75 0 0 0 1.06 1.06l3.22-3.22v1.19a.75.75 0 0 0 1.5 0v-3a.75.75 0 0 0-.75-.75h-3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.25 16.5a.75.75 0 0 0 0-1.5h-1.19l3.22-3.22a.75.75 0 1 0-1.06-1.06l-3.22 3.22v-1.19a.75.75 0 0 0-1.5 0v3c0 .414.336.75.75.75h3Z"
      }));
    };
    SvgMaximizeIcon.displayName = "MaximizeIcon";
    exports.SvgMaximizeIcon = SvgMaximizeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MeasurementSizeIcon.svg.js
var require_MeasurementSizeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MeasurementSizeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMeasurementSizeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.75 5a.75.75 0 0 0 0-1.5h-1.5a.75.75 0 0 0 0 1.5h1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.75 6.5a.75.75 0 0 1-.75-.75v-.5a.25.25 0 0 0-.25-.25h-.5a.75.75 0 0 1 0-1.5h.5c.966 0 1.75.784 1.75 1.75v.5a.75.75 0 0 1-.75.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.75 7.5a.75.75 0 0 1 .75.75v1.5a.75.75 0 0 1-1.5 0v-1.5a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.25 12a.75.75 0 0 1-.75-.75v-5.19l-.97.97a.75.75 0 0 1-1.06-1.06l2.25-2.25a.75.75 0 0 1 1.06 0l2.25 2.25a.75.75 0 0 1-1.06 1.06l-.97-.97v5.19a.75.75 0 0 1-.75.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.75 13a.75.75 0 0 0 0 1.5h5.19l-.97.97a.75.75 0 1 0 1.06 1.06l2.25-2.25a.75.75 0 0 0 0-1.06l-2.25-2.25a.75.75 0 1 0-1.06 1.06l.97.97h-5.19Z"
      }));
    };
    SvgMeasurementSizeIcon.displayName = "MeasurementSizeIcon";
    exports.SvgMeasurementSizeIcon = SvgMeasurementSizeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MeasurementVolumeIcon.svg.js
var require_MeasurementVolumeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MeasurementVolumeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMeasurementVolumeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13.5 5v3.042a3 3 0 0 0 .137.895l1.552 4.966a2 2 0 0 1-1.91 2.597h-6.559a2 2 0 0 1-1.909-2.597l1.552-4.966a3 3 0 0 0 .137-.895v-3.042h-.5a.75.75 0 0 1 0-1.5h8a.75.75 0 0 1 0 1.5h-.5Zm-5.5 3.042v-3.042h4v2.25h-.75a.75.75 0 0 0 0 1.5h.806c.034.214.084.427.149.634l.27.866h-4.95l.27-.866a4.5 4.5 0 0 0 .205-1.342Zm-.944 3.708h5.888l.813 2.6a.5.5 0 0 1-.477.65h-6.56a.5.5 0 0 1-.477-.65l.813-2.6Z"
      }));
    };
    SvgMeasurementVolumeIcon.displayName = "MeasurementVolumeIcon";
    exports.SvgMeasurementVolumeIcon = SvgMeasurementVolumeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MeasurementWeightIcon.svg.js
var require_MeasurementWeightIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MeasurementWeightIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMeasurementWeightIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4.75 3.75a.75.75 0 0 0-1.5 0c0 .966.784 1.75 1.75 1.75h4.25v1.5h-3.5a2.25 2.25 0 0 0-2.25 2.25v5a2.25 2.25 0 0 0 2.25 2.25h8.5a2.25 2.25 0 0 0 2.25-2.25v-5a2.25 2.25 0 0 0-2.25-2.25h-3.5v-1.5h4.25a1.75 1.75 0 0 0 1.75-1.75.75.75 0 0 0-1.5 0 .25.25 0 0 1-.25.25h-10a.25.25 0 0 1-.25-.25Zm.25 5.5a.75.75 0 0 1 .75-.75h4.25a3 3 0 1 0 0 6 3 3 0 0 0 0-6h4.25a.75.75 0 0 1 .75.75v5a.75.75 0 0 1-.75.75h-8.5a.75.75 0 0 1-.75-.75v-5Zm5 3.75a1.5 1.5 0 0 0 1.478-1.756l-.998.832a.75.75 0 1 1-.96-1.152l.998-.832a1.5 1.5 0 1 0-.518 2.908Z"
      }));
    };
    SvgMeasurementWeightIcon.displayName = "MeasurementWeightIcon";
    exports.SvgMeasurementWeightIcon = SvgMeasurementWeightIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MediaReceiverIcon.svg.js
var require_MediaReceiverIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MediaReceiverIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMediaReceiverIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.25 4a.75.75 0 0 1 .75-.75 5.75 5.75 0 0 1 5.75 5.75.75.75 0 0 1-1.5 0 4.25 4.25 0 0 0-4.25-4.25.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.75 12.75a.75.75 0 0 0 0 1.5h2a.75.75 0 0 0 0-1.5h-2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 8.25a.75.75 0 0 1 .75.75v1.499h4c.966 0 1.75.784 1.75 1.75v2.5a1.75 1.75 0 0 1-1.75 1.75h-9.5a1.75 1.75 0 0 1-1.75-1.75v-2.5c0-.966.784-1.75 1.75-1.75h4v-1.499a.75.75 0 0 1 .75-.75Zm-4.75 3.749a.25.25 0 0 0-.25.25v2.5c0 .139.112.25.25.25h9.5a.25.25 0 0 0 .25-.25v-2.5a.25.25 0 0 0-.25-.25h-9.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 5.75a.75.75 0 0 0 0 1.5 1.75 1.75 0 0 1 1.75 1.75.75.75 0 0 0 1.5 0 3.25 3.25 0 0 0-3.25-3.25Z"
      }));
    };
    SvgMediaReceiverIcon.displayName = "MediaReceiverIcon";
    exports.SvgMediaReceiverIcon = SvgMediaReceiverIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MegaphoneFilledIcon.svg.js
var require_MegaphoneFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MegaphoneFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMegaphoneFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 9.75a2.11 2.11 0 0 0 1.982 2.105l4.056.246a.75.75 0 0 1 .4.146l3.068 2.272c.825.611 1.994.022 1.994-1.004v-7.608c0-1.032-1.18-1.62-2.004-.997l-3.097 2.341a.75.75 0 0 1-.407.15l-4.01.244a2.11 2.11 0 0 0-1.982 2.105Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.625 13.177v2.147a1.301 1.301 0 0 0 2.594.152l.238-2.023-.154-.114-2.678-.162Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M17.5 8.75a.75.75 0 0 0-1.5 0v2.5a.75.75 0 0 0 1.5 0v-2.5Z"
      }));
    };
    SvgMegaphoneFilledIcon.displayName = "MegaphoneFilledIcon";
    exports.SvgMegaphoneFilledIcon = SvgMegaphoneFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MegaphoneIcon.svg.js
var require_MegaphoneIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MegaphoneIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMegaphoneIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.451 12.354a2.61 2.61 0 0 1 0-5.208l4.01-.244a.25.25 0 0 0 .137-.05l3.097-2.34c1.153-.872 2.805-.05 2.805 1.395v7.608c0 1.437-1.637 2.261-2.792 1.406l-2.572-1.906-.287 2.44a1.75 1.75 0 0 1-1.738 1.545h-.361a1.75 1.75 0 0 1-1.75-1.75v-2.862l-.549-.034Zm-.951-2.604a1.11 1.11 0 0 0 1.042 1.107l4.056.246c.338.02.664.139.936.34l3.067 2.273a.25.25 0 0 0 .399-.201v-7.608a.25.25 0 0 0-.4-.199l-3.098 2.341a1.75 1.75 0 0 1-.95.35l-4.01.244a1.11 1.11 0 0 0-1.042 1.107Zm3 2.729 1.18.071-.321 2.73a.25.25 0 0 1-.248.22h-.361a.25.25 0 0 1-.25-.25v-2.771Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M17.5 8.75a.75.75 0 0 0-1.5 0v2.5a.75.75 0 0 0 1.5 0v-2.5Z"
      }));
    };
    SvgMegaphoneIcon.displayName = "MegaphoneIcon";
    exports.SvgMegaphoneIcon = SvgMegaphoneIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MentionIcon.svg.js
var require_MentionIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MentionIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMentionIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.738 4.987a5.5 5.5 0 0 1 7.762 5.013c0 .874-.227 1.44-.5 1.773a1.255 1.255 0 0 1-1 .477c-.639 0-.96-.222-1.162-.523-.236-.355-.374-.93-.374-1.727v-2.571a.75.75 0 0 0-1.28-.531c-.438-.3-1.012-.505-1.755-.505-1.159 0-1.952.6-2.422 1.352-.45.72-.614 1.58-.614 2.255 0 .674.164 1.536.614 2.255.47.752 1.263 1.352 2.422 1.352.95 0 1.655-.467 2.119-.937l.069-.072c.515.745 1.326 1.152 2.383 1.152.824 0 1.6-.347 2.157-1.023.55-.668.843-1.601.843-2.727a7 7 0 1 0-3.01 5.751.75.75 0 1 0-.854-1.232 5.5 5.5 0 1 1-5.398-9.532Zm3.276 5.877a7.04 7.04 0 0 1-.05-.864v-.976l-.033-.075c-.09-.204-.173-.392-.352-.598-.2-.228-.522-.458-1.15-.458-.556 0-.906.256-1.15.647-.265.424-.386.991-.386 1.46s.121 1.036.386 1.46c.244.39.594.647 1.15.647.42 0 .763-.199 1.052-.491a3.16 3.16 0 0 0 .534-.752Z"
      }));
    };
    SvgMentionIcon.displayName = "MentionIcon";
    exports.SvgMentionIcon = SvgMentionIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MenuHorizontalIcon.svg.js
var require_MenuHorizontalIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MenuHorizontalIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMenuHorizontalIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M6 10a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.5 10a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M17 10a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0Z"
      }));
    };
    SvgMenuHorizontalIcon.displayName = "MenuHorizontalIcon";
    exports.SvgMenuHorizontalIcon = SvgMenuHorizontalIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MenuIcon.svg.js
var require_MenuIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MenuIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMenuIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3 4.75a.75.75 0 0 1 .75-.75h12.5a.75.75 0 0 1 0 1.5h-12.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3 10a.75.75 0 0 1 .75-.75h12.5a.75.75 0 0 1 0 1.5h-12.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3 15.25a.75.75 0 0 1 .75-.75h12.5a.75.75 0 0 1 0 1.5h-12.5a.75.75 0 0 1-.75-.75Z"
      }));
    };
    SvgMenuIcon.displayName = "MenuIcon";
    exports.SvgMenuIcon = SvgMenuIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MenuVerticalIcon.svg.js
var require_MenuVerticalIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MenuVerticalIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMenuVerticalIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.5 4.5a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.5 10a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.5 15.5a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0Z"
      }));
    };
    SvgMenuVerticalIcon.displayName = "MenuVerticalIcon";
    exports.SvgMenuVerticalIcon = SvgMenuVerticalIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MergeIcon.svg.js
var require_MergeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MergeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMergeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.75 17a.75.75 0 0 1-.75-.75v-1.695a3.75 3.75 0 0 1 1.587-3.064l2.134-1.506a1.25 1.25 0 0 0 .529-1.021v-4.001l-1.991 1.838a.75.75 0 1 1-1.018-1.102l3.25-3a.75.75 0 0 1 1.018 0l3.25 3a.75.75 0 1 1-1.018 1.102l-1.991-1.838v4a2.75 2.75 0 0 1-1.164 2.247l-2.134 1.506a2.25 2.25 0 0 0-.952 1.839v1.695a.75.75 0 0 1-.75.75Zm8.5 0a.75.75 0 0 1-.75-.75v-1.695a2.25 2.25 0 0 0-.953-1.839l-.854-.603a.75.75 0 1 1 .864-1.226l.856.604a3.75 3.75 0 0 1 1.587 3.064v1.695a.75.75 0 0 1-.75.75Z"
      }));
    };
    SvgMergeIcon.displayName = "MergeIcon";
    exports.SvgMergeIcon = SvgMergeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MetafieldsFilledIcon.svg.js
var require_MetafieldsFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MetafieldsFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMetafieldsFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.25 5a1 1 0 0 0-1 1v1.5h-.75a1 1 0 0 0-1 1v5.5a1 1 0 0 0 1 1h13a1 1 0 0 0 1-1v-5.5a1 1 0 0 0-1-1h-.75v-1.5a1 1 0 0 0-1-1h-2a1 1 0 0 0-1 1v1.5h-3.5v-1.5a1 1 0 0 0-1-1h-2Z"
      }));
    };
    SvgMetafieldsFilledIcon.displayName = "MetafieldsFilledIcon";
    exports.SvgMetafieldsFilledIcon = SvgMetafieldsFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MetafieldsIcon.svg.js
var require_MetafieldsIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MetafieldsIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMetafieldsIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 6v1.5h-.5a1 1 0 0 0-1 1v5.5a1 1 0 0 0 1 1h13a1 1 0 0 0 1-1v-5.5a1 1 0 0 0-1-1h-.5v-1.5a1 1 0 0 0-1-1h-2.5a1 1 0 0 0-1 1v1.5h-3v-1.5a1 1 0 0 0-1-1h-2.5a1 1 0 0 0-1 1Zm1.5.5v1h1.5v-1h-1.5Zm7.5 1h1.5v-1h-1.5v1Zm-9 1.5v4.5h12v-4.5h-12Z"
      }));
    };
    SvgMetafieldsIcon.displayName = "MetafieldsIcon";
    exports.SvgMetafieldsIcon = SvgMetafieldsIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MetaobjectFilledIcon.svg.js
var require_MetaobjectFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MetaobjectFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMetaobjectFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 6.5v-1.5a1 1 0 0 1 1-1h2.5a1 1 0 0 1 1 1v1.5h.5a1 1 0 0 1 1 1v3.5h1.5v-1.5a1 1 0 0 1 1-1h2.5a1 1 0 0 1 1 1v1.5h.5a1 1 0 0 1 1 1v4a1 1 0 0 1-1 1h-13a1 1 0 0 1-1-1v-4c0-.086.01-.17.031-.25a1.002 1.002 0 0 1-.031-.25v-4a1 1 0 0 1 1-1h.5Z"
      }));
    };
    SvgMetaobjectFilledIcon.displayName = "MetaobjectFilledIcon";
    exports.SvgMetaobjectFilledIcon = SvgMetaobjectFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MetaobjectIcon.svg.js
var require_MetaobjectIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MetaobjectIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMetaobjectIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 6.5v-1.5a1 1 0 0 1 1-1h2.5a1 1 0 0 1 1 1v1.5h.5a1 1 0 0 1 1 1v3.5h1.5v-1.5a1 1 0 0 1 1-1h2.5a1 1 0 0 1 1 1v1.5h.5a1 1 0 0 1 1 1v4a1 1 0 0 1-1 1h-13a1 1 0 0 1-1-1v-4c0-.086.01-.17.031-.25a1.002 1.002 0 0 1-.031-.25v-4a1 1 0 0 1 1-1h.5Zm1.5 0v-1h1.5v1h-1.5Zm-1.5 1.5v3h4.5v-3h-4.5Zm10.5 3h-1.5v-1h1.5v1Zm1.5 1.5v3h-12v-3h12Z"
      }));
    };
    SvgMetaobjectIcon.displayName = "MetaobjectIcon";
    exports.SvgMetaobjectIcon = SvgMetaobjectIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MetaobjectReferenceIcon.svg.js
var require_MetaobjectReferenceIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MetaobjectReferenceIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMetaobjectReferenceIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 3.5v1.5h-.5a1 1 0 0 0-1 1v4c0 .086.01.17.031.25-.02.08-.031.164-.031.25v.75a.75.75 0 0 0 1.5 0v-.25h12v3.75h-6.25a.75.75 0 0 0 0 1.5h6.75a1 1 0 0 0 1-1v-4.75a1 1 0 0 0-1-1h-.5v-1.5a1 1 0 0 0-1-1h-2.5a1 1 0 0 0-1 1v1.5h-1.5v-3.5a1 1 0 0 0-1-1h-.5v-1.5a1 1 0 0 0-1-1h-2.5a1 1 0 0 0-1 1Zm1.5.5v1h1.5v-1h-1.5Zm3 2.5v3h-4.5v-3h4.5Zm4.5 3h1.5v-1h-1.5v1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4 15c-.69 0-1.25.56-1.25 1.25v.5a.75.75 0 0 1-1.5 0v-.5a2.75 2.75 0 0 1 2.75-2.75h1.44l-.47-.47a.75.75 0 1 1 1.06-1.06l1.75 1.75a.75.75 0 0 1 0 1.06l-1.75 1.75a.75.75 0 0 1-1.06-1.06l.47-.47h-1.44Z"
      }));
    };
    SvgMetaobjectReferenceIcon.displayName = "MetaobjectReferenceIcon";
    exports.SvgMetaobjectReferenceIcon = SvgMetaobjectReferenceIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MicrophoneIcon.svg.js
var require_MicrophoneIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MicrophoneIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMicrophoneIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 3a3.25 3.25 0 0 0-3.25 3.25v2a3.25 3.25 0 0 0 6.5 0v-2a3.25 3.25 0 0 0-3.25-3.25Zm1.75 5.25a1.75 1.75 0 1 1-3.5 0v-2a1.75 1.75 0 1 1 3.5 0v2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.5 8a.75.75 0 0 0-1.5 0v.25c0 3.06 2.29 5.585 5.25 5.954v1.546h-1.25a.75.75 0 0 0 0 1.5h4a.75.75 0 0 0 0-1.5h-1.25v-1.546a6.001 6.001 0 0 0 5.25-5.954v-.25a.75.75 0 0 0-1.5 0v.25a4.5 4.5 0 1 1-9 0v-.25Z"
      }));
    };
    SvgMicrophoneIcon.displayName = "MicrophoneIcon";
    exports.SvgMicrophoneIcon = SvgMicrophoneIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MinimizeIcon.svg.js
var require_MinimizeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MinimizeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMinimizeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.75 9.5a.75.75 0 0 0 0-1.5h-.69l3.22-3.22a.75.75 0 0 0-1.06-1.06l-3.22 3.22v-.69a.75.75 0 0 0-1.5 0v2.5c0 .414.336.75.75.75h2.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.25 10.5a.75.75 0 0 0 0 1.5h.69l-3.22 3.22a.75.75 0 1 0 1.06 1.06l3.22-3.22v.69a.75.75 0 0 0 1.5 0v-2.5a.75.75 0 0 0-.75-.75h-2.5Z"
      }));
    };
    SvgMinimizeIcon.displayName = "MinimizeIcon";
    exports.SvgMinimizeIcon = SvgMinimizeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MinusCircleIcon.svg.js
var require_MinusCircleIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MinusCircleIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMinusCircleIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M7 9.25a.75.75 0 0 0 0 1.5h6a.75.75 0 0 0 0-1.5h-6Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-1.5 0a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Z"
      }));
    };
    SvgMinusCircleIcon.displayName = "MinusCircleIcon";
    exports.SvgMinusCircleIcon = SvgMinusCircleIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MinusIcon.svg.js
var require_MinusIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MinusIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMinusIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6 10a.75.75 0 0 1 .75-.75h6.5a.75.75 0 0 1 0 1.5h-6.5a.75.75 0 0 1-.75-.75Z"
      }));
    };
    SvgMinusIcon.displayName = "MinusIcon";
    exports.SvgMinusIcon = SvgMinusIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MobileIcon.svg.js
var require_MobileIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MobileIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMobileIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.5 13a.75.75 0 0 0 0 1.5h3a.75.75 0 0 0 0-1.5h-3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.5 3a2.75 2.75 0 0 0-2.75 2.75v8.5a2.75 2.75 0 0 0 2.75 2.75h5a2.75 2.75 0 0 0 2.75-2.75v-8.5a2.75 2.75 0 0 0-2.75-2.75h-5Zm-1.25 2.75c0-.69.56-1.25 1.25-1.25h5c.69 0 1.25.56 1.25 1.25v8.5c0 .69-.56 1.25-1.25 1.25h-5c-.69 0-1.25-.56-1.25-1.25v-8.5Z"
      }));
    };
    SvgMobileIcon.displayName = "MobileIcon";
    exports.SvgMobileIcon = SvgMobileIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MoneyFilledIcon.svg.js
var require_MoneyFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MoneyFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMoneyFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.871 4h7.008c.395 0 .736 0 1.017.023.297.024.592.078.875.222.424.216.768.56.984.984.144.283.198.578.222.875.023.28.023.622.023 1.017v2.758c0 .395 0 .736-.023 1.017a2.29 2.29 0 0 1-.222.875 2.25 2.25 0 0 1-.983.984c-.284.144-.58.198-.876.222-.12.01-.253.016-.396.019 0 .346-.002.647-.023.9a2.29 2.29 0 0 1-.222.875 2.25 2.25 0 0 1-.984.984 2.29 2.29 0 0 1-.875.222c-.28.023-.622.023-1.017.023h-7.258c-.395 0-.736 0-1.017-.023a2.29 2.29 0 0 1-.875-.222 2.25 2.25 0 0 1-.984-.984 2.29 2.29 0 0 1-.222-.875c-.023-.28-.023-.622-.023-1.017v-2.758c0-.395 0-.736.023-1.017a2.29 2.29 0 0 1 .222-.875 2.25 2.25 0 0 1 .984-.984 2.29 2.29 0 0 1 .875-.222c.189-.015.405-.02.646-.022 0-.345.002-.645.023-.897a2.29 2.29 0 0 1 .222-.875 2.25 2.25 0 0 1 .984-.984 2.29 2.29 0 0 1 .875-.222c.28-.023.622-.023 1.017-.023Zm7.903 7.482c-.08.007-.17.01-.274.013v-1.374c0-.395 0-.736-.023-1.017a2.29 2.29 0 0 0-.222-.875 2.25 2.25 0 0 0-.984-.984 2.29 2.29 0 0 0-.875-.222c-.28-.023-.622-.023-1.017-.023h-6.129c0-.349.003-.587.018-.774.017-.204.045-.28.064-.316a.75.75 0 0 1 .328-.328c.037-.02.112-.047.316-.064.212-.017.492-.018.924-.018h6.95c.432 0 .712 0 .924.018.204.017.28.045.316.064a.75.75 0 0 1 .328.328c.02.037.047.112.064.316.017.212.018.492.018.924v2.7c0 .432 0 .712-.018.924-.017.204-.045.28-.064.317a.75.75 0 0 1-.328.327c-.037.02-.112.047-.316.064Zm-6.15 2.368c.356-.536.626-1.362.626-2.35s-.27-1.814-.627-2.35c-.364-.546-.702-.65-.873-.65-.17 0-.51.104-.873.65-.357.536-.627 1.362-.627 2.35s.27 1.814.627 2.35c.364.546.702.65.873.65.17 0 .51-.104.873-.65Z"
      }));
    };
    SvgMoneyFilledIcon.displayName = "MoneyFilledIcon";
    exports.SvgMoneyFilledIcon = SvgMoneyFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MoneyIcon.svg.js
var require_MoneyIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MoneyIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMoneyIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9.755 3.145a1.25 1.25 0 0 1 1.008.015l5.654 2.591a1 1 0 0 1 .583.91v.59a1 1 0 0 1-1 1h-.5v3.749h.25a.75.75 0 0 1 0 1.5h-11.5a.75.75 0 0 1 0-1.5h.25v-3.75h-.5a1 1 0 0 1-1-1v-.584a1 1 0 0 1 .61-.921l6.145-2.6Zm.483 1.425-5.154 2.18h9.911l-4.757-2.18Zm3.762 7.43v-3.75h-1.5v3.75h1.5Zm-5-3.75h2v3.75h-2v-3.75Zm-1.5 3.75v-3.75h-1.5v3.75h1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 15.25a.75.75 0 0 1 .75-.75h11.5a.75.75 0 0 1 0 1.5h-11.5a.75.75 0 0 1-.75-.75Z"
      }));
    };
    SvgMoneyIcon.displayName = "MoneyIcon";
    exports.SvgMoneyIcon = SvgMoneyIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MoneyNoneIcon.svg.js
var require_MoneyNoneIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/MoneyNoneIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgMoneyNoneIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17.773 3.322a.774.774 0 1 0-1.095-1.095l-14.451 14.451a.774.774 0 1 0 1.095 1.095l1.773-1.773h7.284c.395 0 .736 0 1.017-.023a2.29 2.29 0 0 0 .875-.222 2.25 2.25 0 0 0 .984-.984 2.29 2.29 0 0 0 .222-.875c.02-.253.023-.554.023-.9.143-.003.275-.009.396-.019a2.29 2.29 0 0 0 .875-.222 2.25 2.25 0 0 0 .984-.984 2.29 2.29 0 0 0 .222-.875c.023-.28.023-.622.023-1.017v-2.758c0-.395 0-.736-.023-1.017a2.29 2.29 0 0 0-.222-.875 2.25 2.25 0 0 0-.932-.957l.95-.95Zm-2.185 2.185-1.618 1.617c.102.031.202.07.301.121.424.216.768.56.984.984.144.283.198.578.222.875.023.28.023.622.023 1.017v1.374c.104-.002.194-.006.274-.013.204-.017.28-.045.316-.064a.75.75 0 0 0 .328-.327c.02-.038.047-.113.064-.317.017-.212.018-.492.018-.924v-2.7c0-.432 0-.712-.018-.924-.017-.204-.045-.28-.064-.316a.75.75 0 0 0-.328-.328c-.037-.02-.112-.047-.316-.064a4.246 4.246 0 0 0-.186-.01Zm-4.112 4.112 1.119-1.119c.298 0 .51.004.68.018.203.017.278.045.316.064a.75.75 0 0 1 .327.328c.02.037.047.112.064.316.017.212.018.492.018.924v2.7c0 .432 0 .712-.018.924-.017.204-.045.28-.064.317a.75.75 0 0 1-.327.327c-.038.02-.113.047-.317.064-.212.017-.492.018-.924.018h-1.364c.475-.796.764-1.848.764-3 0-.672-.098-1.309-.274-1.881Zm-1.262 1.262-2.564 2.563c.07.15.146.285.227.406.364.546.702.65.873.65.17 0 .51-.104.873-.65.357-.536.627-1.362.627-2.35 0-.214-.013-.421-.036-.619Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.871 4h5.034l-1.5 1.5h-3.505c-.432 0-.712 0-.924.018-.204.017-.28.045-.316.064a.75.75 0 0 0-.328.328c-.02.037-.047.112-.064.316-.015.187-.018.425-.018.774h3.655l-4.146 4.146c.053-1.013.329-1.932.755-2.646h-1.364c-.432 0-.712 0-.924.018-.204.017-.28.045-.316.064a.75.75 0 0 0-.328.328c-.02.037-.047.112-.064.316-.017.212-.018.492-.018.924v2.7c0 .22 0 .4.003.553l-1.294 1.293a2.377 2.377 0 0 1-.186-.8c-.023-.28-.023-.622-.023-1.017v-2.758c0-.395 0-.736.023-1.017a2.29 2.29 0 0 1 .222-.875 2.25 2.25 0 0 1 .984-.984 2.29 2.29 0 0 1 .875-.222c.189-.015.405-.02.646-.022 0-.345.002-.645.023-.897a2.29 2.29 0 0 1 .222-.875 2.25 2.25 0 0 1 .984-.984 2.29 2.29 0 0 1 .875-.222c.28-.023.622-.023 1.017-.023Z"
      }));
    };
    SvgMoneyNoneIcon.displayName = "MoneyNoneIcon";
    exports.SvgMoneyNoneIcon = SvgMoneyNoneIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/NatureIcon.svg.js
var require_NatureIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/NatureIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgNatureIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 3a1 1 0 0 0-1 1v4.25a6.75 6.75 0 0 0 6.75 6.75v1.25a.75.75 0 0 0 1.5 0v-1.293a6.501 6.501 0 0 0 5.75-6.457v-1.52a.98.98 0 0 0-.98-.98c-1.99 0-3.762.926-4.91 2.371a6.752 6.752 0 0 0-6.61-5.371h-.5Zm8.035 10.26a5.002 5.002 0 0 0 3.465-4.76v-.972a4.772 4.772 0 0 0-4.227 4.275l1.387-1.766a.75.75 0 1 1 1.18.926l-1.805 2.297Zm-5.905-4.338 3.104 4.553a5.25 5.25 0 0 1-4.734-5.225v-3.75c2.9 0 5.25 2.35 5.25 5.25v1.819l-2.38-3.492a.75.75 0 1 0-1.24.845Z"
      }));
    };
    SvgNatureIcon.displayName = "NatureIcon";
    exports.SvgNatureIcon = SvgNatureIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/NoteAddIcon.svg.js
var require_NoteAddIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/NoteAddIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgNoteAddIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 6.25a2.75 2.75 0 0 1 2.75-2.75h7.5a2.75 2.75 0 0 1 2.75 2.75v4.52a.75.75 0 0 1-1.5 0v-4.52c0-.69-.56-1.25-1.25-1.25h-7.5c-.69 0-1.25.56-1.25 1.25v7.5c0 .69.56 1.25 1.25 1.25h4.92a.75.75 0 0 1 0 1.5h-4.92a2.75 2.75 0 0 1-2.75-2.75v-7.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.75 12.5a.75.75 0 0 1 .75.75v1.25h1.25a.75.75 0 0 1 0 1.5h-1.25v1.25a.75.75 0 0 1-1.5 0v-1.25h-1.25a.75.75 0 0 1 0-1.5h1.25v-1.25a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.55 7.25a.7.7 0 0 1 .7-.7h5.5a.7.7 0 1 1 0 1.4h-5.5a.7.7 0 0 1-.7-.7Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7 9.05a.7.7 0 1 0 0 1.4h2.25a.7.7 0 1 0 0-1.4h-2.25Z"
      }));
    };
    SvgNoteAddIcon.displayName = "NoteAddIcon";
    exports.SvgNoteAddIcon = SvgNoteAddIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/NoteIcon.svg.js
var require_NoteIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/NoteIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgNoteIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.55 7.25a.7.7 0 0 1 .7-.7h5.5a.7.7 0 0 1 0 1.4h-5.5a.7.7 0 0 1-.7-.7Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7 9.05a.7.7 0 0 0 0 1.4h2.25a.7.7 0 1 0 0-1.4h-2.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 6.25a2.75 2.75 0 0 1 2.75-2.75h7.5a2.75 2.75 0 0 1 2.75 2.75v5.5a.75.75 0 0 1-.22.53l-4 4a.75.75 0 0 1-.53.22h-5.5a2.75 2.75 0 0 1-2.75-2.75v-7.5Zm2.75-1.25c-.69 0-1.25.56-1.25 1.25v7.5c0 .69.56 1.25 1.25 1.25h4.75v-2.25c0-.966.784-1.75 1.75-1.75h2.25v-4.75c0-.69-.56-1.25-1.25-1.25h-7.5Zm7.69 7.5h-1.19a.25.25 0 0 0-.25.25v1.19l1.44-1.44Z"
      }));
    };
    SvgNoteIcon.displayName = "NoteIcon";
    exports.SvgNoteIcon = SvgNoteIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/NotificationFilledIcon.svg.js
var require_NotificationFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/NotificationFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgNotificationFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "m7.252 14.424-2.446-.281c-1.855-.213-2.38-2.659-.778-3.616l.065-.038a2.887 2.887 0 0 0 1.407-2.48v-.509a4.5 4.5 0 0 1 9 0v.51c0 1.016.535 1.958 1.408 2.479l.065.038c1.602.957 1.076 3.403-.778 3.616l-2.543.292v.365a2.7 2.7 0 0 1-5.4 0v-.376Zm3.9.076h-2.4v.3a1.2 1.2 0 0 0 2.4 0v-.3Z"
      }));
    };
    SvgNotificationFilledIcon.displayName = "NotificationFilledIcon";
    exports.SvgNotificationFilledIcon = SvgNotificationFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/NotificationIcon.svg.js
var require_NotificationIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/NotificationIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgNotificationIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "m7.252 14.424-2.446-.281c-1.855-.213-2.38-2.659-.778-3.616l.065-.038a2.887 2.887 0 0 0 1.407-2.48v-.509a4.5 4.5 0 0 1 9 0v.51c0 1.016.535 1.958 1.408 2.479l.065.038c1.602.957 1.076 3.403-.778 3.616l-2.543.292v.365a2.7 2.7 0 0 1-5.4 0v-.376Zm3.9.076h-2.4v.3a1.2 1.2 0 0 0 2.4 0v-.3Zm-3.152-1.5h4l3.024-.348a.452.452 0 0 0 .18-.837l-.065-.038a4.414 4.414 0 0 1-.747-.562 4.387 4.387 0 0 1-1.392-3.205v-.51a3 3 0 0 0-6 0v.51a4.387 4.387 0 0 1-2.138 3.767l-.065.038a.452.452 0 0 0 .18.838l3.023.347Z"
      }));
    };
    SvgNotificationIcon.displayName = "NotificationIcon";
    exports.SvgNotificationIcon = SvgNotificationIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrderDraftFilledIcon.svg.js
var require_OrderDraftFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrderDraftFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgOrderDraftFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.704 1.104a.5.5 0 0 0-.707 0l-.957.957 1.768 1.767.957-.957a.5.5 0 0 0 0-.707l-1.06-1.06Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "m16.1 4.536-1.767-1.768-3.83 3.83a2 2 0 0 0-.585 1.348l-.026.772a.25.25 0 0 0 .258.258l.772-.025a2 2 0 0 0 1.348-.585l3.83-3.83Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.739 6.067a1.25 1.25 0 0 1 1.237-1.067h3.774a.75.75 0 0 0 0-1.5h-3.774a2.75 2.75 0 0 0-2.72 2.347l-.662 4.46a8.75 8.75 0 0 0-.094 1.282v1.661a3.25 3.25 0 0 0 3.25 3.25h6.5a3.25 3.25 0 0 0 3.25-3.25v-1.66c0-.43-.032-.858-.095-1.283l-.413-2.792a.75.75 0 0 0-1.484.22l.336 2.265h-2.484a1.25 1.25 0 0 0-1.185.855l-.159.474a.25.25 0 0 1-.237.171h-1.558a.25.25 0 0 1-.237-.17l-.159-.475a1.25 1.25 0 0 0-1.185-.855h-2.484l.583-3.933Z"
      }));
    };
    SvgOrderDraftFilledIcon.displayName = "OrderDraftFilledIcon";
    exports.SvgOrderDraftFilledIcon = SvgOrderDraftFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrderDraftIcon.svg.js
var require_OrderDraftIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrderDraftIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgOrderDraftIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.997 1.104a.5.5 0 0 1 .707 0l1.06 1.06a.5.5 0 0 1 0 .707l-.956.957-1.768-1.767.957-.957Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "m14.333 2.768 1.768 1.768-3.831 3.83a2 2 0 0 1-1.348.585l-.772.025a.25.25 0 0 1-.258-.258l.026-.772a2 2 0 0 1 .584-1.348l3.83-3.83Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.976 5a1.25 1.25 0 0 0-1.237 1.067l-.583 3.933h2.484a1.25 1.25 0 0 1 1.185.855l.159.474a.25.25 0 0 0 .237.171h1.558a.25.25 0 0 0 .237-.17l.159-.475a1.25 1.25 0 0 1 1.185-.855h2.484l-.336-2.265a.75.75 0 1 1 1.484-.22l.413 2.792c.063.425.095.853.095 1.282v1.661a3.25 3.25 0 0 1-3.25 3.25h-6.5a3.25 3.25 0 0 1-3.25-3.25v-1.66c0-.43.032-.858.094-1.283l.661-4.46a2.75 2.75 0 0 1 2.72-2.347h3.775a.75.75 0 0 1 0 1.5h-3.774Zm-1.976 6.59v-.09h2.46l.1.303a1.75 1.75 0 0 0 1.66 1.197h1.56a1.75 1.75 0 0 0 1.66-1.197l.1-.303h2.46v1.75a1.75 1.75 0 0 1-1.75 1.75h-6.5a1.75 1.75 0 0 1-1.75-1.75v-1.66Z"
      }));
    };
    SvgOrderDraftIcon.displayName = "OrderDraftIcon";
    exports.SvgOrderDraftIcon = SvgOrderDraftIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrderFilledIcon.svg.js
var require_OrderFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrderFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgOrderFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4.255 5.847a2.75 2.75 0 0 1 2.72-2.347h6.05a2.75 2.75 0 0 1 2.72 2.347l.66 4.46c.063.425.095.853.095 1.282v1.661a3.25 3.25 0 0 1-3.25 3.25h-6.5a3.25 3.25 0 0 1-3.25-3.25v-1.66c0-.43.032-.858.094-1.283l.661-4.46Zm2.72-.847a1.25 1.25 0 0 0-1.236 1.067l-.583 3.933h2.484a1.25 1.25 0 0 1 1.185.855l.159.474a.25.25 0 0 0 .237.171h1.558a.25.25 0 0 0 .237-.17l.159-.475a1.25 1.25 0 0 1 1.185-.855h2.484l-.583-3.933a1.25 1.25 0 0 0-1.236-1.067h-6.05Z"
      }));
    };
    SvgOrderFilledIcon.displayName = "OrderFilledIcon";
    exports.SvgOrderFilledIcon = SvgOrderFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrderFirstIcon.svg.js
var require_OrderFirstIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrderFirstIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgOrderFirstIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.72 4.28a.75.75 0 0 1 1.06-1.06l.5.5a.75.75 0 0 1-1.06 1.06l-.5-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.013 7.462a.75.75 0 1 1 .474-1.424l1.5.5a.75.75 0 1 1-.474 1.424l-1.5-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.28 3.22a.75.75 0 0 1 0 1.06l-.5.5a.75.75 0 1 1-1.06-1.06l.5-.5a.75.75 0 0 1 1.06 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.462 6.513a.75.75 0 0 1-.475.949l-1.5.5a.75.75 0 0 1-.474-1.424l1.5-.5a.75.75 0 0 1 .949.475Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "m9.751 5.687-.493 3.457a.75.75 0 0 0 1.485.212l.715-5.01c.107-.75-.745-1.255-1.351-.801l-1.807 1.355a.75.75 0 0 0 .9 1.2l.551-.413Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "m5.156 10 .132-.89a.75.75 0 1 0-1.484-.22l-.21 1.417a8.749 8.749 0 0 0-.094 1.282v1.661a3.25 3.25 0 0 0 3.25 3.25h6.5a3.25 3.25 0 0 0 3.25-3.25v-1.66c0-.43-.032-.858-.095-1.283l-.21-1.417a.75.75 0 0 0-1.483.22l.132.89h-2.484a1.25 1.25 0 0 0-1.185.855l-.159.474a.25.25 0 0 1-.237.171h-1.558a.25.25 0 0 1-.237-.17l-.159-.475a1.25 1.25 0 0 0-1.185-.855h-2.484Zm-.155 1.5-.001.09v1.66c0 .967.784 1.75 1.75 1.75h6.5a1.75 1.75 0 0 0 1.75-1.75v-1.75h-2.46l-.1.303a1.75 1.75 0 0 1-1.66 1.197h-1.56a1.75 1.75 0 0 1-1.66-1.197l-.1-.303h-2.46Z"
      }));
    };
    SvgOrderFirstIcon.displayName = "OrderFirstIcon";
    exports.SvgOrderFirstIcon = SvgOrderFirstIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrderFulfilledIcon.svg.js
var require_OrderFulfilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrderFulfilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgOrderFulfilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.28 4.78a.75.75 0 0 0-1.06-1.06l-2.97 2.97-1.22-1.22a.75.75 0 0 0-1.06 1.06l1.75 1.75a.75.75 0 0 0 1.06 0l3.5-3.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4.86 6.883a.75.75 0 0 1 .632.852l-.336 2.265h2.484a1.25 1.25 0 0 1 1.185.855l.159.474a.25.25 0 0 0 .237.171h1.558a.25.25 0 0 0 .237-.17l.159-.475a1.25 1.25 0 0 1 1.185-.855h2.484l-.336-2.265a.75.75 0 1 1 1.484-.22l.413 2.792c.063.425.095.853.095 1.282v1.661a3.25 3.25 0 0 1-3.25 3.25h-6.5a3.25 3.25 0 0 1-3.25-3.25v-1.66c0-.43.032-.858.094-1.283l.414-2.792a.75.75 0 0 1 .852-.632Zm.14 4.706v-.089h2.46l.1.303a1.75 1.75 0 0 0 1.66 1.197h1.56a1.75 1.75 0 0 0 1.66-1.197l.1-.303h2.46v1.75a1.75 1.75 0 0 1-1.75 1.75h-6.5a1.75 1.75 0 0 1-1.75-1.75v-1.66Z"
      }));
    };
    SvgOrderFulfilledIcon.displayName = "OrderFulfilledIcon";
    exports.SvgOrderFulfilledIcon = SvgOrderFulfilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrderIcon.svg.js
var require_OrderIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrderIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgOrderIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.976 3.5a2.75 2.75 0 0 0-2.72 2.347l-.662 4.46a8.75 8.75 0 0 0-.094 1.282v1.661a3.25 3.25 0 0 0 3.25 3.25h6.5a3.25 3.25 0 0 0 3.25-3.25v-1.66c0-.43-.032-.858-.095-1.283l-.66-4.46a2.75 2.75 0 0 0-2.72-2.347h-6.05Zm-1.237 2.567a1.25 1.25 0 0 1 1.237-1.067h6.048c.62 0 1.146.454 1.237 1.067l.583 3.933h-2.484a1.25 1.25 0 0 0-1.185.855l-.159.474a.25.25 0 0 1-.237.171h-1.558a.25.25 0 0 1-.237-.17l-.159-.475a1.25 1.25 0 0 0-1.185-.855h-2.484l.583-3.933Zm-.738 5.433-.001.09v1.66c0 .966.784 1.75 1.75 1.75h6.5a1.75 1.75 0 0 0 1.75-1.75v-1.75h-2.46l-.1.303a1.75 1.75 0 0 1-1.66 1.197h-1.56a1.75 1.75 0 0 1-1.66-1.197l-.1-.303h-2.46Z"
      }));
    };
    SvgOrderIcon.displayName = "OrderIcon";
    exports.SvgOrderIcon = SvgOrderIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrderRepeatIcon.svg.js
var require_OrderRepeatIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrderRepeatIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgOrderRepeatIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13 3.25a.75.75 0 0 1 .75-.75h.5a2.75 2.75 0 1 1 0 5.5h-3.94l.72.72a.75.75 0 1 1-1.06 1.06l-2-2a.75.75 0 0 1 0-1.06l2-2a.75.75 0 1 1 1.06 1.06l-.72.72h3.94a1.25 1.25 0 1 0 0-2.5h-.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.739 6.067a1.25 1.25 0 0 1 1.237-1.067h.274a.75.75 0 0 0 0-1.5h-.274a2.75 2.75 0 0 0-2.72 2.347l-.662 4.46a8.75 8.75 0 0 0-.094 1.282v1.661a3.25 3.25 0 0 0 3.25 3.25h6.5a3.25 3.25 0 0 0 3.25-3.25v-1.66c0-.43-.032-.858-.095-1.283l-.122-.828a.75.75 0 0 0-1.484.22l.045.301h-2.484a1.25 1.25 0 0 0-1.185.855l-.159.474a.25.25 0 0 1-.237.171h-1.558a.25.25 0 0 1-.237-.17l-.159-.475a1.25 1.25 0 0 0-1.185-.855h-2.484l.583-3.933Zm-.738 5.433-.001.09v1.66c0 .966.784 1.75 1.75 1.75h6.5a1.75 1.75 0 0 0 1.75-1.75v-1.75h-2.46l-.1.303a1.75 1.75 0 0 1-1.66 1.197h-1.56a1.75 1.75 0 0 1-1.66-1.197l-.1-.303h-2.46Z"
      }));
    };
    SvgOrderRepeatIcon.displayName = "OrderRepeatIcon";
    exports.SvgOrderRepeatIcon = SvgOrderRepeatIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrderUnfulfilledIcon.svg.js
var require_OrderUnfulfilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrderUnfulfilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgOrderUnfulfilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.53 4.78a.75.75 0 0 0-1.06-1.06l-1.47 1.47-1.47-1.47a.75.75 0 0 0-1.06 1.06l1.47 1.47-1.47 1.47a.75.75 0 0 0 1.06 1.06l1.47-1.47 1.47 1.47a.75.75 0 1 0 1.06-1.06l-1.47-1.47 1.47-1.47Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "m14.844 10-.336-2.265a.75.75 0 1 1 1.484-.22l.413 2.792c.063.425.095.853.095 1.282v1.661a3.25 3.25 0 0 1-3.25 3.25h-6.5a3.25 3.25 0 0 1-3.25-3.25v-1.66c0-.43.032-.858.094-1.283l.414-2.792a.75.75 0 0 1 1.484.22l-.336 2.265h2.484a1.25 1.25 0 0 1 1.185.855l.159.474a.25.25 0 0 0 .237.171h1.558a.25.25 0 0 0 .237-.17l.159-.475a1.25 1.25 0 0 1 1.185-.855h2.484Zm-9.843 1.5-.001.09v1.66c0 .967.784 1.75 1.75 1.75h6.5a1.75 1.75 0 0 0 1.75-1.75v-1.75h-2.46l-.1.303a1.75 1.75 0 0 1-1.66 1.197h-1.56a1.75 1.75 0 0 1-1.66-1.197l-.1-.303h-2.46Z"
      }));
    };
    SvgOrderUnfulfilledIcon.displayName = "OrderUnfulfilledIcon";
    exports.SvgOrderUnfulfilledIcon = SvgOrderUnfulfilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrdersStatusIcon.svg.js
var require_OrdersStatusIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrdersStatusIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgOrdersStatusIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "m8.579 5.615-.867 1.409a1 1 0 0 1-.852.476h-1.86a.75.75 0 1 1 0-1.5h1.58l1.428-2.32c.486-.79 1.693-.55 1.84.367l.59 3.694.864-1.296a1 1 0 0 1 .832-.445h2.866a.75.75 0 0 1 0 1.5h-2.599l-1.423 2.135c-.505.757-1.676.501-1.82-.397l-.58-3.623Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "m5.156 10 .132-.89a.75.75 0 1 0-1.484-.22l-.21 1.417a8.75 8.75 0 0 0-.094 1.282v1.661a3.25 3.25 0 0 0 3.25 3.25h6.5a3.25 3.25 0 0 0 3.25-3.25v-1.66c0-.43-.032-.858-.095-1.283l-.21-1.417a.75.75 0 0 0-1.483.22l.132.89h-2.484a1.25 1.25 0 0 0-1.185.855l-.159.474a.25.25 0 0 1-.237.171h-1.558a.25.25 0 0 1-.237-.17l-.159-.475a1.25 1.25 0 0 0-1.185-.855h-2.484Zm-.155 1.5-.001.09v1.66c0 .967.784 1.75 1.75 1.75h6.5a1.75 1.75 0 0 0 1.75-1.75v-1.75h-2.46l-.1.303a1.75 1.75 0 0 1-1.66 1.197h-1.56a1.75 1.75 0 0 1-1.66-1.197l-.1-.303h-2.46Z"
      }));
    };
    SvgOrdersStatusIcon.displayName = "OrdersStatusIcon";
    exports.SvgOrdersStatusIcon = SvgOrdersStatusIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrganizationIcon.svg.js
var require_OrganizationIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OrganizationIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgOrganizationIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.75 9a.75.75 0 0 0 0 1.5h.5a.75.75 0 0 0 0-1.5h-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.75 9.75a.75.75 0 0 1 .75-.75h.5a.75.75 0 0 1 0 1.5h-.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.5 6.5a.75.75 0 0 0 0 1.5h.5a.75.75 0 0 0 0-1.5h-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6 7.25a.75.75 0 0 1 .75-.75h.5a.75.75 0 0 1 0 1.5h-.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 5.25c0-.966.784-1.75 1.75-1.75h6.25c.966 0 1.75.784 1.75 1.75v1.75h1.5c.966 0 1.75.784 1.75 1.75v6a1.75 1.75 0 0 1-1.75 1.75h-9.5a1.75 1.75 0 0 1-1.75-1.75v-9.5Zm4.25 9.75h1.25v-1.25a.25.25 0 0 0-.25-.25h-.75a.25.25 0 0 0-.25.25v1.25Zm2.75 0v-1.25a1.75 1.75 0 0 0-1.75-1.75h-.75a1.75 1.75 0 0 0-1.75 1.75v1.25h-1a.25.25 0 0 1-.25-.25v-9.5a.25.25 0 0 1 .25-.25h6.25a.25.25 0 0 1 .25.25v9.5a.25.25 0 0 1-.25.25h-1Zm2.75-.25v-6.25h1.5a.25.25 0 0 1 .25.25v6a.25.25 0 0 1-.25.25h-1.518a1.72 1.72 0 0 0 .018-.25Z"
      }));
    };
    SvgOrganizationIcon.displayName = "OrganizationIcon";
    exports.SvgOrganizationIcon = SvgOrganizationIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OutdentIcon.svg.js
var require_OutdentIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OutdentIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgOutdentIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.75 4a.75.75 0 0 0 0 1.5h12.5a.75.75 0 0 0 0-1.5h-12.5Zm7 3.5a.75.75 0 0 0 0 1.5h5.5a.75.75 0 0 0 0-1.5h-5.5Zm-.75 4.25a.75.75 0 0 1 .75-.75h5.5a.75.75 0 0 1 0 1.5h-5.5a.75.75 0 0 1-.75-.75Zm-6.25 2.75a.75.75 0 0 0 0 1.5h12.5a.75.75 0 0 0 0-1.5h-12.5Zm4.25-2.093c0 .473-.55.755-.96.493l-3.765-2.408a.579.579 0 0 1 0-.985l3.765-2.407c.41-.262.96.02.96.493v4.814Z"
      }));
    };
    SvgOutdentIcon.displayName = "OutdentIcon";
    exports.SvgOutdentIcon = SvgOutdentIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OutgoingIcon.svg.js
var require_OutgoingIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/OutgoingIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgOutgoingIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.22 4.03a.75.75 0 0 1 1.06-1.06l2.5 2.5a.75.75 0 0 1 0 1.06l-2.5 2.5a.75.75 0 1 1-1.06-1.06l1.22-1.22h-1.44a2.25 2.25 0 0 0-2.25 2.25v3.75a.75.75 0 0 1-1.5 0v-3.75a3.75 3.75 0 0 1 3.75-3.75h1.44l-1.22-1.22Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.75 13.25a.75.75 0 0 1 .75.75v.51a2.25 2.25 0 0 1-2.25 2.25h-8.5a2.25 2.25 0 0 1-2.25-2.25v-.51a.75.75 0 0 1 1.5 0v.51c0 .414.336.75.75.75h8.5a.75.75 0 0 0 .75-.75v-.51a.75.75 0 0 1 .75-.75Z"
      }));
    };
    SvgOutgoingIcon.displayName = "OutgoingIcon";
    exports.SvgOutgoingIcon = SvgOutgoingIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PackageFilledIcon.svg.js
var require_PackageFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PackageFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPackageFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M16 15.975c.31-.316.5-.748.5-1.225v-6.894a2.75 2.75 0 0 0-.462-1.526l-1.219-1.828a2.25 2.25 0 0 0-1.872-1.002h-5.796a2.25 2.25 0 0 0-1.836.95l-1.31 1.847a2.75 2.75 0 0 0-.505 1.59v6.863c0 .477.19.91.5 1.225v.025h.025c.316.31.748.5 1.225.5h9.5c.477 0 .91-.19 1.225-.5h.025v-.025Zm-9.461-10.659a.75.75 0 0 1 .612-.316h2.099v1.5h-3.55l.839-1.184Zm4.211 1.184h3.599l-.778-1.166a.75.75 0 0 0-.624-.334h-2.197v1.5Zm-4 3.75a.5.5 0 0 1 .5-.5h3.5a.5.5 0 0 1 .5.5v2.5a.5.5 0 0 1-.5.5h-3.5a.5.5 0 0 1-.5-.5v-2.5Z"
      }));
    };
    SvgPackageFilledIcon.displayName = "PackageFilledIcon";
    exports.SvgPackageFilledIcon = SvgPackageFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PackageFulfilledIcon.svg.js
var require_PackageFulfilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PackageFulfilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPackageFulfilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5 8v6.75c0 .138.112.25.25.25h4a.75.75 0 0 1 0 1.5h-4a1.75 1.75 0 0 1-1.75-1.75v-6.863c0-.57.177-1.125.506-1.59l1.309-1.848a2.25 2.25 0 0 1 1.836-.949h5.796a2.25 2.25 0 0 1 1.872 1.002l1.22 1.828c.3.452.461.983.461 1.526v3.644a.75.75 0 0 1-1.5 0v-3.5h-10Zm1.539-2.684a.75.75 0 0 1 .612-.316h2.099v1.5h-3.55l.839-1.184Zm7.81 1.184-.778-1.166a.75.75 0 0 0-.624-.334h-2.197v1.5h3.599Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6 10a1 1 0 0 1 1-1h4a1 1 0 0 1 1 1v3a1 1 0 0 1-1 1h-4a1 1 0 0 1-1-1v-3Zm1.5.5v2h3v-2h-3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M17.78 13.22a.75.75 0 0 1 0 1.06l-3.5 3.5a.75.75 0 0 1-1.06 0l-1.75-1.75a.75.75 0 1 1 1.06-1.06l1.22 1.22 2.97-2.97a.75.75 0 0 1 1.06 0Z"
      }));
    };
    SvgPackageFulfilledIcon.displayName = "PackageFulfilledIcon";
    exports.SvgPackageFulfilledIcon = SvgPackageFulfilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PackageIcon.svg.js
var require_PackageIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PackageIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPackageIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7 9a1 1 0 0 0-1 1v3a1 1 0 0 0 1 1h4a1 1 0 0 0 1-1v-3a1 1 0 0 0-1-1h-4Zm.5 3.5v-2h3v2h-3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.315 4.45a2.25 2.25 0 0 1 1.836-.95h5.796a2.25 2.25 0 0 1 1.872 1.002l1.22 1.828c.3.452.461.983.461 1.526v6.894a1.75 1.75 0 0 1-1.75 1.75h-9.5a1.75 1.75 0 0 1-1.75-1.75v-6.863c0-.57.177-1.125.506-1.59l1.309-1.848Zm1.836.55a.75.75 0 0 0-.612.316l-.839 1.184h3.55v-1.5h-2.1Zm3.599 1.5h3.599l-.778-1.166a.75.75 0 0 0-.624-.334h-2.197v1.5Zm4.25 1.5h-10v6.75c0 .138.112.25.25.25h9.5a.25.25 0 0 0 .25-.25v-6.75Z"
      }));
    };
    SvgPackageIcon.displayName = "PackageIcon";
    exports.SvgPackageIcon = SvgPackageIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PackageOnHoldIcon.svg.js
var require_PackageOnHoldIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PackageOnHoldIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPackageOnHoldIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15 8v2.75a.75.75 0 0 0 1.5 0v-2.894a2.75 2.75 0 0 0-.462-1.526l-1.219-1.828a2.25 2.25 0 0 0-1.872-1.002h-5.796a2.25 2.25 0 0 0-1.836.95l-1.31 1.847a2.75 2.75 0 0 0-.505 1.59v6.863c0 .966.784 1.75 1.75 1.75h6a.75.75 0 0 0 0-1.5h-6a.25.25 0 0 1-.25-.25v-6.75h10Zm-7.85-3a.75.75 0 0 0-.611.316l-.839 1.184h3.55v-1.5h-2.1Zm3.6 1.5h3.599l-.778-1.166a.75.75 0 0 0-.624-.334h-2.197v1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7 9a1 1 0 0 0-1 1v3a1 1 0 0 0 1 1h4a1 1 0 0 0 1-1v-3a1 1 0 0 0-1-1h-4Zm.5 3.5v-2h3v2h-3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.75 12.5a.75.75 0 0 1 .75.75v4a.75.75 0 0 1-1.5 0v-4a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.5 13.25a.75.75 0 0 0-1.5 0v4a.75.75 0 0 0 1.5 0v-4Z"
      }));
    };
    SvgPackageOnHoldIcon.displayName = "PackageOnHoldIcon";
    exports.SvgPackageOnHoldIcon = SvgPackageOnHoldIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PackageReturnedIcon.svg.js
var require_PackageReturnedIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PackageReturnedIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPackageReturnedIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15 11.25v-3.25h-10v6.75c0 .138.112.25.25.25h4a.75.75 0 0 1 0 1.5h-4a1.75 1.75 0 0 1-1.75-1.75v-6.863c0-.57.177-1.125.506-1.59l1.309-1.848a2.25 2.25 0 0 1 1.836-.949h5.796a2.25 2.25 0 0 1 1.872 1.002l1.22 1.828c.3.452.461.983.461 1.526v3.394a.75.75 0 0 1-1.5 0Zm-8.461-5.934a.75.75 0 0 1 .612-.316h2.099v1.5h-3.55l.839-1.184Zm7.81 1.184h-3.599v-1.5h2.197a.75.75 0 0 1 .624.334l.778 1.166Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6 10a1 1 0 0 1 1-1h4a1 1 0 0 1 1 1v3a1 1 0 0 1-1 1h-4a1 1 0 0 1-1-1v-3Zm1.5.5v2h3v-2h-3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M17.5 13a.75.75 0 0 0-1.5 0v.5a1.75 1.75 0 0 1-1.75 1.75h-.94l.22-.22a.75.75 0 1 0-1.06-1.06l-1.5 1.5a.75.75 0 0 0 0 1.06l1.5 1.5a.75.75 0 1 0 1.06-1.06l-.22-.22h.94a3.25 3.25 0 0 0 3.25-3.25v-.5Z"
      }));
    };
    SvgPackageReturnedIcon.displayName = "PackageReturnedIcon";
    exports.SvgPackageReturnedIcon = SvgPackageReturnedIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageAddIcon.svg.js
var require_PageAddIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageAddIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPageAddIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.5 5.75c0-.69.56-1.25 1.25-1.25h2.75v3.25c0 .966.784 1.75 1.75 1.75h3.25v1.25a.75.75 0 0 0 1.5 0v-2a.75.75 0 0 0-.22-.53l-5-5a.75.75 0 0 0-.53-.22h-3.5a2.75 2.75 0 0 0-2.75 2.75v8.5a2.75 2.75 0 0 0 2.75 2.75h4.25a.75.75 0 0 0 0-1.5h-4.25c-.69 0-1.25-.56-1.25-1.25v-8.5Zm7.94 2.25-2.44-2.44v2.19c0 .138.112.25.25.25h2.19Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.5 13.25a.75.75 0 0 1 1.5 0v1.25h1.25a.75.75 0 0 1 0 1.5h-1.25v1.25a.75.75 0 0 1-1.5 0v-1.25h-1.25a.75.75 0 0 1 0-1.5h1.25v-1.25Z"
      }));
    };
    SvgPageAddIcon.displayName = "PageAddIcon";
    exports.SvgPageAddIcon = SvgPageAddIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageAttachmentIcon.svg.js
var require_PageAttachmentIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageAttachmentIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPageAttachmentIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.75 4c-.69 0-1.25.56-1.25 1.25v9.5c0 .69.56 1.25 1.25 1.25h6.5c.69 0 1.25-.56 1.25-1.25v-9a.75.75 0 0 1 1.5 0v9a2.75 2.75 0 0 1-2.75 2.75h-6.5a2.75 2.75 0 0 1-2.75-2.75v-9.5a2.75 2.75 0 0 1 2.75-2.75h3a2.75 2.75 0 0 1 2.75 2.75v6.25a2.5 2.5 0 0 1-5 0v-5.5a.75.75 0 0 1 1.5 0v5.5a1 1 0 1 0 2 0v-6.25c0-.69-.56-1.25-1.25-1.25h-3Z"
      }));
    };
    SvgPageAttachmentIcon.displayName = "PageAttachmentIcon";
    exports.SvgPageAttachmentIcon = SvgPageAttachmentIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageClockFilledIcon.svg.js
var require_PageClockFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageClockFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPageClockFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13 3.69v3.31h3.31l-3.31-3.31Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.75 12a.75.75 0 0 0-1.5 0v1.293c0 .331.132.65.366.884l.854.853a.75.75 0 0 0 1.06-1.06l-.78-.78v-1.19Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 8.5v5.75a2.75 2.75 0 0 1-2.75 2.75h-4.421a4.5 4.5 0 1 1-3.579-7.938v-3.312a2.75 2.75 0 0 1 2.75-2.75h2.5v4a1.5 1.5 0 0 0 1.5 1.5h4Zm-10 8a3 3 0 1 0 0-6 3 3 0 0 0 0 6Z"
      }));
    };
    SvgPageClockFilledIcon.displayName = "PageClockFilledIcon";
    exports.SvgPageClockFilledIcon = SvgPageClockFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageClockIcon.svg.js
var require_PageClockIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageClockIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPageClockIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.75 12a.75.75 0 0 0-1.5 0v1.293c0 .331.132.65.366.884l.854.853a.75.75 0 0 0 1.06-1.06l-.78-.78v-1.19Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M14.25 17h-4.421a4.5 4.5 0 1 1-3.579-7.938v-3.312a2.75 2.75 0 0 1 2.75-2.75h3a.75.75 0 0 1 .53.22l4.25 4.25c.141.14.22.331.22.53v6.25a2.75 2.75 0 0 1-2.75 2.75Zm-6.5-11.25c0-.69.56-1.25 1.25-1.25h2.25v2.5c0 .966.784 1.75 1.75 1.75h2.5v5.5c0 .69-.56 1.25-1.25 1.25h-3.218a4.501 4.501 0 0 0-3.282-6.438v-3.312Zm6.69 1.5-1.69-1.69v1.44c0 .138.112.25.25.25h1.44Zm-7.44 9.25a3 3 0 1 0 0-6 3 3 0 0 0 0 6Z"
      }));
    };
    SvgPageClockIcon.displayName = "PageClockIcon";
    exports.SvgPageClockIcon = SvgPageClockIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageDownIcon.svg.js
var require_PageDownIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageDownIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPageDownIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.5 5.75c0-.69.56-1.25 1.25-1.25h2.75v3.25c0 .966.784 1.75 1.75 1.75h3.25v.75a.75.75 0 0 0 1.5 0v-1.5a.75.75 0 0 0-.22-.53l-5-5a.75.75 0 0 0-.53-.22h-3.5a2.75 2.75 0 0 0-2.75 2.75v8.5a2.75 2.75 0 0 0 2.75 2.75h3.25a.75.75 0 0 0 0-1.5h-3.25c-.69 0-1.25-.56-1.25-1.25v-8.5Zm7.94 2.25-2.44-2.44v2.19c0 .138.112.25.25.25h2.19Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15 12.5a.75.75 0 0 0-1.5 0v2.94l-.72-.72a.75.75 0 1 0-1.06 1.06l2 2a.75.75 0 0 0 1.06 0l2-2a.75.75 0 1 0-1.06-1.06l-.72.72v-2.94Z"
      }));
    };
    SvgPageDownIcon.displayName = "PageDownIcon";
    exports.SvgPageDownIcon = SvgPageDownIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageHeartIcon.svg.js
var require_PageHeartIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageHeartIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPageHeartIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.5 5.25c0-.69.56-1.25 1.25-1.25h2.25v3.75c0 .966.784 1.75 1.75 1.75h3.75v1.75a.75.75 0 0 0 1.5 0v-2.5a.75.75 0 0 0-.22-.53l-5.5-5.5a.75.75 0 0 0-.53-.22h-3a2.75 2.75 0 0 0-2.75 2.75v9.5a2.75 2.75 0 0 0 2.75 2.75h1.25a.75.75 0 0 0 0-1.5h-1.25c-.69 0-1.25-.56-1.25-1.25v-9.5Zm7.94 2.75-2.94-2.94v2.69c0 .138.112.25.25.25h2.69Zm-2.228 6.464a.766.766 0 0 1 1.061 0l.453.442a.75.75 0 0 0 1.048 0l.453-.442a.766.766 0 0 1 1.061 0 .688.688 0 0 1 0 .992l-2.038 1.995-2.038-1.995a.688.688 0 0 1 0-.992Zm2.038-1.14a2.266 2.266 0 0 0-3.087.068 2.188 2.188 0 0 0 0 3.137l2.213 2.165a1.25 1.25 0 0 0 1.748 0l2.213-2.165a2.188 2.188 0 0 0 0-3.137 2.266 2.266 0 0 0-3.087-.068Z"
      }));
    };
    SvgPageHeartIcon.displayName = "PageHeartIcon";
    exports.SvgPageHeartIcon = SvgPageHeartIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageIcon.svg.js
var require_PageIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPageIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.75 4.5c-.69 0-1.25.56-1.25 1.25v8.5c0 .69.56 1.25 1.25 1.25h6.5c.69 0 1.25-.56 1.25-1.25v-4.75h-3.25a1.75 1.75 0 0 1-1.75-1.75v-3.25h-2.75Zm4.25 1.06 2.44 2.44h-2.19a.25.25 0 0 1-.25-.25v-2.19Zm-7 .19a2.75 2.75 0 0 1 2.75-2.75h3.5a.75.75 0 0 1 .53.22l5 5c.141.14.22.331.22.53v5.5a2.75 2.75 0 0 1-2.75 2.75h-6.5a2.75 2.75 0 0 1-2.75-2.75v-8.5Z"
      }));
    };
    SvgPageIcon.displayName = "PageIcon";
    exports.SvgPageIcon = SvgPageIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageReferenceIcon.svg.js
var require_PageReferenceIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageReferenceIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPageReferenceIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.5 5.75c0-.69.56-1.25 1.25-1.25h2.75v3.25c0 .966.784 1.75 1.75 1.75h3.25v1.25a.75.75 0 0 0 1.5 0v-2a.75.75 0 0 0-.22-.53l-5-5a.75.75 0 0 0-.53-.22h-3.5a2.75 2.75 0 0 0-2.75 2.75v8.5a2.75 2.75 0 0 0 2.75 2.75h3.25a.75.75 0 0 0 0-1.5h-3.25c-.69 0-1.25-.56-1.25-1.25v-8.5Zm7.94 2.25-2.44-2.44v2.19c0 .138.112.25.25.25h2.19Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.22 17.28a.75.75 0 0 0 1.06-1.06l-1.97-1.97h.94a.75.75 0 0 0 0-1.5h-2.75a.75.75 0 0 0-.75.75v2.75a.75.75 0 0 0 1.5 0v-.94l1.97 1.97Z"
      }));
    };
    SvgPageReferenceIcon.displayName = "PageReferenceIcon";
    exports.SvgPageReferenceIcon = SvgPageReferenceIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageRemoveIcon.svg.js
var require_PageRemoveIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageRemoveIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPageRemoveIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.5 5.75c0-.69.56-1.25 1.25-1.25h2.75v3.25c0 .966.784 1.75 1.75 1.75h3.25v1.75a.75.75 0 0 0 1.5 0v-2.5a.75.75 0 0 0-.22-.53l-5-5a.75.75 0 0 0-.53-.22h-3.5a2.75 2.75 0 0 0-2.75 2.75v8.5a2.75 2.75 0 0 0 2.75 2.75h4.25a.75.75 0 0 0 0-1.5h-4.25c-.69 0-1.25-.56-1.25-1.25v-8.5Zm7.94 2.25-2.44-2.44v2.19c0 .138.112.25.25.25h2.19Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.25 13.25a.75.75 0 0 0 0 1.5h4a.75.75 0 0 0 0-1.5h-4Z"
      }));
    };
    SvgPageRemoveIcon.displayName = "PageRemoveIcon";
    exports.SvgPageRemoveIcon = SvgPageRemoveIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageUpIcon.svg.js
var require_PageUpIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PageUpIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPageUpIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.5 5.75c0-.69.56-1.25 1.25-1.25h2.75v3.25c0 .966.784 1.75 1.75 1.75h3.25v.75a.75.75 0 0 0 1.5 0v-1.5a.75.75 0 0 0-.22-.53l-5-5a.75.75 0 0 0-.53-.22h-3.5a2.75 2.75 0 0 0-2.75 2.75v8.5a2.75 2.75 0 0 0 2.75 2.75h3.75a.75.75 0 0 0 0-1.5h-3.75c-.69 0-1.25-.56-1.25-1.25v-8.5Zm7.94 2.25-2.44-2.44v2.19c0 .138.112.25.25.25h2.19Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15 14.31v2.94a.75.75 0 0 1-1.5 0v-2.94l-.72.72a.75.75 0 1 1-1.06-1.06l2-2a.75.75 0 0 1 1.06 0l2 2a.75.75 0 1 1-1.06 1.06l-.72-.72Z"
      }));
    };
    SvgPageUpIcon.displayName = "PageUpIcon";
    exports.SvgPageUpIcon = SvgPageUpIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PaginationEndIcon.svg.js
var require_PaginationEndIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PaginationEndIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPaginationEndIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.454 13.736a.75.75 0 1 0 1.092 1.028l4-4.25a.75.75 0 0 0 0-1.028l-4-4.25a.75.75 0 1 0-1.092 1.028l3.516 3.736-3.516 3.736Zm9.296-7.986a.75.75 0 0 0-1.5 0v8.5a.75.75 0 0 0 1.5 0v-8.5Z"
      }));
    };
    SvgPaginationEndIcon.displayName = "PaginationEndIcon";
    exports.SvgPaginationEndIcon = SvgPaginationEndIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PaginationStartIcon.svg.js
var require_PaginationStartIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PaginationStartIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPaginationStartIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.75 5.75a.75.75 0 0 0-1.5 0v8.5a.75.75 0 0 0 1.5 0v-8.5Zm7.796.514a.75.75 0 1 0-1.092-1.028l-4 4.25a.75.75 0 0 0 0 1.028l4 4.25a.75.75 0 1 0 1.092-1.028l-3.516-3.736 3.516-3.736Z"
      }));
    };
    SvgPaginationStartIcon.displayName = "PaginationStartIcon";
    exports.SvgPaginationStartIcon = SvgPaginationStartIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PaintBrushFlatIcon.svg.js
var require_PaintBrushFlatIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PaintBrushFlatIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPaintBrushFlatIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11.677 4.737a.25.25 0 0 0-.354 0l-2.836 2.836a.25.25 0 0 0 0 .354l3.586 3.585a.25.25 0 0 0 .353.001l2.837-2.836a.25.25 0 0 0 0-.354l-1.763-1.762-.47.47a.75.75 0 0 1-1.06-1.061l.47-.47-.763-.763Zm-1.414-1.06-4.586 4.585a1.75 1.75 0 0 0 0 2.475l.262.263-1.97 1.97a2.164 2.164 0 0 0 3.061 3.06l1.97-1.97.263.263a1.75 1.75 0 0 0 2.474 0l4.586-4.586a1.75 1.75 0 0 0 0-2.475l-3.586-3.585a1.75 1.75 0 0 0-2.474 0Zm-3.526 5.646.526-.525c.049.066.104.13.164.19l3.586 3.585c.06.06.123.115.189.164l-.525.525a.25.25 0 0 1-.354 0l-3.586-3.585a.25.25 0 0 1 0-.354Zm.263 2.737-1.97 1.97a.664.664 0 1 0 .94.94l1.97-1.97-.94-.94Z"
      }));
    };
    SvgPaintBrushFlatIcon.displayName = "PaintBrushFlatIcon";
    exports.SvgPaintBrushFlatIcon = SvgPaintBrushFlatIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PaintBrushRoundIcon.svg.js
var require_PaintBrushRoundIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PaintBrushRoundIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPaintBrushRoundIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M16.155 3.844a2.079 2.079 0 0 0-2.831-.1l-6.354 5.506a3.75 3.75 0 0 0-3.72 3.75v3c0 .414.336.75.75.75h3a3.75 3.75 0 0 0 3.75-3.72l5.506-6.354a2.08 2.08 0 0 0-.1-2.832Zm-5.841 7.399 4.809-5.55a.579.579 0 0 0-.817-.816l-5.549 4.81a3.768 3.768 0 0 1 1.557 1.556Zm-3.314-.493a2.25 2.25 0 0 1 0 4.5h-2.25v-2.25a2.25 2.25 0 0 1 2.25-2.25Z"
      }));
    };
    SvgPaintBrushRoundIcon.displayName = "PaintBrushRoundIcon";
    exports.SvgPaintBrushRoundIcon = SvgPaintBrushRoundIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PaperCheckIcon.svg.js
var require_PaperCheckIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PaperCheckIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPaperCheckIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.496 5.354a.5.5 0 0 0 0-.707l-1.06-1.061a.5.5 0 0 0-.707 0l-.957.957 1.767 1.768.957-.957Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "m11.832 7.018-1.768-1.768-2.449 2.45a2 2 0 0 0-.585 1.406l-.003.698a.25.25 0 0 0 .251.251l.698-.002a2 2 0 0 0 1.407-.586l2.45-2.45Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.25 9.25c0-.69.56-1.25 1.25-1.25h.25a.75.75 0 1 0 0-1.5h-.25a2.75 2.75 0 0 0-2.75 2.75v4a2.75 2.75 0 0 0 2.75 2.75h9a2.75 2.75 0 0 0 2.75-2.75v-4.25a2.5 2.5 0 0 0-2.5-2.5.75.75 0 0 0 0 1.5 1 1 0 0 1 1 1v4.25c0 .69-.56 1.25-1.25 1.25h-9c-.69 0-1.25-.56-1.25-1.25v-4Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.5 11.5a.75.75 0 0 0 0 1.5h4a.75.75 0 0 0 0-1.5h-4Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.25 12.25a.75.75 0 0 1 .75-.75h.5a.75.75 0 0 1 0 1.5h-.5a.75.75 0 0 1-.75-.75Z"
      }));
    };
    SvgPaperCheckIcon.displayName = "PaperCheckIcon";
    exports.SvgPaperCheckIcon = SvgPaperCheckIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PasskeyFilledIcon.svg.js
var require_PasskeyFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PasskeyFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPasskeyFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.5 6.5a3.5 3.5 0 1 1 7 0 3.5 3.5 0 0 1-7 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12 11.375a3.125 3.125 0 1 1 6.25 0v1.625a1.5 1.5 0 0 1-1.5 1.5h-.35a.127.127 0 0 0-.105.2l.46.666a.5.5 0 0 1-.073.65l-.182.169a.5.5 0 0 0-.052.678l.286.36a.5.5 0 0 1-.021.648l-.73.8a1 1 0 0 1-1.493-.016l-.494-.567a1 1 0 0 1-.246-.657v-2.681a.25.25 0 0 0-.25-.25 1.5 1.5 0 0 1-1.5-1.5v-1.625Zm3.125 1.125a.875.875 0 1 0 0-1.75.875.875 0 0 0 0 1.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.752 11.25a4.368 4.368 0 0 0-.002.125v1.625c0 1.166.726 2.162 1.75 2.563v1.437h-8.251a1.338 1.338 0 0 1-1.17-1.987l.437-.786a6.273 6.273 0 0 1 7.236-2.978Z"
      }));
    };
    SvgPasskeyFilledIcon.displayName = "PasskeyFilledIcon";
    exports.SvgPasskeyFilledIcon = SvgPasskeyFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PasskeyIcon.svg.js
var require_PasskeyIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PasskeyIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPasskeyIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9 3a3.5 3.5 0 1 0 0 7 3.5 3.5 0 0 0 0-7Zm-2 3.5a2 2 0 1 1 4 0 2 2 0 0 1-4 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.827 14.955a4.773 4.773 0 0 1 4.173-2.455.75.75 0 0 0 0-1.5 6.273 6.273 0 0 0-5.484 3.227l-.437.786a1.338 1.338 0 0 0 1.17 1.987h6.001a.75.75 0 0 0 0-1.5h-5.725l.302-.545Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.125 12.5a.875.875 0 1 0 0-1.75.875.875 0 0 0 0 1.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17.674 14.875a2.348 2.348 0 0 0 1.076-1.975v-1.275a3.625 3.625 0 0 0-7.25 0v1.275c0 .9.506 1.683 1.25 2.077v1.874a2 2 0 0 0 .327 1.095l.422.645a2 2 0 0 0 2.988.411l.553-.482a2 2 0 0 0 .494-2.362c.189-.395.242-.85.14-1.283Zm-3.471-.914a.4.4 0 0 0-.353-.211.85.85 0 0 1-.85-.85v-1.275a2.125 2.125 0 0 1 4.25 0v1.275c0 .47-.38.85-.85.85h-.218a.5.5 0 0 0-.5.5v.072a.5.5 0 0 0 .113.316l.331.405a.439.439 0 0 1 .093.206.437.437 0 0 1-.266.474.439.439 0 0 0-.11.742l.198.16a.5.5 0 0 1 .012.765l-.552.482a.5.5 0 0 1-.747-.102l-.422-.645a.5.5 0 0 1-.082-.274v-2.701a.399.399 0 0 0-.047-.19Z"
      }));
    };
    SvgPasskeyIcon.displayName = "PasskeyIcon";
    exports.SvgPasskeyIcon = SvgPasskeyIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PauseCircleIcon.svg.js
var require_PauseCircleIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PauseCircleIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPauseCircleIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8 7.25a.75.75 0 0 1 .75.75v4a.75.75 0 0 1-1.5 0v-4a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.75 8a.75.75 0 0 0-1.5 0v4a.75.75 0 0 0 1.5 0v-4Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 17a7 7 0 1 0 0-14 7 7 0 0 0 0 14Zm0-1.5a5.5 5.5 0 1 0 0-11 5.5 5.5 0 0 0 0 11Z"
      }));
    };
    SvgPauseCircleIcon.displayName = "PauseCircleIcon";
    exports.SvgPauseCircleIcon = SvgPauseCircleIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PaymentCaptureIcon.svg.js
var require_PaymentCaptureIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PaymentCaptureIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPaymentCaptureIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10.75 3.25a.75.75 0 0 0-1.5 0v2.097l-.756-.661a.75.75 0 1 0-.988 1.128l2 1.75a.75.75 0 0 0 .988 0l2-1.75a.75.75 0 0 0-.988-1.128l-.756.661v-2.097Zm1.682 4.781a2.27 2.27 0 0 1 4.115 1.917l-1.528 3.333a4.75 4.75 0 0 1-2.194 2.27l-2.24 1.12a.75.75 0 0 1-.67-1.342l2.24-1.12a3.25 3.25 0 0 0 1.5-1.553l1.528-3.333a.77.77 0 0 0-1.396-.65l-1.002 2.116a3.75 3.75 0 0 1-1.656 1.72c-.195.119-.41.21-.641.267l-1.806.452-.013.003-.987.247a.75.75 0 0 1-.364-1.456l2.624-.656c.155-.038.303-.093.444-.162a.827.827 0 0 0-.557-1.506l-.822.095a4.25 4.25 0 0 0-3.733 3.715l-.28 2.331a.75.75 0 1 1-1.489-.178l.28-2.331a5.75 5.75 0 0 1 5.05-5.027l.822-.095a2.325 2.325 0 0 1 2.206 1.025l.569-1.202Z"
      }));
    };
    SvgPaymentCaptureIcon.displayName = "PaymentCaptureIcon";
    exports.SvgPaymentCaptureIcon = SvgPaymentCaptureIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PaymentFilledIcon.svg.js
var require_PaymentFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PaymentFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPaymentFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.75 10.227v-2.227c-.778 0-1.044.005-1.283.062a2.25 2.25 0 0 0-.65.27c-.21.128-.398.31-.943.854l-.594.594a.75.75 0 0 1-1.06-1.06l.654-.655c.46-.46.78-.78 1.16-1.012a3.75 3.75 0 0 1 1.083-.45c.433-.103.888-.103 1.546-.103h.087v1.48h11v1.62c0 .84 0 1.26-.163 1.581a1.5 1.5 0 0 1-.656.655c-.32.164-.74.164-1.581.164h-2.705a1.92 1.92 0 0 1-.61.73l-2.73 1.965c-.566.407-.93.67-1.336.859-.358.167-.736.29-1.125.363-.44.083-.889.083-1.586.083h-1.508a.75.75 0 0 1 0-1.5h1.436c.794 0 1.095-.003 1.379-.057.266-.05.524-.134.77-.248.261-.122.508-.296 1.152-.76l2.67-1.923a.423.423 0 0 0-.35-.753l-4.875 1.219a.75.75 0 0 1-.364-1.456l1.182-.295Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M17.587 5.069c.152.298.162.683.163 1.411h-11c0-.728.011-1.113.163-1.411a1.5 1.5 0 0 1 .656-.656c.32-.163.74-.163 1.581-.163h6.2c.84 0 1.26 0 1.581.163a1.5 1.5 0 0 1 .655.656Z"
      }));
    };
    SvgPaymentFilledIcon.displayName = "PaymentFilledIcon";
    exports.SvgPaymentFilledIcon = SvgPaymentFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PaymentIcon.svg.js
var require_PaymentIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PaymentIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPaymentIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9.621 4h5.258c.395 0 .736 0 1.017.023.297.024.592.078.875.222.424.216.768.56.984.984.144.283.198.578.222.875.023.28.023.622.023 1.017v2.258c0 .395 0 .736-.023 1.017a2.29 2.29 0 0 1-.222.875 2.25 2.25 0 0 1-.983.984c-.284.144-.58.198-.876.222-.28.023-.622.023-1.017.023h-2.58c-.08.083-.169.16-.265.23l-2.73 1.965c-.565.407-.93.67-1.335.859-.358.167-.736.29-1.125.363-.44.083-.889.083-1.586.083h-1.508a.75.75 0 0 1 0-1.5h1.436c.794 0 1.095-.003 1.379-.057.266-.05.524-.134.77-.248.261-.122.508-.296 1.152-.76l2.67-1.923a.423.423 0 0 0-.35-.753l-4.875 1.219a.75.75 0 0 1-.364-1.456l.932-.233v-2.289c-.59.002-.821.011-1.033.062a2.25 2.25 0 0 0-.65.27c-.21.128-.398.31-.943.854l-.594.594a.75.75 0 0 1-1.06-1.06l.654-.655c.46-.46.78-.78 1.16-1.012a3.75 3.75 0 0 1 1.083-.45c.397-.095.813-.103 1.387-.103a6.79 6.79 0 0 1 .019-.396 2.29 2.29 0 0 1 .222-.875 2.25 2.25 0 0 1 .984-.984 2.29 2.29 0 0 1 .875-.222c.28-.023.622-.023 1.017-.023Zm5.229 7h-2.024a1.925 1.925 0 0 0-2.382-1.697l-2.444.611v-1.414h8.5v.85c0 .432 0 .712-.018.924-.017.204-.045.28-.064.317a.75.75 0 0 1-.328.327c-.037.02-.112.047-.316.064-.212.017-.492.018-.924.018Zm1.645-4.5h-8.49c.002-.104.006-.194.013-.274.017-.204.045-.28.064-.316a.75.75 0 0 1 .328-.328c.037-.02.112-.047.316-.064.212-.017.492-.018.924-.018h5.2c.432 0 .712 0 .924.018.204.017.28.045.316.064a.75.75 0 0 1 .328.328c.02.037.047.112.064.316.007.08.01.17.013.274Z"
      }));
    };
    SvgPaymentIcon.displayName = "PaymentIcon";
    exports.SvgPaymentIcon = SvgPaymentIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PersonAddIcon.svg.js
var require_PersonAddIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PersonAddIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPersonAddIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.25 1.75a.75.75 0 0 0-1.5 0v1h-1a.75.75 0 0 0 0 1.5h1v1a.75.75 0 0 0 1.5 0v-1h1a.75.75 0 0 0 0-1.5h-1v-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9 3a3.5 3.5 0 1 0 0 7 3.5 3.5 0 0 0 0-7Zm-2 3.5a2 2 0 1 1 4 0 2 2 0 0 1-4 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M14.484 14.227a6.273 6.273 0 0 0-10.968 0l-.437.786a1.338 1.338 0 0 0 1.17 1.987h9.502a1.338 1.338 0 0 0 1.17-1.987l-.437-.786Zm-9.657.728a4.773 4.773 0 0 1 8.346 0l.302.545h-8.95l.302-.545Z"
      }));
    };
    SvgPersonAddIcon.displayName = "PersonAddIcon";
    exports.SvgPersonAddIcon = SvgPersonAddIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PersonExitIcon.svg.js
var require_PersonExitIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PersonExitIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPersonExitIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.518 16h4.842c.735 0 1.455-.203 2.082-.586.387-.236.72-.553.974-.928l.014-.02c.371-.547.57-1.193.57-1.854v-1.31c0-.415-.336-.75-.75-.75s-.75.335-.75.75v1.31c0 .36-.108.713-.31 1.01l-.015.022c-.135.198-.31.365-.515.49-.385.236-.826.362-1.278.366-.538-.579-1.161-1.002-1.796-1.421-.81-.536-1.73-.884-2.693-1.017-.963-.134-1.943-.05-2.868.245-.492.157-.961.371-1.4.637-.037-.152-.067-.34-.087-.585-.037-.462-.038-1.056-.038-1.909v-.9c0-.852 0-1.447.038-1.91.037-.453.107-.714.207-.911.216-.424.56-.768.984-.984.197-.1.458-.17.912-.207.462-.037 1.057-.038 1.909-.038h3.95c.414 0 .75-.336.75-.75s-.336-.75-.75-.75h-3.982c-.813 0-1.469 0-2 .043-.546.045-1.026.14-1.47.366-.706.36-1.28.933-1.64 1.639-.226.444-.32.924-.365 1.47-.043.531-.043 1.187-.043 2v.964c0 .813 0 1.469.043 2 .045.546.14 1.026.366 1.47.36.706.933 1.28 1.639 1.64.444.226.924.32 1.47.365.531.043 1.187.043 2 .043Zm.032-1.5h2.464l-.255-.17c-.624-.413-1.332-.68-2.072-.783-.74-.102-1.494-.038-2.207.19-.327.104-.642.242-.94.41.06.039.124.075.189.108.197.1.458.17.912.207.462.037 1.057.038 1.909.038Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8 6.5c-1.38 0-2.5 1.12-2.5 2.5s1.12 2.5 2.5 2.5 2.5-1.12 2.5-2.5-1.12-2.5-2.5-2.5Zm-1 2.5c0-.552.448-1 1-1s1 .448 1 1-.448 1-1 1-1-.448-1-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.25 9.75c0 .414.336.75.75.75s.75-.336.75-.75v-.5c0-.966.784-1.75 1.75-1.75h.94l-.72.72c-.293.293-.293.767 0 1.06.293.293.767.293 1.06 0l2-2c.293-.293.293-.767 0-1.06l-2-2c-.293-.293-.767-.293-1.06 0-.293.293-.293.767 0 1.06l.72.72h-.94c-1.795 0-3.25 1.455-3.25 3.25v.5Z"
      }));
    };
    SvgPersonExitIcon.displayName = "PersonExitIcon";
    exports.SvgPersonExitIcon = SvgPersonExitIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PersonFilledIcon.svg.js
var require_PersonFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PersonFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPersonFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 9.75a3.25 3.25 0 1 0 0-6.5 3.25 3.25 0 0 0 0 6.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 11.5c-1.968 0-3.815.95-4.959 2.552l-.561.786a1.05 1.05 0 0 0 .855 1.662h9.33a1.05 1.05 0 0 0 .855-1.662l-.561-.786a6.094 6.094 0 0 0-4.959-2.552Z"
      }));
    };
    SvgPersonFilledIcon.displayName = "PersonFilledIcon";
    exports.SvgPersonFilledIcon = SvgPersonFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PersonIcon.svg.js
var require_PersonIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PersonIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPersonIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 3a3.5 3.5 0 1 0 0 7 3.5 3.5 0 0 0 0-7Zm-2 3.5a2 2 0 1 1 4 0 2 2 0 0 1-4 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15.484 14.227a6.274 6.274 0 0 0-10.968 0l-.437.786a1.338 1.338 0 0 0 1.17 1.987h9.502a1.338 1.338 0 0 0 1.17-1.987l-.437-.786Zm-9.657.728a4.773 4.773 0 0 1 8.346 0l.302.545h-8.95l.302-.545Z"
      }));
    };
    SvgPersonIcon.displayName = "PersonIcon";
    exports.SvgPersonIcon = SvgPersonIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PersonLockFilledIcon.svg.js
var require_PersonLockFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PersonLockFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPersonLockFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4.5 6.5a3.5 3.5 0 1 1 7 0 3.5 3.5 0 0 1-7 0Zm8.251 10.5h-.751a1 1 0 0 1-1-1v-3a1 1 0 0 1 1-1h3.5v-1.75a.75.75 0 0 0-1.5 0 .75.75 0 0 1-1.5 0 2.25 2.25 0 0 1 4.5 0v1.75a1 1 0 0 1 1 1v3a1 1 0 0 1-1 1h-4.249Zm-2.146-5.434a1.994 1.994 0 0 0-.605 1.434v3c0 .364.097.706.268 1h-.854a.756.756 0 0 1-.1.007h-5.93c-.408 0-.805-.167-1.074-.478a1.263 1.263 0 0 1-.24-1.243c.322-.96 1.094-2.246 2.361-3.157a5.82 5.82 0 0 1 2.762-1.067 5.42 5.42 0 0 1 .807-.062c.915 0 1.8.2 2.605.566Z"
      }));
    };
    SvgPersonLockFilledIcon.displayName = "PersonLockFilledIcon";
    exports.SvgPersonLockFilledIcon = SvgPersonLockFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PersonLockIcon.svg.js
var require_PersonLockIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PersonLockIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPersonLockIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8 4.5a2 2 0 1 0 0 4 2 2 0 0 0 0-4Zm-3.5 2a3.5 3.5 0 1 1 7 0 3.5 3.5 0 0 1-7 0Zm10.25 3a.75.75 0 0 1 .75.75v1.75h-3.5a1 1 0 0 0-1 1v3a1 1 0 0 0 1 1h5a1 1 0 0 0 1-1v-3a1 1 0 0 0-1-1v-1.75a2.25 2.25 0 0 0-4.5 0 .75.75 0 0 0 1.5 0 .75.75 0 0 1 .75-.75Zm-2.25 4v2h4v-2h-4Zm-7.193-.153a5.24 5.24 0 0 0-1.718 2.16h5.724a.75.75 0 1 1 0 1.5h-5.93c-.407 0-.804-.167-1.073-.478a1.263 1.263 0 0 1-.24-1.243c.322-.96 1.094-2.246 2.361-3.157 1.298-.932 3.084-1.445 5.33-.854a.75.75 0 1 1-.382 1.45c-1.798-.473-3.126-.058-4.072.622Z"
      }));
    };
    SvgPersonLockIcon.displayName = "PersonLockIcon";
    exports.SvgPersonLockIcon = SvgPersonLockIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PersonRemoveIcon.svg.js
var require_PersonRemoveIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PersonRemoveIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPersonRemoveIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.75 2a.75.75 0 0 0 0 1.5h3.5a.75.75 0 0 0 0-1.5h-3.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.5 6.5a3.5 3.5 0 1 1 7 0 3.5 3.5 0 0 1-7 0Zm3.5-2a2 2 0 1 0 0 4 2 2 0 0 0 0-4Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9 11a6.273 6.273 0 0 1 5.484 3.227l.437.786a1.338 1.338 0 0 1-1.17 1.987h-9.502a1.338 1.338 0 0 1-1.17-1.987l.437-.786a6.273 6.273 0 0 1 5.484-3.227Zm0 1.5c-1.734 0-3.33.94-4.173 2.455l-.302.545h8.95l-.302-.545a4.773 4.773 0 0 0-4.173-2.455Z"
      }));
    };
    SvgPersonRemoveIcon.displayName = "PersonRemoveIcon";
    exports.SvgPersonRemoveIcon = SvgPersonRemoveIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PersonalizedTextIcon.svg.js
var require_PersonalizedTextIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PersonalizedTextIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPersonalizedTextIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.75 4a2.75 2.75 0 0 0-2.75 2.75v1.94l-.78.78a.75.75 0 0 0 0 1.06l.78.78v1.94a2.75 2.75 0 0 0 2.75 2.75h.25a.75.75 0 0 0 0-1.5h-.25c-.69 0-1.25-.56-1.25-1.25v-2.25a.75.75 0 0 0-.22-.53l-.47-.47.47-.47a.75.75 0 0 0 .22-.53v-2.25c0-.69.56-1.25 1.25-1.25h.25a.75.75 0 0 0 0-1.5h-.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.25 16a2.75 2.75 0 0 0 2.75-2.75v-1.94l.78-.78a.75.75 0 0 0 0-1.06l-.78-.78v-1.94a2.75 2.75 0 0 0-2.75-2.75h-.25a.75.75 0 0 0 0 1.5h.25c.69 0 1.25.56 1.25 1.25v2.25c0 .199.079.39.22.53l.47.47-.47.47a.75.75 0 0 0-.22.53v2.25c0 .69-.56 1.25-1.25 1.25h-.25a.75.75 0 0 0 0 1.5h.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.75 7.75a2.25 2.25 0 1 1 4.5 0 2.25 2.25 0 0 1-4.5 0Zm2.25-.75a.75.75 0 1 0 0 1.5.75.75 0 0 0 0-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.163 13.368a2.069 2.069 0 0 1 3.674 0l.247.477a.75.75 0 1 0 1.332-.69l-.246-.476a3.569 3.569 0 0 0-6.34 0l-.246.476a.75.75 0 1 0 1.332.69l.247-.477Z"
      }));
    };
    SvgPersonalizedTextIcon.displayName = "PersonalizedTextIcon";
    exports.SvgPersonalizedTextIcon = SvgPersonalizedTextIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PhoneIcon.svg.js
var require_PhoneIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PhoneIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPhoneIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.75 4.5c-1.283 0-2.213 1.025-2.044 2.127.384 2.498 1.296 4.459 2.707 5.89 1.41 1.43 3.373 2.389 5.96 2.786 1.101.17 2.126-.76 2.126-2.044v-.727a.25.25 0 0 0-.187-.242l-1.9-.498a.25.25 0 0 0-.182.022l-1.067.576c-.69.373-1.638.492-2.422-.056a8.678 8.678 0 0 1-2.071-2.09c-.542-.787-.423-1.735-.045-2.428l.57-1.047a.252.252 0 0 0 .022-.182l-.498-1.9a.25.25 0 0 0-.242-.187h-.726Zm-3.526 2.355c-.334-2.174 1.497-3.856 3.527-3.855h.726a1.75 1.75 0 0 1 1.693 1.306l.498 1.9c.113.43.058.885-.153 1.276l-.001.002-.572 1.05c-.191.351-.169.668-.036.86a7.184 7.184 0 0 0 1.694 1.71c.187.13.498.156.85-.034l1.067-.576a1.75 1.75 0 0 1 1.276-.153l1.9.498a1.75 1.75 0 0 1 1.306 1.693v.727c0 2.03-1.68 3.86-3.854 3.527-2.838-.436-5.12-1.511-6.8-3.216-1.68-1.703-2.701-3.978-3.121-6.715Z"
      }));
    };
    SvgPhoneIcon.displayName = "PhoneIcon";
    exports.SvgPhoneIcon = SvgPhoneIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PhoneInIcon.svg.js
var require_PhoneInIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PhoneInIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPhoneInIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.751 3c-2.03 0-3.861 1.681-3.527 3.855.42 2.737 1.442 5.012 3.12 6.715 1.68 1.705 3.962 2.78 6.801 3.216 2.174.334 3.854-1.497 3.854-3.527v-.727a1.75 1.75 0 0 0-1.306-1.693l-1.9-.498a1.75 1.75 0 0 0-1.276.153l-1.067.576c-.352.19-.663.165-.85.034a7.184 7.184 0 0 1-1.694-1.71c-.133-.192-.155-.509.036-.86l.572-1.05.001-.002c.211-.39.266-.846.153-1.276l-.498-1.9a1.75 1.75 0 0 0-1.693-1.306h-.726Zm-2.045 3.627c-.169-1.102.76-2.127 2.045-2.127h.726a.25.25 0 0 1 .242.187l.498 1.9a.252.252 0 0 1-.022.182l-.57 1.047c-.378.693-.496 1.64.045 2.428a8.678 8.678 0 0 0 2.071 2.09c.784.548 1.731.429 2.422.056l1.067-.576a.25.25 0 0 1 .182-.022l1.9.498a.25.25 0 0 1 .187.242v.727c0 1.284-1.025 2.213-2.126 2.044-2.587-.397-4.55-1.356-5.96-2.786-1.41-1.431-2.323-3.392-2.707-5.89Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.749 9.01a.75.75 0 0 0 0-1.5h-1.19l2.72-2.72a.75.75 0 0 0-1.06-1.06l-2.72 2.72v-1.19a.75.75 0 0 0-1.5 0v3c0 .414.336.75.75.75h3Z"
      }));
    };
    SvgPhoneInIcon.displayName = "PhoneInIcon";
    exports.SvgPhoneInIcon = SvgPhoneInIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PhoneOutIcon.svg.js
var require_PhoneOutIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PhoneOutIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPhoneOutIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.75 4.5c-1.283 0-2.213 1.025-2.044 2.127.384 2.498 1.296 4.459 2.707 5.89 1.41 1.43 3.373 2.389 5.96 2.786 1.101.17 2.126-.76 2.126-2.044v-.727a.25.25 0 0 0-.187-.242l-1.9-.498a.25.25 0 0 0-.182.022l-1.067.576c-.69.373-1.638.492-2.422-.056a8.678 8.678 0 0 1-2.071-2.09c-.542-.787-.423-1.735-.045-2.428l.57-1.047a.252.252 0 0 0 .022-.182l-.498-1.9a.25.25 0 0 0-.242-.187h-.726Zm-3.526 2.355c-.334-2.174 1.497-3.856 3.527-3.855h.726a1.75 1.75 0 0 1 1.693 1.306l.498 1.9c.113.43.058.885-.153 1.276l-.001.002-.572 1.05c-.191.351-.169.668-.036.86a7.184 7.184 0 0 0 1.694 1.71c.187.13.498.156.85-.034l1.067-.576a1.75 1.75 0 0 1 1.276-.153l1.9.498a1.75 1.75 0 0 1 1.306 1.693v.727c0 2.03-1.68 3.86-3.854 3.527-2.838-.436-5.12-1.511-6.8-3.216-1.68-1.703-2.701-3.978-3.121-6.715Zm8.775-2.595a.75.75 0 0 1 .75-.75h3a.75.75 0 0 1 .75.75v3a.75.75 0 0 1-1.5 0v-1.19l-2.72 2.72a.75.75 0 0 1-1.06-1.06l2.72-2.72h-1.19a.75.75 0 0 1-.75-.75Z"
      }));
    };
    SvgPhoneOutIcon.displayName = "PhoneOutIcon";
    exports.SvgPhoneOutIcon = SvgPhoneOutIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PinFilledIcon.svg.js
var require_PinFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PinFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPinFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.5 5.275v-1.025c0-.69.56-1.25 1.25-1.25h4.5c.69 0 1.25.56 1.25 1.25v1.025c0 .448-.24.862-.63 1.085l-.43.246.866 3.894h.694c.69 0 1.25.56 1.25 1.25v1c0 .69-.56 1.25-1.25 1.25h-2.781l-.48 2.873a.75.75 0 0 1-1.479 0l-.479-2.873h-2.781c-.69 0-1.25-.56-1.25-1.25v-1c0-.69.56-1.25 1.25-1.25h.694l.866-3.894-.43-.246a1.25 1.25 0 0 1-.63-1.085Z"
      }));
    };
    SvgPinFilledIcon.displayName = "PinFilledIcon";
    exports.SvgPinFilledIcon = SvgPinFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PinIcon.svg.js
var require_PinIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PinIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPinIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.5 14.5h2.35l.408 2.856a.75.75 0 0 0 1.485 0l.407-2.856h2.35a2 2 0 0 0 2-2v-.5a2 2 0 0 0-1.944-2l-.609-2.738a2 2 0 0 0 1.053-1.762v-.5a2 2 0 0 0-2-2h-4a2 2 0 0 0-2 2v.5a2 2 0 0 0 1.053 1.762l-.609 2.739a2 2 0 0 0-1.944 1.999v.5a2 2 0 0 0 2 2Zm1.481-4.5h1.269a.75.75 0 0 1 0 1.5h-2.5v-.007l-.265.007a.5.5 0 0 0-.485.5v.5a.5.5 0 0 0 .5.5h7a.5.5 0 0 0 .5-.5v-.5a.5.5 0 0 0-.485-.5l-1.17-.032-1.108-4.988.999-.539a.5.5 0 0 0 .264-.441v-.5a.5.5 0 0 0-.5-.5h-4a.5.5 0 0 0-.5.5v.5a.5.5 0 0 0 .264.441l1 .539-.783 3.52Z"
      }));
    };
    SvgPinIcon.displayName = "PinIcon";
    exports.SvgPinIcon = SvgPinIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PlanFilledIcon.svg.js
var require_PlanFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PlanFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPlanFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "m14.208 4.688 1.533-2.3a.25.25 0 0 0-.208-.388h-3.066a.25.25 0 0 0-.208.389l1.533 2.299a.25.25 0 0 0 .416 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11.25 7c0-.69.56-1.25 1.25-1.25h3.25c.69 0 1.25.56 1.25 1.25v8.75c0 .69-.56 1.25-1.25 1.25h-11.5c-.69 0-1.25-.56-1.25-1.25v-2.75c0-.69.56-1.25 1.25-1.25h2.75v-1.75c0-.69.56-1.25 1.25-1.25h3v-1.75Zm1.5.25v2.25h1.5v-2.25h-1.5Zm-4.25 3h1.5v2.25h-1.5v-2.25Zm-4 3h1.5v2.25h-1.5v-2.25Z"
      }));
    };
    SvgPlanFilledIcon.displayName = "PlanFilledIcon";
    exports.SvgPlanFilledIcon = SvgPlanFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PlanIcon.svg.js
var require_PlanIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PlanIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPlanIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "m14.208 4.688 1.533-2.3a.25.25 0 0 0-.208-.388h-3.066a.25.25 0 0 0-.208.389l1.533 2.299a.25.25 0 0 0 .416 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11.25 7c0-.69.56-1.25 1.25-1.25h3.25c.69 0 1.25.56 1.25 1.25v8.75c0 .69-.56 1.25-1.25 1.25h-11.5c-.69 0-1.25-.56-1.25-1.25v-2.75c0-.69.56-1.25 1.25-1.25h2.75v-1.75c0-.69.56-1.25 1.25-1.25h3v-1.75Zm2.25 2.5v-2.25h2v8.25h-10.25v-2.25h3.25a.75.75 0 0 0 .75-.75v-2.25h3.5a.75.75 0 0 0 .75-.75Z"
      }));
    };
    SvgPlanIcon.displayName = "PlanIcon";
    exports.SvgPlanIcon = SvgPlanIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PlayCircleIcon.svg.js
var require_PlayCircleIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PlayCircleIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPlayCircleIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13.875 10.65a.75.75 0 0 0 0-1.3l-5.25-3.03a.75.75 0 0 0-1.125.649v6.062a.75.75 0 0 0 1.125.65l5.25-3.032Zm-4.875 1.082v-3.464l3 1.732-3 1.732Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 3a7 7 0 1 0 0 14 7 7 0 0 0 0-14Zm-5.5 7a5.5 5.5 0 1 1 11 0 5.5 5.5 0 0 1-11 0Z"
      }));
    };
    SvgPlayCircleIcon.displayName = "PlayCircleIcon";
    exports.SvgPlayCircleIcon = SvgPlayCircleIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PlayIcon.svg.js
var require_PlayIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PlayIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPlayIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15.375 8.485c1.167.674 1.167 2.358 0 3.031l-7.5 4.33c-1.167.674-2.625-.168-2.625-1.515v-8.66c0-1.348 1.458-2.19 2.625-1.516l7.5 4.33Zm-.75 1.732a.25.25 0 0 0 0-.433l-7.5-4.33a.25.25 0 0 0-.375.217v8.66a.25.25 0 0 0 .375.216l7.5-4.33Z"
      }));
    };
    SvgPlayIcon.displayName = "PlayIcon";
    exports.SvgPlayIcon = SvgPlayIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PlusCircleIcon.svg.js
var require_PlusCircleIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PlusCircleIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPlusCircleIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.25 10a.75.75 0 0 1 .75-.75h2.25v-2.25a.75.75 0 0 1 1.5 0v2.25h2.25a.75.75 0 0 1 0 1.5h-2.25v2.25a.75.75 0 0 1-1.5 0v-2.25h-2.25a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 17a7 7 0 1 0 0-14 7 7 0 0 0 0 14Zm0-1.5a5.5 5.5 0 1 0 0-11 5.5 5.5 0 0 0 0 11Z"
      }));
    };
    SvgPlusCircleIcon.displayName = "PlusCircleIcon";
    exports.SvgPlusCircleIcon = SvgPlusCircleIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PlusIcon.svg.js
var require_PlusIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PlusIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPlusIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 6.75a.75.75 0 0 0-1.5 0v2.5h-2.5a.75.75 0 0 0 0 1.5h2.5v2.5a.75.75 0 0 0 1.5 0v-2.5h2.5a.75.75 0 0 0 0-1.5h-2.5v-2.5Z"
      }));
    };
    SvgPlusIcon.displayName = "PlusIcon";
    exports.SvgPlusIcon = SvgPlusIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PointOfSaleIcon.svg.js
var require_PointOfSaleIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PointOfSaleIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPointOfSaleIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.5 13.5a.75.75 0 0 0 0 1.5h1a.75.75 0 0 0 0-1.5h-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4.604 4.907a1.75 1.75 0 0 1 1.716-1.407h7.36a1.75 1.75 0 0 1 1.716 1.407l.6 3a1.75 1.75 0 0 1-1.716 2.093h-1.272l.688 1.722.011.028h1.293c.966 0 1.75.784 1.75 1.75v1.5a1.75 1.75 0 0 1-1.75 1.75h-10a1.75 1.75 0 0 1-1.75-1.75v-1.5c0-.966.784-1.75 1.75-1.75h1.293a.728.728 0 0 1 .01-.028l.69-1.722h-1.273a1.75 1.75 0 0 1-1.716-2.093l.6-3Zm7.488 6.843h-4.184l.7-1.75h2.784l.7 1.75Zm-5.772-6.75a.25.25 0 0 0-.245.201l-.6 3a.25.25 0 0 0 .245.299h8.56a.25.25 0 0 0 .245-.299l-.6-3a.25.25 0 0 0-.245-.201h-7.36Zm-1.32 8.25a.25.25 0 0 0-.25.25v1.5c0 .138.112.25.25.25h10a.25.25 0 0 0 .25-.25v-1.5a.25.25 0 0 0-.25-.25h-10Z"
      }));
    };
    SvgPointOfSaleIcon.displayName = "PointOfSaleIcon";
    exports.SvgPointOfSaleIcon = SvgPointOfSaleIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PriceListFilledIcon.svg.js
var require_PriceListFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PriceListFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPriceListFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 3.5h8.5a1 1 0 0 1 1 1v3.765a2 2 0 0 0-2.076 1.167 3.251 3.251 0 0 0-1.366 5.212 1.997 1.997 0 0 0-.793 1.856h-5.265a1 1 0 0 1-1-1v-11a1 1 0 0 1 1-1Zm1.125 3.25c0-.345.28-.625.625-.625h5a.625.625 0 1 1 0 1.25h-5a.625.625 0 0 1-.625-.625Zm0 3c0-.345.28-.625.625-.625h2.75a.625.625 0 1 1 0 1.25h-2.75a.625.625 0 0 1-.625-.625Zm0 3c0-.345.28-.625.625-.625h2.25a.625.625 0 1 1 0 1.25h-2.25a.625.625 0 0 1-.625-.625Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.25 9.5a.749.749 0 0 1 .75.75v.25h.75a.75.75 0 0 1 0 1.5h-2.25a.5.5 0 0 0 0 1h1a2 2 0 1 1 0 4 .75.75 0 0 1-1.5 0h-.75a.75.75 0 0 1-.002-1.5h2.252a.5.5 0 0 0 0-1h-1a2 2 0 1 1 0-4v-.25a.75.75 0 0 1 .75-.75Z"
      }));
    };
    SvgPriceListFilledIcon.displayName = "PriceListFilledIcon";
    exports.SvgPriceListFilledIcon = SvgPriceListFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PriceListIcon.svg.js
var require_PriceListIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PriceListIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPriceListIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.25 3a1.75 1.75 0 0 0-1.75 1.75v10.5c0 .966.784 1.75 1.75 1.75h4.5a.75.75 0 0 0 0-1.5h-4.5a.25.25 0 0 1-.25-.25v-10.5a.25.25 0 0 1 .25-.25h8a.25.25 0 0 1 .25.25v2.75a.75.75 0 0 0 1.5 0v-2.75a1.75 1.75 0 0 0-1.75-1.75h-8Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.5 6.75a.75.75 0 0 1 .75-.75h4a.75.75 0 0 1 0 1.5h-4a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14 10.25a.75.75 0 0 0-1.5 0v.25a2 2 0 1 0 0 4h1a.5.5 0 0 1 0 1h-2.25a.75.75 0 0 0 0 1.5h.75a.75.75 0 0 0 1.5 0 2 2 0 1 0 0-4h-1a.5.5 0 0 1 0-1h2.25a.75.75 0 0 0 0-1.5h-.75v-.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.25 9a.75.75 0 0 0 0 1.5h2.75a.75.75 0 0 0 0-1.5h-2.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.5 12.75a.75.75 0 0 1 .75-.75h2.5a.75.75 0 0 1 0 1.5h-2.5a.75.75 0 0 1-.75-.75Z"
      }));
    };
    SvgPriceListIcon.displayName = "PriceListIcon";
    exports.SvgPriceListIcon = SvgPriceListIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PrintIcon.svg.js
var require_PrintIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/PrintIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgPrintIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8 13.75a.5.5 0 0 1 .5-.5h2a.5.5 0 0 1 0 1h-2a.5.5 0 0 1-.5-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.5 11.25a.5.5 0 0 0 0 1h3a.5.5 0 0 0 0-1h-3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "m14.997 6 .001.08a1.6 1.6 0 0 1 .41.138 2 2 0 0 1 .874.874c.218.428.218.988.218 2.108v.6c0 1.12 0 1.68-.218 2.108a2 2 0 0 1-.874.874c-.237.121-.516.175-.908.199v.46c0 .244 0 .509-.019.738-.02.26-.073.602-.254.956a2.5 2.5 0 0 1-1.092 1.092c-.354.18-.697.233-.956.254-.23.02-.494.02-.739.019h-2.88c-.245 0-.51 0-.739-.019a2.518 2.518 0 0 1-.956-.254 2.5 2.5 0 0 1-1.093-1.092 2.518 2.518 0 0 1-.253-.956c-.02-.23-.02-.494-.019-.739v-.46c-.392-.023-.67-.077-.908-.198a2 2 0 0 1-.874-.874c-.218-.428-.218-.988-.218-2.108v-.6c0-1.12 0-1.68.218-2.108a2 2 0 0 1 .874-.874 1.6 1.6 0 0 1 .41-.139v-.079c.01-.675.049-1.08.216-1.408a2 2 0 0 1 .874-.874c.428-.218.988-.218 2.108-.218h3.6c1.12 0 1.68 0 2.108.218a2 2 0 0 1 .874.874c.167.328.206.733.215 1.408Zm-6.797-1h3.6c.585 0 .933.001 1.191.022.158.013.224.03.242.036a.5.5 0 0 1 .21.209c.005.018.022.084.035.242.01.133.016.29.019.491h-6.994c.003-.201.008-.358.02-.491.012-.158.03-.224.035-.242a.5.5 0 0 1 .209-.21c.018-.005.084-.022.242-.035.258-.02.606-.022 1.191-.022Zm-1.5 2.5h6.6c.585 0 .933.001 1.191.022.158.013.224.03.242.036a.5.5 0 0 1 .21.209c.005.018.022.084.035.242.02.258.022.606.022 1.191v.6c0 .585-.001.933-.022 1.191-.013.158-.03.224-.036.242a.5.5 0 0 1-.209.21 1.23 1.23 0 0 1-.233.034v-.591c0-.053 0-.165-.008-.272a1.753 1.753 0 0 0-.183-.658 1.75 1.75 0 0 0-.764-.765 1.752 1.752 0 0 0-.659-.183c-.106-.008-.22-.008-.272-.008h-5.227c-.054 0-.167 0-.273.008a1.752 1.752 0 0 0-.658.183 1.75 1.75 0 0 0-.765.765c-.14.273-.172.523-.183.658-.008.106-.008.22-.008.272v.591a1.23 1.23 0 0 1-.233-.035.5.5 0 0 1-.21-.209 1.255 1.255 0 0 1-.035-.242c-.02-.258-.022-.606-.022-1.191v-.6c0-.585.001-.933.022-1.191.013-.158.03-.224.036-.242a.5.5 0 0 1 .209-.21c.018-.005.084-.022.242-.035.258-.02.606-.022 1.191-.022Zm6.538-2.44-.003-.002.003.001Zm.203.202v.003-.003Zm-6.882 0v.003-.003Zm.203-.203h.003-.003Zm.265 5.577c-.027.054-.027.124-.027.264v2.5c0 .56 0 .84.109 1.054a1 1 0 0 0 .437.437c.214.109.494.109 1.054.109h2.8c.56 0 .84 0 1.054-.109a1 1 0 0 0 .437-.437c.109-.214.109-.494.109-1.054v-2.5c0-.14 0-.21-.027-.264a.251.251 0 0 0-.11-.109c-.053-.027-.123-.027-.263-.027h-5.2c-.14 0-.21 0-.264.027a.25.25 0 0 0-.109.11Zm7.711-3.077Zm.203.203v.003-.003Zm0 3.476v-.003a.012.012 0 0 1 0 .003Zm-.203.203h-.003.003Zm-9.476 0h.003-.003Zm-.203-.203v-.003.003Zm0-3.476v.003-.003Zm.203-.203Z"
      }));
    };
    SvgPrintIcon.displayName = "PrintIcon";
    exports.SvgPrintIcon = SvgPrintIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ProductAddIcon.svg.js
var require_ProductAddIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ProductAddIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgProductAddIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.276 3.5a3.75 3.75 0 0 0-2.701 1.149l-4.254 4.417a2.75 2.75 0 0 0 .036 3.852l2.898 2.898a2.5 2.5 0 0 0 3.502.033l.45-.434a.75.75 0 1 0-1.04-1.08l-.45.434a1 1 0 0 1-1.401-.014l-2.898-2.898a1.25 1.25 0 0 1-.016-1.75l4.253-4.418a2.25 2.25 0 0 1 1.62-.689h1.975c.966 0 1.75.784 1.75 1.75v2.371c0 .358-.146.7-.403.948a.75.75 0 1 0 1.04 1.08 2.81 2.81 0 0 0 .863-2.028v-2.371a3.25 3.25 0 0 0-3.25-3.25h-1.974Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13 8a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.75 12a.75.75 0 0 1 .75.75v1.25h1.25a.75.75 0 0 1 0 1.5h-1.25v1.25a.75.75 0 0 1-1.5 0v-1.25h-1.25a.75.75 0 0 1 0-1.5h1.25v-1.25a.75.75 0 0 1 .75-.75Z"
      }));
    };
    SvgProductAddIcon.displayName = "ProductAddIcon";
    exports.SvgProductAddIcon = SvgProductAddIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ProductCostIcon.svg.js
var require_ProductCostIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ProductCostIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgProductCostIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.575 4.649a3.75 3.75 0 0 1 2.7-1.149h1.975a3.25 3.25 0 0 1 3.25 3.25v2.5a.75.75 0 0 1-1.5 0v-2.5a1.75 1.75 0 0 0-1.75-1.75h-1.974a2.25 2.25 0 0 0-1.62.69l-4.254 4.417a1.25 1.25 0 0 0 .016 1.75l2.898 2.898a1 1 0 0 0 1.4.014l.451-.434a.75.75 0 1 1 1.04 1.08l-.45.434a2.5 2.5 0 0 1-3.502-.033l-2.898-2.898a2.75 2.75 0 0 1-.036-3.852l4.254-4.417Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14 7a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.25 11.357a1.876 1.876 0 0 0 .625 3.643h.75a.375.375 0 0 1 0 .75h-1.875a.75.75 0 0 0 0 1.5h.5v.25a.75.75 0 0 0 1.5 0v-.254a1.875 1.875 0 0 0-.125-3.746h-.75a.375.375 0 0 1 0-.75h1.875a.75.75 0 0 0 0-1.5h-1v-.25a.75.75 0 0 0-1.5 0v.357Z"
      }));
    };
    SvgProductCostIcon.displayName = "ProductCostIcon";
    exports.SvgProductCostIcon = SvgProductCostIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ProductFilledIcon.svg.js
var require_ProductFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ProductFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgProductFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.575 4.649a3.75 3.75 0 0 1 2.7-1.149h1.975a3.25 3.25 0 0 1 3.25 3.25v2.187a3.25 3.25 0 0 1-.996 2.34l-4.747 4.572a2.5 2.5 0 0 1-3.502-.033l-2.898-2.898a2.75 2.75 0 0 1-.036-3.852l4.254-4.417Zm4.425 3.351a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }));
    };
    SvgProductFilledIcon.displayName = "ProductFilledIcon";
    exports.SvgProductFilledIcon = SvgProductFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ProductIcon.svg.js
var require_ProductIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ProductIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgProductIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13 8a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11.276 3.5a3.75 3.75 0 0 0-2.701 1.149l-4.254 4.417a2.75 2.75 0 0 0 .036 3.852l2.898 2.898a2.5 2.5 0 0 0 3.502.033l4.747-4.571a3.25 3.25 0 0 0 .996-2.341v-2.187a3.25 3.25 0 0 0-3.25-3.25h-1.974Zm-1.62 2.19a2.25 2.25 0 0 1 1.62-.69h1.974c.966 0 1.75.784 1.75 1.75v2.187c0 .475-.194.93-.536 1.26l-4.747 4.572a1 1 0 0 1-1.401-.014l-2.898-2.898a1.25 1.25 0 0 1-.016-1.75l4.253-4.418Z"
      }));
    };
    SvgProductIcon.displayName = "ProductIcon";
    exports.SvgProductIcon = SvgProductIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ProductReferenceIcon.svg.js
var require_ProductReferenceIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ProductReferenceIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgProductReferenceIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.575 4.649a3.75 3.75 0 0 1 2.7-1.149h1.975a3.25 3.25 0 0 1 3.25 3.25v2.371c0 .766-.311 1.498-.863 2.029a.75.75 0 1 1-1.04-1.08c.258-.249.403-.591.403-.949v-2.371a1.75 1.75 0 0 0-1.75-1.75h-1.974a2.25 2.25 0 0 0-1.62.69l-4.254 4.417a1.25 1.25 0 0 0 .016 1.75l2.898 2.898a1 1 0 0 0 1.4.014l.451-.434a.75.75 0 1 1 1.04 1.08l-.45.434a2.5 2.5 0 0 1-3.502-.033l-2.898-2.898a2.75 2.75 0 0 1-.036-3.852l4.254-4.417Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14 7a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.78 15.72a.75.75 0 0 1-1.06 1.06l-2.22-2.22v1.19a.75.75 0 0 1-1.5 0v-3a.75.75 0 0 1 .75-.75h3a.75.75 0 1 1 0 1.5h-1.19l2.22 2.22Z"
      }));
    };
    SvgProductReferenceIcon.displayName = "ProductReferenceIcon";
    exports.SvgProductReferenceIcon = SvgProductReferenceIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ProductRemoveIcon.svg.js
var require_ProductRemoveIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ProductRemoveIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgProductRemoveIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.575 4.649a3.75 3.75 0 0 1 2.7-1.149h1.975a3.25 3.25 0 0 1 3.25 3.25v2.371c0 .766-.311 1.498-.863 2.029a.75.75 0 1 1-1.04-1.08c.258-.249.403-.591.403-.949v-2.371a1.75 1.75 0 0 0-1.75-1.75h-1.974a2.25 2.25 0 0 0-1.62.69l-4.254 4.417a1.25 1.25 0 0 0 .016 1.75l2.898 2.898a1 1 0 0 0 1.4.014l.451-.434a.75.75 0 1 1 1.04 1.08l-.45.434a2.5 2.5 0 0 1-3.502-.033l-2.898-2.898a2.75 2.75 0 0 1-.036-3.852l4.254-4.417Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14 7a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.25 12.25a.75.75 0 0 0 0 1.5h4a.75.75 0 0 0 0-1.5h-4Z"
      }));
    };
    SvgProductRemoveIcon.displayName = "ProductRemoveIcon";
    exports.SvgProductRemoveIcon = SvgProductRemoveIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ProductReturnIcon.svg.js
var require_ProductReturnIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ProductReturnIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgProductReturnIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.575 4.649a3.75 3.75 0 0 1 2.7-1.149h1.975a3.25 3.25 0 0 1 3.25 3.25v2.371c0 .766-.311 1.498-.863 2.029a.75.75 0 1 1-1.04-1.08c.258-.249.403-.591.403-.949v-2.371a1.75 1.75 0 0 0-1.75-1.75h-1.974a2.25 2.25 0 0 0-1.62.69l-4.254 4.417a1.25 1.25 0 0 0 .016 1.75l4.112 4.113a.75.75 0 1 1-1.06 1.06l-4.113-4.112a2.75 2.75 0 0 1-.036-3.852l4.254-4.417Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14 7a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M17.25 12a.75.75 0 0 0-1.5 0v.5a1.75 1.75 0 0 1-1.75 1.75h-.94l.22-.22a.75.75 0 1 0-1.06-1.06l-1.5 1.5a.75.75 0 0 0 0 1.06l1.5 1.5a.75.75 0 1 0 1.06-1.06l-.22-.22h.94a3.25 3.25 0 0 0 3.25-3.25v-.5Z"
      }));
    };
    SvgProductReturnIcon.displayName = "ProductReturnIcon";
    exports.SvgProductReturnIcon = SvgProductReturnIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ProfileIcon.svg.js
var require_ProfileIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ProfileIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgProfileIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7 8.25a3 3 0 1 1 6 0 3 3 0 0 1-6 0Zm3-1.5a1.5 1.5 0 1 0 0 3 1.5 1.5 0 0 0 0-3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15.168 15.435a7.5 7.5 0 1 1-10.336-10.87 7.5 7.5 0 0 1 10.336 10.87Zm-9.83-1.659a6 6 0 1 1 9.326 0 7.03 7.03 0 0 0-4.664-1.776 7.03 7.03 0 0 0-4.663 1.776Zm1.086 1.043a5.973 5.973 0 0 0 3.576 1.181c1.34 0 2.577-.44 3.576-1.181a5.53 5.53 0 0 0-3.576-1.319 5.53 5.53 0 0 0-3.576 1.319Z"
      }));
    };
    SvgProfileIcon.displayName = "ProfileIcon";
    exports.SvgProfileIcon = SvgProfileIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/QuestionCircleIcon.svg.js
var require_QuestionCircleIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/QuestionCircleIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgQuestionCircleIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 7.25c-.69 0-1.25.56-1.25 1.25a.75.75 0 0 1-1.5 0 2.75 2.75 0 1 1 3.758 2.56.61.61 0 0 0-.226.147.154.154 0 0 0-.032.046.75.75 0 0 1-1.5-.003c0-.865.696-1.385 1.208-1.586a1.25 1.25 0 0 0-.458-2.414Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 14.5a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 17a7 7 0 1 0 0-14 7 7 0 0 0 0 14Zm0-1.5a5.5 5.5 0 1 0 0-11 5.5 5.5 0 0 0 0 11Z"
      }));
    };
    SvgQuestionCircleIcon.displayName = "QuestionCircleIcon";
    exports.SvgQuestionCircleIcon = SvgQuestionCircleIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptDollarFilledIcon.svg.js
var require_ReceiptDollarFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptDollarFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgReceiptDollarFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.142 16.934a1 1 0 0 1-.642-.934v-11a2 2 0 0 1 2-2h7a2 2 0 0 1 2 2v11a1 1 0 0 1-1.743.669l-1.502-1.669h-.01l-1.502 1.669a1 1 0 0 1-1.486 0l-1.502-1.669h-.01l-1.502 1.669a1 1 0 0 1-1.101.265Zm4.358-11.684a.75.75 0 0 1 1.5 0v.5h.75a.75.75 0 0 1 0 1.5h-2.375a.625.625 0 1 0 0 1.25h1.25a2.125 2.125 0 0 1 0 4.25h-.125v.5a.75.75 0 0 1-1.5 0v-.5h-.75a.75.75 0 0 1 0-1.5h2.375a.625.625 0 1 0 0-1.25h-1.25a2.125 2.125 0 0 1 0-4.25h.125v-.5Z"
      }));
    };
    SvgReceiptDollarFilledIcon.displayName = "ReceiptDollarFilledIcon";
    exports.SvgReceiptDollarFilledIcon = SvgReceiptDollarFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptDollarIcon.svg.js
var require_ReceiptDollarIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptDollarIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgReceiptDollarIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4.963 17.4a1.5 1.5 0 0 1-.963-1.4v-11a2.5 2.5 0 0 1 2.5-2.5h7a2.5 2.5 0 0 1 2.5 2.5v11a1.5 1.5 0 0 1-2.615 1.003l-1.135-1.26-1.135 1.26a1.5 1.5 0 0 1-2.23 0l-1.135-1.26-1.135 1.26a1.5 1.5 0 0 1-1.652.397Zm7.388-3.4h-.203a.995.995 0 0 0-.641.326l-1.507 1.674-1.507-1.674a.995.995 0 0 0-.641-.326h-.204a.995.995 0 0 0-.641.326l-1.507 1.674v-11a1 1 0 0 1 1-1h7a1 1 0 0 1 1 1v11l-1.507-1.674a.995.995 0 0 0-.642-.326Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.25 5a.75.75 0 0 0-.75.75v.25a2 2 0 1 0 0 4h1a.5.5 0 0 1 0 1h-2.25a.75.75 0 0 0 0 1.5h.75v.25a.75.75 0 0 0 1.5 0v-.25a2 2 0 1 0 0-4h-1a.5.5 0 0 1 0-1h2.25a.75.75 0 0 0 0-1.5h-.75v-.25a.75.75 0 0 0-.75-.75Z"
      }));
    };
    SvgReceiptDollarIcon.displayName = "ReceiptDollarIcon";
    exports.SvgReceiptDollarIcon = SvgReceiptDollarIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptEuroFilledIcon.svg.js
var require_ReceiptEuroFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptEuroFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgReceiptEuroFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.142 16.934a1 1 0 0 1-.642-.934v-11a2 2 0 0 1 2-2h7a2 2 0 0 1 2 2v11a1 1 0 0 1-1.743.669l-1.502-1.669h-.01l-1.502 1.669a1 1 0 0 1-1.486 0l-1.502-1.669h-.01l-1.502 1.669a1 1 0 0 1-1.101.265Zm4.882-9.939c-.321.193-.728.692-.846 1.755h2.347a.75.75 0 0 1 0 1.5h-2.318c.146.945.526 1.459.857 1.688.406.28.83.22 1.116-.065a.75.75 0 1 1 1.06 1.06c-.82.82-2.053.912-3.028.239-.801-.553-1.356-1.556-1.518-2.922h-.194a.75.75 0 0 1 0-1.5h.172c.128-1.467.702-2.514 1.58-3.041 1.007-.604 2.21-.39 2.989.389a.75.75 0 1 1-1.061 1.06c-.327-.326-.781-.388-1.156-.163Z"
      }));
    };
    SvgReceiptEuroFilledIcon.displayName = "ReceiptEuroFilledIcon";
    exports.SvgReceiptEuroFilledIcon = SvgReceiptEuroFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptEuroIcon.svg.js
var require_ReceiptEuroIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptEuroIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgReceiptEuroIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.26 7.393c-.248.15-.579.534-.707 1.357h1.697a.75.75 0 0 1 0 1.5h-1.697c.128.823.46 1.208.708 1.357.309.185.684.137.959-.137a.75.75 0 1 1 1.06 1.06c-.725.726-1.85.928-2.79.363-.788-.472-1.304-1.385-1.449-2.643h-.291a.75.75 0 1 1 0-1.5h.291c.145-1.258.661-2.171 1.448-2.643.941-.565 2.066-.363 2.791.363a.75.75 0 0 1-1.06 1.06c-.275-.274-.65-.322-.96-.137Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 16a1.5 1.5 0 0 0 2.615 1.003l1.135-1.26 1.135 1.26a1.5 1.5 0 0 0 2.23 0l1.135-1.26 1.135 1.26a1.5 1.5 0 0 0 2.615-1.003v-11a2.5 2.5 0 0 0-2.5-2.5h-7a2.5 2.5 0 0 0-2.5 2.5v11Zm8.149-2h.202a.995.995 0 0 1 .642.326l1.507 1.674v-11a1 1 0 0 0-1-1h-7a1 1 0 0 0-1 1v11l1.507-1.674a.995.995 0 0 1 .642-.326h.202a.995.995 0 0 1 .642.326l1.507 1.674 1.507-1.674a.995.995 0 0 1 .642-.326Z"
      }));
    };
    SvgReceiptEuroIcon.displayName = "ReceiptEuroIcon";
    exports.SvgReceiptEuroIcon = SvgReceiptEuroIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptIcon.svg.js
var require_ReceiptIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgReceiptIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.75 5a.75.75 0 0 0 0 1.5h4.5a.75.75 0 1 0 0-1.5h-4.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7 8.75a.75.75 0 0 1 .75-.75h1.5a.75.75 0 0 1 0 1.5h-1.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.75 11a.75.75 0 0 0 0 1.5h1.5a.75.75 0 0 0 0-1.5h-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 8.75a.75.75 0 0 1 .75-.75h.5a.75.75 0 0 1 0 1.5h-.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.75 11a.75.75 0 0 0 0 1.5h.5a.75.75 0 0 0 0-1.5h-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 16a1.5 1.5 0 0 0 2.615 1.003l1.135-1.26 1.135 1.26a1.5 1.5 0 0 0 2.23 0l1.135-1.26 1.135 1.26a1.5 1.5 0 0 0 2.615-1.003v-11a2.5 2.5 0 0 0-2.5-2.5h-7a2.5 2.5 0 0 0-2.5 2.5v11Zm2.5-12a1 1 0 0 0-1 1v11l1.507-1.674a1 1 0 0 1 1.486 0l1.507 1.674 1.507-1.674a1 1 0 0 1 1.486 0l1.507 1.674v-11a1 1 0 0 0-1-1h-7Z"
      }));
    };
    SvgReceiptIcon.displayName = "ReceiptIcon";
    exports.SvgReceiptIcon = SvgReceiptIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptPaidIcon.svg.js
var require_ReceiptPaidIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptPaidIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgReceiptPaidIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.28 7.78a.75.75 0 0 0-1.06-1.06l-2.97 2.97-1.22-1.22a.75.75 0 0 0-1.06 1.06l1.75 1.75a.75.75 0 0 0 1.06 0l3.5-3.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 16a1.5 1.5 0 0 0 2.615 1.003l1.135-1.26 1.135 1.26a1.5 1.5 0 0 0 2.23 0l1.135-1.26 1.135 1.26a1.5 1.5 0 0 0 2.615-1.003v-11a2.5 2.5 0 0 0-2.5-2.5h-7a2.5 2.5 0 0 0-2.5 2.5v11Zm2.5-12a1 1 0 0 0-1 1v11l1.507-1.674a1 1 0 0 1 1.486 0l1.507 1.674 1.507-1.674a1 1 0 0 1 1.486 0l1.507 1.674v-11a1 1 0 0 0-1-1h-7Z"
      }));
    };
    SvgReceiptPaidIcon.displayName = "ReceiptPaidIcon";
    exports.SvgReceiptPaidIcon = SvgReceiptPaidIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptPoundFilledIcon.svg.js
var require_ReceiptPoundFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptPoundFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgReceiptPoundFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.142 16.934a1 1 0 0 1-.642-.934v-11a2 2 0 0 1 2-2h7a2 2 0 0 1 2 2v11a1 1 0 0 1-1.743.669l-1.502-1.669h-.01l-1.502 1.669a1 1 0 0 1-1.486 0l-1.502-1.669h-.01l-1.502 1.669a1 1 0 0 1-1.101.265Zm5.108-11.934a1.75 1.75 0 0 0-1.75 1.75v2h-.75a.75.75 0 0 0 0 1.5h.75v1.5h-.75a.75.75 0 0 0 0 1.5h4.5a.75.75 0 0 0 0-1.5h-2.25v-1.5h.75a.75.75 0 0 0 0-1.5h-.75v-2a.25.25 0 0 1 .25-.25h.75v1a.75.75 0 0 0 1.5 0v-1.25c0-.69-.56-1.25-1.25-1.25h-1Z"
      }));
    };
    SvgReceiptPoundFilledIcon.displayName = "ReceiptPoundFilledIcon";
    exports.SvgReceiptPoundFilledIcon = SvgReceiptPoundFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptPoundIcon.svg.js
var require_ReceiptPoundIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptPoundIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgReceiptPoundIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.25 5a1.75 1.75 0 0 0-1.75 1.75v2h-.75a.75.75 0 0 0 0 1.5h.75v1.5h-.75a.75.75 0 0 0 0 1.5h4.5a.75.75 0 0 0 0-1.5h-2.25v-1.5h.75a.75.75 0 0 0 0-1.5h-.75v-2a.25.25 0 0 1 .25-.25h.75v1a.75.75 0 0 0 1.5 0v-1.25c0-.69-.56-1.25-1.25-1.25h-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 16a1.5 1.5 0 0 0 2.615 1.003l1.135-1.26 1.135 1.26a1.5 1.5 0 0 0 2.23 0l1.135-1.26 1.135 1.26a1.5 1.5 0 0 0 2.615-1.003v-11a2.5 2.5 0 0 0-2.5-2.5h-7a2.5 2.5 0 0 0-2.5 2.5v11Zm8.149-2h.203a.995.995 0 0 1 .641.326l1.507 1.674v-11a1 1 0 0 0-1-1h-7a1 1 0 0 0-1 1v11l1.507-1.674a.995.995 0 0 1 .641-.326h.204a.995.995 0 0 1 .641.326l1.507 1.674 1.507-1.674a.995.995 0 0 1 .642-.326Z"
      }));
    };
    SvgReceiptPoundIcon.displayName = "ReceiptPoundIcon";
    exports.SvgReceiptPoundIcon = SvgReceiptPoundIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptRefundIcon.svg.js
var require_ReceiptRefundIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptRefundIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgReceiptRefundIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.25 11.25a.75.75 0 0 1-1.5 0v-.5a1.75 1.75 0 0 0-1.75-1.75h-.94l.72.72a.75.75 0 0 1-1.06 1.06l-2-2a.75.75 0 0 1 0-1.06l2-2a.75.75 0 0 1 1.06 1.06l-.72.72h.94a3.25 3.25 0 0 1 3.25 3.25v.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 16a1.5 1.5 0 0 0 2.615 1.003l1.135-1.26 1.135 1.26a1.5 1.5 0 0 0 2.23 0l1.135-1.26 1.135 1.26a1.5 1.5 0 0 0 2.615-1.003v-11a2.5 2.5 0 0 0-2.5-2.5h-7a2.5 2.5 0 0 0-2.5 2.5v11Zm2.5-12a1 1 0 0 0-1 1v11l1.507-1.674a1 1 0 0 1 1.486 0l1.507 1.674 1.507-1.674a1 1 0 0 1 1.486 0l1.507 1.674v-11a1 1 0 0 0-1-1h-7Z"
      }));
    };
    SvgReceiptRefundIcon.displayName = "ReceiptRefundIcon";
    exports.SvgReceiptRefundIcon = SvgReceiptRefundIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptRupeeFilledIcon.svg.js
var require_ReceiptRupeeFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptRupeeFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgReceiptRupeeFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.142 16.934a1 1 0 0 1-.642-.934v-11a2 2 0 0 1 2-2h7a2 2 0 0 1 2 2v11a1 1 0 0 1-1.743.669l-1.502-1.669h-.01l-1.502 1.669a1 1 0 0 1-1.486 0l-1.502-1.669h-.01l-1.502 1.669a1 1 0 0 1-1.101.265Zm6.747-3.79a.75.75 0 0 0-.246-1.033l-1.713-1.054a2.485 2.485 0 0 0 1.07-2.045v-.012h1.25a.75.75 0 0 0 0-1.5h-1.25v-1h1.25a.75.75 0 0 0 0-1.5h-4.5a.75.75 0 0 0 0 1.5h1.75v1h-1.75a.75.75 0 0 0 0 1.5h1.75v.012a.988.988 0 0 1-.988.988c-.903 0-1.238 1.184-.47 1.657l2.815 1.732a.75.75 0 0 0 1.032-.246Z"
      }));
    };
    SvgReceiptRupeeFilledIcon.displayName = "ReceiptRupeeFilledIcon";
    exports.SvgReceiptRupeeFilledIcon = SvgReceiptRupeeFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptRupeeIcon.svg.js
var require_ReceiptRupeeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptRupeeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgReceiptRupeeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.889 13.143a.75.75 0 0 0-.246-1.032l-1.713-1.054a2.485 2.485 0 0 0 1.07-2.045v-.012h1.25a.75.75 0 0 0 0-1.5h-1.25v-1h1.25a.75.75 0 0 0 0-1.5h-4.5a.75.75 0 0 0 0 1.5h1.75v1h-1.75a.75.75 0 0 0 0 1.5h1.75v.012a.988.988 0 0 1-.988.988c-.903 0-1.238 1.184-.47 1.657l2.815 1.732a.75.75 0 0 0 1.032-.246Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 16a1.5 1.5 0 0 0 2.615 1.003l1.135-1.26 1.135 1.26a1.5 1.5 0 0 0 2.23 0l1.135-1.26 1.135 1.26a1.5 1.5 0 0 0 2.615-1.003v-11a2.5 2.5 0 0 0-2.5-2.5h-7a2.5 2.5 0 0 0-2.5 2.5v11Zm8.149-2h.203a.995.995 0 0 1 .641.326l1.507 1.674v-11a1 1 0 0 0-1-1h-7a1 1 0 0 0-1 1v11l1.507-1.674a.995.995 0 0 1 .641-.326h.204a.995.995 0 0 1 .641.326l1.507 1.674 1.507-1.674a.995.995 0 0 1 .642-.326Z"
      }));
    };
    SvgReceiptRupeeIcon.displayName = "ReceiptRupeeIcon";
    exports.SvgReceiptRupeeIcon = SvgReceiptRupeeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptYenFilledIcon.svg.js
var require_ReceiptYenFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptYenFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgReceiptYenFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.142 16.934a1 1 0 0 1-.642-.934v-11a2 2 0 0 1 2-2h7a2 2 0 0 1 2 2v11a1 1 0 0 1-1.743.669l-1.502-1.669h-.01l-1.502 1.669a1 1 0 0 1-1.486 0l-1.502-1.669h-.01l-1.502 1.669a1 1 0 0 1-1.101.265Zm2.294-11.428a.75.75 0 0 1 1.058-.07l1.506 1.317 1.506-1.317a.75.75 0 0 1 .988 1.128l-1.744 1.526v.41h1.25a.75.75 0 0 1 0 1.5h-1.25v.5h1.25a.75.75 0 0 1 0 1.5h-1.25v.5a.75.75 0 0 1-1.5 0v-.5h-1.25a.75.75 0 0 1 0-1.5h1.25v-.5h-1.25a.75.75 0 1 1 0-1.5h1.25v-.41l-1.744-1.526a.75.75 0 0 1-.07-1.058Z"
      }));
    };
    SvgReceiptYenFilledIcon.displayName = "ReceiptYenFilledIcon";
    exports.SvgReceiptYenFilledIcon = SvgReceiptYenFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptYenIcon.svg.js
var require_ReceiptYenIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReceiptYenIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgReceiptYenIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.436 5.506a.75.75 0 0 1 1.058-.07l1.506 1.317 1.506-1.317a.75.75 0 0 1 .988 1.128l-1.744 1.526v.41h1.25a.75.75 0 0 1 0 1.5h-1.25v.5h1.25a.75.75 0 0 1 0 1.5h-1.25v.5a.75.75 0 0 1-1.5 0v-.5h-1.25a.75.75 0 0 1 0-1.5h1.25v-.5h-1.25a.75.75 0 1 1 0-1.5h1.25v-.41l-1.744-1.526a.75.75 0 0 1-.07-1.058Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 16a1.5 1.5 0 0 0 2.615 1.003l1.135-1.26 1.135 1.26a1.5 1.5 0 0 0 2.23 0l1.135-1.26 1.135 1.26a1.5 1.5 0 0 0 2.615-1.003v-11a2.5 2.5 0 0 0-2.5-2.5h-7a2.5 2.5 0 0 0-2.5 2.5v11Zm8.149-2h.203a.995.995 0 0 1 .641.326l1.507 1.674v-11a1 1 0 0 0-1-1h-7a1 1 0 0 0-1 1v11l1.507-1.674a.995.995 0 0 1 .641-.326h.204a.995.995 0 0 1 .641.326l1.507 1.674 1.507-1.674a.995.995 0 0 1 .642-.326Z"
      }));
    };
    SvgReceiptYenIcon.displayName = "ReceiptYenIcon";
    exports.SvgReceiptYenIcon = SvgReceiptYenIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/RedoIcon.svg.js
var require_RedoIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/RedoIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgRedoIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.53 3.72a.75.75 0 1 0-1.06 1.06l1.72 1.72h-3.94a5 5 0 0 0 0 10h1.5a.75.75 0 0 0 0-1.5h-1.5a3.5 3.5 0 1 1 0-7h3.94l-1.72 1.72a.75.75 0 1 0 1.06 1.06l3-3a.75.75 0 0 0 0-1.06l-3-3Z"
      }));
    };
    SvgRedoIcon.displayName = "RedoIcon";
    exports.SvgRedoIcon = SvgRedoIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReferralCodeIcon.svg.js
var require_ReferralCodeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReferralCodeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgReferralCodeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3 7.25a.75.75 0 0 0 0 1.5h.25v3.25a.75.75 0 0 0 1.5 0v-3.25a1.5 1.5 0 0 0-1.5-1.5h-.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7 7.25a.75.75 0 0 0 0 1.5h.818l-.993 2.111a1.5 1.5 0 0 0 1.357 2.139h.818a.75.75 0 0 0 0-1.5h-.818l.993-2.111a1.5 1.5 0 0 0-1.357-2.139h-.818Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.25 12.25a.75.75 0 0 1 .75-.75h2a.75.75 0 0 1 0 1.5h-2a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 7.25a.75.75 0 0 0 0 1.5h.818l-.31.66a1.5 1.5 0 0 0 .131 1.504l.414.586h-1.303a.75.75 0 0 0 0 1.5h1.303c1.216 0 1.926-1.371 1.225-2.365l-.414-.586.311-.66a1.5 1.5 0 0 0-1.357-2.139h-.818Z"
      }));
    };
    SvgReferralCodeIcon.displayName = "ReferralCodeIcon";
    exports.SvgReferralCodeIcon = SvgReferralCodeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/RefreshIcon.svg.js
var require_RefreshIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/RefreshIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgRefreshIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 9.25a.75.75 0 0 0 1.5 0 3 3 0 0 1 3-3h6.566l-1.123 1.248a.75.75 0 1 0 1.114 1.004l2.25-2.5a.75.75 0 0 0-.027-1.032l-2.25-2.25a.75.75 0 1 0-1.06 1.06l.97.97h-6.44a4.5 4.5 0 0 0-4.5 4.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.5 10.75a.75.75 0 0 0-1.5 0 3 3 0 0 1-3 3h-6.566l1.123-1.248a.75.75 0 1 0-1.114-1.004l-2.25 2.5a.75.75 0 0 0 .027 1.032l2.25 2.25a.75.75 0 0 0 1.06-1.06l-.97-.97h6.44a4.5 4.5 0 0 0 4.5-4.5Z"
      }));
    };
    SvgRefreshIcon.displayName = "RefreshIcon";
    exports.SvgRefreshIcon = SvgRefreshIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReplaceIcon.svg.js
var require_ReplaceIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReplaceIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgReplaceIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13.324 3.5h.852c.258 0 .494 0 .692.016.213.018.446.057.676.175.33.168.598.435.765.765.118.23.157.463.175.676.016.198.016.434.016.692v.852c0 .258 0 .494-.016.692a1.775 1.775 0 0 1-.175.676 1.75 1.75 0 0 1-.765.765 1.77 1.77 0 0 1-.676.175c-.198.016-.434.016-.692.016h-.852c-.258 0-.494 0-.692-.016a1.774 1.774 0 0 1-.676-.175 1.75 1.75 0 0 1-.765-.765 1.775 1.775 0 0 1-.175-.676c-.016-.198-.016-.434-.016-.692v-.852c0-.258 0-.494.016-.692a1.77 1.77 0 0 1 .175-.676 1.75 1.75 0 0 1 .764-.765c.23-.118.464-.157.677-.175.198-.016.434-.016.692-.016Zm-.693 1.53h.001Zm.002-.001a.626.626 0 0 1 .121-.018c.13-.01.304-.011.596-.011h.8c.292 0 .467 0 .596.011a.626.626 0 0 1 .12.018.25.25 0 0 1 .105.104.638.638 0 0 1 .018.121c.01.13.011.304.011.596v.8c0 .292 0 .467-.011.596a.638.638 0 0 1-.018.12.25.25 0 0 1-.104.105.626.626 0 0 1-.121.018c-.13.01-.304.011-.596.011h-.8c-.292 0-.467 0-.596-.011a.626.626 0 0 1-.12-.018.25.25 0 0 1-.105-.104.638.638 0 0 1-.018-.121 8.374 8.374 0 0 1-.011-.596v-.8c0-.292 0-.467.011-.596a.638.638 0 0 1 .018-.12.25.25 0 0 1 .104-.105Zm-.103.102v.001Zm0 2.238v-.001Zm.1.101h.002Zm2.24 0h-.002Zm.1-.1v-.002Zm0-2.24v.002Zm-.102-.1h.001Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.676 16.5h-.852c-.258 0-.494 0-.692-.016a1.775 1.775 0 0 1-.676-.175 1.75 1.75 0 0 1-.765-.765 1.774 1.774 0 0 1-.175-.676c-.016-.198-.016-.434-.016-.692v-.852c0-.258 0-.494.016-.692a1.77 1.77 0 0 1 .175-.676 1.75 1.75 0 0 1 .765-.765c.23-.118.463-.158.676-.175.198-.016.434-.016.692-.016h.852c.258 0 .494 0 .692.016.213.018.446.057.676.175.33.167.597.435.765.764.118.23.157.464.175.677.016.198.016.434.016.692v.852c0 .258 0 .494-.016.692a1.774 1.774 0 0 1-.175.676 1.75 1.75 0 0 1-.765.765 1.77 1.77 0 0 1-.676.175c-.198.016-.434.016-.692.016Zm.693-1.53h-.001Zm-.002.001a.638.638 0 0 1-.121.018c-.13.01-.304.011-.596.011h-.8c-.292 0-.467 0-.596-.011a.638.638 0 0 1-.12-.018.25.25 0 0 1-.105-.104.626.626 0 0 1-.018-.121 8.337 8.337 0 0 1-.011-.596v-.8c0-.292 0-.467.011-.596a.626.626 0 0 1 .018-.12.25.25 0 0 1 .104-.105.638.638 0 0 1 .121-.018c.13-.01.304-.011.596-.011h.8c.292 0 .467 0 .596.011a.638.638 0 0 1 .12.018.25.25 0 0 1 .105.104.626.626 0 0 1 .018.121c.01.13.011.304.011.596v.8c0 .292 0 .467-.011.596a.626.626 0 0 1-.018.12.25.25 0 0 1-.104.105Zm.103-.102v-.001Zm0-2.238v.001Zm-.1-.101h-.002Zm-2.24 0h.002Zm-.1.1v.002Zm0 2.24v-.002Zm.102.1h-.001Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.97 4.53a.75.75 0 1 1 1.06-1.06l1.995 1.994a.758.758 0 0 1 .225.536v.007a.75.75 0 0 1-.22.523l-2 2a.75.75 0 0 1-1.06-1.06l.72-.72h-.24c-.572 0-.957 0-1.253.025-.287.023-.424.065-.514.111a1.25 1.25 0 0 0-.547.547c-.046.09-.088.227-.111.514-.024.296-.025.68-.025 1.253v.3a.75.75 0 0 1-1.5 0v-.33c0-.535 0-.98.03-1.345.03-.38.098-.736.27-1.073a2.75 2.75 0 0 1 1.202-1.202c.337-.172.693-.24 1.073-.27.365-.03.81-.03 1.345-.03h.27l-.72-.72Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.803 13.225c-.296.024-.68.025-1.253.025h-.24l.72-.72a.75.75 0 0 0-1.06-1.06l-2 2a.748.748 0 0 0 .005 1.066l1.995 1.994a.75.75 0 1 0 1.06-1.06l-.72-.72h.27c.535 0 .98 0 1.345-.03.38-.03.736-.098 1.073-.27a2.751 2.751 0 0 0 1.202-1.201c.172-.338.24-.694.27-1.074.03-.365.03-.81.03-1.345v-.33a.75.75 0 0 0-1.5 0v.3c0 .572 0 .957-.025 1.252-.023.288-.065.425-.111.516a1.25 1.25 0 0 1-.546.546c-.091.046-.228.088-.515.111Z"
      }));
    };
    SvgReplaceIcon.displayName = "ReplaceIcon";
    exports.SvgReplaceIcon = SvgReplaceIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReplayIcon.svg.js
var require_ReplayIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReplayIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgReplayIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.53 3.47a.75.75 0 1 0-1.06 1.06l1.72 1.72h-2.69a5 5 0 0 0 0 10h.5a4.75 4.75 0 0 0 4.75-4.75.75.75 0 0 0-1.5 0 3.25 3.25 0 0 1-3.25 3.25h-.5a3.5 3.5 0 1 1 0-7h2.69l-1.72 1.72a.75.75 0 1 0 1.06 1.06l3-3a.75.75 0 0 0 0-1.06l-3-3Z"
      }));
    };
    SvgReplayIcon.displayName = "ReplayIcon";
    exports.SvgReplayIcon = SvgReplayIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ResetIcon.svg.js
var require_ResetIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ResetIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgResetIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M17 9.25a.75.75 0 0 1-1.5 0 3 3 0 0 0-3-3h-6.566l1.123 1.248a.75.75 0 1 1-1.114 1.004l-2.25-2.5a.75.75 0 0 1 .027-1.032l2.25-2.25a.75.75 0 0 1 1.06 1.06l-.97.97h6.44a4.5 4.5 0 0 1 4.5 4.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3 10.75a.75.75 0 0 1 1.5 0 3 3 0 0 0 3 3h6.566l-1.123-1.248a.75.75 0 1 1 1.114-1.004l2.25 2.5a.75.75 0 0 1-.027 1.032l-2.25 2.25a.75.75 0 1 1-1.06-1.06l.97-.97h-6.44a4.5 4.5 0 0 1-4.5-4.5Z"
      }));
    };
    SvgResetIcon.displayName = "ResetIcon";
    exports.SvgResetIcon = SvgResetIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReturnIcon.svg.js
var require_ReturnIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ReturnIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgReturnIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 12c.241 0 .334 0 .41-.004a3.25 3.25 0 0 0 3.086-3.087c.004-.075.004-.168.004-.409 0-.241 0-.334-.004-.41a3.25 3.25 0 0 0-3.087-3.086 9.616 9.616 0 0 0-.409-.004h-1.5a.75.75 0 0 1 0-1.5h1.524c.21 0 .342 0 .46.006a4.75 4.75 0 0 1 4.51 4.51c.006.118.006.25.006.46v.048c0 .21 0 .342-.006.46a4.75 4.75 0 0 1-4.51 4.51c-.118.006-.25.006-.46.006h-3.963l1.72 1.72a.75.75 0 1 1-1.061 1.06l-3-3a.75.75 0 0 1 0-1.06l3-3a.75.75 0 0 1 1.06 1.06l-1.72 1.72h3.94Z"
      }));
    };
    SvgReturnIcon.displayName = "ReturnIcon";
    exports.SvgReturnIcon = SvgReturnIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/RewardIcon.svg.js
var require_RewardIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/RewardIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgRewardIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.654 14.33a2.084 2.084 0 0 1-.41-.48.568.568 0 0 0-.61-.252c-.219.05-.435.065-.643.048l-.935 1.604h.56a1 1 0 0 1 .832.445l.244.366.962-1.732Zm-3.011-1.349a2.048 2.048 0 0 1-.49-1.866.568.568 0 0 0-.253-.61 2.068 2.068 0 0 1 0-3.51.568.568 0 0 0 .253-.61 2.068 2.068 0 0 1 2.482-2.482.568.568 0 0 0 .61-.253c.81-1.3 2.7-1.3 3.51 0a.568.568 0 0 0 .61.253 2.068 2.068 0 0 1 2.482 2.482.567.567 0 0 0 .253.61c1.3.81 1.3 2.7 0 3.51a.567.567 0 0 0-.252.61 2.047 2.047 0 0 1-.44 1.81l1.353 2.321a1 1 0 0 1-.864 1.504h-1.227l-.478.782a1 1 0 0 1-1.72-.025l-1.457-2.539-1.41 2.538a1 1 0 0 1-1.706.069l-.55-.825h-1.164a1 1 0 0 1-.863-1.504l1.32-2.265Zm6.71 3.048-.986-1.718a2.09 2.09 0 0 0 .388-.46.567.567 0 0 1 .61-.254c.247.058.49.07.721.041l.94 1.612h-.636a1 1 0 0 0-.853.478l-.184.301Zm-1.871-2.972a.568.568 0 0 1-.964 0 2.068 2.068 0 0 0-2.223-.92.568.568 0 0 1-.681-.682c.2-.862-.17-1.756-.921-2.223a.568.568 0 0 1 0-.964 2.068 2.068 0 0 0 .92-2.223.568.568 0 0 1 .682-.681c.862.2 1.756-.17 2.223-.921a.568.568 0 0 1 .964 0 2.067 2.067 0 0 0 2.223.92.568.568 0 0 1 .681.682c-.2.862.17 1.756.921 2.223a.568.568 0 0 1 0 .964 2.068 2.068 0 0 0-.92 2.223.568.568 0 0 1-.682.681c-.862-.2-1.755.17-2.223.921Z"
      }));
    };
    SvgRewardIcon.displayName = "RewardIcon";
    exports.SvgRewardIcon = SvgRewardIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SandboxIcon.svg.js
var require_SandboxIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SandboxIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSandboxIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9.605 3.362a.75.75 0 0 1 .79 0l5.25 3.25a.75.75 0 0 1 .345.763c.006.04.01.082.01.125v5.5a.75.75 0 0 1-.355.638l-5.25 3.25a.75.75 0 0 1-.79 0l-5.25-3.25a.75.75 0 0 1-.355-.638v-5.5c0-.043.004-.085.01-.125a.75.75 0 0 1 .345-.763l5.25-3.25Zm1.145 7.556 3.75-2.322v3.986l-3.75 2.322v-3.986Zm-1.5 0-3.75-2.322v3.986l3.75 2.322v-3.986Zm-3.075-3.668 3.825 2.368 3.825-2.368-3.825-2.368-3.825 2.368Z"
      }));
    };
    SvgSandboxIcon.displayName = "SandboxIcon";
    exports.SvgSandboxIcon = SvgSandboxIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SaveIcon.svg.js
var require_SaveIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SaveIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSaveIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.5 6.26a.75.75 0 0 1-1.5 0v-.51a.75.75 0 0 0-.75-.75h-8.5a.75.75 0 0 0-.75.75v.51a.75.75 0 0 1-1.5 0v-.51a2.25 2.25 0 0 1 2.25-2.25h8.5a2.25 2.25 0 0 1 2.25 2.25v.51Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 7.51a.75.75 0 0 0-1.5 0v6.69l-1.72-1.72a.75.75 0 0 0-1.06 1.06l3 3a.75.75 0 0 0 1.06 0l3-3a.75.75 0 1 0-1.06-1.06l-1.72 1.72v-6.69Z"
      }));
    };
    SvgSaveIcon.displayName = "SaveIcon";
    exports.SvgSaveIcon = SvgSaveIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SearchIcon.svg.js
var require_SearchIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SearchIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSearchIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12.323 13.383a5.5 5.5 0 1 1 1.06-1.06l2.897 2.897a.75.75 0 1 1-1.06 1.06l-2.897-2.897Zm.677-4.383a4 4 0 1 1-8 0 4 4 0 0 1 8 0Z"
      }));
    };
    SvgSearchIcon.displayName = "SearchIcon";
    exports.SvgSearchIcon = SvgSearchIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SearchListIcon.svg.js
var require_SearchListIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SearchListIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSearchListIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.5 4.5a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13.189 14.25a4.001 4.001 0 0 1-5.648-2h-.791a.75.75 0 0 1 0-1.5h.5c0-.729.195-1.412.535-2h-1.035a.75.75 0 0 1 0-1.5h2.562a4 4 0 0 1 5.033 6.034l1.935 1.936a.75.75 0 1 1-1.06 1.06l-2.031-2.03Zm.561-3.5a2.5 2.5 0 1 1-5 0 2.5 2.5 0 0 1 5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.5 9a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.5 11.5a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.75 3.75a.75.75 0 0 0 0 1.5h6.5a.75.75 0 0 0 0-1.5h-6.5Z"
      }));
    };
    SvgSearchListIcon.displayName = "SearchListIcon";
    exports.SvgSearchListIcon = SvgSearchListIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SearchRecentIcon.svg.js
var require_SearchRecentIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SearchRecentIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSearchRecentIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.75 6.5a.75.75 0 0 0-1.5 0v2.5c0 .284.16.544.415.67l1.5.75a.75.75 0 1 0 .67-1.34l-1.085-.544v-2.036Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9 14.5c1.248 0 2.4-.416 3.323-1.117l2.897 2.897a.75.75 0 1 0 1.06-1.06l-2.897-2.897a5.5 5.5 0 1 0-4.383 2.177Zm0-1.5a4 4 0 1 0 0-8 4 4 0 0 0 0 8Z"
      }));
    };
    SvgSearchRecentIcon.displayName = "SearchRecentIcon";
    exports.SvgSearchRecentIcon = SvgSearchRecentIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SearchResourceIcon.svg.js
var require_SearchResourceIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SearchResourceIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSearchResourceIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.018 3.5h1.964c.813 0 1.469 0 2 .043.546.045 1.026.14 1.47.366a3.75 3.75 0 0 1 1.64 1.639c.226.444.32.924.365 1.47.043.531.043 1.187.043 2v.232a.75.75 0 0 1-1.5 0v-.2c0-.852 0-1.447-.038-1.91-.037-.453-.107-.714-.207-.911a2.25 2.25 0 0 0-.984-.984c-.197-.1-.458-.17-.912-.207-.462-.037-1.056-.038-1.909-.038h-1.9c-.852 0-1.447 0-1.91.038-.453.037-.714.107-.911.207a2.25 2.25 0 0 0-.984.984c-.1.197-.17.458-.207.912-.037.462-.038 1.057-.038 1.909v1.9c0 .853 0 1.447.038 1.91.037.453.107.714.207.912.216.423.56.767.984.983.197.1.458.17.912.207.462.037 1.057.038 1.909.038h.2a.75.75 0 0 1 0 1.5h-.232c-.813 0-1.469 0-2-.043-.546-.045-1.026-.14-1.47-.366a3.75 3.75 0 0 1-1.64-1.639c-.226-.444-.32-.924-.365-1.47-.043-.531-.043-1.187-.043-2v-1.964c0-.813 0-1.469.043-2 .045-.546.14-1.026.366-1.47a3.75 3.75 0 0 1 1.639-1.64c.444-.226.924-.32 1.47-.365.531-.043 1.187-.043 2-.043Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10.25 13a2.75 2.75 0 1 1 5.152 1.34l1.128 1.13a.75.75 0 1 1-1.06 1.06l-1.13-1.129a2.75 2.75 0 0 1-4.09-2.402Zm2.75-1.25a1.25 1.25 0 1 0 0 2.5 1.25 1.25 0 0 0 0-2.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7 7.75a.75.75 0 0 1 .75-.75h4.5a.75.75 0 0 1 0 1.5h-4.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.75 10a.75.75 0 0 0 0 1.5h1.5a.75.75 0 0 0 0-1.5h-1.5Z"
      }));
    };
    SvgSearchResourceIcon.displayName = "SearchResourceIcon";
    exports.SvgSearchResourceIcon = SvgSearchResourceIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SelectIcon.svg.js
var require_SelectIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SelectIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSelectIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.884 4.323a1.25 1.25 0 0 0-1.768 0l-2.646 2.647a.75.75 0 0 0 1.06 1.06l2.47-2.47 2.47 2.47a.75.75 0 1 0 1.06-1.06l-2.646-2.647Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "m13.53 13.03-2.646 2.647a1.25 1.25 0 0 1-1.768 0l-2.646-2.647a.75.75 0 0 1 1.06-1.06l2.47 2.47 2.47-2.47a.75.75 0 0 1 1.06 1.06Z"
      }));
    };
    SvgSelectIcon.displayName = "SelectIcon";
    exports.SvgSelectIcon = SvgSelectIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SendIcon.svg.js
var require_SendIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SendIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSendIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "m5.008 9.61-2.01-4.75c-.354-.838.506-1.676 1.336-1.3l12.163 5.53a1 1 0 0 1 0 1.82l-12.163 5.53c-.83.376-1.69-.462-1.335-1.3l2.01-4.75a1 1 0 0 0 0-.78Zm1.382-.584-1.51-3.57 9.995 4.544-9.995 4.543 1.51-3.569c.03-.074.058-.148.082-.224h3.778a.75.75 0 0 0 0-1.5h-3.778a2.5 2.5 0 0 0-.082-.224Z"
      }));
    };
    SvgSendIcon.displayName = "SendIcon";
    exports.SvgSendIcon = SvgSendIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SettingsFilledIcon.svg.js
var require_SettingsFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SettingsFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSettingsFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.013 4.389c0-.767.621-1.389 1.389-1.389h1.196c.767 0 1.39.622 1.39 1.389v.66c0 .153.101.33.307.436.141.074.278.155.411.241.196.128.402.13.536.052l.576-.332a1.389 1.389 0 0 1 1.897.508l.599 1.037a1.39 1.39 0 0 1-.509 1.897l-.621.359c-.131.075-.232.249-.225.477a5.135 5.135 0 0 1-.004.427c-.012.233.09.412.223.489l.627.362c.665.384.892 1.233.509 1.897l-.599 1.037a1.39 1.39 0 0 1-1.897.508l-.672-.388c-.132-.076-.332-.076-.526.045a4.928 4.928 0 0 1-.325.185c-.206.108-.308.284-.308.437v.778a1.39 1.39 0 0 1-1.389 1.39h-1.196a1.389 1.389 0 0 1-1.39-1.39v-.778c0-.153-.102-.33-.307-.437a4.96 4.96 0 0 1-.325-.185c-.194-.121-.395-.12-.526-.045l-.672.388a1.39 1.39 0 0 1-1.898-.508l-.598-1.037a1.389 1.389 0 0 1 .509-1.897l.627-.362c.133-.077.235-.256.223-.49a5.03 5.03 0 0 1-.004-.426c.007-.228-.094-.401-.225-.477l-.621-.359a1.389 1.389 0 0 1-.509-1.897l.598-1.037a1.389 1.389 0 0 1 1.898-.508l.576.332c.133.078.34.076.535-.052a4.81 4.81 0 0 1 .412-.24c.205-.108.308-.284.308-.437v-.66Zm1.987 7.611a2 2 0 1 0 0-4 2 2 0 0 0 0 4Z"
      }));
    };
    SvgSettingsFilledIcon.displayName = "SettingsFilledIcon";
    exports.SvgSettingsFilledIcon = SvgSettingsFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SettingsIcon.svg.js
var require_SettingsIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SettingsIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSettingsIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12.5 10a2.5 2.5 0 1 1-5 0 2.5 2.5 0 0 1 5 0Zm-1.5 0a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9.377 2.5c-.926 0-1.676.75-1.676 1.676v.688c0 .056-.043.17-.198.251-.153.08-.303.168-.448.262-.147.097-.268.076-.318.048l-.6-.346a1.676 1.676 0 0 0-2.29.613l-.622 1.08a1.676 1.676 0 0 0 .613 2.289l.648.374c.048.028.124.12.119.29a5.484 5.484 0 0 0 .005.465c.009.175-.07.27-.119.299l-.653.377a1.676 1.676 0 0 0-.613 2.29l.623 1.08a1.676 1.676 0 0 0 2.29.613l.7-.405c.048-.028.166-.048.312.043.115.071.233.139.353.202.155.08.198.195.198.251v.811c0 .926.75 1.676 1.676 1.676h1.246c.926 0 1.676-.75 1.676-1.676v-.81c0-.057.042-.171.197-.252.121-.063.239-.13.354-.202.146-.091.264-.07.312-.043l.7.405a1.676 1.676 0 0 0 2.29-.614l.623-1.08a1.676 1.676 0 0 0-.613-2.289l-.653-.377c-.05-.029-.128-.123-.119-.3a5.494 5.494 0 0 0 .005-.463c-.005-.171.07-.263.12-.291l.647-.374a1.676 1.676 0 0 0 .613-2.29l-.623-1.079a1.676 1.676 0 0 0-2.29-.613l-.6.346c-.049.028-.17.048-.318-.048a5.4 5.4 0 0 0-.448-.262c-.155-.081-.197-.195-.197-.251v-.688c0-.926-.75-1.676-1.676-1.676h-1.246Zm-.176 1.676c0-.097.078-.176.176-.176h1.246c.097 0 .176.079.176.176v.688c0 .728.462 1.298 1.003 1.58.11.058.219.122.323.19.517.337 1.25.458 1.888.09l.6-.346a.176.176 0 0 1 .24.064l.623 1.08a.176.176 0 0 1-.064.24l-.648.374c-.623.36-.888 1.034-.868 1.638a4.184 4.184 0 0 1-.004.337c-.032.615.23 1.31.867 1.677l.653.377a.176.176 0 0 1 .064.24l-.623 1.08a.176.176 0 0 1-.24.065l-.701-.405c-.624-.36-1.341-.251-1.855.069a3.91 3.91 0 0 1-.255.145c-.54.283-1.003.853-1.003 1.581v.811a.176.176 0 0 1-.176.176h-1.246a.176.176 0 0 1-.176-.176v-.81c0-.73-.462-1.3-1.003-1.582a3.873 3.873 0 0 1-.255-.146c-.514-.32-1.23-.428-1.855-.068l-.7.405a.176.176 0 0 1-.241-.065l-.623-1.08a.176.176 0 0 1 .064-.24l.653-.377c.637-.368.899-1.062.867-1.677a3.97 3.97 0 0 1-.004-.337c.02-.604-.245-1.278-.868-1.638l-.648-.374a.176.176 0 0 1-.064-.24l.623-1.08a.176.176 0 0 1 .24-.064l.6.346c.638.368 1.37.247 1.888-.09a3.85 3.85 0 0 1 .323-.19c.54-.282 1.003-.852 1.003-1.58v-.688Z"
      }));
    };
    SvgSettingsIcon.displayName = "SettingsIcon";
    exports.SvgSettingsIcon = SvgSettingsIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ShareIcon.svg.js
var require_ShareIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ShareIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgShareIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 12.75a.75.75 0 0 1-1.5 0v-6.69l-1.22 1.22a.75.75 0 0 1-1.06-1.06l2.5-2.5a.75.75 0 0 1 1.06 0l2.5 2.5a.75.75 0 0 1-1.06 1.06l-1.22-1.22v6.69Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.5 10.25a2.25 2.25 0 0 0-2.25-2.25h-.07a.75.75 0 0 0 0 1.5h.07a.75.75 0 0 1 .75.75v4a.75.75 0 0 1-.75.75h-8.5a.75.75 0 0 1-.75-.75v-4a.75.75 0 0 1 .75-.75h.07a.75.75 0 0 0 0-1.5h-.07a2.25 2.25 0 0 0-2.25 2.25v4a2.25 2.25 0 0 0 2.25 2.25h8.5a2.25 2.25 0 0 0 2.25-2.25v-4Z"
      }));
    };
    SvgShareIcon.displayName = "ShareIcon";
    exports.SvgShareIcon = SvgShareIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ShieldCheckMarkIcon.svg.js
var require_ShieldCheckMarkIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ShieldCheckMarkIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgShieldCheckMarkIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.28 8.683a.75.75 0 0 0-1.06 1.06l1.548 1.548a.75.75 0 0 0 1.06 0l2.963-2.962a.75.75 0 0 0-1.06-1.06l-2.433 2.431-1.018-1.017Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11.093 2.914a1.75 1.75 0 0 0-2.186 0l-.317.253a15.25 15.25 0 0 1-3.217 1.976l-.847.384a1.71 1.71 0 0 0-1.01 1.628c.28 6.25 4.38 9.048 5.732 9.802.47.262 1.034.262 1.503 0 1.352-.753 5.454-3.55 5.734-9.783a1.71 1.71 0 0 0-1.002-1.623l-.9-.416a15.249 15.249 0 0 1-3.136-1.938l-.354-.283Zm-1.25 1.171a.25.25 0 0 1 .313 0l.354.283a16.749 16.749 0 0 0 3.445 2.129l.9.415a.213.213 0 0 1 .131.195c-.246 5.489-3.827 7.906-4.965 8.54a.042.042 0 0 1-.02.006c-.005 0-.012 0-.022-.006-1.136-.634-4.718-3.053-4.965-8.56-.003-.066.037-.15.133-.194l.846-.385a16.75 16.75 0 0 0 3.534-2.17l.317-.253Z"
      }));
    };
    SvgShieldCheckMarkIcon.displayName = "ShieldCheckMarkIcon";
    exports.SvgShieldCheckMarkIcon = SvgShieldCheckMarkIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ShieldNoneIcon.svg.js
var require_ShieldNoneIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ShieldNoneIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgShieldNoneIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.506 3.973a15.26 15.26 0 0 1-1.059-.775l-.354-.283a1.75 1.75 0 0 0-2.186 0l-.317.253a15.25 15.25 0 0 1-3.217 1.976l-.847.384a1.71 1.71 0 0 0-1.01 1.628c.083 1.865.507 3.422 1.096 4.71l1.146-1.145c-.401-1.025-.681-2.228-.744-3.632-.003-.068.037-.152.133-.195l.846-.385a16.75 16.75 0 0 0 3.534-2.17l.317-.253a.25.25 0 0 1 .312 0l.354.283c.298.238.603.466.916.683l1.08-1.08Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4.553 14.046a.75.75 0 0 0 1.066 1.056l.64-.64a11.092 11.092 0 0 0 2.99 2.496 1.533 1.533 0 0 0 1.502 0c1.352-.753 5.454-3.55 5.734-9.783a1.71 1.71 0 0 0-1.002-1.623l-.215-.1.604-.603a.75.75 0 1 0-1.06-1.06l-10.254 10.252a2.489 2.489 0 0 1-.005.005Zm5.426 1.602a9.544 9.544 0 0 1-2.655-2.251l6.814-6.814.717.33a.213.213 0 0 1 .131.195c-.246 5.489-3.827 7.906-4.965 8.54a.043.043 0 0 1-.02.006c-.005 0-.012 0-.022-.006Z"
      }));
    };
    SvgShieldNoneIcon.displayName = "ShieldNoneIcon";
    exports.SvgShieldNoneIcon = SvgShieldNoneIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ShieldPendingIcon.svg.js
var require_ShieldPendingIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ShieldPendingIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgShieldPendingIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.25 11.75a.75.75 0 0 0-1.5 0v1.647a1 1 0 0 0 .293.707l.677.677a.75.75 0 1 0 1.06-1.06l-.53-.531v-1.44Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11.093 2.915a1.75 1.75 0 0 0-2.186 0l-.317.253a15.25 15.25 0 0 1-3.217 1.976l-.847.384a1.71 1.71 0 0 0-1.01 1.628c.28 6.25 4.38 9.048 5.732 9.802.443.247.97.26 1.423.042a4.5 4.5 0 1 0 5.433-7.17c.202-.806.338-1.69.381-2.655a1.71 1.71 0 0 0-1.002-1.623l-.9-.416a15.249 15.249 0 0 1-3.136-1.938l-.354-.283Zm-2.093 10.585c0 .626.128 1.221.358 1.762-1.472-1.004-4.132-3.455-4.344-8.173-.003-.068.037-.152.133-.195l.846-.385a16.75 16.75 0 0 0 3.534-2.17l.317-.253a.25.25 0 0 1 .312 0l.354.283a16.75 16.75 0 0 0 3.445 2.129l.9.415a.213.213 0 0 1 .131.195 11.927 11.927 0 0 1-.268 2.06 4.504 4.504 0 0 0-5.718 4.333Zm4.5 3a3 3 0 1 0 0-6 3 3 0 0 0 0 6Z"
      }));
    };
    SvgShieldPendingIcon.displayName = "ShieldPendingIcon";
    exports.SvgShieldPendingIcon = SvgShieldPendingIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ShieldPersonIcon.svg.js
var require_ShieldPersonIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ShieldPersonIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgShieldPersonIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.907 2.915a1.75 1.75 0 0 1 2.186 0l.354.283a15.27 15.27 0 0 0 3.136 1.938l.9.416a1.709 1.709 0 0 1 1.002 1.622 13.42 13.42 0 0 1-.23 1.969.75.75 0 0 1-1.472-.284c.105-.544.176-1.127.204-1.752a.213.213 0 0 0-.132-.194l-.9-.415a16.75 16.75 0 0 1-3.445-2.129l-.354-.283a.25.25 0 0 0-.312 0l-.317.254a16.75 16.75 0 0 1-3.534 2.17l-.846.384c-.096.043-.136.127-.133.195.148 3.303 1.49 5.482 2.78 6.839a9.71 9.71 0 0 0 1.76 1.464 7.378 7.378 0 0 0 .741.42l.005.001a.75.75 0 0 1-.599 1.375l.299-.687-.299.687h-.002l-.002-.001-.006-.003-.017-.008a5.893 5.893 0 0 1-.256-.127 8.9 8.9 0 0 1-.676-.396 11.209 11.209 0 0 1-2.035-1.692c-1.499-1.576-3.025-4.086-3.192-7.805a1.71 1.71 0 0 1 1.011-1.628l.847-.384a15.25 15.25 0 0 0 3.217-1.976l.317-.253Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.018 14.75h-.036a2.768 2.768 0 0 0-2.454 1.488.692.692 0 0 0 .614 1.012h3.716c.52 0 .854-.551.614-1.012a2.768 2.768 0 0 0-2.455-1.487Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14 13.75a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3Z"
      }));
    };
    SvgShieldPersonIcon.displayName = "ShieldPersonIcon";
    exports.SvgShieldPersonIcon = SvgShieldPersonIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ShippingLabelFilledIcon.svg.js
var require_ShippingLabelFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ShippingLabelFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgShippingLabelFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5 3.25a1 1 0 0 0-1 1v12a1 1 0 0 0 1 1h10a1 1 0 0 0 1-1v-12a1 1 0 0 0-1-1h-10Zm2 2a.5.5 0 0 0-.5.5v2a.5.5 0 0 0 .5.5h2a.5.5 0 0 0 .5-.5v-2a.5.5 0 0 0-.5-.5h-2Zm0 4.5a.75.75 0 0 0 0 1.5h6a.75.75 0 0 0 0-1.5h-6Zm1 3.75v1a.75.75 0 0 1-1.5 0v-1a.75.75 0 0 1 1.5 0Zm2.75 1v-1a.75.75 0 0 0-1.5 0v1a.75.75 0 0 0 1.5 0Zm2.75-1v1a.75.75 0 0 1-1.5 0v-1a.75.75 0 0 1 1.5 0Z"
      }));
    };
    SvgShippingLabelFilledIcon.displayName = "ShippingLabelFilledIcon";
    exports.SvgShippingLabelFilledIcon = SvgShippingLabelFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ShippingLabelIcon.svg.js
var require_ShippingLabelIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ShippingLabelIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgShippingLabelIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.5 5.75a.5.5 0 0 0-.5.5v2a.5.5 0 0 0 .5.5h2a.5.5 0 0 0 .5-.5v-2a.5.5 0 0 0-.5-.5h-2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.5 10.5a.75.75 0 0 1 .75-.75h5.5a.75.75 0 0 1 0 1.5h-5.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.5 14v-1a.75.75 0 0 0-1.5 0v1a.75.75 0 0 0 1.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 13v1a.75.75 0 0 1-1.5 0v-1a.75.75 0 0 1 1.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13 14v-1a.75.75 0 0 0-1.5 0v1a.75.75 0 0 0 1.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 4.25a1 1 0 0 1 1-1h10a1 1 0 0 1 1 1v12a1 1 0 0 1-1 1h-10a1 1 0 0 1-1-1v-12Zm1.5 11.5v-11h9v11h-9Z"
      }));
    };
    SvgShippingLabelIcon.displayName = "ShippingLabelIcon";
    exports.SvgShippingLabelIcon = SvgShippingLabelIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ShopcodesIcon.svg.js
var require_ShopcodesIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ShopcodesIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgShopcodesIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.75 6.25a.5.5 0 0 1 .5-.5h.5a.5.5 0 0 1 .5.5v.5a.5.5 0 0 1-.5.5h-.5a.5.5 0 0 1-.5-.5v-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 5.25c0-.966.784-1.75 1.75-1.75h2.5c.966 0 1.75.784 1.75 1.75v2.5a1.75 1.75 0 0 1-1.75 1.75h-2.5a1.75 1.75 0 0 1-1.75-1.75v-2.5Zm1.75-.25a.25.25 0 0 0-.25.25v2.5c0 .138.112.25.25.25h2.5a.25.25 0 0 0 .25-.25v-2.5a.25.25 0 0 0-.25-.25h-2.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.25 12.75a.5.5 0 0 0-.5.5v.5a.5.5 0 0 0 .5.5h.5a.5.5 0 0 0 .5-.5v-.5a.5.5 0 0 0-.5-.5h-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 12.25c0-.966.784-1.75 1.75-1.75h2.5c.966 0 1.75.784 1.75 1.75v2.5a1.75 1.75 0 0 1-1.75 1.75h-2.5a1.75 1.75 0 0 1-1.75-1.75v-2.5Zm1.75-.25a.25.25 0 0 0-.25.25v2.5c0 .138.112.25.25.25h2.5a.25.25 0 0 0 .25-.25v-2.5a.25.25 0 0 0-.25-.25h-2.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.75 6.25a.5.5 0 0 1 .5-.5h.5a.5.5 0 0 1 .5.5v.5a.5.5 0 0 1-.5.5h-.5a.5.5 0 0 1-.5-.5v-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12.25 3.5a1.75 1.75 0 0 0-1.75 1.75v2.5c0 .966.784 1.75 1.75 1.75h2.5a1.75 1.75 0 0 0 1.75-1.75v-2.5a1.75 1.75 0 0 0-1.75-1.75h-2.5Zm-.25 1.75a.25.25 0 0 1 .25-.25h2.5a.25.25 0 0 1 .25.25v2.5a.25.25 0 0 1-.25.25h-2.5a.25.25 0 0 1-.25-.25v-2.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 10.5a.5.5 0 0 0-.5.5v1a.5.5 0 0 0 .5.5h1a.5.5 0 0 0 .5-.5v-1a.5.5 0 0 0-.5-.5h-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.5 15a.5.5 0 0 1 .5-.5h1a.5.5 0 0 1 .5.5v1a.5.5 0 0 1-.5.5h-1a.5.5 0 0 1-.5-.5v-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15 10.5a.5.5 0 0 0-.5.5v1a.5.5 0 0 0 .5.5h1a.5.5 0 0 0 .5-.5v-1a.5.5 0 0 0-.5-.5h-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.5 15a.5.5 0 0 1 .5-.5h1a.5.5 0 0 1 .5.5v1a.5.5 0 0 1-.5.5h-1a.5.5 0 0 1-.5-.5v-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13 12.5a.5.5 0 0 0-.5.5v1a.5.5 0 0 0 .5.5h1a.5.5 0 0 0 .5-.5v-1a.5.5 0 0 0-.5-.5h-1Z"
      }));
    };
    SvgShopcodesIcon.displayName = "ShopcodesIcon";
    exports.SvgShopcodesIcon = SvgShopcodesIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SidekickIcon.svg.js
var require_SidekickIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SidekickIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSidekickIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "m11.052 14.65-.003.002c-.783.377-1.57.248-2.363-.112-.27-.122-.57-.09-.764.083a.505.505 0 0 0-.174.362.59.59 0 0 0 .157.405 2.875 2.875 0 0 0 2.095.99c.887.037 1.71-.447 2.173-1.147a.582.582 0 0 0 .103-.412.486.486 0 0 0-.217-.331c-.212-.14-.507-.126-.75.022-.087.053-.172.1-.257.139z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M2.42 5.968c-.063.21-.218.875-.218 1.774-.135.781-.083 1.559-.135 2.907l-.063 1.673c-.104 2.73 1.878 5.695 4.583 6.07 2.078.289 4.185.3 6.266.031l.233-.03c.258-.033.41-.053.546-.077 2.503-.455 4.333-3.219 4.368-5.762.002-.137-.004-.292-.014-.55l-.053-1.382c-.03-.774-.052-1.375-.105-1.877l.007-.151c.032-.696.025-.796-.054-1.254a5.99 5.99 0 0 0-.542-1.627c-.294-.56-.77-1.13-1.509-1.13l-.2-.207c-1.603-1.661-2.35-2.032-5.797-2.368-1.955-.062-2.872.245-4.078.835-1.148.562-2.317 1.335-2.734 1.906-.297.407-.403.9-.5 1.22zm10.428.345c.762.073 1.462.139 2.018.054 0 0 .304.84 1.047 1.586.085.085.165.163.24.236.165.16.305.297.42.437.018.13.034.276.047.44a2.443 2.443 0 0 0-.762-.215c-1.139-.081-2.03.36-2.944.813-.876.434-1.772.878-2.926.878-1.153 0-2.049-.444-2.925-.878-.913-.452-1.805-.894-2.945-.813a2.476 2.476 0 0 0-.735.203c.037-.441.088-.744.176-1.011a4.084 4.084 0 0 1 1.263-1.86 2.51 2.51 0 0 1 .24-.084l.442.015c-.054 1.412.288 2.35.493 2.41.168.047.406-.275.72-.701.114-.153.236-.32.37-.487.158-.199.548-.488 1.074-.79.099.716.3 1.157.438 1.196.167.048.405-.274.72-.7.113-.153.236-.32.37-.487.102-.13.237-.25.405-.358h.095c.295 0 .619.003.957.006.58.004 1.157.059 1.702.11zm-9.28 7.962c.55 1.448 1.733 2.694 3.189 2.897 1.97.273 3.966.282 5.938.028l.213-.027c.284-.037.504-.07.504-.07 1.36-.247 2.463-1.454 3-2.83a3.094 3.094 0 0 1-.809.32c-.735.184-1.747-.081-2.871-.67-.39-.204-.689-.443-.968-.668-.51-.409-.956-.767-1.776-.767-.82 0-1.265.358-1.775.767-.28.225-.578.464-.968.669-1.124.588-2.136.853-2.871.67a3.094 3.094 0 0 1-.806-.32zm1.966-1.22a1.334 1.334 0 1 0 0-2.667 1.334 1.334 0 0 0 0 2.668zm7.398-1.333a1.334 1.334 0 1 0 2.668 0 1.334 1.334 0 0 0-2.668 0z"
      }));
    };
    SvgSidekickIcon.displayName = "SidekickIcon";
    exports.SvgSidekickIcon = SvgSidekickIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SkeletonIcon.svg.js
var require_SkeletonIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SkeletonIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSkeletonIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("rect", {
        width: 14,
        height: 14,
        x: 3,
        y: 3,
        fillOpacity: 0.12,
        rx: "0.25rem",
        ry: "0.25rem"
      }));
    };
    SvgSkeletonIcon.displayName = "SkeletonIcon";
    exports.SvgSkeletonIcon = SvgSkeletonIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SlideshowIcon.svg.js
var require_SlideshowIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SlideshowIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSlideshowIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.5 7a1.25 1.25 0 1 1-2.5 0 1.25 1.25 0 0 1 2.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11.031 3.25h-2.062c-.79 0-1.427 0-1.944.041-.532.042-1 .131-1.434.346a3.75 3.75 0 0 0-1.704 1.704c-.215.435-.304.902-.346 1.434-.041.517-.041 1.154-.041 1.944v.062c0 .79 0 1.428.041 1.944.042.532.131 1 .346 1.434a3.75 3.75 0 0 0 1.704 1.704c.435.215.902.304 1.434.346.517.041 1.154.041 1.944.041h2.062c.79 0 1.428 0 1.944-.041.532-.042 1-.131 1.434-.346a3.75 3.75 0 0 0 1.704-1.704c.215-.435.304-.902.346-1.434.041-.516.041-1.154.041-1.944v-.062c0-.79 0-1.427-.041-1.944-.042-.532-.131-1-.346-1.434a3.75 3.75 0 0 0-1.704-1.704c-.435-.215-.902-.304-1.434-.346-.516-.041-1.154-.041-1.944-.041Zm-4.776 1.732c.193-.095.447-.16.889-.196.45-.035 1.027-.036 1.856-.036h2c.829 0 1.406 0 1.856.036.442.035.696.1.89.196.443.22.803.579 1.022 1.023.095.193.16.447.196.889.035.45.036 1.027.036 1.856 0 .348 0 .652-.003.92l-.213-.266a1.75 1.75 0 0 0-2.604-.144l-1.18 1.18-2.695-2.696a1.75 1.75 0 0 0-2.582.117l-.723.868c0-.818 0-1.389.036-1.835.035-.442.1-.696.196-.89a2.25 2.25 0 0 1 1.023-1.022Zm-1.176 5.994a1.8 1.8 0 0 0 .153.52c.22.443.579.803 1.023 1.022.193.095.447.16.889.196.45.035 1.027.036 1.856.036h2c.829 0 1.406 0 1.856-.036.442-.035.696-.1.89-.196a2.25 2.25 0 0 0 .927-.85l-1.06-1.327a.25.25 0 0 0-.373-.02l-1.71 1.71a.75.75 0 0 1-1.06 0l-3.226-3.226a.25.25 0 0 0-.369.016l-1.796 2.155Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6 17a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 16a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14 17a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }));
    };
    SvgSlideshowIcon.displayName = "SlideshowIcon";
    exports.SvgSlideshowIcon = SvgSlideshowIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SmileyHappyIcon.svg.js
var require_SmileyHappyIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SmileyHappyIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSmileyHappyIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.5 7a.75.75 0 0 0-.75.75v1.5a.75.75 0 0 0 1.5 0v-1.5a.75.75 0 0 0-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.75 7.75a.75.75 0 0 1 1.5 0v1.5a.75.75 0 0 1-1.5 0v-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.522 11.983a2.5 2.5 0 0 1-3.937-1.336.75.75 0 1 0-1.449.388 4 4 0 0 0 7.728 0 .75.75 0 0 0-1.45-.388 2.5 2.5 0 0 1-.892 1.336Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-1.5 0a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Z"
      }));
    };
    SvgSmileyHappyIcon.displayName = "SmileyHappyIcon";
    exports.SvgSmileyHappyIcon = SvgSmileyHappyIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SmileyJoyIcon.svg.js
var require_SmileyJoyIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SmileyJoyIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSmileyJoyIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.28 6.97a.75.75 0 0 0-1.06 0l-1 1a.75.75 0 0 0 1.06 1.06l.47-.47.47.47a.75.75 0 0 0 1.06-1.06l-1-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.72 6.97a.75.75 0 0 1 1.06 0l1 1a.75.75 0 0 1-1.06 1.06l-.47-.47-.47.47a.75.75 0 1 1-1.06-1.06l1-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.876 10.99c.136-.536-.324-.99-.876-.99h-6c-.552 0-1.012.454-.876.99a4 4 0 0 0 7.752 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-1.5 0a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Z"
      }));
    };
    SvgSmileyJoyIcon.displayName = "SmileyJoyIcon";
    exports.SvgSmileyJoyIcon = SvgSmileyJoyIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SmileyNeutralIcon.svg.js
var require_SmileyNeutralIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SmileyNeutralIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSmileyNeutralIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.5 11.75a.75.75 0 0 0 0 1.5h5a.75.75 0 0 0 0-1.5h-5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 7.75a.75.75 0 0 1 1.5 0v1.5a.75.75 0 0 1-1.5 0v-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.5 7a.75.75 0 0 0-.75.75v1.5a.75.75 0 0 0 1.5 0v-1.5a.75.75 0 0 0-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-1.5 0a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Z"
      }));
    };
    SvgSmileyNeutralIcon.displayName = "SmileyNeutralIcon";
    exports.SvgSmileyNeutralIcon = SvgSmileyNeutralIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SmileySadIcon.svg.js
var require_SmileySadIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SmileySadIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSmileySadIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15.5 10a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Zm1.5 0a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-7.957 2.69a2.5 2.5 0 0 1 2.725.542.75.75 0 1 0 1.06-1.06 3.998 3.998 0 0 0-5.656 0 .75.75 0 1 0 1.06 1.06 2.5 2.5 0 0 1 .811-.542Zm1.707-4.94a.75.75 0 0 1 1.5 0v1.5a.75.75 0 0 1-1.5 0v-1.5Zm-2.25-.75a.75.75 0 0 0-.75.75v1.5a.75.75 0 0 0 1.5 0v-1.5a.75.75 0 0 0-.75-.75Z"
      }));
    };
    SvgSmileySadIcon.displayName = "SmileySadIcon";
    exports.SvgSmileySadIcon = SvgSmileySadIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SocialAdIcon.svg.js
var require_SocialAdIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SocialAdIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSocialAdIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.5 3a.75.75 0 0 1 .75.75v1.25a.75.75 0 0 1-1.5 0v-1.25a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.03 5.03a.75.75 0 0 0-1.06-1.06l-1 1a.75.75 0 0 0 1.06 1.06l1-1Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.5 7c0-.69.56-1.25 1.25-1.25h3.25a.75.75 0 0 0 0-1.5h-3.25a2.75 2.75 0 0 0-2.75 2.75v7.25a2.75 2.75 0 0 0 2.75 2.75h6.5a2.75 2.75 0 0 0 2.75-2.75v-3.625a.75.75 0 0 0-1.5 0v3.625c0 .69-.56 1.25-1.25 1.25h-6.5c-.69 0-1.25-.56-1.25-1.25v-7.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.25 12.5a.75.75 0 0 0 0 1.5h5.5a.75.75 0 0 0 0-1.5h-5.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.25 7.25a.75.75 0 0 1 .75-.75h6a.75.75 0 0 1 .75.75v3a.75.75 0 0 1-.75.75h-6a.75.75 0 0 1-.75-.75v-3Zm1.5.75v1.5h4.5v-1.5h-4.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.5 8.25a.75.75 0 0 0 0-1.5h-1.25a.75.75 0 0 0 0 1.5h1.25Z"
      }));
    };
    SvgSocialAdIcon.displayName = "SocialAdIcon";
    exports.SvgSocialAdIcon = SvgSocialAdIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SocialPostIcon.svg.js
var require_SocialPostIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SocialPostIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSocialPostIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.25 2.5a.75.75 0 0 1 .75.75v1.25a.75.75 0 0 1-1.5 0v-1.25a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "m16.78 5.53 1-1a.75.75 0 0 0-1.06-1.06l-1 1a.75.75 0 0 0 1.06 1.06Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.5 8.75a3.25 3.25 0 0 1 3.25-3.25h4a.75.75 0 0 0 0-1.5h-4a4.75 4.75 0 0 0-4.75 4.75v.75c0 2.1 1.362 3.88 3.25 4.508v1.992a.75.75 0 0 0 1.196.603l3.178-2.353h1.626a4.75 4.75 0 0 0 4.75-4.75.75.75 0 0 0-1.5 0 3.25 3.25 0 0 1-3.25 3.25h-1.873a.75.75 0 0 0-.447.147l-2.18 1.614v-1.081a.75.75 0 0 0-.61-.737 3.251 3.251 0 0 1-2.64-3.193v-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.75 7.25a.75.75 0 0 0 0 1.5h5.5a.75.75 0 0 0 0-1.5h-5.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6 10.25a.75.75 0 0 1 .75-.75h3.5a.75.75 0 0 1 0 1.5h-3.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M18.25 7.75a.75.75 0 0 0 0-1.5h-1.25a.75.75 0 0 0 0 1.5h1.25Z"
      }));
    };
    SvgSocialPostIcon.displayName = "SocialPostIcon";
    exports.SvgSocialPostIcon = SvgSocialPostIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SortAscendingIcon.svg.js
var require_SortAscendingIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SortAscendingIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSortAscendingIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9.116 4.323a1.25 1.25 0 0 1 1.768 0l2.646 2.647a.75.75 0 0 1-1.06 1.06l-2.47-2.47-2.47 2.47a.75.75 0 1 1-1.06-1.06l2.646-2.647Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillOpacity: 0.33,
        fillRule: "evenodd",
        d: "M9.116 15.677a1.25 1.25 0 0 0 1.768 0l2.646-2.647a.75.75 0 0 0-1.06-1.06l-2.47 2.47-2.47-2.47a.75.75 0 0 0-1.06 1.06l2.646 2.647Z"
      }));
    };
    SvgSortAscendingIcon.displayName = "SortAscendingIcon";
    exports.SvgSortAscendingIcon = SvgSortAscendingIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SortDescendingIcon.svg.js
var require_SortDescendingIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SortDescendingIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSortDescendingIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillOpacity: 0.33,
        fillRule: "evenodd",
        d: "M9.116 4.823a1.25 1.25 0 0 1 1.768 0l2.646 2.647a.75.75 0 0 1-1.06 1.06l-2.47-2.47-2.47 2.47a.75.75 0 1 1-1.06-1.06l2.646-2.647Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9.116 15.177a1.25 1.25 0 0 0 1.768 0l2.646-2.647a.75.75 0 0 0-1.06-1.06l-2.47 2.47-2.47-2.47a.75.75 0 0 0-1.06 1.06l2.646 2.647Z"
      }));
    };
    SvgSortDescendingIcon.displayName = "SortDescendingIcon";
    exports.SvgSortDescendingIcon = SvgSortDescendingIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SortIcon.svg.js
var require_SortIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SortIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSortIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.75 6.06v7.69a.75.75 0 0 1-1.5 0v-7.69l-1.72 1.72a.75.75 0 0 1-1.06-1.06l3-3a.75.75 0 0 1 1.06 0l3 3a.75.75 0 1 1-1.06 1.06l-1.72-1.72Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.75 6.25a.75.75 0 0 0-1.5 0v7.69l-1.72-1.72a.75.75 0 1 0-1.06 1.06l3 3a.75.75 0 0 0 1.06 0l3-3a.75.75 0 1 0-1.06-1.06l-1.72 1.72v-7.69Z"
      }));
    };
    SvgSortIcon.displayName = "SortIcon";
    exports.SvgSortIcon = SvgSortIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SoundIcon.svg.js
var require_SoundIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SoundIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSoundIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.866 4.324c.788-.788 2.134-.23 2.134.884v9.585c0 1.114-1.346 1.672-2.134.884l-2.603-2.603a.25.25 0 0 0-.177-.073h-1.336a1.75 1.75 0 0 1-1.75-1.75v-2.5c0-.967.784-1.75 1.75-1.75h1.336a.25.25 0 0 0 .177-.074l2.603-2.603Zm.634 1.487-2.177 2.177a1.75 1.75 0 0 1-1.237.512h-1.336a.25.25 0 0 0-.25.25v2.5c0 .139.112.25.25.25h1.336c.464 0 .909.185 1.237.513l2.177 2.177v-8.379Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.907 7.345a.75.75 0 0 1 1.047-.166 4.152 4.152 0 0 1 .496 6.294.75.75 0 0 1-1.061-1.06 2.65 2.65 0 0 0-.316-4.02.75.75 0 0 1-.166-1.048Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.62 4.886a.75.75 0 0 0-.881 1.214 5.486 5.486 0 0 1 .654 8.317.75.75 0 1 0 1.06 1.061 6.986 6.986 0 0 0-.833-10.592Z"
      }));
    };
    SvgSoundIcon.displayName = "SoundIcon";
    exports.SvgSoundIcon = SvgSoundIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SportsIcon.svg.js
var require_SportsIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/SportsIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgSportsIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M2.76 9.882a.756.756 0 0 0-.008.179 7.25 7.25 0 1 0 14.495 0 .762.762 0 0 0-.006-.179 7.25 7.25 0 0 0-14.482 0Zm3.518-4.015a5.726 5.726 0 0 1 2.972-1.319v4.702h-1.77a7.471 7.471 0 0 0-1.202-3.383Zm-1.044 1.165a5.717 5.717 0 0 0-.897 2.218h1.634a5.98 5.98 0 0 0-.737-2.218Zm.737 3.718h-1.7c.078.9.363 1.742.808 2.476a5.98 5.98 0 0 0 .892-2.476Zm.092 3.691a5.73 5.73 0 0 0 3.187 1.51v-5.201h-1.77a7.468 7.468 0 0 1-1.417 3.691Zm9.6-5.191a5.718 5.718 0 0 0-.887-2.203 5.98 5.98 0 0 0-.73 2.203h1.617Zm-3.126 0a7.472 7.472 0 0 1 1.197-3.373 5.726 5.726 0 0 0-2.984-1.329v4.702h1.787Zm-1.787 1.5h1.787a7.47 7.47 0 0 0 1.41 3.681 5.731 5.731 0 0 1-3.197 1.52v-5.201Zm4.979 0a5.715 5.715 0 0 1-.8 2.461 5.975 5.975 0 0 1-.882-2.461h1.682Z"
      }));
    };
    SvgSportsIcon.displayName = "SportsIcon";
    exports.SvgSportsIcon = SvgSportsIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StarFilledIcon.svg.js
var require_StarFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StarFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgStarFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.128 4.123c-.453-.95-1.803-.95-2.256 0l-1.39 2.912-3.199.421c-1.042.138-1.46 1.422-.697 2.146l2.34 2.222-.587 3.172c-.192 1.034.901 1.828 1.825 1.327l2.836-1.54 2.836 1.54c.924.501 2.017-.293 1.825-1.327l-.587-3.172 2.34-2.222c.762-.724.345-2.008-.697-2.146l-3.2-.421-1.389-2.912Z"
      }));
    };
    SvgStarFilledIcon.displayName = "StarFilledIcon";
    exports.SvgStarFilledIcon = SvgStarFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StarIcon.svg.js
var require_StarIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StarIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgStarIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.872 4.123c.453-.95 1.803-.95 2.256 0l1.39 2.912 3.199.421c1.042.138 1.46 1.422.697 2.146l-2.34 2.222.587 3.172c.192 1.034-.901 1.828-1.825 1.327l-2.836-1.54-2.836 1.54c-.924.501-2.017-.293-1.825-1.327l.587-3.172-2.34-2.222c-.762-.724-.345-2.008.697-2.146l3.2-.421 1.389-2.912Zm1.128 1.119-1.222 2.561a1.25 1.25 0 0 1-.965.701l-2.814.371 2.058 1.954c.307.292.446.718.369 1.134l-.517 2.791 2.495-1.354a1.25 1.25 0 0 1 1.192 0l2.495 1.354-.517-2.79a1.25 1.25 0 0 1 .369-1.135l2.058-1.954-2.814-.37a1.25 1.25 0 0 1-.965-.702l-1.222-2.561Z"
      }));
    };
    SvgStarIcon.displayName = "StarIcon";
    exports.SvgStarIcon = SvgStarIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StatusActiveIcon.svg.js
var require_StatusActiveIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StatusActiveIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgStatusActiveIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.63 8.81a5.5 5.5 0 0 1 6.56-4.18.75.75 0 0 0 .325-1.464 7 7 0 1 0 5.32 8.35.75.75 0 0 0-1.465-.325 5.5 5.5 0 1 1-10.74-2.38Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.03 6.78a.75.75 0 0 0-1.06-1.06l-4.97 4.97-2.22-2.22a.75.75 0 0 0-1.06 1.06l2.75 2.75a.75.75 0 0 0 1.06 0l5.5-5.5Z"
      }));
    };
    SvgStatusActiveIcon.displayName = "StatusActiveIcon";
    exports.SvgStatusActiveIcon = SvgStatusActiveIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StatusIcon.svg.js
var require_StatusIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StatusIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgStatusIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.25 4.55a5.501 5.501 0 1 0 6.25 5.45.75.75 0 0 1 1.5 0 7 7 0 1 1-7-7 .75.75 0 0 1 .75.75v4.95a1.5 1.5 0 1 1-1.5 0v-1.346a2.751 2.751 0 1 0 3.5 2.646.75.75 0 0 1 1.5 0 4.25 4.25 0 1 1-5-4.184v-1.265Z"
      }));
    };
    SvgStatusIcon.displayName = "StatusIcon";
    exports.SvgStatusIcon = SvgStatusIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StopCircleIcon.svg.js
var require_StopCircleIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StopCircleIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgStopCircleIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.25 7.25a1 1 0 0 0-1 1v3.5a1 1 0 0 0 1 1h3.5a1 1 0 0 0 1-1v-3.5a1 1 0 0 0-1-1h-3.5Zm.5 4v-2.5h2.5v2.5h-2.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-1.5 0a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Z"
      }));
    };
    SvgStopCircleIcon.displayName = "StopCircleIcon";
    exports.SvgStopCircleIcon = SvgStopCircleIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StoreFilledIcon.svg.js
var require_StoreFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StoreFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgStoreFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.278 3a2.75 2.75 0 0 1 2.162 1.051l2.16 2.75.01.013c.736 1.03.238 2.396-.831 2.811h-1.17c-.475 0-.915-.244-1.166-.646l-.663-1.06a.624.624 0 0 0-1.137.184l-.075.298a1.616 1.616 0 0 1-3.136 0l-.075-.298a.628.628 0 0 0-.637-.477.624.624 0 0 0-.5.293l-.662 1.06a1.375 1.375 0 0 1-1.166.646h-1.17c-1.07-.415-1.568-1.781-.832-2.81l.01-.015 2.16-2.749a2.75 2.75 0 0 1 2.162-1.051h4.556Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4.5 10.875v4.375c0 .966.784 1.75 1.75 1.75h7.5a1.75 1.75 0 0 0 1.75-1.75v-4.375h-.892a2.625 2.625 0 0 1-2.226-1.234l-.012-.02a2.866 2.866 0 0 1-4.74 0l-.012.02a2.625 2.625 0 0 1-2.226 1.234h-.892Zm8.5 2.475a1 1 0 0 0-1-1h-1a1 1 0 0 0-1 1v2.4c0 .138.112.25.25.25h2.5a.25.25 0 0 0 .25-.25v-2.4Z"
      }));
    };
    SvgStoreFilledIcon.displayName = "StoreFilledIcon";
    exports.SvgStoreFilledIcon = SvgStoreFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StoreIcon.svg.js
var require_StoreIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StoreIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgStoreIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13.257 3h-6.514a1.25 1.25 0 0 0-.983.478l-2.386 3.037a1.75 1.75 0 0 0-.374 1.08v.655a2.75 2.75 0 0 0 1.5 2.45v4.55c0 .966.784 1.75 1.75 1.75h7.5a1.75 1.75 0 0 0 1.75-1.75v-4.55a2.75 2.75 0 0 0 1.5-2.45v-.481c0-.504-.17-.994-.48-1.39l-2.28-2.901a1.25 1.25 0 0 0-.983-.478Zm-.257 12.5h.75a.25.25 0 0 0 .25-.25v-4.25a2.742 2.742 0 0 1-2-.863 2.742 2.742 0 0 1-2 .863 2.742 2.742 0 0 1-2-.863 2.742 2.742 0 0 1-2 .863v4.25c0 .138.112.25.25.25h3.75v-2.5a1 1 0 0 1 1-1h1a1 1 0 0 1 1 1v2.5Zm-7-6h-.25c-.69 0-1.25-.56-1.25-1.25v-.654a.25.25 0 0 1 .053-.155l2.312-2.941h6.27l2.205 2.805a.75.75 0 0 1 .16.464v.481c0 .69-.56 1.25-1.25 1.25h-.25c-.69 0-1.25-.56-1.25-1.25v-.5a.75.75 0 0 0-1.5 0v.5a1.25 1.25 0 1 1-2.5 0v-.5a.75.75 0 0 0-1.5 0v.5c0 .69-.56 1.25-1.25 1.25Z"
      }));
    };
    SvgStoreIcon.displayName = "StoreIcon";
    exports.SvgStoreIcon = SvgStoreIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StoreImportIcon.svg.js
var require_StoreImportIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StoreImportIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgStoreImportIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 2.75a.75.75 0 0 0-1.5 0v2.69l-.47-.47a.75.75 0 0 0-1.06 1.06l1.75 1.75a.75.75 0 0 0 1.06 0l1.75-1.75a.75.75 0 0 0-1.06-1.06l-.47.47v-2.69Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15.5 10.776v4.474a1.75 1.75 0 0 1-1.75 1.75h-7.5a1.75 1.75 0 0 1-1.75-1.75v-4.474c-1.317-.583-2.003-2.198-1.295-3.612l.079-.159a1.75 1.75 0 0 1 .189-.298l2.378-3.027c.338-.43.853-.68 1.399-.68a.75.75 0 1 1 0 1.5.279.279 0 0 0-.22.107l-2.378 3.027a.25.25 0 0 0-.027.042l-.079.159a1.15 1.15 0 0 0 2.059 1.029l.474-.95a.747.747 0 0 1 1.006-.335.748.748 0 0 1 .394.496l.074.295a1.491 1.491 0 0 0 2.894 0l.074-.295a.748.748 0 0 1 .981-.531.744.744 0 0 1 .419.37l.475.95a1.15 1.15 0 1 0 2.058-1.03l-.08-.158a.255.255 0 0 0-.026-.042l-2.379-3.027a.279.279 0 0 0-.219-.107.75.75 0 0 1 0-1.5c.546 0 1.061.25 1.399.68l2.378 3.027c.073.093.136.193.19.298l.079.159c.707 1.414.02 3.03-1.296 3.612Zm-1.5.19v4.284a.25.25 0 0 1-.25.25h-.75v-2.5a1 1 0 0 0-1-1h-1a1 1 0 0 0-1 1v2.5h-3.75a.25.25 0 0 1-.25-.25v-4.284a2.651 2.651 0 0 0 1.705-1.038 2.99 2.99 0 0 0 4.59 0c.41.554 1.023.927 1.705 1.038Z"
      }));
    };
    SvgStoreImportIcon.displayName = "StoreImportIcon";
    exports.SvgStoreImportIcon = SvgStoreImportIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StoreManagedIcon.svg.js
var require_StoreManagedIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StoreManagedIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgStoreManagedIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12.278 3a2.75 2.75 0 0 1 2.162 1.051l2.087 2.656c.073.093.136.193.19.298l.079.159c.707 1.414.02 3.03-1.296 3.612v1.599a.75.75 0 0 1-1.5 0v-1.41a2.651 2.651 0 0 1-1.705-1.037 2.99 2.99 0 0 1-4.59 0 2.651 2.651 0 0 1-1.705 1.038v4.284c0 .138.112.25.25.25h3.5a.75.75 0 0 1 0 1.5h-3.5a1.75 1.75 0 0 1-1.75-1.75v-4.474c-1.317-.583-2.003-2.198-1.295-3.612l.079-.159a1.75 1.75 0 0 1 .189-.298l2.087-2.656a2.75 2.75 0 0 1 2.162-1.051h4.556Zm-3.926 4.802a.747.747 0 0 0-.855-.258.747.747 0 0 0-.418.37l-.474.95a1.15 1.15 0 1 1-2.059-1.03l.08-.158a.25.25 0 0 1 .026-.042l2.087-2.656c.237-.302.6-.478.983-.478h4.556c.383 0 .746.176.983.478l2.087 2.656c.01.013.019.027.027.042l.079.159a1.15 1.15 0 0 1-2.059 1.029l-.474-.95a.746.746 0 0 0-1.006-.335.747.747 0 0 0-.394.496l-.074.295a1.491 1.491 0 0 1-2.894 0l-.074-.295a.75.75 0 0 0-.127-.273Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M17.78 14.28a.75.75 0 1 0-1.06-1.06l-2.97 2.97-1.22-1.22a.75.75 0 1 0-1.06 1.06l1.75 1.75a.75.75 0 0 0 1.06 0l3.5-3.5Z"
      }));
    };
    SvgStoreManagedIcon.displayName = "StoreManagedIcon";
    exports.SvgStoreManagedIcon = SvgStoreManagedIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StoreOnlineIcon.svg.js
var require_StoreOnlineIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/StoreOnlineIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgStoreOnlineIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12.278 3a2.75 2.75 0 0 1 2.162 1.051l2.087 2.656c.073.093.136.193.19.298l.079.159c.662 1.324.103 2.824-1.052 3.488a.75.75 0 0 1 .006.098v.75a2.75 2.75 0 0 1-2.75 2.75h-.5v1.25h.75a.75.75 0 0 1 0 1.5h-6.5a.75.75 0 0 1 0-1.5h.75v-1.25h-.5a2.75 2.75 0 0 1-2.75-2.75v-.75c0-.033.002-.066.006-.098-1.155-.664-1.714-2.164-1.051-3.488l.079-.159a1.75 1.75 0 0 1 .189-.298l2.087-2.656a2.75 2.75 0 0 1 2.162-1.051h4.556Zm-6.528 7.994v.506c0 .69.56 1.25 1.25 1.25h6c.69 0 1.25-.56 1.25-1.25v-.506a2.651 2.651 0 0 1-1.955-1.066 2.99 2.99 0 0 1-4.59 0 2.651 2.651 0 0 1-1.955 1.066Zm2.602-3.192a.747.747 0 0 0-.855-.258.747.747 0 0 0-.418.37l-.474.95a1.15 1.15 0 1 1-2.059-1.03l.08-.158a.25.25 0 0 1 .026-.042l2.087-2.656c.237-.302.6-.478.983-.478h4.556c.383 0 .746.176.983.478l2.087 2.656c.01.013.019.027.027.042l.079.159a1.15 1.15 0 0 1-2.059 1.029l-.474-.95a.746.746 0 0 0-1.006-.335.747.747 0 0 0-.394.496l-.074.295a1.491 1.491 0 0 1-2.894 0l-.074-.295a.75.75 0 0 0-.127-.273Zm.648 6.448v1.25h2v-1.25h-2Z"
      }));
    };
    SvgStoreOnlineIcon.displayName = "StoreOnlineIcon";
    exports.SvgStoreOnlineIcon = SvgStoreOnlineIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TabletIcon.svg.js
var require_TabletIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TabletIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTabletIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.5 13a.75.75 0 0 0 0 1.5h3a.75.75 0 0 0 0-1.5h-3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.75 3a2.75 2.75 0 0 0-2.75 2.75v8.5a2.75 2.75 0 0 0 2.75 2.75h6.5a2.75 2.75 0 0 0 2.75-2.75v-8.5a2.75 2.75 0 0 0-2.75-2.75h-6.5Zm-1.25 2.75c0-.69.56-1.25 1.25-1.25h6.5c.69 0 1.25.56 1.25 1.25v8.5c0 .69-.56 1.25-1.25 1.25h-6.5c-.69 0-1.25-.56-1.25-1.25v-8.5Z"
      }));
    };
    SvgTabletIcon.displayName = "TabletIcon";
    exports.SvgTabletIcon = SvgTabletIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TargetFilledIcon.svg.js
var require_TargetFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TargetFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTargetFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M5 10a5 5 0 0 1 10 0 1 1 0 1 0 2 0 7 7 0 1 0-7 7 1 1 0 1 0 0-2 5 5 0 0 1-5-5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.29 9.84a1 1 0 0 0 1.98-.278 3.25 3.25 0 1 0-3.782 3.653 1 1 0 1 0 .347-1.97 1.25 1.25 0 1 1 1.455-1.405Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.611 10.973a.5.5 0 0 0-.638.638l2.121 6.01a.5.5 0 0 0 .871.135l1.172-1.558 1.038 1.037a.5.5 0 0 0 .707 0l.353-.353a.5.5 0 0 0 0-.707l-1.037-1.038 1.558-1.172a.5.5 0 0 0-.135-.87l-6.01-2.122Z"
      }));
    };
    SvgTargetFilledIcon.displayName = "TargetFilledIcon";
    exports.SvgTargetFilledIcon = SvgTargetFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TargetIcon.svg.js
var require_TargetIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TargetIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTargetIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.75 10a5.25 5.25 0 0 1 10.5 0 .75.75 0 0 0 1.5 0 6.75 6.75 0 1 0-6.75 6.75.75.75 0 0 0 0-1.5 5.25 5.25 0 0 1-5.25-5.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.537 9.805a.75.75 0 0 0 1.486-.208 3 3 0 1 0-3.492 3.372.75.75 0 0 0 .26-1.478 1.5 1.5 0 1 1 1.746-1.686Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.611 10.973a.5.5 0 0 0-.638.638l2.121 6.01a.5.5 0 0 0 .871.135l1.172-1.558 1.038 1.037a.5.5 0 0 0 .707 0l.353-.353a.5.5 0 0 0 0-.707l-1.037-1.038 1.558-1.172a.5.5 0 0 0-.135-.87l-6.01-2.122Z"
      }));
    };
    SvgTargetIcon.displayName = "TargetIcon";
    exports.SvgTargetIcon = SvgTargetIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TaxFilledIcon.svg.js
var require_TaxFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TaxFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTaxFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.133 3.517c-.131-.547.332-1.017.895-1.017h3.944c.563 0 1.026.47.895 1.017-.225.939-.716 1.72-1.355 2.203a5.307 5.307 0 0 1 3.49 3.315l1.108 3.13c.922 2.603-1.008 5.335-3.77 5.335h-4.68c-2.762 0-4.692-2.732-3.77-5.335l1.108-3.13a5.307 5.307 0 0 1 3.49-3.315c-.639-.484-1.13-1.264-1.355-2.203Zm5.559 5.791a.625.625 0 0 1 0 .884l-4.5 4.5a.625.625 0 1 1-.884-.884l4.5-4.5a.625.625 0 0 1 .884 0Zm-4.692 1.692a1 1 0 1 0 0-2 1 1 0 0 0 0 2Zm5 3a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }));
    };
    SvgTaxFilledIcon.displayName = "TaxFilledIcon";
    exports.SvgTaxFilledIcon = SvgTaxFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TaxIcon.svg.js
var require_TaxIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TaxIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTaxIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.25 10a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.75 14a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12.692 9.308a.625.625 0 0 1 0 .884l-4.5 4.5a.625.625 0 1 1-.884-.884l4.5-4.5a.625.625 0 0 1 .884 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.025 2.5c-.562 0-1.024.467-.914 1.018.19.959.613 1.744 1.172 2.267a5.307 5.307 0 0 0-3.285 3.25l-1.108 3.13c-.922 2.603 1.008 5.335 3.77 5.335h4.68c2.761 0 4.692-2.732 3.77-5.335l-1.108-3.13a5.306 5.306 0 0 0-3.285-3.25c.559-.523.981-1.308 1.172-2.267.11-.551-.352-1.018-.914-1.018h-3.95Zm1.975 2.5c-.295 0-.826-.231-1.176-1h2.352c-.35.769-.88 1-1.176 1Zm3.588 4.536 1.108 3.13a2.5 2.5 0 0 1-2.356 3.334h-4.68a2.5 2.5 0 0 1-2.356-3.335l1.108-3.13a3.806 3.806 0 0 1 7.176 0Z"
      }));
    };
    SvgTaxIcon.displayName = "TaxIcon";
    exports.SvgTaxIcon = SvgTaxIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TeamIcon.svg.js
var require_TeamIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TeamIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTeamIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6 4a2.25 2.25 0 1 0 0 4.5 2.25 2.25 0 0 0 0-4.5Zm-.75 2.25a.75.75 0 1 1 1.5 0 .75.75 0 0 1-1.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 7a2.25 2.25 0 1 0 0 4.5 2.25 2.25 0 0 0 0-4.5Zm-.75 2.25a.75.75 0 1 1 1.5 0 .75.75 0 0 1-1.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M11.75 6.25a2.25 2.25 0 1 1 4.5 0 2.25 2.25 0 0 1-4.5 0Zm2.25-.75a.75.75 0 1 0 0 1.5.75.75 0 0 0 0-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14 9a.75.75 0 0 0 0 1.5h.75c.69 0 1.25.56 1.25 1.25v1.5a.75.75 0 0 0 1.5 0v-1.5a2.75 2.75 0 0 0-2.75-2.75h-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.75 9.75a.75.75 0 0 0-.75-.75h-.75a2.75 2.75 0 0 0-2.75 2.75v1.5a.75.75 0 0 0 1.5 0v-1.5c0-.69.56-1.25 1.25-1.25h.75a.75.75 0 0 0 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 12a2.75 2.75 0 0 1 2.75 2.75v1a.75.75 0 0 1-1.5 0v-1c0-.69-.56-1.25-1.25-1.25h-1.5c-.69 0-1.25.56-1.25 1.25v1a.75.75 0 0 1-1.5 0v-1a2.75 2.75 0 0 1 2.75-2.75h1.5Z"
      }));
    };
    SvgTeamIcon.displayName = "TeamIcon";
    exports.SvgTeamIcon = SvgTeamIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextAlignCenterIcon.svg.js
var require_TextAlignCenterIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextAlignCenterIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextAlignCenterIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3 4.75a.75.75 0 0 1 .75-.75h12.5a.75.75 0 0 1 0 1.5h-12.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.25 8.25a.75.75 0 0 1 .75-.75h8a.75.75 0 0 1 0 1.5h-8a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3 11.75a.75.75 0 0 1 .75-.75h12.5a.75.75 0 0 1 0 1.5h-12.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.25 15.25a.75.75 0 0 1 .75-.75h8a.75.75 0 0 1 0 1.5h-8a.75.75 0 0 1-.75-.75Z"
      }));
    };
    SvgTextAlignCenterIcon.displayName = "TextAlignCenterIcon";
    exports.SvgTextAlignCenterIcon = SvgTextAlignCenterIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextAlignLeftIcon.svg.js
var require_TextAlignLeftIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextAlignLeftIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextAlignLeftIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.75 4a.75.75 0 0 0 0 1.5h12.5a.75.75 0 0 0 0-1.5h-12.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4 7.5a.75.75 0 0 0 0 1.5h8a.75.75 0 0 0 0-1.5h-8Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3 11.75a.75.75 0 0 1 .75-.75h12.5a.75.75 0 0 1 0 1.5h-12.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4 14.5a.75.75 0 0 0 0 1.5h8a.75.75 0 0 0 0-1.5h-8Z"
      }));
    };
    SvgTextAlignLeftIcon.displayName = "TextAlignLeftIcon";
    exports.SvgTextAlignLeftIcon = SvgTextAlignLeftIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextAlignRightIcon.svg.js
var require_TextAlignRightIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextAlignRightIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextAlignRightIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.75 4a.75.75 0 0 0 0 1.5h12.5a.75.75 0 0 0 0-1.5h-12.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.25 7.5a.75.75 0 0 0 0 1.5h8a.75.75 0 0 0 0-1.5h-8Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3 11.75a.75.75 0 0 1 .75-.75h12.5a.75.75 0 0 1 0 1.5h-12.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.25 14.5a.75.75 0 0 0 0 1.5h8a.75.75 0 0 0 0-1.5h-8Z"
      }));
    };
    SvgTextAlignRightIcon.displayName = "TextAlignRightIcon";
    exports.SvgTextAlignRightIcon = SvgTextAlignRightIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextBlockIcon.svg.js
var require_TextBlockIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextBlockIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextBlockIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.25 6.5a.75.75 0 0 0 0 1.5h5.5a.75.75 0 0 0 0-1.5h-5.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.5 10a.75.75 0 0 1 .75-.75h5.5a.75.75 0 0 1 0 1.5h-5.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.25 12a.75.75 0 0 0 0 1.5h3.5a.75.75 0 0 0 0-1.5h-3.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.25 3.5a3.75 3.75 0 0 0-3.75 3.75v5.5a3.75 3.75 0 0 0 3.75 3.75h5.5a3.75 3.75 0 0 0 3.75-3.75v-5.5a3.75 3.75 0 0 0-3.75-3.75h-5.5Zm-2.25 3.75a2.25 2.25 0 0 1 2.25-2.25h5.5a2.25 2.25 0 0 1 2.25 2.25v5.5a2.25 2.25 0 0 1-2.25 2.25h-5.5a2.25 2.25 0 0 1-2.25-2.25v-5.5Z"
      }));
    };
    SvgTextBlockIcon.displayName = "TextBlockIcon";
    exports.SvgTextBlockIcon = SvgTextBlockIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextBoldIcon.svg.js
var require_TextBoldIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextBoldIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextBoldIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7 3c-.83 0-1.5.67-1.5 1.5v10.46c0 .85.69 1.54 1.54 1.54h4.46a4 4 0 0 0 2.32-7.26 4 4 0 0 0-3.32-6.24h-3.5Zm3.5 5.5a1.5 1.5 0 0 0 0-3h-2.5v3h2.5Zm-2.5 2.5v3h3.5a1.5 1.5 0 0 0 0-3h-3.5Z"
      }));
    };
    SvgTextBoldIcon.displayName = "TextBoldIcon";
    exports.SvgTextBoldIcon = SvgTextBoldIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextColorIcon.svg.js
var require_TextColorIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextColorIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextColorIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 3a.75.75 0 0 1 .686.447l4.2 9.5a.75.75 0 1 1-1.372.606l-1.35-3.053h-4.328l-1.35 3.053a.75.75 0 0 1-1.372-.606l4.2-9.5a.75.75 0 0 1 .686-.447Zm-1.5 6h3l-1.5-3.395-1.5 3.395Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.075 16.25a.75.75 0 0 1 .75-.75h12.35a.75.75 0 0 1 0 1.5h-12.35a.75.75 0 0 1-.75-.75Z"
      }));
    };
    SvgTextColorIcon.displayName = "TextColorIcon";
    exports.SvgTextColorIcon = SvgTextColorIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextFontIcon.svg.js
var require_TextFontIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextFontIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextFontIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "m7.077 12.5-.978 2.5h.401a.75.75 0 0 1 0 1.5h-2.5a.75.75 0 0 1 0-1.5h.488l4.314-11.023a.75.75 0 0 1 .814-.468 1 1 0 0 1 1.06.613l4.45 10.878h.874a.75.75 0 0 1 0 1.5h-3.5a.75.75 0 0 1 0-1.5h.465l-1.023-2.5h-4.865Zm.587-1.5 1.792-4.578 1.873 4.578h-3.665Z"
      }));
    };
    SvgTextFontIcon.displayName = "TextFontIcon";
    exports.SvgTextFontIcon = SvgTextFontIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextGrammarIcon.svg.js
var require_TextGrammarIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextGrammarIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextGrammarIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.695 3.717a.75.75 0 0 0-1.39 0l-2.75 6.75a.75.75 0 0 0 1.39.566l.624-1.533h2.681c.06 0 .117-.007.173-.02l.632 1.553a.75.75 0 1 0 1.39-.566l-2.75-6.75Zm-.695 2.27.82 2.013h-1.64l.82-2.012Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 13.25a.75.75 0 0 1 .75-.75h10a.75.75 0 0 1 0 1.5h-10a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 15.75a.75.75 0 0 1 .75-.75h5a.75.75 0 0 1 0 1.5h-5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13.5 5.5c.574 0 1.11.161 1.566.44a.75.75 0 0 1 1.434.31v4.5a.75.75 0 0 1-1.434.31 3 3 0 1 1-1.566-5.56Zm1.5 3a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M17.78 14.28a.75.75 0 1 0-1.06-1.06l-2.97 2.97-1.22-1.22a.75.75 0 1 0-1.06 1.06l1.75 1.75a.75.75 0 0 0 1.06 0l3.5-3.5Z"
      }));
    };
    SvgTextGrammarIcon.displayName = "TextGrammarIcon";
    exports.SvgTextGrammarIcon = SvgTextGrammarIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextIcon.svg.js
var require_TextIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7 3.25a.75.75 0 0 1 .695.467l2.75 6.75a.75.75 0 0 1-1.39.566l-.632-1.553a.752.752 0 0 1-.173.02h-2.68l-.625 1.533a.75.75 0 1 1-1.39-.566l2.75-6.75a.75.75 0 0 1 .695-.467Zm.82 4.75-.82-2.012-.82 2.012h1.64Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.25 12.5a.75.75 0 0 0 0 1.5h11.5a.75.75 0 0 0 0-1.5h-11.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.25 15a.75.75 0 0 0 0 1.5h7a.75.75 0 0 0 0-1.5h-7Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M15.066 5.94a3 3 0 1 0 0 5.118.75.75 0 0 0 1.434-.308v-4.5a.75.75 0 0 0-1.434-.31Zm-1.566 4.06a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3Z"
      }));
    };
    SvgTextIcon.displayName = "TextIcon";
    exports.SvgTextIcon = SvgTextIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextInColumnsIcon.svg.js
var require_TextInColumnsIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextInColumnsIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextInColumnsIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3 5.75c0-.966.784-1.75 1.75-1.75h3.25c.966 0 1.75.784 1.75 1.75v3a1.75 1.75 0 0 1-1.75 1.75h-3.25a1.75 1.75 0 0 1-1.75-1.75v-3Zm1.75-.25a.25.25 0 0 0-.25.25v3c0 .138.112.25.25.25h3.25a.25.25 0 0 0 .25-.25v-3a.25.25 0 0 0-.25-.25h-3.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3 12.5a.75.75 0 0 1 .75-.75h5.25a.75.75 0 0 1 0 1.5h-5.25a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.75 14.5a.75.75 0 0 0 0 1.5h2.625a.75.75 0 0 0 0-1.5h-2.625Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 14.5a.75.75 0 0 0 0 1.5h2.625a.75.75 0 0 0 0-1.5h-2.625Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 11.75a.75.75 0 0 0 0 1.5h5.25a.75.75 0 0 0 0-1.5h-5.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12 4a1.75 1.75 0 0 0-1.75 1.75v3c0 .966.784 1.75 1.75 1.75h3.25a1.75 1.75 0 0 0 1.75-1.75v-3a1.75 1.75 0 0 0-1.75-1.75h-3.25Zm-.25 1.75a.25.25 0 0 1 .25-.25h3.25a.25.25 0 0 1 .25.25v3a.25.25 0 0 1-.25.25h-3.25a.25.25 0 0 1-.25-.25v-3Z"
      }));
    };
    SvgTextInColumnsIcon.displayName = "TextInColumnsIcon";
    exports.SvgTextInColumnsIcon = SvgTextInColumnsIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextInRowsFilledIcon.svg.js
var require_TextInRowsFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextInRowsFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextInRowsFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M5 3.25a1.75 1.75 0 0 0-1.75 1.75v2c0 .966.784 1.75 1.75 1.75h2a1.75 1.75 0 0 0 1.75-1.75v-2a1.75 1.75 0 0 0-1.75-1.75h-2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5 11.25a1.75 1.75 0 0 0-1.75 1.75v2c0 .966.784 1.75 1.75 1.75h2a1.75 1.75 0 0 0 1.75-1.75v-2a1.75 1.75 0 0 0-1.75-1.75h-2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 4.75a.75.75 0 0 1 .75-.75h5.5a.75.75 0 0 1 0 1.5h-5.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 6.5a.75.75 0 0 0 0 1.5h4.5a.75.75 0 0 0 0-1.5h-4.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 12.75a.75.75 0 0 1 .75-.75h5.5a.75.75 0 0 1 0 1.5h-5.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 14.5a.75.75 0 0 0 0 1.5h3.5a.75.75 0 0 0 0-1.5h-3.5Z"
      }));
    };
    SvgTextInRowsFilledIcon.displayName = "TextInRowsFilledIcon";
    exports.SvgTextInRowsFilledIcon = SvgTextInRowsFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextInRowsIcon.svg.js
var require_TextInRowsIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextInRowsIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextInRowsIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5 3a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h2a2 2 0 0 0 2-2v-2a2 2 0 0 0-2-2h-2Zm-.5 2a.5.5 0 0 1 .5-.5h2a.5.5 0 0 1 .5.5v2a.5.5 0 0 1-.5.5h-2a.5.5 0 0 1-.5-.5v-2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5 11a2 2 0 0 0-2 2v2a2 2 0 0 0 2 2h2a2 2 0 0 0 2-2v-2a2 2 0 0 0-2-2h-2Zm-.5 2a.5.5 0 0 1 .5-.5h2a.5.5 0 0 1 .5.5v2a.5.5 0 0 1-.5.5h-2a.5.5 0 0 1-.5-.5v-2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 4.75a.75.75 0 0 1 .75-.75h5.5a.75.75 0 0 1 0 1.5h-5.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 6.5a.75.75 0 0 0 0 1.5h4.5a.75.75 0 0 0 0-1.5h-4.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 12.75a.75.75 0 0 1 .75-.75h5.5a.75.75 0 0 1 0 1.5h-5.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 14.5a.75.75 0 0 0 0 1.5h3.5a.75.75 0 0 0 0-1.5h-3.5Z"
      }));
    };
    SvgTextInRowsIcon.displayName = "TextInRowsIcon";
    exports.SvgTextInRowsIcon = SvgTextInRowsIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextIndentIcon.svg.js
var require_TextIndentIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextIndentIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextIndentIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3 4.75a.75.75 0 0 1 .75-.75h12.5a.75.75 0 0 1 0 1.5h-12.5a.75.75 0 0 1-.75-.75Zm7 3.5a.75.75 0 0 1 .75-.75h5.5a.75.75 0 0 1 0 1.5h-5.5a.75.75 0 0 1-.75-.75Zm0 3.5a.75.75 0 0 1 .75-.75h5.5a.75.75 0 0 1 0 1.5h-5.5a.75.75 0 0 1-.75-.75Zm-7 3.5a.75.75 0 0 1 .75-.75h12.5a.75.75 0 0 1 0 1.5h-12.5a.75.75 0 0 1-.75-.75Zm.96-2.35c-.41.262-.96-.02-.96-.493v-4.814c0-.473.55-.755.96-.493l3.765 2.408a.579.579 0 0 1 0 .985l-3.765 2.407Z"
      }));
    };
    SvgTextIndentIcon.displayName = "TextIndentIcon";
    exports.SvgTextIndentIcon = SvgTextIndentIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextItalicIcon.svg.js
var require_TextItalicIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextItalicIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextItalicIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.5 4.25c0-.41.34-.75.75-.75h6a.75.75 0 0 1 0 1.5h-2.34l-2.28 10h2.12a.75.75 0 0 1 0 1.5h-6a.75.75 0 0 1 0-1.5h2.34l2.28-10h-2.12a.75.75 0 0 1-.75-.75Z"
      }));
    };
    SvgTextItalicIcon.displayName = "TextItalicIcon";
    exports.SvgTextItalicIcon = SvgTextItalicIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextQuoteIcon.svg.js
var require_TextQuoteIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextQuoteIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextQuoteIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.75 4a.75.75 0 0 0 0 1.5h4.5a.75.75 0 0 0 0-1.5h-4.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 8.25a.75.75 0 0 1 .75-.75h4.5a.75.75 0 0 1 0 1.5h-4.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.75 11a.75.75 0 0 0 0 1.5h12.5a.75.75 0 0 0 0-1.5h-12.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.75 14.5a.75.75 0 0 0 0 1.5h8.5a.75.75 0 0 0 0-1.5h-8.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3 8.75a1 1 0 0 0 1 1h1a1 1 0 0 0 1-1v-1a1 1 0 0 0-1-1h-.5v-1a.25.25 0 0 1 .25-.25.75.75 0 0 0 0-1.5 1.75 1.75 0 0 0-1.75 1.75v3Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.5 6.75v-1a.25.25 0 0 1 .25-.25.75.75 0 0 0 0-1.5 1.75 1.75 0 0 0-1.75 1.75v3a1 1 0 0 0 1 1h1a1 1 0 0 0 1-1v-1a1 1 0 0 0-1-1h-.5Z"
      }));
    };
    SvgTextQuoteIcon.displayName = "TextQuoteIcon";
    exports.SvgTextQuoteIcon = SvgTextQuoteIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextTitleIcon.svg.js
var require_TextTitleIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextTitleIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextTitleIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4 4.75a.75.75 0 0 1 .75-.75h10.5a.75.75 0 0 1 .75.75v1.5a.75.75 0 0 1-1.5 0v-.75h-3.5v8.75h1.25a.75.75 0 0 1 0 1.5h-4.5a.75.75 0 0 1 0-1.5h1.25v-8.75h-3.5v.75a.75.75 0 0 1-1.5 0v-1.5Z"
      }));
    };
    SvgTextTitleIcon.displayName = "TextTitleIcon";
    exports.SvgTextTitleIcon = SvgTextTitleIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextUnderlineIcon.svg.js
var require_TextUnderlineIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextUnderlineIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextUnderlineIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.25 3.75a.75.75 0 0 0-1.5 0v6a4.25 4.25 0 0 0 8.5 0v-6a.75.75 0 0 0-1.5 0v6a2.75 2.75 0 1 1-5.5 0v-6Zm-2.5 11.75a.75.75 0 0 0 0 1.5h10.5a.75.75 0 0 0 0-1.5h-10.5Z"
      }));
    };
    SvgTextUnderlineIcon.displayName = "TextUnderlineIcon";
    exports.SvgTextUnderlineIcon = SvgTextUnderlineIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextWithImageIcon.svg.js
var require_TextWithImageIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TextWithImageIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTextWithImageIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.5 3.5a2 2 0 0 0-2 2v3a2 2 0 0 0 2 2h3a2 2 0 0 0 2-2v-3a2 2 0 0 0-2-2h-3Zm3 1.5h-3a.5.5 0 0 0-.5.5v3a.5.5 0 0 0 .5.5h3a.5.5 0 0 0 .5-.5v-3a.5.5 0 0 0-.5-.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.5 15.75a.75.75 0 0 1 .75-.75h8.5a.75.75 0 0 1 0 1.5h-8.5a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.25 11.5a.75.75 0 0 0 0 1.5h11.5a.75.75 0 0 0 0-1.5h-11.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11.25 8.75a.75.75 0 0 1 .75-.75h3.75a.75.75 0 0 1 0 1.5h-3.75a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12 4.5a.75.75 0 0 0 0 1.5h3.75a.75.75 0 0 0 0-1.5h-3.75Z"
      }));
    };
    SvgTextWithImageIcon.displayName = "TextWithImageIcon";
    exports.SvgTextWithImageIcon = SvgTextWithImageIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ThemeEditIcon.svg.js
var require_ThemeEditIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ThemeEditIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgThemeEditIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.25 3.5a3.75 3.75 0 0 0-3.75 3.75v5.5a3.75 3.75 0 0 0 3.75 3.75h1a.75.75 0 0 0 0-1.5h-1a2.25 2.25 0 0 1-2.25-2.25v-3.25h5.5v2.75a.75.75 0 0 0 1.5 0v-7.25h.75a2.25 2.25 0 0 1 2.25 2.25v1a.75.75 0 0 0 1.5 0v-1a3.75 3.75 0 0 0-3.75-3.75h-5.5Zm3.25 1.5v3h-5.5v-.75a2.25 2.25 0 0 1 2.25-2.25h3.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M17.03 12.371a.5.5 0 0 0 0-.707l-1.06-1.06a.5.5 0 0 0-.708 0l-.957.957 1.768 1.767.957-.957Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "m15.366 14.035-1.768-1.767-2.45 2.449a2 2 0 0 0-.585 1.407l-.002.698a.25.25 0 0 0 .25.25l.698-.002a2 2 0 0 0 1.408-.586l2.449-2.449Z"
      }));
    };
    SvgThemeEditIcon.displayName = "ThemeEditIcon";
    exports.SvgThemeEditIcon = SvgThemeEditIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ThemeIcon.svg.js
var require_ThemeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ThemeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgThemeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.25 3.5a3.75 3.75 0 0 0-3.75 3.75v5.5a3.75 3.75 0 0 0 3.75 3.75h5.5a3.75 3.75 0 0 0 3.75-3.75v-5.5a3.75 3.75 0 0 0-3.75-3.75h-5.5Zm-2.25 3.75a2.25 2.25 0 0 1 2.25-2.25h3.25v3h-5.5v-.75Zm7-2.25h.75a2.25 2.25 0 0 1 2.25 2.25v3.75h-3v-6Zm0 7.5v2.5h.75a2.25 2.25 0 0 0 2.25-2.25v-.25h-3Zm-1.5-3v5.5h-3.25a2.25 2.25 0 0 1-2.25-2.25v-3.25h5.5Z"
      }));
    };
    SvgThemeIcon.displayName = "ThemeIcon";
    exports.SvgThemeIcon = SvgThemeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ThemeStoreIcon.svg.js
var require_ThemeStoreIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ThemeStoreIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgThemeStoreIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M7.25 3.5a3.75 3.75 0 0 0-3.75 3.75v5.5a3.75 3.75 0 0 0 3.75 3.75h4a.75.75 0 0 0 .75-.75v-10.75h.75a2.25 2.25 0 0 1 2.25 2.25v1a.75.75 0 0 0 1.5 0v-1a3.75 3.75 0 0 0-3.75-3.75h-5.5Zm3.25 6v5.5h-3.25a2.25 2.25 0 0 1-2.25-2.25v-3.25h5.5Zm0-4.5v3h-5.5v-.75a2.25 2.25 0 0 1 2.25-2.25h3.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14 11.107a1.876 1.876 0 0 0 .625 3.643h.75a.375.375 0 0 1 0 .75h-1.875a.75.75 0 0 0 0 1.5h.5v.25a.75.75 0 0 0 1.5 0v-.254a1.875 1.875 0 0 0-.125-3.746h-.75a.375.375 0 0 1 0-.75h1.875a.75.75 0 0 0 0-1.5h-1v-.25a.75.75 0 0 0-1.5 0v.357Z"
      }));
    };
    SvgThemeStoreIcon.displayName = "ThemeStoreIcon";
    exports.SvgThemeStoreIcon = SvgThemeStoreIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ThemeTemplateIcon.svg.js
var require_ThemeTemplateIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ThemeTemplateIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgThemeTemplateIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 7.25a3.75 3.75 0 0 1 3.75-3.75h5.5a3.75 3.75 0 0 1 3.75 3.75v5.5a3.75 3.75 0 0 1-3.75 3.75h-5.5a3.75 3.75 0 0 1-3.75-3.75v-5.5Zm3.75-2.25a2.25 2.25 0 0 0-2.25 2.25v.5h10v-.5a2.25 2.25 0 0 0-2.25-2.25h-5.5Zm3.75 4.25h-6v3.5a2.25 2.25 0 0 0 2.25 2.25h3.75v-5.75Zm1.5 5.75v-5.75h2.5v3.5a2.25 2.25 0 0 1-2.25 2.25h-.25Z"
      }));
    };
    SvgThemeTemplateIcon.displayName = "ThemeTemplateIcon";
    exports.SvgThemeTemplateIcon = SvgThemeTemplateIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ThumbsDownIcon.svg.js
var require_ThumbsDownIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ThumbsDownIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgThumbsDownIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12.16 4.904a10.75 10.75 0 0 0-4.735-.974l-.391.01a3.75 3.75 0 0 0-3.626 3.236l-.337 2.448a2.75 2.75 0 0 0 2.724 3.126h1.594a.25.25 0 0 1 .249.276l-.133 1.26a2.91 2.91 0 0 0 2.894 3.214h.364c.5 0 .928-.358 1.017-.85l.055-.302a4.989 4.989 0 0 1 1.915-3.098h2c.69 0 1.25-.56 1.25-1.25v-5.5c0-.69-.56-1.25-1.25-1.25h-2.345a2.25 2.25 0 0 1-.938-.205l-.307-.14Zm-4.699.525a9.25 9.25 0 0 1 4.074.839l.307.14a3.75 3.75 0 0 0 1.158.32v5.223c-.052.03-.102.062-.15.098a6.49 6.49 0 0 0-2.475 3.95 1.41 1.41 0 0 1-1.378-1.557l.133-1.26a1.75 1.75 0 0 0-1.74-1.932h-1.595a1.25 1.25 0 0 1-1.238-1.421l.337-2.448a2.25 2.25 0 0 1 2.176-1.942l.391-.01Zm7.039 6.32h1v-5h-1v5Z"
      }));
    };
    SvgThumbsDownIcon.displayName = "ThumbsDownIcon";
    exports.SvgThumbsDownIcon = SvgThumbsDownIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ThumbsUpIcon.svg.js
var require_ThumbsUpIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ThumbsUpIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgThumbsUpIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M12.539 14.57a9.25 9.25 0 0 1-4.074-.838l-.307-.141a3.751 3.751 0 0 0-1.158-.32v-5.222a1.5 1.5 0 0 0 .15-.099 6.489 6.489 0 0 0 2.475-3.95 1.41 1.41 0 0 1 1.378 1.557l-.133 1.26a1.75 1.75 0 0 0 1.74 1.933h1.595c.758 0 1.342.67 1.239 1.42l-.338 2.449a2.25 2.25 0 0 1-2.176 1.942l-.391.01Zm-7.039-6.32h-1v5h1v-5Zm2.34 6.845a10.75 10.75 0 0 0 4.735.975l.391-.01a3.75 3.75 0 0 0 3.626-3.236l.337-2.448a2.75 2.75 0 0 0-2.724-3.126h-1.594a.25.25 0 0 1-.249-.276l.133-1.26a2.91 2.91 0 0 0-2.894-3.214h-.364c-.5 0-.928.357-1.017.849l-.055.303a4.989 4.989 0 0 1-1.915 3.098h-2c-.69 0-1.25.56-1.25 1.25v5.5c0 .69.56 1.25 1.25 1.25h2.345c.324 0 .644.07.938.205l.307.14Z"
      }));
    };
    SvgThumbsUpIcon.displayName = "ThumbsUpIcon";
    exports.SvgThumbsUpIcon = SvgThumbsUpIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TipJarIcon.svg.js
var require_TipJarIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TipJarIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTipJarIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.375 7.25a1.875 1.875 0 0 0 0 3.75h1.25a.375.375 0 0 1 0 .75h-2.375a.75.75 0 0 0 0 1.5h.75a.75.75 0 0 0 1.5 0h.125a1.875 1.875 0 0 0 0-3.75h-1.25a.375.375 0 1 1 0-.75h2.375a.75.75 0 0 0 0-1.5h-.75a.75.75 0 0 0-1.5 0h-.125Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M5.75 5.77c0-.187.022-.368.065-.542a1 1 0 0 1 .685-1.728h7a1 1 0 0 1 .685 1.728c.042.174.065.355.065.542a.77.77 0 0 0 .289.6l.055.044a2.42 2.42 0 0 1 .906 1.886v5.45a2.75 2.75 0 0 1-2.75 2.75h-5.5a2.75 2.75 0 0 1-2.75-2.75v-5.45c0-.733.334-1.427.906-1.886l.055-.043a.77.77 0 0 0 .289-.601Zm1.5 0c0-.095.017-.186.049-.27h5.402a.768.768 0 0 1 .049.27c0 .69.313 1.341.852 1.772l.054.044a.915.915 0 0 1 .344.714v5.45c0 .69-.56 1.25-1.25 1.25h-5.5c-.69 0-1.25-.56-1.25-1.25v-5.45c0-.278.126-.54.344-.714l.054-.044a2.27 2.27 0 0 0 .852-1.772Z"
      }));
    };
    SvgTipJarIcon.displayName = "TipJarIcon";
    exports.SvgTipJarIcon = SvgTipJarIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ToggleOffIcon.svg.js
var require_ToggleOffIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ToggleOffIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgToggleOffIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M8 13a3 3 0 1 0 0-6 3 3 0 0 0 0 6Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8 4.5a5.5 5.5 0 1 0 0 11h4a5.5 5.5 0 1 0 0-11h-4Zm-4 5.5a4 4 0 0 1 4-4h4a4 4 0 0 1 0 8h-4a4 4 0 0 1-4-4Z"
      }));
    };
    SvgToggleOffIcon.displayName = "ToggleOffIcon";
    exports.SvgToggleOffIcon = SvgToggleOffIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ToggleOnIcon.svg.js
var require_ToggleOnIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ToggleOnIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgToggleOnIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12 13a3 3 0 1 0 0-6 3 3 0 0 0 0 6Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8 4.5a5.5 5.5 0 1 0 0 11h4a5.5 5.5 0 1 0 0-11h-4Zm-4 5.5a4 4 0 0 1 4-4h4a4 4 0 0 1 0 8h-4a4 4 0 0 1-4-4Z"
      }));
    };
    SvgToggleOnIcon.displayName = "ToggleOnIcon";
    exports.SvgToggleOnIcon = SvgToggleOnIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransactionFeeDollarIcon.svg.js
var require_TransactionFeeDollarIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransactionFeeDollarIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTransactionFeeDollarIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 5.25a2.25 2.25 0 0 1 4.372-.75h3.256a2.251 2.251 0 1 1 0 1.5h-2.878v5.25c0 .69.56 1.25 1.25 1.25h.25a.75.75 0 0 1 0 1.5h-.25a2.75 2.75 0 0 1-2.75-2.75v-3.984a2.25 2.25 0 0 1-3.25-2.016Zm2.25-.75a.75.75 0 1 0 0 1.5.75.75 0 0 0 0-1.5Zm7.5 0a.75.75 0 1 0 0 1.5.75.75 0 0 0 0-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.25 10.107a1.876 1.876 0 0 0 .625 3.643h.75a.375.375 0 0 1 0 .75h-1.875a.75.75 0 0 0 0 1.5h.5v.25a.75.75 0 0 0 1.5 0v-.254a1.875 1.875 0 0 0-.125-3.746h-.75a.375.375 0 0 1 0-.75h1.875a.75.75 0 0 0 0-1.5h-1v-.25a.75.75 0 0 0-1.5 0v.357Z"
      }));
    };
    SvgTransactionFeeDollarIcon.displayName = "TransactionFeeDollarIcon";
    exports.SvgTransactionFeeDollarIcon = SvgTransactionFeeDollarIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransactionFeeEuroIcon.svg.js
var require_TransactionFeeEuroIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransactionFeeEuroIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTransactionFeeEuroIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 5.25a2.25 2.25 0 0 1 4.372-.75h3.256a2.251 2.251 0 1 1 0 1.5h-2.878v5.25c0 .69.56 1.25 1.25 1.25h.25a.75.75 0 0 1 0 1.5h-.25a2.75 2.75 0 0 1-2.75-2.75v-3.984a2.25 2.25 0 0 1-3.25-2.016Zm2.25-.75a.75.75 0 1 0 0 1.5.75.75 0 0 0 0-1.5Zm7.5 0a.75.75 0 1 0 0 1.5.75.75 0 0 0 0-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.053 12.468c.128-.823.46-1.207.708-1.357.309-.185.684-.136.959.138a.75.75 0 1 0 1.06-1.06c-.725-.727-1.85-.928-2.79-.364-.788.472-1.304 1.385-1.449 2.643h-.291a.75.75 0 0 0 0 1.5h.291c.145 1.258.661 2.172 1.448 2.644.941.564 2.066.363 2.791-.363a.75.75 0 0 0-1.06-1.06c-.275.273-.65.322-.96.136-.248-.149-.579-.533-.707-1.357h1.697a.75.75 0 0 0 0-1.5h-1.697Z"
      }));
    };
    SvgTransactionFeeEuroIcon.displayName = "TransactionFeeEuroIcon";
    exports.SvgTransactionFeeEuroIcon = SvgTransactionFeeEuroIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransactionFeePoundIcon.svg.js
var require_TransactionFeePoundIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransactionFeePoundIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTransactionFeePoundIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 5.25a2.25 2.25 0 0 1 4.372-.75h3.256a2.251 2.251 0 1 1 0 1.5h-2.878v5.25c0 .69.56 1.25 1.25 1.25h.25a.75.75 0 0 1 0 1.5h-.25a2.75 2.75 0 0 1-2.75-2.75v-3.984a2.25 2.25 0 0 1-3.25-2.016Zm2.25-.75a.75.75 0 1 0 0 1.5.75.75 0 0 0 0-1.5Zm7.5 0a.75.75 0 1 0 0 1.5.75.75 0 0 0 0-1.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15 8.75a1.75 1.75 0 0 0-1.75 1.75v2h-.5a.75.75 0 0 0 0 1.5h.5v1.5h-.5a.75.75 0 0 0 0 1.5h3.5a.75.75 0 0 0 0-1.5h-1.5v-1.5h.5a.75.75 0 0 0 0-1.5h-.5v-2a.25.25 0 0 1 .25-.25h.5v1a.75.75 0 0 0 1.5 0v-1.25c0-.69-.56-1.25-1.25-1.25h-.75Z"
      }));
    };
    SvgTransactionFeePoundIcon.displayName = "TransactionFeePoundIcon";
    exports.SvgTransactionFeePoundIcon = SvgTransactionFeePoundIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransactionFeeRupeeIcon.svg.js
var require_TransactionFeeRupeeIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransactionFeeRupeeIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTransactionFeeRupeeIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.25 3a2.25 2.25 0 1 0 1 4.266v3.984a2.75 2.75 0 0 0 2.75 2.75h.25a.75.75 0 0 0 0-1.5h-.25c-.69 0-1.25-.56-1.25-1.25v-5.25h2.878a2.251 2.251 0 1 0 0-1.5h-3.256a2.25 2.25 0 0 0-2.122-1.5Zm-.75 2.25a.75.75 0 1 1 1.5 0 .75.75 0 0 1-1.5 0Zm7.5 0a.75.75 0 1 1 1.5 0 .75.75 0 0 1-1.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.143 15.611a.75.75 0 0 1-.786 1.278l-2.814-1.732c-.769-.473-.433-1.657.469-1.657.463 0 .852-.32.96-.75h-1.222a.75.75 0 0 1 0-1.5h1.25v-.75h-1.25a.75.75 0 0 1 0-1.5h3.5a.75.75 0 0 1 0 1.5h-.75v.75h.75a.75.75 0 0 1 0 1.5h-.761a2.487 2.487 0 0 1-1.06 1.807l1.714 1.054Z"
      }));
    };
    SvgTransactionFeeRupeeIcon.displayName = "TransactionFeeRupeeIcon";
    exports.SvgTransactionFeeRupeeIcon = SvgTransactionFeeRupeeIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransactionFeeYenIcon.svg.js
var require_TransactionFeeYenIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransactionFeeYenIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTransactionFeeYenIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.25 3a2.25 2.25 0 1 0 1 4.266v3.984a2.75 2.75 0 0 0 2.75 2.75h.25a.75.75 0 0 0 0-1.5h-.25c-.69 0-1.25-.56-1.25-1.25v-5.25h2.878a2.251 2.251 0 1 0 0-1.5h-3.256a2.25 2.25 0 0 0-2.122-1.5Zm-.75 2.25a.75.75 0 1 1 1.5 0 .75.75 0 0 1-1.5 0Zm7.5 0a.75.75 0 1 1 1.5 0 .75.75 0 0 1-1.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.994 9.186a.75.75 0 0 0-.988 1.128l1.744 1.526v.41h-1a.75.75 0 0 0 0 1.5h1v.5h-1a.75.75 0 0 0 0 1.5h1v.5a.75.75 0 0 0 1.5 0v-.5h1a.75.75 0 0 0 0-1.5h-1v-.5h1a.75.75 0 0 0 0-1.5h-1v-.41l1.744-1.526a.75.75 0 1 0-.988-1.128l-1.506 1.317-1.506-1.317Z"
      }));
    };
    SvgTransactionFeeYenIcon.displayName = "TransactionFeeYenIcon";
    exports.SvgTransactionFeeYenIcon = SvgTransactionFeeYenIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransactionIcon.svg.js
var require_TransactionIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransactionIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTransactionIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.5 4.75a.75.75 0 0 0-1.5 0v10.5a.75.75 0 0 0 1.5 0v-6.75h6.94l-.72.72a.75.75 0 1 0 1.06 1.06l2-2a.75.75 0 0 0 0-1.06l-2-2a.75.75 0 1 0-1.06 1.06l.72.72h-6.94v-2.25Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M17 4.75a.75.75 0 0 0-1.5 0v7.25h-6.94l.72-.72a.75.75 0 1 0-1.06-1.06l-2 2a.75.75 0 0 0 0 1.06l2 2a.75.75 0 0 0 1.06-1.06l-.72-.72h6.94v1.75a.75.75 0 0 0 1.5 0v-10.5Z"
      }));
    };
    SvgTransactionIcon.displayName = "TransactionIcon";
    exports.SvgTransactionIcon = SvgTransactionIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransferIcon.svg.js
var require_TransferIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransferIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTransferIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M3.75 4a.75.75 0 0 1 .75.75v4.5h6.69l-1.72-1.72a.75.75 0 0 1 1.06-1.06l3 3a.75.75 0 0 1 0 1.06l-3 3a.75.75 0 1 1-1.06-1.06l1.72-1.72h-6.69v4.5a.75.75 0 0 1-1.5 0v-10.5a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.25 4a.75.75 0 0 1 .75.75v10.5a.75.75 0 0 1-1.5 0v-10.5a.75.75 0 0 1 .75-.75Z"
      }));
    };
    SvgTransferIcon.displayName = "TransferIcon";
    exports.SvgTransferIcon = SvgTransferIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransferInIcon.svg.js
var require_TransferInIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransferInIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTransferInIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M16.5 4.25a.75.75 0 0 0-1.5 0v11.5a.75.75 0 0 0 1.5 0v-11.5Zm-12.25 6.5a.75.75 0 0 1 0-1.5h6.94l-1.72-1.72a.75.75 0 0 1 1.06-1.06l3 3a.75.75 0 0 1 0 1.06l-3 3a.75.75 0 1 1-1.06-1.06l1.72-1.72h-6.94Z"
      }));
    };
    SvgTransferInIcon.displayName = "TransferInIcon";
    exports.SvgTransferInIcon = SvgTransferInIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransferInternalIcon.svg.js
var require_TransferInternalIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransferInternalIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTransferInternalIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.25 3.5a2.75 2.75 0 0 0-2.75 2.75v7.5a2.75 2.75 0 0 0 2.75 2.75h7.5a2.75 2.75 0 0 0 2.75-2.75v-7.5a2.75 2.75 0 0 0-2.75-2.75h-7.5Zm-1.25 7h6.44l-1.22 1.22a.75.75 0 1 0 1.06 1.06l2.5-2.5a.75.75 0 0 0 0-1.06l-2.5-2.5a.75.75 0 1 0-1.06 1.06l1.22 1.22h-6.44v-2.75c0-.69.56-1.25 1.25-1.25h.5v2a.75.75 0 0 0 1.5 0v-2h5.5c.69 0 1.25.56 1.25 1.25v7.5c0 .69-.56 1.25-1.25 1.25h-5.5v-2a.75.75 0 0 0-1.5 0v2h-.5c-.69 0-1.25-.56-1.25-1.25v-3.25Z"
      }));
    };
    SvgTransferInternalIcon.displayName = "TransferInternalIcon";
    exports.SvgTransferInternalIcon = SvgTransferInternalIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransferOutIcon.svg.js
var require_TransferOutIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/TransferOutIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgTransferOutIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.5 4.25a.75.75 0 0 0-1.5 0v11.5a.75.75 0 0 0 1.5 0v-11.5Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M13 10.75a.75.75 0 0 0 0-1.5h-6.94l1.72-1.72a.75.75 0 0 0-1.06-1.06l-3 3a.75.75 0 0 0 0 1.06l3 3a.75.75 0 0 0 1.06-1.06l-1.72-1.72h6.94Z"
      }));
    };
    SvgTransferOutIcon.displayName = "TransferOutIcon";
    exports.SvgTransferOutIcon = SvgTransferOutIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/UndoIcon.svg.js
var require_UndoIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/UndoIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgUndoIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.47 3.72a.75.75 0 0 1 1.06 1.06l-1.72 1.72h3.94a5 5 0 0 1 0 10h-1.5a.75.75 0 0 1 0-1.5h1.5a3.5 3.5 0 1 0 0-7h-3.94l1.72 1.72a.75.75 0 1 1-1.06 1.06l-3-3a.75.75 0 0 1 0-1.06l3-3Z"
      }));
    };
    SvgUndoIcon.displayName = "UndoIcon";
    exports.SvgUndoIcon = SvgUndoIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/UnknownDeviceIcon.svg.js
var require_UnknownDeviceIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/UnknownDeviceIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgUnknownDeviceIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 7.25c-.69 0-1.25.56-1.25 1.25a.75.75 0 0 1-1.5 0 2.75 2.75 0 1 1 3.758 2.56.61.61 0 0 0-.226.147.154.154 0 0 0-.032.046.75.75 0 0 1-1.5-.003c0-.865.696-1.385 1.208-1.586a1.25 1.25 0 0 0-.458-2.414Zm.75 4.003v.002-.002Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 14.5a1 1 0 1 0 0-2 1 1 0 0 0 0 2Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M4 5.75a2.75 2.75 0 0 1 2.75-2.75h6.5a2.75 2.75 0 0 1 2.75 2.75v8.5a2.75 2.75 0 0 1-2.75 2.75h-6.5a2.75 2.75 0 0 1-2.75-2.75v-8.5Zm2.75-1.25c-.69 0-1.25.56-1.25 1.25v8.5c0 .69.56 1.25 1.25 1.25h6.5c.69 0 1.25-.56 1.25-1.25v-8.5c0-.69-.56-1.25-1.25-1.25h-6.5Z"
      }));
    };
    SvgUnknownDeviceIcon.displayName = "UnknownDeviceIcon";
    exports.SvgUnknownDeviceIcon = SvgUnknownDeviceIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/UploadIcon.svg.js
var require_UploadIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/UploadIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgUploadIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M16.5 6.26a.75.75 0 0 1-1.5 0v-.51a.75.75 0 0 0-.75-.75h-8.5a.75.75 0 0 0-.75.75v.51a.75.75 0 0 1-1.5 0v-.51a2.25 2.25 0 0 1 2.25-2.25h8.5a2.25 2.25 0 0 1 2.25 2.25v.51Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 16.01a.75.75 0 0 1-1.5 0v-6.69l-1.72 1.72a.75.75 0 1 1-1.06-1.06l3-3a.75.75 0 0 1 1.06 0l3 3a.75.75 0 1 1-1.06 1.06l-1.72-1.72v6.69Z"
      }));
    };
    SvgUploadIcon.displayName = "UploadIcon";
    exports.SvgUploadIcon = SvgUploadIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/VariantIcon.svg.js
var require_VariantIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/VariantIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgVariantIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.01 6.01a2.75 2.75 0 0 1 2.74-2.51h5a2.75 2.75 0 0 1 2.75 2.75v5a2.75 2.75 0 0 1-2.51 2.74 2.75 2.75 0 0 1-2.74 2.51h-5a2.739 2.739 0 0 1-1.771-.646 1.001 1.001 0 0 1-.333-.333 2.739 2.739 0 0 1-.646-1.771v-5a2.75 2.75 0 0 1 2.51-2.74Zm1.515-.01h3.725c.675 0 1.293.243 1.771.646a1.003 1.003 0 0 1 .333.333c.403.478.646 1.096.646 1.771v3.725c.57-.116 1-.62 1-1.225v-5c0-.69-.56-1.25-1.25-1.25h-5c-.605 0-1.11.43-1.225 1Zm-1.275 1.5h4.836l-6.086 6.086v-4.836c0-.69.56-1.25 1.25-1.25Zm5 7.5h-4.836l6.086-6.086v4.836c0 .69-.56 1.25-1.25 1.25Z"
      }));
    };
    SvgVariantIcon.displayName = "VariantIcon";
    exports.SvgVariantIcon = SvgVariantIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ViewIcon.svg.js
var require_ViewIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ViewIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgViewIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M13 10a3 3 0 1 1-6 0 3 3 0 0 1 6 0Zm-1.5 0a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 4c-2.476 0-4.348 1.23-5.577 2.532a9.266 9.266 0 0 0-1.4 1.922 5.98 5.98 0 0 0-.37.818c-.082.227-.153.488-.153.728s.071.501.152.728c.088.246.213.524.371.818.317.587.784 1.27 1.4 1.922 1.229 1.302 3.1 2.532 5.577 2.532 2.476 0 4.348-1.23 5.577-2.532a9.265 9.265 0 0 0 1.4-1.922 5.98 5.98 0 0 0 .37-.818c.082-.227.153-.488.153-.728s-.071-.501-.152-.728a5.984 5.984 0 0 0-.371-.818 9.269 9.269 0 0 0-1.4-1.922c-1.229-1.302-3.1-2.532-5.577-2.532Zm-5.999 6.002v-.004c.004-.02.017-.09.064-.223a4.5 4.5 0 0 1 .278-.608 7.768 7.768 0 0 1 1.17-1.605c1.042-1.104 2.545-2.062 4.487-2.062 1.942 0 3.445.958 4.486 2.062a7.77 7.77 0 0 1 1.17 1.605c.13.24.221.447.279.608.047.132.06.203.064.223v.004c-.004.02-.017.09-.064.223a4.503 4.503 0 0 1-.278.608 7.768 7.768 0 0 1-1.17 1.605c-1.042 1.104-2.545 2.062-4.487 2.062-1.942 0-3.445-.958-4.486-2.062a7.766 7.766 0 0 1-1.17-1.605 4.5 4.5 0 0 1-.279-.608c-.047-.132-.06-.203-.064-.223Z"
      }));
    };
    SvgViewIcon.displayName = "ViewIcon";
    exports.SvgViewIcon = SvgViewIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ViewportNarrowIcon.svg.js
var require_ViewportNarrowIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ViewportNarrowIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgViewportNarrowIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M7.75 5c0-.966.784-1.75 1.75-1.75h1c.966 0 1.75.784 1.75 1.75v1.76a.75.75 0 0 1-1.5 0v-1.76a.25.25 0 0 0-.25-.25h-1a.25.25 0 0 0-.25.25v1.76a.75.75 0 0 1-1.5 0v-1.76Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.5 12.49a.75.75 0 0 1 .75.75v1.76c0 .138.112.25.25.25h1a.25.25 0 0 0 .25-.25v-1.76a.75.75 0 0 1 1.5 0v1.76a1.75 1.75 0 0 1-1.75 1.75h-1a1.75 1.75 0 0 1-1.75-1.75v-1.76a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4 10c0 .414.336.75.75.75h2.44l-.72.72a.75.75 0 1 0 1.06 1.06l2-2a.75.75 0 0 0 0-1.06l-2-2a.75.75 0 1 0-1.06 1.06l.72.72h-2.44a.75.75 0 0 0-.75.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M15.25 10.75a.75.75 0 0 0 0-1.5h-2.44l.72-.72a.75.75 0 0 0-1.06-1.06l-2 2a.75.75 0 0 0 0 1.06l2 2a.75.75 0 1 0 1.06-1.06l-.72-.72h2.44Z"
      }));
    };
    SvgViewportNarrowIcon.displayName = "ViewportNarrowIcon";
    exports.SvgViewportNarrowIcon = SvgViewportNarrowIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ViewportShortIcon.svg.js
var require_ViewportShortIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ViewportShortIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgViewportShortIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10 4a.75.75 0 0 0-.75.75v2.44l-.72-.72a.75.75 0 1 0-1.06 1.06l2 2a.75.75 0 0 0 1.06 0l2-2a.75.75 0 0 0-1.06-1.06l-.72.72v-2.44a.75.75 0 0 0-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.75 12.25a1.75 1.75 0 0 1-1.75-1.75v-1c0-.966.784-1.75 1.75-1.75h1.875a.75.75 0 0 1 0 1.5h-1.875a.25.25 0 0 0-.25.25v1c0 .138.112.25.25.25h1.875a.75.75 0 0 1 0 1.5h-1.875Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.625 11.5a.75.75 0 0 1 .75-.75h1.875a.25.25 0 0 0 .25-.25v-1a.25.25 0 0 0-.25-.25h-1.875a.75.75 0 0 1 0-1.5h1.875c.966 0 1.75.784 1.75 1.75v1a1.75 1.75 0 0 1-1.75 1.75h-1.875a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.25 15.25a.75.75 0 0 0 1.5 0v-2.44l.72.72a.75.75 0 0 0 1.06-1.06l-2-2a.75.75 0 0 0-1.06 0l-2 2a.75.75 0 1 0 1.06 1.06l.72-.72v2.44Z"
      }));
    };
    SvgViewportShortIcon.displayName = "ViewportShortIcon";
    exports.SvgViewportShortIcon = SvgViewportShortIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ViewportTallIcon.svg.js
var require_ViewportTallIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ViewportTallIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgViewportTallIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.25 9v-2.44l-.72.72a.75.75 0 1 1-1.06-1.06l2-2a.75.75 0 0 1 1.06 0l2 2a.75.75 0 0 1-1.06 1.06l-.72-.72v2.44a.75.75 0 0 1-1.5 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M5.75 16a2.75 2.75 0 0 1-2.75-2.75v-6.5a2.75 2.75 0 0 1 2.75-2.75h.875a.75.75 0 0 1 0 1.5h-.875c-.69 0-1.25.56-1.25 1.25v6.5c0 .69.56 1.25 1.25 1.25h.875a.75.75 0 0 1 0 1.5h-.875Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.625 15.25a.75.75 0 0 1 .75-.75h.875c.69 0 1.25-.56 1.25-1.25v-6.5c0-.69-.56-1.25-1.25-1.25h-.875a.75.75 0 0 1 0-1.5h.875a2.75 2.75 0 0 1 2.75 2.75v6.5a2.75 2.75 0 0 1-2.75 2.75h-.875a.75.75 0 0 1-.75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.25 13.44v-2.44a.75.75 0 0 1 1.5 0v2.44l.72-.72a.75.75 0 0 1 1.06 1.06l-2 2.001a.75.75 0 0 1-1.06 0l-2-2a.75.75 0 1 1 1.06-1.06l.72.72Z"
      }));
    };
    SvgViewportTallIcon.displayName = "ViewportTallIcon";
    exports.SvgViewportTallIcon = SvgViewportTallIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ViewportWideIcon.svg.js
var require_ViewportWideIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/ViewportWideIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgViewportWideIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M4 5.75a2.75 2.75 0 0 1 2.75-2.75h6.5a2.75 2.75 0 0 1 2.75 2.75v.875a.75.75 0 0 1-1.5 0v-.875c0-.69-.56-1.25-1.25-1.25h-6.5c-.69 0-1.25.56-1.25 1.25v.875a.75.75 0 0 1-1.5 0v-.875Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.75 12.625a.75.75 0 0 1 .75.75v.875c0 .69.56 1.25 1.25 1.25h6.5c.69 0 1.25-.56 1.25-1.25v-.875a.75.75 0 0 1 1.5 0v.875a2.75 2.75 0 0 1-2.75 2.75h-6.5a2.75 2.75 0 0 1-2.75-2.75v-.875a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M9.75 10a.75.75 0 0 1-.75.75h-2.44l.72.72a.75.75 0 1 1-1.06 1.06l-2-2a.75.75 0 0 1 0-1.06l2-2a.75.75 0 1 1 1.06 1.06l-.72.72h2.44a.75.75 0 0 1 .75.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M11 10.75a.75.75 0 0 1 0-1.5h2.44l-.72-.72a.75.75 0 0 1 1.06-1.06l2 2a.75.75 0 0 1 0 1.06l-2 2a.75.75 0 1 1-1.06-1.06l.72-.72h-2.44Z"
      }));
    };
    SvgViewportWideIcon.displayName = "ViewportWideIcon";
    exports.SvgViewportWideIcon = SvgViewportWideIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/WalletFilledIcon.svg.js
var require_WalletFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/WalletFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgWalletFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 5.75v8.5a2.25 2.25 0 0 0 2.25 2.25h8.25a2.25 2.25 0 0 0 2.25-2.25v-.854a1.25 1.25 0 0 0 .75-1.146v-2a1.25 1.25 0 0 0-.75-1.146v-.604a2.25 2.25 0 0 0-2.25-2.25h-.5v-.5a2.25 2.25 0 0 0-2.25-2.25h-5.5a2.25 2.25 0 0 0-2.25 2.25Zm2.25-.75a.75.75 0 0 0-.75.75v.5h7v-.5a.75.75 0 0 0-.75-.75h-5.5Zm9.75 5.5h-3.75v1.5h3.75v-1.5Z"
      }));
    };
    SvgWalletFilledIcon.displayName = "WalletFilledIcon";
    exports.SvgWalletFilledIcon = SvgWalletFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/WalletIcon.svg.js
var require_WalletIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/WalletIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgWalletIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M3.5 5.75v8.5a2.25 2.25 0 0 0 2.25 2.25h8.5a2.25 2.25 0 0 0 2.25-2.25v-1c.304-.228.5-.591.5-1v-2c0-.409-.196-.772-.5-1v-.75a2.25 2.25 0 0 0-2.25-2.25h-.75v-.5a2.25 2.25 0 0 0-2.25-2.25h-5.5a2.25 2.25 0 0 0-2.25 2.25Zm2.25-.75a.75.75 0 0 0-.75.75v.5h7v-.5a.75.75 0 0 0-.75-.75h-5.5Zm9.75 5.5h-3.75v1.5h3.75v-1.5Zm-.5-1.5v-.5a.75.75 0 0 0-.75-.75h-9.25v6.5c0 .414.336.75.75.75h8.5a.75.75 0 0 0 .75-.75v-.75h-3.5c-.69 0-1.25-.56-1.25-1.25v-2c0-.69.56-1.25 1.25-1.25h3.5Z"
      }));
    };
    SvgWalletIcon.displayName = "WalletIcon";
    exports.SvgWalletIcon = SvgWalletIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/WandIcon.svg.js
var require_WandIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/WandIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgWandIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M14.737 3.677a1.75 1.75 0 0 0-2.474 0l-8.586 8.585a1.75 1.75 0 0 0 0 2.475l1.586 1.586a1.75 1.75 0 0 0 2.474 0l6.784-6.784.01-.009.008-.009 1.784-1.784a1.75 1.75 0 0 0 0-2.475l-1.586-1.585Zm-.737 4.262 1.263-1.262a.25.25 0 0 0 0-.354l-1.586-1.586a.25.25 0 0 0-.354 0l-1.262 1.263 1.939 1.94Zm-3-.878-6.263 6.262a.25.25 0 0 0 0 .354l1.586 1.585a.25.25 0 0 0 .354 0l6.262-6.262-1.94-1.94Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M14.25 12a.75.75 0 0 1 .75.75v.75h.75a.75.75 0 0 1 0 1.5h-.75v.75a.75.75 0 0 1-1.5 0v-.75h-.75a.75.75 0 0 1 0-1.5h.75v-.75a.75.75 0 0 1 .75-.75Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.5 4.25a.75.75 0 0 0-1.5 0v.75h-.75a.75.75 0 0 0 0 1.5h.75v.75a.75.75 0 0 0 1.5 0v-.75h.75a.75.75 0 0 0 0-1.5h-.75v-.75Z"
      }));
    };
    SvgWandIcon.displayName = "WandIcon";
    exports.SvgWandIcon = SvgWandIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/WatchIcon.svg.js
var require_WatchIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/WatchIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgWatchIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.75 8.75a.75.75 0 0 0-1.5 0v1.25c0 .199.079.39.22.53l1.25 1.25a.75.75 0 1 0 1.06-1.06l-1.03-1.03v-.94Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M9 3a1.75 1.75 0 0 0-1.75 1.75v.933a3.75 3.75 0 0 0-2 3.317v2a3.75 3.75 0 0 0 2 3.318v.932c0 .966.784 1.75 1.75 1.75h2a1.75 1.75 0 0 0 1.75-1.75v-.932a3.75 3.75 0 0 0 2-3.318v-2a3.75 3.75 0 0 0-2-3.317v-.933a1.75 1.75 0 0 0-1.75-1.75h-2Zm0 2.25c-.084 0-.167.003-.25.008v-.508a.25.25 0 0 1 .25-.25h2a.25.25 0 0 1 .25.25v.508a3.805 3.805 0 0 0-.25-.008h-2Zm-.25 10v-.508c.083.005.166.008.25.008h2c.084 0 .167-.003.25-.008v.508a.25.25 0 0 1-.25.25h-2a.25.25 0 0 1-.25-.25Zm.25-8.5a2.25 2.25 0 0 0-2.25 2.25v2a2.25 2.25 0 0 0 2.25 2.25h2a2.25 2.25 0 0 0 2.25-2.25v-2a2.25 2.25 0 0 0-2.25-2.25h-2Z"
      }));
    };
    SvgWatchIcon.displayName = "WatchIcon";
    exports.SvgWatchIcon = SvgWatchIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/WifiIcon.svg.js
var require_WifiIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/WifiIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgWifiIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M2.25 7.218a.75.75 0 0 0 1.06 1.06 9.5 9.5 0 0 1 13.435 0 .75.75 0 1 0 1.061-1.06c-4.296-4.296-11.26-4.296-15.556 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M4.725 10.753a.75.75 0 0 1 0-1.06 7.5 7.5 0 0 1 10.606 0 .75.75 0 1 1-1.06 1.06 6 6 0 0 0-8.486 0 .75.75 0 0 1-1.06 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M6.846 11.814a.75.75 0 0 0 1.06 1.06 3 3 0 0 1 4.243 0 .75.75 0 1 0 1.06-1.06 4.5 4.5 0 0 0-6.363 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        d: "M8.967 13.936a1.5 1.5 0 1 0 2.122 2.121 1.5 1.5 0 0 0-2.122-2.121Z"
      }));
    };
    SvgWifiIcon.displayName = "WifiIcon";
    exports.SvgWifiIcon = SvgWifiIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/WorkFilledIcon.svg.js
var require_WorkFilledIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/WorkFilledIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgWorkFilledIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.5 5.5v-.25a2.25 2.25 0 0 1 2.25-2.25h2.5a2.25 2.25 0 0 1 2.25 2.25v.25h.25a3.25 3.25 0 0 1 3.25 3.25v5a3.25 3.25 0 0 1-3.25 3.25h-7.5a3.25 3.25 0 0 1-3.25-3.25v-5a3.25 3.25 0 0 1 3.25-3.25h.25Zm1.5-.25a.75.75 0 0 1 .75-.75h2.5a.75.75 0 0 1 .75.75v.25h-4v-.25Zm-2.84 4.292a.625.625 0 0 1 .798-.381l.256.09c2.45.865 5.122.865 7.572 0l.256-.09a.625.625 0 1 1 .416 1.178l-.256.09a12.625 12.625 0 0 1-3.212.682.91.91 0 0 1 .01.139v.75a1 1 0 1 1-2 0v-.75c0-.047.003-.094.01-.14a12.622 12.622 0 0 1-3.212-.68l-.256-.09a.625.625 0 0 1-.381-.798Z"
      }));
    };
    SvgWorkFilledIcon.displayName = "WorkFilledIcon";
    exports.SvgWorkFilledIcon = SvgWorkFilledIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/WorkIcon.svg.js
var require_WorkIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/WorkIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgWorkIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M10.965 11.238a.986.986 0 0 1 .035.262v.5a1 1 0 1 1-2 0v-.5c0-.09.012-.178.035-.262a12.75 12.75 0 0 1-3.278-.69l-.257-.09a.75.75 0 1 1 .5-1.415l.256.09a11.25 11.25 0 0 0 7.488 0l.256-.09a.75.75 0 1 1 .5 1.414l-.257.09a12.75 12.75 0 0 1-3.278.69Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.5 5.5v-.25a2.25 2.25 0 0 1 2.25-2.25h2.5a2.25 2.25 0 0 1 2.25 2.25v.25h.25a3.25 3.25 0 0 1 3.25 3.25v5a3.25 3.25 0 0 1-3.25 3.25h-7.5a3.25 3.25 0 0 1-3.25-3.25v-5a3.25 3.25 0 0 1 3.25-3.25h.25Zm1.5-.25a.75.75 0 0 1 .75-.75h2.5a.75.75 0 0 1 .75.75v.25h-4v-.25Zm-1.75 1.75a1.75 1.75 0 0 0-1.75 1.75v5c0 .966.784 1.75 1.75 1.75h7.5a1.75 1.75 0 0 0 1.75-1.75v-5a1.75 1.75 0 0 0-1.75-1.75h-7.5Z"
      }));
    };
    SvgWorkIcon.displayName = "WorkIcon";
    exports.SvgWorkIcon = SvgWorkIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/WrenchIcon.svg.js
var require_WrenchIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/WrenchIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgWrenchIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M6.52 3.83a4.768 4.768 0 0 1 6.423 5.374l2.783 2.782a2.644 2.644 0 0 1-3.74 3.74l-2.782-2.782a4.768 4.768 0 0 1-5.373-6.424.75.75 0 0 1 1.228-.256l1.646 1.647a.853.853 0 0 0 1.206-1.206l-1.646-1.646a.75.75 0 0 1 .256-1.228Zm1.809 1.17.643.644a2.353 2.353 0 1 1-3.327 3.327l-.644-.644a3.268 3.268 0 0 0 4.216 3.069.75.75 0 0 1 .748.187l3.082 3.082a1.144 1.144 0 1 0 1.618-1.618l-3.082-3.082a.75.75 0 0 1-.187-.748 3.268 3.268 0 0 0-3.067-4.217Z"
      }));
    };
    SvgWrenchIcon.displayName = "WrenchIcon";
    exports.SvgWrenchIcon = SvgWrenchIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/XCircleIcon.svg.js
var require_XCircleIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/XCircleIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgXCircleIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M13.03 6.97a.75.75 0 0 1 0 1.06l-1.97 1.97 1.97 1.97a.75.75 0 1 1-1.06 1.06l-1.97-1.97-1.97 1.97a.75.75 0 0 1-1.06-1.06l1.97-1.97-1.97-1.97a.75.75 0 0 1 1.06-1.06l1.97 1.97 1.97-1.97a.75.75 0 0 1 1.06 0Z"
      }), /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M10 17a7 7 0 1 0 0-14 7 7 0 0 0 0 14Zm0-1.5a5.5 5.5 0 1 0 0-11 5.5 5.5 0 0 0 0 11Z"
      }));
    };
    SvgXCircleIcon.displayName = "XCircleIcon";
    exports.SvgXCircleIcon = SvgXCircleIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/XIcon.svg.js
var require_XIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/XIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgXIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.72 13.78a.75.75 0 1 0 1.06-1.06l-2.72-2.72 2.72-2.72a.75.75 0 0 0-1.06-1.06l-2.72 2.72-2.72-2.72a.75.75 0 0 0-1.06 1.06l2.72 2.72-2.72 2.72a.75.75 0 1 0 1.06 1.06l2.72-2.72 2.72 2.72Z"
      }));
    };
    SvgXIcon.displayName = "XIcon";
    exports.SvgXIcon = SvgXIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/XSmallIcon.svg.js
var require_XSmallIcon_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/XSmallIcon.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react2(), SvgXSmallIcon = function(props) {
      return /* @__PURE__ */ React12.createElement("svg", Object.assign({
        viewBox: "0 0 20 20"
      }, props), /* @__PURE__ */ React12.createElement("path", {
        d: "M12.72 13.78a.75.75 0 1 0 1.06-1.06l-2.72-2.72 2.72-2.72a.75.75 0 0 0-1.06-1.06l-2.72 2.72-2.72-2.72a.75.75 0 0 0-1.06 1.06l2.72 2.72-2.72 2.72a.75.75 0 1 0 1.06 1.06l2.72-2.72 2.72 2.72Z"
      }));
    };
    SvgXSmallIcon.displayName = "XSmallIcon";
    exports.SvgXSmallIcon = SvgXSmallIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/index.js
var require_dist8 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var icons__AdjustIcon_svg = require_AdjustIcon_svg(), icons__AffiliateIcon_svg = require_AffiliateIcon_svg(), icons__AirplaneIcon_svg = require_AirplaneIcon_svg(), icons__AlertBubbleIcon_svg = require_AlertBubbleIcon_svg(), icons__AlertCircleIcon_svg = require_AlertCircleIcon_svg(), icons__AlertDiamondIcon_svg = require_AlertDiamondIcon_svg(), icons__AlertTriangleIcon_svg = require_AlertTriangleIcon_svg(), icons__AppExtensionIcon_svg = require_AppExtensionIcon_svg(), icons__AppsFilledIcon_svg = require_AppsFilledIcon_svg(), icons__AppsIcon_svg = require_AppsIcon_svg(), icons__ArchiveIcon_svg = require_ArchiveIcon_svg(), icons__ArrowDownIcon_svg = require_ArrowDownIcon_svg(), icons__ArrowLeftIcon_svg = require_ArrowLeftIcon_svg(), icons__ArrowRightIcon_svg = require_ArrowRightIcon_svg(), icons__ArrowUpIcon_svg = require_ArrowUpIcon_svg(), icons__ArrowsInHorizontalIcon_svg = require_ArrowsInHorizontalIcon_svg(), icons__ArrowsOutHorizontalFilledIcon_svg = require_ArrowsOutHorizontalFilledIcon_svg(), icons__ArrowsOutHorizontalIcon_svg = require_ArrowsOutHorizontalIcon_svg(), icons__AttachmentFilledIcon_svg = require_AttachmentFilledIcon_svg(), icons__AttachmentIcon_svg = require_AttachmentIcon_svg(), icons__AutomationFilledIcon_svg = require_AutomationFilledIcon_svg(), icons__AutomationIcon_svg = require_AutomationIcon_svg(), icons__BackspaceIcon_svg = require_BackspaceIcon_svg(), icons__BankFilledIcon_svg = require_BankFilledIcon_svg(), icons__BankIcon_svg = require_BankIcon_svg(), icons__BarcodeIcon_svg = require_BarcodeIcon_svg(), icons__BillFilledIcon_svg = require_BillFilledIcon_svg(), icons__BillIcon_svg = require_BillIcon_svg(), icons__BlankFilledIcon_svg = require_BlankFilledIcon_svg(), icons__BlankIcon_svg = require_BlankIcon_svg(), icons__BlogIcon_svg = require_BlogIcon_svg(), icons__BookIcon_svg = require_BookIcon_svg(), icons__BookOpenIcon_svg = require_BookOpenIcon_svg(), icons__BugIcon_svg = require_BugIcon_svg(), icons__ButtonIcon_svg = require_ButtonIcon_svg(), icons__ButtonPressIcon_svg = require_ButtonPressIcon_svg(), icons__CalculatorIcon_svg = require_CalculatorIcon_svg(), icons__CalendarCheckIcon_svg = require_CalendarCheckIcon_svg(), icons__CalendarIcon_svg = require_CalendarIcon_svg(), icons__CalendarTimeIcon_svg = require_CalendarTimeIcon_svg(), icons__CameraFlipIcon_svg = require_CameraFlipIcon_svg(), icons__CameraIcon_svg = require_CameraIcon_svg(), icons__CaretDownIcon_svg = require_CaretDownIcon_svg(), icons__CaretUpIcon_svg = require_CaretUpIcon_svg(), icons__CartAbandonedFilledIcon_svg = require_CartAbandonedFilledIcon_svg(), icons__CartAbandonedIcon_svg = require_CartAbandonedIcon_svg(), icons__CartDiscountIcon_svg = require_CartDiscountIcon_svg(), icons__CartDownFilledIcon_svg = require_CartDownFilledIcon_svg(), icons__CartDownIcon_svg = require_CartDownIcon_svg(), icons__CartFilledIcon_svg = require_CartFilledIcon_svg(), icons__CartIcon_svg = require_CartIcon_svg(), icons__CartSaleIcon_svg = require_CartSaleIcon_svg(), icons__CartUpIcon_svg = require_CartUpIcon_svg(), icons__CashDollarFilledIcon_svg = require_CashDollarFilledIcon_svg(), icons__CashDollarIcon_svg = require_CashDollarIcon_svg(), icons__CashEuroIcon_svg = require_CashEuroIcon_svg(), icons__CashPoundIcon_svg = require_CashPoundIcon_svg(), icons__CashRupeeIcon_svg = require_CashRupeeIcon_svg(), icons__CashYenIcon_svg = require_CashYenIcon_svg(), icons__CategoriesIcon_svg = require_CategoriesIcon_svg(), icons__ChannelsIcon_svg = require_ChannelsIcon_svg(), icons__ChartCohortIcon_svg = require_ChartCohortIcon_svg(), icons__ChartDonutIcon_svg = require_ChartDonutIcon_svg(), icons__ChartFunnelIcon_svg = require_ChartFunnelIcon_svg(), icons__ChartHistogramFirstIcon_svg = require_ChartHistogramFirstIcon_svg(), icons__ChartHistogramFirstLastIcon_svg = require_ChartHistogramFirstLastIcon_svg(), icons__ChartHistogramFlatIcon_svg = require_ChartHistogramFlatIcon_svg(), icons__ChartHistogramFullIcon_svg = require_ChartHistogramFullIcon_svg(), icons__ChartHistogramGrowthIcon_svg = require_ChartHistogramGrowthIcon_svg(), icons__ChartHistogramLastIcon_svg = require_ChartHistogramLastIcon_svg(), icons__ChartHistogramSecondLastIcon_svg = require_ChartHistogramSecondLastIcon_svg(), icons__ChartHorizontalIcon_svg = require_ChartHorizontalIcon_svg(), icons__ChartLineIcon_svg = require_ChartLineIcon_svg(), icons__ChartPopularIcon_svg = require_ChartPopularIcon_svg(), icons__ChartStackedIcon_svg = require_ChartStackedIcon_svg(), icons__ChartVerticalFilledIcon_svg = require_ChartVerticalFilledIcon_svg(), icons__ChartVerticalIcon_svg = require_ChartVerticalIcon_svg(), icons__ChatIcon_svg = require_ChatIcon_svg(), icons__ChatReferralIcon_svg = require_ChatReferralIcon_svg(), icons__CheckCircleIcon_svg = require_CheckCircleIcon_svg(), icons__CheckIcon_svg = require_CheckIcon_svg(), icons__CheckSmallIcon_svg = require_CheckSmallIcon_svg(), icons__CheckboxIcon_svg = require_CheckboxIcon_svg(), icons__ChevronDownIcon_svg = require_ChevronDownIcon_svg(), icons__ChevronLeftIcon_svg = require_ChevronLeftIcon_svg(), icons__ChevronRightIcon_svg = require_ChevronRightIcon_svg(), icons__ChevronUpIcon_svg = require_ChevronUpIcon_svg(), icons__CircleChevronDownIcon_svg = require_CircleChevronDownIcon_svg(), icons__CircleChevronLeftIcon_svg = require_CircleChevronLeftIcon_svg(), icons__CircleChevronRightIcon_svg = require_CircleChevronRightIcon_svg(), icons__CircleChevronUpIcon_svg = require_CircleChevronUpIcon_svg(), icons__CircleDownIcon_svg = require_CircleDownIcon_svg(), icons__CircleLeftIcon_svg = require_CircleLeftIcon_svg(), icons__CircleRightIcon_svg = require_CircleRightIcon_svg(), icons__CircleUpIcon_svg = require_CircleUpIcon_svg(), icons__ClipboardCheckFilledIcon_svg = require_ClipboardCheckFilledIcon_svg(), icons__ClipboardCheckIcon_svg = require_ClipboardCheckIcon_svg(), icons__ClipboardChecklistIcon_svg = require_ClipboardChecklistIcon_svg(), icons__ClipboardIcon_svg = require_ClipboardIcon_svg(), icons__ClockIcon_svg = require_ClockIcon_svg(), icons__CodeAddIcon_svg = require_CodeAddIcon_svg(), icons__CodeIcon_svg = require_CodeIcon_svg(), icons__CollectionFeaturedIcon_svg = require_CollectionFeaturedIcon_svg(), icons__CollectionFilledIcon_svg = require_CollectionFilledIcon_svg(), icons__CollectionIcon_svg = require_CollectionIcon_svg(), icons__CollectionReferenceIcon_svg = require_CollectionReferenceIcon_svg(), icons__ColorIcon_svg = require_ColorIcon_svg(), icons__ColorNoneIcon_svg = require_ColorNoneIcon_svg(), icons__CompassIcon_svg = require_CompassIcon_svg(), icons__ComposeIcon_svg = require_ComposeIcon_svg(), icons__ConfettiIcon_svg = require_ConfettiIcon_svg(), icons__ConnectIcon_svg = require_ConnectIcon_svg(), icons__ContentFilledIcon_svg = require_ContentFilledIcon_svg(), icons__ContentIcon_svg = require_ContentIcon_svg(), icons__ContractFilledIcon_svg = require_ContractFilledIcon_svg(), icons__ContractIcon_svg = require_ContractIcon_svg(), icons__CornerPillIcon_svg = require_CornerPillIcon_svg(), icons__CornerRoundIcon_svg = require_CornerRoundIcon_svg(), icons__CornerSquareIcon_svg = require_CornerSquareIcon_svg(), icons__CreditCardCancelIcon_svg = require_CreditCardCancelIcon_svg(), icons__CreditCardIcon_svg = require_CreditCardIcon_svg(), icons__CreditCardPercentIcon_svg = require_CreditCardPercentIcon_svg(), icons__CreditCardReaderChipIcon_svg = require_CreditCardReaderChipIcon_svg(), icons__CreditCardReaderIcon_svg = require_CreditCardReaderIcon_svg(), icons__CreditCardReaderTapIcon_svg = require_CreditCardReaderTapIcon_svg(), icons__CreditCardSecureIcon_svg = require_CreditCardSecureIcon_svg(), icons__CreditCardTapChipIcon_svg = require_CreditCardTapChipIcon_svg(), icons__CurrencyConvertIcon_svg = require_CurrencyConvertIcon_svg(), icons__CursorBannerIcon_svg = require_CursorBannerIcon_svg(), icons__CursorFilledIcon_svg = require_CursorFilledIcon_svg(), icons__CursorIcon_svg = require_CursorIcon_svg(), icons__CursorOptionIcon_svg = require_CursorOptionIcon_svg(), icons__DataPresentationIcon_svg = require_DataPresentationIcon_svg(), icons__DataTableIcon_svg = require_DataTableIcon_svg(), icons__DatabaseAddIcon_svg = require_DatabaseAddIcon_svg(), icons__DatabaseIcon_svg = require_DatabaseIcon_svg(), icons__DeleteIcon_svg = require_DeleteIcon_svg(), icons__DeliveryFilledIcon_svg = require_DeliveryFilledIcon_svg(), icons__DeliveryIcon_svg = require_DeliveryIcon_svg(), icons__DesktopIcon_svg = require_DesktopIcon_svg(), icons__DisabledIcon_svg = require_DisabledIcon_svg(), icons__DiscountCodeIcon_svg = require_DiscountCodeIcon_svg(), icons__DiscountFilledIcon_svg = require_DiscountFilledIcon_svg(), icons__DiscountIcon_svg = require_DiscountIcon_svg(), icons__DnsSettingsIcon_svg = require_DnsSettingsIcon_svg(), icons__DockFloatingIcon_svg = require_DockFloatingIcon_svg(), icons__DockSideIcon_svg = require_DockSideIcon_svg(), icons__DomainFilledIcon_svg = require_DomainFilledIcon_svg(), icons__DomainIcon_svg = require_DomainIcon_svg(), icons__DomainLandingPageIcon_svg = require_DomainLandingPageIcon_svg(), icons__DomainNewIcon_svg = require_DomainNewIcon_svg(), icons__DomainRedirectIcon_svg = require_DomainRedirectIcon_svg(), icons__DragDropIcon_svg = require_DragDropIcon_svg(), icons__DragHandleIcon_svg = require_DragHandleIcon_svg(), icons__DuplicateIcon_svg = require_DuplicateIcon_svg(), icons__EditIcon_svg = require_EditIcon_svg(), icons__EmailFollowUpIcon_svg = require_EmailFollowUpIcon_svg(), icons__EmailIcon_svg = require_EmailIcon_svg(), icons__EmailNewsletterIcon_svg = require_EmailNewsletterIcon_svg(), icons__EnterIcon_svg = require_EnterIcon_svg(), icons__EnvelopeIcon_svg = require_EnvelopeIcon_svg(), icons__EnvelopeSoftPackIcon_svg = require_EnvelopeSoftPackIcon_svg(), icons__ExchangeIcon_svg = require_ExchangeIcon_svg(), icons__ExitIcon_svg = require_ExitIcon_svg(), icons__ExportIcon_svg = require_ExportIcon_svg(), icons__ExternalIcon_svg = require_ExternalIcon_svg(), icons__ExternalSmallIcon_svg = require_ExternalSmallIcon_svg(), icons__EyeCheckMarkIcon_svg = require_EyeCheckMarkIcon_svg(), icons__EyeDropperIcon_svg = require_EyeDropperIcon_svg(), icons__EyeFirstIcon_svg = require_EyeFirstIcon_svg(), icons__EyeglassesIcon_svg = require_EyeglassesIcon_svg(), icons__FaviconIcon_svg = require_FaviconIcon_svg(), icons__FileFilledIcon_svg = require_FileFilledIcon_svg(), icons__FileIcon_svg = require_FileIcon_svg(), icons__FilterIcon_svg = require_FilterIcon_svg(), icons__FlagIcon_svg = require_FlagIcon_svg(), icons__FlowerFilledIcon_svg = require_FlowerFilledIcon_svg(), icons__FlowerIcon_svg = require_FlowerIcon_svg(), icons__FolderAddIcon_svg = require_FolderAddIcon_svg(), icons__FolderDownIcon_svg = require_FolderDownIcon_svg(), icons__FolderIcon_svg = require_FolderIcon_svg(), icons__FolderRemoveIcon_svg = require_FolderRemoveIcon_svg(), icons__FolderUpIcon_svg = require_FolderUpIcon_svg(), icons__FoodIcon_svg = require_FoodIcon_svg(), icons__ForkliftIcon_svg = require_ForkliftIcon_svg(), icons__FormsIcon_svg = require_FormsIcon_svg(), icons__GamesIcon_svg = require_GamesIcon_svg(), icons__GaugeIcon_svg = require_GaugeIcon_svg(), icons__GiftCardFilledIcon_svg = require_GiftCardFilledIcon_svg(), icons__GiftCardIcon_svg = require_GiftCardIcon_svg(), icons__GlobeAsiaFilledIcon_svg = require_GlobeAsiaFilledIcon_svg(), icons__GlobeAsiaIcon_svg = require_GlobeAsiaIcon_svg(), icons__GlobeEUFilledIcon_svg = require_GlobeEUFilledIcon_svg(), icons__GlobeEUIcon_svg = require_GlobeEUIcon_svg(), icons__GlobeFilledIcon_svg = require_GlobeFilledIcon_svg(), icons__GlobeIcon_svg = require_GlobeIcon_svg(), icons__HashtagDecimalIcon_svg = require_HashtagDecimalIcon_svg(), icons__HashtagIcon_svg = require_HashtagIcon_svg(), icons__HeartIcon_svg = require_HeartIcon_svg(), icons__HideIcon_svg = require_HideIcon_svg(), icons__HomeFilledIcon_svg = require_HomeFilledIcon_svg(), icons__HomeIcon_svg = require_HomeIcon_svg(), icons__IconsFilledIcon_svg = require_IconsFilledIcon_svg(), icons__IconsIcon_svg = require_IconsIcon_svg(), icons__IdentityCardFilledIcon_svg = require_IdentityCardFilledIcon_svg(), icons__IdentityCardIcon_svg = require_IdentityCardIcon_svg(), icons__ImageAddIcon_svg = require_ImageAddIcon_svg(), icons__ImageAltIcon_svg = require_ImageAltIcon_svg(), icons__ImageExploreIcon_svg = require_ImageExploreIcon_svg(), icons__ImageIcon_svg = require_ImageIcon_svg(), icons__ImageWithTextOverlayIcon_svg = require_ImageWithTextOverlayIcon_svg(), icons__ImagesIcon_svg = require_ImagesIcon_svg(), icons__ImportIcon_svg = require_ImportIcon_svg(), icons__IncomingIcon_svg = require_IncomingIcon_svg(), icons__InfoIcon_svg = require_InfoIcon_svg(), icons__InventoryFilledIcon_svg = require_InventoryFilledIcon_svg(), icons__InventoryIcon_svg = require_InventoryIcon_svg(), icons__InventoryUpdatedIcon_svg = require_InventoryUpdatedIcon_svg(), icons__IqIcon_svg = require_IqIcon_svg(), icons__KeyIcon_svg = require_KeyIcon_svg(), icons__KeyboardHideIcon_svg = require_KeyboardHideIcon_svg(), icons__KeyboardIcon_svg = require_KeyboardIcon_svg(), icons__LabelPrinterIcon_svg = require_LabelPrinterIcon_svg(), icons__LanguageFilledIcon_svg = require_LanguageFilledIcon_svg(), icons__LanguageIcon_svg = require_LanguageIcon_svg(), icons__LanguageTranslateIcon_svg = require_LanguageTranslateIcon_svg(), icons__LayoutBlockIcon_svg = require_LayoutBlockIcon_svg(), icons__LayoutBuyButtonHorizontalIcon_svg = require_LayoutBuyButtonHorizontalIcon_svg(), icons__LayoutBuyButtonIcon_svg = require_LayoutBuyButtonIcon_svg(), icons__LayoutBuyButtonVerticalIcon_svg = require_LayoutBuyButtonVerticalIcon_svg(), icons__LayoutColumn1Icon_svg = require_LayoutColumn1Icon_svg(), icons__LayoutColumns2Icon_svg = require_LayoutColumns2Icon_svg(), icons__LayoutColumns3Icon_svg = require_LayoutColumns3Icon_svg(), icons__LayoutFooterIcon_svg = require_LayoutFooterIcon_svg(), icons__LayoutHeaderIcon_svg = require_LayoutHeaderIcon_svg(), icons__LayoutLogoBlockIcon_svg = require_LayoutLogoBlockIcon_svg(), icons__LayoutPopupIcon_svg = require_LayoutPopupIcon_svg(), icons__LayoutRows2Icon_svg = require_LayoutRows2Icon_svg(), icons__LayoutSectionIcon_svg = require_LayoutSectionIcon_svg(), icons__LayoutSidebarLeftIcon_svg = require_LayoutSidebarLeftIcon_svg(), icons__LayoutSidebarRightIcon_svg = require_LayoutSidebarRightIcon_svg(), icons__LightbulbIcon_svg = require_LightbulbIcon_svg(), icons__LinkIcon_svg = require_LinkIcon_svg(), icons__ListBulletedFilledIcon_svg = require_ListBulletedFilledIcon_svg(), icons__ListBulletedIcon_svg = require_ListBulletedIcon_svg(), icons__ListNumberedIcon_svg = require_ListNumberedIcon_svg(), icons__LiveFilledIcon_svg = require_LiveFilledIcon_svg(), icons__LiveIcon_svg = require_LiveIcon_svg(), icons__LocationFilledIcon_svg = require_LocationFilledIcon_svg(), icons__LocationIcon_svg = require_LocationIcon_svg(), icons__LocationNoneIcon_svg = require_LocationNoneIcon_svg(), icons__LockFilledIcon_svg = require_LockFilledIcon_svg(), icons__LockIcon_svg = require_LockIcon_svg(), icons__LogoCriteoIcon_svg = require_LogoCriteoIcon_svg(), icons__LogoFacebookIcon_svg = require_LogoFacebookIcon_svg(), icons__LogoGoogleIcon_svg = require_LogoGoogleIcon_svg(), icons__LogoInstagramIcon_svg = require_LogoInstagramIcon_svg(), icons__LogoMetaIcon_svg = require_LogoMetaIcon_svg(), icons__LogoPinterestIcon_svg = require_LogoPinterestIcon_svg(), icons__LogoSnapchatIcon_svg = require_LogoSnapchatIcon_svg(), icons__LogoTiktokIcon_svg = require_LogoTiktokIcon_svg(), icons__LogoTumblrIcon_svg = require_LogoTumblrIcon_svg(), icons__LogoTwitchIcon_svg = require_LogoTwitchIcon_svg(), icons__LogoVimeoIcon_svg = require_LogoVimeoIcon_svg(), icons__LogoXIcon_svg = require_LogoXIcon_svg(), icons__LogoYoutubeIcon_svg = require_LogoYoutubeIcon_svg(), icons__MagicIcon_svg = require_MagicIcon_svg(), icons__MarketsEuroFilledIcon_svg = require_MarketsEuroFilledIcon_svg(), icons__MarketsEuroIcon_svg = require_MarketsEuroIcon_svg(), icons__MarketsFilledIcon_svg = require_MarketsFilledIcon_svg(), icons__MarketsIcon_svg = require_MarketsIcon_svg(), icons__MarketsRupeeFilledIcon_svg = require_MarketsRupeeFilledIcon_svg(), icons__MarketsRupeeIcon_svg = require_MarketsRupeeIcon_svg(), icons__MarketsYenFilledIcon_svg = require_MarketsYenFilledIcon_svg(), icons__MarketsYenIcon_svg = require_MarketsYenIcon_svg(), icons__MaximizeIcon_svg = require_MaximizeIcon_svg(), icons__MeasurementSizeIcon_svg = require_MeasurementSizeIcon_svg(), icons__MeasurementVolumeIcon_svg = require_MeasurementVolumeIcon_svg(), icons__MeasurementWeightIcon_svg = require_MeasurementWeightIcon_svg(), icons__MediaReceiverIcon_svg = require_MediaReceiverIcon_svg(), icons__MegaphoneFilledIcon_svg = require_MegaphoneFilledIcon_svg(), icons__MegaphoneIcon_svg = require_MegaphoneIcon_svg(), icons__MentionIcon_svg = require_MentionIcon_svg(), icons__MenuHorizontalIcon_svg = require_MenuHorizontalIcon_svg(), icons__MenuIcon_svg = require_MenuIcon_svg(), icons__MenuVerticalIcon_svg = require_MenuVerticalIcon_svg(), icons__MergeIcon_svg = require_MergeIcon_svg(), icons__MetafieldsFilledIcon_svg = require_MetafieldsFilledIcon_svg(), icons__MetafieldsIcon_svg = require_MetafieldsIcon_svg(), icons__MetaobjectFilledIcon_svg = require_MetaobjectFilledIcon_svg(), icons__MetaobjectIcon_svg = require_MetaobjectIcon_svg(), icons__MetaobjectReferenceIcon_svg = require_MetaobjectReferenceIcon_svg(), icons__MicrophoneIcon_svg = require_MicrophoneIcon_svg(), icons__MinimizeIcon_svg = require_MinimizeIcon_svg(), icons__MinusCircleIcon_svg = require_MinusCircleIcon_svg(), icons__MinusIcon_svg = require_MinusIcon_svg(), icons__MobileIcon_svg = require_MobileIcon_svg(), icons__MoneyFilledIcon_svg = require_MoneyFilledIcon_svg(), icons__MoneyIcon_svg = require_MoneyIcon_svg(), icons__MoneyNoneIcon_svg = require_MoneyNoneIcon_svg(), icons__NatureIcon_svg = require_NatureIcon_svg(), icons__NoteAddIcon_svg = require_NoteAddIcon_svg(), icons__NoteIcon_svg = require_NoteIcon_svg(), icons__NotificationFilledIcon_svg = require_NotificationFilledIcon_svg(), icons__NotificationIcon_svg = require_NotificationIcon_svg(), icons__OrderDraftFilledIcon_svg = require_OrderDraftFilledIcon_svg(), icons__OrderDraftIcon_svg = require_OrderDraftIcon_svg(), icons__OrderFilledIcon_svg = require_OrderFilledIcon_svg(), icons__OrderFirstIcon_svg = require_OrderFirstIcon_svg(), icons__OrderFulfilledIcon_svg = require_OrderFulfilledIcon_svg(), icons__OrderIcon_svg = require_OrderIcon_svg(), icons__OrderRepeatIcon_svg = require_OrderRepeatIcon_svg(), icons__OrderUnfulfilledIcon_svg = require_OrderUnfulfilledIcon_svg(), icons__OrdersStatusIcon_svg = require_OrdersStatusIcon_svg(), icons__OrganizationIcon_svg = require_OrganizationIcon_svg(), icons__OutdentIcon_svg = require_OutdentIcon_svg(), icons__OutgoingIcon_svg = require_OutgoingIcon_svg(), icons__PackageFilledIcon_svg = require_PackageFilledIcon_svg(), icons__PackageFulfilledIcon_svg = require_PackageFulfilledIcon_svg(), icons__PackageIcon_svg = require_PackageIcon_svg(), icons__PackageOnHoldIcon_svg = require_PackageOnHoldIcon_svg(), icons__PackageReturnedIcon_svg = require_PackageReturnedIcon_svg(), icons__PageAddIcon_svg = require_PageAddIcon_svg(), icons__PageAttachmentIcon_svg = require_PageAttachmentIcon_svg(), icons__PageClockFilledIcon_svg = require_PageClockFilledIcon_svg(), icons__PageClockIcon_svg = require_PageClockIcon_svg(), icons__PageDownIcon_svg = require_PageDownIcon_svg(), icons__PageHeartIcon_svg = require_PageHeartIcon_svg(), icons__PageIcon_svg = require_PageIcon_svg(), icons__PageReferenceIcon_svg = require_PageReferenceIcon_svg(), icons__PageRemoveIcon_svg = require_PageRemoveIcon_svg(), icons__PageUpIcon_svg = require_PageUpIcon_svg(), icons__PaginationEndIcon_svg = require_PaginationEndIcon_svg(), icons__PaginationStartIcon_svg = require_PaginationStartIcon_svg(), icons__PaintBrushFlatIcon_svg = require_PaintBrushFlatIcon_svg(), icons__PaintBrushRoundIcon_svg = require_PaintBrushRoundIcon_svg(), icons__PaperCheckIcon_svg = require_PaperCheckIcon_svg(), icons__PasskeyFilledIcon_svg = require_PasskeyFilledIcon_svg(), icons__PasskeyIcon_svg = require_PasskeyIcon_svg(), icons__PauseCircleIcon_svg = require_PauseCircleIcon_svg(), icons__PaymentCaptureIcon_svg = require_PaymentCaptureIcon_svg(), icons__PaymentFilledIcon_svg = require_PaymentFilledIcon_svg(), icons__PaymentIcon_svg = require_PaymentIcon_svg(), icons__PersonAddIcon_svg = require_PersonAddIcon_svg(), icons__PersonExitIcon_svg = require_PersonExitIcon_svg(), icons__PersonFilledIcon_svg = require_PersonFilledIcon_svg(), icons__PersonIcon_svg = require_PersonIcon_svg(), icons__PersonLockFilledIcon_svg = require_PersonLockFilledIcon_svg(), icons__PersonLockIcon_svg = require_PersonLockIcon_svg(), icons__PersonRemoveIcon_svg = require_PersonRemoveIcon_svg(), icons__PersonalizedTextIcon_svg = require_PersonalizedTextIcon_svg(), icons__PhoneIcon_svg = require_PhoneIcon_svg(), icons__PhoneInIcon_svg = require_PhoneInIcon_svg(), icons__PhoneOutIcon_svg = require_PhoneOutIcon_svg(), icons__PinFilledIcon_svg = require_PinFilledIcon_svg(), icons__PinIcon_svg = require_PinIcon_svg(), icons__PlanFilledIcon_svg = require_PlanFilledIcon_svg(), icons__PlanIcon_svg = require_PlanIcon_svg(), icons__PlayCircleIcon_svg = require_PlayCircleIcon_svg(), icons__PlayIcon_svg = require_PlayIcon_svg(), icons__PlusCircleIcon_svg = require_PlusCircleIcon_svg(), icons__PlusIcon_svg = require_PlusIcon_svg(), icons__PointOfSaleIcon_svg = require_PointOfSaleIcon_svg(), icons__PriceListFilledIcon_svg = require_PriceListFilledIcon_svg(), icons__PriceListIcon_svg = require_PriceListIcon_svg(), icons__PrintIcon_svg = require_PrintIcon_svg(), icons__ProductAddIcon_svg = require_ProductAddIcon_svg(), icons__ProductCostIcon_svg = require_ProductCostIcon_svg(), icons__ProductFilledIcon_svg = require_ProductFilledIcon_svg(), icons__ProductIcon_svg = require_ProductIcon_svg(), icons__ProductReferenceIcon_svg = require_ProductReferenceIcon_svg(), icons__ProductRemoveIcon_svg = require_ProductRemoveIcon_svg(), icons__ProductReturnIcon_svg = require_ProductReturnIcon_svg(), icons__ProfileIcon_svg = require_ProfileIcon_svg(), icons__QuestionCircleIcon_svg = require_QuestionCircleIcon_svg(), icons__ReceiptDollarFilledIcon_svg = require_ReceiptDollarFilledIcon_svg(), icons__ReceiptDollarIcon_svg = require_ReceiptDollarIcon_svg(), icons__ReceiptEuroFilledIcon_svg = require_ReceiptEuroFilledIcon_svg(), icons__ReceiptEuroIcon_svg = require_ReceiptEuroIcon_svg(), icons__ReceiptIcon_svg = require_ReceiptIcon_svg(), icons__ReceiptPaidIcon_svg = require_ReceiptPaidIcon_svg(), icons__ReceiptPoundFilledIcon_svg = require_ReceiptPoundFilledIcon_svg(), icons__ReceiptPoundIcon_svg = require_ReceiptPoundIcon_svg(), icons__ReceiptRefundIcon_svg = require_ReceiptRefundIcon_svg(), icons__ReceiptRupeeFilledIcon_svg = require_ReceiptRupeeFilledIcon_svg(), icons__ReceiptRupeeIcon_svg = require_ReceiptRupeeIcon_svg(), icons__ReceiptYenFilledIcon_svg = require_ReceiptYenFilledIcon_svg(), icons__ReceiptYenIcon_svg = require_ReceiptYenIcon_svg(), icons__RedoIcon_svg = require_RedoIcon_svg(), icons__ReferralCodeIcon_svg = require_ReferralCodeIcon_svg(), icons__RefreshIcon_svg = require_RefreshIcon_svg(), icons__ReplaceIcon_svg = require_ReplaceIcon_svg(), icons__ReplayIcon_svg = require_ReplayIcon_svg(), icons__ResetIcon_svg = require_ResetIcon_svg(), icons__ReturnIcon_svg = require_ReturnIcon_svg(), icons__RewardIcon_svg = require_RewardIcon_svg(), icons__SandboxIcon_svg = require_SandboxIcon_svg(), icons__SaveIcon_svg = require_SaveIcon_svg(), icons__SearchIcon_svg = require_SearchIcon_svg(), icons__SearchListIcon_svg = require_SearchListIcon_svg(), icons__SearchRecentIcon_svg = require_SearchRecentIcon_svg(), icons__SearchResourceIcon_svg = require_SearchResourceIcon_svg(), icons__SelectIcon_svg = require_SelectIcon_svg(), icons__SendIcon_svg = require_SendIcon_svg(), icons__SettingsFilledIcon_svg = require_SettingsFilledIcon_svg(), icons__SettingsIcon_svg = require_SettingsIcon_svg(), icons__ShareIcon_svg = require_ShareIcon_svg(), icons__ShieldCheckMarkIcon_svg = require_ShieldCheckMarkIcon_svg(), icons__ShieldNoneIcon_svg = require_ShieldNoneIcon_svg(), icons__ShieldPendingIcon_svg = require_ShieldPendingIcon_svg(), icons__ShieldPersonIcon_svg = require_ShieldPersonIcon_svg(), icons__ShippingLabelFilledIcon_svg = require_ShippingLabelFilledIcon_svg(), icons__ShippingLabelIcon_svg = require_ShippingLabelIcon_svg(), icons__ShopcodesIcon_svg = require_ShopcodesIcon_svg(), icons__SidekickIcon_svg = require_SidekickIcon_svg(), icons__SkeletonIcon_svg = require_SkeletonIcon_svg(), icons__SlideshowIcon_svg = require_SlideshowIcon_svg(), icons__SmileyHappyIcon_svg = require_SmileyHappyIcon_svg(), icons__SmileyJoyIcon_svg = require_SmileyJoyIcon_svg(), icons__SmileyNeutralIcon_svg = require_SmileyNeutralIcon_svg(), icons__SmileySadIcon_svg = require_SmileySadIcon_svg(), icons__SocialAdIcon_svg = require_SocialAdIcon_svg(), icons__SocialPostIcon_svg = require_SocialPostIcon_svg(), icons__SortAscendingIcon_svg = require_SortAscendingIcon_svg(), icons__SortDescendingIcon_svg = require_SortDescendingIcon_svg(), icons__SortIcon_svg = require_SortIcon_svg(), icons__SoundIcon_svg = require_SoundIcon_svg(), icons__SportsIcon_svg = require_SportsIcon_svg(), icons__StarFilledIcon_svg = require_StarFilledIcon_svg(), icons__StarIcon_svg = require_StarIcon_svg(), icons__StatusActiveIcon_svg = require_StatusActiveIcon_svg(), icons__StatusIcon_svg = require_StatusIcon_svg(), icons__StopCircleIcon_svg = require_StopCircleIcon_svg(), icons__StoreFilledIcon_svg = require_StoreFilledIcon_svg(), icons__StoreIcon_svg = require_StoreIcon_svg(), icons__StoreImportIcon_svg = require_StoreImportIcon_svg(), icons__StoreManagedIcon_svg = require_StoreManagedIcon_svg(), icons__StoreOnlineIcon_svg = require_StoreOnlineIcon_svg(), icons__TabletIcon_svg = require_TabletIcon_svg(), icons__TargetFilledIcon_svg = require_TargetFilledIcon_svg(), icons__TargetIcon_svg = require_TargetIcon_svg(), icons__TaxFilledIcon_svg = require_TaxFilledIcon_svg(), icons__TaxIcon_svg = require_TaxIcon_svg(), icons__TeamIcon_svg = require_TeamIcon_svg(), icons__TextAlignCenterIcon_svg = require_TextAlignCenterIcon_svg(), icons__TextAlignLeftIcon_svg = require_TextAlignLeftIcon_svg(), icons__TextAlignRightIcon_svg = require_TextAlignRightIcon_svg(), icons__TextBlockIcon_svg = require_TextBlockIcon_svg(), icons__TextBoldIcon_svg = require_TextBoldIcon_svg(), icons__TextColorIcon_svg = require_TextColorIcon_svg(), icons__TextFontIcon_svg = require_TextFontIcon_svg(), icons__TextGrammarIcon_svg = require_TextGrammarIcon_svg(), icons__TextIcon_svg = require_TextIcon_svg(), icons__TextInColumnsIcon_svg = require_TextInColumnsIcon_svg(), icons__TextInRowsFilledIcon_svg = require_TextInRowsFilledIcon_svg(), icons__TextInRowsIcon_svg = require_TextInRowsIcon_svg(), icons__TextIndentIcon_svg = require_TextIndentIcon_svg(), icons__TextItalicIcon_svg = require_TextItalicIcon_svg(), icons__TextQuoteIcon_svg = require_TextQuoteIcon_svg(), icons__TextTitleIcon_svg = require_TextTitleIcon_svg(), icons__TextUnderlineIcon_svg = require_TextUnderlineIcon_svg(), icons__TextWithImageIcon_svg = require_TextWithImageIcon_svg(), icons__ThemeEditIcon_svg = require_ThemeEditIcon_svg(), icons__ThemeIcon_svg = require_ThemeIcon_svg(), icons__ThemeStoreIcon_svg = require_ThemeStoreIcon_svg(), icons__ThemeTemplateIcon_svg = require_ThemeTemplateIcon_svg(), icons__ThumbsDownIcon_svg = require_ThumbsDownIcon_svg(), icons__ThumbsUpIcon_svg = require_ThumbsUpIcon_svg(), icons__TipJarIcon_svg = require_TipJarIcon_svg(), icons__ToggleOffIcon_svg = require_ToggleOffIcon_svg(), icons__ToggleOnIcon_svg = require_ToggleOnIcon_svg(), icons__TransactionFeeDollarIcon_svg = require_TransactionFeeDollarIcon_svg(), icons__TransactionFeeEuroIcon_svg = require_TransactionFeeEuroIcon_svg(), icons__TransactionFeePoundIcon_svg = require_TransactionFeePoundIcon_svg(), icons__TransactionFeeRupeeIcon_svg = require_TransactionFeeRupeeIcon_svg(), icons__TransactionFeeYenIcon_svg = require_TransactionFeeYenIcon_svg(), icons__TransactionIcon_svg = require_TransactionIcon_svg(), icons__TransferIcon_svg = require_TransferIcon_svg(), icons__TransferInIcon_svg = require_TransferInIcon_svg(), icons__TransferInternalIcon_svg = require_TransferInternalIcon_svg(), icons__TransferOutIcon_svg = require_TransferOutIcon_svg(), icons__UndoIcon_svg = require_UndoIcon_svg(), icons__UnknownDeviceIcon_svg = require_UnknownDeviceIcon_svg(), icons__UploadIcon_svg = require_UploadIcon_svg(), icons__VariantIcon_svg = require_VariantIcon_svg(), icons__ViewIcon_svg = require_ViewIcon_svg(), icons__ViewportNarrowIcon_svg = require_ViewportNarrowIcon_svg(), icons__ViewportShortIcon_svg = require_ViewportShortIcon_svg(), icons__ViewportTallIcon_svg = require_ViewportTallIcon_svg(), icons__ViewportWideIcon_svg = require_ViewportWideIcon_svg(), icons__WalletFilledIcon_svg = require_WalletFilledIcon_svg(), icons__WalletIcon_svg = require_WalletIcon_svg(), icons__WandIcon_svg = require_WandIcon_svg(), icons__WatchIcon_svg = require_WatchIcon_svg(), icons__WifiIcon_svg = require_WifiIcon_svg(), icons__WorkFilledIcon_svg = require_WorkFilledIcon_svg(), icons__WorkIcon_svg = require_WorkIcon_svg(), icons__WrenchIcon_svg = require_WrenchIcon_svg(), icons__XCircleIcon_svg = require_XCircleIcon_svg(), icons__XIcon_svg = require_XIcon_svg(), icons__XSmallIcon_svg = require_XSmallIcon_svg();
    require_react2();
    exports.AdjustIcon = icons__AdjustIcon_svg.SvgAdjustIcon;
    exports.AffiliateIcon = icons__AffiliateIcon_svg.SvgAffiliateIcon;
    exports.AirplaneIcon = icons__AirplaneIcon_svg.SvgAirplaneIcon;
    exports.AlertBubbleIcon = icons__AlertBubbleIcon_svg.SvgAlertBubbleIcon;
    exports.AlertCircleIcon = icons__AlertCircleIcon_svg.SvgAlertCircleIcon;
    exports.AlertDiamondIcon = icons__AlertDiamondIcon_svg.SvgAlertDiamondIcon;
    exports.AlertTriangleIcon = icons__AlertTriangleIcon_svg.SvgAlertTriangleIcon;
    exports.AppExtensionIcon = icons__AppExtensionIcon_svg.SvgAppExtensionIcon;
    exports.AppsFilledIcon = icons__AppsFilledIcon_svg.SvgAppsFilledIcon;
    exports.AppsIcon = icons__AppsIcon_svg.SvgAppsIcon;
    exports.ArchiveIcon = icons__ArchiveIcon_svg.SvgArchiveIcon;
    exports.ArrowDownIcon = icons__ArrowDownIcon_svg.SvgArrowDownIcon;
    exports.ArrowLeftIcon = icons__ArrowLeftIcon_svg.SvgArrowLeftIcon;
    exports.ArrowRightIcon = icons__ArrowRightIcon_svg.SvgArrowRightIcon;
    exports.ArrowUpIcon = icons__ArrowUpIcon_svg.SvgArrowUpIcon;
    exports.ArrowsInHorizontalIcon = icons__ArrowsInHorizontalIcon_svg.SvgArrowsInHorizontalIcon;
    exports.ArrowsOutHorizontalFilledIcon = icons__ArrowsOutHorizontalFilledIcon_svg.SvgArrowsOutHorizontalFilledIcon;
    exports.ArrowsOutHorizontalIcon = icons__ArrowsOutHorizontalIcon_svg.SvgArrowsOutHorizontalIcon;
    exports.AttachmentFilledIcon = icons__AttachmentFilledIcon_svg.SvgAttachmentFilledIcon;
    exports.AttachmentIcon = icons__AttachmentIcon_svg.SvgAttachmentIcon;
    exports.AutomationFilledIcon = icons__AutomationFilledIcon_svg.SvgAutomationFilledIcon;
    exports.AutomationIcon = icons__AutomationIcon_svg.SvgAutomationIcon;
    exports.BackspaceIcon = icons__BackspaceIcon_svg.SvgBackspaceIcon;
    exports.BankFilledIcon = icons__BankFilledIcon_svg.SvgBankFilledIcon;
    exports.BankIcon = icons__BankIcon_svg.SvgBankIcon;
    exports.BarcodeIcon = icons__BarcodeIcon_svg.SvgBarcodeIcon;
    exports.BillFilledIcon = icons__BillFilledIcon_svg.SvgBillFilledIcon;
    exports.BillIcon = icons__BillIcon_svg.SvgBillIcon;
    exports.BlankFilledIcon = icons__BlankFilledIcon_svg.SvgBlankFilledIcon;
    exports.BlankIcon = icons__BlankIcon_svg.SvgBlankIcon;
    exports.BlogIcon = icons__BlogIcon_svg.SvgBlogIcon;
    exports.BookIcon = icons__BookIcon_svg.SvgBookIcon;
    exports.BookOpenIcon = icons__BookOpenIcon_svg.SvgBookOpenIcon;
    exports.BugIcon = icons__BugIcon_svg.SvgBugIcon;
    exports.ButtonIcon = icons__ButtonIcon_svg.SvgButtonIcon;
    exports.ButtonPressIcon = icons__ButtonPressIcon_svg.SvgButtonPressIcon;
    exports.CalculatorIcon = icons__CalculatorIcon_svg.SvgCalculatorIcon;
    exports.CalendarCheckIcon = icons__CalendarCheckIcon_svg.SvgCalendarCheckIcon;
    exports.CalendarIcon = icons__CalendarIcon_svg.SvgCalendarIcon;
    exports.CalendarTimeIcon = icons__CalendarTimeIcon_svg.SvgCalendarTimeIcon;
    exports.CameraFlipIcon = icons__CameraFlipIcon_svg.SvgCameraFlipIcon;
    exports.CameraIcon = icons__CameraIcon_svg.SvgCameraIcon;
    exports.CaretDownIcon = icons__CaretDownIcon_svg.SvgCaretDownIcon;
    exports.CaretUpIcon = icons__CaretUpIcon_svg.SvgCaretUpIcon;
    exports.CartAbandonedFilledIcon = icons__CartAbandonedFilledIcon_svg.SvgCartAbandonedFilledIcon;
    exports.CartAbandonedIcon = icons__CartAbandonedIcon_svg.SvgCartAbandonedIcon;
    exports.CartDiscountIcon = icons__CartDiscountIcon_svg.SvgCartDiscountIcon;
    exports.CartDownFilledIcon = icons__CartDownFilledIcon_svg.SvgCartDownFilledIcon;
    exports.CartDownIcon = icons__CartDownIcon_svg.SvgCartDownIcon;
    exports.CartFilledIcon = icons__CartFilledIcon_svg.SvgCartFilledIcon;
    exports.CartIcon = icons__CartIcon_svg.SvgCartIcon;
    exports.CartSaleIcon = icons__CartSaleIcon_svg.SvgCartSaleIcon;
    exports.CartUpIcon = icons__CartUpIcon_svg.SvgCartUpIcon;
    exports.CashDollarFilledIcon = icons__CashDollarFilledIcon_svg.SvgCashDollarFilledIcon;
    exports.CashDollarIcon = icons__CashDollarIcon_svg.SvgCashDollarIcon;
    exports.CashEuroIcon = icons__CashEuroIcon_svg.SvgCashEuroIcon;
    exports.CashPoundIcon = icons__CashPoundIcon_svg.SvgCashPoundIcon;
    exports.CashRupeeIcon = icons__CashRupeeIcon_svg.SvgCashRupeeIcon;
    exports.CashYenIcon = icons__CashYenIcon_svg.SvgCashYenIcon;
    exports.CategoriesIcon = icons__CategoriesIcon_svg.SvgCategoriesIcon;
    exports.ChannelsIcon = icons__ChannelsIcon_svg.SvgChannelsIcon;
    exports.ChartCohortIcon = icons__ChartCohortIcon_svg.SvgChartCohortIcon;
    exports.ChartDonutIcon = icons__ChartDonutIcon_svg.SvgChartDonutIcon;
    exports.ChartFunnelIcon = icons__ChartFunnelIcon_svg.SvgChartFunnelIcon;
    exports.ChartHistogramFirstIcon = icons__ChartHistogramFirstIcon_svg.SvgChartHistogramFirstIcon;
    exports.ChartHistogramFirstLastIcon = icons__ChartHistogramFirstLastIcon_svg.SvgChartHistogramFirstLastIcon;
    exports.ChartHistogramFlatIcon = icons__ChartHistogramFlatIcon_svg.SvgChartHistogramFlatIcon;
    exports.ChartHistogramFullIcon = icons__ChartHistogramFullIcon_svg.SvgChartHistogramFullIcon;
    exports.ChartHistogramGrowthIcon = icons__ChartHistogramGrowthIcon_svg.SvgChartHistogramGrowthIcon;
    exports.ChartHistogramLastIcon = icons__ChartHistogramLastIcon_svg.SvgChartHistogramLastIcon;
    exports.ChartHistogramSecondLastIcon = icons__ChartHistogramSecondLastIcon_svg.SvgChartHistogramSecondLastIcon;
    exports.ChartHorizontalIcon = icons__ChartHorizontalIcon_svg.SvgChartHorizontalIcon;
    exports.ChartLineIcon = icons__ChartLineIcon_svg.SvgChartLineIcon;
    exports.ChartPopularIcon = icons__ChartPopularIcon_svg.SvgChartPopularIcon;
    exports.ChartStackedIcon = icons__ChartStackedIcon_svg.SvgChartStackedIcon;
    exports.ChartVerticalFilledIcon = icons__ChartVerticalFilledIcon_svg.SvgChartVerticalFilledIcon;
    exports.ChartVerticalIcon = icons__ChartVerticalIcon_svg.SvgChartVerticalIcon;
    exports.ChatIcon = icons__ChatIcon_svg.SvgChatIcon;
    exports.ChatReferralIcon = icons__ChatReferralIcon_svg.SvgChatReferralIcon;
    exports.CheckCircleIcon = icons__CheckCircleIcon_svg.SvgCheckCircleIcon;
    exports.CheckIcon = icons__CheckIcon_svg.SvgCheckIcon;
    exports.CheckSmallIcon = icons__CheckSmallIcon_svg.SvgCheckSmallIcon;
    exports.CheckboxIcon = icons__CheckboxIcon_svg.SvgCheckboxIcon;
    exports.ChevronDownIcon = icons__ChevronDownIcon_svg.SvgChevronDownIcon;
    exports.ChevronLeftIcon = icons__ChevronLeftIcon_svg.SvgChevronLeftIcon;
    exports.ChevronRightIcon = icons__ChevronRightIcon_svg.SvgChevronRightIcon;
    exports.ChevronUpIcon = icons__ChevronUpIcon_svg.SvgChevronUpIcon;
    exports.CircleChevronDownIcon = icons__CircleChevronDownIcon_svg.SvgCircleChevronDownIcon;
    exports.CircleChevronLeftIcon = icons__CircleChevronLeftIcon_svg.SvgCircleChevronLeftIcon;
    exports.CircleChevronRightIcon = icons__CircleChevronRightIcon_svg.SvgCircleChevronRightIcon;
    exports.CircleChevronUpIcon = icons__CircleChevronUpIcon_svg.SvgCircleChevronUpIcon;
    exports.CircleDownIcon = icons__CircleDownIcon_svg.SvgCircleDownIcon;
    exports.CircleLeftIcon = icons__CircleLeftIcon_svg.SvgCircleLeftIcon;
    exports.CircleRightIcon = icons__CircleRightIcon_svg.SvgCircleRightIcon;
    exports.CircleUpIcon = icons__CircleUpIcon_svg.SvgCircleUpIcon;
    exports.ClipboardCheckFilledIcon = icons__ClipboardCheckFilledIcon_svg.SvgClipboardCheckFilledIcon;
    exports.ClipboardCheckIcon = icons__ClipboardCheckIcon_svg.SvgClipboardCheckIcon;
    exports.ClipboardChecklistIcon = icons__ClipboardChecklistIcon_svg.SvgClipboardChecklistIcon;
    exports.ClipboardIcon = icons__ClipboardIcon_svg.SvgClipboardIcon;
    exports.ClockIcon = icons__ClockIcon_svg.SvgClockIcon;
    exports.CodeAddIcon = icons__CodeAddIcon_svg.SvgCodeAddIcon;
    exports.CodeIcon = icons__CodeIcon_svg.SvgCodeIcon;
    exports.CollectionFeaturedIcon = icons__CollectionFeaturedIcon_svg.SvgCollectionFeaturedIcon;
    exports.CollectionFilledIcon = icons__CollectionFilledIcon_svg.SvgCollectionFilledIcon;
    exports.CollectionIcon = icons__CollectionIcon_svg.SvgCollectionIcon;
    exports.CollectionReferenceIcon = icons__CollectionReferenceIcon_svg.SvgCollectionReferenceIcon;
    exports.ColorIcon = icons__ColorIcon_svg.SvgColorIcon;
    exports.ColorNoneIcon = icons__ColorNoneIcon_svg.SvgColorNoneIcon;
    exports.CompassIcon = icons__CompassIcon_svg.SvgCompassIcon;
    exports.ComposeIcon = icons__ComposeIcon_svg.SvgComposeIcon;
    exports.ConfettiIcon = icons__ConfettiIcon_svg.SvgConfettiIcon;
    exports.ConnectIcon = icons__ConnectIcon_svg.SvgConnectIcon;
    exports.ContentFilledIcon = icons__ContentFilledIcon_svg.SvgContentFilledIcon;
    exports.ContentIcon = icons__ContentIcon_svg.SvgContentIcon;
    exports.ContractFilledIcon = icons__ContractFilledIcon_svg.SvgContractFilledIcon;
    exports.ContractIcon = icons__ContractIcon_svg.SvgContractIcon;
    exports.CornerPillIcon = icons__CornerPillIcon_svg.SvgCornerPillIcon;
    exports.CornerRoundIcon = icons__CornerRoundIcon_svg.SvgCornerRoundIcon;
    exports.CornerSquareIcon = icons__CornerSquareIcon_svg.SvgCornerSquareIcon;
    exports.CreditCardCancelIcon = icons__CreditCardCancelIcon_svg.SvgCreditCardCancelIcon;
    exports.CreditCardIcon = icons__CreditCardIcon_svg.SvgCreditCardIcon;
    exports.CreditCardPercentIcon = icons__CreditCardPercentIcon_svg.SvgCreditCardPercentIcon;
    exports.CreditCardReaderChipIcon = icons__CreditCardReaderChipIcon_svg.SvgCreditCardReaderChipIcon;
    exports.CreditCardReaderIcon = icons__CreditCardReaderIcon_svg.SvgCreditCardReaderIcon;
    exports.CreditCardReaderTapIcon = icons__CreditCardReaderTapIcon_svg.SvgCreditCardReaderTapIcon;
    exports.CreditCardSecureIcon = icons__CreditCardSecureIcon_svg.SvgCreditCardSecureIcon;
    exports.CreditCardTapChipIcon = icons__CreditCardTapChipIcon_svg.SvgCreditCardTapChipIcon;
    exports.CurrencyConvertIcon = icons__CurrencyConvertIcon_svg.SvgCurrencyConvertIcon;
    exports.CursorBannerIcon = icons__CursorBannerIcon_svg.SvgCursorBannerIcon;
    exports.CursorFilledIcon = icons__CursorFilledIcon_svg.SvgCursorFilledIcon;
    exports.CursorIcon = icons__CursorIcon_svg.SvgCursorIcon;
    exports.CursorOptionIcon = icons__CursorOptionIcon_svg.SvgCursorOptionIcon;
    exports.DataPresentationIcon = icons__DataPresentationIcon_svg.SvgDataPresentationIcon;
    exports.DataTableIcon = icons__DataTableIcon_svg.SvgDataTableIcon;
    exports.DatabaseAddIcon = icons__DatabaseAddIcon_svg.SvgDatabaseAddIcon;
    exports.DatabaseIcon = icons__DatabaseIcon_svg.SvgDatabaseIcon;
    exports.DeleteIcon = icons__DeleteIcon_svg.SvgDeleteIcon;
    exports.DeliveryFilledIcon = icons__DeliveryFilledIcon_svg.SvgDeliveryFilledIcon;
    exports.DeliveryIcon = icons__DeliveryIcon_svg.SvgDeliveryIcon;
    exports.DesktopIcon = icons__DesktopIcon_svg.SvgDesktopIcon;
    exports.DisabledIcon = icons__DisabledIcon_svg.SvgDisabledIcon;
    exports.DiscountCodeIcon = icons__DiscountCodeIcon_svg.SvgDiscountCodeIcon;
    exports.DiscountFilledIcon = icons__DiscountFilledIcon_svg.SvgDiscountFilledIcon;
    exports.DiscountIcon = icons__DiscountIcon_svg.SvgDiscountIcon;
    exports.DnsSettingsIcon = icons__DnsSettingsIcon_svg.SvgDnsSettingsIcon;
    exports.DockFloatingIcon = icons__DockFloatingIcon_svg.SvgDockFloatingIcon;
    exports.DockSideIcon = icons__DockSideIcon_svg.SvgDockSideIcon;
    exports.DomainFilledIcon = icons__DomainFilledIcon_svg.SvgDomainFilledIcon;
    exports.DomainIcon = icons__DomainIcon_svg.SvgDomainIcon;
    exports.DomainLandingPageIcon = icons__DomainLandingPageIcon_svg.SvgDomainLandingPageIcon;
    exports.DomainNewIcon = icons__DomainNewIcon_svg.SvgDomainNewIcon;
    exports.DomainRedirectIcon = icons__DomainRedirectIcon_svg.SvgDomainRedirectIcon;
    exports.DragDropIcon = icons__DragDropIcon_svg.SvgDragDropIcon;
    exports.DragHandleIcon = icons__DragHandleIcon_svg.SvgDragHandleIcon;
    exports.DuplicateIcon = icons__DuplicateIcon_svg.SvgDuplicateIcon;
    exports.EditIcon = icons__EditIcon_svg.SvgEditIcon;
    exports.EmailFollowUpIcon = icons__EmailFollowUpIcon_svg.SvgEmailFollowUpIcon;
    exports.EmailIcon = icons__EmailIcon_svg.SvgEmailIcon;
    exports.EmailNewsletterIcon = icons__EmailNewsletterIcon_svg.SvgEmailNewsletterIcon;
    exports.EnterIcon = icons__EnterIcon_svg.SvgEnterIcon;
    exports.EnvelopeIcon = icons__EnvelopeIcon_svg.SvgEnvelopeIcon;
    exports.EnvelopeSoftPackIcon = icons__EnvelopeSoftPackIcon_svg.SvgEnvelopeSoftPackIcon;
    exports.ExchangeIcon = icons__ExchangeIcon_svg.SvgExchangeIcon;
    exports.ExitIcon = icons__ExitIcon_svg.SvgExitIcon;
    exports.ExportIcon = icons__ExportIcon_svg.SvgExportIcon;
    exports.ExternalIcon = icons__ExternalIcon_svg.SvgExternalIcon;
    exports.ExternalSmallIcon = icons__ExternalSmallIcon_svg.SvgExternalSmallIcon;
    exports.EyeCheckMarkIcon = icons__EyeCheckMarkIcon_svg.SvgEyeCheckMarkIcon;
    exports.EyeDropperIcon = icons__EyeDropperIcon_svg.SvgEyeDropperIcon;
    exports.EyeFirstIcon = icons__EyeFirstIcon_svg.SvgEyeFirstIcon;
    exports.EyeglassesIcon = icons__EyeglassesIcon_svg.SvgEyeglassesIcon;
    exports.FaviconIcon = icons__FaviconIcon_svg.SvgFaviconIcon;
    exports.FileFilledIcon = icons__FileFilledIcon_svg.SvgFileFilledIcon;
    exports.FileIcon = icons__FileIcon_svg.SvgFileIcon;
    exports.FilterIcon = icons__FilterIcon_svg.SvgFilterIcon;
    exports.FlagIcon = icons__FlagIcon_svg.SvgFlagIcon;
    exports.FlowerFilledIcon = icons__FlowerFilledIcon_svg.SvgFlowerFilledIcon;
    exports.FlowerIcon = icons__FlowerIcon_svg.SvgFlowerIcon;
    exports.FolderAddIcon = icons__FolderAddIcon_svg.SvgFolderAddIcon;
    exports.FolderDownIcon = icons__FolderDownIcon_svg.SvgFolderDownIcon;
    exports.FolderIcon = icons__FolderIcon_svg.SvgFolderIcon;
    exports.FolderRemoveIcon = icons__FolderRemoveIcon_svg.SvgFolderRemoveIcon;
    exports.FolderUpIcon = icons__FolderUpIcon_svg.SvgFolderUpIcon;
    exports.FoodIcon = icons__FoodIcon_svg.SvgFoodIcon;
    exports.ForkliftIcon = icons__ForkliftIcon_svg.SvgForkliftIcon;
    exports.FormsIcon = icons__FormsIcon_svg.SvgFormsIcon;
    exports.GamesIcon = icons__GamesIcon_svg.SvgGamesIcon;
    exports.GaugeIcon = icons__GaugeIcon_svg.SvgGaugeIcon;
    exports.GiftCardFilledIcon = icons__GiftCardFilledIcon_svg.SvgGiftCardFilledIcon;
    exports.GiftCardIcon = icons__GiftCardIcon_svg.SvgGiftCardIcon;
    exports.GlobeAsiaFilledIcon = icons__GlobeAsiaFilledIcon_svg.SvgGlobeAsiaFilledIcon;
    exports.GlobeAsiaIcon = icons__GlobeAsiaIcon_svg.SvgGlobeAsiaIcon;
    exports.GlobeEUFilledIcon = icons__GlobeEUFilledIcon_svg.SvgGlobeEuFilledIcon;
    exports.GlobeEUIcon = icons__GlobeEUIcon_svg.SvgGlobeEuIcon;
    exports.GlobeFilledIcon = icons__GlobeFilledIcon_svg.SvgGlobeFilledIcon;
    exports.GlobeIcon = icons__GlobeIcon_svg.SvgGlobeIcon;
    exports.HashtagDecimalIcon = icons__HashtagDecimalIcon_svg.SvgHashtagDecimalIcon;
    exports.HashtagIcon = icons__HashtagIcon_svg.SvgHashtagIcon;
    exports.HeartIcon = icons__HeartIcon_svg.SvgHeartIcon;
    exports.HideIcon = icons__HideIcon_svg.SvgHideIcon;
    exports.HomeFilledIcon = icons__HomeFilledIcon_svg.SvgHomeFilledIcon;
    exports.HomeIcon = icons__HomeIcon_svg.SvgHomeIcon;
    exports.IconsFilledIcon = icons__IconsFilledIcon_svg.SvgIconsFilledIcon;
    exports.IconsIcon = icons__IconsIcon_svg.SvgIconsIcon;
    exports.IdentityCardFilledIcon = icons__IdentityCardFilledIcon_svg.SvgIdentityCardFilledIcon;
    exports.IdentityCardIcon = icons__IdentityCardIcon_svg.SvgIdentityCardIcon;
    exports.ImageAddIcon = icons__ImageAddIcon_svg.SvgImageAddIcon;
    exports.ImageAltIcon = icons__ImageAltIcon_svg.SvgImageAltIcon;
    exports.ImageExploreIcon = icons__ImageExploreIcon_svg.SvgImageExploreIcon;
    exports.ImageIcon = icons__ImageIcon_svg.SvgImageIcon;
    exports.ImageWithTextOverlayIcon = icons__ImageWithTextOverlayIcon_svg.SvgImageWithTextOverlayIcon;
    exports.ImagesIcon = icons__ImagesIcon_svg.SvgImagesIcon;
    exports.ImportIcon = icons__ImportIcon_svg.SvgImportIcon;
    exports.IncomingIcon = icons__IncomingIcon_svg.SvgIncomingIcon;
    exports.InfoIcon = icons__InfoIcon_svg.SvgInfoIcon;
    exports.InventoryFilledIcon = icons__InventoryFilledIcon_svg.SvgInventoryFilledIcon;
    exports.InventoryIcon = icons__InventoryIcon_svg.SvgInventoryIcon;
    exports.InventoryUpdatedIcon = icons__InventoryUpdatedIcon_svg.SvgInventoryUpdatedIcon;
    exports.IqIcon = icons__IqIcon_svg.SvgIqIcon;
    exports.KeyIcon = icons__KeyIcon_svg.SvgKeyIcon;
    exports.KeyboardHideIcon = icons__KeyboardHideIcon_svg.SvgKeyboardHideIcon;
    exports.KeyboardIcon = icons__KeyboardIcon_svg.SvgKeyboardIcon;
    exports.LabelPrinterIcon = icons__LabelPrinterIcon_svg.SvgLabelPrinterIcon;
    exports.LanguageFilledIcon = icons__LanguageFilledIcon_svg.SvgLanguageFilledIcon;
    exports.LanguageIcon = icons__LanguageIcon_svg.SvgLanguageIcon;
    exports.LanguageTranslateIcon = icons__LanguageTranslateIcon_svg.SvgLanguageTranslateIcon;
    exports.LayoutBlockIcon = icons__LayoutBlockIcon_svg.SvgLayoutBlockIcon;
    exports.LayoutBuyButtonHorizontalIcon = icons__LayoutBuyButtonHorizontalIcon_svg.SvgLayoutBuyButtonHorizontalIcon;
    exports.LayoutBuyButtonIcon = icons__LayoutBuyButtonIcon_svg.SvgLayoutBuyButtonIcon;
    exports.LayoutBuyButtonVerticalIcon = icons__LayoutBuyButtonVerticalIcon_svg.SvgLayoutBuyButtonVerticalIcon;
    exports.LayoutColumn1Icon = icons__LayoutColumn1Icon_svg.SvgLayoutColumn1Icon;
    exports.LayoutColumns2Icon = icons__LayoutColumns2Icon_svg.SvgLayoutColumns2Icon;
    exports.LayoutColumns3Icon = icons__LayoutColumns3Icon_svg.SvgLayoutColumns3Icon;
    exports.LayoutFooterIcon = icons__LayoutFooterIcon_svg.SvgLayoutFooterIcon;
    exports.LayoutHeaderIcon = icons__LayoutHeaderIcon_svg.SvgLayoutHeaderIcon;
    exports.LayoutLogoBlockIcon = icons__LayoutLogoBlockIcon_svg.SvgLayoutLogoBlockIcon;
    exports.LayoutPopupIcon = icons__LayoutPopupIcon_svg.SvgLayoutPopupIcon;
    exports.LayoutRows2Icon = icons__LayoutRows2Icon_svg.SvgLayoutRows2Icon;
    exports.LayoutSectionIcon = icons__LayoutSectionIcon_svg.SvgLayoutSectionIcon;
    exports.LayoutSidebarLeftIcon = icons__LayoutSidebarLeftIcon_svg.SvgLayoutSidebarLeftIcon;
    exports.LayoutSidebarRightIcon = icons__LayoutSidebarRightIcon_svg.SvgLayoutSidebarRightIcon;
    exports.LightbulbIcon = icons__LightbulbIcon_svg.SvgLightbulbIcon;
    exports.LinkIcon = icons__LinkIcon_svg.SvgLinkIcon;
    exports.ListBulletedFilledIcon = icons__ListBulletedFilledIcon_svg.SvgListBulletedFilledIcon;
    exports.ListBulletedIcon = icons__ListBulletedIcon_svg.SvgListBulletedIcon;
    exports.ListNumberedIcon = icons__ListNumberedIcon_svg.SvgListNumberedIcon;
    exports.LiveFilledIcon = icons__LiveFilledIcon_svg.SvgLiveFilledIcon;
    exports.LiveIcon = icons__LiveIcon_svg.SvgLiveIcon;
    exports.LocationFilledIcon = icons__LocationFilledIcon_svg.SvgLocationFilledIcon;
    exports.LocationIcon = icons__LocationIcon_svg.SvgLocationIcon;
    exports.LocationNoneIcon = icons__LocationNoneIcon_svg.SvgLocationNoneIcon;
    exports.LockFilledIcon = icons__LockFilledIcon_svg.SvgLockFilledIcon;
    exports.LockIcon = icons__LockIcon_svg.SvgLockIcon;
    exports.LogoCriteoIcon = icons__LogoCriteoIcon_svg.SvgLogoCriteoIcon;
    exports.LogoFacebookIcon = icons__LogoFacebookIcon_svg.SvgLogoFacebookIcon;
    exports.LogoGoogleIcon = icons__LogoGoogleIcon_svg.SvgLogoGoogleIcon;
    exports.LogoInstagramIcon = icons__LogoInstagramIcon_svg.SvgLogoInstagramIcon;
    exports.LogoMetaIcon = icons__LogoMetaIcon_svg.SvgLogoMetaIcon;
    exports.LogoPinterestIcon = icons__LogoPinterestIcon_svg.SvgLogoPinterestIcon;
    exports.LogoSnapchatIcon = icons__LogoSnapchatIcon_svg.SvgLogoSnapchatIcon;
    exports.LogoTiktokIcon = icons__LogoTiktokIcon_svg.SvgLogoTiktokIcon;
    exports.LogoTumblrIcon = icons__LogoTumblrIcon_svg.SvgLogoTumblrIcon;
    exports.LogoTwitchIcon = icons__LogoTwitchIcon_svg.SvgLogoTwitchIcon;
    exports.LogoVimeoIcon = icons__LogoVimeoIcon_svg.SvgLogoVimeoIcon;
    exports.LogoXIcon = icons__LogoXIcon_svg.SvgLogoXIcon;
    exports.LogoYoutubeIcon = icons__LogoYoutubeIcon_svg.SvgLogoYoutubeIcon;
    exports.MagicIcon = icons__MagicIcon_svg.SvgMagicIcon;
    exports.MarketsEuroFilledIcon = icons__MarketsEuroFilledIcon_svg.SvgMarketsEuroFilledIcon;
    exports.MarketsEuroIcon = icons__MarketsEuroIcon_svg.SvgMarketsEuroIcon;
    exports.MarketsFilledIcon = icons__MarketsFilledIcon_svg.SvgMarketsFilledIcon;
    exports.MarketsIcon = icons__MarketsIcon_svg.SvgMarketsIcon;
    exports.MarketsRupeeFilledIcon = icons__MarketsRupeeFilledIcon_svg.SvgMarketsRupeeFilledIcon;
    exports.MarketsRupeeIcon = icons__MarketsRupeeIcon_svg.SvgMarketsRupeeIcon;
    exports.MarketsYenFilledIcon = icons__MarketsYenFilledIcon_svg.SvgMarketsYenFilledIcon;
    exports.MarketsYenIcon = icons__MarketsYenIcon_svg.SvgMarketsYenIcon;
    exports.MaximizeIcon = icons__MaximizeIcon_svg.SvgMaximizeIcon;
    exports.MeasurementSizeIcon = icons__MeasurementSizeIcon_svg.SvgMeasurementSizeIcon;
    exports.MeasurementVolumeIcon = icons__MeasurementVolumeIcon_svg.SvgMeasurementVolumeIcon;
    exports.MeasurementWeightIcon = icons__MeasurementWeightIcon_svg.SvgMeasurementWeightIcon;
    exports.MediaReceiverIcon = icons__MediaReceiverIcon_svg.SvgMediaReceiverIcon;
    exports.MegaphoneFilledIcon = icons__MegaphoneFilledIcon_svg.SvgMegaphoneFilledIcon;
    exports.MegaphoneIcon = icons__MegaphoneIcon_svg.SvgMegaphoneIcon;
    exports.MentionIcon = icons__MentionIcon_svg.SvgMentionIcon;
    exports.MenuHorizontalIcon = icons__MenuHorizontalIcon_svg.SvgMenuHorizontalIcon;
    exports.MenuIcon = icons__MenuIcon_svg.SvgMenuIcon;
    exports.MenuVerticalIcon = icons__MenuVerticalIcon_svg.SvgMenuVerticalIcon;
    exports.MergeIcon = icons__MergeIcon_svg.SvgMergeIcon;
    exports.MetafieldsFilledIcon = icons__MetafieldsFilledIcon_svg.SvgMetafieldsFilledIcon;
    exports.MetafieldsIcon = icons__MetafieldsIcon_svg.SvgMetafieldsIcon;
    exports.MetaobjectFilledIcon = icons__MetaobjectFilledIcon_svg.SvgMetaobjectFilledIcon;
    exports.MetaobjectIcon = icons__MetaobjectIcon_svg.SvgMetaobjectIcon;
    exports.MetaobjectReferenceIcon = icons__MetaobjectReferenceIcon_svg.SvgMetaobjectReferenceIcon;
    exports.MicrophoneIcon = icons__MicrophoneIcon_svg.SvgMicrophoneIcon;
    exports.MinimizeIcon = icons__MinimizeIcon_svg.SvgMinimizeIcon;
    exports.MinusCircleIcon = icons__MinusCircleIcon_svg.SvgMinusCircleIcon;
    exports.MinusIcon = icons__MinusIcon_svg.SvgMinusIcon;
    exports.MobileIcon = icons__MobileIcon_svg.SvgMobileIcon;
    exports.MoneyFilledIcon = icons__MoneyFilledIcon_svg.SvgMoneyFilledIcon;
    exports.MoneyIcon = icons__MoneyIcon_svg.SvgMoneyIcon;
    exports.MoneyNoneIcon = icons__MoneyNoneIcon_svg.SvgMoneyNoneIcon;
    exports.NatureIcon = icons__NatureIcon_svg.SvgNatureIcon;
    exports.NoteAddIcon = icons__NoteAddIcon_svg.SvgNoteAddIcon;
    exports.NoteIcon = icons__NoteIcon_svg.SvgNoteIcon;
    exports.NotificationFilledIcon = icons__NotificationFilledIcon_svg.SvgNotificationFilledIcon;
    exports.NotificationIcon = icons__NotificationIcon_svg.SvgNotificationIcon;
    exports.OrderDraftFilledIcon = icons__OrderDraftFilledIcon_svg.SvgOrderDraftFilledIcon;
    exports.OrderDraftIcon = icons__OrderDraftIcon_svg.SvgOrderDraftIcon;
    exports.OrderFilledIcon = icons__OrderFilledIcon_svg.SvgOrderFilledIcon;
    exports.OrderFirstIcon = icons__OrderFirstIcon_svg.SvgOrderFirstIcon;
    exports.OrderFulfilledIcon = icons__OrderFulfilledIcon_svg.SvgOrderFulfilledIcon;
    exports.OrderIcon = icons__OrderIcon_svg.SvgOrderIcon;
    exports.OrderRepeatIcon = icons__OrderRepeatIcon_svg.SvgOrderRepeatIcon;
    exports.OrderUnfulfilledIcon = icons__OrderUnfulfilledIcon_svg.SvgOrderUnfulfilledIcon;
    exports.OrdersStatusIcon = icons__OrdersStatusIcon_svg.SvgOrdersStatusIcon;
    exports.OrganizationIcon = icons__OrganizationIcon_svg.SvgOrganizationIcon;
    exports.OutdentIcon = icons__OutdentIcon_svg.SvgOutdentIcon;
    exports.OutgoingIcon = icons__OutgoingIcon_svg.SvgOutgoingIcon;
    exports.PackageFilledIcon = icons__PackageFilledIcon_svg.SvgPackageFilledIcon;
    exports.PackageFulfilledIcon = icons__PackageFulfilledIcon_svg.SvgPackageFulfilledIcon;
    exports.PackageIcon = icons__PackageIcon_svg.SvgPackageIcon;
    exports.PackageOnHoldIcon = icons__PackageOnHoldIcon_svg.SvgPackageOnHoldIcon;
    exports.PackageReturnedIcon = icons__PackageReturnedIcon_svg.SvgPackageReturnedIcon;
    exports.PageAddIcon = icons__PageAddIcon_svg.SvgPageAddIcon;
    exports.PageAttachmentIcon = icons__PageAttachmentIcon_svg.SvgPageAttachmentIcon;
    exports.PageClockFilledIcon = icons__PageClockFilledIcon_svg.SvgPageClockFilledIcon;
    exports.PageClockIcon = icons__PageClockIcon_svg.SvgPageClockIcon;
    exports.PageDownIcon = icons__PageDownIcon_svg.SvgPageDownIcon;
    exports.PageHeartIcon = icons__PageHeartIcon_svg.SvgPageHeartIcon;
    exports.PageIcon = icons__PageIcon_svg.SvgPageIcon;
    exports.PageReferenceIcon = icons__PageReferenceIcon_svg.SvgPageReferenceIcon;
    exports.PageRemoveIcon = icons__PageRemoveIcon_svg.SvgPageRemoveIcon;
    exports.PageUpIcon = icons__PageUpIcon_svg.SvgPageUpIcon;
    exports.PaginationEndIcon = icons__PaginationEndIcon_svg.SvgPaginationEndIcon;
    exports.PaginationStartIcon = icons__PaginationStartIcon_svg.SvgPaginationStartIcon;
    exports.PaintBrushFlatIcon = icons__PaintBrushFlatIcon_svg.SvgPaintBrushFlatIcon;
    exports.PaintBrushRoundIcon = icons__PaintBrushRoundIcon_svg.SvgPaintBrushRoundIcon;
    exports.PaperCheckIcon = icons__PaperCheckIcon_svg.SvgPaperCheckIcon;
    exports.PasskeyFilledIcon = icons__PasskeyFilledIcon_svg.SvgPasskeyFilledIcon;
    exports.PasskeyIcon = icons__PasskeyIcon_svg.SvgPasskeyIcon;
    exports.PauseCircleIcon = icons__PauseCircleIcon_svg.SvgPauseCircleIcon;
    exports.PaymentCaptureIcon = icons__PaymentCaptureIcon_svg.SvgPaymentCaptureIcon;
    exports.PaymentFilledIcon = icons__PaymentFilledIcon_svg.SvgPaymentFilledIcon;
    exports.PaymentIcon = icons__PaymentIcon_svg.SvgPaymentIcon;
    exports.PersonAddIcon = icons__PersonAddIcon_svg.SvgPersonAddIcon;
    exports.PersonExitIcon = icons__PersonExitIcon_svg.SvgPersonExitIcon;
    exports.PersonFilledIcon = icons__PersonFilledIcon_svg.SvgPersonFilledIcon;
    exports.PersonIcon = icons__PersonIcon_svg.SvgPersonIcon;
    exports.PersonLockFilledIcon = icons__PersonLockFilledIcon_svg.SvgPersonLockFilledIcon;
    exports.PersonLockIcon = icons__PersonLockIcon_svg.SvgPersonLockIcon;
    exports.PersonRemoveIcon = icons__PersonRemoveIcon_svg.SvgPersonRemoveIcon;
    exports.PersonalizedTextIcon = icons__PersonalizedTextIcon_svg.SvgPersonalizedTextIcon;
    exports.PhoneIcon = icons__PhoneIcon_svg.SvgPhoneIcon;
    exports.PhoneInIcon = icons__PhoneInIcon_svg.SvgPhoneInIcon;
    exports.PhoneOutIcon = icons__PhoneOutIcon_svg.SvgPhoneOutIcon;
    exports.PinFilledIcon = icons__PinFilledIcon_svg.SvgPinFilledIcon;
    exports.PinIcon = icons__PinIcon_svg.SvgPinIcon;
    exports.PlanFilledIcon = icons__PlanFilledIcon_svg.SvgPlanFilledIcon;
    exports.PlanIcon = icons__PlanIcon_svg.SvgPlanIcon;
    exports.PlayCircleIcon = icons__PlayCircleIcon_svg.SvgPlayCircleIcon;
    exports.PlayIcon = icons__PlayIcon_svg.SvgPlayIcon;
    exports.PlusCircleIcon = icons__PlusCircleIcon_svg.SvgPlusCircleIcon;
    exports.PlusIcon = icons__PlusIcon_svg.SvgPlusIcon;
    exports.PointOfSaleIcon = icons__PointOfSaleIcon_svg.SvgPointOfSaleIcon;
    exports.PriceListFilledIcon = icons__PriceListFilledIcon_svg.SvgPriceListFilledIcon;
    exports.PriceListIcon = icons__PriceListIcon_svg.SvgPriceListIcon;
    exports.PrintIcon = icons__PrintIcon_svg.SvgPrintIcon;
    exports.ProductAddIcon = icons__ProductAddIcon_svg.SvgProductAddIcon;
    exports.ProductCostIcon = icons__ProductCostIcon_svg.SvgProductCostIcon;
    exports.ProductFilledIcon = icons__ProductFilledIcon_svg.SvgProductFilledIcon;
    exports.ProductIcon = icons__ProductIcon_svg.SvgProductIcon;
    exports.ProductReferenceIcon = icons__ProductReferenceIcon_svg.SvgProductReferenceIcon;
    exports.ProductRemoveIcon = icons__ProductRemoveIcon_svg.SvgProductRemoveIcon;
    exports.ProductReturnIcon = icons__ProductReturnIcon_svg.SvgProductReturnIcon;
    exports.ProfileIcon = icons__ProfileIcon_svg.SvgProfileIcon;
    exports.QuestionCircleIcon = icons__QuestionCircleIcon_svg.SvgQuestionCircleIcon;
    exports.ReceiptDollarFilledIcon = icons__ReceiptDollarFilledIcon_svg.SvgReceiptDollarFilledIcon;
    exports.ReceiptDollarIcon = icons__ReceiptDollarIcon_svg.SvgReceiptDollarIcon;
    exports.ReceiptEuroFilledIcon = icons__ReceiptEuroFilledIcon_svg.SvgReceiptEuroFilledIcon;
    exports.ReceiptEuroIcon = icons__ReceiptEuroIcon_svg.SvgReceiptEuroIcon;
    exports.ReceiptIcon = icons__ReceiptIcon_svg.SvgReceiptIcon;
    exports.ReceiptPaidIcon = icons__ReceiptPaidIcon_svg.SvgReceiptPaidIcon;
    exports.ReceiptPoundFilledIcon = icons__ReceiptPoundFilledIcon_svg.SvgReceiptPoundFilledIcon;
    exports.ReceiptPoundIcon = icons__ReceiptPoundIcon_svg.SvgReceiptPoundIcon;
    exports.ReceiptRefundIcon = icons__ReceiptRefundIcon_svg.SvgReceiptRefundIcon;
    exports.ReceiptRupeeFilledIcon = icons__ReceiptRupeeFilledIcon_svg.SvgReceiptRupeeFilledIcon;
    exports.ReceiptRupeeIcon = icons__ReceiptRupeeIcon_svg.SvgReceiptRupeeIcon;
    exports.ReceiptYenFilledIcon = icons__ReceiptYenFilledIcon_svg.SvgReceiptYenFilledIcon;
    exports.ReceiptYenIcon = icons__ReceiptYenIcon_svg.SvgReceiptYenIcon;
    exports.RedoIcon = icons__RedoIcon_svg.SvgRedoIcon;
    exports.ReferralCodeIcon = icons__ReferralCodeIcon_svg.SvgReferralCodeIcon;
    exports.RefreshIcon = icons__RefreshIcon_svg.SvgRefreshIcon;
    exports.ReplaceIcon = icons__ReplaceIcon_svg.SvgReplaceIcon;
    exports.ReplayIcon = icons__ReplayIcon_svg.SvgReplayIcon;
    exports.ResetIcon = icons__ResetIcon_svg.SvgResetIcon;
    exports.ReturnIcon = icons__ReturnIcon_svg.SvgReturnIcon;
    exports.RewardIcon = icons__RewardIcon_svg.SvgRewardIcon;
    exports.SandboxIcon = icons__SandboxIcon_svg.SvgSandboxIcon;
    exports.SaveIcon = icons__SaveIcon_svg.SvgSaveIcon;
    exports.SearchIcon = icons__SearchIcon_svg.SvgSearchIcon;
    exports.SearchListIcon = icons__SearchListIcon_svg.SvgSearchListIcon;
    exports.SearchRecentIcon = icons__SearchRecentIcon_svg.SvgSearchRecentIcon;
    exports.SearchResourceIcon = icons__SearchResourceIcon_svg.SvgSearchResourceIcon;
    exports.SelectIcon = icons__SelectIcon_svg.SvgSelectIcon;
    exports.SendIcon = icons__SendIcon_svg.SvgSendIcon;
    exports.SettingsFilledIcon = icons__SettingsFilledIcon_svg.SvgSettingsFilledIcon;
    exports.SettingsIcon = icons__SettingsIcon_svg.SvgSettingsIcon;
    exports.ShareIcon = icons__ShareIcon_svg.SvgShareIcon;
    exports.ShieldCheckMarkIcon = icons__ShieldCheckMarkIcon_svg.SvgShieldCheckMarkIcon;
    exports.ShieldNoneIcon = icons__ShieldNoneIcon_svg.SvgShieldNoneIcon;
    exports.ShieldPendingIcon = icons__ShieldPendingIcon_svg.SvgShieldPendingIcon;
    exports.ShieldPersonIcon = icons__ShieldPersonIcon_svg.SvgShieldPersonIcon;
    exports.ShippingLabelFilledIcon = icons__ShippingLabelFilledIcon_svg.SvgShippingLabelFilledIcon;
    exports.ShippingLabelIcon = icons__ShippingLabelIcon_svg.SvgShippingLabelIcon;
    exports.ShopcodesIcon = icons__ShopcodesIcon_svg.SvgShopcodesIcon;
    exports.SidekickIcon = icons__SidekickIcon_svg.SvgSidekickIcon;
    exports.SkeletonIcon = icons__SkeletonIcon_svg.SvgSkeletonIcon;
    exports.SlideshowIcon = icons__SlideshowIcon_svg.SvgSlideshowIcon;
    exports.SmileyHappyIcon = icons__SmileyHappyIcon_svg.SvgSmileyHappyIcon;
    exports.SmileyJoyIcon = icons__SmileyJoyIcon_svg.SvgSmileyJoyIcon;
    exports.SmileyNeutralIcon = icons__SmileyNeutralIcon_svg.SvgSmileyNeutralIcon;
    exports.SmileySadIcon = icons__SmileySadIcon_svg.SvgSmileySadIcon;
    exports.SocialAdIcon = icons__SocialAdIcon_svg.SvgSocialAdIcon;
    exports.SocialPostIcon = icons__SocialPostIcon_svg.SvgSocialPostIcon;
    exports.SortAscendingIcon = icons__SortAscendingIcon_svg.SvgSortAscendingIcon;
    exports.SortDescendingIcon = icons__SortDescendingIcon_svg.SvgSortDescendingIcon;
    exports.SortIcon = icons__SortIcon_svg.SvgSortIcon;
    exports.SoundIcon = icons__SoundIcon_svg.SvgSoundIcon;
    exports.SportsIcon = icons__SportsIcon_svg.SvgSportsIcon;
    exports.StarFilledIcon = icons__StarFilledIcon_svg.SvgStarFilledIcon;
    exports.StarIcon = icons__StarIcon_svg.SvgStarIcon;
    exports.StatusActiveIcon = icons__StatusActiveIcon_svg.SvgStatusActiveIcon;
    exports.StatusIcon = icons__StatusIcon_svg.SvgStatusIcon;
    exports.StopCircleIcon = icons__StopCircleIcon_svg.SvgStopCircleIcon;
    exports.StoreFilledIcon = icons__StoreFilledIcon_svg.SvgStoreFilledIcon;
    exports.StoreIcon = icons__StoreIcon_svg.SvgStoreIcon;
    exports.StoreImportIcon = icons__StoreImportIcon_svg.SvgStoreImportIcon;
    exports.StoreManagedIcon = icons__StoreManagedIcon_svg.SvgStoreManagedIcon;
    exports.StoreOnlineIcon = icons__StoreOnlineIcon_svg.SvgStoreOnlineIcon;
    exports.TabletIcon = icons__TabletIcon_svg.SvgTabletIcon;
    exports.TargetFilledIcon = icons__TargetFilledIcon_svg.SvgTargetFilledIcon;
    exports.TargetIcon = icons__TargetIcon_svg.SvgTargetIcon;
    exports.TaxFilledIcon = icons__TaxFilledIcon_svg.SvgTaxFilledIcon;
    exports.TaxIcon = icons__TaxIcon_svg.SvgTaxIcon;
    exports.TeamIcon = icons__TeamIcon_svg.SvgTeamIcon;
    exports.TextAlignCenterIcon = icons__TextAlignCenterIcon_svg.SvgTextAlignCenterIcon;
    exports.TextAlignLeftIcon = icons__TextAlignLeftIcon_svg.SvgTextAlignLeftIcon;
    exports.TextAlignRightIcon = icons__TextAlignRightIcon_svg.SvgTextAlignRightIcon;
    exports.TextBlockIcon = icons__TextBlockIcon_svg.SvgTextBlockIcon;
    exports.TextBoldIcon = icons__TextBoldIcon_svg.SvgTextBoldIcon;
    exports.TextColorIcon = icons__TextColorIcon_svg.SvgTextColorIcon;
    exports.TextFontIcon = icons__TextFontIcon_svg.SvgTextFontIcon;
    exports.TextGrammarIcon = icons__TextGrammarIcon_svg.SvgTextGrammarIcon;
    exports.TextIcon = icons__TextIcon_svg.SvgTextIcon;
    exports.TextInColumnsIcon = icons__TextInColumnsIcon_svg.SvgTextInColumnsIcon;
    exports.TextInRowsFilledIcon = icons__TextInRowsFilledIcon_svg.SvgTextInRowsFilledIcon;
    exports.TextInRowsIcon = icons__TextInRowsIcon_svg.SvgTextInRowsIcon;
    exports.TextIndentIcon = icons__TextIndentIcon_svg.SvgTextIndentIcon;
    exports.TextItalicIcon = icons__TextItalicIcon_svg.SvgTextItalicIcon;
    exports.TextQuoteIcon = icons__TextQuoteIcon_svg.SvgTextQuoteIcon;
    exports.TextTitleIcon = icons__TextTitleIcon_svg.SvgTextTitleIcon;
    exports.TextUnderlineIcon = icons__TextUnderlineIcon_svg.SvgTextUnderlineIcon;
    exports.TextWithImageIcon = icons__TextWithImageIcon_svg.SvgTextWithImageIcon;
    exports.ThemeEditIcon = icons__ThemeEditIcon_svg.SvgThemeEditIcon;
    exports.ThemeIcon = icons__ThemeIcon_svg.SvgThemeIcon;
    exports.ThemeStoreIcon = icons__ThemeStoreIcon_svg.SvgThemeStoreIcon;
    exports.ThemeTemplateIcon = icons__ThemeTemplateIcon_svg.SvgThemeTemplateIcon;
    exports.ThumbsDownIcon = icons__ThumbsDownIcon_svg.SvgThumbsDownIcon;
    exports.ThumbsUpIcon = icons__ThumbsUpIcon_svg.SvgThumbsUpIcon;
    exports.TipJarIcon = icons__TipJarIcon_svg.SvgTipJarIcon;
    exports.ToggleOffIcon = icons__ToggleOffIcon_svg.SvgToggleOffIcon;
    exports.ToggleOnIcon = icons__ToggleOnIcon_svg.SvgToggleOnIcon;
    exports.TransactionFeeDollarIcon = icons__TransactionFeeDollarIcon_svg.SvgTransactionFeeDollarIcon;
    exports.TransactionFeeEuroIcon = icons__TransactionFeeEuroIcon_svg.SvgTransactionFeeEuroIcon;
    exports.TransactionFeePoundIcon = icons__TransactionFeePoundIcon_svg.SvgTransactionFeePoundIcon;
    exports.TransactionFeeRupeeIcon = icons__TransactionFeeRupeeIcon_svg.SvgTransactionFeeRupeeIcon;
    exports.TransactionFeeYenIcon = icons__TransactionFeeYenIcon_svg.SvgTransactionFeeYenIcon;
    exports.TransactionIcon = icons__TransactionIcon_svg.SvgTransactionIcon;
    exports.TransferIcon = icons__TransferIcon_svg.SvgTransferIcon;
    exports.TransferInIcon = icons__TransferInIcon_svg.SvgTransferInIcon;
    exports.TransferInternalIcon = icons__TransferInternalIcon_svg.SvgTransferInternalIcon;
    exports.TransferOutIcon = icons__TransferOutIcon_svg.SvgTransferOutIcon;
    exports.UndoIcon = icons__UndoIcon_svg.SvgUndoIcon;
    exports.UnknownDeviceIcon = icons__UnknownDeviceIcon_svg.SvgUnknownDeviceIcon;
    exports.UploadIcon = icons__UploadIcon_svg.SvgUploadIcon;
    exports.VariantIcon = icons__VariantIcon_svg.SvgVariantIcon;
    exports.ViewIcon = icons__ViewIcon_svg.SvgViewIcon;
    exports.ViewportNarrowIcon = icons__ViewportNarrowIcon_svg.SvgViewportNarrowIcon;
    exports.ViewportShortIcon = icons__ViewportShortIcon_svg.SvgViewportShortIcon;
    exports.ViewportTallIcon = icons__ViewportTallIcon_svg.SvgViewportTallIcon;
    exports.ViewportWideIcon = icons__ViewportWideIcon_svg.SvgViewportWideIcon;
    exports.WalletFilledIcon = icons__WalletFilledIcon_svg.SvgWalletFilledIcon;
    exports.WalletIcon = icons__WalletIcon_svg.SvgWalletIcon;
    exports.WandIcon = icons__WandIcon_svg.SvgWandIcon;
    exports.WatchIcon = icons__WatchIcon_svg.SvgWatchIcon;
    exports.WifiIcon = icons__WifiIcon_svg.SvgWifiIcon;
    exports.WorkFilledIcon = icons__WorkFilledIcon_svg.SvgWorkFilledIcon;
    exports.WorkIcon = icons__WorkIcon_svg.SvgWorkIcon;
    exports.WrenchIcon = icons__WrenchIcon_svg.SvgWrenchIcon;
    exports.XCircleIcon = icons__XCircleIcon_svg.SvgXCircleIcon;
    exports.XIcon = icons__XIcon_svg.SvgXIcon;
    exports.XSmallIcon = icons__XSmallIcon_svg.SvgXSmallIcon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/is-object.js
var require_is_object = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/is-object.js"(exports) {
    "use strict";
    init_cjs_shims();
    function isObject4(value) {
      let type = typeof value;
      return value != null && (type === "object" || type === "function");
    }
    exports.isObject = isObject4;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/css.js
var require_css = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/css.js"(exports) {
    "use strict";
    init_cjs_shims();
    var polarisTokens = require_build2(), isObject4 = require_is_object();
    function classNames(...classes) {
      return classes.filter(Boolean).join(" ");
    }
    function variationName(name, value) {
      return `${name}${value.charAt(0).toUpperCase()}${value.slice(1)}`;
    }
    function sanitizeCustomProperties(styles) {
      let nonNullValues = Object.entries(styles).filter(([_2, value]) => value != null);
      return nonNullValues.length ? Object.fromEntries(nonNullValues) : void 0;
    }
    function getResponsiveProps(componentName, componentProp, tokenSubgroup, responsiveProp) {
      if (!responsiveProp)
        return {};
      let result;
      return isObject4.isObject(responsiveProp) ? result = Object.fromEntries(Object.entries(responsiveProp).map(([breakpointAlias, aliasOrScale]) => [breakpointAlias, `var(--p-${tokenSubgroup}-${aliasOrScale})`])) : result = {
        [polarisTokens.breakpointsAliases[0]]: `var(--p-${tokenSubgroup}-${responsiveProp})`
      }, Object.fromEntries(Object.entries(result).map(([breakpointAlias, value]) => [`--pc-${componentName}-${componentProp}-${breakpointAlias}`, value]));
    }
    function getResponsiveValue(componentName, componentProp, responsiveProp) {
      return responsiveProp ? isObject4.isObject(responsiveProp) ? Object.fromEntries(Object.entries(responsiveProp).map(([breakpointAlias, responsiveValue]) => [`--pc-${componentName}-${componentProp}-${breakpointAlias}`, responsiveValue])) : {
        [`--pc-${componentName}-${componentProp}-${polarisTokens.breakpointsAliases[0]}`]: responsiveProp
      } : {};
    }
    exports.classNames = classNames;
    exports.getResponsiveProps = getResponsiveProps;
    exports.getResponsiveValue = getResponsiveValue;
    exports.sanitizeCustomProperties = sanitizeCustomProperties;
    exports.variationName = variationName;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/is-element-in-viewport.js
var require_is_element_in_viewport = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/is-element-in-viewport.js"(exports) {
    "use strict";
    init_cjs_shims();
    function isElementInViewport(element) {
      let {
        top,
        left,
        bottom,
        right
      } = element.getBoundingClientRect();
      return top >= 0 && right <= window.innerWidth && bottom <= window.innerHeight && left >= 0;
    }
    exports.isElementInViewport = isElementInViewport;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/focus.js
var require_focus = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/focus.js"(exports) {
    "use strict";
    init_cjs_shims();
    var isElementInViewport = require_is_element_in_viewport(), FOCUSABLE_SELECTOR = 'a,frame,iframe,input:not([type=hidden]):not(:disabled),select:not(:disabled),textarea:not(:disabled),button:not([aria-disabled="true"]):not([tabindex="-1"]):not(:disabled),*[tabindex]', KEYBOARD_FOCUSABLE_SELECTORS = 'a,frame,iframe,input:not([type=hidden]):not(:disabled),select:not(:disabled),textarea:not(:disabled),button:not([aria-disabled="true"]):not([tabindex="-1"]):not(:disabled),*[tabindex]:not([tabindex="-1"])', MENUITEM_FOCUSABLE_SELECTORS = 'a[role="menuitem"],frame[role="menuitem"],iframe[role="menuitem"],input[role="menuitem"]:not([type=hidden]):not(:disabled),select[role="menuitem"]:not(:disabled),textarea[role="menuitem"]:not(:disabled),button[role="menuitem"]:not(:disabled),*[tabindex]:not([tabindex="-1"])', handleMouseUpByBlurring = ({
      currentTarget
    }) => currentTarget.blur();
    function nextFocusableNode(node, filter) {
      let allFocusableElements = [...document.querySelectorAll(FOCUSABLE_SELECTOR)], sliceLocation = allFocusableElements.indexOf(node) + 1, focusableElementsAfterNode = allFocusableElements.slice(sliceLocation);
      for (let focusableElement of focusableElementsAfterNode)
        if (isElementInViewport.isElementInViewport(focusableElement) && (!filter || filter && filter(focusableElement)))
          return focusableElement;
      return null;
    }
    function findFirstFocusableNode(element, onlyDescendants = !0) {
      return !onlyDescendants && matches(element, FOCUSABLE_SELECTOR) ? element : element.querySelector(FOCUSABLE_SELECTOR);
    }
    function findFirstFocusableNodeIncludingDisabled(element) {
      let focusableSelector = "a,button,frame,iframe,input:not([type=hidden]),select,textarea,*[tabindex]";
      return matches(element, focusableSelector) ? element : element.querySelector(focusableSelector);
    }
    function focusFirstFocusableNode(element, onlyDescendants = !0) {
      findFirstFocusableNode(element, onlyDescendants)?.focus();
    }
    function focusNextFocusableNode(node, filter) {
      let nextFocusable = nextFocusableNode(node, filter);
      return nextFocusable && nextFocusable instanceof HTMLElement ? (nextFocusable.focus(), !0) : !1;
    }
    function findFirstKeyboardFocusableNode(element, onlyDescendants = !0) {
      return !onlyDescendants && matches(element, KEYBOARD_FOCUSABLE_SELECTORS) ? element : element.querySelector(KEYBOARD_FOCUSABLE_SELECTORS);
    }
    function focusFirstKeyboardFocusableNode(element, onlyDescendants = !0) {
      let firstFocusable = findFirstKeyboardFocusableNode(element, onlyDescendants);
      return firstFocusable ? (firstFocusable.focus(), !0) : !1;
    }
    function findLastKeyboardFocusableNode(element, onlyDescendants = !0) {
      if (!onlyDescendants && matches(element, KEYBOARD_FOCUSABLE_SELECTORS))
        return element;
      let allFocusable = element.querySelectorAll(KEYBOARD_FOCUSABLE_SELECTORS);
      return allFocusable[allFocusable.length - 1];
    }
    function focusLastKeyboardFocusableNode(element, onlyDescendants = !0) {
      let lastFocusable = findLastKeyboardFocusableNode(element, onlyDescendants);
      return lastFocusable ? (lastFocusable.focus(), !0) : !1;
    }
    function wrapFocusPreviousFocusableMenuItem(parentElement, currentFocusedElement) {
      let allFocusableChildren = getMenuFocusableDescendants(parentElement), currentItemIdx = getCurrentFocusedElementIndex(allFocusableChildren, currentFocusedElement);
      currentItemIdx === -1 ? allFocusableChildren[0].focus() : allFocusableChildren[(currentItemIdx - 1 + allFocusableChildren.length) % allFocusableChildren.length].focus();
    }
    function wrapFocusNextFocusableMenuItem(parentElement, currentFocusedElement) {
      let allFocusableChildren = getMenuFocusableDescendants(parentElement), currentItemIdx = getCurrentFocusedElementIndex(allFocusableChildren, currentFocusedElement);
      currentItemIdx === -1 ? allFocusableChildren[0].focus() : allFocusableChildren[(currentItemIdx + 1) % allFocusableChildren.length].focus();
    }
    function getMenuFocusableDescendants(element) {
      return element.querySelectorAll(MENUITEM_FOCUSABLE_SELECTORS);
    }
    function getCurrentFocusedElementIndex(allFocusableChildren, currentFocusedElement) {
      let currentItemIdx = 0;
      for (let focusableChild of allFocusableChildren) {
        if (focusableChild === currentFocusedElement)
          break;
        currentItemIdx++;
      }
      return currentItemIdx === allFocusableChildren.length ? -1 : currentItemIdx;
    }
    function matches(node, selector) {
      if (node.matches)
        return node.matches(selector);
      let matches2 = (node.ownerDocument || document).querySelectorAll(selector), i = matches2.length;
      for (; --i >= 0 && matches2.item(i) !== node; )
        return i > -1;
    }
    exports.findFirstFocusableNode = findFirstFocusableNode;
    exports.findFirstFocusableNodeIncludingDisabled = findFirstFocusableNodeIncludingDisabled;
    exports.findFirstKeyboardFocusableNode = findFirstKeyboardFocusableNode;
    exports.findLastKeyboardFocusableNode = findLastKeyboardFocusableNode;
    exports.focusFirstFocusableNode = focusFirstFocusableNode;
    exports.focusFirstKeyboardFocusableNode = focusFirstKeyboardFocusableNode;
    exports.focusLastKeyboardFocusableNode = focusLastKeyboardFocusableNode;
    exports.focusNextFocusableNode = focusNextFocusableNode;
    exports.handleMouseUpByBlurring = handleMouseUpByBlurring;
    exports.nextFocusableNode = nextFocusableNode;
    exports.wrapFocusNextFocusableMenuItem = wrapFocusNextFocusableMenuItem;
    exports.wrapFocusPreviousFocusableMenuItem = wrapFocusPreviousFocusableMenuItem;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Button/Button.scss.js
var require_Button_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Button/Button.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Button: "Polaris-Button",
      disabled: "Polaris-Button--disabled",
      pressed: "Polaris-Button--pressed",
      variantPrimary: "Polaris-Button--variantPrimary",
      variantSecondary: "Polaris-Button--variantSecondary",
      variantTertiary: "Polaris-Button--variantTertiary",
      variantPlain: "Polaris-Button--variantPlain",
      variantMonochromePlain: "Polaris-Button--variantMonochromePlain",
      toneSuccess: "Polaris-Button--toneSuccess",
      toneCritical: "Polaris-Button--toneCritical",
      sizeMicro: "Polaris-Button--sizeMicro",
      sizeSlim: "Polaris-Button--sizeSlim",
      sizeMedium: "Polaris-Button--sizeMedium",
      sizeLarge: "Polaris-Button--sizeLarge",
      textAlignCenter: "Polaris-Button--textAlignCenter",
      textAlignStart: "Polaris-Button--textAlignStart",
      textAlignLeft: "Polaris-Button--textAlignLeft",
      textAlignEnd: "Polaris-Button--textAlignEnd",
      textAlignRight: "Polaris-Button--textAlignRight",
      fullWidth: "Polaris-Button--fullWidth",
      iconOnly: "Polaris-Button--iconOnly",
      iconWithText: "Polaris-Button--iconWithText",
      disclosure: "Polaris-Button--disclosure",
      loading: "Polaris-Button--loading",
      pressable: "Polaris-Button--pressable",
      hidden: "Polaris-Button--hidden",
      Icon: "Polaris-Button__Icon",
      Spinner: "Polaris-Button__Spinner"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Icon/Icon.scss.js
var require_Icon_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Icon/Icon.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Icon: "Polaris-Icon",
      toneInherit: "Polaris-Icon--toneInherit",
      toneBase: "Polaris-Icon--toneBase",
      toneSubdued: "Polaris-Icon--toneSubdued",
      toneCaution: "Polaris-Icon--toneCaution",
      toneWarning: "Polaris-Icon--toneWarning",
      toneCritical: "Polaris-Icon--toneCritical",
      toneInteractive: "Polaris-Icon--toneInteractive",
      toneInfo: "Polaris-Icon--toneInfo",
      toneSuccess: "Polaris-Icon--toneSuccess",
      tonePrimary: "Polaris-Icon--tonePrimary",
      toneEmphasis: "Polaris-Icon--toneEmphasis",
      toneMagic: "Polaris-Icon--toneMagic",
      toneTextCaution: "Polaris-Icon--toneTextCaution",
      toneTextWarning: "Polaris-Icon--toneTextWarning",
      toneTextCritical: "Polaris-Icon--toneTextCritical",
      toneTextInfo: "Polaris-Icon--toneTextInfo",
      toneTextPrimary: "Polaris-Icon--toneTextPrimary",
      toneTextSuccess: "Polaris-Icon--toneTextSuccess",
      toneTextMagic: "Polaris-Icon--toneTextMagic",
      Svg: "Polaris-Icon__Svg",
      Img: "Polaris-Icon__Img",
      Placeholder: "Polaris-Icon__Placeholder"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Text/Text.scss.js
var require_Text_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Text/Text.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      root: "Polaris-Text--root",
      block: "Polaris-Text--block",
      truncate: "Polaris-Text--truncate",
      visuallyHidden: "Polaris-Text--visuallyHidden",
      start: "Polaris-Text--start",
      center: "Polaris-Text--center",
      end: "Polaris-Text--end",
      justify: "Polaris-Text--justify",
      success: "Polaris-Text--success",
      critical: "Polaris-Text--critical",
      caution: "Polaris-Text--caution",
      subdued: "Polaris-Text--subdued",
      magic: "Polaris-Text--magic",
      "magic-subdued": "Polaris-Text__magic--subdued",
      "text-inverse": "Polaris-Text__text--inverse",
      headingSm: "Polaris-Text--headingSm",
      headingMd: "Polaris-Text--headingMd",
      headingLg: "Polaris-Text--headingLg",
      headingXl: "Polaris-Text--headingXl",
      heading2xl: "Polaris-Text--heading2xl",
      heading3xl: "Polaris-Text--heading3xl",
      bodyXs: "Polaris-Text--bodyXs",
      bodySm: "Polaris-Text--bodySm",
      bodyMd: "Polaris-Text--bodyMd",
      bodyLg: "Polaris-Text--bodyLg",
      regular: "Polaris-Text--regular",
      medium: "Polaris-Text--medium",
      semibold: "Polaris-Text--semibold",
      bold: "Polaris-Text--bold",
      break: "Polaris-Text--break",
      numeric: "Polaris-Text--numeric",
      "line-through": "Polaris-Text__line--through"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Text/Text.js
var require_Text = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Text/Text.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Text_module = require_Text_scss(), Text4 = ({
      alignment,
      as,
      breakWord,
      children,
      tone,
      fontWeight,
      id,
      numeric = !1,
      truncate = !1,
      variant,
      visuallyHidden = !1,
      textDecorationLine
    }) => {
      let Component = as || (visuallyHidden ? "span" : "p"), className = css.classNames(Text_module.default.root, variant && Text_module.default[variant], fontWeight && Text_module.default[fontWeight], (alignment || truncate) && Text_module.default.block, alignment && Text_module.default[alignment], breakWord && Text_module.default.break, tone && Text_module.default[tone], numeric && Text_module.default.numeric, truncate && Text_module.default.truncate, visuallyHidden && Text_module.default.visuallyHidden, textDecorationLine && Text_module.default[textDecorationLine]);
      return /* @__PURE__ */ React12.createElement(Component, Object.assign({
        className
      }, id && {
        id
      }), children);
    };
    exports.Text = Text4;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Icon/Icon.js
var require_Icon = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Icon/Icon.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Icon_module = require_Icon_scss(), Text4 = require_Text();
    function Icon({
      source,
      tone,
      accessibilityLabel
    }) {
      let sourceType;
      typeof source == "function" ? sourceType = "function" : source === "placeholder" ? sourceType = "placeholder" : sourceType = "external", tone && sourceType === "external" && process.env.NODE_ENV === "development" && console.warn("Recoloring external SVGs is not supported. Set the intended color on your SVG instead.");
      let className = css.classNames(Icon_module.default.Icon, tone && Icon_module.default[css.variationName("tone", tone)]), SourceComponent = source, contentMarkup = {
        function: /* @__PURE__ */ React12.createElement(SourceComponent, {
          className: Icon_module.default.Svg,
          focusable: "false",
          "aria-hidden": "true"
        }),
        placeholder: /* @__PURE__ */ React12.createElement("div", {
          className: Icon_module.default.Placeholder
        }),
        external: /* @__PURE__ */ React12.createElement("img", {
          className: Icon_module.default.Img,
          src: `data:image/svg+xml;utf8,${source}`,
          alt: "",
          "aria-hidden": "true"
        })
      };
      return /* @__PURE__ */ React12.createElement("span", {
        className
      }, accessibilityLabel && /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        visuallyHidden: !0
      }, accessibilityLabel), contentMarkup[sourceType]);
    }
    exports.Icon = Icon;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Spinner/Spinner.scss.js
var require_Spinner_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Spinner/Spinner.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Spinner: "Polaris-Spinner",
      sizeSmall: "Polaris-Spinner--sizeSmall",
      sizeLarge: "Polaris-Spinner--sizeLarge"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Spinner/Spinner.js
var require_Spinner = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Spinner/Spinner.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), useIsAfterInitialMount = require_use_is_after_initial_mount(), Spinner_module = require_Spinner_scss(), Text4 = require_Text();
    function Spinner({
      size = "large",
      accessibilityLabel,
      hasFocusableParent
    }) {
      let isAfterInitialMount = useIsAfterInitialMount.useIsAfterInitialMount(), className = css.classNames(Spinner_module.default.Spinner, size && Spinner_module.default[css.variationName("size", size)]), spinnerSVGMarkup = size === "large" ? /* @__PURE__ */ React12.createElement("svg", {
        viewBox: "0 0 44 44",
        xmlns: "http://www.w3.org/2000/svg"
      }, /* @__PURE__ */ React12.createElement("path", {
        d: "M15.542 1.487A21.507 21.507 0 00.5 22c0 11.874 9.626 21.5 21.5 21.5 9.847 0 18.364-6.675 20.809-16.072a1.5 1.5 0 00-2.904-.756C37.803 34.755 30.473 40.5 22 40.5 11.783 40.5 3.5 32.217 3.5 22c0-8.137 5.3-15.247 12.942-17.65a1.5 1.5 0 10-.9-2.863z"
      })) : /* @__PURE__ */ React12.createElement("svg", {
        viewBox: "0 0 20 20",
        xmlns: "http://www.w3.org/2000/svg"
      }, /* @__PURE__ */ React12.createElement("path", {
        d: "M7.229 1.173a9.25 9.25 0 1011.655 11.412 1.25 1.25 0 10-2.4-.698 6.75 6.75 0 11-8.506-8.329 1.25 1.25 0 10-.75-2.385z"
      })), spanAttributes = {
        ...!hasFocusableParent && {
          role: "status"
        }
      }, accessibilityLabelMarkup = (isAfterInitialMount || !hasFocusableParent) && /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        visuallyHidden: !0
      }, accessibilityLabel);
      return /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement("span", {
        className
      }, spinnerSVGMarkup), /* @__PURE__ */ React12.createElement("span", spanAttributes, accessibilityLabelMarkup));
    }
    exports.Spinner = Spinner;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-disable-interaction.js
var require_use_disable_interaction = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-disable-interaction.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react();
    function useDisableClick(disabled, handleClick) {
      let handleClickWrapper = React12.useCallback((event) => {
        disabled && (event.preventDefault(), event.stopPropagation());
      }, [disabled]);
      return disabled ? handleClickWrapper : handleClick;
    }
    exports.useDisableClick = useDisableClick;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/link/hooks.js
var require_hooks = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/link/hooks.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), context = require_context5();
    function useLink() {
      return React12.useContext(context.LinkContext);
    }
    exports.useLink = useLink;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/UnstyledLink/UnstyledLink.js
var require_UnstyledLink = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/UnstyledLink/UnstyledLink.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), shared = require_shared(), hooks2 = require_hooks(), UnstyledLink = /* @__PURE__ */ React12.memo(/* @__PURE__ */ React12.forwardRef(function(props, _ref) {
      let LinkComponent = hooks2.useLink();
      if (LinkComponent)
        return /* @__PURE__ */ React12.createElement(LinkComponent, Object.assign({}, shared.unstyled.props, props, {
          ref: _ref
        }));
      let {
        external,
        url,
        target: targetProp,
        ...rest
      } = props, target;
      external ? target = "_blank" : target = targetProp ?? void 0;
      let rel = target === "_blank" ? "noopener noreferrer" : void 0;
      return /* @__PURE__ */ React12.createElement("a", Object.assign({
        target
      }, rest, {
        href: url,
        rel
      }, shared.unstyled.props, {
        ref: _ref
      }));
    }));
    exports.UnstyledLink = UnstyledLink;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/UnstyledButton/UnstyledButton.js
var require_UnstyledButton = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/UnstyledButton/UnstyledButton.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), focus = require_focus(), useDisableInteraction = require_use_disable_interaction(), UnstyledLink = require_UnstyledLink();
    function UnstyledButton({
      id,
      children,
      className,
      url,
      external,
      target,
      download,
      submit,
      disabled,
      loading,
      pressed,
      accessibilityLabel,
      role,
      ariaControls,
      ariaExpanded,
      ariaDescribedBy,
      ariaChecked,
      onClick,
      onFocus,
      onBlur,
      onKeyDown,
      onKeyPress,
      onKeyUp,
      onMouseEnter,
      onTouchStart,
      ...rest
    }) {
      let buttonMarkup, commonProps = {
        id,
        className,
        "aria-label": accessibilityLabel
      }, interactiveProps = {
        ...commonProps,
        role,
        onClick,
        onFocus,
        onBlur,
        onMouseUp: focus.handleMouseUpByBlurring,
        onMouseEnter,
        onTouchStart
      }, handleClick = useDisableInteraction.useDisableClick(disabled, onClick);
      return url ? buttonMarkup = disabled ? (
        // Render an `<a>` so toggling disabled/enabled state changes only the
        // `href` attribute instead of replacing the whole element.
        /* @__PURE__ */ React12.createElement("a", commonProps, children)
      ) : /* @__PURE__ */ React12.createElement(UnstyledLink.UnstyledLink, Object.assign({}, interactiveProps, {
        url,
        external,
        target,
        download
      }, rest), children) : buttonMarkup = /* @__PURE__ */ React12.createElement("button", Object.assign({}, interactiveProps, {
        "aria-disabled": disabled,
        type: submit ? "submit" : "button",
        "aria-busy": loading ? !0 : void 0,
        "aria-controls": ariaControls,
        "aria-expanded": ariaExpanded,
        "aria-describedby": ariaDescribedBy,
        "aria-checked": ariaChecked,
        "aria-pressed": pressed,
        onKeyDown,
        onKeyUp,
        onKeyPress,
        onClick: handleClick,
        tabIndex: disabled ? -1 : void 0
      }, rest), children), buttonMarkup;
    }
    exports.UnstyledButton = UnstyledButton;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/errors.js
var require_errors6 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/errors.js"(exports) {
    "use strict";
    init_cjs_shims();
    var MissingAppProviderError = class extends Error {
      constructor(message = "") {
        super(`${message && `${message} `}Your application must be wrapped in an <AppProvider> component. See https://polaris.shopify.com/components/app-provider for implementation instructions.`), this.name = "MissingAppProviderError";
      }
    };
    exports.MissingAppProviderError = MissingAppProviderError;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/i18n/hooks.js
var require_hooks2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/i18n/hooks.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), errors2 = require_errors6(), context = require_context2();
    function useI18n() {
      let i18n = React12.useContext(context.I18nContext);
      if (!i18n)
        throw new errors2.MissingAppProviderError("No i18n was provided.");
      return i18n;
    }
    exports.useI18n = useI18n;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Button/Button.js
var require_Button = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Button/Button.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), focus = require_focus(), Button_module = require_Button_scss(), Icon = require_Icon(), Spinner = require_Spinner(), UnstyledButton = require_UnstyledButton(), hooks2 = require_hooks2();
    function Button2({
      id,
      children,
      url,
      disabled,
      external,
      download,
      target,
      submit,
      loading,
      pressed,
      accessibilityLabel,
      role,
      ariaControls,
      ariaExpanded,
      ariaDescribedBy,
      ariaChecked,
      onClick,
      onFocus,
      onBlur,
      onKeyDown,
      onKeyPress,
      onKeyUp,
      onMouseEnter,
      onTouchStart,
      onPointerDown,
      icon,
      disclosure,
      removeUnderline,
      size = "medium",
      textAlign = "center",
      fullWidth,
      dataPrimaryLink,
      tone,
      variant = "secondary"
    }) {
      let i18n = hooks2.useI18n(), isDisabled = disabled || loading, className = css.classNames(Button_module.default.Button, Button_module.default.pressable, Button_module.default[css.variationName("variant", variant)], Button_module.default[css.variationName("size", size)], Button_module.default[css.variationName("textAlign", textAlign)], fullWidth && Button_module.default.fullWidth, disclosure && Button_module.default.disclosure, icon && children && Button_module.default.iconWithText, icon && children == null && Button_module.default.iconOnly, isDisabled && Button_module.default.disabled, loading && Button_module.default.loading, pressed && !disabled && !url && Button_module.default.pressed, removeUnderline && Button_module.default.removeUnderline, tone && Button_module.default[css.variationName("tone", tone)]), disclosureMarkup = disclosure ? /* @__PURE__ */ React12.createElement("span", {
        className: loading ? Button_module.default.hidden : Button_module.default.Icon
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: loading ? "placeholder" : getDisclosureIconSource(disclosure, polarisIcons.ChevronUpIcon, polarisIcons.ChevronDownIcon)
      })) : null, iconSource = isIconSource(icon) ? /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: loading ? "placeholder" : icon
      }) : icon, iconMarkup = iconSource ? /* @__PURE__ */ React12.createElement("span", {
        className: loading ? Button_module.default.hidden : Button_module.default.Icon
      }, iconSource) : null, childMarkup = children ? /* @__PURE__ */ React12.createElement("span", {
        className: removeUnderline ? Button_module.default.removeUnderline : "",
        key: disabled ? "text-disabled" : "text"
      }, children) : null, spinnerSVGMarkup = loading ? /* @__PURE__ */ React12.createElement("span", {
        className: Button_module.default.Spinner
      }, /* @__PURE__ */ React12.createElement(Spinner.Spinner, {
        size: "small",
        accessibilityLabel: i18n.translate("Polaris.Button.spinnerAccessibilityLabel")
      })) : null, commonProps = {
        id,
        className,
        accessibilityLabel,
        ariaDescribedBy,
        role,
        onClick,
        onFocus,
        onBlur,
        onMouseUp: focus.handleMouseUpByBlurring,
        onMouseEnter,
        onTouchStart,
        "data-primary-link": dataPrimaryLink
      }, linkProps = {
        url,
        external,
        download,
        target
      }, actionProps = {
        submit,
        disabled: isDisabled,
        loading,
        ariaControls,
        ariaExpanded,
        ariaChecked,
        pressed,
        onKeyDown,
        onKeyUp,
        onKeyPress,
        onPointerDown
      };
      return /* @__PURE__ */ React12.createElement(UnstyledButton.UnstyledButton, Object.assign({}, commonProps, linkProps, actionProps), spinnerSVGMarkup, iconMarkup, childMarkup, disclosureMarkup);
    }
    function isIconSource(x) {
      return typeof x == "string" || typeof x == "object" && x.body || typeof x == "function";
    }
    function getDisclosureIconSource(disclosure, upIcon, downIcon) {
      return disclosure === "select" ? polarisIcons.SelectIcon : disclosure === "up" ? upIcon : downIcon;
    }
    exports.Button = Button2;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Button/utils.js
var require_utils10 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Button/utils.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), Button2 = require_Button();
    function buttonsFrom(actions, overrides = {}) {
      return Array.isArray(actions) ? actions.map((action, index) => buttonFrom(action, overrides, index)) : buttonFrom(actions, overrides);
    }
    function buttonFrom({
      content,
      onAction,
      plain,
      destructive,
      ...action
    }, overrides, key) {
      let plainVariant = plain ? "plain" : void 0, destructiveVariant = destructive ? "primary" : void 0, tone = !overrides?.tone && destructive ? "critical" : overrides?.tone;
      return /* @__PURE__ */ React12.createElement(Button2.Button, Object.assign({
        key,
        onClick: onAction,
        tone,
        variant: plainVariant || destructiveVariant
      }, action, overrides), content);
    }
    exports.buttonFrom = buttonFrom;
    exports.buttonsFrom = buttonsFrom;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ShadowBevel/ShadowBevel.scss.js
var require_ShadowBevel_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ShadowBevel/ShadowBevel.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      ShadowBevel: "Polaris-ShadowBevel"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ShadowBevel/ShadowBevel.js
var require_ShadowBevel = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ShadowBevel/ShadowBevel.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), ShadowBevel_module = require_ShadowBevel_scss();
    function ShadowBevel(props) {
      let {
        as = "div",
        bevel = !0,
        borderRadius,
        boxShadow,
        children,
        zIndex = "0"
      } = props, Component = as;
      return /* @__PURE__ */ React12.createElement(Component, {
        className: ShadowBevel_module.default.ShadowBevel,
        style: {
          "--pc-shadow-bevel-z-index": zIndex,
          ...css.getResponsiveValue("shadow-bevel", "content", mapResponsiveProp(bevel, (bevel2) => bevel2 ? '""' : "none")),
          ...css.getResponsiveValue("shadow-bevel", "box-shadow", mapResponsiveProp(bevel, (bevel2) => bevel2 ? `var(--p-shadow-${boxShadow})` : "none")),
          ...css.getResponsiveValue("shadow-bevel", "border-radius", mapResponsiveProp(bevel, (bevel2) => bevel2 ? `var(--p-border-radius-${borderRadius})` : "var(--p-border-radius-0)"))
        }
      }, children);
    }
    function mapResponsiveProp(responsiveProp, callback) {
      return typeof responsiveProp == "boolean" ? callback(responsiveProp) : Object.fromEntries(Object.entries(responsiveProp).map(([breakpointsAlias, value]) => [breakpointsAlias, callback(value)]));
    }
    exports.ShadowBevel = ShadowBevel;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Box/Box.scss.js
var require_Box_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Box/Box.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      listReset: "Polaris-Box--listReset",
      Box: "Polaris-Box",
      visuallyHidden: "Polaris-Box--visuallyHidden",
      printHidden: "Polaris-Box--printHidden"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Box/Box.js
var require_Box = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Box/Box.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Box_module = require_Box_scss(), Box2 = /* @__PURE__ */ React12.forwardRef(({
      as = "div",
      background,
      borderColor,
      borderStyle,
      borderWidth,
      borderBlockStartWidth,
      borderBlockEndWidth,
      borderInlineStartWidth,
      borderInlineEndWidth,
      borderRadius,
      borderEndStartRadius,
      borderEndEndRadius,
      borderStartStartRadius,
      borderStartEndRadius,
      children,
      color,
      id,
      minHeight,
      minWidth,
      maxWidth,
      overflowX,
      overflowY,
      outlineColor,
      outlineStyle,
      outlineWidth,
      padding,
      paddingBlock,
      paddingBlockStart,
      paddingBlockEnd,
      paddingInline,
      paddingInlineStart,
      paddingInlineEnd,
      role,
      shadow,
      tabIndex,
      width,
      printHidden,
      visuallyHidden,
      position,
      insetBlockStart,
      insetBlockEnd,
      insetInlineStart,
      insetInlineEnd,
      zIndex,
      opacity,
      ...restProps
    }, ref) => {
      let borderStyleValue = borderStyle || (borderColor || borderWidth || borderBlockStartWidth || borderBlockEndWidth || borderInlineStartWidth || borderInlineEndWidth ? "solid" : void 0), outlineStyleValue = outlineStyle || (outlineColor || outlineWidth ? "solid" : void 0), style = {
        "--pc-box-color": color ? `var(--p-color-${color})` : void 0,
        "--pc-box-background": background ? `var(--p-color-${background})` : void 0,
        // eslint-disable-next-line no-nested-ternary
        "--pc-box-border-color": borderColor ? borderColor === "transparent" ? "transparent" : `var(--p-color-${borderColor})` : void 0,
        "--pc-box-border-style": borderStyleValue,
        "--pc-box-border-radius": borderRadius ? `var(--p-border-radius-${borderRadius})` : void 0,
        "--pc-box-border-end-start-radius": borderEndStartRadius ? `var(--p-border-radius-${borderEndStartRadius})` : void 0,
        "--pc-box-border-end-end-radius": borderEndEndRadius ? `var(--p-border-radius-${borderEndEndRadius})` : void 0,
        "--pc-box-border-start-start-radius": borderStartStartRadius ? `var(--p-border-radius-${borderStartStartRadius})` : void 0,
        "--pc-box-border-start-end-radius": borderStartEndRadius ? `var(--p-border-radius-${borderStartEndRadius})` : void 0,
        "--pc-box-border-width": borderWidth ? `var(--p-border-width-${borderWidth})` : void 0,
        "--pc-box-border-block-start-width": borderBlockStartWidth ? `var(--p-border-width-${borderBlockStartWidth})` : void 0,
        "--pc-box-border-block-end-width": borderBlockEndWidth ? `var(--p-border-width-${borderBlockEndWidth})` : void 0,
        "--pc-box-border-inline-start-width": borderInlineStartWidth ? `var(--p-border-width-${borderInlineStartWidth})` : void 0,
        "--pc-box-border-inline-end-width": borderInlineEndWidth ? `var(--p-border-width-${borderInlineEndWidth})` : void 0,
        "--pc-box-min-height": minHeight,
        "--pc-box-min-width": minWidth,
        "--pc-box-max-width": maxWidth,
        "--pc-box-outline-color": outlineColor ? `var(--p-color-${outlineColor})` : void 0,
        "--pc-box-outline-style": outlineStyleValue,
        "--pc-box-outline-width": outlineWidth ? `var(--p-border-width-${outlineWidth})` : void 0,
        "--pc-box-overflow-x": overflowX,
        "--pc-box-overflow-y": overflowY,
        ...css.getResponsiveProps("box", "padding-block-start", "space", paddingBlockStart || paddingBlock || padding),
        ...css.getResponsiveProps("box", "padding-block-end", "space", paddingBlockEnd || paddingBlock || padding),
        ...css.getResponsiveProps("box", "padding-inline-start", "space", paddingInlineStart || paddingInline || padding),
        ...css.getResponsiveProps("box", "padding-inline-end", "space", paddingInlineEnd || paddingInline || padding),
        "--pc-box-shadow": shadow ? `var(--p-shadow-${shadow})` : void 0,
        "--pc-box-width": width,
        position,
        "--pc-box-inset-block-start": insetBlockStart ? `var(--p-space-${insetBlockStart})` : void 0,
        "--pc-box-inset-block-end": insetBlockEnd ? `var(--p-space-${insetBlockEnd})` : void 0,
        "--pc-box-inset-inline-start": insetInlineStart ? `var(--p-space-${insetInlineStart})` : void 0,
        "--pc-box-inset-inline-end": insetInlineEnd ? `var(--p-space-${insetInlineEnd})` : void 0,
        zIndex,
        opacity
      }, className = css.classNames(Box_module.default.Box, visuallyHidden && Box_module.default.visuallyHidden, printHidden && Box_module.default.printHidden, as === "ul" && Box_module.default.listReset);
      return /* @__PURE__ */ React12.createElement(as, {
        className,
        id,
        ref,
        style: css.sanitizeCustomProperties(style),
        role,
        tabIndex,
        ...restProps
      }, children);
    });
    Box2.displayName = "Box";
    exports.Box = Box2;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Card/Card.js
var require_Card = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Card/Card.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), breakpoints = require_breakpoints2(), withinContentContext = require_within_content_context(), ShadowBevel = require_ShadowBevel(), Box2 = require_Box(), Card2 = ({
      children,
      background = "bg-surface",
      padding = {
        xs: "400"
      },
      roundedAbove = "sm"
    }) => {
      let breakpoints$1 = breakpoints.useBreakpoints(), defaultBorderRadius = "300", hasBorderRadius = !!breakpoints$1[`${roundedAbove}Up`];
      return /* @__PURE__ */ React12.createElement(withinContentContext.WithinContentContext.Provider, {
        value: !0
      }, /* @__PURE__ */ React12.createElement(ShadowBevel.ShadowBevel, {
        boxShadow: "100",
        borderRadius: hasBorderRadius ? defaultBorderRadius : "0",
        zIndex: "32"
      }, /* @__PURE__ */ React12.createElement(Box2.Box, {
        background,
        padding,
        overflowX: "hidden",
        overflowY: "hidden",
        minHeight: "100%"
      }, children)));
    };
    exports.Card = Card2;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SettingAction/SettingAction.scss.js
var require_SettingAction_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SettingAction/SettingAction.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      SettingAction: "Polaris-SettingAction",
      Setting: "Polaris-SettingAction__Setting",
      Action: "Polaris-SettingAction__Action"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SettingAction/SettingAction.js
var require_SettingAction = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SettingAction/SettingAction.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), SettingAction_module = require_SettingAction_scss();
    function SettingAction({
      action,
      children
    }) {
      return /* @__PURE__ */ React12.createElement("div", {
        className: SettingAction_module.default.SettingAction
      }, /* @__PURE__ */ React12.createElement("div", {
        className: SettingAction_module.default.Setting
      }, children), /* @__PURE__ */ React12.createElement("div", {
        className: SettingAction_module.default.Action
      }, action));
    }
    exports.SettingAction = SettingAction;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/InlineStack/InlineStack.scss.js
var require_InlineStack_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/InlineStack/InlineStack.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      InlineStack: "Polaris-InlineStack"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/InlineStack/InlineStack.js
var require_InlineStack = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/InlineStack/InlineStack.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), InlineStack_module = require_InlineStack_scss(), InlineStack2 = function({
      as: Element2 = "div",
      align,
      blockAlign,
      gap,
      wrap = !0,
      children
    }) {
      let style = {
        "--pc-inline-stack-align": align,
        "--pc-inline-stack-block-align": blockAlign,
        "--pc-inline-stack-wrap": wrap ? "wrap" : "nowrap",
        ...css.getResponsiveProps("inline-stack", "gap", "space", gap)
      };
      return /* @__PURE__ */ React12.createElement(Element2, {
        className: InlineStack_module.default.InlineStack,
        style
      }, children);
    };
    exports.InlineStack = InlineStack2;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/BlockStack/BlockStack.scss.js
var require_BlockStack_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/BlockStack/BlockStack.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      BlockStack: "Polaris-BlockStack",
      listReset: "Polaris-BlockStack--listReset",
      fieldsetReset: "Polaris-BlockStack--fieldsetReset"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/BlockStack/BlockStack.js
var require_BlockStack = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/BlockStack/BlockStack.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), BlockStack_module = require_BlockStack_scss(), BlockStack3 = ({
      as = "div",
      children,
      align,
      inlineAlign,
      gap,
      id,
      reverseOrder = !1,
      ...restProps
    }) => {
      let className = css.classNames(BlockStack_module.default.BlockStack, (as === "ul" || as === "ol") && BlockStack_module.default.listReset, as === "fieldset" && BlockStack_module.default.fieldsetReset), style = {
        "--pc-block-stack-align": align ? `${align}` : null,
        "--pc-block-stack-inline-align": inlineAlign ? `${inlineAlign}` : null,
        "--pc-block-stack-order": reverseOrder ? "column-reverse" : "column",
        ...css.getResponsiveProps("block-stack", "gap", "space", gap)
      };
      return /* @__PURE__ */ React12.createElement(as, {
        className,
        style: css.sanitizeCustomProperties(style),
        ...restProps
      }, children);
    };
    exports.BlockStack = BlockStack3;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Avatar/Avatar.scss.js
var require_Avatar_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Avatar/Avatar.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Avatar: "Polaris-Avatar",
      imageHasLoaded: "Polaris-Avatar--imageHasLoaded",
      Text: "Polaris-Avatar__Text",
      long: "Polaris-Avatar--long",
      hidden: "Polaris-Avatar--hidden",
      sizeXs: "Polaris-Avatar--sizeXs",
      sizeSm: "Polaris-Avatar--sizeSm",
      sizeMd: "Polaris-Avatar--sizeMd",
      sizeLg: "Polaris-Avatar--sizeLg",
      sizeXl: "Polaris-Avatar--sizeXl",
      styleOne: "Polaris-Avatar--styleOne",
      styleTwo: "Polaris-Avatar--styleTwo",
      styleThree: "Polaris-Avatar--styleThree",
      styleFour: "Polaris-Avatar--styleFour",
      styleFive: "Polaris-Avatar--styleFive",
      styleSix: "Polaris-Avatar--styleSix",
      styleSeven: "Polaris-Avatar--styleSeven",
      Image: "Polaris-Avatar__Image",
      Initials: "Polaris-Avatar__Initials",
      Svg: "Polaris-Avatar__Svg"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Image/Image.js
var require_Image = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Image/Image.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react();
    function Image({
      alt,
      sourceSet,
      source,
      crossOrigin,
      onLoad,
      className,
      ...rest
    }) {
      let finalSourceSet = sourceSet ? sourceSet.map(({
        source: subSource,
        descriptor
      }) => `${subSource} ${descriptor}`).join(",") : null, handleLoad = React12.useCallback(() => {
        onLoad && onLoad();
      }, [onLoad]);
      return /* @__PURE__ */ React12.createElement("img", Object.assign({
        alt,
        src: source,
        crossOrigin,
        className,
        onLoad: handleLoad
      }, finalSourceSet ? {
        srcSet: finalSourceSet
      } : {}, rest));
    }
    exports.Image = Image;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Avatar/Avatar.js
var require_Avatar = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Avatar/Avatar.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), useIsAfterInitialMount = require_use_is_after_initial_mount(), Avatar_module = require_Avatar_scss(), hooks2 = require_hooks2(), Image = require_Image(), Status2;
    (function(Status3) {
      Status3.Pending = "PENDING", Status3.Loaded = "LOADED", Status3.Errored = "ERRORED";
    })(Status2 || (Status2 = {}));
    var STYLE_CLASSES = ["one", "two", "three", "four", "five", "six", "seven"], avatarStrokeWidth = {
      xs: "3",
      sm: "2.5",
      md: "2.5",
      lg: "2.5",
      xl: "2"
    };
    function xorHash(str) {
      let hash = 0;
      for (let char of str)
        hash ^= char.charCodeAt(0);
      return hash;
    }
    function styleClass(name) {
      return name ? STYLE_CLASSES[xorHash(name) % STYLE_CLASSES.length] : STYLE_CLASSES[0];
    }
    function Avatar({
      name,
      source,
      onError,
      initials,
      customer,
      size = "md",
      accessibilityLabel
    }) {
      let i18n = hooks2.useI18n(), isAfterInitialMount = useIsAfterInitialMount.useIsAfterInitialMount(), [status, setStatus] = React12.useState(Status2.Pending);
      React12.useEffect(() => {
        setStatus(Status2.Pending);
      }, [source]);
      let handleError = React12.useCallback(() => {
        setStatus(Status2.Errored), onError && onError();
      }, [onError]), handleLoad = React12.useCallback(() => {
        setStatus(Status2.Loaded);
      }, []), hasImage = source && status !== Status2.Errored, nameString = name || initials, label;
      if (accessibilityLabel)
        label = accessibilityLabel;
      else if (name)
        label = name;
      else if (initials) {
        let splitInitials = initials.split("").join(" ");
        label = i18n.translate("Polaris.Avatar.labelWithInitials", {
          initials: splitInitials
        });
      }
      let className = css.classNames(Avatar_module.default.Avatar, size && Avatar_module.default[css.variationName("size", size)], hasImage && status === Status2.Loaded && Avatar_module.default.imageHasLoaded, !customer && !hasImage && Avatar_module.default[css.variationName("style", styleClass(nameString))]), textClassName = css.classNames(Avatar_module.default.Text, (initials?.length || 0) > 2 && Avatar_module.default.long), imageClassName = css.classNames(Avatar_module.default.Image, status !== Status2.Loaded && Avatar_module.default.hidden), imageMarkUp = source && isAfterInitialMount && status !== Status2.Errored ? /* @__PURE__ */ React12.createElement(Image.Image, {
        className: imageClassName,
        source,
        alt: "",
        role: "presentation",
        onLoad: handleLoad,
        onError: handleError
      }) : null, verticalOffset = "0.35em", avatarPath = /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement("path", {
        fill: "none",
        d: "M25.5 13.5C25.5 16.5376 23.0376 19 20 19C16.9624 19 14.5 16.5376 14.5 13.5C14.5 10.4624 16.9624 8 20 8C23.0376 8 25.5 10.4624 25.5 13.5Z",
        stroke: "currentColor",
        strokeWidth: avatarStrokeWidth[size]
      }), /* @__PURE__ */ React12.createElement("path", {
        fill: "none",
        d: "M10.3433 29.682L9.47 31.254C9.03481 32.0373 9.60125 33 10.4974 33H29.5026C30.3988 33 30.9652 32.0373 30.53 31.254L29.6567 29.682C27.7084 26.175 24.0119 24 20 24C15.9882 24 12.2916 26.175 10.3433 29.682Z",
        stroke: "currentColor",
        strokeWidth: avatarStrokeWidth[size],
        strokeLinecap: "round",
        strokeLinejoin: "round"
      })), avatarBody = customer || !initials ? avatarPath : /* @__PURE__ */ React12.createElement("text", {
        className: textClassName,
        x: "50%",
        y: "50%",
        dy: verticalOffset,
        fill: "currentColor",
        textAnchor: "middle"
      }, initials), svgMarkup = hasImage ? null : /* @__PURE__ */ React12.createElement("span", {
        className: Avatar_module.default.Initials
      }, /* @__PURE__ */ React12.createElement("svg", {
        className: Avatar_module.default.Svg,
        viewBox: "0 0 40 40"
      }, avatarBody));
      return /* @__PURE__ */ React12.createElement("span", {
        "aria-label": label,
        role: label ? "img" : "presentation",
        className
      }, svgMarkup, imageMarkUp);
    }
    exports.Avatar = Avatar;
    exports.STYLE_CLASSES = STYLE_CLASSES;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/AccountConnection/AccountConnection.js
var require_AccountConnection = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/AccountConnection/AccountConnection.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), breakpoints = require_breakpoints2(), utils = require_utils10(), Card2 = require_Card(), SettingAction = require_SettingAction(), InlineStack2 = require_InlineStack(), BlockStack3 = require_BlockStack(), Avatar = require_Avatar(), Box2 = require_Box(), Text4 = require_Text();
    function AccountConnection({
      connected = !1,
      action,
      avatarUrl,
      accountName = "",
      title,
      details,
      termsOfService
    }) {
      let breakpoints$1 = breakpoints.useBreakpoints(), initials = accountName ? accountName.split(/\s+/).map((name) => name[0]).join("") : void 0, avatarMarkup = connected ? /* @__PURE__ */ React12.createElement("span", null, /* @__PURE__ */ React12.createElement(Avatar.Avatar, {
        accessibilityLabel: "",
        name: accountName,
        initials,
        source: avatarUrl
      })) : null, titleContent = title || accountName, titleMarkup = /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "h2",
        variant: "headingSm"
      }, titleContent), detailsMarkup = details ? /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        tone: "subdued"
      }, details) : null, termsOfServiceMarkup = termsOfService ? /* @__PURE__ */ React12.createElement(Box2.Box, {
        paddingBlockStart: breakpoints$1.mdUp ? "400" : "500"
      }, termsOfService) : null, actionElement = action ? utils.buttonFrom(action, {
        variant: connected ? void 0 : "primary"
      }) : null;
      return /* @__PURE__ */ React12.createElement(Card2.Card, null, /* @__PURE__ */ React12.createElement(SettingAction.SettingAction, {
        action: actionElement
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "400"
      }, avatarMarkup, /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
        gap: "100"
      }, titleMarkup, detailsMarkup))), termsOfServiceMarkup);
    }
    exports.AccountConnection = AccountConnection;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FilterActionsProvider/FilterActionsProvider.js
var require_FilterActionsProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FilterActionsProvider/FilterActionsProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), FilterActionsContext = /* @__PURE__ */ React12.createContext(!1);
    function FilterActionsProvider({
      children,
      filterActions
    }) {
      return /* @__PURE__ */ React12.createElement(FilterActionsContext.Provider, {
        value: filterActions
      }, children);
    }
    exports.FilterActionsContext = FilterActionsContext;
    exports.FilterActionsProvider = FilterActionsProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionList/ActionList.scss.js
var require_ActionList_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionList/ActionList.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Item: "Polaris-ActionList__Item",
      default: "Polaris-ActionList--default",
      active: "Polaris-ActionList--active",
      destructive: "Polaris-ActionList--destructive",
      disabled: "Polaris-ActionList--disabled",
      Prefix: "Polaris-ActionList__Prefix",
      Suffix: "Polaris-ActionList__Suffix",
      indented: "Polaris-ActionList--indented",
      menu: "Polaris-ActionList--menu",
      Text: "Polaris-ActionList__Text"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/within-filter-context.js
var require_within_filter_context = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/within-filter-context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), WithinFilterContext = /* @__PURE__ */ React12.createContext(!1);
    exports.WithinFilterContext = WithinFilterContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Badge/Badge.scss.js
var require_Badge_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Badge/Badge.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Badge: "Polaris-Badge",
      toneSuccess: "Polaris-Badge--toneSuccess",
      "toneSuccess-strong": "Polaris-Badge__toneSuccess--strong",
      toneInfo: "Polaris-Badge--toneInfo",
      "toneInfo-strong": "Polaris-Badge__toneInfo--strong",
      toneAttention: "Polaris-Badge--toneAttention",
      "toneAttention-strong": "Polaris-Badge__toneAttention--strong",
      toneWarning: "Polaris-Badge--toneWarning",
      "toneWarning-strong": "Polaris-Badge__toneWarning--strong",
      toneCritical: "Polaris-Badge--toneCritical",
      "toneCritical-strong": "Polaris-Badge__toneCritical--strong",
      toneNew: "Polaris-Badge--toneNew",
      toneMagic: "Polaris-Badge--toneMagic",
      "toneRead-only": "Polaris-Badge__toneRead--only",
      toneEnabled: "Polaris-Badge--toneEnabled",
      sizeLarge: "Polaris-Badge--sizeLarge",
      withinFilter: "Polaris-Badge--withinFilter",
      Icon: "Polaris-Badge__Icon",
      PipContainer: "Polaris-Badge__PipContainer"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Badge/types.js
var require_types8 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Badge/types.js"(exports) {
    "use strict";
    init_cjs_shims();
    exports.ToneValue = void 0;
    (function(ToneValue) {
      ToneValue.Info = "info", ToneValue.Success = "success", ToneValue.Warning = "warning", ToneValue.Critical = "critical", ToneValue.Attention = "attention", ToneValue.New = "new", ToneValue.Magic = "magic", ToneValue.InfoStrong = "info-strong", ToneValue.SuccessStrong = "success-strong", ToneValue.WarningStrong = "warning-strong", ToneValue.CriticalStrong = "critical-strong", ToneValue.AttentionStrong = "attention-strong", ToneValue.ReadOnly = "read-only", ToneValue.Enabled = "enabled";
    })(exports.ToneValue || (exports.ToneValue = {}));
    exports.ProgressValue = void 0;
    (function(ProgressValue) {
      ProgressValue.Incomplete = "incomplete", ProgressValue.PartiallyComplete = "partiallyComplete", ProgressValue.Complete = "complete";
    })(exports.ProgressValue || (exports.ProgressValue = {}));
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Badge/utils.js
var require_utils11 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Badge/utils.js"(exports) {
    "use strict";
    init_cjs_shims();
    var types = require_types8();
    function getDefaultAccessibilityLabel(i18n, progress, tone) {
      let progressLabel = "", toneLabel = "";
      if (!progress && !tone)
        return "";
      switch (progress) {
        case types.ProgressValue.Incomplete:
          progressLabel = i18n.translate("Polaris.Badge.PROGRESS_LABELS.incomplete");
          break;
        case types.ProgressValue.PartiallyComplete:
          progressLabel = i18n.translate("Polaris.Badge.PROGRESS_LABELS.partiallyComplete");
          break;
        case types.ProgressValue.Complete:
          progressLabel = i18n.translate("Polaris.Badge.PROGRESS_LABELS.complete");
          break;
      }
      switch (tone) {
        case types.ToneValue.Info:
        case types.ToneValue.InfoStrong:
          toneLabel = i18n.translate("Polaris.Badge.TONE_LABELS.info");
          break;
        case types.ToneValue.Success:
        case types.ToneValue.SuccessStrong:
          toneLabel = i18n.translate("Polaris.Badge.TONE_LABELS.success");
          break;
        case types.ToneValue.Warning:
        case types.ToneValue.WarningStrong:
          toneLabel = i18n.translate("Polaris.Badge.TONE_LABELS.warning");
          break;
        case types.ToneValue.Critical:
        case types.ToneValue.CriticalStrong:
          toneLabel = i18n.translate("Polaris.Badge.TONE_LABELS.critical");
          break;
        case types.ToneValue.Attention:
        case types.ToneValue.AttentionStrong:
          toneLabel = i18n.translate("Polaris.Badge.TONE_LABELS.attention");
          break;
        case types.ToneValue.New:
          toneLabel = i18n.translate("Polaris.Badge.TONE_LABELS.new");
          break;
        case types.ToneValue.ReadOnly:
          toneLabel = i18n.translate("Polaris.Badge.TONE_LABELS.readOnly");
          break;
        case types.ToneValue.Enabled:
          toneLabel = i18n.translate("Polaris.Badge.TONE_LABELS.enabled");
          break;
      }
      return !tone && progress ? progressLabel : tone && !progress ? toneLabel : i18n.translate("Polaris.Badge.progressAndTone", {
        progressLabel,
        toneLabel
      });
    }
    exports.getDefaultAccessibilityLabel = getDefaultAccessibilityLabel;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Badge/components/Pip/Pip.scss.js
var require_Pip_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Badge/components/Pip/Pip.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Pip: "Polaris-Badge-Pip",
      toneInfo: "Polaris-Badge-Pip--toneInfo",
      toneSuccess: "Polaris-Badge-Pip--toneSuccess",
      toneNew: "Polaris-Badge-Pip--toneNew",
      toneAttention: "Polaris-Badge-Pip--toneAttention",
      toneWarning: "Polaris-Badge-Pip--toneWarning",
      toneCritical: "Polaris-Badge-Pip--toneCritical",
      progressIncomplete: "Polaris-Badge-Pip--progressIncomplete",
      progressPartiallyComplete: "Polaris-Badge-Pip--progressPartiallyComplete",
      progressComplete: "Polaris-Badge-Pip--progressComplete"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Badge/components/Pip/Pip.js
var require_Pip = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Badge/components/Pip/Pip.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), utils = require_utils11(), Pip_module = require_Pip_scss(), hooks2 = require_hooks2(), Text4 = require_Text();
    function Pip({
      tone,
      progress = "complete",
      accessibilityLabelOverride
    }) {
      let i18n = hooks2.useI18n(), className = css.classNames(Pip_module.default.Pip, tone && Pip_module.default[css.variationName("tone", tone)], progress && Pip_module.default[css.variationName("progress", progress)]), accessibilityLabel = accessibilityLabelOverride || utils.getDefaultAccessibilityLabel(i18n, progress, tone);
      return /* @__PURE__ */ React12.createElement("span", {
        className
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        visuallyHidden: !0
      }, accessibilityLabel));
    }
    exports.Pip = Pip;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Badge/Badge.js
var require_Badge = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Badge/Badge.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), withinFilterContext = require_within_filter_context(), Badge_module = require_Badge_scss(), utils = require_utils11(), Pip = require_Pip(), hooks2 = require_hooks2(), Icon = require_Icon(), Text4 = require_Text(), DEFAULT_SIZE = "medium", progressIconMap = {
      complete: () => /* @__PURE__ */ React12.createElement("svg", {
        viewBox: "0 0 20 20"
      }, /* @__PURE__ */ React12.createElement("path", {
        d: "M6 10c0-.93 0-1.395.102-1.776a3 3 0 0 1 2.121-2.122C8.605 6 9.07 6 10 6c.93 0 1.395 0 1.776.102a3 3 0 0 1 2.122 2.122C14 8.605 14 9.07 14 10s0 1.395-.102 1.777a3 3 0 0 1-2.122 2.12C11.395 14 10.93 14 10 14s-1.395 0-1.777-.102a3 3 0 0 1-2.12-2.121C6 11.395 6 10.93 6 10Z"
      })),
      partiallyComplete: () => /* @__PURE__ */ React12.createElement("svg", {
        viewBox: "0 0 20 20"
      }, /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "m8.888 6.014-.017-.018-.02.02c-.253.013-.45.038-.628.086a3 3 0 0 0-2.12 2.122C6 8.605 6 9.07 6 10s0 1.395.102 1.777a3 3 0 0 0 2.121 2.12C8.605 14 9.07 14 10 14c.93 0 1.395 0 1.776-.102a3 3 0 0 0 2.122-2.121C14 11.395 14 10.93 14 10c0-.93 0-1.395-.102-1.776a3 3 0 0 0-2.122-2.122C11.395 6 10.93 6 10 6c-.475 0-.829 0-1.112.014ZM8.446 7.34a1.75 1.75 0 0 0-1.041.94l4.314 4.315c.443-.2.786-.576.941-1.042L8.446 7.34Zm4.304 2.536L10.124 7.25c.908.001 1.154.013 1.329.06a1.75 1.75 0 0 1 1.237 1.237c.047.175.059.42.06 1.329ZM8.547 12.69c.182.05.442.06 1.453.06h.106L7.25 9.894V10c0 1.01.01 1.27.06 1.453a1.75 1.75 0 0 0 1.237 1.237Z"
      })),
      incomplete: () => /* @__PURE__ */ React12.createElement("svg", {
        viewBox: "0 0 20 20"
      }, /* @__PURE__ */ React12.createElement("path", {
        fillRule: "evenodd",
        d: "M8.547 12.69c.183.05.443.06 1.453.06s1.27-.01 1.453-.06a1.75 1.75 0 0 0 1.237-1.237c.05-.182.06-.443.06-1.453s-.01-1.27-.06-1.453a1.75 1.75 0 0 0-1.237-1.237c-.182-.05-.443-.06-1.453-.06s-1.27.01-1.453.06A1.75 1.75 0 0 0 7.31 8.547c-.05.183-.06.443-.06 1.453s.01 1.27.06 1.453a1.75 1.75 0 0 0 1.237 1.237ZM6.102 8.224C6 8.605 6 9.07 6 10s0 1.395.102 1.777a3 3 0 0 0 2.122 2.12C8.605 14 9.07 14 10 14s1.395 0 1.777-.102a3 3 0 0 0 2.12-2.121C14 11.395 14 10.93 14 10c0-.93 0-1.395-.102-1.776a3 3 0 0 0-2.121-2.122C11.395 6 10.93 6 10 6c-.93 0-1.395 0-1.776.102a3 3 0 0 0-2.122 2.122Z"
      }))
    };
    function Badge2({
      children,
      tone,
      progress,
      icon,
      size = DEFAULT_SIZE,
      toneAndProgressLabelOverride
    }) {
      let i18n = hooks2.useI18n(), withinFilter = React12.useContext(withinFilterContext.WithinFilterContext), className = css.classNames(Badge_module.default.Badge, tone && Badge_module.default[css.variationName("tone", tone)], size && size !== DEFAULT_SIZE && Badge_module.default[css.variationName("size", size)], withinFilter && Badge_module.default.withinFilter), accessibilityLabel = toneAndProgressLabelOverride || utils.getDefaultAccessibilityLabel(i18n, progress, tone), accessibilityMarkup = !!accessibilityLabel && /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        visuallyHidden: !0
      }, accessibilityLabel);
      return progress && !icon && (accessibilityMarkup = /* @__PURE__ */ React12.createElement("span", {
        className: Badge_module.default.Icon
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        accessibilityLabel,
        source: progressIconMap[progress]
      }))), /* @__PURE__ */ React12.createElement("span", {
        className
      }, accessibilityMarkup, icon && /* @__PURE__ */ React12.createElement("span", {
        className: Badge_module.default.Icon
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: icon
      })), children && /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        variant: "bodySm",
        fontWeight: tone === "new" ? "medium" : void 0
      }, children));
    }
    Badge2.Pip = Pip.Pip;
    exports.Badge = Badge2;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-toggle.js
var require_use_toggle = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-toggle.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react();
    function useToggle(initialState) {
      let [value, setState] = React12.useState(initialState);
      return {
        value,
        toggle: React12.useCallback(() => setState((state) => !state), []),
        setTrue: React12.useCallback(() => setState(!0), []),
        setFalse: React12.useCallback(() => setState(!1), [])
      };
    }
    exports.useToggle = useToggle;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tooltip/Tooltip.scss.js
var require_Tooltip_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tooltip/Tooltip.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      TooltipContainer: "Polaris-Tooltip__TooltipContainer",
      HasUnderline: "Polaris-Tooltip__HasUnderline"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/ephemeral-presence-manager/hooks.js
var require_hooks3 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/ephemeral-presence-manager/hooks.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), context = require_context9();
    function useEphemeralPresenceManager() {
      let ephemeralPresenceManager = React12.useContext(context.EphemeralPresenceManagerContext);
      if (!ephemeralPresenceManager)
        throw new Error("No ephemeral presence manager was provided. Your application must be wrapped in an <AppProvider> component. See https://polaris.shopify.com/components/app-provider for implementation instructions.");
      return ephemeralPresenceManager;
    }
    function useReadOnlyEphemeralPresenceManager() {
      let {
        presenceList,
        presenceCounter
      } = useEphemeralPresenceManager();
      return {
        presenceList,
        presenceCounter
      };
    }
    exports.useEphemeralPresenceManager = useEphemeralPresenceManager;
    exports.useReadOnlyEphemeralPresenceManager = useReadOnlyEphemeralPresenceManager;
  }
});

// ../../node_modules/.pnpm/react-dom@18.2.0_react@18.2.0/node_modules/react-dom/cjs/react-dom.production.min.js
var require_react_dom_production_min = __commonJS({
  "../../node_modules/.pnpm/react-dom@18.2.0_react@18.2.0/node_modules/react-dom/cjs/react-dom.production.min.js"(exports) {
    "use strict";
    init_cjs_shims();
    var aa = require_react(), ca = require_scheduler();
    function p(a) {
      for (var b = "https://reactjs.org/docs/error-decoder.html?invariant=" + a, c = 1; c < arguments.length; c++)
        b += "&args[]=" + encodeURIComponent(arguments[c]);
      return "Minified React error #" + a + "; visit " + b + " for the full message or use the non-minified dev environment for full errors and additional helpful warnings.";
    }
    var da = /* @__PURE__ */ new Set(), ea = {};
    function fa(a, b) {
      ha(a, b), ha(a + "Capture", b);
    }
    function ha(a, b) {
      for (ea[a] = b, a = 0; a < b.length; a++)
        da.add(b[a]);
    }
    var ia = !(typeof window > "u" || typeof window.document > "u" || typeof window.document.createElement > "u"), ja = Object.prototype.hasOwnProperty, ka = /^[:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD][:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\-.0-9\u00B7\u0300-\u036F\u203F-\u2040]*$/, la = {}, ma = {};
    function oa(a) {
      return ja.call(ma, a) ? !0 : ja.call(la, a) ? !1 : ka.test(a) ? ma[a] = !0 : (la[a] = !0, !1);
    }
    function pa(a, b, c, d) {
      if (c !== null && c.type === 0)
        return !1;
      switch (typeof b) {
        case "function":
        case "symbol":
          return !0;
        case "boolean":
          return d ? !1 : c !== null ? !c.acceptsBooleans : (a = a.toLowerCase().slice(0, 5), a !== "data-" && a !== "aria-");
        default:
          return !1;
      }
    }
    function qa(a, b, c, d) {
      if (b === null || typeof b > "u" || pa(a, b, c, d))
        return !0;
      if (d)
        return !1;
      if (c !== null)
        switch (c.type) {
          case 3:
            return !b;
          case 4:
            return b === !1;
          case 5:
            return isNaN(b);
          case 6:
            return isNaN(b) || 1 > b;
        }
      return !1;
    }
    function v(a, b, c, d, e, f, g) {
      this.acceptsBooleans = b === 2 || b === 3 || b === 4, this.attributeName = d, this.attributeNamespace = e, this.mustUseProperty = c, this.propertyName = a, this.type = b, this.sanitizeURL = f, this.removeEmptyString = g;
    }
    var z2 = {};
    "children dangerouslySetInnerHTML defaultValue defaultChecked innerHTML suppressContentEditableWarning suppressHydrationWarning style".split(" ").forEach(function(a) {
      z2[a] = new v(a, 0, !1, a, null, !1, !1);
    });
    [["acceptCharset", "accept-charset"], ["className", "class"], ["htmlFor", "for"], ["httpEquiv", "http-equiv"]].forEach(function(a) {
      var b = a[0];
      z2[b] = new v(b, 1, !1, a[1], null, !1, !1);
    });
    ["contentEditable", "draggable", "spellCheck", "value"].forEach(function(a) {
      z2[a] = new v(a, 2, !1, a.toLowerCase(), null, !1, !1);
    });
    ["autoReverse", "externalResourcesRequired", "focusable", "preserveAlpha"].forEach(function(a) {
      z2[a] = new v(a, 2, !1, a, null, !1, !1);
    });
    "allowFullScreen async autoFocus autoPlay controls default defer disabled disablePictureInPicture disableRemotePlayback formNoValidate hidden loop noModule noValidate open playsInline readOnly required reversed scoped seamless itemScope".split(" ").forEach(function(a) {
      z2[a] = new v(a, 3, !1, a.toLowerCase(), null, !1, !1);
    });
    ["checked", "multiple", "muted", "selected"].forEach(function(a) {
      z2[a] = new v(a, 3, !0, a, null, !1, !1);
    });
    ["capture", "download"].forEach(function(a) {
      z2[a] = new v(a, 4, !1, a, null, !1, !1);
    });
    ["cols", "rows", "size", "span"].forEach(function(a) {
      z2[a] = new v(a, 6, !1, a, null, !1, !1);
    });
    ["rowSpan", "start"].forEach(function(a) {
      z2[a] = new v(a, 5, !1, a.toLowerCase(), null, !1, !1);
    });
    var ra = /[\-:]([a-z])/g;
    function sa(a) {
      return a[1].toUpperCase();
    }
    "accent-height alignment-baseline arabic-form baseline-shift cap-height clip-path clip-rule color-interpolation color-interpolation-filters color-profile color-rendering dominant-baseline enable-background fill-opacity fill-rule flood-color flood-opacity font-family font-size font-size-adjust font-stretch font-style font-variant font-weight glyph-name glyph-orientation-horizontal glyph-orientation-vertical horiz-adv-x horiz-origin-x image-rendering letter-spacing lighting-color marker-end marker-mid marker-start overline-position overline-thickness paint-order panose-1 pointer-events rendering-intent shape-rendering stop-color stop-opacity strikethrough-position strikethrough-thickness stroke-dasharray stroke-dashoffset stroke-linecap stroke-linejoin stroke-miterlimit stroke-opacity stroke-width text-anchor text-decoration text-rendering underline-position underline-thickness unicode-bidi unicode-range units-per-em v-alphabetic v-hanging v-ideographic v-mathematical vector-effect vert-adv-y vert-origin-x vert-origin-y word-spacing writing-mode xmlns:xlink x-height".split(" ").forEach(function(a) {
      var b = a.replace(
        ra,
        sa
      );
      z2[b] = new v(b, 1, !1, a, null, !1, !1);
    });
    "xlink:actuate xlink:arcrole xlink:role xlink:show xlink:title xlink:type".split(" ").forEach(function(a) {
      var b = a.replace(ra, sa);
      z2[b] = new v(b, 1, !1, a, "http://www.w3.org/1999/xlink", !1, !1);
    });
    ["xml:base", "xml:lang", "xml:space"].forEach(function(a) {
      var b = a.replace(ra, sa);
      z2[b] = new v(b, 1, !1, a, "http://www.w3.org/XML/1998/namespace", !1, !1);
    });
    ["tabIndex", "crossOrigin"].forEach(function(a) {
      z2[a] = new v(a, 1, !1, a.toLowerCase(), null, !1, !1);
    });
    z2.xlinkHref = new v("xlinkHref", 1, !1, "xlink:href", "http://www.w3.org/1999/xlink", !0, !1);
    ["src", "href", "action", "formAction"].forEach(function(a) {
      z2[a] = new v(a, 1, !1, a.toLowerCase(), null, !0, !0);
    });
    function ta(a, b, c, d) {
      var e = z2.hasOwnProperty(b) ? z2[b] : null;
      (e !== null ? e.type !== 0 : d || !(2 < b.length) || b[0] !== "o" && b[0] !== "O" || b[1] !== "n" && b[1] !== "N") && (qa(b, c, e, d) && (c = null), d || e === null ? oa(b) && (c === null ? a.removeAttribute(b) : a.setAttribute(b, "" + c)) : e.mustUseProperty ? a[e.propertyName] = c === null ? e.type === 3 ? !1 : "" : c : (b = e.attributeName, d = e.attributeNamespace, c === null ? a.removeAttribute(b) : (e = e.type, c = e === 3 || e === 4 && c === !0 ? "" : "" + c, d ? a.setAttributeNS(d, b, c) : a.setAttribute(b, c))));
    }
    var ua = aa.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED, va = Symbol.for("react.element"), wa = Symbol.for("react.portal"), ya = Symbol.for("react.fragment"), za = Symbol.for("react.strict_mode"), Aa = Symbol.for("react.profiler"), Ba = Symbol.for("react.provider"), Ca = Symbol.for("react.context"), Da = Symbol.for("react.forward_ref"), Ea = Symbol.for("react.suspense"), Fa = Symbol.for("react.suspense_list"), Ga = Symbol.for("react.memo"), Ha = Symbol.for("react.lazy");
    Symbol.for("react.scope");
    Symbol.for("react.debug_trace_mode");
    var Ia = Symbol.for("react.offscreen");
    Symbol.for("react.legacy_hidden");
    Symbol.for("react.cache");
    Symbol.for("react.tracing_marker");
    var Ja = Symbol.iterator;
    function Ka(a) {
      return a === null || typeof a != "object" ? null : (a = Ja && a[Ja] || a["@@iterator"], typeof a == "function" ? a : null);
    }
    var A = Object.assign, La;
    function Ma(a) {
      if (La === void 0)
        try {
          throw Error();
        } catch (c) {
          var b = c.stack.trim().match(/\n( *(at )?)/);
          La = b && b[1] || "";
        }
      return `
` + La + a;
    }
    var Na = !1;
    function Oa(a, b) {
      if (!a || Na)
        return "";
      Na = !0;
      var c = Error.prepareStackTrace;
      Error.prepareStackTrace = void 0;
      try {
        if (b)
          if (b = function() {
            throw Error();
          }, Object.defineProperty(b.prototype, "props", { set: function() {
            throw Error();
          } }), typeof Reflect == "object" && Reflect.construct) {
            try {
              Reflect.construct(b, []);
            } catch (l) {
              var d = l;
            }
            Reflect.construct(a, [], b);
          } else {
            try {
              b.call();
            } catch (l) {
              d = l;
            }
            a.call(b.prototype);
          }
        else {
          try {
            throw Error();
          } catch (l) {
            d = l;
          }
          a();
        }
      } catch (l) {
        if (l && d && typeof l.stack == "string") {
          for (var e = l.stack.split(`
`), f = d.stack.split(`
`), g = e.length - 1, h = f.length - 1; 1 <= g && 0 <= h && e[g] !== f[h]; )
            h--;
          for (; 1 <= g && 0 <= h; g--, h--)
            if (e[g] !== f[h]) {
              if (g !== 1 || h !== 1)
                do
                  if (g--, h--, 0 > h || e[g] !== f[h]) {
                    var k = `
` + e[g].replace(" at new ", " at ");
                    return a.displayName && k.includes("<anonymous>") && (k = k.replace("<anonymous>", a.displayName)), k;
                  }
                while (1 <= g && 0 <= h);
              break;
            }
        }
      } finally {
        Na = !1, Error.prepareStackTrace = c;
      }
      return (a = a ? a.displayName || a.name : "") ? Ma(a) : "";
    }
    function Pa(a) {
      switch (a.tag) {
        case 5:
          return Ma(a.type);
        case 16:
          return Ma("Lazy");
        case 13:
          return Ma("Suspense");
        case 19:
          return Ma("SuspenseList");
        case 0:
        case 2:
        case 15:
          return a = Oa(a.type, !1), a;
        case 11:
          return a = Oa(a.type.render, !1), a;
        case 1:
          return a = Oa(a.type, !0), a;
        default:
          return "";
      }
    }
    function Qa(a) {
      if (a == null)
        return null;
      if (typeof a == "function")
        return a.displayName || a.name || null;
      if (typeof a == "string")
        return a;
      switch (a) {
        case ya:
          return "Fragment";
        case wa:
          return "Portal";
        case Aa:
          return "Profiler";
        case za:
          return "StrictMode";
        case Ea:
          return "Suspense";
        case Fa:
          return "SuspenseList";
      }
      if (typeof a == "object")
        switch (a.$$typeof) {
          case Ca:
            return (a.displayName || "Context") + ".Consumer";
          case Ba:
            return (a._context.displayName || "Context") + ".Provider";
          case Da:
            var b = a.render;
            return a = a.displayName, a || (a = b.displayName || b.name || "", a = a !== "" ? "ForwardRef(" + a + ")" : "ForwardRef"), a;
          case Ga:
            return b = a.displayName || null, b !== null ? b : Qa(a.type) || "Memo";
          case Ha:
            b = a._payload, a = a._init;
            try {
              return Qa(a(b));
            } catch {
            }
        }
      return null;
    }
    function Ra(a) {
      var b = a.type;
      switch (a.tag) {
        case 24:
          return "Cache";
        case 9:
          return (b.displayName || "Context") + ".Consumer";
        case 10:
          return (b._context.displayName || "Context") + ".Provider";
        case 18:
          return "DehydratedFragment";
        case 11:
          return a = b.render, a = a.displayName || a.name || "", b.displayName || (a !== "" ? "ForwardRef(" + a + ")" : "ForwardRef");
        case 7:
          return "Fragment";
        case 5:
          return b;
        case 4:
          return "Portal";
        case 3:
          return "Root";
        case 6:
          return "Text";
        case 16:
          return Qa(b);
        case 8:
          return b === za ? "StrictMode" : "Mode";
        case 22:
          return "Offscreen";
        case 12:
          return "Profiler";
        case 21:
          return "Scope";
        case 13:
          return "Suspense";
        case 19:
          return "SuspenseList";
        case 25:
          return "TracingMarker";
        case 1:
        case 0:
        case 17:
        case 2:
        case 14:
        case 15:
          if (typeof b == "function")
            return b.displayName || b.name || null;
          if (typeof b == "string")
            return b;
      }
      return null;
    }
    function Sa(a) {
      switch (typeof a) {
        case "boolean":
        case "number":
        case "string":
        case "undefined":
          return a;
        case "object":
          return a;
        default:
          return "";
      }
    }
    function Ta(a) {
      var b = a.type;
      return (a = a.nodeName) && a.toLowerCase() === "input" && (b === "checkbox" || b === "radio");
    }
    function Ua(a) {
      var b = Ta(a) ? "checked" : "value", c = Object.getOwnPropertyDescriptor(a.constructor.prototype, b), d = "" + a[b];
      if (!a.hasOwnProperty(b) && typeof c < "u" && typeof c.get == "function" && typeof c.set == "function") {
        var e = c.get, f = c.set;
        return Object.defineProperty(a, b, { configurable: !0, get: function() {
          return e.call(this);
        }, set: function(a2) {
          d = "" + a2, f.call(this, a2);
        } }), Object.defineProperty(a, b, { enumerable: c.enumerable }), { getValue: function() {
          return d;
        }, setValue: function(a2) {
          d = "" + a2;
        }, stopTracking: function() {
          a._valueTracker = null, delete a[b];
        } };
      }
    }
    function Va(a) {
      a._valueTracker || (a._valueTracker = Ua(a));
    }
    function Wa(a) {
      if (!a)
        return !1;
      var b = a._valueTracker;
      if (!b)
        return !0;
      var c = b.getValue(), d = "";
      return a && (d = Ta(a) ? a.checked ? "true" : "false" : a.value), a = d, a !== c ? (b.setValue(a), !0) : !1;
    }
    function Xa(a) {
      if (a = a || (typeof document < "u" ? document : void 0), typeof a > "u")
        return null;
      try {
        return a.activeElement || a.body;
      } catch {
        return a.body;
      }
    }
    function Ya(a, b) {
      var c = b.checked;
      return A({}, b, { defaultChecked: void 0, defaultValue: void 0, value: void 0, checked: c ?? a._wrapperState.initialChecked });
    }
    function Za(a, b) {
      var c = b.defaultValue == null ? "" : b.defaultValue, d = b.checked != null ? b.checked : b.defaultChecked;
      c = Sa(b.value != null ? b.value : c), a._wrapperState = { initialChecked: d, initialValue: c, controlled: b.type === "checkbox" || b.type === "radio" ? b.checked != null : b.value != null };
    }
    function ab(a, b) {
      b = b.checked, b != null && ta(a, "checked", b, !1);
    }
    function bb(a, b) {
      ab(a, b);
      var c = Sa(b.value), d = b.type;
      if (c != null)
        d === "number" ? (c === 0 && a.value === "" || a.value != c) && (a.value = "" + c) : a.value !== "" + c && (a.value = "" + c);
      else if (d === "submit" || d === "reset") {
        a.removeAttribute("value");
        return;
      }
      b.hasOwnProperty("value") ? cb(a, b.type, c) : b.hasOwnProperty("defaultValue") && cb(a, b.type, Sa(b.defaultValue)), b.checked == null && b.defaultChecked != null && (a.defaultChecked = !!b.defaultChecked);
    }
    function db(a, b, c) {
      if (b.hasOwnProperty("value") || b.hasOwnProperty("defaultValue")) {
        var d = b.type;
        if (!(d !== "submit" && d !== "reset" || b.value !== void 0 && b.value !== null))
          return;
        b = "" + a._wrapperState.initialValue, c || b === a.value || (a.value = b), a.defaultValue = b;
      }
      c = a.name, c !== "" && (a.name = ""), a.defaultChecked = !!a._wrapperState.initialChecked, c !== "" && (a.name = c);
    }
    function cb(a, b, c) {
      (b !== "number" || Xa(a.ownerDocument) !== a) && (c == null ? a.defaultValue = "" + a._wrapperState.initialValue : a.defaultValue !== "" + c && (a.defaultValue = "" + c));
    }
    var eb = Array.isArray;
    function fb(a, b, c, d) {
      if (a = a.options, b) {
        b = {};
        for (var e = 0; e < c.length; e++)
          b["$" + c[e]] = !0;
        for (c = 0; c < a.length; c++)
          e = b.hasOwnProperty("$" + a[c].value), a[c].selected !== e && (a[c].selected = e), e && d && (a[c].defaultSelected = !0);
      } else {
        for (c = "" + Sa(c), b = null, e = 0; e < a.length; e++) {
          if (a[e].value === c) {
            a[e].selected = !0, d && (a[e].defaultSelected = !0);
            return;
          }
          b !== null || a[e].disabled || (b = a[e]);
        }
        b !== null && (b.selected = !0);
      }
    }
    function gb(a, b) {
      if (b.dangerouslySetInnerHTML != null)
        throw Error(p(91));
      return A({}, b, { value: void 0, defaultValue: void 0, children: "" + a._wrapperState.initialValue });
    }
    function hb(a, b) {
      var c = b.value;
      if (c == null) {
        if (c = b.children, b = b.defaultValue, c != null) {
          if (b != null)
            throw Error(p(92));
          if (eb(c)) {
            if (1 < c.length)
              throw Error(p(93));
            c = c[0];
          }
          b = c;
        }
        b == null && (b = ""), c = b;
      }
      a._wrapperState = { initialValue: Sa(c) };
    }
    function ib(a, b) {
      var c = Sa(b.value), d = Sa(b.defaultValue);
      c != null && (c = "" + c, c !== a.value && (a.value = c), b.defaultValue == null && a.defaultValue !== c && (a.defaultValue = c)), d != null && (a.defaultValue = "" + d);
    }
    function jb(a) {
      var b = a.textContent;
      b === a._wrapperState.initialValue && b !== "" && b !== null && (a.value = b);
    }
    function kb(a) {
      switch (a) {
        case "svg":
          return "http://www.w3.org/2000/svg";
        case "math":
          return "http://www.w3.org/1998/Math/MathML";
        default:
          return "http://www.w3.org/1999/xhtml";
      }
    }
    function lb(a, b) {
      return a == null || a === "http://www.w3.org/1999/xhtml" ? kb(b) : a === "http://www.w3.org/2000/svg" && b === "foreignObject" ? "http://www.w3.org/1999/xhtml" : a;
    }
    var mb, nb = function(a) {
      return typeof MSApp < "u" && MSApp.execUnsafeLocalFunction ? function(b, c, d, e) {
        MSApp.execUnsafeLocalFunction(function() {
          return a(b, c, d, e);
        });
      } : a;
    }(function(a, b) {
      if (a.namespaceURI !== "http://www.w3.org/2000/svg" || "innerHTML" in a)
        a.innerHTML = b;
      else {
        for (mb = mb || document.createElement("div"), mb.innerHTML = "<svg>" + b.valueOf().toString() + "</svg>", b = mb.firstChild; a.firstChild; )
          a.removeChild(a.firstChild);
        for (; b.firstChild; )
          a.appendChild(b.firstChild);
      }
    });
    function ob(a, b) {
      if (b) {
        var c = a.firstChild;
        if (c && c === a.lastChild && c.nodeType === 3) {
          c.nodeValue = b;
          return;
        }
      }
      a.textContent = b;
    }
    var pb = {
      animationIterationCount: !0,
      aspectRatio: !0,
      borderImageOutset: !0,
      borderImageSlice: !0,
      borderImageWidth: !0,
      boxFlex: !0,
      boxFlexGroup: !0,
      boxOrdinalGroup: !0,
      columnCount: !0,
      columns: !0,
      flex: !0,
      flexGrow: !0,
      flexPositive: !0,
      flexShrink: !0,
      flexNegative: !0,
      flexOrder: !0,
      gridArea: !0,
      gridRow: !0,
      gridRowEnd: !0,
      gridRowSpan: !0,
      gridRowStart: !0,
      gridColumn: !0,
      gridColumnEnd: !0,
      gridColumnSpan: !0,
      gridColumnStart: !0,
      fontWeight: !0,
      lineClamp: !0,
      lineHeight: !0,
      opacity: !0,
      order: !0,
      orphans: !0,
      tabSize: !0,
      widows: !0,
      zIndex: !0,
      zoom: !0,
      fillOpacity: !0,
      floodOpacity: !0,
      stopOpacity: !0,
      strokeDasharray: !0,
      strokeDashoffset: !0,
      strokeMiterlimit: !0,
      strokeOpacity: !0,
      strokeWidth: !0
    }, qb = ["Webkit", "ms", "Moz", "O"];
    Object.keys(pb).forEach(function(a) {
      qb.forEach(function(b) {
        b = b + a.charAt(0).toUpperCase() + a.substring(1), pb[b] = pb[a];
      });
    });
    function rb(a, b, c) {
      return b == null || typeof b == "boolean" || b === "" ? "" : c || typeof b != "number" || b === 0 || pb.hasOwnProperty(a) && pb[a] ? ("" + b).trim() : b + "px";
    }
    function sb(a, b) {
      a = a.style;
      for (var c in b)
        if (b.hasOwnProperty(c)) {
          var d = c.indexOf("--") === 0, e = rb(c, b[c], d);
          c === "float" && (c = "cssFloat"), d ? a.setProperty(c, e) : a[c] = e;
        }
    }
    var tb = A({ menuitem: !0 }, { area: !0, base: !0, br: !0, col: !0, embed: !0, hr: !0, img: !0, input: !0, keygen: !0, link: !0, meta: !0, param: !0, source: !0, track: !0, wbr: !0 });
    function ub(a, b) {
      if (b) {
        if (tb[a] && (b.children != null || b.dangerouslySetInnerHTML != null))
          throw Error(p(137, a));
        if (b.dangerouslySetInnerHTML != null) {
          if (b.children != null)
            throw Error(p(60));
          if (typeof b.dangerouslySetInnerHTML != "object" || !("__html" in b.dangerouslySetInnerHTML))
            throw Error(p(61));
        }
        if (b.style != null && typeof b.style != "object")
          throw Error(p(62));
      }
    }
    function vb(a, b) {
      if (a.indexOf("-") === -1)
        return typeof b.is == "string";
      switch (a) {
        case "annotation-xml":
        case "color-profile":
        case "font-face":
        case "font-face-src":
        case "font-face-uri":
        case "font-face-format":
        case "font-face-name":
        case "missing-glyph":
          return !1;
        default:
          return !0;
      }
    }
    var wb = null;
    function xb(a) {
      return a = a.target || a.srcElement || window, a.correspondingUseElement && (a = a.correspondingUseElement), a.nodeType === 3 ? a.parentNode : a;
    }
    var yb = null, zb = null, Ab = null;
    function Bb(a) {
      if (a = Cb(a)) {
        if (typeof yb != "function")
          throw Error(p(280));
        var b = a.stateNode;
        b && (b = Db(b), yb(a.stateNode, a.type, b));
      }
    }
    function Eb(a) {
      zb ? Ab ? Ab.push(a) : Ab = [a] : zb = a;
    }
    function Fb() {
      if (zb) {
        var a = zb, b = Ab;
        if (Ab = zb = null, Bb(a), b)
          for (a = 0; a < b.length; a++)
            Bb(b[a]);
      }
    }
    function Gb(a, b) {
      return a(b);
    }
    function Hb() {
    }
    var Ib = !1;
    function Jb(a, b, c) {
      if (Ib)
        return a(b, c);
      Ib = !0;
      try {
        return Gb(a, b, c);
      } finally {
        Ib = !1, (zb !== null || Ab !== null) && (Hb(), Fb());
      }
    }
    function Kb(a, b) {
      var c = a.stateNode;
      if (c === null)
        return null;
      var d = Db(c);
      if (d === null)
        return null;
      c = d[b];
      a:
        switch (b) {
          case "onClick":
          case "onClickCapture":
          case "onDoubleClick":
          case "onDoubleClickCapture":
          case "onMouseDown":
          case "onMouseDownCapture":
          case "onMouseMove":
          case "onMouseMoveCapture":
          case "onMouseUp":
          case "onMouseUpCapture":
          case "onMouseEnter":
            (d = !d.disabled) || (a = a.type, d = !(a === "button" || a === "input" || a === "select" || a === "textarea")), a = !d;
            break a;
          default:
            a = !1;
        }
      if (a)
        return null;
      if (c && typeof c != "function")
        throw Error(p(231, b, typeof c));
      return c;
    }
    var Lb = !1;
    if (ia)
      try {
        Mb = {}, Object.defineProperty(Mb, "passive", { get: function() {
          Lb = !0;
        } }), window.addEventListener("test", Mb, Mb), window.removeEventListener("test", Mb, Mb);
      } catch {
        Lb = !1;
      }
    var Mb;
    function Nb(a, b, c, d, e, f, g, h, k) {
      var l = Array.prototype.slice.call(arguments, 3);
      try {
        b.apply(c, l);
      } catch (m) {
        this.onError(m);
      }
    }
    var Ob = !1, Pb = null, Qb = !1, Rb = null, Sb = { onError: function(a) {
      Ob = !0, Pb = a;
    } };
    function Tb(a, b, c, d, e, f, g, h, k) {
      Ob = !1, Pb = null, Nb.apply(Sb, arguments);
    }
    function Ub(a, b, c, d, e, f, g, h, k) {
      if (Tb.apply(this, arguments), Ob) {
        if (Ob) {
          var l = Pb;
          Ob = !1, Pb = null;
        } else
          throw Error(p(198));
        Qb || (Qb = !0, Rb = l);
      }
    }
    function Vb(a) {
      var b = a, c = a;
      if (a.alternate)
        for (; b.return; )
          b = b.return;
      else {
        a = b;
        do
          b = a, b.flags & 4098 && (c = b.return), a = b.return;
        while (a);
      }
      return b.tag === 3 ? c : null;
    }
    function Wb(a) {
      if (a.tag === 13) {
        var b = a.memoizedState;
        if (b === null && (a = a.alternate, a !== null && (b = a.memoizedState)), b !== null)
          return b.dehydrated;
      }
      return null;
    }
    function Xb(a) {
      if (Vb(a) !== a)
        throw Error(p(188));
    }
    function Yb(a) {
      var b = a.alternate;
      if (!b) {
        if (b = Vb(a), b === null)
          throw Error(p(188));
        return b !== a ? null : a;
      }
      for (var c = a, d = b; ; ) {
        var e = c.return;
        if (e === null)
          break;
        var f = e.alternate;
        if (f === null) {
          if (d = e.return, d !== null) {
            c = d;
            continue;
          }
          break;
        }
        if (e.child === f.child) {
          for (f = e.child; f; ) {
            if (f === c)
              return Xb(e), a;
            if (f === d)
              return Xb(e), b;
            f = f.sibling;
          }
          throw Error(p(188));
        }
        if (c.return !== d.return)
          c = e, d = f;
        else {
          for (var g = !1, h = e.child; h; ) {
            if (h === c) {
              g = !0, c = e, d = f;
              break;
            }
            if (h === d) {
              g = !0, d = e, c = f;
              break;
            }
            h = h.sibling;
          }
          if (!g) {
            for (h = f.child; h; ) {
              if (h === c) {
                g = !0, c = f, d = e;
                break;
              }
              if (h === d) {
                g = !0, d = f, c = e;
                break;
              }
              h = h.sibling;
            }
            if (!g)
              throw Error(p(189));
          }
        }
        if (c.alternate !== d)
          throw Error(p(190));
      }
      if (c.tag !== 3)
        throw Error(p(188));
      return c.stateNode.current === c ? a : b;
    }
    function Zb(a) {
      return a = Yb(a), a !== null ? $b(a) : null;
    }
    function $b(a) {
      if (a.tag === 5 || a.tag === 6)
        return a;
      for (a = a.child; a !== null; ) {
        var b = $b(a);
        if (b !== null)
          return b;
        a = a.sibling;
      }
      return null;
    }
    var ac = ca.unstable_scheduleCallback, bc = ca.unstable_cancelCallback, cc = ca.unstable_shouldYield, dc = ca.unstable_requestPaint, B = ca.unstable_now, ec = ca.unstable_getCurrentPriorityLevel, fc = ca.unstable_ImmediatePriority, gc = ca.unstable_UserBlockingPriority, hc = ca.unstable_NormalPriority, ic = ca.unstable_LowPriority, jc = ca.unstable_IdlePriority, kc = null, lc = null;
    function mc(a) {
      if (lc && typeof lc.onCommitFiberRoot == "function")
        try {
          lc.onCommitFiberRoot(kc, a, void 0, (a.current.flags & 128) === 128);
        } catch {
        }
    }
    var oc = Math.clz32 ? Math.clz32 : nc, pc = Math.log, qc = Math.LN2;
    function nc(a) {
      return a >>>= 0, a === 0 ? 32 : 31 - (pc(a) / qc | 0) | 0;
    }
    var rc = 64, sc = 4194304;
    function tc(a) {
      switch (a & -a) {
        case 1:
          return 1;
        case 2:
          return 2;
        case 4:
          return 4;
        case 8:
          return 8;
        case 16:
          return 16;
        case 32:
          return 32;
        case 64:
        case 128:
        case 256:
        case 512:
        case 1024:
        case 2048:
        case 4096:
        case 8192:
        case 16384:
        case 32768:
        case 65536:
        case 131072:
        case 262144:
        case 524288:
        case 1048576:
        case 2097152:
          return a & 4194240;
        case 4194304:
        case 8388608:
        case 16777216:
        case 33554432:
        case 67108864:
          return a & 130023424;
        case 134217728:
          return 134217728;
        case 268435456:
          return 268435456;
        case 536870912:
          return 536870912;
        case 1073741824:
          return 1073741824;
        default:
          return a;
      }
    }
    function uc(a, b) {
      var c = a.pendingLanes;
      if (c === 0)
        return 0;
      var d = 0, e = a.suspendedLanes, f = a.pingedLanes, g = c & 268435455;
      if (g !== 0) {
        var h = g & ~e;
        h !== 0 ? d = tc(h) : (f &= g, f !== 0 && (d = tc(f)));
      } else
        g = c & ~e, g !== 0 ? d = tc(g) : f !== 0 && (d = tc(f));
      if (d === 0)
        return 0;
      if (b !== 0 && b !== d && !(b & e) && (e = d & -d, f = b & -b, e >= f || e === 16 && (f & 4194240) !== 0))
        return b;
      if (d & 4 && (d |= c & 16), b = a.entangledLanes, b !== 0)
        for (a = a.entanglements, b &= d; 0 < b; )
          c = 31 - oc(b), e = 1 << c, d |= a[c], b &= ~e;
      return d;
    }
    function vc(a, b) {
      switch (a) {
        case 1:
        case 2:
        case 4:
          return b + 250;
        case 8:
        case 16:
        case 32:
        case 64:
        case 128:
        case 256:
        case 512:
        case 1024:
        case 2048:
        case 4096:
        case 8192:
        case 16384:
        case 32768:
        case 65536:
        case 131072:
        case 262144:
        case 524288:
        case 1048576:
        case 2097152:
          return b + 5e3;
        case 4194304:
        case 8388608:
        case 16777216:
        case 33554432:
        case 67108864:
          return -1;
        case 134217728:
        case 268435456:
        case 536870912:
        case 1073741824:
          return -1;
        default:
          return -1;
      }
    }
    function wc(a, b) {
      for (var c = a.suspendedLanes, d = a.pingedLanes, e = a.expirationTimes, f = a.pendingLanes; 0 < f; ) {
        var g = 31 - oc(f), h = 1 << g, k = e[g];
        k === -1 ? (!(h & c) || h & d) && (e[g] = vc(h, b)) : k <= b && (a.expiredLanes |= h), f &= ~h;
      }
    }
    function xc(a) {
      return a = a.pendingLanes & -1073741825, a !== 0 ? a : a & 1073741824 ? 1073741824 : 0;
    }
    function yc() {
      var a = rc;
      return rc <<= 1, !(rc & 4194240) && (rc = 64), a;
    }
    function zc(a) {
      for (var b = [], c = 0; 31 > c; c++)
        b.push(a);
      return b;
    }
    function Ac(a, b, c) {
      a.pendingLanes |= b, b !== 536870912 && (a.suspendedLanes = 0, a.pingedLanes = 0), a = a.eventTimes, b = 31 - oc(b), a[b] = c;
    }
    function Bc(a, b) {
      var c = a.pendingLanes & ~b;
      a.pendingLanes = b, a.suspendedLanes = 0, a.pingedLanes = 0, a.expiredLanes &= b, a.mutableReadLanes &= b, a.entangledLanes &= b, b = a.entanglements;
      var d = a.eventTimes;
      for (a = a.expirationTimes; 0 < c; ) {
        var e = 31 - oc(c), f = 1 << e;
        b[e] = 0, d[e] = -1, a[e] = -1, c &= ~f;
      }
    }
    function Cc(a, b) {
      var c = a.entangledLanes |= b;
      for (a = a.entanglements; c; ) {
        var d = 31 - oc(c), e = 1 << d;
        e & b | a[d] & b && (a[d] |= b), c &= ~e;
      }
    }
    var C = 0;
    function Dc(a) {
      return a &= -a, 1 < a ? 4 < a ? a & 268435455 ? 16 : 536870912 : 4 : 1;
    }
    var Ec, Fc, Gc, Hc, Ic, Jc = !1, Kc = [], Lc = null, Mc = null, Nc = null, Oc = /* @__PURE__ */ new Map(), Pc = /* @__PURE__ */ new Map(), Qc = [], Rc = "mousedown mouseup touchcancel touchend touchstart auxclick dblclick pointercancel pointerdown pointerup dragend dragstart drop compositionend compositionstart keydown keypress keyup input textInput copy cut paste click change contextmenu reset submit".split(" ");
    function Sc(a, b) {
      switch (a) {
        case "focusin":
        case "focusout":
          Lc = null;
          break;
        case "dragenter":
        case "dragleave":
          Mc = null;
          break;
        case "mouseover":
        case "mouseout":
          Nc = null;
          break;
        case "pointerover":
        case "pointerout":
          Oc.delete(b.pointerId);
          break;
        case "gotpointercapture":
        case "lostpointercapture":
          Pc.delete(b.pointerId);
      }
    }
    function Tc(a, b, c, d, e, f) {
      return a === null || a.nativeEvent !== f ? (a = { blockedOn: b, domEventName: c, eventSystemFlags: d, nativeEvent: f, targetContainers: [e] }, b !== null && (b = Cb(b), b !== null && Fc(b)), a) : (a.eventSystemFlags |= d, b = a.targetContainers, e !== null && b.indexOf(e) === -1 && b.push(e), a);
    }
    function Uc(a, b, c, d, e) {
      switch (b) {
        case "focusin":
          return Lc = Tc(Lc, a, b, c, d, e), !0;
        case "dragenter":
          return Mc = Tc(Mc, a, b, c, d, e), !0;
        case "mouseover":
          return Nc = Tc(Nc, a, b, c, d, e), !0;
        case "pointerover":
          var f = e.pointerId;
          return Oc.set(f, Tc(Oc.get(f) || null, a, b, c, d, e)), !0;
        case "gotpointercapture":
          return f = e.pointerId, Pc.set(f, Tc(Pc.get(f) || null, a, b, c, d, e)), !0;
      }
      return !1;
    }
    function Vc(a) {
      var b = Wc(a.target);
      if (b !== null) {
        var c = Vb(b);
        if (c !== null) {
          if (b = c.tag, b === 13) {
            if (b = Wb(c), b !== null) {
              a.blockedOn = b, Ic(a.priority, function() {
                Gc(c);
              });
              return;
            }
          } else if (b === 3 && c.stateNode.current.memoizedState.isDehydrated) {
            a.blockedOn = c.tag === 3 ? c.stateNode.containerInfo : null;
            return;
          }
        }
      }
      a.blockedOn = null;
    }
    function Xc(a) {
      if (a.blockedOn !== null)
        return !1;
      for (var b = a.targetContainers; 0 < b.length; ) {
        var c = Yc(a.domEventName, a.eventSystemFlags, b[0], a.nativeEvent);
        if (c === null) {
          c = a.nativeEvent;
          var d = new c.constructor(c.type, c);
          wb = d, c.target.dispatchEvent(d), wb = null;
        } else
          return b = Cb(c), b !== null && Fc(b), a.blockedOn = c, !1;
        b.shift();
      }
      return !0;
    }
    function Zc(a, b, c) {
      Xc(a) && c.delete(b);
    }
    function $c() {
      Jc = !1, Lc !== null && Xc(Lc) && (Lc = null), Mc !== null && Xc(Mc) && (Mc = null), Nc !== null && Xc(Nc) && (Nc = null), Oc.forEach(Zc), Pc.forEach(Zc);
    }
    function ad(a, b) {
      a.blockedOn === b && (a.blockedOn = null, Jc || (Jc = !0, ca.unstable_scheduleCallback(ca.unstable_NormalPriority, $c)));
    }
    function bd(a) {
      function b(b2) {
        return ad(b2, a);
      }
      if (0 < Kc.length) {
        ad(Kc[0], a);
        for (var c = 1; c < Kc.length; c++) {
          var d = Kc[c];
          d.blockedOn === a && (d.blockedOn = null);
        }
      }
      for (Lc !== null && ad(Lc, a), Mc !== null && ad(Mc, a), Nc !== null && ad(Nc, a), Oc.forEach(b), Pc.forEach(b), c = 0; c < Qc.length; c++)
        d = Qc[c], d.blockedOn === a && (d.blockedOn = null);
      for (; 0 < Qc.length && (c = Qc[0], c.blockedOn === null); )
        Vc(c), c.blockedOn === null && Qc.shift();
    }
    var cd = ua.ReactCurrentBatchConfig, dd = !0;
    function ed(a, b, c, d) {
      var e = C, f = cd.transition;
      cd.transition = null;
      try {
        C = 1, fd(a, b, c, d);
      } finally {
        C = e, cd.transition = f;
      }
    }
    function gd(a, b, c, d) {
      var e = C, f = cd.transition;
      cd.transition = null;
      try {
        C = 4, fd(a, b, c, d);
      } finally {
        C = e, cd.transition = f;
      }
    }
    function fd(a, b, c, d) {
      if (dd) {
        var e = Yc(a, b, c, d);
        if (e === null)
          hd(a, b, d, id, c), Sc(a, d);
        else if (Uc(e, a, b, c, d))
          d.stopPropagation();
        else if (Sc(a, d), b & 4 && -1 < Rc.indexOf(a)) {
          for (; e !== null; ) {
            var f = Cb(e);
            if (f !== null && Ec(f), f = Yc(a, b, c, d), f === null && hd(a, b, d, id, c), f === e)
              break;
            e = f;
          }
          e !== null && d.stopPropagation();
        } else
          hd(a, b, d, null, c);
      }
    }
    var id = null;
    function Yc(a, b, c, d) {
      if (id = null, a = xb(d), a = Wc(a), a !== null)
        if (b = Vb(a), b === null)
          a = null;
        else if (c = b.tag, c === 13) {
          if (a = Wb(b), a !== null)
            return a;
          a = null;
        } else if (c === 3) {
          if (b.stateNode.current.memoizedState.isDehydrated)
            return b.tag === 3 ? b.stateNode.containerInfo : null;
          a = null;
        } else
          b !== a && (a = null);
      return id = a, null;
    }
    function jd(a) {
      switch (a) {
        case "cancel":
        case "click":
        case "close":
        case "contextmenu":
        case "copy":
        case "cut":
        case "auxclick":
        case "dblclick":
        case "dragend":
        case "dragstart":
        case "drop":
        case "focusin":
        case "focusout":
        case "input":
        case "invalid":
        case "keydown":
        case "keypress":
        case "keyup":
        case "mousedown":
        case "mouseup":
        case "paste":
        case "pause":
        case "play":
        case "pointercancel":
        case "pointerdown":
        case "pointerup":
        case "ratechange":
        case "reset":
        case "resize":
        case "seeked":
        case "submit":
        case "touchcancel":
        case "touchend":
        case "touchstart":
        case "volumechange":
        case "change":
        case "selectionchange":
        case "textInput":
        case "compositionstart":
        case "compositionend":
        case "compositionupdate":
        case "beforeblur":
        case "afterblur":
        case "beforeinput":
        case "blur":
        case "fullscreenchange":
        case "focus":
        case "hashchange":
        case "popstate":
        case "select":
        case "selectstart":
          return 1;
        case "drag":
        case "dragenter":
        case "dragexit":
        case "dragleave":
        case "dragover":
        case "mousemove":
        case "mouseout":
        case "mouseover":
        case "pointermove":
        case "pointerout":
        case "pointerover":
        case "scroll":
        case "toggle":
        case "touchmove":
        case "wheel":
        case "mouseenter":
        case "mouseleave":
        case "pointerenter":
        case "pointerleave":
          return 4;
        case "message":
          switch (ec()) {
            case fc:
              return 1;
            case gc:
              return 4;
            case hc:
            case ic:
              return 16;
            case jc:
              return 536870912;
            default:
              return 16;
          }
        default:
          return 16;
      }
    }
    var kd = null, ld = null, md = null;
    function nd() {
      if (md)
        return md;
      var a, b = ld, c = b.length, d, e = "value" in kd ? kd.value : kd.textContent, f = e.length;
      for (a = 0; a < c && b[a] === e[a]; a++)
        ;
      var g = c - a;
      for (d = 1; d <= g && b[c - d] === e[f - d]; d++)
        ;
      return md = e.slice(a, 1 < d ? 1 - d : void 0);
    }
    function od(a) {
      var b = a.keyCode;
      return "charCode" in a ? (a = a.charCode, a === 0 && b === 13 && (a = 13)) : a = b, a === 10 && (a = 13), 32 <= a || a === 13 ? a : 0;
    }
    function pd() {
      return !0;
    }
    function qd() {
      return !1;
    }
    function rd(a) {
      function b(b2, d, e, f, g) {
        this._reactName = b2, this._targetInst = e, this.type = d, this.nativeEvent = f, this.target = g, this.currentTarget = null;
        for (var c in a)
          a.hasOwnProperty(c) && (b2 = a[c], this[c] = b2 ? b2(f) : f[c]);
        return this.isDefaultPrevented = (f.defaultPrevented != null ? f.defaultPrevented : f.returnValue === !1) ? pd : qd, this.isPropagationStopped = qd, this;
      }
      return A(b.prototype, { preventDefault: function() {
        this.defaultPrevented = !0;
        var a2 = this.nativeEvent;
        a2 && (a2.preventDefault ? a2.preventDefault() : typeof a2.returnValue != "unknown" && (a2.returnValue = !1), this.isDefaultPrevented = pd);
      }, stopPropagation: function() {
        var a2 = this.nativeEvent;
        a2 && (a2.stopPropagation ? a2.stopPropagation() : typeof a2.cancelBubble != "unknown" && (a2.cancelBubble = !0), this.isPropagationStopped = pd);
      }, persist: function() {
      }, isPersistent: pd }), b;
    }
    var sd = { eventPhase: 0, bubbles: 0, cancelable: 0, timeStamp: function(a) {
      return a.timeStamp || Date.now();
    }, defaultPrevented: 0, isTrusted: 0 }, td = rd(sd), ud = A({}, sd, { view: 0, detail: 0 }), vd = rd(ud), wd, xd, yd, Ad = A({}, ud, { screenX: 0, screenY: 0, clientX: 0, clientY: 0, pageX: 0, pageY: 0, ctrlKey: 0, shiftKey: 0, altKey: 0, metaKey: 0, getModifierState: zd, button: 0, buttons: 0, relatedTarget: function(a) {
      return a.relatedTarget === void 0 ? a.fromElement === a.srcElement ? a.toElement : a.fromElement : a.relatedTarget;
    }, movementX: function(a) {
      return "movementX" in a ? a.movementX : (a !== yd && (yd && a.type === "mousemove" ? (wd = a.screenX - yd.screenX, xd = a.screenY - yd.screenY) : xd = wd = 0, yd = a), wd);
    }, movementY: function(a) {
      return "movementY" in a ? a.movementY : xd;
    } }), Bd = rd(Ad), Cd = A({}, Ad, { dataTransfer: 0 }), Dd = rd(Cd), Ed = A({}, ud, { relatedTarget: 0 }), Fd = rd(Ed), Gd = A({}, sd, { animationName: 0, elapsedTime: 0, pseudoElement: 0 }), Hd = rd(Gd), Id = A({}, sd, { clipboardData: function(a) {
      return "clipboardData" in a ? a.clipboardData : window.clipboardData;
    } }), Jd = rd(Id), Kd = A({}, sd, { data: 0 }), Ld = rd(Kd), Md = {
      Esc: "Escape",
      Spacebar: " ",
      Left: "ArrowLeft",
      Up: "ArrowUp",
      Right: "ArrowRight",
      Down: "ArrowDown",
      Del: "Delete",
      Win: "OS",
      Menu: "ContextMenu",
      Apps: "ContextMenu",
      Scroll: "ScrollLock",
      MozPrintableKey: "Unidentified"
    }, Nd = {
      8: "Backspace",
      9: "Tab",
      12: "Clear",
      13: "Enter",
      16: "Shift",
      17: "Control",
      18: "Alt",
      19: "Pause",
      20: "CapsLock",
      27: "Escape",
      32: " ",
      33: "PageUp",
      34: "PageDown",
      35: "End",
      36: "Home",
      37: "ArrowLeft",
      38: "ArrowUp",
      39: "ArrowRight",
      40: "ArrowDown",
      45: "Insert",
      46: "Delete",
      112: "F1",
      113: "F2",
      114: "F3",
      115: "F4",
      116: "F5",
      117: "F6",
      118: "F7",
      119: "F8",
      120: "F9",
      121: "F10",
      122: "F11",
      123: "F12",
      144: "NumLock",
      145: "ScrollLock",
      224: "Meta"
    }, Od = { Alt: "altKey", Control: "ctrlKey", Meta: "metaKey", Shift: "shiftKey" };
    function Pd(a) {
      var b = this.nativeEvent;
      return b.getModifierState ? b.getModifierState(a) : (a = Od[a]) ? !!b[a] : !1;
    }
    function zd() {
      return Pd;
    }
    var Qd = A({}, ud, { key: function(a) {
      if (a.key) {
        var b = Md[a.key] || a.key;
        if (b !== "Unidentified")
          return b;
      }
      return a.type === "keypress" ? (a = od(a), a === 13 ? "Enter" : String.fromCharCode(a)) : a.type === "keydown" || a.type === "keyup" ? Nd[a.keyCode] || "Unidentified" : "";
    }, code: 0, location: 0, ctrlKey: 0, shiftKey: 0, altKey: 0, metaKey: 0, repeat: 0, locale: 0, getModifierState: zd, charCode: function(a) {
      return a.type === "keypress" ? od(a) : 0;
    }, keyCode: function(a) {
      return a.type === "keydown" || a.type === "keyup" ? a.keyCode : 0;
    }, which: function(a) {
      return a.type === "keypress" ? od(a) : a.type === "keydown" || a.type === "keyup" ? a.keyCode : 0;
    } }), Rd = rd(Qd), Sd = A({}, Ad, { pointerId: 0, width: 0, height: 0, pressure: 0, tangentialPressure: 0, tiltX: 0, tiltY: 0, twist: 0, pointerType: 0, isPrimary: 0 }), Td = rd(Sd), Ud = A({}, ud, { touches: 0, targetTouches: 0, changedTouches: 0, altKey: 0, metaKey: 0, ctrlKey: 0, shiftKey: 0, getModifierState: zd }), Vd = rd(Ud), Wd = A({}, sd, { propertyName: 0, elapsedTime: 0, pseudoElement: 0 }), Xd = rd(Wd), Yd = A({}, Ad, {
      deltaX: function(a) {
        return "deltaX" in a ? a.deltaX : "wheelDeltaX" in a ? -a.wheelDeltaX : 0;
      },
      deltaY: function(a) {
        return "deltaY" in a ? a.deltaY : "wheelDeltaY" in a ? -a.wheelDeltaY : "wheelDelta" in a ? -a.wheelDelta : 0;
      },
      deltaZ: 0,
      deltaMode: 0
    }), Zd = rd(Yd), $d = [9, 13, 27, 32], ae = ia && "CompositionEvent" in window, be = null;
    ia && "documentMode" in document && (be = document.documentMode);
    var ce = ia && "TextEvent" in window && !be, de = ia && (!ae || be && 8 < be && 11 >= be), ee = " ", fe = !1;
    function ge(a, b) {
      switch (a) {
        case "keyup":
          return $d.indexOf(b.keyCode) !== -1;
        case "keydown":
          return b.keyCode !== 229;
        case "keypress":
        case "mousedown":
        case "focusout":
          return !0;
        default:
          return !1;
      }
    }
    function he(a) {
      return a = a.detail, typeof a == "object" && "data" in a ? a.data : null;
    }
    var ie = !1;
    function je(a, b) {
      switch (a) {
        case "compositionend":
          return he(b);
        case "keypress":
          return b.which !== 32 ? null : (fe = !0, ee);
        case "textInput":
          return a = b.data, a === ee && fe ? null : a;
        default:
          return null;
      }
    }
    function ke(a, b) {
      if (ie)
        return a === "compositionend" || !ae && ge(a, b) ? (a = nd(), md = ld = kd = null, ie = !1, a) : null;
      switch (a) {
        case "paste":
          return null;
        case "keypress":
          if (!(b.ctrlKey || b.altKey || b.metaKey) || b.ctrlKey && b.altKey) {
            if (b.char && 1 < b.char.length)
              return b.char;
            if (b.which)
              return String.fromCharCode(b.which);
          }
          return null;
        case "compositionend":
          return de && b.locale !== "ko" ? null : b.data;
        default:
          return null;
      }
    }
    var le = { color: !0, date: !0, datetime: !0, "datetime-local": !0, email: !0, month: !0, number: !0, password: !0, range: !0, search: !0, tel: !0, text: !0, time: !0, url: !0, week: !0 };
    function me(a) {
      var b = a && a.nodeName && a.nodeName.toLowerCase();
      return b === "input" ? !!le[a.type] : b === "textarea";
    }
    function ne(a, b, c, d) {
      Eb(d), b = oe(b, "onChange"), 0 < b.length && (c = new td("onChange", "change", null, c, d), a.push({ event: c, listeners: b }));
    }
    var pe = null, qe = null;
    function re(a) {
      se(a, 0);
    }
    function te(a) {
      var b = ue(a);
      if (Wa(b))
        return a;
    }
    function ve(a, b) {
      if (a === "change")
        return b;
    }
    var we = !1;
    ia && (ia ? (ye = "oninput" in document, ye || (ze = document.createElement("div"), ze.setAttribute("oninput", "return;"), ye = typeof ze.oninput == "function"), xe = ye) : xe = !1, we = xe && (!document.documentMode || 9 < document.documentMode));
    var xe, ye, ze;
    function Ae() {
      pe && (pe.detachEvent("onpropertychange", Be), qe = pe = null);
    }
    function Be(a) {
      if (a.propertyName === "value" && te(qe)) {
        var b = [];
        ne(b, qe, a, xb(a)), Jb(re, b);
      }
    }
    function Ce(a, b, c) {
      a === "focusin" ? (Ae(), pe = b, qe = c, pe.attachEvent("onpropertychange", Be)) : a === "focusout" && Ae();
    }
    function De(a) {
      if (a === "selectionchange" || a === "keyup" || a === "keydown")
        return te(qe);
    }
    function Ee(a, b) {
      if (a === "click")
        return te(b);
    }
    function Fe(a, b) {
      if (a === "input" || a === "change")
        return te(b);
    }
    function Ge(a, b) {
      return a === b && (a !== 0 || 1 / a === 1 / b) || a !== a && b !== b;
    }
    var He = typeof Object.is == "function" ? Object.is : Ge;
    function Ie(a, b) {
      if (He(a, b))
        return !0;
      if (typeof a != "object" || a === null || typeof b != "object" || b === null)
        return !1;
      var c = Object.keys(a), d = Object.keys(b);
      if (c.length !== d.length)
        return !1;
      for (d = 0; d < c.length; d++) {
        var e = c[d];
        if (!ja.call(b, e) || !He(a[e], b[e]))
          return !1;
      }
      return !0;
    }
    function Je(a) {
      for (; a && a.firstChild; )
        a = a.firstChild;
      return a;
    }
    function Ke(a, b) {
      var c = Je(a);
      a = 0;
      for (var d; c; ) {
        if (c.nodeType === 3) {
          if (d = a + c.textContent.length, a <= b && d >= b)
            return { node: c, offset: b - a };
          a = d;
        }
        a: {
          for (; c; ) {
            if (c.nextSibling) {
              c = c.nextSibling;
              break a;
            }
            c = c.parentNode;
          }
          c = void 0;
        }
        c = Je(c);
      }
    }
    function Le(a, b) {
      return a && b ? a === b ? !0 : a && a.nodeType === 3 ? !1 : b && b.nodeType === 3 ? Le(a, b.parentNode) : "contains" in a ? a.contains(b) : a.compareDocumentPosition ? !!(a.compareDocumentPosition(b) & 16) : !1 : !1;
    }
    function Me() {
      for (var a = window, b = Xa(); b instanceof a.HTMLIFrameElement; ) {
        try {
          var c = typeof b.contentWindow.location.href == "string";
        } catch {
          c = !1;
        }
        if (c)
          a = b.contentWindow;
        else
          break;
        b = Xa(a.document);
      }
      return b;
    }
    function Ne(a) {
      var b = a && a.nodeName && a.nodeName.toLowerCase();
      return b && (b === "input" && (a.type === "text" || a.type === "search" || a.type === "tel" || a.type === "url" || a.type === "password") || b === "textarea" || a.contentEditable === "true");
    }
    function Oe(a) {
      var b = Me(), c = a.focusedElem, d = a.selectionRange;
      if (b !== c && c && c.ownerDocument && Le(c.ownerDocument.documentElement, c)) {
        if (d !== null && Ne(c)) {
          if (b = d.start, a = d.end, a === void 0 && (a = b), "selectionStart" in c)
            c.selectionStart = b, c.selectionEnd = Math.min(a, c.value.length);
          else if (a = (b = c.ownerDocument || document) && b.defaultView || window, a.getSelection) {
            a = a.getSelection();
            var e = c.textContent.length, f = Math.min(d.start, e);
            d = d.end === void 0 ? f : Math.min(d.end, e), !a.extend && f > d && (e = d, d = f, f = e), e = Ke(c, f);
            var g = Ke(
              c,
              d
            );
            e && g && (a.rangeCount !== 1 || a.anchorNode !== e.node || a.anchorOffset !== e.offset || a.focusNode !== g.node || a.focusOffset !== g.offset) && (b = b.createRange(), b.setStart(e.node, e.offset), a.removeAllRanges(), f > d ? (a.addRange(b), a.extend(g.node, g.offset)) : (b.setEnd(g.node, g.offset), a.addRange(b)));
          }
        }
        for (b = [], a = c; a = a.parentNode; )
          a.nodeType === 1 && b.push({ element: a, left: a.scrollLeft, top: a.scrollTop });
        for (typeof c.focus == "function" && c.focus(), c = 0; c < b.length; c++)
          a = b[c], a.element.scrollLeft = a.left, a.element.scrollTop = a.top;
      }
    }
    var Pe = ia && "documentMode" in document && 11 >= document.documentMode, Qe = null, Re = null, Se = null, Te = !1;
    function Ue(a, b, c) {
      var d = c.window === c ? c.document : c.nodeType === 9 ? c : c.ownerDocument;
      Te || Qe == null || Qe !== Xa(d) || (d = Qe, "selectionStart" in d && Ne(d) ? d = { start: d.selectionStart, end: d.selectionEnd } : (d = (d.ownerDocument && d.ownerDocument.defaultView || window).getSelection(), d = { anchorNode: d.anchorNode, anchorOffset: d.anchorOffset, focusNode: d.focusNode, focusOffset: d.focusOffset }), Se && Ie(Se, d) || (Se = d, d = oe(Re, "onSelect"), 0 < d.length && (b = new td("onSelect", "select", null, b, c), a.push({ event: b, listeners: d }), b.target = Qe)));
    }
    function Ve(a, b) {
      var c = {};
      return c[a.toLowerCase()] = b.toLowerCase(), c["Webkit" + a] = "webkit" + b, c["Moz" + a] = "moz" + b, c;
    }
    var We = { animationend: Ve("Animation", "AnimationEnd"), animationiteration: Ve("Animation", "AnimationIteration"), animationstart: Ve("Animation", "AnimationStart"), transitionend: Ve("Transition", "TransitionEnd") }, Xe = {}, Ye = {};
    ia && (Ye = document.createElement("div").style, "AnimationEvent" in window || (delete We.animationend.animation, delete We.animationiteration.animation, delete We.animationstart.animation), "TransitionEvent" in window || delete We.transitionend.transition);
    function Ze(a) {
      if (Xe[a])
        return Xe[a];
      if (!We[a])
        return a;
      var b = We[a], c;
      for (c in b)
        if (b.hasOwnProperty(c) && c in Ye)
          return Xe[a] = b[c];
      return a;
    }
    var $e = Ze("animationend"), af = Ze("animationiteration"), bf = Ze("animationstart"), cf = Ze("transitionend"), df = /* @__PURE__ */ new Map(), ef = "abort auxClick cancel canPlay canPlayThrough click close contextMenu copy cut drag dragEnd dragEnter dragExit dragLeave dragOver dragStart drop durationChange emptied encrypted ended error gotPointerCapture input invalid keyDown keyPress keyUp load loadedData loadedMetadata loadStart lostPointerCapture mouseDown mouseMove mouseOut mouseOver mouseUp paste pause play playing pointerCancel pointerDown pointerMove pointerOut pointerOver pointerUp progress rateChange reset resize seeked seeking stalled submit suspend timeUpdate touchCancel touchEnd touchStart volumeChange scroll toggle touchMove waiting wheel".split(" ");
    function ff(a, b) {
      df.set(a, b), fa(b, [a]);
    }
    for (gf = 0; gf < ef.length; gf++)
      hf = ef[gf], jf = hf.toLowerCase(), kf = hf[0].toUpperCase() + hf.slice(1), ff(jf, "on" + kf);
    var hf, jf, kf, gf;
    ff($e, "onAnimationEnd");
    ff(af, "onAnimationIteration");
    ff(bf, "onAnimationStart");
    ff("dblclick", "onDoubleClick");
    ff("focusin", "onFocus");
    ff("focusout", "onBlur");
    ff(cf, "onTransitionEnd");
    ha("onMouseEnter", ["mouseout", "mouseover"]);
    ha("onMouseLeave", ["mouseout", "mouseover"]);
    ha("onPointerEnter", ["pointerout", "pointerover"]);
    ha("onPointerLeave", ["pointerout", "pointerover"]);
    fa("onChange", "change click focusin focusout input keydown keyup selectionchange".split(" "));
    fa("onSelect", "focusout contextmenu dragend focusin keydown keyup mousedown mouseup selectionchange".split(" "));
    fa("onBeforeInput", ["compositionend", "keypress", "textInput", "paste"]);
    fa("onCompositionEnd", "compositionend focusout keydown keypress keyup mousedown".split(" "));
    fa("onCompositionStart", "compositionstart focusout keydown keypress keyup mousedown".split(" "));
    fa("onCompositionUpdate", "compositionupdate focusout keydown keypress keyup mousedown".split(" "));
    var lf = "abort canplay canplaythrough durationchange emptied encrypted ended error loadeddata loadedmetadata loadstart pause play playing progress ratechange resize seeked seeking stalled suspend timeupdate volumechange waiting".split(" "), mf = new Set("cancel close invalid load scroll toggle".split(" ").concat(lf));
    function nf(a, b, c) {
      var d = a.type || "unknown-event";
      a.currentTarget = c, Ub(d, b, void 0, a), a.currentTarget = null;
    }
    function se(a, b) {
      b = (b & 4) !== 0;
      for (var c = 0; c < a.length; c++) {
        var d = a[c], e = d.event;
        d = d.listeners;
        a: {
          var f = void 0;
          if (b)
            for (var g = d.length - 1; 0 <= g; g--) {
              var h = d[g], k = h.instance, l = h.currentTarget;
              if (h = h.listener, k !== f && e.isPropagationStopped())
                break a;
              nf(e, h, l), f = k;
            }
          else
            for (g = 0; g < d.length; g++) {
              if (h = d[g], k = h.instance, l = h.currentTarget, h = h.listener, k !== f && e.isPropagationStopped())
                break a;
              nf(e, h, l), f = k;
            }
        }
      }
      if (Qb)
        throw a = Rb, Qb = !1, Rb = null, a;
    }
    function D(a, b) {
      var c = b[of];
      c === void 0 && (c = b[of] = /* @__PURE__ */ new Set());
      var d = a + "__bubble";
      c.has(d) || (pf(b, a, 2, !1), c.add(d));
    }
    function qf(a, b, c) {
      var d = 0;
      b && (d |= 4), pf(c, a, d, b);
    }
    var rf = "_reactListening" + Math.random().toString(36).slice(2);
    function sf(a) {
      if (!a[rf]) {
        a[rf] = !0, da.forEach(function(b2) {
          b2 !== "selectionchange" && (mf.has(b2) || qf(b2, !1, a), qf(b2, !0, a));
        });
        var b = a.nodeType === 9 ? a : a.ownerDocument;
        b === null || b[rf] || (b[rf] = !0, qf("selectionchange", !1, b));
      }
    }
    function pf(a, b, c, d) {
      switch (jd(b)) {
        case 1:
          var e = ed;
          break;
        case 4:
          e = gd;
          break;
        default:
          e = fd;
      }
      c = e.bind(null, b, c, a), e = void 0, !Lb || b !== "touchstart" && b !== "touchmove" && b !== "wheel" || (e = !0), d ? e !== void 0 ? a.addEventListener(b, c, { capture: !0, passive: e }) : a.addEventListener(b, c, !0) : e !== void 0 ? a.addEventListener(b, c, { passive: e }) : a.addEventListener(b, c, !1);
    }
    function hd(a, b, c, d, e) {
      var f = d;
      if (!(b & 1) && !(b & 2) && d !== null)
        a:
          for (; ; ) {
            if (d === null)
              return;
            var g = d.tag;
            if (g === 3 || g === 4) {
              var h = d.stateNode.containerInfo;
              if (h === e || h.nodeType === 8 && h.parentNode === e)
                break;
              if (g === 4)
                for (g = d.return; g !== null; ) {
                  var k = g.tag;
                  if ((k === 3 || k === 4) && (k = g.stateNode.containerInfo, k === e || k.nodeType === 8 && k.parentNode === e))
                    return;
                  g = g.return;
                }
              for (; h !== null; ) {
                if (g = Wc(h), g === null)
                  return;
                if (k = g.tag, k === 5 || k === 6) {
                  d = f = g;
                  continue a;
                }
                h = h.parentNode;
              }
            }
            d = d.return;
          }
      Jb(function() {
        var d2 = f, e2 = xb(c), g2 = [];
        a: {
          var h2 = df.get(a);
          if (h2 !== void 0) {
            var k2 = td, n = a;
            switch (a) {
              case "keypress":
                if (od(c) === 0)
                  break a;
              case "keydown":
              case "keyup":
                k2 = Rd;
                break;
              case "focusin":
                n = "focus", k2 = Fd;
                break;
              case "focusout":
                n = "blur", k2 = Fd;
                break;
              case "beforeblur":
              case "afterblur":
                k2 = Fd;
                break;
              case "click":
                if (c.button === 2)
                  break a;
              case "auxclick":
              case "dblclick":
              case "mousedown":
              case "mousemove":
              case "mouseup":
              case "mouseout":
              case "mouseover":
              case "contextmenu":
                k2 = Bd;
                break;
              case "drag":
              case "dragend":
              case "dragenter":
              case "dragexit":
              case "dragleave":
              case "dragover":
              case "dragstart":
              case "drop":
                k2 = Dd;
                break;
              case "touchcancel":
              case "touchend":
              case "touchmove":
              case "touchstart":
                k2 = Vd;
                break;
              case $e:
              case af:
              case bf:
                k2 = Hd;
                break;
              case cf:
                k2 = Xd;
                break;
              case "scroll":
                k2 = vd;
                break;
              case "wheel":
                k2 = Zd;
                break;
              case "copy":
              case "cut":
              case "paste":
                k2 = Jd;
                break;
              case "gotpointercapture":
              case "lostpointercapture":
              case "pointercancel":
              case "pointerdown":
              case "pointermove":
              case "pointerout":
              case "pointerover":
              case "pointerup":
                k2 = Td;
            }
            var t7 = (b & 4) !== 0, J = !t7 && a === "scroll", x = t7 ? h2 !== null ? h2 + "Capture" : null : h2;
            t7 = [];
            for (var w = d2, u; w !== null; ) {
              u = w;
              var F = u.stateNode;
              if (u.tag === 5 && F !== null && (u = F, x !== null && (F = Kb(w, x), F != null && t7.push(tf(w, F, u)))), J)
                break;
              w = w.return;
            }
            0 < t7.length && (h2 = new k2(h2, n, null, c, e2), g2.push({ event: h2, listeners: t7 }));
          }
        }
        if (!(b & 7)) {
          a: {
            if (h2 = a === "mouseover" || a === "pointerover", k2 = a === "mouseout" || a === "pointerout", h2 && c !== wb && (n = c.relatedTarget || c.fromElement) && (Wc(n) || n[uf]))
              break a;
            if ((k2 || h2) && (h2 = e2.window === e2 ? e2 : (h2 = e2.ownerDocument) ? h2.defaultView || h2.parentWindow : window, k2 ? (n = c.relatedTarget || c.toElement, k2 = d2, n = n ? Wc(n) : null, n !== null && (J = Vb(n), n !== J || n.tag !== 5 && n.tag !== 6) && (n = null)) : (k2 = null, n = d2), k2 !== n)) {
              if (t7 = Bd, F = "onMouseLeave", x = "onMouseEnter", w = "mouse", (a === "pointerout" || a === "pointerover") && (t7 = Td, F = "onPointerLeave", x = "onPointerEnter", w = "pointer"), J = k2 == null ? h2 : ue(k2), u = n == null ? h2 : ue(n), h2 = new t7(F, w + "leave", k2, c, e2), h2.target = J, h2.relatedTarget = u, F = null, Wc(e2) === d2 && (t7 = new t7(x, w + "enter", n, c, e2), t7.target = u, t7.relatedTarget = J, F = t7), J = F, k2 && n)
                b: {
                  for (t7 = k2, x = n, w = 0, u = t7; u; u = vf(u))
                    w++;
                  for (u = 0, F = x; F; F = vf(F))
                    u++;
                  for (; 0 < w - u; )
                    t7 = vf(t7), w--;
                  for (; 0 < u - w; )
                    x = vf(x), u--;
                  for (; w--; ) {
                    if (t7 === x || x !== null && t7 === x.alternate)
                      break b;
                    t7 = vf(t7), x = vf(x);
                  }
                  t7 = null;
                }
              else
                t7 = null;
              k2 !== null && wf(g2, h2, k2, t7, !1), n !== null && J !== null && wf(g2, J, n, t7, !0);
            }
          }
          a: {
            if (h2 = d2 ? ue(d2) : window, k2 = h2.nodeName && h2.nodeName.toLowerCase(), k2 === "select" || k2 === "input" && h2.type === "file")
              var na = ve;
            else if (me(h2))
              if (we)
                na = Fe;
              else {
                na = De;
                var xa = Ce;
              }
            else
              (k2 = h2.nodeName) && k2.toLowerCase() === "input" && (h2.type === "checkbox" || h2.type === "radio") && (na = Ee);
            if (na && (na = na(a, d2))) {
              ne(g2, na, c, e2);
              break a;
            }
            xa && xa(a, h2, d2), a === "focusout" && (xa = h2._wrapperState) && xa.controlled && h2.type === "number" && cb(h2, "number", h2.value);
          }
          switch (xa = d2 ? ue(d2) : window, a) {
            case "focusin":
              (me(xa) || xa.contentEditable === "true") && (Qe = xa, Re = d2, Se = null);
              break;
            case "focusout":
              Se = Re = Qe = null;
              break;
            case "mousedown":
              Te = !0;
              break;
            case "contextmenu":
            case "mouseup":
            case "dragend":
              Te = !1, Ue(g2, c, e2);
              break;
            case "selectionchange":
              if (Pe)
                break;
            case "keydown":
            case "keyup":
              Ue(g2, c, e2);
          }
          var $a;
          if (ae)
            b: {
              switch (a) {
                case "compositionstart":
                  var ba = "onCompositionStart";
                  break b;
                case "compositionend":
                  ba = "onCompositionEnd";
                  break b;
                case "compositionupdate":
                  ba = "onCompositionUpdate";
                  break b;
              }
              ba = void 0;
            }
          else
            ie ? ge(a, c) && (ba = "onCompositionEnd") : a === "keydown" && c.keyCode === 229 && (ba = "onCompositionStart");
          ba && (de && c.locale !== "ko" && (ie || ba !== "onCompositionStart" ? ba === "onCompositionEnd" && ie && ($a = nd()) : (kd = e2, ld = "value" in kd ? kd.value : kd.textContent, ie = !0)), xa = oe(d2, ba), 0 < xa.length && (ba = new Ld(ba, a, null, c, e2), g2.push({ event: ba, listeners: xa }), $a ? ba.data = $a : ($a = he(c), $a !== null && (ba.data = $a)))), ($a = ce ? je(a, c) : ke(a, c)) && (d2 = oe(d2, "onBeforeInput"), 0 < d2.length && (e2 = new Ld("onBeforeInput", "beforeinput", null, c, e2), g2.push({ event: e2, listeners: d2 }), e2.data = $a));
        }
        se(g2, b);
      });
    }
    function tf(a, b, c) {
      return { instance: a, listener: b, currentTarget: c };
    }
    function oe(a, b) {
      for (var c = b + "Capture", d = []; a !== null; ) {
        var e = a, f = e.stateNode;
        e.tag === 5 && f !== null && (e = f, f = Kb(a, c), f != null && d.unshift(tf(a, f, e)), f = Kb(a, b), f != null && d.push(tf(a, f, e))), a = a.return;
      }
      return d;
    }
    function vf(a) {
      if (a === null)
        return null;
      do
        a = a.return;
      while (a && a.tag !== 5);
      return a || null;
    }
    function wf(a, b, c, d, e) {
      for (var f = b._reactName, g = []; c !== null && c !== d; ) {
        var h = c, k = h.alternate, l = h.stateNode;
        if (k !== null && k === d)
          break;
        h.tag === 5 && l !== null && (h = l, e ? (k = Kb(c, f), k != null && g.unshift(tf(c, k, h))) : e || (k = Kb(c, f), k != null && g.push(tf(c, k, h)))), c = c.return;
      }
      g.length !== 0 && a.push({ event: b, listeners: g });
    }
    var xf = /\r\n?/g, yf = /\u0000|\uFFFD/g;
    function zf(a) {
      return (typeof a == "string" ? a : "" + a).replace(xf, `
`).replace(yf, "");
    }
    function Af(a, b, c) {
      if (b = zf(b), zf(a) !== b && c)
        throw Error(p(425));
    }
    function Bf() {
    }
    var Cf = null, Df = null;
    function Ef(a, b) {
      return a === "textarea" || a === "noscript" || typeof b.children == "string" || typeof b.children == "number" || typeof b.dangerouslySetInnerHTML == "object" && b.dangerouslySetInnerHTML !== null && b.dangerouslySetInnerHTML.__html != null;
    }
    var Ff = typeof setTimeout == "function" ? setTimeout : void 0, Gf = typeof clearTimeout == "function" ? clearTimeout : void 0, Hf = typeof Promise == "function" ? Promise : void 0, Jf = typeof queueMicrotask == "function" ? queueMicrotask : typeof Hf < "u" ? function(a) {
      return Hf.resolve(null).then(a).catch(If);
    } : Ff;
    function If(a) {
      setTimeout(function() {
        throw a;
      });
    }
    function Kf(a, b) {
      var c = b, d = 0;
      do {
        var e = c.nextSibling;
        if (a.removeChild(c), e && e.nodeType === 8)
          if (c = e.data, c === "/$") {
            if (d === 0) {
              a.removeChild(e), bd(b);
              return;
            }
            d--;
          } else
            c !== "$" && c !== "$?" && c !== "$!" || d++;
        c = e;
      } while (c);
      bd(b);
    }
    function Lf(a) {
      for (; a != null; a = a.nextSibling) {
        var b = a.nodeType;
        if (b === 1 || b === 3)
          break;
        if (b === 8) {
          if (b = a.data, b === "$" || b === "$!" || b === "$?")
            break;
          if (b === "/$")
            return null;
        }
      }
      return a;
    }
    function Mf(a) {
      a = a.previousSibling;
      for (var b = 0; a; ) {
        if (a.nodeType === 8) {
          var c = a.data;
          if (c === "$" || c === "$!" || c === "$?") {
            if (b === 0)
              return a;
            b--;
          } else
            c === "/$" && b++;
        }
        a = a.previousSibling;
      }
      return null;
    }
    var Nf = Math.random().toString(36).slice(2), Of = "__reactFiber$" + Nf, Pf = "__reactProps$" + Nf, uf = "__reactContainer$" + Nf, of = "__reactEvents$" + Nf, Qf = "__reactListeners$" + Nf, Rf = "__reactHandles$" + Nf;
    function Wc(a) {
      var b = a[Of];
      if (b)
        return b;
      for (var c = a.parentNode; c; ) {
        if (b = c[uf] || c[Of]) {
          if (c = b.alternate, b.child !== null || c !== null && c.child !== null)
            for (a = Mf(a); a !== null; ) {
              if (c = a[Of])
                return c;
              a = Mf(a);
            }
          return b;
        }
        a = c, c = a.parentNode;
      }
      return null;
    }
    function Cb(a) {
      return a = a[Of] || a[uf], !a || a.tag !== 5 && a.tag !== 6 && a.tag !== 13 && a.tag !== 3 ? null : a;
    }
    function ue(a) {
      if (a.tag === 5 || a.tag === 6)
        return a.stateNode;
      throw Error(p(33));
    }
    function Db(a) {
      return a[Pf] || null;
    }
    var Sf = [], Tf = -1;
    function Uf(a) {
      return { current: a };
    }
    function E(a) {
      0 > Tf || (a.current = Sf[Tf], Sf[Tf] = null, Tf--);
    }
    function G(a, b) {
      Tf++, Sf[Tf] = a.current, a.current = b;
    }
    var Vf = {}, H = Uf(Vf), Wf = Uf(!1), Xf = Vf;
    function Yf(a, b) {
      var c = a.type.contextTypes;
      if (!c)
        return Vf;
      var d = a.stateNode;
      if (d && d.__reactInternalMemoizedUnmaskedChildContext === b)
        return d.__reactInternalMemoizedMaskedChildContext;
      var e = {}, f;
      for (f in c)
        e[f] = b[f];
      return d && (a = a.stateNode, a.__reactInternalMemoizedUnmaskedChildContext = b, a.__reactInternalMemoizedMaskedChildContext = e), e;
    }
    function Zf(a) {
      return a = a.childContextTypes, a != null;
    }
    function $f() {
      E(Wf), E(H);
    }
    function ag(a, b, c) {
      if (H.current !== Vf)
        throw Error(p(168));
      G(H, b), G(Wf, c);
    }
    function bg(a, b, c) {
      var d = a.stateNode;
      if (b = b.childContextTypes, typeof d.getChildContext != "function")
        return c;
      d = d.getChildContext();
      for (var e in d)
        if (!(e in b))
          throw Error(p(108, Ra(a) || "Unknown", e));
      return A({}, c, d);
    }
    function cg(a) {
      return a = (a = a.stateNode) && a.__reactInternalMemoizedMergedChildContext || Vf, Xf = H.current, G(H, a), G(Wf, Wf.current), !0;
    }
    function dg(a, b, c) {
      var d = a.stateNode;
      if (!d)
        throw Error(p(169));
      c ? (a = bg(a, b, Xf), d.__reactInternalMemoizedMergedChildContext = a, E(Wf), E(H), G(H, a)) : E(Wf), G(Wf, c);
    }
    var eg = null, fg = !1, gg = !1;
    function hg(a) {
      eg === null ? eg = [a] : eg.push(a);
    }
    function ig(a) {
      fg = !0, hg(a);
    }
    function jg() {
      if (!gg && eg !== null) {
        gg = !0;
        var a = 0, b = C;
        try {
          var c = eg;
          for (C = 1; a < c.length; a++) {
            var d = c[a];
            do
              d = d(!0);
            while (d !== null);
          }
          eg = null, fg = !1;
        } catch (e) {
          throw eg !== null && (eg = eg.slice(a + 1)), ac(fc, jg), e;
        } finally {
          C = b, gg = !1;
        }
      }
      return null;
    }
    var kg = [], lg = 0, mg = null, ng = 0, og = [], pg = 0, qg = null, rg = 1, sg = "";
    function tg(a, b) {
      kg[lg++] = ng, kg[lg++] = mg, mg = a, ng = b;
    }
    function ug(a, b, c) {
      og[pg++] = rg, og[pg++] = sg, og[pg++] = qg, qg = a;
      var d = rg;
      a = sg;
      var e = 32 - oc(d) - 1;
      d &= ~(1 << e), c += 1;
      var f = 32 - oc(b) + e;
      if (30 < f) {
        var g = e - e % 5;
        f = (d & (1 << g) - 1).toString(32), d >>= g, e -= g, rg = 1 << 32 - oc(b) + e | c << e | d, sg = f + a;
      } else
        rg = 1 << f | c << e | d, sg = a;
    }
    function vg(a) {
      a.return !== null && (tg(a, 1), ug(a, 1, 0));
    }
    function wg(a) {
      for (; a === mg; )
        mg = kg[--lg], kg[lg] = null, ng = kg[--lg], kg[lg] = null;
      for (; a === qg; )
        qg = og[--pg], og[pg] = null, sg = og[--pg], og[pg] = null, rg = og[--pg], og[pg] = null;
    }
    var xg = null, yg = null, I = !1, zg = null;
    function Ag(a, b) {
      var c = Bg(5, null, null, 0);
      c.elementType = "DELETED", c.stateNode = b, c.return = a, b = a.deletions, b === null ? (a.deletions = [c], a.flags |= 16) : b.push(c);
    }
    function Cg(a, b) {
      switch (a.tag) {
        case 5:
          var c = a.type;
          return b = b.nodeType !== 1 || c.toLowerCase() !== b.nodeName.toLowerCase() ? null : b, b !== null ? (a.stateNode = b, xg = a, yg = Lf(b.firstChild), !0) : !1;
        case 6:
          return b = a.pendingProps === "" || b.nodeType !== 3 ? null : b, b !== null ? (a.stateNode = b, xg = a, yg = null, !0) : !1;
        case 13:
          return b = b.nodeType !== 8 ? null : b, b !== null ? (c = qg !== null ? { id: rg, overflow: sg } : null, a.memoizedState = { dehydrated: b, treeContext: c, retryLane: 1073741824 }, c = Bg(18, null, null, 0), c.stateNode = b, c.return = a, a.child = c, xg = a, yg = null, !0) : !1;
        default:
          return !1;
      }
    }
    function Dg(a) {
      return (a.mode & 1) !== 0 && (a.flags & 128) === 0;
    }
    function Eg(a) {
      if (I) {
        var b = yg;
        if (b) {
          var c = b;
          if (!Cg(a, b)) {
            if (Dg(a))
              throw Error(p(418));
            b = Lf(c.nextSibling);
            var d = xg;
            b && Cg(a, b) ? Ag(d, c) : (a.flags = a.flags & -4097 | 2, I = !1, xg = a);
          }
        } else {
          if (Dg(a))
            throw Error(p(418));
          a.flags = a.flags & -4097 | 2, I = !1, xg = a;
        }
      }
    }
    function Fg(a) {
      for (a = a.return; a !== null && a.tag !== 5 && a.tag !== 3 && a.tag !== 13; )
        a = a.return;
      xg = a;
    }
    function Gg(a) {
      if (a !== xg)
        return !1;
      if (!I)
        return Fg(a), I = !0, !1;
      var b;
      if ((b = a.tag !== 3) && !(b = a.tag !== 5) && (b = a.type, b = b !== "head" && b !== "body" && !Ef(a.type, a.memoizedProps)), b && (b = yg)) {
        if (Dg(a))
          throw Hg(), Error(p(418));
        for (; b; )
          Ag(a, b), b = Lf(b.nextSibling);
      }
      if (Fg(a), a.tag === 13) {
        if (a = a.memoizedState, a = a !== null ? a.dehydrated : null, !a)
          throw Error(p(317));
        a: {
          for (a = a.nextSibling, b = 0; a; ) {
            if (a.nodeType === 8) {
              var c = a.data;
              if (c === "/$") {
                if (b === 0) {
                  yg = Lf(a.nextSibling);
                  break a;
                }
                b--;
              } else
                c !== "$" && c !== "$!" && c !== "$?" || b++;
            }
            a = a.nextSibling;
          }
          yg = null;
        }
      } else
        yg = xg ? Lf(a.stateNode.nextSibling) : null;
      return !0;
    }
    function Hg() {
      for (var a = yg; a; )
        a = Lf(a.nextSibling);
    }
    function Ig() {
      yg = xg = null, I = !1;
    }
    function Jg(a) {
      zg === null ? zg = [a] : zg.push(a);
    }
    var Kg = ua.ReactCurrentBatchConfig;
    function Lg(a, b) {
      if (a && a.defaultProps) {
        b = A({}, b), a = a.defaultProps;
        for (var c in a)
          b[c] === void 0 && (b[c] = a[c]);
        return b;
      }
      return b;
    }
    var Mg = Uf(null), Ng = null, Og = null, Pg = null;
    function Qg() {
      Pg = Og = Ng = null;
    }
    function Rg(a) {
      var b = Mg.current;
      E(Mg), a._currentValue = b;
    }
    function Sg(a, b, c) {
      for (; a !== null; ) {
        var d = a.alternate;
        if ((a.childLanes & b) !== b ? (a.childLanes |= b, d !== null && (d.childLanes |= b)) : d !== null && (d.childLanes & b) !== b && (d.childLanes |= b), a === c)
          break;
        a = a.return;
      }
    }
    function Tg(a, b) {
      Ng = a, Pg = Og = null, a = a.dependencies, a !== null && a.firstContext !== null && (a.lanes & b && (Ug = !0), a.firstContext = null);
    }
    function Vg(a) {
      var b = a._currentValue;
      if (Pg !== a)
        if (a = { context: a, memoizedValue: b, next: null }, Og === null) {
          if (Ng === null)
            throw Error(p(308));
          Og = a, Ng.dependencies = { lanes: 0, firstContext: a };
        } else
          Og = Og.next = a;
      return b;
    }
    var Wg = null;
    function Xg(a) {
      Wg === null ? Wg = [a] : Wg.push(a);
    }
    function Yg(a, b, c, d) {
      var e = b.interleaved;
      return e === null ? (c.next = c, Xg(b)) : (c.next = e.next, e.next = c), b.interleaved = c, Zg(a, d);
    }
    function Zg(a, b) {
      a.lanes |= b;
      var c = a.alternate;
      for (c !== null && (c.lanes |= b), c = a, a = a.return; a !== null; )
        a.childLanes |= b, c = a.alternate, c !== null && (c.childLanes |= b), c = a, a = a.return;
      return c.tag === 3 ? c.stateNode : null;
    }
    var $g = !1;
    function ah(a) {
      a.updateQueue = { baseState: a.memoizedState, firstBaseUpdate: null, lastBaseUpdate: null, shared: { pending: null, interleaved: null, lanes: 0 }, effects: null };
    }
    function bh(a, b) {
      a = a.updateQueue, b.updateQueue === a && (b.updateQueue = { baseState: a.baseState, firstBaseUpdate: a.firstBaseUpdate, lastBaseUpdate: a.lastBaseUpdate, shared: a.shared, effects: a.effects });
    }
    function ch(a, b) {
      return { eventTime: a, lane: b, tag: 0, payload: null, callback: null, next: null };
    }
    function dh(a, b, c) {
      var d = a.updateQueue;
      if (d === null)
        return null;
      if (d = d.shared, K & 2) {
        var e = d.pending;
        return e === null ? b.next = b : (b.next = e.next, e.next = b), d.pending = b, Zg(a, c);
      }
      return e = d.interleaved, e === null ? (b.next = b, Xg(d)) : (b.next = e.next, e.next = b), d.interleaved = b, Zg(a, c);
    }
    function eh(a, b, c) {
      if (b = b.updateQueue, b !== null && (b = b.shared, (c & 4194240) !== 0)) {
        var d = b.lanes;
        d &= a.pendingLanes, c |= d, b.lanes = c, Cc(a, c);
      }
    }
    function fh(a, b) {
      var c = a.updateQueue, d = a.alternate;
      if (d !== null && (d = d.updateQueue, c === d)) {
        var e = null, f = null;
        if (c = c.firstBaseUpdate, c !== null) {
          do {
            var g = { eventTime: c.eventTime, lane: c.lane, tag: c.tag, payload: c.payload, callback: c.callback, next: null };
            f === null ? e = f = g : f = f.next = g, c = c.next;
          } while (c !== null);
          f === null ? e = f = b : f = f.next = b;
        } else
          e = f = b;
        c = { baseState: d.baseState, firstBaseUpdate: e, lastBaseUpdate: f, shared: d.shared, effects: d.effects }, a.updateQueue = c;
        return;
      }
      a = c.lastBaseUpdate, a === null ? c.firstBaseUpdate = b : a.next = b, c.lastBaseUpdate = b;
    }
    function gh(a, b, c, d) {
      var e = a.updateQueue;
      $g = !1;
      var f = e.firstBaseUpdate, g = e.lastBaseUpdate, h = e.shared.pending;
      if (h !== null) {
        e.shared.pending = null;
        var k = h, l = k.next;
        k.next = null, g === null ? f = l : g.next = l, g = k;
        var m = a.alternate;
        m !== null && (m = m.updateQueue, h = m.lastBaseUpdate, h !== g && (h === null ? m.firstBaseUpdate = l : h.next = l, m.lastBaseUpdate = k));
      }
      if (f !== null) {
        var q = e.baseState;
        g = 0, m = l = k = null, h = f;
        do {
          var r2 = h.lane, y = h.eventTime;
          if ((d & r2) === r2) {
            m !== null && (m = m.next = {
              eventTime: y,
              lane: 0,
              tag: h.tag,
              payload: h.payload,
              callback: h.callback,
              next: null
            });
            a: {
              var n = a, t7 = h;
              switch (r2 = b, y = c, t7.tag) {
                case 1:
                  if (n = t7.payload, typeof n == "function") {
                    q = n.call(y, q, r2);
                    break a;
                  }
                  q = n;
                  break a;
                case 3:
                  n.flags = n.flags & -65537 | 128;
                case 0:
                  if (n = t7.payload, r2 = typeof n == "function" ? n.call(y, q, r2) : n, r2 == null)
                    break a;
                  q = A({}, q, r2);
                  break a;
                case 2:
                  $g = !0;
              }
            }
            h.callback !== null && h.lane !== 0 && (a.flags |= 64, r2 = e.effects, r2 === null ? e.effects = [h] : r2.push(h));
          } else
            y = { eventTime: y, lane: r2, tag: h.tag, payload: h.payload, callback: h.callback, next: null }, m === null ? (l = m = y, k = q) : m = m.next = y, g |= r2;
          if (h = h.next, h === null) {
            if (h = e.shared.pending, h === null)
              break;
            r2 = h, h = r2.next, r2.next = null, e.lastBaseUpdate = r2, e.shared.pending = null;
          }
        } while (!0);
        if (m === null && (k = q), e.baseState = k, e.firstBaseUpdate = l, e.lastBaseUpdate = m, b = e.shared.interleaved, b !== null) {
          e = b;
          do
            g |= e.lane, e = e.next;
          while (e !== b);
        } else
          f === null && (e.shared.lanes = 0);
        hh |= g, a.lanes = g, a.memoizedState = q;
      }
    }
    function ih(a, b, c) {
      if (a = b.effects, b.effects = null, a !== null)
        for (b = 0; b < a.length; b++) {
          var d = a[b], e = d.callback;
          if (e !== null) {
            if (d.callback = null, d = c, typeof e != "function")
              throw Error(p(191, e));
            e.call(d);
          }
        }
    }
    var jh = new aa.Component().refs;
    function kh(a, b, c, d) {
      b = a.memoizedState, c = c(d, b), c = c == null ? b : A({}, b, c), a.memoizedState = c, a.lanes === 0 && (a.updateQueue.baseState = c);
    }
    var nh = { isMounted: function(a) {
      return (a = a._reactInternals) ? Vb(a) === a : !1;
    }, enqueueSetState: function(a, b, c) {
      a = a._reactInternals;
      var d = L(), e = lh(a), f = ch(d, e);
      f.payload = b, c != null && (f.callback = c), b = dh(a, f, e), b !== null && (mh(b, a, e, d), eh(b, a, e));
    }, enqueueReplaceState: function(a, b, c) {
      a = a._reactInternals;
      var d = L(), e = lh(a), f = ch(d, e);
      f.tag = 1, f.payload = b, c != null && (f.callback = c), b = dh(a, f, e), b !== null && (mh(b, a, e, d), eh(b, a, e));
    }, enqueueForceUpdate: function(a, b) {
      a = a._reactInternals;
      var c = L(), d = lh(a), e = ch(c, d);
      e.tag = 2, b != null && (e.callback = b), b = dh(a, e, d), b !== null && (mh(b, a, d, c), eh(b, a, d));
    } };
    function oh(a, b, c, d, e, f, g) {
      return a = a.stateNode, typeof a.shouldComponentUpdate == "function" ? a.shouldComponentUpdate(d, f, g) : b.prototype && b.prototype.isPureReactComponent ? !Ie(c, d) || !Ie(e, f) : !0;
    }
    function ph(a, b, c) {
      var d = !1, e = Vf, f = b.contextType;
      return typeof f == "object" && f !== null ? f = Vg(f) : (e = Zf(b) ? Xf : H.current, d = b.contextTypes, f = (d = d != null) ? Yf(a, e) : Vf), b = new b(c, f), a.memoizedState = b.state !== null && b.state !== void 0 ? b.state : null, b.updater = nh, a.stateNode = b, b._reactInternals = a, d && (a = a.stateNode, a.__reactInternalMemoizedUnmaskedChildContext = e, a.__reactInternalMemoizedMaskedChildContext = f), b;
    }
    function qh(a, b, c, d) {
      a = b.state, typeof b.componentWillReceiveProps == "function" && b.componentWillReceiveProps(c, d), typeof b.UNSAFE_componentWillReceiveProps == "function" && b.UNSAFE_componentWillReceiveProps(c, d), b.state !== a && nh.enqueueReplaceState(b, b.state, null);
    }
    function rh(a, b, c, d) {
      var e = a.stateNode;
      e.props = c, e.state = a.memoizedState, e.refs = jh, ah(a);
      var f = b.contextType;
      typeof f == "object" && f !== null ? e.context = Vg(f) : (f = Zf(b) ? Xf : H.current, e.context = Yf(a, f)), e.state = a.memoizedState, f = b.getDerivedStateFromProps, typeof f == "function" && (kh(a, b, f, c), e.state = a.memoizedState), typeof b.getDerivedStateFromProps == "function" || typeof e.getSnapshotBeforeUpdate == "function" || typeof e.UNSAFE_componentWillMount != "function" && typeof e.componentWillMount != "function" || (b = e.state, typeof e.componentWillMount == "function" && e.componentWillMount(), typeof e.UNSAFE_componentWillMount == "function" && e.UNSAFE_componentWillMount(), b !== e.state && nh.enqueueReplaceState(e, e.state, null), gh(a, c, e, d), e.state = a.memoizedState), typeof e.componentDidMount == "function" && (a.flags |= 4194308);
    }
    function sh(a, b, c) {
      if (a = c.ref, a !== null && typeof a != "function" && typeof a != "object") {
        if (c._owner) {
          if (c = c._owner, c) {
            if (c.tag !== 1)
              throw Error(p(309));
            var d = c.stateNode;
          }
          if (!d)
            throw Error(p(147, a));
          var e = d, f = "" + a;
          return b !== null && b.ref !== null && typeof b.ref == "function" && b.ref._stringRef === f ? b.ref : (b = function(a2) {
            var b2 = e.refs;
            b2 === jh && (b2 = e.refs = {}), a2 === null ? delete b2[f] : b2[f] = a2;
          }, b._stringRef = f, b);
        }
        if (typeof a != "string")
          throw Error(p(284));
        if (!c._owner)
          throw Error(p(290, a));
      }
      return a;
    }
    function th(a, b) {
      throw a = Object.prototype.toString.call(b), Error(p(31, a === "[object Object]" ? "object with keys {" + Object.keys(b).join(", ") + "}" : a));
    }
    function uh(a) {
      var b = a._init;
      return b(a._payload);
    }
    function vh(a) {
      function b(b2, c2) {
        if (a) {
          var d2 = b2.deletions;
          d2 === null ? (b2.deletions = [c2], b2.flags |= 16) : d2.push(c2);
        }
      }
      function c(c2, d2) {
        if (!a)
          return null;
        for (; d2 !== null; )
          b(c2, d2), d2 = d2.sibling;
        return null;
      }
      function d(a2, b2) {
        for (a2 = /* @__PURE__ */ new Map(); b2 !== null; )
          b2.key !== null ? a2.set(b2.key, b2) : a2.set(b2.index, b2), b2 = b2.sibling;
        return a2;
      }
      function e(a2, b2) {
        return a2 = wh(a2, b2), a2.index = 0, a2.sibling = null, a2;
      }
      function f(b2, c2, d2) {
        return b2.index = d2, a ? (d2 = b2.alternate, d2 !== null ? (d2 = d2.index, d2 < c2 ? (b2.flags |= 2, c2) : d2) : (b2.flags |= 2, c2)) : (b2.flags |= 1048576, c2);
      }
      function g(b2) {
        return a && b2.alternate === null && (b2.flags |= 2), b2;
      }
      function h(a2, b2, c2, d2) {
        return b2 === null || b2.tag !== 6 ? (b2 = xh(c2, a2.mode, d2), b2.return = a2, b2) : (b2 = e(b2, c2), b2.return = a2, b2);
      }
      function k(a2, b2, c2, d2) {
        var f2 = c2.type;
        return f2 === ya ? m(a2, b2, c2.props.children, d2, c2.key) : b2 !== null && (b2.elementType === f2 || typeof f2 == "object" && f2 !== null && f2.$$typeof === Ha && uh(f2) === b2.type) ? (d2 = e(b2, c2.props), d2.ref = sh(a2, b2, c2), d2.return = a2, d2) : (d2 = yh(c2.type, c2.key, c2.props, null, a2.mode, d2), d2.ref = sh(a2, b2, c2), d2.return = a2, d2);
      }
      function l(a2, b2, c2, d2) {
        return b2 === null || b2.tag !== 4 || b2.stateNode.containerInfo !== c2.containerInfo || b2.stateNode.implementation !== c2.implementation ? (b2 = zh(c2, a2.mode, d2), b2.return = a2, b2) : (b2 = e(b2, c2.children || []), b2.return = a2, b2);
      }
      function m(a2, b2, c2, d2, f2) {
        return b2 === null || b2.tag !== 7 ? (b2 = Ah(c2, a2.mode, d2, f2), b2.return = a2, b2) : (b2 = e(b2, c2), b2.return = a2, b2);
      }
      function q(a2, b2, c2) {
        if (typeof b2 == "string" && b2 !== "" || typeof b2 == "number")
          return b2 = xh("" + b2, a2.mode, c2), b2.return = a2, b2;
        if (typeof b2 == "object" && b2 !== null) {
          switch (b2.$$typeof) {
            case va:
              return c2 = yh(b2.type, b2.key, b2.props, null, a2.mode, c2), c2.ref = sh(a2, null, b2), c2.return = a2, c2;
            case wa:
              return b2 = zh(b2, a2.mode, c2), b2.return = a2, b2;
            case Ha:
              var d2 = b2._init;
              return q(a2, d2(b2._payload), c2);
          }
          if (eb(b2) || Ka(b2))
            return b2 = Ah(b2, a2.mode, c2, null), b2.return = a2, b2;
          th(a2, b2);
        }
        return null;
      }
      function r2(a2, b2, c2, d2) {
        var e2 = b2 !== null ? b2.key : null;
        if (typeof c2 == "string" && c2 !== "" || typeof c2 == "number")
          return e2 !== null ? null : h(a2, b2, "" + c2, d2);
        if (typeof c2 == "object" && c2 !== null) {
          switch (c2.$$typeof) {
            case va:
              return c2.key === e2 ? k(a2, b2, c2, d2) : null;
            case wa:
              return c2.key === e2 ? l(a2, b2, c2, d2) : null;
            case Ha:
              return e2 = c2._init, r2(
                a2,
                b2,
                e2(c2._payload),
                d2
              );
          }
          if (eb(c2) || Ka(c2))
            return e2 !== null ? null : m(a2, b2, c2, d2, null);
          th(a2, c2);
        }
        return null;
      }
      function y(a2, b2, c2, d2, e2) {
        if (typeof d2 == "string" && d2 !== "" || typeof d2 == "number")
          return a2 = a2.get(c2) || null, h(b2, a2, "" + d2, e2);
        if (typeof d2 == "object" && d2 !== null) {
          switch (d2.$$typeof) {
            case va:
              return a2 = a2.get(d2.key === null ? c2 : d2.key) || null, k(b2, a2, d2, e2);
            case wa:
              return a2 = a2.get(d2.key === null ? c2 : d2.key) || null, l(b2, a2, d2, e2);
            case Ha:
              var f2 = d2._init;
              return y(a2, b2, c2, f2(d2._payload), e2);
          }
          if (eb(d2) || Ka(d2))
            return a2 = a2.get(c2) || null, m(b2, a2, d2, e2, null);
          th(b2, d2);
        }
        return null;
      }
      function n(e2, g2, h2, k2) {
        for (var l2 = null, m2 = null, u = g2, w = g2 = 0, x = null; u !== null && w < h2.length; w++) {
          u.index > w ? (x = u, u = null) : x = u.sibling;
          var n2 = r2(e2, u, h2[w], k2);
          if (n2 === null) {
            u === null && (u = x);
            break;
          }
          a && u && n2.alternate === null && b(e2, u), g2 = f(n2, g2, w), m2 === null ? l2 = n2 : m2.sibling = n2, m2 = n2, u = x;
        }
        if (w === h2.length)
          return c(e2, u), I && tg(e2, w), l2;
        if (u === null) {
          for (; w < h2.length; w++)
            u = q(e2, h2[w], k2), u !== null && (g2 = f(u, g2, w), m2 === null ? l2 = u : m2.sibling = u, m2 = u);
          return I && tg(e2, w), l2;
        }
        for (u = d(e2, u); w < h2.length; w++)
          x = y(u, e2, w, h2[w], k2), x !== null && (a && x.alternate !== null && u.delete(x.key === null ? w : x.key), g2 = f(x, g2, w), m2 === null ? l2 = x : m2.sibling = x, m2 = x);
        return a && u.forEach(function(a2) {
          return b(e2, a2);
        }), I && tg(e2, w), l2;
      }
      function t7(e2, g2, h2, k2) {
        var l2 = Ka(h2);
        if (typeof l2 != "function")
          throw Error(p(150));
        if (h2 = l2.call(h2), h2 == null)
          throw Error(p(151));
        for (var u = l2 = null, m2 = g2, w = g2 = 0, x = null, n2 = h2.next(); m2 !== null && !n2.done; w++, n2 = h2.next()) {
          m2.index > w ? (x = m2, m2 = null) : x = m2.sibling;
          var t8 = r2(e2, m2, n2.value, k2);
          if (t8 === null) {
            m2 === null && (m2 = x);
            break;
          }
          a && m2 && t8.alternate === null && b(e2, m2), g2 = f(t8, g2, w), u === null ? l2 = t8 : u.sibling = t8, u = t8, m2 = x;
        }
        if (n2.done)
          return c(
            e2,
            m2
          ), I && tg(e2, w), l2;
        if (m2 === null) {
          for (; !n2.done; w++, n2 = h2.next())
            n2 = q(e2, n2.value, k2), n2 !== null && (g2 = f(n2, g2, w), u === null ? l2 = n2 : u.sibling = n2, u = n2);
          return I && tg(e2, w), l2;
        }
        for (m2 = d(e2, m2); !n2.done; w++, n2 = h2.next())
          n2 = y(m2, e2, w, n2.value, k2), n2 !== null && (a && n2.alternate !== null && m2.delete(n2.key === null ? w : n2.key), g2 = f(n2, g2, w), u === null ? l2 = n2 : u.sibling = n2, u = n2);
        return a && m2.forEach(function(a2) {
          return b(e2, a2);
        }), I && tg(e2, w), l2;
      }
      function J(a2, d2, f2, h2) {
        if (typeof f2 == "object" && f2 !== null && f2.type === ya && f2.key === null && (f2 = f2.props.children), typeof f2 == "object" && f2 !== null) {
          switch (f2.$$typeof) {
            case va:
              a: {
                for (var k2 = f2.key, l2 = d2; l2 !== null; ) {
                  if (l2.key === k2) {
                    if (k2 = f2.type, k2 === ya) {
                      if (l2.tag === 7) {
                        c(a2, l2.sibling), d2 = e(l2, f2.props.children), d2.return = a2, a2 = d2;
                        break a;
                      }
                    } else if (l2.elementType === k2 || typeof k2 == "object" && k2 !== null && k2.$$typeof === Ha && uh(k2) === l2.type) {
                      c(a2, l2.sibling), d2 = e(l2, f2.props), d2.ref = sh(a2, l2, f2), d2.return = a2, a2 = d2;
                      break a;
                    }
                    c(a2, l2);
                    break;
                  } else
                    b(a2, l2);
                  l2 = l2.sibling;
                }
                f2.type === ya ? (d2 = Ah(f2.props.children, a2.mode, h2, f2.key), d2.return = a2, a2 = d2) : (h2 = yh(f2.type, f2.key, f2.props, null, a2.mode, h2), h2.ref = sh(a2, d2, f2), h2.return = a2, a2 = h2);
              }
              return g(a2);
            case wa:
              a: {
                for (l2 = f2.key; d2 !== null; ) {
                  if (d2.key === l2)
                    if (d2.tag === 4 && d2.stateNode.containerInfo === f2.containerInfo && d2.stateNode.implementation === f2.implementation) {
                      c(a2, d2.sibling), d2 = e(d2, f2.children || []), d2.return = a2, a2 = d2;
                      break a;
                    } else {
                      c(a2, d2);
                      break;
                    }
                  else
                    b(a2, d2);
                  d2 = d2.sibling;
                }
                d2 = zh(f2, a2.mode, h2), d2.return = a2, a2 = d2;
              }
              return g(a2);
            case Ha:
              return l2 = f2._init, J(a2, d2, l2(f2._payload), h2);
          }
          if (eb(f2))
            return n(a2, d2, f2, h2);
          if (Ka(f2))
            return t7(a2, d2, f2, h2);
          th(a2, f2);
        }
        return typeof f2 == "string" && f2 !== "" || typeof f2 == "number" ? (f2 = "" + f2, d2 !== null && d2.tag === 6 ? (c(a2, d2.sibling), d2 = e(d2, f2), d2.return = a2, a2 = d2) : (c(a2, d2), d2 = xh(f2, a2.mode, h2), d2.return = a2, a2 = d2), g(a2)) : c(a2, d2);
      }
      return J;
    }
    var Bh = vh(!0), Ch = vh(!1), Dh = {}, Eh = Uf(Dh), Fh = Uf(Dh), Gh = Uf(Dh);
    function Hh(a) {
      if (a === Dh)
        throw Error(p(174));
      return a;
    }
    function Ih(a, b) {
      switch (G(Gh, b), G(Fh, a), G(Eh, Dh), a = b.nodeType, a) {
        case 9:
        case 11:
          b = (b = b.documentElement) ? b.namespaceURI : lb(null, "");
          break;
        default:
          a = a === 8 ? b.parentNode : b, b = a.namespaceURI || null, a = a.tagName, b = lb(b, a);
      }
      E(Eh), G(Eh, b);
    }
    function Jh() {
      E(Eh), E(Fh), E(Gh);
    }
    function Kh(a) {
      Hh(Gh.current);
      var b = Hh(Eh.current), c = lb(b, a.type);
      b !== c && (G(Fh, a), G(Eh, c));
    }
    function Lh(a) {
      Fh.current === a && (E(Eh), E(Fh));
    }
    var M = Uf(0);
    function Mh(a) {
      for (var b = a; b !== null; ) {
        if (b.tag === 13) {
          var c = b.memoizedState;
          if (c !== null && (c = c.dehydrated, c === null || c.data === "$?" || c.data === "$!"))
            return b;
        } else if (b.tag === 19 && b.memoizedProps.revealOrder !== void 0) {
          if (b.flags & 128)
            return b;
        } else if (b.child !== null) {
          b.child.return = b, b = b.child;
          continue;
        }
        if (b === a)
          break;
        for (; b.sibling === null; ) {
          if (b.return === null || b.return === a)
            return null;
          b = b.return;
        }
        b.sibling.return = b.return, b = b.sibling;
      }
      return null;
    }
    var Nh = [];
    function Oh() {
      for (var a = 0; a < Nh.length; a++)
        Nh[a]._workInProgressVersionPrimary = null;
      Nh.length = 0;
    }
    var Ph = ua.ReactCurrentDispatcher, Qh = ua.ReactCurrentBatchConfig, Rh = 0, N = null, O = null, P = null, Sh = !1, Th = !1, Uh = 0, Vh = 0;
    function Q() {
      throw Error(p(321));
    }
    function Wh(a, b) {
      if (b === null)
        return !1;
      for (var c = 0; c < b.length && c < a.length; c++)
        if (!He(a[c], b[c]))
          return !1;
      return !0;
    }
    function Xh(a, b, c, d, e, f) {
      if (Rh = f, N = b, b.memoizedState = null, b.updateQueue = null, b.lanes = 0, Ph.current = a === null || a.memoizedState === null ? Yh : Zh, a = c(d, e), Th) {
        f = 0;
        do {
          if (Th = !1, Uh = 0, 25 <= f)
            throw Error(p(301));
          f += 1, P = O = null, b.updateQueue = null, Ph.current = $h, a = c(d, e);
        } while (Th);
      }
      if (Ph.current = ai, b = O !== null && O.next !== null, Rh = 0, P = O = N = null, Sh = !1, b)
        throw Error(p(300));
      return a;
    }
    function bi() {
      var a = Uh !== 0;
      return Uh = 0, a;
    }
    function ci() {
      var a = { memoizedState: null, baseState: null, baseQueue: null, queue: null, next: null };
      return P === null ? N.memoizedState = P = a : P = P.next = a, P;
    }
    function di() {
      if (O === null) {
        var a = N.alternate;
        a = a !== null ? a.memoizedState : null;
      } else
        a = O.next;
      var b = P === null ? N.memoizedState : P.next;
      if (b !== null)
        P = b, O = a;
      else {
        if (a === null)
          throw Error(p(310));
        O = a, a = { memoizedState: O.memoizedState, baseState: O.baseState, baseQueue: O.baseQueue, queue: O.queue, next: null }, P === null ? N.memoizedState = P = a : P = P.next = a;
      }
      return P;
    }
    function ei(a, b) {
      return typeof b == "function" ? b(a) : b;
    }
    function fi(a) {
      var b = di(), c = b.queue;
      if (c === null)
        throw Error(p(311));
      c.lastRenderedReducer = a;
      var d = O, e = d.baseQueue, f = c.pending;
      if (f !== null) {
        if (e !== null) {
          var g = e.next;
          e.next = f.next, f.next = g;
        }
        d.baseQueue = e = f, c.pending = null;
      }
      if (e !== null) {
        f = e.next, d = d.baseState;
        var h = g = null, k = null, l = f;
        do {
          var m = l.lane;
          if ((Rh & m) === m)
            k !== null && (k = k.next = { lane: 0, action: l.action, hasEagerState: l.hasEagerState, eagerState: l.eagerState, next: null }), d = l.hasEagerState ? l.eagerState : a(d, l.action);
          else {
            var q = {
              lane: m,
              action: l.action,
              hasEagerState: l.hasEagerState,
              eagerState: l.eagerState,
              next: null
            };
            k === null ? (h = k = q, g = d) : k = k.next = q, N.lanes |= m, hh |= m;
          }
          l = l.next;
        } while (l !== null && l !== f);
        k === null ? g = d : k.next = h, He(d, b.memoizedState) || (Ug = !0), b.memoizedState = d, b.baseState = g, b.baseQueue = k, c.lastRenderedState = d;
      }
      if (a = c.interleaved, a !== null) {
        e = a;
        do
          f = e.lane, N.lanes |= f, hh |= f, e = e.next;
        while (e !== a);
      } else
        e === null && (c.lanes = 0);
      return [b.memoizedState, c.dispatch];
    }
    function gi(a) {
      var b = di(), c = b.queue;
      if (c === null)
        throw Error(p(311));
      c.lastRenderedReducer = a;
      var d = c.dispatch, e = c.pending, f = b.memoizedState;
      if (e !== null) {
        c.pending = null;
        var g = e = e.next;
        do
          f = a(f, g.action), g = g.next;
        while (g !== e);
        He(f, b.memoizedState) || (Ug = !0), b.memoizedState = f, b.baseQueue === null && (b.baseState = f), c.lastRenderedState = f;
      }
      return [f, d];
    }
    function hi() {
    }
    function ii(a, b) {
      var c = N, d = di(), e = b(), f = !He(d.memoizedState, e);
      if (f && (d.memoizedState = e, Ug = !0), d = d.queue, ji(ki.bind(null, c, d, a), [a]), d.getSnapshot !== b || f || P !== null && P.memoizedState.tag & 1) {
        if (c.flags |= 2048, li(9, mi.bind(null, c, d, e, b), void 0, null), R === null)
          throw Error(p(349));
        Rh & 30 || ni(c, b, e);
      }
      return e;
    }
    function ni(a, b, c) {
      a.flags |= 16384, a = { getSnapshot: b, value: c }, b = N.updateQueue, b === null ? (b = { lastEffect: null, stores: null }, N.updateQueue = b, b.stores = [a]) : (c = b.stores, c === null ? b.stores = [a] : c.push(a));
    }
    function mi(a, b, c, d) {
      b.value = c, b.getSnapshot = d, oi(b) && pi(a);
    }
    function ki(a, b, c) {
      return c(function() {
        oi(b) && pi(a);
      });
    }
    function oi(a) {
      var b = a.getSnapshot;
      a = a.value;
      try {
        var c = b();
        return !He(a, c);
      } catch {
        return !0;
      }
    }
    function pi(a) {
      var b = Zg(a, 1);
      b !== null && mh(b, a, 1, -1);
    }
    function qi(a) {
      var b = ci();
      return typeof a == "function" && (a = a()), b.memoizedState = b.baseState = a, a = { pending: null, interleaved: null, lanes: 0, dispatch: null, lastRenderedReducer: ei, lastRenderedState: a }, b.queue = a, a = a.dispatch = ri.bind(null, N, a), [b.memoizedState, a];
    }
    function li(a, b, c, d) {
      return a = { tag: a, create: b, destroy: c, deps: d, next: null }, b = N.updateQueue, b === null ? (b = { lastEffect: null, stores: null }, N.updateQueue = b, b.lastEffect = a.next = a) : (c = b.lastEffect, c === null ? b.lastEffect = a.next = a : (d = c.next, c.next = a, a.next = d, b.lastEffect = a)), a;
    }
    function si() {
      return di().memoizedState;
    }
    function ti(a, b, c, d) {
      var e = ci();
      N.flags |= a, e.memoizedState = li(1 | b, c, void 0, d === void 0 ? null : d);
    }
    function ui(a, b, c, d) {
      var e = di();
      d = d === void 0 ? null : d;
      var f = void 0;
      if (O !== null) {
        var g = O.memoizedState;
        if (f = g.destroy, d !== null && Wh(d, g.deps)) {
          e.memoizedState = li(b, c, f, d);
          return;
        }
      }
      N.flags |= a, e.memoizedState = li(1 | b, c, f, d);
    }
    function vi(a, b) {
      return ti(8390656, 8, a, b);
    }
    function ji(a, b) {
      return ui(2048, 8, a, b);
    }
    function wi(a, b) {
      return ui(4, 2, a, b);
    }
    function xi(a, b) {
      return ui(4, 4, a, b);
    }
    function yi(a, b) {
      if (typeof b == "function")
        return a = a(), b(a), function() {
          b(null);
        };
      if (b != null)
        return a = a(), b.current = a, function() {
          b.current = null;
        };
    }
    function zi(a, b, c) {
      return c = c != null ? c.concat([a]) : null, ui(4, 4, yi.bind(null, b, a), c);
    }
    function Ai() {
    }
    function Bi(a, b) {
      var c = di();
      b = b === void 0 ? null : b;
      var d = c.memoizedState;
      return d !== null && b !== null && Wh(b, d[1]) ? d[0] : (c.memoizedState = [a, b], a);
    }
    function Ci(a, b) {
      var c = di();
      b = b === void 0 ? null : b;
      var d = c.memoizedState;
      return d !== null && b !== null && Wh(b, d[1]) ? d[0] : (a = a(), c.memoizedState = [a, b], a);
    }
    function Di(a, b, c) {
      return Rh & 21 ? (He(c, b) || (c = yc(), N.lanes |= c, hh |= c, a.baseState = !0), b) : (a.baseState && (a.baseState = !1, Ug = !0), a.memoizedState = c);
    }
    function Ei(a, b) {
      var c = C;
      C = c !== 0 && 4 > c ? c : 4, a(!0);
      var d = Qh.transition;
      Qh.transition = {};
      try {
        a(!1), b();
      } finally {
        C = c, Qh.transition = d;
      }
    }
    function Fi() {
      return di().memoizedState;
    }
    function Gi(a, b, c) {
      var d = lh(a);
      if (c = { lane: d, action: c, hasEagerState: !1, eagerState: null, next: null }, Hi(a))
        Ii(b, c);
      else if (c = Yg(a, b, c, d), c !== null) {
        var e = L();
        mh(c, a, d, e), Ji(c, b, d);
      }
    }
    function ri(a, b, c) {
      var d = lh(a), e = { lane: d, action: c, hasEagerState: !1, eagerState: null, next: null };
      if (Hi(a))
        Ii(b, e);
      else {
        var f = a.alternate;
        if (a.lanes === 0 && (f === null || f.lanes === 0) && (f = b.lastRenderedReducer, f !== null))
          try {
            var g = b.lastRenderedState, h = f(g, c);
            if (e.hasEagerState = !0, e.eagerState = h, He(h, g)) {
              var k = b.interleaved;
              k === null ? (e.next = e, Xg(b)) : (e.next = k.next, k.next = e), b.interleaved = e;
              return;
            }
          } catch {
          } finally {
          }
        c = Yg(a, b, e, d), c !== null && (e = L(), mh(c, a, d, e), Ji(c, b, d));
      }
    }
    function Hi(a) {
      var b = a.alternate;
      return a === N || b !== null && b === N;
    }
    function Ii(a, b) {
      Th = Sh = !0;
      var c = a.pending;
      c === null ? b.next = b : (b.next = c.next, c.next = b), a.pending = b;
    }
    function Ji(a, b, c) {
      if (c & 4194240) {
        var d = b.lanes;
        d &= a.pendingLanes, c |= d, b.lanes = c, Cc(a, c);
      }
    }
    var ai = { readContext: Vg, useCallback: Q, useContext: Q, useEffect: Q, useImperativeHandle: Q, useInsertionEffect: Q, useLayoutEffect: Q, useMemo: Q, useReducer: Q, useRef: Q, useState: Q, useDebugValue: Q, useDeferredValue: Q, useTransition: Q, useMutableSource: Q, useSyncExternalStore: Q, useId: Q, unstable_isNewReconciler: !1 }, Yh = { readContext: Vg, useCallback: function(a, b) {
      return ci().memoizedState = [a, b === void 0 ? null : b], a;
    }, useContext: Vg, useEffect: vi, useImperativeHandle: function(a, b, c) {
      return c = c != null ? c.concat([a]) : null, ti(
        4194308,
        4,
        yi.bind(null, b, a),
        c
      );
    }, useLayoutEffect: function(a, b) {
      return ti(4194308, 4, a, b);
    }, useInsertionEffect: function(a, b) {
      return ti(4, 2, a, b);
    }, useMemo: function(a, b) {
      var c = ci();
      return b = b === void 0 ? null : b, a = a(), c.memoizedState = [a, b], a;
    }, useReducer: function(a, b, c) {
      var d = ci();
      return b = c !== void 0 ? c(b) : b, d.memoizedState = d.baseState = b, a = { pending: null, interleaved: null, lanes: 0, dispatch: null, lastRenderedReducer: a, lastRenderedState: b }, d.queue = a, a = a.dispatch = Gi.bind(null, N, a), [d.memoizedState, a];
    }, useRef: function(a) {
      var b = ci();
      return a = { current: a }, b.memoizedState = a;
    }, useState: qi, useDebugValue: Ai, useDeferredValue: function(a) {
      return ci().memoizedState = a;
    }, useTransition: function() {
      var a = qi(!1), b = a[0];
      return a = Ei.bind(null, a[1]), ci().memoizedState = a, [b, a];
    }, useMutableSource: function() {
    }, useSyncExternalStore: function(a, b, c) {
      var d = N, e = ci();
      if (I) {
        if (c === void 0)
          throw Error(p(407));
        c = c();
      } else {
        if (c = b(), R === null)
          throw Error(p(349));
        Rh & 30 || ni(d, b, c);
      }
      e.memoizedState = c;
      var f = { value: c, getSnapshot: b };
      return e.queue = f, vi(ki.bind(
        null,
        d,
        f,
        a
      ), [a]), d.flags |= 2048, li(9, mi.bind(null, d, f, c, b), void 0, null), c;
    }, useId: function() {
      var a = ci(), b = R.identifierPrefix;
      if (I) {
        var c = sg, d = rg;
        c = (d & ~(1 << 32 - oc(d) - 1)).toString(32) + c, b = ":" + b + "R" + c, c = Uh++, 0 < c && (b += "H" + c.toString(32)), b += ":";
      } else
        c = Vh++, b = ":" + b + "r" + c.toString(32) + ":";
      return a.memoizedState = b;
    }, unstable_isNewReconciler: !1 }, Zh = {
      readContext: Vg,
      useCallback: Bi,
      useContext: Vg,
      useEffect: ji,
      useImperativeHandle: zi,
      useInsertionEffect: wi,
      useLayoutEffect: xi,
      useMemo: Ci,
      useReducer: fi,
      useRef: si,
      useState: function() {
        return fi(ei);
      },
      useDebugValue: Ai,
      useDeferredValue: function(a) {
        var b = di();
        return Di(b, O.memoizedState, a);
      },
      useTransition: function() {
        var a = fi(ei)[0], b = di().memoizedState;
        return [a, b];
      },
      useMutableSource: hi,
      useSyncExternalStore: ii,
      useId: Fi,
      unstable_isNewReconciler: !1
    }, $h = { readContext: Vg, useCallback: Bi, useContext: Vg, useEffect: ji, useImperativeHandle: zi, useInsertionEffect: wi, useLayoutEffect: xi, useMemo: Ci, useReducer: gi, useRef: si, useState: function() {
      return gi(ei);
    }, useDebugValue: Ai, useDeferredValue: function(a) {
      var b = di();
      return O === null ? b.memoizedState = a : Di(b, O.memoizedState, a);
    }, useTransition: function() {
      var a = gi(ei)[0], b = di().memoizedState;
      return [a, b];
    }, useMutableSource: hi, useSyncExternalStore: ii, useId: Fi, unstable_isNewReconciler: !1 };
    function Ki(a, b) {
      try {
        var c = "", d = b;
        do
          c += Pa(d), d = d.return;
        while (d);
        var e = c;
      } catch (f) {
        e = `
Error generating stack: ` + f.message + `
` + f.stack;
      }
      return { value: a, source: b, stack: e, digest: null };
    }
    function Li(a, b, c) {
      return { value: a, source: null, stack: c ?? null, digest: b ?? null };
    }
    function Mi(a, b) {
      try {
        console.error(b.value);
      } catch (c) {
        setTimeout(function() {
          throw c;
        });
      }
    }
    var Ni = typeof WeakMap == "function" ? WeakMap : Map;
    function Oi(a, b, c) {
      c = ch(-1, c), c.tag = 3, c.payload = { element: null };
      var d = b.value;
      return c.callback = function() {
        Pi || (Pi = !0, Qi = d), Mi(a, b);
      }, c;
    }
    function Ri(a, b, c) {
      c = ch(-1, c), c.tag = 3;
      var d = a.type.getDerivedStateFromError;
      if (typeof d == "function") {
        var e = b.value;
        c.payload = function() {
          return d(e);
        }, c.callback = function() {
          Mi(a, b);
        };
      }
      var f = a.stateNode;
      return f !== null && typeof f.componentDidCatch == "function" && (c.callback = function() {
        Mi(a, b), typeof d != "function" && (Si === null ? Si = /* @__PURE__ */ new Set([this]) : Si.add(this));
        var c2 = b.stack;
        this.componentDidCatch(b.value, { componentStack: c2 !== null ? c2 : "" });
      }), c;
    }
    function Ti(a, b, c) {
      var d = a.pingCache;
      if (d === null) {
        d = a.pingCache = new Ni();
        var e = /* @__PURE__ */ new Set();
        d.set(b, e);
      } else
        e = d.get(b), e === void 0 && (e = /* @__PURE__ */ new Set(), d.set(b, e));
      e.has(c) || (e.add(c), a = Ui.bind(null, a, b, c), b.then(a, a));
    }
    function Vi(a) {
      do {
        var b;
        if ((b = a.tag === 13) && (b = a.memoizedState, b = b !== null ? b.dehydrated !== null : !0), b)
          return a;
        a = a.return;
      } while (a !== null);
      return null;
    }
    function Wi(a, b, c, d, e) {
      return a.mode & 1 ? (a.flags |= 65536, a.lanes = e, a) : (a === b ? a.flags |= 65536 : (a.flags |= 128, c.flags |= 131072, c.flags &= -52805, c.tag === 1 && (c.alternate === null ? c.tag = 17 : (b = ch(-1, 1), b.tag = 2, dh(c, b, 1))), c.lanes |= 1), a);
    }
    var Xi = ua.ReactCurrentOwner, Ug = !1;
    function Yi(a, b, c, d) {
      b.child = a === null ? Ch(b, null, c, d) : Bh(b, a.child, c, d);
    }
    function Zi(a, b, c, d, e) {
      c = c.render;
      var f = b.ref;
      return Tg(b, e), d = Xh(a, b, c, d, f, e), c = bi(), a !== null && !Ug ? (b.updateQueue = a.updateQueue, b.flags &= -2053, a.lanes &= ~e, $i(a, b, e)) : (I && c && vg(b), b.flags |= 1, Yi(a, b, d, e), b.child);
    }
    function aj(a, b, c, d, e) {
      if (a === null) {
        var f = c.type;
        return typeof f == "function" && !bj(f) && f.defaultProps === void 0 && c.compare === null && c.defaultProps === void 0 ? (b.tag = 15, b.type = f, cj(a, b, f, d, e)) : (a = yh(c.type, null, d, b, b.mode, e), a.ref = b.ref, a.return = b, b.child = a);
      }
      if (f = a.child, !(a.lanes & e)) {
        var g = f.memoizedProps;
        if (c = c.compare, c = c !== null ? c : Ie, c(g, d) && a.ref === b.ref)
          return $i(a, b, e);
      }
      return b.flags |= 1, a = wh(f, d), a.ref = b.ref, a.return = b, b.child = a;
    }
    function cj(a, b, c, d, e) {
      if (a !== null) {
        var f = a.memoizedProps;
        if (Ie(f, d) && a.ref === b.ref)
          if (Ug = !1, b.pendingProps = d = f, (a.lanes & e) !== 0)
            a.flags & 131072 && (Ug = !0);
          else
            return b.lanes = a.lanes, $i(a, b, e);
      }
      return dj(a, b, c, d, e);
    }
    function ej(a, b, c) {
      var d = b.pendingProps, e = d.children, f = a !== null ? a.memoizedState : null;
      if (d.mode === "hidden")
        if (!(b.mode & 1))
          b.memoizedState = { baseLanes: 0, cachePool: null, transitions: null }, G(fj, gj), gj |= c;
        else {
          if (!(c & 1073741824))
            return a = f !== null ? f.baseLanes | c : c, b.lanes = b.childLanes = 1073741824, b.memoizedState = { baseLanes: a, cachePool: null, transitions: null }, b.updateQueue = null, G(fj, gj), gj |= a, null;
          b.memoizedState = { baseLanes: 0, cachePool: null, transitions: null }, d = f !== null ? f.baseLanes : c, G(fj, gj), gj |= d;
        }
      else
        f !== null ? (d = f.baseLanes | c, b.memoizedState = null) : d = c, G(fj, gj), gj |= d;
      return Yi(a, b, e, c), b.child;
    }
    function hj(a, b) {
      var c = b.ref;
      (a === null && c !== null || a !== null && a.ref !== c) && (b.flags |= 512, b.flags |= 2097152);
    }
    function dj(a, b, c, d, e) {
      var f = Zf(c) ? Xf : H.current;
      return f = Yf(b, f), Tg(b, e), c = Xh(a, b, c, d, f, e), d = bi(), a !== null && !Ug ? (b.updateQueue = a.updateQueue, b.flags &= -2053, a.lanes &= ~e, $i(a, b, e)) : (I && d && vg(b), b.flags |= 1, Yi(a, b, c, e), b.child);
    }
    function ij(a, b, c, d, e) {
      if (Zf(c)) {
        var f = !0;
        cg(b);
      } else
        f = !1;
      if (Tg(b, e), b.stateNode === null)
        jj(a, b), ph(b, c, d), rh(b, c, d, e), d = !0;
      else if (a === null) {
        var g = b.stateNode, h = b.memoizedProps;
        g.props = h;
        var k = g.context, l = c.contextType;
        typeof l == "object" && l !== null ? l = Vg(l) : (l = Zf(c) ? Xf : H.current, l = Yf(b, l));
        var m = c.getDerivedStateFromProps, q = typeof m == "function" || typeof g.getSnapshotBeforeUpdate == "function";
        q || typeof g.UNSAFE_componentWillReceiveProps != "function" && typeof g.componentWillReceiveProps != "function" || (h !== d || k !== l) && qh(b, g, d, l), $g = !1;
        var r2 = b.memoizedState;
        g.state = r2, gh(b, d, g, e), k = b.memoizedState, h !== d || r2 !== k || Wf.current || $g ? (typeof m == "function" && (kh(b, c, m, d), k = b.memoizedState), (h = $g || oh(b, c, h, d, r2, k, l)) ? (q || typeof g.UNSAFE_componentWillMount != "function" && typeof g.componentWillMount != "function" || (typeof g.componentWillMount == "function" && g.componentWillMount(), typeof g.UNSAFE_componentWillMount == "function" && g.UNSAFE_componentWillMount()), typeof g.componentDidMount == "function" && (b.flags |= 4194308)) : (typeof g.componentDidMount == "function" && (b.flags |= 4194308), b.memoizedProps = d, b.memoizedState = k), g.props = d, g.state = k, g.context = l, d = h) : (typeof g.componentDidMount == "function" && (b.flags |= 4194308), d = !1);
      } else {
        g = b.stateNode, bh(a, b), h = b.memoizedProps, l = b.type === b.elementType ? h : Lg(b.type, h), g.props = l, q = b.pendingProps, r2 = g.context, k = c.contextType, typeof k == "object" && k !== null ? k = Vg(k) : (k = Zf(c) ? Xf : H.current, k = Yf(b, k));
        var y = c.getDerivedStateFromProps;
        (m = typeof y == "function" || typeof g.getSnapshotBeforeUpdate == "function") || typeof g.UNSAFE_componentWillReceiveProps != "function" && typeof g.componentWillReceiveProps != "function" || (h !== q || r2 !== k) && qh(b, g, d, k), $g = !1, r2 = b.memoizedState, g.state = r2, gh(b, d, g, e);
        var n = b.memoizedState;
        h !== q || r2 !== n || Wf.current || $g ? (typeof y == "function" && (kh(b, c, y, d), n = b.memoizedState), (l = $g || oh(b, c, l, d, r2, n, k) || !1) ? (m || typeof g.UNSAFE_componentWillUpdate != "function" && typeof g.componentWillUpdate != "function" || (typeof g.componentWillUpdate == "function" && g.componentWillUpdate(d, n, k), typeof g.UNSAFE_componentWillUpdate == "function" && g.UNSAFE_componentWillUpdate(d, n, k)), typeof g.componentDidUpdate == "function" && (b.flags |= 4), typeof g.getSnapshotBeforeUpdate == "function" && (b.flags |= 1024)) : (typeof g.componentDidUpdate != "function" || h === a.memoizedProps && r2 === a.memoizedState || (b.flags |= 4), typeof g.getSnapshotBeforeUpdate != "function" || h === a.memoizedProps && r2 === a.memoizedState || (b.flags |= 1024), b.memoizedProps = d, b.memoizedState = n), g.props = d, g.state = n, g.context = k, d = l) : (typeof g.componentDidUpdate != "function" || h === a.memoizedProps && r2 === a.memoizedState || (b.flags |= 4), typeof g.getSnapshotBeforeUpdate != "function" || h === a.memoizedProps && r2 === a.memoizedState || (b.flags |= 1024), d = !1);
      }
      return kj(a, b, c, d, f, e);
    }
    function kj(a, b, c, d, e, f) {
      hj(a, b);
      var g = (b.flags & 128) !== 0;
      if (!d && !g)
        return e && dg(b, c, !1), $i(a, b, f);
      d = b.stateNode, Xi.current = b;
      var h = g && typeof c.getDerivedStateFromError != "function" ? null : d.render();
      return b.flags |= 1, a !== null && g ? (b.child = Bh(b, a.child, null, f), b.child = Bh(b, null, h, f)) : Yi(a, b, h, f), b.memoizedState = d.state, e && dg(b, c, !0), b.child;
    }
    function lj(a) {
      var b = a.stateNode;
      b.pendingContext ? ag(a, b.pendingContext, b.pendingContext !== b.context) : b.context && ag(a, b.context, !1), Ih(a, b.containerInfo);
    }
    function mj(a, b, c, d, e) {
      return Ig(), Jg(e), b.flags |= 256, Yi(a, b, c, d), b.child;
    }
    var nj = { dehydrated: null, treeContext: null, retryLane: 0 };
    function oj(a) {
      return { baseLanes: a, cachePool: null, transitions: null };
    }
    function pj(a, b, c) {
      var d = b.pendingProps, e = M.current, f = !1, g = (b.flags & 128) !== 0, h;
      if ((h = g) || (h = a !== null && a.memoizedState === null ? !1 : (e & 2) !== 0), h ? (f = !0, b.flags &= -129) : (a === null || a.memoizedState !== null) && (e |= 1), G(M, e & 1), a === null)
        return Eg(b), a = b.memoizedState, a !== null && (a = a.dehydrated, a !== null) ? (b.mode & 1 ? a.data === "$!" ? b.lanes = 8 : b.lanes = 1073741824 : b.lanes = 1, null) : (g = d.children, a = d.fallback, f ? (d = b.mode, f = b.child, g = { mode: "hidden", children: g }, !(d & 1) && f !== null ? (f.childLanes = 0, f.pendingProps = g) : f = qj(g, d, 0, null), a = Ah(a, d, c, null), f.return = b, a.return = b, f.sibling = a, b.child = f, b.child.memoizedState = oj(c), b.memoizedState = nj, a) : rj(b, g));
      if (e = a.memoizedState, e !== null && (h = e.dehydrated, h !== null))
        return sj(a, b, g, d, h, e, c);
      if (f) {
        f = d.fallback, g = b.mode, e = a.child, h = e.sibling;
        var k = { mode: "hidden", children: d.children };
        return !(g & 1) && b.child !== e ? (d = b.child, d.childLanes = 0, d.pendingProps = k, b.deletions = null) : (d = wh(e, k), d.subtreeFlags = e.subtreeFlags & 14680064), h !== null ? f = wh(h, f) : (f = Ah(f, g, c, null), f.flags |= 2), f.return = b, d.return = b, d.sibling = f, b.child = d, d = f, f = b.child, g = a.child.memoizedState, g = g === null ? oj(c) : { baseLanes: g.baseLanes | c, cachePool: null, transitions: g.transitions }, f.memoizedState = g, f.childLanes = a.childLanes & ~c, b.memoizedState = nj, d;
      }
      return f = a.child, a = f.sibling, d = wh(f, { mode: "visible", children: d.children }), !(b.mode & 1) && (d.lanes = c), d.return = b, d.sibling = null, a !== null && (c = b.deletions, c === null ? (b.deletions = [a], b.flags |= 16) : c.push(a)), b.child = d, b.memoizedState = null, d;
    }
    function rj(a, b) {
      return b = qj({ mode: "visible", children: b }, a.mode, 0, null), b.return = a, a.child = b;
    }
    function tj(a, b, c, d) {
      return d !== null && Jg(d), Bh(b, a.child, null, c), a = rj(b, b.pendingProps.children), a.flags |= 2, b.memoizedState = null, a;
    }
    function sj(a, b, c, d, e, f, g) {
      if (c)
        return b.flags & 256 ? (b.flags &= -257, d = Li(Error(p(422))), tj(a, b, g, d)) : b.memoizedState !== null ? (b.child = a.child, b.flags |= 128, null) : (f = d.fallback, e = b.mode, d = qj({ mode: "visible", children: d.children }, e, 0, null), f = Ah(f, e, g, null), f.flags |= 2, d.return = b, f.return = b, d.sibling = f, b.child = d, b.mode & 1 && Bh(b, a.child, null, g), b.child.memoizedState = oj(g), b.memoizedState = nj, f);
      if (!(b.mode & 1))
        return tj(a, b, g, null);
      if (e.data === "$!") {
        if (d = e.nextSibling && e.nextSibling.dataset, d)
          var h = d.dgst;
        return d = h, f = Error(p(419)), d = Li(f, d, void 0), tj(a, b, g, d);
      }
      if (h = (g & a.childLanes) !== 0, Ug || h) {
        if (d = R, d !== null) {
          switch (g & -g) {
            case 4:
              e = 2;
              break;
            case 16:
              e = 8;
              break;
            case 64:
            case 128:
            case 256:
            case 512:
            case 1024:
            case 2048:
            case 4096:
            case 8192:
            case 16384:
            case 32768:
            case 65536:
            case 131072:
            case 262144:
            case 524288:
            case 1048576:
            case 2097152:
            case 4194304:
            case 8388608:
            case 16777216:
            case 33554432:
            case 67108864:
              e = 32;
              break;
            case 536870912:
              e = 268435456;
              break;
            default:
              e = 0;
          }
          e = e & (d.suspendedLanes | g) ? 0 : e, e !== 0 && e !== f.retryLane && (f.retryLane = e, Zg(a, e), mh(d, a, e, -1));
        }
        return uj(), d = Li(Error(p(421))), tj(a, b, g, d);
      }
      return e.data === "$?" ? (b.flags |= 128, b.child = a.child, b = vj.bind(null, a), e._reactRetry = b, null) : (a = f.treeContext, yg = Lf(e.nextSibling), xg = b, I = !0, zg = null, a !== null && (og[pg++] = rg, og[pg++] = sg, og[pg++] = qg, rg = a.id, sg = a.overflow, qg = b), b = rj(b, d.children), b.flags |= 4096, b);
    }
    function wj(a, b, c) {
      a.lanes |= b;
      var d = a.alternate;
      d !== null && (d.lanes |= b), Sg(a.return, b, c);
    }
    function xj(a, b, c, d, e) {
      var f = a.memoizedState;
      f === null ? a.memoizedState = { isBackwards: b, rendering: null, renderingStartTime: 0, last: d, tail: c, tailMode: e } : (f.isBackwards = b, f.rendering = null, f.renderingStartTime = 0, f.last = d, f.tail = c, f.tailMode = e);
    }
    function yj(a, b, c) {
      var d = b.pendingProps, e = d.revealOrder, f = d.tail;
      if (Yi(a, b, d.children, c), d = M.current, d & 2)
        d = d & 1 | 2, b.flags |= 128;
      else {
        if (a !== null && a.flags & 128)
          a:
            for (a = b.child; a !== null; ) {
              if (a.tag === 13)
                a.memoizedState !== null && wj(a, c, b);
              else if (a.tag === 19)
                wj(a, c, b);
              else if (a.child !== null) {
                a.child.return = a, a = a.child;
                continue;
              }
              if (a === b)
                break a;
              for (; a.sibling === null; ) {
                if (a.return === null || a.return === b)
                  break a;
                a = a.return;
              }
              a.sibling.return = a.return, a = a.sibling;
            }
        d &= 1;
      }
      if (G(M, d), !(b.mode & 1))
        b.memoizedState = null;
      else
        switch (e) {
          case "forwards":
            for (c = b.child, e = null; c !== null; )
              a = c.alternate, a !== null && Mh(a) === null && (e = c), c = c.sibling;
            c = e, c === null ? (e = b.child, b.child = null) : (e = c.sibling, c.sibling = null), xj(b, !1, e, c, f);
            break;
          case "backwards":
            for (c = null, e = b.child, b.child = null; e !== null; ) {
              if (a = e.alternate, a !== null && Mh(a) === null) {
                b.child = e;
                break;
              }
              a = e.sibling, e.sibling = c, c = e, e = a;
            }
            xj(b, !0, c, null, f);
            break;
          case "together":
            xj(b, !1, null, null, void 0);
            break;
          default:
            b.memoizedState = null;
        }
      return b.child;
    }
    function jj(a, b) {
      !(b.mode & 1) && a !== null && (a.alternate = null, b.alternate = null, b.flags |= 2);
    }
    function $i(a, b, c) {
      if (a !== null && (b.dependencies = a.dependencies), hh |= b.lanes, !(c & b.childLanes))
        return null;
      if (a !== null && b.child !== a.child)
        throw Error(p(153));
      if (b.child !== null) {
        for (a = b.child, c = wh(a, a.pendingProps), b.child = c, c.return = b; a.sibling !== null; )
          a = a.sibling, c = c.sibling = wh(a, a.pendingProps), c.return = b;
        c.sibling = null;
      }
      return b.child;
    }
    function zj(a, b, c) {
      switch (b.tag) {
        case 3:
          lj(b), Ig();
          break;
        case 5:
          Kh(b);
          break;
        case 1:
          Zf(b.type) && cg(b);
          break;
        case 4:
          Ih(b, b.stateNode.containerInfo);
          break;
        case 10:
          var d = b.type._context, e = b.memoizedProps.value;
          G(Mg, d._currentValue), d._currentValue = e;
          break;
        case 13:
          if (d = b.memoizedState, d !== null)
            return d.dehydrated !== null ? (G(M, M.current & 1), b.flags |= 128, null) : c & b.child.childLanes ? pj(a, b, c) : (G(M, M.current & 1), a = $i(a, b, c), a !== null ? a.sibling : null);
          G(M, M.current & 1);
          break;
        case 19:
          if (d = (c & b.childLanes) !== 0, a.flags & 128) {
            if (d)
              return yj(a, b, c);
            b.flags |= 128;
          }
          if (e = b.memoizedState, e !== null && (e.rendering = null, e.tail = null, e.lastEffect = null), G(M, M.current), d)
            break;
          return null;
        case 22:
        case 23:
          return b.lanes = 0, ej(a, b, c);
      }
      return $i(a, b, c);
    }
    var Aj, Bj, Cj, Dj;
    Aj = function(a, b) {
      for (var c = b.child; c !== null; ) {
        if (c.tag === 5 || c.tag === 6)
          a.appendChild(c.stateNode);
        else if (c.tag !== 4 && c.child !== null) {
          c.child.return = c, c = c.child;
          continue;
        }
        if (c === b)
          break;
        for (; c.sibling === null; ) {
          if (c.return === null || c.return === b)
            return;
          c = c.return;
        }
        c.sibling.return = c.return, c = c.sibling;
      }
    };
    Bj = function() {
    };
    Cj = function(a, b, c, d) {
      var e = a.memoizedProps;
      if (e !== d) {
        a = b.stateNode, Hh(Eh.current);
        var f = null;
        switch (c) {
          case "input":
            e = Ya(a, e), d = Ya(a, d), f = [];
            break;
          case "select":
            e = A({}, e, { value: void 0 }), d = A({}, d, { value: void 0 }), f = [];
            break;
          case "textarea":
            e = gb(a, e), d = gb(a, d), f = [];
            break;
          default:
            typeof e.onClick != "function" && typeof d.onClick == "function" && (a.onclick = Bf);
        }
        ub(c, d);
        var g;
        c = null;
        for (l in e)
          if (!d.hasOwnProperty(l) && e.hasOwnProperty(l) && e[l] != null)
            if (l === "style") {
              var h = e[l];
              for (g in h)
                h.hasOwnProperty(g) && (c || (c = {}), c[g] = "");
            } else
              l !== "dangerouslySetInnerHTML" && l !== "children" && l !== "suppressContentEditableWarning" && l !== "suppressHydrationWarning" && l !== "autoFocus" && (ea.hasOwnProperty(l) ? f || (f = []) : (f = f || []).push(l, null));
        for (l in d) {
          var k = d[l];
          if (h = e?.[l], d.hasOwnProperty(l) && k !== h && (k != null || h != null))
            if (l === "style")
              if (h) {
                for (g in h)
                  !h.hasOwnProperty(g) || k && k.hasOwnProperty(g) || (c || (c = {}), c[g] = "");
                for (g in k)
                  k.hasOwnProperty(g) && h[g] !== k[g] && (c || (c = {}), c[g] = k[g]);
              } else
                c || (f || (f = []), f.push(
                  l,
                  c
                )), c = k;
            else
              l === "dangerouslySetInnerHTML" ? (k = k ? k.__html : void 0, h = h ? h.__html : void 0, k != null && h !== k && (f = f || []).push(l, k)) : l === "children" ? typeof k != "string" && typeof k != "number" || (f = f || []).push(l, "" + k) : l !== "suppressContentEditableWarning" && l !== "suppressHydrationWarning" && (ea.hasOwnProperty(l) ? (k != null && l === "onScroll" && D("scroll", a), f || h === k || (f = [])) : (f = f || []).push(l, k));
        }
        c && (f = f || []).push("style", c);
        var l = f;
        (b.updateQueue = l) && (b.flags |= 4);
      }
    };
    Dj = function(a, b, c, d) {
      c !== d && (b.flags |= 4);
    };
    function Ej(a, b) {
      if (!I)
        switch (a.tailMode) {
          case "hidden":
            b = a.tail;
            for (var c = null; b !== null; )
              b.alternate !== null && (c = b), b = b.sibling;
            c === null ? a.tail = null : c.sibling = null;
            break;
          case "collapsed":
            c = a.tail;
            for (var d = null; c !== null; )
              c.alternate !== null && (d = c), c = c.sibling;
            d === null ? b || a.tail === null ? a.tail = null : a.tail.sibling = null : d.sibling = null;
        }
    }
    function S(a) {
      var b = a.alternate !== null && a.alternate.child === a.child, c = 0, d = 0;
      if (b)
        for (var e = a.child; e !== null; )
          c |= e.lanes | e.childLanes, d |= e.subtreeFlags & 14680064, d |= e.flags & 14680064, e.return = a, e = e.sibling;
      else
        for (e = a.child; e !== null; )
          c |= e.lanes | e.childLanes, d |= e.subtreeFlags, d |= e.flags, e.return = a, e = e.sibling;
      return a.subtreeFlags |= d, a.childLanes = c, b;
    }
    function Fj(a, b, c) {
      var d = b.pendingProps;
      switch (wg(b), b.tag) {
        case 2:
        case 16:
        case 15:
        case 0:
        case 11:
        case 7:
        case 8:
        case 12:
        case 9:
        case 14:
          return S(b), null;
        case 1:
          return Zf(b.type) && $f(), S(b), null;
        case 3:
          return d = b.stateNode, Jh(), E(Wf), E(H), Oh(), d.pendingContext && (d.context = d.pendingContext, d.pendingContext = null), (a === null || a.child === null) && (Gg(b) ? b.flags |= 4 : a === null || a.memoizedState.isDehydrated && !(b.flags & 256) || (b.flags |= 1024, zg !== null && (Gj(zg), zg = null))), Bj(a, b), S(b), null;
        case 5:
          Lh(b);
          var e = Hh(Gh.current);
          if (c = b.type, a !== null && b.stateNode != null)
            Cj(a, b, c, d, e), a.ref !== b.ref && (b.flags |= 512, b.flags |= 2097152);
          else {
            if (!d) {
              if (b.stateNode === null)
                throw Error(p(166));
              return S(b), null;
            }
            if (a = Hh(Eh.current), Gg(b)) {
              d = b.stateNode, c = b.type;
              var f = b.memoizedProps;
              switch (d[Of] = b, d[Pf] = f, a = (b.mode & 1) !== 0, c) {
                case "dialog":
                  D("cancel", d), D("close", d);
                  break;
                case "iframe":
                case "object":
                case "embed":
                  D("load", d);
                  break;
                case "video":
                case "audio":
                  for (e = 0; e < lf.length; e++)
                    D(lf[e], d);
                  break;
                case "source":
                  D("error", d);
                  break;
                case "img":
                case "image":
                case "link":
                  D(
                    "error",
                    d
                  ), D("load", d);
                  break;
                case "details":
                  D("toggle", d);
                  break;
                case "input":
                  Za(d, f), D("invalid", d);
                  break;
                case "select":
                  d._wrapperState = { wasMultiple: !!f.multiple }, D("invalid", d);
                  break;
                case "textarea":
                  hb(d, f), D("invalid", d);
              }
              ub(c, f), e = null;
              for (var g in f)
                if (f.hasOwnProperty(g)) {
                  var h = f[g];
                  g === "children" ? typeof h == "string" ? d.textContent !== h && (f.suppressHydrationWarning !== !0 && Af(d.textContent, h, a), e = ["children", h]) : typeof h == "number" && d.textContent !== "" + h && (f.suppressHydrationWarning !== !0 && Af(
                    d.textContent,
                    h,
                    a
                  ), e = ["children", "" + h]) : ea.hasOwnProperty(g) && h != null && g === "onScroll" && D("scroll", d);
                }
              switch (c) {
                case "input":
                  Va(d), db(d, f, !0);
                  break;
                case "textarea":
                  Va(d), jb(d);
                  break;
                case "select":
                case "option":
                  break;
                default:
                  typeof f.onClick == "function" && (d.onclick = Bf);
              }
              d = e, b.updateQueue = d, d !== null && (b.flags |= 4);
            } else {
              g = e.nodeType === 9 ? e : e.ownerDocument, a === "http://www.w3.org/1999/xhtml" && (a = kb(c)), a === "http://www.w3.org/1999/xhtml" ? c === "script" ? (a = g.createElement("div"), a.innerHTML = "<script></script>", a = a.removeChild(a.firstChild)) : typeof d.is == "string" ? a = g.createElement(c, { is: d.is }) : (a = g.createElement(c), c === "select" && (g = a, d.multiple ? g.multiple = !0 : d.size && (g.size = d.size))) : a = g.createElementNS(a, c), a[Of] = b, a[Pf] = d, Aj(a, b, !1, !1), b.stateNode = a;
              a: {
                switch (g = vb(c, d), c) {
                  case "dialog":
                    D("cancel", a), D("close", a), e = d;
                    break;
                  case "iframe":
                  case "object":
                  case "embed":
                    D("load", a), e = d;
                    break;
                  case "video":
                  case "audio":
                    for (e = 0; e < lf.length; e++)
                      D(lf[e], a);
                    e = d;
                    break;
                  case "source":
                    D("error", a), e = d;
                    break;
                  case "img":
                  case "image":
                  case "link":
                    D(
                      "error",
                      a
                    ), D("load", a), e = d;
                    break;
                  case "details":
                    D("toggle", a), e = d;
                    break;
                  case "input":
                    Za(a, d), e = Ya(a, d), D("invalid", a);
                    break;
                  case "option":
                    e = d;
                    break;
                  case "select":
                    a._wrapperState = { wasMultiple: !!d.multiple }, e = A({}, d, { value: void 0 }), D("invalid", a);
                    break;
                  case "textarea":
                    hb(a, d), e = gb(a, d), D("invalid", a);
                    break;
                  default:
                    e = d;
                }
                ub(c, e), h = e;
                for (f in h)
                  if (h.hasOwnProperty(f)) {
                    var k = h[f];
                    f === "style" ? sb(a, k) : f === "dangerouslySetInnerHTML" ? (k = k ? k.__html : void 0, k != null && nb(a, k)) : f === "children" ? typeof k == "string" ? (c !== "textarea" || k !== "") && ob(a, k) : typeof k == "number" && ob(a, "" + k) : f !== "suppressContentEditableWarning" && f !== "suppressHydrationWarning" && f !== "autoFocus" && (ea.hasOwnProperty(f) ? k != null && f === "onScroll" && D("scroll", a) : k != null && ta(a, f, k, g));
                  }
                switch (c) {
                  case "input":
                    Va(a), db(a, d, !1);
                    break;
                  case "textarea":
                    Va(a), jb(a);
                    break;
                  case "option":
                    d.value != null && a.setAttribute("value", "" + Sa(d.value));
                    break;
                  case "select":
                    a.multiple = !!d.multiple, f = d.value, f != null ? fb(a, !!d.multiple, f, !1) : d.defaultValue != null && fb(
                      a,
                      !!d.multiple,
                      d.defaultValue,
                      !0
                    );
                    break;
                  default:
                    typeof e.onClick == "function" && (a.onclick = Bf);
                }
                switch (c) {
                  case "button":
                  case "input":
                  case "select":
                  case "textarea":
                    d = !!d.autoFocus;
                    break a;
                  case "img":
                    d = !0;
                    break a;
                  default:
                    d = !1;
                }
              }
              d && (b.flags |= 4);
            }
            b.ref !== null && (b.flags |= 512, b.flags |= 2097152);
          }
          return S(b), null;
        case 6:
          if (a && b.stateNode != null)
            Dj(a, b, a.memoizedProps, d);
          else {
            if (typeof d != "string" && b.stateNode === null)
              throw Error(p(166));
            if (c = Hh(Gh.current), Hh(Eh.current), Gg(b)) {
              if (d = b.stateNode, c = b.memoizedProps, d[Of] = b, (f = d.nodeValue !== c) && (a = xg, a !== null))
                switch (a.tag) {
                  case 3:
                    Af(d.nodeValue, c, (a.mode & 1) !== 0);
                    break;
                  case 5:
                    a.memoizedProps.suppressHydrationWarning !== !0 && Af(d.nodeValue, c, (a.mode & 1) !== 0);
                }
              f && (b.flags |= 4);
            } else
              d = (c.nodeType === 9 ? c : c.ownerDocument).createTextNode(d), d[Of] = b, b.stateNode = d;
          }
          return S(b), null;
        case 13:
          if (E(M), d = b.memoizedState, a === null || a.memoizedState !== null && a.memoizedState.dehydrated !== null) {
            if (I && yg !== null && b.mode & 1 && !(b.flags & 128))
              Hg(), Ig(), b.flags |= 98560, f = !1;
            else if (f = Gg(b), d !== null && d.dehydrated !== null) {
              if (a === null) {
                if (!f)
                  throw Error(p(318));
                if (f = b.memoizedState, f = f !== null ? f.dehydrated : null, !f)
                  throw Error(p(317));
                f[Of] = b;
              } else
                Ig(), !(b.flags & 128) && (b.memoizedState = null), b.flags |= 4;
              S(b), f = !1;
            } else
              zg !== null && (Gj(zg), zg = null), f = !0;
            if (!f)
              return b.flags & 65536 ? b : null;
          }
          return b.flags & 128 ? (b.lanes = c, b) : (d = d !== null, d !== (a !== null && a.memoizedState !== null) && d && (b.child.flags |= 8192, b.mode & 1 && (a === null || M.current & 1 ? T === 0 && (T = 3) : uj())), b.updateQueue !== null && (b.flags |= 4), S(b), null);
        case 4:
          return Jh(), Bj(a, b), a === null && sf(b.stateNode.containerInfo), S(b), null;
        case 10:
          return Rg(b.type._context), S(b), null;
        case 17:
          return Zf(b.type) && $f(), S(b), null;
        case 19:
          if (E(M), f = b.memoizedState, f === null)
            return S(b), null;
          if (d = (b.flags & 128) !== 0, g = f.rendering, g === null)
            if (d)
              Ej(f, !1);
            else {
              if (T !== 0 || a !== null && a.flags & 128)
                for (a = b.child; a !== null; ) {
                  if (g = Mh(a), g !== null) {
                    for (b.flags |= 128, Ej(f, !1), d = g.updateQueue, d !== null && (b.updateQueue = d, b.flags |= 4), b.subtreeFlags = 0, d = c, c = b.child; c !== null; )
                      f = c, a = d, f.flags &= 14680066, g = f.alternate, g === null ? (f.childLanes = 0, f.lanes = a, f.child = null, f.subtreeFlags = 0, f.memoizedProps = null, f.memoizedState = null, f.updateQueue = null, f.dependencies = null, f.stateNode = null) : (f.childLanes = g.childLanes, f.lanes = g.lanes, f.child = g.child, f.subtreeFlags = 0, f.deletions = null, f.memoizedProps = g.memoizedProps, f.memoizedState = g.memoizedState, f.updateQueue = g.updateQueue, f.type = g.type, a = g.dependencies, f.dependencies = a === null ? null : { lanes: a.lanes, firstContext: a.firstContext }), c = c.sibling;
                    return G(M, M.current & 1 | 2), b.child;
                  }
                  a = a.sibling;
                }
              f.tail !== null && B() > Hj && (b.flags |= 128, d = !0, Ej(f, !1), b.lanes = 4194304);
            }
          else {
            if (!d)
              if (a = Mh(g), a !== null) {
                if (b.flags |= 128, d = !0, c = a.updateQueue, c !== null && (b.updateQueue = c, b.flags |= 4), Ej(f, !0), f.tail === null && f.tailMode === "hidden" && !g.alternate && !I)
                  return S(b), null;
              } else
                2 * B() - f.renderingStartTime > Hj && c !== 1073741824 && (b.flags |= 128, d = !0, Ej(f, !1), b.lanes = 4194304);
            f.isBackwards ? (g.sibling = b.child, b.child = g) : (c = f.last, c !== null ? c.sibling = g : b.child = g, f.last = g);
          }
          return f.tail !== null ? (b = f.tail, f.rendering = b, f.tail = b.sibling, f.renderingStartTime = B(), b.sibling = null, c = M.current, G(M, d ? c & 1 | 2 : c & 1), b) : (S(b), null);
        case 22:
        case 23:
          return Ij(), d = b.memoizedState !== null, a !== null && a.memoizedState !== null !== d && (b.flags |= 8192), d && b.mode & 1 ? gj & 1073741824 && (S(b), b.subtreeFlags & 6 && (b.flags |= 8192)) : S(b), null;
        case 24:
          return null;
        case 25:
          return null;
      }
      throw Error(p(156, b.tag));
    }
    function Jj(a, b) {
      switch (wg(b), b.tag) {
        case 1:
          return Zf(b.type) && $f(), a = b.flags, a & 65536 ? (b.flags = a & -65537 | 128, b) : null;
        case 3:
          return Jh(), E(Wf), E(H), Oh(), a = b.flags, a & 65536 && !(a & 128) ? (b.flags = a & -65537 | 128, b) : null;
        case 5:
          return Lh(b), null;
        case 13:
          if (E(M), a = b.memoizedState, a !== null && a.dehydrated !== null) {
            if (b.alternate === null)
              throw Error(p(340));
            Ig();
          }
          return a = b.flags, a & 65536 ? (b.flags = a & -65537 | 128, b) : null;
        case 19:
          return E(M), null;
        case 4:
          return Jh(), null;
        case 10:
          return Rg(b.type._context), null;
        case 22:
        case 23:
          return Ij(), null;
        case 24:
          return null;
        default:
          return null;
      }
    }
    var Kj = !1, U = !1, Lj = typeof WeakSet == "function" ? WeakSet : Set, V = null;
    function Mj(a, b) {
      var c = a.ref;
      if (c !== null)
        if (typeof c == "function")
          try {
            c(null);
          } catch (d) {
            W(a, b, d);
          }
        else
          c.current = null;
    }
    function Nj(a, b, c) {
      try {
        c();
      } catch (d) {
        W(a, b, d);
      }
    }
    var Oj = !1;
    function Pj(a, b) {
      if (Cf = dd, a = Me(), Ne(a)) {
        if ("selectionStart" in a)
          var c = { start: a.selectionStart, end: a.selectionEnd };
        else
          a: {
            c = (c = a.ownerDocument) && c.defaultView || window;
            var d = c.getSelection && c.getSelection();
            if (d && d.rangeCount !== 0) {
              c = d.anchorNode;
              var e = d.anchorOffset, f = d.focusNode;
              d = d.focusOffset;
              try {
                c.nodeType, f.nodeType;
              } catch {
                c = null;
                break a;
              }
              var g = 0, h = -1, k = -1, l = 0, m = 0, q = a, r2 = null;
              b:
                for (; ; ) {
                  for (var y; q !== c || e !== 0 && q.nodeType !== 3 || (h = g + e), q !== f || d !== 0 && q.nodeType !== 3 || (k = g + d), q.nodeType === 3 && (g += q.nodeValue.length), (y = q.firstChild) !== null; )
                    r2 = q, q = y;
                  for (; ; ) {
                    if (q === a)
                      break b;
                    if (r2 === c && ++l === e && (h = g), r2 === f && ++m === d && (k = g), (y = q.nextSibling) !== null)
                      break;
                    q = r2, r2 = q.parentNode;
                  }
                  q = y;
                }
              c = h === -1 || k === -1 ? null : { start: h, end: k };
            } else
              c = null;
          }
        c = c || { start: 0, end: 0 };
      } else
        c = null;
      for (Df = { focusedElem: a, selectionRange: c }, dd = !1, V = b; V !== null; )
        if (b = V, a = b.child, (b.subtreeFlags & 1028) !== 0 && a !== null)
          a.return = b, V = a;
        else
          for (; V !== null; ) {
            b = V;
            try {
              var n = b.alternate;
              if (b.flags & 1024)
                switch (b.tag) {
                  case 0:
                  case 11:
                  case 15:
                    break;
                  case 1:
                    if (n !== null) {
                      var t7 = n.memoizedProps, J = n.memoizedState, x = b.stateNode, w = x.getSnapshotBeforeUpdate(b.elementType === b.type ? t7 : Lg(b.type, t7), J);
                      x.__reactInternalSnapshotBeforeUpdate = w;
                    }
                    break;
                  case 3:
                    var u = b.stateNode.containerInfo;
                    u.nodeType === 1 ? u.textContent = "" : u.nodeType === 9 && u.documentElement && u.removeChild(u.documentElement);
                    break;
                  case 5:
                  case 6:
                  case 4:
                  case 17:
                    break;
                  default:
                    throw Error(p(163));
                }
            } catch (F) {
              W(b, b.return, F);
            }
            if (a = b.sibling, a !== null) {
              a.return = b.return, V = a;
              break;
            }
            V = b.return;
          }
      return n = Oj, Oj = !1, n;
    }
    function Qj(a, b, c) {
      var d = b.updateQueue;
      if (d = d !== null ? d.lastEffect : null, d !== null) {
        var e = d = d.next;
        do {
          if ((e.tag & a) === a) {
            var f = e.destroy;
            e.destroy = void 0, f !== void 0 && Nj(b, c, f);
          }
          e = e.next;
        } while (e !== d);
      }
    }
    function Rj(a, b) {
      if (b = b.updateQueue, b = b !== null ? b.lastEffect : null, b !== null) {
        var c = b = b.next;
        do {
          if ((c.tag & a) === a) {
            var d = c.create;
            c.destroy = d();
          }
          c = c.next;
        } while (c !== b);
      }
    }
    function Sj(a) {
      var b = a.ref;
      if (b !== null) {
        var c = a.stateNode;
        switch (a.tag) {
          case 5:
            a = c;
            break;
          default:
            a = c;
        }
        typeof b == "function" ? b(a) : b.current = a;
      }
    }
    function Tj(a) {
      var b = a.alternate;
      b !== null && (a.alternate = null, Tj(b)), a.child = null, a.deletions = null, a.sibling = null, a.tag === 5 && (b = a.stateNode, b !== null && (delete b[Of], delete b[Pf], delete b[of], delete b[Qf], delete b[Rf])), a.stateNode = null, a.return = null, a.dependencies = null, a.memoizedProps = null, a.memoizedState = null, a.pendingProps = null, a.stateNode = null, a.updateQueue = null;
    }
    function Uj(a) {
      return a.tag === 5 || a.tag === 3 || a.tag === 4;
    }
    function Vj(a) {
      a:
        for (; ; ) {
          for (; a.sibling === null; ) {
            if (a.return === null || Uj(a.return))
              return null;
            a = a.return;
          }
          for (a.sibling.return = a.return, a = a.sibling; a.tag !== 5 && a.tag !== 6 && a.tag !== 18; ) {
            if (a.flags & 2 || a.child === null || a.tag === 4)
              continue a;
            a.child.return = a, a = a.child;
          }
          if (!(a.flags & 2))
            return a.stateNode;
        }
    }
    function Wj(a, b, c) {
      var d = a.tag;
      if (d === 5 || d === 6)
        a = a.stateNode, b ? c.nodeType === 8 ? c.parentNode.insertBefore(a, b) : c.insertBefore(a, b) : (c.nodeType === 8 ? (b = c.parentNode, b.insertBefore(a, c)) : (b = c, b.appendChild(a)), c = c._reactRootContainer, c != null || b.onclick !== null || (b.onclick = Bf));
      else if (d !== 4 && (a = a.child, a !== null))
        for (Wj(a, b, c), a = a.sibling; a !== null; )
          Wj(a, b, c), a = a.sibling;
    }
    function Xj(a, b, c) {
      var d = a.tag;
      if (d === 5 || d === 6)
        a = a.stateNode, b ? c.insertBefore(a, b) : c.appendChild(a);
      else if (d !== 4 && (a = a.child, a !== null))
        for (Xj(a, b, c), a = a.sibling; a !== null; )
          Xj(a, b, c), a = a.sibling;
    }
    var X = null, Yj = !1;
    function Zj(a, b, c) {
      for (c = c.child; c !== null; )
        ak(a, b, c), c = c.sibling;
    }
    function ak(a, b, c) {
      if (lc && typeof lc.onCommitFiberUnmount == "function")
        try {
          lc.onCommitFiberUnmount(kc, c);
        } catch {
        }
      switch (c.tag) {
        case 5:
          U || Mj(c, b);
        case 6:
          var d = X, e = Yj;
          X = null, Zj(a, b, c), X = d, Yj = e, X !== null && (Yj ? (a = X, c = c.stateNode, a.nodeType === 8 ? a.parentNode.removeChild(c) : a.removeChild(c)) : X.removeChild(c.stateNode));
          break;
        case 18:
          X !== null && (Yj ? (a = X, c = c.stateNode, a.nodeType === 8 ? Kf(a.parentNode, c) : a.nodeType === 1 && Kf(a, c), bd(a)) : Kf(X, c.stateNode));
          break;
        case 4:
          d = X, e = Yj, X = c.stateNode.containerInfo, Yj = !0, Zj(a, b, c), X = d, Yj = e;
          break;
        case 0:
        case 11:
        case 14:
        case 15:
          if (!U && (d = c.updateQueue, d !== null && (d = d.lastEffect, d !== null))) {
            e = d = d.next;
            do {
              var f = e, g = f.destroy;
              f = f.tag, g !== void 0 && (f & 2 || f & 4) && Nj(c, b, g), e = e.next;
            } while (e !== d);
          }
          Zj(a, b, c);
          break;
        case 1:
          if (!U && (Mj(c, b), d = c.stateNode, typeof d.componentWillUnmount == "function"))
            try {
              d.props = c.memoizedProps, d.state = c.memoizedState, d.componentWillUnmount();
            } catch (h) {
              W(c, b, h);
            }
          Zj(a, b, c);
          break;
        case 21:
          Zj(a, b, c);
          break;
        case 22:
          c.mode & 1 ? (U = (d = U) || c.memoizedState !== null, Zj(a, b, c), U = d) : Zj(a, b, c);
          break;
        default:
          Zj(a, b, c);
      }
    }
    function bk(a) {
      var b = a.updateQueue;
      if (b !== null) {
        a.updateQueue = null;
        var c = a.stateNode;
        c === null && (c = a.stateNode = new Lj()), b.forEach(function(b2) {
          var d = ck.bind(null, a, b2);
          c.has(b2) || (c.add(b2), b2.then(d, d));
        });
      }
    }
    function dk(a, b) {
      var c = b.deletions;
      if (c !== null)
        for (var d = 0; d < c.length; d++) {
          var e = c[d];
          try {
            var f = a, g = b, h = g;
            a:
              for (; h !== null; ) {
                switch (h.tag) {
                  case 5:
                    X = h.stateNode, Yj = !1;
                    break a;
                  case 3:
                    X = h.stateNode.containerInfo, Yj = !0;
                    break a;
                  case 4:
                    X = h.stateNode.containerInfo, Yj = !0;
                    break a;
                }
                h = h.return;
              }
            if (X === null)
              throw Error(p(160));
            ak(f, g, e), X = null, Yj = !1;
            var k = e.alternate;
            k !== null && (k.return = null), e.return = null;
          } catch (l) {
            W(e, b, l);
          }
        }
      if (b.subtreeFlags & 12854)
        for (b = b.child; b !== null; )
          ek(b, a), b = b.sibling;
    }
    function ek(a, b) {
      var c = a.alternate, d = a.flags;
      switch (a.tag) {
        case 0:
        case 11:
        case 14:
        case 15:
          if (dk(b, a), fk(a), d & 4) {
            try {
              Qj(3, a, a.return), Rj(3, a);
            } catch (t7) {
              W(a, a.return, t7);
            }
            try {
              Qj(5, a, a.return);
            } catch (t7) {
              W(a, a.return, t7);
            }
          }
          break;
        case 1:
          dk(b, a), fk(a), d & 512 && c !== null && Mj(c, c.return);
          break;
        case 5:
          if (dk(b, a), fk(a), d & 512 && c !== null && Mj(c, c.return), a.flags & 32) {
            var e = a.stateNode;
            try {
              ob(e, "");
            } catch (t7) {
              W(a, a.return, t7);
            }
          }
          if (d & 4 && (e = a.stateNode, e != null)) {
            var f = a.memoizedProps, g = c !== null ? c.memoizedProps : f, h = a.type, k = a.updateQueue;
            if (a.updateQueue = null, k !== null)
              try {
                h === "input" && f.type === "radio" && f.name != null && ab(e, f), vb(h, g);
                var l = vb(h, f);
                for (g = 0; g < k.length; g += 2) {
                  var m = k[g], q = k[g + 1];
                  m === "style" ? sb(e, q) : m === "dangerouslySetInnerHTML" ? nb(e, q) : m === "children" ? ob(e, q) : ta(e, m, q, l);
                }
                switch (h) {
                  case "input":
                    bb(e, f);
                    break;
                  case "textarea":
                    ib(e, f);
                    break;
                  case "select":
                    var r2 = e._wrapperState.wasMultiple;
                    e._wrapperState.wasMultiple = !!f.multiple;
                    var y = f.value;
                    y != null ? fb(e, !!f.multiple, y, !1) : r2 !== !!f.multiple && (f.defaultValue != null ? fb(
                      e,
                      !!f.multiple,
                      f.defaultValue,
                      !0
                    ) : fb(e, !!f.multiple, f.multiple ? [] : "", !1));
                }
                e[Pf] = f;
              } catch (t7) {
                W(a, a.return, t7);
              }
          }
          break;
        case 6:
          if (dk(b, a), fk(a), d & 4) {
            if (a.stateNode === null)
              throw Error(p(162));
            e = a.stateNode, f = a.memoizedProps;
            try {
              e.nodeValue = f;
            } catch (t7) {
              W(a, a.return, t7);
            }
          }
          break;
        case 3:
          if (dk(b, a), fk(a), d & 4 && c !== null && c.memoizedState.isDehydrated)
            try {
              bd(b.containerInfo);
            } catch (t7) {
              W(a, a.return, t7);
            }
          break;
        case 4:
          dk(b, a), fk(a);
          break;
        case 13:
          dk(b, a), fk(a), e = a.child, e.flags & 8192 && (f = e.memoizedState !== null, e.stateNode.isHidden = f, !f || e.alternate !== null && e.alternate.memoizedState !== null || (gk = B())), d & 4 && bk(a);
          break;
        case 22:
          if (m = c !== null && c.memoizedState !== null, a.mode & 1 ? (U = (l = U) || m, dk(b, a), U = l) : dk(b, a), fk(a), d & 8192) {
            if (l = a.memoizedState !== null, (a.stateNode.isHidden = l) && !m && a.mode & 1)
              for (V = a, m = a.child; m !== null; ) {
                for (q = V = m; V !== null; ) {
                  switch (r2 = V, y = r2.child, r2.tag) {
                    case 0:
                    case 11:
                    case 14:
                    case 15:
                      Qj(4, r2, r2.return);
                      break;
                    case 1:
                      Mj(r2, r2.return);
                      var n = r2.stateNode;
                      if (typeof n.componentWillUnmount == "function") {
                        d = r2, c = r2.return;
                        try {
                          b = d, n.props = b.memoizedProps, n.state = b.memoizedState, n.componentWillUnmount();
                        } catch (t7) {
                          W(d, c, t7);
                        }
                      }
                      break;
                    case 5:
                      Mj(r2, r2.return);
                      break;
                    case 22:
                      if (r2.memoizedState !== null) {
                        hk(q);
                        continue;
                      }
                  }
                  y !== null ? (y.return = r2, V = y) : hk(q);
                }
                m = m.sibling;
              }
            a:
              for (m = null, q = a; ; ) {
                if (q.tag === 5) {
                  if (m === null) {
                    m = q;
                    try {
                      e = q.stateNode, l ? (f = e.style, typeof f.setProperty == "function" ? f.setProperty("display", "none", "important") : f.display = "none") : (h = q.stateNode, k = q.memoizedProps.style, g = k != null && k.hasOwnProperty("display") ? k.display : null, h.style.display = rb("display", g));
                    } catch (t7) {
                      W(a, a.return, t7);
                    }
                  }
                } else if (q.tag === 6) {
                  if (m === null)
                    try {
                      q.stateNode.nodeValue = l ? "" : q.memoizedProps;
                    } catch (t7) {
                      W(a, a.return, t7);
                    }
                } else if ((q.tag !== 22 && q.tag !== 23 || q.memoizedState === null || q === a) && q.child !== null) {
                  q.child.return = q, q = q.child;
                  continue;
                }
                if (q === a)
                  break a;
                for (; q.sibling === null; ) {
                  if (q.return === null || q.return === a)
                    break a;
                  m === q && (m = null), q = q.return;
                }
                m === q && (m = null), q.sibling.return = q.return, q = q.sibling;
              }
          }
          break;
        case 19:
          dk(b, a), fk(a), d & 4 && bk(a);
          break;
        case 21:
          break;
        default:
          dk(
            b,
            a
          ), fk(a);
      }
    }
    function fk(a) {
      var b = a.flags;
      if (b & 2) {
        try {
          a: {
            for (var c = a.return; c !== null; ) {
              if (Uj(c)) {
                var d = c;
                break a;
              }
              c = c.return;
            }
            throw Error(p(160));
          }
          switch (d.tag) {
            case 5:
              var e = d.stateNode;
              d.flags & 32 && (ob(e, ""), d.flags &= -33);
              var f = Vj(a);
              Xj(a, f, e);
              break;
            case 3:
            case 4:
              var g = d.stateNode.containerInfo, h = Vj(a);
              Wj(a, h, g);
              break;
            default:
              throw Error(p(161));
          }
        } catch (k) {
          W(a, a.return, k);
        }
        a.flags &= -3;
      }
      b & 4096 && (a.flags &= -4097);
    }
    function ik(a, b, c) {
      V = a, jk(a, b, c);
    }
    function jk(a, b, c) {
      for (var d = (a.mode & 1) !== 0; V !== null; ) {
        var e = V, f = e.child;
        if (e.tag === 22 && d) {
          var g = e.memoizedState !== null || Kj;
          if (!g) {
            var h = e.alternate, k = h !== null && h.memoizedState !== null || U;
            h = Kj;
            var l = U;
            if (Kj = g, (U = k) && !l)
              for (V = e; V !== null; )
                g = V, k = g.child, g.tag === 22 && g.memoizedState !== null ? kk(e) : k !== null ? (k.return = g, V = k) : kk(e);
            for (; f !== null; )
              V = f, jk(f, b, c), f = f.sibling;
            V = e, Kj = h, U = l;
          }
          lk(a, b, c);
        } else
          e.subtreeFlags & 8772 && f !== null ? (f.return = e, V = f) : lk(a, b, c);
      }
    }
    function lk(a) {
      for (; V !== null; ) {
        var b = V;
        if (b.flags & 8772) {
          var c = b.alternate;
          try {
            if (b.flags & 8772)
              switch (b.tag) {
                case 0:
                case 11:
                case 15:
                  U || Rj(5, b);
                  break;
                case 1:
                  var d = b.stateNode;
                  if (b.flags & 4 && !U)
                    if (c === null)
                      d.componentDidMount();
                    else {
                      var e = b.elementType === b.type ? c.memoizedProps : Lg(b.type, c.memoizedProps);
                      d.componentDidUpdate(e, c.memoizedState, d.__reactInternalSnapshotBeforeUpdate);
                    }
                  var f = b.updateQueue;
                  f !== null && ih(b, f, d);
                  break;
                case 3:
                  var g = b.updateQueue;
                  if (g !== null) {
                    if (c = null, b.child !== null)
                      switch (b.child.tag) {
                        case 5:
                          c = b.child.stateNode;
                          break;
                        case 1:
                          c = b.child.stateNode;
                      }
                    ih(b, g, c);
                  }
                  break;
                case 5:
                  var h = b.stateNode;
                  if (c === null && b.flags & 4) {
                    c = h;
                    var k = b.memoizedProps;
                    switch (b.type) {
                      case "button":
                      case "input":
                      case "select":
                      case "textarea":
                        k.autoFocus && c.focus();
                        break;
                      case "img":
                        k.src && (c.src = k.src);
                    }
                  }
                  break;
                case 6:
                  break;
                case 4:
                  break;
                case 12:
                  break;
                case 13:
                  if (b.memoizedState === null) {
                    var l = b.alternate;
                    if (l !== null) {
                      var m = l.memoizedState;
                      if (m !== null) {
                        var q = m.dehydrated;
                        q !== null && bd(q);
                      }
                    }
                  }
                  break;
                case 19:
                case 17:
                case 21:
                case 22:
                case 23:
                case 25:
                  break;
                default:
                  throw Error(p(163));
              }
            U || b.flags & 512 && Sj(b);
          } catch (r2) {
            W(b, b.return, r2);
          }
        }
        if (b === a) {
          V = null;
          break;
        }
        if (c = b.sibling, c !== null) {
          c.return = b.return, V = c;
          break;
        }
        V = b.return;
      }
    }
    function hk(a) {
      for (; V !== null; ) {
        var b = V;
        if (b === a) {
          V = null;
          break;
        }
        var c = b.sibling;
        if (c !== null) {
          c.return = b.return, V = c;
          break;
        }
        V = b.return;
      }
    }
    function kk(a) {
      for (; V !== null; ) {
        var b = V;
        try {
          switch (b.tag) {
            case 0:
            case 11:
            case 15:
              var c = b.return;
              try {
                Rj(4, b);
              } catch (k) {
                W(b, c, k);
              }
              break;
            case 1:
              var d = b.stateNode;
              if (typeof d.componentDidMount == "function") {
                var e = b.return;
                try {
                  d.componentDidMount();
                } catch (k) {
                  W(b, e, k);
                }
              }
              var f = b.return;
              try {
                Sj(b);
              } catch (k) {
                W(b, f, k);
              }
              break;
            case 5:
              var g = b.return;
              try {
                Sj(b);
              } catch (k) {
                W(b, g, k);
              }
          }
        } catch (k) {
          W(b, b.return, k);
        }
        if (b === a) {
          V = null;
          break;
        }
        var h = b.sibling;
        if (h !== null) {
          h.return = b.return, V = h;
          break;
        }
        V = b.return;
      }
    }
    var mk = Math.ceil, nk = ua.ReactCurrentDispatcher, ok2 = ua.ReactCurrentOwner, pk = ua.ReactCurrentBatchConfig, K = 0, R = null, Y = null, Z = 0, gj = 0, fj = Uf(0), T = 0, qk = null, hh = 0, rk = 0, sk = 0, tk = null, uk = null, gk = 0, Hj = 1 / 0, vk = null, Pi = !1, Qi = null, Si = null, wk = !1, xk = null, yk = 0, zk = 0, Ak = null, Bk = -1, Ck = 0;
    function L() {
      return K & 6 ? B() : Bk !== -1 ? Bk : Bk = B();
    }
    function lh(a) {
      return a.mode & 1 ? K & 2 && Z !== 0 ? Z & -Z : Kg.transition !== null ? (Ck === 0 && (Ck = yc()), Ck) : (a = C, a !== 0 || (a = window.event, a = a === void 0 ? 16 : jd(a.type)), a) : 1;
    }
    function mh(a, b, c, d) {
      if (50 < zk)
        throw zk = 0, Ak = null, Error(p(185));
      Ac(a, c, d), (!(K & 2) || a !== R) && (a === R && (!(K & 2) && (rk |= c), T === 4 && Dk(a, Z)), Ek(a, d), c === 1 && K === 0 && !(b.mode & 1) && (Hj = B() + 500, fg && jg()));
    }
    function Ek(a, b) {
      var c = a.callbackNode;
      wc(a, b);
      var d = uc(a, a === R ? Z : 0);
      if (d === 0)
        c !== null && bc(c), a.callbackNode = null, a.callbackPriority = 0;
      else if (b = d & -d, a.callbackPriority !== b) {
        if (c != null && bc(c), b === 1)
          a.tag === 0 ? ig(Fk.bind(null, a)) : hg(Fk.bind(null, a)), Jf(function() {
            !(K & 6) && jg();
          }), c = null;
        else {
          switch (Dc(d)) {
            case 1:
              c = fc;
              break;
            case 4:
              c = gc;
              break;
            case 16:
              c = hc;
              break;
            case 536870912:
              c = jc;
              break;
            default:
              c = hc;
          }
          c = Gk(c, Hk.bind(null, a));
        }
        a.callbackPriority = b, a.callbackNode = c;
      }
    }
    function Hk(a, b) {
      if (Bk = -1, Ck = 0, K & 6)
        throw Error(p(327));
      var c = a.callbackNode;
      if (Ik() && a.callbackNode !== c)
        return null;
      var d = uc(a, a === R ? Z : 0);
      if (d === 0)
        return null;
      if (d & 30 || d & a.expiredLanes || b)
        b = Jk(a, d);
      else {
        b = d;
        var e = K;
        K |= 2;
        var f = Kk();
        (R !== a || Z !== b) && (vk = null, Hj = B() + 500, Lk(a, b));
        do
          try {
            Mk();
            break;
          } catch (h) {
            Nk(a, h);
          }
        while (!0);
        Qg(), nk.current = f, K = e, Y !== null ? b = 0 : (R = null, Z = 0, b = T);
      }
      if (b !== 0) {
        if (b === 2 && (e = xc(a), e !== 0 && (d = e, b = Ok(a, e))), b === 1)
          throw c = qk, Lk(a, 0), Dk(a, d), Ek(a, B()), c;
        if (b === 6)
          Dk(a, d);
        else {
          if (e = a.current.alternate, !(d & 30) && !Pk(e) && (b = Jk(a, d), b === 2 && (f = xc(a), f !== 0 && (d = f, b = Ok(a, f))), b === 1))
            throw c = qk, Lk(a, 0), Dk(a, d), Ek(a, B()), c;
          switch (a.finishedWork = e, a.finishedLanes = d, b) {
            case 0:
            case 1:
              throw Error(p(345));
            case 2:
              Qk(a, uk, vk);
              break;
            case 3:
              if (Dk(a, d), (d & 130023424) === d && (b = gk + 500 - B(), 10 < b)) {
                if (uc(a, 0) !== 0)
                  break;
                if (e = a.suspendedLanes, (e & d) !== d) {
                  L(), a.pingedLanes |= a.suspendedLanes & e;
                  break;
                }
                a.timeoutHandle = Ff(Qk.bind(null, a, uk, vk), b);
                break;
              }
              Qk(a, uk, vk);
              break;
            case 4:
              if (Dk(a, d), (d & 4194240) === d)
                break;
              for (b = a.eventTimes, e = -1; 0 < d; ) {
                var g = 31 - oc(d);
                f = 1 << g, g = b[g], g > e && (e = g), d &= ~f;
              }
              if (d = e, d = B() - d, d = (120 > d ? 120 : 480 > d ? 480 : 1080 > d ? 1080 : 1920 > d ? 1920 : 3e3 > d ? 3e3 : 4320 > d ? 4320 : 1960 * mk(d / 1960)) - d, 10 < d) {
                a.timeoutHandle = Ff(Qk.bind(null, a, uk, vk), d);
                break;
              }
              Qk(a, uk, vk);
              break;
            case 5:
              Qk(a, uk, vk);
              break;
            default:
              throw Error(p(329));
          }
        }
      }
      return Ek(a, B()), a.callbackNode === c ? Hk.bind(null, a) : null;
    }
    function Ok(a, b) {
      var c = tk;
      return a.current.memoizedState.isDehydrated && (Lk(a, b).flags |= 256), a = Jk(a, b), a !== 2 && (b = uk, uk = c, b !== null && Gj(b)), a;
    }
    function Gj(a) {
      uk === null ? uk = a : uk.push.apply(uk, a);
    }
    function Pk(a) {
      for (var b = a; ; ) {
        if (b.flags & 16384) {
          var c = b.updateQueue;
          if (c !== null && (c = c.stores, c !== null))
            for (var d = 0; d < c.length; d++) {
              var e = c[d], f = e.getSnapshot;
              e = e.value;
              try {
                if (!He(f(), e))
                  return !1;
              } catch {
                return !1;
              }
            }
        }
        if (c = b.child, b.subtreeFlags & 16384 && c !== null)
          c.return = b, b = c;
        else {
          if (b === a)
            break;
          for (; b.sibling === null; ) {
            if (b.return === null || b.return === a)
              return !0;
            b = b.return;
          }
          b.sibling.return = b.return, b = b.sibling;
        }
      }
      return !0;
    }
    function Dk(a, b) {
      for (b &= ~sk, b &= ~rk, a.suspendedLanes |= b, a.pingedLanes &= ~b, a = a.expirationTimes; 0 < b; ) {
        var c = 31 - oc(b), d = 1 << c;
        a[c] = -1, b &= ~d;
      }
    }
    function Fk(a) {
      if (K & 6)
        throw Error(p(327));
      Ik();
      var b = uc(a, 0);
      if (!(b & 1))
        return Ek(a, B()), null;
      var c = Jk(a, b);
      if (a.tag !== 0 && c === 2) {
        var d = xc(a);
        d !== 0 && (b = d, c = Ok(a, d));
      }
      if (c === 1)
        throw c = qk, Lk(a, 0), Dk(a, b), Ek(a, B()), c;
      if (c === 6)
        throw Error(p(345));
      return a.finishedWork = a.current.alternate, a.finishedLanes = b, Qk(a, uk, vk), Ek(a, B()), null;
    }
    function Rk(a, b) {
      var c = K;
      K |= 1;
      try {
        return a(b);
      } finally {
        K = c, K === 0 && (Hj = B() + 500, fg && jg());
      }
    }
    function Sk(a) {
      xk !== null && xk.tag === 0 && !(K & 6) && Ik();
      var b = K;
      K |= 1;
      var c = pk.transition, d = C;
      try {
        if (pk.transition = null, C = 1, a)
          return a();
      } finally {
        C = d, pk.transition = c, K = b, !(K & 6) && jg();
      }
    }
    function Ij() {
      gj = fj.current, E(fj);
    }
    function Lk(a, b) {
      a.finishedWork = null, a.finishedLanes = 0;
      var c = a.timeoutHandle;
      if (c !== -1 && (a.timeoutHandle = -1, Gf(c)), Y !== null)
        for (c = Y.return; c !== null; ) {
          var d = c;
          switch (wg(d), d.tag) {
            case 1:
              d = d.type.childContextTypes, d != null && $f();
              break;
            case 3:
              Jh(), E(Wf), E(H), Oh();
              break;
            case 5:
              Lh(d);
              break;
            case 4:
              Jh();
              break;
            case 13:
              E(M);
              break;
            case 19:
              E(M);
              break;
            case 10:
              Rg(d.type._context);
              break;
            case 22:
            case 23:
              Ij();
          }
          c = c.return;
        }
      if (R = a, Y = a = wh(a.current, null), Z = gj = b, T = 0, qk = null, sk = rk = hh = 0, uk = tk = null, Wg !== null) {
        for (b = 0; b < Wg.length; b++)
          if (c = Wg[b], d = c.interleaved, d !== null) {
            c.interleaved = null;
            var e = d.next, f = c.pending;
            if (f !== null) {
              var g = f.next;
              f.next = e, d.next = g;
            }
            c.pending = d;
          }
        Wg = null;
      }
      return a;
    }
    function Nk(a, b) {
      do {
        var c = Y;
        try {
          if (Qg(), Ph.current = ai, Sh) {
            for (var d = N.memoizedState; d !== null; ) {
              var e = d.queue;
              e !== null && (e.pending = null), d = d.next;
            }
            Sh = !1;
          }
          if (Rh = 0, P = O = N = null, Th = !1, Uh = 0, ok2.current = null, c === null || c.return === null) {
            T = 1, qk = b, Y = null;
            break;
          }
          a: {
            var f = a, g = c.return, h = c, k = b;
            if (b = Z, h.flags |= 32768, k !== null && typeof k == "object" && typeof k.then == "function") {
              var l = k, m = h, q = m.tag;
              if (!(m.mode & 1) && (q === 0 || q === 11 || q === 15)) {
                var r2 = m.alternate;
                r2 ? (m.updateQueue = r2.updateQueue, m.memoizedState = r2.memoizedState, m.lanes = r2.lanes) : (m.updateQueue = null, m.memoizedState = null);
              }
              var y = Vi(g);
              if (y !== null) {
                y.flags &= -257, Wi(y, g, h, f, b), y.mode & 1 && Ti(f, l, b), b = y, k = l;
                var n = b.updateQueue;
                if (n === null) {
                  var t7 = /* @__PURE__ */ new Set();
                  t7.add(k), b.updateQueue = t7;
                } else
                  n.add(k);
                break a;
              } else {
                if (!(b & 1)) {
                  Ti(f, l, b), uj();
                  break a;
                }
                k = Error(p(426));
              }
            } else if (I && h.mode & 1) {
              var J = Vi(g);
              if (J !== null) {
                !(J.flags & 65536) && (J.flags |= 256), Wi(J, g, h, f, b), Jg(Ki(k, h));
                break a;
              }
            }
            f = k = Ki(k, h), T !== 4 && (T = 2), tk === null ? tk = [f] : tk.push(f), f = g;
            do {
              switch (f.tag) {
                case 3:
                  f.flags |= 65536, b &= -b, f.lanes |= b;
                  var x = Oi(f, k, b);
                  fh(f, x);
                  break a;
                case 1:
                  h = k;
                  var w = f.type, u = f.stateNode;
                  if (!(f.flags & 128) && (typeof w.getDerivedStateFromError == "function" || u !== null && typeof u.componentDidCatch == "function" && (Si === null || !Si.has(u)))) {
                    f.flags |= 65536, b &= -b, f.lanes |= b;
                    var F = Ri(f, h, b);
                    fh(f, F);
                    break a;
                  }
              }
              f = f.return;
            } while (f !== null);
          }
          Tk(c);
        } catch (na) {
          b = na, Y === c && c !== null && (Y = c = c.return);
          continue;
        }
        break;
      } while (!0);
    }
    function Kk() {
      var a = nk.current;
      return nk.current = ai, a === null ? ai : a;
    }
    function uj() {
      (T === 0 || T === 3 || T === 2) && (T = 4), R === null || !(hh & 268435455) && !(rk & 268435455) || Dk(R, Z);
    }
    function Jk(a, b) {
      var c = K;
      K |= 2;
      var d = Kk();
      (R !== a || Z !== b) && (vk = null, Lk(a, b));
      do
        try {
          Uk();
          break;
        } catch (e) {
          Nk(a, e);
        }
      while (!0);
      if (Qg(), K = c, nk.current = d, Y !== null)
        throw Error(p(261));
      return R = null, Z = 0, T;
    }
    function Uk() {
      for (; Y !== null; )
        Vk(Y);
    }
    function Mk() {
      for (; Y !== null && !cc(); )
        Vk(Y);
    }
    function Vk(a) {
      var b = Wk(a.alternate, a, gj);
      a.memoizedProps = a.pendingProps, b === null ? Tk(a) : Y = b, ok2.current = null;
    }
    function Tk(a) {
      var b = a;
      do {
        var c = b.alternate;
        if (a = b.return, b.flags & 32768) {
          if (c = Jj(c, b), c !== null) {
            c.flags &= 32767, Y = c;
            return;
          }
          if (a !== null)
            a.flags |= 32768, a.subtreeFlags = 0, a.deletions = null;
          else {
            T = 6, Y = null;
            return;
          }
        } else if (c = Fj(c, b, gj), c !== null) {
          Y = c;
          return;
        }
        if (b = b.sibling, b !== null) {
          Y = b;
          return;
        }
        Y = b = a;
      } while (b !== null);
      T === 0 && (T = 5);
    }
    function Qk(a, b, c) {
      var d = C, e = pk.transition;
      try {
        pk.transition = null, C = 1, Xk(a, b, c, d);
      } finally {
        pk.transition = e, C = d;
      }
      return null;
    }
    function Xk(a, b, c, d) {
      do
        Ik();
      while (xk !== null);
      if (K & 6)
        throw Error(p(327));
      c = a.finishedWork;
      var e = a.finishedLanes;
      if (c === null)
        return null;
      if (a.finishedWork = null, a.finishedLanes = 0, c === a.current)
        throw Error(p(177));
      a.callbackNode = null, a.callbackPriority = 0;
      var f = c.lanes | c.childLanes;
      if (Bc(a, f), a === R && (Y = R = null, Z = 0), !(c.subtreeFlags & 2064) && !(c.flags & 2064) || wk || (wk = !0, Gk(hc, function() {
        return Ik(), null;
      })), f = (c.flags & 15990) !== 0, c.subtreeFlags & 15990 || f) {
        f = pk.transition, pk.transition = null;
        var g = C;
        C = 1;
        var h = K;
        K |= 4, ok2.current = null, Pj(a, c), ek(c, a), Oe(Df), dd = !!Cf, Df = Cf = null, a.current = c, ik(c, a, e), dc(), K = h, C = g, pk.transition = f;
      } else
        a.current = c;
      if (wk && (wk = !1, xk = a, yk = e), f = a.pendingLanes, f === 0 && (Si = null), mc(c.stateNode, d), Ek(a, B()), b !== null)
        for (d = a.onRecoverableError, c = 0; c < b.length; c++)
          e = b[c], d(e.value, { componentStack: e.stack, digest: e.digest });
      if (Pi)
        throw Pi = !1, a = Qi, Qi = null, a;
      return yk & 1 && a.tag !== 0 && Ik(), f = a.pendingLanes, f & 1 ? a === Ak ? zk++ : (zk = 0, Ak = a) : zk = 0, jg(), null;
    }
    function Ik() {
      if (xk !== null) {
        var a = Dc(yk), b = pk.transition, c = C;
        try {
          if (pk.transition = null, C = 16 > a ? 16 : a, xk === null)
            var d = !1;
          else {
            if (a = xk, xk = null, yk = 0, K & 6)
              throw Error(p(331));
            var e = K;
            for (K |= 4, V = a.current; V !== null; ) {
              var f = V, g = f.child;
              if (V.flags & 16) {
                var h = f.deletions;
                if (h !== null) {
                  for (var k = 0; k < h.length; k++) {
                    var l = h[k];
                    for (V = l; V !== null; ) {
                      var m = V;
                      switch (m.tag) {
                        case 0:
                        case 11:
                        case 15:
                          Qj(8, m, f);
                      }
                      var q = m.child;
                      if (q !== null)
                        q.return = m, V = q;
                      else
                        for (; V !== null; ) {
                          m = V;
                          var r2 = m.sibling, y = m.return;
                          if (Tj(m), m === l) {
                            V = null;
                            break;
                          }
                          if (r2 !== null) {
                            r2.return = y, V = r2;
                            break;
                          }
                          V = y;
                        }
                    }
                  }
                  var n = f.alternate;
                  if (n !== null) {
                    var t7 = n.child;
                    if (t7 !== null) {
                      n.child = null;
                      do {
                        var J = t7.sibling;
                        t7.sibling = null, t7 = J;
                      } while (t7 !== null);
                    }
                  }
                  V = f;
                }
              }
              if (f.subtreeFlags & 2064 && g !== null)
                g.return = f, V = g;
              else
                b:
                  for (; V !== null; ) {
                    if (f = V, f.flags & 2048)
                      switch (f.tag) {
                        case 0:
                        case 11:
                        case 15:
                          Qj(9, f, f.return);
                      }
                    var x = f.sibling;
                    if (x !== null) {
                      x.return = f.return, V = x;
                      break b;
                    }
                    V = f.return;
                  }
            }
            var w = a.current;
            for (V = w; V !== null; ) {
              g = V;
              var u = g.child;
              if (g.subtreeFlags & 2064 && u !== null)
                u.return = g, V = u;
              else
                b:
                  for (g = w; V !== null; ) {
                    if (h = V, h.flags & 2048)
                      try {
                        switch (h.tag) {
                          case 0:
                          case 11:
                          case 15:
                            Rj(9, h);
                        }
                      } catch (na) {
                        W(h, h.return, na);
                      }
                    if (h === g) {
                      V = null;
                      break b;
                    }
                    var F = h.sibling;
                    if (F !== null) {
                      F.return = h.return, V = F;
                      break b;
                    }
                    V = h.return;
                  }
            }
            if (K = e, jg(), lc && typeof lc.onPostCommitFiberRoot == "function")
              try {
                lc.onPostCommitFiberRoot(kc, a);
              } catch {
              }
            d = !0;
          }
          return d;
        } finally {
          C = c, pk.transition = b;
        }
      }
      return !1;
    }
    function Yk(a, b, c) {
      b = Ki(c, b), b = Oi(a, b, 1), a = dh(a, b, 1), b = L(), a !== null && (Ac(a, 1, b), Ek(a, b));
    }
    function W(a, b, c) {
      if (a.tag === 3)
        Yk(a, a, c);
      else
        for (; b !== null; ) {
          if (b.tag === 3) {
            Yk(b, a, c);
            break;
          } else if (b.tag === 1) {
            var d = b.stateNode;
            if (typeof b.type.getDerivedStateFromError == "function" || typeof d.componentDidCatch == "function" && (Si === null || !Si.has(d))) {
              a = Ki(c, a), a = Ri(b, a, 1), b = dh(b, a, 1), a = L(), b !== null && (Ac(b, 1, a), Ek(b, a));
              break;
            }
          }
          b = b.return;
        }
    }
    function Ui(a, b, c) {
      var d = a.pingCache;
      d !== null && d.delete(b), b = L(), a.pingedLanes |= a.suspendedLanes & c, R === a && (Z & c) === c && (T === 4 || T === 3 && (Z & 130023424) === Z && 500 > B() - gk ? Lk(a, 0) : sk |= c), Ek(a, b);
    }
    function Zk(a, b) {
      b === 0 && (a.mode & 1 ? (b = sc, sc <<= 1, !(sc & 130023424) && (sc = 4194304)) : b = 1);
      var c = L();
      a = Zg(a, b), a !== null && (Ac(a, b, c), Ek(a, c));
    }
    function vj(a) {
      var b = a.memoizedState, c = 0;
      b !== null && (c = b.retryLane), Zk(a, c);
    }
    function ck(a, b) {
      var c = 0;
      switch (a.tag) {
        case 13:
          var d = a.stateNode, e = a.memoizedState;
          e !== null && (c = e.retryLane);
          break;
        case 19:
          d = a.stateNode;
          break;
        default:
          throw Error(p(314));
      }
      d !== null && d.delete(b), Zk(a, c);
    }
    var Wk;
    Wk = function(a, b, c) {
      if (a !== null)
        if (a.memoizedProps !== b.pendingProps || Wf.current)
          Ug = !0;
        else {
          if (!(a.lanes & c) && !(b.flags & 128))
            return Ug = !1, zj(a, b, c);
          Ug = !!(a.flags & 131072);
        }
      else
        Ug = !1, I && b.flags & 1048576 && ug(b, ng, b.index);
      switch (b.lanes = 0, b.tag) {
        case 2:
          var d = b.type;
          jj(a, b), a = b.pendingProps;
          var e = Yf(b, H.current);
          Tg(b, c), e = Xh(null, b, d, a, e, c);
          var f = bi();
          return b.flags |= 1, typeof e == "object" && e !== null && typeof e.render == "function" && e.$$typeof === void 0 ? (b.tag = 1, b.memoizedState = null, b.updateQueue = null, Zf(d) ? (f = !0, cg(b)) : f = !1, b.memoizedState = e.state !== null && e.state !== void 0 ? e.state : null, ah(b), e.updater = nh, b.stateNode = e, e._reactInternals = b, rh(b, d, a, c), b = kj(null, b, d, !0, f, c)) : (b.tag = 0, I && f && vg(b), Yi(null, b, e, c), b = b.child), b;
        case 16:
          d = b.elementType;
          a: {
            switch (jj(a, b), a = b.pendingProps, e = d._init, d = e(d._payload), b.type = d, e = b.tag = $k(d), a = Lg(d, a), e) {
              case 0:
                b = dj(null, b, d, a, c);
                break a;
              case 1:
                b = ij(null, b, d, a, c);
                break a;
              case 11:
                b = Zi(null, b, d, a, c);
                break a;
              case 14:
                b = aj(null, b, d, Lg(d.type, a), c);
                break a;
            }
            throw Error(p(
              306,
              d,
              ""
            ));
          }
          return b;
        case 0:
          return d = b.type, e = b.pendingProps, e = b.elementType === d ? e : Lg(d, e), dj(a, b, d, e, c);
        case 1:
          return d = b.type, e = b.pendingProps, e = b.elementType === d ? e : Lg(d, e), ij(a, b, d, e, c);
        case 3:
          a: {
            if (lj(b), a === null)
              throw Error(p(387));
            d = b.pendingProps, f = b.memoizedState, e = f.element, bh(a, b), gh(b, d, null, c);
            var g = b.memoizedState;
            if (d = g.element, f.isDehydrated)
              if (f = { element: d, isDehydrated: !1, cache: g.cache, pendingSuspenseBoundaries: g.pendingSuspenseBoundaries, transitions: g.transitions }, b.updateQueue.baseState = f, b.memoizedState = f, b.flags & 256) {
                e = Ki(Error(p(423)), b), b = mj(a, b, d, c, e);
                break a;
              } else if (d !== e) {
                e = Ki(Error(p(424)), b), b = mj(a, b, d, c, e);
                break a;
              } else
                for (yg = Lf(b.stateNode.containerInfo.firstChild), xg = b, I = !0, zg = null, c = Ch(b, null, d, c), b.child = c; c; )
                  c.flags = c.flags & -3 | 4096, c = c.sibling;
            else {
              if (Ig(), d === e) {
                b = $i(a, b, c);
                break a;
              }
              Yi(a, b, d, c);
            }
            b = b.child;
          }
          return b;
        case 5:
          return Kh(b), a === null && Eg(b), d = b.type, e = b.pendingProps, f = a !== null ? a.memoizedProps : null, g = e.children, Ef(d, e) ? g = null : f !== null && Ef(d, f) && (b.flags |= 32), hj(a, b), Yi(a, b, g, c), b.child;
        case 6:
          return a === null && Eg(b), null;
        case 13:
          return pj(a, b, c);
        case 4:
          return Ih(b, b.stateNode.containerInfo), d = b.pendingProps, a === null ? b.child = Bh(b, null, d, c) : Yi(a, b, d, c), b.child;
        case 11:
          return d = b.type, e = b.pendingProps, e = b.elementType === d ? e : Lg(d, e), Zi(a, b, d, e, c);
        case 7:
          return Yi(a, b, b.pendingProps, c), b.child;
        case 8:
          return Yi(a, b, b.pendingProps.children, c), b.child;
        case 12:
          return Yi(a, b, b.pendingProps.children, c), b.child;
        case 10:
          a: {
            if (d = b.type._context, e = b.pendingProps, f = b.memoizedProps, g = e.value, G(Mg, d._currentValue), d._currentValue = g, f !== null)
              if (He(f.value, g)) {
                if (f.children === e.children && !Wf.current) {
                  b = $i(a, b, c);
                  break a;
                }
              } else
                for (f = b.child, f !== null && (f.return = b); f !== null; ) {
                  var h = f.dependencies;
                  if (h !== null) {
                    g = f.child;
                    for (var k = h.firstContext; k !== null; ) {
                      if (k.context === d) {
                        if (f.tag === 1) {
                          k = ch(-1, c & -c), k.tag = 2;
                          var l = f.updateQueue;
                          if (l !== null) {
                            l = l.shared;
                            var m = l.pending;
                            m === null ? k.next = k : (k.next = m.next, m.next = k), l.pending = k;
                          }
                        }
                        f.lanes |= c, k = f.alternate, k !== null && (k.lanes |= c), Sg(
                          f.return,
                          c,
                          b
                        ), h.lanes |= c;
                        break;
                      }
                      k = k.next;
                    }
                  } else if (f.tag === 10)
                    g = f.type === b.type ? null : f.child;
                  else if (f.tag === 18) {
                    if (g = f.return, g === null)
                      throw Error(p(341));
                    g.lanes |= c, h = g.alternate, h !== null && (h.lanes |= c), Sg(g, c, b), g = f.sibling;
                  } else
                    g = f.child;
                  if (g !== null)
                    g.return = f;
                  else
                    for (g = f; g !== null; ) {
                      if (g === b) {
                        g = null;
                        break;
                      }
                      if (f = g.sibling, f !== null) {
                        f.return = g.return, g = f;
                        break;
                      }
                      g = g.return;
                    }
                  f = g;
                }
            Yi(a, b, e.children, c), b = b.child;
          }
          return b;
        case 9:
          return e = b.type, d = b.pendingProps.children, Tg(b, c), e = Vg(e), d = d(e), b.flags |= 1, Yi(a, b, d, c), b.child;
        case 14:
          return d = b.type, e = Lg(d, b.pendingProps), e = Lg(d.type, e), aj(a, b, d, e, c);
        case 15:
          return cj(a, b, b.type, b.pendingProps, c);
        case 17:
          return d = b.type, e = b.pendingProps, e = b.elementType === d ? e : Lg(d, e), jj(a, b), b.tag = 1, Zf(d) ? (a = !0, cg(b)) : a = !1, Tg(b, c), ph(b, d, e), rh(b, d, e, c), kj(null, b, d, !0, a, c);
        case 19:
          return yj(a, b, c);
        case 22:
          return ej(a, b, c);
      }
      throw Error(p(156, b.tag));
    };
    function Gk(a, b) {
      return ac(a, b);
    }
    function al(a, b, c, d) {
      this.tag = a, this.key = c, this.sibling = this.child = this.return = this.stateNode = this.type = this.elementType = null, this.index = 0, this.ref = null, this.pendingProps = b, this.dependencies = this.memoizedState = this.updateQueue = this.memoizedProps = null, this.mode = d, this.subtreeFlags = this.flags = 0, this.deletions = null, this.childLanes = this.lanes = 0, this.alternate = null;
    }
    function Bg(a, b, c, d) {
      return new al(a, b, c, d);
    }
    function bj(a) {
      return a = a.prototype, !(!a || !a.isReactComponent);
    }
    function $k(a) {
      if (typeof a == "function")
        return bj(a) ? 1 : 0;
      if (a != null) {
        if (a = a.$$typeof, a === Da)
          return 11;
        if (a === Ga)
          return 14;
      }
      return 2;
    }
    function wh(a, b) {
      var c = a.alternate;
      return c === null ? (c = Bg(a.tag, b, a.key, a.mode), c.elementType = a.elementType, c.type = a.type, c.stateNode = a.stateNode, c.alternate = a, a.alternate = c) : (c.pendingProps = b, c.type = a.type, c.flags = 0, c.subtreeFlags = 0, c.deletions = null), c.flags = a.flags & 14680064, c.childLanes = a.childLanes, c.lanes = a.lanes, c.child = a.child, c.memoizedProps = a.memoizedProps, c.memoizedState = a.memoizedState, c.updateQueue = a.updateQueue, b = a.dependencies, c.dependencies = b === null ? null : { lanes: b.lanes, firstContext: b.firstContext }, c.sibling = a.sibling, c.index = a.index, c.ref = a.ref, c;
    }
    function yh(a, b, c, d, e, f) {
      var g = 2;
      if (d = a, typeof a == "function")
        bj(a) && (g = 1);
      else if (typeof a == "string")
        g = 5;
      else
        a:
          switch (a) {
            case ya:
              return Ah(c.children, e, f, b);
            case za:
              g = 8, e |= 8;
              break;
            case Aa:
              return a = Bg(12, c, b, e | 2), a.elementType = Aa, a.lanes = f, a;
            case Ea:
              return a = Bg(13, c, b, e), a.elementType = Ea, a.lanes = f, a;
            case Fa:
              return a = Bg(19, c, b, e), a.elementType = Fa, a.lanes = f, a;
            case Ia:
              return qj(c, e, f, b);
            default:
              if (typeof a == "object" && a !== null)
                switch (a.$$typeof) {
                  case Ba:
                    g = 10;
                    break a;
                  case Ca:
                    g = 9;
                    break a;
                  case Da:
                    g = 11;
                    break a;
                  case Ga:
                    g = 14;
                    break a;
                  case Ha:
                    g = 16, d = null;
                    break a;
                }
              throw Error(p(130, a == null ? a : typeof a, ""));
          }
      return b = Bg(g, c, b, e), b.elementType = a, b.type = d, b.lanes = f, b;
    }
    function Ah(a, b, c, d) {
      return a = Bg(7, a, d, b), a.lanes = c, a;
    }
    function qj(a, b, c, d) {
      return a = Bg(22, a, d, b), a.elementType = Ia, a.lanes = c, a.stateNode = { isHidden: !1 }, a;
    }
    function xh(a, b, c) {
      return a = Bg(6, a, null, b), a.lanes = c, a;
    }
    function zh(a, b, c) {
      return b = Bg(4, a.children !== null ? a.children : [], a.key, b), b.lanes = c, b.stateNode = { containerInfo: a.containerInfo, pendingChildren: null, implementation: a.implementation }, b;
    }
    function bl(a, b, c, d, e) {
      this.tag = b, this.containerInfo = a, this.finishedWork = this.pingCache = this.current = this.pendingChildren = null, this.timeoutHandle = -1, this.callbackNode = this.pendingContext = this.context = null, this.callbackPriority = 0, this.eventTimes = zc(0), this.expirationTimes = zc(-1), this.entangledLanes = this.finishedLanes = this.mutableReadLanes = this.expiredLanes = this.pingedLanes = this.suspendedLanes = this.pendingLanes = 0, this.entanglements = zc(0), this.identifierPrefix = d, this.onRecoverableError = e, this.mutableSourceEagerHydrationData = null;
    }
    function cl(a, b, c, d, e, f, g, h, k) {
      return a = new bl(a, b, c, h, k), b === 1 ? (b = 1, f === !0 && (b |= 8)) : b = 0, f = Bg(3, null, null, b), a.current = f, f.stateNode = a, f.memoizedState = { element: d, isDehydrated: c, cache: null, transitions: null, pendingSuspenseBoundaries: null }, ah(f), a;
    }
    function dl(a, b, c) {
      var d = 3 < arguments.length && arguments[3] !== void 0 ? arguments[3] : null;
      return { $$typeof: wa, key: d == null ? null : "" + d, children: a, containerInfo: b, implementation: c };
    }
    function el(a) {
      if (!a)
        return Vf;
      a = a._reactInternals;
      a: {
        if (Vb(a) !== a || a.tag !== 1)
          throw Error(p(170));
        var b = a;
        do {
          switch (b.tag) {
            case 3:
              b = b.stateNode.context;
              break a;
            case 1:
              if (Zf(b.type)) {
                b = b.stateNode.__reactInternalMemoizedMergedChildContext;
                break a;
              }
          }
          b = b.return;
        } while (b !== null);
        throw Error(p(171));
      }
      if (a.tag === 1) {
        var c = a.type;
        if (Zf(c))
          return bg(a, c, b);
      }
      return b;
    }
    function fl(a, b, c, d, e, f, g, h, k) {
      return a = cl(c, d, !0, a, e, f, g, h, k), a.context = el(null), c = a.current, d = L(), e = lh(c), f = ch(d, e), f.callback = b ?? null, dh(c, f, e), a.current.lanes = e, Ac(a, e, d), Ek(a, d), a;
    }
    function gl(a, b, c, d) {
      var e = b.current, f = L(), g = lh(e);
      return c = el(c), b.context === null ? b.context = c : b.pendingContext = c, b = ch(f, g), b.payload = { element: a }, d = d === void 0 ? null : d, d !== null && (b.callback = d), a = dh(e, b, g), a !== null && (mh(a, e, g, f), eh(a, e, g)), g;
    }
    function hl(a) {
      if (a = a.current, !a.child)
        return null;
      switch (a.child.tag) {
        case 5:
          return a.child.stateNode;
        default:
          return a.child.stateNode;
      }
    }
    function il(a, b) {
      if (a = a.memoizedState, a !== null && a.dehydrated !== null) {
        var c = a.retryLane;
        a.retryLane = c !== 0 && c < b ? c : b;
      }
    }
    function jl(a, b) {
      il(a, b), (a = a.alternate) && il(a, b);
    }
    function kl() {
      return null;
    }
    var ll = typeof reportError == "function" ? reportError : function(a) {
      console.error(a);
    };
    function ml(a) {
      this._internalRoot = a;
    }
    nl.prototype.render = ml.prototype.render = function(a) {
      var b = this._internalRoot;
      if (b === null)
        throw Error(p(409));
      gl(a, b, null, null);
    };
    nl.prototype.unmount = ml.prototype.unmount = function() {
      var a = this._internalRoot;
      if (a !== null) {
        this._internalRoot = null;
        var b = a.containerInfo;
        Sk(function() {
          gl(null, a, null, null);
        }), b[uf] = null;
      }
    };
    function nl(a) {
      this._internalRoot = a;
    }
    nl.prototype.unstable_scheduleHydration = function(a) {
      if (a) {
        var b = Hc();
        a = { blockedOn: null, target: a, priority: b };
        for (var c = 0; c < Qc.length && b !== 0 && b < Qc[c].priority; c++)
          ;
        Qc.splice(c, 0, a), c === 0 && Vc(a);
      }
    };
    function ol(a) {
      return !(!a || a.nodeType !== 1 && a.nodeType !== 9 && a.nodeType !== 11);
    }
    function pl(a) {
      return !(!a || a.nodeType !== 1 && a.nodeType !== 9 && a.nodeType !== 11 && (a.nodeType !== 8 || a.nodeValue !== " react-mount-point-unstable "));
    }
    function ql() {
    }
    function rl(a, b, c, d, e) {
      if (e) {
        if (typeof d == "function") {
          var f = d;
          d = function() {
            var a2 = hl(g);
            f.call(a2);
          };
        }
        var g = fl(b, d, a, 0, null, !1, !1, "", ql);
        return a._reactRootContainer = g, a[uf] = g.current, sf(a.nodeType === 8 ? a.parentNode : a), Sk(), g;
      }
      for (; e = a.lastChild; )
        a.removeChild(e);
      if (typeof d == "function") {
        var h = d;
        d = function() {
          var a2 = hl(k);
          h.call(a2);
        };
      }
      var k = cl(a, 0, !1, null, null, !1, !1, "", ql);
      return a._reactRootContainer = k, a[uf] = k.current, sf(a.nodeType === 8 ? a.parentNode : a), Sk(function() {
        gl(b, k, c, d);
      }), k;
    }
    function sl(a, b, c, d, e) {
      var f = c._reactRootContainer;
      if (f) {
        var g = f;
        if (typeof e == "function") {
          var h = e;
          e = function() {
            var a2 = hl(g);
            h.call(a2);
          };
        }
        gl(b, g, a, e);
      } else
        g = rl(c, b, a, e, d);
      return hl(g);
    }
    Ec = function(a) {
      switch (a.tag) {
        case 3:
          var b = a.stateNode;
          if (b.current.memoizedState.isDehydrated) {
            var c = tc(b.pendingLanes);
            c !== 0 && (Cc(b, c | 1), Ek(b, B()), !(K & 6) && (Hj = B() + 500, jg()));
          }
          break;
        case 13:
          Sk(function() {
            var b2 = Zg(a, 1);
            if (b2 !== null) {
              var c2 = L();
              mh(b2, a, 1, c2);
            }
          }), jl(a, 1);
      }
    };
    Fc = function(a) {
      if (a.tag === 13) {
        var b = Zg(a, 134217728);
        if (b !== null) {
          var c = L();
          mh(b, a, 134217728, c);
        }
        jl(a, 134217728);
      }
    };
    Gc = function(a) {
      if (a.tag === 13) {
        var b = lh(a), c = Zg(a, b);
        if (c !== null) {
          var d = L();
          mh(c, a, b, d);
        }
        jl(a, b);
      }
    };
    Hc = function() {
      return C;
    };
    Ic = function(a, b) {
      var c = C;
      try {
        return C = a, b();
      } finally {
        C = c;
      }
    };
    yb = function(a, b, c) {
      switch (b) {
        case "input":
          if (bb(a, c), b = c.name, c.type === "radio" && b != null) {
            for (c = a; c.parentNode; )
              c = c.parentNode;
            for (c = c.querySelectorAll("input[name=" + JSON.stringify("" + b) + '][type="radio"]'), b = 0; b < c.length; b++) {
              var d = c[b];
              if (d !== a && d.form === a.form) {
                var e = Db(d);
                if (!e)
                  throw Error(p(90));
                Wa(d), bb(d, e);
              }
            }
          }
          break;
        case "textarea":
          ib(a, c);
          break;
        case "select":
          b = c.value, b != null && fb(a, !!c.multiple, b, !1);
      }
    };
    Gb = Rk;
    Hb = Sk;
    var tl = { usingClientEntryPoint: !1, Events: [Cb, ue, Db, Eb, Fb, Rk] }, ul = { findFiberByHostInstance: Wc, bundleType: 0, version: "18.2.0", rendererPackageName: "react-dom" }, vl = { bundleType: ul.bundleType, version: ul.version, rendererPackageName: ul.rendererPackageName, rendererConfig: ul.rendererConfig, overrideHookState: null, overrideHookStateDeletePath: null, overrideHookStateRenamePath: null, overrideProps: null, overridePropsDeletePath: null, overridePropsRenamePath: null, setErrorHandler: null, setSuspenseHandler: null, scheduleUpdate: null, currentDispatcherRef: ua.ReactCurrentDispatcher, findHostInstanceByFiber: function(a) {
      return a = Zb(a), a === null ? null : a.stateNode;
    }, findFiberByHostInstance: ul.findFiberByHostInstance || kl, findHostInstancesForRefresh: null, scheduleRefresh: null, scheduleRoot: null, setRefreshHandler: null, getCurrentFiber: null, reconcilerVersion: "18.2.0-next-9e3b772b8-20220608" };
    if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ < "u" && (wl = __REACT_DEVTOOLS_GLOBAL_HOOK__, !wl.isDisabled && wl.supportsFiber))
      try {
        kc = wl.inject(vl), lc = wl;
      } catch {
      }
    var wl;
    exports.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = tl;
    exports.createPortal = function(a, b) {
      var c = 2 < arguments.length && arguments[2] !== void 0 ? arguments[2] : null;
      if (!ol(b))
        throw Error(p(200));
      return dl(a, b, null, c);
    };
    exports.createRoot = function(a, b) {
      if (!ol(a))
        throw Error(p(299));
      var c = !1, d = "", e = ll;
      return b != null && (b.unstable_strictMode === !0 && (c = !0), b.identifierPrefix !== void 0 && (d = b.identifierPrefix), b.onRecoverableError !== void 0 && (e = b.onRecoverableError)), b = cl(a, 1, !1, null, null, c, !1, d, e), a[uf] = b.current, sf(a.nodeType === 8 ? a.parentNode : a), new ml(b);
    };
    exports.findDOMNode = function(a) {
      if (a == null)
        return null;
      if (a.nodeType === 1)
        return a;
      var b = a._reactInternals;
      if (b === void 0)
        throw typeof a.render == "function" ? Error(p(188)) : (a = Object.keys(a).join(","), Error(p(268, a)));
      return a = Zb(b), a = a === null ? null : a.stateNode, a;
    };
    exports.flushSync = function(a) {
      return Sk(a);
    };
    exports.hydrate = function(a, b, c) {
      if (!pl(b))
        throw Error(p(200));
      return sl(null, a, b, !0, c);
    };
    exports.hydrateRoot = function(a, b, c) {
      if (!ol(a))
        throw Error(p(405));
      var d = c != null && c.hydratedSources || null, e = !1, f = "", g = ll;
      if (c != null && (c.unstable_strictMode === !0 && (e = !0), c.identifierPrefix !== void 0 && (f = c.identifierPrefix), c.onRecoverableError !== void 0 && (g = c.onRecoverableError)), b = fl(b, null, a, 1, c ?? null, e, !1, f, g), a[uf] = b.current, sf(a), d)
        for (a = 0; a < d.length; a++)
          c = d[a], e = c._getVersion, e = e(c._source), b.mutableSourceEagerHydrationData == null ? b.mutableSourceEagerHydrationData = [c, e] : b.mutableSourceEagerHydrationData.push(
            c,
            e
          );
      return new nl(b);
    };
    exports.render = function(a, b, c) {
      if (!pl(b))
        throw Error(p(200));
      return sl(null, a, b, !1, c);
    };
    exports.unmountComponentAtNode = function(a) {
      if (!pl(a))
        throw Error(p(40));
      return a._reactRootContainer ? (Sk(function() {
        sl(null, null, a, !1, function() {
          a._reactRootContainer = null, a[uf] = null;
        });
      }), !0) : !1;
    };
    exports.unstable_batchedUpdates = Rk;
    exports.unstable_renderSubtreeIntoContainer = function(a, b, c, d) {
      if (!pl(c))
        throw Error(p(200));
      if (a == null || a._reactInternals === void 0)
        throw Error(p(38));
      return sl(a, b, c, !1, d);
    };
    exports.version = "18.2.0-next-9e3b772b8-20220608";
  }
});

// ../../node_modules/.pnpm/react-dom@18.2.0_react@18.2.0/node_modules/react-dom/cjs/react-dom.development.js
var require_react_dom_development = __commonJS({
  "../../node_modules/.pnpm/react-dom@18.2.0_react@18.2.0/node_modules/react-dom/cjs/react-dom.development.js"(exports) {
    "use strict";
    init_cjs_shims();
    process.env.NODE_ENV !== "production" && function() {
      "use strict";
      typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ < "u" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart == "function" && __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStart(new Error());
      var React12 = require_react(), Scheduler = require_scheduler(), ReactSharedInternals = React12.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED, suppressWarning = !1;
      function setSuppressWarning(newSuppressWarning) {
        suppressWarning = newSuppressWarning;
      }
      function warn(format4) {
        if (!suppressWarning) {
          for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++)
            args[_key - 1] = arguments[_key];
          printWarning("warn", format4, args);
        }
      }
      function error(format4) {
        if (!suppressWarning) {
          for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++)
            args[_key2 - 1] = arguments[_key2];
          printWarning("error", format4, args);
        }
      }
      function printWarning(level, format4, args) {
        {
          var ReactDebugCurrentFrame2 = ReactSharedInternals.ReactDebugCurrentFrame, stack = ReactDebugCurrentFrame2.getStackAddendum();
          stack !== "" && (format4 += "%s", args = args.concat([stack]));
          var argsWithFormat = args.map(function(item) {
            return String(item);
          });
          argsWithFormat.unshift("Warning: " + format4), Function.prototype.apply.call(console[level], console, argsWithFormat);
        }
      }
      var FunctionComponent = 0, ClassComponent = 1, IndeterminateComponent = 2, HostRoot = 3, HostPortal = 4, HostComponent = 5, HostText = 6, Fragment = 7, Mode = 8, ContextConsumer = 9, ContextProvider = 10, ForwardRef = 11, Profiler = 12, SuspenseComponent = 13, MemoComponent = 14, SimpleMemoComponent = 15, LazyComponent = 16, IncompleteClassComponent = 17, DehydratedFragment = 18, SuspenseListComponent = 19, ScopeComponent = 21, OffscreenComponent = 22, LegacyHiddenComponent = 23, CacheComponent = 24, TracingMarkerComponent = 25, enableClientRenderFallbackOnTextMismatch = !0, enableNewReconciler = !1, enableLazyContextPropagation = !1, enableLegacyHidden = !1, enableSuspenseAvoidThisFallback = !1, disableCommentsAsDOMContainers = !0, enableCustomElementPropertySupport = !1, warnAboutStringRefs = !1, enableSchedulingProfiler = !0, enableProfilerTimer = !0, enableProfilerCommitHooks = !0, allNativeEvents = /* @__PURE__ */ new Set(), registrationNameDependencies = {}, possibleRegistrationNames = {};
      function registerTwoPhaseEvent(registrationName, dependencies) {
        registerDirectEvent(registrationName, dependencies), registerDirectEvent(registrationName + "Capture", dependencies);
      }
      function registerDirectEvent(registrationName, dependencies) {
        registrationNameDependencies[registrationName] && error("EventRegistry: More than one plugin attempted to publish the same registration name, `%s`.", registrationName), registrationNameDependencies[registrationName] = dependencies;
        {
          var lowerCasedName = registrationName.toLowerCase();
          possibleRegistrationNames[lowerCasedName] = registrationName, registrationName === "onDoubleClick" && (possibleRegistrationNames.ondblclick = registrationName);
        }
        for (var i = 0; i < dependencies.length; i++)
          allNativeEvents.add(dependencies[i]);
      }
      var canUseDOM = typeof window < "u" && typeof window.document < "u" && typeof window.document.createElement < "u", hasOwnProperty = Object.prototype.hasOwnProperty;
      function typeName(value) {
        {
          var hasToStringTag = typeof Symbol == "function" && Symbol.toStringTag, type = hasToStringTag && value[Symbol.toStringTag] || value.constructor.name || "Object";
          return type;
        }
      }
      function willCoercionThrow(value) {
        try {
          return testStringCoercion(value), !1;
        } catch {
          return !0;
        }
      }
      function testStringCoercion(value) {
        return "" + value;
      }
      function checkAttributeStringCoercion(value, attributeName) {
        if (willCoercionThrow(value))
          return error("The provided `%s` attribute is an unsupported type %s. This value must be coerced to a string before before using it here.", attributeName, typeName(value)), testStringCoercion(value);
      }
      function checkKeyStringCoercion(value) {
        if (willCoercionThrow(value))
          return error("The provided key is an unsupported type %s. This value must be coerced to a string before before using it here.", typeName(value)), testStringCoercion(value);
      }
      function checkPropStringCoercion(value, propName) {
        if (willCoercionThrow(value))
          return error("The provided `%s` prop is an unsupported type %s. This value must be coerced to a string before before using it here.", propName, typeName(value)), testStringCoercion(value);
      }
      function checkCSSPropertyStringCoercion(value, propName) {
        if (willCoercionThrow(value))
          return error("The provided `%s` CSS property is an unsupported type %s. This value must be coerced to a string before before using it here.", propName, typeName(value)), testStringCoercion(value);
      }
      function checkHtmlStringCoercion(value) {
        if (willCoercionThrow(value))
          return error("The provided HTML markup uses a value of unsupported type %s. This value must be coerced to a string before before using it here.", typeName(value)), testStringCoercion(value);
      }
      function checkFormFieldValueStringCoercion(value) {
        if (willCoercionThrow(value))
          return error("Form field values (value, checked, defaultValue, or defaultChecked props) must be strings, not %s. This value must be coerced to a string before before using it here.", typeName(value)), testStringCoercion(value);
      }
      var RESERVED = 0, STRING = 1, BOOLEANISH_STRING = 2, BOOLEAN = 3, OVERLOADED_BOOLEAN = 4, NUMERIC = 5, POSITIVE_NUMERIC = 6, ATTRIBUTE_NAME_START_CHAR = ":A-Z_a-z\\u00C0-\\u00D6\\u00D8-\\u00F6\\u00F8-\\u02FF\\u0370-\\u037D\\u037F-\\u1FFF\\u200C-\\u200D\\u2070-\\u218F\\u2C00-\\u2FEF\\u3001-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFFD", ATTRIBUTE_NAME_CHAR = ATTRIBUTE_NAME_START_CHAR + "\\-.0-9\\u00B7\\u0300-\\u036F\\u203F-\\u2040", VALID_ATTRIBUTE_NAME_REGEX = new RegExp("^[" + ATTRIBUTE_NAME_START_CHAR + "][" + ATTRIBUTE_NAME_CHAR + "]*$"), illegalAttributeNameCache = {}, validatedAttributeNameCache = {};
      function isAttributeNameSafe(attributeName) {
        return hasOwnProperty.call(validatedAttributeNameCache, attributeName) ? !0 : hasOwnProperty.call(illegalAttributeNameCache, attributeName) ? !1 : VALID_ATTRIBUTE_NAME_REGEX.test(attributeName) ? (validatedAttributeNameCache[attributeName] = !0, !0) : (illegalAttributeNameCache[attributeName] = !0, error("Invalid attribute name: `%s`", attributeName), !1);
      }
      function shouldIgnoreAttribute(name, propertyInfo, isCustomComponentTag) {
        return propertyInfo !== null ? propertyInfo.type === RESERVED : isCustomComponentTag ? !1 : name.length > 2 && (name[0] === "o" || name[0] === "O") && (name[1] === "n" || name[1] === "N");
      }
      function shouldRemoveAttributeWithWarning(name, value, propertyInfo, isCustomComponentTag) {
        if (propertyInfo !== null && propertyInfo.type === RESERVED)
          return !1;
        switch (typeof value) {
          case "function":
          case "symbol":
            return !0;
          case "boolean": {
            if (isCustomComponentTag)
              return !1;
            if (propertyInfo !== null)
              return !propertyInfo.acceptsBooleans;
            var prefix2 = name.toLowerCase().slice(0, 5);
            return prefix2 !== "data-" && prefix2 !== "aria-";
          }
          default:
            return !1;
        }
      }
      function shouldRemoveAttribute(name, value, propertyInfo, isCustomComponentTag) {
        if (value === null || typeof value > "u" || shouldRemoveAttributeWithWarning(name, value, propertyInfo, isCustomComponentTag))
          return !0;
        if (isCustomComponentTag)
          return !1;
        if (propertyInfo !== null)
          switch (propertyInfo.type) {
            case BOOLEAN:
              return !value;
            case OVERLOADED_BOOLEAN:
              return value === !1;
            case NUMERIC:
              return isNaN(value);
            case POSITIVE_NUMERIC:
              return isNaN(value) || value < 1;
          }
        return !1;
      }
      function getPropertyInfo(name) {
        return properties.hasOwnProperty(name) ? properties[name] : null;
      }
      function PropertyInfoRecord(name, type, mustUseProperty, attributeName, attributeNamespace, sanitizeURL2, removeEmptyString) {
        this.acceptsBooleans = type === BOOLEANISH_STRING || type === BOOLEAN || type === OVERLOADED_BOOLEAN, this.attributeName = attributeName, this.attributeNamespace = attributeNamespace, this.mustUseProperty = mustUseProperty, this.propertyName = name, this.type = type, this.sanitizeURL = sanitizeURL2, this.removeEmptyString = removeEmptyString;
      }
      var properties = {}, reservedProps = [
        "children",
        "dangerouslySetInnerHTML",
        // TODO: This prevents the assignment of defaultValue to regular
        // elements (not just inputs). Now that ReactDOMInput assigns to the
        // defaultValue property -- do we need this?
        "defaultValue",
        "defaultChecked",
        "innerHTML",
        "suppressContentEditableWarning",
        "suppressHydrationWarning",
        "style"
      ];
      reservedProps.forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          RESERVED,
          !1,
          // mustUseProperty
          name,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [["acceptCharset", "accept-charset"], ["className", "class"], ["htmlFor", "for"], ["httpEquiv", "http-equiv"]].forEach(function(_ref) {
        var name = _ref[0], attributeName = _ref[1];
        properties[name] = new PropertyInfoRecord(
          name,
          STRING,
          !1,
          // mustUseProperty
          attributeName,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), ["contentEditable", "draggable", "spellCheck", "value"].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          BOOLEANISH_STRING,
          !1,
          // mustUseProperty
          name.toLowerCase(),
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), ["autoReverse", "externalResourcesRequired", "focusable", "preserveAlpha"].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          BOOLEANISH_STRING,
          !1,
          // mustUseProperty
          name,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "allowFullScreen",
        "async",
        // Note: there is a special case that prevents it from being written to the DOM
        // on the client side because the browsers are inconsistent. Instead we call focus().
        "autoFocus",
        "autoPlay",
        "controls",
        "default",
        "defer",
        "disabled",
        "disablePictureInPicture",
        "disableRemotePlayback",
        "formNoValidate",
        "hidden",
        "loop",
        "noModule",
        "noValidate",
        "open",
        "playsInline",
        "readOnly",
        "required",
        "reversed",
        "scoped",
        "seamless",
        // Microdata
        "itemScope"
      ].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          BOOLEAN,
          !1,
          // mustUseProperty
          name.toLowerCase(),
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "checked",
        // Note: `option.selected` is not updated if `select.multiple` is
        // disabled with `removeAttribute`. We have special logic for handling this.
        "multiple",
        "muted",
        "selected"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          BOOLEAN,
          !0,
          // mustUseProperty
          name,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "capture",
        "download"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          OVERLOADED_BOOLEAN,
          !1,
          // mustUseProperty
          name,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "cols",
        "rows",
        "size",
        "span"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          POSITIVE_NUMERIC,
          !1,
          // mustUseProperty
          name,
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), ["rowSpan", "start"].forEach(function(name) {
        properties[name] = new PropertyInfoRecord(
          name,
          NUMERIC,
          !1,
          // mustUseProperty
          name.toLowerCase(),
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      });
      var CAMELIZE = /[\-\:]([a-z])/g, capitalize2 = function(token) {
        return token[1].toUpperCase();
      };
      [
        "accent-height",
        "alignment-baseline",
        "arabic-form",
        "baseline-shift",
        "cap-height",
        "clip-path",
        "clip-rule",
        "color-interpolation",
        "color-interpolation-filters",
        "color-profile",
        "color-rendering",
        "dominant-baseline",
        "enable-background",
        "fill-opacity",
        "fill-rule",
        "flood-color",
        "flood-opacity",
        "font-family",
        "font-size",
        "font-size-adjust",
        "font-stretch",
        "font-style",
        "font-variant",
        "font-weight",
        "glyph-name",
        "glyph-orientation-horizontal",
        "glyph-orientation-vertical",
        "horiz-adv-x",
        "horiz-origin-x",
        "image-rendering",
        "letter-spacing",
        "lighting-color",
        "marker-end",
        "marker-mid",
        "marker-start",
        "overline-position",
        "overline-thickness",
        "paint-order",
        "panose-1",
        "pointer-events",
        "rendering-intent",
        "shape-rendering",
        "stop-color",
        "stop-opacity",
        "strikethrough-position",
        "strikethrough-thickness",
        "stroke-dasharray",
        "stroke-dashoffset",
        "stroke-linecap",
        "stroke-linejoin",
        "stroke-miterlimit",
        "stroke-opacity",
        "stroke-width",
        "text-anchor",
        "text-decoration",
        "text-rendering",
        "underline-position",
        "underline-thickness",
        "unicode-bidi",
        "unicode-range",
        "units-per-em",
        "v-alphabetic",
        "v-hanging",
        "v-ideographic",
        "v-mathematical",
        "vector-effect",
        "vert-adv-y",
        "vert-origin-x",
        "vert-origin-y",
        "word-spacing",
        "writing-mode",
        "xmlns:xlink",
        "x-height"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(attributeName) {
        var name = attributeName.replace(CAMELIZE, capitalize2);
        properties[name] = new PropertyInfoRecord(
          name,
          STRING,
          !1,
          // mustUseProperty
          attributeName,
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "xlink:actuate",
        "xlink:arcrole",
        "xlink:role",
        "xlink:show",
        "xlink:title",
        "xlink:type"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(attributeName) {
        var name = attributeName.replace(CAMELIZE, capitalize2);
        properties[name] = new PropertyInfoRecord(
          name,
          STRING,
          !1,
          // mustUseProperty
          attributeName,
          "http://www.w3.org/1999/xlink",
          !1,
          // sanitizeURL
          !1
        );
      }), [
        "xml:base",
        "xml:lang",
        "xml:space"
        // NOTE: if you add a camelCased prop to this list,
        // you'll need to set attributeName to name.toLowerCase()
        // instead in the assignment below.
      ].forEach(function(attributeName) {
        var name = attributeName.replace(CAMELIZE, capitalize2);
        properties[name] = new PropertyInfoRecord(
          name,
          STRING,
          !1,
          // mustUseProperty
          attributeName,
          "http://www.w3.org/XML/1998/namespace",
          !1,
          // sanitizeURL
          !1
        );
      }), ["tabIndex", "crossOrigin"].forEach(function(attributeName) {
        properties[attributeName] = new PropertyInfoRecord(
          attributeName,
          STRING,
          !1,
          // mustUseProperty
          attributeName.toLowerCase(),
          // attributeName
          null,
          // attributeNamespace
          !1,
          // sanitizeURL
          !1
        );
      });
      var xlinkHref = "xlinkHref";
      properties[xlinkHref] = new PropertyInfoRecord(
        "xlinkHref",
        STRING,
        !1,
        // mustUseProperty
        "xlink:href",
        "http://www.w3.org/1999/xlink",
        !0,
        // sanitizeURL
        !1
      ), ["src", "href", "action", "formAction"].forEach(function(attributeName) {
        properties[attributeName] = new PropertyInfoRecord(
          attributeName,
          STRING,
          !1,
          // mustUseProperty
          attributeName.toLowerCase(),
          // attributeName
          null,
          // attributeNamespace
          !0,
          // sanitizeURL
          !0
        );
      });
      var isJavaScriptProtocol = /^[\u0000-\u001F ]*j[\r\n\t]*a[\r\n\t]*v[\r\n\t]*a[\r\n\t]*s[\r\n\t]*c[\r\n\t]*r[\r\n\t]*i[\r\n\t]*p[\r\n\t]*t[\r\n\t]*\:/i, didWarn = !1;
      function sanitizeURL(url) {
        !didWarn && isJavaScriptProtocol.test(url) && (didWarn = !0, error("A future version of React will block javascript: URLs as a security precaution. Use event handlers instead if you can. If you need to generate unsafe HTML try using dangerouslySetInnerHTML instead. React was passed %s.", JSON.stringify(url)));
      }
      function getValueForProperty(node, name, expected, propertyInfo) {
        if (propertyInfo.mustUseProperty) {
          var propertyName = propertyInfo.propertyName;
          return node[propertyName];
        } else {
          checkAttributeStringCoercion(expected, name), propertyInfo.sanitizeURL && sanitizeURL("" + expected);
          var attributeName = propertyInfo.attributeName, stringValue = null;
          if (propertyInfo.type === OVERLOADED_BOOLEAN) {
            if (node.hasAttribute(attributeName)) {
              var value = node.getAttribute(attributeName);
              return value === "" ? !0 : shouldRemoveAttribute(name, expected, propertyInfo, !1) ? value : value === "" + expected ? expected : value;
            }
          } else if (node.hasAttribute(attributeName)) {
            if (shouldRemoveAttribute(name, expected, propertyInfo, !1))
              return node.getAttribute(attributeName);
            if (propertyInfo.type === BOOLEAN)
              return expected;
            stringValue = node.getAttribute(attributeName);
          }
          return shouldRemoveAttribute(name, expected, propertyInfo, !1) ? stringValue === null ? expected : stringValue : stringValue === "" + expected ? expected : stringValue;
        }
      }
      function getValueForAttribute(node, name, expected, isCustomComponentTag) {
        {
          if (!isAttributeNameSafe(name))
            return;
          if (!node.hasAttribute(name))
            return expected === void 0 ? void 0 : null;
          var value = node.getAttribute(name);
          return checkAttributeStringCoercion(expected, name), value === "" + expected ? expected : value;
        }
      }
      function setValueForProperty(node, name, value, isCustomComponentTag) {
        var propertyInfo = getPropertyInfo(name);
        if (!shouldIgnoreAttribute(name, propertyInfo, isCustomComponentTag)) {
          if (shouldRemoveAttribute(name, value, propertyInfo, isCustomComponentTag) && (value = null), isCustomComponentTag || propertyInfo === null) {
            if (isAttributeNameSafe(name)) {
              var _attributeName = name;
              value === null ? node.removeAttribute(_attributeName) : (checkAttributeStringCoercion(value, name), node.setAttribute(_attributeName, "" + value));
            }
            return;
          }
          var mustUseProperty = propertyInfo.mustUseProperty;
          if (mustUseProperty) {
            var propertyName = propertyInfo.propertyName;
            if (value === null) {
              var type = propertyInfo.type;
              node[propertyName] = type === BOOLEAN ? !1 : "";
            } else
              node[propertyName] = value;
            return;
          }
          var attributeName = propertyInfo.attributeName, attributeNamespace = propertyInfo.attributeNamespace;
          if (value === null)
            node.removeAttribute(attributeName);
          else {
            var _type = propertyInfo.type, attributeValue;
            _type === BOOLEAN || _type === OVERLOADED_BOOLEAN && value === !0 ? attributeValue = "" : (checkAttributeStringCoercion(value, attributeName), attributeValue = "" + value, propertyInfo.sanitizeURL && sanitizeURL(attributeValue.toString())), attributeNamespace ? node.setAttributeNS(attributeNamespace, attributeName, attributeValue) : node.setAttribute(attributeName, attributeValue);
          }
        }
      }
      var REACT_ELEMENT_TYPE = Symbol.for("react.element"), REACT_PORTAL_TYPE = Symbol.for("react.portal"), REACT_FRAGMENT_TYPE = Symbol.for("react.fragment"), REACT_STRICT_MODE_TYPE = Symbol.for("react.strict_mode"), REACT_PROFILER_TYPE = Symbol.for("react.profiler"), REACT_PROVIDER_TYPE = Symbol.for("react.provider"), REACT_CONTEXT_TYPE = Symbol.for("react.context"), REACT_FORWARD_REF_TYPE = Symbol.for("react.forward_ref"), REACT_SUSPENSE_TYPE = Symbol.for("react.suspense"), REACT_SUSPENSE_LIST_TYPE = Symbol.for("react.suspense_list"), REACT_MEMO_TYPE = Symbol.for("react.memo"), REACT_LAZY_TYPE = Symbol.for("react.lazy"), REACT_SCOPE_TYPE = Symbol.for("react.scope"), REACT_DEBUG_TRACING_MODE_TYPE = Symbol.for("react.debug_trace_mode"), REACT_OFFSCREEN_TYPE = Symbol.for("react.offscreen"), REACT_LEGACY_HIDDEN_TYPE = Symbol.for("react.legacy_hidden"), REACT_CACHE_TYPE = Symbol.for("react.cache"), REACT_TRACING_MARKER_TYPE = Symbol.for("react.tracing_marker"), MAYBE_ITERATOR_SYMBOL = Symbol.iterator, FAUX_ITERATOR_SYMBOL = "@@iterator";
      function getIteratorFn(maybeIterable) {
        if (maybeIterable === null || typeof maybeIterable != "object")
          return null;
        var maybeIterator = MAYBE_ITERATOR_SYMBOL && maybeIterable[MAYBE_ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL];
        return typeof maybeIterator == "function" ? maybeIterator : null;
      }
      var assign = Object.assign, disabledDepth = 0, prevLog, prevInfo, prevWarn, prevError, prevGroup, prevGroupCollapsed, prevGroupEnd;
      function disabledLog() {
      }
      disabledLog.__reactDisabledLog = !0;
      function disableLogs() {
        {
          if (disabledDepth === 0) {
            prevLog = console.log, prevInfo = console.info, prevWarn = console.warn, prevError = console.error, prevGroup = console.group, prevGroupCollapsed = console.groupCollapsed, prevGroupEnd = console.groupEnd;
            var props = {
              configurable: !0,
              enumerable: !0,
              value: disabledLog,
              writable: !0
            };
            Object.defineProperties(console, {
              info: props,
              log: props,
              warn: props,
              error: props,
              group: props,
              groupCollapsed: props,
              groupEnd: props
            });
          }
          disabledDepth++;
        }
      }
      function reenableLogs() {
        {
          if (disabledDepth--, disabledDepth === 0) {
            var props = {
              configurable: !0,
              enumerable: !0,
              writable: !0
            };
            Object.defineProperties(console, {
              log: assign({}, props, {
                value: prevLog
              }),
              info: assign({}, props, {
                value: prevInfo
              }),
              warn: assign({}, props, {
                value: prevWarn
              }),
              error: assign({}, props, {
                value: prevError
              }),
              group: assign({}, props, {
                value: prevGroup
              }),
              groupCollapsed: assign({}, props, {
                value: prevGroupCollapsed
              }),
              groupEnd: assign({}, props, {
                value: prevGroupEnd
              })
            });
          }
          disabledDepth < 0 && error("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
        }
      }
      var ReactCurrentDispatcher = ReactSharedInternals.ReactCurrentDispatcher, prefix;
      function describeBuiltInComponentFrame(name, source, ownerFn) {
        {
          if (prefix === void 0)
            try {
              throw Error();
            } catch (x) {
              var match2 = x.stack.trim().match(/\n( *(at )?)/);
              prefix = match2 && match2[1] || "";
            }
          return `
` + prefix + name;
        }
      }
      var reentry = !1, componentFrameCache;
      {
        var PossiblyWeakMap = typeof WeakMap == "function" ? WeakMap : Map;
        componentFrameCache = new PossiblyWeakMap();
      }
      function describeNativeComponentFrame(fn, construct) {
        if (!fn || reentry)
          return "";
        {
          var frame = componentFrameCache.get(fn);
          if (frame !== void 0)
            return frame;
        }
        var control;
        reentry = !0;
        var previousPrepareStackTrace = Error.prepareStackTrace;
        Error.prepareStackTrace = void 0;
        var previousDispatcher;
        previousDispatcher = ReactCurrentDispatcher.current, ReactCurrentDispatcher.current = null, disableLogs();
        try {
          if (construct) {
            var Fake = function() {
              throw Error();
            };
            if (Object.defineProperty(Fake.prototype, "props", {
              set: function() {
                throw Error();
              }
            }), typeof Reflect == "object" && Reflect.construct) {
              try {
                Reflect.construct(Fake, []);
              } catch (x) {
                control = x;
              }
              Reflect.construct(fn, [], Fake);
            } else {
              try {
                Fake.call();
              } catch (x) {
                control = x;
              }
              fn.call(Fake.prototype);
            }
          } else {
            try {
              throw Error();
            } catch (x) {
              control = x;
            }
            fn();
          }
        } catch (sample) {
          if (sample && control && typeof sample.stack == "string") {
            for (var sampleLines = sample.stack.split(`
`), controlLines = control.stack.split(`
`), s = sampleLines.length - 1, c = controlLines.length - 1; s >= 1 && c >= 0 && sampleLines[s] !== controlLines[c]; )
              c--;
            for (; s >= 1 && c >= 0; s--, c--)
              if (sampleLines[s] !== controlLines[c]) {
                if (s !== 1 || c !== 1)
                  do
                    if (s--, c--, c < 0 || sampleLines[s] !== controlLines[c]) {
                      var _frame = `
` + sampleLines[s].replace(" at new ", " at ");
                      return fn.displayName && _frame.includes("<anonymous>") && (_frame = _frame.replace("<anonymous>", fn.displayName)), typeof fn == "function" && componentFrameCache.set(fn, _frame), _frame;
                    }
                  while (s >= 1 && c >= 0);
                break;
              }
          }
        } finally {
          reentry = !1, ReactCurrentDispatcher.current = previousDispatcher, reenableLogs(), Error.prepareStackTrace = previousPrepareStackTrace;
        }
        var name = fn ? fn.displayName || fn.name : "", syntheticFrame = name ? describeBuiltInComponentFrame(name) : "";
        return typeof fn == "function" && componentFrameCache.set(fn, syntheticFrame), syntheticFrame;
      }
      function describeClassComponentFrame(ctor, source, ownerFn) {
        return describeNativeComponentFrame(ctor, !0);
      }
      function describeFunctionComponentFrame(fn, source, ownerFn) {
        return describeNativeComponentFrame(fn, !1);
      }
      function shouldConstruct(Component) {
        var prototype = Component.prototype;
        return !!(prototype && prototype.isReactComponent);
      }
      function describeUnknownElementTypeFrameInDEV(type, source, ownerFn) {
        if (type == null)
          return "";
        if (typeof type == "function")
          return describeNativeComponentFrame(type, shouldConstruct(type));
        if (typeof type == "string")
          return describeBuiltInComponentFrame(type);
        switch (type) {
          case REACT_SUSPENSE_TYPE:
            return describeBuiltInComponentFrame("Suspense");
          case REACT_SUSPENSE_LIST_TYPE:
            return describeBuiltInComponentFrame("SuspenseList");
        }
        if (typeof type == "object")
          switch (type.$$typeof) {
            case REACT_FORWARD_REF_TYPE:
              return describeFunctionComponentFrame(type.render);
            case REACT_MEMO_TYPE:
              return describeUnknownElementTypeFrameInDEV(type.type, source, ownerFn);
            case REACT_LAZY_TYPE: {
              var lazyComponent = type, payload = lazyComponent._payload, init4 = lazyComponent._init;
              try {
                return describeUnknownElementTypeFrameInDEV(init4(payload), source, ownerFn);
              } catch {
              }
            }
          }
        return "";
      }
      function describeFiber(fiber) {
        var owner = fiber._debugOwner ? fiber._debugOwner.type : null, source = fiber._debugSource;
        switch (fiber.tag) {
          case HostComponent:
            return describeBuiltInComponentFrame(fiber.type);
          case LazyComponent:
            return describeBuiltInComponentFrame("Lazy");
          case SuspenseComponent:
            return describeBuiltInComponentFrame("Suspense");
          case SuspenseListComponent:
            return describeBuiltInComponentFrame("SuspenseList");
          case FunctionComponent:
          case IndeterminateComponent:
          case SimpleMemoComponent:
            return describeFunctionComponentFrame(fiber.type);
          case ForwardRef:
            return describeFunctionComponentFrame(fiber.type.render);
          case ClassComponent:
            return describeClassComponentFrame(fiber.type);
          default:
            return "";
        }
      }
      function getStackByFiberInDevAndProd(workInProgress2) {
        try {
          var info2 = "", node = workInProgress2;
          do
            info2 += describeFiber(node), node = node.return;
          while (node);
          return info2;
        } catch (x) {
          return `
Error generating stack: ` + x.message + `
` + x.stack;
        }
      }
      function getWrappedName(outerType, innerType, wrapperName) {
        var displayName = outerType.displayName;
        if (displayName)
          return displayName;
        var functionName = innerType.displayName || innerType.name || "";
        return functionName !== "" ? wrapperName + "(" + functionName + ")" : wrapperName;
      }
      function getContextName(type) {
        return type.displayName || "Context";
      }
      function getComponentNameFromType(type) {
        if (type == null)
          return null;
        if (typeof type.tag == "number" && error("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue."), typeof type == "function")
          return type.displayName || type.name || null;
        if (typeof type == "string")
          return type;
        switch (type) {
          case REACT_FRAGMENT_TYPE:
            return "Fragment";
          case REACT_PORTAL_TYPE:
            return "Portal";
          case REACT_PROFILER_TYPE:
            return "Profiler";
          case REACT_STRICT_MODE_TYPE:
            return "StrictMode";
          case REACT_SUSPENSE_TYPE:
            return "Suspense";
          case REACT_SUSPENSE_LIST_TYPE:
            return "SuspenseList";
        }
        if (typeof type == "object")
          switch (type.$$typeof) {
            case REACT_CONTEXT_TYPE:
              var context = type;
              return getContextName(context) + ".Consumer";
            case REACT_PROVIDER_TYPE:
              var provider = type;
              return getContextName(provider._context) + ".Provider";
            case REACT_FORWARD_REF_TYPE:
              return getWrappedName(type, type.render, "ForwardRef");
            case REACT_MEMO_TYPE:
              var outerName = type.displayName || null;
              return outerName !== null ? outerName : getComponentNameFromType(type.type) || "Memo";
            case REACT_LAZY_TYPE: {
              var lazyComponent = type, payload = lazyComponent._payload, init4 = lazyComponent._init;
              try {
                return getComponentNameFromType(init4(payload));
              } catch {
                return null;
              }
            }
          }
        return null;
      }
      function getWrappedName$1(outerType, innerType, wrapperName) {
        var functionName = innerType.displayName || innerType.name || "";
        return outerType.displayName || (functionName !== "" ? wrapperName + "(" + functionName + ")" : wrapperName);
      }
      function getContextName$1(type) {
        return type.displayName || "Context";
      }
      function getComponentNameFromFiber(fiber) {
        var tag = fiber.tag, type = fiber.type;
        switch (tag) {
          case CacheComponent:
            return "Cache";
          case ContextConsumer:
            var context = type;
            return getContextName$1(context) + ".Consumer";
          case ContextProvider:
            var provider = type;
            return getContextName$1(provider._context) + ".Provider";
          case DehydratedFragment:
            return "DehydratedFragment";
          case ForwardRef:
            return getWrappedName$1(type, type.render, "ForwardRef");
          case Fragment:
            return "Fragment";
          case HostComponent:
            return type;
          case HostPortal:
            return "Portal";
          case HostRoot:
            return "Root";
          case HostText:
            return "Text";
          case LazyComponent:
            return getComponentNameFromType(type);
          case Mode:
            return type === REACT_STRICT_MODE_TYPE ? "StrictMode" : "Mode";
          case OffscreenComponent:
            return "Offscreen";
          case Profiler:
            return "Profiler";
          case ScopeComponent:
            return "Scope";
          case SuspenseComponent:
            return "Suspense";
          case SuspenseListComponent:
            return "SuspenseList";
          case TracingMarkerComponent:
            return "TracingMarker";
          case ClassComponent:
          case FunctionComponent:
          case IncompleteClassComponent:
          case IndeterminateComponent:
          case MemoComponent:
          case SimpleMemoComponent:
            if (typeof type == "function")
              return type.displayName || type.name || null;
            if (typeof type == "string")
              return type;
            break;
        }
        return null;
      }
      var ReactDebugCurrentFrame = ReactSharedInternals.ReactDebugCurrentFrame, current = null, isRendering = !1;
      function getCurrentFiberOwnerNameInDevOrNull() {
        {
          if (current === null)
            return null;
          var owner = current._debugOwner;
          if (owner !== null && typeof owner < "u")
            return getComponentNameFromFiber(owner);
        }
        return null;
      }
      function getCurrentFiberStackInDev() {
        return current === null ? "" : getStackByFiberInDevAndProd(current);
      }
      function resetCurrentFiber() {
        ReactDebugCurrentFrame.getCurrentStack = null, current = null, isRendering = !1;
      }
      function setCurrentFiber(fiber) {
        ReactDebugCurrentFrame.getCurrentStack = fiber === null ? null : getCurrentFiberStackInDev, current = fiber, isRendering = !1;
      }
      function getCurrentFiber() {
        return current;
      }
      function setIsRendering(rendering) {
        isRendering = rendering;
      }
      function toString2(value) {
        return "" + value;
      }
      function getToStringValue(value) {
        switch (typeof value) {
          case "boolean":
          case "number":
          case "string":
          case "undefined":
            return value;
          case "object":
            return checkFormFieldValueStringCoercion(value), value;
          default:
            return "";
        }
      }
      var hasReadOnlyValue = {
        button: !0,
        checkbox: !0,
        image: !0,
        hidden: !0,
        radio: !0,
        reset: !0,
        submit: !0
      };
      function checkControlledValueProps(tagName, props) {
        hasReadOnlyValue[props.type] || props.onChange || props.onInput || props.readOnly || props.disabled || props.value == null || error("You provided a `value` prop to a form field without an `onChange` handler. This will render a read-only field. If the field should be mutable use `defaultValue`. Otherwise, set either `onChange` or `readOnly`."), props.onChange || props.readOnly || props.disabled || props.checked == null || error("You provided a `checked` prop to a form field without an `onChange` handler. This will render a read-only field. If the field should be mutable use `defaultChecked`. Otherwise, set either `onChange` or `readOnly`.");
      }
      function isCheckable(elem) {
        var type = elem.type, nodeName = elem.nodeName;
        return nodeName && nodeName.toLowerCase() === "input" && (type === "checkbox" || type === "radio");
      }
      function getTracker(node) {
        return node._valueTracker;
      }
      function detachTracker(node) {
        node._valueTracker = null;
      }
      function getValueFromNode(node) {
        var value = "";
        return node && (isCheckable(node) ? value = node.checked ? "true" : "false" : value = node.value), value;
      }
      function trackValueOnNode(node) {
        var valueField = isCheckable(node) ? "checked" : "value", descriptor = Object.getOwnPropertyDescriptor(node.constructor.prototype, valueField);
        checkFormFieldValueStringCoercion(node[valueField]);
        var currentValue = "" + node[valueField];
        if (!(node.hasOwnProperty(valueField) || typeof descriptor > "u" || typeof descriptor.get != "function" || typeof descriptor.set != "function")) {
          var get3 = descriptor.get, set3 = descriptor.set;
          Object.defineProperty(node, valueField, {
            configurable: !0,
            get: function() {
              return get3.call(this);
            },
            set: function(value) {
              checkFormFieldValueStringCoercion(value), currentValue = "" + value, set3.call(this, value);
            }
          }), Object.defineProperty(node, valueField, {
            enumerable: descriptor.enumerable
          });
          var tracker = {
            getValue: function() {
              return currentValue;
            },
            setValue: function(value) {
              checkFormFieldValueStringCoercion(value), currentValue = "" + value;
            },
            stopTracking: function() {
              detachTracker(node), delete node[valueField];
            }
          };
          return tracker;
        }
      }
      function track(node) {
        getTracker(node) || (node._valueTracker = trackValueOnNode(node));
      }
      function updateValueIfChanged(node) {
        if (!node)
          return !1;
        var tracker = getTracker(node);
        if (!tracker)
          return !0;
        var lastValue = tracker.getValue(), nextValue = getValueFromNode(node);
        return nextValue !== lastValue ? (tracker.setValue(nextValue), !0) : !1;
      }
      function getActiveElement(doc) {
        if (doc = doc || (typeof document < "u" ? document : void 0), typeof doc > "u")
          return null;
        try {
          return doc.activeElement || doc.body;
        } catch {
          return doc.body;
        }
      }
      var didWarnValueDefaultValue = !1, didWarnCheckedDefaultChecked = !1, didWarnControlledToUncontrolled = !1, didWarnUncontrolledToControlled = !1;
      function isControlled(props) {
        var usesChecked = props.type === "checkbox" || props.type === "radio";
        return usesChecked ? props.checked != null : props.value != null;
      }
      function getHostProps(element, props) {
        var node = element, checked = props.checked, hostProps = assign({}, props, {
          defaultChecked: void 0,
          defaultValue: void 0,
          value: void 0,
          checked: checked ?? node._wrapperState.initialChecked
        });
        return hostProps;
      }
      function initWrapperState(element, props) {
        checkControlledValueProps("input", props), props.checked !== void 0 && props.defaultChecked !== void 0 && !didWarnCheckedDefaultChecked && (error("%s contains an input of type %s with both checked and defaultChecked props. Input elements must be either controlled or uncontrolled (specify either the checked prop, or the defaultChecked prop, but not both). Decide between using a controlled or uncontrolled input element and remove one of these props. More info: https://reactjs.org/link/controlled-components", getCurrentFiberOwnerNameInDevOrNull() || "A component", props.type), didWarnCheckedDefaultChecked = !0), props.value !== void 0 && props.defaultValue !== void 0 && !didWarnValueDefaultValue && (error("%s contains an input of type %s with both value and defaultValue props. Input elements must be either controlled or uncontrolled (specify either the value prop, or the defaultValue prop, but not both). Decide between using a controlled or uncontrolled input element and remove one of these props. More info: https://reactjs.org/link/controlled-components", getCurrentFiberOwnerNameInDevOrNull() || "A component", props.type), didWarnValueDefaultValue = !0);
        var node = element, defaultValue = props.defaultValue == null ? "" : props.defaultValue;
        node._wrapperState = {
          initialChecked: props.checked != null ? props.checked : props.defaultChecked,
          initialValue: getToStringValue(props.value != null ? props.value : defaultValue),
          controlled: isControlled(props)
        };
      }
      function updateChecked(element, props) {
        var node = element, checked = props.checked;
        checked != null && setValueForProperty(node, "checked", checked, !1);
      }
      function updateWrapper(element, props) {
        var node = element;
        {
          var controlled = isControlled(props);
          !node._wrapperState.controlled && controlled && !didWarnUncontrolledToControlled && (error("A component is changing an uncontrolled input to be controlled. This is likely caused by the value changing from undefined to a defined value, which should not happen. Decide between using a controlled or uncontrolled input element for the lifetime of the component. More info: https://reactjs.org/link/controlled-components"), didWarnUncontrolledToControlled = !0), node._wrapperState.controlled && !controlled && !didWarnControlledToUncontrolled && (error("A component is changing a controlled input to be uncontrolled. This is likely caused by the value changing from a defined to undefined, which should not happen. Decide between using a controlled or uncontrolled input element for the lifetime of the component. More info: https://reactjs.org/link/controlled-components"), didWarnControlledToUncontrolled = !0);
        }
        updateChecked(element, props);
        var value = getToStringValue(props.value), type = props.type;
        if (value != null)
          type === "number" ? (value === 0 && node.value === "" || // We explicitly want to coerce to number here if possible.
          // eslint-disable-next-line
          node.value != value) && (node.value = toString2(value)) : node.value !== toString2(value) && (node.value = toString2(value));
        else if (type === "submit" || type === "reset") {
          node.removeAttribute("value");
          return;
        }
        props.hasOwnProperty("value") ? setDefaultValue(node, props.type, value) : props.hasOwnProperty("defaultValue") && setDefaultValue(node, props.type, getToStringValue(props.defaultValue)), props.checked == null && props.defaultChecked != null && (node.defaultChecked = !!props.defaultChecked);
      }
      function postMountWrapper(element, props, isHydrating2) {
        var node = element;
        if (props.hasOwnProperty("value") || props.hasOwnProperty("defaultValue")) {
          var type = props.type, isButton = type === "submit" || type === "reset";
          if (isButton && (props.value === void 0 || props.value === null))
            return;
          var initialValue = toString2(node._wrapperState.initialValue);
          isHydrating2 || initialValue !== node.value && (node.value = initialValue), node.defaultValue = initialValue;
        }
        var name = node.name;
        name !== "" && (node.name = ""), node.defaultChecked = !node.defaultChecked, node.defaultChecked = !!node._wrapperState.initialChecked, name !== "" && (node.name = name);
      }
      function restoreControlledState(element, props) {
        var node = element;
        updateWrapper(node, props), updateNamedCousins(node, props);
      }
      function updateNamedCousins(rootNode, props) {
        var name = props.name;
        if (props.type === "radio" && name != null) {
          for (var queryRoot = rootNode; queryRoot.parentNode; )
            queryRoot = queryRoot.parentNode;
          checkAttributeStringCoercion(name, "name");
          for (var group = queryRoot.querySelectorAll("input[name=" + JSON.stringify("" + name) + '][type="radio"]'), i = 0; i < group.length; i++) {
            var otherNode = group[i];
            if (!(otherNode === rootNode || otherNode.form !== rootNode.form)) {
              var otherProps = getFiberCurrentPropsFromNode(otherNode);
              if (!otherProps)
                throw new Error("ReactDOMInput: Mixing React and non-React radio inputs with the same `name` is not supported.");
              updateValueIfChanged(otherNode), updateWrapper(otherNode, otherProps);
            }
          }
        }
      }
      function setDefaultValue(node, type, value) {
        // Focused number inputs synchronize on blur. See ChangeEventPlugin.js
        (type !== "number" || getActiveElement(node.ownerDocument) !== node) && (value == null ? node.defaultValue = toString2(node._wrapperState.initialValue) : node.defaultValue !== toString2(value) && (node.defaultValue = toString2(value)));
      }
      var didWarnSelectedSetOnOption = !1, didWarnInvalidChild = !1, didWarnInvalidInnerHTML = !1;
      function validateProps(element, props) {
        props.value == null && (typeof props.children == "object" && props.children !== null ? React12.Children.forEach(props.children, function(child) {
          child != null && (typeof child == "string" || typeof child == "number" || didWarnInvalidChild || (didWarnInvalidChild = !0, error("Cannot infer the option value of complex children. Pass a `value` prop or use a plain string as children to <option>.")));
        }) : props.dangerouslySetInnerHTML != null && (didWarnInvalidInnerHTML || (didWarnInvalidInnerHTML = !0, error("Pass a `value` prop if you set dangerouslyInnerHTML so React knows which value should be selected.")))), props.selected != null && !didWarnSelectedSetOnOption && (error("Use the `defaultValue` or `value` props on <select> instead of setting `selected` on <option>."), didWarnSelectedSetOnOption = !0);
      }
      function postMountWrapper$1(element, props) {
        props.value != null && element.setAttribute("value", toString2(getToStringValue(props.value)));
      }
      var isArrayImpl = Array.isArray;
      function isArray(a) {
        return isArrayImpl(a);
      }
      var didWarnValueDefaultValue$1;
      didWarnValueDefaultValue$1 = !1;
      function getDeclarationErrorAddendum() {
        var ownerName = getCurrentFiberOwnerNameInDevOrNull();
        return ownerName ? `

Check the render method of \`` + ownerName + "`." : "";
      }
      var valuePropNames = ["value", "defaultValue"];
      function checkSelectPropTypes(props) {
        {
          checkControlledValueProps("select", props);
          for (var i = 0; i < valuePropNames.length; i++) {
            var propName = valuePropNames[i];
            if (props[propName] != null) {
              var propNameIsArray = isArray(props[propName]);
              props.multiple && !propNameIsArray ? error("The `%s` prop supplied to <select> must be an array if `multiple` is true.%s", propName, getDeclarationErrorAddendum()) : !props.multiple && propNameIsArray && error("The `%s` prop supplied to <select> must be a scalar value if `multiple` is false.%s", propName, getDeclarationErrorAddendum());
            }
          }
        }
      }
      function updateOptions(node, multiple, propValue, setDefaultSelected) {
        var options2 = node.options;
        if (multiple) {
          for (var selectedValues = propValue, selectedValue = {}, i = 0; i < selectedValues.length; i++)
            selectedValue["$" + selectedValues[i]] = !0;
          for (var _i = 0; _i < options2.length; _i++) {
            var selected = selectedValue.hasOwnProperty("$" + options2[_i].value);
            options2[_i].selected !== selected && (options2[_i].selected = selected), selected && setDefaultSelected && (options2[_i].defaultSelected = !0);
          }
        } else {
          for (var _selectedValue = toString2(getToStringValue(propValue)), defaultSelected = null, _i2 = 0; _i2 < options2.length; _i2++) {
            if (options2[_i2].value === _selectedValue) {
              options2[_i2].selected = !0, setDefaultSelected && (options2[_i2].defaultSelected = !0);
              return;
            }
            defaultSelected === null && !options2[_i2].disabled && (defaultSelected = options2[_i2]);
          }
          defaultSelected !== null && (defaultSelected.selected = !0);
        }
      }
      function getHostProps$1(element, props) {
        return assign({}, props, {
          value: void 0
        });
      }
      function initWrapperState$1(element, props) {
        var node = element;
        checkSelectPropTypes(props), node._wrapperState = {
          wasMultiple: !!props.multiple
        }, props.value !== void 0 && props.defaultValue !== void 0 && !didWarnValueDefaultValue$1 && (error("Select elements must be either controlled or uncontrolled (specify either the value prop, or the defaultValue prop, but not both). Decide between using a controlled or uncontrolled select element and remove one of these props. More info: https://reactjs.org/link/controlled-components"), didWarnValueDefaultValue$1 = !0);
      }
      function postMountWrapper$2(element, props) {
        var node = element;
        node.multiple = !!props.multiple;
        var value = props.value;
        value != null ? updateOptions(node, !!props.multiple, value, !1) : props.defaultValue != null && updateOptions(node, !!props.multiple, props.defaultValue, !0);
      }
      function postUpdateWrapper(element, props) {
        var node = element, wasMultiple = node._wrapperState.wasMultiple;
        node._wrapperState.wasMultiple = !!props.multiple;
        var value = props.value;
        value != null ? updateOptions(node, !!props.multiple, value, !1) : wasMultiple !== !!props.multiple && (props.defaultValue != null ? updateOptions(node, !!props.multiple, props.defaultValue, !0) : updateOptions(node, !!props.multiple, props.multiple ? [] : "", !1));
      }
      function restoreControlledState$1(element, props) {
        var node = element, value = props.value;
        value != null && updateOptions(node, !!props.multiple, value, !1);
      }
      var didWarnValDefaultVal = !1;
      function getHostProps$2(element, props) {
        var node = element;
        if (props.dangerouslySetInnerHTML != null)
          throw new Error("`dangerouslySetInnerHTML` does not make sense on <textarea>.");
        var hostProps = assign({}, props, {
          value: void 0,
          defaultValue: void 0,
          children: toString2(node._wrapperState.initialValue)
        });
        return hostProps;
      }
      function initWrapperState$2(element, props) {
        var node = element;
        checkControlledValueProps("textarea", props), props.value !== void 0 && props.defaultValue !== void 0 && !didWarnValDefaultVal && (error("%s contains a textarea with both value and defaultValue props. Textarea elements must be either controlled or uncontrolled (specify either the value prop, or the defaultValue prop, but not both). Decide between using a controlled or uncontrolled textarea and remove one of these props. More info: https://reactjs.org/link/controlled-components", getCurrentFiberOwnerNameInDevOrNull() || "A component"), didWarnValDefaultVal = !0);
        var initialValue = props.value;
        if (initialValue == null) {
          var children = props.children, defaultValue = props.defaultValue;
          if (children != null) {
            error("Use the `defaultValue` or `value` props instead of setting children on <textarea>.");
            {
              if (defaultValue != null)
                throw new Error("If you supply `defaultValue` on a <textarea>, do not pass children.");
              if (isArray(children)) {
                if (children.length > 1)
                  throw new Error("<textarea> can only have at most one child.");
                children = children[0];
              }
              defaultValue = children;
            }
          }
          defaultValue == null && (defaultValue = ""), initialValue = defaultValue;
        }
        node._wrapperState = {
          initialValue: getToStringValue(initialValue)
        };
      }
      function updateWrapper$1(element, props) {
        var node = element, value = getToStringValue(props.value), defaultValue = getToStringValue(props.defaultValue);
        if (value != null) {
          var newValue = toString2(value);
          newValue !== node.value && (node.value = newValue), props.defaultValue == null && node.defaultValue !== newValue && (node.defaultValue = newValue);
        }
        defaultValue != null && (node.defaultValue = toString2(defaultValue));
      }
      function postMountWrapper$3(element, props) {
        var node = element, textContent = node.textContent;
        textContent === node._wrapperState.initialValue && textContent !== "" && textContent !== null && (node.value = textContent);
      }
      function restoreControlledState$2(element, props) {
        updateWrapper$1(element, props);
      }
      var HTML_NAMESPACE = "http://www.w3.org/1999/xhtml", MATH_NAMESPACE = "http://www.w3.org/1998/Math/MathML", SVG_NAMESPACE = "http://www.w3.org/2000/svg";
      function getIntrinsicNamespace(type) {
        switch (type) {
          case "svg":
            return SVG_NAMESPACE;
          case "math":
            return MATH_NAMESPACE;
          default:
            return HTML_NAMESPACE;
        }
      }
      function getChildNamespace(parentNamespace, type) {
        return parentNamespace == null || parentNamespace === HTML_NAMESPACE ? getIntrinsicNamespace(type) : parentNamespace === SVG_NAMESPACE && type === "foreignObject" ? HTML_NAMESPACE : parentNamespace;
      }
      var createMicrosoftUnsafeLocalFunction = function(func) {
        return typeof MSApp < "u" && MSApp.execUnsafeLocalFunction ? function(arg0, arg1, arg2, arg3) {
          MSApp.execUnsafeLocalFunction(function() {
            return func(arg0, arg1, arg2, arg3);
          });
        } : func;
      }, reusableSVGContainer, setInnerHTML = createMicrosoftUnsafeLocalFunction(function(node, html) {
        if (node.namespaceURI === SVG_NAMESPACE && !("innerHTML" in node)) {
          reusableSVGContainer = reusableSVGContainer || document.createElement("div"), reusableSVGContainer.innerHTML = "<svg>" + html.valueOf().toString() + "</svg>";
          for (var svgNode = reusableSVGContainer.firstChild; node.firstChild; )
            node.removeChild(node.firstChild);
          for (; svgNode.firstChild; )
            node.appendChild(svgNode.firstChild);
          return;
        }
        node.innerHTML = html;
      }), ELEMENT_NODE = 1, TEXT_NODE = 3, COMMENT_NODE = 8, DOCUMENT_NODE = 9, DOCUMENT_FRAGMENT_NODE = 11, setTextContent = function(node, text) {
        if (text) {
          var firstChild = node.firstChild;
          if (firstChild && firstChild === node.lastChild && firstChild.nodeType === TEXT_NODE) {
            firstChild.nodeValue = text;
            return;
          }
        }
        node.textContent = text;
      }, shorthandToLonghand = {
        animation: ["animationDelay", "animationDirection", "animationDuration", "animationFillMode", "animationIterationCount", "animationName", "animationPlayState", "animationTimingFunction"],
        background: ["backgroundAttachment", "backgroundClip", "backgroundColor", "backgroundImage", "backgroundOrigin", "backgroundPositionX", "backgroundPositionY", "backgroundRepeat", "backgroundSize"],
        backgroundPosition: ["backgroundPositionX", "backgroundPositionY"],
        border: ["borderBottomColor", "borderBottomStyle", "borderBottomWidth", "borderImageOutset", "borderImageRepeat", "borderImageSlice", "borderImageSource", "borderImageWidth", "borderLeftColor", "borderLeftStyle", "borderLeftWidth", "borderRightColor", "borderRightStyle", "borderRightWidth", "borderTopColor", "borderTopStyle", "borderTopWidth"],
        borderBlockEnd: ["borderBlockEndColor", "borderBlockEndStyle", "borderBlockEndWidth"],
        borderBlockStart: ["borderBlockStartColor", "borderBlockStartStyle", "borderBlockStartWidth"],
        borderBottom: ["borderBottomColor", "borderBottomStyle", "borderBottomWidth"],
        borderColor: ["borderBottomColor", "borderLeftColor", "borderRightColor", "borderTopColor"],
        borderImage: ["borderImageOutset", "borderImageRepeat", "borderImageSlice", "borderImageSource", "borderImageWidth"],
        borderInlineEnd: ["borderInlineEndColor", "borderInlineEndStyle", "borderInlineEndWidth"],
        borderInlineStart: ["borderInlineStartColor", "borderInlineStartStyle", "borderInlineStartWidth"],
        borderLeft: ["borderLeftColor", "borderLeftStyle", "borderLeftWidth"],
        borderRadius: ["borderBottomLeftRadius", "borderBottomRightRadius", "borderTopLeftRadius", "borderTopRightRadius"],
        borderRight: ["borderRightColor", "borderRightStyle", "borderRightWidth"],
        borderStyle: ["borderBottomStyle", "borderLeftStyle", "borderRightStyle", "borderTopStyle"],
        borderTop: ["borderTopColor", "borderTopStyle", "borderTopWidth"],
        borderWidth: ["borderBottomWidth", "borderLeftWidth", "borderRightWidth", "borderTopWidth"],
        columnRule: ["columnRuleColor", "columnRuleStyle", "columnRuleWidth"],
        columns: ["columnCount", "columnWidth"],
        flex: ["flexBasis", "flexGrow", "flexShrink"],
        flexFlow: ["flexDirection", "flexWrap"],
        font: ["fontFamily", "fontFeatureSettings", "fontKerning", "fontLanguageOverride", "fontSize", "fontSizeAdjust", "fontStretch", "fontStyle", "fontVariant", "fontVariantAlternates", "fontVariantCaps", "fontVariantEastAsian", "fontVariantLigatures", "fontVariantNumeric", "fontVariantPosition", "fontWeight", "lineHeight"],
        fontVariant: ["fontVariantAlternates", "fontVariantCaps", "fontVariantEastAsian", "fontVariantLigatures", "fontVariantNumeric", "fontVariantPosition"],
        gap: ["columnGap", "rowGap"],
        grid: ["gridAutoColumns", "gridAutoFlow", "gridAutoRows", "gridTemplateAreas", "gridTemplateColumns", "gridTemplateRows"],
        gridArea: ["gridColumnEnd", "gridColumnStart", "gridRowEnd", "gridRowStart"],
        gridColumn: ["gridColumnEnd", "gridColumnStart"],
        gridColumnGap: ["columnGap"],
        gridGap: ["columnGap", "rowGap"],
        gridRow: ["gridRowEnd", "gridRowStart"],
        gridRowGap: ["rowGap"],
        gridTemplate: ["gridTemplateAreas", "gridTemplateColumns", "gridTemplateRows"],
        listStyle: ["listStyleImage", "listStylePosition", "listStyleType"],
        margin: ["marginBottom", "marginLeft", "marginRight", "marginTop"],
        marker: ["markerEnd", "markerMid", "markerStart"],
        mask: ["maskClip", "maskComposite", "maskImage", "maskMode", "maskOrigin", "maskPositionX", "maskPositionY", "maskRepeat", "maskSize"],
        maskPosition: ["maskPositionX", "maskPositionY"],
        outline: ["outlineColor", "outlineStyle", "outlineWidth"],
        overflow: ["overflowX", "overflowY"],
        padding: ["paddingBottom", "paddingLeft", "paddingRight", "paddingTop"],
        placeContent: ["alignContent", "justifyContent"],
        placeItems: ["alignItems", "justifyItems"],
        placeSelf: ["alignSelf", "justifySelf"],
        textDecoration: ["textDecorationColor", "textDecorationLine", "textDecorationStyle"],
        textEmphasis: ["textEmphasisColor", "textEmphasisStyle"],
        transition: ["transitionDelay", "transitionDuration", "transitionProperty", "transitionTimingFunction"],
        wordWrap: ["overflowWrap"]
      }, isUnitlessNumber = {
        animationIterationCount: !0,
        aspectRatio: !0,
        borderImageOutset: !0,
        borderImageSlice: !0,
        borderImageWidth: !0,
        boxFlex: !0,
        boxFlexGroup: !0,
        boxOrdinalGroup: !0,
        columnCount: !0,
        columns: !0,
        flex: !0,
        flexGrow: !0,
        flexPositive: !0,
        flexShrink: !0,
        flexNegative: !0,
        flexOrder: !0,
        gridArea: !0,
        gridRow: !0,
        gridRowEnd: !0,
        gridRowSpan: !0,
        gridRowStart: !0,
        gridColumn: !0,
        gridColumnEnd: !0,
        gridColumnSpan: !0,
        gridColumnStart: !0,
        fontWeight: !0,
        lineClamp: !0,
        lineHeight: !0,
        opacity: !0,
        order: !0,
        orphans: !0,
        tabSize: !0,
        widows: !0,
        zIndex: !0,
        zoom: !0,
        // SVG-related properties
        fillOpacity: !0,
        floodOpacity: !0,
        stopOpacity: !0,
        strokeDasharray: !0,
        strokeDashoffset: !0,
        strokeMiterlimit: !0,
        strokeOpacity: !0,
        strokeWidth: !0
      };
      function prefixKey(prefix2, key) {
        return prefix2 + key.charAt(0).toUpperCase() + key.substring(1);
      }
      var prefixes = ["Webkit", "ms", "Moz", "O"];
      Object.keys(isUnitlessNumber).forEach(function(prop) {
        prefixes.forEach(function(prefix2) {
          isUnitlessNumber[prefixKey(prefix2, prop)] = isUnitlessNumber[prop];
        });
      });
      function dangerousStyleValue(name, value, isCustomProperty) {
        var isEmpty2 = value == null || typeof value == "boolean" || value === "";
        return isEmpty2 ? "" : !isCustomProperty && typeof value == "number" && value !== 0 && !(isUnitlessNumber.hasOwnProperty(name) && isUnitlessNumber[name]) ? value + "px" : (checkCSSPropertyStringCoercion(value, name), ("" + value).trim());
      }
      var uppercasePattern = /([A-Z])/g, msPattern = /^ms-/;
      function hyphenateStyleName(name) {
        return name.replace(uppercasePattern, "-$1").toLowerCase().replace(msPattern, "-ms-");
      }
      var warnValidStyle = function() {
      };
      {
        var badVendoredStyleNamePattern = /^(?:webkit|moz|o)[A-Z]/, msPattern$1 = /^-ms-/, hyphenPattern = /-(.)/g, badStyleValueWithSemicolonPattern = /;\s*$/, warnedStyleNames = {}, warnedStyleValues = {}, warnedForNaNValue = !1, warnedForInfinityValue = !1, camelize2 = function(string) {
          return string.replace(hyphenPattern, function(_2, character) {
            return character.toUpperCase();
          });
        }, warnHyphenatedStyleName = function(name) {
          warnedStyleNames.hasOwnProperty(name) && warnedStyleNames[name] || (warnedStyleNames[name] = !0, error(
            "Unsupported style property %s. Did you mean %s?",
            name,
            // As Andi Smith suggests
            // (http://www.andismith.com/blog/2012/02/modernizr-prefixed/), an `-ms` prefix
            // is converted to lowercase `ms`.
            camelize2(name.replace(msPattern$1, "ms-"))
          ));
        }, warnBadVendoredStyleName = function(name) {
          warnedStyleNames.hasOwnProperty(name) && warnedStyleNames[name] || (warnedStyleNames[name] = !0, error("Unsupported vendor-prefixed style property %s. Did you mean %s?", name, name.charAt(0).toUpperCase() + name.slice(1)));
        }, warnStyleValueWithSemicolon = function(name, value) {
          warnedStyleValues.hasOwnProperty(value) && warnedStyleValues[value] || (warnedStyleValues[value] = !0, error(`Style property values shouldn't contain a semicolon. Try "%s: %s" instead.`, name, value.replace(badStyleValueWithSemicolonPattern, "")));
        }, warnStyleValueIsNaN = function(name, value) {
          warnedForNaNValue || (warnedForNaNValue = !0, error("`NaN` is an invalid value for the `%s` css style property.", name));
        }, warnStyleValueIsInfinity = function(name, value) {
          warnedForInfinityValue || (warnedForInfinityValue = !0, error("`Infinity` is an invalid value for the `%s` css style property.", name));
        };
        warnValidStyle = function(name, value) {
          name.indexOf("-") > -1 ? warnHyphenatedStyleName(name) : badVendoredStyleNamePattern.test(name) ? warnBadVendoredStyleName(name) : badStyleValueWithSemicolonPattern.test(value) && warnStyleValueWithSemicolon(name, value), typeof value == "number" && (isNaN(value) ? warnStyleValueIsNaN(name, value) : isFinite(value) || warnStyleValueIsInfinity(name, value));
        };
      }
      var warnValidStyle$1 = warnValidStyle;
      function createDangerousStringForStyles(styles) {
        {
          var serialized = "", delimiter = "";
          for (var styleName in styles)
            if (styles.hasOwnProperty(styleName)) {
              var styleValue = styles[styleName];
              if (styleValue != null) {
                var isCustomProperty = styleName.indexOf("--") === 0;
                serialized += delimiter + (isCustomProperty ? styleName : hyphenateStyleName(styleName)) + ":", serialized += dangerousStyleValue(styleName, styleValue, isCustomProperty), delimiter = ";";
              }
            }
          return serialized || null;
        }
      }
      function setValueForStyles(node, styles) {
        var style2 = node.style;
        for (var styleName in styles)
          if (styles.hasOwnProperty(styleName)) {
            var isCustomProperty = styleName.indexOf("--") === 0;
            isCustomProperty || warnValidStyle$1(styleName, styles[styleName]);
            var styleValue = dangerousStyleValue(styleName, styles[styleName], isCustomProperty);
            styleName === "float" && (styleName = "cssFloat"), isCustomProperty ? style2.setProperty(styleName, styleValue) : style2[styleName] = styleValue;
          }
      }
      function isValueEmpty(value) {
        return value == null || typeof value == "boolean" || value === "";
      }
      function expandShorthandMap(styles) {
        var expanded = {};
        for (var key in styles)
          for (var longhands = shorthandToLonghand[key] || [key], i = 0; i < longhands.length; i++)
            expanded[longhands[i]] = key;
        return expanded;
      }
      function validateShorthandPropertyCollisionInDev(styleUpdates, nextStyles) {
        {
          if (!nextStyles)
            return;
          var expandedUpdates = expandShorthandMap(styleUpdates), expandedStyles = expandShorthandMap(nextStyles), warnedAbout = {};
          for (var key in expandedUpdates) {
            var originalKey = expandedUpdates[key], correctOriginalKey = expandedStyles[key];
            if (correctOriginalKey && originalKey !== correctOriginalKey) {
              var warningKey = originalKey + "," + correctOriginalKey;
              if (warnedAbout[warningKey])
                continue;
              warnedAbout[warningKey] = !0, error("%s a style property during rerender (%s) when a conflicting property is set (%s) can lead to styling bugs. To avoid this, don't mix shorthand and non-shorthand properties for the same value; instead, replace the shorthand with separate values.", isValueEmpty(styleUpdates[originalKey]) ? "Removing" : "Updating", originalKey, correctOriginalKey);
            }
          }
        }
      }
      var omittedCloseTags = {
        area: !0,
        base: !0,
        br: !0,
        col: !0,
        embed: !0,
        hr: !0,
        img: !0,
        input: !0,
        keygen: !0,
        link: !0,
        meta: !0,
        param: !0,
        source: !0,
        track: !0,
        wbr: !0
        // NOTE: menuitem's close tag should be omitted, but that causes problems.
      }, voidElementTags = assign({
        menuitem: !0
      }, omittedCloseTags), HTML = "__html";
      function assertValidProps(tag, props) {
        if (props) {
          if (voidElementTags[tag] && (props.children != null || props.dangerouslySetInnerHTML != null))
            throw new Error(tag + " is a void element tag and must neither have `children` nor use `dangerouslySetInnerHTML`.");
          if (props.dangerouslySetInnerHTML != null) {
            if (props.children != null)
              throw new Error("Can only set one of `children` or `props.dangerouslySetInnerHTML`.");
            if (typeof props.dangerouslySetInnerHTML != "object" || !(HTML in props.dangerouslySetInnerHTML))
              throw new Error("`props.dangerouslySetInnerHTML` must be in the form `{__html: ...}`. Please visit https://reactjs.org/link/dangerously-set-inner-html for more information.");
          }
          if (!props.suppressContentEditableWarning && props.contentEditable && props.children != null && error("A component is `contentEditable` and contains `children` managed by React. It is now your responsibility to guarantee that none of those nodes are unexpectedly modified or duplicated. This is probably not intentional."), props.style != null && typeof props.style != "object")
            throw new Error("The `style` prop expects a mapping from style properties to values, not a string. For example, style={{marginRight: spacing + 'em'}} when using JSX.");
        }
      }
      function isCustomComponent(tagName, props) {
        if (tagName.indexOf("-") === -1)
          return typeof props.is == "string";
        switch (tagName) {
          case "annotation-xml":
          case "color-profile":
          case "font-face":
          case "font-face-src":
          case "font-face-uri":
          case "font-face-format":
          case "font-face-name":
          case "missing-glyph":
            return !1;
          default:
            return !0;
        }
      }
      var possibleStandardNames = {
        // HTML
        accept: "accept",
        acceptcharset: "acceptCharset",
        "accept-charset": "acceptCharset",
        accesskey: "accessKey",
        action: "action",
        allowfullscreen: "allowFullScreen",
        alt: "alt",
        as: "as",
        async: "async",
        autocapitalize: "autoCapitalize",
        autocomplete: "autoComplete",
        autocorrect: "autoCorrect",
        autofocus: "autoFocus",
        autoplay: "autoPlay",
        autosave: "autoSave",
        capture: "capture",
        cellpadding: "cellPadding",
        cellspacing: "cellSpacing",
        challenge: "challenge",
        charset: "charSet",
        checked: "checked",
        children: "children",
        cite: "cite",
        class: "className",
        classid: "classID",
        classname: "className",
        cols: "cols",
        colspan: "colSpan",
        content: "content",
        contenteditable: "contentEditable",
        contextmenu: "contextMenu",
        controls: "controls",
        controlslist: "controlsList",
        coords: "coords",
        crossorigin: "crossOrigin",
        dangerouslysetinnerhtml: "dangerouslySetInnerHTML",
        data: "data",
        datetime: "dateTime",
        default: "default",
        defaultchecked: "defaultChecked",
        defaultvalue: "defaultValue",
        defer: "defer",
        dir: "dir",
        disabled: "disabled",
        disablepictureinpicture: "disablePictureInPicture",
        disableremoteplayback: "disableRemotePlayback",
        download: "download",
        draggable: "draggable",
        enctype: "encType",
        enterkeyhint: "enterKeyHint",
        for: "htmlFor",
        form: "form",
        formmethod: "formMethod",
        formaction: "formAction",
        formenctype: "formEncType",
        formnovalidate: "formNoValidate",
        formtarget: "formTarget",
        frameborder: "frameBorder",
        headers: "headers",
        height: "height",
        hidden: "hidden",
        high: "high",
        href: "href",
        hreflang: "hrefLang",
        htmlfor: "htmlFor",
        httpequiv: "httpEquiv",
        "http-equiv": "httpEquiv",
        icon: "icon",
        id: "id",
        imagesizes: "imageSizes",
        imagesrcset: "imageSrcSet",
        innerhtml: "innerHTML",
        inputmode: "inputMode",
        integrity: "integrity",
        is: "is",
        itemid: "itemID",
        itemprop: "itemProp",
        itemref: "itemRef",
        itemscope: "itemScope",
        itemtype: "itemType",
        keyparams: "keyParams",
        keytype: "keyType",
        kind: "kind",
        label: "label",
        lang: "lang",
        list: "list",
        loop: "loop",
        low: "low",
        manifest: "manifest",
        marginwidth: "marginWidth",
        marginheight: "marginHeight",
        max: "max",
        maxlength: "maxLength",
        media: "media",
        mediagroup: "mediaGroup",
        method: "method",
        min: "min",
        minlength: "minLength",
        multiple: "multiple",
        muted: "muted",
        name: "name",
        nomodule: "noModule",
        nonce: "nonce",
        novalidate: "noValidate",
        open: "open",
        optimum: "optimum",
        pattern: "pattern",
        placeholder: "placeholder",
        playsinline: "playsInline",
        poster: "poster",
        preload: "preload",
        profile: "profile",
        radiogroup: "radioGroup",
        readonly: "readOnly",
        referrerpolicy: "referrerPolicy",
        rel: "rel",
        required: "required",
        reversed: "reversed",
        role: "role",
        rows: "rows",
        rowspan: "rowSpan",
        sandbox: "sandbox",
        scope: "scope",
        scoped: "scoped",
        scrolling: "scrolling",
        seamless: "seamless",
        selected: "selected",
        shape: "shape",
        size: "size",
        sizes: "sizes",
        span: "span",
        spellcheck: "spellCheck",
        src: "src",
        srcdoc: "srcDoc",
        srclang: "srcLang",
        srcset: "srcSet",
        start: "start",
        step: "step",
        style: "style",
        summary: "summary",
        tabindex: "tabIndex",
        target: "target",
        title: "title",
        type: "type",
        usemap: "useMap",
        value: "value",
        width: "width",
        wmode: "wmode",
        wrap: "wrap",
        // SVG
        about: "about",
        accentheight: "accentHeight",
        "accent-height": "accentHeight",
        accumulate: "accumulate",
        additive: "additive",
        alignmentbaseline: "alignmentBaseline",
        "alignment-baseline": "alignmentBaseline",
        allowreorder: "allowReorder",
        alphabetic: "alphabetic",
        amplitude: "amplitude",
        arabicform: "arabicForm",
        "arabic-form": "arabicForm",
        ascent: "ascent",
        attributename: "attributeName",
        attributetype: "attributeType",
        autoreverse: "autoReverse",
        azimuth: "azimuth",
        basefrequency: "baseFrequency",
        baselineshift: "baselineShift",
        "baseline-shift": "baselineShift",
        baseprofile: "baseProfile",
        bbox: "bbox",
        begin: "begin",
        bias: "bias",
        by: "by",
        calcmode: "calcMode",
        capheight: "capHeight",
        "cap-height": "capHeight",
        clip: "clip",
        clippath: "clipPath",
        "clip-path": "clipPath",
        clippathunits: "clipPathUnits",
        cliprule: "clipRule",
        "clip-rule": "clipRule",
        color: "color",
        colorinterpolation: "colorInterpolation",
        "color-interpolation": "colorInterpolation",
        colorinterpolationfilters: "colorInterpolationFilters",
        "color-interpolation-filters": "colorInterpolationFilters",
        colorprofile: "colorProfile",
        "color-profile": "colorProfile",
        colorrendering: "colorRendering",
        "color-rendering": "colorRendering",
        contentscripttype: "contentScriptType",
        contentstyletype: "contentStyleType",
        cursor: "cursor",
        cx: "cx",
        cy: "cy",
        d: "d",
        datatype: "datatype",
        decelerate: "decelerate",
        descent: "descent",
        diffuseconstant: "diffuseConstant",
        direction: "direction",
        display: "display",
        divisor: "divisor",
        dominantbaseline: "dominantBaseline",
        "dominant-baseline": "dominantBaseline",
        dur: "dur",
        dx: "dx",
        dy: "dy",
        edgemode: "edgeMode",
        elevation: "elevation",
        enablebackground: "enableBackground",
        "enable-background": "enableBackground",
        end: "end",
        exponent: "exponent",
        externalresourcesrequired: "externalResourcesRequired",
        fill: "fill",
        fillopacity: "fillOpacity",
        "fill-opacity": "fillOpacity",
        fillrule: "fillRule",
        "fill-rule": "fillRule",
        filter: "filter",
        filterres: "filterRes",
        filterunits: "filterUnits",
        floodopacity: "floodOpacity",
        "flood-opacity": "floodOpacity",
        floodcolor: "floodColor",
        "flood-color": "floodColor",
        focusable: "focusable",
        fontfamily: "fontFamily",
        "font-family": "fontFamily",
        fontsize: "fontSize",
        "font-size": "fontSize",
        fontsizeadjust: "fontSizeAdjust",
        "font-size-adjust": "fontSizeAdjust",
        fontstretch: "fontStretch",
        "font-stretch": "fontStretch",
        fontstyle: "fontStyle",
        "font-style": "fontStyle",
        fontvariant: "fontVariant",
        "font-variant": "fontVariant",
        fontweight: "fontWeight",
        "font-weight": "fontWeight",
        format: "format",
        from: "from",
        fx: "fx",
        fy: "fy",
        g1: "g1",
        g2: "g2",
        glyphname: "glyphName",
        "glyph-name": "glyphName",
        glyphorientationhorizontal: "glyphOrientationHorizontal",
        "glyph-orientation-horizontal": "glyphOrientationHorizontal",
        glyphorientationvertical: "glyphOrientationVertical",
        "glyph-orientation-vertical": "glyphOrientationVertical",
        glyphref: "glyphRef",
        gradienttransform: "gradientTransform",
        gradientunits: "gradientUnits",
        hanging: "hanging",
        horizadvx: "horizAdvX",
        "horiz-adv-x": "horizAdvX",
        horizoriginx: "horizOriginX",
        "horiz-origin-x": "horizOriginX",
        ideographic: "ideographic",
        imagerendering: "imageRendering",
        "image-rendering": "imageRendering",
        in2: "in2",
        in: "in",
        inlist: "inlist",
        intercept: "intercept",
        k1: "k1",
        k2: "k2",
        k3: "k3",
        k4: "k4",
        k: "k",
        kernelmatrix: "kernelMatrix",
        kernelunitlength: "kernelUnitLength",
        kerning: "kerning",
        keypoints: "keyPoints",
        keysplines: "keySplines",
        keytimes: "keyTimes",
        lengthadjust: "lengthAdjust",
        letterspacing: "letterSpacing",
        "letter-spacing": "letterSpacing",
        lightingcolor: "lightingColor",
        "lighting-color": "lightingColor",
        limitingconeangle: "limitingConeAngle",
        local: "local",
        markerend: "markerEnd",
        "marker-end": "markerEnd",
        markerheight: "markerHeight",
        markermid: "markerMid",
        "marker-mid": "markerMid",
        markerstart: "markerStart",
        "marker-start": "markerStart",
        markerunits: "markerUnits",
        markerwidth: "markerWidth",
        mask: "mask",
        maskcontentunits: "maskContentUnits",
        maskunits: "maskUnits",
        mathematical: "mathematical",
        mode: "mode",
        numoctaves: "numOctaves",
        offset: "offset",
        opacity: "opacity",
        operator: "operator",
        order: "order",
        orient: "orient",
        orientation: "orientation",
        origin: "origin",
        overflow: "overflow",
        overlineposition: "overlinePosition",
        "overline-position": "overlinePosition",
        overlinethickness: "overlineThickness",
        "overline-thickness": "overlineThickness",
        paintorder: "paintOrder",
        "paint-order": "paintOrder",
        panose1: "panose1",
        "panose-1": "panose1",
        pathlength: "pathLength",
        patterncontentunits: "patternContentUnits",
        patterntransform: "patternTransform",
        patternunits: "patternUnits",
        pointerevents: "pointerEvents",
        "pointer-events": "pointerEvents",
        points: "points",
        pointsatx: "pointsAtX",
        pointsaty: "pointsAtY",
        pointsatz: "pointsAtZ",
        prefix: "prefix",
        preservealpha: "preserveAlpha",
        preserveaspectratio: "preserveAspectRatio",
        primitiveunits: "primitiveUnits",
        property: "property",
        r: "r",
        radius: "radius",
        refx: "refX",
        refy: "refY",
        renderingintent: "renderingIntent",
        "rendering-intent": "renderingIntent",
        repeatcount: "repeatCount",
        repeatdur: "repeatDur",
        requiredextensions: "requiredExtensions",
        requiredfeatures: "requiredFeatures",
        resource: "resource",
        restart: "restart",
        result: "result",
        results: "results",
        rotate: "rotate",
        rx: "rx",
        ry: "ry",
        scale: "scale",
        security: "security",
        seed: "seed",
        shaperendering: "shapeRendering",
        "shape-rendering": "shapeRendering",
        slope: "slope",
        spacing: "spacing",
        specularconstant: "specularConstant",
        specularexponent: "specularExponent",
        speed: "speed",
        spreadmethod: "spreadMethod",
        startoffset: "startOffset",
        stddeviation: "stdDeviation",
        stemh: "stemh",
        stemv: "stemv",
        stitchtiles: "stitchTiles",
        stopcolor: "stopColor",
        "stop-color": "stopColor",
        stopopacity: "stopOpacity",
        "stop-opacity": "stopOpacity",
        strikethroughposition: "strikethroughPosition",
        "strikethrough-position": "strikethroughPosition",
        strikethroughthickness: "strikethroughThickness",
        "strikethrough-thickness": "strikethroughThickness",
        string: "string",
        stroke: "stroke",
        strokedasharray: "strokeDasharray",
        "stroke-dasharray": "strokeDasharray",
        strokedashoffset: "strokeDashoffset",
        "stroke-dashoffset": "strokeDashoffset",
        strokelinecap: "strokeLinecap",
        "stroke-linecap": "strokeLinecap",
        strokelinejoin: "strokeLinejoin",
        "stroke-linejoin": "strokeLinejoin",
        strokemiterlimit: "strokeMiterlimit",
        "stroke-miterlimit": "strokeMiterlimit",
        strokewidth: "strokeWidth",
        "stroke-width": "strokeWidth",
        strokeopacity: "strokeOpacity",
        "stroke-opacity": "strokeOpacity",
        suppresscontenteditablewarning: "suppressContentEditableWarning",
        suppresshydrationwarning: "suppressHydrationWarning",
        surfacescale: "surfaceScale",
        systemlanguage: "systemLanguage",
        tablevalues: "tableValues",
        targetx: "targetX",
        targety: "targetY",
        textanchor: "textAnchor",
        "text-anchor": "textAnchor",
        textdecoration: "textDecoration",
        "text-decoration": "textDecoration",
        textlength: "textLength",
        textrendering: "textRendering",
        "text-rendering": "textRendering",
        to: "to",
        transform: "transform",
        typeof: "typeof",
        u1: "u1",
        u2: "u2",
        underlineposition: "underlinePosition",
        "underline-position": "underlinePosition",
        underlinethickness: "underlineThickness",
        "underline-thickness": "underlineThickness",
        unicode: "unicode",
        unicodebidi: "unicodeBidi",
        "unicode-bidi": "unicodeBidi",
        unicoderange: "unicodeRange",
        "unicode-range": "unicodeRange",
        unitsperem: "unitsPerEm",
        "units-per-em": "unitsPerEm",
        unselectable: "unselectable",
        valphabetic: "vAlphabetic",
        "v-alphabetic": "vAlphabetic",
        values: "values",
        vectoreffect: "vectorEffect",
        "vector-effect": "vectorEffect",
        version: "version",
        vertadvy: "vertAdvY",
        "vert-adv-y": "vertAdvY",
        vertoriginx: "vertOriginX",
        "vert-origin-x": "vertOriginX",
        vertoriginy: "vertOriginY",
        "vert-origin-y": "vertOriginY",
        vhanging: "vHanging",
        "v-hanging": "vHanging",
        videographic: "vIdeographic",
        "v-ideographic": "vIdeographic",
        viewbox: "viewBox",
        viewtarget: "viewTarget",
        visibility: "visibility",
        vmathematical: "vMathematical",
        "v-mathematical": "vMathematical",
        vocab: "vocab",
        widths: "widths",
        wordspacing: "wordSpacing",
        "word-spacing": "wordSpacing",
        writingmode: "writingMode",
        "writing-mode": "writingMode",
        x1: "x1",
        x2: "x2",
        x: "x",
        xchannelselector: "xChannelSelector",
        xheight: "xHeight",
        "x-height": "xHeight",
        xlinkactuate: "xlinkActuate",
        "xlink:actuate": "xlinkActuate",
        xlinkarcrole: "xlinkArcrole",
        "xlink:arcrole": "xlinkArcrole",
        xlinkhref: "xlinkHref",
        "xlink:href": "xlinkHref",
        xlinkrole: "xlinkRole",
        "xlink:role": "xlinkRole",
        xlinkshow: "xlinkShow",
        "xlink:show": "xlinkShow",
        xlinktitle: "xlinkTitle",
        "xlink:title": "xlinkTitle",
        xlinktype: "xlinkType",
        "xlink:type": "xlinkType",
        xmlbase: "xmlBase",
        "xml:base": "xmlBase",
        xmllang: "xmlLang",
        "xml:lang": "xmlLang",
        xmlns: "xmlns",
        "xml:space": "xmlSpace",
        xmlnsxlink: "xmlnsXlink",
        "xmlns:xlink": "xmlnsXlink",
        xmlspace: "xmlSpace",
        y1: "y1",
        y2: "y2",
        y: "y",
        ychannelselector: "yChannelSelector",
        z: "z",
        zoomandpan: "zoomAndPan"
      }, ariaProperties = {
        "aria-current": 0,
        // state
        "aria-description": 0,
        "aria-details": 0,
        "aria-disabled": 0,
        // state
        "aria-hidden": 0,
        // state
        "aria-invalid": 0,
        // state
        "aria-keyshortcuts": 0,
        "aria-label": 0,
        "aria-roledescription": 0,
        // Widget Attributes
        "aria-autocomplete": 0,
        "aria-checked": 0,
        "aria-expanded": 0,
        "aria-haspopup": 0,
        "aria-level": 0,
        "aria-modal": 0,
        "aria-multiline": 0,
        "aria-multiselectable": 0,
        "aria-orientation": 0,
        "aria-placeholder": 0,
        "aria-pressed": 0,
        "aria-readonly": 0,
        "aria-required": 0,
        "aria-selected": 0,
        "aria-sort": 0,
        "aria-valuemax": 0,
        "aria-valuemin": 0,
        "aria-valuenow": 0,
        "aria-valuetext": 0,
        // Live Region Attributes
        "aria-atomic": 0,
        "aria-busy": 0,
        "aria-live": 0,
        "aria-relevant": 0,
        // Drag-and-Drop Attributes
        "aria-dropeffect": 0,
        "aria-grabbed": 0,
        // Relationship Attributes
        "aria-activedescendant": 0,
        "aria-colcount": 0,
        "aria-colindex": 0,
        "aria-colspan": 0,
        "aria-controls": 0,
        "aria-describedby": 0,
        "aria-errormessage": 0,
        "aria-flowto": 0,
        "aria-labelledby": 0,
        "aria-owns": 0,
        "aria-posinset": 0,
        "aria-rowcount": 0,
        "aria-rowindex": 0,
        "aria-rowspan": 0,
        "aria-setsize": 0
      }, warnedProperties = {}, rARIA = new RegExp("^(aria)-[" + ATTRIBUTE_NAME_CHAR + "]*$"), rARIACamel = new RegExp("^(aria)[A-Z][" + ATTRIBUTE_NAME_CHAR + "]*$");
      function validateProperty(tagName, name) {
        {
          if (hasOwnProperty.call(warnedProperties, name) && warnedProperties[name])
            return !0;
          if (rARIACamel.test(name)) {
            var ariaName = "aria-" + name.slice(4).toLowerCase(), correctName = ariaProperties.hasOwnProperty(ariaName) ? ariaName : null;
            if (correctName == null)
              return error("Invalid ARIA attribute `%s`. ARIA attributes follow the pattern aria-* and must be lowercase.", name), warnedProperties[name] = !0, !0;
            if (name !== correctName)
              return error("Invalid ARIA attribute `%s`. Did you mean `%s`?", name, correctName), warnedProperties[name] = !0, !0;
          }
          if (rARIA.test(name)) {
            var lowerCasedName = name.toLowerCase(), standardName = ariaProperties.hasOwnProperty(lowerCasedName) ? lowerCasedName : null;
            if (standardName == null)
              return warnedProperties[name] = !0, !1;
            if (name !== standardName)
              return error("Unknown ARIA attribute `%s`. Did you mean `%s`?", name, standardName), warnedProperties[name] = !0, !0;
          }
        }
        return !0;
      }
      function warnInvalidARIAProps(type, props) {
        {
          var invalidProps = [];
          for (var key in props) {
            var isValid = validateProperty(type, key);
            isValid || invalidProps.push(key);
          }
          var unknownPropString = invalidProps.map(function(prop) {
            return "`" + prop + "`";
          }).join(", ");
          invalidProps.length === 1 ? error("Invalid aria prop %s on <%s> tag. For details, see https://reactjs.org/link/invalid-aria-props", unknownPropString, type) : invalidProps.length > 1 && error("Invalid aria props %s on <%s> tag. For details, see https://reactjs.org/link/invalid-aria-props", unknownPropString, type);
        }
      }
      function validateProperties(type, props) {
        isCustomComponent(type, props) || warnInvalidARIAProps(type, props);
      }
      var didWarnValueNull = !1;
      function validateProperties$1(type, props) {
        {
          if (type !== "input" && type !== "textarea" && type !== "select")
            return;
          props != null && props.value === null && !didWarnValueNull && (didWarnValueNull = !0, type === "select" && props.multiple ? error("`value` prop on `%s` should not be null. Consider using an empty array when `multiple` is set to `true` to clear the component or `undefined` for uncontrolled components.", type) : error("`value` prop on `%s` should not be null. Consider using an empty string to clear the component or `undefined` for uncontrolled components.", type));
        }
      }
      var validateProperty$1 = function() {
      };
      {
        var warnedProperties$1 = {}, EVENT_NAME_REGEX = /^on./, INVALID_EVENT_NAME_REGEX = /^on[^A-Z]/, rARIA$1 = new RegExp("^(aria)-[" + ATTRIBUTE_NAME_CHAR + "]*$"), rARIACamel$1 = new RegExp("^(aria)[A-Z][" + ATTRIBUTE_NAME_CHAR + "]*$");
        validateProperty$1 = function(tagName, name, value, eventRegistry) {
          if (hasOwnProperty.call(warnedProperties$1, name) && warnedProperties$1[name])
            return !0;
          var lowerCasedName = name.toLowerCase();
          if (lowerCasedName === "onfocusin" || lowerCasedName === "onfocusout")
            return error("React uses onFocus and onBlur instead of onFocusIn and onFocusOut. All React events are normalized to bubble, so onFocusIn and onFocusOut are not needed/supported by React."), warnedProperties$1[name] = !0, !0;
          if (eventRegistry != null) {
            var registrationNameDependencies2 = eventRegistry.registrationNameDependencies, possibleRegistrationNames2 = eventRegistry.possibleRegistrationNames;
            if (registrationNameDependencies2.hasOwnProperty(name))
              return !0;
            var registrationName = possibleRegistrationNames2.hasOwnProperty(lowerCasedName) ? possibleRegistrationNames2[lowerCasedName] : null;
            if (registrationName != null)
              return error("Invalid event handler property `%s`. Did you mean `%s`?", name, registrationName), warnedProperties$1[name] = !0, !0;
            if (EVENT_NAME_REGEX.test(name))
              return error("Unknown event handler property `%s`. It will be ignored.", name), warnedProperties$1[name] = !0, !0;
          } else if (EVENT_NAME_REGEX.test(name))
            return INVALID_EVENT_NAME_REGEX.test(name) && error("Invalid event handler property `%s`. React events use the camelCase naming convention, for example `onClick`.", name), warnedProperties$1[name] = !0, !0;
          if (rARIA$1.test(name) || rARIACamel$1.test(name))
            return !0;
          if (lowerCasedName === "innerhtml")
            return error("Directly setting property `innerHTML` is not permitted. For more information, lookup documentation on `dangerouslySetInnerHTML`."), warnedProperties$1[name] = !0, !0;
          if (lowerCasedName === "aria")
            return error("The `aria` attribute is reserved for future use in React. Pass individual `aria-` attributes instead."), warnedProperties$1[name] = !0, !0;
          if (lowerCasedName === "is" && value !== null && value !== void 0 && typeof value != "string")
            return error("Received a `%s` for a string attribute `is`. If this is expected, cast the value to a string.", typeof value), warnedProperties$1[name] = !0, !0;
          if (typeof value == "number" && isNaN(value))
            return error("Received NaN for the `%s` attribute. If this is expected, cast the value to a string.", name), warnedProperties$1[name] = !0, !0;
          var propertyInfo = getPropertyInfo(name), isReserved = propertyInfo !== null && propertyInfo.type === RESERVED;
          if (possibleStandardNames.hasOwnProperty(lowerCasedName)) {
            var standardName = possibleStandardNames[lowerCasedName];
            if (standardName !== name)
              return error("Invalid DOM property `%s`. Did you mean `%s`?", name, standardName), warnedProperties$1[name] = !0, !0;
          } else if (!isReserved && name !== lowerCasedName)
            return error("React does not recognize the `%s` prop on a DOM element. If you intentionally want it to appear in the DOM as a custom attribute, spell it as lowercase `%s` instead. If you accidentally passed it from a parent component, remove it from the DOM element.", name, lowerCasedName), warnedProperties$1[name] = !0, !0;
          return typeof value == "boolean" && shouldRemoveAttributeWithWarning(name, value, propertyInfo, !1) ? (value ? error('Received `%s` for a non-boolean attribute `%s`.\n\nIf you want to write it to the DOM, pass a string instead: %s="%s" or %s={value.toString()}.', value, name, name, value, name) : error('Received `%s` for a non-boolean attribute `%s`.\n\nIf you want to write it to the DOM, pass a string instead: %s="%s" or %s={value.toString()}.\n\nIf you used to conditionally omit it with %s={condition && value}, pass %s={condition ? value : undefined} instead.', value, name, name, value, name, name, name), warnedProperties$1[name] = !0, !0) : isReserved ? !0 : shouldRemoveAttributeWithWarning(name, value, propertyInfo, !1) ? (warnedProperties$1[name] = !0, !1) : ((value === "false" || value === "true") && propertyInfo !== null && propertyInfo.type === BOOLEAN && (error("Received the string `%s` for the boolean attribute `%s`. %s Did you mean %s={%s}?", value, name, value === "false" ? "The browser will interpret it as a truthy value." : 'Although this works, it will not work as expected if you pass the string "false".', name, value), warnedProperties$1[name] = !0), !0);
        };
      }
      var warnUnknownProperties = function(type, props, eventRegistry) {
        {
          var unknownProps = [];
          for (var key in props) {
            var isValid = validateProperty$1(type, key, props[key], eventRegistry);
            isValid || unknownProps.push(key);
          }
          var unknownPropString = unknownProps.map(function(prop) {
            return "`" + prop + "`";
          }).join(", ");
          unknownProps.length === 1 ? error("Invalid value for prop %s on <%s> tag. Either remove it from the element, or pass a string or number value to keep it in the DOM. For details, see https://reactjs.org/link/attribute-behavior ", unknownPropString, type) : unknownProps.length > 1 && error("Invalid values for props %s on <%s> tag. Either remove them from the element, or pass a string or number value to keep them in the DOM. For details, see https://reactjs.org/link/attribute-behavior ", unknownPropString, type);
        }
      };
      function validateProperties$2(type, props, eventRegistry) {
        isCustomComponent(type, props) || warnUnknownProperties(type, props, eventRegistry);
      }
      var IS_EVENT_HANDLE_NON_MANAGED_NODE = 1, IS_NON_DELEGATED = 2, IS_CAPTURE_PHASE = 4, SHOULD_NOT_PROCESS_POLYFILL_EVENT_PLUGINS = IS_EVENT_HANDLE_NON_MANAGED_NODE | IS_NON_DELEGATED | IS_CAPTURE_PHASE, currentReplayingEvent = null;
      function setReplayingEvent(event) {
        currentReplayingEvent !== null && error("Expected currently replaying event to be null. This error is likely caused by a bug in React. Please file an issue."), currentReplayingEvent = event;
      }
      function resetReplayingEvent() {
        currentReplayingEvent === null && error("Expected currently replaying event to not be null. This error is likely caused by a bug in React. Please file an issue."), currentReplayingEvent = null;
      }
      function isReplayingEvent(event) {
        return event === currentReplayingEvent;
      }
      function getEventTarget(nativeEvent) {
        var target = nativeEvent.target || nativeEvent.srcElement || window;
        return target.correspondingUseElement && (target = target.correspondingUseElement), target.nodeType === TEXT_NODE ? target.parentNode : target;
      }
      var restoreImpl = null, restoreTarget = null, restoreQueue = null;
      function restoreStateOfTarget(target) {
        var internalInstance = getInstanceFromNode(target);
        if (internalInstance) {
          if (typeof restoreImpl != "function")
            throw new Error("setRestoreImplementation() needs to be called to handle a target for controlled events. This error is likely caused by a bug in React. Please file an issue.");
          var stateNode = internalInstance.stateNode;
          if (stateNode) {
            var _props = getFiberCurrentPropsFromNode(stateNode);
            restoreImpl(internalInstance.stateNode, internalInstance.type, _props);
          }
        }
      }
      function setRestoreImplementation(impl) {
        restoreImpl = impl;
      }
      function enqueueStateRestore(target) {
        restoreTarget ? restoreQueue ? restoreQueue.push(target) : restoreQueue = [target] : restoreTarget = target;
      }
      function needsStateRestore() {
        return restoreTarget !== null || restoreQueue !== null;
      }
      function restoreStateIfNeeded() {
        if (restoreTarget) {
          var target = restoreTarget, queuedTargets = restoreQueue;
          if (restoreTarget = null, restoreQueue = null, restoreStateOfTarget(target), queuedTargets)
            for (var i = 0; i < queuedTargets.length; i++)
              restoreStateOfTarget(queuedTargets[i]);
        }
      }
      var batchedUpdatesImpl = function(fn, bookkeeping) {
        return fn(bookkeeping);
      }, flushSyncImpl = function() {
      }, isInsideEventHandler = !1;
      function finishEventHandler() {
        var controlledComponentsHavePendingUpdates = needsStateRestore();
        controlledComponentsHavePendingUpdates && (flushSyncImpl(), restoreStateIfNeeded());
      }
      function batchedUpdates(fn, a, b) {
        if (isInsideEventHandler)
          return fn(a, b);
        isInsideEventHandler = !0;
        try {
          return batchedUpdatesImpl(fn, a, b);
        } finally {
          isInsideEventHandler = !1, finishEventHandler();
        }
      }
      function setBatchingImplementation(_batchedUpdatesImpl, _discreteUpdatesImpl, _flushSyncImpl) {
        batchedUpdatesImpl = _batchedUpdatesImpl, flushSyncImpl = _flushSyncImpl;
      }
      function isInteractive(tag) {
        return tag === "button" || tag === "input" || tag === "select" || tag === "textarea";
      }
      function shouldPreventMouseEvent(name, type, props) {
        switch (name) {
          case "onClick":
          case "onClickCapture":
          case "onDoubleClick":
          case "onDoubleClickCapture":
          case "onMouseDown":
          case "onMouseDownCapture":
          case "onMouseMove":
          case "onMouseMoveCapture":
          case "onMouseUp":
          case "onMouseUpCapture":
          case "onMouseEnter":
            return !!(props.disabled && isInteractive(type));
          default:
            return !1;
        }
      }
      function getListener(inst, registrationName) {
        var stateNode = inst.stateNode;
        if (stateNode === null)
          return null;
        var props = getFiberCurrentPropsFromNode(stateNode);
        if (props === null)
          return null;
        var listener = props[registrationName];
        if (shouldPreventMouseEvent(registrationName, inst.type, props))
          return null;
        if (listener && typeof listener != "function")
          throw new Error("Expected `" + registrationName + "` listener to be a function, instead got a value of `" + typeof listener + "` type.");
        return listener;
      }
      var passiveBrowserEventsSupported = !1;
      if (canUseDOM)
        try {
          var options = {};
          Object.defineProperty(options, "passive", {
            get: function() {
              passiveBrowserEventsSupported = !0;
            }
          }), window.addEventListener("test", options, options), window.removeEventListener("test", options, options);
        } catch {
          passiveBrowserEventsSupported = !1;
        }
      function invokeGuardedCallbackProd(name, func, context, a, b, c, d, e, f) {
        var funcArgs = Array.prototype.slice.call(arguments, 3);
        try {
          func.apply(context, funcArgs);
        } catch (error2) {
          this.onError(error2);
        }
      }
      var invokeGuardedCallbackImpl = invokeGuardedCallbackProd;
      if (typeof window < "u" && typeof window.dispatchEvent == "function" && typeof document < "u" && typeof document.createEvent == "function") {
        var fakeNode = document.createElement("react");
        invokeGuardedCallbackImpl = function(name, func, context, a, b, c, d, e, f) {
          if (typeof document > "u" || document === null)
            throw new Error("The `document` global was defined when React was initialized, but is not defined anymore. This can happen in a test environment if a component schedules an update from an asynchronous callback, but the test has already finished running. To solve this, you can either unmount the component at the end of your test (and ensure that any asynchronous operations get canceled in `componentWillUnmount`), or you can change the test itself to be asynchronous.");
          var evt = document.createEvent("Event"), didCall = !1, didError = !0, windowEvent = window.event, windowEventDescriptor = Object.getOwnPropertyDescriptor(window, "event");
          function restoreAfterDispatch() {
            fakeNode.removeEventListener(evtType, callCallback2, !1), typeof window.event < "u" && window.hasOwnProperty("event") && (window.event = windowEvent);
          }
          var funcArgs = Array.prototype.slice.call(arguments, 3);
          function callCallback2() {
            didCall = !0, restoreAfterDispatch(), func.apply(context, funcArgs), didError = !1;
          }
          var error2, didSetError = !1, isCrossOriginError = !1;
          function handleWindowError(event) {
            if (error2 = event.error, didSetError = !0, error2 === null && event.colno === 0 && event.lineno === 0 && (isCrossOriginError = !0), event.defaultPrevented && error2 != null && typeof error2 == "object")
              try {
                error2._suppressLogging = !0;
              } catch {
              }
          }
          var evtType = "react-" + (name || "invokeguardedcallback");
          if (window.addEventListener("error", handleWindowError), fakeNode.addEventListener(evtType, callCallback2, !1), evt.initEvent(evtType, !1, !1), fakeNode.dispatchEvent(evt), windowEventDescriptor && Object.defineProperty(window, "event", windowEventDescriptor), didCall && didError && (didSetError ? isCrossOriginError && (error2 = new Error("A cross-origin error was thrown. React doesn't have access to the actual error object in development. See https://reactjs.org/link/crossorigin-error for more information.")) : error2 = new Error(`An error was thrown inside one of your components, but React doesn't know what it was. This is likely due to browser flakiness. React does its best to preserve the "Pause on exceptions" behavior of the DevTools, which requires some DEV-mode only tricks. It's possible that these don't work in your browser. Try triggering the error in production mode, or switching to a modern browser. If you suspect that this is actually an issue with React, please file an issue.`), this.onError(error2)), window.removeEventListener("error", handleWindowError), !didCall)
            return restoreAfterDispatch(), invokeGuardedCallbackProd.apply(this, arguments);
        };
      }
      var invokeGuardedCallbackImpl$1 = invokeGuardedCallbackImpl, hasError = !1, caughtError = null, hasRethrowError = !1, rethrowError = null, reporter = {
        onError: function(error2) {
          hasError = !0, caughtError = error2;
        }
      };
      function invokeGuardedCallback(name, func, context, a, b, c, d, e, f) {
        hasError = !1, caughtError = null, invokeGuardedCallbackImpl$1.apply(reporter, arguments);
      }
      function invokeGuardedCallbackAndCatchFirstError(name, func, context, a, b, c, d, e, f) {
        if (invokeGuardedCallback.apply(this, arguments), hasError) {
          var error2 = clearCaughtError();
          hasRethrowError || (hasRethrowError = !0, rethrowError = error2);
        }
      }
      function rethrowCaughtError() {
        if (hasRethrowError) {
          var error2 = rethrowError;
          throw hasRethrowError = !1, rethrowError = null, error2;
        }
      }
      function hasCaughtError() {
        return hasError;
      }
      function clearCaughtError() {
        if (hasError) {
          var error2 = caughtError;
          return hasError = !1, caughtError = null, error2;
        } else
          throw new Error("clearCaughtError was called but no error was captured. This error is likely caused by a bug in React. Please file an issue.");
      }
      function get2(key) {
        return key._reactInternals;
      }
      function has2(key) {
        return key._reactInternals !== void 0;
      }
      function set2(key, value) {
        key._reactInternals = value;
      }
      var NoFlags = (
        /*                      */
        0
      ), PerformedWork = (
        /*                */
        1
      ), Placement = (
        /*                    */
        2
      ), Update = (
        /*                       */
        4
      ), ChildDeletion = (
        /*                */
        16
      ), ContentReset = (
        /*                 */
        32
      ), Callback = (
        /*                     */
        64
      ), DidCapture = (
        /*                   */
        128
      ), ForceClientRender = (
        /*            */
        256
      ), Ref = (
        /*                          */
        512
      ), Snapshot = (
        /*                     */
        1024
      ), Passive = (
        /*                      */
        2048
      ), Hydrating = (
        /*                    */
        4096
      ), Visibility = (
        /*                   */
        8192
      ), StoreConsistency = (
        /*             */
        16384
      ), LifecycleEffectMask = Passive | Update | Callback | Ref | Snapshot | StoreConsistency, HostEffectMask = (
        /*               */
        32767
      ), Incomplete = (
        /*                   */
        32768
      ), ShouldCapture = (
        /*                */
        65536
      ), ForceUpdateForLegacySuspense = (
        /* */
        131072
      ), Forked = (
        /*                       */
        1048576
      ), RefStatic = (
        /*                    */
        2097152
      ), LayoutStatic = (
        /*                 */
        4194304
      ), PassiveStatic = (
        /*                */
        8388608
      ), MountLayoutDev = (
        /*               */
        16777216
      ), MountPassiveDev = (
        /*              */
        33554432
      ), BeforeMutationMask = (
        // TODO: Remove Update flag from before mutation phase by re-landing Visibility
        // flag logic (see #20043)
        Update | Snapshot | 0
      ), MutationMask = Placement | Update | ChildDeletion | ContentReset | Ref | Hydrating | Visibility, LayoutMask = Update | Callback | Ref | Visibility, PassiveMask = Passive | ChildDeletion, StaticMask = LayoutStatic | PassiveStatic | RefStatic, ReactCurrentOwner = ReactSharedInternals.ReactCurrentOwner;
      function getNearestMountedFiber(fiber) {
        var node = fiber, nearestMounted = fiber;
        if (fiber.alternate)
          for (; node.return; )
            node = node.return;
        else {
          var nextNode = node;
          do
            node = nextNode, (node.flags & (Placement | Hydrating)) !== NoFlags && (nearestMounted = node.return), nextNode = node.return;
          while (nextNode);
        }
        return node.tag === HostRoot ? nearestMounted : null;
      }
      function getSuspenseInstanceFromFiber(fiber) {
        if (fiber.tag === SuspenseComponent) {
          var suspenseState = fiber.memoizedState;
          if (suspenseState === null) {
            var current2 = fiber.alternate;
            current2 !== null && (suspenseState = current2.memoizedState);
          }
          if (suspenseState !== null)
            return suspenseState.dehydrated;
        }
        return null;
      }
      function getContainerFromFiber(fiber) {
        return fiber.tag === HostRoot ? fiber.stateNode.containerInfo : null;
      }
      function isFiberMounted(fiber) {
        return getNearestMountedFiber(fiber) === fiber;
      }
      function isMounted(component) {
        {
          var owner = ReactCurrentOwner.current;
          if (owner !== null && owner.tag === ClassComponent) {
            var ownerFiber = owner, instance = ownerFiber.stateNode;
            instance._warnedAboutRefsInRender || error("%s is accessing isMounted inside its render() function. render() should be a pure function of props and state. It should never access something that requires stale data from the previous render, such as refs. Move this logic to componentDidMount and componentDidUpdate instead.", getComponentNameFromFiber(ownerFiber) || "A component"), instance._warnedAboutRefsInRender = !0;
          }
        }
        var fiber = get2(component);
        return fiber ? getNearestMountedFiber(fiber) === fiber : !1;
      }
      function assertIsMounted(fiber) {
        if (getNearestMountedFiber(fiber) !== fiber)
          throw new Error("Unable to find node on an unmounted component.");
      }
      function findCurrentFiberUsingSlowPath(fiber) {
        var alternate = fiber.alternate;
        if (!alternate) {
          var nearestMounted = getNearestMountedFiber(fiber);
          if (nearestMounted === null)
            throw new Error("Unable to find node on an unmounted component.");
          return nearestMounted !== fiber ? null : fiber;
        }
        for (var a = fiber, b = alternate; ; ) {
          var parentA = a.return;
          if (parentA === null)
            break;
          var parentB = parentA.alternate;
          if (parentB === null) {
            var nextParent = parentA.return;
            if (nextParent !== null) {
              a = b = nextParent;
              continue;
            }
            break;
          }
          if (parentA.child === parentB.child) {
            for (var child = parentA.child; child; ) {
              if (child === a)
                return assertIsMounted(parentA), fiber;
              if (child === b)
                return assertIsMounted(parentA), alternate;
              child = child.sibling;
            }
            throw new Error("Unable to find node on an unmounted component.");
          }
          if (a.return !== b.return)
            a = parentA, b = parentB;
          else {
            for (var didFindChild = !1, _child = parentA.child; _child; ) {
              if (_child === a) {
                didFindChild = !0, a = parentA, b = parentB;
                break;
              }
              if (_child === b) {
                didFindChild = !0, b = parentA, a = parentB;
                break;
              }
              _child = _child.sibling;
            }
            if (!didFindChild) {
              for (_child = parentB.child; _child; ) {
                if (_child === a) {
                  didFindChild = !0, a = parentB, b = parentA;
                  break;
                }
                if (_child === b) {
                  didFindChild = !0, b = parentB, a = parentA;
                  break;
                }
                _child = _child.sibling;
              }
              if (!didFindChild)
                throw new Error("Child was not found in either parent set. This indicates a bug in React related to the return pointer. Please file an issue.");
            }
          }
          if (a.alternate !== b)
            throw new Error("Return fibers should always be each others' alternates. This error is likely caused by a bug in React. Please file an issue.");
        }
        if (a.tag !== HostRoot)
          throw new Error("Unable to find node on an unmounted component.");
        return a.stateNode.current === a ? fiber : alternate;
      }
      function findCurrentHostFiber(parent) {
        var currentParent = findCurrentFiberUsingSlowPath(parent);
        return currentParent !== null ? findCurrentHostFiberImpl(currentParent) : null;
      }
      function findCurrentHostFiberImpl(node) {
        if (node.tag === HostComponent || node.tag === HostText)
          return node;
        for (var child = node.child; child !== null; ) {
          var match2 = findCurrentHostFiberImpl(child);
          if (match2 !== null)
            return match2;
          child = child.sibling;
        }
        return null;
      }
      function findCurrentHostFiberWithNoPortals(parent) {
        var currentParent = findCurrentFiberUsingSlowPath(parent);
        return currentParent !== null ? findCurrentHostFiberWithNoPortalsImpl(currentParent) : null;
      }
      function findCurrentHostFiberWithNoPortalsImpl(node) {
        if (node.tag === HostComponent || node.tag === HostText)
          return node;
        for (var child = node.child; child !== null; ) {
          if (child.tag !== HostPortal) {
            var match2 = findCurrentHostFiberWithNoPortalsImpl(child);
            if (match2 !== null)
              return match2;
          }
          child = child.sibling;
        }
        return null;
      }
      var scheduleCallback = Scheduler.unstable_scheduleCallback, cancelCallback = Scheduler.unstable_cancelCallback, shouldYield = Scheduler.unstable_shouldYield, requestPaint = Scheduler.unstable_requestPaint, now = Scheduler.unstable_now, getCurrentPriorityLevel = Scheduler.unstable_getCurrentPriorityLevel, ImmediatePriority = Scheduler.unstable_ImmediatePriority, UserBlockingPriority = Scheduler.unstable_UserBlockingPriority, NormalPriority = Scheduler.unstable_NormalPriority, LowPriority = Scheduler.unstable_LowPriority, IdlePriority = Scheduler.unstable_IdlePriority, unstable_yieldValue = Scheduler.unstable_yieldValue, unstable_setDisableYieldValue = Scheduler.unstable_setDisableYieldValue, rendererID = null, injectedHook = null, injectedProfilingHooks = null, hasLoggedError = !1, isDevToolsPresent = typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ < "u";
      function injectInternals(internals) {
        if (typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ > "u")
          return !1;
        var hook2 = __REACT_DEVTOOLS_GLOBAL_HOOK__;
        if (hook2.isDisabled)
          return !0;
        if (!hook2.supportsFiber)
          return error("The installed version of React DevTools is too old and will not work with the current version of React. Please update React DevTools. https://reactjs.org/link/react-devtools"), !0;
        try {
          enableSchedulingProfiler && (internals = assign({}, internals, {
            getLaneLabelMap,
            injectProfilingHooks
          })), rendererID = hook2.inject(internals), injectedHook = hook2;
        } catch (err2) {
          error("React instrumentation encountered an error: %s.", err2);
        }
        return !!hook2.checkDCE;
      }
      function onScheduleRoot(root2, children) {
        if (injectedHook && typeof injectedHook.onScheduleFiberRoot == "function")
          try {
            injectedHook.onScheduleFiberRoot(rendererID, root2, children);
          } catch (err2) {
            hasLoggedError || (hasLoggedError = !0, error("React instrumentation encountered an error: %s", err2));
          }
      }
      function onCommitRoot(root2, eventPriority) {
        if (injectedHook && typeof injectedHook.onCommitFiberRoot == "function")
          try {
            var didError = (root2.current.flags & DidCapture) === DidCapture;
            if (enableProfilerTimer) {
              var schedulerPriority;
              switch (eventPriority) {
                case DiscreteEventPriority:
                  schedulerPriority = ImmediatePriority;
                  break;
                case ContinuousEventPriority:
                  schedulerPriority = UserBlockingPriority;
                  break;
                case DefaultEventPriority:
                  schedulerPriority = NormalPriority;
                  break;
                case IdleEventPriority:
                  schedulerPriority = IdlePriority;
                  break;
                default:
                  schedulerPriority = NormalPriority;
                  break;
              }
              injectedHook.onCommitFiberRoot(rendererID, root2, schedulerPriority, didError);
            } else
              injectedHook.onCommitFiberRoot(rendererID, root2, void 0, didError);
          } catch (err2) {
            hasLoggedError || (hasLoggedError = !0, error("React instrumentation encountered an error: %s", err2));
          }
      }
      function onPostCommitRoot(root2) {
        if (injectedHook && typeof injectedHook.onPostCommitFiberRoot == "function")
          try {
            injectedHook.onPostCommitFiberRoot(rendererID, root2);
          } catch (err2) {
            hasLoggedError || (hasLoggedError = !0, error("React instrumentation encountered an error: %s", err2));
          }
      }
      function onCommitUnmount(fiber) {
        if (injectedHook && typeof injectedHook.onCommitFiberUnmount == "function")
          try {
            injectedHook.onCommitFiberUnmount(rendererID, fiber);
          } catch (err2) {
            hasLoggedError || (hasLoggedError = !0, error("React instrumentation encountered an error: %s", err2));
          }
      }
      function setIsStrictModeForDevtools(newIsStrictMode) {
        if (typeof unstable_yieldValue == "function" && (unstable_setDisableYieldValue(newIsStrictMode), setSuppressWarning(newIsStrictMode)), injectedHook && typeof injectedHook.setStrictMode == "function")
          try {
            injectedHook.setStrictMode(rendererID, newIsStrictMode);
          } catch (err2) {
            hasLoggedError || (hasLoggedError = !0, error("React instrumentation encountered an error: %s", err2));
          }
      }
      function injectProfilingHooks(profilingHooks) {
        injectedProfilingHooks = profilingHooks;
      }
      function getLaneLabelMap() {
        {
          for (var map = /* @__PURE__ */ new Map(), lane = 1, index2 = 0; index2 < TotalLanes; index2++) {
            var label = getLabelForLane(lane);
            map.set(lane, label), lane *= 2;
          }
          return map;
        }
      }
      function markCommitStarted(lanes) {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markCommitStarted == "function" && injectedProfilingHooks.markCommitStarted(lanes);
      }
      function markCommitStopped() {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markCommitStopped == "function" && injectedProfilingHooks.markCommitStopped();
      }
      function markComponentRenderStarted(fiber) {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentRenderStarted == "function" && injectedProfilingHooks.markComponentRenderStarted(fiber);
      }
      function markComponentRenderStopped() {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentRenderStopped == "function" && injectedProfilingHooks.markComponentRenderStopped();
      }
      function markComponentPassiveEffectMountStarted(fiber) {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentPassiveEffectMountStarted == "function" && injectedProfilingHooks.markComponentPassiveEffectMountStarted(fiber);
      }
      function markComponentPassiveEffectMountStopped() {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentPassiveEffectMountStopped == "function" && injectedProfilingHooks.markComponentPassiveEffectMountStopped();
      }
      function markComponentPassiveEffectUnmountStarted(fiber) {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentPassiveEffectUnmountStarted == "function" && injectedProfilingHooks.markComponentPassiveEffectUnmountStarted(fiber);
      }
      function markComponentPassiveEffectUnmountStopped() {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentPassiveEffectUnmountStopped == "function" && injectedProfilingHooks.markComponentPassiveEffectUnmountStopped();
      }
      function markComponentLayoutEffectMountStarted(fiber) {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentLayoutEffectMountStarted == "function" && injectedProfilingHooks.markComponentLayoutEffectMountStarted(fiber);
      }
      function markComponentLayoutEffectMountStopped() {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentLayoutEffectMountStopped == "function" && injectedProfilingHooks.markComponentLayoutEffectMountStopped();
      }
      function markComponentLayoutEffectUnmountStarted(fiber) {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentLayoutEffectUnmountStarted == "function" && injectedProfilingHooks.markComponentLayoutEffectUnmountStarted(fiber);
      }
      function markComponentLayoutEffectUnmountStopped() {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentLayoutEffectUnmountStopped == "function" && injectedProfilingHooks.markComponentLayoutEffectUnmountStopped();
      }
      function markComponentErrored(fiber, thrownValue, lanes) {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentErrored == "function" && injectedProfilingHooks.markComponentErrored(fiber, thrownValue, lanes);
      }
      function markComponentSuspended(fiber, wakeable, lanes) {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markComponentSuspended == "function" && injectedProfilingHooks.markComponentSuspended(fiber, wakeable, lanes);
      }
      function markLayoutEffectsStarted(lanes) {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markLayoutEffectsStarted == "function" && injectedProfilingHooks.markLayoutEffectsStarted(lanes);
      }
      function markLayoutEffectsStopped() {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markLayoutEffectsStopped == "function" && injectedProfilingHooks.markLayoutEffectsStopped();
      }
      function markPassiveEffectsStarted(lanes) {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markPassiveEffectsStarted == "function" && injectedProfilingHooks.markPassiveEffectsStarted(lanes);
      }
      function markPassiveEffectsStopped() {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markPassiveEffectsStopped == "function" && injectedProfilingHooks.markPassiveEffectsStopped();
      }
      function markRenderStarted(lanes) {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markRenderStarted == "function" && injectedProfilingHooks.markRenderStarted(lanes);
      }
      function markRenderYielded() {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markRenderYielded == "function" && injectedProfilingHooks.markRenderYielded();
      }
      function markRenderStopped() {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markRenderStopped == "function" && injectedProfilingHooks.markRenderStopped();
      }
      function markRenderScheduled(lane) {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markRenderScheduled == "function" && injectedProfilingHooks.markRenderScheduled(lane);
      }
      function markForceUpdateScheduled(fiber, lane) {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markForceUpdateScheduled == "function" && injectedProfilingHooks.markForceUpdateScheduled(fiber, lane);
      }
      function markStateUpdateScheduled(fiber, lane) {
        injectedProfilingHooks !== null && typeof injectedProfilingHooks.markStateUpdateScheduled == "function" && injectedProfilingHooks.markStateUpdateScheduled(fiber, lane);
      }
      var NoMode = (
        /*                         */
        0
      ), ConcurrentMode = (
        /*                 */
        1
      ), ProfileMode = (
        /*                    */
        2
      ), StrictLegacyMode = (
        /*               */
        8
      ), StrictEffectsMode = (
        /*              */
        16
      ), clz32 = Math.clz32 ? Math.clz32 : clz32Fallback, log = Math.log, LN2 = Math.LN2;
      function clz32Fallback(x) {
        var asUint = x >>> 0;
        return asUint === 0 ? 32 : 31 - (log(asUint) / LN2 | 0) | 0;
      }
      var TotalLanes = 31, NoLanes = (
        /*                        */
        0
      ), NoLane = (
        /*                          */
        0
      ), SyncLane = (
        /*                        */
        1
      ), InputContinuousHydrationLane = (
        /*    */
        2
      ), InputContinuousLane = (
        /*             */
        4
      ), DefaultHydrationLane = (
        /*            */
        8
      ), DefaultLane = (
        /*                     */
        16
      ), TransitionHydrationLane = (
        /*                */
        32
      ), TransitionLanes = (
        /*                       */
        4194240
      ), TransitionLane1 = (
        /*                        */
        64
      ), TransitionLane2 = (
        /*                        */
        128
      ), TransitionLane3 = (
        /*                        */
        256
      ), TransitionLane4 = (
        /*                        */
        512
      ), TransitionLane5 = (
        /*                        */
        1024
      ), TransitionLane6 = (
        /*                        */
        2048
      ), TransitionLane7 = (
        /*                        */
        4096
      ), TransitionLane8 = (
        /*                        */
        8192
      ), TransitionLane9 = (
        /*                        */
        16384
      ), TransitionLane10 = (
        /*                       */
        32768
      ), TransitionLane11 = (
        /*                       */
        65536
      ), TransitionLane12 = (
        /*                       */
        131072
      ), TransitionLane13 = (
        /*                       */
        262144
      ), TransitionLane14 = (
        /*                       */
        524288
      ), TransitionLane15 = (
        /*                       */
        1048576
      ), TransitionLane16 = (
        /*                       */
        2097152
      ), RetryLanes = (
        /*                            */
        130023424
      ), RetryLane1 = (
        /*                             */
        4194304
      ), RetryLane2 = (
        /*                             */
        8388608
      ), RetryLane3 = (
        /*                             */
        16777216
      ), RetryLane4 = (
        /*                             */
        33554432
      ), RetryLane5 = (
        /*                             */
        67108864
      ), SomeRetryLane = RetryLane1, SelectiveHydrationLane = (
        /*          */
        134217728
      ), NonIdleLanes = (
        /*                          */
        268435455
      ), IdleHydrationLane = (
        /*               */
        268435456
      ), IdleLane = (
        /*                        */
        536870912
      ), OffscreenLane = (
        /*                   */
        1073741824
      );
      function getLabelForLane(lane) {
        {
          if (lane & SyncLane)
            return "Sync";
          if (lane & InputContinuousHydrationLane)
            return "InputContinuousHydration";
          if (lane & InputContinuousLane)
            return "InputContinuous";
          if (lane & DefaultHydrationLane)
            return "DefaultHydration";
          if (lane & DefaultLane)
            return "Default";
          if (lane & TransitionHydrationLane)
            return "TransitionHydration";
          if (lane & TransitionLanes)
            return "Transition";
          if (lane & RetryLanes)
            return "Retry";
          if (lane & SelectiveHydrationLane)
            return "SelectiveHydration";
          if (lane & IdleHydrationLane)
            return "IdleHydration";
          if (lane & IdleLane)
            return "Idle";
          if (lane & OffscreenLane)
            return "Offscreen";
        }
      }
      var NoTimestamp = -1, nextTransitionLane = TransitionLane1, nextRetryLane = RetryLane1;
      function getHighestPriorityLanes(lanes) {
        switch (getHighestPriorityLane(lanes)) {
          case SyncLane:
            return SyncLane;
          case InputContinuousHydrationLane:
            return InputContinuousHydrationLane;
          case InputContinuousLane:
            return InputContinuousLane;
          case DefaultHydrationLane:
            return DefaultHydrationLane;
          case DefaultLane:
            return DefaultLane;
          case TransitionHydrationLane:
            return TransitionHydrationLane;
          case TransitionLane1:
          case TransitionLane2:
          case TransitionLane3:
          case TransitionLane4:
          case TransitionLane5:
          case TransitionLane6:
          case TransitionLane7:
          case TransitionLane8:
          case TransitionLane9:
          case TransitionLane10:
          case TransitionLane11:
          case TransitionLane12:
          case TransitionLane13:
          case TransitionLane14:
          case TransitionLane15:
          case TransitionLane16:
            return lanes & TransitionLanes;
          case RetryLane1:
          case RetryLane2:
          case RetryLane3:
          case RetryLane4:
          case RetryLane5:
            return lanes & RetryLanes;
          case SelectiveHydrationLane:
            return SelectiveHydrationLane;
          case IdleHydrationLane:
            return IdleHydrationLane;
          case IdleLane:
            return IdleLane;
          case OffscreenLane:
            return OffscreenLane;
          default:
            return error("Should have found matching lanes. This is a bug in React."), lanes;
        }
      }
      function getNextLanes(root2, wipLanes) {
        var pendingLanes = root2.pendingLanes;
        if (pendingLanes === NoLanes)
          return NoLanes;
        var nextLanes = NoLanes, suspendedLanes = root2.suspendedLanes, pingedLanes = root2.pingedLanes, nonIdlePendingLanes = pendingLanes & NonIdleLanes;
        if (nonIdlePendingLanes !== NoLanes) {
          var nonIdleUnblockedLanes = nonIdlePendingLanes & ~suspendedLanes;
          if (nonIdleUnblockedLanes !== NoLanes)
            nextLanes = getHighestPriorityLanes(nonIdleUnblockedLanes);
          else {
            var nonIdlePingedLanes = nonIdlePendingLanes & pingedLanes;
            nonIdlePingedLanes !== NoLanes && (nextLanes = getHighestPriorityLanes(nonIdlePingedLanes));
          }
        } else {
          var unblockedLanes = pendingLanes & ~suspendedLanes;
          unblockedLanes !== NoLanes ? nextLanes = getHighestPriorityLanes(unblockedLanes) : pingedLanes !== NoLanes && (nextLanes = getHighestPriorityLanes(pingedLanes));
        }
        if (nextLanes === NoLanes)
          return NoLanes;
        if (wipLanes !== NoLanes && wipLanes !== nextLanes && // If we already suspended with a delay, then interrupting is fine. Don't
        // bother waiting until the root is complete.
        (wipLanes & suspendedLanes) === NoLanes) {
          var nextLane = getHighestPriorityLane(nextLanes), wipLane = getHighestPriorityLane(wipLanes);
          if (
            // Tests whether the next lane is equal or lower priority than the wip
            // one. This works because the bits decrease in priority as you go left.
            nextLane >= wipLane || // Default priority updates should not interrupt transition updates. The
            // only difference between default updates and transition updates is that
            // default updates do not support refresh transitions.
            nextLane === DefaultLane && (wipLane & TransitionLanes) !== NoLanes
          )
            return wipLanes;
        }
        (nextLanes & InputContinuousLane) !== NoLanes && (nextLanes |= pendingLanes & DefaultLane);
        var entangledLanes = root2.entangledLanes;
        if (entangledLanes !== NoLanes)
          for (var entanglements = root2.entanglements, lanes = nextLanes & entangledLanes; lanes > 0; ) {
            var index2 = pickArbitraryLaneIndex(lanes), lane = 1 << index2;
            nextLanes |= entanglements[index2], lanes &= ~lane;
          }
        return nextLanes;
      }
      function getMostRecentEventTime(root2, lanes) {
        for (var eventTimes = root2.eventTimes, mostRecentEventTime = NoTimestamp; lanes > 0; ) {
          var index2 = pickArbitraryLaneIndex(lanes), lane = 1 << index2, eventTime = eventTimes[index2];
          eventTime > mostRecentEventTime && (mostRecentEventTime = eventTime), lanes &= ~lane;
        }
        return mostRecentEventTime;
      }
      function computeExpirationTime(lane, currentTime) {
        switch (lane) {
          case SyncLane:
          case InputContinuousHydrationLane:
          case InputContinuousLane:
            return currentTime + 250;
          case DefaultHydrationLane:
          case DefaultLane:
          case TransitionHydrationLane:
          case TransitionLane1:
          case TransitionLane2:
          case TransitionLane3:
          case TransitionLane4:
          case TransitionLane5:
          case TransitionLane6:
          case TransitionLane7:
          case TransitionLane8:
          case TransitionLane9:
          case TransitionLane10:
          case TransitionLane11:
          case TransitionLane12:
          case TransitionLane13:
          case TransitionLane14:
          case TransitionLane15:
          case TransitionLane16:
            return currentTime + 5e3;
          case RetryLane1:
          case RetryLane2:
          case RetryLane3:
          case RetryLane4:
          case RetryLane5:
            return NoTimestamp;
          case SelectiveHydrationLane:
          case IdleHydrationLane:
          case IdleLane:
          case OffscreenLane:
            return NoTimestamp;
          default:
            return error("Should have found matching lanes. This is a bug in React."), NoTimestamp;
        }
      }
      function markStarvedLanesAsExpired(root2, currentTime) {
        for (var pendingLanes = root2.pendingLanes, suspendedLanes = root2.suspendedLanes, pingedLanes = root2.pingedLanes, expirationTimes = root2.expirationTimes, lanes = pendingLanes; lanes > 0; ) {
          var index2 = pickArbitraryLaneIndex(lanes), lane = 1 << index2, expirationTime = expirationTimes[index2];
          expirationTime === NoTimestamp ? ((lane & suspendedLanes) === NoLanes || (lane & pingedLanes) !== NoLanes) && (expirationTimes[index2] = computeExpirationTime(lane, currentTime)) : expirationTime <= currentTime && (root2.expiredLanes |= lane), lanes &= ~lane;
        }
      }
      function getHighestPriorityPendingLanes(root2) {
        return getHighestPriorityLanes(root2.pendingLanes);
      }
      function getLanesToRetrySynchronouslyOnError(root2) {
        var everythingButOffscreen = root2.pendingLanes & ~OffscreenLane;
        return everythingButOffscreen !== NoLanes ? everythingButOffscreen : everythingButOffscreen & OffscreenLane ? OffscreenLane : NoLanes;
      }
      function includesSyncLane(lanes) {
        return (lanes & SyncLane) !== NoLanes;
      }
      function includesNonIdleWork(lanes) {
        return (lanes & NonIdleLanes) !== NoLanes;
      }
      function includesOnlyRetries(lanes) {
        return (lanes & RetryLanes) === lanes;
      }
      function includesOnlyNonUrgentLanes(lanes) {
        var UrgentLanes = SyncLane | InputContinuousLane | DefaultLane;
        return (lanes & UrgentLanes) === NoLanes;
      }
      function includesOnlyTransitions(lanes) {
        return (lanes & TransitionLanes) === lanes;
      }
      function includesBlockingLane(root2, lanes) {
        var SyncDefaultLanes = InputContinuousHydrationLane | InputContinuousLane | DefaultHydrationLane | DefaultLane;
        return (lanes & SyncDefaultLanes) !== NoLanes;
      }
      function includesExpiredLane(root2, lanes) {
        return (lanes & root2.expiredLanes) !== NoLanes;
      }
      function isTransitionLane(lane) {
        return (lane & TransitionLanes) !== NoLanes;
      }
      function claimNextTransitionLane() {
        var lane = nextTransitionLane;
        return nextTransitionLane <<= 1, (nextTransitionLane & TransitionLanes) === NoLanes && (nextTransitionLane = TransitionLane1), lane;
      }
      function claimNextRetryLane() {
        var lane = nextRetryLane;
        return nextRetryLane <<= 1, (nextRetryLane & RetryLanes) === NoLanes && (nextRetryLane = RetryLane1), lane;
      }
      function getHighestPriorityLane(lanes) {
        return lanes & -lanes;
      }
      function pickArbitraryLane(lanes) {
        return getHighestPriorityLane(lanes);
      }
      function pickArbitraryLaneIndex(lanes) {
        return 31 - clz32(lanes);
      }
      function laneToIndex(lane) {
        return pickArbitraryLaneIndex(lane);
      }
      function includesSomeLane(a, b) {
        return (a & b) !== NoLanes;
      }
      function isSubsetOfLanes(set3, subset) {
        return (set3 & subset) === subset;
      }
      function mergeLanes(a, b) {
        return a | b;
      }
      function removeLanes(set3, subset) {
        return set3 & ~subset;
      }
      function intersectLanes(a, b) {
        return a & b;
      }
      function laneToLanes(lane) {
        return lane;
      }
      function higherPriorityLane(a, b) {
        return a !== NoLane && a < b ? a : b;
      }
      function createLaneMap(initial) {
        for (var laneMap = [], i = 0; i < TotalLanes; i++)
          laneMap.push(initial);
        return laneMap;
      }
      function markRootUpdated(root2, updateLane, eventTime) {
        root2.pendingLanes |= updateLane, updateLane !== IdleLane && (root2.suspendedLanes = NoLanes, root2.pingedLanes = NoLanes);
        var eventTimes = root2.eventTimes, index2 = laneToIndex(updateLane);
        eventTimes[index2] = eventTime;
      }
      function markRootSuspended(root2, suspendedLanes) {
        root2.suspendedLanes |= suspendedLanes, root2.pingedLanes &= ~suspendedLanes;
        for (var expirationTimes = root2.expirationTimes, lanes = suspendedLanes; lanes > 0; ) {
          var index2 = pickArbitraryLaneIndex(lanes), lane = 1 << index2;
          expirationTimes[index2] = NoTimestamp, lanes &= ~lane;
        }
      }
      function markRootPinged(root2, pingedLanes, eventTime) {
        root2.pingedLanes |= root2.suspendedLanes & pingedLanes;
      }
      function markRootFinished(root2, remainingLanes) {
        var noLongerPendingLanes = root2.pendingLanes & ~remainingLanes;
        root2.pendingLanes = remainingLanes, root2.suspendedLanes = NoLanes, root2.pingedLanes = NoLanes, root2.expiredLanes &= remainingLanes, root2.mutableReadLanes &= remainingLanes, root2.entangledLanes &= remainingLanes;
        for (var entanglements = root2.entanglements, eventTimes = root2.eventTimes, expirationTimes = root2.expirationTimes, lanes = noLongerPendingLanes; lanes > 0; ) {
          var index2 = pickArbitraryLaneIndex(lanes), lane = 1 << index2;
          entanglements[index2] = NoLanes, eventTimes[index2] = NoTimestamp, expirationTimes[index2] = NoTimestamp, lanes &= ~lane;
        }
      }
      function markRootEntangled(root2, entangledLanes) {
        for (var rootEntangledLanes = root2.entangledLanes |= entangledLanes, entanglements = root2.entanglements, lanes = rootEntangledLanes; lanes; ) {
          var index2 = pickArbitraryLaneIndex(lanes), lane = 1 << index2;
          // Is this one of the newly entangled lanes?
          lane & entangledLanes | // Is this lane transitively entangled with the newly entangled lanes?
          entanglements[index2] & entangledLanes && (entanglements[index2] |= entangledLanes), lanes &= ~lane;
        }
      }
      function getBumpedLaneForHydration(root2, renderLanes2) {
        var renderLane = getHighestPriorityLane(renderLanes2), lane;
        switch (renderLane) {
          case InputContinuousLane:
            lane = InputContinuousHydrationLane;
            break;
          case DefaultLane:
            lane = DefaultHydrationLane;
            break;
          case TransitionLane1:
          case TransitionLane2:
          case TransitionLane3:
          case TransitionLane4:
          case TransitionLane5:
          case TransitionLane6:
          case TransitionLane7:
          case TransitionLane8:
          case TransitionLane9:
          case TransitionLane10:
          case TransitionLane11:
          case TransitionLane12:
          case TransitionLane13:
          case TransitionLane14:
          case TransitionLane15:
          case TransitionLane16:
          case RetryLane1:
          case RetryLane2:
          case RetryLane3:
          case RetryLane4:
          case RetryLane5:
            lane = TransitionHydrationLane;
            break;
          case IdleLane:
            lane = IdleHydrationLane;
            break;
          default:
            lane = NoLane;
            break;
        }
        return (lane & (root2.suspendedLanes | renderLanes2)) !== NoLane ? NoLane : lane;
      }
      function addFiberToLanesMap(root2, fiber, lanes) {
        if (isDevToolsPresent)
          for (var pendingUpdatersLaneMap = root2.pendingUpdatersLaneMap; lanes > 0; ) {
            var index2 = laneToIndex(lanes), lane = 1 << index2, updaters = pendingUpdatersLaneMap[index2];
            updaters.add(fiber), lanes &= ~lane;
          }
      }
      function movePendingFibersToMemoized(root2, lanes) {
        if (isDevToolsPresent)
          for (var pendingUpdatersLaneMap = root2.pendingUpdatersLaneMap, memoizedUpdaters = root2.memoizedUpdaters; lanes > 0; ) {
            var index2 = laneToIndex(lanes), lane = 1 << index2, updaters = pendingUpdatersLaneMap[index2];
            updaters.size > 0 && (updaters.forEach(function(fiber) {
              var alternate = fiber.alternate;
              (alternate === null || !memoizedUpdaters.has(alternate)) && memoizedUpdaters.add(fiber);
            }), updaters.clear()), lanes &= ~lane;
          }
      }
      function getTransitionsForLanes(root2, lanes) {
        return null;
      }
      var DiscreteEventPriority = SyncLane, ContinuousEventPriority = InputContinuousLane, DefaultEventPriority = DefaultLane, IdleEventPriority = IdleLane, currentUpdatePriority = NoLane;
      function getCurrentUpdatePriority() {
        return currentUpdatePriority;
      }
      function setCurrentUpdatePriority(newPriority) {
        currentUpdatePriority = newPriority;
      }
      function runWithPriority(priority, fn) {
        var previousPriority = currentUpdatePriority;
        try {
          return currentUpdatePriority = priority, fn();
        } finally {
          currentUpdatePriority = previousPriority;
        }
      }
      function higherEventPriority(a, b) {
        return a !== 0 && a < b ? a : b;
      }
      function lowerEventPriority(a, b) {
        return a === 0 || a > b ? a : b;
      }
      function isHigherEventPriority(a, b) {
        return a !== 0 && a < b;
      }
      function lanesToEventPriority(lanes) {
        var lane = getHighestPriorityLane(lanes);
        return isHigherEventPriority(DiscreteEventPriority, lane) ? isHigherEventPriority(ContinuousEventPriority, lane) ? includesNonIdleWork(lane) ? DefaultEventPriority : IdleEventPriority : ContinuousEventPriority : DiscreteEventPriority;
      }
      function isRootDehydrated(root2) {
        var currentState = root2.current.memoizedState;
        return currentState.isDehydrated;
      }
      var _attemptSynchronousHydration;
      function setAttemptSynchronousHydration(fn) {
        _attemptSynchronousHydration = fn;
      }
      function attemptSynchronousHydration(fiber) {
        _attemptSynchronousHydration(fiber);
      }
      var attemptContinuousHydration;
      function setAttemptContinuousHydration(fn) {
        attemptContinuousHydration = fn;
      }
      var attemptHydrationAtCurrentPriority;
      function setAttemptHydrationAtCurrentPriority(fn) {
        attemptHydrationAtCurrentPriority = fn;
      }
      var getCurrentUpdatePriority$1;
      function setGetCurrentUpdatePriority(fn) {
        getCurrentUpdatePriority$1 = fn;
      }
      var attemptHydrationAtPriority;
      function setAttemptHydrationAtPriority(fn) {
        attemptHydrationAtPriority = fn;
      }
      var hasScheduledReplayAttempt = !1, queuedDiscreteEvents = [], queuedFocus = null, queuedDrag = null, queuedMouse = null, queuedPointers = /* @__PURE__ */ new Map(), queuedPointerCaptures = /* @__PURE__ */ new Map(), queuedExplicitHydrationTargets = [], discreteReplayableEvents = [
        "mousedown",
        "mouseup",
        "touchcancel",
        "touchend",
        "touchstart",
        "auxclick",
        "dblclick",
        "pointercancel",
        "pointerdown",
        "pointerup",
        "dragend",
        "dragstart",
        "drop",
        "compositionend",
        "compositionstart",
        "keydown",
        "keypress",
        "keyup",
        "input",
        "textInput",
        // Intentionally camelCase
        "copy",
        "cut",
        "paste",
        "click",
        "change",
        "contextmenu",
        "reset",
        "submit"
      ];
      function isDiscreteEventThatRequiresHydration(eventType) {
        return discreteReplayableEvents.indexOf(eventType) > -1;
      }
      function createQueuedReplayableEvent(blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent) {
        return {
          blockedOn,
          domEventName,
          eventSystemFlags,
          nativeEvent,
          targetContainers: [targetContainer]
        };
      }
      function clearIfContinuousEvent(domEventName, nativeEvent) {
        switch (domEventName) {
          case "focusin":
          case "focusout":
            queuedFocus = null;
            break;
          case "dragenter":
          case "dragleave":
            queuedDrag = null;
            break;
          case "mouseover":
          case "mouseout":
            queuedMouse = null;
            break;
          case "pointerover":
          case "pointerout": {
            var pointerId = nativeEvent.pointerId;
            queuedPointers.delete(pointerId);
            break;
          }
          case "gotpointercapture":
          case "lostpointercapture": {
            var _pointerId = nativeEvent.pointerId;
            queuedPointerCaptures.delete(_pointerId);
            break;
          }
        }
      }
      function accumulateOrCreateContinuousQueuedReplayableEvent(existingQueuedEvent, blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent) {
        if (existingQueuedEvent === null || existingQueuedEvent.nativeEvent !== nativeEvent) {
          var queuedEvent = createQueuedReplayableEvent(blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent);
          if (blockedOn !== null) {
            var _fiber2 = getInstanceFromNode(blockedOn);
            _fiber2 !== null && attemptContinuousHydration(_fiber2);
          }
          return queuedEvent;
        }
        existingQueuedEvent.eventSystemFlags |= eventSystemFlags;
        var targetContainers = existingQueuedEvent.targetContainers;
        return targetContainer !== null && targetContainers.indexOf(targetContainer) === -1 && targetContainers.push(targetContainer), existingQueuedEvent;
      }
      function queueIfContinuousEvent(blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent) {
        switch (domEventName) {
          case "focusin": {
            var focusEvent = nativeEvent;
            return queuedFocus = accumulateOrCreateContinuousQueuedReplayableEvent(queuedFocus, blockedOn, domEventName, eventSystemFlags, targetContainer, focusEvent), !0;
          }
          case "dragenter": {
            var dragEvent = nativeEvent;
            return queuedDrag = accumulateOrCreateContinuousQueuedReplayableEvent(queuedDrag, blockedOn, domEventName, eventSystemFlags, targetContainer, dragEvent), !0;
          }
          case "mouseover": {
            var mouseEvent = nativeEvent;
            return queuedMouse = accumulateOrCreateContinuousQueuedReplayableEvent(queuedMouse, blockedOn, domEventName, eventSystemFlags, targetContainer, mouseEvent), !0;
          }
          case "pointerover": {
            var pointerEvent = nativeEvent, pointerId = pointerEvent.pointerId;
            return queuedPointers.set(pointerId, accumulateOrCreateContinuousQueuedReplayableEvent(queuedPointers.get(pointerId) || null, blockedOn, domEventName, eventSystemFlags, targetContainer, pointerEvent)), !0;
          }
          case "gotpointercapture": {
            var _pointerEvent = nativeEvent, _pointerId2 = _pointerEvent.pointerId;
            return queuedPointerCaptures.set(_pointerId2, accumulateOrCreateContinuousQueuedReplayableEvent(queuedPointerCaptures.get(_pointerId2) || null, blockedOn, domEventName, eventSystemFlags, targetContainer, _pointerEvent)), !0;
          }
        }
        return !1;
      }
      function attemptExplicitHydrationTarget(queuedTarget) {
        var targetInst = getClosestInstanceFromNode(queuedTarget.target);
        if (targetInst !== null) {
          var nearestMounted = getNearestMountedFiber(targetInst);
          if (nearestMounted !== null) {
            var tag = nearestMounted.tag;
            if (tag === SuspenseComponent) {
              var instance = getSuspenseInstanceFromFiber(nearestMounted);
              if (instance !== null) {
                queuedTarget.blockedOn = instance, attemptHydrationAtPriority(queuedTarget.priority, function() {
                  attemptHydrationAtCurrentPriority(nearestMounted);
                });
                return;
              }
            } else if (tag === HostRoot) {
              var root2 = nearestMounted.stateNode;
              if (isRootDehydrated(root2)) {
                queuedTarget.blockedOn = getContainerFromFiber(nearestMounted);
                return;
              }
            }
          }
        }
        queuedTarget.blockedOn = null;
      }
      function queueExplicitHydrationTarget(target) {
        for (var updatePriority = getCurrentUpdatePriority$1(), queuedTarget = {
          blockedOn: null,
          target,
          priority: updatePriority
        }, i = 0; i < queuedExplicitHydrationTargets.length && isHigherEventPriority(updatePriority, queuedExplicitHydrationTargets[i].priority); i++)
          ;
        queuedExplicitHydrationTargets.splice(i, 0, queuedTarget), i === 0 && attemptExplicitHydrationTarget(queuedTarget);
      }
      function attemptReplayContinuousQueuedEvent(queuedEvent) {
        if (queuedEvent.blockedOn !== null)
          return !1;
        for (var targetContainers = queuedEvent.targetContainers; targetContainers.length > 0; ) {
          var targetContainer = targetContainers[0], nextBlockedOn = findInstanceBlockingEvent(queuedEvent.domEventName, queuedEvent.eventSystemFlags, targetContainer, queuedEvent.nativeEvent);
          if (nextBlockedOn === null) {
            var nativeEvent = queuedEvent.nativeEvent, nativeEventClone = new nativeEvent.constructor(nativeEvent.type, nativeEvent);
            setReplayingEvent(nativeEventClone), nativeEvent.target.dispatchEvent(nativeEventClone), resetReplayingEvent();
          } else {
            var _fiber3 = getInstanceFromNode(nextBlockedOn);
            return _fiber3 !== null && attemptContinuousHydration(_fiber3), queuedEvent.blockedOn = nextBlockedOn, !1;
          }
          targetContainers.shift();
        }
        return !0;
      }
      function attemptReplayContinuousQueuedEventInMap(queuedEvent, key, map) {
        attemptReplayContinuousQueuedEvent(queuedEvent) && map.delete(key);
      }
      function replayUnblockedEvents() {
        hasScheduledReplayAttempt = !1, queuedFocus !== null && attemptReplayContinuousQueuedEvent(queuedFocus) && (queuedFocus = null), queuedDrag !== null && attemptReplayContinuousQueuedEvent(queuedDrag) && (queuedDrag = null), queuedMouse !== null && attemptReplayContinuousQueuedEvent(queuedMouse) && (queuedMouse = null), queuedPointers.forEach(attemptReplayContinuousQueuedEventInMap), queuedPointerCaptures.forEach(attemptReplayContinuousQueuedEventInMap);
      }
      function scheduleCallbackIfUnblocked(queuedEvent, unblocked) {
        queuedEvent.blockedOn === unblocked && (queuedEvent.blockedOn = null, hasScheduledReplayAttempt || (hasScheduledReplayAttempt = !0, Scheduler.unstable_scheduleCallback(Scheduler.unstable_NormalPriority, replayUnblockedEvents)));
      }
      function retryIfBlockedOn(unblocked) {
        if (queuedDiscreteEvents.length > 0) {
          scheduleCallbackIfUnblocked(queuedDiscreteEvents[0], unblocked);
          for (var i = 1; i < queuedDiscreteEvents.length; i++) {
            var queuedEvent = queuedDiscreteEvents[i];
            queuedEvent.blockedOn === unblocked && (queuedEvent.blockedOn = null);
          }
        }
        queuedFocus !== null && scheduleCallbackIfUnblocked(queuedFocus, unblocked), queuedDrag !== null && scheduleCallbackIfUnblocked(queuedDrag, unblocked), queuedMouse !== null && scheduleCallbackIfUnblocked(queuedMouse, unblocked);
        var unblock = function(queuedEvent2) {
          return scheduleCallbackIfUnblocked(queuedEvent2, unblocked);
        };
        queuedPointers.forEach(unblock), queuedPointerCaptures.forEach(unblock);
        for (var _i = 0; _i < queuedExplicitHydrationTargets.length; _i++) {
          var queuedTarget = queuedExplicitHydrationTargets[_i];
          queuedTarget.blockedOn === unblocked && (queuedTarget.blockedOn = null);
        }
        for (; queuedExplicitHydrationTargets.length > 0; ) {
          var nextExplicitTarget = queuedExplicitHydrationTargets[0];
          if (nextExplicitTarget.blockedOn !== null)
            break;
          attemptExplicitHydrationTarget(nextExplicitTarget), nextExplicitTarget.blockedOn === null && queuedExplicitHydrationTargets.shift();
        }
      }
      var ReactCurrentBatchConfig = ReactSharedInternals.ReactCurrentBatchConfig, _enabled = !0;
      function setEnabled(enabled) {
        _enabled = !!enabled;
      }
      function isEnabled() {
        return _enabled;
      }
      function createEventListenerWrapperWithPriority(targetContainer, domEventName, eventSystemFlags) {
        var eventPriority = getEventPriority(domEventName), listenerWrapper;
        switch (eventPriority) {
          case DiscreteEventPriority:
            listenerWrapper = dispatchDiscreteEvent;
            break;
          case ContinuousEventPriority:
            listenerWrapper = dispatchContinuousEvent;
            break;
          case DefaultEventPriority:
          default:
            listenerWrapper = dispatchEvent;
            break;
        }
        return listenerWrapper.bind(null, domEventName, eventSystemFlags, targetContainer);
      }
      function dispatchDiscreteEvent(domEventName, eventSystemFlags, container, nativeEvent) {
        var previousPriority = getCurrentUpdatePriority(), prevTransition = ReactCurrentBatchConfig.transition;
        ReactCurrentBatchConfig.transition = null;
        try {
          setCurrentUpdatePriority(DiscreteEventPriority), dispatchEvent(domEventName, eventSystemFlags, container, nativeEvent);
        } finally {
          setCurrentUpdatePriority(previousPriority), ReactCurrentBatchConfig.transition = prevTransition;
        }
      }
      function dispatchContinuousEvent(domEventName, eventSystemFlags, container, nativeEvent) {
        var previousPriority = getCurrentUpdatePriority(), prevTransition = ReactCurrentBatchConfig.transition;
        ReactCurrentBatchConfig.transition = null;
        try {
          setCurrentUpdatePriority(ContinuousEventPriority), dispatchEvent(domEventName, eventSystemFlags, container, nativeEvent);
        } finally {
          setCurrentUpdatePriority(previousPriority), ReactCurrentBatchConfig.transition = prevTransition;
        }
      }
      function dispatchEvent(domEventName, eventSystemFlags, targetContainer, nativeEvent) {
        _enabled && dispatchEventWithEnableCapturePhaseSelectiveHydrationWithoutDiscreteEventReplay(domEventName, eventSystemFlags, targetContainer, nativeEvent);
      }
      function dispatchEventWithEnableCapturePhaseSelectiveHydrationWithoutDiscreteEventReplay(domEventName, eventSystemFlags, targetContainer, nativeEvent) {
        var blockedOn = findInstanceBlockingEvent(domEventName, eventSystemFlags, targetContainer, nativeEvent);
        if (blockedOn === null) {
          dispatchEventForPluginEventSystem(domEventName, eventSystemFlags, nativeEvent, return_targetInst, targetContainer), clearIfContinuousEvent(domEventName, nativeEvent);
          return;
        }
        if (queueIfContinuousEvent(blockedOn, domEventName, eventSystemFlags, targetContainer, nativeEvent)) {
          nativeEvent.stopPropagation();
          return;
        }
        if (clearIfContinuousEvent(domEventName, nativeEvent), eventSystemFlags & IS_CAPTURE_PHASE && isDiscreteEventThatRequiresHydration(domEventName)) {
          for (; blockedOn !== null; ) {
            var fiber = getInstanceFromNode(blockedOn);
            fiber !== null && attemptSynchronousHydration(fiber);
            var nextBlockedOn = findInstanceBlockingEvent(domEventName, eventSystemFlags, targetContainer, nativeEvent);
            if (nextBlockedOn === null && dispatchEventForPluginEventSystem(domEventName, eventSystemFlags, nativeEvent, return_targetInst, targetContainer), nextBlockedOn === blockedOn)
              break;
            blockedOn = nextBlockedOn;
          }
          blockedOn !== null && nativeEvent.stopPropagation();
          return;
        }
        dispatchEventForPluginEventSystem(domEventName, eventSystemFlags, nativeEvent, null, targetContainer);
      }
      var return_targetInst = null;
      function findInstanceBlockingEvent(domEventName, eventSystemFlags, targetContainer, nativeEvent) {
        return_targetInst = null;
        var nativeEventTarget = getEventTarget(nativeEvent), targetInst = getClosestInstanceFromNode(nativeEventTarget);
        if (targetInst !== null) {
          var nearestMounted = getNearestMountedFiber(targetInst);
          if (nearestMounted === null)
            targetInst = null;
          else {
            var tag = nearestMounted.tag;
            if (tag === SuspenseComponent) {
              var instance = getSuspenseInstanceFromFiber(nearestMounted);
              if (instance !== null)
                return instance;
              targetInst = null;
            } else if (tag === HostRoot) {
              var root2 = nearestMounted.stateNode;
              if (isRootDehydrated(root2))
                return getContainerFromFiber(nearestMounted);
              targetInst = null;
            } else
              nearestMounted !== targetInst && (targetInst = null);
          }
        }
        return return_targetInst = targetInst, null;
      }
      function getEventPriority(domEventName) {
        switch (domEventName) {
          case "cancel":
          case "click":
          case "close":
          case "contextmenu":
          case "copy":
          case "cut":
          case "auxclick":
          case "dblclick":
          case "dragend":
          case "dragstart":
          case "drop":
          case "focusin":
          case "focusout":
          case "input":
          case "invalid":
          case "keydown":
          case "keypress":
          case "keyup":
          case "mousedown":
          case "mouseup":
          case "paste":
          case "pause":
          case "play":
          case "pointercancel":
          case "pointerdown":
          case "pointerup":
          case "ratechange":
          case "reset":
          case "resize":
          case "seeked":
          case "submit":
          case "touchcancel":
          case "touchend":
          case "touchstart":
          case "volumechange":
          case "change":
          case "selectionchange":
          case "textInput":
          case "compositionstart":
          case "compositionend":
          case "compositionupdate":
          case "beforeblur":
          case "afterblur":
          case "beforeinput":
          case "blur":
          case "fullscreenchange":
          case "focus":
          case "hashchange":
          case "popstate":
          case "select":
          case "selectstart":
            return DiscreteEventPriority;
          case "drag":
          case "dragenter":
          case "dragexit":
          case "dragleave":
          case "dragover":
          case "mousemove":
          case "mouseout":
          case "mouseover":
          case "pointermove":
          case "pointerout":
          case "pointerover":
          case "scroll":
          case "toggle":
          case "touchmove":
          case "wheel":
          case "mouseenter":
          case "mouseleave":
          case "pointerenter":
          case "pointerleave":
            return ContinuousEventPriority;
          case "message": {
            var schedulerPriority = getCurrentPriorityLevel();
            switch (schedulerPriority) {
              case ImmediatePriority:
                return DiscreteEventPriority;
              case UserBlockingPriority:
                return ContinuousEventPriority;
              case NormalPriority:
              case LowPriority:
                return DefaultEventPriority;
              case IdlePriority:
                return IdleEventPriority;
              default:
                return DefaultEventPriority;
            }
          }
          default:
            return DefaultEventPriority;
        }
      }
      function addEventBubbleListener(target, eventType, listener) {
        return target.addEventListener(eventType, listener, !1), listener;
      }
      function addEventCaptureListener(target, eventType, listener) {
        return target.addEventListener(eventType, listener, !0), listener;
      }
      function addEventCaptureListenerWithPassiveFlag(target, eventType, listener, passive) {
        return target.addEventListener(eventType, listener, {
          capture: !0,
          passive
        }), listener;
      }
      function addEventBubbleListenerWithPassiveFlag(target, eventType, listener, passive) {
        return target.addEventListener(eventType, listener, {
          passive
        }), listener;
      }
      var root = null, startText = null, fallbackText = null;
      function initialize(nativeEventTarget) {
        return root = nativeEventTarget, startText = getText(), !0;
      }
      function reset() {
        root = null, startText = null, fallbackText = null;
      }
      function getData() {
        if (fallbackText)
          return fallbackText;
        var start, startValue = startText, startLength = startValue.length, end, endValue = getText(), endLength = endValue.length;
        for (start = 0; start < startLength && startValue[start] === endValue[start]; start++)
          ;
        var minEnd = startLength - start;
        for (end = 1; end <= minEnd && startValue[startLength - end] === endValue[endLength - end]; end++)
          ;
        var sliceTail = end > 1 ? 1 - end : void 0;
        return fallbackText = endValue.slice(start, sliceTail), fallbackText;
      }
      function getText() {
        return "value" in root ? root.value : root.textContent;
      }
      function getEventCharCode(nativeEvent) {
        var charCode, keyCode = nativeEvent.keyCode;
        return "charCode" in nativeEvent ? (charCode = nativeEvent.charCode, charCode === 0 && keyCode === 13 && (charCode = 13)) : charCode = keyCode, charCode === 10 && (charCode = 13), charCode >= 32 || charCode === 13 ? charCode : 0;
      }
      function functionThatReturnsTrue() {
        return !0;
      }
      function functionThatReturnsFalse() {
        return !1;
      }
      function createSyntheticEvent(Interface) {
        function SyntheticBaseEvent(reactName, reactEventType, targetInst, nativeEvent, nativeEventTarget) {
          this._reactName = reactName, this._targetInst = targetInst, this.type = reactEventType, this.nativeEvent = nativeEvent, this.target = nativeEventTarget, this.currentTarget = null;
          for (var _propName in Interface)
            if (Interface.hasOwnProperty(_propName)) {
              var normalize = Interface[_propName];
              normalize ? this[_propName] = normalize(nativeEvent) : this[_propName] = nativeEvent[_propName];
            }
          var defaultPrevented = nativeEvent.defaultPrevented != null ? nativeEvent.defaultPrevented : nativeEvent.returnValue === !1;
          return defaultPrevented ? this.isDefaultPrevented = functionThatReturnsTrue : this.isDefaultPrevented = functionThatReturnsFalse, this.isPropagationStopped = functionThatReturnsFalse, this;
        }
        return assign(SyntheticBaseEvent.prototype, {
          preventDefault: function() {
            this.defaultPrevented = !0;
            var event = this.nativeEvent;
            event && (event.preventDefault ? event.preventDefault() : typeof event.returnValue != "unknown" && (event.returnValue = !1), this.isDefaultPrevented = functionThatReturnsTrue);
          },
          stopPropagation: function() {
            var event = this.nativeEvent;
            event && (event.stopPropagation ? event.stopPropagation() : typeof event.cancelBubble != "unknown" && (event.cancelBubble = !0), this.isPropagationStopped = functionThatReturnsTrue);
          },
          /**
           * We release all dispatched `SyntheticEvent`s after each event loop, adding
           * them back into the pool. This allows a way to hold onto a reference that
           * won't be added back into the pool.
           */
          persist: function() {
          },
          /**
           * Checks if this event should be released back into the pool.
           *
           * @return {boolean} True if this should not be released, false otherwise.
           */
          isPersistent: functionThatReturnsTrue
        }), SyntheticBaseEvent;
      }
      var EventInterface = {
        eventPhase: 0,
        bubbles: 0,
        cancelable: 0,
        timeStamp: function(event) {
          return event.timeStamp || Date.now();
        },
        defaultPrevented: 0,
        isTrusted: 0
      }, SyntheticEvent = createSyntheticEvent(EventInterface), UIEventInterface = assign({}, EventInterface, {
        view: 0,
        detail: 0
      }), SyntheticUIEvent = createSyntheticEvent(UIEventInterface), lastMovementX, lastMovementY, lastMouseEvent;
      function updateMouseMovementPolyfillState(event) {
        event !== lastMouseEvent && (lastMouseEvent && event.type === "mousemove" ? (lastMovementX = event.screenX - lastMouseEvent.screenX, lastMovementY = event.screenY - lastMouseEvent.screenY) : (lastMovementX = 0, lastMovementY = 0), lastMouseEvent = event);
      }
      var MouseEventInterface = assign({}, UIEventInterface, {
        screenX: 0,
        screenY: 0,
        clientX: 0,
        clientY: 0,
        pageX: 0,
        pageY: 0,
        ctrlKey: 0,
        shiftKey: 0,
        altKey: 0,
        metaKey: 0,
        getModifierState: getEventModifierState,
        button: 0,
        buttons: 0,
        relatedTarget: function(event) {
          return event.relatedTarget === void 0 ? event.fromElement === event.srcElement ? event.toElement : event.fromElement : event.relatedTarget;
        },
        movementX: function(event) {
          return "movementX" in event ? event.movementX : (updateMouseMovementPolyfillState(event), lastMovementX);
        },
        movementY: function(event) {
          return "movementY" in event ? event.movementY : lastMovementY;
        }
      }), SyntheticMouseEvent = createSyntheticEvent(MouseEventInterface), DragEventInterface = assign({}, MouseEventInterface, {
        dataTransfer: 0
      }), SyntheticDragEvent = createSyntheticEvent(DragEventInterface), FocusEventInterface = assign({}, UIEventInterface, {
        relatedTarget: 0
      }), SyntheticFocusEvent = createSyntheticEvent(FocusEventInterface), AnimationEventInterface = assign({}, EventInterface, {
        animationName: 0,
        elapsedTime: 0,
        pseudoElement: 0
      }), SyntheticAnimationEvent = createSyntheticEvent(AnimationEventInterface), ClipboardEventInterface = assign({}, EventInterface, {
        clipboardData: function(event) {
          return "clipboardData" in event ? event.clipboardData : window.clipboardData;
        }
      }), SyntheticClipboardEvent = createSyntheticEvent(ClipboardEventInterface), CompositionEventInterface = assign({}, EventInterface, {
        data: 0
      }), SyntheticCompositionEvent = createSyntheticEvent(CompositionEventInterface), SyntheticInputEvent = SyntheticCompositionEvent, normalizeKey = {
        Esc: "Escape",
        Spacebar: " ",
        Left: "ArrowLeft",
        Up: "ArrowUp",
        Right: "ArrowRight",
        Down: "ArrowDown",
        Del: "Delete",
        Win: "OS",
        Menu: "ContextMenu",
        Apps: "ContextMenu",
        Scroll: "ScrollLock",
        MozPrintableKey: "Unidentified"
      }, translateToKey = {
        8: "Backspace",
        9: "Tab",
        12: "Clear",
        13: "Enter",
        16: "Shift",
        17: "Control",
        18: "Alt",
        19: "Pause",
        20: "CapsLock",
        27: "Escape",
        32: " ",
        33: "PageUp",
        34: "PageDown",
        35: "End",
        36: "Home",
        37: "ArrowLeft",
        38: "ArrowUp",
        39: "ArrowRight",
        40: "ArrowDown",
        45: "Insert",
        46: "Delete",
        112: "F1",
        113: "F2",
        114: "F3",
        115: "F4",
        116: "F5",
        117: "F6",
        118: "F7",
        119: "F8",
        120: "F9",
        121: "F10",
        122: "F11",
        123: "F12",
        144: "NumLock",
        145: "ScrollLock",
        224: "Meta"
      };
      function getEventKey(nativeEvent) {
        if (nativeEvent.key) {
          var key = normalizeKey[nativeEvent.key] || nativeEvent.key;
          if (key !== "Unidentified")
            return key;
        }
        if (nativeEvent.type === "keypress") {
          var charCode = getEventCharCode(nativeEvent);
          return charCode === 13 ? "Enter" : String.fromCharCode(charCode);
        }
        return nativeEvent.type === "keydown" || nativeEvent.type === "keyup" ? translateToKey[nativeEvent.keyCode] || "Unidentified" : "";
      }
      var modifierKeyToProp = {
        Alt: "altKey",
        Control: "ctrlKey",
        Meta: "metaKey",
        Shift: "shiftKey"
      };
      function modifierStateGetter(keyArg) {
        var syntheticEvent = this, nativeEvent = syntheticEvent.nativeEvent;
        if (nativeEvent.getModifierState)
          return nativeEvent.getModifierState(keyArg);
        var keyProp = modifierKeyToProp[keyArg];
        return keyProp ? !!nativeEvent[keyProp] : !1;
      }
      function getEventModifierState(nativeEvent) {
        return modifierStateGetter;
      }
      var KeyboardEventInterface = assign({}, UIEventInterface, {
        key: getEventKey,
        code: 0,
        location: 0,
        ctrlKey: 0,
        shiftKey: 0,
        altKey: 0,
        metaKey: 0,
        repeat: 0,
        locale: 0,
        getModifierState: getEventModifierState,
        // Legacy Interface
        charCode: function(event) {
          return event.type === "keypress" ? getEventCharCode(event) : 0;
        },
        keyCode: function(event) {
          return event.type === "keydown" || event.type === "keyup" ? event.keyCode : 0;
        },
        which: function(event) {
          return event.type === "keypress" ? getEventCharCode(event) : event.type === "keydown" || event.type === "keyup" ? event.keyCode : 0;
        }
      }), SyntheticKeyboardEvent = createSyntheticEvent(KeyboardEventInterface), PointerEventInterface = assign({}, MouseEventInterface, {
        pointerId: 0,
        width: 0,
        height: 0,
        pressure: 0,
        tangentialPressure: 0,
        tiltX: 0,
        tiltY: 0,
        twist: 0,
        pointerType: 0,
        isPrimary: 0
      }), SyntheticPointerEvent = createSyntheticEvent(PointerEventInterface), TouchEventInterface = assign({}, UIEventInterface, {
        touches: 0,
        targetTouches: 0,
        changedTouches: 0,
        altKey: 0,
        metaKey: 0,
        ctrlKey: 0,
        shiftKey: 0,
        getModifierState: getEventModifierState
      }), SyntheticTouchEvent = createSyntheticEvent(TouchEventInterface), TransitionEventInterface = assign({}, EventInterface, {
        propertyName: 0,
        elapsedTime: 0,
        pseudoElement: 0
      }), SyntheticTransitionEvent = createSyntheticEvent(TransitionEventInterface), WheelEventInterface = assign({}, MouseEventInterface, {
        deltaX: function(event) {
          return "deltaX" in event ? event.deltaX : (
            // Fallback to `wheelDeltaX` for Webkit and normalize (right is positive).
            "wheelDeltaX" in event ? -event.wheelDeltaX : 0
          );
        },
        deltaY: function(event) {
          return "deltaY" in event ? event.deltaY : (
            // Fallback to `wheelDeltaY` for Webkit and normalize (down is positive).
            "wheelDeltaY" in event ? -event.wheelDeltaY : (
              // Fallback to `wheelDelta` for IE<9 and normalize (down is positive).
              "wheelDelta" in event ? -event.wheelDelta : 0
            )
          );
        },
        deltaZ: 0,
        // Browsers without "deltaMode" is reporting in raw wheel delta where one
        // notch on the scroll is always +/- 120, roughly equivalent to pixels.
        // A good approximation of DOM_DELTA_LINE (1) is 5% of viewport size or
        // ~40 pixels, for DOM_DELTA_SCREEN (2) it is 87.5% of viewport size.
        deltaMode: 0
      }), SyntheticWheelEvent = createSyntheticEvent(WheelEventInterface), END_KEYCODES = [9, 13, 27, 32], START_KEYCODE = 229, canUseCompositionEvent = canUseDOM && "CompositionEvent" in window, documentMode = null;
      canUseDOM && "documentMode" in document && (documentMode = document.documentMode);
      var canUseTextInputEvent = canUseDOM && "TextEvent" in window && !documentMode, useFallbackCompositionData = canUseDOM && (!canUseCompositionEvent || documentMode && documentMode > 8 && documentMode <= 11), SPACEBAR_CODE = 32, SPACEBAR_CHAR = String.fromCharCode(SPACEBAR_CODE);
      function registerEvents() {
        registerTwoPhaseEvent("onBeforeInput", ["compositionend", "keypress", "textInput", "paste"]), registerTwoPhaseEvent("onCompositionEnd", ["compositionend", "focusout", "keydown", "keypress", "keyup", "mousedown"]), registerTwoPhaseEvent("onCompositionStart", ["compositionstart", "focusout", "keydown", "keypress", "keyup", "mousedown"]), registerTwoPhaseEvent("onCompositionUpdate", ["compositionupdate", "focusout", "keydown", "keypress", "keyup", "mousedown"]);
      }
      var hasSpaceKeypress = !1;
      function isKeypressCommand(nativeEvent) {
        return (nativeEvent.ctrlKey || nativeEvent.altKey || nativeEvent.metaKey) && // ctrlKey && altKey is equivalent to AltGr, and is not a command.
        !(nativeEvent.ctrlKey && nativeEvent.altKey);
      }
      function getCompositionEventType(domEventName) {
        switch (domEventName) {
          case "compositionstart":
            return "onCompositionStart";
          case "compositionend":
            return "onCompositionEnd";
          case "compositionupdate":
            return "onCompositionUpdate";
        }
      }
      function isFallbackCompositionStart(domEventName, nativeEvent) {
        return domEventName === "keydown" && nativeEvent.keyCode === START_KEYCODE;
      }
      function isFallbackCompositionEnd(domEventName, nativeEvent) {
        switch (domEventName) {
          case "keyup":
            return END_KEYCODES.indexOf(nativeEvent.keyCode) !== -1;
          case "keydown":
            return nativeEvent.keyCode !== START_KEYCODE;
          case "keypress":
          case "mousedown":
          case "focusout":
            return !0;
          default:
            return !1;
        }
      }
      function getDataFromCustomEvent(nativeEvent) {
        var detail = nativeEvent.detail;
        return typeof detail == "object" && "data" in detail ? detail.data : null;
      }
      function isUsingKoreanIME(nativeEvent) {
        return nativeEvent.locale === "ko";
      }
      var isComposing = !1;
      function extractCompositionEvent(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget) {
        var eventType, fallbackData;
        if (canUseCompositionEvent ? eventType = getCompositionEventType(domEventName) : isComposing ? isFallbackCompositionEnd(domEventName, nativeEvent) && (eventType = "onCompositionEnd") : isFallbackCompositionStart(domEventName, nativeEvent) && (eventType = "onCompositionStart"), !eventType)
          return null;
        useFallbackCompositionData && !isUsingKoreanIME(nativeEvent) && (!isComposing && eventType === "onCompositionStart" ? isComposing = initialize(nativeEventTarget) : eventType === "onCompositionEnd" && isComposing && (fallbackData = getData()));
        var listeners = accumulateTwoPhaseListeners(targetInst, eventType);
        if (listeners.length > 0) {
          var event = new SyntheticCompositionEvent(eventType, domEventName, null, nativeEvent, nativeEventTarget);
          if (dispatchQueue.push({
            event,
            listeners
          }), fallbackData)
            event.data = fallbackData;
          else {
            var customData = getDataFromCustomEvent(nativeEvent);
            customData !== null && (event.data = customData);
          }
        }
      }
      function getNativeBeforeInputChars(domEventName, nativeEvent) {
        switch (domEventName) {
          case "compositionend":
            return getDataFromCustomEvent(nativeEvent);
          case "keypress":
            var which = nativeEvent.which;
            return which !== SPACEBAR_CODE ? null : (hasSpaceKeypress = !0, SPACEBAR_CHAR);
          case "textInput":
            var chars = nativeEvent.data;
            return chars === SPACEBAR_CHAR && hasSpaceKeypress ? null : chars;
          default:
            return null;
        }
      }
      function getFallbackBeforeInputChars(domEventName, nativeEvent) {
        if (isComposing) {
          if (domEventName === "compositionend" || !canUseCompositionEvent && isFallbackCompositionEnd(domEventName, nativeEvent)) {
            var chars = getData();
            return reset(), isComposing = !1, chars;
          }
          return null;
        }
        switch (domEventName) {
          case "paste":
            return null;
          case "keypress":
            if (!isKeypressCommand(nativeEvent)) {
              if (nativeEvent.char && nativeEvent.char.length > 1)
                return nativeEvent.char;
              if (nativeEvent.which)
                return String.fromCharCode(nativeEvent.which);
            }
            return null;
          case "compositionend":
            return useFallbackCompositionData && !isUsingKoreanIME(nativeEvent) ? null : nativeEvent.data;
          default:
            return null;
        }
      }
      function extractBeforeInputEvent(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget) {
        var chars;
        if (canUseTextInputEvent ? chars = getNativeBeforeInputChars(domEventName, nativeEvent) : chars = getFallbackBeforeInputChars(domEventName, nativeEvent), !chars)
          return null;
        var listeners = accumulateTwoPhaseListeners(targetInst, "onBeforeInput");
        if (listeners.length > 0) {
          var event = new SyntheticInputEvent("onBeforeInput", "beforeinput", null, nativeEvent, nativeEventTarget);
          dispatchQueue.push({
            event,
            listeners
          }), event.data = chars;
        }
      }
      function extractEvents(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {
        extractCompositionEvent(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget), extractBeforeInputEvent(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget);
      }
      var supportedInputTypes = {
        color: !0,
        date: !0,
        datetime: !0,
        "datetime-local": !0,
        email: !0,
        month: !0,
        number: !0,
        password: !0,
        range: !0,
        search: !0,
        tel: !0,
        text: !0,
        time: !0,
        url: !0,
        week: !0
      };
      function isTextInputElement(elem) {
        var nodeName = elem && elem.nodeName && elem.nodeName.toLowerCase();
        return nodeName === "input" ? !!supportedInputTypes[elem.type] : nodeName === "textarea";
      }
      function isEventSupported(eventNameSuffix) {
        if (!canUseDOM)
          return !1;
        var eventName = "on" + eventNameSuffix, isSupported = eventName in document;
        if (!isSupported) {
          var element = document.createElement("div");
          element.setAttribute(eventName, "return;"), isSupported = typeof element[eventName] == "function";
        }
        return isSupported;
      }
      function registerEvents$1() {
        registerTwoPhaseEvent("onChange", ["change", "click", "focusin", "focusout", "input", "keydown", "keyup", "selectionchange"]);
      }
      function createAndAccumulateChangeEvent(dispatchQueue, inst, nativeEvent, target) {
        enqueueStateRestore(target);
        var listeners = accumulateTwoPhaseListeners(inst, "onChange");
        if (listeners.length > 0) {
          var event = new SyntheticEvent("onChange", "change", null, nativeEvent, target);
          dispatchQueue.push({
            event,
            listeners
          });
        }
      }
      var activeElement = null, activeElementInst = null;
      function shouldUseChangeEvent(elem) {
        var nodeName = elem.nodeName && elem.nodeName.toLowerCase();
        return nodeName === "select" || nodeName === "input" && elem.type === "file";
      }
      function manualDispatchChangeEvent(nativeEvent) {
        var dispatchQueue = [];
        createAndAccumulateChangeEvent(dispatchQueue, activeElementInst, nativeEvent, getEventTarget(nativeEvent)), batchedUpdates(runEventInBatch, dispatchQueue);
      }
      function runEventInBatch(dispatchQueue) {
        processDispatchQueue(dispatchQueue, 0);
      }
      function getInstIfValueChanged(targetInst) {
        var targetNode = getNodeFromInstance(targetInst);
        if (updateValueIfChanged(targetNode))
          return targetInst;
      }
      function getTargetInstForChangeEvent(domEventName, targetInst) {
        if (domEventName === "change")
          return targetInst;
      }
      var isInputEventSupported = !1;
      canUseDOM && (isInputEventSupported = isEventSupported("input") && (!document.documentMode || document.documentMode > 9));
      function startWatchingForValueChange(target, targetInst) {
        activeElement = target, activeElementInst = targetInst, activeElement.attachEvent("onpropertychange", handlePropertyChange);
      }
      function stopWatchingForValueChange() {
        activeElement && (activeElement.detachEvent("onpropertychange", handlePropertyChange), activeElement = null, activeElementInst = null);
      }
      function handlePropertyChange(nativeEvent) {
        nativeEvent.propertyName === "value" && getInstIfValueChanged(activeElementInst) && manualDispatchChangeEvent(nativeEvent);
      }
      function handleEventsForInputEventPolyfill(domEventName, target, targetInst) {
        domEventName === "focusin" ? (stopWatchingForValueChange(), startWatchingForValueChange(target, targetInst)) : domEventName === "focusout" && stopWatchingForValueChange();
      }
      function getTargetInstForInputEventPolyfill(domEventName, targetInst) {
        if (domEventName === "selectionchange" || domEventName === "keyup" || domEventName === "keydown")
          return getInstIfValueChanged(activeElementInst);
      }
      function shouldUseClickEvent(elem) {
        var nodeName = elem.nodeName;
        return nodeName && nodeName.toLowerCase() === "input" && (elem.type === "checkbox" || elem.type === "radio");
      }
      function getTargetInstForClickEvent(domEventName, targetInst) {
        if (domEventName === "click")
          return getInstIfValueChanged(targetInst);
      }
      function getTargetInstForInputOrChangeEvent(domEventName, targetInst) {
        if (domEventName === "input" || domEventName === "change")
          return getInstIfValueChanged(targetInst);
      }
      function handleControlledInputBlur(node) {
        var state = node._wrapperState;
        !state || !state.controlled || node.type !== "number" || setDefaultValue(node, "number", node.value);
      }
      function extractEvents$1(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {
        var targetNode = targetInst ? getNodeFromInstance(targetInst) : window, getTargetInstFunc, handleEventFunc;
        if (shouldUseChangeEvent(targetNode) ? getTargetInstFunc = getTargetInstForChangeEvent : isTextInputElement(targetNode) ? isInputEventSupported ? getTargetInstFunc = getTargetInstForInputOrChangeEvent : (getTargetInstFunc = getTargetInstForInputEventPolyfill, handleEventFunc = handleEventsForInputEventPolyfill) : shouldUseClickEvent(targetNode) && (getTargetInstFunc = getTargetInstForClickEvent), getTargetInstFunc) {
          var inst = getTargetInstFunc(domEventName, targetInst);
          if (inst) {
            createAndAccumulateChangeEvent(dispatchQueue, inst, nativeEvent, nativeEventTarget);
            return;
          }
        }
        handleEventFunc && handleEventFunc(domEventName, targetNode, targetInst), domEventName === "focusout" && handleControlledInputBlur(targetNode);
      }
      function registerEvents$2() {
        registerDirectEvent("onMouseEnter", ["mouseout", "mouseover"]), registerDirectEvent("onMouseLeave", ["mouseout", "mouseover"]), registerDirectEvent("onPointerEnter", ["pointerout", "pointerover"]), registerDirectEvent("onPointerLeave", ["pointerout", "pointerover"]);
      }
      function extractEvents$2(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {
        var isOverEvent = domEventName === "mouseover" || domEventName === "pointerover", isOutEvent = domEventName === "mouseout" || domEventName === "pointerout";
        if (isOverEvent && !isReplayingEvent(nativeEvent)) {
          var related = nativeEvent.relatedTarget || nativeEvent.fromElement;
          if (related && (getClosestInstanceFromNode(related) || isContainerMarkedAsRoot(related)))
            return;
        }
        if (!(!isOutEvent && !isOverEvent)) {
          var win;
          if (nativeEventTarget.window === nativeEventTarget)
            win = nativeEventTarget;
          else {
            var doc = nativeEventTarget.ownerDocument;
            doc ? win = doc.defaultView || doc.parentWindow : win = window;
          }
          var from, to;
          if (isOutEvent) {
            var _related = nativeEvent.relatedTarget || nativeEvent.toElement;
            if (from = targetInst, to = _related ? getClosestInstanceFromNode(_related) : null, to !== null) {
              var nearestMounted = getNearestMountedFiber(to);
              (to !== nearestMounted || to.tag !== HostComponent && to.tag !== HostText) && (to = null);
            }
          } else
            from = null, to = targetInst;
          if (from !== to) {
            var SyntheticEventCtor = SyntheticMouseEvent, leaveEventType = "onMouseLeave", enterEventType = "onMouseEnter", eventTypePrefix = "mouse";
            (domEventName === "pointerout" || domEventName === "pointerover") && (SyntheticEventCtor = SyntheticPointerEvent, leaveEventType = "onPointerLeave", enterEventType = "onPointerEnter", eventTypePrefix = "pointer");
            var fromNode = from == null ? win : getNodeFromInstance(from), toNode = to == null ? win : getNodeFromInstance(to), leave = new SyntheticEventCtor(leaveEventType, eventTypePrefix + "leave", from, nativeEvent, nativeEventTarget);
            leave.target = fromNode, leave.relatedTarget = toNode;
            var enter = null, nativeTargetInst = getClosestInstanceFromNode(nativeEventTarget);
            if (nativeTargetInst === targetInst) {
              var enterEvent = new SyntheticEventCtor(enterEventType, eventTypePrefix + "enter", to, nativeEvent, nativeEventTarget);
              enterEvent.target = toNode, enterEvent.relatedTarget = fromNode, enter = enterEvent;
            }
            accumulateEnterLeaveTwoPhaseListeners(dispatchQueue, leave, enter, from, to);
          }
        }
      }
      function is(x, y) {
        return x === y && (x !== 0 || 1 / x === 1 / y) || x !== x && y !== y;
      }
      var objectIs = typeof Object.is == "function" ? Object.is : is;
      function shallowEqual(objA, objB) {
        if (objectIs(objA, objB))
          return !0;
        if (typeof objA != "object" || objA === null || typeof objB != "object" || objB === null)
          return !1;
        var keysA = Object.keys(objA), keysB = Object.keys(objB);
        if (keysA.length !== keysB.length)
          return !1;
        for (var i = 0; i < keysA.length; i++) {
          var currentKey = keysA[i];
          if (!hasOwnProperty.call(objB, currentKey) || !objectIs(objA[currentKey], objB[currentKey]))
            return !1;
        }
        return !0;
      }
      function getLeafNode(node) {
        for (; node && node.firstChild; )
          node = node.firstChild;
        return node;
      }
      function getSiblingNode(node) {
        for (; node; ) {
          if (node.nextSibling)
            return node.nextSibling;
          node = node.parentNode;
        }
      }
      function getNodeForCharacterOffset(root2, offset) {
        for (var node = getLeafNode(root2), nodeStart = 0, nodeEnd = 0; node; ) {
          if (node.nodeType === TEXT_NODE) {
            if (nodeEnd = nodeStart + node.textContent.length, nodeStart <= offset && nodeEnd >= offset)
              return {
                node,
                offset: offset - nodeStart
              };
            nodeStart = nodeEnd;
          }
          node = getLeafNode(getSiblingNode(node));
        }
      }
      function getOffsets(outerNode) {
        var ownerDocument = outerNode.ownerDocument, win = ownerDocument && ownerDocument.defaultView || window, selection = win.getSelection && win.getSelection();
        if (!selection || selection.rangeCount === 0)
          return null;
        var anchorNode = selection.anchorNode, anchorOffset = selection.anchorOffset, focusNode = selection.focusNode, focusOffset = selection.focusOffset;
        try {
          anchorNode.nodeType, focusNode.nodeType;
        } catch {
          return null;
        }
        return getModernOffsetsFromPoints(outerNode, anchorNode, anchorOffset, focusNode, focusOffset);
      }
      function getModernOffsetsFromPoints(outerNode, anchorNode, anchorOffset, focusNode, focusOffset) {
        var length = 0, start = -1, end = -1, indexWithinAnchor = 0, indexWithinFocus = 0, node = outerNode, parentNode = null;
        outer:
          for (; ; ) {
            for (var next = null; node === anchorNode && (anchorOffset === 0 || node.nodeType === TEXT_NODE) && (start = length + anchorOffset), node === focusNode && (focusOffset === 0 || node.nodeType === TEXT_NODE) && (end = length + focusOffset), node.nodeType === TEXT_NODE && (length += node.nodeValue.length), (next = node.firstChild) !== null; )
              parentNode = node, node = next;
            for (; ; ) {
              if (node === outerNode)
                break outer;
              if (parentNode === anchorNode && ++indexWithinAnchor === anchorOffset && (start = length), parentNode === focusNode && ++indexWithinFocus === focusOffset && (end = length), (next = node.nextSibling) !== null)
                break;
              node = parentNode, parentNode = node.parentNode;
            }
            node = next;
          }
        return start === -1 || end === -1 ? null : {
          start,
          end
        };
      }
      function setOffsets(node, offsets) {
        var doc = node.ownerDocument || document, win = doc && doc.defaultView || window;
        if (win.getSelection) {
          var selection = win.getSelection(), length = node.textContent.length, start = Math.min(offsets.start, length), end = offsets.end === void 0 ? start : Math.min(offsets.end, length);
          if (!selection.extend && start > end) {
            var temp = end;
            end = start, start = temp;
          }
          var startMarker = getNodeForCharacterOffset(node, start), endMarker = getNodeForCharacterOffset(node, end);
          if (startMarker && endMarker) {
            if (selection.rangeCount === 1 && selection.anchorNode === startMarker.node && selection.anchorOffset === startMarker.offset && selection.focusNode === endMarker.node && selection.focusOffset === endMarker.offset)
              return;
            var range = doc.createRange();
            range.setStart(startMarker.node, startMarker.offset), selection.removeAllRanges(), start > end ? (selection.addRange(range), selection.extend(endMarker.node, endMarker.offset)) : (range.setEnd(endMarker.node, endMarker.offset), selection.addRange(range));
          }
        }
      }
      function isTextNode(node) {
        return node && node.nodeType === TEXT_NODE;
      }
      function containsNode(outerNode, innerNode) {
        return !outerNode || !innerNode ? !1 : outerNode === innerNode ? !0 : isTextNode(outerNode) ? !1 : isTextNode(innerNode) ? containsNode(outerNode, innerNode.parentNode) : "contains" in outerNode ? outerNode.contains(innerNode) : outerNode.compareDocumentPosition ? !!(outerNode.compareDocumentPosition(innerNode) & 16) : !1;
      }
      function isInDocument(node) {
        return node && node.ownerDocument && containsNode(node.ownerDocument.documentElement, node);
      }
      function isSameOriginFrame(iframe) {
        try {
          return typeof iframe.contentWindow.location.href == "string";
        } catch {
          return !1;
        }
      }
      function getActiveElementDeep() {
        for (var win = window, element = getActiveElement(); element instanceof win.HTMLIFrameElement; ) {
          if (isSameOriginFrame(element))
            win = element.contentWindow;
          else
            return element;
          element = getActiveElement(win.document);
        }
        return element;
      }
      function hasSelectionCapabilities(elem) {
        var nodeName = elem && elem.nodeName && elem.nodeName.toLowerCase();
        return nodeName && (nodeName === "input" && (elem.type === "text" || elem.type === "search" || elem.type === "tel" || elem.type === "url" || elem.type === "password") || nodeName === "textarea" || elem.contentEditable === "true");
      }
      function getSelectionInformation() {
        var focusedElem = getActiveElementDeep();
        return {
          focusedElem,
          selectionRange: hasSelectionCapabilities(focusedElem) ? getSelection(focusedElem) : null
        };
      }
      function restoreSelection(priorSelectionInformation) {
        var curFocusedElem = getActiveElementDeep(), priorFocusedElem = priorSelectionInformation.focusedElem, priorSelectionRange = priorSelectionInformation.selectionRange;
        if (curFocusedElem !== priorFocusedElem && isInDocument(priorFocusedElem)) {
          priorSelectionRange !== null && hasSelectionCapabilities(priorFocusedElem) && setSelection(priorFocusedElem, priorSelectionRange);
          for (var ancestors = [], ancestor = priorFocusedElem; ancestor = ancestor.parentNode; )
            ancestor.nodeType === ELEMENT_NODE && ancestors.push({
              element: ancestor,
              left: ancestor.scrollLeft,
              top: ancestor.scrollTop
            });
          typeof priorFocusedElem.focus == "function" && priorFocusedElem.focus();
          for (var i = 0; i < ancestors.length; i++) {
            var info2 = ancestors[i];
            info2.element.scrollLeft = info2.left, info2.element.scrollTop = info2.top;
          }
        }
      }
      function getSelection(input) {
        var selection;
        return "selectionStart" in input ? selection = {
          start: input.selectionStart,
          end: input.selectionEnd
        } : selection = getOffsets(input), selection || {
          start: 0,
          end: 0
        };
      }
      function setSelection(input, offsets) {
        var start = offsets.start, end = offsets.end;
        end === void 0 && (end = start), "selectionStart" in input ? (input.selectionStart = start, input.selectionEnd = Math.min(end, input.value.length)) : setOffsets(input, offsets);
      }
      var skipSelectionChangeEvent = canUseDOM && "documentMode" in document && document.documentMode <= 11;
      function registerEvents$3() {
        registerTwoPhaseEvent("onSelect", ["focusout", "contextmenu", "dragend", "focusin", "keydown", "keyup", "mousedown", "mouseup", "selectionchange"]);
      }
      var activeElement$1 = null, activeElementInst$1 = null, lastSelection = null, mouseDown = !1;
      function getSelection$1(node) {
        if ("selectionStart" in node && hasSelectionCapabilities(node))
          return {
            start: node.selectionStart,
            end: node.selectionEnd
          };
        var win = node.ownerDocument && node.ownerDocument.defaultView || window, selection = win.getSelection();
        return {
          anchorNode: selection.anchorNode,
          anchorOffset: selection.anchorOffset,
          focusNode: selection.focusNode,
          focusOffset: selection.focusOffset
        };
      }
      function getEventTargetDocument(eventTarget) {
        return eventTarget.window === eventTarget ? eventTarget.document : eventTarget.nodeType === DOCUMENT_NODE ? eventTarget : eventTarget.ownerDocument;
      }
      function constructSelectEvent(dispatchQueue, nativeEvent, nativeEventTarget) {
        var doc = getEventTargetDocument(nativeEventTarget);
        if (!(mouseDown || activeElement$1 == null || activeElement$1 !== getActiveElement(doc))) {
          var currentSelection = getSelection$1(activeElement$1);
          if (!lastSelection || !shallowEqual(lastSelection, currentSelection)) {
            lastSelection = currentSelection;
            var listeners = accumulateTwoPhaseListeners(activeElementInst$1, "onSelect");
            if (listeners.length > 0) {
              var event = new SyntheticEvent("onSelect", "select", null, nativeEvent, nativeEventTarget);
              dispatchQueue.push({
                event,
                listeners
              }), event.target = activeElement$1;
            }
          }
        }
      }
      function extractEvents$3(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {
        var targetNode = targetInst ? getNodeFromInstance(targetInst) : window;
        switch (domEventName) {
          case "focusin":
            (isTextInputElement(targetNode) || targetNode.contentEditable === "true") && (activeElement$1 = targetNode, activeElementInst$1 = targetInst, lastSelection = null);
            break;
          case "focusout":
            activeElement$1 = null, activeElementInst$1 = null, lastSelection = null;
            break;
          case "mousedown":
            mouseDown = !0;
            break;
          case "contextmenu":
          case "mouseup":
          case "dragend":
            mouseDown = !1, constructSelectEvent(dispatchQueue, nativeEvent, nativeEventTarget);
            break;
          case "selectionchange":
            if (skipSelectionChangeEvent)
              break;
          case "keydown":
          case "keyup":
            constructSelectEvent(dispatchQueue, nativeEvent, nativeEventTarget);
        }
      }
      function makePrefixMap(styleProp, eventName) {
        var prefixes2 = {};
        return prefixes2[styleProp.toLowerCase()] = eventName.toLowerCase(), prefixes2["Webkit" + styleProp] = "webkit" + eventName, prefixes2["Moz" + styleProp] = "moz" + eventName, prefixes2;
      }
      var vendorPrefixes = {
        animationend: makePrefixMap("Animation", "AnimationEnd"),
        animationiteration: makePrefixMap("Animation", "AnimationIteration"),
        animationstart: makePrefixMap("Animation", "AnimationStart"),
        transitionend: makePrefixMap("Transition", "TransitionEnd")
      }, prefixedEventNames = {}, style = {};
      canUseDOM && (style = document.createElement("div").style, "AnimationEvent" in window || (delete vendorPrefixes.animationend.animation, delete vendorPrefixes.animationiteration.animation, delete vendorPrefixes.animationstart.animation), "TransitionEvent" in window || delete vendorPrefixes.transitionend.transition);
      function getVendorPrefixedEventName(eventName) {
        if (prefixedEventNames[eventName])
          return prefixedEventNames[eventName];
        if (!vendorPrefixes[eventName])
          return eventName;
        var prefixMap = vendorPrefixes[eventName];
        for (var styleProp in prefixMap)
          if (prefixMap.hasOwnProperty(styleProp) && styleProp in style)
            return prefixedEventNames[eventName] = prefixMap[styleProp];
        return eventName;
      }
      var ANIMATION_END = getVendorPrefixedEventName("animationend"), ANIMATION_ITERATION = getVendorPrefixedEventName("animationiteration"), ANIMATION_START = getVendorPrefixedEventName("animationstart"), TRANSITION_END = getVendorPrefixedEventName("transitionend"), topLevelEventsToReactNames = /* @__PURE__ */ new Map(), simpleEventPluginEvents = ["abort", "auxClick", "cancel", "canPlay", "canPlayThrough", "click", "close", "contextMenu", "copy", "cut", "drag", "dragEnd", "dragEnter", "dragExit", "dragLeave", "dragOver", "dragStart", "drop", "durationChange", "emptied", "encrypted", "ended", "error", "gotPointerCapture", "input", "invalid", "keyDown", "keyPress", "keyUp", "load", "loadedData", "loadedMetadata", "loadStart", "lostPointerCapture", "mouseDown", "mouseMove", "mouseOut", "mouseOver", "mouseUp", "paste", "pause", "play", "playing", "pointerCancel", "pointerDown", "pointerMove", "pointerOut", "pointerOver", "pointerUp", "progress", "rateChange", "reset", "resize", "seeked", "seeking", "stalled", "submit", "suspend", "timeUpdate", "touchCancel", "touchEnd", "touchStart", "volumeChange", "scroll", "toggle", "touchMove", "waiting", "wheel"];
      function registerSimpleEvent(domEventName, reactName) {
        topLevelEventsToReactNames.set(domEventName, reactName), registerTwoPhaseEvent(reactName, [domEventName]);
      }
      function registerSimpleEvents() {
        for (var i = 0; i < simpleEventPluginEvents.length; i++) {
          var eventName = simpleEventPluginEvents[i], domEventName = eventName.toLowerCase(), capitalizedEvent = eventName[0].toUpperCase() + eventName.slice(1);
          registerSimpleEvent(domEventName, "on" + capitalizedEvent);
        }
        registerSimpleEvent(ANIMATION_END, "onAnimationEnd"), registerSimpleEvent(ANIMATION_ITERATION, "onAnimationIteration"), registerSimpleEvent(ANIMATION_START, "onAnimationStart"), registerSimpleEvent("dblclick", "onDoubleClick"), registerSimpleEvent("focusin", "onFocus"), registerSimpleEvent("focusout", "onBlur"), registerSimpleEvent(TRANSITION_END, "onTransitionEnd");
      }
      function extractEvents$4(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {
        var reactName = topLevelEventsToReactNames.get(domEventName);
        if (reactName !== void 0) {
          var SyntheticEventCtor = SyntheticEvent, reactEventType = domEventName;
          switch (domEventName) {
            case "keypress":
              if (getEventCharCode(nativeEvent) === 0)
                return;
            case "keydown":
            case "keyup":
              SyntheticEventCtor = SyntheticKeyboardEvent;
              break;
            case "focusin":
              reactEventType = "focus", SyntheticEventCtor = SyntheticFocusEvent;
              break;
            case "focusout":
              reactEventType = "blur", SyntheticEventCtor = SyntheticFocusEvent;
              break;
            case "beforeblur":
            case "afterblur":
              SyntheticEventCtor = SyntheticFocusEvent;
              break;
            case "click":
              if (nativeEvent.button === 2)
                return;
            case "auxclick":
            case "dblclick":
            case "mousedown":
            case "mousemove":
            case "mouseup":
            case "mouseout":
            case "mouseover":
            case "contextmenu":
              SyntheticEventCtor = SyntheticMouseEvent;
              break;
            case "drag":
            case "dragend":
            case "dragenter":
            case "dragexit":
            case "dragleave":
            case "dragover":
            case "dragstart":
            case "drop":
              SyntheticEventCtor = SyntheticDragEvent;
              break;
            case "touchcancel":
            case "touchend":
            case "touchmove":
            case "touchstart":
              SyntheticEventCtor = SyntheticTouchEvent;
              break;
            case ANIMATION_END:
            case ANIMATION_ITERATION:
            case ANIMATION_START:
              SyntheticEventCtor = SyntheticAnimationEvent;
              break;
            case TRANSITION_END:
              SyntheticEventCtor = SyntheticTransitionEvent;
              break;
            case "scroll":
              SyntheticEventCtor = SyntheticUIEvent;
              break;
            case "wheel":
              SyntheticEventCtor = SyntheticWheelEvent;
              break;
            case "copy":
            case "cut":
            case "paste":
              SyntheticEventCtor = SyntheticClipboardEvent;
              break;
            case "gotpointercapture":
            case "lostpointercapture":
            case "pointercancel":
            case "pointerdown":
            case "pointermove":
            case "pointerout":
            case "pointerover":
            case "pointerup":
              SyntheticEventCtor = SyntheticPointerEvent;
              break;
          }
          var inCapturePhase = (eventSystemFlags & IS_CAPTURE_PHASE) !== 0;
          {
            var accumulateTargetOnly = !inCapturePhase && // TODO: ideally, we'd eventually add all events from
            // nonDelegatedEvents list in DOMPluginEventSystem.
            // Then we can remove this special list.
            // This is a breaking change that can wait until React 18.
            domEventName === "scroll", _listeners = accumulateSinglePhaseListeners(targetInst, reactName, nativeEvent.type, inCapturePhase, accumulateTargetOnly);
            if (_listeners.length > 0) {
              var _event = new SyntheticEventCtor(reactName, reactEventType, null, nativeEvent, nativeEventTarget);
              dispatchQueue.push({
                event: _event,
                listeners: _listeners
              });
            }
          }
        }
      }
      registerSimpleEvents(), registerEvents$2(), registerEvents$1(), registerEvents$3(), registerEvents();
      function extractEvents$5(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags, targetContainer) {
        extractEvents$4(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags);
        var shouldProcessPolyfillPlugins = (eventSystemFlags & SHOULD_NOT_PROCESS_POLYFILL_EVENT_PLUGINS) === 0;
        shouldProcessPolyfillPlugins && (extractEvents$2(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget), extractEvents$1(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget), extractEvents$3(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget), extractEvents(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget));
      }
      var mediaEventTypes = ["abort", "canplay", "canplaythrough", "durationchange", "emptied", "encrypted", "ended", "error", "loadeddata", "loadedmetadata", "loadstart", "pause", "play", "playing", "progress", "ratechange", "resize", "seeked", "seeking", "stalled", "suspend", "timeupdate", "volumechange", "waiting"], nonDelegatedEvents = new Set(["cancel", "close", "invalid", "load", "scroll", "toggle"].concat(mediaEventTypes));
      function executeDispatch(event, listener, currentTarget) {
        var type = event.type || "unknown-event";
        event.currentTarget = currentTarget, invokeGuardedCallbackAndCatchFirstError(type, listener, void 0, event), event.currentTarget = null;
      }
      function processDispatchQueueItemsInOrder(event, dispatchListeners, inCapturePhase) {
        var previousInstance;
        if (inCapturePhase)
          for (var i = dispatchListeners.length - 1; i >= 0; i--) {
            var _dispatchListeners$i = dispatchListeners[i], instance = _dispatchListeners$i.instance, currentTarget = _dispatchListeners$i.currentTarget, listener = _dispatchListeners$i.listener;
            if (instance !== previousInstance && event.isPropagationStopped())
              return;
            executeDispatch(event, listener, currentTarget), previousInstance = instance;
          }
        else
          for (var _i = 0; _i < dispatchListeners.length; _i++) {
            var _dispatchListeners$_i = dispatchListeners[_i], _instance = _dispatchListeners$_i.instance, _currentTarget = _dispatchListeners$_i.currentTarget, _listener = _dispatchListeners$_i.listener;
            if (_instance !== previousInstance && event.isPropagationStopped())
              return;
            executeDispatch(event, _listener, _currentTarget), previousInstance = _instance;
          }
      }
      function processDispatchQueue(dispatchQueue, eventSystemFlags) {
        for (var inCapturePhase = (eventSystemFlags & IS_CAPTURE_PHASE) !== 0, i = 0; i < dispatchQueue.length; i++) {
          var _dispatchQueue$i = dispatchQueue[i], event = _dispatchQueue$i.event, listeners = _dispatchQueue$i.listeners;
          processDispatchQueueItemsInOrder(event, listeners, inCapturePhase);
        }
        rethrowCaughtError();
      }
      function dispatchEventsForPlugins(domEventName, eventSystemFlags, nativeEvent, targetInst, targetContainer) {
        var nativeEventTarget = getEventTarget(nativeEvent), dispatchQueue = [];
        extractEvents$5(dispatchQueue, domEventName, targetInst, nativeEvent, nativeEventTarget, eventSystemFlags), processDispatchQueue(dispatchQueue, eventSystemFlags);
      }
      function listenToNonDelegatedEvent(domEventName, targetElement) {
        nonDelegatedEvents.has(domEventName) || error('Did not expect a listenToNonDelegatedEvent() call for "%s". This is a bug in React. Please file an issue.', domEventName);
        var isCapturePhaseListener = !1, listenerSet = getEventListenerSet(targetElement), listenerSetKey = getListenerSetKey(domEventName, isCapturePhaseListener);
        listenerSet.has(listenerSetKey) || (addTrappedEventListener(targetElement, domEventName, IS_NON_DELEGATED, isCapturePhaseListener), listenerSet.add(listenerSetKey));
      }
      function listenToNativeEvent(domEventName, isCapturePhaseListener, target) {
        nonDelegatedEvents.has(domEventName) && !isCapturePhaseListener && error('Did not expect a listenToNativeEvent() call for "%s" in the bubble phase. This is a bug in React. Please file an issue.', domEventName);
        var eventSystemFlags = 0;
        isCapturePhaseListener && (eventSystemFlags |= IS_CAPTURE_PHASE), addTrappedEventListener(target, domEventName, eventSystemFlags, isCapturePhaseListener);
      }
      var listeningMarker = "_reactListening" + Math.random().toString(36).slice(2);
      function listenToAllSupportedEvents(rootContainerElement) {
        if (!rootContainerElement[listeningMarker]) {
          rootContainerElement[listeningMarker] = !0, allNativeEvents.forEach(function(domEventName) {
            domEventName !== "selectionchange" && (nonDelegatedEvents.has(domEventName) || listenToNativeEvent(domEventName, !1, rootContainerElement), listenToNativeEvent(domEventName, !0, rootContainerElement));
          });
          var ownerDocument = rootContainerElement.nodeType === DOCUMENT_NODE ? rootContainerElement : rootContainerElement.ownerDocument;
          ownerDocument !== null && (ownerDocument[listeningMarker] || (ownerDocument[listeningMarker] = !0, listenToNativeEvent("selectionchange", !1, ownerDocument)));
        }
      }
      function addTrappedEventListener(targetContainer, domEventName, eventSystemFlags, isCapturePhaseListener, isDeferredListenerForLegacyFBSupport) {
        var listener = createEventListenerWrapperWithPriority(targetContainer, domEventName, eventSystemFlags), isPassiveListener = void 0;
        passiveBrowserEventsSupported && (domEventName === "touchstart" || domEventName === "touchmove" || domEventName === "wheel") && (isPassiveListener = !0), targetContainer = targetContainer;
        var unsubscribeListener;
        isCapturePhaseListener ? isPassiveListener !== void 0 ? unsubscribeListener = addEventCaptureListenerWithPassiveFlag(targetContainer, domEventName, listener, isPassiveListener) : unsubscribeListener = addEventCaptureListener(targetContainer, domEventName, listener) : isPassiveListener !== void 0 ? unsubscribeListener = addEventBubbleListenerWithPassiveFlag(targetContainer, domEventName, listener, isPassiveListener) : unsubscribeListener = addEventBubbleListener(targetContainer, domEventName, listener);
      }
      function isMatchingRootContainer(grandContainer, targetContainer) {
        return grandContainer === targetContainer || grandContainer.nodeType === COMMENT_NODE && grandContainer.parentNode === targetContainer;
      }
      function dispatchEventForPluginEventSystem(domEventName, eventSystemFlags, nativeEvent, targetInst, targetContainer) {
        var ancestorInst = targetInst;
        if (!(eventSystemFlags & IS_EVENT_HANDLE_NON_MANAGED_NODE) && !(eventSystemFlags & IS_NON_DELEGATED)) {
          var targetContainerNode = targetContainer;
          if (targetInst !== null) {
            var node = targetInst;
            mainLoop:
              for (; ; ) {
                if (node === null)
                  return;
                var nodeTag = node.tag;
                if (nodeTag === HostRoot || nodeTag === HostPortal) {
                  var container = node.stateNode.containerInfo;
                  if (isMatchingRootContainer(container, targetContainerNode))
                    break;
                  if (nodeTag === HostPortal)
                    for (var grandNode = node.return; grandNode !== null; ) {
                      var grandTag = grandNode.tag;
                      if (grandTag === HostRoot || grandTag === HostPortal) {
                        var grandContainer = grandNode.stateNode.containerInfo;
                        if (isMatchingRootContainer(grandContainer, targetContainerNode))
                          return;
                      }
                      grandNode = grandNode.return;
                    }
                  for (; container !== null; ) {
                    var parentNode = getClosestInstanceFromNode(container);
                    if (parentNode === null)
                      return;
                    var parentTag = parentNode.tag;
                    if (parentTag === HostComponent || parentTag === HostText) {
                      node = ancestorInst = parentNode;
                      continue mainLoop;
                    }
                    container = container.parentNode;
                  }
                }
                node = node.return;
              }
          }
        }
        batchedUpdates(function() {
          return dispatchEventsForPlugins(domEventName, eventSystemFlags, nativeEvent, ancestorInst);
        });
      }
      function createDispatchListener(instance, listener, currentTarget) {
        return {
          instance,
          listener,
          currentTarget
        };
      }
      function accumulateSinglePhaseListeners(targetFiber, reactName, nativeEventType, inCapturePhase, accumulateTargetOnly, nativeEvent) {
        for (var captureName = reactName !== null ? reactName + "Capture" : null, reactEventName = inCapturePhase ? captureName : reactName, listeners = [], instance = targetFiber, lastHostComponent = null; instance !== null; ) {
          var _instance2 = instance, stateNode = _instance2.stateNode, tag = _instance2.tag;
          if (tag === HostComponent && stateNode !== null && (lastHostComponent = stateNode, reactEventName !== null)) {
            var listener = getListener(instance, reactEventName);
            listener != null && listeners.push(createDispatchListener(instance, listener, lastHostComponent));
          }
          if (accumulateTargetOnly)
            break;
          instance = instance.return;
        }
        return listeners;
      }
      function accumulateTwoPhaseListeners(targetFiber, reactName) {
        for (var captureName = reactName + "Capture", listeners = [], instance = targetFiber; instance !== null; ) {
          var _instance3 = instance, stateNode = _instance3.stateNode, tag = _instance3.tag;
          if (tag === HostComponent && stateNode !== null) {
            var currentTarget = stateNode, captureListener = getListener(instance, captureName);
            captureListener != null && listeners.unshift(createDispatchListener(instance, captureListener, currentTarget));
            var bubbleListener = getListener(instance, reactName);
            bubbleListener != null && listeners.push(createDispatchListener(instance, bubbleListener, currentTarget));
          }
          instance = instance.return;
        }
        return listeners;
      }
      function getParent(inst) {
        if (inst === null)
          return null;
        do
          inst = inst.return;
        while (inst && inst.tag !== HostComponent);
        return inst || null;
      }
      function getLowestCommonAncestor(instA, instB) {
        for (var nodeA = instA, nodeB = instB, depthA = 0, tempA = nodeA; tempA; tempA = getParent(tempA))
          depthA++;
        for (var depthB = 0, tempB = nodeB; tempB; tempB = getParent(tempB))
          depthB++;
        for (; depthA - depthB > 0; )
          nodeA = getParent(nodeA), depthA--;
        for (; depthB - depthA > 0; )
          nodeB = getParent(nodeB), depthB--;
        for (var depth = depthA; depth--; ) {
          if (nodeA === nodeB || nodeB !== null && nodeA === nodeB.alternate)
            return nodeA;
          nodeA = getParent(nodeA), nodeB = getParent(nodeB);
        }
        return null;
      }
      function accumulateEnterLeaveListenersForEvent(dispatchQueue, event, target, common, inCapturePhase) {
        for (var registrationName = event._reactName, listeners = [], instance = target; instance !== null && instance !== common; ) {
          var _instance4 = instance, alternate = _instance4.alternate, stateNode = _instance4.stateNode, tag = _instance4.tag;
          if (alternate !== null && alternate === common)
            break;
          if (tag === HostComponent && stateNode !== null) {
            var currentTarget = stateNode;
            if (inCapturePhase) {
              var captureListener = getListener(instance, registrationName);
              captureListener != null && listeners.unshift(createDispatchListener(instance, captureListener, currentTarget));
            } else if (!inCapturePhase) {
              var bubbleListener = getListener(instance, registrationName);
              bubbleListener != null && listeners.push(createDispatchListener(instance, bubbleListener, currentTarget));
            }
          }
          instance = instance.return;
        }
        listeners.length !== 0 && dispatchQueue.push({
          event,
          listeners
        });
      }
      function accumulateEnterLeaveTwoPhaseListeners(dispatchQueue, leaveEvent, enterEvent, from, to) {
        var common = from && to ? getLowestCommonAncestor(from, to) : null;
        from !== null && accumulateEnterLeaveListenersForEvent(dispatchQueue, leaveEvent, from, common, !1), to !== null && enterEvent !== null && accumulateEnterLeaveListenersForEvent(dispatchQueue, enterEvent, to, common, !0);
      }
      function getListenerSetKey(domEventName, capture) {
        return domEventName + "__" + (capture ? "capture" : "bubble");
      }
      var didWarnInvalidHydration = !1, DANGEROUSLY_SET_INNER_HTML = "dangerouslySetInnerHTML", SUPPRESS_CONTENT_EDITABLE_WARNING = "suppressContentEditableWarning", SUPPRESS_HYDRATION_WARNING = "suppressHydrationWarning", AUTOFOCUS = "autoFocus", CHILDREN = "children", STYLE = "style", HTML$1 = "__html", warnedUnknownTags, validatePropertiesInDevelopment, warnForPropDifference, warnForExtraAttributes, warnForInvalidEventListener, canDiffStyleForHydrationWarning, normalizeHTML;
      warnedUnknownTags = {
        // There are working polyfills for <dialog>. Let people use it.
        dialog: !0,
        // Electron ships a custom <webview> tag to display external web content in
        // an isolated frame and process.
        // This tag is not present in non Electron environments such as JSDom which
        // is often used for testing purposes.
        // @see https://electronjs.org/docs/api/webview-tag
        webview: !0
      }, validatePropertiesInDevelopment = function(type, props) {
        validateProperties(type, props), validateProperties$1(type, props), validateProperties$2(type, props, {
          registrationNameDependencies,
          possibleRegistrationNames
        });
      }, canDiffStyleForHydrationWarning = canUseDOM && !document.documentMode, warnForPropDifference = function(propName, serverValue, clientValue) {
        if (!didWarnInvalidHydration) {
          var normalizedClientValue = normalizeMarkupForTextOrAttribute(clientValue), normalizedServerValue = normalizeMarkupForTextOrAttribute(serverValue);
          normalizedServerValue !== normalizedClientValue && (didWarnInvalidHydration = !0, error("Prop `%s` did not match. Server: %s Client: %s", propName, JSON.stringify(normalizedServerValue), JSON.stringify(normalizedClientValue)));
        }
      }, warnForExtraAttributes = function(attributeNames) {
        if (!didWarnInvalidHydration) {
          didWarnInvalidHydration = !0;
          var names = [];
          attributeNames.forEach(function(name) {
            names.push(name);
          }), error("Extra attributes from the server: %s", names);
        }
      }, warnForInvalidEventListener = function(registrationName, listener) {
        listener === !1 ? error("Expected `%s` listener to be a function, instead got `false`.\n\nIf you used to conditionally omit it with %s={condition && value}, pass %s={condition ? value : undefined} instead.", registrationName, registrationName, registrationName) : error("Expected `%s` listener to be a function, instead got a value of `%s` type.", registrationName, typeof listener);
      }, normalizeHTML = function(parent, html) {
        var testElement = parent.namespaceURI === HTML_NAMESPACE ? parent.ownerDocument.createElement(parent.tagName) : parent.ownerDocument.createElementNS(parent.namespaceURI, parent.tagName);
        return testElement.innerHTML = html, testElement.innerHTML;
      };
      var NORMALIZE_NEWLINES_REGEX = /\r\n?/g, NORMALIZE_NULL_AND_REPLACEMENT_REGEX = /\u0000|\uFFFD/g;
      function normalizeMarkupForTextOrAttribute(markup) {
        checkHtmlStringCoercion(markup);
        var markupString = typeof markup == "string" ? markup : "" + markup;
        return markupString.replace(NORMALIZE_NEWLINES_REGEX, `
`).replace(NORMALIZE_NULL_AND_REPLACEMENT_REGEX, "");
      }
      function checkForUnmatchedText(serverText, clientText, isConcurrentMode, shouldWarnDev) {
        var normalizedClientText = normalizeMarkupForTextOrAttribute(clientText), normalizedServerText = normalizeMarkupForTextOrAttribute(serverText);
        if (normalizedServerText !== normalizedClientText && (shouldWarnDev && (didWarnInvalidHydration || (didWarnInvalidHydration = !0, error('Text content did not match. Server: "%s" Client: "%s"', normalizedServerText, normalizedClientText))), isConcurrentMode && enableClientRenderFallbackOnTextMismatch))
          throw new Error("Text content does not match server-rendered HTML.");
      }
      function getOwnerDocumentFromRootContainer(rootContainerElement) {
        return rootContainerElement.nodeType === DOCUMENT_NODE ? rootContainerElement : rootContainerElement.ownerDocument;
      }
      function noop() {
      }
      function trapClickOnNonInteractiveElement(node) {
        node.onclick = noop;
      }
      function setInitialDOMProperties(tag, domElement, rootContainerElement, nextProps, isCustomComponentTag) {
        for (var propKey in nextProps)
          if (nextProps.hasOwnProperty(propKey)) {
            var nextProp = nextProps[propKey];
            if (propKey === STYLE)
              nextProp && Object.freeze(nextProp), setValueForStyles(domElement, nextProp);
            else if (propKey === DANGEROUSLY_SET_INNER_HTML) {
              var nextHtml = nextProp ? nextProp[HTML$1] : void 0;
              nextHtml != null && setInnerHTML(domElement, nextHtml);
            } else if (propKey === CHILDREN)
              if (typeof nextProp == "string") {
                var canSetTextContent = tag !== "textarea" || nextProp !== "";
                canSetTextContent && setTextContent(domElement, nextProp);
              } else
                typeof nextProp == "number" && setTextContent(domElement, "" + nextProp);
            else
              propKey === SUPPRESS_CONTENT_EDITABLE_WARNING || propKey === SUPPRESS_HYDRATION_WARNING || propKey === AUTOFOCUS || (registrationNameDependencies.hasOwnProperty(propKey) ? nextProp != null && (typeof nextProp != "function" && warnForInvalidEventListener(propKey, nextProp), propKey === "onScroll" && listenToNonDelegatedEvent("scroll", domElement)) : nextProp != null && setValueForProperty(domElement, propKey, nextProp, isCustomComponentTag));
          }
      }
      function updateDOMProperties(domElement, updatePayload, wasCustomComponentTag, isCustomComponentTag) {
        for (var i = 0; i < updatePayload.length; i += 2) {
          var propKey = updatePayload[i], propValue = updatePayload[i + 1];
          propKey === STYLE ? setValueForStyles(domElement, propValue) : propKey === DANGEROUSLY_SET_INNER_HTML ? setInnerHTML(domElement, propValue) : propKey === CHILDREN ? setTextContent(domElement, propValue) : setValueForProperty(domElement, propKey, propValue, isCustomComponentTag);
        }
      }
      function createElement(type, props, rootContainerElement, parentNamespace) {
        var isCustomComponentTag, ownerDocument = getOwnerDocumentFromRootContainer(rootContainerElement), domElement, namespaceURI = parentNamespace;
        if (namespaceURI === HTML_NAMESPACE && (namespaceURI = getIntrinsicNamespace(type)), namespaceURI === HTML_NAMESPACE) {
          if (isCustomComponentTag = isCustomComponent(type, props), !isCustomComponentTag && type !== type.toLowerCase() && error("<%s /> is using incorrect casing. Use PascalCase for React components, or lowercase for HTML elements.", type), type === "script") {
            var div = ownerDocument.createElement("div");
            div.innerHTML = "<script></script>";
            var firstChild = div.firstChild;
            domElement = div.removeChild(firstChild);
          } else if (typeof props.is == "string")
            domElement = ownerDocument.createElement(type, {
              is: props.is
            });
          else if (domElement = ownerDocument.createElement(type), type === "select") {
            var node = domElement;
            props.multiple ? node.multiple = !0 : props.size && (node.size = props.size);
          }
        } else
          domElement = ownerDocument.createElementNS(namespaceURI, type);
        return namespaceURI === HTML_NAMESPACE && !isCustomComponentTag && Object.prototype.toString.call(domElement) === "[object HTMLUnknownElement]" && !hasOwnProperty.call(warnedUnknownTags, type) && (warnedUnknownTags[type] = !0, error("The tag <%s> is unrecognized in this browser. If you meant to render a React component, start its name with an uppercase letter.", type)), domElement;
      }
      function createTextNode(text, rootContainerElement) {
        return getOwnerDocumentFromRootContainer(rootContainerElement).createTextNode(text);
      }
      function setInitialProperties(domElement, tag, rawProps, rootContainerElement) {
        var isCustomComponentTag = isCustomComponent(tag, rawProps);
        validatePropertiesInDevelopment(tag, rawProps);
        var props;
        switch (tag) {
          case "dialog":
            listenToNonDelegatedEvent("cancel", domElement), listenToNonDelegatedEvent("close", domElement), props = rawProps;
            break;
          case "iframe":
          case "object":
          case "embed":
            listenToNonDelegatedEvent("load", domElement), props = rawProps;
            break;
          case "video":
          case "audio":
            for (var i = 0; i < mediaEventTypes.length; i++)
              listenToNonDelegatedEvent(mediaEventTypes[i], domElement);
            props = rawProps;
            break;
          case "source":
            listenToNonDelegatedEvent("error", domElement), props = rawProps;
            break;
          case "img":
          case "image":
          case "link":
            listenToNonDelegatedEvent("error", domElement), listenToNonDelegatedEvent("load", domElement), props = rawProps;
            break;
          case "details":
            listenToNonDelegatedEvent("toggle", domElement), props = rawProps;
            break;
          case "input":
            initWrapperState(domElement, rawProps), props = getHostProps(domElement, rawProps), listenToNonDelegatedEvent("invalid", domElement);
            break;
          case "option":
            validateProps(domElement, rawProps), props = rawProps;
            break;
          case "select":
            initWrapperState$1(domElement, rawProps), props = getHostProps$1(domElement, rawProps), listenToNonDelegatedEvent("invalid", domElement);
            break;
          case "textarea":
            initWrapperState$2(domElement, rawProps), props = getHostProps$2(domElement, rawProps), listenToNonDelegatedEvent("invalid", domElement);
            break;
          default:
            props = rawProps;
        }
        switch (assertValidProps(tag, props), setInitialDOMProperties(tag, domElement, rootContainerElement, props, isCustomComponentTag), tag) {
          case "input":
            track(domElement), postMountWrapper(domElement, rawProps, !1);
            break;
          case "textarea":
            track(domElement), postMountWrapper$3(domElement);
            break;
          case "option":
            postMountWrapper$1(domElement, rawProps);
            break;
          case "select":
            postMountWrapper$2(domElement, rawProps);
            break;
          default:
            typeof props.onClick == "function" && trapClickOnNonInteractiveElement(domElement);
            break;
        }
      }
      function diffProperties(domElement, tag, lastRawProps, nextRawProps, rootContainerElement) {
        validatePropertiesInDevelopment(tag, nextRawProps);
        var updatePayload = null, lastProps, nextProps;
        switch (tag) {
          case "input":
            lastProps = getHostProps(domElement, lastRawProps), nextProps = getHostProps(domElement, nextRawProps), updatePayload = [];
            break;
          case "select":
            lastProps = getHostProps$1(domElement, lastRawProps), nextProps = getHostProps$1(domElement, nextRawProps), updatePayload = [];
            break;
          case "textarea":
            lastProps = getHostProps$2(domElement, lastRawProps), nextProps = getHostProps$2(domElement, nextRawProps), updatePayload = [];
            break;
          default:
            lastProps = lastRawProps, nextProps = nextRawProps, typeof lastProps.onClick != "function" && typeof nextProps.onClick == "function" && trapClickOnNonInteractiveElement(domElement);
            break;
        }
        assertValidProps(tag, nextProps);
        var propKey, styleName, styleUpdates = null;
        for (propKey in lastProps)
          if (!(nextProps.hasOwnProperty(propKey) || !lastProps.hasOwnProperty(propKey) || lastProps[propKey] == null))
            if (propKey === STYLE) {
              var lastStyle = lastProps[propKey];
              for (styleName in lastStyle)
                lastStyle.hasOwnProperty(styleName) && (styleUpdates || (styleUpdates = {}), styleUpdates[styleName] = "");
            } else
              propKey === DANGEROUSLY_SET_INNER_HTML || propKey === CHILDREN || propKey === SUPPRESS_CONTENT_EDITABLE_WARNING || propKey === SUPPRESS_HYDRATION_WARNING || propKey === AUTOFOCUS || (registrationNameDependencies.hasOwnProperty(propKey) ? updatePayload || (updatePayload = []) : (updatePayload = updatePayload || []).push(propKey, null));
        for (propKey in nextProps) {
          var nextProp = nextProps[propKey], lastProp = lastProps?.[propKey];
          if (!(!nextProps.hasOwnProperty(propKey) || nextProp === lastProp || nextProp == null && lastProp == null))
            if (propKey === STYLE)
              if (nextProp && Object.freeze(nextProp), lastProp) {
                for (styleName in lastProp)
                  lastProp.hasOwnProperty(styleName) && (!nextProp || !nextProp.hasOwnProperty(styleName)) && (styleUpdates || (styleUpdates = {}), styleUpdates[styleName] = "");
                for (styleName in nextProp)
                  nextProp.hasOwnProperty(styleName) && lastProp[styleName] !== nextProp[styleName] && (styleUpdates || (styleUpdates = {}), styleUpdates[styleName] = nextProp[styleName]);
              } else
                styleUpdates || (updatePayload || (updatePayload = []), updatePayload.push(propKey, styleUpdates)), styleUpdates = nextProp;
            else if (propKey === DANGEROUSLY_SET_INNER_HTML) {
              var nextHtml = nextProp ? nextProp[HTML$1] : void 0, lastHtml = lastProp ? lastProp[HTML$1] : void 0;
              nextHtml != null && lastHtml !== nextHtml && (updatePayload = updatePayload || []).push(propKey, nextHtml);
            } else
              propKey === CHILDREN ? (typeof nextProp == "string" || typeof nextProp == "number") && (updatePayload = updatePayload || []).push(propKey, "" + nextProp) : propKey === SUPPRESS_CONTENT_EDITABLE_WARNING || propKey === SUPPRESS_HYDRATION_WARNING || (registrationNameDependencies.hasOwnProperty(propKey) ? (nextProp != null && (typeof nextProp != "function" && warnForInvalidEventListener(propKey, nextProp), propKey === "onScroll" && listenToNonDelegatedEvent("scroll", domElement)), !updatePayload && lastProp !== nextProp && (updatePayload = [])) : (updatePayload = updatePayload || []).push(propKey, nextProp));
        }
        return styleUpdates && (validateShorthandPropertyCollisionInDev(styleUpdates, nextProps[STYLE]), (updatePayload = updatePayload || []).push(STYLE, styleUpdates)), updatePayload;
      }
      function updateProperties(domElement, updatePayload, tag, lastRawProps, nextRawProps) {
        tag === "input" && nextRawProps.type === "radio" && nextRawProps.name != null && updateChecked(domElement, nextRawProps);
        var wasCustomComponentTag = isCustomComponent(tag, lastRawProps), isCustomComponentTag = isCustomComponent(tag, nextRawProps);
        switch (updateDOMProperties(domElement, updatePayload, wasCustomComponentTag, isCustomComponentTag), tag) {
          case "input":
            updateWrapper(domElement, nextRawProps);
            break;
          case "textarea":
            updateWrapper$1(domElement, nextRawProps);
            break;
          case "select":
            postUpdateWrapper(domElement, nextRawProps);
            break;
        }
      }
      function getPossibleStandardName(propName) {
        {
          var lowerCasedName = propName.toLowerCase();
          return possibleStandardNames.hasOwnProperty(lowerCasedName) && possibleStandardNames[lowerCasedName] || null;
        }
      }
      function diffHydratedProperties(domElement, tag, rawProps, parentNamespace, rootContainerElement, isConcurrentMode, shouldWarnDev) {
        var isCustomComponentTag, extraAttributeNames;
        switch (isCustomComponentTag = isCustomComponent(tag, rawProps), validatePropertiesInDevelopment(tag, rawProps), tag) {
          case "dialog":
            listenToNonDelegatedEvent("cancel", domElement), listenToNonDelegatedEvent("close", domElement);
            break;
          case "iframe":
          case "object":
          case "embed":
            listenToNonDelegatedEvent("load", domElement);
            break;
          case "video":
          case "audio":
            for (var i = 0; i < mediaEventTypes.length; i++)
              listenToNonDelegatedEvent(mediaEventTypes[i], domElement);
            break;
          case "source":
            listenToNonDelegatedEvent("error", domElement);
            break;
          case "img":
          case "image":
          case "link":
            listenToNonDelegatedEvent("error", domElement), listenToNonDelegatedEvent("load", domElement);
            break;
          case "details":
            listenToNonDelegatedEvent("toggle", domElement);
            break;
          case "input":
            initWrapperState(domElement, rawProps), listenToNonDelegatedEvent("invalid", domElement);
            break;
          case "option":
            validateProps(domElement, rawProps);
            break;
          case "select":
            initWrapperState$1(domElement, rawProps), listenToNonDelegatedEvent("invalid", domElement);
            break;
          case "textarea":
            initWrapperState$2(domElement, rawProps), listenToNonDelegatedEvent("invalid", domElement);
            break;
        }
        assertValidProps(tag, rawProps);
        {
          extraAttributeNames = /* @__PURE__ */ new Set();
          for (var attributes = domElement.attributes, _i = 0; _i < attributes.length; _i++) {
            var name = attributes[_i].name.toLowerCase();
            switch (name) {
              case "value":
                break;
              case "checked":
                break;
              case "selected":
                break;
              default:
                extraAttributeNames.add(attributes[_i].name);
            }
          }
        }
        var updatePayload = null;
        for (var propKey in rawProps)
          if (rawProps.hasOwnProperty(propKey)) {
            var nextProp = rawProps[propKey];
            if (propKey === CHILDREN)
              typeof nextProp == "string" ? domElement.textContent !== nextProp && (rawProps[SUPPRESS_HYDRATION_WARNING] !== !0 && checkForUnmatchedText(domElement.textContent, nextProp, isConcurrentMode, shouldWarnDev), updatePayload = [CHILDREN, nextProp]) : typeof nextProp == "number" && domElement.textContent !== "" + nextProp && (rawProps[SUPPRESS_HYDRATION_WARNING] !== !0 && checkForUnmatchedText(domElement.textContent, nextProp, isConcurrentMode, shouldWarnDev), updatePayload = [CHILDREN, "" + nextProp]);
            else if (registrationNameDependencies.hasOwnProperty(propKey))
              nextProp != null && (typeof nextProp != "function" && warnForInvalidEventListener(propKey, nextProp), propKey === "onScroll" && listenToNonDelegatedEvent("scroll", domElement));
            else if (shouldWarnDev && // Convince Flow we've calculated it (it's DEV-only in this method.)
            typeof isCustomComponentTag == "boolean") {
              var serverValue = void 0, propertyInfo = isCustomComponentTag && enableCustomElementPropertySupport ? null : getPropertyInfo(propKey);
              if (rawProps[SUPPRESS_HYDRATION_WARNING] !== !0) {
                if (!(propKey === SUPPRESS_CONTENT_EDITABLE_WARNING || propKey === SUPPRESS_HYDRATION_WARNING || // Controlled attributes are not validated
                // TODO: Only ignore them on controlled tags.
                propKey === "value" || propKey === "checked" || propKey === "selected")) {
                  if (propKey === DANGEROUSLY_SET_INNER_HTML) {
                    var serverHTML = domElement.innerHTML, nextHtml = nextProp ? nextProp[HTML$1] : void 0;
                    if (nextHtml != null) {
                      var expectedHTML = normalizeHTML(domElement, nextHtml);
                      expectedHTML !== serverHTML && warnForPropDifference(propKey, serverHTML, expectedHTML);
                    }
                  } else if (propKey === STYLE) {
                    if (extraAttributeNames.delete(propKey), canDiffStyleForHydrationWarning) {
                      var expectedStyle = createDangerousStringForStyles(nextProp);
                      serverValue = domElement.getAttribute("style"), expectedStyle !== serverValue && warnForPropDifference(propKey, serverValue, expectedStyle);
                    }
                  } else if (isCustomComponentTag && !enableCustomElementPropertySupport)
                    extraAttributeNames.delete(propKey.toLowerCase()), serverValue = getValueForAttribute(domElement, propKey, nextProp), nextProp !== serverValue && warnForPropDifference(propKey, serverValue, nextProp);
                  else if (!shouldIgnoreAttribute(propKey, propertyInfo, isCustomComponentTag) && !shouldRemoveAttribute(propKey, nextProp, propertyInfo, isCustomComponentTag)) {
                    var isMismatchDueToBadCasing = !1;
                    if (propertyInfo !== null)
                      extraAttributeNames.delete(propertyInfo.attributeName), serverValue = getValueForProperty(domElement, propKey, nextProp, propertyInfo);
                    else {
                      var ownNamespace = parentNamespace;
                      if (ownNamespace === HTML_NAMESPACE && (ownNamespace = getIntrinsicNamespace(tag)), ownNamespace === HTML_NAMESPACE)
                        extraAttributeNames.delete(propKey.toLowerCase());
                      else {
                        var standardName = getPossibleStandardName(propKey);
                        standardName !== null && standardName !== propKey && (isMismatchDueToBadCasing = !0, extraAttributeNames.delete(standardName)), extraAttributeNames.delete(propKey);
                      }
                      serverValue = getValueForAttribute(domElement, propKey, nextProp);
                    }
                    var dontWarnCustomElement = enableCustomElementPropertySupport;
                    !dontWarnCustomElement && nextProp !== serverValue && !isMismatchDueToBadCasing && warnForPropDifference(propKey, serverValue, nextProp);
                  }
                }
              }
            }
          }
        switch (shouldWarnDev && // $FlowFixMe - Should be inferred as not undefined.
        extraAttributeNames.size > 0 && rawProps[SUPPRESS_HYDRATION_WARNING] !== !0 && warnForExtraAttributes(extraAttributeNames), tag) {
          case "input":
            track(domElement), postMountWrapper(domElement, rawProps, !0);
            break;
          case "textarea":
            track(domElement), postMountWrapper$3(domElement);
            break;
          case "select":
          case "option":
            break;
          default:
            typeof rawProps.onClick == "function" && trapClickOnNonInteractiveElement(domElement);
            break;
        }
        return updatePayload;
      }
      function diffHydratedText(textNode, text, isConcurrentMode) {
        var isDifferent = textNode.nodeValue !== text;
        return isDifferent;
      }
      function warnForDeletedHydratableElement(parentNode, child) {
        {
          if (didWarnInvalidHydration)
            return;
          didWarnInvalidHydration = !0, error("Did not expect server HTML to contain a <%s> in <%s>.", child.nodeName.toLowerCase(), parentNode.nodeName.toLowerCase());
        }
      }
      function warnForDeletedHydratableText(parentNode, child) {
        {
          if (didWarnInvalidHydration)
            return;
          didWarnInvalidHydration = !0, error('Did not expect server HTML to contain the text node "%s" in <%s>.', child.nodeValue, parentNode.nodeName.toLowerCase());
        }
      }
      function warnForInsertedHydratedElement(parentNode, tag, props) {
        {
          if (didWarnInvalidHydration)
            return;
          didWarnInvalidHydration = !0, error("Expected server HTML to contain a matching <%s> in <%s>.", tag, parentNode.nodeName.toLowerCase());
        }
      }
      function warnForInsertedHydratedText(parentNode, text) {
        {
          if (text === "" || didWarnInvalidHydration)
            return;
          didWarnInvalidHydration = !0, error('Expected server HTML to contain a matching text node for "%s" in <%s>.', text, parentNode.nodeName.toLowerCase());
        }
      }
      function restoreControlledState$3(domElement, tag, props) {
        switch (tag) {
          case "input":
            restoreControlledState(domElement, props);
            return;
          case "textarea":
            restoreControlledState$2(domElement, props);
            return;
          case "select":
            restoreControlledState$1(domElement, props);
            return;
        }
      }
      var validateDOMNesting = function() {
      }, updatedAncestorInfo = function() {
      };
      {
        var specialTags = ["address", "applet", "area", "article", "aside", "base", "basefont", "bgsound", "blockquote", "body", "br", "button", "caption", "center", "col", "colgroup", "dd", "details", "dir", "div", "dl", "dt", "embed", "fieldset", "figcaption", "figure", "footer", "form", "frame", "frameset", "h1", "h2", "h3", "h4", "h5", "h6", "head", "header", "hgroup", "hr", "html", "iframe", "img", "input", "isindex", "li", "link", "listing", "main", "marquee", "menu", "menuitem", "meta", "nav", "noembed", "noframes", "noscript", "object", "ol", "p", "param", "plaintext", "pre", "script", "section", "select", "source", "style", "summary", "table", "tbody", "td", "template", "textarea", "tfoot", "th", "thead", "title", "tr", "track", "ul", "wbr", "xmp"], inScopeTags = [
          "applet",
          "caption",
          "html",
          "table",
          "td",
          "th",
          "marquee",
          "object",
          "template",
          // https://html.spec.whatwg.org/multipage/syntax.html#html-integration-point
          // TODO: Distinguish by namespace here -- for <title>, including it here
          // errs on the side of fewer warnings
          "foreignObject",
          "desc",
          "title"
        ], buttonScopeTags = inScopeTags.concat(["button"]), impliedEndTags = ["dd", "dt", "li", "option", "optgroup", "p", "rp", "rt"], emptyAncestorInfo = {
          current: null,
          formTag: null,
          aTagInScope: null,
          buttonTagInScope: null,
          nobrTagInScope: null,
          pTagInButtonScope: null,
          listItemTagAutoclosing: null,
          dlItemTagAutoclosing: null
        };
        updatedAncestorInfo = function(oldInfo, tag) {
          var ancestorInfo = assign({}, oldInfo || emptyAncestorInfo), info2 = {
            tag
          };
          return inScopeTags.indexOf(tag) !== -1 && (ancestorInfo.aTagInScope = null, ancestorInfo.buttonTagInScope = null, ancestorInfo.nobrTagInScope = null), buttonScopeTags.indexOf(tag) !== -1 && (ancestorInfo.pTagInButtonScope = null), specialTags.indexOf(tag) !== -1 && tag !== "address" && tag !== "div" && tag !== "p" && (ancestorInfo.listItemTagAutoclosing = null, ancestorInfo.dlItemTagAutoclosing = null), ancestorInfo.current = info2, tag === "form" && (ancestorInfo.formTag = info2), tag === "a" && (ancestorInfo.aTagInScope = info2), tag === "button" && (ancestorInfo.buttonTagInScope = info2), tag === "nobr" && (ancestorInfo.nobrTagInScope = info2), tag === "p" && (ancestorInfo.pTagInButtonScope = info2), tag === "li" && (ancestorInfo.listItemTagAutoclosing = info2), (tag === "dd" || tag === "dt") && (ancestorInfo.dlItemTagAutoclosing = info2), ancestorInfo;
        };
        var isTagValidWithParent = function(tag, parentTag) {
          switch (parentTag) {
            case "select":
              return tag === "option" || tag === "optgroup" || tag === "#text";
            case "optgroup":
              return tag === "option" || tag === "#text";
            case "option":
              return tag === "#text";
            case "tr":
              return tag === "th" || tag === "td" || tag === "style" || tag === "script" || tag === "template";
            case "tbody":
            case "thead":
            case "tfoot":
              return tag === "tr" || tag === "style" || tag === "script" || tag === "template";
            case "colgroup":
              return tag === "col" || tag === "template";
            case "table":
              return tag === "caption" || tag === "colgroup" || tag === "tbody" || tag === "tfoot" || tag === "thead" || tag === "style" || tag === "script" || tag === "template";
            case "head":
              return tag === "base" || tag === "basefont" || tag === "bgsound" || tag === "link" || tag === "meta" || tag === "title" || tag === "noscript" || tag === "noframes" || tag === "style" || tag === "script" || tag === "template";
            case "html":
              return tag === "head" || tag === "body" || tag === "frameset";
            case "frameset":
              return tag === "frame";
            case "#document":
              return tag === "html";
          }
          switch (tag) {
            case "h1":
            case "h2":
            case "h3":
            case "h4":
            case "h5":
            case "h6":
              return parentTag !== "h1" && parentTag !== "h2" && parentTag !== "h3" && parentTag !== "h4" && parentTag !== "h5" && parentTag !== "h6";
            case "rp":
            case "rt":
              return impliedEndTags.indexOf(parentTag) === -1;
            case "body":
            case "caption":
            case "col":
            case "colgroup":
            case "frameset":
            case "frame":
            case "head":
            case "html":
            case "tbody":
            case "td":
            case "tfoot":
            case "th":
            case "thead":
            case "tr":
              return parentTag == null;
          }
          return !0;
        }, findInvalidAncestorForTag = function(tag, ancestorInfo) {
          switch (tag) {
            case "address":
            case "article":
            case "aside":
            case "blockquote":
            case "center":
            case "details":
            case "dialog":
            case "dir":
            case "div":
            case "dl":
            case "fieldset":
            case "figcaption":
            case "figure":
            case "footer":
            case "header":
            case "hgroup":
            case "main":
            case "menu":
            case "nav":
            case "ol":
            case "p":
            case "section":
            case "summary":
            case "ul":
            case "pre":
            case "listing":
            case "table":
            case "hr":
            case "xmp":
            case "h1":
            case "h2":
            case "h3":
            case "h4":
            case "h5":
            case "h6":
              return ancestorInfo.pTagInButtonScope;
            case "form":
              return ancestorInfo.formTag || ancestorInfo.pTagInButtonScope;
            case "li":
              return ancestorInfo.listItemTagAutoclosing;
            case "dd":
            case "dt":
              return ancestorInfo.dlItemTagAutoclosing;
            case "button":
              return ancestorInfo.buttonTagInScope;
            case "a":
              return ancestorInfo.aTagInScope;
            case "nobr":
              return ancestorInfo.nobrTagInScope;
          }
          return null;
        }, didWarn$1 = {};
        validateDOMNesting = function(childTag, childText, ancestorInfo) {
          ancestorInfo = ancestorInfo || emptyAncestorInfo;
          var parentInfo = ancestorInfo.current, parentTag = parentInfo && parentInfo.tag;
          childText != null && (childTag != null && error("validateDOMNesting: when childText is passed, childTag should be null"), childTag = "#text");
          var invalidParent = isTagValidWithParent(childTag, parentTag) ? null : parentInfo, invalidAncestor = invalidParent ? null : findInvalidAncestorForTag(childTag, ancestorInfo), invalidParentOrAncestor = invalidParent || invalidAncestor;
          if (invalidParentOrAncestor) {
            var ancestorTag = invalidParentOrAncestor.tag, warnKey = !!invalidParent + "|" + childTag + "|" + ancestorTag;
            if (!didWarn$1[warnKey]) {
              didWarn$1[warnKey] = !0;
              var tagDisplayName = childTag, whitespaceInfo = "";
              if (childTag === "#text" ? /\S/.test(childText) ? tagDisplayName = "Text nodes" : (tagDisplayName = "Whitespace text nodes", whitespaceInfo = " Make sure you don't have any extra whitespace between tags on each line of your source code.") : tagDisplayName = "<" + childTag + ">", invalidParent) {
                var info2 = "";
                ancestorTag === "table" && childTag === "tr" && (info2 += " Add a <tbody>, <thead> or <tfoot> to your code to match the DOM tree generated by the browser."), error("validateDOMNesting(...): %s cannot appear as a child of <%s>.%s%s", tagDisplayName, ancestorTag, whitespaceInfo, info2);
              } else
                error("validateDOMNesting(...): %s cannot appear as a descendant of <%s>.", tagDisplayName, ancestorTag);
            }
          }
        };
      }
      var SUPPRESS_HYDRATION_WARNING$1 = "suppressHydrationWarning", SUSPENSE_START_DATA = "$", SUSPENSE_END_DATA = "/$", SUSPENSE_PENDING_START_DATA = "$?", SUSPENSE_FALLBACK_START_DATA = "$!", STYLE$1 = "style", eventsEnabled = null, selectionInformation = null;
      function getRootHostContext(rootContainerInstance) {
        var type, namespace, nodeType = rootContainerInstance.nodeType;
        switch (nodeType) {
          case DOCUMENT_NODE:
          case DOCUMENT_FRAGMENT_NODE: {
            type = nodeType === DOCUMENT_NODE ? "#document" : "#fragment";
            var root2 = rootContainerInstance.documentElement;
            namespace = root2 ? root2.namespaceURI : getChildNamespace(null, "");
            break;
          }
          default: {
            var container = nodeType === COMMENT_NODE ? rootContainerInstance.parentNode : rootContainerInstance, ownNamespace = container.namespaceURI || null;
            type = container.tagName, namespace = getChildNamespace(ownNamespace, type);
            break;
          }
        }
        {
          var validatedTag = type.toLowerCase(), ancestorInfo = updatedAncestorInfo(null, validatedTag);
          return {
            namespace,
            ancestorInfo
          };
        }
      }
      function getChildHostContext(parentHostContext, type, rootContainerInstance) {
        {
          var parentHostContextDev = parentHostContext, namespace = getChildNamespace(parentHostContextDev.namespace, type), ancestorInfo = updatedAncestorInfo(parentHostContextDev.ancestorInfo, type);
          return {
            namespace,
            ancestorInfo
          };
        }
      }
      function getPublicInstance(instance) {
        return instance;
      }
      function prepareForCommit(containerInfo) {
        eventsEnabled = isEnabled(), selectionInformation = getSelectionInformation();
        var activeInstance = null;
        return setEnabled(!1), activeInstance;
      }
      function resetAfterCommit(containerInfo) {
        restoreSelection(selectionInformation), setEnabled(eventsEnabled), eventsEnabled = null, selectionInformation = null;
      }
      function createInstance(type, props, rootContainerInstance, hostContext, internalInstanceHandle) {
        var parentNamespace;
        {
          var hostContextDev = hostContext;
          if (validateDOMNesting(type, null, hostContextDev.ancestorInfo), typeof props.children == "string" || typeof props.children == "number") {
            var string = "" + props.children, ownAncestorInfo = updatedAncestorInfo(hostContextDev.ancestorInfo, type);
            validateDOMNesting(null, string, ownAncestorInfo);
          }
          parentNamespace = hostContextDev.namespace;
        }
        var domElement = createElement(type, props, rootContainerInstance, parentNamespace);
        return precacheFiberNode(internalInstanceHandle, domElement), updateFiberProps(domElement, props), domElement;
      }
      function appendInitialChild(parentInstance, child) {
        parentInstance.appendChild(child);
      }
      function finalizeInitialChildren(domElement, type, props, rootContainerInstance, hostContext) {
        switch (setInitialProperties(domElement, type, props, rootContainerInstance), type) {
          case "button":
          case "input":
          case "select":
          case "textarea":
            return !!props.autoFocus;
          case "img":
            return !0;
          default:
            return !1;
        }
      }
      function prepareUpdate(domElement, type, oldProps, newProps, rootContainerInstance, hostContext) {
        {
          var hostContextDev = hostContext;
          if (typeof newProps.children != typeof oldProps.children && (typeof newProps.children == "string" || typeof newProps.children == "number")) {
            var string = "" + newProps.children, ownAncestorInfo = updatedAncestorInfo(hostContextDev.ancestorInfo, type);
            validateDOMNesting(null, string, ownAncestorInfo);
          }
        }
        return diffProperties(domElement, type, oldProps, newProps);
      }
      function shouldSetTextContent(type, props) {
        return type === "textarea" || type === "noscript" || typeof props.children == "string" || typeof props.children == "number" || typeof props.dangerouslySetInnerHTML == "object" && props.dangerouslySetInnerHTML !== null && props.dangerouslySetInnerHTML.__html != null;
      }
      function createTextInstance(text, rootContainerInstance, hostContext, internalInstanceHandle) {
        {
          var hostContextDev = hostContext;
          validateDOMNesting(null, text, hostContextDev.ancestorInfo);
        }
        var textNode = createTextNode(text, rootContainerInstance);
        return precacheFiberNode(internalInstanceHandle, textNode), textNode;
      }
      function getCurrentEventPriority() {
        var currentEvent = window.event;
        return currentEvent === void 0 ? DefaultEventPriority : getEventPriority(currentEvent.type);
      }
      var scheduleTimeout = typeof setTimeout == "function" ? setTimeout : void 0, cancelTimeout = typeof clearTimeout == "function" ? clearTimeout : void 0, noTimeout = -1, localPromise = typeof Promise == "function" ? Promise : void 0, scheduleMicrotask = typeof queueMicrotask == "function" ? queueMicrotask : typeof localPromise < "u" ? function(callback) {
        return localPromise.resolve(null).then(callback).catch(handleErrorInNextTick);
      } : scheduleTimeout;
      function handleErrorInNextTick(error2) {
        setTimeout(function() {
          throw error2;
        });
      }
      function commitMount(domElement, type, newProps, internalInstanceHandle) {
        switch (type) {
          case "button":
          case "input":
          case "select":
          case "textarea":
            newProps.autoFocus && domElement.focus();
            return;
          case "img": {
            newProps.src && (domElement.src = newProps.src);
            return;
          }
        }
      }
      function commitUpdate(domElement, updatePayload, type, oldProps, newProps, internalInstanceHandle) {
        updateProperties(domElement, updatePayload, type, oldProps, newProps), updateFiberProps(domElement, newProps);
      }
      function resetTextContent(domElement) {
        setTextContent(domElement, "");
      }
      function commitTextUpdate(textInstance, oldText, newText) {
        textInstance.nodeValue = newText;
      }
      function appendChild(parentInstance, child) {
        parentInstance.appendChild(child);
      }
      function appendChildToContainer(container, child) {
        var parentNode;
        container.nodeType === COMMENT_NODE ? (parentNode = container.parentNode, parentNode.insertBefore(child, container)) : (parentNode = container, parentNode.appendChild(child));
        var reactRootContainer = container._reactRootContainer;
        reactRootContainer == null && parentNode.onclick === null && trapClickOnNonInteractiveElement(parentNode);
      }
      function insertBefore(parentInstance, child, beforeChild) {
        parentInstance.insertBefore(child, beforeChild);
      }
      function insertInContainerBefore(container, child, beforeChild) {
        container.nodeType === COMMENT_NODE ? container.parentNode.insertBefore(child, beforeChild) : container.insertBefore(child, beforeChild);
      }
      function removeChild(parentInstance, child) {
        parentInstance.removeChild(child);
      }
      function removeChildFromContainer(container, child) {
        container.nodeType === COMMENT_NODE ? container.parentNode.removeChild(child) : container.removeChild(child);
      }
      function clearSuspenseBoundary(parentInstance, suspenseInstance) {
        var node = suspenseInstance, depth = 0;
        do {
          var nextNode = node.nextSibling;
          if (parentInstance.removeChild(node), nextNode && nextNode.nodeType === COMMENT_NODE) {
            var data = nextNode.data;
            if (data === SUSPENSE_END_DATA)
              if (depth === 0) {
                parentInstance.removeChild(nextNode), retryIfBlockedOn(suspenseInstance);
                return;
              } else
                depth--;
            else
              (data === SUSPENSE_START_DATA || data === SUSPENSE_PENDING_START_DATA || data === SUSPENSE_FALLBACK_START_DATA) && depth++;
          }
          node = nextNode;
        } while (node);
        retryIfBlockedOn(suspenseInstance);
      }
      function clearSuspenseBoundaryFromContainer(container, suspenseInstance) {
        container.nodeType === COMMENT_NODE ? clearSuspenseBoundary(container.parentNode, suspenseInstance) : container.nodeType === ELEMENT_NODE && clearSuspenseBoundary(container, suspenseInstance), retryIfBlockedOn(container);
      }
      function hideInstance(instance) {
        instance = instance;
        var style2 = instance.style;
        typeof style2.setProperty == "function" ? style2.setProperty("display", "none", "important") : style2.display = "none";
      }
      function hideTextInstance(textInstance) {
        textInstance.nodeValue = "";
      }
      function unhideInstance(instance, props) {
        instance = instance;
        var styleProp = props[STYLE$1], display = styleProp != null && styleProp.hasOwnProperty("display") ? styleProp.display : null;
        instance.style.display = dangerousStyleValue("display", display);
      }
      function unhideTextInstance(textInstance, text) {
        textInstance.nodeValue = text;
      }
      function clearContainer(container) {
        container.nodeType === ELEMENT_NODE ? container.textContent = "" : container.nodeType === DOCUMENT_NODE && container.documentElement && container.removeChild(container.documentElement);
      }
      function canHydrateInstance(instance, type, props) {
        return instance.nodeType !== ELEMENT_NODE || type.toLowerCase() !== instance.nodeName.toLowerCase() ? null : instance;
      }
      function canHydrateTextInstance(instance, text) {
        return text === "" || instance.nodeType !== TEXT_NODE ? null : instance;
      }
      function canHydrateSuspenseInstance(instance) {
        return instance.nodeType !== COMMENT_NODE ? null : instance;
      }
      function isSuspenseInstancePending(instance) {
        return instance.data === SUSPENSE_PENDING_START_DATA;
      }
      function isSuspenseInstanceFallback(instance) {
        return instance.data === SUSPENSE_FALLBACK_START_DATA;
      }
      function getSuspenseInstanceFallbackErrorDetails(instance) {
        var dataset = instance.nextSibling && instance.nextSibling.dataset, digest, message, stack;
        return dataset && (digest = dataset.dgst, message = dataset.msg, stack = dataset.stck), {
          message,
          digest,
          stack
        };
      }
      function registerSuspenseInstanceRetry(instance, callback) {
        instance._reactRetry = callback;
      }
      function getNextHydratable(node) {
        for (; node != null; node = node.nextSibling) {
          var nodeType = node.nodeType;
          if (nodeType === ELEMENT_NODE || nodeType === TEXT_NODE)
            break;
          if (nodeType === COMMENT_NODE) {
            var nodeData = node.data;
            if (nodeData === SUSPENSE_START_DATA || nodeData === SUSPENSE_FALLBACK_START_DATA || nodeData === SUSPENSE_PENDING_START_DATA)
              break;
            if (nodeData === SUSPENSE_END_DATA)
              return null;
          }
        }
        return node;
      }
      function getNextHydratableSibling(instance) {
        return getNextHydratable(instance.nextSibling);
      }
      function getFirstHydratableChild(parentInstance) {
        return getNextHydratable(parentInstance.firstChild);
      }
      function getFirstHydratableChildWithinContainer(parentContainer) {
        return getNextHydratable(parentContainer.firstChild);
      }
      function getFirstHydratableChildWithinSuspenseInstance(parentInstance) {
        return getNextHydratable(parentInstance.nextSibling);
      }
      function hydrateInstance(instance, type, props, rootContainerInstance, hostContext, internalInstanceHandle, shouldWarnDev) {
        precacheFiberNode(internalInstanceHandle, instance), updateFiberProps(instance, props);
        var parentNamespace;
        {
          var hostContextDev = hostContext;
          parentNamespace = hostContextDev.namespace;
        }
        var isConcurrentMode = (internalInstanceHandle.mode & ConcurrentMode) !== NoMode;
        return diffHydratedProperties(instance, type, props, parentNamespace, rootContainerInstance, isConcurrentMode, shouldWarnDev);
      }
      function hydrateTextInstance(textInstance, text, internalInstanceHandle, shouldWarnDev) {
        precacheFiberNode(internalInstanceHandle, textInstance);
        var isConcurrentMode = (internalInstanceHandle.mode & ConcurrentMode) !== NoMode;
        return diffHydratedText(textInstance, text);
      }
      function hydrateSuspenseInstance(suspenseInstance, internalInstanceHandle) {
        precacheFiberNode(internalInstanceHandle, suspenseInstance);
      }
      function getNextHydratableInstanceAfterSuspenseInstance(suspenseInstance) {
        for (var node = suspenseInstance.nextSibling, depth = 0; node; ) {
          if (node.nodeType === COMMENT_NODE) {
            var data = node.data;
            if (data === SUSPENSE_END_DATA) {
              if (depth === 0)
                return getNextHydratableSibling(node);
              depth--;
            } else
              (data === SUSPENSE_START_DATA || data === SUSPENSE_FALLBACK_START_DATA || data === SUSPENSE_PENDING_START_DATA) && depth++;
          }
          node = node.nextSibling;
        }
        return null;
      }
      function getParentSuspenseInstance(targetInstance) {
        for (var node = targetInstance.previousSibling, depth = 0; node; ) {
          if (node.nodeType === COMMENT_NODE) {
            var data = node.data;
            if (data === SUSPENSE_START_DATA || data === SUSPENSE_FALLBACK_START_DATA || data === SUSPENSE_PENDING_START_DATA) {
              if (depth === 0)
                return node;
              depth--;
            } else
              data === SUSPENSE_END_DATA && depth++;
          }
          node = node.previousSibling;
        }
        return null;
      }
      function commitHydratedContainer(container) {
        retryIfBlockedOn(container);
      }
      function commitHydratedSuspenseInstance(suspenseInstance) {
        retryIfBlockedOn(suspenseInstance);
      }
      function shouldDeleteUnhydratedTailInstances(parentType) {
        return parentType !== "head" && parentType !== "body";
      }
      function didNotMatchHydratedContainerTextInstance(parentContainer, textInstance, text, isConcurrentMode) {
        var shouldWarnDev = !0;
        checkForUnmatchedText(textInstance.nodeValue, text, isConcurrentMode, shouldWarnDev);
      }
      function didNotMatchHydratedTextInstance(parentType, parentProps, parentInstance, textInstance, text, isConcurrentMode) {
        if (parentProps[SUPPRESS_HYDRATION_WARNING$1] !== !0) {
          var shouldWarnDev = !0;
          checkForUnmatchedText(textInstance.nodeValue, text, isConcurrentMode, shouldWarnDev);
        }
      }
      function didNotHydrateInstanceWithinContainer(parentContainer, instance) {
        instance.nodeType === ELEMENT_NODE ? warnForDeletedHydratableElement(parentContainer, instance) : instance.nodeType === COMMENT_NODE || warnForDeletedHydratableText(parentContainer, instance);
      }
      function didNotHydrateInstanceWithinSuspenseInstance(parentInstance, instance) {
        {
          var parentNode = parentInstance.parentNode;
          parentNode !== null && (instance.nodeType === ELEMENT_NODE ? warnForDeletedHydratableElement(parentNode, instance) : instance.nodeType === COMMENT_NODE || warnForDeletedHydratableText(parentNode, instance));
        }
      }
      function didNotHydrateInstance(parentType, parentProps, parentInstance, instance, isConcurrentMode) {
        (isConcurrentMode || parentProps[SUPPRESS_HYDRATION_WARNING$1] !== !0) && (instance.nodeType === ELEMENT_NODE ? warnForDeletedHydratableElement(parentInstance, instance) : instance.nodeType === COMMENT_NODE || warnForDeletedHydratableText(parentInstance, instance));
      }
      function didNotFindHydratableInstanceWithinContainer(parentContainer, type, props) {
        warnForInsertedHydratedElement(parentContainer, type);
      }
      function didNotFindHydratableTextInstanceWithinContainer(parentContainer, text) {
        warnForInsertedHydratedText(parentContainer, text);
      }
      function didNotFindHydratableInstanceWithinSuspenseInstance(parentInstance, type, props) {
        {
          var parentNode = parentInstance.parentNode;
          parentNode !== null && warnForInsertedHydratedElement(parentNode, type);
        }
      }
      function didNotFindHydratableTextInstanceWithinSuspenseInstance(parentInstance, text) {
        {
          var parentNode = parentInstance.parentNode;
          parentNode !== null && warnForInsertedHydratedText(parentNode, text);
        }
      }
      function didNotFindHydratableInstance(parentType, parentProps, parentInstance, type, props, isConcurrentMode) {
        (isConcurrentMode || parentProps[SUPPRESS_HYDRATION_WARNING$1] !== !0) && warnForInsertedHydratedElement(parentInstance, type);
      }
      function didNotFindHydratableTextInstance(parentType, parentProps, parentInstance, text, isConcurrentMode) {
        (isConcurrentMode || parentProps[SUPPRESS_HYDRATION_WARNING$1] !== !0) && warnForInsertedHydratedText(parentInstance, text);
      }
      function errorHydratingContainer(parentContainer) {
        error("An error occurred during hydration. The server HTML was replaced with client content in <%s>.", parentContainer.nodeName.toLowerCase());
      }
      function preparePortalMount(portalInstance) {
        listenToAllSupportedEvents(portalInstance);
      }
      var randomKey = Math.random().toString(36).slice(2), internalInstanceKey = "__reactFiber$" + randomKey, internalPropsKey = "__reactProps$" + randomKey, internalContainerInstanceKey = "__reactContainer$" + randomKey, internalEventHandlersKey = "__reactEvents$" + randomKey, internalEventHandlerListenersKey = "__reactListeners$" + randomKey, internalEventHandlesSetKey = "__reactHandles$" + randomKey;
      function detachDeletedInstance(node) {
        delete node[internalInstanceKey], delete node[internalPropsKey], delete node[internalEventHandlersKey], delete node[internalEventHandlerListenersKey], delete node[internalEventHandlesSetKey];
      }
      function precacheFiberNode(hostInst, node) {
        node[internalInstanceKey] = hostInst;
      }
      function markContainerAsRoot(hostRoot, node) {
        node[internalContainerInstanceKey] = hostRoot;
      }
      function unmarkContainerAsRoot(node) {
        node[internalContainerInstanceKey] = null;
      }
      function isContainerMarkedAsRoot(node) {
        return !!node[internalContainerInstanceKey];
      }
      function getClosestInstanceFromNode(targetNode) {
        var targetInst = targetNode[internalInstanceKey];
        if (targetInst)
          return targetInst;
        for (var parentNode = targetNode.parentNode; parentNode; ) {
          if (targetInst = parentNode[internalContainerInstanceKey] || parentNode[internalInstanceKey], targetInst) {
            var alternate = targetInst.alternate;
            if (targetInst.child !== null || alternate !== null && alternate.child !== null)
              for (var suspenseInstance = getParentSuspenseInstance(targetNode); suspenseInstance !== null; ) {
                var targetSuspenseInst = suspenseInstance[internalInstanceKey];
                if (targetSuspenseInst)
                  return targetSuspenseInst;
                suspenseInstance = getParentSuspenseInstance(suspenseInstance);
              }
            return targetInst;
          }
          targetNode = parentNode, parentNode = targetNode.parentNode;
        }
        return null;
      }
      function getInstanceFromNode(node) {
        var inst = node[internalInstanceKey] || node[internalContainerInstanceKey];
        return inst && (inst.tag === HostComponent || inst.tag === HostText || inst.tag === SuspenseComponent || inst.tag === HostRoot) ? inst : null;
      }
      function getNodeFromInstance(inst) {
        if (inst.tag === HostComponent || inst.tag === HostText)
          return inst.stateNode;
        throw new Error("getNodeFromInstance: Invalid argument.");
      }
      function getFiberCurrentPropsFromNode(node) {
        return node[internalPropsKey] || null;
      }
      function updateFiberProps(node, props) {
        node[internalPropsKey] = props;
      }
      function getEventListenerSet(node) {
        var elementListenerSet = node[internalEventHandlersKey];
        return elementListenerSet === void 0 && (elementListenerSet = node[internalEventHandlersKey] = /* @__PURE__ */ new Set()), elementListenerSet;
      }
      var loggedTypeFailures = {}, ReactDebugCurrentFrame$1 = ReactSharedInternals.ReactDebugCurrentFrame;
      function setCurrentlyValidatingElement(element) {
        if (element) {
          var owner = element._owner, stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
          ReactDebugCurrentFrame$1.setExtraStackFrame(stack);
        } else
          ReactDebugCurrentFrame$1.setExtraStackFrame(null);
      }
      function checkPropTypes(typeSpecs, values, location2, componentName, element) {
        {
          var has3 = Function.call.bind(hasOwnProperty);
          for (var typeSpecName in typeSpecs)
            if (has3(typeSpecs, typeSpecName)) {
              var error$1 = void 0;
              try {
                if (typeof typeSpecs[typeSpecName] != "function") {
                  var err2 = Error((componentName || "React class") + ": " + location2 + " type `" + typeSpecName + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof typeSpecs[typeSpecName] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                  throw err2.name = "Invariant Violation", err2;
                }
                error$1 = typeSpecs[typeSpecName](values, typeSpecName, componentName, location2, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
              } catch (ex) {
                error$1 = ex;
              }
              error$1 && !(error$1 instanceof Error) && (setCurrentlyValidatingElement(element), error("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", componentName || "React class", location2, typeSpecName, typeof error$1), setCurrentlyValidatingElement(null)), error$1 instanceof Error && !(error$1.message in loggedTypeFailures) && (loggedTypeFailures[error$1.message] = !0, setCurrentlyValidatingElement(element), error("Failed %s type: %s", location2, error$1.message), setCurrentlyValidatingElement(null));
            }
        }
      }
      var valueStack = [], fiberStack;
      fiberStack = [];
      var index = -1;
      function createCursor(defaultValue) {
        return {
          current: defaultValue
        };
      }
      function pop(cursor, fiber) {
        if (index < 0) {
          error("Unexpected pop.");
          return;
        }
        fiber !== fiberStack[index] && error("Unexpected Fiber popped."), cursor.current = valueStack[index], valueStack[index] = null, fiberStack[index] = null, index--;
      }
      function push2(cursor, value, fiber) {
        index++, valueStack[index] = cursor.current, fiberStack[index] = fiber, cursor.current = value;
      }
      var warnedAboutMissingGetChildContext;
      warnedAboutMissingGetChildContext = {};
      var emptyContextObject = {};
      Object.freeze(emptyContextObject);
      var contextStackCursor = createCursor(emptyContextObject), didPerformWorkStackCursor = createCursor(!1), previousContext = emptyContextObject;
      function getUnmaskedContext(workInProgress2, Component, didPushOwnContextIfProvider) {
        return didPushOwnContextIfProvider && isContextProvider(Component) ? previousContext : contextStackCursor.current;
      }
      function cacheContext(workInProgress2, unmaskedContext, maskedContext) {
        {
          var instance = workInProgress2.stateNode;
          instance.__reactInternalMemoizedUnmaskedChildContext = unmaskedContext, instance.__reactInternalMemoizedMaskedChildContext = maskedContext;
        }
      }
      function getMaskedContext(workInProgress2, unmaskedContext) {
        {
          var type = workInProgress2.type, contextTypes = type.contextTypes;
          if (!contextTypes)
            return emptyContextObject;
          var instance = workInProgress2.stateNode;
          if (instance && instance.__reactInternalMemoizedUnmaskedChildContext === unmaskedContext)
            return instance.__reactInternalMemoizedMaskedChildContext;
          var context = {};
          for (var key in contextTypes)
            context[key] = unmaskedContext[key];
          {
            var name = getComponentNameFromFiber(workInProgress2) || "Unknown";
            checkPropTypes(contextTypes, context, "context", name);
          }
          return instance && cacheContext(workInProgress2, unmaskedContext, context), context;
        }
      }
      function hasContextChanged() {
        return didPerformWorkStackCursor.current;
      }
      function isContextProvider(type) {
        {
          var childContextTypes = type.childContextTypes;
          return childContextTypes != null;
        }
      }
      function popContext(fiber) {
        pop(didPerformWorkStackCursor, fiber), pop(contextStackCursor, fiber);
      }
      function popTopLevelContextObject(fiber) {
        pop(didPerformWorkStackCursor, fiber), pop(contextStackCursor, fiber);
      }
      function pushTopLevelContextObject(fiber, context, didChange) {
        {
          if (contextStackCursor.current !== emptyContextObject)
            throw new Error("Unexpected context found on stack. This error is likely caused by a bug in React. Please file an issue.");
          push2(contextStackCursor, context, fiber), push2(didPerformWorkStackCursor, didChange, fiber);
        }
      }
      function processChildContext(fiber, type, parentContext) {
        {
          var instance = fiber.stateNode, childContextTypes = type.childContextTypes;
          if (typeof instance.getChildContext != "function") {
            {
              var componentName = getComponentNameFromFiber(fiber) || "Unknown";
              warnedAboutMissingGetChildContext[componentName] || (warnedAboutMissingGetChildContext[componentName] = !0, error("%s.childContextTypes is specified but there is no getChildContext() method on the instance. You can either define getChildContext() on %s or remove childContextTypes from it.", componentName, componentName));
            }
            return parentContext;
          }
          var childContext = instance.getChildContext();
          for (var contextKey in childContext)
            if (!(contextKey in childContextTypes))
              throw new Error((getComponentNameFromFiber(fiber) || "Unknown") + '.getChildContext(): key "' + contextKey + '" is not defined in childContextTypes.');
          {
            var name = getComponentNameFromFiber(fiber) || "Unknown";
            checkPropTypes(childContextTypes, childContext, "child context", name);
          }
          return assign({}, parentContext, childContext);
        }
      }
      function pushContextProvider(workInProgress2) {
        {
          var instance = workInProgress2.stateNode, memoizedMergedChildContext = instance && instance.__reactInternalMemoizedMergedChildContext || emptyContextObject;
          return previousContext = contextStackCursor.current, push2(contextStackCursor, memoizedMergedChildContext, workInProgress2), push2(didPerformWorkStackCursor, didPerformWorkStackCursor.current, workInProgress2), !0;
        }
      }
      function invalidateContextProvider(workInProgress2, type, didChange) {
        {
          var instance = workInProgress2.stateNode;
          if (!instance)
            throw new Error("Expected to have an instance by this point. This error is likely caused by a bug in React. Please file an issue.");
          if (didChange) {
            var mergedContext = processChildContext(workInProgress2, type, previousContext);
            instance.__reactInternalMemoizedMergedChildContext = mergedContext, pop(didPerformWorkStackCursor, workInProgress2), pop(contextStackCursor, workInProgress2), push2(contextStackCursor, mergedContext, workInProgress2), push2(didPerformWorkStackCursor, didChange, workInProgress2);
          } else
            pop(didPerformWorkStackCursor, workInProgress2), push2(didPerformWorkStackCursor, didChange, workInProgress2);
        }
      }
      function findCurrentUnmaskedContext(fiber) {
        {
          if (!isFiberMounted(fiber) || fiber.tag !== ClassComponent)
            throw new Error("Expected subtree parent to be a mounted class component. This error is likely caused by a bug in React. Please file an issue.");
          var node = fiber;
          do {
            switch (node.tag) {
              case HostRoot:
                return node.stateNode.context;
              case ClassComponent: {
                var Component = node.type;
                if (isContextProvider(Component))
                  return node.stateNode.__reactInternalMemoizedMergedChildContext;
                break;
              }
            }
            node = node.return;
          } while (node !== null);
          throw new Error("Found unexpected detached subtree parent. This error is likely caused by a bug in React. Please file an issue.");
        }
      }
      var LegacyRoot = 0, ConcurrentRoot = 1, syncQueue = null, includesLegacySyncCallbacks = !1, isFlushingSyncQueue = !1;
      function scheduleSyncCallback(callback) {
        syncQueue === null ? syncQueue = [callback] : syncQueue.push(callback);
      }
      function scheduleLegacySyncCallback(callback) {
        includesLegacySyncCallbacks = !0, scheduleSyncCallback(callback);
      }
      function flushSyncCallbacksOnlyInLegacyMode() {
        includesLegacySyncCallbacks && flushSyncCallbacks();
      }
      function flushSyncCallbacks() {
        if (!isFlushingSyncQueue && syncQueue !== null) {
          isFlushingSyncQueue = !0;
          var i = 0, previousUpdatePriority = getCurrentUpdatePriority();
          try {
            var isSync = !0, queue = syncQueue;
            for (setCurrentUpdatePriority(DiscreteEventPriority); i < queue.length; i++) {
              var callback = queue[i];
              do
                callback = callback(isSync);
              while (callback !== null);
            }
            syncQueue = null, includesLegacySyncCallbacks = !1;
          } catch (error2) {
            throw syncQueue !== null && (syncQueue = syncQueue.slice(i + 1)), scheduleCallback(ImmediatePriority, flushSyncCallbacks), error2;
          } finally {
            setCurrentUpdatePriority(previousUpdatePriority), isFlushingSyncQueue = !1;
          }
        }
        return null;
      }
      var forkStack = [], forkStackIndex = 0, treeForkProvider = null, treeForkCount = 0, idStack = [], idStackIndex = 0, treeContextProvider = null, treeContextId = 1, treeContextOverflow = "";
      function isForkedChild(workInProgress2) {
        return warnIfNotHydrating(), (workInProgress2.flags & Forked) !== NoFlags;
      }
      function getForksAtLevel(workInProgress2) {
        return warnIfNotHydrating(), treeForkCount;
      }
      function getTreeId() {
        var overflow = treeContextOverflow, idWithLeadingBit = treeContextId, id = idWithLeadingBit & ~getLeadingBit(idWithLeadingBit);
        return id.toString(32) + overflow;
      }
      function pushTreeFork(workInProgress2, totalChildren) {
        warnIfNotHydrating(), forkStack[forkStackIndex++] = treeForkCount, forkStack[forkStackIndex++] = treeForkProvider, treeForkProvider = workInProgress2, treeForkCount = totalChildren;
      }
      function pushTreeId(workInProgress2, totalChildren, index2) {
        warnIfNotHydrating(), idStack[idStackIndex++] = treeContextId, idStack[idStackIndex++] = treeContextOverflow, idStack[idStackIndex++] = treeContextProvider, treeContextProvider = workInProgress2;
        var baseIdWithLeadingBit = treeContextId, baseOverflow = treeContextOverflow, baseLength = getBitLength(baseIdWithLeadingBit) - 1, baseId = baseIdWithLeadingBit & ~(1 << baseLength), slot = index2 + 1, length = getBitLength(totalChildren) + baseLength;
        if (length > 30) {
          var numberOfOverflowBits = baseLength - baseLength % 5, newOverflowBits = (1 << numberOfOverflowBits) - 1, newOverflow = (baseId & newOverflowBits).toString(32), restOfBaseId = baseId >> numberOfOverflowBits, restOfBaseLength = baseLength - numberOfOverflowBits, restOfLength = getBitLength(totalChildren) + restOfBaseLength, restOfNewBits = slot << restOfBaseLength, id = restOfNewBits | restOfBaseId, overflow = newOverflow + baseOverflow;
          treeContextId = 1 << restOfLength | id, treeContextOverflow = overflow;
        } else {
          var newBits = slot << baseLength, _id = newBits | baseId, _overflow = baseOverflow;
          treeContextId = 1 << length | _id, treeContextOverflow = _overflow;
        }
      }
      function pushMaterializedTreeId(workInProgress2) {
        warnIfNotHydrating();
        var returnFiber = workInProgress2.return;
        if (returnFiber !== null) {
          var numberOfForks = 1, slotIndex = 0;
          pushTreeFork(workInProgress2, numberOfForks), pushTreeId(workInProgress2, numberOfForks, slotIndex);
        }
      }
      function getBitLength(number) {
        return 32 - clz32(number);
      }
      function getLeadingBit(id) {
        return 1 << getBitLength(id) - 1;
      }
      function popTreeContext(workInProgress2) {
        for (; workInProgress2 === treeForkProvider; )
          treeForkProvider = forkStack[--forkStackIndex], forkStack[forkStackIndex] = null, treeForkCount = forkStack[--forkStackIndex], forkStack[forkStackIndex] = null;
        for (; workInProgress2 === treeContextProvider; )
          treeContextProvider = idStack[--idStackIndex], idStack[idStackIndex] = null, treeContextOverflow = idStack[--idStackIndex], idStack[idStackIndex] = null, treeContextId = idStack[--idStackIndex], idStack[idStackIndex] = null;
      }
      function getSuspendedTreeContext() {
        return warnIfNotHydrating(), treeContextProvider !== null ? {
          id: treeContextId,
          overflow: treeContextOverflow
        } : null;
      }
      function restoreSuspendedTreeContext(workInProgress2, suspendedContext) {
        warnIfNotHydrating(), idStack[idStackIndex++] = treeContextId, idStack[idStackIndex++] = treeContextOverflow, idStack[idStackIndex++] = treeContextProvider, treeContextId = suspendedContext.id, treeContextOverflow = suspendedContext.overflow, treeContextProvider = workInProgress2;
      }
      function warnIfNotHydrating() {
        getIsHydrating() || error("Expected to be hydrating. This is a bug in React. Please file an issue.");
      }
      var hydrationParentFiber = null, nextHydratableInstance = null, isHydrating = !1, didSuspendOrErrorDEV = !1, hydrationErrors = null;
      function warnIfHydrating() {
        isHydrating && error("We should not be hydrating here. This is a bug in React. Please file a bug.");
      }
      function markDidThrowWhileHydratingDEV() {
        didSuspendOrErrorDEV = !0;
      }
      function didSuspendOrErrorWhileHydratingDEV() {
        return didSuspendOrErrorDEV;
      }
      function enterHydrationState(fiber) {
        var parentInstance = fiber.stateNode.containerInfo;
        return nextHydratableInstance = getFirstHydratableChildWithinContainer(parentInstance), hydrationParentFiber = fiber, isHydrating = !0, hydrationErrors = null, didSuspendOrErrorDEV = !1, !0;
      }
      function reenterHydrationStateFromDehydratedSuspenseInstance(fiber, suspenseInstance, treeContext) {
        return nextHydratableInstance = getFirstHydratableChildWithinSuspenseInstance(suspenseInstance), hydrationParentFiber = fiber, isHydrating = !0, hydrationErrors = null, didSuspendOrErrorDEV = !1, treeContext !== null && restoreSuspendedTreeContext(fiber, treeContext), !0;
      }
      function warnUnhydratedInstance(returnFiber, instance) {
        switch (returnFiber.tag) {
          case HostRoot: {
            didNotHydrateInstanceWithinContainer(returnFiber.stateNode.containerInfo, instance);
            break;
          }
          case HostComponent: {
            var isConcurrentMode = (returnFiber.mode & ConcurrentMode) !== NoMode;
            didNotHydrateInstance(
              returnFiber.type,
              returnFiber.memoizedProps,
              returnFiber.stateNode,
              instance,
              // TODO: Delete this argument when we remove the legacy root API.
              isConcurrentMode
            );
            break;
          }
          case SuspenseComponent: {
            var suspenseState = returnFiber.memoizedState;
            suspenseState.dehydrated !== null && didNotHydrateInstanceWithinSuspenseInstance(suspenseState.dehydrated, instance);
            break;
          }
        }
      }
      function deleteHydratableInstance(returnFiber, instance) {
        warnUnhydratedInstance(returnFiber, instance);
        var childToDelete = createFiberFromHostInstanceForDeletion();
        childToDelete.stateNode = instance, childToDelete.return = returnFiber;
        var deletions = returnFiber.deletions;
        deletions === null ? (returnFiber.deletions = [childToDelete], returnFiber.flags |= ChildDeletion) : deletions.push(childToDelete);
      }
      function warnNonhydratedInstance(returnFiber, fiber) {
        {
          if (didSuspendOrErrorDEV)
            return;
          switch (returnFiber.tag) {
            case HostRoot: {
              var parentContainer = returnFiber.stateNode.containerInfo;
              switch (fiber.tag) {
                case HostComponent:
                  var type = fiber.type, props = fiber.pendingProps;
                  didNotFindHydratableInstanceWithinContainer(parentContainer, type);
                  break;
                case HostText:
                  var text = fiber.pendingProps;
                  didNotFindHydratableTextInstanceWithinContainer(parentContainer, text);
                  break;
              }
              break;
            }
            case HostComponent: {
              var parentType = returnFiber.type, parentProps = returnFiber.memoizedProps, parentInstance = returnFiber.stateNode;
              switch (fiber.tag) {
                case HostComponent: {
                  var _type = fiber.type, _props = fiber.pendingProps, isConcurrentMode = (returnFiber.mode & ConcurrentMode) !== NoMode;
                  didNotFindHydratableInstance(
                    parentType,
                    parentProps,
                    parentInstance,
                    _type,
                    _props,
                    // TODO: Delete this argument when we remove the legacy root API.
                    isConcurrentMode
                  );
                  break;
                }
                case HostText: {
                  var _text = fiber.pendingProps, _isConcurrentMode = (returnFiber.mode & ConcurrentMode) !== NoMode;
                  didNotFindHydratableTextInstance(
                    parentType,
                    parentProps,
                    parentInstance,
                    _text,
                    // TODO: Delete this argument when we remove the legacy root API.
                    _isConcurrentMode
                  );
                  break;
                }
              }
              break;
            }
            case SuspenseComponent: {
              var suspenseState = returnFiber.memoizedState, _parentInstance = suspenseState.dehydrated;
              if (_parentInstance !== null)
                switch (fiber.tag) {
                  case HostComponent:
                    var _type2 = fiber.type, _props2 = fiber.pendingProps;
                    didNotFindHydratableInstanceWithinSuspenseInstance(_parentInstance, _type2);
                    break;
                  case HostText:
                    var _text2 = fiber.pendingProps;
                    didNotFindHydratableTextInstanceWithinSuspenseInstance(_parentInstance, _text2);
                    break;
                }
              break;
            }
            default:
              return;
          }
        }
      }
      function insertNonHydratedInstance(returnFiber, fiber) {
        fiber.flags = fiber.flags & ~Hydrating | Placement, warnNonhydratedInstance(returnFiber, fiber);
      }
      function tryHydrate(fiber, nextInstance) {
        switch (fiber.tag) {
          case HostComponent: {
            var type = fiber.type, props = fiber.pendingProps, instance = canHydrateInstance(nextInstance, type);
            return instance !== null ? (fiber.stateNode = instance, hydrationParentFiber = fiber, nextHydratableInstance = getFirstHydratableChild(instance), !0) : !1;
          }
          case HostText: {
            var text = fiber.pendingProps, textInstance = canHydrateTextInstance(nextInstance, text);
            return textInstance !== null ? (fiber.stateNode = textInstance, hydrationParentFiber = fiber, nextHydratableInstance = null, !0) : !1;
          }
          case SuspenseComponent: {
            var suspenseInstance = canHydrateSuspenseInstance(nextInstance);
            if (suspenseInstance !== null) {
              var suspenseState = {
                dehydrated: suspenseInstance,
                treeContext: getSuspendedTreeContext(),
                retryLane: OffscreenLane
              };
              fiber.memoizedState = suspenseState;
              var dehydratedFragment = createFiberFromDehydratedFragment(suspenseInstance);
              return dehydratedFragment.return = fiber, fiber.child = dehydratedFragment, hydrationParentFiber = fiber, nextHydratableInstance = null, !0;
            }
            return !1;
          }
          default:
            return !1;
        }
      }
      function shouldClientRenderOnMismatch(fiber) {
        return (fiber.mode & ConcurrentMode) !== NoMode && (fiber.flags & DidCapture) === NoFlags;
      }
      function throwOnHydrationMismatch(fiber) {
        throw new Error("Hydration failed because the initial UI does not match what was rendered on the server.");
      }
      function tryToClaimNextHydratableInstance(fiber) {
        if (isHydrating) {
          var nextInstance = nextHydratableInstance;
          if (!nextInstance) {
            shouldClientRenderOnMismatch(fiber) && (warnNonhydratedInstance(hydrationParentFiber, fiber), throwOnHydrationMismatch()), insertNonHydratedInstance(hydrationParentFiber, fiber), isHydrating = !1, hydrationParentFiber = fiber;
            return;
          }
          var firstAttemptedInstance = nextInstance;
          if (!tryHydrate(fiber, nextInstance)) {
            shouldClientRenderOnMismatch(fiber) && (warnNonhydratedInstance(hydrationParentFiber, fiber), throwOnHydrationMismatch()), nextInstance = getNextHydratableSibling(firstAttemptedInstance);
            var prevHydrationParentFiber = hydrationParentFiber;
            if (!nextInstance || !tryHydrate(fiber, nextInstance)) {
              insertNonHydratedInstance(hydrationParentFiber, fiber), isHydrating = !1, hydrationParentFiber = fiber;
              return;
            }
            deleteHydratableInstance(prevHydrationParentFiber, firstAttemptedInstance);
          }
        }
      }
      function prepareToHydrateHostInstance(fiber, rootContainerInstance, hostContext) {
        var instance = fiber.stateNode, shouldWarnIfMismatchDev = !didSuspendOrErrorDEV, updatePayload = hydrateInstance(instance, fiber.type, fiber.memoizedProps, rootContainerInstance, hostContext, fiber, shouldWarnIfMismatchDev);
        return fiber.updateQueue = updatePayload, updatePayload !== null;
      }
      function prepareToHydrateHostTextInstance(fiber) {
        var textInstance = fiber.stateNode, textContent = fiber.memoizedProps, shouldUpdate = hydrateTextInstance(textInstance, textContent, fiber);
        if (shouldUpdate) {
          var returnFiber = hydrationParentFiber;
          if (returnFiber !== null)
            switch (returnFiber.tag) {
              case HostRoot: {
                var parentContainer = returnFiber.stateNode.containerInfo, isConcurrentMode = (returnFiber.mode & ConcurrentMode) !== NoMode;
                didNotMatchHydratedContainerTextInstance(
                  parentContainer,
                  textInstance,
                  textContent,
                  // TODO: Delete this argument when we remove the legacy root API.
                  isConcurrentMode
                );
                break;
              }
              case HostComponent: {
                var parentType = returnFiber.type, parentProps = returnFiber.memoizedProps, parentInstance = returnFiber.stateNode, _isConcurrentMode2 = (returnFiber.mode & ConcurrentMode) !== NoMode;
                didNotMatchHydratedTextInstance(
                  parentType,
                  parentProps,
                  parentInstance,
                  textInstance,
                  textContent,
                  // TODO: Delete this argument when we remove the legacy root API.
                  _isConcurrentMode2
                );
                break;
              }
            }
        }
        return shouldUpdate;
      }
      function prepareToHydrateHostSuspenseInstance(fiber) {
        var suspenseState = fiber.memoizedState, suspenseInstance = suspenseState !== null ? suspenseState.dehydrated : null;
        if (!suspenseInstance)
          throw new Error("Expected to have a hydrated suspense instance. This error is likely caused by a bug in React. Please file an issue.");
        hydrateSuspenseInstance(suspenseInstance, fiber);
      }
      function skipPastDehydratedSuspenseInstance(fiber) {
        var suspenseState = fiber.memoizedState, suspenseInstance = suspenseState !== null ? suspenseState.dehydrated : null;
        if (!suspenseInstance)
          throw new Error("Expected to have a hydrated suspense instance. This error is likely caused by a bug in React. Please file an issue.");
        return getNextHydratableInstanceAfterSuspenseInstance(suspenseInstance);
      }
      function popToNextHostParent(fiber) {
        for (var parent = fiber.return; parent !== null && parent.tag !== HostComponent && parent.tag !== HostRoot && parent.tag !== SuspenseComponent; )
          parent = parent.return;
        hydrationParentFiber = parent;
      }
      function popHydrationState(fiber) {
        if (fiber !== hydrationParentFiber)
          return !1;
        if (!isHydrating)
          return popToNextHostParent(fiber), isHydrating = !0, !1;
        if (fiber.tag !== HostRoot && (fiber.tag !== HostComponent || shouldDeleteUnhydratedTailInstances(fiber.type) && !shouldSetTextContent(fiber.type, fiber.memoizedProps))) {
          var nextInstance = nextHydratableInstance;
          if (nextInstance)
            if (shouldClientRenderOnMismatch(fiber))
              warnIfUnhydratedTailNodes(fiber), throwOnHydrationMismatch();
            else
              for (; nextInstance; )
                deleteHydratableInstance(fiber, nextInstance), nextInstance = getNextHydratableSibling(nextInstance);
        }
        return popToNextHostParent(fiber), fiber.tag === SuspenseComponent ? nextHydratableInstance = skipPastDehydratedSuspenseInstance(fiber) : nextHydratableInstance = hydrationParentFiber ? getNextHydratableSibling(fiber.stateNode) : null, !0;
      }
      function hasUnhydratedTailNodes() {
        return isHydrating && nextHydratableInstance !== null;
      }
      function warnIfUnhydratedTailNodes(fiber) {
        for (var nextInstance = nextHydratableInstance; nextInstance; )
          warnUnhydratedInstance(fiber, nextInstance), nextInstance = getNextHydratableSibling(nextInstance);
      }
      function resetHydrationState() {
        hydrationParentFiber = null, nextHydratableInstance = null, isHydrating = !1, didSuspendOrErrorDEV = !1;
      }
      function upgradeHydrationErrorsToRecoverable() {
        hydrationErrors !== null && (queueRecoverableErrors(hydrationErrors), hydrationErrors = null);
      }
      function getIsHydrating() {
        return isHydrating;
      }
      function queueHydrationError(error2) {
        hydrationErrors === null ? hydrationErrors = [error2] : hydrationErrors.push(error2);
      }
      var ReactCurrentBatchConfig$1 = ReactSharedInternals.ReactCurrentBatchConfig, NoTransition = null;
      function requestCurrentTransition() {
        return ReactCurrentBatchConfig$1.transition;
      }
      var ReactStrictModeWarnings = {
        recordUnsafeLifecycleWarnings: function(fiber, instance) {
        },
        flushPendingUnsafeLifecycleWarnings: function() {
        },
        recordLegacyContextWarning: function(fiber, instance) {
        },
        flushLegacyContextWarning: function() {
        },
        discardPendingWarnings: function() {
        }
      };
      {
        var findStrictRoot = function(fiber) {
          for (var maybeStrictRoot = null, node = fiber; node !== null; )
            node.mode & StrictLegacyMode && (maybeStrictRoot = node), node = node.return;
          return maybeStrictRoot;
        }, setToSortedString = function(set3) {
          var array = [];
          return set3.forEach(function(value) {
            array.push(value);
          }), array.sort().join(", ");
        }, pendingComponentWillMountWarnings = [], pendingUNSAFE_ComponentWillMountWarnings = [], pendingComponentWillReceivePropsWarnings = [], pendingUNSAFE_ComponentWillReceivePropsWarnings = [], pendingComponentWillUpdateWarnings = [], pendingUNSAFE_ComponentWillUpdateWarnings = [], didWarnAboutUnsafeLifecycles = /* @__PURE__ */ new Set();
        ReactStrictModeWarnings.recordUnsafeLifecycleWarnings = function(fiber, instance) {
          didWarnAboutUnsafeLifecycles.has(fiber.type) || (typeof instance.componentWillMount == "function" && // Don't warn about react-lifecycles-compat polyfilled components.
          instance.componentWillMount.__suppressDeprecationWarning !== !0 && pendingComponentWillMountWarnings.push(fiber), fiber.mode & StrictLegacyMode && typeof instance.UNSAFE_componentWillMount == "function" && pendingUNSAFE_ComponentWillMountWarnings.push(fiber), typeof instance.componentWillReceiveProps == "function" && instance.componentWillReceiveProps.__suppressDeprecationWarning !== !0 && pendingComponentWillReceivePropsWarnings.push(fiber), fiber.mode & StrictLegacyMode && typeof instance.UNSAFE_componentWillReceiveProps == "function" && pendingUNSAFE_ComponentWillReceivePropsWarnings.push(fiber), typeof instance.componentWillUpdate == "function" && instance.componentWillUpdate.__suppressDeprecationWarning !== !0 && pendingComponentWillUpdateWarnings.push(fiber), fiber.mode & StrictLegacyMode && typeof instance.UNSAFE_componentWillUpdate == "function" && pendingUNSAFE_ComponentWillUpdateWarnings.push(fiber));
        }, ReactStrictModeWarnings.flushPendingUnsafeLifecycleWarnings = function() {
          var componentWillMountUniqueNames = /* @__PURE__ */ new Set();
          pendingComponentWillMountWarnings.length > 0 && (pendingComponentWillMountWarnings.forEach(function(fiber) {
            componentWillMountUniqueNames.add(getComponentNameFromFiber(fiber) || "Component"), didWarnAboutUnsafeLifecycles.add(fiber.type);
          }), pendingComponentWillMountWarnings = []);
          var UNSAFE_componentWillMountUniqueNames = /* @__PURE__ */ new Set();
          pendingUNSAFE_ComponentWillMountWarnings.length > 0 && (pendingUNSAFE_ComponentWillMountWarnings.forEach(function(fiber) {
            UNSAFE_componentWillMountUniqueNames.add(getComponentNameFromFiber(fiber) || "Component"), didWarnAboutUnsafeLifecycles.add(fiber.type);
          }), pendingUNSAFE_ComponentWillMountWarnings = []);
          var componentWillReceivePropsUniqueNames = /* @__PURE__ */ new Set();
          pendingComponentWillReceivePropsWarnings.length > 0 && (pendingComponentWillReceivePropsWarnings.forEach(function(fiber) {
            componentWillReceivePropsUniqueNames.add(getComponentNameFromFiber(fiber) || "Component"), didWarnAboutUnsafeLifecycles.add(fiber.type);
          }), pendingComponentWillReceivePropsWarnings = []);
          var UNSAFE_componentWillReceivePropsUniqueNames = /* @__PURE__ */ new Set();
          pendingUNSAFE_ComponentWillReceivePropsWarnings.length > 0 && (pendingUNSAFE_ComponentWillReceivePropsWarnings.forEach(function(fiber) {
            UNSAFE_componentWillReceivePropsUniqueNames.add(getComponentNameFromFiber(fiber) || "Component"), didWarnAboutUnsafeLifecycles.add(fiber.type);
          }), pendingUNSAFE_ComponentWillReceivePropsWarnings = []);
          var componentWillUpdateUniqueNames = /* @__PURE__ */ new Set();
          pendingComponentWillUpdateWarnings.length > 0 && (pendingComponentWillUpdateWarnings.forEach(function(fiber) {
            componentWillUpdateUniqueNames.add(getComponentNameFromFiber(fiber) || "Component"), didWarnAboutUnsafeLifecycles.add(fiber.type);
          }), pendingComponentWillUpdateWarnings = []);
          var UNSAFE_componentWillUpdateUniqueNames = /* @__PURE__ */ new Set();
          if (pendingUNSAFE_ComponentWillUpdateWarnings.length > 0 && (pendingUNSAFE_ComponentWillUpdateWarnings.forEach(function(fiber) {
            UNSAFE_componentWillUpdateUniqueNames.add(getComponentNameFromFiber(fiber) || "Component"), didWarnAboutUnsafeLifecycles.add(fiber.type);
          }), pendingUNSAFE_ComponentWillUpdateWarnings = []), UNSAFE_componentWillMountUniqueNames.size > 0) {
            var sortedNames = setToSortedString(UNSAFE_componentWillMountUniqueNames);
            error(`Using UNSAFE_componentWillMount in strict mode is not recommended and may indicate bugs in your code. See https://reactjs.org/link/unsafe-component-lifecycles for details.

* Move code with side effects to componentDidMount, and set initial state in the constructor.

Please update the following components: %s`, sortedNames);
          }
          if (UNSAFE_componentWillReceivePropsUniqueNames.size > 0) {
            var _sortedNames = setToSortedString(UNSAFE_componentWillReceivePropsUniqueNames);
            error(`Using UNSAFE_componentWillReceiveProps in strict mode is not recommended and may indicate bugs in your code. See https://reactjs.org/link/unsafe-component-lifecycles for details.

* Move data fetching code or side effects to componentDidUpdate.
* If you're updating state whenever props change, refactor your code to use memoization techniques or move it to static getDerivedStateFromProps. Learn more at: https://reactjs.org/link/derived-state

Please update the following components: %s`, _sortedNames);
          }
          if (UNSAFE_componentWillUpdateUniqueNames.size > 0) {
            var _sortedNames2 = setToSortedString(UNSAFE_componentWillUpdateUniqueNames);
            error(`Using UNSAFE_componentWillUpdate in strict mode is not recommended and may indicate bugs in your code. See https://reactjs.org/link/unsafe-component-lifecycles for details.

* Move data fetching code or side effects to componentDidUpdate.

Please update the following components: %s`, _sortedNames2);
          }
          if (componentWillMountUniqueNames.size > 0) {
            var _sortedNames3 = setToSortedString(componentWillMountUniqueNames);
            warn(`componentWillMount has been renamed, and is not recommended for use. See https://reactjs.org/link/unsafe-component-lifecycles for details.

* Move code with side effects to componentDidMount, and set initial state in the constructor.
* Rename componentWillMount to UNSAFE_componentWillMount to suppress this warning in non-strict mode. In React 18.x, only the UNSAFE_ name will work. To rename all deprecated lifecycles to their new names, you can run \`npx react-codemod rename-unsafe-lifecycles\` in your project source folder.

Please update the following components: %s`, _sortedNames3);
          }
          if (componentWillReceivePropsUniqueNames.size > 0) {
            var _sortedNames4 = setToSortedString(componentWillReceivePropsUniqueNames);
            warn(`componentWillReceiveProps has been renamed, and is not recommended for use. See https://reactjs.org/link/unsafe-component-lifecycles for details.

* Move data fetching code or side effects to componentDidUpdate.
* If you're updating state whenever props change, refactor your code to use memoization techniques or move it to static getDerivedStateFromProps. Learn more at: https://reactjs.org/link/derived-state
* Rename componentWillReceiveProps to UNSAFE_componentWillReceiveProps to suppress this warning in non-strict mode. In React 18.x, only the UNSAFE_ name will work. To rename all deprecated lifecycles to their new names, you can run \`npx react-codemod rename-unsafe-lifecycles\` in your project source folder.

Please update the following components: %s`, _sortedNames4);
          }
          if (componentWillUpdateUniqueNames.size > 0) {
            var _sortedNames5 = setToSortedString(componentWillUpdateUniqueNames);
            warn(`componentWillUpdate has been renamed, and is not recommended for use. See https://reactjs.org/link/unsafe-component-lifecycles for details.

* Move data fetching code or side effects to componentDidUpdate.
* Rename componentWillUpdate to UNSAFE_componentWillUpdate to suppress this warning in non-strict mode. In React 18.x, only the UNSAFE_ name will work. To rename all deprecated lifecycles to their new names, you can run \`npx react-codemod rename-unsafe-lifecycles\` in your project source folder.

Please update the following components: %s`, _sortedNames5);
          }
        };
        var pendingLegacyContextWarning = /* @__PURE__ */ new Map(), didWarnAboutLegacyContext = /* @__PURE__ */ new Set();
        ReactStrictModeWarnings.recordLegacyContextWarning = function(fiber, instance) {
          var strictRoot = findStrictRoot(fiber);
          if (strictRoot === null) {
            error("Expected to find a StrictMode component in a strict mode tree. This error is likely caused by a bug in React. Please file an issue.");
            return;
          }
          if (!didWarnAboutLegacyContext.has(fiber.type)) {
            var warningsForRoot = pendingLegacyContextWarning.get(strictRoot);
            (fiber.type.contextTypes != null || fiber.type.childContextTypes != null || instance !== null && typeof instance.getChildContext == "function") && (warningsForRoot === void 0 && (warningsForRoot = [], pendingLegacyContextWarning.set(strictRoot, warningsForRoot)), warningsForRoot.push(fiber));
          }
        }, ReactStrictModeWarnings.flushLegacyContextWarning = function() {
          pendingLegacyContextWarning.forEach(function(fiberArray, strictRoot) {
            if (fiberArray.length !== 0) {
              var firstFiber = fiberArray[0], uniqueNames = /* @__PURE__ */ new Set();
              fiberArray.forEach(function(fiber) {
                uniqueNames.add(getComponentNameFromFiber(fiber) || "Component"), didWarnAboutLegacyContext.add(fiber.type);
              });
              var sortedNames = setToSortedString(uniqueNames);
              try {
                setCurrentFiber(firstFiber), error(`Legacy context API has been detected within a strict-mode tree.

The old API will be supported in all 16.x releases, but applications using it should migrate to the new version.

Please update the following components: %s

Learn more about this warning here: https://reactjs.org/link/legacy-context`, sortedNames);
              } finally {
                resetCurrentFiber();
              }
            }
          });
        }, ReactStrictModeWarnings.discardPendingWarnings = function() {
          pendingComponentWillMountWarnings = [], pendingUNSAFE_ComponentWillMountWarnings = [], pendingComponentWillReceivePropsWarnings = [], pendingUNSAFE_ComponentWillReceivePropsWarnings = [], pendingComponentWillUpdateWarnings = [], pendingUNSAFE_ComponentWillUpdateWarnings = [], pendingLegacyContextWarning = /* @__PURE__ */ new Map();
        };
      }
      function resolveDefaultProps(Component, baseProps) {
        if (Component && Component.defaultProps) {
          var props = assign({}, baseProps), defaultProps = Component.defaultProps;
          for (var propName in defaultProps)
            props[propName] === void 0 && (props[propName] = defaultProps[propName]);
          return props;
        }
        return baseProps;
      }
      var valueCursor = createCursor(null), rendererSigil;
      rendererSigil = {};
      var currentlyRenderingFiber = null, lastContextDependency = null, lastFullyObservedContext = null, isDisallowedContextReadInDEV = !1;
      function resetContextDependencies() {
        currentlyRenderingFiber = null, lastContextDependency = null, lastFullyObservedContext = null, isDisallowedContextReadInDEV = !1;
      }
      function enterDisallowedContextReadInDEV() {
        isDisallowedContextReadInDEV = !0;
      }
      function exitDisallowedContextReadInDEV() {
        isDisallowedContextReadInDEV = !1;
      }
      function pushProvider(providerFiber, context, nextValue) {
        push2(valueCursor, context._currentValue, providerFiber), context._currentValue = nextValue, context._currentRenderer !== void 0 && context._currentRenderer !== null && context._currentRenderer !== rendererSigil && error("Detected multiple renderers concurrently rendering the same context provider. This is currently unsupported."), context._currentRenderer = rendererSigil;
      }
      function popProvider(context, providerFiber) {
        var currentValue = valueCursor.current;
        pop(valueCursor, providerFiber), context._currentValue = currentValue;
      }
      function scheduleContextWorkOnParentPath(parent, renderLanes2, propagationRoot) {
        for (var node = parent; node !== null; ) {
          var alternate = node.alternate;
          if (isSubsetOfLanes(node.childLanes, renderLanes2) ? alternate !== null && !isSubsetOfLanes(alternate.childLanes, renderLanes2) && (alternate.childLanes = mergeLanes(alternate.childLanes, renderLanes2)) : (node.childLanes = mergeLanes(node.childLanes, renderLanes2), alternate !== null && (alternate.childLanes = mergeLanes(alternate.childLanes, renderLanes2))), node === propagationRoot)
            break;
          node = node.return;
        }
        node !== propagationRoot && error("Expected to find the propagation root when scheduling context work. This error is likely caused by a bug in React. Please file an issue.");
      }
      function propagateContextChange(workInProgress2, context, renderLanes2) {
        propagateContextChange_eager(workInProgress2, context, renderLanes2);
      }
      function propagateContextChange_eager(workInProgress2, context, renderLanes2) {
        var fiber = workInProgress2.child;
        for (fiber !== null && (fiber.return = workInProgress2); fiber !== null; ) {
          var nextFiber = void 0, list2 = fiber.dependencies;
          if (list2 !== null) {
            nextFiber = fiber.child;
            for (var dependency7 = list2.firstContext; dependency7 !== null; ) {
              if (dependency7.context === context) {
                if (fiber.tag === ClassComponent) {
                  var lane = pickArbitraryLane(renderLanes2), update2 = createUpdate(NoTimestamp, lane);
                  update2.tag = ForceUpdate;
                  var updateQueue = fiber.updateQueue;
                  if (updateQueue !== null) {
                    var sharedQueue = updateQueue.shared, pending = sharedQueue.pending;
                    pending === null ? update2.next = update2 : (update2.next = pending.next, pending.next = update2), sharedQueue.pending = update2;
                  }
                }
                fiber.lanes = mergeLanes(fiber.lanes, renderLanes2);
                var alternate = fiber.alternate;
                alternate !== null && (alternate.lanes = mergeLanes(alternate.lanes, renderLanes2)), scheduleContextWorkOnParentPath(fiber.return, renderLanes2, workInProgress2), list2.lanes = mergeLanes(list2.lanes, renderLanes2);
                break;
              }
              dependency7 = dependency7.next;
            }
          } else if (fiber.tag === ContextProvider)
            nextFiber = fiber.type === workInProgress2.type ? null : fiber.child;
          else if (fiber.tag === DehydratedFragment) {
            var parentSuspense = fiber.return;
            if (parentSuspense === null)
              throw new Error("We just came from a parent so we must have had a parent. This is a bug in React.");
            parentSuspense.lanes = mergeLanes(parentSuspense.lanes, renderLanes2);
            var _alternate = parentSuspense.alternate;
            _alternate !== null && (_alternate.lanes = mergeLanes(_alternate.lanes, renderLanes2)), scheduleContextWorkOnParentPath(parentSuspense, renderLanes2, workInProgress2), nextFiber = fiber.sibling;
          } else
            nextFiber = fiber.child;
          if (nextFiber !== null)
            nextFiber.return = fiber;
          else
            for (nextFiber = fiber; nextFiber !== null; ) {
              if (nextFiber === workInProgress2) {
                nextFiber = null;
                break;
              }
              var sibling = nextFiber.sibling;
              if (sibling !== null) {
                sibling.return = nextFiber.return, nextFiber = sibling;
                break;
              }
              nextFiber = nextFiber.return;
            }
          fiber = nextFiber;
        }
      }
      function prepareToReadContext(workInProgress2, renderLanes2) {
        currentlyRenderingFiber = workInProgress2, lastContextDependency = null, lastFullyObservedContext = null;
        var dependencies = workInProgress2.dependencies;
        if (dependencies !== null) {
          var firstContext = dependencies.firstContext;
          firstContext !== null && (includesSomeLane(dependencies.lanes, renderLanes2) && markWorkInProgressReceivedUpdate(), dependencies.firstContext = null);
        }
      }
      function readContext(context) {
        isDisallowedContextReadInDEV && error("Context can only be read while React is rendering. In classes, you can read it in the render method or getDerivedStateFromProps. In function components, you can read it directly in the function body, but not inside Hooks like useReducer() or useMemo().");
        var value = context._currentValue;
        if (lastFullyObservedContext !== context) {
          var contextItem = {
            context,
            memoizedValue: value,
            next: null
          };
          if (lastContextDependency === null) {
            if (currentlyRenderingFiber === null)
              throw new Error("Context can only be read while React is rendering. In classes, you can read it in the render method or getDerivedStateFromProps. In function components, you can read it directly in the function body, but not inside Hooks like useReducer() or useMemo().");
            lastContextDependency = contextItem, currentlyRenderingFiber.dependencies = {
              lanes: NoLanes,
              firstContext: contextItem
            };
          } else
            lastContextDependency = lastContextDependency.next = contextItem;
        }
        return value;
      }
      var concurrentQueues = null;
      function pushConcurrentUpdateQueue(queue) {
        concurrentQueues === null ? concurrentQueues = [queue] : concurrentQueues.push(queue);
      }
      function finishQueueingConcurrentUpdates() {
        if (concurrentQueues !== null) {
          for (var i = 0; i < concurrentQueues.length; i++) {
            var queue = concurrentQueues[i], lastInterleavedUpdate = queue.interleaved;
            if (lastInterleavedUpdate !== null) {
              queue.interleaved = null;
              var firstInterleavedUpdate = lastInterleavedUpdate.next, lastPendingUpdate = queue.pending;
              if (lastPendingUpdate !== null) {
                var firstPendingUpdate = lastPendingUpdate.next;
                lastPendingUpdate.next = firstInterleavedUpdate, lastInterleavedUpdate.next = firstPendingUpdate;
              }
              queue.pending = lastInterleavedUpdate;
            }
          }
          concurrentQueues = null;
        }
      }
      function enqueueConcurrentHookUpdate(fiber, queue, update2, lane) {
        var interleaved = queue.interleaved;
        return interleaved === null ? (update2.next = update2, pushConcurrentUpdateQueue(queue)) : (update2.next = interleaved.next, interleaved.next = update2), queue.interleaved = update2, markUpdateLaneFromFiberToRoot(fiber, lane);
      }
      function enqueueConcurrentHookUpdateAndEagerlyBailout(fiber, queue, update2, lane) {
        var interleaved = queue.interleaved;
        interleaved === null ? (update2.next = update2, pushConcurrentUpdateQueue(queue)) : (update2.next = interleaved.next, interleaved.next = update2), queue.interleaved = update2;
      }
      function enqueueConcurrentClassUpdate(fiber, queue, update2, lane) {
        var interleaved = queue.interleaved;
        return interleaved === null ? (update2.next = update2, pushConcurrentUpdateQueue(queue)) : (update2.next = interleaved.next, interleaved.next = update2), queue.interleaved = update2, markUpdateLaneFromFiberToRoot(fiber, lane);
      }
      function enqueueConcurrentRenderForLane(fiber, lane) {
        return markUpdateLaneFromFiberToRoot(fiber, lane);
      }
      var unsafe_markUpdateLaneFromFiberToRoot = markUpdateLaneFromFiberToRoot;
      function markUpdateLaneFromFiberToRoot(sourceFiber, lane) {
        sourceFiber.lanes = mergeLanes(sourceFiber.lanes, lane);
        var alternate = sourceFiber.alternate;
        alternate !== null && (alternate.lanes = mergeLanes(alternate.lanes, lane)), alternate === null && (sourceFiber.flags & (Placement | Hydrating)) !== NoFlags && warnAboutUpdateOnNotYetMountedFiberInDEV(sourceFiber);
        for (var node = sourceFiber, parent = sourceFiber.return; parent !== null; )
          parent.childLanes = mergeLanes(parent.childLanes, lane), alternate = parent.alternate, alternate !== null ? alternate.childLanes = mergeLanes(alternate.childLanes, lane) : (parent.flags & (Placement | Hydrating)) !== NoFlags && warnAboutUpdateOnNotYetMountedFiberInDEV(sourceFiber), node = parent, parent = parent.return;
        if (node.tag === HostRoot) {
          var root2 = node.stateNode;
          return root2;
        } else
          return null;
      }
      var UpdateState = 0, ReplaceState = 1, ForceUpdate = 2, CaptureUpdate = 3, hasForceUpdate = !1, didWarnUpdateInsideUpdate, currentlyProcessingQueue;
      didWarnUpdateInsideUpdate = !1, currentlyProcessingQueue = null;
      function initializeUpdateQueue(fiber) {
        var queue = {
          baseState: fiber.memoizedState,
          firstBaseUpdate: null,
          lastBaseUpdate: null,
          shared: {
            pending: null,
            interleaved: null,
            lanes: NoLanes
          },
          effects: null
        };
        fiber.updateQueue = queue;
      }
      function cloneUpdateQueue(current2, workInProgress2) {
        var queue = workInProgress2.updateQueue, currentQueue = current2.updateQueue;
        if (queue === currentQueue) {
          var clone = {
            baseState: currentQueue.baseState,
            firstBaseUpdate: currentQueue.firstBaseUpdate,
            lastBaseUpdate: currentQueue.lastBaseUpdate,
            shared: currentQueue.shared,
            effects: currentQueue.effects
          };
          workInProgress2.updateQueue = clone;
        }
      }
      function createUpdate(eventTime, lane) {
        var update2 = {
          eventTime,
          lane,
          tag: UpdateState,
          payload: null,
          callback: null,
          next: null
        };
        return update2;
      }
      function enqueueUpdate(fiber, update2, lane) {
        var updateQueue = fiber.updateQueue;
        if (updateQueue === null)
          return null;
        var sharedQueue = updateQueue.shared;
        if (currentlyProcessingQueue === sharedQueue && !didWarnUpdateInsideUpdate && (error("An update (setState, replaceState, or forceUpdate) was scheduled from inside an update function. Update functions should be pure, with zero side-effects. Consider using componentDidUpdate or a callback."), didWarnUpdateInsideUpdate = !0), isUnsafeClassRenderPhaseUpdate()) {
          var pending = sharedQueue.pending;
          return pending === null ? update2.next = update2 : (update2.next = pending.next, pending.next = update2), sharedQueue.pending = update2, unsafe_markUpdateLaneFromFiberToRoot(fiber, lane);
        } else
          return enqueueConcurrentClassUpdate(fiber, sharedQueue, update2, lane);
      }
      function entangleTransitions(root2, fiber, lane) {
        var updateQueue = fiber.updateQueue;
        if (updateQueue !== null) {
          var sharedQueue = updateQueue.shared;
          if (isTransitionLane(lane)) {
            var queueLanes = sharedQueue.lanes;
            queueLanes = intersectLanes(queueLanes, root2.pendingLanes);
            var newQueueLanes = mergeLanes(queueLanes, lane);
            sharedQueue.lanes = newQueueLanes, markRootEntangled(root2, newQueueLanes);
          }
        }
      }
      function enqueueCapturedUpdate(workInProgress2, capturedUpdate) {
        var queue = workInProgress2.updateQueue, current2 = workInProgress2.alternate;
        if (current2 !== null) {
          var currentQueue = current2.updateQueue;
          if (queue === currentQueue) {
            var newFirst = null, newLast = null, firstBaseUpdate = queue.firstBaseUpdate;
            if (firstBaseUpdate !== null) {
              var update2 = firstBaseUpdate;
              do {
                var clone = {
                  eventTime: update2.eventTime,
                  lane: update2.lane,
                  tag: update2.tag,
                  payload: update2.payload,
                  callback: update2.callback,
                  next: null
                };
                newLast === null ? newFirst = newLast = clone : (newLast.next = clone, newLast = clone), update2 = update2.next;
              } while (update2 !== null);
              newLast === null ? newFirst = newLast = capturedUpdate : (newLast.next = capturedUpdate, newLast = capturedUpdate);
            } else
              newFirst = newLast = capturedUpdate;
            queue = {
              baseState: currentQueue.baseState,
              firstBaseUpdate: newFirst,
              lastBaseUpdate: newLast,
              shared: currentQueue.shared,
              effects: currentQueue.effects
            }, workInProgress2.updateQueue = queue;
            return;
          }
        }
        var lastBaseUpdate = queue.lastBaseUpdate;
        lastBaseUpdate === null ? queue.firstBaseUpdate = capturedUpdate : lastBaseUpdate.next = capturedUpdate, queue.lastBaseUpdate = capturedUpdate;
      }
      function getStateFromUpdate(workInProgress2, queue, update2, prevState, nextProps, instance) {
        switch (update2.tag) {
          case ReplaceState: {
            var payload = update2.payload;
            if (typeof payload == "function") {
              enterDisallowedContextReadInDEV();
              var nextState = payload.call(instance, prevState, nextProps);
              {
                if (workInProgress2.mode & StrictLegacyMode) {
                  setIsStrictModeForDevtools(!0);
                  try {
                    payload.call(instance, prevState, nextProps);
                  } finally {
                    setIsStrictModeForDevtools(!1);
                  }
                }
                exitDisallowedContextReadInDEV();
              }
              return nextState;
            }
            return payload;
          }
          case CaptureUpdate:
            workInProgress2.flags = workInProgress2.flags & ~ShouldCapture | DidCapture;
          case UpdateState: {
            var _payload = update2.payload, partialState;
            if (typeof _payload == "function") {
              enterDisallowedContextReadInDEV(), partialState = _payload.call(instance, prevState, nextProps);
              {
                if (workInProgress2.mode & StrictLegacyMode) {
                  setIsStrictModeForDevtools(!0);
                  try {
                    _payload.call(instance, prevState, nextProps);
                  } finally {
                    setIsStrictModeForDevtools(!1);
                  }
                }
                exitDisallowedContextReadInDEV();
              }
            } else
              partialState = _payload;
            return partialState == null ? prevState : assign({}, prevState, partialState);
          }
          case ForceUpdate:
            return hasForceUpdate = !0, prevState;
        }
        return prevState;
      }
      function processUpdateQueue(workInProgress2, props, instance, renderLanes2) {
        var queue = workInProgress2.updateQueue;
        hasForceUpdate = !1, currentlyProcessingQueue = queue.shared;
        var firstBaseUpdate = queue.firstBaseUpdate, lastBaseUpdate = queue.lastBaseUpdate, pendingQueue = queue.shared.pending;
        if (pendingQueue !== null) {
          queue.shared.pending = null;
          var lastPendingUpdate = pendingQueue, firstPendingUpdate = lastPendingUpdate.next;
          lastPendingUpdate.next = null, lastBaseUpdate === null ? firstBaseUpdate = firstPendingUpdate : lastBaseUpdate.next = firstPendingUpdate, lastBaseUpdate = lastPendingUpdate;
          var current2 = workInProgress2.alternate;
          if (current2 !== null) {
            var currentQueue = current2.updateQueue, currentLastBaseUpdate = currentQueue.lastBaseUpdate;
            currentLastBaseUpdate !== lastBaseUpdate && (currentLastBaseUpdate === null ? currentQueue.firstBaseUpdate = firstPendingUpdate : currentLastBaseUpdate.next = firstPendingUpdate, currentQueue.lastBaseUpdate = lastPendingUpdate);
          }
        }
        if (firstBaseUpdate !== null) {
          var newState = queue.baseState, newLanes = NoLanes, newBaseState = null, newFirstBaseUpdate = null, newLastBaseUpdate = null, update2 = firstBaseUpdate;
          do {
            var updateLane = update2.lane, updateEventTime = update2.eventTime;
            if (isSubsetOfLanes(renderLanes2, updateLane)) {
              if (newLastBaseUpdate !== null) {
                var _clone = {
                  eventTime: updateEventTime,
                  // This update is going to be committed so we never want uncommit
                  // it. Using NoLane works because 0 is a subset of all bitmasks, so
                  // this will never be skipped by the check above.
                  lane: NoLane,
                  tag: update2.tag,
                  payload: update2.payload,
                  callback: update2.callback,
                  next: null
                };
                newLastBaseUpdate = newLastBaseUpdate.next = _clone;
              }
              newState = getStateFromUpdate(workInProgress2, queue, update2, newState, props, instance);
              var callback = update2.callback;
              if (callback !== null && // If the update was already committed, we should not queue its
              // callback again.
              update2.lane !== NoLane) {
                workInProgress2.flags |= Callback;
                var effects = queue.effects;
                effects === null ? queue.effects = [update2] : effects.push(update2);
              }
            } else {
              var clone = {
                eventTime: updateEventTime,
                lane: updateLane,
                tag: update2.tag,
                payload: update2.payload,
                callback: update2.callback,
                next: null
              };
              newLastBaseUpdate === null ? (newFirstBaseUpdate = newLastBaseUpdate = clone, newBaseState = newState) : newLastBaseUpdate = newLastBaseUpdate.next = clone, newLanes = mergeLanes(newLanes, updateLane);
            }
            if (update2 = update2.next, update2 === null) {
              if (pendingQueue = queue.shared.pending, pendingQueue === null)
                break;
              var _lastPendingUpdate = pendingQueue, _firstPendingUpdate = _lastPendingUpdate.next;
              _lastPendingUpdate.next = null, update2 = _firstPendingUpdate, queue.lastBaseUpdate = _lastPendingUpdate, queue.shared.pending = null;
            }
          } while (!0);
          newLastBaseUpdate === null && (newBaseState = newState), queue.baseState = newBaseState, queue.firstBaseUpdate = newFirstBaseUpdate, queue.lastBaseUpdate = newLastBaseUpdate;
          var lastInterleaved = queue.shared.interleaved;
          if (lastInterleaved !== null) {
            var interleaved = lastInterleaved;
            do
              newLanes = mergeLanes(newLanes, interleaved.lane), interleaved = interleaved.next;
            while (interleaved !== lastInterleaved);
          } else
            firstBaseUpdate === null && (queue.shared.lanes = NoLanes);
          markSkippedUpdateLanes(newLanes), workInProgress2.lanes = newLanes, workInProgress2.memoizedState = newState;
        }
        currentlyProcessingQueue = null;
      }
      function callCallback(callback, context) {
        if (typeof callback != "function")
          throw new Error("Invalid argument passed as callback. Expected a function. Instead " + ("received: " + callback));
        callback.call(context);
      }
      function resetHasForceUpdateBeforeProcessing() {
        hasForceUpdate = !1;
      }
      function checkHasForceUpdateAfterProcessing() {
        return hasForceUpdate;
      }
      function commitUpdateQueue(finishedWork, finishedQueue, instance) {
        var effects = finishedQueue.effects;
        if (finishedQueue.effects = null, effects !== null)
          for (var i = 0; i < effects.length; i++) {
            var effect = effects[i], callback = effect.callback;
            callback !== null && (effect.callback = null, callCallback(callback, instance));
          }
      }
      var fakeInternalInstance = {}, emptyRefsObject = new React12.Component().refs, didWarnAboutStateAssignmentForComponent, didWarnAboutUninitializedState, didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate, didWarnAboutLegacyLifecyclesAndDerivedState, didWarnAboutUndefinedDerivedState, warnOnUndefinedDerivedState, warnOnInvalidCallback, didWarnAboutDirectlyAssigningPropsToState, didWarnAboutContextTypeAndContextTypes, didWarnAboutInvalidateContextType;
      {
        didWarnAboutStateAssignmentForComponent = /* @__PURE__ */ new Set(), didWarnAboutUninitializedState = /* @__PURE__ */ new Set(), didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate = /* @__PURE__ */ new Set(), didWarnAboutLegacyLifecyclesAndDerivedState = /* @__PURE__ */ new Set(), didWarnAboutDirectlyAssigningPropsToState = /* @__PURE__ */ new Set(), didWarnAboutUndefinedDerivedState = /* @__PURE__ */ new Set(), didWarnAboutContextTypeAndContextTypes = /* @__PURE__ */ new Set(), didWarnAboutInvalidateContextType = /* @__PURE__ */ new Set();
        var didWarnOnInvalidCallback = /* @__PURE__ */ new Set();
        warnOnInvalidCallback = function(callback, callerName) {
          if (!(callback === null || typeof callback == "function")) {
            var key = callerName + "_" + callback;
            didWarnOnInvalidCallback.has(key) || (didWarnOnInvalidCallback.add(key), error("%s(...): Expected the last optional `callback` argument to be a function. Instead received: %s.", callerName, callback));
          }
        }, warnOnUndefinedDerivedState = function(type, partialState) {
          if (partialState === void 0) {
            var componentName = getComponentNameFromType(type) || "Component";
            didWarnAboutUndefinedDerivedState.has(componentName) || (didWarnAboutUndefinedDerivedState.add(componentName), error("%s.getDerivedStateFromProps(): A valid state object (or null) must be returned. You have returned undefined.", componentName));
          }
        }, Object.defineProperty(fakeInternalInstance, "_processChildContext", {
          enumerable: !1,
          value: function() {
            throw new Error("_processChildContext is not available in React 16+. This likely means you have multiple copies of React and are attempting to nest a React 15 tree inside a React 16 tree using unstable_renderSubtreeIntoContainer, which isn't supported. Try to make sure you have only one copy of React (and ideally, switch to ReactDOM.createPortal).");
          }
        }), Object.freeze(fakeInternalInstance);
      }
      function applyDerivedStateFromProps(workInProgress2, ctor, getDerivedStateFromProps, nextProps) {
        var prevState = workInProgress2.memoizedState, partialState = getDerivedStateFromProps(nextProps, prevState);
        {
          if (workInProgress2.mode & StrictLegacyMode) {
            setIsStrictModeForDevtools(!0);
            try {
              partialState = getDerivedStateFromProps(nextProps, prevState);
            } finally {
              setIsStrictModeForDevtools(!1);
            }
          }
          warnOnUndefinedDerivedState(ctor, partialState);
        }
        var memoizedState = partialState == null ? prevState : assign({}, prevState, partialState);
        if (workInProgress2.memoizedState = memoizedState, workInProgress2.lanes === NoLanes) {
          var updateQueue = workInProgress2.updateQueue;
          updateQueue.baseState = memoizedState;
        }
      }
      var classComponentUpdater = {
        isMounted,
        enqueueSetState: function(inst, payload, callback) {
          var fiber = get2(inst), eventTime = requestEventTime(), lane = requestUpdateLane(fiber), update2 = createUpdate(eventTime, lane);
          update2.payload = payload, callback != null && (warnOnInvalidCallback(callback, "setState"), update2.callback = callback);
          var root2 = enqueueUpdate(fiber, update2, lane);
          root2 !== null && (scheduleUpdateOnFiber(root2, fiber, lane, eventTime), entangleTransitions(root2, fiber, lane)), markStateUpdateScheduled(fiber, lane);
        },
        enqueueReplaceState: function(inst, payload, callback) {
          var fiber = get2(inst), eventTime = requestEventTime(), lane = requestUpdateLane(fiber), update2 = createUpdate(eventTime, lane);
          update2.tag = ReplaceState, update2.payload = payload, callback != null && (warnOnInvalidCallback(callback, "replaceState"), update2.callback = callback);
          var root2 = enqueueUpdate(fiber, update2, lane);
          root2 !== null && (scheduleUpdateOnFiber(root2, fiber, lane, eventTime), entangleTransitions(root2, fiber, lane)), markStateUpdateScheduled(fiber, lane);
        },
        enqueueForceUpdate: function(inst, callback) {
          var fiber = get2(inst), eventTime = requestEventTime(), lane = requestUpdateLane(fiber), update2 = createUpdate(eventTime, lane);
          update2.tag = ForceUpdate, callback != null && (warnOnInvalidCallback(callback, "forceUpdate"), update2.callback = callback);
          var root2 = enqueueUpdate(fiber, update2, lane);
          root2 !== null && (scheduleUpdateOnFiber(root2, fiber, lane, eventTime), entangleTransitions(root2, fiber, lane)), markForceUpdateScheduled(fiber, lane);
        }
      };
      function checkShouldComponentUpdate(workInProgress2, ctor, oldProps, newProps, oldState, newState, nextContext) {
        var instance = workInProgress2.stateNode;
        if (typeof instance.shouldComponentUpdate == "function") {
          var shouldUpdate = instance.shouldComponentUpdate(newProps, newState, nextContext);
          {
            if (workInProgress2.mode & StrictLegacyMode) {
              setIsStrictModeForDevtools(!0);
              try {
                shouldUpdate = instance.shouldComponentUpdate(newProps, newState, nextContext);
              } finally {
                setIsStrictModeForDevtools(!1);
              }
            }
            shouldUpdate === void 0 && error("%s.shouldComponentUpdate(): Returned undefined instead of a boolean value. Make sure to return true or false.", getComponentNameFromType(ctor) || "Component");
          }
          return shouldUpdate;
        }
        return ctor.prototype && ctor.prototype.isPureReactComponent ? !shallowEqual(oldProps, newProps) || !shallowEqual(oldState, newState) : !0;
      }
      function checkClassInstance(workInProgress2, ctor, newProps) {
        var instance = workInProgress2.stateNode;
        {
          var name = getComponentNameFromType(ctor) || "Component", renderPresent = instance.render;
          renderPresent || (ctor.prototype && typeof ctor.prototype.render == "function" ? error("%s(...): No `render` method found on the returned component instance: did you accidentally return an object from the constructor?", name) : error("%s(...): No `render` method found on the returned component instance: you may have forgotten to define `render`.", name)), instance.getInitialState && !instance.getInitialState.isReactClassApproved && !instance.state && error("getInitialState was defined on %s, a plain JavaScript class. This is only supported for classes created using React.createClass. Did you mean to define a state property instead?", name), instance.getDefaultProps && !instance.getDefaultProps.isReactClassApproved && error("getDefaultProps was defined on %s, a plain JavaScript class. This is only supported for classes created using React.createClass. Use a static property to define defaultProps instead.", name), instance.propTypes && error("propTypes was defined as an instance property on %s. Use a static property to define propTypes instead.", name), instance.contextType && error("contextType was defined as an instance property on %s. Use a static property to define contextType instead.", name), instance.contextTypes && error("contextTypes was defined as an instance property on %s. Use a static property to define contextTypes instead.", name), ctor.contextType && ctor.contextTypes && !didWarnAboutContextTypeAndContextTypes.has(ctor) && (didWarnAboutContextTypeAndContextTypes.add(ctor), error("%s declares both contextTypes and contextType static properties. The legacy contextTypes property will be ignored.", name)), typeof instance.componentShouldUpdate == "function" && error("%s has a method called componentShouldUpdate(). Did you mean shouldComponentUpdate()? The name is phrased as a question because the function is expected to return a value.", name), ctor.prototype && ctor.prototype.isPureReactComponent && typeof instance.shouldComponentUpdate < "u" && error("%s has a method called shouldComponentUpdate(). shouldComponentUpdate should not be used when extending React.PureComponent. Please extend React.Component if shouldComponentUpdate is used.", getComponentNameFromType(ctor) || "A pure component"), typeof instance.componentDidUnmount == "function" && error("%s has a method called componentDidUnmount(). But there is no such lifecycle method. Did you mean componentWillUnmount()?", name), typeof instance.componentDidReceiveProps == "function" && error("%s has a method called componentDidReceiveProps(). But there is no such lifecycle method. If you meant to update the state in response to changing props, use componentWillReceiveProps(). If you meant to fetch data or run side-effects or mutations after React has updated the UI, use componentDidUpdate().", name), typeof instance.componentWillRecieveProps == "function" && error("%s has a method called componentWillRecieveProps(). Did you mean componentWillReceiveProps()?", name), typeof instance.UNSAFE_componentWillRecieveProps == "function" && error("%s has a method called UNSAFE_componentWillRecieveProps(). Did you mean UNSAFE_componentWillReceiveProps()?", name);
          var hasMutatedProps = instance.props !== newProps;
          instance.props !== void 0 && hasMutatedProps && error("%s(...): When calling super() in `%s`, make sure to pass up the same props that your component's constructor was passed.", name, name), instance.defaultProps && error("Setting defaultProps as an instance property on %s is not supported and will be ignored. Instead, define defaultProps as a static property on %s.", name, name), typeof instance.getSnapshotBeforeUpdate == "function" && typeof instance.componentDidUpdate != "function" && !didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate.has(ctor) && (didWarnAboutGetSnapshotBeforeUpdateWithoutDidUpdate.add(ctor), error("%s: getSnapshotBeforeUpdate() should be used with componentDidUpdate(). This component defines getSnapshotBeforeUpdate() only.", getComponentNameFromType(ctor))), typeof instance.getDerivedStateFromProps == "function" && error("%s: getDerivedStateFromProps() is defined as an instance method and will be ignored. Instead, declare it as a static method.", name), typeof instance.getDerivedStateFromError == "function" && error("%s: getDerivedStateFromError() is defined as an instance method and will be ignored. Instead, declare it as a static method.", name), typeof ctor.getSnapshotBeforeUpdate == "function" && error("%s: getSnapshotBeforeUpdate() is defined as a static method and will be ignored. Instead, declare it as an instance method.", name);
          var _state = instance.state;
          _state && (typeof _state != "object" || isArray(_state)) && error("%s.state: must be set to an object or null", name), typeof instance.getChildContext == "function" && typeof ctor.childContextTypes != "object" && error("%s.getChildContext(): childContextTypes must be defined in order to use getChildContext().", name);
        }
      }
      function adoptClassInstance(workInProgress2, instance) {
        instance.updater = classComponentUpdater, workInProgress2.stateNode = instance, set2(instance, workInProgress2), instance._reactInternalInstance = fakeInternalInstance;
      }
      function constructClassInstance(workInProgress2, ctor, props) {
        var isLegacyContextConsumer = !1, unmaskedContext = emptyContextObject, context = emptyContextObject, contextType = ctor.contextType;
        if ("contextType" in ctor) {
          var isValid = (
            // Allow null for conditional declaration
            contextType === null || contextType !== void 0 && contextType.$$typeof === REACT_CONTEXT_TYPE && contextType._context === void 0
          );
          if (!isValid && !didWarnAboutInvalidateContextType.has(ctor)) {
            didWarnAboutInvalidateContextType.add(ctor);
            var addendum = "";
            contextType === void 0 ? addendum = " However, it is set to undefined. This can be caused by a typo or by mixing up named and default imports. This can also happen due to a circular dependency, so try moving the createContext() call to a separate file." : typeof contextType != "object" ? addendum = " However, it is set to a " + typeof contextType + "." : contextType.$$typeof === REACT_PROVIDER_TYPE ? addendum = " Did you accidentally pass the Context.Provider instead?" : contextType._context !== void 0 ? addendum = " Did you accidentally pass the Context.Consumer instead?" : addendum = " However, it is set to an object with keys {" + Object.keys(contextType).join(", ") + "}.", error("%s defines an invalid contextType. contextType should point to the Context object returned by React.createContext().%s", getComponentNameFromType(ctor) || "Component", addendum);
          }
        }
        if (typeof contextType == "object" && contextType !== null)
          context = readContext(contextType);
        else {
          unmaskedContext = getUnmaskedContext(workInProgress2, ctor, !0);
          var contextTypes = ctor.contextTypes;
          isLegacyContextConsumer = contextTypes != null, context = isLegacyContextConsumer ? getMaskedContext(workInProgress2, unmaskedContext) : emptyContextObject;
        }
        var instance = new ctor(props, context);
        if (workInProgress2.mode & StrictLegacyMode) {
          setIsStrictModeForDevtools(!0);
          try {
            instance = new ctor(props, context);
          } finally {
            setIsStrictModeForDevtools(!1);
          }
        }
        var state = workInProgress2.memoizedState = instance.state !== null && instance.state !== void 0 ? instance.state : null;
        adoptClassInstance(workInProgress2, instance);
        {
          if (typeof ctor.getDerivedStateFromProps == "function" && state === null) {
            var componentName = getComponentNameFromType(ctor) || "Component";
            didWarnAboutUninitializedState.has(componentName) || (didWarnAboutUninitializedState.add(componentName), error("`%s` uses `getDerivedStateFromProps` but its initial state is %s. This is not recommended. Instead, define the initial state by assigning an object to `this.state` in the constructor of `%s`. This ensures that `getDerivedStateFromProps` arguments have a consistent shape.", componentName, instance.state === null ? "null" : "undefined", componentName));
          }
          if (typeof ctor.getDerivedStateFromProps == "function" || typeof instance.getSnapshotBeforeUpdate == "function") {
            var foundWillMountName = null, foundWillReceivePropsName = null, foundWillUpdateName = null;
            if (typeof instance.componentWillMount == "function" && instance.componentWillMount.__suppressDeprecationWarning !== !0 ? foundWillMountName = "componentWillMount" : typeof instance.UNSAFE_componentWillMount == "function" && (foundWillMountName = "UNSAFE_componentWillMount"), typeof instance.componentWillReceiveProps == "function" && instance.componentWillReceiveProps.__suppressDeprecationWarning !== !0 ? foundWillReceivePropsName = "componentWillReceiveProps" : typeof instance.UNSAFE_componentWillReceiveProps == "function" && (foundWillReceivePropsName = "UNSAFE_componentWillReceiveProps"), typeof instance.componentWillUpdate == "function" && instance.componentWillUpdate.__suppressDeprecationWarning !== !0 ? foundWillUpdateName = "componentWillUpdate" : typeof instance.UNSAFE_componentWillUpdate == "function" && (foundWillUpdateName = "UNSAFE_componentWillUpdate"), foundWillMountName !== null || foundWillReceivePropsName !== null || foundWillUpdateName !== null) {
              var _componentName = getComponentNameFromType(ctor) || "Component", newApiName = typeof ctor.getDerivedStateFromProps == "function" ? "getDerivedStateFromProps()" : "getSnapshotBeforeUpdate()";
              didWarnAboutLegacyLifecyclesAndDerivedState.has(_componentName) || (didWarnAboutLegacyLifecyclesAndDerivedState.add(_componentName), error(`Unsafe legacy lifecycles will not be called for components using new component APIs.

%s uses %s but also contains the following legacy lifecycles:%s%s%s

The above lifecycles should be removed. Learn more about this warning here:
https://reactjs.org/link/unsafe-component-lifecycles`, _componentName, newApiName, foundWillMountName !== null ? `
  ` + foundWillMountName : "", foundWillReceivePropsName !== null ? `
  ` + foundWillReceivePropsName : "", foundWillUpdateName !== null ? `
  ` + foundWillUpdateName : ""));
            }
          }
        }
        return isLegacyContextConsumer && cacheContext(workInProgress2, unmaskedContext, context), instance;
      }
      function callComponentWillMount(workInProgress2, instance) {
        var oldState = instance.state;
        typeof instance.componentWillMount == "function" && instance.componentWillMount(), typeof instance.UNSAFE_componentWillMount == "function" && instance.UNSAFE_componentWillMount(), oldState !== instance.state && (error("%s.componentWillMount(): Assigning directly to this.state is deprecated (except inside a component's constructor). Use setState instead.", getComponentNameFromFiber(workInProgress2) || "Component"), classComponentUpdater.enqueueReplaceState(instance, instance.state, null));
      }
      function callComponentWillReceiveProps(workInProgress2, instance, newProps, nextContext) {
        var oldState = instance.state;
        if (typeof instance.componentWillReceiveProps == "function" && instance.componentWillReceiveProps(newProps, nextContext), typeof instance.UNSAFE_componentWillReceiveProps == "function" && instance.UNSAFE_componentWillReceiveProps(newProps, nextContext), instance.state !== oldState) {
          {
            var componentName = getComponentNameFromFiber(workInProgress2) || "Component";
            didWarnAboutStateAssignmentForComponent.has(componentName) || (didWarnAboutStateAssignmentForComponent.add(componentName), error("%s.componentWillReceiveProps(): Assigning directly to this.state is deprecated (except inside a component's constructor). Use setState instead.", componentName));
          }
          classComponentUpdater.enqueueReplaceState(instance, instance.state, null);
        }
      }
      function mountClassInstance(workInProgress2, ctor, newProps, renderLanes2) {
        checkClassInstance(workInProgress2, ctor, newProps);
        var instance = workInProgress2.stateNode;
        instance.props = newProps, instance.state = workInProgress2.memoizedState, instance.refs = emptyRefsObject, initializeUpdateQueue(workInProgress2);
        var contextType = ctor.contextType;
        if (typeof contextType == "object" && contextType !== null)
          instance.context = readContext(contextType);
        else {
          var unmaskedContext = getUnmaskedContext(workInProgress2, ctor, !0);
          instance.context = getMaskedContext(workInProgress2, unmaskedContext);
        }
        {
          if (instance.state === newProps) {
            var componentName = getComponentNameFromType(ctor) || "Component";
            didWarnAboutDirectlyAssigningPropsToState.has(componentName) || (didWarnAboutDirectlyAssigningPropsToState.add(componentName), error("%s: It is not recommended to assign props directly to state because updates to props won't be reflected in state. In most cases, it is better to use props directly.", componentName));
          }
          workInProgress2.mode & StrictLegacyMode && ReactStrictModeWarnings.recordLegacyContextWarning(workInProgress2, instance), ReactStrictModeWarnings.recordUnsafeLifecycleWarnings(workInProgress2, instance);
        }
        instance.state = workInProgress2.memoizedState;
        var getDerivedStateFromProps = ctor.getDerivedStateFromProps;
        if (typeof getDerivedStateFromProps == "function" && (applyDerivedStateFromProps(workInProgress2, ctor, getDerivedStateFromProps, newProps), instance.state = workInProgress2.memoizedState), typeof ctor.getDerivedStateFromProps != "function" && typeof instance.getSnapshotBeforeUpdate != "function" && (typeof instance.UNSAFE_componentWillMount == "function" || typeof instance.componentWillMount == "function") && (callComponentWillMount(workInProgress2, instance), processUpdateQueue(workInProgress2, newProps, instance, renderLanes2), instance.state = workInProgress2.memoizedState), typeof instance.componentDidMount == "function") {
          var fiberFlags = Update;
          fiberFlags |= LayoutStatic, (workInProgress2.mode & StrictEffectsMode) !== NoMode && (fiberFlags |= MountLayoutDev), workInProgress2.flags |= fiberFlags;
        }
      }
      function resumeMountClassInstance(workInProgress2, ctor, newProps, renderLanes2) {
        var instance = workInProgress2.stateNode, oldProps = workInProgress2.memoizedProps;
        instance.props = oldProps;
        var oldContext = instance.context, contextType = ctor.contextType, nextContext = emptyContextObject;
        if (typeof contextType == "object" && contextType !== null)
          nextContext = readContext(contextType);
        else {
          var nextLegacyUnmaskedContext = getUnmaskedContext(workInProgress2, ctor, !0);
          nextContext = getMaskedContext(workInProgress2, nextLegacyUnmaskedContext);
        }
        var getDerivedStateFromProps = ctor.getDerivedStateFromProps, hasNewLifecycles = typeof getDerivedStateFromProps == "function" || typeof instance.getSnapshotBeforeUpdate == "function";
        !hasNewLifecycles && (typeof instance.UNSAFE_componentWillReceiveProps == "function" || typeof instance.componentWillReceiveProps == "function") && (oldProps !== newProps || oldContext !== nextContext) && callComponentWillReceiveProps(workInProgress2, instance, newProps, nextContext), resetHasForceUpdateBeforeProcessing();
        var oldState = workInProgress2.memoizedState, newState = instance.state = oldState;
        if (processUpdateQueue(workInProgress2, newProps, instance, renderLanes2), newState = workInProgress2.memoizedState, oldProps === newProps && oldState === newState && !hasContextChanged() && !checkHasForceUpdateAfterProcessing()) {
          if (typeof instance.componentDidMount == "function") {
            var fiberFlags = Update;
            fiberFlags |= LayoutStatic, (workInProgress2.mode & StrictEffectsMode) !== NoMode && (fiberFlags |= MountLayoutDev), workInProgress2.flags |= fiberFlags;
          }
          return !1;
        }
        typeof getDerivedStateFromProps == "function" && (applyDerivedStateFromProps(workInProgress2, ctor, getDerivedStateFromProps, newProps), newState = workInProgress2.memoizedState);
        var shouldUpdate = checkHasForceUpdateAfterProcessing() || checkShouldComponentUpdate(workInProgress2, ctor, oldProps, newProps, oldState, newState, nextContext);
        if (shouldUpdate) {
          if (!hasNewLifecycles && (typeof instance.UNSAFE_componentWillMount == "function" || typeof instance.componentWillMount == "function") && (typeof instance.componentWillMount == "function" && instance.componentWillMount(), typeof instance.UNSAFE_componentWillMount == "function" && instance.UNSAFE_componentWillMount()), typeof instance.componentDidMount == "function") {
            var _fiberFlags = Update;
            _fiberFlags |= LayoutStatic, (workInProgress2.mode & StrictEffectsMode) !== NoMode && (_fiberFlags |= MountLayoutDev), workInProgress2.flags |= _fiberFlags;
          }
        } else {
          if (typeof instance.componentDidMount == "function") {
            var _fiberFlags2 = Update;
            _fiberFlags2 |= LayoutStatic, (workInProgress2.mode & StrictEffectsMode) !== NoMode && (_fiberFlags2 |= MountLayoutDev), workInProgress2.flags |= _fiberFlags2;
          }
          workInProgress2.memoizedProps = newProps, workInProgress2.memoizedState = newState;
        }
        return instance.props = newProps, instance.state = newState, instance.context = nextContext, shouldUpdate;
      }
      function updateClassInstance(current2, workInProgress2, ctor, newProps, renderLanes2) {
        var instance = workInProgress2.stateNode;
        cloneUpdateQueue(current2, workInProgress2);
        var unresolvedOldProps = workInProgress2.memoizedProps, oldProps = workInProgress2.type === workInProgress2.elementType ? unresolvedOldProps : resolveDefaultProps(workInProgress2.type, unresolvedOldProps);
        instance.props = oldProps;
        var unresolvedNewProps = workInProgress2.pendingProps, oldContext = instance.context, contextType = ctor.contextType, nextContext = emptyContextObject;
        if (typeof contextType == "object" && contextType !== null)
          nextContext = readContext(contextType);
        else {
          var nextUnmaskedContext = getUnmaskedContext(workInProgress2, ctor, !0);
          nextContext = getMaskedContext(workInProgress2, nextUnmaskedContext);
        }
        var getDerivedStateFromProps = ctor.getDerivedStateFromProps, hasNewLifecycles = typeof getDerivedStateFromProps == "function" || typeof instance.getSnapshotBeforeUpdate == "function";
        !hasNewLifecycles && (typeof instance.UNSAFE_componentWillReceiveProps == "function" || typeof instance.componentWillReceiveProps == "function") && (unresolvedOldProps !== unresolvedNewProps || oldContext !== nextContext) && callComponentWillReceiveProps(workInProgress2, instance, newProps, nextContext), resetHasForceUpdateBeforeProcessing();
        var oldState = workInProgress2.memoizedState, newState = instance.state = oldState;
        if (processUpdateQueue(workInProgress2, newProps, instance, renderLanes2), newState = workInProgress2.memoizedState, unresolvedOldProps === unresolvedNewProps && oldState === newState && !hasContextChanged() && !checkHasForceUpdateAfterProcessing() && !enableLazyContextPropagation)
          return typeof instance.componentDidUpdate == "function" && (unresolvedOldProps !== current2.memoizedProps || oldState !== current2.memoizedState) && (workInProgress2.flags |= Update), typeof instance.getSnapshotBeforeUpdate == "function" && (unresolvedOldProps !== current2.memoizedProps || oldState !== current2.memoizedState) && (workInProgress2.flags |= Snapshot), !1;
        typeof getDerivedStateFromProps == "function" && (applyDerivedStateFromProps(workInProgress2, ctor, getDerivedStateFromProps, newProps), newState = workInProgress2.memoizedState);
        var shouldUpdate = checkHasForceUpdateAfterProcessing() || checkShouldComponentUpdate(workInProgress2, ctor, oldProps, newProps, oldState, newState, nextContext) || // TODO: In some cases, we'll end up checking if context has changed twice,
        // both before and after `shouldComponentUpdate` has been called. Not ideal,
        // but I'm loath to refactor this function. This only happens for memoized
        // components so it's not that common.
        enableLazyContextPropagation;
        return shouldUpdate ? (!hasNewLifecycles && (typeof instance.UNSAFE_componentWillUpdate == "function" || typeof instance.componentWillUpdate == "function") && (typeof instance.componentWillUpdate == "function" && instance.componentWillUpdate(newProps, newState, nextContext), typeof instance.UNSAFE_componentWillUpdate == "function" && instance.UNSAFE_componentWillUpdate(newProps, newState, nextContext)), typeof instance.componentDidUpdate == "function" && (workInProgress2.flags |= Update), typeof instance.getSnapshotBeforeUpdate == "function" && (workInProgress2.flags |= Snapshot)) : (typeof instance.componentDidUpdate == "function" && (unresolvedOldProps !== current2.memoizedProps || oldState !== current2.memoizedState) && (workInProgress2.flags |= Update), typeof instance.getSnapshotBeforeUpdate == "function" && (unresolvedOldProps !== current2.memoizedProps || oldState !== current2.memoizedState) && (workInProgress2.flags |= Snapshot), workInProgress2.memoizedProps = newProps, workInProgress2.memoizedState = newState), instance.props = newProps, instance.state = newState, instance.context = nextContext, shouldUpdate;
      }
      var didWarnAboutMaps, didWarnAboutGenerators, didWarnAboutStringRefs, ownerHasKeyUseWarning, ownerHasFunctionTypeWarning, warnForMissingKey = function(child, returnFiber) {
      };
      didWarnAboutMaps = !1, didWarnAboutGenerators = !1, didWarnAboutStringRefs = {}, ownerHasKeyUseWarning = {}, ownerHasFunctionTypeWarning = {}, warnForMissingKey = function(child, returnFiber) {
        if (!(child === null || typeof child != "object") && !(!child._store || child._store.validated || child.key != null)) {
          if (typeof child._store != "object")
            throw new Error("React Component in warnForMissingKey should have a _store. This error is likely caused by a bug in React. Please file an issue.");
          child._store.validated = !0;
          var componentName = getComponentNameFromFiber(returnFiber) || "Component";
          ownerHasKeyUseWarning[componentName] || (ownerHasKeyUseWarning[componentName] = !0, error('Each child in a list should have a unique "key" prop. See https://reactjs.org/link/warning-keys for more information.'));
        }
      };
      function coerceRef(returnFiber, current2, element) {
        var mixedRef = element.ref;
        if (mixedRef !== null && typeof mixedRef != "function" && typeof mixedRef != "object") {
          if ((returnFiber.mode & StrictLegacyMode || warnAboutStringRefs) && // We warn in ReactElement.js if owner and self are equal for string refs
          // because these cannot be automatically converted to an arrow function
          // using a codemod. Therefore, we don't have to warn about string refs again.
          !(element._owner && element._self && element._owner.stateNode !== element._self)) {
            var componentName = getComponentNameFromFiber(returnFiber) || "Component";
            didWarnAboutStringRefs[componentName] || (error('A string ref, "%s", has been found within a strict mode tree. String refs are a source of potential bugs and should be avoided. We recommend using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', mixedRef), didWarnAboutStringRefs[componentName] = !0);
          }
          if (element._owner) {
            var owner = element._owner, inst;
            if (owner) {
              var ownerFiber = owner;
              if (ownerFiber.tag !== ClassComponent)
                throw new Error("Function components cannot have string refs. We recommend using useRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref");
              inst = ownerFiber.stateNode;
            }
            if (!inst)
              throw new Error("Missing owner for string ref " + mixedRef + ". This error is likely caused by a bug in React. Please file an issue.");
            var resolvedInst = inst;
            checkPropStringCoercion(mixedRef, "ref");
            var stringRef = "" + mixedRef;
            if (current2 !== null && current2.ref !== null && typeof current2.ref == "function" && current2.ref._stringRef === stringRef)
              return current2.ref;
            var ref = function(value) {
              var refs = resolvedInst.refs;
              refs === emptyRefsObject && (refs = resolvedInst.refs = {}), value === null ? delete refs[stringRef] : refs[stringRef] = value;
            };
            return ref._stringRef = stringRef, ref;
          } else {
            if (typeof mixedRef != "string")
              throw new Error("Expected ref to be a function, a string, an object returned by React.createRef(), or null.");
            if (!element._owner)
              throw new Error("Element ref was specified as a string (" + mixedRef + `) but no owner was set. This could happen for one of the following reasons:
1. You may be adding a ref to a function component
2. You may be adding a ref to a component that was not created inside a component's render method
3. You have multiple copies of React loaded
See https://reactjs.org/link/refs-must-have-owner for more information.`);
          }
        }
        return mixedRef;
      }
      function throwOnInvalidObjectType(returnFiber, newChild) {
        var childString = Object.prototype.toString.call(newChild);
        throw new Error("Objects are not valid as a React child (found: " + (childString === "[object Object]" ? "object with keys {" + Object.keys(newChild).join(", ") + "}" : childString) + "). If you meant to render a collection of children, use an array instead.");
      }
      function warnOnFunctionType(returnFiber) {
        {
          var componentName = getComponentNameFromFiber(returnFiber) || "Component";
          if (ownerHasFunctionTypeWarning[componentName])
            return;
          ownerHasFunctionTypeWarning[componentName] = !0, error("Functions are not valid as a React child. This may happen if you return a Component instead of <Component /> from render. Or maybe you meant to call this function rather than return it.");
        }
      }
      function resolveLazy(lazyType) {
        var payload = lazyType._payload, init4 = lazyType._init;
        return init4(payload);
      }
      function ChildReconciler(shouldTrackSideEffects) {
        function deleteChild(returnFiber, childToDelete) {
          if (shouldTrackSideEffects) {
            var deletions = returnFiber.deletions;
            deletions === null ? (returnFiber.deletions = [childToDelete], returnFiber.flags |= ChildDeletion) : deletions.push(childToDelete);
          }
        }
        function deleteRemainingChildren(returnFiber, currentFirstChild) {
          if (!shouldTrackSideEffects)
            return null;
          for (var childToDelete = currentFirstChild; childToDelete !== null; )
            deleteChild(returnFiber, childToDelete), childToDelete = childToDelete.sibling;
          return null;
        }
        function mapRemainingChildren(returnFiber, currentFirstChild) {
          for (var existingChildren = /* @__PURE__ */ new Map(), existingChild = currentFirstChild; existingChild !== null; )
            existingChild.key !== null ? existingChildren.set(existingChild.key, existingChild) : existingChildren.set(existingChild.index, existingChild), existingChild = existingChild.sibling;
          return existingChildren;
        }
        function useFiber(fiber, pendingProps) {
          var clone = createWorkInProgress(fiber, pendingProps);
          return clone.index = 0, clone.sibling = null, clone;
        }
        function placeChild(newFiber, lastPlacedIndex, newIndex) {
          if (newFiber.index = newIndex, !shouldTrackSideEffects)
            return newFiber.flags |= Forked, lastPlacedIndex;
          var current2 = newFiber.alternate;
          if (current2 !== null) {
            var oldIndex = current2.index;
            return oldIndex < lastPlacedIndex ? (newFiber.flags |= Placement, lastPlacedIndex) : oldIndex;
          } else
            return newFiber.flags |= Placement, lastPlacedIndex;
        }
        function placeSingleChild(newFiber) {
          return shouldTrackSideEffects && newFiber.alternate === null && (newFiber.flags |= Placement), newFiber;
        }
        function updateTextNode(returnFiber, current2, textContent, lanes) {
          if (current2 === null || current2.tag !== HostText) {
            var created = createFiberFromText(textContent, returnFiber.mode, lanes);
            return created.return = returnFiber, created;
          } else {
            var existing = useFiber(current2, textContent);
            return existing.return = returnFiber, existing;
          }
        }
        function updateElement(returnFiber, current2, element, lanes) {
          var elementType = element.type;
          if (elementType === REACT_FRAGMENT_TYPE)
            return updateFragment2(returnFiber, current2, element.props.children, lanes, element.key);
          if (current2 !== null && (current2.elementType === elementType || // Keep this check inline so it only runs on the false path:
          isCompatibleFamilyForHotReloading(current2, element) || // Lazy types should reconcile their resolved type.
          // We need to do this after the Hot Reloading check above,
          // because hot reloading has different semantics than prod because
          // it doesn't resuspend. So we can't let the call below suspend.
          typeof elementType == "object" && elementType !== null && elementType.$$typeof === REACT_LAZY_TYPE && resolveLazy(elementType) === current2.type)) {
            var existing = useFiber(current2, element.props);
            return existing.ref = coerceRef(returnFiber, current2, element), existing.return = returnFiber, existing._debugSource = element._source, existing._debugOwner = element._owner, existing;
          }
          var created = createFiberFromElement(element, returnFiber.mode, lanes);
          return created.ref = coerceRef(returnFiber, current2, element), created.return = returnFiber, created;
        }
        function updatePortal(returnFiber, current2, portal, lanes) {
          if (current2 === null || current2.tag !== HostPortal || current2.stateNode.containerInfo !== portal.containerInfo || current2.stateNode.implementation !== portal.implementation) {
            var created = createFiberFromPortal(portal, returnFiber.mode, lanes);
            return created.return = returnFiber, created;
          } else {
            var existing = useFiber(current2, portal.children || []);
            return existing.return = returnFiber, existing;
          }
        }
        function updateFragment2(returnFiber, current2, fragment, lanes, key) {
          if (current2 === null || current2.tag !== Fragment) {
            var created = createFiberFromFragment(fragment, returnFiber.mode, lanes, key);
            return created.return = returnFiber, created;
          } else {
            var existing = useFiber(current2, fragment);
            return existing.return = returnFiber, existing;
          }
        }
        function createChild(returnFiber, newChild, lanes) {
          if (typeof newChild == "string" && newChild !== "" || typeof newChild == "number") {
            var created = createFiberFromText("" + newChild, returnFiber.mode, lanes);
            return created.return = returnFiber, created;
          }
          if (typeof newChild == "object" && newChild !== null) {
            switch (newChild.$$typeof) {
              case REACT_ELEMENT_TYPE: {
                var _created = createFiberFromElement(newChild, returnFiber.mode, lanes);
                return _created.ref = coerceRef(returnFiber, null, newChild), _created.return = returnFiber, _created;
              }
              case REACT_PORTAL_TYPE: {
                var _created2 = createFiberFromPortal(newChild, returnFiber.mode, lanes);
                return _created2.return = returnFiber, _created2;
              }
              case REACT_LAZY_TYPE: {
                var payload = newChild._payload, init4 = newChild._init;
                return createChild(returnFiber, init4(payload), lanes);
              }
            }
            if (isArray(newChild) || getIteratorFn(newChild)) {
              var _created3 = createFiberFromFragment(newChild, returnFiber.mode, lanes, null);
              return _created3.return = returnFiber, _created3;
            }
            throwOnInvalidObjectType(returnFiber, newChild);
          }
          return typeof newChild == "function" && warnOnFunctionType(returnFiber), null;
        }
        function updateSlot(returnFiber, oldFiber, newChild, lanes) {
          var key = oldFiber !== null ? oldFiber.key : null;
          if (typeof newChild == "string" && newChild !== "" || typeof newChild == "number")
            return key !== null ? null : updateTextNode(returnFiber, oldFiber, "" + newChild, lanes);
          if (typeof newChild == "object" && newChild !== null) {
            switch (newChild.$$typeof) {
              case REACT_ELEMENT_TYPE:
                return newChild.key === key ? updateElement(returnFiber, oldFiber, newChild, lanes) : null;
              case REACT_PORTAL_TYPE:
                return newChild.key === key ? updatePortal(returnFiber, oldFiber, newChild, lanes) : null;
              case REACT_LAZY_TYPE: {
                var payload = newChild._payload, init4 = newChild._init;
                return updateSlot(returnFiber, oldFiber, init4(payload), lanes);
              }
            }
            if (isArray(newChild) || getIteratorFn(newChild))
              return key !== null ? null : updateFragment2(returnFiber, oldFiber, newChild, lanes, null);
            throwOnInvalidObjectType(returnFiber, newChild);
          }
          return typeof newChild == "function" && warnOnFunctionType(returnFiber), null;
        }
        function updateFromMap(existingChildren, returnFiber, newIdx, newChild, lanes) {
          if (typeof newChild == "string" && newChild !== "" || typeof newChild == "number") {
            var matchedFiber = existingChildren.get(newIdx) || null;
            return updateTextNode(returnFiber, matchedFiber, "" + newChild, lanes);
          }
          if (typeof newChild == "object" && newChild !== null) {
            switch (newChild.$$typeof) {
              case REACT_ELEMENT_TYPE: {
                var _matchedFiber = existingChildren.get(newChild.key === null ? newIdx : newChild.key) || null;
                return updateElement(returnFiber, _matchedFiber, newChild, lanes);
              }
              case REACT_PORTAL_TYPE: {
                var _matchedFiber2 = existingChildren.get(newChild.key === null ? newIdx : newChild.key) || null;
                return updatePortal(returnFiber, _matchedFiber2, newChild, lanes);
              }
              case REACT_LAZY_TYPE:
                var payload = newChild._payload, init4 = newChild._init;
                return updateFromMap(existingChildren, returnFiber, newIdx, init4(payload), lanes);
            }
            if (isArray(newChild) || getIteratorFn(newChild)) {
              var _matchedFiber3 = existingChildren.get(newIdx) || null;
              return updateFragment2(returnFiber, _matchedFiber3, newChild, lanes, null);
            }
            throwOnInvalidObjectType(returnFiber, newChild);
          }
          return typeof newChild == "function" && warnOnFunctionType(returnFiber), null;
        }
        function warnOnInvalidKey(child, knownKeys, returnFiber) {
          {
            if (typeof child != "object" || child === null)
              return knownKeys;
            switch (child.$$typeof) {
              case REACT_ELEMENT_TYPE:
              case REACT_PORTAL_TYPE:
                warnForMissingKey(child, returnFiber);
                var key = child.key;
                if (typeof key != "string")
                  break;
                if (knownKeys === null) {
                  knownKeys = /* @__PURE__ */ new Set(), knownKeys.add(key);
                  break;
                }
                if (!knownKeys.has(key)) {
                  knownKeys.add(key);
                  break;
                }
                error("Encountered two children with the same key, `%s`. Keys should be unique so that components maintain their identity across updates. Non-unique keys may cause children to be duplicated and/or omitted \u2014 the behavior is unsupported and could change in a future version.", key);
                break;
              case REACT_LAZY_TYPE:
                var payload = child._payload, init4 = child._init;
                warnOnInvalidKey(init4(payload), knownKeys, returnFiber);
                break;
            }
          }
          return knownKeys;
        }
        function reconcileChildrenArray(returnFiber, currentFirstChild, newChildren, lanes) {
          for (var knownKeys = null, i = 0; i < newChildren.length; i++) {
            var child = newChildren[i];
            knownKeys = warnOnInvalidKey(child, knownKeys, returnFiber);
          }
          for (var resultingFirstChild = null, previousNewFiber = null, oldFiber = currentFirstChild, lastPlacedIndex = 0, newIdx = 0, nextOldFiber = null; oldFiber !== null && newIdx < newChildren.length; newIdx++) {
            oldFiber.index > newIdx ? (nextOldFiber = oldFiber, oldFiber = null) : nextOldFiber = oldFiber.sibling;
            var newFiber = updateSlot(returnFiber, oldFiber, newChildren[newIdx], lanes);
            if (newFiber === null) {
              oldFiber === null && (oldFiber = nextOldFiber);
              break;
            }
            shouldTrackSideEffects && oldFiber && newFiber.alternate === null && deleteChild(returnFiber, oldFiber), lastPlacedIndex = placeChild(newFiber, lastPlacedIndex, newIdx), previousNewFiber === null ? resultingFirstChild = newFiber : previousNewFiber.sibling = newFiber, previousNewFiber = newFiber, oldFiber = nextOldFiber;
          }
          if (newIdx === newChildren.length) {
            if (deleteRemainingChildren(returnFiber, oldFiber), getIsHydrating()) {
              var numberOfForks = newIdx;
              pushTreeFork(returnFiber, numberOfForks);
            }
            return resultingFirstChild;
          }
          if (oldFiber === null) {
            for (; newIdx < newChildren.length; newIdx++) {
              var _newFiber = createChild(returnFiber, newChildren[newIdx], lanes);
              _newFiber !== null && (lastPlacedIndex = placeChild(_newFiber, lastPlacedIndex, newIdx), previousNewFiber === null ? resultingFirstChild = _newFiber : previousNewFiber.sibling = _newFiber, previousNewFiber = _newFiber);
            }
            if (getIsHydrating()) {
              var _numberOfForks = newIdx;
              pushTreeFork(returnFiber, _numberOfForks);
            }
            return resultingFirstChild;
          }
          for (var existingChildren = mapRemainingChildren(returnFiber, oldFiber); newIdx < newChildren.length; newIdx++) {
            var _newFiber2 = updateFromMap(existingChildren, returnFiber, newIdx, newChildren[newIdx], lanes);
            _newFiber2 !== null && (shouldTrackSideEffects && _newFiber2.alternate !== null && existingChildren.delete(_newFiber2.key === null ? newIdx : _newFiber2.key), lastPlacedIndex = placeChild(_newFiber2, lastPlacedIndex, newIdx), previousNewFiber === null ? resultingFirstChild = _newFiber2 : previousNewFiber.sibling = _newFiber2, previousNewFiber = _newFiber2);
          }
          if (shouldTrackSideEffects && existingChildren.forEach(function(child2) {
            return deleteChild(returnFiber, child2);
          }), getIsHydrating()) {
            var _numberOfForks2 = newIdx;
            pushTreeFork(returnFiber, _numberOfForks2);
          }
          return resultingFirstChild;
        }
        function reconcileChildrenIterator(returnFiber, currentFirstChild, newChildrenIterable, lanes) {
          var iteratorFn = getIteratorFn(newChildrenIterable);
          if (typeof iteratorFn != "function")
            throw new Error("An object is not an iterable. This error is likely caused by a bug in React. Please file an issue.");
          {
            typeof Symbol == "function" && // $FlowFixMe Flow doesn't know about toStringTag
            newChildrenIterable[Symbol.toStringTag] === "Generator" && (didWarnAboutGenerators || error("Using Generators as children is unsupported and will likely yield unexpected results because enumerating a generator mutates it. You may convert it to an array with `Array.from()` or the `[...spread]` operator before rendering. Keep in mind you might need to polyfill these features for older browsers."), didWarnAboutGenerators = !0), newChildrenIterable.entries === iteratorFn && (didWarnAboutMaps || error("Using Maps as children is not supported. Use an array of keyed ReactElements instead."), didWarnAboutMaps = !0);
            var _newChildren = iteratorFn.call(newChildrenIterable);
            if (_newChildren)
              for (var knownKeys = null, _step = _newChildren.next(); !_step.done; _step = _newChildren.next()) {
                var child = _step.value;
                knownKeys = warnOnInvalidKey(child, knownKeys, returnFiber);
              }
          }
          var newChildren = iteratorFn.call(newChildrenIterable);
          if (newChildren == null)
            throw new Error("An iterable object provided no iterator.");
          for (var resultingFirstChild = null, previousNewFiber = null, oldFiber = currentFirstChild, lastPlacedIndex = 0, newIdx = 0, nextOldFiber = null, step = newChildren.next(); oldFiber !== null && !step.done; newIdx++, step = newChildren.next()) {
            oldFiber.index > newIdx ? (nextOldFiber = oldFiber, oldFiber = null) : nextOldFiber = oldFiber.sibling;
            var newFiber = updateSlot(returnFiber, oldFiber, step.value, lanes);
            if (newFiber === null) {
              oldFiber === null && (oldFiber = nextOldFiber);
              break;
            }
            shouldTrackSideEffects && oldFiber && newFiber.alternate === null && deleteChild(returnFiber, oldFiber), lastPlacedIndex = placeChild(newFiber, lastPlacedIndex, newIdx), previousNewFiber === null ? resultingFirstChild = newFiber : previousNewFiber.sibling = newFiber, previousNewFiber = newFiber, oldFiber = nextOldFiber;
          }
          if (step.done) {
            if (deleteRemainingChildren(returnFiber, oldFiber), getIsHydrating()) {
              var numberOfForks = newIdx;
              pushTreeFork(returnFiber, numberOfForks);
            }
            return resultingFirstChild;
          }
          if (oldFiber === null) {
            for (; !step.done; newIdx++, step = newChildren.next()) {
              var _newFiber3 = createChild(returnFiber, step.value, lanes);
              _newFiber3 !== null && (lastPlacedIndex = placeChild(_newFiber3, lastPlacedIndex, newIdx), previousNewFiber === null ? resultingFirstChild = _newFiber3 : previousNewFiber.sibling = _newFiber3, previousNewFiber = _newFiber3);
            }
            if (getIsHydrating()) {
              var _numberOfForks3 = newIdx;
              pushTreeFork(returnFiber, _numberOfForks3);
            }
            return resultingFirstChild;
          }
          for (var existingChildren = mapRemainingChildren(returnFiber, oldFiber); !step.done; newIdx++, step = newChildren.next()) {
            var _newFiber4 = updateFromMap(existingChildren, returnFiber, newIdx, step.value, lanes);
            _newFiber4 !== null && (shouldTrackSideEffects && _newFiber4.alternate !== null && existingChildren.delete(_newFiber4.key === null ? newIdx : _newFiber4.key), lastPlacedIndex = placeChild(_newFiber4, lastPlacedIndex, newIdx), previousNewFiber === null ? resultingFirstChild = _newFiber4 : previousNewFiber.sibling = _newFiber4, previousNewFiber = _newFiber4);
          }
          if (shouldTrackSideEffects && existingChildren.forEach(function(child2) {
            return deleteChild(returnFiber, child2);
          }), getIsHydrating()) {
            var _numberOfForks4 = newIdx;
            pushTreeFork(returnFiber, _numberOfForks4);
          }
          return resultingFirstChild;
        }
        function reconcileSingleTextNode(returnFiber, currentFirstChild, textContent, lanes) {
          if (currentFirstChild !== null && currentFirstChild.tag === HostText) {
            deleteRemainingChildren(returnFiber, currentFirstChild.sibling);
            var existing = useFiber(currentFirstChild, textContent);
            return existing.return = returnFiber, existing;
          }
          deleteRemainingChildren(returnFiber, currentFirstChild);
          var created = createFiberFromText(textContent, returnFiber.mode, lanes);
          return created.return = returnFiber, created;
        }
        function reconcileSingleElement(returnFiber, currentFirstChild, element, lanes) {
          for (var key = element.key, child = currentFirstChild; child !== null; ) {
            if (child.key === key) {
              var elementType = element.type;
              if (elementType === REACT_FRAGMENT_TYPE) {
                if (child.tag === Fragment) {
                  deleteRemainingChildren(returnFiber, child.sibling);
                  var existing = useFiber(child, element.props.children);
                  return existing.return = returnFiber, existing._debugSource = element._source, existing._debugOwner = element._owner, existing;
                }
              } else if (child.elementType === elementType || // Keep this check inline so it only runs on the false path:
              isCompatibleFamilyForHotReloading(child, element) || // Lazy types should reconcile their resolved type.
              // We need to do this after the Hot Reloading check above,
              // because hot reloading has different semantics than prod because
              // it doesn't resuspend. So we can't let the call below suspend.
              typeof elementType == "object" && elementType !== null && elementType.$$typeof === REACT_LAZY_TYPE && resolveLazy(elementType) === child.type) {
                deleteRemainingChildren(returnFiber, child.sibling);
                var _existing = useFiber(child, element.props);
                return _existing.ref = coerceRef(returnFiber, child, element), _existing.return = returnFiber, _existing._debugSource = element._source, _existing._debugOwner = element._owner, _existing;
              }
              deleteRemainingChildren(returnFiber, child);
              break;
            } else
              deleteChild(returnFiber, child);
            child = child.sibling;
          }
          if (element.type === REACT_FRAGMENT_TYPE) {
            var created = createFiberFromFragment(element.props.children, returnFiber.mode, lanes, element.key);
            return created.return = returnFiber, created;
          } else {
            var _created4 = createFiberFromElement(element, returnFiber.mode, lanes);
            return _created4.ref = coerceRef(returnFiber, currentFirstChild, element), _created4.return = returnFiber, _created4;
          }
        }
        function reconcileSinglePortal(returnFiber, currentFirstChild, portal, lanes) {
          for (var key = portal.key, child = currentFirstChild; child !== null; ) {
            if (child.key === key)
              if (child.tag === HostPortal && child.stateNode.containerInfo === portal.containerInfo && child.stateNode.implementation === portal.implementation) {
                deleteRemainingChildren(returnFiber, child.sibling);
                var existing = useFiber(child, portal.children || []);
                return existing.return = returnFiber, existing;
              } else {
                deleteRemainingChildren(returnFiber, child);
                break;
              }
            else
              deleteChild(returnFiber, child);
            child = child.sibling;
          }
          var created = createFiberFromPortal(portal, returnFiber.mode, lanes);
          return created.return = returnFiber, created;
        }
        function reconcileChildFibers2(returnFiber, currentFirstChild, newChild, lanes) {
          var isUnkeyedTopLevelFragment = typeof newChild == "object" && newChild !== null && newChild.type === REACT_FRAGMENT_TYPE && newChild.key === null;
          if (isUnkeyedTopLevelFragment && (newChild = newChild.props.children), typeof newChild == "object" && newChild !== null) {
            switch (newChild.$$typeof) {
              case REACT_ELEMENT_TYPE:
                return placeSingleChild(reconcileSingleElement(returnFiber, currentFirstChild, newChild, lanes));
              case REACT_PORTAL_TYPE:
                return placeSingleChild(reconcileSinglePortal(returnFiber, currentFirstChild, newChild, lanes));
              case REACT_LAZY_TYPE:
                var payload = newChild._payload, init4 = newChild._init;
                return reconcileChildFibers2(returnFiber, currentFirstChild, init4(payload), lanes);
            }
            if (isArray(newChild))
              return reconcileChildrenArray(returnFiber, currentFirstChild, newChild, lanes);
            if (getIteratorFn(newChild))
              return reconcileChildrenIterator(returnFiber, currentFirstChild, newChild, lanes);
            throwOnInvalidObjectType(returnFiber, newChild);
          }
          return typeof newChild == "string" && newChild !== "" || typeof newChild == "number" ? placeSingleChild(reconcileSingleTextNode(returnFiber, currentFirstChild, "" + newChild, lanes)) : (typeof newChild == "function" && warnOnFunctionType(returnFiber), deleteRemainingChildren(returnFiber, currentFirstChild));
        }
        return reconcileChildFibers2;
      }
      var reconcileChildFibers = ChildReconciler(!0), mountChildFibers = ChildReconciler(!1);
      function cloneChildFibers(current2, workInProgress2) {
        if (current2 !== null && workInProgress2.child !== current2.child)
          throw new Error("Resuming work not yet implemented.");
        if (workInProgress2.child !== null) {
          var currentChild = workInProgress2.child, newChild = createWorkInProgress(currentChild, currentChild.pendingProps);
          for (workInProgress2.child = newChild, newChild.return = workInProgress2; currentChild.sibling !== null; )
            currentChild = currentChild.sibling, newChild = newChild.sibling = createWorkInProgress(currentChild, currentChild.pendingProps), newChild.return = workInProgress2;
          newChild.sibling = null;
        }
      }
      function resetChildFibers(workInProgress2, lanes) {
        for (var child = workInProgress2.child; child !== null; )
          resetWorkInProgress(child, lanes), child = child.sibling;
      }
      var NO_CONTEXT = {}, contextStackCursor$1 = createCursor(NO_CONTEXT), contextFiberStackCursor = createCursor(NO_CONTEXT), rootInstanceStackCursor = createCursor(NO_CONTEXT);
      function requiredContext(c) {
        if (c === NO_CONTEXT)
          throw new Error("Expected host context to exist. This error is likely caused by a bug in React. Please file an issue.");
        return c;
      }
      function getRootHostContainer() {
        var rootInstance = requiredContext(rootInstanceStackCursor.current);
        return rootInstance;
      }
      function pushHostContainer(fiber, nextRootInstance) {
        push2(rootInstanceStackCursor, nextRootInstance, fiber), push2(contextFiberStackCursor, fiber, fiber), push2(contextStackCursor$1, NO_CONTEXT, fiber);
        var nextRootContext = getRootHostContext(nextRootInstance);
        pop(contextStackCursor$1, fiber), push2(contextStackCursor$1, nextRootContext, fiber);
      }
      function popHostContainer(fiber) {
        pop(contextStackCursor$1, fiber), pop(contextFiberStackCursor, fiber), pop(rootInstanceStackCursor, fiber);
      }
      function getHostContext() {
        var context = requiredContext(contextStackCursor$1.current);
        return context;
      }
      function pushHostContext(fiber) {
        var rootInstance = requiredContext(rootInstanceStackCursor.current), context = requiredContext(contextStackCursor$1.current), nextContext = getChildHostContext(context, fiber.type);
        context !== nextContext && (push2(contextFiberStackCursor, fiber, fiber), push2(contextStackCursor$1, nextContext, fiber));
      }
      function popHostContext(fiber) {
        contextFiberStackCursor.current === fiber && (pop(contextStackCursor$1, fiber), pop(contextFiberStackCursor, fiber));
      }
      var DefaultSuspenseContext = 0, SubtreeSuspenseContextMask = 1, InvisibleParentSuspenseContext = 1, ForceSuspenseFallback = 2, suspenseStackCursor = createCursor(DefaultSuspenseContext);
      function hasSuspenseContext(parentContext, flag) {
        return (parentContext & flag) !== 0;
      }
      function setDefaultShallowSuspenseContext(parentContext) {
        return parentContext & SubtreeSuspenseContextMask;
      }
      function setShallowSuspenseContext(parentContext, shallowContext) {
        return parentContext & SubtreeSuspenseContextMask | shallowContext;
      }
      function addSubtreeSuspenseContext(parentContext, subtreeContext) {
        return parentContext | subtreeContext;
      }
      function pushSuspenseContext(fiber, newContext) {
        push2(suspenseStackCursor, newContext, fiber);
      }
      function popSuspenseContext(fiber) {
        pop(suspenseStackCursor, fiber);
      }
      function shouldCaptureSuspense(workInProgress2, hasInvisibleParent) {
        var nextState = workInProgress2.memoizedState;
        if (nextState !== null)
          return nextState.dehydrated !== null;
        var props = workInProgress2.memoizedProps;
        return !0;
      }
      function findFirstSuspended(row) {
        for (var node = row; node !== null; ) {
          if (node.tag === SuspenseComponent) {
            var state = node.memoizedState;
            if (state !== null) {
              var dehydrated = state.dehydrated;
              if (dehydrated === null || isSuspenseInstancePending(dehydrated) || isSuspenseInstanceFallback(dehydrated))
                return node;
            }
          } else if (node.tag === SuspenseListComponent && // revealOrder undefined can't be trusted because it don't
          // keep track of whether it suspended or not.
          node.memoizedProps.revealOrder !== void 0) {
            var didSuspend = (node.flags & DidCapture) !== NoFlags;
            if (didSuspend)
              return node;
          } else if (node.child !== null) {
            node.child.return = node, node = node.child;
            continue;
          }
          if (node === row)
            return null;
          for (; node.sibling === null; ) {
            if (node.return === null || node.return === row)
              return null;
            node = node.return;
          }
          node.sibling.return = node.return, node = node.sibling;
        }
        return null;
      }
      var NoFlags$1 = (
        /*   */
        0
      ), HasEffect = (
        /* */
        1
      ), Insertion = (
        /*  */
        2
      ), Layout = (
        /*    */
        4
      ), Passive$1 = (
        /*   */
        8
      ), workInProgressSources = [];
      function resetWorkInProgressVersions() {
        for (var i = 0; i < workInProgressSources.length; i++) {
          var mutableSource = workInProgressSources[i];
          mutableSource._workInProgressVersionPrimary = null;
        }
        workInProgressSources.length = 0;
      }
      function registerMutableSourceForHydration(root2, mutableSource) {
        var getVersion = mutableSource._getVersion, version2 = getVersion(mutableSource._source);
        root2.mutableSourceEagerHydrationData == null ? root2.mutableSourceEagerHydrationData = [mutableSource, version2] : root2.mutableSourceEagerHydrationData.push(mutableSource, version2);
      }
      var ReactCurrentDispatcher$1 = ReactSharedInternals.ReactCurrentDispatcher, ReactCurrentBatchConfig$2 = ReactSharedInternals.ReactCurrentBatchConfig, didWarnAboutMismatchedHooksForComponent, didWarnUncachedGetSnapshot;
      didWarnAboutMismatchedHooksForComponent = /* @__PURE__ */ new Set();
      var renderLanes = NoLanes, currentlyRenderingFiber$1 = null, currentHook = null, workInProgressHook = null, didScheduleRenderPhaseUpdate = !1, didScheduleRenderPhaseUpdateDuringThisPass = !1, localIdCounter = 0, globalClientIdCounter = 0, RE_RENDER_LIMIT = 25, currentHookNameInDev = null, hookTypesDev = null, hookTypesUpdateIndexDev = -1, ignorePreviousDependencies = !1;
      function mountHookTypesDev() {
        {
          var hookName = currentHookNameInDev;
          hookTypesDev === null ? hookTypesDev = [hookName] : hookTypesDev.push(hookName);
        }
      }
      function updateHookTypesDev() {
        {
          var hookName = currentHookNameInDev;
          hookTypesDev !== null && (hookTypesUpdateIndexDev++, hookTypesDev[hookTypesUpdateIndexDev] !== hookName && warnOnHookMismatchInDev(hookName));
        }
      }
      function checkDepsAreArrayDev(deps) {
        deps != null && !isArray(deps) && error("%s received a final argument that is not an array (instead, received `%s`). When specified, the final argument must be an array.", currentHookNameInDev, typeof deps);
      }
      function warnOnHookMismatchInDev(currentHookName) {
        {
          var componentName = getComponentNameFromFiber(currentlyRenderingFiber$1);
          if (!didWarnAboutMismatchedHooksForComponent.has(componentName) && (didWarnAboutMismatchedHooksForComponent.add(componentName), hookTypesDev !== null)) {
            for (var table = "", secondColumnStart = 30, i = 0; i <= hookTypesUpdateIndexDev; i++) {
              for (var oldHookName = hookTypesDev[i], newHookName = i === hookTypesUpdateIndexDev ? currentHookName : oldHookName, row = i + 1 + ". " + oldHookName; row.length < secondColumnStart; )
                row += " ";
              row += newHookName + `
`, table += row;
            }
            error(`React has detected a change in the order of Hooks called by %s. This will lead to bugs and errors if not fixed. For more information, read the Rules of Hooks: https://reactjs.org/link/rules-of-hooks

   Previous render            Next render
   ------------------------------------------------------
%s   ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
`, componentName, table);
          }
        }
      }
      function throwInvalidHookError() {
        throw new Error(`Invalid hook call. Hooks can only be called inside of the body of a function component. This could happen for one of the following reasons:
1. You might have mismatching versions of React and the renderer (such as React DOM)
2. You might be breaking the Rules of Hooks
3. You might have more than one copy of React in the same app
See https://reactjs.org/link/invalid-hook-call for tips about how to debug and fix this problem.`);
      }
      function areHookInputsEqual(nextDeps, prevDeps) {
        if (ignorePreviousDependencies)
          return !1;
        if (prevDeps === null)
          return error("%s received a final argument during this render, but not during the previous render. Even though the final argument is optional, its type cannot change between renders.", currentHookNameInDev), !1;
        nextDeps.length !== prevDeps.length && error(`The final argument passed to %s changed size between renders. The order and size of this array must remain constant.

Previous: %s
Incoming: %s`, currentHookNameInDev, "[" + prevDeps.join(", ") + "]", "[" + nextDeps.join(", ") + "]");
        for (var i = 0; i < prevDeps.length && i < nextDeps.length; i++)
          if (!objectIs(nextDeps[i], prevDeps[i]))
            return !1;
        return !0;
      }
      function renderWithHooks(current2, workInProgress2, Component, props, secondArg, nextRenderLanes) {
        renderLanes = nextRenderLanes, currentlyRenderingFiber$1 = workInProgress2, hookTypesDev = current2 !== null ? current2._debugHookTypes : null, hookTypesUpdateIndexDev = -1, ignorePreviousDependencies = current2 !== null && current2.type !== workInProgress2.type, workInProgress2.memoizedState = null, workInProgress2.updateQueue = null, workInProgress2.lanes = NoLanes, current2 !== null && current2.memoizedState !== null ? ReactCurrentDispatcher$1.current = HooksDispatcherOnUpdateInDEV : hookTypesDev !== null ? ReactCurrentDispatcher$1.current = HooksDispatcherOnMountWithHookTypesInDEV : ReactCurrentDispatcher$1.current = HooksDispatcherOnMountInDEV;
        var children = Component(props, secondArg);
        if (didScheduleRenderPhaseUpdateDuringThisPass) {
          var numberOfReRenders = 0;
          do {
            if (didScheduleRenderPhaseUpdateDuringThisPass = !1, localIdCounter = 0, numberOfReRenders >= RE_RENDER_LIMIT)
              throw new Error("Too many re-renders. React limits the number of renders to prevent an infinite loop.");
            numberOfReRenders += 1, ignorePreviousDependencies = !1, currentHook = null, workInProgressHook = null, workInProgress2.updateQueue = null, hookTypesUpdateIndexDev = -1, ReactCurrentDispatcher$1.current = HooksDispatcherOnRerenderInDEV, children = Component(props, secondArg);
          } while (didScheduleRenderPhaseUpdateDuringThisPass);
        }
        ReactCurrentDispatcher$1.current = ContextOnlyDispatcher, workInProgress2._debugHookTypes = hookTypesDev;
        var didRenderTooFewHooks = currentHook !== null && currentHook.next !== null;
        if (renderLanes = NoLanes, currentlyRenderingFiber$1 = null, currentHook = null, workInProgressHook = null, currentHookNameInDev = null, hookTypesDev = null, hookTypesUpdateIndexDev = -1, current2 !== null && (current2.flags & StaticMask) !== (workInProgress2.flags & StaticMask) && // Disable this warning in legacy mode, because legacy Suspense is weird
        // and creates false positives. To make this work in legacy mode, we'd
        // need to mark fibers that commit in an incomplete state, somehow. For
        // now I'll disable the warning that most of the bugs that would trigger
        // it are either exclusive to concurrent mode or exist in both.
        (current2.mode & ConcurrentMode) !== NoMode && error("Internal React error: Expected static flag was missing. Please notify the React team."), didScheduleRenderPhaseUpdate = !1, didRenderTooFewHooks)
          throw new Error("Rendered fewer hooks than expected. This may be caused by an accidental early return statement.");
        return children;
      }
      function checkDidRenderIdHook() {
        var didRenderIdHook = localIdCounter !== 0;
        return localIdCounter = 0, didRenderIdHook;
      }
      function bailoutHooks(current2, workInProgress2, lanes) {
        workInProgress2.updateQueue = current2.updateQueue, (workInProgress2.mode & StrictEffectsMode) !== NoMode ? workInProgress2.flags &= ~(MountPassiveDev | MountLayoutDev | Passive | Update) : workInProgress2.flags &= ~(Passive | Update), current2.lanes = removeLanes(current2.lanes, lanes);
      }
      function resetHooksAfterThrow() {
        if (ReactCurrentDispatcher$1.current = ContextOnlyDispatcher, didScheduleRenderPhaseUpdate) {
          for (var hook2 = currentlyRenderingFiber$1.memoizedState; hook2 !== null; ) {
            var queue = hook2.queue;
            queue !== null && (queue.pending = null), hook2 = hook2.next;
          }
          didScheduleRenderPhaseUpdate = !1;
        }
        renderLanes = NoLanes, currentlyRenderingFiber$1 = null, currentHook = null, workInProgressHook = null, hookTypesDev = null, hookTypesUpdateIndexDev = -1, currentHookNameInDev = null, isUpdatingOpaqueValueInRenderPhase = !1, didScheduleRenderPhaseUpdateDuringThisPass = !1, localIdCounter = 0;
      }
      function mountWorkInProgressHook() {
        var hook2 = {
          memoizedState: null,
          baseState: null,
          baseQueue: null,
          queue: null,
          next: null
        };
        return workInProgressHook === null ? currentlyRenderingFiber$1.memoizedState = workInProgressHook = hook2 : workInProgressHook = workInProgressHook.next = hook2, workInProgressHook;
      }
      function updateWorkInProgressHook() {
        var nextCurrentHook;
        if (currentHook === null) {
          var current2 = currentlyRenderingFiber$1.alternate;
          current2 !== null ? nextCurrentHook = current2.memoizedState : nextCurrentHook = null;
        } else
          nextCurrentHook = currentHook.next;
        var nextWorkInProgressHook;
        if (workInProgressHook === null ? nextWorkInProgressHook = currentlyRenderingFiber$1.memoizedState : nextWorkInProgressHook = workInProgressHook.next, nextWorkInProgressHook !== null)
          workInProgressHook = nextWorkInProgressHook, nextWorkInProgressHook = workInProgressHook.next, currentHook = nextCurrentHook;
        else {
          if (nextCurrentHook === null)
            throw new Error("Rendered more hooks than during the previous render.");
          currentHook = nextCurrentHook;
          var newHook = {
            memoizedState: currentHook.memoizedState,
            baseState: currentHook.baseState,
            baseQueue: currentHook.baseQueue,
            queue: currentHook.queue,
            next: null
          };
          workInProgressHook === null ? currentlyRenderingFiber$1.memoizedState = workInProgressHook = newHook : workInProgressHook = workInProgressHook.next = newHook;
        }
        return workInProgressHook;
      }
      function createFunctionComponentUpdateQueue() {
        return {
          lastEffect: null,
          stores: null
        };
      }
      function basicStateReducer(state, action) {
        return typeof action == "function" ? action(state) : action;
      }
      function mountReducer(reducer, initialArg, init4) {
        var hook2 = mountWorkInProgressHook(), initialState;
        init4 !== void 0 ? initialState = init4(initialArg) : initialState = initialArg, hook2.memoizedState = hook2.baseState = initialState;
        var queue = {
          pending: null,
          interleaved: null,
          lanes: NoLanes,
          dispatch: null,
          lastRenderedReducer: reducer,
          lastRenderedState: initialState
        };
        hook2.queue = queue;
        var dispatch = queue.dispatch = dispatchReducerAction.bind(null, currentlyRenderingFiber$1, queue);
        return [hook2.memoizedState, dispatch];
      }
      function updateReducer(reducer, initialArg, init4) {
        var hook2 = updateWorkInProgressHook(), queue = hook2.queue;
        if (queue === null)
          throw new Error("Should have a queue. This is likely a bug in React. Please file an issue.");
        queue.lastRenderedReducer = reducer;
        var current2 = currentHook, baseQueue = current2.baseQueue, pendingQueue = queue.pending;
        if (pendingQueue !== null) {
          if (baseQueue !== null) {
            var baseFirst = baseQueue.next, pendingFirst = pendingQueue.next;
            baseQueue.next = pendingFirst, pendingQueue.next = baseFirst;
          }
          current2.baseQueue !== baseQueue && error("Internal error: Expected work-in-progress queue to be a clone. This is a bug in React."), current2.baseQueue = baseQueue = pendingQueue, queue.pending = null;
        }
        if (baseQueue !== null) {
          var first = baseQueue.next, newState = current2.baseState, newBaseState = null, newBaseQueueFirst = null, newBaseQueueLast = null, update2 = first;
          do {
            var updateLane = update2.lane;
            if (isSubsetOfLanes(renderLanes, updateLane)) {
              if (newBaseQueueLast !== null) {
                var _clone = {
                  // This update is going to be committed so we never want uncommit
                  // it. Using NoLane works because 0 is a subset of all bitmasks, so
                  // this will never be skipped by the check above.
                  lane: NoLane,
                  action: update2.action,
                  hasEagerState: update2.hasEagerState,
                  eagerState: update2.eagerState,
                  next: null
                };
                newBaseQueueLast = newBaseQueueLast.next = _clone;
              }
              if (update2.hasEagerState)
                newState = update2.eagerState;
              else {
                var action = update2.action;
                newState = reducer(newState, action);
              }
            } else {
              var clone = {
                lane: updateLane,
                action: update2.action,
                hasEagerState: update2.hasEagerState,
                eagerState: update2.eagerState,
                next: null
              };
              newBaseQueueLast === null ? (newBaseQueueFirst = newBaseQueueLast = clone, newBaseState = newState) : newBaseQueueLast = newBaseQueueLast.next = clone, currentlyRenderingFiber$1.lanes = mergeLanes(currentlyRenderingFiber$1.lanes, updateLane), markSkippedUpdateLanes(updateLane);
            }
            update2 = update2.next;
          } while (update2 !== null && update2 !== first);
          newBaseQueueLast === null ? newBaseState = newState : newBaseQueueLast.next = newBaseQueueFirst, objectIs(newState, hook2.memoizedState) || markWorkInProgressReceivedUpdate(), hook2.memoizedState = newState, hook2.baseState = newBaseState, hook2.baseQueue = newBaseQueueLast, queue.lastRenderedState = newState;
        }
        var lastInterleaved = queue.interleaved;
        if (lastInterleaved !== null) {
          var interleaved = lastInterleaved;
          do {
            var interleavedLane = interleaved.lane;
            currentlyRenderingFiber$1.lanes = mergeLanes(currentlyRenderingFiber$1.lanes, interleavedLane), markSkippedUpdateLanes(interleavedLane), interleaved = interleaved.next;
          } while (interleaved !== lastInterleaved);
        } else
          baseQueue === null && (queue.lanes = NoLanes);
        var dispatch = queue.dispatch;
        return [hook2.memoizedState, dispatch];
      }
      function rerenderReducer(reducer, initialArg, init4) {
        var hook2 = updateWorkInProgressHook(), queue = hook2.queue;
        if (queue === null)
          throw new Error("Should have a queue. This is likely a bug in React. Please file an issue.");
        queue.lastRenderedReducer = reducer;
        var dispatch = queue.dispatch, lastRenderPhaseUpdate = queue.pending, newState = hook2.memoizedState;
        if (lastRenderPhaseUpdate !== null) {
          queue.pending = null;
          var firstRenderPhaseUpdate = lastRenderPhaseUpdate.next, update2 = firstRenderPhaseUpdate;
          do {
            var action = update2.action;
            newState = reducer(newState, action), update2 = update2.next;
          } while (update2 !== firstRenderPhaseUpdate);
          objectIs(newState, hook2.memoizedState) || markWorkInProgressReceivedUpdate(), hook2.memoizedState = newState, hook2.baseQueue === null && (hook2.baseState = newState), queue.lastRenderedState = newState;
        }
        return [newState, dispatch];
      }
      function mountMutableSource(source, getSnapshot, subscribe) {
      }
      function updateMutableSource(source, getSnapshot, subscribe) {
      }
      function mountSyncExternalStore(subscribe, getSnapshot, getServerSnapshot) {
        var fiber = currentlyRenderingFiber$1, hook2 = mountWorkInProgressHook(), nextSnapshot, isHydrating2 = getIsHydrating();
        if (isHydrating2) {
          if (getServerSnapshot === void 0)
            throw new Error("Missing getServerSnapshot, which is required for server-rendered content. Will revert to client rendering.");
          nextSnapshot = getServerSnapshot(), didWarnUncachedGetSnapshot || nextSnapshot !== getServerSnapshot() && (error("The result of getServerSnapshot should be cached to avoid an infinite loop"), didWarnUncachedGetSnapshot = !0);
        } else {
          if (nextSnapshot = getSnapshot(), !didWarnUncachedGetSnapshot) {
            var cachedSnapshot = getSnapshot();
            objectIs(nextSnapshot, cachedSnapshot) || (error("The result of getSnapshot should be cached to avoid an infinite loop"), didWarnUncachedGetSnapshot = !0);
          }
          var root2 = getWorkInProgressRoot();
          if (root2 === null)
            throw new Error("Expected a work-in-progress root. This is a bug in React. Please file an issue.");
          includesBlockingLane(root2, renderLanes) || pushStoreConsistencyCheck(fiber, getSnapshot, nextSnapshot);
        }
        hook2.memoizedState = nextSnapshot;
        var inst = {
          value: nextSnapshot,
          getSnapshot
        };
        return hook2.queue = inst, mountEffect(subscribeToStore.bind(null, fiber, inst, subscribe), [subscribe]), fiber.flags |= Passive, pushEffect(HasEffect | Passive$1, updateStoreInstance.bind(null, fiber, inst, nextSnapshot, getSnapshot), void 0, null), nextSnapshot;
      }
      function updateSyncExternalStore(subscribe, getSnapshot, getServerSnapshot) {
        var fiber = currentlyRenderingFiber$1, hook2 = updateWorkInProgressHook(), nextSnapshot = getSnapshot();
        if (!didWarnUncachedGetSnapshot) {
          var cachedSnapshot = getSnapshot();
          objectIs(nextSnapshot, cachedSnapshot) || (error("The result of getSnapshot should be cached to avoid an infinite loop"), didWarnUncachedGetSnapshot = !0);
        }
        var prevSnapshot = hook2.memoizedState, snapshotChanged = !objectIs(prevSnapshot, nextSnapshot);
        snapshotChanged && (hook2.memoizedState = nextSnapshot, markWorkInProgressReceivedUpdate());
        var inst = hook2.queue;
        if (updateEffect(subscribeToStore.bind(null, fiber, inst, subscribe), [subscribe]), inst.getSnapshot !== getSnapshot || snapshotChanged || // Check if the susbcribe function changed. We can save some memory by
        // checking whether we scheduled a subscription effect above.
        workInProgressHook !== null && workInProgressHook.memoizedState.tag & HasEffect) {
          fiber.flags |= Passive, pushEffect(HasEffect | Passive$1, updateStoreInstance.bind(null, fiber, inst, nextSnapshot, getSnapshot), void 0, null);
          var root2 = getWorkInProgressRoot();
          if (root2 === null)
            throw new Error("Expected a work-in-progress root. This is a bug in React. Please file an issue.");
          includesBlockingLane(root2, renderLanes) || pushStoreConsistencyCheck(fiber, getSnapshot, nextSnapshot);
        }
        return nextSnapshot;
      }
      function pushStoreConsistencyCheck(fiber, getSnapshot, renderedSnapshot) {
        fiber.flags |= StoreConsistency;
        var check2 = {
          getSnapshot,
          value: renderedSnapshot
        }, componentUpdateQueue = currentlyRenderingFiber$1.updateQueue;
        if (componentUpdateQueue === null)
          componentUpdateQueue = createFunctionComponentUpdateQueue(), currentlyRenderingFiber$1.updateQueue = componentUpdateQueue, componentUpdateQueue.stores = [check2];
        else {
          var stores = componentUpdateQueue.stores;
          stores === null ? componentUpdateQueue.stores = [check2] : stores.push(check2);
        }
      }
      function updateStoreInstance(fiber, inst, nextSnapshot, getSnapshot) {
        inst.value = nextSnapshot, inst.getSnapshot = getSnapshot, checkIfSnapshotChanged(inst) && forceStoreRerender(fiber);
      }
      function subscribeToStore(fiber, inst, subscribe) {
        var handleStoreChange = function() {
          checkIfSnapshotChanged(inst) && forceStoreRerender(fiber);
        };
        return subscribe(handleStoreChange);
      }
      function checkIfSnapshotChanged(inst) {
        var latestGetSnapshot = inst.getSnapshot, prevValue = inst.value;
        try {
          var nextValue = latestGetSnapshot();
          return !objectIs(prevValue, nextValue);
        } catch {
          return !0;
        }
      }
      function forceStoreRerender(fiber) {
        var root2 = enqueueConcurrentRenderForLane(fiber, SyncLane);
        root2 !== null && scheduleUpdateOnFiber(root2, fiber, SyncLane, NoTimestamp);
      }
      function mountState(initialState) {
        var hook2 = mountWorkInProgressHook();
        typeof initialState == "function" && (initialState = initialState()), hook2.memoizedState = hook2.baseState = initialState;
        var queue = {
          pending: null,
          interleaved: null,
          lanes: NoLanes,
          dispatch: null,
          lastRenderedReducer: basicStateReducer,
          lastRenderedState: initialState
        };
        hook2.queue = queue;
        var dispatch = queue.dispatch = dispatchSetState.bind(null, currentlyRenderingFiber$1, queue);
        return [hook2.memoizedState, dispatch];
      }
      function updateState(initialState) {
        return updateReducer(basicStateReducer);
      }
      function rerenderState(initialState) {
        return rerenderReducer(basicStateReducer);
      }
      function pushEffect(tag, create, destroy, deps) {
        var effect = {
          tag,
          create,
          destroy,
          deps,
          // Circular
          next: null
        }, componentUpdateQueue = currentlyRenderingFiber$1.updateQueue;
        if (componentUpdateQueue === null)
          componentUpdateQueue = createFunctionComponentUpdateQueue(), currentlyRenderingFiber$1.updateQueue = componentUpdateQueue, componentUpdateQueue.lastEffect = effect.next = effect;
        else {
          var lastEffect = componentUpdateQueue.lastEffect;
          if (lastEffect === null)
            componentUpdateQueue.lastEffect = effect.next = effect;
          else {
            var firstEffect = lastEffect.next;
            lastEffect.next = effect, effect.next = firstEffect, componentUpdateQueue.lastEffect = effect;
          }
        }
        return effect;
      }
      function mountRef(initialValue) {
        var hook2 = mountWorkInProgressHook();
        {
          var _ref2 = {
            current: initialValue
          };
          return hook2.memoizedState = _ref2, _ref2;
        }
      }
      function updateRef(initialValue) {
        var hook2 = updateWorkInProgressHook();
        return hook2.memoizedState;
      }
      function mountEffectImpl(fiberFlags, hookFlags, create, deps) {
        var hook2 = mountWorkInProgressHook(), nextDeps = deps === void 0 ? null : deps;
        currentlyRenderingFiber$1.flags |= fiberFlags, hook2.memoizedState = pushEffect(HasEffect | hookFlags, create, void 0, nextDeps);
      }
      function updateEffectImpl(fiberFlags, hookFlags, create, deps) {
        var hook2 = updateWorkInProgressHook(), nextDeps = deps === void 0 ? null : deps, destroy = void 0;
        if (currentHook !== null) {
          var prevEffect = currentHook.memoizedState;
          if (destroy = prevEffect.destroy, nextDeps !== null) {
            var prevDeps = prevEffect.deps;
            if (areHookInputsEqual(nextDeps, prevDeps)) {
              hook2.memoizedState = pushEffect(hookFlags, create, destroy, nextDeps);
              return;
            }
          }
        }
        currentlyRenderingFiber$1.flags |= fiberFlags, hook2.memoizedState = pushEffect(HasEffect | hookFlags, create, destroy, nextDeps);
      }
      function mountEffect(create, deps) {
        return (currentlyRenderingFiber$1.mode & StrictEffectsMode) !== NoMode ? mountEffectImpl(MountPassiveDev | Passive | PassiveStatic, Passive$1, create, deps) : mountEffectImpl(Passive | PassiveStatic, Passive$1, create, deps);
      }
      function updateEffect(create, deps) {
        return updateEffectImpl(Passive, Passive$1, create, deps);
      }
      function mountInsertionEffect(create, deps) {
        return mountEffectImpl(Update, Insertion, create, deps);
      }
      function updateInsertionEffect(create, deps) {
        return updateEffectImpl(Update, Insertion, create, deps);
      }
      function mountLayoutEffect(create, deps) {
        var fiberFlags = Update;
        return fiberFlags |= LayoutStatic, (currentlyRenderingFiber$1.mode & StrictEffectsMode) !== NoMode && (fiberFlags |= MountLayoutDev), mountEffectImpl(fiberFlags, Layout, create, deps);
      }
      function updateLayoutEffect(create, deps) {
        return updateEffectImpl(Update, Layout, create, deps);
      }
      function imperativeHandleEffect(create, ref) {
        if (typeof ref == "function") {
          var refCallback = ref, _inst = create();
          return refCallback(_inst), function() {
            refCallback(null);
          };
        } else if (ref != null) {
          var refObject = ref;
          refObject.hasOwnProperty("current") || error("Expected useImperativeHandle() first argument to either be a ref callback or React.createRef() object. Instead received: %s.", "an object with keys {" + Object.keys(refObject).join(", ") + "}");
          var _inst2 = create();
          return refObject.current = _inst2, function() {
            refObject.current = null;
          };
        }
      }
      function mountImperativeHandle(ref, create, deps) {
        typeof create != "function" && error("Expected useImperativeHandle() second argument to be a function that creates a handle. Instead received: %s.", create !== null ? typeof create : "null");
        var effectDeps = deps != null ? deps.concat([ref]) : null, fiberFlags = Update;
        return fiberFlags |= LayoutStatic, (currentlyRenderingFiber$1.mode & StrictEffectsMode) !== NoMode && (fiberFlags |= MountLayoutDev), mountEffectImpl(fiberFlags, Layout, imperativeHandleEffect.bind(null, create, ref), effectDeps);
      }
      function updateImperativeHandle(ref, create, deps) {
        typeof create != "function" && error("Expected useImperativeHandle() second argument to be a function that creates a handle. Instead received: %s.", create !== null ? typeof create : "null");
        var effectDeps = deps != null ? deps.concat([ref]) : null;
        return updateEffectImpl(Update, Layout, imperativeHandleEffect.bind(null, create, ref), effectDeps);
      }
      function mountDebugValue(value, formatterFn) {
      }
      var updateDebugValue = mountDebugValue;
      function mountCallback(callback, deps) {
        var hook2 = mountWorkInProgressHook(), nextDeps = deps === void 0 ? null : deps;
        return hook2.memoizedState = [callback, nextDeps], callback;
      }
      function updateCallback(callback, deps) {
        var hook2 = updateWorkInProgressHook(), nextDeps = deps === void 0 ? null : deps, prevState = hook2.memoizedState;
        if (prevState !== null && nextDeps !== null) {
          var prevDeps = prevState[1];
          if (areHookInputsEqual(nextDeps, prevDeps))
            return prevState[0];
        }
        return hook2.memoizedState = [callback, nextDeps], callback;
      }
      function mountMemo(nextCreate, deps) {
        var hook2 = mountWorkInProgressHook(), nextDeps = deps === void 0 ? null : deps, nextValue = nextCreate();
        return hook2.memoizedState = [nextValue, nextDeps], nextValue;
      }
      function updateMemo(nextCreate, deps) {
        var hook2 = updateWorkInProgressHook(), nextDeps = deps === void 0 ? null : deps, prevState = hook2.memoizedState;
        if (prevState !== null && nextDeps !== null) {
          var prevDeps = prevState[1];
          if (areHookInputsEqual(nextDeps, prevDeps))
            return prevState[0];
        }
        var nextValue = nextCreate();
        return hook2.memoizedState = [nextValue, nextDeps], nextValue;
      }
      function mountDeferredValue(value) {
        var hook2 = mountWorkInProgressHook();
        return hook2.memoizedState = value, value;
      }
      function updateDeferredValue(value) {
        var hook2 = updateWorkInProgressHook(), resolvedCurrentHook = currentHook, prevValue = resolvedCurrentHook.memoizedState;
        return updateDeferredValueImpl(hook2, prevValue, value);
      }
      function rerenderDeferredValue(value) {
        var hook2 = updateWorkInProgressHook();
        if (currentHook === null)
          return hook2.memoizedState = value, value;
        var prevValue = currentHook.memoizedState;
        return updateDeferredValueImpl(hook2, prevValue, value);
      }
      function updateDeferredValueImpl(hook2, prevValue, value) {
        var shouldDeferValue = !includesOnlyNonUrgentLanes(renderLanes);
        if (shouldDeferValue) {
          if (!objectIs(value, prevValue)) {
            var deferredLane = claimNextTransitionLane();
            currentlyRenderingFiber$1.lanes = mergeLanes(currentlyRenderingFiber$1.lanes, deferredLane), markSkippedUpdateLanes(deferredLane), hook2.baseState = !0;
          }
          return prevValue;
        } else
          return hook2.baseState && (hook2.baseState = !1, markWorkInProgressReceivedUpdate()), hook2.memoizedState = value, value;
      }
      function startTransition(setPending, callback, options2) {
        var previousPriority = getCurrentUpdatePriority();
        setCurrentUpdatePriority(higherEventPriority(previousPriority, ContinuousEventPriority)), setPending(!0);
        var prevTransition = ReactCurrentBatchConfig$2.transition;
        ReactCurrentBatchConfig$2.transition = {};
        var currentTransition = ReactCurrentBatchConfig$2.transition;
        ReactCurrentBatchConfig$2.transition._updatedFibers = /* @__PURE__ */ new Set();
        try {
          setPending(!1), callback();
        } finally {
          if (setCurrentUpdatePriority(previousPriority), ReactCurrentBatchConfig$2.transition = prevTransition, prevTransition === null && currentTransition._updatedFibers) {
            var updatedFibersCount = currentTransition._updatedFibers.size;
            updatedFibersCount > 10 && warn("Detected a large number of updates inside startTransition. If this is due to a subscription please re-write it to use React provided hooks. Otherwise concurrent mode guarantees are off the table."), currentTransition._updatedFibers.clear();
          }
        }
      }
      function mountTransition() {
        var _mountState = mountState(!1), isPending = _mountState[0], setPending = _mountState[1], start = startTransition.bind(null, setPending), hook2 = mountWorkInProgressHook();
        return hook2.memoizedState = start, [isPending, start];
      }
      function updateTransition() {
        var _updateState = updateState(), isPending = _updateState[0], hook2 = updateWorkInProgressHook(), start = hook2.memoizedState;
        return [isPending, start];
      }
      function rerenderTransition() {
        var _rerenderState = rerenderState(), isPending = _rerenderState[0], hook2 = updateWorkInProgressHook(), start = hook2.memoizedState;
        return [isPending, start];
      }
      var isUpdatingOpaqueValueInRenderPhase = !1;
      function getIsUpdatingOpaqueValueInRenderPhaseInDEV() {
        return isUpdatingOpaqueValueInRenderPhase;
      }
      function mountId() {
        var hook2 = mountWorkInProgressHook(), root2 = getWorkInProgressRoot(), identifierPrefix = root2.identifierPrefix, id;
        if (getIsHydrating()) {
          var treeId = getTreeId();
          id = ":" + identifierPrefix + "R" + treeId;
          var localId = localIdCounter++;
          localId > 0 && (id += "H" + localId.toString(32)), id += ":";
        } else {
          var globalClientId = globalClientIdCounter++;
          id = ":" + identifierPrefix + "r" + globalClientId.toString(32) + ":";
        }
        return hook2.memoizedState = id, id;
      }
      function updateId() {
        var hook2 = updateWorkInProgressHook(), id = hook2.memoizedState;
        return id;
      }
      function dispatchReducerAction(fiber, queue, action) {
        typeof arguments[3] == "function" && error("State updates from the useState() and useReducer() Hooks don't support the second callback argument. To execute a side effect after rendering, declare it in the component body with useEffect().");
        var lane = requestUpdateLane(fiber), update2 = {
          lane,
          action,
          hasEagerState: !1,
          eagerState: null,
          next: null
        };
        if (isRenderPhaseUpdate(fiber))
          enqueueRenderPhaseUpdate(queue, update2);
        else {
          var root2 = enqueueConcurrentHookUpdate(fiber, queue, update2, lane);
          if (root2 !== null) {
            var eventTime = requestEventTime();
            scheduleUpdateOnFiber(root2, fiber, lane, eventTime), entangleTransitionUpdate(root2, queue, lane);
          }
        }
        markUpdateInDevTools(fiber, lane);
      }
      function dispatchSetState(fiber, queue, action) {
        typeof arguments[3] == "function" && error("State updates from the useState() and useReducer() Hooks don't support the second callback argument. To execute a side effect after rendering, declare it in the component body with useEffect().");
        var lane = requestUpdateLane(fiber), update2 = {
          lane,
          action,
          hasEagerState: !1,
          eagerState: null,
          next: null
        };
        if (isRenderPhaseUpdate(fiber))
          enqueueRenderPhaseUpdate(queue, update2);
        else {
          var alternate = fiber.alternate;
          if (fiber.lanes === NoLanes && (alternate === null || alternate.lanes === NoLanes)) {
            var lastRenderedReducer = queue.lastRenderedReducer;
            if (lastRenderedReducer !== null) {
              var prevDispatcher;
              prevDispatcher = ReactCurrentDispatcher$1.current, ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
              try {
                var currentState = queue.lastRenderedState, eagerState = lastRenderedReducer(currentState, action);
                if (update2.hasEagerState = !0, update2.eagerState = eagerState, objectIs(eagerState, currentState)) {
                  enqueueConcurrentHookUpdateAndEagerlyBailout(fiber, queue, update2, lane);
                  return;
                }
              } catch {
              } finally {
                ReactCurrentDispatcher$1.current = prevDispatcher;
              }
            }
          }
          var root2 = enqueueConcurrentHookUpdate(fiber, queue, update2, lane);
          if (root2 !== null) {
            var eventTime = requestEventTime();
            scheduleUpdateOnFiber(root2, fiber, lane, eventTime), entangleTransitionUpdate(root2, queue, lane);
          }
        }
        markUpdateInDevTools(fiber, lane);
      }
      function isRenderPhaseUpdate(fiber) {
        var alternate = fiber.alternate;
        return fiber === currentlyRenderingFiber$1 || alternate !== null && alternate === currentlyRenderingFiber$1;
      }
      function enqueueRenderPhaseUpdate(queue, update2) {
        didScheduleRenderPhaseUpdateDuringThisPass = didScheduleRenderPhaseUpdate = !0;
        var pending = queue.pending;
        pending === null ? update2.next = update2 : (update2.next = pending.next, pending.next = update2), queue.pending = update2;
      }
      function entangleTransitionUpdate(root2, queue, lane) {
        if (isTransitionLane(lane)) {
          var queueLanes = queue.lanes;
          queueLanes = intersectLanes(queueLanes, root2.pendingLanes);
          var newQueueLanes = mergeLanes(queueLanes, lane);
          queue.lanes = newQueueLanes, markRootEntangled(root2, newQueueLanes);
        }
      }
      function markUpdateInDevTools(fiber, lane, action) {
        markStateUpdateScheduled(fiber, lane);
      }
      var ContextOnlyDispatcher = {
        readContext,
        useCallback: throwInvalidHookError,
        useContext: throwInvalidHookError,
        useEffect: throwInvalidHookError,
        useImperativeHandle: throwInvalidHookError,
        useInsertionEffect: throwInvalidHookError,
        useLayoutEffect: throwInvalidHookError,
        useMemo: throwInvalidHookError,
        useReducer: throwInvalidHookError,
        useRef: throwInvalidHookError,
        useState: throwInvalidHookError,
        useDebugValue: throwInvalidHookError,
        useDeferredValue: throwInvalidHookError,
        useTransition: throwInvalidHookError,
        useMutableSource: throwInvalidHookError,
        useSyncExternalStore: throwInvalidHookError,
        useId: throwInvalidHookError,
        unstable_isNewReconciler: enableNewReconciler
      }, HooksDispatcherOnMountInDEV = null, HooksDispatcherOnMountWithHookTypesInDEV = null, HooksDispatcherOnUpdateInDEV = null, HooksDispatcherOnRerenderInDEV = null, InvalidNestedHooksDispatcherOnMountInDEV = null, InvalidNestedHooksDispatcherOnUpdateInDEV = null, InvalidNestedHooksDispatcherOnRerenderInDEV = null;
      {
        var warnInvalidContextAccess = function() {
          error("Context can only be read while React is rendering. In classes, you can read it in the render method or getDerivedStateFromProps. In function components, you can read it directly in the function body, but not inside Hooks like useReducer() or useMemo().");
        }, warnInvalidHookAccess = function() {
          error("Do not call Hooks inside useEffect(...), useMemo(...), or other built-in Hooks. You can only call Hooks at the top level of your React function. For more information, see https://reactjs.org/link/rules-of-hooks");
        };
        HooksDispatcherOnMountInDEV = {
          readContext: function(context) {
            return readContext(context);
          },
          useCallback: function(callback, deps) {
            return currentHookNameInDev = "useCallback", mountHookTypesDev(), checkDepsAreArrayDev(deps), mountCallback(callback, deps);
          },
          useContext: function(context) {
            return currentHookNameInDev = "useContext", mountHookTypesDev(), readContext(context);
          },
          useEffect: function(create, deps) {
            return currentHookNameInDev = "useEffect", mountHookTypesDev(), checkDepsAreArrayDev(deps), mountEffect(create, deps);
          },
          useImperativeHandle: function(ref, create, deps) {
            return currentHookNameInDev = "useImperativeHandle", mountHookTypesDev(), checkDepsAreArrayDev(deps), mountImperativeHandle(ref, create, deps);
          },
          useInsertionEffect: function(create, deps) {
            return currentHookNameInDev = "useInsertionEffect", mountHookTypesDev(), checkDepsAreArrayDev(deps), mountInsertionEffect(create, deps);
          },
          useLayoutEffect: function(create, deps) {
            return currentHookNameInDev = "useLayoutEffect", mountHookTypesDev(), checkDepsAreArrayDev(deps), mountLayoutEffect(create, deps);
          },
          useMemo: function(create, deps) {
            currentHookNameInDev = "useMemo", mountHookTypesDev(), checkDepsAreArrayDev(deps);
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
            try {
              return mountMemo(create, deps);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useReducer: function(reducer, initialArg, init4) {
            currentHookNameInDev = "useReducer", mountHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
            try {
              return mountReducer(reducer, initialArg, init4);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useRef: function(initialValue) {
            return currentHookNameInDev = "useRef", mountHookTypesDev(), mountRef(initialValue);
          },
          useState: function(initialState) {
            currentHookNameInDev = "useState", mountHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
            try {
              return mountState(initialState);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useDebugValue: function(value, formatterFn) {
            return currentHookNameInDev = "useDebugValue", mountHookTypesDev(), void 0;
          },
          useDeferredValue: function(value) {
            return currentHookNameInDev = "useDeferredValue", mountHookTypesDev(), mountDeferredValue(value);
          },
          useTransition: function() {
            return currentHookNameInDev = "useTransition", mountHookTypesDev(), mountTransition();
          },
          useMutableSource: function(source, getSnapshot, subscribe) {
            return currentHookNameInDev = "useMutableSource", mountHookTypesDev(), void 0;
          },
          useSyncExternalStore: function(subscribe, getSnapshot, getServerSnapshot) {
            return currentHookNameInDev = "useSyncExternalStore", mountHookTypesDev(), mountSyncExternalStore(subscribe, getSnapshot, getServerSnapshot);
          },
          useId: function() {
            return currentHookNameInDev = "useId", mountHookTypesDev(), mountId();
          },
          unstable_isNewReconciler: enableNewReconciler
        }, HooksDispatcherOnMountWithHookTypesInDEV = {
          readContext: function(context) {
            return readContext(context);
          },
          useCallback: function(callback, deps) {
            return currentHookNameInDev = "useCallback", updateHookTypesDev(), mountCallback(callback, deps);
          },
          useContext: function(context) {
            return currentHookNameInDev = "useContext", updateHookTypesDev(), readContext(context);
          },
          useEffect: function(create, deps) {
            return currentHookNameInDev = "useEffect", updateHookTypesDev(), mountEffect(create, deps);
          },
          useImperativeHandle: function(ref, create, deps) {
            return currentHookNameInDev = "useImperativeHandle", updateHookTypesDev(), mountImperativeHandle(ref, create, deps);
          },
          useInsertionEffect: function(create, deps) {
            return currentHookNameInDev = "useInsertionEffect", updateHookTypesDev(), mountInsertionEffect(create, deps);
          },
          useLayoutEffect: function(create, deps) {
            return currentHookNameInDev = "useLayoutEffect", updateHookTypesDev(), mountLayoutEffect(create, deps);
          },
          useMemo: function(create, deps) {
            currentHookNameInDev = "useMemo", updateHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
            try {
              return mountMemo(create, deps);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useReducer: function(reducer, initialArg, init4) {
            currentHookNameInDev = "useReducer", updateHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
            try {
              return mountReducer(reducer, initialArg, init4);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useRef: function(initialValue) {
            return currentHookNameInDev = "useRef", updateHookTypesDev(), mountRef(initialValue);
          },
          useState: function(initialState) {
            currentHookNameInDev = "useState", updateHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
            try {
              return mountState(initialState);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useDebugValue: function(value, formatterFn) {
            return currentHookNameInDev = "useDebugValue", updateHookTypesDev(), void 0;
          },
          useDeferredValue: function(value) {
            return currentHookNameInDev = "useDeferredValue", updateHookTypesDev(), mountDeferredValue(value);
          },
          useTransition: function() {
            return currentHookNameInDev = "useTransition", updateHookTypesDev(), mountTransition();
          },
          useMutableSource: function(source, getSnapshot, subscribe) {
            return currentHookNameInDev = "useMutableSource", updateHookTypesDev(), void 0;
          },
          useSyncExternalStore: function(subscribe, getSnapshot, getServerSnapshot) {
            return currentHookNameInDev = "useSyncExternalStore", updateHookTypesDev(), mountSyncExternalStore(subscribe, getSnapshot, getServerSnapshot);
          },
          useId: function() {
            return currentHookNameInDev = "useId", updateHookTypesDev(), mountId();
          },
          unstable_isNewReconciler: enableNewReconciler
        }, HooksDispatcherOnUpdateInDEV = {
          readContext: function(context) {
            return readContext(context);
          },
          useCallback: function(callback, deps) {
            return currentHookNameInDev = "useCallback", updateHookTypesDev(), updateCallback(callback, deps);
          },
          useContext: function(context) {
            return currentHookNameInDev = "useContext", updateHookTypesDev(), readContext(context);
          },
          useEffect: function(create, deps) {
            return currentHookNameInDev = "useEffect", updateHookTypesDev(), updateEffect(create, deps);
          },
          useImperativeHandle: function(ref, create, deps) {
            return currentHookNameInDev = "useImperativeHandle", updateHookTypesDev(), updateImperativeHandle(ref, create, deps);
          },
          useInsertionEffect: function(create, deps) {
            return currentHookNameInDev = "useInsertionEffect", updateHookTypesDev(), updateInsertionEffect(create, deps);
          },
          useLayoutEffect: function(create, deps) {
            return currentHookNameInDev = "useLayoutEffect", updateHookTypesDev(), updateLayoutEffect(create, deps);
          },
          useMemo: function(create, deps) {
            currentHookNameInDev = "useMemo", updateHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
            try {
              return updateMemo(create, deps);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useReducer: function(reducer, initialArg, init4) {
            currentHookNameInDev = "useReducer", updateHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
            try {
              return updateReducer(reducer, initialArg, init4);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useRef: function(initialValue) {
            return currentHookNameInDev = "useRef", updateHookTypesDev(), updateRef();
          },
          useState: function(initialState) {
            currentHookNameInDev = "useState", updateHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
            try {
              return updateState(initialState);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useDebugValue: function(value, formatterFn) {
            return currentHookNameInDev = "useDebugValue", updateHookTypesDev(), updateDebugValue();
          },
          useDeferredValue: function(value) {
            return currentHookNameInDev = "useDeferredValue", updateHookTypesDev(), updateDeferredValue(value);
          },
          useTransition: function() {
            return currentHookNameInDev = "useTransition", updateHookTypesDev(), updateTransition();
          },
          useMutableSource: function(source, getSnapshot, subscribe) {
            return currentHookNameInDev = "useMutableSource", updateHookTypesDev(), void 0;
          },
          useSyncExternalStore: function(subscribe, getSnapshot, getServerSnapshot) {
            return currentHookNameInDev = "useSyncExternalStore", updateHookTypesDev(), updateSyncExternalStore(subscribe, getSnapshot);
          },
          useId: function() {
            return currentHookNameInDev = "useId", updateHookTypesDev(), updateId();
          },
          unstable_isNewReconciler: enableNewReconciler
        }, HooksDispatcherOnRerenderInDEV = {
          readContext: function(context) {
            return readContext(context);
          },
          useCallback: function(callback, deps) {
            return currentHookNameInDev = "useCallback", updateHookTypesDev(), updateCallback(callback, deps);
          },
          useContext: function(context) {
            return currentHookNameInDev = "useContext", updateHookTypesDev(), readContext(context);
          },
          useEffect: function(create, deps) {
            return currentHookNameInDev = "useEffect", updateHookTypesDev(), updateEffect(create, deps);
          },
          useImperativeHandle: function(ref, create, deps) {
            return currentHookNameInDev = "useImperativeHandle", updateHookTypesDev(), updateImperativeHandle(ref, create, deps);
          },
          useInsertionEffect: function(create, deps) {
            return currentHookNameInDev = "useInsertionEffect", updateHookTypesDev(), updateInsertionEffect(create, deps);
          },
          useLayoutEffect: function(create, deps) {
            return currentHookNameInDev = "useLayoutEffect", updateHookTypesDev(), updateLayoutEffect(create, deps);
          },
          useMemo: function(create, deps) {
            currentHookNameInDev = "useMemo", updateHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnRerenderInDEV;
            try {
              return updateMemo(create, deps);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useReducer: function(reducer, initialArg, init4) {
            currentHookNameInDev = "useReducer", updateHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnRerenderInDEV;
            try {
              return rerenderReducer(reducer, initialArg, init4);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useRef: function(initialValue) {
            return currentHookNameInDev = "useRef", updateHookTypesDev(), updateRef();
          },
          useState: function(initialState) {
            currentHookNameInDev = "useState", updateHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnRerenderInDEV;
            try {
              return rerenderState(initialState);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useDebugValue: function(value, formatterFn) {
            return currentHookNameInDev = "useDebugValue", updateHookTypesDev(), updateDebugValue();
          },
          useDeferredValue: function(value) {
            return currentHookNameInDev = "useDeferredValue", updateHookTypesDev(), rerenderDeferredValue(value);
          },
          useTransition: function() {
            return currentHookNameInDev = "useTransition", updateHookTypesDev(), rerenderTransition();
          },
          useMutableSource: function(source, getSnapshot, subscribe) {
            return currentHookNameInDev = "useMutableSource", updateHookTypesDev(), void 0;
          },
          useSyncExternalStore: function(subscribe, getSnapshot, getServerSnapshot) {
            return currentHookNameInDev = "useSyncExternalStore", updateHookTypesDev(), updateSyncExternalStore(subscribe, getSnapshot);
          },
          useId: function() {
            return currentHookNameInDev = "useId", updateHookTypesDev(), updateId();
          },
          unstable_isNewReconciler: enableNewReconciler
        }, InvalidNestedHooksDispatcherOnMountInDEV = {
          readContext: function(context) {
            return warnInvalidContextAccess(), readContext(context);
          },
          useCallback: function(callback, deps) {
            return currentHookNameInDev = "useCallback", warnInvalidHookAccess(), mountHookTypesDev(), mountCallback(callback, deps);
          },
          useContext: function(context) {
            return currentHookNameInDev = "useContext", warnInvalidHookAccess(), mountHookTypesDev(), readContext(context);
          },
          useEffect: function(create, deps) {
            return currentHookNameInDev = "useEffect", warnInvalidHookAccess(), mountHookTypesDev(), mountEffect(create, deps);
          },
          useImperativeHandle: function(ref, create, deps) {
            return currentHookNameInDev = "useImperativeHandle", warnInvalidHookAccess(), mountHookTypesDev(), mountImperativeHandle(ref, create, deps);
          },
          useInsertionEffect: function(create, deps) {
            return currentHookNameInDev = "useInsertionEffect", warnInvalidHookAccess(), mountHookTypesDev(), mountInsertionEffect(create, deps);
          },
          useLayoutEffect: function(create, deps) {
            return currentHookNameInDev = "useLayoutEffect", warnInvalidHookAccess(), mountHookTypesDev(), mountLayoutEffect(create, deps);
          },
          useMemo: function(create, deps) {
            currentHookNameInDev = "useMemo", warnInvalidHookAccess(), mountHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
            try {
              return mountMemo(create, deps);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useReducer: function(reducer, initialArg, init4) {
            currentHookNameInDev = "useReducer", warnInvalidHookAccess(), mountHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
            try {
              return mountReducer(reducer, initialArg, init4);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useRef: function(initialValue) {
            return currentHookNameInDev = "useRef", warnInvalidHookAccess(), mountHookTypesDev(), mountRef(initialValue);
          },
          useState: function(initialState) {
            currentHookNameInDev = "useState", warnInvalidHookAccess(), mountHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnMountInDEV;
            try {
              return mountState(initialState);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useDebugValue: function(value, formatterFn) {
            return currentHookNameInDev = "useDebugValue", warnInvalidHookAccess(), mountHookTypesDev(), void 0;
          },
          useDeferredValue: function(value) {
            return currentHookNameInDev = "useDeferredValue", warnInvalidHookAccess(), mountHookTypesDev(), mountDeferredValue(value);
          },
          useTransition: function() {
            return currentHookNameInDev = "useTransition", warnInvalidHookAccess(), mountHookTypesDev(), mountTransition();
          },
          useMutableSource: function(source, getSnapshot, subscribe) {
            return currentHookNameInDev = "useMutableSource", warnInvalidHookAccess(), mountHookTypesDev(), void 0;
          },
          useSyncExternalStore: function(subscribe, getSnapshot, getServerSnapshot) {
            return currentHookNameInDev = "useSyncExternalStore", warnInvalidHookAccess(), mountHookTypesDev(), mountSyncExternalStore(subscribe, getSnapshot, getServerSnapshot);
          },
          useId: function() {
            return currentHookNameInDev = "useId", warnInvalidHookAccess(), mountHookTypesDev(), mountId();
          },
          unstable_isNewReconciler: enableNewReconciler
        }, InvalidNestedHooksDispatcherOnUpdateInDEV = {
          readContext: function(context) {
            return warnInvalidContextAccess(), readContext(context);
          },
          useCallback: function(callback, deps) {
            return currentHookNameInDev = "useCallback", warnInvalidHookAccess(), updateHookTypesDev(), updateCallback(callback, deps);
          },
          useContext: function(context) {
            return currentHookNameInDev = "useContext", warnInvalidHookAccess(), updateHookTypesDev(), readContext(context);
          },
          useEffect: function(create, deps) {
            return currentHookNameInDev = "useEffect", warnInvalidHookAccess(), updateHookTypesDev(), updateEffect(create, deps);
          },
          useImperativeHandle: function(ref, create, deps) {
            return currentHookNameInDev = "useImperativeHandle", warnInvalidHookAccess(), updateHookTypesDev(), updateImperativeHandle(ref, create, deps);
          },
          useInsertionEffect: function(create, deps) {
            return currentHookNameInDev = "useInsertionEffect", warnInvalidHookAccess(), updateHookTypesDev(), updateInsertionEffect(create, deps);
          },
          useLayoutEffect: function(create, deps) {
            return currentHookNameInDev = "useLayoutEffect", warnInvalidHookAccess(), updateHookTypesDev(), updateLayoutEffect(create, deps);
          },
          useMemo: function(create, deps) {
            currentHookNameInDev = "useMemo", warnInvalidHookAccess(), updateHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
            try {
              return updateMemo(create, deps);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useReducer: function(reducer, initialArg, init4) {
            currentHookNameInDev = "useReducer", warnInvalidHookAccess(), updateHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
            try {
              return updateReducer(reducer, initialArg, init4);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useRef: function(initialValue) {
            return currentHookNameInDev = "useRef", warnInvalidHookAccess(), updateHookTypesDev(), updateRef();
          },
          useState: function(initialState) {
            currentHookNameInDev = "useState", warnInvalidHookAccess(), updateHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
            try {
              return updateState(initialState);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useDebugValue: function(value, formatterFn) {
            return currentHookNameInDev = "useDebugValue", warnInvalidHookAccess(), updateHookTypesDev(), updateDebugValue();
          },
          useDeferredValue: function(value) {
            return currentHookNameInDev = "useDeferredValue", warnInvalidHookAccess(), updateHookTypesDev(), updateDeferredValue(value);
          },
          useTransition: function() {
            return currentHookNameInDev = "useTransition", warnInvalidHookAccess(), updateHookTypesDev(), updateTransition();
          },
          useMutableSource: function(source, getSnapshot, subscribe) {
            return currentHookNameInDev = "useMutableSource", warnInvalidHookAccess(), updateHookTypesDev(), void 0;
          },
          useSyncExternalStore: function(subscribe, getSnapshot, getServerSnapshot) {
            return currentHookNameInDev = "useSyncExternalStore", warnInvalidHookAccess(), updateHookTypesDev(), updateSyncExternalStore(subscribe, getSnapshot);
          },
          useId: function() {
            return currentHookNameInDev = "useId", warnInvalidHookAccess(), updateHookTypesDev(), updateId();
          },
          unstable_isNewReconciler: enableNewReconciler
        }, InvalidNestedHooksDispatcherOnRerenderInDEV = {
          readContext: function(context) {
            return warnInvalidContextAccess(), readContext(context);
          },
          useCallback: function(callback, deps) {
            return currentHookNameInDev = "useCallback", warnInvalidHookAccess(), updateHookTypesDev(), updateCallback(callback, deps);
          },
          useContext: function(context) {
            return currentHookNameInDev = "useContext", warnInvalidHookAccess(), updateHookTypesDev(), readContext(context);
          },
          useEffect: function(create, deps) {
            return currentHookNameInDev = "useEffect", warnInvalidHookAccess(), updateHookTypesDev(), updateEffect(create, deps);
          },
          useImperativeHandle: function(ref, create, deps) {
            return currentHookNameInDev = "useImperativeHandle", warnInvalidHookAccess(), updateHookTypesDev(), updateImperativeHandle(ref, create, deps);
          },
          useInsertionEffect: function(create, deps) {
            return currentHookNameInDev = "useInsertionEffect", warnInvalidHookAccess(), updateHookTypesDev(), updateInsertionEffect(create, deps);
          },
          useLayoutEffect: function(create, deps) {
            return currentHookNameInDev = "useLayoutEffect", warnInvalidHookAccess(), updateHookTypesDev(), updateLayoutEffect(create, deps);
          },
          useMemo: function(create, deps) {
            currentHookNameInDev = "useMemo", warnInvalidHookAccess(), updateHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
            try {
              return updateMemo(create, deps);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useReducer: function(reducer, initialArg, init4) {
            currentHookNameInDev = "useReducer", warnInvalidHookAccess(), updateHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
            try {
              return rerenderReducer(reducer, initialArg, init4);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useRef: function(initialValue) {
            return currentHookNameInDev = "useRef", warnInvalidHookAccess(), updateHookTypesDev(), updateRef();
          },
          useState: function(initialState) {
            currentHookNameInDev = "useState", warnInvalidHookAccess(), updateHookTypesDev();
            var prevDispatcher = ReactCurrentDispatcher$1.current;
            ReactCurrentDispatcher$1.current = InvalidNestedHooksDispatcherOnUpdateInDEV;
            try {
              return rerenderState(initialState);
            } finally {
              ReactCurrentDispatcher$1.current = prevDispatcher;
            }
          },
          useDebugValue: function(value, formatterFn) {
            return currentHookNameInDev = "useDebugValue", warnInvalidHookAccess(), updateHookTypesDev(), updateDebugValue();
          },
          useDeferredValue: function(value) {
            return currentHookNameInDev = "useDeferredValue", warnInvalidHookAccess(), updateHookTypesDev(), rerenderDeferredValue(value);
          },
          useTransition: function() {
            return currentHookNameInDev = "useTransition", warnInvalidHookAccess(), updateHookTypesDev(), rerenderTransition();
          },
          useMutableSource: function(source, getSnapshot, subscribe) {
            return currentHookNameInDev = "useMutableSource", warnInvalidHookAccess(), updateHookTypesDev(), void 0;
          },
          useSyncExternalStore: function(subscribe, getSnapshot, getServerSnapshot) {
            return currentHookNameInDev = "useSyncExternalStore", warnInvalidHookAccess(), updateHookTypesDev(), updateSyncExternalStore(subscribe, getSnapshot);
          },
          useId: function() {
            return currentHookNameInDev = "useId", warnInvalidHookAccess(), updateHookTypesDev(), updateId();
          },
          unstable_isNewReconciler: enableNewReconciler
        };
      }
      var now$1 = Scheduler.unstable_now, commitTime = 0, layoutEffectStartTime = -1, profilerStartTime = -1, passiveEffectStartTime = -1, currentUpdateIsNested = !1, nestedUpdateScheduled = !1;
      function isCurrentUpdateNested() {
        return currentUpdateIsNested;
      }
      function markNestedUpdateScheduled() {
        nestedUpdateScheduled = !0;
      }
      function resetNestedUpdateFlag() {
        currentUpdateIsNested = !1, nestedUpdateScheduled = !1;
      }
      function syncNestedUpdateFlag() {
        currentUpdateIsNested = nestedUpdateScheduled, nestedUpdateScheduled = !1;
      }
      function getCommitTime() {
        return commitTime;
      }
      function recordCommitTime() {
        commitTime = now$1();
      }
      function startProfilerTimer(fiber) {
        profilerStartTime = now$1(), fiber.actualStartTime < 0 && (fiber.actualStartTime = now$1());
      }
      function stopProfilerTimerIfRunning(fiber) {
        profilerStartTime = -1;
      }
      function stopProfilerTimerIfRunningAndRecordDelta(fiber, overrideBaseTime) {
        if (profilerStartTime >= 0) {
          var elapsedTime = now$1() - profilerStartTime;
          fiber.actualDuration += elapsedTime, overrideBaseTime && (fiber.selfBaseDuration = elapsedTime), profilerStartTime = -1;
        }
      }
      function recordLayoutEffectDuration(fiber) {
        if (layoutEffectStartTime >= 0) {
          var elapsedTime = now$1() - layoutEffectStartTime;
          layoutEffectStartTime = -1;
          for (var parentFiber = fiber.return; parentFiber !== null; ) {
            switch (parentFiber.tag) {
              case HostRoot:
                var root2 = parentFiber.stateNode;
                root2.effectDuration += elapsedTime;
                return;
              case Profiler:
                var parentStateNode = parentFiber.stateNode;
                parentStateNode.effectDuration += elapsedTime;
                return;
            }
            parentFiber = parentFiber.return;
          }
        }
      }
      function recordPassiveEffectDuration(fiber) {
        if (passiveEffectStartTime >= 0) {
          var elapsedTime = now$1() - passiveEffectStartTime;
          passiveEffectStartTime = -1;
          for (var parentFiber = fiber.return; parentFiber !== null; ) {
            switch (parentFiber.tag) {
              case HostRoot:
                var root2 = parentFiber.stateNode;
                root2 !== null && (root2.passiveEffectDuration += elapsedTime);
                return;
              case Profiler:
                var parentStateNode = parentFiber.stateNode;
                parentStateNode !== null && (parentStateNode.passiveEffectDuration += elapsedTime);
                return;
            }
            parentFiber = parentFiber.return;
          }
        }
      }
      function startLayoutEffectTimer() {
        layoutEffectStartTime = now$1();
      }
      function startPassiveEffectTimer() {
        passiveEffectStartTime = now$1();
      }
      function transferActualDuration(fiber) {
        for (var child = fiber.child; child; )
          fiber.actualDuration += child.actualDuration, child = child.sibling;
      }
      function createCapturedValueAtFiber(value, source) {
        return {
          value,
          source,
          stack: getStackByFiberInDevAndProd(source),
          digest: null
        };
      }
      function createCapturedValue(value, digest, stack) {
        return {
          value,
          source: null,
          stack: stack ?? null,
          digest: digest ?? null
        };
      }
      function showErrorDialog(boundary, errorInfo) {
        return !0;
      }
      function logCapturedError(boundary, errorInfo) {
        try {
          var logError = showErrorDialog(boundary, errorInfo);
          if (logError === !1)
            return;
          var error2 = errorInfo.value, source = errorInfo.source, stack = errorInfo.stack, componentStack = stack !== null ? stack : "";
          if (error2 != null && error2._suppressLogging) {
            if (boundary.tag === ClassComponent)
              return;
            console.error(error2);
          }
          var componentName = source ? getComponentNameFromFiber(source) : null, componentNameMessage = componentName ? "The above error occurred in the <" + componentName + "> component:" : "The above error occurred in one of your React components:", errorBoundaryMessage;
          if (boundary.tag === HostRoot)
            errorBoundaryMessage = `Consider adding an error boundary to your tree to customize error handling behavior.
Visit https://reactjs.org/link/error-boundaries to learn more about error boundaries.`;
          else {
            var errorBoundaryName = getComponentNameFromFiber(boundary) || "Anonymous";
            errorBoundaryMessage = "React will try to recreate this component tree from scratch " + ("using the error boundary you provided, " + errorBoundaryName + ".");
          }
          var combinedMessage = componentNameMessage + `
` + componentStack + `

` + ("" + errorBoundaryMessage);
          console.error(combinedMessage);
        } catch (e) {
          setTimeout(function() {
            throw e;
          });
        }
      }
      var PossiblyWeakMap$1 = typeof WeakMap == "function" ? WeakMap : Map;
      function createRootErrorUpdate(fiber, errorInfo, lane) {
        var update2 = createUpdate(NoTimestamp, lane);
        update2.tag = CaptureUpdate, update2.payload = {
          element: null
        };
        var error2 = errorInfo.value;
        return update2.callback = function() {
          onUncaughtError(error2), logCapturedError(fiber, errorInfo);
        }, update2;
      }
      function createClassErrorUpdate(fiber, errorInfo, lane) {
        var update2 = createUpdate(NoTimestamp, lane);
        update2.tag = CaptureUpdate;
        var getDerivedStateFromError = fiber.type.getDerivedStateFromError;
        if (typeof getDerivedStateFromError == "function") {
          var error$1 = errorInfo.value;
          update2.payload = function() {
            return getDerivedStateFromError(error$1);
          }, update2.callback = function() {
            markFailedErrorBoundaryForHotReloading(fiber), logCapturedError(fiber, errorInfo);
          };
        }
        var inst = fiber.stateNode;
        return inst !== null && typeof inst.componentDidCatch == "function" && (update2.callback = function() {
          markFailedErrorBoundaryForHotReloading(fiber), logCapturedError(fiber, errorInfo), typeof getDerivedStateFromError != "function" && markLegacyErrorBoundaryAsFailed(this);
          var error$12 = errorInfo.value, stack = errorInfo.stack;
          this.componentDidCatch(error$12, {
            componentStack: stack !== null ? stack : ""
          }), typeof getDerivedStateFromError != "function" && (includesSomeLane(fiber.lanes, SyncLane) || error("%s: Error boundaries should implement getDerivedStateFromError(). In that method, return a state update to display an error message or fallback UI.", getComponentNameFromFiber(fiber) || "Unknown"));
        }), update2;
      }
      function attachPingListener(root2, wakeable, lanes) {
        var pingCache = root2.pingCache, threadIDs;
        if (pingCache === null ? (pingCache = root2.pingCache = new PossiblyWeakMap$1(), threadIDs = /* @__PURE__ */ new Set(), pingCache.set(wakeable, threadIDs)) : (threadIDs = pingCache.get(wakeable), threadIDs === void 0 && (threadIDs = /* @__PURE__ */ new Set(), pingCache.set(wakeable, threadIDs))), !threadIDs.has(lanes)) {
          threadIDs.add(lanes);
          var ping = pingSuspendedRoot.bind(null, root2, wakeable, lanes);
          isDevToolsPresent && restorePendingUpdaters(root2, lanes), wakeable.then(ping, ping);
        }
      }
      function attachRetryListener(suspenseBoundary, root2, wakeable, lanes) {
        var wakeables = suspenseBoundary.updateQueue;
        if (wakeables === null) {
          var updateQueue = /* @__PURE__ */ new Set();
          updateQueue.add(wakeable), suspenseBoundary.updateQueue = updateQueue;
        } else
          wakeables.add(wakeable);
      }
      function resetSuspendedComponent(sourceFiber, rootRenderLanes) {
        var tag = sourceFiber.tag;
        if ((sourceFiber.mode & ConcurrentMode) === NoMode && (tag === FunctionComponent || tag === ForwardRef || tag === SimpleMemoComponent)) {
          var currentSource = sourceFiber.alternate;
          currentSource ? (sourceFiber.updateQueue = currentSource.updateQueue, sourceFiber.memoizedState = currentSource.memoizedState, sourceFiber.lanes = currentSource.lanes) : (sourceFiber.updateQueue = null, sourceFiber.memoizedState = null);
        }
      }
      function getNearestSuspenseBoundaryToCapture(returnFiber) {
        var node = returnFiber;
        do {
          if (node.tag === SuspenseComponent && shouldCaptureSuspense(node))
            return node;
          node = node.return;
        } while (node !== null);
        return null;
      }
      function markSuspenseBoundaryShouldCapture(suspenseBoundary, returnFiber, sourceFiber, root2, rootRenderLanes) {
        if ((suspenseBoundary.mode & ConcurrentMode) === NoMode) {
          if (suspenseBoundary === returnFiber)
            suspenseBoundary.flags |= ShouldCapture;
          else {
            if (suspenseBoundary.flags |= DidCapture, sourceFiber.flags |= ForceUpdateForLegacySuspense, sourceFiber.flags &= ~(LifecycleEffectMask | Incomplete), sourceFiber.tag === ClassComponent) {
              var currentSourceFiber = sourceFiber.alternate;
              if (currentSourceFiber === null)
                sourceFiber.tag = IncompleteClassComponent;
              else {
                var update2 = createUpdate(NoTimestamp, SyncLane);
                update2.tag = ForceUpdate, enqueueUpdate(sourceFiber, update2, SyncLane);
              }
            }
            sourceFiber.lanes = mergeLanes(sourceFiber.lanes, SyncLane);
          }
          return suspenseBoundary;
        }
        return suspenseBoundary.flags |= ShouldCapture, suspenseBoundary.lanes = rootRenderLanes, suspenseBoundary;
      }
      function throwException(root2, returnFiber, sourceFiber, value, rootRenderLanes) {
        if (sourceFiber.flags |= Incomplete, isDevToolsPresent && restorePendingUpdaters(root2, rootRenderLanes), value !== null && typeof value == "object" && typeof value.then == "function") {
          var wakeable = value;
          resetSuspendedComponent(sourceFiber), getIsHydrating() && sourceFiber.mode & ConcurrentMode && markDidThrowWhileHydratingDEV();
          var suspenseBoundary = getNearestSuspenseBoundaryToCapture(returnFiber);
          if (suspenseBoundary !== null) {
            suspenseBoundary.flags &= ~ForceClientRender, markSuspenseBoundaryShouldCapture(suspenseBoundary, returnFiber, sourceFiber, root2, rootRenderLanes), suspenseBoundary.mode & ConcurrentMode && attachPingListener(root2, wakeable, rootRenderLanes), attachRetryListener(suspenseBoundary, root2, wakeable);
            return;
          } else {
            if (!includesSyncLane(rootRenderLanes)) {
              attachPingListener(root2, wakeable, rootRenderLanes), renderDidSuspendDelayIfPossible();
              return;
            }
            var uncaughtSuspenseError = new Error("A component suspended while responding to synchronous input. This will cause the UI to be replaced with a loading indicator. To fix, updates that suspend should be wrapped with startTransition.");
            value = uncaughtSuspenseError;
          }
        } else if (getIsHydrating() && sourceFiber.mode & ConcurrentMode) {
          markDidThrowWhileHydratingDEV();
          var _suspenseBoundary = getNearestSuspenseBoundaryToCapture(returnFiber);
          if (_suspenseBoundary !== null) {
            (_suspenseBoundary.flags & ShouldCapture) === NoFlags && (_suspenseBoundary.flags |= ForceClientRender), markSuspenseBoundaryShouldCapture(_suspenseBoundary, returnFiber, sourceFiber, root2, rootRenderLanes), queueHydrationError(createCapturedValueAtFiber(value, sourceFiber));
            return;
          }
        }
        value = createCapturedValueAtFiber(value, sourceFiber), renderDidError(value);
        var workInProgress2 = returnFiber;
        do {
          switch (workInProgress2.tag) {
            case HostRoot: {
              var _errorInfo = value;
              workInProgress2.flags |= ShouldCapture;
              var lane = pickArbitraryLane(rootRenderLanes);
              workInProgress2.lanes = mergeLanes(workInProgress2.lanes, lane);
              var update2 = createRootErrorUpdate(workInProgress2, _errorInfo, lane);
              enqueueCapturedUpdate(workInProgress2, update2);
              return;
            }
            case ClassComponent:
              var errorInfo = value, ctor = workInProgress2.type, instance = workInProgress2.stateNode;
              if ((workInProgress2.flags & DidCapture) === NoFlags && (typeof ctor.getDerivedStateFromError == "function" || instance !== null && typeof instance.componentDidCatch == "function" && !isAlreadyFailedLegacyErrorBoundary(instance))) {
                workInProgress2.flags |= ShouldCapture;
                var _lane = pickArbitraryLane(rootRenderLanes);
                workInProgress2.lanes = mergeLanes(workInProgress2.lanes, _lane);
                var _update = createClassErrorUpdate(workInProgress2, errorInfo, _lane);
                enqueueCapturedUpdate(workInProgress2, _update);
                return;
              }
              break;
          }
          workInProgress2 = workInProgress2.return;
        } while (workInProgress2 !== null);
      }
      function getSuspendedCache() {
        return null;
      }
      var ReactCurrentOwner$1 = ReactSharedInternals.ReactCurrentOwner, didReceiveUpdate = !1, didWarnAboutBadClass, didWarnAboutModulePatternComponent, didWarnAboutContextTypeOnFunctionComponent, didWarnAboutGetDerivedStateOnFunctionComponent, didWarnAboutFunctionRefs, didWarnAboutReassigningProps, didWarnAboutRevealOrder, didWarnAboutTailOptions;
      didWarnAboutBadClass = {}, didWarnAboutModulePatternComponent = {}, didWarnAboutContextTypeOnFunctionComponent = {}, didWarnAboutGetDerivedStateOnFunctionComponent = {}, didWarnAboutFunctionRefs = {}, didWarnAboutReassigningProps = !1, didWarnAboutRevealOrder = {}, didWarnAboutTailOptions = {};
      function reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2) {
        current2 === null ? workInProgress2.child = mountChildFibers(workInProgress2, null, nextChildren, renderLanes2) : workInProgress2.child = reconcileChildFibers(workInProgress2, current2.child, nextChildren, renderLanes2);
      }
      function forceUnmountCurrentAndReconcile(current2, workInProgress2, nextChildren, renderLanes2) {
        workInProgress2.child = reconcileChildFibers(workInProgress2, current2.child, null, renderLanes2), workInProgress2.child = reconcileChildFibers(workInProgress2, null, nextChildren, renderLanes2);
      }
      function updateForwardRef(current2, workInProgress2, Component, nextProps, renderLanes2) {
        if (workInProgress2.type !== workInProgress2.elementType) {
          var innerPropTypes = Component.propTypes;
          innerPropTypes && checkPropTypes(
            innerPropTypes,
            nextProps,
            // Resolved props
            "prop",
            getComponentNameFromType(Component)
          );
        }
        var render4 = Component.render, ref = workInProgress2.ref, nextChildren, hasId;
        prepareToReadContext(workInProgress2, renderLanes2), markComponentRenderStarted(workInProgress2);
        {
          if (ReactCurrentOwner$1.current = workInProgress2, setIsRendering(!0), nextChildren = renderWithHooks(current2, workInProgress2, render4, nextProps, ref, renderLanes2), hasId = checkDidRenderIdHook(), workInProgress2.mode & StrictLegacyMode) {
            setIsStrictModeForDevtools(!0);
            try {
              nextChildren = renderWithHooks(current2, workInProgress2, render4, nextProps, ref, renderLanes2), hasId = checkDidRenderIdHook();
            } finally {
              setIsStrictModeForDevtools(!1);
            }
          }
          setIsRendering(!1);
        }
        return markComponentRenderStopped(), current2 !== null && !didReceiveUpdate ? (bailoutHooks(current2, workInProgress2, renderLanes2), bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2)) : (getIsHydrating() && hasId && pushMaterializedTreeId(workInProgress2), workInProgress2.flags |= PerformedWork, reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2), workInProgress2.child);
      }
      function updateMemoComponent(current2, workInProgress2, Component, nextProps, renderLanes2) {
        if (current2 === null) {
          var type = Component.type;
          if (isSimpleFunctionComponent(type) && Component.compare === null && // SimpleMemoComponent codepath doesn't resolve outer props either.
          Component.defaultProps === void 0) {
            var resolvedType = type;
            return resolvedType = resolveFunctionForHotReloading(type), workInProgress2.tag = SimpleMemoComponent, workInProgress2.type = resolvedType, validateFunctionComponentInDev(workInProgress2, type), updateSimpleMemoComponent(current2, workInProgress2, resolvedType, nextProps, renderLanes2);
          }
          {
            var innerPropTypes = type.propTypes;
            innerPropTypes && checkPropTypes(
              innerPropTypes,
              nextProps,
              // Resolved props
              "prop",
              getComponentNameFromType(type)
            );
          }
          var child = createFiberFromTypeAndProps(Component.type, null, nextProps, workInProgress2, workInProgress2.mode, renderLanes2);
          return child.ref = workInProgress2.ref, child.return = workInProgress2, workInProgress2.child = child, child;
        }
        {
          var _type = Component.type, _innerPropTypes = _type.propTypes;
          _innerPropTypes && checkPropTypes(
            _innerPropTypes,
            nextProps,
            // Resolved props
            "prop",
            getComponentNameFromType(_type)
          );
        }
        var currentChild = current2.child, hasScheduledUpdateOrContext = checkScheduledUpdateOrContext(current2, renderLanes2);
        if (!hasScheduledUpdateOrContext) {
          var prevProps = currentChild.memoizedProps, compare2 = Component.compare;
          if (compare2 = compare2 !== null ? compare2 : shallowEqual, compare2(prevProps, nextProps) && current2.ref === workInProgress2.ref)
            return bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2);
        }
        workInProgress2.flags |= PerformedWork;
        var newChild = createWorkInProgress(currentChild, nextProps);
        return newChild.ref = workInProgress2.ref, newChild.return = workInProgress2, workInProgress2.child = newChild, newChild;
      }
      function updateSimpleMemoComponent(current2, workInProgress2, Component, nextProps, renderLanes2) {
        if (workInProgress2.type !== workInProgress2.elementType) {
          var outerMemoType = workInProgress2.elementType;
          if (outerMemoType.$$typeof === REACT_LAZY_TYPE) {
            var lazyComponent = outerMemoType, payload = lazyComponent._payload, init4 = lazyComponent._init;
            try {
              outerMemoType = init4(payload);
            } catch {
              outerMemoType = null;
            }
            var outerPropTypes = outerMemoType && outerMemoType.propTypes;
            outerPropTypes && checkPropTypes(
              outerPropTypes,
              nextProps,
              // Resolved (SimpleMemoComponent has no defaultProps)
              "prop",
              getComponentNameFromType(outerMemoType)
            );
          }
        }
        if (current2 !== null) {
          var prevProps = current2.memoizedProps;
          if (shallowEqual(prevProps, nextProps) && current2.ref === workInProgress2.ref && // Prevent bailout if the implementation changed due to hot reload.
          workInProgress2.type === current2.type)
            if (didReceiveUpdate = !1, workInProgress2.pendingProps = nextProps = prevProps, checkScheduledUpdateOrContext(current2, renderLanes2))
              (current2.flags & ForceUpdateForLegacySuspense) !== NoFlags && (didReceiveUpdate = !0);
            else
              return workInProgress2.lanes = current2.lanes, bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2);
        }
        return updateFunctionComponent(current2, workInProgress2, Component, nextProps, renderLanes2);
      }
      function updateOffscreenComponent(current2, workInProgress2, renderLanes2) {
        var nextProps = workInProgress2.pendingProps, nextChildren = nextProps.children, prevState = current2 !== null ? current2.memoizedState : null;
        if (nextProps.mode === "hidden" || enableLegacyHidden)
          if ((workInProgress2.mode & ConcurrentMode) === NoMode) {
            var nextState = {
              baseLanes: NoLanes,
              cachePool: null,
              transitions: null
            };
            workInProgress2.memoizedState = nextState, pushRenderLanes(workInProgress2, renderLanes2);
          } else if (includesSomeLane(renderLanes2, OffscreenLane)) {
            var _nextState2 = {
              baseLanes: NoLanes,
              cachePool: null,
              transitions: null
            };
            workInProgress2.memoizedState = _nextState2;
            var subtreeRenderLanes2 = prevState !== null ? prevState.baseLanes : renderLanes2;
            pushRenderLanes(workInProgress2, subtreeRenderLanes2);
          } else {
            var spawnedCachePool = null, nextBaseLanes;
            if (prevState !== null) {
              var prevBaseLanes = prevState.baseLanes;
              nextBaseLanes = mergeLanes(prevBaseLanes, renderLanes2);
            } else
              nextBaseLanes = renderLanes2;
            workInProgress2.lanes = workInProgress2.childLanes = OffscreenLane;
            var _nextState = {
              baseLanes: nextBaseLanes,
              cachePool: spawnedCachePool,
              transitions: null
            };
            return workInProgress2.memoizedState = _nextState, workInProgress2.updateQueue = null, pushRenderLanes(workInProgress2, nextBaseLanes), null;
          }
        else {
          var _subtreeRenderLanes;
          prevState !== null ? (_subtreeRenderLanes = mergeLanes(prevState.baseLanes, renderLanes2), workInProgress2.memoizedState = null) : _subtreeRenderLanes = renderLanes2, pushRenderLanes(workInProgress2, _subtreeRenderLanes);
        }
        return reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2), workInProgress2.child;
      }
      function updateFragment(current2, workInProgress2, renderLanes2) {
        var nextChildren = workInProgress2.pendingProps;
        return reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2), workInProgress2.child;
      }
      function updateMode(current2, workInProgress2, renderLanes2) {
        var nextChildren = workInProgress2.pendingProps.children;
        return reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2), workInProgress2.child;
      }
      function updateProfiler(current2, workInProgress2, renderLanes2) {
        {
          workInProgress2.flags |= Update;
          {
            var stateNode = workInProgress2.stateNode;
            stateNode.effectDuration = 0, stateNode.passiveEffectDuration = 0;
          }
        }
        var nextProps = workInProgress2.pendingProps, nextChildren = nextProps.children;
        return reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2), workInProgress2.child;
      }
      function markRef(current2, workInProgress2) {
        var ref = workInProgress2.ref;
        (current2 === null && ref !== null || current2 !== null && current2.ref !== ref) && (workInProgress2.flags |= Ref, workInProgress2.flags |= RefStatic);
      }
      function updateFunctionComponent(current2, workInProgress2, Component, nextProps, renderLanes2) {
        if (workInProgress2.type !== workInProgress2.elementType) {
          var innerPropTypes = Component.propTypes;
          innerPropTypes && checkPropTypes(
            innerPropTypes,
            nextProps,
            // Resolved props
            "prop",
            getComponentNameFromType(Component)
          );
        }
        var context;
        {
          var unmaskedContext = getUnmaskedContext(workInProgress2, Component, !0);
          context = getMaskedContext(workInProgress2, unmaskedContext);
        }
        var nextChildren, hasId;
        prepareToReadContext(workInProgress2, renderLanes2), markComponentRenderStarted(workInProgress2);
        {
          if (ReactCurrentOwner$1.current = workInProgress2, setIsRendering(!0), nextChildren = renderWithHooks(current2, workInProgress2, Component, nextProps, context, renderLanes2), hasId = checkDidRenderIdHook(), workInProgress2.mode & StrictLegacyMode) {
            setIsStrictModeForDevtools(!0);
            try {
              nextChildren = renderWithHooks(current2, workInProgress2, Component, nextProps, context, renderLanes2), hasId = checkDidRenderIdHook();
            } finally {
              setIsStrictModeForDevtools(!1);
            }
          }
          setIsRendering(!1);
        }
        return markComponentRenderStopped(), current2 !== null && !didReceiveUpdate ? (bailoutHooks(current2, workInProgress2, renderLanes2), bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2)) : (getIsHydrating() && hasId && pushMaterializedTreeId(workInProgress2), workInProgress2.flags |= PerformedWork, reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2), workInProgress2.child);
      }
      function updateClassComponent(current2, workInProgress2, Component, nextProps, renderLanes2) {
        {
          switch (shouldError(workInProgress2)) {
            case !1: {
              var _instance = workInProgress2.stateNode, ctor = workInProgress2.type, tempInstance = new ctor(workInProgress2.memoizedProps, _instance.context), state = tempInstance.state;
              _instance.updater.enqueueSetState(_instance, state, null);
              break;
            }
            case !0: {
              workInProgress2.flags |= DidCapture, workInProgress2.flags |= ShouldCapture;
              var error$1 = new Error("Simulated error coming from DevTools"), lane = pickArbitraryLane(renderLanes2);
              workInProgress2.lanes = mergeLanes(workInProgress2.lanes, lane);
              var update2 = createClassErrorUpdate(workInProgress2, createCapturedValueAtFiber(error$1, workInProgress2), lane);
              enqueueCapturedUpdate(workInProgress2, update2);
              break;
            }
          }
          if (workInProgress2.type !== workInProgress2.elementType) {
            var innerPropTypes = Component.propTypes;
            innerPropTypes && checkPropTypes(
              innerPropTypes,
              nextProps,
              // Resolved props
              "prop",
              getComponentNameFromType(Component)
            );
          }
        }
        var hasContext;
        isContextProvider(Component) ? (hasContext = !0, pushContextProvider(workInProgress2)) : hasContext = !1, prepareToReadContext(workInProgress2, renderLanes2);
        var instance = workInProgress2.stateNode, shouldUpdate;
        instance === null ? (resetSuspendedCurrentOnMountInLegacyMode(current2, workInProgress2), constructClassInstance(workInProgress2, Component, nextProps), mountClassInstance(workInProgress2, Component, nextProps, renderLanes2), shouldUpdate = !0) : current2 === null ? shouldUpdate = resumeMountClassInstance(workInProgress2, Component, nextProps, renderLanes2) : shouldUpdate = updateClassInstance(current2, workInProgress2, Component, nextProps, renderLanes2);
        var nextUnitOfWork = finishClassComponent(current2, workInProgress2, Component, shouldUpdate, hasContext, renderLanes2);
        {
          var inst = workInProgress2.stateNode;
          shouldUpdate && inst.props !== nextProps && (didWarnAboutReassigningProps || error("It looks like %s is reassigning its own `this.props` while rendering. This is not supported and can lead to confusing bugs.", getComponentNameFromFiber(workInProgress2) || "a component"), didWarnAboutReassigningProps = !0);
        }
        return nextUnitOfWork;
      }
      function finishClassComponent(current2, workInProgress2, Component, shouldUpdate, hasContext, renderLanes2) {
        markRef(current2, workInProgress2);
        var didCaptureError = (workInProgress2.flags & DidCapture) !== NoFlags;
        if (!shouldUpdate && !didCaptureError)
          return hasContext && invalidateContextProvider(workInProgress2, Component, !1), bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2);
        var instance = workInProgress2.stateNode;
        ReactCurrentOwner$1.current = workInProgress2;
        var nextChildren;
        if (didCaptureError && typeof Component.getDerivedStateFromError != "function")
          nextChildren = null, stopProfilerTimerIfRunning();
        else {
          markComponentRenderStarted(workInProgress2);
          {
            if (setIsRendering(!0), nextChildren = instance.render(), workInProgress2.mode & StrictLegacyMode) {
              setIsStrictModeForDevtools(!0);
              try {
                instance.render();
              } finally {
                setIsStrictModeForDevtools(!1);
              }
            }
            setIsRendering(!1);
          }
          markComponentRenderStopped();
        }
        return workInProgress2.flags |= PerformedWork, current2 !== null && didCaptureError ? forceUnmountCurrentAndReconcile(current2, workInProgress2, nextChildren, renderLanes2) : reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2), workInProgress2.memoizedState = instance.state, hasContext && invalidateContextProvider(workInProgress2, Component, !0), workInProgress2.child;
      }
      function pushHostRootContext(workInProgress2) {
        var root2 = workInProgress2.stateNode;
        root2.pendingContext ? pushTopLevelContextObject(workInProgress2, root2.pendingContext, root2.pendingContext !== root2.context) : root2.context && pushTopLevelContextObject(workInProgress2, root2.context, !1), pushHostContainer(workInProgress2, root2.containerInfo);
      }
      function updateHostRoot(current2, workInProgress2, renderLanes2) {
        if (pushHostRootContext(workInProgress2), current2 === null)
          throw new Error("Should have a current fiber. This is a bug in React.");
        var nextProps = workInProgress2.pendingProps, prevState = workInProgress2.memoizedState, prevChildren = prevState.element;
        cloneUpdateQueue(current2, workInProgress2), processUpdateQueue(workInProgress2, nextProps, null, renderLanes2);
        var nextState = workInProgress2.memoizedState, root2 = workInProgress2.stateNode, nextChildren = nextState.element;
        if (prevState.isDehydrated) {
          var overrideState = {
            element: nextChildren,
            isDehydrated: !1,
            cache: nextState.cache,
            pendingSuspenseBoundaries: nextState.pendingSuspenseBoundaries,
            transitions: nextState.transitions
          }, updateQueue = workInProgress2.updateQueue;
          if (updateQueue.baseState = overrideState, workInProgress2.memoizedState = overrideState, workInProgress2.flags & ForceClientRender) {
            var recoverableError = createCapturedValueAtFiber(new Error("There was an error while hydrating. Because the error happened outside of a Suspense boundary, the entire root will switch to client rendering."), workInProgress2);
            return mountHostRootWithoutHydrating(current2, workInProgress2, nextChildren, renderLanes2, recoverableError);
          } else if (nextChildren !== prevChildren) {
            var _recoverableError = createCapturedValueAtFiber(new Error("This root received an early update, before anything was able hydrate. Switched the entire root to client rendering."), workInProgress2);
            return mountHostRootWithoutHydrating(current2, workInProgress2, nextChildren, renderLanes2, _recoverableError);
          } else {
            enterHydrationState(workInProgress2);
            var child = mountChildFibers(workInProgress2, null, nextChildren, renderLanes2);
            workInProgress2.child = child;
            for (var node = child; node; )
              node.flags = node.flags & ~Placement | Hydrating, node = node.sibling;
          }
        } else {
          if (resetHydrationState(), nextChildren === prevChildren)
            return bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2);
          reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2);
        }
        return workInProgress2.child;
      }
      function mountHostRootWithoutHydrating(current2, workInProgress2, nextChildren, renderLanes2, recoverableError) {
        return resetHydrationState(), queueHydrationError(recoverableError), workInProgress2.flags |= ForceClientRender, reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2), workInProgress2.child;
      }
      function updateHostComponent(current2, workInProgress2, renderLanes2) {
        pushHostContext(workInProgress2), current2 === null && tryToClaimNextHydratableInstance(workInProgress2);
        var type = workInProgress2.type, nextProps = workInProgress2.pendingProps, prevProps = current2 !== null ? current2.memoizedProps : null, nextChildren = nextProps.children, isDirectTextChild = shouldSetTextContent(type, nextProps);
        return isDirectTextChild ? nextChildren = null : prevProps !== null && shouldSetTextContent(type, prevProps) && (workInProgress2.flags |= ContentReset), markRef(current2, workInProgress2), reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2), workInProgress2.child;
      }
      function updateHostText(current2, workInProgress2) {
        return current2 === null && tryToClaimNextHydratableInstance(workInProgress2), null;
      }
      function mountLazyComponent(_current, workInProgress2, elementType, renderLanes2) {
        resetSuspendedCurrentOnMountInLegacyMode(_current, workInProgress2);
        var props = workInProgress2.pendingProps, lazyComponent = elementType, payload = lazyComponent._payload, init4 = lazyComponent._init, Component = init4(payload);
        workInProgress2.type = Component;
        var resolvedTag = workInProgress2.tag = resolveLazyComponentTag(Component), resolvedProps = resolveDefaultProps(Component, props), child;
        switch (resolvedTag) {
          case FunctionComponent:
            return validateFunctionComponentInDev(workInProgress2, Component), workInProgress2.type = Component = resolveFunctionForHotReloading(Component), child = updateFunctionComponent(null, workInProgress2, Component, resolvedProps, renderLanes2), child;
          case ClassComponent:
            return workInProgress2.type = Component = resolveClassForHotReloading(Component), child = updateClassComponent(null, workInProgress2, Component, resolvedProps, renderLanes2), child;
          case ForwardRef:
            return workInProgress2.type = Component = resolveForwardRefForHotReloading(Component), child = updateForwardRef(null, workInProgress2, Component, resolvedProps, renderLanes2), child;
          case MemoComponent: {
            if (workInProgress2.type !== workInProgress2.elementType) {
              var outerPropTypes = Component.propTypes;
              outerPropTypes && checkPropTypes(
                outerPropTypes,
                resolvedProps,
                // Resolved for outer only
                "prop",
                getComponentNameFromType(Component)
              );
            }
            return child = updateMemoComponent(
              null,
              workInProgress2,
              Component,
              resolveDefaultProps(Component.type, resolvedProps),
              // The inner type can have defaults too
              renderLanes2
            ), child;
          }
        }
        var hint = "";
        throw Component !== null && typeof Component == "object" && Component.$$typeof === REACT_LAZY_TYPE && (hint = " Did you wrap a component in React.lazy() more than once?"), new Error("Element type is invalid. Received a promise that resolves to: " + Component + ". " + ("Lazy element type must resolve to a class or function." + hint));
      }
      function mountIncompleteClassComponent(_current, workInProgress2, Component, nextProps, renderLanes2) {
        resetSuspendedCurrentOnMountInLegacyMode(_current, workInProgress2), workInProgress2.tag = ClassComponent;
        var hasContext;
        return isContextProvider(Component) ? (hasContext = !0, pushContextProvider(workInProgress2)) : hasContext = !1, prepareToReadContext(workInProgress2, renderLanes2), constructClassInstance(workInProgress2, Component, nextProps), mountClassInstance(workInProgress2, Component, nextProps, renderLanes2), finishClassComponent(null, workInProgress2, Component, !0, hasContext, renderLanes2);
      }
      function mountIndeterminateComponent(_current, workInProgress2, Component, renderLanes2) {
        resetSuspendedCurrentOnMountInLegacyMode(_current, workInProgress2);
        var props = workInProgress2.pendingProps, context;
        {
          var unmaskedContext = getUnmaskedContext(workInProgress2, Component, !1);
          context = getMaskedContext(workInProgress2, unmaskedContext);
        }
        prepareToReadContext(workInProgress2, renderLanes2);
        var value, hasId;
        markComponentRenderStarted(workInProgress2);
        {
          if (Component.prototype && typeof Component.prototype.render == "function") {
            var componentName = getComponentNameFromType(Component) || "Unknown";
            didWarnAboutBadClass[componentName] || (error("The <%s /> component appears to have a render method, but doesn't extend React.Component. This is likely to cause errors. Change %s to extend React.Component instead.", componentName, componentName), didWarnAboutBadClass[componentName] = !0);
          }
          workInProgress2.mode & StrictLegacyMode && ReactStrictModeWarnings.recordLegacyContextWarning(workInProgress2, null), setIsRendering(!0), ReactCurrentOwner$1.current = workInProgress2, value = renderWithHooks(null, workInProgress2, Component, props, context, renderLanes2), hasId = checkDidRenderIdHook(), setIsRendering(!1);
        }
        if (markComponentRenderStopped(), workInProgress2.flags |= PerformedWork, typeof value == "object" && value !== null && typeof value.render == "function" && value.$$typeof === void 0) {
          var _componentName = getComponentNameFromType(Component) || "Unknown";
          didWarnAboutModulePatternComponent[_componentName] || (error("The <%s /> component appears to be a function component that returns a class instance. Change %s to a class that extends React.Component instead. If you can't use a class try assigning the prototype on the function as a workaround. `%s.prototype = React.Component.prototype`. Don't use an arrow function since it cannot be called with `new` by React.", _componentName, _componentName, _componentName), didWarnAboutModulePatternComponent[_componentName] = !0);
        }
        if (
          // Run these checks in production only if the flag is off.
          // Eventually we'll delete this branch altogether.
          typeof value == "object" && value !== null && typeof value.render == "function" && value.$$typeof === void 0
        ) {
          {
            var _componentName2 = getComponentNameFromType(Component) || "Unknown";
            didWarnAboutModulePatternComponent[_componentName2] || (error("The <%s /> component appears to be a function component that returns a class instance. Change %s to a class that extends React.Component instead. If you can't use a class try assigning the prototype on the function as a workaround. `%s.prototype = React.Component.prototype`. Don't use an arrow function since it cannot be called with `new` by React.", _componentName2, _componentName2, _componentName2), didWarnAboutModulePatternComponent[_componentName2] = !0);
          }
          workInProgress2.tag = ClassComponent, workInProgress2.memoizedState = null, workInProgress2.updateQueue = null;
          var hasContext = !1;
          return isContextProvider(Component) ? (hasContext = !0, pushContextProvider(workInProgress2)) : hasContext = !1, workInProgress2.memoizedState = value.state !== null && value.state !== void 0 ? value.state : null, initializeUpdateQueue(workInProgress2), adoptClassInstance(workInProgress2, value), mountClassInstance(workInProgress2, Component, props, renderLanes2), finishClassComponent(null, workInProgress2, Component, !0, hasContext, renderLanes2);
        } else {
          if (workInProgress2.tag = FunctionComponent, workInProgress2.mode & StrictLegacyMode) {
            setIsStrictModeForDevtools(!0);
            try {
              value = renderWithHooks(null, workInProgress2, Component, props, context, renderLanes2), hasId = checkDidRenderIdHook();
            } finally {
              setIsStrictModeForDevtools(!1);
            }
          }
          return getIsHydrating() && hasId && pushMaterializedTreeId(workInProgress2), reconcileChildren(null, workInProgress2, value, renderLanes2), validateFunctionComponentInDev(workInProgress2, Component), workInProgress2.child;
        }
      }
      function validateFunctionComponentInDev(workInProgress2, Component) {
        {
          if (Component && Component.childContextTypes && error("%s(...): childContextTypes cannot be defined on a function component.", Component.displayName || Component.name || "Component"), workInProgress2.ref !== null) {
            var info2 = "", ownerName = getCurrentFiberOwnerNameInDevOrNull();
            ownerName && (info2 += `

Check the render method of \`` + ownerName + "`.");
            var warningKey = ownerName || "", debugSource = workInProgress2._debugSource;
            debugSource && (warningKey = debugSource.fileName + ":" + debugSource.lineNumber), didWarnAboutFunctionRefs[warningKey] || (didWarnAboutFunctionRefs[warningKey] = !0, error("Function components cannot be given refs. Attempts to access this ref will fail. Did you mean to use React.forwardRef()?%s", info2));
          }
          if (typeof Component.getDerivedStateFromProps == "function") {
            var _componentName3 = getComponentNameFromType(Component) || "Unknown";
            didWarnAboutGetDerivedStateOnFunctionComponent[_componentName3] || (error("%s: Function components do not support getDerivedStateFromProps.", _componentName3), didWarnAboutGetDerivedStateOnFunctionComponent[_componentName3] = !0);
          }
          if (typeof Component.contextType == "object" && Component.contextType !== null) {
            var _componentName4 = getComponentNameFromType(Component) || "Unknown";
            didWarnAboutContextTypeOnFunctionComponent[_componentName4] || (error("%s: Function components do not support contextType.", _componentName4), didWarnAboutContextTypeOnFunctionComponent[_componentName4] = !0);
          }
        }
      }
      var SUSPENDED_MARKER = {
        dehydrated: null,
        treeContext: null,
        retryLane: NoLane
      };
      function mountSuspenseOffscreenState(renderLanes2) {
        return {
          baseLanes: renderLanes2,
          cachePool: getSuspendedCache(),
          transitions: null
        };
      }
      function updateSuspenseOffscreenState(prevOffscreenState, renderLanes2) {
        var cachePool = null;
        return {
          baseLanes: mergeLanes(prevOffscreenState.baseLanes, renderLanes2),
          cachePool,
          transitions: prevOffscreenState.transitions
        };
      }
      function shouldRemainOnFallback(suspenseContext, current2, workInProgress2, renderLanes2) {
        if (current2 !== null) {
          var suspenseState = current2.memoizedState;
          if (suspenseState === null)
            return !1;
        }
        return hasSuspenseContext(suspenseContext, ForceSuspenseFallback);
      }
      function getRemainingWorkInPrimaryTree(current2, renderLanes2) {
        return removeLanes(current2.childLanes, renderLanes2);
      }
      function updateSuspenseComponent(current2, workInProgress2, renderLanes2) {
        var nextProps = workInProgress2.pendingProps;
        shouldSuspend(workInProgress2) && (workInProgress2.flags |= DidCapture);
        var suspenseContext = suspenseStackCursor.current, showFallback = !1, didSuspend = (workInProgress2.flags & DidCapture) !== NoFlags;
        if (didSuspend || shouldRemainOnFallback(suspenseContext, current2) ? (showFallback = !0, workInProgress2.flags &= ~DidCapture) : (current2 === null || current2.memoizedState !== null) && (suspenseContext = addSubtreeSuspenseContext(suspenseContext, InvisibleParentSuspenseContext)), suspenseContext = setDefaultShallowSuspenseContext(suspenseContext), pushSuspenseContext(workInProgress2, suspenseContext), current2 === null) {
          tryToClaimNextHydratableInstance(workInProgress2);
          var suspenseState = workInProgress2.memoizedState;
          if (suspenseState !== null) {
            var dehydrated = suspenseState.dehydrated;
            if (dehydrated !== null)
              return mountDehydratedSuspenseComponent(workInProgress2, dehydrated);
          }
          var nextPrimaryChildren = nextProps.children, nextFallbackChildren = nextProps.fallback;
          if (showFallback) {
            var fallbackFragment = mountSuspenseFallbackChildren(workInProgress2, nextPrimaryChildren, nextFallbackChildren, renderLanes2), primaryChildFragment = workInProgress2.child;
            return primaryChildFragment.memoizedState = mountSuspenseOffscreenState(renderLanes2), workInProgress2.memoizedState = SUSPENDED_MARKER, fallbackFragment;
          } else
            return mountSuspensePrimaryChildren(workInProgress2, nextPrimaryChildren);
        } else {
          var prevState = current2.memoizedState;
          if (prevState !== null) {
            var _dehydrated = prevState.dehydrated;
            if (_dehydrated !== null)
              return updateDehydratedSuspenseComponent(current2, workInProgress2, didSuspend, nextProps, _dehydrated, prevState, renderLanes2);
          }
          if (showFallback) {
            var _nextFallbackChildren = nextProps.fallback, _nextPrimaryChildren = nextProps.children, fallbackChildFragment = updateSuspenseFallbackChildren(current2, workInProgress2, _nextPrimaryChildren, _nextFallbackChildren, renderLanes2), _primaryChildFragment2 = workInProgress2.child, prevOffscreenState = current2.child.memoizedState;
            return _primaryChildFragment2.memoizedState = prevOffscreenState === null ? mountSuspenseOffscreenState(renderLanes2) : updateSuspenseOffscreenState(prevOffscreenState, renderLanes2), _primaryChildFragment2.childLanes = getRemainingWorkInPrimaryTree(current2, renderLanes2), workInProgress2.memoizedState = SUSPENDED_MARKER, fallbackChildFragment;
          } else {
            var _nextPrimaryChildren2 = nextProps.children, _primaryChildFragment3 = updateSuspensePrimaryChildren(current2, workInProgress2, _nextPrimaryChildren2, renderLanes2);
            return workInProgress2.memoizedState = null, _primaryChildFragment3;
          }
        }
      }
      function mountSuspensePrimaryChildren(workInProgress2, primaryChildren, renderLanes2) {
        var mode = workInProgress2.mode, primaryChildProps = {
          mode: "visible",
          children: primaryChildren
        }, primaryChildFragment = mountWorkInProgressOffscreenFiber(primaryChildProps, mode);
        return primaryChildFragment.return = workInProgress2, workInProgress2.child = primaryChildFragment, primaryChildFragment;
      }
      function mountSuspenseFallbackChildren(workInProgress2, primaryChildren, fallbackChildren, renderLanes2) {
        var mode = workInProgress2.mode, progressedPrimaryFragment = workInProgress2.child, primaryChildProps = {
          mode: "hidden",
          children: primaryChildren
        }, primaryChildFragment, fallbackChildFragment;
        return (mode & ConcurrentMode) === NoMode && progressedPrimaryFragment !== null ? (primaryChildFragment = progressedPrimaryFragment, primaryChildFragment.childLanes = NoLanes, primaryChildFragment.pendingProps = primaryChildProps, workInProgress2.mode & ProfileMode && (primaryChildFragment.actualDuration = 0, primaryChildFragment.actualStartTime = -1, primaryChildFragment.selfBaseDuration = 0, primaryChildFragment.treeBaseDuration = 0), fallbackChildFragment = createFiberFromFragment(fallbackChildren, mode, renderLanes2, null)) : (primaryChildFragment = mountWorkInProgressOffscreenFiber(primaryChildProps, mode), fallbackChildFragment = createFiberFromFragment(fallbackChildren, mode, renderLanes2, null)), primaryChildFragment.return = workInProgress2, fallbackChildFragment.return = workInProgress2, primaryChildFragment.sibling = fallbackChildFragment, workInProgress2.child = primaryChildFragment, fallbackChildFragment;
      }
      function mountWorkInProgressOffscreenFiber(offscreenProps, mode, renderLanes2) {
        return createFiberFromOffscreen(offscreenProps, mode, NoLanes, null);
      }
      function updateWorkInProgressOffscreenFiber(current2, offscreenProps) {
        return createWorkInProgress(current2, offscreenProps);
      }
      function updateSuspensePrimaryChildren(current2, workInProgress2, primaryChildren, renderLanes2) {
        var currentPrimaryChildFragment = current2.child, currentFallbackChildFragment = currentPrimaryChildFragment.sibling, primaryChildFragment = updateWorkInProgressOffscreenFiber(currentPrimaryChildFragment, {
          mode: "visible",
          children: primaryChildren
        });
        if ((workInProgress2.mode & ConcurrentMode) === NoMode && (primaryChildFragment.lanes = renderLanes2), primaryChildFragment.return = workInProgress2, primaryChildFragment.sibling = null, currentFallbackChildFragment !== null) {
          var deletions = workInProgress2.deletions;
          deletions === null ? (workInProgress2.deletions = [currentFallbackChildFragment], workInProgress2.flags |= ChildDeletion) : deletions.push(currentFallbackChildFragment);
        }
        return workInProgress2.child = primaryChildFragment, primaryChildFragment;
      }
      function updateSuspenseFallbackChildren(current2, workInProgress2, primaryChildren, fallbackChildren, renderLanes2) {
        var mode = workInProgress2.mode, currentPrimaryChildFragment = current2.child, currentFallbackChildFragment = currentPrimaryChildFragment.sibling, primaryChildProps = {
          mode: "hidden",
          children: primaryChildren
        }, primaryChildFragment;
        if (
          // In legacy mode, we commit the primary tree as if it successfully
          // completed, even though it's in an inconsistent state.
          (mode & ConcurrentMode) === NoMode && // Make sure we're on the second pass, i.e. the primary child fragment was
          // already cloned. In legacy mode, the only case where this isn't true is
          // when DevTools forces us to display a fallback; we skip the first render
          // pass entirely and go straight to rendering the fallback. (In Concurrent
          // Mode, SuspenseList can also trigger this scenario, but this is a legacy-
          // only codepath.)
          workInProgress2.child !== currentPrimaryChildFragment
        ) {
          var progressedPrimaryFragment = workInProgress2.child;
          primaryChildFragment = progressedPrimaryFragment, primaryChildFragment.childLanes = NoLanes, primaryChildFragment.pendingProps = primaryChildProps, workInProgress2.mode & ProfileMode && (primaryChildFragment.actualDuration = 0, primaryChildFragment.actualStartTime = -1, primaryChildFragment.selfBaseDuration = currentPrimaryChildFragment.selfBaseDuration, primaryChildFragment.treeBaseDuration = currentPrimaryChildFragment.treeBaseDuration), workInProgress2.deletions = null;
        } else
          primaryChildFragment = updateWorkInProgressOffscreenFiber(currentPrimaryChildFragment, primaryChildProps), primaryChildFragment.subtreeFlags = currentPrimaryChildFragment.subtreeFlags & StaticMask;
        var fallbackChildFragment;
        return currentFallbackChildFragment !== null ? fallbackChildFragment = createWorkInProgress(currentFallbackChildFragment, fallbackChildren) : (fallbackChildFragment = createFiberFromFragment(fallbackChildren, mode, renderLanes2, null), fallbackChildFragment.flags |= Placement), fallbackChildFragment.return = workInProgress2, primaryChildFragment.return = workInProgress2, primaryChildFragment.sibling = fallbackChildFragment, workInProgress2.child = primaryChildFragment, fallbackChildFragment;
      }
      function retrySuspenseComponentWithoutHydrating(current2, workInProgress2, renderLanes2, recoverableError) {
        recoverableError !== null && queueHydrationError(recoverableError), reconcileChildFibers(workInProgress2, current2.child, null, renderLanes2);
        var nextProps = workInProgress2.pendingProps, primaryChildren = nextProps.children, primaryChildFragment = mountSuspensePrimaryChildren(workInProgress2, primaryChildren);
        return primaryChildFragment.flags |= Placement, workInProgress2.memoizedState = null, primaryChildFragment;
      }
      function mountSuspenseFallbackAfterRetryWithoutHydrating(current2, workInProgress2, primaryChildren, fallbackChildren, renderLanes2) {
        var fiberMode = workInProgress2.mode, primaryChildProps = {
          mode: "visible",
          children: primaryChildren
        }, primaryChildFragment = mountWorkInProgressOffscreenFiber(primaryChildProps, fiberMode), fallbackChildFragment = createFiberFromFragment(fallbackChildren, fiberMode, renderLanes2, null);
        return fallbackChildFragment.flags |= Placement, primaryChildFragment.return = workInProgress2, fallbackChildFragment.return = workInProgress2, primaryChildFragment.sibling = fallbackChildFragment, workInProgress2.child = primaryChildFragment, (workInProgress2.mode & ConcurrentMode) !== NoMode && reconcileChildFibers(workInProgress2, current2.child, null, renderLanes2), fallbackChildFragment;
      }
      function mountDehydratedSuspenseComponent(workInProgress2, suspenseInstance, renderLanes2) {
        return (workInProgress2.mode & ConcurrentMode) === NoMode ? (error("Cannot hydrate Suspense in legacy mode. Switch from ReactDOM.hydrate(element, container) to ReactDOMClient.hydrateRoot(container, <App />).render(element) or remove the Suspense components from the server rendered components."), workInProgress2.lanes = SyncLane) : isSuspenseInstanceFallback(suspenseInstance) ? workInProgress2.lanes = DefaultHydrationLane : workInProgress2.lanes = OffscreenLane, null;
      }
      function updateDehydratedSuspenseComponent(current2, workInProgress2, didSuspend, nextProps, suspenseInstance, suspenseState, renderLanes2) {
        if (didSuspend)
          if (workInProgress2.flags & ForceClientRender) {
            workInProgress2.flags &= ~ForceClientRender;
            var _capturedValue2 = createCapturedValue(new Error("There was an error while hydrating this Suspense boundary. Switched to client rendering."));
            return retrySuspenseComponentWithoutHydrating(current2, workInProgress2, renderLanes2, _capturedValue2);
          } else {
            if (workInProgress2.memoizedState !== null)
              return workInProgress2.child = current2.child, workInProgress2.flags |= DidCapture, null;
            var nextPrimaryChildren = nextProps.children, nextFallbackChildren = nextProps.fallback, fallbackChildFragment = mountSuspenseFallbackAfterRetryWithoutHydrating(current2, workInProgress2, nextPrimaryChildren, nextFallbackChildren, renderLanes2), _primaryChildFragment4 = workInProgress2.child;
            return _primaryChildFragment4.memoizedState = mountSuspenseOffscreenState(renderLanes2), workInProgress2.memoizedState = SUSPENDED_MARKER, fallbackChildFragment;
          }
        else {
          if (warnIfHydrating(), (workInProgress2.mode & ConcurrentMode) === NoMode)
            return retrySuspenseComponentWithoutHydrating(
              current2,
              workInProgress2,
              renderLanes2,
              // TODO: When we delete legacy mode, we should make this error argument
              // required — every concurrent mode path that causes hydration to
              // de-opt to client rendering should have an error message.
              null
            );
          if (isSuspenseInstanceFallback(suspenseInstance)) {
            var digest, message, stack;
            {
              var _getSuspenseInstanceF = getSuspenseInstanceFallbackErrorDetails(suspenseInstance);
              digest = _getSuspenseInstanceF.digest, message = _getSuspenseInstanceF.message, stack = _getSuspenseInstanceF.stack;
            }
            var error2;
            message ? error2 = new Error(message) : error2 = new Error("The server could not finish this Suspense boundary, likely due to an error during server rendering. Switched to client rendering.");
            var capturedValue = createCapturedValue(error2, digest, stack);
            return retrySuspenseComponentWithoutHydrating(current2, workInProgress2, renderLanes2, capturedValue);
          }
          var hasContextChanged2 = includesSomeLane(renderLanes2, current2.childLanes);
          if (didReceiveUpdate || hasContextChanged2) {
            var root2 = getWorkInProgressRoot();
            if (root2 !== null) {
              var attemptHydrationAtLane = getBumpedLaneForHydration(root2, renderLanes2);
              if (attemptHydrationAtLane !== NoLane && attemptHydrationAtLane !== suspenseState.retryLane) {
                suspenseState.retryLane = attemptHydrationAtLane;
                var eventTime = NoTimestamp;
                enqueueConcurrentRenderForLane(current2, attemptHydrationAtLane), scheduleUpdateOnFiber(root2, current2, attemptHydrationAtLane, eventTime);
              }
            }
            renderDidSuspendDelayIfPossible();
            var _capturedValue = createCapturedValue(new Error("This Suspense boundary received an update before it finished hydrating. This caused the boundary to switch to client rendering. The usual way to fix this is to wrap the original update in startTransition."));
            return retrySuspenseComponentWithoutHydrating(current2, workInProgress2, renderLanes2, _capturedValue);
          } else if (isSuspenseInstancePending(suspenseInstance)) {
            workInProgress2.flags |= DidCapture, workInProgress2.child = current2.child;
            var retry = retryDehydratedSuspenseBoundary.bind(null, current2);
            return registerSuspenseInstanceRetry(suspenseInstance, retry), null;
          } else {
            reenterHydrationStateFromDehydratedSuspenseInstance(workInProgress2, suspenseInstance, suspenseState.treeContext);
            var primaryChildren = nextProps.children, primaryChildFragment = mountSuspensePrimaryChildren(workInProgress2, primaryChildren);
            return primaryChildFragment.flags |= Hydrating, primaryChildFragment;
          }
        }
      }
      function scheduleSuspenseWorkOnFiber(fiber, renderLanes2, propagationRoot) {
        fiber.lanes = mergeLanes(fiber.lanes, renderLanes2);
        var alternate = fiber.alternate;
        alternate !== null && (alternate.lanes = mergeLanes(alternate.lanes, renderLanes2)), scheduleContextWorkOnParentPath(fiber.return, renderLanes2, propagationRoot);
      }
      function propagateSuspenseContextChange(workInProgress2, firstChild, renderLanes2) {
        for (var node = firstChild; node !== null; ) {
          if (node.tag === SuspenseComponent) {
            var state = node.memoizedState;
            state !== null && scheduleSuspenseWorkOnFiber(node, renderLanes2, workInProgress2);
          } else if (node.tag === SuspenseListComponent)
            scheduleSuspenseWorkOnFiber(node, renderLanes2, workInProgress2);
          else if (node.child !== null) {
            node.child.return = node, node = node.child;
            continue;
          }
          if (node === workInProgress2)
            return;
          for (; node.sibling === null; ) {
            if (node.return === null || node.return === workInProgress2)
              return;
            node = node.return;
          }
          node.sibling.return = node.return, node = node.sibling;
        }
      }
      function findLastContentRow(firstChild) {
        for (var row = firstChild, lastContentRow = null; row !== null; ) {
          var currentRow = row.alternate;
          currentRow !== null && findFirstSuspended(currentRow) === null && (lastContentRow = row), row = row.sibling;
        }
        return lastContentRow;
      }
      function validateRevealOrder(revealOrder) {
        if (revealOrder !== void 0 && revealOrder !== "forwards" && revealOrder !== "backwards" && revealOrder !== "together" && !didWarnAboutRevealOrder[revealOrder])
          if (didWarnAboutRevealOrder[revealOrder] = !0, typeof revealOrder == "string")
            switch (revealOrder.toLowerCase()) {
              case "together":
              case "forwards":
              case "backwards": {
                error('"%s" is not a valid value for revealOrder on <SuspenseList />. Use lowercase "%s" instead.', revealOrder, revealOrder.toLowerCase());
                break;
              }
              case "forward":
              case "backward": {
                error('"%s" is not a valid value for revealOrder on <SuspenseList />. React uses the -s suffix in the spelling. Use "%ss" instead.', revealOrder, revealOrder.toLowerCase());
                break;
              }
              default:
                error('"%s" is not a supported revealOrder on <SuspenseList />. Did you mean "together", "forwards" or "backwards"?', revealOrder);
                break;
            }
          else
            error('%s is not a supported value for revealOrder on <SuspenseList />. Did you mean "together", "forwards" or "backwards"?', revealOrder);
      }
      function validateTailOptions(tailMode, revealOrder) {
        tailMode !== void 0 && !didWarnAboutTailOptions[tailMode] && (tailMode !== "collapsed" && tailMode !== "hidden" ? (didWarnAboutTailOptions[tailMode] = !0, error('"%s" is not a supported value for tail on <SuspenseList />. Did you mean "collapsed" or "hidden"?', tailMode)) : revealOrder !== "forwards" && revealOrder !== "backwards" && (didWarnAboutTailOptions[tailMode] = !0, error('<SuspenseList tail="%s" /> is only valid if revealOrder is "forwards" or "backwards". Did you mean to specify revealOrder="forwards"?', tailMode)));
      }
      function validateSuspenseListNestedChild(childSlot, index2) {
        {
          var isAnArray = isArray(childSlot), isIterable = !isAnArray && typeof getIteratorFn(childSlot) == "function";
          if (isAnArray || isIterable) {
            var type = isAnArray ? "array" : "iterable";
            return error("A nested %s was passed to row #%s in <SuspenseList />. Wrap it in an additional SuspenseList to configure its revealOrder: <SuspenseList revealOrder=...> ... <SuspenseList revealOrder=...>{%s}</SuspenseList> ... </SuspenseList>", type, index2, type), !1;
          }
        }
        return !0;
      }
      function validateSuspenseListChildren(children, revealOrder) {
        if ((revealOrder === "forwards" || revealOrder === "backwards") && children !== void 0 && children !== null && children !== !1)
          if (isArray(children)) {
            for (var i = 0; i < children.length; i++)
              if (!validateSuspenseListNestedChild(children[i], i))
                return;
          } else {
            var iteratorFn = getIteratorFn(children);
            if (typeof iteratorFn == "function") {
              var childrenIterator = iteratorFn.call(children);
              if (childrenIterator)
                for (var step = childrenIterator.next(), _i = 0; !step.done; step = childrenIterator.next()) {
                  if (!validateSuspenseListNestedChild(step.value, _i))
                    return;
                  _i++;
                }
            } else
              error('A single row was passed to a <SuspenseList revealOrder="%s" />. This is not useful since it needs multiple rows. Did you mean to pass multiple children or an array?', revealOrder);
          }
      }
      function initSuspenseListRenderState(workInProgress2, isBackwards, tail, lastContentRow, tailMode) {
        var renderState = workInProgress2.memoizedState;
        renderState === null ? workInProgress2.memoizedState = {
          isBackwards,
          rendering: null,
          renderingStartTime: 0,
          last: lastContentRow,
          tail,
          tailMode
        } : (renderState.isBackwards = isBackwards, renderState.rendering = null, renderState.renderingStartTime = 0, renderState.last = lastContentRow, renderState.tail = tail, renderState.tailMode = tailMode);
      }
      function updateSuspenseListComponent(current2, workInProgress2, renderLanes2) {
        var nextProps = workInProgress2.pendingProps, revealOrder = nextProps.revealOrder, tailMode = nextProps.tail, newChildren = nextProps.children;
        validateRevealOrder(revealOrder), validateTailOptions(tailMode, revealOrder), validateSuspenseListChildren(newChildren, revealOrder), reconcileChildren(current2, workInProgress2, newChildren, renderLanes2);
        var suspenseContext = suspenseStackCursor.current, shouldForceFallback = hasSuspenseContext(suspenseContext, ForceSuspenseFallback);
        if (shouldForceFallback)
          suspenseContext = setShallowSuspenseContext(suspenseContext, ForceSuspenseFallback), workInProgress2.flags |= DidCapture;
        else {
          var didSuspendBefore = current2 !== null && (current2.flags & DidCapture) !== NoFlags;
          didSuspendBefore && propagateSuspenseContextChange(workInProgress2, workInProgress2.child, renderLanes2), suspenseContext = setDefaultShallowSuspenseContext(suspenseContext);
        }
        if (pushSuspenseContext(workInProgress2, suspenseContext), (workInProgress2.mode & ConcurrentMode) === NoMode)
          workInProgress2.memoizedState = null;
        else
          switch (revealOrder) {
            case "forwards": {
              var lastContentRow = findLastContentRow(workInProgress2.child), tail;
              lastContentRow === null ? (tail = workInProgress2.child, workInProgress2.child = null) : (tail = lastContentRow.sibling, lastContentRow.sibling = null), initSuspenseListRenderState(
                workInProgress2,
                !1,
                // isBackwards
                tail,
                lastContentRow,
                tailMode
              );
              break;
            }
            case "backwards": {
              var _tail = null, row = workInProgress2.child;
              for (workInProgress2.child = null; row !== null; ) {
                var currentRow = row.alternate;
                if (currentRow !== null && findFirstSuspended(currentRow) === null) {
                  workInProgress2.child = row;
                  break;
                }
                var nextRow = row.sibling;
                row.sibling = _tail, _tail = row, row = nextRow;
              }
              initSuspenseListRenderState(
                workInProgress2,
                !0,
                // isBackwards
                _tail,
                null,
                // last
                tailMode
              );
              break;
            }
            case "together": {
              initSuspenseListRenderState(
                workInProgress2,
                !1,
                // isBackwards
                null,
                // tail
                null,
                // last
                void 0
              );
              break;
            }
            default:
              workInProgress2.memoizedState = null;
          }
        return workInProgress2.child;
      }
      function updatePortalComponent(current2, workInProgress2, renderLanes2) {
        pushHostContainer(workInProgress2, workInProgress2.stateNode.containerInfo);
        var nextChildren = workInProgress2.pendingProps;
        return current2 === null ? workInProgress2.child = reconcileChildFibers(workInProgress2, null, nextChildren, renderLanes2) : reconcileChildren(current2, workInProgress2, nextChildren, renderLanes2), workInProgress2.child;
      }
      var hasWarnedAboutUsingNoValuePropOnContextProvider = !1;
      function updateContextProvider(current2, workInProgress2, renderLanes2) {
        var providerType = workInProgress2.type, context = providerType._context, newProps = workInProgress2.pendingProps, oldProps = workInProgress2.memoizedProps, newValue = newProps.value;
        {
          "value" in newProps || hasWarnedAboutUsingNoValuePropOnContextProvider || (hasWarnedAboutUsingNoValuePropOnContextProvider = !0, error("The `value` prop is required for the `<Context.Provider>`. Did you misspell it or forget to pass it?"));
          var providerPropTypes = workInProgress2.type.propTypes;
          providerPropTypes && checkPropTypes(providerPropTypes, newProps, "prop", "Context.Provider");
        }
        if (pushProvider(workInProgress2, context, newValue), oldProps !== null) {
          var oldValue = oldProps.value;
          if (objectIs(oldValue, newValue)) {
            if (oldProps.children === newProps.children && !hasContextChanged())
              return bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2);
          } else
            propagateContextChange(workInProgress2, context, renderLanes2);
        }
        var newChildren = newProps.children;
        return reconcileChildren(current2, workInProgress2, newChildren, renderLanes2), workInProgress2.child;
      }
      var hasWarnedAboutUsingContextAsConsumer = !1;
      function updateContextConsumer(current2, workInProgress2, renderLanes2) {
        var context = workInProgress2.type;
        context._context === void 0 ? context !== context.Consumer && (hasWarnedAboutUsingContextAsConsumer || (hasWarnedAboutUsingContextAsConsumer = !0, error("Rendering <Context> directly is not supported and will be removed in a future major release. Did you mean to render <Context.Consumer> instead?"))) : context = context._context;
        var newProps = workInProgress2.pendingProps, render4 = newProps.children;
        typeof render4 != "function" && error("A context consumer was rendered with multiple children, or a child that isn't a function. A context consumer expects a single child that is a function. If you did pass a function, make sure there is no trailing or leading whitespace around it."), prepareToReadContext(workInProgress2, renderLanes2);
        var newValue = readContext(context);
        markComponentRenderStarted(workInProgress2);
        var newChildren;
        return ReactCurrentOwner$1.current = workInProgress2, setIsRendering(!0), newChildren = render4(newValue), setIsRendering(!1), markComponentRenderStopped(), workInProgress2.flags |= PerformedWork, reconcileChildren(current2, workInProgress2, newChildren, renderLanes2), workInProgress2.child;
      }
      function markWorkInProgressReceivedUpdate() {
        didReceiveUpdate = !0;
      }
      function resetSuspendedCurrentOnMountInLegacyMode(current2, workInProgress2) {
        (workInProgress2.mode & ConcurrentMode) === NoMode && current2 !== null && (current2.alternate = null, workInProgress2.alternate = null, workInProgress2.flags |= Placement);
      }
      function bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2) {
        return current2 !== null && (workInProgress2.dependencies = current2.dependencies), stopProfilerTimerIfRunning(), markSkippedUpdateLanes(workInProgress2.lanes), includesSomeLane(renderLanes2, workInProgress2.childLanes) ? (cloneChildFibers(current2, workInProgress2), workInProgress2.child) : null;
      }
      function remountFiber(current2, oldWorkInProgress, newWorkInProgress) {
        {
          var returnFiber = oldWorkInProgress.return;
          if (returnFiber === null)
            throw new Error("Cannot swap the root fiber.");
          if (current2.alternate = null, oldWorkInProgress.alternate = null, newWorkInProgress.index = oldWorkInProgress.index, newWorkInProgress.sibling = oldWorkInProgress.sibling, newWorkInProgress.return = oldWorkInProgress.return, newWorkInProgress.ref = oldWorkInProgress.ref, oldWorkInProgress === returnFiber.child)
            returnFiber.child = newWorkInProgress;
          else {
            var prevSibling = returnFiber.child;
            if (prevSibling === null)
              throw new Error("Expected parent to have a child.");
            for (; prevSibling.sibling !== oldWorkInProgress; )
              if (prevSibling = prevSibling.sibling, prevSibling === null)
                throw new Error("Expected to find the previous sibling.");
            prevSibling.sibling = newWorkInProgress;
          }
          var deletions = returnFiber.deletions;
          return deletions === null ? (returnFiber.deletions = [current2], returnFiber.flags |= ChildDeletion) : deletions.push(current2), newWorkInProgress.flags |= Placement, newWorkInProgress;
        }
      }
      function checkScheduledUpdateOrContext(current2, renderLanes2) {
        var updateLanes = current2.lanes;
        return !!includesSomeLane(updateLanes, renderLanes2);
      }
      function attemptEarlyBailoutIfNoScheduledUpdate(current2, workInProgress2, renderLanes2) {
        switch (workInProgress2.tag) {
          case HostRoot:
            pushHostRootContext(workInProgress2);
            var root2 = workInProgress2.stateNode;
            resetHydrationState();
            break;
          case HostComponent:
            pushHostContext(workInProgress2);
            break;
          case ClassComponent: {
            var Component = workInProgress2.type;
            isContextProvider(Component) && pushContextProvider(workInProgress2);
            break;
          }
          case HostPortal:
            pushHostContainer(workInProgress2, workInProgress2.stateNode.containerInfo);
            break;
          case ContextProvider: {
            var newValue = workInProgress2.memoizedProps.value, context = workInProgress2.type._context;
            pushProvider(workInProgress2, context, newValue);
            break;
          }
          case Profiler:
            {
              var hasChildWork = includesSomeLane(renderLanes2, workInProgress2.childLanes);
              hasChildWork && (workInProgress2.flags |= Update);
              {
                var stateNode = workInProgress2.stateNode;
                stateNode.effectDuration = 0, stateNode.passiveEffectDuration = 0;
              }
            }
            break;
          case SuspenseComponent: {
            var state = workInProgress2.memoizedState;
            if (state !== null) {
              if (state.dehydrated !== null)
                return pushSuspenseContext(workInProgress2, setDefaultShallowSuspenseContext(suspenseStackCursor.current)), workInProgress2.flags |= DidCapture, null;
              var primaryChildFragment = workInProgress2.child, primaryChildLanes = primaryChildFragment.childLanes;
              if (includesSomeLane(renderLanes2, primaryChildLanes))
                return updateSuspenseComponent(current2, workInProgress2, renderLanes2);
              pushSuspenseContext(workInProgress2, setDefaultShallowSuspenseContext(suspenseStackCursor.current));
              var child = bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2);
              return child !== null ? child.sibling : null;
            } else
              pushSuspenseContext(workInProgress2, setDefaultShallowSuspenseContext(suspenseStackCursor.current));
            break;
          }
          case SuspenseListComponent: {
            var didSuspendBefore = (current2.flags & DidCapture) !== NoFlags, _hasChildWork = includesSomeLane(renderLanes2, workInProgress2.childLanes);
            if (didSuspendBefore) {
              if (_hasChildWork)
                return updateSuspenseListComponent(current2, workInProgress2, renderLanes2);
              workInProgress2.flags |= DidCapture;
            }
            var renderState = workInProgress2.memoizedState;
            if (renderState !== null && (renderState.rendering = null, renderState.tail = null, renderState.lastEffect = null), pushSuspenseContext(workInProgress2, suspenseStackCursor.current), _hasChildWork)
              break;
            return null;
          }
          case OffscreenComponent:
          case LegacyHiddenComponent:
            return workInProgress2.lanes = NoLanes, updateOffscreenComponent(current2, workInProgress2, renderLanes2);
        }
        return bailoutOnAlreadyFinishedWork(current2, workInProgress2, renderLanes2);
      }
      function beginWork(current2, workInProgress2, renderLanes2) {
        if (workInProgress2._debugNeedsRemount && current2 !== null)
          return remountFiber(current2, workInProgress2, createFiberFromTypeAndProps(workInProgress2.type, workInProgress2.key, workInProgress2.pendingProps, workInProgress2._debugOwner || null, workInProgress2.mode, workInProgress2.lanes));
        if (current2 !== null) {
          var oldProps = current2.memoizedProps, newProps = workInProgress2.pendingProps;
          if (oldProps !== newProps || hasContextChanged() || // Force a re-render if the implementation changed due to hot reload:
          workInProgress2.type !== current2.type)
            didReceiveUpdate = !0;
          else {
            var hasScheduledUpdateOrContext = checkScheduledUpdateOrContext(current2, renderLanes2);
            if (!hasScheduledUpdateOrContext && // If this is the second pass of an error or suspense boundary, there
            // may not be work scheduled on `current`, so we check for this flag.
            (workInProgress2.flags & DidCapture) === NoFlags)
              return didReceiveUpdate = !1, attemptEarlyBailoutIfNoScheduledUpdate(current2, workInProgress2, renderLanes2);
            (current2.flags & ForceUpdateForLegacySuspense) !== NoFlags ? didReceiveUpdate = !0 : didReceiveUpdate = !1;
          }
        } else if (didReceiveUpdate = !1, getIsHydrating() && isForkedChild(workInProgress2)) {
          var slotIndex = workInProgress2.index, numberOfForks = getForksAtLevel();
          pushTreeId(workInProgress2, numberOfForks, slotIndex);
        }
        switch (workInProgress2.lanes = NoLanes, workInProgress2.tag) {
          case IndeterminateComponent:
            return mountIndeterminateComponent(current2, workInProgress2, workInProgress2.type, renderLanes2);
          case LazyComponent: {
            var elementType = workInProgress2.elementType;
            return mountLazyComponent(current2, workInProgress2, elementType, renderLanes2);
          }
          case FunctionComponent: {
            var Component = workInProgress2.type, unresolvedProps = workInProgress2.pendingProps, resolvedProps = workInProgress2.elementType === Component ? unresolvedProps : resolveDefaultProps(Component, unresolvedProps);
            return updateFunctionComponent(current2, workInProgress2, Component, resolvedProps, renderLanes2);
          }
          case ClassComponent: {
            var _Component = workInProgress2.type, _unresolvedProps = workInProgress2.pendingProps, _resolvedProps = workInProgress2.elementType === _Component ? _unresolvedProps : resolveDefaultProps(_Component, _unresolvedProps);
            return updateClassComponent(current2, workInProgress2, _Component, _resolvedProps, renderLanes2);
          }
          case HostRoot:
            return updateHostRoot(current2, workInProgress2, renderLanes2);
          case HostComponent:
            return updateHostComponent(current2, workInProgress2, renderLanes2);
          case HostText:
            return updateHostText(current2, workInProgress2);
          case SuspenseComponent:
            return updateSuspenseComponent(current2, workInProgress2, renderLanes2);
          case HostPortal:
            return updatePortalComponent(current2, workInProgress2, renderLanes2);
          case ForwardRef: {
            var type = workInProgress2.type, _unresolvedProps2 = workInProgress2.pendingProps, _resolvedProps2 = workInProgress2.elementType === type ? _unresolvedProps2 : resolveDefaultProps(type, _unresolvedProps2);
            return updateForwardRef(current2, workInProgress2, type, _resolvedProps2, renderLanes2);
          }
          case Fragment:
            return updateFragment(current2, workInProgress2, renderLanes2);
          case Mode:
            return updateMode(current2, workInProgress2, renderLanes2);
          case Profiler:
            return updateProfiler(current2, workInProgress2, renderLanes2);
          case ContextProvider:
            return updateContextProvider(current2, workInProgress2, renderLanes2);
          case ContextConsumer:
            return updateContextConsumer(current2, workInProgress2, renderLanes2);
          case MemoComponent: {
            var _type2 = workInProgress2.type, _unresolvedProps3 = workInProgress2.pendingProps, _resolvedProps3 = resolveDefaultProps(_type2, _unresolvedProps3);
            if (workInProgress2.type !== workInProgress2.elementType) {
              var outerPropTypes = _type2.propTypes;
              outerPropTypes && checkPropTypes(
                outerPropTypes,
                _resolvedProps3,
                // Resolved for outer only
                "prop",
                getComponentNameFromType(_type2)
              );
            }
            return _resolvedProps3 = resolveDefaultProps(_type2.type, _resolvedProps3), updateMemoComponent(current2, workInProgress2, _type2, _resolvedProps3, renderLanes2);
          }
          case SimpleMemoComponent:
            return updateSimpleMemoComponent(current2, workInProgress2, workInProgress2.type, workInProgress2.pendingProps, renderLanes2);
          case IncompleteClassComponent: {
            var _Component2 = workInProgress2.type, _unresolvedProps4 = workInProgress2.pendingProps, _resolvedProps4 = workInProgress2.elementType === _Component2 ? _unresolvedProps4 : resolveDefaultProps(_Component2, _unresolvedProps4);
            return mountIncompleteClassComponent(current2, workInProgress2, _Component2, _resolvedProps4, renderLanes2);
          }
          case SuspenseListComponent:
            return updateSuspenseListComponent(current2, workInProgress2, renderLanes2);
          case ScopeComponent:
            break;
          case OffscreenComponent:
            return updateOffscreenComponent(current2, workInProgress2, renderLanes2);
        }
        throw new Error("Unknown unit of work tag (" + workInProgress2.tag + "). This error is likely caused by a bug in React. Please file an issue.");
      }
      function markUpdate(workInProgress2) {
        workInProgress2.flags |= Update;
      }
      function markRef$1(workInProgress2) {
        workInProgress2.flags |= Ref, workInProgress2.flags |= RefStatic;
      }
      var appendAllChildren, updateHostContainer, updateHostComponent$1, updateHostText$1;
      appendAllChildren = function(parent, workInProgress2, needsVisibilityToggle, isHidden) {
        for (var node = workInProgress2.child; node !== null; ) {
          if (node.tag === HostComponent || node.tag === HostText)
            appendInitialChild(parent, node.stateNode);
          else if (node.tag !== HostPortal) {
            if (node.child !== null) {
              node.child.return = node, node = node.child;
              continue;
            }
          }
          if (node === workInProgress2)
            return;
          for (; node.sibling === null; ) {
            if (node.return === null || node.return === workInProgress2)
              return;
            node = node.return;
          }
          node.sibling.return = node.return, node = node.sibling;
        }
      }, updateHostContainer = function(current2, workInProgress2) {
      }, updateHostComponent$1 = function(current2, workInProgress2, type, newProps, rootContainerInstance) {
        var oldProps = current2.memoizedProps;
        if (oldProps !== newProps) {
          var instance = workInProgress2.stateNode, currentHostContext = getHostContext(), updatePayload = prepareUpdate(instance, type, oldProps, newProps, rootContainerInstance, currentHostContext);
          workInProgress2.updateQueue = updatePayload, updatePayload && markUpdate(workInProgress2);
        }
      }, updateHostText$1 = function(current2, workInProgress2, oldText, newText) {
        oldText !== newText && markUpdate(workInProgress2);
      };
      function cutOffTailIfNeeded(renderState, hasRenderedATailFallback) {
        if (!getIsHydrating())
          switch (renderState.tailMode) {
            case "hidden": {
              for (var tailNode = renderState.tail, lastTailNode = null; tailNode !== null; )
                tailNode.alternate !== null && (lastTailNode = tailNode), tailNode = tailNode.sibling;
              lastTailNode === null ? renderState.tail = null : lastTailNode.sibling = null;
              break;
            }
            case "collapsed": {
              for (var _tailNode = renderState.tail, _lastTailNode = null; _tailNode !== null; )
                _tailNode.alternate !== null && (_lastTailNode = _tailNode), _tailNode = _tailNode.sibling;
              _lastTailNode === null ? !hasRenderedATailFallback && renderState.tail !== null ? renderState.tail.sibling = null : renderState.tail = null : _lastTailNode.sibling = null;
              break;
            }
          }
      }
      function bubbleProperties(completedWork) {
        var didBailout = completedWork.alternate !== null && completedWork.alternate.child === completedWork.child, newChildLanes = NoLanes, subtreeFlags = NoFlags;
        if (didBailout) {
          if ((completedWork.mode & ProfileMode) !== NoMode) {
            for (var _treeBaseDuration = completedWork.selfBaseDuration, _child2 = completedWork.child; _child2 !== null; )
              newChildLanes = mergeLanes(newChildLanes, mergeLanes(_child2.lanes, _child2.childLanes)), subtreeFlags |= _child2.subtreeFlags & StaticMask, subtreeFlags |= _child2.flags & StaticMask, _treeBaseDuration += _child2.treeBaseDuration, _child2 = _child2.sibling;
            completedWork.treeBaseDuration = _treeBaseDuration;
          } else
            for (var _child3 = completedWork.child; _child3 !== null; )
              newChildLanes = mergeLanes(newChildLanes, mergeLanes(_child3.lanes, _child3.childLanes)), subtreeFlags |= _child3.subtreeFlags & StaticMask, subtreeFlags |= _child3.flags & StaticMask, _child3.return = completedWork, _child3 = _child3.sibling;
          completedWork.subtreeFlags |= subtreeFlags;
        } else {
          if ((completedWork.mode & ProfileMode) !== NoMode) {
            for (var actualDuration = completedWork.actualDuration, treeBaseDuration = completedWork.selfBaseDuration, child = completedWork.child; child !== null; )
              newChildLanes = mergeLanes(newChildLanes, mergeLanes(child.lanes, child.childLanes)), subtreeFlags |= child.subtreeFlags, subtreeFlags |= child.flags, actualDuration += child.actualDuration, treeBaseDuration += child.treeBaseDuration, child = child.sibling;
            completedWork.actualDuration = actualDuration, completedWork.treeBaseDuration = treeBaseDuration;
          } else
            for (var _child = completedWork.child; _child !== null; )
              newChildLanes = mergeLanes(newChildLanes, mergeLanes(_child.lanes, _child.childLanes)), subtreeFlags |= _child.subtreeFlags, subtreeFlags |= _child.flags, _child.return = completedWork, _child = _child.sibling;
          completedWork.subtreeFlags |= subtreeFlags;
        }
        return completedWork.childLanes = newChildLanes, didBailout;
      }
      function completeDehydratedSuspenseBoundary(current2, workInProgress2, nextState) {
        if (hasUnhydratedTailNodes() && (workInProgress2.mode & ConcurrentMode) !== NoMode && (workInProgress2.flags & DidCapture) === NoFlags)
          return warnIfUnhydratedTailNodes(workInProgress2), resetHydrationState(), workInProgress2.flags |= ForceClientRender | Incomplete | ShouldCapture, !1;
        var wasHydrated = popHydrationState(workInProgress2);
        if (nextState !== null && nextState.dehydrated !== null)
          if (current2 === null) {
            if (!wasHydrated)
              throw new Error("A dehydrated suspense component was completed without a hydrated node. This is probably a bug in React.");
            if (prepareToHydrateHostSuspenseInstance(workInProgress2), bubbleProperties(workInProgress2), (workInProgress2.mode & ProfileMode) !== NoMode) {
              var isTimedOutSuspense = nextState !== null;
              if (isTimedOutSuspense) {
                var primaryChildFragment = workInProgress2.child;
                primaryChildFragment !== null && (workInProgress2.treeBaseDuration -= primaryChildFragment.treeBaseDuration);
              }
            }
            return !1;
          } else {
            if (resetHydrationState(), (workInProgress2.flags & DidCapture) === NoFlags && (workInProgress2.memoizedState = null), workInProgress2.flags |= Update, bubbleProperties(workInProgress2), (workInProgress2.mode & ProfileMode) !== NoMode) {
              var _isTimedOutSuspense = nextState !== null;
              if (_isTimedOutSuspense) {
                var _primaryChildFragment = workInProgress2.child;
                _primaryChildFragment !== null && (workInProgress2.treeBaseDuration -= _primaryChildFragment.treeBaseDuration);
              }
            }
            return !1;
          }
        else
          return upgradeHydrationErrorsToRecoverable(), !0;
      }
      function completeWork(current2, workInProgress2, renderLanes2) {
        var newProps = workInProgress2.pendingProps;
        switch (popTreeContext(workInProgress2), workInProgress2.tag) {
          case IndeterminateComponent:
          case LazyComponent:
          case SimpleMemoComponent:
          case FunctionComponent:
          case ForwardRef:
          case Fragment:
          case Mode:
          case Profiler:
          case ContextConsumer:
          case MemoComponent:
            return bubbleProperties(workInProgress2), null;
          case ClassComponent: {
            var Component = workInProgress2.type;
            return isContextProvider(Component) && popContext(workInProgress2), bubbleProperties(workInProgress2), null;
          }
          case HostRoot: {
            var fiberRoot = workInProgress2.stateNode;
            if (popHostContainer(workInProgress2), popTopLevelContextObject(workInProgress2), resetWorkInProgressVersions(), fiberRoot.pendingContext && (fiberRoot.context = fiberRoot.pendingContext, fiberRoot.pendingContext = null), current2 === null || current2.child === null) {
              var wasHydrated = popHydrationState(workInProgress2);
              if (wasHydrated)
                markUpdate(workInProgress2);
              else if (current2 !== null) {
                var prevState = current2.memoizedState;
                // Check if this is a client root
                (!prevState.isDehydrated || // Check if we reverted to client rendering (e.g. due to an error)
                (workInProgress2.flags & ForceClientRender) !== NoFlags) && (workInProgress2.flags |= Snapshot, upgradeHydrationErrorsToRecoverable());
              }
            }
            return updateHostContainer(current2, workInProgress2), bubbleProperties(workInProgress2), null;
          }
          case HostComponent: {
            popHostContext(workInProgress2);
            var rootContainerInstance = getRootHostContainer(), type = workInProgress2.type;
            if (current2 !== null && workInProgress2.stateNode != null)
              updateHostComponent$1(current2, workInProgress2, type, newProps, rootContainerInstance), current2.ref !== workInProgress2.ref && markRef$1(workInProgress2);
            else {
              if (!newProps) {
                if (workInProgress2.stateNode === null)
                  throw new Error("We must have new props for new mounts. This error is likely caused by a bug in React. Please file an issue.");
                return bubbleProperties(workInProgress2), null;
              }
              var currentHostContext = getHostContext(), _wasHydrated = popHydrationState(workInProgress2);
              if (_wasHydrated)
                prepareToHydrateHostInstance(workInProgress2, rootContainerInstance, currentHostContext) && markUpdate(workInProgress2);
              else {
                var instance = createInstance(type, newProps, rootContainerInstance, currentHostContext, workInProgress2);
                appendAllChildren(instance, workInProgress2, !1, !1), workInProgress2.stateNode = instance, finalizeInitialChildren(instance, type, newProps, rootContainerInstance) && markUpdate(workInProgress2);
              }
              workInProgress2.ref !== null && markRef$1(workInProgress2);
            }
            return bubbleProperties(workInProgress2), null;
          }
          case HostText: {
            var newText = newProps;
            if (current2 && workInProgress2.stateNode != null) {
              var oldText = current2.memoizedProps;
              updateHostText$1(current2, workInProgress2, oldText, newText);
            } else {
              if (typeof newText != "string" && workInProgress2.stateNode === null)
                throw new Error("We must have new props for new mounts. This error is likely caused by a bug in React. Please file an issue.");
              var _rootContainerInstance = getRootHostContainer(), _currentHostContext = getHostContext(), _wasHydrated2 = popHydrationState(workInProgress2);
              _wasHydrated2 ? prepareToHydrateHostTextInstance(workInProgress2) && markUpdate(workInProgress2) : workInProgress2.stateNode = createTextInstance(newText, _rootContainerInstance, _currentHostContext, workInProgress2);
            }
            return bubbleProperties(workInProgress2), null;
          }
          case SuspenseComponent: {
            popSuspenseContext(workInProgress2);
            var nextState = workInProgress2.memoizedState;
            if (current2 === null || current2.memoizedState !== null && current2.memoizedState.dehydrated !== null) {
              var fallthroughToNormalSuspensePath = completeDehydratedSuspenseBoundary(current2, workInProgress2, nextState);
              if (!fallthroughToNormalSuspensePath)
                return workInProgress2.flags & ShouldCapture ? workInProgress2 : null;
            }
            if ((workInProgress2.flags & DidCapture) !== NoFlags)
              return workInProgress2.lanes = renderLanes2, (workInProgress2.mode & ProfileMode) !== NoMode && transferActualDuration(workInProgress2), workInProgress2;
            var nextDidTimeout = nextState !== null, prevDidTimeout = current2 !== null && current2.memoizedState !== null;
            if (nextDidTimeout !== prevDidTimeout && nextDidTimeout) {
              var _offscreenFiber2 = workInProgress2.child;
              if (_offscreenFiber2.flags |= Visibility, (workInProgress2.mode & ConcurrentMode) !== NoMode) {
                var hasInvisibleChildContext = current2 === null && (workInProgress2.memoizedProps.unstable_avoidThisFallback !== !0 || !enableSuspenseAvoidThisFallback);
                hasInvisibleChildContext || hasSuspenseContext(suspenseStackCursor.current, InvisibleParentSuspenseContext) ? renderDidSuspend() : renderDidSuspendDelayIfPossible();
              }
            }
            var wakeables = workInProgress2.updateQueue;
            if (wakeables !== null && (workInProgress2.flags |= Update), bubbleProperties(workInProgress2), (workInProgress2.mode & ProfileMode) !== NoMode && nextDidTimeout) {
              var primaryChildFragment = workInProgress2.child;
              primaryChildFragment !== null && (workInProgress2.treeBaseDuration -= primaryChildFragment.treeBaseDuration);
            }
            return null;
          }
          case HostPortal:
            return popHostContainer(workInProgress2), updateHostContainer(current2, workInProgress2), current2 === null && preparePortalMount(workInProgress2.stateNode.containerInfo), bubbleProperties(workInProgress2), null;
          case ContextProvider:
            var context = workInProgress2.type._context;
            return popProvider(context, workInProgress2), bubbleProperties(workInProgress2), null;
          case IncompleteClassComponent: {
            var _Component = workInProgress2.type;
            return isContextProvider(_Component) && popContext(workInProgress2), bubbleProperties(workInProgress2), null;
          }
          case SuspenseListComponent: {
            popSuspenseContext(workInProgress2);
            var renderState = workInProgress2.memoizedState;
            if (renderState === null)
              return bubbleProperties(workInProgress2), null;
            var didSuspendAlready = (workInProgress2.flags & DidCapture) !== NoFlags, renderedTail = renderState.rendering;
            if (renderedTail === null)
              if (didSuspendAlready)
                cutOffTailIfNeeded(renderState, !1);
              else {
                var cannotBeSuspended = renderHasNotSuspendedYet() && (current2 === null || (current2.flags & DidCapture) === NoFlags);
                if (!cannotBeSuspended)
                  for (var row = workInProgress2.child; row !== null; ) {
                    var suspended = findFirstSuspended(row);
                    if (suspended !== null) {
                      didSuspendAlready = !0, workInProgress2.flags |= DidCapture, cutOffTailIfNeeded(renderState, !1);
                      var newThenables = suspended.updateQueue;
                      return newThenables !== null && (workInProgress2.updateQueue = newThenables, workInProgress2.flags |= Update), workInProgress2.subtreeFlags = NoFlags, resetChildFibers(workInProgress2, renderLanes2), pushSuspenseContext(workInProgress2, setShallowSuspenseContext(suspenseStackCursor.current, ForceSuspenseFallback)), workInProgress2.child;
                    }
                    row = row.sibling;
                  }
                renderState.tail !== null && now() > getRenderTargetTime() && (workInProgress2.flags |= DidCapture, didSuspendAlready = !0, cutOffTailIfNeeded(renderState, !1), workInProgress2.lanes = SomeRetryLane);
              }
            else {
              if (!didSuspendAlready) {
                var _suspended = findFirstSuspended(renderedTail);
                if (_suspended !== null) {
                  workInProgress2.flags |= DidCapture, didSuspendAlready = !0;
                  var _newThenables = _suspended.updateQueue;
                  if (_newThenables !== null && (workInProgress2.updateQueue = _newThenables, workInProgress2.flags |= Update), cutOffTailIfNeeded(renderState, !0), renderState.tail === null && renderState.tailMode === "hidden" && !renderedTail.alternate && !getIsHydrating())
                    return bubbleProperties(workInProgress2), null;
                } else
                  // The time it took to render last row is greater than the remaining
                  // time we have to render. So rendering one more row would likely
                  // exceed it.
                  now() * 2 - renderState.renderingStartTime > getRenderTargetTime() && renderLanes2 !== OffscreenLane && (workInProgress2.flags |= DidCapture, didSuspendAlready = !0, cutOffTailIfNeeded(renderState, !1), workInProgress2.lanes = SomeRetryLane);
              }
              if (renderState.isBackwards)
                renderedTail.sibling = workInProgress2.child, workInProgress2.child = renderedTail;
              else {
                var previousSibling = renderState.last;
                previousSibling !== null ? previousSibling.sibling = renderedTail : workInProgress2.child = renderedTail, renderState.last = renderedTail;
              }
            }
            if (renderState.tail !== null) {
              var next = renderState.tail;
              renderState.rendering = next, renderState.tail = next.sibling, renderState.renderingStartTime = now(), next.sibling = null;
              var suspenseContext = suspenseStackCursor.current;
              return didSuspendAlready ? suspenseContext = setShallowSuspenseContext(suspenseContext, ForceSuspenseFallback) : suspenseContext = setDefaultShallowSuspenseContext(suspenseContext), pushSuspenseContext(workInProgress2, suspenseContext), next;
            }
            return bubbleProperties(workInProgress2), null;
          }
          case ScopeComponent:
            break;
          case OffscreenComponent:
          case LegacyHiddenComponent: {
            popRenderLanes(workInProgress2);
            var _nextState = workInProgress2.memoizedState, nextIsHidden = _nextState !== null;
            if (current2 !== null) {
              var _prevState = current2.memoizedState, prevIsHidden = _prevState !== null;
              prevIsHidden !== nextIsHidden && // LegacyHidden doesn't do any hiding — it only pre-renders.
              !enableLegacyHidden && (workInProgress2.flags |= Visibility);
            }
            return !nextIsHidden || (workInProgress2.mode & ConcurrentMode) === NoMode ? bubbleProperties(workInProgress2) : includesSomeLane(subtreeRenderLanes, OffscreenLane) && (bubbleProperties(workInProgress2), workInProgress2.subtreeFlags & (Placement | Update) && (workInProgress2.flags |= Visibility)), null;
          }
          case CacheComponent:
            return null;
          case TracingMarkerComponent:
            return null;
        }
        throw new Error("Unknown unit of work tag (" + workInProgress2.tag + "). This error is likely caused by a bug in React. Please file an issue.");
      }
      function unwindWork(current2, workInProgress2, renderLanes2) {
        switch (popTreeContext(workInProgress2), workInProgress2.tag) {
          case ClassComponent: {
            var Component = workInProgress2.type;
            isContextProvider(Component) && popContext(workInProgress2);
            var flags = workInProgress2.flags;
            return flags & ShouldCapture ? (workInProgress2.flags = flags & ~ShouldCapture | DidCapture, (workInProgress2.mode & ProfileMode) !== NoMode && transferActualDuration(workInProgress2), workInProgress2) : null;
          }
          case HostRoot: {
            var root2 = workInProgress2.stateNode;
            popHostContainer(workInProgress2), popTopLevelContextObject(workInProgress2), resetWorkInProgressVersions();
            var _flags = workInProgress2.flags;
            return (_flags & ShouldCapture) !== NoFlags && (_flags & DidCapture) === NoFlags ? (workInProgress2.flags = _flags & ~ShouldCapture | DidCapture, workInProgress2) : null;
          }
          case HostComponent:
            return popHostContext(workInProgress2), null;
          case SuspenseComponent: {
            popSuspenseContext(workInProgress2);
            var suspenseState = workInProgress2.memoizedState;
            if (suspenseState !== null && suspenseState.dehydrated !== null) {
              if (workInProgress2.alternate === null)
                throw new Error("Threw in newly mounted dehydrated component. This is likely a bug in React. Please file an issue.");
              resetHydrationState();
            }
            var _flags2 = workInProgress2.flags;
            return _flags2 & ShouldCapture ? (workInProgress2.flags = _flags2 & ~ShouldCapture | DidCapture, (workInProgress2.mode & ProfileMode) !== NoMode && transferActualDuration(workInProgress2), workInProgress2) : null;
          }
          case SuspenseListComponent:
            return popSuspenseContext(workInProgress2), null;
          case HostPortal:
            return popHostContainer(workInProgress2), null;
          case ContextProvider:
            var context = workInProgress2.type._context;
            return popProvider(context, workInProgress2), null;
          case OffscreenComponent:
          case LegacyHiddenComponent:
            return popRenderLanes(workInProgress2), null;
          case CacheComponent:
            return null;
          default:
            return null;
        }
      }
      function unwindInterruptedWork(current2, interruptedWork, renderLanes2) {
        switch (popTreeContext(interruptedWork), interruptedWork.tag) {
          case ClassComponent: {
            var childContextTypes = interruptedWork.type.childContextTypes;
            childContextTypes != null && popContext(interruptedWork);
            break;
          }
          case HostRoot: {
            var root2 = interruptedWork.stateNode;
            popHostContainer(interruptedWork), popTopLevelContextObject(interruptedWork), resetWorkInProgressVersions();
            break;
          }
          case HostComponent: {
            popHostContext(interruptedWork);
            break;
          }
          case HostPortal:
            popHostContainer(interruptedWork);
            break;
          case SuspenseComponent:
            popSuspenseContext(interruptedWork);
            break;
          case SuspenseListComponent:
            popSuspenseContext(interruptedWork);
            break;
          case ContextProvider:
            var context = interruptedWork.type._context;
            popProvider(context, interruptedWork);
            break;
          case OffscreenComponent:
          case LegacyHiddenComponent:
            popRenderLanes(interruptedWork);
            break;
        }
      }
      var didWarnAboutUndefinedSnapshotBeforeUpdate = null;
      didWarnAboutUndefinedSnapshotBeforeUpdate = /* @__PURE__ */ new Set();
      var offscreenSubtreeIsHidden = !1, offscreenSubtreeWasHidden = !1, PossiblyWeakSet = typeof WeakSet == "function" ? WeakSet : Set, nextEffect = null, inProgressLanes = null, inProgressRoot = null;
      function reportUncaughtErrorInDEV(error2) {
        invokeGuardedCallback(null, function() {
          throw error2;
        }), clearCaughtError();
      }
      var callComponentWillUnmountWithTimer = function(current2, instance) {
        if (instance.props = current2.memoizedProps, instance.state = current2.memoizedState, current2.mode & ProfileMode)
          try {
            startLayoutEffectTimer(), instance.componentWillUnmount();
          } finally {
            recordLayoutEffectDuration(current2);
          }
        else
          instance.componentWillUnmount();
      };
      function safelyCallCommitHookLayoutEffectListMount(current2, nearestMountedAncestor) {
        try {
          commitHookEffectListMount(Layout, current2);
        } catch (error2) {
          captureCommitPhaseError(current2, nearestMountedAncestor, error2);
        }
      }
      function safelyCallComponentWillUnmount(current2, nearestMountedAncestor, instance) {
        try {
          callComponentWillUnmountWithTimer(current2, instance);
        } catch (error2) {
          captureCommitPhaseError(current2, nearestMountedAncestor, error2);
        }
      }
      function safelyCallComponentDidMount(current2, nearestMountedAncestor, instance) {
        try {
          instance.componentDidMount();
        } catch (error2) {
          captureCommitPhaseError(current2, nearestMountedAncestor, error2);
        }
      }
      function safelyAttachRef(current2, nearestMountedAncestor) {
        try {
          commitAttachRef(current2);
        } catch (error2) {
          captureCommitPhaseError(current2, nearestMountedAncestor, error2);
        }
      }
      function safelyDetachRef(current2, nearestMountedAncestor) {
        var ref = current2.ref;
        if (ref !== null)
          if (typeof ref == "function") {
            var retVal;
            try {
              if (enableProfilerTimer && enableProfilerCommitHooks && current2.mode & ProfileMode)
                try {
                  startLayoutEffectTimer(), retVal = ref(null);
                } finally {
                  recordLayoutEffectDuration(current2);
                }
              else
                retVal = ref(null);
            } catch (error2) {
              captureCommitPhaseError(current2, nearestMountedAncestor, error2);
            }
            typeof retVal == "function" && error("Unexpected return value from a callback ref in %s. A callback ref should not return a function.", getComponentNameFromFiber(current2));
          } else
            ref.current = null;
      }
      function safelyCallDestroy(current2, nearestMountedAncestor, destroy) {
        try {
          destroy();
        } catch (error2) {
          captureCommitPhaseError(current2, nearestMountedAncestor, error2);
        }
      }
      var focusedInstanceHandle = null, shouldFireAfterActiveInstanceBlur = !1;
      function commitBeforeMutationEffects(root2, firstChild) {
        focusedInstanceHandle = prepareForCommit(root2.containerInfo), nextEffect = firstChild, commitBeforeMutationEffects_begin();
        var shouldFire = shouldFireAfterActiveInstanceBlur;
        return shouldFireAfterActiveInstanceBlur = !1, focusedInstanceHandle = null, shouldFire;
      }
      function commitBeforeMutationEffects_begin() {
        for (; nextEffect !== null; ) {
          var fiber = nextEffect, child = fiber.child;
          (fiber.subtreeFlags & BeforeMutationMask) !== NoFlags && child !== null ? (child.return = fiber, nextEffect = child) : commitBeforeMutationEffects_complete();
        }
      }
      function commitBeforeMutationEffects_complete() {
        for (; nextEffect !== null; ) {
          var fiber = nextEffect;
          setCurrentFiber(fiber);
          try {
            commitBeforeMutationEffectsOnFiber(fiber);
          } catch (error2) {
            captureCommitPhaseError(fiber, fiber.return, error2);
          }
          resetCurrentFiber();
          var sibling = fiber.sibling;
          if (sibling !== null) {
            sibling.return = fiber.return, nextEffect = sibling;
            return;
          }
          nextEffect = fiber.return;
        }
      }
      function commitBeforeMutationEffectsOnFiber(finishedWork) {
        var current2 = finishedWork.alternate, flags = finishedWork.flags;
        if ((flags & Snapshot) !== NoFlags) {
          switch (setCurrentFiber(finishedWork), finishedWork.tag) {
            case FunctionComponent:
            case ForwardRef:
            case SimpleMemoComponent:
              break;
            case ClassComponent: {
              if (current2 !== null) {
                var prevProps = current2.memoizedProps, prevState = current2.memoizedState, instance = finishedWork.stateNode;
                finishedWork.type === finishedWork.elementType && !didWarnAboutReassigningProps && (instance.props !== finishedWork.memoizedProps && error("Expected %s props to match memoized props before getSnapshotBeforeUpdate. This might either be because of a bug in React, or because a component reassigns its own `this.props`. Please file an issue.", getComponentNameFromFiber(finishedWork) || "instance"), instance.state !== finishedWork.memoizedState && error("Expected %s state to match memoized state before getSnapshotBeforeUpdate. This might either be because of a bug in React, or because a component reassigns its own `this.state`. Please file an issue.", getComponentNameFromFiber(finishedWork) || "instance"));
                var snapshot = instance.getSnapshotBeforeUpdate(finishedWork.elementType === finishedWork.type ? prevProps : resolveDefaultProps(finishedWork.type, prevProps), prevState);
                {
                  var didWarnSet = didWarnAboutUndefinedSnapshotBeforeUpdate;
                  snapshot === void 0 && !didWarnSet.has(finishedWork.type) && (didWarnSet.add(finishedWork.type), error("%s.getSnapshotBeforeUpdate(): A snapshot value (or null) must be returned. You have returned undefined.", getComponentNameFromFiber(finishedWork)));
                }
                instance.__reactInternalSnapshotBeforeUpdate = snapshot;
              }
              break;
            }
            case HostRoot: {
              {
                var root2 = finishedWork.stateNode;
                clearContainer(root2.containerInfo);
              }
              break;
            }
            case HostComponent:
            case HostText:
            case HostPortal:
            case IncompleteClassComponent:
              break;
            default:
              throw new Error("This unit of work tag should not have side-effects. This error is likely caused by a bug in React. Please file an issue.");
          }
          resetCurrentFiber();
        }
      }
      function commitHookEffectListUnmount(flags, finishedWork, nearestMountedAncestor) {
        var updateQueue = finishedWork.updateQueue, lastEffect = updateQueue !== null ? updateQueue.lastEffect : null;
        if (lastEffect !== null) {
          var firstEffect = lastEffect.next, effect = firstEffect;
          do {
            if ((effect.tag & flags) === flags) {
              var destroy = effect.destroy;
              effect.destroy = void 0, destroy !== void 0 && ((flags & Passive$1) !== NoFlags$1 ? markComponentPassiveEffectUnmountStarted(finishedWork) : (flags & Layout) !== NoFlags$1 && markComponentLayoutEffectUnmountStarted(finishedWork), (flags & Insertion) !== NoFlags$1 && setIsRunningInsertionEffect(!0), safelyCallDestroy(finishedWork, nearestMountedAncestor, destroy), (flags & Insertion) !== NoFlags$1 && setIsRunningInsertionEffect(!1), (flags & Passive$1) !== NoFlags$1 ? markComponentPassiveEffectUnmountStopped() : (flags & Layout) !== NoFlags$1 && markComponentLayoutEffectUnmountStopped());
            }
            effect = effect.next;
          } while (effect !== firstEffect);
        }
      }
      function commitHookEffectListMount(flags, finishedWork) {
        var updateQueue = finishedWork.updateQueue, lastEffect = updateQueue !== null ? updateQueue.lastEffect : null;
        if (lastEffect !== null) {
          var firstEffect = lastEffect.next, effect = firstEffect;
          do {
            if ((effect.tag & flags) === flags) {
              (flags & Passive$1) !== NoFlags$1 ? markComponentPassiveEffectMountStarted(finishedWork) : (flags & Layout) !== NoFlags$1 && markComponentLayoutEffectMountStarted(finishedWork);
              var create = effect.create;
              (flags & Insertion) !== NoFlags$1 && setIsRunningInsertionEffect(!0), effect.destroy = create(), (flags & Insertion) !== NoFlags$1 && setIsRunningInsertionEffect(!1), (flags & Passive$1) !== NoFlags$1 ? markComponentPassiveEffectMountStopped() : (flags & Layout) !== NoFlags$1 && markComponentLayoutEffectMountStopped();
              {
                var destroy = effect.destroy;
                if (destroy !== void 0 && typeof destroy != "function") {
                  var hookName = void 0;
                  (effect.tag & Layout) !== NoFlags ? hookName = "useLayoutEffect" : (effect.tag & Insertion) !== NoFlags ? hookName = "useInsertionEffect" : hookName = "useEffect";
                  var addendum = void 0;
                  destroy === null ? addendum = " You returned null. If your effect does not require clean up, return undefined (or nothing)." : typeof destroy.then == "function" ? addendum = `

It looks like you wrote ` + hookName + `(async () => ...) or returned a Promise. Instead, write the async function inside your effect and call it immediately:

` + hookName + `(() => {
  async function fetchData() {
    // You can await here
    const response = await MyAPI.getData(someId);
    // ...
  }
  fetchData();
}, [someId]); // Or [] if effect doesn't need props or state

Learn more about data fetching with Hooks: https://reactjs.org/link/hooks-data-fetching` : addendum = " You returned: " + destroy, error("%s must not return anything besides a function, which is used for clean-up.%s", hookName, addendum);
                }
              }
            }
            effect = effect.next;
          } while (effect !== firstEffect);
        }
      }
      function commitPassiveEffectDurations(finishedRoot, finishedWork) {
        if ((finishedWork.flags & Update) !== NoFlags)
          switch (finishedWork.tag) {
            case Profiler: {
              var passiveEffectDuration = finishedWork.stateNode.passiveEffectDuration, _finishedWork$memoize = finishedWork.memoizedProps, id = _finishedWork$memoize.id, onPostCommit = _finishedWork$memoize.onPostCommit, commitTime2 = getCommitTime(), phase = finishedWork.alternate === null ? "mount" : "update";
              isCurrentUpdateNested() && (phase = "nested-update"), typeof onPostCommit == "function" && onPostCommit(id, phase, passiveEffectDuration, commitTime2);
              var parentFiber = finishedWork.return;
              outer:
                for (; parentFiber !== null; ) {
                  switch (parentFiber.tag) {
                    case HostRoot:
                      var root2 = parentFiber.stateNode;
                      root2.passiveEffectDuration += passiveEffectDuration;
                      break outer;
                    case Profiler:
                      var parentStateNode = parentFiber.stateNode;
                      parentStateNode.passiveEffectDuration += passiveEffectDuration;
                      break outer;
                  }
                  parentFiber = parentFiber.return;
                }
              break;
            }
          }
      }
      function commitLayoutEffectOnFiber(finishedRoot, current2, finishedWork, committedLanes) {
        if ((finishedWork.flags & LayoutMask) !== NoFlags)
          switch (finishedWork.tag) {
            case FunctionComponent:
            case ForwardRef:
            case SimpleMemoComponent: {
              if (!offscreenSubtreeWasHidden)
                if (finishedWork.mode & ProfileMode)
                  try {
                    startLayoutEffectTimer(), commitHookEffectListMount(Layout | HasEffect, finishedWork);
                  } finally {
                    recordLayoutEffectDuration(finishedWork);
                  }
                else
                  commitHookEffectListMount(Layout | HasEffect, finishedWork);
              break;
            }
            case ClassComponent: {
              var instance = finishedWork.stateNode;
              if (finishedWork.flags & Update && !offscreenSubtreeWasHidden)
                if (current2 === null)
                  if (finishedWork.type === finishedWork.elementType && !didWarnAboutReassigningProps && (instance.props !== finishedWork.memoizedProps && error("Expected %s props to match memoized props before componentDidMount. This might either be because of a bug in React, or because a component reassigns its own `this.props`. Please file an issue.", getComponentNameFromFiber(finishedWork) || "instance"), instance.state !== finishedWork.memoizedState && error("Expected %s state to match memoized state before componentDidMount. This might either be because of a bug in React, or because a component reassigns its own `this.state`. Please file an issue.", getComponentNameFromFiber(finishedWork) || "instance")), finishedWork.mode & ProfileMode)
                    try {
                      startLayoutEffectTimer(), instance.componentDidMount();
                    } finally {
                      recordLayoutEffectDuration(finishedWork);
                    }
                  else
                    instance.componentDidMount();
                else {
                  var prevProps = finishedWork.elementType === finishedWork.type ? current2.memoizedProps : resolveDefaultProps(finishedWork.type, current2.memoizedProps), prevState = current2.memoizedState;
                  if (finishedWork.type === finishedWork.elementType && !didWarnAboutReassigningProps && (instance.props !== finishedWork.memoizedProps && error("Expected %s props to match memoized props before componentDidUpdate. This might either be because of a bug in React, or because a component reassigns its own `this.props`. Please file an issue.", getComponentNameFromFiber(finishedWork) || "instance"), instance.state !== finishedWork.memoizedState && error("Expected %s state to match memoized state before componentDidUpdate. This might either be because of a bug in React, or because a component reassigns its own `this.state`. Please file an issue.", getComponentNameFromFiber(finishedWork) || "instance")), finishedWork.mode & ProfileMode)
                    try {
                      startLayoutEffectTimer(), instance.componentDidUpdate(prevProps, prevState, instance.__reactInternalSnapshotBeforeUpdate);
                    } finally {
                      recordLayoutEffectDuration(finishedWork);
                    }
                  else
                    instance.componentDidUpdate(prevProps, prevState, instance.__reactInternalSnapshotBeforeUpdate);
                }
              var updateQueue = finishedWork.updateQueue;
              updateQueue !== null && (finishedWork.type === finishedWork.elementType && !didWarnAboutReassigningProps && (instance.props !== finishedWork.memoizedProps && error("Expected %s props to match memoized props before processing the update queue. This might either be because of a bug in React, or because a component reassigns its own `this.props`. Please file an issue.", getComponentNameFromFiber(finishedWork) || "instance"), instance.state !== finishedWork.memoizedState && error("Expected %s state to match memoized state before processing the update queue. This might either be because of a bug in React, or because a component reassigns its own `this.state`. Please file an issue.", getComponentNameFromFiber(finishedWork) || "instance")), commitUpdateQueue(finishedWork, updateQueue, instance));
              break;
            }
            case HostRoot: {
              var _updateQueue = finishedWork.updateQueue;
              if (_updateQueue !== null) {
                var _instance = null;
                if (finishedWork.child !== null)
                  switch (finishedWork.child.tag) {
                    case HostComponent:
                      _instance = finishedWork.child.stateNode;
                      break;
                    case ClassComponent:
                      _instance = finishedWork.child.stateNode;
                      break;
                  }
                commitUpdateQueue(finishedWork, _updateQueue, _instance);
              }
              break;
            }
            case HostComponent: {
              var _instance2 = finishedWork.stateNode;
              if (current2 === null && finishedWork.flags & Update) {
                var type = finishedWork.type, props = finishedWork.memoizedProps;
                commitMount(_instance2, type, props);
              }
              break;
            }
            case HostText:
              break;
            case HostPortal:
              break;
            case Profiler: {
              {
                var _finishedWork$memoize2 = finishedWork.memoizedProps, onCommit = _finishedWork$memoize2.onCommit, onRender = _finishedWork$memoize2.onRender, effectDuration = finishedWork.stateNode.effectDuration, commitTime2 = getCommitTime(), phase = current2 === null ? "mount" : "update";
                isCurrentUpdateNested() && (phase = "nested-update"), typeof onRender == "function" && onRender(finishedWork.memoizedProps.id, phase, finishedWork.actualDuration, finishedWork.treeBaseDuration, finishedWork.actualStartTime, commitTime2);
                {
                  typeof onCommit == "function" && onCommit(finishedWork.memoizedProps.id, phase, effectDuration, commitTime2), enqueuePendingPassiveProfilerEffect(finishedWork);
                  var parentFiber = finishedWork.return;
                  outer:
                    for (; parentFiber !== null; ) {
                      switch (parentFiber.tag) {
                        case HostRoot:
                          var root2 = parentFiber.stateNode;
                          root2.effectDuration += effectDuration;
                          break outer;
                        case Profiler:
                          var parentStateNode = parentFiber.stateNode;
                          parentStateNode.effectDuration += effectDuration;
                          break outer;
                      }
                      parentFiber = parentFiber.return;
                    }
                }
              }
              break;
            }
            case SuspenseComponent: {
              commitSuspenseHydrationCallbacks(finishedRoot, finishedWork);
              break;
            }
            case SuspenseListComponent:
            case IncompleteClassComponent:
            case ScopeComponent:
            case OffscreenComponent:
            case LegacyHiddenComponent:
            case TracingMarkerComponent:
              break;
            default:
              throw new Error("This unit of work tag should not have side-effects. This error is likely caused by a bug in React. Please file an issue.");
          }
        offscreenSubtreeWasHidden || finishedWork.flags & Ref && commitAttachRef(finishedWork);
      }
      function reappearLayoutEffectsOnFiber(node) {
        switch (node.tag) {
          case FunctionComponent:
          case ForwardRef:
          case SimpleMemoComponent: {
            if (node.mode & ProfileMode)
              try {
                startLayoutEffectTimer(), safelyCallCommitHookLayoutEffectListMount(node, node.return);
              } finally {
                recordLayoutEffectDuration(node);
              }
            else
              safelyCallCommitHookLayoutEffectListMount(node, node.return);
            break;
          }
          case ClassComponent: {
            var instance = node.stateNode;
            typeof instance.componentDidMount == "function" && safelyCallComponentDidMount(node, node.return, instance), safelyAttachRef(node, node.return);
            break;
          }
          case HostComponent: {
            safelyAttachRef(node, node.return);
            break;
          }
        }
      }
      function hideOrUnhideAllChildren(finishedWork, isHidden) {
        for (var hostSubtreeRoot = null, node = finishedWork; ; ) {
          if (node.tag === HostComponent) {
            if (hostSubtreeRoot === null) {
              hostSubtreeRoot = node;
              try {
                var instance = node.stateNode;
                isHidden ? hideInstance(instance) : unhideInstance(node.stateNode, node.memoizedProps);
              } catch (error2) {
                captureCommitPhaseError(finishedWork, finishedWork.return, error2);
              }
            }
          } else if (node.tag === HostText) {
            if (hostSubtreeRoot === null)
              try {
                var _instance3 = node.stateNode;
                isHidden ? hideTextInstance(_instance3) : unhideTextInstance(_instance3, node.memoizedProps);
              } catch (error2) {
                captureCommitPhaseError(finishedWork, finishedWork.return, error2);
              }
          } else if (!((node.tag === OffscreenComponent || node.tag === LegacyHiddenComponent) && node.memoizedState !== null && node !== finishedWork)) {
            if (node.child !== null) {
              node.child.return = node, node = node.child;
              continue;
            }
          }
          if (node === finishedWork)
            return;
          for (; node.sibling === null; ) {
            if (node.return === null || node.return === finishedWork)
              return;
            hostSubtreeRoot === node && (hostSubtreeRoot = null), node = node.return;
          }
          hostSubtreeRoot === node && (hostSubtreeRoot = null), node.sibling.return = node.return, node = node.sibling;
        }
      }
      function commitAttachRef(finishedWork) {
        var ref = finishedWork.ref;
        if (ref !== null) {
          var instance = finishedWork.stateNode, instanceToUse;
          switch (finishedWork.tag) {
            case HostComponent:
              instanceToUse = instance;
              break;
            default:
              instanceToUse = instance;
          }
          if (typeof ref == "function") {
            var retVal;
            if (finishedWork.mode & ProfileMode)
              try {
                startLayoutEffectTimer(), retVal = ref(instanceToUse);
              } finally {
                recordLayoutEffectDuration(finishedWork);
              }
            else
              retVal = ref(instanceToUse);
            typeof retVal == "function" && error("Unexpected return value from a callback ref in %s. A callback ref should not return a function.", getComponentNameFromFiber(finishedWork));
          } else
            ref.hasOwnProperty("current") || error("Unexpected ref object provided for %s. Use either a ref-setter function or React.createRef().", getComponentNameFromFiber(finishedWork)), ref.current = instanceToUse;
        }
      }
      function detachFiberMutation(fiber) {
        var alternate = fiber.alternate;
        alternate !== null && (alternate.return = null), fiber.return = null;
      }
      function detachFiberAfterEffects(fiber) {
        var alternate = fiber.alternate;
        alternate !== null && (fiber.alternate = null, detachFiberAfterEffects(alternate));
        {
          if (fiber.child = null, fiber.deletions = null, fiber.sibling = null, fiber.tag === HostComponent) {
            var hostInstance = fiber.stateNode;
            hostInstance !== null && detachDeletedInstance(hostInstance);
          }
          fiber.stateNode = null, fiber._debugOwner = null, fiber.return = null, fiber.dependencies = null, fiber.memoizedProps = null, fiber.memoizedState = null, fiber.pendingProps = null, fiber.stateNode = null, fiber.updateQueue = null;
        }
      }
      function getHostParentFiber(fiber) {
        for (var parent = fiber.return; parent !== null; ) {
          if (isHostParent(parent))
            return parent;
          parent = parent.return;
        }
        throw new Error("Expected to find a host parent. This error is likely caused by a bug in React. Please file an issue.");
      }
      function isHostParent(fiber) {
        return fiber.tag === HostComponent || fiber.tag === HostRoot || fiber.tag === HostPortal;
      }
      function getHostSibling(fiber) {
        var node = fiber;
        siblings:
          for (; ; ) {
            for (; node.sibling === null; ) {
              if (node.return === null || isHostParent(node.return))
                return null;
              node = node.return;
            }
            for (node.sibling.return = node.return, node = node.sibling; node.tag !== HostComponent && node.tag !== HostText && node.tag !== DehydratedFragment; ) {
              if (node.flags & Placement || node.child === null || node.tag === HostPortal)
                continue siblings;
              node.child.return = node, node = node.child;
            }
            if (!(node.flags & Placement))
              return node.stateNode;
          }
      }
      function commitPlacement(finishedWork) {
        var parentFiber = getHostParentFiber(finishedWork);
        switch (parentFiber.tag) {
          case HostComponent: {
            var parent = parentFiber.stateNode;
            parentFiber.flags & ContentReset && (resetTextContent(parent), parentFiber.flags &= ~ContentReset);
            var before = getHostSibling(finishedWork);
            insertOrAppendPlacementNode(finishedWork, before, parent);
            break;
          }
          case HostRoot:
          case HostPortal: {
            var _parent = parentFiber.stateNode.containerInfo, _before = getHostSibling(finishedWork);
            insertOrAppendPlacementNodeIntoContainer(finishedWork, _before, _parent);
            break;
          }
          default:
            throw new Error("Invalid host parent fiber. This error is likely caused by a bug in React. Please file an issue.");
        }
      }
      function insertOrAppendPlacementNodeIntoContainer(node, before, parent) {
        var tag = node.tag, isHost = tag === HostComponent || tag === HostText;
        if (isHost) {
          var stateNode = node.stateNode;
          before ? insertInContainerBefore(parent, stateNode, before) : appendChildToContainer(parent, stateNode);
        } else if (tag !== HostPortal) {
          var child = node.child;
          if (child !== null) {
            insertOrAppendPlacementNodeIntoContainer(child, before, parent);
            for (var sibling = child.sibling; sibling !== null; )
              insertOrAppendPlacementNodeIntoContainer(sibling, before, parent), sibling = sibling.sibling;
          }
        }
      }
      function insertOrAppendPlacementNode(node, before, parent) {
        var tag = node.tag, isHost = tag === HostComponent || tag === HostText;
        if (isHost) {
          var stateNode = node.stateNode;
          before ? insertBefore(parent, stateNode, before) : appendChild(parent, stateNode);
        } else if (tag !== HostPortal) {
          var child = node.child;
          if (child !== null) {
            insertOrAppendPlacementNode(child, before, parent);
            for (var sibling = child.sibling; sibling !== null; )
              insertOrAppendPlacementNode(sibling, before, parent), sibling = sibling.sibling;
          }
        }
      }
      var hostParent = null, hostParentIsContainer = !1;
      function commitDeletionEffects(root2, returnFiber, deletedFiber) {
        {
          var parent = returnFiber;
          findParent:
            for (; parent !== null; ) {
              switch (parent.tag) {
                case HostComponent: {
                  hostParent = parent.stateNode, hostParentIsContainer = !1;
                  break findParent;
                }
                case HostRoot: {
                  hostParent = parent.stateNode.containerInfo, hostParentIsContainer = !0;
                  break findParent;
                }
                case HostPortal: {
                  hostParent = parent.stateNode.containerInfo, hostParentIsContainer = !0;
                  break findParent;
                }
              }
              parent = parent.return;
            }
          if (hostParent === null)
            throw new Error("Expected to find a host parent. This error is likely caused by a bug in React. Please file an issue.");
          commitDeletionEffectsOnFiber(root2, returnFiber, deletedFiber), hostParent = null, hostParentIsContainer = !1;
        }
        detachFiberMutation(deletedFiber);
      }
      function recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, parent) {
        for (var child = parent.child; child !== null; )
          commitDeletionEffectsOnFiber(finishedRoot, nearestMountedAncestor, child), child = child.sibling;
      }
      function commitDeletionEffectsOnFiber(finishedRoot, nearestMountedAncestor, deletedFiber) {
        switch (onCommitUnmount(deletedFiber), deletedFiber.tag) {
          case HostComponent:
            offscreenSubtreeWasHidden || safelyDetachRef(deletedFiber, nearestMountedAncestor);
          case HostText: {
            {
              var prevHostParent = hostParent, prevHostParentIsContainer = hostParentIsContainer;
              hostParent = null, recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, deletedFiber), hostParent = prevHostParent, hostParentIsContainer = prevHostParentIsContainer, hostParent !== null && (hostParentIsContainer ? removeChildFromContainer(hostParent, deletedFiber.stateNode) : removeChild(hostParent, deletedFiber.stateNode));
            }
            return;
          }
          case DehydratedFragment: {
            hostParent !== null && (hostParentIsContainer ? clearSuspenseBoundaryFromContainer(hostParent, deletedFiber.stateNode) : clearSuspenseBoundary(hostParent, deletedFiber.stateNode));
            return;
          }
          case HostPortal: {
            {
              var _prevHostParent = hostParent, _prevHostParentIsContainer = hostParentIsContainer;
              hostParent = deletedFiber.stateNode.containerInfo, hostParentIsContainer = !0, recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, deletedFiber), hostParent = _prevHostParent, hostParentIsContainer = _prevHostParentIsContainer;
            }
            return;
          }
          case FunctionComponent:
          case ForwardRef:
          case MemoComponent:
          case SimpleMemoComponent: {
            if (!offscreenSubtreeWasHidden) {
              var updateQueue = deletedFiber.updateQueue;
              if (updateQueue !== null) {
                var lastEffect = updateQueue.lastEffect;
                if (lastEffect !== null) {
                  var firstEffect = lastEffect.next, effect = firstEffect;
                  do {
                    var _effect = effect, destroy = _effect.destroy, tag = _effect.tag;
                    destroy !== void 0 && ((tag & Insertion) !== NoFlags$1 ? safelyCallDestroy(deletedFiber, nearestMountedAncestor, destroy) : (tag & Layout) !== NoFlags$1 && (markComponentLayoutEffectUnmountStarted(deletedFiber), deletedFiber.mode & ProfileMode ? (startLayoutEffectTimer(), safelyCallDestroy(deletedFiber, nearestMountedAncestor, destroy), recordLayoutEffectDuration(deletedFiber)) : safelyCallDestroy(deletedFiber, nearestMountedAncestor, destroy), markComponentLayoutEffectUnmountStopped())), effect = effect.next;
                  } while (effect !== firstEffect);
                }
              }
            }
            recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, deletedFiber);
            return;
          }
          case ClassComponent: {
            if (!offscreenSubtreeWasHidden) {
              safelyDetachRef(deletedFiber, nearestMountedAncestor);
              var instance = deletedFiber.stateNode;
              typeof instance.componentWillUnmount == "function" && safelyCallComponentWillUnmount(deletedFiber, nearestMountedAncestor, instance);
            }
            recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, deletedFiber);
            return;
          }
          case ScopeComponent: {
            recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, deletedFiber);
            return;
          }
          case OffscreenComponent: {
            if (
              // TODO: Remove this dead flag
              deletedFiber.mode & ConcurrentMode
            ) {
              var prevOffscreenSubtreeWasHidden = offscreenSubtreeWasHidden;
              offscreenSubtreeWasHidden = prevOffscreenSubtreeWasHidden || deletedFiber.memoizedState !== null, recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, deletedFiber), offscreenSubtreeWasHidden = prevOffscreenSubtreeWasHidden;
            } else
              recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, deletedFiber);
            break;
          }
          default: {
            recursivelyTraverseDeletionEffects(finishedRoot, nearestMountedAncestor, deletedFiber);
            return;
          }
        }
      }
      function commitSuspenseCallback(finishedWork) {
        var newState = finishedWork.memoizedState;
      }
      function commitSuspenseHydrationCallbacks(finishedRoot, finishedWork) {
        var newState = finishedWork.memoizedState;
        if (newState === null) {
          var current2 = finishedWork.alternate;
          if (current2 !== null) {
            var prevState = current2.memoizedState;
            if (prevState !== null) {
              var suspenseInstance = prevState.dehydrated;
              suspenseInstance !== null && commitHydratedSuspenseInstance(suspenseInstance);
            }
          }
        }
      }
      function attachSuspenseRetryListeners(finishedWork) {
        var wakeables = finishedWork.updateQueue;
        if (wakeables !== null) {
          finishedWork.updateQueue = null;
          var retryCache = finishedWork.stateNode;
          retryCache === null && (retryCache = finishedWork.stateNode = new PossiblyWeakSet()), wakeables.forEach(function(wakeable) {
            var retry = resolveRetryWakeable.bind(null, finishedWork, wakeable);
            if (!retryCache.has(wakeable)) {
              if (retryCache.add(wakeable), isDevToolsPresent)
                if (inProgressLanes !== null && inProgressRoot !== null)
                  restorePendingUpdaters(inProgressRoot, inProgressLanes);
                else
                  throw Error("Expected finished root and lanes to be set. This is a bug in React.");
              wakeable.then(retry, retry);
            }
          });
        }
      }
      function commitMutationEffects(root2, finishedWork, committedLanes) {
        inProgressLanes = committedLanes, inProgressRoot = root2, setCurrentFiber(finishedWork), commitMutationEffectsOnFiber(finishedWork, root2), setCurrentFiber(finishedWork), inProgressLanes = null, inProgressRoot = null;
      }
      function recursivelyTraverseMutationEffects(root2, parentFiber, lanes) {
        var deletions = parentFiber.deletions;
        if (deletions !== null)
          for (var i = 0; i < deletions.length; i++) {
            var childToDelete = deletions[i];
            try {
              commitDeletionEffects(root2, parentFiber, childToDelete);
            } catch (error2) {
              captureCommitPhaseError(childToDelete, parentFiber, error2);
            }
          }
        var prevDebugFiber = getCurrentFiber();
        if (parentFiber.subtreeFlags & MutationMask)
          for (var child = parentFiber.child; child !== null; )
            setCurrentFiber(child), commitMutationEffectsOnFiber(child, root2), child = child.sibling;
        setCurrentFiber(prevDebugFiber);
      }
      function commitMutationEffectsOnFiber(finishedWork, root2, lanes) {
        var current2 = finishedWork.alternate, flags = finishedWork.flags;
        switch (finishedWork.tag) {
          case FunctionComponent:
          case ForwardRef:
          case MemoComponent:
          case SimpleMemoComponent: {
            if (recursivelyTraverseMutationEffects(root2, finishedWork), commitReconciliationEffects(finishedWork), flags & Update) {
              try {
                commitHookEffectListUnmount(Insertion | HasEffect, finishedWork, finishedWork.return), commitHookEffectListMount(Insertion | HasEffect, finishedWork);
              } catch (error2) {
                captureCommitPhaseError(finishedWork, finishedWork.return, error2);
              }
              if (finishedWork.mode & ProfileMode) {
                try {
                  startLayoutEffectTimer(), commitHookEffectListUnmount(Layout | HasEffect, finishedWork, finishedWork.return);
                } catch (error2) {
                  captureCommitPhaseError(finishedWork, finishedWork.return, error2);
                }
                recordLayoutEffectDuration(finishedWork);
              } else
                try {
                  commitHookEffectListUnmount(Layout | HasEffect, finishedWork, finishedWork.return);
                } catch (error2) {
                  captureCommitPhaseError(finishedWork, finishedWork.return, error2);
                }
            }
            return;
          }
          case ClassComponent: {
            recursivelyTraverseMutationEffects(root2, finishedWork), commitReconciliationEffects(finishedWork), flags & Ref && current2 !== null && safelyDetachRef(current2, current2.return);
            return;
          }
          case HostComponent: {
            recursivelyTraverseMutationEffects(root2, finishedWork), commitReconciliationEffects(finishedWork), flags & Ref && current2 !== null && safelyDetachRef(current2, current2.return);
            {
              if (finishedWork.flags & ContentReset) {
                var instance = finishedWork.stateNode;
                try {
                  resetTextContent(instance);
                } catch (error2) {
                  captureCommitPhaseError(finishedWork, finishedWork.return, error2);
                }
              }
              if (flags & Update) {
                var _instance4 = finishedWork.stateNode;
                if (_instance4 != null) {
                  var newProps = finishedWork.memoizedProps, oldProps = current2 !== null ? current2.memoizedProps : newProps, type = finishedWork.type, updatePayload = finishedWork.updateQueue;
                  if (finishedWork.updateQueue = null, updatePayload !== null)
                    try {
                      commitUpdate(_instance4, updatePayload, type, oldProps, newProps, finishedWork);
                    } catch (error2) {
                      captureCommitPhaseError(finishedWork, finishedWork.return, error2);
                    }
                }
              }
            }
            return;
          }
          case HostText: {
            if (recursivelyTraverseMutationEffects(root2, finishedWork), commitReconciliationEffects(finishedWork), flags & Update) {
              if (finishedWork.stateNode === null)
                throw new Error("This should have a text node initialized. This error is likely caused by a bug in React. Please file an issue.");
              var textInstance = finishedWork.stateNode, newText = finishedWork.memoizedProps, oldText = current2 !== null ? current2.memoizedProps : newText;
              try {
                commitTextUpdate(textInstance, oldText, newText);
              } catch (error2) {
                captureCommitPhaseError(finishedWork, finishedWork.return, error2);
              }
            }
            return;
          }
          case HostRoot: {
            if (recursivelyTraverseMutationEffects(root2, finishedWork), commitReconciliationEffects(finishedWork), flags & Update && current2 !== null) {
              var prevRootState = current2.memoizedState;
              if (prevRootState.isDehydrated)
                try {
                  commitHydratedContainer(root2.containerInfo);
                } catch (error2) {
                  captureCommitPhaseError(finishedWork, finishedWork.return, error2);
                }
            }
            return;
          }
          case HostPortal: {
            recursivelyTraverseMutationEffects(root2, finishedWork), commitReconciliationEffects(finishedWork);
            return;
          }
          case SuspenseComponent: {
            recursivelyTraverseMutationEffects(root2, finishedWork), commitReconciliationEffects(finishedWork);
            var offscreenFiber = finishedWork.child;
            if (offscreenFiber.flags & Visibility) {
              var offscreenInstance = offscreenFiber.stateNode, newState = offscreenFiber.memoizedState, isHidden = newState !== null;
              if (offscreenInstance.isHidden = isHidden, isHidden) {
                var wasHidden = offscreenFiber.alternate !== null && offscreenFiber.alternate.memoizedState !== null;
                wasHidden || markCommitTimeOfFallback();
              }
            }
            if (flags & Update) {
              try {
                commitSuspenseCallback(finishedWork);
              } catch (error2) {
                captureCommitPhaseError(finishedWork, finishedWork.return, error2);
              }
              attachSuspenseRetryListeners(finishedWork);
            }
            return;
          }
          case OffscreenComponent: {
            var _wasHidden = current2 !== null && current2.memoizedState !== null;
            if (
              // TODO: Remove this dead flag
              finishedWork.mode & ConcurrentMode
            ) {
              var prevOffscreenSubtreeWasHidden = offscreenSubtreeWasHidden;
              offscreenSubtreeWasHidden = prevOffscreenSubtreeWasHidden || _wasHidden, recursivelyTraverseMutationEffects(root2, finishedWork), offscreenSubtreeWasHidden = prevOffscreenSubtreeWasHidden;
            } else
              recursivelyTraverseMutationEffects(root2, finishedWork);
            if (commitReconciliationEffects(finishedWork), flags & Visibility) {
              var _offscreenInstance = finishedWork.stateNode, _newState = finishedWork.memoizedState, _isHidden = _newState !== null, offscreenBoundary = finishedWork;
              if (_offscreenInstance.isHidden = _isHidden, _isHidden && !_wasHidden && (offscreenBoundary.mode & ConcurrentMode) !== NoMode) {
                nextEffect = offscreenBoundary;
                for (var offscreenChild = offscreenBoundary.child; offscreenChild !== null; )
                  nextEffect = offscreenChild, disappearLayoutEffects_begin(offscreenChild), offscreenChild = offscreenChild.sibling;
              }
              hideOrUnhideAllChildren(offscreenBoundary, _isHidden);
            }
            return;
          }
          case SuspenseListComponent: {
            recursivelyTraverseMutationEffects(root2, finishedWork), commitReconciliationEffects(finishedWork), flags & Update && attachSuspenseRetryListeners(finishedWork);
            return;
          }
          case ScopeComponent:
            return;
          default: {
            recursivelyTraverseMutationEffects(root2, finishedWork), commitReconciliationEffects(finishedWork);
            return;
          }
        }
      }
      function commitReconciliationEffects(finishedWork) {
        var flags = finishedWork.flags;
        if (flags & Placement) {
          try {
            commitPlacement(finishedWork);
          } catch (error2) {
            captureCommitPhaseError(finishedWork, finishedWork.return, error2);
          }
          finishedWork.flags &= ~Placement;
        }
        flags & Hydrating && (finishedWork.flags &= ~Hydrating);
      }
      function commitLayoutEffects(finishedWork, root2, committedLanes) {
        inProgressLanes = committedLanes, inProgressRoot = root2, nextEffect = finishedWork, commitLayoutEffects_begin(finishedWork, root2, committedLanes), inProgressLanes = null, inProgressRoot = null;
      }
      function commitLayoutEffects_begin(subtreeRoot, root2, committedLanes) {
        for (var isModernRoot = (subtreeRoot.mode & ConcurrentMode) !== NoMode; nextEffect !== null; ) {
          var fiber = nextEffect, firstChild = fiber.child;
          if (fiber.tag === OffscreenComponent && isModernRoot) {
            var isHidden = fiber.memoizedState !== null, newOffscreenSubtreeIsHidden = isHidden || offscreenSubtreeIsHidden;
            if (newOffscreenSubtreeIsHidden) {
              commitLayoutMountEffects_complete(subtreeRoot, root2, committedLanes);
              continue;
            } else {
              var current2 = fiber.alternate, wasHidden = current2 !== null && current2.memoizedState !== null, newOffscreenSubtreeWasHidden = wasHidden || offscreenSubtreeWasHidden, prevOffscreenSubtreeIsHidden = offscreenSubtreeIsHidden, prevOffscreenSubtreeWasHidden = offscreenSubtreeWasHidden;
              offscreenSubtreeIsHidden = newOffscreenSubtreeIsHidden, offscreenSubtreeWasHidden = newOffscreenSubtreeWasHidden, offscreenSubtreeWasHidden && !prevOffscreenSubtreeWasHidden && (nextEffect = fiber, reappearLayoutEffects_begin(fiber));
              for (var child = firstChild; child !== null; )
                nextEffect = child, commitLayoutEffects_begin(
                  child,
                  // New root; bubble back up to here and stop.
                  root2,
                  committedLanes
                ), child = child.sibling;
              nextEffect = fiber, offscreenSubtreeIsHidden = prevOffscreenSubtreeIsHidden, offscreenSubtreeWasHidden = prevOffscreenSubtreeWasHidden, commitLayoutMountEffects_complete(subtreeRoot, root2, committedLanes);
              continue;
            }
          }
          (fiber.subtreeFlags & LayoutMask) !== NoFlags && firstChild !== null ? (firstChild.return = fiber, nextEffect = firstChild) : commitLayoutMountEffects_complete(subtreeRoot, root2, committedLanes);
        }
      }
      function commitLayoutMountEffects_complete(subtreeRoot, root2, committedLanes) {
        for (; nextEffect !== null; ) {
          var fiber = nextEffect;
          if ((fiber.flags & LayoutMask) !== NoFlags) {
            var current2 = fiber.alternate;
            setCurrentFiber(fiber);
            try {
              commitLayoutEffectOnFiber(root2, current2, fiber, committedLanes);
            } catch (error2) {
              captureCommitPhaseError(fiber, fiber.return, error2);
            }
            resetCurrentFiber();
          }
          if (fiber === subtreeRoot) {
            nextEffect = null;
            return;
          }
          var sibling = fiber.sibling;
          if (sibling !== null) {
            sibling.return = fiber.return, nextEffect = sibling;
            return;
          }
          nextEffect = fiber.return;
        }
      }
      function disappearLayoutEffects_begin(subtreeRoot) {
        for (; nextEffect !== null; ) {
          var fiber = nextEffect, firstChild = fiber.child;
          switch (fiber.tag) {
            case FunctionComponent:
            case ForwardRef:
            case MemoComponent:
            case SimpleMemoComponent: {
              if (fiber.mode & ProfileMode)
                try {
                  startLayoutEffectTimer(), commitHookEffectListUnmount(Layout, fiber, fiber.return);
                } finally {
                  recordLayoutEffectDuration(fiber);
                }
              else
                commitHookEffectListUnmount(Layout, fiber, fiber.return);
              break;
            }
            case ClassComponent: {
              safelyDetachRef(fiber, fiber.return);
              var instance = fiber.stateNode;
              typeof instance.componentWillUnmount == "function" && safelyCallComponentWillUnmount(fiber, fiber.return, instance);
              break;
            }
            case HostComponent: {
              safelyDetachRef(fiber, fiber.return);
              break;
            }
            case OffscreenComponent: {
              var isHidden = fiber.memoizedState !== null;
              if (isHidden) {
                disappearLayoutEffects_complete(subtreeRoot);
                continue;
              }
              break;
            }
          }
          firstChild !== null ? (firstChild.return = fiber, nextEffect = firstChild) : disappearLayoutEffects_complete(subtreeRoot);
        }
      }
      function disappearLayoutEffects_complete(subtreeRoot) {
        for (; nextEffect !== null; ) {
          var fiber = nextEffect;
          if (fiber === subtreeRoot) {
            nextEffect = null;
            return;
          }
          var sibling = fiber.sibling;
          if (sibling !== null) {
            sibling.return = fiber.return, nextEffect = sibling;
            return;
          }
          nextEffect = fiber.return;
        }
      }
      function reappearLayoutEffects_begin(subtreeRoot) {
        for (; nextEffect !== null; ) {
          var fiber = nextEffect, firstChild = fiber.child;
          if (fiber.tag === OffscreenComponent) {
            var isHidden = fiber.memoizedState !== null;
            if (isHidden) {
              reappearLayoutEffects_complete(subtreeRoot);
              continue;
            }
          }
          firstChild !== null ? (firstChild.return = fiber, nextEffect = firstChild) : reappearLayoutEffects_complete(subtreeRoot);
        }
      }
      function reappearLayoutEffects_complete(subtreeRoot) {
        for (; nextEffect !== null; ) {
          var fiber = nextEffect;
          setCurrentFiber(fiber);
          try {
            reappearLayoutEffectsOnFiber(fiber);
          } catch (error2) {
            captureCommitPhaseError(fiber, fiber.return, error2);
          }
          if (resetCurrentFiber(), fiber === subtreeRoot) {
            nextEffect = null;
            return;
          }
          var sibling = fiber.sibling;
          if (sibling !== null) {
            sibling.return = fiber.return, nextEffect = sibling;
            return;
          }
          nextEffect = fiber.return;
        }
      }
      function commitPassiveMountEffects(root2, finishedWork, committedLanes, committedTransitions) {
        nextEffect = finishedWork, commitPassiveMountEffects_begin(finishedWork, root2, committedLanes, committedTransitions);
      }
      function commitPassiveMountEffects_begin(subtreeRoot, root2, committedLanes, committedTransitions) {
        for (; nextEffect !== null; ) {
          var fiber = nextEffect, firstChild = fiber.child;
          (fiber.subtreeFlags & PassiveMask) !== NoFlags && firstChild !== null ? (firstChild.return = fiber, nextEffect = firstChild) : commitPassiveMountEffects_complete(subtreeRoot, root2, committedLanes, committedTransitions);
        }
      }
      function commitPassiveMountEffects_complete(subtreeRoot, root2, committedLanes, committedTransitions) {
        for (; nextEffect !== null; ) {
          var fiber = nextEffect;
          if ((fiber.flags & Passive) !== NoFlags) {
            setCurrentFiber(fiber);
            try {
              commitPassiveMountOnFiber(root2, fiber, committedLanes, committedTransitions);
            } catch (error2) {
              captureCommitPhaseError(fiber, fiber.return, error2);
            }
            resetCurrentFiber();
          }
          if (fiber === subtreeRoot) {
            nextEffect = null;
            return;
          }
          var sibling = fiber.sibling;
          if (sibling !== null) {
            sibling.return = fiber.return, nextEffect = sibling;
            return;
          }
          nextEffect = fiber.return;
        }
      }
      function commitPassiveMountOnFiber(finishedRoot, finishedWork, committedLanes, committedTransitions) {
        switch (finishedWork.tag) {
          case FunctionComponent:
          case ForwardRef:
          case SimpleMemoComponent: {
            if (finishedWork.mode & ProfileMode) {
              startPassiveEffectTimer();
              try {
                commitHookEffectListMount(Passive$1 | HasEffect, finishedWork);
              } finally {
                recordPassiveEffectDuration(finishedWork);
              }
            } else
              commitHookEffectListMount(Passive$1 | HasEffect, finishedWork);
            break;
          }
        }
      }
      function commitPassiveUnmountEffects(firstChild) {
        nextEffect = firstChild, commitPassiveUnmountEffects_begin();
      }
      function commitPassiveUnmountEffects_begin() {
        for (; nextEffect !== null; ) {
          var fiber = nextEffect, child = fiber.child;
          if ((nextEffect.flags & ChildDeletion) !== NoFlags) {
            var deletions = fiber.deletions;
            if (deletions !== null) {
              for (var i = 0; i < deletions.length; i++) {
                var fiberToDelete = deletions[i];
                nextEffect = fiberToDelete, commitPassiveUnmountEffectsInsideOfDeletedTree_begin(fiberToDelete, fiber);
              }
              {
                var previousFiber = fiber.alternate;
                if (previousFiber !== null) {
                  var detachedChild = previousFiber.child;
                  if (detachedChild !== null) {
                    previousFiber.child = null;
                    do {
                      var detachedSibling = detachedChild.sibling;
                      detachedChild.sibling = null, detachedChild = detachedSibling;
                    } while (detachedChild !== null);
                  }
                }
              }
              nextEffect = fiber;
            }
          }
          (fiber.subtreeFlags & PassiveMask) !== NoFlags && child !== null ? (child.return = fiber, nextEffect = child) : commitPassiveUnmountEffects_complete();
        }
      }
      function commitPassiveUnmountEffects_complete() {
        for (; nextEffect !== null; ) {
          var fiber = nextEffect;
          (fiber.flags & Passive) !== NoFlags && (setCurrentFiber(fiber), commitPassiveUnmountOnFiber(fiber), resetCurrentFiber());
          var sibling = fiber.sibling;
          if (sibling !== null) {
            sibling.return = fiber.return, nextEffect = sibling;
            return;
          }
          nextEffect = fiber.return;
        }
      }
      function commitPassiveUnmountOnFiber(finishedWork) {
        switch (finishedWork.tag) {
          case FunctionComponent:
          case ForwardRef:
          case SimpleMemoComponent: {
            finishedWork.mode & ProfileMode ? (startPassiveEffectTimer(), commitHookEffectListUnmount(Passive$1 | HasEffect, finishedWork, finishedWork.return), recordPassiveEffectDuration(finishedWork)) : commitHookEffectListUnmount(Passive$1 | HasEffect, finishedWork, finishedWork.return);
            break;
          }
        }
      }
      function commitPassiveUnmountEffectsInsideOfDeletedTree_begin(deletedSubtreeRoot, nearestMountedAncestor) {
        for (; nextEffect !== null; ) {
          var fiber = nextEffect;
          setCurrentFiber(fiber), commitPassiveUnmountInsideDeletedTreeOnFiber(fiber, nearestMountedAncestor), resetCurrentFiber();
          var child = fiber.child;
          child !== null ? (child.return = fiber, nextEffect = child) : commitPassiveUnmountEffectsInsideOfDeletedTree_complete(deletedSubtreeRoot);
        }
      }
      function commitPassiveUnmountEffectsInsideOfDeletedTree_complete(deletedSubtreeRoot) {
        for (; nextEffect !== null; ) {
          var fiber = nextEffect, sibling = fiber.sibling, returnFiber = fiber.return;
          if (detachFiberAfterEffects(fiber), fiber === deletedSubtreeRoot) {
            nextEffect = null;
            return;
          }
          if (sibling !== null) {
            sibling.return = returnFiber, nextEffect = sibling;
            return;
          }
          nextEffect = returnFiber;
        }
      }
      function commitPassiveUnmountInsideDeletedTreeOnFiber(current2, nearestMountedAncestor) {
        switch (current2.tag) {
          case FunctionComponent:
          case ForwardRef:
          case SimpleMemoComponent: {
            current2.mode & ProfileMode ? (startPassiveEffectTimer(), commitHookEffectListUnmount(Passive$1, current2, nearestMountedAncestor), recordPassiveEffectDuration(current2)) : commitHookEffectListUnmount(Passive$1, current2, nearestMountedAncestor);
            break;
          }
        }
      }
      function invokeLayoutEffectMountInDEV(fiber) {
        switch (fiber.tag) {
          case FunctionComponent:
          case ForwardRef:
          case SimpleMemoComponent: {
            try {
              commitHookEffectListMount(Layout | HasEffect, fiber);
            } catch (error2) {
              captureCommitPhaseError(fiber, fiber.return, error2);
            }
            break;
          }
          case ClassComponent: {
            var instance = fiber.stateNode;
            try {
              instance.componentDidMount();
            } catch (error2) {
              captureCommitPhaseError(fiber, fiber.return, error2);
            }
            break;
          }
        }
      }
      function invokePassiveEffectMountInDEV(fiber) {
        switch (fiber.tag) {
          case FunctionComponent:
          case ForwardRef:
          case SimpleMemoComponent: {
            try {
              commitHookEffectListMount(Passive$1 | HasEffect, fiber);
            } catch (error2) {
              captureCommitPhaseError(fiber, fiber.return, error2);
            }
            break;
          }
        }
      }
      function invokeLayoutEffectUnmountInDEV(fiber) {
        switch (fiber.tag) {
          case FunctionComponent:
          case ForwardRef:
          case SimpleMemoComponent: {
            try {
              commitHookEffectListUnmount(Layout | HasEffect, fiber, fiber.return);
            } catch (error2) {
              captureCommitPhaseError(fiber, fiber.return, error2);
            }
            break;
          }
          case ClassComponent: {
            var instance = fiber.stateNode;
            typeof instance.componentWillUnmount == "function" && safelyCallComponentWillUnmount(fiber, fiber.return, instance);
            break;
          }
        }
      }
      function invokePassiveEffectUnmountInDEV(fiber) {
        switch (fiber.tag) {
          case FunctionComponent:
          case ForwardRef:
          case SimpleMemoComponent:
            try {
              commitHookEffectListUnmount(Passive$1 | HasEffect, fiber, fiber.return);
            } catch (error2) {
              captureCommitPhaseError(fiber, fiber.return, error2);
            }
        }
      }
      var COMPONENT_TYPE = 0, HAS_PSEUDO_CLASS_TYPE = 1, ROLE_TYPE = 2, TEST_NAME_TYPE = 3, TEXT_TYPE = 4;
      if (typeof Symbol == "function" && Symbol.for) {
        var symbolFor = Symbol.for;
        COMPONENT_TYPE = symbolFor("selector.component"), HAS_PSEUDO_CLASS_TYPE = symbolFor("selector.has_pseudo_class"), ROLE_TYPE = symbolFor("selector.role"), TEST_NAME_TYPE = symbolFor("selector.test_id"), TEXT_TYPE = symbolFor("selector.text");
      }
      var commitHooks = [];
      function onCommitRoot$1() {
        commitHooks.forEach(function(commitHook) {
          return commitHook();
        });
      }
      var ReactCurrentActQueue = ReactSharedInternals.ReactCurrentActQueue;
      function isLegacyActEnvironment(fiber) {
        {
          var isReactActEnvironmentGlobal = (
            // $FlowExpectedError – Flow doesn't know about IS_REACT_ACT_ENVIRONMENT global
            typeof IS_REACT_ACT_ENVIRONMENT < "u" ? IS_REACT_ACT_ENVIRONMENT : void 0
          ), jestIsDefined = typeof jest < "u";
          return jestIsDefined && isReactActEnvironmentGlobal !== !1;
        }
      }
      function isConcurrentActEnvironment() {
        {
          var isReactActEnvironmentGlobal = (
            // $FlowExpectedError – Flow doesn't know about IS_REACT_ACT_ENVIRONMENT global
            typeof IS_REACT_ACT_ENVIRONMENT < "u" ? IS_REACT_ACT_ENVIRONMENT : void 0
          );
          return !isReactActEnvironmentGlobal && ReactCurrentActQueue.current !== null && error("The current testing environment is not configured to support act(...)"), isReactActEnvironmentGlobal;
        }
      }
      var ceil = Math.ceil, ReactCurrentDispatcher$2 = ReactSharedInternals.ReactCurrentDispatcher, ReactCurrentOwner$2 = ReactSharedInternals.ReactCurrentOwner, ReactCurrentBatchConfig$3 = ReactSharedInternals.ReactCurrentBatchConfig, ReactCurrentActQueue$1 = ReactSharedInternals.ReactCurrentActQueue, NoContext = (
        /*             */
        0
      ), BatchedContext = (
        /*               */
        1
      ), RenderContext = (
        /*                */
        2
      ), CommitContext = (
        /*                */
        4
      ), RootInProgress = 0, RootFatalErrored = 1, RootErrored = 2, RootSuspended = 3, RootSuspendedWithDelay = 4, RootCompleted = 5, RootDidNotComplete = 6, executionContext = NoContext, workInProgressRoot = null, workInProgress = null, workInProgressRootRenderLanes = NoLanes, subtreeRenderLanes = NoLanes, subtreeRenderLanesCursor = createCursor(NoLanes), workInProgressRootExitStatus = RootInProgress, workInProgressRootFatalError = null, workInProgressRootIncludedLanes = NoLanes, workInProgressRootSkippedLanes = NoLanes, workInProgressRootInterleavedUpdatedLanes = NoLanes, workInProgressRootPingedLanes = NoLanes, workInProgressRootConcurrentErrors = null, workInProgressRootRecoverableErrors = null, globalMostRecentFallbackTime = 0, FALLBACK_THROTTLE_MS = 500, workInProgressRootRenderTargetTime = 1 / 0, RENDER_TIMEOUT_MS = 500, workInProgressTransitions = null;
      function resetRenderTimer() {
        workInProgressRootRenderTargetTime = now() + RENDER_TIMEOUT_MS;
      }
      function getRenderTargetTime() {
        return workInProgressRootRenderTargetTime;
      }
      var hasUncaughtError = !1, firstUncaughtError = null, legacyErrorBoundariesThatAlreadyFailed = null, rootDoesHavePassiveEffects = !1, rootWithPendingPassiveEffects = null, pendingPassiveEffectsLanes = NoLanes, pendingPassiveProfilerEffects = [], pendingPassiveTransitions = null, NESTED_UPDATE_LIMIT = 50, nestedUpdateCount = 0, rootWithNestedUpdates = null, isFlushingPassiveEffects = !1, didScheduleUpdateDuringPassiveEffects = !1, NESTED_PASSIVE_UPDATE_LIMIT = 50, nestedPassiveUpdateCount = 0, rootWithPassiveNestedUpdates = null, currentEventTime = NoTimestamp, currentEventTransitionLane = NoLanes, isRunningInsertionEffect = !1;
      function getWorkInProgressRoot() {
        return workInProgressRoot;
      }
      function requestEventTime() {
        return (executionContext & (RenderContext | CommitContext)) !== NoContext ? now() : (currentEventTime !== NoTimestamp || (currentEventTime = now()), currentEventTime);
      }
      function requestUpdateLane(fiber) {
        var mode = fiber.mode;
        if ((mode & ConcurrentMode) === NoMode)
          return SyncLane;
        if ((executionContext & RenderContext) !== NoContext && workInProgressRootRenderLanes !== NoLanes)
          return pickArbitraryLane(workInProgressRootRenderLanes);
        var isTransition = requestCurrentTransition() !== NoTransition;
        if (isTransition) {
          if (ReactCurrentBatchConfig$3.transition !== null) {
            var transition = ReactCurrentBatchConfig$3.transition;
            transition._updatedFibers || (transition._updatedFibers = /* @__PURE__ */ new Set()), transition._updatedFibers.add(fiber);
          }
          return currentEventTransitionLane === NoLane && (currentEventTransitionLane = claimNextTransitionLane()), currentEventTransitionLane;
        }
        var updateLane = getCurrentUpdatePriority();
        if (updateLane !== NoLane)
          return updateLane;
        var eventLane = getCurrentEventPriority();
        return eventLane;
      }
      function requestRetryLane(fiber) {
        var mode = fiber.mode;
        return (mode & ConcurrentMode) === NoMode ? SyncLane : claimNextRetryLane();
      }
      function scheduleUpdateOnFiber(root2, fiber, lane, eventTime) {
        checkForNestedUpdates(), isRunningInsertionEffect && error("useInsertionEffect must not schedule updates."), isFlushingPassiveEffects && (didScheduleUpdateDuringPassiveEffects = !0), markRootUpdated(root2, lane, eventTime), (executionContext & RenderContext) !== NoLanes && root2 === workInProgressRoot ? warnAboutRenderPhaseUpdatesInDEV(fiber) : (isDevToolsPresent && addFiberToLanesMap(root2, fiber, lane), warnIfUpdatesNotWrappedWithActDEV(fiber), root2 === workInProgressRoot && ((executionContext & RenderContext) === NoContext && (workInProgressRootInterleavedUpdatedLanes = mergeLanes(workInProgressRootInterleavedUpdatedLanes, lane)), workInProgressRootExitStatus === RootSuspendedWithDelay && markRootSuspended$1(root2, workInProgressRootRenderLanes)), ensureRootIsScheduled(root2, eventTime), lane === SyncLane && executionContext === NoContext && (fiber.mode & ConcurrentMode) === NoMode && // Treat `act` as if it's inside `batchedUpdates`, even in legacy mode.
        !ReactCurrentActQueue$1.isBatchingLegacy && (resetRenderTimer(), flushSyncCallbacksOnlyInLegacyMode()));
      }
      function scheduleInitialHydrationOnRoot(root2, lane, eventTime) {
        var current2 = root2.current;
        current2.lanes = lane, markRootUpdated(root2, lane, eventTime), ensureRootIsScheduled(root2, eventTime);
      }
      function isUnsafeClassRenderPhaseUpdate(fiber) {
        return (
          // TODO: Remove outdated deferRenderPhaseUpdateToNextBatch experiment. We
          // decided not to enable it.
          (executionContext & RenderContext) !== NoContext
        );
      }
      function ensureRootIsScheduled(root2, currentTime) {
        var existingCallbackNode = root2.callbackNode;
        markStarvedLanesAsExpired(root2, currentTime);
        var nextLanes = getNextLanes(root2, root2 === workInProgressRoot ? workInProgressRootRenderLanes : NoLanes);
        if (nextLanes === NoLanes) {
          existingCallbackNode !== null && cancelCallback$1(existingCallbackNode), root2.callbackNode = null, root2.callbackPriority = NoLane;
          return;
        }
        var newCallbackPriority = getHighestPriorityLane(nextLanes), existingCallbackPriority = root2.callbackPriority;
        if (existingCallbackPriority === newCallbackPriority && // Special case related to `act`. If the currently scheduled task is a
        // Scheduler task, rather than an `act` task, cancel it and re-scheduled
        // on the `act` queue.
        !(ReactCurrentActQueue$1.current !== null && existingCallbackNode !== fakeActCallbackNode)) {
          existingCallbackNode == null && existingCallbackPriority !== SyncLane && error("Expected scheduled callback to exist. This error is likely caused by a bug in React. Please file an issue.");
          return;
        }
        existingCallbackNode != null && cancelCallback$1(existingCallbackNode);
        var newCallbackNode;
        if (newCallbackPriority === SyncLane)
          root2.tag === LegacyRoot ? (ReactCurrentActQueue$1.isBatchingLegacy !== null && (ReactCurrentActQueue$1.didScheduleLegacyUpdate = !0), scheduleLegacySyncCallback(performSyncWorkOnRoot.bind(null, root2))) : scheduleSyncCallback(performSyncWorkOnRoot.bind(null, root2)), ReactCurrentActQueue$1.current !== null ? ReactCurrentActQueue$1.current.push(flushSyncCallbacks) : scheduleMicrotask(function() {
            (executionContext & (RenderContext | CommitContext)) === NoContext && flushSyncCallbacks();
          }), newCallbackNode = null;
        else {
          var schedulerPriorityLevel;
          switch (lanesToEventPriority(nextLanes)) {
            case DiscreteEventPriority:
              schedulerPriorityLevel = ImmediatePriority;
              break;
            case ContinuousEventPriority:
              schedulerPriorityLevel = UserBlockingPriority;
              break;
            case DefaultEventPriority:
              schedulerPriorityLevel = NormalPriority;
              break;
            case IdleEventPriority:
              schedulerPriorityLevel = IdlePriority;
              break;
            default:
              schedulerPriorityLevel = NormalPriority;
              break;
          }
          newCallbackNode = scheduleCallback$1(schedulerPriorityLevel, performConcurrentWorkOnRoot.bind(null, root2));
        }
        root2.callbackPriority = newCallbackPriority, root2.callbackNode = newCallbackNode;
      }
      function performConcurrentWorkOnRoot(root2, didTimeout) {
        if (resetNestedUpdateFlag(), currentEventTime = NoTimestamp, currentEventTransitionLane = NoLanes, (executionContext & (RenderContext | CommitContext)) !== NoContext)
          throw new Error("Should not already be working.");
        var originalCallbackNode = root2.callbackNode, didFlushPassiveEffects = flushPassiveEffects();
        if (didFlushPassiveEffects && root2.callbackNode !== originalCallbackNode)
          return null;
        var lanes = getNextLanes(root2, root2 === workInProgressRoot ? workInProgressRootRenderLanes : NoLanes);
        if (lanes === NoLanes)
          return null;
        var shouldTimeSlice = !includesBlockingLane(root2, lanes) && !includesExpiredLane(root2, lanes) && !didTimeout, exitStatus = shouldTimeSlice ? renderRootConcurrent(root2, lanes) : renderRootSync(root2, lanes);
        if (exitStatus !== RootInProgress) {
          if (exitStatus === RootErrored) {
            var errorRetryLanes = getLanesToRetrySynchronouslyOnError(root2);
            errorRetryLanes !== NoLanes && (lanes = errorRetryLanes, exitStatus = recoverFromConcurrentError(root2, errorRetryLanes));
          }
          if (exitStatus === RootFatalErrored) {
            var fatalError = workInProgressRootFatalError;
            throw prepareFreshStack(root2, NoLanes), markRootSuspended$1(root2, lanes), ensureRootIsScheduled(root2, now()), fatalError;
          }
          if (exitStatus === RootDidNotComplete)
            markRootSuspended$1(root2, lanes);
          else {
            var renderWasConcurrent = !includesBlockingLane(root2, lanes), finishedWork = root2.current.alternate;
            if (renderWasConcurrent && !isRenderConsistentWithExternalStores(finishedWork)) {
              if (exitStatus = renderRootSync(root2, lanes), exitStatus === RootErrored) {
                var _errorRetryLanes = getLanesToRetrySynchronouslyOnError(root2);
                _errorRetryLanes !== NoLanes && (lanes = _errorRetryLanes, exitStatus = recoverFromConcurrentError(root2, _errorRetryLanes));
              }
              if (exitStatus === RootFatalErrored) {
                var _fatalError = workInProgressRootFatalError;
                throw prepareFreshStack(root2, NoLanes), markRootSuspended$1(root2, lanes), ensureRootIsScheduled(root2, now()), _fatalError;
              }
            }
            root2.finishedWork = finishedWork, root2.finishedLanes = lanes, finishConcurrentRender(root2, exitStatus, lanes);
          }
        }
        return ensureRootIsScheduled(root2, now()), root2.callbackNode === originalCallbackNode ? performConcurrentWorkOnRoot.bind(null, root2) : null;
      }
      function recoverFromConcurrentError(root2, errorRetryLanes) {
        var errorsFromFirstAttempt = workInProgressRootConcurrentErrors;
        if (isRootDehydrated(root2)) {
          var rootWorkInProgress = prepareFreshStack(root2, errorRetryLanes);
          rootWorkInProgress.flags |= ForceClientRender, errorHydratingContainer(root2.containerInfo);
        }
        var exitStatus = renderRootSync(root2, errorRetryLanes);
        if (exitStatus !== RootErrored) {
          var errorsFromSecondAttempt = workInProgressRootRecoverableErrors;
          workInProgressRootRecoverableErrors = errorsFromFirstAttempt, errorsFromSecondAttempt !== null && queueRecoverableErrors(errorsFromSecondAttempt);
        }
        return exitStatus;
      }
      function queueRecoverableErrors(errors2) {
        workInProgressRootRecoverableErrors === null ? workInProgressRootRecoverableErrors = errors2 : workInProgressRootRecoverableErrors.push.apply(workInProgressRootRecoverableErrors, errors2);
      }
      function finishConcurrentRender(root2, exitStatus, lanes) {
        switch (exitStatus) {
          case RootInProgress:
          case RootFatalErrored:
            throw new Error("Root did not complete. This is a bug in React.");
          case RootErrored: {
            commitRoot(root2, workInProgressRootRecoverableErrors, workInProgressTransitions);
            break;
          }
          case RootSuspended: {
            if (markRootSuspended$1(root2, lanes), includesOnlyRetries(lanes) && // do not delay if we're inside an act() scope
            !shouldForceFlushFallbacksInDEV()) {
              var msUntilTimeout = globalMostRecentFallbackTime + FALLBACK_THROTTLE_MS - now();
              if (msUntilTimeout > 10) {
                var nextLanes = getNextLanes(root2, NoLanes);
                if (nextLanes !== NoLanes)
                  break;
                var suspendedLanes = root2.suspendedLanes;
                if (!isSubsetOfLanes(suspendedLanes, lanes)) {
                  var eventTime = requestEventTime();
                  markRootPinged(root2, suspendedLanes);
                  break;
                }
                root2.timeoutHandle = scheduleTimeout(commitRoot.bind(null, root2, workInProgressRootRecoverableErrors, workInProgressTransitions), msUntilTimeout);
                break;
              }
            }
            commitRoot(root2, workInProgressRootRecoverableErrors, workInProgressTransitions);
            break;
          }
          case RootSuspendedWithDelay: {
            if (markRootSuspended$1(root2, lanes), includesOnlyTransitions(lanes))
              break;
            if (!shouldForceFlushFallbacksInDEV()) {
              var mostRecentEventTime = getMostRecentEventTime(root2, lanes), eventTimeMs = mostRecentEventTime, timeElapsedMs = now() - eventTimeMs, _msUntilTimeout = jnd(timeElapsedMs) - timeElapsedMs;
              if (_msUntilTimeout > 10) {
                root2.timeoutHandle = scheduleTimeout(commitRoot.bind(null, root2, workInProgressRootRecoverableErrors, workInProgressTransitions), _msUntilTimeout);
                break;
              }
            }
            commitRoot(root2, workInProgressRootRecoverableErrors, workInProgressTransitions);
            break;
          }
          case RootCompleted: {
            commitRoot(root2, workInProgressRootRecoverableErrors, workInProgressTransitions);
            break;
          }
          default:
            throw new Error("Unknown root exit status.");
        }
      }
      function isRenderConsistentWithExternalStores(finishedWork) {
        for (var node = finishedWork; ; ) {
          if (node.flags & StoreConsistency) {
            var updateQueue = node.updateQueue;
            if (updateQueue !== null) {
              var checks = updateQueue.stores;
              if (checks !== null)
                for (var i = 0; i < checks.length; i++) {
                  var check2 = checks[i], getSnapshot = check2.getSnapshot, renderedValue = check2.value;
                  try {
                    if (!objectIs(getSnapshot(), renderedValue))
                      return !1;
                  } catch {
                    return !1;
                  }
                }
            }
          }
          var child = node.child;
          if (node.subtreeFlags & StoreConsistency && child !== null) {
            child.return = node, node = child;
            continue;
          }
          if (node === finishedWork)
            return !0;
          for (; node.sibling === null; ) {
            if (node.return === null || node.return === finishedWork)
              return !0;
            node = node.return;
          }
          node.sibling.return = node.return, node = node.sibling;
        }
        return !0;
      }
      function markRootSuspended$1(root2, suspendedLanes) {
        suspendedLanes = removeLanes(suspendedLanes, workInProgressRootPingedLanes), suspendedLanes = removeLanes(suspendedLanes, workInProgressRootInterleavedUpdatedLanes), markRootSuspended(root2, suspendedLanes);
      }
      function performSyncWorkOnRoot(root2) {
        if (syncNestedUpdateFlag(), (executionContext & (RenderContext | CommitContext)) !== NoContext)
          throw new Error("Should not already be working.");
        flushPassiveEffects();
        var lanes = getNextLanes(root2, NoLanes);
        if (!includesSomeLane(lanes, SyncLane))
          return ensureRootIsScheduled(root2, now()), null;
        var exitStatus = renderRootSync(root2, lanes);
        if (root2.tag !== LegacyRoot && exitStatus === RootErrored) {
          var errorRetryLanes = getLanesToRetrySynchronouslyOnError(root2);
          errorRetryLanes !== NoLanes && (lanes = errorRetryLanes, exitStatus = recoverFromConcurrentError(root2, errorRetryLanes));
        }
        if (exitStatus === RootFatalErrored) {
          var fatalError = workInProgressRootFatalError;
          throw prepareFreshStack(root2, NoLanes), markRootSuspended$1(root2, lanes), ensureRootIsScheduled(root2, now()), fatalError;
        }
        if (exitStatus === RootDidNotComplete)
          throw new Error("Root did not complete. This is a bug in React.");
        var finishedWork = root2.current.alternate;
        return root2.finishedWork = finishedWork, root2.finishedLanes = lanes, commitRoot(root2, workInProgressRootRecoverableErrors, workInProgressTransitions), ensureRootIsScheduled(root2, now()), null;
      }
      function flushRoot(root2, lanes) {
        lanes !== NoLanes && (markRootEntangled(root2, mergeLanes(lanes, SyncLane)), ensureRootIsScheduled(root2, now()), (executionContext & (RenderContext | CommitContext)) === NoContext && (resetRenderTimer(), flushSyncCallbacks()));
      }
      function batchedUpdates$1(fn, a) {
        var prevExecutionContext = executionContext;
        executionContext |= BatchedContext;
        try {
          return fn(a);
        } finally {
          executionContext = prevExecutionContext, executionContext === NoContext && // Treat `act` as if it's inside `batchedUpdates`, even in legacy mode.
          !ReactCurrentActQueue$1.isBatchingLegacy && (resetRenderTimer(), flushSyncCallbacksOnlyInLegacyMode());
        }
      }
      function discreteUpdates(fn, a, b, c, d) {
        var previousPriority = getCurrentUpdatePriority(), prevTransition = ReactCurrentBatchConfig$3.transition;
        try {
          return ReactCurrentBatchConfig$3.transition = null, setCurrentUpdatePriority(DiscreteEventPriority), fn(a, b, c, d);
        } finally {
          setCurrentUpdatePriority(previousPriority), ReactCurrentBatchConfig$3.transition = prevTransition, executionContext === NoContext && resetRenderTimer();
        }
      }
      function flushSync(fn) {
        rootWithPendingPassiveEffects !== null && rootWithPendingPassiveEffects.tag === LegacyRoot && (executionContext & (RenderContext | CommitContext)) === NoContext && flushPassiveEffects();
        var prevExecutionContext = executionContext;
        executionContext |= BatchedContext;
        var prevTransition = ReactCurrentBatchConfig$3.transition, previousPriority = getCurrentUpdatePriority();
        try {
          return ReactCurrentBatchConfig$3.transition = null, setCurrentUpdatePriority(DiscreteEventPriority), fn ? fn() : void 0;
        } finally {
          setCurrentUpdatePriority(previousPriority), ReactCurrentBatchConfig$3.transition = prevTransition, executionContext = prevExecutionContext, (executionContext & (RenderContext | CommitContext)) === NoContext && flushSyncCallbacks();
        }
      }
      function isAlreadyRendering() {
        return (executionContext & (RenderContext | CommitContext)) !== NoContext;
      }
      function pushRenderLanes(fiber, lanes) {
        push2(subtreeRenderLanesCursor, subtreeRenderLanes, fiber), subtreeRenderLanes = mergeLanes(subtreeRenderLanes, lanes), workInProgressRootIncludedLanes = mergeLanes(workInProgressRootIncludedLanes, lanes);
      }
      function popRenderLanes(fiber) {
        subtreeRenderLanes = subtreeRenderLanesCursor.current, pop(subtreeRenderLanesCursor, fiber);
      }
      function prepareFreshStack(root2, lanes) {
        root2.finishedWork = null, root2.finishedLanes = NoLanes;
        var timeoutHandle = root2.timeoutHandle;
        if (timeoutHandle !== noTimeout && (root2.timeoutHandle = noTimeout, cancelTimeout(timeoutHandle)), workInProgress !== null)
          for (var interruptedWork = workInProgress.return; interruptedWork !== null; ) {
            var current2 = interruptedWork.alternate;
            unwindInterruptedWork(current2, interruptedWork), interruptedWork = interruptedWork.return;
          }
        workInProgressRoot = root2;
        var rootWorkInProgress = createWorkInProgress(root2.current, null);
        return workInProgress = rootWorkInProgress, workInProgressRootRenderLanes = subtreeRenderLanes = workInProgressRootIncludedLanes = lanes, workInProgressRootExitStatus = RootInProgress, workInProgressRootFatalError = null, workInProgressRootSkippedLanes = NoLanes, workInProgressRootInterleavedUpdatedLanes = NoLanes, workInProgressRootPingedLanes = NoLanes, workInProgressRootConcurrentErrors = null, workInProgressRootRecoverableErrors = null, finishQueueingConcurrentUpdates(), ReactStrictModeWarnings.discardPendingWarnings(), rootWorkInProgress;
      }
      function handleError(root2, thrownValue) {
        do {
          var erroredWork = workInProgress;
          try {
            if (resetContextDependencies(), resetHooksAfterThrow(), resetCurrentFiber(), ReactCurrentOwner$2.current = null, erroredWork === null || erroredWork.return === null) {
              workInProgressRootExitStatus = RootFatalErrored, workInProgressRootFatalError = thrownValue, workInProgress = null;
              return;
            }
            if (enableProfilerTimer && erroredWork.mode & ProfileMode && stopProfilerTimerIfRunningAndRecordDelta(erroredWork, !0), enableSchedulingProfiler)
              if (markComponentRenderStopped(), thrownValue !== null && typeof thrownValue == "object" && typeof thrownValue.then == "function") {
                var wakeable = thrownValue;
                markComponentSuspended(erroredWork, wakeable, workInProgressRootRenderLanes);
              } else
                markComponentErrored(erroredWork, thrownValue, workInProgressRootRenderLanes);
            throwException(root2, erroredWork.return, erroredWork, thrownValue, workInProgressRootRenderLanes), completeUnitOfWork(erroredWork);
          } catch (yetAnotherThrownValue) {
            thrownValue = yetAnotherThrownValue, workInProgress === erroredWork && erroredWork !== null ? (erroredWork = erroredWork.return, workInProgress = erroredWork) : erroredWork = workInProgress;
            continue;
          }
          return;
        } while (!0);
      }
      function pushDispatcher() {
        var prevDispatcher = ReactCurrentDispatcher$2.current;
        return ReactCurrentDispatcher$2.current = ContextOnlyDispatcher, prevDispatcher === null ? ContextOnlyDispatcher : prevDispatcher;
      }
      function popDispatcher(prevDispatcher) {
        ReactCurrentDispatcher$2.current = prevDispatcher;
      }
      function markCommitTimeOfFallback() {
        globalMostRecentFallbackTime = now();
      }
      function markSkippedUpdateLanes(lane) {
        workInProgressRootSkippedLanes = mergeLanes(lane, workInProgressRootSkippedLanes);
      }
      function renderDidSuspend() {
        workInProgressRootExitStatus === RootInProgress && (workInProgressRootExitStatus = RootSuspended);
      }
      function renderDidSuspendDelayIfPossible() {
        (workInProgressRootExitStatus === RootInProgress || workInProgressRootExitStatus === RootSuspended || workInProgressRootExitStatus === RootErrored) && (workInProgressRootExitStatus = RootSuspendedWithDelay), workInProgressRoot !== null && (includesNonIdleWork(workInProgressRootSkippedLanes) || includesNonIdleWork(workInProgressRootInterleavedUpdatedLanes)) && markRootSuspended$1(workInProgressRoot, workInProgressRootRenderLanes);
      }
      function renderDidError(error2) {
        workInProgressRootExitStatus !== RootSuspendedWithDelay && (workInProgressRootExitStatus = RootErrored), workInProgressRootConcurrentErrors === null ? workInProgressRootConcurrentErrors = [error2] : workInProgressRootConcurrentErrors.push(error2);
      }
      function renderHasNotSuspendedYet() {
        return workInProgressRootExitStatus === RootInProgress;
      }
      function renderRootSync(root2, lanes) {
        var prevExecutionContext = executionContext;
        executionContext |= RenderContext;
        var prevDispatcher = pushDispatcher();
        if (workInProgressRoot !== root2 || workInProgressRootRenderLanes !== lanes) {
          if (isDevToolsPresent) {
            var memoizedUpdaters = root2.memoizedUpdaters;
            memoizedUpdaters.size > 0 && (restorePendingUpdaters(root2, workInProgressRootRenderLanes), memoizedUpdaters.clear()), movePendingFibersToMemoized(root2, lanes);
          }
          workInProgressTransitions = getTransitionsForLanes(), prepareFreshStack(root2, lanes);
        }
        markRenderStarted(lanes);
        do
          try {
            workLoopSync();
            break;
          } catch (thrownValue) {
            handleError(root2, thrownValue);
          }
        while (!0);
        if (resetContextDependencies(), executionContext = prevExecutionContext, popDispatcher(prevDispatcher), workInProgress !== null)
          throw new Error("Cannot commit an incomplete root. This error is likely caused by a bug in React. Please file an issue.");
        return markRenderStopped(), workInProgressRoot = null, workInProgressRootRenderLanes = NoLanes, workInProgressRootExitStatus;
      }
      function workLoopSync() {
        for (; workInProgress !== null; )
          performUnitOfWork(workInProgress);
      }
      function renderRootConcurrent(root2, lanes) {
        var prevExecutionContext = executionContext;
        executionContext |= RenderContext;
        var prevDispatcher = pushDispatcher();
        if (workInProgressRoot !== root2 || workInProgressRootRenderLanes !== lanes) {
          if (isDevToolsPresent) {
            var memoizedUpdaters = root2.memoizedUpdaters;
            memoizedUpdaters.size > 0 && (restorePendingUpdaters(root2, workInProgressRootRenderLanes), memoizedUpdaters.clear()), movePendingFibersToMemoized(root2, lanes);
          }
          workInProgressTransitions = getTransitionsForLanes(), resetRenderTimer(), prepareFreshStack(root2, lanes);
        }
        markRenderStarted(lanes);
        do
          try {
            workLoopConcurrent();
            break;
          } catch (thrownValue) {
            handleError(root2, thrownValue);
          }
        while (!0);
        return resetContextDependencies(), popDispatcher(prevDispatcher), executionContext = prevExecutionContext, workInProgress !== null ? (markRenderYielded(), RootInProgress) : (markRenderStopped(), workInProgressRoot = null, workInProgressRootRenderLanes = NoLanes, workInProgressRootExitStatus);
      }
      function workLoopConcurrent() {
        for (; workInProgress !== null && !shouldYield(); )
          performUnitOfWork(workInProgress);
      }
      function performUnitOfWork(unitOfWork) {
        var current2 = unitOfWork.alternate;
        setCurrentFiber(unitOfWork);
        var next;
        (unitOfWork.mode & ProfileMode) !== NoMode ? (startProfilerTimer(unitOfWork), next = beginWork$1(current2, unitOfWork, subtreeRenderLanes), stopProfilerTimerIfRunningAndRecordDelta(unitOfWork, !0)) : next = beginWork$1(current2, unitOfWork, subtreeRenderLanes), resetCurrentFiber(), unitOfWork.memoizedProps = unitOfWork.pendingProps, next === null ? completeUnitOfWork(unitOfWork) : workInProgress = next, ReactCurrentOwner$2.current = null;
      }
      function completeUnitOfWork(unitOfWork) {
        var completedWork = unitOfWork;
        do {
          var current2 = completedWork.alternate, returnFiber = completedWork.return;
          if ((completedWork.flags & Incomplete) === NoFlags) {
            setCurrentFiber(completedWork);
            var next = void 0;
            if ((completedWork.mode & ProfileMode) === NoMode ? next = completeWork(current2, completedWork, subtreeRenderLanes) : (startProfilerTimer(completedWork), next = completeWork(current2, completedWork, subtreeRenderLanes), stopProfilerTimerIfRunningAndRecordDelta(completedWork, !1)), resetCurrentFiber(), next !== null) {
              workInProgress = next;
              return;
            }
          } else {
            var _next = unwindWork(current2, completedWork);
            if (_next !== null) {
              _next.flags &= HostEffectMask, workInProgress = _next;
              return;
            }
            if ((completedWork.mode & ProfileMode) !== NoMode) {
              stopProfilerTimerIfRunningAndRecordDelta(completedWork, !1);
              for (var actualDuration = completedWork.actualDuration, child = completedWork.child; child !== null; )
                actualDuration += child.actualDuration, child = child.sibling;
              completedWork.actualDuration = actualDuration;
            }
            if (returnFiber !== null)
              returnFiber.flags |= Incomplete, returnFiber.subtreeFlags = NoFlags, returnFiber.deletions = null;
            else {
              workInProgressRootExitStatus = RootDidNotComplete, workInProgress = null;
              return;
            }
          }
          var siblingFiber = completedWork.sibling;
          if (siblingFiber !== null) {
            workInProgress = siblingFiber;
            return;
          }
          completedWork = returnFiber, workInProgress = completedWork;
        } while (completedWork !== null);
        workInProgressRootExitStatus === RootInProgress && (workInProgressRootExitStatus = RootCompleted);
      }
      function commitRoot(root2, recoverableErrors, transitions) {
        var previousUpdateLanePriority = getCurrentUpdatePriority(), prevTransition = ReactCurrentBatchConfig$3.transition;
        try {
          ReactCurrentBatchConfig$3.transition = null, setCurrentUpdatePriority(DiscreteEventPriority), commitRootImpl(root2, recoverableErrors, transitions, previousUpdateLanePriority);
        } finally {
          ReactCurrentBatchConfig$3.transition = prevTransition, setCurrentUpdatePriority(previousUpdateLanePriority);
        }
        return null;
      }
      function commitRootImpl(root2, recoverableErrors, transitions, renderPriorityLevel) {
        do
          flushPassiveEffects();
        while (rootWithPendingPassiveEffects !== null);
        if (flushRenderPhaseStrictModeWarningsInDEV(), (executionContext & (RenderContext | CommitContext)) !== NoContext)
          throw new Error("Should not already be working.");
        var finishedWork = root2.finishedWork, lanes = root2.finishedLanes;
        if (markCommitStarted(lanes), finishedWork === null)
          return markCommitStopped(), null;
        if (lanes === NoLanes && error("root.finishedLanes should not be empty during a commit. This is a bug in React."), root2.finishedWork = null, root2.finishedLanes = NoLanes, finishedWork === root2.current)
          throw new Error("Cannot commit the same tree as before. This error is likely caused by a bug in React. Please file an issue.");
        root2.callbackNode = null, root2.callbackPriority = NoLane;
        var remainingLanes = mergeLanes(finishedWork.lanes, finishedWork.childLanes);
        markRootFinished(root2, remainingLanes), root2 === workInProgressRoot && (workInProgressRoot = null, workInProgress = null, workInProgressRootRenderLanes = NoLanes), ((finishedWork.subtreeFlags & PassiveMask) !== NoFlags || (finishedWork.flags & PassiveMask) !== NoFlags) && (rootDoesHavePassiveEffects || (rootDoesHavePassiveEffects = !0, pendingPassiveTransitions = transitions, scheduleCallback$1(NormalPriority, function() {
          return flushPassiveEffects(), null;
        })));
        var subtreeHasEffects = (finishedWork.subtreeFlags & (BeforeMutationMask | MutationMask | LayoutMask | PassiveMask)) !== NoFlags, rootHasEffect = (finishedWork.flags & (BeforeMutationMask | MutationMask | LayoutMask | PassiveMask)) !== NoFlags;
        if (subtreeHasEffects || rootHasEffect) {
          var prevTransition = ReactCurrentBatchConfig$3.transition;
          ReactCurrentBatchConfig$3.transition = null;
          var previousPriority = getCurrentUpdatePriority();
          setCurrentUpdatePriority(DiscreteEventPriority);
          var prevExecutionContext = executionContext;
          executionContext |= CommitContext, ReactCurrentOwner$2.current = null;
          var shouldFireAfterActiveInstanceBlur2 = commitBeforeMutationEffects(root2, finishedWork);
          recordCommitTime(), commitMutationEffects(root2, finishedWork, lanes), resetAfterCommit(root2.containerInfo), root2.current = finishedWork, markLayoutEffectsStarted(lanes), commitLayoutEffects(finishedWork, root2, lanes), markLayoutEffectsStopped(), requestPaint(), executionContext = prevExecutionContext, setCurrentUpdatePriority(previousPriority), ReactCurrentBatchConfig$3.transition = prevTransition;
        } else
          root2.current = finishedWork, recordCommitTime();
        var rootDidHavePassiveEffects = rootDoesHavePassiveEffects;
        if (rootDoesHavePassiveEffects ? (rootDoesHavePassiveEffects = !1, rootWithPendingPassiveEffects = root2, pendingPassiveEffectsLanes = lanes) : (nestedPassiveUpdateCount = 0, rootWithPassiveNestedUpdates = null), remainingLanes = root2.pendingLanes, remainingLanes === NoLanes && (legacyErrorBoundariesThatAlreadyFailed = null), rootDidHavePassiveEffects || commitDoubleInvokeEffectsInDEV(root2.current, !1), onCommitRoot(finishedWork.stateNode, renderPriorityLevel), isDevToolsPresent && root2.memoizedUpdaters.clear(), onCommitRoot$1(), ensureRootIsScheduled(root2, now()), recoverableErrors !== null)
          for (var onRecoverableError = root2.onRecoverableError, i = 0; i < recoverableErrors.length; i++) {
            var recoverableError = recoverableErrors[i], componentStack = recoverableError.stack, digest = recoverableError.digest;
            onRecoverableError(recoverableError.value, {
              componentStack,
              digest
            });
          }
        if (hasUncaughtError) {
          hasUncaughtError = !1;
          var error$1 = firstUncaughtError;
          throw firstUncaughtError = null, error$1;
        }
        return includesSomeLane(pendingPassiveEffectsLanes, SyncLane) && root2.tag !== LegacyRoot && flushPassiveEffects(), remainingLanes = root2.pendingLanes, includesSomeLane(remainingLanes, SyncLane) ? (markNestedUpdateScheduled(), root2 === rootWithNestedUpdates ? nestedUpdateCount++ : (nestedUpdateCount = 0, rootWithNestedUpdates = root2)) : nestedUpdateCount = 0, flushSyncCallbacks(), markCommitStopped(), null;
      }
      function flushPassiveEffects() {
        if (rootWithPendingPassiveEffects !== null) {
          var renderPriority = lanesToEventPriority(pendingPassiveEffectsLanes), priority = lowerEventPriority(DefaultEventPriority, renderPriority), prevTransition = ReactCurrentBatchConfig$3.transition, previousPriority = getCurrentUpdatePriority();
          try {
            return ReactCurrentBatchConfig$3.transition = null, setCurrentUpdatePriority(priority), flushPassiveEffectsImpl();
          } finally {
            setCurrentUpdatePriority(previousPriority), ReactCurrentBatchConfig$3.transition = prevTransition;
          }
        }
        return !1;
      }
      function enqueuePendingPassiveProfilerEffect(fiber) {
        pendingPassiveProfilerEffects.push(fiber), rootDoesHavePassiveEffects || (rootDoesHavePassiveEffects = !0, scheduleCallback$1(NormalPriority, function() {
          return flushPassiveEffects(), null;
        }));
      }
      function flushPassiveEffectsImpl() {
        if (rootWithPendingPassiveEffects === null)
          return !1;
        var transitions = pendingPassiveTransitions;
        pendingPassiveTransitions = null;
        var root2 = rootWithPendingPassiveEffects, lanes = pendingPassiveEffectsLanes;
        if (rootWithPendingPassiveEffects = null, pendingPassiveEffectsLanes = NoLanes, (executionContext & (RenderContext | CommitContext)) !== NoContext)
          throw new Error("Cannot flush passive effects while already rendering.");
        isFlushingPassiveEffects = !0, didScheduleUpdateDuringPassiveEffects = !1, markPassiveEffectsStarted(lanes);
        var prevExecutionContext = executionContext;
        executionContext |= CommitContext, commitPassiveUnmountEffects(root2.current), commitPassiveMountEffects(root2, root2.current, lanes, transitions);
        {
          var profilerEffects = pendingPassiveProfilerEffects;
          pendingPassiveProfilerEffects = [];
          for (var i = 0; i < profilerEffects.length; i++) {
            var _fiber = profilerEffects[i];
            commitPassiveEffectDurations(root2, _fiber);
          }
        }
        markPassiveEffectsStopped(), commitDoubleInvokeEffectsInDEV(root2.current, !0), executionContext = prevExecutionContext, flushSyncCallbacks(), didScheduleUpdateDuringPassiveEffects ? root2 === rootWithPassiveNestedUpdates ? nestedPassiveUpdateCount++ : (nestedPassiveUpdateCount = 0, rootWithPassiveNestedUpdates = root2) : nestedPassiveUpdateCount = 0, isFlushingPassiveEffects = !1, didScheduleUpdateDuringPassiveEffects = !1, onPostCommitRoot(root2);
        {
          var stateNode = root2.current.stateNode;
          stateNode.effectDuration = 0, stateNode.passiveEffectDuration = 0;
        }
        return !0;
      }
      function isAlreadyFailedLegacyErrorBoundary(instance) {
        return legacyErrorBoundariesThatAlreadyFailed !== null && legacyErrorBoundariesThatAlreadyFailed.has(instance);
      }
      function markLegacyErrorBoundaryAsFailed(instance) {
        legacyErrorBoundariesThatAlreadyFailed === null ? legacyErrorBoundariesThatAlreadyFailed = /* @__PURE__ */ new Set([instance]) : legacyErrorBoundariesThatAlreadyFailed.add(instance);
      }
      function prepareToThrowUncaughtError(error2) {
        hasUncaughtError || (hasUncaughtError = !0, firstUncaughtError = error2);
      }
      var onUncaughtError = prepareToThrowUncaughtError;
      function captureCommitPhaseErrorOnRoot(rootFiber, sourceFiber, error2) {
        var errorInfo = createCapturedValueAtFiber(error2, sourceFiber), update2 = createRootErrorUpdate(rootFiber, errorInfo, SyncLane), root2 = enqueueUpdate(rootFiber, update2, SyncLane), eventTime = requestEventTime();
        root2 !== null && (markRootUpdated(root2, SyncLane, eventTime), ensureRootIsScheduled(root2, eventTime));
      }
      function captureCommitPhaseError(sourceFiber, nearestMountedAncestor, error$1) {
        if (reportUncaughtErrorInDEV(error$1), setIsRunningInsertionEffect(!1), sourceFiber.tag === HostRoot) {
          captureCommitPhaseErrorOnRoot(sourceFiber, sourceFiber, error$1);
          return;
        }
        var fiber = null;
        for (fiber = nearestMountedAncestor; fiber !== null; ) {
          if (fiber.tag === HostRoot) {
            captureCommitPhaseErrorOnRoot(fiber, sourceFiber, error$1);
            return;
          } else if (fiber.tag === ClassComponent) {
            var ctor = fiber.type, instance = fiber.stateNode;
            if (typeof ctor.getDerivedStateFromError == "function" || typeof instance.componentDidCatch == "function" && !isAlreadyFailedLegacyErrorBoundary(instance)) {
              var errorInfo = createCapturedValueAtFiber(error$1, sourceFiber), update2 = createClassErrorUpdate(fiber, errorInfo, SyncLane), root2 = enqueueUpdate(fiber, update2, SyncLane), eventTime = requestEventTime();
              root2 !== null && (markRootUpdated(root2, SyncLane, eventTime), ensureRootIsScheduled(root2, eventTime));
              return;
            }
          }
          fiber = fiber.return;
        }
        error(`Internal React error: Attempted to capture a commit phase error inside a detached tree. This indicates a bug in React. Likely causes include deleting the same fiber more than once, committing an already-finished tree, or an inconsistent return pointer.

Error message:

%s`, error$1);
      }
      function pingSuspendedRoot(root2, wakeable, pingedLanes) {
        var pingCache = root2.pingCache;
        pingCache !== null && pingCache.delete(wakeable);
        var eventTime = requestEventTime();
        markRootPinged(root2, pingedLanes), warnIfSuspenseResolutionNotWrappedWithActDEV(root2), workInProgressRoot === root2 && isSubsetOfLanes(workInProgressRootRenderLanes, pingedLanes) && (workInProgressRootExitStatus === RootSuspendedWithDelay || workInProgressRootExitStatus === RootSuspended && includesOnlyRetries(workInProgressRootRenderLanes) && now() - globalMostRecentFallbackTime < FALLBACK_THROTTLE_MS ? prepareFreshStack(root2, NoLanes) : workInProgressRootPingedLanes = mergeLanes(workInProgressRootPingedLanes, pingedLanes)), ensureRootIsScheduled(root2, eventTime);
      }
      function retryTimedOutBoundary(boundaryFiber, retryLane) {
        retryLane === NoLane && (retryLane = requestRetryLane(boundaryFiber));
        var eventTime = requestEventTime(), root2 = enqueueConcurrentRenderForLane(boundaryFiber, retryLane);
        root2 !== null && (markRootUpdated(root2, retryLane, eventTime), ensureRootIsScheduled(root2, eventTime));
      }
      function retryDehydratedSuspenseBoundary(boundaryFiber) {
        var suspenseState = boundaryFiber.memoizedState, retryLane = NoLane;
        suspenseState !== null && (retryLane = suspenseState.retryLane), retryTimedOutBoundary(boundaryFiber, retryLane);
      }
      function resolveRetryWakeable(boundaryFiber, wakeable) {
        var retryLane = NoLane, retryCache;
        switch (boundaryFiber.tag) {
          case SuspenseComponent:
            retryCache = boundaryFiber.stateNode;
            var suspenseState = boundaryFiber.memoizedState;
            suspenseState !== null && (retryLane = suspenseState.retryLane);
            break;
          case SuspenseListComponent:
            retryCache = boundaryFiber.stateNode;
            break;
          default:
            throw new Error("Pinged unknown suspense boundary type. This is probably a bug in React.");
        }
        retryCache !== null && retryCache.delete(wakeable), retryTimedOutBoundary(boundaryFiber, retryLane);
      }
      function jnd(timeElapsed) {
        return timeElapsed < 120 ? 120 : timeElapsed < 480 ? 480 : timeElapsed < 1080 ? 1080 : timeElapsed < 1920 ? 1920 : timeElapsed < 3e3 ? 3e3 : timeElapsed < 4320 ? 4320 : ceil(timeElapsed / 1960) * 1960;
      }
      function checkForNestedUpdates() {
        if (nestedUpdateCount > NESTED_UPDATE_LIMIT)
          throw nestedUpdateCount = 0, rootWithNestedUpdates = null, new Error("Maximum update depth exceeded. This can happen when a component repeatedly calls setState inside componentWillUpdate or componentDidUpdate. React limits the number of nested updates to prevent infinite loops.");
        nestedPassiveUpdateCount > NESTED_PASSIVE_UPDATE_LIMIT && (nestedPassiveUpdateCount = 0, rootWithPassiveNestedUpdates = null, error("Maximum update depth exceeded. This can happen when a component calls setState inside useEffect, but useEffect either doesn't have a dependency array, or one of the dependencies changes on every render."));
      }
      function flushRenderPhaseStrictModeWarningsInDEV() {
        ReactStrictModeWarnings.flushLegacyContextWarning(), ReactStrictModeWarnings.flushPendingUnsafeLifecycleWarnings();
      }
      function commitDoubleInvokeEffectsInDEV(fiber, hasPassiveEffects) {
        setCurrentFiber(fiber), invokeEffectsInDev(fiber, MountLayoutDev, invokeLayoutEffectUnmountInDEV), hasPassiveEffects && invokeEffectsInDev(fiber, MountPassiveDev, invokePassiveEffectUnmountInDEV), invokeEffectsInDev(fiber, MountLayoutDev, invokeLayoutEffectMountInDEV), hasPassiveEffects && invokeEffectsInDev(fiber, MountPassiveDev, invokePassiveEffectMountInDEV), resetCurrentFiber();
      }
      function invokeEffectsInDev(firstChild, fiberFlags, invokeEffectFn) {
        for (var current2 = firstChild, subtreeRoot = null; current2 !== null; ) {
          var primarySubtreeFlag = current2.subtreeFlags & fiberFlags;
          current2 !== subtreeRoot && current2.child !== null && primarySubtreeFlag !== NoFlags ? current2 = current2.child : ((current2.flags & fiberFlags) !== NoFlags && invokeEffectFn(current2), current2.sibling !== null ? current2 = current2.sibling : current2 = subtreeRoot = current2.return);
        }
      }
      var didWarnStateUpdateForNotYetMountedComponent = null;
      function warnAboutUpdateOnNotYetMountedFiberInDEV(fiber) {
        {
          if ((executionContext & RenderContext) !== NoContext || !(fiber.mode & ConcurrentMode))
            return;
          var tag = fiber.tag;
          if (tag !== IndeterminateComponent && tag !== HostRoot && tag !== ClassComponent && tag !== FunctionComponent && tag !== ForwardRef && tag !== MemoComponent && tag !== SimpleMemoComponent)
            return;
          var componentName = getComponentNameFromFiber(fiber) || "ReactComponent";
          if (didWarnStateUpdateForNotYetMountedComponent !== null) {
            if (didWarnStateUpdateForNotYetMountedComponent.has(componentName))
              return;
            didWarnStateUpdateForNotYetMountedComponent.add(componentName);
          } else
            didWarnStateUpdateForNotYetMountedComponent = /* @__PURE__ */ new Set([componentName]);
          var previousFiber = current;
          try {
            setCurrentFiber(fiber), error("Can't perform a React state update on a component that hasn't mounted yet. This indicates that you have a side-effect in your render function that asynchronously later calls tries to update the component. Move this work to useEffect instead.");
          } finally {
            previousFiber ? setCurrentFiber(fiber) : resetCurrentFiber();
          }
        }
      }
      var beginWork$1;
      {
        var dummyFiber = null;
        beginWork$1 = function(current2, unitOfWork, lanes) {
          var originalWorkInProgressCopy = assignFiberPropertiesInDEV(dummyFiber, unitOfWork);
          try {
            return beginWork(current2, unitOfWork, lanes);
          } catch (originalError) {
            if (didSuspendOrErrorWhileHydratingDEV() || originalError !== null && typeof originalError == "object" && typeof originalError.then == "function")
              throw originalError;
            if (resetContextDependencies(), resetHooksAfterThrow(), unwindInterruptedWork(current2, unitOfWork), assignFiberPropertiesInDEV(unitOfWork, originalWorkInProgressCopy), unitOfWork.mode & ProfileMode && startProfilerTimer(unitOfWork), invokeGuardedCallback(null, beginWork, null, current2, unitOfWork, lanes), hasCaughtError()) {
              var replayError = clearCaughtError();
              typeof replayError == "object" && replayError !== null && replayError._suppressLogging && typeof originalError == "object" && originalError !== null && !originalError._suppressLogging && (originalError._suppressLogging = !0);
            }
            throw originalError;
          }
        };
      }
      var didWarnAboutUpdateInRender = !1, didWarnAboutUpdateInRenderForAnotherComponent;
      didWarnAboutUpdateInRenderForAnotherComponent = /* @__PURE__ */ new Set();
      function warnAboutRenderPhaseUpdatesInDEV(fiber) {
        if (isRendering && !getIsUpdatingOpaqueValueInRenderPhaseInDEV())
          switch (fiber.tag) {
            case FunctionComponent:
            case ForwardRef:
            case SimpleMemoComponent: {
              var renderingComponentName = workInProgress && getComponentNameFromFiber(workInProgress) || "Unknown", dedupeKey = renderingComponentName;
              if (!didWarnAboutUpdateInRenderForAnotherComponent.has(dedupeKey)) {
                didWarnAboutUpdateInRenderForAnotherComponent.add(dedupeKey);
                var setStateComponentName = getComponentNameFromFiber(fiber) || "Unknown";
                error("Cannot update a component (`%s`) while rendering a different component (`%s`). To locate the bad setState() call inside `%s`, follow the stack trace as described in https://reactjs.org/link/setstate-in-render", setStateComponentName, renderingComponentName, renderingComponentName);
              }
              break;
            }
            case ClassComponent: {
              didWarnAboutUpdateInRender || (error("Cannot update during an existing state transition (such as within `render`). Render methods should be a pure function of props and state."), didWarnAboutUpdateInRender = !0);
              break;
            }
          }
      }
      function restorePendingUpdaters(root2, lanes) {
        if (isDevToolsPresent) {
          var memoizedUpdaters = root2.memoizedUpdaters;
          memoizedUpdaters.forEach(function(schedulingFiber) {
            addFiberToLanesMap(root2, schedulingFiber, lanes);
          });
        }
      }
      var fakeActCallbackNode = {};
      function scheduleCallback$1(priorityLevel, callback) {
        {
          var actQueue = ReactCurrentActQueue$1.current;
          return actQueue !== null ? (actQueue.push(callback), fakeActCallbackNode) : scheduleCallback(priorityLevel, callback);
        }
      }
      function cancelCallback$1(callbackNode) {
        if (callbackNode !== fakeActCallbackNode)
          return cancelCallback(callbackNode);
      }
      function shouldForceFlushFallbacksInDEV() {
        return ReactCurrentActQueue$1.current !== null;
      }
      function warnIfUpdatesNotWrappedWithActDEV(fiber) {
        {
          if (fiber.mode & ConcurrentMode) {
            if (!isConcurrentActEnvironment())
              return;
          } else if (!isLegacyActEnvironment() || executionContext !== NoContext || fiber.tag !== FunctionComponent && fiber.tag !== ForwardRef && fiber.tag !== SimpleMemoComponent)
            return;
          if (ReactCurrentActQueue$1.current === null) {
            var previousFiber = current;
            try {
              setCurrentFiber(fiber), error(`An update to %s inside a test was not wrapped in act(...).

When testing, code that causes React state updates should be wrapped into act(...):

act(() => {
  /* fire events that update state */
});
/* assert on the output */

This ensures that you're testing the behavior the user would see in the browser. Learn more at https://reactjs.org/link/wrap-tests-with-act`, getComponentNameFromFiber(fiber));
            } finally {
              previousFiber ? setCurrentFiber(fiber) : resetCurrentFiber();
            }
          }
        }
      }
      function warnIfSuspenseResolutionNotWrappedWithActDEV(root2) {
        root2.tag !== LegacyRoot && isConcurrentActEnvironment() && ReactCurrentActQueue$1.current === null && error(`A suspended resource finished loading inside a test, but the event was not wrapped in act(...).

When testing, code that resolves suspended data should be wrapped into act(...):

act(() => {
  /* finish loading suspended data */
});
/* assert on the output */

This ensures that you're testing the behavior the user would see in the browser. Learn more at https://reactjs.org/link/wrap-tests-with-act`);
      }
      function setIsRunningInsertionEffect(isRunning) {
        isRunningInsertionEffect = isRunning;
      }
      var resolveFamily = null, failedBoundaries = null, setRefreshHandler = function(handler) {
        resolveFamily = handler;
      };
      function resolveFunctionForHotReloading(type) {
        {
          if (resolveFamily === null)
            return type;
          var family = resolveFamily(type);
          return family === void 0 ? type : family.current;
        }
      }
      function resolveClassForHotReloading(type) {
        return resolveFunctionForHotReloading(type);
      }
      function resolveForwardRefForHotReloading(type) {
        {
          if (resolveFamily === null)
            return type;
          var family = resolveFamily(type);
          if (family === void 0) {
            if (type != null && typeof type.render == "function") {
              var currentRender = resolveFunctionForHotReloading(type.render);
              if (type.render !== currentRender) {
                var syntheticType = {
                  $$typeof: REACT_FORWARD_REF_TYPE,
                  render: currentRender
                };
                return type.displayName !== void 0 && (syntheticType.displayName = type.displayName), syntheticType;
              }
            }
            return type;
          }
          return family.current;
        }
      }
      function isCompatibleFamilyForHotReloading(fiber, element) {
        {
          if (resolveFamily === null)
            return !1;
          var prevType = fiber.elementType, nextType = element.type, needsCompareFamilies = !1, $$typeofNextType = typeof nextType == "object" && nextType !== null ? nextType.$$typeof : null;
          switch (fiber.tag) {
            case ClassComponent: {
              typeof nextType == "function" && (needsCompareFamilies = !0);
              break;
            }
            case FunctionComponent: {
              (typeof nextType == "function" || $$typeofNextType === REACT_LAZY_TYPE) && (needsCompareFamilies = !0);
              break;
            }
            case ForwardRef: {
              ($$typeofNextType === REACT_FORWARD_REF_TYPE || $$typeofNextType === REACT_LAZY_TYPE) && (needsCompareFamilies = !0);
              break;
            }
            case MemoComponent:
            case SimpleMemoComponent: {
              ($$typeofNextType === REACT_MEMO_TYPE || $$typeofNextType === REACT_LAZY_TYPE) && (needsCompareFamilies = !0);
              break;
            }
            default:
              return !1;
          }
          if (needsCompareFamilies) {
            var prevFamily = resolveFamily(prevType);
            if (prevFamily !== void 0 && prevFamily === resolveFamily(nextType))
              return !0;
          }
          return !1;
        }
      }
      function markFailedErrorBoundaryForHotReloading(fiber) {
        {
          if (resolveFamily === null || typeof WeakSet != "function")
            return;
          failedBoundaries === null && (failedBoundaries = /* @__PURE__ */ new WeakSet()), failedBoundaries.add(fiber);
        }
      }
      var scheduleRefresh = function(root2, update2) {
        {
          if (resolveFamily === null)
            return;
          var staleFamilies = update2.staleFamilies, updatedFamilies = update2.updatedFamilies;
          flushPassiveEffects(), flushSync(function() {
            scheduleFibersWithFamiliesRecursively(root2.current, updatedFamilies, staleFamilies);
          });
        }
      }, scheduleRoot = function(root2, element) {
        {
          if (root2.context !== emptyContextObject)
            return;
          flushPassiveEffects(), flushSync(function() {
            updateContainer(element, root2, null, null);
          });
        }
      };
      function scheduleFibersWithFamiliesRecursively(fiber, updatedFamilies, staleFamilies) {
        {
          var alternate = fiber.alternate, child = fiber.child, sibling = fiber.sibling, tag = fiber.tag, type = fiber.type, candidateType = null;
          switch (tag) {
            case FunctionComponent:
            case SimpleMemoComponent:
            case ClassComponent:
              candidateType = type;
              break;
            case ForwardRef:
              candidateType = type.render;
              break;
          }
          if (resolveFamily === null)
            throw new Error("Expected resolveFamily to be set during hot reload.");
          var needsRender = !1, needsRemount = !1;
          if (candidateType !== null) {
            var family = resolveFamily(candidateType);
            family !== void 0 && (staleFamilies.has(family) ? needsRemount = !0 : updatedFamilies.has(family) && (tag === ClassComponent ? needsRemount = !0 : needsRender = !0));
          }
          if (failedBoundaries !== null && (failedBoundaries.has(fiber) || alternate !== null && failedBoundaries.has(alternate)) && (needsRemount = !0), needsRemount && (fiber._debugNeedsRemount = !0), needsRemount || needsRender) {
            var _root = enqueueConcurrentRenderForLane(fiber, SyncLane);
            _root !== null && scheduleUpdateOnFiber(_root, fiber, SyncLane, NoTimestamp);
          }
          child !== null && !needsRemount && scheduleFibersWithFamiliesRecursively(child, updatedFamilies, staleFamilies), sibling !== null && scheduleFibersWithFamiliesRecursively(sibling, updatedFamilies, staleFamilies);
        }
      }
      var findHostInstancesForRefresh = function(root2, families) {
        {
          var hostInstances = /* @__PURE__ */ new Set(), types = new Set(families.map(function(family) {
            return family.current;
          }));
          return findHostInstancesForMatchingFibersRecursively(root2.current, types, hostInstances), hostInstances;
        }
      };
      function findHostInstancesForMatchingFibersRecursively(fiber, types, hostInstances) {
        {
          var child = fiber.child, sibling = fiber.sibling, tag = fiber.tag, type = fiber.type, candidateType = null;
          switch (tag) {
            case FunctionComponent:
            case SimpleMemoComponent:
            case ClassComponent:
              candidateType = type;
              break;
            case ForwardRef:
              candidateType = type.render;
              break;
          }
          var didMatch = !1;
          candidateType !== null && types.has(candidateType) && (didMatch = !0), didMatch ? findHostInstancesForFiberShallowly(fiber, hostInstances) : child !== null && findHostInstancesForMatchingFibersRecursively(child, types, hostInstances), sibling !== null && findHostInstancesForMatchingFibersRecursively(sibling, types, hostInstances);
        }
      }
      function findHostInstancesForFiberShallowly(fiber, hostInstances) {
        {
          var foundHostInstances = findChildHostInstancesForFiberShallowly(fiber, hostInstances);
          if (foundHostInstances)
            return;
          for (var node = fiber; ; ) {
            switch (node.tag) {
              case HostComponent:
                hostInstances.add(node.stateNode);
                return;
              case HostPortal:
                hostInstances.add(node.stateNode.containerInfo);
                return;
              case HostRoot:
                hostInstances.add(node.stateNode.containerInfo);
                return;
            }
            if (node.return === null)
              throw new Error("Expected to reach root first.");
            node = node.return;
          }
        }
      }
      function findChildHostInstancesForFiberShallowly(fiber, hostInstances) {
        for (var node = fiber, foundHostInstances = !1; ; ) {
          if (node.tag === HostComponent)
            foundHostInstances = !0, hostInstances.add(node.stateNode);
          else if (node.child !== null) {
            node.child.return = node, node = node.child;
            continue;
          }
          if (node === fiber)
            return foundHostInstances;
          for (; node.sibling === null; ) {
            if (node.return === null || node.return === fiber)
              return foundHostInstances;
            node = node.return;
          }
          node.sibling.return = node.return, node = node.sibling;
        }
        return !1;
      }
      var hasBadMapPolyfill;
      {
        hasBadMapPolyfill = !1;
        try {
          var nonExtensibleObject = Object.preventExtensions({});
        } catch {
          hasBadMapPolyfill = !0;
        }
      }
      function FiberNode(tag, pendingProps, key, mode) {
        this.tag = tag, this.key = key, this.elementType = null, this.type = null, this.stateNode = null, this.return = null, this.child = null, this.sibling = null, this.index = 0, this.ref = null, this.pendingProps = pendingProps, this.memoizedProps = null, this.updateQueue = null, this.memoizedState = null, this.dependencies = null, this.mode = mode, this.flags = NoFlags, this.subtreeFlags = NoFlags, this.deletions = null, this.lanes = NoLanes, this.childLanes = NoLanes, this.alternate = null, this.actualDuration = Number.NaN, this.actualStartTime = Number.NaN, this.selfBaseDuration = Number.NaN, this.treeBaseDuration = Number.NaN, this.actualDuration = 0, this.actualStartTime = -1, this.selfBaseDuration = 0, this.treeBaseDuration = 0, this._debugSource = null, this._debugOwner = null, this._debugNeedsRemount = !1, this._debugHookTypes = null, !hasBadMapPolyfill && typeof Object.preventExtensions == "function" && Object.preventExtensions(this);
      }
      var createFiber = function(tag, pendingProps, key, mode) {
        return new FiberNode(tag, pendingProps, key, mode);
      };
      function shouldConstruct$1(Component) {
        var prototype = Component.prototype;
        return !!(prototype && prototype.isReactComponent);
      }
      function isSimpleFunctionComponent(type) {
        return typeof type == "function" && !shouldConstruct$1(type) && type.defaultProps === void 0;
      }
      function resolveLazyComponentTag(Component) {
        if (typeof Component == "function")
          return shouldConstruct$1(Component) ? ClassComponent : FunctionComponent;
        if (Component != null) {
          var $$typeof = Component.$$typeof;
          if ($$typeof === REACT_FORWARD_REF_TYPE)
            return ForwardRef;
          if ($$typeof === REACT_MEMO_TYPE)
            return MemoComponent;
        }
        return IndeterminateComponent;
      }
      function createWorkInProgress(current2, pendingProps) {
        var workInProgress2 = current2.alternate;
        workInProgress2 === null ? (workInProgress2 = createFiber(current2.tag, pendingProps, current2.key, current2.mode), workInProgress2.elementType = current2.elementType, workInProgress2.type = current2.type, workInProgress2.stateNode = current2.stateNode, workInProgress2._debugSource = current2._debugSource, workInProgress2._debugOwner = current2._debugOwner, workInProgress2._debugHookTypes = current2._debugHookTypes, workInProgress2.alternate = current2, current2.alternate = workInProgress2) : (workInProgress2.pendingProps = pendingProps, workInProgress2.type = current2.type, workInProgress2.flags = NoFlags, workInProgress2.subtreeFlags = NoFlags, workInProgress2.deletions = null, workInProgress2.actualDuration = 0, workInProgress2.actualStartTime = -1), workInProgress2.flags = current2.flags & StaticMask, workInProgress2.childLanes = current2.childLanes, workInProgress2.lanes = current2.lanes, workInProgress2.child = current2.child, workInProgress2.memoizedProps = current2.memoizedProps, workInProgress2.memoizedState = current2.memoizedState, workInProgress2.updateQueue = current2.updateQueue;
        var currentDependencies = current2.dependencies;
        switch (workInProgress2.dependencies = currentDependencies === null ? null : {
          lanes: currentDependencies.lanes,
          firstContext: currentDependencies.firstContext
        }, workInProgress2.sibling = current2.sibling, workInProgress2.index = current2.index, workInProgress2.ref = current2.ref, workInProgress2.selfBaseDuration = current2.selfBaseDuration, workInProgress2.treeBaseDuration = current2.treeBaseDuration, workInProgress2._debugNeedsRemount = current2._debugNeedsRemount, workInProgress2.tag) {
          case IndeterminateComponent:
          case FunctionComponent:
          case SimpleMemoComponent:
            workInProgress2.type = resolveFunctionForHotReloading(current2.type);
            break;
          case ClassComponent:
            workInProgress2.type = resolveClassForHotReloading(current2.type);
            break;
          case ForwardRef:
            workInProgress2.type = resolveForwardRefForHotReloading(current2.type);
            break;
        }
        return workInProgress2;
      }
      function resetWorkInProgress(workInProgress2, renderLanes2) {
        workInProgress2.flags &= StaticMask | Placement;
        var current2 = workInProgress2.alternate;
        if (current2 === null)
          workInProgress2.childLanes = NoLanes, workInProgress2.lanes = renderLanes2, workInProgress2.child = null, workInProgress2.subtreeFlags = NoFlags, workInProgress2.memoizedProps = null, workInProgress2.memoizedState = null, workInProgress2.updateQueue = null, workInProgress2.dependencies = null, workInProgress2.stateNode = null, workInProgress2.selfBaseDuration = 0, workInProgress2.treeBaseDuration = 0;
        else {
          workInProgress2.childLanes = current2.childLanes, workInProgress2.lanes = current2.lanes, workInProgress2.child = current2.child, workInProgress2.subtreeFlags = NoFlags, workInProgress2.deletions = null, workInProgress2.memoizedProps = current2.memoizedProps, workInProgress2.memoizedState = current2.memoizedState, workInProgress2.updateQueue = current2.updateQueue, workInProgress2.type = current2.type;
          var currentDependencies = current2.dependencies;
          workInProgress2.dependencies = currentDependencies === null ? null : {
            lanes: currentDependencies.lanes,
            firstContext: currentDependencies.firstContext
          }, workInProgress2.selfBaseDuration = current2.selfBaseDuration, workInProgress2.treeBaseDuration = current2.treeBaseDuration;
        }
        return workInProgress2;
      }
      function createHostRootFiber(tag, isStrictMode, concurrentUpdatesByDefaultOverride) {
        var mode;
        return tag === ConcurrentRoot ? (mode = ConcurrentMode, isStrictMode === !0 && (mode |= StrictLegacyMode, mode |= StrictEffectsMode)) : mode = NoMode, isDevToolsPresent && (mode |= ProfileMode), createFiber(HostRoot, null, null, mode);
      }
      function createFiberFromTypeAndProps(type, key, pendingProps, owner, mode, lanes) {
        var fiberTag = IndeterminateComponent, resolvedType = type;
        if (typeof type == "function")
          shouldConstruct$1(type) ? (fiberTag = ClassComponent, resolvedType = resolveClassForHotReloading(resolvedType)) : resolvedType = resolveFunctionForHotReloading(resolvedType);
        else if (typeof type == "string")
          fiberTag = HostComponent;
        else
          getTag:
            switch (type) {
              case REACT_FRAGMENT_TYPE:
                return createFiberFromFragment(pendingProps.children, mode, lanes, key);
              case REACT_STRICT_MODE_TYPE:
                fiberTag = Mode, mode |= StrictLegacyMode, (mode & ConcurrentMode) !== NoMode && (mode |= StrictEffectsMode);
                break;
              case REACT_PROFILER_TYPE:
                return createFiberFromProfiler(pendingProps, mode, lanes, key);
              case REACT_SUSPENSE_TYPE:
                return createFiberFromSuspense(pendingProps, mode, lanes, key);
              case REACT_SUSPENSE_LIST_TYPE:
                return createFiberFromSuspenseList(pendingProps, mode, lanes, key);
              case REACT_OFFSCREEN_TYPE:
                return createFiberFromOffscreen(pendingProps, mode, lanes, key);
              case REACT_LEGACY_HIDDEN_TYPE:
              case REACT_SCOPE_TYPE:
              case REACT_CACHE_TYPE:
              case REACT_TRACING_MARKER_TYPE:
              case REACT_DEBUG_TRACING_MODE_TYPE:
              default: {
                if (typeof type == "object" && type !== null)
                  switch (type.$$typeof) {
                    case REACT_PROVIDER_TYPE:
                      fiberTag = ContextProvider;
                      break getTag;
                    case REACT_CONTEXT_TYPE:
                      fiberTag = ContextConsumer;
                      break getTag;
                    case REACT_FORWARD_REF_TYPE:
                      fiberTag = ForwardRef, resolvedType = resolveForwardRefForHotReloading(resolvedType);
                      break getTag;
                    case REACT_MEMO_TYPE:
                      fiberTag = MemoComponent;
                      break getTag;
                    case REACT_LAZY_TYPE:
                      fiberTag = LazyComponent, resolvedType = null;
                      break getTag;
                  }
                var info2 = "";
                {
                  (type === void 0 || typeof type == "object" && type !== null && Object.keys(type).length === 0) && (info2 += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
                  var ownerName = owner ? getComponentNameFromFiber(owner) : null;
                  ownerName && (info2 += `

Check the render method of \`` + ownerName + "`.");
                }
                throw new Error("Element type is invalid: expected a string (for built-in components) or a class/function (for composite components) " + ("but got: " + (type == null ? type : typeof type) + "." + info2));
              }
            }
        var fiber = createFiber(fiberTag, pendingProps, key, mode);
        return fiber.elementType = type, fiber.type = resolvedType, fiber.lanes = lanes, fiber._debugOwner = owner, fiber;
      }
      function createFiberFromElement(element, mode, lanes) {
        var owner = null;
        owner = element._owner;
        var type = element.type, key = element.key, pendingProps = element.props, fiber = createFiberFromTypeAndProps(type, key, pendingProps, owner, mode, lanes);
        return fiber._debugSource = element._source, fiber._debugOwner = element._owner, fiber;
      }
      function createFiberFromFragment(elements, mode, lanes, key) {
        var fiber = createFiber(Fragment, elements, key, mode);
        return fiber.lanes = lanes, fiber;
      }
      function createFiberFromProfiler(pendingProps, mode, lanes, key) {
        typeof pendingProps.id != "string" && error('Profiler must specify an "id" of type `string` as a prop. Received the type `%s` instead.', typeof pendingProps.id);
        var fiber = createFiber(Profiler, pendingProps, key, mode | ProfileMode);
        return fiber.elementType = REACT_PROFILER_TYPE, fiber.lanes = lanes, fiber.stateNode = {
          effectDuration: 0,
          passiveEffectDuration: 0
        }, fiber;
      }
      function createFiberFromSuspense(pendingProps, mode, lanes, key) {
        var fiber = createFiber(SuspenseComponent, pendingProps, key, mode);
        return fiber.elementType = REACT_SUSPENSE_TYPE, fiber.lanes = lanes, fiber;
      }
      function createFiberFromSuspenseList(pendingProps, mode, lanes, key) {
        var fiber = createFiber(SuspenseListComponent, pendingProps, key, mode);
        return fiber.elementType = REACT_SUSPENSE_LIST_TYPE, fiber.lanes = lanes, fiber;
      }
      function createFiberFromOffscreen(pendingProps, mode, lanes, key) {
        var fiber = createFiber(OffscreenComponent, pendingProps, key, mode);
        fiber.elementType = REACT_OFFSCREEN_TYPE, fiber.lanes = lanes;
        var primaryChildInstance = {
          isHidden: !1
        };
        return fiber.stateNode = primaryChildInstance, fiber;
      }
      function createFiberFromText(content, mode, lanes) {
        var fiber = createFiber(HostText, content, null, mode);
        return fiber.lanes = lanes, fiber;
      }
      function createFiberFromHostInstanceForDeletion() {
        var fiber = createFiber(HostComponent, null, null, NoMode);
        return fiber.elementType = "DELETED", fiber;
      }
      function createFiberFromDehydratedFragment(dehydratedNode) {
        var fiber = createFiber(DehydratedFragment, null, null, NoMode);
        return fiber.stateNode = dehydratedNode, fiber;
      }
      function createFiberFromPortal(portal, mode, lanes) {
        var pendingProps = portal.children !== null ? portal.children : [], fiber = createFiber(HostPortal, pendingProps, portal.key, mode);
        return fiber.lanes = lanes, fiber.stateNode = {
          containerInfo: portal.containerInfo,
          pendingChildren: null,
          // Used by persistent updates
          implementation: portal.implementation
        }, fiber;
      }
      function assignFiberPropertiesInDEV(target, source) {
        return target === null && (target = createFiber(IndeterminateComponent, null, null, NoMode)), target.tag = source.tag, target.key = source.key, target.elementType = source.elementType, target.type = source.type, target.stateNode = source.stateNode, target.return = source.return, target.child = source.child, target.sibling = source.sibling, target.index = source.index, target.ref = source.ref, target.pendingProps = source.pendingProps, target.memoizedProps = source.memoizedProps, target.updateQueue = source.updateQueue, target.memoizedState = source.memoizedState, target.dependencies = source.dependencies, target.mode = source.mode, target.flags = source.flags, target.subtreeFlags = source.subtreeFlags, target.deletions = source.deletions, target.lanes = source.lanes, target.childLanes = source.childLanes, target.alternate = source.alternate, target.actualDuration = source.actualDuration, target.actualStartTime = source.actualStartTime, target.selfBaseDuration = source.selfBaseDuration, target.treeBaseDuration = source.treeBaseDuration, target._debugSource = source._debugSource, target._debugOwner = source._debugOwner, target._debugNeedsRemount = source._debugNeedsRemount, target._debugHookTypes = source._debugHookTypes, target;
      }
      function FiberRootNode(containerInfo, tag, hydrate2, identifierPrefix, onRecoverableError) {
        this.tag = tag, this.containerInfo = containerInfo, this.pendingChildren = null, this.current = null, this.pingCache = null, this.finishedWork = null, this.timeoutHandle = noTimeout, this.context = null, this.pendingContext = null, this.callbackNode = null, this.callbackPriority = NoLane, this.eventTimes = createLaneMap(NoLanes), this.expirationTimes = createLaneMap(NoTimestamp), this.pendingLanes = NoLanes, this.suspendedLanes = NoLanes, this.pingedLanes = NoLanes, this.expiredLanes = NoLanes, this.mutableReadLanes = NoLanes, this.finishedLanes = NoLanes, this.entangledLanes = NoLanes, this.entanglements = createLaneMap(NoLanes), this.identifierPrefix = identifierPrefix, this.onRecoverableError = onRecoverableError, this.mutableSourceEagerHydrationData = null, this.effectDuration = 0, this.passiveEffectDuration = 0;
        {
          this.memoizedUpdaters = /* @__PURE__ */ new Set();
          for (var pendingUpdatersLaneMap = this.pendingUpdatersLaneMap = [], _i = 0; _i < TotalLanes; _i++)
            pendingUpdatersLaneMap.push(/* @__PURE__ */ new Set());
        }
        switch (tag) {
          case ConcurrentRoot:
            this._debugRootType = hydrate2 ? "hydrateRoot()" : "createRoot()";
            break;
          case LegacyRoot:
            this._debugRootType = hydrate2 ? "hydrate()" : "render()";
            break;
        }
      }
      function createFiberRoot(containerInfo, tag, hydrate2, initialChildren, hydrationCallbacks, isStrictMode, concurrentUpdatesByDefaultOverride, identifierPrefix, onRecoverableError, transitionCallbacks) {
        var root2 = new FiberRootNode(containerInfo, tag, hydrate2, identifierPrefix, onRecoverableError), uninitializedFiber = createHostRootFiber(tag, isStrictMode);
        root2.current = uninitializedFiber, uninitializedFiber.stateNode = root2;
        {
          var _initialState = {
            element: initialChildren,
            isDehydrated: hydrate2,
            cache: null,
            // not enabled yet
            transitions: null,
            pendingSuspenseBoundaries: null
          };
          uninitializedFiber.memoizedState = _initialState;
        }
        return initializeUpdateQueue(uninitializedFiber), root2;
      }
      var ReactVersion = "18.2.0";
      function createPortal(children, containerInfo, implementation) {
        var key = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null;
        return checkKeyStringCoercion(key), {
          // This tag allow us to uniquely identify this as a React Portal
          $$typeof: REACT_PORTAL_TYPE,
          key: key == null ? null : "" + key,
          children,
          containerInfo,
          implementation
        };
      }
      var didWarnAboutNestedUpdates, didWarnAboutFindNodeInStrictMode;
      didWarnAboutNestedUpdates = !1, didWarnAboutFindNodeInStrictMode = {};
      function getContextForSubtree(parentComponent) {
        if (!parentComponent)
          return emptyContextObject;
        var fiber = get2(parentComponent), parentContext = findCurrentUnmaskedContext(fiber);
        if (fiber.tag === ClassComponent) {
          var Component = fiber.type;
          if (isContextProvider(Component))
            return processChildContext(fiber, Component, parentContext);
        }
        return parentContext;
      }
      function findHostInstanceWithWarning(component, methodName) {
        {
          var fiber = get2(component);
          if (fiber === void 0) {
            if (typeof component.render == "function")
              throw new Error("Unable to find node on an unmounted component.");
            var keys = Object.keys(component).join(",");
            throw new Error("Argument appears to not be a ReactComponent. Keys: " + keys);
          }
          var hostFiber = findCurrentHostFiber(fiber);
          if (hostFiber === null)
            return null;
          if (hostFiber.mode & StrictLegacyMode) {
            var componentName = getComponentNameFromFiber(fiber) || "Component";
            if (!didWarnAboutFindNodeInStrictMode[componentName]) {
              didWarnAboutFindNodeInStrictMode[componentName] = !0;
              var previousFiber = current;
              try {
                setCurrentFiber(hostFiber), fiber.mode & StrictLegacyMode ? error("%s is deprecated in StrictMode. %s was passed an instance of %s which is inside StrictMode. Instead, add a ref directly to the element you want to reference. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-find-node", methodName, methodName, componentName) : error("%s is deprecated in StrictMode. %s was passed an instance of %s which renders StrictMode children. Instead, add a ref directly to the element you want to reference. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-find-node", methodName, methodName, componentName);
              } finally {
                previousFiber ? setCurrentFiber(previousFiber) : resetCurrentFiber();
              }
            }
          }
          return hostFiber.stateNode;
        }
      }
      function createContainer(containerInfo, tag, hydrationCallbacks, isStrictMode, concurrentUpdatesByDefaultOverride, identifierPrefix, onRecoverableError, transitionCallbacks) {
        var hydrate2 = !1, initialChildren = null;
        return createFiberRoot(containerInfo, tag, hydrate2, initialChildren, hydrationCallbacks, isStrictMode, concurrentUpdatesByDefaultOverride, identifierPrefix, onRecoverableError);
      }
      function createHydrationContainer(initialChildren, callback, containerInfo, tag, hydrationCallbacks, isStrictMode, concurrentUpdatesByDefaultOverride, identifierPrefix, onRecoverableError, transitionCallbacks) {
        var hydrate2 = !0, root2 = createFiberRoot(containerInfo, tag, hydrate2, initialChildren, hydrationCallbacks, isStrictMode, concurrentUpdatesByDefaultOverride, identifierPrefix, onRecoverableError);
        root2.context = getContextForSubtree(null);
        var current2 = root2.current, eventTime = requestEventTime(), lane = requestUpdateLane(current2), update2 = createUpdate(eventTime, lane);
        return update2.callback = callback ?? null, enqueueUpdate(current2, update2, lane), scheduleInitialHydrationOnRoot(root2, lane, eventTime), root2;
      }
      function updateContainer(element, container, parentComponent, callback) {
        onScheduleRoot(container, element);
        var current$1 = container.current, eventTime = requestEventTime(), lane = requestUpdateLane(current$1);
        markRenderScheduled(lane);
        var context = getContextForSubtree(parentComponent);
        container.context === null ? container.context = context : container.pendingContext = context, isRendering && current !== null && !didWarnAboutNestedUpdates && (didWarnAboutNestedUpdates = !0, error(`Render methods should be a pure function of props and state; triggering nested component updates from render is not allowed. If necessary, trigger nested updates in componentDidUpdate.

Check the render method of %s.`, getComponentNameFromFiber(current) || "Unknown"));
        var update2 = createUpdate(eventTime, lane);
        update2.payload = {
          element
        }, callback = callback === void 0 ? null : callback, callback !== null && (typeof callback != "function" && error("render(...): Expected the last optional `callback` argument to be a function. Instead received: %s.", callback), update2.callback = callback);
        var root2 = enqueueUpdate(current$1, update2, lane);
        return root2 !== null && (scheduleUpdateOnFiber(root2, current$1, lane, eventTime), entangleTransitions(root2, current$1, lane)), lane;
      }
      function getPublicRootInstance(container) {
        var containerFiber = container.current;
        if (!containerFiber.child)
          return null;
        switch (containerFiber.child.tag) {
          case HostComponent:
            return containerFiber.child.stateNode;
          default:
            return containerFiber.child.stateNode;
        }
      }
      function attemptSynchronousHydration$1(fiber) {
        switch (fiber.tag) {
          case HostRoot: {
            var root2 = fiber.stateNode;
            if (isRootDehydrated(root2)) {
              var lanes = getHighestPriorityPendingLanes(root2);
              flushRoot(root2, lanes);
            }
            break;
          }
          case SuspenseComponent: {
            flushSync(function() {
              var root3 = enqueueConcurrentRenderForLane(fiber, SyncLane);
              if (root3 !== null) {
                var eventTime = requestEventTime();
                scheduleUpdateOnFiber(root3, fiber, SyncLane, eventTime);
              }
            });
            var retryLane = SyncLane;
            markRetryLaneIfNotHydrated(fiber, retryLane);
            break;
          }
        }
      }
      function markRetryLaneImpl(fiber, retryLane) {
        var suspenseState = fiber.memoizedState;
        suspenseState !== null && suspenseState.dehydrated !== null && (suspenseState.retryLane = higherPriorityLane(suspenseState.retryLane, retryLane));
      }
      function markRetryLaneIfNotHydrated(fiber, retryLane) {
        markRetryLaneImpl(fiber, retryLane);
        var alternate = fiber.alternate;
        alternate && markRetryLaneImpl(alternate, retryLane);
      }
      function attemptContinuousHydration$1(fiber) {
        if (fiber.tag === SuspenseComponent) {
          var lane = SelectiveHydrationLane, root2 = enqueueConcurrentRenderForLane(fiber, lane);
          if (root2 !== null) {
            var eventTime = requestEventTime();
            scheduleUpdateOnFiber(root2, fiber, lane, eventTime);
          }
          markRetryLaneIfNotHydrated(fiber, lane);
        }
      }
      function attemptHydrationAtCurrentPriority$1(fiber) {
        if (fiber.tag === SuspenseComponent) {
          var lane = requestUpdateLane(fiber), root2 = enqueueConcurrentRenderForLane(fiber, lane);
          if (root2 !== null) {
            var eventTime = requestEventTime();
            scheduleUpdateOnFiber(root2, fiber, lane, eventTime);
          }
          markRetryLaneIfNotHydrated(fiber, lane);
        }
      }
      function findHostInstanceWithNoPortals(fiber) {
        var hostFiber = findCurrentHostFiberWithNoPortals(fiber);
        return hostFiber === null ? null : hostFiber.stateNode;
      }
      var shouldErrorImpl = function(fiber) {
        return null;
      };
      function shouldError(fiber) {
        return shouldErrorImpl(fiber);
      }
      var shouldSuspendImpl = function(fiber) {
        return !1;
      };
      function shouldSuspend(fiber) {
        return shouldSuspendImpl(fiber);
      }
      var overrideHookState = null, overrideHookStateDeletePath = null, overrideHookStateRenamePath = null, overrideProps = null, overridePropsDeletePath = null, overridePropsRenamePath = null, scheduleUpdate = null, setErrorHandler = null, setSuspenseHandler = null;
      {
        var copyWithDeleteImpl = function(obj, path3, index2) {
          var key = path3[index2], updated = isArray(obj) ? obj.slice() : assign({}, obj);
          return index2 + 1 === path3.length ? (isArray(updated) ? updated.splice(key, 1) : delete updated[key], updated) : (updated[key] = copyWithDeleteImpl(obj[key], path3, index2 + 1), updated);
        }, copyWithDelete = function(obj, path3) {
          return copyWithDeleteImpl(obj, path3, 0);
        }, copyWithRenameImpl = function(obj, oldPath, newPath, index2) {
          var oldKey = oldPath[index2], updated = isArray(obj) ? obj.slice() : assign({}, obj);
          if (index2 + 1 === oldPath.length) {
            var newKey = newPath[index2];
            updated[newKey] = updated[oldKey], isArray(updated) ? updated.splice(oldKey, 1) : delete updated[oldKey];
          } else
            updated[oldKey] = copyWithRenameImpl(
              // $FlowFixMe number or string is fine here
              obj[oldKey],
              oldPath,
              newPath,
              index2 + 1
            );
          return updated;
        }, copyWithRename = function(obj, oldPath, newPath) {
          if (oldPath.length !== newPath.length) {
            warn("copyWithRename() expects paths of the same length");
            return;
          } else
            for (var i = 0; i < newPath.length - 1; i++)
              if (oldPath[i] !== newPath[i]) {
                warn("copyWithRename() expects paths to be the same except for the deepest key");
                return;
              }
          return copyWithRenameImpl(obj, oldPath, newPath, 0);
        }, copyWithSetImpl = function(obj, path3, index2, value) {
          if (index2 >= path3.length)
            return value;
          var key = path3[index2], updated = isArray(obj) ? obj.slice() : assign({}, obj);
          return updated[key] = copyWithSetImpl(obj[key], path3, index2 + 1, value), updated;
        }, copyWithSet = function(obj, path3, value) {
          return copyWithSetImpl(obj, path3, 0, value);
        }, findHook = function(fiber, id) {
          for (var currentHook2 = fiber.memoizedState; currentHook2 !== null && id > 0; )
            currentHook2 = currentHook2.next, id--;
          return currentHook2;
        };
        overrideHookState = function(fiber, id, path3, value) {
          var hook2 = findHook(fiber, id);
          if (hook2 !== null) {
            var newState = copyWithSet(hook2.memoizedState, path3, value);
            hook2.memoizedState = newState, hook2.baseState = newState, fiber.memoizedProps = assign({}, fiber.memoizedProps);
            var root2 = enqueueConcurrentRenderForLane(fiber, SyncLane);
            root2 !== null && scheduleUpdateOnFiber(root2, fiber, SyncLane, NoTimestamp);
          }
        }, overrideHookStateDeletePath = function(fiber, id, path3) {
          var hook2 = findHook(fiber, id);
          if (hook2 !== null) {
            var newState = copyWithDelete(hook2.memoizedState, path3);
            hook2.memoizedState = newState, hook2.baseState = newState, fiber.memoizedProps = assign({}, fiber.memoizedProps);
            var root2 = enqueueConcurrentRenderForLane(fiber, SyncLane);
            root2 !== null && scheduleUpdateOnFiber(root2, fiber, SyncLane, NoTimestamp);
          }
        }, overrideHookStateRenamePath = function(fiber, id, oldPath, newPath) {
          var hook2 = findHook(fiber, id);
          if (hook2 !== null) {
            var newState = copyWithRename(hook2.memoizedState, oldPath, newPath);
            hook2.memoizedState = newState, hook2.baseState = newState, fiber.memoizedProps = assign({}, fiber.memoizedProps);
            var root2 = enqueueConcurrentRenderForLane(fiber, SyncLane);
            root2 !== null && scheduleUpdateOnFiber(root2, fiber, SyncLane, NoTimestamp);
          }
        }, overrideProps = function(fiber, path3, value) {
          fiber.pendingProps = copyWithSet(fiber.memoizedProps, path3, value), fiber.alternate && (fiber.alternate.pendingProps = fiber.pendingProps);
          var root2 = enqueueConcurrentRenderForLane(fiber, SyncLane);
          root2 !== null && scheduleUpdateOnFiber(root2, fiber, SyncLane, NoTimestamp);
        }, overridePropsDeletePath = function(fiber, path3) {
          fiber.pendingProps = copyWithDelete(fiber.memoizedProps, path3), fiber.alternate && (fiber.alternate.pendingProps = fiber.pendingProps);
          var root2 = enqueueConcurrentRenderForLane(fiber, SyncLane);
          root2 !== null && scheduleUpdateOnFiber(root2, fiber, SyncLane, NoTimestamp);
        }, overridePropsRenamePath = function(fiber, oldPath, newPath) {
          fiber.pendingProps = copyWithRename(fiber.memoizedProps, oldPath, newPath), fiber.alternate && (fiber.alternate.pendingProps = fiber.pendingProps);
          var root2 = enqueueConcurrentRenderForLane(fiber, SyncLane);
          root2 !== null && scheduleUpdateOnFiber(root2, fiber, SyncLane, NoTimestamp);
        }, scheduleUpdate = function(fiber) {
          var root2 = enqueueConcurrentRenderForLane(fiber, SyncLane);
          root2 !== null && scheduleUpdateOnFiber(root2, fiber, SyncLane, NoTimestamp);
        }, setErrorHandler = function(newShouldErrorImpl) {
          shouldErrorImpl = newShouldErrorImpl;
        }, setSuspenseHandler = function(newShouldSuspendImpl) {
          shouldSuspendImpl = newShouldSuspendImpl;
        };
      }
      function findHostInstanceByFiber(fiber) {
        var hostFiber = findCurrentHostFiber(fiber);
        return hostFiber === null ? null : hostFiber.stateNode;
      }
      function emptyFindFiberByHostInstance(instance) {
        return null;
      }
      function getCurrentFiberForDevTools() {
        return current;
      }
      function injectIntoDevTools(devToolsConfig) {
        var findFiberByHostInstance = devToolsConfig.findFiberByHostInstance, ReactCurrentDispatcher2 = ReactSharedInternals.ReactCurrentDispatcher;
        return injectInternals({
          bundleType: devToolsConfig.bundleType,
          version: devToolsConfig.version,
          rendererPackageName: devToolsConfig.rendererPackageName,
          rendererConfig: devToolsConfig.rendererConfig,
          overrideHookState,
          overrideHookStateDeletePath,
          overrideHookStateRenamePath,
          overrideProps,
          overridePropsDeletePath,
          overridePropsRenamePath,
          setErrorHandler,
          setSuspenseHandler,
          scheduleUpdate,
          currentDispatcherRef: ReactCurrentDispatcher2,
          findHostInstanceByFiber,
          findFiberByHostInstance: findFiberByHostInstance || emptyFindFiberByHostInstance,
          // React Refresh
          findHostInstancesForRefresh,
          scheduleRefresh,
          scheduleRoot,
          setRefreshHandler,
          // Enables DevTools to append owner stacks to error messages in DEV mode.
          getCurrentFiber: getCurrentFiberForDevTools,
          // Enables DevTools to detect reconciler version rather than renderer version
          // which may not match for third party renderers.
          reconcilerVersion: ReactVersion
        });
      }
      var defaultOnRecoverableError = typeof reportError == "function" ? (
        // In modern browsers, reportError will dispatch an error event,
        // emulating an uncaught JavaScript error.
        reportError
      ) : function(error2) {
        console.error(error2);
      };
      function ReactDOMRoot(internalRoot) {
        this._internalRoot = internalRoot;
      }
      ReactDOMHydrationRoot.prototype.render = ReactDOMRoot.prototype.render = function(children) {
        var root2 = this._internalRoot;
        if (root2 === null)
          throw new Error("Cannot update an unmounted root.");
        {
          typeof arguments[1] == "function" ? error("render(...): does not support the second callback argument. To execute a side effect after rendering, declare it in a component body with useEffect().") : isValidContainer(arguments[1]) ? error("You passed a container to the second argument of root.render(...). You don't need to pass it again since you already passed it to create the root.") : typeof arguments[1] < "u" && error("You passed a second argument to root.render(...) but it only accepts one argument.");
          var container = root2.containerInfo;
          if (container.nodeType !== COMMENT_NODE) {
            var hostInstance = findHostInstanceWithNoPortals(root2.current);
            hostInstance && hostInstance.parentNode !== container && error("render(...): It looks like the React-rendered content of the root container was removed without using React. This is not supported and will cause errors. Instead, call root.unmount() to empty a root's container.");
          }
        }
        updateContainer(children, root2, null, null);
      }, ReactDOMHydrationRoot.prototype.unmount = ReactDOMRoot.prototype.unmount = function() {
        typeof arguments[0] == "function" && error("unmount(...): does not support a callback argument. To execute a side effect after rendering, declare it in a component body with useEffect().");
        var root2 = this._internalRoot;
        if (root2 !== null) {
          this._internalRoot = null;
          var container = root2.containerInfo;
          isAlreadyRendering() && error("Attempted to synchronously unmount a root while React was already rendering. React cannot finish unmounting the root until the current render has completed, which may lead to a race condition."), flushSync(function() {
            updateContainer(null, root2, null, null);
          }), unmarkContainerAsRoot(container);
        }
      };
      function createRoot(container, options2) {
        if (!isValidContainer(container))
          throw new Error("createRoot(...): Target container is not a DOM element.");
        warnIfReactDOMContainerInDEV(container);
        var isStrictMode = !1, concurrentUpdatesByDefaultOverride = !1, identifierPrefix = "", onRecoverableError = defaultOnRecoverableError, transitionCallbacks = null;
        options2 != null && (options2.hydrate ? warn("hydrate through createRoot is deprecated. Use ReactDOMClient.hydrateRoot(container, <App />) instead.") : typeof options2 == "object" && options2 !== null && options2.$$typeof === REACT_ELEMENT_TYPE && error(`You passed a JSX element to createRoot. You probably meant to call root.render instead. Example usage:

  let root = createRoot(domContainer);
  root.render(<App />);`), options2.unstable_strictMode === !0 && (isStrictMode = !0), options2.identifierPrefix !== void 0 && (identifierPrefix = options2.identifierPrefix), options2.onRecoverableError !== void 0 && (onRecoverableError = options2.onRecoverableError), options2.transitionCallbacks !== void 0 && (transitionCallbacks = options2.transitionCallbacks));
        var root2 = createContainer(container, ConcurrentRoot, null, isStrictMode, concurrentUpdatesByDefaultOverride, identifierPrefix, onRecoverableError);
        markContainerAsRoot(root2.current, container);
        var rootContainerElement = container.nodeType === COMMENT_NODE ? container.parentNode : container;
        return listenToAllSupportedEvents(rootContainerElement), new ReactDOMRoot(root2);
      }
      function ReactDOMHydrationRoot(internalRoot) {
        this._internalRoot = internalRoot;
      }
      function scheduleHydration(target) {
        target && queueExplicitHydrationTarget(target);
      }
      ReactDOMHydrationRoot.prototype.unstable_scheduleHydration = scheduleHydration;
      function hydrateRoot(container, initialChildren, options2) {
        if (!isValidContainer(container))
          throw new Error("hydrateRoot(...): Target container is not a DOM element.");
        warnIfReactDOMContainerInDEV(container), initialChildren === void 0 && error("Must provide initial children as second argument to hydrateRoot. Example usage: hydrateRoot(domContainer, <App />)");
        var hydrationCallbacks = options2 ?? null, mutableSources = options2 != null && options2.hydratedSources || null, isStrictMode = !1, concurrentUpdatesByDefaultOverride = !1, identifierPrefix = "", onRecoverableError = defaultOnRecoverableError;
        options2 != null && (options2.unstable_strictMode === !0 && (isStrictMode = !0), options2.identifierPrefix !== void 0 && (identifierPrefix = options2.identifierPrefix), options2.onRecoverableError !== void 0 && (onRecoverableError = options2.onRecoverableError));
        var root2 = createHydrationContainer(initialChildren, null, container, ConcurrentRoot, hydrationCallbacks, isStrictMode, concurrentUpdatesByDefaultOverride, identifierPrefix, onRecoverableError);
        if (markContainerAsRoot(root2.current, container), listenToAllSupportedEvents(container), mutableSources)
          for (var i = 0; i < mutableSources.length; i++) {
            var mutableSource = mutableSources[i];
            registerMutableSourceForHydration(root2, mutableSource);
          }
        return new ReactDOMHydrationRoot(root2);
      }
      function isValidContainer(node) {
        return !!(node && (node.nodeType === ELEMENT_NODE || node.nodeType === DOCUMENT_NODE || node.nodeType === DOCUMENT_FRAGMENT_NODE || !disableCommentsAsDOMContainers));
      }
      function isValidContainerLegacy(node) {
        return !!(node && (node.nodeType === ELEMENT_NODE || node.nodeType === DOCUMENT_NODE || node.nodeType === DOCUMENT_FRAGMENT_NODE || node.nodeType === COMMENT_NODE && node.nodeValue === " react-mount-point-unstable "));
      }
      function warnIfReactDOMContainerInDEV(container) {
        container.nodeType === ELEMENT_NODE && container.tagName && container.tagName.toUpperCase() === "BODY" && error("createRoot(): Creating roots directly with document.body is discouraged, since its children are often manipulated by third-party scripts and browser extensions. This may lead to subtle reconciliation issues. Try using a container element created for your app."), isContainerMarkedAsRoot(container) && (container._reactRootContainer ? error("You are calling ReactDOMClient.createRoot() on a container that was previously passed to ReactDOM.render(). This is not supported.") : error("You are calling ReactDOMClient.createRoot() on a container that has already been passed to createRoot() before. Instead, call root.render() on the existing root instead if you want to update it."));
      }
      var ReactCurrentOwner$3 = ReactSharedInternals.ReactCurrentOwner, topLevelUpdateWarnings;
      topLevelUpdateWarnings = function(container) {
        if (container._reactRootContainer && container.nodeType !== COMMENT_NODE) {
          var hostInstance = findHostInstanceWithNoPortals(container._reactRootContainer.current);
          hostInstance && hostInstance.parentNode !== container && error("render(...): It looks like the React-rendered content of this container was removed without using React. This is not supported and will cause errors. Instead, call ReactDOM.unmountComponentAtNode to empty a container.");
        }
        var isRootRenderedBySomeReact = !!container._reactRootContainer, rootEl = getReactRootElementInContainer(container), hasNonRootReactChild = !!(rootEl && getInstanceFromNode(rootEl));
        hasNonRootReactChild && !isRootRenderedBySomeReact && error("render(...): Replacing React-rendered children with a new root component. If you intended to update the children of this node, you should instead have the existing children update their state and render the new components instead of calling ReactDOM.render."), container.nodeType === ELEMENT_NODE && container.tagName && container.tagName.toUpperCase() === "BODY" && error("render(): Rendering components directly into document.body is discouraged, since its children are often manipulated by third-party scripts and browser extensions. This may lead to subtle reconciliation issues. Try rendering into a container element created for your app.");
      };
      function getReactRootElementInContainer(container) {
        return container ? container.nodeType === DOCUMENT_NODE ? container.documentElement : container.firstChild : null;
      }
      function noopOnRecoverableError() {
      }
      function legacyCreateRootFromDOMContainer(container, initialChildren, parentComponent, callback, isHydrationContainer) {
        if (isHydrationContainer) {
          if (typeof callback == "function") {
            var originalCallback = callback;
            callback = function() {
              var instance = getPublicRootInstance(root2);
              originalCallback.call(instance);
            };
          }
          var root2 = createHydrationContainer(
            initialChildren,
            callback,
            container,
            LegacyRoot,
            null,
            // hydrationCallbacks
            !1,
            // isStrictMode
            !1,
            // concurrentUpdatesByDefaultOverride,
            "",
            // identifierPrefix
            noopOnRecoverableError
          );
          container._reactRootContainer = root2, markContainerAsRoot(root2.current, container);
          var rootContainerElement = container.nodeType === COMMENT_NODE ? container.parentNode : container;
          return listenToAllSupportedEvents(rootContainerElement), flushSync(), root2;
        } else {
          for (var rootSibling; rootSibling = container.lastChild; )
            container.removeChild(rootSibling);
          if (typeof callback == "function") {
            var _originalCallback = callback;
            callback = function() {
              var instance = getPublicRootInstance(_root);
              _originalCallback.call(instance);
            };
          }
          var _root = createContainer(
            container,
            LegacyRoot,
            null,
            // hydrationCallbacks
            !1,
            // isStrictMode
            !1,
            // concurrentUpdatesByDefaultOverride,
            "",
            // identifierPrefix
            noopOnRecoverableError
          );
          container._reactRootContainer = _root, markContainerAsRoot(_root.current, container);
          var _rootContainerElement = container.nodeType === COMMENT_NODE ? container.parentNode : container;
          return listenToAllSupportedEvents(_rootContainerElement), flushSync(function() {
            updateContainer(initialChildren, _root, parentComponent, callback);
          }), _root;
        }
      }
      function warnOnInvalidCallback$1(callback, callerName) {
        callback !== null && typeof callback != "function" && error("%s(...): Expected the last optional `callback` argument to be a function. Instead received: %s.", callerName, callback);
      }
      function legacyRenderSubtreeIntoContainer(parentComponent, children, container, forceHydrate, callback) {
        topLevelUpdateWarnings(container), warnOnInvalidCallback$1(callback === void 0 ? null : callback, "render");
        var maybeRoot = container._reactRootContainer, root2;
        if (!maybeRoot)
          root2 = legacyCreateRootFromDOMContainer(container, children, parentComponent, callback, forceHydrate);
        else {
          if (root2 = maybeRoot, typeof callback == "function") {
            var originalCallback = callback;
            callback = function() {
              var instance = getPublicRootInstance(root2);
              originalCallback.call(instance);
            };
          }
          updateContainer(children, root2, parentComponent, callback);
        }
        return getPublicRootInstance(root2);
      }
      function findDOMNode(componentOrElement) {
        {
          var owner = ReactCurrentOwner$3.current;
          if (owner !== null && owner.stateNode !== null) {
            var warnedAboutRefsInRender = owner.stateNode._warnedAboutRefsInRender;
            warnedAboutRefsInRender || error("%s is accessing findDOMNode inside its render(). render() should be a pure function of props and state. It should never access something that requires stale data from the previous render, such as refs. Move this logic to componentDidMount and componentDidUpdate instead.", getComponentNameFromType(owner.type) || "A component"), owner.stateNode._warnedAboutRefsInRender = !0;
          }
        }
        return componentOrElement == null ? null : componentOrElement.nodeType === ELEMENT_NODE ? componentOrElement : findHostInstanceWithWarning(componentOrElement, "findDOMNode");
      }
      function hydrate(element, container, callback) {
        if (error("ReactDOM.hydrate is no longer supported in React 18. Use hydrateRoot instead. Until you switch to the new API, your app will behave as if it's running React 17. Learn more: https://reactjs.org/link/switch-to-createroot"), !isValidContainerLegacy(container))
          throw new Error("Target container is not a DOM element.");
        {
          var isModernRoot = isContainerMarkedAsRoot(container) && container._reactRootContainer === void 0;
          isModernRoot && error("You are calling ReactDOM.hydrate() on a container that was previously passed to ReactDOMClient.createRoot(). This is not supported. Did you mean to call hydrateRoot(container, element)?");
        }
        return legacyRenderSubtreeIntoContainer(null, element, container, !0, callback);
      }
      function render3(element, container, callback) {
        if (error("ReactDOM.render is no longer supported in React 18. Use createRoot instead. Until you switch to the new API, your app will behave as if it's running React 17. Learn more: https://reactjs.org/link/switch-to-createroot"), !isValidContainerLegacy(container))
          throw new Error("Target container is not a DOM element.");
        {
          var isModernRoot = isContainerMarkedAsRoot(container) && container._reactRootContainer === void 0;
          isModernRoot && error("You are calling ReactDOM.render() on a container that was previously passed to ReactDOMClient.createRoot(). This is not supported. Did you mean to call root.render(element)?");
        }
        return legacyRenderSubtreeIntoContainer(null, element, container, !1, callback);
      }
      function unstable_renderSubtreeIntoContainer(parentComponent, element, containerNode, callback) {
        if (error("ReactDOM.unstable_renderSubtreeIntoContainer() is no longer supported in React 18. Consider using a portal instead. Until you switch to the createRoot API, your app will behave as if it's running React 17. Learn more: https://reactjs.org/link/switch-to-createroot"), !isValidContainerLegacy(containerNode))
          throw new Error("Target container is not a DOM element.");
        if (parentComponent == null || !has2(parentComponent))
          throw new Error("parentComponent must be a valid React Component");
        return legacyRenderSubtreeIntoContainer(parentComponent, element, containerNode, !1, callback);
      }
      function unmountComponentAtNode(container) {
        if (!isValidContainerLegacy(container))
          throw new Error("unmountComponentAtNode(...): Target container is not a DOM element.");
        {
          var isModernRoot = isContainerMarkedAsRoot(container) && container._reactRootContainer === void 0;
          isModernRoot && error("You are calling ReactDOM.unmountComponentAtNode() on a container that was previously passed to ReactDOMClient.createRoot(). This is not supported. Did you mean to call root.unmount()?");
        }
        if (container._reactRootContainer) {
          {
            var rootEl = getReactRootElementInContainer(container), renderedByDifferentReact = rootEl && !getInstanceFromNode(rootEl);
            renderedByDifferentReact && error("unmountComponentAtNode(): The node you're attempting to unmount was rendered by another copy of React.");
          }
          return flushSync(function() {
            legacyRenderSubtreeIntoContainer(null, null, container, !1, function() {
              container._reactRootContainer = null, unmarkContainerAsRoot(container);
            });
          }), !0;
        } else {
          {
            var _rootEl = getReactRootElementInContainer(container), hasNonRootReactChild = !!(_rootEl && getInstanceFromNode(_rootEl)), isContainerReactRoot = container.nodeType === ELEMENT_NODE && isValidContainerLegacy(container.parentNode) && !!container.parentNode._reactRootContainer;
            hasNonRootReactChild && error("unmountComponentAtNode(): The node you're attempting to unmount was rendered by React and is not a top-level container. %s", isContainerReactRoot ? "You may have accidentally passed in a React root node instead of its container." : "Instead, have the parent component update its state and rerender in order to remove this component.");
          }
          return !1;
        }
      }
      setAttemptSynchronousHydration(attemptSynchronousHydration$1), setAttemptContinuousHydration(attemptContinuousHydration$1), setAttemptHydrationAtCurrentPriority(attemptHydrationAtCurrentPriority$1), setGetCurrentUpdatePriority(getCurrentUpdatePriority), setAttemptHydrationAtPriority(runWithPriority), (typeof Map != "function" || // $FlowIssue Flow incorrectly thinks Map has no prototype
      Map.prototype == null || typeof Map.prototype.forEach != "function" || typeof Set != "function" || // $FlowIssue Flow incorrectly thinks Set has no prototype
      Set.prototype == null || typeof Set.prototype.clear != "function" || typeof Set.prototype.forEach != "function") && error("React depends on Map and Set built-in types. Make sure that you load a polyfill in older browsers. https://reactjs.org/link/react-polyfills"), setRestoreImplementation(restoreControlledState$3), setBatchingImplementation(batchedUpdates$1, discreteUpdates, flushSync);
      function createPortal$1(children, container) {
        var key = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
        if (!isValidContainer(container))
          throw new Error("Target container is not a DOM element.");
        return createPortal(children, container, null, key);
      }
      function renderSubtreeIntoContainer(parentComponent, element, containerNode, callback) {
        return unstable_renderSubtreeIntoContainer(parentComponent, element, containerNode, callback);
      }
      var Internals = {
        usingClientEntryPoint: !1,
        // Keep in sync with ReactTestUtils.js.
        // This is an array for better minification.
        Events: [getInstanceFromNode, getNodeFromInstance, getFiberCurrentPropsFromNode, enqueueStateRestore, restoreStateIfNeeded, batchedUpdates$1]
      };
      function createRoot$1(container, options2) {
        return Internals.usingClientEntryPoint || error('You are importing createRoot from "react-dom" which is not supported. You should instead import it from "react-dom/client".'), createRoot(container, options2);
      }
      function hydrateRoot$1(container, initialChildren, options2) {
        return Internals.usingClientEntryPoint || error('You are importing hydrateRoot from "react-dom" which is not supported. You should instead import it from "react-dom/client".'), hydrateRoot(container, initialChildren, options2);
      }
      function flushSync$1(fn) {
        return isAlreadyRendering() && error("flushSync was called from inside a lifecycle method. React cannot flush when React is already rendering. Consider moving this call to a scheduler task or micro task."), flushSync(fn);
      }
      var foundDevTools = injectIntoDevTools({
        findFiberByHostInstance: getClosestInstanceFromNode,
        bundleType: 1,
        version: ReactVersion,
        rendererPackageName: "react-dom"
      });
      if (!foundDevTools && canUseDOM && window.top === window.self && (navigator.userAgent.indexOf("Chrome") > -1 && navigator.userAgent.indexOf("Edge") === -1 || navigator.userAgent.indexOf("Firefox") > -1)) {
        var protocol = window.location.protocol;
        /^(https?|file):$/.test(protocol) && console.info("%cDownload the React DevTools for a better development experience: https://reactjs.org/link/react-devtools" + (protocol === "file:" ? `
You might need to use a local HTTP server (instead of file://): https://reactjs.org/link/react-devtools-faq` : ""), "font-weight:bold");
      }
      exports.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = Internals, exports.createPortal = createPortal$1, exports.createRoot = createRoot$1, exports.findDOMNode = findDOMNode, exports.flushSync = flushSync$1, exports.hydrate = hydrate, exports.hydrateRoot = hydrateRoot$1, exports.render = render3, exports.unmountComponentAtNode = unmountComponentAtNode, exports.unstable_batchedUpdates = batchedUpdates$1, exports.unstable_renderSubtreeIntoContainer = renderSubtreeIntoContainer, exports.version = ReactVersion, typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ < "u" && typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop == "function" && __REACT_DEVTOOLS_GLOBAL_HOOK__.registerInternalModuleStop(new Error());
    }();
  }
});

// ../../node_modules/.pnpm/react-dom@18.2.0_react@18.2.0/node_modules/react-dom/index.js
var require_react_dom = __commonJS({
  "../../node_modules/.pnpm/react-dom@18.2.0_react@18.2.0/node_modules/react-dom/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    function checkDCE() {
      if (!(typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ > "u" || typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE != "function")) {
        if (process.env.NODE_ENV !== "production")
          throw new Error("^_^");
        try {
          __REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE(checkDCE);
        } catch (err2) {
          console.error(err2);
        }
      }
    }
    process.env.NODE_ENV === "production" ? (checkDCE(), module.exports = require_react_dom_production_min()) : module.exports = require_react_dom_development();
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/portals/hooks.js
var require_hooks4 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/portals/hooks.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), context = require_context7();
    function usePortalsManager() {
      let portalsManager = React12.useContext(context.PortalsManagerContext);
      if (!portalsManager)
        throw new Error("No portals manager was provided. Your application must be wrapped in an <AppProvider> component. See https://polaris.shopify.com/components/app-provider for implementation instructions.");
      return portalsManager;
    }
    exports.usePortalsManager = usePortalsManager;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Portal/Portal.js
var require_Portal = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Portal/Portal.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), reactDom = require_react_dom(), hooks2 = require_hooks4();
    function Portal({
      children,
      idPrefix = "",
      onPortalCreated = noop
    }) {
      let {
        container
      } = hooks2.usePortalsManager(), uniqueId = React12.useId(), portalId = idPrefix !== "" ? `${idPrefix}-${uniqueId}` : uniqueId;
      return React12.useEffect(() => {
        onPortalCreated();
      }, [onPortalCreated]), container ? /* @__PURE__ */ reactDom.createPortal(/* @__PURE__ */ React12.createElement("div", {
        "data-portal-id": portalId
      }, children), container) : null;
    }
    function noop() {
    }
    exports.Portal = Portal;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tooltip/components/TooltipOverlay/TooltipOverlay.scss.js
var require_TooltipOverlay_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tooltip/components/TooltipOverlay/TooltipOverlay.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      TooltipOverlay: "Polaris-Tooltip-TooltipOverlay",
      Tail: "Polaris-Tooltip-TooltipOverlay__Tail",
      positionedAbove: "Polaris-Tooltip-TooltipOverlay--positionedAbove",
      measuring: "Polaris-Tooltip-TooltipOverlay--measuring",
      measured: "Polaris-Tooltip-TooltipOverlay--measured",
      instant: "Polaris-Tooltip-TooltipOverlay--instant",
      Content: "Polaris-Tooltip-TooltipOverlay__Content",
      default: "Polaris-Tooltip-TooltipOverlay--default",
      wide: "Polaris-Tooltip-TooltipOverlay--wide"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/PositionedOverlay/utilities/math.js
var require_math = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/PositionedOverlay/utilities/math.js"(exports) {
    "use strict";
    init_cjs_shims();
    var geometry = require_geometry();
    function calculateVerticalPosition(activatorRect, overlayRect, overlayMargins, scrollableContainerRect, containerRect, preferredPosition, fixed, topBarOffset = 0) {
      let activatorTop = activatorRect.top, activatorBottom = activatorTop + activatorRect.height, spaceAbove = activatorRect.top - topBarOffset, spaceBelow = containerRect.height - activatorRect.top - activatorRect.height, desiredHeight = overlayRect.height, verticalMargins = overlayMargins.activator + overlayMargins.container, minimumSpaceToScroll = overlayMargins.container, distanceToTopScroll = activatorRect.top - Math.max(scrollableContainerRect.top, 0), distanceToBottomScroll = containerRect.top + Math.min(containerRect.height, scrollableContainerRect.top + scrollableContainerRect.height) - (activatorRect.top + activatorRect.height), enoughSpaceFromTopScroll = distanceToTopScroll >= minimumSpaceToScroll, enoughSpaceFromBottomScroll = distanceToBottomScroll >= minimumSpaceToScroll, heightIfBelow = Math.min(spaceBelow, desiredHeight), heightIfAbove = Math.min(spaceAbove, desiredHeight), containerRectTop = fixed ? 0 : containerRect.top, positionIfAbove = {
        height: heightIfAbove - verticalMargins,
        top: activatorTop + containerRectTop - heightIfAbove,
        positioning: "above"
      }, positionIfBelow = {
        height: heightIfBelow - verticalMargins,
        top: activatorBottom + containerRectTop,
        positioning: "below"
      };
      return preferredPosition === "above" ? (enoughSpaceFromTopScroll || distanceToTopScroll >= distanceToBottomScroll && !enoughSpaceFromBottomScroll) && (spaceAbove > desiredHeight || spaceAbove > spaceBelow) ? positionIfAbove : positionIfBelow : preferredPosition === "below" ? (enoughSpaceFromBottomScroll || distanceToBottomScroll >= distanceToTopScroll && !enoughSpaceFromTopScroll) && (spaceBelow > desiredHeight || spaceBelow > spaceAbove) ? positionIfBelow : positionIfAbove : enoughSpaceFromTopScroll && enoughSpaceFromBottomScroll ? spaceAbove > spaceBelow ? positionIfAbove : positionIfBelow : distanceToTopScroll > minimumSpaceToScroll ? positionIfAbove : positionIfBelow;
    }
    function calculateHorizontalPosition(activatorRect, overlayRect, containerRect, overlayMargins, preferredAlignment) {
      let maximum = containerRect.width - overlayRect.width;
      if (preferredAlignment === "left")
        return Math.min(maximum, Math.max(0, activatorRect.left - overlayMargins.horizontal));
      if (preferredAlignment === "right") {
        let activatorRight = containerRect.width - (activatorRect.left + activatorRect.width);
        return Math.min(maximum, Math.max(0, activatorRight - overlayMargins.horizontal));
      }
      return Math.min(maximum, Math.max(0, activatorRect.center.x - overlayRect.width / 2));
    }
    function rectIsOutsideOfRect(inner, outer) {
      let {
        center
      } = inner;
      return center.y < outer.top || center.y > outer.top + outer.height;
    }
    function intersectionWithViewport(rect, viewport = windowRect()) {
      let top = Math.max(rect.top, 0), left = Math.max(rect.left, 0), bottom = Math.min(rect.top + rect.height, viewport.height), right = Math.min(rect.left + rect.width, viewport.width);
      return new geometry.Rect({
        top,
        left,
        height: bottom - top,
        width: right - left
      });
    }
    function windowRect() {
      return new geometry.Rect({
        top: window.scrollY,
        left: window.scrollX,
        height: window.innerHeight,
        width: document.body.clientWidth
      });
    }
    exports.calculateHorizontalPosition = calculateHorizontalPosition;
    exports.calculateVerticalPosition = calculateVerticalPosition;
    exports.intersectionWithViewport = intersectionWithViewport;
    exports.rectIsOutsideOfRect = rectIsOutsideOfRect;
    exports.windowRect = windowRect;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/PositionedOverlay/PositionedOverlay.scss.js
var require_PositionedOverlay_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/PositionedOverlay/PositionedOverlay.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      PositionedOverlay: "Polaris-PositionedOverlay",
      fixed: "Polaris-PositionedOverlay--fixed",
      calculating: "Polaris-PositionedOverlay--calculating",
      preventInteraction: "Polaris-PositionedOverlay--preventInteraction"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-lazy-ref.js
var require_use_lazy_ref = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-lazy-ref.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), UNIQUE_IDENTIFIER = Symbol("unique_identifier");
    function useLazyRef(initialValue) {
      let lazyRef = React12.useRef(UNIQUE_IDENTIFIER);
      return lazyRef.current === UNIQUE_IDENTIFIER && (lazyRef.current = initialValue()), lazyRef;
    }
    exports.useLazyRef = useLazyRef;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-component-did-mount.js
var require_use_component_did_mount = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-component-did-mount.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), useIsAfterInitialMount = require_use_is_after_initial_mount();
    function useComponentDidMount(callback) {
      let isAfterInitialMount = useIsAfterInitialMount.useIsAfterInitialMount(), hasInvokedLifeCycle = React12.useRef(!1);
      if (isAfterInitialMount && !hasInvokedLifeCycle.current)
        return hasInvokedLifeCycle.current = !0, callback();
    }
    exports.useComponentDidMount = useComponentDidMount;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Scrollable/context.js
var require_context10 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Scrollable/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), ScrollableContext = /* @__PURE__ */ React12.createContext(void 0);
    exports.ScrollableContext = ScrollableContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Scrollable/Scrollable.scss.js
var require_Scrollable_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Scrollable/Scrollable.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Scrollable: "Polaris-Scrollable",
      hasTopShadow: "Polaris-Scrollable--hasTopShadow",
      hasBottomShadow: "Polaris-Scrollable--hasBottomShadow",
      horizontal: "Polaris-Scrollable--horizontal",
      vertical: "Polaris-Scrollable--vertical"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Scrollable/components/ScrollTo/ScrollTo.js
var require_ScrollTo = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Scrollable/components/ScrollTo/ScrollTo.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), context = require_context10();
    function ScrollTo() {
      let anchorNode = React12.useRef(null), scrollToPosition = React12.useContext(context.ScrollableContext);
      React12.useEffect(() => {
        !scrollToPosition || !anchorNode.current || scrollToPosition(anchorNode.current.offsetTop);
      }, [scrollToPosition]);
      let id = React12.useId();
      return /* @__PURE__ */ React12.createElement("a", {
        id,
        ref: anchorNode
      });
    }
    exports.ScrollTo = ScrollTo;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Scrollable/Scrollable.js
var require_Scrollable = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Scrollable/Scrollable.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), debounce = require_debounce2(), css = require_css(), shared = require_shared(), useLazyRef = require_use_lazy_ref(), useComponentDidMount = require_use_component_did_mount(), context = require_context10(), Scrollable_module = require_Scrollable_scss(), ScrollTo = require_ScrollTo(), stickyManager = require_sticky_manager(), context$1 = require_context4(), MAX_SCROLL_HINT_DISTANCE = 100, LOW_RES_BUFFER = 2, ScrollableComponent = /* @__PURE__ */ React12.forwardRef(({
      children,
      className,
      horizontal = !0,
      vertical = !0,
      shadow,
      hint,
      focusable,
      onScrolledToBottom,
      ...rest
    }, forwardedRef) => {
      let [topShadow, setTopShadow] = React12.useState(!1), [bottomShadow, setBottomShadow] = React12.useState(!1), stickyManager$1 = useLazyRef.useLazyRef(() => new stickyManager.StickyManager()), scrollArea = React12.useRef(null), scrollTo = React12.useCallback((scrollY, options = {}) => {
        let optionsBehavior = options.behavior || "smooth", behavior = prefersReducedMotion() ? "auto" : optionsBehavior;
        scrollArea.current?.scrollTo({
          top: scrollY,
          behavior
        });
      }, []), defaultRef = React12.useRef();
      React12.useImperativeHandle(forwardedRef || defaultRef, () => ({
        scrollTo
      }));
      let handleScroll = React12.useCallback(() => {
        let currentScrollArea = scrollArea.current;
        currentScrollArea && requestAnimationFrame(() => {
          let {
            scrollTop,
            clientHeight,
            scrollHeight
          } = currentScrollArea, canScroll = scrollHeight > clientHeight, isBelowTopOfScroll = scrollTop > 0, isAtBottomOfScroll = scrollTop + clientHeight >= scrollHeight - LOW_RES_BUFFER;
          setTopShadow(isBelowTopOfScroll), setBottomShadow(!isAtBottomOfScroll), canScroll && isAtBottomOfScroll && onScrolledToBottom && onScrolledToBottom();
        });
      }, [onScrolledToBottom]);
      useComponentDidMount.useComponentDidMount(() => {
        handleScroll(), hint && requestAnimationFrame(() => performScrollHint(scrollArea.current));
      }), React12.useEffect(() => {
        let currentScrollArea = scrollArea.current;
        if (!currentScrollArea)
          return;
        let handleResize = debounce.debounce(handleScroll, 50, {
          trailing: !0
        });
        return stickyManager$1.current?.setContainer(currentScrollArea), currentScrollArea.addEventListener("scroll", handleScroll), globalThis.addEventListener("resize", handleResize), () => {
          currentScrollArea.removeEventListener("scroll", handleScroll), globalThis.removeEventListener("resize", handleResize);
        };
      }, [stickyManager$1, handleScroll]);
      let finalClassName = css.classNames(className, Scrollable_module.default.Scrollable, vertical && Scrollable_module.default.vertical, horizontal && Scrollable_module.default.horizontal, shadow && topShadow && Scrollable_module.default.hasTopShadow, shadow && bottomShadow && Scrollable_module.default.hasBottomShadow);
      return /* @__PURE__ */ React12.createElement(context.ScrollableContext.Provider, {
        value: scrollTo
      }, /* @__PURE__ */ React12.createElement(context$1.StickyManagerContext.Provider, {
        value: stickyManager$1.current
      }, /* @__PURE__ */ React12.createElement("div", Object.assign({
        className: finalClassName
      }, shared.scrollable.props, rest, {
        ref: scrollArea,
        tabIndex: focusable ? 0 : void 0
      }), children)));
    });
    ScrollableComponent.displayName = "Scrollable";
    function prefersReducedMotion() {
      try {
        return window.matchMedia("(prefers-reduced-motion: reduce)").matches;
      } catch {
        return !1;
      }
    }
    function performScrollHint(elem) {
      if (!elem || prefersReducedMotion())
        return;
      let scrollableDistance = elem.scrollHeight - elem.clientHeight, distanceToPeek = Math.min(MAX_SCROLL_HINT_DISTANCE, scrollableDistance) - LOW_RES_BUFFER, goBackToTop = () => {
        requestAnimationFrame(() => {
          elem.scrollTop >= distanceToPeek && (elem.removeEventListener("scroll", goBackToTop), elem.scrollTo({
            top: 0,
            behavior: "smooth"
          }));
        });
      };
      elem.addEventListener("scroll", goBackToTop), elem.scrollTo({
        top: MAX_SCROLL_HINT_DISTANCE,
        behavior: "smooth"
      });
    }
    var forNode = (node) => {
      let closestElement = node.closest(shared.scrollable.selector);
      return closestElement instanceof HTMLElement ? closestElement : document;
    }, Scrollable = ScrollableComponent;
    Scrollable.ScrollTo = ScrollTo.ScrollTo;
    Scrollable.forNode = forNode;
    exports.Scrollable = Scrollable;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/PositionedOverlay/PositionedOverlay.js
var require_PositionedOverlay = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/PositionedOverlay/PositionedOverlay.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), geometry = require_geometry(), shared = require_shared(), math = require_math(), PositionedOverlay_module = require_PositionedOverlay_scss(), Scrollable = require_Scrollable(), EventListener = require_EventListener(), OBSERVER_CONFIG = {
      childList: !0,
      subtree: !0,
      characterData: !0,
      attributeFilter: ["style"]
    }, PositionedOverlay = class extends React12.PureComponent {
      constructor(props) {
        super(props), this.state = {
          measuring: !0,
          activatorRect: geometry.getRectForNode(this.props.activator),
          right: void 0,
          left: void 0,
          top: 0,
          height: 0,
          width: null,
          positioning: "below",
          zIndex: null,
          outsideScrollableContainer: !1,
          lockPosition: !1,
          chevronOffset: 0
        }, this.overlay = null, this.scrollableContainers = [], this.overlayDetails = () => {
          let {
            measuring,
            left,
            right,
            positioning,
            height,
            activatorRect,
            chevronOffset
          } = this.state;
          return {
            measuring,
            left,
            right,
            desiredHeight: height,
            positioning,
            activatorRect,
            chevronOffset
          };
        }, this.setOverlay = (node) => {
          this.overlay = node;
        }, this.setScrollableContainers = () => {
          let containers = [], scrollableContainer = Scrollable.Scrollable.forNode(this.props.activator);
          if (scrollableContainer)
            for (containers.push(scrollableContainer); scrollableContainer?.parentElement; )
              scrollableContainer = Scrollable.Scrollable.forNode(scrollableContainer.parentElement), containers.push(scrollableContainer);
          this.scrollableContainers = containers;
        }, this.registerScrollHandlers = () => {
          this.scrollableContainers.forEach((node) => {
            node.addEventListener("scroll", this.handleMeasurement);
          });
        }, this.unregisterScrollHandlers = () => {
          this.scrollableContainers.forEach((node) => {
            node.removeEventListener("scroll", this.handleMeasurement);
          });
        }, this.handleMeasurement = () => {
          let {
            lockPosition,
            top
          } = this.state;
          this.observer.disconnect(), this.setState(({
            left,
            top: top2,
            right
          }) => ({
            left,
            right,
            top: top2,
            height: 0,
            positioning: "below",
            measuring: !0
          }), () => {
            if (this.overlay == null || this.firstScrollableContainer == null)
              return;
            let {
              activator,
              preferredPosition = "below",
              preferredAlignment = "center",
              onScrollOut,
              fullWidth,
              fixed,
              preferInputActivator = !0
            } = this.props, preferredActivator = preferInputActivator && activator.querySelector("input") || activator, activatorRect = geometry.getRectForNode(preferredActivator), currentOverlayRect = geometry.getRectForNode(this.overlay), scrollableElement = isDocument(this.firstScrollableContainer) ? document.body : this.firstScrollableContainer, scrollableContainerRect = geometry.getRectForNode(scrollableElement), overlayRect = fullWidth ? new geometry.Rect({
              ...currentOverlayRect,
              width: activatorRect.width
            }) : currentOverlayRect;
            scrollableElement === document.body && (scrollableContainerRect.height = document.body.scrollHeight);
            let topBarOffset = 0, topBarElement = scrollableElement.querySelector(`${shared.dataPolarisTopBar.selector}`);
            topBarElement && (topBarOffset = topBarElement.clientHeight);
            let overlayMargins = this.overlay.firstElementChild && this.overlay.firstChild instanceof HTMLElement ? getMarginsForNode(this.overlay.firstElementChild) : {
              activator: 0,
              container: 0,
              horizontal: 0
            }, containerRect = math.windowRect(), zIndexForLayer = getZIndexForLayerFromNode(activator), zIndex = zIndexForLayer == null ? zIndexForLayer : zIndexForLayer + 1, verticalPosition = math.calculateVerticalPosition(activatorRect, overlayRect, overlayMargins, scrollableContainerRect, containerRect, preferredPosition, fixed, topBarOffset), horizontalPosition = math.calculateHorizontalPosition(activatorRect, overlayRect, containerRect, overlayMargins, preferredAlignment), chevronOffset = activatorRect.center.x - horizontalPosition + overlayMargins.horizontal * 2;
            this.setState({
              measuring: !1,
              activatorRect: geometry.getRectForNode(activator),
              left: preferredAlignment !== "right" ? horizontalPosition : void 0,
              right: preferredAlignment === "right" ? horizontalPosition : void 0,
              top: lockPosition ? top : verticalPosition.top,
              lockPosition: !!fixed,
              height: verticalPosition.height || 0,
              width: fullWidth ? overlayRect.width : null,
              positioning: verticalPosition.positioning,
              outsideScrollableContainer: onScrollOut != null && math.rectIsOutsideOfRect(activatorRect, math.intersectionWithViewport(scrollableContainerRect)),
              zIndex,
              chevronOffset
            }, () => {
              this.overlay && (this.observer.observe(this.overlay, OBSERVER_CONFIG), this.observer.observe(activator, OBSERVER_CONFIG));
            });
          });
        }, this.observer = new MutationObserver(this.handleMeasurement);
      }
      componentDidMount() {
        this.setScrollableContainers(), this.scrollableContainers.length && !this.props.fixed && this.registerScrollHandlers(), this.handleMeasurement();
      }
      componentWillUnmount() {
        this.observer.disconnect(), this.scrollableContainers.length && !this.props.fixed && this.unregisterScrollHandlers();
      }
      componentDidUpdate() {
        let {
          outsideScrollableContainer,
          top
        } = this.state, {
          onScrollOut,
          active
        } = this.props;
        active && onScrollOut != null && top !== 0 && outsideScrollableContainer && onScrollOut();
      }
      render() {
        let {
          left,
          right,
          top,
          zIndex,
          width
        } = this.state, {
          render: render3,
          fixed,
          preventInteraction,
          classNames: propClassNames,
          zIndexOverride
        } = this.props, style = {
          top: top == null || isNaN(top) ? void 0 : top,
          left: left == null || isNaN(left) ? void 0 : left,
          right: right == null || isNaN(right) ? void 0 : right,
          width: width == null || isNaN(width) ? void 0 : width,
          zIndex: zIndexOverride || zIndex || void 0
        }, className = css.classNames(PositionedOverlay_module.default.PositionedOverlay, fixed && PositionedOverlay_module.default.fixed, preventInteraction && PositionedOverlay_module.default.preventInteraction, propClassNames);
        return /* @__PURE__ */ React12.createElement("div", {
          className,
          style,
          ref: this.setOverlay
        }, /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
          event: "resize",
          handler: this.handleMeasurement
        }), render3(this.overlayDetails()));
      }
      get firstScrollableContainer() {
        return this.scrollableContainers[0] ?? null;
      }
      forceUpdatePosition() {
        requestAnimationFrame(this.handleMeasurement);
      }
    };
    function getMarginsForNode(node) {
      let nodeStyles = window.getComputedStyle(node);
      return {
        activator: parseFloat(nodeStyles.marginTop || "0"),
        container: parseFloat(nodeStyles.marginBottom || "0"),
        horizontal: parseFloat(nodeStyles.marginLeft || "0")
      };
    }
    function getZIndexForLayerFromNode(node) {
      let layerNode = node.closest(shared.layer.selector) || document.body, zIndex = layerNode === document.body ? "auto" : parseInt(window.getComputedStyle(layerNode).zIndex || "0", 10);
      return zIndex === "auto" || isNaN(zIndex) ? null : zIndex;
    }
    function isDocument(node) {
      return node === document;
    }
    exports.PositionedOverlay = PositionedOverlay;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tooltip/components/TooltipOverlay/TooltipOverlay.js
var require_TooltipOverlay = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tooltip/components/TooltipOverlay/TooltipOverlay.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), shared = require_shared(), TooltipOverlay_module = require_TooltipOverlay_scss(), PositionedOverlay = require_PositionedOverlay(), hooks2 = require_hooks2(), tailUpPaths = /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement("path", {
      d: "M18.829 8.171 11.862.921A3 3 0 0 0 7.619.838L0 8.171h1.442l6.87-6.612a2 2 0 0 1 2.83.055l6.3 6.557h1.387Z",
      fill: "#E3E3E3"
    }), /* @__PURE__ */ React12.createElement("path", {
      d: "M17.442 10.171h-16v-2l6.87-6.612a2 2 0 0 1 2.83.055l6.3 6.557v2Z",
      fill: "var(--p-color-bg-surface)"
    })), tailDownPaths = /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement("path", {
      d: "m0 2 6.967 7.25a3 3 0 0 0 4.243.083L18.829 2h-1.442l-6.87 6.612a2 2 0 0 1-2.83-.055L1.387 2H0Z",
      fill: "#D4D4D4"
    }), /* @__PURE__ */ React12.createElement("path", {
      d: "M1.387 0h16v2l-6.87 6.612a2 2 0 0 1-2.83-.055L1.387 2V0Z",
      fill: "var(--p-color-bg-surface)"
    }));
    function TooltipOverlay({
      active,
      activator,
      preferredPosition = "above",
      preventInteraction,
      id,
      children,
      accessibilityLabel,
      width,
      padding,
      borderRadius,
      zIndexOverride,
      instant
    }) {
      let i18n = hooks2.useI18n();
      return active ? /* @__PURE__ */ React12.createElement(PositionedOverlay.PositionedOverlay, {
        active,
        activator,
        preferredPosition,
        preventInteraction,
        render: renderTooltip,
        zIndexOverride
      }) : null;
      function renderTooltip(overlayDetails) {
        let {
          measuring,
          desiredHeight,
          positioning,
          chevronOffset
        } = overlayDetails, containerClassName = css.classNames(TooltipOverlay_module.default.TooltipOverlay, measuring && TooltipOverlay_module.default.measuring, !measuring && TooltipOverlay_module.default.measured, instant && TooltipOverlay_module.default.instant, positioning === "above" && TooltipOverlay_module.default.positionedAbove), contentClassName = css.classNames(TooltipOverlay_module.default.Content, width && TooltipOverlay_module.default[width]), contentStyles = measuring ? void 0 : {
          minHeight: desiredHeight
        }, style = {
          "--pc-tooltip-chevron-x-pos": `${chevronOffset}px`,
          "--pc-tooltip-border-radius": borderRadius ? `var(--p-border-radius-${borderRadius})` : void 0,
          "--pc-tooltip-padding": padding && padding === "default" ? "var(--p-space-100) var(--p-space-200)" : `var(--p-space-${padding})`
        };
        return /* @__PURE__ */ React12.createElement("div", Object.assign({
          style,
          className: containerClassName
        }, shared.layer.props), /* @__PURE__ */ React12.createElement("svg", {
          className: TooltipOverlay_module.default.Tail,
          width: "19",
          height: "11",
          fill: "none"
        }, positioning === "above" ? tailDownPaths : tailUpPaths), /* @__PURE__ */ React12.createElement("div", {
          id,
          role: "tooltip",
          className: contentClassName,
          style: {
            ...contentStyles,
            ...style
          },
          "aria-label": accessibilityLabel ? i18n.translate("Polaris.TooltipOverlay.accessibilityLabel", {
            label: accessibilityLabel
          }) : void 0
        }, children));
      }
    }
    exports.TooltipOverlay = TooltipOverlay;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tooltip/Tooltip.js
var require_Tooltip = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tooltip/Tooltip.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), focus = require_focus(), useToggle = require_use_toggle(), css = require_css(), Tooltip_module = require_Tooltip_scss(), hooks2 = require_hooks3(), Portal = require_Portal(), TooltipOverlay = require_TooltipOverlay(), HOVER_OUT_TIMEOUT = 150;
    function Tooltip({
      children,
      content,
      dismissOnMouseOut,
      active: originalActive,
      hoverDelay,
      preferredPosition = "above",
      activatorWrapper = "span",
      accessibilityLabel,
      width = "default",
      padding = "default",
      borderRadius: borderRadiusProp,
      zIndexOverride,
      hasUnderline,
      persistOnClick,
      onOpen,
      onClose
    }) {
      let borderRadius = borderRadiusProp || "200", WrapperComponent = activatorWrapper, {
        value: active,
        setTrue: setActiveTrue,
        setFalse: handleBlur
      } = useToggle.useToggle(!!originalActive), {
        value: persist,
        toggle: togglePersisting
      } = useToggle.useToggle(!!originalActive && !!persistOnClick), [activatorNode, setActivatorNode] = React12.useState(null), {
        presenceList,
        addPresence,
        removePresence
      } = hooks2.useEphemeralPresenceManager(), id = React12.useId(), activatorContainer = React12.useRef(null), mouseEntered = React12.useRef(!1), [shouldAnimate, setShouldAnimate] = React12.useState(!originalActive), hoverDelayTimeout = React12.useRef(null), hoverOutTimeout = React12.useRef(null), handleFocus = React12.useCallback(() => {
        originalActive !== !1 && setActiveTrue();
      }, [originalActive, setActiveTrue]);
      React12.useEffect(() => {
        let accessibilityNode = (activatorContainer.current ? focus.findFirstFocusableNode(activatorContainer.current) : null) || activatorContainer.current;
        accessibilityNode && (accessibilityNode.tabIndex = 0, accessibilityNode.setAttribute("aria-describedby", id), accessibilityNode.setAttribute("data-polaris-tooltip-activator", "true"));
      }, [id, children]), React12.useEffect(() => () => {
        hoverDelayTimeout.current && clearTimeout(hoverDelayTimeout.current), hoverOutTimeout.current && clearTimeout(hoverOutTimeout.current);
      }, []);
      let handleOpen = React12.useCallback(() => {
        setShouldAnimate(!presenceList.tooltip && !active), onOpen?.(), addPresence("tooltip");
      }, [addPresence, presenceList.tooltip, onOpen, active]), handleClose = React12.useCallback(() => {
        onClose?.(), setShouldAnimate(!1), hoverOutTimeout.current = setTimeout(() => {
          removePresence("tooltip");
        }, HOVER_OUT_TIMEOUT);
      }, [removePresence, onClose]), handleKeyUp = React12.useCallback((event) => {
        event.key === "Escape" && (handleClose?.(), handleBlur(), persistOnClick && togglePersisting());
      }, [handleBlur, handleClose, persistOnClick, togglePersisting]);
      React12.useEffect(() => {
        originalActive === !1 && active && (handleClose(), handleBlur());
      }, [originalActive, active, handleClose, handleBlur]);
      let portal = activatorNode ? /* @__PURE__ */ React12.createElement(Portal.Portal, {
        idPrefix: "tooltip"
      }, /* @__PURE__ */ React12.createElement(TooltipOverlay.TooltipOverlay, {
        id,
        preferredPosition,
        activator: activatorNode,
        active,
        accessibilityLabel,
        onClose: noop,
        preventInteraction: dismissOnMouseOut,
        width,
        padding,
        borderRadius,
        zIndexOverride,
        instant: !shouldAnimate
      }, content)) : null, wrapperClassNames = css.classNames(activatorWrapper === "div" && Tooltip_module.default.TooltipContainer, hasUnderline && Tooltip_module.default.HasUnderline);
      return /* @__PURE__ */ React12.createElement(WrapperComponent, {
        onFocus: () => {
          handleOpen(), handleFocus();
        },
        onBlur: () => {
          handleClose(), handleBlur(), persistOnClick && togglePersisting();
        },
        onMouseLeave: handleMouseLeave,
        onMouseOver: handleMouseEnterFix,
        onMouseDown: persistOnClick ? togglePersisting : void 0,
        ref: setActivator,
        onKeyUp: handleKeyUp,
        className: wrapperClassNames
      }, children, portal);
      function setActivator(node) {
        let activatorContainerRef = activatorContainer;
        if (node == null) {
          activatorContainerRef.current = null, setActivatorNode(null);
          return;
        }
        node.firstElementChild instanceof HTMLElement && setActivatorNode(node.firstElementChild), activatorContainerRef.current = node;
      }
      function handleMouseEnter() {
        mouseEntered.current = !0, hoverDelay && !presenceList.tooltip ? hoverDelayTimeout.current = setTimeout(() => {
          handleOpen(), handleFocus();
        }, hoverDelay) : (handleOpen(), handleFocus());
      }
      function handleMouseLeave() {
        hoverDelayTimeout.current && (clearTimeout(hoverDelayTimeout.current), hoverDelayTimeout.current = null), mouseEntered.current = !1, handleClose(), persist || handleBlur();
      }
      function handleMouseEnterFix() {
        !mouseEntered.current && handleMouseEnter();
      }
    }
    function noop() {
    }
    exports.Tooltip = Tooltip;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionList/components/Item/Item.js
var require_Item = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionList/components/Item/Item.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), ActionList_module = require_ActionList_scss(), focus = require_focus(), useIsomorphicLayoutEffect = require_use_isomorphic_layout_effect(), useTheme = require_use_theme(), Badge2 = require_Badge(), Tooltip = require_Tooltip(), Icon = require_Icon(), Box2 = require_Box(), Text4 = require_Text(), Scrollable = require_Scrollable(), UnstyledLink = require_UnstyledLink(), InlineStack2 = require_InlineStack();
    function Item({
      id,
      badge,
      content,
      accessibilityLabel,
      helpText,
      url,
      onAction,
      onMouseEnter,
      icon,
      image,
      prefix,
      suffix,
      disabled,
      external,
      destructive,
      ellipsis,
      truncate,
      active,
      role,
      variant = "default"
    }) {
      let className = css.classNames(ActionList_module.default.Item, disabled && ActionList_module.default.disabled, destructive && ActionList_module.default.destructive, active && ActionList_module.default.active, variant === "default" && ActionList_module.default.default, variant === "indented" && ActionList_module.default.indented, variant === "menu" && ActionList_module.default.menu), prefixMarkup = null;
      prefix ? prefixMarkup = /* @__PURE__ */ React12.createElement("span", {
        className: ActionList_module.default.Prefix
      }, prefix) : icon ? prefixMarkup = /* @__PURE__ */ React12.createElement("span", {
        className: ActionList_module.default.Prefix
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: icon
      })) : image && (prefixMarkup = /* @__PURE__ */ React12.createElement("span", {
        role: "presentation",
        className: ActionList_module.default.Prefix,
        style: {
          backgroundImage: `url(${image}`
        }
      }));
      let contentText = content || "";
      truncate && content ? contentText = /* @__PURE__ */ React12.createElement(TruncateText, null, content) : ellipsis && (contentText = `${content}\u2026`);
      let contentMarkup = helpText ? /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement(Box2.Box, null, contentText), /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        variant: "bodySm",
        tone: active || disabled ? void 0 : "subdued"
      }, helpText)) : contentText, badgeMarkup = badge && /* @__PURE__ */ React12.createElement("span", {
        className: ActionList_module.default.Suffix
      }, /* @__PURE__ */ React12.createElement(Badge2.Badge, {
        tone: badge.tone
      }, badge.content)), suffixMarkup = suffix && /* @__PURE__ */ React12.createElement(Box2.Box, null, /* @__PURE__ */ React12.createElement("span", {
        className: ActionList_module.default.Suffix
      }, suffix)), textMarkup = /* @__PURE__ */ React12.createElement("span", {
        className: ActionList_module.default.Text
      }, contentMarkup), contentElement = /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        blockAlign: "center",
        gap: "150",
        wrap: !truncate
      }, prefixMarkup, textMarkup, badgeMarkup, suffixMarkup), contentWrapper = /* @__PURE__ */ React12.createElement(Box2.Box, {
        width: "100%"
      }, contentElement), scrollMarkup = active ? /* @__PURE__ */ React12.createElement(Scrollable.Scrollable.ScrollTo, null) : null, control = url ? /* @__PURE__ */ React12.createElement(UnstyledLink.UnstyledLink, {
        id,
        url: disabled ? null : url,
        className,
        external,
        "aria-label": accessibilityLabel,
        onClick: disabled ? null : onAction,
        role
      }, contentWrapper) : /* @__PURE__ */ React12.createElement("button", {
        id,
        type: "button",
        className,
        disabled,
        "aria-label": accessibilityLabel,
        onClick: onAction,
        onMouseUp: focus.handleMouseUpByBlurring,
        role,
        onMouseEnter
      }, contentWrapper);
      return /* @__PURE__ */ React12.createElement(React12.Fragment, null, scrollMarkup, control);
    }
    var TruncateText = ({
      children
    }) => {
      let theme = useTheme.useTheme(), textRef = React12.useRef(null), [isOverflowing, setIsOverflowing] = React12.useState(!1);
      useIsomorphicLayoutEffect.useIsomorphicLayoutEffect(() => {
        textRef.current && setIsOverflowing(textRef.current.scrollWidth > textRef.current.offsetWidth);
      }, [children]);
      let text = /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        truncate: !0
      }, /* @__PURE__ */ React12.createElement(Box2.Box, {
        width: "100%",
        ref: textRef
      }, children));
      return isOverflowing ? /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, {
        zIndexOverride: Number(theme.zIndex["z-index-11"]),
        preferredPosition: "above",
        hoverDelay: 1e3,
        content: children,
        dismissOnMouseOut: !0
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        truncate: !0
      }, children)) : text;
    };
    exports.Item = Item;
    exports.TruncateText = TruncateText;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionList/components/Section/Section.js
var require_Section = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionList/components/Section/Section.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), Item = require_Item(), Box2 = require_Box(), InlineStack2 = require_InlineStack(), Text4 = require_Text(), BlockStack3 = require_BlockStack();
    function Section({
      section,
      hasMultipleSections,
      isFirst,
      actionRole,
      onActionAnyItem
    }) {
      let handleAction = (itemOnAction) => () => {
        itemOnAction && itemOnAction(), onActionAnyItem && onActionAnyItem();
      }, actionMarkup = section.items.map(({
        content,
        helpText,
        onAction,
        ...item
      }, index) => {
        let itemMarkup = /* @__PURE__ */ React12.createElement(Item.Item, Object.assign({
          content,
          helpText,
          role: actionRole,
          onAction: handleAction(onAction)
        }, item));
        return /* @__PURE__ */ React12.createElement(Box2.Box, {
          as: "li",
          key: `${content}-${index}`,
          role: actionRole === "menuitem" ? "presentation" : void 0
        }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
          wrap: !1
        }, itemMarkup));
      }), titleMarkup = null;
      section.title && (titleMarkup = typeof section.title == "string" ? /* @__PURE__ */ React12.createElement(Box2.Box, {
        paddingBlockStart: "300",
        paddingBlockEnd: "100",
        paddingInlineStart: "300",
        paddingInlineEnd: "300"
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "p",
        variant: "headingSm"
      }, section.title)) : /* @__PURE__ */ React12.createElement(Box2.Box, {
        padding: "200",
        paddingInlineEnd: "150"
      }, section.title));
      let sectionRole;
      switch (actionRole) {
        case "option":
          sectionRole = "presentation";
          break;
        case "menuitem":
          sectionRole = hasMultipleSections ? "presentation" : "menu";
          break;
        default:
          sectionRole = void 0;
          break;
      }
      let sectionMarkup = /* @__PURE__ */ React12.createElement(React12.Fragment, null, titleMarkup, /* @__PURE__ */ React12.createElement(Box2.Box, Object.assign({
        as: "div",
        padding: "150"
      }, hasMultipleSections && {
        paddingBlockStart: "0"
      }, {
        tabIndex: hasMultipleSections ? void 0 : -1
      }), /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, Object.assign({
        gap: "100",
        as: "ul"
      }, sectionRole && {
        role: sectionRole
      }), actionMarkup)));
      return hasMultipleSections ? /* @__PURE__ */ React12.createElement(Box2.Box, Object.assign({
        as: "li",
        role: "presentation",
        borderColor: "border-secondary"
      }, !isFirst && {
        borderBlockStartWidth: "025"
      }, !section.title && {
        paddingBlockStart: "150"
      }), sectionMarkup) : sectionMarkup;
    }
    exports.Section = Section;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/KeypressListener/KeypressListener.js
var require_KeypressListener = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/KeypressListener/KeypressListener.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), useIsomorphicLayoutEffect = require_use_isomorphic_layout_effect();
    function KeypressListener({
      keyCode,
      handler,
      keyEvent = "keyup",
      options,
      useCapture
    }) {
      let tracked = React12.useRef({
        handler,
        keyCode
      });
      useIsomorphicLayoutEffect.useIsomorphicLayoutEffect(() => {
        tracked.current = {
          handler,
          keyCode
        };
      }, [handler, keyCode]);
      let handleKeyEvent = React12.useCallback((event) => {
        let {
          handler: handler2,
          keyCode: keyCode2
        } = tracked.current;
        event.keyCode === keyCode2 && handler2(event);
      }, []);
      return React12.useEffect(() => (document.addEventListener(keyEvent, handleKeyEvent, useCapture || options), () => {
        document.removeEventListener(keyEvent, handleKeyEvent, useCapture || options);
      }), [keyEvent, handleKeyEvent, useCapture, options]), null;
    }
    exports.KeypressListener = KeypressListener;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TextField/TextField.scss.js
var require_TextField_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TextField/TextField.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      TextField: "Polaris-TextField",
      ClearButton: "Polaris-TextField__ClearButton",
      disabled: "Polaris-TextField--disabled",
      error: "Polaris-TextField--error",
      readOnly: "Polaris-TextField--readOnly",
      Input: "Polaris-TextField__Input",
      Backdrop: "Polaris-TextField__Backdrop",
      multiline: "Polaris-TextField--multiline",
      hasValue: "Polaris-TextField--hasValue",
      focus: "Polaris-TextField--focus",
      VerticalContent: "Polaris-TextField__VerticalContent",
      toneMagic: "Polaris-TextField--toneMagic",
      Prefix: "Polaris-TextField__Prefix",
      Suffix: "Polaris-TextField__Suffix",
      suggestion: "Polaris-TextField--suggestion",
      borderless: "Polaris-TextField--borderless",
      slim: "Polaris-TextField--slim",
      "Input-hasClearButton": "Polaris-TextField__Input--hasClearButton",
      "Input-suffixed": "Polaris-TextField__Input--suffixed",
      "Input-alignRight": "Polaris-TextField__Input--alignRight",
      "Input-alignLeft": "Polaris-TextField__Input--alignLeft",
      "Input-alignCenter": "Polaris-TextField__Input--alignCenter",
      PrefixIcon: "Polaris-TextField__PrefixIcon",
      CharacterCount: "Polaris-TextField__CharacterCount",
      AlignFieldBottom: "Polaris-TextField__AlignFieldBottom",
      Spinner: "Polaris-TextField__Spinner",
      SpinnerIcon: "Polaris-TextField__SpinnerIcon",
      Resizer: "Polaris-TextField__Resizer",
      DummyInput: "Polaris-TextField__DummyInput",
      Segment: "Polaris-TextField__Segment",
      monospaced: "Polaris-TextField--monospaced"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TextField/components/Spinner/Spinner.js
var require_Spinner2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TextField/components/Spinner/Spinner.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), TextField_module = require_TextField_scss(), Icon = require_Icon(), Spinner = /* @__PURE__ */ React12.forwardRef(function({
      onChange,
      onClick,
      onMouseDown,
      onMouseUp,
      onBlur
    }, ref) {
      function handleStep(step) {
        return () => onChange(step);
      }
      function handleMouseDown(onChange2) {
        return (event) => {
          event.button === 0 && onMouseDown?.(onChange2);
        };
      }
      return /* @__PURE__ */ React12.createElement("div", {
        className: TextField_module.default.Spinner,
        onClick,
        "aria-hidden": !0,
        ref
      }, /* @__PURE__ */ React12.createElement("div", {
        role: "button",
        className: TextField_module.default.Segment,
        tabIndex: -1,
        onClick: handleStep(1),
        onMouseDown: handleMouseDown(handleStep(1)),
        onMouseUp,
        onBlur
      }, /* @__PURE__ */ React12.createElement("div", {
        className: TextField_module.default.SpinnerIcon
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.ChevronUpIcon
      }))), /* @__PURE__ */ React12.createElement("div", {
        role: "button",
        className: TextField_module.default.Segment,
        tabIndex: -1,
        onClick: handleStep(-1),
        onMouseDown: handleMouseDown(handleStep(-1)),
        onMouseUp,
        onBlur
      }, /* @__PURE__ */ React12.createElement("div", {
        className: TextField_module.default.SpinnerIcon
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.ChevronDownIcon
      }))));
    });
    exports.Spinner = Spinner;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Labelled/Labelled.scss.js
var require_Labelled_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Labelled/Labelled.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      hidden: "Polaris-Labelled--hidden",
      LabelWrapper: "Polaris-Labelled__LabelWrapper",
      disabled: "Polaris-Labelled--disabled",
      HelpText: "Polaris-Labelled__HelpText",
      readOnly: "Polaris-Labelled--readOnly",
      Error: "Polaris-Labelled__Error",
      Action: "Polaris-Labelled__Action"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/InlineError/InlineError.scss.js
var require_InlineError_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/InlineError/InlineError.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      InlineError: "Polaris-InlineError",
      Icon: "Polaris-InlineError__Icon"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/InlineError/InlineError.js
var require_InlineError = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/InlineError/InlineError.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), InlineError_module = require_InlineError_scss(), Icon = require_Icon();
    function InlineError({
      message,
      fieldID
    }) {
      return message ? /* @__PURE__ */ React12.createElement("div", {
        id: errorTextID(fieldID),
        className: InlineError_module.default.InlineError
      }, /* @__PURE__ */ React12.createElement("div", {
        className: InlineError_module.default.Icon
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.AlertCircleIcon
      })), message) : null;
    }
    function errorTextID(id) {
      return `${id}Error`;
    }
    exports.InlineError = InlineError;
    exports.errorTextID = errorTextID;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Label/Label.scss.js
var require_Label_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Label/Label.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Label: "Polaris-Label",
      hidden: "Polaris-Label--hidden",
      Text: "Polaris-Label__Text",
      RequiredIndicator: "Polaris-Label__RequiredIndicator"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Label/Label.js
var require_Label = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Label/Label.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Label_module = require_Label_scss();
    function labelID(id) {
      return `${id}Label`;
    }
    function Label({
      children,
      id,
      hidden,
      requiredIndicator
    }) {
      let className = css.classNames(Label_module.default.Label, hidden && Label_module.default.hidden);
      return /* @__PURE__ */ React12.createElement("div", {
        className
      }, /* @__PURE__ */ React12.createElement("label", {
        id: labelID(id),
        htmlFor: id,
        className: css.classNames(Label_module.default.Text, requiredIndicator && Label_module.default.RequiredIndicator)
      }, children));
    }
    exports.Label = Label;
    exports.labelID = labelID;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Labelled/Labelled.js
var require_Labelled = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Labelled/Labelled.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Labelled_module = require_Labelled_scss(), InlineError = require_InlineError(), Label = require_Label(), utils = require_utils10(), Text4 = require_Text();
    function Labelled({
      id,
      label,
      error,
      action,
      helpText,
      children,
      labelHidden,
      requiredIndicator,
      disabled,
      readOnly,
      ...rest
    }) {
      let className = css.classNames(labelHidden && Labelled_module.default.hidden, disabled && Labelled_module.default.disabled, readOnly && Labelled_module.default.readOnly), actionMarkup = action ? /* @__PURE__ */ React12.createElement("div", {
        className: Labelled_module.default.Action
      }, utils.buttonFrom(action, {
        variant: "plain"
      })) : null, helpTextMarkup = helpText ? /* @__PURE__ */ React12.createElement("div", {
        className: Labelled_module.default.HelpText,
        id: helpTextID(id),
        "aria-disabled": disabled
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        tone: "subdued",
        breakWord: !0
      }, helpText)) : null, errorMarkup = error && typeof error != "boolean" && /* @__PURE__ */ React12.createElement("div", {
        className: Labelled_module.default.Error
      }, /* @__PURE__ */ React12.createElement(InlineError.InlineError, {
        message: error,
        fieldID: id
      })), labelMarkup = label ? /* @__PURE__ */ React12.createElement("div", {
        className: Labelled_module.default.LabelWrapper
      }, /* @__PURE__ */ React12.createElement(Label.Label, Object.assign({
        id,
        requiredIndicator
      }, rest, {
        hidden: !1
      }), label), actionMarkup) : null;
      return /* @__PURE__ */ React12.createElement("div", {
        className
      }, labelMarkup, children, errorMarkup, helpTextMarkup);
    }
    function helpTextID(id) {
      return `${id}HelpText`;
    }
    exports.labelID = Label.labelID;
    exports.Labelled = Labelled;
    exports.helpTextID = helpTextID;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Connected/Connected.scss.js
var require_Connected_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Connected/Connected.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Connected: "Polaris-Connected",
      Item: "Polaris-Connected__Item",
      "Item-primary": "Polaris-Connected__Item--primary",
      "Item-focused": "Polaris-Connected__Item--focused"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Connected/components/Item/Item.js
var require_Item2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Connected/components/Item/Item.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), useToggle = require_use_toggle(), Connected_module = require_Connected_scss();
    function Item({
      children,
      position
    }) {
      let {
        value: focused,
        setTrue: forceTrueFocused,
        setFalse: forceFalseFocused
      } = useToggle.useToggle(!1), className = css.classNames(Connected_module.default.Item, focused && Connected_module.default["Item-focused"], position === "primary" ? Connected_module.default["Item-primary"] : Connected_module.default["Item-connection"]);
      return /* @__PURE__ */ React12.createElement("div", {
        onBlur: forceFalseFocused,
        onFocus: forceTrueFocused,
        className
      }, children);
    }
    exports.Item = Item;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Connected/Connected.js
var require_Connected = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Connected/Connected.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), Connected_module = require_Connected_scss(), Item = require_Item2();
    function Connected({
      children,
      left,
      right
    }) {
      let leftConnectionMarkup = left ? /* @__PURE__ */ React12.createElement(Item.Item, {
        position: "left"
      }, left) : null, rightConnectionMarkup = right ? /* @__PURE__ */ React12.createElement(Item.Item, {
        position: "right"
      }, right) : null;
      return /* @__PURE__ */ React12.createElement("div", {
        className: Connected_module.default.Connected
      }, leftConnectionMarkup, /* @__PURE__ */ React12.createElement(Item.Item, {
        position: "primary"
      }, children), rightConnectionMarkup);
    }
    exports.Connected = Connected;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TextField/components/Resizer/Resizer.js
var require_Resizer = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TextField/components/Resizer/Resizer.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), useIsomorphicLayoutEffect = require_use_isomorphic_layout_effect(), TextField_module = require_TextField_scss(), EventListener = require_EventListener();
    function Resizer({
      contents,
      currentHeight: currentHeightProp = null,
      minimumLines,
      onHeightChange
    }) {
      let contentNode = React12.useRef(null), minimumLinesNode = React12.useRef(null), animationFrame = React12.useRef(), currentHeight = React12.useRef(currentHeightProp);
      currentHeightProp !== currentHeight.current && (currentHeight.current = currentHeightProp), React12.useEffect(() => () => {
        animationFrame.current && cancelAnimationFrame(animationFrame.current);
      }, []);
      let minimumLinesMarkup = minimumLines ? /* @__PURE__ */ React12.createElement("div", {
        ref: minimumLinesNode,
        className: TextField_module.default.DummyInput,
        dangerouslySetInnerHTML: {
          __html: getContentsForMinimumLines(minimumLines)
        }
      }) : null, handleHeightCheck = React12.useCallback(() => {
        animationFrame.current && cancelAnimationFrame(animationFrame.current), animationFrame.current = requestAnimationFrame(() => {
          if (!contentNode.current || !minimumLinesNode.current)
            return;
          let newHeight = Math.max(contentNode.current.offsetHeight, minimumLinesNode.current.offsetHeight);
          newHeight !== currentHeight.current && onHeightChange(newHeight);
        });
      }, [onHeightChange]);
      return useIsomorphicLayoutEffect.useIsomorphicLayoutEffect(() => {
        handleHeightCheck();
      }), /* @__PURE__ */ React12.createElement("div", {
        "aria-hidden": !0,
        className: TextField_module.default.Resizer
      }, /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
        event: "resize",
        handler: handleHeightCheck
      }), /* @__PURE__ */ React12.createElement("div", {
        ref: contentNode,
        className: TextField_module.default.DummyInput,
        dangerouslySetInnerHTML: {
          __html: getFinalContents(contents)
        }
      }), minimumLinesMarkup);
    }
    var ENTITIES_TO_REPLACE = {
      "&": "&amp;",
      "<": "&lt;",
      ">": "&gt;",
      "\n": "<br>",
      "\r": ""
    }, REPLACE_REGEX = new RegExp(`[${Object.keys(ENTITIES_TO_REPLACE).join()}]`, "g");
    function replaceEntity(entity) {
      return ENTITIES_TO_REPLACE[entity];
    }
    function getContentsForMinimumLines(minimumLines) {
      let content = "";
      for (let line = 0; line < minimumLines; line++)
        content += "<br>";
      return content;
    }
    function getFinalContents(contents) {
      return contents ? `${contents.replace(REPLACE_REGEX, replaceEntity)}<br>` : "<br>";
    }
    exports.Resizer = Resizer;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TextField/TextField.js
var require_TextField = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TextField/TextField.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), useIsAfterInitialMount = require_use_is_after_initial_mount(), types = require_types7(), useEventListener = require_use_event_listener(), TextField_module = require_TextField_scss(), Spinner = require_Spinner2(), Labelled = require_Labelled(), Connected = require_Connected(), Resizer = require_Resizer(), Label = require_Label(), hooks2 = require_hooks2(), Icon = require_Icon(), Text4 = require_Text();
    function TextField({
      prefix,
      suffix,
      verticalContent,
      placeholder,
      value = "",
      helpText,
      label,
      labelAction,
      labelHidden,
      disabled,
      clearButton,
      readOnly,
      autoFocus,
      focused,
      multiline,
      error,
      connectedRight,
      connectedLeft,
      type = "text",
      name,
      id: idProp,
      role,
      step,
      largeStep,
      autoComplete,
      max,
      maxLength,
      maxHeight,
      min,
      minLength,
      pattern,
      inputMode,
      spellCheck,
      ariaOwns,
      ariaControls,
      ariaExpanded,
      ariaActiveDescendant,
      ariaAutocomplete,
      showCharacterCount,
      align,
      requiredIndicator,
      monospaced,
      selectTextOnFocus,
      suggestion,
      variant = "inherit",
      size = "medium",
      onClearButtonClick,
      onChange,
      onSpinnerChange,
      onFocus,
      onBlur,
      tone
    }) {
      let i18n = hooks2.useI18n(), [height, setHeight] = React12.useState(null), [focus, setFocus] = React12.useState(!!focused), isAfterInitial = useIsAfterInitialMount.useIsAfterInitialMount(), uniqId = React12.useId(), id = idProp ?? uniqId, textFieldRef = React12.useRef(null), inputRef = React12.useRef(null), textAreaRef = React12.useRef(null), prefixRef = React12.useRef(null), suffixRef = React12.useRef(null), verticalContentRef = React12.useRef(null), buttonPressTimer = React12.useRef(), spinnerRef = React12.useRef(null), getInputRef = React12.useCallback(() => multiline ? textAreaRef.current : inputRef.current, [multiline]);
      React12.useEffect(() => {
        let input2 = getInputRef();
        !input2 || focused === void 0 || (focused ? input2.focus() : input2.blur());
      }, [focused, verticalContent, getInputRef]), React12.useEffect(() => {
        let input2 = inputRef.current;
        !input2 || !(type === "text" || type === "tel" || type === "search" || type === "url" || type === "password") || !suggestion || input2.setSelectionRange(value.length, suggestion.length);
      }, [focus, value, type, suggestion]);
      let normalizedValue = suggestion || value, normalizedStep = step ?? 1, normalizedMax = max ?? 1 / 0, normalizedMin = min ?? -1 / 0, className = css.classNames(TextField_module.default.TextField, !!normalizedValue && TextField_module.default.hasValue, disabled && TextField_module.default.disabled, readOnly && TextField_module.default.readOnly, error && TextField_module.default.error, tone && TextField_module.default[css.variationName("tone", tone)], multiline && TextField_module.default.multiline, focus && !disabled && TextField_module.default.focus, variant !== "inherit" && TextField_module.default[variant], size === "slim" && TextField_module.default.slim), inputType = type === "currency" ? "text" : type, isNumericType = type === "number" || type === "integer", iconPrefix = /* @__PURE__ */ React12.isValidElement(prefix) && prefix.type === Icon.Icon, prefixMarkup = prefix ? /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(TextField_module.default.Prefix, iconPrefix && TextField_module.default.PrefixIcon),
        id: `${id}-Prefix`,
        ref: prefixRef
      }, prefix) : null, suffixMarkup = suffix ? /* @__PURE__ */ React12.createElement("div", {
        className: TextField_module.default.Suffix,
        id: `${id}-Suffix`,
        ref: suffixRef
      }, suffix) : null, characterCountMarkup = null;
      if (showCharacterCount) {
        let characterCount = normalizedValue.length, characterCountLabel = maxLength ? i18n.translate("Polaris.TextField.characterCountWithMaxLength", {
          count: characterCount,
          limit: maxLength
        }) : i18n.translate("Polaris.TextField.characterCount", {
          count: characterCount
        }), characterCountClassName = css.classNames(TextField_module.default.CharacterCount, multiline && TextField_module.default.AlignFieldBottom), characterCountText = maxLength ? `${characterCount}/${maxLength}` : characterCount;
        characterCountMarkup = /* @__PURE__ */ React12.createElement("div", {
          id: `${id}-CharacterCounter`,
          className: characterCountClassName,
          "aria-label": characterCountLabel,
          "aria-live": focus ? "polite" : "off",
          "aria-atomic": "true",
          onClick: handleClickChild
        }, characterCountText);
      }
      let clearButtonMarkup = clearButton && normalizedValue !== "" ? /* @__PURE__ */ React12.createElement("button", {
        type: "button",
        className: TextField_module.default.ClearButton,
        onClick: handleClearButtonPress,
        disabled
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        visuallyHidden: !0
      }, i18n.translate("Polaris.Common.clear")), /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.XCircleIcon,
        tone: "base"
      })) : null, handleNumberChange = React12.useCallback((steps, stepAmount = normalizedStep) => {
        if (onChange == null && onSpinnerChange == null)
          return;
        let dpl = (num) => (num.toString().split(".")[1] || []).length, numericValue = value ? parseFloat(value) : 0;
        if (isNaN(numericValue))
          return;
        let decimalPlaces = type === "integer" ? 0 : Math.max(dpl(numericValue), dpl(stepAmount)), newValue = Math.min(Number(normalizedMax), Math.max(numericValue + steps * stepAmount, Number(normalizedMin)));
        onSpinnerChange != null ? onSpinnerChange(String(newValue.toFixed(decimalPlaces)), id) : onChange?.(String(newValue.toFixed(decimalPlaces)), id);
      }, [id, normalizedMax, normalizedMin, onChange, onSpinnerChange, normalizedStep, type, value]), handleSpinnerButtonRelease = React12.useCallback(() => {
        clearTimeout(buttonPressTimer.current);
      }, []), handleSpinnerButtonPress = React12.useCallback((onChange2) => {
        let interval = 200, onChangeInterval = () => {
          interval > 50 && (interval -= 10), onChange2(0), buttonPressTimer.current = window.setTimeout(onChangeInterval, interval);
        };
        buttonPressTimer.current = window.setTimeout(onChangeInterval, interval), document.addEventListener("mouseup", handleSpinnerButtonRelease, {
          once: !0
        });
      }, [handleSpinnerButtonRelease]), spinnerMarkup = isNumericType && step !== 0 && !disabled && !readOnly ? /* @__PURE__ */ React12.createElement(Spinner.Spinner, {
        onClick: handleClickChild,
        onChange: handleNumberChange,
        onMouseDown: handleSpinnerButtonPress,
        onMouseUp: handleSpinnerButtonRelease,
        ref: spinnerRef,
        onBlur: handleOnBlur
      }) : null, style = multiline && height ? {
        height,
        maxHeight
      } : null, handleExpandingResize = React12.useCallback((height2) => {
        setHeight(height2);
      }, []), resizer = multiline && isAfterInitial ? /* @__PURE__ */ React12.createElement(Resizer.Resizer, {
        contents: normalizedValue || placeholder,
        currentHeight: height,
        minimumLines: typeof multiline == "number" ? multiline : 1,
        onHeightChange: handleExpandingResize
      }) : null, describedBy = [];
      error && describedBy.push(`${id}Error`), helpText && describedBy.push(Labelled.helpTextID(id)), showCharacterCount && describedBy.push(`${id}-CharacterCounter`);
      let labelledBy = [];
      prefix && labelledBy.push(`${id}-Prefix`), suffix && labelledBy.push(`${id}-Suffix`), verticalContent && labelledBy.push(`${id}-VerticalContent`), labelledBy.unshift(Label.labelID(id));
      let inputClassName = css.classNames(TextField_module.default.Input, align && TextField_module.default[css.variationName("Input-align", align)], suffix && TextField_module.default["Input-suffixed"], clearButton && TextField_module.default["Input-hasClearButton"], monospaced && TextField_module.default.monospaced, suggestion && TextField_module.default.suggestion), handleOnFocus = (event) => {
        setFocus(!0), selectTextOnFocus && !suggestion && getInputRef()?.select(), onFocus && onFocus(event);
      };
      useEventListener.useEventListener("wheel", handleOnWheel, inputRef);
      function handleOnWheel(event) {
        document.activeElement === event.target && isNumericType && event.stopPropagation();
      }
      let input = /* @__PURE__ */ React12.createElement(multiline ? "textarea" : "input", {
        name,
        id,
        disabled,
        readOnly,
        role,
        autoFocus,
        value: normalizedValue,
        placeholder,
        style,
        autoComplete,
        className: inputClassName,
        ref: multiline ? textAreaRef : inputRef,
        min,
        max,
        step,
        minLength,
        maxLength,
        spellCheck,
        pattern,
        inputMode,
        type: inputType,
        rows: getRows(multiline),
        "aria-describedby": describedBy.length ? describedBy.join(" ") : void 0,
        "aria-labelledby": labelledBy.join(" "),
        "aria-invalid": !!error,
        "aria-owns": ariaOwns,
        "aria-activedescendant": ariaActiveDescendant,
        "aria-autocomplete": ariaAutocomplete,
        "aria-controls": ariaControls,
        "aria-expanded": ariaExpanded,
        "aria-required": requiredIndicator,
        ...normalizeAriaMultiline(multiline),
        onFocus: handleOnFocus,
        onBlur: handleOnBlur,
        onClick: handleClickChild,
        onKeyPress: handleKeyPress,
        onKeyDown: handleKeyDown,
        onChange: suggestion ? void 0 : handleChange,
        onInput: suggestion ? handleChange : void 0,
        // 1Password disable data attribute
        "data-1p-ignore": autoComplete === "off" || void 0,
        // LastPass disable data attribute
        "data-lpignore": autoComplete === "off" || void 0,
        // Dashlane disable data attribute
        "data-form-type": autoComplete === "off" ? "other" : void 0
      }), inputWithVerticalContentMarkup = verticalContent ? /* @__PURE__ */ React12.createElement("div", {
        className: TextField_module.default.VerticalContent,
        id: `${id}-VerticalContent`,
        ref: verticalContentRef,
        onClick: handleClickChild
      }, verticalContent, input) : null, inputMarkup = verticalContent ? inputWithVerticalContentMarkup : input, backdropMarkup = /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(TextField_module.default.Backdrop, connectedLeft && TextField_module.default["Backdrop-connectedLeft"], connectedRight && TextField_module.default["Backdrop-connectedRight"])
      });
      return /* @__PURE__ */ React12.createElement(Labelled.Labelled, {
        label,
        id,
        error,
        action: labelAction,
        labelHidden,
        helpText,
        requiredIndicator,
        disabled,
        readOnly
      }, /* @__PURE__ */ React12.createElement(Connected.Connected, {
        left: connectedLeft,
        right: connectedRight
      }, /* @__PURE__ */ React12.createElement("div", {
        className,
        onClick: handleClick,
        ref: textFieldRef
      }, prefixMarkup, inputMarkup, suffixMarkup, characterCountMarkup, clearButtonMarkup, spinnerMarkup, backdropMarkup, resizer)));
      function handleChange(event) {
        onChange && onChange(event.currentTarget.value, id);
      }
      function handleClick(event) {
        let {
          target
        } = event, inputRefRole = inputRef?.current?.getAttribute("role");
        if (target === inputRef.current && inputRefRole === "combobox") {
          inputRef.current?.focus(), handleOnFocus(event);
          return;
        }
        isPrefixOrSuffix(target) || isVerticalContent(target) || isInput(target) || isSpinner(target) || focus || getInputRef()?.focus();
      }
      function handleClickChild(event) {
        !isSpinner(event.target) && !isInput(event.target) && event.stopPropagation(), !(isPrefixOrSuffix(event.target) || isVerticalContent(event.target) || isInput(event.target) || focus) && (setFocus(!0), getInputRef()?.focus());
      }
      function handleClearButtonPress() {
        onClearButtonClick && onClearButtonClick(id);
      }
      function handleKeyPress(event) {
        let {
          key,
          which
        } = event, numbersSpec = /[\d.,eE+-]$/, integerSpec = /[\deE+-]$/;
        !isNumericType || which === types.Key.Enter || type === "number" && numbersSpec.test(key) || type === "integer" && integerSpec.test(key) || event.preventDefault();
      }
      function handleKeyDown(event) {
        if (!isNumericType)
          return;
        let {
          key,
          which
        } = event;
        type === "integer" && (key === "ArrowUp" || which === types.Key.UpArrow) && (handleNumberChange(1), event.preventDefault()), type === "integer" && (key === "ArrowDown" || which === types.Key.DownArrow) && (handleNumberChange(-1), event.preventDefault()), (which === types.Key.Home || key === "Home") && min !== void 0 && (onSpinnerChange != null ? onSpinnerChange(String(min), id) : onChange?.(String(min), id)), (which === types.Key.End || key === "End") && max !== void 0 && (onSpinnerChange != null ? onSpinnerChange(String(max), id) : onChange?.(String(max), id)), (which === types.Key.PageUp || key === "PageUp") && largeStep !== void 0 && handleNumberChange(1, largeStep), (which === types.Key.PageDown || key === "PageDown") && largeStep !== void 0 && handleNumberChange(-1, largeStep);
      }
      function handleOnBlur(event) {
        setFocus(!1), !textFieldRef.current?.contains(event?.relatedTarget) && onBlur && onBlur(event);
      }
      function isInput(target) {
        let input2 = getInputRef();
        return target instanceof HTMLElement && input2 && (input2.contains(target) || input2.contains(document.activeElement));
      }
      function isPrefixOrSuffix(target) {
        return target instanceof Element && (prefixRef.current && prefixRef.current.contains(target) || suffixRef.current && suffixRef.current.contains(target));
      }
      function isSpinner(target) {
        return target instanceof Element && spinnerRef.current && spinnerRef.current.contains(target);
      }
      function isVerticalContent(target) {
        return target instanceof Element && verticalContentRef.current && (verticalContentRef.current.contains(target) || verticalContentRef.current.contains(document.activeElement));
      }
    }
    function getRows(multiline) {
      if (multiline)
        return typeof multiline == "number" ? multiline : 1;
    }
    function normalizeAriaMultiline(multiline) {
      if (multiline)
        return multiline || typeof multiline == "number" && multiline > 0 ? {
          "aria-multiline": !0
        } : void 0;
    }
    exports.TextField = TextField;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionList/ActionList.js
var require_ActionList = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionList/ActionList.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), types = require_types7(), focus = require_focus(), FilterActionsProvider = require_FilterActionsProvider(), Section = require_Section(), KeypressListener = require_KeypressListener(), TextField = require_TextField(), hooks2 = require_hooks2(), Box2 = require_Box(), Icon = require_Icon(), Item = require_Item(), FILTER_ACTIONS_THRESHOLD = 8;
    function ActionList({
      items,
      sections = [],
      actionRole,
      allowFiltering,
      onActionAnyItem
    }) {
      let i18n = hooks2.useI18n(), filterActions = React12.useContext(FilterActionsProvider.FilterActionsContext), finalSections = [], actionListRef = React12.useRef(null), [searchText, setSeachText] = React12.useState("");
      items ? finalSections = [{
        items
      }, ...sections] : sections && (finalSections = sections);
      let isFilterable = finalSections?.some((section) => section.items.some((item) => typeof item.content == "string")), hasMultipleSections = finalSections.length > 1, elementRole = hasMultipleSections && actionRole === "menuitem" ? "menu" : void 0, elementTabIndex = hasMultipleSections && actionRole === "menuitem" ? -1 : void 0, filteredSections = finalSections?.map((section) => ({
        ...section,
        items: section.items.filter(({
          content
        }) => typeof content == "string" ? content?.toLowerCase().includes(searchText.toLowerCase()) : content)
      })), sectionMarkup = filteredSections.map((section, index) => section.items.length > 0 ? /* @__PURE__ */ React12.createElement(Section.Section, {
        key: typeof section.title == "string" ? section.title : index,
        section,
        hasMultipleSections,
        actionRole,
        onActionAnyItem,
        isFirst: index === 0
      }) : null), handleFocusPreviousItem = (evt) => {
        evt.preventDefault(), actionListRef.current && evt.target && actionListRef.current.contains(evt.target) && focus.wrapFocusPreviousFocusableMenuItem(actionListRef.current, evt.target);
      }, handleFocusNextItem = (evt) => {
        evt.preventDefault(), actionListRef.current && evt.target && actionListRef.current.contains(evt.target) && focus.wrapFocusNextFocusableMenuItem(actionListRef.current, evt.target);
      }, listeners = actionRole === "menuitem" ? /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement(KeypressListener.KeypressListener, {
        keyEvent: "keydown",
        keyCode: types.Key.DownArrow,
        handler: handleFocusNextItem
      }), /* @__PURE__ */ React12.createElement(KeypressListener.KeypressListener, {
        keyEvent: "keydown",
        keyCode: types.Key.UpArrow,
        handler: handleFocusPreviousItem
      })) : null, totalFilteredActions = React12.useMemo(() => filteredSections?.reduce((acc, section) => acc + section.items.length, 0) || 0, [filteredSections]), hasManyActions = (finalSections?.reduce((acc, section) => acc + section.items.length, 0) || 0) >= FILTER_ACTIONS_THRESHOLD;
      return /* @__PURE__ */ React12.createElement(React12.Fragment, null, (allowFiltering || filterActions) && hasManyActions && isFilterable && /* @__PURE__ */ React12.createElement(Box2.Box, {
        padding: "200",
        paddingBlockEnd: totalFilteredActions > 0 ? "0" : "200"
      }, /* @__PURE__ */ React12.createElement(TextField.TextField, {
        clearButton: !0,
        labelHidden: !0,
        label: i18n.translate("Polaris.ActionList.SearchField.placeholder"),
        placeholder: i18n.translate("Polaris.ActionList.SearchField.placeholder"),
        autoComplete: "off",
        value: searchText,
        onChange: (value) => setSeachText(value),
        prefix: /* @__PURE__ */ React12.createElement(Icon.Icon, {
          source: polarisIcons.SearchIcon
        }),
        onClearButtonClick: () => setSeachText("")
      })), /* @__PURE__ */ React12.createElement(Box2.Box, {
        as: hasMultipleSections ? "ul" : "div",
        ref: actionListRef,
        role: elementRole,
        tabIndex: elementTabIndex
      }, listeners, sectionMarkup));
    }
    ActionList.Item = Item.Item;
    exports.ActionList = ActionList;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/ActionMenu.scss.js
var require_ActionMenu_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/ActionMenu.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      ActionMenu: "Polaris-ActionMenu"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/components/RollupActions/RollupActions.scss.js
var require_RollupActions_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/components/RollupActions/RollupActions.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      RollupActivator: "Polaris-ActionMenu-RollupActions__RollupActivator"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Popover/set-activator-attributes.js
var require_set_activator_attributes = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Popover/set-activator-attributes.js"(exports) {
    "use strict";
    init_cjs_shims();
    function setActivatorAttributes(activator, {
      id,
      active = !1,
      ariaHaspopup,
      activatorDisabled = !1
    }) {
      activatorDisabled || (activator.tabIndex = activator.tabIndex || 0), activator.setAttribute("aria-controls", id), activator.setAttribute("aria-owns", id), activator.setAttribute("aria-expanded", String(active)), activator.setAttribute("data-state", active ? "open" : "closed"), ariaHaspopup != null && activator.setAttribute("aria-haspopup", String(ariaHaspopup));
    }
    exports.setActivatorAttributes = setActivatorAttributes;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/components.js
var require_components = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/components.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react();
    function wrapWithComponent(element, Component, props) {
      return element == null ? null : isElementOfType(element, Component) ? element : /* @__PURE__ */ React12.createElement(Component, props, element);
    }
    var isComponent = process.env.NODE_ENV === "development" ? hotReloadComponentCheck : (AComponent, AnotherComponent) => AComponent === AnotherComponent;
    function isElementOfType(element, Component) {
      if (element == null || !/* @__PURE__ */ React12.isValidElement(element) || typeof element.type == "string")
        return !1;
      let {
        type: defaultType
      } = element, type = element.props?.__type__ || defaultType;
      return (Array.isArray(Component) ? Component : [Component]).some((AComponent) => typeof type != "string" && isComponent(AComponent, type));
    }
    function elementChildren(children, predicate = () => !0) {
      return React12.Children.toArray(children).filter((child) => /* @__PURE__ */ React12.isValidElement(child) && predicate(child));
    }
    function ConditionalWrapper({
      condition,
      wrapper,
      children
    }) {
      return condition ? wrapper(children) : children;
    }
    function ConditionalRender({
      condition,
      children
    }) {
      return condition ? children : null;
    }
    function hotReloadComponentCheck(AComponent, AnotherComponent) {
      let componentName = AComponent.name, anotherComponentName = AnotherComponent.displayName;
      return AComponent === AnotherComponent || !!componentName && componentName === anotherComponentName;
    }
    exports.ConditionalRender = ConditionalRender;
    exports.ConditionalWrapper = ConditionalWrapper;
    exports.elementChildren = elementChildren;
    exports.isElementOfType = isElementOfType;
    exports.wrapWithComponent = wrapWithComponent;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Popover/Popover.scss.js
var require_Popover_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Popover/Popover.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Popover: "Polaris-Popover",
      PopoverOverlay: "Polaris-Popover__PopoverOverlay",
      "PopoverOverlay-entering": "Polaris-Popover__PopoverOverlay--entering",
      "PopoverOverlay-open": "Polaris-Popover__PopoverOverlay--open",
      measuring: "Polaris-Popover--measuring",
      "PopoverOverlay-exiting": "Polaris-Popover__PopoverOverlay--exiting",
      fullWidth: "Polaris-Popover--fullWidth",
      Content: "Polaris-Popover__Content",
      positionedAbove: "Polaris-Popover--positionedAbove",
      ContentContainer: "Polaris-Popover__ContentContainer",
      "Content-fullHeight": "Polaris-Popover__Content--fullHeight",
      "Content-fluidContent": "Polaris-Popover__Content--fluidContent",
      Pane: "Polaris-Popover__Pane",
      "Pane-fixed": "Polaris-Popover__Pane--fixed",
      "Pane-subdued": "Polaris-Popover__Pane--subdued",
      "Pane-captureOverscroll": "Polaris-Popover__Pane--captureOverscroll",
      Section: "Polaris-Popover__Section",
      FocusTracker: "Polaris-Popover__FocusTracker",
      "PopoverOverlay-hideOnPrint": "Polaris-Popover__PopoverOverlay--hideOnPrint"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Popover/components/Section/Section.js
var require_Section2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Popover/components/Section/Section.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), Popover_module = require_Popover_scss(), Box2 = require_Box();
    function Section({
      children
    }) {
      return /* @__PURE__ */ React12.createElement("div", {
        className: Popover_module.default.Section
      }, /* @__PURE__ */ React12.createElement(Box2.Box, {
        paddingInlineStart: "300",
        paddingInlineEnd: "300",
        paddingBlockStart: "200",
        paddingBlockEnd: "150"
      }, children));
    }
    exports.Section = Section;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Popover/components/Pane/Pane.js
var require_Pane = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Popover/components/Pane/Pane.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), components = require_components(), Popover_module = require_Popover_scss(), Section = require_Section2(), Scrollable = require_Scrollable();
    function Pane({
      captureOverscroll = !1,
      fixed,
      sectioned,
      children,
      height,
      subdued,
      onScrolledToBottom
    }) {
      let className = css.classNames(Popover_module.default.Pane, fixed && Popover_module.default["Pane-fixed"], subdued && Popover_module.default["Pane-subdued"], captureOverscroll && Popover_module.default["Pane-captureOverscroll"]), content = sectioned ? components.wrapWithComponent(children, Section.Section, {}) : children, style = height ? {
        height,
        maxHeight: height,
        minHeight: height
      } : void 0;
      return fixed ? /* @__PURE__ */ React12.createElement("div", {
        style,
        className
      }, content) : /* @__PURE__ */ React12.createElement(Scrollable.Scrollable, {
        shadow: !0,
        className,
        style,
        onScrolledToBottom
      }, content);
    }
    exports.Pane = Pane;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Popover/components/PopoverOverlay/PopoverOverlay.js
var require_PopoverOverlay = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Popover/components/PopoverOverlay/PopoverOverlay.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisTokens = require_build2(), focus = require_focus(), css = require_css(), components = require_components(), types = require_types7(), shared = require_shared(), Popover_module = require_Popover_scss(), Pane = require_Pane(), context = require_context7(), EventListener = require_EventListener(), KeypressListener = require_KeypressListener(), PositionedOverlay = require_PositionedOverlay();
    exports.PopoverCloseSource = void 0;
    (function(PopoverCloseSource) {
      PopoverCloseSource[PopoverCloseSource.Click = 0] = "Click", PopoverCloseSource[PopoverCloseSource.EscapeKeypress = 1] = "EscapeKeypress", PopoverCloseSource[PopoverCloseSource.FocusOut = 2] = "FocusOut", PopoverCloseSource[PopoverCloseSource.ScrollOut = 3] = "ScrollOut";
    })(exports.PopoverCloseSource || (exports.PopoverCloseSource = {}));
    var TransitionStatus;
    (function(TransitionStatus2) {
      TransitionStatus2.Entering = "entering", TransitionStatus2.Entered = "entered", TransitionStatus2.Exiting = "exiting", TransitionStatus2.Exited = "exited";
    })(TransitionStatus || (TransitionStatus = {}));
    var PopoverOverlay = class extends React12.PureComponent {
      constructor(props) {
        super(props), this.state = {
          transitionStatus: this.props.active ? TransitionStatus.Entering : TransitionStatus.Exited
        }, this.contentNode = /* @__PURE__ */ React12.createRef(), this.renderPopover = (overlayDetails) => {
          let {
            measuring,
            desiredHeight,
            positioning
          } = overlayDetails, {
            id,
            children,
            sectioned,
            fullWidth,
            fullHeight,
            fluidContent,
            hideOnPrint,
            autofocusTarget,
            captureOverscroll
          } = this.props, className = css.classNames(Popover_module.default.Popover, positioning === "above" && Popover_module.default.positionedAbove, fullWidth && Popover_module.default.fullWidth, measuring && Popover_module.default.measuring, hideOnPrint && Popover_module.default["PopoverOverlay-hideOnPrint"]), contentStyles = measuring ? void 0 : {
            height: desiredHeight
          }, contentClassNames = css.classNames(Popover_module.default.Content, fullHeight && Popover_module.default["Content-fullHeight"], fluidContent && Popover_module.default["Content-fluidContent"]);
          return /* @__PURE__ */ React12.createElement("div", Object.assign({
            className
          }, shared.overlay.props), /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
            event: "click",
            handler: this.handleClick
          }), /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
            event: "touchstart",
            handler: this.handleClick
          }), /* @__PURE__ */ React12.createElement(KeypressListener.KeypressListener, {
            keyCode: types.Key.Escape,
            handler: this.handleEscape
          }), /* @__PURE__ */ React12.createElement("div", {
            className: Popover_module.default.FocusTracker,
            tabIndex: 0,
            onFocus: this.handleFocusFirstItem
          }), /* @__PURE__ */ React12.createElement("div", {
            className: Popover_module.default.ContentContainer
          }, /* @__PURE__ */ React12.createElement("div", {
            id,
            tabIndex: autofocusTarget === "none" ? void 0 : -1,
            className: contentClassNames,
            style: contentStyles,
            ref: this.contentNode
          }, renderPopoverContent(children, {
            captureOverscroll,
            sectioned
          }))), /* @__PURE__ */ React12.createElement("div", {
            className: Popover_module.default.FocusTracker,
            tabIndex: 0,
            onFocus: this.handleFocusLastItem
          }));
        }, this.handleClick = (event) => {
          let target = event.target, {
            contentNode,
            props: {
              activator,
              onClose,
              preventCloseOnChildOverlayClick
            }
          } = this, composedPath = event.composedPath(), wasDescendant = preventCloseOnChildOverlayClick ? wasPolarisPortalDescendant(composedPath, this.context.container) : wasContentNodeDescendant(composedPath, contentNode), isActivatorDescendant = nodeContainsDescendant(activator, target);
          wasDescendant || isActivatorDescendant || this.state.transitionStatus !== TransitionStatus.Entered || onClose(exports.PopoverCloseSource.Click);
        }, this.handleScrollOut = () => {
          this.props.onClose(exports.PopoverCloseSource.ScrollOut);
        }, this.handleEscape = (event) => {
          let target = event.target, {
            contentNode,
            props: {
              activator
            }
          } = this, composedPath = event.composedPath(), wasDescendant = wasContentNodeDescendant(composedPath, contentNode), isActivatorDescendant = nodeContainsDescendant(activator, target);
          (wasDescendant || isActivatorDescendant) && this.props.onClose(exports.PopoverCloseSource.EscapeKeypress);
        }, this.handleFocusFirstItem = () => {
          this.props.onClose(exports.PopoverCloseSource.FocusOut);
        }, this.handleFocusLastItem = () => {
          this.props.onClose(exports.PopoverCloseSource.FocusOut);
        }, this.overlayRef = /* @__PURE__ */ React12.createRef();
      }
      forceUpdatePosition() {
        this.overlayRef.current?.forceUpdatePosition();
      }
      changeTransitionStatus(transitionStatus, cb) {
        this.setState({
          transitionStatus
        }, cb), this.contentNode.current && this.contentNode.current.getBoundingClientRect();
      }
      componentDidMount() {
        this.props.active && (this.focusContent(), this.changeTransitionStatus(TransitionStatus.Entered));
      }
      componentDidUpdate(oldProps) {
        this.props.active && !oldProps.active && (this.focusContent(), this.changeTransitionStatus(TransitionStatus.Entering, () => {
          this.clearTransitionTimeout(), this.enteringTimer = window.setTimeout(() => {
            this.setState({
              transitionStatus: TransitionStatus.Entered
            });
          }, parseInt(polarisTokens.themeDefault.motion["motion-duration-100"], 10));
        })), !this.props.active && oldProps.active && (this.clearTransitionTimeout(), this.setState({
          transitionStatus: TransitionStatus.Exited
        }));
      }
      componentWillUnmount() {
        this.clearTransitionTimeout();
      }
      render() {
        let {
          active,
          activator,
          fullWidth,
          preferredPosition = "below",
          preferredAlignment = "center",
          preferInputActivator = !0,
          fixed,
          zIndexOverride
        } = this.props, {
          transitionStatus
        } = this.state;
        if (transitionStatus === TransitionStatus.Exited && !active)
          return null;
        let className = css.classNames(Popover_module.default.PopoverOverlay, transitionStatus === TransitionStatus.Entering && Popover_module.default["PopoverOverlay-entering"], transitionStatus === TransitionStatus.Entered && Popover_module.default["PopoverOverlay-open"], transitionStatus === TransitionStatus.Exiting && Popover_module.default["PopoverOverlay-exiting"]);
        return /* @__PURE__ */ React12.createElement(PositionedOverlay.PositionedOverlay, {
          ref: this.overlayRef,
          fullWidth,
          active,
          activator,
          preferInputActivator,
          preferredPosition,
          preferredAlignment,
          render: this.renderPopover.bind(this),
          fixed,
          onScrollOut: this.handleScrollOut,
          classNames: className,
          zIndexOverride
        });
      }
      clearTransitionTimeout() {
        this.enteringTimer && window.clearTimeout(this.enteringTimer);
      }
      focusContent() {
        let {
          autofocusTarget = "container"
        } = this.props;
        autofocusTarget === "none" || this.contentNode == null || requestAnimationFrame(() => {
          if (this.contentNode.current == null)
            return;
          let focusableChild = focus.findFirstKeyboardFocusableNode(this.contentNode.current);
          focusableChild && autofocusTarget === "first-node" ? focusableChild.focus({
            preventScroll: process.env.NODE_ENV === "development"
          }) : this.contentNode.current.focus({
            preventScroll: process.env.NODE_ENV === "development"
          });
        });
      }
      // eslint-disable-next-line @shopify/react-no-multiple-render-methods
    };
    PopoverOverlay.contextType = context.PortalsManagerContext;
    function renderPopoverContent(children, props) {
      let childrenArray = React12.Children.toArray(children);
      return components.isElementOfType(childrenArray[0], Pane.Pane) ? childrenArray : components.wrapWithComponent(childrenArray, Pane.Pane, props);
    }
    function nodeContainsDescendant(rootNode, descendant) {
      if (rootNode === descendant)
        return !0;
      let parent = descendant.parentNode;
      for (; parent != null; ) {
        if (parent === rootNode)
          return !0;
        parent = parent.parentNode;
      }
      return !1;
    }
    function wasContentNodeDescendant(composedPath, contentNode) {
      return contentNode.current != null && composedPath.includes(contentNode.current);
    }
    function wasPolarisPortalDescendant(composedPath, portalsContainerElement) {
      return composedPath.some((eventTarget) => eventTarget instanceof Node && portalsContainerElement?.contains(eventTarget));
    }
    exports.PopoverOverlay = PopoverOverlay;
    exports.nodeContainsDescendant = nodeContainsDescendant;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Popover/Popover.js
var require_Popover = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Popover/Popover.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), focus = require_focus(), shared = require_shared(), setActivatorAttributes = require_set_activator_attributes(), PopoverOverlay = require_PopoverOverlay(), Pane = require_Pane(), Section = require_Section2(), Portal = require_Portal(), PopoverComponent = /* @__PURE__ */ React12.forwardRef(function({
      activatorWrapper = "div",
      children,
      onClose,
      activator,
      preventFocusOnClose,
      active,
      fixed,
      ariaHaspopup,
      preferInputActivator = !0,
      zIndexOverride,
      ...rest
    }, ref) {
      let [activatorNode, setActivatorNode] = React12.useState(), overlayRef = React12.useRef(null), activatorContainer = React12.useRef(null), WrapperComponent = activatorWrapper, id = React12.useId();
      function forceUpdatePosition() {
        overlayRef.current?.forceUpdatePosition();
      }
      React12.useImperativeHandle(ref, () => ({
        forceUpdatePosition
      }));
      let setAccessibilityAttributes = React12.useCallback(() => {
        if (activatorContainer.current == null)
          return;
        let focusableActivator = focus.findFirstFocusableNodeIncludingDisabled(activatorContainer.current) || activatorContainer.current, activatorDisabled = "disabled" in focusableActivator && !!focusableActivator.disabled;
        setActivatorAttributes.setActivatorAttributes(focusableActivator, {
          id,
          active,
          ariaHaspopup,
          activatorDisabled
        });
      }, [id, active, ariaHaspopup]), handleClose = (source) => {
        if (onClose(source), !(activatorContainer.current == null || preventFocusOnClose)) {
          if (source === PopoverOverlay.PopoverCloseSource.FocusOut && activatorNode) {
            let focusableActivator = focus.findFirstFocusableNodeIncludingDisabled(activatorNode) || focus.findFirstFocusableNodeIncludingDisabled(activatorContainer.current) || activatorContainer.current;
            focus.focusNextFocusableNode(focusableActivator, isInPortal) || focusableActivator.focus();
          } else if (source === PopoverOverlay.PopoverCloseSource.EscapeKeypress && activatorNode) {
            let focusableActivator = focus.findFirstFocusableNodeIncludingDisabled(activatorNode) || focus.findFirstFocusableNodeIncludingDisabled(activatorContainer.current) || activatorContainer.current;
            focusableActivator ? focusableActivator.focus() : focus.focusNextFocusableNode(focusableActivator, isInPortal);
          }
        }
      };
      React12.useEffect(() => {
        (!activatorNode && activatorContainer.current || activatorNode && activatorContainer.current && !activatorContainer.current.contains(activatorNode)) && setActivatorNode(activatorContainer.current.firstElementChild), setAccessibilityAttributes();
      }, [activatorNode, setAccessibilityAttributes]), React12.useEffect(() => {
        activatorNode && activatorContainer.current && setActivatorNode(activatorContainer.current.firstElementChild), setAccessibilityAttributes();
      }, [activatorNode, setAccessibilityAttributes]);
      let portal = activatorNode ? /* @__PURE__ */ React12.createElement(Portal.Portal, {
        idPrefix: "popover"
      }, /* @__PURE__ */ React12.createElement(PopoverOverlay.PopoverOverlay, Object.assign({
        ref: overlayRef,
        id,
        activator: activatorNode,
        preferInputActivator,
        onClose: handleClose,
        active,
        fixed,
        zIndexOverride
      }, rest), children)) : null;
      return /* @__PURE__ */ React12.createElement(WrapperComponent, {
        ref: activatorContainer
      }, React12.Children.only(activator), portal);
    });
    function isInPortal(element) {
      let parentElement = element.parentElement;
      for (; parentElement; ) {
        if (parentElement.matches(shared.portal.selector))
          return !1;
        parentElement = parentElement.parentElement;
      }
      return !0;
    }
    var Popover = Object.assign(PopoverComponent, {
      Pane: Pane.Pane,
      Section: Section.Section
    });
    Object.defineProperty(exports, "PopoverCloseSource", {
      enumerable: !0,
      get: function() {
        return PopoverOverlay.PopoverCloseSource;
      }
    });
    exports.Popover = Popover;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/components/RollupActions/RollupActions.js
var require_RollupActions = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/components/RollupActions/RollupActions.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), useToggle = require_use_toggle(), RollupActions_module = require_RollupActions_scss(), hooks2 = require_hooks2(), Button2 = require_Button(), Popover = require_Popover(), ActionList = require_ActionList();
    function RollupActions({
      accessibilityLabel,
      items = [],
      sections = []
    }) {
      let i18n = hooks2.useI18n(), {
        value: rollupOpen,
        toggle: toggleRollupOpen
      } = useToggle.useToggle(!1);
      if (items.length === 0 && sections.length === 0)
        return null;
      let activatorMarkup = /* @__PURE__ */ React12.createElement("div", {
        className: RollupActions_module.default.RollupActivator
      }, /* @__PURE__ */ React12.createElement(Button2.Button, {
        icon: polarisIcons.MenuHorizontalIcon,
        accessibilityLabel: accessibilityLabel || i18n.translate("Polaris.ActionMenu.RollupActions.rollupButton"),
        onClick: toggleRollupOpen
      }));
      return /* @__PURE__ */ React12.createElement(Popover.Popover, {
        active: rollupOpen,
        activator: activatorMarkup,
        preferredAlignment: "right",
        onClose: toggleRollupOpen,
        hideOnPrint: !0
      }, /* @__PURE__ */ React12.createElement(ActionList.ActionList, {
        items,
        sections,
        onActionAnyItem: toggleRollupOpen
      }));
    }
    exports.RollupActions = RollupActions;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/components/Actions/Actions.scss.js
var require_Actions_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/components/Actions/Actions.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      ActionsLayout: "Polaris-ActionMenu-Actions__ActionsLayout"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/components/MenuGroup/MenuGroup.scss.js
var require_MenuGroup_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/components/MenuGroup/MenuGroup.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Details: "Polaris-ActionMenu-MenuGroup__Details"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/components/SecondaryAction/SecondaryAction.scss.js
var require_SecondaryAction_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/components/SecondaryAction/SecondaryAction.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      SecondaryAction: "Polaris-ActionMenu-SecondaryAction",
      critical: "Polaris-ActionMenu-SecondaryAction--critical"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/components/SecondaryAction/SecondaryAction.js
var require_SecondaryAction = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/components/SecondaryAction/SecondaryAction.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), SecondaryAction_module = require_SecondaryAction_scss(), Button2 = require_Button(), Tooltip = require_Tooltip();
    function SecondaryAction({
      children,
      tone,
      helpText,
      onAction,
      getOffsetWidth,
      destructive,
      ...rest
    }) {
      let secondaryActionsRef = React12.useRef(null);
      React12.useEffect(() => {
        !getOffsetWidth || !secondaryActionsRef.current || getOffsetWidth(secondaryActionsRef.current?.offsetWidth);
      }, [getOffsetWidth]);
      let buttonMarkup = /* @__PURE__ */ React12.createElement(Button2.Button, Object.assign({
        onClick: onAction,
        tone: destructive ? "critical" : void 0
      }, rest), children), actionMarkup = helpText ? /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, {
        preferredPosition: "below",
        content: helpText
      }, buttonMarkup) : buttonMarkup;
      return /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(SecondaryAction_module.default.SecondaryAction, tone === "critical" && SecondaryAction_module.default.critical),
        ref: secondaryActionsRef
      }, actionMarkup);
    }
    exports.SecondaryAction = SecondaryAction;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/components/MenuGroup/MenuGroup.js
var require_MenuGroup = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/components/MenuGroup/MenuGroup.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), MenuGroup_module = require_MenuGroup_scss(), Popover = require_Popover(), ActionList = require_ActionList(), SecondaryAction = require_SecondaryAction();
    function MenuGroup({
      accessibilityLabel,
      active,
      actions,
      details,
      title,
      icon,
      disabled,
      onClick,
      onClose,
      onOpen,
      getOffsetWidth,
      sections
    }) {
      let handleClose = React12.useCallback(() => {
        onClose(title);
      }, [onClose, title]), handleOpen = React12.useCallback(() => {
        onOpen(title);
      }, [onOpen, title]), handleClick = React12.useCallback(() => {
        onClick ? onClick(handleOpen) : handleOpen();
      }, [onClick, handleOpen]), handleOffsetWidth = React12.useCallback((width) => {
        getOffsetWidth && getOffsetWidth(width);
      }, [getOffsetWidth]), popoverActivator = /* @__PURE__ */ React12.createElement(SecondaryAction.SecondaryAction, {
        disclosure: !0,
        disabled,
        icon,
        accessibilityLabel,
        onClick: handleClick,
        getOffsetWidth: handleOffsetWidth
      }, title);
      return /* @__PURE__ */ React12.createElement(Popover.Popover, {
        active: !!active,
        activator: popoverActivator,
        preferredAlignment: "left",
        onClose: handleClose,
        hideOnPrint: !0
      }, /* @__PURE__ */ React12.createElement(ActionList.ActionList, {
        items: actions,
        sections,
        onActionAnyItem: handleClose
      }), details && /* @__PURE__ */ React12.createElement("div", {
        className: MenuGroup_module.default.Details
      }, details));
    }
    exports.MenuGroup = MenuGroup;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ButtonGroup/ButtonGroup.scss.js
var require_ButtonGroup_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ButtonGroup/ButtonGroup.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      ButtonGroup: "Polaris-ButtonGroup",
      Item: "Polaris-ButtonGroup__Item",
      "Item-plain": "Polaris-ButtonGroup__Item--plain",
      variantSegmented: "Polaris-ButtonGroup--variantSegmented",
      "Item-focused": "Polaris-ButtonGroup__Item--focused",
      fullWidth: "Polaris-ButtonGroup--fullWidth",
      extraTight: "Polaris-ButtonGroup--extraTight",
      tight: "Polaris-ButtonGroup--tight",
      loose: "Polaris-ButtonGroup--loose",
      noWrap: "Polaris-ButtonGroup--noWrap"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ButtonGroup/components/Item/Item.js
var require_Item3 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ButtonGroup/components/Item/Item.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), useToggle = require_use_toggle(), css = require_css(), ButtonGroup_module = require_ButtonGroup_scss();
    function Item({
      button
    }) {
      let {
        value: focused,
        setTrue: forceTrueFocused,
        setFalse: forceFalseFocused
      } = useToggle.useToggle(!1), className = css.classNames(ButtonGroup_module.default.Item, focused && ButtonGroup_module.default["Item-focused"], button.props.variant === "plain" && ButtonGroup_module.default["Item-plain"]);
      return /* @__PURE__ */ React12.createElement("div", {
        className,
        onFocus: forceTrueFocused,
        onBlur: forceFalseFocused
      }, button);
    }
    exports.Item = Item;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ButtonGroup/ButtonGroup.js
var require_ButtonGroup = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ButtonGroup/ButtonGroup.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), components = require_components(), ButtonGroup_module = require_ButtonGroup_scss(), Item = require_Item3();
    function ButtonGroup({
      children,
      gap,
      variant,
      fullWidth,
      connectedTop,
      noWrap
    }) {
      let className = css.classNames(ButtonGroup_module.default.ButtonGroup, gap && ButtonGroup_module.default[gap], variant && ButtonGroup_module.default[css.variationName("variant", variant)], fullWidth && ButtonGroup_module.default.fullWidth, noWrap && ButtonGroup_module.default.noWrap), contents = components.elementChildren(children).map((child, index) => /* @__PURE__ */ React12.createElement(Item.Item, {
        button: child,
        key: index
      }));
      return /* @__PURE__ */ React12.createElement("div", {
        className,
        "data-buttongroup-variant": variant,
        "data-buttongroup-connected-top": connectedTop,
        "data-buttongroup-full-width": fullWidth,
        "data-buttongroup-no-wrap": noWrap
      }, contents);
    }
    exports.ButtonGroup = ButtonGroup;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/components/Actions/Actions.js
var require_Actions = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/components/Actions/Actions.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), debounce = require_debounce2(), useEventListener = require_use_event_listener(), useIsomorphicLayoutEffect = require_use_isomorphic_layout_effect(), Actions_module = require_Actions_scss(), MenuGroup = require_MenuGroup(), ButtonGroup = require_ButtonGroup(), hooks2 = require_hooks2(), SecondaryAction = require_SecondaryAction(), ACTION_SPACING = 8;
    function Actions({
      actions = [],
      groups = [],
      onActionRollup
    }) {
      let i18n = hooks2.useI18n(), actionsLayoutRef = React12.useRef(null), menuGroupWidthRef = React12.useRef(0), availableWidthRef = React12.useRef(0), actionsAndGroupsLengthRef = React12.useRef(0), timesMeasured = React12.useRef(0), actionWidthsRef = React12.useRef([]), rollupActiveRef = React12.useRef(null), [activeMenuGroup, setActiveMenuGroup] = React12.useState(void 0), [measuredActions, setMeasuredActions] = React12.useState({
        showable: [],
        rolledUp: []
      }), defaultRollupGroup = {
        title: i18n.translate("Polaris.ActionMenu.Actions.moreActions"),
        actions: []
      }, lastMenuGroup = [...groups].pop(), lastMenuGroupWidth = [...actionWidthsRef.current].pop() || 0, handleActionsOffsetWidth = React12.useCallback((width) => {
        actionWidthsRef.current = [...actionWidthsRef.current, width];
      }, []), handleMenuGroupToggle = React12.useCallback((group) => setActiveMenuGroup(activeMenuGroup ? void 0 : group), [activeMenuGroup]), handleMenuGroupClose = React12.useCallback(() => setActiveMenuGroup(void 0), []), updateActions = React12.useCallback(() => {
        let actionsAndGroups = [...actions, ...groups];
        groups.length > 0 && (actionsAndGroups = [...actionsAndGroups].slice(0, actionsAndGroups.length - 1)), setMeasuredActions((currentMeasuredActions) => {
          let showable = actionsAndGroups.slice(0, currentMeasuredActions.showable.length), rolledUp = actionsAndGroups.slice(currentMeasuredActions.showable.length, actionsAndGroups.length);
          return {
            showable,
            rolledUp
          };
        });
      }, [actions, groups]), measureActions = React12.useCallback(() => {
        if (actionWidthsRef.current.length === 0 || availableWidthRef.current === 0)
          return;
        let actionsAndGroups = [...actions, ...groups];
        if (actionsAndGroups.length === 1) {
          setMeasuredActions({
            showable: actionsAndGroups,
            rolledUp: []
          });
          return;
        }
        let currentAvailableWidth = availableWidthRef.current, newShowableActions = [], newRolledUpActions = [];
        if (actionsAndGroups.forEach((action, index) => {
          if (actionWidthsRef.current[index] + menuGroupWidthRef.current + ACTION_SPACING + lastMenuGroupWidth <= currentAvailableWidth)
            currentAvailableWidth -= actionWidthsRef.current[index] + ACTION_SPACING * 2, newShowableActions = [...newShowableActions, action];
          else {
            if (currentAvailableWidth = 0, action === lastMenuGroup)
              return;
            newRolledUpActions = [...newRolledUpActions, action];
          }
        }), onActionRollup) {
          let isRollupActive = newShowableActions.length < actionsAndGroups.length - 1;
          rollupActiveRef.current !== isRollupActive && (onActionRollup(isRollupActive), rollupActiveRef.current = isRollupActive);
        }
        setMeasuredActions({
          showable: newShowableActions,
          rolledUp: newRolledUpActions
        }), timesMeasured.current += 1, actionsAndGroupsLengthRef.current = actionsAndGroups.length;
      }, [actions, groups, lastMenuGroup, lastMenuGroupWidth, onActionRollup]), handleResize = React12.useMemo(() => debounce.debounce(() => {
        actionsLayoutRef.current && (availableWidthRef.current = actionsLayoutRef.current.offsetWidth, timesMeasured.current = 0, measureActions());
      }, 50, {
        leading: !1,
        trailing: !0
      }), [measureActions]);
      useEventListener.useEventListener("resize", handleResize), useIsomorphicLayoutEffect.useIsomorphicLayoutEffect(() => {
        if (actionsLayoutRef.current) {
          if (availableWidthRef.current = actionsLayoutRef.current.offsetWidth, // Allow measuring twice
          // This accounts for the initial paint and re-flow
          timesMeasured.current >= 2 && [...actions, ...groups].length === actionsAndGroupsLengthRef.current) {
            updateActions();
            return;
          }
          measureActions();
        }
      }, [actions, groups, measureActions, updateActions]);
      let actionsMarkup = actions.map((action) => {
        if (measuredActions.showable.length > 0 || measuredActions.rolledUp.includes(action))
          return null;
        let {
          content,
          onAction,
          ...rest
        } = action;
        return /* @__PURE__ */ React12.createElement(SecondaryAction.SecondaryAction, Object.assign({
          key: content,
          onClick: onAction
        }, rest, {
          getOffsetWidth: handleActionsOffsetWidth
        }), content);
      }), rollUppableActionsMarkup = measuredActions.showable.length > 0 ? measuredActions.showable.map((action) => action.content && /* @__PURE__ */ React12.createElement(SecondaryAction.SecondaryAction, Object.assign({
        key: action.content
      }, action, {
        getOffsetWidth: handleActionsOffsetWidth
      }), action.content)) : null, groupsMarkup = [...groups, defaultRollupGroup].filter((group) => groups.length === 0 ? group : group === lastMenuGroup || !measuredActions.rolledUp.some((rolledUpGroup) => isMenuGroup(rolledUpGroup) && rolledUpGroup.title === group.title)).map((group) => {
        let {
          title,
          actions: groupActions,
          ...rest
        } = group, isDefaultGroup = group === defaultRollupGroup, isLastMenuGroup = group === lastMenuGroup, [finalRolledUpActions, finalRolledUpSectionGroups] = measuredActions.rolledUp.reduce(([actions2, sections], action) => (isMenuGroup(action) ? sections.push({
          title: action.title,
          items: action.actions.map((sectionAction) => ({
            ...sectionAction,
            disabled: action.disabled || sectionAction.disabled
          }))
        }) : actions2.push(action), [actions2, sections]), [[], []]);
        if (!isDefaultGroup && !isLastMenuGroup)
          return /* @__PURE__ */ React12.createElement(MenuGroup.MenuGroup, Object.assign({
            key: title,
            title,
            active: title === activeMenuGroup,
            actions: groupActions
          }, rest, {
            onOpen: handleMenuGroupToggle,
            onClose: handleMenuGroupClose,
            getOffsetWidth: handleActionsOffsetWidth
          }));
        if (!isDefaultGroup && isLastMenuGroup)
          return /* @__PURE__ */ React12.createElement(MenuGroup.MenuGroup, Object.assign({
            key: title,
            title,
            active: title === activeMenuGroup,
            actions: [...finalRolledUpActions, ...groupActions],
            sections: finalRolledUpSectionGroups
          }, rest, {
            onOpen: handleMenuGroupToggle,
            onClose: handleMenuGroupClose,
            getOffsetWidth: handleActionsOffsetWidth
          }));
        if (isDefaultGroup && groups.length === 0 && finalRolledUpActions.length)
          return /* @__PURE__ */ React12.createElement(MenuGroup.MenuGroup, Object.assign({
            key: title,
            title,
            active: title === activeMenuGroup,
            actions: finalRolledUpActions,
            sections: finalRolledUpSectionGroups
          }, rest, {
            onOpen: handleMenuGroupToggle,
            onClose: handleMenuGroupClose,
            getOffsetWidth: handleActionsOffsetWidth
          }));
      }), groupedActionsMarkup = /* @__PURE__ */ React12.createElement(ButtonGroup.ButtonGroup, {
        gap: "tight"
      }, rollUppableActionsMarkup, actionsMarkup, groupsMarkup);
      return /* @__PURE__ */ React12.createElement("div", {
        className: Actions_module.default.ActionsLayout,
        ref: actionsLayoutRef
      }, groupedActionsMarkup);
    }
    function isMenuGroup(actionOrMenuGroup) {
      return "title" in actionOrMenuGroup;
    }
    exports.Actions = Actions;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/ActionMenu.js
var require_ActionMenu = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ActionMenu/ActionMenu.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), ActionMenu_module = require_ActionMenu_scss(), RollupActions = require_RollupActions(), Actions = require_Actions();
    function ActionMenu({
      actions = [],
      groups = [],
      rollup,
      rollupActionsLabel,
      onActionRollup
    }) {
      if (actions.length === 0 && groups.length === 0)
        return null;
      let actionMenuClassNames = css.classNames(ActionMenu_module.default.ActionMenu, rollup && ActionMenu_module.default.rollup), rollupSections = groups.map((group) => convertGroupToSection(group));
      return /* @__PURE__ */ React12.createElement("div", {
        className: actionMenuClassNames
      }, rollup ? /* @__PURE__ */ React12.createElement(RollupActions.RollupActions, {
        accessibilityLabel: rollupActionsLabel,
        items: actions,
        sections: rollupSections
      }) : /* @__PURE__ */ React12.createElement(Actions.Actions, {
        actions,
        groups,
        onActionRollup
      }));
    }
    function hasGroupsWithActions(groups = []) {
      return groups.length === 0 ? !1 : groups.some((group) => group.actions.length > 0);
    }
    function convertGroupToSection({
      title,
      actions,
      disabled
    }) {
      return {
        title,
        items: actions.map((action) => ({
          ...action,
          disabled: disabled || action.disabled
        }))
      };
    }
    exports.ActionMenu = ActionMenu;
    exports.hasGroupsWithActions = hasGroupsWithActions;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/options.js
var require_options2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/options.js"(exports) {
    "use strict";
    init_cjs_shims();
    function isSection(arr) {
      return typeof arr[0] == "object" && Object.prototype.hasOwnProperty.call(arr[0], "options");
    }
    exports.isSection = isSection;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Autocomplete/Autocomplete.scss.js
var require_Autocomplete_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Autocomplete/Autocomplete.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Loading: "Polaris-Autocomplete__Loading",
      SectionWrapper: "Polaris-Autocomplete__SectionWrapper"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Autocomplete/components/MappedOption/MappedOption.scss.js
var require_MappedOption_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Autocomplete/components/MappedOption/MappedOption.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Content: "Polaris-Autocomplete-MappedOption__Content",
      Media: "Polaris-Autocomplete-MappedOption__Media",
      singleSelectionMedia: "Polaris-Autocomplete-MappedOption--singleSelectionMedia",
      disabledMedia: "Polaris-Autocomplete-MappedOption--disabledMedia"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/Listbox.scss.js
var require_Listbox_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/Listbox.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Listbox: "Polaris-Listbox"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/combobox/context.js
var require_context11 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/combobox/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), ComboboxTextFieldContext = /* @__PURE__ */ React12.createContext(void 0), ComboboxListboxContext = /* @__PURE__ */ React12.createContext({}), ComboboxListboxOptionContext = /* @__PURE__ */ React12.createContext({});
    exports.ComboboxListboxContext = ComboboxListboxContext;
    exports.ComboboxListboxOptionContext = ComboboxListboxOptionContext;
    exports.ComboboxTextFieldContext = ComboboxTextFieldContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/combobox/hooks.js
var require_hooks5 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/combobox/hooks.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), context = require_context11();
    function useComboboxTextField() {
      let context$1 = React12.useContext(context.ComboboxTextFieldContext);
      if (!context$1)
        throw new Error("No Combobox was provided. Your component must be wrapped in a <Combobox> component.");
      return context$1;
    }
    function useComboboxListbox() {
      return React12.useContext(context.ComboboxListboxContext);
    }
    exports.useComboboxListbox = useComboboxListbox;
    exports.useComboboxTextField = useComboboxTextField;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/listbox/utilities.js
var require_utilities = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/listbox/utilities.js"(exports) {
    "use strict";
    init_cjs_shims();
    function scrollOptionIntoView(option, scrollable) {
      let listTop = scrollable.scrollTop, listBottom = listTop + scrollable.clientHeight, {
        offsetHeight: optionHeight
      } = option, {
        offsetTop: optionTop
      } = option, optionBottom = optionTop + optionHeight;
      if (!(optionTop > listTop && optionBottom < listBottom)) {
        let top = 0;
        optionBottom > listBottom ? top = optionBottom + optionHeight * 0.85 - listBottom : optionTop < listTop && (top = optionTop - optionHeight * 0.15 - listTop), requestAnimationFrame(() => {
          scrollable.scrollBy({
            top,
            behavior: "auto"
          });
        });
      }
    }
    exports.scrollOptionIntoView = scrollOptionIntoView;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/listbox/context.js
var require_context12 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/listbox/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), ListboxContext = /* @__PURE__ */ React12.createContext(void 0), WithinListboxContext = /* @__PURE__ */ React12.createContext(!1), ActionContext = /* @__PURE__ */ React12.createContext(!1);
    exports.ActionContext = ActionContext;
    exports.ListboxContext = ListboxContext;
    exports.WithinListboxContext = WithinListboxContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/TextOption/TextOption.scss.js
var require_TextOption_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/TextOption/TextOption.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      TextOption: "Polaris-Listbox-TextOption",
      allowMultiple: "Polaris-Listbox-TextOption--allowMultiple",
      isAction: "Polaris-Listbox-TextOption--isAction",
      disabled: "Polaris-Listbox-TextOption--disabled",
      selected: "Polaris-Listbox-TextOption--selected",
      Content: "Polaris-Listbox-TextOption__Content",
      Checkbox: "Polaris-Listbox-TextOption__Checkbox"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Checkbox/Checkbox.scss.js
var require_Checkbox_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Checkbox/Checkbox.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Checkbox: "Polaris-Checkbox",
      ChoiceLabel: "Polaris-Checkbox__ChoiceLabel",
      Backdrop: "Polaris-Checkbox__Backdrop",
      Input: "Polaris-Checkbox__Input",
      "Input-indeterminate": "Polaris-Checkbox__Input--indeterminate",
      Icon: "Polaris-Checkbox__Icon",
      animated: "Polaris-Checkbox--animated",
      toneMagic: "Polaris-Checkbox--toneMagic",
      hover: "Polaris-Checkbox--hover",
      error: "Polaris-Checkbox--error",
      checked: "Polaris-Checkbox--checked",
      pathAnimation: "Polaris-Checkbox--pathAnimation"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Choice/Choice.scss.js
var require_Choice_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Choice/Choice.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Choice: "Polaris-Choice",
      labelHidden: "Polaris-Choice--labelHidden",
      Label: "Polaris-Choice__Label",
      Control: "Polaris-Choice__Control",
      disabled: "Polaris-Choice--disabled",
      toneMagic: "Polaris-Choice--toneMagic",
      Descriptions: "Polaris-Choice__Descriptions",
      HelpText: "Polaris-Choice__HelpText"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Choice/Choice.js
var require_Choice = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Choice/Choice.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Choice_module = require_Choice_scss(), Text4 = require_Text(), InlineError = require_InlineError();
    function Choice({
      id,
      label,
      disabled,
      error,
      children,
      labelHidden,
      helpText,
      onClick,
      labelClassName,
      fill,
      bleed,
      bleedBlockStart,
      bleedBlockEnd,
      bleedInlineStart,
      bleedInlineEnd,
      tone
    }) {
      let className = css.classNames(Choice_module.default.Choice, labelHidden && Choice_module.default.labelHidden, disabled && Choice_module.default.disabled, tone && Choice_module.default[css.variationName("tone", tone)], labelClassName), labelStyle = {
        // Pass through overrides for bleed values if they're set by the prop
        ...css.getResponsiveProps("choice", "bleed-block-end", "space", bleedBlockEnd || bleed),
        ...css.getResponsiveProps("choice", "bleed-block-start", "space", bleedBlockStart || bleed),
        ...css.getResponsiveProps("choice", "bleed-inline-start", "space", bleedInlineStart || bleed),
        ...css.getResponsiveProps("choice", "bleed-inline-end", "space", bleedInlineEnd || bleed),
        ...Object.fromEntries(Object.entries(css.getResponsiveValue("choice", "fill", fill)).map(
          // Map "true" => "100%" and "false" => "auto" for use in
          // inline/block-size calc()
          ([key, value]) => [key, value ? "100%" : "auto"]
        ))
      }, labelMarkup = (
        // NOTE: Can't use a Box here for a few reasons:
        // - as="label" fails `Element` typecheck (even though the JS works)
        // - Can't pass hard coded values to padding (forced to tokens)
        // - Can't pass negative values to padding
        // - Can't pass margins at all
        /* @__PURE__ */ React12.createElement("label", {
          className,
          htmlFor: id,
          onClick,
          style: css.sanitizeCustomProperties(labelStyle)
        }, /* @__PURE__ */ React12.createElement("span", {
          className: Choice_module.default.Control
        }, children), /* @__PURE__ */ React12.createElement("span", {
          className: Choice_module.default.Label
        }, /* @__PURE__ */ React12.createElement("span", null, label)))
      ), helpTextMarkup = helpText ? /* @__PURE__ */ React12.createElement("div", {
        className: Choice_module.default.HelpText,
        id: helpTextID(id)
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        tone: disabled ? void 0 : "subdued"
      }, helpText)) : null, errorMarkup = error && typeof error != "boolean" && /* @__PURE__ */ React12.createElement("div", {
        className: Choice_module.default.Error
      }, /* @__PURE__ */ React12.createElement(InlineError.InlineError, {
        message: error,
        fieldID: id
      })), descriptionMarkup = helpTextMarkup || errorMarkup ? /* @__PURE__ */ React12.createElement("div", {
        className: Choice_module.default.Descriptions
      }, errorMarkup, helpTextMarkup) : null;
      return descriptionMarkup ? /* @__PURE__ */ React12.createElement("div", null, labelMarkup, descriptionMarkup) : labelMarkup;
    }
    function helpTextID(id) {
      return `${id}HelpText`;
    }
    exports.Choice = Choice;
    exports.helpTextID = helpTextID;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Checkbox/Checkbox.js
var require_Checkbox = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Checkbox/Checkbox.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), context = require_context12(), Checkbox_module = require_Checkbox_scss(), Choice = require_Choice(), InlineError = require_InlineError(), Icon = require_Icon(), Checkbox = /* @__PURE__ */ React12.forwardRef(function({
      ariaControls,
      ariaDescribedBy: ariaDescribedByProp,
      label,
      labelHidden,
      checked = !1,
      helpText,
      disabled,
      id: idProp,
      name,
      value,
      error,
      onChange,
      onFocus,
      onBlur,
      labelClassName,
      fill,
      bleed,
      bleedBlockStart,
      bleedBlockEnd,
      bleedInlineStart,
      bleedInlineEnd,
      tone
    }, ref) {
      let inputNode = React12.useRef(null), uniqId = React12.useId(), id = idProp ?? uniqId, isWithinListbox = React12.useContext(context.WithinListboxContext);
      React12.useImperativeHandle(ref, () => ({
        focus: () => {
          inputNode.current && inputNode.current.focus();
        }
      }));
      let handleBlur = () => {
        onBlur && onBlur();
      }, handleOnClick = () => {
        onChange == null || inputNode.current == null || disabled || (onChange(inputNode.current.checked, id), inputNode.current.focus());
      }, describedBy = [];
      error && typeof error != "boolean" && describedBy.push(InlineError.errorTextID(id)), helpText && describedBy.push(Choice.helpTextID(id)), ariaDescribedByProp && describedBy.push(ariaDescribedByProp);
      let ariaDescribedBy = describedBy.length ? describedBy.join(" ") : void 0, wrapperClassName = css.classNames(Checkbox_module.default.Checkbox, error && Checkbox_module.default.error), isIndeterminate = checked === "indeterminate", isChecked = !isIndeterminate && !!checked, indeterminateAttributes = isIndeterminate ? {
        indeterminate: "true",
        "aria-checked": "mixed"
      } : {
        "aria-checked": isChecked
      }, iconSource = /* @__PURE__ */ React12.createElement("svg", {
        viewBox: "0 0 16 16",
        shapeRendering: "geometricPrecision",
        textRendering: "geometricPrecision"
      }, /* @__PURE__ */ React12.createElement("path", {
        className: css.classNames(checked && Checkbox_module.default.checked),
        d: "M1.5,5.5L3.44655,8.22517C3.72862,8.62007,4.30578,8.64717,4.62362,8.28044L10.5,1.5",
        transform: "translate(2 2.980376)",
        opacity: "0",
        fill: "none",
        stroke: "currentColor",
        strokeWidth: "2",
        strokeLinecap: "round",
        strokeLinejoin: "round",
        pathLength: "1"
      })), inputClassName = css.classNames(Checkbox_module.default.Input, isIndeterminate && Checkbox_module.default["Input-indeterminate"], tone && Checkbox_module.default[css.variationName("tone", tone)]), extraChoiceProps = {
        helpText,
        error,
        bleed,
        bleedBlockStart,
        bleedBlockEnd,
        bleedInlineStart,
        bleedInlineEnd
      };
      return /* @__PURE__ */ React12.createElement(Choice.Choice, Object.assign({
        id,
        label,
        labelHidden,
        disabled,
        labelClassName: css.classNames(Checkbox_module.default.ChoiceLabel, labelClassName),
        fill,
        tone
      }, extraChoiceProps), /* @__PURE__ */ React12.createElement("span", {
        className: wrapperClassName
      }, /* @__PURE__ */ React12.createElement("input", Object.assign({
        ref: inputNode,
        id,
        name,
        value,
        type: "checkbox",
        checked: isChecked,
        disabled,
        className: inputClassName,
        onBlur: handleBlur,
        onChange: noop,
        onClick: handleOnClick,
        onFocus,
        "aria-invalid": error != null,
        "aria-controls": ariaControls,
        "aria-describedby": ariaDescribedBy,
        role: isWithinListbox ? "presentation" : "checkbox"
      }, indeterminateAttributes)), /* @__PURE__ */ React12.createElement("span", {
        className: Checkbox_module.default.Backdrop,
        onClick: stopPropagation,
        onKeyUp: stopPropagation
      }), /* @__PURE__ */ React12.createElement("span", {
        className: css.classNames(Checkbox_module.default.Icon, !isIndeterminate && Checkbox_module.default.animated)
      }, isIndeterminate ? /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.MinusIcon
      }) : iconSource)));
    });
    function noop() {
    }
    function stopPropagation(event) {
      event.stopPropagation();
    }
    exports.Checkbox = Checkbox;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/TextOption/TextOption.js
var require_TextOption = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/TextOption/TextOption.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), context = require_context11(), context$1 = require_context12(), TextOption_module = require_TextOption_scss(), Checkbox = require_Checkbox(), Box2 = require_Box(), InlineStack2 = require_InlineStack(), Icon = require_Icon(), TextOption = /* @__PURE__ */ React12.memo(function({
      children,
      selected,
      disabled
    }) {
      let {
        allowMultiple
      } = React12.useContext(context.ComboboxListboxOptionContext), isAction = React12.useContext(context$1.ActionContext), textOptionClassName = css.classNames(TextOption_module.default.TextOption, selected && !allowMultiple && TextOption_module.default.selected, disabled && TextOption_module.default.disabled, allowMultiple && TextOption_module.default.allowMultiple, isAction && TextOption_module.default.isAction), optionMarkup = selected ? /* @__PURE__ */ React12.createElement(Box2.Box, {
        width: "100%"
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        wrap: !1,
        align: "space-between",
        gap: "200"
      }, children, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        align: "end"
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.CheckIcon
      })))) : /* @__PURE__ */ React12.createElement(React12.Fragment, null, children);
      return /* @__PURE__ */ React12.createElement("div", {
        className: textOptionClassName
      }, /* @__PURE__ */ React12.createElement("div", {
        className: TextOption_module.default.Content
      }, allowMultiple && !isAction ? /* @__PURE__ */ React12.createElement("div", {
        className: TextOption_module.default.Checkbox
      }, /* @__PURE__ */ React12.createElement(Checkbox.Checkbox, {
        disabled,
        checked: selected,
        label: children
      })) : optionMarkup));
    });
    exports.TextOption = TextOption;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Loading/Loading.scss.js
var require_Loading_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Loading/Loading.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      ListItem: "Polaris-Listbox-Loading__ListItem",
      Loading: "Polaris-Listbox-Loading"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/listbox/hooks.js
var require_hooks6 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/listbox/hooks.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), context = require_context12();
    function useListbox() {
      let listbox = React12.useContext(context.ListboxContext);
      if (!listbox)
        throw new Error("No Listbox was provided. Listbox components must be wrapped in a Listbox");
      return listbox;
    }
    exports.useListbox = useListbox;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Loading/Loading.js
var require_Loading = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Loading/Loading.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), Loading_module = require_Loading_scss(), hooks2 = require_hooks6(), Spinner = require_Spinner(), Loading = /* @__PURE__ */ React12.memo(function({
      children,
      accessibilityLabel: label
    }) {
      let {
        setLoading
      } = hooks2.useListbox();
      return React12.useEffect(() => (setLoading(label), () => {
        setLoading(void 0);
      }), [label, setLoading]), /* @__PURE__ */ React12.createElement("li", {
        className: Loading_module.default.ListItem,
        role: "presentation"
      }, children || /* @__PURE__ */ React12.createElement("div", {
        className: Loading_module.default.Loading
      }, /* @__PURE__ */ React12.createElement(Spinner.Spinner, {
        size: "small",
        accessibilityLabel: label
      })));
    });
    exports.Loading = Loading;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Section/selectors.js
var require_selectors = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Section/selectors.js"(exports) {
    "use strict";
    init_cjs_shims();
    var listboxSectionDataSelector = {
      props: {
        "data-polaris-listbox-section-item": !0
      },
      selector: "[data-polaris-listbox-section-item]"
    }, listboxWithinSectionDataSelector = {
      attribute: "data-polaris-listbox-within-section-item"
    };
    exports.listboxSectionDataSelector = listboxSectionDataSelector;
    exports.listboxWithinSectionDataSelector = listboxWithinSectionDataSelector;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Section/context.js
var require_context13 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Section/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), SectionContext = /* @__PURE__ */ React12.createContext(null);
    exports.SectionContext = SectionContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Section/Section.scss.js
var require_Section_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Section/Section.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      SectionGroup: "Polaris-Listbox-Section__SectionGroup",
      noDivider: "Polaris-Listbox-Section--noDivider"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Section/Section.js
var require_Section3 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Section/Section.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), selectors = require_selectors(), context = require_context13(), Section_module = require_Section_scss();
    function Section({
      children,
      divider = !0,
      title
    }) {
      let id = React12.useId();
      return /* @__PURE__ */ React12.createElement(context.SectionContext.Provider, {
        value: id
      }, /* @__PURE__ */ React12.createElement("li", Object.assign({
        role: "presentation"
      }, selectors.listboxSectionDataSelector.props), title, /* @__PURE__ */ React12.createElement("ul", {
        role: "group",
        "aria-labelledby": id,
        className: css.classNames(Section_module.default.SectionGroup, !divider && Section_module.default.noDivider)
      }, children)));
    }
    exports.Section = Section;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Section/hooks.js
var require_hooks7 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Section/hooks.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), context = require_context13();
    function useSection() {
      return React12.useContext(context.SectionContext);
    }
    exports.useSection = useSection;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Header/Header.js
var require_Header = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Header/Header.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), hooks2 = require_hooks7(), Box2 = require_Box(), Text4 = require_Text();
    function Header3({
      children
    }) {
      let sectionId = hooks2.useSection() || "", content = typeof children == "string" ? /* @__PURE__ */ React12.createElement(Box2.Box, {
        paddingBlockStart: "200",
        paddingInlineStart: "400",
        paddingBlockEnd: "200",
        paddingInlineEnd: "400"
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        variant: "headingSm",
        tone: "subdued"
      }, children)) : children;
      return /* @__PURE__ */ React12.createElement("div", {
        "aria-hidden": !0,
        id: sectionId
      }, content);
    }
    exports.Header = Header3;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Action/Action.scss.js
var require_Action_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Action/Action.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Action: "Polaris-Listbox-Action",
      ActionDivider: "Polaris-Listbox-Action__ActionDivider",
      Icon: "Polaris-Listbox-Action__Icon"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Option/Option.scss.js
var require_Option_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Option/Option.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Option: "Polaris-Listbox-Option",
      divider: "Polaris-Listbox-Option--divider"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/autocomplete/context.js
var require_context14 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/autocomplete/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), MappedActionContext = /* @__PURE__ */ React12.createContext({});
    exports.MappedActionContext = MappedActionContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Option/Option.js
var require_Option = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Option/Option.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), context = require_context12(), Option_module = require_Option_scss(), hooks2 = require_hooks6(), context$1 = require_context14(), hooks$1 = require_hooks7(), selectors = require_selectors(), TextOption = require_TextOption(), UnstyledLink = require_UnstyledLink(), Option = /* @__PURE__ */ React12.memo(function({
      value,
      children,
      selected,
      disabled = !1,
      accessibilityLabel,
      divider
    }) {
      let {
        onOptionSelect
      } = hooks2.useListbox(), isAction = React12.useContext(context.ActionContext), {
        role,
        url,
        external,
        onAction,
        destructive
      } = React12.useContext(context$1.MappedActionContext), listItemRef = React12.useRef(null), domId = React12.useId(), isWithinSection = !!hooks$1.useSection(), handleOptionSelect = React12.useCallback((event) => {
        event.preventDefault(), event.stopPropagation(), onAction && onAction(), listItemRef.current && !onAction && onOptionSelect({
          domId,
          value,
          element: listItemRef.current,
          disabled
        });
      }, [domId, onOptionSelect, value, disabled, onAction]), handleMouseDown = (event) => {
        event.preventDefault();
      }, content = typeof children == "string" ? /* @__PURE__ */ React12.createElement(TextOption.TextOption, {
        selected,
        disabled
      }, children) : children, sectionAttributes = {
        [selectors.listboxWithinSectionDataSelector.attribute]: isWithinSection
      }, legacyRoleSupport = role || "option", contentMarkup = url ? /* @__PURE__ */ React12.createElement(UnstyledLink.UnstyledLink, {
        url,
        external
      }, content) : content;
      return /* @__PURE__ */ React12.createElement("li", Object.assign({}, sectionAttributes, {
        "data-listbox-option": !0,
        "data-listbox-option-action": isAction,
        "data-listbox-option-value": value,
        "data-listbox-option-destructive": destructive,
        "data-within-section": isWithinSection,
        className: css.classNames(Option_module.default.Option, divider && Option_module.default.divider),
        id: domId,
        ref: listItemRef,
        tabIndex: -1,
        role: legacyRoleSupport,
        "aria-label": accessibilityLabel,
        "aria-selected": selected,
        "aria-disabled": disabled,
        onClick: disabled ? void 0 : handleOptionSelect,
        onKeyDown: disabled ? void 0 : handleOptionSelect,
        onMouseDown: handleMouseDown
      }), contentMarkup);
    });
    exports.Option = Option;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Action/Action.js
var require_Action = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/components/Action/Action.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), context = require_context12(), Action_module = require_Action_scss(), Option = require_Option(), TextOption = require_TextOption(), Icon = require_Icon();
    function Action(props) {
      let {
        selected,
        disabled,
        children,
        icon,
        divider
      } = props, iconMarkup = icon && /* @__PURE__ */ React12.createElement("div", {
        className: Action_module.default.Icon
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        tone: "subdued",
        source: icon
      })), className = css.classNames(Action_module.default.Action, divider && Action_module.default.ActionDivider);
      return /* @__PURE__ */ React12.createElement(context.ActionContext.Provider, {
        value: !0
      }, /* @__PURE__ */ React12.createElement(Option.Option, props, /* @__PURE__ */ React12.createElement("div", {
        className
      }, /* @__PURE__ */ React12.createElement(TextOption.TextOption, {
        selected,
        disabled
      }, iconMarkup, children))));
    }
    exports.Action = Action;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/Listbox.js
var require_Listbox = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Listbox/Listbox.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), debounce = require_debounce2(), useToggle = require_use_toggle(), types = require_types7(), shared = require_shared(), Listbox_module = require_Listbox_scss(), hooks2 = require_hooks5(), utilities = require_utilities(), context = require_context12(), TextOption = require_TextOption(), Loading = require_Loading(), Section = require_Section3(), Header3 = require_Header(), Action = require_Action(), KeypressListener = require_KeypressListener(), Text4 = require_Text(), Option = require_Option();
    exports.AutoSelection = void 0;
    (function(AutoSelection) {
      AutoSelection.FirstSelected = "FIRST_SELECTED", AutoSelection.First = "FIRST", AutoSelection.None = "NONE";
    })(exports.AutoSelection || (exports.AutoSelection = {}));
    var OPTION_SELECTOR = "[data-listbox-option]", OPTION_VALUE_ATTRIBUTE = "data-listbox-option-value", OPTION_ACTION_ATTRIBUTE = "data-listbox-option-action", OPTION_FOCUS_ATTRIBUTE = "data-focused";
    function Listbox({
      children,
      autoSelection = exports.AutoSelection.FirstSelected,
      enableKeyboardControl,
      accessibilityLabel,
      customListId,
      onSelect,
      onActiveOptionChange
    }) {
      let [loading, setLoading] = React12.useState(), [activeOption, setActiveOption] = React12.useState(), [lazyLoading, setLazyLoading] = React12.useState(!1), [currentOptions, setCurrentOptions] = React12.useState([]), {
        value: keyboardEventsEnabled,
        setTrue: enableKeyboardEvents,
        setFalse: disableKeyboardEvents
      } = useToggle.useToggle(!!enableKeyboardControl), uniqueId = React12.useId(), listId = customListId || uniqueId, scrollableRef = React12.useRef(null), listboxRef = React12.useRef(null), {
        listboxId,
        textFieldLabelId,
        textFieldFocused,
        willLoadMoreOptions,
        setActiveOptionId,
        setListboxId,
        onOptionSelected,
        onKeyToBottom
      } = hooks2.useComboboxListbox(), inCombobox = !!setActiveOptionId;
      React12.useEffect(() => {
        setListboxId && !listboxId && setListboxId(listId);
      }, [setListboxId, listboxId, listId]);
      let getNavigableOptions = React12.useCallback(() => listboxRef.current ? [...new Set(listboxRef.current.querySelectorAll(OPTION_SELECTOR))] : [], []), getFirstNavigableOption = React12.useCallback((currentOptions2) => {
        let hasSelectedOptions = currentOptions2.some((option) => option.getAttribute("aria-selected") === "true"), elementIndex = 0, element = currentOptions2.find((option, index) => {
          let isInteractable = option.getAttribute("aria-disabled") !== "true", isFirstNavigableOption;
          return hasSelectedOptions && autoSelection === exports.AutoSelection.FirstSelected ? isFirstNavigableOption = option.getAttribute("aria-selected") === "true" && isInteractable : isFirstNavigableOption = isInteractable, isFirstNavigableOption && (elementIndex = index), isFirstNavigableOption;
        });
        if (element)
          return {
            element,
            index: elementIndex
          };
      }, [autoSelection]), handleScrollIntoView = React12.useCallback((option) => {
        let {
          current: scrollable
        } = scrollableRef;
        scrollable && utilities.scrollOptionIntoView(option.element, scrollable);
      }, []), handleScrollIntoViewDebounced = debounce.debounce(handleScrollIntoView, 50), handleKeyToBottom = React12.useCallback(() => {
        if (onKeyToBottom)
          return setLazyLoading(!0), Promise.resolve(onKeyToBottom());
      }, [onKeyToBottom]), handleChangeActiveOption = React12.useCallback((nextOption) => {
        if (!nextOption)
          return setActiveOption(void 0);
        activeOption?.element.removeAttribute(OPTION_FOCUS_ATTRIBUTE), nextOption.element.setAttribute(OPTION_FOCUS_ATTRIBUTE, "true"), handleScrollIntoViewDebounced(nextOption), setActiveOption(nextOption), setActiveOptionId?.(nextOption.domId), onActiveOptionChange?.(nextOption.value, nextOption.domId);
      }, [activeOption, setActiveOptionId, onActiveOptionChange, handleScrollIntoViewDebounced]), getFormattedOption = React12.useCallback((element, index) => ({
        element,
        index,
        domId: element.id,
        value: element.getAttribute(OPTION_VALUE_ATTRIBUTE) || "",
        disabled: element.getAttribute("aria-disabled") === "true",
        isAction: element.getAttribute(OPTION_ACTION_ATTRIBUTE) === "true"
      }), []), resetActiveOption = React12.useCallback(() => {
        let nextOption, nextOptions = getNavigableOptions(), nextActiveOption = getFirstNavigableOption(nextOptions);
        if (nextOptions.length === 0 && currentOptions.length > 0) {
          setCurrentOptions(nextOptions), handleChangeActiveOption();
          return;
        }
        if (nextActiveOption) {
          let {
            element,
            index
          } = nextActiveOption;
          nextOption = getFormattedOption(element, index);
        }
        let optionIsAlreadyActive = activeOption !== void 0 && nextOption?.domId === activeOption?.domId, actionContentHasUpdated = activeOption?.isAction && nextOption?.isAction && nextOption?.value !== activeOption?.value, currentValues = currentOptions.map((option) => option.getAttribute(OPTION_VALUE_ATTRIBUTE)), nextValues = nextOptions.map((option) => option.getAttribute(OPTION_VALUE_ATTRIBUTE)), listIsUnchanged = nextValues.length === currentValues.length && nextValues.every((value, index) => currentValues[index] === value), listIsAppended = currentValues.length !== 0 && nextValues.length > currentValues.length && currentValues.every((value, index) => nextValues[index] === value);
        if (listIsUnchanged) {
          optionIsAlreadyActive && actionContentHasUpdated && (setCurrentOptions(nextOptions), handleChangeActiveOption(nextOption));
          return;
        }
        if (listIsAppended) {
          setCurrentOptions(nextOptions);
          return;
        }
        if (setCurrentOptions(nextOptions), lazyLoading) {
          setLazyLoading(!1);
          return;
        }
        handleChangeActiveOption(nextOption);
      }, [lazyLoading, currentOptions, activeOption, getFirstNavigableOption, getNavigableOptions, getFormattedOption, handleChangeActiveOption]);
      React12.useEffect(() => {
        autoSelection !== exports.AutoSelection.None && !loading && children && React12.Children.count(children) > 0 && resetActiveOption();
      }, [children, autoSelection, activeOption, loading, resetActiveOption]), React12.useEffect(() => {
        listboxRef.current && (scrollableRef.current = listboxRef.current.closest(shared.scrollable.selector));
      }, []), React12.useEffect(() => {
        enableKeyboardControl && !keyboardEventsEnabled && enableKeyboardEvents();
      }, [enableKeyboardControl, keyboardEventsEnabled, enableKeyboardEvents]);
      let onOptionSelect = React12.useCallback((option) => {
        handleChangeActiveOption(option), onOptionSelected && onOptionSelected(), onSelect && onSelect(option.value);
      }, [handleChangeActiveOption, onSelect, onOptionSelected]), getNextIndex = React12.useCallback((currentIndex, lastIndex, direction) => {
        let nextIndex;
        return direction === "down" ? currentIndex === lastIndex ? nextIndex = willLoadMoreOptions ? currentIndex + 1 : 0 : nextIndex = currentIndex + 1 : nextIndex = currentIndex === 0 ? lastIndex : currentIndex - 1, nextIndex;
      }, [willLoadMoreOptions]), getNextValidOption = React12.useCallback(async (key) => {
        let lastIndex = currentOptions.length - 1, currentIndex = activeOption?.index || 0, nextIndex = 0, element = activeOption?.element, totalOptions = -1;
        if (!activeOption && autoSelection === exports.AutoSelection.None) {
          let nextOptions = getNavigableOptions(), nextActiveOption = getFirstNavigableOption(nextOptions);
          return setCurrentOptions(nextOptions), {
            element: nextActiveOption?.element,
            nextIndex: nextActiveOption?.index || 0
          };
        }
        for (; totalOptions++ < lastIndex; ) {
          nextIndex = getNextIndex(currentIndex, lastIndex, key), element = currentOptions[nextIndex];
          let triggerLazyLoad = nextIndex >= lastIndex, isDisabled = element?.getAttribute("aria-disabled") === "true";
          if (triggerLazyLoad && willLoadMoreOptions && await handleKeyToBottom(), isDisabled) {
            currentIndex = nextIndex, element = void 0;
            continue;
          }
          break;
        }
        return {
          element,
          nextIndex
        };
      }, [autoSelection, currentOptions, activeOption, willLoadMoreOptions, getNextIndex, handleKeyToBottom, getFirstNavigableOption, getNavigableOptions]), handleArrow = React12.useCallback(async (type, event) => {
        event.preventDefault();
        let {
          element,
          nextIndex
        } = await getNextValidOption(type);
        if (!element)
          return;
        let nextOption = getFormattedOption(element, nextIndex);
        handleChangeActiveOption(nextOption);
      }, [getFormattedOption, getNextValidOption, handleChangeActiveOption]), handleDownArrow = React12.useCallback((event) => {
        handleArrow("down", event);
      }, [handleArrow]), handleUpArrow = React12.useCallback((event) => {
        handleArrow("up", event);
      }, [handleArrow]), handleEnter = React12.useCallback((event) => {
        event.preventDefault(), event.stopPropagation(), activeOption && onOptionSelect(activeOption);
      }, [activeOption, onOptionSelect]), handleFocus = React12.useCallback(() => {
        enableKeyboardControl || enableKeyboardEvents();
      }, [enableKeyboardControl, enableKeyboardEvents]), handleBlur = React12.useCallback((event) => {
        if (event.stopPropagation(), keyboardEventsEnabled) {
          let nextActiveOption = getFirstNavigableOption(currentOptions);
          if (nextActiveOption) {
            let {
              element,
              index
            } = nextActiveOption, nextOption = getFormattedOption(element, index);
            handleChangeActiveOption(nextOption);
          }
        }
        enableKeyboardControl || disableKeyboardEvents();
      }, [enableKeyboardControl, currentOptions, keyboardEventsEnabled, disableKeyboardEvents, getFirstNavigableOption, getFormattedOption, handleChangeActiveOption]), listeners = keyboardEventsEnabled || textFieldFocused ? /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement(KeypressListener.KeypressListener, {
        keyEvent: "keydown",
        keyCode: types.Key.DownArrow,
        handler: handleDownArrow
      }), /* @__PURE__ */ React12.createElement(KeypressListener.KeypressListener, {
        keyEvent: "keydown",
        keyCode: types.Key.UpArrow,
        handler: handleUpArrow
      }), /* @__PURE__ */ React12.createElement(KeypressListener.KeypressListener, {
        keyEvent: "keydown",
        keyCode: types.Key.Enter,
        handler: handleEnter
      })) : null, listboxContext = React12.useMemo(() => ({
        onOptionSelect,
        setLoading
      }), [onOptionSelect]);
      return /* @__PURE__ */ React12.createElement(React12.Fragment, null, listeners, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        visuallyHidden: !0
      }, /* @__PURE__ */ React12.createElement("div", {
        "aria-live": "polite"
      }, loading || null)), /* @__PURE__ */ React12.createElement(context.ListboxContext.Provider, {
        value: listboxContext
      }, /* @__PURE__ */ React12.createElement(context.WithinListboxContext.Provider, {
        value: !0
      }, children ? /* @__PURE__ */ React12.createElement("ul", {
        tabIndex: 0,
        role: "listbox",
        className: Listbox_module.default.Listbox,
        "aria-label": inCombobox ? void 0 : accessibilityLabel,
        "aria-labelledby": textFieldLabelId,
        "aria-busy": !!loading,
        "aria-activedescendant": activeOption && activeOption.domId,
        id: listId,
        onFocus: inCombobox ? void 0 : handleFocus,
        onBlur: inCombobox ? void 0 : handleBlur,
        ref: listboxRef
      }, children) : null)));
    }
    Listbox.Option = Option.Option;
    Listbox.TextOption = TextOption.TextOption;
    Listbox.Loading = Loading.Loading;
    Listbox.Section = Section.Section;
    Listbox.Header = Header3.Header;
    Listbox.Action = Action.Action;
    exports.Listbox = Listbox;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Autocomplete/components/MappedOption/MappedOption.js
var require_MappedOption = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Autocomplete/components/MappedOption/MappedOption.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), MappedOption_module = require_MappedOption_scss(), Listbox = require_Listbox(), MappedOption = /* @__PURE__ */ React12.memo(function({
      label,
      value,
      disabled,
      media,
      selected,
      singleSelection
    }) {
      let mediaClassNames = css.classNames(MappedOption_module.default.Media, disabled && MappedOption_module.default.disabledMedia, singleSelection && MappedOption_module.default.singleSelectionMedia), mediaMarkup = media ? /* @__PURE__ */ React12.createElement("div", {
        className: mediaClassNames
      }, media) : null, accessibilityLabel = typeof label == "string" ? label : void 0;
      return /* @__PURE__ */ React12.createElement(Listbox.Listbox.Option, {
        accessibilityLabel,
        key: value,
        selected,
        value,
        disabled
      }, /* @__PURE__ */ React12.createElement(Listbox.Listbox.TextOption, {
        selected,
        disabled
      }, /* @__PURE__ */ React12.createElement("div", {
        className: MappedOption_module.default.Content
      }, mediaMarkup, label)));
    });
    exports.MappedOption = MappedOption;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Combobox/Combobox.scss.js
var require_Combobox_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Combobox/Combobox.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Listbox: "Polaris-Combobox__Listbox"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Combobox/components/TextField/TextField.js
var require_TextField2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Combobox/components/TextField/TextField.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), hooks2 = require_hooks5(), Label = require_Label(), TextField$1 = require_TextField();
    function TextField({
      value,
      id: idProp,
      type = "text",
      ariaAutocomplete = "list",
      onFocus,
      onBlur,
      onChange,
      ...rest
    }) {
      let comboboxTextFieldContext = hooks2.useComboboxTextField(), {
        activeOptionId,
        listboxId,
        expanded,
        setTextFieldFocused,
        setTextFieldLabelId,
        onTextFieldFocus,
        onTextFieldChange,
        onTextFieldBlur
      } = comboboxTextFieldContext, uniqueId = React12.useId(), textFieldId = React12.useMemo(() => idProp || uniqueId, [uniqueId, idProp]), labelId = React12.useMemo(() => Label.labelID(idProp || uniqueId), [uniqueId, idProp]);
      React12.useEffect(() => {
        setTextFieldLabelId && setTextFieldLabelId(labelId);
      }, [labelId, setTextFieldLabelId]);
      let handleFocus = React12.useCallback((event) => {
        onFocus && onFocus(event), onTextFieldFocus && onTextFieldFocus(), setTextFieldFocused && setTextFieldFocused(!0);
      }, [onFocus, onTextFieldFocus, setTextFieldFocused]), handleBlur = React12.useCallback((event) => {
        onBlur && onBlur(event), onTextFieldBlur && onTextFieldBlur(), setTextFieldFocused && setTextFieldFocused(!1);
      }, [onBlur, onTextFieldBlur, setTextFieldFocused]), handleChange = React12.useCallback((value2, id) => {
        onChange && onChange(value2, id), onTextFieldChange && onTextFieldChange(value2);
      }, [onChange, onTextFieldChange]);
      return /* @__PURE__ */ React12.createElement(TextField$1.TextField, Object.assign({}, rest, {
        value,
        id: textFieldId,
        type,
        ariaAutocomplete,
        "aria-haspopup": "listbox",
        ariaActiveDescendant: activeOptionId,
        ariaControls: listboxId,
        role: "combobox",
        ariaExpanded: expanded,
        onFocus: handleFocus,
        onBlur: handleBlur,
        onChange: handleChange
      }));
    }
    exports.TextField = TextField;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Combobox/Combobox.js
var require_Combobox = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Combobox/Combobox.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), Combobox_module = require_Combobox_scss(), context = require_context11(), TextField = require_TextField2(), Popover = require_Popover();
    function Combobox({
      activator,
      allowMultiple,
      children,
      preferredPosition = "below",
      willLoadMoreOptions,
      height,
      onScrolledToBottom,
      onClose
    }) {
      let [popoverActive, setPopoverActive] = React12.useState(!1), [activeOptionId, setActiveOptionId] = React12.useState(), [textFieldLabelId, setTextFieldLabelId] = React12.useState(), [listboxId, setListboxId] = React12.useState(), [textFieldFocused, setTextFieldFocused] = React12.useState(!1), shouldOpen = !popoverActive && React12.Children.count(children) > 0, ref = React12.useRef(null), handleClose = React12.useCallback(() => {
        setPopoverActive(!1), onClose?.(), setActiveOptionId(void 0);
      }, [onClose]), handleOpen = React12.useCallback(() => {
        setPopoverActive(!0), setActiveOptionId(void 0);
      }, []), onOptionSelected = React12.useCallback(() => {
        if (!allowMultiple) {
          handleClose(), setActiveOptionId(void 0);
          return;
        }
        ref.current?.forceUpdatePosition();
      }, [allowMultiple, handleClose]), handleFocus = React12.useCallback(() => {
        shouldOpen && handleOpen();
      }, [shouldOpen, handleOpen]), handleChange = React12.useCallback(() => {
        shouldOpen && handleOpen();
      }, [shouldOpen, handleOpen]), handleBlur = React12.useCallback(() => {
        popoverActive && handleClose();
      }, [popoverActive, handleClose]), textFieldContextValue = React12.useMemo(() => ({
        activeOptionId,
        expanded: popoverActive,
        listboxId,
        setTextFieldFocused,
        setTextFieldLabelId,
        onTextFieldFocus: handleFocus,
        onTextFieldChange: handleChange,
        onTextFieldBlur: handleBlur
      }), [activeOptionId, popoverActive, listboxId, setTextFieldFocused, setTextFieldLabelId, handleFocus, handleChange, handleBlur]), listboxOptionContextValue = React12.useMemo(() => ({
        allowMultiple
      }), [allowMultiple]), listboxContextValue = React12.useMemo(() => ({
        listboxId,
        textFieldLabelId,
        textFieldFocused,
        willLoadMoreOptions,
        onOptionSelected,
        setActiveOptionId,
        setListboxId,
        onKeyToBottom: onScrolledToBottom
      }), [listboxId, textFieldLabelId, textFieldFocused, willLoadMoreOptions, onOptionSelected, setActiveOptionId, setListboxId, onScrolledToBottom]);
      return /* @__PURE__ */ React12.createElement(Popover.Popover, {
        ref,
        active: popoverActive,
        activator: /* @__PURE__ */ React12.createElement(context.ComboboxTextFieldContext.Provider, {
          value: textFieldContextValue
        }, activator),
        autofocusTarget: "none",
        preventFocusOnClose: !0,
        fullWidth: !0,
        preferInputActivator: !1,
        preferredPosition,
        onClose: handleClose
      }, React12.Children.count(children) > 0 ? /* @__PURE__ */ React12.createElement(Popover.Popover.Pane, {
        onScrolledToBottom,
        height
      }, /* @__PURE__ */ React12.createElement(context.ComboboxListboxContext.Provider, {
        value: listboxContextValue
      }, /* @__PURE__ */ React12.createElement(context.ComboboxListboxOptionContext.Provider, {
        value: listboxOptionContextValue
      }, /* @__PURE__ */ React12.createElement("div", {
        className: Combobox_module.default.Listbox
      }, children)))) : null);
    }
    Combobox.TextField = TextField.TextField;
    exports.Combobox = Combobox;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Autocomplete/components/MappedAction/MappedAction.scss.js
var require_MappedAction_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Autocomplete/components/MappedAction/MappedAction.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      ActionContainer: "Polaris-Autocomplete-MappedAction__ActionContainer",
      Action: "Polaris-Autocomplete-MappedAction__Action",
      destructive: "Polaris-Autocomplete-MappedAction--destructive",
      selected: "Polaris-Autocomplete-MappedAction--selected",
      disabled: "Polaris-Autocomplete-MappedAction--disabled",
      Prefix: "Polaris-Autocomplete-MappedAction__Prefix",
      Suffix: "Polaris-Autocomplete-MappedAction__Suffix",
      Content: "Polaris-Autocomplete-MappedAction__Content",
      Text: "Polaris-Autocomplete-MappedAction__Text",
      ContentWrap: "Polaris-Autocomplete-MappedAction__ContentWrap"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Autocomplete/components/MappedAction/MappedAction.js
var require_MappedAction = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Autocomplete/components/MappedAction/MappedAction.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), MappedAction_module = require_MappedAction_scss(), hooks2 = require_hooks2(), Icon = require_Icon(), Badge2 = require_Badge(), Text4 = require_Text(), context = require_context14(), Listbox = require_Listbox();
    function MappedAction({
      active,
      content,
      disabled,
      icon,
      image,
      prefix,
      suffix,
      ellipsis,
      role,
      url,
      external,
      onAction,
      destructive,
      badge,
      helpText,
      wrapOverflow = !1
    }) {
      let i18n = hooks2.useI18n(), prefixMarkup = null, contentOverflowStyle = wrapOverflow ? MappedAction_module.default.ContentWrap : void 0;
      prefix ? prefixMarkup = /* @__PURE__ */ React12.createElement("div", {
        className: MappedAction_module.default.Prefix
      }, prefix) : icon ? prefixMarkup = /* @__PURE__ */ React12.createElement("div", {
        className: MappedAction_module.default.Prefix
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: icon
      })) : image && (prefixMarkup = /* @__PURE__ */ React12.createElement("div", {
        role: "presentation",
        className: MappedAction_module.default.Prefix,
        style: {
          backgroundImage: `url(${image}`
        }
      }));
      let badgeMarkup = badge && /* @__PURE__ */ React12.createElement("span", {
        className: MappedAction_module.default.Suffix
      }, /* @__PURE__ */ React12.createElement(Badge2.Badge, {
        tone: badge.tone
      }, badge.content)), suffixMarkup = suffix && /* @__PURE__ */ React12.createElement("span", {
        className: MappedAction_module.default.Suffix
      }, suffix), contentText = ellipsis && content ? i18n.translate("Polaris.Autocomplete.ellipsis", {
        content
      }) : content, contentMarkup = /* @__PURE__ */ React12.createElement("div", {
        className: MappedAction_module.default.Text
      }, /* @__PURE__ */ React12.createElement("div", {
        className: contentOverflowStyle
      }, contentText), helpText ? /* @__PURE__ */ React12.createElement(Text4.Text, {
        tone: "subdued",
        as: "span"
      }, helpText) : null), context$1 = React12.useMemo(() => ({
        role,
        url,
        external,
        onAction,
        destructive
      }), [role, url, external, onAction, destructive]), actionClassNames = css.classNames(MappedAction_module.default.Action, disabled && MappedAction_module.default.disabled, destructive && MappedAction_module.default.destructive, active && MappedAction_module.default.selected);
      return /* @__PURE__ */ React12.createElement(context.MappedActionContext.Provider, {
        value: context$1
      }, /* @__PURE__ */ React12.createElement("div", {
        className: MappedAction_module.default.ActionContainer
      }, /* @__PURE__ */ React12.createElement(Listbox.Listbox.Action, {
        selected: active,
        disabled,
        value: content || ""
      }, /* @__PURE__ */ React12.createElement("div", {
        className: actionClassNames
      }, /* @__PURE__ */ React12.createElement("div", {
        className: MappedAction_module.default.Content
      }, prefixMarkup, contentMarkup, badgeMarkup, suffixMarkup)))));
    }
    exports.MappedAction = MappedAction;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Autocomplete/Autocomplete.js
var require_Autocomplete = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Autocomplete/Autocomplete.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), options = require_options2(), Autocomplete_module = require_Autocomplete_scss(), MappedOption = require_MappedOption(), Listbox = require_Listbox(), Combobox = require_Combobox(), MappedAction = require_MappedAction(), hooks2 = require_hooks2(), Autocomplete = function({
      options: options$1,
      selected,
      textField,
      preferredPosition,
      listTitle,
      allowMultiple,
      loading,
      actionBefore,
      willLoadMoreResults,
      emptyState,
      onSelect,
      onLoadMoreResults
    }) {
      let i18n = hooks2.useI18n(), buildMappedOptionFromOption = React12.useCallback((options2) => options2.map((option) => /* @__PURE__ */ React12.createElement(MappedOption.MappedOption, Object.assign({
        key: option.id || option.value
      }, option, {
        selected: selected.includes(option.value),
        singleSelection: !allowMultiple
      }))), [selected, allowMultiple]), optionsMarkup = React12.useMemo(() => {
        let conditionalOptions = loading && !willLoadMoreResults ? [] : options$1;
        if (options.isSection(conditionalOptions)) {
          if (conditionalOptions.every(({
            options: options2
          }) => options2.length === 0))
            return null;
          let optionsMarkup2 = conditionalOptions.map(({
            options: options2,
            title
          }) => {
            if (options2.length === 0)
              return null;
            let optionMarkup = buildMappedOptionFromOption(options2);
            return /* @__PURE__ */ React12.createElement(Listbox.Listbox.Section, {
              divider: !1,
              title: /* @__PURE__ */ React12.createElement(Listbox.Listbox.Header, null, title),
              key: title
            }, optionMarkup);
          });
          return /* @__PURE__ */ React12.createElement("div", {
            className: Autocomplete_module.default.SectionWrapper
          }, optionsMarkup2);
        }
        let optionList = conditionalOptions.length > 0 ? buildMappedOptionFromOption(conditionalOptions) : null;
        return listTitle ? /* @__PURE__ */ React12.createElement(Listbox.Listbox.Section, {
          divider: !1,
          title: /* @__PURE__ */ React12.createElement(Listbox.Listbox.Header, null, listTitle)
        }, optionList) : optionList;
      }, [listTitle, loading, options$1, willLoadMoreResults, buildMappedOptionFromOption]), loadingMarkup = loading ? /* @__PURE__ */ React12.createElement(Listbox.Listbox.Loading, {
        accessibilityLabel: i18n.translate("Polaris.Autocomplete.spinnerAccessibilityLabel")
      }) : null, updateSelection = React12.useCallback((newSelection) => {
        if (actionBefore && newSelection === actionBefore.content) {
          actionBefore.onAction && actionBefore.onAction();
          return;
        }
        allowMultiple ? selected.includes(newSelection) ? onSelect(selected.filter((option) => option !== newSelection)) : onSelect([...selected, newSelection]) : onSelect([newSelection]);
      }, [allowMultiple, onSelect, selected, actionBefore]), actionMarkup = actionBefore && /* @__PURE__ */ React12.createElement(MappedAction.MappedAction, actionBefore), emptyStateMarkup = emptyState && options$1.length < 1 && !loading && /* @__PURE__ */ React12.createElement("div", {
        role: "status"
      }, emptyState), autoSelection = actionBefore ? Listbox.AutoSelection.First : void 0;
      return /* @__PURE__ */ React12.createElement(Combobox.Combobox, {
        activator: textField,
        allowMultiple,
        onScrolledToBottom: onLoadMoreResults,
        preferredPosition,
        willLoadMoreOptions: willLoadMoreResults
      }, actionMarkup || optionsMarkup || loadingMarkup || emptyStateMarkup ? /* @__PURE__ */ React12.createElement(Listbox.Listbox, {
        autoSelection,
        onSelect: updateSelection
      }, actionMarkup, optionsMarkup && (!loading || willLoadMoreResults) ? optionsMarkup : null, loadingMarkup, emptyStateMarkup) : null);
    };
    Autocomplete.TextField = Combobox.Combobox.TextField;
    exports.Autocomplete = Autocomplete;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Backdrop/Backdrop.scss.js
var require_Backdrop_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Backdrop/Backdrop.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Backdrop: "Polaris-Backdrop",
      transparent: "Polaris-Backdrop--transparent",
      belowNavigation: "Polaris-Backdrop--belowNavigation"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ScrollLock/ScrollLock.scss.js
var require_ScrollLock_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ScrollLock/ScrollLock.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var ScrollLock_module = {};
    exports.default = ScrollLock_module;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/scroll-lock-manager/hooks.js
var require_hooks8 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/scroll-lock-manager/hooks.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), errors2 = require_errors6(), context = require_context3();
    function useScrollLockManager() {
      let scrollLockManager = React12.useContext(context.ScrollLockManagerContext);
      if (!scrollLockManager)
        throw new errors2.MissingAppProviderError("No ScrollLockManager was provided.");
      return scrollLockManager;
    }
    exports.useScrollLockManager = useScrollLockManager;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ScrollLock/ScrollLock.js
var require_ScrollLock = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ScrollLock/ScrollLock.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react();
    require_ScrollLock_scss();
    var hooks2 = require_hooks8();
    function ScrollLock(_2) {
      let scrollLockManager = hooks2.useScrollLockManager();
      return React12.useEffect(() => (scrollLockManager.registerScrollLock(), () => {
        scrollLockManager.unregisterScrollLock();
      }), [scrollLockManager]), null;
    }
    exports.ScrollLock = ScrollLock;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Backdrop/Backdrop.js
var require_Backdrop = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Backdrop/Backdrop.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Backdrop_module = require_Backdrop_scss(), ScrollLock = require_ScrollLock();
    function Backdrop(props) {
      let {
        onClick,
        onTouchStart,
        belowNavigation,
        transparent,
        setClosing
      } = props, className = css.classNames(Backdrop_module.default.Backdrop, belowNavigation && Backdrop_module.default.belowNavigation, transparent && Backdrop_module.default.transparent), handleMouseDown = () => {
        setClosing && setClosing(!0);
      }, handleClick = () => {
        setClosing && setClosing(!1), onClick && onClick();
      };
      return /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement(ScrollLock.ScrollLock, null), /* @__PURE__ */ React12.createElement("div", {
        className,
        onClick: handleClick,
        onTouchStart,
        onMouseDown: handleMouseDown
      }));
    }
    exports.Backdrop = Backdrop;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/banner-context.js
var require_banner_context = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/banner-context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), BannerContext = /* @__PURE__ */ React12.createContext(!1);
    exports.BannerContext = BannerContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Banner/Banner.scss.js
var require_Banner_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Banner/Banner.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Banner: "Polaris-Banner",
      keyFocused: "Polaris-Banner--keyFocused",
      withinContentContainer: "Polaris-Banner--withinContentContainer",
      withinPage: "Polaris-Banner--withinPage",
      DismissIcon: "Polaris-Banner__DismissIcon",
      "text-success-on-bg-fill": "Polaris-Banner--textSuccessOnBgFill",
      "text-success": "Polaris-Banner__text--success",
      "text-warning-on-bg-fill": "Polaris-Banner--textWarningOnBgFill",
      "text-warning": "Polaris-Banner__text--warning",
      "text-critical-on-bg-fill": "Polaris-Banner--textCriticalOnBgFill",
      "text-critical": "Polaris-Banner__text--critical",
      "text-info-on-bg-fill": "Polaris-Banner--textInfoOnBgFill",
      "text-info": "Polaris-Banner__text--info",
      "icon-secondary": "Polaris-Banner__icon--secondary"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Banner/utilities.js
var require_utilities2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Banner/utilities.js"(exports) {
    "use strict";
    init_cjs_shims();
    var polarisIcons = require_dist8(), React12 = require_react(), bannerAttributes = {
      success: {
        withinPage: {
          background: "bg-fill-success",
          text: "text-success-on-bg-fill",
          icon: "text-success-on-bg-fill"
        },
        withinContentContainer: {
          background: "bg-surface-success",
          text: "text-success",
          icon: "text-success"
        },
        icon: polarisIcons.CheckIcon
      },
      warning: {
        withinPage: {
          background: "bg-fill-warning",
          text: "text-warning-on-bg-fill",
          icon: "text-warning-on-bg-fill"
        },
        withinContentContainer: {
          background: "bg-surface-warning",
          text: "text-warning",
          icon: "text-warning"
        },
        icon: polarisIcons.AlertTriangleIcon
      },
      critical: {
        withinPage: {
          background: "bg-fill-critical",
          text: "text-critical-on-bg-fill",
          icon: "text-critical-on-bg-fill"
        },
        withinContentContainer: {
          background: "bg-surface-critical",
          text: "text-critical",
          icon: "text-critical"
        },
        icon: polarisIcons.AlertDiamondIcon
      },
      info: {
        withinPage: {
          background: "bg-fill-info",
          text: "text-info-on-bg-fill",
          icon: "text-info-on-bg-fill"
        },
        withinContentContainer: {
          background: "bg-surface-info",
          text: "text-info",
          icon: "text-info"
        },
        icon: polarisIcons.InfoIcon
      }
    };
    function useBannerFocus(bannerRef) {
      let wrapperRef = React12.useRef(null), [shouldShowFocus, setShouldShowFocus] = React12.useState(!1);
      return React12.useImperativeHandle(bannerRef, () => ({
        focus: () => {
          wrapperRef.current?.focus(), setShouldShowFocus(!0);
        }
      }), []), {
        wrapperRef,
        handleKeyUp: (event) => {
          event.target === wrapperRef.current && setShouldShowFocus(!0);
        },
        handleBlur: () => setShouldShowFocus(!1),
        handleMouseUp: (event) => {
          event.currentTarget.blur(), setShouldShowFocus(!1);
        },
        shouldShowFocus
      };
    }
    exports.bannerAttributes = bannerAttributes;
    exports.useBannerFocus = useBannerFocus;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Banner/Banner.js
var require_Banner = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Banner/Banner.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), bannerContext = require_banner_context(), withinContentContext = require_within_content_context(), css = require_css(), breakpoints = require_breakpoints2(), useEventListener = require_use_event_listener(), Banner_module = require_Banner_scss(), utilities = require_utilities2(), hooks2 = require_hooks2(), Text4 = require_Text(), Icon = require_Icon(), ButtonGroup = require_ButtonGroup(), Button2 = require_Button(), Box2 = require_Box(), BlockStack3 = require_BlockStack(), InlineStack2 = require_InlineStack(), Banner2 = /* @__PURE__ */ React12.forwardRef(function(props, bannerRef) {
      let {
        tone,
        stopAnnouncements
      } = props, withinContentContainer = React12.useContext(withinContentContext.WithinContentContext), {
        wrapperRef,
        handleKeyUp,
        handleBlur,
        handleMouseUp,
        shouldShowFocus
      } = utilities.useBannerFocus(bannerRef), className = css.classNames(Banner_module.default.Banner, shouldShowFocus && Banner_module.default.keyFocused, withinContentContainer ? Banner_module.default.withinContentContainer : Banner_module.default.withinPage);
      return /* @__PURE__ */ React12.createElement(bannerContext.BannerContext.Provider, {
        value: !0
      }, /* @__PURE__ */ React12.createElement("div", {
        className,
        tabIndex: 0,
        ref: wrapperRef,
        role: tone === "warning" || tone === "critical" ? "alert" : "status",
        "aria-live": stopAnnouncements ? "off" : "polite",
        onMouseUp: handleMouseUp,
        onKeyUp: handleKeyUp,
        onBlur: handleBlur
      }, /* @__PURE__ */ React12.createElement(BannerLayout, props)));
    });
    function BannerLayout({
      tone = "info",
      icon,
      hideIcon,
      onDismiss,
      action,
      secondaryAction,
      title,
      children
    }) {
      let i18n = hooks2.useI18n(), withinContentContainer = React12.useContext(withinContentContext.WithinContentContext), isInlineIconBanner = !title && !withinContentContainer, bannerTone = Object.keys(utilities.bannerAttributes).includes(tone) ? tone : "info", bannerColors = utilities.bannerAttributes[bannerTone][withinContentContainer ? "withinContentContainer" : "withinPage"], sharedBannerProps = {
        backgroundColor: bannerColors.background,
        textColor: bannerColors.text,
        bannerTitle: title ? /* @__PURE__ */ React12.createElement(Text4.Text, {
          as: "h2",
          variant: "headingSm",
          breakWord: !0
        }, title) : null,
        bannerIcon: hideIcon ? null : /* @__PURE__ */ React12.createElement("span", {
          className: Banner_module.default[bannerColors.icon]
        }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
          source: icon ?? utilities.bannerAttributes[bannerTone].icon
        })),
        actionButtons: action || secondaryAction ? /* @__PURE__ */ React12.createElement(ButtonGroup.ButtonGroup, null, action && /* @__PURE__ */ React12.createElement(Button2.Button, Object.assign({
          onClick: action.onAction
        }, action), action.content), secondaryAction && /* @__PURE__ */ React12.createElement(Button2.Button, Object.assign({
          onClick: secondaryAction.onAction
        }, secondaryAction), secondaryAction.content)) : null,
        dismissButton: onDismiss ? /* @__PURE__ */ React12.createElement(Button2.Button, {
          variant: "tertiary",
          icon: /* @__PURE__ */ React12.createElement("span", {
            className: Banner_module.default[isInlineIconBanner ? "icon-secondary" : bannerColors.icon]
          }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
            source: polarisIcons.XIcon
          })),
          onClick: onDismiss,
          accessibilityLabel: i18n.translate("Polaris.Banner.dismissButton")
        }) : null
      };
      return withinContentContainer ? /* @__PURE__ */ React12.createElement(WithinContentContainerBanner, sharedBannerProps, children) : isInlineIconBanner ? /* @__PURE__ */ React12.createElement(InlineIconBanner, sharedBannerProps, children) : /* @__PURE__ */ React12.createElement(DefaultBanner, sharedBannerProps, children);
    }
    function DefaultBanner({
      backgroundColor,
      textColor,
      bannerTitle,
      bannerIcon,
      actionButtons,
      dismissButton,
      children
    }) {
      let {
        smUp
      } = breakpoints.useBreakpoints(), hasContent = children || actionButtons;
      return /* @__PURE__ */ React12.createElement(Box2.Box, {
        width: "100%"
      }, /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
        align: "space-between"
      }, /* @__PURE__ */ React12.createElement(Box2.Box, {
        background: backgroundColor,
        color: textColor,
        borderStartStartRadius: smUp ? "300" : void 0,
        borderStartEndRadius: smUp ? "300" : void 0,
        borderEndStartRadius: !hasContent && smUp ? "300" : void 0,
        borderEndEndRadius: !hasContent && smUp ? "300" : void 0,
        padding: "300"
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        align: "space-between",
        blockAlign: "center",
        gap: "200",
        wrap: !1
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "100",
        wrap: !1
      }, bannerIcon, bannerTitle), dismissButton)), hasContent && /* @__PURE__ */ React12.createElement(Box2.Box, {
        padding: {
          xs: "300",
          md: "400"
        },
        paddingBlockStart: "300"
      }, /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
        gap: "200"
      }, /* @__PURE__ */ React12.createElement("div", null, children), actionButtons))));
    }
    function InlineIconBanner({
      backgroundColor,
      bannerIcon,
      actionButtons,
      dismissButton,
      children
    }) {
      let [blockAlign, setBlockAlign] = React12.useState("center"), contentNode = React12.useRef(null), iconNode = React12.useRef(null), dismissIconNode = React12.useRef(null), handleResize = React12.useCallback(() => {
        let contentHeight = contentNode.current?.offsetHeight, iconBoxHeight = iconNode.current?.offsetHeight || dismissIconNode.current?.offsetHeight;
        !contentHeight || !iconBoxHeight || (contentHeight > iconBoxHeight ? setBlockAlign("start") : setBlockAlign("center"));
      }, []);
      return React12.useEffect(() => handleResize(), [handleResize]), useEventListener.useEventListener("resize", handleResize), /* @__PURE__ */ React12.createElement(Box2.Box, {
        width: "100%",
        padding: "300",
        borderRadius: "300"
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        align: "space-between",
        blockAlign,
        wrap: !1
      }, /* @__PURE__ */ React12.createElement(Box2.Box, {
        width: "100%"
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "200",
        wrap: !1,
        blockAlign
      }, bannerIcon ? /* @__PURE__ */ React12.createElement("div", {
        ref: iconNode
      }, /* @__PURE__ */ React12.createElement(Box2.Box, {
        background: backgroundColor,
        borderRadius: "200",
        padding: "100"
      }, bannerIcon)) : null, /* @__PURE__ */ React12.createElement(Box2.Box, {
        ref: contentNode,
        width: "100%"
      }, /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
        gap: "200"
      }, /* @__PURE__ */ React12.createElement("div", null, children), actionButtons)))), /* @__PURE__ */ React12.createElement("div", {
        ref: dismissIconNode,
        className: Banner_module.default.DismissIcon
      }, dismissButton)));
    }
    function WithinContentContainerBanner({
      backgroundColor,
      textColor,
      bannerTitle,
      bannerIcon,
      actionButtons,
      dismissButton,
      children
    }) {
      return /* @__PURE__ */ React12.createElement(Box2.Box, {
        width: "100%",
        background: backgroundColor,
        padding: "200",
        borderRadius: "200",
        color: textColor
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        align: "space-between",
        blockAlign: "start",
        wrap: !1,
        gap: "200"
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "150",
        wrap: !1
      }, bannerIcon, /* @__PURE__ */ React12.createElement(Box2.Box, {
        width: "100%"
      }, /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
        gap: "200"
      }, /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
        gap: "050"
      }, bannerTitle, /* @__PURE__ */ React12.createElement("div", null, children)), actionButtons))), dismissButton));
    }
    exports.Banner = Banner2;
    exports.BannerLayout = BannerLayout;
    exports.DefaultBanner = DefaultBanner;
    exports.InlineIconBanner = InlineIconBanner;
    exports.WithinContentContainerBanner = WithinContentContainerBanner;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Bleed/Bleed.scss.js
var require_Bleed_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Bleed/Bleed.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Bleed: "Polaris-Bleed"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Bleed/Bleed.js
var require_Bleed = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Bleed/Bleed.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Bleed_module = require_Bleed_scss(), Bleed = ({
      marginInline,
      marginBlock,
      marginBlockStart,
      marginBlockEnd,
      marginInlineStart,
      marginInlineEnd,
      children
    }) => {
      let getNegativeMargins = (direction) => {
        let xAxis = ["marginInlineStart", "marginInlineEnd"], yAxis = ["marginBlockStart", "marginBlockEnd"], directionValues = {
          marginBlockStart,
          marginBlockEnd,
          marginInlineStart,
          marginInlineEnd,
          marginInline,
          marginBlock
        };
        if (directionValues[direction])
          return directionValues[direction];
        if (xAxis.includes(direction) && marginInline)
          return directionValues.marginInline;
        if (yAxis.includes(direction) && marginBlock)
          return directionValues.marginBlock;
      }, negativeMarginBlockStart = getNegativeMargins("marginBlockStart"), negativeMarginBlockEnd = getNegativeMargins("marginBlockEnd"), negativeMarginInlineStart = getNegativeMargins("marginInlineStart"), negativeMarginInlineEnd = getNegativeMargins("marginInlineEnd"), style = {
        ...css.getResponsiveProps("bleed", "margin-block-start", "space", negativeMarginBlockStart),
        ...css.getResponsiveProps("bleed", "margin-block-end", "space", negativeMarginBlockEnd),
        ...css.getResponsiveProps("bleed", "margin-inline-start", "space", negativeMarginInlineStart),
        ...css.getResponsiveProps("bleed", "margin-inline-end", "space", negativeMarginInlineEnd)
      };
      return /* @__PURE__ */ React12.createElement("div", {
        className: Bleed_module.default.Bleed,
        style: css.sanitizeCustomProperties(style)
      }, children);
    };
    exports.Bleed = Bleed;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Breadcrumbs/Breadcrumbs.js
var require_Breadcrumbs = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Breadcrumbs/Breadcrumbs.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), focus = require_focus(), Button2 = require_Button();
    function Breadcrumbs({
      backAction
    }) {
      let {
        content
      } = backAction, breadcrumbMarkup = /* @__PURE__ */ React12.createElement(Button2.Button, {
        key: content,
        url: "url" in backAction ? backAction.url : void 0,
        onClick: "onAction" in backAction ? backAction.onAction : void 0,
        onPointerDown: focus.handleMouseUpByBlurring,
        icon: polarisIcons.ArrowLeftIcon,
        accessibilityLabel: backAction.accessibilityLabel ?? content
      });
      return /* @__PURE__ */ React12.createElement("nav", {
        role: "navigation"
      }, breadcrumbMarkup);
    }
    exports.Breadcrumbs = Breadcrumbs;
  }
});

// ../../node_modules/.pnpm/react-is@16.13.1/node_modules/react-is/cjs/react-is.production.min.js
var require_react_is_production_min = __commonJS({
  "../../node_modules/.pnpm/react-is@16.13.1/node_modules/react-is/cjs/react-is.production.min.js"(exports) {
    "use strict";
    init_cjs_shims();
    var b = typeof Symbol == "function" && Symbol.for, c = b ? Symbol.for("react.element") : 60103, d = b ? Symbol.for("react.portal") : 60106, e = b ? Symbol.for("react.fragment") : 60107, f = b ? Symbol.for("react.strict_mode") : 60108, g = b ? Symbol.for("react.profiler") : 60114, h = b ? Symbol.for("react.provider") : 60109, k = b ? Symbol.for("react.context") : 60110, l = b ? Symbol.for("react.async_mode") : 60111, m = b ? Symbol.for("react.concurrent_mode") : 60111, n = b ? Symbol.for("react.forward_ref") : 60112, p = b ? Symbol.for("react.suspense") : 60113, q = b ? Symbol.for("react.suspense_list") : 60120, r2 = b ? Symbol.for("react.memo") : 60115, t7 = b ? Symbol.for("react.lazy") : 60116, v = b ? Symbol.for("react.block") : 60121, w = b ? Symbol.for("react.fundamental") : 60117, x = b ? Symbol.for("react.responder") : 60118, y = b ? Symbol.for("react.scope") : 60119;
    function z2(a) {
      if (typeof a == "object" && a !== null) {
        var u = a.$$typeof;
        switch (u) {
          case c:
            switch (a = a.type, a) {
              case l:
              case m:
              case e:
              case g:
              case f:
              case p:
                return a;
              default:
                switch (a = a && a.$$typeof, a) {
                  case k:
                  case n:
                  case t7:
                  case r2:
                  case h:
                    return a;
                  default:
                    return u;
                }
            }
          case d:
            return u;
        }
      }
    }
    function A(a) {
      return z2(a) === m;
    }
    exports.AsyncMode = l;
    exports.ConcurrentMode = m;
    exports.ContextConsumer = k;
    exports.ContextProvider = h;
    exports.Element = c;
    exports.ForwardRef = n;
    exports.Fragment = e;
    exports.Lazy = t7;
    exports.Memo = r2;
    exports.Portal = d;
    exports.Profiler = g;
    exports.StrictMode = f;
    exports.Suspense = p;
    exports.isAsyncMode = function(a) {
      return A(a) || z2(a) === l;
    };
    exports.isConcurrentMode = A;
    exports.isContextConsumer = function(a) {
      return z2(a) === k;
    };
    exports.isContextProvider = function(a) {
      return z2(a) === h;
    };
    exports.isElement = function(a) {
      return typeof a == "object" && a !== null && a.$$typeof === c;
    };
    exports.isForwardRef = function(a) {
      return z2(a) === n;
    };
    exports.isFragment = function(a) {
      return z2(a) === e;
    };
    exports.isLazy = function(a) {
      return z2(a) === t7;
    };
    exports.isMemo = function(a) {
      return z2(a) === r2;
    };
    exports.isPortal = function(a) {
      return z2(a) === d;
    };
    exports.isProfiler = function(a) {
      return z2(a) === g;
    };
    exports.isStrictMode = function(a) {
      return z2(a) === f;
    };
    exports.isSuspense = function(a) {
      return z2(a) === p;
    };
    exports.isValidElementType = function(a) {
      return typeof a == "string" || typeof a == "function" || a === e || a === m || a === g || a === f || a === p || a === q || typeof a == "object" && a !== null && (a.$$typeof === t7 || a.$$typeof === r2 || a.$$typeof === h || a.$$typeof === k || a.$$typeof === n || a.$$typeof === w || a.$$typeof === x || a.$$typeof === y || a.$$typeof === v);
    };
    exports.typeOf = z2;
  }
});

// ../../node_modules/.pnpm/react-is@16.13.1/node_modules/react-is/cjs/react-is.development.js
var require_react_is_development = __commonJS({
  "../../node_modules/.pnpm/react-is@16.13.1/node_modules/react-is/cjs/react-is.development.js"(exports) {
    "use strict";
    init_cjs_shims();
    process.env.NODE_ENV !== "production" && function() {
      "use strict";
      var hasSymbol = typeof Symbol == "function" && Symbol.for, REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for("react.element") : 60103, REACT_PORTAL_TYPE = hasSymbol ? Symbol.for("react.portal") : 60106, REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for("react.fragment") : 60107, REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for("react.strict_mode") : 60108, REACT_PROFILER_TYPE = hasSymbol ? Symbol.for("react.profiler") : 60114, REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for("react.provider") : 60109, REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for("react.context") : 60110, REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for("react.async_mode") : 60111, REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for("react.concurrent_mode") : 60111, REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for("react.forward_ref") : 60112, REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for("react.suspense") : 60113, REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for("react.suspense_list") : 60120, REACT_MEMO_TYPE = hasSymbol ? Symbol.for("react.memo") : 60115, REACT_LAZY_TYPE = hasSymbol ? Symbol.for("react.lazy") : 60116, REACT_BLOCK_TYPE = hasSymbol ? Symbol.for("react.block") : 60121, REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for("react.fundamental") : 60117, REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for("react.responder") : 60118, REACT_SCOPE_TYPE = hasSymbol ? Symbol.for("react.scope") : 60119;
      function isValidElementType(type) {
        return typeof type == "string" || typeof type == "function" || // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
        type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || typeof type == "object" && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_RESPONDER_TYPE || type.$$typeof === REACT_SCOPE_TYPE || type.$$typeof === REACT_BLOCK_TYPE);
      }
      function typeOf(object) {
        if (typeof object == "object" && object !== null) {
          var $$typeof = object.$$typeof;
          switch ($$typeof) {
            case REACT_ELEMENT_TYPE:
              var type = object.type;
              switch (type) {
                case REACT_ASYNC_MODE_TYPE:
                case REACT_CONCURRENT_MODE_TYPE:
                case REACT_FRAGMENT_TYPE:
                case REACT_PROFILER_TYPE:
                case REACT_STRICT_MODE_TYPE:
                case REACT_SUSPENSE_TYPE:
                  return type;
                default:
                  var $$typeofType = type && type.$$typeof;
                  switch ($$typeofType) {
                    case REACT_CONTEXT_TYPE:
                    case REACT_FORWARD_REF_TYPE:
                    case REACT_LAZY_TYPE:
                    case REACT_MEMO_TYPE:
                    case REACT_PROVIDER_TYPE:
                      return $$typeofType;
                    default:
                      return $$typeof;
                  }
              }
            case REACT_PORTAL_TYPE:
              return $$typeof;
          }
        }
      }
      var AsyncMode = REACT_ASYNC_MODE_TYPE, ConcurrentMode = REACT_CONCURRENT_MODE_TYPE, ContextConsumer = REACT_CONTEXT_TYPE, ContextProvider = REACT_PROVIDER_TYPE, Element2 = REACT_ELEMENT_TYPE, ForwardRef = REACT_FORWARD_REF_TYPE, Fragment = REACT_FRAGMENT_TYPE, Lazy = REACT_LAZY_TYPE, Memo = REACT_MEMO_TYPE, Portal = REACT_PORTAL_TYPE, Profiler = REACT_PROFILER_TYPE, StrictMode = REACT_STRICT_MODE_TYPE, Suspense = REACT_SUSPENSE_TYPE, hasWarnedAboutDeprecatedIsAsyncMode = !1;
      function isAsyncMode(object) {
        return hasWarnedAboutDeprecatedIsAsyncMode || (hasWarnedAboutDeprecatedIsAsyncMode = !0, console.warn("The ReactIs.isAsyncMode() alias has been deprecated, and will be removed in React 17+. Update your code to use ReactIs.isConcurrentMode() instead. It has the exact same API.")), isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
      }
      function isConcurrentMode(object) {
        return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
      }
      function isContextConsumer(object) {
        return typeOf(object) === REACT_CONTEXT_TYPE;
      }
      function isContextProvider(object) {
        return typeOf(object) === REACT_PROVIDER_TYPE;
      }
      function isElement(object) {
        return typeof object == "object" && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
      }
      function isForwardRef(object) {
        return typeOf(object) === REACT_FORWARD_REF_TYPE;
      }
      function isFragment(object) {
        return typeOf(object) === REACT_FRAGMENT_TYPE;
      }
      function isLazy(object) {
        return typeOf(object) === REACT_LAZY_TYPE;
      }
      function isMemo(object) {
        return typeOf(object) === REACT_MEMO_TYPE;
      }
      function isPortal(object) {
        return typeOf(object) === REACT_PORTAL_TYPE;
      }
      function isProfiler(object) {
        return typeOf(object) === REACT_PROFILER_TYPE;
      }
      function isStrictMode(object) {
        return typeOf(object) === REACT_STRICT_MODE_TYPE;
      }
      function isSuspense(object) {
        return typeOf(object) === REACT_SUSPENSE_TYPE;
      }
      exports.AsyncMode = AsyncMode, exports.ConcurrentMode = ConcurrentMode, exports.ContextConsumer = ContextConsumer, exports.ContextProvider = ContextProvider, exports.Element = Element2, exports.ForwardRef = ForwardRef, exports.Fragment = Fragment, exports.Lazy = Lazy, exports.Memo = Memo, exports.Portal = Portal, exports.Profiler = Profiler, exports.StrictMode = StrictMode, exports.Suspense = Suspense, exports.isAsyncMode = isAsyncMode, exports.isConcurrentMode = isConcurrentMode, exports.isContextConsumer = isContextConsumer, exports.isContextProvider = isContextProvider, exports.isElement = isElement, exports.isForwardRef = isForwardRef, exports.isFragment = isFragment, exports.isLazy = isLazy, exports.isMemo = isMemo, exports.isPortal = isPortal, exports.isProfiler = isProfiler, exports.isStrictMode = isStrictMode, exports.isSuspense = isSuspense, exports.isValidElementType = isValidElementType, exports.typeOf = typeOf;
    }();
  }
});

// ../../node_modules/.pnpm/react-is@16.13.1/node_modules/react-is/index.js
var require_react_is = __commonJS({
  "../../node_modules/.pnpm/react-is@16.13.1/node_modules/react-is/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    process.env.NODE_ENV === "production" ? module.exports = require_react_is_production_min() : module.exports = require_react_is_development();
  }
});

// ../../node_modules/.pnpm/prop-types@15.8.1/node_modules/prop-types/lib/ReactPropTypesSecret.js
var require_ReactPropTypesSecret = __commonJS({
  "../../node_modules/.pnpm/prop-types@15.8.1/node_modules/prop-types/lib/ReactPropTypesSecret.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var ReactPropTypesSecret = "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED";
    module.exports = ReactPropTypesSecret;
  }
});

// ../../node_modules/.pnpm/prop-types@15.8.1/node_modules/prop-types/lib/has.js
var require_has = __commonJS({
  "../../node_modules/.pnpm/prop-types@15.8.1/node_modules/prop-types/lib/has.js"(exports, module) {
    init_cjs_shims();
    module.exports = Function.call.bind(Object.prototype.hasOwnProperty);
  }
});

// ../../node_modules/.pnpm/prop-types@15.8.1/node_modules/prop-types/checkPropTypes.js
var require_checkPropTypes = __commonJS({
  "../../node_modules/.pnpm/prop-types@15.8.1/node_modules/prop-types/checkPropTypes.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var printWarning = function() {
    };
    process.env.NODE_ENV !== "production" && (ReactPropTypesSecret = require_ReactPropTypesSecret(), loggedTypeFailures = {}, has2 = require_has(), printWarning = function(text) {
      var message = "Warning: " + text;
      typeof console < "u" && console.error(message);
      try {
        throw new Error(message);
      } catch {
      }
    });
    var ReactPropTypesSecret, loggedTypeFailures, has2;
    function checkPropTypes(typeSpecs, values, location2, componentName, getStack) {
      if (process.env.NODE_ENV !== "production") {
        for (var typeSpecName in typeSpecs)
          if (has2(typeSpecs, typeSpecName)) {
            var error;
            try {
              if (typeof typeSpecs[typeSpecName] != "function") {
                var err2 = Error(
                  (componentName || "React class") + ": " + location2 + " type `" + typeSpecName + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof typeSpecs[typeSpecName] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`."
                );
                throw err2.name = "Invariant Violation", err2;
              }
              error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location2, null, ReactPropTypesSecret);
            } catch (ex) {
              error = ex;
            }
            if (error && !(error instanceof Error) && printWarning(
              (componentName || "React class") + ": type specification of " + location2 + " `" + typeSpecName + "` is invalid; the type checker function must return `null` or an `Error` but returned a " + typeof error + ". You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument)."
            ), error instanceof Error && !(error.message in loggedTypeFailures)) {
              loggedTypeFailures[error.message] = !0;
              var stack = getStack ? getStack() : "";
              printWarning(
                "Failed " + location2 + " type: " + error.message + (stack ?? "")
              );
            }
          }
      }
    }
    checkPropTypes.resetWarningCache = function() {
      process.env.NODE_ENV !== "production" && (loggedTypeFailures = {});
    };
    module.exports = checkPropTypes;
  }
});

// ../../node_modules/.pnpm/prop-types@15.8.1/node_modules/prop-types/factoryWithTypeCheckers.js
var require_factoryWithTypeCheckers = __commonJS({
  "../../node_modules/.pnpm/prop-types@15.8.1/node_modules/prop-types/factoryWithTypeCheckers.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var ReactIs = require_react_is(), assign = require_object_assign(), ReactPropTypesSecret = require_ReactPropTypesSecret(), has2 = require_has(), checkPropTypes = require_checkPropTypes(), printWarning = function() {
    };
    process.env.NODE_ENV !== "production" && (printWarning = function(text) {
      var message = "Warning: " + text;
      typeof console < "u" && console.error(message);
      try {
        throw new Error(message);
      } catch {
      }
    });
    function emptyFunctionThatReturnsNull() {
      return null;
    }
    module.exports = function(isValidElement, throwOnDirectAccess) {
      var ITERATOR_SYMBOL = typeof Symbol == "function" && Symbol.iterator, FAUX_ITERATOR_SYMBOL = "@@iterator";
      function getIteratorFn(maybeIterable) {
        var iteratorFn = maybeIterable && (ITERATOR_SYMBOL && maybeIterable[ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL]);
        if (typeof iteratorFn == "function")
          return iteratorFn;
      }
      var ANONYMOUS = "<<anonymous>>", ReactPropTypes = {
        array: createPrimitiveTypeChecker("array"),
        bigint: createPrimitiveTypeChecker("bigint"),
        bool: createPrimitiveTypeChecker("boolean"),
        func: createPrimitiveTypeChecker("function"),
        number: createPrimitiveTypeChecker("number"),
        object: createPrimitiveTypeChecker("object"),
        string: createPrimitiveTypeChecker("string"),
        symbol: createPrimitiveTypeChecker("symbol"),
        any: createAnyTypeChecker(),
        arrayOf: createArrayOfTypeChecker,
        element: createElementTypeChecker(),
        elementType: createElementTypeTypeChecker(),
        instanceOf: createInstanceTypeChecker,
        node: createNodeChecker(),
        objectOf: createObjectOfTypeChecker,
        oneOf: createEnumTypeChecker,
        oneOfType: createUnionTypeChecker,
        shape: createShapeTypeChecker,
        exact: createStrictShapeTypeChecker
      };
      function is(x, y) {
        return x === y ? x !== 0 || 1 / x === 1 / y : x !== x && y !== y;
      }
      function PropTypeError(message, data) {
        this.message = message, this.data = data && typeof data == "object" ? data : {}, this.stack = "";
      }
      PropTypeError.prototype = Error.prototype;
      function createChainableTypeChecker(validate5) {
        if (process.env.NODE_ENV !== "production")
          var manualPropTypeCallCache = {}, manualPropTypeWarningCount = 0;
        function checkType(isRequired, props, propName, componentName, location2, propFullName, secret) {
          if (componentName = componentName || ANONYMOUS, propFullName = propFullName || propName, secret !== ReactPropTypesSecret) {
            if (throwOnDirectAccess) {
              var err2 = new Error(
                "Calling PropTypes validators directly is not supported by the `prop-types` package. Use `PropTypes.checkPropTypes()` to call them. Read more at http://fb.me/use-check-prop-types"
              );
              throw err2.name = "Invariant Violation", err2;
            } else if (process.env.NODE_ENV !== "production" && typeof console < "u") {
              var cacheKey = componentName + ":" + propName;
              !manualPropTypeCallCache[cacheKey] && // Avoid spamming the console because they are often not actionable except for lib authors
              manualPropTypeWarningCount < 3 && (printWarning(
                "You are manually calling a React.PropTypes validation function for the `" + propFullName + "` prop on `" + componentName + "`. This is deprecated and will throw in the standalone `prop-types` package. You may be seeing this warning due to a third-party PropTypes library. See https://fb.me/react-warning-dont-call-proptypes for details."
              ), manualPropTypeCallCache[cacheKey] = !0, manualPropTypeWarningCount++);
            }
          }
          return props[propName] == null ? isRequired ? props[propName] === null ? new PropTypeError("The " + location2 + " `" + propFullName + "` is marked as required " + ("in `" + componentName + "`, but its value is `null`.")) : new PropTypeError("The " + location2 + " `" + propFullName + "` is marked as required in " + ("`" + componentName + "`, but its value is `undefined`.")) : null : validate5(props, propName, componentName, location2, propFullName);
        }
        var chainedCheckType = checkType.bind(null, !1);
        return chainedCheckType.isRequired = checkType.bind(null, !0), chainedCheckType;
      }
      function createPrimitiveTypeChecker(expectedType) {
        function validate5(props, propName, componentName, location2, propFullName, secret) {
          var propValue = props[propName], propType = getPropType(propValue);
          if (propType !== expectedType) {
            var preciseType = getPreciseType(propValue);
            return new PropTypeError(
              "Invalid " + location2 + " `" + propFullName + "` of type " + ("`" + preciseType + "` supplied to `" + componentName + "`, expected ") + ("`" + expectedType + "`."),
              { expectedType }
            );
          }
          return null;
        }
        return createChainableTypeChecker(validate5);
      }
      function createAnyTypeChecker() {
        return createChainableTypeChecker(emptyFunctionThatReturnsNull);
      }
      function createArrayOfTypeChecker(typeChecker) {
        function validate5(props, propName, componentName, location2, propFullName) {
          if (typeof typeChecker != "function")
            return new PropTypeError("Property `" + propFullName + "` of component `" + componentName + "` has invalid PropType notation inside arrayOf.");
          var propValue = props[propName];
          if (!Array.isArray(propValue)) {
            var propType = getPropType(propValue);
            return new PropTypeError("Invalid " + location2 + " `" + propFullName + "` of type " + ("`" + propType + "` supplied to `" + componentName + "`, expected an array."));
          }
          for (var i = 0; i < propValue.length; i++) {
            var error = typeChecker(propValue, i, componentName, location2, propFullName + "[" + i + "]", ReactPropTypesSecret);
            if (error instanceof Error)
              return error;
          }
          return null;
        }
        return createChainableTypeChecker(validate5);
      }
      function createElementTypeChecker() {
        function validate5(props, propName, componentName, location2, propFullName) {
          var propValue = props[propName];
          if (!isValidElement(propValue)) {
            var propType = getPropType(propValue);
            return new PropTypeError("Invalid " + location2 + " `" + propFullName + "` of type " + ("`" + propType + "` supplied to `" + componentName + "`, expected a single ReactElement."));
          }
          return null;
        }
        return createChainableTypeChecker(validate5);
      }
      function createElementTypeTypeChecker() {
        function validate5(props, propName, componentName, location2, propFullName) {
          var propValue = props[propName];
          if (!ReactIs.isValidElementType(propValue)) {
            var propType = getPropType(propValue);
            return new PropTypeError("Invalid " + location2 + " `" + propFullName + "` of type " + ("`" + propType + "` supplied to `" + componentName + "`, expected a single ReactElement type."));
          }
          return null;
        }
        return createChainableTypeChecker(validate5);
      }
      function createInstanceTypeChecker(expectedClass) {
        function validate5(props, propName, componentName, location2, propFullName) {
          if (!(props[propName] instanceof expectedClass)) {
            var expectedClassName = expectedClass.name || ANONYMOUS, actualClassName = getClassName(props[propName]);
            return new PropTypeError("Invalid " + location2 + " `" + propFullName + "` of type " + ("`" + actualClassName + "` supplied to `" + componentName + "`, expected ") + ("instance of `" + expectedClassName + "`."));
          }
          return null;
        }
        return createChainableTypeChecker(validate5);
      }
      function createEnumTypeChecker(expectedValues) {
        if (!Array.isArray(expectedValues))
          return process.env.NODE_ENV !== "production" && (arguments.length > 1 ? printWarning(
            "Invalid arguments supplied to oneOf, expected an array, got " + arguments.length + " arguments. A common mistake is to write oneOf(x, y, z) instead of oneOf([x, y, z])."
          ) : printWarning("Invalid argument supplied to oneOf, expected an array.")), emptyFunctionThatReturnsNull;
        function validate5(props, propName, componentName, location2, propFullName) {
          for (var propValue = props[propName], i = 0; i < expectedValues.length; i++)
            if (is(propValue, expectedValues[i]))
              return null;
          var valuesString = JSON.stringify(expectedValues, function(key, value) {
            var type = getPreciseType(value);
            return type === "symbol" ? String(value) : value;
          });
          return new PropTypeError("Invalid " + location2 + " `" + propFullName + "` of value `" + String(propValue) + "` " + ("supplied to `" + componentName + "`, expected one of " + valuesString + "."));
        }
        return createChainableTypeChecker(validate5);
      }
      function createObjectOfTypeChecker(typeChecker) {
        function validate5(props, propName, componentName, location2, propFullName) {
          if (typeof typeChecker != "function")
            return new PropTypeError("Property `" + propFullName + "` of component `" + componentName + "` has invalid PropType notation inside objectOf.");
          var propValue = props[propName], propType = getPropType(propValue);
          if (propType !== "object")
            return new PropTypeError("Invalid " + location2 + " `" + propFullName + "` of type " + ("`" + propType + "` supplied to `" + componentName + "`, expected an object."));
          for (var key in propValue)
            if (has2(propValue, key)) {
              var error = typeChecker(propValue, key, componentName, location2, propFullName + "." + key, ReactPropTypesSecret);
              if (error instanceof Error)
                return error;
            }
          return null;
        }
        return createChainableTypeChecker(validate5);
      }
      function createUnionTypeChecker(arrayOfTypeCheckers) {
        if (!Array.isArray(arrayOfTypeCheckers))
          return process.env.NODE_ENV !== "production" && printWarning("Invalid argument supplied to oneOfType, expected an instance of array."), emptyFunctionThatReturnsNull;
        for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
          var checker = arrayOfTypeCheckers[i];
          if (typeof checker != "function")
            return printWarning(
              "Invalid argument supplied to oneOfType. Expected an array of check functions, but received " + getPostfixForTypeWarning(checker) + " at index " + i + "."
            ), emptyFunctionThatReturnsNull;
        }
        function validate5(props, propName, componentName, location2, propFullName) {
          for (var expectedTypes = [], i2 = 0; i2 < arrayOfTypeCheckers.length; i2++) {
            var checker2 = arrayOfTypeCheckers[i2], checkerResult = checker2(props, propName, componentName, location2, propFullName, ReactPropTypesSecret);
            if (checkerResult == null)
              return null;
            checkerResult.data && has2(checkerResult.data, "expectedType") && expectedTypes.push(checkerResult.data.expectedType);
          }
          var expectedTypesMessage = expectedTypes.length > 0 ? ", expected one of type [" + expectedTypes.join(", ") + "]" : "";
          return new PropTypeError("Invalid " + location2 + " `" + propFullName + "` supplied to " + ("`" + componentName + "`" + expectedTypesMessage + "."));
        }
        return createChainableTypeChecker(validate5);
      }
      function createNodeChecker() {
        function validate5(props, propName, componentName, location2, propFullName) {
          return isNode(props[propName]) ? null : new PropTypeError("Invalid " + location2 + " `" + propFullName + "` supplied to " + ("`" + componentName + "`, expected a ReactNode."));
        }
        return createChainableTypeChecker(validate5);
      }
      function invalidValidatorError(componentName, location2, propFullName, key, type) {
        return new PropTypeError(
          (componentName || "React class") + ": " + location2 + " type `" + propFullName + "." + key + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + type + "`."
        );
      }
      function createShapeTypeChecker(shapeTypes) {
        function validate5(props, propName, componentName, location2, propFullName) {
          var propValue = props[propName], propType = getPropType(propValue);
          if (propType !== "object")
            return new PropTypeError("Invalid " + location2 + " `" + propFullName + "` of type `" + propType + "` " + ("supplied to `" + componentName + "`, expected `object`."));
          for (var key in shapeTypes) {
            var checker = shapeTypes[key];
            if (typeof checker != "function")
              return invalidValidatorError(componentName, location2, propFullName, key, getPreciseType(checker));
            var error = checker(propValue, key, componentName, location2, propFullName + "." + key, ReactPropTypesSecret);
            if (error)
              return error;
          }
          return null;
        }
        return createChainableTypeChecker(validate5);
      }
      function createStrictShapeTypeChecker(shapeTypes) {
        function validate5(props, propName, componentName, location2, propFullName) {
          var propValue = props[propName], propType = getPropType(propValue);
          if (propType !== "object")
            return new PropTypeError("Invalid " + location2 + " `" + propFullName + "` of type `" + propType + "` " + ("supplied to `" + componentName + "`, expected `object`."));
          var allKeys = assign({}, props[propName], shapeTypes);
          for (var key in allKeys) {
            var checker = shapeTypes[key];
            if (has2(shapeTypes, key) && typeof checker != "function")
              return invalidValidatorError(componentName, location2, propFullName, key, getPreciseType(checker));
            if (!checker)
              return new PropTypeError(
                "Invalid " + location2 + " `" + propFullName + "` key `" + key + "` supplied to `" + componentName + "`.\nBad object: " + JSON.stringify(props[propName], null, "  ") + `
Valid keys: ` + JSON.stringify(Object.keys(shapeTypes), null, "  ")
              );
            var error = checker(propValue, key, componentName, location2, propFullName + "." + key, ReactPropTypesSecret);
            if (error)
              return error;
          }
          return null;
        }
        return createChainableTypeChecker(validate5);
      }
      function isNode(propValue) {
        switch (typeof propValue) {
          case "number":
          case "string":
          case "undefined":
            return !0;
          case "boolean":
            return !propValue;
          case "object":
            if (Array.isArray(propValue))
              return propValue.every(isNode);
            if (propValue === null || isValidElement(propValue))
              return !0;
            var iteratorFn = getIteratorFn(propValue);
            if (iteratorFn) {
              var iterator = iteratorFn.call(propValue), step;
              if (iteratorFn !== propValue.entries) {
                for (; !(step = iterator.next()).done; )
                  if (!isNode(step.value))
                    return !1;
              } else
                for (; !(step = iterator.next()).done; ) {
                  var entry = step.value;
                  if (entry && !isNode(entry[1]))
                    return !1;
                }
            } else
              return !1;
            return !0;
          default:
            return !1;
        }
      }
      function isSymbol(propType, propValue) {
        return propType === "symbol" ? !0 : propValue ? propValue["@@toStringTag"] === "Symbol" || typeof Symbol == "function" && propValue instanceof Symbol : !1;
      }
      function getPropType(propValue) {
        var propType = typeof propValue;
        return Array.isArray(propValue) ? "array" : propValue instanceof RegExp ? "object" : isSymbol(propType, propValue) ? "symbol" : propType;
      }
      function getPreciseType(propValue) {
        if (typeof propValue > "u" || propValue === null)
          return "" + propValue;
        var propType = getPropType(propValue);
        if (propType === "object") {
          if (propValue instanceof Date)
            return "date";
          if (propValue instanceof RegExp)
            return "regexp";
        }
        return propType;
      }
      function getPostfixForTypeWarning(value) {
        var type = getPreciseType(value);
        switch (type) {
          case "array":
          case "object":
            return "an " + type;
          case "boolean":
          case "date":
          case "regexp":
            return "a " + type;
          default:
            return type;
        }
      }
      function getClassName(propValue) {
        return !propValue.constructor || !propValue.constructor.name ? ANONYMOUS : propValue.constructor.name;
      }
      return ReactPropTypes.checkPropTypes = checkPropTypes, ReactPropTypes.resetWarningCache = checkPropTypes.resetWarningCache, ReactPropTypes.PropTypes = ReactPropTypes, ReactPropTypes;
    };
  }
});

// ../../node_modules/.pnpm/prop-types@15.8.1/node_modules/prop-types/factoryWithThrowingShims.js
var require_factoryWithThrowingShims = __commonJS({
  "../../node_modules/.pnpm/prop-types@15.8.1/node_modules/prop-types/factoryWithThrowingShims.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var ReactPropTypesSecret = require_ReactPropTypesSecret();
    function emptyFunction() {
    }
    function emptyFunctionWithReset() {
    }
    emptyFunctionWithReset.resetWarningCache = emptyFunction;
    module.exports = function() {
      function shim(props, propName, componentName, location2, propFullName, secret) {
        if (secret !== ReactPropTypesSecret) {
          var err2 = new Error(
            "Calling PropTypes validators directly is not supported by the `prop-types` package. Use PropTypes.checkPropTypes() to call them. Read more at http://fb.me/use-check-prop-types"
          );
          throw err2.name = "Invariant Violation", err2;
        }
      }
      shim.isRequired = shim;
      function getShim() {
        return shim;
      }
      var ReactPropTypes = {
        array: shim,
        bigint: shim,
        bool: shim,
        func: shim,
        number: shim,
        object: shim,
        string: shim,
        symbol: shim,
        any: shim,
        arrayOf: getShim,
        element: shim,
        elementType: shim,
        instanceOf: getShim,
        node: shim,
        objectOf: getShim,
        oneOf: getShim,
        oneOfType: getShim,
        shape: getShim,
        exact: getShim,
        checkPropTypes: emptyFunctionWithReset,
        resetWarningCache: emptyFunction
      };
      return ReactPropTypes.PropTypes = ReactPropTypes, ReactPropTypes;
    };
  }
});

// ../../node_modules/.pnpm/prop-types@15.8.1/node_modules/prop-types/index.js
var require_prop_types = __commonJS({
  "../../node_modules/.pnpm/prop-types@15.8.1/node_modules/prop-types/index.js"(exports, module) {
    init_cjs_shims();
    process.env.NODE_ENV !== "production" ? (ReactIs = require_react_is(), throwOnDirectAccess = !0, module.exports = require_factoryWithTypeCheckers()(ReactIs.isElement, throwOnDirectAccess)) : module.exports = require_factoryWithThrowingShims()();
    var ReactIs, throwOnDirectAccess;
  }
});

// ../../node_modules/.pnpm/@babel+runtime@7.24.5/node_modules/@babel/runtime/helpers/interopRequireDefault.js
var require_interopRequireDefault = __commonJS({
  "../../node_modules/.pnpm/@babel+runtime@7.24.5/node_modules/@babel/runtime/helpers/interopRequireDefault.js"(exports, module) {
    init_cjs_shims();
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        default: obj
      };
    }
    module.exports = _interopRequireDefault, module.exports.__esModule = !0, module.exports.default = module.exports;
  }
});

// ../../node_modules/.pnpm/dom-helpers@5.2.1/node_modules/dom-helpers/cjs/hasClass.js
var require_hasClass = __commonJS({
  "../../node_modules/.pnpm/dom-helpers@5.2.1/node_modules/dom-helpers/cjs/hasClass.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    exports.__esModule = !0;
    exports.default = hasClass;
    function hasClass(element, className) {
      return element.classList ? !!className && element.classList.contains(className) : (" " + (element.className.baseVal || element.className) + " ").indexOf(" " + className + " ") !== -1;
    }
    module.exports = exports.default;
  }
});

// ../../node_modules/.pnpm/dom-helpers@5.2.1/node_modules/dom-helpers/cjs/addClass.js
var require_addClass = __commonJS({
  "../../node_modules/.pnpm/dom-helpers@5.2.1/node_modules/dom-helpers/cjs/addClass.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var _interopRequireDefault = require_interopRequireDefault();
    exports.__esModule = !0;
    exports.default = addClass;
    var _hasClass = _interopRequireDefault(require_hasClass());
    function addClass(element, className) {
      element.classList ? element.classList.add(className) : (0, _hasClass.default)(element, className) || (typeof element.className == "string" ? element.className = element.className + " " + className : element.setAttribute("class", (element.className && element.className.baseVal || "") + " " + className));
    }
    module.exports = exports.default;
  }
});

// ../../node_modules/.pnpm/dom-helpers@5.2.1/node_modules/dom-helpers/cjs/removeClass.js
var require_removeClass = __commonJS({
  "../../node_modules/.pnpm/dom-helpers@5.2.1/node_modules/dom-helpers/cjs/removeClass.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    exports.__esModule = !0;
    exports.default = removeClass;
    function replaceClassName(origClass, classToRemove) {
      return origClass.replace(new RegExp("(^|\\s)" + classToRemove + "(?:\\s|$)", "g"), "$1").replace(/\s+/g, " ").replace(/^\s*|\s*$/g, "");
    }
    function removeClass(element, className) {
      element.classList ? element.classList.remove(className) : typeof element.className == "string" ? element.className = replaceClassName(element.className, className) : element.setAttribute("class", replaceClassName(element.className && element.className.baseVal || "", className));
    }
    module.exports = exports.default;
  }
});

// ../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/config.js
var require_config2 = __commonJS({
  "../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/config.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    exports.__esModule = !0;
    exports.default = void 0;
    var _default = {
      disabled: !1
    };
    exports.default = _default;
    module.exports = exports.default;
  }
});

// ../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/utils/PropTypes.js
var require_PropTypes = __commonJS({
  "../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/utils/PropTypes.js"(exports) {
    "use strict";
    init_cjs_shims();
    exports.__esModule = !0;
    exports.classNamesShape = exports.timeoutsShape = void 0;
    var _propTypes = _interopRequireDefault(require_prop_types());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    var timeoutsShape = process.env.NODE_ENV !== "production" ? _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.shape({
      enter: _propTypes.default.number,
      exit: _propTypes.default.number,
      appear: _propTypes.default.number
    }).isRequired]) : null;
    exports.timeoutsShape = timeoutsShape;
    var classNamesShape = process.env.NODE_ENV !== "production" ? _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.shape({
      enter: _propTypes.default.string,
      exit: _propTypes.default.string,
      active: _propTypes.default.string
    }), _propTypes.default.shape({
      enter: _propTypes.default.string,
      enterDone: _propTypes.default.string,
      enterActive: _propTypes.default.string,
      exit: _propTypes.default.string,
      exitDone: _propTypes.default.string,
      exitActive: _propTypes.default.string
    })]) : null;
    exports.classNamesShape = classNamesShape;
  }
});

// ../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/TransitionGroupContext.js
var require_TransitionGroupContext = __commonJS({
  "../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/TransitionGroupContext.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    exports.__esModule = !0;
    exports.default = void 0;
    var _react = _interopRequireDefault(require_react());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    var _default = _react.default.createContext(null);
    exports.default = _default;
    module.exports = exports.default;
  }
});

// ../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/utils/reflow.js
var require_reflow = __commonJS({
  "../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/utils/reflow.js"(exports) {
    "use strict";
    init_cjs_shims();
    exports.__esModule = !0;
    exports.forceReflow = void 0;
    var forceReflow = function(node) {
      return node.scrollTop;
    };
    exports.forceReflow = forceReflow;
  }
});

// ../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/Transition.js
var require_Transition = __commonJS({
  "../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/Transition.js"(exports) {
    "use strict";
    init_cjs_shims();
    exports.__esModule = !0;
    exports.default = exports.EXITING = exports.ENTERED = exports.ENTERING = exports.EXITED = exports.UNMOUNTED = void 0;
    var _propTypes = _interopRequireDefault(require_prop_types()), _react = _interopRequireDefault(require_react()), _reactDom = _interopRequireDefault(require_react_dom()), _config = _interopRequireDefault(require_config2()), _PropTypes = require_PropTypes(), _TransitionGroupContext = _interopRequireDefault(require_TransitionGroupContext()), _reflow = require_reflow();
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function _objectWithoutPropertiesLoose(source, excluded) {
      if (source == null)
        return {};
      var target = {}, sourceKeys = Object.keys(source), key, i;
      for (i = 0; i < sourceKeys.length; i++)
        key = sourceKeys[i], !(excluded.indexOf(key) >= 0) && (target[key] = source[key]);
      return target;
    }
    function _inheritsLoose(subClass, superClass) {
      subClass.prototype = Object.create(superClass.prototype), subClass.prototype.constructor = subClass, subClass.__proto__ = superClass;
    }
    var UNMOUNTED = "unmounted";
    exports.UNMOUNTED = UNMOUNTED;
    var EXITED = "exited";
    exports.EXITED = EXITED;
    var ENTERING = "entering";
    exports.ENTERING = ENTERING;
    var ENTERED = "entered";
    exports.ENTERED = ENTERED;
    var EXITING = "exiting";
    exports.EXITING = EXITING;
    var Transition = /* @__PURE__ */ function(_React$Component) {
      _inheritsLoose(Transition2, _React$Component);
      function Transition2(props, context) {
        var _this;
        _this = _React$Component.call(this, props, context) || this;
        var parentGroup = context, appear = parentGroup && !parentGroup.isMounting ? props.enter : props.appear, initialStatus;
        return _this.appearStatus = null, props.in ? appear ? (initialStatus = EXITED, _this.appearStatus = ENTERING) : initialStatus = ENTERED : props.unmountOnExit || props.mountOnEnter ? initialStatus = UNMOUNTED : initialStatus = EXITED, _this.state = {
          status: initialStatus
        }, _this.nextCallback = null, _this;
      }
      Transition2.getDerivedStateFromProps = function(_ref, prevState) {
        var nextIn = _ref.in;
        return nextIn && prevState.status === UNMOUNTED ? {
          status: EXITED
        } : null;
      };
      var _proto = Transition2.prototype;
      return _proto.componentDidMount = function() {
        this.updateStatus(!0, this.appearStatus);
      }, _proto.componentDidUpdate = function(prevProps) {
        var nextStatus = null;
        if (prevProps !== this.props) {
          var status = this.state.status;
          this.props.in ? status !== ENTERING && status !== ENTERED && (nextStatus = ENTERING) : (status === ENTERING || status === ENTERED) && (nextStatus = EXITING);
        }
        this.updateStatus(!1, nextStatus);
      }, _proto.componentWillUnmount = function() {
        this.cancelNextCallback();
      }, _proto.getTimeouts = function() {
        var timeout = this.props.timeout, exit, enter, appear;
        return exit = enter = appear = timeout, timeout != null && typeof timeout != "number" && (exit = timeout.exit, enter = timeout.enter, appear = timeout.appear !== void 0 ? timeout.appear : enter), {
          exit,
          enter,
          appear
        };
      }, _proto.updateStatus = function(mounting, nextStatus) {
        if (mounting === void 0 && (mounting = !1), nextStatus !== null)
          if (this.cancelNextCallback(), nextStatus === ENTERING) {
            if (this.props.unmountOnExit || this.props.mountOnEnter) {
              var node = this.props.nodeRef ? this.props.nodeRef.current : _reactDom.default.findDOMNode(this);
              node && (0, _reflow.forceReflow)(node);
            }
            this.performEnter(mounting);
          } else
            this.performExit();
        else
          this.props.unmountOnExit && this.state.status === EXITED && this.setState({
            status: UNMOUNTED
          });
      }, _proto.performEnter = function(mounting) {
        var _this2 = this, enter = this.props.enter, appearing = this.context ? this.context.isMounting : mounting, _ref2 = this.props.nodeRef ? [appearing] : [_reactDom.default.findDOMNode(this), appearing], maybeNode = _ref2[0], maybeAppearing = _ref2[1], timeouts = this.getTimeouts(), enterTimeout = appearing ? timeouts.appear : timeouts.enter;
        if (!mounting && !enter || _config.default.disabled) {
          this.safeSetState({
            status: ENTERED
          }, function() {
            _this2.props.onEntered(maybeNode);
          });
          return;
        }
        this.props.onEnter(maybeNode, maybeAppearing), this.safeSetState({
          status: ENTERING
        }, function() {
          _this2.props.onEntering(maybeNode, maybeAppearing), _this2.onTransitionEnd(enterTimeout, function() {
            _this2.safeSetState({
              status: ENTERED
            }, function() {
              _this2.props.onEntered(maybeNode, maybeAppearing);
            });
          });
        });
      }, _proto.performExit = function() {
        var _this3 = this, exit = this.props.exit, timeouts = this.getTimeouts(), maybeNode = this.props.nodeRef ? void 0 : _reactDom.default.findDOMNode(this);
        if (!exit || _config.default.disabled) {
          this.safeSetState({
            status: EXITED
          }, function() {
            _this3.props.onExited(maybeNode);
          });
          return;
        }
        this.props.onExit(maybeNode), this.safeSetState({
          status: EXITING
        }, function() {
          _this3.props.onExiting(maybeNode), _this3.onTransitionEnd(timeouts.exit, function() {
            _this3.safeSetState({
              status: EXITED
            }, function() {
              _this3.props.onExited(maybeNode);
            });
          });
        });
      }, _proto.cancelNextCallback = function() {
        this.nextCallback !== null && (this.nextCallback.cancel(), this.nextCallback = null);
      }, _proto.safeSetState = function(nextState, callback) {
        callback = this.setNextCallback(callback), this.setState(nextState, callback);
      }, _proto.setNextCallback = function(callback) {
        var _this4 = this, active = !0;
        return this.nextCallback = function(event) {
          active && (active = !1, _this4.nextCallback = null, callback(event));
        }, this.nextCallback.cancel = function() {
          active = !1;
        }, this.nextCallback;
      }, _proto.onTransitionEnd = function(timeout, handler) {
        this.setNextCallback(handler);
        var node = this.props.nodeRef ? this.props.nodeRef.current : _reactDom.default.findDOMNode(this), doesNotHaveTimeoutOrListener = timeout == null && !this.props.addEndListener;
        if (!node || doesNotHaveTimeoutOrListener) {
          setTimeout(this.nextCallback, 0);
          return;
        }
        if (this.props.addEndListener) {
          var _ref3 = this.props.nodeRef ? [this.nextCallback] : [node, this.nextCallback], maybeNode = _ref3[0], maybeNextCallback = _ref3[1];
          this.props.addEndListener(maybeNode, maybeNextCallback);
        }
        timeout != null && setTimeout(this.nextCallback, timeout);
      }, _proto.render = function() {
        var status = this.state.status;
        if (status === UNMOUNTED)
          return null;
        var _this$props = this.props, children = _this$props.children, _in = _this$props.in, _mountOnEnter = _this$props.mountOnEnter, _unmountOnExit = _this$props.unmountOnExit, _appear = _this$props.appear, _enter = _this$props.enter, _exit = _this$props.exit, _timeout = _this$props.timeout, _addEndListener = _this$props.addEndListener, _onEnter = _this$props.onEnter, _onEntering = _this$props.onEntering, _onEntered = _this$props.onEntered, _onExit = _this$props.onExit, _onExiting = _this$props.onExiting, _onExited = _this$props.onExited, _nodeRef = _this$props.nodeRef, childProps = _objectWithoutPropertiesLoose(_this$props, ["children", "in", "mountOnEnter", "unmountOnExit", "appear", "enter", "exit", "timeout", "addEndListener", "onEnter", "onEntering", "onEntered", "onExit", "onExiting", "onExited", "nodeRef"]);
        return (
          // allows for nested Transitions
          /* @__PURE__ */ _react.default.createElement(_TransitionGroupContext.default.Provider, {
            value: null
          }, typeof children == "function" ? children(status, childProps) : _react.default.cloneElement(_react.default.Children.only(children), childProps))
        );
      }, Transition2;
    }(_react.default.Component);
    Transition.contextType = _TransitionGroupContext.default;
    Transition.propTypes = process.env.NODE_ENV !== "production" ? {
      /**
       * A React reference to DOM element that need to transition:
       * https://stackoverflow.com/a/51127130/4671932
       *
       *   - When `nodeRef` prop is used, `node` is not passed to callback functions
       *      (e.g. `onEnter`) because user already has direct access to the node.
       *   - When changing `key` prop of `Transition` in a `TransitionGroup` a new
       *     `nodeRef` need to be provided to `Transition` with changed `key` prop
       *     (see
       *     [test/CSSTransition-test.js](https://github.com/reactjs/react-transition-group/blob/13435f897b3ab71f6e19d724f145596f5910581c/test/CSSTransition-test.js#L362-L437)).
       */
      nodeRef: _propTypes.default.shape({
        current: typeof Element > "u" ? _propTypes.default.any : function(propValue, key, componentName, location2, propFullName, secret) {
          var value = propValue[key];
          return _propTypes.default.instanceOf(value && "ownerDocument" in value ? value.ownerDocument.defaultView.Element : Element)(propValue, key, componentName, location2, propFullName, secret);
        }
      }),
      /**
       * A `function` child can be used instead of a React element. This function is
       * called with the current transition status (`'entering'`, `'entered'`,
       * `'exiting'`, `'exited'`), which can be used to apply context
       * specific props to a component.
       *
       * ```jsx
       * <Transition in={this.state.in} timeout={150}>
       *   {state => (
       *     <MyComponent className={`fade fade-${state}`} />
       *   )}
       * </Transition>
       * ```
       */
      children: _propTypes.default.oneOfType([_propTypes.default.func.isRequired, _propTypes.default.element.isRequired]).isRequired,
      /**
       * Show the component; triggers the enter or exit states
       */
      in: _propTypes.default.bool,
      /**
       * By default the child component is mounted immediately along with
       * the parent `Transition` component. If you want to "lazy mount" the component on the
       * first `in={true}` you can set `mountOnEnter`. After the first enter transition the component will stay
       * mounted, even on "exited", unless you also specify `unmountOnExit`.
       */
      mountOnEnter: _propTypes.default.bool,
      /**
       * By default the child component stays mounted after it reaches the `'exited'` state.
       * Set `unmountOnExit` if you'd prefer to unmount the component after it finishes exiting.
       */
      unmountOnExit: _propTypes.default.bool,
      /**
       * By default the child component does not perform the enter transition when
       * it first mounts, regardless of the value of `in`. If you want this
       * behavior, set both `appear` and `in` to `true`.
       *
       * > **Note**: there are no special appear states like `appearing`/`appeared`, this prop
       * > only adds an additional enter transition. However, in the
       * > `<CSSTransition>` component that first enter transition does result in
       * > additional `.appear-*` classes, that way you can choose to style it
       * > differently.
       */
      appear: _propTypes.default.bool,
      /**
       * Enable or disable enter transitions.
       */
      enter: _propTypes.default.bool,
      /**
       * Enable or disable exit transitions.
       */
      exit: _propTypes.default.bool,
      /**
       * The duration of the transition, in milliseconds.
       * Required unless `addEndListener` is provided.
       *
       * You may specify a single timeout for all transitions:
       *
       * ```jsx
       * timeout={500}
       * ```
       *
       * or individually:
       *
       * ```jsx
       * timeout={{
       *  appear: 500,
       *  enter: 300,
       *  exit: 500,
       * }}
       * ```
       *
       * - `appear` defaults to the value of `enter`
       * - `enter` defaults to `0`
       * - `exit` defaults to `0`
       *
       * @type {number | { enter?: number, exit?: number, appear?: number }}
       */
      timeout: function(props) {
        var pt = _PropTypes.timeoutsShape;
        props.addEndListener || (pt = pt.isRequired);
        for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++)
          args[_key - 1] = arguments[_key];
        return pt.apply(void 0, [props].concat(args));
      },
      /**
       * Add a custom transition end trigger. Called with the transitioning
       * DOM node and a `done` callback. Allows for more fine grained transition end
       * logic. Timeouts are still used as a fallback if provided.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * ```jsx
       * addEndListener={(node, done) => {
       *   // use the css transitionend event to mark the finish of a transition
       *   node.addEventListener('transitionend', done, false);
       * }}
       * ```
       */
      addEndListener: _propTypes.default.func,
      /**
       * Callback fired before the "entering" status is applied. An extra parameter
       * `isAppearing` is supplied to indicate if the enter stage is occurring on the initial mount
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * @type Function(node: HtmlElement, isAppearing: bool) -> void
       */
      onEnter: _propTypes.default.func,
      /**
       * Callback fired after the "entering" status is applied. An extra parameter
       * `isAppearing` is supplied to indicate if the enter stage is occurring on the initial mount
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * @type Function(node: HtmlElement, isAppearing: bool)
       */
      onEntering: _propTypes.default.func,
      /**
       * Callback fired after the "entered" status is applied. An extra parameter
       * `isAppearing` is supplied to indicate if the enter stage is occurring on the initial mount
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * @type Function(node: HtmlElement, isAppearing: bool) -> void
       */
      onEntered: _propTypes.default.func,
      /**
       * Callback fired before the "exiting" status is applied.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * @type Function(node: HtmlElement) -> void
       */
      onExit: _propTypes.default.func,
      /**
       * Callback fired after the "exiting" status is applied.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * @type Function(node: HtmlElement) -> void
       */
      onExiting: _propTypes.default.func,
      /**
       * Callback fired after the "exited" status is applied.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed
       *
       * @type Function(node: HtmlElement) -> void
       */
      onExited: _propTypes.default.func
    } : {};
    function noop() {
    }
    Transition.defaultProps = {
      in: !1,
      mountOnEnter: !1,
      unmountOnExit: !1,
      appear: !1,
      enter: !0,
      exit: !0,
      onEnter: noop,
      onEntering: noop,
      onEntered: noop,
      onExit: noop,
      onExiting: noop,
      onExited: noop
    };
    Transition.UNMOUNTED = UNMOUNTED;
    Transition.EXITED = EXITED;
    Transition.ENTERING = ENTERING;
    Transition.ENTERED = ENTERED;
    Transition.EXITING = EXITING;
    var _default = Transition;
    exports.default = _default;
  }
});

// ../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/CSSTransition.js
var require_CSSTransition = __commonJS({
  "../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/CSSTransition.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    exports.__esModule = !0;
    exports.default = void 0;
    var _propTypes = _interopRequireDefault(require_prop_types()), _addClass2 = _interopRequireDefault(require_addClass()), _removeClass = _interopRequireDefault(require_removeClass()), _react = _interopRequireDefault(require_react()), _Transition = _interopRequireDefault(require_Transition()), _PropTypes = require_PropTypes(), _reflow = require_reflow();
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function _extends() {
      return _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];
          for (var key in source)
            Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
        }
        return target;
      }, _extends.apply(this, arguments);
    }
    function _objectWithoutPropertiesLoose(source, excluded) {
      if (source == null)
        return {};
      var target = {}, sourceKeys = Object.keys(source), key, i;
      for (i = 0; i < sourceKeys.length; i++)
        key = sourceKeys[i], !(excluded.indexOf(key) >= 0) && (target[key] = source[key]);
      return target;
    }
    function _inheritsLoose(subClass, superClass) {
      subClass.prototype = Object.create(superClass.prototype), subClass.prototype.constructor = subClass, subClass.__proto__ = superClass;
    }
    var _addClass = function(node, classes) {
      return node && classes && classes.split(" ").forEach(function(c) {
        return (0, _addClass2.default)(node, c);
      });
    }, removeClass = function(node, classes) {
      return node && classes && classes.split(" ").forEach(function(c) {
        return (0, _removeClass.default)(node, c);
      });
    }, CSSTransition = /* @__PURE__ */ function(_React$Component) {
      _inheritsLoose(CSSTransition2, _React$Component);
      function CSSTransition2() {
        for (var _this, _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++)
          args[_key] = arguments[_key];
        return _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this, _this.appliedClasses = {
          appear: {},
          enter: {},
          exit: {}
        }, _this.onEnter = function(maybeNode, maybeAppearing) {
          var _this$resolveArgument = _this.resolveArguments(maybeNode, maybeAppearing), node = _this$resolveArgument[0], appearing = _this$resolveArgument[1];
          _this.removeClasses(node, "exit"), _this.addClass(node, appearing ? "appear" : "enter", "base"), _this.props.onEnter && _this.props.onEnter(maybeNode, maybeAppearing);
        }, _this.onEntering = function(maybeNode, maybeAppearing) {
          var _this$resolveArgument2 = _this.resolveArguments(maybeNode, maybeAppearing), node = _this$resolveArgument2[0], appearing = _this$resolveArgument2[1], type = appearing ? "appear" : "enter";
          _this.addClass(node, type, "active"), _this.props.onEntering && _this.props.onEntering(maybeNode, maybeAppearing);
        }, _this.onEntered = function(maybeNode, maybeAppearing) {
          var _this$resolveArgument3 = _this.resolveArguments(maybeNode, maybeAppearing), node = _this$resolveArgument3[0], appearing = _this$resolveArgument3[1], type = appearing ? "appear" : "enter";
          _this.removeClasses(node, type), _this.addClass(node, type, "done"), _this.props.onEntered && _this.props.onEntered(maybeNode, maybeAppearing);
        }, _this.onExit = function(maybeNode) {
          var _this$resolveArgument4 = _this.resolveArguments(maybeNode), node = _this$resolveArgument4[0];
          _this.removeClasses(node, "appear"), _this.removeClasses(node, "enter"), _this.addClass(node, "exit", "base"), _this.props.onExit && _this.props.onExit(maybeNode);
        }, _this.onExiting = function(maybeNode) {
          var _this$resolveArgument5 = _this.resolveArguments(maybeNode), node = _this$resolveArgument5[0];
          _this.addClass(node, "exit", "active"), _this.props.onExiting && _this.props.onExiting(maybeNode);
        }, _this.onExited = function(maybeNode) {
          var _this$resolveArgument6 = _this.resolveArguments(maybeNode), node = _this$resolveArgument6[0];
          _this.removeClasses(node, "exit"), _this.addClass(node, "exit", "done"), _this.props.onExited && _this.props.onExited(maybeNode);
        }, _this.resolveArguments = function(maybeNode, maybeAppearing) {
          return _this.props.nodeRef ? [_this.props.nodeRef.current, maybeNode] : [maybeNode, maybeAppearing];
        }, _this.getClassNames = function(type) {
          var classNames = _this.props.classNames, isStringClassNames = typeof classNames == "string", prefix = isStringClassNames && classNames ? classNames + "-" : "", baseClassName = isStringClassNames ? "" + prefix + type : classNames[type], activeClassName = isStringClassNames ? baseClassName + "-active" : classNames[type + "Active"], doneClassName = isStringClassNames ? baseClassName + "-done" : classNames[type + "Done"];
          return {
            baseClassName,
            activeClassName,
            doneClassName
          };
        }, _this;
      }
      var _proto = CSSTransition2.prototype;
      return _proto.addClass = function(node, type, phase) {
        var className = this.getClassNames(type)[phase + "ClassName"], _this$getClassNames = this.getClassNames("enter"), doneClassName = _this$getClassNames.doneClassName;
        type === "appear" && phase === "done" && doneClassName && (className += " " + doneClassName), phase === "active" && node && (0, _reflow.forceReflow)(node), className && (this.appliedClasses[type][phase] = className, _addClass(node, className));
      }, _proto.removeClasses = function(node, type) {
        var _this$appliedClasses$ = this.appliedClasses[type], baseClassName = _this$appliedClasses$.base, activeClassName = _this$appliedClasses$.active, doneClassName = _this$appliedClasses$.done;
        this.appliedClasses[type] = {}, baseClassName && removeClass(node, baseClassName), activeClassName && removeClass(node, activeClassName), doneClassName && removeClass(node, doneClassName);
      }, _proto.render = function() {
        var _this$props = this.props, _2 = _this$props.classNames, props = _objectWithoutPropertiesLoose(_this$props, ["classNames"]);
        return /* @__PURE__ */ _react.default.createElement(_Transition.default, _extends({}, props, {
          onEnter: this.onEnter,
          onEntered: this.onEntered,
          onEntering: this.onEntering,
          onExit: this.onExit,
          onExiting: this.onExiting,
          onExited: this.onExited
        }));
      }, CSSTransition2;
    }(_react.default.Component);
    CSSTransition.defaultProps = {
      classNames: ""
    };
    CSSTransition.propTypes = process.env.NODE_ENV !== "production" ? _extends({}, _Transition.default.propTypes, {
      /**
       * The animation classNames applied to the component as it appears, enters,
       * exits or has finished the transition. A single name can be provided, which
       * will be suffixed for each stage, e.g. `classNames="fade"` applies:
       *
       * - `fade-appear`, `fade-appear-active`, `fade-appear-done`
       * - `fade-enter`, `fade-enter-active`, `fade-enter-done`
       * - `fade-exit`, `fade-exit-active`, `fade-exit-done`
       *
       * A few details to note about how these classes are applied:
       *
       * 1. They are _joined_ with the ones that are already defined on the child
       *    component, so if you want to add some base styles, you can use
       *    `className` without worrying that it will be overridden.
       *
       * 2. If the transition component mounts with `in={false}`, no classes are
       *    applied yet. You might be expecting `*-exit-done`, but if you think
       *    about it, a component cannot finish exiting if it hasn't entered yet.
       *
       * 2. `fade-appear-done` and `fade-enter-done` will _both_ be applied. This
       *    allows you to define different behavior for when appearing is done and
       *    when regular entering is done, using selectors like
       *    `.fade-enter-done:not(.fade-appear-done)`. For example, you could apply
       *    an epic entrance animation when element first appears in the DOM using
       *    [Animate.css](https://daneden.github.io/animate.css/). Otherwise you can
       *    simply use `fade-enter-done` for defining both cases.
       *
       * Each individual classNames can also be specified independently like:
       *
       * ```js
       * classNames={{
       *  appear: 'my-appear',
       *  appearActive: 'my-active-appear',
       *  appearDone: 'my-done-appear',
       *  enter: 'my-enter',
       *  enterActive: 'my-active-enter',
       *  enterDone: 'my-done-enter',
       *  exit: 'my-exit',
       *  exitActive: 'my-active-exit',
       *  exitDone: 'my-done-exit',
       * }}
       * ```
       *
       * If you want to set these classes using CSS Modules:
       *
       * ```js
       * import styles from './styles.css';
       * ```
       *
       * you might want to use camelCase in your CSS file, that way could simply
       * spread them instead of listing them one by one:
       *
       * ```js
       * classNames={{ ...styles }}
       * ```
       *
       * @type {string | {
       *  appear?: string,
       *  appearActive?: string,
       *  appearDone?: string,
       *  enter?: string,
       *  enterActive?: string,
       *  enterDone?: string,
       *  exit?: string,
       *  exitActive?: string,
       *  exitDone?: string,
       * }}
       */
      classNames: _PropTypes.classNamesShape,
      /**
       * A `<Transition>` callback fired immediately after the 'enter' or 'appear' class is
       * applied.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * @type Function(node: HtmlElement, isAppearing: bool)
       */
      onEnter: _propTypes.default.func,
      /**
       * A `<Transition>` callback fired immediately after the 'enter-active' or
       * 'appear-active' class is applied.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * @type Function(node: HtmlElement, isAppearing: bool)
       */
      onEntering: _propTypes.default.func,
      /**
       * A `<Transition>` callback fired immediately after the 'enter' or
       * 'appear' classes are **removed** and the `done` class is added to the DOM node.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed.
       *
       * @type Function(node: HtmlElement, isAppearing: bool)
       */
      onEntered: _propTypes.default.func,
      /**
       * A `<Transition>` callback fired immediately after the 'exit' class is
       * applied.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed
       *
       * @type Function(node: HtmlElement)
       */
      onExit: _propTypes.default.func,
      /**
       * A `<Transition>` callback fired immediately after the 'exit-active' is applied.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed
       *
       * @type Function(node: HtmlElement)
       */
      onExiting: _propTypes.default.func,
      /**
       * A `<Transition>` callback fired immediately after the 'exit' classes
       * are **removed** and the `exit-done` class is added to the DOM node.
       *
       * **Note**: when `nodeRef` prop is passed, `node` is not passed
       *
       * @type Function(node: HtmlElement)
       */
      onExited: _propTypes.default.func
    }) : {};
    var _default = CSSTransition;
    exports.default = _default;
    module.exports = exports.default;
  }
});

// ../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/utils/ChildMapping.js
var require_ChildMapping = __commonJS({
  "../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/utils/ChildMapping.js"(exports) {
    "use strict";
    init_cjs_shims();
    exports.__esModule = !0;
    exports.getChildMapping = getChildMapping;
    exports.mergeChildMappings = mergeChildMappings;
    exports.getInitialChildMapping = getInitialChildMapping;
    exports.getNextChildMapping = getNextChildMapping;
    var _react = require_react();
    function getChildMapping(children, mapFn) {
      var mapper = function(child) {
        return mapFn && (0, _react.isValidElement)(child) ? mapFn(child) : child;
      }, result = /* @__PURE__ */ Object.create(null);
      return children && _react.Children.map(children, function(c) {
        return c;
      }).forEach(function(child) {
        result[child.key] = mapper(child);
      }), result;
    }
    function mergeChildMappings(prev, next) {
      prev = prev || {}, next = next || {};
      function getValueForKey(key) {
        return key in next ? next[key] : prev[key];
      }
      var nextKeysPending = /* @__PURE__ */ Object.create(null), pendingKeys = [];
      for (var prevKey in prev)
        prevKey in next ? pendingKeys.length && (nextKeysPending[prevKey] = pendingKeys, pendingKeys = []) : pendingKeys.push(prevKey);
      var i, childMapping = {};
      for (var nextKey in next) {
        if (nextKeysPending[nextKey])
          for (i = 0; i < nextKeysPending[nextKey].length; i++) {
            var pendingNextKey = nextKeysPending[nextKey][i];
            childMapping[nextKeysPending[nextKey][i]] = getValueForKey(pendingNextKey);
          }
        childMapping[nextKey] = getValueForKey(nextKey);
      }
      for (i = 0; i < pendingKeys.length; i++)
        childMapping[pendingKeys[i]] = getValueForKey(pendingKeys[i]);
      return childMapping;
    }
    function getProp(child, prop, props) {
      return props[prop] != null ? props[prop] : child.props[prop];
    }
    function getInitialChildMapping(props, onExited) {
      return getChildMapping(props.children, function(child) {
        return (0, _react.cloneElement)(child, {
          onExited: onExited.bind(null, child),
          in: !0,
          appear: getProp(child, "appear", props),
          enter: getProp(child, "enter", props),
          exit: getProp(child, "exit", props)
        });
      });
    }
    function getNextChildMapping(nextProps, prevChildMapping, onExited) {
      var nextChildMapping = getChildMapping(nextProps.children), children = mergeChildMappings(prevChildMapping, nextChildMapping);
      return Object.keys(children).forEach(function(key) {
        var child = children[key];
        if ((0, _react.isValidElement)(child)) {
          var hasPrev = key in prevChildMapping, hasNext = key in nextChildMapping, prevChild = prevChildMapping[key], isLeaving = (0, _react.isValidElement)(prevChild) && !prevChild.props.in;
          hasNext && (!hasPrev || isLeaving) ? children[key] = (0, _react.cloneElement)(child, {
            onExited: onExited.bind(null, child),
            in: !0,
            exit: getProp(child, "exit", nextProps),
            enter: getProp(child, "enter", nextProps)
          }) : !hasNext && hasPrev && !isLeaving ? children[key] = (0, _react.cloneElement)(child, {
            in: !1
          }) : hasNext && hasPrev && (0, _react.isValidElement)(prevChild) && (children[key] = (0, _react.cloneElement)(child, {
            onExited: onExited.bind(null, child),
            in: prevChild.props.in,
            exit: getProp(child, "exit", nextProps),
            enter: getProp(child, "enter", nextProps)
          }));
        }
      }), children;
    }
  }
});

// ../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/TransitionGroup.js
var require_TransitionGroup = __commonJS({
  "../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/TransitionGroup.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    exports.__esModule = !0;
    exports.default = void 0;
    var _propTypes = _interopRequireDefault(require_prop_types()), _react = _interopRequireDefault(require_react()), _TransitionGroupContext = _interopRequireDefault(require_TransitionGroupContext()), _ChildMapping = require_ChildMapping();
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function _objectWithoutPropertiesLoose(source, excluded) {
      if (source == null)
        return {};
      var target = {}, sourceKeys = Object.keys(source), key, i;
      for (i = 0; i < sourceKeys.length; i++)
        key = sourceKeys[i], !(excluded.indexOf(key) >= 0) && (target[key] = source[key]);
      return target;
    }
    function _extends() {
      return _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];
          for (var key in source)
            Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
        }
        return target;
      }, _extends.apply(this, arguments);
    }
    function _assertThisInitialized(self2) {
      if (self2 === void 0)
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      return self2;
    }
    function _inheritsLoose(subClass, superClass) {
      subClass.prototype = Object.create(superClass.prototype), subClass.prototype.constructor = subClass, subClass.__proto__ = superClass;
    }
    var values = Object.values || function(obj) {
      return Object.keys(obj).map(function(k) {
        return obj[k];
      });
    }, defaultProps = {
      component: "div",
      childFactory: function(child) {
        return child;
      }
    }, TransitionGroup = /* @__PURE__ */ function(_React$Component) {
      _inheritsLoose(TransitionGroup2, _React$Component);
      function TransitionGroup2(props, context) {
        var _this;
        _this = _React$Component.call(this, props, context) || this;
        var handleExited = _this.handleExited.bind(_assertThisInitialized(_this));
        return _this.state = {
          contextValue: {
            isMounting: !0
          },
          handleExited,
          firstRender: !0
        }, _this;
      }
      var _proto = TransitionGroup2.prototype;
      return _proto.componentDidMount = function() {
        this.mounted = !0, this.setState({
          contextValue: {
            isMounting: !1
          }
        });
      }, _proto.componentWillUnmount = function() {
        this.mounted = !1;
      }, TransitionGroup2.getDerivedStateFromProps = function(nextProps, _ref) {
        var prevChildMapping = _ref.children, handleExited = _ref.handleExited, firstRender = _ref.firstRender;
        return {
          children: firstRender ? (0, _ChildMapping.getInitialChildMapping)(nextProps, handleExited) : (0, _ChildMapping.getNextChildMapping)(nextProps, prevChildMapping, handleExited),
          firstRender: !1
        };
      }, _proto.handleExited = function(child, node) {
        var currentChildMapping = (0, _ChildMapping.getChildMapping)(this.props.children);
        child.key in currentChildMapping || (child.props.onExited && child.props.onExited(node), this.mounted && this.setState(function(state) {
          var children = _extends({}, state.children);
          return delete children[child.key], {
            children
          };
        }));
      }, _proto.render = function() {
        var _this$props = this.props, Component = _this$props.component, childFactory = _this$props.childFactory, props = _objectWithoutPropertiesLoose(_this$props, ["component", "childFactory"]), contextValue = this.state.contextValue, children = values(this.state.children).map(childFactory);
        return delete props.appear, delete props.enter, delete props.exit, Component === null ? /* @__PURE__ */ _react.default.createElement(_TransitionGroupContext.default.Provider, {
          value: contextValue
        }, children) : /* @__PURE__ */ _react.default.createElement(_TransitionGroupContext.default.Provider, {
          value: contextValue
        }, /* @__PURE__ */ _react.default.createElement(Component, props, children));
      }, TransitionGroup2;
    }(_react.default.Component);
    TransitionGroup.propTypes = process.env.NODE_ENV !== "production" ? {
      /**
       * `<TransitionGroup>` renders a `<div>` by default. You can change this
       * behavior by providing a `component` prop.
       * If you use React v16+ and would like to avoid a wrapping `<div>` element
       * you can pass in `component={null}`. This is useful if the wrapping div
       * borks your css styles.
       */
      component: _propTypes.default.any,
      /**
       * A set of `<Transition>` components, that are toggled `in` and out as they
       * leave. the `<TransitionGroup>` will inject specific transition props, so
       * remember to spread them through if you are wrapping the `<Transition>` as
       * with our `<Fade>` example.
       *
       * While this component is meant for multiple `Transition` or `CSSTransition`
       * children, sometimes you may want to have a single transition child with
       * content that you want to be transitioned out and in when you change it
       * (e.g. routes, images etc.) In that case you can change the `key` prop of
       * the transition child as you change its content, this will cause
       * `TransitionGroup` to transition the child out and back in.
       */
      children: _propTypes.default.node,
      /**
       * A convenience prop that enables or disables appear animations
       * for all children. Note that specifying this will override any defaults set
       * on individual children Transitions.
       */
      appear: _propTypes.default.bool,
      /**
       * A convenience prop that enables or disables enter animations
       * for all children. Note that specifying this will override any defaults set
       * on individual children Transitions.
       */
      enter: _propTypes.default.bool,
      /**
       * A convenience prop that enables or disables exit animations
       * for all children. Note that specifying this will override any defaults set
       * on individual children Transitions.
       */
      exit: _propTypes.default.bool,
      /**
       * You may need to apply reactive updates to a child as it is exiting.
       * This is generally done by using `cloneElement` however in the case of an exiting
       * child the element has already been removed and not accessible to the consumer.
       *
       * If you do need to update a child as it leaves you can provide a `childFactory`
       * to wrap every child, even the ones that are leaving.
       *
       * @type Function(child: ReactElement) -> ReactElement
       */
      childFactory: _propTypes.default.func
    } : {};
    TransitionGroup.defaultProps = defaultProps;
    var _default = TransitionGroup;
    exports.default = _default;
    module.exports = exports.default;
  }
});

// ../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/ReplaceTransition.js
var require_ReplaceTransition = __commonJS({
  "../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/ReplaceTransition.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    exports.__esModule = !0;
    exports.default = void 0;
    var _propTypes = _interopRequireDefault(require_prop_types()), _react = _interopRequireDefault(require_react()), _reactDom = _interopRequireDefault(require_react_dom()), _TransitionGroup = _interopRequireDefault(require_TransitionGroup());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function _objectWithoutPropertiesLoose(source, excluded) {
      if (source == null)
        return {};
      var target = {}, sourceKeys = Object.keys(source), key, i;
      for (i = 0; i < sourceKeys.length; i++)
        key = sourceKeys[i], !(excluded.indexOf(key) >= 0) && (target[key] = source[key]);
      return target;
    }
    function _inheritsLoose(subClass, superClass) {
      subClass.prototype = Object.create(superClass.prototype), subClass.prototype.constructor = subClass, subClass.__proto__ = superClass;
    }
    var ReplaceTransition = /* @__PURE__ */ function(_React$Component) {
      _inheritsLoose(ReplaceTransition2, _React$Component);
      function ReplaceTransition2() {
        for (var _this, _len = arguments.length, _args = new Array(_len), _key = 0; _key < _len; _key++)
          _args[_key] = arguments[_key];
        return _this = _React$Component.call.apply(_React$Component, [this].concat(_args)) || this, _this.handleEnter = function() {
          for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++)
            args[_key2] = arguments[_key2];
          return _this.handleLifecycle("onEnter", 0, args);
        }, _this.handleEntering = function() {
          for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++)
            args[_key3] = arguments[_key3];
          return _this.handleLifecycle("onEntering", 0, args);
        }, _this.handleEntered = function() {
          for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++)
            args[_key4] = arguments[_key4];
          return _this.handleLifecycle("onEntered", 0, args);
        }, _this.handleExit = function() {
          for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++)
            args[_key5] = arguments[_key5];
          return _this.handleLifecycle("onExit", 1, args);
        }, _this.handleExiting = function() {
          for (var _len6 = arguments.length, args = new Array(_len6), _key6 = 0; _key6 < _len6; _key6++)
            args[_key6] = arguments[_key6];
          return _this.handleLifecycle("onExiting", 1, args);
        }, _this.handleExited = function() {
          for (var _len7 = arguments.length, args = new Array(_len7), _key7 = 0; _key7 < _len7; _key7++)
            args[_key7] = arguments[_key7];
          return _this.handleLifecycle("onExited", 1, args);
        }, _this;
      }
      var _proto = ReplaceTransition2.prototype;
      return _proto.handleLifecycle = function(handler, idx, originalArgs) {
        var _child$props, children = this.props.children, child = _react.default.Children.toArray(children)[idx];
        if (child.props[handler] && (_child$props = child.props)[handler].apply(_child$props, originalArgs), this.props[handler]) {
          var maybeNode = child.props.nodeRef ? void 0 : _reactDom.default.findDOMNode(this);
          this.props[handler](maybeNode);
        }
      }, _proto.render = function() {
        var _this$props = this.props, children = _this$props.children, inProp = _this$props.in, props = _objectWithoutPropertiesLoose(_this$props, ["children", "in"]), _React$Children$toArr = _react.default.Children.toArray(children), first = _React$Children$toArr[0], second = _React$Children$toArr[1];
        return delete props.onEnter, delete props.onEntering, delete props.onEntered, delete props.onExit, delete props.onExiting, delete props.onExited, /* @__PURE__ */ _react.default.createElement(_TransitionGroup.default, props, inProp ? _react.default.cloneElement(first, {
          key: "first",
          onEnter: this.handleEnter,
          onEntering: this.handleEntering,
          onEntered: this.handleEntered
        }) : _react.default.cloneElement(second, {
          key: "second",
          onEnter: this.handleExit,
          onEntering: this.handleExiting,
          onEntered: this.handleExited
        }));
      }, ReplaceTransition2;
    }(_react.default.Component);
    ReplaceTransition.propTypes = process.env.NODE_ENV !== "production" ? {
      in: _propTypes.default.bool.isRequired,
      children: function(props, propName) {
        return _react.default.Children.count(props[propName]) !== 2 ? new Error('"' + propName + '" must be exactly two transition components.') : null;
      }
    } : {};
    var _default = ReplaceTransition;
    exports.default = _default;
    module.exports = exports.default;
  }
});

// ../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/SwitchTransition.js
var require_SwitchTransition = __commonJS({
  "../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/SwitchTransition.js"(exports) {
    "use strict";
    init_cjs_shims();
    exports.__esModule = !0;
    exports.default = exports.modes = void 0;
    var _react = _interopRequireDefault(require_react()), _propTypes = _interopRequireDefault(require_prop_types()), _Transition = require_Transition(), _TransitionGroupContext = _interopRequireDefault(require_TransitionGroupContext()), _leaveRenders, _enterRenders;
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
    function _inheritsLoose(subClass, superClass) {
      subClass.prototype = Object.create(superClass.prototype), subClass.prototype.constructor = subClass, subClass.__proto__ = superClass;
    }
    function areChildrenDifferent(oldChildren, newChildren) {
      return !(oldChildren === newChildren || _react.default.isValidElement(oldChildren) && _react.default.isValidElement(newChildren) && oldChildren.key != null && oldChildren.key === newChildren.key);
    }
    var modes = {
      out: "out-in",
      in: "in-out"
    };
    exports.modes = modes;
    var callHook = function(element, name, cb) {
      return function() {
        var _element$props;
        element.props[name] && (_element$props = element.props)[name].apply(_element$props, arguments), cb();
      };
    }, leaveRenders = (_leaveRenders = {}, _leaveRenders[modes.out] = function(_ref) {
      var current = _ref.current, changeState = _ref.changeState;
      return _react.default.cloneElement(current, {
        in: !1,
        onExited: callHook(current, "onExited", function() {
          changeState(_Transition.ENTERING, null);
        })
      });
    }, _leaveRenders[modes.in] = function(_ref2) {
      var current = _ref2.current, changeState = _ref2.changeState, children = _ref2.children;
      return [current, _react.default.cloneElement(children, {
        in: !0,
        onEntered: callHook(children, "onEntered", function() {
          changeState(_Transition.ENTERING);
        })
      })];
    }, _leaveRenders), enterRenders = (_enterRenders = {}, _enterRenders[modes.out] = function(_ref3) {
      var children = _ref3.children, changeState = _ref3.changeState;
      return _react.default.cloneElement(children, {
        in: !0,
        onEntered: callHook(children, "onEntered", function() {
          changeState(_Transition.ENTERED, _react.default.cloneElement(children, {
            in: !0
          }));
        })
      });
    }, _enterRenders[modes.in] = function(_ref4) {
      var current = _ref4.current, children = _ref4.children, changeState = _ref4.changeState;
      return [_react.default.cloneElement(current, {
        in: !1,
        onExited: callHook(current, "onExited", function() {
          changeState(_Transition.ENTERED, _react.default.cloneElement(children, {
            in: !0
          }));
        })
      }), _react.default.cloneElement(children, {
        in: !0
      })];
    }, _enterRenders), SwitchTransition = /* @__PURE__ */ function(_React$Component) {
      _inheritsLoose(SwitchTransition2, _React$Component);
      function SwitchTransition2() {
        for (var _this, _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++)
          args[_key] = arguments[_key];
        return _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this, _this.state = {
          status: _Transition.ENTERED,
          current: null
        }, _this.appeared = !1, _this.changeState = function(status, current) {
          current === void 0 && (current = _this.state.current), _this.setState({
            status,
            current
          });
        }, _this;
      }
      var _proto = SwitchTransition2.prototype;
      return _proto.componentDidMount = function() {
        this.appeared = !0;
      }, SwitchTransition2.getDerivedStateFromProps = function(props, state) {
        return props.children == null ? {
          current: null
        } : state.status === _Transition.ENTERING && props.mode === modes.in ? {
          status: _Transition.ENTERING
        } : state.current && areChildrenDifferent(state.current, props.children) ? {
          status: _Transition.EXITING
        } : {
          current: _react.default.cloneElement(props.children, {
            in: !0
          })
        };
      }, _proto.render = function() {
        var _this$props = this.props, children = _this$props.children, mode = _this$props.mode, _this$state = this.state, status = _this$state.status, current = _this$state.current, data = {
          children,
          current,
          changeState: this.changeState,
          status
        }, component;
        switch (status) {
          case _Transition.ENTERING:
            component = enterRenders[mode](data);
            break;
          case _Transition.EXITING:
            component = leaveRenders[mode](data);
            break;
          case _Transition.ENTERED:
            component = current;
        }
        return /* @__PURE__ */ _react.default.createElement(_TransitionGroupContext.default.Provider, {
          value: {
            isMounting: !this.appeared
          }
        }, component);
      }, SwitchTransition2;
    }(_react.default.Component);
    SwitchTransition.propTypes = process.env.NODE_ENV !== "production" ? {
      /**
       * Transition modes.
       * `out-in`: Current element transitions out first, then when complete, the new element transitions in.
       * `in-out`: New element transitions in first, then when complete, the current element transitions out.
       *
       * @type {'out-in'|'in-out'}
       */
      mode: _propTypes.default.oneOf([modes.in, modes.out]),
      /**
       * Any `Transition` or `CSSTransition` component.
       */
      children: _propTypes.default.oneOfType([_propTypes.default.element.isRequired])
    } : {};
    SwitchTransition.defaultProps = {
      mode: modes.out
    };
    var _default = SwitchTransition;
    exports.default = _default;
  }
});

// ../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/index.js
var require_cjs4 = __commonJS({
  "../../node_modules/.pnpm/react-transition-group@4.4.5_react-dom@18.2.0_react@18.2.0/node_modules/react-transition-group/cjs/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    exports.__esModule = !0;
    exports.config = exports.Transition = exports.TransitionGroup = exports.SwitchTransition = exports.ReplaceTransition = exports.CSSTransition = void 0;
    var _CSSTransition = _interopRequireDefault(require_CSSTransition());
    exports.CSSTransition = _CSSTransition.default;
    var _ReplaceTransition = _interopRequireDefault(require_ReplaceTransition());
    exports.ReplaceTransition = _ReplaceTransition.default;
    var _SwitchTransition = _interopRequireDefault(require_SwitchTransition());
    exports.SwitchTransition = _SwitchTransition.default;
    var _TransitionGroup = _interopRequireDefault(require_TransitionGroup());
    exports.TransitionGroup = _TransitionGroup.default;
    var _Transition = _interopRequireDefault(require_Transition());
    exports.Transition = _Transition.default;
    var _config = _interopRequireDefault(require_config2());
    exports.config = _config.default;
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/BulkActions/BulkActions.scss.js
var require_BulkActions_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/BulkActions/BulkActions.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Group: "Polaris-BulkActions__Group",
      "Group-not-sticky": "Polaris-BulkActions--groupNotSticky",
      "Group-entering": "Polaris-BulkActions__Group--entering",
      "Group-exiting": "Polaris-BulkActions__Group--exiting",
      "Group-entered": "Polaris-BulkActions__Group--entered",
      "Group-exited": "Polaris-BulkActions__Group--exited",
      "Group-measuring": "Polaris-BulkActions__Group--measuring",
      ButtonGroupWrapper: "Polaris-BulkActions__ButtonGroupWrapper",
      BulkActionButton: "Polaris-BulkActions__BulkActionButton",
      disabled: "Polaris-BulkActions--disabled"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Indicator/Indicator.scss.js
var require_Indicator_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Indicator/Indicator.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Indicator: "Polaris-Indicator",
      pulseIndicator: "Polaris-Indicator--pulseIndicator"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Indicator/Indicator.js
var require_Indicator = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Indicator/Indicator.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Indicator_module = require_Indicator_scss();
    function Indicator({
      pulse = !0
    }) {
      let className = css.classNames(Indicator_module.default.Indicator, pulse && Indicator_module.default.pulseIndicator);
      return /* @__PURE__ */ React12.createElement("span", {
        className
      });
    }
    exports.Indicator = Indicator;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/BulkActions/components/BulkActionButton/BulkActionButton.js
var require_BulkActionButton = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/BulkActions/components/BulkActionButton/BulkActionButton.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), useComponentDidMount = require_use_component_did_mount(), BulkActions_module = require_BulkActions_scss(), Indicator = require_Indicator(), Tooltip = require_Tooltip(), Button2 = require_Button(), Icon = require_Icon();
    function BulkActionButton({
      handleMeasurement,
      url,
      external,
      onAction,
      content,
      disclosure,
      accessibilityLabel,
      disabled,
      indicator,
      showContentInButton
    }) {
      let bulkActionButton = React12.useRef(null);
      useComponentDidMount.useComponentDidMount(() => {
        if (handleMeasurement && bulkActionButton.current) {
          let width = bulkActionButton.current.getBoundingClientRect().width;
          handleMeasurement(width);
        }
      });
      let isActivatorForMoreActionsPopover = disclosure && !showContentInButton, buttonContent = isActivatorForMoreActionsPopover ? void 0 : content, buttonMarkup = /* @__PURE__ */ React12.createElement(Button2.Button, {
        external,
        url,
        accessibilityLabel: isActivatorForMoreActionsPopover ? content : accessibilityLabel,
        disclosure: disclosure && showContentInButton,
        onClick: onAction,
        disabled,
        size: "slim",
        icon: isActivatorForMoreActionsPopover ? /* @__PURE__ */ React12.createElement(Icon.Icon, {
          source: polarisIcons.MenuHorizontalIcon,
          tone: "base"
        }) : void 0
      }, buttonContent);
      return /* @__PURE__ */ React12.createElement("div", {
        className: BulkActions_module.default.BulkActionButton,
        ref: bulkActionButton
      }, isActivatorForMoreActionsPopover ? /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, {
        content,
        preferredPosition: "above"
      }, buttonMarkup) : buttonMarkup, indicator && /* @__PURE__ */ React12.createElement(Indicator.Indicator, null));
    }
    exports.BulkActionButton = BulkActionButton;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/BulkActions/components/BulkActionMenu/BulkActionMenu.js
var require_BulkActionMenu = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/BulkActions/components/BulkActionMenu/BulkActionMenu.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), useToggle = require_use_toggle(), BulkActionButton = require_BulkActionButton(), Popover = require_Popover(), ActionList = require_ActionList();
    function BulkActionMenu({
      title,
      actions,
      isNewBadgeInBadgeActions
    }) {
      let {
        value: isVisible,
        toggle: toggleMenuVisibility
      } = useToggle.useToggle(!1);
      return /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement(Popover.Popover, {
        active: isVisible,
        activator: /* @__PURE__ */ React12.createElement(BulkActionButton.BulkActionButton, {
          disclosure: !0,
          showContentInButton: !0,
          onAction: toggleMenuVisibility,
          content: title,
          indicator: isNewBadgeInBadgeActions
        }),
        onClose: toggleMenuVisibility,
        preferInputActivator: !0
      }, /* @__PURE__ */ React12.createElement(ActionList.ActionList, {
        items: actions,
        onActionAnyItem: toggleMenuVisibility
      })));
    }
    exports.BulkActionMenu = BulkActionMenu;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/BulkActions/BulkActions.js
var require_BulkActions = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/BulkActions/BulkActions.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), reactTransitionGroup = require_cjs4(), debounce = require_debounce2(), css = require_css(), clamp = require_clamp(), BulkActions_module = require_BulkActions_scss(), BulkActionMenu = require_BulkActionMenu(), hooks2 = require_hooks2(), BulkActionButton = require_BulkActionButton(), Popover = require_Popover(), ActionList = require_ActionList(), EventListener = require_EventListener(), InlineStack2 = require_InlineStack(), BUTTONS_NODE_ADDITIONAL_WIDTH = 64, BulkActionsInner = class extends React12.PureComponent {
      constructor(...args) {
        super(...args), this.state = {
          popoverVisible: !1,
          containerWidth: 0,
          measuring: !0
        }, this.containerNode = null, this.buttonsNode = null, this.moreActionsNode = null, this.groupNode = /* @__PURE__ */ React12.createRef(), this.promotedActionsWidths = [], this.bulkActionsWidth = 0, this.addedMoreActionsWidthForMeasuring = 0, this.handleResize = debounce.debounce(() => {
          let {
            popoverVisible
          } = this.state;
          if (this.containerNode) {
            let containerWidth = this.containerNode.getBoundingClientRect().width;
            containerWidth > 0 && this.setState({
              containerWidth
            });
          }
          popoverVisible && this.setState({
            popoverVisible: !1
          });
        }, 50, {
          trailing: !0
        }), this.setButtonsNode = (node) => {
          this.buttonsNode = node;
        }, this.setContainerNode = (node) => {
          this.containerNode = node;
        }, this.setMoreActionsNode = (node) => {
          this.moreActionsNode = node;
        }, this.togglePopover = () => {
          this.props.onMoreActionPopoverToggle && this.props.onMoreActionPopoverToggle(this.state.popoverVisible), this.setState(({
            popoverVisible
          }) => ({
            popoverVisible: !popoverVisible
          }));
        }, this.handleMeasurement = (width) => {
          let {
            measuring
          } = this.state;
          measuring && this.promotedActionsWidths.push(width);
        };
      }
      numberOfPromotedActionsToRender() {
        let {
          promotedActions
        } = this.props, {
          containerWidth,
          measuring
        } = this.state;
        if (!promotedActions)
          return 0;
        let containerWidthMinusAdditionalWidth = Math.max(0, containerWidth - BUTTONS_NODE_ADDITIONAL_WIDTH);
        if (containerWidthMinusAdditionalWidth >= this.bulkActionsWidth || measuring)
          return promotedActions.length;
        let sufficientSpace = !1, counter = promotedActions.length - 1, totalWidth = 0;
        for (; !sufficientSpace && counter >= 0; ) {
          totalWidth += this.promotedActionsWidths[counter];
          let widthWithRemovedAction = this.bulkActionsWidth - totalWidth + this.addedMoreActionsWidthForMeasuring;
          containerWidthMinusAdditionalWidth >= widthWithRemovedAction ? sufficientSpace = !0 : counter--;
        }
        return clamp.clamp(counter, 0, promotedActions.length);
      }
      actionSections() {
        let {
          actions
        } = this.props;
        if (!(!actions || actions.length === 0)) {
          if (instanceOfBulkActionListSectionArray(actions))
            return actions;
          if (instanceOfBulkActionArray(actions))
            return [{
              items: actions
            }];
        }
      }
      rolledInPromotedActions() {
        let {
          promotedActions
        } = this.props, numberOfPromotedActionsToRender = this.numberOfPromotedActionsToRender();
        return !promotedActions || promotedActions.length === 0 || numberOfPromotedActionsToRender >= promotedActions.length ? [] : promotedActions.map((action) => instanceOfMenuGroupDescriptor(action) ? {
          items: [...action.actions]
        } : {
          items: [action]
        }).slice(numberOfPromotedActionsToRender);
      }
      // eslint-disable-next-line @typescript-eslint/member-ordering
      componentDidMount() {
        let {
          actions,
          promotedActions
        } = this.props;
        promotedActions && !actions && this.moreActionsNode && (this.addedMoreActionsWidthForMeasuring = this.moreActionsNode.getBoundingClientRect().width), this.bulkActionsWidth = this.buttonsNode ? this.buttonsNode.getBoundingClientRect().width - this.addedMoreActionsWidthForMeasuring : 0, this.containerNode && this.setState({
          containerWidth: this.containerNode.getBoundingClientRect().width,
          measuring: !1
        });
      }
      // eslint-disable-next-line @typescript-eslint/member-ordering
      render() {
        let {
          selectMode,
          disabled,
          promotedActions,
          i18n,
          isSticky,
          width
        } = this.props, actionSections = this.actionSections(), {
          popoverVisible,
          measuring
        } = this.state, numberOfPromotedActionsToRender = this.numberOfPromotedActionsToRender(), promotedActionsMarkup = promotedActions && numberOfPromotedActionsToRender > 0 ? [...promotedActions].slice(0, numberOfPromotedActionsToRender).map((action, index) => instanceOfMenuGroupDescriptor(action) ? /* @__PURE__ */ React12.createElement(BulkActionMenu.BulkActionMenu, Object.assign({
          key: index
        }, action, {
          isNewBadgeInBadgeActions: this.isNewBadgeInBadgeActions()
        })) : /* @__PURE__ */ React12.createElement(BulkActionButton.BulkActionButton, Object.assign({
          key: index,
          disabled
        }, action, {
          handleMeasurement: this.handleMeasurement
        }))) : null, rolledInPromotedActions = this.rolledInPromotedActions(), activatorLabel = !promotedActions || promotedActions && numberOfPromotedActionsToRender === 0 && !measuring ? i18n.translate("Polaris.ResourceList.BulkActions.actionsActivatorLabel") : i18n.translate("Polaris.ResourceList.BulkActions.moreActionsActivatorLabel"), combinedActions = [];
        actionSections && rolledInPromotedActions.length > 0 ? combinedActions = [...rolledInPromotedActions, ...actionSections] : actionSections ? combinedActions = actionSections : rolledInPromotedActions.length > 0 && (combinedActions = [...rolledInPromotedActions]);
        let actionsPopover = actionSections || rolledInPromotedActions.length > 0 || measuring ? /* @__PURE__ */ React12.createElement("div", {
          className: BulkActions_module.default.Popover,
          ref: this.setMoreActionsNode
        }, /* @__PURE__ */ React12.createElement(Popover.Popover, {
          active: popoverVisible,
          activator: /* @__PURE__ */ React12.createElement(BulkActionButton.BulkActionButton, {
            disclosure: !0,
            showContentInButton: !promotedActionsMarkup,
            onAction: this.togglePopover,
            content: activatorLabel,
            disabled,
            indicator: this.isNewBadgeInBadgeActions()
          }),
          preferredAlignment: "right",
          onClose: this.togglePopover
        }, /* @__PURE__ */ React12.createElement(ActionList.ActionList, {
          sections: combinedActions,
          onActionAnyItem: this.togglePopover
        }))) : null, groupContent = promotedActionsMarkup || actionsPopover ? /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
          gap: "300"
        }, promotedActionsMarkup, actionsPopover) : null;
        if (!groupContent)
          return null;
        let group = /* @__PURE__ */ React12.createElement(reactTransitionGroup.Transition, {
          timeout: 100,
          in: selectMode,
          key: "group",
          nodeRef: this.groupNode
        }, (status) => {
          let groupClassName = css.classNames(BulkActions_module.default.Group, !isSticky && BulkActions_module.default["Group-not-sticky"], !measuring && isSticky && BulkActions_module.default[`Group-${status}`], measuring && BulkActions_module.default["Group-measuring"]);
          return /* @__PURE__ */ React12.createElement("div", {
            className: groupClassName,
            ref: this.groupNode,
            style: {
              width
            }
          }, /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
            event: "resize",
            handler: this.handleResize
          }), /* @__PURE__ */ React12.createElement("div", {
            className: BulkActions_module.default.ButtonGroupWrapper,
            ref: this.setButtonsNode
          }, /* @__PURE__ */ React12.createElement("div", {
            className: BulkActions_module.default.ButtonGroupInner
          }, groupContent)));
        });
        return /* @__PURE__ */ React12.createElement("div", {
          ref: this.setContainerNode
        }, group);
      }
      isNewBadgeInBadgeActions() {
        let actions = this.actionSections();
        if (!actions)
          return !1;
        for (let action of actions)
          for (let item of action.items)
            if (item.badge?.tone === "new")
              return !0;
        return !1;
      }
    };
    function instanceOfBulkActionListSectionArray(actions) {
      let validList = actions.filter((action) => action.items);
      return actions.length === validList.length;
    }
    function instanceOfBulkActionArray(actions) {
      let validList = actions.filter((action) => !action.items);
      return actions.length === validList.length;
    }
    function instanceOfMenuGroupDescriptor(action) {
      return "title" in action;
    }
    function BulkActions(props) {
      let i18n = hooks2.useI18n();
      return /* @__PURE__ */ React12.createElement(BulkActionsInner, Object.assign({}, props, {
        i18n
      }));
    }
    exports.BulkActions = BulkActions;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/CalloutCard/CalloutCard.scss.js
var require_CalloutCard_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/CalloutCard/CalloutCard.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      CalloutCard: "Polaris-CalloutCard",
      Image: "Polaris-CalloutCard__Image",
      DismissImage: "Polaris-CalloutCard__DismissImage",
      Content: "Polaris-CalloutCard__Content",
      Title: "Polaris-CalloutCard__Title",
      Buttons: "Polaris-CalloutCard__Buttons",
      Container: "Polaris-CalloutCard__Container",
      Dismiss: "Polaris-CalloutCard__Dismiss",
      hasDismiss: "Polaris-CalloutCard--hasDismiss"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyCard/LegacyCard.scss.js
var require_LegacyCard_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyCard/LegacyCard.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      LegacyCard: "Polaris-LegacyCard",
      Section: "Polaris-LegacyCard__Section",
      subdued: "Polaris-LegacyCard--subdued",
      "Section-hideOnPrint": "Polaris-LegacyCard__Section--hideOnPrint",
      hideOnPrint: "Polaris-LegacyCard--hideOnPrint",
      Header: "Polaris-LegacyCard__Header",
      "Section-fullWidth": "Polaris-LegacyCard__Section--fullWidth",
      "Section-flush": "Polaris-LegacyCard__Section--flush",
      "Section-subdued": "Polaris-LegacyCard__Section--subdued",
      SectionHeader: "Polaris-LegacyCard__SectionHeader",
      Subsection: "Polaris-LegacyCard__Subsection",
      Footer: "Polaris-LegacyCard__Footer",
      LeftJustified: "Polaris-LegacyCard__LeftJustified",
      FirstSectionPadding: "Polaris-LegacyCard__FirstSectionPadding",
      LastSectionPadding: "Polaris-LegacyCard__LastSectionPadding"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyCard/components/Header/Header.js
var require_Header2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyCard/components/Header/Header.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), LegacyCard_module = require_LegacyCard_scss(), utils = require_utils10(), ButtonGroup = require_ButtonGroup(), InlineStack2 = require_InlineStack(), Text4 = require_Text();
    function Header3({
      children,
      title,
      actions
    }) {
      let actionMarkup = actions ? /* @__PURE__ */ React12.createElement(ButtonGroup.ButtonGroup, null, utils.buttonsFrom(actions, {
        variant: "plain"
      })) : null, titleMarkup = /* @__PURE__ */ React12.isValidElement(title) ? title : /* @__PURE__ */ React12.createElement(Text4.Text, {
        variant: "headingSm",
        as: "h2"
      }, title), headingMarkup = actionMarkup || children ? /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        wrap: !1,
        gap: "200",
        align: "space-between",
        blockAlign: "center"
      }, titleMarkup, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        wrap: !1,
        gap: "400",
        blockAlign: "center"
      }, actionMarkup, children)) : titleMarkup;
      return /* @__PURE__ */ React12.createElement("div", {
        className: LegacyCard_module.default.Header
      }, headingMarkup);
    }
    exports.Header = Header3;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyStack/LegacyStack.scss.js
var require_LegacyStack_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyStack/LegacyStack.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      LegacyStack: "Polaris-LegacyStack",
      Item: "Polaris-LegacyStack__Item",
      noWrap: "Polaris-LegacyStack--noWrap",
      spacingNone: "Polaris-LegacyStack--spacingNone",
      spacingExtraTight: "Polaris-LegacyStack--spacingExtraTight",
      spacingTight: "Polaris-LegacyStack--spacingTight",
      spacingBaseTight: "Polaris-LegacyStack--spacingBaseTight",
      spacingLoose: "Polaris-LegacyStack--spacingLoose",
      spacingExtraLoose: "Polaris-LegacyStack--spacingExtraLoose",
      distributionLeading: "Polaris-LegacyStack--distributionLeading",
      distributionTrailing: "Polaris-LegacyStack--distributionTrailing",
      distributionCenter: "Polaris-LegacyStack--distributionCenter",
      distributionEqualSpacing: "Polaris-LegacyStack--distributionEqualSpacing",
      distributionFill: "Polaris-LegacyStack--distributionFill",
      distributionFillEvenly: "Polaris-LegacyStack--distributionFillEvenly",
      alignmentLeading: "Polaris-LegacyStack--alignmentLeading",
      alignmentTrailing: "Polaris-LegacyStack--alignmentTrailing",
      alignmentCenter: "Polaris-LegacyStack--alignmentCenter",
      alignmentFill: "Polaris-LegacyStack--alignmentFill",
      alignmentBaseline: "Polaris-LegacyStack--alignmentBaseline",
      vertical: "Polaris-LegacyStack--vertical",
      "Item-fill": "Polaris-LegacyStack__Item--fill"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyStack/components/Item/Item.js
var require_Item4 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyStack/components/Item/Item.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), LegacyStack_module = require_LegacyStack_scss();
    function Item({
      children,
      fill
    }) {
      let className = css.classNames(LegacyStack_module.default.Item, fill && LegacyStack_module.default["Item-fill"]);
      return /* @__PURE__ */ React12.createElement("div", {
        className
      }, children);
    }
    exports.Item = Item;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyStack/LegacyStack.js
var require_LegacyStack = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyStack/LegacyStack.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), components = require_components(), LegacyStack_module = require_LegacyStack_scss(), Item = require_Item4(), LegacyStack = /* @__PURE__ */ React12.memo(function({
      children,
      vertical,
      spacing,
      distribution,
      alignment,
      wrap
    }) {
      let className = css.classNames(LegacyStack_module.default.LegacyStack, vertical && LegacyStack_module.default.vertical, spacing && LegacyStack_module.default[css.variationName("spacing", spacing)], distribution && LegacyStack_module.default[css.variationName("distribution", distribution)], alignment && LegacyStack_module.default[css.variationName("alignment", alignment)], wrap === !1 && LegacyStack_module.default.noWrap), itemMarkup = components.elementChildren(children).map((child, index) => {
        let props = {
          key: index
        };
        return components.wrapWithComponent(child, Item.Item, props);
      });
      return /* @__PURE__ */ React12.createElement("div", {
        className
      }, itemMarkup);
    });
    LegacyStack.Item = Item.Item;
    exports.LegacyStack = LegacyStack;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyCard/components/Section/Section.js
var require_Section4 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyCard/components/Section/Section.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), LegacyCard_module = require_LegacyCard_scss(), LegacyStack = require_LegacyStack(), ButtonGroup = require_ButtonGroup(), utils = require_utils10(), Text4 = require_Text();
    function Section({
      children,
      title,
      subdued,
      flush,
      fullWidth,
      actions,
      hideOnPrint
    }) {
      let className = css.classNames(LegacyCard_module.default.Section, flush && LegacyCard_module.default["Section-flush"], subdued && LegacyCard_module.default["Section-subdued"], fullWidth && LegacyCard_module.default["Section-fullWidth"], hideOnPrint && LegacyCard_module.default["Section-hideOnPrint"]), actionMarkup = actions ? /* @__PURE__ */ React12.createElement(ButtonGroup.ButtonGroup, null, utils.buttonsFrom(actions, {
        variant: "plain"
      })) : null, titleMarkup = typeof title == "string" ? /* @__PURE__ */ React12.createElement(Text4.Text, {
        variant: "headingSm",
        as: "h3",
        fontWeight: "medium"
      }, title) : title, titleAreaMarkup = titleMarkup || actionMarkup ? /* @__PURE__ */ React12.createElement("div", {
        className: LegacyCard_module.default.SectionHeader
      }, actionMarkup ? /* @__PURE__ */ React12.createElement(LegacyStack.LegacyStack, {
        alignment: "baseline"
      }, /* @__PURE__ */ React12.createElement(LegacyStack.LegacyStack.Item, {
        fill: !0
      }, titleMarkup), actionMarkup) : titleMarkup) : null;
      return /* @__PURE__ */ React12.createElement("div", {
        className
      }, titleAreaMarkup, children);
    }
    exports.Section = Section;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyCard/components/Subsection/Subsection.js
var require_Subsection = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyCard/components/Subsection/Subsection.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), LegacyCard_module = require_LegacyCard_scss();
    function Subsection({
      children
    }) {
      return /* @__PURE__ */ React12.createElement("div", {
        className: LegacyCard_module.default.Subsection
      }, children);
    }
    exports.Subsection = Subsection;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyCard/LegacyCard.js
var require_LegacyCard = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyCard/LegacyCard.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), useToggle = require_use_toggle(), withinContentContext = require_within_content_context(), LegacyCard_module = require_LegacyCard_scss(), Header3 = require_Header2(), Section = require_Section4(), Subsection = require_Subsection(), hooks2 = require_hooks2(), utils = require_utils10(), Popover = require_Popover(), Button2 = require_Button(), ActionList = require_ActionList(), ButtonGroup = require_ButtonGroup(), LegacyCard = function({
      children,
      hideOnPrint,
      title,
      subdued,
      sectioned,
      actions,
      primaryFooterAction,
      secondaryFooterActions,
      secondaryFooterActionsDisclosureText,
      footerActionAlignment = "right"
    }) {
      let i18n = hooks2.useI18n(), {
        value: secondaryActionsPopoverOpen,
        toggle: toggleSecondaryActionsPopoverOpen
      } = useToggle.useToggle(!1), legacyCard = useLegacyCardPaddingObserverRef(), className = css.classNames(LegacyCard_module.default.LegacyCard, subdued && LegacyCard_module.default.subdued, hideOnPrint && LegacyCard_module.default.hideOnPrint), headerMarkup = title || actions ? /* @__PURE__ */ React12.createElement(Header3.Header, {
        actions,
        title
      }) : null, content = sectioned ? /* @__PURE__ */ React12.createElement(Section.Section, null, children) : children, primaryFooterActionMarkup = primaryFooterAction ? utils.buttonFrom(primaryFooterAction, {
        variant: "primary"
      }) : null, secondaryFooterActionsMarkup = null;
      secondaryFooterActions && secondaryFooterActions.length && (secondaryFooterActions.length === 1 ? secondaryFooterActionsMarkup = utils.buttonFrom(secondaryFooterActions[0]) : secondaryFooterActionsMarkup = /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement(Popover.Popover, {
        active: secondaryActionsPopoverOpen,
        activator: /* @__PURE__ */ React12.createElement(Button2.Button, {
          disclosure: !0,
          onClick: toggleSecondaryActionsPopoverOpen
        }, secondaryFooterActionsDisclosureText || i18n.translate("Polaris.Common.more")),
        onClose: toggleSecondaryActionsPopoverOpen
      }, /* @__PURE__ */ React12.createElement(ActionList.ActionList, {
        items: secondaryFooterActions
      }))));
      let footerMarkup = primaryFooterActionMarkup || secondaryFooterActionsMarkup ? /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(LegacyCard_module.default.Footer, footerActionAlignment === "left" && LegacyCard_module.default.LeftJustified)
      }, footerActionAlignment === "right" ? /* @__PURE__ */ React12.createElement(ButtonGroup.ButtonGroup, null, secondaryFooterActionsMarkup, primaryFooterActionMarkup) : /* @__PURE__ */ React12.createElement(ButtonGroup.ButtonGroup, null, primaryFooterActionMarkup, secondaryFooterActionsMarkup)) : null;
      return /* @__PURE__ */ React12.createElement(withinContentContext.WithinContentContext.Provider, {
        value: !0
      }, /* @__PURE__ */ React12.createElement("div", {
        className,
        ref: legacyCard
      }, headerMarkup, content, footerMarkup));
    };
    LegacyCard.Header = Header3.Header;
    LegacyCard.Section = Section.Section;
    LegacyCard.Subsection = Subsection.Subsection;
    function useLegacyCardPaddingObserverRef() {
      let legacyCard = React12.useRef(null);
      return React12.useEffect(() => {
        let legacyCardNode = legacyCard.current, firstSection, lastSection;
        if (legacyCardNode) {
          let updateFirstAndLastSectionPadding = () => {
            updatePadding(firstSection, "top", !1), updatePadding(lastSection, "bottom", !1);
            let currentElements = legacyCardNode.querySelectorAll(`.${LegacyCard_module.default.Section}, .${LegacyCard_module.default.Header}, .${LegacyCard_module.default.Footer}`);
            if (!currentElements?.length)
              return;
            let firstElement = currentElements[0], lastElement = getMostSeniorLastElement(currentElements);
            legacyCardNode.firstChild?.contains(firstElement) && (firstSection = firstElement, updatePadding(firstSection, "top", !0)), legacyCardNode.lastChild?.contains(lastElement) && (lastSection = lastElement, updatePadding(lastSection, "bottom", !0));
          };
          updateFirstAndLastSectionPadding();
          let observer = new MutationObserver(updateFirstAndLastSectionPadding);
          return observer.observe(legacyCardNode, {
            childList: !0,
            subtree: !0
          }), () => {
            updatePadding(firstSection, "top", !1), updatePadding(lastSection, "bottom", !1), observer.disconnect();
          };
        }
      }, []), legacyCard;
    }
    function updatePadding(element, area, add) {
      if (!(!element || element.className.includes(LegacyCard_module.default["Section-flush"])))
        switch (area) {
          case "top":
            element.classList.toggle(LegacyCard_module.default.FirstSectionPadding, add);
            return;
          case "bottom":
            element.classList.toggle(LegacyCard_module.default.LastSectionPadding, add);
        }
    }
    function getMostSeniorLastElement(elements) {
      let lastElement = elements[0];
      return elements.forEach((element) => {
        lastElement.contains(element) || (lastElement = element);
      }), lastElement;
    }
    exports.LegacyCard = LegacyCard;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TextContainer/TextContainer.scss.js
var require_TextContainer_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TextContainer/TextContainer.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      TextContainer: "Polaris-TextContainer",
      spacingTight: "Polaris-TextContainer--spacingTight",
      spacingLoose: "Polaris-TextContainer--spacingLoose"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TextContainer/TextContainer.js
var require_TextContainer = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TextContainer/TextContainer.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), TextContainer_module = require_TextContainer_scss();
    function TextContainer({
      spacing,
      children
    }) {
      let className = css.classNames(TextContainer_module.default.TextContainer, spacing && TextContainer_module.default[css.variationName("spacing", spacing)]);
      return /* @__PURE__ */ React12.createElement("div", {
        className
      }, children);
    }
    exports.TextContainer = TextContainer;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/CalloutCard/CalloutCard.js
var require_CalloutCard = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/CalloutCard/CalloutCard.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), CalloutCard_module = require_CalloutCard_scss(), LegacyCard = require_LegacyCard(), TextContainer = require_TextContainer(), utils = require_utils10(), Button2 = require_Button(), Text4 = require_Text(), Image = require_Image(), ButtonGroup = require_ButtonGroup();
    function CalloutCard({
      title,
      children,
      illustration,
      primaryAction,
      secondaryAction,
      onDismiss
    }) {
      let primaryActionMarkup = utils.buttonFrom(primaryAction), secondaryActionMarkup = secondaryAction ? utils.buttonFrom(secondaryAction, {
        variant: "tertiary"
      }) : null, buttonMarkup = secondaryActionMarkup ? /* @__PURE__ */ React12.createElement(ButtonGroup.ButtonGroup, null, primaryActionMarkup, secondaryActionMarkup) : primaryActionMarkup, dismissButton = onDismiss ? /* @__PURE__ */ React12.createElement("div", {
        className: CalloutCard_module.default.Dismiss
      }, /* @__PURE__ */ React12.createElement(Button2.Button, {
        variant: "plain",
        icon: polarisIcons.XSmallIcon,
        onClick: onDismiss,
        accessibilityLabel: "Dismiss card"
      })) : null, imageClassName = css.classNames(CalloutCard_module.default.Image, onDismiss && CalloutCard_module.default.DismissImage), containerClassName = css.classNames(CalloutCard_module.default.Container, onDismiss && CalloutCard_module.default.hasDismiss);
      return /* @__PURE__ */ React12.createElement(LegacyCard.LegacyCard, null, /* @__PURE__ */ React12.createElement("div", {
        className: containerClassName
      }, dismissButton, /* @__PURE__ */ React12.createElement(LegacyCard.LegacyCard.Section, null, /* @__PURE__ */ React12.createElement("div", {
        className: CalloutCard_module.default.CalloutCard
      }, /* @__PURE__ */ React12.createElement("div", {
        className: CalloutCard_module.default.Content
      }, /* @__PURE__ */ React12.createElement("div", {
        className: CalloutCard_module.default.Title
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        variant: "headingMd",
        as: "h2"
      }, title)), /* @__PURE__ */ React12.createElement(TextContainer.TextContainer, null, children), /* @__PURE__ */ React12.createElement("div", {
        className: CalloutCard_module.default.Buttons
      }, buttonMarkup)), /* @__PURE__ */ React12.createElement(Image.Image, {
        alt: "",
        className: imageClassName,
        source: illustration
      })))));
    }
    exports.CalloutCard = CalloutCard;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ChoiceList/ChoiceList.scss.js
var require_ChoiceList_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ChoiceList/ChoiceList.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      ChoiceChildren: "Polaris-ChoiceList__ChoiceChildren"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RadioButton/RadioButton.scss.js
var require_RadioButton_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RadioButton/RadioButton.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      RadioButton: "Polaris-RadioButton",
      Input: "Polaris-RadioButton__Input",
      Backdrop: "Polaris-RadioButton__Backdrop",
      ChoiceLabel: "Polaris-RadioButton__ChoiceLabel",
      toneMagic: "Polaris-RadioButton--toneMagic"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RadioButton/RadioButton.js
var require_RadioButton = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RadioButton/RadioButton.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), RadioButton_module = require_RadioButton_scss(), Choice = require_Choice();
    function RadioButton({
      ariaDescribedBy: ariaDescribedByProp,
      label,
      labelHidden,
      helpText,
      checked,
      disabled,
      onChange,
      onFocus,
      onBlur,
      id: idProp,
      name: nameProp,
      value,
      fill,
      bleed,
      bleedBlockStart,
      bleedBlockEnd,
      bleedInlineStart,
      bleedInlineEnd,
      tone
    }) {
      let uniqId = React12.useId(), id = idProp ?? uniqId, name = nameProp || id, inputNode = React12.useRef(null), handleBlur = () => {
        onBlur && onBlur();
      };
      function handleChange({
        currentTarget
      }) {
        onChange && onChange(currentTarget.checked, id);
      }
      let describedBy = [];
      helpText && describedBy.push(Choice.helpTextID(id)), ariaDescribedByProp && describedBy.push(ariaDescribedByProp);
      let ariaDescribedBy = describedBy.length ? describedBy.join(" ") : void 0, inputClassName = css.classNames(RadioButton_module.default.Input, tone && RadioButton_module.default[css.variationName("tone", tone)]), extraChoiceProps = {
        helpText,
        bleed,
        bleedBlockStart,
        bleedBlockEnd,
        bleedInlineStart,
        bleedInlineEnd
      };
      return /* @__PURE__ */ React12.createElement(Choice.Choice, Object.assign({
        label,
        labelHidden,
        disabled,
        id,
        labelClassName: RadioButton_module.default.ChoiceLabel,
        fill
      }, extraChoiceProps, checked ? {
        tone
      } : {}), /* @__PURE__ */ React12.createElement("span", {
        className: RadioButton_module.default.RadioButton
      }, /* @__PURE__ */ React12.createElement("input", {
        id,
        name,
        value,
        type: "radio",
        checked,
        disabled,
        className: inputClassName,
        onChange: handleChange,
        onFocus,
        onBlur: handleBlur,
        "aria-describedby": ariaDescribedBy,
        ref: inputNode
      }), /* @__PURE__ */ React12.createElement("span", {
        className: RadioButton_module.default.Backdrop
      })));
    }
    exports.RadioButton = RadioButton;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ChoiceList/ChoiceList.js
var require_ChoiceList = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ChoiceList/ChoiceList.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), ChoiceList_module = require_ChoiceList_scss(), Bleed = require_Bleed(), RadioButton = require_RadioButton(), Box2 = require_Box(), InlineError = require_InlineError(), BlockStack3 = require_BlockStack(), Checkbox = require_Checkbox();
    function ChoiceList({
      title,
      titleHidden,
      allowMultiple,
      choices,
      selected,
      onChange = noop,
      error,
      disabled = !1,
      name: nameProp,
      tone
    }) {
      let ControlComponent = allowMultiple ? Checkbox.Checkbox : RadioButton.RadioButton, uniqName = React12.useId(), name = nameProp ?? uniqName, finalName = allowMultiple ? `${name}[]` : name, titleMarkup = title ? /* @__PURE__ */ React12.createElement(Box2.Box, {
        as: "legend",
        paddingBlockEnd: {
          xs: "500",
          md: "100"
        },
        visuallyHidden: titleHidden
      }, title) : null, choicesMarkup = choices.map((choice) => {
        let {
          value,
          id,
          label,
          helpText,
          disabled: choiceDisabled,
          describedByError
        } = choice;
        function handleChange(checked) {
          onChange(updateSelectedChoices(choice, checked, selected, allowMultiple), name);
        }
        let isSelected = choiceIsSelected(choice, selected), renderedChildren = choice.renderChildren ? choice.renderChildren(isSelected) : null, children = renderedChildren ? /* @__PURE__ */ React12.createElement("div", {
          className: ChoiceList_module.default.ChoiceChildren
        }, /* @__PURE__ */ React12.createElement(Box2.Box, {
          paddingBlockStart: {
            xs: "400",
            md: "0"
          }
        }, renderedChildren)) : null;
        return /* @__PURE__ */ React12.createElement("li", {
          key: value
        }, /* @__PURE__ */ React12.createElement(Bleed.Bleed, {
          marginBlockEnd: helpText ? {
            xs: "100",
            md: "0"
          } : {
            xs: "0"
          }
        }, /* @__PURE__ */ React12.createElement(ControlComponent, {
          name: finalName,
          value,
          id,
          label,
          disabled: choiceDisabled || disabled,
          fill: {
            xs: !0,
            sm: !1
          },
          checked: choiceIsSelected(choice, selected),
          helpText,
          onChange: handleChange,
          ariaDescribedBy: error && describedByError ? InlineError.errorTextID(finalName) : null,
          tone
        }), children));
      }), errorMarkup = error && /* @__PURE__ */ React12.createElement(Box2.Box, {
        paddingBlockStart: {
          xs: "0",
          md: "100"
        },
        paddingBlockEnd: "200"
      }, /* @__PURE__ */ React12.createElement(InlineError.InlineError, {
        message: error,
        fieldID: finalName
      }));
      return /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
        as: "fieldset",
        gap: {
          xs: "400",
          md: "0"
        },
        "aria-invalid": error != null,
        id: finalName
      }, titleMarkup, /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
        as: "ul",
        gap: {
          xs: "400",
          md: "0"
        }
      }, choicesMarkup), errorMarkup);
    }
    function noop() {
    }
    function choiceIsSelected({
      value
    }, selected) {
      return selected.includes(value);
    }
    function updateSelectedChoices({
      value
    }, checked, selected, allowMultiple = !1) {
      return checked ? allowMultiple ? [...selected, value] : [value] : selected.filter((selectedChoice) => selectedChoice !== value);
    }
    exports.ChoiceList = ChoiceList;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Collapsible/Collapsible.scss.js
var require_Collapsible_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Collapsible/Collapsible.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Collapsible: "Polaris-Collapsible",
      isFullyClosed: "Polaris-Collapsible--isFullyClosed",
      expandOnPrint: "Polaris-Collapsible--expandOnPrint"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Collapsible/Collapsible.js
var require_Collapsible = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Collapsible/Collapsible.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Collapsible_module = require_Collapsible_scss();
    function Collapsible({
      id,
      expandOnPrint,
      open: open2,
      transition = !0,
      children,
      onAnimationEnd
    }) {
      let [height, setHeight] = React12.useState(0), [isOpen, setIsOpen] = React12.useState(open2), [animationState, setAnimationState] = React12.useState("idle"), collapsibleContainer = React12.useRef(null), isFullyOpen = animationState === "idle" && open2 && isOpen, isFullyClosed = animationState === "idle" && !open2 && !isOpen, content = expandOnPrint || !isFullyClosed ? children : null, wrapperClassName = css.classNames(Collapsible_module.default.Collapsible, isFullyClosed && Collapsible_module.default.isFullyClosed, expandOnPrint && Collapsible_module.default.expandOnPrint), transitionDisabled = isTransitionDisabled(transition), collapsibleStyles = {
        ...typeof transition == "object" && {
          transitionDuration: transition.duration,
          transitionTimingFunction: transition.timingFunction
        },
        maxHeight: isFullyOpen ? "none" : `${height}px`,
        overflow: isFullyOpen ? "visible" : "hidden"
      }, handleCompleteAnimation = React12.useCallback(({
        target
      }) => {
        target === collapsibleContainer.current && (setAnimationState("idle"), setIsOpen(open2), onAnimationEnd && onAnimationEnd());
      }, [onAnimationEnd, open2]), startAnimation = React12.useCallback(() => {
        transitionDisabled ? (setIsOpen(open2), setAnimationState("idle"), open2 && collapsibleContainer.current ? setHeight(collapsibleContainer.current.scrollHeight) : setHeight(0)) : setAnimationState("measuring");
      }, [open2, transitionDisabled]);
      return React12.useEffect(() => {
        open2 !== isOpen && startAnimation();
      }, [open2, isOpen]), React12.useEffect(() => {
        !open2 || !collapsibleContainer.current || setHeight(collapsibleContainer.current.scrollHeight);
      }, []), React12.useEffect(() => {
        if (collapsibleContainer.current)
          switch (animationState) {
            case "idle":
              break;
            case "measuring":
              setHeight(collapsibleContainer.current.scrollHeight), setAnimationState("animating");
              break;
            case "animating":
              setHeight(open2 ? collapsibleContainer.current.scrollHeight : 0);
          }
      }, [animationState, open2, isOpen]), /* @__PURE__ */ React12.createElement("div", {
        id,
        style: collapsibleStyles,
        ref: collapsibleContainer,
        className: wrapperClassName,
        onTransitionEnd: handleCompleteAnimation,
        "aria-hidden": !open2
      }, content);
    }
    var zeroDurationRegex = /^0(ms|s)$/;
    function isTransitionDisabled(transitionProp) {
      if (typeof transitionProp == "boolean")
        return !transitionProp;
      let {
        duration
      } = transitionProp;
      return !!(duration && zeroDurationRegex.test(duration.trim()));
    }
    exports.Collapsible = Collapsible;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ColorPicker/ColorPicker.scss.js
var require_ColorPicker_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ColorPicker/ColorPicker.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      ColorPicker: "Polaris-ColorPicker",
      MainColor: "Polaris-ColorPicker__MainColor",
      fullWidth: "Polaris-ColorPicker--fullWidth",
      Dragger: "Polaris-ColorPicker__Dragger",
      ColorLayer: "Polaris-ColorPicker__ColorLayer",
      HuePicker: "Polaris-ColorPicker__HuePicker",
      AlphaPicker: "Polaris-ColorPicker__AlphaPicker",
      Slidable: "Polaris-ColorPicker__Slidable"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ColorPicker/components/AlphaPicker/utilities.js
var require_utilities3 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ColorPicker/components/AlphaPicker/utilities.js"(exports) {
    "use strict";
    init_cjs_shims();
    var clamp = require_clamp(), VERTICAL_PADDING = 13;
    function calculateDraggerY(alpha, sliderHeight, draggerHeight) {
      let offset = offsetForAlpha(alpha, sliderHeight, draggerHeight);
      return clamp.clamp(offset, 0, sliderHeight);
    }
    function alphaForDraggerY(y, sliderHeight) {
      let offsetY = clamp.clamp(y, 0, sliderHeight);
      return alphaForOffset(offsetY, sliderHeight);
    }
    function alphaForOffset(offset, sliderHeight) {
      let selectionHeight = offset - VERTICAL_PADDING, slidableArea = sliderHeight - VERTICAL_PADDING * 2;
      return clamp.clamp(1 - selectionHeight / slidableArea, 0, 1);
    }
    function offsetForAlpha(alpha, sliderHeight, draggerHeight) {
      let slidableArea = sliderHeight - (draggerHeight + VERTICAL_PADDING);
      return clamp.clamp((1 - alpha) * slidableArea + VERTICAL_PADDING, 0, sliderHeight - draggerHeight);
    }
    exports.alphaForDraggerY = alphaForDraggerY;
    exports.alphaForOffset = alphaForOffset;
    exports.calculateDraggerY = calculateDraggerY;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ColorPicker/components/Slidable/Slidable.js
var require_Slidable = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ColorPicker/components/Slidable/Slidable.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), target = require_target(), ColorPicker_module = require_ColorPicker_scss(), EventListener = require_EventListener(), isDragging = !1;
    target.isServer || window.addEventListener("touchmove", (event) => {
      isDragging && event.preventDefault();
    }, {
      passive: !1
    });
    var Slidable = class extends React12.PureComponent {
      constructor(...args) {
        super(...args), this.state = {
          dragging: !1
        }, this.node = null, this.draggerNode = null, this.setDraggerNode = (node) => {
          this.draggerNode = node;
        }, this.setNode = (node) => {
          this.node = node;
        }, this.startDrag = (event) => {
          isMouseDownEvent(event) && this.handleDraggerMove(event.clientX, event.clientY), isDragging = !0, this.setState({
            dragging: !0
          });
        }, this.handleDragEnd = () => {
          isDragging = !1, this.setState({
            dragging: !1
          });
        }, this.handleMove = (event) => {
          if (event.stopImmediatePropagation(), event.stopPropagation(), event.cancelable && event.preventDefault(), isMouseMoveEvent(event)) {
            this.handleDraggerMove(event.clientX, event.clientY);
            return;
          }
          this.handleDraggerMove(event.touches[0].clientX, event.touches[0].clientY);
        }, this.handleDraggerMove = (x, y) => {
          if (this.node == null)
            return;
          let {
            onChange
          } = this.props, rect = this.node.getBoundingClientRect(), offsetX = x - rect.left, offsetY = y - rect.top;
          onChange({
            x: offsetX,
            y: offsetY
          });
        };
      }
      componentDidMount() {
        let {
          onDraggerHeight
        } = this.props;
        if (onDraggerHeight == null)
          return;
        let {
          draggerNode
        } = this;
        draggerNode != null && (onDraggerHeight(draggerNode.clientWidth), process.env.NODE_ENV === "development" && setTimeout(() => {
          onDraggerHeight(draggerNode.clientWidth);
        }, 0));
      }
      render() {
        let {
          dragging
        } = this.state, {
          draggerX = 0,
          draggerY = 0
        } = this.props, draggerPositioning = {
          transform: `translate3d(${draggerX}px, ${draggerY}px, 0)`
        }, moveListener = dragging ? /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
          event: "mousemove",
          handler: this.handleMove,
          passive: !1
        }) : null, touchMoveListener = dragging ? /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
          event: "touchmove",
          handler: this.handleMove,
          passive: !1
        }) : null, endDragListener = dragging ? /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
          event: "mouseup",
          handler: this.handleDragEnd
        }) : null, touchEndListener = dragging ? /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
          event: "touchend",
          handler: this.handleDragEnd
        }) : null, touchCancelListener = dragging ? /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
          event: "touchcancel",
          handler: this.handleDragEnd
        }) : null;
        return /* @__PURE__ */ React12.createElement("div", {
          ref: this.setNode,
          className: ColorPicker_module.default.Slidable,
          onMouseDown: this.startDrag,
          onTouchStart: this.startDrag
        }, endDragListener, moveListener, touchMoveListener, touchEndListener, touchCancelListener, /* @__PURE__ */ React12.createElement("div", {
          style: draggerPositioning,
          className: ColorPicker_module.default.Dragger,
          ref: this.setDraggerNode
        }));
      }
    };
    function isMouseMoveEvent(event) {
      return event.type === "mousemove";
    }
    function isMouseDownEvent(event) {
      return event.type === "mousedown";
    }
    exports.Slidable = Slidable;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ColorPicker/components/AlphaPicker/AlphaPicker.js
var require_AlphaPicker = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ColorPicker/components/AlphaPicker/AlphaPicker.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), colorTransformers = require_color_transformers(), ColorPicker_module = require_ColorPicker_scss(), utilities = require_utilities3(), Slidable = require_Slidable(), AlphaPicker = class extends React12.PureComponent {
      constructor(...args) {
        super(...args), this.state = {
          sliderHeight: 0,
          draggerHeight: 0
        }, this.setSliderHeight = (node) => {
          node != null && (this.setState({
            sliderHeight: node.clientHeight
          }), process.env.NODE_ENV === "development" && setTimeout(() => {
            this.setState({
              sliderHeight: node.clientHeight
            });
          }, 0));
        }, this.setDraggerHeight = (height) => {
          this.setState({
            draggerHeight: height
          });
        }, this.handleChange = ({
          y
        }) => {
          let {
            onChange
          } = this.props, {
            sliderHeight
          } = this.state, alpha = utilities.alphaForDraggerY(y, sliderHeight);
          onChange(alpha);
        };
      }
      render() {
        let {
          color,
          alpha
        } = this.props, {
          sliderHeight,
          draggerHeight
        } = this.state, draggerY = utilities.calculateDraggerY(alpha, sliderHeight, draggerHeight), background = alphaGradientForColor(color);
        return /* @__PURE__ */ React12.createElement("div", {
          className: ColorPicker_module.default.AlphaPicker,
          ref: this.setSliderHeight
        }, /* @__PURE__ */ React12.createElement("div", {
          className: ColorPicker_module.default.ColorLayer,
          style: {
            background
          }
        }), /* @__PURE__ */ React12.createElement(Slidable.Slidable, {
          draggerY,
          draggerX: 0,
          onChange: this.handleChange,
          onDraggerHeight: this.setDraggerHeight
        }));
      }
    };
    function alphaGradientForColor(color) {
      let {
        red,
        green,
        blue
      } = colorTransformers.hsbToRgb(color), rgb = `${red}, ${green}, ${blue}`;
      return `linear-gradient(to top, rgba(${rgb}, 0) 18px, rgba(${rgb}, 1) calc(100% - 18px))`;
    }
    exports.AlphaPicker = AlphaPicker;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ColorPicker/components/HuePicker/utilities.js
var require_utilities4 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ColorPicker/components/HuePicker/utilities.js"(exports) {
    "use strict";
    init_cjs_shims();
    var clamp = require_clamp(), VERTICAL_PADDING = 13;
    function calculateDraggerY(hue, sliderHeight, draggerHeight) {
      let offset = offsetForHue(hue, sliderHeight, draggerHeight);
      return clamp.clamp(offset, 0, sliderHeight);
    }
    function hueForDraggerY(y, sliderHeight) {
      let offsetY = clamp.clamp(y, 0, sliderHeight);
      return hueForOffset(offsetY, sliderHeight);
    }
    function hueForOffset(offset, sliderHeight) {
      let selectionHeight = offset - VERTICAL_PADDING, slidableArea = sliderHeight - VERTICAL_PADDING * 2;
      return clamp.clamp(selectionHeight / slidableArea * 360, 0, 360);
    }
    function offsetForHue(hue, sliderHeight, draggerHeight) {
      let slidableArea = sliderHeight - (draggerHeight + VERTICAL_PADDING);
      return clamp.clamp(hue / 360 * slidableArea + VERTICAL_PADDING, 0, sliderHeight - draggerHeight);
    }
    exports.calculateDraggerY = calculateDraggerY;
    exports.hueForDraggerY = hueForDraggerY;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ColorPicker/components/HuePicker/HuePicker.js
var require_HuePicker = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ColorPicker/components/HuePicker/HuePicker.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), ColorPicker_module = require_ColorPicker_scss(), utilities = require_utilities4(), Slidable = require_Slidable(), HuePicker = class extends React12.PureComponent {
      constructor(...args) {
        super(...args), this.state = {
          sliderHeight: 0,
          draggerHeight: 0
        }, this.setSliderHeight = (node) => {
          node != null && (this.setState({
            sliderHeight: node.clientHeight
          }), process.env.NODE_ENV === "development" && setTimeout(() => {
            this.setState({
              sliderHeight: node.clientHeight
            });
          }, 0));
        }, this.setDraggerHeight = (height) => {
          this.setState({
            draggerHeight: height
          });
        }, this.handleChange = ({
          y
        }) => {
          let {
            onChange
          } = this.props, {
            sliderHeight
          } = this.state, hue = utilities.hueForDraggerY(y, sliderHeight);
          onChange(hue);
        };
      }
      render() {
        let {
          hue
        } = this.props, {
          sliderHeight,
          draggerHeight
        } = this.state, draggerY = utilities.calculateDraggerY(hue, sliderHeight, draggerHeight);
        return /* @__PURE__ */ React12.createElement("div", {
          className: ColorPicker_module.default.HuePicker,
          ref: this.setSliderHeight
        }, /* @__PURE__ */ React12.createElement(Slidable.Slidable, {
          draggerY,
          draggerX: 0,
          onChange: this.handleChange,
          onDraggerHeight: this.setDraggerHeight
        }));
      }
    };
    exports.HuePicker = HuePicker;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ColorPicker/ColorPicker.js
var require_ColorPicker = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ColorPicker/ColorPicker.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), debounce = require_debounce2(), clamp = require_clamp(), css = require_css(), colorTransformers = require_color_transformers(), ColorPicker_module = require_ColorPicker_scss(), AlphaPicker = require_AlphaPicker(), HuePicker = require_HuePicker(), Slidable = require_Slidable(), EventListener = require_EventListener(), RESIZE_DEBOUNCE_TIME_MS = 200, ColorPicker = class extends React12.PureComponent {
      constructor(...args) {
        super(...args), this.state = {
          pickerSize: {
            width: 0,
            height: 0
          }
        }, this.colorNode = null, this.handleResize = debounce.debounce(() => {
          let {
            colorNode
          } = this;
          colorNode != null && this.setState({
            pickerSize: {
              width: colorNode.clientWidth,
              height: colorNode.clientHeight
            }
          });
        }, RESIZE_DEBOUNCE_TIME_MS, {
          leading: !0,
          trailing: !0,
          maxWait: RESIZE_DEBOUNCE_TIME_MS
        }), this.setColorNode = (node) => {
          this.colorNode = node;
        }, this.handleHueChange = (hue) => {
          let {
            color: {
              brightness,
              saturation,
              alpha = 1
            },
            onChange
          } = this.props;
          onChange({
            hue,
            brightness,
            saturation,
            alpha
          });
        }, this.handleAlphaChange = (alpha) => {
          let {
            color: {
              hue,
              brightness,
              saturation
            },
            onChange
          } = this.props;
          onChange({
            hue,
            brightness,
            saturation,
            alpha
          });
        }, this.handleDraggerMove = ({
          x,
          y
        }) => {
          let {
            pickerSize
          } = this.state, {
            color: {
              hue,
              alpha = 1
            },
            onChange
          } = this.props, saturation = clamp.clamp(x / pickerSize.width, 0, 1), brightness = clamp.clamp(1 - y / pickerSize.height, 0, 1);
          onChange({
            hue,
            saturation,
            brightness,
            alpha
          });
        }, this.handlePickerDrag = (event) => {
          event.preventDefault();
        };
      }
      componentDidMount() {
        let {
          colorNode
        } = this;
        colorNode != null && (this.setState({
          pickerSize: {
            width: colorNode.clientWidth,
            height: colorNode.clientHeight
          }
        }), process.env.NODE_ENV === "development" && setTimeout(() => {
          this.setState({
            pickerSize: {
              width: colorNode.clientWidth,
              height: colorNode.clientHeight
            }
          });
        }, 0));
      }
      render() {
        let {
          id,
          color,
          allowAlpha,
          fullWidth
        } = this.props, {
          hue,
          saturation,
          brightness,
          alpha: providedAlpha
        } = color, {
          pickerSize
        } = this.state, alpha = providedAlpha != null && allowAlpha ? providedAlpha : 1, {
          red,
          green,
          blue
        } = colorTransformers.hsbToRgb({
          hue,
          saturation: 1,
          brightness: 1
        }), colorString = `rgba(${red}, ${green}, ${blue}, ${alpha})`, draggerX = clamp.clamp(saturation * pickerSize.width, 0, pickerSize.width), draggerY = clamp.clamp(pickerSize.height - brightness * pickerSize.height, 0, pickerSize.height), alphaSliderMarkup = allowAlpha ? /* @__PURE__ */ React12.createElement(AlphaPicker.AlphaPicker, {
          alpha,
          color,
          onChange: this.handleAlphaChange
        }) : null, className = css.classNames(ColorPicker_module.default.ColorPicker, fullWidth && ColorPicker_module.default.fullWidth);
        return /* @__PURE__ */ React12.createElement("div", {
          className,
          id,
          onMouseDown: this.handlePickerDrag
        }, /* @__PURE__ */ React12.createElement("div", {
          ref: this.setColorNode,
          className: ColorPicker_module.default.MainColor
        }, /* @__PURE__ */ React12.createElement("div", {
          className: ColorPicker_module.default.ColorLayer,
          style: {
            backgroundColor: colorString
          }
        }), /* @__PURE__ */ React12.createElement(Slidable.Slidable, {
          onChange: this.handleDraggerMove,
          draggerX,
          draggerY
        })), /* @__PURE__ */ React12.createElement(HuePicker.HuePicker, {
          hue,
          onChange: this.handleHueChange
        }), alphaSliderMarkup, /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
          event: "resize",
          handler: this.handleResize
        }));
      }
    };
    exports.ColorPicker = ColorPicker;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/InlineGrid/InlineGrid.scss.js
var require_InlineGrid_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/InlineGrid/InlineGrid.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      InlineGrid: "Polaris-InlineGrid"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/InlineGrid/InlineGrid.js
var require_InlineGrid = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/InlineGrid/InlineGrid.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), InlineGrid_module = require_InlineGrid_scss();
    function InlineGrid({
      children,
      columns: columns3,
      gap,
      alignItems
    }) {
      let style = {
        ...css.getResponsiveValue("inline-grid", "grid-template-columns", formatInlineGrid(columns3)),
        ...css.getResponsiveProps("inline-grid", "gap", "space", gap),
        "--pc-inline-grid-align-items": alignItems
      };
      return /* @__PURE__ */ React12.createElement("div", {
        className: InlineGrid_module.default.InlineGrid,
        style: css.sanitizeCustomProperties(style)
      }, children);
    }
    function formatInlineGrid(columns3) {
      return typeof columns3 == "object" && columns3 !== null && !Array.isArray(columns3) ? Object.fromEntries(Object.entries(columns3).map(([breakpointAlias, breakpointInlineGrid]) => [breakpointAlias, getColumnValue(breakpointInlineGrid)])) : getColumnValue(columns3);
    }
    function getColumnValue(columns3) {
      if (columns3)
        return typeof columns3 == "number" || !isNaN(Number(columns3)) ? `repeat(${Number(columns3)}, minmax(0, 1fr))` : typeof columns3 == "string" ? columns3 : columns3.map((column) => {
          switch (column) {
            case "oneThird":
              return "minmax(0, 1fr)";
            case "oneHalf":
              return "minmax(0, 1fr)";
            case "twoThirds":
              return "minmax(0, 2fr)";
          }
        }).join(" ");
    }
    exports.InlineGrid = InlineGrid;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/frame/context.js
var require_context15 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/frame/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), FrameContext = /* @__PURE__ */ React12.createContext(void 0);
    exports.FrameContext = FrameContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/frame/hooks.js
var require_hooks9 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/frame/hooks.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), context = require_context15();
    function useFrame() {
      let frame = React12.useContext(context.FrameContext);
      if (!frame)
        throw new Error("No Frame context was provided. Your component must be wrapped in a <Frame> component. See https://polaris.shopify.com/components/internal-only/frame for implementation instructions.");
      return frame;
    }
    exports.useFrame = useFrame;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ContextualSaveBar/ContextualSaveBar.js
var require_ContextualSaveBar = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ContextualSaveBar/ContextualSaveBar.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), hooks2 = require_hooks9(), ContextualSaveBar = /* @__PURE__ */ React12.memo(function({
      message,
      saveAction,
      discardAction,
      alignContentFlush,
      fullWidth,
      contextControl,
      secondaryMenu
    }) {
      let {
        setContextualSaveBar,
        removeContextualSaveBar
      } = hooks2.useFrame();
      return React12.useEffect(() => {
        setContextualSaveBar({
          message,
          saveAction,
          discardAction,
          alignContentFlush,
          fullWidth,
          contextControl,
          secondaryMenu
        });
      }, [message, saveAction, discardAction, alignContentFlush, setContextualSaveBar, fullWidth, contextControl, secondaryMenu]), React12.useEffect(() => removeContextualSaveBar, [removeContextualSaveBar]), null;
    });
    exports.ContextualSaveBar = ContextualSaveBar;
  }
});

// ../../node_modules/.pnpm/react-fast-compare@3.2.2/node_modules/react-fast-compare/index.js
var require_react_fast_compare = __commonJS({
  "../../node_modules/.pnpm/react-fast-compare@3.2.2/node_modules/react-fast-compare/index.js"(exports, module) {
    init_cjs_shims();
    var hasElementType = typeof Element < "u", hasMap = typeof Map == "function", hasSet = typeof Set == "function", hasArrayBuffer = typeof ArrayBuffer == "function" && !!ArrayBuffer.isView;
    function equal(a, b) {
      if (a === b)
        return !0;
      if (a && b && typeof a == "object" && typeof b == "object") {
        if (a.constructor !== b.constructor)
          return !1;
        var length, i, keys;
        if (Array.isArray(a)) {
          if (length = a.length, length != b.length)
            return !1;
          for (i = length; i-- !== 0; )
            if (!equal(a[i], b[i]))
              return !1;
          return !0;
        }
        var it;
        if (hasMap && a instanceof Map && b instanceof Map) {
          if (a.size !== b.size)
            return !1;
          for (it = a.entries(); !(i = it.next()).done; )
            if (!b.has(i.value[0]))
              return !1;
          for (it = a.entries(); !(i = it.next()).done; )
            if (!equal(i.value[1], b.get(i.value[0])))
              return !1;
          return !0;
        }
        if (hasSet && a instanceof Set && b instanceof Set) {
          if (a.size !== b.size)
            return !1;
          for (it = a.entries(); !(i = it.next()).done; )
            if (!b.has(i.value[0]))
              return !1;
          return !0;
        }
        if (hasArrayBuffer && ArrayBuffer.isView(a) && ArrayBuffer.isView(b)) {
          if (length = a.length, length != b.length)
            return !1;
          for (i = length; i-- !== 0; )
            if (a[i] !== b[i])
              return !1;
          return !0;
        }
        if (a.constructor === RegExp)
          return a.source === b.source && a.flags === b.flags;
        if (a.valueOf !== Object.prototype.valueOf && typeof a.valueOf == "function" && typeof b.valueOf == "function")
          return a.valueOf() === b.valueOf();
        if (a.toString !== Object.prototype.toString && typeof a.toString == "function" && typeof b.toString == "function")
          return a.toString() === b.toString();
        if (keys = Object.keys(a), length = keys.length, length !== Object.keys(b).length)
          return !1;
        for (i = length; i-- !== 0; )
          if (!Object.prototype.hasOwnProperty.call(b, keys[i]))
            return !1;
        if (hasElementType && a instanceof Element)
          return !1;
        for (i = length; i-- !== 0; )
          if (!((keys[i] === "_owner" || keys[i] === "__v" || keys[i] === "__o") && a.$$typeof) && !equal(a[keys[i]], b[keys[i]]))
            return !1;
        return !0;
      }
      return a !== a && b !== b;
    }
    module.exports = function(a, b) {
      try {
        return equal(a, b);
      } catch (error) {
        if ((error.message || "").match(/stack|recursion/i))
          return console.warn("react-fast-compare cannot handle circular refs"), !1;
        throw error;
      }
    };
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DataTable/utilities.js
var require_utilities5 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DataTable/utilities.js"(exports) {
    "use strict";
    init_cjs_shims();
    function measureColumn(tableData) {
      return function(column, index) {
        let {
          firstVisibleColumnIndex,
          tableLeftVisibleEdge: tableStart,
          tableRightVisibleEdge: tableEnd
        } = tableData, leftEdge = column.offsetLeft, rightEdge = leftEdge + column.offsetWidth, isVisibleLeft = isEdgeVisible(leftEdge, tableStart, tableEnd, "left"), isVisibleRight = isEdgeVisible(rightEdge, tableStart, tableEnd, "right"), isVisible = isVisibleLeft || isVisibleRight, width = column.offsetWidth;
        return isVisible && (tableData.firstVisibleColumnIndex = Math.min(firstVisibleColumnIndex, index)), {
          leftEdge,
          rightEdge,
          isVisible,
          width,
          index
        };
      };
    }
    function isEdgeVisible(position, start, end, edgeType) {
      return position >= start + (edgeType === "left" ? 0 : 30) && position <= end - 30;
    }
    function getPrevAndCurrentColumns(tableData, columnData) {
      let {
        firstVisibleColumnIndex
      } = tableData, previousColumnIndex = Math.max(firstVisibleColumnIndex - 1, 0), previousColumn = columnData[previousColumnIndex], currentColumn = columnData[firstVisibleColumnIndex];
      return {
        previousColumn,
        currentColumn
      };
    }
    exports.getPrevAndCurrentColumns = getPrevAndCurrentColumns;
    exports.isEdgeVisible = isEdgeVisible;
    exports.measureColumn = measureColumn;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DataTable/DataTable.scss.js
var require_DataTable_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DataTable/DataTable.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      DataTable: "Polaris-DataTable",
      condensed: "Polaris-DataTable--condensed",
      Navigation: "Polaris-DataTable__Navigation",
      Pip: "Polaris-DataTable__Pip",
      "Pip-visible": "Polaris-DataTable__Pip--visible",
      ScrollContainer: "Polaris-DataTable__ScrollContainer",
      Table: "Polaris-DataTable__Table",
      TableRow: "Polaris-DataTable__TableRow",
      Cell: "Polaris-DataTable__Cell",
      IncreasedTableDensity: "Polaris-DataTable__IncreasedTableDensity",
      ZebraStripingOnData: "Polaris-DataTable__ZebraStripingOnData",
      RowCountIsEven: "Polaris-DataTable__RowCountIsEven",
      ShowTotalsInFooter: "Polaris-DataTable__ShowTotalsInFooter",
      "Cell-separate": "Polaris-DataTable__Cell--separate",
      "Cell-firstColumn": "Polaris-DataTable__Cell--firstColumn",
      "Cell-numeric": "Polaris-DataTable__Cell--numeric",
      "Cell-truncated": "Polaris-DataTable__Cell--truncated",
      "Cell-header": "Polaris-DataTable__Cell--header",
      "Cell-sortable": "Polaris-DataTable__Cell--sortable",
      "Heading-left": "Polaris-DataTable__Heading--left",
      "Cell-verticalAlignTop": "Polaris-DataTable__Cell--verticalAlignTop",
      "Cell-verticalAlignBottom": "Polaris-DataTable__Cell--verticalAlignBottom",
      "Cell-verticalAlignMiddle": "Polaris-DataTable__Cell--verticalAlignMiddle",
      "Cell-verticalAlignBaseline": "Polaris-DataTable__Cell--verticalAlignBaseline",
      hoverable: "Polaris-DataTable--hoverable",
      "Cell-hovered": "Polaris-DataTable__Cell--hovered",
      Icon: "Polaris-DataTable__Icon",
      Heading: "Polaris-DataTable__Heading",
      StickyHeaderEnabled: "Polaris-DataTable__StickyHeaderEnabled",
      StickyHeaderWrapper: "Polaris-DataTable__StickyHeaderWrapper",
      "Cell-sorted": "Polaris-DataTable__Cell--sorted",
      "Cell-total": "Polaris-DataTable__Cell--total",
      ShowTotals: "Polaris-DataTable__ShowTotals",
      "Cell-total-footer": "Polaris-DataTable--cellTotalFooter",
      Footer: "Polaris-DataTable__Footer",
      StickyHeaderInner: "Polaris-DataTable__StickyHeaderInner",
      "StickyHeaderInner-isSticky": "Polaris-DataTable__StickyHeaderInner--isSticky",
      StickyHeaderTable: "Polaris-DataTable__StickyHeaderTable",
      FixedFirstColumn: "Polaris-DataTable__FixedFirstColumn",
      StickyTableHeadingsRow: "Polaris-DataTable__StickyTableHeadingsRow",
      TooltipContent: "Polaris-DataTable__TooltipContent"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DataTable/components/Cell/Cell.js
var require_Cell = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DataTable/components/Cell/Cell.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), shared = require_shared(), DataTable_module = require_DataTable_scss(), hooks2 = require_hooks2(), Tooltip = require_Tooltip(), Icon = require_Icon();
    function Cell({
      content,
      contentType,
      nthColumn,
      firstColumn,
      truncate,
      header: header2,
      total,
      totalInFooter,
      sorted,
      sortable,
      sortDirection,
      inFixedNthColumn,
      verticalAlign = "top",
      defaultSortDirection = "ascending",
      onSort,
      colSpan,
      setRef = () => {
      },
      stickyHeadingCell = !1,
      stickyCellWidth,
      hovered = !1,
      handleFocus = () => {
      },
      hasFixedNthColumn = !1,
      fixedCellVisible = !1,
      firstColumnMinWidth,
      style,
      lastFixedFirstColumn
    }) {
      let i18n = hooks2.useI18n(), numeric = contentType === "numeric", className = css.classNames(DataTable_module.default.Cell, DataTable_module.default[`Cell-${css.variationName("verticalAlign", verticalAlign)}`], firstColumn && DataTable_module.default["Cell-firstColumn"], truncate && DataTable_module.default["Cell-truncated"], header2 && DataTable_module.default["Cell-header"], total && DataTable_module.default["Cell-total"], totalInFooter && DataTable_module.default["Cell-total-footer"], numeric && DataTable_module.default["Cell-numeric"], sortable && DataTable_module.default["Cell-sortable"], sorted && DataTable_module.default["Cell-sorted"], stickyHeadingCell && DataTable_module.default.StickyHeaderCell, hovered && DataTable_module.default["Cell-hovered"], lastFixedFirstColumn && inFixedNthColumn && fixedCellVisible && DataTable_module.default["Cell-separate"], nthColumn && inFixedNthColumn && stickyHeadingCell && DataTable_module.default.FixedFirstColumn), headerClassName = css.classNames(header2 && DataTable_module.default.Heading, header2 && contentType === "text" && DataTable_module.default["Heading-left"]), iconClassName = css.classNames(sortable && DataTable_module.default.Icon), direction = sorted && sortDirection ? sortDirection : defaultSortDirection, source = direction === "descending" ? polarisIcons.SortDescendingIcon : polarisIcons.SortAscendingIcon, oppositeDirection = sortDirection === "ascending" ? "descending" : "ascending", sortAccessibilityLabel = i18n.translate("Polaris.DataTable.sortAccessibilityLabel", {
        direction: sorted ? oppositeDirection : direction
      }), iconMarkup = /* @__PURE__ */ React12.createElement("span", {
        className: iconClassName
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source,
        accessibilityLabel: sortAccessibilityLabel
      })), focusable = !(stickyHeadingCell && hasFixedNthColumn && nthColumn && !inFixedNthColumn), columnHeadingContent = sortable ? /* @__PURE__ */ React12.createElement("button", {
        className: headerClassName,
        onClick: onSort,
        onFocus: handleFocus,
        tabIndex: focusable ? 0 : -1
      }, iconMarkup, content) : content, colSpanProp = colSpan && colSpan > 1 ? {
        colSpan
      } : {}, minWidthStyles = nthColumn && firstColumnMinWidth ? {
        minWidth: firstColumnMinWidth
      } : {
        minWidth: stickyCellWidth
      }, stickyHeading = /* @__PURE__ */ React12.createElement("th", Object.assign({
        ref: setRef
      }, shared.headerCell.props, colSpanProp, {
        className,
        "aria-sort": sortDirection,
        style: {
          ...style,
          ...minWidthStyles
        },
        "data-index-table-sticky-heading": !0
      }), columnHeadingContent), headingMarkup = header2 ? /* @__PURE__ */ React12.createElement("th", Object.assign({}, shared.headerCell.props, {
        "aria-sort": sortDirection
      }, colSpanProp, {
        ref: setRef,
        className,
        scope: "col",
        style: {
          ...minWidthStyles
        }
      }), columnHeadingContent) : /* @__PURE__ */ React12.createElement("th", Object.assign({}, colSpanProp, {
        ref: setRef,
        className,
        scope: "row",
        style: {
          ...minWidthStyles
        }
      }), truncate ? /* @__PURE__ */ React12.createElement(TruncatedText, {
        className: DataTable_module.default.TooltipContent
      }, content) : content), cellMarkup = header2 || firstColumn || nthColumn ? headingMarkup : /* @__PURE__ */ React12.createElement("td", Object.assign({
        className
      }, colSpanProp), content);
      return stickyHeadingCell ? stickyHeading : cellMarkup;
    }
    var TruncatedText = ({
      children,
      className = ""
    }) => {
      let textRef = React12.useRef(null), {
        current
      } = textRef, text = /* @__PURE__ */ React12.createElement("span", {
        ref: textRef,
        className
      }, children);
      return current?.scrollWidth > current?.offsetWidth ? /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, {
        content: textRef.current.innerText
      }, text) : text;
    };
    exports.Cell = Cell;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/is-input-focused.js
var require_is_input_focused = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/is-input-focused.js"(exports) {
    "use strict";
    init_cjs_shims();
    var EditableTarget;
    (function(EditableTarget2) {
      EditableTarget2.Input = "INPUT", EditableTarget2.Textarea = "TEXTAREA", EditableTarget2.Select = "SELECT", EditableTarget2.ContentEditable = "contenteditable";
    })(EditableTarget || (EditableTarget = {}));
    function isInputFocused() {
      if (document == null || document.activeElement == null)
        return !1;
      let {
        tagName
      } = document.activeElement;
      return tagName === EditableTarget.Input || tagName === EditableTarget.Textarea || tagName === EditableTarget.Select || document.activeElement.hasAttribute(EditableTarget.ContentEditable);
    }
    exports.isInputFocused = isInputFocused;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Pagination/Pagination.scss.js
var require_Pagination_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Pagination/Pagination.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Pagination: "Polaris-Pagination",
      table: "Polaris-Pagination--table"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Pagination/Pagination.js
var require_Pagination = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Pagination/Pagination.js"(exports) {
    "use strict";
    init_cjs_shims();
    var polarisIcons = require_dist8(), React12 = require_react(), isInputFocused = require_is_input_focused(), css = require_css(), Pagination_module = require_Pagination_scss(), hooks2 = require_hooks2(), KeypressListener = require_KeypressListener(), Box2 = require_Box(), InlineStack2 = require_InlineStack(), ButtonGroup = require_ButtonGroup(), Tooltip = require_Tooltip(), Text4 = require_Text(), Button2 = require_Button();
    function Pagination({
      hasNext,
      hasPrevious,
      nextURL,
      previousURL,
      onNext,
      onPrevious,
      nextTooltip,
      previousTooltip,
      nextKeys,
      previousKeys,
      accessibilityLabel,
      accessibilityLabels,
      label,
      type = "page"
    }) {
      let i18n = hooks2.useI18n(), node = /* @__PURE__ */ React12.createRef(), navLabel = accessibilityLabel || i18n.translate("Polaris.Pagination.pagination"), previousLabel = accessibilityLabels?.previous || i18n.translate("Polaris.Pagination.previous"), nextLabel = accessibilityLabels?.next || i18n.translate("Polaris.Pagination.next"), prev = /* @__PURE__ */ React12.createElement(Button2.Button, {
        icon: polarisIcons.ChevronLeftIcon,
        accessibilityLabel: previousLabel,
        url: previousURL,
        onClick: onPrevious,
        disabled: !hasPrevious,
        id: "previousURL"
      }), constructedPrevious = previousTooltip && hasPrevious ? /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, {
        activatorWrapper: "span",
        content: previousTooltip,
        preferredPosition: "below"
      }, prev) : prev, next = /* @__PURE__ */ React12.createElement(Button2.Button, {
        icon: polarisIcons.ChevronRightIcon,
        accessibilityLabel: nextLabel,
        url: nextURL,
        onClick: onNext,
        disabled: !hasNext,
        id: "nextURL"
      }), constructedNext = nextTooltip && hasNext ? /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, {
        activatorWrapper: "span",
        content: nextTooltip,
        preferredPosition: "below"
      }, next) : next, previousHandler = onPrevious || noop, previousButtonEvents = previousKeys && (previousURL || onPrevious) && hasPrevious && previousKeys.map((key) => /* @__PURE__ */ React12.createElement(KeypressListener.KeypressListener, {
        key,
        keyCode: key,
        handler: handleCallback(previousURL ? clickPaginationLink("previousURL", node) : previousHandler)
      })), nextHandler = onNext || noop, nextButtonEvents = nextKeys && (nextURL || onNext) && hasNext && nextKeys.map((key) => /* @__PURE__ */ React12.createElement(KeypressListener.KeypressListener, {
        key,
        keyCode: key,
        handler: handleCallback(nextURL ? clickPaginationLink("nextURL", node) : nextHandler)
      }));
      if (type === "table") {
        let labelMarkup2 = label ? /* @__PURE__ */ React12.createElement(Text4.Text, {
          as: "span",
          variant: "bodySm",
          fontWeight: "medium"
        }, label) : null;
        return /* @__PURE__ */ React12.createElement("nav", {
          "aria-label": navLabel,
          ref: node,
          className: css.classNames(Pagination_module.default.Pagination, Pagination_module.default.table)
        }, previousButtonEvents, nextButtonEvents, /* @__PURE__ */ React12.createElement(Box2.Box, {
          background: "bg-surface-secondary",
          paddingBlockStart: "150",
          paddingBlockEnd: "150",
          paddingInlineStart: "300",
          paddingInlineEnd: "200"
        }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
          align: labelMarkup2 ? "space-between" : "end",
          blockAlign: "center"
        }, labelMarkup2, /* @__PURE__ */ React12.createElement(ButtonGroup.ButtonGroup, {
          variant: "segmented"
        }, constructedPrevious, constructedNext))));
      }
      let labelTextMarkup = hasNext && hasPrevious ? /* @__PURE__ */ React12.createElement("span", null, label) : /* @__PURE__ */ React12.createElement(Text4.Text, {
        tone: "subdued",
        as: "span"
      }, label), labelMarkup = label ? /* @__PURE__ */ React12.createElement(Box2.Box, {
        padding: "300",
        paddingBlockStart: "0",
        paddingBlockEnd: "0"
      }, /* @__PURE__ */ React12.createElement("div", {
        "aria-live": "polite"
      }, labelTextMarkup)) : null;
      return /* @__PURE__ */ React12.createElement("nav", {
        "aria-label": navLabel,
        ref: node,
        className: Pagination_module.default.Pagination
      }, previousButtonEvents, nextButtonEvents, /* @__PURE__ */ React12.createElement(ButtonGroup.ButtonGroup, {
        variant: "segmented"
      }, constructedPrevious, labelMarkup, constructedNext));
    }
    function clickPaginationLink(id, node) {
      return () => {
        if (node.current == null)
          return;
        let link2 = node.current.querySelector(`#${id}`);
        link2 && link2.click();
      };
    }
    function handleCallback(fn) {
      return () => {
        isInputFocused.isInputFocused() || fn();
      };
    }
    function noop() {
    }
    exports.Pagination = Pagination;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/AfterInitialMount/AfterInitialMount.js
var require_AfterInitialMount = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/AfterInitialMount/AfterInitialMount.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), useIsAfterInitialMount = require_use_is_after_initial_mount();
    function AfterInitialMount({
      children,
      onMount,
      fallback = null
    }) {
      let isMounted = useIsAfterInitialMount.useIsAfterInitialMount(), content = isMounted ? children : fallback;
      return React12.useEffect(() => {
        isMounted && onMount && onMount();
      }, [isMounted, onMount]), /* @__PURE__ */ React12.createElement(React12.Fragment, null, content);
    }
    exports.AfterInitialMount = AfterInitialMount;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/sticky-manager/hooks.js
var require_hooks10 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/sticky-manager/hooks.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), errors2 = require_errors6(), context = require_context4();
    function useStickyManager() {
      let stickyManager = React12.useContext(context.StickyManagerContext);
      if (!stickyManager)
        throw new errors2.MissingAppProviderError("No StickyManager was provided.");
      return stickyManager;
    }
    exports.useStickyManager = useStickyManager;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Sticky/Sticky.js
var require_Sticky = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Sticky/Sticky.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), geometry = require_geometry(), hooks2 = require_hooks10(), StickyInner = class extends React12.Component {
      constructor(...args) {
        super(...args), this.state = {
          isSticky: !1,
          style: {}
        }, this.placeHolderNode = null, this.stickyNode = null, this.setPlaceHolderNode = (node) => {
          this.placeHolderNode = node;
        }, this.setStickyNode = (node) => {
          this.stickyNode = node;
        }, this.handlePositioning = (stick, top = 0, left = 0, width = 0) => {
          let {
            isSticky
          } = this.state;
          (stick && !isSticky || !stick && isSticky) && (this.adjustPlaceHolderNode(stick), this.setState({
            isSticky: !isSticky
          }, () => {
            if (this.props.onStickyChange == null || (this.props.onStickyChange(!isSticky), this.props.boundingElement == null))
              return null;
            this.props.boundingElement.toggleAttribute("data-sticky-active");
          }));
          let style = stick ? {
            position: "fixed",
            top,
            left,
            width
          } : {};
          this.setState({
            style
          });
        }, this.adjustPlaceHolderNode = (add) => {
          this.placeHolderNode && this.stickyNode && (this.placeHolderNode.style.paddingBottom = add ? `${geometry.getRectForNode(this.stickyNode).height}px` : "0px");
        };
      }
      componentDidMount() {
        let {
          boundingElement,
          offset = !1,
          disableWhenStacked = !1,
          stickyManager
        } = this.props;
        !this.stickyNode || !this.placeHolderNode || stickyManager.registerStickyItem({
          stickyNode: this.stickyNode,
          placeHolderNode: this.placeHolderNode,
          handlePositioning: this.handlePositioning,
          offset,
          boundingElement,
          disableWhenStacked
        });
      }
      componentWillUnmount() {
        let {
          stickyManager
        } = this.props;
        this.stickyNode && stickyManager.unregisterStickyItem(this.stickyNode);
      }
      render() {
        let {
          style,
          isSticky
        } = this.state, {
          children
        } = this.props, childrenContent = isFunction(children) ? children(isSticky) : children;
        return /* @__PURE__ */ React12.createElement("div", null, /* @__PURE__ */ React12.createElement("div", {
          ref: this.setPlaceHolderNode
        }), /* @__PURE__ */ React12.createElement("div", {
          ref: this.setStickyNode,
          style
        }, childrenContent));
      }
    };
    function isFunction(arg) {
      return typeof arg == "function";
    }
    function Sticky(props) {
      let stickyManager = hooks2.useStickyManager();
      return /* @__PURE__ */ React12.createElement(StickyInner, Object.assign({}, props, {
        stickyManager
      }));
    }
    exports.Sticky = Sticky;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DataTable/components/Navigation/Navigation.js
var require_Navigation = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DataTable/components/Navigation/Navigation.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), DataTable_module = require_DataTable_scss(), hooks2 = require_hooks2(), Button2 = require_Button();
    function Navigation({
      columnVisibilityData,
      isScrolledFarthestLeft,
      isScrolledFarthestRight,
      navigateTableLeft,
      navigateTableRight,
      fixedFirstColumns,
      setRef = () => {
      }
    }) {
      let i18n = hooks2.useI18n(), pipMarkup = columnVisibilityData.map((column, index) => {
        if (index < fixedFirstColumns)
          return;
        let className = css.classNames(DataTable_module.default.Pip, column.isVisible && DataTable_module.default["Pip-visible"]);
        return /* @__PURE__ */ React12.createElement("div", {
          className,
          key: `pip-${index}`
        });
      }), leftA11yLabel = i18n.translate("Polaris.DataTable.navAccessibilityLabel", {
        direction: "left"
      }), rightA11yLabel = i18n.translate("Polaris.DataTable.navAccessibilityLabel", {
        direction: "right"
      });
      return /* @__PURE__ */ React12.createElement("div", {
        className: DataTable_module.default.Navigation,
        ref: setRef
      }, /* @__PURE__ */ React12.createElement(Button2.Button, {
        variant: "tertiary",
        icon: polarisIcons.ChevronLeftIcon,
        disabled: isScrolledFarthestLeft,
        accessibilityLabel: leftA11yLabel,
        onClick: navigateTableLeft
      }), pipMarkup, /* @__PURE__ */ React12.createElement(Button2.Button, {
        variant: "tertiary",
        icon: polarisIcons.ChevronRightIcon,
        disabled: isScrolledFarthestRight,
        accessibilityLabel: rightA11yLabel,
        onClick: navigateTableRight
      }));
    }
    exports.Navigation = Navigation;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DataTable/DataTable.js
var require_DataTable = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DataTable/DataTable.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), isEqual = require_react_fast_compare(), debounce = require_debounce2(), css = require_css(), shared = require_shared(), utilities = require_utilities5(), DataTable_module = require_DataTable_scss(), Cell = require_Cell(), Pagination = require_Pagination(), AfterInitialMount = require_AfterInitialMount(), Sticky = require_Sticky(), Navigation = require_Navigation(), hooks2 = require_hooks2(), EventListener = require_EventListener(), getRowClientHeights = (rows) => {
      let heights = [];
      return rows && rows.forEach((row) => {
        heights.push(row.clientHeight);
      }), heights;
    }, DataTableInner = class extends React12.PureComponent {
      constructor(...args) {
        super(...args), this.state = {
          condensed: !1,
          columnVisibilityData: [],
          isScrolledFarthestLeft: !0,
          isScrolledFarthestRight: !1,
          rowHovered: void 0
        }, this.dataTable = /* @__PURE__ */ React12.createRef(), this.scrollContainer = /* @__PURE__ */ React12.createRef(), this.table = /* @__PURE__ */ React12.createRef(), this.stickyTable = /* @__PURE__ */ React12.createRef(), this.stickyNav = null, this.headerNav = null, this.tableHeadings = [], this.stickyHeadings = [], this.tableHeadingWidths = [], this.stickyHeaderActive = !1, this.scrollStopTimer = null, this.handleResize = debounce.debounce(() => {
          let {
            table: {
              current: table
            },
            scrollContainer: {
              current: scrollContainer
            }
          } = this, condensed = !1;
          table && scrollContainer && (condensed = table.scrollWidth > scrollContainer.clientWidth + 1), this.setState({
            condensed,
            ...this.calculateColumnVisibilityData(condensed)
          });
        }), this.setCellRef = ({
          ref,
          index,
          inStickyHeader
        }) => {
          if (ref != null)
            if (inStickyHeader) {
              this.stickyHeadings[index] = ref;
              let button = ref.querySelector("button");
              if (button == null)
                return;
              button.addEventListener("focus", this.handleHeaderButtonFocus);
            } else
              this.tableHeadings[index] = ref, this.tableHeadingWidths[index] = ref.clientWidth;
        }, this.changeHeadingFocus = () => {
          let {
            tableHeadings,
            stickyHeadings,
            stickyNav,
            headerNav
          } = this, stickyFocusedItemIndex = stickyHeadings.findIndex((item) => item === document.activeElement?.parentElement), tableFocusedItemIndex = tableHeadings.findIndex((item) => item === document.activeElement?.parentElement), arrowsInStickyNav = stickyNav?.querySelectorAll("button"), arrowsInHeaderNav = headerNav?.querySelectorAll("button"), stickyFocusedNavIndex = -1;
          arrowsInStickyNav?.forEach((item, index) => {
            item === document.activeElement && (stickyFocusedNavIndex = index);
          });
          let headerFocusedNavIndex = -1;
          if (arrowsInHeaderNav?.forEach((item, index) => {
            item === document.activeElement && (headerFocusedNavIndex = index);
          }), stickyFocusedItemIndex < 0 && tableFocusedItemIndex < 0 && stickyFocusedNavIndex < 0 && headerFocusedNavIndex < 0)
            return null;
          let button;
          if (stickyFocusedItemIndex >= 0 ? button = tableHeadings[stickyFocusedItemIndex].querySelector("button") : tableFocusedItemIndex >= 0 && (button = stickyHeadings[tableFocusedItemIndex].querySelector("button")), stickyFocusedNavIndex >= 0 ? button = arrowsInHeaderNav?.[stickyFocusedNavIndex] : headerFocusedNavIndex >= 0 && (button = arrowsInStickyNav?.[headerFocusedNavIndex]), button == null)
            return null;
          button.style.visibility = "visible", button.focus(), button.style.removeProperty("visibility");
        }, this.calculateColumnVisibilityData = (condensed) => {
          let fixedFirstColumns = this.fixedFirstColumns(), {
            table: {
              current: table
            },
            scrollContainer: {
              current: scrollContainer
            },
            dataTable: {
              current: dataTable
            }
          } = this, {
            stickyHeader
          } = this.props;
          if ((stickyHeader || condensed) && table && scrollContainer && dataTable) {
            let headerCells = table.querySelectorAll(shared.headerCell.selector), rightMostHeader = headerCells[fixedFirstColumns - 1], nthColumnWidth = fixedFirstColumns ? rightMostHeader.offsetLeft + rightMostHeader.offsetWidth : 0;
            if (headerCells.length > 0) {
              let firstVisibleColumnIndex = headerCells.length - 1, tableLeftVisibleEdge = scrollContainer.scrollLeft + nthColumnWidth, tableRightVisibleEdge = scrollContainer.scrollLeft + dataTable.offsetWidth, tableData = {
                firstVisibleColumnIndex,
                tableLeftVisibleEdge,
                tableRightVisibleEdge
              }, columnVisibilityData = [...headerCells].map(utilities.measureColumn(tableData)), lastColumn = columnVisibilityData[columnVisibilityData.length - 1], isScrolledFarthestLeft = fixedFirstColumns ? tableLeftVisibleEdge === nthColumnWidth : tableLeftVisibleEdge === 0;
              return {
                columnVisibilityData,
                ...utilities.getPrevAndCurrentColumns(tableData, columnVisibilityData),
                isScrolledFarthestLeft,
                isScrolledFarthestRight: lastColumn.rightEdge <= tableRightVisibleEdge
              };
            }
          }
          return {
            columnVisibilityData: [],
            previousColumn: void 0,
            currentColumn: void 0
          };
        }, this.handleHeaderButtonFocus = (event) => {
          let fixedFirstColumns = this.fixedFirstColumns();
          if (this.scrollContainer.current == null || event.target == null || this.state.columnVisibilityData.length === 0)
            return;
          let currentCell = event.target.parentNode, tableScrollLeft = this.scrollContainer.current.scrollLeft, tableViewableWidth = this.scrollContainer.current.offsetWidth, tableRightEdge = tableScrollLeft + tableViewableWidth, nthColumnWidth = this.state.columnVisibilityData.length > 0 ? this.state.columnVisibilityData[fixedFirstColumns]?.rightEdge : 0, currentColumnLeftEdge = currentCell.offsetLeft, currentColumnRightEdge = currentCell.offsetLeft + currentCell.offsetWidth;
          tableScrollLeft > currentColumnLeftEdge - nthColumnWidth && (this.scrollContainer.current.scrollLeft = currentColumnLeftEdge - nthColumnWidth), currentColumnRightEdge > tableRightEdge && (this.scrollContainer.current.scrollLeft = currentColumnRightEdge - tableViewableWidth);
        }, this.stickyHeaderScrolling = () => {
          let {
            current: stickyTable
          } = this.stickyTable, {
            current: scrollContainer
          } = this.scrollContainer;
          stickyTable == null || scrollContainer == null || (stickyTable.scrollLeft = scrollContainer.scrollLeft);
        }, this.scrollListener = () => {
          this.scrollStopTimer && clearTimeout(this.scrollStopTimer), this.scrollStopTimer = setTimeout(() => {
            this.setState((prevState) => ({
              ...this.calculateColumnVisibilityData(prevState.condensed)
            }));
          }, 100), this.setState({
            isScrolledFarthestLeft: this.scrollContainer.current?.scrollLeft === 0
          }), this.props.stickyHeader && this.stickyHeaderActive && this.stickyHeaderScrolling();
        }, this.handleHover = (row) => () => {
          this.setState({
            rowHovered: row
          });
        }, this.handleFocus = (event) => {
          let fixedFirstColumns = this.fixedFirstColumns();
          if (this.scrollContainer.current == null || event.target == null)
            return;
          let currentCell = event.target.parentNode, nthColumnWidth = this.props ? this.state.columnVisibilityData[fixedFirstColumns]?.rightEdge : 0, desiredScrollLeft = currentCell.offsetLeft - nthColumnWidth;
          this.scrollContainer.current.scrollLeft > desiredScrollLeft && (this.scrollContainer.current.scrollLeft = desiredScrollLeft);
        }, this.navigateTable = (direction) => {
          let fixedFirstColumns = this.fixedFirstColumns(), {
            currentColumn,
            previousColumn
          } = this.state, nthColumnWidth = this.state.columnVisibilityData[fixedFirstColumns - 1]?.rightEdge;
          if (!currentColumn || !previousColumn)
            return;
          let prevWidths = 0;
          for (let index = 0; index < currentColumn.index; index++)
            prevWidths += this.state.columnVisibilityData[index].width;
          let {
            current: scrollContainer
          } = this.scrollContainer;
          return () => {
            let newScrollLeft = 0;
            fixedFirstColumns ? newScrollLeft = direction === "right" ? prevWidths - nthColumnWidth + currentColumn.width : prevWidths - previousColumn.width - nthColumnWidth : newScrollLeft = direction === "right" ? currentColumn.rightEdge : previousColumn.leftEdge, scrollContainer && (scrollContainer.scrollLeft = newScrollLeft, requestAnimationFrame(() => {
              this.setState((prevState) => ({
                ...this.calculateColumnVisibilityData(prevState.condensed)
              }));
            }));
          };
        }, this.renderHeading = ({
          heading,
          headingIndex,
          inFixedNthColumn,
          inStickyHeader
        }) => {
          let {
            sortable,
            truncate = !1,
            columnContentTypes,
            defaultSortDirection,
            initialSortColumnIndex = 0,
            verticalAlign,
            firstColumnMinWidth
          } = this.props, fixedFirstColumns = this.fixedFirstColumns(), {
            sortDirection = defaultSortDirection,
            sortedColumnIndex = initialSortColumnIndex,
            isScrolledFarthestLeft
          } = this.state, sortableHeadingProps, headingCellId = `heading-cell-${headingIndex}`, stickyHeaderId = `stickyheader-${headingIndex}`, id = inStickyHeader ? stickyHeaderId : headingCellId;
          if (sortable) {
            let isSortable = sortable[headingIndex], isSorted = isSortable && sortedColumnIndex === headingIndex;
            sortableHeadingProps = {
              defaultSortDirection,
              sorted: isSorted,
              sortable: isSortable,
              sortDirection: isSorted ? sortDirection : "none",
              onSort: this.defaultOnSort(headingIndex),
              fixedNthColumn: fixedFirstColumns,
              inFixedNthColumn: fixedFirstColumns
            };
          }
          let stickyCellWidth = inStickyHeader ? this.tableHeadingWidths[headingIndex] : void 0, fixedCellVisible = !isScrolledFarthestLeft, cellProps = {
            header: !0,
            stickyHeadingCell: inStickyHeader,
            content: heading,
            contentType: columnContentTypes[headingIndex],
            nthColumn: headingIndex < fixedFirstColumns,
            fixedFirstColumns,
            truncate,
            headingIndex,
            ...sortableHeadingProps,
            verticalAlign,
            handleFocus: this.handleFocus,
            stickyCellWidth,
            fixedCellVisible,
            firstColumnMinWidth
          };
          return inFixedNthColumn && inStickyHeader ? [/* @__PURE__ */ React12.createElement(Cell.Cell, Object.assign({
            key: id
          }, cellProps, {
            setRef: (ref) => {
              this.setCellRef({
                ref,
                index: headingIndex,
                inStickyHeader
              });
            },
            inFixedNthColumn: !1
          })), /* @__PURE__ */ React12.createElement(Cell.Cell, Object.assign({
            key: `${id}-sticky`
          }, cellProps, {
            setRef: (ref) => {
              this.setCellRef({
                ref,
                index: headingIndex,
                inStickyHeader
              });
            },
            inFixedNthColumn: !!fixedFirstColumns,
            lastFixedFirstColumn: headingIndex === fixedFirstColumns - 1,
            style: {
              left: this.state.columnVisibilityData[headingIndex]?.leftEdge
            }
          }))] : /* @__PURE__ */ React12.createElement(Cell.Cell, Object.assign({
            key: id
          }, cellProps, {
            setRef: (ref) => {
              this.setCellRef({
                ref,
                index: headingIndex,
                inStickyHeader
              });
            },
            lastFixedFirstColumn: headingIndex === fixedFirstColumns - 1,
            inFixedNthColumn
          }));
        }, this.totalsRowHeading = () => {
          let {
            i18n,
            totals,
            totalsName
          } = this.props, totalsLabel = totalsName || {
            singular: i18n.translate("Polaris.DataTable.totalRowHeading"),
            plural: i18n.translate("Polaris.DataTable.totalsRowHeading")
          };
          return totals && totals.filter((total) => total !== "").length > 1 ? totalsLabel.plural : totalsLabel.singular;
        }, this.renderTotals = ({
          total,
          index
        }) => {
          let fixedFirstColumns = this.fixedFirstColumns(), id = `totals-cell-${index}`, {
            truncate = !1,
            verticalAlign,
            columnContentTypes
          } = this.props, content, contentType;
          index === 0 && (content = this.totalsRowHeading()), total !== "" && index > 0 && (contentType = columnContentTypes[index], content = total);
          let totalInFooter = this.props.showTotalsInFooter;
          return /* @__PURE__ */ React12.createElement(Cell.Cell, {
            total: !0,
            totalInFooter,
            nthColumn: index <= fixedFirstColumns - 1,
            firstColumn: index === 0,
            key: id,
            content,
            contentType,
            truncate,
            verticalAlign
          });
        }, this.getColSpan = (rowLength, headingsLength, contentTypesLength, cellIndex) => {
          if (this.fixedFirstColumns())
            return 1;
          let rowLen = rowLength || 1, colLen = headingsLength || contentTypesLength, colSpan = Math.floor(colLen / rowLen), remainder = colLen % rowLen;
          return cellIndex === 0 ? colSpan + remainder : colSpan;
        }, this.defaultRenderRow = ({
          row,
          index,
          inFixedNthColumn,
          rowHeights
        }) => {
          let {
            columnContentTypes,
            truncate = !1,
            verticalAlign,
            hoverable = !0,
            headings
          } = this.props, {
            condensed
          } = this.state, fixedFirstColumns = this.fixedFirstColumns(), className = css.classNames(DataTable_module.default.TableRow, hoverable && DataTable_module.default.hoverable);
          return /* @__PURE__ */ React12.createElement("tr", {
            key: `row-${index}`,
            className,
            onMouseEnter: this.handleHover(index),
            onMouseLeave: this.handleHover()
          }, row.map((content, cellIndex) => {
            let hovered = index === this.state.rowHovered, id = `cell-${cellIndex}-row-${index}`, colSpan = this.getColSpan(row.length, headings.length, columnContentTypes.length, cellIndex);
            return /* @__PURE__ */ React12.createElement(Cell.Cell, {
              key: id,
              content,
              contentType: columnContentTypes[cellIndex],
              nthColumn: cellIndex <= fixedFirstColumns - 1,
              firstColumn: cellIndex === 0,
              truncate,
              verticalAlign,
              colSpan,
              hovered,
              style: rowHeights ? {
                height: `${rowHeights[index]}px`
              } : {},
              inFixedNthColumn: condensed && inFixedNthColumn
            });
          }));
        }, this.defaultOnSort = (headingIndex) => {
          let {
            onSort,
            defaultSortDirection = "ascending",
            initialSortColumnIndex
          } = this.props, {
            sortDirection = defaultSortDirection,
            sortedColumnIndex = initialSortColumnIndex
          } = this.state, newSortDirection = defaultSortDirection;
          return sortedColumnIndex === headingIndex && (newSortDirection = sortDirection === "ascending" ? "descending" : "ascending"), () => {
            this.setState({
              sortDirection: newSortDirection,
              sortedColumnIndex: headingIndex
            }, () => {
              onSort && onSort(headingIndex, newSortDirection);
            });
          };
        };
      }
      componentDidMount() {
        process.env.NODE_ENV === "development" ? setTimeout(() => {
          this.handleResize();
        }, 10) : this.handleResize();
      }
      componentDidUpdate(prevProps) {
        isEqual(prevProps, this.props) || this.handleResize();
      }
      componentWillUnmount() {
        this.handleResize.cancel();
      }
      render() {
        let {
          headings,
          totals,
          showTotalsInFooter,
          rows,
          footerContent,
          hideScrollIndicator = !1,
          increasedTableDensity = !1,
          hasZebraStripingOnData = !1,
          stickyHeader = !1,
          hasFixedFirstColumn: fixedFirstColumn = !1,
          pagination
        } = this.props, {
          condensed,
          columnVisibilityData,
          isScrolledFarthestLeft,
          isScrolledFarthestRight
        } = this.state;
        fixedFirstColumn && process.env.NODE_ENV === "development" && console.warn("Deprecation: The `hasFixedFirstColumn` prop on the `DataTable` has been deprecated. Use fixedFirstColumns={n} instead.");
        let fixedFirstColumns = this.fixedFirstColumns(), rowCountIsEven = rows.length % 2 === 0, className = css.classNames(DataTable_module.default.DataTable, condensed && DataTable_module.default.condensed, totals && DataTable_module.default.ShowTotals, showTotalsInFooter && DataTable_module.default.ShowTotalsInFooter, hasZebraStripingOnData && DataTable_module.default.ZebraStripingOnData, hasZebraStripingOnData && rowCountIsEven && DataTable_module.default.RowCountIsEven), wrapperClassName = css.classNames(DataTable_module.default.TableWrapper, condensed && DataTable_module.default.condensed, increasedTableDensity && DataTable_module.default.IncreasedTableDensity, stickyHeader && DataTable_module.default.StickyHeaderEnabled), headingMarkup = /* @__PURE__ */ React12.createElement("tr", null, headings.map((heading, index) => this.renderHeading({
          heading,
          headingIndex: index,
          inFixedNthColumn: !1,
          inStickyHeader: !1
        }))), totalsMarkup = totals ? /* @__PURE__ */ React12.createElement("tr", null, totals.map((total, index) => this.renderTotals({
          total,
          index
        }))) : null, nthColumns = rows.map((row) => row.slice(0, fixedFirstColumns)), nthHeadings = headings.slice(0, fixedFirstColumns), nthTotals = totals?.slice(0, fixedFirstColumns), tableHeaderRows = this.table.current?.children[0].childNodes, tableBodyRows = this.table.current?.children[1].childNodes, headerRowHeights = getRowClientHeights(tableHeaderRows), bodyRowHeights = getRowClientHeights(tableBodyRows), fixedNthColumnMarkup = condensed && fixedFirstColumns !== 0 && /* @__PURE__ */ React12.createElement("table", {
          className: css.classNames(DataTable_module.default.FixedFirstColumn, !isScrolledFarthestLeft && DataTable_module.default.separate),
          style: {
            width: `${columnVisibilityData[fixedFirstColumns - 1]?.rightEdge}px`
          }
        }, /* @__PURE__ */ React12.createElement("thead", null, /* @__PURE__ */ React12.createElement("tr", {
          style: {
            height: `${headerRowHeights[0]}px`
          }
        }, nthHeadings.map((heading, index) => this.renderHeading({
          heading,
          headingIndex: index,
          inFixedNthColumn: !0,
          inStickyHeader: !1
        }))), totals && !showTotalsInFooter && /* @__PURE__ */ React12.createElement("tr", {
          style: {
            height: `${headerRowHeights[1]}px`
          }
        }, nthTotals?.map((total, index) => this.renderTotals({
          total,
          index
        })))), /* @__PURE__ */ React12.createElement("tbody", null, nthColumns.map((row, index) => this.defaultRenderRow({
          row,
          index,
          inFixedNthColumn: !0,
          rowHeights: bodyRowHeights
        }))), totals && showTotalsInFooter && /* @__PURE__ */ React12.createElement("tfoot", null, /* @__PURE__ */ React12.createElement("tr", null, nthTotals?.map((total, index) => this.renderTotals({
          total,
          index
        }))))), bodyMarkup = rows.map((row, index) => this.defaultRenderRow({
          row,
          index,
          inFixedNthColumn: !1
        })), footerMarkup = footerContent ? /* @__PURE__ */ React12.createElement("div", {
          className: DataTable_module.default.Footer
        }, footerContent) : null, paginationMarkup = pagination ? /* @__PURE__ */ React12.createElement(Pagination.Pagination, Object.assign({
          type: "table"
        }, pagination)) : null, headerTotalsMarkup = showTotalsInFooter ? null : totalsMarkup, footerTotalsMarkup = showTotalsInFooter ? /* @__PURE__ */ React12.createElement("tfoot", null, totalsMarkup) : null, navigationMarkup = (location2) => hideScrollIndicator ? null : /* @__PURE__ */ React12.createElement(Navigation.Navigation, {
          columnVisibilityData,
          isScrolledFarthestLeft,
          isScrolledFarthestRight,
          navigateTableLeft: this.navigateTable("left"),
          navigateTableRight: this.navigateTable("right"),
          fixedFirstColumns,
          setRef: (ref) => {
            location2 === "header" ? this.headerNav = ref : location2 === "sticky" && (this.stickyNav = ref);
          }
        }), stickyHeaderMarkup = stickyHeader ? /* @__PURE__ */ React12.createElement(AfterInitialMount.AfterInitialMount, null, /* @__PURE__ */ React12.createElement("div", {
          className: DataTable_module.default.StickyHeaderWrapper,
          role: "presentation"
        }, /* @__PURE__ */ React12.createElement(Sticky.Sticky, {
          boundingElement: this.dataTable.current,
          onStickyChange: (isSticky) => {
            this.changeHeadingFocus(), this.stickyHeaderActive = isSticky;
          }
        }, (isSticky) => {
          let stickyHeaderInnerClassNames = css.classNames(DataTable_module.default.StickyHeaderInner, isSticky && DataTable_module.default["StickyHeaderInner-isSticky"]), stickyHeaderTableClassNames = css.classNames(DataTable_module.default.StickyHeaderTable, !isScrolledFarthestLeft && DataTable_module.default.separate);
          return /* @__PURE__ */ React12.createElement("div", {
            className: stickyHeaderInnerClassNames
          }, /* @__PURE__ */ React12.createElement("div", null, navigationMarkup("sticky")), /* @__PURE__ */ React12.createElement("table", {
            className: stickyHeaderTableClassNames,
            ref: this.stickyTable
          }, /* @__PURE__ */ React12.createElement("thead", null, /* @__PURE__ */ React12.createElement("tr", {
            className: DataTable_module.default.StickyTableHeadingsRow
          }, headings.map((heading, index) => this.renderHeading({
            heading,
            headingIndex: index,
            inFixedNthColumn: !!(index <= fixedFirstColumns - 1 && fixedFirstColumns),
            inStickyHeader: !0
          }))))));
        }))) : null;
        return /* @__PURE__ */ React12.createElement("div", {
          className: wrapperClassName,
          ref: this.dataTable
        }, stickyHeaderMarkup, navigationMarkup("header"), /* @__PURE__ */ React12.createElement("div", {
          className
        }, /* @__PURE__ */ React12.createElement("div", {
          className: DataTable_module.default.ScrollContainer,
          ref: this.scrollContainer
        }, /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
          event: "resize",
          handler: this.handleResize
        }), /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
          capture: !0,
          passive: !0,
          event: "scroll",
          handler: this.scrollListener
        }), fixedNthColumnMarkup, /* @__PURE__ */ React12.createElement("table", {
          className: DataTable_module.default.Table,
          ref: this.table
        }, /* @__PURE__ */ React12.createElement("thead", null, headingMarkup, headerTotalsMarkup), /* @__PURE__ */ React12.createElement("tbody", null, bodyMarkup), footerTotalsMarkup)), paginationMarkup, footerMarkup));
      }
      fixedFirstColumns() {
        let {
          hasFixedFirstColumn,
          fixedFirstColumns = 0,
          headings
        } = this.props, numberOfFixedFirstColumns = hasFixedFirstColumn && !fixedFirstColumns ? 1 : fixedFirstColumns;
        return numberOfFixedFirstColumns >= headings.length ? 0 : numberOfFixedFirstColumns;
      }
      // eslint-disable-next-line @shopify/react-no-multiple-render-methods
      // eslint-disable-next-line @shopify/react-no-multiple-render-methods
    };
    function DataTable(props) {
      let i18n = hooks2.useI18n();
      return /* @__PURE__ */ React12.createElement(DataTableInner, Object.assign({}, props, {
        i18n
      }));
    }
    exports.DataTable = DataTable;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/dates.js
var require_dates = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/dates.js"(exports) {
    "use strict";
    init_cjs_shims();
    function getWeeksForMonth(month, year, weekStartsOn = 0) {
      let firstOfMonth = new Date(year, month, 1), firstDayOfWeek = firstOfMonth.getDay(), weeks = [[]], currentWeek = weeks[0], currentDate = firstOfMonth, orderedWeekday = getOrderedWeekdays(weekStartsOn);
      for (let i = 0; i < orderedWeekday.indexOf(firstDayOfWeek); i++)
        currentWeek.push(null);
      for (; currentDate.getMonth() === month; )
        currentWeek.length === 7 && (currentWeek = [], weeks.push(currentWeek)), currentWeek.push(currentDate), currentDate = new Date(year, month, currentDate.getDate() + 1);
      for (; currentWeek.length < 7; )
        currentWeek.push(null);
      return weeks;
    }
    function dateIsInRange(day, range) {
      if (day == null)
        return !1;
      let {
        start,
        end
      } = range;
      return !!(start && day > start && end && day < end);
    }
    function dateIsSelected(day, range) {
      if (day == null)
        return !1;
      let {
        start,
        end
      } = range;
      return !!(start && isSameDay(start, day) || end && isSameDay(end, day));
    }
    function isSameDay(day1, day2) {
      return day1.getDate() === day2.getDate() && day1.getMonth() === day2.getMonth() && day1.getFullYear() === day2.getFullYear();
    }
    function getNewRange(range, selected) {
      if (range == null)
        return {
          start: selected,
          end: selected
        };
      let {
        start,
        end
      } = range;
      return end && (isDateAfter(start, end) || isDateBefore(start, end)) ? {
        start: selected,
        end: selected
      } : start ? isDateBefore(selected, start) ? {
        start: selected,
        end: selected
      } : {
        start,
        end: selected
      } : end ? isDateBefore(selected, end) ? {
        start: selected,
        end
      } : {
        start: start || end,
        end: selected
      } : {
        start: selected,
        end: selected
      };
    }
    function getNextDisplayMonth(month) {
      return month === 11 ? 0 : month + 1;
    }
    function getNextDisplayYear(month, year) {
      return month === 11 ? year + 1 : year;
    }
    function getPreviousDisplayMonth(month) {
      return month === 0 ? 11 : month - 1;
    }
    function getPreviousDisplayYear(month, year) {
      return month === 0 ? year - 1 : year;
    }
    function isDateAfter(date, dateToCompare) {
      return date.getTime() > dateToCompare.getTime();
    }
    function isDateBefore(date, dateToCompare) {
      return date.getTime() < dateToCompare.getTime();
    }
    function isDateDisabled(date, datesToCompare) {
      return datesToCompare.some((dateToCompare) => date.getTime() === dateToCompare.getTime());
    }
    var WEEKDAYS = [0, 1, 2, 3, 4, 5, 6];
    function getOrderedWeekdays(weekStartsOn) {
      let weekDays = [...WEEKDAYS];
      return [...weekDays.splice(weekStartsOn), ...weekDays];
    }
    exports.dateIsInRange = dateIsInRange;
    exports.dateIsSelected = dateIsSelected;
    exports.getNewRange = getNewRange;
    exports.getNextDisplayMonth = getNextDisplayMonth;
    exports.getNextDisplayYear = getNextDisplayYear;
    exports.getOrderedWeekdays = getOrderedWeekdays;
    exports.getPreviousDisplayMonth = getPreviousDisplayMonth;
    exports.getPreviousDisplayYear = getPreviousDisplayYear;
    exports.getWeeksForMonth = getWeeksForMonth;
    exports.isDateAfter = isDateAfter;
    exports.isDateBefore = isDateBefore;
    exports.isDateDisabled = isDateDisabled;
    exports.isSameDay = isSameDay;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DatePicker/utilities.js
var require_utilities6 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DatePicker/utilities.js"(exports) {
    "use strict";
    init_cjs_shims();
    function monthName(month) {
      switch (month) {
        case 0:
          return "january";
        case 1:
          return "february";
        case 2:
          return "march";
        case 3:
          return "april";
        case 4:
          return "may";
        case 5:
          return "june";
        case 6:
          return "july";
        case 7:
          return "august";
        case 8:
          return "september";
        case 9:
          return "october";
        case 10:
          return "november";
        case 11:
          return "december";
      }
    }
    function weekdayName(weekday) {
      switch (weekday) {
        case 0:
          return "sunday";
        case 1:
          return "monday";
        case 2:
          return "tuesday";
        case 3:
          return "wednesday";
        case 4:
          return "thursday";
        case 5:
          return "friday";
        case 6:
          return "saturday";
      }
    }
    exports.monthName = monthName;
    exports.weekdayName = weekdayName;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DatePicker/DatePicker.scss.js
var require_DatePicker_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DatePicker/DatePicker.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      DatePicker: "Polaris-DatePicker",
      MonthLayout: "Polaris-DatePicker__MonthLayout",
      MonthContainer: "Polaris-DatePicker__MonthContainer",
      Month: "Polaris-DatePicker__Month",
      "Month-current": "Polaris-DatePicker__Month--current",
      DayCell: "Polaris-DatePicker__DayCell",
      "DayCell-inRange": "Polaris-DatePicker__DayCell--inRange",
      Day: "Polaris-DatePicker__Day",
      "Day-today": "Polaris-DatePicker__Day--today",
      "Day-inRange": "Polaris-DatePicker__Day--inRange",
      "Day-selected": "Polaris-DatePicker__Day--selected",
      "Day-disabled": "Polaris-DatePicker__Day--disabled",
      EmptyDayCell: "Polaris-DatePicker__EmptyDayCell",
      Weekday: "Polaris-DatePicker__Weekday",
      "Weekday-current": "Polaris-DatePicker__Weekday--current",
      Header: "Polaris-DatePicker__Header",
      Title: "Polaris-DatePicker__Title",
      "Day-firstInRange": "Polaris-DatePicker__Day--firstInRange",
      "Day-hasRange": "Polaris-DatePicker__Day--hasRange",
      "Day-hoverRight": "Polaris-DatePicker__Day--hoverRight",
      "Day-lastInRange": "Polaris-DatePicker__Day--lastInRange",
      Week: "Polaris-DatePicker__Week"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DatePicker/components/Weekday/Weekday.js
var require_Weekday = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DatePicker/components/Weekday/Weekday.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), DatePicker_module = require_DatePicker_scss(), Weekday = /* @__PURE__ */ React12.memo(function({
      label,
      title,
      current
    }) {
      let className = css.classNames(DatePicker_module.default.Weekday, current && DatePicker_module.default["Weekday-current"]);
      return /* @__PURE__ */ React12.createElement("th", {
        "aria-label": label,
        scope: "col",
        className
      }, title);
    });
    exports.Weekday = Weekday;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DatePicker/components/Day/Day.js
var require_Day = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DatePicker/components/Day/Day.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), dates = require_dates(), utilities = require_utilities6(), DatePicker_module = require_DatePicker_scss(), hooks2 = require_hooks2(), Day = /* @__PURE__ */ React12.memo(function({
      day,
      focused,
      onClick,
      onHover = noop,
      onFocus = noop,
      selected,
      inRange,
      inHoveringRange,
      disabled,
      lastDayOfMonth,
      isLastSelectedDay,
      isFirstSelectedDay,
      isHoveringRight,
      rangeIsDifferent,
      weekday,
      selectedAccessibilityLabelPrefix
    }) {
      let i18n = hooks2.useI18n(), dayNode = React12.useRef(null), hoverValue = lastDayOfMonth || day;
      if (React12.useEffect(() => {
        focused && dayNode.current && dayNode.current.focus();
      }, [focused]), !day)
        return /* @__PURE__ */ React12.createElement("td", {
          className: DatePicker_module.default.EmptyDayCell,
          onMouseOver: () => onHover(hoverValue)
        });
      let handleClick = onClick && !disabled ? onClick.bind(null, day) : noop, today = dates.isSameDay(/* @__PURE__ */ new Date(), day), dayCellClassName = css.classNames(DatePicker_module.default.DayCell, selected && DatePicker_module.default["DayCell-selected"], (inRange || inHoveringRange) && !disabled && DatePicker_module.default["DayCell-inRange"], isLastSelectedDay && DatePicker_module.default["DayCell-lastInRange"], isFirstSelectedDay && DatePicker_module.default["DayCell-firstInRange"], isHoveringRight && DatePicker_module.default["DayCell-hoverRight"], rangeIsDifferent && DatePicker_module.default["DayCell-hasRange"]), dayClassName = css.classNames(DatePicker_module.default.Day, selected && DatePicker_module.default["Day-selected"], disabled && DatePicker_module.default["Day-disabled"], today && DatePicker_module.default["Day-today"], (inRange || inHoveringRange) && !disabled && DatePicker_module.default["Day-inRange"], isLastSelectedDay && DatePicker_module.default["Day-lastInRange"], isFirstSelectedDay && DatePicker_module.default["Day-firstInRange"], isHoveringRight && DatePicker_module.default["Day-hoverRight"], rangeIsDifferent && DatePicker_module.default["Day-hasRange"]), date = day.getDate(), tabIndex = (focused || selected || today || date === 1) && !disabled ? 0 : -1, ariaLabel = [selected && selectedAccessibilityLabelPrefix ? `${selectedAccessibilityLabelPrefix} ` : "", `${today ? i18n.translate("Polaris.DatePicker.today") : ""}`, `${weekday || ""} `, `${i18n.translate(`Polaris.DatePicker.months.${utilities.monthName(day.getMonth())}`)} `, `${date} `, `${day.getFullYear()}`].join("");
      return /* @__PURE__ */ React12.createElement("td", {
        className: dayCellClassName
      }, /* @__PURE__ */ React12.createElement("button", {
        onFocus: () => onFocus(day),
        type: "button",
        ref: dayNode,
        tabIndex,
        className: dayClassName,
        onMouseOver: () => onHover(hoverValue),
        onClick: handleClick,
        "aria-label": ariaLabel,
        "aria-disabled": disabled,
        "aria-pressed": selected
      }, date));
    });
    function noop() {
    }
    exports.Day = Day;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DatePicker/components/Month/Month.js
var require_Month = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DatePicker/components/Month/Month.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), dates = require_dates(), DatePicker_module = require_DatePicker_scss(), utilities = require_utilities6(), Weekday = require_Weekday(), Day = require_Day(), hooks2 = require_hooks2();
    function Month({
      focusedDate,
      selected,
      hoverDate,
      disableDatesBefore,
      disableDatesAfter,
      disableSpecificDates,
      allowRange,
      onChange = noop,
      onHover = noop,
      onFocus = noop,
      month,
      year,
      weekStartsOn,
      accessibilityLabelPrefixes
    }) {
      let i18n = hooks2.useI18n(), isInHoveringRange = allowRange ? hoveringDateIsInRange : () => !1, now = /* @__PURE__ */ new Date(), current = now.getMonth() === month && now.getFullYear() === year, className = css.classNames(DatePicker_module.default.Title, current && DatePicker_module.default["Month-current"]), weeks = React12.useMemo(() => dates.getWeeksForMonth(month, year, weekStartsOn), [month, weekStartsOn, year]), weekdays = dates.getOrderedWeekdays(weekStartsOn).map((weekday) => /* @__PURE__ */ React12.createElement(Weekday.Weekday, {
        key: weekday,
        title: i18n.translate(`Polaris.DatePicker.daysAbbreviated.${utilities.weekdayName(weekday)}`),
        label: weekdayLabel(weekday),
        current: current && (/* @__PURE__ */ new Date()).getDay() === weekday
      })), handleDateClick = React12.useCallback((selectedDate) => {
        onChange(dates.getNewRange(allowRange ? selected : void 0, selectedDate));
      }, [allowRange, onChange, selected]), lastDayOfMonth = React12.useMemo(() => new Date(year, month + 1, 0), [month, year]);
      function renderWeek(day, dayIndex) {
        if (day == null)
          return /* @__PURE__ */ React12.createElement(Day.Day, {
            key: dayIndex,
            onHover,
            lastDayOfMonth
          });
        let disabled = disableDatesBefore && dates.isDateBefore(day, disableDatesBefore) || disableDatesAfter && dates.isDateAfter(day, disableDatesAfter) || disableSpecificDates && dates.isDateDisabled(day, disableSpecificDates), isFirstSelectedDay = allowRange && selected && isDateStart(day, selected), isLastSelectedDay = allowRange && selected && (!dates.isSameDay(selected.start, selected.end) && isDateEnd(day, selected) || hoverDate && dates.isSameDay(selected.start, selected.end) && dates.isDateAfter(hoverDate, selected.start) && dates.isSameDay(day, hoverDate) && !isFirstSelectedDay), rangeIsDifferent = !(selected && dates.isSameDay(selected.start, selected.end)), isHoveringRight = hoverDate && dates.isDateBefore(day, hoverDate), [firstAccessibilityLabelPrefix, lastAccessibilityLabelPrefix] = accessibilityLabelPrefixes, accessibilityLabelPrefix;
        return allowRange && isFirstSelectedDay || !allowRange && firstAccessibilityLabelPrefix ? accessibilityLabelPrefix = firstAccessibilityLabelPrefix : allowRange && isLastSelectedDay && (accessibilityLabelPrefix = lastAccessibilityLabelPrefix), /* @__PURE__ */ React12.createElement(Day.Day, {
          selectedAccessibilityLabelPrefix: accessibilityLabelPrefix,
          weekday: weekdayLabel(dayIndex),
          focused: focusedDate != null && dates.isSameDay(day, focusedDate),
          day,
          key: dayIndex,
          onFocus,
          onClick: handleDateClick,
          onHover,
          selected: selected != null && dates.dateIsSelected(day, selected),
          inRange: selected != null && dates.dateIsInRange(day, selected),
          disabled,
          inHoveringRange: selected != null && hoverDate != null && isInHoveringRange(day, selected, hoverDate),
          isLastSelectedDay,
          isFirstSelectedDay,
          isHoveringRight,
          rangeIsDifferent
        });
      }
      let weeksMarkup = weeks.map((week, index) => /* @__PURE__ */ React12.createElement("tr", {
        className: DatePicker_module.default.Week,
        key: index
      }, week.map(renderWeek)));
      return /* @__PURE__ */ React12.createElement("div", {
        className: DatePicker_module.default.MonthContainer
      }, /* @__PURE__ */ React12.createElement("table", {
        role: "grid",
        className: DatePicker_module.default.Month
      }, /* @__PURE__ */ React12.createElement("caption", {
        className
      }, i18n.translate(`Polaris.DatePicker.months.${utilities.monthName(month)}`), " ", year), /* @__PURE__ */ React12.createElement("thead", null, /* @__PURE__ */ React12.createElement("tr", {
        className: DatePicker_module.default.WeekHeadings
      }, weekdays)), /* @__PURE__ */ React12.createElement("tbody", null, weeksMarkup)));
      function weekdayLabel(weekday) {
        return i18n.translate(`Polaris.DatePicker.days.${utilities.weekdayName(weekday)}`);
      }
    }
    function noop() {
    }
    function hoveringDateIsInRange(day, range, hoverEndDate) {
      if (day == null)
        return !1;
      let {
        start,
        end
      } = range;
      return !!(dates.isSameDay(start, end) && day > start && day <= hoverEndDate);
    }
    function isDateEnd(day, range) {
      if (day == null)
        return !1;
      let {
        end
      } = range;
      return !!(end && dates.isSameDay(end, day));
    }
    function isDateStart(day, range) {
      if (day == null)
        return !1;
      let {
        start
      } = range;
      return !!(start && dates.isSameDay(start, day));
    }
    exports.Month = Month;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DatePicker/DatePicker.js
var require_DatePicker = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DatePicker/DatePicker.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), dates = require_dates(), utilities = require_utilities6(), DatePicker_module = require_DatePicker_scss(), Month = require_Month(), hooks2 = require_hooks2(), Button2 = require_Button();
    function DatePicker({
      id,
      selected,
      month,
      year,
      allowRange,
      multiMonth,
      disableDatesBefore,
      disableDatesAfter,
      disableSpecificDates,
      weekStartsOn = 0,
      dayAccessibilityLabelPrefix,
      onMonthChange,
      onChange = noop
    }) {
      let i18n = hooks2.useI18n(), [hoverDate, setHoverDate] = React12.useState(void 0), [focusDate, setFocusDate] = React12.useState(void 0);
      React12.useEffect(() => {
        setFocusDate(void 0);
      }, [selected]);
      let handleFocus = React12.useCallback((date) => {
        setFocusDate(date);
      }, []), setFocusDateAndHandleMonthChange = React12.useCallback((date) => {
        onMonthChange && onMonthChange(date.getMonth(), date.getFullYear()), setHoverDate(date), setFocusDate(date);
      }, [onMonthChange]), handleDateSelection = React12.useCallback((range) => {
        let {
          end
        } = range;
        setHoverDate(end), setFocusDate(new Date(end)), onChange(range);
      }, [onChange]), handleMonthChangeClick = React12.useCallback((month2, year2) => {
        onMonthChange && (setFocusDate(void 0), onMonthChange(month2, year2));
      }, [onMonthChange]), handleHover = React12.useCallback((date) => {
        setHoverDate(date);
      }, []), handleKeyUp = React12.useCallback((event) => {
        let {
          key
        } = event, range = deriveRange(selected), focusedDate = focusDate || range && range.start;
        if (focusedDate != null) {
          if (key === "ArrowUp") {
            let previousWeek = new Date(focusedDate);
            previousWeek.setDate(focusedDate.getDate() - 7), disableDatesBefore && dates.isDateBefore(previousWeek, disableDatesBefore) || disableSpecificDates && dates.isDateDisabled(previousWeek, disableSpecificDates) || setFocusDateAndHandleMonthChange(previousWeek);
          }
          if (key === "ArrowDown") {
            let nextWeek = new Date(focusedDate);
            nextWeek.setDate(focusedDate.getDate() + 7), disableDatesAfter && dates.isDateAfter(nextWeek, disableDatesAfter) || disableSpecificDates && dates.isDateDisabled(nextWeek, disableSpecificDates) || setFocusDateAndHandleMonthChange(nextWeek);
          }
          if (key === "ArrowRight") {
            let tomorrow = new Date(focusedDate);
            tomorrow.setDate(focusedDate.getDate() + 1), disableDatesAfter && dates.isDateAfter(tomorrow, disableDatesAfter) || disableSpecificDates && dates.isDateDisabled(tomorrow, disableSpecificDates) || setFocusDateAndHandleMonthChange(tomorrow);
          }
          if (key === "ArrowLeft") {
            let yesterday = new Date(focusedDate);
            yesterday.setDate(focusedDate.getDate() - 1), disableDatesBefore && dates.isDateBefore(yesterday, disableDatesBefore) || disableSpecificDates && dates.isDateDisabled(yesterday, disableSpecificDates) || setFocusDateAndHandleMonthChange(yesterday);
          }
        }
      }, [disableDatesAfter, disableDatesBefore, disableSpecificDates, focusDate, selected, setFocusDateAndHandleMonthChange]), showNextYear = dates.getNextDisplayYear(month, year), showNextMonth = dates.getNextDisplayMonth(month), showNextToNextYear = dates.getNextDisplayYear(showNextMonth, showNextYear), showNextToNextMonth = dates.getNextDisplayMonth(showNextMonth), showPreviousYear = dates.getPreviousDisplayYear(month, year), showPreviousMonth = dates.getPreviousDisplayMonth(month), previousMonthName = i18n.translate(`Polaris.DatePicker.months.${utilities.monthName(showPreviousMonth)}`), nextMonth = multiMonth ? i18n.translate(`Polaris.DatePicker.months.${utilities.monthName(showNextToNextMonth)}`) : i18n.translate(`Polaris.DatePicker.months.${utilities.monthName(showNextMonth)}`), nextYear = multiMonth ? showNextToNextYear : showNextYear, monthIsSelected = React12.useMemo(() => deriveRange(selected), [selected]), firstDatePickerAccessibilityLabelPrefix = allowRange ? i18n.translate("Polaris.DatePicker.start") : dayAccessibilityLabelPrefix, secondDatePickerAccessibilityLabelPrefix = i18n.translate("Polaris.DatePicker.end"), accessibilityLabelPrefixes = [firstDatePickerAccessibilityLabelPrefix, secondDatePickerAccessibilityLabelPrefix], secondDatePicker = multiMonth ? /* @__PURE__ */ React12.createElement(Month.Month, {
        onFocus: handleFocus,
        focusedDate: focusDate,
        month: showNextMonth,
        year: showNextYear,
        selected: monthIsSelected,
        hoverDate,
        onChange: handleDateSelection,
        onHover: handleHover,
        disableDatesBefore,
        disableDatesAfter,
        disableSpecificDates,
        allowRange,
        weekStartsOn,
        accessibilityLabelPrefixes
      }) : null, datePickerClassName = css.classNames(DatePicker_module.default.DatePicker);
      return /* @__PURE__ */ React12.createElement("div", {
        id,
        className: datePickerClassName,
        onKeyDown: handleKeyDown,
        onKeyUp: handleKeyUp
      }, /* @__PURE__ */ React12.createElement("div", {
        className: DatePicker_module.default.Header
      }, /* @__PURE__ */ React12.createElement(Button2.Button, {
        variant: "tertiary",
        icon: polarisIcons.ArrowLeftIcon,
        accessibilityLabel: i18n.translate("Polaris.DatePicker.previousMonth", {
          previousMonthName,
          showPreviousYear
        }),
        onClick: () => handleMonthChangeClick(showPreviousMonth, showPreviousYear)
      }), /* @__PURE__ */ React12.createElement(Button2.Button, {
        variant: "tertiary",
        icon: polarisIcons.ArrowRightIcon,
        accessibilityLabel: i18n.translate("Polaris.DatePicker.nextMonth", {
          nextMonth,
          nextYear
        }),
        onClick: () => handleMonthChangeClick(showNextMonth, showNextYear)
      })), /* @__PURE__ */ React12.createElement("div", {
        className: DatePicker_module.default.MonthLayout
      }, /* @__PURE__ */ React12.createElement(Month.Month, {
        onFocus: handleFocus,
        focusedDate: focusDate,
        month,
        year,
        selected: deriveRange(selected),
        hoverDate,
        onChange: handleDateSelection,
        onHover: handleHover,
        disableDatesBefore,
        disableDatesAfter,
        disableSpecificDates,
        allowRange,
        weekStartsOn,
        accessibilityLabelPrefixes
      }), secondDatePicker));
    }
    function noop() {
    }
    function handleKeyDown(event) {
      let {
        key
      } = event;
      (key === "ArrowUp" || key === "ArrowDown" || key === "ArrowLeft" || key === "ArrowRight") && (event.preventDefault(), event.stopPropagation());
    }
    function deriveRange(selected) {
      return selected instanceof Date ? {
        start: selected,
        end: selected
      } : selected;
    }
    exports.DatePicker = DatePicker;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DescriptionList/DescriptionList.scss.js
var require_DescriptionList_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DescriptionList/DescriptionList.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      DescriptionList: "Polaris-DescriptionList",
      Term: "Polaris-DescriptionList__Term",
      spacingTight: "Polaris-DescriptionList--spacingTight",
      Description: "Polaris-DescriptionList__Description"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DescriptionList/DescriptionList.js
var require_DescriptionList = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DescriptionList/DescriptionList.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), DescriptionList_module = require_DescriptionList_scss(), Text4 = require_Text();
    function DescriptionList({
      items,
      gap = "loose"
    }) {
      let terms = items.reduce((allTerms, {
        term,
        description
      }, index) => [...allTerms, /* @__PURE__ */ React12.createElement("dt", {
        key: `dt${index}`,
        className: DescriptionList_module.default.Term
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        variant: "headingSm"
      }, term)), /* @__PURE__ */ React12.createElement("dd", {
        key: `dd${index}`,
        className: DescriptionList_module.default.Description
      }, description)], []), className = css.classNames(DescriptionList_module.default.DescriptionList, gap === "tight" && DescriptionList_module.default.spacingTight);
      return /* @__PURE__ */ React12.createElement("dl", {
        className
      }, terms);
    }
    exports.DescriptionList = DescriptionList;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Divider/Divider.scss.js
var require_Divider_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Divider/Divider.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Divider: "Polaris-Divider"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Divider/Divider.js
var require_Divider = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Divider/Divider.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), Divider_module = require_Divider_scss(), Divider = ({
      borderColor = "border-secondary",
      borderWidth = "025"
    }) => {
      let borderColorValue = borderColor === "transparent" ? borderColor : `var(--p-color-${borderColor})`;
      return /* @__PURE__ */ React12.createElement("hr", {
        className: Divider_module.default.Divider,
        style: {
          borderBlockStart: `var(--p-border-width-${borderWidth}) solid ${borderColorValue}`
        }
      });
    };
    exports.Divider = Divider;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/capitalize.js
var require_capitalize2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/capitalize.js"(exports) {
    "use strict";
    init_cjs_shims();
    function capitalize2(word = "") {
      let wordLower = word.toLowerCase();
      return wordLower.charAt(0).toUpperCase() + wordLower.slice(1);
    }
    exports.capitalize = capitalize2;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DropZone/utils/index.js
var require_utils12 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DropZone/utils/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var dragEvents = ["dragover", "dragenter", "drop"];
    function fileAccepted(file, accept) {
      return file.type === "application/x-moz-file" || accepts(file, accept);
    }
    function getDataTransferFiles(event) {
      if (isDragEvent(event) && event.dataTransfer) {
        let dt = event.dataTransfer;
        if (dt.files && dt.files.length)
          return Array.from(dt.files);
        if (dt.items && dt.items.length)
          return Array.from(dt.items);
      } else if (isChangeEvent(event) && event.target.files)
        return Array.from(event.target.files);
      return [];
    }
    function accepts(file, acceptedFiles) {
      if (file && acceptedFiles) {
        let fileName = file.name || "", mimeType = file.type || "", baseMimeType = mimeType.replace(/\/.*$/, "");
        return (Array.isArray(acceptedFiles) ? acceptedFiles : acceptedFiles.split(",")).some((type) => {
          let validType = type.trim();
          return validType.startsWith(".") ? fileName.toLowerCase().endsWith(validType.toLowerCase()) : validType.endsWith("/*") ? baseMimeType === validType.replace(/\/.*$/, "") : mimeType === validType;
        });
      }
      return !0;
    }
    function isDragEvent(event) {
      return dragEvents.indexOf(event.type) > 0;
    }
    function isChangeEvent(event) {
      return Object.prototype.hasOwnProperty.call(event, "target");
    }
    var defaultAllowMultiple = !0;
    function createAllowMultipleKey(allowMultiple) {
      return allowMultiple ? "allowMultiple" : "single";
    }
    exports.createAllowMultipleKey = createAllowMultipleKey;
    exports.defaultAllowMultiple = defaultAllowMultiple;
    exports.fileAccepted = fileAccepted;
    exports.getDataTransferFiles = getDataTransferFiles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DropZone/context.js
var require_context16 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DropZone/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), index = require_utils12(), DropZoneContext = /* @__PURE__ */ React12.createContext({
      disabled: !1,
      focused: !1,
      size: "extraLarge",
      type: "file",
      measuring: !1,
      allowMultiple: index.defaultAllowMultiple
    });
    exports.DropZoneContext = DropZoneContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DropZone/DropZone.scss.js
var require_DropZone_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DropZone/DropZone.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      DropZone: "Polaris-DropZone",
      focused: "Polaris-DropZone--focused",
      hasOutline: "Polaris-DropZone--hasOutline",
      isDisabled: "Polaris-DropZone--isDisabled",
      isDragging: "Polaris-DropZone--isDragging",
      sizeLarge: "Polaris-DropZone--sizeLarge",
      sizeMedium: "Polaris-DropZone--sizeMedium",
      sizeSmall: "Polaris-DropZone--sizeSmall",
      measuring: "Polaris-DropZone--measuring",
      Container: "Polaris-DropZone__Container",
      Overlay: "Polaris-DropZone__Overlay",
      hasError: "Polaris-DropZone--hasError"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DropZone/components/FileUpload/FileUpload.scss.js
var require_FileUpload_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DropZone/components/FileUpload/FileUpload.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      FileUpload: "Polaris-DropZone-FileUpload",
      large: "Polaris-DropZone-FileUpload--large",
      small: "Polaris-DropZone-FileUpload--small",
      Action: "Polaris-DropZone-FileUpload__Action",
      disabled: "Polaris-DropZone-FileUpload--disabled",
      ActionTitle: "Polaris-DropZone-FileUpload__ActionTitle",
      "ActionTitle-disabled": "Polaris-DropZone-FileUpload__ActionTitle--disabled",
      "ActionTitle-focused": "Polaris-DropZone-FileUpload__ActionTitle--focused",
      UploadIcon: "Polaris-DropZone-FileUpload__UploadIcon"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DropZone/components/FileUpload/FileUpload.js
var require_FileUpload = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DropZone/components/FileUpload/FileUpload.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), capitalize2 = require_capitalize2(), context = require_context16(), index = require_utils12(), FileUpload_module = require_FileUpload_scss(), hooks2 = require_hooks2(), Icon = require_Icon(), BlockStack3 = require_BlockStack(), Text4 = require_Text();
    function FileUpload(props) {
      let i18n = hooks2.useI18n(), {
        size,
        measuring,
        type,
        disabled,
        allowMultiple
      } = React12.useContext(context.DropZoneContext), typeSuffix = capitalize2.capitalize(type), allowMultipleKey = index.createAllowMultipleKey(allowMultiple), {
        actionTitle = i18n.translate(`Polaris.DropZone.${allowMultipleKey}.actionTitle${typeSuffix}`),
        actionHint
      } = props, actionClassNames = css.classNames(FileUpload_module.default.Action, disabled && FileUpload_module.default.disabled), actionMarkup = /* @__PURE__ */ React12.createElement("div", {
        className: actionClassNames
      }, actionTitle), fileUploadClassName = css.classNames(FileUpload_module.default.FileUpload, measuring && FileUpload_module.default.measuring, size === "large" && FileUpload_module.default.large, size === "small" && FileUpload_module.default.small), actionHintMarkup = actionHint && /* @__PURE__ */ React12.createElement(Text4.Text, {
        variant: "bodySm",
        as: "p",
        tone: "subdued"
      }, actionHint), viewMarkup;
      switch (size) {
        case "large":
          viewMarkup = /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
            inlineAlign: "center",
            gap: "200"
          }, actionMarkup, actionHintMarkup);
          break;
        case "medium":
          viewMarkup = /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
            inlineAlign: "center",
            gap: "200"
          }, actionMarkup, actionHintMarkup);
          break;
        case "small":
          viewMarkup = /* @__PURE__ */ React12.createElement("div", {
            className: css.classNames(FileUpload_module.default.UploadIcon, disabled && FileUpload_module.default.disabled)
          }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
            source: polarisIcons.UploadIcon
          }));
          break;
      }
      return /* @__PURE__ */ React12.createElement("div", {
        className: fileUploadClassName
      }, viewMarkup);
    }
    exports.FileUpload = FileUpload;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DropZone/DropZone.js
var require_DropZone = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/DropZone/DropZone.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), debounce = require_debounce2(), css = require_css(), capitalize2 = require_capitalize2(), target = require_target(), useComponentDidMount = require_use_component_did_mount(), useToggle = require_use_toggle(), useEventListener = require_use_event_listener(), context = require_context16(), index = require_utils12(), DropZone_module = require_DropZone_scss(), FileUpload = require_FileUpload(), hooks2 = require_hooks2(), BlockStack3 = require_BlockStack(), Icon = require_Icon(), Text4 = require_Text(), Labelled = require_Labelled(), DropZone = function({
      dropOnPage,
      label,
      labelAction,
      labelHidden,
      children,
      disabled = !1,
      outline = !0,
      accept,
      active,
      overlay = !0,
      allowMultiple = index.defaultAllowMultiple,
      overlayText,
      errorOverlayText,
      id: idProp,
      type = "file",
      onClick,
      error,
      openFileDialog,
      variableHeight,
      onFileDialogClose,
      customValidator,
      onDrop,
      onDropAccepted,
      onDropRejected,
      onDragEnter,
      onDragOver,
      onDragLeave
    }) {
      let node = React12.useRef(null), inputRef = React12.useRef(null), dragTargets = React12.useRef([]), adjustSize = React12.useCallback(debounce.debounce(() => {
        if (!node.current)
          return;
        if (variableHeight) {
          setMeasuring(!1);
          return;
        }
        let size2 = "large", width = node.current.getBoundingClientRect().width;
        width < 100 ? size2 = "small" : width < 160 && (size2 = "medium"), setSize(size2), measuring && setMeasuring(!1);
      }, 50, {
        trailing: !0
      }), []), [dragging, setDragging] = React12.useState(!1), [internalError, setInternalError] = React12.useState(!1), {
        value: focused,
        setTrue: handleFocus,
        setFalse: handleBlur
      } = useToggle.useToggle(!1), [size, setSize] = React12.useState("large"), [measuring, setMeasuring] = React12.useState(!0), i18n = hooks2.useI18n(), getValidatedFiles = React12.useCallback((files) => {
        let acceptedFiles = [], rejectedFiles = [];
        return Array.from(files).forEach((file) => {
          !index.fileAccepted(file, accept) || customValidator && !customValidator(file) ? rejectedFiles.push(file) : acceptedFiles.push(file);
        }), allowMultiple || (acceptedFiles.splice(1, acceptedFiles.length), rejectedFiles.push(...acceptedFiles.slice(1))), {
          files,
          acceptedFiles,
          rejectedFiles
        };
      }, [accept, allowMultiple, customValidator]), handleDrop = React12.useCallback((event) => {
        if (stopEvent(event), disabled)
          return;
        let fileList = index.getDataTransferFiles(event), {
          files,
          acceptedFiles,
          rejectedFiles
        } = getValidatedFiles(fileList);
        dragTargets.current = [], setDragging(!1), setInternalError(rejectedFiles.length > 0), onDrop && onDrop(files, acceptedFiles, rejectedFiles), onDropAccepted && acceptedFiles.length && onDropAccepted(acceptedFiles), onDropRejected && rejectedFiles.length && onDropRejected(rejectedFiles), event.target && "value" in event.target && (event.target.value = "");
      }, [disabled, getValidatedFiles, onDrop, onDropAccepted, onDropRejected]), handleDragEnter = React12.useCallback((event) => {
        if (stopEvent(event), disabled)
          return;
        let fileList = index.getDataTransferFiles(event);
        if (event.target && !dragTargets.current.includes(event.target) && dragTargets.current.push(event.target), dragging)
          return;
        let {
          rejectedFiles
        } = getValidatedFiles(fileList);
        setDragging(!0), setInternalError(rejectedFiles.length > 0), onDragEnter && onDragEnter();
      }, [disabled, dragging, getValidatedFiles, onDragEnter]), handleDragOver = React12.useCallback((event) => {
        stopEvent(event), !disabled && onDragOver && onDragOver();
      }, [disabled, onDragOver]), handleDragLeave = React12.useCallback((event) => {
        event.preventDefault(), !disabled && (dragTargets.current = dragTargets.current.filter((el) => {
          let compareNode = dropOnPage && !target.isServer ? document : node.current;
          return el !== event.target && compareNode && compareNode.contains(el);
        }), !(dragTargets.current.length > 0) && (setDragging(!1), setInternalError(!1), onDragLeave && onDragLeave()));
      }, [dropOnPage, disabled, onDragLeave]), dropNode = dropOnPage && !target.isServer ? document : node.current;
      useEventListener.useEventListener("drop", handleDrop, dropNode), useEventListener.useEventListener("dragover", handleDragOver, dropNode), useEventListener.useEventListener("dragenter", handleDragEnter, dropNode), useEventListener.useEventListener("dragleave", handleDragLeave, dropNode), useEventListener.useEventListener("resize", adjustSize, target.isServer ? null : window), useComponentDidMount.useComponentDidMount(() => {
        adjustSize();
      });
      let uniqId = React12.useId(), id = idProp ?? uniqId, typeSuffix = capitalize2.capitalize(type), allowMultipleKey = index.createAllowMultipleKey(allowMultiple), overlayTextWithDefault = overlayText === void 0 ? i18n.translate(`Polaris.DropZone.${allowMultipleKey}.overlayText${typeSuffix}`) : overlayText, errorOverlayTextWithDefault = errorOverlayText === void 0 ? i18n.translate(`Polaris.DropZone.errorOverlayText${typeSuffix}`) : errorOverlayText, labelValue = label || i18n.translate(`Polaris.DropZone.${allowMultipleKey}.label${typeSuffix}`), labelHiddenValue = label ? labelHidden : !0, classes = css.classNames(DropZone_module.default.DropZone, outline && DropZone_module.default.hasOutline, focused && DropZone_module.default.focused, (active || dragging) && DropZone_module.default.isDragging, disabled && DropZone_module.default.isDisabled, (internalError || error) && DropZone_module.default.hasError, !variableHeight && DropZone_module.default[css.variationName("size", size)], measuring && DropZone_module.default.measuring), dragOverlay = (active || dragging) && !internalError && !error && overlay && overlayMarkup(polarisIcons.UploadIcon, overlayTextWithDefault), dragErrorOverlay = dragging && (internalError || error) && overlayMarkup(polarisIcons.AlertCircleIcon, errorOverlayTextWithDefault, "critical"), context$1 = React12.useMemo(() => ({
        disabled,
        focused,
        size,
        type: type || "file",
        measuring,
        allowMultiple
      }), [disabled, focused, measuring, size, type, allowMultiple]), open2 = React12.useCallback(() => {
        inputRef.current && inputRef.current.click();
      }, [inputRef]), triggerFileDialog = React12.useCallback(() => {
        open2(), onFileDialogClose?.();
      }, [open2, onFileDialogClose]);
      function overlayMarkup(icon, text, color) {
        return /* @__PURE__ */ React12.createElement("div", {
          className: DropZone_module.default.Overlay
        }, /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
          gap: "200",
          inlineAlign: "center"
        }, size === "small" && /* @__PURE__ */ React12.createElement(Icon.Icon, {
          source: icon,
          tone: color
        }), (size === "medium" || size === "large") && /* @__PURE__ */ React12.createElement(Text4.Text, {
          variant: "bodySm",
          as: "p",
          fontWeight: "bold"
        }, text)));
      }
      function handleClick(event) {
        if (!disabled)
          return onClick ? onClick(event) : open2();
      }
      return React12.useEffect(() => {
        openFileDialog && triggerFileDialog();
      }, [openFileDialog, triggerFileDialog]), /* @__PURE__ */ React12.createElement(context.DropZoneContext.Provider, {
        value: context$1
      }, /* @__PURE__ */ React12.createElement(Labelled.Labelled, {
        id,
        label: labelValue,
        action: labelAction,
        labelHidden: labelHiddenValue
      }, /* @__PURE__ */ React12.createElement("div", {
        ref: node,
        className: classes,
        "aria-disabled": disabled,
        onClick: handleClick,
        onDragStart: stopEvent
      }, dragOverlay, dragErrorOverlay, /* @__PURE__ */ React12.createElement(Text4.Text, {
        variant: "bodySm",
        as: "span",
        visuallyHidden: !0
      }, /* @__PURE__ */ React12.createElement("input", {
        id,
        accept,
        disabled,
        multiple: allowMultiple,
        onChange: handleDrop,
        onFocus: handleFocus,
        onBlur: handleBlur,
        type: "file",
        ref: inputRef,
        autoComplete: "off"
      })), /* @__PURE__ */ React12.createElement("div", {
        className: DropZone_module.default.Container
      }, children))));
    };
    function stopEvent(event) {
      event.preventDefault(), event.stopPropagation();
    }
    DropZone.FileUpload = FileUpload.FileUpload;
    exports.DropZone = DropZone;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/EmptySearchResult/illustrations/empty-search.svg.js
var require_empty_search_svg = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/EmptySearchResult/illustrations/empty-search.svg.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var img = "data:image/svg+xml,%3csvg width='60' height='60' xmlns='http://www.w3.org/2000/svg'%3e%3cpath fill-rule='evenodd' d='M41.87 24a17.87 17.87 0 11-35.74 0 17.87 17.87 0 0135.74 0zm-3.15 18.96a24 24 0 114.24-4.24L59.04 54.8a3 3 0 11-4.24 4.24L38.72 42.96z' fill='%238C9196'/%3e%3c/svg%3e", emptySearch = img;
    exports.default = emptySearch;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/EmptySearchResult/EmptySearchResult.js
var require_EmptySearchResult = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/EmptySearchResult/EmptySearchResult.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), emptySearch = require_empty_search_svg(), hooks2 = require_hooks2(), LegacyStack = require_LegacyStack(), Text4 = require_Text(), Image = require_Image();
    function EmptySearchResult({
      title,
      description,
      withIllustration
    }) {
      let altText = hooks2.useI18n().translate("Polaris.EmptySearchResult.altText"), descriptionMarkup = description ? /* @__PURE__ */ React12.createElement("p", null, description) : null, illustrationMarkup = withIllustration ? /* @__PURE__ */ React12.createElement(Image.Image, {
        alt: altText,
        source: emptySearch.default,
        draggable: !1
      }) : null;
      return /* @__PURE__ */ React12.createElement(LegacyStack.LegacyStack, {
        alignment: "center",
        vertical: !0
      }, illustrationMarkup, /* @__PURE__ */ React12.createElement(Text4.Text, {
        variant: "headingLg",
        as: "p"
      }, title), /* @__PURE__ */ React12.createElement(Text4.Text, {
        tone: "subdued",
        as: "span"
      }, descriptionMarkup));
    }
    exports.EmptySearchResult = EmptySearchResult;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/EmptyState/EmptyState.scss.js
var require_EmptyState_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/EmptyState/EmptyState.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      imageContained: "Polaris-EmptyState--imageContained"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/EmptyState/EmptyState.js
var require_EmptyState = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/EmptyState/EmptyState.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), EmptyState_module = require_EmptyState_scss(), utils = require_utils10(), Box2 = require_Box(), BlockStack3 = require_BlockStack(), Image = require_Image(), Text4 = require_Text(), InlineStack2 = require_InlineStack();
    function EmptyState({
      children,
      heading,
      image,
      largeImage,
      imageContained,
      fullWidth = !1,
      action,
      secondaryAction,
      footerContent
    }) {
      let imageContainedClass = css.classNames(imageContained && EmptyState_module.default.imageContained), imageMarkup = largeImage ? /* @__PURE__ */ React12.createElement(Image.Image, {
        alt: "",
        role: "presentation",
        source: largeImage,
        className: imageContainedClass,
        sourceSet: [{
          source: image,
          descriptor: "568w"
        }, {
          source: largeImage,
          descriptor: "1136w"
        }],
        sizes: "(max-width: 568px) 60vw"
      }) : /* @__PURE__ */ React12.createElement(Image.Image, {
        className: imageContainedClass,
        role: "presentation",
        alt: "",
        source: image
      }), secondaryActionMarkup = secondaryAction ? utils.buttonFrom(secondaryAction, {}) : null, footerContentMarkup = footerContent ? /* @__PURE__ */ React12.createElement(Box2.Box, {
        paddingBlockStart: "400"
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        alignment: "center",
        variant: "bodySm"
      }, footerContent)) : null, primaryActionMarkup = action ? utils.buttonFrom(action, {
        variant: "primary",
        size: "medium"
      }) : null, headingMarkup = heading ? /* @__PURE__ */ React12.createElement(Box2.Box, {
        paddingBlockEnd: "150"
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        variant: "headingMd",
        as: "p",
        alignment: "center"
      }, heading)) : null, childrenMarkup = children ? /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        alignment: "center",
        variant: "bodySm"
      }, children) : null, textContentMarkup = headingMarkup || children ? /* @__PURE__ */ React12.createElement(Box2.Box, {
        paddingBlockEnd: "400"
      }, headingMarkup, childrenMarkup) : null, actionsMarkup = primaryActionMarkup || secondaryActionMarkup ? /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        align: "center",
        gap: "200"
      }, secondaryActionMarkup, primaryActionMarkup) : null, detailsMarkup = textContentMarkup || actionsMarkup || footerContentMarkup ? /* @__PURE__ */ React12.createElement(Box2.Box, {
        maxWidth: fullWidth ? "100%" : "400px"
      }, /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
        inlineAlign: "center"
      }, textContentMarkup, actionsMarkup, footerContentMarkup)) : null;
      return /* @__PURE__ */ React12.createElement(Box2.Box, {
        paddingInlineStart: "0",
        paddingInlineEnd: "0",
        paddingBlockStart: "500",
        paddingBlockEnd: "1600"
      }, /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
        inlineAlign: "center"
      }, imageMarkup, detailsMarkup));
    }
    exports.EmptyState = EmptyState;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ExceptionList/ExceptionList.scss.js
var require_ExceptionList_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ExceptionList/ExceptionList.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      ExceptionList: "Polaris-ExceptionList",
      Item: "Polaris-ExceptionList__Item",
      Icon: "Polaris-ExceptionList__Icon",
      statusWarning: "Polaris-ExceptionList--statusWarning",
      statusCritical: "Polaris-ExceptionList--statusCritical",
      Bullet: "Polaris-ExceptionList__Bullet",
      Title: "Polaris-ExceptionList__Title",
      Description: "Polaris-ExceptionList__Description"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Truncate/Truncate.scss.js
var require_Truncate_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Truncate/Truncate.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Truncate: "Polaris-Truncate"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Truncate/Truncate.js
var require_Truncate = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Truncate/Truncate.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), Truncate_module = require_Truncate_scss();
    function Truncate({
      children
    }) {
      return /* @__PURE__ */ React12.createElement("span", {
        className: Truncate_module.default.Truncate
      }, children);
    }
    exports.Truncate = Truncate;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ExceptionList/ExceptionList.js
var require_ExceptionList = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ExceptionList/ExceptionList.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), ExceptionList_module = require_ExceptionList_scss(), Truncate = require_Truncate(), Icon = require_Icon();
    function ExceptionList({
      items: itemsList
    }) {
      let items = itemsList.map((item, index) => {
        let {
          status,
          icon,
          title,
          description,
          truncate = !1
        } = item, itemClasses = css.classNames(ExceptionList_module.default.Item, status && ExceptionList_module.default[css.variationName("status", status)]), iconMarkup = icon ? /* @__PURE__ */ React12.createElement(Icon.Icon, {
          source: icon
        }) : /* @__PURE__ */ React12.createElement("span", {
          className: ExceptionList_module.default.Bullet
        }), titleMarkup = title && /* @__PURE__ */ React12.createElement("span", {
          className: ExceptionList_module.default.Title
        }, title), descriptionMarkup = description && /* @__PURE__ */ React12.createElement("span", {
          className: ExceptionList_module.default.Description
        }, description), Element2 = truncate ? Truncate.Truncate : React12.Fragment;
        return /* @__PURE__ */ React12.createElement("li", {
          className: itemClasses,
          key: index
        }, /* @__PURE__ */ React12.createElement("span", {
          className: ExceptionList_module.default.Icon
        }, iconMarkup), /* @__PURE__ */ React12.createElement(Element2, null, titleMarkup, descriptionMarkup));
      });
      return /* @__PURE__ */ React12.createElement("ul", {
        className: ExceptionList_module.default.ExceptionList
      }, items);
    }
    exports.ExceptionList = ExceptionList;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Filters/Filters.scss.js
var require_Filters_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Filters/Filters.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Container: "Polaris-Filters__Container",
      SearchField: "Polaris-Filters__SearchField",
      FiltersWrapper: "Polaris-Filters__FiltersWrapper",
      hideQueryField: "Polaris-Filters--hideQueryField",
      FiltersInner: "Polaris-Filters__FiltersInner",
      AddFilter: "Polaris-Filters__AddFilter",
      FiltersWrapperWithAddButton: "Polaris-Filters__FiltersWrapperWithAddButton",
      AddFilterActivatorMultiple: "Polaris-Filters__AddFilterActivatorMultiple",
      FiltersStickyArea: "Polaris-Filters__FiltersStickyArea",
      ClearAll: "Polaris-Filters__ClearAll",
      MultiplePinnedFilterClearAll: "Polaris-Filters__MultiplePinnedFilterClearAll"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Filters/components/SearchField/SearchField.scss.js
var require_SearchField_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Filters/components/SearchField/SearchField.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Spinner: "Polaris-Filters-SearchField__Spinner"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Filters/components/SearchField/SearchField.js
var require_SearchField = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Filters/components/SearchField/SearchField.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), breakpoints = require_breakpoints2(), SearchField_module = require_SearchField_scss(), TextField = require_TextField(), Icon = require_Icon(), Spinner = require_Spinner();
    function SearchField({
      onChange,
      onClear,
      onFocus,
      onBlur,
      focused,
      value,
      placeholder,
      disabled,
      borderlessQueryField,
      loading
    }) {
      let id = React12.useId(), {
        mdUp
      } = breakpoints.useBreakpoints();
      function handleChange(value2) {
        onChange(value2);
      }
      function handleClear() {
        onClear ? onClear() : onChange("");
      }
      return /* @__PURE__ */ React12.createElement(TextField.TextField, {
        id,
        value,
        onChange: (eventValue) => handleChange(eventValue ?? value),
        onFocus,
        onBlur,
        onClearButtonClick: handleClear,
        autoComplete: "off",
        placeholder,
        disabled,
        variant: borderlessQueryField ? "borderless" : "inherit",
        size: "slim",
        prefix: mdUp ? /* @__PURE__ */ React12.createElement(Icon.Icon, {
          source: polarisIcons.SearchIcon
        }) : void 0,
        suffix: loading ? /* @__PURE__ */ React12.createElement("div", {
          className: SearchField_module.default.Spinner
        }, /* @__PURE__ */ React12.createElement(Spinner.Spinner, {
          size: "small"
        })) : null,
        focused,
        label: placeholder,
        labelHidden: !0,
        clearButton: !0
      });
    }
    exports.SearchField = SearchField;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-on-value-change.js
var require_use_on_value_change = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-on-value-change.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react();
    function useOnValueChange(value, onChange) {
      let tracked = React12.useRef(value);
      React12.useEffect(() => {
        let oldValue = tracked.current;
        value !== tracked.current && (tracked.current = value, onChange(value, oldValue));
      }, [value, onChange]);
    }
    exports.useOnValueChange = useOnValueChange;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Filters/components/FilterPill/FilterPill.scss.js
var require_FilterPill_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Filters/components/FilterPill/FilterPill.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      FilterButton: "Polaris-Filters-FilterPill__FilterButton",
      focusedFilterButton: "Polaris-Filters-FilterPill--focusedFilterButton",
      ActiveFilterButton: "Polaris-Filters-FilterPill__ActiveFilterButton",
      PlainButton: "Polaris-Filters-FilterPill__PlainButton",
      ToggleButton: "Polaris-Filters-FilterPill__ToggleButton",
      Label: "Polaris-Filters-FilterPill__Label",
      clearButton: "Polaris-Filters-FilterPill--clearButton",
      IconWrapper: "Polaris-Filters-FilterPill__IconWrapper",
      PopoverWrapper: "Polaris-Filters-FilterPill__PopoverWrapper",
      ClearButtonWrapper: "Polaris-Filters-FilterPill__ClearButtonWrapper"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Filters/components/FilterPill/FilterPill.js
var require_FilterPill = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Filters/components/FilterPill/FilterPill.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), useToggle = require_use_toggle(), breakpoints = require_breakpoints2(), css = require_css(), FilterPill_module = require_FilterPill_scss(), hooks2 = require_hooks2(), Text4 = require_Text(), InlineStack2 = require_InlineStack(), UnstyledButton = require_UnstyledButton(), Icon = require_Icon(), Button2 = require_Button(), Popover = require_Popover(), BlockStack3 = require_BlockStack();
    function FilterPill({
      filterKey,
      label,
      filter,
      disabled,
      hideClearButton,
      selected,
      initialActive,
      closeOnChildOverlayClick,
      onRemove,
      onClick
    }) {
      let i18n = hooks2.useI18n(), {
        mdDown
      } = breakpoints.useBreakpoints(), elementRef = React12.useRef(null), {
        value: focused,
        setTrue: setFocusedTrue,
        setFalse: setFocusedFalse
      } = useToggle.useToggle(!1), [popoverActive, setPopoverActive] = React12.useState(initialActive);
      React12.useEffect(() => {
        let node = elementRef.current;
        if (!node || !popoverActive)
          return;
        let parent = node.parentElement?.parentElement;
        parent && parent.scroll?.({
          left: node.offsetLeft
        });
      }, [elementRef, popoverActive]);
      let togglePopoverActive = React12.useCallback(() => {
        filter && setPopoverActive((popoverActive2) => !popoverActive2), onClick && onClick(filterKey);
      }, [filter, filterKey, onClick]), handlePopoverClose = React12.useCallback(() => {
        togglePopoverActive(), selected || onRemove?.(filterKey);
      }, [onRemove, selected, filterKey, togglePopoverActive]), handleClear = () => {
        onRemove && onRemove(filterKey), setPopoverActive(!1);
      }, buttonClasses = css.classNames(FilterPill_module.default.FilterButton, selected && FilterPill_module.default.ActiveFilterButton, popoverActive && FilterPill_module.default.FocusFilterButton, focused && FilterPill_module.default.focusedFilterButton), clearButtonClassNames = css.classNames(FilterPill_module.default.PlainButton, FilterPill_module.default.clearButton), toggleButtonClassNames = css.classNames(FilterPill_module.default.PlainButton, FilterPill_module.default.ToggleButton), labelVariant = mdDown ? "bodyLg" : "bodySm", wrappedLabel = /* @__PURE__ */ React12.createElement("div", {
        className: FilterPill_module.default.Label
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        variant: labelVariant,
        as: "span"
      }, label)), activator = /* @__PURE__ */ React12.createElement("div", {
        className: buttonClasses
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "0",
        wrap: !1
      }, /* @__PURE__ */ React12.createElement(UnstyledButton.UnstyledButton, {
        onFocus: setFocusedTrue,
        onBlur: setFocusedFalse,
        onClick: togglePopoverActive,
        className: toggleButtonClassNames,
        type: "button"
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        wrap: !1,
        align: "center",
        blockAlign: "center",
        gap: "0"
      }, selected ? /* @__PURE__ */ React12.createElement(React12.Fragment, null, wrappedLabel) : /* @__PURE__ */ React12.createElement(React12.Fragment, null, wrappedLabel, /* @__PURE__ */ React12.createElement("div", {
        className: FilterPill_module.default.IconWrapper
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.ChevronDownIcon,
        tone: "base"
      }))))), selected ? /* @__PURE__ */ React12.createElement(UnstyledButton.UnstyledButton, {
        onClick: handleClear,
        className: clearButtonClassNames,
        type: "button",
        "aria-label": i18n.translate("Polaris.FilterPill.clear")
      }, /* @__PURE__ */ React12.createElement("div", {
        className: FilterPill_module.default.IconWrapper
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.XSmallIcon,
        tone: "base"
      }))) : null)), clearButtonMarkup = !hideClearButton && /* @__PURE__ */ React12.createElement("div", {
        className: FilterPill_module.default.ClearButtonWrapper
      }, /* @__PURE__ */ React12.createElement(Button2.Button, {
        onClick: handleClear,
        variant: "plain",
        disabled: !selected,
        textAlign: "left"
      }, i18n.translate("Polaris.FilterPill.clear")));
      return disabled ? null : /* @__PURE__ */ React12.createElement("div", {
        ref: elementRef
      }, /* @__PURE__ */ React12.createElement(Popover.Popover, {
        active: popoverActive,
        activator,
        key: filterKey,
        onClose: handlePopoverClose,
        preferredAlignment: "left",
        preventCloseOnChildOverlayClick: !closeOnChildOverlayClick
      }, /* @__PURE__ */ React12.createElement("div", {
        className: FilterPill_module.default.PopoverWrapper
      }, /* @__PURE__ */ React12.createElement(Popover.Popover.Section, null, /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
        gap: "100"
      }, filter, clearButtonMarkup)))));
    }
    exports.FilterPill = FilterPill;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Filters/components/FiltersBar/FiltersBar.js
var require_FiltersBar = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Filters/components/FiltersBar/FiltersBar.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), useOnValueChange = require_use_on_value_change(), css = require_css(), breakpoints = require_breakpoints2(), Filters_module = require_Filters_scss(), FilterPill = require_FilterPill(), hooks2 = require_hooks2(), UnstyledButton = require_UnstyledButton(), Text4 = require_Text(), Popover = require_Popover(), ActionList = require_ActionList(), Button2 = require_Button(), Box2 = require_Box(), InlineStack2 = require_InlineStack();
    function FiltersBar({
      filters,
      appliedFilters,
      onClearAll,
      disabled,
      hideQueryField,
      disableFilters,
      mountedStateStyles,
      onAddFilterClick,
      closeOnChildOverlayClick,
      children
    }) {
      let i18n = hooks2.useI18n(), {
        mdDown
      } = breakpoints.useBreakpoints(), [popoverActive, setPopoverActive] = React12.useState(!1), hasMounted = React12.useRef(!1);
      React12.useEffect(() => {
        hasMounted.current = !0;
      });
      let togglePopoverActive = () => setPopoverActive((popoverActive2) => !popoverActive2), handleAddFilterClick = () => {
        onAddFilterClick?.(), togglePopoverActive();
      }, appliedFilterKeys = appliedFilters?.map(({
        key
      }) => key), pinnedFromPropsKeys = filters.filter(({
        pinned
      }) => pinned).map(({
        key
      }) => key), pinnedFiltersFromPropsAndAppliedFilters = filters.filter(({
        pinned,
        key
      }) => !!pinned || appliedFilterKeys?.includes(key)), [localPinnedFilters, setLocalPinnedFilters] = React12.useState(pinnedFiltersFromPropsAndAppliedFilters.map(({
        key
      }) => key));
      useOnValueChange.useOnValueChange(filters.length, () => {
        setLocalPinnedFilters(pinnedFiltersFromPropsAndAppliedFilters.map(({
          key
        }) => key));
      });
      let pinnedFilters = localPinnedFilters.map((key) => filters.find((filter) => filter.key === key)).reduce((acc, filter) => filter ? [...acc, filter] : acc, []), onFilterClick = ({
        key,
        onAction
      }) => () => {
        setTimeout(() => {
          setLocalPinnedFilters((currentLocalPinnedFilters) => [.../* @__PURE__ */ new Set([...currentLocalPinnedFilters, key])]), onAction?.(), togglePopoverActive();
        }, 0);
      }, filterToActionItem = (filter) => ({
        ...filter,
        content: filter.label,
        onAction: onFilterClick(filter)
      }), unpinnedFilters = filters.filter((filter) => !pinnedFilters.some(({
        key
      }) => key === filter.key)), unsectionedFilters = unpinnedFilters.filter((filter) => !filter.section && !filter.hidden).map(filterToActionItem), sectionedFilters = unpinnedFilters.filter((filter) => filter.section).reduce((acc, filter) => {
        let filterActionItem = filterToActionItem(filter), sectionIndex = acc.findIndex((section) => section.title === filter.section);
        return sectionIndex === -1 ? acc.push({
          title: filter.section,
          items: [filterActionItem]
        }) : acc[sectionIndex].items.push(filterActionItem), acc;
      }, []), hasOneOrMorePinnedFilters = pinnedFilters.length >= 1, labelVariant = mdDown ? "bodyMd" : "bodySm", addFilterActivator = /* @__PURE__ */ React12.createElement("div", null, /* @__PURE__ */ React12.createElement(UnstyledButton.UnstyledButton, {
        type: "button",
        className: Filters_module.default.AddFilter,
        onClick: handleAddFilterClick,
        "aria-label": i18n.translate("Polaris.Filters.addFilter"),
        disabled: disabled || unsectionedFilters.length === 0 && sectionedFilters.length === 0 || disableFilters
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        variant: labelVariant,
        as: "span"
      }, i18n.translate("Polaris.Filters.addFilter"), " "), /* @__PURE__ */ React12.createElement(polarisIcons.PlusIcon, null))), handleClearAllFilters = () => {
        setLocalPinnedFilters(pinnedFromPropsKeys), onClearAll?.();
      }, shouldShowAddButton = filters.some((filter) => !filter.pinned) || filters.length !== localPinnedFilters.length, pinnedFiltersMarkup = pinnedFilters.map(({
        key: filterKey,
        ...pinnedFilter
      }) => {
        let appliedFilter = appliedFilters?.find(({
          key
        }) => key === filterKey), handleFilterPillRemove = () => {
          setLocalPinnedFilters((currentLocalPinnedFilters) => currentLocalPinnedFilters.filter((key) => {
            let isMatchedFilters = key === filterKey, isPinnedFilterFromProps = pinnedFromPropsKeys.includes(key);
            return !isMatchedFilters || isPinnedFilterFromProps;
          })), appliedFilter?.onRemove(filterKey);
        };
        return /* @__PURE__ */ React12.createElement(FilterPill.FilterPill, Object.assign({
          key: filterKey
        }, pinnedFilter, {
          initialActive: hasMounted.current && !pinnedFilter.pinned && !appliedFilter,
          label: appliedFilter?.label || pinnedFilter.label,
          filterKey,
          selected: appliedFilterKeys?.includes(filterKey),
          onRemove: handleFilterPillRemove,
          disabled: pinnedFilter.disabled || disableFilters,
          closeOnChildOverlayClick
        }));
      }), addButton = shouldShowAddButton ? /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(Filters_module.default.AddFilterActivator, hasOneOrMorePinnedFilters && Filters_module.default.AddFilterActivatorMultiple)
      }, /* @__PURE__ */ React12.createElement(Popover.Popover, {
        active: popoverActive && !disabled,
        activator: addFilterActivator,
        onClose: togglePopoverActive
      }, /* @__PURE__ */ React12.createElement(ActionList.ActionList, {
        actionRole: "menuitem",
        items: unsectionedFilters,
        sections: sectionedFilters
      }))) : null, clearAllMarkup = appliedFilters?.length ? /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(Filters_module.default.ClearAll, hasOneOrMorePinnedFilters && shouldShowAddButton && Filters_module.default.MultiplePinnedFilterClearAll)
      }, /* @__PURE__ */ React12.createElement(Button2.Button, {
        size: "micro",
        onClick: handleClearAllFilters,
        removeUnderline: !0,
        variant: "monochromePlain"
      }, i18n.translate("Polaris.Filters.clearFilters"))) : null;
      return /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(Filters_module.default.FiltersWrapper, shouldShowAddButton && hasOneOrMorePinnedFilters && Filters_module.default.FiltersWrapperWithAddButton),
        "aria-live": "polite",
        style: mountedStateStyles
      }, /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(Filters_module.default.FiltersInner)
      }, /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(Filters_module.default.FiltersStickyArea)
      }, pinnedFiltersMarkup, addButton, clearAllMarkup)), hideQueryField ? /* @__PURE__ */ React12.createElement(Box2.Box, {
        paddingInlineEnd: "300",
        paddingBlockStart: "200",
        paddingBlockEnd: "200"
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        align: "start",
        blockAlign: "center",
        gap: {
          xs: "400",
          md: "300"
        }
      }, children)) : null);
    }
    exports.FiltersBar = FiltersBar;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Filters/Filters.js
var require_Filters = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Filters/Filters.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Filters_module = require_Filters_scss(), SearchField = require_SearchField(), FiltersBar = require_FiltersBar(), Box2 = require_Box(), InlineStack2 = require_InlineStack(), TRANSITION_DURATION = "var(--p-motion-duration-150)", TRANSITION_MARGIN = "-36px", defaultStyle = {
      transition: `opacity ${TRANSITION_DURATION} var(--p-motion-ease)`,
      opacity: 0
    }, transitionStyles = {
      entering: {
        opacity: 1
      },
      entered: {
        opacity: 1
      },
      exiting: {
        opacity: 0
      },
      exited: {
        opacity: 0
      },
      unmounted: {
        opacity: 0
      }
    }, defaultFilterStyles = {
      transition: `opacity ${TRANSITION_DURATION} var(--p-motion-ease), margin ${TRANSITION_DURATION} var(--p-motion-ease)`,
      opacity: 0,
      marginTop: TRANSITION_MARGIN
    }, transitionFilterStyles = {
      entering: {
        opacity: 1,
        marginTop: 0
      },
      entered: {
        opacity: 1,
        marginTop: 0
      },
      exiting: {
        opacity: 0,
        marginTop: TRANSITION_MARGIN
      },
      exited: {
        opacity: 0,
        marginTop: TRANSITION_MARGIN
      },
      unmounted: {
        opacity: 0,
        marginTop: TRANSITION_MARGIN
      }
    };
    function Filters({
      queryValue,
      queryPlaceholder,
      focused,
      filters,
      appliedFilters,
      onQueryChange,
      onQueryClear,
      onQueryBlur,
      onQueryFocus,
      onClearAll,
      children,
      disabled,
      hideFilters,
      hideQueryField,
      disableQueryField,
      borderlessQueryField,
      loading,
      disableFilters,
      mountedState,
      onAddFilterClick,
      closeOnChildOverlayClick
    }) {
      let hideFilterBar = hideFilters || filters.length === 0, queryFieldMarkup = hideQueryField ? null : /* @__PURE__ */ React12.createElement("div", {
        className: Filters_module.default.Container
      }, /* @__PURE__ */ React12.createElement(Box2.Box, {
        padding: hideFilterBar ? "300" : "200"
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        align: "start",
        blockAlign: "center",
        gap: {
          xs: "400",
          md: "300"
        }
      }, /* @__PURE__ */ React12.createElement("div", {
        className: Filters_module.default.SearchField,
        style: mountedState ? {
          ...defaultStyle,
          ...transitionStyles[mountedState]
        } : void 0
      }, /* @__PURE__ */ React12.createElement(SearchField.SearchField, {
        onChange: onQueryChange,
        onFocus: onQueryFocus,
        onBlur: onQueryBlur,
        onClear: onQueryClear,
        value: queryValue,
        placeholder: queryPlaceholder,
        focused,
        disabled: disabled || disableQueryField,
        borderlessQueryField,
        loading
      })), children))), mountedStateStyles = mountedState && !hideQueryField ? {
        ...defaultFilterStyles,
        ...transitionFilterStyles[mountedState]
      } : void 0, filtersMarkup = hideFilterBar ? null : /* @__PURE__ */ React12.createElement(FiltersBar.FiltersBar, {
        filters,
        appliedFilters,
        onClearAll,
        disabled,
        hideQueryField,
        disableFilters,
        onAddFilterClick,
        closeOnChildOverlayClick,
        mountedStateStyles
      }, children);
      return /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(Filters_module.default.Filters, hideQueryField && Filters_module.default.hideQueryField)
      }, queryFieldMarkup, filtersMarkup);
    }
    exports.Filters = Filters;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Focus/Focus.js
var require_Focus = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Focus/Focus.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), focus = require_focus(), Focus = /* @__PURE__ */ React12.memo(function({
      children,
      disabled,
      root
    }) {
      return React12.useEffect(() => {
        if (disabled || !root)
          return;
        let node = isRef(root) ? root.current : root;
        !node || node.querySelector("[autofocus]") || focus.focusFirstFocusableNode(node, !1);
      }, [disabled, root]), /* @__PURE__ */ React12.createElement(React12.Fragment, null, children);
    });
    function isRef(ref) {
      return ref.current !== void 0;
    }
    exports.Focus = Focus;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FooterHelp/FooterHelp.scss.js
var require_FooterHelp_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FooterHelp/FooterHelp.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      FooterHelp: "Polaris-FooterHelp",
      Text: "Polaris-FooterHelp__Text"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FooterHelp/FooterHelp.js
var require_FooterHelp = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FooterHelp/FooterHelp.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), FooterHelp_module = require_FooterHelp_scss();
    function FooterHelp({
      children
    }) {
      return /* @__PURE__ */ React12.createElement("div", {
        className: FooterHelp_module.default.FooterHelp
      }, /* @__PURE__ */ React12.createElement("div", {
        className: FooterHelp_module.default.Text
      }, children));
    }
    exports.FooterHelp = FooterHelp;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Form/Form.js
var require_Form = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Form/Form.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), hooks2 = require_hooks2(), Text4 = require_Text();
    function Form({
      acceptCharset,
      action,
      autoComplete,
      children,
      encType,
      implicitSubmit = !0,
      method = "post",
      name,
      noValidate,
      preventDefault = !0,
      target,
      onSubmit
    }) {
      let i18n = hooks2.useI18n(), handleSubmit = React12.useCallback((event) => {
        preventDefault && (event.preventDefault(), onSubmit(event));
      }, [onSubmit, preventDefault]), autoCompleteInputs = normalizeAutoComplete(autoComplete), submitMarkup = implicitSubmit ? /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        visuallyHidden: !0
      }, /* @__PURE__ */ React12.createElement("button", {
        type: "submit",
        "aria-hidden": "true",
        tabIndex: -1
      }, i18n.translate("Polaris.Common.submit"))) : null;
      return /* @__PURE__ */ React12.createElement("form", {
        acceptCharset,
        action,
        autoComplete: autoCompleteInputs,
        encType,
        method,
        name,
        noValidate,
        target,
        onSubmit: handleSubmit
      }, submitMarkup, children);
    }
    function normalizeAutoComplete(autoComplete) {
      return autoComplete == null ? autoComplete : autoComplete ? "on" : "off";
    }
    exports.Form = Form;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FormLayout/FormLayout.scss.js
var require_FormLayout_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FormLayout/FormLayout.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Item: "Polaris-FormLayout__Item",
      grouped: "Polaris-FormLayout--grouped",
      condensed: "Polaris-FormLayout--condensed"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FormLayout/components/Item/Item.js
var require_Item5 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FormLayout/components/Item/Item.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), FormLayout_module = require_FormLayout_scss();
    function Item({
      children,
      condensed = !1
    }) {
      let className = css.classNames(FormLayout_module.default.Item, condensed ? FormLayout_module.default.condensed : FormLayout_module.default.grouped);
      return children ? /* @__PURE__ */ React12.createElement("div", {
        className
      }, children) : null;
    }
    exports.Item = Item;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FormLayout/components/Group/Group.js
var require_Group = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FormLayout/components/Group/Group.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), components = require_components(), Item = require_Item5(), BlockStack3 = require_BlockStack(), InlineStack2 = require_InlineStack(), Box2 = require_Box(), Text4 = require_Text();
    function Group({
      children,
      condensed,
      title,
      helpText
    }) {
      let id = React12.useId(), helpTextElement = null, helpTextId, titleElement = null, titleId;
      helpText && (helpTextId = `${id}HelpText`, helpTextElement = /* @__PURE__ */ React12.createElement(Box2.Box, {
        id: helpTextId,
        color: "text-secondary"
      }, helpText)), title && (titleId = `${id}Title`, titleElement = /* @__PURE__ */ React12.createElement(Text4.Text, {
        id: titleId,
        as: "p"
      }, title));
      let itemsMarkup = React12.Children.map(children, (child) => components.wrapWithComponent(child, Item.Item, {
        condensed
      }));
      return /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
        role: "group",
        gap: "200",
        "aria-labelledby": titleId,
        "aria-describedby": helpTextId
      }, titleElement, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "300"
      }, itemsMarkup), helpTextElement);
    }
    exports.Group = Group;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FormLayout/FormLayout.js
var require_FormLayout = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FormLayout/FormLayout.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), components = require_components(), Group = require_Group(), BlockStack3 = require_BlockStack(), Item = require_Item5(), FormLayout = /* @__PURE__ */ React12.memo(function({
      children
    }) {
      return /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
        gap: "400"
      }, React12.Children.map(children, wrapChildren));
    });
    FormLayout.Group = Group.Group;
    function wrapChildren(child, index) {
      if (components.isElementOfType(child, Group.Group))
        return child;
      let props = {
        key: index
      };
      return components.wrapWithComponent(child, Item.Item, props);
    }
    exports.FormLayout = FormLayout;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/set-root-property.js
var require_set_root_property = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/set-root-property.js"(exports) {
    "use strict";
    init_cjs_shims();
    function setRootProperty(name, value, node) {
      if (!document)
        return;
      (node || document.documentElement).style.setProperty(name, value);
    }
    exports.setRootProperty = setRootProperty;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/Frame.scss.js
var require_Frame_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/Frame.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Frame: "Polaris-Frame",
      Navigation: "Polaris-Frame__Navigation",
      hasTopBar: "Polaris-Frame--hasTopBar",
      "Navigation-enter": "Polaris-Frame__Navigation--enter",
      "Navigation-enterActive": "Polaris-Frame__Navigation--enterActive",
      "Navigation-exit": "Polaris-Frame__Navigation--exit",
      "Navigation-exitActive": "Polaris-Frame__Navigation--exitActive",
      NavigationDismiss: "Polaris-Frame__NavigationDismiss",
      "Navigation-visible": "Polaris-Frame__Navigation--visible",
      TopBar: "Polaris-Frame__TopBar",
      ContextualSaveBar: "Polaris-Frame__ContextualSaveBar",
      Main: "Polaris-Frame__Main",
      hasNav: "Polaris-Frame--hasNav",
      Content: "Polaris-Frame__Content",
      hasSidebar: "Polaris-Frame--hasSidebar",
      GlobalRibbonContainer: "Polaris-Frame__GlobalRibbonContainer",
      LoadingBar: "Polaris-Frame__LoadingBar",
      Skip: "Polaris-Frame__Skip",
      focused: "Polaris-Frame--focused",
      pressed: "Polaris-Frame--pressed"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/media-query/hooks.js
var require_hooks11 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/media-query/hooks.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), context = require_context6();
    function useMediaQuery() {
      let mediaQuery = React12.useContext(context.MediaQueryContext);
      if (!mediaQuery)
        throw new Error("No mediaQuery was provided. Your application must be wrapped in an <AppProvider> component. See https://polaris.shopify.com/components/app-provider for implementation instructions.");
      return mediaQuery;
    }
    exports.useMediaQuery = useMediaQuery;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-is-mounted-ref.js
var require_use_is_mounted_ref = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-is-mounted-ref.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react();
    function useIsMountedRef() {
      let isMounted = React12.useRef(!1);
      return React12.useEffect(() => (isMounted.current = !0, () => {
        isMounted.current = !1;
      }), []), isMounted;
    }
    exports.useIsMountedRef = useIsMountedRef;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/Loading/Loading.scss.js
var require_Loading_scss2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/Loading/Loading.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Loading: "Polaris-Frame-Loading",
      Level: "Polaris-Frame-Loading__Level"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/Loading/Loading.js
var require_Loading2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/Loading/Loading.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), useIsMountedRef = require_use_is_mounted_ref(), Loading_module = require_Loading_scss2(), hooks2 = require_hooks2(), STUCK_THRESHOLD = 99;
    function Loading() {
      let i18n = hooks2.useI18n(), isMountedRef = useIsMountedRef.useIsMountedRef(), [progress, setProgress] = React12.useState(0), [animating, setAnimating] = React12.useState(!1);
      React12.useEffect(() => {
        progress >= STUCK_THRESHOLD || animating || requestAnimationFrame(() => {
          if (!isMountedRef.current)
            return;
          let step = Math.max((STUCK_THRESHOLD - progress) / 10, 1);
          setAnimating(!0), setProgress(progress + step);
        });
      }, [progress, animating, isMountedRef]);
      let customStyles = {
        transform: `scaleX(${Math.floor(progress) / 100})`
      };
      return /* @__PURE__ */ React12.createElement("div", {
        className: Loading_module.default.Loading,
        "aria-valuenow": progress,
        "aria-valuemin": 0,
        "aria-valuemax": 100,
        role: "progressbar",
        "aria-label": i18n.translate("Polaris.Loading.label")
      }, /* @__PURE__ */ React12.createElement("div", {
        className: Loading_module.default.Level,
        style: customStyles,
        onTransitionEnd: () => setAnimating(!1)
      }));
    }
    exports.Loading = Loading;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/CSSAnimation/CSSAnimation.scss.js
var require_CSSAnimation_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/CSSAnimation/CSSAnimation.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      startFade: "Polaris-Frame-CSSAnimation--startFade",
      endFade: "Polaris-Frame-CSSAnimation--endFade"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/CSSAnimation/CSSAnimation.js
var require_CSSAnimation = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/CSSAnimation/CSSAnimation.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), CSSAnimation_module = require_CSSAnimation_scss(), TransitionStatus;
    (function(TransitionStatus2) {
      TransitionStatus2.Entering = "entering", TransitionStatus2.Entered = "entered", TransitionStatus2.Exiting = "exiting", TransitionStatus2.Exited = "exited";
    })(TransitionStatus || (TransitionStatus = {}));
    function CSSAnimation({
      in: inProp,
      className,
      type,
      children
    }) {
      let [transitionStatus, setTransitionStatus] = React12.useState(inProp ? TransitionStatus.Entering : TransitionStatus.Exited), isMounted = React12.useRef(!1), node = React12.useRef(null);
      React12.useEffect(() => {
        isMounted.current && transitionStatus === TransitionStatus.Entering && changeTransitionStatus(TransitionStatus.Entered);
      }, [transitionStatus]), React12.useEffect(() => {
        isMounted.current && (inProp && changeTransitionStatus(TransitionStatus.Entering), !inProp && changeTransitionStatus(TransitionStatus.Exiting));
      }, [inProp]), React12.useEffect(() => {
        isMounted.current = !0;
      }, []);
      let wrapperClassName = css.classNames(className, CSSAnimation_module.default[css.variationName("start", type)], inProp && CSSAnimation_module.default[css.variationName("end", type)]), content = transitionStatus === TransitionStatus.Exited && !inProp ? null : children;
      return /* @__PURE__ */ React12.createElement("div", {
        className: wrapperClassName,
        ref: node,
        onTransitionEnd: handleTransitionEnd
      }, content);
      function handleTransitionEnd() {
        transitionStatus === TransitionStatus.Exiting && changeTransitionStatus(TransitionStatus.Exited);
      }
      function changeTransitionStatus(transitionStatus2) {
        setTransitionStatus(transitionStatus2), transitionStatus2 === TransitionStatus.Entering && node.current && node.current.getBoundingClientRect();
      }
    }
    exports.CSSAnimation = CSSAnimation;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/pluck-deep.js
var require_pluck_deep = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/pluck-deep.js"(exports) {
    "use strict";
    init_cjs_shims();
    var isObject4 = require_is_object();
    function pluckDeep(obj, key) {
      if (!obj)
        return null;
      let keys = Object.keys(obj);
      for (let currKey of keys) {
        if (currKey === key)
          return obj[key];
        if (isObject4.isObject(obj[currKey])) {
          let plucked = pluckDeep(obj[currKey], key);
          if (plucked)
            return plucked;
        }
      }
      return null;
    }
    exports.pluckDeep = pluckDeep;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/get-width.js
var require_get_width = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/get-width.js"(exports) {
    "use strict";
    init_cjs_shims();
    var pluckDeep = require_pluck_deep();
    function getWidth(value = {}, defaultWidth = 0, key = "width") {
      let width = typeof value == "number" ? value : pluckDeep.pluckDeep(value, key);
      return width ? `${width}px` : `${defaultWidth}px`;
    }
    exports.getWidth = getWidth;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/ContextualSaveBar/ContextualSaveBar.scss.js
var require_ContextualSaveBar_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/ContextualSaveBar/ContextualSaveBar.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      ContextualSaveBar: "Polaris-Frame-ContextualSaveBar",
      LogoContainer: "Polaris-Frame-ContextualSaveBar__LogoContainer",
      ContextControl: "Polaris-Frame-ContextualSaveBar__ContextControl",
      Contents: "Polaris-Frame-ContextualSaveBar__Contents",
      fullWidth: "Polaris-Frame-ContextualSaveBar--fullWidth",
      MessageContainer: "Polaris-Frame-ContextualSaveBar__MessageContainer",
      ActionContainer: "Polaris-Frame-ContextualSaveBar__ActionContainer",
      Action: "Polaris-Frame-ContextualSaveBar__Action"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/Modal.scss.js
var require_Modal_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/Modal.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Body: "Polaris-Modal__Body",
      IFrame: "Polaris-Modal__IFrame"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/components/Section/Section.scss.js
var require_Section_scss2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/components/Section/Section.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Section: "Polaris-Modal-Section",
      titleHidden: "Polaris-Modal-Section--titleHidden"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/components/Section/Section.js
var require_Section5 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/components/Section/Section.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Section_module = require_Section_scss2(), Box2 = require_Box();
    function Section({
      children,
      flush = !1,
      subdued = !1,
      titleHidden = !1
    }) {
      let className = css.classNames(Section_module.default.Section, titleHidden && Section_module.default.titleHidden);
      return /* @__PURE__ */ React12.createElement("div", {
        className
      }, /* @__PURE__ */ React12.createElement(Box2.Box, Object.assign({
        as: "section",
        padding: flush ? "0" : "400"
      }, titleHidden && {
        paddingInlineEnd: "0"
      }, subdued && {
        background: "bg-surface-tertiary"
      }), children));
    }
    exports.Section = Section;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/components/Dialog/Dialog.scss.js
var require_Dialog_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/components/Dialog/Dialog.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Container: "Polaris-Modal-Dialog__Container",
      Dialog: "Polaris-Modal-Dialog",
      Modal: "Polaris-Modal-Dialog__Modal",
      limitHeight: "Polaris-Modal-Dialog--limitHeight",
      sizeSmall: "Polaris-Modal-Dialog--sizeSmall",
      sizeLarge: "Polaris-Modal-Dialog--sizeLarge",
      sizeFullScreen: "Polaris-Modal-Dialog--sizeFullScreen",
      animateFadeUp: "Polaris-Modal-Dialog--animateFadeUp",
      entering: "Polaris-Modal-Dialog--entering",
      exiting: "Polaris-Modal-Dialog--exiting",
      exited: "Polaris-Modal-Dialog--exited",
      entered: "Polaris-Modal-Dialog--entered"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/focus-manager/hooks.js
var require_hooks12 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/focus-manager/hooks.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), errors2 = require_errors6(), context = require_context8();
    function useFocusManager({
      trapping
    }) {
      let focusManager = React12.useContext(context.FocusManagerContext), id = React12.useId();
      if (!focusManager)
        throw new errors2.MissingAppProviderError("No FocusManager was provided.");
      let {
        trapFocusList,
        add: addFocusItem,
        remove: removeFocusItem
      } = focusManager, canSafelyFocus = trapFocusList[0] === id, value = React12.useMemo(() => ({
        canSafelyFocus
      }), [canSafelyFocus]);
      return React12.useEffect(() => {
        if (trapping)
          return addFocusItem(id), () => {
            removeFocusItem(id);
          };
      }, [addFocusItem, id, removeFocusItem, trapping]), value;
    }
    exports.useFocusManager = useFocusManager;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TrapFocus/TrapFocus.js
var require_TrapFocus = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TrapFocus/TrapFocus.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), types = require_types7(), focus = require_focus(), shared = require_shared(), hooks2 = require_hooks12(), Focus = require_Focus(), EventListener = require_EventListener(), KeypressListener = require_KeypressListener();
    function TrapFocus({
      trapping = !0,
      children
    }) {
      let {
        canSafelyFocus
      } = hooks2.useFocusManager({
        trapping
      }), focusTrapWrapper = React12.useRef(null), [disableFocus, setDisableFocus] = React12.useState(!0);
      React12.useEffect(() => {
        let disable = canSafelyFocus && !(focusTrapWrapper.current && focusTrapWrapper.current.contains(document.activeElement)) ? !trapping : !0;
        setDisableFocus(disable);
      }, [canSafelyFocus, trapping]);
      let handleFocusIn = (event) => {
        let containerContentsHaveFocus = focusTrapWrapper.current && focusTrapWrapper.current.contains(document.activeElement);
        trapping === !1 || !focusTrapWrapper.current || containerContentsHaveFocus || event.target instanceof Element && event.target.matches(`${shared.portal.selector} *`) || canSafelyFocus && event.target instanceof HTMLElement && focusTrapWrapper.current !== event.target && !focusTrapWrapper.current.contains(event.target) && focus.focusFirstFocusableNode(focusTrapWrapper.current);
      }, handleTab = (event) => {
        if (trapping === !1 || !focusTrapWrapper.current)
          return;
        let firstFocusableNode = focus.findFirstKeyboardFocusableNode(focusTrapWrapper.current), lastFocusableNode = focus.findLastKeyboardFocusableNode(focusTrapWrapper.current);
        event.target === lastFocusableNode && !event.shiftKey && (event.preventDefault(), focus.focusFirstKeyboardFocusableNode(focusTrapWrapper.current)), event.target === firstFocusableNode && event.shiftKey && (event.preventDefault(), focus.focusLastKeyboardFocusableNode(focusTrapWrapper.current));
      };
      return /* @__PURE__ */ React12.createElement(Focus.Focus, {
        disabled: disableFocus,
        root: focusTrapWrapper.current
      }, /* @__PURE__ */ React12.createElement("div", {
        ref: focusTrapWrapper
      }, /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
        event: "focusin",
        handler: handleFocusIn
      }), /* @__PURE__ */ React12.createElement(KeypressListener.KeypressListener, {
        keyCode: types.Key.Tab,
        keyEvent: "keydown",
        handler: handleTab
      }), children));
    }
    exports.TrapFocus = TrapFocus;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/components/Dialog/Dialog.js
var require_Dialog = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/components/Dialog/Dialog.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), reactTransitionGroup = require_cjs4(), css = require_css(), focus = require_focus(), types = require_types7(), useTheme = require_use_theme(), Dialog_module = require_Dialog_scss(), context = require_context15(), TrapFocus = require_TrapFocus(), Text4 = require_Text(), KeypressListener = require_KeypressListener();
    function Dialog({
      instant,
      labelledBy,
      children,
      limitHeight,
      size,
      onClose,
      onExited,
      onEntered,
      setClosing,
      hasToasts,
      ...props
    }) {
      let theme = useTheme.useTheme(), containerNode = React12.useRef(null), frameContext = React12.useContext(context.FrameContext), toastMessages;
      frameContext && (toastMessages = frameContext.toastMessages);
      let classes = css.classNames(Dialog_module.default.Modal, size && Dialog_module.default[css.variationName("size", size)], limitHeight && Dialog_module.default.limitHeight), TransitionChild = instant ? reactTransitionGroup.Transition : FadeUp;
      React12.useEffect(() => {
        containerNode.current && !containerNode.current.contains(document.activeElement) && focus.focusFirstFocusableNode(containerNode.current);
      }, []);
      let handleKeyDown = () => {
        setClosing && setClosing(!0);
      }, handleKeyUp = () => {
        setClosing && setClosing(!1), onClose();
      }, ariaLiveAnnouncements = /* @__PURE__ */ React12.createElement("div", {
        "aria-live": "assertive"
      }, toastMessages ? toastMessages.map((toastMessage) => /* @__PURE__ */ React12.createElement(Text4.Text, {
        visuallyHidden: !0,
        as: "p",
        key: toastMessage.id
      }, toastMessage.content)) : null);
      return /* @__PURE__ */ React12.createElement(TransitionChild, Object.assign({}, props, {
        nodeRef: containerNode,
        mountOnEnter: !0,
        unmountOnExit: !0,
        timeout: parseInt(theme.motion["motion-duration-200"], 10),
        onEntered,
        onExited
      }), /* @__PURE__ */ React12.createElement("div", {
        className: Dialog_module.default.Container,
        "data-polaris-layer": !0,
        "data-polaris-overlay": !0,
        ref: containerNode
      }, /* @__PURE__ */ React12.createElement(TrapFocus.TrapFocus, null, /* @__PURE__ */ React12.createElement("div", {
        role: "dialog",
        "aria-modal": !0,
        "aria-label": labelledBy,
        "aria-labelledby": labelledBy,
        tabIndex: -1,
        className: Dialog_module.default.Dialog
      }, /* @__PURE__ */ React12.createElement("div", {
        className: classes
      }, /* @__PURE__ */ React12.createElement(KeypressListener.KeypressListener, {
        keyCode: types.Key.Escape,
        keyEvent: "keydown",
        handler: handleKeyDown
      }), /* @__PURE__ */ React12.createElement(KeypressListener.KeypressListener, {
        keyCode: types.Key.Escape,
        handler: handleKeyUp
      }), children), ariaLiveAnnouncements))));
    }
    var fadeUpClasses = {
      appear: css.classNames(Dialog_module.default.animateFadeUp, Dialog_module.default.entering),
      appearActive: css.classNames(Dialog_module.default.animateFadeUp, Dialog_module.default.entered),
      enter: css.classNames(Dialog_module.default.animateFadeUp, Dialog_module.default.entering),
      enterActive: css.classNames(Dialog_module.default.animateFadeUp, Dialog_module.default.entered),
      exit: css.classNames(Dialog_module.default.animateFadeUp, Dialog_module.default.exiting),
      exitActive: css.classNames(Dialog_module.default.animateFadeUp, Dialog_module.default.exited)
    };
    function FadeUp({
      children,
      ...props
    }) {
      return /* @__PURE__ */ React12.createElement(reactTransitionGroup.CSSTransition, Object.assign({}, props, {
        classNames: fadeUpClasses
      }), children);
    }
    exports.Dialog = Dialog;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/components/CloseButton/CloseButton.js
var require_CloseButton = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/components/CloseButton/CloseButton.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), hooks2 = require_hooks2(), Button2 = require_Button();
    function CloseButton({
      pressed,
      onClick
    }) {
      let i18n = hooks2.useI18n();
      return /* @__PURE__ */ React12.createElement(Button2.Button, {
        variant: "tertiary",
        pressed,
        icon: polarisIcons.XIcon,
        onClick,
        accessibilityLabel: i18n.translate("Polaris.Common.close")
      });
    }
    exports.CloseButton = CloseButton;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/components/Header/Header.js
var require_Header3 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/components/Header/Header.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), CloseButton = require_CloseButton(), InlineGrid = require_InlineGrid(), Box2 = require_Box(), InlineStack2 = require_InlineStack(), Text4 = require_Text();
    function Header3({
      id,
      children,
      closing,
      titleHidden,
      onClose
    }) {
      let headerPaddingInline = "400", headerPaddingBlock = "400";
      return titleHidden || !children ? /* @__PURE__ */ React12.createElement(Box2.Box, {
        position: "absolute",
        insetInlineEnd: headerPaddingInline,
        insetBlockStart: headerPaddingBlock,
        zIndex: "1"
      }, /* @__PURE__ */ React12.createElement(CloseButton.CloseButton, {
        onClick: onClose
      })) : /* @__PURE__ */ React12.createElement(Box2.Box, {
        paddingBlockStart: "400",
        paddingBlockEnd: "400",
        paddingInlineStart: headerPaddingInline,
        paddingInlineEnd: headerPaddingInline,
        borderBlockEndWidth: "025",
        borderColor: "border",
        background: "bg-surface-tertiary"
      }, /* @__PURE__ */ React12.createElement(InlineGrid.InlineGrid, {
        columns: {
          xs: "1fr auto"
        },
        gap: "400"
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "400",
        blockAlign: "center"
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        id,
        as: "h2",
        variant: "headingMd",
        breakWord: !0
      }, children)), /* @__PURE__ */ React12.createElement(CloseButton.CloseButton, {
        pressed: closing,
        onClick: onClose
      })));
    }
    exports.Header = Header3;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/components/Footer/Footer.js
var require_Footer = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/components/Footer/Footer.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), utils = require_utils10(), InlineStack2 = require_InlineStack(), Box2 = require_Box();
    function Footer({
      primaryAction,
      secondaryActions,
      children
    }) {
      let primaryActionButton = primaryAction && utils.buttonsFrom(primaryAction, {
        variant: "primary"
      }) || null, secondaryActionButtons = secondaryActions && utils.buttonsFrom(secondaryActions) || null, actions = primaryActionButton || secondaryActionButtons ? /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "200"
      }, secondaryActionButtons, primaryActionButton) : null;
      return /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "400",
        blockAlign: "center"
      }, /* @__PURE__ */ React12.createElement(Box2.Box, {
        borderColor: "border",
        borderBlockStartWidth: "025",
        padding: "400",
        width: "100%"
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "400",
        blockAlign: "center",
        align: "space-between"
      }, /* @__PURE__ */ React12.createElement(Box2.Box, null, children), actions)));
    }
    exports.Footer = Footer;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/Modal.js
var require_Modal = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Modal/Modal.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), reactTransitionGroup = require_cjs4(), focus = require_focus(), withinContentContext = require_within_content_context(), components = require_components(), Modal_module = require_Modal_scss(), Section = require_Section5(), Dialog = require_Dialog(), Header3 = require_Header3(), Backdrop = require_Backdrop(), Footer = require_Footer(), hooks2 = require_hooks2(), Box2 = require_Box(), Scrollable = require_Scrollable(), Portal = require_Portal(), InlineStack2 = require_InlineStack(), Spinner = require_Spinner(), IFRAME_LOADING_HEIGHT = 200, DEFAULT_IFRAME_CONTENT_HEIGHT = 400, Modal = function({
      children,
      title,
      titleHidden = !1,
      src,
      iFrameName,
      open: open2,
      instant,
      sectioned,
      loading,
      size,
      limitHeight,
      footer,
      primaryAction,
      secondaryActions,
      onScrolledToBottom,
      activator,
      activatorWrapper = "div",
      onClose,
      onIFrameLoad,
      onTransitionEnd,
      noScroll
    }) {
      let [iframeHeight, setIframeHeight] = React12.useState(IFRAME_LOADING_HEIGHT), [closing, setClosing] = React12.useState(!1), headerId = React12.useId(), activatorRef = React12.useRef(null), iframeTitle = hooks2.useI18n().translate("Polaris.Modal.iFrameTitle"), dialog, backdrop, handleEntered = React12.useCallback(() => {
        onTransitionEnd && onTransitionEnd();
      }, [onTransitionEnd]), handleExited = React12.useCallback(() => {
        setIframeHeight(IFRAME_LOADING_HEIGHT);
        let activatorElement = activator && isRef(activator) ? activator && activator.current : activatorRef.current;
        activatorElement && requestAnimationFrame(() => focus.focusFirstFocusableNode(activatorElement));
      }, [activator]), handleIFrameLoad = React12.useCallback((evt) => {
        let iframe = evt.target;
        if (iframe && iframe.contentWindow)
          try {
            setIframeHeight(iframe.contentWindow.document.body.scrollHeight);
          } catch {
            setIframeHeight(DEFAULT_IFRAME_CONTENT_HEIGHT);
          }
        onIFrameLoad?.(evt);
      }, [onIFrameLoad]);
      if (open2) {
        let footerMarkup = !footer && !primaryAction && !secondaryActions ? null : /* @__PURE__ */ React12.createElement(Footer.Footer, {
          primaryAction,
          secondaryActions
        }, footer), content = sectioned ? components.wrapWithComponent(children, Section.Section, {
          titleHidden
        }) : children, body = loading ? /* @__PURE__ */ React12.createElement(Box2.Box, {
          padding: "400"
        }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
          gap: "400",
          align: "center",
          blockAlign: "center"
        }, /* @__PURE__ */ React12.createElement(Spinner.Spinner, null))) : content, scrollContainerMarkup = noScroll ? /* @__PURE__ */ React12.createElement(Box2.Box, {
          width: "100%",
          overflowX: "hidden",
          overflowY: "hidden"
        }, body) : /* @__PURE__ */ React12.createElement(Scrollable.Scrollable, {
          shadow: !0,
          className: Modal_module.default.Body,
          onScrolledToBottom
        }, body), bodyMarkup = src ? /* @__PURE__ */ React12.createElement("iframe", {
          name: iFrameName,
          title: iframeTitle,
          src,
          className: Modal_module.default.IFrame,
          onLoad: handleIFrameLoad,
          style: {
            height: `${iframeHeight}px`
          }
        }) : scrollContainerMarkup;
        dialog = /* @__PURE__ */ React12.createElement(Dialog.Dialog, {
          instant,
          labelledBy: headerId,
          onClose,
          onEntered: handleEntered,
          onExited: handleExited,
          size,
          limitHeight,
          setClosing
        }, /* @__PURE__ */ React12.createElement(Header3.Header, {
          titleHidden,
          id: headerId,
          closing,
          onClose
        }, title), bodyMarkup, footerMarkup), backdrop = /* @__PURE__ */ React12.createElement(Backdrop.Backdrop, {
          setClosing,
          onClick: onClose
        });
      }
      let animated = !instant, activatorMarkup = activator && !isRef(activator) ? /* @__PURE__ */ React12.createElement(Box2.Box, {
        ref: activatorRef,
        as: activatorWrapper
      }, activator) : null;
      return /* @__PURE__ */ React12.createElement(withinContentContext.WithinContentContext.Provider, {
        value: !0
      }, activatorMarkup, /* @__PURE__ */ React12.createElement(Portal.Portal, {
        idPrefix: "modal"
      }, /* @__PURE__ */ React12.createElement(reactTransitionGroup.TransitionGroup, {
        appear: animated,
        enter: animated,
        exit: animated
      }, dialog), backdrop));
    };
    function isRef(ref) {
      return Object.prototype.hasOwnProperty.call(ref, "current");
    }
    Modal.Section = Section.Section;
    exports.Modal = Modal;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/ContextualSaveBar/components/DiscardConfirmationModal/DiscardConfirmationModal.js
var require_DiscardConfirmationModal = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/ContextualSaveBar/components/DiscardConfirmationModal/DiscardConfirmationModal.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), Modal = require_Modal(), hooks2 = require_hooks2();
    function DiscardConfirmationModal({
      open: open2,
      onDiscard,
      onCancel
    }) {
      let i18n = hooks2.useI18n();
      return /* @__PURE__ */ React12.createElement(Modal.Modal, {
        title: i18n.translate("Polaris.DiscardConfirmationModal.title"),
        open: open2,
        onClose: onCancel,
        primaryAction: {
          content: i18n.translate("Polaris.DiscardConfirmationModal.primaryAction"),
          destructive: !0,
          onAction: onDiscard
        },
        secondaryActions: [{
          content: i18n.translate("Polaris.DiscardConfirmationModal.secondaryAction"),
          onAction: onCancel
        }],
        sectioned: !0
      }, i18n.translate("Polaris.DiscardConfirmationModal.message"));
    }
    exports.DiscardConfirmationModal = DiscardConfirmationModal;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/ContextualSaveBar/ContextualSaveBar.js
var require_ContextualSaveBar2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/ContextualSaveBar/ContextualSaveBar.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), getWidth = require_get_width(), useToggle = require_use_toggle(), ContextualSaveBar_module = require_ContextualSaveBar_scss(), DiscardConfirmationModal = require_DiscardConfirmationModal(), hooks2 = require_hooks2(), hooks$1 = require_hooks9(), Button2 = require_Button(), Image = require_Image(), Icon = require_Icon(), Text4 = require_Text(), LegacyStack = require_LegacyStack();
    function ContextualSaveBar({
      alignContentFlush,
      message,
      saveAction,
      discardAction,
      fullWidth,
      contextControl,
      secondaryMenu
    }) {
      let i18n = hooks2.useI18n(), {
        logo
      } = hooks$1.useFrame(), {
        value: discardConfirmationModalVisible,
        toggle: toggleDiscardConfirmationModal,
        setFalse: closeDiscardConfirmationModal
      } = useToggle.useToggle(!1), handleDiscardAction = React12.useCallback(() => {
        discardAction && discardAction.onAction && discardAction.onAction(), closeDiscardConfirmationModal();
      }, [closeDiscardConfirmationModal, discardAction]), discardActionContent = discardAction && discardAction.content ? discardAction.content : i18n.translate("Polaris.ContextualSaveBar.discard"), discardActionHandler;
      discardAction && discardAction.discardConfirmationModal ? discardActionHandler = toggleDiscardConfirmationModal : discardAction && (discardActionHandler = discardAction.onAction);
      let discardConfirmationModalMarkup = discardAction && discardAction.onAction && discardAction.discardConfirmationModal && /* @__PURE__ */ React12.createElement(DiscardConfirmationModal.DiscardConfirmationModal, {
        open: discardConfirmationModalVisible,
        onCancel: toggleDiscardConfirmationModal,
        onDiscard: handleDiscardAction
      }), discardActionMarkup = discardAction && /* @__PURE__ */ React12.createElement(Button2.Button, {
        variant: "tertiary",
        size: "large",
        url: discardAction.url,
        onClick: discardActionHandler,
        loading: discardAction.loading,
        disabled: discardAction.disabled,
        accessibilityLabel: discardAction.content
      }, discardActionContent), saveActionContent = saveAction && saveAction.content ? saveAction.content : i18n.translate("Polaris.ContextualSaveBar.save"), saveActionMarkup = saveAction && /* @__PURE__ */ React12.createElement(Button2.Button, {
        variant: "primary",
        tone: "success",
        size: "large",
        url: saveAction.url,
        onClick: saveAction.onAction,
        loading: saveAction.loading,
        disabled: saveAction.disabled,
        accessibilityLabel: saveAction.content
      }, saveActionContent), width = getWidth.getWidth(logo, 104), imageMarkup = logo && /* @__PURE__ */ React12.createElement(Image.Image, {
        style: {
          width
        },
        source: logo.contextualSaveBarSource || "",
        alt: ""
      }), logoMarkup = alignContentFlush || contextControl ? null : /* @__PURE__ */ React12.createElement("div", {
        className: ContextualSaveBar_module.default.LogoContainer,
        style: {
          width
        }
      }, imageMarkup), contextControlMarkup = contextControl ? /* @__PURE__ */ React12.createElement("div", {
        className: ContextualSaveBar_module.default.ContextControl
      }, contextControl) : null, contentsClassName = css.classNames(ContextualSaveBar_module.default.Contents, fullWidth && ContextualSaveBar_module.default.fullWidth);
      return /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement("div", {
        className: ContextualSaveBar_module.default.ContextualSaveBar
      }, contextControlMarkup, logoMarkup, /* @__PURE__ */ React12.createElement("div", {
        className: contentsClassName
      }, /* @__PURE__ */ React12.createElement("div", {
        className: ContextualSaveBar_module.default.MessageContainer
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.AlertTriangleIcon
      }), message && /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "h2",
        variant: "headingMd",
        tone: "text-inverse",
        truncate: !0
      }, message)), /* @__PURE__ */ React12.createElement("div", {
        className: ContextualSaveBar_module.default.ActionContainer
      }, /* @__PURE__ */ React12.createElement(LegacyStack.LegacyStack, {
        spacing: "tight",
        wrap: !1
      }, secondaryMenu, discardActionMarkup, saveActionMarkup)))), discardConfirmationModalMarkup);
    }
    exports.ContextualSaveBar = ContextualSaveBar;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-deep-compare-ref.js
var require_use_deep_compare_ref = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-deep-compare-ref.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), isEqual = require_react_fast_compare();
    function useDeepCompareRef(dependencies, comparator = isEqual) {
      let dependencyList = React12.useRef(dependencies);
      return comparator(dependencyList.current, dependencies) || (dependencyList.current = dependencies), dependencyList.current;
    }
    exports.useDeepCompareRef = useDeepCompareRef;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-deep-effect.js
var require_use_deep_effect = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-deep-effect.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), useDeepCompareRef = require_use_deep_compare_ref();
    function useDeepEffect(callback, dependencies, customCompare) {
      React12.useEffect(callback, useDeepCompareRef.useDeepCompareRef(dependencies, customCompare));
    }
    exports.useDeepEffect = useDeepEffect;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-deep-callback.js
var require_use_deep_callback = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-deep-callback.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), useDeepCompareRef = require_use_deep_compare_ref();
    function useDeepCallback(callback, dependencies, customCompare) {
      return React12.useCallback(callback, useDeepCompareRef.useDeepCompareRef(dependencies, customCompare));
    }
    exports.useDeepCallback = useDeepCallback;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/ToastManager/ToastManager.scss.js
var require_ToastManager_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/ToastManager/ToastManager.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      ToastManager: "Polaris-Frame-ToastManager",
      ToastWrapper: "Polaris-Frame-ToastManager__ToastWrapper",
      "ToastWrapper-enter": "Polaris-Frame-ToastManager__ToastWrapper--enter",
      "ToastWrapper-exit": "Polaris-Frame-ToastManager__ToastWrapper--exit",
      "ToastWrapper-enter-done": "Polaris-Frame-ToastManager--toastWrapperEnterDone"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/Toast/Toast.scss.js
var require_Toast_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/Toast/Toast.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Toast: "Polaris-Frame-Toast",
      Action: "Polaris-Frame-Toast__Action",
      error: "Polaris-Frame-Toast--error",
      CloseButton: "Polaris-Frame-Toast__CloseButton",
      LeadingIcon: "Polaris-Frame-Toast__LeadingIcon"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/Toast/Toast.js
var require_Toast = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/Toast/Toast.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), types = require_types7(), Toast_module = require_Toast_scss(), Icon = require_Icon(), Button2 = require_Button(), KeypressListener = require_KeypressListener(), InlineStack2 = require_InlineStack(), Text4 = require_Text(), DEFAULT_TOAST_DURATION = 5e3, DEFAULT_TOAST_DURATION_WITH_ACTION = 1e4;
    function Toast({
      content,
      onDismiss,
      duration,
      error,
      action
    }) {
      React12.useEffect(() => {
        let timeoutDuration = duration || DEFAULT_TOAST_DURATION;
        action && !duration ? timeoutDuration = DEFAULT_TOAST_DURATION_WITH_ACTION : action && duration && duration < DEFAULT_TOAST_DURATION_WITH_ACTION && console.log("Toast with action should persist for at least 10,000 milliseconds to give the merchant enough time to act on it.");
        let timer = setTimeout(onDismiss, timeoutDuration);
        return () => {
          clearTimeout(timer);
        };
      }, [action, duration, onDismiss]);
      let dismissMarkup = /* @__PURE__ */ React12.createElement("button", {
        type: "button",
        className: Toast_module.default.CloseButton,
        onClick: onDismiss
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.XSmallIcon,
        tone: "inherit"
      })), actionMarkup = action ? /* @__PURE__ */ React12.createElement("div", {
        className: Toast_module.default.Action
      }, /* @__PURE__ */ React12.createElement(Button2.Button, {
        variant: "monochromePlain",
        removeUnderline: !0,
        size: "slim",
        onClick: action.onAction
      }, action.content)) : null, leadingIconMarkup = error ? /* @__PURE__ */ React12.createElement("div", {
        className: Toast_module.default.LeadingIcon
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.AlertCircleIcon,
        tone: "inherit"
      })) : null, className = css.classNames(Toast_module.default.Toast, error && Toast_module.default.error);
      return /* @__PURE__ */ React12.createElement("div", {
        className,
        "aria-live": "assertive"
      }, /* @__PURE__ */ React12.createElement(KeypressListener.KeypressListener, {
        keyCode: types.Key.Escape,
        handler: onDismiss
      }), leadingIconMarkup, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "400",
        blockAlign: "center"
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        fontWeight: "medium"
      }, content)), actionMarkup, dismissMarkup);
    }
    exports.DEFAULT_TOAST_DURATION = DEFAULT_TOAST_DURATION;
    exports.DEFAULT_TOAST_DURATION_WITH_ACTION = DEFAULT_TOAST_DURATION_WITH_ACTION;
    exports.Toast = Toast;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/ToastManager/ToastManager.js
var require_ToastManager = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/components/ToastManager/ToastManager.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), reactTransitionGroup = require_cjs4(), css = require_css(), useDeepEffect = require_use_deep_effect(), useDeepCallback = require_use_deep_callback(), ToastManager_module = require_ToastManager_scss(), Toast = require_Toast(), Portal = require_Portal(), EventListener = require_EventListener(), ToastManager = /* @__PURE__ */ React12.memo(function({
      toastMessages
    }) {
      let toastNodes = [], updateToasts = useDeepCallback.useDeepCallback(() => {
        let targetInPos = 0;
        toastMessages.forEach((_2, index) => {
          let currentToast = toastNodes[index];
          currentToast.current && (targetInPos += currentToast.current.clientHeight, currentToast.current.style.setProperty("--pc-toast-manager-translate-y-in", `-${targetInPos}px`), currentToast.current.style.setProperty("--pc-toast-manager-translate-y-out", `${-targetInPos + 150}px`));
        });
      }, [toastMessages, toastNodes]);
      useDeepEffect.useDeepEffect(() => {
        updateToasts();
      }, [toastMessages]);
      let toastsMarkup = toastMessages.map((toast, index) => {
        let toastNode = /* @__PURE__ */ React12.createRef();
        return toastNodes[index] = toastNode, /* @__PURE__ */ React12.createElement(reactTransitionGroup.CSSTransition, {
          nodeRef: toastNodes[index],
          key: toast.id,
          timeout: {
            enter: 0,
            exit: 400
          },
          classNames: toastClasses
        }, /* @__PURE__ */ React12.createElement("div", {
          ref: toastNode
        }, /* @__PURE__ */ React12.createElement(Toast.Toast, toast)));
      });
      return /* @__PURE__ */ React12.createElement(Portal.Portal, {
        idPrefix: "toast"
      }, /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
        event: "resize",
        handler: updateToasts
      }), /* @__PURE__ */ React12.createElement("div", {
        className: ToastManager_module.default.ToastManager,
        "aria-live": "assertive"
      }, /* @__PURE__ */ React12.createElement(reactTransitionGroup.TransitionGroup, {
        component: null
      }, toastsMarkup)));
    }), toastClasses = {
      enter: css.classNames(ToastManager_module.default.ToastWrapper, ToastManager_module.default["ToastWrapper-enter"]),
      enterDone: css.classNames(ToastManager_module.default.ToastWrapper, ToastManager_module.default["ToastWrapper-enter-done"]),
      exit: css.classNames(ToastManager_module.default.ToastWrapper, ToastManager_module.default["ToastWrapper-exit"])
    };
    exports.ToastManager = ToastManager;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/Frame.js
var require_Frame = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Frame/Frame.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), reactTransitionGroup = require_cjs4(), css = require_css(), shared = require_shared(), setRootProperty = require_set_root_property(), useTheme = require_use_theme(), Frame_module = require_Frame_scss(), hooks$1 = require_hooks11(), Loading = require_Loading2(), CSSAnimation = require_CSSAnimation(), ContextualSaveBar = require_ContextualSaveBar2(), ToastManager = require_ToastManager(), hooks2 = require_hooks2(), Backdrop = require_Backdrop(), context = require_context15(), EventListener = require_EventListener(), TrapFocus = require_TrapFocus(), Icon = require_Icon(), APP_FRAME_MAIN = "AppFrameMain", APP_FRAME_NAV = "AppFrameNav", APP_FRAME_TOP_BAR = "AppFrameTopBar", APP_FRAME_LOADING_BAR = "AppFrameLoadingBar", FrameInner = class extends React12.PureComponent {
      constructor(...args) {
        super(...args), this.state = {
          skipFocused: !1,
          globalRibbonHeight: 0,
          loadingStack: 0,
          toastMessages: [],
          showContextualSaveBar: !1
        }, this.contextualSaveBar = null, this.globalRibbonContainer = null, this.navigationNode = /* @__PURE__ */ React12.createRef(), this.setGlobalRibbonHeight = () => {
          let {
            globalRibbonContainer
          } = this;
          globalRibbonContainer && this.setState({
            globalRibbonHeight: globalRibbonContainer.offsetHeight
          }, this.setGlobalRibbonRootProperty);
        }, this.setOffset = () => {
          let {
            offset = "0px"
          } = this.props;
          setRootProperty.setRootProperty("--pc-frame-offset", offset);
        }, this.setGlobalRibbonRootProperty = () => {
          let {
            globalRibbonHeight
          } = this.state;
          setRootProperty.setRootProperty("--pc-frame-global-ribbon-height", `${globalRibbonHeight}px`);
        }, this.showToast = (toast) => {
          this.setState(({
            toastMessages
          }) => ({
            toastMessages: toastMessages.find(({
              id
            }) => id === toast.id) != null ? toastMessages : [...toastMessages, toast]
          }));
        }, this.hideToast = ({
          id
        }) => {
          this.setState(({
            toastMessages
          }) => ({
            toastMessages: toastMessages.filter(({
              id: toastId
            }) => id !== toastId)
          }));
        }, this.setContextualSaveBar = (props) => {
          let {
            showContextualSaveBar
          } = this.state;
          this.contextualSaveBar = {
            ...props
          }, showContextualSaveBar === !0 ? this.forceUpdate() : this.setState({
            showContextualSaveBar: !0
          });
        }, this.removeContextualSaveBar = () => {
          this.contextualSaveBar = null, this.setState({
            showContextualSaveBar: !1
          });
        }, this.startLoading = () => {
          this.setState(({
            loadingStack
          }) => ({
            loadingStack: loadingStack + 1
          }));
        }, this.stopLoading = () => {
          this.setState(({
            loadingStack
          }) => ({
            loadingStack: Math.max(0, loadingStack - 1)
          }));
        }, this.handleResize = () => {
          this.props.globalRibbon && this.setGlobalRibbonHeight();
        }, this.handleFocus = () => {
          this.setState({
            skipFocused: !0
          });
        }, this.handleBlur = () => {
          this.setState({
            skipFocused: !1
          });
        }, this.handleClick = (event) => {
          let {
            skipToContentTarget
          } = this.props;
          skipToContentTarget && skipToContentTarget.current && (skipToContentTarget.current.focus(), event?.preventDefault());
        }, this.handleNavigationDismiss = () => {
          let {
            onNavigationDismiss
          } = this.props;
          onNavigationDismiss?.();
        }, this.setGlobalRibbonContainer = (node) => {
          this.globalRibbonContainer = node;
        }, this.handleNavKeydown = (event) => {
          let {
            key
          } = event, {
            mediaQuery: {
              isNavigationCollapsed
            },
            showMobileNavigation
          } = this.props;
          isNavigationCollapsed && showMobileNavigation && key === "Escape" && this.handleNavigationDismiss();
        };
      }
      componentDidMount() {
        this.handleResize(), !this.props.globalRibbon && (this.setGlobalRibbonRootProperty(), this.setOffset());
      }
      componentDidUpdate(prevProps) {
        this.props.globalRibbon !== prevProps.globalRibbon && this.setGlobalRibbonHeight(), this.setOffset();
      }
      render() {
        let {
          skipFocused,
          loadingStack,
          toastMessages,
          showContextualSaveBar
        } = this.state, {
          logo,
          children,
          navigation,
          topBar,
          globalRibbon,
          showMobileNavigation = !1,
          skipToContentTarget,
          i18n,
          sidebar,
          mediaQuery: {
            isNavigationCollapsed
          }
        } = this.props, navClassName = css.classNames(Frame_module.default.Navigation, showMobileNavigation && Frame_module.default["Navigation-visible"]), mobileNavHidden = isNavigationCollapsed && !showMobileNavigation, mobileNavShowing = isNavigationCollapsed && showMobileNavigation, tabIndex = mobileNavShowing ? 0 : -1, mobileNavAttributes = {
          ...mobileNavShowing && {
            "aria-modal": !0,
            role: "dialog"
          }
        }, navigationMarkup = navigation ? /* @__PURE__ */ React12.createElement(useTheme.UseTheme, null, (theme) => /* @__PURE__ */ React12.createElement(TrapFocus.TrapFocus, {
          trapping: mobileNavShowing
        }, /* @__PURE__ */ React12.createElement(reactTransitionGroup.CSSTransition, {
          nodeRef: this.navigationNode,
          appear: isNavigationCollapsed,
          exit: isNavigationCollapsed,
          in: showMobileNavigation,
          timeout: parseInt(theme.motion["motion-duration-300"], 10),
          classNames: navTransitionClasses
        }, /* @__PURE__ */ React12.createElement("div", Object.assign({
          key: "NavContent"
        }, mobileNavAttributes, {
          "aria-label": i18n.translate("Polaris.Frame.navigationLabel"),
          ref: this.navigationNode,
          className: navClassName,
          onKeyDown: this.handleNavKeydown,
          id: APP_FRAME_NAV,
          hidden: mobileNavHidden
        }), navigation, /* @__PURE__ */ React12.createElement("button", {
          type: "button",
          className: Frame_module.default.NavigationDismiss,
          onClick: this.handleNavigationDismiss,
          "aria-hidden": mobileNavHidden || !isNavigationCollapsed && !showMobileNavigation,
          "aria-label": i18n.translate("Polaris.Frame.Navigation.closeMobileNavigationLabel"),
          tabIndex
        }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
          source: polarisIcons.XIcon
        })))))) : null, loadingMarkup = loadingStack > 0 ? /* @__PURE__ */ React12.createElement("div", {
          className: Frame_module.default.LoadingBar,
          id: APP_FRAME_LOADING_BAR
        }, /* @__PURE__ */ React12.createElement(Loading.Loading, null)) : null, topBarMarkup = topBar ? /* @__PURE__ */ React12.createElement("div", Object.assign({
          className: Frame_module.default.TopBar
        }, shared.layer.props, shared.dataPolarisTopBar.props, {
          id: APP_FRAME_TOP_BAR
        }), topBar) : null, globalRibbonMarkup = globalRibbon ? /* @__PURE__ */ React12.createElement("div", {
          className: Frame_module.default.GlobalRibbonContainer,
          ref: this.setGlobalRibbonContainer
        }, globalRibbon) : null, skipClassName = css.classNames(Frame_module.default.Skip, skipFocused && Frame_module.default.focused), skipTarget = skipToContentTarget?.current ? skipToContentTarget.current.id : APP_FRAME_MAIN, skipMarkup = /* @__PURE__ */ React12.createElement("div", {
          className: skipClassName
        }, /* @__PURE__ */ React12.createElement("a", {
          href: `#${skipTarget}`,
          onFocus: this.handleFocus,
          onBlur: this.handleBlur,
          onClick: this.handleClick
        }, i18n.translate("Polaris.Frame.skipToContent"))), navigationAttributes = navigation ? {
          "data-has-navigation": !0
        } : {}, frameClassName = css.classNames(Frame_module.default.Frame, navigation && Frame_module.default.hasNav, topBar && Frame_module.default.hasTopBar, sidebar && Frame_module.default.hasSidebar), contextualSaveBarMarkup = /* @__PURE__ */ React12.createElement(CSSAnimation.CSSAnimation, {
          in: showContextualSaveBar,
          className: Frame_module.default.ContextualSaveBar,
          type: "fade"
        }, /* @__PURE__ */ React12.createElement(ContextualSaveBar.ContextualSaveBar, this.contextualSaveBar)), navigationOverlayMarkup = showMobileNavigation && isNavigationCollapsed ? /* @__PURE__ */ React12.createElement(Backdrop.Backdrop, {
          belowNavigation: !0,
          onClick: this.handleNavigationDismiss,
          onTouchStart: this.handleNavigationDismiss
        }) : null, context$1 = {
          logo,
          showToast: this.showToast,
          hideToast: this.hideToast,
          toastMessages,
          startLoading: this.startLoading,
          stopLoading: this.stopLoading,
          setContextualSaveBar: this.setContextualSaveBar,
          removeContextualSaveBar: this.removeContextualSaveBar
        };
        return /* @__PURE__ */ React12.createElement(context.FrameContext.Provider, {
          value: context$1
        }, /* @__PURE__ */ React12.createElement("div", Object.assign({
          className: frameClassName
        }, shared.layer.props, navigationAttributes), skipMarkup, topBarMarkup, navigationMarkup, contextualSaveBarMarkup, loadingMarkup, navigationOverlayMarkup, /* @__PURE__ */ React12.createElement("main", {
          className: Frame_module.default.Main,
          id: APP_FRAME_MAIN,
          "data-has-global-ribbon": !!globalRibbon
        }, /* @__PURE__ */ React12.createElement("div", {
          className: Frame_module.default.Content
        }, children)), /* @__PURE__ */ React12.createElement(ToastManager.ToastManager, {
          toastMessages
        }), globalRibbonMarkup, /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
          event: "resize",
          handler: this.handleResize
        })));
      }
    }, navTransitionClasses = {
      enter: css.classNames(Frame_module.default["Navigation-enter"]),
      enterActive: css.classNames(Frame_module.default["Navigation-enterActive"]),
      enterDone: css.classNames(Frame_module.default["Navigation-enterActive"]),
      exit: css.classNames(Frame_module.default["Navigation-exit"]),
      exitActive: css.classNames(Frame_module.default["Navigation-exitActive"])
    };
    function Frame(props) {
      let i18n = hooks2.useI18n(), mediaQuery = hooks$1.useMediaQuery();
      return /* @__PURE__ */ React12.createElement(FrameInner, Object.assign({}, props, {
        i18n,
        mediaQuery
      }));
    }
    exports.Frame = Frame;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FullscreenBar/FullscreenBar.scss.js
var require_FullscreenBar_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FullscreenBar/FullscreenBar.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      FullscreenBar: "Polaris-FullscreenBar",
      BackAction: "Polaris-FullscreenBar__BackAction"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FullscreenBar/FullscreenBar.js
var require_FullscreenBar = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/FullscreenBar/FullscreenBar.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), FullscreenBar_module = require_FullscreenBar_scss(), hooks2 = require_hooks2(), Text4 = require_Text(), Icon = require_Icon();
    function FullscreenBar({
      onAction,
      children
    }) {
      let i18n = hooks2.useI18n(), backButtonMarkup = /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        variant: "bodyLg"
      }, i18n.translate("Polaris.FullscreenBar.back"));
      return /* @__PURE__ */ React12.createElement("div", {
        className: FullscreenBar_module.default.FullscreenBar
      }, /* @__PURE__ */ React12.createElement("button", {
        className: FullscreenBar_module.default.BackAction,
        onClick: onAction,
        "aria-label": i18n.translate("Polaris.FullscreenBar.accessibilityLabel")
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.ExitIcon
      }), backButtonMarkup), children);
    }
    exports.FullscreenBar = FullscreenBar;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Grid/Grid.scss.js
var require_Grid_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Grid/Grid.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Grid: "Polaris-Grid"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Grid/components/Cell/Cell.scss.js
var require_Cell_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Grid/components/Cell/Cell.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Cell: "Polaris-Grid-Cell",
      "Cell-1-column-xs": "Polaris-Grid-Cell--cell_1ColumnXs",
      "Cell-2-column-xs": "Polaris-Grid-Cell--cell_2ColumnXs",
      "Cell-3-column-xs": "Polaris-Grid-Cell--cell_3ColumnXs",
      "Cell-4-column-xs": "Polaris-Grid-Cell--cell_4ColumnXs",
      "Cell-5-column-xs": "Polaris-Grid-Cell--cell_5ColumnXs",
      "Cell-6-column-xs": "Polaris-Grid-Cell--cell_6ColumnXs",
      "Cell-1-column-sm": "Polaris-Grid-Cell--cell_1ColumnSm",
      "Cell-2-column-sm": "Polaris-Grid-Cell--cell_2ColumnSm",
      "Cell-3-column-sm": "Polaris-Grid-Cell--cell_3ColumnSm",
      "Cell-4-column-sm": "Polaris-Grid-Cell--cell_4ColumnSm",
      "Cell-5-column-sm": "Polaris-Grid-Cell--cell_5ColumnSm",
      "Cell-6-column-sm": "Polaris-Grid-Cell--cell_6ColumnSm",
      "Cell-1-column-md": "Polaris-Grid-Cell--cell_1ColumnMd",
      "Cell-2-column-md": "Polaris-Grid-Cell--cell_2ColumnMd",
      "Cell-3-column-md": "Polaris-Grid-Cell--cell_3ColumnMd",
      "Cell-4-column-md": "Polaris-Grid-Cell--cell_4ColumnMd",
      "Cell-5-column-md": "Polaris-Grid-Cell--cell_5ColumnMd",
      "Cell-6-column-md": "Polaris-Grid-Cell--cell_6ColumnMd",
      "Cell-1-column-lg": "Polaris-Grid-Cell--cell_1ColumnLg",
      "Cell-2-column-lg": "Polaris-Grid-Cell--cell_2ColumnLg",
      "Cell-3-column-lg": "Polaris-Grid-Cell--cell_3ColumnLg",
      "Cell-4-column-lg": "Polaris-Grid-Cell--cell_4ColumnLg",
      "Cell-5-column-lg": "Polaris-Grid-Cell--cell_5ColumnLg",
      "Cell-6-column-lg": "Polaris-Grid-Cell--cell_6ColumnLg",
      "Cell-7-column-lg": "Polaris-Grid-Cell--cell_7ColumnLg",
      "Cell-8-column-lg": "Polaris-Grid-Cell--cell_8ColumnLg",
      "Cell-9-column-lg": "Polaris-Grid-Cell--cell_9ColumnLg",
      "Cell-10-column-lg": "Polaris-Grid-Cell--cell_10ColumnLg",
      "Cell-11-column-lg": "Polaris-Grid-Cell--cell_11ColumnLg",
      "Cell-12-column-lg": "Polaris-Grid-Cell--cell_12ColumnLg",
      "Cell-1-column-xl": "Polaris-Grid-Cell--cell_1ColumnXl",
      "Cell-2-column-xl": "Polaris-Grid-Cell--cell_2ColumnXl",
      "Cell-3-column-xl": "Polaris-Grid-Cell--cell_3ColumnXl",
      "Cell-4-column-xl": "Polaris-Grid-Cell--cell_4ColumnXl",
      "Cell-5-column-xl": "Polaris-Grid-Cell--cell_5ColumnXl",
      "Cell-6-column-xl": "Polaris-Grid-Cell--cell_6ColumnXl",
      "Cell-7-column-xl": "Polaris-Grid-Cell--cell_7ColumnXl",
      "Cell-8-column-xl": "Polaris-Grid-Cell--cell_8ColumnXl",
      "Cell-9-column-xl": "Polaris-Grid-Cell--cell_9ColumnXl",
      "Cell-10-column-xl": "Polaris-Grid-Cell--cell_10ColumnXl",
      "Cell-11-column-xl": "Polaris-Grid-Cell--cell_11ColumnXl",
      "Cell-12-column-xl": "Polaris-Grid-Cell--cell_12ColumnXl"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Grid/components/Cell/Cell.js
var require_Cell2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Grid/components/Cell/Cell.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Cell_module = require_Cell_scss();
    function Cell({
      area: gridArea,
      column,
      columnSpan,
      row,
      children
    }) {
      let className = css.classNames(Cell_module.default.Cell, columnSpan?.xs && Cell_module.default[`Cell-${columnSpan.xs}-column-xs`], columnSpan?.sm && Cell_module.default[`Cell-${columnSpan.sm}-column-sm`], columnSpan?.md && Cell_module.default[`Cell-${columnSpan.md}-column-md`], columnSpan?.lg && Cell_module.default[`Cell-${columnSpan.lg}-column-lg`], columnSpan?.xl && Cell_module.default[`Cell-${columnSpan.xl}-column-xl`]), style = {
        gridArea,
        "--pc-column-xs": column?.xs,
        "--pc-column-sm": column?.sm,
        "--pc-column-md": column?.md,
        "--pc-column-lg": column?.lg,
        "--pc-column-xl": column?.xl,
        "--pc-row-xs": row?.xs,
        "--pc-row-sm": row?.sm,
        "--pc-row-md": row?.md,
        "--pc-row-lg": row?.lg,
        "--pc-row-xl": row?.xl
      };
      return /* @__PURE__ */ React12.createElement("div", {
        className,
        style
      }, children);
    }
    exports.Cell = Cell;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Grid/Grid.js
var require_Grid = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Grid/Grid.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), Grid_module = require_Grid_scss(), Cell = require_Cell2(), Grid2 = function({
      gap,
      areas,
      children,
      columns: columns3
    }) {
      let style = {
        "--pc-grid-gap-xs": gap?.xs,
        "--pc-grid-gap-sm": gap?.sm,
        "--pc-grid-gap-md": gap?.md,
        "--pc-grid-gap-lg": gap?.lg,
        "--pc-grid-gap-xl": gap?.xl,
        "--pc-grid-columns-xs": columns3?.xs,
        "--pc-grid-columns-sm": columns3?.sm,
        "--pc-grid-columns-md": columns3?.md,
        "--pc-grid-columns-lg": columns3?.lg,
        "--pc-grid-columns-xl": columns3?.xl,
        "--pc-grid-areas-xs": formatAreas(areas?.xs),
        "--pc-grid-areas-sm": formatAreas(areas?.sm),
        "--pc-grid-areas-md": formatAreas(areas?.md),
        "--pc-grid-areas-lg": formatAreas(areas?.lg),
        "--pc-grid-areas-xl": formatAreas(areas?.xl)
      };
      return /* @__PURE__ */ React12.createElement("div", {
        className: Grid_module.default.Grid,
        style
      }, children);
    };
    function formatAreas(areas) {
      if (areas)
        return `'${areas?.join("' '")}'`;
    }
    Grid2.Cell = Cell.Cell;
    exports.Grid = Grid2;
    exports.formatAreas = formatAreas;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/types.js
var require_types9 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/types.js"(exports) {
    "use strict";
    init_cjs_shims();
    exports.IndexFiltersMode = void 0;
    (function(IndexFiltersMode) {
      IndexFiltersMode.Default = "DEFAULT", IndexFiltersMode.Filtering = "FILTERING", IndexFiltersMode.EditingColumns = "EDITING_COLUMNS";
    })(exports.IndexFiltersMode || (exports.IndexFiltersMode = {}));
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/IndexFilters.scss.js
var require_IndexFilters_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/IndexFilters.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      IndexFiltersWrapper: "Polaris-IndexFilters__IndexFiltersWrapper",
      IndexFilters: "Polaris-IndexFilters",
      IndexFiltersSticky: "Polaris-IndexFilters__IndexFiltersSticky",
      IndexFiltersStickyFlush: "Polaris-IndexFilters__IndexFiltersStickyFlush",
      TabsWrapper: "Polaris-IndexFilters__TabsWrapper",
      SmallScreenTabsWrapper: "Polaris-IndexFilters__SmallScreenTabsWrapper",
      TabsWrapperLoading: "Polaris-IndexFilters__TabsWrapperLoading",
      TabsLoading: "Polaris-IndexFilters__TabsLoading",
      ActionWrap: "Polaris-IndexFilters__ActionWrap",
      Spinner: "Polaris-IndexFilters__Spinner",
      ButtonWrap: "Polaris-IndexFilters__ButtonWrap"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/hooks/useIsSticky/useIsSticky.js
var require_useIsSticky = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/hooks/useIsSticky/useIsSticky.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), debounce = require_debounce2(), DEBOUNCE_PERIOD = 250;
    function useIsSticky(mode, disabled, isFlushWhenSticky) {
      let hasIOSupport = typeof window < "u" && !!window.IntersectionObserver, options = {
        root: null,
        rootMargin: `${isFlushWhenSticky ? "0px" : "-56px"} 0px 0px 0px`,
        threshold: 0
      }, [indexFilteringHeight, setIndexFiltersHeight] = React12.useState(0), [isSticky, setIsSticky] = React12.useState(!1), measurerRef = React12.useRef(null), intersectionRef = React12.useRef(null), handleIntersect = (entries) => {
        entries.forEach((entry) => {
          setIsSticky(!entry.isIntersecting);
        });
      }, observerRef = React12.useRef(hasIOSupport ? new IntersectionObserver(handleIntersect, options) : null);
      return React12.useEffect(() => {
        function computeDimensions() {
          let node = measurerRef.current;
          if (!node)
            return {
              height: 0
            };
          let height = node.getBoundingClientRect().height;
          setIndexFiltersHeight(height);
        }
        computeDimensions();
        let debouncedComputeDimensions = debounce.debounce(computeDimensions, DEBOUNCE_PERIOD, {
          trailing: !0
        });
        return window.addEventListener("resize", debouncedComputeDimensions), () => window.removeEventListener("resize", debouncedComputeDimensions);
      }, [measurerRef, mode]), React12.useEffect(() => {
        let observer = observerRef.current;
        if (!observer)
          return;
        let node = intersectionRef.current;
        return node && observer.observe(node), () => {
          observer?.disconnect();
        };
      }, [intersectionRef]), {
        intersectionRef,
        measurerRef,
        isSticky: isSticky && !disabled,
        indexFilteringHeight
      };
    }
    exports.useIsSticky = useIsSticky;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-is-touch-device.js
var require_use_is_touch_device = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-is-touch-device.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), useEventListener = require_use_event_listener();
    function useIsTouchDevice() {
      let [isTouchDevice, setIsTouchDevice] = React12.useState(!1), handleTouchStart = React12.useCallback(() => setIsTouchDevice(!0), []);
      return useEventListener.useEventListener("touchstart", handleTouchStart), isTouchDevice;
    }
    exports.useIsTouchDevice = useIsTouchDevice;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/components/UpdateButtons/UpdateButtons.js
var require_UpdateButtons = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/components/UpdateButtons/UpdateButtons.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), focus = require_focus(), useIsTouchDevice = require_use_is_touch_device(), hooks2 = require_hooks2(), Button2 = require_Button(), InlineStack2 = require_InlineStack(), Modal = require_Modal(), Form = require_Form(), FormLayout = require_FormLayout(), TextField = require_TextField(), MAX_VIEW_NAME_LENGTH = 40;
    function UpdateButtons({
      primaryAction,
      cancelAction,
      viewNames,
      disabled
    }) {
      let i18n = hooks2.useI18n(), [savedViewName, setSavedViewName] = React12.useState(""), [savedViewModalOpen, setSavedViewModalOpen] = React12.useState(!1), container = React12.useRef(null), isTouchDevice = useIsTouchDevice.useIsTouchDevice();
      React12.useEffect(() => {
        !container.current || isTouchDevice || savedViewModalOpen && focus.focusFirstFocusableNode(container.current);
      }, [savedViewModalOpen, isTouchDevice]);
      async function handleClickSaveButton() {
        primaryAction?.type === "save-as" ? handleOpenModal() : await primaryAction?.onAction("");
      }
      function handleOpenModal() {
        setSavedViewModalOpen(!0);
      }
      function handleCloseModal() {
        setSavedViewModalOpen(!1);
      }
      function handleChange(value) {
        setSavedViewName(value);
      }
      async function handlePrimaryAction() {
        isPrimaryActionDisabled || (await primaryAction?.onAction(savedViewName), handleCloseModal());
      }
      let buttonText = React12.useMemo(() => {
        switch (primaryAction?.type) {
          case "save":
            return i18n.translate("Polaris.IndexFilters.UpdateButtons.save");
          case "save-as":
          default:
            return i18n.translate("Polaris.IndexFilters.UpdateButtons.saveAs");
        }
      }, [primaryAction?.type, i18n]), saveButton = /* @__PURE__ */ React12.createElement(Button2.Button, {
        size: "micro",
        onClick: handleClickSaveButton,
        disabled: primaryAction?.disabled || disabled
      }, buttonText), hasSameNameError = viewNames.some((name) => name.trim().toLowerCase() === savedViewName.trim().toLowerCase()), isPrimaryActionDisabled = hasSameNameError || !savedViewName || primaryAction?.loading || savedViewName.length > MAX_VIEW_NAME_LENGTH, cancelButtonMarkup = /* @__PURE__ */ React12.createElement(Button2.Button, {
        variant: "tertiary",
        size: "micro",
        onClick: cancelAction.onAction,
        disabled
      }, i18n.translate("Polaris.IndexFilters.UpdateButtons.cancel"));
      return primaryAction ? /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        align: "start",
        blockAlign: "center",
        gap: "100"
      }, cancelButtonMarkup, primaryAction.type === "save-as" ? /* @__PURE__ */ React12.createElement(Modal.Modal, {
        activator: /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, null, saveButton),
        open: savedViewModalOpen,
        title: i18n.translate("Polaris.IndexFilters.UpdateButtons.modal.title"),
        onClose: handleCloseModal,
        primaryAction: {
          onAction: handlePrimaryAction,
          content: i18n.translate("Polaris.IndexFilters.UpdateButtons.modal.save"),
          disabled: isPrimaryActionDisabled
        },
        secondaryActions: [{
          onAction: handleCloseModal,
          content: i18n.translate("Polaris.IndexFilters.UpdateButtons.modal.cancel")
        }]
      }, /* @__PURE__ */ React12.createElement(Modal.Modal.Section, null, /* @__PURE__ */ React12.createElement(Form.Form, {
        onSubmit: handlePrimaryAction
      }, /* @__PURE__ */ React12.createElement(FormLayout.FormLayout, null, /* @__PURE__ */ React12.createElement("div", {
        ref: container
      }, /* @__PURE__ */ React12.createElement(TextField.TextField, {
        label: i18n.translate("Polaris.IndexFilters.UpdateButtons.modal.label"),
        value: savedViewName,
        onChange: handleChange,
        autoComplete: "off",
        maxLength: MAX_VIEW_NAME_LENGTH,
        showCharacterCount: !0,
        error: hasSameNameError ? i18n.translate("Polaris.IndexFilters.UpdateButtons.modal.sameName", {
          name: savedViewName
        }) : void 0
      })))))) : saveButton) : cancelButtonMarkup;
    }
    exports.UpdateButtons = UpdateButtons;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/components/SortButton/components/DirectionButton/DirectionButton.scss.js
var require_DirectionButton_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/components/SortButton/components/DirectionButton/DirectionButton.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      DirectionButton: "Polaris-SortButton-DirectionButton",
      "DirectionButton-active": "Polaris-SortButton-DirectionButton__DirectionButton--active",
      Label: "Polaris-SortButton-DirectionButton__Label"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/components/SortButton/components/DirectionButton/DirectionButton.js
var require_DirectionButton = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/components/SortButton/components/DirectionButton/DirectionButton.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), DirectionButton_module = require_DirectionButton_scss(), UnstyledButton = require_UnstyledButton(), Icon = require_Icon();
    function DirectionButton({
      onClick,
      active,
      children,
      direction,
      value
    }) {
      let classes = css.classNames(DirectionButton_module.default.DirectionButton, active && DirectionButton_module.default["DirectionButton-active"]);
      function handleClick() {
        onClick([value]);
      }
      return /* @__PURE__ */ React12.createElement(UnstyledButton.UnstyledButton, {
        className: classes,
        onClick: handleClick
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: direction === "asc" ? polarisIcons.ArrowUpIcon : polarisIcons.ArrowDownIcon,
        tone: "base"
      }), /* @__PURE__ */ React12.createElement("span", {
        className: DirectionButton_module.default.Label
      }, children));
    }
    exports.DirectionButton = DirectionButton;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/components/SortButton/SortButton.js
var require_SortButton = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/components/SortButton/SortButton.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), ChoiceList = require_ChoiceList(), DirectionButton = require_DirectionButton(), hooks2 = require_hooks2(), Tooltip = require_Tooltip(), Button2 = require_Button(), Popover = require_Popover(), Box2 = require_Box();
    exports.SortButtonDirection = void 0;
    (function(SortButtonDirection) {
      SortButtonDirection.Asc = "asc", SortButtonDirection.Desc = "desc";
    })(exports.SortButtonDirection || (exports.SortButtonDirection = {}));
    function SortButton({
      choices,
      selected,
      onChange,
      disabled,
      onChangeKey,
      onChangeDirection
    }) {
      let i18n = hooks2.useI18n(), [active, setActive] = React12.useState(!1), [selectedValueKey, selectedDirection] = selected[0].split(" ");
      function handleClick() {
        setActive((pastActive) => !pastActive);
      }
      function handleClose() {
        setActive(!1);
      }
      function handleChangeChoiceList(sel) {
        if (onChangeKey) {
          let [key] = sel[0].split(" ");
          onChangeKey(key);
        } else
          onChange(sel);
      }
      function handleChangeDirection(sel) {
        if (onChangeDirection) {
          let [, direction] = sel[0].split(" ");
          onChangeDirection(direction);
        } else
          onChange(sel);
      }
      let choiceListChoices = React12.useMemo(() => choices.reduce((acc, curr) => {
        let alreadyExists = acc.some((option) => option.label === curr.label), [, currentValueDirection] = curr.value.split(" "), isSameDirection = currentValueDirection === selectedDirection;
        return alreadyExists ? isSameDirection ? acc.map((option) => option.label === curr.label ? curr : option) : acc : [...acc, curr];
      }, []), [choices, selectedDirection]), selectedChoices = choices.filter((choice) => {
        let [currentKey] = choice.value.split(" ");
        return currentKey === selectedValueKey;
      }), sortButton = /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, {
        content: i18n.translate("Polaris.IndexFilters.SortButton.tooltip"),
        preferredPosition: "above",
        hoverDelay: 400
      }, /* @__PURE__ */ React12.createElement(Button2.Button, {
        size: "slim",
        icon: polarisIcons.SortIcon,
        onClick: handleClick,
        disabled,
        accessibilityLabel: i18n.translate("Polaris.IndexFilters.SortButton.ariaLabel")
      }));
      return /* @__PURE__ */ React12.createElement(Popover.Popover, {
        active: active && !disabled,
        activator: sortButton,
        autofocusTarget: "first-node",
        onClose: handleClose,
        preferredAlignment: "right",
        fluidContent: !0
      }, /* @__PURE__ */ React12.createElement(Box2.Box, {
        minWidth: "148px",
        paddingInlineStart: "300",
        paddingInlineEnd: "300",
        paddingBlockStart: "200",
        paddingBlockEnd: "200",
        borderBlockEndWidth: "025",
        borderColor: "border-secondary"
      }, /* @__PURE__ */ React12.createElement(ChoiceList.ChoiceList, {
        title: i18n.translate("Polaris.IndexFilters.SortButton.title"),
        choices: choiceListChoices,
        selected,
        onChange: handleChangeChoiceList
      })), /* @__PURE__ */ React12.createElement(Box2.Box, {
        paddingInlineStart: "150",
        paddingInlineEnd: "150",
        paddingBlockStart: "200",
        paddingBlockEnd: "200"
      }, /* @__PURE__ */ React12.createElement(DirectionButton.DirectionButton, {
        direction: "asc",
        active: selectedDirection === exports.SortButtonDirection.Asc,
        onClick: handleChangeDirection,
        value: selectedChoices?.[0]?.value
      }, selectedChoices?.[0]?.directionLabel), /* @__PURE__ */ React12.createElement(DirectionButton.DirectionButton, {
        direction: "desc",
        active: selectedDirection === exports.SortButtonDirection.Desc,
        onClick: handleChangeDirection,
        value: selectedChoices?.[1]?.value
      }, selectedChoices?.[1]?.directionLabel)));
    }
    exports.SortButton = SortButton;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/components/Container/Container.scss.js
var require_Container_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/components/Container/Container.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Container: "Polaris-IndexFilters-Container"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/components/Container/Container.js
var require_Container = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/components/Container/Container.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), Container_module = require_Container_scss(), Container2 = ({
      children
    }) => /* @__PURE__ */ React12.createElement("div", {
      className: Container_module.default.Container
    }, children);
    exports.Container = Container2;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-previous.js
var require_use_previous = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/use-previous.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react();
    function usePrevious(value) {
      let ref = React12.useRef();
      return React12.useEffect(() => {
        ref.current = value;
      }, [value]), ref.current;
    }
    exports.usePrevious = usePrevious;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/utilities.js
var require_utilities7 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/utilities.js"(exports) {
    "use strict";
    init_cjs_shims();
    function getVisibleAndHiddenTabIndices(tabs, selected, disclosureWidth, tabWidths, containerWidth) {
      let sumTabWidths = tabWidths.reduce((sum, width) => sum + width, 0), arrayOfTabIndices = tabs.map((_2, index) => index), visibleTabs = [], hiddenTabs = [];
      if (containerWidth > sumTabWidths)
        visibleTabs.push(...arrayOfTabIndices);
      else {
        visibleTabs.push(selected);
        let tabListWidth = tabWidths[selected];
        arrayOfTabIndices.forEach((currentTabIndex) => {
          if (currentTabIndex !== selected) {
            let currentTabWidth = tabWidths[currentTabIndex];
            if (tabListWidth + currentTabWidth >= containerWidth - disclosureWidth) {
              hiddenTabs.push(currentTabIndex);
              return;
            }
            visibleTabs.push(currentTabIndex), tabListWidth += currentTabWidth;
          }
        });
      }
      return {
        visibleTabs,
        hiddenTabs
      };
    }
    exports.getVisibleAndHiddenTabIndices = getVisibleAndHiddenTabIndices;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/Tabs.scss.js
var require_Tabs_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/Tabs.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Outer: "Polaris-Tabs__Outer",
      Wrapper: "Polaris-Tabs__Wrapper",
      WrapperWithNewButton: "Polaris-Tabs__WrapperWithNewButton",
      ButtonWrapper: "Polaris-Tabs__ButtonWrapper",
      Tabs: "Polaris-Tabs",
      Tab: "Polaris-Tabs__Tab",
      "Tab-active": "Polaris-Tabs__Tab--active",
      "Tab-hasActions": "Polaris-Tabs__Tab--hasActions",
      "Tab-iconOnly": "Polaris-Tabs__Tab--iconOnly",
      fillSpace: "Polaris-Tabs--fillSpace",
      TabContainer: "Polaris-Tabs__TabContainer",
      fitted: "Polaris-Tabs--fitted",
      titleWithIcon: "Polaris-Tabs--titleWithIcon",
      List: "Polaris-Tabs__List",
      Item: "Polaris-Tabs__Item",
      DisclosureTab: "Polaris-Tabs__DisclosureTab",
      "DisclosureTab-visible": "Polaris-Tabs__DisclosureTab--visible",
      DisclosureActivator: "Polaris-Tabs__DisclosureActivator",
      TabsMeasurer: "Polaris-Tabs__TabsMeasurer",
      NewTab: "Polaris-Tabs__NewTab",
      ActionListWrap: "Polaris-Tabs__ActionListWrap",
      Panel: "Polaris-Tabs__Panel",
      "Panel-hidden": "Polaris-Tabs__Panel--hidden"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/components/Tab/components/DuplicateModal/DuplicateModal.js
var require_DuplicateModal = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/components/Tab/components/DuplicateModal/DuplicateModal.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), focus = require_focus(), hooks2 = require_hooks2(), Modal = require_Modal(), Form = require_Form(), FormLayout = require_FormLayout(), TextField = require_TextField(), MAX_VIEW_NAME_LENGTH = 40;
    function DuplicateModal({
      open: open2,
      isModalLoading,
      name,
      onClose,
      onClickPrimaryAction,
      onClickSecondaryAction,
      helpText,
      viewNames
    }) {
      let i18n = hooks2.useI18n(), [value, setValue] = React12.useState(name), container = React12.useRef(null), hasSameNameError = viewNames?.some((viewName) => viewName.trim().toLowerCase() === value.trim().toLowerCase()), isPrimaryActionDisabled = isModalLoading || hasSameNameError || !value || value.length > MAX_VIEW_NAME_LENGTH;
      React12.useEffect(() => {
        container.current && open2 && focus.focusFirstFocusableNode(container.current);
      }, [open2]), React12.useEffect(() => {
        open2 && setValue(name.slice(0, MAX_VIEW_NAME_LENGTH));
      }, [name, open2]);
      let handleChange = React12.useCallback((newValue) => {
        setValue(newValue);
      }, []);
      async function handlePrimaryAction() {
        isPrimaryActionDisabled || (await onClickPrimaryAction(value), setValue(""), onClose());
      }
      function handleSecondaryAction() {
        onClickSecondaryAction?.(), setValue(name), onClose();
      }
      return /* @__PURE__ */ React12.createElement(Modal.Modal, {
        open: open2,
        onClose,
        title: i18n.translate("Polaris.Tabs.DuplicateModal.title"),
        primaryAction: {
          content: i18n.translate("Polaris.Tabs.DuplicateModal.create"),
          onAction: handlePrimaryAction,
          disabled: isPrimaryActionDisabled
        },
        secondaryActions: [{
          content: i18n.translate("Polaris.Tabs.DuplicateModal.cancel"),
          onAction: handleSecondaryAction
        }],
        instant: !0
      }, /* @__PURE__ */ React12.createElement(Modal.Modal.Section, null, /* @__PURE__ */ React12.createElement(Form.Form, {
        onSubmit: handlePrimaryAction
      }, /* @__PURE__ */ React12.createElement(FormLayout.FormLayout, null, /* @__PURE__ */ React12.createElement("div", {
        ref: container
      }, /* @__PURE__ */ React12.createElement(TextField.TextField, {
        label: i18n.translate("Polaris.Tabs.DuplicateModal.label"),
        value,
        onChange: handleChange,
        autoComplete: "off",
        helpText,
        maxLength: MAX_VIEW_NAME_LENGTH,
        showCharacterCount: !0,
        error: hasSameNameError ? i18n.translate("Polaris.Tabs.DuplicateModal.errors.sameName", {
          name: value
        }) : void 0
      }))))));
    }
    exports.DuplicateModal = DuplicateModal;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/components/Tab/components/RenameModal/RenameModal.js
var require_RenameModal = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/components/Tab/components/RenameModal/RenameModal.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), focus = require_focus(), Form = require_Form(), FormLayout = require_FormLayout(), hooks2 = require_hooks2(), Modal = require_Modal(), TextField = require_TextField();
    function RenameModal({
      open: open2,
      isModalLoading,
      name,
      onClose,
      onClickPrimaryAction,
      onClickSecondaryAction,
      helpText,
      viewNames
    }) {
      let i18n = hooks2.useI18n(), [value, setValue] = React12.useState(name), container = React12.useRef(null), hasSameNameError = viewNames?.filter((viewName) => viewName !== name).some((viewName) => viewName.trim().toLowerCase() === value.trim().toLowerCase()), isPrimaryActionDisabled = isModalLoading || hasSameNameError || value === name || !value;
      React12.useEffect(() => {
        container.current && open2 && focus.focusFirstFocusableNode(container.current);
      }, [open2]), React12.useEffect(() => {
        open2 && setValue(name);
      }, [name, open2]);
      let handleChange = React12.useCallback((newValue) => {
        setValue(newValue);
      }, []);
      async function handlePrimaryAction() {
        isPrimaryActionDisabled || (await onClickPrimaryAction(value), setValue(""), onClose());
      }
      function handleSecondaryAction() {
        onClickSecondaryAction?.(), setValue(name), onClose();
      }
      return /* @__PURE__ */ React12.createElement(Modal.Modal, {
        open: open2,
        onClose,
        title: i18n.translate("Polaris.Tabs.RenameModal.title"),
        primaryAction: {
          content: i18n.translate("Polaris.Tabs.RenameModal.create"),
          onAction: handlePrimaryAction,
          disabled: isPrimaryActionDisabled
        },
        secondaryActions: [{
          content: i18n.translate("Polaris.Tabs.RenameModal.cancel"),
          onAction: handleSecondaryAction
        }],
        instant: !0
      }, /* @__PURE__ */ React12.createElement(Modal.Modal.Section, null, /* @__PURE__ */ React12.createElement(Form.Form, {
        onSubmit: handlePrimaryAction
      }, /* @__PURE__ */ React12.createElement(FormLayout.FormLayout, null, /* @__PURE__ */ React12.createElement("div", {
        ref: container
      }, /* @__PURE__ */ React12.createElement(TextField.TextField, {
        label: i18n.translate("Polaris.Tabs.RenameModal.label"),
        value,
        onChange: handleChange,
        autoComplete: "off",
        helpText,
        maxLength: 40,
        showCharacterCount: !0,
        error: hasSameNameError ? i18n.translate("Polaris.Tabs.RenameModal.errors.sameName", {
          name: value
        }) : void 0
      }))))));
    }
    exports.RenameModal = RenameModal;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/components/Tab/Tab.js
var require_Tab = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/components/Tab/Tab.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), focus = require_focus(), breakpoints = require_breakpoints2(), Tabs_module = require_Tabs_scss(), DuplicateModal = require_DuplicateModal(), RenameModal = require_RenameModal(), hooks2 = require_hooks2(), Icon = require_Icon(), Modal = require_Modal(), Popover = require_Popover(), ActionList = require_ActionList(), InlineStack2 = require_InlineStack(), Text4 = require_Text(), UnstyledLink = require_UnstyledLink(), UnstyledButton = require_UnstyledButton(), Badge2 = require_Badge(), Tab = /* @__PURE__ */ React12.forwardRef(({
      content,
      accessibilityLabel,
      badge,
      id,
      panelID,
      url,
      onAction,
      actions,
      disabled,
      isModalLoading,
      icon,
      siblingTabHasFocus,
      measuring,
      focused,
      selected,
      onToggleModal,
      onTogglePopover,
      viewNames,
      tabIndexOverride,
      onFocus
    }, ref) => {
      let i18n = hooks2.useI18n(), [popoverActive, setPopoverActive] = React12.useState(!1), [activeModalType, setActiveModalType] = React12.useState(null), {
        mdDown
      } = breakpoints.useBreakpoints(), wasSelected = React12.useRef(selected), panelFocused = React12.useRef(!1), node = React12.useRef(null);
      React12.useEffect(() => {
        onTogglePopover(popoverActive);
      }, [popoverActive, onTogglePopover]), React12.useEffect(() => {
        onToggleModal(!!activeModalType);
      }, [activeModalType, onToggleModal]), React12.useEffect(() => () => {
        onToggleModal(!1), onTogglePopover(!1);
      }, [onToggleModal, onTogglePopover]), React12.useEffect(() => {
        if (measuring)
          return;
        (focused || document.activeElement && document.activeElement.id === id) && selected && panelID != null && !panelFocused.current && (focusPanelID(panelID), panelFocused.current = !0), selected && !wasSelected.current && panelID != null ? focusPanelID(panelID) : focused && node.current != null && activeModalType == null && !disabled && focus.focusFirstFocusableNode(node.current), wasSelected.current = selected;
      }, [focused, id, content, measuring, panelID, selected, activeModalType, disabled]);
      let tabIndex;
      selected && !siblingTabHasFocus && !measuring || focused && !measuring ? tabIndex = 0 : tabIndex = -1, tabIndexOverride != null && (tabIndex = tabIndexOverride);
      let renameAction = actions?.find((action) => action.type === "rename"), duplicateAction = actions?.find((action) => action.type === "duplicate"), deleteAction = actions?.find((action) => action.type === "delete"), togglePopoverActive = React12.useCallback(() => {
        actions?.length && setPopoverActive((popoverActive2) => !popoverActive2);
      }, [actions]), handleClick = React12.useCallback(() => {
        disabled || (selected ? togglePopoverActive() : onAction?.());
      }, [selected, onAction, togglePopoverActive, disabled]), handleModalOpen = (type) => {
        setActiveModalType(type);
      }, handleModalClose = () => {
        setActiveModalType(null);
      }, handleSaveRenameModal = React12.useCallback(async (value) => {
        await renameAction?.onPrimaryAction?.(value), setTimeout(() => {
          node.current && focus.focusFirstFocusableNode(node.current);
        }, 250);
      }, [renameAction]), handleConfirmDeleteView = React12.useCallback(async () => {
        await deleteAction?.onPrimaryAction?.(content), handleModalClose();
      }, [deleteAction, content]), handleSaveDuplicateModal = React12.useCallback(async (duplicateName) => {
        await duplicateAction?.onPrimaryAction?.(duplicateName);
      }, [duplicateAction]), actionContent = {
        rename: {
          icon: polarisIcons.InfoIcon,
          content: i18n.translate("Polaris.Tabs.Tab.rename")
        },
        duplicate: {
          icon: polarisIcons.DuplicateIcon,
          content: i18n.translate("Polaris.Tabs.Tab.duplicate")
        },
        edit: {
          icon: polarisIcons.EditIcon,
          content: i18n.translate("Polaris.Tabs.Tab.edit")
        },
        "edit-columns": {
          icon: polarisIcons.LayoutColumns3Icon,
          content: i18n.translate("Polaris.Tabs.Tab.editColumns")
        },
        delete: {
          icon: polarisIcons.DeleteIcon,
          content: i18n.translate("Polaris.Tabs.Tab.delete"),
          destructive: !0
        }
      }, formattedActions = actions?.map(({
        type,
        onAction: onAction2,
        onPrimaryAction,
        ...additionalOptions
      }) => {
        let isModalActivator = !type.includes("edit");
        return {
          ...actionContent[type],
          ...additionalOptions,
          onAction: () => {
            onAction2?.(content), togglePopoverActive(), isModalActivator && handleModalOpen(type);
          }
        };
      }), handleKeyDown = React12.useCallback((event) => {
        event.key === " " && (event.preventDefault(), handleClick());
      }, [handleClick]), tabContainerClassNames = css.classNames(Tabs_module.default.TabContainer, selected && Tabs_module.default.Underline), urlIfNotDisabledOrSelected = disabled || selected ? void 0 : url, BaseComponent = urlIfNotDisabledOrSelected ? UnstyledLink.UnstyledLink : UnstyledButton.UnstyledButton, tabClassName = css.classNames(Tabs_module.default.Tab, icon && Tabs_module.default["Tab-iconOnly"], popoverActive && Tabs_module.default["Tab-popoverActive"], selected && Tabs_module.default["Tab-active"], selected && actions?.length && Tabs_module.default["Tab-hasActions"]), badgeMarkup = badge ? /* @__PURE__ */ React12.createElement(Badge2.Badge, {
        tone: selected ? void 0 : "new"
      }, badge) : null, disclosureMarkup = selected && actions?.length ? /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(Tabs_module.default.IconWrap)
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.ChevronDownIcon
      })) : null, activator = /* @__PURE__ */ React12.createElement(BaseComponent, {
        id,
        className: tabClassName,
        tabIndex,
        "aria-selected": selected,
        "aria-controls": panelID,
        "aria-label": accessibilityLabel,
        role: tabIndexOverride == null ? "tab" : void 0,
        disabled,
        url: urlIfNotDisabledOrSelected,
        onFocus,
        onMouseUp: focus.handleMouseUpByBlurring,
        onClick: handleClick,
        onKeyDown: handleKeyDown
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "200",
        align: "center",
        blockAlign: "center",
        wrap: !1
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        variant: mdDown ? "bodyLg" : "bodySm",
        fontWeight: "medium"
      }, icon ?? content), badgeMarkup), disclosureMarkup), isPlainButton = !selected || !actions?.length, renameModal = renameAction ? /* @__PURE__ */ React12.createElement(RenameModal.RenameModal, {
        name: content,
        open: activeModalType === "rename",
        onClose: handleModalClose,
        onClickPrimaryAction: handleSaveRenameModal,
        isModalLoading,
        viewNames
      }) : null, duplicateModal = duplicateAction ? /* @__PURE__ */ React12.createElement(DuplicateModal.DuplicateModal, {
        open: activeModalType === "duplicate",
        name: i18n.translate("Polaris.Tabs.Tab.copy", {
          name: content
        }),
        onClose: handleModalClose,
        onClickPrimaryAction: handleSaveDuplicateModal,
        isModalLoading,
        viewNames: viewNames || []
      }) : null, deleteModal = deleteAction ? /* @__PURE__ */ React12.createElement(Modal.Modal, {
        open: activeModalType === "delete",
        onClose: handleModalClose,
        primaryAction: {
          content: i18n.translate("Polaris.Tabs.Tab.deleteModal.delete"),
          onAction: handleConfirmDeleteView,
          destructive: !0,
          disabled: isModalLoading
        },
        secondaryActions: [{
          content: i18n.translate("Polaris.Tabs.Tab.deleteModal.cancel"),
          onAction: handleModalClose
        }],
        title: i18n.translate("Polaris.Tabs.Tab.deleteModal.title"),
        instant: !0
      }, /* @__PURE__ */ React12.createElement(Modal.Modal.Section, null, i18n.translate("Polaris.Tabs.Tab.deleteModal.description", {
        viewName: content
      }))) : null, markup = isPlainButton || disabled ? activator : /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement(Popover.Popover, {
        active: popoverActive,
        activator,
        autofocusTarget: "first-node",
        onClose: togglePopoverActive
      }, /* @__PURE__ */ React12.createElement("div", {
        className: Tabs_module.default.ActionListWrap
      }, /* @__PURE__ */ React12.createElement(ActionList.ActionList, {
        actionRole: "menuitem",
        items: formattedActions
      }))), renameModal, duplicateModal, deleteModal);
      return icon ? markup : /* @__PURE__ */ React12.createElement("li", {
        className: tabContainerClassNames,
        ref: mergeRefs([node, ref]),
        role: "presentation"
      }, markup);
    });
    Tab.displayName = "Tab";
    function focusPanelID(panelID) {
      let panel = document.getElementById(panelID);
      panel && panel.focus({
        preventScroll: !0
      });
    }
    function mergeRefs(refs) {
      return (node) => {
        for (let ref of refs)
          ref != null && (ref.current = node);
      };
    }
    exports.Tab = Tab;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/components/TabMeasurer/TabMeasurer.js
var require_TabMeasurer = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/components/TabMeasurer/TabMeasurer.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), useComponentDidMount = require_use_component_did_mount(), useEventListener = require_use_event_listener(), Tabs_module = require_Tabs_scss(), Tab = require_Tab(), TabMeasurer = /* @__PURE__ */ React12.memo(function({
      selected,
      tabs,
      activator,
      tabToFocus,
      siblingTabHasFocus,
      handleMeasurement: handleMeasurementProp
    }) {
      let containerNode = React12.useRef(null), animationFrame = React12.useRef(null), handleMeasurement = React12.useCallback(() => {
        animationFrame.current && cancelAnimationFrame(animationFrame.current), animationFrame.current = requestAnimationFrame(() => {
          if (!containerNode.current)
            return;
          let containerWidth = containerNode.current.offsetWidth - 20 - 28, hiddenTabNodes = containerNode.current.children, hiddenTabWidths = Array.from(hiddenTabNodes).map((node) => Math.ceil(node.getBoundingClientRect().width) + 4), disclosureWidth = hiddenTabWidths.pop() || 0;
          handleMeasurementProp({
            containerWidth,
            disclosureWidth,
            hiddenTabWidths
          });
        });
      }, [handleMeasurementProp]);
      React12.useEffect(() => {
        handleMeasurement();
      }, [handleMeasurement, tabs]), useComponentDidMount.useComponentDidMount(() => {
        process.env.NODE_ENV === "development" && setTimeout(handleMeasurement, 0);
      });
      let tabsMarkup = tabs.map((tab, index) => /* @__PURE__ */ React12.createElement(Tab.Tab, {
        measuring: !0,
        key: `$${tab.id}Hidden`,
        id: `${tab.id}Measurer`,
        siblingTabHasFocus,
        focused: index === tabToFocus,
        selected: index === selected,
        url: tab.url,
        content: tab.content,
        onTogglePopover: noop,
        onToggleModal: noop
      })), classname = css.classNames(Tabs_module.default.Tabs, Tabs_module.default.TabsMeasurer);
      return useEventListener.useEventListener("resize", handleMeasurement), /* @__PURE__ */ React12.createElement("div", {
        className: classname,
        ref: containerNode
      }, tabsMarkup, activator);
    });
    function noop() {
    }
    exports.TabMeasurer = TabMeasurer;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/components/Panel/Panel.js
var require_Panel = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/components/Panel/Panel.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Tabs_module = require_Tabs_scss();
    function Panel({
      hidden,
      id,
      tabID,
      children
    }) {
      let className = css.classNames(Tabs_module.default.Panel, hidden && Tabs_module.default["Panel-hidden"]);
      return /* @__PURE__ */ React12.createElement("div", {
        className,
        id,
        role: "tabpanel",
        "aria-labelledby": tabID,
        tabIndex: -1
      }, children);
    }
    exports.Panel = Panel;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/components/Item/Item.js
var require_Item6 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/components/Item/Item.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Tabs_module = require_Tabs_scss(), UnstyledLink = require_UnstyledLink(), Item = /* @__PURE__ */ React12.memo(function({
      id,
      focused,
      children,
      url,
      accessibilityLabel,
      onClick = noop
    }) {
      let focusedNode = React12.useRef(null);
      React12.useEffect(() => {
        focusedNode.current && focusedNode.current instanceof HTMLElement && focused && focusedNode.current.focus();
      }, [focusedNode, focused]);
      let classname = css.classNames(Tabs_module.default.Item), sharedProps = {
        id,
        ref: focusedNode,
        onClick,
        className: classname,
        "aria-selected": !1,
        "aria-label": accessibilityLabel
      }, markup = url ? /* @__PURE__ */ React12.createElement(UnstyledLink.UnstyledLink, Object.assign({}, sharedProps, {
        url
      }), children) : /* @__PURE__ */ React12.createElement("button", Object.assign({}, sharedProps, {
        ref: focusedNode,
        type: "button"
      }), children);
      return /* @__PURE__ */ React12.createElement("li", null, markup);
    });
    function noop() {
    }
    exports.Item = Item;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/components/List/List.js
var require_List = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/components/List/List.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), Tabs_module = require_Tabs_scss(), Item = require_Item6();
    function List3({
      focusIndex,
      disclosureTabs,
      onClick = noop,
      onKeyPress = noop
    }) {
      let tabs = disclosureTabs.map(({
        id,
        content,
        ...tabProps
      }, index) => /* @__PURE__ */ React12.createElement(Item.Item, Object.assign({
        key: id
      }, tabProps, {
        id,
        focused: index === focusIndex,
        onClick: onClick.bind(null, id)
      }), content));
      return /* @__PURE__ */ React12.createElement("ul", {
        className: Tabs_module.default.List,
        onKeyDown: handleKeyDown,
        onKeyUp: onKeyPress
      }, tabs);
    }
    function noop() {
    }
    function handleKeyDown(event) {
      let {
        key
      } = event;
      (key === "ArrowLeft" || key === "ArrowRight") && (event.preventDefault(), event.stopPropagation());
    }
    exports.List = List3;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/components/CreateViewModal/CreateViewModal.js
var require_CreateViewModal = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/components/CreateViewModal/CreateViewModal.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), useIsTouchDevice = require_use_is_touch_device(), focus = require_focus(), hooks2 = require_hooks2(), Modal = require_Modal(), Form = require_Form(), FormLayout = require_FormLayout(), TextField = require_TextField(), MAX_VIEW_NAME_LENGTH = 40;
    function CreateViewModal({
      activator,
      open: open2,
      onClose,
      onClickPrimaryAction,
      onClickSecondaryAction,
      viewNames
    }) {
      let i18n = hooks2.useI18n(), [value, setValue] = React12.useState(""), [loading, setLoading] = React12.useState(!1), container = React12.useRef(null), isTouchDevice = useIsTouchDevice.useIsTouchDevice(), hasSameNameError = viewNames.some((viewName) => viewName.trim().toLowerCase() === value.trim().toLowerCase()), isPrimaryActionDisabled = !value || hasSameNameError || loading || value.length > MAX_VIEW_NAME_LENGTH;
      React12.useEffect(() => {
        if (!(!container.current || isTouchDevice) && open2) {
          focus.focusFirstFocusableNode(container.current);
          let timeout = setTimeout(() => {
            container.current && focus.focusFirstFocusableNode(container.current);
          }, 50);
          return () => clearTimeout(timeout);
        }
      }, [open2, isTouchDevice]);
      let handleChange = React12.useCallback((newValue) => {
        setValue(newValue);
      }, []);
      async function handlePrimaryAction() {
        hasSameNameError || isPrimaryActionDisabled || (setLoading(!0), await onClickPrimaryAction(value), setLoading(!1), setValue(""), onClose());
      }
      function handleSecondaryAction() {
        onClickSecondaryAction?.(), setValue(""), onClose();
      }
      return /* @__PURE__ */ React12.createElement(Modal.Modal, {
        activator,
        open: open2,
        onClose,
        title: i18n.translate("Polaris.Tabs.CreateViewModal.title"),
        primaryAction: {
          content: i18n.translate("Polaris.Tabs.CreateViewModal.create"),
          onAction: handlePrimaryAction,
          disabled: isPrimaryActionDisabled
        },
        secondaryActions: [{
          content: i18n.translate("Polaris.Tabs.CreateViewModal.cancel"),
          onAction: handleSecondaryAction
        }]
      }, /* @__PURE__ */ React12.createElement(Modal.Modal.Section, null, /* @__PURE__ */ React12.createElement(Form.Form, {
        onSubmit: handlePrimaryAction
      }, /* @__PURE__ */ React12.createElement(FormLayout.FormLayout, null, /* @__PURE__ */ React12.createElement("div", {
        ref: container
      }, /* @__PURE__ */ React12.createElement(TextField.TextField, {
        label: i18n.translate("Polaris.Tabs.CreateViewModal.label"),
        value,
        onChange: handleChange,
        autoComplete: "off",
        maxLength: MAX_VIEW_NAME_LENGTH,
        showCharacterCount: !0,
        error: hasSameNameError ? i18n.translate("Polaris.Tabs.CreateViewModal.errors.sameName", {
          name: value
        }) : void 0
      }))))));
    }
    exports.CreateViewModal = CreateViewModal;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/Tabs.js
var require_Tabs = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tabs/Tabs.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), breakpoints = require_breakpoints2(), usePrevious = require_use_previous(), utilities = require_utilities7(), Tabs_module = require_Tabs_scss(), Tab = require_Tab(), TabMeasurer = require_TabMeasurer(), Panel = require_Panel(), List3 = require_List(), CreateViewModal = require_CreateViewModal(), hooks2 = require_hooks2(), Text4 = require_Text(), Icon = require_Icon(), UnstyledButton = require_UnstyledButton(), Box2 = require_Box(), Popover = require_Popover(), Tooltip = require_Tooltip(), CREATE_NEW_VIEW_ID = "create-new-view", Tabs = ({
      tabs,
      children,
      selected,
      newViewAccessibilityLabel,
      canCreateNewView,
      disabled,
      onCreateNewView,
      onSelect,
      fitted,
      disclosureText
    }) => {
      let i18n = hooks2.useI18n(), {
        mdDown
      } = breakpoints.useBreakpoints(), scrollRef = React12.useRef(null), wrapRef = React12.useRef(null), selectedTabRef = React12.useRef(null), [state, setState] = React12.useReducer((data, partialData) => ({
        ...data,
        ...partialData
      }), {
        disclosureWidth: 0,
        containerWidth: 1 / 0,
        tabWidths: [],
        visibleTabs: [],
        hiddenTabs: [],
        showDisclosure: !1,
        tabToFocus: -1,
        isNewViewModalActive: !1,
        modalSubmitted: !1,
        isTabsFocused: !1,
        isTabPopoverOpen: !1,
        isTabModalOpen: !1
      }), {
        tabToFocus,
        visibleTabs,
        hiddenTabs,
        showDisclosure,
        isNewViewModalActive,
        modalSubmitted,
        disclosureWidth,
        tabWidths,
        containerWidth,
        isTabsFocused,
        isTabModalOpen,
        isTabPopoverOpen
      } = state, prevModalOpen = usePrevious.usePrevious(isTabModalOpen), prevPopoverOpen = usePrevious.usePrevious(isTabPopoverOpen);
      React12.useEffect(() => {
        prevModalOpen && !isTabModalOpen ? setState({
          isTabsFocused: !0,
          tabToFocus: selected
        }) : prevPopoverOpen && !isTabPopoverOpen && !isTabModalOpen && setState({
          isTabsFocused: !0,
          tabToFocus: selected
        });
      }, [prevPopoverOpen, isTabPopoverOpen, prevModalOpen, isTabModalOpen, selected, tabToFocus]);
      let handleTogglePopover = React12.useCallback((isOpen) => setState({
        isTabPopoverOpen: isOpen
      }), []), handleToggleModal = React12.useCallback((isOpen) => setState({
        isTabModalOpen: isOpen
      }), []), handleCloseNewViewModal = () => {
        setState({
          isNewViewModalActive: !1
        });
      }, handleSaveNewViewModal = async (value) => {
        if (!onCreateNewView)
          return !1;
        let hasExecuted = await onCreateNewView?.(value);
        return hasExecuted && setState({
          modalSubmitted: !0
        }), hasExecuted;
      }, handleClickNewTab = () => {
        setState({
          isNewViewModalActive: !0
        });
      }, handleTabClick = React12.useCallback((id) => {
        let tab = tabs.find((aTab) => aTab.id === id);
        if (tab == null)
          return null;
        let selectedIndex = tabs.indexOf(tab);
        onSelect?.(selectedIndex);
      }, [tabs, onSelect]), renderTabMarkup = React12.useCallback((tab, index) => {
        let handleClick = () => {
          handleTabClick(tab.id), tab.onAction?.();
        }, viewNames2 = tabs.map(({
          content
        }) => content), tabPanelID = tab.panelID || `${tab.id}-panel`;
        return /* @__PURE__ */ React12.createElement(Tab.Tab, Object.assign({}, tab, {
          key: `${index}-${tab.id}`,
          id: tab.id,
          panelID: children ? tabPanelID : void 0,
          disabled: disabled || tab.disabled,
          siblingTabHasFocus: tabToFocus > -1,
          focused: index === tabToFocus,
          selected: index === selected,
          onAction: handleClick,
          accessibilityLabel: tab.accessibilityLabel,
          url: tab.url,
          content: tab.content,
          onToggleModal: handleToggleModal,
          onTogglePopover: handleTogglePopover,
          viewNames: viewNames2,
          ref: index === selected ? selectedTabRef : null
        }));
      }, [disabled, handleTabClick, tabs, children, selected, tabToFocus, handleToggleModal, handleTogglePopover]), handleFocus = React12.useCallback((event) => {
        let target = event.target, isItem = target.classList.contains(Tabs_module.default.Item), isInNaturalDOMOrder = target.closest("[data-tabs-focus-catchment]") || isItem;
        target.classList.contains(Tabs_module.default.DisclosureActivator) || !isInNaturalDOMOrder || setState({
          isTabsFocused: !0
        });
      }, []), handleBlur = React12.useCallback((event) => {
        let target = event.target, relatedTarget = event.relatedTarget, isInNaturalDOMOrder = relatedTarget?.closest?.(`.${Tabs_module.default.Tabs}`), targetIsATab = target?.classList?.contains?.(Tabs_module.default.Tab), focusReceiverIsAnItem = relatedTarget?.classList.contains(Tabs_module.default.Item);
        if (!relatedTarget && !isTabModalOpen && !targetIsATab && !focusReceiverIsAnItem) {
          setState({
            tabToFocus: -1
          });
          return;
        }
        if (!isInNaturalDOMOrder && !isTabModalOpen && !targetIsATab && !focusReceiverIsAnItem) {
          setState({
            tabToFocus: -1
          });
          return;
        }
        setState({
          isTabsFocused: !1
        });
      }, [isTabModalOpen]), handleKeyDown = (event) => {
        if (isTabPopoverOpen || isTabModalOpen || isNewViewModalActive)
          return;
        let {
          key
        } = event;
        (key === "ArrowLeft" || key === "ArrowRight") && (event.preventDefault(), event.stopPropagation());
      };
      React12.useEffect(() => {
        let {
          visibleTabs: visibleTabs2,
          hiddenTabs: hiddenTabs2
        } = utilities.getVisibleAndHiddenTabIndices(tabs, selected, disclosureWidth, tabWidths, containerWidth);
        setState({
          visibleTabs: visibleTabs2,
          hiddenTabs: hiddenTabs2
        });
      }, [containerWidth, disclosureWidth, tabs, selected, tabWidths, setState]);
      let moveToSelectedTab = React12.useCallback(() => {
        let activeButton = selectedTabRef.current?.querySelector(`.${Tabs_module.default["Tab-active"]}`);
        activeButton && moveToActiveTab(activeButton.offsetLeft);
      }, []);
      React12.useEffect(() => {
        mdDown && moveToSelectedTab();
      }, [moveToSelectedTab, selected, mdDown]), React12.useEffect(() => {
        isTabsFocused && !showDisclosure && setState({
          tabToFocus: selected
        });
      }, [isTabsFocused, selected, setState, showDisclosure]);
      let handleKeyPress = (event) => {
        let {
          showDisclosure: showDisclosure2,
          visibleTabs: visibleTabs2,
          hiddenTabs: hiddenTabs2,
          tabToFocus: tabToFocus2,
          isNewViewModalActive: isNewViewModalActive2
        } = state;
        if (isTabModalOpen || isTabPopoverOpen || isNewViewModalActive2)
          return;
        let key = event.key, tabsArrayInOrder = showDisclosure2 || mdDown ? visibleTabs2.concat(hiddenTabs2) : [...visibleTabs2], newFocus = tabsArrayInOrder.indexOf(tabToFocus2);
        key === "ArrowRight" && (newFocus += 1, newFocus === tabsArrayInOrder.length && (newFocus = 0)), key === "ArrowLeft" && (newFocus === -1 || newFocus === 0 ? newFocus = tabsArrayInOrder.length - 1 : newFocus -= 1);
        let buttonToFocus = tabsArrayInOrder[newFocus];
        buttonToFocus != null && setState({
          tabToFocus: buttonToFocus
        });
      }, handleDisclosureActivatorClick = () => {
        setState({
          showDisclosure: !showDisclosure,
          tabToFocus: hiddenTabs[0]
        });
      }, handleClose = () => {
        setState({
          showDisclosure: !1
        });
      }, handleMeasurement = React12.useCallback((measurements) => {
        let {
          hiddenTabWidths: tabWidths2,
          containerWidth: containerWidth2,
          disclosureWidth: disclosureWidth2
        } = measurements, {
          visibleTabs: visibleTabs2,
          hiddenTabs: hiddenTabs2
        } = utilities.getVisibleAndHiddenTabIndices(tabs, selected, disclosureWidth2, tabWidths2, containerWidth2);
        setState({
          visibleTabs: visibleTabs2,
          hiddenTabs: hiddenTabs2,
          disclosureWidth: disclosureWidth2,
          containerWidth: containerWidth2,
          tabWidths: tabWidths2
        });
      }, [tabs, selected, setState]), handleListTabClick = (id) => {
        handleTabClick(id), handleClose(), setState({
          isTabsFocused: !0
        });
      }, moveToActiveTab = (offsetLeft) => {
        setTimeout(() => {
          if (scrollRef.current && typeof scrollRef.current.scroll == "function") {
            let scrollRefOffset = wrapRef?.current?.offsetLeft || 0;
            scrollRef?.current?.scroll({
              left: offsetLeft - scrollRefOffset
            });
          }
        }, 0);
      }, createViewA11yLabel = newViewAccessibilityLabel || i18n.translate("Polaris.Tabs.newViewAccessibilityLabel"), tabsToShow = mdDown ? [...visibleTabs, ...hiddenTabs] : visibleTabs, tabsMarkup = tabsToShow.sort((tabA, tabB) => tabA - tabB).filter((tabIndex) => tabs[tabIndex]).map((tabIndex) => renderTabMarkup(tabs[tabIndex], tabIndex)), disclosureActivatorVisible = visibleTabs.length < tabs.length && !mdDown, classname = css.classNames(Tabs_module.default.Tabs, fitted && Tabs_module.default.fitted, disclosureActivatorVisible && Tabs_module.default.fillSpace), wrapperClassNames = css.classNames(Tabs_module.default.Wrapper, canCreateNewView && Tabs_module.default.WrapperWithNewButton), disclosureTabClassName = css.classNames(Tabs_module.default.DisclosureTab, disclosureActivatorVisible && Tabs_module.default["DisclosureTab-visible"]), disclosureButtonClassName = css.classNames(Tabs_module.default.DisclosureActivator), disclosureButtonContent = /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        variant: "bodySm",
        fontWeight: "medium"
      }, disclosureText ?? i18n.translate("Polaris.Tabs.toggleTabsLabel")), /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(Tabs_module.default.IconWrap, disclosureActivatorVisible && showDisclosure && Tabs_module.default["IconWrap-open"])
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.ChevronDownIcon,
        tone: "subdued"
      }))), activator = /* @__PURE__ */ React12.createElement(UnstyledButton.UnstyledButton, {
        type: "button",
        className: disclosureButtonClassName,
        onClick: handleDisclosureActivatorClick,
        "aria-label": disclosureText ?? i18n.translate("Polaris.Tabs.toggleTabsLabel"),
        disabled
      }, disclosureButtonContent), disclosureTabs = hiddenTabs.map((tabIndex) => tabs[tabIndex]), viewNames = tabs.map(({
        content
      }) => content), tabMeasurer = /* @__PURE__ */ React12.createElement(TabMeasurer.TabMeasurer, {
        tabToFocus,
        activator,
        selected,
        tabs,
        siblingTabHasFocus: tabToFocus > -1,
        handleMeasurement
      }), newTab = /* @__PURE__ */ React12.createElement(Tab.Tab, {
        id: CREATE_NEW_VIEW_ID,
        content: createViewA11yLabel,
        actions: [],
        onAction: handleClickNewTab,
        onFocus: () => {
          modalSubmitted && setState({
            tabToFocus: selected,
            modalSubmitted: !1
          });
        },
        icon: /* @__PURE__ */ React12.createElement(Icon.Icon, {
          source: polarisIcons.PlusIcon,
          accessibilityLabel: createViewA11yLabel
        }),
        disabled,
        onTogglePopover: handleTogglePopover,
        onToggleModal: handleToggleModal,
        tabIndexOverride: 0
      }), panelMarkup = children ? tabs.map((_tab, index) => selected === index ? /* @__PURE__ */ React12.createElement(Panel.Panel, {
        id: tabs[index].panelID || `${tabs[index].id}-panel`,
        tabID: tabs[index].id,
        key: tabs[index].id
      }, children) : /* @__PURE__ */ React12.createElement(Panel.Panel, {
        id: tabs[index].panelID || `${tabs[index].id}-panel`,
        tabID: tabs[index].id,
        key: tabs[index].id,
        hidden: !0
      })) : null;
      return /* @__PURE__ */ React12.createElement("div", {
        className: Tabs_module.default.Outer
      }, /* @__PURE__ */ React12.createElement(Box2.Box, {
        padding: {
          md: "200"
        }
      }, tabMeasurer, /* @__PURE__ */ React12.createElement("div", {
        className: wrapperClassNames,
        ref: scrollRef
      }, /* @__PURE__ */ React12.createElement("div", {
        className: Tabs_module.default.ButtonWrapper,
        ref: wrapRef
      }, /* @__PURE__ */ React12.createElement("ul", {
        role: tabsMarkup.length > 0 ? "tablist" : void 0,
        className: classname,
        onFocus: handleFocus,
        onBlur: handleBlur,
        onKeyDown: handleKeyDown,
        onKeyUp: handleKeyPress,
        "data-tabs-focus-catchment": !0
      }, tabsMarkup, mdDown || tabsToShow.length === 0 ? null : /* @__PURE__ */ React12.createElement("li", {
        className: disclosureTabClassName,
        role: "presentation"
      }, /* @__PURE__ */ React12.createElement(Popover.Popover, {
        preferredPosition: "below",
        preferredAlignment: "left",
        activator,
        active: disclosureActivatorVisible && showDisclosure,
        onClose: handleClose,
        autofocusTarget: "first-node"
      }, /* @__PURE__ */ React12.createElement(List3.List, {
        focusIndex: hiddenTabs.indexOf(tabToFocus),
        disclosureTabs,
        onClick: handleListTabClick,
        onKeyPress: handleKeyPress
      })))), canCreateNewView && tabsToShow.length > 0 ? /* @__PURE__ */ React12.createElement("div", {
        className: Tabs_module.default.NewTab
      }, /* @__PURE__ */ React12.createElement(CreateViewModal.CreateViewModal, {
        open: isNewViewModalActive,
        onClose: handleCloseNewViewModal,
        onClickPrimaryAction: handleSaveNewViewModal,
        viewNames,
        activator: disabled ? newTab : /* @__PURE__ */ React12.createElement("div", null, /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, {
          content: i18n.translate("Polaris.Tabs.newViewTooltip"),
          preferredPosition: "above",
          hoverDelay: 400
        }, newTab))
      })) : null))), panelMarkup);
    };
    exports.Tabs = Tabs;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/components/SearchFilterButton/SearchFilterButton.js
var require_SearchFilterButton = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/components/SearchFilterButton/SearchFilterButton.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), Tooltip = require_Tooltip(), Button2 = require_Button(), Text4 = require_Text(), InlineStack2 = require_InlineStack(), Icon = require_Icon();
    function SearchFilterButton({
      onClick,
      label,
      disabled,
      tooltipContent,
      style,
      hideFilters,
      hideQueryField
    }) {
      let iconMarkup = /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "0"
      }, hideQueryField ? null : /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.SearchIcon,
        tone: "base"
      }), hideFilters ? null : /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.FilterIcon,
        tone: "base"
      })), activator = /* @__PURE__ */ React12.createElement("div", {
        style
      }, /* @__PURE__ */ React12.createElement(Button2.Button, {
        size: "slim",
        onClick,
        disabled,
        icon: iconMarkup,
        accessibilityLabel: label
      })), content = /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        variant: "bodyMd",
        alignment: "center"
      }, tooltipContent);
      return /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, {
        content,
        preferredPosition: "above",
        hoverDelay: 400
      }, activator);
    }
    exports.SearchFilterButton = SearchFilterButton;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/components/EditColumnsButton/EditColumnsButton.js
var require_EditColumnsButton = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/components/EditColumnsButton/EditColumnsButton.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), hooks2 = require_hooks2(), Text4 = require_Text(), Tooltip = require_Tooltip(), Button2 = require_Button();
    function EditColumnsButton({
      onClick,
      disabled
    }) {
      let i18n = hooks2.useI18n(), tooltipContent = /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        variant: "bodyMd",
        alignment: "center"
      }, i18n.translate("Polaris.IndexFilters.EditColumnsButton.tooltip"));
      return /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, {
        content: tooltipContent,
        preferredPosition: "above",
        hoverDelay: 400
      }, /* @__PURE__ */ React12.createElement(Button2.Button, {
        size: "slim",
        onClick,
        disabled,
        icon: polarisIcons.LayoutColumns3Icon,
        accessibilityLabel: i18n.translate("Polaris.IndexFilters.EditColumnsButton.accessibilityLabel")
      }));
    }
    exports.EditColumnsButton = EditColumnsButton;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/IndexFilters.js
var require_IndexFilters = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/IndexFilters.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), reactTransitionGroup = require_cjs4(), css = require_css(), useEventListener = require_use_event_listener(), useToggle = require_use_toggle(), useOnValueChange = require_use_on_value_change(), breakpoints = require_breakpoints2(), types = require_types9(), IndexFilters_module = require_IndexFilters_scss(), useIsSticky = require_useIsSticky(), UpdateButtons = require_UpdateButtons(), SortButton = require_SortButton(), Container2 = require_Container(), Tabs = require_Tabs(), SearchFilterButton = require_SearchFilterButton(), Filters = require_Filters(), EditColumnsButton = require_EditColumnsButton(), hooks2 = require_hooks2(), InlineStack2 = require_InlineStack(), Spinner = require_Spinner(), DEFAULT_IGNORED_TAGS = ["INPUT", "SELECT", "TEXTAREA"], TRANSITION_DURATION = 150, defaultStyle = {
      transition: `opacity ${TRANSITION_DURATION}ms var(--p-motion-ease)`,
      opacity: 0
    }, transitionStyles = {
      entering: {
        opacity: 1
      },
      entered: {
        opacity: 1
      },
      exiting: {
        opacity: 0
      },
      exited: {
        opacity: 0
      },
      unmounted: {
        opacity: 0
      }
    };
    function IndexFilters({
      tabs,
      selected,
      onSelect,
      onSort,
      onSortKeyChange,
      onSortDirectionChange,
      onAddFilterClick,
      sortOptions,
      sortSelected,
      queryValue = "",
      queryPlaceholder,
      primaryAction,
      cancelAction,
      filters,
      appliedFilters,
      onClearAll,
      onQueryChange,
      onQueryFocus,
      onQueryClear,
      onEditStart,
      disabled,
      disableQueryField,
      hideFilters,
      loading,
      mode,
      setMode,
      disableStickyMode,
      isFlushWhenSticky = !1,
      canCreateNewView = !0,
      onCreateNewView,
      filteringAccessibilityLabel,
      filteringAccessibilityTooltip,
      hideQueryField,
      closeOnChildOverlayClick,
      disableKeyboardShortcuts,
      showEditColumnsButton
    }) {
      let i18n = hooks2.useI18n(), {
        mdDown
      } = breakpoints.useBreakpoints(), defaultRef = React12.useRef(null), filteringRef = React12.useRef(null), {
        value: filtersFocused,
        setFalse: setFiltersUnFocused,
        setTrue: setFiltersFocused
      } = useToggle.useToggle(mode === types.IndexFiltersMode.Filtering), handleModeChange = (newMode) => {
        newMode === types.IndexFiltersMode.Filtering ? setFiltersFocused() : setFiltersUnFocused();
      };
      useOnValueChange.useOnValueChange(mode, handleModeChange), useEventListener.useEventListener("keydown", (event) => {
        if (disableKeyboardShortcuts)
          return;
        let {
          key
        } = event, tag = document?.activeElement?.tagName;
        if (mode !== types.IndexFiltersMode.Default && event.key === "Escape" && onPressEscape(), key === "f" && mode === types.IndexFiltersMode.Default) {
          if (tag && DEFAULT_IGNORED_TAGS.includes(tag))
            return;
          onPressF(), event.preventDefault();
        }
      });
      let {
        intersectionRef,
        measurerRef,
        indexFilteringHeight,
        isSticky
      } = useIsSticky.useIsSticky(mode, !!disableStickyMode, isFlushWhenSticky), viewNames = tabs.map(({
        content
      }) => content), handleChangeSortButton = React12.useCallback((value) => {
        onSort?.(value);
      }, [onSort]), handleChangeSearch = React12.useCallback((value) => {
        onQueryChange(value);
      }, [onQueryChange]), onExecutedPrimaryAction = ((action, afterEffect) => React12.useCallback(async (name) => {
        await action?.(name) && (setMode(types.IndexFiltersMode.Default), afterEffect?.());
      }, [action, afterEffect]))(primaryAction?.onAction), onExecutedCancelAction = React12.useCallback(() => {
        cancelAction.onAction?.(), setMode(types.IndexFiltersMode.Default);
      }, [cancelAction, setMode]), enhancedPrimaryAction = React12.useMemo(() => primaryAction ? {
        ...primaryAction,
        onAction: onExecutedPrimaryAction
      } : void 0, [onExecutedPrimaryAction, primaryAction]), enhancedCancelAction = React12.useMemo(() => ({
        ...cancelAction,
        onAction: onExecutedCancelAction
      }), [cancelAction, onExecutedCancelAction]), beginEdit = React12.useCallback((mode2) => {
        setMode(mode2), onEditStart?.(mode2);
      }, [onEditStart, setMode]), updateButtonsMarkup = React12.useMemo(() => /* @__PURE__ */ React12.createElement(UpdateButtons.UpdateButtons, {
        primaryAction: enhancedPrimaryAction,
        cancelAction: enhancedCancelAction,
        viewNames,
        disabled
      }), [enhancedPrimaryAction, enhancedCancelAction, disabled, viewNames]), sortMarkup = React12.useMemo(() => sortOptions?.length ? /* @__PURE__ */ React12.createElement(SortButton.SortButton, {
        choices: sortOptions,
        selected: sortSelected,
        onChange: handleChangeSortButton,
        onChangeKey: onSortKeyChange,
        onChangeDirection: onSortDirectionChange,
        disabled
      }) : null, [handleChangeSortButton, onSortDirectionChange, onSortKeyChange, sortOptions, sortSelected, disabled]);
      function handleClickEditColumnsButon() {
        beginEdit(types.IndexFiltersMode.EditingColumns);
      }
      let editColumnsMarkup = showEditColumnsButton ? /* @__PURE__ */ React12.createElement(EditColumnsButton.EditColumnsButton, {
        onClick: handleClickEditColumnsButon,
        disabled
      }) : null, isActionLoading = primaryAction?.loading || cancelAction?.loading;
      function handleClickFilterButton() {
        beginEdit(types.IndexFiltersMode.Filtering);
      }
      let searchFilterTooltipLabelId = disableKeyboardShortcuts ? "Polaris.IndexFilters.searchFilterTooltip" : "Polaris.IndexFilters.searchFilterTooltipWithShortcut", searchFilterTooltip = filteringAccessibilityTooltip || i18n.translate(searchFilterTooltipLabelId), searchFilterAriaLabel = filteringAccessibilityLabel || i18n.translate("Polaris.IndexFilters.searchFilterAccessibilityLabel"), isLoading = loading || isActionLoading;
      function onPressEscape() {
        cancelAction?.onAction(), setMode(types.IndexFiltersMode.Default);
      }
      function handleClearSearch() {
        onQueryClear?.();
      }
      function handleQueryBlur() {
        setFiltersUnFocused();
      }
      function handleQueryFocus() {
        setFiltersFocused(), onQueryFocus?.();
      }
      function onPressF() {
        mode === types.IndexFiltersMode.Default && beginEdit(types.IndexFiltersMode.Filtering);
      }
      return /* @__PURE__ */ React12.createElement("div", {
        className: IndexFilters_module.default.IndexFiltersWrapper,
        style: {
          height: indexFilteringHeight
        }
      }, /* @__PURE__ */ React12.createElement("div", {
        ref: intersectionRef
      }), /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(IndexFilters_module.default.IndexFilters, isSticky && IndexFilters_module.default.IndexFiltersSticky, isSticky && isFlushWhenSticky && IndexFilters_module.default.IndexFiltersStickyFlush),
        ref: measurerRef
      }, /* @__PURE__ */ React12.createElement(reactTransitionGroup.Transition, {
        nodeRef: defaultRef,
        in: mode !== types.IndexFiltersMode.Filtering,
        timeout: TRANSITION_DURATION
      }, (state) => /* @__PURE__ */ React12.createElement("div", {
        ref: defaultRef
      }, mode !== types.IndexFiltersMode.Filtering ? /* @__PURE__ */ React12.createElement(Container2.Container, null, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        align: "start",
        blockAlign: "center",
        gap: {
          xs: "0",
          md: "200"
        },
        wrap: !1
      }, /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(IndexFilters_module.default.TabsWrapper, mdDown && IndexFilters_module.default.SmallScreenTabsWrapper, isLoading && IndexFilters_module.default.TabsWrapperLoading)
      }, /* @__PURE__ */ React12.createElement("div", {
        className: IndexFilters_module.default.TabsInner,
        style: {
          ...defaultStyle,
          ...transitionStyles[state]
        }
      }, /* @__PURE__ */ React12.createElement(Tabs.Tabs, {
        tabs,
        selected,
        onSelect,
        disabled: !!(mode !== types.IndexFiltersMode.Default || disabled),
        canCreateNewView,
        onCreateNewView
      })), isLoading && mdDown && /* @__PURE__ */ React12.createElement("div", {
        className: IndexFilters_module.default.TabsLoading
      }, /* @__PURE__ */ React12.createElement(Spinner.Spinner, {
        size: "small"
      }))), /* @__PURE__ */ React12.createElement("div", {
        className: IndexFilters_module.default.ActionWrap
      }, isLoading && !mdDown && /* @__PURE__ */ React12.createElement(Spinner.Spinner, {
        size: "small"
      }), mode === types.IndexFiltersMode.Default ? /* @__PURE__ */ React12.createElement(React12.Fragment, null, hideFilters && hideQueryField ? null : /* @__PURE__ */ React12.createElement(SearchFilterButton.SearchFilterButton, {
        onClick: handleClickFilterButton,
        label: searchFilterAriaLabel,
        tooltipContent: searchFilterTooltip,
        disabled,
        hideFilters,
        hideQueryField,
        style: {
          ...defaultStyle,
          ...transitionStyles[state]
        }
      }), editColumnsMarkup, sortMarkup) : null, mode === types.IndexFiltersMode.EditingColumns ? updateButtonsMarkup : null))) : null)), /* @__PURE__ */ React12.createElement(reactTransitionGroup.Transition, {
        nodeRef: filteringRef,
        in: mode === types.IndexFiltersMode.Filtering,
        timeout: TRANSITION_DURATION
      }, (state) => /* @__PURE__ */ React12.createElement("div", {
        ref: filteringRef
      }, mode === types.IndexFiltersMode.Filtering ? /* @__PURE__ */ React12.createElement(Filters.Filters, {
        queryValue,
        queryPlaceholder,
        onQueryChange: handleChangeSearch,
        onQueryClear: handleClearSearch,
        onQueryFocus: handleQueryFocus,
        onQueryBlur: handleQueryBlur,
        onAddFilterClick,
        filters,
        appliedFilters,
        onClearAll,
        disableFilters: disabled,
        hideFilters,
        hideQueryField,
        disableQueryField: disabled || disableQueryField,
        loading: loading || isActionLoading,
        focused: filtersFocused,
        mountedState: mdDown ? void 0 : state,
        borderlessQueryField: !0,
        closeOnChildOverlayClick
      }, /* @__PURE__ */ React12.createElement("div", {
        className: IndexFilters_module.default.ButtonWrap
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "200",
        align: "start",
        blockAlign: "center"
      }, /* @__PURE__ */ React12.createElement("div", {
        style: {
          ...defaultStyle,
          ...transitionStyles[state]
        }
      }, updateButtonsMarkup), sortMarkup))) : null))));
    }
    exports.IndexFilters = IndexFilters;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/hooks/useSetIndexFiltersMode/useSetIndexFiltersMode.js
var require_useSetIndexFiltersMode = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexFilters/hooks/useSetIndexFiltersMode/useSetIndexFiltersMode.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), types = require_types9();
    function useSetIndexFiltersMode(defaultMode = types.IndexFiltersMode.Default) {
      let [mode, setMode] = React12.useState(defaultMode);
      return {
        mode,
        setMode
      };
    }
    exports.useSetIndexFiltersMode = useSetIndexFiltersMode;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/IndexTable.scss.js
var require_IndexTable_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/IndexTable.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      IndexTable: "Polaris-IndexTable",
      IndexTableWrapper: "Polaris-IndexTable__IndexTableWrapper",
      "IndexTableWrapper-scrollBarHidden": "Polaris-IndexTable__IndexTableWrapper--scrollBarHidden",
      IndexTableWrapperWithBulkActions: "Polaris-IndexTable__IndexTableWrapperWithBulkActions",
      "LoadingContainer-enter": "Polaris-IndexTable__LoadingContainer--enter",
      "LoadingContainer-enter-active": "Polaris-IndexTable--loadingContainerEnterActive",
      "LoadingContainer-exit": "Polaris-IndexTable__LoadingContainer--exit",
      "LoadingContainer-exit-active": "Polaris-IndexTable--loadingContainerExitActive",
      LoadingPanel: "Polaris-IndexTable__LoadingPanel",
      LoadingPanelRow: "Polaris-IndexTable__LoadingPanelRow",
      LoadingPanelText: "Polaris-IndexTable__LoadingPanelText",
      Table: "Polaris-IndexTable__Table",
      "Table-scrolling": "Polaris-IndexTable__Table--scrolling",
      "TableCell-first": "Polaris-IndexTable__TableCell--first",
      TableCell: "Polaris-IndexTable__TableCell",
      "TableHeading-first": "Polaris-IndexTable__TableHeading--first",
      "TableHeading-second": "Polaris-IndexTable__TableHeading--second",
      "Table-sticky": "Polaris-IndexTable__Table--sticky",
      "Table-unselectable": "Polaris-IndexTable__Table--unselectable",
      TableRow: "Polaris-IndexTable__TableRow",
      "TableRow-unclickable": "Polaris-IndexTable__TableRow--unclickable",
      toneSuccess: "Polaris-IndexTable--toneSuccess",
      "TableRow-child": "Polaris-IndexTable__TableRow--child",
      toneWarning: "Polaris-IndexTable--toneWarning",
      toneCritical: "Polaris-IndexTable--toneCritical",
      toneSubdued: "Polaris-IndexTable--toneSubdued",
      "TableRow-subheader": "Polaris-IndexTable__TableRow--subheader",
      "TableRow-selected": "Polaris-IndexTable__TableRow--selected",
      "TableRow-hovered": "Polaris-IndexTable__TableRow--hovered",
      "TableRow-disabled": "Polaris-IndexTable__TableRow--disabled",
      ZebraStriping: "Polaris-IndexTable__ZebraStriping",
      TableHeading: "Polaris-IndexTable__TableHeading",
      "TableHeading-flush": "Polaris-IndexTable__TableHeading--flush",
      "TableHeading-align-center": "Polaris-IndexTable--tableHeadingAlignCenter",
      "TableHeading-align-end": "Polaris-IndexTable--tableHeadingAlignEnd",
      "TableHeading-extra-padding-right": "Polaris-IndexTable--tableHeadingExtraPaddingRight",
      "TableHeading-sortable": "Polaris-IndexTable__TableHeading--sortable",
      TableHeadingSortButton: "Polaris-IndexTable__TableHeadingSortButton",
      TableHeadingSortIcon: "Polaris-IndexTable__TableHeadingSortIcon",
      "TableHeadingSortButton-heading-align-end": "Polaris-IndexTable--tableHeadingSortButtonHeadingAlignEnd",
      "TableHeadingSortButton-heading-align-end-currently-sorted": "Polaris-IndexTable--tableHeadingSortButtonHeadingAlignEndCurrentlySorted",
      "TableHeadingSortIcon-heading-align-end": "Polaris-IndexTable--tableHeadingSortIconHeadingAlignEnd",
      "TableHeadingSortButton-heading-align-end-previously-sorted": "Polaris-IndexTable--tableHeadingSortButtonHeadingAlignEndPreviouslySorted",
      "right-aligned-sort-button-slide-out": "Polaris-IndexTable--rightAlignedSortButtonSlideOut",
      "reveal-right-aligned-sort-button-icon": "Polaris-IndexTable--revealRightAlignedSortButtonIcon",
      TableHeadingUnderline: "Polaris-IndexTable__TableHeadingUnderline",
      TableHeadingTooltipUnderlinePlaceholder: "Polaris-IndexTable__TableHeadingTooltipUnderlinePlaceholder",
      "TableHeadingSortIcon-visible": "Polaris-IndexTable__TableHeadingSortIcon--visible",
      TableHeadingSortSvg: "Polaris-IndexTable__TableHeadingSortSvg",
      SortableTableHeadingWithCustomMarkup: "Polaris-IndexTable__SortableTableHeadingWithCustomMarkup",
      SortableTableHeaderWrapper: "Polaris-IndexTable__SortableTableHeaderWrapper",
      ColumnHeaderCheckboxWrapper: "Polaris-IndexTable__ColumnHeaderCheckboxWrapper",
      FirstStickyHeaderElement: "Polaris-IndexTable__FirstStickyHeaderElement",
      "TableHeading-unselectable": "Polaris-IndexTable__TableHeading--unselectable",
      "TableCell-flush": "Polaris-IndexTable__TableCell--flush",
      "Table-sticky-scrolling": "Polaris-IndexTable--tableStickyScrolling",
      "TableHeading-last": "Polaris-IndexTable__TableHeading--last",
      "Table-sticky-last": "Polaris-IndexTable--tableStickyLast",
      "Table-sortable": "Polaris-IndexTable__Table--sortable",
      StickyTable: "Polaris-IndexTable__StickyTable",
      StickyTableHeader: "Polaris-IndexTable__StickyTableHeader",
      "StickyTableHeader-isSticky": "Polaris-IndexTable__StickyTableHeader--isSticky",
      StickyTableColumnHeader: "Polaris-IndexTable__StickyTableColumnHeader",
      StickyTableHeadings: "Polaris-IndexTable__StickyTableHeadings",
      "StickyTableHeading-second": "Polaris-IndexTable__StickyTableHeading--second",
      unselectable: "Polaris-IndexTable--unselectable",
      "StickyTableHeading-second-scrolling": "Polaris-IndexTable--stickyTableHeadingSecondScrolling",
      ScrollLeft: "Polaris-IndexTable__ScrollLeft",
      ScrollRight: "Polaris-IndexTable__ScrollRight",
      "ScrollRight-onboarding": "Polaris-IndexTable__ScrollRight--onboarding",
      BulkActionsWrapper: "Polaris-IndexTable__BulkActionsWrapper",
      BulkActionsWrapperSticky: "Polaris-IndexTable__BulkActionsWrapperSticky",
      SelectAllActionsWrapper: "Polaris-IndexTable__SelectAllActionsWrapper",
      ScrollBarContainer: "Polaris-IndexTable__ScrollBarContainer",
      scrollBarContainerCondensed: "Polaris-IndexTable--scrollBarContainerCondensed",
      scrollBarContainerHidden: "Polaris-IndexTable--scrollBarContainerHidden",
      ScrollBar: "Polaris-IndexTable__ScrollBar",
      disableTextSelection: "Polaris-IndexTable--disableTextSelection",
      selectMode: "Polaris-IndexTable--selectMode",
      EmptySearchResultWrapper: "Polaris-IndexTable__EmptySearchResultWrapper",
      condensedRow: "Polaris-IndexTable--condensedRow",
      CondensedList: "Polaris-IndexTable__CondensedList",
      HeaderWrapper: "Polaris-IndexTable__HeaderWrapper",
      "StickyTable-condensed": "Polaris-IndexTable__StickyTable--condensed",
      "StickyTableHeader-condensed": "Polaris-IndexTable__StickyTableHeader--condensed",
      ScrollBarContent: "Polaris-IndexTable__ScrollBarContent"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/index-provider/types.js
var require_types10 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/index-provider/types.js"(exports) {
    "use strict";
    init_cjs_shims();
    var SELECT_ALL_ITEMS = "All";
    exports.SelectionType = void 0;
    (function(SelectionType) {
      SelectionType.All = "all", SelectionType.Page = "page", SelectionType.Multi = "multi", SelectionType.Single = "single", SelectionType.Range = "range";
    })(exports.SelectionType || (exports.SelectionType = {}));
    exports.SELECT_ALL_ITEMS = SELECT_ALL_ITEMS;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/index-provider/context.js
var require_context17 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/index-provider/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), IndexContext = /* @__PURE__ */ React12.createContext(void 0), IndexSelectionChangeContext = /* @__PURE__ */ React12.createContext(void 0), IndexRowContext = /* @__PURE__ */ React12.createContext(void 0);
    exports.IndexContext = IndexContext;
    exports.IndexRowContext = IndexRowContext;
    exports.IndexSelectionChangeContext = IndexSelectionChangeContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/index-provider/hooks.js
var require_hooks13 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/index-provider/hooks.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), types = require_types10(), context = require_context17(), hooks2 = require_hooks2();
    function useIndexSelectionChange() {
      let onSelectionChange = React12.useContext(context.IndexSelectionChangeContext);
      if (!onSelectionChange)
        throw new Error("Missing IndexProvider context");
      return onSelectionChange;
    }
    function useIndexRow() {
      let indexRow = React12.useContext(context.IndexRowContext);
      if (!indexRow)
        throw new Error("Missing IndexProvider context");
      return indexRow;
    }
    function useIndexValue() {
      let index = React12.useContext(context.IndexContext);
      if (!index)
        throw new Error("Missing IndexProvider context");
      return index;
    }
    function useBulkSelectionData({
      selectedItemsCount,
      itemCount,
      hasMoreItems,
      resourceName: passedResourceName
    }) {
      let i18n = hooks2.useI18n(), selectable = !!selectedItemsCount, selectMode = selectedItemsCount === "All" || selectedItemsCount > 0, defaultResourceName = {
        singular: i18n.translate("Polaris.IndexProvider.defaultItemSingular"),
        plural: i18n.translate("Polaris.IndexProvider.defaultItemPlural")
      }, resourceName = passedResourceName || defaultResourceName, paginatedSelectAllText = getPaginatedSelectAllText(), bulkActionsLabel = getBulkActionsLabel(), bulkActionsAccessibilityLabel = getBulkActionsAccessibilityLabel(), bulkSelectState = "indeterminate";
      return !selectedItemsCount || selectedItemsCount === 0 ? bulkSelectState = void 0 : (selectedItemsCount === types.SELECT_ALL_ITEMS || selectedItemsCount === itemCount) && (bulkSelectState = !0), {
        paginatedSelectAllText,
        bulkActionsLabel,
        bulkActionsAccessibilityLabel,
        resourceName,
        selectMode,
        bulkSelectState,
        selectable
      };
      function getPaginatedSelectAllText() {
        if (!(!selectable || !hasMoreItems) && selectedItemsCount === types.SELECT_ALL_ITEMS)
          return i18n.translate("Polaris.IndexProvider.allItemsSelected", {
            itemsLength: itemCount,
            resourceNamePlural: resourceName.plural.toLocaleLowerCase()
          });
      }
      function getBulkActionsLabel() {
        let selectedItemsCountLabel = selectedItemsCount === types.SELECT_ALL_ITEMS ? `${itemCount}+` : selectedItemsCount;
        return i18n.translate("Polaris.IndexProvider.selected", {
          selectedItemsCount: selectedItemsCountLabel
        });
      }
      function getBulkActionsAccessibilityLabel() {
        let totalItemsCount = itemCount, allSelected = selectedItemsCount === totalItemsCount;
        return totalItemsCount === 1 && allSelected ? i18n.translate("Polaris.IndexProvider.a11yCheckboxDeselectAllSingle", {
          resourceNameSingular: resourceName.singular
        }) : totalItemsCount === 1 ? i18n.translate("Polaris.IndexProvider.a11yCheckboxSelectAllSingle", {
          resourceNameSingular: resourceName.singular
        }) : allSelected ? i18n.translate("Polaris.IndexProvider.a11yCheckboxDeselectAllMultiple", {
          itemsLength: itemCount,
          resourceNamePlural: resourceName.plural
        }) : i18n.translate("Polaris.IndexProvider.a11yCheckboxSelectAllMultiple", {
          itemsLength: itemCount,
          resourceNamePlural: resourceName.plural
        });
      }
    }
    function useHandleBulkSelection({
      onSelectionChange = () => {
      }
    }) {
      let lastSelected = React12.useRef(null);
      return React12.useCallback((selectionType, toggleType, selection, sortOrder) => {
        let prevSelected = lastSelected.current;
        if (types.SelectionType.Multi && typeof sortOrder == "number" && (lastSelected.current = sortOrder), selectionType === types.SelectionType.Single || selectionType === types.SelectionType.Multi && (typeof prevSelected != "number" || typeof sortOrder != "number"))
          onSelectionChange(types.SelectionType.Single, toggleType, selection);
        else if (selectionType === types.SelectionType.Multi) {
          let min = Math.min(prevSelected, sortOrder), max = Math.max(prevSelected, sortOrder);
          onSelectionChange(selectionType, toggleType, [min, max]);
        } else
          selectionType === types.SelectionType.Page || selectionType === types.SelectionType.All ? onSelectionChange(selectionType, toggleType) : selectionType === types.SelectionType.Range && onSelectionChange(types.SelectionType.Range, toggleType, selection);
      }, [onSelectionChange]);
    }
    exports.useBulkSelectionData = useBulkSelectionData;
    exports.useHandleBulkSelection = useHandleBulkSelection;
    exports.useIndexRow = useIndexRow;
    exports.useIndexSelectionChange = useIndexSelectionChange;
    exports.useIndexValue = useIndexValue;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexProvider/IndexProvider.js
var require_IndexProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexProvider/IndexProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), hooks2 = require_hooks13(), context = require_context17();
    function IndexProvider({
      children,
      resourceName: passedResourceName,
      loading,
      onSelectionChange,
      selectedItemsCount = 0,
      itemCount,
      hasMoreItems,
      condensed,
      selectable: isSelectableIndex = !0
    }) {
      let {
        paginatedSelectAllText,
        bulkActionsLabel,
        bulkActionsAccessibilityLabel,
        resourceName,
        selectMode,
        bulkSelectState
      } = hooks2.useBulkSelectionData({
        selectedItemsCount,
        itemCount,
        hasMoreItems,
        resourceName: passedResourceName
      }), handleSelectionChange = hooks2.useHandleBulkSelection({
        onSelectionChange
      }), contextValue = React12.useMemo(() => ({
        itemCount,
        selectMode: selectMode && isSelectableIndex,
        selectable: isSelectableIndex,
        resourceName,
        loading,
        paginatedSelectAllText,
        hasMoreItems,
        bulkActionsLabel,
        bulkActionsAccessibilityLabel,
        bulkSelectState,
        selectedItemsCount,
        condensed
      }), [itemCount, selectMode, isSelectableIndex, resourceName, loading, paginatedSelectAllText, hasMoreItems, bulkActionsLabel, bulkActionsAccessibilityLabel, bulkSelectState, selectedItemsCount, condensed]), rowContextValue = React12.useMemo(() => ({
        selectable: isSelectableIndex,
        selectMode: selectMode && isSelectableIndex,
        condensed
      }), [condensed, selectMode, isSelectableIndex]);
      return /* @__PURE__ */ React12.createElement(context.IndexContext.Provider, {
        value: contextValue
      }, /* @__PURE__ */ React12.createElement(context.IndexRowContext.Provider, {
        value: rowContextValue
      }, /* @__PURE__ */ React12.createElement(context.IndexSelectionChangeContext.Provider, {
        value: handleSelectionChange
      }, children)));
    }
    exports.IndexProvider = IndexProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/components/Cell/Cell.js
var require_Cell3 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/components/Cell/Cell.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), IndexTable_module = require_IndexTable_scss(), Cell = /* @__PURE__ */ React12.memo(function({
      children,
      className: customClassName,
      flush,
      colSpan,
      headers,
      scope,
      as = "td",
      id
    }) {
      let className = css.classNames(customClassName, IndexTable_module.default.TableCell, flush && IndexTable_module.default["TableCell-flush"]);
      return /* @__PURE__ */ React12.createElement(as, {
        id,
        colSpan,
        headers,
        scope,
        className
      }, children);
    });
    exports.Cell = Cell;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/components/Checkbox/Checkbox.scss.js
var require_Checkbox_scss2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/components/Checkbox/Checkbox.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      TableCellContentContainer: "Polaris-IndexTable-Checkbox__TableCellContentContainer",
      Wrapper: "Polaris-IndexTable-Checkbox__Wrapper"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/index-table/context.js
var require_context18 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/index-table/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), RowContext = /* @__PURE__ */ React12.createContext({}), RowHoveredContext = /* @__PURE__ */ React12.createContext(void 0), scrollDefaultContext = {
      scrollableContainer: null,
      canScrollLeft: !1,
      canScrollRight: !1
    }, ScrollContext = /* @__PURE__ */ React12.createContext(scrollDefaultContext);
    exports.RowContext = RowContext;
    exports.RowHoveredContext = RowHoveredContext;
    exports.ScrollContext = ScrollContext;
    exports.scrollDefaultContext = scrollDefaultContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/components/Checkbox/Checkbox.js
var require_Checkbox2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/components/Checkbox/Checkbox.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), debounce = require_debounce2(), css = require_css(), setRootProperty = require_set_root_property(), IndexTable_module = require_IndexTable_scss(), Checkbox_module = require_Checkbox_scss2(), hooks$1 = require_hooks13(), context = require_context18(), hooks2 = require_hooks2(), Checkbox$1 = require_Checkbox(), Checkbox = /* @__PURE__ */ React12.memo(function({
      accessibilityLabel
    }) {
      let i18n = hooks2.useI18n(), {
        resourceName
      } = hooks$1.useIndexValue(), {
        itemId,
        selected,
        disabled,
        onInteraction
      } = React12.useContext(context.RowContext), wrapperClassName = css.classNames(Checkbox_module.default.Wrapper), label = accessibilityLabel || i18n.translate("Polaris.IndexTable.selectItem", {
        resourceName: resourceName.singular
      });
      return /* @__PURE__ */ React12.createElement(CheckboxWrapper, null, /* @__PURE__ */ React12.createElement("div", {
        className: Checkbox_module.default.TableCellContentContainer
      }, /* @__PURE__ */ React12.createElement("div", {
        className: wrapperClassName,
        onClick: onInteraction,
        onKeyUp: noop
      }, /* @__PURE__ */ React12.createElement(Checkbox$1.Checkbox, {
        id: `Select-${itemId}`,
        label,
        labelHidden: !0,
        checked: selected,
        disabled
      }))));
    });
    function CheckboxWrapper({
      children
    }) {
      let {
        position
      } = React12.useContext(context.RowContext), checkboxNode = React12.useRef(null), handleResize = React12.useCallback(debounce.debounce(() => {
        if (position !== 0 || !checkboxNode.current)
          return;
        let {
          width
        } = checkboxNode.current.getBoundingClientRect();
        setRootProperty.setRootProperty("--pc-checkbox-offset", `${width}px`);
      }), [position]);
      React12.useEffect(() => {
        handleResize();
      }, [handleResize]), React12.useEffect(() => {
        if (checkboxNode.current)
          return window.addEventListener("resize", handleResize), () => {
            window.removeEventListener("resize", handleResize);
          };
      }, [handleResize]);
      let checkboxClassName = css.classNames(IndexTable_module.default.TableCell, IndexTable_module.default["TableCell-first"]);
      return /* @__PURE__ */ React12.createElement("td", {
        className: checkboxClassName,
        ref: checkboxNode
      }, children);
    }
    function noop() {
    }
    exports.Checkbox = Checkbox;
    exports.CheckboxWrapper = CheckboxWrapper;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/components/Row/Row.js
var require_Row = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/components/Row/Row.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), useToggle = require_use_toggle(), css = require_css(), IndexTable_module = require_IndexTable_scss(), hooks2 = require_hooks13(), types = require_types10(), Checkbox = require_Checkbox2(), context = require_context18(), Row = /* @__PURE__ */ React12.memo(function({
      children,
      selected,
      id,
      position,
      tone,
      disabled,
      selectionRange,
      rowType = "data",
      accessibilityLabel,
      onNavigation,
      onClick
    }) {
      let {
        selectable,
        selectMode,
        condensed
      } = hooks2.useIndexRow(), onSelectionChange = hooks2.useIndexSelectionChange(), {
        value: hovered,
        setTrue: setHoverIn,
        setFalse: setHoverOut
      } = useToggle.useToggle(!1), handleInteraction = React12.useCallback((event) => {
        event.stopPropagation();
        let selectionType = types.SelectionType.Single;
        if ("key" in event && event.key !== " " || !onSelectionChange)
          return;
        event.nativeEvent.shiftKey ? selectionType = types.SelectionType.Multi : selectionRange && (selectionType = types.SelectionType.Range), onSelectionChange(selectionType, !selected, selectionRange ?? id, position);
      }, [id, onSelectionChange, selected, selectionRange, position]), contextValue = React12.useMemo(() => ({
        itemId: id,
        selected,
        position,
        onInteraction: handleInteraction,
        disabled
      }), [id, selected, disabled, position, handleInteraction]), primaryLinkElement = React12.useRef(null), isNavigating = React12.useRef(!1), tableRowRef = React12.useRef(null), tableRowCallbackRef = React12.useCallback((node) => {
        tableRowRef.current = node;
        let el = node?.querySelector("[data-primary-link]");
        el && (primaryLinkElement.current = el);
      }, []), rowClassName = css.classNames(IndexTable_module.default.TableRow, rowType === "subheader" && IndexTable_module.default["TableRow-subheader"], rowType === "child" && IndexTable_module.default["TableRow-child"], selectable && condensed && IndexTable_module.default.condensedRow, selected && IndexTable_module.default["TableRow-selected"], hovered && !condensed && IndexTable_module.default["TableRow-hovered"], disabled && IndexTable_module.default["TableRow-disabled"], tone && IndexTable_module.default[css.variationName("tone", tone)], !selectable && !primaryLinkElement.current && IndexTable_module.default["TableRow-unclickable"]), handleRowClick;
      (!disabled && selectable || primaryLinkElement.current) && (handleRowClick = (event) => {
        if (rowType !== "subheader" && !(!tableRowRef.current || isNavigating.current)) {
          if (event.stopPropagation(), event.preventDefault(), onClick) {
            onClick();
            return;
          }
          if (primaryLinkElement.current && !selectMode) {
            isNavigating.current = !0;
            let {
              ctrlKey,
              metaKey
            } = event.nativeEvent;
            if (onNavigation && onNavigation(id), (ctrlKey || metaKey) && primaryLinkElement.current instanceof HTMLAnchorElement) {
              isNavigating.current = !1, window.open(primaryLinkElement.current.href, "_blank");
              return;
            }
            primaryLinkElement.current.dispatchEvent(new MouseEvent(event.type, event.nativeEvent));
          } else
            isNavigating.current = !1, handleInteraction(event);
        }
      });
      let RowWrapper = condensed ? "li" : "tr", checkboxMarkup = selectable ? /* @__PURE__ */ React12.createElement(Checkbox.Checkbox, {
        accessibilityLabel
      }) : null;
      return /* @__PURE__ */ React12.createElement(context.RowContext.Provider, {
        value: contextValue
      }, /* @__PURE__ */ React12.createElement(context.RowHoveredContext.Provider, {
        value: hovered
      }, /* @__PURE__ */ React12.createElement(RowWrapper, {
        key: id,
        id,
        className: rowClassName,
        onMouseEnter: setHoverIn,
        onMouseLeave: setHoverOut,
        onClick: handleRowClick,
        ref: tableRowCallbackRef
      }, checkboxMarkup, children)));
    });
    exports.Row = Row;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/BulkActions/hooks/use-is-bulk-actions-sticky.js
var require_use_is_bulk_actions_sticky = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/BulkActions/hooks/use-is-bulk-actions-sticky.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), debounce = require_debounce2(), DEBOUNCE_PERIOD = 250, PADDING_IN_SELECT_MODE = 92;
    function useIsBulkActionsSticky(selectMode) {
      let hasIOSupport = typeof window < "u" && !!window.IntersectionObserver, [isBulkActionsSticky, setIsSticky] = React12.useState(!1), [bulkActionsAbsoluteOffset, setBulkActionsAbsoluteOffset] = React12.useState(0), [bulkActionsMaxWidth, setBulkActionsMaxWidth] = React12.useState(0), [bulkActionsOffsetLeft, setBulkActionsOffsetLeft] = React12.useState(0), bulkActionsIntersectionRef = React12.useRef(null), tableMeasurerRef = React12.useRef(null), handleIntersect = (entries) => {
        entries.forEach((entry) => {
          setIsSticky(!entry.isIntersecting);
        });
      }, options = {
        root: null,
        rootMargin: "-12px",
        threshold: 0
      }, observerRef = React12.useRef(hasIOSupport ? new IntersectionObserver(handleIntersect, options) : null), computeTableDimensions = React12.useCallback(() => {
        let node = tableMeasurerRef.current;
        if (!node)
          return {
            maxWidth: 0,
            offsetHeight: 0,
            offsetLeft: 0
          };
        let box = node.getBoundingClientRect(), paddingHeight = selectMode ? PADDING_IN_SELECT_MODE : 0, offsetHeight = box.height - paddingHeight, maxWidth = box.width, offsetLeft = box.left;
        setBulkActionsAbsoluteOffset(offsetHeight), setBulkActionsMaxWidth(maxWidth), setBulkActionsOffsetLeft(offsetLeft);
      }, [selectMode]);
      return React12.useEffect(() => {
        computeTableDimensions();
        let debouncedComputeTableHeight = debounce.debounce(computeTableDimensions, DEBOUNCE_PERIOD, {
          trailing: !0
        });
        return window.addEventListener("resize", debouncedComputeTableHeight), () => window.removeEventListener("resize", debouncedComputeTableHeight);
      }, [computeTableDimensions]), React12.useEffect(() => {
        let observer = observerRef.current;
        if (!observer)
          return;
        let node = bulkActionsIntersectionRef.current;
        return node && observer.observe(node), () => {
          observer?.disconnect();
        };
      }, [bulkActionsIntersectionRef]), {
        bulkActionsIntersectionRef,
        tableMeasurerRef,
        isBulkActionsSticky,
        bulkActionsAbsoluteOffset,
        bulkActionsMaxWidth,
        bulkActionsOffsetLeft,
        computeTableDimensions
      };
    }
    exports.useIsBulkActionsSticky = useIsBulkActionsSticky;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/utilities/utilities.js
var require_utilities8 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/utilities/utilities.js"(exports) {
    "use strict";
    init_cjs_shims();
    function getTableHeadingsBySelector(wrapperElement, selector) {
      return wrapperElement ? Array.from(wrapperElement.querySelectorAll(selector)) : [];
    }
    exports.getTableHeadingsBySelector = getTableHeadingsBySelector;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/components/ScrollContainer/ScrollContainer.scss.js
var require_ScrollContainer_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/components/ScrollContainer/ScrollContainer.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      ScrollContainer: "Polaris-IndexTable-ScrollContainer"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/components/ScrollContainer/ScrollContainer.js
var require_ScrollContainer = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/components/ScrollContainer/ScrollContainer.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), debounce = require_debounce2(), ScrollContainer_module = require_ScrollContainer_scss(), context = require_context18();
    function ScrollContainer({
      children,
      scrollableContainerRef,
      onScroll
    }) {
      React12.useEffect(() => {
        scrollableContainerRef.current && scrollableContainerRef.current.dispatchEvent(new Event("scroll"));
      }, [scrollableContainerRef]);
      let [containerScroll, setContainerScroll] = React12.useState(context.scrollDefaultContext), handleScroll = React12.useCallback(debounce.debounce(() => {
        if (!scrollableContainerRef.current)
          return;
        let availableScrollAmount = scrollableContainerRef.current.scrollWidth - scrollableContainerRef.current.offsetWidth, canScrollLeft = scrollableContainerRef.current.scrollLeft > 0, canScrollRight = scrollableContainerRef.current.scrollLeft < availableScrollAmount;
        onScroll(canScrollLeft, canScrollRight), setContainerScroll({
          scrollableContainer: scrollableContainerRef.current,
          canScrollLeft,
          canScrollRight
        });
      }, 40, {
        trailing: !0,
        leading: !0,
        maxWait: 40
      }), [onScroll, scrollableContainerRef]);
      return /* @__PURE__ */ React12.createElement(context.ScrollContext.Provider, {
        value: containerScroll
      }, /* @__PURE__ */ React12.createElement("div", {
        className: ScrollContainer_module.default.ScrollContainer,
        ref: scrollableContainerRef,
        onScroll: handleScroll
      }, children));
    }
    exports.ScrollContainer = ScrollContainer;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SelectAllActions/SelectAllActions.scss.js
var require_SelectAllActions_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SelectAllActions/SelectAllActions.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      SelectAllActions: "Polaris-SelectAllActions",
      "SelectAllActions-entering": "Polaris-SelectAllActions__SelectAllActions--entering",
      "SelectAllActions-exiting": "Polaris-SelectAllActions__SelectAllActions--exiting",
      "SelectAllActions-entered": "Polaris-SelectAllActions__SelectAllActions--entered",
      "SelectAllActions-exited": "Polaris-SelectAllActions__SelectAllActions--exited",
      PaginatedSelectAll: "Polaris-SelectAllActions__PaginatedSelectAll",
      AllAction: "Polaris-SelectAllActions__AllAction"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/CheckableButton/CheckableButton.scss.js
var require_CheckableButton_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/CheckableButton/CheckableButton.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      CheckableButton: "Polaris-CheckableButton",
      Checkbox: "Polaris-CheckableButton__Checkbox",
      Label: "Polaris-CheckableButton__Label"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/CheckableButton/CheckableButton.js
var require_CheckableButton = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/CheckableButton/CheckableButton.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), CheckableButton_module = require_CheckableButton_scss(), Checkbox = require_Checkbox(), CheckableButton = /* @__PURE__ */ React12.forwardRef(function({
      accessibilityLabel,
      label = "",
      onToggleAll,
      selected,
      disabled,
      ariaLive
    }, ref) {
      let checkBoxRef = React12.useRef(null);
      function focus() {
        checkBoxRef?.current?.focus();
      }
      React12.useImperativeHandle(ref, () => ({
        focus
      }));
      let className = css.classNames(CheckableButton_module.default.CheckableButton);
      return /* @__PURE__ */ React12.createElement("div", {
        className,
        onClick: onToggleAll
      }, /* @__PURE__ */ React12.createElement("div", {
        className: CheckableButton_module.default.Checkbox
      }, /* @__PURE__ */ React12.createElement(Checkbox.Checkbox, {
        label: accessibilityLabel,
        labelHidden: !0,
        checked: selected,
        disabled,
        onChange: onToggleAll,
        ref: checkBoxRef
      })), /* @__PURE__ */ React12.createElement("span", {
        className: CheckableButton_module.default.Label,
        "aria-live": ariaLive
      }, label));
    });
    exports.CheckableButton = CheckableButton;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SelectAllActions/SelectAllActions.js
var require_SelectAllActions = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SelectAllActions/SelectAllActions.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), reactTransitionGroup = require_cjs4(), css = require_css(), SelectAllActions_module = require_SelectAllActions_scss(), CheckableButton = require_CheckableButton(), UnstyledButton = require_UnstyledButton(), SelectAllActions = /* @__PURE__ */ React12.forwardRef(function({
      accessibilityLabel,
      label,
      selected,
      selectMode,
      paginatedSelectAllText,
      paginatedSelectAllAction,
      disabled,
      onToggleAll
    }, ref) {
      let paginatedSelectAllActionMarkup = paginatedSelectAllAction ? /* @__PURE__ */ React12.createElement(UnstyledButton.UnstyledButton, {
        className: SelectAllActions_module.default.AllAction,
        onClick: paginatedSelectAllAction.onAction,
        size: "slim",
        disabled
      }, paginatedSelectAllAction.content) : null, hasTextAndAction = paginatedSelectAllText && paginatedSelectAllAction, paginatedSelectAllMarkup = paginatedSelectAllActionMarkup ? /* @__PURE__ */ React12.createElement("div", {
        className: SelectAllActions_module.default.PaginatedSelectAll
      }, paginatedSelectAllActionMarkup) : null, checkableButtonProps = {
        accessibilityLabel,
        label: hasTextAndAction ? paginatedSelectAllText : label,
        selected,
        onToggleAll,
        disabled,
        ariaLive: hasTextAndAction ? "polite" : void 0,
        ref
      };
      return /* @__PURE__ */ React12.createElement(reactTransitionGroup.Transition, {
        timeout: 0,
        in: selectMode,
        key: "markup"
      }, (status) => {
        let wrapperClasses = css.classNames(SelectAllActions_module.default.SelectAllActions, SelectAllActions_module.default[`SelectAllActions-${status}`]);
        return /* @__PURE__ */ React12.createElement("div", {
          className: wrapperClasses
        }, /* @__PURE__ */ React12.createElement(CheckableButton.CheckableButton, checkableButtonProps), paginatedSelectAllMarkup);
      });
    });
    exports.SelectAllActions = SelectAllActions;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/IndexTable.js
var require_IndexTable = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/IndexTable/IndexTable.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), reactTransitionGroup = require_cjs4(), polarisTokens = require_build2(), debounce = require_debounce2(), useToggle = require_use_toggle(), useIsomorphicLayoutEffect = require_use_isomorphic_layout_effect(), css = require_css(), useTheme = require_use_theme(), IndexTable_module = require_IndexTable_scss(), IndexProvider = require_IndexProvider(), Cell = require_Cell3(), Row = require_Row(), useIsBulkActionsSticky = require_use_is_bulk_actions_sticky(), types = require_types10(), utilities = require_utilities8(), EmptySearchResult = require_EmptySearchResult(), ScrollContainer = require_ScrollContainer(), BulkActions = require_BulkActions(), SelectAllActions = require_SelectAllActions(), Pagination = require_Pagination(), hooks2 = require_hooks13(), hooks$1 = require_hooks2(), LegacyStack = require_LegacyStack(), Spinner = require_Spinner(), AfterInitialMount = require_AfterInitialMount(), EventListener = require_EventListener(), Checkbox = require_Checkbox(), Badge2 = require_Badge(), Text4 = require_Text(), UnstyledButton = require_UnstyledButton(), Tooltip = require_Tooltip(), Sticky = require_Sticky(), SCROLL_BAR_PADDING = 4, SCROLL_BAR_DEBOUNCE_PERIOD = 300;
    function IndexTableBase({
      headings,
      bulkActions = [],
      promotedBulkActions = [],
      children,
      emptyState,
      sort: sort2,
      paginatedSelectAllActionText,
      lastColumnSticky = !1,
      sortable,
      sortDirection,
      defaultSortDirection = "descending",
      sortColumnIndex,
      onSort,
      sortToggleLabels,
      hasZebraStriping,
      ...restProps
    }) {
      let theme = useTheme.useTheme(), {
        loading,
        bulkSelectState,
        resourceName,
        bulkActionsAccessibilityLabel,
        selectMode,
        selectable = restProps.selectable,
        paginatedSelectAllText,
        itemCount,
        hasMoreItems,
        selectedItemsCount,
        condensed
      } = hooks2.useIndexValue(), handleSelectionChange = hooks2.useIndexSelectionChange(), i18n = hooks$1.useI18n(), {
        value: hasMoreLeftColumns,
        toggle: toggleHasMoreLeftColumns
      } = useToggle.useToggle(!1), tablePosition = React12.useRef({
        top: 0,
        left: 0
      }), tableHeadingRects = React12.useRef([]), scrollableContainerElement = React12.useRef(null), tableElement = React12.useRef(null), condensedListElement = React12.useRef(null), loadingElement = React12.useRef(null), [tableInitialized, setTableInitialized] = React12.useState(!1), [stickyWrapper, setStickyWrapper] = React12.useState(null), [hideScrollContainer, setHideScrollContainer] = React12.useState(!1), tableHeadings = React12.useRef([]), stickyTableHeadings = React12.useRef([]), stickyHeaderWrapperElement = React12.useRef(null), firstStickyHeaderElement = React12.useRef(null), stickyHeaderElement = React12.useRef(null), scrollBarElement = React12.useRef(null), scrollContainerElement = React12.useRef(null), scrollingWithBar = React12.useRef(!1), scrollingContainer = React12.useRef(!1), lastSortedColumnIndex = React12.useRef(sortColumnIndex), renderAfterSelectEvent = React12.useRef(!1), lastSelectedItemsCount = React12.useRef(0), hasSelected = React12.useRef(!1);
      selectedItemsCount !== lastSelectedItemsCount.current && (renderAfterSelectEvent.current = !0, lastSelectedItemsCount.current = selectedItemsCount), !hasSelected.current && selectedItemsCount !== 0 && (hasSelected.current = !0);
      let {
        bulkActionsIntersectionRef,
        tableMeasurerRef,
        isBulkActionsSticky,
        bulkActionsAbsoluteOffset,
        bulkActionsMaxWidth,
        bulkActionsOffsetLeft,
        computeTableDimensions
      } = useIsBulkActionsSticky.useIsBulkActionsSticky(selectMode);
      React12.useEffect(() => {
        computeTableDimensions();
      }, [computeTableDimensions, itemCount]);
      let tableBodyRef = React12.useCallback((node) => {
        node !== null && !tableInitialized && setTableInitialized(!0);
      }, [tableInitialized]), handleSelectAllItemsInStore = React12.useCallback(() => {
        handleSelectionChange(selectedItemsCount === types.SELECT_ALL_ITEMS ? types.SelectionType.Page : types.SelectionType.All, !0);
      }, [handleSelectionChange, selectedItemsCount]), calculateFirstHeaderOffset = React12.useCallback(() => selectable ? condensed ? tableHeadingRects.current[0].offsetWidth : tableHeadingRects.current[0].offsetWidth + tableHeadingRects.current[1].offsetWidth : tableHeadingRects.current[0].offsetWidth, [condensed, selectable]), resizeTableHeadings = React12.useMemo(() => debounce.debounce(() => {
        if (!tableElement.current || !scrollableContainerElement.current)
          return;
        let boundingRect = scrollableContainerElement.current.getBoundingClientRect();
        tablePosition.current = {
          top: boundingRect.top,
          left: boundingRect.left
        }, tableHeadingRects.current = tableHeadings.current.map((heading) => ({
          offsetWidth: heading.offsetWidth || 0,
          offsetLeft: heading.offsetLeft || 0
        })), tableHeadings.current.length !== 0 && (selectable && tableHeadings.current.length > 1 && (tableHeadings.current[1].style.left = `${tableHeadingRects.current[0].offsetWidth}px`), stickyTableHeadings.current.forEach((heading, index) => {
          let minWidth = 0;
          index === 0 && (!isBreakpointsXS() || !selectable) ? minWidth = calculateFirstHeaderOffset() : selectable && tableHeadingRects.current.length > index ? minWidth = tableHeadingRects.current[index]?.offsetWidth || 0 : !selectable && tableHeadingRects.current.length >= index && (minWidth = tableHeadingRects.current[index - 1]?.offsetWidth || 0), heading.style.minWidth = `${minWidth}px`;
        }));
      }), [calculateFirstHeaderOffset, selectable]), resizeTableScrollBar = React12.useCallback(() => {
        scrollBarElement.current && tableElement.current && tableInitialized && (scrollBarElement.current.style.setProperty("--pc-index-table-scroll-bar-content-width", `${tableElement.current.offsetWidth - SCROLL_BAR_PADDING}px`), setHideScrollContainer(scrollContainerElement.current?.offsetWidth === tableElement.current?.offsetWidth));
      }, [tableInitialized]), debounceResizeTableScrollbar = React12.useCallback(debounce.debounce(resizeTableScrollBar, SCROLL_BAR_DEBOUNCE_PERIOD, {
        trailing: !0
      }), [resizeTableScrollBar]), [canScrollRight, setCanScrollRight] = React12.useState(!0), handleCanScrollRight = React12.useCallback(debounce.debounce(() => {
        if (!lastColumnSticky || !tableElement.current || !scrollableContainerElement.current)
          return;
        let tableRect = tableElement.current.getBoundingClientRect(), scrollableRect = scrollableContainerElement.current.getBoundingClientRect();
        setCanScrollRight(tableRect.width > scrollableRect.width);
      }), [lastColumnSticky]);
      React12.useEffect(() => {
        handleCanScrollRight();
      }, [handleCanScrollRight]);
      let [canFitStickyColumn, setCanFitStickyColumn] = React12.useState(!0), handleCanFitStickyColumn = React12.useCallback(() => {
        if (!scrollableContainerElement.current || !tableHeadings.current.length)
          return;
        let scrollableRect = scrollableContainerElement.current.getBoundingClientRect(), checkboxColumnWidth = selectable ? tableHeadings.current[0].getBoundingClientRect().width : 0, firstStickyColumnWidth = tableHeadings.current[selectable ? 1 : 0].getBoundingClientRect().width, lastColumnIsNotTheFirst = selectable ? tableHeadings.current.length > 2 : 1, lastStickyColumnWidth = lastColumnSticky && lastColumnIsNotTheFirst ? tableHeadings.current[tableHeadings.current.length - 1].getBoundingClientRect().width : 0, restOfContentMinWidth = 100;
        setCanFitStickyColumn(scrollableRect.width > firstStickyColumnWidth + checkboxColumnWidth + lastStickyColumnWidth + restOfContentMinWidth);
      }, [lastColumnSticky, selectable]);
      React12.useEffect(() => {
        tableInitialized && handleCanFitStickyColumn();
      }, [handleCanFitStickyColumn, tableInitialized]);
      let handleResize = React12.useCallback(() => {
        scrollBarElement.current?.style.setProperty("--pc-index-table-scroll-bar-content-width", "0px"), resizeTableHeadings(), debounceResizeTableScrollbar(), handleCanScrollRight(), handleCanFitStickyColumn();
      }, [resizeTableHeadings, debounceResizeTableScrollbar, handleCanScrollRight, handleCanFitStickyColumn]), handleScrollContainerScroll = React12.useCallback((canScrollLeft, canScrollRight2) => {
        !scrollableContainerElement.current || !scrollBarElement.current || (scrollingWithBar.current || (scrollingContainer.current = !0, scrollBarElement.current.scrollLeft = scrollableContainerElement.current.scrollLeft), scrollingWithBar.current = !1, stickyHeaderElement.current && (stickyHeaderElement.current.scrollLeft = scrollableContainerElement.current.scrollLeft), (canScrollLeft && !hasMoreLeftColumns || !canScrollLeft && hasMoreLeftColumns) && toggleHasMoreLeftColumns(), setCanScrollRight(canScrollRight2));
      }, [hasMoreLeftColumns, toggleHasMoreLeftColumns]), handleScrollBarScroll = React12.useCallback(() => {
        !scrollableContainerElement.current || !scrollBarElement.current || (scrollingContainer.current || (scrollingWithBar.current = !0, scrollableContainerElement.current.scrollLeft = scrollBarElement.current.scrollLeft), scrollingContainer.current = !1);
      }, []);
      useIsomorphicLayoutEffect.useIsomorphicLayoutEffect(() => {
        tableHeadings.current = utilities.getTableHeadingsBySelector(tableElement.current, "[data-index-table-heading]"), stickyTableHeadings.current = utilities.getTableHeadingsBySelector(stickyHeaderWrapperElement.current, "[data-index-table-sticky-heading]"), resizeTableHeadings();
      }, [headings, resizeTableHeadings, firstStickyHeaderElement, tableInitialized]), React12.useEffect(() => {
        resizeTableScrollBar(), setStickyWrapper(condensed ? condensedListElement.current : tableElement.current);
      }, [tableInitialized, resizeTableScrollBar, condensed]);
      let hasBulkActions = !!(promotedBulkActions && promotedBulkActions.length > 0 || bulkActions && bulkActions.length > 0), headingsMarkup = headings.map(renderHeading).reduce((acc, heading) => acc.concat(heading), []), bulkActionsSelectable = promotedBulkActions.length > 0 || bulkActions.length > 0, stickyColumnHeaderStyle = tableHeadingRects.current && tableHeadingRects.current.length > 0 ? {
        minWidth: calculateFirstHeaderOffset()
      } : void 0, stickyColumnHeader = /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(IndexTable_module.default.TableHeading, selectable && IndexTable_module.default["TableHeading-first"], headings[0].flush && IndexTable_module.default["TableHeading-flush"]),
        key: getHeadingKey(headings[0]),
        style: stickyColumnHeaderStyle,
        "data-index-table-sticky-heading": !0
      }, /* @__PURE__ */ React12.createElement(LegacyStack.LegacyStack, {
        spacing: "none",
        wrap: !1,
        alignment: "center"
      }, selectable && /* @__PURE__ */ React12.createElement("div", {
        className: IndexTable_module.default.FirstStickyHeaderElement,
        ref: firstStickyHeaderElement
      }, renderCheckboxContent()), selectable && /* @__PURE__ */ React12.createElement("div", {
        className: IndexTable_module.default["StickyTableHeading-second-scrolling"]
      }, renderHeadingContent(headings[0], 0)), !selectable && /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(IndexTable_module.default.FirstStickyHeaderElement),
        ref: firstStickyHeaderElement
      }, renderHeadingContent(headings[0], 0)))), stickyHeadingsMarkup = headings.map(renderStickyHeading), selectedItemsCountLabel = selectedItemsCount === types.SELECT_ALL_ITEMS ? `${itemCount}+` : selectedItemsCount, handleTogglePage = React12.useCallback(() => {
        handleSelectionChange(types.SelectionType.Page, !bulkSelectState || bulkSelectState === "indeterminate");
      }, [bulkSelectState, handleSelectionChange]), paginatedSelectAllAction = getPaginatedSelectAllAction(), loadingTransitionClassNames = {
        enter: IndexTable_module.default["LoadingContainer-enter"],
        enterActive: IndexTable_module.default["LoadingContainer-enter-active"],
        exit: IndexTable_module.default["LoadingContainer-exit"],
        exitActive: IndexTable_module.default["LoadingContainer-exit-active"]
      }, loadingMarkup = /* @__PURE__ */ React12.createElement(reactTransitionGroup.CSSTransition, {
        in: loading,
        classNames: loadingTransitionClassNames,
        timeout: parseInt(theme.motion["motion-duration-100"], 10),
        nodeRef: loadingElement,
        appear: !0,
        unmountOnExit: !0
      }, /* @__PURE__ */ React12.createElement("div", {
        className: IndexTable_module.default.LoadingPanel,
        ref: loadingElement
      }, /* @__PURE__ */ React12.createElement("div", {
        className: IndexTable_module.default.LoadingPanelRow
      }, /* @__PURE__ */ React12.createElement(Spinner.Spinner, {
        size: "small"
      }), /* @__PURE__ */ React12.createElement("span", {
        className: IndexTable_module.default.LoadingPanelText
      }, i18n.translate("Polaris.IndexTable.resourceLoadingAccessibilityLabel", {
        resourceNamePlural: resourceName.plural.toLocaleLowerCase()
      }))))), stickyTableClassNames = css.classNames(IndexTable_module.default.StickyTable, condensed && IndexTable_module.default["StickyTable-condensed"]), shouldShowBulkActions = bulkActionsSelectable && selectedItemsCount, bulkActionClassNames = css.classNames(IndexTable_module.default.BulkActionsWrapper, isBulkActionsSticky && IndexTable_module.default.BulkActionsWrapperSticky), shouldShowActions = !condensed || selectedItemsCount, promotedActions = shouldShowActions ? promotedBulkActions : [], actions = shouldShowActions ? bulkActions : [], bulkActionsMarkup = shouldShowBulkActions && !condensed ? /* @__PURE__ */ React12.createElement("div", {
        className: bulkActionClassNames,
        style: {
          insetBlockStart: isBulkActionsSticky ? void 0 : bulkActionsAbsoluteOffset,
          width: bulkActionsMaxWidth,
          insetInlineStart: isBulkActionsSticky ? bulkActionsOffsetLeft : void 0
        }
      }, /* @__PURE__ */ React12.createElement(BulkActions.BulkActions, {
        selectMode,
        promotedActions,
        actions,
        onSelectModeToggle: condensed ? handleSelectModeToggle : void 0,
        isSticky: isBulkActionsSticky,
        width: bulkActionsMaxWidth
      })) : null, stickyHeaderMarkup = /* @__PURE__ */ React12.createElement("div", {
        className: stickyTableClassNames,
        role: "presentation"
      }, /* @__PURE__ */ React12.createElement(Sticky.Sticky, {
        boundingElement: stickyWrapper
      }, (isSticky) => {
        let stickyHeaderClassNames = css.classNames(IndexTable_module.default.StickyTableHeader, isSticky && IndexTable_module.default["StickyTableHeader-isSticky"]), selectAllActionsClassName = css.classNames(IndexTable_module.default.SelectAllActionsWrapper, condensed && IndexTable_module.default["StickyTableHeader-condensed"], isSticky && IndexTable_module.default["StickyTableHeader-isSticky"]), selectAllActionsMarkup = shouldShowBulkActions && !condensed ? /* @__PURE__ */ React12.createElement("div", {
          className: selectAllActionsClassName
        }, /* @__PURE__ */ React12.createElement(SelectAllActions.SelectAllActions, {
          label: i18n.translate("Polaris.IndexTable.selected", {
            selectedItemsCount: selectedItemsCountLabel
          }),
          accessibilityLabel: bulkActionsAccessibilityLabel,
          selected: bulkSelectState,
          selectMode,
          onToggleAll: handleTogglePage,
          paginatedSelectAllText,
          paginatedSelectAllAction
        }), loadingMarkup) : null, headerMarkup = condensed ? /* @__PURE__ */ React12.createElement("div", {
          className: css.classNames(IndexTable_module.default.HeaderWrapper, (!selectable || condensed) && IndexTable_module.default.unselectable)
        }, loadingMarkup, sort2) : /* @__PURE__ */ React12.createElement("div", {
          className: stickyHeaderClassNames,
          ref: stickyHeaderWrapperElement
        }, loadingMarkup, /* @__PURE__ */ React12.createElement("div", {
          className: IndexTable_module.default.StickyTableColumnHeader
        }, stickyColumnHeader), /* @__PURE__ */ React12.createElement("div", {
          className: IndexTable_module.default.StickyTableHeadings,
          ref: stickyHeaderElement
        }, stickyHeadingsMarkup));
        return selectAllActionsMarkup ?? headerMarkup;
      }), bulkActionsMarkup), scrollBarWrapperClassNames = css.classNames(IndexTable_module.default.ScrollBarContainer, condensed && IndexTable_module.default.scrollBarContainerCondensed, hideScrollContainer && IndexTable_module.default.scrollBarContainerHidden), scrollBarClassNames = css.classNames(tableElement.current && tableInitialized && IndexTable_module.default.ScrollBarContent), scrollBarMarkup = itemCount > 0 ? /* @__PURE__ */ React12.createElement(AfterInitialMount.AfterInitialMount, {
        onMount: resizeTableScrollBar
      }, /* @__PURE__ */ React12.createElement("div", {
        className: scrollBarWrapperClassNames,
        ref: scrollContainerElement
      }, /* @__PURE__ */ React12.createElement("div", {
        onScroll: handleScrollBarScroll,
        className: IndexTable_module.default.ScrollBar,
        ref: scrollBarElement
      }, /* @__PURE__ */ React12.createElement("div", {
        className: scrollBarClassNames
      })))) : null, isSortable = sortable?.some((value) => value), tableClassNames = css.classNames(IndexTable_module.default.Table, hasMoreLeftColumns && IndexTable_module.default["Table-scrolling"], selectMode && IndexTable_module.default.disableTextSelection, selectMode && shouldShowBulkActions && IndexTable_module.default.selectMode, !selectable && IndexTable_module.default["Table-unselectable"], canFitStickyColumn && IndexTable_module.default["Table-sticky"], isSortable && IndexTable_module.default["Table-sortable"], canFitStickyColumn && lastColumnSticky && IndexTable_module.default["Table-sticky-last"], canFitStickyColumn && lastColumnSticky && canScrollRight && IndexTable_module.default["Table-sticky-scrolling"], hasZebraStriping && IndexTable_module.default.ZebraStriping), emptyStateMarkup = emptyState || /* @__PURE__ */ React12.createElement(EmptySearchResult.EmptySearchResult, {
        title: i18n.translate("Polaris.IndexTable.emptySearchTitle", {
          resourceNamePlural: resourceName.plural
        }),
        description: i18n.translate("Polaris.IndexTable.emptySearchDescription"),
        withIllustration: !0
      }), sharedMarkup = /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
        event: "resize",
        handler: handleResize
      }), /* @__PURE__ */ React12.createElement(AfterInitialMount.AfterInitialMount, null, stickyHeaderMarkup)), condensedClassNames = css.classNames(IndexTable_module.default.CondensedList, hasZebraStriping && IndexTable_module.default.ZebraStriping), bodyMarkup = condensed ? /* @__PURE__ */ React12.createElement(React12.Fragment, null, sharedMarkup, /* @__PURE__ */ React12.createElement("ul", {
        "data-selectmode": !!selectMode,
        className: condensedClassNames,
        ref: condensedListElement
      }, children)) : /* @__PURE__ */ React12.createElement(React12.Fragment, null, sharedMarkup, /* @__PURE__ */ React12.createElement(ScrollContainer.ScrollContainer, {
        scrollableContainerRef: scrollableContainerElement,
        onScroll: handleScrollContainerScroll
      }, /* @__PURE__ */ React12.createElement("table", {
        ref: tableElement,
        className: tableClassNames
      }, /* @__PURE__ */ React12.createElement("thead", null, /* @__PURE__ */ React12.createElement("tr", {
        className: IndexTable_module.default.HeadingRow
      }, headingsMarkup)), /* @__PURE__ */ React12.createElement("tbody", {
        ref: tableBodyRef
      }, children)))), tableContentMarkup = itemCount > 0 ? bodyMarkup : /* @__PURE__ */ React12.createElement("div", {
        className: IndexTable_module.default.EmptySearchResultWrapper
      }, emptyStateMarkup), tableWrapperClassNames = css.classNames(IndexTable_module.default.IndexTableWrapper, hideScrollContainer && IndexTable_module.default["IndexTableWrapper-scrollBarHidden"], !!bulkActionsMarkup && selectMode && IndexTable_module.default.IndexTableWrapperWithBulkActions);
      return /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement("div", {
        className: IndexTable_module.default.IndexTable
      }, /* @__PURE__ */ React12.createElement("div", {
        className: tableWrapperClassNames,
        ref: tableMeasurerRef
      }, !shouldShowBulkActions && !condensed && loadingMarkup, tableContentMarkup), /* @__PURE__ */ React12.createElement("div", {
        ref: bulkActionsIntersectionRef
      })), scrollBarMarkup);
      function renderHeading(heading, index) {
        let isSecond = index === 0, isLast = index === headings.length - 1, hasSortable = sortable?.some((value) => value === !0), headingAlignment = heading.alignment || "start", headingContentClassName = css.classNames(IndexTable_module.default.TableHeading, headingAlignment === "center" && IndexTable_module.default["TableHeading-align-center"], headingAlignment === "end" && IndexTable_module.default["TableHeading-align-end"], hasSortable && IndexTable_module.default["TableHeading-sortable"], isSecond && IndexTable_module.default["TableHeading-second"], isLast && !heading.hidden && IndexTable_module.default["TableHeading-last"], !selectable && IndexTable_module.default["TableHeading-unselectable"], heading.flush && IndexTable_module.default["TableHeading-flush"]), stickyPositioningStyle = selectable !== !1 && isSecond && tableHeadingRects.current && tableHeadingRects.current.length > 0 ? {
          left: tableHeadingRects.current[0].offsetWidth
        } : void 0, headingContent = /* @__PURE__ */ React12.createElement("th", {
          id: heading.id,
          className: headingContentClassName,
          key: getHeadingKey(heading),
          "data-index-table-heading": !0,
          style: stickyPositioningStyle
        }, renderHeadingContent(heading, index));
        if (index !== 0 || !selectable)
          return headingContent;
        let checkboxClassName = css.classNames(IndexTable_module.default.TableHeading, hasSortable && IndexTable_module.default["TableHeading-sortable"], index === 0 && IndexTable_module.default["TableHeading-first"]);
        return [/* @__PURE__ */ React12.createElement("th", {
          className: checkboxClassName,
          key: `${heading}-${index}`,
          "data-index-table-heading": !0
        }, renderCheckboxContent()), headingContent];
      }
      function renderCheckboxContent() {
        return /* @__PURE__ */ React12.createElement("div", {
          className: IndexTable_module.default.ColumnHeaderCheckboxWrapper
        }, /* @__PURE__ */ React12.createElement(Checkbox.Checkbox, {
          label: i18n.translate("Polaris.IndexTable.selectAllLabel", {
            resourceNamePlural: resourceName.plural
          }),
          labelHidden: !0,
          onChange: handleSelectPage,
          checked: bulkSelectState
        }));
      }
      function handleSortHeadingClick(index, direction) {
        renderAfterSelectEvent.current = !1, hasSelected.current = !1, lastSortedColumnIndex.current = sortColumnIndex, onSort?.(index, direction);
      }
      function renderHeadingContent(heading, index) {
        let headingContent, defaultTooltipProps = {
          width: heading.tooltipWidth ?? "default",
          activatorWrapper: "div",
          dismissOnMouseOut: !0,
          persistOnClick: heading.tooltipPersistsOnClick
        }, defaultHeaderTooltipProps = {
          ...defaultTooltipProps,
          padding: "400",
          borderRadius: "200",
          content: heading.tooltipContent,
          preferredPosition: "above"
        };
        heading.new ? headingContent = /* @__PURE__ */ React12.createElement(LegacyStack.LegacyStack, {
          wrap: !1,
          alignment: "center"
        }, /* @__PURE__ */ React12.createElement("span", null, heading.title), /* @__PURE__ */ React12.createElement(Badge2.Badge, {
          tone: "new"
        }, i18n.translate("Polaris.IndexTable.onboardingBadgeText"))) : heading.hidden ? headingContent = /* @__PURE__ */ React12.createElement(Text4.Text, {
          as: "span",
          visuallyHidden: !0
        }, heading.title) : headingContent = heading.title;
        let style = {
          "--pc-index-table-heading-extra-padding-right": heading.paddingBlockEnd ? `var(--p-space-${heading.paddingBlockEnd})` : "0"
        };
        if (sortable?.[index]) {
          let isCurrentlySorted = index === sortColumnIndex, isPreviouslySorted = !isCurrentlySorted && index === lastSortedColumnIndex.current, isRenderAfterSelectEvent = renderAfterSelectEvent.current || !hasSelected.current && selectedItemsCount !== 0, isAscending = sortDirection === "ascending", newDirection = heading.defaultSortDirection ?? defaultSortDirection, SourceComponent = newDirection === "ascending" ? polarisIcons.SortAscendingIcon : polarisIcons.SortDescendingIcon;
          isCurrentlySorted && (newDirection = isAscending ? "descending" : "ascending", SourceComponent = sortDirection === "ascending" ? polarisIcons.SortAscendingIcon : polarisIcons.SortDescendingIcon);
          let iconMarkup = /* @__PURE__ */ React12.createElement("span", {
            className: css.classNames(IndexTable_module.default.TableHeadingSortIcon, heading?.alignment === "end" && IndexTable_module.default["TableHeadingSortIcon-heading-align-end"], isCurrentlySorted && IndexTable_module.default["TableHeadingSortIcon-visible"])
          }, /* @__PURE__ */ React12.createElement(SourceComponent, {
            focusable: "false",
            "aria-hidden": "true",
            className: IndexTable_module.default.TableHeadingSortSvg
          })), defaultSortButtonProps = {
            onClick: () => handleSortHeadingClick(index, newDirection),
            className: css.classNames(IndexTable_module.default.TableHeadingSortButton, !isCurrentlySorted && heading?.alignment === "end" && IndexTable_module.default["TableHeadingSortButton-heading-align-end"], isCurrentlySorted && heading?.alignment === "end" && IndexTable_module.default["TableHeadingSortButton-heading-align-end-currently-sorted"], isPreviouslySorted && !isRenderAfterSelectEvent && heading?.alignment === "end" && IndexTable_module.default["TableHeadingSortButton-heading-align-end-previously-sorted"]),
            tabIndex: selectMode ? -1 : 0
          }, sortMarkup = /* @__PURE__ */ React12.createElement(UnstyledButton.UnstyledButton, defaultSortButtonProps, iconMarkup, /* @__PURE__ */ React12.createElement("span", {
            className: css.classNames(sortToggleLabels && selectMode && heading.tooltipContent && IndexTable_module.default.TableHeadingTooltipUnderlinePlaceholder)
          }, headingContent));
          if (!sortToggleLabels || selectMode)
            return /* @__PURE__ */ React12.createElement("div", {
              className: IndexTable_module.default.SortableTableHeadingWithCustomMarkup
            }, sortMarkup);
          let tooltipDirection = isCurrentlySorted ? sortDirection : newDirection, sortTooltipContent = sortToggleLabels[index][tooltipDirection];
          if (!heading.tooltipContent)
            return (
              // Regular header with sort icon and sort direction tooltip
              /* @__PURE__ */ React12.createElement("div", {
                style,
                className: css.classNames(heading.paddingBlockEnd && IndexTable_module.default["TableHeading-extra-padding-right"])
              }, /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, Object.assign({}, defaultTooltipProps, {
                content: sortTooltipContent,
                preferredPosition: "above"
              }), sortMarkup))
            );
          if (heading.tooltipContent)
            return (
              // Header text and sort icon have separate tooltips
              /* @__PURE__ */ React12.createElement("div", {
                className: css.classNames(IndexTable_module.default.SortableTableHeadingWithCustomMarkup, heading.paddingBlockEnd && IndexTable_module.default["TableHeading-extra-padding-right"]),
                style
              }, /* @__PURE__ */ React12.createElement(UnstyledButton.UnstyledButton, defaultSortButtonProps, /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, defaultHeaderTooltipProps, /* @__PURE__ */ React12.createElement("span", {
                className: IndexTable_module.default.TableHeadingUnderline
              }, headingContent)), /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, Object.assign({}, defaultTooltipProps, {
                content: sortTooltipContent,
                preferredPosition: "above"
              }), iconMarkup)))
            );
        }
        return heading.tooltipContent ? (
          // Non-sortable header with tooltip
          /* @__PURE__ */ React12.createElement("div", {
            style,
            className: css.classNames(heading.paddingBlockEnd && IndexTable_module.default["TableHeading-extra-padding-right"])
          }, /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, Object.assign({}, defaultHeaderTooltipProps, {
            activatorWrapper: "span"
          }), /* @__PURE__ */ React12.createElement("span", {
            className: css.classNames(IndexTable_module.default.TableHeadingUnderline, IndexTable_module.default.SortableTableHeaderWrapper)
          }, headingContent)))
        ) : /* @__PURE__ */ React12.createElement("div", {
          style,
          className: css.classNames(heading.paddingBlockEnd && IndexTable_module.default["TableHeading-extra-padding-right"])
        }, headingContent);
      }
      function handleSelectPage(checked) {
        handleSelectionChange(types.SelectionType.Page, checked);
      }
      function renderStickyHeading(heading, index) {
        let position = selectable ? index + 1 : index, headingStyle = tableHeadingRects.current && tableHeadingRects.current.length > position ? {
          minWidth: tableHeadingRects.current[position].offsetWidth
        } : void 0, headingAlignment = heading.alignment || "start", headingContent = renderHeadingContent(heading, index), stickyHeadingClassName = css.classNames(IndexTable_module.default.TableHeading, heading.flush && IndexTable_module.default["TableHeading-flush"], headingAlignment === "center" && IndexTable_module.default["TableHeading-align-center"], headingAlignment === "end" && IndexTable_module.default["TableHeading-align-end"], index === 0 && IndexTable_module.default["StickyTableHeading-second"], index === 0 && !selectable && IndexTable_module.default.unselectable);
        return /* @__PURE__ */ React12.createElement("div", {
          className: stickyHeadingClassName,
          key: getHeadingKey(heading),
          style: headingStyle,
          "data-index-table-sticky-heading": !0
        }, headingContent);
      }
      function getPaginatedSelectAllAction() {
        if (!selectable || !hasBulkActions || !hasMoreItems)
          return;
        let customActionText = paginatedSelectAllActionText ?? i18n.translate("Polaris.IndexTable.selectAllItems", {
          itemsLength: itemCount,
          resourceNamePlural: resourceName.plural.toLocaleLowerCase()
        });
        return {
          content: selectedItemsCount === types.SELECT_ALL_ITEMS ? i18n.translate("Polaris.IndexTable.undo") : customActionText,
          onAction: handleSelectAllItemsInStore
        };
      }
      function handleSelectModeToggle() {
        handleSelectionChange(types.SelectionType.All, !1);
      }
    }
    var isBreakpointsXS = () => typeof window > "u" ? !1 : window.innerWidth < parseFloat(polarisTokens.toPx(polarisTokens.themeDefault.breakpoints["breakpoints-sm"]) ?? "");
    function getHeadingKey(heading) {
      return heading.id ? heading.id : typeof heading.title == "string" ? heading.title : "";
    }
    function IndexTable({
      children,
      selectable = !0,
      itemCount,
      selectedItemsCount = 0,
      resourceName: passedResourceName,
      loading,
      hasMoreItems,
      condensed,
      onSelectionChange,
      pagination,
      ...indexTableBaseProps
    }) {
      let paginationMarkup = pagination ? /* @__PURE__ */ React12.createElement(Pagination.Pagination, Object.assign({
        type: "table"
      }, pagination)) : null;
      return /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement(IndexProvider.IndexProvider, {
        selectable: selectable && !condensed,
        itemCount,
        selectedItemsCount,
        resourceName: passedResourceName,
        loading,
        hasMoreItems,
        condensed,
        onSelectionChange
      }, /* @__PURE__ */ React12.createElement(IndexTableBase, indexTableBaseProps, children)), paginationMarkup);
    }
    IndexTable.Cell = Cell.Cell;
    IndexTable.Row = Row.Row;
    exports.IndexTable = IndexTable;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/InlineCode/InlineCode.scss.js
var require_InlineCode_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/InlineCode/InlineCode.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Code: "Polaris-InlineCode__Code"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/InlineCode/InlineCode.js
var require_InlineCode = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/InlineCode/InlineCode.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), InlineCode_module = require_InlineCode_scss(), InlineCode = ({
      children
    }) => /* @__PURE__ */ React12.createElement("code", {
      className: InlineCode_module.default.Code
    }, children);
    exports.InlineCode = InlineCode;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/KeyboardKey/KeyboardKey.scss.js
var require_KeyboardKey_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/KeyboardKey/KeyboardKey.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      KeyboardKey: "Polaris-KeyboardKey",
      small: "Polaris-KeyboardKey--small"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/KeyboardKey/KeyboardKey.js
var require_KeyboardKey = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/KeyboardKey/KeyboardKey.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), KeyboardKey_module = require_KeyboardKey_scss();
    function KeyboardKey({
      children = "",
      size
    }) {
      let key = !size && children.length > 1 ? children.toLowerCase() : children.toUpperCase(), className = css.classNames(KeyboardKey_module.default.KeyboardKey, size && KeyboardKey_module.default[size]);
      return /* @__PURE__ */ React12.createElement("kbd", {
        className
      }, key);
    }
    exports.KeyboardKey = KeyboardKey;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Layout/Layout.scss.js
var require_Layout_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Layout/Layout.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Layout: "Polaris-Layout",
      Section: "Polaris-Layout__Section",
      "Section-fullWidth": "Polaris-Layout__Section--fullWidth",
      "Section-oneHalf": "Polaris-Layout__Section--oneHalf",
      "Section-oneThird": "Polaris-Layout__Section--oneThird",
      AnnotatedSection: "Polaris-Layout__AnnotatedSection",
      AnnotationWrapper: "Polaris-Layout__AnnotationWrapper",
      AnnotationContent: "Polaris-Layout__AnnotationContent",
      Annotation: "Polaris-Layout__Annotation"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Layout/components/AnnotatedSection/AnnotatedSection.js
var require_AnnotatedSection = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Layout/components/AnnotatedSection/AnnotatedSection.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), Layout_module = require_Layout_scss(), TextContainer = require_TextContainer(), Text4 = require_Text(), Box2 = require_Box();
    function AnnotatedSection({
      children,
      title,
      description,
      id
    }) {
      let descriptionMarkup = typeof description == "string" ? /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "p",
        variant: "bodyMd"
      }, description) : description;
      return /* @__PURE__ */ React12.createElement("div", {
        className: Layout_module.default.AnnotatedSection
      }, /* @__PURE__ */ React12.createElement("div", {
        className: Layout_module.default.AnnotationWrapper
      }, /* @__PURE__ */ React12.createElement("div", {
        className: Layout_module.default.Annotation
      }, /* @__PURE__ */ React12.createElement(TextContainer.TextContainer, {
        spacing: "tight"
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        id,
        variant: "headingMd",
        as: "h2"
      }, title), descriptionMarkup && /* @__PURE__ */ React12.createElement(Box2.Box, {
        color: "text-secondary"
      }, descriptionMarkup))), /* @__PURE__ */ React12.createElement("div", {
        className: Layout_module.default.AnnotationContent
      }, children)));
    }
    exports.AnnotatedSection = AnnotatedSection;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Layout/components/Section/Section.js
var require_Section6 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Layout/components/Section/Section.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Layout_module = require_Layout_scss();
    function Section({
      children,
      variant
    }) {
      let className = css.classNames(Layout_module.default.Section, Layout_module.default[`Section-${variant}`]);
      return /* @__PURE__ */ React12.createElement("div", {
        className
      }, children);
    }
    exports.Section = Section;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Layout/Layout.js
var require_Layout = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Layout/Layout.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), Layout_module = require_Layout_scss(), AnnotatedSection = require_AnnotatedSection(), Section = require_Section6(), Layout = function({
      sectioned,
      children
    }) {
      let content = sectioned ? /* @__PURE__ */ React12.createElement(Section.Section, null, children) : children;
      return /* @__PURE__ */ React12.createElement("div", {
        className: Layout_module.default.Layout
      }, content);
    };
    Layout.AnnotatedSection = AnnotatedSection.AnnotatedSection;
    Layout.Section = Section.Section;
    exports.Layout = Layout;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyFilters/LegacyFilters.scss.js
var require_LegacyFilters_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyFilters/LegacyFilters.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      LegacyFilters: "Polaris-LegacyFilters",
      LegacyFiltersContainer: "Polaris-LegacyFilters__LegacyFiltersContainer",
      LegacyFiltersContainerHeader: "Polaris-LegacyFilters__LegacyFiltersContainerHeader",
      LegacyFiltersDesktopContainerContent: "Polaris-LegacyFilters__LegacyFiltersDesktopContainerContent",
      LegacyFiltersMobileContainerContent: "Polaris-LegacyFilters__LegacyFiltersMobileContainerContent",
      LegacyFiltersContainerFooter: "Polaris-LegacyFilters__LegacyFiltersContainerFooter",
      LegacyFiltersMobileContainerFooter: "Polaris-LegacyFilters__LegacyFiltersMobileContainerFooter",
      EmptyFooterState: "Polaris-LegacyFilters__EmptyFooterState",
      FilterTriggerContainer: "Polaris-LegacyFilters__FilterTriggerContainer",
      FilterTrigger: "Polaris-LegacyFilters__FilterTrigger",
      FilterTriggerTitle: "Polaris-LegacyFilters__FilterTriggerTitle",
      AppliedFilterBadgeContainer: "Polaris-LegacyFilters__AppliedFilterBadgeContainer",
      open: "Polaris-LegacyFilters--open",
      FilterTriggerLabelContainer: "Polaris-LegacyFilters__FilterTriggerLabelContainer",
      first: "Polaris-LegacyFilters--first",
      last: "Polaris-LegacyFilters--last",
      FilterNodeContainer: "Polaris-LegacyFilters__FilterNodeContainer",
      SearchIcon: "Polaris-LegacyFilters__SearchIcon",
      Backdrop: "Polaris-LegacyFilters__Backdrop",
      HelpText: "Polaris-LegacyFilters__HelpText",
      TagsContainer: "Polaris-LegacyFilters__TagsContainer"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/resource-list/context.js
var require_context19 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/resource-list/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), ResourceListContext = /* @__PURE__ */ React12.createContext({});
    exports.ResourceListContext = ResourceListContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyFilters/components/ConnectedFilterControl/ConnectedFilterControl.scss.js
var require_ConnectedFilterControl_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyFilters/components/ConnectedFilterControl/ConnectedFilterControl.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      ConnectedFilterControl: "Polaris-LegacyFilters-ConnectedFilterControl",
      CenterContainer: "Polaris-LegacyFilters-ConnectedFilterControl__CenterContainer",
      right: "Polaris-LegacyFilters-ConnectedFilterControl--right",
      Item: "Polaris-LegacyFilters-ConnectedFilterControl__Item",
      "Item-focused": "Polaris-LegacyFilters-ConnectedFilterControl__Item--focused",
      ProxyButtonContainer: "Polaris-LegacyFilters-ConnectedFilterControl__ProxyButtonContainer",
      RightContainer: "Polaris-LegacyFilters-ConnectedFilterControl__RightContainer",
      MoreFiltersButtonContainer: "Polaris-LegacyFilters-ConnectedFilterControl__MoreFiltersButtonContainer",
      queryFieldHidden: "Polaris-LegacyFilters-ConnectedFilterControl--queryFieldHidden",
      RightContainerWithoutMoreFilters: "Polaris-LegacyFilters-ConnectedFilterControl__RightContainerWithoutMoreFilters",
      onlyButtonVisible: "Polaris-LegacyFilters-ConnectedFilterControl--onlyButtonVisible",
      Wrapper: "Polaris-LegacyFilters-ConnectedFilterControl__Wrapper",
      AuxiliaryContainer: "Polaris-LegacyFilters-ConnectedFilterControl__AuxiliaryContainer"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyFilters/components/ConnectedFilterControl/components/Item/Item.js
var require_Item7 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyFilters/components/ConnectedFilterControl/components/Item/Item.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), useToggle = require_use_toggle(), ConnectedFilterControl_module = require_ConnectedFilterControl_scss();
    function Item({
      children
    }) {
      let {
        value: focused,
        setTrue: forceTrueFocused,
        setFalse: forceFalseFocused
      } = useToggle.useToggle(!1), className = css.classNames(ConnectedFilterControl_module.default.Item, focused && ConnectedFilterControl_module.default["Item-focused"]);
      return /* @__PURE__ */ React12.createElement("div", {
        onBlur: forceFalseFocused,
        onFocus: forceTrueFocused,
        className
      }, children);
    }
    exports.Item = Item;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyFilters/components/ConnectedFilterControl/ConnectedFilterControl.js
var require_ConnectedFilterControl = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyFilters/components/ConnectedFilterControl/ConnectedFilterControl.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), debounce = require_debounce2(), css = require_css(), ConnectedFilterControl_module = require_ConnectedFilterControl_scss(), Item = require_Item7(), EventListener = require_EventListener(), Button2 = require_Button(), Popover = require_Popover(), FILTER_FIELD_MIN_WIDTH = 150, ConnectedFilterControl = class extends React12.Component {
      constructor(...args) {
        super(...args), this.state = {
          availableWidth: 0,
          proxyButtonsWidth: {}
        }, this.container = /* @__PURE__ */ React12.createRef(), this.proxyButtonContainer = /* @__PURE__ */ React12.createRef(), this.moreFiltersButtonContainer = /* @__PURE__ */ React12.createRef(), this.handleResize = debounce.debounce(() => {
          this.measureProxyButtons(), this.measureAvailableWidth();
        }, 40, {
          leading: !0,
          trailing: !0,
          maxWait: 40
        });
      }
      componentDidMount() {
        this.handleResize();
      }
      render() {
        let {
          children,
          rightPopoverableActions,
          rightAction,
          auxiliary,
          forceShowMorefiltersButton = !0,
          queryFieldHidden
        } = this.props, actionsToRender = rightPopoverableActions != null ? this.getActionsToRender(rightPopoverableActions) : [], className = css.classNames(ConnectedFilterControl_module.default.ConnectedFilterControl, rightPopoverableActions && ConnectedFilterControl_module.default.right), shouldRenderMoreFiltersButton = forceShowMorefiltersButton || rightPopoverableActions && rightPopoverableActions.length !== actionsToRender.length, RightContainerClassName = css.classNames(ConnectedFilterControl_module.default.RightContainer, !shouldRenderMoreFiltersButton && ConnectedFilterControl_module.default.RightContainerWithoutMoreFilters, queryFieldHidden && ConnectedFilterControl_module.default.queryFieldHidden), rightMarkup = actionsToRender.length > 0 ? /* @__PURE__ */ React12.createElement("div", {
          className: RightContainerClassName
        }, this.popoverFrom(actionsToRender)) : null, moreFiltersButtonContainerClassname = css.classNames(ConnectedFilterControl_module.default.MoreFiltersButtonContainer, actionsToRender.length === 0 && ConnectedFilterControl_module.default.onlyButtonVisible), rightActionMarkup = rightAction ? /* @__PURE__ */ React12.createElement("div", {
          ref: this.moreFiltersButtonContainer,
          className: moreFiltersButtonContainerClassname
        }, shouldRenderMoreFiltersButton && /* @__PURE__ */ React12.createElement(Item.Item, null, rightAction)) : null, proxyButtonMarkup = rightPopoverableActions ? /* @__PURE__ */ React12.createElement("div", {
          className: ConnectedFilterControl_module.default.ProxyButtonContainer,
          ref: this.proxyButtonContainer,
          "aria-hidden": !0
        }, rightPopoverableActions.map((action) => /* @__PURE__ */ React12.createElement("div", {
          key: action.key,
          "data-key": action.key
        }, this.activatorButtonFrom(action, {
          proxy: !0
        })))) : null, auxMarkup = auxiliary ? /* @__PURE__ */ React12.createElement("div", {
          className: ConnectedFilterControl_module.default.AuxiliaryContainer
        }, auxiliary) : null;
        return /* @__PURE__ */ React12.createElement(React12.Fragment, null, proxyButtonMarkup, /* @__PURE__ */ React12.createElement("div", {
          className: ConnectedFilterControl_module.default.Wrapper
        }, /* @__PURE__ */ React12.createElement("div", {
          className,
          ref: this.container
        }, children ? /* @__PURE__ */ React12.createElement("div", {
          className: ConnectedFilterControl_module.default.CenterContainer
        }, /* @__PURE__ */ React12.createElement(Item.Item, null, children)) : null, rightMarkup, rightActionMarkup, /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
          event: "resize",
          handler: this.handleResize
        })), auxMarkup));
      }
      measureProxyButtons() {
        if (this.proxyButtonContainer.current) {
          let proxyButtonsWidth = {};
          this.proxyButtonContainer.current && Array.from(this.proxyButtonContainer.current.children).forEach((element) => {
            let buttonWidth = element.getBoundingClientRect().width + 78, buttonKey = element instanceof HTMLElement && element.dataset.key;
            buttonKey && (proxyButtonsWidth[buttonKey] = buttonWidth);
          }), this.setState({
            proxyButtonsWidth
          });
        }
      }
      measureAvailableWidth() {
        if (this.container.current && this.moreFiltersButtonContainer.current) {
          let containerWidth = this.container.current.getBoundingClientRect().width, moreFiltersButtonWidth = this.moreFiltersButtonContainer.current.getBoundingClientRect().width, filtersActionWidth = 0, filterFieldMinWidth = this.props.queryFieldHidden ? 0 : FILTER_FIELD_MIN_WIDTH, availableWidth = containerWidth - filterFieldMinWidth - moreFiltersButtonWidth - filtersActionWidth;
          this.setState({
            availableWidth
          });
        }
      }
      getActionsToRender(actions) {
        let remainingWidth = this.state.availableWidth, actionsToReturn = [];
        for (let i = 0; remainingWidth > 0 && i < actions.length; i++) {
          let action = actions[i], actionWidth = this.state.proxyButtonsWidth[action.key];
          if (actionWidth <= remainingWidth)
            actionsToReturn.push(action), remainingWidth -= actionWidth;
          else
            break;
        }
        return actionsToReturn;
      }
      activatorButtonFrom(action, options) {
        let id = options?.proxy ? void 0 : `Activator-${action.key}`;
        return /* @__PURE__ */ React12.createElement(Button2.Button, {
          onClick: action.onAction,
          disclosure: !0,
          disabled: this.props.disabled || action.disabled,
          id,
          size: "large"
        }, action.content);
      }
      popoverFrom(actions) {
        return actions.map((action) => /* @__PURE__ */ React12.createElement(Item.Item, {
          key: action.key
        }, /* @__PURE__ */ React12.createElement(Popover.Popover, {
          active: action.popoverOpen,
          activator: this.activatorButtonFrom(action),
          onClose: action.onAction,
          preferredAlignment: "left",
          sectioned: !0
        }, action.popoverContent)));
      }
    };
    exports.ConnectedFilterControl = ConnectedFilterControl;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyFilters/components/TagsWrapper/TagsWrapper.js
var require_TagsWrapper = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyFilters/components/TagsWrapper/TagsWrapper.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), Text4 = require_Text();
    function TagsWrapper({
      children,
      hidden
    }) {
      return hidden ? /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        visuallyHidden: !0
      }, children) : /* @__PURE__ */ React12.createElement(React12.Fragment, null, children);
    }
    exports.TagsWrapper = TagsWrapper;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tag/Tag.scss.js
var require_Tag_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tag/Tag.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Tag: "Polaris-Tag",
      disabled: "Polaris-Tag--disabled",
      clickable: "Polaris-Tag--clickable",
      linkable: "Polaris-Tag--linkable",
      removable: "Polaris-Tag--removable",
      TagText: "Polaris-Tag__TagText",
      Button: "Polaris-Tag__Button",
      Link: "Polaris-Tag__Link",
      LinkText: "Polaris-Tag__LinkText",
      segmented: "Polaris-Tag--segmented"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tag/Tag.js
var require_Tag = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Tag/Tag.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), focus = require_focus(), Tag_module = require_Tag_scss(), hooks2 = require_hooks2(), Icon = require_Icon();
    function Tag({
      children,
      disabled = !1,
      onClick,
      onRemove,
      accessibilityLabel,
      url
    }) {
      let i18n = hooks2.useI18n(), segmented = onRemove && url, className = css.classNames(Tag_module.default.Tag, disabled && Tag_module.default.disabled, onClick && Tag_module.default.clickable, onRemove && Tag_module.default.removable, url && !disabled && Tag_module.default.linkable, segmented && Tag_module.default.segmented);
      if (onClick)
        return /* @__PURE__ */ React12.createElement("button", {
          type: "button",
          disabled,
          className,
          onClick
        }, children);
      let tagTitle = accessibilityLabel;
      tagTitle || (tagTitle = typeof children == "string" ? children : void 0);
      let ariaLabel = i18n.translate("Polaris.Tag.ariaLabel", {
        children: tagTitle || ""
      }), removeButton = onRemove ? /* @__PURE__ */ React12.createElement("button", {
        type: "button",
        "aria-label": ariaLabel,
        className: css.classNames(Tag_module.default.Button, segmented && Tag_module.default.segmented),
        onClick: onRemove,
        onMouseUp: focus.handleMouseUpByBlurring,
        disabled
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.XSmallIcon
      })) : null, tagContent = url && !disabled ? /* @__PURE__ */ React12.createElement("a", {
        className: css.classNames(Tag_module.default.Link, segmented && Tag_module.default.segmented),
        href: url
      }, /* @__PURE__ */ React12.createElement("span", {
        title: tagTitle,
        className: Tag_module.default.LinkText
      }, children)) : /* @__PURE__ */ React12.createElement("span", {
        title: tagTitle,
        className: Tag_module.default.TagText
      }, children);
      return /* @__PURE__ */ React12.createElement("span", {
        className,
        "aria-disabled": disabled
      }, tagContent, removeButton);
    }
    exports.Tag = Tag;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Sheet/Sheet.scss.js
var require_Sheet_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Sheet/Sheet.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Sheet: "Polaris-Sheet",
      Container: "Polaris-Sheet__Container",
      Bottom: "Polaris-Sheet__Bottom",
      enterBottom: "Polaris-Sheet--enterBottom",
      enterBottomActive: "Polaris-Sheet--enterBottomActive",
      exitBottom: "Polaris-Sheet--exitBottom",
      exitBottomActive: "Polaris-Sheet--exitBottomActive",
      Right: "Polaris-Sheet__Right",
      enterRight: "Polaris-Sheet--enterRight",
      enterRightActive: "Polaris-Sheet--enterRightActive",
      exitRight: "Polaris-Sheet--exitRight",
      exitRightActive: "Polaris-Sheet--exitRightActive"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Sheet/Sheet.js
var require_Sheet = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Sheet/Sheet.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), reactTransitionGroup = require_cjs4(), focus = require_focus(), css = require_css(), types = require_types7(), shared = require_shared(), useTheme = require_use_theme(), Sheet_module = require_Sheet_scss(), hooks2 = require_hooks11(), Portal = require_Portal(), TrapFocus = require_TrapFocus(), KeypressListener = require_KeypressListener(), Backdrop = require_Backdrop(), BOTTOM_CLASS_NAMES = {
      enter: css.classNames(Sheet_module.default.Bottom, Sheet_module.default.enterBottom),
      enterActive: css.classNames(Sheet_module.default.Bottom, Sheet_module.default.enterBottomActive),
      exit: css.classNames(Sheet_module.default.Bottom, Sheet_module.default.exitBottom),
      exitActive: css.classNames(Sheet_module.default.Bottom, Sheet_module.default.exitBottomActive)
    }, RIGHT_CLASS_NAMES = {
      enter: css.classNames(Sheet_module.default.Right, Sheet_module.default.enterRight),
      enterActive: css.classNames(Sheet_module.default.Right, Sheet_module.default.enterRightActive),
      exit: css.classNames(Sheet_module.default.Right, Sheet_module.default.exitRight),
      exitActive: css.classNames(Sheet_module.default.Right, Sheet_module.default.exitRightActive)
    };
    function Sheet({
      children,
      open: open2,
      onClose,
      onEntered,
      onExit,
      accessibilityLabel,
      activator
    }) {
      let theme = useTheme.useTheme(), {
        isNavigationCollapsed
      } = hooks2.useMediaQuery(), container = React12.useRef(null), activatorRef = React12.useRef(null), handleClose = React12.useCallback(() => {
        onClose();
        let activatorElement = activator && isRef(activator) ? activator && activator.current : activatorRef.current;
        activatorElement && requestAnimationFrame(() => focus.focusFirstFocusableNode(activatorElement));
      }, [activator, onClose]);
      React12.useEffect(() => {
        process.env.NODE_ENV === "development" && console.warn("Deprecation: <Sheet /> is deprecated. This component might be removed in a future major version of Polaris. Use <Modal /> instead or avoid modal patterns all together.");
      }, []);
      let activatorMarkup = activator && !isRef(activator) ? /* @__PURE__ */ React12.createElement("div", {
        ref: activatorRef
      }, activator) : null;
      return /* @__PURE__ */ React12.createElement(React12.Fragment, null, activatorMarkup, /* @__PURE__ */ React12.createElement(Portal.Portal, {
        idPrefix: "sheet"
      }, /* @__PURE__ */ React12.createElement(reactTransitionGroup.CSSTransition, {
        nodeRef: container,
        classNames: isNavigationCollapsed ? BOTTOM_CLASS_NAMES : RIGHT_CLASS_NAMES,
        timeout: parseInt(theme.motion["motion-duration-300"], 10),
        in: open2,
        mountOnEnter: !0,
        unmountOnExit: !0,
        onEntered,
        onExit
      }, /* @__PURE__ */ React12.createElement("div", Object.assign({
        className: Sheet_module.default.Container
      }, shared.layer.props, shared.overlay.props, {
        ref: container
      }), /* @__PURE__ */ React12.createElement(TrapFocus.TrapFocus, {
        trapping: open2
      }, /* @__PURE__ */ React12.createElement("div", {
        role: "dialog",
        "aria-modal": !0,
        tabIndex: -1,
        className: Sheet_module.default.Sheet,
        "aria-label": accessibilityLabel
      }, children)))), /* @__PURE__ */ React12.createElement(KeypressListener.KeypressListener, {
        keyCode: types.Key.Escape,
        handler: handleClose
      }), open2 && /* @__PURE__ */ React12.createElement(Backdrop.Backdrop, {
        transparent: !0,
        onClick: handleClose
      })));
    }
    function isRef(ref) {
      return Object.prototype.hasOwnProperty.call(ref, "current");
    }
    exports.Sheet = Sheet;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyFilters/LegacyFilters.js
var require_LegacyFilters = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyFilters/LegacyFilters.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), focus = require_focus(), withinFilterContext = require_within_filter_context(), types = require_types7(), LegacyFilters_module = require_LegacyFilters_scss(), context = require_context19(), Collapsible = require_Collapsible(), ConnectedFilterControl = require_ConnectedFilterControl(), TagsWrapper = require_TagsWrapper(), Tag = require_Tag(), Sheet = require_Sheet(), hooks2 = require_hooks2(), hooks$1 = require_hooks11(), ScrollLock = require_ScrollLock(), Badge2 = require_Badge(), Text4 = require_Text(), Icon = require_Icon(), Focus = require_Focus(), Button2 = require_Button(), TextField = require_TextField(), Scrollable = require_Scrollable(), KeypressListener = require_KeypressListener(), LegacyStack = require_LegacyStack(), Suffix;
    (function(Suffix2) {
      Suffix2.Filter = "Filter", Suffix2.Shortcut = "Shortcut";
    })(Suffix || (Suffix = {}));
    var LegacyFiltersInner = class extends React12.Component {
      constructor(...args) {
        super(...args), this.state = {
          open: !1,
          readyForFocus: !1
        }, this.moreFiltersButtonContainer = /* @__PURE__ */ React12.createRef(), this.moreFiltersDoneButtonContainer = /* @__PURE__ */ React12.createRef(), this.focusNode = /* @__PURE__ */ React12.createRef(), this.closeFilters = () => {
          this.setState({
            open: !1
          }, () => {
            this.moreFiltersButtonContainer.current && focus.focusFirstFocusableNode(this.moreFiltersButtonContainer.current, !1);
          });
        }, this.toggleFilters = () => {
          this.state.open === !0 ? this.closeFilters() : this.openFilters();
        }, this.setReadyForFocus = (newState) => () => {
          this.setState({
            readyForFocus: newState
          });
        }, this.handleClearAll = () => {
          this.props.onClearAll(), this.moreFiltersDoneButtonContainer.current && focus.focusFirstFocusableNode(this.moreFiltersDoneButtonContainer.current, !1);
        };
      }
      render() {
        let {
          filters,
          queryValue,
          onQueryBlur,
          onQueryChange,
          onQueryFocus,
          focused,
          onClearAll,
          appliedFilters,
          onQueryClear,
          queryPlaceholder,
          children,
          disabled = !1,
          helpText,
          hideTags,
          hideQueryField,
          disableQueryField = !1,
          i18n,
          mediaQuery: {
            isNavigationCollapsed
          }
        } = this.props, {
          resourceName
        } = this.context, {
          open: open2,
          readyForFocus
        } = this.state, backdropMarkup = open2 ? /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement(ScrollLock.ScrollLock, null), /* @__PURE__ */ React12.createElement("div", {
          className: LegacyFilters_module.default.Backdrop,
          onClick: this.closeFilters
        })) : null, filtersContentMarkup = filters.map((filter, index) => {
          let filterIsOpen = this.state[`${filter.key}${Suffix.Filter}`] === !0, icon = filterIsOpen ? polarisIcons.ChevronUpIcon : polarisIcons.ChevronDownIcon, className = css.classNames(LegacyFilters_module.default.FilterTriggerContainer, filterIsOpen && LegacyFilters_module.default.open, index === 0 && LegacyFilters_module.default.first, filters.length !== 1 && index === filters.length - 1 && LegacyFilters_module.default.last), appliedFilterContent = this.getAppliedFilterContent(filter.key), appliedFilterBadgeMarkup = appliedFilterContent ? /* @__PURE__ */ React12.createElement("div", {
            className: LegacyFilters_module.default.AppliedFilterBadgeContainer
          }, /* @__PURE__ */ React12.createElement(Badge2.Badge, {
            tone: "new"
          }, appliedFilterContent)) : null, collapsibleID = `${filter.key}Collapsible`, buttonClassName = css.classNames(LegacyFilters_module.default.FilterTrigger);
          return /* @__PURE__ */ React12.createElement("div", {
            key: filter.key,
            className
          }, /* @__PURE__ */ React12.createElement("button", {
            onClick: () => this.toggleFilter(filter.key),
            className: buttonClassName,
            id: `${filter.key}ToggleButton`,
            type: "button",
            "aria-controls": collapsibleID,
            "aria-expanded": filterIsOpen
          }, /* @__PURE__ */ React12.createElement("div", {
            className: LegacyFilters_module.default.FilterTriggerLabelContainer
          }, /* @__PURE__ */ React12.createElement("h3", {
            className: LegacyFilters_module.default.FilterTriggerTitle
          }, /* @__PURE__ */ React12.createElement(Text4.Text, {
            as: "span",
            tone: this.props.disabled || filter.disabled ? "subdued" : void 0
          }, filter.label)), /* @__PURE__ */ React12.createElement("span", {
            className: LegacyFilters_module.default.FilterTriggerIcon
          }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
            source: icon,
            tone: "base"
          }))), appliedFilterBadgeMarkup), /* @__PURE__ */ React12.createElement(Collapsible.Collapsible, {
            id: collapsibleID,
            open: filterIsOpen,
            onAnimationEnd: this.setReadyForFocus(!0)
          }, /* @__PURE__ */ React12.createElement("div", {
            className: LegacyFilters_module.default.FilterNodeContainer
          }, /* @__PURE__ */ React12.createElement(Focus.Focus, {
            disabled: !filterIsOpen || !readyForFocus || !open2,
            root: this.focusNode
          }, this.generateFilterMarkup(filter)))));
        }), appliedFiltersCount = appliedFilters ? appliedFilters.length : 0, moreFiltersLabel = hideTags && appliedFiltersCount > 0 ? i18n.translate("Polaris.Filters.moreFiltersWithCount", {
          count: appliedFiltersCount
        }) : i18n.translate("Polaris.Filters.moreFilters"), rightActionMarkup = filters.length ? /* @__PURE__ */ React12.createElement("div", {
          ref: this.moreFiltersButtonContainer
        }, /* @__PURE__ */ React12.createElement(Button2.Button, {
          onClick: this.toggleFilters,
          disabled,
          size: "large"
        }, moreFiltersLabel)) : null, filterResourceName = resourceName || {
          singular: i18n.translate("Polaris.ResourceList.defaultItemSingular"),
          plural: i18n.translate("Polaris.ResourceList.defaultItemPlural")
        }, transformedFilters = this.transformFilters(filters), filtersControlMarkup = /* @__PURE__ */ React12.createElement(ConnectedFilterControl.ConnectedFilterControl, {
          rightPopoverableActions: transformedFilters,
          rightAction: rightActionMarkup,
          auxiliary: children,
          disabled,
          forceShowMorefiltersButton: filters.length > transformedFilters.length,
          queryFieldHidden: hideQueryField
        }, hideQueryField ? null : /* @__PURE__ */ React12.createElement(TextField.TextField, {
          placeholder: queryPlaceholder || i18n.translate("Polaris.Filters.filter", {
            resourceName: filterResourceName.plural
          }),
          onChange: onQueryChange,
          onBlur: onQueryBlur,
          onFocus: onQueryFocus,
          value: queryValue,
          focused,
          label: queryPlaceholder || i18n.translate("Polaris.Filters.filter", {
            resourceName: filterResourceName.plural
          }),
          labelHidden: !0,
          prefix: /* @__PURE__ */ React12.createElement("span", {
            className: LegacyFilters_module.default.SearchIcon
          }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
            source: polarisIcons.SearchIcon
          })),
          clearButton: !0,
          onClearButtonClick: onQueryClear,
          disabled: disabled || disableQueryField,
          autoComplete: "off"
        })), filtersContainerHeaderClassname = css.classNames(LegacyFilters_module.default.LegacyFiltersContainerHeader), filtersDesktopHeaderMarkup = /* @__PURE__ */ React12.createElement("div", {
          className: filtersContainerHeaderClassname
        }, /* @__PURE__ */ React12.createElement(Text4.Text, {
          variant: "headingLg",
          as: "h3"
        }, moreFiltersLabel), /* @__PURE__ */ React12.createElement(Button2.Button, {
          icon: polarisIcons.XSmallIcon,
          variant: "plain",
          accessibilityLabel: i18n.translate("Polaris.Filters.cancel"),
          onClick: this.closeFilters
        })), filtersMobileHeaderMarkup = /* @__PURE__ */ React12.createElement("div", {
          className: filtersContainerHeaderClassname
        }, /* @__PURE__ */ React12.createElement(Button2.Button, {
          icon: polarisIcons.XSmallIcon,
          variant: "plain",
          accessibilityLabel: i18n.translate("Polaris.Filters.cancel"),
          onClick: this.closeFilters
        }), /* @__PURE__ */ React12.createElement(Text4.Text, {
          variant: "headingLg",
          as: "h3"
        }, moreFiltersLabel), /* @__PURE__ */ React12.createElement(Button2.Button, {
          onClick: this.closeFilters,
          variant: "primary"
        }, i18n.translate("Polaris.Filters.done"))), filtersDesktopFooterClassname = css.classNames(LegacyFilters_module.default.LegacyFiltersContainerFooter), filtersDesktopFooterMarkup = /* @__PURE__ */ React12.createElement("div", {
          className: filtersDesktopFooterClassname
        }, /* @__PURE__ */ React12.createElement(Button2.Button, {
          onClick: this.handleClearAll,
          disabled: !this.hasAppliedFilters()
        }, i18n.translate("Polaris.Filters.clearAllFilters")), /* @__PURE__ */ React12.createElement("div", {
          ref: this.moreFiltersDoneButtonContainer
        }, /* @__PURE__ */ React12.createElement(Button2.Button, {
          onClick: this.closeFilters,
          variant: "primary"
        }, i18n.translate("Polaris.Filters.done")))), filtersMobileFooterMarkup = /* @__PURE__ */ React12.createElement("div", {
          className: LegacyFilters_module.default.LegacyFiltersMobileContainerFooter
        }, this.hasAppliedFilters() ? /* @__PURE__ */ React12.createElement(Button2.Button, {
          onClick: onClearAll,
          fullWidth: !0
        }, i18n.translate("Polaris.Filters.clearAllFilters")) : /* @__PURE__ */ React12.createElement("div", {
          className: LegacyFilters_module.default.EmptyFooterState
        }, /* @__PURE__ */ React12.createElement(Text4.Text, {
          tone: "subdued",
          as: "span"
        }, /* @__PURE__ */ React12.createElement("p", null, i18n.translate("Polaris.Filters.noFiltersApplied"))))), shouldHideTagsContainer = !appliedFilters || appliedFilters.length < 1, tagsMarkup = hideTags ? null : /* @__PURE__ */ React12.createElement(TagsWrapper.TagsWrapper, {
          hidden: shouldHideTagsContainer
        }, /* @__PURE__ */ React12.createElement("div", {
          className: LegacyFilters_module.default.TagsContainer,
          "aria-live": "polite"
        }, (appliedFilters || []).map((filter) => /* @__PURE__ */ React12.createElement(Tag.Tag, {
          key: filter.key,
          onRemove: () => {
            filter.onRemove(filter.key);
          },
          disabled
        }, filter.label)))), filtersMobileContainerContentClassName = css.classNames(LegacyFilters_module.default.LegacyFiltersMobileContainerContent), filtersDesktopContainerContentClassName = css.classNames(LegacyFilters_module.default.LegacyFiltersDesktopContainerContent), filtersContainerMarkup = isNavigationCollapsed ? /* @__PURE__ */ React12.createElement(Sheet.Sheet, {
          accessibilityLabel: moreFiltersLabel,
          open: open2,
          onClose: this.closeFilters,
          onEntered: this.setReadyForFocus(!0),
          onExit: this.setReadyForFocus(!1)
        }, filtersMobileHeaderMarkup, /* @__PURE__ */ React12.createElement(Scrollable.Scrollable, {
          className: filtersMobileContainerContentClassName,
          shadow: !0
        }, filtersContentMarkup, filtersMobileFooterMarkup)) : /* @__PURE__ */ React12.createElement(Sheet.Sheet, {
          accessibilityLabel: moreFiltersLabel,
          open: open2,
          onClose: this.closeFilters,
          onEntered: this.setReadyForFocus(!0),
          onExit: this.setReadyForFocus(!1)
        }, /* @__PURE__ */ React12.createElement("div", {
          className: LegacyFilters_module.default.LegacyFiltersContainer
        }, filtersDesktopHeaderMarkup, /* @__PURE__ */ React12.createElement(Scrollable.Scrollable, {
          className: filtersDesktopContainerContentClassName,
          shadow: !0
        }, filtersContentMarkup), filtersDesktopFooterMarkup)), helpTextMarkup = helpText ? /* @__PURE__ */ React12.createElement("div", {
          id: "FiltersHelpText",
          className: LegacyFilters_module.default.HelpText
        }, /* @__PURE__ */ React12.createElement(Text4.Text, {
          tone: "subdued",
          as: "span"
        }, helpText)) : null;
        return /* @__PURE__ */ React12.createElement(withinFilterContext.WithinFilterContext.Provider, {
          value: !0
        }, /* @__PURE__ */ React12.createElement("div", {
          className: LegacyFilters_module.default.LegacyFilters
        }, filtersControlMarkup, filtersContainerMarkup, tagsMarkup, helpTextMarkup, backdropMarkup, /* @__PURE__ */ React12.createElement(KeypressListener.KeypressListener, {
          keyCode: types.Key.Escape,
          handler: this.closeFilters
        })));
      }
      hasAppliedFilters() {
        let {
          appliedFilters,
          queryValue
        } = this.props;
        return !!(appliedFilters && appliedFilters.length > 0) || !!(queryValue && queryValue !== "");
      }
      getAppliedFilterContent(key) {
        let {
          appliedFilters
        } = this.props;
        if (!appliedFilters)
          return;
        let filter = appliedFilters.find((filter2) => filter2.key === key);
        return filter?.label;
      }
      getAppliedFilterRemoveHandler(key) {
        let {
          appliedFilters
        } = this.props;
        if (!appliedFilters)
          return;
        let filter = appliedFilters.find((filter2) => filter2.key === key);
        return filter?.onRemove;
      }
      openFilters() {
        this.setState({
          open: !0
        });
      }
      toggleFilter(key) {
        this.state[`${key}${Suffix.Filter}`] === !0 ? this.setState({
          readyForFocus: !1,
          [`${key}${Suffix.Filter}`]: !1
        }) : this.setState({
          readyForFocus: !1,
          [`${key}${Suffix.Filter}`]: !0
        });
      }
      openFilterShortcut(key) {
        this.setState({
          [`${key}${Suffix.Shortcut}`]: !0
        });
      }
      closeFilterShortcut(key) {
        this.setState({
          [`${key}${Suffix.Shortcut}`]: !1
        });
      }
      toggleFilterShortcut(key) {
        this.state[`${key}${Suffix.Shortcut}`] === !0 ? this.closeFilterShortcut(key) : this.openFilterShortcut(key);
      }
      transformFilters(filters) {
        let transformedActions = [];
        return getShortcutFilters(filters).forEach((filter) => {
          let {
            key,
            label,
            disabled
          } = filter;
          transformedActions.push({
            popoverContent: this.generateFilterMarkup(filter),
            popoverOpen: !!this.state[`${key}${Suffix.Shortcut}`],
            key,
            content: label,
            disabled,
            onAction: () => this.toggleFilterShortcut(key)
          });
        }), transformedActions;
      }
      generateFilterMarkup(filter) {
        let i18n = this.props.i18n, removeCallback = this.getAppliedFilterRemoveHandler(filter.key), removeHandler = removeCallback == null ? void 0 : () => {
          removeCallback(filter.key);
        }, clearButtonMarkup = !filter.hideClearButton && /* @__PURE__ */ React12.createElement(Button2.Button, {
          variant: "plain",
          disabled: removeHandler == null,
          onClick: removeHandler,
          accessibilityLabel: i18n.translate("Polaris.Filters.clearLabel", {
            filterName: filter.label
          })
        }, i18n.translate("Polaris.Filters.clear"));
        return /* @__PURE__ */ React12.createElement("div", {
          ref: this.focusNode
        }, /* @__PURE__ */ React12.createElement(LegacyStack.LegacyStack, {
          vertical: !0,
          spacing: "tight"
        }, filter.filter, clearButtonMarkup));
      }
    };
    LegacyFiltersInner.contextType = context.ResourceListContext;
    function getShortcutFilters(filters) {
      return filters.filter((filter) => filter.shortcut === !0);
    }
    function LegacyFilters(props) {
      let i18n = hooks2.useI18n(), mediaQuery = hooks$1.useMediaQuery();
      return /* @__PURE__ */ React12.createElement(LegacyFiltersInner, Object.assign({}, props, {
        i18n,
        mediaQuery
      }));
    }
    exports.LegacyFilters = LegacyFilters;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyTabs/utilities.js
var require_utilities9 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyTabs/utilities.js"(exports) {
    "use strict";
    init_cjs_shims();
    function getVisibleAndHiddenTabIndices(tabs, selected, disclosureWidth, tabWidths, containerWidth) {
      let sumTabWidths = tabWidths.reduce((sum, width) => sum + width, 0), arrayOfTabIndices = tabs.map((_2, index) => index), visibleTabs = [], hiddenTabs = [];
      if (containerWidth > sumTabWidths)
        visibleTabs.push(...arrayOfTabIndices);
      else {
        visibleTabs.push(selected);
        let tabListWidth = tabWidths[selected];
        arrayOfTabIndices.forEach((currentTabIndex) => {
          if (currentTabIndex !== selected) {
            let currentTabWidth = tabWidths[currentTabIndex];
            if (tabListWidth + currentTabWidth >= containerWidth - disclosureWidth) {
              hiddenTabs.push(currentTabIndex);
              return;
            }
            visibleTabs.push(currentTabIndex), tabListWidth += currentTabWidth;
          }
        });
      }
      return {
        visibleTabs,
        hiddenTabs
      };
    }
    exports.getVisibleAndHiddenTabIndices = getVisibleAndHiddenTabIndices;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyTabs/LegacyTabs.scss.js
var require_LegacyTabs_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyTabs/LegacyTabs.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      LegacyTabs: "Polaris-LegacyTabs",
      fitted: "Polaris-LegacyTabs--fitted",
      TabContainer: "Polaris-LegacyTabs__TabContainer",
      Title: "Polaris-LegacyTabs__Title",
      fillSpace: "Polaris-LegacyTabs--fillSpace",
      Tab: "Polaris-LegacyTabs__Tab",
      "Tab-selected": "Polaris-LegacyTabs__Tab--selected",
      titleWithIcon: "Polaris-LegacyTabs--titleWithIcon",
      Panel: "Polaris-LegacyTabs__Panel",
      "Panel-hidden": "Polaris-LegacyTabs__Panel--hidden",
      Item: "Polaris-LegacyTabs__Item",
      DisclosureTab: "Polaris-LegacyTabs__DisclosureTab",
      "DisclosureTab-visible": "Polaris-LegacyTabs__DisclosureTab--visible",
      DisclosureActivator: "Polaris-LegacyTabs__DisclosureActivator",
      TabMeasurer: "Polaris-LegacyTabs__TabMeasurer"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyTabs/components/Panel/Panel.js
var require_Panel2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyTabs/components/Panel/Panel.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), LegacyTabs_module = require_LegacyTabs_scss();
    function Panel({
      hidden,
      id,
      tabID,
      children
    }) {
      let className = css.classNames(LegacyTabs_module.default.Panel, hidden && LegacyTabs_module.default["Panel-hidden"]);
      return /* @__PURE__ */ React12.createElement("div", {
        className,
        id,
        role: "tabpanel",
        "aria-labelledby": tabID,
        tabIndex: -1
      }, children);
    }
    exports.Panel = Panel;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyTabs/components/Tab/Tab.js
var require_Tab2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyTabs/components/Tab/Tab.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), focus = require_focus(), LegacyTabs_module = require_LegacyTabs_scss(), UnstyledLink = require_UnstyledLink();
    function Tab({
      id,
      focused,
      siblingTabHasFocus,
      children,
      onClick,
      selected,
      url,
      panelID,
      measuring,
      accessibilityLabel
    }) {
      let wasSelected = React12.useRef(selected), panelFocused = React12.useRef(!1), node = React12.useRef(null);
      React12.useEffect(() => {
        if (measuring)
          return;
        (focused || document.activeElement && document.activeElement.id === id) && selected && panelID != null && !panelFocused.current && (focusPanelID(panelID), panelFocused.current = !0), selected && !wasSelected.current && panelID != null ? focusPanelID(panelID) : focused && node.current != null && focus.focusFirstFocusableNode(node.current), wasSelected.current = selected;
      }, [focused, id, measuring, panelID, selected]);
      let handleClick = onClick && onClick.bind(null, id), className = css.classNames(LegacyTabs_module.default.Tab, selected && LegacyTabs_module.default["Tab-selected"]), tabIndex;
      selected && !siblingTabHasFocus && !measuring || focused && !measuring ? tabIndex = 0 : tabIndex = -1;
      let tabContainerClassNames = css.classNames(LegacyTabs_module.default.TabContainer, selected && LegacyTabs_module.default.Underline), markup = url ? /* @__PURE__ */ React12.createElement(UnstyledLink.UnstyledLink, {
        id,
        url,
        role: "tab",
        tabIndex,
        onClick: handleClick,
        className,
        "aria-selected": selected,
        "aria-controls": panelID,
        "aria-label": accessibilityLabel,
        onMouseUp: focus.handleMouseUpByBlurring
      }, /* @__PURE__ */ React12.createElement("span", {
        className: LegacyTabs_module.default.Title
      }, children)) : /* @__PURE__ */ React12.createElement("button", {
        id,
        role: "tab",
        type: "button",
        tabIndex,
        className,
        onClick: handleClick,
        "aria-selected": selected,
        "aria-controls": panelID,
        "aria-label": accessibilityLabel,
        onMouseUp: focus.handleMouseUpByBlurring
      }, /* @__PURE__ */ React12.createElement("span", {
        className: LegacyTabs_module.default.Title
      }, children));
      return /* @__PURE__ */ React12.createElement("li", {
        className: tabContainerClassNames,
        ref: node,
        role: "presentation"
      }, markup);
    }
    function focusPanelID(panelID) {
      let panel = document.getElementById(panelID);
      panel && panel.focus({
        preventScroll: !0
      });
    }
    exports.Tab = Tab;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyTabs/components/TabMeasurer/TabMeasurer.js
var require_TabMeasurer2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyTabs/components/TabMeasurer/TabMeasurer.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), useComponentDidMount = require_use_component_did_mount(), LegacyTabs_module = require_LegacyTabs_scss(), Tab = require_Tab2(), EventListener = require_EventListener(), TabMeasurer = /* @__PURE__ */ React12.memo(function({
      selected,
      tabs,
      activator,
      tabToFocus,
      siblingTabHasFocus,
      handleMeasurement: handleMeasurementProp
    }) {
      let containerNode = React12.useRef(null), animationFrame = React12.useRef(null), handleMeasurement = React12.useCallback(() => {
        animationFrame.current && cancelAnimationFrame(animationFrame.current), animationFrame.current = requestAnimationFrame(() => {
          if (!containerNode.current)
            return;
          let containerWidth = containerNode.current.offsetWidth, hiddenTabNodes = containerNode.current.children, hiddenTabWidths = Array.from(hiddenTabNodes).map((node) => Math.ceil(node.getBoundingClientRect().width)), disclosureWidth = hiddenTabWidths.pop() || 0;
          handleMeasurementProp({
            containerWidth,
            disclosureWidth,
            hiddenTabWidths
          });
        });
      }, [handleMeasurementProp]);
      React12.useEffect(() => {
        handleMeasurement();
      }, [handleMeasurement, tabs]), useComponentDidMount.useComponentDidMount(() => {
        process.env.NODE_ENV === "development" && setTimeout(handleMeasurement, 0);
      });
      let tabsMarkup = tabs.map((tab, index) => /* @__PURE__ */ React12.createElement(Tab.Tab, {
        measuring: !0,
        key: `${index}${tab.id}Hidden`,
        id: `${tab.id}Measurer`,
        siblingTabHasFocus,
        focused: index === tabToFocus,
        selected: index === selected,
        onClick: noop,
        url: tab.url
      }, tab.content)), classname = css.classNames(LegacyTabs_module.default.LegacyTabs, LegacyTabs_module.default.TabMeasurer);
      return /* @__PURE__ */ React12.createElement("div", {
        className: classname,
        ref: containerNode
      }, /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
        event: "resize",
        handler: handleMeasurement
      }), tabsMarkup, activator);
    });
    function noop() {
    }
    exports.TabMeasurer = TabMeasurer;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyTabs/components/Item/Item.js
var require_Item8 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyTabs/components/Item/Item.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), LegacyTabs_module = require_LegacyTabs_scss(), UnstyledLink = require_UnstyledLink(), context = require_context(), Item = class extends React12.PureComponent {
      constructor(...args) {
        super(...args), this.focusedNode = null, this.setFocusedNode = (node) => {
          this.focusedNode = node;
        };
      }
      componentDidMount() {
        let {
          focusedNode
        } = this, {
          focused
        } = this.props;
        focusedNode && focusedNode instanceof HTMLElement && focused && focusedNode.focus();
      }
      componentDidUpdate() {
        let {
          focusedNode
        } = this, {
          focused
        } = this.props;
        focusedNode && focusedNode instanceof HTMLElement && focused && focusedNode.focus();
      }
      render() {
        let {
          id,
          panelID,
          children,
          url,
          accessibilityLabel,
          onClick = noop
        } = this.props, classname = css.classNames(LegacyTabs_module.default.Item), sharedProps = {
          id,
          ref: this.setFocusedNode,
          onClick,
          className: classname,
          "aria-controls": panelID,
          "aria-selected": !1,
          "aria-label": accessibilityLabel
        }, markup = url ? /* @__PURE__ */ React12.createElement(UnstyledLink.UnstyledLink, Object.assign({}, sharedProps, {
          url
        }), children) : /* @__PURE__ */ React12.createElement("button", Object.assign({}, sharedProps, {
          type: "button"
        }), children);
        return /* @__PURE__ */ React12.createElement("li", null, markup);
      }
    };
    Item.contextType = context.FeaturesContext;
    function noop() {
    }
    exports.Item = Item;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyTabs/components/List/List.js
var require_List2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyTabs/components/List/List.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), Item = require_Item8(), Box2 = require_Box();
    function List3({
      focusIndex,
      disclosureTabs,
      onClick = noop,
      onKeyPress = noop
    }) {
      let tabs = disclosureTabs.map(({
        id,
        content,
        ...tabProps
      }, index) => /* @__PURE__ */ React12.createElement(Item.Item, Object.assign({
        key: id
      }, tabProps, {
        id,
        focused: index === focusIndex,
        onClick: onClick.bind(null, id)
      }), content));
      return /* @__PURE__ */ React12.createElement("div", {
        onKeyDown: handleKeyDown,
        onKeyUp: onKeyPress
      }, /* @__PURE__ */ React12.createElement(Box2.Box, {
        as: "ul",
        padding: "200"
      }, tabs));
    }
    function noop() {
    }
    function handleKeyDown(event) {
      let {
        key
      } = event;
      (key === "ArrowLeft" || key === "ArrowRight") && (event.preventDefault(), event.stopPropagation());
    }
    exports.List = List3;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyTabs/LegacyTabs.js
var require_LegacyTabs = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/LegacyTabs/LegacyTabs.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), utilities = require_utilities9(), LegacyTabs_module = require_LegacyTabs_scss(), Panel = require_Panel2(), TabMeasurer = require_TabMeasurer2(), List3 = require_List2(), hooks2 = require_hooks2(), Tab = require_Tab2(), Icon = require_Icon(), Box2 = require_Box(), Popover = require_Popover(), TabsInner = class extends React12.PureComponent {
      constructor(...args) {
        super(...args), this.state = {
          disclosureWidth: 0,
          containerWidth: 1 / 0,
          tabWidths: [],
          visibleTabs: [],
          hiddenTabs: [],
          showDisclosure: !1,
          tabToFocus: -1
        }, this.handleKeyPress = (event) => {
          let {
            tabToFocus,
            visibleTabs,
            hiddenTabs,
            showDisclosure
          } = this.state, key = event.key, tabsArrayInOrder = showDisclosure ? visibleTabs.concat(hiddenTabs) : [...visibleTabs], newFocus = tabsArrayInOrder.indexOf(tabToFocus);
          key === "ArrowRight" && (newFocus += 1, newFocus === tabsArrayInOrder.length && (newFocus = 0)), key === "ArrowLeft" && (newFocus === -1 || newFocus === 0 ? newFocus = tabsArrayInOrder.length - 1 : newFocus -= 1), this.setState({
            tabToFocus: tabsArrayInOrder[newFocus]
          });
        }, this.renderTabMarkup = (tab, index) => {
          let {
            selected,
            children
          } = this.props, {
            tabToFocus
          } = this.state, tabPanelID = tab.panelID || `${tab.id}-panel`;
          return /* @__PURE__ */ React12.createElement(Tab.Tab, {
            key: `${index}-${tab.id}`,
            id: tab.id,
            siblingTabHasFocus: tabToFocus > -1,
            focused: index === tabToFocus,
            selected: index === selected,
            onClick: this.handleTabClick,
            panelID: children ? tabPanelID : void 0,
            accessibilityLabel: tab.accessibilityLabel,
            url: tab.url
          }, tab.content);
        }, this.handleFocus = (event) => {
          let {
            selected,
            tabs
          } = this.props, target = event.target;
          if (target.classList.contains(LegacyTabs_module.default.Tab) || target.classList.contains(LegacyTabs_module.default.Item)) {
            let tabToFocus = -1;
            tabs.every((tab, index) => tab.id === target.id ? (tabToFocus = index, !1) : !0), this.setState({
              tabToFocus
            });
            return;
          }
          if (target.classList.contains(LegacyTabs_module.default.DisclosureActivator))
            return;
          if (!event.relatedTarget) {
            this.setState({
              tabToFocus: selected
            });
            return;
          }
          let relatedTarget = event.relatedTarget;
          relatedTarget instanceof HTMLElement && !relatedTarget.classList.contains(LegacyTabs_module.default.Tab) && !relatedTarget.classList.contains(LegacyTabs_module.default.Item) && !relatedTarget.classList.contains(LegacyTabs_module.default.DisclosureActivator) && this.setState({
            tabToFocus: selected
          });
        }, this.handleBlur = (event) => {
          if (event.relatedTarget == null) {
            this.setState({
              tabToFocus: -1
            });
            return;
          }
          let target = event.relatedTarget;
          target instanceof HTMLElement && !target.classList.contains(LegacyTabs_module.default.Tab) && !target.classList.contains(LegacyTabs_module.default.Item) && this.setState({
            tabToFocus: -1
          });
        }, this.handleDisclosureActivatorClick = () => {
          this.setState(({
            showDisclosure
          }) => ({
            showDisclosure: !showDisclosure
          }));
        }, this.handleClose = () => {
          this.setState({
            showDisclosure: !1
          });
        }, this.handleMeasurement = (measurements) => {
          let {
            tabs,
            selected
          } = this.props, {
            tabToFocus
          } = this.state, {
            hiddenTabWidths: tabWidths,
            containerWidth,
            disclosureWidth
          } = measurements, {
            visibleTabs,
            hiddenTabs
          } = utilities.getVisibleAndHiddenTabIndices(tabs, selected, disclosureWidth, tabWidths, containerWidth);
          this.setState({
            tabToFocus: tabToFocus === -1 ? -1 : selected,
            visibleTabs,
            hiddenTabs,
            disclosureWidth,
            containerWidth,
            tabWidths
          });
        }, this.handleTabClick = (id) => {
          let {
            tabs,
            onSelect = noop
          } = this.props, tab = tabs.find((aTab) => aTab.id === id);
          if (tab == null)
            return;
          let selectedIndex = tabs.indexOf(tab);
          onSelect(selectedIndex);
        };
      }
      static getDerivedStateFromProps(nextProps, prevState) {
        let {
          disclosureWidth,
          tabWidths,
          containerWidth
        } = prevState, {
          visibleTabs,
          hiddenTabs
        } = utilities.getVisibleAndHiddenTabIndices(nextProps.tabs, nextProps.selected, disclosureWidth, tabWidths, containerWidth);
        return {
          visibleTabs,
          hiddenTabs,
          selected: nextProps.selected
        };
      }
      render() {
        let {
          tabs,
          selected,
          fitted,
          children,
          i18n,
          disclosureText
        } = this.props, {
          tabToFocus,
          visibleTabs,
          hiddenTabs,
          showDisclosure
        } = this.state, disclosureTabs = hiddenTabs.map((tabIndex) => tabs[tabIndex]), panelMarkup = children ? tabs.map((_tab, index) => selected === index ? /* @__PURE__ */ React12.createElement(Panel.Panel, {
          id: tabs[index].panelID || `${tabs[index].id}-panel`,
          tabID: tabs[index].id,
          key: tabs[index].id
        }, children) : /* @__PURE__ */ React12.createElement(Panel.Panel, {
          id: tabs[index].panelID || `${tabs[index].id}-panel`,
          tabID: tabs[index].id,
          key: tabs[index].id,
          hidden: !0
        })) : null, tabsMarkup = visibleTabs.sort((tabA, tabB) => tabA - tabB).map((tabIndex) => this.renderTabMarkup(tabs[tabIndex], tabIndex)), disclosureActivatorVisible = visibleTabs.length < tabs.length, hasCustomDisclosure = !!disclosureText, classname = css.classNames(LegacyTabs_module.default.LegacyTabs, fitted && LegacyTabs_module.default.fitted, disclosureActivatorVisible && LegacyTabs_module.default.fillSpace), disclosureTabClassName = css.classNames(LegacyTabs_module.default.DisclosureTab, disclosureActivatorVisible && LegacyTabs_module.default["DisclosureTab-visible"]), disclosureButtonClassName = css.classNames(LegacyTabs_module.default.DisclosureActivator, hasCustomDisclosure && LegacyTabs_module.default.Tab), disclosureButtonContentWrapperClassName = css.classNames(LegacyTabs_module.default.Title, hasCustomDisclosure && LegacyTabs_module.default.titleWithIcon), disclosureButtonContent = hasCustomDisclosure ? /* @__PURE__ */ React12.createElement(React12.Fragment, null, disclosureText, /* @__PURE__ */ React12.createElement(Icon.Icon, {
          source: polarisIcons.ChevronDownIcon,
          tone: "subdued"
        })) : /* @__PURE__ */ React12.createElement(Icon.Icon, {
          source: polarisIcons.MenuHorizontalIcon,
          tone: "subdued"
        }), disclosureButton = /* @__PURE__ */ React12.createElement("button", {
          type: "button",
          className: disclosureButtonClassName,
          onClick: this.handleDisclosureActivatorClick,
          "aria-label": i18n.translate("Polaris.Tabs.toggleTabsLabel")
        }, /* @__PURE__ */ React12.createElement("span", {
          className: disclosureButtonContentWrapperClassName
        }, disclosureButtonContent)), activator = disclosureText ? /* @__PURE__ */ React12.createElement("div", {
          className: LegacyTabs_module.default.TabContainer
        }, disclosureButton) : disclosureButton;
        return /* @__PURE__ */ React12.createElement("div", null, /* @__PURE__ */ React12.createElement(Box2.Box, {
          borderBlockEndWidth: "025",
          borderColor: "border-secondary",
          paddingInlineStart: "200",
          paddingInlineEnd: "200"
        }, /* @__PURE__ */ React12.createElement(TabMeasurer.TabMeasurer, {
          tabToFocus,
          activator,
          selected,
          tabs,
          siblingTabHasFocus: tabToFocus > -1,
          handleMeasurement: this.handleMeasurement
        }), /* @__PURE__ */ React12.createElement("ul", {
          role: "tablist",
          className: classname,
          onFocus: this.handleFocus,
          onBlur: this.handleBlur,
          onKeyDown: handleKeyDown,
          onKeyUp: this.handleKeyPress
        }, tabsMarkup, /* @__PURE__ */ React12.createElement("li", {
          className: disclosureTabClassName,
          role: "presentation"
        }, /* @__PURE__ */ React12.createElement(Popover.Popover, {
          preferredPosition: "below",
          activator,
          active: disclosureActivatorVisible && showDisclosure,
          onClose: this.handleClose,
          autofocusTarget: "first-node"
        }, /* @__PURE__ */ React12.createElement(List3.List, {
          focusIndex: hiddenTabs.indexOf(tabToFocus),
          disclosureTabs,
          onClick: this.handleTabClick,
          onKeyPress: this.handleKeyPress
        }))))), panelMarkup);
      }
      // eslint-disable-next-line @shopify/react-no-multiple-render-methods
    };
    function noop() {
    }
    function handleKeyDown(event) {
      let {
        key
      } = event;
      (key === "ArrowLeft" || key === "ArrowRight") && (event.preventDefault(), event.stopPropagation());
    }
    function LegacyTabs(props) {
      let i18n = hooks2.useI18n();
      return /* @__PURE__ */ React12.createElement(TabsInner, Object.assign({}, props, {
        i18n
      }));
    }
    exports.LegacyTabs = LegacyTabs;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Link/Link.scss.js
var require_Link_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Link/Link.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Link: "Polaris-Link",
      monochrome: "Polaris-Link--monochrome",
      removeUnderline: "Polaris-Link--removeUnderline"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Link/Link.js
var require_Link = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Link/Link.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), bannerContext = require_banner_context(), css = require_css(), Link_module = require_Link_scss(), UnstyledLink = require_UnstyledLink();
    function Link4({
      url,
      children,
      onClick,
      external,
      target,
      id,
      monochrome,
      removeUnderline,
      accessibilityLabel,
      dataPrimaryLink
    }) {
      return /* @__PURE__ */ React12.createElement(bannerContext.BannerContext.Consumer, null, (BannerContext) => {
        let shouldBeMonochrome = monochrome || BannerContext, className = css.classNames(Link_module.default.Link, shouldBeMonochrome && Link_module.default.monochrome, removeUnderline && Link_module.default.removeUnderline);
        return url ? /* @__PURE__ */ React12.createElement(UnstyledLink.UnstyledLink, {
          onClick,
          className,
          url,
          external,
          target,
          id,
          "aria-label": accessibilityLabel,
          "data-primary-link": dataPrimaryLink
        }, children) : /* @__PURE__ */ React12.createElement("button", {
          type: "button",
          onClick,
          className,
          id,
          "aria-label": accessibilityLabel,
          "data-primary-link": dataPrimaryLink
        }, children);
      });
    }
    exports.Link = Link4;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/List/List.scss.js
var require_List_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/List/List.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      List: "Polaris-List",
      typeNumber: "Polaris-List--typeNumber",
      Item: "Polaris-List__Item",
      spacingLoose: "Polaris-List--spacingLoose"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/List/components/Item/Item.js
var require_Item9 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/List/components/Item/Item.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), List_module = require_List_scss();
    function Item({
      children
    }) {
      return /* @__PURE__ */ React12.createElement("li", {
        className: List_module.default.Item
      }, children);
    }
    exports.Item = Item;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/List/List.js
var require_List3 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/List/List.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), List_module = require_List_scss(), Item = require_Item9(), List3 = function({
      children,
      gap = "loose",
      type = "bullet"
    }) {
      let className = css.classNames(List_module.default.List, gap && List_module.default[css.variationName("spacing", gap)], type && List_module.default[css.variationName("type", type)]), ListElement = type === "bullet" ? "ul" : "ol";
      return /* @__PURE__ */ React12.createElement(ListElement, {
        className
      }, children);
    };
    List3.Item = Item.Item;
    exports.List = List3;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Loading/Loading.js
var require_Loading3 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Loading/Loading.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), hooks2 = require_hooks9(), Loading = /* @__PURE__ */ React12.memo(function() {
      let {
        startLoading,
        stopLoading
      } = hooks2.useFrame();
      return React12.useEffect(() => (startLoading(), () => {
        stopLoading();
      }), [startLoading, stopLoading]), null;
    });
    exports.Loading = Loading;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/MediaCard/MediaCard.scss.js
var require_MediaCard_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/MediaCard/MediaCard.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      MediaCard: "Polaris-MediaCard",
      portrait: "Polaris-MediaCard--portrait",
      MediaContainer: "Polaris-MediaCard__MediaContainer",
      sizeSmall: "Polaris-MediaCard--sizeSmall",
      InfoContainer: "Polaris-MediaCard__InfoContainer",
      ActionContainer: "Polaris-MediaCard__ActionContainer",
      Description: "Polaris-MediaCard__Description"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/MediaCard/MediaCard.js
var require_MediaCard = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/MediaCard/MediaCard.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), useToggle = require_use_toggle(), css = require_css(), MediaCard_module = require_MediaCard_scss(), hooks2 = require_hooks2(), Button2 = require_Button(), InlineStack2 = require_InlineStack(), Popover = require_Popover(), ActionList = require_ActionList(), utils = require_utils10(), LegacyCard = require_LegacyCard(), Box2 = require_Box(), BlockStack3 = require_BlockStack(), ButtonGroup = require_ButtonGroup(), Text4 = require_Text();
    function MediaCard({
      title,
      children,
      primaryAction,
      secondaryAction,
      description,
      popoverActions = [],
      portrait = !1,
      size = "medium",
      onDismiss
    }) {
      let i18n = hooks2.useI18n(), {
        value: popoverActive,
        toggle: togglePopoverActive
      } = useToggle.useToggle(!1), headerMarkup = null;
      if (title) {
        let headerContent = typeof title == "string" ? /* @__PURE__ */ React12.createElement(Text4.Text, {
          variant: "headingSm",
          as: "h2"
        }, title) : title;
        headerMarkup = /* @__PURE__ */ React12.createElement("div", null, headerContent);
      }
      let dismissButtonMarkup = onDismiss ? /* @__PURE__ */ React12.createElement(Button2.Button, {
        icon: polarisIcons.XIcon,
        onClick: onDismiss,
        size: "slim",
        accessibilityLabel: i18n.translate("Polaris.MediaCard.dismissButton"),
        variant: "tertiary"
      }) : null, popoverActivator = /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        blockAlign: "center"
      }, /* @__PURE__ */ React12.createElement(Button2.Button, {
        icon: polarisIcons.MenuHorizontalIcon,
        onClick: togglePopoverActive,
        size: "slim",
        accessibilityLabel: i18n.translate("Polaris.MediaCard.popoverButton"),
        variant: "tertiary"
      })), popoverActionsMarkup = popoverActions.length > 0 ? /* @__PURE__ */ React12.createElement(Popover.Popover, {
        active: popoverActive,
        activator: popoverActivator,
        onClose: togglePopoverActive,
        preferredAlignment: "left",
        preferredPosition: "below"
      }, /* @__PURE__ */ React12.createElement(ActionList.ActionList, {
        items: popoverActions,
        onActionAnyItem: togglePopoverActive
      })) : null, primaryActionMarkup = primaryAction ? /* @__PURE__ */ React12.createElement("div", null, utils.buttonFrom(primaryAction)) : null, secondaryActionMarkup = secondaryAction ? /* @__PURE__ */ React12.createElement("div", null, utils.buttonFrom(secondaryAction)) : null, actionClassName = css.classNames(MediaCard_module.default.ActionContainer, portrait && MediaCard_module.default.portrait), actionMarkup = primaryActionMarkup || secondaryActionMarkup ? /* @__PURE__ */ React12.createElement("div", {
        className: actionClassName
      }, /* @__PURE__ */ React12.createElement(ButtonGroup.ButtonGroup, null, primaryActionMarkup, secondaryActionMarkup)) : null, mediaCardClassName = css.classNames(MediaCard_module.default.MediaCard, portrait && MediaCard_module.default.portrait), mediaContainerClassName = css.classNames(MediaCard_module.default.MediaContainer, portrait && MediaCard_module.default.portrait, size === "small" && MediaCard_module.default.sizeSmall), infoContainerClassName = css.classNames(MediaCard_module.default.InfoContainer, portrait && MediaCard_module.default.portrait, size === "small" && MediaCard_module.default.sizeSmall), popoverOrDismissMarkup = popoverActionsMarkup || dismissButtonMarkup ? /* @__PURE__ */ React12.createElement(Box2.Box, {
        position: "absolute",
        insetInlineEnd: "500",
        zIndex: "var(--p-z-index-2)"
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "100",
        wrap: !1
      }, popoverActionsMarkup, dismissButtonMarkup)) : null;
      return /* @__PURE__ */ React12.createElement(LegacyCard.LegacyCard, null, /* @__PURE__ */ React12.createElement("div", {
        className: mediaCardClassName
      }, /* @__PURE__ */ React12.createElement("div", {
        className: mediaContainerClassName
      }, children), /* @__PURE__ */ React12.createElement("div", {
        className: infoContainerClassName
      }, /* @__PURE__ */ React12.createElement(Box2.Box, {
        padding: "500"
      }, /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
        gap: "200"
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        wrap: !1,
        align: "space-between",
        gap: "200"
      }, headerMarkup, popoverOrDismissMarkup), /* @__PURE__ */ React12.createElement("p", {
        className: MediaCard_module.default.Description
      }, description), actionMarkup)))));
    }
    exports.MediaCard = MediaCard;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Navigation/context.js
var require_context20 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Navigation/context.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), NavigationContext = /* @__PURE__ */ React12.createContext({
      location: ""
    });
    exports.NavigationContext = NavigationContext;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Navigation/Navigation.scss.js
var require_Navigation_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Navigation/Navigation.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Navigation: "Polaris-Navigation",
      UserMenu: "Polaris-Navigation__UserMenu",
      ContextControl: "Polaris-Navigation__ContextControl",
      PrimaryNavigation: "Polaris-Navigation__PrimaryNavigation",
      LogoContainer: "Polaris-Navigation__LogoContainer",
      hasLogoSuffix: "Polaris-Navigation--hasLogoSuffix",
      Logo: "Polaris-Navigation__Logo",
      LogoLink: "Polaris-Navigation__LogoLink",
      Item: "Polaris-Navigation__Item",
      "Icon-resized": "Polaris-Navigation__Icon--resized",
      Badge: "Polaris-Navigation__Badge",
      ItemInnerWrapper: "Polaris-Navigation__ItemInnerWrapper",
      ItemWrapper: "Polaris-Navigation__ItemWrapper",
      ItemInnerDisabled: "Polaris-Navigation__ItemInnerDisabled",
      "ItemInnerWrapper-display-actions-on-hover": "Polaris-Navigation--itemInnerWrapperDisplayActionsOnHover",
      SecondaryActions: "Polaris-Navigation__SecondaryActions",
      "ItemInnerWrapper-selected": "Polaris-Navigation__ItemInnerWrapper--selected",
      Text: "Polaris-Navigation__Text",
      "ItemInnerWrapper-open": "Polaris-Navigation__ItemInnerWrapper--open",
      "Item-selected": "Polaris-Navigation__Item--selected",
      "Item-child-active": "Polaris-Navigation--itemChildActive",
      "Item-disabled": "Polaris-Navigation__Item--disabled",
      Icon: "Polaris-Navigation__Icon",
      "ListItem-hasAction": "Polaris-Navigation__ListItem--hasAction",
      subNavigationActive: "Polaris-Navigation--subNavigationActive",
      ListItem: "Polaris-Navigation__ListItem",
      RollupSection: "Polaris-Navigation__RollupSection",
      SecondaryNavigation: "Polaris-Navigation__SecondaryNavigation",
      "Text-truncated": "Polaris-Navigation__Text--truncated",
      ItemWithFloatingActions: "Polaris-Navigation__ItemWithFloatingActions",
      SecondaryAction: "Polaris-Navigation__SecondaryAction",
      List: "Polaris-Navigation__List",
      "Item-line": "Polaris-Navigation__Item--line",
      "Item-hover-line": "Polaris-Navigation--itemHoverLine",
      "Item-line-pointer": "Polaris-Navigation--itemLinePointer",
      "Item-hover-pointer": "Polaris-Navigation--itemHoverPointer",
      "SecondaryNavigation-noIcon": "Polaris-Navigation__SecondaryNavigation--noIcon",
      Section: "Polaris-Navigation__Section",
      "Section-fill": "Polaris-Navigation__Section--fill",
      "Section-withSeparator": "Polaris-Navigation__Section--withSeparator",
      SectionHeading: "Polaris-Navigation__SectionHeading",
      Action: "Polaris-Navigation__Action",
      RollupToggle: "Polaris-Navigation__RollupToggle",
      Indicator: "Polaris-Navigation__Indicator",
      SecondaryNavigationOpen: "Polaris-Navigation__SecondaryNavigationOpen",
      "snappy-grow": "Polaris-Navigation__snappy--grow"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Navigation/types.js
var require_types11 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Navigation/types.js"(exports) {
    "use strict";
    init_cjs_shims();
    exports.MatchState = void 0;
    (function(MatchState) {
      MatchState[MatchState.MatchForced = 0] = "MatchForced", MatchState[MatchState.MatchUrl = 1] = "MatchUrl", MatchState[MatchState.MatchPaths = 2] = "MatchPaths", MatchState[MatchState.Excluded = 3] = "Excluded", MatchState[MatchState.NoMatch = 4] = "NoMatch";
    })(exports.MatchState || (exports.MatchState = {}));
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Navigation/components/Item/components/SecondaryNavigation/SecondaryNavigation.js
var require_SecondaryNavigation = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Navigation/components/Item/components/SecondaryNavigation/SecondaryNavigation.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), isEqual = require_react_fast_compare(), css = require_css(), context = require_context20(), Navigation_module = require_Navigation_scss(), Collapsible = require_Collapsible();
    function SecondaryNavigation({
      ItemComponent,
      icon,
      longestMatch,
      subNavigationItems,
      showExpanded,
      truncateText,
      secondaryNavigationId
    }) {
      let uid = React12.useId(), {
        onNavigationDismiss
      } = React12.useContext(context.NavigationContext), [hoveredItem, setHoveredItem] = React12.useState(), matchedItemPosition = subNavigationItems.findIndex((item) => isEqual(item, longestMatch)), hoveredItemPosition = subNavigationItems.findIndex((item) => isEqual(item, hoveredItem));
      return /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(Navigation_module.default.SecondaryNavigation, showExpanded && Navigation_module.default.SecondaryNavigationOpen, !icon && Navigation_module.default["SecondaryNavigation-noIcon"])
      }, /* @__PURE__ */ React12.createElement(Collapsible.Collapsible, {
        id: secondaryNavigationId || uid,
        open: showExpanded,
        transition: !1
      }, /* @__PURE__ */ React12.createElement("ul", {
        className: Navigation_module.default.List
      }, subNavigationItems.map((item, index) => {
        let {
          label,
          ...rest
        } = item, onClick = () => {
          onNavigationDismiss?.(), item.onClick && item.onClick !== onNavigationDismiss && item.onClick();
        }, shouldShowVerticalLine = index < matchedItemPosition;
        return /* @__PURE__ */ React12.createElement(ItemComponent, Object.assign({
          key: label
        }, rest, {
          label,
          showVerticalLine: shouldShowVerticalLine,
          showVerticalHoverPointer: index === hoveredItemPosition,
          onMouseEnter: item.disabled ? void 0 : () => setHoveredItem(item),
          onMouseLeave: item.disabled ? void 0 : () => setHoveredItem(void 0),
          matches: isEqual(item, longestMatch),
          onClick,
          truncateText
        }));
      }))));
    }
    exports.SecondaryNavigation = SecondaryNavigation;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Navigation/components/Item/Item.js
var require_Item10 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Navigation/components/Item/Item.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), useIsomorphicLayoutEffect = require_use_isomorphic_layout_effect(), css = require_css(), context = require_context20(), Navigation_module = require_Navigation_scss(), types = require_types11(), SecondaryNavigation = require_SecondaryNavigation(), hooks2 = require_hooks2(), hooks$1 = require_hooks11(), Indicator = require_Indicator(), Icon = require_Icon(), Badge2 = require_Badge(), UnstyledLink = require_UnstyledLink(), UnstyledButton = require_UnstyledButton(), Tooltip = require_Tooltip(), MAX_SECONDARY_ACTIONS = 2, TOOLTIP_HOVER_DELAY = 1e3;
    function Item({
      url,
      icon: baseIcon,
      matchedItemIcon,
      label,
      subNavigationItems = [],
      secondaryAction,
      secondaryActions,
      displayActionsOnHover,
      disabled,
      onClick,
      accessibilityLabel,
      selected: selectedOverride,
      badge,
      new: isNew,
      matches,
      exactMatch,
      matchPaths,
      excludePaths,
      external,
      onToggleExpandedState,
      expanded,
      shouldResizeIcon,
      truncateText,
      showVerticalLine,
      showVerticalHoverPointer,
      onMouseEnter,
      onMouseLeave
    }) {
      let i18n = hooks2.useI18n(), {
        isNavigationCollapsed
      } = hooks$1.useMediaQuery(), secondaryNavigationId = React12.useId(), {
        location: location2,
        onNavigationDismiss
      } = React12.useContext(context.NavigationContext), navTextRef = React12.useRef(null), [isTruncated, setIsTruncated] = React12.useState(!1);
      React12.useEffect(() => {
        !isNavigationCollapsed && expanded && onToggleExpandedState?.();
      }, [expanded, isNavigationCollapsed, onToggleExpandedState]), useIsomorphicLayoutEffect.useIsomorphicLayoutEffect(() => {
        let navTextNode = navTextRef.current;
        truncateText && navTextNode && setIsTruncated(navTextNode.scrollHeight > navTextNode.clientHeight);
      }, [truncateText]);
      let tabIndex = disabled ? -1 : 0, indicatorMarkup = subNavigationItems.filter((subNavigationItem) => subNavigationItem.new).length > 0 ? /* @__PURE__ */ React12.createElement("span", {
        className: Navigation_module.default.Indicator
      }, /* @__PURE__ */ React12.createElement(Indicator.Indicator, {
        pulse: !0
      })) : null, matchState = matchStateForItem({
        url,
        matches,
        exactMatch,
        matchPaths,
        excludePaths
      }, location2), matchingSubNavigationItems = subNavigationItems.filter((item) => {
        let subMatchState = matchStateForItem(item, location2);
        return subMatchState === types.MatchState.MatchForced || subMatchState === types.MatchState.MatchUrl || subMatchState === types.MatchState.MatchPaths;
      }), childIsActive = matchingSubNavigationItems.length > 0, selected = selectedOverride ?? (matchState === types.MatchState.MatchForced || matchState === types.MatchState.MatchUrl || matchState === types.MatchState.MatchPaths), icon = selected || childIsActive ? matchedItemIcon ?? baseIcon : baseIcon, iconMarkup = icon ? /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(Navigation_module.default.Icon, shouldResizeIcon && Navigation_module.default["Icon-resized"])
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: icon
      })) : null, badgeMarkup = null;
      isNew ? badgeMarkup = /* @__PURE__ */ React12.createElement(Badge2.Badge, {
        tone: "new"
      }, i18n.translate("Polaris.Badge.TONE_LABELS.new")) : typeof badge == "string" ? badgeMarkup = /* @__PURE__ */ React12.createElement(Badge2.Badge, {
        tone: "new"
      }, badge) : badgeMarkup = badge;
      let wrappedBadgeMarkup = badgeMarkup == null ? null : /* @__PURE__ */ React12.createElement("div", {
        className: Navigation_module.default.Badge
      }, badgeMarkup), itemLabelMarkup = /* @__PURE__ */ React12.createElement("span", {
        className: css.classNames(Navigation_module.default.Text, truncateText && Navigation_module.default["Text-truncated"]),
        ref: navTextRef
      }, label, indicatorMarkup);
      if (url == null) {
        let className2 = css.classNames(Navigation_module.default.Item, disabled && Navigation_module.default["Item-disabled"], selectedOverride && Navigation_module.default["Item-selected"]);
        return /* @__PURE__ */ React12.createElement("li", {
          className: Navigation_module.default.ListItem
        }, /* @__PURE__ */ React12.createElement("div", {
          className: Navigation_module.default.ItemWrapper
        }, /* @__PURE__ */ React12.createElement("div", {
          className: css.classNames(Navigation_module.default.ItemInnerWrapper, disabled && Navigation_module.default.ItemInnerDisabled, selectedOverride && Navigation_module.default["ItemInnerWrapper-selected"])
        }, /* @__PURE__ */ React12.createElement("button", {
          type: "button",
          className: className2,
          disabled,
          "aria-disabled": disabled,
          "aria-label": accessibilityLabel,
          onClick: getClickHandler(onClick)
        }, iconMarkup, itemLabelMarkup, wrappedBadgeMarkup))));
      }
      secondaryAction && process.env.NODE_ENV === "development" && console.warn("Deprecation: The `secondaryAction` prop on the `Navigation.Item` has been deprecated. Use `secondaryActions` instead.");
      let actions = secondaryActions || secondaryAction && [secondaryAction];
      actions && actions.length > MAX_SECONDARY_ACTIONS && (actions.length = MAX_SECONDARY_ACTIONS, process.env.NODE_ENV === "development" && console.warn(`secondaryActions must have a maximum of ${MAX_SECONDARY_ACTIONS} actions. Only the first ${MAX_SECONDARY_ACTIONS} actions will be rendered.`));
      let secondaryActionMarkup = actions?.length ? /* @__PURE__ */ React12.createElement("span", {
        className: Navigation_module.default.SecondaryActions
      }, actions.map((action) => /* @__PURE__ */ React12.createElement(ItemSecondaryAction, Object.assign({
        key: action.accessibilityLabel
      }, action, {
        tabIndex,
        disabled
      })))) : null, itemContentMarkup = /* @__PURE__ */ React12.createElement(React12.Fragment, null, iconMarkup, itemLabelMarkup, secondaryActionMarkup ? null : wrappedBadgeMarkup), outerContentMarkup = /* @__PURE__ */ React12.createElement(React12.Fragment, null, secondaryActionMarkup ? wrappedBadgeMarkup : null), showExpanded = selected || expanded || childIsActive, itemClassName = css.classNames(Navigation_module.default.Item, disabled && Navigation_module.default["Item-disabled"], (selected || childIsActive) && Navigation_module.default["Item-selected"], showExpanded && Navigation_module.default.subNavigationActive, childIsActive && Navigation_module.default["Item-child-active"], showVerticalLine && Navigation_module.default["Item-line"], matches && Navigation_module.default["Item-line-pointer"], showVerticalHoverPointer && Navigation_module.default["Item-hover-pointer"]), secondaryNavigationMarkup = null;
      if (subNavigationItems.length > 0) {
        let longestMatch = matchingSubNavigationItems.sort(({
          url: firstUrl
        }, {
          url: secondUrl
        }) => secondUrl.length - firstUrl.length)[0];
        secondaryNavigationMarkup = /* @__PURE__ */ React12.createElement(SecondaryNavigation.SecondaryNavigation, {
          ItemComponent: Item,
          icon,
          longestMatch,
          subNavigationItems,
          showExpanded,
          truncateText,
          secondaryNavigationId
        });
      }
      let className = css.classNames(Navigation_module.default.ListItem, !!(actions && actions.length) && Navigation_module.default["ListItem-hasAction"]), itemLinkMarkup = () => {
        let linkMarkup = /* @__PURE__ */ React12.createElement(UnstyledLink.UnstyledLink, Object.assign({
          url,
          className: itemClassName,
          external,
          tabIndex,
          "aria-disabled": disabled,
          "aria-label": accessibilityLabel,
          onClick: getClickHandler(onClick)
        }, normalizeAriaAttributes(secondaryNavigationId, subNavigationItems.length > 0, showExpanded)), itemContentMarkup);
        return isTruncated ? /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, {
          hoverDelay: TOOLTIP_HOVER_DELAY,
          content: label,
          preferredPosition: "above"
        }, linkMarkup) : linkMarkup;
      };
      return /* @__PURE__ */ React12.createElement("li", {
        className,
        onMouseEnter: () => {
          onMouseEnter?.(label);
        },
        onMouseLeave
      }, /* @__PURE__ */ React12.createElement("div", {
        className: Navigation_module.default.ItemWrapper
      }, /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(Navigation_module.default.ItemInnerWrapper, selected && childIsActive && Navigation_module.default["ItemInnerWrapper-open"] || selected && !childIsActive && Navigation_module.default["ItemInnerWrapper-selected"], displayActionsOnHover && Navigation_module.default["ItemInnerWrapper-display-actions-on-hover"], disabled && Navigation_module.default.ItemInnerDisabled)
      }, displayActionsOnHover && secondaryActionMarkup && wrappedBadgeMarkup ? /* @__PURE__ */ React12.createElement("span", {
        className: Navigation_module.default.ItemWithFloatingActions
      }, itemLinkMarkup(), secondaryActionMarkup) : /* @__PURE__ */ React12.createElement(React12.Fragment, null, itemLinkMarkup(), secondaryActionMarkup), outerContentMarkup)), secondaryNavigationMarkup);
      function getClickHandler(onClick2) {
        return (event) => {
          let {
            currentTarget
          } = event;
          if (currentTarget.getAttribute("href") === location2 && event.preventDefault(), subNavigationItems && subNavigationItems.length > 0 && isNavigationCollapsed)
            event.preventDefault(), onToggleExpandedState?.();
          else if (onNavigationDismiss) {
            onNavigationDismiss(), onClick2 && onClick2 !== onNavigationDismiss && onClick2();
            return;
          }
          onClick2 && onClick2();
        };
      }
    }
    function ItemSecondaryAction({
      url,
      icon,
      accessibilityLabel,
      tooltip,
      onClick,
      disabled,
      tabIndex
    }) {
      let markup = url ? /* @__PURE__ */ React12.createElement(UnstyledLink.UnstyledLink, {
        external: !0,
        url,
        className: Navigation_module.default.SecondaryAction,
        tabIndex,
        "aria-disabled": disabled,
        "aria-label": accessibilityLabel,
        onClick
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: icon
      })) : /* @__PURE__ */ React12.createElement(UnstyledButton.UnstyledButton, {
        className: Navigation_module.default.SecondaryAction,
        tabIndex,
        disabled,
        accessibilityLabel,
        onClick
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: icon
      }));
      return tooltip ? /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, tooltip, " ", markup, " ") : markup;
    }
    function isNavigationItemActive(navigationItem, currentPath) {
      let matchState = matchStateForItem(navigationItem, currentPath), matchingSubNavigationItems = navigationItem.subNavigationItems && navigationItem.subNavigationItems.filter((item) => {
        let subMatchState = matchStateForItem(item, currentPath);
        return subMatchState === types.MatchState.MatchForced || subMatchState === types.MatchState.MatchUrl || subMatchState === types.MatchState.MatchPaths;
      }), childIsActive = matchingSubNavigationItems && matchingSubNavigationItems.length > 0;
      return matchState === types.MatchState.MatchForced || matchState === types.MatchState.MatchUrl || matchState === types.MatchState.MatchPaths || childIsActive;
    }
    function normalizePathname(pathname) {
      let barePathname = pathname.split("?")[0].split("#")[0];
      return barePathname.endsWith("/") ? barePathname : `${barePathname}/`;
    }
    function safeEqual(location2, path3) {
      return normalizePathname(location2) === normalizePathname(path3);
    }
    function safeStartsWith(location2, path3) {
      return normalizePathname(location2).startsWith(normalizePathname(path3));
    }
    function matchStateForItem({
      url,
      matches,
      exactMatch,
      matchPaths,
      excludePaths
    }, location2) {
      return url == null ? types.MatchState.NoMatch : matches ? types.MatchState.MatchForced : matches === !1 || excludePaths && excludePaths.some((path3) => safeStartsWith(location2, path3)) ? types.MatchState.Excluded : matchPaths && matchPaths.some((path3) => safeStartsWith(location2, path3)) ? types.MatchState.MatchPaths : (exactMatch ? safeEqual(location2, url) : safeStartsWith(location2, url)) ? types.MatchState.MatchUrl : types.MatchState.NoMatch;
    }
    function normalizeAriaAttributes(controlId, hasSubMenu, expanded) {
      return hasSubMenu ? {
        "aria-expanded": expanded,
        "aria-controls": controlId
      } : void 0;
    }
    exports.Item = Item;
    exports.ItemSecondaryAction = ItemSecondaryAction;
    exports.MAX_SECONDARY_ACTIONS = MAX_SECONDARY_ACTIONS;
    exports.isNavigationItemActive = isNavigationItemActive;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Navigation/components/Section/Section.js
var require_Section7 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Navigation/components/Section/Section.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), useToggle = require_use_toggle(), Navigation_module = require_Navigation_scss(), Item = require_Item10(), hooks2 = require_hooks11(), Icon = require_Icon(), Tooltip = require_Tooltip(), Text4 = require_Text(), Collapsible = require_Collapsible();
    function Section({
      title,
      fill,
      action,
      items,
      rollup,
      separator
    }) {
      let {
        value: expanded,
        toggle: toggleExpanded,
        setFalse: setExpandedFalse
      } = useToggle.useToggle(!1), animationFrame = React12.useRef(null), {
        isNavigationCollapsed
      } = hooks2.useMediaQuery(), [expandedIndex, setExpandedIndex] = React12.useState(), handleClick = (onClick, hasSubNavItems) => () => {
        onClick && onClick(), animationFrame.current && cancelAnimationFrame(animationFrame.current), (!hasSubNavItems || !isNavigationCollapsed) && (animationFrame.current = requestAnimationFrame(setExpandedFalse));
      };
      React12.useEffect(() => () => {
        animationFrame.current && cancelAnimationFrame(animationFrame.current);
      });
      let className = css.classNames(Navigation_module.default.Section, separator && Navigation_module.default["Section-withSeparator"], fill && Navigation_module.default["Section-fill"]), buttonMarkup = action && /* @__PURE__ */ React12.createElement("button", {
        type: "button",
        className: Navigation_module.default.Action,
        "aria-label": action.accessibilityLabel,
        onClick: action.onClick
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: action.icon
      })), actionMarkup = action && (action.tooltip ? /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, action.tooltip, buttonMarkup) : buttonMarkup), sectionHeadingMarkup = title && /* @__PURE__ */ React12.createElement("li", {
        className: Navigation_module.default.SectionHeading
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        variant: "bodySm",
        fontWeight: "medium",
        tone: "subdued"
      }, title), actionMarkup), itemsMarkup = items.map((item, index) => {
        let {
          onClick,
          label,
          subNavigationItems,
          ...rest
        } = item, hasSubNavItems = subNavigationItems != null && subNavigationItems.length > 0, handleToggleExpandedState = () => {
          setExpandedIndex(expandedIndex === index ? -1 : index);
        };
        return /* @__PURE__ */ React12.createElement(Item.Item, Object.assign({
          key: label
        }, rest, {
          label,
          subNavigationItems,
          onClick: handleClick(onClick, hasSubNavItems),
          onToggleExpandedState: handleToggleExpandedState,
          expanded: expandedIndex === index
        }));
      }), toggleClassName = css.classNames(Navigation_module.default.Item, Navigation_module.default.RollupToggle), ariaLabel = rollup && (expanded ? rollup.hide : rollup.view), toggleRollup = rollup && items.length > rollup.after && /* @__PURE__ */ React12.createElement("div", {
        className: Navigation_module.default.ListItem,
        key: "List Item"
      }, /* @__PURE__ */ React12.createElement("div", {
        className: Navigation_module.default.ItemWrapper
      }, /* @__PURE__ */ React12.createElement("div", {
        className: Navigation_module.default.ItemInnerWrapper
      }, /* @__PURE__ */ React12.createElement("button", {
        type: "button",
        className: toggleClassName,
        onClick: toggleExpanded,
        "aria-label": ariaLabel
      }, /* @__PURE__ */ React12.createElement("span", {
        className: Navigation_module.default.Icon
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.MenuHorizontalIcon
      })))))), activeItemIndex = items.findIndex((item) => rollup ? rollup.activePath === item.url || item.url && rollup.activePath.startsWith(item.url) || (item.subNavigationItems ? item.subNavigationItems.some(({
        url: itemUrl
      }) => rollup.activePath.startsWith(itemUrl)) : !1) : !1), sectionItems = rollup ? itemsMarkup.slice(0, rollup.after) : itemsMarkup, additionalItems = rollup ? itemsMarkup.slice(rollup.after) : [];
      rollup && activeItemIndex !== -1 && activeItemIndex > rollup.after - 1 && sectionItems.push(...additionalItems.splice(activeItemIndex - rollup.after, 1));
      let additionalItemsId = React12.useId(), activeItemsMarkup = rollup && additionalItems.length > 0 && /* @__PURE__ */ React12.createElement("li", {
        className: Navigation_module.default.RollupSection
      }, /* @__PURE__ */ React12.createElement(Collapsible.Collapsible, {
        id: additionalItemsId,
        open: expanded
      }, /* @__PURE__ */ React12.createElement("ul", {
        className: Navigation_module.default.List
      }, additionalItems)), toggleRollup);
      return /* @__PURE__ */ React12.createElement("ul", {
        className
      }, sectionHeadingMarkup, sectionItems, activeItemsMarkup);
    }
    exports.Section = Section;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Navigation/Navigation.js
var require_Navigation2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Navigation/Navigation.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), withinContentContext = require_within_content_context(), css = require_css(), getWidth = require_get_width(), context = require_context20(), Navigation_module = require_Navigation_scss(), Section = require_Section7(), hooks2 = require_hooks9(), UnstyledLink = require_UnstyledLink(), Image = require_Image(), Scrollable = require_Scrollable(), Item = require_Item10(), Navigation = function({
      children,
      contextControl,
      location: location2,
      onDismiss,
      ariaLabelledBy,
      logoSuffix
    }) {
      let {
        logo
      } = hooks2.useFrame(), width = getWidth.getWidth(logo, 104), logoMarkup = logo ? /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(Navigation_module.default.LogoContainer, logoSuffix && Navigation_module.default.hasLogoSuffix)
      }, /* @__PURE__ */ React12.createElement(UnstyledLink.UnstyledLink, {
        url: logo.url || "",
        className: Navigation_module.default.LogoLink,
        style: {
          width
        }
      }, /* @__PURE__ */ React12.createElement(Image.Image, {
        source: logo.topBarSource || "",
        alt: logo.accessibilityLabel || "",
        className: Navigation_module.default.Logo,
        style: {
          width
        }
      })), logoSuffix) : null, mediaMarkup = contextControl ? /* @__PURE__ */ React12.createElement("div", {
        className: Navigation_module.default.ContextControl
      }, contextControl) : logoMarkup, context$1 = React12.useMemo(() => ({
        location: location2,
        onNavigationDismiss: onDismiss
      }), [location2, onDismiss]);
      return /* @__PURE__ */ React12.createElement(context.NavigationContext.Provider, {
        value: context$1
      }, /* @__PURE__ */ React12.createElement(withinContentContext.WithinContentContext.Provider, {
        value: !0
      }, /* @__PURE__ */ React12.createElement("nav", {
        className: Navigation_module.default.Navigation,
        "aria-labelledby": ariaLabelledBy
      }, mediaMarkup, /* @__PURE__ */ React12.createElement(Scrollable.Scrollable, {
        className: Navigation_module.default.PrimaryNavigation
      }, children))));
    };
    Navigation.Item = Item.Item;
    Navigation.Section = Section.Section;
    exports.Navigation = Navigation;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/arrays.js
var require_arrays = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/arrays.js"(exports) {
    "use strict";
    init_cjs_shims();
    function arraysAreEqual(firstArray, secondArray, comparator) {
      return firstArray.length !== secondArray.length ? !1 : firstArray.every((firstItem, index) => {
        let secondItem = secondArray[index];
        return comparator != null ? comparator(firstItem, secondItem) : firstItem === secondItem;
      });
    }
    exports.arraysAreEqual = arraysAreEqual;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/OptionList/components/Option/Option.scss.js
var require_Option_scss2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/OptionList/components/Option/Option.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Option: "Polaris-OptionList-Option",
      SingleSelectOption: "Polaris-OptionList-Option__SingleSelectOption",
      focused: "Polaris-OptionList-Option--focused",
      active: "Polaris-OptionList-Option--active",
      disabled: "Polaris-OptionList-Option--disabled",
      select: "Polaris-OptionList-Option--select",
      Media: "Polaris-OptionList-Option__Media",
      Label: "Polaris-OptionList-Option__Label",
      MultiSelectOption: "Polaris-OptionList-Option__MultiSelectOption",
      CheckboxLabel: "Polaris-OptionList-Option__CheckboxLabel",
      verticalAlignTop: "Polaris-OptionList-Option--verticalAlignTop",
      verticalAlignCenter: "Polaris-OptionList-Option--verticalAlignCenter",
      verticalAlignBottom: "Polaris-OptionList-Option--verticalAlignBottom",
      Icon: "Polaris-OptionList-Option__Icon",
      Checkbox: "Polaris-OptionList-Option__Checkbox"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/OptionList/components/Option/Option.js
var require_Option2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/OptionList/components/Option/Option.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), useToggle = require_use_toggle(), css = require_css(), Option_module = require_Option_scss2(), Checkbox = require_Checkbox(), InlineStack2 = require_InlineStack(), Icon = require_Icon(), Scrollable = require_Scrollable();
    function Option({
      label,
      value,
      id,
      select,
      active,
      allowMultiple,
      disabled,
      media,
      onClick,
      section,
      index,
      verticalAlign,
      onPointerEnter,
      onFocus
    }) {
      let {
        value: focused,
        toggle: toggleFocused
      } = useToggle.useToggle(!1), handleClick = React12.useCallback(() => {
        disabled || onClick(section, index);
      }, [disabled, index, onClick, section]), handlePointerEnter = React12.useCallback(() => {
        disabled || onPointerEnter(section, index);
      }, [disabled, onPointerEnter, section, index]), handleFocus = React12.useCallback(() => {
        toggleFocused(), onFocus(section, index);
      }, [toggleFocused, onFocus, section, index]), mediaMarkup = media ? /* @__PURE__ */ React12.createElement("div", {
        className: Option_module.default.Media
      }, media) : null, singleSelectClassName = css.classNames(Option_module.default.SingleSelectOption, focused && Option_module.default.focused, disabled && Option_module.default.disabled, select && Option_module.default.select, active && Option_module.default.active, verticalAlign && Option_module.default[css.variationName("verticalAlign", verticalAlign)]), multiSelectClassName = css.classNames(Option_module.default.Label, disabled && Option_module.default.disabled, active && Option_module.default.active, select && Option_module.default.select, verticalAlign && Option_module.default[css.variationName("verticalAlign", verticalAlign)], allowMultiple && Option_module.default.CheckboxLabel, allowMultiple && Option_module.default.MultiSelectOption), optionMarkup = allowMultiple ? /* @__PURE__ */ React12.createElement("label", {
        htmlFor: id,
        className: multiSelectClassName
      }, /* @__PURE__ */ React12.createElement("div", {
        className: Option_module.default.Checkbox
      }, /* @__PURE__ */ React12.createElement(Checkbox.Checkbox, {
        id,
        label: "",
        ariaDescribedBy: `${id}-label`,
        value,
        checked: select,
        disabled,
        onChange: handleClick
      })), mediaMarkup, /* @__PURE__ */ React12.createElement("span", {
        id: `${id}-label`
      }, label)) : /* @__PURE__ */ React12.createElement("button", {
        id,
        type: "button",
        className: singleSelectClassName,
        onClick: handleClick,
        disabled,
        onFocus: handleFocus,
        onBlur: toggleFocused,
        "aria-pressed": active || select
      }, /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        wrap: !1,
        blockAlign: verticalAlignToBlockAlign(verticalAlign)
      }, mediaMarkup, label), (select || active) && /* @__PURE__ */ React12.createElement("span", {
        className: Option_module.default.Icon
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.CheckIcon
      })))), scrollMarkup = active ? /* @__PURE__ */ React12.createElement(Scrollable.Scrollable.ScrollTo, null) : null;
      return /* @__PURE__ */ React12.createElement("li", {
        key: id,
        className: Option_module.default.Option,
        tabIndex: -1,
        onPointerEnter: handlePointerEnter
      }, scrollMarkup, optionMarkup);
    }
    function verticalAlignToBlockAlign(verticalAlign) {
      switch (verticalAlign) {
        case "top":
          return "start";
        case "center":
          return "center";
        case "bottom":
          return "end";
        default:
          return "start";
      }
    }
    exports.Option = Option;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/OptionList/OptionList.js
var require_OptionList = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/OptionList/OptionList.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), options = require_options2(), arrays = require_arrays(), useDeepEffect = require_use_deep_effect(), Option = require_Option2(), Box2 = require_Box(), BlockStack3 = require_BlockStack(), Text4 = require_Text();
    function OptionList({
      options: options2,
      sections,
      title,
      selected,
      allowMultiple,
      role,
      verticalAlign,
      onChange,
      id: idProp,
      onPointerEnterOption,
      onFocusOption
    }) {
      let [normalizedOptions, setNormalizedOptions] = React12.useState(createNormalizedOptions(options2, sections, title)), uniqId = React12.useId(), id = idProp ?? uniqId;
      useDeepEffect.useDeepEffect(() => {
        setNormalizedOptions(createNormalizedOptions(options2 || [], sections || [], title));
      }, [options2, sections, title], optionArraysAreEqual);
      let handleClick = React12.useCallback((sectionIndex, optionIndex) => {
        let selectedValue = normalizedOptions[sectionIndex].options[optionIndex].value, foundIndex = selected.indexOf(selectedValue);
        if (allowMultiple) {
          let newSelection = foundIndex === -1 ? [selectedValue, ...selected] : [...selected.slice(0, foundIndex), ...selected.slice(foundIndex + 1, selected.length)];
          onChange(newSelection);
          return;
        }
        onChange([selectedValue]);
      }, [normalizedOptions, selected, allowMultiple, onChange]), handlePointerEnter = React12.useCallback((sectionIndex, optionIndex) => {
        if (!onPointerEnterOption)
          return;
        let selectedValue = normalizedOptions[sectionIndex].options[optionIndex].value;
        onPointerEnterOption(selectedValue);
      }, [normalizedOptions, onPointerEnterOption]), handleFocus = React12.useCallback((sectionIndex, optionIndex) => {
        if (!onFocusOption)
          return;
        let selectedValue = normalizedOptions[sectionIndex].options[optionIndex].value;
        onFocusOption(selectedValue);
      }, [normalizedOptions, onFocusOption]), optionsMarkup = normalizedOptions.length > 0 ? normalizedOptions.map(({
        title: title2,
        options: options3
      }, sectionIndex) => {
        let isFirstOption = sectionIndex === 0, titleLevel = isFirstOption ? "h2" : "h3", titleMarkup = title2 ? /* @__PURE__ */ React12.createElement(Box2.Box, {
          paddingBlockStart: isFirstOption ? "050" : "300",
          paddingInlineStart: "150",
          paddingBlockEnd: "100",
          paddingInlineEnd: "150",
          borderColor: "border-secondary"
        }, /* @__PURE__ */ React12.createElement(Text4.Text, {
          as: titleLevel,
          variant: "headingSm"
        }, title2)) : null, optionsMarkup2 = options3 && options3.map((option2, optionIndex) => {
          let isSelected = selected.includes(option2.value), optionId = option2.id || `${id}-${sectionIndex}-${optionIndex}`;
          return /* @__PURE__ */ React12.createElement(Option.Option, Object.assign({
            key: optionId
          }, option2, {
            id: optionId,
            section: sectionIndex,
            index: optionIndex,
            onClick: handleClick,
            select: isSelected,
            allowMultiple,
            verticalAlign,
            onPointerEnter: handlePointerEnter,
            onFocus: handleFocus
          }));
        }), option = /* @__PURE__ */ React12.createElement(Box2.Box, {
          as: "ul",
          id: `${id}-${sectionIndex}`,
          role
        }, optionsMarkup2), blockStartPadding = isFirstOption ? title2 ? "100" : "0" : title2 ? "050" : "0";
        return /* @__PURE__ */ React12.createElement(Box2.Box, {
          key: title2 || `noTitle-${sectionIndex}`,
          as: "li",
          paddingBlockStart: blockStartPadding
        }, /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
          gap: isFirstOption && sections ? void 0 : "0"
        }, titleMarkup, option));
      }) : null;
      return /* @__PURE__ */ React12.createElement(Box2.Box, {
        as: "ul",
        role,
        padding: "150"
      }, optionsMarkup);
    }
    function createNormalizedOptions(options2, sections, title) {
      if (options2 == null) {
        let section = {
          options: [],
          title
        };
        return sections == null ? [] : [section, ...sections];
      }
      return sections == null ? [{
        title,
        options: options2
      }] : [{
        title,
        options: options2
      }, ...sections];
    }
    function optionArraysAreEqual(firstArray, secondArray) {
      return options.isSection(firstArray) && options.isSection(secondArray) ? arrays.arraysAreEqual(firstArray, secondArray, testSectionsPropEquality) : arrays.arraysAreEqual(firstArray, secondArray);
    }
    function testSectionsPropEquality(previousSection, currentSection) {
      let {
        options: previousOptions
      } = previousSection, {
        options: currentOptions
      } = currentSection, optionsAreEqual = arrays.arraysAreEqual(previousOptions, currentOptions), titlesAreEqual = previousSection.title === currentSection.title;
      return optionsAreEqual && titlesAreEqual;
    }
    exports.OptionList = OptionList;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/is-interface.js
var require_is_interface = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/is-interface.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react();
    function isInterface(x) {
      return !/* @__PURE__ */ React12.isValidElement(x) && x !== void 0;
    }
    exports.isInterface = isInterface;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/is-react-element.js
var require_is_react_element = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/is-react-element.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react();
    function isReactElement(x) {
      return /* @__PURE__ */ React12.isValidElement(x) && x !== void 0;
    }
    exports.isReactElement = isReactElement;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Page/Page.scss.js
var require_Page_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Page/Page.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Page: "Polaris-Page",
      fullWidth: "Polaris-Page--fullWidth",
      narrowWidth: "Polaris-Page--narrowWidth",
      Content: "Polaris-Page__Content"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Page/components/Header/Header.scss.js
var require_Header_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Page/components/Header/Header.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      TitleWrapper: "Polaris-Page-Header__TitleWrapper",
      BreadcrumbWrapper: "Polaris-Page-Header__BreadcrumbWrapper",
      PaginationWrapper: "Polaris-Page-Header__PaginationWrapper",
      PrimaryActionWrapper: "Polaris-Page-Header__PrimaryActionWrapper",
      Row: "Polaris-Page-Header__Row",
      mobileView: "Polaris-Page-Header--mobileView",
      RightAlign: "Polaris-Page-Header__RightAlign",
      noBreadcrumbs: "Polaris-Page-Header--noBreadcrumbs",
      AdditionalMetaData: "Polaris-Page-Header__AdditionalMetaData",
      Actions: "Polaris-Page-Header__Actions",
      longTitle: "Polaris-Page-Header--longTitle",
      mediumTitle: "Polaris-Page-Header--mediumTitle",
      isSingleRow: "Polaris-Page-Header--isSingleRow"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Page/components/Header/components/Title/Title.scss.js
var require_Title_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Page/components/Header/components/Title/Title.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Title: "Polaris-Header-Title",
      TitleWithSubtitle: "Polaris-Header-Title__TitleWithSubtitle",
      TitleWrapper: "Polaris-Header-Title__TitleWrapper",
      SubTitle: "Polaris-Header-Title__SubTitle",
      SubtitleCompact: "Polaris-Header-Title__SubtitleCompact"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Page/components/Header/components/Title/Title.js
var require_Title = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Page/components/Header/components/Title/Title.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Title_module = require_Title_scss(), Text4 = require_Text(), Bleed = require_Bleed();
    function Title({
      title,
      subtitle,
      titleMetadata,
      compactTitle
    }) {
      let className = css.classNames(Title_module.default.Title, subtitle && Title_module.default.TitleWithSubtitle), titleMarkup = title ? /* @__PURE__ */ React12.createElement("h1", {
        className
      }, title) : null, titleMetadataMarkup = titleMetadata ? /* @__PURE__ */ React12.createElement(Bleed.Bleed, {
        marginBlock: "100"
      }, titleMetadata) : null, wrappedTitleMarkup = /* @__PURE__ */ React12.createElement("div", {
        className: Title_module.default.TitleWrapper
      }, titleMarkup, titleMetadataMarkup), subtitleMarkup = subtitle ? /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(Title_module.default.SubTitle, compactTitle && Title_module.default.SubtitleCompact)
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "p",
        variant: "bodySm"
      }, subtitle)) : null;
      return /* @__PURE__ */ React12.createElement(React12.Fragment, null, wrappedTitleMarkup, subtitleMarkup);
    }
    exports.Title = Title;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Page/components/Header/Header.js
var require_Header4 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Page/components/Header/Header.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), components = require_components(), isInterface = require_is_interface(), isReactElement = require_is_react_element(), Header_module = require_Header_scss(), Breadcrumbs = require_Breadcrumbs(), Title = require_Title(), ActionMenu = require_ActionMenu(), FilterActionsProvider = require_FilterActionsProvider(), hooks2 = require_hooks2(), hooks$1 = require_hooks11(), Box2 = require_Box(), Pagination = require_Pagination(), Text4 = require_Text(), InlineStack2 = require_InlineStack(), utils = require_utils10(), Tooltip = require_Tooltip(), SHORT_TITLE = 20, REALLY_SHORT_TITLE = 8, LONG_TITLE = 34;
    function Header3({
      title,
      subtitle,
      pageReadyAccessibilityLabel,
      titleMetadata,
      additionalMetadata,
      titleHidden = !1,
      primaryAction,
      pagination,
      filterActions,
      backAction,
      secondaryActions = [],
      actionGroups = [],
      compactTitle = !1,
      onActionRollup
    }) {
      let i18n = hooks2.useI18n(), {
        isNavigationCollapsed
      } = hooks$1.useMediaQuery(), isSingleRow = !primaryAction && !pagination && (isInterface.isInterface(secondaryActions) && !secondaryActions.length || isReactElement.isReactElement(secondaryActions)) && !actionGroups.length, breadcrumbMarkup = backAction ? /* @__PURE__ */ React12.createElement("div", {
        className: Header_module.default.BreadcrumbWrapper
      }, /* @__PURE__ */ React12.createElement(Box2.Box, {
        maxWidth: "100%",
        paddingInlineEnd: "100",
        printHidden: !0
      }, /* @__PURE__ */ React12.createElement(Breadcrumbs.Breadcrumbs, {
        backAction
      }))) : null, paginationMarkup = pagination && !isNavigationCollapsed ? /* @__PURE__ */ React12.createElement("div", {
        className: Header_module.default.PaginationWrapper
      }, /* @__PURE__ */ React12.createElement(Box2.Box, {
        printHidden: !0
      }, /* @__PURE__ */ React12.createElement(Pagination.Pagination, Object.assign({}, pagination, {
        hasPrevious: pagination.hasPrevious,
        hasNext: pagination.hasNext
      })))) : null, pageTitleMarkup = /* @__PURE__ */ React12.createElement("div", {
        className: Header_module.default.TitleWrapper
      }, /* @__PURE__ */ React12.createElement(Title.Title, {
        title,
        subtitle,
        titleMetadata,
        compactTitle
      })), labelForPageReadyAccessibilityLabel = pageReadyAccessibilityLabel || title, pageReadyAccessibilityLabelMarkup = labelForPageReadyAccessibilityLabel ? /* @__PURE__ */ React12.createElement("div", {
        role: "status"
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        visuallyHidden: !0,
        as: "p"
      }, i18n.translate("Polaris.Page.Header.pageReadyAccessibilityLabel", {
        title: labelForPageReadyAccessibilityLabel
      }))) : void 0, primaryActionMarkup = primaryAction ? /* @__PURE__ */ React12.createElement(PrimaryActionMarkup, {
        primaryAction
      }) : null, actionMenuMarkup = null;
      isInterface.isInterface(secondaryActions) && (secondaryActions.length > 0 || ActionMenu.hasGroupsWithActions(actionGroups)) ? actionMenuMarkup = /* @__PURE__ */ React12.createElement(ActionMenu.ActionMenu, {
        actions: secondaryActions,
        groups: actionGroups,
        rollup: isNavigationCollapsed,
        rollupActionsLabel: title ? i18n.translate("Polaris.Page.Header.rollupActionsLabel", {
          title
        }) : void 0,
        onActionRollup
      }) : isReactElement.isReactElement(secondaryActions) && (actionMenuMarkup = /* @__PURE__ */ React12.createElement(React12.Fragment, null, secondaryActions));
      let navigationMarkup = breadcrumbMarkup || paginationMarkup ? /* @__PURE__ */ React12.createElement(Box2.Box, {
        printHidden: !0,
        paddingBlockEnd: "100",
        paddingInlineEnd: actionMenuMarkup && isNavigationCollapsed ? "1000" : void 0
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "400",
        align: "space-between",
        blockAlign: "center"
      }, breadcrumbMarkup, paginationMarkup)) : null, additionalMetadataMarkup = additionalMetadata ? /* @__PURE__ */ React12.createElement("div", {
        className: Header_module.default.AdditionalMetaData
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        tone: "subdued",
        as: "span",
        variant: "bodySm"
      }, additionalMetadata)) : null, headerClassNames = css.classNames(isSingleRow && Header_module.default.isSingleRow, navigationMarkup && Header_module.default.hasNavigation, actionMenuMarkup && Header_module.default.hasActionMenu, isNavigationCollapsed && Header_module.default.mobileView, !backAction && Header_module.default.noBreadcrumbs, title && title.length < LONG_TITLE && Header_module.default.mediumTitle, title && title.length > LONG_TITLE && Header_module.default.longTitle), {
        slot1,
        slot2,
        slot3,
        slot4,
        slot5
      } = determineLayout({
        actionMenuMarkup,
        additionalMetadataMarkup,
        breadcrumbMarkup,
        isNavigationCollapsed,
        pageTitleMarkup,
        paginationMarkup,
        primaryActionMarkup,
        title
      });
      return /* @__PURE__ */ React12.createElement(Box2.Box, {
        position: "relative",
        paddingBlockStart: {
          xs: "400",
          md: "600"
        },
        paddingBlockEnd: {
          xs: "400",
          md: "600"
        },
        paddingInlineStart: {
          xs: "400",
          sm: "0"
        },
        paddingInlineEnd: {
          xs: "400",
          sm: "0"
        },
        visuallyHidden: titleHidden
      }, pageReadyAccessibilityLabelMarkup, /* @__PURE__ */ React12.createElement("div", {
        className: headerClassNames
      }, /* @__PURE__ */ React12.createElement(FilterActionsProvider.FilterActionsProvider, {
        filterActions: !!filterActions
      }, /* @__PURE__ */ React12.createElement(components.ConditionalRender, {
        condition: [slot1, slot2, slot3, slot4].some(notNull2)
      }, /* @__PURE__ */ React12.createElement("div", {
        className: Header_module.default.Row
      }, slot1, slot2, /* @__PURE__ */ React12.createElement(components.ConditionalRender, {
        condition: [slot3, slot4].some(notNull2)
      }, /* @__PURE__ */ React12.createElement("div", {
        className: Header_module.default.RightAlign
      }, /* @__PURE__ */ React12.createElement(components.ConditionalWrapper, {
        condition: [slot3, slot4].every(notNull2),
        wrapper: (children) => /* @__PURE__ */ React12.createElement("div", {
          className: Header_module.default.Actions
        }, children)
      }, slot3, slot4))))), /* @__PURE__ */ React12.createElement(components.ConditionalRender, {
        condition: [slot5].some(notNull2)
      }, /* @__PURE__ */ React12.createElement("div", {
        className: Header_module.default.Row
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "400"
      }, slot5))))));
    }
    function PrimaryActionMarkup({
      primaryAction
    }) {
      let {
        isNavigationCollapsed
      } = hooks$1.useMediaQuery(), actionMarkup;
      if (isInterface.isInterface(primaryAction)) {
        let {
          primary: isPrimary,
          helpText
        } = primaryAction, primary = isPrimary === void 0 ? !0 : isPrimary, content = utils.buttonFrom(shouldShowIconOnly(isNavigationCollapsed, primaryAction), {
          variant: primary ? "primary" : void 0
        });
        actionMarkup = helpText ? /* @__PURE__ */ React12.createElement(Tooltip.Tooltip, {
          content: helpText
        }, content) : content;
      } else
        actionMarkup = primaryAction;
      return /* @__PURE__ */ React12.createElement("div", {
        className: Header_module.default.PrimaryActionWrapper
      }, /* @__PURE__ */ React12.createElement(Box2.Box, {
        printHidden: !0
      }, actionMarkup));
    }
    function shouldShowIconOnly(isMobile, action) {
      let {
        content,
        accessibilityLabel,
        icon
      } = action;
      return icon == null ? {
        ...action,
        icon: void 0
      } : (isMobile ? (accessibilityLabel = accessibilityLabel || content, content = void 0) : icon = void 0, {
        ...action,
        content,
        accessibilityLabel,
        icon
      });
    }
    function notNull2(value) {
      return value != null;
    }
    function determineLayout({
      actionMenuMarkup,
      additionalMetadataMarkup,
      breadcrumbMarkup,
      isNavigationCollapsed,
      pageTitleMarkup,
      paginationMarkup,
      primaryActionMarkup,
      title
    }) {
      let layouts = {
        mobileCompact: {
          slots: {
            slot1: null,
            slot2: pageTitleMarkup,
            slot3: actionMenuMarkup,
            slot4: primaryActionMarkup,
            slot5: additionalMetadataMarkup
          },
          condition: isNavigationCollapsed && breadcrumbMarkup == null && title != null && title.length <= REALLY_SHORT_TITLE
        },
        mobileDefault: {
          slots: {
            slot1: breadcrumbMarkup,
            slot2: pageTitleMarkup,
            slot3: actionMenuMarkup,
            slot4: primaryActionMarkup,
            slot5: additionalMetadataMarkup
          },
          condition: isNavigationCollapsed
        },
        desktopCompact: {
          slots: {
            slot1: breadcrumbMarkup,
            slot2: pageTitleMarkup,
            slot3: actionMenuMarkup,
            slot4: primaryActionMarkup,
            slot5: additionalMetadataMarkup
          },
          condition: !isNavigationCollapsed && paginationMarkup == null && actionMenuMarkup == null && title != null && title.length <= SHORT_TITLE
        },
        desktopDefault: {
          slots: {
            slot1: breadcrumbMarkup,
            slot2: pageTitleMarkup,
            slot3: /* @__PURE__ */ React12.createElement(React12.Fragment, null, actionMenuMarkup, primaryActionMarkup),
            slot4: paginationMarkup,
            slot5: additionalMetadataMarkup
          },
          condition: !isNavigationCollapsed
        }
      };
      return (Object.values(layouts).find((layout2) => layout2.condition) || layouts.desktopDefault).slots;
    }
    exports.Header = Header3;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Page/Page.js
var require_Page = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Page/Page.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), isInterface = require_is_interface(), isReactElement = require_is_react_element(), Page_module = require_Page_scss(), Header3 = require_Header4();
    function Page2({
      children,
      fullWidth,
      narrowWidth,
      ...rest
    }) {
      let pageClassName = css.classNames(Page_module.default.Page, fullWidth && Page_module.default.fullWidth, narrowWidth && Page_module.default.narrowWidth), hasHeaderContent = rest.title != null && rest.title !== "" || rest.subtitle != null && rest.subtitle !== "" || rest.primaryAction != null || rest.secondaryActions != null && (isInterface.isInterface(rest.secondaryActions) && rest.secondaryActions.length > 0 || isReactElement.isReactElement(rest.secondaryActions)) || rest.actionGroups != null && rest.actionGroups.length > 0 || rest.backAction != null, contentClassName = css.classNames(!hasHeaderContent && Page_module.default.Content), headerMarkup = hasHeaderContent ? /* @__PURE__ */ React12.createElement(Header3.Header, Object.assign({
        filterActions: !0
      }, rest)) : null;
      return /* @__PURE__ */ React12.createElement("div", {
        className: pageClassName
      }, headerMarkup, /* @__PURE__ */ React12.createElement("div", {
        className: contentClassName
      }, children));
    }
    exports.Page = Page2;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/PageActions/PageActions.scss.js
var require_PageActions_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/PageActions/PageActions.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      PageActions: "Polaris-PageActions"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/PageActions/PageActions.js
var require_PageActions = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/PageActions/PageActions.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), isInterface = require_is_interface(), isReactElement = require_is_react_element(), PageActions_module = require_PageActions_scss(), utils = require_utils10(), ButtonGroup = require_ButtonGroup(), LegacyStack = require_LegacyStack();
    function PageActions({
      primaryAction,
      secondaryActions
    }) {
      let primaryActionMarkup = null;
      isReactElement.isReactElement(primaryAction) ? primaryActionMarkup = /* @__PURE__ */ React12.createElement(React12.Fragment, null, primaryAction) : primaryAction && (primaryActionMarkup = utils.buttonsFrom(primaryAction, {
        variant: "primary"
      }));
      let secondaryActionsMarkup = null;
      return isInterface.isInterface(secondaryActions) && secondaryActions.length > 0 ? secondaryActionsMarkup = /* @__PURE__ */ React12.createElement(ButtonGroup.ButtonGroup, null, utils.buttonsFrom(secondaryActions)) : isReactElement.isReactElement(secondaryActions) && (secondaryActionsMarkup = /* @__PURE__ */ React12.createElement(React12.Fragment, null, secondaryActions)), /* @__PURE__ */ React12.createElement("div", {
        className: PageActions_module.default.PageActions
      }, /* @__PURE__ */ React12.createElement(LegacyStack.LegacyStack, {
        distribution: "trailing",
        spacing: "tight"
      }, secondaryActionsMarkup, primaryActionMarkup));
    }
    exports.PageActions = PageActions;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/PolarisTestProvider/PolarisTestProvider.js
var require_PolarisTestProvider = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/PolarisTestProvider/PolarisTestProvider.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisTokens = require_build2(), merge = require_merge2(), useTheme = require_use_theme(), I18n = require_I18n(), scrollLockManager = require_scroll_lock_manager(), stickyManager = require_sticky_manager(), context = require_context(), context$1 = require_context2(), context$2 = require_context3(), context$3 = require_context4(), context$4 = require_context5(), context$5 = require_context6(), PortalsManager = require_PortalsManager(), FocusManager = require_FocusManager(), EphemeralPresenceManager = require_EphemeralPresenceManager(), context$6 = require_context15(), defaultMediaQuery = {
      isNavigationCollapsed: !1
    };
    function PolarisTestProvider({
      strict,
      children,
      i18n,
      link: link2,
      mediaQuery,
      features,
      frame,
      theme = polarisTokens.themeNameDefault
    }) {
      let Wrapper = strict ? React12.StrictMode : React12.Fragment, intl = React12.useMemo(() => new I18n.I18n(i18n || {}), [i18n]), scrollLockManager$1 = React12.useMemo(() => new scrollLockManager.ScrollLockManager(), []), stickyManager$1 = React12.useMemo(() => new stickyManager.StickyManager(), []), mergedFrame = createFrameContext(frame), mergedMediaQuery = merge.merge(defaultMediaQuery, mediaQuery);
      return /* @__PURE__ */ React12.createElement(Wrapper, null, /* @__PURE__ */ React12.createElement(useTheme.ThemeContext.Provider, {
        value: useTheme.getTheme(theme)
      }, /* @__PURE__ */ React12.createElement(context.FeaturesContext.Provider, {
        value: features
      }, /* @__PURE__ */ React12.createElement(context$1.I18nContext.Provider, {
        value: intl
      }, /* @__PURE__ */ React12.createElement(context$2.ScrollLockManagerContext.Provider, {
        value: scrollLockManager$1
      }, /* @__PURE__ */ React12.createElement(context$3.StickyManagerContext.Provider, {
        value: stickyManager$1
      }, /* @__PURE__ */ React12.createElement(context$4.LinkContext.Provider, {
        value: link2
      }, /* @__PURE__ */ React12.createElement(context$5.MediaQueryContext.Provider, {
        value: mergedMediaQuery
      }, /* @__PURE__ */ React12.createElement(PortalsManager.PortalsManager, null, /* @__PURE__ */ React12.createElement(FocusManager.FocusManager, null, /* @__PURE__ */ React12.createElement(EphemeralPresenceManager.EphemeralPresenceManager, null, /* @__PURE__ */ React12.createElement(context$6.FrameContext.Provider, {
        value: mergedFrame
      }, children))))))))))));
    }
    function noop() {
    }
    function createFrameContext({
      logo = void 0,
      showToast = noop,
      hideToast = noop,
      toastMessages = [],
      setContextualSaveBar = noop,
      removeContextualSaveBar = noop,
      startLoading = noop,
      stopLoading = noop
    } = {}) {
      return {
        logo,
        showToast,
        hideToast,
        toastMessages,
        setContextualSaveBar,
        removeContextualSaveBar,
        startLoading,
        stopLoading
      };
    }
    exports.PolarisTestProvider = PolarisTestProvider;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ProgressBar/ProgressBar.scss.js
var require_ProgressBar_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ProgressBar/ProgressBar.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      ProgressBar: "Polaris-ProgressBar",
      sizeSmall: "Polaris-ProgressBar--sizeSmall",
      sizeMedium: "Polaris-ProgressBar--sizeMedium",
      sizeLarge: "Polaris-ProgressBar--sizeLarge",
      toneHighlight: "Polaris-ProgressBar--toneHighlight",
      tonePrimary: "Polaris-ProgressBar--tonePrimary",
      toneSuccess: "Polaris-ProgressBar--toneSuccess",
      toneCritical: "Polaris-ProgressBar--toneCritical",
      Indicator: "Polaris-ProgressBar__Indicator",
      IndicatorAppearActive: "Polaris-ProgressBar__IndicatorAppearActive",
      IndicatorAppearDone: "Polaris-ProgressBar__IndicatorAppearDone",
      Progress: "Polaris-ProgressBar__Progress",
      Label: "Polaris-ProgressBar__Label"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ProgressBar/ProgressBar.js
var require_ProgressBar = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ProgressBar/ProgressBar.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), reactTransitionGroup = require_cjs4(), css = require_css(), useTheme = require_use_theme(), ProgressBar_module = require_ProgressBar_scss(), hooks2 = require_hooks2();
    function ProgressBar({
      progress = 0,
      size = "medium",
      tone = "highlight",
      animated: hasAppearAnimation = !0,
      ariaLabelledBy
    }) {
      let theme = useTheme.useTheme(), i18n = hooks2.useI18n(), indicatorRef = React12.useRef(null), className = css.classNames(ProgressBar_module.default.ProgressBar, size && ProgressBar_module.default[css.variationName("size", size)], tone && ProgressBar_module.default[css.variationName("tone", tone)]), warningMessage = i18n.translate(progress < 0 ? "Polaris.ProgressBar.negativeWarningMessage" : "Polaris.ProgressBar.exceedWarningMessage", {
        progress
      }), parsedProgress = parseProgress(progress, warningMessage), progressBarDuration = hasAppearAnimation ? theme.motion["motion-duration-500"] : theme.motion["motion-duration-0"];
      return /* @__PURE__ */ React12.createElement("div", {
        className
      }, /* @__PURE__ */ React12.createElement("progress", {
        "aria-labelledby": ariaLabelledBy,
        className: ProgressBar_module.default.Progress,
        value: parsedProgress,
        max: "100"
      }), /* @__PURE__ */ React12.createElement(reactTransitionGroup.CSSTransition, {
        in: !0,
        appear: !0,
        timeout: parseInt(progressBarDuration, 10),
        nodeRef: indicatorRef,
        classNames: {
          appearActive: ProgressBar_module.default.IndicatorAppearActive,
          appearDone: ProgressBar_module.default.IndicatorAppearDone
        }
      }, /* @__PURE__ */ React12.createElement("div", {
        ref: indicatorRef,
        className: ProgressBar_module.default.Indicator,
        style: {
          "--pc-progress-bar-duration": progressBarDuration,
          "--pc-progress-bar-percent": parsedProgress / 100
        }
      }, /* @__PURE__ */ React12.createElement("span", {
        className: ProgressBar_module.default.Label
      }, parsedProgress, "%"))));
    }
    function parseProgress(progress, warningMessage) {
      let progressWidth;
      return progress < 0 ? (process.env.NODE_ENV === "development" && console.warn(warningMessage), progressWidth = 0) : progress > 100 ? (process.env.NODE_ENV === "development" && console.warn(warningMessage), progressWidth = 100) : progressWidth = progress, progressWidth;
    }
    exports.ProgressBar = ProgressBar;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RangeSlider/RangeSlider.scss.js
var require_RangeSlider_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RangeSlider/RangeSlider.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var sharedStyles = {
      RangeSlider: "Polaris-RangeSlider"
    };
    exports.default = sharedStyles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RangeSlider/components/DualThumb/DualThumb.scss.js
var require_DualThumb_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RangeSlider/components/DualThumb/DualThumb.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      DualThumb: "Polaris-RangeSlider-DualThumb",
      TrackWrapper: "Polaris-RangeSlider-DualThumb__TrackWrapper",
      disabled: "Polaris-RangeSlider-DualThumb--disabled",
      Track: "Polaris-RangeSlider-DualThumb__Track",
      error: "Polaris-RangeSlider-DualThumb--error",
      "Track--dashed": "Polaris-RangeSlider-DualThumb--trackDashed",
      Thumbs: "Polaris-RangeSlider-DualThumb__Thumbs",
      Prefix: "Polaris-RangeSlider-DualThumb__Prefix",
      Suffix: "Polaris-RangeSlider-DualThumb__Suffix",
      Output: "Polaris-RangeSlider-DualThumb__Output",
      OutputBubble: "Polaris-RangeSlider-DualThumb__OutputBubble"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RangeSlider/components/DualThumb/DualThumb.js
var require_DualThumb = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RangeSlider/components/DualThumb/DualThumb.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), debounce = require_debounce2(), css = require_css(), types = require_types7(), RangeSlider_module = require_RangeSlider_scss(), DualThumb_module = require_DualThumb_scss(), Text4 = require_Text(), Labelled = require_Labelled(), Label = require_Label(), EventListener = require_EventListener(), context = require_context(), Control;
    (function(Control2) {
      Control2[Control2.Lower = 0] = "Lower", Control2[Control2.Upper = 1] = "Upper";
    })(Control || (Control = {}));
    var DualThumb = class extends React12.Component {
      constructor(...args) {
        super(...args), this.state = {
          value: sanitizeValue(this.props.value, this.props.min, this.props.max, this.props.step),
          trackWidth: 0,
          trackLeft: 0
        }, this.track = /* @__PURE__ */ React12.createRef(), this.trackWrapper = /* @__PURE__ */ React12.createRef(), this.thumbLower = /* @__PURE__ */ React12.createRef(), this.thumbUpper = /* @__PURE__ */ React12.createRef(), this.setTrackPosition = debounce.debounce(() => {
          if (this.track.current) {
            let {
              width,
              left
            } = this.track.current.getBoundingClientRect(), adjustedTrackWidth = width - 16, adjustedTrackLeft = left + 16 / 2, range = this.props.max - this.props.min, minValuePosition = this.props.min / range * adjustedTrackWidth;
            this.setState({
              trackWidth: adjustedTrackWidth,
              trackLeft: adjustedTrackLeft - minValuePosition
            });
          }
        }, 40, {
          leading: !0,
          trailing: !0,
          maxWait: 40
        }), this.handleMouseDownThumbLower = (event) => {
          event.button !== 0 || this.props.disabled || (registerMouseMoveHandler(this.handleMouseMoveThumbLower), event.stopPropagation());
        }, this.handleMouseMoveThumbLower = (event) => {
          let valueUpper = this.state.value[1];
          this.setValue([this.actualXPosition(event.clientX), valueUpper], Control.Upper);
        }, this.handleTouchStartThumbLower = (event) => {
          this.props.disabled || (registerTouchMoveHandler(this.handleTouchMoveThumbLower), event.stopPropagation());
        }, this.handleTouchMoveThumbLower = (event) => {
          event.preventDefault();
          let valueUpper = this.state.value[1];
          this.setValue([this.actualXPosition(event.touches[0].clientX), valueUpper], Control.Upper);
        }, this.handleMouseDownThumbUpper = (event) => {
          event.button !== 0 || this.props.disabled || (registerMouseMoveHandler(this.handleMouseMoveThumbUpper), event.stopPropagation());
        }, this.handleMouseMoveThumbUpper = (event) => {
          let valueLower = this.state.value[0];
          this.setValue([valueLower, this.actualXPosition(event.clientX)], Control.Lower);
        }, this.handleTouchStartThumbUpper = (event) => {
          this.props.disabled || (registerTouchMoveHandler(this.handleTouchMoveThumbUpper), event.stopPropagation());
        }, this.handleTouchMoveThumbUpper = (event) => {
          event.preventDefault();
          let valueLower = this.state.value[0];
          this.setValue([valueLower, this.actualXPosition(event.touches[0].clientX)], Control.Lower);
        }, this.handleKeypressLower = (event) => {
          if (this.props.disabled)
            return;
          let {
            incrementValueLower,
            decrementValueLower
          } = this, handler = {
            [types.Key.UpArrow]: incrementValueLower,
            [types.Key.RightArrow]: incrementValueLower,
            [types.Key.DownArrow]: decrementValueLower,
            [types.Key.LeftArrow]: decrementValueLower
          }[event.keyCode];
          handler != null && (event.preventDefault(), event.stopPropagation(), handler());
        }, this.handleKeypressUpper = (event) => {
          if (this.props.disabled)
            return;
          let {
            incrementValueUpper,
            decrementValueUpper
          } = this, handler = {
            [types.Key.UpArrow]: incrementValueUpper,
            [types.Key.RightArrow]: incrementValueUpper,
            [types.Key.DownArrow]: decrementValueUpper,
            [types.Key.LeftArrow]: decrementValueUpper
          }[event.keyCode];
          handler != null && (event.preventDefault(), event.stopPropagation(), handler());
        }, this.incrementValueLower = () => {
          this.setValue([this.state.value[0] + this.props.step, this.state.value[1]], Control.Upper);
        }, this.decrementValueLower = () => {
          this.setValue([this.state.value[0] - this.props.step, this.state.value[1]], Control.Upper);
        }, this.incrementValueUpper = () => {
          this.setValue([this.state.value[0], this.state.value[1] + this.props.step], Control.Lower);
        }, this.decrementValueUpper = () => {
          this.setValue([this.state.value[0], this.state.value[1] - this.props.step], Control.Lower);
        }, this.dispatchValue = () => {
          let {
            onChange,
            id
          } = this.props, {
            value
          } = this.state;
          onChange(value, id);
        }, this.setValue = (dirtyValue, control) => {
          let {
            props: {
              min,
              max,
              step
            },
            state: {
              value
            }
          } = this, sanitizedValue = sanitizeValue(dirtyValue, min, max, step, control);
          isTupleEqual(sanitizedValue, value) === !1 && this.setState({
            value: sanitizedValue
          }, this.dispatchValue);
        }, this.handleMouseDownTrack = (event) => {
          if (event.button !== 0 || this.props.disabled)
            return;
          event.preventDefault();
          let clickXPosition = this.actualXPosition(event.clientX), {
            value
          } = this.state, distanceFromLowerThumb = Math.abs(value[0] - clickXPosition), distanceFromUpperThumb = Math.abs(value[1] - clickXPosition);
          distanceFromLowerThumb <= distanceFromUpperThumb ? (this.setValue([clickXPosition, value[1]], Control.Upper), registerMouseMoveHandler(this.handleMouseMoveThumbLower), this.thumbLower.current != null && this.thumbLower.current.focus()) : (this.setValue([value[0], clickXPosition], Control.Lower), registerMouseMoveHandler(this.handleMouseMoveThumbUpper), this.thumbUpper.current != null && this.thumbUpper.current.focus());
        }, this.handleTouchStartTrack = (event) => {
          if (this.props.disabled)
            return;
          event.preventDefault();
          let clickXPosition = this.actualXPosition(event.touches[0].clientX), {
            value
          } = this.state, distanceFromLowerThumb = Math.abs(value[0] - clickXPosition), distanceFromUpperThumb = Math.abs(value[1] - clickXPosition);
          distanceFromLowerThumb <= distanceFromUpperThumb ? (this.setValue([clickXPosition, value[1]], Control.Upper), registerTouchMoveHandler(this.handleTouchMoveThumbLower), this.thumbLower.current != null && this.thumbLower.current.focus()) : (this.setValue([value[0], clickXPosition], Control.Lower), registerTouchMoveHandler(this.handleTouchMoveThumbUpper), this.thumbUpper.current != null && this.thumbUpper.current.focus());
        }, this.actualXPosition = (dirtyXPosition) => {
          if (this.track.current) {
            let {
              min,
              max
            } = this.props, {
              trackLeft,
              trackWidth
            } = this.state;
            return (dirtyXPosition - trackLeft) / trackWidth * (max - min);
          } else
            return 0;
        };
      }
      static getDerivedStateFromProps(props, state) {
        let {
          min,
          step,
          max,
          value,
          onChange,
          id
        } = props, {
          prevValue
        } = state;
        if (isTupleEqual(prevValue, value))
          return null;
        let sanitizedValue = sanitizeValue(value, min, max, step);
        return isTupleEqual(value, sanitizedValue) || onChange(sanitizedValue, id), {
          prevValue: value,
          value: sanitizedValue
        };
      }
      componentDidMount() {
        this.setTrackPosition(), this.trackWrapper.current != null && this.trackWrapper.current.addEventListener("touchstart", this.handleTouchStartTrack, {
          passive: !1
        });
      }
      componentWillUnmount() {
        this.trackWrapper.current != null && this.trackWrapper.current.removeEventListener("touchstart", this.handleTouchStartTrack);
      }
      render() {
        let {
          id,
          min,
          max,
          prefix,
          suffix,
          disabled,
          output,
          error,
          onFocus,
          onBlur,
          label,
          labelAction,
          labelHidden,
          helpText
        } = this.props, {
          value
        } = this.state, idLower = id, idUpper = `${id}Upper`, describedBy = [];
        error && describedBy.push(`${id}Error`);
        let ariaDescribedBy = describedBy.length ? describedBy.join(" ") : void 0, trackWrapperClassName = css.classNames(DualThumb_module.default.TrackWrapper, error && DualThumb_module.default.error, disabled && DualThumb_module.default.disabled), thumbLowerClassName = css.classNames(DualThumb_module.default.Thumbs, DualThumb_module.default.ThumbLower, disabled && DualThumb_module.default.disabled), thumbUpperClassName = css.classNames(DualThumb_module.default.Thumbs, DualThumb_module.default.ThumbUpper, disabled && DualThumb_module.default.disabled), trackWidth = this.state.trackWidth, range = max - min, minValuePosition = min / range * trackWidth, leftPositionThumbLower = value[0] / range * trackWidth - minValuePosition, leftPositionThumbUpper = value[1] / range * trackWidth - minValuePosition, outputLowerClassName = css.classNames(DualThumb_module.default.Output, DualThumb_module.default.OutputLower), outputMarkupLower = !disabled && output ? /* @__PURE__ */ React12.createElement("output", {
          htmlFor: idLower,
          className: outputLowerClassName,
          style: {
            left: `${leftPositionThumbLower}px`
          }
        }, /* @__PURE__ */ React12.createElement("div", {
          className: DualThumb_module.default.OutputBubble
        }, /* @__PURE__ */ React12.createElement(Text4.Text, {
          as: "span",
          variant: "headingSm",
          alignment: "center"
        }, value[0]))) : null, outputUpperClassName = css.classNames(DualThumb_module.default.Output, DualThumb_module.default.OutputUpper), outputMarkupUpper = !disabled && output ? /* @__PURE__ */ React12.createElement("output", {
          htmlFor: idUpper,
          className: outputUpperClassName,
          style: {
            left: `${leftPositionThumbUpper}px`
          }
        }, /* @__PURE__ */ React12.createElement("div", {
          className: DualThumb_module.default.OutputBubble
        }, /* @__PURE__ */ React12.createElement(Text4.Text, {
          as: "span",
          variant: "headingSm",
          alignment: "center"
        }, value[1]))) : null, cssVars = {
          "--pc-range-slider-progress-lower": `${leftPositionThumbLower}px`,
          "--pc-range-slider-progress-upper": `${leftPositionThumbUpper}px`
        }, prefixMarkup = prefix && /* @__PURE__ */ React12.createElement("div", {
          className: DualThumb_module.default.Prefix
        }, prefix), suffixMarkup = suffix && /* @__PURE__ */ React12.createElement("div", {
          className: DualThumb_module.default.Suffix
        }, suffix);
        return /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement(Labelled.Labelled, {
          id,
          label,
          error,
          action: labelAction,
          labelHidden,
          helpText
        }, /* @__PURE__ */ React12.createElement("div", {
          className: css.classNames(DualThumb_module.default.DualThumb, RangeSlider_module.default.RangeSlider)
        }, prefixMarkup, /* @__PURE__ */ React12.createElement("div", {
          className: trackWrapperClassName,
          onMouseDown: this.handleMouseDownTrack,
          ref: this.trackWrapper
        }, /* @__PURE__ */ React12.createElement("div", {
          className: DualThumb_module.default.Track,
          style: cssVars,
          ref: this.track
        }), /* @__PURE__ */ React12.createElement("div", {
          className: DualThumb_module.default["Track--dashed"]
        }), /* @__PURE__ */ React12.createElement("div", {
          id: idLower,
          className: thumbLowerClassName,
          style: {
            left: `${leftPositionThumbLower}px`
          },
          role: "slider",
          "aria-disabled": disabled,
          "aria-valuemin": min,
          "aria-valuemax": max,
          "aria-valuenow": value[0],
          "aria-invalid": !!error,
          "aria-describedby": ariaDescribedBy,
          "aria-labelledby": Label.labelID(id),
          onFocus,
          onBlur,
          tabIndex: 0,
          onKeyDown: this.handleKeypressLower,
          onMouseDown: this.handleMouseDownThumbLower,
          onTouchStart: this.handleTouchStartThumbLower,
          ref: this.thumbLower
        }), outputMarkupLower, /* @__PURE__ */ React12.createElement("div", {
          id: idUpper,
          className: thumbUpperClassName,
          style: {
            left: `${leftPositionThumbUpper}px`
          },
          role: "slider",
          "aria-disabled": disabled,
          "aria-valuemin": min,
          "aria-valuemax": max,
          "aria-valuenow": value[1],
          "aria-invalid": !!error,
          "aria-describedby": ariaDescribedBy,
          "aria-labelledby": Label.labelID(id),
          onFocus,
          onBlur,
          tabIndex: 0,
          onKeyDown: this.handleKeypressUpper,
          onMouseDown: this.handleMouseDownThumbUpper,
          onTouchStart: this.handleTouchStartThumbUpper,
          ref: this.thumbUpper
        }), outputMarkupUpper), suffixMarkup)), /* @__PURE__ */ React12.createElement(EventListener.EventListener, {
          event: "resize",
          handler: this.setTrackPosition
        }));
      }
    };
    DualThumb.contextType = context.FeaturesContext;
    function registerMouseMoveHandler(handler) {
      document.addEventListener("mousemove", handler), document.addEventListener("mouseup", () => {
        document.removeEventListener("mousemove", handler);
      }, {
        once: !0
      });
    }
    function registerTouchMoveHandler(handler) {
      let removeHandler = () => {
        document.removeEventListener("touchmove", handler), document.removeEventListener("touchend", removeHandler), document.removeEventListener("touchcancel", removeHandler);
      };
      document.addEventListener("touchmove", handler, {
        passive: !1
      }), document.addEventListener("touchend", removeHandler, {
        once: !0
      }), document.addEventListener("touchcancel", removeHandler, {
        once: !0
      });
    }
    function sanitizeValue(value, min, max, step, control = Control.Upper) {
      let upperValue = inBoundsUpper(roundedToStep(value[1])), lowerValue = inBoundsLower(roundedToStep(value[0])), maxLowerValue = upperValue - step, minUpperValue = lowerValue + step;
      return control === Control.Upper && lowerValue > maxLowerValue ? lowerValue = maxLowerValue : control === Control.Lower && upperValue < minUpperValue && (upperValue = minUpperValue), [lowerValue, upperValue];
      function inBoundsUpper(value2) {
        let lowerMin = min + step;
        return value2 < lowerMin ? lowerMin : value2 > max ? max : value2;
      }
      function inBoundsLower(value2) {
        let upperMax = max - step;
        return value2 < min ? min : value2 > upperMax ? upperMax : value2;
      }
      function roundedToStep(value2) {
        return Math.round(value2 / step) * step;
      }
    }
    function isTupleEqual(a, b) {
      return a == null || b == null ? !1 : a[0] === b[0] && a[1] === b[1];
    }
    exports.DualThumb = DualThumb;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RangeSlider/components/SingleThumb/SingleThumb.scss.js
var require_SingleThumb_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RangeSlider/components/SingleThumb/SingleThumb.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      SingleThumb: "Polaris-RangeSlider-SingleThumb",
      disabled: "Polaris-RangeSlider-SingleThumb--disabled",
      InputWrapper: "Polaris-RangeSlider-SingleThumb__InputWrapper",
      Prefix: "Polaris-RangeSlider-SingleThumb__Prefix",
      Suffix: "Polaris-RangeSlider-SingleThumb__Suffix",
      Input: "Polaris-RangeSlider-SingleThumb__Input",
      error: "Polaris-RangeSlider-SingleThumb--error",
      Output: "Polaris-RangeSlider-SingleThumb__Output",
      OutputBubble: "Polaris-RangeSlider-SingleThumb__OutputBubble"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RangeSlider/utilities/invertNumber.js
var require_invertNumber = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RangeSlider/utilities/invertNumber.js"(exports) {
    "use strict";
    init_cjs_shims();
    function invertNumber(number) {
      return Math.sign(number) === 1 ? -Math.abs(number) : Math.sign(number) === -1 ? Math.abs(number) : 0;
    }
    exports.invertNumber = invertNumber;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RangeSlider/components/SingleThumb/SingleThumb.js
var require_SingleThumb = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RangeSlider/components/SingleThumb/SingleThumb.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), clamp = require_clamp(), RangeSlider_module = require_RangeSlider_scss(), SingleThumb_module = require_SingleThumb_scss(), invertNumber = require_invertNumber(), Text4 = require_Text(), Labelled = require_Labelled();
    function SingleThumb(props) {
      let {
        id,
        error,
        helpText,
        value,
        min,
        max,
        disabled,
        output,
        prefix,
        suffix,
        label,
        labelAction,
        labelHidden,
        step,
        onBlur,
        onFocus
      } = props, clampedValue = clamp.clamp(value, min, max), describedBy = [];
      error && describedBy.push(`${id}Error`), helpText && describedBy.push(Labelled.helpTextID(id));
      let ariaDescribedBy = describedBy.length ? describedBy.join(" ") : void 0, sliderProgress = (clampedValue - min) * 100 / (max - min), outputFactor = invertNumber.invertNumber((sliderProgress - 50) / 100), cssVars = {
        "--pc-range-slider-min": min,
        "--pc-range-slider-max": max,
        "--pc-range-slider-current": clampedValue,
        "--pc-range-slider-progress": `${sliderProgress}%`,
        "--pc-range-slider-output-factor": `${outputFactor}`
      }, outputMarkup = !disabled && output && /* @__PURE__ */ React12.createElement("output", {
        htmlFor: id,
        className: SingleThumb_module.default.Output
      }, /* @__PURE__ */ React12.createElement("div", {
        className: SingleThumb_module.default.OutputBubble
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        variant: "headingSm",
        alignment: "center"
      }, clampedValue))), prefixMarkup = prefix && /* @__PURE__ */ React12.createElement("div", {
        className: SingleThumb_module.default.Prefix
      }, prefix), suffixMarkup = suffix && /* @__PURE__ */ React12.createElement("div", {
        className: SingleThumb_module.default.Suffix
      }, suffix), className = css.classNames(SingleThumb_module.default.SingleThumb, RangeSlider_module.default.RangeSlider, error && SingleThumb_module.default.error, disabled && SingleThumb_module.default.disabled);
      return /* @__PURE__ */ React12.createElement(Labelled.Labelled, {
        id,
        label,
        error,
        action: labelAction,
        labelHidden,
        helpText
      }, /* @__PURE__ */ React12.createElement("div", {
        className,
        style: cssVars
      }, prefixMarkup, /* @__PURE__ */ React12.createElement("div", {
        className: SingleThumb_module.default.InputWrapper
      }, /* @__PURE__ */ React12.createElement("input", {
        type: "range",
        className: SingleThumb_module.default.Input,
        id,
        name: id,
        min,
        max,
        step,
        value: clampedValue,
        disabled,
        onChange: handleChange,
        onFocus,
        onBlur,
        "aria-valuemin": min,
        "aria-valuemax": max,
        "aria-valuenow": clampedValue,
        "aria-invalid": !!error,
        "aria-describedby": ariaDescribedBy
      }), outputMarkup), suffixMarkup));
      function handleChange(event) {
        let {
          onChange
        } = props;
        onChange && onChange(parseFloat(event.currentTarget.value), id);
      }
    }
    exports.SingleThumb = SingleThumb;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RangeSlider/RangeSlider.js
var require_RangeSlider = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/RangeSlider/RangeSlider.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), DualThumb = require_DualThumb(), SingleThumb = require_SingleThumb();
    function RangeSlider({
      min = 0,
      max = 100,
      step = 1,
      value,
      ...rest
    }) {
      let sharedProps = {
        id: React12.useId(),
        min,
        max,
        step,
        ...rest
      };
      return isDualThumb(value) ? /* @__PURE__ */ React12.createElement(DualThumb.DualThumb, Object.assign({
        value
      }, sharedProps)) : /* @__PURE__ */ React12.createElement(SingleThumb.SingleThumb, Object.assign({
        value
      }, sharedProps));
    }
    function isDualThumb(value) {
      return Array.isArray(value);
    }
    exports.RangeSlider = RangeSlider;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ResourceItem/ResourceItem.scss.js
var require_ResourceItem_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ResourceItem/ResourceItem.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      ResourceItem: "Polaris-ResourceItem",
      Actions: "Polaris-ResourceItem__Actions",
      ItemWrapper: "Polaris-ResourceItem__ItemWrapper",
      CheckboxWrapper: "Polaris-ResourceItem__CheckboxWrapper",
      focusedInner: "Polaris-ResourceItem--focusedInner",
      focused: "Polaris-ResourceItem--focused",
      selected: "Polaris-ResourceItem--selected",
      Link: "Polaris-ResourceItem__Link",
      Button: "Polaris-ResourceItem__Button",
      selectable: "Polaris-ResourceItem--selectable",
      ListItem: "Polaris-ResourceItem__ListItem",
      hasBulkActions: "Polaris-ResourceItem--hasBulkActions"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/resource-list/types.js
var require_types12 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/resource-list/types.js"(exports) {
    "use strict";
    init_cjs_shims();
    var SELECT_ALL_ITEMS = "All";
    exports.SELECT_ALL_ITEMS = SELECT_ALL_ITEMS;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ResourceItem/ResourceItem.js
var require_ResourceItem = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ResourceItem/ResourceItem.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), isEqual = require_react_fast_compare(), breakpoints = require_breakpoints2(), css = require_css(), ResourceItem_module = require_ResourceItem_scss(), types = require_types12(), context = require_context19(), hooks2 = require_hooks2(), Checkbox = require_Checkbox(), ButtonGroup = require_ButtonGroup(), utils = require_utils10(), Popover = require_Popover(), Button2 = require_Button(), ActionList = require_ActionList(), Box2 = require_Box(), InlineGrid = require_InlineGrid(), InlineStack2 = require_InlineStack(), UnstyledLink = require_UnstyledLink(), BaseResourceItem = class extends React12.Component {
      constructor(...args) {
        super(...args), this.state = {
          actionsMenuVisible: !1,
          focused: !1,
          focusedInner: !1,
          selected: isSelected(this.props.id, this.props.context.selectedItems)
        }, this.node = null, this.overlayRef = /* @__PURE__ */ React12.createRef(), this.buttonOverlay = /* @__PURE__ */ React12.createRef(), this.setNode = (node) => {
          this.node = node;
        }, this.handleFocus = (event) => {
          event.target === this.buttonOverlay.current || this.node && event.target === this.overlayRef.current ? this.setState({
            focused: !0,
            focusedInner: !1
          }) : this.node && this.node.contains(event.target) && this.setState({
            focused: !0,
            focusedInner: !0
          });
        }, this.handleBlur = ({
          relatedTarget
        }) => {
          this.node && relatedTarget instanceof Element && this.node.contains(relatedTarget) || this.setState({
            focused: !1,
            focusedInner: !1
          });
        }, this.handleMouseOut = () => {
          this.state.focused && this.setState({
            focused: !1,
            focusedInner: !1
          }), this.props.onMouseOut && this.props.onMouseOut();
        }, this.handleLargerSelectionArea = (event) => {
          stopPropagation(event), this.handleSelection(!this.state.selected, event.nativeEvent.shiftKey);
        }, this.handleSelection = (value, shiftKey) => {
          let {
            id,
            sortOrder,
            context: {
              onSelectionChange
            }
          } = this.props;
          id == null || onSelectionChange == null || (this.setState({
            focused: value,
            focusedInner: value
          }), onSelectionChange(value, id, sortOrder, shiftKey));
        }, this.handleClick = (event) => {
          stopPropagation(event);
          let {
            id,
            onClick,
            url,
            context: {
              selectMode
            }
          } = this.props, {
            ctrlKey,
            metaKey
          } = event.nativeEvent, anchor = this.node && this.node.querySelector("a");
          if (selectMode) {
            this.handleLargerSelectionArea(event);
            return;
          }
          if (anchor !== event.target) {
            if (onClick && onClick(id), url && (ctrlKey || metaKey)) {
              window.open(url, "_blank");
              return;
            }
            url && anchor && anchor.click();
          }
        }, this.handleKeyUp = (event) => {
          let {
            onClick = noop,
            context: {
              selectMode
            }
          } = this.props, {
            key
          } = event;
          key === "Enter" && this.props.url && !selectMode && onClick();
        }, this.handleActionsClick = () => {
          this.setState(({
            actionsMenuVisible
          }) => ({
            actionsMenuVisible: !actionsMenuVisible
          }));
        }, this.handleCloseRequest = () => {
          this.setState({
            actionsMenuVisible: !1
          });
        };
      }
      static getDerivedStateFromProps(nextProps, prevState) {
        let selected = isSelected(nextProps.id, nextProps.context.selectedItems);
        return prevState.selected === selected ? null : {
          selected
        };
      }
      shouldComponentUpdate(nextProps, nextState) {
        let {
          children: nextChildren,
          context: {
            selectedItems: nextSelectedItems,
            ...restNextContext
          },
          ...restNextProps
        } = nextProps, {
          children,
          context: {
            selectedItems,
            ...restContext
          },
          ...restProps
        } = this.props, nextSelectMode = nextProps.context.selectMode;
        return !isEqual(this.state, nextState) || this.props.context.selectMode !== nextSelectMode || !nextProps.context.selectMode && (!isEqual(restProps, restNextProps) || !isEqual(restContext, restNextContext));
      }
      render() {
        let {
          children,
          url,
          external,
          media,
          shortcutActions,
          ariaControls,
          ariaExpanded,
          persistActions = !1,
          accessibilityLabel,
          name,
          context: {
            selectable,
            selectMode,
            hasBulkActions,
            loading,
            resourceName
          },
          i18n,
          verticalAlignment,
          dataHref,
          breakpoints: breakpoints2,
          onMouseOver
        } = this.props, {
          actionsMenuVisible,
          focused,
          focusedInner,
          selected
        } = this.state, ownedMarkup = null, handleMarkup = null;
        if (selectable) {
          let checkboxAccessibilityLabel = name || accessibilityLabel || i18n.translate("Polaris.Common.checkbox");
          handleMarkup = /* @__PURE__ */ React12.createElement("div", {
            className: ResourceItem_module.default.CheckboxWrapper,
            onClick: stopPropagation,
            onChange: this.handleLargerSelectionArea
          }, /* @__PURE__ */ React12.createElement(UseId, null, (id) => /* @__PURE__ */ React12.createElement(Checkbox.Checkbox, {
            id,
            label: checkboxAccessibilityLabel,
            labelHidden: !0,
            checked: selected,
            disabled: loading,
            bleedInlineStart: "300",
            bleedInlineEnd: "300",
            bleedBlockStart: "300",
            bleedBlockEnd: "300",
            fill: !0,
            labelClassName: ResourceItem_module.default.CheckboxLabel
          })));
        }
        (media || selectable) && (ownedMarkup = /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
          gap: "300",
          blockAlign: media && selectable ? "center" : getAlignment(verticalAlignment)
        }, handleMarkup, media));
        let className = css.classNames(ResourceItem_module.default.ResourceItem, focused && ResourceItem_module.default.focused, selectable && ResourceItem_module.default.selectable, selected && ResourceItem_module.default.selected, selectMode && ResourceItem_module.default.selectMode, persistActions && ResourceItem_module.default.persistActions, focusedInner && ResourceItem_module.default.focusedInner), listItemClassName = css.classNames(ResourceItem_module.default.ListItem, focused && !focusedInner && ResourceItem_module.default.focused, hasBulkActions && ResourceItem_module.default.hasBulkActions, selected && ResourceItem_module.default.selected, selectable && ResourceItem_module.default.selectable), actionsMarkup = null, disclosureMarkup = null;
        if (shortcutActions && !loading)
          if (persistActions) {
            actionsMarkup = breakpoints2?.lgUp ? /* @__PURE__ */ React12.createElement("div", {
              className: ResourceItem_module.default.Actions,
              onClick: stopPropagation
            }, /* @__PURE__ */ React12.createElement(ButtonGroup.ButtonGroup, null, utils.buttonsFrom(shortcutActions, {
              variant: "tertiary"
            }))) : null;
            let disclosureAccessibilityLabel = name ? i18n.translate("Polaris.ResourceList.Item.actionsDropdownLabel", {
              accessibilityLabel: name
            }) : i18n.translate("Polaris.ResourceList.Item.actionsDropdown");
            disclosureMarkup = !selectMode && breakpoints2?.lgDown ? /* @__PURE__ */ React12.createElement("div", {
              onClick: stopPropagation
            }, /* @__PURE__ */ React12.createElement(Popover.Popover, {
              activator: /* @__PURE__ */ React12.createElement(Button2.Button, {
                accessibilityLabel: disclosureAccessibilityLabel,
                onClick: this.handleActionsClick,
                variant: "tertiary",
                icon: polarisIcons.MenuHorizontalIcon
              }),
              onClose: this.handleCloseRequest,
              active: actionsMenuVisible
            }, /* @__PURE__ */ React12.createElement(ActionList.ActionList, {
              items: shortcutActions
            }))) : null;
          } else
            breakpoints2?.lgUp && (actionsMarkup = /* @__PURE__ */ React12.createElement("div", {
              className: ResourceItem_module.default.Actions,
              onClick: stopPropagation
            }, /* @__PURE__ */ React12.createElement(Box2.Box, {
              position: "absolute",
              insetBlockStart: "400",
              insetInlineEnd: "500"
            }, /* @__PURE__ */ React12.createElement(ButtonGroup.ButtonGroup, {
              variant: "segmented"
            }, utils.buttonsFrom(shortcutActions, {
              size: "slim"
            })))));
        let containerMarkup = /* @__PURE__ */ React12.createElement(Box2.Box, {
          id: this.props.id,
          position: "relative",
          paddingInlineStart: "300",
          paddingInlineEnd: "300",
          paddingBlockStart: "300",
          paddingBlockEnd: "300",
          zIndex: "var(--pc-resource-item-content-stacking-order)"
        }, /* @__PURE__ */ React12.createElement(InlineGrid.InlineGrid, {
          columns: {
            xs: "1fr auto"
          }
        }, /* @__PURE__ */ React12.createElement(InlineGrid.InlineGrid, {
          columns: {
            xs: media || selectable ? "auto 1fr" : "1fr"
          },
          gap: "300"
        }, ownedMarkup, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
          blockAlign: getAlignment(verticalAlignment)
        }, /* @__PURE__ */ React12.createElement(Box2.Box, {
          width: "100%",
          padding: "0"
        }, children))), actionsMarkup, disclosureMarkup)), tabIndex = loading ? -1 : 0, ariaLabel = accessibilityLabel || i18n.translate("Polaris.ResourceList.Item.viewItem", {
          itemName: name || resourceName && resourceName.singular || ""
        }), accessibleMarkup = url ? /* @__PURE__ */ React12.createElement(UseId, null, (id) => /* @__PURE__ */ React12.createElement(UnstyledLink.UnstyledLink, {
          "aria-describedby": this.props.id,
          "aria-label": ariaLabel,
          className: ResourceItem_module.default.Link,
          url,
          external,
          tabIndex,
          id,
          ref: this.overlayRef
        })) : /* @__PURE__ */ React12.createElement("button", {
          className: ResourceItem_module.default.Button,
          "aria-label": ariaLabel,
          "aria-controls": ariaControls,
          "aria-expanded": ariaExpanded,
          onClick: this.handleClick,
          tabIndex,
          ref: this.buttonOverlay
        });
        return /* @__PURE__ */ React12.createElement("li", {
          className: listItemClassName,
          "data-href": dataHref
        }, /* @__PURE__ */ React12.createElement("div", {
          className: ResourceItem_module.default.ItemWrapper
        }, /* @__PURE__ */ React12.createElement("div", {
          ref: this.setNode,
          className,
          onClick: this.handleClick,
          onFocus: this.handleFocus,
          onBlur: this.handleBlur,
          onKeyUp: this.handleKeyUp,
          onMouseOver,
          onMouseOut: this.handleMouseOut,
          "data-href": url
        }, accessibleMarkup, containerMarkup)));
      }
      // This fires onClick when there is a URL on the item
    };
    function noop() {
    }
    function stopPropagation(event) {
      event.stopPropagation();
    }
    function isSelected(id, selectedItems) {
      return !!(selectedItems && (Array.isArray(selectedItems) && selectedItems.includes(id) || selectedItems === types.SELECT_ALL_ITEMS));
    }
    function ResourceItem(props) {
      let breakpoints$1 = breakpoints.useBreakpoints();
      return /* @__PURE__ */ React12.createElement(BaseResourceItem, Object.assign({}, props, {
        breakpoints: breakpoints$1,
        context: React12.useContext(context.ResourceListContext),
        i18n: hooks2.useI18n()
      }));
    }
    function getAlignment(alignment) {
      switch (alignment) {
        case "leading":
          return "start";
        case "trailing":
          return "end";
        case "center":
          return "center";
        case "fill":
          return "stretch";
        case "baseline":
          return "baseline";
        default:
          return "start";
      }
    }
    function UseId(props) {
      let id = React12.useId();
      return props.children(id);
    }
    exports.ResourceItem = ResourceItem;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ResourceList/ResourceList.scss.js
var require_ResourceList_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ResourceList/ResourceList.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      FiltersWrapper: "Polaris-ResourceList__FiltersWrapper",
      ResourceList: "Polaris-ResourceList",
      HeaderOuterWrapper: "Polaris-ResourceList__HeaderOuterWrapper",
      BulkActionsWrapper: "Polaris-ResourceList__BulkActionsWrapper",
      "HeaderWrapper-disabled": "Polaris-ResourceList__HeaderWrapper--disabled",
      "HeaderWrapper-overlay": "Polaris-ResourceList__HeaderWrapper--overlay",
      HeaderWrapper: "Polaris-ResourceList__HeaderWrapper",
      "HeaderWrapper-isSticky": "Polaris-ResourceList__HeaderWrapper--isSticky",
      HeaderContentWrapper: "Polaris-ResourceList__HeaderContentWrapper",
      "HeaderWrapper-inSelectMode": "Polaris-ResourceList__HeaderWrapper--inSelectMode",
      SortWrapper: "Polaris-ResourceList__SortWrapper",
      AlternateToolWrapper: "Polaris-ResourceList__AlternateToolWrapper",
      "HeaderWrapper-hasSelect": "Polaris-ResourceList__HeaderWrapper--hasSelect",
      "HeaderWrapper-hasAlternateTool": "Polaris-ResourceList__HeaderWrapper--hasAlternateTool",
      "HeaderWrapper-hasSort": "Polaris-ResourceList__HeaderWrapper--hasSort",
      HeaderTitleWrapper: "Polaris-ResourceList__HeaderTitleWrapper",
      BulkActionsWrapperSticky: "Polaris-ResourceList__BulkActionsWrapperSticky",
      SelectAllActionsWrapper: "Polaris-ResourceList__SelectAllActionsWrapper",
      CheckableButtonWrapper: "Polaris-ResourceList__CheckableButtonWrapper",
      SelectButtonWrapper: "Polaris-ResourceList__SelectButtonWrapper",
      EmptySearchResultWrapper: "Polaris-ResourceList__EmptySearchResultWrapper",
      ResourceListWrapper: "Polaris-ResourceList__ResourceListWrapper",
      ResourceListWrapperWithBulkActions: "Polaris-ResourceList__ResourceListWrapperWithBulkActions",
      ItemWrapper: "Polaris-ResourceList__ItemWrapper",
      "ItemWrapper-isLoading": "Polaris-ResourceList__ItemWrapper--isLoading",
      SpinnerContainer: "Polaris-ResourceList__SpinnerContainer",
      LoadingOverlay: "Polaris-ResourceList__LoadingOverlay",
      DisabledPointerEvents: "Polaris-ResourceList__DisabledPointerEvents",
      disableTextSelection: "Polaris-ResourceList--disableTextSelection"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Select/Select.scss.js
var require_Select_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Select/Select.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Select: "Polaris-Select",
      disabled: "Polaris-Select--disabled",
      error: "Polaris-Select--error",
      Backdrop: "Polaris-Select__Backdrop",
      Input: "Polaris-Select__Input",
      Content: "Polaris-Select__Content",
      InlineLabel: "Polaris-Select__InlineLabel",
      Icon: "Polaris-Select__Icon",
      SelectedOption: "Polaris-Select__SelectedOption",
      Prefix: "Polaris-Select__Prefix",
      hover: "Polaris-Select--hover",
      toneMagic: "Polaris-Select--toneMagic"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Select/Select.js
var require_Select = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Select/Select.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), useToggle = require_use_toggle(), Select_module = require_Select_scss(), Icon = require_Icon(), Labelled = require_Labelled(), Box2 = require_Box(), Text4 = require_Text(), PLACEHOLDER_VALUE = "";
    function Select2({
      options: optionsProp,
      label,
      labelAction,
      labelHidden: labelHiddenProp,
      labelInline,
      disabled,
      helpText,
      placeholder,
      id: idProp,
      name,
      value = PLACEHOLDER_VALUE,
      error,
      onChange,
      onFocus,
      onBlur,
      requiredIndicator,
      tone
    }) {
      let {
        value: focused,
        toggle: toggleFocused
      } = useToggle.useToggle(!1), uniqId = React12.useId(), id = idProp ?? uniqId, labelHidden = labelInline ? !0 : labelHiddenProp, className = css.classNames(Select_module.default.Select, error && Select_module.default.error, tone && Select_module.default[css.variationName("tone", tone)], disabled && Select_module.default.disabled), handleFocus = React12.useCallback((event) => {
        toggleFocused(), onFocus?.(event);
      }, [onFocus, toggleFocused]), handleBlur = React12.useCallback((event) => {
        toggleFocused(), onBlur?.(event);
      }, [onBlur, toggleFocused]), handleChange = onChange ? (event) => onChange(event.currentTarget.value, id) : void 0, describedBy = [];
      helpText && describedBy.push(Labelled.helpTextID(id)), error && describedBy.push(`${id}Error`);
      let normalizedOptions = (optionsProp || []).map(normalizeOption);
      placeholder && (normalizedOptions = [{
        label: placeholder,
        value: PLACEHOLDER_VALUE,
        disabled: !0
      }, ...normalizedOptions]);
      let inlineLabelMarkup = labelInline && /* @__PURE__ */ React12.createElement(Box2.Box, {
        paddingInlineEnd: "100"
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        tone: tone && tone === "magic" && !focused ? "magic-subdued" : "subdued",
        truncate: !0
      }, label)), selectedOption = getSelectedOption(normalizedOptions, value), prefixMarkup = selectedOption.prefix && /* @__PURE__ */ React12.createElement("div", {
        className: Select_module.default.Prefix
      }, selectedOption.prefix), contentMarkup = /* @__PURE__ */ React12.createElement("div", {
        className: Select_module.default.Content,
        "aria-hidden": !0,
        "aria-disabled": disabled
      }, inlineLabelMarkup, prefixMarkup, /* @__PURE__ */ React12.createElement("span", {
        className: Select_module.default.SelectedOption
      }, selectedOption.label), /* @__PURE__ */ React12.createElement("span", {
        className: Select_module.default.Icon
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.SelectIcon
      }))), optionsMarkup = normalizedOptions.map(renderOption);
      return /* @__PURE__ */ React12.createElement(Labelled.Labelled, {
        id,
        label,
        error,
        action: labelAction,
        labelHidden,
        helpText,
        requiredIndicator,
        disabled
      }, /* @__PURE__ */ React12.createElement("div", {
        className
      }, /* @__PURE__ */ React12.createElement("select", {
        id,
        name,
        value,
        className: Select_module.default.Input,
        disabled,
        onFocus: handleFocus,
        onBlur: handleBlur,
        onChange: handleChange,
        "aria-invalid": !!error,
        "aria-describedby": describedBy.length ? describedBy.join(" ") : void 0,
        "aria-required": requiredIndicator
      }, optionsMarkup), contentMarkup, /* @__PURE__ */ React12.createElement("div", {
        className: Select_module.default.Backdrop
      })));
    }
    function isString2(option) {
      return typeof option == "string";
    }
    function isGroup(option) {
      return typeof option == "object" && "options" in option && option.options != null;
    }
    function normalizeStringOption(option) {
      return {
        label: option,
        value: option
      };
    }
    function normalizeOption(option) {
      if (isString2(option))
        return normalizeStringOption(option);
      if (isGroup(option)) {
        let {
          title,
          options
        } = option;
        return {
          title,
          options: options.map((option2) => isString2(option2) ? normalizeStringOption(option2) : option2)
        };
      }
      return option;
    }
    function getSelectedOption(options, value) {
      let flatOptions = flattenOptions(options), selectedOption = flatOptions.find((option) => value === option.value);
      return selectedOption === void 0 && (selectedOption = flatOptions.find((option) => !option.hidden)), selectedOption || {
        value: "",
        label: ""
      };
    }
    function flattenOptions(options) {
      let flatOptions = [];
      return options.forEach((optionOrGroup) => {
        isGroup(optionOrGroup) ? flatOptions = flatOptions.concat(optionOrGroup.options) : flatOptions.push(optionOrGroup);
      }), flatOptions;
    }
    function renderSingleOption(option) {
      let {
        value,
        label,
        prefix: _prefix,
        key,
        ...rest
      } = option;
      return /* @__PURE__ */ React12.createElement("option", Object.assign({
        key: key ?? value,
        value
      }, rest), label);
    }
    function renderOption(optionOrGroup) {
      if (isGroup(optionOrGroup)) {
        let {
          title,
          options
        } = optionOrGroup;
        return /* @__PURE__ */ React12.createElement("optgroup", {
          label: title,
          key: title
        }, options.map(renderSingleOption));
      }
      return renderSingleOption(optionOrGroup);
    }
    exports.Select = Select2;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ResourceList/ResourceList.js
var require_ResourceList = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/ResourceList/ResourceList.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), polarisTokens = require_build2(), debounce = require_debounce2(), css = require_css(), components = require_components(), useLazyRef = require_use_lazy_ref(), useEventListener = require_use_event_listener(), ResourceList_module = require_ResourceList_scss(), Select2 = require_Select(), ResourceItem = require_ResourceItem(), types = require_types12(), hooks2 = require_hooks2(), useIsBulkActionsSticky = require_use_is_bulk_actions_sticky(), SelectAllActions = require_SelectAllActions(), Button2 = require_Button(), CheckableButton = require_CheckableButton(), Sticky = require_Sticky(), EmptySearchResult = require_EmptySearchResult(), Spinner = require_Spinner(), Pagination = require_Pagination(), context = require_context19(), BulkActions = require_BulkActions(), SMALL_SPINNER_HEIGHT = 28, LARGE_SPINNER_HEIGHT = 45;
    function getAllItemsOnPage(items, idForItem) {
      return items.map((item, index) => idForItem(item, index));
    }
    var isBreakpointsXS = () => typeof window > "u" ? !1 : window.innerWidth < parseFloat(polarisTokens.toPx(polarisTokens.themeDefault.breakpoints["breakpoints-sm"]) ?? "");
    function defaultIdForItem(item, index) {
      return Object.prototype.hasOwnProperty.call(item, "id") ? item.id : index.toString();
    }
    function ResourceList({
      items,
      filterControl,
      flushFilters,
      emptyState,
      emptySearchState,
      resourceName: resourceNameProp,
      promotedBulkActions,
      bulkActions,
      selectedItems = [],
      isFiltered,
      selectable,
      hasMoreItems,
      loading,
      headerContent,
      showHeader,
      totalItemsCount,
      sortValue,
      sortOptions,
      alternateTool,
      onSortChange,
      onSelectionChange,
      renderItem,
      idForItem = defaultIdForItem,
      resolveItemId,
      pagination
    }) {
      let i18n = hooks2.useI18n(), [selectMode, setSelectMode] = React12.useState(!!(selectedItems && selectedItems.length > 0)), [loadingPosition, setLoadingPositionState] = React12.useState(0), [lastSelected, setLastSelected] = React12.useState(), [smallScreen, setSmallScreen] = React12.useState(isBreakpointsXS()), forceUpdate = React12.useReducer((x = 0) => x + 1, 0)[1], checkableButtonRef = React12.useRef(null), {
        bulkActionsIntersectionRef,
        tableMeasurerRef,
        isBulkActionsSticky,
        bulkActionsAbsoluteOffset,
        bulkActionsMaxWidth,
        bulkActionsOffsetLeft,
        computeTableDimensions
      } = useIsBulkActionsSticky.useIsBulkActionsSticky(selectMode);
      React12.useEffect(() => {
        computeTableDimensions();
      }, [computeTableDimensions, items.length]);
      let defaultResourceName = useLazyRef.useLazyRef(() => ({
        singular: i18n.translate("Polaris.ResourceList.defaultItemSingular"),
        plural: i18n.translate("Polaris.ResourceList.defaultItemPlural")
      })), listRef = React12.useRef(null), handleSelectMode = (selectMode2) => {
        setSelectMode(selectMode2), !selectMode2 && onSelectionChange && onSelectionChange([]);
      }, handleResize = debounce.debounce(() => {
        let newSmallScreen = isBreakpointsXS();
        selectedItems && selectedItems.length === 0 && selectMode && !newSmallScreen && handleSelectMode(!1), smallScreen !== newSmallScreen && setSmallScreen(newSmallScreen);
      }, 50, {
        leading: !0,
        trailing: !0,
        maxWait: 50
      });
      useEventListener.useEventListener("resize", handleResize);
      let isSelectable = !!(promotedBulkActions && promotedBulkActions.length > 0 || bulkActions && bulkActions.length > 0 || selectable) && !smallScreen, selectAllSelectState = () => {
        let selectState = "indeterminate";
        return !selectedItems || Array.isArray(selectedItems) && selectedItems.length === 0 ? selectState = !1 : (selectedItems === types.SELECT_ALL_ITEMS || Array.isArray(selectedItems) && selectedItems.length === items.length) && (selectState = !0), selectState;
      }, resourceName = resourceNameProp || defaultResourceName.current, headerTitle = () => {
        let itemsCount = items.length, resource = !loading && (!totalItemsCount && itemsCount === 1 || totalItemsCount === 1) ? resourceName.singular : resourceName.plural;
        return loading ? i18n.translate("Polaris.ResourceList.loading", {
          resource
        }) : totalItemsCount ? i18n.translate("Polaris.ResourceList.showingTotalCount", {
          itemsCount,
          totalItemsCount,
          resource
        }) : headerContent || i18n.translate("Polaris.ResourceList.showing", {
          itemsCount,
          resource
        });
      }, selectAllActionsLabel = () => {
        let selectedItemsCount = selectedItems === types.SELECT_ALL_ITEMS ? `${items.length}+` : selectedItems.length;
        return i18n.translate("Polaris.ResourceList.selected", {
          selectedItemsCount
        });
      }, selectAllActionsAccessibilityLabel = () => {
        let selectedItemsCount = selectedItems.length, totalItemsCount2 = items.length, allSelected = selectedItemsCount === totalItemsCount2;
        return totalItemsCount2 === 1 && allSelected ? i18n.translate("Polaris.ResourceList.a11yCheckboxDeselectAllSingle", {
          resourceNameSingular: resourceName.singular
        }) : totalItemsCount2 === 1 ? i18n.translate("Polaris.ResourceList.a11yCheckboxSelectAllSingle", {
          resourceNameSingular: resourceName.singular
        }) : allSelected ? i18n.translate("Polaris.ResourceList.a11yCheckboxDeselectAllMultiple", {
          itemsLength: items.length,
          resourceNamePlural: resourceName.plural
        }) : i18n.translate("Polaris.ResourceList.a11yCheckboxSelectAllMultiple", {
          itemsLength: items.length,
          resourceNamePlural: resourceName.plural
        });
      }, paginatedSelectAllText = () => {
        if (!(!isSelectable || !hasMoreItems) && selectedItems === types.SELECT_ALL_ITEMS)
          return i18n.translate(isFiltered ? "Polaris.ResourceList.allFilteredItemsSelected" : "Polaris.ResourceList.allItemsSelected", {
            itemsLength: items.length,
            resourceNamePlural: resourceName.plural
          });
      }, paginatedSelectAllAction = () => !isSelectable || !hasMoreItems ? void 0 : {
        content: selectedItems === types.SELECT_ALL_ITEMS ? i18n.translate("Polaris.Common.undo") : i18n.translate(isFiltered ? "Polaris.ResourceList.selectAllFilteredItems" : "Polaris.ResourceList.selectAllItems", {
          itemsLength: items.length,
          resourceNamePlural: resourceName.plural
        }),
        onAction: handleSelectAllItemsInStore
      }, emptySearchResultText = {
        title: i18n.translate("Polaris.ResourceList.emptySearchResultTitle", {
          resourceNamePlural: resourceName.plural
        }),
        description: i18n.translate("Polaris.ResourceList.emptySearchResultDescription")
      }, handleSelectAllItemsInStore = () => {
        let newlySelectedItems = selectedItems === types.SELECT_ALL_ITEMS ? getAllItemsOnPage(items, idForItem) : types.SELECT_ALL_ITEMS;
        onSelectionChange && onSelectionChange(newlySelectedItems);
      }, setLoadingPosition = React12.useCallback(() => {
        if (listRef.current != null) {
          if (typeof window > "u")
            return;
          let overlay = listRef.current.getBoundingClientRect(), viewportHeight = Math.max(document.documentElement ? document.documentElement.clientHeight : 0, window.innerHeight || 0), overflow = viewportHeight - overlay.height, spinnerHeight = items.length === 1 ? SMALL_SPINNER_HEIGHT : LARGE_SPINNER_HEIGHT, spinnerPosition = overflow > 0 ? (overlay.height - spinnerHeight) / 2 : (viewportHeight - overlay.top - spinnerHeight) / 2;
          setLoadingPositionState(spinnerPosition);
        }
      }, [listRef, items.length]), itemsExist = items.length > 0;
      React12.useEffect(() => {
        loading && setLoadingPosition();
      }, [loading, setLoadingPosition]), React12.useEffect(() => {
        selectedItems && selectedItems.length > 0 && !selectMode && setSelectMode(!0), (!selectedItems || selectedItems.length === 0) && !isBreakpointsXS() && setSelectMode(!1);
      }, [selectedItems, selectMode]), React12.useEffect(() => {
        forceUpdate();
      }, [forceUpdate, items]);
      let renderItemWithId = (item, index) => {
        let id = idForItem(item, index), itemContent = renderItem(item, id, index);
        return process.env.NODE_ENV === "development" && !components.isElementOfType(itemContent, ResourceItem.ResourceItem) && console.warn("<ResourceList /> renderItem function should return a <ResourceItem />."), itemContent;
      }, handleMultiSelectionChange = (lastSelected2, currentSelected, resolveItemId2) => {
        let min = Math.min(lastSelected2, currentSelected), max = Math.max(lastSelected2, currentSelected);
        return items.slice(min, max + 1).map(resolveItemId2);
      }, handleSelectionChange = (selected, id, sortOrder, shiftKey) => {
        if (selectedItems == null || onSelectionChange == null)
          return;
        let newlySelectedItems = selectedItems === types.SELECT_ALL_ITEMS ? getAllItemsOnPage(items, idForItem) : [...selectedItems];
        sortOrder !== void 0 && setLastSelected(sortOrder);
        let lastSelectedFromState = lastSelected, selectedIds = [id];
        if (shiftKey && lastSelectedFromState != null && sortOrder !== void 0 && resolveItemId && (selectedIds = handleMultiSelectionChange(lastSelectedFromState, sortOrder, resolveItemId)), newlySelectedItems = [.../* @__PURE__ */ new Set([...newlySelectedItems, ...selectedIds])], !selected)
          for (let selectedId of selectedIds)
            newlySelectedItems.splice(newlySelectedItems.indexOf(selectedId), 1);
        newlySelectedItems.length === 0 && !isBreakpointsXS() ? handleSelectMode(!1) : newlySelectedItems.length > 0 && handleSelectMode(!0), onSelectionChange && onSelectionChange(newlySelectedItems);
      }, handleToggleAll = () => {
        let newlySelectedItems;
        Array.isArray(selectedItems) && selectedItems.length === items.length || selectedItems === types.SELECT_ALL_ITEMS ? newlySelectedItems = [] : newlySelectedItems = items.map((item, index) => idForItem(item, index)), newlySelectedItems.length === 0 && !isBreakpointsXS() ? handleSelectMode(!1) : newlySelectedItems.length > 0 && handleSelectMode(!0), onSelectionChange && onSelectionChange(newlySelectedItems), setTimeout(() => {
          checkableButtonRef?.current?.focus();
        }, 0);
      }, selectAllActionsMarkup = isSelectable ? /* @__PURE__ */ React12.createElement("div", {
        className: ResourceList_module.default.SelectAllActionsWrapper
      }, /* @__PURE__ */ React12.createElement(SelectAllActions.SelectAllActions, {
        label: selectAllActionsLabel(),
        accessibilityLabel: selectAllActionsAccessibilityLabel(),
        selected: selectAllSelectState(),
        onToggleAll: handleToggleAll,
        selectMode,
        paginatedSelectAllAction: paginatedSelectAllAction(),
        paginatedSelectAllText: paginatedSelectAllText(),
        disabled: loading,
        ref: checkableButtonRef
      })) : null, bulkActionClassNames = css.classNames(ResourceList_module.default.BulkActionsWrapper, isBulkActionsSticky && ResourceList_module.default.BulkActionsWrapperSticky), bulkActionsMarkup = isSelectable && selectMode && (bulkActions || promotedBulkActions) ? /* @__PURE__ */ React12.createElement("div", {
        className: bulkActionClassNames,
        style: {
          top: isBulkActionsSticky ? void 0 : bulkActionsAbsoluteOffset,
          width: bulkActionsMaxWidth,
          left: isBulkActionsSticky ? bulkActionsOffsetLeft : void 0
        }
      }, /* @__PURE__ */ React12.createElement(BulkActions.BulkActions, {
        selectMode,
        onSelectModeToggle: handleSelectMode,
        promotedActions: promotedBulkActions,
        actions: bulkActions,
        disabled: loading,
        isSticky: isBulkActionsSticky,
        width: bulkActionsMaxWidth
      })) : null, filterControlMarkup = filterControl ? /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(!flushFilters && ResourceList_module.default.FiltersWrapper)
      }, filterControl) : null, sortingSelectMarkup = sortOptions && sortOptions.length > 0 && !alternateTool ? /* @__PURE__ */ React12.createElement("div", {
        className: ResourceList_module.default.SortWrapper
      }, /* @__PURE__ */ React12.createElement(Select2.Select, {
        label: i18n.translate("Polaris.ResourceList.sortingLabel"),
        labelInline: !smallScreen,
        labelHidden: smallScreen,
        options: sortOptions,
        onChange: onSortChange,
        value: sortValue,
        disabled: selectMode
      })) : null, alternateToolMarkup = alternateTool && !sortingSelectMarkup ? /* @__PURE__ */ React12.createElement("div", {
        className: ResourceList_module.default.AlternateToolWrapper
      }, alternateTool) : null, headerTitleMarkup = /* @__PURE__ */ React12.createElement("div", {
        className: ResourceList_module.default.HeaderTitleWrapper
      }, headerTitle()), selectButtonMarkup = isSelectable ? /* @__PURE__ */ React12.createElement("div", {
        className: ResourceList_module.default.SelectButtonWrapper
      }, /* @__PURE__ */ React12.createElement(Button2.Button, {
        disabled: selectMode,
        icon: polarisIcons.CheckboxIcon,
        onClick: () => handleSelectMode(!0)
      }, i18n.translate("Polaris.ResourceList.selectButtonText"))) : null, checkableButtonMarkup = isSelectable ? /* @__PURE__ */ React12.createElement("div", {
        className: ResourceList_module.default.CheckableButtonWrapper
      }, /* @__PURE__ */ React12.createElement(CheckableButton.CheckableButton, {
        accessibilityLabel: selectAllActionsAccessibilityLabel(),
        label: headerTitle(),
        onToggleAll: handleToggleAll,
        disabled: loading,
        ref: checkableButtonRef
      })) : null, needsHeader = isSelectable || sortOptions && sortOptions.length > 0 || alternateTool, headerWrapperOverlay = loading ? /* @__PURE__ */ React12.createElement("div", {
        className: ResourceList_module.default["HeaderWrapper-overlay"]
      }) : null, showEmptyState = emptyState && !itemsExist && !loading, showEmptySearchState = !showEmptyState && filterControl && !itemsExist && !loading, headerMarkup = !showEmptyState && showHeader !== !1 && !showEmptySearchState && (showHeader || needsHeader) && listRef.current && /* @__PURE__ */ React12.createElement("div", {
        className: ResourceList_module.default.HeaderOuterWrapper
      }, /* @__PURE__ */ React12.createElement(Sticky.Sticky, {
        boundingElement: listRef.current
      }, (isSticky) => {
        let headerClassName = css.classNames(ResourceList_module.default.HeaderWrapper, sortOptions && sortOptions.length > 0 && !alternateTool && ResourceList_module.default["HeaderWrapper-hasSort"], alternateTool && ResourceList_module.default["HeaderWrapper-hasAlternateTool"], isSelectable && ResourceList_module.default["HeaderWrapper-hasSelect"], loading && ResourceList_module.default["HeaderWrapper-disabled"], isSelectable && selectMode && ResourceList_module.default["HeaderWrapper-inSelectMode"], isSticky && ResourceList_module.default["HeaderWrapper-isSticky"]);
        return /* @__PURE__ */ React12.createElement("div", {
          className: headerClassName
        }, headerWrapperOverlay, /* @__PURE__ */ React12.createElement("div", {
          className: ResourceList_module.default.HeaderContentWrapper
        }, headerTitleMarkup, checkableButtonMarkup, alternateToolMarkup, sortingSelectMarkup, selectButtonMarkup), selectAllActionsMarkup);
      })), emptySearchStateMarkup = showEmptySearchState ? emptySearchState || /* @__PURE__ */ React12.createElement("div", {
        className: ResourceList_module.default.EmptySearchResultWrapper
      }, /* @__PURE__ */ React12.createElement(EmptySearchResult.EmptySearchResult, Object.assign({}, emptySearchResultText, {
        withIllustration: !0
      }))) : null, emptyStateMarkup = showEmptyState ? emptyState : null, defaultTopPadding = 8, spinnerStyle = {
        paddingTop: `${loadingPosition > 0 ? loadingPosition : defaultTopPadding}px`
      }, spinnerSize = items.length < 2 ? "small" : "large", loadingOverlay = loading ? /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement("li", {
        className: ResourceList_module.default.SpinnerContainer,
        style: spinnerStyle
      }, /* @__PURE__ */ React12.createElement(Spinner.Spinner, {
        size: spinnerSize,
        accessibilityLabel: "Items are loading"
      })), /* @__PURE__ */ React12.createElement("li", {
        className: ResourceList_module.default.LoadingOverlay
      })) : null, className = css.classNames(ResourceList_module.default.ItemWrapper, loading && ResourceList_module.default["ItemWrapper-isLoading"]), loadingWithoutItemsMarkup = loading && !itemsExist ? /* @__PURE__ */ React12.createElement("div", {
        className,
        tabIndex: -1
      }, loadingOverlay) : null, resourceListClassName = css.classNames(ResourceList_module.default.ResourceList, loading && ResourceList_module.default.disabledPointerEvents, selectMode && ResourceList_module.default.disableTextSelection), listMarkup = itemsExist ? /* @__PURE__ */ React12.createElement("ul", {
        className: resourceListClassName,
        ref: listRef,
        "aria-live": "polite",
        "aria-busy": loading
      }, loadingOverlay, React12.Children.toArray(items.map(renderItemWithId))) : null, paginationMarkup = pagination ? /* @__PURE__ */ React12.createElement(Pagination.Pagination, Object.assign({
        type: "table"
      }, pagination)) : null, context$1 = {
        selectable: isSelectable,
        selectedItems,
        selectMode,
        hasBulkActions: !!bulkActions,
        resourceName,
        loading,
        onSelectionChange: handleSelectionChange
      }, resourceListWrapperClasses = css.classNames(ResourceList_module.default.ResourceListWrapper, !!bulkActionsMarkup && selectMode && bulkActions && ResourceList_module.default.ResourceListWrapperWithBulkActions);
      return /* @__PURE__ */ React12.createElement(context.ResourceListContext.Provider, {
        value: context$1
      }, /* @__PURE__ */ React12.createElement("div", {
        className: resourceListWrapperClasses,
        ref: tableMeasurerRef
      }, filterControlMarkup, headerMarkup, bulkActionsMarkup, listMarkup, emptySearchStateMarkup, emptyStateMarkup, loadingWithoutItemsMarkup, paginationMarkup), /* @__PURE__ */ React12.createElement("div", {
        ref: bulkActionsIntersectionRef
      }));
    }
    ResourceList.Item = ResourceItem.ResourceItem;
    exports.ResourceList = ResourceList;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SettingToggle/SettingToggle.js
var require_SettingToggle = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SettingToggle/SettingToggle.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), utils = require_utils10(), LegacyCard = require_LegacyCard(), SettingAction = require_SettingAction();
    function SettingToggle({
      enabled,
      action,
      children
    }) {
      let id = React12.useId();
      process.env.NODE_ENV === "development" && console.warn(`Deprecation: <SettingToggle /> is deprecated. This component will be removed in a future major version of Polaris. Use the primitive layout and typography components to compose a setting toggle card.
      See the "With primitive components" example in https://polaris.shopify.com/components/deprecated/setting-toggle`);
      let actionMarkup = action ? utils.buttonFrom(action, {
        role: "switch",
        ariaChecked: enabled ? "true" : "false",
        size: "slim"
      }) : null;
      return /* @__PURE__ */ React12.createElement(LegacyCard.LegacyCard, {
        sectioned: !0
      }, /* @__PURE__ */ React12.createElement(SettingAction.SettingAction, {
        action: actionMarkup
      }, /* @__PURE__ */ React12.createElement("label", {
        htmlFor: id
      }, children)));
    }
    exports.SettingToggle = SettingToggle;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonBodyText/SkeletonBodyText.scss.js
var require_SkeletonBodyText_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonBodyText/SkeletonBodyText.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      SkeletonBodyTextContainer: "Polaris-SkeletonBodyText__SkeletonBodyTextContainer",
      SkeletonBodyText: "Polaris-SkeletonBodyText"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonBodyText/SkeletonBodyText.js
var require_SkeletonBodyText = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonBodyText/SkeletonBodyText.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), SkeletonBodyText_module = require_SkeletonBodyText_scss();
    function SkeletonBodyText({
      lines = 3
    }) {
      let bodyTextLines = [];
      for (let i = 0; i < lines; i++)
        bodyTextLines.push(/* @__PURE__ */ React12.createElement("div", {
          className: SkeletonBodyText_module.default.SkeletonBodyText,
          key: i
        }));
      return /* @__PURE__ */ React12.createElement("div", {
        className: SkeletonBodyText_module.default.SkeletonBodyTextContainer
      }, bodyTextLines);
    }
    exports.SkeletonBodyText = SkeletonBodyText;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonDisplayText/SkeletonDisplayText.scss.js
var require_SkeletonDisplayText_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonDisplayText/SkeletonDisplayText.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      DisplayText: "Polaris-SkeletonDisplayText__DisplayText",
      sizeSmall: "Polaris-SkeletonDisplayText--sizeSmall",
      sizeMedium: "Polaris-SkeletonDisplayText--sizeMedium",
      sizeLarge: "Polaris-SkeletonDisplayText--sizeLarge",
      sizeExtraLarge: "Polaris-SkeletonDisplayText--sizeExtraLarge"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonDisplayText/SkeletonDisplayText.js
var require_SkeletonDisplayText = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonDisplayText/SkeletonDisplayText.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), SkeletonDisplayText_module = require_SkeletonDisplayText_scss();
    function SkeletonDisplayText({
      size = "medium",
      maxWidth
    }) {
      let className = css.classNames(SkeletonDisplayText_module.default.DisplayText, size && SkeletonDisplayText_module.default[css.variationName("size", size)]), style = {
        "--pc-skeleton-display-text-max-width": maxWidth ?? void 0
      };
      return /* @__PURE__ */ React12.createElement("div", {
        className,
        style: css.sanitizeCustomProperties(style)
      });
    }
    exports.SkeletonDisplayText = SkeletonDisplayText;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonPage/SkeletonPage.scss.js
var require_SkeletonPage_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonPage/SkeletonPage.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Title: "Polaris-SkeletonPage__Title",
      SkeletonTitle: "Polaris-SkeletonPage__SkeletonTitle"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonPage/SkeletonPage.js
var require_SkeletonPage = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonPage/SkeletonPage.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), SkeletonPage_module = require_SkeletonPage_scss(), hooks2 = require_hooks2(), Box2 = require_Box(), BlockStack3 = require_BlockStack(), InlineStack2 = require_InlineStack();
    function SkeletonPage({
      children,
      fullWidth,
      narrowWidth,
      primaryAction,
      title = "",
      backAction
    }) {
      let i18n = hooks2.useI18n(), titleContent = title ? /* @__PURE__ */ React12.createElement("h1", {
        className: SkeletonPage_module.default.Title
      }, title) : /* @__PURE__ */ React12.createElement("div", {
        className: SkeletonPage_module.default.SkeletonTitle
      }, /* @__PURE__ */ React12.createElement(Box2.Box, {
        background: "bg-fill-tertiary",
        minWidth: "120px",
        minHeight: "28px",
        borderRadius: "100"
      })), primaryActionMarkup = primaryAction ? /* @__PURE__ */ React12.createElement(Box2.Box, {
        id: "SkeletonPage-PrimaryAction",
        borderRadius: "100",
        background: "bg-fill-tertiary",
        minHeight: "2.25rem",
        minWidth: "6.25rem"
      }) : null, backActionMarkup = backAction ? /* @__PURE__ */ React12.createElement(Box2.Box, {
        borderRadius: "100",
        background: "bg-fill-tertiary",
        minHeight: "2.25rem",
        minWidth: "2.25rem",
        maxWidth: "2.25rem"
      }) : null;
      return /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, {
        gap: "400",
        inlineAlign: "center"
      }, /* @__PURE__ */ React12.createElement(Box2.Box, Object.assign({
        width: "100%",
        padding: "0",
        paddingInlineStart: {
          sm: "600"
        },
        paddingInlineEnd: {
          sm: "600"
        },
        maxWidth: "var(--pc-skeleton-page-max-width)",
        "aria-label": i18n.translate("Polaris.SkeletonPage.loadingLabel"),
        role: "status"
      }, narrowWidth && {
        maxWidth: "var(--pc-skeleton-page-max-width-narrow)"
      }, fullWidth && {
        maxWidth: "none"
      }), /* @__PURE__ */ React12.createElement(BlockStack3.BlockStack, null, /* @__PURE__ */ React12.createElement(Box2.Box, {
        paddingBlockStart: {
          xs: "400",
          md: "500"
        },
        paddingBlockEnd: {
          xs: "400",
          md: "500"
        },
        paddingInlineStart: {
          xs: "400",
          sm: "0"
        },
        paddingInlineEnd: {
          xs: "400",
          sm: "0"
        },
        width: "100%"
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "400",
        align: "space-between",
        blockAlign: "center"
      }, /* @__PURE__ */ React12.createElement(InlineStack2.InlineStack, {
        gap: "400"
      }, backActionMarkup, /* @__PURE__ */ React12.createElement(Box2.Box, {
        paddingBlockStart: "100",
        paddingBlockEnd: "100"
      }, titleContent)), primaryActionMarkup)), /* @__PURE__ */ React12.createElement(Box2.Box, {
        paddingBlockEnd: "200",
        width: "100%"
      }, children))));
    }
    exports.SkeletonPage = SkeletonPage;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonTabs/SkeletonTabs.scss.js
var require_SkeletonTabs_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonTabs/SkeletonTabs.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Tabs: "Polaris-SkeletonTabs__Tabs",
      Tab: "Polaris-SkeletonTabs__Tab",
      TabText: "Polaris-SkeletonTabs__TabText",
      fitted: "Polaris-SkeletonTabs--fitted"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonTabs/SkeletonTabs.js
var require_SkeletonTabs = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonTabs/SkeletonTabs.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), SkeletonTabs_module = require_SkeletonTabs_scss();
    function SkeletonTabs({
      count = 2,
      fitted = !1
    }) {
      return /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(SkeletonTabs_module.default.Tabs, fitted && SkeletonTabs_module.default.fitted)
      }, [...Array(count).keys()].map((key) => /* @__PURE__ */ React12.createElement("div", {
        key,
        className: css.classNames(SkeletonTabs_module.default.Tab)
      }, /* @__PURE__ */ React12.createElement("div", {
        className: SkeletonTabs_module.default.TabText
      }))));
    }
    exports.SkeletonTabs = SkeletonTabs;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonThumbnail/SkeletonThumbnail.scss.js
var require_SkeletonThumbnail_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonThumbnail/SkeletonThumbnail.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      SkeletonThumbnail: "Polaris-SkeletonThumbnail",
      sizeExtraSmall: "Polaris-SkeletonThumbnail--sizeExtraSmall",
      sizeSmall: "Polaris-SkeletonThumbnail--sizeSmall",
      sizeMedium: "Polaris-SkeletonThumbnail--sizeMedium",
      sizeLarge: "Polaris-SkeletonThumbnail--sizeLarge"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonThumbnail/SkeletonThumbnail.js
var require_SkeletonThumbnail = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/SkeletonThumbnail/SkeletonThumbnail.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), SkeletonThumbnail_module = require_SkeletonThumbnail_scss();
    function SkeletonThumbnail({
      size = "medium"
    }) {
      let className = css.classNames(SkeletonThumbnail_module.default.SkeletonThumbnail, size && SkeletonThumbnail_module.default[css.variationName("size", size)]);
      return /* @__PURE__ */ React12.createElement("div", {
        className
      });
    }
    exports.SkeletonThumbnail = SkeletonThumbnail;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Thumbnail/Thumbnail.scss.js
var require_Thumbnail_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Thumbnail/Thumbnail.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Thumbnail: "Polaris-Thumbnail",
      sizeExtraSmall: "Polaris-Thumbnail--sizeExtraSmall",
      sizeSmall: "Polaris-Thumbnail--sizeSmall",
      sizeMedium: "Polaris-Thumbnail--sizeMedium",
      sizeLarge: "Polaris-Thumbnail--sizeLarge",
      transparent: "Polaris-Thumbnail--transparent"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Thumbnail/Thumbnail.js
var require_Thumbnail = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Thumbnail/Thumbnail.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Thumbnail_module = require_Thumbnail_scss(), Image = require_Image(), Icon = require_Icon();
    function Thumbnail({
      source,
      alt,
      size = "medium",
      transparent
    }) {
      let className = css.classNames(Thumbnail_module.default.Thumbnail, size && Thumbnail_module.default[css.variationName("size", size)], transparent && Thumbnail_module.default.transparent), content = typeof source == "string" ? /* @__PURE__ */ React12.createElement(Image.Image, {
        alt,
        source
      }) : /* @__PURE__ */ React12.createElement(Icon.Icon, {
        accessibilityLabel: alt,
        source
      });
      return /* @__PURE__ */ React12.createElement("span", {
        className
      }, content);
    }
    exports.Thumbnail = Thumbnail;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Toast/Toast.js
var require_Toast2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/Toast/Toast.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), useDeepEffect = require_use_deep_effect(), hooks2 = require_hooks9(), Toast = /* @__PURE__ */ React12.memo(function(props) {
      let id = React12.useId(), {
        showToast,
        hideToast
      } = hooks2.useFrame();
      return useDeepEffect.useDeepEffect(() => (showToast({
        id,
        ...props
      }), () => {
        hideToast({
          id
        });
      }), [props]), null;
    });
    exports.Toast = Toast;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/TopBar.scss.js
var require_TopBar_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/TopBar.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      TopBar: "Polaris-TopBar",
      Container: "Polaris-TopBar__Container",
      LogoDisplayControl: "Polaris-TopBar__LogoDisplayControl",
      LogoDisplayContainer: "Polaris-TopBar__LogoDisplayContainer",
      LogoContainer: "Polaris-TopBar__LogoContainer",
      hasLogoSuffix: "Polaris-TopBar--hasLogoSuffix",
      Logo: "Polaris-TopBar__Logo",
      LogoLink: "Polaris-TopBar__LogoLink",
      ContextControl: "Polaris-TopBar__ContextControl",
      NavigationIcon: "Polaris-TopBar__NavigationIcon",
      focused: "Polaris-TopBar--focused",
      IconWrapper: "Polaris-TopBar__IconWrapper",
      LeftContent: "Polaris-TopBar__LeftContent",
      Search: "Polaris-TopBar__Search",
      RightContent: "Polaris-TopBar__RightContent",
      SecondaryMenu: "Polaris-TopBar__SecondaryMenu"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/Search/Search.scss.js
var require_Search_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/Search/Search.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Search: "Polaris-TopBar-Search",
      SearchContent: "Polaris-TopBar-Search__SearchContent",
      visible: "Polaris-TopBar-Search--visible",
      Results: "Polaris-TopBar-Search__Results"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/SearchDismissOverlay/SearchDismissOverlay.scss.js
var require_SearchDismissOverlay_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/SearchDismissOverlay/SearchDismissOverlay.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      SearchDismissOverlay: "Polaris-TopBar-SearchDismissOverlay",
      visible: "Polaris-TopBar-SearchDismissOverlay--visible"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/SearchDismissOverlay/SearchDismissOverlay.js
var require_SearchDismissOverlay = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/SearchDismissOverlay/SearchDismissOverlay.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), SearchDismissOverlay_module = require_SearchDismissOverlay_scss(), ScrollLock = require_ScrollLock();
    function SearchDismissOverlay({
      onDismiss,
      visible
    }) {
      let node = React12.useRef(null), handleDismiss = React12.useCallback(({
        target
      }) => {
        target === node.current && onDismiss != null && onDismiss();
      }, [onDismiss]);
      return /* @__PURE__ */ React12.createElement(React12.Fragment, null, visible ? /* @__PURE__ */ React12.createElement(ScrollLock.ScrollLock, null) : null, /* @__PURE__ */ React12.createElement("div", {
        ref: node,
        className: css.classNames(SearchDismissOverlay_module.default.SearchDismissOverlay, visible && SearchDismissOverlay_module.default.visible),
        onClick: handleDismiss
      }));
    }
    exports.SearchDismissOverlay = SearchDismissOverlay;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/Search/Search.js
var require_Search = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/Search/Search.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Search_module = require_Search_scss(), SearchDismissOverlay = require_SearchDismissOverlay();
    function Search2({
      visible,
      children,
      onDismiss,
      overlayVisible = !1
    }) {
      if (children == null)
        return null;
      let overlayMarkup = visible ? /* @__PURE__ */ React12.createElement(SearchDismissOverlay.SearchDismissOverlay, {
        onDismiss,
        visible: overlayVisible
      }) : null;
      return /* @__PURE__ */ React12.createElement(React12.Fragment, null, overlayMarkup, /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(Search_module.default.Search, visible && Search_module.default.visible)
      }, /* @__PURE__ */ React12.createElement("div", {
        className: Search_module.default.SearchContent
      }, /* @__PURE__ */ React12.createElement("div", {
        className: Search_module.default.Results
      }, children))));
    }
    exports.Search = Search2;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/SearchField/SearchField.scss.js
var require_SearchField_scss2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/SearchField/SearchField.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      SearchField: "Polaris-TopBar-SearchField",
      focused: "Polaris-TopBar-SearchField--focused",
      Input: "Polaris-TopBar-SearchField__Input",
      Backdrop: "Polaris-TopBar-SearchField__Backdrop",
      BackdropShowFocusBorder: "Polaris-TopBar-SearchField__BackdropShowFocusBorder",
      Icon: "Polaris-TopBar-SearchField__Icon",
      Clear: "Polaris-TopBar-SearchField__Clear"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/SearchField/SearchField.js
var require_SearchField2 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/SearchField/SearchField.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), SearchField_module = require_SearchField_scss2(), hooks2 = require_hooks2(), Icon = require_Icon(), Text4 = require_Text();
    function SearchField({
      value,
      focused,
      active,
      placeholder,
      onChange,
      onFocus,
      onBlur,
      onCancel,
      showFocusBorder
    }) {
      let i18n = hooks2.useI18n(), [forceActive, setForceActive] = React12.useState(!1), input = React12.useRef(null), searchId = React12.useId(), handleChange = React12.useCallback(({
        currentTarget
      }) => {
        onChange(currentTarget.value);
      }, [onChange]), handleFocus = React12.useCallback(() => onFocus && onFocus(), [onFocus]), handleBlur = React12.useCallback(() => onBlur && onBlur(), [onBlur]), handleClear = React12.useCallback(() => {
        onCancel && onCancel(), input.current && (input.current.value = "", onChange(""), input.current.focus());
      }, [onCancel, onChange]);
      React12.useEffect(() => {
        input.current && (focused ? input.current.focus() : input.current.blur());
      }, [focused]);
      let clearMarkup = value !== "" && /* @__PURE__ */ React12.createElement("button", {
        type: "button",
        "aria-label": i18n.translate("Polaris.TopBar.SearchField.clearButtonLabel"),
        className: SearchField_module.default.Clear,
        onClick: handleClear,
        onBlur: () => {
          setForceActive(!1), handleClear();
        },
        onFocus: () => {
          handleFocus(), setForceActive(!0);
        }
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.XCircleIcon
      })), className = css.classNames(SearchField_module.default.SearchField, (focused || active || forceActive) && SearchField_module.default.focused);
      return /* @__PURE__ */ React12.createElement("div", {
        className,
        onFocus: handleFocus,
        onBlur: handleBlur
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "span",
        visuallyHidden: !0
      }, /* @__PURE__ */ React12.createElement("label", {
        htmlFor: searchId
      }, i18n.translate("Polaris.TopBar.SearchField.search"))), /* @__PURE__ */ React12.createElement("input", {
        id: searchId,
        className: SearchField_module.default.Input,
        placeholder,
        type: "search",
        autoCapitalize: "off",
        autoComplete: "off",
        autoCorrect: "off",
        ref: input,
        value,
        onChange: handleChange,
        onKeyDown: preventDefault
      }), /* @__PURE__ */ React12.createElement("span", {
        className: SearchField_module.default.Icon
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.SearchIcon
      })), clearMarkup, /* @__PURE__ */ React12.createElement("div", {
        className: css.classNames(SearchField_module.default.Backdrop, showFocusBorder && SearchField_module.default.BackdropShowFocusBorder)
      }));
    }
    function preventDefault(event) {
      event.key === "Enter" && event.preventDefault();
    }
    exports.SearchField = SearchField;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/UserMenu/UserMenu.scss.js
var require_UserMenu_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/UserMenu/UserMenu.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Details: "Polaris-TopBar-UserMenu__Details",
      Message: "Polaris-TopBar-UserMenu__Message"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/MessageIndicator/MessageIndicator.scss.js
var require_MessageIndicator_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/MessageIndicator/MessageIndicator.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      MessageIndicatorWrapper: "Polaris-MessageIndicator__MessageIndicatorWrapper",
      MessageIndicator: "Polaris-MessageIndicator"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/MessageIndicator/MessageIndicator.js
var require_MessageIndicator = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/MessageIndicator/MessageIndicator.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), MessageIndicator_module = require_MessageIndicator_scss();
    function MessageIndicator({
      children,
      active
    }) {
      let indicatorMarkup = active && /* @__PURE__ */ React12.createElement("div", {
        className: MessageIndicator_module.default.MessageIndicator
      });
      return /* @__PURE__ */ React12.createElement("div", {
        className: MessageIndicator_module.default.MessageIndicatorWrapper
      }, indicatorMarkup, children);
    }
    exports.MessageIndicator = MessageIndicator;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/Menu/Menu.scss.js
var require_Menu_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/Menu/Menu.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      ActivatorWrapper: "Polaris-TopBar-Menu__ActivatorWrapper",
      Activator: "Polaris-TopBar-Menu__Activator",
      "Activator-userMenu": "Polaris-TopBar-Menu__Activator--userMenu",
      Section: "Polaris-TopBar-Menu__Section"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/Menu/components/Message/Message.scss.js
var require_Message_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/Menu/components/Message/Message.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Section: "Polaris-Menu-Message__Section"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/Menu/components/Message/Message.js
var require_Message = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/Menu/components/Message/Message.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), Message_module = require_Message_scss(), Link4 = require_Link(), Badge2 = require_Badge(), Popover = require_Popover(), LegacyStack = require_LegacyStack(), TextContainer = require_TextContainer(), Text4 = require_Text(), Button2 = require_Button();
    function Message({
      title,
      description,
      action,
      link: link2,
      badge
    }) {
      let badgeMarkup = badge && /* @__PURE__ */ React12.createElement(Badge2.Badge, {
        tone: badge.tone
      }, badge.content), {
        to,
        content: linkContent
      } = link2, {
        onClick,
        content: actionContent
      } = action;
      return /* @__PURE__ */ React12.createElement("div", {
        className: Message_module.default.Section
      }, /* @__PURE__ */ React12.createElement(Popover.Popover.Section, null, /* @__PURE__ */ React12.createElement(LegacyStack.LegacyStack, {
        vertical: !0,
        spacing: "tight"
      }, /* @__PURE__ */ React12.createElement(TextContainer.TextContainer, null, /* @__PURE__ */ React12.createElement(Text4.Text, {
        variant: "headingMd",
        as: "h2"
      }, title, badgeMarkup), /* @__PURE__ */ React12.createElement("p", null, description)), /* @__PURE__ */ React12.createElement(Link4.Link, {
        url: to
      }, linkContent), /* @__PURE__ */ React12.createElement(Button2.Button, {
        variant: "plain",
        onClick
      }, actionContent))));
    }
    exports.Message = Message;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/Menu/Menu.js
var require_Menu = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/Menu/Menu.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), css = require_css(), Menu_module = require_Menu_scss(), Message = require_Message(), Popover = require_Popover(), Box2 = require_Box(), ActionList = require_ActionList();
    function Menu(props) {
      let {
        actions,
        onOpen,
        onClose,
        open: open2,
        activatorContent,
        message,
        accessibilityLabel,
        customWidth,
        userMenu
      } = props, badgeProps = message && message.badge && {
        content: message.badge.content,
        tone: message.badge.tone
      }, messageMarkup = message && /* @__PURE__ */ React12.createElement(Message.Message, {
        title: message.title,
        description: message.description,
        action: {
          onClick: message.action.onClick,
          content: message.action.content
        },
        link: {
          to: message.link.to,
          content: message.link.content
        },
        badge: badgeProps
      });
      return /* @__PURE__ */ React12.createElement(Popover.Popover, {
        activator: /* @__PURE__ */ React12.createElement("div", {
          className: Menu_module.default.ActivatorWrapper
        }, /* @__PURE__ */ React12.createElement("button", {
          type: "button",
          className: css.classNames(Menu_module.default.Activator, userMenu && Menu_module.default["Activator-userMenu"]),
          onClick: onOpen,
          "aria-label": accessibilityLabel
        }, activatorContent)),
        active: open2,
        onClose,
        fixed: !0,
        fullHeight: !0,
        preferredAlignment: "right"
      }, /* @__PURE__ */ React12.createElement("div", {
        className: Menu_module.default.MenuItems
      }, /* @__PURE__ */ React12.createElement(Box2.Box, {
        width: customWidth
      }, /* @__PURE__ */ React12.createElement(ActionList.ActionList, {
        actionRole: "menuitem",
        onActionAnyItem: onClose,
        sections: actions
      }), messageMarkup)));
    }
    exports.Menu = Menu;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/UserMenu/UserMenu.js
var require_UserMenu = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/components/UserMenu/UserMenu.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), UserMenu_module = require_UserMenu_scss(), MessageIndicator = require_MessageIndicator(), Menu = require_Menu(), Text4 = require_Text(), Avatar = require_Avatar();
    function UserMenu({
      name,
      detail,
      avatar,
      initials,
      actions,
      message,
      onToggle,
      open: open2,
      accessibilityLabel,
      customActivator,
      customWidth
    }) {
      let showIndicator = !!message, activatorContentMarkup = customActivator || /* @__PURE__ */ React12.createElement(React12.Fragment, null, /* @__PURE__ */ React12.createElement("span", {
        className: UserMenu_module.default.Details
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "p",
        alignment: "start",
        fontWeight: "medium",
        truncate: !0
      }, name), /* @__PURE__ */ React12.createElement("span", {
        className: UserMenu_module.default.Message
      }, /* @__PURE__ */ React12.createElement(Text4.Text, {
        as: "p",
        variant: "bodySm",
        alignment: "start",
        tone: "subdued",
        truncate: !0
      }, detail))), /* @__PURE__ */ React12.createElement(MessageIndicator.MessageIndicator, {
        active: showIndicator
      }, /* @__PURE__ */ React12.createElement(Avatar.Avatar, {
        size: "md",
        initials: initials && initials.replace(" ", ""),
        source: avatar,
        name
      })));
      return /* @__PURE__ */ React12.createElement(Menu.Menu, {
        activatorContent: activatorContentMarkup,
        open: open2,
        onOpen: onToggle,
        onClose: onToggle,
        actions,
        message,
        accessibilityLabel,
        customWidth,
        userMenu: !0
      });
    }
    exports.UserMenu = UserMenu;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/TopBar.js
var require_TopBar = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/TopBar/TopBar.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), css = require_css(), getWidth = require_get_width(), useToggle = require_use_toggle(), TopBar_module = require_TopBar_scss(), Search2 = require_Search(), SearchField = require_SearchField2(), UserMenu = require_UserMenu(), hooks2 = require_hooks2(), hooks$1 = require_hooks9(), Icon = require_Icon(), UnstyledLink = require_UnstyledLink(), Image = require_Image(), Menu = require_Menu(), TopBar = function({
      showNavigationToggle,
      userMenu,
      searchResults,
      searchField,
      secondaryMenu,
      searchResultsVisible,
      searchResultsOverlayVisible = !1,
      onNavigationToggle,
      onSearchResultsDismiss,
      contextControl,
      logoSuffix
    }) {
      let i18n = hooks2.useI18n(), {
        logo
      } = hooks$1.useFrame(), {
        value: focused,
        setTrue: forceTrueFocused,
        setFalse: forceFalseFocused
      } = useToggle.useToggle(!1), iconClassName = css.classNames(TopBar_module.default.NavigationIcon, focused && TopBar_module.default.focused), navigationButtonMarkup = showNavigationToggle ? /* @__PURE__ */ React12.createElement("button", {
        type: "button",
        className: iconClassName,
        onClick: onNavigationToggle,
        onFocus: forceTrueFocused,
        onBlur: forceFalseFocused,
        "aria-label": i18n.translate("Polaris.TopBar.toggleMenuLabel")
      }, /* @__PURE__ */ React12.createElement("div", {
        className: TopBar_module.default.IconWrapper
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.MenuIcon
      }))) : null, width = getWidth.getWidth(logo, 104), contextMarkup;
      if (contextControl)
        contextMarkup = /* @__PURE__ */ React12.createElement("div", {
          className: TopBar_module.default.ContextControl
        }, contextControl);
      else if (logo) {
        let className = css.classNames(TopBar_module.default.LogoContainer, showNavigationToggle || searchField ? TopBar_module.default.LogoDisplayControl : TopBar_module.default.LogoDisplayContainer, logoSuffix && TopBar_module.default.hasLogoSuffix);
        contextMarkup = /* @__PURE__ */ React12.createElement("div", {
          className
        }, /* @__PURE__ */ React12.createElement(UnstyledLink.UnstyledLink, {
          url: logo.url || "",
          className: TopBar_module.default.LogoLink,
          style: {
            width
          }
        }, /* @__PURE__ */ React12.createElement(Image.Image, {
          source: logo.topBarSource || "",
          alt: logo.accessibilityLabel || "",
          className: TopBar_module.default.Logo,
          style: {
            width
          }
        })), logoSuffix);
      }
      let searchMarkup = searchField ? /* @__PURE__ */ React12.createElement(React12.Fragment, null, searchField, /* @__PURE__ */ React12.createElement(Search2.Search, {
        visible: searchResultsVisible,
        onDismiss: onSearchResultsDismiss,
        overlayVisible: searchResultsOverlayVisible
      }, searchResults)) : null;
      return /* @__PURE__ */ React12.createElement("div", {
        className: TopBar_module.default.TopBar
      }, /* @__PURE__ */ React12.createElement("div", {
        className: TopBar_module.default.Container
      }, /* @__PURE__ */ React12.createElement("div", {
        className: TopBar_module.default.LeftContent
      }, navigationButtonMarkup, contextMarkup), /* @__PURE__ */ React12.createElement("div", {
        className: TopBar_module.default.Search
      }, searchMarkup), /* @__PURE__ */ React12.createElement("div", {
        className: TopBar_module.default.RightContent
      }, /* @__PURE__ */ React12.createElement("div", {
        className: TopBar_module.default.SecondaryMenu
      }, secondaryMenu), userMenu)));
    };
    TopBar.Menu = Menu.Menu;
    TopBar.SearchField = SearchField.SearchField;
    TopBar.UserMenu = UserMenu.UserMenu;
    exports.TopBar = TopBar;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/UnstyledButton/utils.js
var require_utils13 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/UnstyledButton/utils.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), UnstyledButton = require_UnstyledButton();
    function unstyledButtonFrom({
      content,
      onAction,
      ...action
    }, overrides, key) {
      return /* @__PURE__ */ React12.createElement(UnstyledButton.UnstyledButton, Object.assign({
        key,
        onClick: onAction
      }, action, overrides), content);
    }
    exports.unstyledButtonFrom = unstyledButtonFrom;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/duration.js
var require_duration = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/duration.js"(exports) {
    "use strict";
    init_cjs_shims();
    function ensureTwoDigits(num) {
      return num > 9 ? String(num) : `0${num}`;
    }
    function secondsToTimeComponents(seconds) {
      return {
        hours: Math.floor(seconds / 3600),
        minutes: Math.floor(seconds % 3600 / 60),
        seconds: seconds % 60
      };
    }
    function secondsToTimestamp(numSeconds) {
      let {
        hours,
        minutes,
        seconds
      } = secondsToTimeComponents(numSeconds), hasHours = numSeconds > 3600, hoursText = hasHours ? `${hours}:` : "", minutesText = `${hasHours ? ensureTwoDigits(minutes) : minutes}:`, secondsText = `${ensureTwoDigits(seconds)}`;
      return `${hoursText}${minutesText}${secondsText}`;
    }
    function secondsToDurationTranslationKey(numSeconds) {
      let {
        hours,
        minutes,
        seconds
      } = secondsToTimeComponents(numSeconds), durationKey = "Polaris.VideoThumbnail.playButtonA11yLabel.duration";
      return hours ? (durationKey += `.hours.${hours > 1 ? "other" : "one"}`, seconds ? minutes > 1 ? durationKey += `${seconds > 1 ? ".minutesAndSeconds" : ".minutesAndSecond"}` : minutes === 1 ? durationKey += `${seconds > 1 ? ".minuteAndSeconds" : ".minuteAndSecond"}` : durationKey += `${seconds > 1 ? ".andSeconds" : ".andSecond"}` : minutes ? durationKey += `${minutes > 1 ? ".andMinutes" : ".andMinute"}` : durationKey += ".only") : minutes ? (durationKey += `.minutes.${minutes > 1 ? "other" : "one"}`, seconds ? durationKey += `${seconds > 1 ? ".andSeconds" : ".andSecond"}` : durationKey += ".only") : seconds && (durationKey += seconds > 1 ? ".seconds.other" : ".seconds.one"), durationKey;
    }
    exports.ensureTwoDigits = ensureTwoDigits;
    exports.secondsToDurationTranslationKey = secondsToDurationTranslationKey;
    exports.secondsToTimeComponents = secondsToTimeComponents;
    exports.secondsToTimestamp = secondsToTimestamp;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/VideoThumbnail/VideoThumbnail.scss.js
var require_VideoThumbnail_scss = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/VideoThumbnail/VideoThumbnail.scss.js"(exports) {
    "use strict";
    init_cjs_shims();
    Object.defineProperty(exports, "__esModule", { value: !0 });
    var styles = {
      Thumbnail: "Polaris-VideoThumbnail__Thumbnail",
      ThumbnailContainer: "Polaris-VideoThumbnail__ThumbnailContainer",
      PlayButton: "Polaris-VideoThumbnail__PlayButton",
      Timestamp: "Polaris-VideoThumbnail__Timestamp",
      PlayIcon: "Polaris-VideoThumbnail__PlayIcon",
      Progress: "Polaris-VideoThumbnail__Progress",
      Indicator: "Polaris-VideoThumbnail__Indicator",
      ProgressBar: "Polaris-VideoThumbnail__ProgressBar",
      Label: "Polaris-VideoThumbnail__Label"
    };
    exports.default = styles;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/VideoThumbnail/VideoThumbnail.js
var require_VideoThumbnail = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/components/VideoThumbnail/VideoThumbnail.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), polarisIcons = require_dist8(), duration = require_duration(), VideoThumbnail_module = require_VideoThumbnail_scss(), hooks2 = require_hooks2(), hooks$1 = require_hooks11(), LegacyStack = require_LegacyStack(), Icon = require_Icon(), Text4 = require_Text();
    function VideoThumbnail({
      thumbnailUrl,
      videoLength = 0,
      videoProgress = 0,
      showVideoProgress = !1,
      accessibilityLabel,
      onClick,
      onBeforeStartPlaying
    }) {
      let i18n = hooks2.useI18n(), {
        isNavigationCollapsed
      } = hooks$1.useMediaQuery(), buttonLabel;
      if (accessibilityLabel)
        buttonLabel = accessibilityLabel;
      else if (videoLength) {
        let {
          hours,
          minutes,
          seconds
        } = duration.secondsToTimeComponents(videoLength);
        buttonLabel = i18n.translate("Polaris.VideoThumbnail.playButtonA11yLabel.defaultWithDuration", {
          duration: i18n.translate(duration.secondsToDurationTranslationKey(videoLength), {
            hourCount: hours,
            minuteCount: minutes,
            secondCount: seconds
          })
        });
      } else
        buttonLabel = i18n.translate("Polaris.VideoThumbnail.playButtonA11yLabel.default");
      let timeStampMarkup = videoLength ? /* @__PURE__ */ React12.createElement("div", {
        className: VideoThumbnail_module.default.Timestamp
      }, /* @__PURE__ */ React12.createElement(LegacyStack.LegacyStack, {
        alignment: "center",
        spacing: "extraTight"
      }, /* @__PURE__ */ React12.createElement("span", {
        className: VideoThumbnail_module.default.PlayIcon
      }, /* @__PURE__ */ React12.createElement(Icon.Icon, {
        source: polarisIcons.PlayIcon
      })), /* @__PURE__ */ React12.createElement(Text4.Text, {
        variant: isNavigationCollapsed ? "bodyLg" : "bodyMd",
        as: "p",
        fontWeight: "semibold"
      }, duration.secondsToTimestamp(videoLength)))) : null, progressMarkup = null;
      if (showVideoProgress) {
        let progressValue = calculateProgress(videoLength, videoProgress), progressValuePercents = Math.round(progressValue * 100);
        progressMarkup = /* @__PURE__ */ React12.createElement("div", {
          className: VideoThumbnail_module.default.Progress
        }, /* @__PURE__ */ React12.createElement("progress", {
          className: VideoThumbnail_module.default.ProgressBar,
          value: progressValuePercents,
          max: "100"
        }), /* @__PURE__ */ React12.createElement("div", {
          className: VideoThumbnail_module.default.Indicator,
          style: {
            transform: `scaleX(${progressValue})`
          }
        }, /* @__PURE__ */ React12.createElement("span", {
          className: VideoThumbnail_module.default.Label
        }, progressValuePercents, "%")));
      }
      return /* @__PURE__ */ React12.createElement("div", {
        className: VideoThumbnail_module.default.ThumbnailContainer
      }, /* @__PURE__ */ React12.createElement("div", {
        className: VideoThumbnail_module.default.Thumbnail,
        style: {
          backgroundImage: `url(${thumbnailUrl})`
        }
      }), /* @__PURE__ */ React12.createElement("button", {
        type: "button",
        className: VideoThumbnail_module.default.PlayButton,
        "aria-label": buttonLabel,
        onClick,
        onMouseEnter: onBeforeStartPlaying,
        onFocus: onBeforeStartPlaying,
        onTouchStart: onBeforeStartPlaying
      }, timeStampMarkup), progressMarkup);
    }
    function calculateProgress(videoLength, videoProgress) {
      if (videoProgress > videoLength && process.env.NODE_ENV === "development" && console.warn("Value passed to the video progress should not exceed video length. Resetting progress to 100%."), videoProgress > 0 && videoLength > 0) {
        let progress = parseFloat((videoProgress / videoLength).toFixed(2));
        return progress > 1 ? 1 : progress;
      }
      return 0;
    }
    exports.VideoThumbnail = VideoThumbnail;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/index-table/hooks.js
var require_hooks14 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/utilities/index-table/hooks.js"(exports) {
    "use strict";
    init_cjs_shims();
    var React12 = require_react(), context = require_context18();
    function useRowHovered() {
      return React12.useContext(context.RowHoveredContext);
    }
    function useRowSelected() {
      let {
        selected
      } = React12.useContext(context.RowContext);
      return selected;
    }
    function useContainerScroll() {
      return React12.useContext(context.ScrollContext);
    }
    exports.useContainerScroll = useContainerScroll;
    exports.useRowHovered = useRowHovered;
    exports.useRowSelected = useRowSelected;
  }
});

// ../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/index.js
var require_cjs5 = __commonJS({
  "../../node_modules/.pnpm/@shopify+polaris@12.10.0_react-dom@18.2.0_react@18.2.0/node_modules/@shopify/polaris/build/cjs/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var configure = require_configure(), types = require_types7(), shared = require_shared(), colorTransformers = require_color_transformers(), withinContentContext = require_within_content_context(), useEventListener = require_use_event_listener(), useTheme = require_use_theme(), useIndexResourceState = require_use_index_resource_state(), breakpoints = require_breakpoints2(), AppProvider3 = require_AppProvider(), AccountConnection = require_AccountConnection(), ActionList = require_ActionList(), ActionMenu = require_ActionMenu(), Autocomplete = require_Autocomplete(), Avatar = require_Avatar(), Backdrop = require_Backdrop(), Badge2 = require_Badge(), types$1 = require_types8(), Banner2 = require_Banner(), Bleed = require_Bleed(), Box2 = require_Box(), Breadcrumbs = require_Breadcrumbs(), BulkActions = require_BulkActions(), Button2 = require_Button(), utils = require_utils10(), ButtonGroup = require_ButtonGroup(), CalloutCard = require_CalloutCard(), Card2 = require_Card(), Checkbox = require_Checkbox(), ChoiceList = require_ChoiceList(), Collapsible = require_Collapsible(), ColorPicker = require_ColorPicker(), InlineGrid = require_InlineGrid(), Combobox = require_Combobox(), Connected = require_Connected(), ContextualSaveBar = require_ContextualSaveBar(), DataTable = require_DataTable(), DatePicker = require_DatePicker(), DescriptionList = require_DescriptionList(), Divider = require_Divider(), DropZone = require_DropZone(), EmptySearchResult = require_EmptySearchResult(), EmptyState = require_EmptyState(), EventListener = require_EventListener(), ExceptionList = require_ExceptionList(), Filters = require_Filters(), Focus = require_Focus(), FooterHelp = require_FooterHelp(), Form = require_Form(), FormLayout = require_FormLayout(), Frame = require_Frame(), Toast = require_Toast(), FullscreenBar = require_FullscreenBar(), Grid2 = require_Grid(), Icon = require_Icon(), Image = require_Image(), IndexFilters = require_IndexFilters(), useSetIndexFiltersMode = require_useSetIndexFiltersMode(), types$2 = require_types9(), IndexTable = require_IndexTable(), Indicator = require_Indicator(), InlineStack2 = require_InlineStack(), InlineCode = require_InlineCode(), InlineError = require_InlineError(), KeyboardKey = require_KeyboardKey(), KeypressListener = require_KeypressListener(), Label = require_Label(), Labelled = require_Labelled(), Layout = require_Layout(), LegacyCard = require_LegacyCard(), LegacyFilters = require_LegacyFilters(), LegacyStack = require_LegacyStack(), LegacyTabs = require_LegacyTabs(), Link4 = require_Link(), List3 = require_List3(), Listbox = require_Listbox(), Loading = require_Loading3(), MediaCard = require_MediaCard(), Modal = require_Modal(), Navigation = require_Navigation2(), Item = require_Item10(), OptionList = require_OptionList(), Page2 = require_Page(), PageActions = require_PageActions(), Pagination = require_Pagination(), PolarisTestProvider = require_PolarisTestProvider(), Popover = require_Popover(), PopoverOverlay = require_PopoverOverlay(), Portal = require_Portal(), PortalsManager = require_PortalsManager(), PositionedOverlay = require_PositionedOverlay(), ProgressBar = require_ProgressBar(), RadioButton = require_RadioButton(), RangeSlider = require_RangeSlider(), ResourceItem = require_ResourceItem(), ResourceList = require_ResourceList(), Scrollable = require_Scrollable(), ScrollLock = require_ScrollLock(), Select2 = require_Select(), SelectAllActions = require_SelectAllActions(), SettingToggle = require_SettingToggle(), Sheet = require_Sheet(), SkeletonBodyText = require_SkeletonBodyText(), SkeletonDisplayText = require_SkeletonDisplayText(), SkeletonPage = require_SkeletonPage(), SkeletonTabs = require_SkeletonTabs(), SkeletonThumbnail = require_SkeletonThumbnail(), Spinner = require_Spinner(), Sticky = require_Sticky(), Tabs = require_Tabs(), Tag = require_Tag(), Text4 = require_Text(), TextContainer = require_TextContainer(), TextField = require_TextField(), Thumbnail = require_Thumbnail(), Toast$1 = require_Toast2(), Tooltip = require_Tooltip(), TopBar = require_TopBar(), TrapFocus = require_TrapFocus(), Truncate = require_Truncate(), UnstyledButton = require_UnstyledButton(), utils$1 = require_utils13(), UnstyledLink = require_UnstyledLink(), BlockStack3 = require_BlockStack(), VideoThumbnail = require_VideoThumbnail(), hooks2 = require_hooks9(), context = require_context15(), context$1 = require_context3(), hooks$1 = require_hooks14(), types$3 = require_types10(), hooks$2 = require_hooks3();
    exports.DEFAULT_LOCALE = configure.DEFAULT_LOCALE;
    exports.SUPPORTED_LOCALES = configure.SUPPORTED_LOCALES;
    Object.defineProperty(exports, "Key", {
      enumerable: !0,
      get: function() {
        return types.Key;
      }
    });
    exports.DATA_ATTRIBUTE = shared.DATA_ATTRIBUTE;
    exports.hexToRgb = colorTransformers.hexToRgb;
    exports.hsbToHex = colorTransformers.hsbToHex;
    exports.hsbToRgb = colorTransformers.hsbToRgb;
    exports.hslToRgb = colorTransformers.hslToRgb;
    exports.rgbString = colorTransformers.rgbString;
    exports.rgbToHex = colorTransformers.rgbToHex;
    exports.rgbToHsb = colorTransformers.rgbToHsb;
    exports.rgbToHsl = colorTransformers.rgbToHsl;
    exports.rgbaString = colorTransformers.rgbaString;
    exports._SECRET_INTERNAL_WITHIN_CONTENT_CONTEXT = withinContentContext.WithinContentContext;
    exports.useEventListener = useEventListener.useEventListener;
    exports.useTheme = useTheme.useTheme;
    exports.useIndexResourceState = useIndexResourceState.useIndexResourceState;
    exports.useBreakpoints = breakpoints.useBreakpoints;
    exports.AppProvider = AppProvider3.AppProvider;
    exports.AccountConnection = AccountConnection.AccountConnection;
    exports.ActionList = ActionList.ActionList;
    exports.ActionMenu = ActionMenu.ActionMenu;
    exports.Autocomplete = Autocomplete.Autocomplete;
    exports.Avatar = Avatar.Avatar;
    exports.Backdrop = Backdrop.Backdrop;
    exports.Badge = Badge2.Badge;
    Object.defineProperty(exports, "BadgeProgressValue", {
      enumerable: !0,
      get: function() {
        return types$1.ProgressValue;
      }
    });
    Object.defineProperty(exports, "BadgeStatusValue", {
      enumerable: !0,
      get: function() {
        return types$1.ToneValue;
      }
    });
    exports.Banner = Banner2.Banner;
    exports.Bleed = Bleed.Bleed;
    exports.Box = Box2.Box;
    exports.Breadcrumbs = Breadcrumbs.Breadcrumbs;
    exports.UnstableBulkActions = BulkActions.BulkActions;
    exports.Button = Button2.Button;
    exports.buttonFrom = utils.buttonFrom;
    exports.buttonsFrom = utils.buttonsFrom;
    exports.ButtonGroup = ButtonGroup.ButtonGroup;
    exports.CalloutCard = CalloutCard.CalloutCard;
    exports.Card = Card2.Card;
    exports.Checkbox = Checkbox.Checkbox;
    exports.ChoiceList = ChoiceList.ChoiceList;
    exports.Collapsible = Collapsible.Collapsible;
    exports.ColorPicker = ColorPicker.ColorPicker;
    exports.InlineGrid = InlineGrid.InlineGrid;
    exports.Combobox = Combobox.Combobox;
    exports.Connected = Connected.Connected;
    exports.ContextualSaveBar = ContextualSaveBar.ContextualSaveBar;
    exports.DataTable = DataTable.DataTable;
    exports.DatePicker = DatePicker.DatePicker;
    exports.DescriptionList = DescriptionList.DescriptionList;
    exports.Divider = Divider.Divider;
    exports.DropZone = DropZone.DropZone;
    exports.EmptySearchResult = EmptySearchResult.EmptySearchResult;
    exports.EmptyState = EmptyState.EmptyState;
    exports.EventListener = EventListener.EventListener;
    exports.ExceptionList = ExceptionList.ExceptionList;
    exports.Filters = Filters.Filters;
    exports.Focus = Focus.Focus;
    exports.FooterHelp = FooterHelp.FooterHelp;
    exports.Form = Form.Form;
    exports.FormLayout = FormLayout.FormLayout;
    exports.Frame = Frame.Frame;
    exports.DEFAULT_TOAST_DURATION = Toast.DEFAULT_TOAST_DURATION;
    exports.DEFAULT_TOAST_DURATION_WITH_ACTION = Toast.DEFAULT_TOAST_DURATION_WITH_ACTION;
    exports.FullscreenBar = FullscreenBar.FullscreenBar;
    exports.Grid = Grid2.Grid;
    exports.Icon = Icon.Icon;
    exports.Image = Image.Image;
    exports.IndexFilters = IndexFilters.IndexFilters;
    exports.useSetIndexFiltersMode = useSetIndexFiltersMode.useSetIndexFiltersMode;
    Object.defineProperty(exports, "IndexFiltersMode", {
      enumerable: !0,
      get: function() {
        return types$2.IndexFiltersMode;
      }
    });
    exports.IndexTable = IndexTable.IndexTable;
    exports.Indicator = Indicator.Indicator;
    exports.InlineStack = InlineStack2.InlineStack;
    exports.InlineCode = InlineCode.InlineCode;
    exports.InlineError = InlineError.InlineError;
    exports.errorTextID = InlineError.errorTextID;
    exports.KeyboardKey = KeyboardKey.KeyboardKey;
    exports.KeypressListener = KeypressListener.KeypressListener;
    exports.Label = Label.Label;
    exports.labelID = Label.labelID;
    exports.Labelled = Labelled.Labelled;
    exports.Layout = Layout.Layout;
    exports.LegacyCard = LegacyCard.LegacyCard;
    exports.LegacyFilters = LegacyFilters.LegacyFilters;
    exports.LegacyStack = LegacyStack.LegacyStack;
    exports.LegacyTabs = LegacyTabs.LegacyTabs;
    exports.Link = Link4.Link;
    exports.List = List3.List;
    Object.defineProperty(exports, "AutoSelection", {
      enumerable: !0,
      get: function() {
        return Listbox.AutoSelection;
      }
    });
    exports.Listbox = Listbox.Listbox;
    exports.Loading = Loading.Loading;
    exports.MediaCard = MediaCard.MediaCard;
    exports.Modal = Modal.Modal;
    exports.Navigation = Navigation.Navigation;
    exports.isNavigationItemActive = Item.isNavigationItemActive;
    exports.OptionList = OptionList.OptionList;
    exports.Page = Page2.Page;
    exports.PageActions = PageActions.PageActions;
    exports.Pagination = Pagination.Pagination;
    exports.PolarisTestProvider = PolarisTestProvider.PolarisTestProvider;
    exports.Popover = Popover.Popover;
    Object.defineProperty(exports, "PopoverCloseSource", {
      enumerable: !0,
      get: function() {
        return PopoverOverlay.PopoverCloseSource;
      }
    });
    exports.Portal = Portal.Portal;
    exports.PortalsManager = PortalsManager.PortalsManager;
    exports.PositionedOverlay = PositionedOverlay.PositionedOverlay;
    exports.ProgressBar = ProgressBar.ProgressBar;
    exports.RadioButton = RadioButton.RadioButton;
    exports.RangeSlider = RangeSlider.RangeSlider;
    exports.ResourceItem = ResourceItem.ResourceItem;
    exports.ResourceList = ResourceList.ResourceList;
    exports.Scrollable = Scrollable.Scrollable;
    exports.ScrollLock = ScrollLock.ScrollLock;
    exports.Select = Select2.Select;
    exports.SelectAllActions = SelectAllActions.SelectAllActions;
    exports.SettingToggle = SettingToggle.SettingToggle;
    exports.Sheet = Sheet.Sheet;
    exports.SkeletonBodyText = SkeletonBodyText.SkeletonBodyText;
    exports.SkeletonDisplayText = SkeletonDisplayText.SkeletonDisplayText;
    exports.SkeletonPage = SkeletonPage.SkeletonPage;
    exports.SkeletonTabs = SkeletonTabs.SkeletonTabs;
    exports.SkeletonThumbnail = SkeletonThumbnail.SkeletonThumbnail;
    exports.Spinner = Spinner.Spinner;
    exports.Sticky = Sticky.Sticky;
    exports.Tabs = Tabs.Tabs;
    exports.Tag = Tag.Tag;
    exports.Text = Text4.Text;
    exports.TextContainer = TextContainer.TextContainer;
    exports.TextField = TextField.TextField;
    exports.Thumbnail = Thumbnail.Thumbnail;
    exports.Toast = Toast$1.Toast;
    exports.Tooltip = Tooltip.Tooltip;
    exports.TopBar = TopBar.TopBar;
    exports.TrapFocus = TrapFocus.TrapFocus;
    exports.Truncate = Truncate.Truncate;
    exports.UnstyledButton = UnstyledButton.UnstyledButton;
    exports.unstyledButtonFrom = utils$1.unstyledButtonFrom;
    exports.UnstyledLink = UnstyledLink.UnstyledLink;
    exports.BlockStack = BlockStack3.BlockStack;
    exports.VideoThumbnail = VideoThumbnail.VideoThumbnail;
    exports.useFrame = hooks2.useFrame;
    exports.FrameContext = context.FrameContext;
    exports._SECRET_INTERNAL_SCROLL_LOCK_MANAGER_CONTEXT = context$1.ScrollLockManagerContext;
    exports.useIndexTableContainerScroll = hooks$1.useContainerScroll;
    exports.useIndexTableRowHovered = hooks$1.useRowHovered;
    exports.useIndexTableRowSelected = hooks$1.useRowSelected;
    exports.INDEX_TABLE_SELECT_ALL_ITEMS = types$3.SELECT_ALL_ITEMS;
    Object.defineProperty(exports, "IndexTableSelectionType", {
      enumerable: !0,
      get: function() {
        return types$3.SelectionType;
      }
    });
    exports.useEphemeralPresenceManager = hooks$2.useReadOnlyEphemeralPresenceManager;
  }
});

// ../../node_modules/.pnpm/depd@2.0.0/node_modules/depd/index.js
var require_depd = __commonJS({
  "../../node_modules/.pnpm/depd@2.0.0/node_modules/depd/index.js"(exports, module) {
    init_cjs_shims();
    var relative = __require("path").relative;
    module.exports = depd;
    var basePath = process.cwd();
    function containsNamespace(str, namespace) {
      for (var vals = str.split(/[ ,]+/), ns = String(namespace).toLowerCase(), i = 0; i < vals.length; i++) {
        var val = vals[i];
        if (val && (val === "*" || val.toLowerCase() === ns))
          return !0;
      }
      return !1;
    }
    function convertDataDescriptorToAccessor(obj, prop, message) {
      var descriptor = Object.getOwnPropertyDescriptor(obj, prop), value = descriptor.value;
      return descriptor.get = function() {
        return value;
      }, descriptor.writable && (descriptor.set = function(val) {
        return value = val;
      }), delete descriptor.value, delete descriptor.writable, Object.defineProperty(obj, prop, descriptor), descriptor;
    }
    function createArgumentsString(arity) {
      for (var str = "", i = 0; i < arity; i++)
        str += ", arg" + i;
      return str.substr(2);
    }
    function createStackString(stack) {
      var str = this.name + ": " + this.namespace;
      this.message && (str += " deprecated " + this.message);
      for (var i = 0; i < stack.length; i++)
        str += `
    at ` + stack[i].toString();
      return str;
    }
    function depd(namespace) {
      if (!namespace)
        throw new TypeError("argument namespace is required");
      var stack = getStack(), site = callSiteLocation(stack[1]), file = site[0];
      function deprecate(message) {
        log.call(deprecate, message);
      }
      return deprecate._file = file, deprecate._ignored = isignored(namespace), deprecate._namespace = namespace, deprecate._traced = istraced(namespace), deprecate._warned = /* @__PURE__ */ Object.create(null), deprecate.function = wrapfunction, deprecate.property = wrapproperty, deprecate;
    }
    function eehaslisteners(emitter, type) {
      var count = typeof emitter.listenerCount != "function" ? emitter.listeners(type).length : emitter.listenerCount(type);
      return count > 0;
    }
    function isignored(namespace) {
      if (process.noDeprecation)
        return !0;
      var str = process.env.NO_DEPRECATION || "";
      return containsNamespace(str, namespace);
    }
    function istraced(namespace) {
      if (process.traceDeprecation)
        return !0;
      var str = process.env.TRACE_DEPRECATION || "";
      return containsNamespace(str, namespace);
    }
    function log(message, site) {
      var haslisteners = eehaslisteners(process, "deprecation");
      if (!(!haslisteners && this._ignored)) {
        var caller, callFile, callSite, depSite, i = 0, seen = !1, stack = getStack(), file = this._file;
        for (site ? (depSite = site, callSite = callSiteLocation(stack[1]), callSite.name = depSite.name, file = callSite[0]) : (i = 2, depSite = callSiteLocation(stack[i]), callSite = depSite); i < stack.length; i++)
          if (caller = callSiteLocation(stack[i]), callFile = caller[0], callFile === file)
            seen = !0;
          else if (callFile === this._file)
            file = this._file;
          else if (seen)
            break;
        var key = caller ? depSite.join(":") + "__" + caller.join(":") : void 0;
        if (!(key !== void 0 && key in this._warned)) {
          this._warned[key] = !0;
          var msg = message;
          if (msg || (msg = callSite === depSite || !callSite.name ? defaultMessage(depSite) : defaultMessage(callSite)), haslisteners) {
            var err2 = DeprecationError(this._namespace, msg, stack.slice(i));
            process.emit("deprecation", err2);
            return;
          }
          var format4 = process.stderr.isTTY ? formatColor : formatPlain, output = format4.call(this, msg, caller, stack.slice(i));
          process.stderr.write(output + `
`, "utf8");
        }
      }
    }
    function callSiteLocation(callSite) {
      var file = callSite.getFileName() || "<anonymous>", line = callSite.getLineNumber(), colm = callSite.getColumnNumber();
      callSite.isEval() && (file = callSite.getEvalOrigin() + ", " + file);
      var site = [file, line, colm];
      return site.callSite = callSite, site.name = callSite.getFunctionName(), site;
    }
    function defaultMessage(site) {
      var callSite = site.callSite, funcName = site.name;
      funcName || (funcName = "<anonymous@" + formatLocation(site) + ">");
      var context = callSite.getThis(), typeName = context && callSite.getTypeName();
      return typeName === "Object" && (typeName = void 0), typeName === "Function" && (typeName = context.name || typeName), typeName && callSite.getMethodName() ? typeName + "." + funcName : funcName;
    }
    function formatPlain(msg, caller, stack) {
      var timestamp = (/* @__PURE__ */ new Date()).toUTCString(), formatted = timestamp + " " + this._namespace + " deprecated " + msg;
      if (this._traced) {
        for (var i = 0; i < stack.length; i++)
          formatted += `
    at ` + stack[i].toString();
        return formatted;
      }
      return caller && (formatted += " at " + formatLocation(caller)), formatted;
    }
    function formatColor(msg, caller, stack) {
      var formatted = "\x1B[36;1m" + this._namespace + "\x1B[22;39m \x1B[33;1mdeprecated\x1B[22;39m \x1B[0m" + msg + "\x1B[39m";
      if (this._traced) {
        for (var i = 0; i < stack.length; i++)
          formatted += `
    \x1B[36mat ` + stack[i].toString() + "\x1B[39m";
        return formatted;
      }
      return caller && (formatted += " \x1B[36m" + formatLocation(caller) + "\x1B[39m"), formatted;
    }
    function formatLocation(callSite) {
      return relative(basePath, callSite[0]) + ":" + callSite[1] + ":" + callSite[2];
    }
    function getStack() {
      var limit = Error.stackTraceLimit, obj = {}, prep = Error.prepareStackTrace;
      Error.prepareStackTrace = prepareObjectStackTrace, Error.stackTraceLimit = Math.max(10, limit), Error.captureStackTrace(obj);
      var stack = obj.stack.slice(1);
      return Error.prepareStackTrace = prep, Error.stackTraceLimit = limit, stack;
    }
    function prepareObjectStackTrace(obj, stack) {
      return stack;
    }
    function wrapfunction(fn, message) {
      if (typeof fn != "function")
        throw new TypeError("argument fn must be a function");
      var args = createArgumentsString(fn.length), stack = getStack(), site = callSiteLocation(stack[1]);
      site.name = fn.name;
      var deprecatedfn = new Function(
        "fn",
        "log",
        "deprecate",
        "message",
        "site",
        `"use strict"
return function (` + args + `) {log.call(deprecate, message, site)
return fn.apply(this, arguments)
}`
      )(fn, log, this, message, site);
      return deprecatedfn;
    }
    function wrapproperty(obj, prop, message) {
      if (!obj || typeof obj != "object" && typeof obj != "function")
        throw new TypeError("argument obj must be object");
      var descriptor = Object.getOwnPropertyDescriptor(obj, prop);
      if (!descriptor)
        throw new TypeError("must call property on owner object");
      if (!descriptor.configurable)
        throw new TypeError("property must be configurable");
      var deprecate = this, stack = getStack(), site = callSiteLocation(stack[1]);
      site.name = prop, "value" in descriptor && (descriptor = convertDataDescriptorToAccessor(obj, prop, message));
      var get2 = descriptor.get, set2 = descriptor.set;
      typeof get2 == "function" && (descriptor.get = function() {
        return log.call(deprecate, message, site), get2.apply(this, arguments);
      }), typeof set2 == "function" && (descriptor.set = function() {
        return log.call(deprecate, message, site), set2.apply(this, arguments);
      }), Object.defineProperty(obj, prop, descriptor);
    }
    function DeprecationError(namespace, message, stack) {
      var error = new Error(), stackString;
      return Object.defineProperty(error, "constructor", {
        value: DeprecationError
      }), Object.defineProperty(error, "message", {
        configurable: !0,
        enumerable: !1,
        value: message,
        writable: !0
      }), Object.defineProperty(error, "name", {
        enumerable: !1,
        configurable: !0,
        value: "DeprecationError",
        writable: !0
      }), Object.defineProperty(error, "namespace", {
        configurable: !0,
        enumerable: !1,
        value: namespace,
        writable: !0
      }), Object.defineProperty(error, "stack", {
        configurable: !0,
        enumerable: !1,
        get: function() {
          return stackString !== void 0 ? stackString : stackString = createStackString.call(this, stack);
        },
        set: function(val) {
          stackString = val;
        }
      }), error;
    }
  }
});

// ../../node_modules/.pnpm/bytes@3.1.2/node_modules/bytes/index.js
var require_bytes = __commonJS({
  "../../node_modules/.pnpm/bytes@3.1.2/node_modules/bytes/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = bytes;
    module.exports.format = format4;
    module.exports.parse = parse4;
    var formatThousandsRegExp = /\B(?=(\d{3})+(?!\d))/g, formatDecimalsRegExp = /(?:\.0*|(\.[^0]+)0+)$/, map = {
      b: 1,
      kb: 1024,
      mb: 1 << 20,
      gb: 1 << 30,
      tb: Math.pow(1024, 4),
      pb: Math.pow(1024, 5)
    }, parseRegExp = /^((-|\+)?(\d+(?:\.\d+)?)) *(kb|mb|gb|tb|pb)$/i;
    function bytes(value, options) {
      return typeof value == "string" ? parse4(value) : typeof value == "number" ? format4(value, options) : null;
    }
    function format4(value, options) {
      if (!Number.isFinite(value))
        return null;
      var mag = Math.abs(value), thousandsSeparator = options && options.thousandsSeparator || "", unitSeparator = options && options.unitSeparator || "", decimalPlaces = options && options.decimalPlaces !== void 0 ? options.decimalPlaces : 2, fixedDecimals = !!(options && options.fixedDecimals), unit = options && options.unit || "";
      (!unit || !map[unit.toLowerCase()]) && (mag >= map.pb ? unit = "PB" : mag >= map.tb ? unit = "TB" : mag >= map.gb ? unit = "GB" : mag >= map.mb ? unit = "MB" : mag >= map.kb ? unit = "KB" : unit = "B");
      var val = value / map[unit.toLowerCase()], str = val.toFixed(decimalPlaces);
      return fixedDecimals || (str = str.replace(formatDecimalsRegExp, "$1")), thousandsSeparator && (str = str.split(".").map(function(s, i) {
        return i === 0 ? s.replace(formatThousandsRegExp, thousandsSeparator) : s;
      }).join(".")), str + unitSeparator + unit;
    }
    function parse4(val) {
      if (typeof val == "number" && !isNaN(val))
        return val;
      if (typeof val != "string")
        return null;
      var results = parseRegExp.exec(val), floatValue, unit = "b";
      return results ? (floatValue = parseFloat(results[1]), unit = results[4].toLowerCase()) : (floatValue = parseInt(val, 10), unit = "b"), isNaN(floatValue) ? null : Math.floor(map[unit] * floatValue);
    }
  }
});

// ../../node_modules/.pnpm/content-type@1.0.5/node_modules/content-type/index.js
var require_content_type = __commonJS({
  "../../node_modules/.pnpm/content-type@1.0.5/node_modules/content-type/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    var PARAM_REGEXP = /; *([!#$%&'*+.^_`|~0-9A-Za-z-]+) *= *("(?:[\u000b\u0020\u0021\u0023-\u005b\u005d-\u007e\u0080-\u00ff]|\\[\u000b\u0020-\u00ff])*"|[!#$%&'*+.^_`|~0-9A-Za-z-]+) */g, TEXT_REGEXP = /^[\u000b\u0020-\u007e\u0080-\u00ff]+$/, TOKEN_REGEXP = /^[!#$%&'*+.^_`|~0-9A-Za-z-]+$/, QESC_REGEXP = /\\([\u000b\u0020-\u00ff])/g, QUOTE_REGEXP = /([\\"])/g, TYPE_REGEXP = /^[!#$%&'*+.^_`|~0-9A-Za-z-]+\/[!#$%&'*+.^_`|~0-9A-Za-z-]+$/;
    exports.format = format4;
    exports.parse = parse4;
    function format4(obj) {
      if (!obj || typeof obj != "object")
        throw new TypeError("argument obj is required");
      var parameters = obj.parameters, type = obj.type;
      if (!type || !TYPE_REGEXP.test(type))
        throw new TypeError("invalid type");
      var string = type;
      if (parameters && typeof parameters == "object")
        for (var param, params = Object.keys(parameters).sort(), i = 0; i < params.length; i++) {
          if (param = params[i], !TOKEN_REGEXP.test(param))
            throw new TypeError("invalid parameter name");
          string += "; " + param + "=" + qstring(parameters[param]);
        }
      return string;
    }
    function parse4(string) {
      if (!string)
        throw new TypeError("argument string is required");
      var header2 = typeof string == "object" ? getcontenttype(string) : string;
      if (typeof header2 != "string")
        throw new TypeError("argument string is required to be a string");
      var index = header2.indexOf(";"), type = index !== -1 ? header2.slice(0, index).trim() : header2.trim();
      if (!TYPE_REGEXP.test(type))
        throw new TypeError("invalid media type");
      var obj = new ContentType(type.toLowerCase());
      if (index !== -1) {
        var key, match2, value;
        for (PARAM_REGEXP.lastIndex = index; match2 = PARAM_REGEXP.exec(header2); ) {
          if (match2.index !== index)
            throw new TypeError("invalid parameter format");
          index += match2[0].length, key = match2[1].toLowerCase(), value = match2[2], value.charCodeAt(0) === 34 && (value = value.slice(1, -1), value.indexOf("\\") !== -1 && (value = value.replace(QESC_REGEXP, "$1"))), obj.parameters[key] = value;
        }
        if (index !== header2.length)
          throw new TypeError("invalid parameter format");
      }
      return obj;
    }
    function getcontenttype(obj) {
      var header2;
      if (typeof obj.getHeader == "function" ? header2 = obj.getHeader("content-type") : typeof obj.headers == "object" && (header2 = obj.headers && obj.headers["content-type"]), typeof header2 != "string")
        throw new TypeError("content-type header is missing from object");
      return header2;
    }
    function qstring(val) {
      var str = String(val);
      if (TOKEN_REGEXP.test(str))
        return str;
      if (str.length > 0 && !TEXT_REGEXP.test(str))
        throw new TypeError("invalid parameter value");
      return '"' + str.replace(QUOTE_REGEXP, "\\$1") + '"';
    }
    function ContentType(type) {
      this.parameters = /* @__PURE__ */ Object.create(null), this.type = type;
    }
  }
});

// ../../node_modules/.pnpm/setprototypeof@1.2.0/node_modules/setprototypeof/index.js
var require_setprototypeof = __commonJS({
  "../../node_modules/.pnpm/setprototypeof@1.2.0/node_modules/setprototypeof/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = Object.setPrototypeOf || ({ __proto__: [] } instanceof Array ? setProtoOf : mixinProperties);
    function setProtoOf(obj, proto) {
      return obj.__proto__ = proto, obj;
    }
    function mixinProperties(obj, proto) {
      for (var prop in proto)
        Object.prototype.hasOwnProperty.call(obj, prop) || (obj[prop] = proto[prop]);
      return obj;
    }
  }
});

// ../../node_modules/.pnpm/statuses@2.0.1/node_modules/statuses/codes.json
var require_codes = __commonJS({
  "../../node_modules/.pnpm/statuses@2.0.1/node_modules/statuses/codes.json"(exports, module) {
    module.exports = {
      "100": "Continue",
      "101": "Switching Protocols",
      "102": "Processing",
      "103": "Early Hints",
      "200": "OK",
      "201": "Created",
      "202": "Accepted",
      "203": "Non-Authoritative Information",
      "204": "No Content",
      "205": "Reset Content",
      "206": "Partial Content",
      "207": "Multi-Status",
      "208": "Already Reported",
      "226": "IM Used",
      "300": "Multiple Choices",
      "301": "Moved Permanently",
      "302": "Found",
      "303": "See Other",
      "304": "Not Modified",
      "305": "Use Proxy",
      "307": "Temporary Redirect",
      "308": "Permanent Redirect",
      "400": "Bad Request",
      "401": "Unauthorized",
      "402": "Payment Required",
      "403": "Forbidden",
      "404": "Not Found",
      "405": "Method Not Allowed",
      "406": "Not Acceptable",
      "407": "Proxy Authentication Required",
      "408": "Request Timeout",
      "409": "Conflict",
      "410": "Gone",
      "411": "Length Required",
      "412": "Precondition Failed",
      "413": "Payload Too Large",
      "414": "URI Too Long",
      "415": "Unsupported Media Type",
      "416": "Range Not Satisfiable",
      "417": "Expectation Failed",
      "418": "I'm a Teapot",
      "421": "Misdirected Request",
      "422": "Unprocessable Entity",
      "423": "Locked",
      "424": "Failed Dependency",
      "425": "Too Early",
      "426": "Upgrade Required",
      "428": "Precondition Required",
      "429": "Too Many Requests",
      "431": "Request Header Fields Too Large",
      "451": "Unavailable For Legal Reasons",
      "500": "Internal Server Error",
      "501": "Not Implemented",
      "502": "Bad Gateway",
      "503": "Service Unavailable",
      "504": "Gateway Timeout",
      "505": "HTTP Version Not Supported",
      "506": "Variant Also Negotiates",
      "507": "Insufficient Storage",
      "508": "Loop Detected",
      "509": "Bandwidth Limit Exceeded",
      "510": "Not Extended",
      "511": "Network Authentication Required"
    };
  }
});

// ../../node_modules/.pnpm/statuses@2.0.1/node_modules/statuses/index.js
var require_statuses = __commonJS({
  "../../node_modules/.pnpm/statuses@2.0.1/node_modules/statuses/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var codes = require_codes();
    module.exports = status;
    status.message = codes;
    status.code = createMessageToStatusCodeMap(codes);
    status.codes = createStatusCodeList(codes);
    status.redirect = {
      300: !0,
      301: !0,
      302: !0,
      303: !0,
      305: !0,
      307: !0,
      308: !0
    };
    status.empty = {
      204: !0,
      205: !0,
      304: !0
    };
    status.retry = {
      502: !0,
      503: !0,
      504: !0
    };
    function createMessageToStatusCodeMap(codes2) {
      var map = {};
      return Object.keys(codes2).forEach(function(code) {
        var message = codes2[code], status2 = Number(code);
        map[message.toLowerCase()] = status2;
      }), map;
    }
    function createStatusCodeList(codes2) {
      return Object.keys(codes2).map(function(code) {
        return Number(code);
      });
    }
    function getStatusCode(message) {
      var msg = message.toLowerCase();
      if (!Object.prototype.hasOwnProperty.call(status.code, msg))
        throw new Error('invalid status message: "' + message + '"');
      return status.code[msg];
    }
    function getStatusMessage(code) {
      if (!Object.prototype.hasOwnProperty.call(status.message, code))
        throw new Error("invalid status code: " + code);
      return status.message[code];
    }
    function status(code) {
      if (typeof code == "number")
        return getStatusMessage(code);
      if (typeof code != "string")
        throw new TypeError("code must be a number or string");
      var n = parseInt(code, 10);
      return isNaN(n) ? getStatusCode(code) : getStatusMessage(n);
    }
  }
});

// ../../node_modules/.pnpm/toidentifier@1.0.1/node_modules/toidentifier/index.js
var require_toidentifier = __commonJS({
  "../../node_modules/.pnpm/toidentifier@1.0.1/node_modules/toidentifier/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = toIdentifier;
    function toIdentifier(str) {
      return str.split(" ").map(function(token) {
        return token.slice(0, 1).toUpperCase() + token.slice(1);
      }).join("").replace(/[^ _0-9a-z]/gi, "");
    }
  }
});

// ../../node_modules/.pnpm/http-errors@2.0.0/node_modules/http-errors/index.js
var require_http_errors = __commonJS({
  "../../node_modules/.pnpm/http-errors@2.0.0/node_modules/http-errors/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var deprecate = require_depd()("http-errors"), setPrototypeOf = require_setprototypeof(), statuses = require_statuses(), inherits = require_inherits(), toIdentifier = require_toidentifier();
    module.exports = createError2;
    module.exports.HttpError = createHttpErrorConstructor();
    module.exports.isHttpError = createIsHttpErrorFunction(module.exports.HttpError);
    populateConstructorExports(module.exports, statuses.codes, module.exports.HttpError);
    function codeClass(status) {
      return +(String(status).charAt(0) + "00");
    }
    function createError2() {
      for (var err2, msg, status = 500, props = {}, i = 0; i < arguments.length; i++) {
        var arg = arguments[i], type = typeof arg;
        if (type === "object" && arg instanceof Error)
          err2 = arg, status = err2.status || err2.statusCode || status;
        else if (type === "number" && i === 0)
          status = arg;
        else if (type === "string")
          msg = arg;
        else if (type === "object")
          props = arg;
        else
          throw new TypeError("argument #" + (i + 1) + " unsupported type " + type);
      }
      typeof status == "number" && (status < 400 || status >= 600) && deprecate("non-error status code; use only 4xx or 5xx status codes"), (typeof status != "number" || !statuses.message[status] && (status < 400 || status >= 600)) && (status = 500);
      var HttpError = createError2[status] || createError2[codeClass(status)];
      err2 || (err2 = HttpError ? new HttpError(msg) : new Error(msg || statuses.message[status]), Error.captureStackTrace(err2, createError2)), (!HttpError || !(err2 instanceof HttpError) || err2.status !== status) && (err2.expose = status < 500, err2.status = err2.statusCode = status);
      for (var key in props)
        key !== "status" && key !== "statusCode" && (err2[key] = props[key]);
      return err2;
    }
    function createHttpErrorConstructor() {
      function HttpError() {
        throw new TypeError("cannot construct abstract class");
      }
      return inherits(HttpError, Error), HttpError;
    }
    function createClientErrorConstructor(HttpError, name, code) {
      var className = toClassName(name);
      function ClientError2(message) {
        var msg = message ?? statuses.message[code], err2 = new Error(msg);
        return Error.captureStackTrace(err2, ClientError2), setPrototypeOf(err2, ClientError2.prototype), Object.defineProperty(err2, "message", {
          enumerable: !0,
          configurable: !0,
          value: msg,
          writable: !0
        }), Object.defineProperty(err2, "name", {
          enumerable: !1,
          configurable: !0,
          value: className,
          writable: !0
        }), err2;
      }
      return inherits(ClientError2, HttpError), nameFunc(ClientError2, className), ClientError2.prototype.status = code, ClientError2.prototype.statusCode = code, ClientError2.prototype.expose = !0, ClientError2;
    }
    function createIsHttpErrorFunction(HttpError) {
      return function(val) {
        return !val || typeof val != "object" ? !1 : val instanceof HttpError ? !0 : val instanceof Error && typeof val.expose == "boolean" && typeof val.statusCode == "number" && val.status === val.statusCode;
      };
    }
    function createServerErrorConstructor(HttpError, name, code) {
      var className = toClassName(name);
      function ServerError(message) {
        var msg = message ?? statuses.message[code], err2 = new Error(msg);
        return Error.captureStackTrace(err2, ServerError), setPrototypeOf(err2, ServerError.prototype), Object.defineProperty(err2, "message", {
          enumerable: !0,
          configurable: !0,
          value: msg,
          writable: !0
        }), Object.defineProperty(err2, "name", {
          enumerable: !1,
          configurable: !0,
          value: className,
          writable: !0
        }), err2;
      }
      return inherits(ServerError, HttpError), nameFunc(ServerError, className), ServerError.prototype.status = code, ServerError.prototype.statusCode = code, ServerError.prototype.expose = !1, ServerError;
    }
    function nameFunc(func, name) {
      var desc = Object.getOwnPropertyDescriptor(func, "name");
      desc && desc.configurable && (desc.value = name, Object.defineProperty(func, "name", desc));
    }
    function populateConstructorExports(exports2, codes, HttpError) {
      codes.forEach(function(code) {
        var CodeError, name = toIdentifier(statuses.message[code]);
        switch (codeClass(code)) {
          case 400:
            CodeError = createClientErrorConstructor(HttpError, name, code);
            break;
          case 500:
            CodeError = createServerErrorConstructor(HttpError, name, code);
            break;
        }
        CodeError && (exports2[code] = CodeError, exports2[name] = CodeError);
      });
    }
    function toClassName(name) {
      return name.substr(-5) !== "Error" ? name + "Error" : name;
    }
  }
});

// ../../node_modules/.pnpm/ms@2.0.0/node_modules/ms/index.js
var require_ms = __commonJS({
  "../../node_modules/.pnpm/ms@2.0.0/node_modules/ms/index.js"(exports, module) {
    init_cjs_shims();
    var s = 1e3, m = s * 60, h = m * 60, d = h * 24, y = d * 365.25;
    module.exports = function(val, options) {
      options = options || {};
      var type = typeof val;
      if (type === "string" && val.length > 0)
        return parse4(val);
      if (type === "number" && isNaN(val) === !1)
        return options.long ? fmtLong(val) : fmtShort(val);
      throw new Error(
        "val is not a non-empty string or a valid number. val=" + JSON.stringify(val)
      );
    };
    function parse4(str) {
      if (str = String(str), !(str.length > 100)) {
        var match2 = /^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(
          str
        );
        if (match2) {
          var n = parseFloat(match2[1]), type = (match2[2] || "ms").toLowerCase();
          switch (type) {
            case "years":
            case "year":
            case "yrs":
            case "yr":
            case "y":
              return n * y;
            case "days":
            case "day":
            case "d":
              return n * d;
            case "hours":
            case "hour":
            case "hrs":
            case "hr":
            case "h":
              return n * h;
            case "minutes":
            case "minute":
            case "mins":
            case "min":
            case "m":
              return n * m;
            case "seconds":
            case "second":
            case "secs":
            case "sec":
            case "s":
              return n * s;
            case "milliseconds":
            case "millisecond":
            case "msecs":
            case "msec":
            case "ms":
              return n;
            default:
              return;
          }
        }
      }
    }
    function fmtShort(ms) {
      return ms >= d ? Math.round(ms / d) + "d" : ms >= h ? Math.round(ms / h) + "h" : ms >= m ? Math.round(ms / m) + "m" : ms >= s ? Math.round(ms / s) + "s" : ms + "ms";
    }
    function fmtLong(ms) {
      return plural(ms, d, "day") || plural(ms, h, "hour") || plural(ms, m, "minute") || plural(ms, s, "second") || ms + " ms";
    }
    function plural(ms, n, name) {
      if (!(ms < n))
        return ms < n * 1.5 ? Math.floor(ms / n) + " " + name : Math.ceil(ms / n) + " " + name + "s";
    }
  }
});

// ../../node_modules/.pnpm/debug@2.6.9/node_modules/debug/src/debug.js
var require_debug = __commonJS({
  "../../node_modules/.pnpm/debug@2.6.9/node_modules/debug/src/debug.js"(exports, module) {
    init_cjs_shims();
    exports = module.exports = createDebug.debug = createDebug.default = createDebug;
    exports.coerce = coerce;
    exports.disable = disable;
    exports.enable = enable;
    exports.enabled = enabled;
    exports.humanize = require_ms();
    exports.names = [];
    exports.skips = [];
    exports.formatters = {};
    var prevTime;
    function selectColor(namespace) {
      var hash = 0, i;
      for (i in namespace)
        hash = (hash << 5) - hash + namespace.charCodeAt(i), hash |= 0;
      return exports.colors[Math.abs(hash) % exports.colors.length];
    }
    function createDebug(namespace) {
      function debug4() {
        if (debug4.enabled) {
          var self2 = debug4, curr = +/* @__PURE__ */ new Date(), ms = curr - (prevTime || curr);
          self2.diff = ms, self2.prev = prevTime, self2.curr = curr, prevTime = curr;
          for (var args = new Array(arguments.length), i = 0; i < args.length; i++)
            args[i] = arguments[i];
          args[0] = exports.coerce(args[0]), typeof args[0] != "string" && args.unshift("%O");
          var index = 0;
          args[0] = args[0].replace(/%([a-zA-Z%])/g, function(match2, format4) {
            if (match2 === "%%")
              return match2;
            index++;
            var formatter = exports.formatters[format4];
            if (typeof formatter == "function") {
              var val = args[index];
              match2 = formatter.call(self2, val), args.splice(index, 1), index--;
            }
            return match2;
          }), exports.formatArgs.call(self2, args);
          var logFn = debug4.log || exports.log || console.log.bind(console);
          logFn.apply(self2, args);
        }
      }
      return debug4.namespace = namespace, debug4.enabled = exports.enabled(namespace), debug4.useColors = exports.useColors(), debug4.color = selectColor(namespace), typeof exports.init == "function" && exports.init(debug4), debug4;
    }
    function enable(namespaces) {
      exports.save(namespaces), exports.names = [], exports.skips = [];
      for (var split = (typeof namespaces == "string" ? namespaces : "").split(/[\s,]+/), len = split.length, i = 0; i < len; i++)
        split[i] && (namespaces = split[i].replace(/\*/g, ".*?"), namespaces[0] === "-" ? exports.skips.push(new RegExp("^" + namespaces.substr(1) + "$")) : exports.names.push(new RegExp("^" + namespaces + "$")));
    }
    function disable() {
      exports.enable("");
    }
    function enabled(name) {
      var i, len;
      for (i = 0, len = exports.skips.length; i < len; i++)
        if (exports.skips[i].test(name))
          return !1;
      for (i = 0, len = exports.names.length; i < len; i++)
        if (exports.names[i].test(name))
          return !0;
      return !1;
    }
    function coerce(val) {
      return val instanceof Error ? val.stack || val.message : val;
    }
  }
});

// ../../node_modules/.pnpm/debug@2.6.9/node_modules/debug/src/browser.js
var require_browser = __commonJS({
  "../../node_modules/.pnpm/debug@2.6.9/node_modules/debug/src/browser.js"(exports, module) {
    init_cjs_shims();
    exports = module.exports = require_debug();
    exports.log = log;
    exports.formatArgs = formatArgs;
    exports.save = save;
    exports.load = load;
    exports.useColors = useColors;
    exports.storage = typeof chrome < "u" && typeof chrome.storage < "u" ? chrome.storage.local : localstorage();
    exports.colors = [
      "lightseagreen",
      "forestgreen",
      "goldenrod",
      "dodgerblue",
      "darkorchid",
      "crimson"
    ];
    function useColors() {
      return typeof window < "u" && window.process && window.process.type === "renderer" ? !0 : typeof document < "u" && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || // is firebug? http://stackoverflow.com/a/398120/376773
      typeof window < "u" && window.console && (window.console.firebug || window.console.exception && window.console.table) || // is firefox >= v31?
      // https://developer.mozilla.org/en-US/docs/Tools/Web_Console#Styling_messages
      typeof navigator < "u" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || // double check webkit in userAgent just in case we are in a worker
      typeof navigator < "u" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
    }
    exports.formatters.j = function(v) {
      try {
        return JSON.stringify(v);
      } catch (err2) {
        return "[UnexpectedJSONParseError]: " + err2.message;
      }
    };
    function formatArgs(args) {
      var useColors2 = this.useColors;
      if (args[0] = (useColors2 ? "%c" : "") + this.namespace + (useColors2 ? " %c" : " ") + args[0] + (useColors2 ? "%c " : " ") + "+" + exports.humanize(this.diff), !!useColors2) {
        var c = "color: " + this.color;
        args.splice(1, 0, c, "color: inherit");
        var index = 0, lastC = 0;
        args[0].replace(/%[a-zA-Z%]/g, function(match2) {
          match2 !== "%%" && (index++, match2 === "%c" && (lastC = index));
        }), args.splice(lastC, 0, c);
      }
    }
    function log() {
      return typeof console == "object" && console.log && Function.prototype.apply.call(console.log, console, arguments);
    }
    function save(namespaces) {
      try {
        namespaces == null ? exports.storage.removeItem("debug") : exports.storage.debug = namespaces;
      } catch {
      }
    }
    function load() {
      var r2;
      try {
        r2 = exports.storage.debug;
      } catch {
      }
      return !r2 && typeof process < "u" && "env" in process && (r2 = process.env.DEBUG), r2;
    }
    exports.enable(load());
    function localstorage() {
      try {
        return window.localStorage;
      } catch {
      }
    }
  }
});

// ../../node_modules/.pnpm/debug@2.6.9/node_modules/debug/src/node.js
var require_node6 = __commonJS({
  "../../node_modules/.pnpm/debug@2.6.9/node_modules/debug/src/node.js"(exports, module) {
    init_cjs_shims();
    var tty = __require("tty"), util2 = __require("util");
    exports = module.exports = require_debug();
    exports.init = init4;
    exports.log = log;
    exports.formatArgs = formatArgs;
    exports.save = save;
    exports.load = load;
    exports.useColors = useColors;
    exports.colors = [6, 2, 3, 4, 5, 1];
    exports.inspectOpts = Object.keys(process.env).filter(function(key) {
      return /^debug_/i.test(key);
    }).reduce(function(obj, key) {
      var prop = key.substring(6).toLowerCase().replace(/_([a-z])/g, function(_2, k) {
        return k.toUpperCase();
      }), val = process.env[key];
      return /^(yes|on|true|enabled)$/i.test(val) ? val = !0 : /^(no|off|false|disabled)$/i.test(val) ? val = !1 : val === "null" ? val = null : val = Number(val), obj[prop] = val, obj;
    }, {});
    var fd = parseInt(process.env.DEBUG_FD, 10) || 2;
    fd !== 1 && fd !== 2 && util2.deprecate(function() {
    }, "except for stderr(2) and stdout(1), any other usage of DEBUG_FD is deprecated. Override debug.log if you want to use a different log function (https://git.io/debug_fd)")();
    var stream2 = fd === 1 ? process.stdout : fd === 2 ? process.stderr : createWritableStdioStream(fd);
    function useColors() {
      return "colors" in exports.inspectOpts ? !!exports.inspectOpts.colors : tty.isatty(fd);
    }
    exports.formatters.o = function(v) {
      return this.inspectOpts.colors = this.useColors, util2.inspect(v, this.inspectOpts).split(`
`).map(function(str) {
        return str.trim();
      }).join(" ");
    };
    exports.formatters.O = function(v) {
      return this.inspectOpts.colors = this.useColors, util2.inspect(v, this.inspectOpts);
    };
    function formatArgs(args) {
      var name = this.namespace, useColors2 = this.useColors;
      if (useColors2) {
        var c = this.color, prefix = "  \x1B[3" + c + ";1m" + name + " \x1B[0m";
        args[0] = prefix + args[0].split(`
`).join(`
` + prefix), args.push("\x1B[3" + c + "m+" + exports.humanize(this.diff) + "\x1B[0m");
      } else
        args[0] = (/* @__PURE__ */ new Date()).toUTCString() + " " + name + " " + args[0];
    }
    function log() {
      return stream2.write(util2.format.apply(util2, arguments) + `
`);
    }
    function save(namespaces) {
      namespaces == null ? delete process.env.DEBUG : process.env.DEBUG = namespaces;
    }
    function load() {
      return process.env.DEBUG;
    }
    function createWritableStdioStream(fd2) {
      var stream3, tty_wrap = process.binding("tty_wrap");
      switch (tty_wrap.guessHandleType(fd2)) {
        case "TTY":
          stream3 = new tty.WriteStream(fd2), stream3._type = "tty", stream3._handle && stream3._handle.unref && stream3._handle.unref();
          break;
        case "FILE":
          var fs6 = __require("fs");
          stream3 = new fs6.SyncWriteStream(fd2, { autoClose: !1 }), stream3._type = "fs";
          break;
        case "PIPE":
        case "TCP":
          var net = __require("net");
          stream3 = new net.Socket({
            fd: fd2,
            readable: !1,
            writable: !0
          }), stream3.readable = !1, stream3.read = null, stream3._type = "pipe", stream3._handle && stream3._handle.unref && stream3._handle.unref();
          break;
        default:
          throw new Error("Implement me. Unknown stream file type!");
      }
      return stream3.fd = fd2, stream3._isStdio = !0, stream3;
    }
    function init4(debug4) {
      debug4.inspectOpts = {};
      for (var keys = Object.keys(exports.inspectOpts), i = 0; i < keys.length; i++)
        debug4.inspectOpts[keys[i]] = exports.inspectOpts[keys[i]];
    }
    exports.enable(load());
  }
});

// ../../node_modules/.pnpm/debug@2.6.9/node_modules/debug/src/index.js
var require_src2 = __commonJS({
  "../../node_modules/.pnpm/debug@2.6.9/node_modules/debug/src/index.js"(exports, module) {
    init_cjs_shims();
    typeof process < "u" && process.type === "renderer" ? module.exports = require_browser() : module.exports = require_node6();
  }
});

// ../../node_modules/.pnpm/destroy@1.2.0/node_modules/destroy/index.js
var require_destroy3 = __commonJS({
  "../../node_modules/.pnpm/destroy@1.2.0/node_modules/destroy/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var EventEmitter3 = __require("events").EventEmitter, ReadStream = __require("fs").ReadStream, Stream = __require("stream"), Zlib = __require("zlib");
    module.exports = destroy;
    function destroy(stream2, suppress) {
      return isFsReadStream(stream2) ? destroyReadStream(stream2) : isZlibStream(stream2) ? destroyZlibStream(stream2) : hasDestroy(stream2) && stream2.destroy(), isEventEmitter(stream2) && suppress && (stream2.removeAllListeners("error"), stream2.addListener("error", noop)), stream2;
    }
    function destroyReadStream(stream2) {
      stream2.destroy(), typeof stream2.close == "function" && stream2.on("open", onOpenClose);
    }
    function closeZlibStream(stream2) {
      if (stream2._hadError === !0) {
        var prop = stream2._binding === null ? "_binding" : "_handle";
        stream2[prop] = {
          close: function() {
            this[prop] = null;
          }
        };
      }
      stream2.close();
    }
    function destroyZlibStream(stream2) {
      typeof stream2.destroy == "function" ? stream2._binding ? (stream2.destroy(), stream2._processing ? (stream2._needDrain = !0, stream2.once("drain", onDrainClearBinding)) : stream2._binding.clear()) : stream2._destroy && stream2._destroy !== Stream.Transform.prototype._destroy ? stream2.destroy() : stream2._destroy && typeof stream2.close == "function" ? (stream2.destroyed = !0, stream2.close()) : stream2.destroy() : typeof stream2.close == "function" && closeZlibStream(stream2);
    }
    function hasDestroy(stream2) {
      return stream2 instanceof Stream && typeof stream2.destroy == "function";
    }
    function isEventEmitter(val) {
      return val instanceof EventEmitter3;
    }
    function isFsReadStream(stream2) {
      return stream2 instanceof ReadStream;
    }
    function isZlibStream(stream2) {
      return stream2 instanceof Zlib.Gzip || stream2 instanceof Zlib.Gunzip || stream2 instanceof Zlib.Deflate || stream2 instanceof Zlib.DeflateRaw || stream2 instanceof Zlib.Inflate || stream2 instanceof Zlib.InflateRaw || stream2 instanceof Zlib.Unzip;
    }
    function noop() {
    }
    function onDrainClearBinding() {
      this._binding.clear();
    }
    function onOpenClose() {
      typeof this.fd == "number" && this.close();
    }
  }
});

// ../../node_modules/.pnpm/safer-buffer@2.1.2/node_modules/safer-buffer/safer.js
var require_safer = __commonJS({
  "../../node_modules/.pnpm/safer-buffer@2.1.2/node_modules/safer-buffer/safer.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var buffer = __require("buffer"), Buffer2 = buffer.Buffer, safer = {}, key;
    for (key in buffer)
      buffer.hasOwnProperty(key) && (key === "SlowBuffer" || key === "Buffer" || (safer[key] = buffer[key]));
    var Safer = safer.Buffer = {};
    for (key in Buffer2)
      Buffer2.hasOwnProperty(key) && (key === "allocUnsafe" || key === "allocUnsafeSlow" || (Safer[key] = Buffer2[key]));
    safer.Buffer.prototype = Buffer2.prototype;
    (!Safer.from || Safer.from === Uint8Array.from) && (Safer.from = function(value, encodingOrOffset, length) {
      if (typeof value == "number")
        throw new TypeError('The "value" argument must not be of type number. Received type ' + typeof value);
      if (value && typeof value.length > "u")
        throw new TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type " + typeof value);
      return Buffer2(value, encodingOrOffset, length);
    });
    Safer.alloc || (Safer.alloc = function(size, fill, encoding) {
      if (typeof size != "number")
        throw new TypeError('The "size" argument must be of type number. Received type ' + typeof size);
      if (size < 0 || size >= 2 * (1 << 30))
        throw new RangeError('The value "' + size + '" is invalid for option "size"');
      var buf = Buffer2(size);
      return !fill || fill.length === 0 ? buf.fill(0) : typeof encoding == "string" ? buf.fill(fill, encoding) : buf.fill(fill), buf;
    });
    if (!safer.kStringMaxLength)
      try {
        safer.kStringMaxLength = process.binding("buffer").kStringMaxLength;
      } catch {
      }
    safer.constants || (safer.constants = {
      MAX_LENGTH: safer.kMaxLength
    }, safer.kStringMaxLength && (safer.constants.MAX_STRING_LENGTH = safer.kStringMaxLength));
    module.exports = safer;
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/lib/bom-handling.js
var require_bom_handling = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/lib/bom-handling.js"(exports) {
    "use strict";
    init_cjs_shims();
    var BOMChar = "\uFEFF";
    exports.PrependBOM = PrependBOMWrapper;
    function PrependBOMWrapper(encoder, options) {
      this.encoder = encoder, this.addBOM = !0;
    }
    PrependBOMWrapper.prototype.write = function(str) {
      return this.addBOM && (str = BOMChar + str, this.addBOM = !1), this.encoder.write(str);
    };
    PrependBOMWrapper.prototype.end = function() {
      return this.encoder.end();
    };
    exports.StripBOM = StripBOMWrapper;
    function StripBOMWrapper(decoder, options) {
      this.decoder = decoder, this.pass = !1, this.options = options || {};
    }
    StripBOMWrapper.prototype.write = function(buf) {
      var res = this.decoder.write(buf);
      return this.pass || !res || (res[0] === BOMChar && (res = res.slice(1), typeof this.options.stripBOM == "function" && this.options.stripBOM()), this.pass = !0), res;
    };
    StripBOMWrapper.prototype.end = function() {
      return this.decoder.end();
    };
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/internal.js
var require_internal = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/internal.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Buffer2 = require_safer().Buffer;
    module.exports = {
      // Encodings
      utf8: { type: "_internal", bomAware: !0 },
      cesu8: { type: "_internal", bomAware: !0 },
      unicode11utf8: "utf8",
      ucs2: { type: "_internal", bomAware: !0 },
      utf16le: "ucs2",
      binary: { type: "_internal" },
      base64: { type: "_internal" },
      hex: { type: "_internal" },
      // Codec.
      _internal: InternalCodec
    };
    function InternalCodec(codecOptions, iconv) {
      this.enc = codecOptions.encodingName, this.bomAware = codecOptions.bomAware, this.enc === "base64" ? this.encoder = InternalEncoderBase64 : this.enc === "cesu8" && (this.enc = "utf8", this.encoder = InternalEncoderCesu8, Buffer2.from("eda0bdedb2a9", "hex").toString() !== "\u{1F4A9}" && (this.decoder = InternalDecoderCesu8, this.defaultCharUnicode = iconv.defaultCharUnicode));
    }
    InternalCodec.prototype.encoder = InternalEncoder;
    InternalCodec.prototype.decoder = InternalDecoder;
    var StringDecoder = __require("string_decoder").StringDecoder;
    StringDecoder.prototype.end || (StringDecoder.prototype.end = function() {
    });
    function InternalDecoder(options, codec) {
      StringDecoder.call(this, codec.enc);
    }
    InternalDecoder.prototype = StringDecoder.prototype;
    function InternalEncoder(options, codec) {
      this.enc = codec.enc;
    }
    InternalEncoder.prototype.write = function(str) {
      return Buffer2.from(str, this.enc);
    };
    InternalEncoder.prototype.end = function() {
    };
    function InternalEncoderBase64(options, codec) {
      this.prevStr = "";
    }
    InternalEncoderBase64.prototype.write = function(str) {
      str = this.prevStr + str;
      var completeQuads = str.length - str.length % 4;
      return this.prevStr = str.slice(completeQuads), str = str.slice(0, completeQuads), Buffer2.from(str, "base64");
    };
    InternalEncoderBase64.prototype.end = function() {
      return Buffer2.from(this.prevStr, "base64");
    };
    function InternalEncoderCesu8(options, codec) {
    }
    InternalEncoderCesu8.prototype.write = function(str) {
      for (var buf = Buffer2.alloc(str.length * 3), bufIdx = 0, i = 0; i < str.length; i++) {
        var charCode = str.charCodeAt(i);
        charCode < 128 ? buf[bufIdx++] = charCode : charCode < 2048 ? (buf[bufIdx++] = 192 + (charCode >>> 6), buf[bufIdx++] = 128 + (charCode & 63)) : (buf[bufIdx++] = 224 + (charCode >>> 12), buf[bufIdx++] = 128 + (charCode >>> 6 & 63), buf[bufIdx++] = 128 + (charCode & 63));
      }
      return buf.slice(0, bufIdx);
    };
    InternalEncoderCesu8.prototype.end = function() {
    };
    function InternalDecoderCesu8(options, codec) {
      this.acc = 0, this.contBytes = 0, this.accBytes = 0, this.defaultCharUnicode = codec.defaultCharUnicode;
    }
    InternalDecoderCesu8.prototype.write = function(buf) {
      for (var acc = this.acc, contBytes = this.contBytes, accBytes = this.accBytes, res = "", i = 0; i < buf.length; i++) {
        var curByte = buf[i];
        (curByte & 192) !== 128 ? (contBytes > 0 && (res += this.defaultCharUnicode, contBytes = 0), curByte < 128 ? res += String.fromCharCode(curByte) : curByte < 224 ? (acc = curByte & 31, contBytes = 1, accBytes = 1) : curByte < 240 ? (acc = curByte & 15, contBytes = 2, accBytes = 1) : res += this.defaultCharUnicode) : contBytes > 0 ? (acc = acc << 6 | curByte & 63, contBytes--, accBytes++, contBytes === 0 && (accBytes === 2 && acc < 128 && acc > 0 ? res += this.defaultCharUnicode : accBytes === 3 && acc < 2048 ? res += this.defaultCharUnicode : res += String.fromCharCode(acc))) : res += this.defaultCharUnicode;
      }
      return this.acc = acc, this.contBytes = contBytes, this.accBytes = accBytes, res;
    };
    InternalDecoderCesu8.prototype.end = function() {
      var res = 0;
      return this.contBytes > 0 && (res += this.defaultCharUnicode), res;
    };
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/utf16.js
var require_utf16 = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/utf16.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Buffer2 = require_safer().Buffer;
    exports.utf16be = Utf16BECodec;
    function Utf16BECodec() {
    }
    Utf16BECodec.prototype.encoder = Utf16BEEncoder;
    Utf16BECodec.prototype.decoder = Utf16BEDecoder;
    Utf16BECodec.prototype.bomAware = !0;
    function Utf16BEEncoder() {
    }
    Utf16BEEncoder.prototype.write = function(str) {
      for (var buf = Buffer2.from(str, "ucs2"), i = 0; i < buf.length; i += 2) {
        var tmp = buf[i];
        buf[i] = buf[i + 1], buf[i + 1] = tmp;
      }
      return buf;
    };
    Utf16BEEncoder.prototype.end = function() {
    };
    function Utf16BEDecoder() {
      this.overflowByte = -1;
    }
    Utf16BEDecoder.prototype.write = function(buf) {
      if (buf.length == 0)
        return "";
      var buf2 = Buffer2.alloc(buf.length + 1), i = 0, j = 0;
      for (this.overflowByte !== -1 && (buf2[0] = buf[0], buf2[1] = this.overflowByte, i = 1, j = 2); i < buf.length - 1; i += 2, j += 2)
        buf2[j] = buf[i + 1], buf2[j + 1] = buf[i];
      return this.overflowByte = i == buf.length - 1 ? buf[buf.length - 1] : -1, buf2.slice(0, j).toString("ucs2");
    };
    Utf16BEDecoder.prototype.end = function() {
    };
    exports.utf16 = Utf16Codec;
    function Utf16Codec(codecOptions, iconv) {
      this.iconv = iconv;
    }
    Utf16Codec.prototype.encoder = Utf16Encoder;
    Utf16Codec.prototype.decoder = Utf16Decoder;
    function Utf16Encoder(options, codec) {
      options = options || {}, options.addBOM === void 0 && (options.addBOM = !0), this.encoder = codec.iconv.getEncoder("utf-16le", options);
    }
    Utf16Encoder.prototype.write = function(str) {
      return this.encoder.write(str);
    };
    Utf16Encoder.prototype.end = function() {
      return this.encoder.end();
    };
    function Utf16Decoder(options, codec) {
      this.decoder = null, this.initialBytes = [], this.initialBytesLen = 0, this.options = options || {}, this.iconv = codec.iconv;
    }
    Utf16Decoder.prototype.write = function(buf) {
      if (!this.decoder) {
        if (this.initialBytes.push(buf), this.initialBytesLen += buf.length, this.initialBytesLen < 16)
          return "";
        var buf = Buffer2.concat(this.initialBytes), encoding = detectEncoding(buf, this.options.defaultEncoding);
        this.decoder = this.iconv.getDecoder(encoding, this.options), this.initialBytes.length = this.initialBytesLen = 0;
      }
      return this.decoder.write(buf);
    };
    Utf16Decoder.prototype.end = function() {
      if (!this.decoder) {
        var buf = Buffer2.concat(this.initialBytes), encoding = detectEncoding(buf, this.options.defaultEncoding);
        this.decoder = this.iconv.getDecoder(encoding, this.options);
        var res = this.decoder.write(buf), trail = this.decoder.end();
        return trail ? res + trail : res;
      }
      return this.decoder.end();
    };
    function detectEncoding(buf, defaultEncoding) {
      var enc = defaultEncoding || "utf-16le";
      if (buf.length >= 2)
        if (buf[0] == 254 && buf[1] == 255)
          enc = "utf-16be";
        else if (buf[0] == 255 && buf[1] == 254)
          enc = "utf-16le";
        else {
          for (var asciiCharsLE = 0, asciiCharsBE = 0, _len = Math.min(buf.length - buf.length % 2, 64), i = 0; i < _len; i += 2)
            buf[i] === 0 && buf[i + 1] !== 0 && asciiCharsBE++, buf[i] !== 0 && buf[i + 1] === 0 && asciiCharsLE++;
          asciiCharsBE > asciiCharsLE ? enc = "utf-16be" : asciiCharsBE < asciiCharsLE && (enc = "utf-16le");
        }
      return enc;
    }
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/utf7.js
var require_utf7 = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/utf7.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Buffer2 = require_safer().Buffer;
    exports.utf7 = Utf7Codec;
    exports.unicode11utf7 = "utf7";
    function Utf7Codec(codecOptions, iconv) {
      this.iconv = iconv;
    }
    Utf7Codec.prototype.encoder = Utf7Encoder;
    Utf7Codec.prototype.decoder = Utf7Decoder;
    Utf7Codec.prototype.bomAware = !0;
    var nonDirectChars = /[^A-Za-z0-9'\(\),-\.\/:\? \n\r\t]+/g;
    function Utf7Encoder(options, codec) {
      this.iconv = codec.iconv;
    }
    Utf7Encoder.prototype.write = function(str) {
      return Buffer2.from(str.replace(nonDirectChars, function(chunk) {
        return "+" + (chunk === "+" ? "" : this.iconv.encode(chunk, "utf16-be").toString("base64").replace(/=+$/, "")) + "-";
      }.bind(this)));
    };
    Utf7Encoder.prototype.end = function() {
    };
    function Utf7Decoder(options, codec) {
      this.iconv = codec.iconv, this.inBase64 = !1, this.base64Accum = "";
    }
    var base64Regex = /[A-Za-z0-9\/+]/, base64Chars = [];
    for (i = 0; i < 256; i++)
      base64Chars[i] = base64Regex.test(String.fromCharCode(i));
    var i, plusChar = 43, minusChar = 45, andChar = 38;
    Utf7Decoder.prototype.write = function(buf) {
      for (var res = "", lastI = 0, inBase64 = this.inBase64, base64Accum = this.base64Accum, i2 = 0; i2 < buf.length; i2++)
        if (!inBase64)
          buf[i2] == plusChar && (res += this.iconv.decode(buf.slice(lastI, i2), "ascii"), lastI = i2 + 1, inBase64 = !0);
        else if (!base64Chars[buf[i2]]) {
          if (i2 == lastI && buf[i2] == minusChar)
            res += "+";
          else {
            var b64str = base64Accum + buf.slice(lastI, i2).toString();
            res += this.iconv.decode(Buffer2.from(b64str, "base64"), "utf16-be");
          }
          buf[i2] != minusChar && i2--, lastI = i2 + 1, inBase64 = !1, base64Accum = "";
        }
      if (!inBase64)
        res += this.iconv.decode(buf.slice(lastI), "ascii");
      else {
        var b64str = base64Accum + buf.slice(lastI).toString(), canBeDecoded = b64str.length - b64str.length % 8;
        base64Accum = b64str.slice(canBeDecoded), b64str = b64str.slice(0, canBeDecoded), res += this.iconv.decode(Buffer2.from(b64str, "base64"), "utf16-be");
      }
      return this.inBase64 = inBase64, this.base64Accum = base64Accum, res;
    };
    Utf7Decoder.prototype.end = function() {
      var res = "";
      return this.inBase64 && this.base64Accum.length > 0 && (res = this.iconv.decode(Buffer2.from(this.base64Accum, "base64"), "utf16-be")), this.inBase64 = !1, this.base64Accum = "", res;
    };
    exports.utf7imap = Utf7IMAPCodec;
    function Utf7IMAPCodec(codecOptions, iconv) {
      this.iconv = iconv;
    }
    Utf7IMAPCodec.prototype.encoder = Utf7IMAPEncoder;
    Utf7IMAPCodec.prototype.decoder = Utf7IMAPDecoder;
    Utf7IMAPCodec.prototype.bomAware = !0;
    function Utf7IMAPEncoder(options, codec) {
      this.iconv = codec.iconv, this.inBase64 = !1, this.base64Accum = Buffer2.alloc(6), this.base64AccumIdx = 0;
    }
    Utf7IMAPEncoder.prototype.write = function(str) {
      for (var inBase64 = this.inBase64, base64Accum = this.base64Accum, base64AccumIdx = this.base64AccumIdx, buf = Buffer2.alloc(str.length * 5 + 10), bufIdx = 0, i2 = 0; i2 < str.length; i2++) {
        var uChar = str.charCodeAt(i2);
        32 <= uChar && uChar <= 126 ? (inBase64 && (base64AccumIdx > 0 && (bufIdx += buf.write(base64Accum.slice(0, base64AccumIdx).toString("base64").replace(/\//g, ",").replace(/=+$/, ""), bufIdx), base64AccumIdx = 0), buf[bufIdx++] = minusChar, inBase64 = !1), inBase64 || (buf[bufIdx++] = uChar, uChar === andChar && (buf[bufIdx++] = minusChar))) : (inBase64 || (buf[bufIdx++] = andChar, inBase64 = !0), inBase64 && (base64Accum[base64AccumIdx++] = uChar >> 8, base64Accum[base64AccumIdx++] = uChar & 255, base64AccumIdx == base64Accum.length && (bufIdx += buf.write(base64Accum.toString("base64").replace(/\//g, ","), bufIdx), base64AccumIdx = 0)));
      }
      return this.inBase64 = inBase64, this.base64AccumIdx = base64AccumIdx, buf.slice(0, bufIdx);
    };
    Utf7IMAPEncoder.prototype.end = function() {
      var buf = Buffer2.alloc(10), bufIdx = 0;
      return this.inBase64 && (this.base64AccumIdx > 0 && (bufIdx += buf.write(this.base64Accum.slice(0, this.base64AccumIdx).toString("base64").replace(/\//g, ",").replace(/=+$/, ""), bufIdx), this.base64AccumIdx = 0), buf[bufIdx++] = minusChar, this.inBase64 = !1), buf.slice(0, bufIdx);
    };
    function Utf7IMAPDecoder(options, codec) {
      this.iconv = codec.iconv, this.inBase64 = !1, this.base64Accum = "";
    }
    var base64IMAPChars = base64Chars.slice();
    base64IMAPChars[44] = !0;
    Utf7IMAPDecoder.prototype.write = function(buf) {
      for (var res = "", lastI = 0, inBase64 = this.inBase64, base64Accum = this.base64Accum, i2 = 0; i2 < buf.length; i2++)
        if (!inBase64)
          buf[i2] == andChar && (res += this.iconv.decode(buf.slice(lastI, i2), "ascii"), lastI = i2 + 1, inBase64 = !0);
        else if (!base64IMAPChars[buf[i2]]) {
          if (i2 == lastI && buf[i2] == minusChar)
            res += "&";
          else {
            var b64str = base64Accum + buf.slice(lastI, i2).toString().replace(/,/g, "/");
            res += this.iconv.decode(Buffer2.from(b64str, "base64"), "utf16-be");
          }
          buf[i2] != minusChar && i2--, lastI = i2 + 1, inBase64 = !1, base64Accum = "";
        }
      if (!inBase64)
        res += this.iconv.decode(buf.slice(lastI), "ascii");
      else {
        var b64str = base64Accum + buf.slice(lastI).toString().replace(/,/g, "/"), canBeDecoded = b64str.length - b64str.length % 8;
        base64Accum = b64str.slice(canBeDecoded), b64str = b64str.slice(0, canBeDecoded), res += this.iconv.decode(Buffer2.from(b64str, "base64"), "utf16-be");
      }
      return this.inBase64 = inBase64, this.base64Accum = base64Accum, res;
    };
    Utf7IMAPDecoder.prototype.end = function() {
      var res = "";
      return this.inBase64 && this.base64Accum.length > 0 && (res = this.iconv.decode(Buffer2.from(this.base64Accum, "base64"), "utf16-be")), this.inBase64 = !1, this.base64Accum = "", res;
    };
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/sbcs-codec.js
var require_sbcs_codec = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/sbcs-codec.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Buffer2 = require_safer().Buffer;
    exports._sbcs = SBCSCodec;
    function SBCSCodec(codecOptions, iconv) {
      if (!codecOptions)
        throw new Error("SBCS codec is called without the data.");
      if (!codecOptions.chars || codecOptions.chars.length !== 128 && codecOptions.chars.length !== 256)
        throw new Error("Encoding '" + codecOptions.type + "' has incorrect 'chars' (must be of len 128 or 256)");
      if (codecOptions.chars.length === 128) {
        for (var asciiString = "", i = 0; i < 128; i++)
          asciiString += String.fromCharCode(i);
        codecOptions.chars = asciiString + codecOptions.chars;
      }
      this.decodeBuf = Buffer2.from(codecOptions.chars, "ucs2");
      for (var encodeBuf = Buffer2.alloc(65536, iconv.defaultCharSingleByte.charCodeAt(0)), i = 0; i < codecOptions.chars.length; i++)
        encodeBuf[codecOptions.chars.charCodeAt(i)] = i;
      this.encodeBuf = encodeBuf;
    }
    SBCSCodec.prototype.encoder = SBCSEncoder;
    SBCSCodec.prototype.decoder = SBCSDecoder;
    function SBCSEncoder(options, codec) {
      this.encodeBuf = codec.encodeBuf;
    }
    SBCSEncoder.prototype.write = function(str) {
      for (var buf = Buffer2.alloc(str.length), i = 0; i < str.length; i++)
        buf[i] = this.encodeBuf[str.charCodeAt(i)];
      return buf;
    };
    SBCSEncoder.prototype.end = function() {
    };
    function SBCSDecoder(options, codec) {
      this.decodeBuf = codec.decodeBuf;
    }
    SBCSDecoder.prototype.write = function(buf) {
      for (var decodeBuf = this.decodeBuf, newBuf = Buffer2.alloc(buf.length * 2), idx1 = 0, idx2 = 0, i = 0; i < buf.length; i++)
        idx1 = buf[i] * 2, idx2 = i * 2, newBuf[idx2] = decodeBuf[idx1], newBuf[idx2 + 1] = decodeBuf[idx1 + 1];
      return newBuf.toString("ucs2");
    };
    SBCSDecoder.prototype.end = function() {
    };
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/sbcs-data.js
var require_sbcs_data = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/sbcs-data.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = {
      // Not supported by iconv, not sure why.
      10029: "maccenteuro",
      maccenteuro: {
        type: "_sbcs",
        chars: "\xC4\u0100\u0101\xC9\u0104\xD6\xDC\xE1\u0105\u010C\xE4\u010D\u0106\u0107\xE9\u0179\u017A\u010E\xED\u010F\u0112\u0113\u0116\xF3\u0117\xF4\xF6\xF5\xFA\u011A\u011B\xFC\u2020\xB0\u0118\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\u0119\xA8\u2260\u0123\u012E\u012F\u012A\u2264\u2265\u012B\u0136\u2202\u2211\u0142\u013B\u013C\u013D\u013E\u0139\u013A\u0145\u0146\u0143\xAC\u221A\u0144\u0147\u2206\xAB\xBB\u2026\xA0\u0148\u0150\xD5\u0151\u014C\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\u014D\u0154\u0155\u0158\u2039\u203A\u0159\u0156\u0157\u0160\u201A\u201E\u0161\u015A\u015B\xC1\u0164\u0165\xCD\u017D\u017E\u016A\xD3\xD4\u016B\u016E\xDA\u016F\u0170\u0171\u0172\u0173\xDD\xFD\u0137\u017B\u0141\u017C\u0122\u02C7"
      },
      808: "cp808",
      ibm808: "cp808",
      cp808: {
        type: "_sbcs",
        chars: "\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F\u0401\u0451\u0404\u0454\u0407\u0457\u040E\u045E\xB0\u2219\xB7\u221A\u2116\u20AC\u25A0\xA0"
      },
      mik: {
        type: "_sbcs",
        chars: "\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F\u2514\u2534\u252C\u251C\u2500\u253C\u2563\u2551\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2510\u2591\u2592\u2593\u2502\u2524\u2116\xA7\u2557\u255D\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u03B1\xDF\u0393\u03C0\u03A3\u03C3\xB5\u03C4\u03A6\u0398\u03A9\u03B4\u221E\u03C6\u03B5\u2229\u2261\xB1\u2265\u2264\u2320\u2321\xF7\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0"
      },
      // Aliases of generated encodings.
      ascii8bit: "ascii",
      usascii: "ascii",
      ansix34: "ascii",
      ansix341968: "ascii",
      ansix341986: "ascii",
      csascii: "ascii",
      cp367: "ascii",
      ibm367: "ascii",
      isoir6: "ascii",
      iso646us: "ascii",
      iso646irv: "ascii",
      us: "ascii",
      latin1: "iso88591",
      latin2: "iso88592",
      latin3: "iso88593",
      latin4: "iso88594",
      latin5: "iso88599",
      latin6: "iso885910",
      latin7: "iso885913",
      latin8: "iso885914",
      latin9: "iso885915",
      latin10: "iso885916",
      csisolatin1: "iso88591",
      csisolatin2: "iso88592",
      csisolatin3: "iso88593",
      csisolatin4: "iso88594",
      csisolatincyrillic: "iso88595",
      csisolatinarabic: "iso88596",
      csisolatingreek: "iso88597",
      csisolatinhebrew: "iso88598",
      csisolatin5: "iso88599",
      csisolatin6: "iso885910",
      l1: "iso88591",
      l2: "iso88592",
      l3: "iso88593",
      l4: "iso88594",
      l5: "iso88599",
      l6: "iso885910",
      l7: "iso885913",
      l8: "iso885914",
      l9: "iso885915",
      l10: "iso885916",
      isoir14: "iso646jp",
      isoir57: "iso646cn",
      isoir100: "iso88591",
      isoir101: "iso88592",
      isoir109: "iso88593",
      isoir110: "iso88594",
      isoir144: "iso88595",
      isoir127: "iso88596",
      isoir126: "iso88597",
      isoir138: "iso88598",
      isoir148: "iso88599",
      isoir157: "iso885910",
      isoir166: "tis620",
      isoir179: "iso885913",
      isoir199: "iso885914",
      isoir203: "iso885915",
      isoir226: "iso885916",
      cp819: "iso88591",
      ibm819: "iso88591",
      cyrillic: "iso88595",
      arabic: "iso88596",
      arabic8: "iso88596",
      ecma114: "iso88596",
      asmo708: "iso88596",
      greek: "iso88597",
      greek8: "iso88597",
      ecma118: "iso88597",
      elot928: "iso88597",
      hebrew: "iso88598",
      hebrew8: "iso88598",
      turkish: "iso88599",
      turkish8: "iso88599",
      thai: "iso885911",
      thai8: "iso885911",
      celtic: "iso885914",
      celtic8: "iso885914",
      isoceltic: "iso885914",
      tis6200: "tis620",
      tis62025291: "tis620",
      tis62025330: "tis620",
      1e4: "macroman",
      10006: "macgreek",
      10007: "maccyrillic",
      10079: "maciceland",
      10081: "macturkish",
      cspc8codepage437: "cp437",
      cspc775baltic: "cp775",
      cspc850multilingual: "cp850",
      cspcp852: "cp852",
      cspc862latinhebrew: "cp862",
      cpgr: "cp869",
      msee: "cp1250",
      mscyrl: "cp1251",
      msansi: "cp1252",
      msgreek: "cp1253",
      msturk: "cp1254",
      mshebr: "cp1255",
      msarab: "cp1256",
      winbaltrim: "cp1257",
      cp20866: "koi8r",
      20866: "koi8r",
      ibm878: "koi8r",
      cskoi8r: "koi8r",
      cp21866: "koi8u",
      21866: "koi8u",
      ibm1168: "koi8u",
      strk10482002: "rk1048",
      tcvn5712: "tcvn",
      tcvn57121: "tcvn",
      gb198880: "iso646cn",
      cn: "iso646cn",
      csiso14jisc6220ro: "iso646jp",
      jisc62201969ro: "iso646jp",
      jp: "iso646jp",
      cshproman8: "hproman8",
      r8: "hproman8",
      roman8: "hproman8",
      xroman8: "hproman8",
      ibm1051: "hproman8",
      mac: "macintosh",
      csmacintosh: "macintosh"
    };
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/sbcs-data-generated.js
var require_sbcs_data_generated = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/sbcs-data-generated.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = {
      437: "cp437",
      737: "cp737",
      775: "cp775",
      850: "cp850",
      852: "cp852",
      855: "cp855",
      856: "cp856",
      857: "cp857",
      858: "cp858",
      860: "cp860",
      861: "cp861",
      862: "cp862",
      863: "cp863",
      864: "cp864",
      865: "cp865",
      866: "cp866",
      869: "cp869",
      874: "windows874",
      922: "cp922",
      1046: "cp1046",
      1124: "cp1124",
      1125: "cp1125",
      1129: "cp1129",
      1133: "cp1133",
      1161: "cp1161",
      1162: "cp1162",
      1163: "cp1163",
      1250: "windows1250",
      1251: "windows1251",
      1252: "windows1252",
      1253: "windows1253",
      1254: "windows1254",
      1255: "windows1255",
      1256: "windows1256",
      1257: "windows1257",
      1258: "windows1258",
      28591: "iso88591",
      28592: "iso88592",
      28593: "iso88593",
      28594: "iso88594",
      28595: "iso88595",
      28596: "iso88596",
      28597: "iso88597",
      28598: "iso88598",
      28599: "iso88599",
      28600: "iso885910",
      28601: "iso885911",
      28603: "iso885913",
      28604: "iso885914",
      28605: "iso885915",
      28606: "iso885916",
      windows874: {
        type: "_sbcs",
        chars: "\u20AC\uFFFD\uFFFD\uFFFD\uFFFD\u2026\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u2018\u2019\u201C\u201D\u2022\u2013\u2014\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\xA0\u0E01\u0E02\u0E03\u0E04\u0E05\u0E06\u0E07\u0E08\u0E09\u0E0A\u0E0B\u0E0C\u0E0D\u0E0E\u0E0F\u0E10\u0E11\u0E12\u0E13\u0E14\u0E15\u0E16\u0E17\u0E18\u0E19\u0E1A\u0E1B\u0E1C\u0E1D\u0E1E\u0E1F\u0E20\u0E21\u0E22\u0E23\u0E24\u0E25\u0E26\u0E27\u0E28\u0E29\u0E2A\u0E2B\u0E2C\u0E2D\u0E2E\u0E2F\u0E30\u0E31\u0E32\u0E33\u0E34\u0E35\u0E36\u0E37\u0E38\u0E39\u0E3A\uFFFD\uFFFD\uFFFD\uFFFD\u0E3F\u0E40\u0E41\u0E42\u0E43\u0E44\u0E45\u0E46\u0E47\u0E48\u0E49\u0E4A\u0E4B\u0E4C\u0E4D\u0E4E\u0E4F\u0E50\u0E51\u0E52\u0E53\u0E54\u0E55\u0E56\u0E57\u0E58\u0E59\u0E5A\u0E5B\uFFFD\uFFFD\uFFFD\uFFFD"
      },
      win874: "windows874",
      cp874: "windows874",
      windows1250: {
        type: "_sbcs",
        chars: "\u20AC\uFFFD\u201A\uFFFD\u201E\u2026\u2020\u2021\uFFFD\u2030\u0160\u2039\u015A\u0164\u017D\u0179\uFFFD\u2018\u2019\u201C\u201D\u2022\u2013\u2014\uFFFD\u2122\u0161\u203A\u015B\u0165\u017E\u017A\xA0\u02C7\u02D8\u0141\xA4\u0104\xA6\xA7\xA8\xA9\u015E\xAB\xAC\xAD\xAE\u017B\xB0\xB1\u02DB\u0142\xB4\xB5\xB6\xB7\xB8\u0105\u015F\xBB\u013D\u02DD\u013E\u017C\u0154\xC1\xC2\u0102\xC4\u0139\u0106\xC7\u010C\xC9\u0118\xCB\u011A\xCD\xCE\u010E\u0110\u0143\u0147\xD3\xD4\u0150\xD6\xD7\u0158\u016E\xDA\u0170\xDC\xDD\u0162\xDF\u0155\xE1\xE2\u0103\xE4\u013A\u0107\xE7\u010D\xE9\u0119\xEB\u011B\xED\xEE\u010F\u0111\u0144\u0148\xF3\xF4\u0151\xF6\xF7\u0159\u016F\xFA\u0171\xFC\xFD\u0163\u02D9"
      },
      win1250: "windows1250",
      cp1250: "windows1250",
      windows1251: {
        type: "_sbcs",
        chars: "\u0402\u0403\u201A\u0453\u201E\u2026\u2020\u2021\u20AC\u2030\u0409\u2039\u040A\u040C\u040B\u040F\u0452\u2018\u2019\u201C\u201D\u2022\u2013\u2014\uFFFD\u2122\u0459\u203A\u045A\u045C\u045B\u045F\xA0\u040E\u045E\u0408\xA4\u0490\xA6\xA7\u0401\xA9\u0404\xAB\xAC\xAD\xAE\u0407\xB0\xB1\u0406\u0456\u0491\xB5\xB6\xB7\u0451\u2116\u0454\xBB\u0458\u0405\u0455\u0457\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F"
      },
      win1251: "windows1251",
      cp1251: "windows1251",
      windows1252: {
        type: "_sbcs",
        chars: "\u20AC\uFFFD\u201A\u0192\u201E\u2026\u2020\u2021\u02C6\u2030\u0160\u2039\u0152\uFFFD\u017D\uFFFD\uFFFD\u2018\u2019\u201C\u201D\u2022\u2013\u2014\u02DC\u2122\u0161\u203A\u0153\uFFFD\u017E\u0178\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\xD0\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\xDD\xDE\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF"
      },
      win1252: "windows1252",
      cp1252: "windows1252",
      windows1253: {
        type: "_sbcs",
        chars: "\u20AC\uFFFD\u201A\u0192\u201E\u2026\u2020\u2021\uFFFD\u2030\uFFFD\u2039\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u2018\u2019\u201C\u201D\u2022\u2013\u2014\uFFFD\u2122\uFFFD\u203A\uFFFD\uFFFD\uFFFD\uFFFD\xA0\u0385\u0386\xA3\xA4\xA5\xA6\xA7\xA8\xA9\uFFFD\xAB\xAC\xAD\xAE\u2015\xB0\xB1\xB2\xB3\u0384\xB5\xB6\xB7\u0388\u0389\u038A\xBB\u038C\xBD\u038E\u038F\u0390\u0391\u0392\u0393\u0394\u0395\u0396\u0397\u0398\u0399\u039A\u039B\u039C\u039D\u039E\u039F\u03A0\u03A1\uFFFD\u03A3\u03A4\u03A5\u03A6\u03A7\u03A8\u03A9\u03AA\u03AB\u03AC\u03AD\u03AE\u03AF\u03B0\u03B1\u03B2\u03B3\u03B4\u03B5\u03B6\u03B7\u03B8\u03B9\u03BA\u03BB\u03BC\u03BD\u03BE\u03BF\u03C0\u03C1\u03C2\u03C3\u03C4\u03C5\u03C6\u03C7\u03C8\u03C9\u03CA\u03CB\u03CC\u03CD\u03CE\uFFFD"
      },
      win1253: "windows1253",
      cp1253: "windows1253",
      windows1254: {
        type: "_sbcs",
        chars: "\u20AC\uFFFD\u201A\u0192\u201E\u2026\u2020\u2021\u02C6\u2030\u0160\u2039\u0152\uFFFD\uFFFD\uFFFD\uFFFD\u2018\u2019\u201C\u201D\u2022\u2013\u2014\u02DC\u2122\u0161\u203A\u0153\uFFFD\uFFFD\u0178\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\u011E\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\u0130\u015E\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\u011F\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\u0131\u015F\xFF"
      },
      win1254: "windows1254",
      cp1254: "windows1254",
      windows1255: {
        type: "_sbcs",
        chars: "\u20AC\uFFFD\u201A\u0192\u201E\u2026\u2020\u2021\u02C6\u2030\uFFFD\u2039\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u2018\u2019\u201C\u201D\u2022\u2013\u2014\u02DC\u2122\uFFFD\u203A\uFFFD\uFFFD\uFFFD\uFFFD\xA0\xA1\xA2\xA3\u20AA\xA5\xA6\xA7\xA8\xA9\xD7\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xF7\xBB\xBC\xBD\xBE\xBF\u05B0\u05B1\u05B2\u05B3\u05B4\u05B5\u05B6\u05B7\u05B8\u05B9\u05BA\u05BB\u05BC\u05BD\u05BE\u05BF\u05C0\u05C1\u05C2\u05C3\u05F0\u05F1\u05F2\u05F3\u05F4\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u05D0\u05D1\u05D2\u05D3\u05D4\u05D5\u05D6\u05D7\u05D8\u05D9\u05DA\u05DB\u05DC\u05DD\u05DE\u05DF\u05E0\u05E1\u05E2\u05E3\u05E4\u05E5\u05E6\u05E7\u05E8\u05E9\u05EA\uFFFD\uFFFD\u200E\u200F\uFFFD"
      },
      win1255: "windows1255",
      cp1255: "windows1255",
      windows1256: {
        type: "_sbcs",
        chars: "\u20AC\u067E\u201A\u0192\u201E\u2026\u2020\u2021\u02C6\u2030\u0679\u2039\u0152\u0686\u0698\u0688\u06AF\u2018\u2019\u201C\u201D\u2022\u2013\u2014\u06A9\u2122\u0691\u203A\u0153\u200C\u200D\u06BA\xA0\u060C\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\u06BE\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\u061B\xBB\xBC\xBD\xBE\u061F\u06C1\u0621\u0622\u0623\u0624\u0625\u0626\u0627\u0628\u0629\u062A\u062B\u062C\u062D\u062E\u062F\u0630\u0631\u0632\u0633\u0634\u0635\u0636\xD7\u0637\u0638\u0639\u063A\u0640\u0641\u0642\u0643\xE0\u0644\xE2\u0645\u0646\u0647\u0648\xE7\xE8\xE9\xEA\xEB\u0649\u064A\xEE\xEF\u064B\u064C\u064D\u064E\xF4\u064F\u0650\xF7\u0651\xF9\u0652\xFB\xFC\u200E\u200F\u06D2"
      },
      win1256: "windows1256",
      cp1256: "windows1256",
      windows1257: {
        type: "_sbcs",
        chars: "\u20AC\uFFFD\u201A\uFFFD\u201E\u2026\u2020\u2021\uFFFD\u2030\uFFFD\u2039\uFFFD\xA8\u02C7\xB8\uFFFD\u2018\u2019\u201C\u201D\u2022\u2013\u2014\uFFFD\u2122\uFFFD\u203A\uFFFD\xAF\u02DB\uFFFD\xA0\uFFFD\xA2\xA3\xA4\uFFFD\xA6\xA7\xD8\xA9\u0156\xAB\xAC\xAD\xAE\xC6\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xF8\xB9\u0157\xBB\xBC\xBD\xBE\xE6\u0104\u012E\u0100\u0106\xC4\xC5\u0118\u0112\u010C\xC9\u0179\u0116\u0122\u0136\u012A\u013B\u0160\u0143\u0145\xD3\u014C\xD5\xD6\xD7\u0172\u0141\u015A\u016A\xDC\u017B\u017D\xDF\u0105\u012F\u0101\u0107\xE4\xE5\u0119\u0113\u010D\xE9\u017A\u0117\u0123\u0137\u012B\u013C\u0161\u0144\u0146\xF3\u014D\xF5\xF6\xF7\u0173\u0142\u015B\u016B\xFC\u017C\u017E\u02D9"
      },
      win1257: "windows1257",
      cp1257: "windows1257",
      windows1258: {
        type: "_sbcs",
        chars: "\u20AC\uFFFD\u201A\u0192\u201E\u2026\u2020\u2021\u02C6\u2030\uFFFD\u2039\u0152\uFFFD\uFFFD\uFFFD\uFFFD\u2018\u2019\u201C\u201D\u2022\u2013\u2014\u02DC\u2122\uFFFD\u203A\u0153\uFFFD\uFFFD\u0178\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\u0102\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\u0300\xCD\xCE\xCF\u0110\xD1\u0309\xD3\xD4\u01A0\xD6\xD7\xD8\xD9\xDA\xDB\xDC\u01AF\u0303\xDF\xE0\xE1\xE2\u0103\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\u0301\xED\xEE\xEF\u0111\xF1\u0323\xF3\xF4\u01A1\xF6\xF7\xF8\xF9\xFA\xFB\xFC\u01B0\u20AB\xFF"
      },
      win1258: "windows1258",
      cp1258: "windows1258",
      iso88591: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\xD0\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\xDD\xDE\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF"
      },
      cp28591: "iso88591",
      iso88592: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0104\u02D8\u0141\xA4\u013D\u015A\xA7\xA8\u0160\u015E\u0164\u0179\xAD\u017D\u017B\xB0\u0105\u02DB\u0142\xB4\u013E\u015B\u02C7\xB8\u0161\u015F\u0165\u017A\u02DD\u017E\u017C\u0154\xC1\xC2\u0102\xC4\u0139\u0106\xC7\u010C\xC9\u0118\xCB\u011A\xCD\xCE\u010E\u0110\u0143\u0147\xD3\xD4\u0150\xD6\xD7\u0158\u016E\xDA\u0170\xDC\xDD\u0162\xDF\u0155\xE1\xE2\u0103\xE4\u013A\u0107\xE7\u010D\xE9\u0119\xEB\u011B\xED\xEE\u010F\u0111\u0144\u0148\xF3\xF4\u0151\xF6\xF7\u0159\u016F\xFA\u0171\xFC\xFD\u0163\u02D9"
      },
      cp28592: "iso88592",
      iso88593: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0126\u02D8\xA3\xA4\uFFFD\u0124\xA7\xA8\u0130\u015E\u011E\u0134\xAD\uFFFD\u017B\xB0\u0127\xB2\xB3\xB4\xB5\u0125\xB7\xB8\u0131\u015F\u011F\u0135\xBD\uFFFD\u017C\xC0\xC1\xC2\uFFFD\xC4\u010A\u0108\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\uFFFD\xD1\xD2\xD3\xD4\u0120\xD6\xD7\u011C\xD9\xDA\xDB\xDC\u016C\u015C\xDF\xE0\xE1\xE2\uFFFD\xE4\u010B\u0109\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\uFFFD\xF1\xF2\xF3\xF4\u0121\xF6\xF7\u011D\xF9\xFA\xFB\xFC\u016D\u015D\u02D9"
      },
      cp28593: "iso88593",
      iso88594: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0104\u0138\u0156\xA4\u0128\u013B\xA7\xA8\u0160\u0112\u0122\u0166\xAD\u017D\xAF\xB0\u0105\u02DB\u0157\xB4\u0129\u013C\u02C7\xB8\u0161\u0113\u0123\u0167\u014A\u017E\u014B\u0100\xC1\xC2\xC3\xC4\xC5\xC6\u012E\u010C\xC9\u0118\xCB\u0116\xCD\xCE\u012A\u0110\u0145\u014C\u0136\xD4\xD5\xD6\xD7\xD8\u0172\xDA\xDB\xDC\u0168\u016A\xDF\u0101\xE1\xE2\xE3\xE4\xE5\xE6\u012F\u010D\xE9\u0119\xEB\u0117\xED\xEE\u012B\u0111\u0146\u014D\u0137\xF4\xF5\xF6\xF7\xF8\u0173\xFA\xFB\xFC\u0169\u016B\u02D9"
      },
      cp28594: "iso88594",
      iso88595: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0401\u0402\u0403\u0404\u0405\u0406\u0407\u0408\u0409\u040A\u040B\u040C\xAD\u040E\u040F\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F\u2116\u0451\u0452\u0453\u0454\u0455\u0456\u0457\u0458\u0459\u045A\u045B\u045C\xA7\u045E\u045F"
      },
      cp28595: "iso88595",
      iso88596: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\uFFFD\uFFFD\uFFFD\xA4\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u060C\xAD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u061B\uFFFD\uFFFD\uFFFD\u061F\uFFFD\u0621\u0622\u0623\u0624\u0625\u0626\u0627\u0628\u0629\u062A\u062B\u062C\u062D\u062E\u062F\u0630\u0631\u0632\u0633\u0634\u0635\u0636\u0637\u0638\u0639\u063A\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u0640\u0641\u0642\u0643\u0644\u0645\u0646\u0647\u0648\u0649\u064A\u064B\u064C\u064D\u064E\u064F\u0650\u0651\u0652\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"
      },
      cp28596: "iso88596",
      iso88597: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u2018\u2019\xA3\u20AC\u20AF\xA6\xA7\xA8\xA9\u037A\xAB\xAC\xAD\uFFFD\u2015\xB0\xB1\xB2\xB3\u0384\u0385\u0386\xB7\u0388\u0389\u038A\xBB\u038C\xBD\u038E\u038F\u0390\u0391\u0392\u0393\u0394\u0395\u0396\u0397\u0398\u0399\u039A\u039B\u039C\u039D\u039E\u039F\u03A0\u03A1\uFFFD\u03A3\u03A4\u03A5\u03A6\u03A7\u03A8\u03A9\u03AA\u03AB\u03AC\u03AD\u03AE\u03AF\u03B0\u03B1\u03B2\u03B3\u03B4\u03B5\u03B6\u03B7\u03B8\u03B9\u03BA\u03BB\u03BC\u03BD\u03BE\u03BF\u03C0\u03C1\u03C2\u03C3\u03C4\u03C5\u03C6\u03C7\u03C8\u03C9\u03CA\u03CB\u03CC\u03CD\u03CE\uFFFD"
      },
      cp28597: "iso88597",
      iso88598: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\uFFFD\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xD7\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xF7\xBB\xBC\xBD\xBE\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u2017\u05D0\u05D1\u05D2\u05D3\u05D4\u05D5\u05D6\u05D7\u05D8\u05D9\u05DA\u05DB\u05DC\u05DD\u05DE\u05DF\u05E0\u05E1\u05E2\u05E3\u05E4\u05E5\u05E6\u05E7\u05E8\u05E9\u05EA\uFFFD\uFFFD\u200E\u200F\uFFFD"
      },
      cp28598: "iso88598",
      iso88599: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\u011E\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\u0130\u015E\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\u011F\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\u0131\u015F\xFF"
      },
      cp28599: "iso88599",
      iso885910: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0104\u0112\u0122\u012A\u0128\u0136\xA7\u013B\u0110\u0160\u0166\u017D\xAD\u016A\u014A\xB0\u0105\u0113\u0123\u012B\u0129\u0137\xB7\u013C\u0111\u0161\u0167\u017E\u2015\u016B\u014B\u0100\xC1\xC2\xC3\xC4\xC5\xC6\u012E\u010C\xC9\u0118\xCB\u0116\xCD\xCE\xCF\xD0\u0145\u014C\xD3\xD4\xD5\xD6\u0168\xD8\u0172\xDA\xDB\xDC\xDD\xDE\xDF\u0101\xE1\xE2\xE3\xE4\xE5\xE6\u012F\u010D\xE9\u0119\xEB\u0117\xED\xEE\xEF\xF0\u0146\u014D\xF3\xF4\xF5\xF6\u0169\xF8\u0173\xFA\xFB\xFC\xFD\xFE\u0138"
      },
      cp28600: "iso885910",
      iso885911: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0E01\u0E02\u0E03\u0E04\u0E05\u0E06\u0E07\u0E08\u0E09\u0E0A\u0E0B\u0E0C\u0E0D\u0E0E\u0E0F\u0E10\u0E11\u0E12\u0E13\u0E14\u0E15\u0E16\u0E17\u0E18\u0E19\u0E1A\u0E1B\u0E1C\u0E1D\u0E1E\u0E1F\u0E20\u0E21\u0E22\u0E23\u0E24\u0E25\u0E26\u0E27\u0E28\u0E29\u0E2A\u0E2B\u0E2C\u0E2D\u0E2E\u0E2F\u0E30\u0E31\u0E32\u0E33\u0E34\u0E35\u0E36\u0E37\u0E38\u0E39\u0E3A\uFFFD\uFFFD\uFFFD\uFFFD\u0E3F\u0E40\u0E41\u0E42\u0E43\u0E44\u0E45\u0E46\u0E47\u0E48\u0E49\u0E4A\u0E4B\u0E4C\u0E4D\u0E4E\u0E4F\u0E50\u0E51\u0E52\u0E53\u0E54\u0E55\u0E56\u0E57\u0E58\u0E59\u0E5A\u0E5B\uFFFD\uFFFD\uFFFD\uFFFD"
      },
      cp28601: "iso885911",
      iso885913: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u201D\xA2\xA3\xA4\u201E\xA6\xA7\xD8\xA9\u0156\xAB\xAC\xAD\xAE\xC6\xB0\xB1\xB2\xB3\u201C\xB5\xB6\xB7\xF8\xB9\u0157\xBB\xBC\xBD\xBE\xE6\u0104\u012E\u0100\u0106\xC4\xC5\u0118\u0112\u010C\xC9\u0179\u0116\u0122\u0136\u012A\u013B\u0160\u0143\u0145\xD3\u014C\xD5\xD6\xD7\u0172\u0141\u015A\u016A\xDC\u017B\u017D\xDF\u0105\u012F\u0101\u0107\xE4\xE5\u0119\u0113\u010D\xE9\u017A\u0117\u0123\u0137\u012B\u013C\u0161\u0144\u0146\xF3\u014D\xF5\xF6\xF7\u0173\u0142\u015B\u016B\xFC\u017C\u017E\u2019"
      },
      cp28603: "iso885913",
      iso885914: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u1E02\u1E03\xA3\u010A\u010B\u1E0A\xA7\u1E80\xA9\u1E82\u1E0B\u1EF2\xAD\xAE\u0178\u1E1E\u1E1F\u0120\u0121\u1E40\u1E41\xB6\u1E56\u1E81\u1E57\u1E83\u1E60\u1EF3\u1E84\u1E85\u1E61\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\u0174\xD1\xD2\xD3\xD4\xD5\xD6\u1E6A\xD8\xD9\xDA\xDB\xDC\xDD\u0176\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\u0175\xF1\xF2\xF3\xF4\xF5\xF6\u1E6B\xF8\xF9\xFA\xFB\xFC\xFD\u0177\xFF"
      },
      cp28604: "iso885914",
      iso885915: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\xA1\xA2\xA3\u20AC\xA5\u0160\xA7\u0161\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\u017D\xB5\xB6\xB7\u017E\xB9\xBA\xBB\u0152\u0153\u0178\xBF\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\xD0\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\xDD\xDE\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF"
      },
      cp28605: "iso885915",
      iso885916: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0104\u0105\u0141\u20AC\u201E\u0160\xA7\u0161\xA9\u0218\xAB\u0179\xAD\u017A\u017B\xB0\xB1\u010C\u0142\u017D\u201D\xB6\xB7\u017E\u010D\u0219\xBB\u0152\u0153\u0178\u017C\xC0\xC1\xC2\u0102\xC4\u0106\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\u0110\u0143\xD2\xD3\xD4\u0150\xD6\u015A\u0170\xD9\xDA\xDB\xDC\u0118\u021A\xDF\xE0\xE1\xE2\u0103\xE4\u0107\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\u0111\u0144\xF2\xF3\xF4\u0151\xF6\u015B\u0171\xF9\xFA\xFB\xFC\u0119\u021B\xFF"
      },
      cp28606: "iso885916",
      cp437: {
        type: "_sbcs",
        chars: "\xC7\xFC\xE9\xE2\xE4\xE0\xE5\xE7\xEA\xEB\xE8\xEF\xEE\xEC\xC4\xC5\xC9\xE6\xC6\xF4\xF6\xF2\xFB\xF9\xFF\xD6\xDC\xA2\xA3\xA5\u20A7\u0192\xE1\xED\xF3\xFA\xF1\xD1\xAA\xBA\xBF\u2310\xAC\xBD\xBC\xA1\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u03B1\xDF\u0393\u03C0\u03A3\u03C3\xB5\u03C4\u03A6\u0398\u03A9\u03B4\u221E\u03C6\u03B5\u2229\u2261\xB1\u2265\u2264\u2320\u2321\xF7\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0"
      },
      ibm437: "cp437",
      csibm437: "cp437",
      cp737: {
        type: "_sbcs",
        chars: "\u0391\u0392\u0393\u0394\u0395\u0396\u0397\u0398\u0399\u039A\u039B\u039C\u039D\u039E\u039F\u03A0\u03A1\u03A3\u03A4\u03A5\u03A6\u03A7\u03A8\u03A9\u03B1\u03B2\u03B3\u03B4\u03B5\u03B6\u03B7\u03B8\u03B9\u03BA\u03BB\u03BC\u03BD\u03BE\u03BF\u03C0\u03C1\u03C3\u03C2\u03C4\u03C5\u03C6\u03C7\u03C8\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u03C9\u03AC\u03AD\u03AE\u03CA\u03AF\u03CC\u03CD\u03CB\u03CE\u0386\u0388\u0389\u038A\u038C\u038E\u038F\xB1\u2265\u2264\u03AA\u03AB\xF7\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0"
      },
      ibm737: "cp737",
      csibm737: "cp737",
      cp775: {
        type: "_sbcs",
        chars: "\u0106\xFC\xE9\u0101\xE4\u0123\xE5\u0107\u0142\u0113\u0156\u0157\u012B\u0179\xC4\xC5\xC9\xE6\xC6\u014D\xF6\u0122\xA2\u015A\u015B\xD6\xDC\xF8\xA3\xD8\xD7\xA4\u0100\u012A\xF3\u017B\u017C\u017A\u201D\xA6\xA9\xAE\xAC\xBD\xBC\u0141\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u0104\u010C\u0118\u0116\u2563\u2551\u2557\u255D\u012E\u0160\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u0172\u016A\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u017D\u0105\u010D\u0119\u0117\u012F\u0161\u0173\u016B\u017E\u2518\u250C\u2588\u2584\u258C\u2590\u2580\xD3\xDF\u014C\u0143\xF5\xD5\xB5\u0144\u0136\u0137\u013B\u013C\u0146\u0112\u0145\u2019\xAD\xB1\u201C\xBE\xB6\xA7\xF7\u201E\xB0\u2219\xB7\xB9\xB3\xB2\u25A0\xA0"
      },
      ibm775: "cp775",
      csibm775: "cp775",
      cp850: {
        type: "_sbcs",
        chars: "\xC7\xFC\xE9\xE2\xE4\xE0\xE5\xE7\xEA\xEB\xE8\xEF\xEE\xEC\xC4\xC5\xC9\xE6\xC6\xF4\xF6\xF2\xFB\xF9\xFF\xD6\xDC\xF8\xA3\xD8\xD7\u0192\xE1\xED\xF3\xFA\xF1\xD1\xAA\xBA\xBF\xAE\xAC\xBD\xBC\xA1\xAB\xBB\u2591\u2592\u2593\u2502\u2524\xC1\xC2\xC0\xA9\u2563\u2551\u2557\u255D\xA2\xA5\u2510\u2514\u2534\u252C\u251C\u2500\u253C\xE3\xC3\u255A\u2554\u2569\u2566\u2560\u2550\u256C\xA4\xF0\xD0\xCA\xCB\xC8\u0131\xCD\xCE\xCF\u2518\u250C\u2588\u2584\xA6\xCC\u2580\xD3\xDF\xD4\xD2\xF5\xD5\xB5\xFE\xDE\xDA\xDB\xD9\xFD\xDD\xAF\xB4\xAD\xB1\u2017\xBE\xB6\xA7\xF7\xB8\xB0\xA8\xB7\xB9\xB3\xB2\u25A0\xA0"
      },
      ibm850: "cp850",
      csibm850: "cp850",
      cp852: {
        type: "_sbcs",
        chars: "\xC7\xFC\xE9\xE2\xE4\u016F\u0107\xE7\u0142\xEB\u0150\u0151\xEE\u0179\xC4\u0106\xC9\u0139\u013A\xF4\xF6\u013D\u013E\u015A\u015B\xD6\xDC\u0164\u0165\u0141\xD7\u010D\xE1\xED\xF3\xFA\u0104\u0105\u017D\u017E\u0118\u0119\xAC\u017A\u010C\u015F\xAB\xBB\u2591\u2592\u2593\u2502\u2524\xC1\xC2\u011A\u015E\u2563\u2551\u2557\u255D\u017B\u017C\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u0102\u0103\u255A\u2554\u2569\u2566\u2560\u2550\u256C\xA4\u0111\u0110\u010E\xCB\u010F\u0147\xCD\xCE\u011B\u2518\u250C\u2588\u2584\u0162\u016E\u2580\xD3\xDF\xD4\u0143\u0144\u0148\u0160\u0161\u0154\xDA\u0155\u0170\xFD\xDD\u0163\xB4\xAD\u02DD\u02DB\u02C7\u02D8\xA7\xF7\xB8\xB0\xA8\u02D9\u0171\u0158\u0159\u25A0\xA0"
      },
      ibm852: "cp852",
      csibm852: "cp852",
      cp855: {
        type: "_sbcs",
        chars: "\u0452\u0402\u0453\u0403\u0451\u0401\u0454\u0404\u0455\u0405\u0456\u0406\u0457\u0407\u0458\u0408\u0459\u0409\u045A\u040A\u045B\u040B\u045C\u040C\u045E\u040E\u045F\u040F\u044E\u042E\u044A\u042A\u0430\u0410\u0431\u0411\u0446\u0426\u0434\u0414\u0435\u0415\u0444\u0424\u0433\u0413\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u0445\u0425\u0438\u0418\u2563\u2551\u2557\u255D\u0439\u0419\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u043A\u041A\u255A\u2554\u2569\u2566\u2560\u2550\u256C\xA4\u043B\u041B\u043C\u041C\u043D\u041D\u043E\u041E\u043F\u2518\u250C\u2588\u2584\u041F\u044F\u2580\u042F\u0440\u0420\u0441\u0421\u0442\u0422\u0443\u0423\u0436\u0416\u0432\u0412\u044C\u042C\u2116\xAD\u044B\u042B\u0437\u0417\u0448\u0428\u044D\u042D\u0449\u0429\u0447\u0427\xA7\u25A0\xA0"
      },
      ibm855: "cp855",
      csibm855: "cp855",
      cp856: {
        type: "_sbcs",
        chars: "\u05D0\u05D1\u05D2\u05D3\u05D4\u05D5\u05D6\u05D7\u05D8\u05D9\u05DA\u05DB\u05DC\u05DD\u05DE\u05DF\u05E0\u05E1\u05E2\u05E3\u05E4\u05E5\u05E6\u05E7\u05E8\u05E9\u05EA\uFFFD\xA3\uFFFD\xD7\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\xAE\xAC\xBD\xBC\uFFFD\xAB\xBB\u2591\u2592\u2593\u2502\u2524\uFFFD\uFFFD\uFFFD\xA9\u2563\u2551\u2557\u255D\xA2\xA5\u2510\u2514\u2534\u252C\u251C\u2500\u253C\uFFFD\uFFFD\u255A\u2554\u2569\u2566\u2560\u2550\u256C\xA4\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u2518\u250C\u2588\u2584\xA6\uFFFD\u2580\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\xB5\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\xAF\xB4\xAD\xB1\u2017\xBE\xB6\xA7\xF7\xB8\xB0\xA8\xB7\xB9\xB3\xB2\u25A0\xA0"
      },
      ibm856: "cp856",
      csibm856: "cp856",
      cp857: {
        type: "_sbcs",
        chars: "\xC7\xFC\xE9\xE2\xE4\xE0\xE5\xE7\xEA\xEB\xE8\xEF\xEE\u0131\xC4\xC5\xC9\xE6\xC6\xF4\xF6\xF2\xFB\xF9\u0130\xD6\xDC\xF8\xA3\xD8\u015E\u015F\xE1\xED\xF3\xFA\xF1\xD1\u011E\u011F\xBF\xAE\xAC\xBD\xBC\xA1\xAB\xBB\u2591\u2592\u2593\u2502\u2524\xC1\xC2\xC0\xA9\u2563\u2551\u2557\u255D\xA2\xA5\u2510\u2514\u2534\u252C\u251C\u2500\u253C\xE3\xC3\u255A\u2554\u2569\u2566\u2560\u2550\u256C\xA4\xBA\xAA\xCA\xCB\xC8\uFFFD\xCD\xCE\xCF\u2518\u250C\u2588\u2584\xA6\xCC\u2580\xD3\xDF\xD4\xD2\xF5\xD5\xB5\uFFFD\xD7\xDA\xDB\xD9\xEC\xFF\xAF\xB4\xAD\xB1\uFFFD\xBE\xB6\xA7\xF7\xB8\xB0\xA8\xB7\xB9\xB3\xB2\u25A0\xA0"
      },
      ibm857: "cp857",
      csibm857: "cp857",
      cp858: {
        type: "_sbcs",
        chars: "\xC7\xFC\xE9\xE2\xE4\xE0\xE5\xE7\xEA\xEB\xE8\xEF\xEE\xEC\xC4\xC5\xC9\xE6\xC6\xF4\xF6\xF2\xFB\xF9\xFF\xD6\xDC\xF8\xA3\xD8\xD7\u0192\xE1\xED\xF3\xFA\xF1\xD1\xAA\xBA\xBF\xAE\xAC\xBD\xBC\xA1\xAB\xBB\u2591\u2592\u2593\u2502\u2524\xC1\xC2\xC0\xA9\u2563\u2551\u2557\u255D\xA2\xA5\u2510\u2514\u2534\u252C\u251C\u2500\u253C\xE3\xC3\u255A\u2554\u2569\u2566\u2560\u2550\u256C\xA4\xF0\xD0\xCA\xCB\xC8\u20AC\xCD\xCE\xCF\u2518\u250C\u2588\u2584\xA6\xCC\u2580\xD3\xDF\xD4\xD2\xF5\xD5\xB5\xFE\xDE\xDA\xDB\xD9\xFD\xDD\xAF\xB4\xAD\xB1\u2017\xBE\xB6\xA7\xF7\xB8\xB0\xA8\xB7\xB9\xB3\xB2\u25A0\xA0"
      },
      ibm858: "cp858",
      csibm858: "cp858",
      cp860: {
        type: "_sbcs",
        chars: "\xC7\xFC\xE9\xE2\xE3\xE0\xC1\xE7\xEA\xCA\xE8\xCD\xD4\xEC\xC3\xC2\xC9\xC0\xC8\xF4\xF5\xF2\xDA\xF9\xCC\xD5\xDC\xA2\xA3\xD9\u20A7\xD3\xE1\xED\xF3\xFA\xF1\xD1\xAA\xBA\xBF\xD2\xAC\xBD\xBC\xA1\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u03B1\xDF\u0393\u03C0\u03A3\u03C3\xB5\u03C4\u03A6\u0398\u03A9\u03B4\u221E\u03C6\u03B5\u2229\u2261\xB1\u2265\u2264\u2320\u2321\xF7\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0"
      },
      ibm860: "cp860",
      csibm860: "cp860",
      cp861: {
        type: "_sbcs",
        chars: "\xC7\xFC\xE9\xE2\xE4\xE0\xE5\xE7\xEA\xEB\xE8\xD0\xF0\xDE\xC4\xC5\xC9\xE6\xC6\xF4\xF6\xFE\xFB\xDD\xFD\xD6\xDC\xF8\xA3\xD8\u20A7\u0192\xE1\xED\xF3\xFA\xC1\xCD\xD3\xDA\xBF\u2310\xAC\xBD\xBC\xA1\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u03B1\xDF\u0393\u03C0\u03A3\u03C3\xB5\u03C4\u03A6\u0398\u03A9\u03B4\u221E\u03C6\u03B5\u2229\u2261\xB1\u2265\u2264\u2320\u2321\xF7\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0"
      },
      ibm861: "cp861",
      csibm861: "cp861",
      cp862: {
        type: "_sbcs",
        chars: "\u05D0\u05D1\u05D2\u05D3\u05D4\u05D5\u05D6\u05D7\u05D8\u05D9\u05DA\u05DB\u05DC\u05DD\u05DE\u05DF\u05E0\u05E1\u05E2\u05E3\u05E4\u05E5\u05E6\u05E7\u05E8\u05E9\u05EA\xA2\xA3\xA5\u20A7\u0192\xE1\xED\xF3\xFA\xF1\xD1\xAA\xBA\xBF\u2310\xAC\xBD\xBC\xA1\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u03B1\xDF\u0393\u03C0\u03A3\u03C3\xB5\u03C4\u03A6\u0398\u03A9\u03B4\u221E\u03C6\u03B5\u2229\u2261\xB1\u2265\u2264\u2320\u2321\xF7\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0"
      },
      ibm862: "cp862",
      csibm862: "cp862",
      cp863: {
        type: "_sbcs",
        chars: "\xC7\xFC\xE9\xE2\xC2\xE0\xB6\xE7\xEA\xEB\xE8\xEF\xEE\u2017\xC0\xA7\xC9\xC8\xCA\xF4\xCB\xCF\xFB\xF9\xA4\xD4\xDC\xA2\xA3\xD9\xDB\u0192\xA6\xB4\xF3\xFA\xA8\xB8\xB3\xAF\xCE\u2310\xAC\xBD\xBC\xBE\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u03B1\xDF\u0393\u03C0\u03A3\u03C3\xB5\u03C4\u03A6\u0398\u03A9\u03B4\u221E\u03C6\u03B5\u2229\u2261\xB1\u2265\u2264\u2320\u2321\xF7\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0"
      },
      ibm863: "cp863",
      csibm863: "cp863",
      cp864: {
        type: "_sbcs",
        chars: `\0\x07\b	
\v\f\r\x1B !"#$\u066A&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_\`abcdefghijklmnopqrstuvwxyz{|}~\x7F\xB0\xB7\u2219\u221A\u2592\u2500\u2502\u253C\u2524\u252C\u251C\u2534\u2510\u250C\u2514\u2518\u03B2\u221E\u03C6\xB1\xBD\xBC\u2248\xAB\xBB\uFEF7\uFEF8\uFFFD\uFFFD\uFEFB\uFEFC\uFFFD\xA0\xAD\uFE82\xA3\xA4\uFE84\uFFFD\uFFFD\uFE8E\uFE8F\uFE95\uFE99\u060C\uFE9D\uFEA1\uFEA5\u0660\u0661\u0662\u0663\u0664\u0665\u0666\u0667\u0668\u0669\uFED1\u061B\uFEB1\uFEB5\uFEB9\u061F\xA2\uFE80\uFE81\uFE83\uFE85\uFECA\uFE8B\uFE8D\uFE91\uFE93\uFE97\uFE9B\uFE9F\uFEA3\uFEA7\uFEA9\uFEAB\uFEAD\uFEAF\uFEB3\uFEB7\uFEBB\uFEBF\uFEC1\uFEC5\uFECB\uFECF\xA6\xAC\xF7\xD7\uFEC9\u0640\uFED3\uFED7\uFEDB\uFEDF\uFEE3\uFEE7\uFEEB\uFEED\uFEEF\uFEF3\uFEBD\uFECC\uFECE\uFECD\uFEE1\uFE7D\u0651\uFEE5\uFEE9\uFEEC\uFEF0\uFEF2\uFED0\uFED5\uFEF5\uFEF6\uFEDD\uFED9\uFEF1\u25A0\uFFFD`
      },
      ibm864: "cp864",
      csibm864: "cp864",
      cp865: {
        type: "_sbcs",
        chars: "\xC7\xFC\xE9\xE2\xE4\xE0\xE5\xE7\xEA\xEB\xE8\xEF\xEE\xEC\xC4\xC5\xC9\xE6\xC6\xF4\xF6\xF2\xFB\xF9\xFF\xD6\xDC\xF8\xA3\xD8\u20A7\u0192\xE1\xED\xF3\xFA\xF1\xD1\xAA\xBA\xBF\u2310\xAC\xBD\xBC\xA1\xAB\xA4\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u03B1\xDF\u0393\u03C0\u03A3\u03C3\xB5\u03C4\u03A6\u0398\u03A9\u03B4\u221E\u03C6\u03B5\u2229\u2261\xB1\u2265\u2264\u2320\u2321\xF7\u2248\xB0\u2219\xB7\u221A\u207F\xB2\u25A0\xA0"
      },
      ibm865: "cp865",
      csibm865: "cp865",
      cp866: {
        type: "_sbcs",
        chars: "\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F\u0401\u0451\u0404\u0454\u0407\u0457\u040E\u045E\xB0\u2219\xB7\u221A\u2116\xA4\u25A0\xA0"
      },
      ibm866: "cp866",
      csibm866: "cp866",
      cp869: {
        type: "_sbcs",
        chars: "\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u0386\uFFFD\xB7\xAC\xA6\u2018\u2019\u0388\u2015\u0389\u038A\u03AA\u038C\uFFFD\uFFFD\u038E\u03AB\xA9\u038F\xB2\xB3\u03AC\xA3\u03AD\u03AE\u03AF\u03CA\u0390\u03CC\u03CD\u0391\u0392\u0393\u0394\u0395\u0396\u0397\xBD\u0398\u0399\xAB\xBB\u2591\u2592\u2593\u2502\u2524\u039A\u039B\u039C\u039D\u2563\u2551\u2557\u255D\u039E\u039F\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u03A0\u03A1\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u03A3\u03A4\u03A5\u03A6\u03A7\u03A8\u03A9\u03B1\u03B2\u03B3\u2518\u250C\u2588\u2584\u03B4\u03B5\u2580\u03B6\u03B7\u03B8\u03B9\u03BA\u03BB\u03BC\u03BD\u03BE\u03BF\u03C0\u03C1\u03C3\u03C2\u03C4\u0384\xAD\xB1\u03C5\u03C6\u03C7\xA7\u03C8\u0385\xB0\xA8\u03C9\u03CB\u03B0\u03CE\u25A0\xA0"
      },
      ibm869: "cp869",
      csibm869: "cp869",
      cp922: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\u203E\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\u0160\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\xDD\u017D\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\u0161\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\u017E\xFF"
      },
      ibm922: "cp922",
      csibm922: "cp922",
      cp1046: {
        type: "_sbcs",
        chars: "\uFE88\xD7\xF7\uF8F6\uF8F5\uF8F4\uF8F7\uFE71\x88\u25A0\u2502\u2500\u2510\u250C\u2514\u2518\uFE79\uFE7B\uFE7D\uFE7F\uFE77\uFE8A\uFEF0\uFEF3\uFEF2\uFECE\uFECF\uFED0\uFEF6\uFEF8\uFEFA\uFEFC\xA0\uF8FA\uF8F9\uF8F8\xA4\uF8FB\uFE8B\uFE91\uFE97\uFE9B\uFE9F\uFEA3\u060C\xAD\uFEA7\uFEB3\u0660\u0661\u0662\u0663\u0664\u0665\u0666\u0667\u0668\u0669\uFEB7\u061B\uFEBB\uFEBF\uFECA\u061F\uFECB\u0621\u0622\u0623\u0624\u0625\u0626\u0627\u0628\u0629\u062A\u062B\u062C\u062D\u062E\u062F\u0630\u0631\u0632\u0633\u0634\u0635\u0636\u0637\uFEC7\u0639\u063A\uFECC\uFE82\uFE84\uFE8E\uFED3\u0640\u0641\u0642\u0643\u0644\u0645\u0646\u0647\u0648\u0649\u064A\u064B\u064C\u064D\u064E\u064F\u0650\u0651\u0652\uFED7\uFEDB\uFEDF\uF8FC\uFEF5\uFEF7\uFEF9\uFEFB\uFEE3\uFEE7\uFEEC\uFEE9\uFFFD"
      },
      ibm1046: "cp1046",
      csibm1046: "cp1046",
      cp1124: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0401\u0402\u0490\u0404\u0405\u0406\u0407\u0408\u0409\u040A\u040B\u040C\xAD\u040E\u040F\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F\u2116\u0451\u0452\u0491\u0454\u0455\u0456\u0457\u0458\u0459\u045A\u045B\u045C\xA7\u045E\u045F"
      },
      ibm1124: "cp1124",
      csibm1124: "cp1124",
      cp1125: {
        type: "_sbcs",
        chars: "\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u2591\u2592\u2593\u2502\u2524\u2561\u2562\u2556\u2555\u2563\u2551\u2557\u255D\u255C\u255B\u2510\u2514\u2534\u252C\u251C\u2500\u253C\u255E\u255F\u255A\u2554\u2569\u2566\u2560\u2550\u256C\u2567\u2568\u2564\u2565\u2559\u2558\u2552\u2553\u256B\u256A\u2518\u250C\u2588\u2584\u258C\u2590\u2580\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F\u0401\u0451\u0490\u0491\u0404\u0454\u0406\u0456\u0407\u0457\xB7\u221A\u2116\xA4\u25A0\xA0"
      },
      ibm1125: "cp1125",
      csibm1125: "cp1125",
      cp1129: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\u0153\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\u0178\xB5\xB6\xB7\u0152\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\u0102\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\u0300\xCD\xCE\xCF\u0110\xD1\u0309\xD3\xD4\u01A0\xD6\xD7\xD8\xD9\xDA\xDB\xDC\u01AF\u0303\xDF\xE0\xE1\xE2\u0103\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\u0301\xED\xEE\xEF\u0111\xF1\u0323\xF3\xF4\u01A1\xF6\xF7\xF8\xF9\xFA\xFB\xFC\u01B0\u20AB\xFF"
      },
      ibm1129: "cp1129",
      csibm1129: "cp1129",
      cp1133: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0E81\u0E82\u0E84\u0E87\u0E88\u0EAA\u0E8A\u0E8D\u0E94\u0E95\u0E96\u0E97\u0E99\u0E9A\u0E9B\u0E9C\u0E9D\u0E9E\u0E9F\u0EA1\u0EA2\u0EA3\u0EA5\u0EA7\u0EAB\u0EAD\u0EAE\uFFFD\uFFFD\uFFFD\u0EAF\u0EB0\u0EB2\u0EB3\u0EB4\u0EB5\u0EB6\u0EB7\u0EB8\u0EB9\u0EBC\u0EB1\u0EBB\u0EBD\uFFFD\uFFFD\uFFFD\u0EC0\u0EC1\u0EC2\u0EC3\u0EC4\u0EC8\u0EC9\u0ECA\u0ECB\u0ECC\u0ECD\u0EC6\uFFFD\u0EDC\u0EDD\u20AD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u0ED0\u0ED1\u0ED2\u0ED3\u0ED4\u0ED5\u0ED6\u0ED7\u0ED8\u0ED9\uFFFD\uFFFD\xA2\xAC\xA6\uFFFD"
      },
      ibm1133: "cp1133",
      csibm1133: "cp1133",
      cp1161: {
        type: "_sbcs",
        chars: "\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u0E48\u0E01\u0E02\u0E03\u0E04\u0E05\u0E06\u0E07\u0E08\u0E09\u0E0A\u0E0B\u0E0C\u0E0D\u0E0E\u0E0F\u0E10\u0E11\u0E12\u0E13\u0E14\u0E15\u0E16\u0E17\u0E18\u0E19\u0E1A\u0E1B\u0E1C\u0E1D\u0E1E\u0E1F\u0E20\u0E21\u0E22\u0E23\u0E24\u0E25\u0E26\u0E27\u0E28\u0E29\u0E2A\u0E2B\u0E2C\u0E2D\u0E2E\u0E2F\u0E30\u0E31\u0E32\u0E33\u0E34\u0E35\u0E36\u0E37\u0E38\u0E39\u0E3A\u0E49\u0E4A\u0E4B\u20AC\u0E3F\u0E40\u0E41\u0E42\u0E43\u0E44\u0E45\u0E46\u0E47\u0E48\u0E49\u0E4A\u0E4B\u0E4C\u0E4D\u0E4E\u0E4F\u0E50\u0E51\u0E52\u0E53\u0E54\u0E55\u0E56\u0E57\u0E58\u0E59\u0E5A\u0E5B\xA2\xAC\xA6\xA0"
      },
      ibm1161: "cp1161",
      csibm1161: "cp1161",
      cp1162: {
        type: "_sbcs",
        chars: "\u20AC\x81\x82\x83\x84\u2026\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\u2018\u2019\u201C\u201D\u2022\u2013\u2014\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\u0E01\u0E02\u0E03\u0E04\u0E05\u0E06\u0E07\u0E08\u0E09\u0E0A\u0E0B\u0E0C\u0E0D\u0E0E\u0E0F\u0E10\u0E11\u0E12\u0E13\u0E14\u0E15\u0E16\u0E17\u0E18\u0E19\u0E1A\u0E1B\u0E1C\u0E1D\u0E1E\u0E1F\u0E20\u0E21\u0E22\u0E23\u0E24\u0E25\u0E26\u0E27\u0E28\u0E29\u0E2A\u0E2B\u0E2C\u0E2D\u0E2E\u0E2F\u0E30\u0E31\u0E32\u0E33\u0E34\u0E35\u0E36\u0E37\u0E38\u0E39\u0E3A\uFFFD\uFFFD\uFFFD\uFFFD\u0E3F\u0E40\u0E41\u0E42\u0E43\u0E44\u0E45\u0E46\u0E47\u0E48\u0E49\u0E4A\u0E4B\u0E4C\u0E4D\u0E4E\u0E4F\u0E50\u0E51\u0E52\u0E53\u0E54\u0E55\u0E56\u0E57\u0E58\u0E59\u0E5A\u0E5B\uFFFD\uFFFD\uFFFD\uFFFD"
      },
      ibm1162: "cp1162",
      csibm1162: "cp1162",
      cp1163: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\xA1\xA2\xA3\u20AC\xA5\xA6\xA7\u0153\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\u0178\xB5\xB6\xB7\u0152\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\u0102\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\u0300\xCD\xCE\xCF\u0110\xD1\u0309\xD3\xD4\u01A0\xD6\xD7\xD8\xD9\xDA\xDB\xDC\u01AF\u0303\xDF\xE0\xE1\xE2\u0103\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\u0301\xED\xEE\xEF\u0111\xF1\u0323\xF3\xF4\u01A1\xF6\xF7\xF8\xF9\xFA\xFB\xFC\u01B0\u20AB\xFF"
      },
      ibm1163: "cp1163",
      csibm1163: "cp1163",
      maccroatian: {
        type: "_sbcs",
        chars: "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\u2020\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\u0160\u2122\xB4\xA8\u2260\u017D\xD8\u221E\xB1\u2264\u2265\u2206\xB5\u2202\u2211\u220F\u0161\u222B\xAA\xBA\u2126\u017E\xF8\xBF\xA1\xAC\u221A\u0192\u2248\u0106\xAB\u010C\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u0110\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\uFFFD\xA9\u2044\xA4\u2039\u203A\xC6\xBB\u2013\xB7\u201A\u201E\u2030\xC2\u0107\xC1\u010D\xC8\xCD\xCE\xCF\xCC\xD3\xD4\u0111\xD2\xDA\xDB\xD9\u0131\u02C6\u02DC\xAF\u03C0\xCB\u02DA\xB8\xCA\xE6\u02C7"
      },
      maccyrillic: {
        type: "_sbcs",
        chars: "\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u2020\xB0\xA2\xA3\xA7\u2022\xB6\u0406\xAE\xA9\u2122\u0402\u0452\u2260\u0403\u0453\u221E\xB1\u2264\u2265\u0456\xB5\u2202\u0408\u0404\u0454\u0407\u0457\u0409\u0459\u040A\u045A\u0458\u0405\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\u040B\u045B\u040C\u045C\u0455\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u201E\u040E\u045E\u040F\u045F\u2116\u0401\u0451\u044F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\xA4"
      },
      macgreek: {
        type: "_sbcs",
        chars: "\xC4\xB9\xB2\xC9\xB3\xD6\xDC\u0385\xE0\xE2\xE4\u0384\xA8\xE7\xE9\xE8\xEA\xEB\xA3\u2122\xEE\xEF\u2022\xBD\u2030\xF4\xF6\xA6\xAD\xF9\xFB\xFC\u2020\u0393\u0394\u0398\u039B\u039E\u03A0\xDF\xAE\xA9\u03A3\u03AA\xA7\u2260\xB0\u0387\u0391\xB1\u2264\u2265\xA5\u0392\u0395\u0396\u0397\u0399\u039A\u039C\u03A6\u03AB\u03A8\u03A9\u03AC\u039D\xAC\u039F\u03A1\u2248\u03A4\xAB\xBB\u2026\xA0\u03A5\u03A7\u0386\u0388\u0153\u2013\u2015\u201C\u201D\u2018\u2019\xF7\u0389\u038A\u038C\u038E\u03AD\u03AE\u03AF\u03CC\u038F\u03CD\u03B1\u03B2\u03C8\u03B4\u03B5\u03C6\u03B3\u03B7\u03B9\u03BE\u03BA\u03BB\u03BC\u03BD\u03BF\u03C0\u03CE\u03C1\u03C3\u03C4\u03B8\u03C9\u03C2\u03C7\u03C5\u03B6\u03CA\u03CB\u0390\u03B0\uFFFD"
      },
      maciceland: {
        type: "_sbcs",
        chars: "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\xDD\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\xB4\xA8\u2260\xC6\xD8\u221E\xB1\u2264\u2265\xA5\xB5\u2202\u2211\u220F\u03C0\u222B\xAA\xBA\u2126\xE6\xF8\xBF\xA1\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\xFF\u0178\u2044\xA4\xD0\xF0\xDE\xFE\xFD\xB7\u201A\u201E\u2030\xC2\xCA\xC1\xCB\xC8\xCD\xCE\xCF\xCC\xD3\xD4\uFFFD\xD2\xDA\xDB\xD9\u0131\u02C6\u02DC\xAF\u02D8\u02D9\u02DA\xB8\u02DD\u02DB\u02C7"
      },
      macroman: {
        type: "_sbcs",
        chars: "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\u2020\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\xB4\xA8\u2260\xC6\xD8\u221E\xB1\u2264\u2265\xA5\xB5\u2202\u2211\u220F\u03C0\u222B\xAA\xBA\u2126\xE6\xF8\xBF\xA1\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\xFF\u0178\u2044\xA4\u2039\u203A\uFB01\uFB02\u2021\xB7\u201A\u201E\u2030\xC2\xCA\xC1\xCB\xC8\xCD\xCE\xCF\xCC\xD3\xD4\uFFFD\xD2\xDA\xDB\xD9\u0131\u02C6\u02DC\xAF\u02D8\u02D9\u02DA\xB8\u02DD\u02DB\u02C7"
      },
      macromania: {
        type: "_sbcs",
        chars: "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\u2020\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\xB4\xA8\u2260\u0102\u015E\u221E\xB1\u2264\u2265\xA5\xB5\u2202\u2211\u220F\u03C0\u222B\xAA\xBA\u2126\u0103\u015F\xBF\xA1\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\xFF\u0178\u2044\xA4\u2039\u203A\u0162\u0163\u2021\xB7\u201A\u201E\u2030\xC2\xCA\xC1\xCB\xC8\xCD\xCE\xCF\xCC\xD3\xD4\uFFFD\xD2\xDA\xDB\xD9\u0131\u02C6\u02DC\xAF\u02D8\u02D9\u02DA\xB8\u02DD\u02DB\u02C7"
      },
      macthai: {
        type: "_sbcs",
        chars: "\xAB\xBB\u2026\uF88C\uF88F\uF892\uF895\uF898\uF88B\uF88E\uF891\uF894\uF897\u201C\u201D\uF899\uFFFD\u2022\uF884\uF889\uF885\uF886\uF887\uF888\uF88A\uF88D\uF890\uF893\uF896\u2018\u2019\uFFFD\xA0\u0E01\u0E02\u0E03\u0E04\u0E05\u0E06\u0E07\u0E08\u0E09\u0E0A\u0E0B\u0E0C\u0E0D\u0E0E\u0E0F\u0E10\u0E11\u0E12\u0E13\u0E14\u0E15\u0E16\u0E17\u0E18\u0E19\u0E1A\u0E1B\u0E1C\u0E1D\u0E1E\u0E1F\u0E20\u0E21\u0E22\u0E23\u0E24\u0E25\u0E26\u0E27\u0E28\u0E29\u0E2A\u0E2B\u0E2C\u0E2D\u0E2E\u0E2F\u0E30\u0E31\u0E32\u0E33\u0E34\u0E35\u0E36\u0E37\u0E38\u0E39\u0E3A\uFEFF\u200B\u2013\u2014\u0E3F\u0E40\u0E41\u0E42\u0E43\u0E44\u0E45\u0E46\u0E47\u0E48\u0E49\u0E4A\u0E4B\u0E4C\u0E4D\u2122\u0E4F\u0E50\u0E51\u0E52\u0E53\u0E54\u0E55\u0E56\u0E57\u0E58\u0E59\xAE\xA9\uFFFD\uFFFD\uFFFD\uFFFD"
      },
      macturkish: {
        type: "_sbcs",
        chars: "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\u2020\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\xB4\xA8\u2260\xC6\xD8\u221E\xB1\u2264\u2265\xA5\xB5\u2202\u2211\u220F\u03C0\u222B\xAA\xBA\u2126\xE6\xF8\xBF\xA1\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\xFF\u0178\u011E\u011F\u0130\u0131\u015E\u015F\u2021\xB7\u201A\u201E\u2030\xC2\xCA\xC1\xCB\xC8\xCD\xCE\xCF\xCC\xD3\xD4\uFFFD\xD2\xDA\xDB\xD9\uFFFD\u02C6\u02DC\xAF\u02D8\u02D9\u02DA\xB8\u02DD\u02DB\u02C7"
      },
      macukraine: {
        type: "_sbcs",
        chars: "\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u2020\xB0\u0490\xA3\xA7\u2022\xB6\u0406\xAE\xA9\u2122\u0402\u0452\u2260\u0403\u0453\u221E\xB1\u2264\u2265\u0456\xB5\u0491\u0408\u0404\u0454\u0407\u0457\u0409\u0459\u040A\u045A\u0458\u0405\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\u040B\u045B\u040C\u045C\u0455\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u201E\u040E\u045E\u040F\u045F\u2116\u0401\u0451\u044F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\xA4"
      },
      koi8r: {
        type: "_sbcs",
        chars: "\u2500\u2502\u250C\u2510\u2514\u2518\u251C\u2524\u252C\u2534\u253C\u2580\u2584\u2588\u258C\u2590\u2591\u2592\u2593\u2320\u25A0\u2219\u221A\u2248\u2264\u2265\xA0\u2321\xB0\xB2\xB7\xF7\u2550\u2551\u2552\u0451\u2553\u2554\u2555\u2556\u2557\u2558\u2559\u255A\u255B\u255C\u255D\u255E\u255F\u2560\u2561\u0401\u2562\u2563\u2564\u2565\u2566\u2567\u2568\u2569\u256A\u256B\u256C\xA9\u044E\u0430\u0431\u0446\u0434\u0435\u0444\u0433\u0445\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u044F\u0440\u0441\u0442\u0443\u0436\u0432\u044C\u044B\u0437\u0448\u044D\u0449\u0447\u044A\u042E\u0410\u0411\u0426\u0414\u0415\u0424\u0413\u0425\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u042F\u0420\u0421\u0422\u0423\u0416\u0412\u042C\u042B\u0417\u0428\u042D\u0429\u0427\u042A"
      },
      koi8u: {
        type: "_sbcs",
        chars: "\u2500\u2502\u250C\u2510\u2514\u2518\u251C\u2524\u252C\u2534\u253C\u2580\u2584\u2588\u258C\u2590\u2591\u2592\u2593\u2320\u25A0\u2219\u221A\u2248\u2264\u2265\xA0\u2321\xB0\xB2\xB7\xF7\u2550\u2551\u2552\u0451\u0454\u2554\u0456\u0457\u2557\u2558\u2559\u255A\u255B\u0491\u255D\u255E\u255F\u2560\u2561\u0401\u0404\u2563\u0406\u0407\u2566\u2567\u2568\u2569\u256A\u0490\u256C\xA9\u044E\u0430\u0431\u0446\u0434\u0435\u0444\u0433\u0445\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u044F\u0440\u0441\u0442\u0443\u0436\u0432\u044C\u044B\u0437\u0448\u044D\u0449\u0447\u044A\u042E\u0410\u0411\u0426\u0414\u0415\u0424\u0413\u0425\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u042F\u0420\u0421\u0422\u0423\u0416\u0412\u042C\u042B\u0417\u0428\u042D\u0429\u0427\u042A"
      },
      koi8ru: {
        type: "_sbcs",
        chars: "\u2500\u2502\u250C\u2510\u2514\u2518\u251C\u2524\u252C\u2534\u253C\u2580\u2584\u2588\u258C\u2590\u2591\u2592\u2593\u2320\u25A0\u2219\u221A\u2248\u2264\u2265\xA0\u2321\xB0\xB2\xB7\xF7\u2550\u2551\u2552\u0451\u0454\u2554\u0456\u0457\u2557\u2558\u2559\u255A\u255B\u0491\u045E\u255E\u255F\u2560\u2561\u0401\u0404\u2563\u0406\u0407\u2566\u2567\u2568\u2569\u256A\u0490\u040E\xA9\u044E\u0430\u0431\u0446\u0434\u0435\u0444\u0433\u0445\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u044F\u0440\u0441\u0442\u0443\u0436\u0432\u044C\u044B\u0437\u0448\u044D\u0449\u0447\u044A\u042E\u0410\u0411\u0426\u0414\u0415\u0424\u0413\u0425\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u042F\u0420\u0421\u0422\u0423\u0416\u0412\u042C\u042B\u0417\u0428\u042D\u0429\u0427\u042A"
      },
      koi8t: {
        type: "_sbcs",
        chars: "\u049B\u0493\u201A\u0492\u201E\u2026\u2020\u2021\uFFFD\u2030\u04B3\u2039\u04B2\u04B7\u04B6\uFFFD\u049A\u2018\u2019\u201C\u201D\u2022\u2013\u2014\uFFFD\u2122\uFFFD\u203A\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u04EF\u04EE\u0451\xA4\u04E3\xA6\xA7\uFFFD\uFFFD\uFFFD\xAB\xAC\xAD\xAE\uFFFD\xB0\xB1\xB2\u0401\uFFFD\u04E2\xB6\xB7\uFFFD\u2116\uFFFD\xBB\uFFFD\uFFFD\uFFFD\xA9\u044E\u0430\u0431\u0446\u0434\u0435\u0444\u0433\u0445\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u044F\u0440\u0441\u0442\u0443\u0436\u0432\u044C\u044B\u0437\u0448\u044D\u0449\u0447\u044A\u042E\u0410\u0411\u0426\u0414\u0415\u0424\u0413\u0425\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u042F\u0420\u0421\u0422\u0423\u0416\u0412\u042C\u042B\u0417\u0428\u042D\u0429\u0427\u042A"
      },
      armscii8: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\uFFFD\u0587\u0589)(\xBB\xAB\u2014.\u055D,-\u058A\u2026\u055C\u055B\u055E\u0531\u0561\u0532\u0562\u0533\u0563\u0534\u0564\u0535\u0565\u0536\u0566\u0537\u0567\u0538\u0568\u0539\u0569\u053A\u056A\u053B\u056B\u053C\u056C\u053D\u056D\u053E\u056E\u053F\u056F\u0540\u0570\u0541\u0571\u0542\u0572\u0543\u0573\u0544\u0574\u0545\u0575\u0546\u0576\u0547\u0577\u0548\u0578\u0549\u0579\u054A\u057A\u054B\u057B\u054C\u057C\u054D\u057D\u054E\u057E\u054F\u057F\u0550\u0580\u0551\u0581\u0552\u0582\u0553\u0583\u0554\u0584\u0555\u0585\u0556\u0586\u055A\uFFFD"
      },
      rk1048: {
        type: "_sbcs",
        chars: "\u0402\u0403\u201A\u0453\u201E\u2026\u2020\u2021\u20AC\u2030\u0409\u2039\u040A\u049A\u04BA\u040F\u0452\u2018\u2019\u201C\u201D\u2022\u2013\u2014\uFFFD\u2122\u0459\u203A\u045A\u049B\u04BB\u045F\xA0\u04B0\u04B1\u04D8\xA4\u04E8\xA6\xA7\u0401\xA9\u0492\xAB\xAC\xAD\xAE\u04AE\xB0\xB1\u0406\u0456\u04E9\xB5\xB6\xB7\u0451\u2116\u0493\xBB\u04D9\u04A2\u04A3\u04AF\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F"
      },
      tcvn: {
        type: "_sbcs",
        chars: `\0\xDA\u1EE4\u1EEA\u1EEC\u1EEE\x07\b	
\v\f\r\u1EE8\u1EF0\u1EF2\u1EF6\u1EF8\xDD\u1EF4\x1B !"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_\`abcdefghijklmnopqrstuvwxyz{|}~\x7F\xC0\u1EA2\xC3\xC1\u1EA0\u1EB6\u1EAC\xC8\u1EBA\u1EBC\xC9\u1EB8\u1EC6\xCC\u1EC8\u0128\xCD\u1ECA\xD2\u1ECE\xD5\xD3\u1ECC\u1ED8\u1EDC\u1EDE\u1EE0\u1EDA\u1EE2\xD9\u1EE6\u0168\xA0\u0102\xC2\xCA\xD4\u01A0\u01AF\u0110\u0103\xE2\xEA\xF4\u01A1\u01B0\u0111\u1EB0\u0300\u0309\u0303\u0301\u0323\xE0\u1EA3\xE3\xE1\u1EA1\u1EB2\u1EB1\u1EB3\u1EB5\u1EAF\u1EB4\u1EAE\u1EA6\u1EA8\u1EAA\u1EA4\u1EC0\u1EB7\u1EA7\u1EA9\u1EAB\u1EA5\u1EAD\xE8\u1EC2\u1EBB\u1EBD\xE9\u1EB9\u1EC1\u1EC3\u1EC5\u1EBF\u1EC7\xEC\u1EC9\u1EC4\u1EBE\u1ED2\u0129\xED\u1ECB\xF2\u1ED4\u1ECF\xF5\xF3\u1ECD\u1ED3\u1ED5\u1ED7\u1ED1\u1ED9\u1EDD\u1EDF\u1EE1\u1EDB\u1EE3\xF9\u1ED6\u1EE7\u0169\xFA\u1EE5\u1EEB\u1EED\u1EEF\u1EE9\u1EF1\u1EF3\u1EF7\u1EF9\xFD\u1EF5\u1ED0`
      },
      georgianacademy: {
        type: "_sbcs",
        chars: "\x80\x81\u201A\u0192\u201E\u2026\u2020\u2021\u02C6\u2030\u0160\u2039\u0152\x8D\x8E\x8F\x90\u2018\u2019\u201C\u201D\u2022\u2013\u2014\u02DC\u2122\u0161\u203A\u0153\x9D\x9E\u0178\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\u10D0\u10D1\u10D2\u10D3\u10D4\u10D5\u10D6\u10D7\u10D8\u10D9\u10DA\u10DB\u10DC\u10DD\u10DE\u10DF\u10E0\u10E1\u10E2\u10E3\u10E4\u10E5\u10E6\u10E7\u10E8\u10E9\u10EA\u10EB\u10EC\u10ED\u10EE\u10EF\u10F0\u10F1\u10F2\u10F3\u10F4\u10F5\u10F6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF"
      },
      georgianps: {
        type: "_sbcs",
        chars: "\x80\x81\u201A\u0192\u201E\u2026\u2020\u2021\u02C6\u2030\u0160\u2039\u0152\x8D\x8E\x8F\x90\u2018\u2019\u201C\u201D\u2022\u2013\u2014\u02DC\u2122\u0161\u203A\u0153\x9D\x9E\u0178\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\u10D0\u10D1\u10D2\u10D3\u10D4\u10D5\u10D6\u10F1\u10D7\u10D8\u10D9\u10DA\u10DB\u10DC\u10F2\u10DD\u10DE\u10DF\u10E0\u10E1\u10E2\u10F3\u10E3\u10E4\u10E5\u10E6\u10E7\u10E8\u10E9\u10EA\u10EB\u10EC\u10ED\u10EE\u10F4\u10EF\u10F0\u10F5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF"
      },
      pt154: {
        type: "_sbcs",
        chars: "\u0496\u0492\u04EE\u0493\u201E\u2026\u04B6\u04AE\u04B2\u04AF\u04A0\u04E2\u04A2\u049A\u04BA\u04B8\u0497\u2018\u2019\u201C\u201D\u2022\u2013\u2014\u04B3\u04B7\u04A1\u04E3\u04A3\u049B\u04BB\u04B9\xA0\u040E\u045E\u0408\u04E8\u0498\u04B0\xA7\u0401\xA9\u04D8\xAB\xAC\u04EF\xAE\u049C\xB0\u04B1\u0406\u0456\u0499\u04E9\xB6\xB7\u0451\u2116\u04D9\xBB\u0458\u04AA\u04AB\u049D\u0410\u0411\u0412\u0413\u0414\u0415\u0416\u0417\u0418\u0419\u041A\u041B\u041C\u041D\u041E\u041F\u0420\u0421\u0422\u0423\u0424\u0425\u0426\u0427\u0428\u0429\u042A\u042B\u042C\u042D\u042E\u042F\u0430\u0431\u0432\u0433\u0434\u0435\u0436\u0437\u0438\u0439\u043A\u043B\u043C\u043D\u043E\u043F\u0440\u0441\u0442\u0443\u0444\u0445\u0446\u0447\u0448\u0449\u044A\u044B\u044C\u044D\u044E\u044F"
      },
      viscii: {
        type: "_sbcs",
        chars: `\0\u1EB2\u1EB4\u1EAA\x07\b	
\v\f\r\u1EF6\u1EF8\x1B\u1EF4 !"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_\`abcdefghijklmnopqrstuvwxyz{|}~\x7F\u1EA0\u1EAE\u1EB0\u1EB6\u1EA4\u1EA6\u1EA8\u1EAC\u1EBC\u1EB8\u1EBE\u1EC0\u1EC2\u1EC4\u1EC6\u1ED0\u1ED2\u1ED4\u1ED6\u1ED8\u1EE2\u1EDA\u1EDC\u1EDE\u1ECA\u1ECE\u1ECC\u1EC8\u1EE6\u0168\u1EE4\u1EF2\xD5\u1EAF\u1EB1\u1EB7\u1EA5\u1EA7\u1EA9\u1EAD\u1EBD\u1EB9\u1EBF\u1EC1\u1EC3\u1EC5\u1EC7\u1ED1\u1ED3\u1ED5\u1ED7\u1EE0\u01A0\u1ED9\u1EDD\u1EDF\u1ECB\u1EF0\u1EE8\u1EEA\u1EEC\u01A1\u1EDB\u01AF\xC0\xC1\xC2\xC3\u1EA2\u0102\u1EB3\u1EB5\xC8\xC9\xCA\u1EBA\xCC\xCD\u0128\u1EF3\u0110\u1EE9\xD2\xD3\xD4\u1EA1\u1EF7\u1EEB\u1EED\xD9\xDA\u1EF9\u1EF5\xDD\u1EE1\u01B0\xE0\xE1\xE2\xE3\u1EA3\u0103\u1EEF\u1EAB\xE8\xE9\xEA\u1EBB\xEC\xED\u0129\u1EC9\u0111\u1EF1\xF2\xF3\xF4\xF5\u1ECF\u1ECD\u1EE5\xF9\xFA\u0169\u1EE7\xFD\u1EE3\u1EEE`
      },
      iso646cn: {
        type: "_sbcs",
        chars: `\0\x07\b	
\v\f\r\x1B !"#\xA5%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_\`abcdefghijklmnopqrstuvwxyz{|}\u203E\x7F\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD`
      },
      iso646jp: {
        type: "_sbcs",
        chars: `\0\x07\b	
\v\f\r\x1B !"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\xA5]^_\`abcdefghijklmnopqrstuvwxyz{|}\u203E\x7F\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD`
      },
      hproman8: {
        type: "_sbcs",
        chars: "\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\xC0\xC2\xC8\xCA\xCB\xCE\xCF\xB4\u02CB\u02C6\xA8\u02DC\xD9\xDB\u20A4\xAF\xDD\xFD\xB0\xC7\xE7\xD1\xF1\xA1\xBF\xA4\xA3\xA5\xA7\u0192\xA2\xE2\xEA\xF4\xFB\xE1\xE9\xF3\xFA\xE0\xE8\xF2\xF9\xE4\xEB\xF6\xFC\xC5\xEE\xD8\xC6\xE5\xED\xF8\xE6\xC4\xEC\xD6\xDC\xC9\xEF\xDF\xD4\xC1\xC3\xE3\xD0\xF0\xCD\xCC\xD3\xD2\xD5\xF5\u0160\u0161\xDA\u0178\xFF\xDE\xFE\xB7\xB5\xB6\xBE\u2014\xBC\xBD\xAA\xBA\xAB\u25A0\xBB\xB1\uFFFD"
      },
      macintosh: {
        type: "_sbcs",
        chars: "\xC4\xC5\xC7\xC9\xD1\xD6\xDC\xE1\xE0\xE2\xE4\xE3\xE5\xE7\xE9\xE8\xEA\xEB\xED\xEC\xEE\xEF\xF1\xF3\xF2\xF4\xF6\xF5\xFA\xF9\xFB\xFC\u2020\xB0\xA2\xA3\xA7\u2022\xB6\xDF\xAE\xA9\u2122\xB4\xA8\u2260\xC6\xD8\u221E\xB1\u2264\u2265\xA5\xB5\u2202\u2211\u220F\u03C0\u222B\xAA\xBA\u2126\xE6\xF8\xBF\xA1\xAC\u221A\u0192\u2248\u2206\xAB\xBB\u2026\xA0\xC0\xC3\xD5\u0152\u0153\u2013\u2014\u201C\u201D\u2018\u2019\xF7\u25CA\xFF\u0178\u2044\xA4\u2039\u203A\uFB01\uFB02\u2021\xB7\u201A\u201E\u2030\xC2\xCA\xC1\xCB\xC8\xCD\xCE\xCF\xCC\xD3\xD4\uFFFD\xD2\xDA\xDB\xD9\u0131\u02C6\u02DC\xAF\u02D8\u02D9\u02DA\xB8\u02DD\u02DB\u02C7"
      },
      ascii: {
        type: "_sbcs",
        chars: "\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD"
      },
      tis620: {
        type: "_sbcs",
        chars: "\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\uFFFD\u0E01\u0E02\u0E03\u0E04\u0E05\u0E06\u0E07\u0E08\u0E09\u0E0A\u0E0B\u0E0C\u0E0D\u0E0E\u0E0F\u0E10\u0E11\u0E12\u0E13\u0E14\u0E15\u0E16\u0E17\u0E18\u0E19\u0E1A\u0E1B\u0E1C\u0E1D\u0E1E\u0E1F\u0E20\u0E21\u0E22\u0E23\u0E24\u0E25\u0E26\u0E27\u0E28\u0E29\u0E2A\u0E2B\u0E2C\u0E2D\u0E2E\u0E2F\u0E30\u0E31\u0E32\u0E33\u0E34\u0E35\u0E36\u0E37\u0E38\u0E39\u0E3A\uFFFD\uFFFD\uFFFD\uFFFD\u0E3F\u0E40\u0E41\u0E42\u0E43\u0E44\u0E45\u0E46\u0E47\u0E48\u0E49\u0E4A\u0E4B\u0E4C\u0E4D\u0E4E\u0E4F\u0E50\u0E51\u0E52\u0E53\u0E54\u0E55\u0E56\u0E57\u0E58\u0E59\u0E5A\u0E5B\uFFFD\uFFFD\uFFFD\uFFFD"
      }
    };
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/dbcs-codec.js
var require_dbcs_codec = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/dbcs-codec.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Buffer2 = require_safer().Buffer;
    exports._dbcs = DBCSCodec;
    var UNASSIGNED = -1, GB18030_CODE = -2, SEQ_START = -10, NODE_START = -1e3, UNASSIGNED_NODE = new Array(256), DEF_CHAR = -1;
    for (i = 0; i < 256; i++)
      UNASSIGNED_NODE[i] = UNASSIGNED;
    var i;
    function DBCSCodec(codecOptions, iconv) {
      if (this.encodingName = codecOptions.encodingName, !codecOptions)
        throw new Error("DBCS codec is called without the data.");
      if (!codecOptions.table)
        throw new Error("Encoding '" + this.encodingName + "' has no data.");
      var mappingTable = codecOptions.table();
      this.decodeTables = [], this.decodeTables[0] = UNASSIGNED_NODE.slice(0), this.decodeTableSeq = [];
      for (var i2 = 0; i2 < mappingTable.length; i2++)
        this._addDecodeChunk(mappingTable[i2]);
      this.defaultCharUnicode = iconv.defaultCharUnicode, this.encodeTable = [], this.encodeTableSeq = [];
      var skipEncodeChars = {};
      if (codecOptions.encodeSkipVals)
        for (var i2 = 0; i2 < codecOptions.encodeSkipVals.length; i2++) {
          var val = codecOptions.encodeSkipVals[i2];
          if (typeof val == "number")
            skipEncodeChars[val] = !0;
          else
            for (var j = val.from; j <= val.to; j++)
              skipEncodeChars[j] = !0;
        }
      if (this._fillEncodeTable(0, 0, skipEncodeChars), codecOptions.encodeAdd)
        for (var uChar in codecOptions.encodeAdd)
          Object.prototype.hasOwnProperty.call(codecOptions.encodeAdd, uChar) && this._setEncodeChar(uChar.charCodeAt(0), codecOptions.encodeAdd[uChar]);
      if (this.defCharSB = this.encodeTable[0][iconv.defaultCharSingleByte.charCodeAt(0)], this.defCharSB === UNASSIGNED && (this.defCharSB = this.encodeTable[0]["?"]), this.defCharSB === UNASSIGNED && (this.defCharSB = 63), typeof codecOptions.gb18030 == "function") {
        this.gb18030 = codecOptions.gb18030();
        for (var thirdByteNodeIdx = this.decodeTables.length, thirdByteNode = this.decodeTables[thirdByteNodeIdx] = UNASSIGNED_NODE.slice(0), fourthByteNodeIdx = this.decodeTables.length, fourthByteNode = this.decodeTables[fourthByteNodeIdx] = UNASSIGNED_NODE.slice(0), i2 = 129; i2 <= 254; i2++)
          for (var secondByteNodeIdx = NODE_START - this.decodeTables[0][i2], secondByteNode = this.decodeTables[secondByteNodeIdx], j = 48; j <= 57; j++)
            secondByteNode[j] = NODE_START - thirdByteNodeIdx;
        for (var i2 = 129; i2 <= 254; i2++)
          thirdByteNode[i2] = NODE_START - fourthByteNodeIdx;
        for (var i2 = 48; i2 <= 57; i2++)
          fourthByteNode[i2] = GB18030_CODE;
      }
    }
    DBCSCodec.prototype.encoder = DBCSEncoder;
    DBCSCodec.prototype.decoder = DBCSDecoder;
    DBCSCodec.prototype._getDecodeTrieNode = function(addr) {
      for (var bytes = []; addr > 0; addr >>= 8)
        bytes.push(addr & 255);
      bytes.length == 0 && bytes.push(0);
      for (var node = this.decodeTables[0], i2 = bytes.length - 1; i2 > 0; i2--) {
        var val = node[bytes[i2]];
        if (val == UNASSIGNED)
          node[bytes[i2]] = NODE_START - this.decodeTables.length, this.decodeTables.push(node = UNASSIGNED_NODE.slice(0));
        else if (val <= NODE_START)
          node = this.decodeTables[NODE_START - val];
        else
          throw new Error("Overwrite byte in " + this.encodingName + ", addr: " + addr.toString(16));
      }
      return node;
    };
    DBCSCodec.prototype._addDecodeChunk = function(chunk) {
      var curAddr = parseInt(chunk[0], 16), writeTable = this._getDecodeTrieNode(curAddr);
      curAddr = curAddr & 255;
      for (var k = 1; k < chunk.length; k++) {
        var part = chunk[k];
        if (typeof part == "string")
          for (var l = 0; l < part.length; ) {
            var code = part.charCodeAt(l++);
            if (55296 <= code && code < 56320) {
              var codeTrail = part.charCodeAt(l++);
              if (56320 <= codeTrail && codeTrail < 57344)
                writeTable[curAddr++] = 65536 + (code - 55296) * 1024 + (codeTrail - 56320);
              else
                throw new Error("Incorrect surrogate pair in " + this.encodingName + " at chunk " + chunk[0]);
            } else if (4080 < code && code <= 4095) {
              for (var len = 4095 - code + 2, seq = [], m = 0; m < len; m++)
                seq.push(part.charCodeAt(l++));
              writeTable[curAddr++] = SEQ_START - this.decodeTableSeq.length, this.decodeTableSeq.push(seq);
            } else
              writeTable[curAddr++] = code;
          }
        else if (typeof part == "number")
          for (var charCode = writeTable[curAddr - 1] + 1, l = 0; l < part; l++)
            writeTable[curAddr++] = charCode++;
        else
          throw new Error("Incorrect type '" + typeof part + "' given in " + this.encodingName + " at chunk " + chunk[0]);
      }
      if (curAddr > 255)
        throw new Error("Incorrect chunk in " + this.encodingName + " at addr " + chunk[0] + ": too long" + curAddr);
    };
    DBCSCodec.prototype._getEncodeBucket = function(uCode) {
      var high = uCode >> 8;
      return this.encodeTable[high] === void 0 && (this.encodeTable[high] = UNASSIGNED_NODE.slice(0)), this.encodeTable[high];
    };
    DBCSCodec.prototype._setEncodeChar = function(uCode, dbcsCode) {
      var bucket = this._getEncodeBucket(uCode), low = uCode & 255;
      bucket[low] <= SEQ_START ? this.encodeTableSeq[SEQ_START - bucket[low]][DEF_CHAR] = dbcsCode : bucket[low] == UNASSIGNED && (bucket[low] = dbcsCode);
    };
    DBCSCodec.prototype._setEncodeSequence = function(seq, dbcsCode) {
      var uCode = seq[0], bucket = this._getEncodeBucket(uCode), low = uCode & 255, node;
      bucket[low] <= SEQ_START ? node = this.encodeTableSeq[SEQ_START - bucket[low]] : (node = {}, bucket[low] !== UNASSIGNED && (node[DEF_CHAR] = bucket[low]), bucket[low] = SEQ_START - this.encodeTableSeq.length, this.encodeTableSeq.push(node));
      for (var j = 1; j < seq.length - 1; j++) {
        var oldVal = node[uCode];
        typeof oldVal == "object" ? node = oldVal : (node = node[uCode] = {}, oldVal !== void 0 && (node[DEF_CHAR] = oldVal));
      }
      uCode = seq[seq.length - 1], node[uCode] = dbcsCode;
    };
    DBCSCodec.prototype._fillEncodeTable = function(nodeIdx, prefix, skipEncodeChars) {
      for (var node = this.decodeTables[nodeIdx], i2 = 0; i2 < 256; i2++) {
        var uCode = node[i2], mbCode = prefix + i2;
        skipEncodeChars[mbCode] || (uCode >= 0 ? this._setEncodeChar(uCode, mbCode) : uCode <= NODE_START ? this._fillEncodeTable(NODE_START - uCode, mbCode << 8, skipEncodeChars) : uCode <= SEQ_START && this._setEncodeSequence(this.decodeTableSeq[SEQ_START - uCode], mbCode));
      }
    };
    function DBCSEncoder(options, codec) {
      this.leadSurrogate = -1, this.seqObj = void 0, this.encodeTable = codec.encodeTable, this.encodeTableSeq = codec.encodeTableSeq, this.defaultCharSingleByte = codec.defCharSB, this.gb18030 = codec.gb18030;
    }
    DBCSEncoder.prototype.write = function(str) {
      for (var newBuf = Buffer2.alloc(str.length * (this.gb18030 ? 4 : 3)), leadSurrogate = this.leadSurrogate, seqObj = this.seqObj, nextChar = -1, i2 = 0, j = 0; ; ) {
        if (nextChar === -1) {
          if (i2 == str.length)
            break;
          var uCode = str.charCodeAt(i2++);
        } else {
          var uCode = nextChar;
          nextChar = -1;
        }
        if (55296 <= uCode && uCode < 57344)
          if (uCode < 56320)
            if (leadSurrogate === -1) {
              leadSurrogate = uCode;
              continue;
            } else
              leadSurrogate = uCode, uCode = UNASSIGNED;
          else
            leadSurrogate !== -1 ? (uCode = 65536 + (leadSurrogate - 55296) * 1024 + (uCode - 56320), leadSurrogate = -1) : uCode = UNASSIGNED;
        else
          leadSurrogate !== -1 && (nextChar = uCode, uCode = UNASSIGNED, leadSurrogate = -1);
        var dbcsCode = UNASSIGNED;
        if (seqObj !== void 0 && uCode != UNASSIGNED) {
          var resCode = seqObj[uCode];
          if (typeof resCode == "object") {
            seqObj = resCode;
            continue;
          } else
            typeof resCode == "number" ? dbcsCode = resCode : resCode == null && (resCode = seqObj[DEF_CHAR], resCode !== void 0 && (dbcsCode = resCode, nextChar = uCode));
          seqObj = void 0;
        } else if (uCode >= 0) {
          var subtable = this.encodeTable[uCode >> 8];
          if (subtable !== void 0 && (dbcsCode = subtable[uCode & 255]), dbcsCode <= SEQ_START) {
            seqObj = this.encodeTableSeq[SEQ_START - dbcsCode];
            continue;
          }
          if (dbcsCode == UNASSIGNED && this.gb18030) {
            var idx = findIdx(this.gb18030.uChars, uCode);
            if (idx != -1) {
              var dbcsCode = this.gb18030.gbChars[idx] + (uCode - this.gb18030.uChars[idx]);
              newBuf[j++] = 129 + Math.floor(dbcsCode / 12600), dbcsCode = dbcsCode % 12600, newBuf[j++] = 48 + Math.floor(dbcsCode / 1260), dbcsCode = dbcsCode % 1260, newBuf[j++] = 129 + Math.floor(dbcsCode / 10), dbcsCode = dbcsCode % 10, newBuf[j++] = 48 + dbcsCode;
              continue;
            }
          }
        }
        dbcsCode === UNASSIGNED && (dbcsCode = this.defaultCharSingleByte), dbcsCode < 256 ? newBuf[j++] = dbcsCode : dbcsCode < 65536 ? (newBuf[j++] = dbcsCode >> 8, newBuf[j++] = dbcsCode & 255) : (newBuf[j++] = dbcsCode >> 16, newBuf[j++] = dbcsCode >> 8 & 255, newBuf[j++] = dbcsCode & 255);
      }
      return this.seqObj = seqObj, this.leadSurrogate = leadSurrogate, newBuf.slice(0, j);
    };
    DBCSEncoder.prototype.end = function() {
      if (!(this.leadSurrogate === -1 && this.seqObj === void 0)) {
        var newBuf = Buffer2.alloc(10), j = 0;
        if (this.seqObj) {
          var dbcsCode = this.seqObj[DEF_CHAR];
          dbcsCode !== void 0 && (dbcsCode < 256 ? newBuf[j++] = dbcsCode : (newBuf[j++] = dbcsCode >> 8, newBuf[j++] = dbcsCode & 255)), this.seqObj = void 0;
        }
        return this.leadSurrogate !== -1 && (newBuf[j++] = this.defaultCharSingleByte, this.leadSurrogate = -1), newBuf.slice(0, j);
      }
    };
    DBCSEncoder.prototype.findIdx = findIdx;
    function DBCSDecoder(options, codec) {
      this.nodeIdx = 0, this.prevBuf = Buffer2.alloc(0), this.decodeTables = codec.decodeTables, this.decodeTableSeq = codec.decodeTableSeq, this.defaultCharUnicode = codec.defaultCharUnicode, this.gb18030 = codec.gb18030;
    }
    DBCSDecoder.prototype.write = function(buf) {
      var newBuf = Buffer2.alloc(buf.length * 2), nodeIdx = this.nodeIdx, prevBuf = this.prevBuf, prevBufOffset = this.prevBuf.length, seqStart = -this.prevBuf.length, uCode;
      prevBufOffset > 0 && (prevBuf = Buffer2.concat([prevBuf, buf.slice(0, 10)]));
      for (var i2 = 0, j = 0; i2 < buf.length; i2++) {
        var curByte = i2 >= 0 ? buf[i2] : prevBuf[i2 + prevBufOffset], uCode = this.decodeTables[nodeIdx][curByte];
        if (!(uCode >= 0))
          if (uCode === UNASSIGNED)
            i2 = seqStart, uCode = this.defaultCharUnicode.charCodeAt(0);
          else if (uCode === GB18030_CODE) {
            var curSeq = seqStart >= 0 ? buf.slice(seqStart, i2 + 1) : prevBuf.slice(seqStart + prevBufOffset, i2 + 1 + prevBufOffset), ptr = (curSeq[0] - 129) * 12600 + (curSeq[1] - 48) * 1260 + (curSeq[2] - 129) * 10 + (curSeq[3] - 48), idx = findIdx(this.gb18030.gbChars, ptr);
            uCode = this.gb18030.uChars[idx] + ptr - this.gb18030.gbChars[idx];
          } else if (uCode <= NODE_START) {
            nodeIdx = NODE_START - uCode;
            continue;
          } else if (uCode <= SEQ_START) {
            for (var seq = this.decodeTableSeq[SEQ_START - uCode], k = 0; k < seq.length - 1; k++)
              uCode = seq[k], newBuf[j++] = uCode & 255, newBuf[j++] = uCode >> 8;
            uCode = seq[seq.length - 1];
          } else
            throw new Error("iconv-lite internal error: invalid decoding table value " + uCode + " at " + nodeIdx + "/" + curByte);
        if (uCode > 65535) {
          uCode -= 65536;
          var uCodeLead = 55296 + Math.floor(uCode / 1024);
          newBuf[j++] = uCodeLead & 255, newBuf[j++] = uCodeLead >> 8, uCode = 56320 + uCode % 1024;
        }
        newBuf[j++] = uCode & 255, newBuf[j++] = uCode >> 8, nodeIdx = 0, seqStart = i2 + 1;
      }
      return this.nodeIdx = nodeIdx, this.prevBuf = seqStart >= 0 ? buf.slice(seqStart) : prevBuf.slice(seqStart + prevBufOffset), newBuf.slice(0, j).toString("ucs2");
    };
    DBCSDecoder.prototype.end = function() {
      for (var ret = ""; this.prevBuf.length > 0; ) {
        ret += this.defaultCharUnicode;
        var buf = this.prevBuf.slice(1);
        this.prevBuf = Buffer2.alloc(0), this.nodeIdx = 0, buf.length > 0 && (ret += this.write(buf));
      }
      return this.nodeIdx = 0, ret;
    };
    function findIdx(table, val) {
      if (table[0] > val)
        return -1;
      for (var l = 0, r2 = table.length; l < r2 - 1; ) {
        var mid = l + Math.floor((r2 - l + 1) / 2);
        table[mid] <= val ? l = mid : r2 = mid;
      }
      return l;
    }
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/tables/shiftjis.json
var require_shiftjis = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/tables/shiftjis.json"(exports, module) {
    module.exports = [
      ["0", "\0", 128],
      ["a1", "\uFF61", 62],
      ["8140", "\u3000\u3001\u3002\uFF0C\uFF0E\u30FB\uFF1A\uFF1B\uFF1F\uFF01\u309B\u309C\xB4\uFF40\xA8\uFF3E\uFFE3\uFF3F\u30FD\u30FE\u309D\u309E\u3003\u4EDD\u3005\u3006\u3007\u30FC\u2015\u2010\uFF0F\uFF3C\uFF5E\u2225\uFF5C\u2026\u2025\u2018\u2019\u201C\u201D\uFF08\uFF09\u3014\u3015\uFF3B\uFF3D\uFF5B\uFF5D\u3008", 9, "\uFF0B\uFF0D\xB1\xD7"],
      ["8180", "\xF7\uFF1D\u2260\uFF1C\uFF1E\u2266\u2267\u221E\u2234\u2642\u2640\xB0\u2032\u2033\u2103\uFFE5\uFF04\uFFE0\uFFE1\uFF05\uFF03\uFF06\uFF0A\uFF20\xA7\u2606\u2605\u25CB\u25CF\u25CE\u25C7\u25C6\u25A1\u25A0\u25B3\u25B2\u25BD\u25BC\u203B\u3012\u2192\u2190\u2191\u2193\u3013"],
      ["81b8", "\u2208\u220B\u2286\u2287\u2282\u2283\u222A\u2229"],
      ["81c8", "\u2227\u2228\uFFE2\u21D2\u21D4\u2200\u2203"],
      ["81da", "\u2220\u22A5\u2312\u2202\u2207\u2261\u2252\u226A\u226B\u221A\u223D\u221D\u2235\u222B\u222C"],
      ["81f0", "\u212B\u2030\u266F\u266D\u266A\u2020\u2021\xB6"],
      ["81fc", "\u25EF"],
      ["824f", "\uFF10", 9],
      ["8260", "\uFF21", 25],
      ["8281", "\uFF41", 25],
      ["829f", "\u3041", 82],
      ["8340", "\u30A1", 62],
      ["8380", "\u30E0", 22],
      ["839f", "\u0391", 16, "\u03A3", 6],
      ["83bf", "\u03B1", 16, "\u03C3", 6],
      ["8440", "\u0410", 5, "\u0401\u0416", 25],
      ["8470", "\u0430", 5, "\u0451\u0436", 7],
      ["8480", "\u043E", 17],
      ["849f", "\u2500\u2502\u250C\u2510\u2518\u2514\u251C\u252C\u2524\u2534\u253C\u2501\u2503\u250F\u2513\u251B\u2517\u2523\u2533\u252B\u253B\u254B\u2520\u252F\u2528\u2537\u253F\u251D\u2530\u2525\u2538\u2542"],
      ["8740", "\u2460", 19, "\u2160", 9],
      ["875f", "\u3349\u3314\u3322\u334D\u3318\u3327\u3303\u3336\u3351\u3357\u330D\u3326\u3323\u332B\u334A\u333B\u339C\u339D\u339E\u338E\u338F\u33C4\u33A1"],
      ["877e", "\u337B"],
      ["8780", "\u301D\u301F\u2116\u33CD\u2121\u32A4", 4, "\u3231\u3232\u3239\u337E\u337D\u337C\u2252\u2261\u222B\u222E\u2211\u221A\u22A5\u2220\u221F\u22BF\u2235\u2229\u222A"],
      ["889f", "\u4E9C\u5516\u5A03\u963F\u54C0\u611B\u6328\u59F6\u9022\u8475\u831C\u7A50\u60AA\u63E1\u6E25\u65ED\u8466\u82A6\u9BF5\u6893\u5727\u65A1\u6271\u5B9B\u59D0\u867B\u98F4\u7D62\u7DBE\u9B8E\u6216\u7C9F\u88B7\u5B89\u5EB5\u6309\u6697\u6848\u95C7\u978D\u674F\u4EE5\u4F0A\u4F4D\u4F9D\u5049\u56F2\u5937\u59D4\u5A01\u5C09\u60DF\u610F\u6170\u6613\u6905\u70BA\u754F\u7570\u79FB\u7DAD\u7DEF\u80C3\u840E\u8863\u8B02\u9055\u907A\u533B\u4E95\u4EA5\u57DF\u80B2\u90C1\u78EF\u4E00\u58F1\u6EA2\u9038\u7A32\u8328\u828B\u9C2F\u5141\u5370\u54BD\u54E1\u56E0\u59FB\u5F15\u98F2\u6DEB\u80E4\u852D"],
      ["8940", "\u9662\u9670\u96A0\u97FB\u540B\u53F3\u5B87\u70CF\u7FBD\u8FC2\u96E8\u536F\u9D5C\u7ABA\u4E11\u7893\u81FC\u6E26\u5618\u5504\u6B1D\u851A\u9C3B\u59E5\u53A9\u6D66\u74DC\u958F\u5642\u4E91\u904B\u96F2\u834F\u990C\u53E1\u55B6\u5B30\u5F71\u6620\u66F3\u6804\u6C38\u6CF3\u6D29\u745B\u76C8\u7A4E\u9834\u82F1\u885B\u8A60\u92ED\u6DB2\u75AB\u76CA\u99C5\u60A6\u8B01\u8D8A\u95B2\u698E\u53AD\u5186"],
      ["8980", "\u5712\u5830\u5944\u5BB4\u5EF6\u6028\u63A9\u63F4\u6CBF\u6F14\u708E\u7114\u7159\u71D5\u733F\u7E01\u8276\u82D1\u8597\u9060\u925B\u9D1B\u5869\u65BC\u6C5A\u7525\u51F9\u592E\u5965\u5F80\u5FDC\u62BC\u65FA\u6A2A\u6B27\u6BB4\u738B\u7FC1\u8956\u9D2C\u9D0E\u9EC4\u5CA1\u6C96\u837B\u5104\u5C4B\u61B6\u81C6\u6876\u7261\u4E59\u4FFA\u5378\u6069\u6E29\u7A4F\u97F3\u4E0B\u5316\u4EEE\u4F55\u4F3D\u4FA1\u4F73\u52A0\u53EF\u5609\u590F\u5AC1\u5BB6\u5BE1\u79D1\u6687\u679C\u67B6\u6B4C\u6CB3\u706B\u73C2\u798D\u79BE\u7A3C\u7B87\u82B1\u82DB\u8304\u8377\u83EF\u83D3\u8766\u8AB2\u5629\u8CA8\u8FE6\u904E\u971E\u868A\u4FC4\u5CE8\u6211\u7259\u753B\u81E5\u82BD\u86FE\u8CC0\u96C5\u9913\u99D5\u4ECB\u4F1A\u89E3\u56DE\u584A\u58CA\u5EFB\u5FEB\u602A\u6094\u6062\u61D0\u6212\u62D0\u6539"],
      ["8a40", "\u9B41\u6666\u68B0\u6D77\u7070\u754C\u7686\u7D75\u82A5\u87F9\u958B\u968E\u8C9D\u51F1\u52BE\u5916\u54B3\u5BB3\u5D16\u6168\u6982\u6DAF\u788D\u84CB\u8857\u8A72\u93A7\u9AB8\u6D6C\u99A8\u86D9\u57A3\u67FF\u86CE\u920E\u5283\u5687\u5404\u5ED3\u62E1\u64B9\u683C\u6838\u6BBB\u7372\u78BA\u7A6B\u899A\u89D2\u8D6B\u8F03\u90ED\u95A3\u9694\u9769\u5B66\u5CB3\u697D\u984D\u984E\u639B\u7B20\u6A2B"],
      ["8a80", "\u6A7F\u68B6\u9C0D\u6F5F\u5272\u559D\u6070\u62EC\u6D3B\u6E07\u6ED1\u845B\u8910\u8F44\u4E14\u9C39\u53F6\u691B\u6A3A\u9784\u682A\u515C\u7AC3\u84B2\u91DC\u938C\u565B\u9D28\u6822\u8305\u8431\u7CA5\u5208\u82C5\u74E6\u4E7E\u4F83\u51A0\u5BD2\u520A\u52D8\u52E7\u5DFB\u559A\u582A\u59E6\u5B8C\u5B98\u5BDB\u5E72\u5E79\u60A3\u611F\u6163\u61BE\u63DB\u6562\u67D1\u6853\u68FA\u6B3E\u6B53\u6C57\u6F22\u6F97\u6F45\u74B0\u7518\u76E3\u770B\u7AFF\u7BA1\u7C21\u7DE9\u7F36\u7FF0\u809D\u8266\u839E\u89B3\u8ACC\u8CAB\u9084\u9451\u9593\u9591\u95A2\u9665\u97D3\u9928\u8218\u4E38\u542B\u5CB8\u5DCC\u73A9\u764C\u773C\u5CA9\u7FEB\u8D0B\u96C1\u9811\u9854\u9858\u4F01\u4F0E\u5371\u559C\u5668\u57FA\u5947\u5B09\u5BC4\u5C90\u5E0C\u5E7E\u5FCC\u63EE\u673A\u65D7\u65E2\u671F\u68CB\u68C4"],
      ["8b40", "\u6A5F\u5E30\u6BC5\u6C17\u6C7D\u757F\u7948\u5B63\u7A00\u7D00\u5FBD\u898F\u8A18\u8CB4\u8D77\u8ECC\u8F1D\u98E2\u9A0E\u9B3C\u4E80\u507D\u5100\u5993\u5B9C\u622F\u6280\u64EC\u6B3A\u72A0\u7591\u7947\u7FA9\u87FB\u8ABC\u8B70\u63AC\u83CA\u97A0\u5409\u5403\u55AB\u6854\u6A58\u8A70\u7827\u6775\u9ECD\u5374\u5BA2\u811A\u8650\u9006\u4E18\u4E45\u4EC7\u4F11\u53CA\u5438\u5BAE\u5F13\u6025\u6551"],
      ["8b80", "\u673D\u6C42\u6C72\u6CE3\u7078\u7403\u7A76\u7AAE\u7B08\u7D1A\u7CFE\u7D66\u65E7\u725B\u53BB\u5C45\u5DE8\u62D2\u62E0\u6319\u6E20\u865A\u8A31\u8DDD\u92F8\u6F01\u79A6\u9B5A\u4EA8\u4EAB\u4EAC\u4F9B\u4FA0\u50D1\u5147\u7AF6\u5171\u51F6\u5354\u5321\u537F\u53EB\u55AC\u5883\u5CE1\u5F37\u5F4A\u602F\u6050\u606D\u631F\u6559\u6A4B\u6CC1\u72C2\u72ED\u77EF\u80F8\u8105\u8208\u854E\u90F7\u93E1\u97FF\u9957\u9A5A\u4EF0\u51DD\u5C2D\u6681\u696D\u5C40\u66F2\u6975\u7389\u6850\u7C81\u50C5\u52E4\u5747\u5DFE\u9326\u65A4\u6B23\u6B3D\u7434\u7981\u79BD\u7B4B\u7DCA\u82B9\u83CC\u887F\u895F\u8B39\u8FD1\u91D1\u541F\u9280\u4E5D\u5036\u53E5\u533A\u72D7\u7396\u77E9\u82E6\u8EAF\u99C6\u99C8\u99D2\u5177\u611A\u865E\u55B0\u7A7A\u5076\u5BD3\u9047\u9685\u4E32\u6ADB\u91E7\u5C51\u5C48"],
      ["8c40", "\u6398\u7A9F\u6C93\u9774\u8F61\u7AAA\u718A\u9688\u7C82\u6817\u7E70\u6851\u936C\u52F2\u541B\u85AB\u8A13\u7FA4\u8ECD\u90E1\u5366\u8888\u7941\u4FC2\u50BE\u5211\u5144\u5553\u572D\u73EA\u578B\u5951\u5F62\u5F84\u6075\u6176\u6167\u61A9\u63B2\u643A\u656C\u666F\u6842\u6E13\u7566\u7A3D\u7CFB\u7D4C\u7D99\u7E4B\u7F6B\u830E\u834A\u86CD\u8A08\u8A63\u8B66\u8EFD\u981A\u9D8F\u82B8\u8FCE\u9BE8"],
      ["8c80", "\u5287\u621F\u6483\u6FC0\u9699\u6841\u5091\u6B20\u6C7A\u6F54\u7A74\u7D50\u8840\u8A23\u6708\u4EF6\u5039\u5026\u5065\u517C\u5238\u5263\u55A7\u570F\u5805\u5ACC\u5EFA\u61B2\u61F8\u62F3\u6372\u691C\u6A29\u727D\u72AC\u732E\u7814\u786F\u7D79\u770C\u80A9\u898B\u8B19\u8CE2\u8ED2\u9063\u9375\u967A\u9855\u9A13\u9E78\u5143\u539F\u53B3\u5E7B\u5F26\u6E1B\u6E90\u7384\u73FE\u7D43\u8237\u8A00\u8AFA\u9650\u4E4E\u500B\u53E4\u547C\u56FA\u59D1\u5B64\u5DF1\u5EAB\u5F27\u6238\u6545\u67AF\u6E56\u72D0\u7CCA\u88B4\u80A1\u80E1\u83F0\u864E\u8A87\u8DE8\u9237\u96C7\u9867\u9F13\u4E94\u4E92\u4F0D\u5348\u5449\u543E\u5A2F\u5F8C\u5FA1\u609F\u68A7\u6A8E\u745A\u7881\u8A9E\u8AA4\u8B77\u9190\u4E5E\u9BC9\u4EA4\u4F7C\u4FAF\u5019\u5016\u5149\u516C\u529F\u52B9\u52FE\u539A\u53E3\u5411"],
      ["8d40", "\u540E\u5589\u5751\u57A2\u597D\u5B54\u5B5D\u5B8F\u5DE5\u5DE7\u5DF7\u5E78\u5E83\u5E9A\u5EB7\u5F18\u6052\u614C\u6297\u62D8\u63A7\u653B\u6602\u6643\u66F4\u676D\u6821\u6897\u69CB\u6C5F\u6D2A\u6D69\u6E2F\u6E9D\u7532\u7687\u786C\u7A3F\u7CE0\u7D05\u7D18\u7D5E\u7DB1\u8015\u8003\u80AF\u80B1\u8154\u818F\u822A\u8352\u884C\u8861\u8B1B\u8CA2\u8CFC\u90CA\u9175\u9271\u783F\u92FC\u95A4\u964D"],
      ["8d80", "\u9805\u9999\u9AD8\u9D3B\u525B\u52AB\u53F7\u5408\u58D5\u62F7\u6FE0\u8C6A\u8F5F\u9EB9\u514B\u523B\u544A\u56FD\u7A40\u9177\u9D60\u9ED2\u7344\u6F09\u8170\u7511\u5FFD\u60DA\u9AA8\u72DB\u8FBC\u6B64\u9803\u4ECA\u56F0\u5764\u58BE\u5A5A\u6068\u61C7\u660F\u6606\u6839\u68B1\u6DF7\u75D5\u7D3A\u826E\u9B42\u4E9B\u4F50\u53C9\u5506\u5D6F\u5DE6\u5DEE\u67FB\u6C99\u7473\u7802\u8A50\u9396\u88DF\u5750\u5EA7\u632B\u50B5\u50AC\u518D\u6700\u54C9\u585E\u59BB\u5BB0\u5F69\u624D\u63A1\u683D\u6B73\u6E08\u707D\u91C7\u7280\u7815\u7826\u796D\u658E\u7D30\u83DC\u88C1\u8F09\u969B\u5264\u5728\u6750\u7F6A\u8CA1\u51B4\u5742\u962A\u583A\u698A\u80B4\u54B2\u5D0E\u57FC\u7895\u9DFA\u4F5C\u524A\u548B\u643E\u6628\u6714\u67F5\u7A84\u7B56\u7D22\u932F\u685C\u9BAD\u7B39\u5319\u518A\u5237"],
      ["8e40", "\u5BDF\u62F6\u64AE\u64E6\u672D\u6BBA\u85A9\u96D1\u7690\u9BD6\u634C\u9306\u9BAB\u76BF\u6652\u4E09\u5098\u53C2\u5C71\u60E8\u6492\u6563\u685F\u71E6\u73CA\u7523\u7B97\u7E82\u8695\u8B83\u8CDB\u9178\u9910\u65AC\u66AB\u6B8B\u4ED5\u4ED4\u4F3A\u4F7F\u523A\u53F8\u53F2\u55E3\u56DB\u58EB\u59CB\u59C9\u59FF\u5B50\u5C4D\u5E02\u5E2B\u5FD7\u601D\u6307\u652F\u5B5C\u65AF\u65BD\u65E8\u679D\u6B62"],
      ["8e80", "\u6B7B\u6C0F\u7345\u7949\u79C1\u7CF8\u7D19\u7D2B\u80A2\u8102\u81F3\u8996\u8A5E\u8A69\u8A66\u8A8C\u8AEE\u8CC7\u8CDC\u96CC\u98FC\u6B6F\u4E8B\u4F3C\u4F8D\u5150\u5B57\u5BFA\u6148\u6301\u6642\u6B21\u6ECB\u6CBB\u723E\u74BD\u75D4\u78C1\u793A\u800C\u8033\u81EA\u8494\u8F9E\u6C50\u9E7F\u5F0F\u8B58\u9D2B\u7AFA\u8EF8\u5B8D\u96EB\u4E03\u53F1\u57F7\u5931\u5AC9\u5BA4\u6089\u6E7F\u6F06\u75BE\u8CEA\u5B9F\u8500\u7BE0\u5072\u67F4\u829D\u5C61\u854A\u7E1E\u820E\u5199\u5C04\u6368\u8D66\u659C\u716E\u793E\u7D17\u8005\u8B1D\u8ECA\u906E\u86C7\u90AA\u501F\u52FA\u5C3A\u6753\u707C\u7235\u914C\u91C8\u932B\u82E5\u5BC2\u5F31\u60F9\u4E3B\u53D6\u5B88\u624B\u6731\u6B8A\u72E9\u73E0\u7A2E\u816B\u8DA3\u9152\u9996\u5112\u53D7\u546A\u5BFF\u6388\u6A39\u7DAC\u9700\u56DA\u53CE\u5468"],
      ["8f40", "\u5B97\u5C31\u5DDE\u4FEE\u6101\u62FE\u6D32\u79C0\u79CB\u7D42\u7E4D\u7FD2\u81ED\u821F\u8490\u8846\u8972\u8B90\u8E74\u8F2F\u9031\u914B\u916C\u96C6\u919C\u4EC0\u4F4F\u5145\u5341\u5F93\u620E\u67D4\u6C41\u6E0B\u7363\u7E26\u91CD\u9283\u53D4\u5919\u5BBF\u6DD1\u795D\u7E2E\u7C9B\u587E\u719F\u51FA\u8853\u8FF0\u4FCA\u5CFB\u6625\u77AC\u7AE3\u821C\u99FF\u51C6\u5FAA\u65EC\u696F\u6B89\u6DF3"],
      ["8f80", "\u6E96\u6F64\u76FE\u7D14\u5DE1\u9075\u9187\u9806\u51E6\u521D\u6240\u6691\u66D9\u6E1A\u5EB6\u7DD2\u7F72\u66F8\u85AF\u85F7\u8AF8\u52A9\u53D9\u5973\u5E8F\u5F90\u6055\u92E4\u9664\u50B7\u511F\u52DD\u5320\u5347\u53EC\u54E8\u5546\u5531\u5617\u5968\u59BE\u5A3C\u5BB5\u5C06\u5C0F\u5C11\u5C1A\u5E84\u5E8A\u5EE0\u5F70\u627F\u6284\u62DB\u638C\u6377\u6607\u660C\u662D\u6676\u677E\u68A2\u6A1F\u6A35\u6CBC\u6D88\u6E09\u6E58\u713C\u7126\u7167\u75C7\u7701\u785D\u7901\u7965\u79F0\u7AE0\u7B11\u7CA7\u7D39\u8096\u83D6\u848B\u8549\u885D\u88F3\u8A1F\u8A3C\u8A54\u8A73\u8C61\u8CDE\u91A4\u9266\u937E\u9418\u969C\u9798\u4E0A\u4E08\u4E1E\u4E57\u5197\u5270\u57CE\u5834\u58CC\u5B22\u5E38\u60C5\u64FE\u6761\u6756\u6D44\u72B6\u7573\u7A63\u84B8\u8B72\u91B8\u9320\u5631\u57F4\u98FE"],
      ["9040", "\u62ED\u690D\u6B96\u71ED\u7E54\u8077\u8272\u89E6\u98DF\u8755\u8FB1\u5C3B\u4F38\u4FE1\u4FB5\u5507\u5A20\u5BDD\u5BE9\u5FC3\u614E\u632F\u65B0\u664B\u68EE\u699B\u6D78\u6DF1\u7533\u75B9\u771F\u795E\u79E6\u7D33\u81E3\u82AF\u85AA\u89AA\u8A3A\u8EAB\u8F9B\u9032\u91DD\u9707\u4EBA\u4EC1\u5203\u5875\u58EC\u5C0B\u751A\u5C3D\u814E\u8A0A\u8FC5\u9663\u976D\u7B25\u8ACF\u9808\u9162\u56F3\u53A8"],
      ["9080", "\u9017\u5439\u5782\u5E25\u63A8\u6C34\u708A\u7761\u7C8B\u7FE0\u8870\u9042\u9154\u9310\u9318\u968F\u745E\u9AC4\u5D07\u5D69\u6570\u67A2\u8DA8\u96DB\u636E\u6749\u6919\u83C5\u9817\u96C0\u88FE\u6F84\u647A\u5BF8\u4E16\u702C\u755D\u662F\u51C4\u5236\u52E2\u59D3\u5F81\u6027\u6210\u653F\u6574\u661F\u6674\u68F2\u6816\u6B63\u6E05\u7272\u751F\u76DB\u7CBE\u8056\u58F0\u88FD\u897F\u8AA0\u8A93\u8ACB\u901D\u9192\u9752\u9759\u6589\u7A0E\u8106\u96BB\u5E2D\u60DC\u621A\u65A5\u6614\u6790\u77F3\u7A4D\u7C4D\u7E3E\u810A\u8CAC\u8D64\u8DE1\u8E5F\u78A9\u5207\u62D9\u63A5\u6442\u6298\u8A2D\u7A83\u7BC0\u8AAC\u96EA\u7D76\u820C\u8749\u4ED9\u5148\u5343\u5360\u5BA3\u5C02\u5C16\u5DDD\u6226\u6247\u64B0\u6813\u6834\u6CC9\u6D45\u6D17\u67D3\u6F5C\u714E\u717D\u65CB\u7A7F\u7BAD\u7DDA"],
      ["9140", "\u7E4A\u7FA8\u817A\u821B\u8239\u85A6\u8A6E\u8CCE\u8DF5\u9078\u9077\u92AD\u9291\u9583\u9BAE\u524D\u5584\u6F38\u7136\u5168\u7985\u7E55\u81B3\u7CCE\u564C\u5851\u5CA8\u63AA\u66FE\u66FD\u695A\u72D9\u758F\u758E\u790E\u7956\u79DF\u7C97\u7D20\u7D44\u8607\u8A34\u963B\u9061\u9F20\u50E7\u5275\u53CC\u53E2\u5009\u55AA\u58EE\u594F\u723D\u5B8B\u5C64\u531D\u60E3\u60F3\u635C\u6383\u633F\u63BB"],
      ["9180", "\u64CD\u65E9\u66F9\u5DE3\u69CD\u69FD\u6F15\u71E5\u4E89\u75E9\u76F8\u7A93\u7CDF\u7DCF\u7D9C\u8061\u8349\u8358\u846C\u84BC\u85FB\u88C5\u8D70\u9001\u906D\u9397\u971C\u9A12\u50CF\u5897\u618E\u81D3\u8535\u8D08\u9020\u4FC3\u5074\u5247\u5373\u606F\u6349\u675F\u6E2C\u8DB3\u901F\u4FD7\u5C5E\u8CCA\u65CF\u7D9A\u5352\u8896\u5176\u63C3\u5B58\u5B6B\u5C0A\u640D\u6751\u905C\u4ED6\u591A\u592A\u6C70\u8A51\u553E\u5815\u59A5\u60F0\u6253\u67C1\u8235\u6955\u9640\u99C4\u9A28\u4F53\u5806\u5BFE\u8010\u5CB1\u5E2F\u5F85\u6020\u614B\u6234\u66FF\u6CF0\u6EDE\u80CE\u817F\u82D4\u888B\u8CB8\u9000\u902E\u968A\u9EDB\u9BDB\u4EE3\u53F0\u5927\u7B2C\u918D\u984C\u9DF9\u6EDD\u7027\u5353\u5544\u5B85\u6258\u629E\u62D3\u6CA2\u6FEF\u7422\u8A17\u9438\u6FC1\u8AFE\u8338\u51E7\u86F8\u53EA"],
      ["9240", "\u53E9\u4F46\u9054\u8FB0\u596A\u8131\u5DFD\u7AEA\u8FBF\u68DA\u8C37\u72F8\u9C48\u6A3D\u8AB0\u4E39\u5358\u5606\u5766\u62C5\u63A2\u65E6\u6B4E\u6DE1\u6E5B\u70AD\u77ED\u7AEF\u7BAA\u7DBB\u803D\u80C6\u86CB\u8A95\u935B\u56E3\u58C7\u5F3E\u65AD\u6696\u6A80\u6BB5\u7537\u8AC7\u5024\u77E5\u5730\u5F1B\u6065\u667A\u6C60\u75F4\u7A1A\u7F6E\u81F4\u8718\u9045\u99B3\u7BC9\u755C\u7AF9\u7B51\u84C4"],
      ["9280", "\u9010\u79E9\u7A92\u8336\u5AE1\u7740\u4E2D\u4EF2\u5B99\u5FE0\u62BD\u663C\u67F1\u6CE8\u866B\u8877\u8A3B\u914E\u92F3\u99D0\u6A17\u7026\u732A\u82E7\u8457\u8CAF\u4E01\u5146\u51CB\u558B\u5BF5\u5E16\u5E33\u5E81\u5F14\u5F35\u5F6B\u5FB4\u61F2\u6311\u66A2\u671D\u6F6E\u7252\u753A\u773A\u8074\u8139\u8178\u8776\u8ABF\u8ADC\u8D85\u8DF3\u929A\u9577\u9802\u9CE5\u52C5\u6357\u76F4\u6715\u6C88\u73CD\u8CC3\u93AE\u9673\u6D25\u589C\u690E\u69CC\u8FFD\u939A\u75DB\u901A\u585A\u6802\u63B4\u69FB\u4F43\u6F2C\u67D8\u8FBB\u8526\u7DB4\u9354\u693F\u6F70\u576A\u58F7\u5B2C\u7D2C\u722A\u540A\u91E3\u9DB4\u4EAD\u4F4E\u505C\u5075\u5243\u8C9E\u5448\u5824\u5B9A\u5E1D\u5E95\u5EAD\u5EF7\u5F1F\u608C\u62B5\u633A\u63D0\u68AF\u6C40\u7887\u798E\u7A0B\u7DE0\u8247\u8A02\u8AE6\u8E44\u9013"],
      ["9340", "\u90B8\u912D\u91D8\u9F0E\u6CE5\u6458\u64E2\u6575\u6EF4\u7684\u7B1B\u9069\u93D1\u6EBA\u54F2\u5FB9\u64A4\u8F4D\u8FED\u9244\u5178\u586B\u5929\u5C55\u5E97\u6DFB\u7E8F\u751C\u8CBC\u8EE2\u985B\u70B9\u4F1D\u6BBF\u6FB1\u7530\u96FB\u514E\u5410\u5835\u5857\u59AC\u5C60\u5F92\u6597\u675C\u6E21\u767B\u83DF\u8CED\u9014\u90FD\u934D\u7825\u783A\u52AA\u5EA6\u571F\u5974\u6012\u5012\u515A\u51AC"],
      ["9380", "\u51CD\u5200\u5510\u5854\u5858\u5957\u5B95\u5CF6\u5D8B\u60BC\u6295\u642D\u6771\u6843\u68BC\u68DF\u76D7\u6DD8\u6E6F\u6D9B\u706F\u71C8\u5F53\u75D8\u7977\u7B49\u7B54\u7B52\u7CD6\u7D71\u5230\u8463\u8569\u85E4\u8A0E\u8B04\u8C46\u8E0F\u9003\u900F\u9419\u9676\u982D\u9A30\u95D8\u50CD\u52D5\u540C\u5802\u5C0E\u61A7\u649E\u6D1E\u77B3\u7AE5\u80F4\u8404\u9053\u9285\u5CE0\u9D07\u533F\u5F97\u5FB3\u6D9C\u7279\u7763\u79BF\u7BE4\u6BD2\u72EC\u8AAD\u6803\u6A61\u51F8\u7A81\u6934\u5C4A\u9CF6\u82EB\u5BC5\u9149\u701E\u5678\u5C6F\u60C7\u6566\u6C8C\u8C5A\u9041\u9813\u5451\u66C7\u920D\u5948\u90A3\u5185\u4E4D\u51EA\u8599\u8B0E\u7058\u637A\u934B\u6962\u99B4\u7E04\u7577\u5357\u6960\u8EDF\u96E3\u6C5D\u4E8C\u5C3C\u5F10\u8FE9\u5302\u8CD1\u8089\u8679\u5EFF\u65E5\u4E73\u5165"],
      ["9440", "\u5982\u5C3F\u97EE\u4EFB\u598A\u5FCD\u8A8D\u6FE1\u79B0\u7962\u5BE7\u8471\u732B\u71B1\u5E74\u5FF5\u637B\u649A\u71C3\u7C98\u4E43\u5EFC\u4E4B\u57DC\u56A2\u60A9\u6FC3\u7D0D\u80FD\u8133\u81BF\u8FB2\u8997\u86A4\u5DF4\u628A\u64AD\u8987\u6777\u6CE2\u6D3E\u7436\u7834\u5A46\u7F75\u82AD\u99AC\u4FF3\u5EC3\u62DD\u6392\u6557\u676F\u76C3\u724C\u80CC\u80BA\u8F29\u914D\u500D\u57F9\u5A92\u6885"],
      ["9480", "\u6973\u7164\u72FD\u8CB7\u58F2\u8CE0\u966A\u9019\u877F\u79E4\u77E7\u8429\u4F2F\u5265\u535A\u62CD\u67CF\u6CCA\u767D\u7B94\u7C95\u8236\u8584\u8FEB\u66DD\u6F20\u7206\u7E1B\u83AB\u99C1\u9EA6\u51FD\u7BB1\u7872\u7BB8\u8087\u7B48\u6AE8\u5E61\u808C\u7551\u7560\u516B\u9262\u6E8C\u767A\u9197\u9AEA\u4F10\u7F70\u629C\u7B4F\u95A5\u9CE9\u567A\u5859\u86E4\u96BC\u4F34\u5224\u534A\u53CD\u53DB\u5E06\u642C\u6591\u677F\u6C3E\u6C4E\u7248\u72AF\u73ED\u7554\u7E41\u822C\u85E9\u8CA9\u7BC4\u91C6\u7169\u9812\u98EF\u633D\u6669\u756A\u76E4\u78D0\u8543\u86EE\u532A\u5351\u5426\u5983\u5E87\u5F7C\u60B2\u6249\u6279\u62AB\u6590\u6BD4\u6CCC\u75B2\u76AE\u7891\u79D8\u7DCB\u7F77\u80A5\u88AB\u8AB9\u8CBB\u907F\u975E\u98DB\u6A0B\u7C38\u5099\u5C3E\u5FAE\u6787\u6BD8\u7435\u7709\u7F8E"],
      ["9540", "\u9F3B\u67CA\u7A17\u5339\u758B\u9AED\u5F66\u819D\u83F1\u8098\u5F3C\u5FC5\u7562\u7B46\u903C\u6867\u59EB\u5A9B\u7D10\u767E\u8B2C\u4FF5\u5F6A\u6A19\u6C37\u6F02\u74E2\u7968\u8868\u8A55\u8C79\u5EDF\u63CF\u75C5\u79D2\u82D7\u9328\u92F2\u849C\u86ED\u9C2D\u54C1\u5F6C\u658C\u6D5C\u7015\u8CA7\u8CD3\u983B\u654F\u74F6\u4E0D\u4ED8\u57E0\u592B\u5A66\u5BCC\u51A8\u5E03\u5E9C\u6016\u6276\u6577"],
      ["9580", "\u65A7\u666E\u6D6E\u7236\u7B26\u8150\u819A\u8299\u8B5C\u8CA0\u8CE6\u8D74\u961C\u9644\u4FAE\u64AB\u6B66\u821E\u8461\u856A\u90E8\u5C01\u6953\u98A8\u847A\u8557\u4F0F\u526F\u5FA9\u5E45\u670D\u798F\u8179\u8907\u8986\u6DF5\u5F17\u6255\u6CB8\u4ECF\u7269\u9B92\u5206\u543B\u5674\u58B3\u61A4\u626E\u711A\u596E\u7C89\u7CDE\u7D1B\u96F0\u6587\u805E\u4E19\u4F75\u5175\u5840\u5E63\u5E73\u5F0A\u67C4\u4E26\u853D\u9589\u965B\u7C73\u9801\u50FB\u58C1\u7656\u78A7\u5225\u77A5\u8511\u7B86\u504F\u5909\u7247\u7BC7\u7DE8\u8FBA\u8FD4\u904D\u4FBF\u52C9\u5A29\u5F01\u97AD\u4FDD\u8217\u92EA\u5703\u6355\u6B69\u752B\u88DC\u8F14\u7A42\u52DF\u5893\u6155\u620A\u66AE\u6BCD\u7C3F\u83E9\u5023\u4FF8\u5305\u5446\u5831\u5949\u5B9D\u5CF0\u5CEF\u5D29\u5E96\u62B1\u6367\u653E\u65B9\u670B"],
      ["9640", "\u6CD5\u6CE1\u70F9\u7832\u7E2B\u80DE\u82B3\u840C\u84EC\u8702\u8912\u8A2A\u8C4A\u90A6\u92D2\u98FD\u9CF3\u9D6C\u4E4F\u4EA1\u508D\u5256\u574A\u59A8\u5E3D\u5FD8\u5FD9\u623F\u66B4\u671B\u67D0\u68D2\u5192\u7D21\u80AA\u81A8\u8B00\u8C8C\u8CBF\u927E\u9632\u5420\u982C\u5317\u50D5\u535C\u58A8\u64B2\u6734\u7267\u7766\u7A46\u91E6\u52C3\u6CA1\u6B86\u5800\u5E4C\u5954\u672C\u7FFB\u51E1\u76C6"],
      ["9680", "\u6469\u78E8\u9B54\u9EBB\u57CB\u59B9\u6627\u679A\u6BCE\u54E9\u69D9\u5E55\u819C\u6795\u9BAA\u67FE\u9C52\u685D\u4EA6\u4FE3\u53C8\u62B9\u672B\u6CAB\u8FC4\u4FAD\u7E6D\u9EBF\u4E07\u6162\u6E80\u6F2B\u8513\u5473\u672A\u9B45\u5DF3\u7B95\u5CAC\u5BC6\u871C\u6E4A\u84D1\u7A14\u8108\u5999\u7C8D\u6C11\u7720\u52D9\u5922\u7121\u725F\u77DB\u9727\u9D61\u690B\u5A7F\u5A18\u51A5\u540D\u547D\u660E\u76DF\u8FF7\u9298\u9CF4\u59EA\u725D\u6EC5\u514D\u68C9\u7DBF\u7DEC\u9762\u9EBA\u6478\u6A21\u8302\u5984\u5B5F\u6BDB\u731B\u76F2\u7DB2\u8017\u8499\u5132\u6728\u9ED9\u76EE\u6762\u52FF\u9905\u5C24\u623B\u7C7E\u8CB0\u554F\u60B6\u7D0B\u9580\u5301\u4E5F\u51B6\u591C\u723A\u8036\u91CE\u5F25\u77E2\u5384\u5F79\u7D04\u85AC\u8A33\u8E8D\u9756\u67F3\u85AE\u9453\u6109\u6108\u6CB9\u7652"],
      ["9740", "\u8AED\u8F38\u552F\u4F51\u512A\u52C7\u53CB\u5BA5\u5E7D\u60A0\u6182\u63D6\u6709\u67DA\u6E67\u6D8C\u7336\u7337\u7531\u7950\u88D5\u8A98\u904A\u9091\u90F5\u96C4\u878D\u5915\u4E88\u4F59\u4E0E\u8A89\u8F3F\u9810\u50AD\u5E7C\u5996\u5BB9\u5EB8\u63DA\u63FA\u64C1\u66DC\u694A\u69D8\u6D0B\u6EB6\u7194\u7528\u7AAF\u7F8A\u8000\u8449\u84C9\u8981\u8B21\u8E0A\u9065\u967D\u990A\u617E\u6291\u6B32"],
      ["9780", "\u6C83\u6D74\u7FCC\u7FFC\u6DC0\u7F85\u87BA\u88F8\u6765\u83B1\u983C\u96F7\u6D1B\u7D61\u843D\u916A\u4E71\u5375\u5D50\u6B04\u6FEB\u85CD\u862D\u89A7\u5229\u540F\u5C65\u674E\u68A8\u7406\u7483\u75E2\u88CF\u88E1\u91CC\u96E2\u9678\u5F8B\u7387\u7ACB\u844E\u63A0\u7565\u5289\u6D41\u6E9C\u7409\u7559\u786B\u7C92\u9686\u7ADC\u9F8D\u4FB6\u616E\u65C5\u865C\u4E86\u4EAE\u50DA\u4E21\u51CC\u5BEE\u6599\u6881\u6DBC\u731F\u7642\u77AD\u7A1C\u7CE7\u826F\u8AD2\u907C\u91CF\u9675\u9818\u529B\u7DD1\u502B\u5398\u6797\u6DCB\u71D0\u7433\u81E8\u8F2A\u96A3\u9C57\u9E9F\u7460\u5841\u6D99\u7D2F\u985E\u4EE4\u4F36\u4F8B\u51B7\u52B1\u5DBA\u601C\u73B2\u793C\u82D3\u9234\u96B7\u96F6\u970A\u9E97\u9F62\u66A6\u6B74\u5217\u52A3\u70C8\u88C2\u5EC9\u604B\u6190\u6F23\u7149\u7C3E\u7DF4\u806F"],
      ["9840", "\u84EE\u9023\u932C\u5442\u9B6F\u6AD3\u7089\u8CC2\u8DEF\u9732\u52B4\u5A41\u5ECA\u5F04\u6717\u697C\u6994\u6D6A\u6F0F\u7262\u72FC\u7BED\u8001\u807E\u874B\u90CE\u516D\u9E93\u7984\u808B\u9332\u8AD6\u502D\u548C\u8A71\u6B6A\u8CC4\u8107\u60D1\u67A0\u9DF2\u4E99\u4E98\u9C10\u8A6B\u85C1\u8568\u6900\u6E7E\u7897\u8155"],
      ["989f", "\u5F0C\u4E10\u4E15\u4E2A\u4E31\u4E36\u4E3C\u4E3F\u4E42\u4E56\u4E58\u4E82\u4E85\u8C6B\u4E8A\u8212\u5F0D\u4E8E\u4E9E\u4E9F\u4EA0\u4EA2\u4EB0\u4EB3\u4EB6\u4ECE\u4ECD\u4EC4\u4EC6\u4EC2\u4ED7\u4EDE\u4EED\u4EDF\u4EF7\u4F09\u4F5A\u4F30\u4F5B\u4F5D\u4F57\u4F47\u4F76\u4F88\u4F8F\u4F98\u4F7B\u4F69\u4F70\u4F91\u4F6F\u4F86\u4F96\u5118\u4FD4\u4FDF\u4FCE\u4FD8\u4FDB\u4FD1\u4FDA\u4FD0\u4FE4\u4FE5\u501A\u5028\u5014\u502A\u5025\u5005\u4F1C\u4FF6\u5021\u5029\u502C\u4FFE\u4FEF\u5011\u5006\u5043\u5047\u6703\u5055\u5050\u5048\u505A\u5056\u506C\u5078\u5080\u509A\u5085\u50B4\u50B2"],
      ["9940", "\u50C9\u50CA\u50B3\u50C2\u50D6\u50DE\u50E5\u50ED\u50E3\u50EE\u50F9\u50F5\u5109\u5101\u5102\u5116\u5115\u5114\u511A\u5121\u513A\u5137\u513C\u513B\u513F\u5140\u5152\u514C\u5154\u5162\u7AF8\u5169\u516A\u516E\u5180\u5182\u56D8\u518C\u5189\u518F\u5191\u5193\u5195\u5196\u51A4\u51A6\u51A2\u51A9\u51AA\u51AB\u51B3\u51B1\u51B2\u51B0\u51B5\u51BD\u51C5\u51C9\u51DB\u51E0\u8655\u51E9\u51ED"],
      ["9980", "\u51F0\u51F5\u51FE\u5204\u520B\u5214\u520E\u5227\u522A\u522E\u5233\u5239\u524F\u5244\u524B\u524C\u525E\u5254\u526A\u5274\u5269\u5273\u527F\u527D\u528D\u5294\u5292\u5271\u5288\u5291\u8FA8\u8FA7\u52AC\u52AD\u52BC\u52B5\u52C1\u52CD\u52D7\u52DE\u52E3\u52E6\u98ED\u52E0\u52F3\u52F5\u52F8\u52F9\u5306\u5308\u7538\u530D\u5310\u530F\u5315\u531A\u5323\u532F\u5331\u5333\u5338\u5340\u5346\u5345\u4E17\u5349\u534D\u51D6\u535E\u5369\u536E\u5918\u537B\u5377\u5382\u5396\u53A0\u53A6\u53A5\u53AE\u53B0\u53B6\u53C3\u7C12\u96D9\u53DF\u66FC\u71EE\u53EE\u53E8\u53ED\u53FA\u5401\u543D\u5440\u542C\u542D\u543C\u542E\u5436\u5429\u541D\u544E\u548F\u5475\u548E\u545F\u5471\u5477\u5470\u5492\u547B\u5480\u5476\u5484\u5490\u5486\u54C7\u54A2\u54B8\u54A5\u54AC\u54C4\u54C8\u54A8"],
      ["9a40", "\u54AB\u54C2\u54A4\u54BE\u54BC\u54D8\u54E5\u54E6\u550F\u5514\u54FD\u54EE\u54ED\u54FA\u54E2\u5539\u5540\u5563\u554C\u552E\u555C\u5545\u5556\u5557\u5538\u5533\u555D\u5599\u5580\u54AF\u558A\u559F\u557B\u557E\u5598\u559E\u55AE\u557C\u5583\u55A9\u5587\u55A8\u55DA\u55C5\u55DF\u55C4\u55DC\u55E4\u55D4\u5614\u55F7\u5616\u55FE\u55FD\u561B\u55F9\u564E\u5650\u71DF\u5634\u5636\u5632\u5638"],
      ["9a80", "\u566B\u5664\u562F\u566C\u566A\u5686\u5680\u568A\u56A0\u5694\u568F\u56A5\u56AE\u56B6\u56B4\u56C2\u56BC\u56C1\u56C3\u56C0\u56C8\u56CE\u56D1\u56D3\u56D7\u56EE\u56F9\u5700\u56FF\u5704\u5709\u5708\u570B\u570D\u5713\u5718\u5716\u55C7\u571C\u5726\u5737\u5738\u574E\u573B\u5740\u574F\u5769\u57C0\u5788\u5761\u577F\u5789\u5793\u57A0\u57B3\u57A4\u57AA\u57B0\u57C3\u57C6\u57D4\u57D2\u57D3\u580A\u57D6\u57E3\u580B\u5819\u581D\u5872\u5821\u5862\u584B\u5870\u6BC0\u5852\u583D\u5879\u5885\u58B9\u589F\u58AB\u58BA\u58DE\u58BB\u58B8\u58AE\u58C5\u58D3\u58D1\u58D7\u58D9\u58D8\u58E5\u58DC\u58E4\u58DF\u58EF\u58FA\u58F9\u58FB\u58FC\u58FD\u5902\u590A\u5910\u591B\u68A6\u5925\u592C\u592D\u5932\u5938\u593E\u7AD2\u5955\u5950\u594E\u595A\u5958\u5962\u5960\u5967\u596C\u5969"],
      ["9b40", "\u5978\u5981\u599D\u4F5E\u4FAB\u59A3\u59B2\u59C6\u59E8\u59DC\u598D\u59D9\u59DA\u5A25\u5A1F\u5A11\u5A1C\u5A09\u5A1A\u5A40\u5A6C\u5A49\u5A35\u5A36\u5A62\u5A6A\u5A9A\u5ABC\u5ABE\u5ACB\u5AC2\u5ABD\u5AE3\u5AD7\u5AE6\u5AE9\u5AD6\u5AFA\u5AFB\u5B0C\u5B0B\u5B16\u5B32\u5AD0\u5B2A\u5B36\u5B3E\u5B43\u5B45\u5B40\u5B51\u5B55\u5B5A\u5B5B\u5B65\u5B69\u5B70\u5B73\u5B75\u5B78\u6588\u5B7A\u5B80"],
      ["9b80", "\u5B83\u5BA6\u5BB8\u5BC3\u5BC7\u5BC9\u5BD4\u5BD0\u5BE4\u5BE6\u5BE2\u5BDE\u5BE5\u5BEB\u5BF0\u5BF6\u5BF3\u5C05\u5C07\u5C08\u5C0D\u5C13\u5C20\u5C22\u5C28\u5C38\u5C39\u5C41\u5C46\u5C4E\u5C53\u5C50\u5C4F\u5B71\u5C6C\u5C6E\u4E62\u5C76\u5C79\u5C8C\u5C91\u5C94\u599B\u5CAB\u5CBB\u5CB6\u5CBC\u5CB7\u5CC5\u5CBE\u5CC7\u5CD9\u5CE9\u5CFD\u5CFA\u5CED\u5D8C\u5CEA\u5D0B\u5D15\u5D17\u5D5C\u5D1F\u5D1B\u5D11\u5D14\u5D22\u5D1A\u5D19\u5D18\u5D4C\u5D52\u5D4E\u5D4B\u5D6C\u5D73\u5D76\u5D87\u5D84\u5D82\u5DA2\u5D9D\u5DAC\u5DAE\u5DBD\u5D90\u5DB7\u5DBC\u5DC9\u5DCD\u5DD3\u5DD2\u5DD6\u5DDB\u5DEB\u5DF2\u5DF5\u5E0B\u5E1A\u5E19\u5E11\u5E1B\u5E36\u5E37\u5E44\u5E43\u5E40\u5E4E\u5E57\u5E54\u5E5F\u5E62\u5E64\u5E47\u5E75\u5E76\u5E7A\u9EBC\u5E7F\u5EA0\u5EC1\u5EC2\u5EC8\u5ED0\u5ECF"],
      ["9c40", "\u5ED6\u5EE3\u5EDD\u5EDA\u5EDB\u5EE2\u5EE1\u5EE8\u5EE9\u5EEC\u5EF1\u5EF3\u5EF0\u5EF4\u5EF8\u5EFE\u5F03\u5F09\u5F5D\u5F5C\u5F0B\u5F11\u5F16\u5F29\u5F2D\u5F38\u5F41\u5F48\u5F4C\u5F4E\u5F2F\u5F51\u5F56\u5F57\u5F59\u5F61\u5F6D\u5F73\u5F77\u5F83\u5F82\u5F7F\u5F8A\u5F88\u5F91\u5F87\u5F9E\u5F99\u5F98\u5FA0\u5FA8\u5FAD\u5FBC\u5FD6\u5FFB\u5FE4\u5FF8\u5FF1\u5FDD\u60B3\u5FFF\u6021\u6060"],
      ["9c80", "\u6019\u6010\u6029\u600E\u6031\u601B\u6015\u602B\u6026\u600F\u603A\u605A\u6041\u606A\u6077\u605F\u604A\u6046\u604D\u6063\u6043\u6064\u6042\u606C\u606B\u6059\u6081\u608D\u60E7\u6083\u609A\u6084\u609B\u6096\u6097\u6092\u60A7\u608B\u60E1\u60B8\u60E0\u60D3\u60B4\u5FF0\u60BD\u60C6\u60B5\u60D8\u614D\u6115\u6106\u60F6\u60F7\u6100\u60F4\u60FA\u6103\u6121\u60FB\u60F1\u610D\u610E\u6147\u613E\u6128\u6127\u614A\u613F\u613C\u612C\u6134\u613D\u6142\u6144\u6173\u6177\u6158\u6159\u615A\u616B\u6174\u616F\u6165\u6171\u615F\u615D\u6153\u6175\u6199\u6196\u6187\u61AC\u6194\u619A\u618A\u6191\u61AB\u61AE\u61CC\u61CA\u61C9\u61F7\u61C8\u61C3\u61C6\u61BA\u61CB\u7F79\u61CD\u61E6\u61E3\u61F6\u61FA\u61F4\u61FF\u61FD\u61FC\u61FE\u6200\u6208\u6209\u620D\u620C\u6214\u621B"],
      ["9d40", "\u621E\u6221\u622A\u622E\u6230\u6232\u6233\u6241\u624E\u625E\u6263\u625B\u6260\u6268\u627C\u6282\u6289\u627E\u6292\u6293\u6296\u62D4\u6283\u6294\u62D7\u62D1\u62BB\u62CF\u62FF\u62C6\u64D4\u62C8\u62DC\u62CC\u62CA\u62C2\u62C7\u629B\u62C9\u630C\u62EE\u62F1\u6327\u6302\u6308\u62EF\u62F5\u6350\u633E\u634D\u641C\u634F\u6396\u638E\u6380\u63AB\u6376\u63A3\u638F\u6389\u639F\u63B5\u636B"],
      ["9d80", "\u6369\u63BE\u63E9\u63C0\u63C6\u63E3\u63C9\u63D2\u63F6\u63C4\u6416\u6434\u6406\u6413\u6426\u6436\u651D\u6417\u6428\u640F\u6467\u646F\u6476\u644E\u652A\u6495\u6493\u64A5\u64A9\u6488\u64BC\u64DA\u64D2\u64C5\u64C7\u64BB\u64D8\u64C2\u64F1\u64E7\u8209\u64E0\u64E1\u62AC\u64E3\u64EF\u652C\u64F6\u64F4\u64F2\u64FA\u6500\u64FD\u6518\u651C\u6505\u6524\u6523\u652B\u6534\u6535\u6537\u6536\u6538\u754B\u6548\u6556\u6555\u654D\u6558\u655E\u655D\u6572\u6578\u6582\u6583\u8B8A\u659B\u659F\u65AB\u65B7\u65C3\u65C6\u65C1\u65C4\u65CC\u65D2\u65DB\u65D9\u65E0\u65E1\u65F1\u6772\u660A\u6603\u65FB\u6773\u6635\u6636\u6634\u661C\u664F\u6644\u6649\u6641\u665E\u665D\u6664\u6667\u6668\u665F\u6662\u6670\u6683\u6688\u668E\u6689\u6684\u6698\u669D\u66C1\u66B9\u66C9\u66BE\u66BC"],
      ["9e40", "\u66C4\u66B8\u66D6\u66DA\u66E0\u663F\u66E6\u66E9\u66F0\u66F5\u66F7\u670F\u6716\u671E\u6726\u6727\u9738\u672E\u673F\u6736\u6741\u6738\u6737\u6746\u675E\u6760\u6759\u6763\u6764\u6789\u6770\u67A9\u677C\u676A\u678C\u678B\u67A6\u67A1\u6785\u67B7\u67EF\u67B4\u67EC\u67B3\u67E9\u67B8\u67E4\u67DE\u67DD\u67E2\u67EE\u67B9\u67CE\u67C6\u67E7\u6A9C\u681E\u6846\u6829\u6840\u684D\u6832\u684E"],
      ["9e80", "\u68B3\u682B\u6859\u6863\u6877\u687F\u689F\u688F\u68AD\u6894\u689D\u689B\u6883\u6AAE\u68B9\u6874\u68B5\u68A0\u68BA\u690F\u688D\u687E\u6901\u68CA\u6908\u68D8\u6922\u6926\u68E1\u690C\u68CD\u68D4\u68E7\u68D5\u6936\u6912\u6904\u68D7\u68E3\u6925\u68F9\u68E0\u68EF\u6928\u692A\u691A\u6923\u6921\u68C6\u6979\u6977\u695C\u6978\u696B\u6954\u697E\u696E\u6939\u6974\u693D\u6959\u6930\u6961\u695E\u695D\u6981\u696A\u69B2\u69AE\u69D0\u69BF\u69C1\u69D3\u69BE\u69CE\u5BE8\u69CA\u69DD\u69BB\u69C3\u69A7\u6A2E\u6991\u69A0\u699C\u6995\u69B4\u69DE\u69E8\u6A02\u6A1B\u69FF\u6B0A\u69F9\u69F2\u69E7\u6A05\u69B1\u6A1E\u69ED\u6A14\u69EB\u6A0A\u6A12\u6AC1\u6A23\u6A13\u6A44\u6A0C\u6A72\u6A36\u6A78\u6A47\u6A62\u6A59\u6A66\u6A48\u6A38\u6A22\u6A90\u6A8D\u6AA0\u6A84\u6AA2\u6AA3"],
      ["9f40", "\u6A97\u8617\u6ABB\u6AC3\u6AC2\u6AB8\u6AB3\u6AAC\u6ADE\u6AD1\u6ADF\u6AAA\u6ADA\u6AEA\u6AFB\u6B05\u8616\u6AFA\u6B12\u6B16\u9B31\u6B1F\u6B38\u6B37\u76DC\u6B39\u98EE\u6B47\u6B43\u6B49\u6B50\u6B59\u6B54\u6B5B\u6B5F\u6B61\u6B78\u6B79\u6B7F\u6B80\u6B84\u6B83\u6B8D\u6B98\u6B95\u6B9E\u6BA4\u6BAA\u6BAB\u6BAF\u6BB2\u6BB1\u6BB3\u6BB7\u6BBC\u6BC6\u6BCB\u6BD3\u6BDF\u6BEC\u6BEB\u6BF3\u6BEF"],
      ["9f80", "\u9EBE\u6C08\u6C13\u6C14\u6C1B\u6C24\u6C23\u6C5E\u6C55\u6C62\u6C6A\u6C82\u6C8D\u6C9A\u6C81\u6C9B\u6C7E\u6C68\u6C73\u6C92\u6C90\u6CC4\u6CF1\u6CD3\u6CBD\u6CD7\u6CC5\u6CDD\u6CAE\u6CB1\u6CBE\u6CBA\u6CDB\u6CEF\u6CD9\u6CEA\u6D1F\u884D\u6D36\u6D2B\u6D3D\u6D38\u6D19\u6D35\u6D33\u6D12\u6D0C\u6D63\u6D93\u6D64\u6D5A\u6D79\u6D59\u6D8E\u6D95\u6FE4\u6D85\u6DF9\u6E15\u6E0A\u6DB5\u6DC7\u6DE6\u6DB8\u6DC6\u6DEC\u6DDE\u6DCC\u6DE8\u6DD2\u6DC5\u6DFA\u6DD9\u6DE4\u6DD5\u6DEA\u6DEE\u6E2D\u6E6E\u6E2E\u6E19\u6E72\u6E5F\u6E3E\u6E23\u6E6B\u6E2B\u6E76\u6E4D\u6E1F\u6E43\u6E3A\u6E4E\u6E24\u6EFF\u6E1D\u6E38\u6E82\u6EAA\u6E98\u6EC9\u6EB7\u6ED3\u6EBD\u6EAF\u6EC4\u6EB2\u6ED4\u6ED5\u6E8F\u6EA5\u6EC2\u6E9F\u6F41\u6F11\u704C\u6EEC\u6EF8\u6EFE\u6F3F\u6EF2\u6F31\u6EEF\u6F32\u6ECC"],
      ["e040", "\u6F3E\u6F13\u6EF7\u6F86\u6F7A\u6F78\u6F81\u6F80\u6F6F\u6F5B\u6FF3\u6F6D\u6F82\u6F7C\u6F58\u6F8E\u6F91\u6FC2\u6F66\u6FB3\u6FA3\u6FA1\u6FA4\u6FB9\u6FC6\u6FAA\u6FDF\u6FD5\u6FEC\u6FD4\u6FD8\u6FF1\u6FEE\u6FDB\u7009\u700B\u6FFA\u7011\u7001\u700F\u6FFE\u701B\u701A\u6F74\u701D\u7018\u701F\u7030\u703E\u7032\u7051\u7063\u7099\u7092\u70AF\u70F1\u70AC\u70B8\u70B3\u70AE\u70DF\u70CB\u70DD"],
      ["e080", "\u70D9\u7109\u70FD\u711C\u7119\u7165\u7155\u7188\u7166\u7162\u714C\u7156\u716C\u718F\u71FB\u7184\u7195\u71A8\u71AC\u71D7\u71B9\u71BE\u71D2\u71C9\u71D4\u71CE\u71E0\u71EC\u71E7\u71F5\u71FC\u71F9\u71FF\u720D\u7210\u721B\u7228\u722D\u722C\u7230\u7232\u723B\u723C\u723F\u7240\u7246\u724B\u7258\u7274\u727E\u7282\u7281\u7287\u7292\u7296\u72A2\u72A7\u72B9\u72B2\u72C3\u72C6\u72C4\u72CE\u72D2\u72E2\u72E0\u72E1\u72F9\u72F7\u500F\u7317\u730A\u731C\u7316\u731D\u7334\u732F\u7329\u7325\u733E\u734E\u734F\u9ED8\u7357\u736A\u7368\u7370\u7378\u7375\u737B\u737A\u73C8\u73B3\u73CE\u73BB\u73C0\u73E5\u73EE\u73DE\u74A2\u7405\u746F\u7425\u73F8\u7432\u743A\u7455\u743F\u745F\u7459\u7441\u745C\u7469\u7470\u7463\u746A\u7476\u747E\u748B\u749E\u74A7\u74CA\u74CF\u74D4\u73F1"],
      ["e140", "\u74E0\u74E3\u74E7\u74E9\u74EE\u74F2\u74F0\u74F1\u74F8\u74F7\u7504\u7503\u7505\u750C\u750E\u750D\u7515\u7513\u751E\u7526\u752C\u753C\u7544\u754D\u754A\u7549\u755B\u7546\u755A\u7569\u7564\u7567\u756B\u756D\u7578\u7576\u7586\u7587\u7574\u758A\u7589\u7582\u7594\u759A\u759D\u75A5\u75A3\u75C2\u75B3\u75C3\u75B5\u75BD\u75B8\u75BC\u75B1\u75CD\u75CA\u75D2\u75D9\u75E3\u75DE\u75FE\u75FF"],
      ["e180", "\u75FC\u7601\u75F0\u75FA\u75F2\u75F3\u760B\u760D\u7609\u761F\u7627\u7620\u7621\u7622\u7624\u7634\u7630\u763B\u7647\u7648\u7646\u765C\u7658\u7661\u7662\u7668\u7669\u766A\u7667\u766C\u7670\u7672\u7676\u7678\u767C\u7680\u7683\u7688\u768B\u768E\u7696\u7693\u7699\u769A\u76B0\u76B4\u76B8\u76B9\u76BA\u76C2\u76CD\u76D6\u76D2\u76DE\u76E1\u76E5\u76E7\u76EA\u862F\u76FB\u7708\u7707\u7704\u7729\u7724\u771E\u7725\u7726\u771B\u7737\u7738\u7747\u775A\u7768\u776B\u775B\u7765\u777F\u777E\u7779\u778E\u778B\u7791\u77A0\u779E\u77B0\u77B6\u77B9\u77BF\u77BC\u77BD\u77BB\u77C7\u77CD\u77D7\u77DA\u77DC\u77E3\u77EE\u77FC\u780C\u7812\u7926\u7820\u792A\u7845\u788E\u7874\u7886\u787C\u789A\u788C\u78A3\u78B5\u78AA\u78AF\u78D1\u78C6\u78CB\u78D4\u78BE\u78BC\u78C5\u78CA\u78EC"],
      ["e240", "\u78E7\u78DA\u78FD\u78F4\u7907\u7912\u7911\u7919\u792C\u792B\u7940\u7960\u7957\u795F\u795A\u7955\u7953\u797A\u797F\u798A\u799D\u79A7\u9F4B\u79AA\u79AE\u79B3\u79B9\u79BA\u79C9\u79D5\u79E7\u79EC\u79E1\u79E3\u7A08\u7A0D\u7A18\u7A19\u7A20\u7A1F\u7980\u7A31\u7A3B\u7A3E\u7A37\u7A43\u7A57\u7A49\u7A61\u7A62\u7A69\u9F9D\u7A70\u7A79\u7A7D\u7A88\u7A97\u7A95\u7A98\u7A96\u7AA9\u7AC8\u7AB0"],
      ["e280", "\u7AB6\u7AC5\u7AC4\u7ABF\u9083\u7AC7\u7ACA\u7ACD\u7ACF\u7AD5\u7AD3\u7AD9\u7ADA\u7ADD\u7AE1\u7AE2\u7AE6\u7AED\u7AF0\u7B02\u7B0F\u7B0A\u7B06\u7B33\u7B18\u7B19\u7B1E\u7B35\u7B28\u7B36\u7B50\u7B7A\u7B04\u7B4D\u7B0B\u7B4C\u7B45\u7B75\u7B65\u7B74\u7B67\u7B70\u7B71\u7B6C\u7B6E\u7B9D\u7B98\u7B9F\u7B8D\u7B9C\u7B9A\u7B8B\u7B92\u7B8F\u7B5D\u7B99\u7BCB\u7BC1\u7BCC\u7BCF\u7BB4\u7BC6\u7BDD\u7BE9\u7C11\u7C14\u7BE6\u7BE5\u7C60\u7C00\u7C07\u7C13\u7BF3\u7BF7\u7C17\u7C0D\u7BF6\u7C23\u7C27\u7C2A\u7C1F\u7C37\u7C2B\u7C3D\u7C4C\u7C43\u7C54\u7C4F\u7C40\u7C50\u7C58\u7C5F\u7C64\u7C56\u7C65\u7C6C\u7C75\u7C83\u7C90\u7CA4\u7CAD\u7CA2\u7CAB\u7CA1\u7CA8\u7CB3\u7CB2\u7CB1\u7CAE\u7CB9\u7CBD\u7CC0\u7CC5\u7CC2\u7CD8\u7CD2\u7CDC\u7CE2\u9B3B\u7CEF\u7CF2\u7CF4\u7CF6\u7CFA\u7D06"],
      ["e340", "\u7D02\u7D1C\u7D15\u7D0A\u7D45\u7D4B\u7D2E\u7D32\u7D3F\u7D35\u7D46\u7D73\u7D56\u7D4E\u7D72\u7D68\u7D6E\u7D4F\u7D63\u7D93\u7D89\u7D5B\u7D8F\u7D7D\u7D9B\u7DBA\u7DAE\u7DA3\u7DB5\u7DC7\u7DBD\u7DAB\u7E3D\u7DA2\u7DAF\u7DDC\u7DB8\u7D9F\u7DB0\u7DD8\u7DDD\u7DE4\u7DDE\u7DFB\u7DF2\u7DE1\u7E05\u7E0A\u7E23\u7E21\u7E12\u7E31\u7E1F\u7E09\u7E0B\u7E22\u7E46\u7E66\u7E3B\u7E35\u7E39\u7E43\u7E37"],
      ["e380", "\u7E32\u7E3A\u7E67\u7E5D\u7E56\u7E5E\u7E59\u7E5A\u7E79\u7E6A\u7E69\u7E7C\u7E7B\u7E83\u7DD5\u7E7D\u8FAE\u7E7F\u7E88\u7E89\u7E8C\u7E92\u7E90\u7E93\u7E94\u7E96\u7E8E\u7E9B\u7E9C\u7F38\u7F3A\u7F45\u7F4C\u7F4D\u7F4E\u7F50\u7F51\u7F55\u7F54\u7F58\u7F5F\u7F60\u7F68\u7F69\u7F67\u7F78\u7F82\u7F86\u7F83\u7F88\u7F87\u7F8C\u7F94\u7F9E\u7F9D\u7F9A\u7FA3\u7FAF\u7FB2\u7FB9\u7FAE\u7FB6\u7FB8\u8B71\u7FC5\u7FC6\u7FCA\u7FD5\u7FD4\u7FE1\u7FE6\u7FE9\u7FF3\u7FF9\u98DC\u8006\u8004\u800B\u8012\u8018\u8019\u801C\u8021\u8028\u803F\u803B\u804A\u8046\u8052\u8058\u805A\u805F\u8062\u8068\u8073\u8072\u8070\u8076\u8079\u807D\u807F\u8084\u8086\u8085\u809B\u8093\u809A\u80AD\u5190\u80AC\u80DB\u80E5\u80D9\u80DD\u80C4\u80DA\u80D6\u8109\u80EF\u80F1\u811B\u8129\u8123\u812F\u814B"],
      ["e440", "\u968B\u8146\u813E\u8153\u8151\u80FC\u8171\u816E\u8165\u8166\u8174\u8183\u8188\u818A\u8180\u8182\u81A0\u8195\u81A4\u81A3\u815F\u8193\u81A9\u81B0\u81B5\u81BE\u81B8\u81BD\u81C0\u81C2\u81BA\u81C9\u81CD\u81D1\u81D9\u81D8\u81C8\u81DA\u81DF\u81E0\u81E7\u81FA\u81FB\u81FE\u8201\u8202\u8205\u8207\u820A\u820D\u8210\u8216\u8229\u822B\u8238\u8233\u8240\u8259\u8258\u825D\u825A\u825F\u8264"],
      ["e480", "\u8262\u8268\u826A\u826B\u822E\u8271\u8277\u8278\u827E\u828D\u8292\u82AB\u829F\u82BB\u82AC\u82E1\u82E3\u82DF\u82D2\u82F4\u82F3\u82FA\u8393\u8303\u82FB\u82F9\u82DE\u8306\u82DC\u8309\u82D9\u8335\u8334\u8316\u8332\u8331\u8340\u8339\u8350\u8345\u832F\u832B\u8317\u8318\u8385\u839A\u83AA\u839F\u83A2\u8396\u8323\u838E\u8387\u838A\u837C\u83B5\u8373\u8375\u83A0\u8389\u83A8\u83F4\u8413\u83EB\u83CE\u83FD\u8403\u83D8\u840B\u83C1\u83F7\u8407\u83E0\u83F2\u840D\u8422\u8420\u83BD\u8438\u8506\u83FB\u846D\u842A\u843C\u855A\u8484\u8477\u846B\u84AD\u846E\u8482\u8469\u8446\u842C\u846F\u8479\u8435\u84CA\u8462\u84B9\u84BF\u849F\u84D9\u84CD\u84BB\u84DA\u84D0\u84C1\u84C6\u84D6\u84A1\u8521\u84FF\u84F4\u8517\u8518\u852C\u851F\u8515\u8514\u84FC\u8540\u8563\u8558\u8548"],
      ["e540", "\u8541\u8602\u854B\u8555\u8580\u85A4\u8588\u8591\u858A\u85A8\u856D\u8594\u859B\u85EA\u8587\u859C\u8577\u857E\u8590\u85C9\u85BA\u85CF\u85B9\u85D0\u85D5\u85DD\u85E5\u85DC\u85F9\u860A\u8613\u860B\u85FE\u85FA\u8606\u8622\u861A\u8630\u863F\u864D\u4E55\u8654\u865F\u8667\u8671\u8693\u86A3\u86A9\u86AA\u868B\u868C\u86B6\u86AF\u86C4\u86C6\u86B0\u86C9\u8823\u86AB\u86D4\u86DE\u86E9\u86EC"],
      ["e580", "\u86DF\u86DB\u86EF\u8712\u8706\u8708\u8700\u8703\u86FB\u8711\u8709\u870D\u86F9\u870A\u8734\u873F\u8737\u873B\u8725\u8729\u871A\u8760\u875F\u8778\u874C\u874E\u8774\u8757\u8768\u876E\u8759\u8753\u8763\u876A\u8805\u87A2\u879F\u8782\u87AF\u87CB\u87BD\u87C0\u87D0\u96D6\u87AB\u87C4\u87B3\u87C7\u87C6\u87BB\u87EF\u87F2\u87E0\u880F\u880D\u87FE\u87F6\u87F7\u880E\u87D2\u8811\u8816\u8815\u8822\u8821\u8831\u8836\u8839\u8827\u883B\u8844\u8842\u8852\u8859\u885E\u8862\u886B\u8881\u887E\u889E\u8875\u887D\u88B5\u8872\u8882\u8897\u8892\u88AE\u8899\u88A2\u888D\u88A4\u88B0\u88BF\u88B1\u88C3\u88C4\u88D4\u88D8\u88D9\u88DD\u88F9\u8902\u88FC\u88F4\u88E8\u88F2\u8904\u890C\u890A\u8913\u8943\u891E\u8925\u892A\u892B\u8941\u8944\u893B\u8936\u8938\u894C\u891D\u8960\u895E"],
      ["e640", "\u8966\u8964\u896D\u896A\u896F\u8974\u8977\u897E\u8983\u8988\u898A\u8993\u8998\u89A1\u89A9\u89A6\u89AC\u89AF\u89B2\u89BA\u89BD\u89BF\u89C0\u89DA\u89DC\u89DD\u89E7\u89F4\u89F8\u8A03\u8A16\u8A10\u8A0C\u8A1B\u8A1D\u8A25\u8A36\u8A41\u8A5B\u8A52\u8A46\u8A48\u8A7C\u8A6D\u8A6C\u8A62\u8A85\u8A82\u8A84\u8AA8\u8AA1\u8A91\u8AA5\u8AA6\u8A9A\u8AA3\u8AC4\u8ACD\u8AC2\u8ADA\u8AEB\u8AF3\u8AE7"],
      ["e680", "\u8AE4\u8AF1\u8B14\u8AE0\u8AE2\u8AF7\u8ADE\u8ADB\u8B0C\u8B07\u8B1A\u8AE1\u8B16\u8B10\u8B17\u8B20\u8B33\u97AB\u8B26\u8B2B\u8B3E\u8B28\u8B41\u8B4C\u8B4F\u8B4E\u8B49\u8B56\u8B5B\u8B5A\u8B6B\u8B5F\u8B6C\u8B6F\u8B74\u8B7D\u8B80\u8B8C\u8B8E\u8B92\u8B93\u8B96\u8B99\u8B9A\u8C3A\u8C41\u8C3F\u8C48\u8C4C\u8C4E\u8C50\u8C55\u8C62\u8C6C\u8C78\u8C7A\u8C82\u8C89\u8C85\u8C8A\u8C8D\u8C8E\u8C94\u8C7C\u8C98\u621D\u8CAD\u8CAA\u8CBD\u8CB2\u8CB3\u8CAE\u8CB6\u8CC8\u8CC1\u8CE4\u8CE3\u8CDA\u8CFD\u8CFA\u8CFB\u8D04\u8D05\u8D0A\u8D07\u8D0F\u8D0D\u8D10\u9F4E\u8D13\u8CCD\u8D14\u8D16\u8D67\u8D6D\u8D71\u8D73\u8D81\u8D99\u8DC2\u8DBE\u8DBA\u8DCF\u8DDA\u8DD6\u8DCC\u8DDB\u8DCB\u8DEA\u8DEB\u8DDF\u8DE3\u8DFC\u8E08\u8E09\u8DFF\u8E1D\u8E1E\u8E10\u8E1F\u8E42\u8E35\u8E30\u8E34\u8E4A"],
      ["e740", "\u8E47\u8E49\u8E4C\u8E50\u8E48\u8E59\u8E64\u8E60\u8E2A\u8E63\u8E55\u8E76\u8E72\u8E7C\u8E81\u8E87\u8E85\u8E84\u8E8B\u8E8A\u8E93\u8E91\u8E94\u8E99\u8EAA\u8EA1\u8EAC\u8EB0\u8EC6\u8EB1\u8EBE\u8EC5\u8EC8\u8ECB\u8EDB\u8EE3\u8EFC\u8EFB\u8EEB\u8EFE\u8F0A\u8F05\u8F15\u8F12\u8F19\u8F13\u8F1C\u8F1F\u8F1B\u8F0C\u8F26\u8F33\u8F3B\u8F39\u8F45\u8F42\u8F3E\u8F4C\u8F49\u8F46\u8F4E\u8F57\u8F5C"],
      ["e780", "\u8F62\u8F63\u8F64\u8F9C\u8F9F\u8FA3\u8FAD\u8FAF\u8FB7\u8FDA\u8FE5\u8FE2\u8FEA\u8FEF\u9087\u8FF4\u9005\u8FF9\u8FFA\u9011\u9015\u9021\u900D\u901E\u9016\u900B\u9027\u9036\u9035\u9039\u8FF8\u904F\u9050\u9051\u9052\u900E\u9049\u903E\u9056\u9058\u905E\u9068\u906F\u9076\u96A8\u9072\u9082\u907D\u9081\u9080\u908A\u9089\u908F\u90A8\u90AF\u90B1\u90B5\u90E2\u90E4\u6248\u90DB\u9102\u9112\u9119\u9132\u9130\u914A\u9156\u9158\u9163\u9165\u9169\u9173\u9172\u918B\u9189\u9182\u91A2\u91AB\u91AF\u91AA\u91B5\u91B4\u91BA\u91C0\u91C1\u91C9\u91CB\u91D0\u91D6\u91DF\u91E1\u91DB\u91FC\u91F5\u91F6\u921E\u91FF\u9214\u922C\u9215\u9211\u925E\u9257\u9245\u9249\u9264\u9248\u9295\u923F\u924B\u9250\u929C\u9296\u9293\u929B\u925A\u92CF\u92B9\u92B7\u92E9\u930F\u92FA\u9344\u932E"],
      ["e840", "\u9319\u9322\u931A\u9323\u933A\u9335\u933B\u935C\u9360\u937C\u936E\u9356\u93B0\u93AC\u93AD\u9394\u93B9\u93D6\u93D7\u93E8\u93E5\u93D8\u93C3\u93DD\u93D0\u93C8\u93E4\u941A\u9414\u9413\u9403\u9407\u9410\u9436\u942B\u9435\u9421\u943A\u9441\u9452\u9444\u945B\u9460\u9462\u945E\u946A\u9229\u9470\u9475\u9477\u947D\u945A\u947C\u947E\u9481\u947F\u9582\u9587\u958A\u9594\u9596\u9598\u9599"],
      ["e880", "\u95A0\u95A8\u95A7\u95AD\u95BC\u95BB\u95B9\u95BE\u95CA\u6FF6\u95C3\u95CD\u95CC\u95D5\u95D4\u95D6\u95DC\u95E1\u95E5\u95E2\u9621\u9628\u962E\u962F\u9642\u964C\u964F\u964B\u9677\u965C\u965E\u965D\u965F\u9666\u9672\u966C\u968D\u9698\u9695\u9697\u96AA\u96A7\u96B1\u96B2\u96B0\u96B4\u96B6\u96B8\u96B9\u96CE\u96CB\u96C9\u96CD\u894D\u96DC\u970D\u96D5\u96F9\u9704\u9706\u9708\u9713\u970E\u9711\u970F\u9716\u9719\u9724\u972A\u9730\u9739\u973D\u973E\u9744\u9746\u9748\u9742\u9749\u975C\u9760\u9764\u9766\u9768\u52D2\u976B\u9771\u9779\u9785\u977C\u9781\u977A\u9786\u978B\u978F\u9790\u979C\u97A8\u97A6\u97A3\u97B3\u97B4\u97C3\u97C6\u97C8\u97CB\u97DC\u97ED\u9F4F\u97F2\u7ADF\u97F6\u97F5\u980F\u980C\u9838\u9824\u9821\u9837\u983D\u9846\u984F\u984B\u986B\u986F\u9870"],
      ["e940", "\u9871\u9874\u9873\u98AA\u98AF\u98B1\u98B6\u98C4\u98C3\u98C6\u98E9\u98EB\u9903\u9909\u9912\u9914\u9918\u9921\u991D\u991E\u9924\u9920\u992C\u992E\u993D\u993E\u9942\u9949\u9945\u9950\u994B\u9951\u9952\u994C\u9955\u9997\u9998\u99A5\u99AD\u99AE\u99BC\u99DF\u99DB\u99DD\u99D8\u99D1\u99ED\u99EE\u99F1\u99F2\u99FB\u99F8\u9A01\u9A0F\u9A05\u99E2\u9A19\u9A2B\u9A37\u9A45\u9A42\u9A40\u9A43"],
      ["e980", "\u9A3E\u9A55\u9A4D\u9A5B\u9A57\u9A5F\u9A62\u9A65\u9A64\u9A69\u9A6B\u9A6A\u9AAD\u9AB0\u9ABC\u9AC0\u9ACF\u9AD1\u9AD3\u9AD4\u9ADE\u9ADF\u9AE2\u9AE3\u9AE6\u9AEF\u9AEB\u9AEE\u9AF4\u9AF1\u9AF7\u9AFB\u9B06\u9B18\u9B1A\u9B1F\u9B22\u9B23\u9B25\u9B27\u9B28\u9B29\u9B2A\u9B2E\u9B2F\u9B32\u9B44\u9B43\u9B4F\u9B4D\u9B4E\u9B51\u9B58\u9B74\u9B93\u9B83\u9B91\u9B96\u9B97\u9B9F\u9BA0\u9BA8\u9BB4\u9BC0\u9BCA\u9BB9\u9BC6\u9BCF\u9BD1\u9BD2\u9BE3\u9BE2\u9BE4\u9BD4\u9BE1\u9C3A\u9BF2\u9BF1\u9BF0\u9C15\u9C14\u9C09\u9C13\u9C0C\u9C06\u9C08\u9C12\u9C0A\u9C04\u9C2E\u9C1B\u9C25\u9C24\u9C21\u9C30\u9C47\u9C32\u9C46\u9C3E\u9C5A\u9C60\u9C67\u9C76\u9C78\u9CE7\u9CEC\u9CF0\u9D09\u9D08\u9CEB\u9D03\u9D06\u9D2A\u9D26\u9DAF\u9D23\u9D1F\u9D44\u9D15\u9D12\u9D41\u9D3F\u9D3E\u9D46\u9D48"],
      ["ea40", "\u9D5D\u9D5E\u9D64\u9D51\u9D50\u9D59\u9D72\u9D89\u9D87\u9DAB\u9D6F\u9D7A\u9D9A\u9DA4\u9DA9\u9DB2\u9DC4\u9DC1\u9DBB\u9DB8\u9DBA\u9DC6\u9DCF\u9DC2\u9DD9\u9DD3\u9DF8\u9DE6\u9DED\u9DEF\u9DFD\u9E1A\u9E1B\u9E1E\u9E75\u9E79\u9E7D\u9E81\u9E88\u9E8B\u9E8C\u9E92\u9E95\u9E91\u9E9D\u9EA5\u9EA9\u9EB8\u9EAA\u9EAD\u9761\u9ECC\u9ECE\u9ECF\u9ED0\u9ED4\u9EDC\u9EDE\u9EDD\u9EE0\u9EE5\u9EE8\u9EEF"],
      ["ea80", "\u9EF4\u9EF6\u9EF7\u9EF9\u9EFB\u9EFC\u9EFD\u9F07\u9F08\u76B7\u9F15\u9F21\u9F2C\u9F3E\u9F4A\u9F52\u9F54\u9F63\u9F5F\u9F60\u9F61\u9F66\u9F67\u9F6C\u9F6A\u9F77\u9F72\u9F76\u9F95\u9F9C\u9FA0\u582F\u69C7\u9059\u7464\u51DC\u7199"],
      ["ed40", "\u7E8A\u891C\u9348\u9288\u84DC\u4FC9\u70BB\u6631\u68C8\u92F9\u66FB\u5F45\u4E28\u4EE1\u4EFC\u4F00\u4F03\u4F39\u4F56\u4F92\u4F8A\u4F9A\u4F94\u4FCD\u5040\u5022\u4FFF\u501E\u5046\u5070\u5042\u5094\u50F4\u50D8\u514A\u5164\u519D\u51BE\u51EC\u5215\u529C\u52A6\u52C0\u52DB\u5300\u5307\u5324\u5372\u5393\u53B2\u53DD\uFA0E\u549C\u548A\u54A9\u54FF\u5586\u5759\u5765\u57AC\u57C8\u57C7\uFA0F"],
      ["ed80", "\uFA10\u589E\u58B2\u590B\u5953\u595B\u595D\u5963\u59A4\u59BA\u5B56\u5BC0\u752F\u5BD8\u5BEC\u5C1E\u5CA6\u5CBA\u5CF5\u5D27\u5D53\uFA11\u5D42\u5D6D\u5DB8\u5DB9\u5DD0\u5F21\u5F34\u5F67\u5FB7\u5FDE\u605D\u6085\u608A\u60DE\u60D5\u6120\u60F2\u6111\u6137\u6130\u6198\u6213\u62A6\u63F5\u6460\u649D\u64CE\u654E\u6600\u6615\u663B\u6609\u662E\u661E\u6624\u6665\u6657\u6659\uFA12\u6673\u6699\u66A0\u66B2\u66BF\u66FA\u670E\uF929\u6766\u67BB\u6852\u67C0\u6801\u6844\u68CF\uFA13\u6968\uFA14\u6998\u69E2\u6A30\u6A6B\u6A46\u6A73\u6A7E\u6AE2\u6AE4\u6BD6\u6C3F\u6C5C\u6C86\u6C6F\u6CDA\u6D04\u6D87\u6D6F\u6D96\u6DAC\u6DCF\u6DF8\u6DF2\u6DFC\u6E39\u6E5C\u6E27\u6E3C\u6EBF\u6F88\u6FB5\u6FF5\u7005\u7007\u7028\u7085\u70AB\u710F\u7104\u715C\u7146\u7147\uFA15\u71C1\u71FE\u72B1"],
      ["ee40", "\u72BE\u7324\uFA16\u7377\u73BD\u73C9\u73D6\u73E3\u73D2\u7407\u73F5\u7426\u742A\u7429\u742E\u7462\u7489\u749F\u7501\u756F\u7682\u769C\u769E\u769B\u76A6\uFA17\u7746\u52AF\u7821\u784E\u7864\u787A\u7930\uFA18\uFA19\uFA1A\u7994\uFA1B\u799B\u7AD1\u7AE7\uFA1C\u7AEB\u7B9E\uFA1D\u7D48\u7D5C\u7DB7\u7DA0\u7DD6\u7E52\u7F47\u7FA1\uFA1E\u8301\u8362\u837F\u83C7\u83F6\u8448\u84B4\u8553\u8559"],
      ["ee80", "\u856B\uFA1F\u85B0\uFA20\uFA21\u8807\u88F5\u8A12\u8A37\u8A79\u8AA7\u8ABE\u8ADF\uFA22\u8AF6\u8B53\u8B7F\u8CF0\u8CF4\u8D12\u8D76\uFA23\u8ECF\uFA24\uFA25\u9067\u90DE\uFA26\u9115\u9127\u91DA\u91D7\u91DE\u91ED\u91EE\u91E4\u91E5\u9206\u9210\u920A\u923A\u9240\u923C\u924E\u9259\u9251\u9239\u9267\u92A7\u9277\u9278\u92E7\u92D7\u92D9\u92D0\uFA27\u92D5\u92E0\u92D3\u9325\u9321\u92FB\uFA28\u931E\u92FF\u931D\u9302\u9370\u9357\u93A4\u93C6\u93DE\u93F8\u9431\u9445\u9448\u9592\uF9DC\uFA29\u969D\u96AF\u9733\u973B\u9743\u974D\u974F\u9751\u9755\u9857\u9865\uFA2A\uFA2B\u9927\uFA2C\u999E\u9A4E\u9AD9\u9ADC\u9B75\u9B72\u9B8F\u9BB1\u9BBB\u9C00\u9D70\u9D6B\uFA2D\u9E19\u9ED1"],
      ["eeef", "\u2170", 9, "\uFFE2\uFFE4\uFF07\uFF02"],
      ["f040", "\uE000", 62],
      ["f080", "\uE03F", 124],
      ["f140", "\uE0BC", 62],
      ["f180", "\uE0FB", 124],
      ["f240", "\uE178", 62],
      ["f280", "\uE1B7", 124],
      ["f340", "\uE234", 62],
      ["f380", "\uE273", 124],
      ["f440", "\uE2F0", 62],
      ["f480", "\uE32F", 124],
      ["f540", "\uE3AC", 62],
      ["f580", "\uE3EB", 124],
      ["f640", "\uE468", 62],
      ["f680", "\uE4A7", 124],
      ["f740", "\uE524", 62],
      ["f780", "\uE563", 124],
      ["f840", "\uE5E0", 62],
      ["f880", "\uE61F", 124],
      ["f940", "\uE69C"],
      ["fa40", "\u2170", 9, "\u2160", 9, "\uFFE2\uFFE4\uFF07\uFF02\u3231\u2116\u2121\u2235\u7E8A\u891C\u9348\u9288\u84DC\u4FC9\u70BB\u6631\u68C8\u92F9\u66FB\u5F45\u4E28\u4EE1\u4EFC\u4F00\u4F03\u4F39\u4F56\u4F92\u4F8A\u4F9A\u4F94\u4FCD\u5040\u5022\u4FFF\u501E\u5046\u5070\u5042\u5094\u50F4\u50D8\u514A"],
      ["fa80", "\u5164\u519D\u51BE\u51EC\u5215\u529C\u52A6\u52C0\u52DB\u5300\u5307\u5324\u5372\u5393\u53B2\u53DD\uFA0E\u549C\u548A\u54A9\u54FF\u5586\u5759\u5765\u57AC\u57C8\u57C7\uFA0F\uFA10\u589E\u58B2\u590B\u5953\u595B\u595D\u5963\u59A4\u59BA\u5B56\u5BC0\u752F\u5BD8\u5BEC\u5C1E\u5CA6\u5CBA\u5CF5\u5D27\u5D53\uFA11\u5D42\u5D6D\u5DB8\u5DB9\u5DD0\u5F21\u5F34\u5F67\u5FB7\u5FDE\u605D\u6085\u608A\u60DE\u60D5\u6120\u60F2\u6111\u6137\u6130\u6198\u6213\u62A6\u63F5\u6460\u649D\u64CE\u654E\u6600\u6615\u663B\u6609\u662E\u661E\u6624\u6665\u6657\u6659\uFA12\u6673\u6699\u66A0\u66B2\u66BF\u66FA\u670E\uF929\u6766\u67BB\u6852\u67C0\u6801\u6844\u68CF\uFA13\u6968\uFA14\u6998\u69E2\u6A30\u6A6B\u6A46\u6A73\u6A7E\u6AE2\u6AE4\u6BD6\u6C3F\u6C5C\u6C86\u6C6F\u6CDA\u6D04\u6D87\u6D6F"],
      ["fb40", "\u6D96\u6DAC\u6DCF\u6DF8\u6DF2\u6DFC\u6E39\u6E5C\u6E27\u6E3C\u6EBF\u6F88\u6FB5\u6FF5\u7005\u7007\u7028\u7085\u70AB\u710F\u7104\u715C\u7146\u7147\uFA15\u71C1\u71FE\u72B1\u72BE\u7324\uFA16\u7377\u73BD\u73C9\u73D6\u73E3\u73D2\u7407\u73F5\u7426\u742A\u7429\u742E\u7462\u7489\u749F\u7501\u756F\u7682\u769C\u769E\u769B\u76A6\uFA17\u7746\u52AF\u7821\u784E\u7864\u787A\u7930\uFA18\uFA19"],
      ["fb80", "\uFA1A\u7994\uFA1B\u799B\u7AD1\u7AE7\uFA1C\u7AEB\u7B9E\uFA1D\u7D48\u7D5C\u7DB7\u7DA0\u7DD6\u7E52\u7F47\u7FA1\uFA1E\u8301\u8362\u837F\u83C7\u83F6\u8448\u84B4\u8553\u8559\u856B\uFA1F\u85B0\uFA20\uFA21\u8807\u88F5\u8A12\u8A37\u8A79\u8AA7\u8ABE\u8ADF\uFA22\u8AF6\u8B53\u8B7F\u8CF0\u8CF4\u8D12\u8D76\uFA23\u8ECF\uFA24\uFA25\u9067\u90DE\uFA26\u9115\u9127\u91DA\u91D7\u91DE\u91ED\u91EE\u91E4\u91E5\u9206\u9210\u920A\u923A\u9240\u923C\u924E\u9259\u9251\u9239\u9267\u92A7\u9277\u9278\u92E7\u92D7\u92D9\u92D0\uFA27\u92D5\u92E0\u92D3\u9325\u9321\u92FB\uFA28\u931E\u92FF\u931D\u9302\u9370\u9357\u93A4\u93C6\u93DE\u93F8\u9431\u9445\u9448\u9592\uF9DC\uFA29\u969D\u96AF\u9733\u973B\u9743\u974D\u974F\u9751\u9755\u9857\u9865\uFA2A\uFA2B\u9927\uFA2C\u999E\u9A4E\u9AD9"],
      ["fc40", "\u9ADC\u9B75\u9B72\u9B8F\u9BB1\u9BBB\u9C00\u9D70\u9D6B\uFA2D\u9E19\u9ED1"]
    ];
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/tables/eucjp.json
var require_eucjp = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/tables/eucjp.json"(exports, module) {
    module.exports = [
      ["0", "\0", 127],
      ["8ea1", "\uFF61", 62],
      ["a1a1", "\u3000\u3001\u3002\uFF0C\uFF0E\u30FB\uFF1A\uFF1B\uFF1F\uFF01\u309B\u309C\xB4\uFF40\xA8\uFF3E\uFFE3\uFF3F\u30FD\u30FE\u309D\u309E\u3003\u4EDD\u3005\u3006\u3007\u30FC\u2015\u2010\uFF0F\uFF3C\uFF5E\u2225\uFF5C\u2026\u2025\u2018\u2019\u201C\u201D\uFF08\uFF09\u3014\u3015\uFF3B\uFF3D\uFF5B\uFF5D\u3008", 9, "\uFF0B\uFF0D\xB1\xD7\xF7\uFF1D\u2260\uFF1C\uFF1E\u2266\u2267\u221E\u2234\u2642\u2640\xB0\u2032\u2033\u2103\uFFE5\uFF04\uFFE0\uFFE1\uFF05\uFF03\uFF06\uFF0A\uFF20\xA7\u2606\u2605\u25CB\u25CF\u25CE\u25C7"],
      ["a2a1", "\u25C6\u25A1\u25A0\u25B3\u25B2\u25BD\u25BC\u203B\u3012\u2192\u2190\u2191\u2193\u3013"],
      ["a2ba", "\u2208\u220B\u2286\u2287\u2282\u2283\u222A\u2229"],
      ["a2ca", "\u2227\u2228\uFFE2\u21D2\u21D4\u2200\u2203"],
      ["a2dc", "\u2220\u22A5\u2312\u2202\u2207\u2261\u2252\u226A\u226B\u221A\u223D\u221D\u2235\u222B\u222C"],
      ["a2f2", "\u212B\u2030\u266F\u266D\u266A\u2020\u2021\xB6"],
      ["a2fe", "\u25EF"],
      ["a3b0", "\uFF10", 9],
      ["a3c1", "\uFF21", 25],
      ["a3e1", "\uFF41", 25],
      ["a4a1", "\u3041", 82],
      ["a5a1", "\u30A1", 85],
      ["a6a1", "\u0391", 16, "\u03A3", 6],
      ["a6c1", "\u03B1", 16, "\u03C3", 6],
      ["a7a1", "\u0410", 5, "\u0401\u0416", 25],
      ["a7d1", "\u0430", 5, "\u0451\u0436", 25],
      ["a8a1", "\u2500\u2502\u250C\u2510\u2518\u2514\u251C\u252C\u2524\u2534\u253C\u2501\u2503\u250F\u2513\u251B\u2517\u2523\u2533\u252B\u253B\u254B\u2520\u252F\u2528\u2537\u253F\u251D\u2530\u2525\u2538\u2542"],
      ["ada1", "\u2460", 19, "\u2160", 9],
      ["adc0", "\u3349\u3314\u3322\u334D\u3318\u3327\u3303\u3336\u3351\u3357\u330D\u3326\u3323\u332B\u334A\u333B\u339C\u339D\u339E\u338E\u338F\u33C4\u33A1"],
      ["addf", "\u337B\u301D\u301F\u2116\u33CD\u2121\u32A4", 4, "\u3231\u3232\u3239\u337E\u337D\u337C\u2252\u2261\u222B\u222E\u2211\u221A\u22A5\u2220\u221F\u22BF\u2235\u2229\u222A"],
      ["b0a1", "\u4E9C\u5516\u5A03\u963F\u54C0\u611B\u6328\u59F6\u9022\u8475\u831C\u7A50\u60AA\u63E1\u6E25\u65ED\u8466\u82A6\u9BF5\u6893\u5727\u65A1\u6271\u5B9B\u59D0\u867B\u98F4\u7D62\u7DBE\u9B8E\u6216\u7C9F\u88B7\u5B89\u5EB5\u6309\u6697\u6848\u95C7\u978D\u674F\u4EE5\u4F0A\u4F4D\u4F9D\u5049\u56F2\u5937\u59D4\u5A01\u5C09\u60DF\u610F\u6170\u6613\u6905\u70BA\u754F\u7570\u79FB\u7DAD\u7DEF\u80C3\u840E\u8863\u8B02\u9055\u907A\u533B\u4E95\u4EA5\u57DF\u80B2\u90C1\u78EF\u4E00\u58F1\u6EA2\u9038\u7A32\u8328\u828B\u9C2F\u5141\u5370\u54BD\u54E1\u56E0\u59FB\u5F15\u98F2\u6DEB\u80E4\u852D"],
      ["b1a1", "\u9662\u9670\u96A0\u97FB\u540B\u53F3\u5B87\u70CF\u7FBD\u8FC2\u96E8\u536F\u9D5C\u7ABA\u4E11\u7893\u81FC\u6E26\u5618\u5504\u6B1D\u851A\u9C3B\u59E5\u53A9\u6D66\u74DC\u958F\u5642\u4E91\u904B\u96F2\u834F\u990C\u53E1\u55B6\u5B30\u5F71\u6620\u66F3\u6804\u6C38\u6CF3\u6D29\u745B\u76C8\u7A4E\u9834\u82F1\u885B\u8A60\u92ED\u6DB2\u75AB\u76CA\u99C5\u60A6\u8B01\u8D8A\u95B2\u698E\u53AD\u5186\u5712\u5830\u5944\u5BB4\u5EF6\u6028\u63A9\u63F4\u6CBF\u6F14\u708E\u7114\u7159\u71D5\u733F\u7E01\u8276\u82D1\u8597\u9060\u925B\u9D1B\u5869\u65BC\u6C5A\u7525\u51F9\u592E\u5965\u5F80\u5FDC"],
      ["b2a1", "\u62BC\u65FA\u6A2A\u6B27\u6BB4\u738B\u7FC1\u8956\u9D2C\u9D0E\u9EC4\u5CA1\u6C96\u837B\u5104\u5C4B\u61B6\u81C6\u6876\u7261\u4E59\u4FFA\u5378\u6069\u6E29\u7A4F\u97F3\u4E0B\u5316\u4EEE\u4F55\u4F3D\u4FA1\u4F73\u52A0\u53EF\u5609\u590F\u5AC1\u5BB6\u5BE1\u79D1\u6687\u679C\u67B6\u6B4C\u6CB3\u706B\u73C2\u798D\u79BE\u7A3C\u7B87\u82B1\u82DB\u8304\u8377\u83EF\u83D3\u8766\u8AB2\u5629\u8CA8\u8FE6\u904E\u971E\u868A\u4FC4\u5CE8\u6211\u7259\u753B\u81E5\u82BD\u86FE\u8CC0\u96C5\u9913\u99D5\u4ECB\u4F1A\u89E3\u56DE\u584A\u58CA\u5EFB\u5FEB\u602A\u6094\u6062\u61D0\u6212\u62D0\u6539"],
      ["b3a1", "\u9B41\u6666\u68B0\u6D77\u7070\u754C\u7686\u7D75\u82A5\u87F9\u958B\u968E\u8C9D\u51F1\u52BE\u5916\u54B3\u5BB3\u5D16\u6168\u6982\u6DAF\u788D\u84CB\u8857\u8A72\u93A7\u9AB8\u6D6C\u99A8\u86D9\u57A3\u67FF\u86CE\u920E\u5283\u5687\u5404\u5ED3\u62E1\u64B9\u683C\u6838\u6BBB\u7372\u78BA\u7A6B\u899A\u89D2\u8D6B\u8F03\u90ED\u95A3\u9694\u9769\u5B66\u5CB3\u697D\u984D\u984E\u639B\u7B20\u6A2B\u6A7F\u68B6\u9C0D\u6F5F\u5272\u559D\u6070\u62EC\u6D3B\u6E07\u6ED1\u845B\u8910\u8F44\u4E14\u9C39\u53F6\u691B\u6A3A\u9784\u682A\u515C\u7AC3\u84B2\u91DC\u938C\u565B\u9D28\u6822\u8305\u8431"],
      ["b4a1", "\u7CA5\u5208\u82C5\u74E6\u4E7E\u4F83\u51A0\u5BD2\u520A\u52D8\u52E7\u5DFB\u559A\u582A\u59E6\u5B8C\u5B98\u5BDB\u5E72\u5E79\u60A3\u611F\u6163\u61BE\u63DB\u6562\u67D1\u6853\u68FA\u6B3E\u6B53\u6C57\u6F22\u6F97\u6F45\u74B0\u7518\u76E3\u770B\u7AFF\u7BA1\u7C21\u7DE9\u7F36\u7FF0\u809D\u8266\u839E\u89B3\u8ACC\u8CAB\u9084\u9451\u9593\u9591\u95A2\u9665\u97D3\u9928\u8218\u4E38\u542B\u5CB8\u5DCC\u73A9\u764C\u773C\u5CA9\u7FEB\u8D0B\u96C1\u9811\u9854\u9858\u4F01\u4F0E\u5371\u559C\u5668\u57FA\u5947\u5B09\u5BC4\u5C90\u5E0C\u5E7E\u5FCC\u63EE\u673A\u65D7\u65E2\u671F\u68CB\u68C4"],
      ["b5a1", "\u6A5F\u5E30\u6BC5\u6C17\u6C7D\u757F\u7948\u5B63\u7A00\u7D00\u5FBD\u898F\u8A18\u8CB4\u8D77\u8ECC\u8F1D\u98E2\u9A0E\u9B3C\u4E80\u507D\u5100\u5993\u5B9C\u622F\u6280\u64EC\u6B3A\u72A0\u7591\u7947\u7FA9\u87FB\u8ABC\u8B70\u63AC\u83CA\u97A0\u5409\u5403\u55AB\u6854\u6A58\u8A70\u7827\u6775\u9ECD\u5374\u5BA2\u811A\u8650\u9006\u4E18\u4E45\u4EC7\u4F11\u53CA\u5438\u5BAE\u5F13\u6025\u6551\u673D\u6C42\u6C72\u6CE3\u7078\u7403\u7A76\u7AAE\u7B08\u7D1A\u7CFE\u7D66\u65E7\u725B\u53BB\u5C45\u5DE8\u62D2\u62E0\u6319\u6E20\u865A\u8A31\u8DDD\u92F8\u6F01\u79A6\u9B5A\u4EA8\u4EAB\u4EAC"],
      ["b6a1", "\u4F9B\u4FA0\u50D1\u5147\u7AF6\u5171\u51F6\u5354\u5321\u537F\u53EB\u55AC\u5883\u5CE1\u5F37\u5F4A\u602F\u6050\u606D\u631F\u6559\u6A4B\u6CC1\u72C2\u72ED\u77EF\u80F8\u8105\u8208\u854E\u90F7\u93E1\u97FF\u9957\u9A5A\u4EF0\u51DD\u5C2D\u6681\u696D\u5C40\u66F2\u6975\u7389\u6850\u7C81\u50C5\u52E4\u5747\u5DFE\u9326\u65A4\u6B23\u6B3D\u7434\u7981\u79BD\u7B4B\u7DCA\u82B9\u83CC\u887F\u895F\u8B39\u8FD1\u91D1\u541F\u9280\u4E5D\u5036\u53E5\u533A\u72D7\u7396\u77E9\u82E6\u8EAF\u99C6\u99C8\u99D2\u5177\u611A\u865E\u55B0\u7A7A\u5076\u5BD3\u9047\u9685\u4E32\u6ADB\u91E7\u5C51\u5C48"],
      ["b7a1", "\u6398\u7A9F\u6C93\u9774\u8F61\u7AAA\u718A\u9688\u7C82\u6817\u7E70\u6851\u936C\u52F2\u541B\u85AB\u8A13\u7FA4\u8ECD\u90E1\u5366\u8888\u7941\u4FC2\u50BE\u5211\u5144\u5553\u572D\u73EA\u578B\u5951\u5F62\u5F84\u6075\u6176\u6167\u61A9\u63B2\u643A\u656C\u666F\u6842\u6E13\u7566\u7A3D\u7CFB\u7D4C\u7D99\u7E4B\u7F6B\u830E\u834A\u86CD\u8A08\u8A63\u8B66\u8EFD\u981A\u9D8F\u82B8\u8FCE\u9BE8\u5287\u621F\u6483\u6FC0\u9699\u6841\u5091\u6B20\u6C7A\u6F54\u7A74\u7D50\u8840\u8A23\u6708\u4EF6\u5039\u5026\u5065\u517C\u5238\u5263\u55A7\u570F\u5805\u5ACC\u5EFA\u61B2\u61F8\u62F3\u6372"],
      ["b8a1", "\u691C\u6A29\u727D\u72AC\u732E\u7814\u786F\u7D79\u770C\u80A9\u898B\u8B19\u8CE2\u8ED2\u9063\u9375\u967A\u9855\u9A13\u9E78\u5143\u539F\u53B3\u5E7B\u5F26\u6E1B\u6E90\u7384\u73FE\u7D43\u8237\u8A00\u8AFA\u9650\u4E4E\u500B\u53E4\u547C\u56FA\u59D1\u5B64\u5DF1\u5EAB\u5F27\u6238\u6545\u67AF\u6E56\u72D0\u7CCA\u88B4\u80A1\u80E1\u83F0\u864E\u8A87\u8DE8\u9237\u96C7\u9867\u9F13\u4E94\u4E92\u4F0D\u5348\u5449\u543E\u5A2F\u5F8C\u5FA1\u609F\u68A7\u6A8E\u745A\u7881\u8A9E\u8AA4\u8B77\u9190\u4E5E\u9BC9\u4EA4\u4F7C\u4FAF\u5019\u5016\u5149\u516C\u529F\u52B9\u52FE\u539A\u53E3\u5411"],
      ["b9a1", "\u540E\u5589\u5751\u57A2\u597D\u5B54\u5B5D\u5B8F\u5DE5\u5DE7\u5DF7\u5E78\u5E83\u5E9A\u5EB7\u5F18\u6052\u614C\u6297\u62D8\u63A7\u653B\u6602\u6643\u66F4\u676D\u6821\u6897\u69CB\u6C5F\u6D2A\u6D69\u6E2F\u6E9D\u7532\u7687\u786C\u7A3F\u7CE0\u7D05\u7D18\u7D5E\u7DB1\u8015\u8003\u80AF\u80B1\u8154\u818F\u822A\u8352\u884C\u8861\u8B1B\u8CA2\u8CFC\u90CA\u9175\u9271\u783F\u92FC\u95A4\u964D\u9805\u9999\u9AD8\u9D3B\u525B\u52AB\u53F7\u5408\u58D5\u62F7\u6FE0\u8C6A\u8F5F\u9EB9\u514B\u523B\u544A\u56FD\u7A40\u9177\u9D60\u9ED2\u7344\u6F09\u8170\u7511\u5FFD\u60DA\u9AA8\u72DB\u8FBC"],
      ["baa1", "\u6B64\u9803\u4ECA\u56F0\u5764\u58BE\u5A5A\u6068\u61C7\u660F\u6606\u6839\u68B1\u6DF7\u75D5\u7D3A\u826E\u9B42\u4E9B\u4F50\u53C9\u5506\u5D6F\u5DE6\u5DEE\u67FB\u6C99\u7473\u7802\u8A50\u9396\u88DF\u5750\u5EA7\u632B\u50B5\u50AC\u518D\u6700\u54C9\u585E\u59BB\u5BB0\u5F69\u624D\u63A1\u683D\u6B73\u6E08\u707D\u91C7\u7280\u7815\u7826\u796D\u658E\u7D30\u83DC\u88C1\u8F09\u969B\u5264\u5728\u6750\u7F6A\u8CA1\u51B4\u5742\u962A\u583A\u698A\u80B4\u54B2\u5D0E\u57FC\u7895\u9DFA\u4F5C\u524A\u548B\u643E\u6628\u6714\u67F5\u7A84\u7B56\u7D22\u932F\u685C\u9BAD\u7B39\u5319\u518A\u5237"],
      ["bba1", "\u5BDF\u62F6\u64AE\u64E6\u672D\u6BBA\u85A9\u96D1\u7690\u9BD6\u634C\u9306\u9BAB\u76BF\u6652\u4E09\u5098\u53C2\u5C71\u60E8\u6492\u6563\u685F\u71E6\u73CA\u7523\u7B97\u7E82\u8695\u8B83\u8CDB\u9178\u9910\u65AC\u66AB\u6B8B\u4ED5\u4ED4\u4F3A\u4F7F\u523A\u53F8\u53F2\u55E3\u56DB\u58EB\u59CB\u59C9\u59FF\u5B50\u5C4D\u5E02\u5E2B\u5FD7\u601D\u6307\u652F\u5B5C\u65AF\u65BD\u65E8\u679D\u6B62\u6B7B\u6C0F\u7345\u7949\u79C1\u7CF8\u7D19\u7D2B\u80A2\u8102\u81F3\u8996\u8A5E\u8A69\u8A66\u8A8C\u8AEE\u8CC7\u8CDC\u96CC\u98FC\u6B6F\u4E8B\u4F3C\u4F8D\u5150\u5B57\u5BFA\u6148\u6301\u6642"],
      ["bca1", "\u6B21\u6ECB\u6CBB\u723E\u74BD\u75D4\u78C1\u793A\u800C\u8033\u81EA\u8494\u8F9E\u6C50\u9E7F\u5F0F\u8B58\u9D2B\u7AFA\u8EF8\u5B8D\u96EB\u4E03\u53F1\u57F7\u5931\u5AC9\u5BA4\u6089\u6E7F\u6F06\u75BE\u8CEA\u5B9F\u8500\u7BE0\u5072\u67F4\u829D\u5C61\u854A\u7E1E\u820E\u5199\u5C04\u6368\u8D66\u659C\u716E\u793E\u7D17\u8005\u8B1D\u8ECA\u906E\u86C7\u90AA\u501F\u52FA\u5C3A\u6753\u707C\u7235\u914C\u91C8\u932B\u82E5\u5BC2\u5F31\u60F9\u4E3B\u53D6\u5B88\u624B\u6731\u6B8A\u72E9\u73E0\u7A2E\u816B\u8DA3\u9152\u9996\u5112\u53D7\u546A\u5BFF\u6388\u6A39\u7DAC\u9700\u56DA\u53CE\u5468"],
      ["bda1", "\u5B97\u5C31\u5DDE\u4FEE\u6101\u62FE\u6D32\u79C0\u79CB\u7D42\u7E4D\u7FD2\u81ED\u821F\u8490\u8846\u8972\u8B90\u8E74\u8F2F\u9031\u914B\u916C\u96C6\u919C\u4EC0\u4F4F\u5145\u5341\u5F93\u620E\u67D4\u6C41\u6E0B\u7363\u7E26\u91CD\u9283\u53D4\u5919\u5BBF\u6DD1\u795D\u7E2E\u7C9B\u587E\u719F\u51FA\u8853\u8FF0\u4FCA\u5CFB\u6625\u77AC\u7AE3\u821C\u99FF\u51C6\u5FAA\u65EC\u696F\u6B89\u6DF3\u6E96\u6F64\u76FE\u7D14\u5DE1\u9075\u9187\u9806\u51E6\u521D\u6240\u6691\u66D9\u6E1A\u5EB6\u7DD2\u7F72\u66F8\u85AF\u85F7\u8AF8\u52A9\u53D9\u5973\u5E8F\u5F90\u6055\u92E4\u9664\u50B7\u511F"],
      ["bea1", "\u52DD\u5320\u5347\u53EC\u54E8\u5546\u5531\u5617\u5968\u59BE\u5A3C\u5BB5\u5C06\u5C0F\u5C11\u5C1A\u5E84\u5E8A\u5EE0\u5F70\u627F\u6284\u62DB\u638C\u6377\u6607\u660C\u662D\u6676\u677E\u68A2\u6A1F\u6A35\u6CBC\u6D88\u6E09\u6E58\u713C\u7126\u7167\u75C7\u7701\u785D\u7901\u7965\u79F0\u7AE0\u7B11\u7CA7\u7D39\u8096\u83D6\u848B\u8549\u885D\u88F3\u8A1F\u8A3C\u8A54\u8A73\u8C61\u8CDE\u91A4\u9266\u937E\u9418\u969C\u9798\u4E0A\u4E08\u4E1E\u4E57\u5197\u5270\u57CE\u5834\u58CC\u5B22\u5E38\u60C5\u64FE\u6761\u6756\u6D44\u72B6\u7573\u7A63\u84B8\u8B72\u91B8\u9320\u5631\u57F4\u98FE"],
      ["bfa1", "\u62ED\u690D\u6B96\u71ED\u7E54\u8077\u8272\u89E6\u98DF\u8755\u8FB1\u5C3B\u4F38\u4FE1\u4FB5\u5507\u5A20\u5BDD\u5BE9\u5FC3\u614E\u632F\u65B0\u664B\u68EE\u699B\u6D78\u6DF1\u7533\u75B9\u771F\u795E\u79E6\u7D33\u81E3\u82AF\u85AA\u89AA\u8A3A\u8EAB\u8F9B\u9032\u91DD\u9707\u4EBA\u4EC1\u5203\u5875\u58EC\u5C0B\u751A\u5C3D\u814E\u8A0A\u8FC5\u9663\u976D\u7B25\u8ACF\u9808\u9162\u56F3\u53A8\u9017\u5439\u5782\u5E25\u63A8\u6C34\u708A\u7761\u7C8B\u7FE0\u8870\u9042\u9154\u9310\u9318\u968F\u745E\u9AC4\u5D07\u5D69\u6570\u67A2\u8DA8\u96DB\u636E\u6749\u6919\u83C5\u9817\u96C0\u88FE"],
      ["c0a1", "\u6F84\u647A\u5BF8\u4E16\u702C\u755D\u662F\u51C4\u5236\u52E2\u59D3\u5F81\u6027\u6210\u653F\u6574\u661F\u6674\u68F2\u6816\u6B63\u6E05\u7272\u751F\u76DB\u7CBE\u8056\u58F0\u88FD\u897F\u8AA0\u8A93\u8ACB\u901D\u9192\u9752\u9759\u6589\u7A0E\u8106\u96BB\u5E2D\u60DC\u621A\u65A5\u6614\u6790\u77F3\u7A4D\u7C4D\u7E3E\u810A\u8CAC\u8D64\u8DE1\u8E5F\u78A9\u5207\u62D9\u63A5\u6442\u6298\u8A2D\u7A83\u7BC0\u8AAC\u96EA\u7D76\u820C\u8749\u4ED9\u5148\u5343\u5360\u5BA3\u5C02\u5C16\u5DDD\u6226\u6247\u64B0\u6813\u6834\u6CC9\u6D45\u6D17\u67D3\u6F5C\u714E\u717D\u65CB\u7A7F\u7BAD\u7DDA"],
      ["c1a1", "\u7E4A\u7FA8\u817A\u821B\u8239\u85A6\u8A6E\u8CCE\u8DF5\u9078\u9077\u92AD\u9291\u9583\u9BAE\u524D\u5584\u6F38\u7136\u5168\u7985\u7E55\u81B3\u7CCE\u564C\u5851\u5CA8\u63AA\u66FE\u66FD\u695A\u72D9\u758F\u758E\u790E\u7956\u79DF\u7C97\u7D20\u7D44\u8607\u8A34\u963B\u9061\u9F20\u50E7\u5275\u53CC\u53E2\u5009\u55AA\u58EE\u594F\u723D\u5B8B\u5C64\u531D\u60E3\u60F3\u635C\u6383\u633F\u63BB\u64CD\u65E9\u66F9\u5DE3\u69CD\u69FD\u6F15\u71E5\u4E89\u75E9\u76F8\u7A93\u7CDF\u7DCF\u7D9C\u8061\u8349\u8358\u846C\u84BC\u85FB\u88C5\u8D70\u9001\u906D\u9397\u971C\u9A12\u50CF\u5897\u618E"],
      ["c2a1", "\u81D3\u8535\u8D08\u9020\u4FC3\u5074\u5247\u5373\u606F\u6349\u675F\u6E2C\u8DB3\u901F\u4FD7\u5C5E\u8CCA\u65CF\u7D9A\u5352\u8896\u5176\u63C3\u5B58\u5B6B\u5C0A\u640D\u6751\u905C\u4ED6\u591A\u592A\u6C70\u8A51\u553E\u5815\u59A5\u60F0\u6253\u67C1\u8235\u6955\u9640\u99C4\u9A28\u4F53\u5806\u5BFE\u8010\u5CB1\u5E2F\u5F85\u6020\u614B\u6234\u66FF\u6CF0\u6EDE\u80CE\u817F\u82D4\u888B\u8CB8\u9000\u902E\u968A\u9EDB\u9BDB\u4EE3\u53F0\u5927\u7B2C\u918D\u984C\u9DF9\u6EDD\u7027\u5353\u5544\u5B85\u6258\u629E\u62D3\u6CA2\u6FEF\u7422\u8A17\u9438\u6FC1\u8AFE\u8338\u51E7\u86F8\u53EA"],
      ["c3a1", "\u53E9\u4F46\u9054\u8FB0\u596A\u8131\u5DFD\u7AEA\u8FBF\u68DA\u8C37\u72F8\u9C48\u6A3D\u8AB0\u4E39\u5358\u5606\u5766\u62C5\u63A2\u65E6\u6B4E\u6DE1\u6E5B\u70AD\u77ED\u7AEF\u7BAA\u7DBB\u803D\u80C6\u86CB\u8A95\u935B\u56E3\u58C7\u5F3E\u65AD\u6696\u6A80\u6BB5\u7537\u8AC7\u5024\u77E5\u5730\u5F1B\u6065\u667A\u6C60\u75F4\u7A1A\u7F6E\u81F4\u8718\u9045\u99B3\u7BC9\u755C\u7AF9\u7B51\u84C4\u9010\u79E9\u7A92\u8336\u5AE1\u7740\u4E2D\u4EF2\u5B99\u5FE0\u62BD\u663C\u67F1\u6CE8\u866B\u8877\u8A3B\u914E\u92F3\u99D0\u6A17\u7026\u732A\u82E7\u8457\u8CAF\u4E01\u5146\u51CB\u558B\u5BF5"],
      ["c4a1", "\u5E16\u5E33\u5E81\u5F14\u5F35\u5F6B\u5FB4\u61F2\u6311\u66A2\u671D\u6F6E\u7252\u753A\u773A\u8074\u8139\u8178\u8776\u8ABF\u8ADC\u8D85\u8DF3\u929A\u9577\u9802\u9CE5\u52C5\u6357\u76F4\u6715\u6C88\u73CD\u8CC3\u93AE\u9673\u6D25\u589C\u690E\u69CC\u8FFD\u939A\u75DB\u901A\u585A\u6802\u63B4\u69FB\u4F43\u6F2C\u67D8\u8FBB\u8526\u7DB4\u9354\u693F\u6F70\u576A\u58F7\u5B2C\u7D2C\u722A\u540A\u91E3\u9DB4\u4EAD\u4F4E\u505C\u5075\u5243\u8C9E\u5448\u5824\u5B9A\u5E1D\u5E95\u5EAD\u5EF7\u5F1F\u608C\u62B5\u633A\u63D0\u68AF\u6C40\u7887\u798E\u7A0B\u7DE0\u8247\u8A02\u8AE6\u8E44\u9013"],
      ["c5a1", "\u90B8\u912D\u91D8\u9F0E\u6CE5\u6458\u64E2\u6575\u6EF4\u7684\u7B1B\u9069\u93D1\u6EBA\u54F2\u5FB9\u64A4\u8F4D\u8FED\u9244\u5178\u586B\u5929\u5C55\u5E97\u6DFB\u7E8F\u751C\u8CBC\u8EE2\u985B\u70B9\u4F1D\u6BBF\u6FB1\u7530\u96FB\u514E\u5410\u5835\u5857\u59AC\u5C60\u5F92\u6597\u675C\u6E21\u767B\u83DF\u8CED\u9014\u90FD\u934D\u7825\u783A\u52AA\u5EA6\u571F\u5974\u6012\u5012\u515A\u51AC\u51CD\u5200\u5510\u5854\u5858\u5957\u5B95\u5CF6\u5D8B\u60BC\u6295\u642D\u6771\u6843\u68BC\u68DF\u76D7\u6DD8\u6E6F\u6D9B\u706F\u71C8\u5F53\u75D8\u7977\u7B49\u7B54\u7B52\u7CD6\u7D71\u5230"],
      ["c6a1", "\u8463\u8569\u85E4\u8A0E\u8B04\u8C46\u8E0F\u9003\u900F\u9419\u9676\u982D\u9A30\u95D8\u50CD\u52D5\u540C\u5802\u5C0E\u61A7\u649E\u6D1E\u77B3\u7AE5\u80F4\u8404\u9053\u9285\u5CE0\u9D07\u533F\u5F97\u5FB3\u6D9C\u7279\u7763\u79BF\u7BE4\u6BD2\u72EC\u8AAD\u6803\u6A61\u51F8\u7A81\u6934\u5C4A\u9CF6\u82EB\u5BC5\u9149\u701E\u5678\u5C6F\u60C7\u6566\u6C8C\u8C5A\u9041\u9813\u5451\u66C7\u920D\u5948\u90A3\u5185\u4E4D\u51EA\u8599\u8B0E\u7058\u637A\u934B\u6962\u99B4\u7E04\u7577\u5357\u6960\u8EDF\u96E3\u6C5D\u4E8C\u5C3C\u5F10\u8FE9\u5302\u8CD1\u8089\u8679\u5EFF\u65E5\u4E73\u5165"],
      ["c7a1", "\u5982\u5C3F\u97EE\u4EFB\u598A\u5FCD\u8A8D\u6FE1\u79B0\u7962\u5BE7\u8471\u732B\u71B1\u5E74\u5FF5\u637B\u649A\u71C3\u7C98\u4E43\u5EFC\u4E4B\u57DC\u56A2\u60A9\u6FC3\u7D0D\u80FD\u8133\u81BF\u8FB2\u8997\u86A4\u5DF4\u628A\u64AD\u8987\u6777\u6CE2\u6D3E\u7436\u7834\u5A46\u7F75\u82AD\u99AC\u4FF3\u5EC3\u62DD\u6392\u6557\u676F\u76C3\u724C\u80CC\u80BA\u8F29\u914D\u500D\u57F9\u5A92\u6885\u6973\u7164\u72FD\u8CB7\u58F2\u8CE0\u966A\u9019\u877F\u79E4\u77E7\u8429\u4F2F\u5265\u535A\u62CD\u67CF\u6CCA\u767D\u7B94\u7C95\u8236\u8584\u8FEB\u66DD\u6F20\u7206\u7E1B\u83AB\u99C1\u9EA6"],
      ["c8a1", "\u51FD\u7BB1\u7872\u7BB8\u8087\u7B48\u6AE8\u5E61\u808C\u7551\u7560\u516B\u9262\u6E8C\u767A\u9197\u9AEA\u4F10\u7F70\u629C\u7B4F\u95A5\u9CE9\u567A\u5859\u86E4\u96BC\u4F34\u5224\u534A\u53CD\u53DB\u5E06\u642C\u6591\u677F\u6C3E\u6C4E\u7248\u72AF\u73ED\u7554\u7E41\u822C\u85E9\u8CA9\u7BC4\u91C6\u7169\u9812\u98EF\u633D\u6669\u756A\u76E4\u78D0\u8543\u86EE\u532A\u5351\u5426\u5983\u5E87\u5F7C\u60B2\u6249\u6279\u62AB\u6590\u6BD4\u6CCC\u75B2\u76AE\u7891\u79D8\u7DCB\u7F77\u80A5\u88AB\u8AB9\u8CBB\u907F\u975E\u98DB\u6A0B\u7C38\u5099\u5C3E\u5FAE\u6787\u6BD8\u7435\u7709\u7F8E"],
      ["c9a1", "\u9F3B\u67CA\u7A17\u5339\u758B\u9AED\u5F66\u819D\u83F1\u8098\u5F3C\u5FC5\u7562\u7B46\u903C\u6867\u59EB\u5A9B\u7D10\u767E\u8B2C\u4FF5\u5F6A\u6A19\u6C37\u6F02\u74E2\u7968\u8868\u8A55\u8C79\u5EDF\u63CF\u75C5\u79D2\u82D7\u9328\u92F2\u849C\u86ED\u9C2D\u54C1\u5F6C\u658C\u6D5C\u7015\u8CA7\u8CD3\u983B\u654F\u74F6\u4E0D\u4ED8\u57E0\u592B\u5A66\u5BCC\u51A8\u5E03\u5E9C\u6016\u6276\u6577\u65A7\u666E\u6D6E\u7236\u7B26\u8150\u819A\u8299\u8B5C\u8CA0\u8CE6\u8D74\u961C\u9644\u4FAE\u64AB\u6B66\u821E\u8461\u856A\u90E8\u5C01\u6953\u98A8\u847A\u8557\u4F0F\u526F\u5FA9\u5E45\u670D"],
      ["caa1", "\u798F\u8179\u8907\u8986\u6DF5\u5F17\u6255\u6CB8\u4ECF\u7269\u9B92\u5206\u543B\u5674\u58B3\u61A4\u626E\u711A\u596E\u7C89\u7CDE\u7D1B\u96F0\u6587\u805E\u4E19\u4F75\u5175\u5840\u5E63\u5E73\u5F0A\u67C4\u4E26\u853D\u9589\u965B\u7C73\u9801\u50FB\u58C1\u7656\u78A7\u5225\u77A5\u8511\u7B86\u504F\u5909\u7247\u7BC7\u7DE8\u8FBA\u8FD4\u904D\u4FBF\u52C9\u5A29\u5F01\u97AD\u4FDD\u8217\u92EA\u5703\u6355\u6B69\u752B\u88DC\u8F14\u7A42\u52DF\u5893\u6155\u620A\u66AE\u6BCD\u7C3F\u83E9\u5023\u4FF8\u5305\u5446\u5831\u5949\u5B9D\u5CF0\u5CEF\u5D29\u5E96\u62B1\u6367\u653E\u65B9\u670B"],
      ["cba1", "\u6CD5\u6CE1\u70F9\u7832\u7E2B\u80DE\u82B3\u840C\u84EC\u8702\u8912\u8A2A\u8C4A\u90A6\u92D2\u98FD\u9CF3\u9D6C\u4E4F\u4EA1\u508D\u5256\u574A\u59A8\u5E3D\u5FD8\u5FD9\u623F\u66B4\u671B\u67D0\u68D2\u5192\u7D21\u80AA\u81A8\u8B00\u8C8C\u8CBF\u927E\u9632\u5420\u982C\u5317\u50D5\u535C\u58A8\u64B2\u6734\u7267\u7766\u7A46\u91E6\u52C3\u6CA1\u6B86\u5800\u5E4C\u5954\u672C\u7FFB\u51E1\u76C6\u6469\u78E8\u9B54\u9EBB\u57CB\u59B9\u6627\u679A\u6BCE\u54E9\u69D9\u5E55\u819C\u6795\u9BAA\u67FE\u9C52\u685D\u4EA6\u4FE3\u53C8\u62B9\u672B\u6CAB\u8FC4\u4FAD\u7E6D\u9EBF\u4E07\u6162\u6E80"],
      ["cca1", "\u6F2B\u8513\u5473\u672A\u9B45\u5DF3\u7B95\u5CAC\u5BC6\u871C\u6E4A\u84D1\u7A14\u8108\u5999\u7C8D\u6C11\u7720\u52D9\u5922\u7121\u725F\u77DB\u9727\u9D61\u690B\u5A7F\u5A18\u51A5\u540D\u547D\u660E\u76DF\u8FF7\u9298\u9CF4\u59EA\u725D\u6EC5\u514D\u68C9\u7DBF\u7DEC\u9762\u9EBA\u6478\u6A21\u8302\u5984\u5B5F\u6BDB\u731B\u76F2\u7DB2\u8017\u8499\u5132\u6728\u9ED9\u76EE\u6762\u52FF\u9905\u5C24\u623B\u7C7E\u8CB0\u554F\u60B6\u7D0B\u9580\u5301\u4E5F\u51B6\u591C\u723A\u8036\u91CE\u5F25\u77E2\u5384\u5F79\u7D04\u85AC\u8A33\u8E8D\u9756\u67F3\u85AE\u9453\u6109\u6108\u6CB9\u7652"],
      ["cda1", "\u8AED\u8F38\u552F\u4F51\u512A\u52C7\u53CB\u5BA5\u5E7D\u60A0\u6182\u63D6\u6709\u67DA\u6E67\u6D8C\u7336\u7337\u7531\u7950\u88D5\u8A98\u904A\u9091\u90F5\u96C4\u878D\u5915\u4E88\u4F59\u4E0E\u8A89\u8F3F\u9810\u50AD\u5E7C\u5996\u5BB9\u5EB8\u63DA\u63FA\u64C1\u66DC\u694A\u69D8\u6D0B\u6EB6\u7194\u7528\u7AAF\u7F8A\u8000\u8449\u84C9\u8981\u8B21\u8E0A\u9065\u967D\u990A\u617E\u6291\u6B32\u6C83\u6D74\u7FCC\u7FFC\u6DC0\u7F85\u87BA\u88F8\u6765\u83B1\u983C\u96F7\u6D1B\u7D61\u843D\u916A\u4E71\u5375\u5D50\u6B04\u6FEB\u85CD\u862D\u89A7\u5229\u540F\u5C65\u674E\u68A8\u7406\u7483"],
      ["cea1", "\u75E2\u88CF\u88E1\u91CC\u96E2\u9678\u5F8B\u7387\u7ACB\u844E\u63A0\u7565\u5289\u6D41\u6E9C\u7409\u7559\u786B\u7C92\u9686\u7ADC\u9F8D\u4FB6\u616E\u65C5\u865C\u4E86\u4EAE\u50DA\u4E21\u51CC\u5BEE\u6599\u6881\u6DBC\u731F\u7642\u77AD\u7A1C\u7CE7\u826F\u8AD2\u907C\u91CF\u9675\u9818\u529B\u7DD1\u502B\u5398\u6797\u6DCB\u71D0\u7433\u81E8\u8F2A\u96A3\u9C57\u9E9F\u7460\u5841\u6D99\u7D2F\u985E\u4EE4\u4F36\u4F8B\u51B7\u52B1\u5DBA\u601C\u73B2\u793C\u82D3\u9234\u96B7\u96F6\u970A\u9E97\u9F62\u66A6\u6B74\u5217\u52A3\u70C8\u88C2\u5EC9\u604B\u6190\u6F23\u7149\u7C3E\u7DF4\u806F"],
      ["cfa1", "\u84EE\u9023\u932C\u5442\u9B6F\u6AD3\u7089\u8CC2\u8DEF\u9732\u52B4\u5A41\u5ECA\u5F04\u6717\u697C\u6994\u6D6A\u6F0F\u7262\u72FC\u7BED\u8001\u807E\u874B\u90CE\u516D\u9E93\u7984\u808B\u9332\u8AD6\u502D\u548C\u8A71\u6B6A\u8CC4\u8107\u60D1\u67A0\u9DF2\u4E99\u4E98\u9C10\u8A6B\u85C1\u8568\u6900\u6E7E\u7897\u8155"],
      ["d0a1", "\u5F0C\u4E10\u4E15\u4E2A\u4E31\u4E36\u4E3C\u4E3F\u4E42\u4E56\u4E58\u4E82\u4E85\u8C6B\u4E8A\u8212\u5F0D\u4E8E\u4E9E\u4E9F\u4EA0\u4EA2\u4EB0\u4EB3\u4EB6\u4ECE\u4ECD\u4EC4\u4EC6\u4EC2\u4ED7\u4EDE\u4EED\u4EDF\u4EF7\u4F09\u4F5A\u4F30\u4F5B\u4F5D\u4F57\u4F47\u4F76\u4F88\u4F8F\u4F98\u4F7B\u4F69\u4F70\u4F91\u4F6F\u4F86\u4F96\u5118\u4FD4\u4FDF\u4FCE\u4FD8\u4FDB\u4FD1\u4FDA\u4FD0\u4FE4\u4FE5\u501A\u5028\u5014\u502A\u5025\u5005\u4F1C\u4FF6\u5021\u5029\u502C\u4FFE\u4FEF\u5011\u5006\u5043\u5047\u6703\u5055\u5050\u5048\u505A\u5056\u506C\u5078\u5080\u509A\u5085\u50B4\u50B2"],
      ["d1a1", "\u50C9\u50CA\u50B3\u50C2\u50D6\u50DE\u50E5\u50ED\u50E3\u50EE\u50F9\u50F5\u5109\u5101\u5102\u5116\u5115\u5114\u511A\u5121\u513A\u5137\u513C\u513B\u513F\u5140\u5152\u514C\u5154\u5162\u7AF8\u5169\u516A\u516E\u5180\u5182\u56D8\u518C\u5189\u518F\u5191\u5193\u5195\u5196\u51A4\u51A6\u51A2\u51A9\u51AA\u51AB\u51B3\u51B1\u51B2\u51B0\u51B5\u51BD\u51C5\u51C9\u51DB\u51E0\u8655\u51E9\u51ED\u51F0\u51F5\u51FE\u5204\u520B\u5214\u520E\u5227\u522A\u522E\u5233\u5239\u524F\u5244\u524B\u524C\u525E\u5254\u526A\u5274\u5269\u5273\u527F\u527D\u528D\u5294\u5292\u5271\u5288\u5291\u8FA8"],
      ["d2a1", "\u8FA7\u52AC\u52AD\u52BC\u52B5\u52C1\u52CD\u52D7\u52DE\u52E3\u52E6\u98ED\u52E0\u52F3\u52F5\u52F8\u52F9\u5306\u5308\u7538\u530D\u5310\u530F\u5315\u531A\u5323\u532F\u5331\u5333\u5338\u5340\u5346\u5345\u4E17\u5349\u534D\u51D6\u535E\u5369\u536E\u5918\u537B\u5377\u5382\u5396\u53A0\u53A6\u53A5\u53AE\u53B0\u53B6\u53C3\u7C12\u96D9\u53DF\u66FC\u71EE\u53EE\u53E8\u53ED\u53FA\u5401\u543D\u5440\u542C\u542D\u543C\u542E\u5436\u5429\u541D\u544E\u548F\u5475\u548E\u545F\u5471\u5477\u5470\u5492\u547B\u5480\u5476\u5484\u5490\u5486\u54C7\u54A2\u54B8\u54A5\u54AC\u54C4\u54C8\u54A8"],
      ["d3a1", "\u54AB\u54C2\u54A4\u54BE\u54BC\u54D8\u54E5\u54E6\u550F\u5514\u54FD\u54EE\u54ED\u54FA\u54E2\u5539\u5540\u5563\u554C\u552E\u555C\u5545\u5556\u5557\u5538\u5533\u555D\u5599\u5580\u54AF\u558A\u559F\u557B\u557E\u5598\u559E\u55AE\u557C\u5583\u55A9\u5587\u55A8\u55DA\u55C5\u55DF\u55C4\u55DC\u55E4\u55D4\u5614\u55F7\u5616\u55FE\u55FD\u561B\u55F9\u564E\u5650\u71DF\u5634\u5636\u5632\u5638\u566B\u5664\u562F\u566C\u566A\u5686\u5680\u568A\u56A0\u5694\u568F\u56A5\u56AE\u56B6\u56B4\u56C2\u56BC\u56C1\u56C3\u56C0\u56C8\u56CE\u56D1\u56D3\u56D7\u56EE\u56F9\u5700\u56FF\u5704\u5709"],
      ["d4a1", "\u5708\u570B\u570D\u5713\u5718\u5716\u55C7\u571C\u5726\u5737\u5738\u574E\u573B\u5740\u574F\u5769\u57C0\u5788\u5761\u577F\u5789\u5793\u57A0\u57B3\u57A4\u57AA\u57B0\u57C3\u57C6\u57D4\u57D2\u57D3\u580A\u57D6\u57E3\u580B\u5819\u581D\u5872\u5821\u5862\u584B\u5870\u6BC0\u5852\u583D\u5879\u5885\u58B9\u589F\u58AB\u58BA\u58DE\u58BB\u58B8\u58AE\u58C5\u58D3\u58D1\u58D7\u58D9\u58D8\u58E5\u58DC\u58E4\u58DF\u58EF\u58FA\u58F9\u58FB\u58FC\u58FD\u5902\u590A\u5910\u591B\u68A6\u5925\u592C\u592D\u5932\u5938\u593E\u7AD2\u5955\u5950\u594E\u595A\u5958\u5962\u5960\u5967\u596C\u5969"],
      ["d5a1", "\u5978\u5981\u599D\u4F5E\u4FAB\u59A3\u59B2\u59C6\u59E8\u59DC\u598D\u59D9\u59DA\u5A25\u5A1F\u5A11\u5A1C\u5A09\u5A1A\u5A40\u5A6C\u5A49\u5A35\u5A36\u5A62\u5A6A\u5A9A\u5ABC\u5ABE\u5ACB\u5AC2\u5ABD\u5AE3\u5AD7\u5AE6\u5AE9\u5AD6\u5AFA\u5AFB\u5B0C\u5B0B\u5B16\u5B32\u5AD0\u5B2A\u5B36\u5B3E\u5B43\u5B45\u5B40\u5B51\u5B55\u5B5A\u5B5B\u5B65\u5B69\u5B70\u5B73\u5B75\u5B78\u6588\u5B7A\u5B80\u5B83\u5BA6\u5BB8\u5BC3\u5BC7\u5BC9\u5BD4\u5BD0\u5BE4\u5BE6\u5BE2\u5BDE\u5BE5\u5BEB\u5BF0\u5BF6\u5BF3\u5C05\u5C07\u5C08\u5C0D\u5C13\u5C20\u5C22\u5C28\u5C38\u5C39\u5C41\u5C46\u5C4E\u5C53"],
      ["d6a1", "\u5C50\u5C4F\u5B71\u5C6C\u5C6E\u4E62\u5C76\u5C79\u5C8C\u5C91\u5C94\u599B\u5CAB\u5CBB\u5CB6\u5CBC\u5CB7\u5CC5\u5CBE\u5CC7\u5CD9\u5CE9\u5CFD\u5CFA\u5CED\u5D8C\u5CEA\u5D0B\u5D15\u5D17\u5D5C\u5D1F\u5D1B\u5D11\u5D14\u5D22\u5D1A\u5D19\u5D18\u5D4C\u5D52\u5D4E\u5D4B\u5D6C\u5D73\u5D76\u5D87\u5D84\u5D82\u5DA2\u5D9D\u5DAC\u5DAE\u5DBD\u5D90\u5DB7\u5DBC\u5DC9\u5DCD\u5DD3\u5DD2\u5DD6\u5DDB\u5DEB\u5DF2\u5DF5\u5E0B\u5E1A\u5E19\u5E11\u5E1B\u5E36\u5E37\u5E44\u5E43\u5E40\u5E4E\u5E57\u5E54\u5E5F\u5E62\u5E64\u5E47\u5E75\u5E76\u5E7A\u9EBC\u5E7F\u5EA0\u5EC1\u5EC2\u5EC8\u5ED0\u5ECF"],
      ["d7a1", "\u5ED6\u5EE3\u5EDD\u5EDA\u5EDB\u5EE2\u5EE1\u5EE8\u5EE9\u5EEC\u5EF1\u5EF3\u5EF0\u5EF4\u5EF8\u5EFE\u5F03\u5F09\u5F5D\u5F5C\u5F0B\u5F11\u5F16\u5F29\u5F2D\u5F38\u5F41\u5F48\u5F4C\u5F4E\u5F2F\u5F51\u5F56\u5F57\u5F59\u5F61\u5F6D\u5F73\u5F77\u5F83\u5F82\u5F7F\u5F8A\u5F88\u5F91\u5F87\u5F9E\u5F99\u5F98\u5FA0\u5FA8\u5FAD\u5FBC\u5FD6\u5FFB\u5FE4\u5FF8\u5FF1\u5FDD\u60B3\u5FFF\u6021\u6060\u6019\u6010\u6029\u600E\u6031\u601B\u6015\u602B\u6026\u600F\u603A\u605A\u6041\u606A\u6077\u605F\u604A\u6046\u604D\u6063\u6043\u6064\u6042\u606C\u606B\u6059\u6081\u608D\u60E7\u6083\u609A"],
      ["d8a1", "\u6084\u609B\u6096\u6097\u6092\u60A7\u608B\u60E1\u60B8\u60E0\u60D3\u60B4\u5FF0\u60BD\u60C6\u60B5\u60D8\u614D\u6115\u6106\u60F6\u60F7\u6100\u60F4\u60FA\u6103\u6121\u60FB\u60F1\u610D\u610E\u6147\u613E\u6128\u6127\u614A\u613F\u613C\u612C\u6134\u613D\u6142\u6144\u6173\u6177\u6158\u6159\u615A\u616B\u6174\u616F\u6165\u6171\u615F\u615D\u6153\u6175\u6199\u6196\u6187\u61AC\u6194\u619A\u618A\u6191\u61AB\u61AE\u61CC\u61CA\u61C9\u61F7\u61C8\u61C3\u61C6\u61BA\u61CB\u7F79\u61CD\u61E6\u61E3\u61F6\u61FA\u61F4\u61FF\u61FD\u61FC\u61FE\u6200\u6208\u6209\u620D\u620C\u6214\u621B"],
      ["d9a1", "\u621E\u6221\u622A\u622E\u6230\u6232\u6233\u6241\u624E\u625E\u6263\u625B\u6260\u6268\u627C\u6282\u6289\u627E\u6292\u6293\u6296\u62D4\u6283\u6294\u62D7\u62D1\u62BB\u62CF\u62FF\u62C6\u64D4\u62C8\u62DC\u62CC\u62CA\u62C2\u62C7\u629B\u62C9\u630C\u62EE\u62F1\u6327\u6302\u6308\u62EF\u62F5\u6350\u633E\u634D\u641C\u634F\u6396\u638E\u6380\u63AB\u6376\u63A3\u638F\u6389\u639F\u63B5\u636B\u6369\u63BE\u63E9\u63C0\u63C6\u63E3\u63C9\u63D2\u63F6\u63C4\u6416\u6434\u6406\u6413\u6426\u6436\u651D\u6417\u6428\u640F\u6467\u646F\u6476\u644E\u652A\u6495\u6493\u64A5\u64A9\u6488\u64BC"],
      ["daa1", "\u64DA\u64D2\u64C5\u64C7\u64BB\u64D8\u64C2\u64F1\u64E7\u8209\u64E0\u64E1\u62AC\u64E3\u64EF\u652C\u64F6\u64F4\u64F2\u64FA\u6500\u64FD\u6518\u651C\u6505\u6524\u6523\u652B\u6534\u6535\u6537\u6536\u6538\u754B\u6548\u6556\u6555\u654D\u6558\u655E\u655D\u6572\u6578\u6582\u6583\u8B8A\u659B\u659F\u65AB\u65B7\u65C3\u65C6\u65C1\u65C4\u65CC\u65D2\u65DB\u65D9\u65E0\u65E1\u65F1\u6772\u660A\u6603\u65FB\u6773\u6635\u6636\u6634\u661C\u664F\u6644\u6649\u6641\u665E\u665D\u6664\u6667\u6668\u665F\u6662\u6670\u6683\u6688\u668E\u6689\u6684\u6698\u669D\u66C1\u66B9\u66C9\u66BE\u66BC"],
      ["dba1", "\u66C4\u66B8\u66D6\u66DA\u66E0\u663F\u66E6\u66E9\u66F0\u66F5\u66F7\u670F\u6716\u671E\u6726\u6727\u9738\u672E\u673F\u6736\u6741\u6738\u6737\u6746\u675E\u6760\u6759\u6763\u6764\u6789\u6770\u67A9\u677C\u676A\u678C\u678B\u67A6\u67A1\u6785\u67B7\u67EF\u67B4\u67EC\u67B3\u67E9\u67B8\u67E4\u67DE\u67DD\u67E2\u67EE\u67B9\u67CE\u67C6\u67E7\u6A9C\u681E\u6846\u6829\u6840\u684D\u6832\u684E\u68B3\u682B\u6859\u6863\u6877\u687F\u689F\u688F\u68AD\u6894\u689D\u689B\u6883\u6AAE\u68B9\u6874\u68B5\u68A0\u68BA\u690F\u688D\u687E\u6901\u68CA\u6908\u68D8\u6922\u6926\u68E1\u690C\u68CD"],
      ["dca1", "\u68D4\u68E7\u68D5\u6936\u6912\u6904\u68D7\u68E3\u6925\u68F9\u68E0\u68EF\u6928\u692A\u691A\u6923\u6921\u68C6\u6979\u6977\u695C\u6978\u696B\u6954\u697E\u696E\u6939\u6974\u693D\u6959\u6930\u6961\u695E\u695D\u6981\u696A\u69B2\u69AE\u69D0\u69BF\u69C1\u69D3\u69BE\u69CE\u5BE8\u69CA\u69DD\u69BB\u69C3\u69A7\u6A2E\u6991\u69A0\u699C\u6995\u69B4\u69DE\u69E8\u6A02\u6A1B\u69FF\u6B0A\u69F9\u69F2\u69E7\u6A05\u69B1\u6A1E\u69ED\u6A14\u69EB\u6A0A\u6A12\u6AC1\u6A23\u6A13\u6A44\u6A0C\u6A72\u6A36\u6A78\u6A47\u6A62\u6A59\u6A66\u6A48\u6A38\u6A22\u6A90\u6A8D\u6AA0\u6A84\u6AA2\u6AA3"],
      ["dda1", "\u6A97\u8617\u6ABB\u6AC3\u6AC2\u6AB8\u6AB3\u6AAC\u6ADE\u6AD1\u6ADF\u6AAA\u6ADA\u6AEA\u6AFB\u6B05\u8616\u6AFA\u6B12\u6B16\u9B31\u6B1F\u6B38\u6B37\u76DC\u6B39\u98EE\u6B47\u6B43\u6B49\u6B50\u6B59\u6B54\u6B5B\u6B5F\u6B61\u6B78\u6B79\u6B7F\u6B80\u6B84\u6B83\u6B8D\u6B98\u6B95\u6B9E\u6BA4\u6BAA\u6BAB\u6BAF\u6BB2\u6BB1\u6BB3\u6BB7\u6BBC\u6BC6\u6BCB\u6BD3\u6BDF\u6BEC\u6BEB\u6BF3\u6BEF\u9EBE\u6C08\u6C13\u6C14\u6C1B\u6C24\u6C23\u6C5E\u6C55\u6C62\u6C6A\u6C82\u6C8D\u6C9A\u6C81\u6C9B\u6C7E\u6C68\u6C73\u6C92\u6C90\u6CC4\u6CF1\u6CD3\u6CBD\u6CD7\u6CC5\u6CDD\u6CAE\u6CB1\u6CBE"],
      ["dea1", "\u6CBA\u6CDB\u6CEF\u6CD9\u6CEA\u6D1F\u884D\u6D36\u6D2B\u6D3D\u6D38\u6D19\u6D35\u6D33\u6D12\u6D0C\u6D63\u6D93\u6D64\u6D5A\u6D79\u6D59\u6D8E\u6D95\u6FE4\u6D85\u6DF9\u6E15\u6E0A\u6DB5\u6DC7\u6DE6\u6DB8\u6DC6\u6DEC\u6DDE\u6DCC\u6DE8\u6DD2\u6DC5\u6DFA\u6DD9\u6DE4\u6DD5\u6DEA\u6DEE\u6E2D\u6E6E\u6E2E\u6E19\u6E72\u6E5F\u6E3E\u6E23\u6E6B\u6E2B\u6E76\u6E4D\u6E1F\u6E43\u6E3A\u6E4E\u6E24\u6EFF\u6E1D\u6E38\u6E82\u6EAA\u6E98\u6EC9\u6EB7\u6ED3\u6EBD\u6EAF\u6EC4\u6EB2\u6ED4\u6ED5\u6E8F\u6EA5\u6EC2\u6E9F\u6F41\u6F11\u704C\u6EEC\u6EF8\u6EFE\u6F3F\u6EF2\u6F31\u6EEF\u6F32\u6ECC"],
      ["dfa1", "\u6F3E\u6F13\u6EF7\u6F86\u6F7A\u6F78\u6F81\u6F80\u6F6F\u6F5B\u6FF3\u6F6D\u6F82\u6F7C\u6F58\u6F8E\u6F91\u6FC2\u6F66\u6FB3\u6FA3\u6FA1\u6FA4\u6FB9\u6FC6\u6FAA\u6FDF\u6FD5\u6FEC\u6FD4\u6FD8\u6FF1\u6FEE\u6FDB\u7009\u700B\u6FFA\u7011\u7001\u700F\u6FFE\u701B\u701A\u6F74\u701D\u7018\u701F\u7030\u703E\u7032\u7051\u7063\u7099\u7092\u70AF\u70F1\u70AC\u70B8\u70B3\u70AE\u70DF\u70CB\u70DD\u70D9\u7109\u70FD\u711C\u7119\u7165\u7155\u7188\u7166\u7162\u714C\u7156\u716C\u718F\u71FB\u7184\u7195\u71A8\u71AC\u71D7\u71B9\u71BE\u71D2\u71C9\u71D4\u71CE\u71E0\u71EC\u71E7\u71F5\u71FC"],
      ["e0a1", "\u71F9\u71FF\u720D\u7210\u721B\u7228\u722D\u722C\u7230\u7232\u723B\u723C\u723F\u7240\u7246\u724B\u7258\u7274\u727E\u7282\u7281\u7287\u7292\u7296\u72A2\u72A7\u72B9\u72B2\u72C3\u72C6\u72C4\u72CE\u72D2\u72E2\u72E0\u72E1\u72F9\u72F7\u500F\u7317\u730A\u731C\u7316\u731D\u7334\u732F\u7329\u7325\u733E\u734E\u734F\u9ED8\u7357\u736A\u7368\u7370\u7378\u7375\u737B\u737A\u73C8\u73B3\u73CE\u73BB\u73C0\u73E5\u73EE\u73DE\u74A2\u7405\u746F\u7425\u73F8\u7432\u743A\u7455\u743F\u745F\u7459\u7441\u745C\u7469\u7470\u7463\u746A\u7476\u747E\u748B\u749E\u74A7\u74CA\u74CF\u74D4\u73F1"],
      ["e1a1", "\u74E0\u74E3\u74E7\u74E9\u74EE\u74F2\u74F0\u74F1\u74F8\u74F7\u7504\u7503\u7505\u750C\u750E\u750D\u7515\u7513\u751E\u7526\u752C\u753C\u7544\u754D\u754A\u7549\u755B\u7546\u755A\u7569\u7564\u7567\u756B\u756D\u7578\u7576\u7586\u7587\u7574\u758A\u7589\u7582\u7594\u759A\u759D\u75A5\u75A3\u75C2\u75B3\u75C3\u75B5\u75BD\u75B8\u75BC\u75B1\u75CD\u75CA\u75D2\u75D9\u75E3\u75DE\u75FE\u75FF\u75FC\u7601\u75F0\u75FA\u75F2\u75F3\u760B\u760D\u7609\u761F\u7627\u7620\u7621\u7622\u7624\u7634\u7630\u763B\u7647\u7648\u7646\u765C\u7658\u7661\u7662\u7668\u7669\u766A\u7667\u766C\u7670"],
      ["e2a1", "\u7672\u7676\u7678\u767C\u7680\u7683\u7688\u768B\u768E\u7696\u7693\u7699\u769A\u76B0\u76B4\u76B8\u76B9\u76BA\u76C2\u76CD\u76D6\u76D2\u76DE\u76E1\u76E5\u76E7\u76EA\u862F\u76FB\u7708\u7707\u7704\u7729\u7724\u771E\u7725\u7726\u771B\u7737\u7738\u7747\u775A\u7768\u776B\u775B\u7765\u777F\u777E\u7779\u778E\u778B\u7791\u77A0\u779E\u77B0\u77B6\u77B9\u77BF\u77BC\u77BD\u77BB\u77C7\u77CD\u77D7\u77DA\u77DC\u77E3\u77EE\u77FC\u780C\u7812\u7926\u7820\u792A\u7845\u788E\u7874\u7886\u787C\u789A\u788C\u78A3\u78B5\u78AA\u78AF\u78D1\u78C6\u78CB\u78D4\u78BE\u78BC\u78C5\u78CA\u78EC"],
      ["e3a1", "\u78E7\u78DA\u78FD\u78F4\u7907\u7912\u7911\u7919\u792C\u792B\u7940\u7960\u7957\u795F\u795A\u7955\u7953\u797A\u797F\u798A\u799D\u79A7\u9F4B\u79AA\u79AE\u79B3\u79B9\u79BA\u79C9\u79D5\u79E7\u79EC\u79E1\u79E3\u7A08\u7A0D\u7A18\u7A19\u7A20\u7A1F\u7980\u7A31\u7A3B\u7A3E\u7A37\u7A43\u7A57\u7A49\u7A61\u7A62\u7A69\u9F9D\u7A70\u7A79\u7A7D\u7A88\u7A97\u7A95\u7A98\u7A96\u7AA9\u7AC8\u7AB0\u7AB6\u7AC5\u7AC4\u7ABF\u9083\u7AC7\u7ACA\u7ACD\u7ACF\u7AD5\u7AD3\u7AD9\u7ADA\u7ADD\u7AE1\u7AE2\u7AE6\u7AED\u7AF0\u7B02\u7B0F\u7B0A\u7B06\u7B33\u7B18\u7B19\u7B1E\u7B35\u7B28\u7B36\u7B50"],
      ["e4a1", "\u7B7A\u7B04\u7B4D\u7B0B\u7B4C\u7B45\u7B75\u7B65\u7B74\u7B67\u7B70\u7B71\u7B6C\u7B6E\u7B9D\u7B98\u7B9F\u7B8D\u7B9C\u7B9A\u7B8B\u7B92\u7B8F\u7B5D\u7B99\u7BCB\u7BC1\u7BCC\u7BCF\u7BB4\u7BC6\u7BDD\u7BE9\u7C11\u7C14\u7BE6\u7BE5\u7C60\u7C00\u7C07\u7C13\u7BF3\u7BF7\u7C17\u7C0D\u7BF6\u7C23\u7C27\u7C2A\u7C1F\u7C37\u7C2B\u7C3D\u7C4C\u7C43\u7C54\u7C4F\u7C40\u7C50\u7C58\u7C5F\u7C64\u7C56\u7C65\u7C6C\u7C75\u7C83\u7C90\u7CA4\u7CAD\u7CA2\u7CAB\u7CA1\u7CA8\u7CB3\u7CB2\u7CB1\u7CAE\u7CB9\u7CBD\u7CC0\u7CC5\u7CC2\u7CD8\u7CD2\u7CDC\u7CE2\u9B3B\u7CEF\u7CF2\u7CF4\u7CF6\u7CFA\u7D06"],
      ["e5a1", "\u7D02\u7D1C\u7D15\u7D0A\u7D45\u7D4B\u7D2E\u7D32\u7D3F\u7D35\u7D46\u7D73\u7D56\u7D4E\u7D72\u7D68\u7D6E\u7D4F\u7D63\u7D93\u7D89\u7D5B\u7D8F\u7D7D\u7D9B\u7DBA\u7DAE\u7DA3\u7DB5\u7DC7\u7DBD\u7DAB\u7E3D\u7DA2\u7DAF\u7DDC\u7DB8\u7D9F\u7DB0\u7DD8\u7DDD\u7DE4\u7DDE\u7DFB\u7DF2\u7DE1\u7E05\u7E0A\u7E23\u7E21\u7E12\u7E31\u7E1F\u7E09\u7E0B\u7E22\u7E46\u7E66\u7E3B\u7E35\u7E39\u7E43\u7E37\u7E32\u7E3A\u7E67\u7E5D\u7E56\u7E5E\u7E59\u7E5A\u7E79\u7E6A\u7E69\u7E7C\u7E7B\u7E83\u7DD5\u7E7D\u8FAE\u7E7F\u7E88\u7E89\u7E8C\u7E92\u7E90\u7E93\u7E94\u7E96\u7E8E\u7E9B\u7E9C\u7F38\u7F3A"],
      ["e6a1", "\u7F45\u7F4C\u7F4D\u7F4E\u7F50\u7F51\u7F55\u7F54\u7F58\u7F5F\u7F60\u7F68\u7F69\u7F67\u7F78\u7F82\u7F86\u7F83\u7F88\u7F87\u7F8C\u7F94\u7F9E\u7F9D\u7F9A\u7FA3\u7FAF\u7FB2\u7FB9\u7FAE\u7FB6\u7FB8\u8B71\u7FC5\u7FC6\u7FCA\u7FD5\u7FD4\u7FE1\u7FE6\u7FE9\u7FF3\u7FF9\u98DC\u8006\u8004\u800B\u8012\u8018\u8019\u801C\u8021\u8028\u803F\u803B\u804A\u8046\u8052\u8058\u805A\u805F\u8062\u8068\u8073\u8072\u8070\u8076\u8079\u807D\u807F\u8084\u8086\u8085\u809B\u8093\u809A\u80AD\u5190\u80AC\u80DB\u80E5\u80D9\u80DD\u80C4\u80DA\u80D6\u8109\u80EF\u80F1\u811B\u8129\u8123\u812F\u814B"],
      ["e7a1", "\u968B\u8146\u813E\u8153\u8151\u80FC\u8171\u816E\u8165\u8166\u8174\u8183\u8188\u818A\u8180\u8182\u81A0\u8195\u81A4\u81A3\u815F\u8193\u81A9\u81B0\u81B5\u81BE\u81B8\u81BD\u81C0\u81C2\u81BA\u81C9\u81CD\u81D1\u81D9\u81D8\u81C8\u81DA\u81DF\u81E0\u81E7\u81FA\u81FB\u81FE\u8201\u8202\u8205\u8207\u820A\u820D\u8210\u8216\u8229\u822B\u8238\u8233\u8240\u8259\u8258\u825D\u825A\u825F\u8264\u8262\u8268\u826A\u826B\u822E\u8271\u8277\u8278\u827E\u828D\u8292\u82AB\u829F\u82BB\u82AC\u82E1\u82E3\u82DF\u82D2\u82F4\u82F3\u82FA\u8393\u8303\u82FB\u82F9\u82DE\u8306\u82DC\u8309\u82D9"],
      ["e8a1", "\u8335\u8334\u8316\u8332\u8331\u8340\u8339\u8350\u8345\u832F\u832B\u8317\u8318\u8385\u839A\u83AA\u839F\u83A2\u8396\u8323\u838E\u8387\u838A\u837C\u83B5\u8373\u8375\u83A0\u8389\u83A8\u83F4\u8413\u83EB\u83CE\u83FD\u8403\u83D8\u840B\u83C1\u83F7\u8407\u83E0\u83F2\u840D\u8422\u8420\u83BD\u8438\u8506\u83FB\u846D\u842A\u843C\u855A\u8484\u8477\u846B\u84AD\u846E\u8482\u8469\u8446\u842C\u846F\u8479\u8435\u84CA\u8462\u84B9\u84BF\u849F\u84D9\u84CD\u84BB\u84DA\u84D0\u84C1\u84C6\u84D6\u84A1\u8521\u84FF\u84F4\u8517\u8518\u852C\u851F\u8515\u8514\u84FC\u8540\u8563\u8558\u8548"],
      ["e9a1", "\u8541\u8602\u854B\u8555\u8580\u85A4\u8588\u8591\u858A\u85A8\u856D\u8594\u859B\u85EA\u8587\u859C\u8577\u857E\u8590\u85C9\u85BA\u85CF\u85B9\u85D0\u85D5\u85DD\u85E5\u85DC\u85F9\u860A\u8613\u860B\u85FE\u85FA\u8606\u8622\u861A\u8630\u863F\u864D\u4E55\u8654\u865F\u8667\u8671\u8693\u86A3\u86A9\u86AA\u868B\u868C\u86B6\u86AF\u86C4\u86C6\u86B0\u86C9\u8823\u86AB\u86D4\u86DE\u86E9\u86EC\u86DF\u86DB\u86EF\u8712\u8706\u8708\u8700\u8703\u86FB\u8711\u8709\u870D\u86F9\u870A\u8734\u873F\u8737\u873B\u8725\u8729\u871A\u8760\u875F\u8778\u874C\u874E\u8774\u8757\u8768\u876E\u8759"],
      ["eaa1", "\u8753\u8763\u876A\u8805\u87A2\u879F\u8782\u87AF\u87CB\u87BD\u87C0\u87D0\u96D6\u87AB\u87C4\u87B3\u87C7\u87C6\u87BB\u87EF\u87F2\u87E0\u880F\u880D\u87FE\u87F6\u87F7\u880E\u87D2\u8811\u8816\u8815\u8822\u8821\u8831\u8836\u8839\u8827\u883B\u8844\u8842\u8852\u8859\u885E\u8862\u886B\u8881\u887E\u889E\u8875\u887D\u88B5\u8872\u8882\u8897\u8892\u88AE\u8899\u88A2\u888D\u88A4\u88B0\u88BF\u88B1\u88C3\u88C4\u88D4\u88D8\u88D9\u88DD\u88F9\u8902\u88FC\u88F4\u88E8\u88F2\u8904\u890C\u890A\u8913\u8943\u891E\u8925\u892A\u892B\u8941\u8944\u893B\u8936\u8938\u894C\u891D\u8960\u895E"],
      ["eba1", "\u8966\u8964\u896D\u896A\u896F\u8974\u8977\u897E\u8983\u8988\u898A\u8993\u8998\u89A1\u89A9\u89A6\u89AC\u89AF\u89B2\u89BA\u89BD\u89BF\u89C0\u89DA\u89DC\u89DD\u89E7\u89F4\u89F8\u8A03\u8A16\u8A10\u8A0C\u8A1B\u8A1D\u8A25\u8A36\u8A41\u8A5B\u8A52\u8A46\u8A48\u8A7C\u8A6D\u8A6C\u8A62\u8A85\u8A82\u8A84\u8AA8\u8AA1\u8A91\u8AA5\u8AA6\u8A9A\u8AA3\u8AC4\u8ACD\u8AC2\u8ADA\u8AEB\u8AF3\u8AE7\u8AE4\u8AF1\u8B14\u8AE0\u8AE2\u8AF7\u8ADE\u8ADB\u8B0C\u8B07\u8B1A\u8AE1\u8B16\u8B10\u8B17\u8B20\u8B33\u97AB\u8B26\u8B2B\u8B3E\u8B28\u8B41\u8B4C\u8B4F\u8B4E\u8B49\u8B56\u8B5B\u8B5A\u8B6B"],
      ["eca1", "\u8B5F\u8B6C\u8B6F\u8B74\u8B7D\u8B80\u8B8C\u8B8E\u8B92\u8B93\u8B96\u8B99\u8B9A\u8C3A\u8C41\u8C3F\u8C48\u8C4C\u8C4E\u8C50\u8C55\u8C62\u8C6C\u8C78\u8C7A\u8C82\u8C89\u8C85\u8C8A\u8C8D\u8C8E\u8C94\u8C7C\u8C98\u621D\u8CAD\u8CAA\u8CBD\u8CB2\u8CB3\u8CAE\u8CB6\u8CC8\u8CC1\u8CE4\u8CE3\u8CDA\u8CFD\u8CFA\u8CFB\u8D04\u8D05\u8D0A\u8D07\u8D0F\u8D0D\u8D10\u9F4E\u8D13\u8CCD\u8D14\u8D16\u8D67\u8D6D\u8D71\u8D73\u8D81\u8D99\u8DC2\u8DBE\u8DBA\u8DCF\u8DDA\u8DD6\u8DCC\u8DDB\u8DCB\u8DEA\u8DEB\u8DDF\u8DE3\u8DFC\u8E08\u8E09\u8DFF\u8E1D\u8E1E\u8E10\u8E1F\u8E42\u8E35\u8E30\u8E34\u8E4A"],
      ["eda1", "\u8E47\u8E49\u8E4C\u8E50\u8E48\u8E59\u8E64\u8E60\u8E2A\u8E63\u8E55\u8E76\u8E72\u8E7C\u8E81\u8E87\u8E85\u8E84\u8E8B\u8E8A\u8E93\u8E91\u8E94\u8E99\u8EAA\u8EA1\u8EAC\u8EB0\u8EC6\u8EB1\u8EBE\u8EC5\u8EC8\u8ECB\u8EDB\u8EE3\u8EFC\u8EFB\u8EEB\u8EFE\u8F0A\u8F05\u8F15\u8F12\u8F19\u8F13\u8F1C\u8F1F\u8F1B\u8F0C\u8F26\u8F33\u8F3B\u8F39\u8F45\u8F42\u8F3E\u8F4C\u8F49\u8F46\u8F4E\u8F57\u8F5C\u8F62\u8F63\u8F64\u8F9C\u8F9F\u8FA3\u8FAD\u8FAF\u8FB7\u8FDA\u8FE5\u8FE2\u8FEA\u8FEF\u9087\u8FF4\u9005\u8FF9\u8FFA\u9011\u9015\u9021\u900D\u901E\u9016\u900B\u9027\u9036\u9035\u9039\u8FF8"],
      ["eea1", "\u904F\u9050\u9051\u9052\u900E\u9049\u903E\u9056\u9058\u905E\u9068\u906F\u9076\u96A8\u9072\u9082\u907D\u9081\u9080\u908A\u9089\u908F\u90A8\u90AF\u90B1\u90B5\u90E2\u90E4\u6248\u90DB\u9102\u9112\u9119\u9132\u9130\u914A\u9156\u9158\u9163\u9165\u9169\u9173\u9172\u918B\u9189\u9182\u91A2\u91AB\u91AF\u91AA\u91B5\u91B4\u91BA\u91C0\u91C1\u91C9\u91CB\u91D0\u91D6\u91DF\u91E1\u91DB\u91FC\u91F5\u91F6\u921E\u91FF\u9214\u922C\u9215\u9211\u925E\u9257\u9245\u9249\u9264\u9248\u9295\u923F\u924B\u9250\u929C\u9296\u9293\u929B\u925A\u92CF\u92B9\u92B7\u92E9\u930F\u92FA\u9344\u932E"],
      ["efa1", "\u9319\u9322\u931A\u9323\u933A\u9335\u933B\u935C\u9360\u937C\u936E\u9356\u93B0\u93AC\u93AD\u9394\u93B9\u93D6\u93D7\u93E8\u93E5\u93D8\u93C3\u93DD\u93D0\u93C8\u93E4\u941A\u9414\u9413\u9403\u9407\u9410\u9436\u942B\u9435\u9421\u943A\u9441\u9452\u9444\u945B\u9460\u9462\u945E\u946A\u9229\u9470\u9475\u9477\u947D\u945A\u947C\u947E\u9481\u947F\u9582\u9587\u958A\u9594\u9596\u9598\u9599\u95A0\u95A8\u95A7\u95AD\u95BC\u95BB\u95B9\u95BE\u95CA\u6FF6\u95C3\u95CD\u95CC\u95D5\u95D4\u95D6\u95DC\u95E1\u95E5\u95E2\u9621\u9628\u962E\u962F\u9642\u964C\u964F\u964B\u9677\u965C\u965E"],
      ["f0a1", "\u965D\u965F\u9666\u9672\u966C\u968D\u9698\u9695\u9697\u96AA\u96A7\u96B1\u96B2\u96B0\u96B4\u96B6\u96B8\u96B9\u96CE\u96CB\u96C9\u96CD\u894D\u96DC\u970D\u96D5\u96F9\u9704\u9706\u9708\u9713\u970E\u9711\u970F\u9716\u9719\u9724\u972A\u9730\u9739\u973D\u973E\u9744\u9746\u9748\u9742\u9749\u975C\u9760\u9764\u9766\u9768\u52D2\u976B\u9771\u9779\u9785\u977C\u9781\u977A\u9786\u978B\u978F\u9790\u979C\u97A8\u97A6\u97A3\u97B3\u97B4\u97C3\u97C6\u97C8\u97CB\u97DC\u97ED\u9F4F\u97F2\u7ADF\u97F6\u97F5\u980F\u980C\u9838\u9824\u9821\u9837\u983D\u9846\u984F\u984B\u986B\u986F\u9870"],
      ["f1a1", "\u9871\u9874\u9873\u98AA\u98AF\u98B1\u98B6\u98C4\u98C3\u98C6\u98E9\u98EB\u9903\u9909\u9912\u9914\u9918\u9921\u991D\u991E\u9924\u9920\u992C\u992E\u993D\u993E\u9942\u9949\u9945\u9950\u994B\u9951\u9952\u994C\u9955\u9997\u9998\u99A5\u99AD\u99AE\u99BC\u99DF\u99DB\u99DD\u99D8\u99D1\u99ED\u99EE\u99F1\u99F2\u99FB\u99F8\u9A01\u9A0F\u9A05\u99E2\u9A19\u9A2B\u9A37\u9A45\u9A42\u9A40\u9A43\u9A3E\u9A55\u9A4D\u9A5B\u9A57\u9A5F\u9A62\u9A65\u9A64\u9A69\u9A6B\u9A6A\u9AAD\u9AB0\u9ABC\u9AC0\u9ACF\u9AD1\u9AD3\u9AD4\u9ADE\u9ADF\u9AE2\u9AE3\u9AE6\u9AEF\u9AEB\u9AEE\u9AF4\u9AF1\u9AF7"],
      ["f2a1", "\u9AFB\u9B06\u9B18\u9B1A\u9B1F\u9B22\u9B23\u9B25\u9B27\u9B28\u9B29\u9B2A\u9B2E\u9B2F\u9B32\u9B44\u9B43\u9B4F\u9B4D\u9B4E\u9B51\u9B58\u9B74\u9B93\u9B83\u9B91\u9B96\u9B97\u9B9F\u9BA0\u9BA8\u9BB4\u9BC0\u9BCA\u9BB9\u9BC6\u9BCF\u9BD1\u9BD2\u9BE3\u9BE2\u9BE4\u9BD4\u9BE1\u9C3A\u9BF2\u9BF1\u9BF0\u9C15\u9C14\u9C09\u9C13\u9C0C\u9C06\u9C08\u9C12\u9C0A\u9C04\u9C2E\u9C1B\u9C25\u9C24\u9C21\u9C30\u9C47\u9C32\u9C46\u9C3E\u9C5A\u9C60\u9C67\u9C76\u9C78\u9CE7\u9CEC\u9CF0\u9D09\u9D08\u9CEB\u9D03\u9D06\u9D2A\u9D26\u9DAF\u9D23\u9D1F\u9D44\u9D15\u9D12\u9D41\u9D3F\u9D3E\u9D46\u9D48"],
      ["f3a1", "\u9D5D\u9D5E\u9D64\u9D51\u9D50\u9D59\u9D72\u9D89\u9D87\u9DAB\u9D6F\u9D7A\u9D9A\u9DA4\u9DA9\u9DB2\u9DC4\u9DC1\u9DBB\u9DB8\u9DBA\u9DC6\u9DCF\u9DC2\u9DD9\u9DD3\u9DF8\u9DE6\u9DED\u9DEF\u9DFD\u9E1A\u9E1B\u9E1E\u9E75\u9E79\u9E7D\u9E81\u9E88\u9E8B\u9E8C\u9E92\u9E95\u9E91\u9E9D\u9EA5\u9EA9\u9EB8\u9EAA\u9EAD\u9761\u9ECC\u9ECE\u9ECF\u9ED0\u9ED4\u9EDC\u9EDE\u9EDD\u9EE0\u9EE5\u9EE8\u9EEF\u9EF4\u9EF6\u9EF7\u9EF9\u9EFB\u9EFC\u9EFD\u9F07\u9F08\u76B7\u9F15\u9F21\u9F2C\u9F3E\u9F4A\u9F52\u9F54\u9F63\u9F5F\u9F60\u9F61\u9F66\u9F67\u9F6C\u9F6A\u9F77\u9F72\u9F76\u9F95\u9F9C\u9FA0"],
      ["f4a1", "\u582F\u69C7\u9059\u7464\u51DC\u7199"],
      ["f9a1", "\u7E8A\u891C\u9348\u9288\u84DC\u4FC9\u70BB\u6631\u68C8\u92F9\u66FB\u5F45\u4E28\u4EE1\u4EFC\u4F00\u4F03\u4F39\u4F56\u4F92\u4F8A\u4F9A\u4F94\u4FCD\u5040\u5022\u4FFF\u501E\u5046\u5070\u5042\u5094\u50F4\u50D8\u514A\u5164\u519D\u51BE\u51EC\u5215\u529C\u52A6\u52C0\u52DB\u5300\u5307\u5324\u5372\u5393\u53B2\u53DD\uFA0E\u549C\u548A\u54A9\u54FF\u5586\u5759\u5765\u57AC\u57C8\u57C7\uFA0F\uFA10\u589E\u58B2\u590B\u5953\u595B\u595D\u5963\u59A4\u59BA\u5B56\u5BC0\u752F\u5BD8\u5BEC\u5C1E\u5CA6\u5CBA\u5CF5\u5D27\u5D53\uFA11\u5D42\u5D6D\u5DB8\u5DB9\u5DD0\u5F21\u5F34\u5F67\u5FB7"],
      ["faa1", "\u5FDE\u605D\u6085\u608A\u60DE\u60D5\u6120\u60F2\u6111\u6137\u6130\u6198\u6213\u62A6\u63F5\u6460\u649D\u64CE\u654E\u6600\u6615\u663B\u6609\u662E\u661E\u6624\u6665\u6657\u6659\uFA12\u6673\u6699\u66A0\u66B2\u66BF\u66FA\u670E\uF929\u6766\u67BB\u6852\u67C0\u6801\u6844\u68CF\uFA13\u6968\uFA14\u6998\u69E2\u6A30\u6A6B\u6A46\u6A73\u6A7E\u6AE2\u6AE4\u6BD6\u6C3F\u6C5C\u6C86\u6C6F\u6CDA\u6D04\u6D87\u6D6F\u6D96\u6DAC\u6DCF\u6DF8\u6DF2\u6DFC\u6E39\u6E5C\u6E27\u6E3C\u6EBF\u6F88\u6FB5\u6FF5\u7005\u7007\u7028\u7085\u70AB\u710F\u7104\u715C\u7146\u7147\uFA15\u71C1\u71FE\u72B1"],
      ["fba1", "\u72BE\u7324\uFA16\u7377\u73BD\u73C9\u73D6\u73E3\u73D2\u7407\u73F5\u7426\u742A\u7429\u742E\u7462\u7489\u749F\u7501\u756F\u7682\u769C\u769E\u769B\u76A6\uFA17\u7746\u52AF\u7821\u784E\u7864\u787A\u7930\uFA18\uFA19\uFA1A\u7994\uFA1B\u799B\u7AD1\u7AE7\uFA1C\u7AEB\u7B9E\uFA1D\u7D48\u7D5C\u7DB7\u7DA0\u7DD6\u7E52\u7F47\u7FA1\uFA1E\u8301\u8362\u837F\u83C7\u83F6\u8448\u84B4\u8553\u8559\u856B\uFA1F\u85B0\uFA20\uFA21\u8807\u88F5\u8A12\u8A37\u8A79\u8AA7\u8ABE\u8ADF\uFA22\u8AF6\u8B53\u8B7F\u8CF0\u8CF4\u8D12\u8D76\uFA23\u8ECF\uFA24\uFA25\u9067\u90DE\uFA26\u9115\u9127\u91DA"],
      ["fca1", "\u91D7\u91DE\u91ED\u91EE\u91E4\u91E5\u9206\u9210\u920A\u923A\u9240\u923C\u924E\u9259\u9251\u9239\u9267\u92A7\u9277\u9278\u92E7\u92D7\u92D9\u92D0\uFA27\u92D5\u92E0\u92D3\u9325\u9321\u92FB\uFA28\u931E\u92FF\u931D\u9302\u9370\u9357\u93A4\u93C6\u93DE\u93F8\u9431\u9445\u9448\u9592\uF9DC\uFA29\u969D\u96AF\u9733\u973B\u9743\u974D\u974F\u9751\u9755\u9857\u9865\uFA2A\uFA2B\u9927\uFA2C\u999E\u9A4E\u9AD9\u9ADC\u9B75\u9B72\u9B8F\u9BB1\u9BBB\u9C00\u9D70\u9D6B\uFA2D\u9E19\u9ED1"],
      ["fcf1", "\u2170", 9, "\uFFE2\uFFE4\uFF07\uFF02"],
      ["8fa2af", "\u02D8\u02C7\xB8\u02D9\u02DD\xAF\u02DB\u02DA\uFF5E\u0384\u0385"],
      ["8fa2c2", "\xA1\xA6\xBF"],
      ["8fa2eb", "\xBA\xAA\xA9\xAE\u2122\xA4\u2116"],
      ["8fa6e1", "\u0386\u0388\u0389\u038A\u03AA"],
      ["8fa6e7", "\u038C"],
      ["8fa6e9", "\u038E\u03AB"],
      ["8fa6ec", "\u038F"],
      ["8fa6f1", "\u03AC\u03AD\u03AE\u03AF\u03CA\u0390\u03CC\u03C2\u03CD\u03CB\u03B0\u03CE"],
      ["8fa7c2", "\u0402", 10, "\u040E\u040F"],
      ["8fa7f2", "\u0452", 10, "\u045E\u045F"],
      ["8fa9a1", "\xC6\u0110"],
      ["8fa9a4", "\u0126"],
      ["8fa9a6", "\u0132"],
      ["8fa9a8", "\u0141\u013F"],
      ["8fa9ab", "\u014A\xD8\u0152"],
      ["8fa9af", "\u0166\xDE"],
      ["8fa9c1", "\xE6\u0111\xF0\u0127\u0131\u0133\u0138\u0142\u0140\u0149\u014B\xF8\u0153\xDF\u0167\xFE"],
      ["8faaa1", "\xC1\xC0\xC4\xC2\u0102\u01CD\u0100\u0104\xC5\xC3\u0106\u0108\u010C\xC7\u010A\u010E\xC9\xC8\xCB\xCA\u011A\u0116\u0112\u0118"],
      ["8faaba", "\u011C\u011E\u0122\u0120\u0124\xCD\xCC\xCF\xCE\u01CF\u0130\u012A\u012E\u0128\u0134\u0136\u0139\u013D\u013B\u0143\u0147\u0145\xD1\xD3\xD2\xD6\xD4\u01D1\u0150\u014C\xD5\u0154\u0158\u0156\u015A\u015C\u0160\u015E\u0164\u0162\xDA\xD9\xDC\xDB\u016C\u01D3\u0170\u016A\u0172\u016E\u0168\u01D7\u01DB\u01D9\u01D5\u0174\xDD\u0178\u0176\u0179\u017D\u017B"],
      ["8faba1", "\xE1\xE0\xE4\xE2\u0103\u01CE\u0101\u0105\xE5\xE3\u0107\u0109\u010D\xE7\u010B\u010F\xE9\xE8\xEB\xEA\u011B\u0117\u0113\u0119\u01F5\u011D\u011F"],
      ["8fabbd", "\u0121\u0125\xED\xEC\xEF\xEE\u01D0"],
      ["8fabc5", "\u012B\u012F\u0129\u0135\u0137\u013A\u013E\u013C\u0144\u0148\u0146\xF1\xF3\xF2\xF6\xF4\u01D2\u0151\u014D\xF5\u0155\u0159\u0157\u015B\u015D\u0161\u015F\u0165\u0163\xFA\xF9\xFC\xFB\u016D\u01D4\u0171\u016B\u0173\u016F\u0169\u01D8\u01DC\u01DA\u01D6\u0175\xFD\xFF\u0177\u017A\u017E\u017C"],
      ["8fb0a1", "\u4E02\u4E04\u4E05\u4E0C\u4E12\u4E1F\u4E23\u4E24\u4E28\u4E2B\u4E2E\u4E2F\u4E30\u4E35\u4E40\u4E41\u4E44\u4E47\u4E51\u4E5A\u4E5C\u4E63\u4E68\u4E69\u4E74\u4E75\u4E79\u4E7F\u4E8D\u4E96\u4E97\u4E9D\u4EAF\u4EB9\u4EC3\u4ED0\u4EDA\u4EDB\u4EE0\u4EE1\u4EE2\u4EE8\u4EEF\u4EF1\u4EF3\u4EF5\u4EFD\u4EFE\u4EFF\u4F00\u4F02\u4F03\u4F08\u4F0B\u4F0C\u4F12\u4F15\u4F16\u4F17\u4F19\u4F2E\u4F31\u4F60\u4F33\u4F35\u4F37\u4F39\u4F3B\u4F3E\u4F40\u4F42\u4F48\u4F49\u4F4B\u4F4C\u4F52\u4F54\u4F56\u4F58\u4F5F\u4F63\u4F6A\u4F6C\u4F6E\u4F71\u4F77\u4F78\u4F79\u4F7A\u4F7D\u4F7E\u4F81\u4F82\u4F84"],
      ["8fb1a1", "\u4F85\u4F89\u4F8A\u4F8C\u4F8E\u4F90\u4F92\u4F93\u4F94\u4F97\u4F99\u4F9A\u4F9E\u4F9F\u4FB2\u4FB7\u4FB9\u4FBB\u4FBC\u4FBD\u4FBE\u4FC0\u4FC1\u4FC5\u4FC6\u4FC8\u4FC9\u4FCB\u4FCC\u4FCD\u4FCF\u4FD2\u4FDC\u4FE0\u4FE2\u4FF0\u4FF2\u4FFC\u4FFD\u4FFF\u5000\u5001\u5004\u5007\u500A\u500C\u500E\u5010\u5013\u5017\u5018\u501B\u501C\u501D\u501E\u5022\u5027\u502E\u5030\u5032\u5033\u5035\u5040\u5041\u5042\u5045\u5046\u504A\u504C\u504E\u5051\u5052\u5053\u5057\u5059\u505F\u5060\u5062\u5063\u5066\u5067\u506A\u506D\u5070\u5071\u503B\u5081\u5083\u5084\u5086\u508A\u508E\u508F\u5090"],
      ["8fb2a1", "\u5092\u5093\u5094\u5096\u509B\u509C\u509E", 4, "\u50AA\u50AF\u50B0\u50B9\u50BA\u50BD\u50C0\u50C3\u50C4\u50C7\u50CC\u50CE\u50D0\u50D3\u50D4\u50D8\u50DC\u50DD\u50DF\u50E2\u50E4\u50E6\u50E8\u50E9\u50EF\u50F1\u50F6\u50FA\u50FE\u5103\u5106\u5107\u5108\u510B\u510C\u510D\u510E\u50F2\u5110\u5117\u5119\u511B\u511C\u511D\u511E\u5123\u5127\u5128\u512C\u512D\u512F\u5131\u5133\u5134\u5135\u5138\u5139\u5142\u514A\u514F\u5153\u5155\u5157\u5158\u515F\u5164\u5166\u517E\u5183\u5184\u518B\u518E\u5198\u519D\u51A1\u51A3\u51AD\u51B8\u51BA\u51BC\u51BE\u51BF\u51C2"],
      ["8fb3a1", "\u51C8\u51CF\u51D1\u51D2\u51D3\u51D5\u51D8\u51DE\u51E2\u51E5\u51EE\u51F2\u51F3\u51F4\u51F7\u5201\u5202\u5205\u5212\u5213\u5215\u5216\u5218\u5222\u5228\u5231\u5232\u5235\u523C\u5245\u5249\u5255\u5257\u5258\u525A\u525C\u525F\u5260\u5261\u5266\u526E\u5277\u5278\u5279\u5280\u5282\u5285\u528A\u528C\u5293\u5295\u5296\u5297\u5298\u529A\u529C\u52A4\u52A5\u52A6\u52A7\u52AF\u52B0\u52B6\u52B7\u52B8\u52BA\u52BB\u52BD\u52C0\u52C4\u52C6\u52C8\u52CC\u52CF\u52D1\u52D4\u52D6\u52DB\u52DC\u52E1\u52E5\u52E8\u52E9\u52EA\u52EC\u52F0\u52F1\u52F4\u52F6\u52F7\u5300\u5303\u530A\u530B"],
      ["8fb4a1", "\u530C\u5311\u5313\u5318\u531B\u531C\u531E\u531F\u5325\u5327\u5328\u5329\u532B\u532C\u532D\u5330\u5332\u5335\u533C\u533D\u533E\u5342\u534C\u534B\u5359\u535B\u5361\u5363\u5365\u536C\u536D\u5372\u5379\u537E\u5383\u5387\u5388\u538E\u5393\u5394\u5399\u539D\u53A1\u53A4\u53AA\u53AB\u53AF\u53B2\u53B4\u53B5\u53B7\u53B8\u53BA\u53BD\u53C0\u53C5\u53CF\u53D2\u53D3\u53D5\u53DA\u53DD\u53DE\u53E0\u53E6\u53E7\u53F5\u5402\u5413\u541A\u5421\u5427\u5428\u542A\u542F\u5431\u5434\u5435\u5443\u5444\u5447\u544D\u544F\u545E\u5462\u5464\u5466\u5467\u5469\u546B\u546D\u546E\u5474\u547F"],
      ["8fb5a1", "\u5481\u5483\u5485\u5488\u5489\u548D\u5491\u5495\u5496\u549C\u549F\u54A1\u54A6\u54A7\u54A9\u54AA\u54AD\u54AE\u54B1\u54B7\u54B9\u54BA\u54BB\u54BF\u54C6\u54CA\u54CD\u54CE\u54E0\u54EA\u54EC\u54EF\u54F6\u54FC\u54FE\u54FF\u5500\u5501\u5505\u5508\u5509\u550C\u550D\u550E\u5515\u552A\u552B\u5532\u5535\u5536\u553B\u553C\u553D\u5541\u5547\u5549\u554A\u554D\u5550\u5551\u5558\u555A\u555B\u555E\u5560\u5561\u5564\u5566\u557F\u5581\u5582\u5586\u5588\u558E\u558F\u5591\u5592\u5593\u5594\u5597\u55A3\u55A4\u55AD\u55B2\u55BF\u55C1\u55C3\u55C6\u55C9\u55CB\u55CC\u55CE\u55D1\u55D2"],
      ["8fb6a1", "\u55D3\u55D7\u55D8\u55DB\u55DE\u55E2\u55E9\u55F6\u55FF\u5605\u5608\u560A\u560D", 5, "\u5619\u562C\u5630\u5633\u5635\u5637\u5639\u563B\u563C\u563D\u563F\u5640\u5641\u5643\u5644\u5646\u5649\u564B\u564D\u564F\u5654\u565E\u5660\u5661\u5662\u5663\u5666\u5669\u566D\u566F\u5671\u5672\u5675\u5684\u5685\u5688\u568B\u568C\u5695\u5699\u569A\u569D\u569E\u569F\u56A6\u56A7\u56A8\u56A9\u56AB\u56AC\u56AD\u56B1\u56B3\u56B7\u56BE\u56C5\u56C9\u56CA\u56CB\u56CF\u56D0\u56CC\u56CD\u56D9\u56DC\u56DD\u56DF\u56E1\u56E4", 4, "\u56F1\u56EB\u56ED"],
      ["8fb7a1", "\u56F6\u56F7\u5701\u5702\u5707\u570A\u570C\u5711\u5715\u571A\u571B\u571D\u5720\u5722\u5723\u5724\u5725\u5729\u572A\u572C\u572E\u572F\u5733\u5734\u573D\u573E\u573F\u5745\u5746\u574C\u574D\u5752\u5762\u5765\u5767\u5768\u576B\u576D", 4, "\u5773\u5774\u5775\u5777\u5779\u577A\u577B\u577C\u577E\u5781\u5783\u578C\u5794\u5797\u5799\u579A\u579C\u579D\u579E\u579F\u57A1\u5795\u57A7\u57A8\u57A9\u57AC\u57B8\u57BD\u57C7\u57C8\u57CC\u57CF\u57D5\u57DD\u57DE\u57E4\u57E6\u57E7\u57E9\u57ED\u57F0\u57F5\u57F6\u57F8\u57FD\u57FE\u57FF\u5803\u5804\u5808\u5809\u57E1"],
      ["8fb8a1", "\u580C\u580D\u581B\u581E\u581F\u5820\u5826\u5827\u582D\u5832\u5839\u583F\u5849\u584C\u584D\u584F\u5850\u5855\u585F\u5861\u5864\u5867\u5868\u5878\u587C\u587F\u5880\u5881\u5887\u5888\u5889\u588A\u588C\u588D\u588F\u5890\u5894\u5896\u589D\u58A0\u58A1\u58A2\u58A6\u58A9\u58B1\u58B2\u58C4\u58BC\u58C2\u58C8\u58CD\u58CE\u58D0\u58D2\u58D4\u58D6\u58DA\u58DD\u58E1\u58E2\u58E9\u58F3\u5905\u5906\u590B\u590C\u5912\u5913\u5914\u8641\u591D\u5921\u5923\u5924\u5928\u592F\u5930\u5933\u5935\u5936\u593F\u5943\u5946\u5952\u5953\u5959\u595B\u595D\u595E\u595F\u5961\u5963\u596B\u596D"],
      ["8fb9a1", "\u596F\u5972\u5975\u5976\u5979\u597B\u597C\u598B\u598C\u598E\u5992\u5995\u5997\u599F\u59A4\u59A7\u59AD\u59AE\u59AF\u59B0\u59B3\u59B7\u59BA\u59BC\u59C1\u59C3\u59C4\u59C8\u59CA\u59CD\u59D2\u59DD\u59DE\u59DF\u59E3\u59E4\u59E7\u59EE\u59EF\u59F1\u59F2\u59F4\u59F7\u5A00\u5A04\u5A0C\u5A0D\u5A0E\u5A12\u5A13\u5A1E\u5A23\u5A24\u5A27\u5A28\u5A2A\u5A2D\u5A30\u5A44\u5A45\u5A47\u5A48\u5A4C\u5A50\u5A55\u5A5E\u5A63\u5A65\u5A67\u5A6D\u5A77\u5A7A\u5A7B\u5A7E\u5A8B\u5A90\u5A93\u5A96\u5A99\u5A9C\u5A9E\u5A9F\u5AA0\u5AA2\u5AA7\u5AAC\u5AB1\u5AB2\u5AB3\u5AB5\u5AB8\u5ABA\u5ABB\u5ABF"],
      ["8fbaa1", "\u5AC4\u5AC6\u5AC8\u5ACF\u5ADA\u5ADC\u5AE0\u5AE5\u5AEA\u5AEE\u5AF5\u5AF6\u5AFD\u5B00\u5B01\u5B08\u5B17\u5B34\u5B19\u5B1B\u5B1D\u5B21\u5B25\u5B2D\u5B38\u5B41\u5B4B\u5B4C\u5B52\u5B56\u5B5E\u5B68\u5B6E\u5B6F\u5B7C\u5B7D\u5B7E\u5B7F\u5B81\u5B84\u5B86\u5B8A\u5B8E\u5B90\u5B91\u5B93\u5B94\u5B96\u5BA8\u5BA9\u5BAC\u5BAD\u5BAF\u5BB1\u5BB2\u5BB7\u5BBA\u5BBC\u5BC0\u5BC1\u5BCD\u5BCF\u5BD6", 4, "\u5BE0\u5BEF\u5BF1\u5BF4\u5BFD\u5C0C\u5C17\u5C1E\u5C1F\u5C23\u5C26\u5C29\u5C2B\u5C2C\u5C2E\u5C30\u5C32\u5C35\u5C36\u5C59\u5C5A\u5C5C\u5C62\u5C63\u5C67\u5C68\u5C69"],
      ["8fbba1", "\u5C6D\u5C70\u5C74\u5C75\u5C7A\u5C7B\u5C7C\u5C7D\u5C87\u5C88\u5C8A\u5C8F\u5C92\u5C9D\u5C9F\u5CA0\u5CA2\u5CA3\u5CA6\u5CAA\u5CB2\u5CB4\u5CB5\u5CBA\u5CC9\u5CCB\u5CD2\u5CDD\u5CD7\u5CEE\u5CF1\u5CF2\u5CF4\u5D01\u5D06\u5D0D\u5D12\u5D2B\u5D23\u5D24\u5D26\u5D27\u5D31\u5D34\u5D39\u5D3D\u5D3F\u5D42\u5D43\u5D46\u5D48\u5D55\u5D51\u5D59\u5D4A\u5D5F\u5D60\u5D61\u5D62\u5D64\u5D6A\u5D6D\u5D70\u5D79\u5D7A\u5D7E\u5D7F\u5D81\u5D83\u5D88\u5D8A\u5D92\u5D93\u5D94\u5D95\u5D99\u5D9B\u5D9F\u5DA0\u5DA7\u5DAB\u5DB0\u5DB4\u5DB8\u5DB9\u5DC3\u5DC7\u5DCB\u5DD0\u5DCE\u5DD8\u5DD9\u5DE0\u5DE4"],
      ["8fbca1", "\u5DE9\u5DF8\u5DF9\u5E00\u5E07\u5E0D\u5E12\u5E14\u5E15\u5E18\u5E1F\u5E20\u5E2E\u5E28\u5E32\u5E35\u5E3E\u5E4B\u5E50\u5E49\u5E51\u5E56\u5E58\u5E5B\u5E5C\u5E5E\u5E68\u5E6A", 4, "\u5E70\u5E80\u5E8B\u5E8E\u5EA2\u5EA4\u5EA5\u5EA8\u5EAA\u5EAC\u5EB1\u5EB3\u5EBD\u5EBE\u5EBF\u5EC6\u5ECC\u5ECB\u5ECE\u5ED1\u5ED2\u5ED4\u5ED5\u5EDC\u5EDE\u5EE5\u5EEB\u5F02\u5F06\u5F07\u5F08\u5F0E\u5F19\u5F1C\u5F1D\u5F21\u5F22\u5F23\u5F24\u5F28\u5F2B\u5F2C\u5F2E\u5F30\u5F34\u5F36\u5F3B\u5F3D\u5F3F\u5F40\u5F44\u5F45\u5F47\u5F4D\u5F50\u5F54\u5F58\u5F5B\u5F60\u5F63\u5F64\u5F67"],
      ["8fbda1", "\u5F6F\u5F72\u5F74\u5F75\u5F78\u5F7A\u5F7D\u5F7E\u5F89\u5F8D\u5F8F\u5F96\u5F9C\u5F9D\u5FA2\u5FA7\u5FAB\u5FA4\u5FAC\u5FAF\u5FB0\u5FB1\u5FB8\u5FC4\u5FC7\u5FC8\u5FC9\u5FCB\u5FD0", 4, "\u5FDE\u5FE1\u5FE2\u5FE8\u5FE9\u5FEA\u5FEC\u5FED\u5FEE\u5FEF\u5FF2\u5FF3\u5FF6\u5FFA\u5FFC\u6007\u600A\u600D\u6013\u6014\u6017\u6018\u601A\u601F\u6024\u602D\u6033\u6035\u6040\u6047\u6048\u6049\u604C\u6051\u6054\u6056\u6057\u605D\u6061\u6067\u6071\u607E\u607F\u6082\u6086\u6088\u608A\u608E\u6091\u6093\u6095\u6098\u609D\u609E\u60A2\u60A4\u60A5\u60A8\u60B0\u60B1\u60B7"],
      ["8fbea1", "\u60BB\u60BE\u60C2\u60C4\u60C8\u60C9\u60CA\u60CB\u60CE\u60CF\u60D4\u60D5\u60D9\u60DB\u60DD\u60DE\u60E2\u60E5\u60F2\u60F5\u60F8\u60FC\u60FD\u6102\u6107\u610A\u610C\u6110", 4, "\u6116\u6117\u6119\u611C\u611E\u6122\u612A\u612B\u6130\u6131\u6135\u6136\u6137\u6139\u6141\u6145\u6146\u6149\u615E\u6160\u616C\u6172\u6178\u617B\u617C\u617F\u6180\u6181\u6183\u6184\u618B\u618D\u6192\u6193\u6197\u6198\u619C\u619D\u619F\u61A0\u61A5\u61A8\u61AA\u61AD\u61B8\u61B9\u61BC\u61C0\u61C1\u61C2\u61CE\u61CF\u61D5\u61DC\u61DD\u61DE\u61DF\u61E1\u61E2\u61E7\u61E9\u61E5"],
      ["8fbfa1", "\u61EC\u61ED\u61EF\u6201\u6203\u6204\u6207\u6213\u6215\u621C\u6220\u6222\u6223\u6227\u6229\u622B\u6239\u623D\u6242\u6243\u6244\u6246\u624C\u6250\u6251\u6252\u6254\u6256\u625A\u625C\u6264\u626D\u626F\u6273\u627A\u627D\u628D\u628E\u628F\u6290\u62A6\u62A8\u62B3\u62B6\u62B7\u62BA\u62BE\u62BF\u62C4\u62CE\u62D5\u62D6\u62DA\u62EA\u62F2\u62F4\u62FC\u62FD\u6303\u6304\u630A\u630B\u630D\u6310\u6313\u6316\u6318\u6329\u632A\u632D\u6335\u6336\u6339\u633C\u6341\u6342\u6343\u6344\u6346\u634A\u634B\u634E\u6352\u6353\u6354\u6358\u635B\u6365\u6366\u636C\u636D\u6371\u6374\u6375"],
      ["8fc0a1", "\u6378\u637C\u637D\u637F\u6382\u6384\u6387\u638A\u6390\u6394\u6395\u6399\u639A\u639E\u63A4\u63A6\u63AD\u63AE\u63AF\u63BD\u63C1\u63C5\u63C8\u63CE\u63D1\u63D3\u63D4\u63D5\u63DC\u63E0\u63E5\u63EA\u63EC\u63F2\u63F3\u63F5\u63F8\u63F9\u6409\u640A\u6410\u6412\u6414\u6418\u641E\u6420\u6422\u6424\u6425\u6429\u642A\u642F\u6430\u6435\u643D\u643F\u644B\u644F\u6451\u6452\u6453\u6454\u645A\u645B\u645C\u645D\u645F\u6460\u6461\u6463\u646D\u6473\u6474\u647B\u647D\u6485\u6487\u648F\u6490\u6491\u6498\u6499\u649B\u649D\u649F\u64A1\u64A3\u64A6\u64A8\u64AC\u64B3\u64BD\u64BE\u64BF"],
      ["8fc1a1", "\u64C4\u64C9\u64CA\u64CB\u64CC\u64CE\u64D0\u64D1\u64D5\u64D7\u64E4\u64E5\u64E9\u64EA\u64ED\u64F0\u64F5\u64F7\u64FB\u64FF\u6501\u6504\u6508\u6509\u650A\u650F\u6513\u6514\u6516\u6519\u651B\u651E\u651F\u6522\u6526\u6529\u652E\u6531\u653A\u653C\u653D\u6543\u6547\u6549\u6550\u6552\u6554\u655F\u6560\u6567\u656B\u657A\u657D\u6581\u6585\u658A\u6592\u6595\u6598\u659D\u65A0\u65A3\u65A6\u65AE\u65B2\u65B3\u65B4\u65BF\u65C2\u65C8\u65C9\u65CE\u65D0\u65D4\u65D6\u65D8\u65DF\u65F0\u65F2\u65F4\u65F5\u65F9\u65FE\u65FF\u6600\u6604\u6608\u6609\u660D\u6611\u6612\u6615\u6616\u661D"],
      ["8fc2a1", "\u661E\u6621\u6622\u6623\u6624\u6626\u6629\u662A\u662B\u662C\u662E\u6630\u6631\u6633\u6639\u6637\u6640\u6645\u6646\u664A\u664C\u6651\u664E\u6657\u6658\u6659\u665B\u665C\u6660\u6661\u66FB\u666A\u666B\u666C\u667E\u6673\u6675\u667F\u6677\u6678\u6679\u667B\u6680\u667C\u668B\u668C\u668D\u6690\u6692\u6699\u669A\u669B\u669C\u669F\u66A0\u66A4\u66AD\u66B1\u66B2\u66B5\u66BB\u66BF\u66C0\u66C2\u66C3\u66C8\u66CC\u66CE\u66CF\u66D4\u66DB\u66DF\u66E8\u66EB\u66EC\u66EE\u66FA\u6705\u6707\u670E\u6713\u6719\u671C\u6720\u6722\u6733\u673E\u6745\u6747\u6748\u674C\u6754\u6755\u675D"],
      ["8fc3a1", "\u6766\u676C\u676E\u6774\u6776\u677B\u6781\u6784\u678E\u678F\u6791\u6793\u6796\u6798\u6799\u679B\u67B0\u67B1\u67B2\u67B5\u67BB\u67BC\u67BD\u67F9\u67C0\u67C2\u67C3\u67C5\u67C8\u67C9\u67D2\u67D7\u67D9\u67DC\u67E1\u67E6\u67F0\u67F2\u67F6\u67F7\u6852\u6814\u6819\u681D\u681F\u6828\u6827\u682C\u682D\u682F\u6830\u6831\u6833\u683B\u683F\u6844\u6845\u684A\u684C\u6855\u6857\u6858\u685B\u686B\u686E", 4, "\u6875\u6879\u687A\u687B\u687C\u6882\u6884\u6886\u6888\u6896\u6898\u689A\u689C\u68A1\u68A3\u68A5\u68A9\u68AA\u68AE\u68B2\u68BB\u68C5\u68C8\u68CC\u68CF"],
      ["8fc4a1", "\u68D0\u68D1\u68D3\u68D6\u68D9\u68DC\u68DD\u68E5\u68E8\u68EA\u68EB\u68EC\u68ED\u68F0\u68F1\u68F5\u68F6\u68FB\u68FC\u68FD\u6906\u6909\u690A\u6910\u6911\u6913\u6916\u6917\u6931\u6933\u6935\u6938\u693B\u6942\u6945\u6949\u694E\u6957\u695B\u6963\u6964\u6965\u6966\u6968\u6969\u696C\u6970\u6971\u6972\u697A\u697B\u697F\u6980\u698D\u6992\u6996\u6998\u69A1\u69A5\u69A6\u69A8\u69AB\u69AD\u69AF\u69B7\u69B8\u69BA\u69BC\u69C5\u69C8\u69D1\u69D6\u69D7\u69E2\u69E5\u69EE\u69EF\u69F1\u69F3\u69F5\u69FE\u6A00\u6A01\u6A03\u6A0F\u6A11\u6A15\u6A1A\u6A1D\u6A20\u6A24\u6A28\u6A30\u6A32"],
      ["8fc5a1", "\u6A34\u6A37\u6A3B\u6A3E\u6A3F\u6A45\u6A46\u6A49\u6A4A\u6A4E\u6A50\u6A51\u6A52\u6A55\u6A56\u6A5B\u6A64\u6A67\u6A6A\u6A71\u6A73\u6A7E\u6A81\u6A83\u6A86\u6A87\u6A89\u6A8B\u6A91\u6A9B\u6A9D\u6A9E\u6A9F\u6AA5\u6AAB\u6AAF\u6AB0\u6AB1\u6AB4\u6ABD\u6ABE\u6ABF\u6AC6\u6AC9\u6AC8\u6ACC\u6AD0\u6AD4\u6AD5\u6AD6\u6ADC\u6ADD\u6AE4\u6AE7\u6AEC\u6AF0\u6AF1\u6AF2\u6AFC\u6AFD\u6B02\u6B03\u6B06\u6B07\u6B09\u6B0F\u6B10\u6B11\u6B17\u6B1B\u6B1E\u6B24\u6B28\u6B2B\u6B2C\u6B2F\u6B35\u6B36\u6B3B\u6B3F\u6B46\u6B4A\u6B4D\u6B52\u6B56\u6B58\u6B5D\u6B60\u6B67\u6B6B\u6B6E\u6B70\u6B75\u6B7D"],
      ["8fc6a1", "\u6B7E\u6B82\u6B85\u6B97\u6B9B\u6B9F\u6BA0\u6BA2\u6BA3\u6BA8\u6BA9\u6BAC\u6BAD\u6BAE\u6BB0\u6BB8\u6BB9\u6BBD\u6BBE\u6BC3\u6BC4\u6BC9\u6BCC\u6BD6\u6BDA\u6BE1\u6BE3\u6BE6\u6BE7\u6BEE\u6BF1\u6BF7\u6BF9\u6BFF\u6C02\u6C04\u6C05\u6C09\u6C0D\u6C0E\u6C10\u6C12\u6C19\u6C1F\u6C26\u6C27\u6C28\u6C2C\u6C2E\u6C33\u6C35\u6C36\u6C3A\u6C3B\u6C3F\u6C4A\u6C4B\u6C4D\u6C4F\u6C52\u6C54\u6C59\u6C5B\u6C5C\u6C6B\u6C6D\u6C6F\u6C74\u6C76\u6C78\u6C79\u6C7B\u6C85\u6C86\u6C87\u6C89\u6C94\u6C95\u6C97\u6C98\u6C9C\u6C9F\u6CB0\u6CB2\u6CB4\u6CC2\u6CC6\u6CCD\u6CCF\u6CD0\u6CD1\u6CD2\u6CD4\u6CD6"],
      ["8fc7a1", "\u6CDA\u6CDC\u6CE0\u6CE7\u6CE9\u6CEB\u6CEC\u6CEE\u6CF2\u6CF4\u6D04\u6D07\u6D0A\u6D0E\u6D0F\u6D11\u6D13\u6D1A\u6D26\u6D27\u6D28\u6C67\u6D2E\u6D2F\u6D31\u6D39\u6D3C\u6D3F\u6D57\u6D5E\u6D5F\u6D61\u6D65\u6D67\u6D6F\u6D70\u6D7C\u6D82\u6D87\u6D91\u6D92\u6D94\u6D96\u6D97\u6D98\u6DAA\u6DAC\u6DB4\u6DB7\u6DB9\u6DBD\u6DBF\u6DC4\u6DC8\u6DCA\u6DCE\u6DCF\u6DD6\u6DDB\u6DDD\u6DDF\u6DE0\u6DE2\u6DE5\u6DE9\u6DEF\u6DF0\u6DF4\u6DF6\u6DFC\u6E00\u6E04\u6E1E\u6E22\u6E27\u6E32\u6E36\u6E39\u6E3B\u6E3C\u6E44\u6E45\u6E48\u6E49\u6E4B\u6E4F\u6E51\u6E52\u6E53\u6E54\u6E57\u6E5C\u6E5D\u6E5E"],
      ["8fc8a1", "\u6E62\u6E63\u6E68\u6E73\u6E7B\u6E7D\u6E8D\u6E93\u6E99\u6EA0\u6EA7\u6EAD\u6EAE\u6EB1\u6EB3\u6EBB\u6EBF\u6EC0\u6EC1\u6EC3\u6EC7\u6EC8\u6ECA\u6ECD\u6ECE\u6ECF\u6EEB\u6EED\u6EEE\u6EF9\u6EFB\u6EFD\u6F04\u6F08\u6F0A\u6F0C\u6F0D\u6F16\u6F18\u6F1A\u6F1B\u6F26\u6F29\u6F2A\u6F2F\u6F30\u6F33\u6F36\u6F3B\u6F3C\u6F2D\u6F4F\u6F51\u6F52\u6F53\u6F57\u6F59\u6F5A\u6F5D\u6F5E\u6F61\u6F62\u6F68\u6F6C\u6F7D\u6F7E\u6F83\u6F87\u6F88\u6F8B\u6F8C\u6F8D\u6F90\u6F92\u6F93\u6F94\u6F96\u6F9A\u6F9F\u6FA0\u6FA5\u6FA6\u6FA7\u6FA8\u6FAE\u6FAF\u6FB0\u6FB5\u6FB6\u6FBC\u6FC5\u6FC7\u6FC8\u6FCA"],
      ["8fc9a1", "\u6FDA\u6FDE\u6FE8\u6FE9\u6FF0\u6FF5\u6FF9\u6FFC\u6FFD\u7000\u7005\u7006\u7007\u700D\u7017\u7020\u7023\u702F\u7034\u7037\u7039\u703C\u7043\u7044\u7048\u7049\u704A\u704B\u7054\u7055\u705D\u705E\u704E\u7064\u7065\u706C\u706E\u7075\u7076\u707E\u7081\u7085\u7086\u7094", 4, "\u709B\u70A4\u70AB\u70B0\u70B1\u70B4\u70B7\u70CA\u70D1\u70D3\u70D4\u70D5\u70D6\u70D8\u70DC\u70E4\u70FA\u7103", 4, "\u710B\u710C\u710F\u711E\u7120\u712B\u712D\u712F\u7130\u7131\u7138\u7141\u7145\u7146\u7147\u714A\u714B\u7150\u7152\u7157\u715A\u715C\u715E\u7160"],
      ["8fcaa1", "\u7168\u7179\u7180\u7185\u7187\u718C\u7192\u719A\u719B\u71A0\u71A2\u71AF\u71B0\u71B2\u71B3\u71BA\u71BF\u71C0\u71C1\u71C4\u71CB\u71CC\u71D3\u71D6\u71D9\u71DA\u71DC\u71F8\u71FE\u7200\u7207\u7208\u7209\u7213\u7217\u721A\u721D\u721F\u7224\u722B\u722F\u7234\u7238\u7239\u7241\u7242\u7243\u7245\u724E\u724F\u7250\u7253\u7255\u7256\u725A\u725C\u725E\u7260\u7263\u7268\u726B\u726E\u726F\u7271\u7277\u7278\u727B\u727C\u727F\u7284\u7289\u728D\u728E\u7293\u729B\u72A8\u72AD\u72AE\u72B1\u72B4\u72BE\u72C1\u72C7\u72C9\u72CC\u72D5\u72D6\u72D8\u72DF\u72E5\u72F3\u72F4\u72FA\u72FB"],
      ["8fcba1", "\u72FE\u7302\u7304\u7305\u7307\u730B\u730D\u7312\u7313\u7318\u7319\u731E\u7322\u7324\u7327\u7328\u732C\u7331\u7332\u7335\u733A\u733B\u733D\u7343\u734D\u7350\u7352\u7356\u7358\u735D\u735E\u735F\u7360\u7366\u7367\u7369\u736B\u736C\u736E\u736F\u7371\u7377\u7379\u737C\u7380\u7381\u7383\u7385\u7386\u738E\u7390\u7393\u7395\u7397\u7398\u739C\u739E\u739F\u73A0\u73A2\u73A5\u73A6\u73AA\u73AB\u73AD\u73B5\u73B7\u73B9\u73BC\u73BD\u73BF\u73C5\u73C6\u73C9\u73CB\u73CC\u73CF\u73D2\u73D3\u73D6\u73D9\u73DD\u73E1\u73E3\u73E6\u73E7\u73E9\u73F4\u73F5\u73F7\u73F9\u73FA\u73FB\u73FD"],
      ["8fcca1", "\u73FF\u7400\u7401\u7404\u7407\u740A\u7411\u741A\u741B\u7424\u7426\u7428", 9, "\u7439\u7440\u7443\u7444\u7446\u7447\u744B\u744D\u7451\u7452\u7457\u745D\u7462\u7466\u7467\u7468\u746B\u746D\u746E\u7471\u7472\u7480\u7481\u7485\u7486\u7487\u7489\u748F\u7490\u7491\u7492\u7498\u7499\u749A\u749C\u749F\u74A0\u74A1\u74A3\u74A6\u74A8\u74A9\u74AA\u74AB\u74AE\u74AF\u74B1\u74B2\u74B5\u74B9\u74BB\u74BF\u74C8\u74C9\u74CC\u74D0\u74D3\u74D8\u74DA\u74DB\u74DE\u74DF\u74E4\u74E8\u74EA\u74EB\u74EF\u74F4\u74FA\u74FB\u74FC\u74FF\u7506"],
      ["8fcda1", "\u7512\u7516\u7517\u7520\u7521\u7524\u7527\u7529\u752A\u752F\u7536\u7539\u753D\u753E\u753F\u7540\u7543\u7547\u7548\u754E\u7550\u7552\u7557\u755E\u755F\u7561\u756F\u7571\u7579", 5, "\u7581\u7585\u7590\u7592\u7593\u7595\u7599\u759C\u75A2\u75A4\u75B4\u75BA\u75BF\u75C0\u75C1\u75C4\u75C6\u75CC\u75CE\u75CF\u75D7\u75DC\u75DF\u75E0\u75E1\u75E4\u75E7\u75EC\u75EE\u75EF\u75F1\u75F9\u7600\u7602\u7603\u7604\u7607\u7608\u760A\u760C\u760F\u7612\u7613\u7615\u7616\u7619\u761B\u761C\u761D\u761E\u7623\u7625\u7626\u7629\u762D\u7632\u7633\u7635\u7638\u7639"],
      ["8fcea1", "\u763A\u763C\u764A\u7640\u7641\u7643\u7644\u7645\u7649\u764B\u7655\u7659\u765F\u7664\u7665\u766D\u766E\u766F\u7671\u7674\u7681\u7685\u768C\u768D\u7695\u769B\u769C\u769D\u769F\u76A0\u76A2", 6, "\u76AA\u76AD\u76BD\u76C1\u76C5\u76C9\u76CB\u76CC\u76CE\u76D4\u76D9\u76E0\u76E6\u76E8\u76EC\u76F0\u76F1\u76F6\u76F9\u76FC\u7700\u7706\u770A\u770E\u7712\u7714\u7715\u7717\u7719\u771A\u771C\u7722\u7728\u772D\u772E\u772F\u7734\u7735\u7736\u7739\u773D\u773E\u7742\u7745\u7746\u774A\u774D\u774E\u774F\u7752\u7756\u7757\u775C\u775E\u775F\u7760\u7762"],
      ["8fcfa1", "\u7764\u7767\u776A\u776C\u7770\u7772\u7773\u7774\u777A\u777D\u7780\u7784\u778C\u778D\u7794\u7795\u7796\u779A\u779F\u77A2\u77A7\u77AA\u77AE\u77AF\u77B1\u77B5\u77BE\u77C3\u77C9\u77D1\u77D2\u77D5\u77D9\u77DE\u77DF\u77E0\u77E4\u77E6\u77EA\u77EC\u77F0\u77F1\u77F4\u77F8\u77FB\u7805\u7806\u7809\u780D\u780E\u7811\u781D\u7821\u7822\u7823\u782D\u782E\u7830\u7835\u7837\u7843\u7844\u7847\u7848\u784C\u784E\u7852\u785C\u785E\u7860\u7861\u7863\u7864\u7868\u786A\u786E\u787A\u787E\u788A\u788F\u7894\u7898\u78A1\u789D\u789E\u789F\u78A4\u78A8\u78AC\u78AD\u78B0\u78B1\u78B2\u78B3"],
      ["8fd0a1", "\u78BB\u78BD\u78BF\u78C7\u78C8\u78C9\u78CC\u78CE\u78D2\u78D3\u78D5\u78D6\u78E4\u78DB\u78DF\u78E0\u78E1\u78E6\u78EA\u78F2\u78F3\u7900\u78F6\u78F7\u78FA\u78FB\u78FF\u7906\u790C\u7910\u791A\u791C\u791E\u791F\u7920\u7925\u7927\u7929\u792D\u7931\u7934\u7935\u793B\u793D\u793F\u7944\u7945\u7946\u794A\u794B\u794F\u7951\u7954\u7958\u795B\u795C\u7967\u7969\u796B\u7972\u7979\u797B\u797C\u797E\u798B\u798C\u7991\u7993\u7994\u7995\u7996\u7998\u799B\u799C\u79A1\u79A8\u79A9\u79AB\u79AF\u79B1\u79B4\u79B8\u79BB\u79C2\u79C4\u79C7\u79C8\u79CA\u79CF\u79D4\u79D6\u79DA\u79DD\u79DE"],
      ["8fd1a1", "\u79E0\u79E2\u79E5\u79EA\u79EB\u79ED\u79F1\u79F8\u79FC\u7A02\u7A03\u7A07\u7A09\u7A0A\u7A0C\u7A11\u7A15\u7A1B\u7A1E\u7A21\u7A27\u7A2B\u7A2D\u7A2F\u7A30\u7A34\u7A35\u7A38\u7A39\u7A3A\u7A44\u7A45\u7A47\u7A48\u7A4C\u7A55\u7A56\u7A59\u7A5C\u7A5D\u7A5F\u7A60\u7A65\u7A67\u7A6A\u7A6D\u7A75\u7A78\u7A7E\u7A80\u7A82\u7A85\u7A86\u7A8A\u7A8B\u7A90\u7A91\u7A94\u7A9E\u7AA0\u7AA3\u7AAC\u7AB3\u7AB5\u7AB9\u7ABB\u7ABC\u7AC6\u7AC9\u7ACC\u7ACE\u7AD1\u7ADB\u7AE8\u7AE9\u7AEB\u7AEC\u7AF1\u7AF4\u7AFB\u7AFD\u7AFE\u7B07\u7B14\u7B1F\u7B23\u7B27\u7B29\u7B2A\u7B2B\u7B2D\u7B2E\u7B2F\u7B30"],
      ["8fd2a1", "\u7B31\u7B34\u7B3D\u7B3F\u7B40\u7B41\u7B47\u7B4E\u7B55\u7B60\u7B64\u7B66\u7B69\u7B6A\u7B6D\u7B6F\u7B72\u7B73\u7B77\u7B84\u7B89\u7B8E\u7B90\u7B91\u7B96\u7B9B\u7B9E\u7BA0\u7BA5\u7BAC\u7BAF\u7BB0\u7BB2\u7BB5\u7BB6\u7BBA\u7BBB\u7BBC\u7BBD\u7BC2\u7BC5\u7BC8\u7BCA\u7BD4\u7BD6\u7BD7\u7BD9\u7BDA\u7BDB\u7BE8\u7BEA\u7BF2\u7BF4\u7BF5\u7BF8\u7BF9\u7BFA\u7BFC\u7BFE\u7C01\u7C02\u7C03\u7C04\u7C06\u7C09\u7C0B\u7C0C\u7C0E\u7C0F\u7C19\u7C1B\u7C20\u7C25\u7C26\u7C28\u7C2C\u7C31\u7C33\u7C34\u7C36\u7C39\u7C3A\u7C46\u7C4A\u7C55\u7C51\u7C52\u7C53\u7C59", 5],
      ["8fd3a1", "\u7C61\u7C63\u7C67\u7C69\u7C6D\u7C6E\u7C70\u7C72\u7C79\u7C7C\u7C7D\u7C86\u7C87\u7C8F\u7C94\u7C9E\u7CA0\u7CA6\u7CB0\u7CB6\u7CB7\u7CBA\u7CBB\u7CBC\u7CBF\u7CC4\u7CC7\u7CC8\u7CC9\u7CCD\u7CCF\u7CD3\u7CD4\u7CD5\u7CD7\u7CD9\u7CDA\u7CDD\u7CE6\u7CE9\u7CEB\u7CF5\u7D03\u7D07\u7D08\u7D09\u7D0F\u7D11\u7D12\u7D13\u7D16\u7D1D\u7D1E\u7D23\u7D26\u7D2A\u7D2D\u7D31\u7D3C\u7D3D\u7D3E\u7D40\u7D41\u7D47\u7D48\u7D4D\u7D51\u7D53\u7D57\u7D59\u7D5A\u7D5C\u7D5D\u7D65\u7D67\u7D6A\u7D70\u7D78\u7D7A\u7D7B\u7D7F\u7D81\u7D82\u7D83\u7D85\u7D86\u7D88\u7D8B\u7D8C\u7D8D\u7D91\u7D96\u7D97\u7D9D"],
      ["8fd4a1", "\u7D9E\u7DA6\u7DA7\u7DAA\u7DB3\u7DB6\u7DB7\u7DB9\u7DC2", 4, "\u7DCC\u7DCD\u7DCE\u7DD7\u7DD9\u7E00\u7DE2\u7DE5\u7DE6\u7DEA\u7DEB\u7DED\u7DF1\u7DF5\u7DF6\u7DF9\u7DFA\u7E08\u7E10\u7E11\u7E15\u7E17\u7E1C\u7E1D\u7E20\u7E27\u7E28\u7E2C\u7E2D\u7E2F\u7E33\u7E36\u7E3F\u7E44\u7E45\u7E47\u7E4E\u7E50\u7E52\u7E58\u7E5F\u7E61\u7E62\u7E65\u7E6B\u7E6E\u7E6F\u7E73\u7E78\u7E7E\u7E81\u7E86\u7E87\u7E8A\u7E8D\u7E91\u7E95\u7E98\u7E9A\u7E9D\u7E9E\u7F3C\u7F3B\u7F3D\u7F3E\u7F3F\u7F43\u7F44\u7F47\u7F4F\u7F52\u7F53\u7F5B\u7F5C\u7F5D\u7F61\u7F63\u7F64\u7F65\u7F66\u7F6D"],
      ["8fd5a1", "\u7F71\u7F7D\u7F7E\u7F7F\u7F80\u7F8B\u7F8D\u7F8F\u7F90\u7F91\u7F96\u7F97\u7F9C\u7FA1\u7FA2\u7FA6\u7FAA\u7FAD\u7FB4\u7FBC\u7FBF\u7FC0\u7FC3\u7FC8\u7FCE\u7FCF\u7FDB\u7FDF\u7FE3\u7FE5\u7FE8\u7FEC\u7FEE\u7FEF\u7FF2\u7FFA\u7FFD\u7FFE\u7FFF\u8007\u8008\u800A\u800D\u800E\u800F\u8011\u8013\u8014\u8016\u801D\u801E\u801F\u8020\u8024\u8026\u802C\u802E\u8030\u8034\u8035\u8037\u8039\u803A\u803C\u803E\u8040\u8044\u8060\u8064\u8066\u806D\u8071\u8075\u8081\u8088\u808E\u809C\u809E\u80A6\u80A7\u80AB\u80B8\u80B9\u80C8\u80CD\u80CF\u80D2\u80D4\u80D5\u80D7\u80D8\u80E0\u80ED\u80EE"],
      ["8fd6a1", "\u80F0\u80F2\u80F3\u80F6\u80F9\u80FA\u80FE\u8103\u810B\u8116\u8117\u8118\u811C\u811E\u8120\u8124\u8127\u812C\u8130\u8135\u813A\u813C\u8145\u8147\u814A\u814C\u8152\u8157\u8160\u8161\u8167\u8168\u8169\u816D\u816F\u8177\u8181\u8190\u8184\u8185\u8186\u818B\u818E\u8196\u8198\u819B\u819E\u81A2\u81AE\u81B2\u81B4\u81BB\u81CB\u81C3\u81C5\u81CA\u81CE\u81CF\u81D5\u81D7\u81DB\u81DD\u81DE\u81E1\u81E4\u81EB\u81EC\u81F0\u81F1\u81F2\u81F5\u81F6\u81F8\u81F9\u81FD\u81FF\u8200\u8203\u820F\u8213\u8214\u8219\u821A\u821D\u8221\u8222\u8228\u8232\u8234\u823A\u8243\u8244\u8245\u8246"],
      ["8fd7a1", "\u824B\u824E\u824F\u8251\u8256\u825C\u8260\u8263\u8267\u826D\u8274\u827B\u827D\u827F\u8280\u8281\u8283\u8284\u8287\u8289\u828A\u828E\u8291\u8294\u8296\u8298\u829A\u829B\u82A0\u82A1\u82A3\u82A4\u82A7\u82A8\u82A9\u82AA\u82AE\u82B0\u82B2\u82B4\u82B7\u82BA\u82BC\u82BE\u82BF\u82C6\u82D0\u82D5\u82DA\u82E0\u82E2\u82E4\u82E8\u82EA\u82ED\u82EF\u82F6\u82F7\u82FD\u82FE\u8300\u8301\u8307\u8308\u830A\u830B\u8354\u831B\u831D\u831E\u831F\u8321\u8322\u832C\u832D\u832E\u8330\u8333\u8337\u833A\u833C\u833D\u8342\u8343\u8344\u8347\u834D\u834E\u8351\u8355\u8356\u8357\u8370\u8378"],
      ["8fd8a1", "\u837D\u837F\u8380\u8382\u8384\u8386\u838D\u8392\u8394\u8395\u8398\u8399\u839B\u839C\u839D\u83A6\u83A7\u83A9\u83AC\u83BE\u83BF\u83C0\u83C7\u83C9\u83CF\u83D0\u83D1\u83D4\u83DD\u8353\u83E8\u83EA\u83F6\u83F8\u83F9\u83FC\u8401\u8406\u840A\u840F\u8411\u8415\u8419\u83AD\u842F\u8439\u8445\u8447\u8448\u844A\u844D\u844F\u8451\u8452\u8456\u8458\u8459\u845A\u845C\u8460\u8464\u8465\u8467\u846A\u8470\u8473\u8474\u8476\u8478\u847C\u847D\u8481\u8485\u8492\u8493\u8495\u849E\u84A6\u84A8\u84A9\u84AA\u84AF\u84B1\u84B4\u84BA\u84BD\u84BE\u84C0\u84C2\u84C7\u84C8\u84CC\u84CF\u84D3"],
      ["8fd9a1", "\u84DC\u84E7\u84EA\u84EF\u84F0\u84F1\u84F2\u84F7\u8532\u84FA\u84FB\u84FD\u8502\u8503\u8507\u850C\u850E\u8510\u851C\u851E\u8522\u8523\u8524\u8525\u8527\u852A\u852B\u852F\u8533\u8534\u8536\u853F\u8546\u854F", 4, "\u8556\u8559\u855C", 6, "\u8564\u856B\u856F\u8579\u857A\u857B\u857D\u857F\u8581\u8585\u8586\u8589\u858B\u858C\u858F\u8593\u8598\u859D\u859F\u85A0\u85A2\u85A5\u85A7\u85B4\u85B6\u85B7\u85B8\u85BC\u85BD\u85BE\u85BF\u85C2\u85C7\u85CA\u85CB\u85CE\u85AD\u85D8\u85DA\u85DF\u85E0\u85E6\u85E8\u85ED\u85F3\u85F6\u85FC"],
      ["8fdaa1", "\u85FF\u8600\u8604\u8605\u860D\u860E\u8610\u8611\u8612\u8618\u8619\u861B\u861E\u8621\u8627\u8629\u8636\u8638\u863A\u863C\u863D\u8640\u8642\u8646\u8652\u8653\u8656\u8657\u8658\u8659\u865D\u8660", 4, "\u8669\u866C\u866F\u8675\u8676\u8677\u867A\u868D\u8691\u8696\u8698\u869A\u869C\u86A1\u86A6\u86A7\u86A8\u86AD\u86B1\u86B3\u86B4\u86B5\u86B7\u86B8\u86B9\u86BF\u86C0\u86C1\u86C3\u86C5\u86D1\u86D2\u86D5\u86D7\u86DA\u86DC\u86E0\u86E3\u86E5\u86E7\u8688\u86FA\u86FC\u86FD\u8704\u8705\u8707\u870B\u870E\u870F\u8710\u8713\u8714\u8719\u871E\u871F\u8721\u8723"],
      ["8fdba1", "\u8728\u872E\u872F\u8731\u8732\u8739\u873A\u873C\u873D\u873E\u8740\u8743\u8745\u874D\u8758\u875D\u8761\u8764\u8765\u876F\u8771\u8772\u877B\u8783", 6, "\u878B\u878C\u8790\u8793\u8795\u8797\u8798\u8799\u879E\u87A0\u87A3\u87A7\u87AC\u87AD\u87AE\u87B1\u87B5\u87BE\u87BF\u87C1\u87C8\u87C9\u87CA\u87CE\u87D5\u87D6\u87D9\u87DA\u87DC\u87DF\u87E2\u87E3\u87E4\u87EA\u87EB\u87ED\u87F1\u87F3\u87F8\u87FA\u87FF\u8801\u8803\u8806\u8809\u880A\u880B\u8810\u8819\u8812\u8813\u8814\u8818\u881A\u881B\u881C\u881E\u881F\u8828\u882D\u882E\u8830\u8832\u8835"],
      ["8fdca1", "\u883A\u883C\u8841\u8843\u8845\u8848\u8849\u884A\u884B\u884E\u8851\u8855\u8856\u8858\u885A\u885C\u885F\u8860\u8864\u8869\u8871\u8879\u887B\u8880\u8898\u889A\u889B\u889C\u889F\u88A0\u88A8\u88AA\u88BA\u88BD\u88BE\u88C0\u88CA", 4, "\u88D1\u88D2\u88D3\u88DB\u88DE\u88E7\u88EF\u88F0\u88F1\u88F5\u88F7\u8901\u8906\u890D\u890E\u890F\u8915\u8916\u8918\u8919\u891A\u891C\u8920\u8926\u8927\u8928\u8930\u8931\u8932\u8935\u8939\u893A\u893E\u8940\u8942\u8945\u8946\u8949\u894F\u8952\u8957\u895A\u895B\u895C\u8961\u8962\u8963\u896B\u896E\u8970\u8973\u8975\u897A"],
      ["8fdda1", "\u897B\u897C\u897D\u8989\u898D\u8990\u8994\u8995\u899B\u899C\u899F\u89A0\u89A5\u89B0\u89B4\u89B5\u89B6\u89B7\u89BC\u89D4", 4, "\u89E5\u89E9\u89EB\u89ED\u89F1\u89F3\u89F6\u89F9\u89FD\u89FF\u8A04\u8A05\u8A07\u8A0F\u8A11\u8A12\u8A14\u8A15\u8A1E\u8A20\u8A22\u8A24\u8A26\u8A2B\u8A2C\u8A2F\u8A35\u8A37\u8A3D\u8A3E\u8A40\u8A43\u8A45\u8A47\u8A49\u8A4D\u8A4E\u8A53\u8A56\u8A57\u8A58\u8A5C\u8A5D\u8A61\u8A65\u8A67\u8A75\u8A76\u8A77\u8A79\u8A7A\u8A7B\u8A7E\u8A7F\u8A80\u8A83\u8A86\u8A8B\u8A8F\u8A90\u8A92\u8A96\u8A97\u8A99\u8A9F\u8AA7\u8AA9\u8AAE\u8AAF\u8AB3"],
      ["8fdea1", "\u8AB6\u8AB7\u8ABB\u8ABE\u8AC3\u8AC6\u8AC8\u8AC9\u8ACA\u8AD1\u8AD3\u8AD4\u8AD5\u8AD7\u8ADD\u8ADF\u8AEC\u8AF0\u8AF4\u8AF5\u8AF6\u8AFC\u8AFF\u8B05\u8B06\u8B0B\u8B11\u8B1C\u8B1E\u8B1F\u8B0A\u8B2D\u8B30\u8B37\u8B3C\u8B42", 4, "\u8B48\u8B52\u8B53\u8B54\u8B59\u8B4D\u8B5E\u8B63\u8B6D\u8B76\u8B78\u8B79\u8B7C\u8B7E\u8B81\u8B84\u8B85\u8B8B\u8B8D\u8B8F\u8B94\u8B95\u8B9C\u8B9E\u8B9F\u8C38\u8C39\u8C3D\u8C3E\u8C45\u8C47\u8C49\u8C4B\u8C4F\u8C51\u8C53\u8C54\u8C57\u8C58\u8C5B\u8C5D\u8C59\u8C63\u8C64\u8C66\u8C68\u8C69\u8C6D\u8C73\u8C75\u8C76\u8C7B\u8C7E\u8C86"],
      ["8fdfa1", "\u8C87\u8C8B\u8C90\u8C92\u8C93\u8C99\u8C9B\u8C9C\u8CA4\u8CB9\u8CBA\u8CC5\u8CC6\u8CC9\u8CCB\u8CCF\u8CD6\u8CD5\u8CD9\u8CDD\u8CE1\u8CE8\u8CEC\u8CEF\u8CF0\u8CF2\u8CF5\u8CF7\u8CF8\u8CFE\u8CFF\u8D01\u8D03\u8D09\u8D12\u8D17\u8D1B\u8D65\u8D69\u8D6C\u8D6E\u8D7F\u8D82\u8D84\u8D88\u8D8D\u8D90\u8D91\u8D95\u8D9E\u8D9F\u8DA0\u8DA6\u8DAB\u8DAC\u8DAF\u8DB2\u8DB5\u8DB7\u8DB9\u8DBB\u8DC0\u8DC5\u8DC6\u8DC7\u8DC8\u8DCA\u8DCE\u8DD1\u8DD4\u8DD5\u8DD7\u8DD9\u8DE4\u8DE5\u8DE7\u8DEC\u8DF0\u8DBC\u8DF1\u8DF2\u8DF4\u8DFD\u8E01\u8E04\u8E05\u8E06\u8E0B\u8E11\u8E14\u8E16\u8E20\u8E21\u8E22"],
      ["8fe0a1", "\u8E23\u8E26\u8E27\u8E31\u8E33\u8E36\u8E37\u8E38\u8E39\u8E3D\u8E40\u8E41\u8E4B\u8E4D\u8E4E\u8E4F\u8E54\u8E5B\u8E5C\u8E5D\u8E5E\u8E61\u8E62\u8E69\u8E6C\u8E6D\u8E6F\u8E70\u8E71\u8E79\u8E7A\u8E7B\u8E82\u8E83\u8E89\u8E90\u8E92\u8E95\u8E9A\u8E9B\u8E9D\u8E9E\u8EA2\u8EA7\u8EA9\u8EAD\u8EAE\u8EB3\u8EB5\u8EBA\u8EBB\u8EC0\u8EC1\u8EC3\u8EC4\u8EC7\u8ECF\u8ED1\u8ED4\u8EDC\u8EE8\u8EEE\u8EF0\u8EF1\u8EF7\u8EF9\u8EFA\u8EED\u8F00\u8F02\u8F07\u8F08\u8F0F\u8F10\u8F16\u8F17\u8F18\u8F1E\u8F20\u8F21\u8F23\u8F25\u8F27\u8F28\u8F2C\u8F2D\u8F2E\u8F34\u8F35\u8F36\u8F37\u8F3A\u8F40\u8F41"],
      ["8fe1a1", "\u8F43\u8F47\u8F4F\u8F51", 4, "\u8F58\u8F5D\u8F5E\u8F65\u8F9D\u8FA0\u8FA1\u8FA4\u8FA5\u8FA6\u8FB5\u8FB6\u8FB8\u8FBE\u8FC0\u8FC1\u8FC6\u8FCA\u8FCB\u8FCD\u8FD0\u8FD2\u8FD3\u8FD5\u8FE0\u8FE3\u8FE4\u8FE8\u8FEE\u8FF1\u8FF5\u8FF6\u8FFB\u8FFE\u9002\u9004\u9008\u900C\u9018\u901B\u9028\u9029\u902F\u902A\u902C\u902D\u9033\u9034\u9037\u903F\u9043\u9044\u904C\u905B\u905D\u9062\u9066\u9067\u906C\u9070\u9074\u9079\u9085\u9088\u908B\u908C\u908E\u9090\u9095\u9097\u9098\u9099\u909B\u90A0\u90A1\u90A2\u90A5\u90B0\u90B2\u90B3\u90B4\u90B6\u90BD\u90CC\u90BE\u90C3"],
      ["8fe2a1", "\u90C4\u90C5\u90C7\u90C8\u90D5\u90D7\u90D8\u90D9\u90DC\u90DD\u90DF\u90E5\u90D2\u90F6\u90EB\u90EF\u90F0\u90F4\u90FE\u90FF\u9100\u9104\u9105\u9106\u9108\u910D\u9110\u9114\u9116\u9117\u9118\u911A\u911C\u911E\u9120\u9125\u9122\u9123\u9127\u9129\u912E\u912F\u9131\u9134\u9136\u9137\u9139\u913A\u913C\u913D\u9143\u9147\u9148\u914F\u9153\u9157\u9159\u915A\u915B\u9161\u9164\u9167\u916D\u9174\u9179\u917A\u917B\u9181\u9183\u9185\u9186\u918A\u918E\u9191\u9193\u9194\u9195\u9198\u919E\u91A1\u91A6\u91A8\u91AC\u91AD\u91AE\u91B0\u91B1\u91B2\u91B3\u91B6\u91BB\u91BC\u91BD\u91BF"],
      ["8fe3a1", "\u91C2\u91C3\u91C5\u91D3\u91D4\u91D7\u91D9\u91DA\u91DE\u91E4\u91E5\u91E9\u91EA\u91EC", 5, "\u91F7\u91F9\u91FB\u91FD\u9200\u9201\u9204\u9205\u9206\u9207\u9209\u920A\u920C\u9210\u9212\u9213\u9216\u9218\u921C\u921D\u9223\u9224\u9225\u9226\u9228\u922E\u922F\u9230\u9233\u9235\u9236\u9238\u9239\u923A\u923C\u923E\u9240\u9242\u9243\u9246\u9247\u924A\u924D\u924E\u924F\u9251\u9258\u9259\u925C\u925D\u9260\u9261\u9265\u9267\u9268\u9269\u926E\u926F\u9270\u9275", 4, "\u927B\u927C\u927D\u927F\u9288\u9289\u928A\u928D\u928E\u9292\u9297"],
      ["8fe4a1", "\u9299\u929F\u92A0\u92A4\u92A5\u92A7\u92A8\u92AB\u92AF\u92B2\u92B6\u92B8\u92BA\u92BB\u92BC\u92BD\u92BF", 4, "\u92C5\u92C6\u92C7\u92C8\u92CB\u92CC\u92CD\u92CE\u92D0\u92D3\u92D5\u92D7\u92D8\u92D9\u92DC\u92DD\u92DF\u92E0\u92E1\u92E3\u92E5\u92E7\u92E8\u92EC\u92EE\u92F0\u92F9\u92FB\u92FF\u9300\u9302\u9308\u930D\u9311\u9314\u9315\u931C\u931D\u931E\u931F\u9321\u9324\u9325\u9327\u9329\u932A\u9333\u9334\u9336\u9337\u9347\u9348\u9349\u9350\u9351\u9352\u9355\u9357\u9358\u935A\u935E\u9364\u9365\u9367\u9369\u936A\u936D\u936F\u9370\u9371\u9373\u9374\u9376"],
      ["8fe5a1", "\u937A\u937D\u937F\u9380\u9381\u9382\u9388\u938A\u938B\u938D\u938F\u9392\u9395\u9398\u939B\u939E\u93A1\u93A3\u93A4\u93A6\u93A8\u93AB\u93B4\u93B5\u93B6\u93BA\u93A9\u93C1\u93C4\u93C5\u93C6\u93C7\u93C9", 4, "\u93D3\u93D9\u93DC\u93DE\u93DF\u93E2\u93E6\u93E7\u93F9\u93F7\u93F8\u93FA\u93FB\u93FD\u9401\u9402\u9404\u9408\u9409\u940D\u940E\u940F\u9415\u9416\u9417\u941F\u942E\u942F\u9431\u9432\u9433\u9434\u943B\u943F\u943D\u9443\u9445\u9448\u944A\u944C\u9455\u9459\u945C\u945F\u9461\u9463\u9468\u946B\u946D\u946E\u946F\u9471\u9472\u9484\u9483\u9578\u9579"],
      ["8fe6a1", "\u957E\u9584\u9588\u958C\u958D\u958E\u959D\u959E\u959F\u95A1\u95A6\u95A9\u95AB\u95AC\u95B4\u95B6\u95BA\u95BD\u95BF\u95C6\u95C8\u95C9\u95CB\u95D0\u95D1\u95D2\u95D3\u95D9\u95DA\u95DD\u95DE\u95DF\u95E0\u95E4\u95E6\u961D\u961E\u9622\u9624\u9625\u9626\u962C\u9631\u9633\u9637\u9638\u9639\u963A\u963C\u963D\u9641\u9652\u9654\u9656\u9657\u9658\u9661\u966E\u9674\u967B\u967C\u967E\u967F\u9681\u9682\u9683\u9684\u9689\u9691\u9696\u969A\u969D\u969F\u96A4\u96A5\u96A6\u96A9\u96AE\u96AF\u96B3\u96BA\u96CA\u96D2\u5DB2\u96D8\u96DA\u96DD\u96DE\u96DF\u96E9\u96EF\u96F1\u96FA\u9702"],
      ["8fe7a1", "\u9703\u9705\u9709\u971A\u971B\u971D\u9721\u9722\u9723\u9728\u9731\u9733\u9741\u9743\u974A\u974E\u974F\u9755\u9757\u9758\u975A\u975B\u9763\u9767\u976A\u976E\u9773\u9776\u9777\u9778\u977B\u977D\u977F\u9780\u9789\u9795\u9796\u9797\u9799\u979A\u979E\u979F\u97A2\u97AC\u97AE\u97B1\u97B2\u97B5\u97B6\u97B8\u97B9\u97BA\u97BC\u97BE\u97BF\u97C1\u97C4\u97C5\u97C7\u97C9\u97CA\u97CC\u97CD\u97CE\u97D0\u97D1\u97D4\u97D7\u97D8\u97D9\u97DD\u97DE\u97E0\u97DB\u97E1\u97E4\u97EF\u97F1\u97F4\u97F7\u97F8\u97FA\u9807\u980A\u9819\u980D\u980E\u9814\u9816\u981C\u981E\u9820\u9823\u9826"],
      ["8fe8a1", "\u982B\u982E\u982F\u9830\u9832\u9833\u9835\u9825\u983E\u9844\u9847\u984A\u9851\u9852\u9853\u9856\u9857\u9859\u985A\u9862\u9863\u9865\u9866\u986A\u986C\u98AB\u98AD\u98AE\u98B0\u98B4\u98B7\u98B8\u98BA\u98BB\u98BF\u98C2\u98C5\u98C8\u98CC\u98E1\u98E3\u98E5\u98E6\u98E7\u98EA\u98F3\u98F6\u9902\u9907\u9908\u9911\u9915\u9916\u9917\u991A\u991B\u991C\u991F\u9922\u9926\u9927\u992B\u9931", 4, "\u9939\u993A\u993B\u993C\u9940\u9941\u9946\u9947\u9948\u994D\u994E\u9954\u9958\u9959\u995B\u995C\u995E\u995F\u9960\u999B\u999D\u999F\u99A6\u99B0\u99B1\u99B2\u99B5"],
      ["8fe9a1", "\u99B9\u99BA\u99BD\u99BF\u99C3\u99C9\u99D3\u99D4\u99D9\u99DA\u99DC\u99DE\u99E7\u99EA\u99EB\u99EC\u99F0\u99F4\u99F5\u99F9\u99FD\u99FE\u9A02\u9A03\u9A04\u9A0B\u9A0C\u9A10\u9A11\u9A16\u9A1E\u9A20\u9A22\u9A23\u9A24\u9A27\u9A2D\u9A2E\u9A33\u9A35\u9A36\u9A38\u9A47\u9A41\u9A44\u9A4A\u9A4B\u9A4C\u9A4E\u9A51\u9A54\u9A56\u9A5D\u9AAA\u9AAC\u9AAE\u9AAF\u9AB2\u9AB4\u9AB5\u9AB6\u9AB9\u9ABB\u9ABE\u9ABF\u9AC1\u9AC3\u9AC6\u9AC8\u9ACE\u9AD0\u9AD2\u9AD5\u9AD6\u9AD7\u9ADB\u9ADC\u9AE0\u9AE4\u9AE5\u9AE7\u9AE9\u9AEC\u9AF2\u9AF3\u9AF5\u9AF9\u9AFA\u9AFD\u9AFF", 4],
      ["8feaa1", "\u9B04\u9B05\u9B08\u9B09\u9B0B\u9B0C\u9B0D\u9B0E\u9B10\u9B12\u9B16\u9B19\u9B1B\u9B1C\u9B20\u9B26\u9B2B\u9B2D\u9B33\u9B34\u9B35\u9B37\u9B39\u9B3A\u9B3D\u9B48\u9B4B\u9B4C\u9B55\u9B56\u9B57\u9B5B\u9B5E\u9B61\u9B63\u9B65\u9B66\u9B68\u9B6A", 4, "\u9B73\u9B75\u9B77\u9B78\u9B79\u9B7F\u9B80\u9B84\u9B85\u9B86\u9B87\u9B89\u9B8A\u9B8B\u9B8D\u9B8F\u9B90\u9B94\u9B9A\u9B9D\u9B9E\u9BA6\u9BA7\u9BA9\u9BAC\u9BB0\u9BB1\u9BB2\u9BB7\u9BB8\u9BBB\u9BBC\u9BBE\u9BBF\u9BC1\u9BC7\u9BC8\u9BCE\u9BD0\u9BD7\u9BD8\u9BDD\u9BDF\u9BE5\u9BE7\u9BEA\u9BEB\u9BEF\u9BF3\u9BF7\u9BF8"],
      ["8feba1", "\u9BF9\u9BFA\u9BFD\u9BFF\u9C00\u9C02\u9C0B\u9C0F\u9C11\u9C16\u9C18\u9C19\u9C1A\u9C1C\u9C1E\u9C22\u9C23\u9C26", 4, "\u9C31\u9C35\u9C36\u9C37\u9C3D\u9C41\u9C43\u9C44\u9C45\u9C49\u9C4A\u9C4E\u9C4F\u9C50\u9C53\u9C54\u9C56\u9C58\u9C5B\u9C5D\u9C5E\u9C5F\u9C63\u9C69\u9C6A\u9C5C\u9C6B\u9C68\u9C6E\u9C70\u9C72\u9C75\u9C77\u9C7B\u9CE6\u9CF2\u9CF7\u9CF9\u9D0B\u9D02\u9D11\u9D17\u9D18\u9D1C\u9D1D\u9D1E\u9D2F\u9D30\u9D32\u9D33\u9D34\u9D3A\u9D3C\u9D45\u9D3D\u9D42\u9D43\u9D47\u9D4A\u9D53\u9D54\u9D5F\u9D63\u9D62\u9D65\u9D69\u9D6A\u9D6B\u9D70\u9D76\u9D77\u9D7B"],
      ["8feca1", "\u9D7C\u9D7E\u9D83\u9D84\u9D86\u9D8A\u9D8D\u9D8E\u9D92\u9D93\u9D95\u9D96\u9D97\u9D98\u9DA1\u9DAA\u9DAC\u9DAE\u9DB1\u9DB5\u9DB9\u9DBC\u9DBF\u9DC3\u9DC7\u9DC9\u9DCA\u9DD4\u9DD5\u9DD6\u9DD7\u9DDA\u9DDE\u9DDF\u9DE0\u9DE5\u9DE7\u9DE9\u9DEB\u9DEE\u9DF0\u9DF3\u9DF4\u9DFE\u9E0A\u9E02\u9E07\u9E0E\u9E10\u9E11\u9E12\u9E15\u9E16\u9E19\u9E1C\u9E1D\u9E7A\u9E7B\u9E7C\u9E80\u9E82\u9E83\u9E84\u9E85\u9E87\u9E8E\u9E8F\u9E96\u9E98\u9E9B\u9E9E\u9EA4\u9EA8\u9EAC\u9EAE\u9EAF\u9EB0\u9EB3\u9EB4\u9EB5\u9EC6\u9EC8\u9ECB\u9ED5\u9EDF\u9EE4\u9EE7\u9EEC\u9EED\u9EEE\u9EF0\u9EF1\u9EF2\u9EF5"],
      ["8feda1", "\u9EF8\u9EFF\u9F02\u9F03\u9F09\u9F0F\u9F10\u9F11\u9F12\u9F14\u9F16\u9F17\u9F19\u9F1A\u9F1B\u9F1F\u9F22\u9F26\u9F2A\u9F2B\u9F2F\u9F31\u9F32\u9F34\u9F37\u9F39\u9F3A\u9F3C\u9F3D\u9F3F\u9F41\u9F43", 4, "\u9F53\u9F55\u9F56\u9F57\u9F58\u9F5A\u9F5D\u9F5E\u9F68\u9F69\u9F6D", 4, "\u9F73\u9F75\u9F7A\u9F7D\u9F8F\u9F90\u9F91\u9F92\u9F94\u9F96\u9F97\u9F9E\u9FA1\u9FA2\u9FA3\u9FA5"]
    ];
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/tables/cp936.json
var require_cp936 = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/tables/cp936.json"(exports, module) {
    module.exports = [
      ["0", "\0", 127, "\u20AC"],
      ["8140", "\u4E02\u4E04\u4E05\u4E06\u4E0F\u4E12\u4E17\u4E1F\u4E20\u4E21\u4E23\u4E26\u4E29\u4E2E\u4E2F\u4E31\u4E33\u4E35\u4E37\u4E3C\u4E40\u4E41\u4E42\u4E44\u4E46\u4E4A\u4E51\u4E55\u4E57\u4E5A\u4E5B\u4E62\u4E63\u4E64\u4E65\u4E67\u4E68\u4E6A", 5, "\u4E72\u4E74", 9, "\u4E7F", 6, "\u4E87\u4E8A"],
      ["8180", "\u4E90\u4E96\u4E97\u4E99\u4E9C\u4E9D\u4E9E\u4EA3\u4EAA\u4EAF\u4EB0\u4EB1\u4EB4\u4EB6\u4EB7\u4EB8\u4EB9\u4EBC\u4EBD\u4EBE\u4EC8\u4ECC\u4ECF\u4ED0\u4ED2\u4EDA\u4EDB\u4EDC\u4EE0\u4EE2\u4EE6\u4EE7\u4EE9\u4EED\u4EEE\u4EEF\u4EF1\u4EF4\u4EF8\u4EF9\u4EFA\u4EFC\u4EFE\u4F00\u4F02", 6, "\u4F0B\u4F0C\u4F12", 4, "\u4F1C\u4F1D\u4F21\u4F23\u4F28\u4F29\u4F2C\u4F2D\u4F2E\u4F31\u4F33\u4F35\u4F37\u4F39\u4F3B\u4F3E", 4, "\u4F44\u4F45\u4F47", 5, "\u4F52\u4F54\u4F56\u4F61\u4F62\u4F66\u4F68\u4F6A\u4F6B\u4F6D\u4F6E\u4F71\u4F72\u4F75\u4F77\u4F78\u4F79\u4F7A\u4F7D\u4F80\u4F81\u4F82\u4F85\u4F86\u4F87\u4F8A\u4F8C\u4F8E\u4F90\u4F92\u4F93\u4F95\u4F96\u4F98\u4F99\u4F9A\u4F9C\u4F9E\u4F9F\u4FA1\u4FA2"],
      ["8240", "\u4FA4\u4FAB\u4FAD\u4FB0", 4, "\u4FB6", 8, "\u4FC0\u4FC1\u4FC2\u4FC6\u4FC7\u4FC8\u4FC9\u4FCB\u4FCC\u4FCD\u4FD2", 4, "\u4FD9\u4FDB\u4FE0\u4FE2\u4FE4\u4FE5\u4FE7\u4FEB\u4FEC\u4FF0\u4FF2\u4FF4\u4FF5\u4FF6\u4FF7\u4FF9\u4FFB\u4FFC\u4FFD\u4FFF", 11],
      ["8280", "\u500B\u500E\u5010\u5011\u5013\u5015\u5016\u5017\u501B\u501D\u501E\u5020\u5022\u5023\u5024\u5027\u502B\u502F", 10, "\u503B\u503D\u503F\u5040\u5041\u5042\u5044\u5045\u5046\u5049\u504A\u504B\u504D\u5050", 4, "\u5056\u5057\u5058\u5059\u505B\u505D", 7, "\u5066", 5, "\u506D", 8, "\u5078\u5079\u507A\u507C\u507D\u5081\u5082\u5083\u5084\u5086\u5087\u5089\u508A\u508B\u508C\u508E", 20, "\u50A4\u50A6\u50AA\u50AB\u50AD", 4, "\u50B3", 6, "\u50BC"],
      ["8340", "\u50BD", 17, "\u50D0", 5, "\u50D7\u50D8\u50D9\u50DB", 10, "\u50E8\u50E9\u50EA\u50EB\u50EF\u50F0\u50F1\u50F2\u50F4\u50F6", 4, "\u50FC", 9, "\u5108"],
      ["8380", "\u5109\u510A\u510C", 5, "\u5113", 13, "\u5122", 28, "\u5142\u5147\u514A\u514C\u514E\u514F\u5150\u5152\u5153\u5157\u5158\u5159\u515B\u515D", 4, "\u5163\u5164\u5166\u5167\u5169\u516A\u516F\u5172\u517A\u517E\u517F\u5183\u5184\u5186\u5187\u518A\u518B\u518E\u518F\u5190\u5191\u5193\u5194\u5198\u519A\u519D\u519E\u519F\u51A1\u51A3\u51A6", 4, "\u51AD\u51AE\u51B4\u51B8\u51B9\u51BA\u51BE\u51BF\u51C1\u51C2\u51C3\u51C5\u51C8\u51CA\u51CD\u51CE\u51D0\u51D2", 5],
      ["8440", "\u51D8\u51D9\u51DA\u51DC\u51DE\u51DF\u51E2\u51E3\u51E5", 5, "\u51EC\u51EE\u51F1\u51F2\u51F4\u51F7\u51FE\u5204\u5205\u5209\u520B\u520C\u520F\u5210\u5213\u5214\u5215\u521C\u521E\u521F\u5221\u5222\u5223\u5225\u5226\u5227\u522A\u522C\u522F\u5231\u5232\u5234\u5235\u523C\u523E\u5244", 5, "\u524B\u524E\u524F\u5252\u5253\u5255\u5257\u5258"],
      ["8480", "\u5259\u525A\u525B\u525D\u525F\u5260\u5262\u5263\u5264\u5266\u5268\u526B\u526C\u526D\u526E\u5270\u5271\u5273", 9, "\u527E\u5280\u5283", 4, "\u5289", 6, "\u5291\u5292\u5294", 6, "\u529C\u52A4\u52A5\u52A6\u52A7\u52AE\u52AF\u52B0\u52B4", 9, "\u52C0\u52C1\u52C2\u52C4\u52C5\u52C6\u52C8\u52CA\u52CC\u52CD\u52CE\u52CF\u52D1\u52D3\u52D4\u52D5\u52D7\u52D9", 5, "\u52E0\u52E1\u52E2\u52E3\u52E5", 10, "\u52F1", 7, "\u52FB\u52FC\u52FD\u5301\u5302\u5303\u5304\u5307\u5309\u530A\u530B\u530C\u530E"],
      ["8540", "\u5311\u5312\u5313\u5314\u5318\u531B\u531C\u531E\u531F\u5322\u5324\u5325\u5327\u5328\u5329\u532B\u532C\u532D\u532F", 9, "\u533C\u533D\u5340\u5342\u5344\u5346\u534B\u534C\u534D\u5350\u5354\u5358\u5359\u535B\u535D\u5365\u5368\u536A\u536C\u536D\u5372\u5376\u5379\u537B\u537C\u537D\u537E\u5380\u5381\u5383\u5387\u5388\u538A\u538E\u538F"],
      ["8580", "\u5390", 4, "\u5396\u5397\u5399\u539B\u539C\u539E\u53A0\u53A1\u53A4\u53A7\u53AA\u53AB\u53AC\u53AD\u53AF", 6, "\u53B7\u53B8\u53B9\u53BA\u53BC\u53BD\u53BE\u53C0\u53C3", 4, "\u53CE\u53CF\u53D0\u53D2\u53D3\u53D5\u53DA\u53DC\u53DD\u53DE\u53E1\u53E2\u53E7\u53F4\u53FA\u53FE\u53FF\u5400\u5402\u5405\u5407\u540B\u5414\u5418\u5419\u541A\u541C\u5422\u5424\u5425\u542A\u5430\u5433\u5436\u5437\u543A\u543D\u543F\u5441\u5442\u5444\u5445\u5447\u5449\u544C\u544D\u544E\u544F\u5451\u545A\u545D", 4, "\u5463\u5465\u5467\u5469", 7, "\u5474\u5479\u547A\u547E\u547F\u5481\u5483\u5485\u5487\u5488\u5489\u548A\u548D\u5491\u5493\u5497\u5498\u549C\u549E\u549F\u54A0\u54A1"],
      ["8640", "\u54A2\u54A5\u54AE\u54B0\u54B2\u54B5\u54B6\u54B7\u54B9\u54BA\u54BC\u54BE\u54C3\u54C5\u54CA\u54CB\u54D6\u54D8\u54DB\u54E0", 4, "\u54EB\u54EC\u54EF\u54F0\u54F1\u54F4", 5, "\u54FB\u54FE\u5500\u5502\u5503\u5504\u5505\u5508\u550A", 4, "\u5512\u5513\u5515", 5, "\u551C\u551D\u551E\u551F\u5521\u5525\u5526"],
      ["8680", "\u5528\u5529\u552B\u552D\u5532\u5534\u5535\u5536\u5538\u5539\u553A\u553B\u553D\u5540\u5542\u5545\u5547\u5548\u554B", 4, "\u5551\u5552\u5553\u5554\u5557", 4, "\u555D\u555E\u555F\u5560\u5562\u5563\u5568\u5569\u556B\u556F", 5, "\u5579\u557A\u557D\u557F\u5585\u5586\u558C\u558D\u558E\u5590\u5592\u5593\u5595\u5596\u5597\u559A\u559B\u559E\u55A0", 6, "\u55A8", 8, "\u55B2\u55B4\u55B6\u55B8\u55BA\u55BC\u55BF", 4, "\u55C6\u55C7\u55C8\u55CA\u55CB\u55CE\u55CF\u55D0\u55D5\u55D7", 4, "\u55DE\u55E0\u55E2\u55E7\u55E9\u55ED\u55EE\u55F0\u55F1\u55F4\u55F6\u55F8", 4, "\u55FF\u5602\u5603\u5604\u5605"],
      ["8740", "\u5606\u5607\u560A\u560B\u560D\u5610", 7, "\u5619\u561A\u561C\u561D\u5620\u5621\u5622\u5625\u5626\u5628\u5629\u562A\u562B\u562E\u562F\u5630\u5633\u5635\u5637\u5638\u563A\u563C\u563D\u563E\u5640", 11, "\u564F", 4, "\u5655\u5656\u565A\u565B\u565D", 4],
      ["8780", "\u5663\u5665\u5666\u5667\u566D\u566E\u566F\u5670\u5672\u5673\u5674\u5675\u5677\u5678\u5679\u567A\u567D", 7, "\u5687", 6, "\u5690\u5691\u5692\u5694", 14, "\u56A4", 10, "\u56B0", 6, "\u56B8\u56B9\u56BA\u56BB\u56BD", 12, "\u56CB", 8, "\u56D5\u56D6\u56D8\u56D9\u56DC\u56E3\u56E5", 5, "\u56EC\u56EE\u56EF\u56F2\u56F3\u56F6\u56F7\u56F8\u56FB\u56FC\u5700\u5701\u5702\u5705\u5707\u570B", 6],
      ["8840", "\u5712", 9, "\u571D\u571E\u5720\u5721\u5722\u5724\u5725\u5726\u5727\u572B\u5731\u5732\u5734", 4, "\u573C\u573D\u573F\u5741\u5743\u5744\u5745\u5746\u5748\u5749\u574B\u5752", 4, "\u5758\u5759\u5762\u5763\u5765\u5767\u576C\u576E\u5770\u5771\u5772\u5774\u5775\u5778\u5779\u577A\u577D\u577E\u577F\u5780"],
      ["8880", "\u5781\u5787\u5788\u5789\u578A\u578D", 4, "\u5794", 6, "\u579C\u579D\u579E\u579F\u57A5\u57A8\u57AA\u57AC\u57AF\u57B0\u57B1\u57B3\u57B5\u57B6\u57B7\u57B9", 8, "\u57C4", 6, "\u57CC\u57CD\u57D0\u57D1\u57D3\u57D6\u57D7\u57DB\u57DC\u57DE\u57E1\u57E2\u57E3\u57E5", 7, "\u57EE\u57F0\u57F1\u57F2\u57F3\u57F5\u57F6\u57F7\u57FB\u57FC\u57FE\u57FF\u5801\u5803\u5804\u5805\u5808\u5809\u580A\u580C\u580E\u580F\u5810\u5812\u5813\u5814\u5816\u5817\u5818\u581A\u581B\u581C\u581D\u581F\u5822\u5823\u5825", 4, "\u582B", 4, "\u5831\u5832\u5833\u5834\u5836", 7],
      ["8940", "\u583E", 5, "\u5845", 6, "\u584E\u584F\u5850\u5852\u5853\u5855\u5856\u5857\u5859", 4, "\u585F", 5, "\u5866", 4, "\u586D", 16, "\u587F\u5882\u5884\u5886\u5887\u5888\u588A\u588B\u588C"],
      ["8980", "\u588D", 4, "\u5894", 4, "\u589B\u589C\u589D\u58A0", 7, "\u58AA", 17, "\u58BD\u58BE\u58BF\u58C0\u58C2\u58C3\u58C4\u58C6", 10, "\u58D2\u58D3\u58D4\u58D6", 13, "\u58E5", 5, "\u58ED\u58EF\u58F1\u58F2\u58F4\u58F5\u58F7\u58F8\u58FA", 7, "\u5903\u5905\u5906\u5908", 4, "\u590E\u5910\u5911\u5912\u5913\u5917\u5918\u591B\u591D\u591E\u5920\u5921\u5922\u5923\u5926\u5928\u592C\u5930\u5932\u5933\u5935\u5936\u593B"],
      ["8a40", "\u593D\u593E\u593F\u5940\u5943\u5945\u5946\u594A\u594C\u594D\u5950\u5952\u5953\u5959\u595B", 4, "\u5961\u5963\u5964\u5966", 12, "\u5975\u5977\u597A\u597B\u597C\u597E\u597F\u5980\u5985\u5989\u598B\u598C\u598E\u598F\u5990\u5991\u5994\u5995\u5998\u599A\u599B\u599C\u599D\u599F\u59A0\u59A1\u59A2\u59A6"],
      ["8a80", "\u59A7\u59AC\u59AD\u59B0\u59B1\u59B3", 5, "\u59BA\u59BC\u59BD\u59BF", 6, "\u59C7\u59C8\u59C9\u59CC\u59CD\u59CE\u59CF\u59D5\u59D6\u59D9\u59DB\u59DE", 4, "\u59E4\u59E6\u59E7\u59E9\u59EA\u59EB\u59ED", 11, "\u59FA\u59FC\u59FD\u59FE\u5A00\u5A02\u5A0A\u5A0B\u5A0D\u5A0E\u5A0F\u5A10\u5A12\u5A14\u5A15\u5A16\u5A17\u5A19\u5A1A\u5A1B\u5A1D\u5A1E\u5A21\u5A22\u5A24\u5A26\u5A27\u5A28\u5A2A", 6, "\u5A33\u5A35\u5A37", 4, "\u5A3D\u5A3E\u5A3F\u5A41", 4, "\u5A47\u5A48\u5A4B", 9, "\u5A56\u5A57\u5A58\u5A59\u5A5B", 5],
      ["8b40", "\u5A61\u5A63\u5A64\u5A65\u5A66\u5A68\u5A69\u5A6B", 8, "\u5A78\u5A79\u5A7B\u5A7C\u5A7D\u5A7E\u5A80", 17, "\u5A93", 6, "\u5A9C", 13, "\u5AAB\u5AAC"],
      ["8b80", "\u5AAD", 4, "\u5AB4\u5AB6\u5AB7\u5AB9", 4, "\u5ABF\u5AC0\u5AC3", 5, "\u5ACA\u5ACB\u5ACD", 4, "\u5AD3\u5AD5\u5AD7\u5AD9\u5ADA\u5ADB\u5ADD\u5ADE\u5ADF\u5AE2\u5AE4\u5AE5\u5AE7\u5AE8\u5AEA\u5AEC", 4, "\u5AF2", 22, "\u5B0A", 11, "\u5B18", 25, "\u5B33\u5B35\u5B36\u5B38", 7, "\u5B41", 6],
      ["8c40", "\u5B48", 7, "\u5B52\u5B56\u5B5E\u5B60\u5B61\u5B67\u5B68\u5B6B\u5B6D\u5B6E\u5B6F\u5B72\u5B74\u5B76\u5B77\u5B78\u5B79\u5B7B\u5B7C\u5B7E\u5B7F\u5B82\u5B86\u5B8A\u5B8D\u5B8E\u5B90\u5B91\u5B92\u5B94\u5B96\u5B9F\u5BA7\u5BA8\u5BA9\u5BAC\u5BAD\u5BAE\u5BAF\u5BB1\u5BB2\u5BB7\u5BBA\u5BBB\u5BBC\u5BC0\u5BC1\u5BC3\u5BC8\u5BC9\u5BCA\u5BCB\u5BCD\u5BCE\u5BCF"],
      ["8c80", "\u5BD1\u5BD4", 8, "\u5BE0\u5BE2\u5BE3\u5BE6\u5BE7\u5BE9", 4, "\u5BEF\u5BF1", 6, "\u5BFD\u5BFE\u5C00\u5C02\u5C03\u5C05\u5C07\u5C08\u5C0B\u5C0C\u5C0D\u5C0E\u5C10\u5C12\u5C13\u5C17\u5C19\u5C1B\u5C1E\u5C1F\u5C20\u5C21\u5C23\u5C26\u5C28\u5C29\u5C2A\u5C2B\u5C2D\u5C2E\u5C2F\u5C30\u5C32\u5C33\u5C35\u5C36\u5C37\u5C43\u5C44\u5C46\u5C47\u5C4C\u5C4D\u5C52\u5C53\u5C54\u5C56\u5C57\u5C58\u5C5A\u5C5B\u5C5C\u5C5D\u5C5F\u5C62\u5C64\u5C67", 6, "\u5C70\u5C72", 6, "\u5C7B\u5C7C\u5C7D\u5C7E\u5C80\u5C83", 4, "\u5C89\u5C8A\u5C8B\u5C8E\u5C8F\u5C92\u5C93\u5C95\u5C9D", 4, "\u5CA4", 4],
      ["8d40", "\u5CAA\u5CAE\u5CAF\u5CB0\u5CB2\u5CB4\u5CB6\u5CB9\u5CBA\u5CBB\u5CBC\u5CBE\u5CC0\u5CC2\u5CC3\u5CC5", 5, "\u5CCC", 5, "\u5CD3", 5, "\u5CDA", 6, "\u5CE2\u5CE3\u5CE7\u5CE9\u5CEB\u5CEC\u5CEE\u5CEF\u5CF1", 9, "\u5CFC", 4],
      ["8d80", "\u5D01\u5D04\u5D05\u5D08", 5, "\u5D0F", 4, "\u5D15\u5D17\u5D18\u5D19\u5D1A\u5D1C\u5D1D\u5D1F", 4, "\u5D25\u5D28\u5D2A\u5D2B\u5D2C\u5D2F", 4, "\u5D35", 7, "\u5D3F", 7, "\u5D48\u5D49\u5D4D", 10, "\u5D59\u5D5A\u5D5C\u5D5E", 10, "\u5D6A\u5D6D\u5D6E\u5D70\u5D71\u5D72\u5D73\u5D75", 12, "\u5D83", 21, "\u5D9A\u5D9B\u5D9C\u5D9E\u5D9F\u5DA0"],
      ["8e40", "\u5DA1", 21, "\u5DB8", 12, "\u5DC6", 6, "\u5DCE", 12, "\u5DDC\u5DDF\u5DE0\u5DE3\u5DE4\u5DEA\u5DEC\u5DED"],
      ["8e80", "\u5DF0\u5DF5\u5DF6\u5DF8", 4, "\u5DFF\u5E00\u5E04\u5E07\u5E09\u5E0A\u5E0B\u5E0D\u5E0E\u5E12\u5E13\u5E17\u5E1E", 7, "\u5E28", 4, "\u5E2F\u5E30\u5E32", 4, "\u5E39\u5E3A\u5E3E\u5E3F\u5E40\u5E41\u5E43\u5E46", 5, "\u5E4D", 6, "\u5E56", 4, "\u5E5C\u5E5D\u5E5F\u5E60\u5E63", 14, "\u5E75\u5E77\u5E79\u5E7E\u5E81\u5E82\u5E83\u5E85\u5E88\u5E89\u5E8C\u5E8D\u5E8E\u5E92\u5E98\u5E9B\u5E9D\u5EA1\u5EA2\u5EA3\u5EA4\u5EA8", 4, "\u5EAE", 4, "\u5EB4\u5EBA\u5EBB\u5EBC\u5EBD\u5EBF", 6],
      ["8f40", "\u5EC6\u5EC7\u5EC8\u5ECB", 5, "\u5ED4\u5ED5\u5ED7\u5ED8\u5ED9\u5EDA\u5EDC", 11, "\u5EE9\u5EEB", 8, "\u5EF5\u5EF8\u5EF9\u5EFB\u5EFC\u5EFD\u5F05\u5F06\u5F07\u5F09\u5F0C\u5F0D\u5F0E\u5F10\u5F12\u5F14\u5F16\u5F19\u5F1A\u5F1C\u5F1D\u5F1E\u5F21\u5F22\u5F23\u5F24"],
      ["8f80", "\u5F28\u5F2B\u5F2C\u5F2E\u5F30\u5F32", 6, "\u5F3B\u5F3D\u5F3E\u5F3F\u5F41", 14, "\u5F51\u5F54\u5F59\u5F5A\u5F5B\u5F5C\u5F5E\u5F5F\u5F60\u5F63\u5F65\u5F67\u5F68\u5F6B\u5F6E\u5F6F\u5F72\u5F74\u5F75\u5F76\u5F78\u5F7A\u5F7D\u5F7E\u5F7F\u5F83\u5F86\u5F8D\u5F8E\u5F8F\u5F91\u5F93\u5F94\u5F96\u5F9A\u5F9B\u5F9D\u5F9E\u5F9F\u5FA0\u5FA2", 5, "\u5FA9\u5FAB\u5FAC\u5FAF", 5, "\u5FB6\u5FB8\u5FB9\u5FBA\u5FBB\u5FBE", 4, "\u5FC7\u5FC8\u5FCA\u5FCB\u5FCE\u5FD3\u5FD4\u5FD5\u5FDA\u5FDB\u5FDC\u5FDE\u5FDF\u5FE2\u5FE3\u5FE5\u5FE6\u5FE8\u5FE9\u5FEC\u5FEF\u5FF0\u5FF2\u5FF3\u5FF4\u5FF6\u5FF7\u5FF9\u5FFA\u5FFC\u6007"],
      ["9040", "\u6008\u6009\u600B\u600C\u6010\u6011\u6013\u6017\u6018\u601A\u601E\u601F\u6022\u6023\u6024\u602C\u602D\u602E\u6030", 4, "\u6036", 4, "\u603D\u603E\u6040\u6044", 6, "\u604C\u604E\u604F\u6051\u6053\u6054\u6056\u6057\u6058\u605B\u605C\u605E\u605F\u6060\u6061\u6065\u6066\u606E\u6071\u6072\u6074\u6075\u6077\u607E\u6080"],
      ["9080", "\u6081\u6082\u6085\u6086\u6087\u6088\u608A\u608B\u608E\u608F\u6090\u6091\u6093\u6095\u6097\u6098\u6099\u609C\u609E\u60A1\u60A2\u60A4\u60A5\u60A7\u60A9\u60AA\u60AE\u60B0\u60B3\u60B5\u60B6\u60B7\u60B9\u60BA\u60BD", 7, "\u60C7\u60C8\u60C9\u60CC", 4, "\u60D2\u60D3\u60D4\u60D6\u60D7\u60D9\u60DB\u60DE\u60E1", 4, "\u60EA\u60F1\u60F2\u60F5\u60F7\u60F8\u60FB", 4, "\u6102\u6103\u6104\u6105\u6107\u610A\u610B\u610C\u6110", 4, "\u6116\u6117\u6118\u6119\u611B\u611C\u611D\u611E\u6121\u6122\u6125\u6128\u6129\u612A\u612C", 18, "\u6140", 6],
      ["9140", "\u6147\u6149\u614B\u614D\u614F\u6150\u6152\u6153\u6154\u6156", 6, "\u615E\u615F\u6160\u6161\u6163\u6164\u6165\u6166\u6169", 6, "\u6171\u6172\u6173\u6174\u6176\u6178", 18, "\u618C\u618D\u618F", 4, "\u6195"],
      ["9180", "\u6196", 6, "\u619E", 8, "\u61AA\u61AB\u61AD", 9, "\u61B8", 5, "\u61BF\u61C0\u61C1\u61C3", 4, "\u61C9\u61CC", 4, "\u61D3\u61D5", 16, "\u61E7", 13, "\u61F6", 8, "\u6200", 5, "\u6207\u6209\u6213\u6214\u6219\u621C\u621D\u621E\u6220\u6223\u6226\u6227\u6228\u6229\u622B\u622D\u622F\u6230\u6231\u6232\u6235\u6236\u6238", 4, "\u6242\u6244\u6245\u6246\u624A"],
      ["9240", "\u624F\u6250\u6255\u6256\u6257\u6259\u625A\u625C", 6, "\u6264\u6265\u6268\u6271\u6272\u6274\u6275\u6277\u6278\u627A\u627B\u627D\u6281\u6282\u6283\u6285\u6286\u6287\u6288\u628B", 5, "\u6294\u6299\u629C\u629D\u629E\u62A3\u62A6\u62A7\u62A9\u62AA\u62AD\u62AE\u62AF\u62B0\u62B2\u62B3\u62B4\u62B6\u62B7\u62B8\u62BA\u62BE\u62C0\u62C1"],
      ["9280", "\u62C3\u62CB\u62CF\u62D1\u62D5\u62DD\u62DE\u62E0\u62E1\u62E4\u62EA\u62EB\u62F0\u62F2\u62F5\u62F8\u62F9\u62FA\u62FB\u6300\u6303\u6304\u6305\u6306\u630A\u630B\u630C\u630D\u630F\u6310\u6312\u6313\u6314\u6315\u6317\u6318\u6319\u631C\u6326\u6327\u6329\u632C\u632D\u632E\u6330\u6331\u6333", 5, "\u633B\u633C\u633E\u633F\u6340\u6341\u6344\u6347\u6348\u634A\u6351\u6352\u6353\u6354\u6356", 7, "\u6360\u6364\u6365\u6366\u6368\u636A\u636B\u636C\u636F\u6370\u6372\u6373\u6374\u6375\u6378\u6379\u637C\u637D\u637E\u637F\u6381\u6383\u6384\u6385\u6386\u638B\u638D\u6391\u6393\u6394\u6395\u6397\u6399", 6, "\u63A1\u63A4\u63A6\u63AB\u63AF\u63B1\u63B2\u63B5\u63B6\u63B9\u63BB\u63BD\u63BF\u63C0"],
      ["9340", "\u63C1\u63C2\u63C3\u63C5\u63C7\u63C8\u63CA\u63CB\u63CC\u63D1\u63D3\u63D4\u63D5\u63D7", 6, "\u63DF\u63E2\u63E4", 4, "\u63EB\u63EC\u63EE\u63EF\u63F0\u63F1\u63F3\u63F5\u63F7\u63F9\u63FA\u63FB\u63FC\u63FE\u6403\u6404\u6406", 4, "\u640D\u640E\u6411\u6412\u6415", 5, "\u641D\u641F\u6422\u6423\u6424"],
      ["9380", "\u6425\u6427\u6428\u6429\u642B\u642E", 5, "\u6435", 4, "\u643B\u643C\u643E\u6440\u6442\u6443\u6449\u644B", 6, "\u6453\u6455\u6456\u6457\u6459", 4, "\u645F", 7, "\u6468\u646A\u646B\u646C\u646E", 9, "\u647B", 6, "\u6483\u6486\u6488", 8, "\u6493\u6494\u6497\u6498\u649A\u649B\u649C\u649D\u649F", 4, "\u64A5\u64A6\u64A7\u64A8\u64AA\u64AB\u64AF\u64B1\u64B2\u64B3\u64B4\u64B6\u64B9\u64BB\u64BD\u64BE\u64BF\u64C1\u64C3\u64C4\u64C6", 6, "\u64CF\u64D1\u64D3\u64D4\u64D5\u64D6\u64D9\u64DA"],
      ["9440", "\u64DB\u64DC\u64DD\u64DF\u64E0\u64E1\u64E3\u64E5\u64E7", 24, "\u6501", 7, "\u650A", 7, "\u6513", 4, "\u6519", 8],
      ["9480", "\u6522\u6523\u6524\u6526", 4, "\u652C\u652D\u6530\u6531\u6532\u6533\u6537\u653A\u653C\u653D\u6540", 4, "\u6546\u6547\u654A\u654B\u654D\u654E\u6550\u6552\u6553\u6554\u6557\u6558\u655A\u655C\u655F\u6560\u6561\u6564\u6565\u6567\u6568\u6569\u656A\u656D\u656E\u656F\u6571\u6573\u6575\u6576\u6578", 14, "\u6588\u6589\u658A\u658D\u658E\u658F\u6592\u6594\u6595\u6596\u6598\u659A\u659D\u659E\u65A0\u65A2\u65A3\u65A6\u65A8\u65AA\u65AC\u65AE\u65B1", 7, "\u65BA\u65BB\u65BE\u65BF\u65C0\u65C2\u65C7\u65C8\u65C9\u65CA\u65CD\u65D0\u65D1\u65D3\u65D4\u65D5\u65D8", 7, "\u65E1\u65E3\u65E4\u65EA\u65EB"],
      ["9540", "\u65F2\u65F3\u65F4\u65F5\u65F8\u65F9\u65FB", 4, "\u6601\u6604\u6605\u6607\u6608\u6609\u660B\u660D\u6610\u6611\u6612\u6616\u6617\u6618\u661A\u661B\u661C\u661E\u6621\u6622\u6623\u6624\u6626\u6629\u662A\u662B\u662C\u662E\u6630\u6632\u6633\u6637", 4, "\u663D\u663F\u6640\u6642\u6644", 6, "\u664D\u664E\u6650\u6651\u6658"],
      ["9580", "\u6659\u665B\u665C\u665D\u665E\u6660\u6662\u6663\u6665\u6667\u6669", 4, "\u6671\u6672\u6673\u6675\u6678\u6679\u667B\u667C\u667D\u667F\u6680\u6681\u6683\u6685\u6686\u6688\u6689\u668A\u668B\u668D\u668E\u668F\u6690\u6692\u6693\u6694\u6695\u6698", 4, "\u669E", 8, "\u66A9", 4, "\u66AF", 4, "\u66B5\u66B6\u66B7\u66B8\u66BA\u66BB\u66BC\u66BD\u66BF", 25, "\u66DA\u66DE", 7, "\u66E7\u66E8\u66EA", 5, "\u66F1\u66F5\u66F6\u66F8\u66FA\u66FB\u66FD\u6701\u6702\u6703"],
      ["9640", "\u6704\u6705\u6706\u6707\u670C\u670E\u670F\u6711\u6712\u6713\u6716\u6718\u6719\u671A\u671C\u671E\u6720", 5, "\u6727\u6729\u672E\u6730\u6732\u6733\u6736\u6737\u6738\u6739\u673B\u673C\u673E\u673F\u6741\u6744\u6745\u6747\u674A\u674B\u674D\u6752\u6754\u6755\u6757", 4, "\u675D\u6762\u6763\u6764\u6766\u6767\u676B\u676C\u676E\u6771\u6774\u6776"],
      ["9680", "\u6778\u6779\u677A\u677B\u677D\u6780\u6782\u6783\u6785\u6786\u6788\u678A\u678C\u678D\u678E\u678F\u6791\u6792\u6793\u6794\u6796\u6799\u679B\u679F\u67A0\u67A1\u67A4\u67A6\u67A9\u67AC\u67AE\u67B1\u67B2\u67B4\u67B9", 7, "\u67C2\u67C5", 9, "\u67D5\u67D6\u67D7\u67DB\u67DF\u67E1\u67E3\u67E4\u67E6\u67E7\u67E8\u67EA\u67EB\u67ED\u67EE\u67F2\u67F5", 7, "\u67FE\u6801\u6802\u6803\u6804\u6806\u680D\u6810\u6812\u6814\u6815\u6818", 4, "\u681E\u681F\u6820\u6822", 6, "\u682B", 6, "\u6834\u6835\u6836\u683A\u683B\u683F\u6847\u684B\u684D\u684F\u6852\u6856", 5],
      ["9740", "\u685C\u685D\u685E\u685F\u686A\u686C", 7, "\u6875\u6878", 8, "\u6882\u6884\u6887", 7, "\u6890\u6891\u6892\u6894\u6895\u6896\u6898", 9, "\u68A3\u68A4\u68A5\u68A9\u68AA\u68AB\u68AC\u68AE\u68B1\u68B2\u68B4\u68B6\u68B7\u68B8"],
      ["9780", "\u68B9", 6, "\u68C1\u68C3", 5, "\u68CA\u68CC\u68CE\u68CF\u68D0\u68D1\u68D3\u68D4\u68D6\u68D7\u68D9\u68DB", 4, "\u68E1\u68E2\u68E4", 9, "\u68EF\u68F2\u68F3\u68F4\u68F6\u68F7\u68F8\u68FB\u68FD\u68FE\u68FF\u6900\u6902\u6903\u6904\u6906", 4, "\u690C\u690F\u6911\u6913", 11, "\u6921\u6922\u6923\u6925", 7, "\u692E\u692F\u6931\u6932\u6933\u6935\u6936\u6937\u6938\u693A\u693B\u693C\u693E\u6940\u6941\u6943", 16, "\u6955\u6956\u6958\u6959\u695B\u695C\u695F"],
      ["9840", "\u6961\u6962\u6964\u6965\u6967\u6968\u6969\u696A\u696C\u696D\u696F\u6970\u6972", 4, "\u697A\u697B\u697D\u697E\u697F\u6981\u6983\u6985\u698A\u698B\u698C\u698E", 5, "\u6996\u6997\u6999\u699A\u699D", 9, "\u69A9\u69AA\u69AC\u69AE\u69AF\u69B0\u69B2\u69B3\u69B5\u69B6\u69B8\u69B9\u69BA\u69BC\u69BD"],
      ["9880", "\u69BE\u69BF\u69C0\u69C2", 7, "\u69CB\u69CD\u69CF\u69D1\u69D2\u69D3\u69D5", 5, "\u69DC\u69DD\u69DE\u69E1", 11, "\u69EE\u69EF\u69F0\u69F1\u69F3", 9, "\u69FE\u6A00", 9, "\u6A0B", 11, "\u6A19", 5, "\u6A20\u6A22", 5, "\u6A29\u6A2B\u6A2C\u6A2D\u6A2E\u6A30\u6A32\u6A33\u6A34\u6A36", 6, "\u6A3F", 4, "\u6A45\u6A46\u6A48", 7, "\u6A51", 6, "\u6A5A"],
      ["9940", "\u6A5C", 4, "\u6A62\u6A63\u6A64\u6A66", 10, "\u6A72", 6, "\u6A7A\u6A7B\u6A7D\u6A7E\u6A7F\u6A81\u6A82\u6A83\u6A85", 8, "\u6A8F\u6A92", 4, "\u6A98", 7, "\u6AA1", 5],
      ["9980", "\u6AA7\u6AA8\u6AAA\u6AAD", 114, "\u6B25\u6B26\u6B28", 6],
      ["9a40", "\u6B2F\u6B30\u6B31\u6B33\u6B34\u6B35\u6B36\u6B38\u6B3B\u6B3C\u6B3D\u6B3F\u6B40\u6B41\u6B42\u6B44\u6B45\u6B48\u6B4A\u6B4B\u6B4D", 11, "\u6B5A", 7, "\u6B68\u6B69\u6B6B", 13, "\u6B7A\u6B7D\u6B7E\u6B7F\u6B80\u6B85\u6B88"],
      ["9a80", "\u6B8C\u6B8E\u6B8F\u6B90\u6B91\u6B94\u6B95\u6B97\u6B98\u6B99\u6B9C", 4, "\u6BA2", 7, "\u6BAB", 7, "\u6BB6\u6BB8", 6, "\u6BC0\u6BC3\u6BC4\u6BC6", 4, "\u6BCC\u6BCE\u6BD0\u6BD1\u6BD8\u6BDA\u6BDC", 4, "\u6BE2", 7, "\u6BEC\u6BED\u6BEE\u6BF0\u6BF1\u6BF2\u6BF4\u6BF6\u6BF7\u6BF8\u6BFA\u6BFB\u6BFC\u6BFE", 6, "\u6C08", 4, "\u6C0E\u6C12\u6C17\u6C1C\u6C1D\u6C1E\u6C20\u6C23\u6C25\u6C2B\u6C2C\u6C2D\u6C31\u6C33\u6C36\u6C37\u6C39\u6C3A\u6C3B\u6C3C\u6C3E\u6C3F\u6C43\u6C44\u6C45\u6C48\u6C4B", 4, "\u6C51\u6C52\u6C53\u6C56\u6C58"],
      ["9b40", "\u6C59\u6C5A\u6C62\u6C63\u6C65\u6C66\u6C67\u6C6B", 4, "\u6C71\u6C73\u6C75\u6C77\u6C78\u6C7A\u6C7B\u6C7C\u6C7F\u6C80\u6C84\u6C87\u6C8A\u6C8B\u6C8D\u6C8E\u6C91\u6C92\u6C95\u6C96\u6C97\u6C98\u6C9A\u6C9C\u6C9D\u6C9E\u6CA0\u6CA2\u6CA8\u6CAC\u6CAF\u6CB0\u6CB4\u6CB5\u6CB6\u6CB7\u6CBA\u6CC0\u6CC1\u6CC2\u6CC3\u6CC6\u6CC7\u6CC8\u6CCB\u6CCD\u6CCE\u6CCF\u6CD1\u6CD2\u6CD8"],
      ["9b80", "\u6CD9\u6CDA\u6CDC\u6CDD\u6CDF\u6CE4\u6CE6\u6CE7\u6CE9\u6CEC\u6CED\u6CF2\u6CF4\u6CF9\u6CFF\u6D00\u6D02\u6D03\u6D05\u6D06\u6D08\u6D09\u6D0A\u6D0D\u6D0F\u6D10\u6D11\u6D13\u6D14\u6D15\u6D16\u6D18\u6D1C\u6D1D\u6D1F", 5, "\u6D26\u6D28\u6D29\u6D2C\u6D2D\u6D2F\u6D30\u6D34\u6D36\u6D37\u6D38\u6D3A\u6D3F\u6D40\u6D42\u6D44\u6D49\u6D4C\u6D50\u6D55\u6D56\u6D57\u6D58\u6D5B\u6D5D\u6D5F\u6D61\u6D62\u6D64\u6D65\u6D67\u6D68\u6D6B\u6D6C\u6D6D\u6D70\u6D71\u6D72\u6D73\u6D75\u6D76\u6D79\u6D7A\u6D7B\u6D7D", 4, "\u6D83\u6D84\u6D86\u6D87\u6D8A\u6D8B\u6D8D\u6D8F\u6D90\u6D92\u6D96", 4, "\u6D9C\u6DA2\u6DA5\u6DAC\u6DAD\u6DB0\u6DB1\u6DB3\u6DB4\u6DB6\u6DB7\u6DB9", 5, "\u6DC1\u6DC2\u6DC3\u6DC8\u6DC9\u6DCA"],
      ["9c40", "\u6DCD\u6DCE\u6DCF\u6DD0\u6DD2\u6DD3\u6DD4\u6DD5\u6DD7\u6DDA\u6DDB\u6DDC\u6DDF\u6DE2\u6DE3\u6DE5\u6DE7\u6DE8\u6DE9\u6DEA\u6DED\u6DEF\u6DF0\u6DF2\u6DF4\u6DF5\u6DF6\u6DF8\u6DFA\u6DFD", 7, "\u6E06\u6E07\u6E08\u6E09\u6E0B\u6E0F\u6E12\u6E13\u6E15\u6E18\u6E19\u6E1B\u6E1C\u6E1E\u6E1F\u6E22\u6E26\u6E27\u6E28\u6E2A\u6E2C\u6E2E\u6E30\u6E31\u6E33\u6E35"],
      ["9c80", "\u6E36\u6E37\u6E39\u6E3B", 7, "\u6E45", 7, "\u6E4F\u6E50\u6E51\u6E52\u6E55\u6E57\u6E59\u6E5A\u6E5C\u6E5D\u6E5E\u6E60", 10, "\u6E6C\u6E6D\u6E6F", 14, "\u6E80\u6E81\u6E82\u6E84\u6E87\u6E88\u6E8A", 4, "\u6E91", 6, "\u6E99\u6E9A\u6E9B\u6E9D\u6E9E\u6EA0\u6EA1\u6EA3\u6EA4\u6EA6\u6EA8\u6EA9\u6EAB\u6EAC\u6EAD\u6EAE\u6EB0\u6EB3\u6EB5\u6EB8\u6EB9\u6EBC\u6EBE\u6EBF\u6EC0\u6EC3\u6EC4\u6EC5\u6EC6\u6EC8\u6EC9\u6ECA\u6ECC\u6ECD\u6ECE\u6ED0\u6ED2\u6ED6\u6ED8\u6ED9\u6EDB\u6EDC\u6EDD\u6EE3\u6EE7\u6EEA", 5],
      ["9d40", "\u6EF0\u6EF1\u6EF2\u6EF3\u6EF5\u6EF6\u6EF7\u6EF8\u6EFA", 7, "\u6F03\u6F04\u6F05\u6F07\u6F08\u6F0A", 4, "\u6F10\u6F11\u6F12\u6F16", 9, "\u6F21\u6F22\u6F23\u6F25\u6F26\u6F27\u6F28\u6F2C\u6F2E\u6F30\u6F32\u6F34\u6F35\u6F37", 6, "\u6F3F\u6F40\u6F41\u6F42"],
      ["9d80", "\u6F43\u6F44\u6F45\u6F48\u6F49\u6F4A\u6F4C\u6F4E", 9, "\u6F59\u6F5A\u6F5B\u6F5D\u6F5F\u6F60\u6F61\u6F63\u6F64\u6F65\u6F67", 5, "\u6F6F\u6F70\u6F71\u6F73\u6F75\u6F76\u6F77\u6F79\u6F7B\u6F7D", 6, "\u6F85\u6F86\u6F87\u6F8A\u6F8B\u6F8F", 12, "\u6F9D\u6F9E\u6F9F\u6FA0\u6FA2", 4, "\u6FA8", 10, "\u6FB4\u6FB5\u6FB7\u6FB8\u6FBA", 5, "\u6FC1\u6FC3", 5, "\u6FCA", 6, "\u6FD3", 10, "\u6FDF\u6FE2\u6FE3\u6FE4\u6FE5"],
      ["9e40", "\u6FE6", 7, "\u6FF0", 32, "\u7012", 7, "\u701C", 6, "\u7024", 6],
      ["9e80", "\u702B", 9, "\u7036\u7037\u7038\u703A", 17, "\u704D\u704E\u7050", 13, "\u705F", 11, "\u706E\u7071\u7072\u7073\u7074\u7077\u7079\u707A\u707B\u707D\u7081\u7082\u7083\u7084\u7086\u7087\u7088\u708B\u708C\u708D\u708F\u7090\u7091\u7093\u7097\u7098\u709A\u709B\u709E", 12, "\u70B0\u70B2\u70B4\u70B5\u70B6\u70BA\u70BE\u70BF\u70C4\u70C5\u70C6\u70C7\u70C9\u70CB", 12, "\u70DA"],
      ["9f40", "\u70DC\u70DD\u70DE\u70E0\u70E1\u70E2\u70E3\u70E5\u70EA\u70EE\u70F0", 6, "\u70F8\u70FA\u70FB\u70FC\u70FE", 10, "\u710B", 4, "\u7111\u7112\u7114\u7117\u711B", 10, "\u7127", 7, "\u7132\u7133\u7134"],
      ["9f80", "\u7135\u7137", 13, "\u7146\u7147\u7148\u7149\u714B\u714D\u714F", 12, "\u715D\u715F", 4, "\u7165\u7169", 4, "\u716F\u7170\u7171\u7174\u7175\u7176\u7177\u7179\u717B\u717C\u717E", 5, "\u7185", 4, "\u718B\u718C\u718D\u718E\u7190\u7191\u7192\u7193\u7195\u7196\u7197\u719A", 4, "\u71A1", 6, "\u71A9\u71AA\u71AB\u71AD", 5, "\u71B4\u71B6\u71B7\u71B8\u71BA", 8, "\u71C4", 9, "\u71CF", 4],
      ["a040", "\u71D6", 9, "\u71E1\u71E2\u71E3\u71E4\u71E6\u71E8", 5, "\u71EF", 9, "\u71FA", 11, "\u7207", 19],
      ["a080", "\u721B\u721C\u721E", 9, "\u7229\u722B\u722D\u722E\u722F\u7232\u7233\u7234\u723A\u723C\u723E\u7240", 6, "\u7249\u724A\u724B\u724E\u724F\u7250\u7251\u7253\u7254\u7255\u7257\u7258\u725A\u725C\u725E\u7260\u7263\u7264\u7265\u7268\u726A\u726B\u726C\u726D\u7270\u7271\u7273\u7274\u7276\u7277\u7278\u727B\u727C\u727D\u7282\u7283\u7285", 4, "\u728C\u728E\u7290\u7291\u7293", 11, "\u72A0", 11, "\u72AE\u72B1\u72B2\u72B3\u72B5\u72BA", 6, "\u72C5\u72C6\u72C7\u72C9\u72CA\u72CB\u72CC\u72CF\u72D1\u72D3\u72D4\u72D5\u72D6\u72D8\u72DA\u72DB"],
      ["a1a1", "\u3000\u3001\u3002\xB7\u02C9\u02C7\xA8\u3003\u3005\u2014\uFF5E\u2016\u2026\u2018\u2019\u201C\u201D\u3014\u3015\u3008", 7, "\u3016\u3017\u3010\u3011\xB1\xD7\xF7\u2236\u2227\u2228\u2211\u220F\u222A\u2229\u2208\u2237\u221A\u22A5\u2225\u2220\u2312\u2299\u222B\u222E\u2261\u224C\u2248\u223D\u221D\u2260\u226E\u226F\u2264\u2265\u221E\u2235\u2234\u2642\u2640\xB0\u2032\u2033\u2103\uFF04\xA4\uFFE0\uFFE1\u2030\xA7\u2116\u2606\u2605\u25CB\u25CF\u25CE\u25C7\u25C6\u25A1\u25A0\u25B3\u25B2\u203B\u2192\u2190\u2191\u2193\u3013"],
      ["a2a1", "\u2170", 9],
      ["a2b1", "\u2488", 19, "\u2474", 19, "\u2460", 9],
      ["a2e5", "\u3220", 9],
      ["a2f1", "\u2160", 11],
      ["a3a1", "\uFF01\uFF02\uFF03\uFFE5\uFF05", 88, "\uFFE3"],
      ["a4a1", "\u3041", 82],
      ["a5a1", "\u30A1", 85],
      ["a6a1", "\u0391", 16, "\u03A3", 6],
      ["a6c1", "\u03B1", 16, "\u03C3", 6],
      ["a6e0", "\uFE35\uFE36\uFE39\uFE3A\uFE3F\uFE40\uFE3D\uFE3E\uFE41\uFE42\uFE43\uFE44"],
      ["a6ee", "\uFE3B\uFE3C\uFE37\uFE38\uFE31"],
      ["a6f4", "\uFE33\uFE34"],
      ["a7a1", "\u0410", 5, "\u0401\u0416", 25],
      ["a7d1", "\u0430", 5, "\u0451\u0436", 25],
      ["a840", "\u02CA\u02CB\u02D9\u2013\u2015\u2025\u2035\u2105\u2109\u2196\u2197\u2198\u2199\u2215\u221F\u2223\u2252\u2266\u2267\u22BF\u2550", 35, "\u2581", 6],
      ["a880", "\u2588", 7, "\u2593\u2594\u2595\u25BC\u25BD\u25E2\u25E3\u25E4\u25E5\u2609\u2295\u3012\u301D\u301E"],
      ["a8a1", "\u0101\xE1\u01CE\xE0\u0113\xE9\u011B\xE8\u012B\xED\u01D0\xEC\u014D\xF3\u01D2\xF2\u016B\xFA\u01D4\xF9\u01D6\u01D8\u01DA\u01DC\xFC\xEA\u0251"],
      ["a8bd", "\u0144\u0148"],
      ["a8c0", "\u0261"],
      ["a8c5", "\u3105", 36],
      ["a940", "\u3021", 8, "\u32A3\u338E\u338F\u339C\u339D\u339E\u33A1\u33C4\u33CE\u33D1\u33D2\u33D5\uFE30\uFFE2\uFFE4"],
      ["a959", "\u2121\u3231"],
      ["a95c", "\u2010"],
      ["a960", "\u30FC\u309B\u309C\u30FD\u30FE\u3006\u309D\u309E\uFE49", 9, "\uFE54\uFE55\uFE56\uFE57\uFE59", 8],
      ["a980", "\uFE62", 4, "\uFE68\uFE69\uFE6A\uFE6B"],
      ["a996", "\u3007"],
      ["a9a4", "\u2500", 75],
      ["aa40", "\u72DC\u72DD\u72DF\u72E2", 5, "\u72EA\u72EB\u72F5\u72F6\u72F9\u72FD\u72FE\u72FF\u7300\u7302\u7304", 5, "\u730B\u730C\u730D\u730F\u7310\u7311\u7312\u7314\u7318\u7319\u731A\u731F\u7320\u7323\u7324\u7326\u7327\u7328\u732D\u732F\u7330\u7332\u7333\u7335\u7336\u733A\u733B\u733C\u733D\u7340", 8],
      ["aa80", "\u7349\u734A\u734B\u734C\u734E\u734F\u7351\u7353\u7354\u7355\u7356\u7358", 7, "\u7361", 10, "\u736E\u7370\u7371"],
      ["ab40", "\u7372", 11, "\u737F", 4, "\u7385\u7386\u7388\u738A\u738C\u738D\u738F\u7390\u7392\u7393\u7394\u7395\u7397\u7398\u7399\u739A\u739C\u739D\u739E\u73A0\u73A1\u73A3", 5, "\u73AA\u73AC\u73AD\u73B1\u73B4\u73B5\u73B6\u73B8\u73B9\u73BC\u73BD\u73BE\u73BF\u73C1\u73C3", 4],
      ["ab80", "\u73CB\u73CC\u73CE\u73D2", 6, "\u73DA\u73DB\u73DC\u73DD\u73DF\u73E1\u73E2\u73E3\u73E4\u73E6\u73E8\u73EA\u73EB\u73EC\u73EE\u73EF\u73F0\u73F1\u73F3", 4],
      ["ac40", "\u73F8", 10, "\u7404\u7407\u7408\u740B\u740C\u740D\u740E\u7411", 8, "\u741C", 5, "\u7423\u7424\u7427\u7429\u742B\u742D\u742F\u7431\u7432\u7437", 4, "\u743D\u743E\u743F\u7440\u7442", 11],
      ["ac80", "\u744E", 6, "\u7456\u7458\u745D\u7460", 12, "\u746E\u746F\u7471", 4, "\u7478\u7479\u747A"],
      ["ad40", "\u747B\u747C\u747D\u747F\u7482\u7484\u7485\u7486\u7488\u7489\u748A\u748C\u748D\u748F\u7491", 10, "\u749D\u749F", 7, "\u74AA", 15, "\u74BB", 12],
      ["ad80", "\u74C8", 9, "\u74D3", 8, "\u74DD\u74DF\u74E1\u74E5\u74E7", 6, "\u74F0\u74F1\u74F2"],
      ["ae40", "\u74F3\u74F5\u74F8", 6, "\u7500\u7501\u7502\u7503\u7505", 7, "\u750E\u7510\u7512\u7514\u7515\u7516\u7517\u751B\u751D\u751E\u7520", 4, "\u7526\u7527\u752A\u752E\u7534\u7536\u7539\u753C\u753D\u753F\u7541\u7542\u7543\u7544\u7546\u7547\u7549\u754A\u754D\u7550\u7551\u7552\u7553\u7555\u7556\u7557\u7558"],
      ["ae80", "\u755D", 7, "\u7567\u7568\u7569\u756B", 6, "\u7573\u7575\u7576\u7577\u757A", 4, "\u7580\u7581\u7582\u7584\u7585\u7587"],
      ["af40", "\u7588\u7589\u758A\u758C\u758D\u758E\u7590\u7593\u7595\u7598\u759B\u759C\u759E\u75A2\u75A6", 4, "\u75AD\u75B6\u75B7\u75BA\u75BB\u75BF\u75C0\u75C1\u75C6\u75CB\u75CC\u75CE\u75CF\u75D0\u75D1\u75D3\u75D7\u75D9\u75DA\u75DC\u75DD\u75DF\u75E0\u75E1\u75E5\u75E9\u75EC\u75ED\u75EE\u75EF\u75F2\u75F3\u75F5\u75F6\u75F7\u75F8\u75FA\u75FB\u75FD\u75FE\u7602\u7604\u7606\u7607"],
      ["af80", "\u7608\u7609\u760B\u760D\u760E\u760F\u7611\u7612\u7613\u7614\u7616\u761A\u761C\u761D\u761E\u7621\u7623\u7627\u7628\u762C\u762E\u762F\u7631\u7632\u7636\u7637\u7639\u763A\u763B\u763D\u7641\u7642\u7644"],
      ["b040", "\u7645", 6, "\u764E", 5, "\u7655\u7657", 4, "\u765D\u765F\u7660\u7661\u7662\u7664", 6, "\u766C\u766D\u766E\u7670", 7, "\u7679\u767A\u767C\u767F\u7680\u7681\u7683\u7685\u7689\u768A\u768C\u768D\u768F\u7690\u7692\u7694\u7695\u7697\u7698\u769A\u769B"],
      ["b080", "\u769C", 7, "\u76A5", 8, "\u76AF\u76B0\u76B3\u76B5", 9, "\u76C0\u76C1\u76C3\u554A\u963F\u57C3\u6328\u54CE\u5509\u54C0\u7691\u764C\u853C\u77EE\u827E\u788D\u7231\u9698\u978D\u6C28\u5B89\u4FFA\u6309\u6697\u5CB8\u80FA\u6848\u80AE\u6602\u76CE\u51F9\u6556\u71AC\u7FF1\u8884\u50B2\u5965\u61CA\u6FB3\u82AD\u634C\u6252\u53ED\u5427\u7B06\u516B\u75A4\u5DF4\u62D4\u8DCB\u9776\u628A\u8019\u575D\u9738\u7F62\u7238\u767D\u67CF\u767E\u6446\u4F70\u8D25\u62DC\u7A17\u6591\u73ED\u642C\u6273\u822C\u9881\u677F\u7248\u626E\u62CC\u4F34\u74E3\u534A\u529E\u7ECA\u90A6\u5E2E\u6886\u699C\u8180\u7ED1\u68D2\u78C5\u868C\u9551\u508D\u8C24\u82DE\u80DE\u5305\u8912\u5265"],
      ["b140", "\u76C4\u76C7\u76C9\u76CB\u76CC\u76D3\u76D5\u76D9\u76DA\u76DC\u76DD\u76DE\u76E0", 4, "\u76E6", 7, "\u76F0\u76F3\u76F5\u76F6\u76F7\u76FA\u76FB\u76FD\u76FF\u7700\u7702\u7703\u7705\u7706\u770A\u770C\u770E", 10, "\u771B\u771C\u771D\u771E\u7721\u7723\u7724\u7725\u7727\u772A\u772B"],
      ["b180", "\u772C\u772E\u7730", 4, "\u7739\u773B\u773D\u773E\u773F\u7742\u7744\u7745\u7746\u7748", 7, "\u7752", 7, "\u775C\u8584\u96F9\u4FDD\u5821\u9971\u5B9D\u62B1\u62A5\u66B4\u8C79\u9C8D\u7206\u676F\u7891\u60B2\u5351\u5317\u8F88\u80CC\u8D1D\u94A1\u500D\u72C8\u5907\u60EB\u7119\u88AB\u5954\u82EF\u672C\u7B28\u5D29\u7EF7\u752D\u6CF5\u8E66\u8FF8\u903C\u9F3B\u6BD4\u9119\u7B14\u5F7C\u78A7\u84D6\u853D\u6BD5\u6BD9\u6BD6\u5E01\u5E87\u75F9\u95ED\u655D\u5F0A\u5FC5\u8F9F\u58C1\u81C2\u907F\u965B\u97AD\u8FB9\u7F16\u8D2C\u6241\u4FBF\u53D8\u535E\u8FA8\u8FA9\u8FAB\u904D\u6807\u5F6A\u8198\u8868\u9CD6\u618B\u522B\u762A\u5F6C\u658C\u6FD2\u6EE8\u5BBE\u6448\u5175\u51B0\u67C4\u4E19\u79C9\u997C\u70B3"],
      ["b240", "\u775D\u775E\u775F\u7760\u7764\u7767\u7769\u776A\u776D", 11, "\u777A\u777B\u777C\u7781\u7782\u7783\u7786", 5, "\u778F\u7790\u7793", 11, "\u77A1\u77A3\u77A4\u77A6\u77A8\u77AB\u77AD\u77AE\u77AF\u77B1\u77B2\u77B4\u77B6", 4],
      ["b280", "\u77BC\u77BE\u77C0", 12, "\u77CE", 8, "\u77D8\u77D9\u77DA\u77DD", 4, "\u77E4\u75C5\u5E76\u73BB\u83E0\u64AD\u62E8\u94B5\u6CE2\u535A\u52C3\u640F\u94C2\u7B94\u4F2F\u5E1B\u8236\u8116\u818A\u6E24\u6CCA\u9A73\u6355\u535C\u54FA\u8865\u57E0\u4E0D\u5E03\u6B65\u7C3F\u90E8\u6016\u64E6\u731C\u88C1\u6750\u624D\u8D22\u776C\u8E29\u91C7\u5F69\u83DC\u8521\u9910\u53C2\u8695\u6B8B\u60ED\u60E8\u707F\u82CD\u8231\u4ED3\u6CA7\u85CF\u64CD\u7CD9\u69FD\u66F9\u8349\u5395\u7B56\u4FA7\u518C\u6D4B\u5C42\u8E6D\u63D2\u53C9\u832C\u8336\u67E5\u78B4\u643D\u5BDF\u5C94\u5DEE\u8BE7\u62C6\u67F4\u8C7A\u6400\u63BA\u8749\u998B\u8C17\u7F20\u94F2\u4EA7\u9610\u98A4\u660C\u7316"],
      ["b340", "\u77E6\u77E8\u77EA\u77EF\u77F0\u77F1\u77F2\u77F4\u77F5\u77F7\u77F9\u77FA\u77FB\u77FC\u7803", 5, "\u780A\u780B\u780E\u780F\u7810\u7813\u7815\u7819\u781B\u781E\u7820\u7821\u7822\u7824\u7828\u782A\u782B\u782E\u782F\u7831\u7832\u7833\u7835\u7836\u783D\u783F\u7841\u7842\u7843\u7844\u7846\u7848\u7849\u784A\u784B\u784D\u784F\u7851\u7853\u7854\u7858\u7859\u785A"],
      ["b380", "\u785B\u785C\u785E", 11, "\u786F", 7, "\u7878\u7879\u787A\u787B\u787D", 6, "\u573A\u5C1D\u5E38\u957F\u507F\u80A0\u5382\u655E\u7545\u5531\u5021\u8D85\u6284\u949E\u671D\u5632\u6F6E\u5DE2\u5435\u7092\u8F66\u626F\u64A4\u63A3\u5F7B\u6F88\u90F4\u81E3\u8FB0\u5C18\u6668\u5FF1\u6C89\u9648\u8D81\u886C\u6491\u79F0\u57CE\u6A59\u6210\u5448\u4E58\u7A0B\u60E9\u6F84\u8BDA\u627F\u901E\u9A8B\u79E4\u5403\u75F4\u6301\u5319\u6C60\u8FDF\u5F1B\u9A70\u803B\u9F7F\u4F88\u5C3A\u8D64\u7FC5\u65A5\u70BD\u5145\u51B2\u866B\u5D07\u5BA0\u62BD\u916C\u7574\u8E0C\u7A20\u6101\u7B79\u4EC7\u7EF8\u7785\u4E11\u81ED\u521D\u51FA\u6A71\u53A8\u8E87\u9504\u96CF\u6EC1\u9664\u695A"],
      ["b440", "\u7884\u7885\u7886\u7888\u788A\u788B\u788F\u7890\u7892\u7894\u7895\u7896\u7899\u789D\u789E\u78A0\u78A2\u78A4\u78A6\u78A8", 7, "\u78B5\u78B6\u78B7\u78B8\u78BA\u78BB\u78BC\u78BD\u78BF\u78C0\u78C2\u78C3\u78C4\u78C6\u78C7\u78C8\u78CC\u78CD\u78CE\u78CF\u78D1\u78D2\u78D3\u78D6\u78D7\u78D8\u78DA", 9],
      ["b480", "\u78E4\u78E5\u78E6\u78E7\u78E9\u78EA\u78EB\u78ED", 4, "\u78F3\u78F5\u78F6\u78F8\u78F9\u78FB", 5, "\u7902\u7903\u7904\u7906", 6, "\u7840\u50A8\u77D7\u6410\u89E6\u5904\u63E3\u5DDD\u7A7F\u693D\u4F20\u8239\u5598\u4E32\u75AE\u7A97\u5E62\u5E8A\u95EF\u521B\u5439\u708A\u6376\u9524\u5782\u6625\u693F\u9187\u5507\u6DF3\u7EAF\u8822\u6233\u7EF0\u75B5\u8328\u78C1\u96CC\u8F9E\u6148\u74F7\u8BCD\u6B64\u523A\u8D50\u6B21\u806A\u8471\u56F1\u5306\u4ECE\u4E1B\u51D1\u7C97\u918B\u7C07\u4FC3\u8E7F\u7BE1\u7A9C\u6467\u5D14\u50AC\u8106\u7601\u7CB9\u6DEC\u7FE0\u6751\u5B58\u5BF8\u78CB\u64AE\u6413\u63AA\u632B\u9519\u642D\u8FBE\u7B54\u7629\u6253\u5927\u5446\u6B79\u50A3\u6234\u5E26\u6B86\u4EE3\u8D37\u888B\u5F85\u902E"],
      ["b540", "\u790D", 5, "\u7914", 9, "\u791F", 4, "\u7925", 14, "\u7935", 4, "\u793D\u793F\u7942\u7943\u7944\u7945\u7947\u794A", 8, "\u7954\u7955\u7958\u7959\u7961\u7963"],
      ["b580", "\u7964\u7966\u7969\u796A\u796B\u796C\u796E\u7970", 6, "\u7979\u797B", 4, "\u7982\u7983\u7986\u7987\u7988\u7989\u798B\u798C\u798D\u798E\u7990\u7991\u7992\u6020\u803D\u62C5\u4E39\u5355\u90F8\u63B8\u80C6\u65E6\u6C2E\u4F46\u60EE\u6DE1\u8BDE\u5F39\u86CB\u5F53\u6321\u515A\u8361\u6863\u5200\u6363\u8E48\u5012\u5C9B\u7977\u5BFC\u5230\u7A3B\u60BC\u9053\u76D7\u5FB7\u5F97\u7684\u8E6C\u706F\u767B\u7B49\u77AA\u51F3\u9093\u5824\u4F4E\u6EF4\u8FEA\u654C\u7B1B\u72C4\u6DA4\u7FDF\u5AE1\u62B5\u5E95\u5730\u8482\u7B2C\u5E1D\u5F1F\u9012\u7F14\u98A0\u6382\u6EC7\u7898\u70B9\u5178\u975B\u57AB\u7535\u4F43\u7538\u5E97\u60E6\u5960\u6DC0\u6BBF\u7889\u53FC\u96D5\u51CB\u5201\u6389\u540A\u9493\u8C03\u8DCC\u7239\u789F\u8776\u8FED\u8C0D\u53E0"],
      ["b640", "\u7993", 6, "\u799B", 11, "\u79A8", 10, "\u79B4", 4, "\u79BC\u79BF\u79C2\u79C4\u79C5\u79C7\u79C8\u79CA\u79CC\u79CE\u79CF\u79D0\u79D3\u79D4\u79D6\u79D7\u79D9", 5, "\u79E0\u79E1\u79E2\u79E5\u79E8\u79EA"],
      ["b680", "\u79EC\u79EE\u79F1", 6, "\u79F9\u79FA\u79FC\u79FE\u79FF\u7A01\u7A04\u7A05\u7A07\u7A08\u7A09\u7A0A\u7A0C\u7A0F", 4, "\u7A15\u7A16\u7A18\u7A19\u7A1B\u7A1C\u4E01\u76EF\u53EE\u9489\u9876\u9F0E\u952D\u5B9A\u8BA2\u4E22\u4E1C\u51AC\u8463\u61C2\u52A8\u680B\u4F97\u606B\u51BB\u6D1E\u515C\u6296\u6597\u9661\u8C46\u9017\u75D8\u90FD\u7763\u6BD2\u728A\u72EC\u8BFB\u5835\u7779\u8D4C\u675C\u9540\u809A\u5EA6\u6E21\u5992\u7AEF\u77ED\u953B\u6BB5\u65AD\u7F0E\u5806\u5151\u961F\u5BF9\u58A9\u5428\u8E72\u6566\u987F\u56E4\u949D\u76FE\u9041\u6387\u54C6\u591A\u593A\u579B\u8EB2\u6735\u8DFA\u8235\u5241\u60F0\u5815\u86FE\u5CE8\u9E45\u4FC4\u989D\u8BB9\u5A25\u6076\u5384\u627C\u904F\u9102\u997F\u6069\u800C\u513F\u8033\u5C14\u9975\u6D31\u4E8C"],
      ["b740", "\u7A1D\u7A1F\u7A21\u7A22\u7A24", 14, "\u7A34\u7A35\u7A36\u7A38\u7A3A\u7A3E\u7A40", 5, "\u7A47", 9, "\u7A52", 4, "\u7A58", 16],
      ["b780", "\u7A69", 6, "\u7A71\u7A72\u7A73\u7A75\u7A7B\u7A7C\u7A7D\u7A7E\u7A82\u7A85\u7A87\u7A89\u7A8A\u7A8B\u7A8C\u7A8E\u7A8F\u7A90\u7A93\u7A94\u7A99\u7A9A\u7A9B\u7A9E\u7AA1\u7AA2\u8D30\u53D1\u7F5A\u7B4F\u4F10\u4E4F\u9600\u6CD5\u73D0\u85E9\u5E06\u756A\u7FFB\u6A0A\u77FE\u9492\u7E41\u51E1\u70E6\u53CD\u8FD4\u8303\u8D29\u72AF\u996D\u6CDB\u574A\u82B3\u65B9\u80AA\u623F\u9632\u59A8\u4EFF\u8BBF\u7EBA\u653E\u83F2\u975E\u5561\u98DE\u80A5\u532A\u8BFD\u5420\u80BA\u5E9F\u6CB8\u8D39\u82AC\u915A\u5429\u6C1B\u5206\u7EB7\u575F\u711A\u6C7E\u7C89\u594B\u4EFD\u5FFF\u6124\u7CAA\u4E30\u5C01\u67AB\u8702\u5CF0\u950B\u98CE\u75AF\u70FD\u9022\u51AF\u7F1D\u8BBD\u5949\u51E4\u4F5B\u5426\u592B\u6577\u80A4\u5B75\u6276\u62C2\u8F90\u5E45\u6C1F\u7B26\u4F0F\u4FD8\u670D"],
      ["b840", "\u7AA3\u7AA4\u7AA7\u7AA9\u7AAA\u7AAB\u7AAE", 4, "\u7AB4", 10, "\u7AC0", 10, "\u7ACC", 9, "\u7AD7\u7AD8\u7ADA\u7ADB\u7ADC\u7ADD\u7AE1\u7AE2\u7AE4\u7AE7", 5, "\u7AEE\u7AF0\u7AF1\u7AF2\u7AF3"],
      ["b880", "\u7AF4", 4, "\u7AFB\u7AFC\u7AFE\u7B00\u7B01\u7B02\u7B05\u7B07\u7B09\u7B0C\u7B0D\u7B0E\u7B10\u7B12\u7B13\u7B16\u7B17\u7B18\u7B1A\u7B1C\u7B1D\u7B1F\u7B21\u7B22\u7B23\u7B27\u7B29\u7B2D\u6D6E\u6DAA\u798F\u88B1\u5F17\u752B\u629A\u8F85\u4FEF\u91DC\u65A7\u812F\u8151\u5E9C\u8150\u8D74\u526F\u8986\u8D4B\u590D\u5085\u4ED8\u961C\u7236\u8179\u8D1F\u5BCC\u8BA3\u9644\u5987\u7F1A\u5490\u5676\u560E\u8BE5\u6539\u6982\u9499\u76D6\u6E89\u5E72\u7518\u6746\u67D1\u7AFF\u809D\u8D76\u611F\u79C6\u6562\u8D63\u5188\u521A\u94A2\u7F38\u809B\u7EB2\u5C97\u6E2F\u6760\u7BD9\u768B\u9AD8\u818F\u7F94\u7CD5\u641E\u9550\u7A3F\u544A\u54E5\u6B4C\u6401\u6208\u9E3D\u80F3\u7599\u5272\u9769\u845B\u683C\u86E4\u9601\u9694\u94EC\u4E2A\u5404\u7ED9\u6839\u8DDF\u8015\u66F4\u5E9A\u7FB9"],
      ["b940", "\u7B2F\u7B30\u7B32\u7B34\u7B35\u7B36\u7B37\u7B39\u7B3B\u7B3D\u7B3F", 5, "\u7B46\u7B48\u7B4A\u7B4D\u7B4E\u7B53\u7B55\u7B57\u7B59\u7B5C\u7B5E\u7B5F\u7B61\u7B63", 10, "\u7B6F\u7B70\u7B73\u7B74\u7B76\u7B78\u7B7A\u7B7C\u7B7D\u7B7F\u7B81\u7B82\u7B83\u7B84\u7B86", 6, "\u7B8E\u7B8F"],
      ["b980", "\u7B91\u7B92\u7B93\u7B96\u7B98\u7B99\u7B9A\u7B9B\u7B9E\u7B9F\u7BA0\u7BA3\u7BA4\u7BA5\u7BAE\u7BAF\u7BB0\u7BB2\u7BB3\u7BB5\u7BB6\u7BB7\u7BB9", 7, "\u7BC2\u7BC3\u7BC4\u57C2\u803F\u6897\u5DE5\u653B\u529F\u606D\u9F9A\u4F9B\u8EAC\u516C\u5BAB\u5F13\u5DE9\u6C5E\u62F1\u8D21\u5171\u94A9\u52FE\u6C9F\u82DF\u72D7\u57A2\u6784\u8D2D\u591F\u8F9C\u83C7\u5495\u7B8D\u4F30\u6CBD\u5B64\u59D1\u9F13\u53E4\u86CA\u9AA8\u8C37\u80A1\u6545\u987E\u56FA\u96C7\u522E\u74DC\u5250\u5BE1\u6302\u8902\u4E56\u62D0\u602A\u68FA\u5173\u5B98\u51A0\u89C2\u7BA1\u9986\u7F50\u60EF\u704C\u8D2F\u5149\u5E7F\u901B\u7470\u89C4\u572D\u7845\u5F52\u9F9F\u95FA\u8F68\u9B3C\u8BE1\u7678\u6842\u67DC\u8DEA\u8D35\u523D\u8F8A\u6EDA\u68CD\u9505\u90ED\u56FD\u679C\u88F9\u8FC7\u54C8"],
      ["ba40", "\u7BC5\u7BC8\u7BC9\u7BCA\u7BCB\u7BCD\u7BCE\u7BCF\u7BD0\u7BD2\u7BD4", 4, "\u7BDB\u7BDC\u7BDE\u7BDF\u7BE0\u7BE2\u7BE3\u7BE4\u7BE7\u7BE8\u7BE9\u7BEB\u7BEC\u7BED\u7BEF\u7BF0\u7BF2", 4, "\u7BF8\u7BF9\u7BFA\u7BFB\u7BFD\u7BFF", 7, "\u7C08\u7C09\u7C0A\u7C0D\u7C0E\u7C10", 5, "\u7C17\u7C18\u7C19"],
      ["ba80", "\u7C1A", 4, "\u7C20", 5, "\u7C28\u7C29\u7C2B", 12, "\u7C39", 5, "\u7C42\u9AB8\u5B69\u6D77\u6C26\u4EA5\u5BB3\u9A87\u9163\u61A8\u90AF\u97E9\u542B\u6DB5\u5BD2\u51FD\u558A\u7F55\u7FF0\u64BC\u634D\u65F1\u61BE\u608D\u710A\u6C57\u6C49\u592F\u676D\u822A\u58D5\u568E\u8C6A\u6BEB\u90DD\u597D\u8017\u53F7\u6D69\u5475\u559D\u8377\u83CF\u6838\u79BE\u548C\u4F55\u5408\u76D2\u8C89\u9602\u6CB3\u6DB8\u8D6B\u8910\u9E64\u8D3A\u563F\u9ED1\u75D5\u5F88\u72E0\u6068\u54FC\u4EA8\u6A2A\u8861\u6052\u8F70\u54C4\u70D8\u8679\u9E3F\u6D2A\u5B8F\u5F18\u7EA2\u5589\u4FAF\u7334\u543C\u539A\u5019\u540E\u547C\u4E4E\u5FFD\u745A\u58F6\u846B\u80E1\u8774\u72D0\u7CCA\u6E56"],
      ["bb40", "\u7C43", 9, "\u7C4E", 36, "\u7C75", 5, "\u7C7E", 9],
      ["bb80", "\u7C88\u7C8A", 6, "\u7C93\u7C94\u7C96\u7C99\u7C9A\u7C9B\u7CA0\u7CA1\u7CA3\u7CA6\u7CA7\u7CA8\u7CA9\u7CAB\u7CAC\u7CAD\u7CAF\u7CB0\u7CB4", 4, "\u7CBA\u7CBB\u5F27\u864E\u552C\u62A4\u4E92\u6CAA\u6237\u82B1\u54D7\u534E\u733E\u6ED1\u753B\u5212\u5316\u8BDD\u69D0\u5F8A\u6000\u6DEE\u574F\u6B22\u73AF\u6853\u8FD8\u7F13\u6362\u60A3\u5524\u75EA\u8C62\u7115\u6DA3\u5BA6\u5E7B\u8352\u614C\u9EC4\u78FA\u8757\u7C27\u7687\u51F0\u60F6\u714C\u6643\u5E4C\u604D\u8C0E\u7070\u6325\u8F89\u5FBD\u6062\u86D4\u56DE\u6BC1\u6094\u6167\u5349\u60E0\u6666\u8D3F\u79FD\u4F1A\u70E9\u6C47\u8BB3\u8BF2\u7ED8\u8364\u660F\u5A5A\u9B42\u6D51\u6DF7\u8C41\u6D3B\u4F19\u706B\u83B7\u6216\u60D1\u970D\u8D27\u7978\u51FB\u573E\u57FA\u673A\u7578\u7A3D\u79EF\u7B95"],
      ["bc40", "\u7CBF\u7CC0\u7CC2\u7CC3\u7CC4\u7CC6\u7CC9\u7CCB\u7CCE", 6, "\u7CD8\u7CDA\u7CDB\u7CDD\u7CDE\u7CE1", 6, "\u7CE9", 5, "\u7CF0", 7, "\u7CF9\u7CFA\u7CFC", 13, "\u7D0B", 5],
      ["bc80", "\u7D11", 14, "\u7D21\u7D23\u7D24\u7D25\u7D26\u7D28\u7D29\u7D2A\u7D2C\u7D2D\u7D2E\u7D30", 6, "\u808C\u9965\u8FF9\u6FC0\u8BA5\u9E21\u59EC\u7EE9\u7F09\u5409\u6781\u68D8\u8F91\u7C4D\u96C6\u53CA\u6025\u75BE\u6C72\u5373\u5AC9\u7EA7\u6324\u51E0\u810A\u5DF1\u84DF\u6280\u5180\u5B63\u4F0E\u796D\u5242\u60B8\u6D4E\u5BC4\u5BC2\u8BA1\u8BB0\u65E2\u5FCC\u9645\u5993\u7EE7\u7EAA\u5609\u67B7\u5939\u4F73\u5BB6\u52A0\u835A\u988A\u8D3E\u7532\u94BE\u5047\u7A3C\u4EF7\u67B6\u9A7E\u5AC1\u6B7C\u76D1\u575A\u5C16\u7B3A\u95F4\u714E\u517C\u80A9\u8270\u5978\u7F04\u8327\u68C0\u67EC\u78B1\u7877\u62E3\u6361\u7B80\u4FED\u526A\u51CF\u8350\u69DB\u9274\u8DF5\u8D31\u89C1\u952E\u7BAD\u4EF6"],
      ["bd40", "\u7D37", 54, "\u7D6F", 7],
      ["bd80", "\u7D78", 32, "\u5065\u8230\u5251\u996F\u6E10\u6E85\u6DA7\u5EFA\u50F5\u59DC\u5C06\u6D46\u6C5F\u7586\u848B\u6868\u5956\u8BB2\u5320\u9171\u964D\u8549\u6912\u7901\u7126\u80F6\u4EA4\u90CA\u6D47\u9A84\u5A07\u56BC\u6405\u94F0\u77EB\u4FA5\u811A\u72E1\u89D2\u997A\u7F34\u7EDE\u527F\u6559\u9175\u8F7F\u8F83\u53EB\u7A96\u63ED\u63A5\u7686\u79F8\u8857\u9636\u622A\u52AB\u8282\u6854\u6770\u6377\u776B\u7AED\u6D01\u7ED3\u89E3\u59D0\u6212\u85C9\u82A5\u754C\u501F\u4ECB\u75A5\u8BEB\u5C4A\u5DFE\u7B4B\u65A4\u91D1\u4ECA\u6D25\u895F\u7D27\u9526\u4EC5\u8C28\u8FDB\u9773\u664B\u7981\u8FD1\u70EC\u6D78"],
      ["be40", "\u7D99", 12, "\u7DA7", 6, "\u7DAF", 42],
      ["be80", "\u7DDA", 32, "\u5C3D\u52B2\u8346\u5162\u830E\u775B\u6676\u9CB8\u4EAC\u60CA\u7CBE\u7CB3\u7ECF\u4E95\u8B66\u666F\u9888\u9759\u5883\u656C\u955C\u5F84\u75C9\u9756\u7ADF\u7ADE\u51C0\u70AF\u7A98\u63EA\u7A76\u7EA0\u7396\u97ED\u4E45\u7078\u4E5D\u9152\u53A9\u6551\u65E7\u81FC\u8205\u548E\u5C31\u759A\u97A0\u62D8\u72D9\u75BD\u5C45\u9A79\u83CA\u5C40\u5480\u77E9\u4E3E\u6CAE\u805A\u62D2\u636E\u5DE8\u5177\u8DDD\u8E1E\u952F\u4FF1\u53E5\u60E7\u70AC\u5267\u6350\u9E43\u5A1F\u5026\u7737\u5377\u7EE2\u6485\u652B\u6289\u6398\u5014\u7235\u89C9\u51B3\u8BC0\u7EDD\u5747\u83CC\u94A7\u519B\u541B\u5CFB"],
      ["bf40", "\u7DFB", 62],
      ["bf80", "\u7E3A\u7E3C", 4, "\u7E42", 4, "\u7E48", 21, "\u4FCA\u7AE3\u6D5A\u90E1\u9A8F\u5580\u5496\u5361\u54AF\u5F00\u63E9\u6977\u51EF\u6168\u520A\u582A\u52D8\u574E\u780D\u770B\u5EB7\u6177\u7CE0\u625B\u6297\u4EA2\u7095\u8003\u62F7\u70E4\u9760\u5777\u82DB\u67EF\u68F5\u78D5\u9897\u79D1\u58F3\u54B3\u53EF\u6E34\u514B\u523B\u5BA2\u8BFE\u80AF\u5543\u57A6\u6073\u5751\u542D\u7A7A\u6050\u5B54\u63A7\u62A0\u53E3\u6263\u5BC7\u67AF\u54ED\u7A9F\u82E6\u9177\u5E93\u88E4\u5938\u57AE\u630E\u8DE8\u80EF\u5757\u7B77\u4FA9\u5FEB\u5BBD\u6B3E\u5321\u7B50\u72C2\u6846\u77FF\u7736\u65F7\u51B5\u4E8F\u76D4\u5CBF\u7AA5\u8475\u594E\u9B41\u5080"],
      ["c040", "\u7E5E", 35, "\u7E83", 23, "\u7E9C\u7E9D\u7E9E"],
      ["c080", "\u7EAE\u7EB4\u7EBB\u7EBC\u7ED6\u7EE4\u7EEC\u7EF9\u7F0A\u7F10\u7F1E\u7F37\u7F39\u7F3B", 6, "\u7F43\u7F46", 9, "\u7F52\u7F53\u9988\u6127\u6E83\u5764\u6606\u6346\u56F0\u62EC\u6269\u5ED3\u9614\u5783\u62C9\u5587\u8721\u814A\u8FA3\u5566\u83B1\u6765\u8D56\u84DD\u5A6A\u680F\u62E6\u7BEE\u9611\u5170\u6F9C\u8C30\u63FD\u89C8\u61D2\u7F06\u70C2\u6EE5\u7405\u6994\u72FC\u5ECA\u90CE\u6717\u6D6A\u635E\u52B3\u7262\u8001\u4F6C\u59E5\u916A\u70D9\u6D9D\u52D2\u4E50\u96F7\u956D\u857E\u78CA\u7D2F\u5121\u5792\u64C2\u808B\u7C7B\u6CEA\u68F1\u695E\u51B7\u5398\u68A8\u7281\u9ECE\u7BF1\u72F8\u79BB\u6F13\u7406\u674E\u91CC\u9CA4\u793C\u8389\u8354\u540F\u6817\u4E3D\u5389\u52B1\u783E\u5386\u5229\u5088\u4F8B\u4FD0"],
      ["c140", "\u7F56\u7F59\u7F5B\u7F5C\u7F5D\u7F5E\u7F60\u7F63", 4, "\u7F6B\u7F6C\u7F6D\u7F6F\u7F70\u7F73\u7F75\u7F76\u7F77\u7F78\u7F7A\u7F7B\u7F7C\u7F7D\u7F7F\u7F80\u7F82", 7, "\u7F8B\u7F8D\u7F8F", 4, "\u7F95", 4, "\u7F9B\u7F9C\u7FA0\u7FA2\u7FA3\u7FA5\u7FA6\u7FA8", 6, "\u7FB1"],
      ["c180", "\u7FB3", 4, "\u7FBA\u7FBB\u7FBE\u7FC0\u7FC2\u7FC3\u7FC4\u7FC6\u7FC7\u7FC8\u7FC9\u7FCB\u7FCD\u7FCF", 4, "\u7FD6\u7FD7\u7FD9", 5, "\u7FE2\u7FE3\u75E2\u7ACB\u7C92\u6CA5\u96B6\u529B\u7483\u54E9\u4FE9\u8054\u83B2\u8FDE\u9570\u5EC9\u601C\u6D9F\u5E18\u655B\u8138\u94FE\u604B\u70BC\u7EC3\u7CAE\u51C9\u6881\u7CB1\u826F\u4E24\u8F86\u91CF\u667E\u4EAE\u8C05\u64A9\u804A\u50DA\u7597\u71CE\u5BE5\u8FBD\u6F66\u4E86\u6482\u9563\u5ED6\u6599\u5217\u88C2\u70C8\u52A3\u730E\u7433\u6797\u78F7\u9716\u4E34\u90BB\u9CDE\u6DCB\u51DB\u8D41\u541D\u62CE\u73B2\u83F1\u96F6\u9F84\u94C3\u4F36\u7F9A\u51CC\u7075\u9675\u5CAD\u9886\u53E6\u4EE4\u6E9C\u7409\u69B4\u786B\u998F\u7559\u5218\u7624\u6D41\u67F3\u516D\u9F99\u804B\u5499\u7B3C\u7ABF"],
      ["c240", "\u7FE4\u7FE7\u7FE8\u7FEA\u7FEB\u7FEC\u7FED\u7FEF\u7FF2\u7FF4", 6, "\u7FFD\u7FFE\u7FFF\u8002\u8007\u8008\u8009\u800A\u800E\u800F\u8011\u8013\u801A\u801B\u801D\u801E\u801F\u8021\u8023\u8024\u802B", 5, "\u8032\u8034\u8039\u803A\u803C\u803E\u8040\u8041\u8044\u8045\u8047\u8048\u8049\u804E\u804F\u8050\u8051\u8053\u8055\u8056\u8057"],
      ["c280", "\u8059\u805B", 13, "\u806B", 5, "\u8072", 11, "\u9686\u5784\u62E2\u9647\u697C\u5A04\u6402\u7BD3\u6F0F\u964B\u82A6\u5362\u9885\u5E90\u7089\u63B3\u5364\u864F\u9C81\u9E93\u788C\u9732\u8DEF\u8D42\u9E7F\u6F5E\u7984\u5F55\u9646\u622E\u9A74\u5415\u94DD\u4FA3\u65C5\u5C65\u5C61\u7F15\u8651\u6C2F\u5F8B\u7387\u6EE4\u7EFF\u5CE6\u631B\u5B6A\u6EE6\u5375\u4E71\u63A0\u7565\u62A1\u8F6E\u4F26\u4ED1\u6CA6\u7EB6\u8BBA\u841D\u87BA\u7F57\u903B\u9523\u7BA9\u9AA1\u88F8\u843D\u6D1B\u9A86\u7EDC\u5988\u9EBB\u739B\u7801\u8682\u9A6C\u9A82\u561B\u5417\u57CB\u4E70\u9EA6\u5356\u8FC8\u8109\u7792\u9992\u86EE\u6EE1\u8513\u66FC\u6162\u6F2B"],
      ["c340", "\u807E\u8081\u8082\u8085\u8088\u808A\u808D", 5, "\u8094\u8095\u8097\u8099\u809E\u80A3\u80A6\u80A7\u80A8\u80AC\u80B0\u80B3\u80B5\u80B6\u80B8\u80B9\u80BB\u80C5\u80C7", 4, "\u80CF", 6, "\u80D8\u80DF\u80E0\u80E2\u80E3\u80E6\u80EE\u80F5\u80F7\u80F9\u80FB\u80FE\u80FF\u8100\u8101\u8103\u8104\u8105\u8107\u8108\u810B"],
      ["c380", "\u810C\u8115\u8117\u8119\u811B\u811C\u811D\u811F", 12, "\u812D\u812E\u8130\u8133\u8134\u8135\u8137\u8139", 4, "\u813F\u8C29\u8292\u832B\u76F2\u6C13\u5FD9\u83BD\u732B\u8305\u951A\u6BDB\u77DB\u94C6\u536F\u8302\u5192\u5E3D\u8C8C\u8D38\u4E48\u73AB\u679A\u6885\u9176\u9709\u7164\u6CA1\u7709\u5A92\u9541\u6BCF\u7F8E\u6627\u5BD0\u59B9\u5A9A\u95E8\u95F7\u4EEC\u840C\u8499\u6AAC\u76DF\u9530\u731B\u68A6\u5B5F\u772F\u919A\u9761\u7CDC\u8FF7\u8C1C\u5F25\u7C73\u79D8\u89C5\u6CCC\u871C\u5BC6\u5E42\u68C9\u7720\u7EF5\u5195\u514D\u52C9\u5A29\u7F05\u9762\u82D7\u63CF\u7784\u85D0\u79D2\u6E3A\u5E99\u5999\u8511\u706D\u6C11\u62BF\u76BF\u654F\u60AF\u95FD\u660E\u879F\u9E23\u94ED\u540D\u547D\u8C2C\u6478"],
      ["c440", "\u8140", 5, "\u8147\u8149\u814D\u814E\u814F\u8152\u8156\u8157\u8158\u815B", 4, "\u8161\u8162\u8163\u8164\u8166\u8168\u816A\u816B\u816C\u816F\u8172\u8173\u8175\u8176\u8177\u8178\u8181\u8183", 4, "\u8189\u818B\u818C\u818D\u818E\u8190\u8192", 5, "\u8199\u819A\u819E", 4, "\u81A4\u81A5"],
      ["c480", "\u81A7\u81A9\u81AB", 7, "\u81B4", 5, "\u81BC\u81BD\u81BE\u81BF\u81C4\u81C5\u81C7\u81C8\u81C9\u81CB\u81CD", 6, "\u6479\u8611\u6A21\u819C\u78E8\u6469\u9B54\u62B9\u672B\u83AB\u58A8\u9ED8\u6CAB\u6F20\u5BDE\u964C\u8C0B\u725F\u67D0\u62C7\u7261\u4EA9\u59C6\u6BCD\u5893\u66AE\u5E55\u52DF\u6155\u6728\u76EE\u7766\u7267\u7A46\u62FF\u54EA\u5450\u94A0\u90A3\u5A1C\u7EB3\u6C16\u4E43\u5976\u8010\u5948\u5357\u7537\u96BE\u56CA\u6320\u8111\u607C\u95F9\u6DD6\u5462\u9981\u5185\u5AE9\u80FD\u59AE\u9713\u502A\u6CE5\u5C3C\u62DF\u4F60\u533F\u817B\u9006\u6EBA\u852B\u62C8\u5E74\u78BE\u64B5\u637B\u5FF5\u5A18\u917F\u9E1F\u5C3F\u634F\u8042\u5B7D\u556E\u954A\u954D\u6D85\u60A8\u67E0\u72DE\u51DD\u5B81"],
      ["c540", "\u81D4", 14, "\u81E4\u81E5\u81E6\u81E8\u81E9\u81EB\u81EE", 4, "\u81F5", 5, "\u81FD\u81FF\u8203\u8207", 4, "\u820E\u820F\u8211\u8213\u8215", 5, "\u821D\u8220\u8224\u8225\u8226\u8227\u8229\u822E\u8232\u823A\u823C\u823D\u823F"],
      ["c580", "\u8240\u8241\u8242\u8243\u8245\u8246\u8248\u824A\u824C\u824D\u824E\u8250", 7, "\u8259\u825B\u825C\u825D\u825E\u8260", 7, "\u8269\u62E7\u6CDE\u725B\u626D\u94AE\u7EBD\u8113\u6D53\u519C\u5F04\u5974\u52AA\u6012\u5973\u6696\u8650\u759F\u632A\u61E6\u7CEF\u8BFA\u54E6\u6B27\u9E25\u6BB4\u85D5\u5455\u5076\u6CA4\u556A\u8DB4\u722C\u5E15\u6015\u7436\u62CD\u6392\u724C\u5F98\u6E43\u6D3E\u6500\u6F58\u76D8\u78D0\u76FC\u7554\u5224\u53DB\u4E53\u5E9E\u65C1\u802A\u80D6\u629B\u5486\u5228\u70AE\u888D\u8DD1\u6CE1\u5478\u80DA\u57F9\u88F4\u8D54\u966A\u914D\u4F69\u6C9B\u55B7\u76C6\u7830\u62A8\u70F9\u6F8E\u5F6D\u84EC\u68DA\u787C\u7BF7\u81A8\u670B\u9E4F\u6367\u78B0\u576F\u7812\u9739\u6279\u62AB\u5288\u7435\u6BD7"],
      ["c640", "\u826A\u826B\u826C\u826D\u8271\u8275\u8276\u8277\u8278\u827B\u827C\u8280\u8281\u8283\u8285\u8286\u8287\u8289\u828C\u8290\u8293\u8294\u8295\u8296\u829A\u829B\u829E\u82A0\u82A2\u82A3\u82A7\u82B2\u82B5\u82B6\u82BA\u82BB\u82BC\u82BF\u82C0\u82C2\u82C3\u82C5\u82C6\u82C9\u82D0\u82D6\u82D9\u82DA\u82DD\u82E2\u82E7\u82E8\u82E9\u82EA\u82EC\u82ED\u82EE\u82F0\u82F2\u82F3\u82F5\u82F6\u82F8"],
      ["c680", "\u82FA\u82FC", 4, "\u830A\u830B\u830D\u8310\u8312\u8313\u8316\u8318\u8319\u831D", 9, "\u8329\u832A\u832E\u8330\u8332\u8337\u833B\u833D\u5564\u813E\u75B2\u76AE\u5339\u75DE\u50FB\u5C41\u8B6C\u7BC7\u504F\u7247\u9A97\u98D8\u6F02\u74E2\u7968\u6487\u77A5\u62FC\u9891\u8D2B\u54C1\u8058\u4E52\u576A\u82F9\u840D\u5E73\u51ED\u74F6\u8BC4\u5C4F\u5761\u6CFC\u9887\u5A46\u7834\u9B44\u8FEB\u7C95\u5256\u6251\u94FA\u4EC6\u8386\u8461\u83E9\u84B2\u57D4\u6734\u5703\u666E\u6D66\u8C31\u66DD\u7011\u671F\u6B3A\u6816\u621A\u59BB\u4E03\u51C4\u6F06\u67D2\u6C8F\u5176\u68CB\u5947\u6B67\u7566\u5D0E\u8110\u9F50\u65D7\u7948\u7941\u9A91\u8D77\u5C82\u4E5E\u4F01\u542F\u5951\u780C\u5668\u6C14\u8FC4\u5F03\u6C7D\u6CE3\u8BAB\u6390"],
      ["c740", "\u833E\u833F\u8341\u8342\u8344\u8345\u8348\u834A", 4, "\u8353\u8355", 4, "\u835D\u8362\u8370", 6, "\u8379\u837A\u837E", 6, "\u8387\u8388\u838A\u838B\u838C\u838D\u838F\u8390\u8391\u8394\u8395\u8396\u8397\u8399\u839A\u839D\u839F\u83A1", 6, "\u83AC\u83AD\u83AE"],
      ["c780", "\u83AF\u83B5\u83BB\u83BE\u83BF\u83C2\u83C3\u83C4\u83C6\u83C8\u83C9\u83CB\u83CD\u83CE\u83D0\u83D1\u83D2\u83D3\u83D5\u83D7\u83D9\u83DA\u83DB\u83DE\u83E2\u83E3\u83E4\u83E6\u83E7\u83E8\u83EB\u83EC\u83ED\u6070\u6D3D\u7275\u6266\u948E\u94C5\u5343\u8FC1\u7B7E\u4EDF\u8C26\u4E7E\u9ED4\u94B1\u94B3\u524D\u6F5C\u9063\u6D45\u8C34\u5811\u5D4C\u6B20\u6B49\u67AA\u545B\u8154\u7F8C\u5899\u8537\u5F3A\u62A2\u6A47\u9539\u6572\u6084\u6865\u77A7\u4E54\u4FA8\u5DE7\u9798\u64AC\u7FD8\u5CED\u4FCF\u7A8D\u5207\u8304\u4E14\u602F\u7A83\u94A6\u4FB5\u4EB2\u79E6\u7434\u52E4\u82B9\u64D2\u79BD\u5BDD\u6C81\u9752\u8F7B\u6C22\u503E\u537F\u6E05\u64CE\u6674\u6C30\u60C5\u9877\u8BF7\u5E86\u743C\u7A77\u79CB\u4E18\u90B1\u7403\u6C42\u56DA\u914B\u6CC5\u8D8B\u533A\u86C6\u66F2\u8EAF\u5C48\u9A71\u6E20"],
      ["c840", "\u83EE\u83EF\u83F3", 4, "\u83FA\u83FB\u83FC\u83FE\u83FF\u8400\u8402\u8405\u8407\u8408\u8409\u840A\u8410\u8412", 5, "\u8419\u841A\u841B\u841E", 5, "\u8429", 7, "\u8432", 5, "\u8439\u843A\u843B\u843E", 7, "\u8447\u8448\u8449"],
      ["c880", "\u844A", 6, "\u8452", 4, "\u8458\u845D\u845E\u845F\u8460\u8462\u8464", 4, "\u846A\u846E\u846F\u8470\u8472\u8474\u8477\u8479\u847B\u847C\u53D6\u5A36\u9F8B\u8DA3\u53BB\u5708\u98A7\u6743\u919B\u6CC9\u5168\u75CA\u62F3\u72AC\u5238\u529D\u7F3A\u7094\u7638\u5374\u9E4A\u69B7\u786E\u96C0\u88D9\u7FA4\u7136\u71C3\u5189\u67D3\u74E4\u58E4\u6518\u56B7\u8BA9\u9976\u6270\u7ED5\u60F9\u70ED\u58EC\u4EC1\u4EBA\u5FCD\u97E7\u4EFB\u8BA4\u5203\u598A\u7EAB\u6254\u4ECD\u65E5\u620E\u8338\u84C9\u8363\u878D\u7194\u6EB6\u5BB9\u7ED2\u5197\u63C9\u67D4\u8089\u8339\u8815\u5112\u5B7A\u5982\u8FB1\u4E73\u6C5D\u5165\u8925\u8F6F\u962E\u854A\u745E\u9510\u95F0\u6DA6\u82E5\u5F31\u6492\u6D12\u8428\u816E\u9CC3\u585E\u8D5B\u4E09\u53C1"],
      ["c940", "\u847D", 4, "\u8483\u8484\u8485\u8486\u848A\u848D\u848F", 7, "\u8498\u849A\u849B\u849D\u849E\u849F\u84A0\u84A2", 12, "\u84B0\u84B1\u84B3\u84B5\u84B6\u84B7\u84BB\u84BC\u84BE\u84C0\u84C2\u84C3\u84C5\u84C6\u84C7\u84C8\u84CB\u84CC\u84CE\u84CF\u84D2\u84D4\u84D5\u84D7"],
      ["c980", "\u84D8", 4, "\u84DE\u84E1\u84E2\u84E4\u84E7", 4, "\u84ED\u84EE\u84EF\u84F1", 10, "\u84FD\u84FE\u8500\u8501\u8502\u4F1E\u6563\u6851\u55D3\u4E27\u6414\u9A9A\u626B\u5AC2\u745F\u8272\u6DA9\u68EE\u50E7\u838E\u7802\u6740\u5239\u6C99\u7EB1\u50BB\u5565\u715E\u7B5B\u6652\u73CA\u82EB\u6749\u5C71\u5220\u717D\u886B\u95EA\u9655\u64C5\u8D61\u81B3\u5584\u6C55\u6247\u7F2E\u5892\u4F24\u5546\u8D4F\u664C\u4E0A\u5C1A\u88F3\u68A2\u634E\u7A0D\u70E7\u828D\u52FA\u97F6\u5C11\u54E8\u90B5\u7ECD\u5962\u8D4A\u86C7\u820C\u820D\u8D66\u6444\u5C04\u6151\u6D89\u793E\u8BBE\u7837\u7533\u547B\u4F38\u8EAB\u6DF1\u5A20\u7EC5\u795E\u6C88\u5BA1\u5A76\u751A\u80BE\u614E\u6E17\u58F0\u751F\u7525\u7272\u5347\u7EF3"],
      ["ca40", "\u8503", 8, "\u850D\u850E\u850F\u8510\u8512\u8514\u8515\u8516\u8518\u8519\u851B\u851C\u851D\u851E\u8520\u8522", 8, "\u852D", 9, "\u853E", 4, "\u8544\u8545\u8546\u8547\u854B", 10],
      ["ca80", "\u8557\u8558\u855A\u855B\u855C\u855D\u855F", 4, "\u8565\u8566\u8567\u8569", 8, "\u8573\u8575\u8576\u8577\u8578\u857C\u857D\u857F\u8580\u8581\u7701\u76DB\u5269\u80DC\u5723\u5E08\u5931\u72EE\u65BD\u6E7F\u8BD7\u5C38\u8671\u5341\u77F3\u62FE\u65F6\u4EC0\u98DF\u8680\u5B9E\u8BC6\u53F2\u77E2\u4F7F\u5C4E\u9A76\u59CB\u5F0F\u793A\u58EB\u4E16\u67FF\u4E8B\u62ED\u8A93\u901D\u52BF\u662F\u55DC\u566C\u9002\u4ED5\u4F8D\u91CA\u9970\u6C0F\u5E02\u6043\u5BA4\u89C6\u8BD5\u6536\u624B\u9996\u5B88\u5BFF\u6388\u552E\u53D7\u7626\u517D\u852C\u67A2\u68B3\u6B8A\u6292\u8F93\u53D4\u8212\u6DD1\u758F\u4E66\u8D4E\u5B70\u719F\u85AF\u6691\u66D9\u7F72\u8700\u9ECD\u9F20\u5C5E\u672F\u8FF0\u6811\u675F\u620D\u7AD6\u5885\u5EB6\u6570\u6F31"],
      ["cb40", "\u8582\u8583\u8586\u8588", 6, "\u8590", 10, "\u859D", 6, "\u85A5\u85A6\u85A7\u85A9\u85AB\u85AC\u85AD\u85B1", 5, "\u85B8\u85BA", 6, "\u85C2", 6, "\u85CA", 4, "\u85D1\u85D2"],
      ["cb80", "\u85D4\u85D6", 5, "\u85DD", 6, "\u85E5\u85E6\u85E7\u85E8\u85EA", 14, "\u6055\u5237\u800D\u6454\u8870\u7529\u5E05\u6813\u62F4\u971C\u53CC\u723D\u8C01\u6C34\u7761\u7A0E\u542E\u77AC\u987A\u821C\u8BF4\u7855\u6714\u70C1\u65AF\u6495\u5636\u601D\u79C1\u53F8\u4E1D\u6B7B\u8086\u5BFA\u55E3\u56DB\u4F3A\u4F3C\u9972\u5DF3\u677E\u8038\u6002\u9882\u9001\u5B8B\u8BBC\u8BF5\u641C\u8258\u64DE\u55FD\u82CF\u9165\u4FD7\u7D20\u901F\u7C9F\u50F3\u5851\u6EAF\u5BBF\u8BC9\u8083\u9178\u849C\u7B97\u867D\u968B\u968F\u7EE5\u9AD3\u788E\u5C81\u7A57\u9042\u96A7\u795F\u5B59\u635F\u7B0B\u84D1\u68AD\u5506\u7F29\u7410\u7D22\u9501\u6240\u584C\u4ED6\u5B83\u5979\u5854"],
      ["cc40", "\u85F9\u85FA\u85FC\u85FD\u85FE\u8600", 4, "\u8606", 10, "\u8612\u8613\u8614\u8615\u8617", 15, "\u8628\u862A", 13, "\u8639\u863A\u863B\u863D\u863E\u863F\u8640"],
      ["cc80", "\u8641", 11, "\u8652\u8653\u8655", 4, "\u865B\u865C\u865D\u865F\u8660\u8661\u8663", 7, "\u736D\u631E\u8E4B\u8E0F\u80CE\u82D4\u62AC\u53F0\u6CF0\u915E\u592A\u6001\u6C70\u574D\u644A\u8D2A\u762B\u6EE9\u575B\u6A80\u75F0\u6F6D\u8C2D\u8C08\u5766\u6BEF\u8892\u78B3\u63A2\u53F9\u70AD\u6C64\u5858\u642A\u5802\u68E0\u819B\u5510\u7CD6\u5018\u8EBA\u6DCC\u8D9F\u70EB\u638F\u6D9B\u6ED4\u7EE6\u8404\u6843\u9003\u6DD8\u9676\u8BA8\u5957\u7279\u85E4\u817E\u75BC\u8A8A\u68AF\u5254\u8E22\u9511\u63D0\u9898\u8E44\u557C\u4F53\u66FF\u568F\u60D5\u6D95\u5243\u5C49\u5929\u6DFB\u586B\u7530\u751C\u606C\u8214\u8146\u6311\u6761\u8FE2\u773A\u8DF3\u8D34\u94C1\u5E16\u5385\u542C\u70C3"],
      ["cd40", "\u866D\u866F\u8670\u8672", 6, "\u8683", 6, "\u868E", 4, "\u8694\u8696", 5, "\u869E", 4, "\u86A5\u86A6\u86AB\u86AD\u86AE\u86B2\u86B3\u86B7\u86B8\u86B9\u86BB", 4, "\u86C1\u86C2\u86C3\u86C5\u86C8\u86CC\u86CD\u86D2\u86D3\u86D5\u86D6\u86D7\u86DA\u86DC"],
      ["cd80", "\u86DD\u86E0\u86E1\u86E2\u86E3\u86E5\u86E6\u86E7\u86E8\u86EA\u86EB\u86EC\u86EF\u86F5\u86F6\u86F7\u86FA\u86FB\u86FC\u86FD\u86FF\u8701\u8704\u8705\u8706\u870B\u870C\u870E\u870F\u8710\u8711\u8714\u8716\u6C40\u5EF7\u505C\u4EAD\u5EAD\u633A\u8247\u901A\u6850\u916E\u77B3\u540C\u94DC\u5F64\u7AE5\u6876\u6345\u7B52\u7EDF\u75DB\u5077\u6295\u5934\u900F\u51F8\u79C3\u7A81\u56FE\u5F92\u9014\u6D82\u5C60\u571F\u5410\u5154\u6E4D\u56E2\u63A8\u9893\u817F\u8715\u892A\u9000\u541E\u5C6F\u81C0\u62D6\u6258\u8131\u9E35\u9640\u9A6E\u9A7C\u692D\u59A5\u62D3\u553E\u6316\u54C7\u86D9\u6D3C\u5A03\u74E6\u889C\u6B6A\u5916\u8C4C\u5F2F\u6E7E\u73A9\u987D\u4E38\u70F7\u5B8C\u7897\u633D\u665A\u7696\u60CB\u5B9B\u5A49\u4E07\u8155\u6C6A\u738B\u4EA1\u6789\u7F51\u5F80\u65FA\u671B\u5FD8\u5984\u5A01"],
      ["ce40", "\u8719\u871B\u871D\u871F\u8720\u8724\u8726\u8727\u8728\u872A\u872B\u872C\u872D\u872F\u8730\u8732\u8733\u8735\u8736\u8738\u8739\u873A\u873C\u873D\u8740", 6, "\u874A\u874B\u874D\u874F\u8750\u8751\u8752\u8754\u8755\u8756\u8758\u875A", 5, "\u8761\u8762\u8766", 7, "\u876F\u8771\u8772\u8773\u8775"],
      ["ce80", "\u8777\u8778\u8779\u877A\u877F\u8780\u8781\u8784\u8786\u8787\u8789\u878A\u878C\u878E", 4, "\u8794\u8795\u8796\u8798", 6, "\u87A0", 4, "\u5DCD\u5FAE\u5371\u97E6\u8FDD\u6845\u56F4\u552F\u60DF\u4E3A\u6F4D\u7EF4\u82C7\u840E\u59D4\u4F1F\u4F2A\u5C3E\u7EAC\u672A\u851A\u5473\u754F\u80C3\u5582\u9B4F\u4F4D\u6E2D\u8C13\u5C09\u6170\u536B\u761F\u6E29\u868A\u6587\u95FB\u7EB9\u543B\u7A33\u7D0A\u95EE\u55E1\u7FC1\u74EE\u631D\u8717\u6DA1\u7A9D\u6211\u65A1\u5367\u63E1\u6C83\u5DEB\u545C\u94A8\u4E4C\u6C61\u8BEC\u5C4B\u65E0\u829C\u68A7\u543E\u5434\u6BCB\u6B66\u4E94\u6342\u5348\u821E\u4F0D\u4FAE\u575E\u620A\u96FE\u6664\u7269\u52FF\u52A1\u609F\u8BEF\u6614\u7199\u6790\u897F\u7852\u77FD\u6670\u563B\u5438\u9521\u727A"],
      ["cf40", "\u87A5\u87A6\u87A7\u87A9\u87AA\u87AE\u87B0\u87B1\u87B2\u87B4\u87B6\u87B7\u87B8\u87B9\u87BB\u87BC\u87BE\u87BF\u87C1", 4, "\u87C7\u87C8\u87C9\u87CC", 4, "\u87D4", 6, "\u87DC\u87DD\u87DE\u87DF\u87E1\u87E2\u87E3\u87E4\u87E6\u87E7\u87E8\u87E9\u87EB\u87EC\u87ED\u87EF", 9],
      ["cf80", "\u87FA\u87FB\u87FC\u87FD\u87FF\u8800\u8801\u8802\u8804", 5, "\u880B", 7, "\u8814\u8817\u8818\u8819\u881A\u881C", 4, "\u8823\u7A00\u606F\u5E0C\u6089\u819D\u5915\u60DC\u7184\u70EF\u6EAA\u6C50\u7280\u6A84\u88AD\u5E2D\u4E60\u5AB3\u559C\u94E3\u6D17\u7CFB\u9699\u620F\u7EC6\u778E\u867E\u5323\u971E\u8F96\u6687\u5CE1\u4FA0\u72ED\u4E0B\u53A6\u590F\u5413\u6380\u9528\u5148\u4ED9\u9C9C\u7EA4\u54B8\u8D24\u8854\u8237\u95F2\u6D8E\u5F26\u5ACC\u663E\u9669\u73B0\u732E\u53BF\u817A\u9985\u7FA1\u5BAA\u9677\u9650\u7EBF\u76F8\u53A2\u9576\u9999\u7BB1\u8944\u6E58\u4E61\u7FD4\u7965\u8BE6\u60F3\u54CD\u4EAB\u9879\u5DF7\u6A61\u50CF\u5411\u8C61\u8427\u785D\u9704\u524A\u54EE\u56A3\u9500\u6D88\u5BB5\u6DC6\u6653"],
      ["d040", "\u8824", 13, "\u8833", 5, "\u883A\u883B\u883D\u883E\u883F\u8841\u8842\u8843\u8846", 5, "\u884E", 5, "\u8855\u8856\u8858\u885A", 6, "\u8866\u8867\u886A\u886D\u886F\u8871\u8873\u8874\u8875\u8876\u8878\u8879\u887A"],
      ["d080", "\u887B\u887C\u8880\u8883\u8886\u8887\u8889\u888A\u888C\u888E\u888F\u8890\u8891\u8893\u8894\u8895\u8897", 4, "\u889D", 4, "\u88A3\u88A5", 5, "\u5C0F\u5B5D\u6821\u8096\u5578\u7B11\u6548\u6954\u4E9B\u6B47\u874E\u978B\u534F\u631F\u643A\u90AA\u659C\u80C1\u8C10\u5199\u68B0\u5378\u87F9\u61C8\u6CC4\u6CFB\u8C22\u5C51\u85AA\u82AF\u950C\u6B23\u8F9B\u65B0\u5FFB\u5FC3\u4FE1\u8845\u661F\u8165\u7329\u60FA\u5174\u5211\u578B\u5F62\u90A2\u884C\u9192\u5E78\u674F\u6027\u59D3\u5144\u51F6\u80F8\u5308\u6C79\u96C4\u718A\u4F11\u4FEE\u7F9E\u673D\u55C5\u9508\u79C0\u8896\u7EE3\u589F\u620C\u9700\u865A\u5618\u987B\u5F90\u8BB8\u84C4\u9157\u53D9\u65ED\u5E8F\u755C\u6064\u7D6E\u5A7F\u7EEA\u7EED\u8F69\u55A7\u5BA3\u60AC\u65CB\u7384"],
      ["d140", "\u88AC\u88AE\u88AF\u88B0\u88B2", 4, "\u88B8\u88B9\u88BA\u88BB\u88BD\u88BE\u88BF\u88C0\u88C3\u88C4\u88C7\u88C8\u88CA\u88CB\u88CC\u88CD\u88CF\u88D0\u88D1\u88D3\u88D6\u88D7\u88DA", 4, "\u88E0\u88E1\u88E6\u88E7\u88E9", 6, "\u88F2\u88F5\u88F6\u88F7\u88FA\u88FB\u88FD\u88FF\u8900\u8901\u8903", 5],
      ["d180", "\u8909\u890B", 4, "\u8911\u8914", 4, "\u891C", 4, "\u8922\u8923\u8924\u8926\u8927\u8928\u8929\u892C\u892D\u892E\u892F\u8931\u8932\u8933\u8935\u8937\u9009\u7663\u7729\u7EDA\u9774\u859B\u5B66\u7A74\u96EA\u8840\u52CB\u718F\u5FAA\u65EC\u8BE2\u5BFB\u9A6F\u5DE1\u6B89\u6C5B\u8BAD\u8BAF\u900A\u8FC5\u538B\u62BC\u9E26\u9E2D\u5440\u4E2B\u82BD\u7259\u869C\u5D16\u8859\u6DAF\u96C5\u54D1\u4E9A\u8BB6\u7109\u54BD\u9609\u70DF\u6DF9\u76D0\u4E25\u7814\u8712\u5CA9\u5EF6\u8A00\u989C\u960E\u708E\u6CBF\u5944\u63A9\u773C\u884D\u6F14\u8273\u5830\u71D5\u538C\u781A\u96C1\u5501\u5F66\u7130\u5BB4\u8C1A\u9A8C\u6B83\u592E\u9E2F\u79E7\u6768\u626C\u4F6F\u75A1\u7F8A\u6D0B\u9633\u6C27\u4EF0\u75D2\u517B\u6837\u6F3E\u9080\u8170\u5996\u7476"],
      ["d240", "\u8938", 8, "\u8942\u8943\u8945", 24, "\u8960", 5, "\u8967", 19, "\u897C"],
      ["d280", "\u897D\u897E\u8980\u8982\u8984\u8985\u8987", 26, "\u6447\u5C27\u9065\u7A91\u8C23\u59DA\u54AC\u8200\u836F\u8981\u8000\u6930\u564E\u8036\u7237\u91CE\u51B6\u4E5F\u9875\u6396\u4E1A\u53F6\u66F3\u814B\u591C\u6DB2\u4E00\u58F9\u533B\u63D6\u94F1\u4F9D\u4F0A\u8863\u9890\u5937\u9057\u79FB\u4EEA\u80F0\u7591\u6C82\u5B9C\u59E8\u5F5D\u6905\u8681\u501A\u5DF2\u4E59\u77E3\u4EE5\u827A\u6291\u6613\u9091\u5C79\u4EBF\u5F79\u81C6\u9038\u8084\u75AB\u4EA6\u88D4\u610F\u6BC5\u5FC6\u4E49\u76CA\u6EA2\u8BE3\u8BAE\u8C0A\u8BD1\u5F02\u7FFC\u7FCC\u7ECE\u8335\u836B\u56E0\u6BB7\u97F3\u9634\u59FB\u541F\u94F6\u6DEB\u5BC5\u996E\u5C39\u5F15\u9690"],
      ["d340", "\u89A2", 30, "\u89C3\u89CD\u89D3\u89D4\u89D5\u89D7\u89D8\u89D9\u89DB\u89DD\u89DF\u89E0\u89E1\u89E2\u89E4\u89E7\u89E8\u89E9\u89EA\u89EC\u89ED\u89EE\u89F0\u89F1\u89F2\u89F4", 6],
      ["d380", "\u89FB", 4, "\u8A01", 5, "\u8A08", 21, "\u5370\u82F1\u6A31\u5A74\u9E70\u5E94\u7F28\u83B9\u8424\u8425\u8367\u8747\u8FCE\u8D62\u76C8\u5F71\u9896\u786C\u6620\u54DF\u62E5\u4F63\u81C3\u75C8\u5EB8\u96CD\u8E0A\u86F9\u548F\u6CF3\u6D8C\u6C38\u607F\u52C7\u7528\u5E7D\u4F18\u60A0\u5FE7\u5C24\u7531\u90AE\u94C0\u72B9\u6CB9\u6E38\u9149\u6709\u53CB\u53F3\u4F51\u91C9\u8BF1\u53C8\u5E7C\u8FC2\u6DE4\u4E8E\u76C2\u6986\u865E\u611A\u8206\u4F59\u4FDE\u903E\u9C7C\u6109\u6E1D\u6E14\u9685\u4E88\u5A31\u96E8\u4E0E\u5C7F\u79B9\u5B87\u8BED\u7FBD\u7389\u57DF\u828B\u90C1\u5401\u9047\u55BB\u5CEA\u5FA1\u6108\u6B32\u72F1\u80B2\u8A89"],
      ["d440", "\u8A1E", 31, "\u8A3F", 8, "\u8A49", 21],
      ["d480", "\u8A5F", 25, "\u8A7A", 6, "\u6D74\u5BD3\u88D5\u9884\u8C6B\u9A6D\u9E33\u6E0A\u51A4\u5143\u57A3\u8881\u539F\u63F4\u8F95\u56ED\u5458\u5706\u733F\u6E90\u7F18\u8FDC\u82D1\u613F\u6028\u9662\u66F0\u7EA6\u8D8A\u8DC3\u94A5\u5CB3\u7CA4\u6708\u60A6\u9605\u8018\u4E91\u90E7\u5300\u9668\u5141\u8FD0\u8574\u915D\u6655\u97F5\u5B55\u531D\u7838\u6742\u683D\u54C9\u707E\u5BB0\u8F7D\u518D\u5728\u54B1\u6512\u6682\u8D5E\u8D43\u810F\u846C\u906D\u7CDF\u51FF\u85FB\u67A3\u65E9\u6FA1\u86A4\u8E81\u566A\u9020\u7682\u7076\u71E5\u8D23\u62E9\u5219\u6CFD\u8D3C\u600E\u589E\u618E\u66FE\u8D60\u624E\u55B3\u6E23\u672D\u8F67"],
      ["d540", "\u8A81", 7, "\u8A8B", 7, "\u8A94", 46],
      ["d580", "\u8AC3", 32, "\u94E1\u95F8\u7728\u6805\u69A8\u548B\u4E4D\u70B8\u8BC8\u6458\u658B\u5B85\u7A84\u503A\u5BE8\u77BB\u6BE1\u8A79\u7C98\u6CBE\u76CF\u65A9\u8F97\u5D2D\u5C55\u8638\u6808\u5360\u6218\u7AD9\u6E5B\u7EFD\u6A1F\u7AE0\u5F70\u6F33\u5F20\u638C\u6DA8\u6756\u4E08\u5E10\u8D26\u4ED7\u80C0\u7634\u969C\u62DB\u662D\u627E\u6CBC\u8D75\u7167\u7F69\u5146\u8087\u53EC\u906E\u6298\u54F2\u86F0\u8F99\u8005\u9517\u8517\u8FD9\u6D59\u73CD\u659F\u771F\u7504\u7827\u81FB\u8D1E\u9488\u4FA6\u6795\u75B9\u8BCA\u9707\u632F\u9547\u9635\u84B8\u6323\u7741\u5F81\u72F0\u4E89\u6014\u6574\u62EF\u6B63\u653F"],
      ["d640", "\u8AE4", 34, "\u8B08", 27],
      ["d680", "\u8B24\u8B25\u8B27", 30, "\u5E27\u75C7\u90D1\u8BC1\u829D\u679D\u652F\u5431\u8718\u77E5\u80A2\u8102\u6C41\u4E4B\u7EC7\u804C\u76F4\u690D\u6B96\u6267\u503C\u4F84\u5740\u6307\u6B62\u8DBE\u53EA\u65E8\u7EB8\u5FD7\u631A\u63B7\u81F3\u81F4\u7F6E\u5E1C\u5CD9\u5236\u667A\u79E9\u7A1A\u8D28\u7099\u75D4\u6EDE\u6CBB\u7A92\u4E2D\u76C5\u5FE0\u949F\u8877\u7EC8\u79CD\u80BF\u91CD\u4EF2\u4F17\u821F\u5468\u5DDE\u6D32\u8BCC\u7CA5\u8F74\u8098\u5E1A\u5492\u76B1\u5B99\u663C\u9AA4\u73E0\u682A\u86DB\u6731\u732A\u8BF8\u8BDB\u9010\u7AF9\u70DB\u716E\u62C4\u77A9\u5631\u4E3B\u8457\u67F1\u52A9\u86C0\u8D2E\u94F8\u7B51"],
      ["d740", "\u8B46", 31, "\u8B67", 4, "\u8B6D", 25],
      ["d780", "\u8B87", 24, "\u8BAC\u8BB1\u8BBB\u8BC7\u8BD0\u8BEA\u8C09\u8C1E\u4F4F\u6CE8\u795D\u9A7B\u6293\u722A\u62FD\u4E13\u7816\u8F6C\u64B0\u8D5A\u7BC6\u6869\u5E84\u88C5\u5986\u649E\u58EE\u72B6\u690E\u9525\u8FFD\u8D58\u5760\u7F00\u8C06\u51C6\u6349\u62D9\u5353\u684C\u7422\u8301\u914C\u5544\u7740\u707C\u6D4A\u5179\u54A8\u8D44\u59FF\u6ECB\u6DC4\u5B5C\u7D2B\u4ED4\u7C7D\u6ED3\u5B50\u81EA\u6E0D\u5B57\u9B03\u68D5\u8E2A\u5B97\u7EFC\u603B\u7EB5\u90B9\u8D70\u594F\u63CD\u79DF\u8DB3\u5352\u65CF\u7956\u8BC5\u963B\u7EC4\u94BB\u7E82\u5634\u9189\u6700\u7F6A\u5C0A\u9075\u6628\u5DE6\u4F50\u67DE\u505A\u4F5C\u5750\u5EA7"],
      ["d840", "\u8C38", 8, "\u8C42\u8C43\u8C44\u8C45\u8C48\u8C4A\u8C4B\u8C4D", 7, "\u8C56\u8C57\u8C58\u8C59\u8C5B", 5, "\u8C63", 6, "\u8C6C", 6, "\u8C74\u8C75\u8C76\u8C77\u8C7B", 6, "\u8C83\u8C84\u8C86\u8C87"],
      ["d880", "\u8C88\u8C8B\u8C8D", 6, "\u8C95\u8C96\u8C97\u8C99", 20, "\u4E8D\u4E0C\u5140\u4E10\u5EFF\u5345\u4E15\u4E98\u4E1E\u9B32\u5B6C\u5669\u4E28\u79BA\u4E3F\u5315\u4E47\u592D\u723B\u536E\u6C10\u56DF\u80E4\u9997\u6BD3\u777E\u9F17\u4E36\u4E9F\u9F10\u4E5C\u4E69\u4E93\u8288\u5B5B\u556C\u560F\u4EC4\u538D\u539D\u53A3\u53A5\u53AE\u9765\u8D5D\u531A\u53F5\u5326\u532E\u533E\u8D5C\u5366\u5363\u5202\u5208\u520E\u522D\u5233\u523F\u5240\u524C\u525E\u5261\u525C\u84AF\u527D\u5282\u5281\u5290\u5293\u5182\u7F54\u4EBB\u4EC3\u4EC9\u4EC2\u4EE8\u4EE1\u4EEB\u4EDE\u4F1B\u4EF3\u4F22\u4F64\u4EF5\u4F25\u4F27\u4F09\u4F2B\u4F5E\u4F67\u6538\u4F5A\u4F5D"],
      ["d940", "\u8CAE", 62],
      ["d980", "\u8CED", 32, "\u4F5F\u4F57\u4F32\u4F3D\u4F76\u4F74\u4F91\u4F89\u4F83\u4F8F\u4F7E\u4F7B\u4FAA\u4F7C\u4FAC\u4F94\u4FE6\u4FE8\u4FEA\u4FC5\u4FDA\u4FE3\u4FDC\u4FD1\u4FDF\u4FF8\u5029\u504C\u4FF3\u502C\u500F\u502E\u502D\u4FFE\u501C\u500C\u5025\u5028\u507E\u5043\u5055\u5048\u504E\u506C\u507B\u50A5\u50A7\u50A9\u50BA\u50D6\u5106\u50ED\u50EC\u50E6\u50EE\u5107\u510B\u4EDD\u6C3D\u4F58\u4F65\u4FCE\u9FA0\u6C46\u7C74\u516E\u5DFD\u9EC9\u9998\u5181\u5914\u52F9\u530D\u8A07\u5310\u51EB\u5919\u5155\u4EA0\u5156\u4EB3\u886E\u88A4\u4EB5\u8114\u88D2\u7980\u5B34\u8803\u7FB8\u51AB\u51B1\u51BD\u51BC"],
      ["da40", "\u8D0E", 14, "\u8D20\u8D51\u8D52\u8D57\u8D5F\u8D65\u8D68\u8D69\u8D6A\u8D6C\u8D6E\u8D6F\u8D71\u8D72\u8D78", 8, "\u8D82\u8D83\u8D86\u8D87\u8D88\u8D89\u8D8C", 4, "\u8D92\u8D93\u8D95", 9, "\u8DA0\u8DA1"],
      ["da80", "\u8DA2\u8DA4", 12, "\u8DB2\u8DB6\u8DB7\u8DB9\u8DBB\u8DBD\u8DC0\u8DC1\u8DC2\u8DC5\u8DC7\u8DC8\u8DC9\u8DCA\u8DCD\u8DD0\u8DD2\u8DD3\u8DD4\u51C7\u5196\u51A2\u51A5\u8BA0\u8BA6\u8BA7\u8BAA\u8BB4\u8BB5\u8BB7\u8BC2\u8BC3\u8BCB\u8BCF\u8BCE\u8BD2\u8BD3\u8BD4\u8BD6\u8BD8\u8BD9\u8BDC\u8BDF\u8BE0\u8BE4\u8BE8\u8BE9\u8BEE\u8BF0\u8BF3\u8BF6\u8BF9\u8BFC\u8BFF\u8C00\u8C02\u8C04\u8C07\u8C0C\u8C0F\u8C11\u8C12\u8C14\u8C15\u8C16\u8C19\u8C1B\u8C18\u8C1D\u8C1F\u8C20\u8C21\u8C25\u8C27\u8C2A\u8C2B\u8C2E\u8C2F\u8C32\u8C33\u8C35\u8C36\u5369\u537A\u961D\u9622\u9621\u9631\u962A\u963D\u963C\u9642\u9649\u9654\u965F\u9667\u966C\u9672\u9674\u9688\u968D\u9697\u96B0\u9097\u909B\u909D\u9099\u90AC\u90A1\u90B4\u90B3\u90B6\u90BA"],
      ["db40", "\u8DD5\u8DD8\u8DD9\u8DDC\u8DE0\u8DE1\u8DE2\u8DE5\u8DE6\u8DE7\u8DE9\u8DED\u8DEE\u8DF0\u8DF1\u8DF2\u8DF4\u8DF6\u8DFC\u8DFE", 6, "\u8E06\u8E07\u8E08\u8E0B\u8E0D\u8E0E\u8E10\u8E11\u8E12\u8E13\u8E15", 7, "\u8E20\u8E21\u8E24", 4, "\u8E2B\u8E2D\u8E30\u8E32\u8E33\u8E34\u8E36\u8E37\u8E38\u8E3B\u8E3C\u8E3E"],
      ["db80", "\u8E3F\u8E43\u8E45\u8E46\u8E4C", 4, "\u8E53", 5, "\u8E5A", 11, "\u8E67\u8E68\u8E6A\u8E6B\u8E6E\u8E71\u90B8\u90B0\u90CF\u90C5\u90BE\u90D0\u90C4\u90C7\u90D3\u90E6\u90E2\u90DC\u90D7\u90DB\u90EB\u90EF\u90FE\u9104\u9122\u911E\u9123\u9131\u912F\u9139\u9143\u9146\u520D\u5942\u52A2\u52AC\u52AD\u52BE\u54FF\u52D0\u52D6\u52F0\u53DF\u71EE\u77CD\u5EF4\u51F5\u51FC\u9B2F\u53B6\u5F01\u755A\u5DEF\u574C\u57A9\u57A1\u587E\u58BC\u58C5\u58D1\u5729\u572C\u572A\u5733\u5739\u572E\u572F\u575C\u573B\u5742\u5769\u5785\u576B\u5786\u577C\u577B\u5768\u576D\u5776\u5773\u57AD\u57A4\u578C\u57B2\u57CF\u57A7\u57B4\u5793\u57A0\u57D5\u57D8\u57DA\u57D9\u57D2\u57B8\u57F4\u57EF\u57F8\u57E4\u57DD"],
      ["dc40", "\u8E73\u8E75\u8E77", 4, "\u8E7D\u8E7E\u8E80\u8E82\u8E83\u8E84\u8E86\u8E88", 6, "\u8E91\u8E92\u8E93\u8E95", 6, "\u8E9D\u8E9F", 11, "\u8EAD\u8EAE\u8EB0\u8EB1\u8EB3", 6, "\u8EBB", 7],
      ["dc80", "\u8EC3", 10, "\u8ECF", 21, "\u580B\u580D\u57FD\u57ED\u5800\u581E\u5819\u5844\u5820\u5865\u586C\u5881\u5889\u589A\u5880\u99A8\u9F19\u61FF\u8279\u827D\u827F\u828F\u828A\u82A8\u8284\u828E\u8291\u8297\u8299\u82AB\u82B8\u82BE\u82B0\u82C8\u82CA\u82E3\u8298\u82B7\u82AE\u82CB\u82CC\u82C1\u82A9\u82B4\u82A1\u82AA\u829F\u82C4\u82CE\u82A4\u82E1\u8309\u82F7\u82E4\u830F\u8307\u82DC\u82F4\u82D2\u82D8\u830C\u82FB\u82D3\u8311\u831A\u8306\u8314\u8315\u82E0\u82D5\u831C\u8351\u835B\u835C\u8308\u8392\u833C\u8334\u8331\u839B\u835E\u832F\u834F\u8347\u8343\u835F\u8340\u8317\u8360\u832D\u833A\u8333\u8366\u8365"],
      ["dd40", "\u8EE5", 62],
      ["dd80", "\u8F24", 32, "\u8368\u831B\u8369\u836C\u836A\u836D\u836E\u83B0\u8378\u83B3\u83B4\u83A0\u83AA\u8393\u839C\u8385\u837C\u83B6\u83A9\u837D\u83B8\u837B\u8398\u839E\u83A8\u83BA\u83BC\u83C1\u8401\u83E5\u83D8\u5807\u8418\u840B\u83DD\u83FD\u83D6\u841C\u8438\u8411\u8406\u83D4\u83DF\u840F\u8403\u83F8\u83F9\u83EA\u83C5\u83C0\u8426\u83F0\u83E1\u845C\u8451\u845A\u8459\u8473\u8487\u8488\u847A\u8489\u8478\u843C\u8446\u8469\u8476\u848C\u848E\u8431\u846D\u84C1\u84CD\u84D0\u84E6\u84BD\u84D3\u84CA\u84BF\u84BA\u84E0\u84A1\u84B9\u84B4\u8497\u84E5\u84E3\u850C\u750D\u8538\u84F0\u8539\u851F\u853A"],
      ["de40", "\u8F45", 32, "\u8F6A\u8F80\u8F8C\u8F92\u8F9D\u8FA0\u8FA1\u8FA2\u8FA4\u8FA5\u8FA6\u8FA7\u8FAA\u8FAC\u8FAD\u8FAE\u8FAF\u8FB2\u8FB3\u8FB4\u8FB5\u8FB7\u8FB8\u8FBA\u8FBB\u8FBC\u8FBF\u8FC0\u8FC3\u8FC6"],
      ["de80", "\u8FC9", 4, "\u8FCF\u8FD2\u8FD6\u8FD7\u8FDA\u8FE0\u8FE1\u8FE3\u8FE7\u8FEC\u8FEF\u8FF1\u8FF2\u8FF4\u8FF5\u8FF6\u8FFA\u8FFB\u8FFC\u8FFE\u8FFF\u9007\u9008\u900C\u900E\u9013\u9015\u9018\u8556\u853B\u84FF\u84FC\u8559\u8548\u8568\u8564\u855E\u857A\u77A2\u8543\u8572\u857B\u85A4\u85A8\u8587\u858F\u8579\u85AE\u859C\u8585\u85B9\u85B7\u85B0\u85D3\u85C1\u85DC\u85FF\u8627\u8605\u8629\u8616\u863C\u5EFE\u5F08\u593C\u5941\u8037\u5955\u595A\u5958\u530F\u5C22\u5C25\u5C2C\u5C34\u624C\u626A\u629F\u62BB\u62CA\u62DA\u62D7\u62EE\u6322\u62F6\u6339\u634B\u6343\u63AD\u63F6\u6371\u637A\u638E\u63B4\u636D\u63AC\u638A\u6369\u63AE\u63BC\u63F2\u63F8\u63E0\u63FF\u63C4\u63DE\u63CE\u6452\u63C6\u63BE\u6445\u6441\u640B\u641B\u6420\u640C\u6426\u6421\u645E\u6484\u646D\u6496"],
      ["df40", "\u9019\u901C\u9023\u9024\u9025\u9027", 5, "\u9030", 4, "\u9037\u9039\u903A\u903D\u903F\u9040\u9043\u9045\u9046\u9048", 4, "\u904E\u9054\u9055\u9056\u9059\u905A\u905C", 5, "\u9064\u9066\u9067\u9069\u906A\u906B\u906C\u906F", 4, "\u9076", 6, "\u907E\u9081"],
      ["df80", "\u9084\u9085\u9086\u9087\u9089\u908A\u908C", 4, "\u9092\u9094\u9096\u9098\u909A\u909C\u909E\u909F\u90A0\u90A4\u90A5\u90A7\u90A8\u90A9\u90AB\u90AD\u90B2\u90B7\u90BC\u90BD\u90BF\u90C0\u647A\u64B7\u64B8\u6499\u64BA\u64C0\u64D0\u64D7\u64E4\u64E2\u6509\u6525\u652E\u5F0B\u5FD2\u7519\u5F11\u535F\u53F1\u53FD\u53E9\u53E8\u53FB\u5412\u5416\u5406\u544B\u5452\u5453\u5454\u5456\u5443\u5421\u5457\u5459\u5423\u5432\u5482\u5494\u5477\u5471\u5464\u549A\u549B\u5484\u5476\u5466\u549D\u54D0\u54AD\u54C2\u54B4\u54D2\u54A7\u54A6\u54D3\u54D4\u5472\u54A3\u54D5\u54BB\u54BF\u54CC\u54D9\u54DA\u54DC\u54A9\u54AA\u54A4\u54DD\u54CF\u54DE\u551B\u54E7\u5520\u54FD\u5514\u54F3\u5522\u5523\u550F\u5511\u5527\u552A\u5567\u558F\u55B5\u5549\u556D\u5541\u5555\u553F\u5550\u553C"],
      ["e040", "\u90C2\u90C3\u90C6\u90C8\u90C9\u90CB\u90CC\u90CD\u90D2\u90D4\u90D5\u90D6\u90D8\u90D9\u90DA\u90DE\u90DF\u90E0\u90E3\u90E4\u90E5\u90E9\u90EA\u90EC\u90EE\u90F0\u90F1\u90F2\u90F3\u90F5\u90F6\u90F7\u90F9\u90FA\u90FB\u90FC\u90FF\u9100\u9101\u9103\u9105", 19, "\u911A\u911B\u911C"],
      ["e080", "\u911D\u911F\u9120\u9121\u9124", 10, "\u9130\u9132", 6, "\u913A", 8, "\u9144\u5537\u5556\u5575\u5576\u5577\u5533\u5530\u555C\u558B\u55D2\u5583\u55B1\u55B9\u5588\u5581\u559F\u557E\u55D6\u5591\u557B\u55DF\u55BD\u55BE\u5594\u5599\u55EA\u55F7\u55C9\u561F\u55D1\u55EB\u55EC\u55D4\u55E6\u55DD\u55C4\u55EF\u55E5\u55F2\u55F3\u55CC\u55CD\u55E8\u55F5\u55E4\u8F94\u561E\u5608\u560C\u5601\u5624\u5623\u55FE\u5600\u5627\u562D\u5658\u5639\u5657\u562C\u564D\u5662\u5659\u565C\u564C\u5654\u5686\u5664\u5671\u566B\u567B\u567C\u5685\u5693\u56AF\u56D4\u56D7\u56DD\u56E1\u56F5\u56EB\u56F9\u56FF\u5704\u570A\u5709\u571C\u5E0F\u5E19\u5E14\u5E11\u5E31\u5E3B\u5E3C"],
      ["e140", "\u9145\u9147\u9148\u9151\u9153\u9154\u9155\u9156\u9158\u9159\u915B\u915C\u915F\u9160\u9166\u9167\u9168\u916B\u916D\u9173\u917A\u917B\u917C\u9180", 4, "\u9186\u9188\u918A\u918E\u918F\u9193", 6, "\u919C", 5, "\u91A4", 5, "\u91AB\u91AC\u91B0\u91B1\u91B2\u91B3\u91B6\u91B7\u91B8\u91B9\u91BB"],
      ["e180", "\u91BC", 10, "\u91C8\u91CB\u91D0\u91D2", 9, "\u91DD", 8, "\u5E37\u5E44\u5E54\u5E5B\u5E5E\u5E61\u5C8C\u5C7A\u5C8D\u5C90\u5C96\u5C88\u5C98\u5C99\u5C91\u5C9A\u5C9C\u5CB5\u5CA2\u5CBD\u5CAC\u5CAB\u5CB1\u5CA3\u5CC1\u5CB7\u5CC4\u5CD2\u5CE4\u5CCB\u5CE5\u5D02\u5D03\u5D27\u5D26\u5D2E\u5D24\u5D1E\u5D06\u5D1B\u5D58\u5D3E\u5D34\u5D3D\u5D6C\u5D5B\u5D6F\u5D5D\u5D6B\u5D4B\u5D4A\u5D69\u5D74\u5D82\u5D99\u5D9D\u8C73\u5DB7\u5DC5\u5F73\u5F77\u5F82\u5F87\u5F89\u5F8C\u5F95\u5F99\u5F9C\u5FA8\u5FAD\u5FB5\u5FBC\u8862\u5F61\u72AD\u72B0\u72B4\u72B7\u72B8\u72C3\u72C1\u72CE\u72CD\u72D2\u72E8\u72EF\u72E9\u72F2\u72F4\u72F7\u7301\u72F3\u7303\u72FA"],
      ["e240", "\u91E6", 62],
      ["e280", "\u9225", 32, "\u72FB\u7317\u7313\u7321\u730A\u731E\u731D\u7315\u7322\u7339\u7325\u732C\u7338\u7331\u7350\u734D\u7357\u7360\u736C\u736F\u737E\u821B\u5925\u98E7\u5924\u5902\u9963\u9967", 5, "\u9974\u9977\u997D\u9980\u9984\u9987\u998A\u998D\u9990\u9991\u9993\u9994\u9995\u5E80\u5E91\u5E8B\u5E96\u5EA5\u5EA0\u5EB9\u5EB5\u5EBE\u5EB3\u8D53\u5ED2\u5ED1\u5EDB\u5EE8\u5EEA\u81BA\u5FC4\u5FC9\u5FD6\u5FCF\u6003\u5FEE\u6004\u5FE1\u5FE4\u5FFE\u6005\u6006\u5FEA\u5FED\u5FF8\u6019\u6035\u6026\u601B\u600F\u600D\u6029\u602B\u600A\u603F\u6021\u6078\u6079\u607B\u607A\u6042"],
      ["e340", "\u9246", 45, "\u9275", 16],
      ["e380", "\u9286", 7, "\u928F", 24, "\u606A\u607D\u6096\u609A\u60AD\u609D\u6083\u6092\u608C\u609B\u60EC\u60BB\u60B1\u60DD\u60D8\u60C6\u60DA\u60B4\u6120\u6126\u6115\u6123\u60F4\u6100\u610E\u612B\u614A\u6175\u61AC\u6194\u61A7\u61B7\u61D4\u61F5\u5FDD\u96B3\u95E9\u95EB\u95F1\u95F3\u95F5\u95F6\u95FC\u95FE\u9603\u9604\u9606\u9608\u960A\u960B\u960C\u960D\u960F\u9612\u9615\u9616\u9617\u9619\u961A\u4E2C\u723F\u6215\u6C35\u6C54\u6C5C\u6C4A\u6CA3\u6C85\u6C90\u6C94\u6C8C\u6C68\u6C69\u6C74\u6C76\u6C86\u6CA9\u6CD0\u6CD4\u6CAD\u6CF7\u6CF8\u6CF1\u6CD7\u6CB2\u6CE0\u6CD6\u6CFA\u6CEB\u6CEE\u6CB1\u6CD3\u6CEF\u6CFE"],
      ["e440", "\u92A8", 5, "\u92AF", 24, "\u92C9", 31],
      ["e480", "\u92E9", 32, "\u6D39\u6D27\u6D0C\u6D43\u6D48\u6D07\u6D04\u6D19\u6D0E\u6D2B\u6D4D\u6D2E\u6D35\u6D1A\u6D4F\u6D52\u6D54\u6D33\u6D91\u6D6F\u6D9E\u6DA0\u6D5E\u6D93\u6D94\u6D5C\u6D60\u6D7C\u6D63\u6E1A\u6DC7\u6DC5\u6DDE\u6E0E\u6DBF\u6DE0\u6E11\u6DE6\u6DDD\u6DD9\u6E16\u6DAB\u6E0C\u6DAE\u6E2B\u6E6E\u6E4E\u6E6B\u6EB2\u6E5F\u6E86\u6E53\u6E54\u6E32\u6E25\u6E44\u6EDF\u6EB1\u6E98\u6EE0\u6F2D\u6EE2\u6EA5\u6EA7\u6EBD\u6EBB\u6EB7\u6ED7\u6EB4\u6ECF\u6E8F\u6EC2\u6E9F\u6F62\u6F46\u6F47\u6F24\u6F15\u6EF9\u6F2F\u6F36\u6F4B\u6F74\u6F2A\u6F09\u6F29\u6F89\u6F8D\u6F8C\u6F78\u6F72\u6F7C\u6F7A\u6FD1"],
      ["e540", "\u930A", 51, "\u933F", 10],
      ["e580", "\u934A", 31, "\u936B\u6FC9\u6FA7\u6FB9\u6FB6\u6FC2\u6FE1\u6FEE\u6FDE\u6FE0\u6FEF\u701A\u7023\u701B\u7039\u7035\u704F\u705E\u5B80\u5B84\u5B95\u5B93\u5BA5\u5BB8\u752F\u9A9E\u6434\u5BE4\u5BEE\u8930\u5BF0\u8E47\u8B07\u8FB6\u8FD3\u8FD5\u8FE5\u8FEE\u8FE4\u8FE9\u8FE6\u8FF3\u8FE8\u9005\u9004\u900B\u9026\u9011\u900D\u9016\u9021\u9035\u9036\u902D\u902F\u9044\u9051\u9052\u9050\u9068\u9058\u9062\u905B\u66B9\u9074\u907D\u9082\u9088\u9083\u908B\u5F50\u5F57\u5F56\u5F58\u5C3B\u54AB\u5C50\u5C59\u5B71\u5C63\u5C66\u7FBC\u5F2A\u5F29\u5F2D\u8274\u5F3C\u9B3B\u5C6E\u5981\u5983\u598D\u59A9\u59AA\u59A3"],
      ["e640", "\u936C", 34, "\u9390", 27],
      ["e680", "\u93AC", 29, "\u93CB\u93CC\u93CD\u5997\u59CA\u59AB\u599E\u59A4\u59D2\u59B2\u59AF\u59D7\u59BE\u5A05\u5A06\u59DD\u5A08\u59E3\u59D8\u59F9\u5A0C\u5A09\u5A32\u5A34\u5A11\u5A23\u5A13\u5A40\u5A67\u5A4A\u5A55\u5A3C\u5A62\u5A75\u80EC\u5AAA\u5A9B\u5A77\u5A7A\u5ABE\u5AEB\u5AB2\u5AD2\u5AD4\u5AB8\u5AE0\u5AE3\u5AF1\u5AD6\u5AE6\u5AD8\u5ADC\u5B09\u5B17\u5B16\u5B32\u5B37\u5B40\u5C15\u5C1C\u5B5A\u5B65\u5B73\u5B51\u5B53\u5B62\u9A75\u9A77\u9A78\u9A7A\u9A7F\u9A7D\u9A80\u9A81\u9A85\u9A88\u9A8A\u9A90\u9A92\u9A93\u9A96\u9A98\u9A9B\u9A9C\u9A9D\u9A9F\u9AA0\u9AA2\u9AA3\u9AA5\u9AA7\u7E9F\u7EA1\u7EA3\u7EA5\u7EA8\u7EA9"],
      ["e740", "\u93CE", 7, "\u93D7", 54],
      ["e780", "\u940E", 32, "\u7EAD\u7EB0\u7EBE\u7EC0\u7EC1\u7EC2\u7EC9\u7ECB\u7ECC\u7ED0\u7ED4\u7ED7\u7EDB\u7EE0\u7EE1\u7EE8\u7EEB\u7EEE\u7EEF\u7EF1\u7EF2\u7F0D\u7EF6\u7EFA\u7EFB\u7EFE\u7F01\u7F02\u7F03\u7F07\u7F08\u7F0B\u7F0C\u7F0F\u7F11\u7F12\u7F17\u7F19\u7F1C\u7F1B\u7F1F\u7F21", 6, "\u7F2A\u7F2B\u7F2C\u7F2D\u7F2F", 4, "\u7F35\u5E7A\u757F\u5DDB\u753E\u9095\u738E\u7391\u73AE\u73A2\u739F\u73CF\u73C2\u73D1\u73B7\u73B3\u73C0\u73C9\u73C8\u73E5\u73D9\u987C\u740A\u73E9\u73E7\u73DE\u73BA\u73F2\u740F\u742A\u745B\u7426\u7425\u7428\u7430\u742E\u742C"],
      ["e840", "\u942F", 14, "\u943F", 43, "\u946C\u946D\u946E\u946F"],
      ["e880", "\u9470", 20, "\u9491\u9496\u9498\u94C7\u94CF\u94D3\u94D4\u94DA\u94E6\u94FB\u951C\u9520\u741B\u741A\u7441\u745C\u7457\u7455\u7459\u7477\u746D\u747E\u749C\u748E\u7480\u7481\u7487\u748B\u749E\u74A8\u74A9\u7490\u74A7\u74D2\u74BA\u97EA\u97EB\u97EC\u674C\u6753\u675E\u6748\u6769\u67A5\u6787\u676A\u6773\u6798\u67A7\u6775\u67A8\u679E\u67AD\u678B\u6777\u677C\u67F0\u6809\u67D8\u680A\u67E9\u67B0\u680C\u67D9\u67B5\u67DA\u67B3\u67DD\u6800\u67C3\u67B8\u67E2\u680E\u67C1\u67FD\u6832\u6833\u6860\u6861\u684E\u6862\u6844\u6864\u6883\u681D\u6855\u6866\u6841\u6867\u6840\u683E\u684A\u6849\u6829\u68B5\u688F\u6874\u6877\u6893\u686B\u68C2\u696E\u68FC\u691F\u6920\u68F9"],
      ["e940", "\u9527\u9533\u953D\u9543\u9548\u954B\u9555\u955A\u9560\u956E\u9574\u9575\u9577", 7, "\u9580", 42],
      ["e980", "\u95AB", 32, "\u6924\u68F0\u690B\u6901\u6957\u68E3\u6910\u6971\u6939\u6960\u6942\u695D\u6984\u696B\u6980\u6998\u6978\u6934\u69CC\u6987\u6988\u69CE\u6989\u6966\u6963\u6979\u699B\u69A7\u69BB\u69AB\u69AD\u69D4\u69B1\u69C1\u69CA\u69DF\u6995\u69E0\u698D\u69FF\u6A2F\u69ED\u6A17\u6A18\u6A65\u69F2\u6A44\u6A3E\u6AA0\u6A50\u6A5B\u6A35\u6A8E\u6A79\u6A3D\u6A28\u6A58\u6A7C\u6A91\u6A90\u6AA9\u6A97\u6AAB\u7337\u7352\u6B81\u6B82\u6B87\u6B84\u6B92\u6B93\u6B8D\u6B9A\u6B9B\u6BA1\u6BAA\u8F6B\u8F6D\u8F71\u8F72\u8F73\u8F75\u8F76\u8F78\u8F77\u8F79\u8F7A\u8F7C\u8F7E\u8F81\u8F82\u8F84\u8F87\u8F8B"],
      ["ea40", "\u95CC", 27, "\u95EC\u95FF\u9607\u9613\u9618\u961B\u961E\u9620\u9623", 6, "\u962B\u962C\u962D\u962F\u9630\u9637\u9638\u9639\u963A\u963E\u9641\u9643\u964A\u964E\u964F\u9651\u9652\u9653\u9656\u9657"],
      ["ea80", "\u9658\u9659\u965A\u965C\u965D\u965E\u9660\u9663\u9665\u9666\u966B\u966D", 4, "\u9673\u9678", 12, "\u9687\u9689\u968A\u8F8D\u8F8E\u8F8F\u8F98\u8F9A\u8ECE\u620B\u6217\u621B\u621F\u6222\u6221\u6225\u6224\u622C\u81E7\u74EF\u74F4\u74FF\u750F\u7511\u7513\u6534\u65EE\u65EF\u65F0\u660A\u6619\u6772\u6603\u6615\u6600\u7085\u66F7\u661D\u6634\u6631\u6636\u6635\u8006\u665F\u6654\u6641\u664F\u6656\u6661\u6657\u6677\u6684\u668C\u66A7\u669D\u66BE\u66DB\u66DC\u66E6\u66E9\u8D32\u8D33\u8D36\u8D3B\u8D3D\u8D40\u8D45\u8D46\u8D48\u8D49\u8D47\u8D4D\u8D55\u8D59\u89C7\u89CA\u89CB\u89CC\u89CE\u89CF\u89D0\u89D1\u726E\u729F\u725D\u7266\u726F\u727E\u727F\u7284\u728B\u728D\u728F\u7292\u6308\u6332\u63B0"],
      ["eb40", "\u968C\u968E\u9691\u9692\u9693\u9695\u9696\u969A\u969B\u969D", 9, "\u96A8", 7, "\u96B1\u96B2\u96B4\u96B5\u96B7\u96B8\u96BA\u96BB\u96BF\u96C2\u96C3\u96C8\u96CA\u96CB\u96D0\u96D1\u96D3\u96D4\u96D6", 9, "\u96E1", 6, "\u96EB"],
      ["eb80", "\u96EC\u96ED\u96EE\u96F0\u96F1\u96F2\u96F4\u96F5\u96F8\u96FA\u96FB\u96FC\u96FD\u96FF\u9702\u9703\u9705\u970A\u970B\u970C\u9710\u9711\u9712\u9714\u9715\u9717", 4, "\u971D\u971F\u9720\u643F\u64D8\u8004\u6BEA\u6BF3\u6BFD\u6BF5\u6BF9\u6C05\u6C07\u6C06\u6C0D\u6C15\u6C18\u6C19\u6C1A\u6C21\u6C29\u6C24\u6C2A\u6C32\u6535\u6555\u656B\u724D\u7252\u7256\u7230\u8662\u5216\u809F\u809C\u8093\u80BC\u670A\u80BD\u80B1\u80AB\u80AD\u80B4\u80B7\u80E7\u80E8\u80E9\u80EA\u80DB\u80C2\u80C4\u80D9\u80CD\u80D7\u6710\u80DD\u80EB\u80F1\u80F4\u80ED\u810D\u810E\u80F2\u80FC\u6715\u8112\u8C5A\u8136\u811E\u812C\u8118\u8132\u8148\u814C\u8153\u8174\u8159\u815A\u8171\u8160\u8169\u817C\u817D\u816D\u8167\u584D\u5AB5\u8188\u8182\u8191\u6ED5\u81A3\u81AA\u81CC\u6726\u81CA\u81BB"],
      ["ec40", "\u9721", 8, "\u972B\u972C\u972E\u972F\u9731\u9733", 4, "\u973A\u973B\u973C\u973D\u973F", 18, "\u9754\u9755\u9757\u9758\u975A\u975C\u975D\u975F\u9763\u9764\u9766\u9767\u9768\u976A", 7],
      ["ec80", "\u9772\u9775\u9777", 4, "\u977D", 7, "\u9786", 4, "\u978C\u978E\u978F\u9790\u9793\u9795\u9796\u9797\u9799", 4, "\u81C1\u81A6\u6B24\u6B37\u6B39\u6B43\u6B46\u6B59\u98D1\u98D2\u98D3\u98D5\u98D9\u98DA\u6BB3\u5F40\u6BC2\u89F3\u6590\u9F51\u6593\u65BC\u65C6\u65C4\u65C3\u65CC\u65CE\u65D2\u65D6\u7080\u709C\u7096\u709D\u70BB\u70C0\u70B7\u70AB\u70B1\u70E8\u70CA\u7110\u7113\u7116\u712F\u7131\u7173\u715C\u7168\u7145\u7172\u714A\u7178\u717A\u7198\u71B3\u71B5\u71A8\u71A0\u71E0\u71D4\u71E7\u71F9\u721D\u7228\u706C\u7118\u7166\u71B9\u623E\u623D\u6243\u6248\u6249\u793B\u7940\u7946\u7949\u795B\u795C\u7953\u795A\u7962\u7957\u7960\u796F\u7967\u797A\u7985\u798A\u799A\u79A7\u79B3\u5FD1\u5FD0"],
      ["ed40", "\u979E\u979F\u97A1\u97A2\u97A4", 6, "\u97AC\u97AE\u97B0\u97B1\u97B3\u97B5", 46],
      ["ed80", "\u97E4\u97E5\u97E8\u97EE", 4, "\u97F4\u97F7", 23, "\u603C\u605D\u605A\u6067\u6041\u6059\u6063\u60AB\u6106\u610D\u615D\u61A9\u619D\u61CB\u61D1\u6206\u8080\u807F\u6C93\u6CF6\u6DFC\u77F6\u77F8\u7800\u7809\u7817\u7818\u7811\u65AB\u782D\u781C\u781D\u7839\u783A\u783B\u781F\u783C\u7825\u782C\u7823\u7829\u784E\u786D\u7856\u7857\u7826\u7850\u7847\u784C\u786A\u789B\u7893\u789A\u7887\u789C\u78A1\u78A3\u78B2\u78B9\u78A5\u78D4\u78D9\u78C9\u78EC\u78F2\u7905\u78F4\u7913\u7924\u791E\u7934\u9F9B\u9EF9\u9EFB\u9EFC\u76F1\u7704\u770D\u76F9\u7707\u7708\u771A\u7722\u7719\u772D\u7726\u7735\u7738\u7750\u7751\u7747\u7743\u775A\u7768"],
      ["ee40", "\u980F", 62],
      ["ee80", "\u984E", 32, "\u7762\u7765\u777F\u778D\u777D\u7780\u778C\u7791\u779F\u77A0\u77B0\u77B5\u77BD\u753A\u7540\u754E\u754B\u7548\u755B\u7572\u7579\u7583\u7F58\u7F61\u7F5F\u8A48\u7F68\u7F74\u7F71\u7F79\u7F81\u7F7E\u76CD\u76E5\u8832\u9485\u9486\u9487\u948B\u948A\u948C\u948D\u948F\u9490\u9494\u9497\u9495\u949A\u949B\u949C\u94A3\u94A4\u94AB\u94AA\u94AD\u94AC\u94AF\u94B0\u94B2\u94B4\u94B6", 4, "\u94BC\u94BD\u94BF\u94C4\u94C8", 6, "\u94D0\u94D1\u94D2\u94D5\u94D6\u94D7\u94D9\u94D8\u94DB\u94DE\u94DF\u94E0\u94E2\u94E4\u94E5\u94E7\u94E8\u94EA"],
      ["ef40", "\u986F", 5, "\u988B\u988E\u9892\u9895\u9899\u98A3\u98A8", 37, "\u98CF\u98D0\u98D4\u98D6\u98D7\u98DB\u98DC\u98DD\u98E0", 4],
      ["ef80", "\u98E5\u98E6\u98E9", 30, "\u94E9\u94EB\u94EE\u94EF\u94F3\u94F4\u94F5\u94F7\u94F9\u94FC\u94FD\u94FF\u9503\u9502\u9506\u9507\u9509\u950A\u950D\u950E\u950F\u9512", 4, "\u9518\u951B\u951D\u951E\u951F\u9522\u952A\u952B\u9529\u952C\u9531\u9532\u9534\u9536\u9537\u9538\u953C\u953E\u953F\u9542\u9535\u9544\u9545\u9546\u9549\u954C\u954E\u954F\u9552\u9553\u9554\u9556\u9557\u9558\u9559\u955B\u955E\u955F\u955D\u9561\u9562\u9564", 8, "\u956F\u9571\u9572\u9573\u953A\u77E7\u77EC\u96C9\u79D5\u79ED\u79E3\u79EB\u7A06\u5D47\u7A03\u7A02\u7A1E\u7A14"],
      ["f040", "\u9908", 4, "\u990E\u990F\u9911", 28, "\u992F", 26],
      ["f080", "\u994A", 9, "\u9956", 12, "\u9964\u9966\u9973\u9978\u9979\u997B\u997E\u9982\u9983\u9989\u7A39\u7A37\u7A51\u9ECF\u99A5\u7A70\u7688\u768E\u7693\u7699\u76A4\u74DE\u74E0\u752C\u9E20\u9E22\u9E28", 4, "\u9E32\u9E31\u9E36\u9E38\u9E37\u9E39\u9E3A\u9E3E\u9E41\u9E42\u9E44\u9E46\u9E47\u9E48\u9E49\u9E4B\u9E4C\u9E4E\u9E51\u9E55\u9E57\u9E5A\u9E5B\u9E5C\u9E5E\u9E63\u9E66", 6, "\u9E71\u9E6D\u9E73\u7592\u7594\u7596\u75A0\u759D\u75AC\u75A3\u75B3\u75B4\u75B8\u75C4\u75B1\u75B0\u75C3\u75C2\u75D6\u75CD\u75E3\u75E8\u75E6\u75E4\u75EB\u75E7\u7603\u75F1\u75FC\u75FF\u7610\u7600\u7605\u760C\u7617\u760A\u7625\u7618\u7615\u7619"],
      ["f140", "\u998C\u998E\u999A", 10, "\u99A6\u99A7\u99A9", 47],
      ["f180", "\u99D9", 32, "\u761B\u763C\u7622\u7620\u7640\u762D\u7630\u763F\u7635\u7643\u763E\u7633\u764D\u765E\u7654\u765C\u7656\u766B\u766F\u7FCA\u7AE6\u7A78\u7A79\u7A80\u7A86\u7A88\u7A95\u7AA6\u7AA0\u7AAC\u7AA8\u7AAD\u7AB3\u8864\u8869\u8872\u887D\u887F\u8882\u88A2\u88C6\u88B7\u88BC\u88C9\u88E2\u88CE\u88E3\u88E5\u88F1\u891A\u88FC\u88E8\u88FE\u88F0\u8921\u8919\u8913\u891B\u890A\u8934\u892B\u8936\u8941\u8966\u897B\u758B\u80E5\u76B2\u76B4\u77DC\u8012\u8014\u8016\u801C\u8020\u8022\u8025\u8026\u8027\u8029\u8028\u8031\u800B\u8035\u8043\u8046\u804D\u8052\u8069\u8071\u8983\u9878\u9880\u9883"],
      ["f240", "\u99FA", 62],
      ["f280", "\u9A39", 32, "\u9889\u988C\u988D\u988F\u9894\u989A\u989B\u989E\u989F\u98A1\u98A2\u98A5\u98A6\u864D\u8654\u866C\u866E\u867F\u867A\u867C\u867B\u86A8\u868D\u868B\u86AC\u869D\u86A7\u86A3\u86AA\u8693\u86A9\u86B6\u86C4\u86B5\u86CE\u86B0\u86BA\u86B1\u86AF\u86C9\u86CF\u86B4\u86E9\u86F1\u86F2\u86ED\u86F3\u86D0\u8713\u86DE\u86F4\u86DF\u86D8\u86D1\u8703\u8707\u86F8\u8708\u870A\u870D\u8709\u8723\u873B\u871E\u8725\u872E\u871A\u873E\u8748\u8734\u8731\u8729\u8737\u873F\u8782\u8722\u877D\u877E\u877B\u8760\u8770\u874C\u876E\u878B\u8753\u8763\u877C\u8764\u8759\u8765\u8793\u87AF\u87A8\u87D2"],
      ["f340", "\u9A5A", 17, "\u9A72\u9A83\u9A89\u9A8D\u9A8E\u9A94\u9A95\u9A99\u9AA6\u9AA9", 6, "\u9AB2\u9AB3\u9AB4\u9AB5\u9AB9\u9ABB\u9ABD\u9ABE\u9ABF\u9AC3\u9AC4\u9AC6", 4, "\u9ACD\u9ACE\u9ACF\u9AD0\u9AD2\u9AD4\u9AD5\u9AD6\u9AD7\u9AD9\u9ADA\u9ADB\u9ADC"],
      ["f380", "\u9ADD\u9ADE\u9AE0\u9AE2\u9AE3\u9AE4\u9AE5\u9AE7\u9AE8\u9AE9\u9AEA\u9AEC\u9AEE\u9AF0", 8, "\u9AFA\u9AFC", 6, "\u9B04\u9B05\u9B06\u87C6\u8788\u8785\u87AD\u8797\u8783\u87AB\u87E5\u87AC\u87B5\u87B3\u87CB\u87D3\u87BD\u87D1\u87C0\u87CA\u87DB\u87EA\u87E0\u87EE\u8816\u8813\u87FE\u880A\u881B\u8821\u8839\u883C\u7F36\u7F42\u7F44\u7F45\u8210\u7AFA\u7AFD\u7B08\u7B03\u7B04\u7B15\u7B0A\u7B2B\u7B0F\u7B47\u7B38\u7B2A\u7B19\u7B2E\u7B31\u7B20\u7B25\u7B24\u7B33\u7B3E\u7B1E\u7B58\u7B5A\u7B45\u7B75\u7B4C\u7B5D\u7B60\u7B6E\u7B7B\u7B62\u7B72\u7B71\u7B90\u7BA6\u7BA7\u7BB8\u7BAC\u7B9D\u7BA8\u7B85\u7BAA\u7B9C\u7BA2\u7BAB\u7BB4\u7BD1\u7BC1\u7BCC\u7BDD\u7BDA\u7BE5\u7BE6\u7BEA\u7C0C\u7BFE\u7BFC\u7C0F\u7C16\u7C0B"],
      ["f440", "\u9B07\u9B09", 5, "\u9B10\u9B11\u9B12\u9B14", 10, "\u9B20\u9B21\u9B22\u9B24", 10, "\u9B30\u9B31\u9B33", 7, "\u9B3D\u9B3E\u9B3F\u9B40\u9B46\u9B4A\u9B4B\u9B4C\u9B4E\u9B50\u9B52\u9B53\u9B55", 5],
      ["f480", "\u9B5B", 32, "\u7C1F\u7C2A\u7C26\u7C38\u7C41\u7C40\u81FE\u8201\u8202\u8204\u81EC\u8844\u8221\u8222\u8223\u822D\u822F\u8228\u822B\u8238\u823B\u8233\u8234\u823E\u8244\u8249\u824B\u824F\u825A\u825F\u8268\u887E\u8885\u8888\u88D8\u88DF\u895E\u7F9D\u7F9F\u7FA7\u7FAF\u7FB0\u7FB2\u7C7C\u6549\u7C91\u7C9D\u7C9C\u7C9E\u7CA2\u7CB2\u7CBC\u7CBD\u7CC1\u7CC7\u7CCC\u7CCD\u7CC8\u7CC5\u7CD7\u7CE8\u826E\u66A8\u7FBF\u7FCE\u7FD5\u7FE5\u7FE1\u7FE6\u7FE9\u7FEE\u7FF3\u7CF8\u7D77\u7DA6\u7DAE\u7E47\u7E9B\u9EB8\u9EB4\u8D73\u8D84\u8D94\u8D91\u8DB1\u8D67\u8D6D\u8C47\u8C49\u914A\u9150\u914E\u914F\u9164"],
      ["f540", "\u9B7C", 62],
      ["f580", "\u9BBB", 32, "\u9162\u9161\u9170\u9169\u916F\u917D\u917E\u9172\u9174\u9179\u918C\u9185\u9190\u918D\u9191\u91A2\u91A3\u91AA\u91AD\u91AE\u91AF\u91B5\u91B4\u91BA\u8C55\u9E7E\u8DB8\u8DEB\u8E05\u8E59\u8E69\u8DB5\u8DBF\u8DBC\u8DBA\u8DC4\u8DD6\u8DD7\u8DDA\u8DDE\u8DCE\u8DCF\u8DDB\u8DC6\u8DEC\u8DF7\u8DF8\u8DE3\u8DF9\u8DFB\u8DE4\u8E09\u8DFD\u8E14\u8E1D\u8E1F\u8E2C\u8E2E\u8E23\u8E2F\u8E3A\u8E40\u8E39\u8E35\u8E3D\u8E31\u8E49\u8E41\u8E42\u8E51\u8E52\u8E4A\u8E70\u8E76\u8E7C\u8E6F\u8E74\u8E85\u8E8F\u8E94\u8E90\u8E9C\u8E9E\u8C78\u8C82\u8C8A\u8C85\u8C98\u8C94\u659B\u89D6\u89DE\u89DA\u89DC"],
      ["f640", "\u9BDC", 62],
      ["f680", "\u9C1B", 32, "\u89E5\u89EB\u89EF\u8A3E\u8B26\u9753\u96E9\u96F3\u96EF\u9706\u9701\u9708\u970F\u970E\u972A\u972D\u9730\u973E\u9F80\u9F83\u9F85", 5, "\u9F8C\u9EFE\u9F0B\u9F0D\u96B9\u96BC\u96BD\u96CE\u96D2\u77BF\u96E0\u928E\u92AE\u92C8\u933E\u936A\u93CA\u938F\u943E\u946B\u9C7F\u9C82\u9C85\u9C86\u9C87\u9C88\u7A23\u9C8B\u9C8E\u9C90\u9C91\u9C92\u9C94\u9C95\u9C9A\u9C9B\u9C9E", 5, "\u9CA5", 4, "\u9CAB\u9CAD\u9CAE\u9CB0", 7, "\u9CBA\u9CBB\u9CBC\u9CBD\u9CC4\u9CC5\u9CC6\u9CC7\u9CCA\u9CCB"],
      ["f740", "\u9C3C", 62],
      ["f780", "\u9C7B\u9C7D\u9C7E\u9C80\u9C83\u9C84\u9C89\u9C8A\u9C8C\u9C8F\u9C93\u9C96\u9C97\u9C98\u9C99\u9C9D\u9CAA\u9CAC\u9CAF\u9CB9\u9CBE", 4, "\u9CC8\u9CC9\u9CD1\u9CD2\u9CDA\u9CDB\u9CE0\u9CE1\u9CCC", 4, "\u9CD3\u9CD4\u9CD5\u9CD7\u9CD8\u9CD9\u9CDC\u9CDD\u9CDF\u9CE2\u977C\u9785\u9791\u9792\u9794\u97AF\u97AB\u97A3\u97B2\u97B4\u9AB1\u9AB0\u9AB7\u9E58\u9AB6\u9ABA\u9ABC\u9AC1\u9AC0\u9AC5\u9AC2\u9ACB\u9ACC\u9AD1\u9B45\u9B43\u9B47\u9B49\u9B48\u9B4D\u9B51\u98E8\u990D\u992E\u9955\u9954\u9ADF\u9AE1\u9AE6\u9AEF\u9AEB\u9AFB\u9AED\u9AF9\u9B08\u9B0F\u9B13\u9B1F\u9B23\u9EBD\u9EBE\u7E3B\u9E82\u9E87\u9E88\u9E8B\u9E92\u93D6\u9E9D\u9E9F\u9EDB\u9EDC\u9EDD\u9EE0\u9EDF\u9EE2\u9EE9\u9EE7\u9EE5\u9EEA\u9EEF\u9F22\u9F2C\u9F2F\u9F39\u9F37\u9F3D\u9F3E\u9F44"],
      ["f840", "\u9CE3", 62],
      ["f880", "\u9D22", 32],
      ["f940", "\u9D43", 62],
      ["f980", "\u9D82", 32],
      ["fa40", "\u9DA3", 62],
      ["fa80", "\u9DE2", 32],
      ["fb40", "\u9E03", 27, "\u9E24\u9E27\u9E2E\u9E30\u9E34\u9E3B\u9E3C\u9E40\u9E4D\u9E50\u9E52\u9E53\u9E54\u9E56\u9E59\u9E5D\u9E5F\u9E60\u9E61\u9E62\u9E65\u9E6E\u9E6F\u9E72\u9E74", 9, "\u9E80"],
      ["fb80", "\u9E81\u9E83\u9E84\u9E85\u9E86\u9E89\u9E8A\u9E8C", 5, "\u9E94", 8, "\u9E9E\u9EA0", 5, "\u9EA7\u9EA8\u9EA9\u9EAA"],
      ["fc40", "\u9EAB", 8, "\u9EB5\u9EB6\u9EB7\u9EB9\u9EBA\u9EBC\u9EBF", 4, "\u9EC5\u9EC6\u9EC7\u9EC8\u9ECA\u9ECB\u9ECC\u9ED0\u9ED2\u9ED3\u9ED5\u9ED6\u9ED7\u9ED9\u9EDA\u9EDE\u9EE1\u9EE3\u9EE4\u9EE6\u9EE8\u9EEB\u9EEC\u9EED\u9EEE\u9EF0", 8, "\u9EFA\u9EFD\u9EFF", 6],
      ["fc80", "\u9F06", 4, "\u9F0C\u9F0F\u9F11\u9F12\u9F14\u9F15\u9F16\u9F18\u9F1A", 5, "\u9F21\u9F23", 8, "\u9F2D\u9F2E\u9F30\u9F31"],
      ["fd40", "\u9F32", 4, "\u9F38\u9F3A\u9F3C\u9F3F", 4, "\u9F45", 10, "\u9F52", 38],
      ["fd80", "\u9F79", 5, "\u9F81\u9F82\u9F8D", 11, "\u9F9C\u9F9D\u9F9E\u9FA1", 4, "\uF92C\uF979\uF995\uF9E7\uF9F1"],
      ["fe40", "\uFA0C\uFA0D\uFA0E\uFA0F\uFA11\uFA13\uFA14\uFA18\uFA1F\uFA20\uFA21\uFA23\uFA24\uFA27\uFA28\uFA29"]
    ];
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/tables/gbk-added.json
var require_gbk_added = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/tables/gbk-added.json"(exports, module) {
    module.exports = [
      ["a140", "\uE4C6", 62],
      ["a180", "\uE505", 32],
      ["a240", "\uE526", 62],
      ["a280", "\uE565", 32],
      ["a2ab", "\uE766", 5],
      ["a2e3", "\u20AC\uE76D"],
      ["a2ef", "\uE76E\uE76F"],
      ["a2fd", "\uE770\uE771"],
      ["a340", "\uE586", 62],
      ["a380", "\uE5C5", 31, "\u3000"],
      ["a440", "\uE5E6", 62],
      ["a480", "\uE625", 32],
      ["a4f4", "\uE772", 10],
      ["a540", "\uE646", 62],
      ["a580", "\uE685", 32],
      ["a5f7", "\uE77D", 7],
      ["a640", "\uE6A6", 62],
      ["a680", "\uE6E5", 32],
      ["a6b9", "\uE785", 7],
      ["a6d9", "\uE78D", 6],
      ["a6ec", "\uE794\uE795"],
      ["a6f3", "\uE796"],
      ["a6f6", "\uE797", 8],
      ["a740", "\uE706", 62],
      ["a780", "\uE745", 32],
      ["a7c2", "\uE7A0", 14],
      ["a7f2", "\uE7AF", 12],
      ["a896", "\uE7BC", 10],
      ["a8bc", "\uE7C7"],
      ["a8bf", "\u01F9"],
      ["a8c1", "\uE7C9\uE7CA\uE7CB\uE7CC"],
      ["a8ea", "\uE7CD", 20],
      ["a958", "\uE7E2"],
      ["a95b", "\uE7E3"],
      ["a95d", "\uE7E4\uE7E5\uE7E6"],
      ["a989", "\u303E\u2FF0", 11],
      ["a997", "\uE7F4", 12],
      ["a9f0", "\uE801", 14],
      ["aaa1", "\uE000", 93],
      ["aba1", "\uE05E", 93],
      ["aca1", "\uE0BC", 93],
      ["ada1", "\uE11A", 93],
      ["aea1", "\uE178", 93],
      ["afa1", "\uE1D6", 93],
      ["d7fa", "\uE810", 4],
      ["f8a1", "\uE234", 93],
      ["f9a1", "\uE292", 93],
      ["faa1", "\uE2F0", 93],
      ["fba1", "\uE34E", 93],
      ["fca1", "\uE3AC", 93],
      ["fda1", "\uE40A", 93],
      ["fe50", "\u2E81\uE816\uE817\uE818\u2E84\u3473\u3447\u2E88\u2E8B\uE81E\u359E\u361A\u360E\u2E8C\u2E97\u396E\u3918\uE826\u39CF\u39DF\u3A73\u39D0\uE82B\uE82C\u3B4E\u3C6E\u3CE0\u2EA7\uE831\uE832\u2EAA\u4056\u415F\u2EAE\u4337\u2EB3\u2EB6\u2EB7\uE83B\u43B1\u43AC\u2EBB\u43DD\u44D6\u4661\u464C\uE843"],
      ["fe80", "\u4723\u4729\u477C\u478D\u2ECA\u4947\u497A\u497D\u4982\u4983\u4985\u4986\u499F\u499B\u49B7\u49B6\uE854\uE855\u4CA3\u4C9F\u4CA0\u4CA1\u4C77\u4CA2\u4D13", 6, "\u4DAE\uE864\uE468", 93]
    ];
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/tables/gb18030-ranges.json
var require_gb18030_ranges = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/tables/gb18030-ranges.json"(exports, module) {
    module.exports = { uChars: [128, 165, 169, 178, 184, 216, 226, 235, 238, 244, 248, 251, 253, 258, 276, 284, 300, 325, 329, 334, 364, 463, 465, 467, 469, 471, 473, 475, 477, 506, 594, 610, 712, 716, 730, 930, 938, 962, 970, 1026, 1104, 1106, 8209, 8215, 8218, 8222, 8231, 8241, 8244, 8246, 8252, 8365, 8452, 8454, 8458, 8471, 8482, 8556, 8570, 8596, 8602, 8713, 8720, 8722, 8726, 8731, 8737, 8740, 8742, 8748, 8751, 8760, 8766, 8777, 8781, 8787, 8802, 8808, 8816, 8854, 8858, 8870, 8896, 8979, 9322, 9372, 9548, 9588, 9616, 9622, 9634, 9652, 9662, 9672, 9676, 9680, 9702, 9735, 9738, 9793, 9795, 11906, 11909, 11913, 11917, 11928, 11944, 11947, 11951, 11956, 11960, 11964, 11979, 12284, 12292, 12312, 12319, 12330, 12351, 12436, 12447, 12535, 12543, 12586, 12842, 12850, 12964, 13200, 13215, 13218, 13253, 13263, 13267, 13270, 13384, 13428, 13727, 13839, 13851, 14617, 14703, 14801, 14816, 14964, 15183, 15471, 15585, 16471, 16736, 17208, 17325, 17330, 17374, 17623, 17997, 18018, 18212, 18218, 18301, 18318, 18760, 18811, 18814, 18820, 18823, 18844, 18848, 18872, 19576, 19620, 19738, 19887, 40870, 59244, 59336, 59367, 59413, 59417, 59423, 59431, 59437, 59443, 59452, 59460, 59478, 59493, 63789, 63866, 63894, 63976, 63986, 64016, 64018, 64021, 64025, 64034, 64037, 64042, 65074, 65093, 65107, 65112, 65127, 65132, 65375, 65510, 65536], gbChars: [0, 36, 38, 45, 50, 81, 89, 95, 96, 100, 103, 104, 105, 109, 126, 133, 148, 172, 175, 179, 208, 306, 307, 308, 309, 310, 311, 312, 313, 341, 428, 443, 544, 545, 558, 741, 742, 749, 750, 805, 819, 820, 7922, 7924, 7925, 7927, 7934, 7943, 7944, 7945, 7950, 8062, 8148, 8149, 8152, 8164, 8174, 8236, 8240, 8262, 8264, 8374, 8380, 8381, 8384, 8388, 8390, 8392, 8393, 8394, 8396, 8401, 8406, 8416, 8419, 8424, 8437, 8439, 8445, 8482, 8485, 8496, 8521, 8603, 8936, 8946, 9046, 9050, 9063, 9066, 9076, 9092, 9100, 9108, 9111, 9113, 9131, 9162, 9164, 9218, 9219, 11329, 11331, 11334, 11336, 11346, 11361, 11363, 11366, 11370, 11372, 11375, 11389, 11682, 11686, 11687, 11692, 11694, 11714, 11716, 11723, 11725, 11730, 11736, 11982, 11989, 12102, 12336, 12348, 12350, 12384, 12393, 12395, 12397, 12510, 12553, 12851, 12962, 12973, 13738, 13823, 13919, 13933, 14080, 14298, 14585, 14698, 15583, 15847, 16318, 16434, 16438, 16481, 16729, 17102, 17122, 17315, 17320, 17402, 17418, 17859, 17909, 17911, 17915, 17916, 17936, 17939, 17961, 18664, 18703, 18814, 18962, 19043, 33469, 33470, 33471, 33484, 33485, 33490, 33497, 33501, 33505, 33513, 33520, 33536, 33550, 37845, 37921, 37948, 38029, 38038, 38064, 38065, 38066, 38069, 38075, 38076, 38078, 39108, 39109, 39113, 39114, 39115, 39116, 39265, 39394, 189e3] };
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/tables/cp949.json
var require_cp949 = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/tables/cp949.json"(exports, module) {
    module.exports = [
      ["0", "\0", 127],
      ["8141", "\uAC02\uAC03\uAC05\uAC06\uAC0B", 4, "\uAC18\uAC1E\uAC1F\uAC21\uAC22\uAC23\uAC25", 6, "\uAC2E\uAC32\uAC33\uAC34"],
      ["8161", "\uAC35\uAC36\uAC37\uAC3A\uAC3B\uAC3D\uAC3E\uAC3F\uAC41", 9, "\uAC4C\uAC4E", 5, "\uAC55"],
      ["8181", "\uAC56\uAC57\uAC59\uAC5A\uAC5B\uAC5D", 18, "\uAC72\uAC73\uAC75\uAC76\uAC79\uAC7B", 4, "\uAC82\uAC87\uAC88\uAC8D\uAC8E\uAC8F\uAC91\uAC92\uAC93\uAC95", 6, "\uAC9E\uACA2", 5, "\uACAB\uACAD\uACAE\uACB1", 6, "\uACBA\uACBE\uACBF\uACC0\uACC2\uACC3\uACC5\uACC6\uACC7\uACC9\uACCA\uACCB\uACCD", 7, "\uACD6\uACD8", 7, "\uACE2\uACE3\uACE5\uACE6\uACE9\uACEB\uACED\uACEE\uACF2\uACF4\uACF7", 4, "\uACFE\uACFF\uAD01\uAD02\uAD03\uAD05\uAD07", 4, "\uAD0E\uAD10\uAD12\uAD13"],
      ["8241", "\uAD14\uAD15\uAD16\uAD17\uAD19\uAD1A\uAD1B\uAD1D\uAD1E\uAD1F\uAD21", 7, "\uAD2A\uAD2B\uAD2E", 5],
      ["8261", "\uAD36\uAD37\uAD39\uAD3A\uAD3B\uAD3D", 6, "\uAD46\uAD48\uAD4A", 5, "\uAD51\uAD52\uAD53\uAD55\uAD56\uAD57"],
      ["8281", "\uAD59", 7, "\uAD62\uAD64", 7, "\uAD6E\uAD6F\uAD71\uAD72\uAD77\uAD78\uAD79\uAD7A\uAD7E\uAD80\uAD83", 4, "\uAD8A\uAD8B\uAD8D\uAD8E\uAD8F\uAD91", 10, "\uAD9E", 5, "\uADA5", 17, "\uADB8", 7, "\uADC2\uADC3\uADC5\uADC6\uADC7\uADC9", 6, "\uADD2\uADD4", 7, "\uADDD\uADDE\uADDF\uADE1\uADE2\uADE3\uADE5", 18],
      ["8341", "\uADFA\uADFB\uADFD\uADFE\uAE02", 5, "\uAE0A\uAE0C\uAE0E", 5, "\uAE15", 7],
      ["8361", "\uAE1D", 18, "\uAE32\uAE33\uAE35\uAE36\uAE39\uAE3B\uAE3C"],
      ["8381", "\uAE3D\uAE3E\uAE3F\uAE42\uAE44\uAE47\uAE48\uAE49\uAE4B\uAE4F\uAE51\uAE52\uAE53\uAE55\uAE57", 4, "\uAE5E\uAE62\uAE63\uAE64\uAE66\uAE67\uAE6A\uAE6B\uAE6D\uAE6E\uAE6F\uAE71", 6, "\uAE7A\uAE7E", 5, "\uAE86", 5, "\uAE8D", 46, "\uAEBF\uAEC1\uAEC2\uAEC3\uAEC5", 6, "\uAECE\uAED2", 5, "\uAEDA\uAEDB\uAEDD", 8],
      ["8441", "\uAEE6\uAEE7\uAEE9\uAEEA\uAEEC\uAEEE", 5, "\uAEF5\uAEF6\uAEF7\uAEF9\uAEFA\uAEFB\uAEFD", 8],
      ["8461", "\uAF06\uAF09\uAF0A\uAF0B\uAF0C\uAF0E\uAF0F\uAF11", 18],
      ["8481", "\uAF24", 7, "\uAF2E\uAF2F\uAF31\uAF33\uAF35", 6, "\uAF3E\uAF40\uAF44\uAF45\uAF46\uAF47\uAF4A", 5, "\uAF51", 10, "\uAF5E", 5, "\uAF66", 18, "\uAF7A", 5, "\uAF81\uAF82\uAF83\uAF85\uAF86\uAF87\uAF89", 6, "\uAF92\uAF93\uAF94\uAF96", 5, "\uAF9D", 26, "\uAFBA\uAFBB\uAFBD\uAFBE"],
      ["8541", "\uAFBF\uAFC1", 5, "\uAFCA\uAFCC\uAFCF", 4, "\uAFD5", 6, "\uAFDD", 4],
      ["8561", "\uAFE2", 5, "\uAFEA", 5, "\uAFF2\uAFF3\uAFF5\uAFF6\uAFF7\uAFF9", 6, "\uB002\uB003"],
      ["8581", "\uB005", 6, "\uB00D\uB00E\uB00F\uB011\uB012\uB013\uB015", 6, "\uB01E", 9, "\uB029", 26, "\uB046\uB047\uB049\uB04B\uB04D\uB04F\uB050\uB051\uB052\uB056\uB058\uB05A\uB05B\uB05C\uB05E", 29, "\uB07E\uB07F\uB081\uB082\uB083\uB085", 6, "\uB08E\uB090\uB092", 5, "\uB09B\uB09D\uB09E\uB0A3\uB0A4"],
      ["8641", "\uB0A5\uB0A6\uB0A7\uB0AA\uB0B0\uB0B2\uB0B6\uB0B7\uB0B9\uB0BA\uB0BB\uB0BD", 6, "\uB0C6\uB0CA", 5, "\uB0D2"],
      ["8661", "\uB0D3\uB0D5\uB0D6\uB0D7\uB0D9", 6, "\uB0E1\uB0E2\uB0E3\uB0E4\uB0E6", 10],
      ["8681", "\uB0F1", 22, "\uB10A\uB10D\uB10E\uB10F\uB111\uB114\uB115\uB116\uB117\uB11A\uB11E", 4, "\uB126\uB127\uB129\uB12A\uB12B\uB12D", 6, "\uB136\uB13A", 5, "\uB142\uB143\uB145\uB146\uB147\uB149", 6, "\uB152\uB153\uB156\uB157\uB159\uB15A\uB15B\uB15D\uB15E\uB15F\uB161", 22, "\uB17A\uB17B\uB17D\uB17E\uB17F\uB181\uB183", 4, "\uB18A\uB18C\uB18E\uB18F\uB190\uB191\uB195\uB196\uB197\uB199\uB19A\uB19B\uB19D"],
      ["8741", "\uB19E", 9, "\uB1A9", 15],
      ["8761", "\uB1B9", 18, "\uB1CD\uB1CE\uB1CF\uB1D1\uB1D2\uB1D3\uB1D5"],
      ["8781", "\uB1D6", 5, "\uB1DE\uB1E0", 7, "\uB1EA\uB1EB\uB1ED\uB1EE\uB1EF\uB1F1", 7, "\uB1FA\uB1FC\uB1FE", 5, "\uB206\uB207\uB209\uB20A\uB20D", 6, "\uB216\uB218\uB21A", 5, "\uB221", 18, "\uB235", 6, "\uB23D", 26, "\uB259\uB25A\uB25B\uB25D\uB25E\uB25F\uB261", 6, "\uB26A", 4],
      ["8841", "\uB26F", 4, "\uB276", 5, "\uB27D", 6, "\uB286\uB287\uB288\uB28A", 4],
      ["8861", "\uB28F\uB292\uB293\uB295\uB296\uB297\uB29B", 4, "\uB2A2\uB2A4\uB2A7\uB2A8\uB2A9\uB2AB\uB2AD\uB2AE\uB2AF\uB2B1\uB2B2\uB2B3\uB2B5\uB2B6\uB2B7"],
      ["8881", "\uB2B8", 15, "\uB2CA\uB2CB\uB2CD\uB2CE\uB2CF\uB2D1\uB2D3", 4, "\uB2DA\uB2DC\uB2DE\uB2DF\uB2E0\uB2E1\uB2E3\uB2E7\uB2E9\uB2EA\uB2F0\uB2F1\uB2F2\uB2F6\uB2FC\uB2FD\uB2FE\uB302\uB303\uB305\uB306\uB307\uB309", 6, "\uB312\uB316", 5, "\uB31D", 54, "\uB357\uB359\uB35A\uB35D\uB360\uB361\uB362\uB363"],
      ["8941", "\uB366\uB368\uB36A\uB36C\uB36D\uB36F\uB372\uB373\uB375\uB376\uB377\uB379", 6, "\uB382\uB386", 5, "\uB38D"],
      ["8961", "\uB38E\uB38F\uB391\uB392\uB393\uB395", 10, "\uB3A2", 5, "\uB3A9\uB3AA\uB3AB\uB3AD"],
      ["8981", "\uB3AE", 21, "\uB3C6\uB3C7\uB3C9\uB3CA\uB3CD\uB3CF\uB3D1\uB3D2\uB3D3\uB3D6\uB3D8\uB3DA\uB3DC\uB3DE\uB3DF\uB3E1\uB3E2\uB3E3\uB3E5\uB3E6\uB3E7\uB3E9", 18, "\uB3FD", 18, "\uB411", 6, "\uB419\uB41A\uB41B\uB41D\uB41E\uB41F\uB421", 6, "\uB42A\uB42C", 7, "\uB435", 15],
      ["8a41", "\uB445", 10, "\uB452\uB453\uB455\uB456\uB457\uB459", 6, "\uB462\uB464\uB466"],
      ["8a61", "\uB467", 4, "\uB46D", 18, "\uB481\uB482"],
      ["8a81", "\uB483", 4, "\uB489", 19, "\uB49E", 5, "\uB4A5\uB4A6\uB4A7\uB4A9\uB4AA\uB4AB\uB4AD", 7, "\uB4B6\uB4B8\uB4BA", 5, "\uB4C1\uB4C2\uB4C3\uB4C5\uB4C6\uB4C7\uB4C9", 6, "\uB4D1\uB4D2\uB4D3\uB4D4\uB4D6", 5, "\uB4DE\uB4DF\uB4E1\uB4E2\uB4E5\uB4E7", 4, "\uB4EE\uB4F0\uB4F2", 5, "\uB4F9", 26, "\uB516\uB517\uB519\uB51A\uB51D"],
      ["8b41", "\uB51E", 5, "\uB526\uB52B", 4, "\uB532\uB533\uB535\uB536\uB537\uB539", 6, "\uB542\uB546"],
      ["8b61", "\uB547\uB548\uB549\uB54A\uB54E\uB54F\uB551\uB552\uB553\uB555", 6, "\uB55E\uB562", 8],
      ["8b81", "\uB56B", 52, "\uB5A2\uB5A3\uB5A5\uB5A6\uB5A7\uB5A9\uB5AC\uB5AD\uB5AE\uB5AF\uB5B2\uB5B6", 4, "\uB5BE\uB5BF\uB5C1\uB5C2\uB5C3\uB5C5", 6, "\uB5CE\uB5D2", 5, "\uB5D9", 18, "\uB5ED", 18],
      ["8c41", "\uB600", 15, "\uB612\uB613\uB615\uB616\uB617\uB619", 4],
      ["8c61", "\uB61E", 6, "\uB626", 5, "\uB62D", 6, "\uB635", 5],
      ["8c81", "\uB63B", 12, "\uB649", 26, "\uB665\uB666\uB667\uB669", 50, "\uB69E\uB69F\uB6A1\uB6A2\uB6A3\uB6A5", 5, "\uB6AD\uB6AE\uB6AF\uB6B0\uB6B2", 16],
      ["8d41", "\uB6C3", 16, "\uB6D5", 8],
      ["8d61", "\uB6DE", 17, "\uB6F1\uB6F2\uB6F3\uB6F5\uB6F6\uB6F7\uB6F9\uB6FA"],
      ["8d81", "\uB6FB", 4, "\uB702\uB703\uB704\uB706", 33, "\uB72A\uB72B\uB72D\uB72E\uB731", 6, "\uB73A\uB73C", 7, "\uB745\uB746\uB747\uB749\uB74A\uB74B\uB74D", 6, "\uB756", 9, "\uB761\uB762\uB763\uB765\uB766\uB767\uB769", 6, "\uB772\uB774\uB776", 5, "\uB77E\uB77F\uB781\uB782\uB783\uB785", 6, "\uB78E\uB793\uB794\uB795\uB79A\uB79B\uB79D\uB79E"],
      ["8e41", "\uB79F\uB7A1", 6, "\uB7AA\uB7AE", 5, "\uB7B6\uB7B7\uB7B9", 8],
      ["8e61", "\uB7C2", 4, "\uB7C8\uB7CA", 19],
      ["8e81", "\uB7DE", 13, "\uB7EE\uB7EF\uB7F1\uB7F2\uB7F3\uB7F5", 6, "\uB7FE\uB802", 4, "\uB80A\uB80B\uB80D\uB80E\uB80F\uB811", 6, "\uB81A\uB81C\uB81E", 5, "\uB826\uB827\uB829\uB82A\uB82B\uB82D", 6, "\uB836\uB83A", 5, "\uB841\uB842\uB843\uB845", 11, "\uB852\uB854", 7, "\uB85E\uB85F\uB861\uB862\uB863\uB865", 6, "\uB86E\uB870\uB872", 5, "\uB879\uB87A\uB87B\uB87D", 7],
      ["8f41", "\uB885", 7, "\uB88E", 17],
      ["8f61", "\uB8A0", 7, "\uB8A9", 6, "\uB8B1\uB8B2\uB8B3\uB8B5\uB8B6\uB8B7\uB8B9", 4],
      ["8f81", "\uB8BE\uB8BF\uB8C2\uB8C4\uB8C6", 5, "\uB8CD\uB8CE\uB8CF\uB8D1\uB8D2\uB8D3\uB8D5", 7, "\uB8DE\uB8E0\uB8E2", 5, "\uB8EA\uB8EB\uB8ED\uB8EE\uB8EF\uB8F1", 6, "\uB8FA\uB8FC\uB8FE", 5, "\uB905", 18, "\uB919", 6, "\uB921", 26, "\uB93E\uB93F\uB941\uB942\uB943\uB945", 6, "\uB94D\uB94E\uB950\uB952", 5],
      ["9041", "\uB95A\uB95B\uB95D\uB95E\uB95F\uB961", 6, "\uB96A\uB96C\uB96E", 5, "\uB976\uB977\uB979\uB97A\uB97B\uB97D"],
      ["9061", "\uB97E", 5, "\uB986\uB988\uB98B\uB98C\uB98F", 15],
      ["9081", "\uB99F", 12, "\uB9AE\uB9AF\uB9B1\uB9B2\uB9B3\uB9B5", 6, "\uB9BE\uB9C0\uB9C2", 5, "\uB9CA\uB9CB\uB9CD\uB9D3", 4, "\uB9DA\uB9DC\uB9DF\uB9E0\uB9E2\uB9E6\uB9E7\uB9E9\uB9EA\uB9EB\uB9ED", 6, "\uB9F6\uB9FB", 4, "\uBA02", 5, "\uBA09", 11, "\uBA16", 33, "\uBA3A\uBA3B\uBA3D\uBA3E\uBA3F\uBA41\uBA43\uBA44\uBA45\uBA46"],
      ["9141", "\uBA47\uBA4A\uBA4C\uBA4F\uBA50\uBA51\uBA52\uBA56\uBA57\uBA59\uBA5A\uBA5B\uBA5D", 6, "\uBA66\uBA6A", 5],
      ["9161", "\uBA72\uBA73\uBA75\uBA76\uBA77\uBA79", 9, "\uBA86\uBA88\uBA89\uBA8A\uBA8B\uBA8D", 5],
      ["9181", "\uBA93", 20, "\uBAAA\uBAAD\uBAAE\uBAAF\uBAB1\uBAB3", 4, "\uBABA\uBABC\uBABE", 5, "\uBAC5\uBAC6\uBAC7\uBAC9", 14, "\uBADA", 33, "\uBAFD\uBAFE\uBAFF\uBB01\uBB02\uBB03\uBB05", 7, "\uBB0E\uBB10\uBB12", 5, "\uBB19\uBB1A\uBB1B\uBB1D\uBB1E\uBB1F\uBB21", 6],
      ["9241", "\uBB28\uBB2A\uBB2C", 7, "\uBB37\uBB39\uBB3A\uBB3F", 4, "\uBB46\uBB48\uBB4A\uBB4B\uBB4C\uBB4E\uBB51\uBB52"],
      ["9261", "\uBB53\uBB55\uBB56\uBB57\uBB59", 7, "\uBB62\uBB64", 7, "\uBB6D", 4],
      ["9281", "\uBB72", 21, "\uBB89\uBB8A\uBB8B\uBB8D\uBB8E\uBB8F\uBB91", 18, "\uBBA5\uBBA6\uBBA7\uBBA9\uBBAA\uBBAB\uBBAD", 6, "\uBBB5\uBBB6\uBBB8", 7, "\uBBC1\uBBC2\uBBC3\uBBC5\uBBC6\uBBC7\uBBC9", 6, "\uBBD1\uBBD2\uBBD4", 35, "\uBBFA\uBBFB\uBBFD\uBBFE\uBC01"],
      ["9341", "\uBC03", 4, "\uBC0A\uBC0E\uBC10\uBC12\uBC13\uBC19\uBC1A\uBC20\uBC21\uBC22\uBC23\uBC26\uBC28\uBC2A\uBC2B\uBC2C\uBC2E\uBC2F\uBC32\uBC33\uBC35"],
      ["9361", "\uBC36\uBC37\uBC39", 6, "\uBC42\uBC46\uBC47\uBC48\uBC4A\uBC4B\uBC4E\uBC4F\uBC51", 8],
      ["9381", "\uBC5A\uBC5B\uBC5C\uBC5E", 37, "\uBC86\uBC87\uBC89\uBC8A\uBC8D\uBC8F", 4, "\uBC96\uBC98\uBC9B", 4, "\uBCA2\uBCA3\uBCA5\uBCA6\uBCA9", 6, "\uBCB2\uBCB6", 5, "\uBCBE\uBCBF\uBCC1\uBCC2\uBCC3\uBCC5", 7, "\uBCCE\uBCD2\uBCD3\uBCD4\uBCD6\uBCD7\uBCD9\uBCDA\uBCDB\uBCDD", 22, "\uBCF7\uBCF9\uBCFA\uBCFB\uBCFD"],
      ["9441", "\uBCFE", 5, "\uBD06\uBD08\uBD0A", 5, "\uBD11\uBD12\uBD13\uBD15", 8],
      ["9461", "\uBD1E", 5, "\uBD25", 6, "\uBD2D", 12],
      ["9481", "\uBD3A", 5, "\uBD41", 6, "\uBD4A\uBD4B\uBD4D\uBD4E\uBD4F\uBD51", 6, "\uBD5A", 9, "\uBD65\uBD66\uBD67\uBD69", 22, "\uBD82\uBD83\uBD85\uBD86\uBD8B", 4, "\uBD92\uBD94\uBD96\uBD97\uBD98\uBD9B\uBD9D", 6, "\uBDA5", 10, "\uBDB1", 6, "\uBDB9", 24],
      ["9541", "\uBDD2\uBDD3\uBDD6\uBDD7\uBDD9\uBDDA\uBDDB\uBDDD", 11, "\uBDEA", 5, "\uBDF1"],
      ["9561", "\uBDF2\uBDF3\uBDF5\uBDF6\uBDF7\uBDF9", 6, "\uBE01\uBE02\uBE04\uBE06", 5, "\uBE0E\uBE0F\uBE11\uBE12\uBE13"],
      ["9581", "\uBE15", 6, "\uBE1E\uBE20", 35, "\uBE46\uBE47\uBE49\uBE4A\uBE4B\uBE4D\uBE4F", 4, "\uBE56\uBE58\uBE5C\uBE5D\uBE5E\uBE5F\uBE62\uBE63\uBE65\uBE66\uBE67\uBE69\uBE6B", 4, "\uBE72\uBE76", 4, "\uBE7E\uBE7F\uBE81\uBE82\uBE83\uBE85", 6, "\uBE8E\uBE92", 5, "\uBE9A", 13, "\uBEA9", 14],
      ["9641", "\uBEB8", 23, "\uBED2\uBED3"],
      ["9661", "\uBED5\uBED6\uBED9", 6, "\uBEE1\uBEE2\uBEE6", 5, "\uBEED", 8],
      ["9681", "\uBEF6", 10, "\uBF02", 5, "\uBF0A", 13, "\uBF1A\uBF1E", 33, "\uBF42\uBF43\uBF45\uBF46\uBF47\uBF49", 6, "\uBF52\uBF53\uBF54\uBF56", 44],
      ["9741", "\uBF83", 16, "\uBF95", 8],
      ["9761", "\uBF9E", 17, "\uBFB1", 7],
      ["9781", "\uBFB9", 11, "\uBFC6", 5, "\uBFCE\uBFCF\uBFD1\uBFD2\uBFD3\uBFD5", 6, "\uBFDD\uBFDE\uBFE0\uBFE2", 89, "\uC03D\uC03E\uC03F"],
      ["9841", "\uC040", 16, "\uC052", 5, "\uC059\uC05A\uC05B"],
      ["9861", "\uC05D\uC05E\uC05F\uC061", 6, "\uC06A", 15],
      ["9881", "\uC07A", 21, "\uC092\uC093\uC095\uC096\uC097\uC099", 6, "\uC0A2\uC0A4\uC0A6", 5, "\uC0AE\uC0B1\uC0B2\uC0B7", 4, "\uC0BE\uC0C2\uC0C3\uC0C4\uC0C6\uC0C7\uC0CA\uC0CB\uC0CD\uC0CE\uC0CF\uC0D1", 6, "\uC0DA\uC0DE", 5, "\uC0E6\uC0E7\uC0E9\uC0EA\uC0EB\uC0ED", 6, "\uC0F6\uC0F8\uC0FA", 5, "\uC101\uC102\uC103\uC105\uC106\uC107\uC109", 6, "\uC111\uC112\uC113\uC114\uC116", 5, "\uC121\uC122\uC125\uC128\uC129\uC12A\uC12B\uC12E"],
      ["9941", "\uC132\uC133\uC134\uC135\uC137\uC13A\uC13B\uC13D\uC13E\uC13F\uC141", 6, "\uC14A\uC14E", 5, "\uC156\uC157"],
      ["9961", "\uC159\uC15A\uC15B\uC15D", 6, "\uC166\uC16A", 5, "\uC171\uC172\uC173\uC175\uC176\uC177\uC179\uC17A\uC17B"],
      ["9981", "\uC17C", 8, "\uC186", 5, "\uC18F\uC191\uC192\uC193\uC195\uC197", 4, "\uC19E\uC1A0\uC1A2\uC1A3\uC1A4\uC1A6\uC1A7\uC1AA\uC1AB\uC1AD\uC1AE\uC1AF\uC1B1", 11, "\uC1BE", 5, "\uC1C5\uC1C6\uC1C7\uC1C9\uC1CA\uC1CB\uC1CD", 6, "\uC1D5\uC1D6\uC1D9", 6, "\uC1E1\uC1E2\uC1E3\uC1E5\uC1E6\uC1E7\uC1E9", 6, "\uC1F2\uC1F4", 7, "\uC1FE\uC1FF\uC201\uC202\uC203\uC205", 6, "\uC20E\uC210\uC212", 5, "\uC21A\uC21B\uC21D\uC21E\uC221\uC222\uC223"],
      ["9a41", "\uC224\uC225\uC226\uC227\uC22A\uC22C\uC22E\uC230\uC233\uC235", 16],
      ["9a61", "\uC246\uC247\uC249", 6, "\uC252\uC253\uC255\uC256\uC257\uC259", 6, "\uC261\uC262\uC263\uC264\uC266"],
      ["9a81", "\uC267", 4, "\uC26E\uC26F\uC271\uC272\uC273\uC275", 6, "\uC27E\uC280\uC282", 5, "\uC28A", 5, "\uC291", 6, "\uC299\uC29A\uC29C\uC29E", 5, "\uC2A6\uC2A7\uC2A9\uC2AA\uC2AB\uC2AE", 5, "\uC2B6\uC2B8\uC2BA", 33, "\uC2DE\uC2DF\uC2E1\uC2E2\uC2E5", 5, "\uC2EE\uC2F0\uC2F2\uC2F3\uC2F4\uC2F5\uC2F7\uC2FA\uC2FD\uC2FE\uC2FF\uC301", 6, "\uC30A\uC30B\uC30E\uC30F"],
      ["9b41", "\uC310\uC311\uC312\uC316\uC317\uC319\uC31A\uC31B\uC31D", 6, "\uC326\uC327\uC32A", 8],
      ["9b61", "\uC333", 17, "\uC346", 7],
      ["9b81", "\uC34E", 25, "\uC36A\uC36B\uC36D\uC36E\uC36F\uC371\uC373", 4, "\uC37A\uC37B\uC37E", 5, "\uC385\uC386\uC387\uC389\uC38A\uC38B\uC38D", 50, "\uC3C1", 22, "\uC3DA"],
      ["9c41", "\uC3DB\uC3DD\uC3DE\uC3E1\uC3E3", 4, "\uC3EA\uC3EB\uC3EC\uC3EE", 5, "\uC3F6\uC3F7\uC3F9", 5],
      ["9c61", "\uC3FF", 8, "\uC409", 6, "\uC411", 9],
      ["9c81", "\uC41B", 8, "\uC425", 6, "\uC42D\uC42E\uC42F\uC431\uC432\uC433\uC435", 6, "\uC43E", 9, "\uC449", 26, "\uC466\uC467\uC469\uC46A\uC46B\uC46D", 6, "\uC476\uC477\uC478\uC47A", 5, "\uC481", 18, "\uC495", 6, "\uC49D", 12],
      ["9d41", "\uC4AA", 13, "\uC4B9\uC4BA\uC4BB\uC4BD", 8],
      ["9d61", "\uC4C6", 25],
      ["9d81", "\uC4E0", 8, "\uC4EA", 5, "\uC4F2\uC4F3\uC4F5\uC4F6\uC4F7\uC4F9\uC4FB\uC4FC\uC4FD\uC4FE\uC502", 9, "\uC50D\uC50E\uC50F\uC511\uC512\uC513\uC515", 6, "\uC51D", 10, "\uC52A\uC52B\uC52D\uC52E\uC52F\uC531", 6, "\uC53A\uC53C\uC53E", 5, "\uC546\uC547\uC54B\uC54F\uC550\uC551\uC552\uC556\uC55A\uC55B\uC55C\uC55F\uC562\uC563\uC565\uC566\uC567\uC569", 6, "\uC572\uC576", 5, "\uC57E\uC57F\uC581\uC582\uC583\uC585\uC586\uC588\uC589\uC58A\uC58B\uC58E\uC590\uC592\uC593\uC594"],
      ["9e41", "\uC596\uC599\uC59A\uC59B\uC59D\uC59E\uC59F\uC5A1", 7, "\uC5AA", 9, "\uC5B6"],
      ["9e61", "\uC5B7\uC5BA\uC5BF", 4, "\uC5CB\uC5CD\uC5CF\uC5D2\uC5D3\uC5D5\uC5D6\uC5D7\uC5D9", 6, "\uC5E2\uC5E4\uC5E6\uC5E7"],
      ["9e81", "\uC5E8\uC5E9\uC5EA\uC5EB\uC5EF\uC5F1\uC5F2\uC5F3\uC5F5\uC5F8\uC5F9\uC5FA\uC5FB\uC602\uC603\uC604\uC609\uC60A\uC60B\uC60D\uC60E\uC60F\uC611", 6, "\uC61A\uC61D", 6, "\uC626\uC627\uC629\uC62A\uC62B\uC62F\uC631\uC632\uC636\uC638\uC63A\uC63C\uC63D\uC63E\uC63F\uC642\uC643\uC645\uC646\uC647\uC649", 6, "\uC652\uC656", 5, "\uC65E\uC65F\uC661", 10, "\uC66D\uC66E\uC670\uC672", 5, "\uC67A\uC67B\uC67D\uC67E\uC67F\uC681", 6, "\uC68A\uC68C\uC68E", 5, "\uC696\uC697\uC699\uC69A\uC69B\uC69D", 6, "\uC6A6"],
      ["9f41", "\uC6A8\uC6AA", 5, "\uC6B2\uC6B3\uC6B5\uC6B6\uC6B7\uC6BB", 4, "\uC6C2\uC6C4\uC6C6", 5, "\uC6CE"],
      ["9f61", "\uC6CF\uC6D1\uC6D2\uC6D3\uC6D5", 6, "\uC6DE\uC6DF\uC6E2", 5, "\uC6EA\uC6EB\uC6ED\uC6EE\uC6EF\uC6F1\uC6F2"],
      ["9f81", "\uC6F3", 4, "\uC6FA\uC6FB\uC6FC\uC6FE", 5, "\uC706\uC707\uC709\uC70A\uC70B\uC70D", 6, "\uC716\uC718\uC71A", 5, "\uC722\uC723\uC725\uC726\uC727\uC729", 6, "\uC732\uC734\uC736\uC738\uC739\uC73A\uC73B\uC73E\uC73F\uC741\uC742\uC743\uC745", 4, "\uC74B\uC74E\uC750\uC759\uC75A\uC75B\uC75D\uC75E\uC75F\uC761", 6, "\uC769\uC76A\uC76C", 7, "\uC776\uC777\uC779\uC77A\uC77B\uC77F\uC780\uC781\uC782\uC786\uC78B\uC78C\uC78D\uC78F\uC792\uC793\uC795\uC799\uC79B", 4, "\uC7A2\uC7A7", 4, "\uC7AE\uC7AF\uC7B1\uC7B2\uC7B3\uC7B5\uC7B6\uC7B7"],
      ["a041", "\uC7B8\uC7B9\uC7BA\uC7BB\uC7BE\uC7C2", 5, "\uC7CA\uC7CB\uC7CD\uC7CF\uC7D1", 6, "\uC7D9\uC7DA\uC7DB\uC7DC"],
      ["a061", "\uC7DE", 5, "\uC7E5\uC7E6\uC7E7\uC7E9\uC7EA\uC7EB\uC7ED", 13],
      ["a081", "\uC7FB", 4, "\uC802\uC803\uC805\uC806\uC807\uC809\uC80B", 4, "\uC812\uC814\uC817", 4, "\uC81E\uC81F\uC821\uC822\uC823\uC825", 6, "\uC82E\uC830\uC832", 5, "\uC839\uC83A\uC83B\uC83D\uC83E\uC83F\uC841", 6, "\uC84A\uC84B\uC84E", 5, "\uC855", 26, "\uC872\uC873\uC875\uC876\uC877\uC879\uC87B", 4, "\uC882\uC884\uC888\uC889\uC88A\uC88E", 5, "\uC895", 7, "\uC89E\uC8A0\uC8A2\uC8A3\uC8A4"],
      ["a141", "\uC8A5\uC8A6\uC8A7\uC8A9", 18, "\uC8BE\uC8BF\uC8C0\uC8C1"],
      ["a161", "\uC8C2\uC8C3\uC8C5\uC8C6\uC8C7\uC8C9\uC8CA\uC8CB\uC8CD", 6, "\uC8D6\uC8D8\uC8DA", 5, "\uC8E2\uC8E3\uC8E5"],
      ["a181", "\uC8E6", 14, "\uC8F6", 5, "\uC8FE\uC8FF\uC901\uC902\uC903\uC907", 4, "\uC90E\u3000\u3001\u3002\xB7\u2025\u2026\xA8\u3003\xAD\u2015\u2225\uFF3C\u223C\u2018\u2019\u201C\u201D\u3014\u3015\u3008", 9, "\xB1\xD7\xF7\u2260\u2264\u2265\u221E\u2234\xB0\u2032\u2033\u2103\u212B\uFFE0\uFFE1\uFFE5\u2642\u2640\u2220\u22A5\u2312\u2202\u2207\u2261\u2252\xA7\u203B\u2606\u2605\u25CB\u25CF\u25CE\u25C7\u25C6\u25A1\u25A0\u25B3\u25B2\u25BD\u25BC\u2192\u2190\u2191\u2193\u2194\u3013\u226A\u226B\u221A\u223D\u221D\u2235\u222B\u222C\u2208\u220B\u2286\u2287\u2282\u2283\u222A\u2229\u2227\u2228\uFFE2"],
      ["a241", "\uC910\uC912", 5, "\uC919", 18],
      ["a261", "\uC92D", 6, "\uC935", 18],
      ["a281", "\uC948", 7, "\uC952\uC953\uC955\uC956\uC957\uC959", 6, "\uC962\uC964", 7, "\uC96D\uC96E\uC96F\u21D2\u21D4\u2200\u2203\xB4\uFF5E\u02C7\u02D8\u02DD\u02DA\u02D9\xB8\u02DB\xA1\xBF\u02D0\u222E\u2211\u220F\xA4\u2109\u2030\u25C1\u25C0\u25B7\u25B6\u2664\u2660\u2661\u2665\u2667\u2663\u2299\u25C8\u25A3\u25D0\u25D1\u2592\u25A4\u25A5\u25A8\u25A7\u25A6\u25A9\u2668\u260F\u260E\u261C\u261E\xB6\u2020\u2021\u2195\u2197\u2199\u2196\u2198\u266D\u2669\u266A\u266C\u327F\u321C\u2116\u33C7\u2122\u33C2\u33D8\u2121\u20AC\xAE"],
      ["a341", "\uC971\uC972\uC973\uC975", 6, "\uC97D", 10, "\uC98A\uC98B\uC98D\uC98E\uC98F"],
      ["a361", "\uC991", 6, "\uC99A\uC99C\uC99E", 16],
      ["a381", "\uC9AF", 16, "\uC9C2\uC9C3\uC9C5\uC9C6\uC9C9\uC9CB", 4, "\uC9D2\uC9D4\uC9D7\uC9D8\uC9DB\uFF01", 58, "\uFFE6\uFF3D", 32, "\uFFE3"],
      ["a441", "\uC9DE\uC9DF\uC9E1\uC9E3\uC9E5\uC9E6\uC9E8\uC9E9\uC9EA\uC9EB\uC9EE\uC9F2", 5, "\uC9FA\uC9FB\uC9FD\uC9FE\uC9FF\uCA01\uCA02\uCA03\uCA04"],
      ["a461", "\uCA05\uCA06\uCA07\uCA0A\uCA0E", 5, "\uCA15\uCA16\uCA17\uCA19", 12],
      ["a481", "\uCA26\uCA27\uCA28\uCA2A", 28, "\u3131", 93],
      ["a541", "\uCA47", 4, "\uCA4E\uCA4F\uCA51\uCA52\uCA53\uCA55", 6, "\uCA5E\uCA62", 5, "\uCA69\uCA6A"],
      ["a561", "\uCA6B", 17, "\uCA7E", 5, "\uCA85\uCA86"],
      ["a581", "\uCA87", 16, "\uCA99", 14, "\u2170", 9],
      ["a5b0", "\u2160", 9],
      ["a5c1", "\u0391", 16, "\u03A3", 6],
      ["a5e1", "\u03B1", 16, "\u03C3", 6],
      ["a641", "\uCAA8", 19, "\uCABE\uCABF\uCAC1\uCAC2\uCAC3\uCAC5"],
      ["a661", "\uCAC6", 5, "\uCACE\uCAD0\uCAD2\uCAD4\uCAD5\uCAD6\uCAD7\uCADA", 5, "\uCAE1", 6],
      ["a681", "\uCAE8\uCAE9\uCAEA\uCAEB\uCAED", 6, "\uCAF5", 18, "\uCB09\uCB0A\u2500\u2502\u250C\u2510\u2518\u2514\u251C\u252C\u2524\u2534\u253C\u2501\u2503\u250F\u2513\u251B\u2517\u2523\u2533\u252B\u253B\u254B\u2520\u252F\u2528\u2537\u253F\u251D\u2530\u2525\u2538\u2542\u2512\u2511\u251A\u2519\u2516\u2515\u250E\u250D\u251E\u251F\u2521\u2522\u2526\u2527\u2529\u252A\u252D\u252E\u2531\u2532\u2535\u2536\u2539\u253A\u253D\u253E\u2540\u2541\u2543", 7],
      ["a741", "\uCB0B", 4, "\uCB11\uCB12\uCB13\uCB15\uCB16\uCB17\uCB19", 6, "\uCB22", 7],
      ["a761", "\uCB2A", 22, "\uCB42\uCB43\uCB44"],
      ["a781", "\uCB45\uCB46\uCB47\uCB4A\uCB4B\uCB4D\uCB4E\uCB4F\uCB51", 6, "\uCB5A\uCB5B\uCB5C\uCB5E", 5, "\uCB65", 7, "\u3395\u3396\u3397\u2113\u3398\u33C4\u33A3\u33A4\u33A5\u33A6\u3399", 9, "\u33CA\u338D\u338E\u338F\u33CF\u3388\u3389\u33C8\u33A7\u33A8\u33B0", 9, "\u3380", 4, "\u33BA", 5, "\u3390", 4, "\u2126\u33C0\u33C1\u338A\u338B\u338C\u33D6\u33C5\u33AD\u33AE\u33AF\u33DB\u33A9\u33AA\u33AB\u33AC\u33DD\u33D0\u33D3\u33C3\u33C9\u33DC\u33C6"],
      ["a841", "\uCB6D", 10, "\uCB7A", 14],
      ["a861", "\uCB89", 18, "\uCB9D", 6],
      ["a881", "\uCBA4", 19, "\uCBB9", 11, "\xC6\xD0\xAA\u0126"],
      ["a8a6", "\u0132"],
      ["a8a8", "\u013F\u0141\xD8\u0152\xBA\xDE\u0166\u014A"],
      ["a8b1", "\u3260", 27, "\u24D0", 25, "\u2460", 14, "\xBD\u2153\u2154\xBC\xBE\u215B\u215C\u215D\u215E"],
      ["a941", "\uCBC5", 14, "\uCBD5", 10],
      ["a961", "\uCBE0\uCBE1\uCBE2\uCBE3\uCBE5\uCBE6\uCBE8\uCBEA", 18],
      ["a981", "\uCBFD", 14, "\uCC0E\uCC0F\uCC11\uCC12\uCC13\uCC15", 6, "\uCC1E\uCC1F\uCC20\uCC23\uCC24\xE6\u0111\xF0\u0127\u0131\u0133\u0138\u0140\u0142\xF8\u0153\xDF\xFE\u0167\u014B\u0149\u3200", 27, "\u249C", 25, "\u2474", 14, "\xB9\xB2\xB3\u2074\u207F\u2081\u2082\u2083\u2084"],
      ["aa41", "\uCC25\uCC26\uCC2A\uCC2B\uCC2D\uCC2F\uCC31", 6, "\uCC3A\uCC3F", 4, "\uCC46\uCC47\uCC49\uCC4A\uCC4B\uCC4D\uCC4E"],
      ["aa61", "\uCC4F", 4, "\uCC56\uCC5A", 5, "\uCC61\uCC62\uCC63\uCC65\uCC67\uCC69", 6, "\uCC71\uCC72"],
      ["aa81", "\uCC73\uCC74\uCC76", 29, "\u3041", 82],
      ["ab41", "\uCC94\uCC95\uCC96\uCC97\uCC9A\uCC9B\uCC9D\uCC9E\uCC9F\uCCA1", 6, "\uCCAA\uCCAE", 5, "\uCCB6\uCCB7\uCCB9"],
      ["ab61", "\uCCBA\uCCBB\uCCBD", 6, "\uCCC6\uCCC8\uCCCA", 5, "\uCCD1\uCCD2\uCCD3\uCCD5", 5],
      ["ab81", "\uCCDB", 8, "\uCCE5", 6, "\uCCED\uCCEE\uCCEF\uCCF1", 12, "\u30A1", 85],
      ["ac41", "\uCCFE\uCCFF\uCD00\uCD02", 5, "\uCD0A\uCD0B\uCD0D\uCD0E\uCD0F\uCD11", 6, "\uCD1A\uCD1C\uCD1E\uCD1F\uCD20"],
      ["ac61", "\uCD21\uCD22\uCD23\uCD25\uCD26\uCD27\uCD29\uCD2A\uCD2B\uCD2D", 11, "\uCD3A", 4],
      ["ac81", "\uCD3F", 28, "\uCD5D\uCD5E\uCD5F\u0410", 5, "\u0401\u0416", 25],
      ["acd1", "\u0430", 5, "\u0451\u0436", 25],
      ["ad41", "\uCD61\uCD62\uCD63\uCD65", 6, "\uCD6E\uCD70\uCD72", 5, "\uCD79", 7],
      ["ad61", "\uCD81", 6, "\uCD89", 10, "\uCD96\uCD97\uCD99\uCD9A\uCD9B\uCD9D\uCD9E\uCD9F"],
      ["ad81", "\uCDA0\uCDA1\uCDA2\uCDA3\uCDA6\uCDA8\uCDAA", 5, "\uCDB1", 18, "\uCDC5"],
      ["ae41", "\uCDC6", 5, "\uCDCD\uCDCE\uCDCF\uCDD1", 16],
      ["ae61", "\uCDE2", 5, "\uCDE9\uCDEA\uCDEB\uCDED\uCDEE\uCDEF\uCDF1", 6, "\uCDFA\uCDFC\uCDFE", 4],
      ["ae81", "\uCE03\uCE05\uCE06\uCE07\uCE09\uCE0A\uCE0B\uCE0D", 6, "\uCE15\uCE16\uCE17\uCE18\uCE1A", 5, "\uCE22\uCE23\uCE25\uCE26\uCE27\uCE29\uCE2A\uCE2B"],
      ["af41", "\uCE2C\uCE2D\uCE2E\uCE2F\uCE32\uCE34\uCE36", 19],
      ["af61", "\uCE4A", 13, "\uCE5A\uCE5B\uCE5D\uCE5E\uCE62", 5, "\uCE6A\uCE6C"],
      ["af81", "\uCE6E", 5, "\uCE76\uCE77\uCE79\uCE7A\uCE7B\uCE7D", 6, "\uCE86\uCE88\uCE8A", 5, "\uCE92\uCE93\uCE95\uCE96\uCE97\uCE99"],
      ["b041", "\uCE9A", 5, "\uCEA2\uCEA6", 5, "\uCEAE", 12],
      ["b061", "\uCEBB", 5, "\uCEC2", 19],
      ["b081", "\uCED6", 13, "\uCEE6\uCEE7\uCEE9\uCEEA\uCEED", 6, "\uCEF6\uCEFA", 5, "\uAC00\uAC01\uAC04\uAC07\uAC08\uAC09\uAC0A\uAC10", 7, "\uAC19", 4, "\uAC20\uAC24\uAC2C\uAC2D\uAC2F\uAC30\uAC31\uAC38\uAC39\uAC3C\uAC40\uAC4B\uAC4D\uAC54\uAC58\uAC5C\uAC70\uAC71\uAC74\uAC77\uAC78\uAC7A\uAC80\uAC81\uAC83\uAC84\uAC85\uAC86\uAC89\uAC8A\uAC8B\uAC8C\uAC90\uAC94\uAC9C\uAC9D\uAC9F\uACA0\uACA1\uACA8\uACA9\uACAA\uACAC\uACAF\uACB0\uACB8\uACB9\uACBB\uACBC\uACBD\uACC1\uACC4\uACC8\uACCC\uACD5\uACD7\uACE0\uACE1\uACE4\uACE7\uACE8\uACEA\uACEC\uACEF\uACF0\uACF1\uACF3\uACF5\uACF6\uACFC\uACFD\uAD00\uAD04\uAD06"],
      ["b141", "\uCF02\uCF03\uCF05\uCF06\uCF07\uCF09", 6, "\uCF12\uCF14\uCF16", 5, "\uCF1D\uCF1E\uCF1F\uCF21\uCF22\uCF23"],
      ["b161", "\uCF25", 6, "\uCF2E\uCF32", 5, "\uCF39", 11],
      ["b181", "\uCF45", 14, "\uCF56\uCF57\uCF59\uCF5A\uCF5B\uCF5D", 6, "\uCF66\uCF68\uCF6A\uCF6B\uCF6C\uAD0C\uAD0D\uAD0F\uAD11\uAD18\uAD1C\uAD20\uAD29\uAD2C\uAD2D\uAD34\uAD35\uAD38\uAD3C\uAD44\uAD45\uAD47\uAD49\uAD50\uAD54\uAD58\uAD61\uAD63\uAD6C\uAD6D\uAD70\uAD73\uAD74\uAD75\uAD76\uAD7B\uAD7C\uAD7D\uAD7F\uAD81\uAD82\uAD88\uAD89\uAD8C\uAD90\uAD9C\uAD9D\uADA4\uADB7\uADC0\uADC1\uADC4\uADC8\uADD0\uADD1\uADD3\uADDC\uADE0\uADE4\uADF8\uADF9\uADFC\uADFF\uAE00\uAE01\uAE08\uAE09\uAE0B\uAE0D\uAE14\uAE30\uAE31\uAE34\uAE37\uAE38\uAE3A\uAE40\uAE41\uAE43\uAE45\uAE46\uAE4A\uAE4C\uAE4D\uAE4E\uAE50\uAE54\uAE56\uAE5C\uAE5D\uAE5F\uAE60\uAE61\uAE65\uAE68\uAE69\uAE6C\uAE70\uAE78"],
      ["b241", "\uCF6D\uCF6E\uCF6F\uCF72\uCF73\uCF75\uCF76\uCF77\uCF79", 6, "\uCF81\uCF82\uCF83\uCF84\uCF86", 5, "\uCF8D"],
      ["b261", "\uCF8E", 18, "\uCFA2", 5, "\uCFA9"],
      ["b281", "\uCFAA", 5, "\uCFB1", 18, "\uCFC5", 6, "\uAE79\uAE7B\uAE7C\uAE7D\uAE84\uAE85\uAE8C\uAEBC\uAEBD\uAEBE\uAEC0\uAEC4\uAECC\uAECD\uAECF\uAED0\uAED1\uAED8\uAED9\uAEDC\uAEE8\uAEEB\uAEED\uAEF4\uAEF8\uAEFC\uAF07\uAF08\uAF0D\uAF10\uAF2C\uAF2D\uAF30\uAF32\uAF34\uAF3C\uAF3D\uAF3F\uAF41\uAF42\uAF43\uAF48\uAF49\uAF50\uAF5C\uAF5D\uAF64\uAF65\uAF79\uAF80\uAF84\uAF88\uAF90\uAF91\uAF95\uAF9C\uAFB8\uAFB9\uAFBC\uAFC0\uAFC7\uAFC8\uAFC9\uAFCB\uAFCD\uAFCE\uAFD4\uAFDC\uAFE8\uAFE9\uAFF0\uAFF1\uAFF4\uAFF8\uB000\uB001\uB004\uB00C\uB010\uB014\uB01C\uB01D\uB028\uB044\uB045\uB048\uB04A\uB04C\uB04E\uB053\uB054\uB055\uB057\uB059"],
      ["b341", "\uCFCC", 19, "\uCFE2\uCFE3\uCFE5\uCFE6\uCFE7\uCFE9"],
      ["b361", "\uCFEA", 5, "\uCFF2\uCFF4\uCFF6", 5, "\uCFFD\uCFFE\uCFFF\uD001\uD002\uD003\uD005", 5],
      ["b381", "\uD00B", 5, "\uD012", 5, "\uD019", 19, "\uB05D\uB07C\uB07D\uB080\uB084\uB08C\uB08D\uB08F\uB091\uB098\uB099\uB09A\uB09C\uB09F\uB0A0\uB0A1\uB0A2\uB0A8\uB0A9\uB0AB", 4, "\uB0B1\uB0B3\uB0B4\uB0B5\uB0B8\uB0BC\uB0C4\uB0C5\uB0C7\uB0C8\uB0C9\uB0D0\uB0D1\uB0D4\uB0D8\uB0E0\uB0E5\uB108\uB109\uB10B\uB10C\uB110\uB112\uB113\uB118\uB119\uB11B\uB11C\uB11D\uB123\uB124\uB125\uB128\uB12C\uB134\uB135\uB137\uB138\uB139\uB140\uB141\uB144\uB148\uB150\uB151\uB154\uB155\uB158\uB15C\uB160\uB178\uB179\uB17C\uB180\uB182\uB188\uB189\uB18B\uB18D\uB192\uB193\uB194\uB198\uB19C\uB1A8\uB1CC\uB1D0\uB1D4\uB1DC\uB1DD"],
      ["b441", "\uD02E", 5, "\uD036\uD037\uD039\uD03A\uD03B\uD03D", 6, "\uD046\uD048\uD04A", 5],
      ["b461", "\uD051\uD052\uD053\uD055\uD056\uD057\uD059", 6, "\uD061", 10, "\uD06E\uD06F"],
      ["b481", "\uD071\uD072\uD073\uD075", 6, "\uD07E\uD07F\uD080\uD082", 18, "\uB1DF\uB1E8\uB1E9\uB1EC\uB1F0\uB1F9\uB1FB\uB1FD\uB204\uB205\uB208\uB20B\uB20C\uB214\uB215\uB217\uB219\uB220\uB234\uB23C\uB258\uB25C\uB260\uB268\uB269\uB274\uB275\uB27C\uB284\uB285\uB289\uB290\uB291\uB294\uB298\uB299\uB29A\uB2A0\uB2A1\uB2A3\uB2A5\uB2A6\uB2AA\uB2AC\uB2B0\uB2B4\uB2C8\uB2C9\uB2CC\uB2D0\uB2D2\uB2D8\uB2D9\uB2DB\uB2DD\uB2E2\uB2E4\uB2E5\uB2E6\uB2E8\uB2EB", 4, "\uB2F3\uB2F4\uB2F5\uB2F7", 4, "\uB2FF\uB300\uB301\uB304\uB308\uB310\uB311\uB313\uB314\uB315\uB31C\uB354\uB355\uB356\uB358\uB35B\uB35C\uB35E\uB35F\uB364\uB365"],
      ["b541", "\uD095", 14, "\uD0A6\uD0A7\uD0A9\uD0AA\uD0AB\uD0AD", 5],
      ["b561", "\uD0B3\uD0B6\uD0B8\uD0BA", 5, "\uD0C2\uD0C3\uD0C5\uD0C6\uD0C7\uD0CA", 5, "\uD0D2\uD0D6", 4],
      ["b581", "\uD0DB\uD0DE\uD0DF\uD0E1\uD0E2\uD0E3\uD0E5", 6, "\uD0EE\uD0F2", 5, "\uD0F9", 11, "\uB367\uB369\uB36B\uB36E\uB370\uB371\uB374\uB378\uB380\uB381\uB383\uB384\uB385\uB38C\uB390\uB394\uB3A0\uB3A1\uB3A8\uB3AC\uB3C4\uB3C5\uB3C8\uB3CB\uB3CC\uB3CE\uB3D0\uB3D4\uB3D5\uB3D7\uB3D9\uB3DB\uB3DD\uB3E0\uB3E4\uB3E8\uB3FC\uB410\uB418\uB41C\uB420\uB428\uB429\uB42B\uB434\uB450\uB451\uB454\uB458\uB460\uB461\uB463\uB465\uB46C\uB480\uB488\uB49D\uB4A4\uB4A8\uB4AC\uB4B5\uB4B7\uB4B9\uB4C0\uB4C4\uB4C8\uB4D0\uB4D5\uB4DC\uB4DD\uB4E0\uB4E3\uB4E4\uB4E6\uB4EC\uB4ED\uB4EF\uB4F1\uB4F8\uB514\uB515\uB518\uB51B\uB51C\uB524\uB525\uB527\uB528\uB529\uB52A\uB530\uB531\uB534\uB538"],
      ["b641", "\uD105", 7, "\uD10E", 17],
      ["b661", "\uD120", 15, "\uD132\uD133\uD135\uD136\uD137\uD139\uD13B\uD13C\uD13D\uD13E"],
      ["b681", "\uD13F\uD142\uD146", 5, "\uD14E\uD14F\uD151\uD152\uD153\uD155", 6, "\uD15E\uD160\uD162", 5, "\uD169\uD16A\uD16B\uD16D\uB540\uB541\uB543\uB544\uB545\uB54B\uB54C\uB54D\uB550\uB554\uB55C\uB55D\uB55F\uB560\uB561\uB5A0\uB5A1\uB5A4\uB5A8\uB5AA\uB5AB\uB5B0\uB5B1\uB5B3\uB5B4\uB5B5\uB5BB\uB5BC\uB5BD\uB5C0\uB5C4\uB5CC\uB5CD\uB5CF\uB5D0\uB5D1\uB5D8\uB5EC\uB610\uB611\uB614\uB618\uB625\uB62C\uB634\uB648\uB664\uB668\uB69C\uB69D\uB6A0\uB6A4\uB6AB\uB6AC\uB6B1\uB6D4\uB6F0\uB6F4\uB6F8\uB700\uB701\uB705\uB728\uB729\uB72C\uB72F\uB730\uB738\uB739\uB73B\uB744\uB748\uB74C\uB754\uB755\uB760\uB764\uB768\uB770\uB771\uB773\uB775\uB77C\uB77D\uB780\uB784\uB78C\uB78D\uB78F\uB790\uB791\uB792\uB796\uB797"],
      ["b741", "\uD16E", 13, "\uD17D", 6, "\uD185\uD186\uD187\uD189\uD18A"],
      ["b761", "\uD18B", 20, "\uD1A2\uD1A3\uD1A5\uD1A6\uD1A7"],
      ["b781", "\uD1A9", 6, "\uD1B2\uD1B4\uD1B6\uD1B7\uD1B8\uD1B9\uD1BB\uD1BD\uD1BE\uD1BF\uD1C1", 14, "\uB798\uB799\uB79C\uB7A0\uB7A8\uB7A9\uB7AB\uB7AC\uB7AD\uB7B4\uB7B5\uB7B8\uB7C7\uB7C9\uB7EC\uB7ED\uB7F0\uB7F4\uB7FC\uB7FD\uB7FF\uB800\uB801\uB807\uB808\uB809\uB80C\uB810\uB818\uB819\uB81B\uB81D\uB824\uB825\uB828\uB82C\uB834\uB835\uB837\uB838\uB839\uB840\uB844\uB851\uB853\uB85C\uB85D\uB860\uB864\uB86C\uB86D\uB86F\uB871\uB878\uB87C\uB88D\uB8A8\uB8B0\uB8B4\uB8B8\uB8C0\uB8C1\uB8C3\uB8C5\uB8CC\uB8D0\uB8D4\uB8DD\uB8DF\uB8E1\uB8E8\uB8E9\uB8EC\uB8F0\uB8F8\uB8F9\uB8FB\uB8FD\uB904\uB918\uB920\uB93C\uB93D\uB940\uB944\uB94C\uB94F\uB951\uB958\uB959\uB95C\uB960\uB968\uB969"],
      ["b841", "\uD1D0", 7, "\uD1D9", 17],
      ["b861", "\uD1EB", 8, "\uD1F5\uD1F6\uD1F7\uD1F9", 13],
      ["b881", "\uD208\uD20A", 5, "\uD211", 24, "\uB96B\uB96D\uB974\uB975\uB978\uB97C\uB984\uB985\uB987\uB989\uB98A\uB98D\uB98E\uB9AC\uB9AD\uB9B0\uB9B4\uB9BC\uB9BD\uB9BF\uB9C1\uB9C8\uB9C9\uB9CC\uB9CE", 4, "\uB9D8\uB9D9\uB9DB\uB9DD\uB9DE\uB9E1\uB9E3\uB9E4\uB9E5\uB9E8\uB9EC\uB9F4\uB9F5\uB9F7\uB9F8\uB9F9\uB9FA\uBA00\uBA01\uBA08\uBA15\uBA38\uBA39\uBA3C\uBA40\uBA42\uBA48\uBA49\uBA4B\uBA4D\uBA4E\uBA53\uBA54\uBA55\uBA58\uBA5C\uBA64\uBA65\uBA67\uBA68\uBA69\uBA70\uBA71\uBA74\uBA78\uBA83\uBA84\uBA85\uBA87\uBA8C\uBAA8\uBAA9\uBAAB\uBAAC\uBAB0\uBAB2\uBAB8\uBAB9\uBABB\uBABD\uBAC4\uBAC8\uBAD8\uBAD9\uBAFC"],
      ["b941", "\uD22A\uD22B\uD22E\uD22F\uD231\uD232\uD233\uD235", 6, "\uD23E\uD240\uD242", 5, "\uD249\uD24A\uD24B\uD24C"],
      ["b961", "\uD24D", 14, "\uD25D", 6, "\uD265\uD266\uD267\uD268"],
      ["b981", "\uD269", 22, "\uD282\uD283\uD285\uD286\uD287\uD289\uD28A\uD28B\uD28C\uBB00\uBB04\uBB0D\uBB0F\uBB11\uBB18\uBB1C\uBB20\uBB29\uBB2B\uBB34\uBB35\uBB36\uBB38\uBB3B\uBB3C\uBB3D\uBB3E\uBB44\uBB45\uBB47\uBB49\uBB4D\uBB4F\uBB50\uBB54\uBB58\uBB61\uBB63\uBB6C\uBB88\uBB8C\uBB90\uBBA4\uBBA8\uBBAC\uBBB4\uBBB7\uBBC0\uBBC4\uBBC8\uBBD0\uBBD3\uBBF8\uBBF9\uBBFC\uBBFF\uBC00\uBC02\uBC08\uBC09\uBC0B\uBC0C\uBC0D\uBC0F\uBC11\uBC14", 4, "\uBC1B", 4, "\uBC24\uBC25\uBC27\uBC29\uBC2D\uBC30\uBC31\uBC34\uBC38\uBC40\uBC41\uBC43\uBC44\uBC45\uBC49\uBC4C\uBC4D\uBC50\uBC5D\uBC84\uBC85\uBC88\uBC8B\uBC8C\uBC8E\uBC94\uBC95\uBC97"],
      ["ba41", "\uD28D\uD28E\uD28F\uD292\uD293\uD294\uD296", 5, "\uD29D\uD29E\uD29F\uD2A1\uD2A2\uD2A3\uD2A5", 6, "\uD2AD"],
      ["ba61", "\uD2AE\uD2AF\uD2B0\uD2B2", 5, "\uD2BA\uD2BB\uD2BD\uD2BE\uD2C1\uD2C3", 4, "\uD2CA\uD2CC", 5],
      ["ba81", "\uD2D2\uD2D3\uD2D5\uD2D6\uD2D7\uD2D9\uD2DA\uD2DB\uD2DD", 6, "\uD2E6", 9, "\uD2F2\uD2F3\uD2F5\uD2F6\uD2F7\uD2F9\uD2FA\uBC99\uBC9A\uBCA0\uBCA1\uBCA4\uBCA7\uBCA8\uBCB0\uBCB1\uBCB3\uBCB4\uBCB5\uBCBC\uBCBD\uBCC0\uBCC4\uBCCD\uBCCF\uBCD0\uBCD1\uBCD5\uBCD8\uBCDC\uBCF4\uBCF5\uBCF6\uBCF8\uBCFC\uBD04\uBD05\uBD07\uBD09\uBD10\uBD14\uBD24\uBD2C\uBD40\uBD48\uBD49\uBD4C\uBD50\uBD58\uBD59\uBD64\uBD68\uBD80\uBD81\uBD84\uBD87\uBD88\uBD89\uBD8A\uBD90\uBD91\uBD93\uBD95\uBD99\uBD9A\uBD9C\uBDA4\uBDB0\uBDB8\uBDD4\uBDD5\uBDD8\uBDDC\uBDE9\uBDF0\uBDF4\uBDF8\uBE00\uBE03\uBE05\uBE0C\uBE0D\uBE10\uBE14\uBE1C\uBE1D\uBE1F\uBE44\uBE45\uBE48\uBE4C\uBE4E\uBE54\uBE55\uBE57\uBE59\uBE5A\uBE5B\uBE60\uBE61\uBE64"],
      ["bb41", "\uD2FB", 4, "\uD302\uD304\uD306", 5, "\uD30F\uD311\uD312\uD313\uD315\uD317", 4, "\uD31E\uD322\uD323"],
      ["bb61", "\uD324\uD326\uD327\uD32A\uD32B\uD32D\uD32E\uD32F\uD331", 6, "\uD33A\uD33E", 5, "\uD346\uD347\uD348\uD349"],
      ["bb81", "\uD34A", 31, "\uBE68\uBE6A\uBE70\uBE71\uBE73\uBE74\uBE75\uBE7B\uBE7C\uBE7D\uBE80\uBE84\uBE8C\uBE8D\uBE8F\uBE90\uBE91\uBE98\uBE99\uBEA8\uBED0\uBED1\uBED4\uBED7\uBED8\uBEE0\uBEE3\uBEE4\uBEE5\uBEEC\uBF01\uBF08\uBF09\uBF18\uBF19\uBF1B\uBF1C\uBF1D\uBF40\uBF41\uBF44\uBF48\uBF50\uBF51\uBF55\uBF94\uBFB0\uBFC5\uBFCC\uBFCD\uBFD0\uBFD4\uBFDC\uBFDF\uBFE1\uC03C\uC051\uC058\uC05C\uC060\uC068\uC069\uC090\uC091\uC094\uC098\uC0A0\uC0A1\uC0A3\uC0A5\uC0AC\uC0AD\uC0AF\uC0B0\uC0B3\uC0B4\uC0B5\uC0B6\uC0BC\uC0BD\uC0BF\uC0C0\uC0C1\uC0C5\uC0C8\uC0C9\uC0CC\uC0D0\uC0D8\uC0D9\uC0DB\uC0DC\uC0DD\uC0E4"],
      ["bc41", "\uD36A", 17, "\uD37E\uD37F\uD381\uD382\uD383\uD385\uD386\uD387"],
      ["bc61", "\uD388\uD389\uD38A\uD38B\uD38E\uD392", 5, "\uD39A\uD39B\uD39D\uD39E\uD39F\uD3A1", 6, "\uD3AA\uD3AC\uD3AE"],
      ["bc81", "\uD3AF", 4, "\uD3B5\uD3B6\uD3B7\uD3B9\uD3BA\uD3BB\uD3BD", 6, "\uD3C6\uD3C7\uD3CA", 5, "\uD3D1", 5, "\uC0E5\uC0E8\uC0EC\uC0F4\uC0F5\uC0F7\uC0F9\uC100\uC104\uC108\uC110\uC115\uC11C", 4, "\uC123\uC124\uC126\uC127\uC12C\uC12D\uC12F\uC130\uC131\uC136\uC138\uC139\uC13C\uC140\uC148\uC149\uC14B\uC14C\uC14D\uC154\uC155\uC158\uC15C\uC164\uC165\uC167\uC168\uC169\uC170\uC174\uC178\uC185\uC18C\uC18D\uC18E\uC190\uC194\uC196\uC19C\uC19D\uC19F\uC1A1\uC1A5\uC1A8\uC1A9\uC1AC\uC1B0\uC1BD\uC1C4\uC1C8\uC1CC\uC1D4\uC1D7\uC1D8\uC1E0\uC1E4\uC1E8\uC1F0\uC1F1\uC1F3\uC1FC\uC1FD\uC200\uC204\uC20C\uC20D\uC20F\uC211\uC218\uC219\uC21C\uC21F\uC220\uC228\uC229\uC22B\uC22D"],
      ["bd41", "\uD3D7\uD3D9", 7, "\uD3E2\uD3E4", 7, "\uD3EE\uD3EF\uD3F1\uD3F2\uD3F3\uD3F5\uD3F6\uD3F7"],
      ["bd61", "\uD3F8\uD3F9\uD3FA\uD3FB\uD3FE\uD400\uD402", 5, "\uD409", 13],
      ["bd81", "\uD417", 5, "\uD41E", 25, "\uC22F\uC231\uC232\uC234\uC248\uC250\uC251\uC254\uC258\uC260\uC265\uC26C\uC26D\uC270\uC274\uC27C\uC27D\uC27F\uC281\uC288\uC289\uC290\uC298\uC29B\uC29D\uC2A4\uC2A5\uC2A8\uC2AC\uC2AD\uC2B4\uC2B5\uC2B7\uC2B9\uC2DC\uC2DD\uC2E0\uC2E3\uC2E4\uC2EB\uC2EC\uC2ED\uC2EF\uC2F1\uC2F6\uC2F8\uC2F9\uC2FB\uC2FC\uC300\uC308\uC309\uC30C\uC30D\uC313\uC314\uC315\uC318\uC31C\uC324\uC325\uC328\uC329\uC345\uC368\uC369\uC36C\uC370\uC372\uC378\uC379\uC37C\uC37D\uC384\uC388\uC38C\uC3C0\uC3D8\uC3D9\uC3DC\uC3DF\uC3E0\uC3E2\uC3E8\uC3E9\uC3ED\uC3F4\uC3F5\uC3F8\uC408\uC410\uC424\uC42C\uC430"],
      ["be41", "\uD438", 7, "\uD441\uD442\uD443\uD445", 14],
      ["be61", "\uD454", 7, "\uD45D\uD45E\uD45F\uD461\uD462\uD463\uD465", 7, "\uD46E\uD470\uD471\uD472"],
      ["be81", "\uD473", 4, "\uD47A\uD47B\uD47D\uD47E\uD481\uD483", 4, "\uD48A\uD48C\uD48E", 5, "\uD495", 8, "\uC434\uC43C\uC43D\uC448\uC464\uC465\uC468\uC46C\uC474\uC475\uC479\uC480\uC494\uC49C\uC4B8\uC4BC\uC4E9\uC4F0\uC4F1\uC4F4\uC4F8\uC4FA\uC4FF\uC500\uC501\uC50C\uC510\uC514\uC51C\uC528\uC529\uC52C\uC530\uC538\uC539\uC53B\uC53D\uC544\uC545\uC548\uC549\uC54A\uC54C\uC54D\uC54E\uC553\uC554\uC555\uC557\uC558\uC559\uC55D\uC55E\uC560\uC561\uC564\uC568\uC570\uC571\uC573\uC574\uC575\uC57C\uC57D\uC580\uC584\uC587\uC58C\uC58D\uC58F\uC591\uC595\uC597\uC598\uC59C\uC5A0\uC5A9\uC5B4\uC5B5\uC5B8\uC5B9\uC5BB\uC5BC\uC5BD\uC5BE\uC5C4", 6, "\uC5CC\uC5CE"],
      ["bf41", "\uD49E", 10, "\uD4AA", 14],
      ["bf61", "\uD4B9", 18, "\uD4CD\uD4CE\uD4CF\uD4D1\uD4D2\uD4D3\uD4D5"],
      ["bf81", "\uD4D6", 5, "\uD4DD\uD4DE\uD4E0", 7, "\uD4E9\uD4EA\uD4EB\uD4ED\uD4EE\uD4EF\uD4F1", 6, "\uD4F9\uD4FA\uD4FC\uC5D0\uC5D1\uC5D4\uC5D8\uC5E0\uC5E1\uC5E3\uC5E5\uC5EC\uC5ED\uC5EE\uC5F0\uC5F4\uC5F6\uC5F7\uC5FC", 5, "\uC605\uC606\uC607\uC608\uC60C\uC610\uC618\uC619\uC61B\uC61C\uC624\uC625\uC628\uC62C\uC62D\uC62E\uC630\uC633\uC634\uC635\uC637\uC639\uC63B\uC640\uC641\uC644\uC648\uC650\uC651\uC653\uC654\uC655\uC65C\uC65D\uC660\uC66C\uC66F\uC671\uC678\uC679\uC67C\uC680\uC688\uC689\uC68B\uC68D\uC694\uC695\uC698\uC69C\uC6A4\uC6A5\uC6A7\uC6A9\uC6B0\uC6B1\uC6B4\uC6B8\uC6B9\uC6BA\uC6C0\uC6C1\uC6C3\uC6C5\uC6CC\uC6CD\uC6D0\uC6D4\uC6DC\uC6DD\uC6E0\uC6E1\uC6E8"],
      ["c041", "\uD4FE", 5, "\uD505\uD506\uD507\uD509\uD50A\uD50B\uD50D", 6, "\uD516\uD518", 5],
      ["c061", "\uD51E", 25],
      ["c081", "\uD538\uD539\uD53A\uD53B\uD53E\uD53F\uD541\uD542\uD543\uD545", 6, "\uD54E\uD550\uD552", 5, "\uD55A\uD55B\uD55D\uD55E\uD55F\uD561\uD562\uD563\uC6E9\uC6EC\uC6F0\uC6F8\uC6F9\uC6FD\uC704\uC705\uC708\uC70C\uC714\uC715\uC717\uC719\uC720\uC721\uC724\uC728\uC730\uC731\uC733\uC735\uC737\uC73C\uC73D\uC740\uC744\uC74A\uC74C\uC74D\uC74F\uC751", 7, "\uC75C\uC760\uC768\uC76B\uC774\uC775\uC778\uC77C\uC77D\uC77E\uC783\uC784\uC785\uC787\uC788\uC789\uC78A\uC78E\uC790\uC791\uC794\uC796\uC797\uC798\uC79A\uC7A0\uC7A1\uC7A3\uC7A4\uC7A5\uC7A6\uC7AC\uC7AD\uC7B0\uC7B4\uC7BC\uC7BD\uC7BF\uC7C0\uC7C1\uC7C8\uC7C9\uC7CC\uC7CE\uC7D0\uC7D8\uC7DD\uC7E4\uC7E8\uC7EC\uC800\uC801\uC804\uC808\uC80A"],
      ["c141", "\uD564\uD566\uD567\uD56A\uD56C\uD56E", 5, "\uD576\uD577\uD579\uD57A\uD57B\uD57D", 6, "\uD586\uD58A\uD58B"],
      ["c161", "\uD58C\uD58D\uD58E\uD58F\uD591", 19, "\uD5A6\uD5A7"],
      ["c181", "\uD5A8", 31, "\uC810\uC811\uC813\uC815\uC816\uC81C\uC81D\uC820\uC824\uC82C\uC82D\uC82F\uC831\uC838\uC83C\uC840\uC848\uC849\uC84C\uC84D\uC854\uC870\uC871\uC874\uC878\uC87A\uC880\uC881\uC883\uC885\uC886\uC887\uC88B\uC88C\uC88D\uC894\uC89D\uC89F\uC8A1\uC8A8\uC8BC\uC8BD\uC8C4\uC8C8\uC8CC\uC8D4\uC8D5\uC8D7\uC8D9\uC8E0\uC8E1\uC8E4\uC8F5\uC8FC\uC8FD\uC900\uC904\uC905\uC906\uC90C\uC90D\uC90F\uC911\uC918\uC92C\uC934\uC950\uC951\uC954\uC958\uC960\uC961\uC963\uC96C\uC970\uC974\uC97C\uC988\uC989\uC98C\uC990\uC998\uC999\uC99B\uC99D\uC9C0\uC9C1\uC9C4\uC9C7\uC9C8\uC9CA\uC9D0\uC9D1\uC9D3"],
      ["c241", "\uD5CA\uD5CB\uD5CD\uD5CE\uD5CF\uD5D1\uD5D3", 4, "\uD5DA\uD5DC\uD5DE", 5, "\uD5E6\uD5E7\uD5E9\uD5EA\uD5EB\uD5ED\uD5EE"],
      ["c261", "\uD5EF", 4, "\uD5F6\uD5F8\uD5FA", 5, "\uD602\uD603\uD605\uD606\uD607\uD609", 6, "\uD612"],
      ["c281", "\uD616", 5, "\uD61D\uD61E\uD61F\uD621\uD622\uD623\uD625", 7, "\uD62E", 9, "\uD63A\uD63B\uC9D5\uC9D6\uC9D9\uC9DA\uC9DC\uC9DD\uC9E0\uC9E2\uC9E4\uC9E7\uC9EC\uC9ED\uC9EF\uC9F0\uC9F1\uC9F8\uC9F9\uC9FC\uCA00\uCA08\uCA09\uCA0B\uCA0C\uCA0D\uCA14\uCA18\uCA29\uCA4C\uCA4D\uCA50\uCA54\uCA5C\uCA5D\uCA5F\uCA60\uCA61\uCA68\uCA7D\uCA84\uCA98\uCABC\uCABD\uCAC0\uCAC4\uCACC\uCACD\uCACF\uCAD1\uCAD3\uCAD8\uCAD9\uCAE0\uCAEC\uCAF4\uCB08\uCB10\uCB14\uCB18\uCB20\uCB21\uCB41\uCB48\uCB49\uCB4C\uCB50\uCB58\uCB59\uCB5D\uCB64\uCB78\uCB79\uCB9C\uCBB8\uCBD4\uCBE4\uCBE7\uCBE9\uCC0C\uCC0D\uCC10\uCC14\uCC1C\uCC1D\uCC21\uCC22\uCC27\uCC28\uCC29\uCC2C\uCC2E\uCC30\uCC38\uCC39\uCC3B"],
      ["c341", "\uD63D\uD63E\uD63F\uD641\uD642\uD643\uD644\uD646\uD647\uD64A\uD64C\uD64E\uD64F\uD650\uD652\uD653\uD656\uD657\uD659\uD65A\uD65B\uD65D", 4],
      ["c361", "\uD662", 4, "\uD668\uD66A", 5, "\uD672\uD673\uD675", 11],
      ["c381", "\uD681\uD682\uD684\uD686", 5, "\uD68E\uD68F\uD691\uD692\uD693\uD695", 7, "\uD69E\uD6A0\uD6A2", 5, "\uD6A9\uD6AA\uCC3C\uCC3D\uCC3E\uCC44\uCC45\uCC48\uCC4C\uCC54\uCC55\uCC57\uCC58\uCC59\uCC60\uCC64\uCC66\uCC68\uCC70\uCC75\uCC98\uCC99\uCC9C\uCCA0\uCCA8\uCCA9\uCCAB\uCCAC\uCCAD\uCCB4\uCCB5\uCCB8\uCCBC\uCCC4\uCCC5\uCCC7\uCCC9\uCCD0\uCCD4\uCCE4\uCCEC\uCCF0\uCD01\uCD08\uCD09\uCD0C\uCD10\uCD18\uCD19\uCD1B\uCD1D\uCD24\uCD28\uCD2C\uCD39\uCD5C\uCD60\uCD64\uCD6C\uCD6D\uCD6F\uCD71\uCD78\uCD88\uCD94\uCD95\uCD98\uCD9C\uCDA4\uCDA5\uCDA7\uCDA9\uCDB0\uCDC4\uCDCC\uCDD0\uCDE8\uCDEC\uCDF0\uCDF8\uCDF9\uCDFB\uCDFD\uCE04\uCE08\uCE0C\uCE14\uCE19\uCE20\uCE21\uCE24\uCE28\uCE30\uCE31\uCE33\uCE35"],
      ["c441", "\uD6AB\uD6AD\uD6AE\uD6AF\uD6B1", 7, "\uD6BA\uD6BC", 7, "\uD6C6\uD6C7\uD6C9\uD6CA\uD6CB"],
      ["c461", "\uD6CD\uD6CE\uD6CF\uD6D0\uD6D2\uD6D3\uD6D5\uD6D6\uD6D8\uD6DA", 5, "\uD6E1\uD6E2\uD6E3\uD6E5\uD6E6\uD6E7\uD6E9", 4],
      ["c481", "\uD6EE\uD6EF\uD6F1\uD6F2\uD6F3\uD6F4\uD6F6", 5, "\uD6FE\uD6FF\uD701\uD702\uD703\uD705", 11, "\uD712\uD713\uD714\uCE58\uCE59\uCE5C\uCE5F\uCE60\uCE61\uCE68\uCE69\uCE6B\uCE6D\uCE74\uCE75\uCE78\uCE7C\uCE84\uCE85\uCE87\uCE89\uCE90\uCE91\uCE94\uCE98\uCEA0\uCEA1\uCEA3\uCEA4\uCEA5\uCEAC\uCEAD\uCEC1\uCEE4\uCEE5\uCEE8\uCEEB\uCEEC\uCEF4\uCEF5\uCEF7\uCEF8\uCEF9\uCF00\uCF01\uCF04\uCF08\uCF10\uCF11\uCF13\uCF15\uCF1C\uCF20\uCF24\uCF2C\uCF2D\uCF2F\uCF30\uCF31\uCF38\uCF54\uCF55\uCF58\uCF5C\uCF64\uCF65\uCF67\uCF69\uCF70\uCF71\uCF74\uCF78\uCF80\uCF85\uCF8C\uCFA1\uCFA8\uCFB0\uCFC4\uCFE0\uCFE1\uCFE4\uCFE8\uCFF0\uCFF1\uCFF3\uCFF5\uCFFC\uD000\uD004\uD011\uD018\uD02D\uD034\uD035\uD038\uD03C"],
      ["c541", "\uD715\uD716\uD717\uD71A\uD71B\uD71D\uD71E\uD71F\uD721", 6, "\uD72A\uD72C\uD72E", 5, "\uD736\uD737\uD739"],
      ["c561", "\uD73A\uD73B\uD73D", 6, "\uD745\uD746\uD748\uD74A", 5, "\uD752\uD753\uD755\uD75A", 4],
      ["c581", "\uD75F\uD762\uD764\uD766\uD767\uD768\uD76A\uD76B\uD76D\uD76E\uD76F\uD771\uD772\uD773\uD775", 6, "\uD77E\uD77F\uD780\uD782", 5, "\uD78A\uD78B\uD044\uD045\uD047\uD049\uD050\uD054\uD058\uD060\uD06C\uD06D\uD070\uD074\uD07C\uD07D\uD081\uD0A4\uD0A5\uD0A8\uD0AC\uD0B4\uD0B5\uD0B7\uD0B9\uD0C0\uD0C1\uD0C4\uD0C8\uD0C9\uD0D0\uD0D1\uD0D3\uD0D4\uD0D5\uD0DC\uD0DD\uD0E0\uD0E4\uD0EC\uD0ED\uD0EF\uD0F0\uD0F1\uD0F8\uD10D\uD130\uD131\uD134\uD138\uD13A\uD140\uD141\uD143\uD144\uD145\uD14C\uD14D\uD150\uD154\uD15C\uD15D\uD15F\uD161\uD168\uD16C\uD17C\uD184\uD188\uD1A0\uD1A1\uD1A4\uD1A8\uD1B0\uD1B1\uD1B3\uD1B5\uD1BA\uD1BC\uD1C0\uD1D8\uD1F4\uD1F8\uD207\uD209\uD210\uD22C\uD22D\uD230\uD234\uD23C\uD23D\uD23F\uD241\uD248\uD25C"],
      ["c641", "\uD78D\uD78E\uD78F\uD791", 6, "\uD79A\uD79C\uD79E", 5],
      ["c6a1", "\uD264\uD280\uD281\uD284\uD288\uD290\uD291\uD295\uD29C\uD2A0\uD2A4\uD2AC\uD2B1\uD2B8\uD2B9\uD2BC\uD2BF\uD2C0\uD2C2\uD2C8\uD2C9\uD2CB\uD2D4\uD2D8\uD2DC\uD2E4\uD2E5\uD2F0\uD2F1\uD2F4\uD2F8\uD300\uD301\uD303\uD305\uD30C\uD30D\uD30E\uD310\uD314\uD316\uD31C\uD31D\uD31F\uD320\uD321\uD325\uD328\uD329\uD32C\uD330\uD338\uD339\uD33B\uD33C\uD33D\uD344\uD345\uD37C\uD37D\uD380\uD384\uD38C\uD38D\uD38F\uD390\uD391\uD398\uD399\uD39C\uD3A0\uD3A8\uD3A9\uD3AB\uD3AD\uD3B4\uD3B8\uD3BC\uD3C4\uD3C5\uD3C8\uD3C9\uD3D0\uD3D8\uD3E1\uD3E3\uD3EC\uD3ED\uD3F0\uD3F4\uD3FC\uD3FD\uD3FF\uD401"],
      ["c7a1", "\uD408\uD41D\uD440\uD444\uD45C\uD460\uD464\uD46D\uD46F\uD478\uD479\uD47C\uD47F\uD480\uD482\uD488\uD489\uD48B\uD48D\uD494\uD4A9\uD4CC\uD4D0\uD4D4\uD4DC\uD4DF\uD4E8\uD4EC\uD4F0\uD4F8\uD4FB\uD4FD\uD504\uD508\uD50C\uD514\uD515\uD517\uD53C\uD53D\uD540\uD544\uD54C\uD54D\uD54F\uD551\uD558\uD559\uD55C\uD560\uD565\uD568\uD569\uD56B\uD56D\uD574\uD575\uD578\uD57C\uD584\uD585\uD587\uD588\uD589\uD590\uD5A5\uD5C8\uD5C9\uD5CC\uD5D0\uD5D2\uD5D8\uD5D9\uD5DB\uD5DD\uD5E4\uD5E5\uD5E8\uD5EC\uD5F4\uD5F5\uD5F7\uD5F9\uD600\uD601\uD604\uD608\uD610\uD611\uD613\uD614\uD615\uD61C\uD620"],
      ["c8a1", "\uD624\uD62D\uD638\uD639\uD63C\uD640\uD645\uD648\uD649\uD64B\uD64D\uD651\uD654\uD655\uD658\uD65C\uD667\uD669\uD670\uD671\uD674\uD683\uD685\uD68C\uD68D\uD690\uD694\uD69D\uD69F\uD6A1\uD6A8\uD6AC\uD6B0\uD6B9\uD6BB\uD6C4\uD6C5\uD6C8\uD6CC\uD6D1\uD6D4\uD6D7\uD6D9\uD6E0\uD6E4\uD6E8\uD6F0\uD6F5\uD6FC\uD6FD\uD700\uD704\uD711\uD718\uD719\uD71C\uD720\uD728\uD729\uD72B\uD72D\uD734\uD735\uD738\uD73C\uD744\uD747\uD749\uD750\uD751\uD754\uD756\uD757\uD758\uD759\uD760\uD761\uD763\uD765\uD769\uD76C\uD770\uD774\uD77C\uD77D\uD781\uD788\uD789\uD78C\uD790\uD798\uD799\uD79B\uD79D"],
      ["caa1", "\u4F3D\u4F73\u5047\u50F9\u52A0\u53EF\u5475\u54E5\u5609\u5AC1\u5BB6\u6687\u67B6\u67B7\u67EF\u6B4C\u73C2\u75C2\u7A3C\u82DB\u8304\u8857\u8888\u8A36\u8CC8\u8DCF\u8EFB\u8FE6\u99D5\u523B\u5374\u5404\u606A\u6164\u6BBC\u73CF\u811A\u89BA\u89D2\u95A3\u4F83\u520A\u58BE\u5978\u59E6\u5E72\u5E79\u61C7\u63C0\u6746\u67EC\u687F\u6F97\u764E\u770B\u78F5\u7A08\u7AFF\u7C21\u809D\u826E\u8271\u8AEB\u9593\u4E6B\u559D\u66F7\u6E34\u78A3\u7AED\u845B\u8910\u874E\u97A8\u52D8\u574E\u582A\u5D4C\u611F\u61BE\u6221\u6562\u67D1\u6A44\u6E1B\u7518\u75B3\u76E3\u77B0\u7D3A\u90AF\u9451\u9452\u9F95"],
      ["cba1", "\u5323\u5CAC\u7532\u80DB\u9240\u9598\u525B\u5808\u59DC\u5CA1\u5D17\u5EB7\u5F3A\u5F4A\u6177\u6C5F\u757A\u7586\u7CE0\u7D73\u7DB1\u7F8C\u8154\u8221\u8591\u8941\u8B1B\u92FC\u964D\u9C47\u4ECB\u4EF7\u500B\u51F1\u584F\u6137\u613E\u6168\u6539\u69EA\u6F11\u75A5\u7686\u76D6\u7B87\u82A5\u84CB\uF900\u93A7\u958B\u5580\u5BA2\u5751\uF901\u7CB3\u7FB9\u91B5\u5028\u53BB\u5C45\u5DE8\u62D2\u636E\u64DA\u64E7\u6E20\u70AC\u795B\u8DDD\u8E1E\uF902\u907D\u9245\u92F8\u4E7E\u4EF6\u5065\u5DFE\u5EFA\u6106\u6957\u8171\u8654\u8E47\u9375\u9A2B\u4E5E\u5091\u6770\u6840\u5109\u528D\u5292\u6AA2"],
      ["cca1", "\u77BC\u9210\u9ED4\u52AB\u602F\u8FF2\u5048\u61A9\u63ED\u64CA\u683C\u6A84\u6FC0\u8188\u89A1\u9694\u5805\u727D\u72AC\u7504\u7D79\u7E6D\u80A9\u898B\u8B74\u9063\u9D51\u6289\u6C7A\u6F54\u7D50\u7F3A\u8A23\u517C\u614A\u7B9D\u8B19\u9257\u938C\u4EAC\u4FD3\u501E\u50BE\u5106\u52C1\u52CD\u537F\u5770\u5883\u5E9A\u5F91\u6176\u61AC\u64CE\u656C\u666F\u66BB\u66F4\u6897\u6D87\u7085\u70F1\u749F\u74A5\u74CA\u75D9\u786C\u78EC\u7ADF\u7AF6\u7D45\u7D93\u8015\u803F\u811B\u8396\u8B66\u8F15\u9015\u93E1\u9803\u9838\u9A5A\u9BE8\u4FC2\u5553\u583A\u5951\u5B63\u5C46\u60B8\u6212\u6842\u68B0"],
      ["cda1", "\u68E8\u6EAA\u754C\u7678\u78CE\u7A3D\u7CFB\u7E6B\u7E7C\u8A08\u8AA1\u8C3F\u968E\u9DC4\u53E4\u53E9\u544A\u5471\u56FA\u59D1\u5B64\u5C3B\u5EAB\u62F7\u6537\u6545\u6572\u66A0\u67AF\u69C1\u6CBD\u75FC\u7690\u777E\u7A3F\u7F94\u8003\u80A1\u818F\u82E6\u82FD\u83F0\u85C1\u8831\u88B4\u8AA5\uF903\u8F9C\u932E\u96C7\u9867\u9AD8\u9F13\u54ED\u659B\u66F2\u688F\u7A40\u8C37\u9D60\u56F0\u5764\u5D11\u6606\u68B1\u68CD\u6EFE\u7428\u889E\u9BE4\u6C68\uF904\u9AA8\u4F9B\u516C\u5171\u529F\u5B54\u5DE5\u6050\u606D\u62F1\u63A7\u653B\u73D9\u7A7A\u86A3\u8CA2\u978F\u4E32\u5BE1\u6208\u679C\u74DC"],
      ["cea1", "\u79D1\u83D3\u8A87\u8AB2\u8DE8\u904E\u934B\u9846\u5ED3\u69E8\u85FF\u90ED\uF905\u51A0\u5B98\u5BEC\u6163\u68FA\u6B3E\u704C\u742F\u74D8\u7BA1\u7F50\u83C5\u89C0\u8CAB\u95DC\u9928\u522E\u605D\u62EC\u9002\u4F8A\u5149\u5321\u58D9\u5EE3\u66E0\u6D38\u709A\u72C2\u73D6\u7B50\u80F1\u945B\u5366\u639B\u7F6B\u4E56\u5080\u584A\u58DE\u602A\u6127\u62D0\u69D0\u9B41\u5B8F\u7D18\u80B1\u8F5F\u4EA4\u50D1\u54AC\u55AC\u5B0C\u5DA0\u5DE7\u652A\u654E\u6821\u6A4B\u72E1\u768E\u77EF\u7D5E\u7FF9\u81A0\u854E\u86DF\u8F03\u8F4E\u90CA\u9903\u9A55\u9BAB\u4E18\u4E45\u4E5D\u4EC7\u4FF1\u5177\u52FE"],
      ["cfa1", "\u5340\u53E3\u53E5\u548E\u5614\u5775\u57A2\u5BC7\u5D87\u5ED0\u61FC\u62D8\u6551\u67B8\u67E9\u69CB\u6B50\u6BC6\u6BEC\u6C42\u6E9D\u7078\u72D7\u7396\u7403\u77BF\u77E9\u7A76\u7D7F\u8009\u81FC\u8205\u820A\u82DF\u8862\u8B33\u8CFC\u8EC0\u9011\u90B1\u9264\u92B6\u99D2\u9A45\u9CE9\u9DD7\u9F9C\u570B\u5C40\u83CA\u97A0\u97AB\u9EB4\u541B\u7A98\u7FA4\u88D9\u8ECD\u90E1\u5800\u5C48\u6398\u7A9F\u5BAE\u5F13\u7A79\u7AAE\u828E\u8EAC\u5026\u5238\u52F8\u5377\u5708\u62F3\u6372\u6B0A\u6DC3\u7737\u53A5\u7357\u8568\u8E76\u95D5\u673A\u6AC3\u6F70\u8A6D\u8ECC\u994B\uF906\u6677\u6B78\u8CB4"],
      ["d0a1", "\u9B3C\uF907\u53EB\u572D\u594E\u63C6\u69FB\u73EA\u7845\u7ABA\u7AC5\u7CFE\u8475\u898F\u8D73\u9035\u95A8\u52FB\u5747\u7547\u7B60\u83CC\u921E\uF908\u6A58\u514B\u524B\u5287\u621F\u68D8\u6975\u9699\u50C5\u52A4\u52E4\u61C3\u65A4\u6839\u69FF\u747E\u7B4B\u82B9\u83EB\u89B2\u8B39\u8FD1\u9949\uF909\u4ECA\u5997\u64D2\u6611\u6A8E\u7434\u7981\u79BD\u82A9\u887E\u887F\u895F\uF90A\u9326\u4F0B\u53CA\u6025\u6271\u6C72\u7D1A\u7D66\u4E98\u5162\u77DC\u80AF\u4F01\u4F0E\u5176\u5180\u55DC\u5668\u573B\u57FA\u57FC\u5914\u5947\u5993\u5BC4\u5C90\u5D0E\u5DF1\u5E7E\u5FCC\u6280\u65D7\u65E3"],
      ["d1a1", "\u671E\u671F\u675E\u68CB\u68C4\u6A5F\u6B3A\u6C23\u6C7D\u6C82\u6DC7\u7398\u7426\u742A\u7482\u74A3\u7578\u757F\u7881\u78EF\u7941\u7947\u7948\u797A\u7B95\u7D00\u7DBA\u7F88\u8006\u802D\u808C\u8A18\u8B4F\u8C48\u8D77\u9321\u9324\u98E2\u9951\u9A0E\u9A0F\u9A65\u9E92\u7DCA\u4F76\u5409\u62EE\u6854\u91D1\u55AB\u513A\uF90B\uF90C\u5A1C\u61E6\uF90D\u62CF\u62FF\uF90E", 5, "\u90A3\uF914", 4, "\u8AFE\uF919\uF91A\uF91B\uF91C\u6696\uF91D\u7156\uF91E\uF91F\u96E3\uF920\u634F\u637A\u5357\uF921\u678F\u6960\u6E73\uF922\u7537\uF923\uF924\uF925"],
      ["d2a1", "\u7D0D\uF926\uF927\u8872\u56CA\u5A18\uF928", 4, "\u4E43\uF92D\u5167\u5948\u67F0\u8010\uF92E\u5973\u5E74\u649A\u79CA\u5FF5\u606C\u62C8\u637B\u5BE7\u5BD7\u52AA\uF92F\u5974\u5F29\u6012\uF930\uF931\uF932\u7459\uF933", 5, "\u99D1\uF939", 10, "\u6FC3\uF944\uF945\u81BF\u8FB2\u60F1\uF946\uF947\u8166\uF948\uF949\u5C3F\uF94A", 7, "\u5AE9\u8A25\u677B\u7D10\uF952", 5, "\u80FD\uF958\uF959\u5C3C\u6CE5\u533F\u6EBA\u591A\u8336"],
      ["d3a1", "\u4E39\u4EB6\u4F46\u55AE\u5718\u58C7\u5F56\u65B7\u65E6\u6A80\u6BB5\u6E4D\u77ED\u7AEF\u7C1E\u7DDE\u86CB\u8892\u9132\u935B\u64BB\u6FBE\u737A\u75B8\u9054\u5556\u574D\u61BA\u64D4\u66C7\u6DE1\u6E5B\u6F6D\u6FB9\u75F0\u8043\u81BD\u8541\u8983\u8AC7\u8B5A\u931F\u6C93\u7553\u7B54\u8E0F\u905D\u5510\u5802\u5858\u5E62\u6207\u649E\u68E0\u7576\u7CD6\u87B3\u9EE8\u4EE3\u5788\u576E\u5927\u5C0D\u5CB1\u5E36\u5F85\u6234\u64E1\u73B3\u81FA\u888B\u8CB8\u968A\u9EDB\u5B85\u5FB7\u60B3\u5012\u5200\u5230\u5716\u5835\u5857\u5C0E\u5C60\u5CF6\u5D8B\u5EA6\u5F92\u60BC\u6311\u6389\u6417\u6843"],
      ["d4a1", "\u68F9\u6AC2\u6DD8\u6E21\u6ED4\u6FE4\u71FE\u76DC\u7779\u79B1\u7A3B\u8404\u89A9\u8CED\u8DF3\u8E48\u9003\u9014\u9053\u90FD\u934D\u9676\u97DC\u6BD2\u7006\u7258\u72A2\u7368\u7763\u79BF\u7BE4\u7E9B\u8B80\u58A9\u60C7\u6566\u65FD\u66BE\u6C8C\u711E\u71C9\u8C5A\u9813\u4E6D\u7A81\u4EDD\u51AC\u51CD\u52D5\u540C\u61A7\u6771\u6850\u68DF\u6D1E\u6F7C\u75BC\u77B3\u7AE5\u80F4\u8463\u9285\u515C\u6597\u675C\u6793\u75D8\u7AC7\u8373\uF95A\u8C46\u9017\u982D\u5C6F\u81C0\u829A\u9041\u906F\u920D\u5F97\u5D9D\u6A59\u71C8\u767B\u7B49\u85E4\u8B04\u9127\u9A30\u5587\u61F6\uF95B\u7669\u7F85"],
      ["d5a1", "\u863F\u87BA\u88F8\u908F\uF95C\u6D1B\u70D9\u73DE\u7D61\u843D\uF95D\u916A\u99F1\uF95E\u4E82\u5375\u6B04\u6B12\u703E\u721B\u862D\u9E1E\u524C\u8FA3\u5D50\u64E5\u652C\u6B16\u6FEB\u7C43\u7E9C\u85CD\u8964\u89BD\u62C9\u81D8\u881F\u5ECA\u6717\u6D6A\u72FC\u7405\u746F\u8782\u90DE\u4F86\u5D0D\u5FA0\u840A\u51B7\u63A0\u7565\u4EAE\u5006\u5169\u51C9\u6881\u6A11\u7CAE\u7CB1\u7CE7\u826F\u8AD2\u8F1B\u91CF\u4FB6\u5137\u52F5\u5442\u5EEC\u616E\u623E\u65C5\u6ADA\u6FFE\u792A\u85DC\u8823\u95AD\u9A62\u9A6A\u9E97\u9ECE\u529B\u66C6\u6B77\u701D\u792B\u8F62\u9742\u6190\u6200\u6523\u6F23"],
      ["d6a1", "\u7149\u7489\u7DF4\u806F\u84EE\u8F26\u9023\u934A\u51BD\u5217\u52A3\u6D0C\u70C8\u88C2\u5EC9\u6582\u6BAE\u6FC2\u7C3E\u7375\u4EE4\u4F36\u56F9\uF95F\u5CBA\u5DBA\u601C\u73B2\u7B2D\u7F9A\u7FCE\u8046\u901E\u9234\u96F6\u9748\u9818\u9F61\u4F8B\u6FA7\u79AE\u91B4\u96B7\u52DE\uF960\u6488\u64C4\u6AD3\u6F5E\u7018\u7210\u76E7\u8001\u8606\u865C\u8DEF\u8F05\u9732\u9B6F\u9DFA\u9E75\u788C\u797F\u7DA0\u83C9\u9304\u9E7F\u9E93\u8AD6\u58DF\u5F04\u6727\u7027\u74CF\u7C60\u807E\u5121\u7028\u7262\u78CA\u8CC2\u8CDA\u8CF4\u96F7\u4E86\u50DA\u5BEE\u5ED6\u6599\u71CE\u7642\u77AD\u804A\u84FC"],
      ["d7a1", "\u907C\u9B27\u9F8D\u58D8\u5A41\u5C62\u6A13\u6DDA\u6F0F\u763B\u7D2F\u7E37\u851E\u8938\u93E4\u964B\u5289\u65D2\u67F3\u69B4\u6D41\u6E9C\u700F\u7409\u7460\u7559\u7624\u786B\u8B2C\u985E\u516D\u622E\u9678\u4F96\u502B\u5D19\u6DEA\u7DB8\u8F2A\u5F8B\u6144\u6817\uF961\u9686\u52D2\u808B\u51DC\u51CC\u695E\u7A1C\u7DBE\u83F1\u9675\u4FDA\u5229\u5398\u540F\u550E\u5C65\u60A7\u674E\u68A8\u6D6C\u7281\u72F8\u7406\u7483\uF962\u75E2\u7C6C\u7F79\u7FB8\u8389\u88CF\u88E1\u91CC\u91D0\u96E2\u9BC9\u541D\u6F7E\u71D0\u7498\u85FA\u8EAA\u96A3\u9C57\u9E9F\u6797\u6DCB\u7433\u81E8\u9716\u782C"],
      ["d8a1", "\u7ACB\u7B20\u7C92\u6469\u746A\u75F2\u78BC\u78E8\u99AC\u9B54\u9EBB\u5BDE\u5E55\u6F20\u819C\u83AB\u9088\u4E07\u534D\u5A29\u5DD2\u5F4E\u6162\u633D\u6669\u66FC\u6EFF\u6F2B\u7063\u779E\u842C\u8513\u883B\u8F13\u9945\u9C3B\u551C\u62B9\u672B\u6CAB\u8309\u896A\u977A\u4EA1\u5984\u5FD8\u5FD9\u671B\u7DB2\u7F54\u8292\u832B\u83BD\u8F1E\u9099\u57CB\u59B9\u5A92\u5BD0\u6627\u679A\u6885\u6BCF\u7164\u7F75\u8CB7\u8CE3\u9081\u9B45\u8108\u8C8A\u964C\u9A40\u9EA5\u5B5F\u6C13\u731B\u76F2\u76DF\u840C\u51AA\u8993\u514D\u5195\u52C9\u68C9\u6C94\u7704\u7720\u7DBF\u7DEC\u9762\u9EB5\u6EC5"],
      ["d9a1", "\u8511\u51A5\u540D\u547D\u660E\u669D\u6927\u6E9F\u76BF\u7791\u8317\u84C2\u879F\u9169\u9298\u9CF4\u8882\u4FAE\u5192\u52DF\u59C6\u5E3D\u6155\u6478\u6479\u66AE\u67D0\u6A21\u6BCD\u6BDB\u725F\u7261\u7441\u7738\u77DB\u8017\u82BC\u8305\u8B00\u8B28\u8C8C\u6728\u6C90\u7267\u76EE\u7766\u7A46\u9DA9\u6B7F\u6C92\u5922\u6726\u8499\u536F\u5893\u5999\u5EDF\u63CF\u6634\u6773\u6E3A\u732B\u7AD7\u82D7\u9328\u52D9\u5DEB\u61AE\u61CB\u620A\u62C7\u64AB\u65E0\u6959\u6B66\u6BCB\u7121\u73F7\u755D\u7E46\u821E\u8302\u856A\u8AA3\u8CBF\u9727\u9D61\u58A8\u9ED8\u5011\u520E\u543B\u554F\u6587"],
      ["daa1", "\u6C76\u7D0A\u7D0B\u805E\u868A\u9580\u96EF\u52FF\u6C95\u7269\u5473\u5A9A\u5C3E\u5D4B\u5F4C\u5FAE\u672A\u68B6\u6963\u6E3C\u6E44\u7709\u7C73\u7F8E\u8587\u8B0E\u8FF7\u9761\u9EF4\u5CB7\u60B6\u610D\u61AB\u654F\u65FB\u65FC\u6C11\u6CEF\u739F\u73C9\u7DE1\u9594\u5BC6\u871C\u8B10\u525D\u535A\u62CD\u640F\u64B2\u6734\u6A38\u6CCA\u73C0\u749E\u7B94\u7C95\u7E1B\u818A\u8236\u8584\u8FEB\u96F9\u99C1\u4F34\u534A\u53CD\u53DB\u62CC\u642C\u6500\u6591\u69C3\u6CEE\u6F58\u73ED\u7554\u7622\u76E4\u76FC\u78D0\u78FB\u792C\u7D46\u822C\u87E0\u8FD4\u9812\u98EF\u52C3\u62D4\u64A5\u6E24\u6F51"],
      ["dba1", "\u767C\u8DCB\u91B1\u9262\u9AEE\u9B43\u5023\u508D\u574A\u59A8\u5C28\u5E47\u5F77\u623F\u653E\u65B9\u65C1\u6609\u678B\u699C\u6EC2\u78C5\u7D21\u80AA\u8180\u822B\u82B3\u84A1\u868C\u8A2A\u8B17\u90A6\u9632\u9F90\u500D\u4FF3\uF963\u57F9\u5F98\u62DC\u6392\u676F\u6E43\u7119\u76C3\u80CC\u80DA\u88F4\u88F5\u8919\u8CE0\u8F29\u914D\u966A\u4F2F\u4F70\u5E1B\u67CF\u6822\u767D\u767E\u9B44\u5E61\u6A0A\u7169\u71D4\u756A\uF964\u7E41\u8543\u85E9\u98DC\u4F10\u7B4F\u7F70\u95A5\u51E1\u5E06\u68B5\u6C3E\u6C4E\u6CDB\u72AF\u7BC4\u8303\u6CD5\u743A\u50FB\u5288\u58C1\u64D8\u6A97\u74A7\u7656"],
      ["dca1", "\u78A7\u8617\u95E2\u9739\uF965\u535E\u5F01\u8B8A\u8FA8\u8FAF\u908A\u5225\u77A5\u9C49\u9F08\u4E19\u5002\u5175\u5C5B\u5E77\u661E\u663A\u67C4\u68C5\u70B3\u7501\u75C5\u79C9\u7ADD\u8F27\u9920\u9A08\u4FDD\u5821\u5831\u5BF6\u666E\u6B65\u6D11\u6E7A\u6F7D\u73E4\u752B\u83E9\u88DC\u8913\u8B5C\u8F14\u4F0F\u50D5\u5310\u535C\u5B93\u5FA9\u670D\u798F\u8179\u832F\u8514\u8907\u8986\u8F39\u8F3B\u99A5\u9C12\u672C\u4E76\u4FF8\u5949\u5C01\u5CEF\u5CF0\u6367\u68D2\u70FD\u71A2\u742B\u7E2B\u84EC\u8702\u9022\u92D2\u9CF3\u4E0D\u4ED8\u4FEF\u5085\u5256\u526F\u5426\u5490\u57E0\u592B\u5A66"],
      ["dda1", "\u5B5A\u5B75\u5BCC\u5E9C\uF966\u6276\u6577\u65A7\u6D6E\u6EA5\u7236\u7B26\u7C3F\u7F36\u8150\u8151\u819A\u8240\u8299\u83A9\u8A03\u8CA0\u8CE6\u8CFB\u8D74\u8DBA\u90E8\u91DC\u961C\u9644\u99D9\u9CE7\u5317\u5206\u5429\u5674\u58B3\u5954\u596E\u5FFF\u61A4\u626E\u6610\u6C7E\u711A\u76C6\u7C89\u7CDE\u7D1B\u82AC\u8CC1\u96F0\uF967\u4F5B\u5F17\u5F7F\u62C2\u5D29\u670B\u68DA\u787C\u7E43\u9D6C\u4E15\u5099\u5315\u532A\u5351\u5983\u5A62\u5E87\u60B2\u618A\u6249\u6279\u6590\u6787\u69A7\u6BD4\u6BD6\u6BD7\u6BD8\u6CB8\uF968\u7435\u75FA\u7812\u7891\u79D5\u79D8\u7C83\u7DCB\u7FE1\u80A5"],
      ["dea1", "\u813E\u81C2\u83F2\u871A\u88E8\u8AB9\u8B6C\u8CBB\u9119\u975E\u98DB\u9F3B\u56AC\u5B2A\u5F6C\u658C\u6AB3\u6BAF\u6D5C\u6FF1\u7015\u725D\u73AD\u8CA7\u8CD3\u983B\u6191\u6C37\u8058\u9A01\u4E4D\u4E8B\u4E9B\u4ED5\u4F3A\u4F3C\u4F7F\u4FDF\u50FF\u53F2\u53F8\u5506\u55E3\u56DB\u58EB\u5962\u5A11\u5BEB\u5BFA\u5C04\u5DF3\u5E2B\u5F99\u601D\u6368\u659C\u65AF\u67F6\u67FB\u68AD\u6B7B\u6C99\u6CD7\u6E23\u7009\u7345\u7802\u793E\u7940\u7960\u79C1\u7BE9\u7D17\u7D72\u8086\u820D\u838E\u84D1\u86C7\u88DF\u8A50\u8A5E\u8B1D\u8CDC\u8D66\u8FAD\u90AA\u98FC\u99DF\u9E9D\u524A\uF969\u6714\uF96A"],
      ["dfa1", "\u5098\u522A\u5C71\u6563\u6C55\u73CA\u7523\u759D\u7B97\u849C\u9178\u9730\u4E77\u6492\u6BBA\u715E\u85A9\u4E09\uF96B\u6749\u68EE\u6E17\u829F\u8518\u886B\u63F7\u6F81\u9212\u98AF\u4E0A\u50B7\u50CF\u511F\u5546\u55AA\u5617\u5B40\u5C19\u5CE0\u5E38\u5E8A\u5EA0\u5EC2\u60F3\u6851\u6A61\u6E58\u723D\u7240\u72C0\u76F8\u7965\u7BB1\u7FD4\u88F3\u89F4\u8A73\u8C61\u8CDE\u971C\u585E\u74BD\u8CFD\u55C7\uF96C\u7A61\u7D22\u8272\u7272\u751F\u7525\uF96D\u7B19\u5885\u58FB\u5DBC\u5E8F\u5EB6\u5F90\u6055\u6292\u637F\u654D\u6691\u66D9\u66F8\u6816\u68F2\u7280\u745E\u7B6E\u7D6E\u7DD6\u7F72"],
      ["e0a1", "\u80E5\u8212\u85AF\u897F\u8A93\u901D\u92E4\u9ECD\u9F20\u5915\u596D\u5E2D\u60DC\u6614\u6673\u6790\u6C50\u6DC5\u6F5F\u77F3\u78A9\u84C6\u91CB\u932B\u4ED9\u50CA\u5148\u5584\u5B0B\u5BA3\u6247\u657E\u65CB\u6E32\u717D\u7401\u7444\u7487\u74BF\u766C\u79AA\u7DDA\u7E55\u7FA8\u817A\u81B3\u8239\u861A\u87EC\u8A75\u8DE3\u9078\u9291\u9425\u994D\u9BAE\u5368\u5C51\u6954\u6CC4\u6D29\u6E2B\u820C\u859B\u893B\u8A2D\u8AAA\u96EA\u9F67\u5261\u66B9\u6BB2\u7E96\u87FE\u8D0D\u9583\u965D\u651D\u6D89\u71EE\uF96E\u57CE\u59D3\u5BAC\u6027\u60FA\u6210\u661F\u665F\u7329\u73F9\u76DB\u7701\u7B6C"],
      ["e1a1", "\u8056\u8072\u8165\u8AA0\u9192\u4E16\u52E2\u6B72\u6D17\u7A05\u7B39\u7D30\uF96F\u8CB0\u53EC\u562F\u5851\u5BB5\u5C0F\u5C11\u5DE2\u6240\u6383\u6414\u662D\u68B3\u6CBC\u6D88\u6EAF\u701F\u70A4\u71D2\u7526\u758F\u758E\u7619\u7B11\u7BE0\u7C2B\u7D20\u7D39\u852C\u856D\u8607\u8A34\u900D\u9061\u90B5\u92B7\u97F6\u9A37\u4FD7\u5C6C\u675F\u6D91\u7C9F\u7E8C\u8B16\u8D16\u901F\u5B6B\u5DFD\u640D\u84C0\u905C\u98E1\u7387\u5B8B\u609A\u677E\u6DDE\u8A1F\u8AA6\u9001\u980C\u5237\uF970\u7051\u788E\u9396\u8870\u91D7\u4FEE\u53D7\u55FD\u56DA\u5782\u58FD\u5AC2\u5B88\u5CAB\u5CC0\u5E25\u6101"],
      ["e2a1", "\u620D\u624B\u6388\u641C\u6536\u6578\u6A39\u6B8A\u6C34\u6D19\u6F31\u71E7\u72E9\u7378\u7407\u74B2\u7626\u7761\u79C0\u7A57\u7AEA\u7CB9\u7D8F\u7DAC\u7E61\u7F9E\u8129\u8331\u8490\u84DA\u85EA\u8896\u8AB0\u8B90\u8F38\u9042\u9083\u916C\u9296\u92B9\u968B\u96A7\u96A8\u96D6\u9700\u9808\u9996\u9AD3\u9B1A\u53D4\u587E\u5919\u5B70\u5BBF\u6DD1\u6F5A\u719F\u7421\u74B9\u8085\u83FD\u5DE1\u5F87\u5FAA\u6042\u65EC\u6812\u696F\u6A53\u6B89\u6D35\u6DF3\u73E3\u76FE\u77AC\u7B4D\u7D14\u8123\u821C\u8340\u84F4\u8563\u8A62\u8AC4\u9187\u931E\u9806\u99B4\u620C\u8853\u8FF0\u9265\u5D07\u5D27"],
      ["e3a1", "\u5D69\u745F\u819D\u8768\u6FD5\u62FE\u7FD2\u8936\u8972\u4E1E\u4E58\u50E7\u52DD\u5347\u627F\u6607\u7E69\u8805\u965E\u4F8D\u5319\u5636\u59CB\u5AA4\u5C38\u5C4E\u5C4D\u5E02\u5F11\u6043\u65BD\u662F\u6642\u67BE\u67F4\u731C\u77E2\u793A\u7FC5\u8494\u84CD\u8996\u8A66\u8A69\u8AE1\u8C55\u8C7A\u57F4\u5BD4\u5F0F\u606F\u62ED\u690D\u6B96\u6E5C\u7184\u7BD2\u8755\u8B58\u8EFE\u98DF\u98FE\u4F38\u4F81\u4FE1\u547B\u5A20\u5BB8\u613C\u65B0\u6668\u71FC\u7533\u795E\u7D33\u814E\u81E3\u8398\u85AA\u85CE\u8703\u8A0A\u8EAB\u8F9B\uF971\u8FC5\u5931\u5BA4\u5BE6\u6089\u5BE9\u5C0B\u5FC3\u6C81"],
      ["e4a1", "\uF972\u6DF1\u700B\u751A\u82AF\u8AF6\u4EC0\u5341\uF973\u96D9\u6C0F\u4E9E\u4FC4\u5152\u555E\u5A25\u5CE8\u6211\u7259\u82BD\u83AA\u86FE\u8859\u8A1D\u963F\u96C5\u9913\u9D09\u9D5D\u580A\u5CB3\u5DBD\u5E44\u60E1\u6115\u63E1\u6A02\u6E25\u9102\u9354\u984E\u9C10\u9F77\u5B89\u5CB8\u6309\u664F\u6848\u773C\u96C1\u978D\u9854\u9B9F\u65A1\u8B01\u8ECB\u95BC\u5535\u5CA9\u5DD6\u5EB5\u6697\u764C\u83F4\u95C7\u58D3\u62BC\u72CE\u9D28\u4EF0\u592E\u600F\u663B\u6B83\u79E7\u9D26\u5393\u54C0\u57C3\u5D16\u611B\u66D6\u6DAF\u788D\u827E\u9698\u9744\u5384\u627C\u6396\u6DB2\u7E0A\u814B\u984D"],
      ["e5a1", "\u6AFB\u7F4C\u9DAF\u9E1A\u4E5F\u503B\u51B6\u591C\u60F9\u63F6\u6930\u723A\u8036\uF974\u91CE\u5F31\uF975\uF976\u7D04\u82E5\u846F\u84BB\u85E5\u8E8D\uF977\u4F6F\uF978\uF979\u58E4\u5B43\u6059\u63DA\u6518\u656D\u6698\uF97A\u694A\u6A23\u6D0B\u7001\u716C\u75D2\u760D\u79B3\u7A70\uF97B\u7F8A\uF97C\u8944\uF97D\u8B93\u91C0\u967D\uF97E\u990A\u5704\u5FA1\u65BC\u6F01\u7600\u79A6\u8A9E\u99AD\u9B5A\u9F6C\u5104\u61B6\u6291\u6A8D\u81C6\u5043\u5830\u5F66\u7109\u8A00\u8AFA\u5B7C\u8616\u4FFA\u513C\u56B4\u5944\u63A9\u6DF9\u5DAA\u696D\u5186\u4E88\u4F59\uF97F\uF980\uF981\u5982\uF982"],
      ["e6a1", "\uF983\u6B5F\u6C5D\uF984\u74B5\u7916\uF985\u8207\u8245\u8339\u8F3F\u8F5D\uF986\u9918\uF987\uF988\uF989\u4EA6\uF98A\u57DF\u5F79\u6613\uF98B\uF98C\u75AB\u7E79\u8B6F\uF98D\u9006\u9A5B\u56A5\u5827\u59F8\u5A1F\u5BB4\uF98E\u5EF6\uF98F\uF990\u6350\u633B\uF991\u693D\u6C87\u6CBF\u6D8E\u6D93\u6DF5\u6F14\uF992\u70DF\u7136\u7159\uF993\u71C3\u71D5\uF994\u784F\u786F\uF995\u7B75\u7DE3\uF996\u7E2F\uF997\u884D\u8EDF\uF998\uF999\uF99A\u925B\uF99B\u9CF6\uF99C\uF99D\uF99E\u6085\u6D85\uF99F\u71B1\uF9A0\uF9A1\u95B1\u53AD\uF9A2\uF9A3\uF9A4\u67D3\uF9A5\u708E\u7130\u7430\u8276\u82D2"],
      ["e7a1", "\uF9A6\u95BB\u9AE5\u9E7D\u66C4\uF9A7\u71C1\u8449\uF9A8\uF9A9\u584B\uF9AA\uF9AB\u5DB8\u5F71\uF9AC\u6620\u668E\u6979\u69AE\u6C38\u6CF3\u6E36\u6F41\u6FDA\u701B\u702F\u7150\u71DF\u7370\uF9AD\u745B\uF9AE\u74D4\u76C8\u7A4E\u7E93\uF9AF\uF9B0\u82F1\u8A60\u8FCE\uF9B1\u9348\uF9B2\u9719\uF9B3\uF9B4\u4E42\u502A\uF9B5\u5208\u53E1\u66F3\u6C6D\u6FCA\u730A\u777F\u7A62\u82AE\u85DD\u8602\uF9B6\u88D4\u8A63\u8B7D\u8C6B\uF9B7\u92B3\uF9B8\u9713\u9810\u4E94\u4F0D\u4FC9\u50B2\u5348\u543E\u5433\u55DA\u5862\u58BA\u5967\u5A1B\u5BE4\u609F\uF9B9\u61CA\u6556\u65FF\u6664\u68A7\u6C5A\u6FB3"],
      ["e8a1", "\u70CF\u71AC\u7352\u7B7D\u8708\u8AA4\u9C32\u9F07\u5C4B\u6C83\u7344\u7389\u923A\u6EAB\u7465\u761F\u7A69\u7E15\u860A\u5140\u58C5\u64C1\u74EE\u7515\u7670\u7FC1\u9095\u96CD\u9954\u6E26\u74E6\u7AA9\u7AAA\u81E5\u86D9\u8778\u8A1B\u5A49\u5B8C\u5B9B\u68A1\u6900\u6D63\u73A9\u7413\u742C\u7897\u7DE9\u7FEB\u8118\u8155\u839E\u8C4C\u962E\u9811\u66F0\u5F80\u65FA\u6789\u6C6A\u738B\u502D\u5A03\u6B6A\u77EE\u5916\u5D6C\u5DCD\u7325\u754F\uF9BA\uF9BB\u50E5\u51F9\u582F\u592D\u5996\u59DA\u5BE5\uF9BC\uF9BD\u5DA2\u62D7\u6416\u6493\u64FE\uF9BE\u66DC\uF9BF\u6A48\uF9C0\u71FF\u7464\uF9C1"],
      ["e9a1", "\u7A88\u7AAF\u7E47\u7E5E\u8000\u8170\uF9C2\u87EF\u8981\u8B20\u9059\uF9C3\u9080\u9952\u617E\u6B32\u6D74\u7E1F\u8925\u8FB1\u4FD1\u50AD\u5197\u52C7\u57C7\u5889\u5BB9\u5EB8\u6142\u6995\u6D8C\u6E67\u6EB6\u7194\u7462\u7528\u752C\u8073\u8338\u84C9\u8E0A\u9394\u93DE\uF9C4\u4E8E\u4F51\u5076\u512A\u53C8\u53CB\u53F3\u5B87\u5BD3\u5C24\u611A\u6182\u65F4\u725B\u7397\u7440\u76C2\u7950\u7991\u79B9\u7D06\u7FBD\u828B\u85D5\u865E\u8FC2\u9047\u90F5\u91EA\u9685\u96E8\u96E9\u52D6\u5F67\u65ED\u6631\u682F\u715C\u7A36\u90C1\u980A\u4E91\uF9C5\u6A52\u6B9E\u6F90\u7189\u8018\u82B8\u8553"],
      ["eaa1", "\u904B\u9695\u96F2\u97FB\u851A\u9B31\u4E90\u718A\u96C4\u5143\u539F\u54E1\u5713\u5712\u57A3\u5A9B\u5AC4\u5BC3\u6028\u613F\u63F4\u6C85\u6D39\u6E72\u6E90\u7230\u733F\u7457\u82D1\u8881\u8F45\u9060\uF9C6\u9662\u9858\u9D1B\u6708\u8D8A\u925E\u4F4D\u5049\u50DE\u5371\u570D\u59D4\u5A01\u5C09\u6170\u6690\u6E2D\u7232\u744B\u7DEF\u80C3\u840E\u8466\u853F\u875F\u885B\u8918\u8B02\u9055\u97CB\u9B4F\u4E73\u4F91\u5112\u516A\uF9C7\u552F\u55A9\u5B7A\u5BA5\u5E7C\u5E7D\u5EBE\u60A0\u60DF\u6108\u6109\u63C4\u6538\u6709\uF9C8\u67D4\u67DA\uF9C9\u6961\u6962\u6CB9\u6D27\uF9CA\u6E38\uF9CB"],
      ["eba1", "\u6FE1\u7336\u7337\uF9CC\u745C\u7531\uF9CD\u7652\uF9CE\uF9CF\u7DAD\u81FE\u8438\u88D5\u8A98\u8ADB\u8AED\u8E30\u8E42\u904A\u903E\u907A\u9149\u91C9\u936E\uF9D0\uF9D1\u5809\uF9D2\u6BD3\u8089\u80B2\uF9D3\uF9D4\u5141\u596B\u5C39\uF9D5\uF9D6\u6F64\u73A7\u80E4\u8D07\uF9D7\u9217\u958F\uF9D8\uF9D9\uF9DA\uF9DB\u807F\u620E\u701C\u7D68\u878D\uF9DC\u57A0\u6069\u6147\u6BB7\u8ABE\u9280\u96B1\u4E59\u541F\u6DEB\u852D\u9670\u97F3\u98EE\u63D6\u6CE3\u9091\u51DD\u61C9\u81BA\u9DF9\u4F9D\u501A\u5100\u5B9C\u610F\u61FF\u64EC\u6905\u6BC5\u7591\u77E3\u7FA9\u8264\u858F\u87FB\u8863\u8ABC"],
      ["eca1", "\u8B70\u91AB\u4E8C\u4EE5\u4F0A\uF9DD\uF9DE\u5937\u59E8\uF9DF\u5DF2\u5F1B\u5F5B\u6021\uF9E0\uF9E1\uF9E2\uF9E3\u723E\u73E5\uF9E4\u7570\u75CD\uF9E5\u79FB\uF9E6\u800C\u8033\u8084\u82E1\u8351\uF9E7\uF9E8\u8CBD\u8CB3\u9087\uF9E9\uF9EA\u98F4\u990C\uF9EB\uF9EC\u7037\u76CA\u7FCA\u7FCC\u7FFC\u8B1A\u4EBA\u4EC1\u5203\u5370\uF9ED\u54BD\u56E0\u59FB\u5BC5\u5F15\u5FCD\u6E6E\uF9EE\uF9EF\u7D6A\u8335\uF9F0\u8693\u8A8D\uF9F1\u976D\u9777\uF9F2\uF9F3\u4E00\u4F5A\u4F7E\u58F9\u65E5\u6EA2\u9038\u93B0\u99B9\u4EFB\u58EC\u598A\u59D9\u6041\uF9F4\uF9F5\u7A14\uF9F6\u834F\u8CC3\u5165\u5344"],
      ["eda1", "\uF9F7\uF9F8\uF9F9\u4ECD\u5269\u5B55\u82BF\u4ED4\u523A\u54A8\u59C9\u59FF\u5B50\u5B57\u5B5C\u6063\u6148\u6ECB\u7099\u716E\u7386\u74F7\u75B5\u78C1\u7D2B\u8005\u81EA\u8328\u8517\u85C9\u8AEE\u8CC7\u96CC\u4F5C\u52FA\u56BC\u65AB\u6628\u707C\u70B8\u7235\u7DBD\u828D\u914C\u96C0\u9D72\u5B71\u68E7\u6B98\u6F7A\u76DE\u5C91\u66AB\u6F5B\u7BB4\u7C2A\u8836\u96DC\u4E08\u4ED7\u5320\u5834\u58BB\u58EF\u596C\u5C07\u5E33\u5E84\u5F35\u638C\u66B2\u6756\u6A1F\u6AA3\u6B0C\u6F3F\u7246\uF9FA\u7350\u748B\u7AE0\u7CA7\u8178\u81DF\u81E7\u838A\u846C\u8523\u8594\u85CF\u88DD\u8D13\u91AC\u9577"],
      ["eea1", "\u969C\u518D\u54C9\u5728\u5BB0\u624D\u6750\u683D\u6893\u6E3D\u6ED3\u707D\u7E21\u88C1\u8CA1\u8F09\u9F4B\u9F4E\u722D\u7B8F\u8ACD\u931A\u4F47\u4F4E\u5132\u5480\u59D0\u5E95\u62B5\u6775\u696E\u6A17\u6CAE\u6E1A\u72D9\u732A\u75BD\u7BB8\u7D35\u82E7\u83F9\u8457\u85F7\u8A5B\u8CAF\u8E87\u9019\u90B8\u96CE\u9F5F\u52E3\u540A\u5AE1\u5BC2\u6458\u6575\u6EF4\u72C4\uF9FB\u7684\u7A4D\u7B1B\u7C4D\u7E3E\u7FDF\u837B\u8B2B\u8CCA\u8D64\u8DE1\u8E5F\u8FEA\u8FF9\u9069\u93D1\u4F43\u4F7A\u50B3\u5168\u5178\u524D\u526A\u5861\u587C\u5960\u5C08\u5C55\u5EDB\u609B\u6230\u6813\u6BBF\u6C08\u6FB1"],
      ["efa1", "\u714E\u7420\u7530\u7538\u7551\u7672\u7B4C\u7B8B\u7BAD\u7BC6\u7E8F\u8A6E\u8F3E\u8F49\u923F\u9293\u9322\u942B\u96FB\u985A\u986B\u991E\u5207\u622A\u6298\u6D59\u7664\u7ACA\u7BC0\u7D76\u5360\u5CBE\u5E97\u6F38\u70B9\u7C98\u9711\u9B8E\u9EDE\u63A5\u647A\u8776\u4E01\u4E95\u4EAD\u505C\u5075\u5448\u59C3\u5B9A\u5E40\u5EAD\u5EF7\u5F81\u60C5\u633A\u653F\u6574\u65CC\u6676\u6678\u67FE\u6968\u6A89\u6B63\u6C40\u6DC0\u6DE8\u6E1F\u6E5E\u701E\u70A1\u738E\u73FD\u753A\u775B\u7887\u798E\u7A0B\u7A7D\u7CBE\u7D8E\u8247\u8A02\u8AEA\u8C9E\u912D\u914A\u91D8\u9266\u92CC\u9320\u9706\u9756"],
      ["f0a1", "\u975C\u9802\u9F0E\u5236\u5291\u557C\u5824\u5E1D\u5F1F\u608C\u63D0\u68AF\u6FDF\u796D\u7B2C\u81CD\u85BA\u88FD\u8AF8\u8E44\u918D\u9664\u969B\u973D\u984C\u9F4A\u4FCE\u5146\u51CB\u52A9\u5632\u5F14\u5F6B\u63AA\u64CD\u65E9\u6641\u66FA\u66F9\u671D\u689D\u68D7\u69FD\u6F15\u6F6E\u7167\u71E5\u722A\u74AA\u773A\u7956\u795A\u79DF\u7A20\u7A95\u7C97\u7CDF\u7D44\u7E70\u8087\u85FB\u86A4\u8A54\u8ABF\u8D99\u8E81\u9020\u906D\u91E3\u963B\u96D5\u9CE5\u65CF\u7C07\u8DB3\u93C3\u5B58\u5C0A\u5352\u62D9\u731D\u5027\u5B97\u5F9E\u60B0\u616B\u68D5\u6DD9\u742E\u7A2E\u7D42\u7D9C\u7E31\u816B"],
      ["f1a1", "\u8E2A\u8E35\u937E\u9418\u4F50\u5750\u5DE6\u5EA7\u632B\u7F6A\u4E3B\u4F4F\u4F8F\u505A\u59DD\u80C4\u546A\u5468\u55FE\u594F\u5B99\u5DDE\u5EDA\u665D\u6731\u67F1\u682A\u6CE8\u6D32\u6E4A\u6F8D\u70B7\u73E0\u7587\u7C4C\u7D02\u7D2C\u7DA2\u821F\u86DB\u8A3B\u8A85\u8D70\u8E8A\u8F33\u9031\u914E\u9152\u9444\u99D0\u7AF9\u7CA5\u4FCA\u5101\u51C6\u57C8\u5BEF\u5CFB\u6659\u6A3D\u6D5A\u6E96\u6FEC\u710C\u756F\u7AE3\u8822\u9021\u9075\u96CB\u99FF\u8301\u4E2D\u4EF2\u8846\u91CD\u537D\u6ADB\u696B\u6C41\u847A\u589E\u618E\u66FE\u62EF\u70DD\u7511\u75C7\u7E52\u84B8\u8B49\u8D08\u4E4B\u53EA"],
      ["f2a1", "\u54AB\u5730\u5740\u5FD7\u6301\u6307\u646F\u652F\u65E8\u667A\u679D\u67B3\u6B62\u6C60\u6C9A\u6F2C\u77E5\u7825\u7949\u7957\u7D19\u80A2\u8102\u81F3\u829D\u82B7\u8718\u8A8C\uF9FC\u8D04\u8DBE\u9072\u76F4\u7A19\u7A37\u7E54\u8077\u5507\u55D4\u5875\u632F\u6422\u6649\u664B\u686D\u699B\u6B84\u6D25\u6EB1\u73CD\u7468\u74A1\u755B\u75B9\u76E1\u771E\u778B\u79E6\u7E09\u7E1D\u81FB\u852F\u8897\u8A3A\u8CD1\u8EEB\u8FB0\u9032\u93AD\u9663\u9673\u9707\u4F84\u53F1\u59EA\u5AC9\u5E19\u684E\u74C6\u75BE\u79E9\u7A92\u81A3\u86ED\u8CEA\u8DCC\u8FED\u659F\u6715\uF9FD\u57F7\u6F57\u7DDD\u8F2F"],
      ["f3a1", "\u93F6\u96C6\u5FB5\u61F2\u6F84\u4E14\u4F98\u501F\u53C9\u55DF\u5D6F\u5DEE\u6B21\u6B64\u78CB\u7B9A\uF9FE\u8E49\u8ECA\u906E\u6349\u643E\u7740\u7A84\u932F\u947F\u9F6A\u64B0\u6FAF\u71E6\u74A8\u74DA\u7AC4\u7C12\u7E82\u7CB2\u7E98\u8B9A\u8D0A\u947D\u9910\u994C\u5239\u5BDF\u64E6\u672D\u7D2E\u50ED\u53C3\u5879\u6158\u6159\u61FA\u65AC\u7AD9\u8B92\u8B96\u5009\u5021\u5275\u5531\u5A3C\u5EE0\u5F70\u6134\u655E\u660C\u6636\u66A2\u69CD\u6EC4\u6F32\u7316\u7621\u7A93\u8139\u8259\u83D6\u84BC\u50B5\u57F0\u5BC0\u5BE8\u5F69\u63A1\u7826\u7DB5\u83DC\u8521\u91C7\u91F5\u518A\u67F5\u7B56"],
      ["f4a1", "\u8CAC\u51C4\u59BB\u60BD\u8655\u501C\uF9FF\u5254\u5C3A\u617D\u621A\u62D3\u64F2\u65A5\u6ECC\u7620\u810A\u8E60\u965F\u96BB\u4EDF\u5343\u5598\u5929\u5DDD\u64C5\u6CC9\u6DFA\u7394\u7A7F\u821B\u85A6\u8CE4\u8E10\u9077\u91E7\u95E1\u9621\u97C6\u51F8\u54F2\u5586\u5FB9\u64A4\u6F88\u7DB4\u8F1F\u8F4D\u9435\u50C9\u5C16\u6CBE\u6DFB\u751B\u77BB\u7C3D\u7C64\u8A79\u8AC2\u581E\u59BE\u5E16\u6377\u7252\u758A\u776B\u8ADC\u8CBC\u8F12\u5EF3\u6674\u6DF8\u807D\u83C1\u8ACB\u9751\u9BD6\uFA00\u5243\u66FF\u6D95\u6EEF\u7DE0\u8AE6\u902E\u905E\u9AD4\u521D\u527F\u54E8\u6194\u6284\u62DB\u68A2"],
      ["f5a1", "\u6912\u695A\u6A35\u7092\u7126\u785D\u7901\u790E\u79D2\u7A0D\u8096\u8278\u82D5\u8349\u8549\u8C82\u8D85\u9162\u918B\u91AE\u4FC3\u56D1\u71ED\u77D7\u8700\u89F8\u5BF8\u5FD6\u6751\u90A8\u53E2\u585A\u5BF5\u60A4\u6181\u6460\u7E3D\u8070\u8525\u9283\u64AE\u50AC\u5D14\u6700\u589C\u62BD\u63A8\u690E\u6978\u6A1E\u6E6B\u76BA\u79CB\u82BB\u8429\u8ACF\u8DA8\u8FFD\u9112\u914B\u919C\u9310\u9318\u939A\u96DB\u9A36\u9C0D\u4E11\u755C\u795D\u7AFA\u7B51\u7BC9\u7E2E\u84C4\u8E59\u8E74\u8EF8\u9010\u6625\u693F\u7443\u51FA\u672E\u9EDC\u5145\u5FE0\u6C96\u87F2\u885D\u8877\u60B4\u81B5\u8403"],
      ["f6a1", "\u8D05\u53D6\u5439\u5634\u5A36\u5C31\u708A\u7FE0\u805A\u8106\u81ED\u8DA3\u9189\u9A5F\u9DF2\u5074\u4EC4\u53A0\u60FB\u6E2C\u5C64\u4F88\u5024\u55E4\u5CD9\u5E5F\u6065\u6894\u6CBB\u6DC4\u71BE\u75D4\u75F4\u7661\u7A1A\u7A49\u7DC7\u7DFB\u7F6E\u81F4\u86A9\u8F1C\u96C9\u99B3\u9F52\u5247\u52C5\u98ED\u89AA\u4E03\u67D2\u6F06\u4FB5\u5BE2\u6795\u6C88\u6D78\u741B\u7827\u91DD\u937C\u87C4\u79E4\u7A31\u5FEB\u4ED6\u54A4\u553E\u58AE\u59A5\u60F0\u6253\u62D6\u6736\u6955\u8235\u9640\u99B1\u99DD\u502C\u5353\u5544\u577C\uFA01\u6258\uFA02\u64E2\u666B\u67DD\u6FC1\u6FEF\u7422\u7438\u8A17"],
      ["f7a1", "\u9438\u5451\u5606\u5766\u5F48\u619A\u6B4E\u7058\u70AD\u7DBB\u8A95\u596A\u812B\u63A2\u7708\u803D\u8CAA\u5854\u642D\u69BB\u5B95\u5E11\u6E6F\uFA03\u8569\u514C\u53F0\u592A\u6020\u614B\u6B86\u6C70\u6CF0\u7B1E\u80CE\u82D4\u8DC6\u90B0\u98B1\uFA04\u64C7\u6FA4\u6491\u6504\u514E\u5410\u571F\u8A0E\u615F\u6876\uFA05\u75DB\u7B52\u7D71\u901A\u5806\u69CC\u817F\u892A\u9000\u9839\u5078\u5957\u59AC\u6295\u900F\u9B2A\u615D\u7279\u95D6\u5761\u5A46\u5DF4\u628A\u64AD\u64FA\u6777\u6CE2\u6D3E\u722C\u7436\u7834\u7F77\u82AD\u8DDB\u9817\u5224\u5742\u677F\u7248\u74E3\u8CA9\u8FA6\u9211"],
      ["f8a1", "\u962A\u516B\u53ED\u634C\u4F69\u5504\u6096\u6557\u6C9B\u6D7F\u724C\u72FD\u7A17\u8987\u8C9D\u5F6D\u6F8E\u70F9\u81A8\u610E\u4FBF\u504F\u6241\u7247\u7BC7\u7DE8\u7FE9\u904D\u97AD\u9A19\u8CB6\u576A\u5E73\u67B0\u840D\u8A55\u5420\u5B16\u5E63\u5EE2\u5F0A\u6583\u80BA\u853D\u9589\u965B\u4F48\u5305\u530D\u530F\u5486\u54FA\u5703\u5E03\u6016\u629B\u62B1\u6355\uFA06\u6CE1\u6D66\u75B1\u7832\u80DE\u812F\u82DE\u8461\u84B2\u888D\u8912\u900B\u92EA\u98FD\u9B91\u5E45\u66B4\u66DD\u7011\u7206\uFA07\u4FF5\u527D\u5F6A\u6153\u6753\u6A19\u6F02\u74E2\u7968\u8868\u8C79\u98C7\u98C4\u9A43"],
      ["f9a1", "\u54C1\u7A1F\u6953\u8AF7\u8C4A\u98A8\u99AE\u5F7C\u62AB\u75B2\u76AE\u88AB\u907F\u9642\u5339\u5F3C\u5FC5\u6CCC\u73CC\u7562\u758B\u7B46\u82FE\u999D\u4E4F\u903C\u4E0B\u4F55\u53A6\u590F\u5EC8\u6630\u6CB3\u7455\u8377\u8766\u8CC0\u9050\u971E\u9C15\u58D1\u5B78\u8650\u8B14\u9DB4\u5BD2\u6068\u608D\u65F1\u6C57\u6F22\u6FA3\u701A\u7F55\u7FF0\u9591\u9592\u9650\u97D3\u5272\u8F44\u51FD\u542B\u54B8\u5563\u558A\u6ABB\u6DB5\u7DD8\u8266\u929C\u9677\u9E79\u5408\u54C8\u76D2\u86E4\u95A4\u95D4\u965C\u4EA2\u4F09\u59EE\u5AE6\u5DF7\u6052\u6297\u676D\u6841\u6C86\u6E2F\u7F38\u809B\u822A"],
      ["faa1", "\uFA08\uFA09\u9805\u4EA5\u5055\u54B3\u5793\u595A\u5B69\u5BB3\u61C8\u6977\u6D77\u7023\u87F9\u89E3\u8A72\u8AE7\u9082\u99ED\u9AB8\u52BE\u6838\u5016\u5E78\u674F\u8347\u884C\u4EAB\u5411\u56AE\u73E6\u9115\u97FF\u9909\u9957\u9999\u5653\u589F\u865B\u8A31\u61B2\u6AF6\u737B\u8ED2\u6B47\u96AA\u9A57\u5955\u7200\u8D6B\u9769\u4FD4\u5CF4\u5F26\u61F8\u665B\u6CEB\u70AB\u7384\u73B9\u73FE\u7729\u774D\u7D43\u7D62\u7E23\u8237\u8852\uFA0A\u8CE2\u9249\u986F\u5B51\u7A74\u8840\u9801\u5ACC\u4FE0\u5354\u593E\u5CFD\u633E\u6D79\u72F9\u8105\u8107\u83A2\u92CF\u9830\u4EA8\u5144\u5211\u578B"],
      ["fba1", "\u5F62\u6CC2\u6ECE\u7005\u7050\u70AF\u7192\u73E9\u7469\u834A\u87A2\u8861\u9008\u90A2\u93A3\u99A8\u516E\u5F57\u60E0\u6167\u66B3\u8559\u8E4A\u91AF\u978B\u4E4E\u4E92\u547C\u58D5\u58FA\u597D\u5CB5\u5F27\u6236\u6248\u660A\u6667\u6BEB\u6D69\u6DCF\u6E56\u6EF8\u6F94\u6FE0\u6FE9\u705D\u72D0\u7425\u745A\u74E0\u7693\u795C\u7CCA\u7E1E\u80E1\u82A6\u846B\u84BF\u864E\u865F\u8774\u8B77\u8C6A\u93AC\u9800\u9865\u60D1\u6216\u9177\u5A5A\u660F\u6DF7\u6E3E\u743F\u9B42\u5FFD\u60DA\u7B0F\u54C4\u5F18\u6C5E\u6CD3\u6D2A\u70D8\u7D05\u8679\u8A0C\u9D3B\u5316\u548C\u5B05\u6A3A\u706B\u7575"],
      ["fca1", "\u798D\u79BE\u82B1\u83EF\u8A71\u8B41\u8CA8\u9774\uFA0B\u64F4\u652B\u78BA\u78BB\u7A6B\u4E38\u559A\u5950\u5BA6\u5E7B\u60A3\u63DB\u6B61\u6665\u6853\u6E19\u7165\u74B0\u7D08\u9084\u9A69\u9C25\u6D3B\u6ED1\u733E\u8C41\u95CA\u51F0\u5E4C\u5FA8\u604D\u60F6\u6130\u614C\u6643\u6644\u69A5\u6CC1\u6E5F\u6EC9\u6F62\u714C\u749C\u7687\u7BC1\u7C27\u8352\u8757\u9051\u968D\u9EC3\u532F\u56DE\u5EFB\u5F8A\u6062\u6094\u61F7\u6666\u6703\u6A9C\u6DEE\u6FAE\u7070\u736A\u7E6A\u81BE\u8334\u86D4\u8AA8\u8CC4\u5283\u7372\u5B96\u6A6B\u9404\u54EE\u5686\u5B5D\u6548\u6585\u66C9\u689F\u6D8D\u6DC6"],
      ["fda1", "\u723B\u80B4\u9175\u9A4D\u4FAF\u5019\u539A\u540E\u543C\u5589\u55C5\u5E3F\u5F8C\u673D\u7166\u73DD\u9005\u52DB\u52F3\u5864\u58CE\u7104\u718F\u71FB\u85B0\u8A13\u6688\u85A8\u55A7\u6684\u714A\u8431\u5349\u5599\u6BC1\u5F59\u5FBD\u63EE\u6689\u7147\u8AF1\u8F1D\u9EBE\u4F11\u643A\u70CB\u7566\u8667\u6064\u8B4E\u9DF8\u5147\u51F6\u5308\u6D36\u80F8\u9ED1\u6615\u6B23\u7098\u75D5\u5403\u5C79\u7D07\u8A16\u6B20\u6B3D\u6B46\u5438\u6070\u6D3D\u7FD5\u8208\u50D6\u51DE\u559C\u566B\u56CD\u59EC\u5B09\u5E0C\u6199\u6198\u6231\u665E\u66E6\u7199\u71B9\u71BA\u72A7\u79A7\u7A00\u7FB2\u8A70"]
    ];
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/tables/cp950.json
var require_cp950 = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/tables/cp950.json"(exports, module) {
    module.exports = [
      ["0", "\0", 127],
      ["a140", "\u3000\uFF0C\u3001\u3002\uFF0E\u2027\uFF1B\uFF1A\uFF1F\uFF01\uFE30\u2026\u2025\uFE50\uFE51\uFE52\xB7\uFE54\uFE55\uFE56\uFE57\uFF5C\u2013\uFE31\u2014\uFE33\u2574\uFE34\uFE4F\uFF08\uFF09\uFE35\uFE36\uFF5B\uFF5D\uFE37\uFE38\u3014\u3015\uFE39\uFE3A\u3010\u3011\uFE3B\uFE3C\u300A\u300B\uFE3D\uFE3E\u3008\u3009\uFE3F\uFE40\u300C\u300D\uFE41\uFE42\u300E\u300F\uFE43\uFE44\uFE59\uFE5A"],
      ["a1a1", "\uFE5B\uFE5C\uFE5D\uFE5E\u2018\u2019\u201C\u201D\u301D\u301E\u2035\u2032\uFF03\uFF06\uFF0A\u203B\xA7\u3003\u25CB\u25CF\u25B3\u25B2\u25CE\u2606\u2605\u25C7\u25C6\u25A1\u25A0\u25BD\u25BC\u32A3\u2105\xAF\uFFE3\uFF3F\u02CD\uFE49\uFE4A\uFE4D\uFE4E\uFE4B\uFE4C\uFE5F\uFE60\uFE61\uFF0B\uFF0D\xD7\xF7\xB1\u221A\uFF1C\uFF1E\uFF1D\u2266\u2267\u2260\u221E\u2252\u2261\uFE62", 4, "\uFF5E\u2229\u222A\u22A5\u2220\u221F\u22BF\u33D2\u33D1\u222B\u222E\u2235\u2234\u2640\u2642\u2295\u2299\u2191\u2193\u2190\u2192\u2196\u2197\u2199\u2198\u2225\u2223\uFF0F"],
      ["a240", "\uFF3C\u2215\uFE68\uFF04\uFFE5\u3012\uFFE0\uFFE1\uFF05\uFF20\u2103\u2109\uFE69\uFE6A\uFE6B\u33D5\u339C\u339D\u339E\u33CE\u33A1\u338E\u338F\u33C4\xB0\u5159\u515B\u515E\u515D\u5161\u5163\u55E7\u74E9\u7CCE\u2581", 7, "\u258F\u258E\u258D\u258C\u258B\u258A\u2589\u253C\u2534\u252C\u2524\u251C\u2594\u2500\u2502\u2595\u250C\u2510\u2514\u2518\u256D"],
      ["a2a1", "\u256E\u2570\u256F\u2550\u255E\u256A\u2561\u25E2\u25E3\u25E5\u25E4\u2571\u2572\u2573\uFF10", 9, "\u2160", 9, "\u3021", 8, "\u5341\u5344\u5345\uFF21", 25, "\uFF41", 21],
      ["a340", "\uFF57\uFF58\uFF59\uFF5A\u0391", 16, "\u03A3", 6, "\u03B1", 16, "\u03C3", 6, "\u3105", 10],
      ["a3a1", "\u3110", 25, "\u02D9\u02C9\u02CA\u02C7\u02CB"],
      ["a3e1", "\u20AC"],
      ["a440", "\u4E00\u4E59\u4E01\u4E03\u4E43\u4E5D\u4E86\u4E8C\u4EBA\u513F\u5165\u516B\u51E0\u5200\u5201\u529B\u5315\u5341\u535C\u53C8\u4E09\u4E0B\u4E08\u4E0A\u4E2B\u4E38\u51E1\u4E45\u4E48\u4E5F\u4E5E\u4E8E\u4EA1\u5140\u5203\u52FA\u5343\u53C9\u53E3\u571F\u58EB\u5915\u5927\u5973\u5B50\u5B51\u5B53\u5BF8\u5C0F\u5C22\u5C38\u5C71\u5DDD\u5DE5\u5DF1\u5DF2\u5DF3\u5DFE\u5E72\u5EFE\u5F0B\u5F13\u624D"],
      ["a4a1", "\u4E11\u4E10\u4E0D\u4E2D\u4E30\u4E39\u4E4B\u5C39\u4E88\u4E91\u4E95\u4E92\u4E94\u4EA2\u4EC1\u4EC0\u4EC3\u4EC6\u4EC7\u4ECD\u4ECA\u4ECB\u4EC4\u5143\u5141\u5167\u516D\u516E\u516C\u5197\u51F6\u5206\u5207\u5208\u52FB\u52FE\u52FF\u5316\u5339\u5348\u5347\u5345\u535E\u5384\u53CB\u53CA\u53CD\u58EC\u5929\u592B\u592A\u592D\u5B54\u5C11\u5C24\u5C3A\u5C6F\u5DF4\u5E7B\u5EFF\u5F14\u5F15\u5FC3\u6208\u6236\u624B\u624E\u652F\u6587\u6597\u65A4\u65B9\u65E5\u66F0\u6708\u6728\u6B20\u6B62\u6B79\u6BCB\u6BD4\u6BDB\u6C0F\u6C34\u706B\u722A\u7236\u723B\u7247\u7259\u725B\u72AC\u738B\u4E19"],
      ["a540", "\u4E16\u4E15\u4E14\u4E18\u4E3B\u4E4D\u4E4F\u4E4E\u4EE5\u4ED8\u4ED4\u4ED5\u4ED6\u4ED7\u4EE3\u4EE4\u4ED9\u4EDE\u5145\u5144\u5189\u518A\u51AC\u51F9\u51FA\u51F8\u520A\u52A0\u529F\u5305\u5306\u5317\u531D\u4EDF\u534A\u5349\u5361\u5360\u536F\u536E\u53BB\u53EF\u53E4\u53F3\u53EC\u53EE\u53E9\u53E8\u53FC\u53F8\u53F5\u53EB\u53E6\u53EA\u53F2\u53F1\u53F0\u53E5\u53ED\u53FB\u56DB\u56DA\u5916"],
      ["a5a1", "\u592E\u5931\u5974\u5976\u5B55\u5B83\u5C3C\u5DE8\u5DE7\u5DE6\u5E02\u5E03\u5E73\u5E7C\u5F01\u5F18\u5F17\u5FC5\u620A\u6253\u6254\u6252\u6251\u65A5\u65E6\u672E\u672C\u672A\u672B\u672D\u6B63\u6BCD\u6C11\u6C10\u6C38\u6C41\u6C40\u6C3E\u72AF\u7384\u7389\u74DC\u74E6\u7518\u751F\u7528\u7529\u7530\u7531\u7532\u7533\u758B\u767D\u76AE\u76BF\u76EE\u77DB\u77E2\u77F3\u793A\u79BE\u7A74\u7ACB\u4E1E\u4E1F\u4E52\u4E53\u4E69\u4E99\u4EA4\u4EA6\u4EA5\u4EFF\u4F09\u4F19\u4F0A\u4F15\u4F0D\u4F10\u4F11\u4F0F\u4EF2\u4EF6\u4EFB\u4EF0\u4EF3\u4EFD\u4F01\u4F0B\u5149\u5147\u5146\u5148\u5168"],
      ["a640", "\u5171\u518D\u51B0\u5217\u5211\u5212\u520E\u5216\u52A3\u5308\u5321\u5320\u5370\u5371\u5409\u540F\u540C\u540A\u5410\u5401\u540B\u5404\u5411\u540D\u5408\u5403\u540E\u5406\u5412\u56E0\u56DE\u56DD\u5733\u5730\u5728\u572D\u572C\u572F\u5729\u5919\u591A\u5937\u5938\u5984\u5978\u5983\u597D\u5979\u5982\u5981\u5B57\u5B58\u5B87\u5B88\u5B85\u5B89\u5BFA\u5C16\u5C79\u5DDE\u5E06\u5E76\u5E74"],
      ["a6a1", "\u5F0F\u5F1B\u5FD9\u5FD6\u620E\u620C\u620D\u6210\u6263\u625B\u6258\u6536\u65E9\u65E8\u65EC\u65ED\u66F2\u66F3\u6709\u673D\u6734\u6731\u6735\u6B21\u6B64\u6B7B\u6C16\u6C5D\u6C57\u6C59\u6C5F\u6C60\u6C50\u6C55\u6C61\u6C5B\u6C4D\u6C4E\u7070\u725F\u725D\u767E\u7AF9\u7C73\u7CF8\u7F36\u7F8A\u7FBD\u8001\u8003\u800C\u8012\u8033\u807F\u8089\u808B\u808C\u81E3\u81EA\u81F3\u81FC\u820C\u821B\u821F\u826E\u8272\u827E\u866B\u8840\u884C\u8863\u897F\u9621\u4E32\u4EA8\u4F4D\u4F4F\u4F47\u4F57\u4F5E\u4F34\u4F5B\u4F55\u4F30\u4F50\u4F51\u4F3D\u4F3A\u4F38\u4F43\u4F54\u4F3C\u4F46\u4F63"],
      ["a740", "\u4F5C\u4F60\u4F2F\u4F4E\u4F36\u4F59\u4F5D\u4F48\u4F5A\u514C\u514B\u514D\u5175\u51B6\u51B7\u5225\u5224\u5229\u522A\u5228\u52AB\u52A9\u52AA\u52AC\u5323\u5373\u5375\u541D\u542D\u541E\u543E\u5426\u544E\u5427\u5446\u5443\u5433\u5448\u5442\u541B\u5429\u544A\u5439\u543B\u5438\u542E\u5435\u5436\u5420\u543C\u5440\u5431\u542B\u541F\u542C\u56EA\u56F0\u56E4\u56EB\u574A\u5751\u5740\u574D"],
      ["a7a1", "\u5747\u574E\u573E\u5750\u574F\u573B\u58EF\u593E\u599D\u5992\u59A8\u599E\u59A3\u5999\u5996\u598D\u59A4\u5993\u598A\u59A5\u5B5D\u5B5C\u5B5A\u5B5B\u5B8C\u5B8B\u5B8F\u5C2C\u5C40\u5C41\u5C3F\u5C3E\u5C90\u5C91\u5C94\u5C8C\u5DEB\u5E0C\u5E8F\u5E87\u5E8A\u5EF7\u5F04\u5F1F\u5F64\u5F62\u5F77\u5F79\u5FD8\u5FCC\u5FD7\u5FCD\u5FF1\u5FEB\u5FF8\u5FEA\u6212\u6211\u6284\u6297\u6296\u6280\u6276\u6289\u626D\u628A\u627C\u627E\u6279\u6273\u6292\u626F\u6298\u626E\u6295\u6293\u6291\u6286\u6539\u653B\u6538\u65F1\u66F4\u675F\u674E\u674F\u6750\u6751\u675C\u6756\u675E\u6749\u6746\u6760"],
      ["a840", "\u6753\u6757\u6B65\u6BCF\u6C42\u6C5E\u6C99\u6C81\u6C88\u6C89\u6C85\u6C9B\u6C6A\u6C7A\u6C90\u6C70\u6C8C\u6C68\u6C96\u6C92\u6C7D\u6C83\u6C72\u6C7E\u6C74\u6C86\u6C76\u6C8D\u6C94\u6C98\u6C82\u7076\u707C\u707D\u7078\u7262\u7261\u7260\u72C4\u72C2\u7396\u752C\u752B\u7537\u7538\u7682\u76EF\u77E3\u79C1\u79C0\u79BF\u7A76\u7CFB\u7F55\u8096\u8093\u809D\u8098\u809B\u809A\u80B2\u826F\u8292"],
      ["a8a1", "\u828B\u828D\u898B\u89D2\u8A00\u8C37\u8C46\u8C55\u8C9D\u8D64\u8D70\u8DB3\u8EAB\u8ECA\u8F9B\u8FB0\u8FC2\u8FC6\u8FC5\u8FC4\u5DE1\u9091\u90A2\u90AA\u90A6\u90A3\u9149\u91C6\u91CC\u9632\u962E\u9631\u962A\u962C\u4E26\u4E56\u4E73\u4E8B\u4E9B\u4E9E\u4EAB\u4EAC\u4F6F\u4F9D\u4F8D\u4F73\u4F7F\u4F6C\u4F9B\u4F8B\u4F86\u4F83\u4F70\u4F75\u4F88\u4F69\u4F7B\u4F96\u4F7E\u4F8F\u4F91\u4F7A\u5154\u5152\u5155\u5169\u5177\u5176\u5178\u51BD\u51FD\u523B\u5238\u5237\u523A\u5230\u522E\u5236\u5241\u52BE\u52BB\u5352\u5354\u5353\u5351\u5366\u5377\u5378\u5379\u53D6\u53D4\u53D7\u5473\u5475"],
      ["a940", "\u5496\u5478\u5495\u5480\u547B\u5477\u5484\u5492\u5486\u547C\u5490\u5471\u5476\u548C\u549A\u5462\u5468\u548B\u547D\u548E\u56FA\u5783\u5777\u576A\u5769\u5761\u5766\u5764\u577C\u591C\u5949\u5947\u5948\u5944\u5954\u59BE\u59BB\u59D4\u59B9\u59AE\u59D1\u59C6\u59D0\u59CD\u59CB\u59D3\u59CA\u59AF\u59B3\u59D2\u59C5\u5B5F\u5B64\u5B63\u5B97\u5B9A\u5B98\u5B9C\u5B99\u5B9B\u5C1A\u5C48\u5C45"],
      ["a9a1", "\u5C46\u5CB7\u5CA1\u5CB8\u5CA9\u5CAB\u5CB1\u5CB3\u5E18\u5E1A\u5E16\u5E15\u5E1B\u5E11\u5E78\u5E9A\u5E97\u5E9C\u5E95\u5E96\u5EF6\u5F26\u5F27\u5F29\u5F80\u5F81\u5F7F\u5F7C\u5FDD\u5FE0\u5FFD\u5FF5\u5FFF\u600F\u6014\u602F\u6035\u6016\u602A\u6015\u6021\u6027\u6029\u602B\u601B\u6216\u6215\u623F\u623E\u6240\u627F\u62C9\u62CC\u62C4\u62BF\u62C2\u62B9\u62D2\u62DB\u62AB\u62D3\u62D4\u62CB\u62C8\u62A8\u62BD\u62BC\u62D0\u62D9\u62C7\u62CD\u62B5\u62DA\u62B1\u62D8\u62D6\u62D7\u62C6\u62AC\u62CE\u653E\u65A7\u65BC\u65FA\u6614\u6613\u660C\u6606\u6602\u660E\u6600\u660F\u6615\u660A"],
      ["aa40", "\u6607\u670D\u670B\u676D\u678B\u6795\u6771\u679C\u6773\u6777\u6787\u679D\u6797\u676F\u6770\u677F\u6789\u677E\u6790\u6775\u679A\u6793\u677C\u676A\u6772\u6B23\u6B66\u6B67\u6B7F\u6C13\u6C1B\u6CE3\u6CE8\u6CF3\u6CB1\u6CCC\u6CE5\u6CB3\u6CBD\u6CBE\u6CBC\u6CE2\u6CAB\u6CD5\u6CD3\u6CB8\u6CC4\u6CB9\u6CC1\u6CAE\u6CD7\u6CC5\u6CF1\u6CBF\u6CBB\u6CE1\u6CDB\u6CCA\u6CAC\u6CEF\u6CDC\u6CD6\u6CE0"],
      ["aaa1", "\u7095\u708E\u7092\u708A\u7099\u722C\u722D\u7238\u7248\u7267\u7269\u72C0\u72CE\u72D9\u72D7\u72D0\u73A9\u73A8\u739F\u73AB\u73A5\u753D\u759D\u7599\u759A\u7684\u76C2\u76F2\u76F4\u77E5\u77FD\u793E\u7940\u7941\u79C9\u79C8\u7A7A\u7A79\u7AFA\u7CFE\u7F54\u7F8C\u7F8B\u8005\u80BA\u80A5\u80A2\u80B1\u80A1\u80AB\u80A9\u80B4\u80AA\u80AF\u81E5\u81FE\u820D\u82B3\u829D\u8299\u82AD\u82BD\u829F\u82B9\u82B1\u82AC\u82A5\u82AF\u82B8\u82A3\u82B0\u82BE\u82B7\u864E\u8671\u521D\u8868\u8ECB\u8FCE\u8FD4\u8FD1\u90B5\u90B8\u90B1\u90B6\u91C7\u91D1\u9577\u9580\u961C\u9640\u963F\u963B\u9644"],
      ["ab40", "\u9642\u96B9\u96E8\u9752\u975E\u4E9F\u4EAD\u4EAE\u4FE1\u4FB5\u4FAF\u4FBF\u4FE0\u4FD1\u4FCF\u4FDD\u4FC3\u4FB6\u4FD8\u4FDF\u4FCA\u4FD7\u4FAE\u4FD0\u4FC4\u4FC2\u4FDA\u4FCE\u4FDE\u4FB7\u5157\u5192\u5191\u51A0\u524E\u5243\u524A\u524D\u524C\u524B\u5247\u52C7\u52C9\u52C3\u52C1\u530D\u5357\u537B\u539A\u53DB\u54AC\u54C0\u54A8\u54CE\u54C9\u54B8\u54A6\u54B3\u54C7\u54C2\u54BD\u54AA\u54C1"],
      ["aba1", "\u54C4\u54C8\u54AF\u54AB\u54B1\u54BB\u54A9\u54A7\u54BF\u56FF\u5782\u578B\u57A0\u57A3\u57A2\u57CE\u57AE\u5793\u5955\u5951\u594F\u594E\u5950\u59DC\u59D8\u59FF\u59E3\u59E8\u5A03\u59E5\u59EA\u59DA\u59E6\u5A01\u59FB\u5B69\u5BA3\u5BA6\u5BA4\u5BA2\u5BA5\u5C01\u5C4E\u5C4F\u5C4D\u5C4B\u5CD9\u5CD2\u5DF7\u5E1D\u5E25\u5E1F\u5E7D\u5EA0\u5EA6\u5EFA\u5F08\u5F2D\u5F65\u5F88\u5F85\u5F8A\u5F8B\u5F87\u5F8C\u5F89\u6012\u601D\u6020\u6025\u600E\u6028\u604D\u6070\u6068\u6062\u6046\u6043\u606C\u606B\u606A\u6064\u6241\u62DC\u6316\u6309\u62FC\u62ED\u6301\u62EE\u62FD\u6307\u62F1\u62F7"],
      ["ac40", "\u62EF\u62EC\u62FE\u62F4\u6311\u6302\u653F\u6545\u65AB\u65BD\u65E2\u6625\u662D\u6620\u6627\u662F\u661F\u6628\u6631\u6624\u66F7\u67FF\u67D3\u67F1\u67D4\u67D0\u67EC\u67B6\u67AF\u67F5\u67E9\u67EF\u67C4\u67D1\u67B4\u67DA\u67E5\u67B8\u67CF\u67DE\u67F3\u67B0\u67D9\u67E2\u67DD\u67D2\u6B6A\u6B83\u6B86\u6BB5\u6BD2\u6BD7\u6C1F\u6CC9\u6D0B\u6D32\u6D2A\u6D41\u6D25\u6D0C\u6D31\u6D1E\u6D17"],
      ["aca1", "\u6D3B\u6D3D\u6D3E\u6D36\u6D1B\u6CF5\u6D39\u6D27\u6D38\u6D29\u6D2E\u6D35\u6D0E\u6D2B\u70AB\u70BA\u70B3\u70AC\u70AF\u70AD\u70B8\u70AE\u70A4\u7230\u7272\u726F\u7274\u72E9\u72E0\u72E1\u73B7\u73CA\u73BB\u73B2\u73CD\u73C0\u73B3\u751A\u752D\u754F\u754C\u754E\u754B\u75AB\u75A4\u75A5\u75A2\u75A3\u7678\u7686\u7687\u7688\u76C8\u76C6\u76C3\u76C5\u7701\u76F9\u76F8\u7709\u770B\u76FE\u76FC\u7707\u77DC\u7802\u7814\u780C\u780D\u7946\u7949\u7948\u7947\u79B9\u79BA\u79D1\u79D2\u79CB\u7A7F\u7A81\u7AFF\u7AFD\u7C7D\u7D02\u7D05\u7D00\u7D09\u7D07\u7D04\u7D06\u7F38\u7F8E\u7FBF\u8004"],
      ["ad40", "\u8010\u800D\u8011\u8036\u80D6\u80E5\u80DA\u80C3\u80C4\u80CC\u80E1\u80DB\u80CE\u80DE\u80E4\u80DD\u81F4\u8222\u82E7\u8303\u8305\u82E3\u82DB\u82E6\u8304\u82E5\u8302\u8309\u82D2\u82D7\u82F1\u8301\u82DC\u82D4\u82D1\u82DE\u82D3\u82DF\u82EF\u8306\u8650\u8679\u867B\u867A\u884D\u886B\u8981\u89D4\u8A08\u8A02\u8A03\u8C9E\u8CA0\u8D74\u8D73\u8DB4\u8ECD\u8ECC\u8FF0\u8FE6\u8FE2\u8FEA\u8FE5"],
      ["ada1", "\u8FED\u8FEB\u8FE4\u8FE8\u90CA\u90CE\u90C1\u90C3\u914B\u914A\u91CD\u9582\u9650\u964B\u964C\u964D\u9762\u9769\u97CB\u97ED\u97F3\u9801\u98A8\u98DB\u98DF\u9996\u9999\u4E58\u4EB3\u500C\u500D\u5023\u4FEF\u5026\u5025\u4FF8\u5029\u5016\u5006\u503C\u501F\u501A\u5012\u5011\u4FFA\u5000\u5014\u5028\u4FF1\u5021\u500B\u5019\u5018\u4FF3\u4FEE\u502D\u502A\u4FFE\u502B\u5009\u517C\u51A4\u51A5\u51A2\u51CD\u51CC\u51C6\u51CB\u5256\u525C\u5254\u525B\u525D\u532A\u537F\u539F\u539D\u53DF\u54E8\u5510\u5501\u5537\u54FC\u54E5\u54F2\u5506\u54FA\u5514\u54E9\u54ED\u54E1\u5509\u54EE\u54EA"],
      ["ae40", "\u54E6\u5527\u5507\u54FD\u550F\u5703\u5704\u57C2\u57D4\u57CB\u57C3\u5809\u590F\u5957\u5958\u595A\u5A11\u5A18\u5A1C\u5A1F\u5A1B\u5A13\u59EC\u5A20\u5A23\u5A29\u5A25\u5A0C\u5A09\u5B6B\u5C58\u5BB0\u5BB3\u5BB6\u5BB4\u5BAE\u5BB5\u5BB9\u5BB8\u5C04\u5C51\u5C55\u5C50\u5CED\u5CFD\u5CFB\u5CEA\u5CE8\u5CF0\u5CF6\u5D01\u5CF4\u5DEE\u5E2D\u5E2B\u5EAB\u5EAD\u5EA7\u5F31\u5F92\u5F91\u5F90\u6059"],
      ["aea1", "\u6063\u6065\u6050\u6055\u606D\u6069\u606F\u6084\u609F\u609A\u608D\u6094\u608C\u6085\u6096\u6247\u62F3\u6308\u62FF\u634E\u633E\u632F\u6355\u6342\u6346\u634F\u6349\u633A\u6350\u633D\u632A\u632B\u6328\u634D\u634C\u6548\u6549\u6599\u65C1\u65C5\u6642\u6649\u664F\u6643\u6652\u664C\u6645\u6641\u66F8\u6714\u6715\u6717\u6821\u6838\u6848\u6846\u6853\u6839\u6842\u6854\u6829\u68B3\u6817\u684C\u6851\u683D\u67F4\u6850\u6840\u683C\u6843\u682A\u6845\u6813\u6818\u6841\u6B8A\u6B89\u6BB7\u6C23\u6C27\u6C28\u6C26\u6C24\u6CF0\u6D6A\u6D95\u6D88\u6D87\u6D66\u6D78\u6D77\u6D59\u6D93"],
      ["af40", "\u6D6C\u6D89\u6D6E\u6D5A\u6D74\u6D69\u6D8C\u6D8A\u6D79\u6D85\u6D65\u6D94\u70CA\u70D8\u70E4\u70D9\u70C8\u70CF\u7239\u7279\u72FC\u72F9\u72FD\u72F8\u72F7\u7386\u73ED\u7409\u73EE\u73E0\u73EA\u73DE\u7554\u755D\u755C\u755A\u7559\u75BE\u75C5\u75C7\u75B2\u75B3\u75BD\u75BC\u75B9\u75C2\u75B8\u768B\u76B0\u76CA\u76CD\u76CE\u7729\u771F\u7720\u7728\u77E9\u7830\u7827\u7838\u781D\u7834\u7837"],
      ["afa1", "\u7825\u782D\u7820\u781F\u7832\u7955\u7950\u7960\u795F\u7956\u795E\u795D\u7957\u795A\u79E4\u79E3\u79E7\u79DF\u79E6\u79E9\u79D8\u7A84\u7A88\u7AD9\u7B06\u7B11\u7C89\u7D21\u7D17\u7D0B\u7D0A\u7D20\u7D22\u7D14\u7D10\u7D15\u7D1A\u7D1C\u7D0D\u7D19\u7D1B\u7F3A\u7F5F\u7F94\u7FC5\u7FC1\u8006\u8018\u8015\u8019\u8017\u803D\u803F\u80F1\u8102\u80F0\u8105\u80ED\u80F4\u8106\u80F8\u80F3\u8108\u80FD\u810A\u80FC\u80EF\u81ED\u81EC\u8200\u8210\u822A\u822B\u8228\u822C\u82BB\u832B\u8352\u8354\u834A\u8338\u8350\u8349\u8335\u8334\u834F\u8332\u8339\u8336\u8317\u8340\u8331\u8328\u8343"],
      ["b040", "\u8654\u868A\u86AA\u8693\u86A4\u86A9\u868C\u86A3\u869C\u8870\u8877\u8881\u8882\u887D\u8879\u8A18\u8A10\u8A0E\u8A0C\u8A15\u8A0A\u8A17\u8A13\u8A16\u8A0F\u8A11\u8C48\u8C7A\u8C79\u8CA1\u8CA2\u8D77\u8EAC\u8ED2\u8ED4\u8ECF\u8FB1\u9001\u9006\u8FF7\u9000\u8FFA\u8FF4\u9003\u8FFD\u9005\u8FF8\u9095\u90E1\u90DD\u90E2\u9152\u914D\u914C\u91D8\u91DD\u91D7\u91DC\u91D9\u9583\u9662\u9663\u9661"],
      ["b0a1", "\u965B\u965D\u9664\u9658\u965E\u96BB\u98E2\u99AC\u9AA8\u9AD8\u9B25\u9B32\u9B3C\u4E7E\u507A\u507D\u505C\u5047\u5043\u504C\u505A\u5049\u5065\u5076\u504E\u5055\u5075\u5074\u5077\u504F\u500F\u506F\u506D\u515C\u5195\u51F0\u526A\u526F\u52D2\u52D9\u52D8\u52D5\u5310\u530F\u5319\u533F\u5340\u533E\u53C3\u66FC\u5546\u556A\u5566\u5544\u555E\u5561\u5543\u554A\u5531\u5556\u554F\u5555\u552F\u5564\u5538\u552E\u555C\u552C\u5563\u5533\u5541\u5557\u5708\u570B\u5709\u57DF\u5805\u580A\u5806\u57E0\u57E4\u57FA\u5802\u5835\u57F7\u57F9\u5920\u5962\u5A36\u5A41\u5A49\u5A66\u5A6A\u5A40"],
      ["b140", "\u5A3C\u5A62\u5A5A\u5A46\u5A4A\u5B70\u5BC7\u5BC5\u5BC4\u5BC2\u5BBF\u5BC6\u5C09\u5C08\u5C07\u5C60\u5C5C\u5C5D\u5D07\u5D06\u5D0E\u5D1B\u5D16\u5D22\u5D11\u5D29\u5D14\u5D19\u5D24\u5D27\u5D17\u5DE2\u5E38\u5E36\u5E33\u5E37\u5EB7\u5EB8\u5EB6\u5EB5\u5EBE\u5F35\u5F37\u5F57\u5F6C\u5F69\u5F6B\u5F97\u5F99\u5F9E\u5F98\u5FA1\u5FA0\u5F9C\u607F\u60A3\u6089\u60A0\u60A8\u60CB\u60B4\u60E6\u60BD"],
      ["b1a1", "\u60C5\u60BB\u60B5\u60DC\u60BC\u60D8\u60D5\u60C6\u60DF\u60B8\u60DA\u60C7\u621A\u621B\u6248\u63A0\u63A7\u6372\u6396\u63A2\u63A5\u6377\u6367\u6398\u63AA\u6371\u63A9\u6389\u6383\u639B\u636B\u63A8\u6384\u6388\u6399\u63A1\u63AC\u6392\u638F\u6380\u637B\u6369\u6368\u637A\u655D\u6556\u6551\u6559\u6557\u555F\u654F\u6558\u6555\u6554\u659C\u659B\u65AC\u65CF\u65CB\u65CC\u65CE\u665D\u665A\u6664\u6668\u6666\u665E\u66F9\u52D7\u671B\u6881\u68AF\u68A2\u6893\u68B5\u687F\u6876\u68B1\u68A7\u6897\u68B0\u6883\u68C4\u68AD\u6886\u6885\u6894\u689D\u68A8\u689F\u68A1\u6882\u6B32\u6BBA"],
      ["b240", "\u6BEB\u6BEC\u6C2B\u6D8E\u6DBC\u6DF3\u6DD9\u6DB2\u6DE1\u6DCC\u6DE4\u6DFB\u6DFA\u6E05\u6DC7\u6DCB\u6DAF\u6DD1\u6DAE\u6DDE\u6DF9\u6DB8\u6DF7\u6DF5\u6DC5\u6DD2\u6E1A\u6DB5\u6DDA\u6DEB\u6DD8\u6DEA\u6DF1\u6DEE\u6DE8\u6DC6\u6DC4\u6DAA\u6DEC\u6DBF\u6DE6\u70F9\u7109\u710A\u70FD\u70EF\u723D\u727D\u7281\u731C\u731B\u7316\u7313\u7319\u7387\u7405\u740A\u7403\u7406\u73FE\u740D\u74E0\u74F6"],
      ["b2a1", "\u74F7\u751C\u7522\u7565\u7566\u7562\u7570\u758F\u75D4\u75D5\u75B5\u75CA\u75CD\u768E\u76D4\u76D2\u76DB\u7737\u773E\u773C\u7736\u7738\u773A\u786B\u7843\u784E\u7965\u7968\u796D\u79FB\u7A92\u7A95\u7B20\u7B28\u7B1B\u7B2C\u7B26\u7B19\u7B1E\u7B2E\u7C92\u7C97\u7C95\u7D46\u7D43\u7D71\u7D2E\u7D39\u7D3C\u7D40\u7D30\u7D33\u7D44\u7D2F\u7D42\u7D32\u7D31\u7F3D\u7F9E\u7F9A\u7FCC\u7FCE\u7FD2\u801C\u804A\u8046\u812F\u8116\u8123\u812B\u8129\u8130\u8124\u8202\u8235\u8237\u8236\u8239\u838E\u839E\u8398\u8378\u83A2\u8396\u83BD\u83AB\u8392\u838A\u8393\u8389\u83A0\u8377\u837B\u837C"],
      ["b340", "\u8386\u83A7\u8655\u5F6A\u86C7\u86C0\u86B6\u86C4\u86B5\u86C6\u86CB\u86B1\u86AF\u86C9\u8853\u889E\u8888\u88AB\u8892\u8896\u888D\u888B\u8993\u898F\u8A2A\u8A1D\u8A23\u8A25\u8A31\u8A2D\u8A1F\u8A1B\u8A22\u8C49\u8C5A\u8CA9\u8CAC\u8CAB\u8CA8\u8CAA\u8CA7\u8D67\u8D66\u8DBE\u8DBA\u8EDB\u8EDF\u9019\u900D\u901A\u9017\u9023\u901F\u901D\u9010\u9015\u901E\u9020\u900F\u9022\u9016\u901B\u9014"],
      ["b3a1", "\u90E8\u90ED\u90FD\u9157\u91CE\u91F5\u91E6\u91E3\u91E7\u91ED\u91E9\u9589\u966A\u9675\u9673\u9678\u9670\u9674\u9676\u9677\u966C\u96C0\u96EA\u96E9\u7AE0\u7ADF\u9802\u9803\u9B5A\u9CE5\u9E75\u9E7F\u9EA5\u9EBB\u50A2\u508D\u5085\u5099\u5091\u5080\u5096\u5098\u509A\u6700\u51F1\u5272\u5274\u5275\u5269\u52DE\u52DD\u52DB\u535A\u53A5\u557B\u5580\u55A7\u557C\u558A\u559D\u5598\u5582\u559C\u55AA\u5594\u5587\u558B\u5583\u55B3\u55AE\u559F\u553E\u55B2\u559A\u55BB\u55AC\u55B1\u557E\u5589\u55AB\u5599\u570D\u582F\u582A\u5834\u5824\u5830\u5831\u5821\u581D\u5820\u58F9\u58FA\u5960"],
      ["b440", "\u5A77\u5A9A\u5A7F\u5A92\u5A9B\u5AA7\u5B73\u5B71\u5BD2\u5BCC\u5BD3\u5BD0\u5C0A\u5C0B\u5C31\u5D4C\u5D50\u5D34\u5D47\u5DFD\u5E45\u5E3D\u5E40\u5E43\u5E7E\u5ECA\u5EC1\u5EC2\u5EC4\u5F3C\u5F6D\u5FA9\u5FAA\u5FA8\u60D1\u60E1\u60B2\u60B6\u60E0\u611C\u6123\u60FA\u6115\u60F0\u60FB\u60F4\u6168\u60F1\u610E\u60F6\u6109\u6100\u6112\u621F\u6249\u63A3\u638C\u63CF\u63C0\u63E9\u63C9\u63C6\u63CD"],
      ["b4a1", "\u63D2\u63E3\u63D0\u63E1\u63D6\u63ED\u63EE\u6376\u63F4\u63EA\u63DB\u6452\u63DA\u63F9\u655E\u6566\u6562\u6563\u6591\u6590\u65AF\u666E\u6670\u6674\u6676\u666F\u6691\u667A\u667E\u6677\u66FE\u66FF\u671F\u671D\u68FA\u68D5\u68E0\u68D8\u68D7\u6905\u68DF\u68F5\u68EE\u68E7\u68F9\u68D2\u68F2\u68E3\u68CB\u68CD\u690D\u6912\u690E\u68C9\u68DA\u696E\u68FB\u6B3E\u6B3A\u6B3D\u6B98\u6B96\u6BBC\u6BEF\u6C2E\u6C2F\u6C2C\u6E2F\u6E38\u6E54\u6E21\u6E32\u6E67\u6E4A\u6E20\u6E25\u6E23\u6E1B\u6E5B\u6E58\u6E24\u6E56\u6E6E\u6E2D\u6E26\u6E6F\u6E34\u6E4D\u6E3A\u6E2C\u6E43\u6E1D\u6E3E\u6ECB"],
      ["b540", "\u6E89\u6E19\u6E4E\u6E63\u6E44\u6E72\u6E69\u6E5F\u7119\u711A\u7126\u7130\u7121\u7136\u716E\u711C\u724C\u7284\u7280\u7336\u7325\u7334\u7329\u743A\u742A\u7433\u7422\u7425\u7435\u7436\u7434\u742F\u741B\u7426\u7428\u7525\u7526\u756B\u756A\u75E2\u75DB\u75E3\u75D9\u75D8\u75DE\u75E0\u767B\u767C\u7696\u7693\u76B4\u76DC\u774F\u77ED\u785D\u786C\u786F\u7A0D\u7A08\u7A0B\u7A05\u7A00\u7A98"],
      ["b5a1", "\u7A97\u7A96\u7AE5\u7AE3\u7B49\u7B56\u7B46\u7B50\u7B52\u7B54\u7B4D\u7B4B\u7B4F\u7B51\u7C9F\u7CA5\u7D5E\u7D50\u7D68\u7D55\u7D2B\u7D6E\u7D72\u7D61\u7D66\u7D62\u7D70\u7D73\u5584\u7FD4\u7FD5\u800B\u8052\u8085\u8155\u8154\u814B\u8151\u814E\u8139\u8146\u813E\u814C\u8153\u8174\u8212\u821C\u83E9\u8403\u83F8\u840D\u83E0\u83C5\u840B\u83C1\u83EF\u83F1\u83F4\u8457\u840A\u83F0\u840C\u83CC\u83FD\u83F2\u83CA\u8438\u840E\u8404\u83DC\u8407\u83D4\u83DF\u865B\u86DF\u86D9\u86ED\u86D4\u86DB\u86E4\u86D0\u86DE\u8857\u88C1\u88C2\u88B1\u8983\u8996\u8A3B\u8A60\u8A55\u8A5E\u8A3C\u8A41"],
      ["b640", "\u8A54\u8A5B\u8A50\u8A46\u8A34\u8A3A\u8A36\u8A56\u8C61\u8C82\u8CAF\u8CBC\u8CB3\u8CBD\u8CC1\u8CBB\u8CC0\u8CB4\u8CB7\u8CB6\u8CBF\u8CB8\u8D8A\u8D85\u8D81\u8DCE\u8DDD\u8DCB\u8DDA\u8DD1\u8DCC\u8DDB\u8DC6\u8EFB\u8EF8\u8EFC\u8F9C\u902E\u9035\u9031\u9038\u9032\u9036\u9102\u90F5\u9109\u90FE\u9163\u9165\u91CF\u9214\u9215\u9223\u9209\u921E\u920D\u9210\u9207\u9211\u9594\u958F\u958B\u9591"],
      ["b6a1", "\u9593\u9592\u958E\u968A\u968E\u968B\u967D\u9685\u9686\u968D\u9672\u9684\u96C1\u96C5\u96C4\u96C6\u96C7\u96EF\u96F2\u97CC\u9805\u9806\u9808\u98E7\u98EA\u98EF\u98E9\u98F2\u98ED\u99AE\u99AD\u9EC3\u9ECD\u9ED1\u4E82\u50AD\u50B5\u50B2\u50B3\u50C5\u50BE\u50AC\u50B7\u50BB\u50AF\u50C7\u527F\u5277\u527D\u52DF\u52E6\u52E4\u52E2\u52E3\u532F\u55DF\u55E8\u55D3\u55E6\u55CE\u55DC\u55C7\u55D1\u55E3\u55E4\u55EF\u55DA\u55E1\u55C5\u55C6\u55E5\u55C9\u5712\u5713\u585E\u5851\u5858\u5857\u585A\u5854\u586B\u584C\u586D\u584A\u5862\u5852\u584B\u5967\u5AC1\u5AC9\u5ACC\u5ABE\u5ABD\u5ABC"],
      ["b740", "\u5AB3\u5AC2\u5AB2\u5D69\u5D6F\u5E4C\u5E79\u5EC9\u5EC8\u5F12\u5F59\u5FAC\u5FAE\u611A\u610F\u6148\u611F\u60F3\u611B\u60F9\u6101\u6108\u614E\u614C\u6144\u614D\u613E\u6134\u6127\u610D\u6106\u6137\u6221\u6222\u6413\u643E\u641E\u642A\u642D\u643D\u642C\u640F\u641C\u6414\u640D\u6436\u6416\u6417\u6406\u656C\u659F\u65B0\u6697\u6689\u6687\u6688\u6696\u6684\u6698\u668D\u6703\u6994\u696D"],
      ["b7a1", "\u695A\u6977\u6960\u6954\u6975\u6930\u6982\u694A\u6968\u696B\u695E\u6953\u6979\u6986\u695D\u6963\u695B\u6B47\u6B72\u6BC0\u6BBF\u6BD3\u6BFD\u6EA2\u6EAF\u6ED3\u6EB6\u6EC2\u6E90\u6E9D\u6EC7\u6EC5\u6EA5\u6E98\u6EBC\u6EBA\u6EAB\u6ED1\u6E96\u6E9C\u6EC4\u6ED4\u6EAA\u6EA7\u6EB4\u714E\u7159\u7169\u7164\u7149\u7167\u715C\u716C\u7166\u714C\u7165\u715E\u7146\u7168\u7156\u723A\u7252\u7337\u7345\u733F\u733E\u746F\u745A\u7455\u745F\u745E\u7441\u743F\u7459\u745B\u745C\u7576\u7578\u7600\u75F0\u7601\u75F2\u75F1\u75FA\u75FF\u75F4\u75F3\u76DE\u76DF\u775B\u776B\u7766\u775E\u7763"],
      ["b840", "\u7779\u776A\u776C\u775C\u7765\u7768\u7762\u77EE\u788E\u78B0\u7897\u7898\u788C\u7889\u787C\u7891\u7893\u787F\u797A\u797F\u7981\u842C\u79BD\u7A1C\u7A1A\u7A20\u7A14\u7A1F\u7A1E\u7A9F\u7AA0\u7B77\u7BC0\u7B60\u7B6E\u7B67\u7CB1\u7CB3\u7CB5\u7D93\u7D79\u7D91\u7D81\u7D8F\u7D5B\u7F6E\u7F69\u7F6A\u7F72\u7FA9\u7FA8\u7FA4\u8056\u8058\u8086\u8084\u8171\u8170\u8178\u8165\u816E\u8173\u816B"],
      ["b8a1", "\u8179\u817A\u8166\u8205\u8247\u8482\u8477\u843D\u8431\u8475\u8466\u846B\u8449\u846C\u845B\u843C\u8435\u8461\u8463\u8469\u846D\u8446\u865E\u865C\u865F\u86F9\u8713\u8708\u8707\u8700\u86FE\u86FB\u8702\u8703\u8706\u870A\u8859\u88DF\u88D4\u88D9\u88DC\u88D8\u88DD\u88E1\u88CA\u88D5\u88D2\u899C\u89E3\u8A6B\u8A72\u8A73\u8A66\u8A69\u8A70\u8A87\u8A7C\u8A63\u8AA0\u8A71\u8A85\u8A6D\u8A62\u8A6E\u8A6C\u8A79\u8A7B\u8A3E\u8A68\u8C62\u8C8A\u8C89\u8CCA\u8CC7\u8CC8\u8CC4\u8CB2\u8CC3\u8CC2\u8CC5\u8DE1\u8DDF\u8DE8\u8DEF\u8DF3\u8DFA\u8DEA\u8DE4\u8DE6\u8EB2\u8F03\u8F09\u8EFE\u8F0A"],
      ["b940", "\u8F9F\u8FB2\u904B\u904A\u9053\u9042\u9054\u903C\u9055\u9050\u9047\u904F\u904E\u904D\u9051\u903E\u9041\u9112\u9117\u916C\u916A\u9169\u91C9\u9237\u9257\u9238\u923D\u9240\u923E\u925B\u924B\u9264\u9251\u9234\u9249\u924D\u9245\u9239\u923F\u925A\u9598\u9698\u9694\u9695\u96CD\u96CB\u96C9\u96CA\u96F7\u96FB\u96F9\u96F6\u9756\u9774\u9776\u9810\u9811\u9813\u980A\u9812\u980C\u98FC\u98F4"],
      ["b9a1", "\u98FD\u98FE\u99B3\u99B1\u99B4\u9AE1\u9CE9\u9E82\u9F0E\u9F13\u9F20\u50E7\u50EE\u50E5\u50D6\u50ED\u50DA\u50D5\u50CF\u50D1\u50F1\u50CE\u50E9\u5162\u51F3\u5283\u5282\u5331\u53AD\u55FE\u5600\u561B\u5617\u55FD\u5614\u5606\u5609\u560D\u560E\u55F7\u5616\u561F\u5608\u5610\u55F6\u5718\u5716\u5875\u587E\u5883\u5893\u588A\u5879\u5885\u587D\u58FD\u5925\u5922\u5924\u596A\u5969\u5AE1\u5AE6\u5AE9\u5AD7\u5AD6\u5AD8\u5AE3\u5B75\u5BDE\u5BE7\u5BE1\u5BE5\u5BE6\u5BE8\u5BE2\u5BE4\u5BDF\u5C0D\u5C62\u5D84\u5D87\u5E5B\u5E63\u5E55\u5E57\u5E54\u5ED3\u5ED6\u5F0A\u5F46\u5F70\u5FB9\u6147"],
      ["ba40", "\u613F\u614B\u6177\u6162\u6163\u615F\u615A\u6158\u6175\u622A\u6487\u6458\u6454\u64A4\u6478\u645F\u647A\u6451\u6467\u6434\u646D\u647B\u6572\u65A1\u65D7\u65D6\u66A2\u66A8\u669D\u699C\u69A8\u6995\u69C1\u69AE\u69D3\u69CB\u699B\u69B7\u69BB\u69AB\u69B4\u69D0\u69CD\u69AD\u69CC\u69A6\u69C3\u69A3\u6B49\u6B4C\u6C33\u6F33\u6F14\u6EFE\u6F13\u6EF4\u6F29\u6F3E\u6F20\u6F2C\u6F0F\u6F02\u6F22"],
      ["baa1", "\u6EFF\u6EEF\u6F06\u6F31\u6F38\u6F32\u6F23\u6F15\u6F2B\u6F2F\u6F88\u6F2A\u6EEC\u6F01\u6EF2\u6ECC\u6EF7\u7194\u7199\u717D\u718A\u7184\u7192\u723E\u7292\u7296\u7344\u7350\u7464\u7463\u746A\u7470\u746D\u7504\u7591\u7627\u760D\u760B\u7609\u7613\u76E1\u76E3\u7784\u777D\u777F\u7761\u78C1\u789F\u78A7\u78B3\u78A9\u78A3\u798E\u798F\u798D\u7A2E\u7A31\u7AAA\u7AA9\u7AED\u7AEF\u7BA1\u7B95\u7B8B\u7B75\u7B97\u7B9D\u7B94\u7B8F\u7BB8\u7B87\u7B84\u7CB9\u7CBD\u7CBE\u7DBB\u7DB0\u7D9C\u7DBD\u7DBE\u7DA0\u7DCA\u7DB4\u7DB2\u7DB1\u7DBA\u7DA2\u7DBF\u7DB5\u7DB8\u7DAD\u7DD2\u7DC7\u7DAC"],
      ["bb40", "\u7F70\u7FE0\u7FE1\u7FDF\u805E\u805A\u8087\u8150\u8180\u818F\u8188\u818A\u817F\u8182\u81E7\u81FA\u8207\u8214\u821E\u824B\u84C9\u84BF\u84C6\u84C4\u8499\u849E\u84B2\u849C\u84CB\u84B8\u84C0\u84D3\u8490\u84BC\u84D1\u84CA\u873F\u871C\u873B\u8722\u8725\u8734\u8718\u8755\u8737\u8729\u88F3\u8902\u88F4\u88F9\u88F8\u88FD\u88E8\u891A\u88EF\u8AA6\u8A8C\u8A9E\u8AA3\u8A8D\u8AA1\u8A93\u8AA4"],
      ["bba1", "\u8AAA\u8AA5\u8AA8\u8A98\u8A91\u8A9A\u8AA7\u8C6A\u8C8D\u8C8C\u8CD3\u8CD1\u8CD2\u8D6B\u8D99\u8D95\u8DFC\u8F14\u8F12\u8F15\u8F13\u8FA3\u9060\u9058\u905C\u9063\u9059\u905E\u9062\u905D\u905B\u9119\u9118\u911E\u9175\u9178\u9177\u9174\u9278\u9280\u9285\u9298\u9296\u927B\u9293\u929C\u92A8\u927C\u9291\u95A1\u95A8\u95A9\u95A3\u95A5\u95A4\u9699\u969C\u969B\u96CC\u96D2\u9700\u977C\u9785\u97F6\u9817\u9818\u98AF\u98B1\u9903\u9905\u990C\u9909\u99C1\u9AAF\u9AB0\u9AE6\u9B41\u9B42\u9CF4\u9CF6\u9CF3\u9EBC\u9F3B\u9F4A\u5104\u5100\u50FB\u50F5\u50F9\u5102\u5108\u5109\u5105\u51DC"],
      ["bc40", "\u5287\u5288\u5289\u528D\u528A\u52F0\u53B2\u562E\u563B\u5639\u5632\u563F\u5634\u5629\u5653\u564E\u5657\u5674\u5636\u562F\u5630\u5880\u589F\u589E\u58B3\u589C\u58AE\u58A9\u58A6\u596D\u5B09\u5AFB\u5B0B\u5AF5\u5B0C\u5B08\u5BEE\u5BEC\u5BE9\u5BEB\u5C64\u5C65\u5D9D\u5D94\u5E62\u5E5F\u5E61\u5EE2\u5EDA\u5EDF\u5EDD\u5EE3\u5EE0\u5F48\u5F71\u5FB7\u5FB5\u6176\u6167\u616E\u615D\u6155\u6182"],
      ["bca1", "\u617C\u6170\u616B\u617E\u61A7\u6190\u61AB\u618E\u61AC\u619A\u61A4\u6194\u61AE\u622E\u6469\u646F\u6479\u649E\u64B2\u6488\u6490\u64B0\u64A5\u6493\u6495\u64A9\u6492\u64AE\u64AD\u64AB\u649A\u64AC\u6499\u64A2\u64B3\u6575\u6577\u6578\u66AE\u66AB\u66B4\u66B1\u6A23\u6A1F\u69E8\u6A01\u6A1E\u6A19\u69FD\u6A21\u6A13\u6A0A\u69F3\u6A02\u6A05\u69ED\u6A11\u6B50\u6B4E\u6BA4\u6BC5\u6BC6\u6F3F\u6F7C\u6F84\u6F51\u6F66\u6F54\u6F86\u6F6D\u6F5B\u6F78\u6F6E\u6F8E\u6F7A\u6F70\u6F64\u6F97\u6F58\u6ED5\u6F6F\u6F60\u6F5F\u719F\u71AC\u71B1\u71A8\u7256\u729B\u734E\u7357\u7469\u748B\u7483"],
      ["bd40", "\u747E\u7480\u757F\u7620\u7629\u761F\u7624\u7626\u7621\u7622\u769A\u76BA\u76E4\u778E\u7787\u778C\u7791\u778B\u78CB\u78C5\u78BA\u78CA\u78BE\u78D5\u78BC\u78D0\u7A3F\u7A3C\u7A40\u7A3D\u7A37\u7A3B\u7AAF\u7AAE\u7BAD\u7BB1\u7BC4\u7BB4\u7BC6\u7BC7\u7BC1\u7BA0\u7BCC\u7CCA\u7DE0\u7DF4\u7DEF\u7DFB\u7DD8\u7DEC\u7DDD\u7DE8\u7DE3\u7DDA\u7DDE\u7DE9\u7D9E\u7DD9\u7DF2\u7DF9\u7F75\u7F77\u7FAF"],
      ["bda1", "\u7FE9\u8026\u819B\u819C\u819D\u81A0\u819A\u8198\u8517\u853D\u851A\u84EE\u852C\u852D\u8513\u8511\u8523\u8521\u8514\u84EC\u8525\u84FF\u8506\u8782\u8774\u8776\u8760\u8766\u8778\u8768\u8759\u8757\u874C\u8753\u885B\u885D\u8910\u8907\u8912\u8913\u8915\u890A\u8ABC\u8AD2\u8AC7\u8AC4\u8A95\u8ACB\u8AF8\u8AB2\u8AC9\u8AC2\u8ABF\u8AB0\u8AD6\u8ACD\u8AB6\u8AB9\u8ADB\u8C4C\u8C4E\u8C6C\u8CE0\u8CDE\u8CE6\u8CE4\u8CEC\u8CED\u8CE2\u8CE3\u8CDC\u8CEA\u8CE1\u8D6D\u8D9F\u8DA3\u8E2B\u8E10\u8E1D\u8E22\u8E0F\u8E29\u8E1F\u8E21\u8E1E\u8EBA\u8F1D\u8F1B\u8F1F\u8F29\u8F26\u8F2A\u8F1C\u8F1E"],
      ["be40", "\u8F25\u9069\u906E\u9068\u906D\u9077\u9130\u912D\u9127\u9131\u9187\u9189\u918B\u9183\u92C5\u92BB\u92B7\u92EA\u92AC\u92E4\u92C1\u92B3\u92BC\u92D2\u92C7\u92F0\u92B2\u95AD\u95B1\u9704\u9706\u9707\u9709\u9760\u978D\u978B\u978F\u9821\u982B\u981C\u98B3\u990A\u9913\u9912\u9918\u99DD\u99D0\u99DF\u99DB\u99D1\u99D5\u99D2\u99D9\u9AB7\u9AEE\u9AEF\u9B27\u9B45\u9B44\u9B77\u9B6F\u9D06\u9D09"],
      ["bea1", "\u9D03\u9EA9\u9EBE\u9ECE\u58A8\u9F52\u5112\u5118\u5114\u5110\u5115\u5180\u51AA\u51DD\u5291\u5293\u52F3\u5659\u566B\u5679\u5669\u5664\u5678\u566A\u5668\u5665\u5671\u566F\u566C\u5662\u5676\u58C1\u58BE\u58C7\u58C5\u596E\u5B1D\u5B34\u5B78\u5BF0\u5C0E\u5F4A\u61B2\u6191\u61A9\u618A\u61CD\u61B6\u61BE\u61CA\u61C8\u6230\u64C5\u64C1\u64CB\u64BB\u64BC\u64DA\u64C4\u64C7\u64C2\u64CD\u64BF\u64D2\u64D4\u64BE\u6574\u66C6\u66C9\u66B9\u66C4\u66C7\u66B8\u6A3D\u6A38\u6A3A\u6A59\u6A6B\u6A58\u6A39\u6A44\u6A62\u6A61\u6A4B\u6A47\u6A35\u6A5F\u6A48\u6B59\u6B77\u6C05\u6FC2\u6FB1\u6FA1"],
      ["bf40", "\u6FC3\u6FA4\u6FC1\u6FA7\u6FB3\u6FC0\u6FB9\u6FB6\u6FA6\u6FA0\u6FB4\u71BE\u71C9\u71D0\u71D2\u71C8\u71D5\u71B9\u71CE\u71D9\u71DC\u71C3\u71C4\u7368\u749C\u74A3\u7498\u749F\u749E\u74E2\u750C\u750D\u7634\u7638\u763A\u76E7\u76E5\u77A0\u779E\u779F\u77A5\u78E8\u78DA\u78EC\u78E7\u79A6\u7A4D\u7A4E\u7A46\u7A4C\u7A4B\u7ABA\u7BD9\u7C11\u7BC9\u7BE4\u7BDB\u7BE1\u7BE9\u7BE6\u7CD5\u7CD6\u7E0A"],
      ["bfa1", "\u7E11\u7E08\u7E1B\u7E23\u7E1E\u7E1D\u7E09\u7E10\u7F79\u7FB2\u7FF0\u7FF1\u7FEE\u8028\u81B3\u81A9\u81A8\u81FB\u8208\u8258\u8259\u854A\u8559\u8548\u8568\u8569\u8543\u8549\u856D\u856A\u855E\u8783\u879F\u879E\u87A2\u878D\u8861\u892A\u8932\u8925\u892B\u8921\u89AA\u89A6\u8AE6\u8AFA\u8AEB\u8AF1\u8B00\u8ADC\u8AE7\u8AEE\u8AFE\u8B01\u8B02\u8AF7\u8AED\u8AF3\u8AF6\u8AFC\u8C6B\u8C6D\u8C93\u8CF4\u8E44\u8E31\u8E34\u8E42\u8E39\u8E35\u8F3B\u8F2F\u8F38\u8F33\u8FA8\u8FA6\u9075\u9074\u9078\u9072\u907C\u907A\u9134\u9192\u9320\u9336\u92F8\u9333\u932F\u9322\u92FC\u932B\u9304\u931A"],
      ["c040", "\u9310\u9326\u9321\u9315\u932E\u9319\u95BB\u96A7\u96A8\u96AA\u96D5\u970E\u9711\u9716\u970D\u9713\u970F\u975B\u975C\u9766\u9798\u9830\u9838\u983B\u9837\u982D\u9839\u9824\u9910\u9928\u991E\u991B\u9921\u991A\u99ED\u99E2\u99F1\u9AB8\u9ABC\u9AFB\u9AED\u9B28\u9B91\u9D15\u9D23\u9D26\u9D28\u9D12\u9D1B\u9ED8\u9ED4\u9F8D\u9F9C\u512A\u511F\u5121\u5132\u52F5\u568E\u5680\u5690\u5685\u5687"],
      ["c0a1", "\u568F\u58D5\u58D3\u58D1\u58CE\u5B30\u5B2A\u5B24\u5B7A\u5C37\u5C68\u5DBC\u5DBA\u5DBD\u5DB8\u5E6B\u5F4C\u5FBD\u61C9\u61C2\u61C7\u61E6\u61CB\u6232\u6234\u64CE\u64CA\u64D8\u64E0\u64F0\u64E6\u64EC\u64F1\u64E2\u64ED\u6582\u6583\u66D9\u66D6\u6A80\u6A94\u6A84\u6AA2\u6A9C\u6ADB\u6AA3\u6A7E\u6A97\u6A90\u6AA0\u6B5C\u6BAE\u6BDA\u6C08\u6FD8\u6FF1\u6FDF\u6FE0\u6FDB\u6FE4\u6FEB\u6FEF\u6F80\u6FEC\u6FE1\u6FE9\u6FD5\u6FEE\u6FF0\u71E7\u71DF\u71EE\u71E6\u71E5\u71ED\u71EC\u71F4\u71E0\u7235\u7246\u7370\u7372\u74A9\u74B0\u74A6\u74A8\u7646\u7642\u764C\u76EA\u77B3\u77AA\u77B0\u77AC"],
      ["c140", "\u77A7\u77AD\u77EF\u78F7\u78FA\u78F4\u78EF\u7901\u79A7\u79AA\u7A57\u7ABF\u7C07\u7C0D\u7BFE\u7BF7\u7C0C\u7BE0\u7CE0\u7CDC\u7CDE\u7CE2\u7CDF\u7CD9\u7CDD\u7E2E\u7E3E\u7E46\u7E37\u7E32\u7E43\u7E2B\u7E3D\u7E31\u7E45\u7E41\u7E34\u7E39\u7E48\u7E35\u7E3F\u7E2F\u7F44\u7FF3\u7FFC\u8071\u8072\u8070\u806F\u8073\u81C6\u81C3\u81BA\u81C2\u81C0\u81BF\u81BD\u81C9\u81BE\u81E8\u8209\u8271\u85AA"],
      ["c1a1", "\u8584\u857E\u859C\u8591\u8594\u85AF\u859B\u8587\u85A8\u858A\u8667\u87C0\u87D1\u87B3\u87D2\u87C6\u87AB\u87BB\u87BA\u87C8\u87CB\u893B\u8936\u8944\u8938\u893D\u89AC\u8B0E\u8B17\u8B19\u8B1B\u8B0A\u8B20\u8B1D\u8B04\u8B10\u8C41\u8C3F\u8C73\u8CFA\u8CFD\u8CFC\u8CF8\u8CFB\u8DA8\u8E49\u8E4B\u8E48\u8E4A\u8F44\u8F3E\u8F42\u8F45\u8F3F\u907F\u907D\u9084\u9081\u9082\u9080\u9139\u91A3\u919E\u919C\u934D\u9382\u9328\u9375\u934A\u9365\u934B\u9318\u937E\u936C\u935B\u9370\u935A\u9354\u95CA\u95CB\u95CC\u95C8\u95C6\u96B1\u96B8\u96D6\u971C\u971E\u97A0\u97D3\u9846\u98B6\u9935\u9A01"],
      ["c240", "\u99FF\u9BAE\u9BAB\u9BAA\u9BAD\u9D3B\u9D3F\u9E8B\u9ECF\u9EDE\u9EDC\u9EDD\u9EDB\u9F3E\u9F4B\u53E2\u5695\u56AE\u58D9\u58D8\u5B38\u5F5D\u61E3\u6233\u64F4\u64F2\u64FE\u6506\u64FA\u64FB\u64F7\u65B7\u66DC\u6726\u6AB3\u6AAC\u6AC3\u6ABB\u6AB8\u6AC2\u6AAE\u6AAF\u6B5F\u6B78\u6BAF\u7009\u700B\u6FFE\u7006\u6FFA\u7011\u700F\u71FB\u71FC\u71FE\u71F8\u7377\u7375\u74A7\u74BF\u7515\u7656\u7658"],
      ["c2a1", "\u7652\u77BD\u77BF\u77BB\u77BC\u790E\u79AE\u7A61\u7A62\u7A60\u7AC4\u7AC5\u7C2B\u7C27\u7C2A\u7C1E\u7C23\u7C21\u7CE7\u7E54\u7E55\u7E5E\u7E5A\u7E61\u7E52\u7E59\u7F48\u7FF9\u7FFB\u8077\u8076\u81CD\u81CF\u820A\u85CF\u85A9\u85CD\u85D0\u85C9\u85B0\u85BA\u85B9\u85A6\u87EF\u87EC\u87F2\u87E0\u8986\u89B2\u89F4\u8B28\u8B39\u8B2C\u8B2B\u8C50\u8D05\u8E59\u8E63\u8E66\u8E64\u8E5F\u8E55\u8EC0\u8F49\u8F4D\u9087\u9083\u9088\u91AB\u91AC\u91D0\u9394\u938A\u9396\u93A2\u93B3\u93AE\u93AC\u93B0\u9398\u939A\u9397\u95D4\u95D6\u95D0\u95D5\u96E2\u96DC\u96D9\u96DB\u96DE\u9724\u97A3\u97A6"],
      ["c340", "\u97AD\u97F9\u984D\u984F\u984C\u984E\u9853\u98BA\u993E\u993F\u993D\u992E\u99A5\u9A0E\u9AC1\u9B03\u9B06\u9B4F\u9B4E\u9B4D\u9BCA\u9BC9\u9BFD\u9BC8\u9BC0\u9D51\u9D5D\u9D60\u9EE0\u9F15\u9F2C\u5133\u56A5\u58DE\u58DF\u58E2\u5BF5\u9F90\u5EEC\u61F2\u61F7\u61F6\u61F5\u6500\u650F\u66E0\u66DD\u6AE5\u6ADD\u6ADA\u6AD3\u701B\u701F\u7028\u701A\u701D\u7015\u7018\u7206\u720D\u7258\u72A2\u7378"],
      ["c3a1", "\u737A\u74BD\u74CA\u74E3\u7587\u7586\u765F\u7661\u77C7\u7919\u79B1\u7A6B\u7A69\u7C3E\u7C3F\u7C38\u7C3D\u7C37\u7C40\u7E6B\u7E6D\u7E79\u7E69\u7E6A\u7F85\u7E73\u7FB6\u7FB9\u7FB8\u81D8\u85E9\u85DD\u85EA\u85D5\u85E4\u85E5\u85F7\u87FB\u8805\u880D\u87F9\u87FE\u8960\u895F\u8956\u895E\u8B41\u8B5C\u8B58\u8B49\u8B5A\u8B4E\u8B4F\u8B46\u8B59\u8D08\u8D0A\u8E7C\u8E72\u8E87\u8E76\u8E6C\u8E7A\u8E74\u8F54\u8F4E\u8FAD\u908A\u908B\u91B1\u91AE\u93E1\u93D1\u93DF\u93C3\u93C8\u93DC\u93DD\u93D6\u93E2\u93CD\u93D8\u93E4\u93D7\u93E8\u95DC\u96B4\u96E3\u972A\u9727\u9761\u97DC\u97FB\u985E"],
      ["c440", "\u9858\u985B\u98BC\u9945\u9949\u9A16\u9A19\u9B0D\u9BE8\u9BE7\u9BD6\u9BDB\u9D89\u9D61\u9D72\u9D6A\u9D6C\u9E92\u9E97\u9E93\u9EB4\u52F8\u56A8\u56B7\u56B6\u56B4\u56BC\u58E4\u5B40\u5B43\u5B7D\u5BF6\u5DC9\u61F8\u61FA\u6518\u6514\u6519\u66E6\u6727\u6AEC\u703E\u7030\u7032\u7210\u737B\u74CF\u7662\u7665\u7926\u792A\u792C\u792B\u7AC7\u7AF6\u7C4C\u7C43\u7C4D\u7CEF\u7CF0\u8FAE\u7E7D\u7E7C"],
      ["c4a1", "\u7E82\u7F4C\u8000\u81DA\u8266\u85FB\u85F9\u8611\u85FA\u8606\u860B\u8607\u860A\u8814\u8815\u8964\u89BA\u89F8\u8B70\u8B6C\u8B66\u8B6F\u8B5F\u8B6B\u8D0F\u8D0D\u8E89\u8E81\u8E85\u8E82\u91B4\u91CB\u9418\u9403\u93FD\u95E1\u9730\u98C4\u9952\u9951\u99A8\u9A2B\u9A30\u9A37\u9A35\u9C13\u9C0D\u9E79\u9EB5\u9EE8\u9F2F\u9F5F\u9F63\u9F61\u5137\u5138\u56C1\u56C0\u56C2\u5914\u5C6C\u5DCD\u61FC\u61FE\u651D\u651C\u6595\u66E9\u6AFB\u6B04\u6AFA\u6BB2\u704C\u721B\u72A7\u74D6\u74D4\u7669\u77D3\u7C50\u7E8F\u7E8C\u7FBC\u8617\u862D\u861A\u8823\u8822\u8821\u881F\u896A\u896C\u89BD\u8B74"],
      ["c540", "\u8B77\u8B7D\u8D13\u8E8A\u8E8D\u8E8B\u8F5F\u8FAF\u91BA\u942E\u9433\u9435\u943A\u9438\u9432\u942B\u95E2\u9738\u9739\u9732\u97FF\u9867\u9865\u9957\u9A45\u9A43\u9A40\u9A3E\u9ACF\u9B54\u9B51\u9C2D\u9C25\u9DAF\u9DB4\u9DC2\u9DB8\u9E9D\u9EEF\u9F19\u9F5C\u9F66\u9F67\u513C\u513B\u56C8\u56CA\u56C9\u5B7F\u5DD4\u5DD2\u5F4E\u61FF\u6524\u6B0A\u6B61\u7051\u7058\u7380\u74E4\u758A\u766E\u766C"],
      ["c5a1", "\u79B3\u7C60\u7C5F\u807E\u807D\u81DF\u8972\u896F\u89FC\u8B80\u8D16\u8D17\u8E91\u8E93\u8F61\u9148\u9444\u9451\u9452\u973D\u973E\u97C3\u97C1\u986B\u9955\u9A55\u9A4D\u9AD2\u9B1A\u9C49\u9C31\u9C3E\u9C3B\u9DD3\u9DD7\u9F34\u9F6C\u9F6A\u9F94\u56CC\u5DD6\u6200\u6523\u652B\u652A\u66EC\u6B10\u74DA\u7ACA\u7C64\u7C63\u7C65\u7E93\u7E96\u7E94\u81E2\u8638\u863F\u8831\u8B8A\u9090\u908F\u9463\u9460\u9464\u9768\u986F\u995C\u9A5A\u9A5B\u9A57\u9AD3\u9AD4\u9AD1\u9C54\u9C57\u9C56\u9DE5\u9E9F\u9EF4\u56D1\u58E9\u652C\u705E\u7671\u7672\u77D7\u7F50\u7F88\u8836\u8839\u8862\u8B93\u8B92"],
      ["c640", "\u8B96\u8277\u8D1B\u91C0\u946A\u9742\u9748\u9744\u97C6\u9870\u9A5F\u9B22\u9B58\u9C5F\u9DF9\u9DFA\u9E7C\u9E7D\u9F07\u9F77\u9F72\u5EF3\u6B16\u7063\u7C6C\u7C6E\u883B\u89C0\u8EA1\u91C1\u9472\u9470\u9871\u995E\u9AD6\u9B23\u9ECC\u7064\u77DA\u8B9A\u9477\u97C9\u9A62\u9A65\u7E9C\u8B9C\u8EAA\u91C5\u947D\u947E\u947C\u9C77\u9C78\u9EF7\u8C54\u947F\u9E1A\u7228\u9A6A\u9B31\u9E1B\u9E1E\u7C72"],
      ["c940", "\u4E42\u4E5C\u51F5\u531A\u5382\u4E07\u4E0C\u4E47\u4E8D\u56D7\uFA0C\u5C6E\u5F73\u4E0F\u5187\u4E0E\u4E2E\u4E93\u4EC2\u4EC9\u4EC8\u5198\u52FC\u536C\u53B9\u5720\u5903\u592C\u5C10\u5DFF\u65E1\u6BB3\u6BCC\u6C14\u723F\u4E31\u4E3C\u4EE8\u4EDC\u4EE9\u4EE1\u4EDD\u4EDA\u520C\u531C\u534C\u5722\u5723\u5917\u592F\u5B81\u5B84\u5C12\u5C3B\u5C74\u5C73\u5E04\u5E80\u5E82\u5FC9\u6209\u6250\u6C15"],
      ["c9a1", "\u6C36\u6C43\u6C3F\u6C3B\u72AE\u72B0\u738A\u79B8\u808A\u961E\u4F0E\u4F18\u4F2C\u4EF5\u4F14\u4EF1\u4F00\u4EF7\u4F08\u4F1D\u4F02\u4F05\u4F22\u4F13\u4F04\u4EF4\u4F12\u51B1\u5213\u5209\u5210\u52A6\u5322\u531F\u534D\u538A\u5407\u56E1\u56DF\u572E\u572A\u5734\u593C\u5980\u597C\u5985\u597B\u597E\u5977\u597F\u5B56\u5C15\u5C25\u5C7C\u5C7A\u5C7B\u5C7E\u5DDF\u5E75\u5E84\u5F02\u5F1A\u5F74\u5FD5\u5FD4\u5FCF\u625C\u625E\u6264\u6261\u6266\u6262\u6259\u6260\u625A\u6265\u65EF\u65EE\u673E\u6739\u6738\u673B\u673A\u673F\u673C\u6733\u6C18\u6C46\u6C52\u6C5C\u6C4F\u6C4A\u6C54\u6C4B"],
      ["ca40", "\u6C4C\u7071\u725E\u72B4\u72B5\u738E\u752A\u767F\u7A75\u7F51\u8278\u827C\u8280\u827D\u827F\u864D\u897E\u9099\u9097\u9098\u909B\u9094\u9622\u9624\u9620\u9623\u4F56\u4F3B\u4F62\u4F49\u4F53\u4F64\u4F3E\u4F67\u4F52\u4F5F\u4F41\u4F58\u4F2D\u4F33\u4F3F\u4F61\u518F\u51B9\u521C\u521E\u5221\u52AD\u52AE\u5309\u5363\u5372\u538E\u538F\u5430\u5437\u542A\u5454\u5445\u5419\u541C\u5425\u5418"],
      ["caa1", "\u543D\u544F\u5441\u5428\u5424\u5447\u56EE\u56E7\u56E5\u5741\u5745\u574C\u5749\u574B\u5752\u5906\u5940\u59A6\u5998\u59A0\u5997\u598E\u59A2\u5990\u598F\u59A7\u59A1\u5B8E\u5B92\u5C28\u5C2A\u5C8D\u5C8F\u5C88\u5C8B\u5C89\u5C92\u5C8A\u5C86\u5C93\u5C95\u5DE0\u5E0A\u5E0E\u5E8B\u5E89\u5E8C\u5E88\u5E8D\u5F05\u5F1D\u5F78\u5F76\u5FD2\u5FD1\u5FD0\u5FED\u5FE8\u5FEE\u5FF3\u5FE1\u5FE4\u5FE3\u5FFA\u5FEF\u5FF7\u5FFB\u6000\u5FF4\u623A\u6283\u628C\u628E\u628F\u6294\u6287\u6271\u627B\u627A\u6270\u6281\u6288\u6277\u627D\u6272\u6274\u6537\u65F0\u65F4\u65F3\u65F2\u65F5\u6745\u6747"],
      ["cb40", "\u6759\u6755\u674C\u6748\u675D\u674D\u675A\u674B\u6BD0\u6C19\u6C1A\u6C78\u6C67\u6C6B\u6C84\u6C8B\u6C8F\u6C71\u6C6F\u6C69\u6C9A\u6C6D\u6C87\u6C95\u6C9C\u6C66\u6C73\u6C65\u6C7B\u6C8E\u7074\u707A\u7263\u72BF\u72BD\u72C3\u72C6\u72C1\u72BA\u72C5\u7395\u7397\u7393\u7394\u7392\u753A\u7539\u7594\u7595\u7681\u793D\u8034\u8095\u8099\u8090\u8092\u809C\u8290\u828F\u8285\u828E\u8291\u8293"],
      ["cba1", "\u828A\u8283\u8284\u8C78\u8FC9\u8FBF\u909F\u90A1\u90A5\u909E\u90A7\u90A0\u9630\u9628\u962F\u962D\u4E33\u4F98\u4F7C\u4F85\u4F7D\u4F80\u4F87\u4F76\u4F74\u4F89\u4F84\u4F77\u4F4C\u4F97\u4F6A\u4F9A\u4F79\u4F81\u4F78\u4F90\u4F9C\u4F94\u4F9E\u4F92\u4F82\u4F95\u4F6B\u4F6E\u519E\u51BC\u51BE\u5235\u5232\u5233\u5246\u5231\u52BC\u530A\u530B\u533C\u5392\u5394\u5487\u547F\u5481\u5491\u5482\u5488\u546B\u547A\u547E\u5465\u546C\u5474\u5466\u548D\u546F\u5461\u5460\u5498\u5463\u5467\u5464\u56F7\u56F9\u576F\u5772\u576D\u576B\u5771\u5770\u5776\u5780\u5775\u577B\u5773\u5774\u5762"],
      ["cc40", "\u5768\u577D\u590C\u5945\u59B5\u59BA\u59CF\u59CE\u59B2\u59CC\u59C1\u59B6\u59BC\u59C3\u59D6\u59B1\u59BD\u59C0\u59C8\u59B4\u59C7\u5B62\u5B65\u5B93\u5B95\u5C44\u5C47\u5CAE\u5CA4\u5CA0\u5CB5\u5CAF\u5CA8\u5CAC\u5C9F\u5CA3\u5CAD\u5CA2\u5CAA\u5CA7\u5C9D\u5CA5\u5CB6\u5CB0\u5CA6\u5E17\u5E14\u5E19\u5F28\u5F22\u5F23\u5F24\u5F54\u5F82\u5F7E\u5F7D\u5FDE\u5FE5\u602D\u6026\u6019\u6032\u600B"],
      ["cca1", "\u6034\u600A\u6017\u6033\u601A\u601E\u602C\u6022\u600D\u6010\u602E\u6013\u6011\u600C\u6009\u601C\u6214\u623D\u62AD\u62B4\u62D1\u62BE\u62AA\u62B6\u62CA\u62AE\u62B3\u62AF\u62BB\u62A9\u62B0\u62B8\u653D\u65A8\u65BB\u6609\u65FC\u6604\u6612\u6608\u65FB\u6603\u660B\u660D\u6605\u65FD\u6611\u6610\u66F6\u670A\u6785\u676C\u678E\u6792\u6776\u677B\u6798\u6786\u6784\u6774\u678D\u678C\u677A\u679F\u6791\u6799\u6783\u677D\u6781\u6778\u6779\u6794\u6B25\u6B80\u6B7E\u6BDE\u6C1D\u6C93\u6CEC\u6CEB\u6CEE\u6CD9\u6CB6\u6CD4\u6CAD\u6CE7\u6CB7\u6CD0\u6CC2\u6CBA\u6CC3\u6CC6\u6CED\u6CF2"],
      ["cd40", "\u6CD2\u6CDD\u6CB4\u6C8A\u6C9D\u6C80\u6CDE\u6CC0\u6D30\u6CCD\u6CC7\u6CB0\u6CF9\u6CCF\u6CE9\u6CD1\u7094\u7098\u7085\u7093\u7086\u7084\u7091\u7096\u7082\u709A\u7083\u726A\u72D6\u72CB\u72D8\u72C9\u72DC\u72D2\u72D4\u72DA\u72CC\u72D1\u73A4\u73A1\u73AD\u73A6\u73A2\u73A0\u73AC\u739D\u74DD\u74E8\u753F\u7540\u753E\u758C\u7598\u76AF\u76F3\u76F1\u76F0\u76F5\u77F8\u77FC\u77F9\u77FB\u77FA"],
      ["cda1", "\u77F7\u7942\u793F\u79C5\u7A78\u7A7B\u7AFB\u7C75\u7CFD\u8035\u808F\u80AE\u80A3\u80B8\u80B5\u80AD\u8220\u82A0\u82C0\u82AB\u829A\u8298\u829B\u82B5\u82A7\u82AE\u82BC\u829E\u82BA\u82B4\u82A8\u82A1\u82A9\u82C2\u82A4\u82C3\u82B6\u82A2\u8670\u866F\u866D\u866E\u8C56\u8FD2\u8FCB\u8FD3\u8FCD\u8FD6\u8FD5\u8FD7\u90B2\u90B4\u90AF\u90B3\u90B0\u9639\u963D\u963C\u963A\u9643\u4FCD\u4FC5\u4FD3\u4FB2\u4FC9\u4FCB\u4FC1\u4FD4\u4FDC\u4FD9\u4FBB\u4FB3\u4FDB\u4FC7\u4FD6\u4FBA\u4FC0\u4FB9\u4FEC\u5244\u5249\u52C0\u52C2\u533D\u537C\u5397\u5396\u5399\u5398\u54BA\u54A1\u54AD\u54A5\u54CF"],
      ["ce40", "\u54C3\u830D\u54B7\u54AE\u54D6\u54B6\u54C5\u54C6\u54A0\u5470\u54BC\u54A2\u54BE\u5472\u54DE\u54B0\u57B5\u579E\u579F\u57A4\u578C\u5797\u579D\u579B\u5794\u5798\u578F\u5799\u57A5\u579A\u5795\u58F4\u590D\u5953\u59E1\u59DE\u59EE\u5A00\u59F1\u59DD\u59FA\u59FD\u59FC\u59F6\u59E4\u59F2\u59F7\u59DB\u59E9\u59F3\u59F5\u59E0\u59FE\u59F4\u59ED\u5BA8\u5C4C\u5CD0\u5CD8\u5CCC\u5CD7\u5CCB\u5CDB"],
      ["cea1", "\u5CDE\u5CDA\u5CC9\u5CC7\u5CCA\u5CD6\u5CD3\u5CD4\u5CCF\u5CC8\u5CC6\u5CCE\u5CDF\u5CF8\u5DF9\u5E21\u5E22\u5E23\u5E20\u5E24\u5EB0\u5EA4\u5EA2\u5E9B\u5EA3\u5EA5\u5F07\u5F2E\u5F56\u5F86\u6037\u6039\u6054\u6072\u605E\u6045\u6053\u6047\u6049\u605B\u604C\u6040\u6042\u605F\u6024\u6044\u6058\u6066\u606E\u6242\u6243\u62CF\u630D\u630B\u62F5\u630E\u6303\u62EB\u62F9\u630F\u630C\u62F8\u62F6\u6300\u6313\u6314\u62FA\u6315\u62FB\u62F0\u6541\u6543\u65AA\u65BF\u6636\u6621\u6632\u6635\u661C\u6626\u6622\u6633\u662B\u663A\u661D\u6634\u6639\u662E\u670F\u6710\u67C1\u67F2\u67C8\u67BA"],
      ["cf40", "\u67DC\u67BB\u67F8\u67D8\u67C0\u67B7\u67C5\u67EB\u67E4\u67DF\u67B5\u67CD\u67B3\u67F7\u67F6\u67EE\u67E3\u67C2\u67B9\u67CE\u67E7\u67F0\u67B2\u67FC\u67C6\u67ED\u67CC\u67AE\u67E6\u67DB\u67FA\u67C9\u67CA\u67C3\u67EA\u67CB\u6B28\u6B82\u6B84\u6BB6\u6BD6\u6BD8\u6BE0\u6C20\u6C21\u6D28\u6D34\u6D2D\u6D1F\u6D3C\u6D3F\u6D12\u6D0A\u6CDA\u6D33\u6D04\u6D19\u6D3A\u6D1A\u6D11\u6D00\u6D1D\u6D42"],
      ["cfa1", "\u6D01\u6D18\u6D37\u6D03\u6D0F\u6D40\u6D07\u6D20\u6D2C\u6D08\u6D22\u6D09\u6D10\u70B7\u709F\u70BE\u70B1\u70B0\u70A1\u70B4\u70B5\u70A9\u7241\u7249\u724A\u726C\u7270\u7273\u726E\u72CA\u72E4\u72E8\u72EB\u72DF\u72EA\u72E6\u72E3\u7385\u73CC\u73C2\u73C8\u73C5\u73B9\u73B6\u73B5\u73B4\u73EB\u73BF\u73C7\u73BE\u73C3\u73C6\u73B8\u73CB\u74EC\u74EE\u752E\u7547\u7548\u75A7\u75AA\u7679\u76C4\u7708\u7703\u7704\u7705\u770A\u76F7\u76FB\u76FA\u77E7\u77E8\u7806\u7811\u7812\u7805\u7810\u780F\u780E\u7809\u7803\u7813\u794A\u794C\u794B\u7945\u7944\u79D5\u79CD\u79CF\u79D6\u79CE\u7A80"],
      ["d040", "\u7A7E\u7AD1\u7B00\u7B01\u7C7A\u7C78\u7C79\u7C7F\u7C80\u7C81\u7D03\u7D08\u7D01\u7F58\u7F91\u7F8D\u7FBE\u8007\u800E\u800F\u8014\u8037\u80D8\u80C7\u80E0\u80D1\u80C8\u80C2\u80D0\u80C5\u80E3\u80D9\u80DC\u80CA\u80D5\u80C9\u80CF\u80D7\u80E6\u80CD\u81FF\u8221\u8294\u82D9\u82FE\u82F9\u8307\u82E8\u8300\u82D5\u833A\u82EB\u82D6\u82F4\u82EC\u82E1\u82F2\u82F5\u830C\u82FB\u82F6\u82F0\u82EA"],
      ["d0a1", "\u82E4\u82E0\u82FA\u82F3\u82ED\u8677\u8674\u867C\u8673\u8841\u884E\u8867\u886A\u8869\u89D3\u8A04\u8A07\u8D72\u8FE3\u8FE1\u8FEE\u8FE0\u90F1\u90BD\u90BF\u90D5\u90C5\u90BE\u90C7\u90CB\u90C8\u91D4\u91D3\u9654\u964F\u9651\u9653\u964A\u964E\u501E\u5005\u5007\u5013\u5022\u5030\u501B\u4FF5\u4FF4\u5033\u5037\u502C\u4FF6\u4FF7\u5017\u501C\u5020\u5027\u5035\u502F\u5031\u500E\u515A\u5194\u5193\u51CA\u51C4\u51C5\u51C8\u51CE\u5261\u525A\u5252\u525E\u525F\u5255\u5262\u52CD\u530E\u539E\u5526\u54E2\u5517\u5512\u54E7\u54F3\u54E4\u551A\u54FF\u5504\u5508\u54EB\u5511\u5505\u54F1"],
      ["d140", "\u550A\u54FB\u54F7\u54F8\u54E0\u550E\u5503\u550B\u5701\u5702\u57CC\u5832\u57D5\u57D2\u57BA\u57C6\u57BD\u57BC\u57B8\u57B6\u57BF\u57C7\u57D0\u57B9\u57C1\u590E\u594A\u5A19\u5A16\u5A2D\u5A2E\u5A15\u5A0F\u5A17\u5A0A\u5A1E\u5A33\u5B6C\u5BA7\u5BAD\u5BAC\u5C03\u5C56\u5C54\u5CEC\u5CFF\u5CEE\u5CF1\u5CF7\u5D00\u5CF9\u5E29\u5E28\u5EA8\u5EAE\u5EAA\u5EAC\u5F33\u5F30\u5F67\u605D\u605A\u6067"],
      ["d1a1", "\u6041\u60A2\u6088\u6080\u6092\u6081\u609D\u6083\u6095\u609B\u6097\u6087\u609C\u608E\u6219\u6246\u62F2\u6310\u6356\u632C\u6344\u6345\u6336\u6343\u63E4\u6339\u634B\u634A\u633C\u6329\u6341\u6334\u6358\u6354\u6359\u632D\u6347\u6333\u635A\u6351\u6338\u6357\u6340\u6348\u654A\u6546\u65C6\u65C3\u65C4\u65C2\u664A\u665F\u6647\u6651\u6712\u6713\u681F\u681A\u6849\u6832\u6833\u683B\u684B\u684F\u6816\u6831\u681C\u6835\u682B\u682D\u682F\u684E\u6844\u6834\u681D\u6812\u6814\u6826\u6828\u682E\u684D\u683A\u6825\u6820\u6B2C\u6B2F\u6B2D\u6B31\u6B34\u6B6D\u8082\u6B88\u6BE6\u6BE4"],
      ["d240", "\u6BE8\u6BE3\u6BE2\u6BE7\u6C25\u6D7A\u6D63\u6D64\u6D76\u6D0D\u6D61\u6D92\u6D58\u6D62\u6D6D\u6D6F\u6D91\u6D8D\u6DEF\u6D7F\u6D86\u6D5E\u6D67\u6D60\u6D97\u6D70\u6D7C\u6D5F\u6D82\u6D98\u6D2F\u6D68\u6D8B\u6D7E\u6D80\u6D84\u6D16\u6D83\u6D7B\u6D7D\u6D75\u6D90\u70DC\u70D3\u70D1\u70DD\u70CB\u7F39\u70E2\u70D7\u70D2\u70DE\u70E0\u70D4\u70CD\u70C5\u70C6\u70C7\u70DA\u70CE\u70E1\u7242\u7278"],
      ["d2a1", "\u7277\u7276\u7300\u72FA\u72F4\u72FE\u72F6\u72F3\u72FB\u7301\u73D3\u73D9\u73E5\u73D6\u73BC\u73E7\u73E3\u73E9\u73DC\u73D2\u73DB\u73D4\u73DD\u73DA\u73D7\u73D8\u73E8\u74DE\u74DF\u74F4\u74F5\u7521\u755B\u755F\u75B0\u75C1\u75BB\u75C4\u75C0\u75BF\u75B6\u75BA\u768A\u76C9\u771D\u771B\u7710\u7713\u7712\u7723\u7711\u7715\u7719\u771A\u7722\u7727\u7823\u782C\u7822\u7835\u782F\u7828\u782E\u782B\u7821\u7829\u7833\u782A\u7831\u7954\u795B\u794F\u795C\u7953\u7952\u7951\u79EB\u79EC\u79E0\u79EE\u79ED\u79EA\u79DC\u79DE\u79DD\u7A86\u7A89\u7A85\u7A8B\u7A8C\u7A8A\u7A87\u7AD8\u7B10"],
      ["d340", "\u7B04\u7B13\u7B05\u7B0F\u7B08\u7B0A\u7B0E\u7B09\u7B12\u7C84\u7C91\u7C8A\u7C8C\u7C88\u7C8D\u7C85\u7D1E\u7D1D\u7D11\u7D0E\u7D18\u7D16\u7D13\u7D1F\u7D12\u7D0F\u7D0C\u7F5C\u7F61\u7F5E\u7F60\u7F5D\u7F5B\u7F96\u7F92\u7FC3\u7FC2\u7FC0\u8016\u803E\u8039\u80FA\u80F2\u80F9\u80F5\u8101\u80FB\u8100\u8201\u822F\u8225\u8333\u832D\u8344\u8319\u8351\u8325\u8356\u833F\u8341\u8326\u831C\u8322"],
      ["d3a1", "\u8342\u834E\u831B\u832A\u8308\u833C\u834D\u8316\u8324\u8320\u8337\u832F\u8329\u8347\u8345\u834C\u8353\u831E\u832C\u834B\u8327\u8348\u8653\u8652\u86A2\u86A8\u8696\u868D\u8691\u869E\u8687\u8697\u8686\u868B\u869A\u8685\u86A5\u8699\u86A1\u86A7\u8695\u8698\u868E\u869D\u8690\u8694\u8843\u8844\u886D\u8875\u8876\u8872\u8880\u8871\u887F\u886F\u8883\u887E\u8874\u887C\u8A12\u8C47\u8C57\u8C7B\u8CA4\u8CA3\u8D76\u8D78\u8DB5\u8DB7\u8DB6\u8ED1\u8ED3\u8FFE\u8FF5\u9002\u8FFF\u8FFB\u9004\u8FFC\u8FF6\u90D6\u90E0\u90D9\u90DA\u90E3\u90DF\u90E5\u90D8\u90DB\u90D7\u90DC\u90E4\u9150"],
      ["d440", "\u914E\u914F\u91D5\u91E2\u91DA\u965C\u965F\u96BC\u98E3\u9ADF\u9B2F\u4E7F\u5070\u506A\u5061\u505E\u5060\u5053\u504B\u505D\u5072\u5048\u504D\u5041\u505B\u504A\u5062\u5015\u5045\u505F\u5069\u506B\u5063\u5064\u5046\u5040\u506E\u5073\u5057\u5051\u51D0\u526B\u526D\u526C\u526E\u52D6\u52D3\u532D\u539C\u5575\u5576\u553C\u554D\u5550\u5534\u552A\u5551\u5562\u5536\u5535\u5530\u5552\u5545"],
      ["d4a1", "\u550C\u5532\u5565\u554E\u5539\u5548\u552D\u553B\u5540\u554B\u570A\u5707\u57FB\u5814\u57E2\u57F6\u57DC\u57F4\u5800\u57ED\u57FD\u5808\u57F8\u580B\u57F3\u57CF\u5807\u57EE\u57E3\u57F2\u57E5\u57EC\u57E1\u580E\u57FC\u5810\u57E7\u5801\u580C\u57F1\u57E9\u57F0\u580D\u5804\u595C\u5A60\u5A58\u5A55\u5A67\u5A5E\u5A38\u5A35\u5A6D\u5A50\u5A5F\u5A65\u5A6C\u5A53\u5A64\u5A57\u5A43\u5A5D\u5A52\u5A44\u5A5B\u5A48\u5A8E\u5A3E\u5A4D\u5A39\u5A4C\u5A70\u5A69\u5A47\u5A51\u5A56\u5A42\u5A5C\u5B72\u5B6E\u5BC1\u5BC0\u5C59\u5D1E\u5D0B\u5D1D\u5D1A\u5D20\u5D0C\u5D28\u5D0D\u5D26\u5D25\u5D0F"],
      ["d540", "\u5D30\u5D12\u5D23\u5D1F\u5D2E\u5E3E\u5E34\u5EB1\u5EB4\u5EB9\u5EB2\u5EB3\u5F36\u5F38\u5F9B\u5F96\u5F9F\u608A\u6090\u6086\u60BE\u60B0\u60BA\u60D3\u60D4\u60CF\u60E4\u60D9\u60DD\u60C8\u60B1\u60DB\u60B7\u60CA\u60BF\u60C3\u60CD\u60C0\u6332\u6365\u638A\u6382\u637D\u63BD\u639E\u63AD\u639D\u6397\u63AB\u638E\u636F\u6387\u6390\u636E\u63AF\u6375\u639C\u636D\u63AE\u637C\u63A4\u633B\u639F"],
      ["d5a1", "\u6378\u6385\u6381\u6391\u638D\u6370\u6553\u65CD\u6665\u6661\u665B\u6659\u665C\u6662\u6718\u6879\u6887\u6890\u689C\u686D\u686E\u68AE\u68AB\u6956\u686F\u68A3\u68AC\u68A9\u6875\u6874\u68B2\u688F\u6877\u6892\u687C\u686B\u6872\u68AA\u6880\u6871\u687E\u689B\u6896\u688B\u68A0\u6889\u68A4\u6878\u687B\u6891\u688C\u688A\u687D\u6B36\u6B33\u6B37\u6B38\u6B91\u6B8F\u6B8D\u6B8E\u6B8C\u6C2A\u6DC0\u6DAB\u6DB4\u6DB3\u6E74\u6DAC\u6DE9\u6DE2\u6DB7\u6DF6\u6DD4\u6E00\u6DC8\u6DE0\u6DDF\u6DD6\u6DBE\u6DE5\u6DDC\u6DDD\u6DDB\u6DF4\u6DCA\u6DBD\u6DED\u6DF0\u6DBA\u6DD5\u6DC2\u6DCF\u6DC9"],
      ["d640", "\u6DD0\u6DF2\u6DD3\u6DFD\u6DD7\u6DCD\u6DE3\u6DBB\u70FA\u710D\u70F7\u7117\u70F4\u710C\u70F0\u7104\u70F3\u7110\u70FC\u70FF\u7106\u7113\u7100\u70F8\u70F6\u710B\u7102\u710E\u727E\u727B\u727C\u727F\u731D\u7317\u7307\u7311\u7318\u730A\u7308\u72FF\u730F\u731E\u7388\u73F6\u73F8\u73F5\u7404\u7401\u73FD\u7407\u7400\u73FA\u73FC\u73FF\u740C\u740B\u73F4\u7408\u7564\u7563\u75CE\u75D2\u75CF"],
      ["d6a1", "\u75CB\u75CC\u75D1\u75D0\u768F\u7689\u76D3\u7739\u772F\u772D\u7731\u7732\u7734\u7733\u773D\u7725\u773B\u7735\u7848\u7852\u7849\u784D\u784A\u784C\u7826\u7845\u7850\u7964\u7967\u7969\u796A\u7963\u796B\u7961\u79BB\u79FA\u79F8\u79F6\u79F7\u7A8F\u7A94\u7A90\u7B35\u7B47\u7B34\u7B25\u7B30\u7B22\u7B24\u7B33\u7B18\u7B2A\u7B1D\u7B31\u7B2B\u7B2D\u7B2F\u7B32\u7B38\u7B1A\u7B23\u7C94\u7C98\u7C96\u7CA3\u7D35\u7D3D\u7D38\u7D36\u7D3A\u7D45\u7D2C\u7D29\u7D41\u7D47\u7D3E\u7D3F\u7D4A\u7D3B\u7D28\u7F63\u7F95\u7F9C\u7F9D\u7F9B\u7FCA\u7FCB\u7FCD\u7FD0\u7FD1\u7FC7\u7FCF\u7FC9\u801F"],
      ["d740", "\u801E\u801B\u8047\u8043\u8048\u8118\u8125\u8119\u811B\u812D\u811F\u812C\u811E\u8121\u8115\u8127\u811D\u8122\u8211\u8238\u8233\u823A\u8234\u8232\u8274\u8390\u83A3\u83A8\u838D\u837A\u8373\u83A4\u8374\u838F\u8381\u8395\u8399\u8375\u8394\u83A9\u837D\u8383\u838C\u839D\u839B\u83AA\u838B\u837E\u83A5\u83AF\u8388\u8397\u83B0\u837F\u83A6\u8387\u83AE\u8376\u839A\u8659\u8656\u86BF\u86B7"],
      ["d7a1", "\u86C2\u86C1\u86C5\u86BA\u86B0\u86C8\u86B9\u86B3\u86B8\u86CC\u86B4\u86BB\u86BC\u86C3\u86BD\u86BE\u8852\u8889\u8895\u88A8\u88A2\u88AA\u889A\u8891\u88A1\u889F\u8898\u88A7\u8899\u889B\u8897\u88A4\u88AC\u888C\u8893\u888E\u8982\u89D6\u89D9\u89D5\u8A30\u8A27\u8A2C\u8A1E\u8C39\u8C3B\u8C5C\u8C5D\u8C7D\u8CA5\u8D7D\u8D7B\u8D79\u8DBC\u8DC2\u8DB9\u8DBF\u8DC1\u8ED8\u8EDE\u8EDD\u8EDC\u8ED7\u8EE0\u8EE1\u9024\u900B\u9011\u901C\u900C\u9021\u90EF\u90EA\u90F0\u90F4\u90F2\u90F3\u90D4\u90EB\u90EC\u90E9\u9156\u9158\u915A\u9153\u9155\u91EC\u91F4\u91F1\u91F3\u91F8\u91E4\u91F9\u91EA"],
      ["d840", "\u91EB\u91F7\u91E8\u91EE\u957A\u9586\u9588\u967C\u966D\u966B\u9671\u966F\u96BF\u976A\u9804\u98E5\u9997\u509B\u5095\u5094\u509E\u508B\u50A3\u5083\u508C\u508E\u509D\u5068\u509C\u5092\u5082\u5087\u515F\u51D4\u5312\u5311\u53A4\u53A7\u5591\u55A8\u55A5\u55AD\u5577\u5645\u55A2\u5593\u5588\u558F\u55B5\u5581\u55A3\u5592\u55A4\u557D\u558C\u55A6\u557F\u5595\u55A1\u558E\u570C\u5829\u5837"],
      ["d8a1", "\u5819\u581E\u5827\u5823\u5828\u57F5\u5848\u5825\u581C\u581B\u5833\u583F\u5836\u582E\u5839\u5838\u582D\u582C\u583B\u5961\u5AAF\u5A94\u5A9F\u5A7A\u5AA2\u5A9E\u5A78\u5AA6\u5A7C\u5AA5\u5AAC\u5A95\u5AAE\u5A37\u5A84\u5A8A\u5A97\u5A83\u5A8B\u5AA9\u5A7B\u5A7D\u5A8C\u5A9C\u5A8F\u5A93\u5A9D\u5BEA\u5BCD\u5BCB\u5BD4\u5BD1\u5BCA\u5BCE\u5C0C\u5C30\u5D37\u5D43\u5D6B\u5D41\u5D4B\u5D3F\u5D35\u5D51\u5D4E\u5D55\u5D33\u5D3A\u5D52\u5D3D\u5D31\u5D59\u5D42\u5D39\u5D49\u5D38\u5D3C\u5D32\u5D36\u5D40\u5D45\u5E44\u5E41\u5F58\u5FA6\u5FA5\u5FAB\u60C9\u60B9\u60CC\u60E2\u60CE\u60C4\u6114"],
      ["d940", "\u60F2\u610A\u6116\u6105\u60F5\u6113\u60F8\u60FC\u60FE\u60C1\u6103\u6118\u611D\u6110\u60FF\u6104\u610B\u624A\u6394\u63B1\u63B0\u63CE\u63E5\u63E8\u63EF\u63C3\u649D\u63F3\u63CA\u63E0\u63F6\u63D5\u63F2\u63F5\u6461\u63DF\u63BE\u63DD\u63DC\u63C4\u63D8\u63D3\u63C2\u63C7\u63CC\u63CB\u63C8\u63F0\u63D7\u63D9\u6532\u6567\u656A\u6564\u655C\u6568\u6565\u658C\u659D\u659E\u65AE\u65D0\u65D2"],
      ["d9a1", "\u667C\u666C\u667B\u6680\u6671\u6679\u666A\u6672\u6701\u690C\u68D3\u6904\u68DC\u692A\u68EC\u68EA\u68F1\u690F\u68D6\u68F7\u68EB\u68E4\u68F6\u6913\u6910\u68F3\u68E1\u6907\u68CC\u6908\u6970\u68B4\u6911\u68EF\u68C6\u6914\u68F8\u68D0\u68FD\u68FC\u68E8\u690B\u690A\u6917\u68CE\u68C8\u68DD\u68DE\u68E6\u68F4\u68D1\u6906\u68D4\u68E9\u6915\u6925\u68C7\u6B39\u6B3B\u6B3F\u6B3C\u6B94\u6B97\u6B99\u6B95\u6BBD\u6BF0\u6BF2\u6BF3\u6C30\u6DFC\u6E46\u6E47\u6E1F\u6E49\u6E88\u6E3C\u6E3D\u6E45\u6E62\u6E2B\u6E3F\u6E41\u6E5D\u6E73\u6E1C\u6E33\u6E4B\u6E40\u6E51\u6E3B\u6E03\u6E2E\u6E5E"],
      ["da40", "\u6E68\u6E5C\u6E61\u6E31\u6E28\u6E60\u6E71\u6E6B\u6E39\u6E22\u6E30\u6E53\u6E65\u6E27\u6E78\u6E64\u6E77\u6E55\u6E79\u6E52\u6E66\u6E35\u6E36\u6E5A\u7120\u711E\u712F\u70FB\u712E\u7131\u7123\u7125\u7122\u7132\u711F\u7128\u713A\u711B\u724B\u725A\u7288\u7289\u7286\u7285\u728B\u7312\u730B\u7330\u7322\u7331\u7333\u7327\u7332\u732D\u7326\u7323\u7335\u730C\u742E\u742C\u7430\u742B\u7416"],
      ["daa1", "\u741A\u7421\u742D\u7431\u7424\u7423\u741D\u7429\u7420\u7432\u74FB\u752F\u756F\u756C\u75E7\u75DA\u75E1\u75E6\u75DD\u75DF\u75E4\u75D7\u7695\u7692\u76DA\u7746\u7747\u7744\u774D\u7745\u774A\u774E\u774B\u774C\u77DE\u77EC\u7860\u7864\u7865\u785C\u786D\u7871\u786A\u786E\u7870\u7869\u7868\u785E\u7862\u7974\u7973\u7972\u7970\u7A02\u7A0A\u7A03\u7A0C\u7A04\u7A99\u7AE6\u7AE4\u7B4A\u7B3B\u7B44\u7B48\u7B4C\u7B4E\u7B40\u7B58\u7B45\u7CA2\u7C9E\u7CA8\u7CA1\u7D58\u7D6F\u7D63\u7D53\u7D56\u7D67\u7D6A\u7D4F\u7D6D\u7D5C\u7D6B\u7D52\u7D54\u7D69\u7D51\u7D5F\u7D4E\u7F3E\u7F3F\u7F65"],
      ["db40", "\u7F66\u7FA2\u7FA0\u7FA1\u7FD7\u8051\u804F\u8050\u80FE\u80D4\u8143\u814A\u8152\u814F\u8147\u813D\u814D\u813A\u81E6\u81EE\u81F7\u81F8\u81F9\u8204\u823C\u823D\u823F\u8275\u833B\u83CF\u83F9\u8423\u83C0\u83E8\u8412\u83E7\u83E4\u83FC\u83F6\u8410\u83C6\u83C8\u83EB\u83E3\u83BF\u8401\u83DD\u83E5\u83D8\u83FF\u83E1\u83CB\u83CE\u83D6\u83F5\u83C9\u8409\u840F\u83DE\u8411\u8406\u83C2\u83F3"],
      ["dba1", "\u83D5\u83FA\u83C7\u83D1\u83EA\u8413\u83C3\u83EC\u83EE\u83C4\u83FB\u83D7\u83E2\u841B\u83DB\u83FE\u86D8\u86E2\u86E6\u86D3\u86E3\u86DA\u86EA\u86DD\u86EB\u86DC\u86EC\u86E9\u86D7\u86E8\u86D1\u8848\u8856\u8855\u88BA\u88D7\u88B9\u88B8\u88C0\u88BE\u88B6\u88BC\u88B7\u88BD\u88B2\u8901\u88C9\u8995\u8998\u8997\u89DD\u89DA\u89DB\u8A4E\u8A4D\u8A39\u8A59\u8A40\u8A57\u8A58\u8A44\u8A45\u8A52\u8A48\u8A51\u8A4A\u8A4C\u8A4F\u8C5F\u8C81\u8C80\u8CBA\u8CBE\u8CB0\u8CB9\u8CB5\u8D84\u8D80\u8D89\u8DD8\u8DD3\u8DCD\u8DC7\u8DD6\u8DDC\u8DCF\u8DD5\u8DD9\u8DC8\u8DD7\u8DC5\u8EEF\u8EF7\u8EFA"],
      ["dc40", "\u8EF9\u8EE6\u8EEE\u8EE5\u8EF5\u8EE7\u8EE8\u8EF6\u8EEB\u8EF1\u8EEC\u8EF4\u8EE9\u902D\u9034\u902F\u9106\u912C\u9104\u90FF\u90FC\u9108\u90F9\u90FB\u9101\u9100\u9107\u9105\u9103\u9161\u9164\u915F\u9162\u9160\u9201\u920A\u9225\u9203\u921A\u9226\u920F\u920C\u9200\u9212\u91FF\u91FD\u9206\u9204\u9227\u9202\u921C\u9224\u9219\u9217\u9205\u9216\u957B\u958D\u958C\u9590\u9687\u967E\u9688"],
      ["dca1", "\u9689\u9683\u9680\u96C2\u96C8\u96C3\u96F1\u96F0\u976C\u9770\u976E\u9807\u98A9\u98EB\u9CE6\u9EF9\u4E83\u4E84\u4EB6\u50BD\u50BF\u50C6\u50AE\u50C4\u50CA\u50B4\u50C8\u50C2\u50B0\u50C1\u50BA\u50B1\u50CB\u50C9\u50B6\u50B8\u51D7\u527A\u5278\u527B\u527C\u55C3\u55DB\u55CC\u55D0\u55CB\u55CA\u55DD\u55C0\u55D4\u55C4\u55E9\u55BF\u55D2\u558D\u55CF\u55D5\u55E2\u55D6\u55C8\u55F2\u55CD\u55D9\u55C2\u5714\u5853\u5868\u5864\u584F\u584D\u5849\u586F\u5855\u584E\u585D\u5859\u5865\u585B\u583D\u5863\u5871\u58FC\u5AC7\u5AC4\u5ACB\u5ABA\u5AB8\u5AB1\u5AB5\u5AB0\u5ABF\u5AC8\u5ABB\u5AC6"],
      ["dd40", "\u5AB7\u5AC0\u5ACA\u5AB4\u5AB6\u5ACD\u5AB9\u5A90\u5BD6\u5BD8\u5BD9\u5C1F\u5C33\u5D71\u5D63\u5D4A\u5D65\u5D72\u5D6C\u5D5E\u5D68\u5D67\u5D62\u5DF0\u5E4F\u5E4E\u5E4A\u5E4D\u5E4B\u5EC5\u5ECC\u5EC6\u5ECB\u5EC7\u5F40\u5FAF\u5FAD\u60F7\u6149\u614A\u612B\u6145\u6136\u6132\u612E\u6146\u612F\u614F\u6129\u6140\u6220\u9168\u6223\u6225\u6224\u63C5\u63F1\u63EB\u6410\u6412\u6409\u6420\u6424"],
      ["dda1", "\u6433\u6443\u641F\u6415\u6418\u6439\u6437\u6422\u6423\u640C\u6426\u6430\u6428\u6441\u6435\u642F\u640A\u641A\u6440\u6425\u6427\u640B\u63E7\u641B\u642E\u6421\u640E\u656F\u6592\u65D3\u6686\u668C\u6695\u6690\u668B\u668A\u6699\u6694\u6678\u6720\u6966\u695F\u6938\u694E\u6962\u6971\u693F\u6945\u696A\u6939\u6942\u6957\u6959\u697A\u6948\u6949\u6935\u696C\u6933\u693D\u6965\u68F0\u6978\u6934\u6969\u6940\u696F\u6944\u6976\u6958\u6941\u6974\u694C\u693B\u694B\u6937\u695C\u694F\u6951\u6932\u6952\u692F\u697B\u693C\u6B46\u6B45\u6B43\u6B42\u6B48\u6B41\u6B9B\uFA0D\u6BFB\u6BFC"],
      ["de40", "\u6BF9\u6BF7\u6BF8\u6E9B\u6ED6\u6EC8\u6E8F\u6EC0\u6E9F\u6E93\u6E94\u6EA0\u6EB1\u6EB9\u6EC6\u6ED2\u6EBD\u6EC1\u6E9E\u6EC9\u6EB7\u6EB0\u6ECD\u6EA6\u6ECF\u6EB2\u6EBE\u6EC3\u6EDC\u6ED8\u6E99\u6E92\u6E8E\u6E8D\u6EA4\u6EA1\u6EBF\u6EB3\u6ED0\u6ECA\u6E97\u6EAE\u6EA3\u7147\u7154\u7152\u7163\u7160\u7141\u715D\u7162\u7172\u7178\u716A\u7161\u7142\u7158\u7143\u714B\u7170\u715F\u7150\u7153"],
      ["dea1", "\u7144\u714D\u715A\u724F\u728D\u728C\u7291\u7290\u728E\u733C\u7342\u733B\u733A\u7340\u734A\u7349\u7444\u744A\u744B\u7452\u7451\u7457\u7440\u744F\u7450\u744E\u7442\u7446\u744D\u7454\u74E1\u74FF\u74FE\u74FD\u751D\u7579\u7577\u6983\u75EF\u760F\u7603\u75F7\u75FE\u75FC\u75F9\u75F8\u7610\u75FB\u75F6\u75ED\u75F5\u75FD\u7699\u76B5\u76DD\u7755\u775F\u7760\u7752\u7756\u775A\u7769\u7767\u7754\u7759\u776D\u77E0\u7887\u789A\u7894\u788F\u7884\u7895\u7885\u7886\u78A1\u7883\u7879\u7899\u7880\u7896\u787B\u797C\u7982\u797D\u7979\u7A11\u7A18\u7A19\u7A12\u7A17\u7A15\u7A22\u7A13"],
      ["df40", "\u7A1B\u7A10\u7AA3\u7AA2\u7A9E\u7AEB\u7B66\u7B64\u7B6D\u7B74\u7B69\u7B72\u7B65\u7B73\u7B71\u7B70\u7B61\u7B78\u7B76\u7B63\u7CB2\u7CB4\u7CAF\u7D88\u7D86\u7D80\u7D8D\u7D7F\u7D85\u7D7A\u7D8E\u7D7B\u7D83\u7D7C\u7D8C\u7D94\u7D84\u7D7D\u7D92\u7F6D\u7F6B\u7F67\u7F68\u7F6C\u7FA6\u7FA5\u7FA7\u7FDB\u7FDC\u8021\u8164\u8160\u8177\u815C\u8169\u815B\u8162\u8172\u6721\u815E\u8176\u8167\u816F"],
      ["dfa1", "\u8144\u8161\u821D\u8249\u8244\u8240\u8242\u8245\u84F1\u843F\u8456\u8476\u8479\u848F\u848D\u8465\u8451\u8440\u8486\u8467\u8430\u844D\u847D\u845A\u8459\u8474\u8473\u845D\u8507\u845E\u8437\u843A\u8434\u847A\u8443\u8478\u8432\u8445\u8429\u83D9\u844B\u842F\u8442\u842D\u845F\u8470\u8439\u844E\u844C\u8452\u846F\u84C5\u848E\u843B\u8447\u8436\u8433\u8468\u847E\u8444\u842B\u8460\u8454\u846E\u8450\u870B\u8704\u86F7\u870C\u86FA\u86D6\u86F5\u874D\u86F8\u870E\u8709\u8701\u86F6\u870D\u8705\u88D6\u88CB\u88CD\u88CE\u88DE\u88DB\u88DA\u88CC\u88D0\u8985\u899B\u89DF\u89E5\u89E4"],
      ["e040", "\u89E1\u89E0\u89E2\u89DC\u89E6\u8A76\u8A86\u8A7F\u8A61\u8A3F\u8A77\u8A82\u8A84\u8A75\u8A83\u8A81\u8A74\u8A7A\u8C3C\u8C4B\u8C4A\u8C65\u8C64\u8C66\u8C86\u8C84\u8C85\u8CCC\u8D68\u8D69\u8D91\u8D8C\u8D8E\u8D8F\u8D8D\u8D93\u8D94\u8D90\u8D92\u8DF0\u8DE0\u8DEC\u8DF1\u8DEE\u8DD0\u8DE9\u8DE3\u8DE2\u8DE7\u8DF2\u8DEB\u8DF4\u8F06\u8EFF\u8F01\u8F00\u8F05\u8F07\u8F08\u8F02\u8F0B\u9052\u903F"],
      ["e0a1", "\u9044\u9049\u903D\u9110\u910D\u910F\u9111\u9116\u9114\u910B\u910E\u916E\u916F\u9248\u9252\u9230\u923A\u9266\u9233\u9265\u925E\u9283\u922E\u924A\u9246\u926D\u926C\u924F\u9260\u9267\u926F\u9236\u9261\u9270\u9231\u9254\u9263\u9250\u9272\u924E\u9253\u924C\u9256\u9232\u959F\u959C\u959E\u959B\u9692\u9693\u9691\u9697\u96CE\u96FA\u96FD\u96F8\u96F5\u9773\u9777\u9778\u9772\u980F\u980D\u980E\u98AC\u98F6\u98F9\u99AF\u99B2\u99B0\u99B5\u9AAD\u9AAB\u9B5B\u9CEA\u9CED\u9CE7\u9E80\u9EFD\u50E6\u50D4\u50D7\u50E8\u50F3\u50DB\u50EA\u50DD\u50E4\u50D3\u50EC\u50F0\u50EF\u50E3\u50E0"],
      ["e140", "\u51D8\u5280\u5281\u52E9\u52EB\u5330\u53AC\u5627\u5615\u560C\u5612\u55FC\u560F\u561C\u5601\u5613\u5602\u55FA\u561D\u5604\u55FF\u55F9\u5889\u587C\u5890\u5898\u5886\u5881\u587F\u5874\u588B\u587A\u5887\u5891\u588E\u5876\u5882\u5888\u587B\u5894\u588F\u58FE\u596B\u5ADC\u5AEE\u5AE5\u5AD5\u5AEA\u5ADA\u5AED\u5AEB\u5AF3\u5AE2\u5AE0\u5ADB\u5AEC\u5ADE\u5ADD\u5AD9\u5AE8\u5ADF\u5B77\u5BE0"],
      ["e1a1", "\u5BE3\u5C63\u5D82\u5D80\u5D7D\u5D86\u5D7A\u5D81\u5D77\u5D8A\u5D89\u5D88\u5D7E\u5D7C\u5D8D\u5D79\u5D7F\u5E58\u5E59\u5E53\u5ED8\u5ED1\u5ED7\u5ECE\u5EDC\u5ED5\u5ED9\u5ED2\u5ED4\u5F44\u5F43\u5F6F\u5FB6\u612C\u6128\u6141\u615E\u6171\u6173\u6152\u6153\u6172\u616C\u6180\u6174\u6154\u617A\u615B\u6165\u613B\u616A\u6161\u6156\u6229\u6227\u622B\u642B\u644D\u645B\u645D\u6474\u6476\u6472\u6473\u647D\u6475\u6466\u64A6\u644E\u6482\u645E\u645C\u644B\u6453\u6460\u6450\u647F\u643F\u646C\u646B\u6459\u6465\u6477\u6573\u65A0\u66A1\u66A0\u669F\u6705\u6704\u6722\u69B1\u69B6\u69C9"],
      ["e240", "\u69A0\u69CE\u6996\u69B0\u69AC\u69BC\u6991\u6999\u698E\u69A7\u698D\u69A9\u69BE\u69AF\u69BF\u69C4\u69BD\u69A4\u69D4\u69B9\u69CA\u699A\u69CF\u69B3\u6993\u69AA\u69A1\u699E\u69D9\u6997\u6990\u69C2\u69B5\u69A5\u69C6\u6B4A\u6B4D\u6B4B\u6B9E\u6B9F\u6BA0\u6BC3\u6BC4\u6BFE\u6ECE\u6EF5\u6EF1\u6F03\u6F25\u6EF8\u6F37\u6EFB\u6F2E\u6F09\u6F4E\u6F19\u6F1A\u6F27\u6F18\u6F3B\u6F12\u6EED\u6F0A"],
      ["e2a1", "\u6F36\u6F73\u6EF9\u6EEE\u6F2D\u6F40\u6F30\u6F3C\u6F35\u6EEB\u6F07\u6F0E\u6F43\u6F05\u6EFD\u6EF6\u6F39\u6F1C\u6EFC\u6F3A\u6F1F\u6F0D\u6F1E\u6F08\u6F21\u7187\u7190\u7189\u7180\u7185\u7182\u718F\u717B\u7186\u7181\u7197\u7244\u7253\u7297\u7295\u7293\u7343\u734D\u7351\u734C\u7462\u7473\u7471\u7475\u7472\u7467\u746E\u7500\u7502\u7503\u757D\u7590\u7616\u7608\u760C\u7615\u7611\u760A\u7614\u76B8\u7781\u777C\u7785\u7782\u776E\u7780\u776F\u777E\u7783\u78B2\u78AA\u78B4\u78AD\u78A8\u787E\u78AB\u789E\u78A5\u78A0\u78AC\u78A2\u78A4\u7998\u798A\u798B\u7996\u7995\u7994\u7993"],
      ["e340", "\u7997\u7988\u7992\u7990\u7A2B\u7A4A\u7A30\u7A2F\u7A28\u7A26\u7AA8\u7AAB\u7AAC\u7AEE\u7B88\u7B9C\u7B8A\u7B91\u7B90\u7B96\u7B8D\u7B8C\u7B9B\u7B8E\u7B85\u7B98\u5284\u7B99\u7BA4\u7B82\u7CBB\u7CBF\u7CBC\u7CBA\u7DA7\u7DB7\u7DC2\u7DA3\u7DAA\u7DC1\u7DC0\u7DC5\u7D9D\u7DCE\u7DC4\u7DC6\u7DCB\u7DCC\u7DAF\u7DB9\u7D96\u7DBC\u7D9F\u7DA6\u7DAE\u7DA9\u7DA1\u7DC9\u7F73\u7FE2\u7FE3\u7FE5\u7FDE"],
      ["e3a1", "\u8024\u805D\u805C\u8189\u8186\u8183\u8187\u818D\u818C\u818B\u8215\u8497\u84A4\u84A1\u849F\u84BA\u84CE\u84C2\u84AC\u84AE\u84AB\u84B9\u84B4\u84C1\u84CD\u84AA\u849A\u84B1\u84D0\u849D\u84A7\u84BB\u84A2\u8494\u84C7\u84CC\u849B\u84A9\u84AF\u84A8\u84D6\u8498\u84B6\u84CF\u84A0\u84D7\u84D4\u84D2\u84DB\u84B0\u8491\u8661\u8733\u8723\u8728\u876B\u8740\u872E\u871E\u8721\u8719\u871B\u8743\u872C\u8741\u873E\u8746\u8720\u8732\u872A\u872D\u873C\u8712\u873A\u8731\u8735\u8742\u8726\u8727\u8738\u8724\u871A\u8730\u8711\u88F7\u88E7\u88F1\u88F2\u88FA\u88FE\u88EE\u88FC\u88F6\u88FB"],
      ["e440", "\u88F0\u88EC\u88EB\u899D\u89A1\u899F\u899E\u89E9\u89EB\u89E8\u8AAB\u8A99\u8A8B\u8A92\u8A8F\u8A96\u8C3D\u8C68\u8C69\u8CD5\u8CCF\u8CD7\u8D96\u8E09\u8E02\u8DFF\u8E0D\u8DFD\u8E0A\u8E03\u8E07\u8E06\u8E05\u8DFE\u8E00\u8E04\u8F10\u8F11\u8F0E\u8F0D\u9123\u911C\u9120\u9122\u911F\u911D\u911A\u9124\u9121\u911B\u917A\u9172\u9179\u9173\u92A5\u92A4\u9276\u929B\u927A\u92A0\u9294\u92AA\u928D"],
      ["e4a1", "\u92A6\u929A\u92AB\u9279\u9297\u927F\u92A3\u92EE\u928E\u9282\u9295\u92A2\u927D\u9288\u92A1\u928A\u9286\u928C\u9299\u92A7\u927E\u9287\u92A9\u929D\u928B\u922D\u969E\u96A1\u96FF\u9758\u977D\u977A\u977E\u9783\u9780\u9782\u977B\u9784\u9781\u977F\u97CE\u97CD\u9816\u98AD\u98AE\u9902\u9900\u9907\u999D\u999C\u99C3\u99B9\u99BB\u99BA\u99C2\u99BD\u99C7\u9AB1\u9AE3\u9AE7\u9B3E\u9B3F\u9B60\u9B61\u9B5F\u9CF1\u9CF2\u9CF5\u9EA7\u50FF\u5103\u5130\u50F8\u5106\u5107\u50F6\u50FE\u510B\u510C\u50FD\u510A\u528B\u528C\u52F1\u52EF\u5648\u5642\u564C\u5635\u5641\u564A\u5649\u5646\u5658"],
      ["e540", "\u565A\u5640\u5633\u563D\u562C\u563E\u5638\u562A\u563A\u571A\u58AB\u589D\u58B1\u58A0\u58A3\u58AF\u58AC\u58A5\u58A1\u58FF\u5AFF\u5AF4\u5AFD\u5AF7\u5AF6\u5B03\u5AF8\u5B02\u5AF9\u5B01\u5B07\u5B05\u5B0F\u5C67\u5D99\u5D97\u5D9F\u5D92\u5DA2\u5D93\u5D95\u5DA0\u5D9C\u5DA1\u5D9A\u5D9E\u5E69\u5E5D\u5E60\u5E5C\u7DF3\u5EDB\u5EDE\u5EE1\u5F49\u5FB2\u618B\u6183\u6179\u61B1\u61B0\u61A2\u6189"],
      ["e5a1", "\u619B\u6193\u61AF\u61AD\u619F\u6192\u61AA\u61A1\u618D\u6166\u61B3\u622D\u646E\u6470\u6496\u64A0\u6485\u6497\u649C\u648F\u648B\u648A\u648C\u64A3\u649F\u6468\u64B1\u6498\u6576\u657A\u6579\u657B\u65B2\u65B3\u66B5\u66B0\u66A9\u66B2\u66B7\u66AA\u66AF\u6A00\u6A06\u6A17\u69E5\u69F8\u6A15\u69F1\u69E4\u6A20\u69FF\u69EC\u69E2\u6A1B\u6A1D\u69FE\u6A27\u69F2\u69EE\u6A14\u69F7\u69E7\u6A40\u6A08\u69E6\u69FB\u6A0D\u69FC\u69EB\u6A09\u6A04\u6A18\u6A25\u6A0F\u69F6\u6A26\u6A07\u69F4\u6A16\u6B51\u6BA5\u6BA3\u6BA2\u6BA6\u6C01\u6C00\u6BFF\u6C02\u6F41\u6F26\u6F7E\u6F87\u6FC6\u6F92"],
      ["e640", "\u6F8D\u6F89\u6F8C\u6F62\u6F4F\u6F85\u6F5A\u6F96\u6F76\u6F6C\u6F82\u6F55\u6F72\u6F52\u6F50\u6F57\u6F94\u6F93\u6F5D\u6F00\u6F61\u6F6B\u6F7D\u6F67\u6F90\u6F53\u6F8B\u6F69\u6F7F\u6F95\u6F63\u6F77\u6F6A\u6F7B\u71B2\u71AF\u719B\u71B0\u71A0\u719A\u71A9\u71B5\u719D\u71A5\u719E\u71A4\u71A1\u71AA\u719C\u71A7\u71B3\u7298\u729A\u7358\u7352\u735E\u735F\u7360\u735D\u735B\u7361\u735A\u7359"],
      ["e6a1", "\u7362\u7487\u7489\u748A\u7486\u7481\u747D\u7485\u7488\u747C\u7479\u7508\u7507\u757E\u7625\u761E\u7619\u761D\u761C\u7623\u761A\u7628\u761B\u769C\u769D\u769E\u769B\u778D\u778F\u7789\u7788\u78CD\u78BB\u78CF\u78CC\u78D1\u78CE\u78D4\u78C8\u78C3\u78C4\u78C9\u799A\u79A1\u79A0\u799C\u79A2\u799B\u6B76\u7A39\u7AB2\u7AB4\u7AB3\u7BB7\u7BCB\u7BBE\u7BAC\u7BCE\u7BAF\u7BB9\u7BCA\u7BB5\u7CC5\u7CC8\u7CCC\u7CCB\u7DF7\u7DDB\u7DEA\u7DE7\u7DD7\u7DE1\u7E03\u7DFA\u7DE6\u7DF6\u7DF1\u7DF0\u7DEE\u7DDF\u7F76\u7FAC\u7FB0\u7FAD\u7FED\u7FEB\u7FEA\u7FEC\u7FE6\u7FE8\u8064\u8067\u81A3\u819F"],
      ["e740", "\u819E\u8195\u81A2\u8199\u8197\u8216\u824F\u8253\u8252\u8250\u824E\u8251\u8524\u853B\u850F\u8500\u8529\u850E\u8509\u850D\u851F\u850A\u8527\u851C\u84FB\u852B\u84FA\u8508\u850C\u84F4\u852A\u84F2\u8515\u84F7\u84EB\u84F3\u84FC\u8512\u84EA\u84E9\u8516\u84FE\u8528\u851D\u852E\u8502\u84FD\u851E\u84F6\u8531\u8526\u84E7\u84E8\u84F0\u84EF\u84F9\u8518\u8520\u8530\u850B\u8519\u852F\u8662"],
      ["e7a1", "\u8756\u8763\u8764\u8777\u87E1\u8773\u8758\u8754\u875B\u8752\u8761\u875A\u8751\u875E\u876D\u876A\u8750\u874E\u875F\u875D\u876F\u876C\u877A\u876E\u875C\u8765\u874F\u877B\u8775\u8762\u8767\u8769\u885A\u8905\u890C\u8914\u890B\u8917\u8918\u8919\u8906\u8916\u8911\u890E\u8909\u89A2\u89A4\u89A3\u89ED\u89F0\u89EC\u8ACF\u8AC6\u8AB8\u8AD3\u8AD1\u8AD4\u8AD5\u8ABB\u8AD7\u8ABE\u8AC0\u8AC5\u8AD8\u8AC3\u8ABA\u8ABD\u8AD9\u8C3E\u8C4D\u8C8F\u8CE5\u8CDF\u8CD9\u8CE8\u8CDA\u8CDD\u8CE7\u8DA0\u8D9C\u8DA1\u8D9B\u8E20\u8E23\u8E25\u8E24\u8E2E\u8E15\u8E1B\u8E16\u8E11\u8E19\u8E26\u8E27"],
      ["e840", "\u8E14\u8E12\u8E18\u8E13\u8E1C\u8E17\u8E1A\u8F2C\u8F24\u8F18\u8F1A\u8F20\u8F23\u8F16\u8F17\u9073\u9070\u906F\u9067\u906B\u912F\u912B\u9129\u912A\u9132\u9126\u912E\u9185\u9186\u918A\u9181\u9182\u9184\u9180\u92D0\u92C3\u92C4\u92C0\u92D9\u92B6\u92CF\u92F1\u92DF\u92D8\u92E9\u92D7\u92DD\u92CC\u92EF\u92C2\u92E8\u92CA\u92C8\u92CE\u92E6\u92CD\u92D5\u92C9\u92E0\u92DE\u92E7\u92D1\u92D3"],
      ["e8a1", "\u92B5\u92E1\u92C6\u92B4\u957C\u95AC\u95AB\u95AE\u95B0\u96A4\u96A2\u96D3\u9705\u9708\u9702\u975A\u978A\u978E\u9788\u97D0\u97CF\u981E\u981D\u9826\u9829\u9828\u9820\u981B\u9827\u98B2\u9908\u98FA\u9911\u9914\u9916\u9917\u9915\u99DC\u99CD\u99CF\u99D3\u99D4\u99CE\u99C9\u99D6\u99D8\u99CB\u99D7\u99CC\u9AB3\u9AEC\u9AEB\u9AF3\u9AF2\u9AF1\u9B46\u9B43\u9B67\u9B74\u9B71\u9B66\u9B76\u9B75\u9B70\u9B68\u9B64\u9B6C\u9CFC\u9CFA\u9CFD\u9CFF\u9CF7\u9D07\u9D00\u9CF9\u9CFB\u9D08\u9D05\u9D04\u9E83\u9ED3\u9F0F\u9F10\u511C\u5113\u5117\u511A\u5111\u51DE\u5334\u53E1\u5670\u5660\u566E"],
      ["e940", "\u5673\u5666\u5663\u566D\u5672\u565E\u5677\u571C\u571B\u58C8\u58BD\u58C9\u58BF\u58BA\u58C2\u58BC\u58C6\u5B17\u5B19\u5B1B\u5B21\u5B14\u5B13\u5B10\u5B16\u5B28\u5B1A\u5B20\u5B1E\u5BEF\u5DAC\u5DB1\u5DA9\u5DA7\u5DB5\u5DB0\u5DAE\u5DAA\u5DA8\u5DB2\u5DAD\u5DAF\u5DB4\u5E67\u5E68\u5E66\u5E6F\u5EE9\u5EE7\u5EE6\u5EE8\u5EE5\u5F4B\u5FBC\u619D\u61A8\u6196\u61C5\u61B4\u61C6\u61C1\u61CC\u61BA"],
      ["e9a1", "\u61BF\u61B8\u618C\u64D7\u64D6\u64D0\u64CF\u64C9\u64BD\u6489\u64C3\u64DB\u64F3\u64D9\u6533\u657F\u657C\u65A2\u66C8\u66BE\u66C0\u66CA\u66CB\u66CF\u66BD\u66BB\u66BA\u66CC\u6723\u6A34\u6A66\u6A49\u6A67\u6A32\u6A68\u6A3E\u6A5D\u6A6D\u6A76\u6A5B\u6A51\u6A28\u6A5A\u6A3B\u6A3F\u6A41\u6A6A\u6A64\u6A50\u6A4F\u6A54\u6A6F\u6A69\u6A60\u6A3C\u6A5E\u6A56\u6A55\u6A4D\u6A4E\u6A46\u6B55\u6B54\u6B56\u6BA7\u6BAA\u6BAB\u6BC8\u6BC7\u6C04\u6C03\u6C06\u6FAD\u6FCB\u6FA3\u6FC7\u6FBC\u6FCE\u6FC8\u6F5E\u6FC4\u6FBD\u6F9E\u6FCA\u6FA8\u7004\u6FA5\u6FAE\u6FBA\u6FAC\u6FAA\u6FCF\u6FBF\u6FB8"],
      ["ea40", "\u6FA2\u6FC9\u6FAB\u6FCD\u6FAF\u6FB2\u6FB0\u71C5\u71C2\u71BF\u71B8\u71D6\u71C0\u71C1\u71CB\u71D4\u71CA\u71C7\u71CF\u71BD\u71D8\u71BC\u71C6\u71DA\u71DB\u729D\u729E\u7369\u7366\u7367\u736C\u7365\u736B\u736A\u747F\u749A\u74A0\u7494\u7492\u7495\u74A1\u750B\u7580\u762F\u762D\u7631\u763D\u7633\u763C\u7635\u7632\u7630\u76BB\u76E6\u779A\u779D\u77A1\u779C\u779B\u77A2\u77A3\u7795\u7799"],
      ["eaa1", "\u7797\u78DD\u78E9\u78E5\u78EA\u78DE\u78E3\u78DB\u78E1\u78E2\u78ED\u78DF\u78E0\u79A4\u7A44\u7A48\u7A47\u7AB6\u7AB8\u7AB5\u7AB1\u7AB7\u7BDE\u7BE3\u7BE7\u7BDD\u7BD5\u7BE5\u7BDA\u7BE8\u7BF9\u7BD4\u7BEA\u7BE2\u7BDC\u7BEB\u7BD8\u7BDF\u7CD2\u7CD4\u7CD7\u7CD0\u7CD1\u7E12\u7E21\u7E17\u7E0C\u7E1F\u7E20\u7E13\u7E0E\u7E1C\u7E15\u7E1A\u7E22\u7E0B\u7E0F\u7E16\u7E0D\u7E14\u7E25\u7E24\u7F43\u7F7B\u7F7C\u7F7A\u7FB1\u7FEF\u802A\u8029\u806C\u81B1\u81A6\u81AE\u81B9\u81B5\u81AB\u81B0\u81AC\u81B4\u81B2\u81B7\u81A7\u81F2\u8255\u8256\u8257\u8556\u8545\u856B\u854D\u8553\u8561\u8558"],
      ["eb40", "\u8540\u8546\u8564\u8541\u8562\u8544\u8551\u8547\u8563\u853E\u855B\u8571\u854E\u856E\u8575\u8555\u8567\u8560\u858C\u8566\u855D\u8554\u8565\u856C\u8663\u8665\u8664\u879B\u878F\u8797\u8793\u8792\u8788\u8781\u8796\u8798\u8779\u8787\u87A3\u8785\u8790\u8791\u879D\u8784\u8794\u879C\u879A\u8789\u891E\u8926\u8930\u892D\u892E\u8927\u8931\u8922\u8929\u8923\u892F\u892C\u891F\u89F1\u8AE0"],
      ["eba1", "\u8AE2\u8AF2\u8AF4\u8AF5\u8ADD\u8B14\u8AE4\u8ADF\u8AF0\u8AC8\u8ADE\u8AE1\u8AE8\u8AFF\u8AEF\u8AFB\u8C91\u8C92\u8C90\u8CF5\u8CEE\u8CF1\u8CF0\u8CF3\u8D6C\u8D6E\u8DA5\u8DA7\u8E33\u8E3E\u8E38\u8E40\u8E45\u8E36\u8E3C\u8E3D\u8E41\u8E30\u8E3F\u8EBD\u8F36\u8F2E\u8F35\u8F32\u8F39\u8F37\u8F34\u9076\u9079\u907B\u9086\u90FA\u9133\u9135\u9136\u9193\u9190\u9191\u918D\u918F\u9327\u931E\u9308\u931F\u9306\u930F\u937A\u9338\u933C\u931B\u9323\u9312\u9301\u9346\u932D\u930E\u930D\u92CB\u931D\u92FA\u9325\u9313\u92F9\u92F7\u9334\u9302\u9324\u92FF\u9329\u9339\u9335\u932A\u9314\u930C"],
      ["ec40", "\u930B\u92FE\u9309\u9300\u92FB\u9316\u95BC\u95CD\u95BE\u95B9\u95BA\u95B6\u95BF\u95B5\u95BD\u96A9\u96D4\u970B\u9712\u9710\u9799\u9797\u9794\u97F0\u97F8\u9835\u982F\u9832\u9924\u991F\u9927\u9929\u999E\u99EE\u99EC\u99E5\u99E4\u99F0\u99E3\u99EA\u99E9\u99E7\u9AB9\u9ABF\u9AB4\u9ABB\u9AF6\u9AFA\u9AF9\u9AF7\u9B33\u9B80\u9B85\u9B87\u9B7C\u9B7E\u9B7B\u9B82\u9B93\u9B92\u9B90\u9B7A\u9B95"],
      ["eca1", "\u9B7D\u9B88\u9D25\u9D17\u9D20\u9D1E\u9D14\u9D29\u9D1D\u9D18\u9D22\u9D10\u9D19\u9D1F\u9E88\u9E86\u9E87\u9EAE\u9EAD\u9ED5\u9ED6\u9EFA\u9F12\u9F3D\u5126\u5125\u5122\u5124\u5120\u5129\u52F4\u5693\u568C\u568D\u5686\u5684\u5683\u567E\u5682\u567F\u5681\u58D6\u58D4\u58CF\u58D2\u5B2D\u5B25\u5B32\u5B23\u5B2C\u5B27\u5B26\u5B2F\u5B2E\u5B7B\u5BF1\u5BF2\u5DB7\u5E6C\u5E6A\u5FBE\u5FBB\u61C3\u61B5\u61BC\u61E7\u61E0\u61E5\u61E4\u61E8\u61DE\u64EF\u64E9\u64E3\u64EB\u64E4\u64E8\u6581\u6580\u65B6\u65DA\u66D2\u6A8D\u6A96\u6A81\u6AA5\u6A89\u6A9F\u6A9B\u6AA1\u6A9E\u6A87\u6A93\u6A8E"],
      ["ed40", "\u6A95\u6A83\u6AA8\u6AA4\u6A91\u6A7F\u6AA6\u6A9A\u6A85\u6A8C\u6A92\u6B5B\u6BAD\u6C09\u6FCC\u6FA9\u6FF4\u6FD4\u6FE3\u6FDC\u6FED\u6FE7\u6FE6\u6FDE\u6FF2\u6FDD\u6FE2\u6FE8\u71E1\u71F1\u71E8\u71F2\u71E4\u71F0\u71E2\u7373\u736E\u736F\u7497\u74B2\u74AB\u7490\u74AA\u74AD\u74B1\u74A5\u74AF\u7510\u7511\u7512\u750F\u7584\u7643\u7648\u7649\u7647\u76A4\u76E9\u77B5\u77AB\u77B2\u77B7\u77B6"],
      ["eda1", "\u77B4\u77B1\u77A8\u77F0\u78F3\u78FD\u7902\u78FB\u78FC\u78F2\u7905\u78F9\u78FE\u7904\u79AB\u79A8\u7A5C\u7A5B\u7A56\u7A58\u7A54\u7A5A\u7ABE\u7AC0\u7AC1\u7C05\u7C0F\u7BF2\u7C00\u7BFF\u7BFB\u7C0E\u7BF4\u7C0B\u7BF3\u7C02\u7C09\u7C03\u7C01\u7BF8\u7BFD\u7C06\u7BF0\u7BF1\u7C10\u7C0A\u7CE8\u7E2D\u7E3C\u7E42\u7E33\u9848\u7E38\u7E2A\u7E49\u7E40\u7E47\u7E29\u7E4C\u7E30\u7E3B\u7E36\u7E44\u7E3A\u7F45\u7F7F\u7F7E\u7F7D\u7FF4\u7FF2\u802C\u81BB\u81C4\u81CC\u81CA\u81C5\u81C7\u81BC\u81E9\u825B\u825A\u825C\u8583\u8580\u858F\u85A7\u8595\u85A0\u858B\u85A3\u857B\u85A4\u859A\u859E"],
      ["ee40", "\u8577\u857C\u8589\u85A1\u857A\u8578\u8557\u858E\u8596\u8586\u858D\u8599\u859D\u8581\u85A2\u8582\u8588\u8585\u8579\u8576\u8598\u8590\u859F\u8668\u87BE\u87AA\u87AD\u87C5\u87B0\u87AC\u87B9\u87B5\u87BC\u87AE\u87C9\u87C3\u87C2\u87CC\u87B7\u87AF\u87C4\u87CA\u87B4\u87B6\u87BF\u87B8\u87BD\u87DE\u87B2\u8935\u8933\u893C\u893E\u8941\u8952\u8937\u8942\u89AD\u89AF\u89AE\u89F2\u89F3\u8B1E"],
      ["eea1", "\u8B18\u8B16\u8B11\u8B05\u8B0B\u8B22\u8B0F\u8B12\u8B15\u8B07\u8B0D\u8B08\u8B06\u8B1C\u8B13\u8B1A\u8C4F\u8C70\u8C72\u8C71\u8C6F\u8C95\u8C94\u8CF9\u8D6F\u8E4E\u8E4D\u8E53\u8E50\u8E4C\u8E47\u8F43\u8F40\u9085\u907E\u9138\u919A\u91A2\u919B\u9199\u919F\u91A1\u919D\u91A0\u93A1\u9383\u93AF\u9364\u9356\u9347\u937C\u9358\u935C\u9376\u9349\u9350\u9351\u9360\u936D\u938F\u934C\u936A\u9379\u9357\u9355\u9352\u934F\u9371\u9377\u937B\u9361\u935E\u9363\u9367\u9380\u934E\u9359\u95C7\u95C0\u95C9\u95C3\u95C5\u95B7\u96AE\u96B0\u96AC\u9720\u971F\u9718\u971D\u9719\u979A\u97A1\u979C"],
      ["ef40", "\u979E\u979D\u97D5\u97D4\u97F1\u9841\u9844\u984A\u9849\u9845\u9843\u9925\u992B\u992C\u992A\u9933\u9932\u992F\u992D\u9931\u9930\u9998\u99A3\u99A1\u9A02\u99FA\u99F4\u99F7\u99F9\u99F8\u99F6\u99FB\u99FD\u99FE\u99FC\u9A03\u9ABE\u9AFE\u9AFD\u9B01\u9AFC\u9B48\u9B9A\u9BA8\u9B9E\u9B9B\u9BA6\u9BA1\u9BA5\u9BA4\u9B86\u9BA2\u9BA0\u9BAF\u9D33\u9D41\u9D67\u9D36\u9D2E\u9D2F\u9D31\u9D38\u9D30"],
      ["efa1", "\u9D45\u9D42\u9D43\u9D3E\u9D37\u9D40\u9D3D\u7FF5\u9D2D\u9E8A\u9E89\u9E8D\u9EB0\u9EC8\u9EDA\u9EFB\u9EFF\u9F24\u9F23\u9F22\u9F54\u9FA0\u5131\u512D\u512E\u5698\u569C\u5697\u569A\u569D\u5699\u5970\u5B3C\u5C69\u5C6A\u5DC0\u5E6D\u5E6E\u61D8\u61DF\u61ED\u61EE\u61F1\u61EA\u61F0\u61EB\u61D6\u61E9\u64FF\u6504\u64FD\u64F8\u6501\u6503\u64FC\u6594\u65DB\u66DA\u66DB\u66D8\u6AC5\u6AB9\u6ABD\u6AE1\u6AC6\u6ABA\u6AB6\u6AB7\u6AC7\u6AB4\u6AAD\u6B5E\u6BC9\u6C0B\u7007\u700C\u700D\u7001\u7005\u7014\u700E\u6FFF\u7000\u6FFB\u7026\u6FFC\u6FF7\u700A\u7201\u71FF\u71F9\u7203\u71FD\u7376"],
      ["f040", "\u74B8\u74C0\u74B5\u74C1\u74BE\u74B6\u74BB\u74C2\u7514\u7513\u765C\u7664\u7659\u7650\u7653\u7657\u765A\u76A6\u76BD\u76EC\u77C2\u77BA\u78FF\u790C\u7913\u7914\u7909\u7910\u7912\u7911\u79AD\u79AC\u7A5F\u7C1C\u7C29\u7C19\u7C20\u7C1F\u7C2D\u7C1D\u7C26\u7C28\u7C22\u7C25\u7C30\u7E5C\u7E50\u7E56\u7E63\u7E58\u7E62\u7E5F\u7E51\u7E60\u7E57\u7E53\u7FB5\u7FB3\u7FF7\u7FF8\u8075\u81D1\u81D2"],
      ["f0a1", "\u81D0\u825F\u825E\u85B4\u85C6\u85C0\u85C3\u85C2\u85B3\u85B5\u85BD\u85C7\u85C4\u85BF\u85CB\u85CE\u85C8\u85C5\u85B1\u85B6\u85D2\u8624\u85B8\u85B7\u85BE\u8669\u87E7\u87E6\u87E2\u87DB\u87EB\u87EA\u87E5\u87DF\u87F3\u87E4\u87D4\u87DC\u87D3\u87ED\u87D8\u87E3\u87A4\u87D7\u87D9\u8801\u87F4\u87E8\u87DD\u8953\u894B\u894F\u894C\u8946\u8950\u8951\u8949\u8B2A\u8B27\u8B23\u8B33\u8B30\u8B35\u8B47\u8B2F\u8B3C\u8B3E\u8B31\u8B25\u8B37\u8B26\u8B36\u8B2E\u8B24\u8B3B\u8B3D\u8B3A\u8C42\u8C75\u8C99\u8C98\u8C97\u8CFE\u8D04\u8D02\u8D00\u8E5C\u8E62\u8E60\u8E57\u8E56\u8E5E\u8E65\u8E67"],
      ["f140", "\u8E5B\u8E5A\u8E61\u8E5D\u8E69\u8E54\u8F46\u8F47\u8F48\u8F4B\u9128\u913A\u913B\u913E\u91A8\u91A5\u91A7\u91AF\u91AA\u93B5\u938C\u9392\u93B7\u939B\u939D\u9389\u93A7\u938E\u93AA\u939E\u93A6\u9395\u9388\u9399\u939F\u938D\u93B1\u9391\u93B2\u93A4\u93A8\u93B4\u93A3\u93A5\u95D2\u95D3\u95D1\u96B3\u96D7\u96DA\u5DC2\u96DF\u96D8\u96DD\u9723\u9722\u9725\u97AC\u97AE\u97A8\u97AB\u97A4\u97AA"],
      ["f1a1", "\u97A2\u97A5\u97D7\u97D9\u97D6\u97D8\u97FA\u9850\u9851\u9852\u98B8\u9941\u993C\u993A\u9A0F\u9A0B\u9A09\u9A0D\u9A04\u9A11\u9A0A\u9A05\u9A07\u9A06\u9AC0\u9ADC\u9B08\u9B04\u9B05\u9B29\u9B35\u9B4A\u9B4C\u9B4B\u9BC7\u9BC6\u9BC3\u9BBF\u9BC1\u9BB5\u9BB8\u9BD3\u9BB6\u9BC4\u9BB9\u9BBD\u9D5C\u9D53\u9D4F\u9D4A\u9D5B\u9D4B\u9D59\u9D56\u9D4C\u9D57\u9D52\u9D54\u9D5F\u9D58\u9D5A\u9E8E\u9E8C\u9EDF\u9F01\u9F00\u9F16\u9F25\u9F2B\u9F2A\u9F29\u9F28\u9F4C\u9F55\u5134\u5135\u5296\u52F7\u53B4\u56AB\u56AD\u56A6\u56A7\u56AA\u56AC\u58DA\u58DD\u58DB\u5912\u5B3D\u5B3E\u5B3F\u5DC3\u5E70"],
      ["f240", "\u5FBF\u61FB\u6507\u6510\u650D\u6509\u650C\u650E\u6584\u65DE\u65DD\u66DE\u6AE7\u6AE0\u6ACC\u6AD1\u6AD9\u6ACB\u6ADF\u6ADC\u6AD0\u6AEB\u6ACF\u6ACD\u6ADE\u6B60\u6BB0\u6C0C\u7019\u7027\u7020\u7016\u702B\u7021\u7022\u7023\u7029\u7017\u7024\u701C\u702A\u720C\u720A\u7207\u7202\u7205\u72A5\u72A6\u72A4\u72A3\u72A1\u74CB\u74C5\u74B7\u74C3\u7516\u7660\u77C9\u77CA\u77C4\u77F1\u791D\u791B"],
      ["f2a1", "\u7921\u791C\u7917\u791E\u79B0\u7A67\u7A68\u7C33\u7C3C\u7C39\u7C2C\u7C3B\u7CEC\u7CEA\u7E76\u7E75\u7E78\u7E70\u7E77\u7E6F\u7E7A\u7E72\u7E74\u7E68\u7F4B\u7F4A\u7F83\u7F86\u7FB7\u7FFD\u7FFE\u8078\u81D7\u81D5\u8264\u8261\u8263\u85EB\u85F1\u85ED\u85D9\u85E1\u85E8\u85DA\u85D7\u85EC\u85F2\u85F8\u85D8\u85DF\u85E3\u85DC\u85D1\u85F0\u85E6\u85EF\u85DE\u85E2\u8800\u87FA\u8803\u87F6\u87F7\u8809\u880C\u880B\u8806\u87FC\u8808\u87FF\u880A\u8802\u8962\u895A\u895B\u8957\u8961\u895C\u8958\u895D\u8959\u8988\u89B7\u89B6\u89F6\u8B50\u8B48\u8B4A\u8B40\u8B53\u8B56\u8B54\u8B4B\u8B55"],
      ["f340", "\u8B51\u8B42\u8B52\u8B57\u8C43\u8C77\u8C76\u8C9A\u8D06\u8D07\u8D09\u8DAC\u8DAA\u8DAD\u8DAB\u8E6D\u8E78\u8E73\u8E6A\u8E6F\u8E7B\u8EC2\u8F52\u8F51\u8F4F\u8F50\u8F53\u8FB4\u9140\u913F\u91B0\u91AD\u93DE\u93C7\u93CF\u93C2\u93DA\u93D0\u93F9\u93EC\u93CC\u93D9\u93A9\u93E6\u93CA\u93D4\u93EE\u93E3\u93D5\u93C4\u93CE\u93C0\u93D2\u93E7\u957D\u95DA\u95DB\u96E1\u9729\u972B\u972C\u9728\u9726"],
      ["f3a1", "\u97B3\u97B7\u97B6\u97DD\u97DE\u97DF\u985C\u9859\u985D\u9857\u98BF\u98BD\u98BB\u98BE\u9948\u9947\u9943\u99A6\u99A7\u9A1A\u9A15\u9A25\u9A1D\u9A24\u9A1B\u9A22\u9A20\u9A27\u9A23\u9A1E\u9A1C\u9A14\u9AC2\u9B0B\u9B0A\u9B0E\u9B0C\u9B37\u9BEA\u9BEB\u9BE0\u9BDE\u9BE4\u9BE6\u9BE2\u9BF0\u9BD4\u9BD7\u9BEC\u9BDC\u9BD9\u9BE5\u9BD5\u9BE1\u9BDA\u9D77\u9D81\u9D8A\u9D84\u9D88\u9D71\u9D80\u9D78\u9D86\u9D8B\u9D8C\u9D7D\u9D6B\u9D74\u9D75\u9D70\u9D69\u9D85\u9D73\u9D7B\u9D82\u9D6F\u9D79\u9D7F\u9D87\u9D68\u9E94\u9E91\u9EC0\u9EFC\u9F2D\u9F40\u9F41\u9F4D\u9F56\u9F57\u9F58\u5337\u56B2"],
      ["f440", "\u56B5\u56B3\u58E3\u5B45\u5DC6\u5DC7\u5EEE\u5EEF\u5FC0\u5FC1\u61F9\u6517\u6516\u6515\u6513\u65DF\u66E8\u66E3\u66E4\u6AF3\u6AF0\u6AEA\u6AE8\u6AF9\u6AF1\u6AEE\u6AEF\u703C\u7035\u702F\u7037\u7034\u7031\u7042\u7038\u703F\u703A\u7039\u7040\u703B\u7033\u7041\u7213\u7214\u72A8\u737D\u737C\u74BA\u76AB\u76AA\u76BE\u76ED\u77CC\u77CE\u77CF\u77CD\u77F2\u7925\u7923\u7927\u7928\u7924\u7929"],
      ["f4a1", "\u79B2\u7A6E\u7A6C\u7A6D\u7AF7\u7C49\u7C48\u7C4A\u7C47\u7C45\u7CEE\u7E7B\u7E7E\u7E81\u7E80\u7FBA\u7FFF\u8079\u81DB\u81D9\u820B\u8268\u8269\u8622\u85FF\u8601\u85FE\u861B\u8600\u85F6\u8604\u8609\u8605\u860C\u85FD\u8819\u8810\u8811\u8817\u8813\u8816\u8963\u8966\u89B9\u89F7\u8B60\u8B6A\u8B5D\u8B68\u8B63\u8B65\u8B67\u8B6D\u8DAE\u8E86\u8E88\u8E84\u8F59\u8F56\u8F57\u8F55\u8F58\u8F5A\u908D\u9143\u9141\u91B7\u91B5\u91B2\u91B3\u940B\u9413\u93FB\u9420\u940F\u9414\u93FE\u9415\u9410\u9428\u9419\u940D\u93F5\u9400\u93F7\u9407\u940E\u9416\u9412\u93FA\u9409\u93F8\u940A\u93FF"],
      ["f540", "\u93FC\u940C\u93F6\u9411\u9406\u95DE\u95E0\u95DF\u972E\u972F\u97B9\u97BB\u97FD\u97FE\u9860\u9862\u9863\u985F\u98C1\u98C2\u9950\u994E\u9959\u994C\u994B\u9953\u9A32\u9A34\u9A31\u9A2C\u9A2A\u9A36\u9A29\u9A2E\u9A38\u9A2D\u9AC7\u9ACA\u9AC6\u9B10\u9B12\u9B11\u9C0B\u9C08\u9BF7\u9C05\u9C12\u9BF8\u9C40\u9C07\u9C0E\u9C06\u9C17\u9C14\u9C09\u9D9F\u9D99\u9DA4\u9D9D\u9D92\u9D98\u9D90\u9D9B"],
      ["f5a1", "\u9DA0\u9D94\u9D9C\u9DAA\u9D97\u9DA1\u9D9A\u9DA2\u9DA8\u9D9E\u9DA3\u9DBF\u9DA9\u9D96\u9DA6\u9DA7\u9E99\u9E9B\u9E9A\u9EE5\u9EE4\u9EE7\u9EE6\u9F30\u9F2E\u9F5B\u9F60\u9F5E\u9F5D\u9F59\u9F91\u513A\u5139\u5298\u5297\u56C3\u56BD\u56BE\u5B48\u5B47\u5DCB\u5DCF\u5EF1\u61FD\u651B\u6B02\u6AFC\u6B03\u6AF8\u6B00\u7043\u7044\u704A\u7048\u7049\u7045\u7046\u721D\u721A\u7219\u737E\u7517\u766A\u77D0\u792D\u7931\u792F\u7C54\u7C53\u7CF2\u7E8A\u7E87\u7E88\u7E8B\u7E86\u7E8D\u7F4D\u7FBB\u8030\u81DD\u8618\u862A\u8626\u861F\u8623\u861C\u8619\u8627\u862E\u8621\u8620\u8629\u861E\u8625"],
      ["f640", "\u8829\u881D\u881B\u8820\u8824\u881C\u882B\u884A\u896D\u8969\u896E\u896B\u89FA\u8B79\u8B78\u8B45\u8B7A\u8B7B\u8D10\u8D14\u8DAF\u8E8E\u8E8C\u8F5E\u8F5B\u8F5D\u9146\u9144\u9145\u91B9\u943F\u943B\u9436\u9429\u943D\u943C\u9430\u9439\u942A\u9437\u942C\u9440\u9431\u95E5\u95E4\u95E3\u9735\u973A\u97BF\u97E1\u9864\u98C9\u98C6\u98C0\u9958\u9956\u9A39\u9A3D\u9A46\u9A44\u9A42\u9A41\u9A3A"],
      ["f6a1", "\u9A3F\u9ACD\u9B15\u9B17\u9B18\u9B16\u9B3A\u9B52\u9C2B\u9C1D\u9C1C\u9C2C\u9C23\u9C28\u9C29\u9C24\u9C21\u9DB7\u9DB6\u9DBC\u9DC1\u9DC7\u9DCA\u9DCF\u9DBE\u9DC5\u9DC3\u9DBB\u9DB5\u9DCE\u9DB9\u9DBA\u9DAC\u9DC8\u9DB1\u9DAD\u9DCC\u9DB3\u9DCD\u9DB2\u9E7A\u9E9C\u9EEB\u9EEE\u9EED\u9F1B\u9F18\u9F1A\u9F31\u9F4E\u9F65\u9F64\u9F92\u4EB9\u56C6\u56C5\u56CB\u5971\u5B4B\u5B4C\u5DD5\u5DD1\u5EF2\u6521\u6520\u6526\u6522\u6B0B\u6B08\u6B09\u6C0D\u7055\u7056\u7057\u7052\u721E\u721F\u72A9\u737F\u74D8\u74D5\u74D9\u74D7\u766D\u76AD\u7935\u79B4\u7A70\u7A71\u7C57\u7C5C\u7C59\u7C5B\u7C5A"],
      ["f740", "\u7CF4\u7CF1\u7E91\u7F4F\u7F87\u81DE\u826B\u8634\u8635\u8633\u862C\u8632\u8636\u882C\u8828\u8826\u882A\u8825\u8971\u89BF\u89BE\u89FB\u8B7E\u8B84\u8B82\u8B86\u8B85\u8B7F\u8D15\u8E95\u8E94\u8E9A\u8E92\u8E90\u8E96\u8E97\u8F60\u8F62\u9147\u944C\u9450\u944A\u944B\u944F\u9447\u9445\u9448\u9449\u9446\u973F\u97E3\u986A\u9869\u98CB\u9954\u995B\u9A4E\u9A53\u9A54\u9A4C\u9A4F\u9A48\u9A4A"],
      ["f7a1", "\u9A49\u9A52\u9A50\u9AD0\u9B19\u9B2B\u9B3B\u9B56\u9B55\u9C46\u9C48\u9C3F\u9C44\u9C39\u9C33\u9C41\u9C3C\u9C37\u9C34\u9C32\u9C3D\u9C36\u9DDB\u9DD2\u9DDE\u9DDA\u9DCB\u9DD0\u9DDC\u9DD1\u9DDF\u9DE9\u9DD9\u9DD8\u9DD6\u9DF5\u9DD5\u9DDD\u9EB6\u9EF0\u9F35\u9F33\u9F32\u9F42\u9F6B\u9F95\u9FA2\u513D\u5299\u58E8\u58E7\u5972\u5B4D\u5DD8\u882F\u5F4F\u6201\u6203\u6204\u6529\u6525\u6596\u66EB\u6B11\u6B12\u6B0F\u6BCA\u705B\u705A\u7222\u7382\u7381\u7383\u7670\u77D4\u7C67\u7C66\u7E95\u826C\u863A\u8640\u8639\u863C\u8631\u863B\u863E\u8830\u8832\u882E\u8833\u8976\u8974\u8973\u89FE"],
      ["f840", "\u8B8C\u8B8E\u8B8B\u8B88\u8C45\u8D19\u8E98\u8F64\u8F63\u91BC\u9462\u9455\u945D\u9457\u945E\u97C4\u97C5\u9800\u9A56\u9A59\u9B1E\u9B1F\u9B20\u9C52\u9C58\u9C50\u9C4A\u9C4D\u9C4B\u9C55\u9C59\u9C4C\u9C4E\u9DFB\u9DF7\u9DEF\u9DE3\u9DEB\u9DF8\u9DE4\u9DF6\u9DE1\u9DEE\u9DE6\u9DF2\u9DF0\u9DE2\u9DEC\u9DF4\u9DF3\u9DE8\u9DED\u9EC2\u9ED0\u9EF2\u9EF3\u9F06\u9F1C\u9F38\u9F37\u9F36\u9F43\u9F4F"],
      ["f8a1", "\u9F71\u9F70\u9F6E\u9F6F\u56D3\u56CD\u5B4E\u5C6D\u652D\u66ED\u66EE\u6B13\u705F\u7061\u705D\u7060\u7223\u74DB\u74E5\u77D5\u7938\u79B7\u79B6\u7C6A\u7E97\u7F89\u826D\u8643\u8838\u8837\u8835\u884B\u8B94\u8B95\u8E9E\u8E9F\u8EA0\u8E9D\u91BE\u91BD\u91C2\u946B\u9468\u9469\u96E5\u9746\u9743\u9747\u97C7\u97E5\u9A5E\u9AD5\u9B59\u9C63\u9C67\u9C66\u9C62\u9C5E\u9C60\u9E02\u9DFE\u9E07\u9E03\u9E06\u9E05\u9E00\u9E01\u9E09\u9DFF\u9DFD\u9E04\u9EA0\u9F1E\u9F46\u9F74\u9F75\u9F76\u56D4\u652E\u65B8\u6B18\u6B19\u6B17\u6B1A\u7062\u7226\u72AA\u77D8\u77D9\u7939\u7C69\u7C6B\u7CF6\u7E9A"],
      ["f940", "\u7E98\u7E9B\u7E99\u81E0\u81E1\u8646\u8647\u8648\u8979\u897A\u897C\u897B\u89FF\u8B98\u8B99\u8EA5\u8EA4\u8EA3\u946E\u946D\u946F\u9471\u9473\u9749\u9872\u995F\u9C68\u9C6E\u9C6D\u9E0B\u9E0D\u9E10\u9E0F\u9E12\u9E11\u9EA1\u9EF5\u9F09\u9F47\u9F78\u9F7B\u9F7A\u9F79\u571E\u7066\u7C6F\u883C\u8DB2\u8EA6\u91C3\u9474\u9478\u9476\u9475\u9A60\u9C74\u9C73\u9C71\u9C75\u9E14\u9E13\u9EF6\u9F0A"],
      ["f9a1", "\u9FA4\u7068\u7065\u7CF7\u866A\u883E\u883D\u883F\u8B9E\u8C9C\u8EA9\u8EC9\u974B\u9873\u9874\u98CC\u9961\u99AB\u9A64\u9A66\u9A67\u9B24\u9E15\u9E17\u9F48\u6207\u6B1E\u7227\u864C\u8EA8\u9482\u9480\u9481\u9A69\u9A68\u9B2E\u9E19\u7229\u864B\u8B9F\u9483\u9C79\u9EB7\u7675\u9A6B\u9C7A\u9E1D\u7069\u706A\u9EA4\u9F7E\u9F49\u9F98\u7881\u92B9\u88CF\u58BB\u6052\u7CA7\u5AFA\u2554\u2566\u2557\u2560\u256C\u2563\u255A\u2569\u255D\u2552\u2564\u2555\u255E\u256A\u2561\u2558\u2567\u255B\u2553\u2565\u2556\u255F\u256B\u2562\u2559\u2568\u255C\u2551\u2550\u256D\u256E\u2570\u256F\u2593"]
    ];
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/tables/big5-added.json
var require_big5_added = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/tables/big5-added.json"(exports, module) {
    module.exports = [
      ["8740", "\u43F0\u4C32\u4603\u45A6\u4578\u{27267}\u4D77\u45B3\u{27CB1}\u4CE2\u{27CC5}\u3B95\u4736\u4744\u4C47\u4C40\u{242BF}\u{23617}\u{27352}\u{26E8B}\u{270D2}\u4C57\u{2A351}\u474F\u45DA\u4C85\u{27C6C}\u4D07\u4AA4\u46A1\u{26B23}\u7225\u{25A54}\u{21A63}\u{23E06}\u{23F61}\u664D\u56FB"],
      ["8767", "\u7D95\u591D\u{28BB9}\u3DF4\u9734\u{27BEF}\u5BDB\u{21D5E}\u5AA4\u3625\u{29EB0}\u5AD1\u5BB7\u5CFC\u676E\u8593\u{29945}\u7461\u749D\u3875\u{21D53}\u{2369E}\u{26021}\u3EEC"],
      ["87a1", "\u{258DE}\u3AF5\u7AFC\u9F97\u{24161}\u{2890D}\u{231EA}\u{20A8A}\u{2325E}\u430A\u8484\u9F96\u942F\u4930\u8613\u5896\u974A\u9218\u79D0\u7A32\u6660\u6A29\u889D\u744C\u7BC5\u6782\u7A2C\u524F\u9046\u34E6\u73C4\u{25DB9}\u74C6\u9FC7\u57B3\u492F\u544C\u4131\u{2368E}\u5818\u7A72\u{27B65}\u8B8F\u46AE\u{26E88}\u4181\u{25D99}\u7BAE\u{224BC}\u9FC8\u{224C1}\u{224C9}\u{224CC}\u9FC9\u8504\u{235BB}\u40B4\u9FCA\u44E1\u{2ADFF}\u62C1\u706E\u9FCB"],
      ["8840", "\u31C0", 4, "\u{2010C}\u31C5\u{200D1}\u{200CD}\u31C6\u31C7\u{200CB}\u{21FE8}\u31C8\u{200CA}\u31C9\u31CA\u31CB\u31CC\u{2010E}\u31CD\u31CE\u0100\xC1\u01CD\xC0\u0112\xC9\u011A\xC8\u014C\xD3\u01D1\xD2\u0FFF\xCA\u0304\u1EBE\u0FFF\xCA\u030C\u1EC0\xCA\u0101\xE1\u01CE\xE0\u0251\u0113\xE9\u011B\xE8\u012B\xED\u01D0\xEC\u014D\xF3\u01D2\xF2\u016B\xFA\u01D4\xF9\u01D6\u01D8\u01DA"],
      ["88a1", "\u01DC\xFC\u0FFF\xEA\u0304\u1EBF\u0FFF\xEA\u030C\u1EC1\xEA\u0261\u23DA\u23DB"],
      ["8940", "\u{2A3A9}\u{21145}"],
      ["8943", "\u650A"],
      ["8946", "\u4E3D\u6EDD\u9D4E\u91DF"],
      ["894c", "\u{27735}\u6491\u4F1A\u4F28\u4FA8\u5156\u5174\u519C\u51E4\u52A1\u52A8\u533B\u534E\u53D1\u53D8\u56E2\u58F0\u5904\u5907\u5932\u5934\u5B66\u5B9E\u5B9F\u5C9A\u5E86\u603B\u6589\u67FE\u6804\u6865\u6D4E\u70BC\u7535\u7EA4\u7EAC\u7EBA\u7EC7\u7ECF\u7EDF\u7F06\u7F37\u827A\u82CF\u836F\u89C6\u8BBE\u8BE2\u8F66\u8F67\u8F6E"],
      ["89a1", "\u7411\u7CFC\u7DCD\u6946\u7AC9\u5227"],
      ["89ab", "\u918C\u78B8\u915E\u80BC"],
      ["89b0", "\u8D0B\u80F6\u{209E7}"],
      ["89b5", "\u809F\u9EC7\u4CCD\u9DC9\u9E0C\u4C3E\u{29DF6}\u{2700E}\u9E0A\u{2A133}\u35C1"],
      ["89c1", "\u6E9A\u823E\u7519"],
      ["89c5", "\u4911\u9A6C\u9A8F\u9F99\u7987\u{2846C}\u{21DCA}\u{205D0}\u{22AE6}\u4E24\u4E81\u4E80\u4E87\u4EBF\u4EEB\u4F37\u344C\u4FBD\u3E48\u5003\u5088\u347D\u3493\u34A5\u5186\u5905\u51DB\u51FC\u5205\u4E89\u5279\u5290\u5327\u35C7\u53A9\u3551\u53B0\u3553\u53C2\u5423\u356D\u3572\u3681\u5493\u54A3\u54B4\u54B9\u54D0\u54EF\u5518\u5523\u5528\u3598\u553F\u35A5\u35BF\u55D7\u35C5"],
      ["8a40", "\u{27D84}\u5525"],
      ["8a43", "\u{20C42}\u{20D15}\u{2512B}\u5590\u{22CC6}\u39EC\u{20341}\u8E46\u{24DB8}\u{294E5}\u4053\u{280BE}\u777A\u{22C38}\u3A34\u47D5\u{2815D}\u{269F2}\u{24DEA}\u64DD\u{20D7C}\u{20FB4}\u{20CD5}\u{210F4}\u648D\u8E7E\u{20E96}\u{20C0B}\u{20F64}\u{22CA9}\u{28256}\u{244D3}"],
      ["8a64", "\u{20D46}\u{29A4D}\u{280E9}\u47F4\u{24EA7}\u{22CC2}\u9AB2\u3A67\u{295F4}\u3FED\u3506\u{252C7}\u{297D4}\u{278C8}\u{22D44}\u9D6E\u9815"],
      ["8a76", "\u43D9\u{260A5}\u64B4\u54E3\u{22D4C}\u{22BCA}\u{21077}\u39FB\u{2106F}"],
      ["8aa1", "\u{266DA}\u{26716}\u{279A0}\u64EA\u{25052}\u{20C43}\u8E68\u{221A1}\u{28B4C}\u{20731}"],
      ["8aac", "\u480B\u{201A9}\u3FFA\u5873\u{22D8D}"],
      ["8ab2", "\u{245C8}\u{204FC}\u{26097}\u{20F4C}\u{20D96}\u5579\u40BB\u43BA"],
      ["8abb", "\u4AB4\u{22A66}\u{2109D}\u81AA\u98F5\u{20D9C}\u6379\u39FE\u{22775}\u8DC0\u56A1\u647C\u3E43"],
      ["8ac9", "\u{2A601}\u{20E09}\u{22ACF}\u{22CC9}"],
      ["8ace", "\u{210C8}\u{239C2}\u3992\u3A06\u{2829B}\u3578\u{25E49}\u{220C7}\u5652\u{20F31}\u{22CB2}\u{29720}\u34BC\u6C3D\u{24E3B}"],
      ["8adf", "\u{27574}\u{22E8B}\u{22208}\u{2A65B}\u{28CCD}\u{20E7A}\u{20C34}\u{2681C}\u7F93\u{210CF}\u{22803}\u{22939}\u35FB\u{251E3}\u{20E8C}\u{20F8D}\u{20EAA}\u3F93\u{20F30}\u{20D47}\u{2114F}\u{20E4C}"],
      ["8af6", "\u{20EAB}\u{20BA9}\u{20D48}\u{210C0}\u{2113D}\u3FF9\u{22696}\u6432\u{20FAD}"],
      ["8b40", "\u{233F4}\u{27639}\u{22BCE}\u{20D7E}\u{20D7F}\u{22C51}\u{22C55}\u3A18\u{20E98}\u{210C7}\u{20F2E}\u{2A632}\u{26B50}\u{28CD2}\u{28D99}\u{28CCA}\u95AA\u54CC\u82C4\u55B9"],
      ["8b55", "\u{29EC3}\u9C26\u9AB6\u{2775E}\u{22DEE}\u7140\u816D\u80EC\u5C1C\u{26572}\u8134\u3797\u535F\u{280BD}\u91B6\u{20EFA}\u{20E0F}\u{20E77}\u{20EFB}\u35DD\u{24DEB}\u3609\u{20CD6}\u56AF\u{227B5}\u{210C9}\u{20E10}\u{20E78}\u{21078}\u{21148}\u{28207}\u{21455}\u{20E79}\u{24E50}\u{22DA4}\u5A54\u{2101D}\u{2101E}\u{210F5}\u{210F6}\u579C\u{20E11}"],
      ["8ba1", "\u{27694}\u{282CD}\u{20FB5}\u{20E7B}\u{2517E}\u3703\u{20FB6}\u{21180}\u{252D8}\u{2A2BD}\u{249DA}\u{2183A}\u{24177}\u{2827C}\u5899\u5268\u361A\u{2573D}\u7BB2\u5B68\u4800\u4B2C\u9F27\u49E7\u9C1F\u9B8D\u{25B74}\u{2313D}\u55FB\u35F2\u5689\u4E28\u5902\u{21BC1}\u{2F878}\u9751\u{20086}\u4E5B\u4EBB\u353E\u5C23\u5F51\u5FC4\u38FA\u624C\u6535\u6B7A\u6C35\u6C3A\u706C\u722B\u4E2C\u72AD\u{248E9}\u7F52\u793B\u7CF9\u7F53\u{2626A}\u34C1"],
      ["8bde", "\u{2634B}\u8002\u8080\u{26612}\u{26951}\u535D\u8864\u89C1\u{278B2}\u8BA0\u8D1D\u9485\u9578\u957F\u95E8\u{28E0F}\u97E6\u9875\u98CE\u98DE\u9963\u{29810}\u9C7C\u9E1F\u9EC4\u6B6F\uF907\u4E37\u{20087}\u961D\u6237\u94A2"],
      ["8c40", "\u503B\u6DFE\u{29C73}\u9FA6\u3DC9\u888F\u{2414E}\u7077\u5CF5\u4B20\u{251CD}\u3559\u{25D30}\u6122\u{28A32}\u8FA7\u91F6\u7191\u6719\u73BA\u{23281}\u{2A107}\u3C8B\u{21980}\u4B10\u78E4\u7402\u51AE\u{2870F}\u4009\u6A63\u{2A2BA}\u4223\u860F\u{20A6F}\u7A2A\u{29947}\u{28AEA}\u9755\u704D\u5324\u{2207E}\u93F4\u76D9\u{289E3}\u9FA7\u77DD\u4EA3\u4FF0\u50BC\u4E2F\u4F17\u9FA8\u5434\u7D8B\u5892\u58D0\u{21DB6}\u5E92\u5E99\u5FC2\u{22712}\u658B"],
      ["8ca1", "\u{233F9}\u6919\u6A43\u{23C63}\u6CFF"],
      ["8ca7", "\u7200\u{24505}\u738C\u3EDB\u{24A13}\u5B15\u74B9\u8B83\u{25CA4}\u{25695}\u7A93\u7BEC\u7CC3\u7E6C\u82F8\u8597\u9FA9\u8890\u9FAA\u8EB9\u9FAB\u8FCF\u855F\u99E0\u9221\u9FAC\u{28DB9}\u{2143F}\u4071\u42A2\u5A1A"],
      ["8cc9", "\u9868\u676B\u4276\u573D"],
      ["8cce", "\u85D6\u{2497B}\u82BF\u{2710D}\u4C81\u{26D74}\u5D7B\u{26B15}\u{26FBE}\u9FAD\u9FAE\u5B96\u9FAF\u66E7\u7E5B\u6E57\u79CA\u3D88\u44C3\u{23256}\u{22796}\u439A\u4536"],
      ["8ce6", "\u5CD5\u{23B1A}\u8AF9\u5C78\u3D12\u{23551}\u5D78\u9FB2\u7157\u4558\u{240EC}\u{21E23}\u4C77\u3978\u344A\u{201A4}\u{26C41}\u8ACC\u4FB4\u{20239}\u59BF\u816C\u9856\u{298FA}\u5F3B"],
      ["8d40", "\u{20B9F}"],
      ["8d42", "\u{221C1}\u{2896D}\u4102\u46BB\u{29079}\u3F07\u9FB3\u{2A1B5}\u40F8\u37D6\u46F7\u{26C46}\u417C\u{286B2}\u{273FF}\u456D\u38D4\u{2549A}\u4561\u451B\u4D89\u4C7B\u4D76\u45EA\u3FC8\u{24B0F}\u3661\u44DE\u44BD\u41ED\u5D3E\u5D48\u5D56\u3DFC\u380F\u5DA4\u5DB9\u3820\u3838\u5E42\u5EBD\u5F25\u5F83\u3908\u3914\u393F\u394D\u60D7\u613D\u5CE5\u3989\u61B7\u61B9\u61CF\u39B8\u622C\u6290\u62E5\u6318\u39F8\u56B1"],
      ["8da1", "\u3A03\u63E2\u63FB\u6407\u645A\u3A4B\u64C0\u5D15\u5621\u9F9F\u3A97\u6586\u3ABD\u65FF\u6653\u3AF2\u6692\u3B22\u6716\u3B42\u67A4\u6800\u3B58\u684A\u6884\u3B72\u3B71\u3B7B\u6909\u6943\u725C\u6964\u699F\u6985\u3BBC\u69D6\u3BDD\u6A65\u6A74\u6A71\u6A82\u3BEC\u6A99\u3BF2\u6AAB\u6AB5\u6AD4\u6AF6\u6B81\u6BC1\u6BEA\u6C75\u6CAA\u3CCB\u6D02\u6D06\u6D26\u6D81\u3CEF\u6DA4\u6DB1\u6E15\u6E18\u6E29\u6E86\u{289C0}\u6EBB\u6EE2\u6EDA\u9F7F\u6EE8\u6EE9\u6F24\u6F34\u3D46\u{23F41}\u6F81\u6FBE\u3D6A\u3D75\u71B7\u5C99\u3D8A\u702C\u3D91\u7050\u7054\u706F\u707F\u7089\u{20325}\u43C1\u35F1\u{20ED8}"],
      ["8e40", "\u{23ED7}\u57BE\u{26ED3}\u713E\u{257E0}\u364E\u69A2\u{28BE9}\u5B74\u7A49\u{258E1}\u{294D9}\u7A65\u7A7D\u{259AC}\u7ABB\u7AB0\u7AC2\u7AC3\u71D1\u{2648D}\u41CA\u7ADA\u7ADD\u7AEA\u41EF\u54B2\u{25C01}\u7B0B\u7B55\u7B29\u{2530E}\u{25CFE}\u7BA2\u7B6F\u839C\u{25BB4}\u{26C7F}\u7BD0\u8421\u7B92\u7BB8\u{25D20}\u3DAD\u{25C65}\u8492\u7BFA\u7C06\u7C35\u{25CC1}\u7C44\u7C83\u{24882}\u7CA6\u667D\u{24578}\u7CC9\u7CC7\u7CE6\u7C74\u7CF3\u7CF5\u7CCE"],
      ["8ea1", "\u7E67\u451D\u{26E44}\u7D5D\u{26ED6}\u748D\u7D89\u7DAB\u7135\u7DB3\u7DD2\u{24057}\u{26029}\u7DE4\u3D13\u7DF5\u{217F9}\u7DE5\u{2836D}\u7E1D\u{26121}\u{2615A}\u7E6E\u7E92\u432B\u946C\u7E27\u7F40\u7F41\u7F47\u7936\u{262D0}\u99E1\u7F97\u{26351}\u7FA3\u{21661}\u{20068}\u455C\u{23766}\u4503\u{2833A}\u7FFA\u{26489}\u8005\u8008\u801D\u8028\u802F\u{2A087}\u{26CC3}\u803B\u803C\u8061\u{22714}\u4989\u{26626}\u{23DE3}\u{266E8}\u6725\u80A7\u{28A48}\u8107\u811A\u58B0\u{226F6}\u6C7F\u{26498}\u{24FB8}\u64E7\u{2148A}\u8218\u{2185E}\u6A53\u{24A65}\u{24A95}\u447A\u8229\u{20B0D}\u{26A52}\u{23D7E}\u4FF9\u{214FD}\u84E2\u8362\u{26B0A}\u{249A7}\u{23530}\u{21773}\u{23DF8}\u82AA\u691B\u{2F994}\u41DB"],
      ["8f40", "\u854B\u82D0\u831A\u{20E16}\u{217B4}\u36C1\u{2317D}\u{2355A}\u827B\u82E2\u8318\u{23E8B}\u{26DA3}\u{26B05}\u{26B97}\u{235CE}\u3DBF\u831D\u55EC\u8385\u450B\u{26DA5}\u83AC\u83C1\u83D3\u347E\u{26ED4}\u6A57\u855A\u3496\u{26E42}\u{22EEF}\u8458\u{25BE4}\u8471\u3DD3\u44E4\u6AA7\u844A\u{23CB5}\u7958\u84A8\u{26B96}\u{26E77}\u{26E43}\u84DE\u840F\u8391\u44A0\u8493\u84E4\u{25C91}\u4240\u{25CC0}\u4543\u8534\u5AF2\u{26E99}\u4527\u8573\u4516\u67BF\u8616"],
      ["8fa1", "\u{28625}\u{2863B}\u85C1\u{27088}\u8602\u{21582}\u{270CD}\u{2F9B2}\u456A\u8628\u3648\u{218A2}\u53F7\u{2739A}\u867E\u8771\u{2A0F8}\u87EE\u{22C27}\u87B1\u87DA\u880F\u5661\u866C\u6856\u460F\u8845\u8846\u{275E0}\u{23DB9}\u{275E4}\u885E\u889C\u465B\u88B4\u88B5\u63C1\u88C5\u7777\u{2770F}\u8987\u898A\u89A6\u89A9\u89A7\u89BC\u{28A25}\u89E7\u{27924}\u{27ABD}\u8A9C\u7793\u91FE\u8A90\u{27A59}\u7AE9\u{27B3A}\u{23F8F}\u4713\u{27B38}\u717C\u8B0C\u8B1F\u{25430}\u{25565}\u8B3F\u8B4C\u8B4D\u8AA9\u{24A7A}\u8B90\u8B9B\u8AAF\u{216DF}\u4615\u884F\u8C9B\u{27D54}\u{27D8F}\u{2F9D4}\u3725\u{27D53}\u8CD6\u{27D98}\u{27DBD}\u8D12\u8D03\u{21910}\u8CDB\u705C\u8D11\u{24CC9}\u3ED0\u8D77"],
      ["9040", "\u8DA9\u{28002}\u{21014}\u{2498A}\u3B7C\u{281BC}\u{2710C}\u7AE7\u8EAD\u8EB6\u8EC3\u92D4\u8F19\u8F2D\u{28365}\u{28412}\u8FA5\u9303\u{2A29F}\u{20A50}\u8FB3\u492A\u{289DE}\u{2853D}\u{23DBB}\u5EF8\u{23262}\u8FF9\u{2A014}\u{286BC}\u{28501}\u{22325}\u3980\u{26ED7}\u9037\u{2853C}\u{27ABE}\u9061\u{2856C}\u{2860B}\u90A8\u{28713}\u90C4\u{286E6}\u90AE\u90FD\u9167\u3AF0\u91A9\u91C4\u7CAC\u{28933}\u{21E89}\u920E\u6C9F\u9241\u9262\u{255B9}\u92B9\u{28AC6}\u{23C9B}\u{28B0C}\u{255DB}"],
      ["90a1", "\u{20D31}\u932C\u936B\u{28AE1}\u{28BEB}\u708F\u5AC3\u{28AE2}\u{28AE5}\u4965\u9244\u{28BEC}\u{28C39}\u{28BFF}\u9373\u945B\u8EBC\u9585\u95A6\u9426\u95A0\u6FF6\u42B9\u{2267A}\u{286D8}\u{2127C}\u{23E2E}\u49DF\u6C1C\u967B\u9696\u416C\u96A3\u{26ED5}\u61DA\u96B6\u78F5\u{28AE0}\u96BD\u53CC\u49A1\u{26CB8}\u{20274}\u{26410}\u{290AF}\u{290E5}\u{24AD1}\u{21915}\u{2330A}\u9731\u8642\u9736\u4A0F\u453D\u4585\u{24AE9}\u7075\u5B41\u971B\u975C\u{291D5}\u9757\u5B4A\u{291EB}\u975F\u9425\u50D0\u{230B7}\u{230BC}\u9789\u979F\u97B1\u97BE\u97C0\u97D2\u97E0\u{2546C}\u97EE\u741C\u{29433}\u97FF\u97F5\u{2941D}\u{2797A}\u4AD1\u9834\u9833\u984B\u9866\u3B0E\u{27175}\u3D51\u{20630}\u{2415C}"],
      ["9140", "\u{25706}\u98CA\u98B7\u98C8\u98C7\u4AFF\u{26D27}\u{216D3}\u55B0\u98E1\u98E6\u98EC\u9378\u9939\u{24A29}\u4B72\u{29857}\u{29905}\u99F5\u9A0C\u9A3B\u9A10\u9A58\u{25725}\u36C4\u{290B1}\u{29BD5}\u9AE0\u9AE2\u{29B05}\u9AF4\u4C0E\u9B14\u9B2D\u{28600}\u5034\u9B34\u{269A8}\u38C3\u{2307D}\u9B50\u9B40\u{29D3E}\u5A45\u{21863}\u9B8E\u{2424B}\u9C02\u9BFF\u9C0C\u{29E68}\u9DD4\u{29FB7}\u{2A192}\u{2A1AB}\u{2A0E1}\u{2A123}\u{2A1DF}\u9D7E\u9D83\u{2A134}\u9E0E\u6888"],
      ["91a1", "\u9DC4\u{2215B}\u{2A193}\u{2A220}\u{2193B}\u{2A233}\u9D39\u{2A0B9}\u{2A2B4}\u9E90\u9E95\u9E9E\u9EA2\u4D34\u9EAA\u9EAF\u{24364}\u9EC1\u3B60\u39E5\u3D1D\u4F32\u37BE\u{28C2B}\u9F02\u9F08\u4B96\u9424\u{26DA2}\u9F17\u9F16\u9F39\u569F\u568A\u9F45\u99B8\u{2908B}\u97F2\u847F\u9F62\u9F69\u7ADC\u9F8E\u7216\u4BBE\u{24975}\u{249BB}\u7177\u{249F8}\u{24348}\u{24A51}\u739E\u{28BDA}\u{218FA}\u799F\u{2897E}\u{28E36}\u9369\u93F3\u{28A44}\u92EC\u9381\u93CB\u{2896C}\u{244B9}\u7217\u3EEB\u7772\u7A43\u70D0\u{24473}\u{243F8}\u717E\u{217EF}\u70A3\u{218BE}\u{23599}\u3EC7\u{21885}\u{2542F}\u{217F8}\u3722\u{216FB}\u{21839}\u36E1\u{21774}\u{218D1}\u{25F4B}\u3723\u{216C0}\u575B\u{24A25}\u{213FE}\u{212A8}"],
      ["9240", "\u{213C6}\u{214B6}\u8503\u{236A6}\u8503\u8455\u{24994}\u{27165}\u{23E31}\u{2555C}\u{23EFB}\u{27052}\u44F4\u{236EE}\u{2999D}\u{26F26}\u67F9\u3733\u3C15\u3DE7\u586C\u{21922}\u6810\u4057\u{2373F}\u{240E1}\u{2408B}\u{2410F}\u{26C21}\u54CB\u569E\u{266B1}\u5692\u{20FDF}\u{20BA8}\u{20E0D}\u93C6\u{28B13}\u939C\u4EF8\u512B\u3819\u{24436}\u4EBC\u{20465}\u{2037F}\u4F4B\u4F8A\u{25651}\u5A68\u{201AB}\u{203CB}\u3999\u{2030A}\u{20414}\u3435\u4F29\u{202C0}\u{28EB3}\u{20275}\u8ADA\u{2020C}\u4E98"],
      ["92a1", "\u50CD\u510D\u4FA2\u4F03\u{24A0E}\u{23E8A}\u4F42\u502E\u506C\u5081\u4FCC\u4FE5\u5058\u50FC\u5159\u515B\u515D\u515E\u6E76\u{23595}\u{23E39}\u{23EBF}\u6D72\u{21884}\u{23E89}\u51A8\u51C3\u{205E0}\u44DD\u{204A3}\u{20492}\u{20491}\u8D7A\u{28A9C}\u{2070E}\u5259\u52A4\u{20873}\u52E1\u936E\u467A\u718C\u{2438C}\u{20C20}\u{249AC}\u{210E4}\u69D1\u{20E1D}\u7479\u3EDE\u7499\u7414\u7456\u7398\u4B8E\u{24ABC}\u{2408D}\u53D0\u3584\u720F\u{240C9}\u55B4\u{20345}\u54CD\u{20BC6}\u571D\u925D\u96F4\u9366\u57DD\u578D\u577F\u363E\u58CB\u5A99\u{28A46}\u{216FA}\u{2176F}\u{21710}\u5A2C\u59B8\u928F\u5A7E\u5ACF\u5A12\u{25946}\u{219F3}\u{21861}\u{24295}\u36F5\u6D05\u7443\u5A21\u{25E83}"],
      ["9340", "\u5A81\u{28BD7}\u{20413}\u93E0\u748C\u{21303}\u7105\u4972\u9408\u{289FB}\u93BD\u37A0\u5C1E\u5C9E\u5E5E\u5E48\u{21996}\u{2197C}\u{23AEE}\u5ECD\u5B4F\u{21903}\u{21904}\u3701\u{218A0}\u36DD\u{216FE}\u36D3\u812A\u{28A47}\u{21DBA}\u{23472}\u{289A8}\u5F0C\u5F0E\u{21927}\u{217AB}\u5A6B\u{2173B}\u5B44\u8614\u{275FD}\u8860\u607E\u{22860}\u{2262B}\u5FDB\u3EB8\u{225AF}\u{225BE}\u{29088}\u{26F73}\u61C0\u{2003E}\u{20046}\u{2261B}\u6199\u6198\u6075\u{22C9B}\u{22D07}\u{246D4}\u{2914D}"],
      ["93a1", "\u6471\u{24665}\u{22B6A}\u3A29\u{22B22}\u{23450}\u{298EA}\u{22E78}\u6337\u{2A45B}\u64B6\u6331\u63D1\u{249E3}\u{22D67}\u62A4\u{22CA1}\u643B\u656B\u6972\u3BF4\u{2308E}\u{232AD}\u{24989}\u{232AB}\u550D\u{232E0}\u{218D9}\u{2943F}\u66CE\u{23289}\u{231B3}\u3AE0\u4190\u{25584}\u{28B22}\u{2558F}\u{216FC}\u{2555B}\u{25425}\u78EE\u{23103}\u{2182A}\u{23234}\u3464\u{2320F}\u{23182}\u{242C9}\u668E\u{26D24}\u666B\u4B93\u6630\u{27870}\u{21DEB}\u6663\u{232D2}\u{232E1}\u661E\u{25872}\u38D1\u{2383A}\u{237BC}\u3B99\u{237A2}\u{233FE}\u74D0\u3B96\u678F\u{2462A}\u68B6\u681E\u3BC4\u6ABE\u3863\u{237D5}\u{24487}\u6A33\u6A52\u6AC9\u6B05\u{21912}\u6511\u6898\u6A4C\u3BD7\u6A7A\u6B57\u{23FC0}\u{23C9A}\u93A0\u92F2\u{28BEA}\u{28ACB}"],
      ["9440", "\u9289\u{2801E}\u{289DC}\u9467\u6DA5\u6F0B\u{249EC}\u6D67\u{23F7F}\u3D8F\u6E04\u{2403C}\u5A3D\u6E0A\u5847\u6D24\u7842\u713B\u{2431A}\u{24276}\u70F1\u7250\u7287\u7294\u{2478F}\u{24725}\u5179\u{24AA4}\u{205EB}\u747A\u{23EF8}\u{2365F}\u{24A4A}\u{24917}\u{25FE1}\u3F06\u3EB1\u{24ADF}\u{28C23}\u{23F35}\u60A7\u3EF3\u74CC\u743C\u9387\u7437\u449F\u{26DEA}\u4551\u7583\u3F63\u{24CD9}\u{24D06}\u3F58\u7555\u7673\u{2A5C6}\u3B19\u7468\u{28ACC}\u{249AB}\u{2498E}\u3AFB"],
      ["94a1", "\u3DCD\u{24A4E}\u3EFF\u{249C5}\u{248F3}\u91FA\u5732\u9342\u{28AE3}\u{21864}\u50DF\u{25221}\u{251E7}\u7778\u{23232}\u770E\u770F\u777B\u{24697}\u{23781}\u3A5E\u{248F0}\u7438\u749B\u3EBF\u{24ABA}\u{24AC7}\u40C8\u{24A96}\u{261AE}\u9307\u{25581}\u781E\u788D\u7888\u78D2\u73D0\u7959\u{27741}\u{256E3}\u410E\u799B\u8496\u79A5\u6A2D\u{23EFA}\u7A3A\u79F4\u416E\u{216E6}\u4132\u9235\u79F1\u{20D4C}\u{2498C}\u{20299}\u{23DBA}\u{2176E}\u3597\u556B\u3570\u36AA\u{201D4}\u{20C0D}\u7AE2\u5A59\u{226F5}\u{25AAF}\u{25A9C}\u5A0D\u{2025B}\u78F0\u5A2A\u{25BC6}\u7AFE\u41F9\u7C5D\u7C6D\u4211\u{25BB3}\u{25EBC}\u{25EA6}\u7CCD\u{249F9}\u{217B0}\u7C8E\u7C7C\u7CAE\u6AB2\u7DDC\u7E07\u7DD3\u7F4E\u{26261}"],
      ["9540", "\u{2615C}\u{27B48}\u7D97\u{25E82}\u426A\u{26B75}\u{20916}\u67D6\u{2004E}\u{235CF}\u57C4\u{26412}\u{263F8}\u{24962}\u7FDD\u7B27\u{2082C}\u{25AE9}\u{25D43}\u7B0C\u{25E0E}\u99E6\u8645\u9A63\u6A1C\u{2343F}\u39E2\u{249F7}\u{265AD}\u9A1F\u{265A0}\u8480\u{27127}\u{26CD1}\u44EA\u8137\u4402\u80C6\u8109\u8142\u{267B4}\u98C3\u{26A42}\u8262\u8265\u{26A51}\u8453\u{26DA7}\u8610\u{2721B}\u5A86\u417F\u{21840}\u5B2B\u{218A1}\u5AE4\u{218D8}\u86A0\u{2F9BC}\u{23D8F}\u882D\u{27422}\u5A02"],
      ["95a1", "\u886E\u4F45\u8887\u88BF\u88E6\u8965\u894D\u{25683}\u8954\u{27785}\u{27784}\u{28BF5}\u{28BD9}\u{28B9C}\u{289F9}\u3EAD\u84A3\u46F5\u46CF\u37F2\u8A3D\u8A1C\u{29448}\u5F4D\u922B\u{24284}\u65D4\u7129\u70C4\u{21845}\u9D6D\u8C9F\u8CE9\u{27DDC}\u599A\u77C3\u59F0\u436E\u36D4\u8E2A\u8EA7\u{24C09}\u8F30\u8F4A\u42F4\u6C58\u6FBB\u{22321}\u489B\u6F79\u6E8B\u{217DA}\u9BE9\u36B5\u{2492F}\u90BB\u9097\u5571\u4906\u91BB\u9404\u{28A4B}\u4062\u{28AFC}\u9427\u{28C1D}\u{28C3B}\u84E5\u8A2B\u9599\u95A7\u9597\u9596\u{28D34}\u7445\u3EC2\u{248FF}\u{24A42}\u{243EA}\u3EE7\u{23225}\u968F\u{28EE7}\u{28E66}\u{28E65}\u3ECC\u{249ED}\u{24A78}\u{23FEE}\u7412\u746B\u3EFC\u9741\u{290B0}"],
      ["9640", "\u6847\u4A1D\u{29093}\u{257DF}\u975D\u9368\u{28989}\u{28C26}\u{28B2F}\u{263BE}\u92BA\u5B11\u8B69\u493C\u73F9\u{2421B}\u979B\u9771\u9938\u{20F26}\u5DC1\u{28BC5}\u{24AB2}\u981F\u{294DA}\u92F6\u{295D7}\u91E5\u44C0\u{28B50}\u{24A67}\u{28B64}\u98DC\u{28A45}\u3F00\u922A\u4925\u8414\u993B\u994D\u{27B06}\u3DFD\u999B\u4B6F\u99AA\u9A5C\u{28B65}\u{258C8}\u6A8F\u9A21\u5AFE\u9A2F\u{298F1}\u4B90\u{29948}\u99BC\u4BBD\u4B97\u937D\u5872\u{21302}\u5822\u{249B8}"],
      ["96a1", "\u{214E8}\u7844\u{2271F}\u{23DB8}\u68C5\u3D7D\u9458\u3927\u6150\u{22781}\u{2296B}\u6107\u9C4F\u9C53\u9C7B\u9C35\u9C10\u9B7F\u9BCF\u{29E2D}\u9B9F\u{2A1F5}\u{2A0FE}\u9D21\u4CAE\u{24104}\u9E18\u4CB0\u9D0C\u{2A1B4}\u{2A0ED}\u{2A0F3}\u{2992F}\u9DA5\u84BD\u{26E12}\u{26FDF}\u{26B82}\u85FC\u4533\u{26DA4}\u{26E84}\u{26DF0}\u8420\u85EE\u{26E00}\u{237D7}\u{26064}\u79E2\u{2359C}\u{23640}\u492D\u{249DE}\u3D62\u93DB\u92BE\u9348\u{202BF}\u78B9\u9277\u944D\u4FE4\u3440\u9064\u{2555D}\u783D\u7854\u78B6\u784B\u{21757}\u{231C9}\u{24941}\u369A\u4F72\u6FDA\u6FD9\u701E\u701E\u5414\u{241B5}\u57BB\u58F3\u578A\u9D16\u57D7\u7134\u34AF\u{241AC}\u71EB\u{26C40}\u{24F97}\u5B28\u{217B5}\u{28A49}"],
      ["9740", "\u610C\u5ACE\u5A0B\u42BC\u{24488}\u372C\u4B7B\u{289FC}\u93BB\u93B8\u{218D6}\u{20F1D}\u8472\u{26CC0}\u{21413}\u{242FA}\u{22C26}\u{243C1}\u5994\u{23DB7}\u{26741}\u7DA8\u{2615B}\u{260A4}\u{249B9}\u{2498B}\u{289FA}\u92E5\u73E2\u3EE9\u74B4\u{28B63}\u{2189F}\u3EE1\u{24AB3}\u6AD8\u73F3\u73FB\u3ED6\u{24A3E}\u{24A94}\u{217D9}\u{24A66}\u{203A7}\u{21424}\u{249E5}\u7448\u{24916}\u70A5\u{24976}\u9284\u73E6\u935F\u{204FE}\u9331\u{28ACE}\u{28A16}\u9386\u{28BE7}\u{255D5}\u4935\u{28A82}\u716B"],
      ["97a1", "\u{24943}\u{20CFF}\u56A4\u{2061A}\u{20BEB}\u{20CB8}\u5502\u79C4\u{217FA}\u7DFE\u{216C2}\u{24A50}\u{21852}\u452E\u9401\u370A\u{28AC0}\u{249AD}\u59B0\u{218BF}\u{21883}\u{27484}\u5AA1\u36E2\u{23D5B}\u36B0\u925F\u5A79\u{28A81}\u{21862}\u9374\u3CCD\u{20AB4}\u4A96\u398A\u50F4\u3D69\u3D4C\u{2139C}\u7175\u42FB\u{28218}\u6E0F\u{290E4}\u44EB\u6D57\u{27E4F}\u7067\u6CAF\u3CD6\u{23FED}\u{23E2D}\u6E02\u6F0C\u3D6F\u{203F5}\u7551\u36BC\u34C8\u4680\u3EDA\u4871\u59C4\u926E\u493E\u8F41\u{28C1C}\u{26BC0}\u5812\u57C8\u36D6\u{21452}\u70FE\u{24362}\u{24A71}\u{22FE3}\u{212B0}\u{223BD}\u68B9\u6967\u{21398}\u{234E5}\u{27BF4}\u{236DF}\u{28A83}\u{237D6}\u{233FA}\u{24C9F}\u6A1A\u{236AD}\u{26CB7}\u843E\u44DF\u44CE"],
      ["9840", "\u{26D26}\u{26D51}\u{26C82}\u{26FDE}\u6F17\u{27109}\u833D\u{2173A}\u83ED\u{26C80}\u{27053}\u{217DB}\u5989\u5A82\u{217B3}\u5A61\u5A71\u{21905}\u{241FC}\u372D\u59EF\u{2173C}\u36C7\u718E\u9390\u669A\u{242A5}\u5A6E\u5A2B\u{24293}\u6A2B\u{23EF9}\u{27736}\u{2445B}\u{242CA}\u711D\u{24259}\u{289E1}\u4FB0\u{26D28}\u5CC2\u{244CE}\u{27E4D}\u{243BD}\u6A0C\u{24256}\u{21304}\u70A6\u7133\u{243E9}\u3DA5\u6CDF\u{2F825}\u{24A4F}\u7E65\u59EB\u5D2F\u3DF3\u5F5C\u{24A5D}\u{217DF}\u7DA4\u8426"],
      ["98a1", "\u5485\u{23AFA}\u{23300}\u{20214}\u577E\u{208D5}\u{20619}\u3FE5\u{21F9E}\u{2A2B6}\u7003\u{2915B}\u5D70\u738F\u7CD3\u{28A59}\u{29420}\u4FC8\u7FE7\u72CD\u7310\u{27AF4}\u7338\u7339\u{256F6}\u7341\u7348\u3EA9\u{27B18}\u906C\u71F5\u{248F2}\u73E1\u81F6\u3ECA\u770C\u3ED1\u6CA2\u56FD\u7419\u741E\u741F\u3EE2\u3EF0\u3EF4\u3EFA\u74D3\u3F0E\u3F53\u7542\u756D\u7572\u758D\u3F7C\u75C8\u75DC\u3FC0\u764D\u3FD7\u7674\u3FDC\u767A\u{24F5C}\u7188\u5623\u8980\u5869\u401D\u7743\u4039\u6761\u4045\u35DB\u7798\u406A\u406F\u5C5E\u77BE\u77CB\u58F2\u7818\u70B9\u781C\u40A8\u7839\u7847\u7851\u7866\u8448\u{25535}\u7933\u6803\u7932\u4103"],
      ["9940", "\u4109\u7991\u7999\u8FBB\u7A06\u8FBC\u4167\u7A91\u41B2\u7ABC\u8279\u41C4\u7ACF\u7ADB\u41CF\u4E21\u7B62\u7B6C\u7B7B\u7C12\u7C1B\u4260\u427A\u7C7B\u7C9C\u428C\u7CB8\u4294\u7CED\u8F93\u70C0\u{20CCF}\u7DCF\u7DD4\u7DD0\u7DFD\u7FAE\u7FB4\u729F\u4397\u8020\u8025\u7B39\u802E\u8031\u8054\u3DCC\u57B4\u70A0\u80B7\u80E9\u43ED\u810C\u732A\u810E\u8112\u7560\u8114\u4401\u3B39\u8156\u8159\u815A"],
      ["99a1", "\u4413\u583A\u817C\u8184\u4425\u8193\u442D\u81A5\u57EF\u81C1\u81E4\u8254\u448F\u82A6\u8276\u82CA\u82D8\u82FF\u44B0\u8357\u9669\u698A\u8405\u70F5\u8464\u60E3\u8488\u4504\u84BE\u84E1\u84F8\u8510\u8538\u8552\u453B\u856F\u8570\u85E0\u4577\u8672\u8692\u86B2\u86EF\u9645\u878B\u4606\u4617\u88AE\u88FF\u8924\u8947\u8991\u{27967}\u8A29\u8A38\u8A94\u8AB4\u8C51\u8CD4\u8CF2\u8D1C\u4798\u585F\u8DC3\u47ED\u4EEE\u8E3A\u55D8\u5754\u8E71\u55F5\u8EB0\u4837\u8ECE\u8EE2\u8EE4\u8EED\u8EF2\u8FB7\u8FC1\u8FCA\u8FCC\u9033\u99C4\u48AD\u98E0\u9213\u491E\u9228\u9258\u926B\u92B1\u92AE\u92BF"],
      ["9a40", "\u92E3\u92EB\u92F3\u92F4\u92FD\u9343\u9384\u93AD\u4945\u4951\u9EBF\u9417\u5301\u941D\u942D\u943E\u496A\u9454\u9479\u952D\u95A2\u49A7\u95F4\u9633\u49E5\u67A0\u4A24\u9740\u4A35\u97B2\u97C2\u5654\u4AE4\u60E8\u98B9\u4B19\u98F1\u5844\u990E\u9919\u51B4\u991C\u9937\u9942\u995D\u9962\u4B70\u99C5\u4B9D\u9A3C\u9B0F\u7A83\u9B69\u9B81\u9BDD\u9BF1\u9BF4\u4C6D\u9C20\u376F\u{21BC2}\u9D49\u9C3A"],
      ["9aa1", "\u9EFE\u5650\u9D93\u9DBD\u9DC0\u9DFC\u94F6\u8FB6\u9E7B\u9EAC\u9EB1\u9EBD\u9EC6\u94DC\u9EE2\u9EF1\u9EF8\u7AC8\u9F44\u{20094}\u{202B7}\u{203A0}\u691A\u94C3\u59AC\u{204D7}\u5840\u94C1\u37B9\u{205D5}\u{20615}\u{20676}\u{216BA}\u5757\u7173\u{20AC2}\u{20ACD}\u{20BBF}\u546A\u{2F83B}\u{20BCB}\u549E\u{20BFB}\u{20C3B}\u{20C53}\u{20C65}\u{20C7C}\u60E7\u{20C8D}\u567A\u{20CB5}\u{20CDD}\u{20CED}\u{20D6F}\u{20DB2}\u{20DC8}\u6955\u9C2F\u87A5\u{20E04}\u{20E0E}\u{20ED7}\u{20F90}\u{20F2D}\u{20E73}\u5C20\u{20FBC}\u5E0B\u{2105C}\u{2104F}\u{21076}\u671E\u{2107B}\u{21088}\u{21096}\u3647\u{210BF}\u{210D3}\u{2112F}\u{2113B}\u5364\u84AD\u{212E3}\u{21375}\u{21336}\u8B81\u{21577}\u{21619}\u{217C3}\u{217C7}\u4E78\u70BB\u{2182D}\u{2196A}"],
      ["9b40", "\u{21A2D}\u{21A45}\u{21C2A}\u{21C70}\u{21CAC}\u{21EC8}\u62C3\u{21ED5}\u{21F15}\u7198\u6855\u{22045}\u69E9\u36C8\u{2227C}\u{223D7}\u{223FA}\u{2272A}\u{22871}\u{2294F}\u82FD\u{22967}\u{22993}\u{22AD5}\u89A5\u{22AE8}\u8FA0\u{22B0E}\u97B8\u{22B3F}\u9847\u9ABD\u{22C4C}"],
      ["9b62", "\u{22C88}\u{22CB7}\u{25BE8}\u{22D08}\u{22D12}\u{22DB7}\u{22D95}\u{22E42}\u{22F74}\u{22FCC}\u{23033}\u{23066}\u{2331F}\u{233DE}\u5FB1\u6648\u66BF\u{27A79}\u{23567}\u{235F3}\u7201\u{249BA}\u77D7\u{2361A}\u{23716}\u7E87\u{20346}\u58B5\u670E"],
      ["9ba1", "\u6918\u{23AA7}\u{27657}\u{25FE2}\u{23E11}\u{23EB9}\u{275FE}\u{2209A}\u48D0\u4AB8\u{24119}\u{28A9A}\u{242EE}\u{2430D}\u{2403B}\u{24334}\u{24396}\u{24A45}\u{205CA}\u51D2\u{20611}\u599F\u{21EA8}\u3BBE\u{23CFF}\u{24404}\u{244D6}\u5788\u{24674}\u399B\u{2472F}\u{285E8}\u{299C9}\u3762\u{221C3}\u8B5E\u{28B4E}\u99D6\u{24812}\u{248FB}\u{24A15}\u7209\u{24AC0}\u{20C78}\u5965\u{24EA5}\u{24F86}\u{20779}\u8EDA\u{2502C}\u528F\u573F\u7171\u{25299}\u{25419}\u{23F4A}\u{24AA7}\u55BC\u{25446}\u{2546E}\u{26B52}\u91D4\u3473\u{2553F}\u{27632}\u{2555E}\u4718\u{25562}\u{25566}\u{257C7}\u{2493F}\u{2585D}\u5066\u34FB\u{233CC}\u60DE\u{25903}\u477C\u{28948}\u{25AAE}\u{25B89}\u{25C06}\u{21D90}\u57A1\u7151\u6FB6\u{26102}\u{27C12}\u9056\u{261B2}\u{24F9A}\u8B62\u{26402}\u{2644A}"],
      ["9c40", "\u5D5B\u{26BF7}\u8F36\u{26484}\u{2191C}\u8AEA\u{249F6}\u{26488}\u{23FEF}\u{26512}\u4BC0\u{265BF}\u{266B5}\u{2271B}\u9465\u{257E1}\u6195\u5A27\u{2F8CD}\u4FBB\u56B9\u{24521}\u{266FC}\u4E6A\u{24934}\u9656\u6D8F\u{26CBD}\u3618\u8977\u{26799}\u{2686E}\u{26411}\u{2685E}\u71DF\u{268C7}\u7B42\u{290C0}\u{20A11}\u{26926}\u9104\u{26939}\u7A45\u9DF0\u{269FA}\u9A26\u{26A2D}\u365F\u{26469}\u{20021}\u7983\u{26A34}\u{26B5B}\u5D2C\u{23519}\u83CF\u{26B9D}\u46D0\u{26CA4}\u753B\u8865\u{26DAE}\u58B6"],
      ["9ca1", "\u371C\u{2258D}\u{2704B}\u{271CD}\u3C54\u{27280}\u{27285}\u9281\u{2217A}\u{2728B}\u9330\u{272E6}\u{249D0}\u6C39\u949F\u{27450}\u{20EF8}\u8827\u88F5\u{22926}\u{28473}\u{217B1}\u6EB8\u{24A2A}\u{21820}\u39A4\u36B9\u5C10\u79E3\u453F\u66B6\u{29CAD}\u{298A4}\u8943\u{277CC}\u{27858}\u56D6\u40DF\u{2160A}\u39A1\u{2372F}\u{280E8}\u{213C5}\u71AD\u8366\u{279DD}\u{291A8}\u5A67\u4CB7\u{270AF}\u{289AB}\u{279FD}\u{27A0A}\u{27B0B}\u{27D66}\u{2417A}\u7B43\u797E\u{28009}\u6FB5\u{2A2DF}\u6A03\u{28318}\u53A2\u{26E07}\u93BF\u6836\u975D\u{2816F}\u{28023}\u{269B5}\u{213ED}\u{2322F}\u{28048}\u5D85\u{28C30}\u{28083}\u5715\u9823\u{28949}\u5DAB\u{24988}\u65BE\u69D5\u53D2\u{24AA5}\u{23F81}\u3C11\u6736\u{28090}\u{280F4}\u{2812E}\u{21FA1}\u{2814F}"],
      ["9d40", "\u{28189}\u{281AF}\u{2821A}\u{28306}\u{2832F}\u{2838A}\u35CA\u{28468}\u{286AA}\u48FA\u63E6\u{28956}\u7808\u9255\u{289B8}\u43F2\u{289E7}\u43DF\u{289E8}\u{28B46}\u{28BD4}\u59F8\u{28C09}\u8F0B\u{28FC5}\u{290EC}\u7B51\u{29110}\u{2913C}\u3DF7\u{2915E}\u{24ACA}\u8FD0\u728F\u568B\u{294E7}\u{295E9}\u{295B0}\u{295B8}\u{29732}\u{298D1}\u{29949}\u{2996A}\u{299C3}\u{29A28}\u{29B0E}\u{29D5A}\u{29D9B}\u7E9F\u{29EF8}\u{29F23}\u4CA4\u9547\u{2A293}\u71A2\u{2A2FF}\u4D91\u9012\u{2A5CB}\u4D9C\u{20C9C}\u8FBE\u55C1"],
      ["9da1", "\u8FBA\u{224B0}\u8FB9\u{24A93}\u4509\u7E7F\u6F56\u6AB1\u4EEA\u34E4\u{28B2C}\u{2789D}\u373A\u8E80\u{217F5}\u{28024}\u{28B6C}\u{28B99}\u{27A3E}\u{266AF}\u3DEB\u{27655}\u{23CB7}\u{25635}\u{25956}\u4E9A\u{25E81}\u{26258}\u56BF\u{20E6D}\u8E0E\u5B6D\u{23E88}\u{24C9E}\u63DE\u62D0\u{217F6}\u{2187B}\u6530\u562D\u{25C4A}\u541A\u{25311}\u3DC6\u{29D98}\u4C7D\u5622\u561E\u7F49\u{25ED8}\u5975\u{23D40}\u8770\u4E1C\u{20FEA}\u{20D49}\u{236BA}\u8117\u9D5E\u8D18\u763B\u9C45\u764E\u77B9\u9345\u5432\u8148\u82F7\u5625\u8132\u8418\u80BD\u55EA\u7962\u5643\u5416\u{20E9D}\u35CE\u5605\u55F1\u66F1\u{282E2}\u362D\u7534\u55F0\u55BA\u5497\u5572\u{20C41}\u{20C96}\u5ED0\u{25148}\u{20E76}\u{22C62}"],
      ["9e40", "\u{20EA2}\u9EAB\u7D5A\u55DE\u{21075}\u629D\u976D\u5494\u8CCD\u71F6\u9176\u63FC\u63B9\u63FE\u5569\u{22B43}\u9C72\u{22EB3}\u519A\u34DF\u{20DA7}\u51A7\u544D\u551E\u5513\u7666\u8E2D\u{2688A}\u75B1\u80B6\u8804\u8786\u88C7\u81B6\u841C\u{210C1}\u44EC\u7304\u{24706}\u5B90\u830B\u{26893}\u567B\u{226F4}\u{27D2F}\u{241A3}\u{27D73}\u{26ED0}\u{272B6}\u9170\u{211D9}\u9208\u{23CFC}\u{2A6A9}\u{20EAC}\u{20EF9}\u7266\u{21CA2}\u474E\u{24FC2}\u{27FF9}\u{20FEB}\u40FA"],
      ["9ea1", "\u9C5D\u651F\u{22DA0}\u48F3\u{247E0}\u{29D7C}\u{20FEC}\u{20E0A}\u6062\u{275A3}\u{20FED}"],
      ["9ead", "\u{26048}\u{21187}\u71A3\u7E8E\u9D50\u4E1A\u4E04\u3577\u5B0D\u6CB2\u5367\u36AC\u39DC\u537D\u36A5\u{24618}\u589A\u{24B6E}\u822D\u544B\u57AA\u{25A95}\u{20979}"],
      ["9ec5", "\u3A52\u{22465}\u7374\u{29EAC}\u4D09\u9BED\u{23CFE}\u{29F30}\u4C5B\u{24FA9}\u{2959E}\u{29FDE}\u845C\u{23DB6}\u{272B2}\u{267B3}\u{23720}\u632E\u7D25\u{23EF7}\u{23E2C}\u3A2A\u9008\u52CC\u3E74\u367A\u45E9\u{2048E}\u7640\u5AF0\u{20EB6}\u787A\u{27F2E}\u58A7\u40BF\u567C\u9B8B\u5D74\u7654\u{2A434}\u9E85\u4CE1\u75F9\u37FB\u6119\u{230DA}\u{243F2}"],
      ["9ef5", "\u565D\u{212A9}\u57A7\u{24963}\u{29E06}\u5234\u{270AE}\u35AD\u6C4A\u9D7C"],
      ["9f40", "\u7C56\u9B39\u57DE\u{2176C}\u5C53\u64D3\u{294D0}\u{26335}\u{27164}\u86AD\u{20D28}\u{26D22}\u{24AE2}\u{20D71}"],
      ["9f4f", "\u51FE\u{21F0F}\u5D8E\u9703\u{21DD1}\u9E81\u904C\u7B1F\u9B02\u5CD1\u7BA3\u6268\u6335\u9AFF\u7BCF\u9B2A\u7C7E\u9B2E\u7C42\u7C86\u9C15\u7BFC\u9B09\u9F17\u9C1B\u{2493E}\u9F5A\u5573\u5BC3\u4FFD\u9E98\u4FF2\u5260\u3E06\u52D1\u5767\u5056\u59B7\u5E12\u97C8\u9DAB\u8F5C\u5469\u97B4\u9940\u97BA\u532C\u6130"],
      ["9fa1", "\u692C\u53DA\u9C0A\u9D02\u4C3B\u9641\u6980\u50A6\u7546\u{2176D}\u99DA\u5273"],
      ["9fae", "\u9159\u9681\u915C"],
      ["9fb2", "\u9151\u{28E97}\u637F\u{26D23}\u6ACA\u5611\u918E\u757A\u6285\u{203FC}\u734F\u7C70\u{25C21}\u{23CFD}"],
      ["9fc1", "\u{24919}\u76D6\u9B9D\u4E2A\u{20CD4}\u83BE\u8842"],
      ["9fc9", "\u5C4A\u69C0\u50ED\u577A\u521F\u5DF5\u4ECE\u6C31\u{201F2}\u4F39\u549C\u54DA\u529A\u8D82\u35FE\u5F0C\u35F3"],
      ["9fdb", "\u6B52\u917C\u9FA5\u9B97\u982E\u98B4\u9ABA\u9EA8\u9E84\u717A\u7B14"],
      ["9fe7", "\u6BFA\u8818\u7F78"],
      ["9feb", "\u5620\u{2A64A}\u8E77\u9F53"],
      ["9ff0", "\u8DD4\u8E4F\u9E1C\u8E01\u6282\u{2837D}\u8E28\u8E75\u7AD3\u{24A77}\u7A3E\u78D8\u6CEA\u8A67\u7607"],
      ["a040", "\u{28A5A}\u9F26\u6CCE\u87D6\u75C3\u{2A2B2}\u7853\u{2F840}\u8D0C\u72E2\u7371\u8B2D\u7302\u74F1\u8CEB\u{24ABB}\u862F\u5FBA\u88A0\u44B7"],
      ["a055", "\u{2183B}\u{26E05}"],
      ["a058", "\u8A7E\u{2251B}"],
      ["a05b", "\u60FD\u7667\u9AD7\u9D44\u936E\u9B8F\u87F5"],
      ["a063", "\u880F\u8CF7\u732C\u9721\u9BB0\u35D6\u72B2\u4C07\u7C51\u994A\u{26159}\u6159\u4C04\u9E96\u617D"],
      ["a073", "\u575F\u616F\u62A6\u6239\u62CE\u3A5C\u61E2\u53AA\u{233F5}\u6364\u6802\u35D2"],
      ["a0a1", "\u5D57\u{28BC2}\u8FDA\u{28E39}"],
      ["a0a6", "\u50D9\u{21D46}\u7906\u5332\u9638\u{20F3B}\u4065"],
      ["a0ae", "\u77FE"],
      ["a0b0", "\u7CC2\u{25F1A}\u7CDA\u7A2D\u8066\u8063\u7D4D\u7505\u74F2\u8994\u821A\u670C\u8062\u{27486}\u805B\u74F0\u8103\u7724\u8989\u{267CC}\u7553\u{26ED1}\u87A9\u87CE\u81C8\u878C\u8A49\u8CAD\u8B43\u772B\u74F8\u84DA\u3635\u69B2\u8DA6"],
      ["a0d4", "\u89A9\u7468\u6DB9\u87C1\u{24011}\u74E7\u3DDB\u7176\u60A4\u619C\u3CD1\u7162\u6077"],
      ["a0e2", "\u7F71\u{28B2D}\u7250\u60E9\u4B7E\u5220\u3C18\u{23CC7}\u{25ED7}\u{27656}\u{25531}\u{21944}\u{212FE}\u{29903}\u{26DDC}\u{270AD}\u5CC1\u{261AD}\u{28A0F}\u{23677}\u{200EE}\u{26846}\u{24F0E}\u4562\u5B1F\u{2634C}\u9F50\u9EA6\u{2626B}"],
      ["a3c0", "\u2400", 31, "\u2421"],
      ["c6a1", "\u2460", 9, "\u2474", 9, "\u2170", 9, "\u4E36\u4E3F\u4E85\u4EA0\u5182\u5196\u51AB\u52F9\u5338\u5369\u53B6\u590A\u5B80\u5DDB\u2F33\u5E7F\u5EF4\u5F50\u5F61\u6534\u65E0\u7592\u7676\u8FB5\u96B6\xA8\u02C6\u30FD\u30FE\u309D\u309E\u3003\u4EDD\u3005\u3006\u3007\u30FC\uFF3B\uFF3D\u273D\u3041", 23],
      ["c740", "\u3059", 58, "\u30A1\u30A2\u30A3\u30A4"],
      ["c7a1", "\u30A5", 81, "\u0410", 5, "\u0401\u0416", 4],
      ["c840", "\u041B", 26, "\u0451\u0436", 25, "\u21E7\u21B8\u21B9\u31CF\u{200CC}\u4E5A\u{2008A}\u5202\u4491"],
      ["c8a1", "\u9FB0\u5188\u9FB1\u{27607}"],
      ["c8cd", "\uFFE2\uFFE4\uFF07\uFF02\u3231\u2116\u2121\u309B\u309C\u2E80\u2E84\u2E86\u2E87\u2E88\u2E8A\u2E8C\u2E8D\u2E95\u2E9C\u2E9D\u2EA5\u2EA7\u2EAA\u2EAC\u2EAE\u2EB6\u2EBC\u2EBE\u2EC6\u2ECA\u2ECC\u2ECD\u2ECF\u2ED6\u2ED7\u2EDE\u2EE3"],
      ["c8f5", "\u0283\u0250\u025B\u0254\u0275\u0153\xF8\u014B\u028A\u026A"],
      ["f9fe", "\uFFED"],
      ["fa40", "\u{20547}\u92DB\u{205DF}\u{23FC5}\u854C\u42B5\u73EF\u51B5\u3649\u{24942}\u{289E4}\u9344\u{219DB}\u82EE\u{23CC8}\u783C\u6744\u62DF\u{24933}\u{289AA}\u{202A0}\u{26BB3}\u{21305}\u4FAB\u{224ED}\u5008\u{26D29}\u{27A84}\u{23600}\u{24AB1}\u{22513}\u5029\u{2037E}\u5FA4\u{20380}\u{20347}\u6EDB\u{2041F}\u507D\u5101\u347A\u510E\u986C\u3743\u8416\u{249A4}\u{20487}\u5160\u{233B4}\u516A\u{20BFF}\u{220FC}\u{202E5}\u{22530}\u{2058E}\u{23233}\u{21983}\u5B82\u877D\u{205B3}\u{23C99}\u51B2\u51B8"],
      ["faa1", "\u9D34\u51C9\u51CF\u51D1\u3CDC\u51D3\u{24AA6}\u51B3\u51E2\u5342\u51ED\u83CD\u693E\u{2372D}\u5F7B\u520B\u5226\u523C\u52B5\u5257\u5294\u52B9\u52C5\u7C15\u8542\u52E0\u860D\u{26B13}\u5305\u{28ADE}\u5549\u6ED9\u{23F80}\u{20954}\u{23FEC}\u5333\u5344\u{20BE2}\u6CCB\u{21726}\u681B\u73D5\u604A\u3EAA\u38CC\u{216E8}\u71DD\u44A2\u536D\u5374\u{286AB}\u537E\u537F\u{21596}\u{21613}\u77E6\u5393\u{28A9B}\u53A0\u53AB\u53AE\u73A7\u{25772}\u3F59\u739C\u53C1\u53C5\u6C49\u4E49\u57FE\u53D9\u3AAB\u{20B8F}\u53E0\u{23FEB}\u{22DA3}\u53F6\u{20C77}\u5413\u7079\u552B\u6657\u6D5B\u546D\u{26B53}\u{20D74}\u555D\u548F\u54A4\u47A6\u{2170D}\u{20EDD}\u3DB4\u{20D4D}"],
      ["fb40", "\u{289BC}\u{22698}\u5547\u4CED\u542F\u7417\u5586\u55A9\u5605\u{218D7}\u{2403A}\u4552\u{24435}\u66B3\u{210B4}\u5637\u66CD\u{2328A}\u66A4\u66AD\u564D\u564F\u78F1\u56F1\u9787\u53FE\u5700\u56EF\u56ED\u{28B66}\u3623\u{2124F}\u5746\u{241A5}\u6C6E\u708B\u5742\u36B1\u{26C7E}\u57E6\u{21416}\u5803\u{21454}\u{24363}\u5826\u{24BF5}\u585C\u58AA\u3561\u58E0\u58DC\u{2123C}\u58FB\u5BFF\u5743\u{2A150}\u{24278}\u93D3\u35A1\u591F\u68A6\u36C3\u6E59"],
      ["fba1", "\u{2163E}\u5A24\u5553\u{21692}\u8505\u59C9\u{20D4E}\u{26C81}\u{26D2A}\u{217DC}\u59D9\u{217FB}\u{217B2}\u{26DA6}\u6D71\u{21828}\u{216D5}\u59F9\u{26E45}\u5AAB\u5A63\u36E6\u{249A9}\u5A77\u3708\u5A96\u7465\u5AD3\u{26FA1}\u{22554}\u3D85\u{21911}\u3732\u{216B8}\u5E83\u52D0\u5B76\u6588\u5B7C\u{27A0E}\u4004\u485D\u{20204}\u5BD5\u6160\u{21A34}\u{259CC}\u{205A5}\u5BF3\u5B9D\u4D10\u5C05\u{21B44}\u5C13\u73CE\u5C14\u{21CA5}\u{26B28}\u5C49\u48DD\u5C85\u5CE9\u5CEF\u5D8B\u{21DF9}\u{21E37}\u5D10\u5D18\u5D46\u{21EA4}\u5CBA\u5DD7\u82FC\u382D\u{24901}\u{22049}\u{22173}\u8287\u3836\u3BC2\u5E2E\u6A8A\u5E75\u5E7A\u{244BC}\u{20CD3}\u53A6\u4EB7\u5ED0\u53A8\u{21771}\u5E09\u5EF4\u{28482}"],
      ["fc40", "\u5EF9\u5EFB\u38A0\u5EFC\u683E\u941B\u5F0D\u{201C1}\u{2F894}\u3ADE\u48AE\u{2133A}\u5F3A\u{26888}\u{223D0}\u5F58\u{22471}\u5F63\u97BD\u{26E6E}\u5F72\u9340\u{28A36}\u5FA7\u5DB6\u3D5F\u{25250}\u{21F6A}\u{270F8}\u{22668}\u91D6\u{2029E}\u{28A29}\u6031\u6685\u{21877}\u3963\u3DC7\u3639\u5790\u{227B4}\u7971\u3E40\u609E\u60A4\u60B3\u{24982}\u{2498F}\u{27A53}\u74A4\u50E1\u5AA0\u6164\u8424\u6142\u{2F8A6}\u{26ED2}\u6181\u51F4\u{20656}\u6187\u5BAA\u{23FB7}"],
      ["fca1", "\u{2285F}\u61D3\u{28B9D}\u{2995D}\u61D0\u3932\u{22980}\u{228C1}\u6023\u615C\u651E\u638B\u{20118}\u62C5\u{21770}\u62D5\u{22E0D}\u636C\u{249DF}\u3A17\u6438\u63F8\u{2138E}\u{217FC}\u6490\u6F8A\u{22E36}\u9814\u{2408C}\u{2571D}\u64E1\u64E5\u947B\u3A66\u643A\u3A57\u654D\u6F16\u{24A28}\u{24A23}\u6585\u656D\u655F\u{2307E}\u65B5\u{24940}\u4B37\u65D1\u40D8\u{21829}\u65E0\u65E3\u5FDF\u{23400}\u6618\u{231F7}\u{231F8}\u6644\u{231A4}\u{231A5}\u664B\u{20E75}\u6667\u{251E6}\u6673\u6674\u{21E3D}\u{23231}\u{285F4}\u{231C8}\u{25313}\u77C5\u{228F7}\u99A4\u6702\u{2439C}\u{24A21}\u3B2B\u69FA\u{237C2}\u675E\u6767\u6762\u{241CD}\u{290ED}\u67D7\u44E9\u6822\u6E50\u923C\u6801\u{233E6}\u{26DA0}\u685D"],
      ["fd40", "\u{2346F}\u69E1\u6A0B\u{28ADF}\u6973\u68C3\u{235CD}\u6901\u6900\u3D32\u3A01\u{2363C}\u3B80\u67AC\u6961\u{28A4A}\u42FC\u6936\u6998\u3BA1\u{203C9}\u8363\u5090\u69F9\u{23659}\u{2212A}\u6A45\u{23703}\u6A9D\u3BF3\u67B1\u6AC8\u{2919C}\u3C0D\u6B1D\u{20923}\u60DE\u6B35\u6B74\u{227CD}\u6EB5\u{23ADB}\u{203B5}\u{21958}\u3740\u5421\u{23B5A}\u6BE1\u{23EFC}\u6BDC\u6C37\u{2248B}\u{248F1}\u{26B51}\u6C5A\u8226\u6C79\u{23DBC}\u44C5\u{23DBD}\u{241A4}\u{2490C}\u{24900}"],
      ["fda1", "\u{23CC9}\u36E5\u3CEB\u{20D32}\u9B83\u{231F9}\u{22491}\u7F8F\u6837\u{26D25}\u{26DA1}\u{26DEB}\u6D96\u6D5C\u6E7C\u6F04\u{2497F}\u{24085}\u{26E72}\u8533\u{26F74}\u51C7\u6C9C\u6E1D\u842E\u{28B21}\u6E2F\u{23E2F}\u7453\u{23F82}\u79CC\u6E4F\u5A91\u{2304B}\u6FF8\u370D\u6F9D\u{23E30}\u6EFA\u{21497}\u{2403D}\u4555\u93F0\u6F44\u6F5C\u3D4E\u6F74\u{29170}\u3D3B\u6F9F\u{24144}\u6FD3\u{24091}\u{24155}\u{24039}\u{23FF0}\u{23FB4}\u{2413F}\u51DF\u{24156}\u{24157}\u{24140}\u{261DD}\u704B\u707E\u70A7\u7081\u70CC\u70D5\u70D6\u70DF\u4104\u3DE8\u71B4\u7196\u{24277}\u712B\u7145\u5A88\u714A\u716E\u5C9C\u{24365}\u714F\u9362\u{242C1}\u712C\u{2445A}\u{24A27}\u{24A22}\u71BA\u{28BE8}\u70BD\u720E"],
      ["fe40", "\u9442\u7215\u5911\u9443\u7224\u9341\u{25605}\u722E\u7240\u{24974}\u68BD\u7255\u7257\u3E55\u{23044}\u680D\u6F3D\u7282\u732A\u732B\u{24823}\u{2882B}\u48ED\u{28804}\u7328\u732E\u73CF\u73AA\u{20C3A}\u{26A2E}\u73C9\u7449\u{241E2}\u{216E7}\u{24A24}\u6623\u36C5\u{249B7}\u{2498D}\u{249FB}\u73F7\u7415\u6903\u{24A26}\u7439\u{205C3}\u3ED7\u745C\u{228AD}\u7460\u{28EB2}\u7447\u73E4\u7476\u83B9\u746C\u3730\u7474\u93F1\u6A2C\u7482\u4953\u{24A8C}"],
      ["fea1", "\u{2415F}\u{24A79}\u{28B8F}\u5B46\u{28C03}\u{2189E}\u74C8\u{21988}\u750E\u74E9\u751E\u{28ED9}\u{21A4B}\u5BD7\u{28EAC}\u9385\u754D\u754A\u7567\u756E\u{24F82}\u3F04\u{24D13}\u758E\u745D\u759E\u75B4\u7602\u762C\u7651\u764F\u766F\u7676\u{263F5}\u7690\u81EF\u37F8\u{26911}\u{2690E}\u76A1\u76A5\u76B7\u76CC\u{26F9F}\u8462\u{2509D}\u{2517D}\u{21E1C}\u771E\u7726\u7740\u64AF\u{25220}\u7758\u{232AC}\u77AF\u{28964}\u{28968}\u{216C1}\u77F4\u7809\u{21376}\u{24A12}\u68CA\u78AF\u78C7\u78D3\u96A5\u792E\u{255E0}\u78D7\u7934\u78B1\u{2760C}\u8FB8\u8884\u{28B2B}\u{26083}\u{2261C}\u7986\u8900\u6902\u7980\u{25857}\u799D\u{27B39}\u793C\u79A9\u6E2A\u{27126}\u3EA8\u79C6\u{2910D}\u79D4"]
    ];
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/dbcs-data.js
var require_dbcs_data = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/dbcs-data.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = {
      // == Japanese/ShiftJIS ====================================================
      // All japanese encodings are based on JIS X set of standards:
      // JIS X 0201 - Single-byte encoding of ASCII + ¥ + Kana chars at 0xA1-0xDF.
      // JIS X 0208 - Main set of 6879 characters, placed in 94x94 plane, to be encoded by 2 bytes. 
      //              Has several variations in 1978, 1983, 1990 and 1997.
      // JIS X 0212 - Supplementary plane of 6067 chars in 94x94 plane. 1990. Effectively dead.
      // JIS X 0213 - Extension and modern replacement of 0208 and 0212. Total chars: 11233.
      //              2 planes, first is superset of 0208, second - revised 0212.
      //              Introduced in 2000, revised 2004. Some characters are in Unicode Plane 2 (0x2xxxx)
      // Byte encodings are:
      //  * Shift_JIS: Compatible with 0201, uses not defined chars in top half as lead bytes for double-byte
      //               encoding of 0208. Lead byte ranges: 0x81-0x9F, 0xE0-0xEF; Trail byte ranges: 0x40-0x7E, 0x80-0x9E, 0x9F-0xFC.
      //               Windows CP932 is a superset of Shift_JIS. Some companies added more chars, notably KDDI.
      //  * EUC-JP:    Up to 3 bytes per character. Used mostly on *nixes.
      //               0x00-0x7F       - lower part of 0201
      //               0x8E, 0xA1-0xDF - upper part of 0201
      //               (0xA1-0xFE)x2   - 0208 plane (94x94).
      //               0x8F, (0xA1-0xFE)x2 - 0212 plane (94x94).
      //  * JIS X 208: 7-bit, direct encoding of 0208. Byte ranges: 0x21-0x7E (94 values). Uncommon.
      //               Used as-is in ISO2022 family.
      //  * ISO2022-JP: Stateful encoding, with escape sequences to switch between ASCII, 
      //                0201-1976 Roman, 0208-1978, 0208-1983.
      //  * ISO2022-JP-1: Adds esc seq for 0212-1990.
      //  * ISO2022-JP-2: Adds esc seq for GB2313-1980, KSX1001-1992, ISO8859-1, ISO8859-7.
      //  * ISO2022-JP-3: Adds esc seq for 0201-1976 Kana set, 0213-2000 Planes 1, 2.
      //  * ISO2022-JP-2004: Adds 0213-2004 Plane 1.
      //
      // After JIS X 0213 appeared, Shift_JIS-2004, EUC-JISX0213 and ISO2022-JP-2004 followed, with just changing the planes.
      //
      // Overall, it seems that it's a mess :( http://www8.plala.or.jp/tkubota1/unicode-symbols-map2.html
      shiftjis: {
        type: "_dbcs",
        table: function() {
          return require_shiftjis();
        },
        encodeAdd: { "\xA5": 92, "\u203E": 126 },
        encodeSkipVals: [{ from: 60736, to: 63808 }]
      },
      csshiftjis: "shiftjis",
      mskanji: "shiftjis",
      sjis: "shiftjis",
      windows31j: "shiftjis",
      ms31j: "shiftjis",
      xsjis: "shiftjis",
      windows932: "shiftjis",
      ms932: "shiftjis",
      932: "shiftjis",
      cp932: "shiftjis",
      eucjp: {
        type: "_dbcs",
        table: function() {
          return require_eucjp();
        },
        encodeAdd: { "\xA5": 92, "\u203E": 126 }
      },
      // TODO: KDDI extension to Shift_JIS
      // TODO: IBM CCSID 942 = CP932, but F0-F9 custom chars and other char changes.
      // TODO: IBM CCSID 943 = Shift_JIS = CP932 with original Shift_JIS lower 128 chars.
      // == Chinese/GBK ==========================================================
      // http://en.wikipedia.org/wiki/GBK
      // We mostly implement W3C recommendation: https://www.w3.org/TR/encoding/#gbk-encoder
      // Oldest GB2312 (1981, ~7600 chars) is a subset of CP936
      gb2312: "cp936",
      gb231280: "cp936",
      gb23121980: "cp936",
      csgb2312: "cp936",
      csiso58gb231280: "cp936",
      euccn: "cp936",
      // Microsoft's CP936 is a subset and approximation of GBK.
      windows936: "cp936",
      ms936: "cp936",
      936: "cp936",
      cp936: {
        type: "_dbcs",
        table: function() {
          return require_cp936();
        }
      },
      // GBK (~22000 chars) is an extension of CP936 that added user-mapped chars and some other.
      gbk: {
        type: "_dbcs",
        table: function() {
          return require_cp936().concat(require_gbk_added());
        }
      },
      xgbk: "gbk",
      isoir58: "gbk",
      // GB18030 is an algorithmic extension of GBK.
      // Main source: https://www.w3.org/TR/encoding/#gbk-encoder
      // http://icu-project.org/docs/papers/gb18030.html
      // http://source.icu-project.org/repos/icu/data/trunk/charset/data/xml/gb-18030-2000.xml
      // http://www.khngai.com/chinese/charmap/tblgbk.php?page=0
      gb18030: {
        type: "_dbcs",
        table: function() {
          return require_cp936().concat(require_gbk_added());
        },
        gb18030: function() {
          return require_gb18030_ranges();
        },
        encodeSkipVals: [128],
        encodeAdd: { "\u20AC": 41699 }
      },
      chinese: "gb18030",
      // == Korean ===============================================================
      // EUC-KR, KS_C_5601 and KS X 1001 are exactly the same.
      windows949: "cp949",
      ms949: "cp949",
      949: "cp949",
      cp949: {
        type: "_dbcs",
        table: function() {
          return require_cp949();
        }
      },
      cseuckr: "cp949",
      csksc56011987: "cp949",
      euckr: "cp949",
      isoir149: "cp949",
      korean: "cp949",
      ksc56011987: "cp949",
      ksc56011989: "cp949",
      ksc5601: "cp949",
      // == Big5/Taiwan/Hong Kong ================================================
      // There are lots of tables for Big5 and cp950. Please see the following links for history:
      // http://moztw.org/docs/big5/  http://www.haible.de/bruno/charsets/conversion-tables/Big5.html
      // Variations, in roughly number of defined chars:
      //  * Windows CP 950: Microsoft variant of Big5. Canonical: http://www.unicode.org/Public/MAPPINGS/VENDORS/MICSFT/WINDOWS/CP950.TXT
      //  * Windows CP 951: Microsoft variant of Big5-HKSCS-2001. Seems to be never public. http://me.abelcheung.org/articles/research/what-is-cp951/
      //  * Big5-2003 (Taiwan standard) almost superset of cp950.
      //  * Unicode-at-on (UAO) / Mozilla 1.8. Falling out of use on the Web. Not supported by other browsers.
      //  * Big5-HKSCS (-2001, -2004, -2008). Hong Kong standard. 
      //    many unicode code points moved from PUA to Supplementary plane (U+2XXXX) over the years.
      //    Plus, it has 4 combining sequences.
      //    Seems that Mozilla refused to support it for 10 yrs. https://bugzilla.mozilla.org/show_bug.cgi?id=162431 https://bugzilla.mozilla.org/show_bug.cgi?id=310299
      //    because big5-hkscs is the only encoding to include astral characters in non-algorithmic way.
      //    Implementations are not consistent within browsers; sometimes labeled as just big5.
      //    MS Internet Explorer switches from big5 to big5-hkscs when a patch applied.
      //    Great discussion & recap of what's going on https://bugzilla.mozilla.org/show_bug.cgi?id=912470#c31
      //    In the encoder, it might make sense to support encoding old PUA mappings to Big5 bytes seq-s.
      //    Official spec: http://www.ogcio.gov.hk/en/business/tech_promotion/ccli/terms/doc/2003cmp_2008.txt
      //                   http://www.ogcio.gov.hk/tc/business/tech_promotion/ccli/terms/doc/hkscs-2008-big5-iso.txt
      // 
      // Current understanding of how to deal with Big5(-HKSCS) is in the Encoding Standard, http://encoding.spec.whatwg.org/#big5-encoder
      // Unicode mapping (http://www.unicode.org/Public/MAPPINGS/OBSOLETE/EASTASIA/OTHER/BIG5.TXT) is said to be wrong.
      windows950: "cp950",
      ms950: "cp950",
      950: "cp950",
      cp950: {
        type: "_dbcs",
        table: function() {
          return require_cp950();
        }
      },
      // Big5 has many variations and is an extension of cp950. We use Encoding Standard's as a consensus.
      big5: "big5hkscs",
      big5hkscs: {
        type: "_dbcs",
        table: function() {
          return require_cp950().concat(require_big5_added());
        },
        encodeSkipVals: [41676]
      },
      cnbig5: "big5hkscs",
      csbig5: "big5hkscs",
      xxbig5: "big5hkscs"
    };
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/index.js
var require_encodings = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/encodings/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var modules = [
      require_internal(),
      require_utf16(),
      require_utf7(),
      require_sbcs_codec(),
      require_sbcs_data(),
      require_sbcs_data_generated(),
      require_dbcs_codec(),
      require_dbcs_data()
    ];
    for (i = 0; i < modules.length; i++) {
      module = modules[i];
      for (enc in module)
        Object.prototype.hasOwnProperty.call(module, enc) && (exports[enc] = module[enc]);
    }
    var module, enc, i;
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/lib/streams.js
var require_streams = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/lib/streams.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Buffer2 = __require("buffer").Buffer, Transform = __require("stream").Transform;
    module.exports = function(iconv) {
      iconv.encodeStream = function(encoding, options) {
        return new IconvLiteEncoderStream(iconv.getEncoder(encoding, options), options);
      }, iconv.decodeStream = function(encoding, options) {
        return new IconvLiteDecoderStream(iconv.getDecoder(encoding, options), options);
      }, iconv.supportsStreams = !0, iconv.IconvLiteEncoderStream = IconvLiteEncoderStream, iconv.IconvLiteDecoderStream = IconvLiteDecoderStream, iconv._collect = IconvLiteDecoderStream.prototype.collect;
    };
    function IconvLiteEncoderStream(conv, options) {
      this.conv = conv, options = options || {}, options.decodeStrings = !1, Transform.call(this, options);
    }
    IconvLiteEncoderStream.prototype = Object.create(Transform.prototype, {
      constructor: { value: IconvLiteEncoderStream }
    });
    IconvLiteEncoderStream.prototype._transform = function(chunk, encoding, done) {
      if (typeof chunk != "string")
        return done(new Error("Iconv encoding stream needs strings as its input."));
      try {
        var res = this.conv.write(chunk);
        res && res.length && this.push(res), done();
      } catch (e) {
        done(e);
      }
    };
    IconvLiteEncoderStream.prototype._flush = function(done) {
      try {
        var res = this.conv.end();
        res && res.length && this.push(res), done();
      } catch (e) {
        done(e);
      }
    };
    IconvLiteEncoderStream.prototype.collect = function(cb) {
      var chunks = [];
      return this.on("error", cb), this.on("data", function(chunk) {
        chunks.push(chunk);
      }), this.on("end", function() {
        cb(null, Buffer2.concat(chunks));
      }), this;
    };
    function IconvLiteDecoderStream(conv, options) {
      this.conv = conv, options = options || {}, options.encoding = this.encoding = "utf8", Transform.call(this, options);
    }
    IconvLiteDecoderStream.prototype = Object.create(Transform.prototype, {
      constructor: { value: IconvLiteDecoderStream }
    });
    IconvLiteDecoderStream.prototype._transform = function(chunk, encoding, done) {
      if (!Buffer2.isBuffer(chunk))
        return done(new Error("Iconv decoding stream needs buffers as its input."));
      try {
        var res = this.conv.write(chunk);
        res && res.length && this.push(res, this.encoding), done();
      } catch (e) {
        done(e);
      }
    };
    IconvLiteDecoderStream.prototype._flush = function(done) {
      try {
        var res = this.conv.end();
        res && res.length && this.push(res, this.encoding), done();
      } catch (e) {
        done(e);
      }
    };
    IconvLiteDecoderStream.prototype.collect = function(cb) {
      var res = "";
      return this.on("error", cb), this.on("data", function(chunk) {
        res += chunk;
      }), this.on("end", function() {
        cb(null, res);
      }), this;
    };
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/lib/extend-node.js
var require_extend_node = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/lib/extend-node.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Buffer2 = __require("buffer").Buffer;
    module.exports = function(iconv) {
      var original = void 0;
      iconv.supportsNodeEncodingsExtension = !(Buffer2.from || new Buffer2(0) instanceof Uint8Array), iconv.extendNodeEncodings = function() {
        if (!original) {
          if (original = {}, !iconv.supportsNodeEncodingsExtension) {
            console.error("ACTION NEEDED: require('iconv-lite').extendNodeEncodings() is not supported in your version of Node"), console.error("See more info at https://github.com/ashtuchkin/iconv-lite/wiki/Node-v4-compatibility");
            return;
          }
          var nodeNativeEncodings = {
            hex: !0,
            utf8: !0,
            "utf-8": !0,
            ascii: !0,
            binary: !0,
            base64: !0,
            ucs2: !0,
            "ucs-2": !0,
            utf16le: !0,
            "utf-16le": !0
          };
          Buffer2.isNativeEncoding = function(enc) {
            return enc && nodeNativeEncodings[enc.toLowerCase()];
          };
          var SlowBuffer = __require("buffer").SlowBuffer;
          if (original.SlowBufferToString = SlowBuffer.prototype.toString, SlowBuffer.prototype.toString = function(encoding, start, end) {
            return encoding = String(encoding || "utf8").toLowerCase(), Buffer2.isNativeEncoding(encoding) ? original.SlowBufferToString.call(this, encoding, start, end) : (typeof start > "u" && (start = 0), typeof end > "u" && (end = this.length), iconv.decode(this.slice(start, end), encoding));
          }, original.SlowBufferWrite = SlowBuffer.prototype.write, SlowBuffer.prototype.write = function(string, offset, length, encoding) {
            if (isFinite(offset))
              isFinite(length) || (encoding = length, length = void 0);
            else {
              var swap = encoding;
              encoding = offset, offset = length, length = swap;
            }
            offset = +offset || 0;
            var remaining = this.length - offset;
            if (length ? (length = +length, length > remaining && (length = remaining)) : length = remaining, encoding = String(encoding || "utf8").toLowerCase(), Buffer2.isNativeEncoding(encoding))
              return original.SlowBufferWrite.call(this, string, offset, length, encoding);
            if (string.length > 0 && (length < 0 || offset < 0))
              throw new RangeError("attempt to write beyond buffer bounds");
            var buf = iconv.encode(string, encoding);
            return buf.length < length && (length = buf.length), buf.copy(this, offset, 0, length), length;
          }, original.BufferIsEncoding = Buffer2.isEncoding, Buffer2.isEncoding = function(encoding) {
            return Buffer2.isNativeEncoding(encoding) || iconv.encodingExists(encoding);
          }, original.BufferByteLength = Buffer2.byteLength, Buffer2.byteLength = SlowBuffer.byteLength = function(str, encoding) {
            return encoding = String(encoding || "utf8").toLowerCase(), Buffer2.isNativeEncoding(encoding) ? original.BufferByteLength.call(this, str, encoding) : iconv.encode(str, encoding).length;
          }, original.BufferToString = Buffer2.prototype.toString, Buffer2.prototype.toString = function(encoding, start, end) {
            return encoding = String(encoding || "utf8").toLowerCase(), Buffer2.isNativeEncoding(encoding) ? original.BufferToString.call(this, encoding, start, end) : (typeof start > "u" && (start = 0), typeof end > "u" && (end = this.length), iconv.decode(this.slice(start, end), encoding));
          }, original.BufferWrite = Buffer2.prototype.write, Buffer2.prototype.write = function(string, offset, length, encoding) {
            var _offset = offset, _length = length, _encoding = encoding;
            if (isFinite(offset))
              isFinite(length) || (encoding = length, length = void 0);
            else {
              var swap = encoding;
              encoding = offset, offset = length, length = swap;
            }
            if (encoding = String(encoding || "utf8").toLowerCase(), Buffer2.isNativeEncoding(encoding))
              return original.BufferWrite.call(this, string, _offset, _length, _encoding);
            offset = +offset || 0;
            var remaining = this.length - offset;
            if (length ? (length = +length, length > remaining && (length = remaining)) : length = remaining, string.length > 0 && (length < 0 || offset < 0))
              throw new RangeError("attempt to write beyond buffer bounds");
            var buf = iconv.encode(string, encoding);
            return buf.length < length && (length = buf.length), buf.copy(this, offset, 0, length), length;
          }, iconv.supportsStreams) {
            var Readable = __require("stream").Readable;
            original.ReadableSetEncoding = Readable.prototype.setEncoding, Readable.prototype.setEncoding = function(enc, options) {
              this._readableState.decoder = iconv.getDecoder(enc, options), this._readableState.encoding = enc;
            }, Readable.prototype.collect = iconv._collect;
          }
        }
      }, iconv.undoExtendNodeEncodings = function() {
        if (iconv.supportsNodeEncodingsExtension) {
          if (!original)
            throw new Error("require('iconv-lite').undoExtendNodeEncodings(): Nothing to undo; extendNodeEncodings() is not called.");
          delete Buffer2.isNativeEncoding;
          var SlowBuffer = __require("buffer").SlowBuffer;
          if (SlowBuffer.prototype.toString = original.SlowBufferToString, SlowBuffer.prototype.write = original.SlowBufferWrite, Buffer2.isEncoding = original.BufferIsEncoding, Buffer2.byteLength = original.BufferByteLength, Buffer2.prototype.toString = original.BufferToString, Buffer2.prototype.write = original.BufferWrite, iconv.supportsStreams) {
            var Readable = __require("stream").Readable;
            Readable.prototype.setEncoding = original.ReadableSetEncoding, delete Readable.prototype.collect;
          }
          original = void 0;
        }
      };
    };
  }
});

// ../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/lib/index.js
var require_lib8 = __commonJS({
  "../../node_modules/.pnpm/iconv-lite@0.4.24/node_modules/iconv-lite/lib/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Buffer2 = require_safer().Buffer, bomHandling = require_bom_handling(), iconv = module.exports;
    iconv.encodings = null;
    iconv.defaultCharUnicode = "\uFFFD";
    iconv.defaultCharSingleByte = "?";
    iconv.encode = function(str, encoding, options) {
      str = "" + (str || "");
      var encoder = iconv.getEncoder(encoding, options), res = encoder.write(str), trail = encoder.end();
      return trail && trail.length > 0 ? Buffer2.concat([res, trail]) : res;
    };
    iconv.decode = function(buf, encoding, options) {
      typeof buf == "string" && (iconv.skipDecodeWarning || (console.error("Iconv-lite warning: decode()-ing strings is deprecated. Refer to https://github.com/ashtuchkin/iconv-lite/wiki/Use-Buffers-when-decoding"), iconv.skipDecodeWarning = !0), buf = Buffer2.from("" + (buf || ""), "binary"));
      var decoder = iconv.getDecoder(encoding, options), res = decoder.write(buf), trail = decoder.end();
      return trail ? res + trail : res;
    };
    iconv.encodingExists = function(enc) {
      try {
        return iconv.getCodec(enc), !0;
      } catch {
        return !1;
      }
    };
    iconv.toEncoding = iconv.encode;
    iconv.fromEncoding = iconv.decode;
    iconv._codecDataCache = {};
    iconv.getCodec = function(encoding) {
      iconv.encodings || (iconv.encodings = require_encodings());
      for (var enc = iconv._canonicalizeEncoding(encoding), codecOptions = {}; ; ) {
        var codec = iconv._codecDataCache[enc];
        if (codec)
          return codec;
        var codecDef = iconv.encodings[enc];
        switch (typeof codecDef) {
          case "string":
            enc = codecDef;
            break;
          case "object":
            for (var key in codecDef)
              codecOptions[key] = codecDef[key];
            codecOptions.encodingName || (codecOptions.encodingName = enc), enc = codecDef.type;
            break;
          case "function":
            return codecOptions.encodingName || (codecOptions.encodingName = enc), codec = new codecDef(codecOptions, iconv), iconv._codecDataCache[codecOptions.encodingName] = codec, codec;
          default:
            throw new Error("Encoding not recognized: '" + encoding + "' (searched as: '" + enc + "')");
        }
      }
    };
    iconv._canonicalizeEncoding = function(encoding) {
      return ("" + encoding).toLowerCase().replace(/:\d{4}$|[^0-9a-z]/g, "");
    };
    iconv.getEncoder = function(encoding, options) {
      var codec = iconv.getCodec(encoding), encoder = new codec.encoder(options, codec);
      return codec.bomAware && options && options.addBOM && (encoder = new bomHandling.PrependBOM(encoder, options)), encoder;
    };
    iconv.getDecoder = function(encoding, options) {
      var codec = iconv.getCodec(encoding), decoder = new codec.decoder(options, codec);
      return codec.bomAware && !(options && options.stripBOM === !1) && (decoder = new bomHandling.StripBOM(decoder, options)), decoder;
    };
    var nodeVer = typeof process < "u" && process.versions && process.versions.node;
    nodeVer && (nodeVerArr = nodeVer.split(".").map(Number), (nodeVerArr[0] > 0 || nodeVerArr[1] >= 10) && require_streams()(iconv), require_extend_node()(iconv));
    var nodeVerArr;
  }
});

// ../../node_modules/.pnpm/unpipe@1.0.0/node_modules/unpipe/index.js
var require_unpipe = __commonJS({
  "../../node_modules/.pnpm/unpipe@1.0.0/node_modules/unpipe/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = unpipe;
    function hasPipeDataListeners(stream2) {
      for (var listeners = stream2.listeners("data"), i = 0; i < listeners.length; i++)
        if (listeners[i].name === "ondata")
          return !0;
      return !1;
    }
    function unpipe(stream2) {
      if (!stream2)
        throw new TypeError("argument stream is required");
      if (typeof stream2.unpipe == "function") {
        stream2.unpipe();
        return;
      }
      if (hasPipeDataListeners(stream2))
        for (var listener, listeners = stream2.listeners("close"), i = 0; i < listeners.length; i++)
          listener = listeners[i], !(listener.name !== "cleanup" && listener.name !== "onclose") && listener.call(stream2);
    }
  }
});

// ../../node_modules/.pnpm/raw-body@2.5.2/node_modules/raw-body/index.js
var require_raw_body = __commonJS({
  "../../node_modules/.pnpm/raw-body@2.5.2/node_modules/raw-body/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var asyncHooks = tryRequireAsyncHooks(), bytes = require_bytes(), createError2 = require_http_errors(), iconv = require_lib8(), unpipe = require_unpipe();
    module.exports = getRawBody;
    var ICONV_ENCODING_MESSAGE_REGEXP = /^Encoding not recognized: /;
    function getDecoder(encoding) {
      if (!encoding)
        return null;
      try {
        return iconv.getDecoder(encoding);
      } catch (e) {
        throw ICONV_ENCODING_MESSAGE_REGEXP.test(e.message) ? createError2(415, "specified encoding unsupported", {
          encoding,
          type: "encoding.unsupported"
        }) : e;
      }
    }
    function getRawBody(stream2, options, callback) {
      var done = callback, opts = options || {};
      if (stream2 === void 0)
        throw new TypeError("argument stream is required");
      if (typeof stream2 != "object" || stream2 === null || typeof stream2.on != "function")
        throw new TypeError("argument stream must be a stream");
      if ((options === !0 || typeof options == "string") && (opts = {
        encoding: options
      }), typeof options == "function" && (done = options, opts = {}), done !== void 0 && typeof done != "function")
        throw new TypeError("argument callback must be a function");
      if (!done && !global.Promise)
        throw new TypeError("argument callback is required");
      var encoding = opts.encoding !== !0 ? opts.encoding : "utf-8", limit = bytes.parse(opts.limit), length = opts.length != null && !isNaN(opts.length) ? parseInt(opts.length, 10) : null;
      return done ? readStream(stream2, encoding, length, limit, wrap(done)) : new Promise(function(resolve2, reject) {
        readStream(stream2, encoding, length, limit, function(err2, buf) {
          if (err2)
            return reject(err2);
          resolve2(buf);
        });
      });
    }
    function halt(stream2) {
      unpipe(stream2), typeof stream2.pause == "function" && stream2.pause();
    }
    function readStream(stream2, encoding, length, limit, callback) {
      var complete = !1, sync = !0;
      if (limit !== null && length !== null && length > limit)
        return done(createError2(413, "request entity too large", {
          expected: length,
          length,
          limit,
          type: "entity.too.large"
        }));
      var state = stream2._readableState;
      if (stream2._decoder || state && (state.encoding || state.decoder))
        return done(createError2(500, "stream encoding should not be set", {
          type: "stream.encoding.set"
        }));
      if (typeof stream2.readable < "u" && !stream2.readable)
        return done(createError2(500, "stream is not readable", {
          type: "stream.not.readable"
        }));
      var received = 0, decoder;
      try {
        decoder = getDecoder(encoding);
      } catch (err2) {
        return done(err2);
      }
      var buffer = decoder ? "" : [];
      stream2.on("aborted", onAborted), stream2.on("close", cleanup2), stream2.on("data", onData), stream2.on("end", onEnd), stream2.on("error", onEnd), sync = !1;
      function done() {
        for (var args = new Array(arguments.length), i = 0; i < args.length; i++)
          args[i] = arguments[i];
        complete = !0, sync ? process.nextTick(invokeCallback) : invokeCallback();
        function invokeCallback() {
          cleanup2(), args[0] && halt(stream2), callback.apply(null, args);
        }
      }
      function onAborted() {
        complete || done(createError2(400, "request aborted", {
          code: "ECONNABORTED",
          expected: length,
          length,
          received,
          type: "request.aborted"
        }));
      }
      function onData(chunk) {
        complete || (received += chunk.length, limit !== null && received > limit ? done(createError2(413, "request entity too large", {
          limit,
          received,
          type: "entity.too.large"
        })) : decoder ? buffer += decoder.write(chunk) : buffer.push(chunk));
      }
      function onEnd(err2) {
        if (!complete) {
          if (err2)
            return done(err2);
          if (length !== null && received !== length)
            done(createError2(400, "request size did not match content length", {
              expected: length,
              length,
              received,
              type: "request.size.invalid"
            }));
          else {
            var string = decoder ? buffer + (decoder.end() || "") : Buffer.concat(buffer);
            done(null, string);
          }
        }
      }
      function cleanup2() {
        buffer = null, stream2.removeListener("aborted", onAborted), stream2.removeListener("data", onData), stream2.removeListener("end", onEnd), stream2.removeListener("error", onEnd), stream2.removeListener("close", cleanup2);
      }
    }
    function tryRequireAsyncHooks() {
      try {
        return __require("async_hooks");
      } catch {
        return {};
      }
    }
    function wrap(fn) {
      var res;
      return asyncHooks.AsyncResource && (res = new asyncHooks.AsyncResource(fn.name || "bound-anonymous-fn")), !res || !res.runInAsyncScope ? fn : res.runInAsyncScope.bind(res, fn, null);
    }
  }
});

// ../../node_modules/.pnpm/ee-first@1.1.1/node_modules/ee-first/index.js
var require_ee_first = __commonJS({
  "../../node_modules/.pnpm/ee-first@1.1.1/node_modules/ee-first/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = first;
    function first(stuff, done) {
      if (!Array.isArray(stuff))
        throw new TypeError("arg must be an array of [ee, events...] arrays");
      for (var cleanups = [], i = 0; i < stuff.length; i++) {
        var arr = stuff[i];
        if (!Array.isArray(arr) || arr.length < 2)
          throw new TypeError("each array member must be [ee, events...]");
        for (var ee = arr[0], j = 1; j < arr.length; j++) {
          var event = arr[j], fn = listener(event, callback);
          ee.on(event, fn), cleanups.push({
            ee,
            event,
            fn
          });
        }
      }
      function callback() {
        cleanup2(), done.apply(null, arguments);
      }
      function cleanup2() {
        for (var x, i2 = 0; i2 < cleanups.length; i2++)
          x = cleanups[i2], x.ee.removeListener(x.event, x.fn);
      }
      function thunk(fn2) {
        done = fn2;
      }
      return thunk.cancel = cleanup2, thunk;
    }
    function listener(event, done) {
      return function(arg1) {
        for (var args = new Array(arguments.length), ee = this, err2 = event === "error" ? arg1 : null, i = 0; i < args.length; i++)
          args[i] = arguments[i];
        done(err2, ee, event, args);
      };
    }
  }
});

// ../../node_modules/.pnpm/on-finished@2.4.1/node_modules/on-finished/index.js
var require_on_finished = __commonJS({
  "../../node_modules/.pnpm/on-finished@2.4.1/node_modules/on-finished/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = onFinished;
    module.exports.isFinished = isFinished;
    var asyncHooks = tryRequireAsyncHooks(), first = require_ee_first(), defer2 = typeof setImmediate == "function" ? setImmediate : function(fn) {
      process.nextTick(fn.bind.apply(fn, arguments));
    };
    function onFinished(msg, listener) {
      return isFinished(msg) !== !1 ? (defer2(listener, null, msg), msg) : (attachListener(msg, wrap(listener)), msg);
    }
    function isFinished(msg) {
      var socket = msg.socket;
      if (typeof msg.finished == "boolean")
        return !!(msg.finished || socket && !socket.writable);
      if (typeof msg.complete == "boolean")
        return !!(msg.upgrade || !socket || !socket.readable || msg.complete && !msg.readable);
    }
    function attachFinishedListener(msg, callback) {
      var eeMsg, eeSocket, finished = !1;
      function onFinish(error) {
        eeMsg.cancel(), eeSocket.cancel(), finished = !0, callback(error);
      }
      eeMsg = eeSocket = first([[msg, "end", "finish"]], onFinish);
      function onSocket(socket) {
        msg.removeListener("socket", onSocket), !finished && eeMsg === eeSocket && (eeSocket = first([[socket, "error", "close"]], onFinish));
      }
      if (msg.socket) {
        onSocket(msg.socket);
        return;
      }
      msg.on("socket", onSocket), msg.socket === void 0 && patchAssignSocket(msg, onSocket);
    }
    function attachListener(msg, listener) {
      var attached = msg.__onFinished;
      (!attached || !attached.queue) && (attached = msg.__onFinished = createListener(msg), attachFinishedListener(msg, attached)), attached.queue.push(listener);
    }
    function createListener(msg) {
      function listener(err2) {
        if (msg.__onFinished === listener && (msg.__onFinished = null), !!listener.queue) {
          var queue = listener.queue;
          listener.queue = null;
          for (var i = 0; i < queue.length; i++)
            queue[i](err2, msg);
        }
      }
      return listener.queue = [], listener;
    }
    function patchAssignSocket(res, callback) {
      var assignSocket = res.assignSocket;
      typeof assignSocket == "function" && (res.assignSocket = function(socket) {
        assignSocket.call(this, socket), callback(socket);
      });
    }
    function tryRequireAsyncHooks() {
      try {
        return __require("async_hooks");
      } catch {
        return {};
      }
    }
    function wrap(fn) {
      var res;
      return asyncHooks.AsyncResource && (res = new asyncHooks.AsyncResource(fn.name || "bound-anonymous-fn")), !res || !res.runInAsyncScope ? fn : res.runInAsyncScope.bind(res, fn, null);
    }
  }
});

// ../../node_modules/.pnpm/body-parser@1.20.2/node_modules/body-parser/lib/read.js
var require_read = __commonJS({
  "../../node_modules/.pnpm/body-parser@1.20.2/node_modules/body-parser/lib/read.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var createError2 = require_http_errors(), destroy = require_destroy3(), getBody = require_raw_body(), iconv = require_lib8(), onFinished = require_on_finished(), unpipe = require_unpipe(), zlib = __require("zlib");
    module.exports = read;
    function read(req, res, next, parse4, debug4, options) {
      var length, opts = options, stream2;
      req._body = !0;
      var encoding = opts.encoding !== null ? opts.encoding : null, verify = opts.verify;
      try {
        stream2 = contentstream(req, debug4, opts.inflate), length = stream2.length, stream2.length = void 0;
      } catch (err2) {
        return next(err2);
      }
      if (opts.length = length, opts.encoding = verify ? null : encoding, opts.encoding === null && encoding !== null && !iconv.encodingExists(encoding))
        return next(createError2(415, 'unsupported charset "' + encoding.toUpperCase() + '"', {
          charset: encoding.toLowerCase(),
          type: "charset.unsupported"
        }));
      debug4("read body"), getBody(stream2, opts, function(error, body) {
        if (error) {
          var _error;
          error.type === "encoding.unsupported" ? _error = createError2(415, 'unsupported charset "' + encoding.toUpperCase() + '"', {
            charset: encoding.toLowerCase(),
            type: "charset.unsupported"
          }) : _error = createError2(400, error), stream2 !== req && (unpipe(req), destroy(stream2, !0)), dump(req, function() {
            next(createError2(400, _error));
          });
          return;
        }
        if (verify)
          try {
            debug4("verify body"), verify(req, res, body, encoding);
          } catch (err2) {
            next(createError2(403, err2, {
              body,
              type: err2.type || "entity.verify.failed"
            }));
            return;
          }
        var str = body;
        try {
          debug4("parse body"), str = typeof body != "string" && encoding !== null ? iconv.decode(body, encoding) : body, req.body = parse4(str);
        } catch (err2) {
          next(createError2(400, err2, {
            body: str,
            type: err2.type || "entity.parse.failed"
          }));
          return;
        }
        next();
      });
    }
    function contentstream(req, debug4, inflate) {
      var encoding = (req.headers["content-encoding"] || "identity").toLowerCase(), length = req.headers["content-length"], stream2;
      if (debug4('content-encoding "%s"', encoding), inflate === !1 && encoding !== "identity")
        throw createError2(415, "content encoding unsupported", {
          encoding,
          type: "encoding.unsupported"
        });
      switch (encoding) {
        case "deflate":
          stream2 = zlib.createInflate(), debug4("inflate body"), req.pipe(stream2);
          break;
        case "gzip":
          stream2 = zlib.createGunzip(), debug4("gunzip body"), req.pipe(stream2);
          break;
        case "identity":
          stream2 = req, stream2.length = length;
          break;
        default:
          throw createError2(415, 'unsupported content encoding "' + encoding + '"', {
            encoding,
            type: "encoding.unsupported"
          });
      }
      return stream2;
    }
    function dump(req, callback) {
      onFinished.isFinished(req) ? callback(null) : (onFinished(req, callback), req.resume());
    }
  }
});

// ../../node_modules/.pnpm/media-typer@0.3.0/node_modules/media-typer/index.js
var require_media_typer = __commonJS({
  "../../node_modules/.pnpm/media-typer@0.3.0/node_modules/media-typer/index.js"(exports) {
    init_cjs_shims();
    var paramRegExp = /; *([!#$%&'\*\+\-\.0-9A-Z\^_`a-z\|~]+) *= *("(?:[ !\u0023-\u005b\u005d-\u007e\u0080-\u00ff]|\\[\u0020-\u007e])*"|[!#$%&'\*\+\-\.0-9A-Z\^_`a-z\|~]+) */g, textRegExp = /^[\u0020-\u007e\u0080-\u00ff]+$/, tokenRegExp = /^[!#$%&'\*\+\-\.0-9A-Z\^_`a-z\|~]+$/, qescRegExp = /\\([\u0000-\u007f])/g, quoteRegExp = /([\\"])/g, subtypeNameRegExp = /^[A-Za-z0-9][A-Za-z0-9!#$&^_.-]{0,126}$/, typeNameRegExp = /^[A-Za-z0-9][A-Za-z0-9!#$&^_-]{0,126}$/, typeRegExp = /^ *([A-Za-z0-9][A-Za-z0-9!#$&^_-]{0,126})\/([A-Za-z0-9][A-Za-z0-9!#$&^_.+-]{0,126}) *$/;
    exports.format = format4;
    exports.parse = parse4;
    function format4(obj) {
      if (!obj || typeof obj != "object")
        throw new TypeError("argument obj is required");
      var parameters = obj.parameters, subtype = obj.subtype, suffix = obj.suffix, type = obj.type;
      if (!type || !typeNameRegExp.test(type))
        throw new TypeError("invalid type");
      if (!subtype || !subtypeNameRegExp.test(subtype))
        throw new TypeError("invalid subtype");
      var string = type + "/" + subtype;
      if (suffix) {
        if (!typeNameRegExp.test(suffix))
          throw new TypeError("invalid suffix");
        string += "+" + suffix;
      }
      if (parameters && typeof parameters == "object")
        for (var param, params = Object.keys(parameters).sort(), i = 0; i < params.length; i++) {
          if (param = params[i], !tokenRegExp.test(param))
            throw new TypeError("invalid parameter name");
          string += "; " + param + "=" + qstring(parameters[param]);
        }
      return string;
    }
    function parse4(string) {
      if (!string)
        throw new TypeError("argument string is required");
      if (typeof string == "object" && (string = getcontenttype(string)), typeof string != "string")
        throw new TypeError("argument string is required to be a string");
      var index = string.indexOf(";"), type = index !== -1 ? string.substr(0, index) : string, key, match2, obj = splitType(type), params = {}, value;
      for (paramRegExp.lastIndex = index; match2 = paramRegExp.exec(string); ) {
        if (match2.index !== index)
          throw new TypeError("invalid parameter format");
        index += match2[0].length, key = match2[1].toLowerCase(), value = match2[2], value[0] === '"' && (value = value.substr(1, value.length - 2).replace(qescRegExp, "$1")), params[key] = value;
      }
      if (index !== -1 && index !== string.length)
        throw new TypeError("invalid parameter format");
      return obj.parameters = params, obj;
    }
    function getcontenttype(obj) {
      if (typeof obj.getHeader == "function")
        return obj.getHeader("content-type");
      if (typeof obj.headers == "object")
        return obj.headers && obj.headers["content-type"];
    }
    function qstring(val) {
      var str = String(val);
      if (tokenRegExp.test(str))
        return str;
      if (str.length > 0 && !textRegExp.test(str))
        throw new TypeError("invalid parameter value");
      return '"' + str.replace(quoteRegExp, "\\$1") + '"';
    }
    function splitType(string) {
      var match2 = typeRegExp.exec(string.toLowerCase());
      if (!match2)
        throw new TypeError("invalid media type");
      var type = match2[1], subtype = match2[2], suffix, index = subtype.lastIndexOf("+");
      index !== -1 && (suffix = subtype.substr(index + 1), subtype = subtype.substr(0, index));
      var obj = {
        type,
        subtype,
        suffix
      };
      return obj;
    }
  }
});

// ../../node_modules/.pnpm/type-is@1.6.18/node_modules/type-is/index.js
var require_type_is = __commonJS({
  "../../node_modules/.pnpm/type-is@1.6.18/node_modules/type-is/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var typer = require_media_typer(), mime = require_mime_types();
    module.exports = typeofrequest;
    module.exports.is = typeis;
    module.exports.hasBody = hasbody;
    module.exports.normalize = normalize;
    module.exports.match = mimeMatch;
    function typeis(value, types_) {
      var i, types = types_, val = tryNormalizeType(value);
      if (!val)
        return !1;
      if (types && !Array.isArray(types))
        for (types = new Array(arguments.length - 1), i = 0; i < types.length; i++)
          types[i] = arguments[i + 1];
      if (!types || !types.length)
        return val;
      var type;
      for (i = 0; i < types.length; i++)
        if (mimeMatch(normalize(type = types[i]), val))
          return type[0] === "+" || type.indexOf("*") !== -1 ? val : type;
      return !1;
    }
    function hasbody(req) {
      return req.headers["transfer-encoding"] !== void 0 || !isNaN(req.headers["content-length"]);
    }
    function typeofrequest(req, types_) {
      var types = types_;
      if (!hasbody(req))
        return null;
      if (arguments.length > 2) {
        types = new Array(arguments.length - 1);
        for (var i = 0; i < types.length; i++)
          types[i] = arguments[i + 1];
      }
      var value = req.headers["content-type"];
      return typeis(value, types);
    }
    function normalize(type) {
      if (typeof type != "string")
        return !1;
      switch (type) {
        case "urlencoded":
          return "application/x-www-form-urlencoded";
        case "multipart":
          return "multipart/*";
      }
      return type[0] === "+" ? "*/*" + type : type.indexOf("/") === -1 ? mime.lookup(type) : type;
    }
    function mimeMatch(expected, actual) {
      if (expected === !1)
        return !1;
      var actualParts = actual.split("/"), expectedParts = expected.split("/");
      return actualParts.length !== 2 || expectedParts.length !== 2 || expectedParts[0] !== "*" && expectedParts[0] !== actualParts[0] ? !1 : expectedParts[1].substr(0, 2) === "*+" ? expectedParts[1].length <= actualParts[1].length + 1 && expectedParts[1].substr(1) === actualParts[1].substr(1 - expectedParts[1].length) : !(expectedParts[1] !== "*" && expectedParts[1] !== actualParts[1]);
    }
    function normalizeType(value) {
      var type = typer.parse(value);
      return type.parameters = void 0, typer.format(type);
    }
    function tryNormalizeType(value) {
      if (!value)
        return null;
      try {
        return normalizeType(value);
      } catch {
        return null;
      }
    }
  }
});

// ../../node_modules/.pnpm/body-parser@1.20.2/node_modules/body-parser/lib/types/json.js
var require_json6 = __commonJS({
  "../../node_modules/.pnpm/body-parser@1.20.2/node_modules/body-parser/lib/types/json.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var bytes = require_bytes(), contentType = require_content_type(), createError2 = require_http_errors(), debug4 = require_src2()("body-parser:json"), read = require_read(), typeis = require_type_is();
    module.exports = json;
    var FIRST_CHAR_REGEXP = /^[\x20\x09\x0a\x0d]*([^\x20\x09\x0a\x0d])/, JSON_SYNTAX_CHAR = "#", JSON_SYNTAX_REGEXP = /#+/g;
    function json(options) {
      var opts = options || {}, limit = typeof opts.limit != "number" ? bytes.parse(opts.limit || "100kb") : opts.limit, inflate = opts.inflate !== !1, reviver = opts.reviver, strict = opts.strict !== !1, type = opts.type || "application/json", verify = opts.verify || !1;
      if (verify !== !1 && typeof verify != "function")
        throw new TypeError("option verify must be function");
      var shouldParse = typeof type != "function" ? typeChecker(type) : type;
      function parse4(body) {
        if (body.length === 0)
          return {};
        if (strict) {
          var first = firstchar(body);
          if (first !== "{" && first !== "[")
            throw debug4("strict violation"), createStrictSyntaxError(body, first);
        }
        try {
          return debug4("parse json"), JSON.parse(body, reviver);
        } catch (e) {
          throw normalizeJsonSyntaxError(e, {
            message: e.message,
            stack: e.stack
          });
        }
      }
      return function(req, res, next) {
        if (req._body) {
          debug4("body already parsed"), next();
          return;
        }
        if (req.body = req.body || {}, !typeis.hasBody(req)) {
          debug4("skip empty body"), next();
          return;
        }
        if (debug4("content-type %j", req.headers["content-type"]), !shouldParse(req)) {
          debug4("skip parsing"), next();
          return;
        }
        var charset = getCharset(req) || "utf-8";
        if (charset.slice(0, 4) !== "utf-") {
          debug4("invalid charset"), next(createError2(415, 'unsupported charset "' + charset.toUpperCase() + '"', {
            charset,
            type: "charset.unsupported"
          }));
          return;
        }
        read(req, res, next, parse4, debug4, {
          encoding: charset,
          inflate,
          limit,
          verify
        });
      };
    }
    function createStrictSyntaxError(str, char) {
      var index = str.indexOf(char), partial = "";
      if (index !== -1) {
        partial = str.substring(0, index) + JSON_SYNTAX_CHAR;
        for (var i = index + 1; i < str.length; i++)
          partial += JSON_SYNTAX_CHAR;
      }
      try {
        throw JSON.parse(partial), new SyntaxError("strict violation");
      } catch (e) {
        return normalizeJsonSyntaxError(e, {
          message: e.message.replace(JSON_SYNTAX_REGEXP, function(placeholder) {
            return str.substring(index, index + placeholder.length);
          }),
          stack: e.stack
        });
      }
    }
    function firstchar(str) {
      var match2 = FIRST_CHAR_REGEXP.exec(str);
      return match2 ? match2[1] : void 0;
    }
    function getCharset(req) {
      try {
        return (contentType.parse(req).parameters.charset || "").toLowerCase();
      } catch {
        return;
      }
    }
    function normalizeJsonSyntaxError(error, obj) {
      for (var keys = Object.getOwnPropertyNames(error), i = 0; i < keys.length; i++) {
        var key = keys[i];
        key !== "stack" && key !== "message" && delete error[key];
      }
      return error.stack = obj.stack.replace(error.message, obj.message), error.message = obj.message, error;
    }
    function typeChecker(type) {
      return function(req) {
        return !!typeis(req, type);
      };
    }
  }
});

// ../../node_modules/.pnpm/body-parser@1.20.2/node_modules/body-parser/lib/types/raw.js
var require_raw = __commonJS({
  "../../node_modules/.pnpm/body-parser@1.20.2/node_modules/body-parser/lib/types/raw.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var bytes = require_bytes(), debug4 = require_src2()("body-parser:raw"), read = require_read(), typeis = require_type_is();
    module.exports = raw;
    function raw(options) {
      var opts = options || {}, inflate = opts.inflate !== !1, limit = typeof opts.limit != "number" ? bytes.parse(opts.limit || "100kb") : opts.limit, type = opts.type || "application/octet-stream", verify = opts.verify || !1;
      if (verify !== !1 && typeof verify != "function")
        throw new TypeError("option verify must be function");
      var shouldParse = typeof type != "function" ? typeChecker(type) : type;
      function parse4(buf) {
        return buf;
      }
      return function(req, res, next) {
        if (req._body) {
          debug4("body already parsed"), next();
          return;
        }
        if (req.body = req.body || {}, !typeis.hasBody(req)) {
          debug4("skip empty body"), next();
          return;
        }
        if (debug4("content-type %j", req.headers["content-type"]), !shouldParse(req)) {
          debug4("skip parsing"), next();
          return;
        }
        read(req, res, next, parse4, debug4, {
          encoding: null,
          inflate,
          limit,
          verify
        });
      };
    }
    function typeChecker(type) {
      return function(req) {
        return !!typeis(req, type);
      };
    }
  }
});

// ../../node_modules/.pnpm/body-parser@1.20.2/node_modules/body-parser/lib/types/text.js
var require_text3 = __commonJS({
  "../../node_modules/.pnpm/body-parser@1.20.2/node_modules/body-parser/lib/types/text.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var bytes = require_bytes(), contentType = require_content_type(), debug4 = require_src2()("body-parser:text"), read = require_read(), typeis = require_type_is();
    module.exports = text;
    function text(options) {
      var opts = options || {}, defaultCharset = opts.defaultCharset || "utf-8", inflate = opts.inflate !== !1, limit = typeof opts.limit != "number" ? bytes.parse(opts.limit || "100kb") : opts.limit, type = opts.type || "text/plain", verify = opts.verify || !1;
      if (verify !== !1 && typeof verify != "function")
        throw new TypeError("option verify must be function");
      var shouldParse = typeof type != "function" ? typeChecker(type) : type;
      function parse4(buf) {
        return buf;
      }
      return function(req, res, next) {
        if (req._body) {
          debug4("body already parsed"), next();
          return;
        }
        if (req.body = req.body || {}, !typeis.hasBody(req)) {
          debug4("skip empty body"), next();
          return;
        }
        if (debug4("content-type %j", req.headers["content-type"]), !shouldParse(req)) {
          debug4("skip parsing"), next();
          return;
        }
        var charset = getCharset(req) || defaultCharset;
        read(req, res, next, parse4, debug4, {
          encoding: charset,
          inflate,
          limit,
          verify
        });
      };
    }
    function getCharset(req) {
      try {
        return (contentType.parse(req).parameters.charset || "").toLowerCase();
      } catch {
        return;
      }
    }
    function typeChecker(type) {
      return function(req) {
        return !!typeis(req, type);
      };
    }
  }
});

// ../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/index.js
var require_es_errors = __commonJS({
  "../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = Error;
  }
});

// ../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/eval.js
var require_eval = __commonJS({
  "../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/eval.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = EvalError;
  }
});

// ../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/range.js
var require_range = __commonJS({
  "../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/range.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = RangeError;
  }
});

// ../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/ref.js
var require_ref2 = __commonJS({
  "../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/ref.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = ReferenceError;
  }
});

// ../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/syntax.js
var require_syntax = __commonJS({
  "../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/syntax.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = SyntaxError;
  }
});

// ../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/type.js
var require_type2 = __commonJS({
  "../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/type.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = TypeError;
  }
});

// ../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/uri.js
var require_uri = __commonJS({
  "../../node_modules/.pnpm/es-errors@1.3.0/node_modules/es-errors/uri.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = URIError;
  }
});

// ../../node_modules/.pnpm/has-symbols@1.0.3/node_modules/has-symbols/shams.js
var require_shams = __commonJS({
  "../../node_modules/.pnpm/has-symbols@1.0.3/node_modules/has-symbols/shams.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = function() {
      if (typeof Symbol != "function" || typeof Object.getOwnPropertySymbols != "function")
        return !1;
      if (typeof Symbol.iterator == "symbol")
        return !0;
      var obj = {}, sym = Symbol("test"), symObj = Object(sym);
      if (typeof sym == "string" || Object.prototype.toString.call(sym) !== "[object Symbol]" || Object.prototype.toString.call(symObj) !== "[object Symbol]")
        return !1;
      var symVal = 42;
      obj[sym] = symVal;
      for (sym in obj)
        return !1;
      if (typeof Object.keys == "function" && Object.keys(obj).length !== 0 || typeof Object.getOwnPropertyNames == "function" && Object.getOwnPropertyNames(obj).length !== 0)
        return !1;
      var syms = Object.getOwnPropertySymbols(obj);
      if (syms.length !== 1 || syms[0] !== sym || !Object.prototype.propertyIsEnumerable.call(obj, sym))
        return !1;
      if (typeof Object.getOwnPropertyDescriptor == "function") {
        var descriptor = Object.getOwnPropertyDescriptor(obj, sym);
        if (descriptor.value !== symVal || descriptor.enumerable !== !0)
          return !1;
      }
      return !0;
    };
  }
});

// ../../node_modules/.pnpm/has-symbols@1.0.3/node_modules/has-symbols/index.js
var require_has_symbols = __commonJS({
  "../../node_modules/.pnpm/has-symbols@1.0.3/node_modules/has-symbols/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var origSymbol = typeof Symbol < "u" && Symbol, hasSymbolSham = require_shams();
    module.exports = function() {
      return typeof origSymbol != "function" || typeof Symbol != "function" || typeof origSymbol("foo") != "symbol" || typeof Symbol("bar") != "symbol" ? !1 : hasSymbolSham();
    };
  }
});

// ../../node_modules/.pnpm/has-proto@1.0.3/node_modules/has-proto/index.js
var require_has_proto = __commonJS({
  "../../node_modules/.pnpm/has-proto@1.0.3/node_modules/has-proto/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var test = {
      __proto__: null,
      foo: {}
    }, $Object = Object;
    module.exports = function() {
      return { __proto__: test }.foo === test.foo && !(test instanceof $Object);
    };
  }
});

// ../../node_modules/.pnpm/function-bind@1.1.2/node_modules/function-bind/implementation.js
var require_implementation = __commonJS({
  "../../node_modules/.pnpm/function-bind@1.1.2/node_modules/function-bind/implementation.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var ERROR_MESSAGE = "Function.prototype.bind called on incompatible ", toStr = Object.prototype.toString, max = Math.max, funcType = "[object Function]", concatty = function(a, b) {
      for (var arr = [], i = 0; i < a.length; i += 1)
        arr[i] = a[i];
      for (var j = 0; j < b.length; j += 1)
        arr[j + a.length] = b[j];
      return arr;
    }, slicy = function(arrLike, offset) {
      for (var arr = [], i = offset || 0, j = 0; i < arrLike.length; i += 1, j += 1)
        arr[j] = arrLike[i];
      return arr;
    }, joiny = function(arr, joiner) {
      for (var str = "", i = 0; i < arr.length; i += 1)
        str += arr[i], i + 1 < arr.length && (str += joiner);
      return str;
    };
    module.exports = function(that) {
      var target = this;
      if (typeof target != "function" || toStr.apply(target) !== funcType)
        throw new TypeError(ERROR_MESSAGE + target);
      for (var args = slicy(arguments, 1), bound, binder = function() {
        if (this instanceof bound) {
          var result = target.apply(
            this,
            concatty(args, arguments)
          );
          return Object(result) === result ? result : this;
        }
        return target.apply(
          that,
          concatty(args, arguments)
        );
      }, boundLength = max(0, target.length - args.length), boundArgs = [], i = 0; i < boundLength; i++)
        boundArgs[i] = "$" + i;
      if (bound = Function("binder", "return function (" + joiny(boundArgs, ",") + "){ return binder.apply(this,arguments); }")(binder), target.prototype) {
        var Empty = function() {
        };
        Empty.prototype = target.prototype, bound.prototype = new Empty(), Empty.prototype = null;
      }
      return bound;
    };
  }
});

// ../../node_modules/.pnpm/function-bind@1.1.2/node_modules/function-bind/index.js
var require_function_bind = __commonJS({
  "../../node_modules/.pnpm/function-bind@1.1.2/node_modules/function-bind/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var implementation = require_implementation();
    module.exports = Function.prototype.bind || implementation;
  }
});

// ../../node_modules/.pnpm/hasown@2.0.2/node_modules/hasown/index.js
var require_hasown = __commonJS({
  "../../node_modules/.pnpm/hasown@2.0.2/node_modules/hasown/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var call = Function.prototype.call, $hasOwn = Object.prototype.hasOwnProperty, bind = require_function_bind();
    module.exports = bind.call(call, $hasOwn);
  }
});

// ../../node_modules/.pnpm/get-intrinsic@1.2.4/node_modules/get-intrinsic/index.js
var require_get_intrinsic = __commonJS({
  "../../node_modules/.pnpm/get-intrinsic@1.2.4/node_modules/get-intrinsic/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var undefined2, $Error = require_es_errors(), $EvalError = require_eval(), $RangeError = require_range(), $ReferenceError = require_ref2(), $SyntaxError = require_syntax(), $TypeError = require_type2(), $URIError = require_uri(), $Function = Function, getEvalledConstructor = function(expressionSyntax) {
      try {
        return $Function('"use strict"; return (' + expressionSyntax + ").constructor;")();
      } catch {
      }
    }, $gOPD = Object.getOwnPropertyDescriptor;
    if ($gOPD)
      try {
        $gOPD({}, "");
      } catch {
        $gOPD = null;
      }
    var throwTypeError = function() {
      throw new $TypeError();
    }, ThrowTypeError = $gOPD ? function() {
      try {
        return arguments.callee, throwTypeError;
      } catch {
        try {
          return $gOPD(arguments, "callee").get;
        } catch {
          return throwTypeError;
        }
      }
    }() : throwTypeError, hasSymbols = require_has_symbols()(), hasProto = require_has_proto()(), getProto = Object.getPrototypeOf || (hasProto ? function(x) {
      return x.__proto__;
    } : null), needsEval = {}, TypedArray = typeof Uint8Array > "u" || !getProto ? undefined2 : getProto(Uint8Array), INTRINSICS = {
      __proto__: null,
      "%AggregateError%": typeof AggregateError > "u" ? undefined2 : AggregateError,
      "%Array%": Array,
      "%ArrayBuffer%": typeof ArrayBuffer > "u" ? undefined2 : ArrayBuffer,
      "%ArrayIteratorPrototype%": hasSymbols && getProto ? getProto([][Symbol.iterator]()) : undefined2,
      "%AsyncFromSyncIteratorPrototype%": undefined2,
      "%AsyncFunction%": needsEval,
      "%AsyncGenerator%": needsEval,
      "%AsyncGeneratorFunction%": needsEval,
      "%AsyncIteratorPrototype%": needsEval,
      "%Atomics%": typeof Atomics > "u" ? undefined2 : Atomics,
      "%BigInt%": typeof BigInt > "u" ? undefined2 : BigInt,
      "%BigInt64Array%": typeof BigInt64Array > "u" ? undefined2 : BigInt64Array,
      "%BigUint64Array%": typeof BigUint64Array > "u" ? undefined2 : BigUint64Array,
      "%Boolean%": Boolean,
      "%DataView%": typeof DataView > "u" ? undefined2 : DataView,
      "%Date%": Date,
      "%decodeURI%": decodeURI,
      "%decodeURIComponent%": decodeURIComponent,
      "%encodeURI%": encodeURI,
      "%encodeURIComponent%": encodeURIComponent,
      "%Error%": $Error,
      "%eval%": eval,
      // eslint-disable-line no-eval
      "%EvalError%": $EvalError,
      "%Float32Array%": typeof Float32Array > "u" ? undefined2 : Float32Array,
      "%Float64Array%": typeof Float64Array > "u" ? undefined2 : Float64Array,
      "%FinalizationRegistry%": typeof FinalizationRegistry > "u" ? undefined2 : FinalizationRegistry,
      "%Function%": $Function,
      "%GeneratorFunction%": needsEval,
      "%Int8Array%": typeof Int8Array > "u" ? undefined2 : Int8Array,
      "%Int16Array%": typeof Int16Array > "u" ? undefined2 : Int16Array,
      "%Int32Array%": typeof Int32Array > "u" ? undefined2 : Int32Array,
      "%isFinite%": isFinite,
      "%isNaN%": isNaN,
      "%IteratorPrototype%": hasSymbols && getProto ? getProto(getProto([][Symbol.iterator]())) : undefined2,
      "%JSON%": typeof JSON == "object" ? JSON : undefined2,
      "%Map%": typeof Map > "u" ? undefined2 : Map,
      "%MapIteratorPrototype%": typeof Map > "u" || !hasSymbols || !getProto ? undefined2 : getProto((/* @__PURE__ */ new Map())[Symbol.iterator]()),
      "%Math%": Math,
      "%Number%": Number,
      "%Object%": Object,
      "%parseFloat%": parseFloat,
      "%parseInt%": parseInt,
      "%Promise%": typeof Promise > "u" ? undefined2 : Promise,
      "%Proxy%": typeof Proxy > "u" ? undefined2 : Proxy,
      "%RangeError%": $RangeError,
      "%ReferenceError%": $ReferenceError,
      "%Reflect%": typeof Reflect > "u" ? undefined2 : Reflect,
      "%RegExp%": RegExp,
      "%Set%": typeof Set > "u" ? undefined2 : Set,
      "%SetIteratorPrototype%": typeof Set > "u" || !hasSymbols || !getProto ? undefined2 : getProto((/* @__PURE__ */ new Set())[Symbol.iterator]()),
      "%SharedArrayBuffer%": typeof SharedArrayBuffer > "u" ? undefined2 : SharedArrayBuffer,
      "%String%": String,
      "%StringIteratorPrototype%": hasSymbols && getProto ? getProto(""[Symbol.iterator]()) : undefined2,
      "%Symbol%": hasSymbols ? Symbol : undefined2,
      "%SyntaxError%": $SyntaxError,
      "%ThrowTypeError%": ThrowTypeError,
      "%TypedArray%": TypedArray,
      "%TypeError%": $TypeError,
      "%Uint8Array%": typeof Uint8Array > "u" ? undefined2 : Uint8Array,
      "%Uint8ClampedArray%": typeof Uint8ClampedArray > "u" ? undefined2 : Uint8ClampedArray,
      "%Uint16Array%": typeof Uint16Array > "u" ? undefined2 : Uint16Array,
      "%Uint32Array%": typeof Uint32Array > "u" ? undefined2 : Uint32Array,
      "%URIError%": $URIError,
      "%WeakMap%": typeof WeakMap > "u" ? undefined2 : WeakMap,
      "%WeakRef%": typeof WeakRef > "u" ? undefined2 : WeakRef,
      "%WeakSet%": typeof WeakSet > "u" ? undefined2 : WeakSet
    };
    if (getProto)
      try {
        null.error;
      } catch (e) {
        errorProto = getProto(getProto(e)), INTRINSICS["%Error.prototype%"] = errorProto;
      }
    var errorProto, doEval = function doEval2(name) {
      var value;
      if (name === "%AsyncFunction%")
        value = getEvalledConstructor("async function () {}");
      else if (name === "%GeneratorFunction%")
        value = getEvalledConstructor("function* () {}");
      else if (name === "%AsyncGeneratorFunction%")
        value = getEvalledConstructor("async function* () {}");
      else if (name === "%AsyncGenerator%") {
        var fn = doEval2("%AsyncGeneratorFunction%");
        fn && (value = fn.prototype);
      } else if (name === "%AsyncIteratorPrototype%") {
        var gen = doEval2("%AsyncGenerator%");
        gen && getProto && (value = getProto(gen.prototype));
      }
      return INTRINSICS[name] = value, value;
    }, LEGACY_ALIASES = {
      __proto__: null,
      "%ArrayBufferPrototype%": ["ArrayBuffer", "prototype"],
      "%ArrayPrototype%": ["Array", "prototype"],
      "%ArrayProto_entries%": ["Array", "prototype", "entries"],
      "%ArrayProto_forEach%": ["Array", "prototype", "forEach"],
      "%ArrayProto_keys%": ["Array", "prototype", "keys"],
      "%ArrayProto_values%": ["Array", "prototype", "values"],
      "%AsyncFunctionPrototype%": ["AsyncFunction", "prototype"],
      "%AsyncGenerator%": ["AsyncGeneratorFunction", "prototype"],
      "%AsyncGeneratorPrototype%": ["AsyncGeneratorFunction", "prototype", "prototype"],
      "%BooleanPrototype%": ["Boolean", "prototype"],
      "%DataViewPrototype%": ["DataView", "prototype"],
      "%DatePrototype%": ["Date", "prototype"],
      "%ErrorPrototype%": ["Error", "prototype"],
      "%EvalErrorPrototype%": ["EvalError", "prototype"],
      "%Float32ArrayPrototype%": ["Float32Array", "prototype"],
      "%Float64ArrayPrototype%": ["Float64Array", "prototype"],
      "%FunctionPrototype%": ["Function", "prototype"],
      "%Generator%": ["GeneratorFunction", "prototype"],
      "%GeneratorPrototype%": ["GeneratorFunction", "prototype", "prototype"],
      "%Int8ArrayPrototype%": ["Int8Array", "prototype"],
      "%Int16ArrayPrototype%": ["Int16Array", "prototype"],
      "%Int32ArrayPrototype%": ["Int32Array", "prototype"],
      "%JSONParse%": ["JSON", "parse"],
      "%JSONStringify%": ["JSON", "stringify"],
      "%MapPrototype%": ["Map", "prototype"],
      "%NumberPrototype%": ["Number", "prototype"],
      "%ObjectPrototype%": ["Object", "prototype"],
      "%ObjProto_toString%": ["Object", "prototype", "toString"],
      "%ObjProto_valueOf%": ["Object", "prototype", "valueOf"],
      "%PromisePrototype%": ["Promise", "prototype"],
      "%PromiseProto_then%": ["Promise", "prototype", "then"],
      "%Promise_all%": ["Promise", "all"],
      "%Promise_reject%": ["Promise", "reject"],
      "%Promise_resolve%": ["Promise", "resolve"],
      "%RangeErrorPrototype%": ["RangeError", "prototype"],
      "%ReferenceErrorPrototype%": ["ReferenceError", "prototype"],
      "%RegExpPrototype%": ["RegExp", "prototype"],
      "%SetPrototype%": ["Set", "prototype"],
      "%SharedArrayBufferPrototype%": ["SharedArrayBuffer", "prototype"],
      "%StringPrototype%": ["String", "prototype"],
      "%SymbolPrototype%": ["Symbol", "prototype"],
      "%SyntaxErrorPrototype%": ["SyntaxError", "prototype"],
      "%TypedArrayPrototype%": ["TypedArray", "prototype"],
      "%TypeErrorPrototype%": ["TypeError", "prototype"],
      "%Uint8ArrayPrototype%": ["Uint8Array", "prototype"],
      "%Uint8ClampedArrayPrototype%": ["Uint8ClampedArray", "prototype"],
      "%Uint16ArrayPrototype%": ["Uint16Array", "prototype"],
      "%Uint32ArrayPrototype%": ["Uint32Array", "prototype"],
      "%URIErrorPrototype%": ["URIError", "prototype"],
      "%WeakMapPrototype%": ["WeakMap", "prototype"],
      "%WeakSetPrototype%": ["WeakSet", "prototype"]
    }, bind = require_function_bind(), hasOwn = require_hasown(), $concat = bind.call(Function.call, Array.prototype.concat), $spliceApply = bind.call(Function.apply, Array.prototype.splice), $replace = bind.call(Function.call, String.prototype.replace), $strSlice = bind.call(Function.call, String.prototype.slice), $exec = bind.call(Function.call, RegExp.prototype.exec), rePropName = /[^%.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|%$))/g, reEscapeChar = /\\(\\)?/g, stringToPath = function(string) {
      var first = $strSlice(string, 0, 1), last = $strSlice(string, -1);
      if (first === "%" && last !== "%")
        throw new $SyntaxError("invalid intrinsic syntax, expected closing `%`");
      if (last === "%" && first !== "%")
        throw new $SyntaxError("invalid intrinsic syntax, expected opening `%`");
      var result = [];
      return $replace(string, rePropName, function(match2, number, quote, subString) {
        result[result.length] = quote ? $replace(subString, reEscapeChar, "$1") : number || match2;
      }), result;
    }, getBaseIntrinsic = function(name, allowMissing) {
      var intrinsicName = name, alias;
      if (hasOwn(LEGACY_ALIASES, intrinsicName) && (alias = LEGACY_ALIASES[intrinsicName], intrinsicName = "%" + alias[0] + "%"), hasOwn(INTRINSICS, intrinsicName)) {
        var value = INTRINSICS[intrinsicName];
        if (value === needsEval && (value = doEval(intrinsicName)), typeof value > "u" && !allowMissing)
          throw new $TypeError("intrinsic " + name + " exists, but is not available. Please file an issue!");
        return {
          alias,
          name: intrinsicName,
          value
        };
      }
      throw new $SyntaxError("intrinsic " + name + " does not exist!");
    };
    module.exports = function(name, allowMissing) {
      if (typeof name != "string" || name.length === 0)
        throw new $TypeError("intrinsic name must be a non-empty string");
      if (arguments.length > 1 && typeof allowMissing != "boolean")
        throw new $TypeError('"allowMissing" argument must be a boolean');
      if ($exec(/^%?[^%]*%?$/, name) === null)
        throw new $SyntaxError("`%` may not be present anywhere but at the beginning and end of the intrinsic name");
      var parts = stringToPath(name), intrinsicBaseName = parts.length > 0 ? parts[0] : "", intrinsic = getBaseIntrinsic("%" + intrinsicBaseName + "%", allowMissing), intrinsicRealName = intrinsic.name, value = intrinsic.value, skipFurtherCaching = !1, alias = intrinsic.alias;
      alias && (intrinsicBaseName = alias[0], $spliceApply(parts, $concat([0, 1], alias)));
      for (var i = 1, isOwn = !0; i < parts.length; i += 1) {
        var part = parts[i], first = $strSlice(part, 0, 1), last = $strSlice(part, -1);
        if ((first === '"' || first === "'" || first === "`" || last === '"' || last === "'" || last === "`") && first !== last)
          throw new $SyntaxError("property names with quotes must have matching quotes");
        if ((part === "constructor" || !isOwn) && (skipFurtherCaching = !0), intrinsicBaseName += "." + part, intrinsicRealName = "%" + intrinsicBaseName + "%", hasOwn(INTRINSICS, intrinsicRealName))
          value = INTRINSICS[intrinsicRealName];
        else if (value != null) {
          if (!(part in value)) {
            if (!allowMissing)
              throw new $TypeError("base intrinsic for " + name + " exists, but the property is not available.");
            return;
          }
          if ($gOPD && i + 1 >= parts.length) {
            var desc = $gOPD(value, part);
            isOwn = !!desc, isOwn && "get" in desc && !("originalValue" in desc.get) ? value = desc.get : value = value[part];
          } else
            isOwn = hasOwn(value, part), value = value[part];
          isOwn && !skipFurtherCaching && (INTRINSICS[intrinsicRealName] = value);
        }
      }
      return value;
    };
  }
});

// ../../node_modules/.pnpm/es-define-property@1.0.0/node_modules/es-define-property/index.js
var require_es_define_property = __commonJS({
  "../../node_modules/.pnpm/es-define-property@1.0.0/node_modules/es-define-property/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var GetIntrinsic = require_get_intrinsic(), $defineProperty = GetIntrinsic("%Object.defineProperty%", !0) || !1;
    if ($defineProperty)
      try {
        $defineProperty({}, "a", { value: 1 });
      } catch {
        $defineProperty = !1;
      }
    module.exports = $defineProperty;
  }
});

// ../../node_modules/.pnpm/gopd@1.0.1/node_modules/gopd/index.js
var require_gopd = __commonJS({
  "../../node_modules/.pnpm/gopd@1.0.1/node_modules/gopd/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var GetIntrinsic = require_get_intrinsic(), $gOPD = GetIntrinsic("%Object.getOwnPropertyDescriptor%", !0);
    if ($gOPD)
      try {
        $gOPD([], "length");
      } catch {
        $gOPD = null;
      }
    module.exports = $gOPD;
  }
});

// ../../node_modules/.pnpm/define-data-property@1.1.4/node_modules/define-data-property/index.js
var require_define_data_property = __commonJS({
  "../../node_modules/.pnpm/define-data-property@1.1.4/node_modules/define-data-property/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var $defineProperty = require_es_define_property(), $SyntaxError = require_syntax(), $TypeError = require_type2(), gopd = require_gopd();
    module.exports = function(obj, property, value) {
      if (!obj || typeof obj != "object" && typeof obj != "function")
        throw new $TypeError("`obj` must be an object or a function`");
      if (typeof property != "string" && typeof property != "symbol")
        throw new $TypeError("`property` must be a string or a symbol`");
      if (arguments.length > 3 && typeof arguments[3] != "boolean" && arguments[3] !== null)
        throw new $TypeError("`nonEnumerable`, if provided, must be a boolean or null");
      if (arguments.length > 4 && typeof arguments[4] != "boolean" && arguments[4] !== null)
        throw new $TypeError("`nonWritable`, if provided, must be a boolean or null");
      if (arguments.length > 5 && typeof arguments[5] != "boolean" && arguments[5] !== null)
        throw new $TypeError("`nonConfigurable`, if provided, must be a boolean or null");
      if (arguments.length > 6 && typeof arguments[6] != "boolean")
        throw new $TypeError("`loose`, if provided, must be a boolean");
      var nonEnumerable = arguments.length > 3 ? arguments[3] : null, nonWritable = arguments.length > 4 ? arguments[4] : null, nonConfigurable = arguments.length > 5 ? arguments[5] : null, loose = arguments.length > 6 ? arguments[6] : !1, desc = !!gopd && gopd(obj, property);
      if ($defineProperty)
        $defineProperty(obj, property, {
          configurable: nonConfigurable === null && desc ? desc.configurable : !nonConfigurable,
          enumerable: nonEnumerable === null && desc ? desc.enumerable : !nonEnumerable,
          value,
          writable: nonWritable === null && desc ? desc.writable : !nonWritable
        });
      else if (loose || !nonEnumerable && !nonWritable && !nonConfigurable)
        obj[property] = value;
      else
        throw new $SyntaxError("This environment does not support defining a property as non-configurable, non-writable, or non-enumerable.");
    };
  }
});

// ../../node_modules/.pnpm/has-property-descriptors@1.0.2/node_modules/has-property-descriptors/index.js
var require_has_property_descriptors = __commonJS({
  "../../node_modules/.pnpm/has-property-descriptors@1.0.2/node_modules/has-property-descriptors/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var $defineProperty = require_es_define_property(), hasPropertyDescriptors = function() {
      return !!$defineProperty;
    };
    hasPropertyDescriptors.hasArrayLengthDefineBug = function() {
      if (!$defineProperty)
        return null;
      try {
        return $defineProperty([], "length", { value: 1 }).length !== 1;
      } catch {
        return !0;
      }
    };
    module.exports = hasPropertyDescriptors;
  }
});

// ../../node_modules/.pnpm/set-function-length@1.2.2/node_modules/set-function-length/index.js
var require_set_function_length = __commonJS({
  "../../node_modules/.pnpm/set-function-length@1.2.2/node_modules/set-function-length/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var GetIntrinsic = require_get_intrinsic(), define2 = require_define_data_property(), hasDescriptors = require_has_property_descriptors()(), gOPD = require_gopd(), $TypeError = require_type2(), $floor = GetIntrinsic("%Math.floor%");
    module.exports = function(fn, length) {
      if (typeof fn != "function")
        throw new $TypeError("`fn` is not a function");
      if (typeof length != "number" || length < 0 || length > 4294967295 || $floor(length) !== length)
        throw new $TypeError("`length` must be a positive 32-bit integer");
      var loose = arguments.length > 2 && !!arguments[2], functionLengthIsConfigurable = !0, functionLengthIsWritable = !0;
      if ("length" in fn && gOPD) {
        var desc = gOPD(fn, "length");
        desc && !desc.configurable && (functionLengthIsConfigurable = !1), desc && !desc.writable && (functionLengthIsWritable = !1);
      }
      return (functionLengthIsConfigurable || functionLengthIsWritable || !loose) && (hasDescriptors ? define2(
        /** @type {Parameters<define>[0]} */
        fn,
        "length",
        length,
        !0,
        !0
      ) : define2(
        /** @type {Parameters<define>[0]} */
        fn,
        "length",
        length
      )), fn;
    };
  }
});

// ../../node_modules/.pnpm/call-bind@1.0.7/node_modules/call-bind/index.js
var require_call_bind = __commonJS({
  "../../node_modules/.pnpm/call-bind@1.0.7/node_modules/call-bind/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var bind = require_function_bind(), GetIntrinsic = require_get_intrinsic(), setFunctionLength = require_set_function_length(), $TypeError = require_type2(), $apply = GetIntrinsic("%Function.prototype.apply%"), $call = GetIntrinsic("%Function.prototype.call%"), $reflectApply = GetIntrinsic("%Reflect.apply%", !0) || bind.call($call, $apply), $defineProperty = require_es_define_property(), $max = GetIntrinsic("%Math.max%");
    module.exports = function(originalFunction) {
      if (typeof originalFunction != "function")
        throw new $TypeError("a function is required");
      var func = $reflectApply(bind, $call, arguments);
      return setFunctionLength(
        func,
        1 + $max(0, originalFunction.length - (arguments.length - 1)),
        !0
      );
    };
    var applyBind = function() {
      return $reflectApply(bind, $apply, arguments);
    };
    $defineProperty ? $defineProperty(module.exports, "apply", { value: applyBind }) : module.exports.apply = applyBind;
  }
});

// ../../node_modules/.pnpm/call-bind@1.0.7/node_modules/call-bind/callBound.js
var require_callBound = __commonJS({
  "../../node_modules/.pnpm/call-bind@1.0.7/node_modules/call-bind/callBound.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var GetIntrinsic = require_get_intrinsic(), callBind = require_call_bind(), $indexOf = callBind(GetIntrinsic("String.prototype.indexOf"));
    module.exports = function(name, allowMissing) {
      var intrinsic = GetIntrinsic(name, !!allowMissing);
      return typeof intrinsic == "function" && $indexOf(name, ".prototype.") > -1 ? callBind(intrinsic) : intrinsic;
    };
  }
});

// ../../node_modules/.pnpm/object-inspect@1.13.1/node_modules/object-inspect/util.inspect.js
var require_util_inspect = __commonJS({
  "../../node_modules/.pnpm/object-inspect@1.13.1/node_modules/object-inspect/util.inspect.js"(exports, module) {
    init_cjs_shims();
    module.exports = __require("util").inspect;
  }
});

// ../../node_modules/.pnpm/object-inspect@1.13.1/node_modules/object-inspect/index.js
var require_object_inspect = __commonJS({
  "../../node_modules/.pnpm/object-inspect@1.13.1/node_modules/object-inspect/index.js"(exports, module) {
    init_cjs_shims();
    var hasMap = typeof Map == "function" && Map.prototype, mapSizeDescriptor = Object.getOwnPropertyDescriptor && hasMap ? Object.getOwnPropertyDescriptor(Map.prototype, "size") : null, mapSize = hasMap && mapSizeDescriptor && typeof mapSizeDescriptor.get == "function" ? mapSizeDescriptor.get : null, mapForEach = hasMap && Map.prototype.forEach, hasSet = typeof Set == "function" && Set.prototype, setSizeDescriptor = Object.getOwnPropertyDescriptor && hasSet ? Object.getOwnPropertyDescriptor(Set.prototype, "size") : null, setSize = hasSet && setSizeDescriptor && typeof setSizeDescriptor.get == "function" ? setSizeDescriptor.get : null, setForEach = hasSet && Set.prototype.forEach, hasWeakMap = typeof WeakMap == "function" && WeakMap.prototype, weakMapHas = hasWeakMap ? WeakMap.prototype.has : null, hasWeakSet = typeof WeakSet == "function" && WeakSet.prototype, weakSetHas = hasWeakSet ? WeakSet.prototype.has : null, hasWeakRef = typeof WeakRef == "function" && WeakRef.prototype, weakRefDeref = hasWeakRef ? WeakRef.prototype.deref : null, booleanValueOf = Boolean.prototype.valueOf, objectToString = Object.prototype.toString, functionToString = Function.prototype.toString, $match = String.prototype.match, $slice = String.prototype.slice, $replace = String.prototype.replace, $toUpperCase = String.prototype.toUpperCase, $toLowerCase = String.prototype.toLowerCase, $test = RegExp.prototype.test, $concat = Array.prototype.concat, $join = Array.prototype.join, $arrSlice = Array.prototype.slice, $floor = Math.floor, bigIntValueOf = typeof BigInt == "function" ? BigInt.prototype.valueOf : null, gOPS = Object.getOwnPropertySymbols, symToString = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Symbol.prototype.toString : null, hasShammedSymbols = typeof Symbol == "function" && typeof Symbol.iterator == "object", toStringTag = typeof Symbol == "function" && Symbol.toStringTag && (typeof Symbol.toStringTag === hasShammedSymbols || !0) ? Symbol.toStringTag : null, isEnumerable = Object.prototype.propertyIsEnumerable, gPO = (typeof Reflect == "function" ? Reflect.getPrototypeOf : Object.getPrototypeOf) || ([].__proto__ === Array.prototype ? function(O) {
      return O.__proto__;
    } : null);
    function addNumericSeparator(num, str) {
      if (num === 1 / 0 || num === -1 / 0 || num !== num || num && num > -1e3 && num < 1e3 || $test.call(/e/, str))
        return str;
      var sepRegex = /[0-9](?=(?:[0-9]{3})+(?![0-9]))/g;
      if (typeof num == "number") {
        var int = num < 0 ? -$floor(-num) : $floor(num);
        if (int !== num) {
          var intStr = String(int), dec = $slice.call(str, intStr.length + 1);
          return $replace.call(intStr, sepRegex, "$&_") + "." + $replace.call($replace.call(dec, /([0-9]{3})/g, "$&_"), /_$/, "");
        }
      }
      return $replace.call(str, sepRegex, "$&_");
    }
    var utilInspect = require_util_inspect(), inspectCustom = utilInspect.custom, inspectSymbol = isSymbol(inspectCustom) ? inspectCustom : null;
    module.exports = function inspect_(obj, options, depth, seen) {
      var opts = options || {};
      if (has2(opts, "quoteStyle") && opts.quoteStyle !== "single" && opts.quoteStyle !== "double")
        throw new TypeError('option "quoteStyle" must be "single" or "double"');
      if (has2(opts, "maxStringLength") && (typeof opts.maxStringLength == "number" ? opts.maxStringLength < 0 && opts.maxStringLength !== 1 / 0 : opts.maxStringLength !== null))
        throw new TypeError('option "maxStringLength", if provided, must be a positive integer, Infinity, or `null`');
      var customInspect = has2(opts, "customInspect") ? opts.customInspect : !0;
      if (typeof customInspect != "boolean" && customInspect !== "symbol")
        throw new TypeError("option \"customInspect\", if provided, must be `true`, `false`, or `'symbol'`");
      if (has2(opts, "indent") && opts.indent !== null && opts.indent !== "	" && !(parseInt(opts.indent, 10) === opts.indent && opts.indent > 0))
        throw new TypeError('option "indent" must be "\\t", an integer > 0, or `null`');
      if (has2(opts, "numericSeparator") && typeof opts.numericSeparator != "boolean")
        throw new TypeError('option "numericSeparator", if provided, must be `true` or `false`');
      var numericSeparator = opts.numericSeparator;
      if (typeof obj > "u")
        return "undefined";
      if (obj === null)
        return "null";
      if (typeof obj == "boolean")
        return obj ? "true" : "false";
      if (typeof obj == "string")
        return inspectString(obj, opts);
      if (typeof obj == "number") {
        if (obj === 0)
          return 1 / 0 / obj > 0 ? "0" : "-0";
        var str = String(obj);
        return numericSeparator ? addNumericSeparator(obj, str) : str;
      }
      if (typeof obj == "bigint") {
        var bigIntStr = String(obj) + "n";
        return numericSeparator ? addNumericSeparator(obj, bigIntStr) : bigIntStr;
      }
      var maxDepth = typeof opts.depth > "u" ? 5 : opts.depth;
      if (typeof depth > "u" && (depth = 0), depth >= maxDepth && maxDepth > 0 && typeof obj == "object")
        return isArray(obj) ? "[Array]" : "[Object]";
      var indent = getIndent(opts, depth);
      if (typeof seen > "u")
        seen = [];
      else if (indexOf(seen, obj) >= 0)
        return "[Circular]";
      function inspect(value, from, noIndent) {
        if (from && (seen = $arrSlice.call(seen), seen.push(from)), noIndent) {
          var newOpts = {
            depth: opts.depth
          };
          return has2(opts, "quoteStyle") && (newOpts.quoteStyle = opts.quoteStyle), inspect_(value, newOpts, depth + 1, seen);
        }
        return inspect_(value, opts, depth + 1, seen);
      }
      if (typeof obj == "function" && !isRegExp(obj)) {
        var name = nameOf(obj), keys = arrObjKeys(obj, inspect);
        return "[Function" + (name ? ": " + name : " (anonymous)") + "]" + (keys.length > 0 ? " { " + $join.call(keys, ", ") + " }" : "");
      }
      if (isSymbol(obj)) {
        var symString = hasShammedSymbols ? $replace.call(String(obj), /^(Symbol\(.*\))_[^)]*$/, "$1") : symToString.call(obj);
        return typeof obj == "object" && !hasShammedSymbols ? markBoxed(symString) : symString;
      }
      if (isElement(obj)) {
        for (var s = "<" + $toLowerCase.call(String(obj.nodeName)), attrs = obj.attributes || [], i = 0; i < attrs.length; i++)
          s += " " + attrs[i].name + "=" + wrapQuotes(quote(attrs[i].value), "double", opts);
        return s += ">", obj.childNodes && obj.childNodes.length && (s += "..."), s += "</" + $toLowerCase.call(String(obj.nodeName)) + ">", s;
      }
      if (isArray(obj)) {
        if (obj.length === 0)
          return "[]";
        var xs = arrObjKeys(obj, inspect);
        return indent && !singleLineValues(xs) ? "[" + indentedJoin(xs, indent) + "]" : "[ " + $join.call(xs, ", ") + " ]";
      }
      if (isError2(obj)) {
        var parts = arrObjKeys(obj, inspect);
        return !("cause" in Error.prototype) && "cause" in obj && !isEnumerable.call(obj, "cause") ? "{ [" + String(obj) + "] " + $join.call($concat.call("[cause]: " + inspect(obj.cause), parts), ", ") + " }" : parts.length === 0 ? "[" + String(obj) + "]" : "{ [" + String(obj) + "] " + $join.call(parts, ", ") + " }";
      }
      if (typeof obj == "object" && customInspect) {
        if (inspectSymbol && typeof obj[inspectSymbol] == "function" && utilInspect)
          return utilInspect(obj, { depth: maxDepth - depth });
        if (customInspect !== "symbol" && typeof obj.inspect == "function")
          return obj.inspect();
      }
      if (isMap(obj)) {
        var mapParts = [];
        return mapForEach && mapForEach.call(obj, function(value, key) {
          mapParts.push(inspect(key, obj, !0) + " => " + inspect(value, obj));
        }), collectionOf("Map", mapSize.call(obj), mapParts, indent);
      }
      if (isSet(obj)) {
        var setParts = [];
        return setForEach && setForEach.call(obj, function(value) {
          setParts.push(inspect(value, obj));
        }), collectionOf("Set", setSize.call(obj), setParts, indent);
      }
      if (isWeakMap(obj))
        return weakCollectionOf("WeakMap");
      if (isWeakSet(obj))
        return weakCollectionOf("WeakSet");
      if (isWeakRef(obj))
        return weakCollectionOf("WeakRef");
      if (isNumber2(obj))
        return markBoxed(inspect(Number(obj)));
      if (isBigInt(obj))
        return markBoxed(inspect(bigIntValueOf.call(obj)));
      if (isBoolean2(obj))
        return markBoxed(booleanValueOf.call(obj));
      if (isString2(obj))
        return markBoxed(inspect(String(obj)));
      if (typeof window < "u" && obj === window)
        return "{ [object Window] }";
      if (obj === global)
        return "{ [object globalThis] }";
      if (!isDate(obj) && !isRegExp(obj)) {
        var ys = arrObjKeys(obj, inspect), isPlainObject = gPO ? gPO(obj) === Object.prototype : obj instanceof Object || obj.constructor === Object, protoTag = obj instanceof Object ? "" : "null prototype", stringTag = !isPlainObject && toStringTag && Object(obj) === obj && toStringTag in obj ? $slice.call(toStr(obj), 8, -1) : protoTag ? "Object" : "", constructorTag = isPlainObject || typeof obj.constructor != "function" ? "" : obj.constructor.name ? obj.constructor.name + " " : "", tag = constructorTag + (stringTag || protoTag ? "[" + $join.call($concat.call([], stringTag || [], protoTag || []), ": ") + "] " : "");
        return ys.length === 0 ? tag + "{}" : indent ? tag + "{" + indentedJoin(ys, indent) + "}" : tag + "{ " + $join.call(ys, ", ") + " }";
      }
      return String(obj);
    };
    function wrapQuotes(s, defaultStyle, opts) {
      var quoteChar = (opts.quoteStyle || defaultStyle) === "double" ? '"' : "'";
      return quoteChar + s + quoteChar;
    }
    function quote(s) {
      return $replace.call(String(s), /"/g, "&quot;");
    }
    function isArray(obj) {
      return toStr(obj) === "[object Array]" && (!toStringTag || !(typeof obj == "object" && toStringTag in obj));
    }
    function isDate(obj) {
      return toStr(obj) === "[object Date]" && (!toStringTag || !(typeof obj == "object" && toStringTag in obj));
    }
    function isRegExp(obj) {
      return toStr(obj) === "[object RegExp]" && (!toStringTag || !(typeof obj == "object" && toStringTag in obj));
    }
    function isError2(obj) {
      return toStr(obj) === "[object Error]" && (!toStringTag || !(typeof obj == "object" && toStringTag in obj));
    }
    function isString2(obj) {
      return toStr(obj) === "[object String]" && (!toStringTag || !(typeof obj == "object" && toStringTag in obj));
    }
    function isNumber2(obj) {
      return toStr(obj) === "[object Number]" && (!toStringTag || !(typeof obj == "object" && toStringTag in obj));
    }
    function isBoolean2(obj) {
      return toStr(obj) === "[object Boolean]" && (!toStringTag || !(typeof obj == "object" && toStringTag in obj));
    }
    function isSymbol(obj) {
      if (hasShammedSymbols)
        return obj && typeof obj == "object" && obj instanceof Symbol;
      if (typeof obj == "symbol")
        return !0;
      if (!obj || typeof obj != "object" || !symToString)
        return !1;
      try {
        return symToString.call(obj), !0;
      } catch {
      }
      return !1;
    }
    function isBigInt(obj) {
      if (!obj || typeof obj != "object" || !bigIntValueOf)
        return !1;
      try {
        return bigIntValueOf.call(obj), !0;
      } catch {
      }
      return !1;
    }
    var hasOwn = Object.prototype.hasOwnProperty || function(key) {
      return key in this;
    };
    function has2(obj, key) {
      return hasOwn.call(obj, key);
    }
    function toStr(obj) {
      return objectToString.call(obj);
    }
    function nameOf(f) {
      if (f.name)
        return f.name;
      var m = $match.call(functionToString.call(f), /^function\s*([\w$]+)/);
      return m ? m[1] : null;
    }
    function indexOf(xs, x) {
      if (xs.indexOf)
        return xs.indexOf(x);
      for (var i = 0, l = xs.length; i < l; i++)
        if (xs[i] === x)
          return i;
      return -1;
    }
    function isMap(x) {
      if (!mapSize || !x || typeof x != "object")
        return !1;
      try {
        mapSize.call(x);
        try {
          setSize.call(x);
        } catch {
          return !0;
        }
        return x instanceof Map;
      } catch {
      }
      return !1;
    }
    function isWeakMap(x) {
      if (!weakMapHas || !x || typeof x != "object")
        return !1;
      try {
        weakMapHas.call(x, weakMapHas);
        try {
          weakSetHas.call(x, weakSetHas);
        } catch {
          return !0;
        }
        return x instanceof WeakMap;
      } catch {
      }
      return !1;
    }
    function isWeakRef(x) {
      if (!weakRefDeref || !x || typeof x != "object")
        return !1;
      try {
        return weakRefDeref.call(x), !0;
      } catch {
      }
      return !1;
    }
    function isSet(x) {
      if (!setSize || !x || typeof x != "object")
        return !1;
      try {
        setSize.call(x);
        try {
          mapSize.call(x);
        } catch {
          return !0;
        }
        return x instanceof Set;
      } catch {
      }
      return !1;
    }
    function isWeakSet(x) {
      if (!weakSetHas || !x || typeof x != "object")
        return !1;
      try {
        weakSetHas.call(x, weakSetHas);
        try {
          weakMapHas.call(x, weakMapHas);
        } catch {
          return !0;
        }
        return x instanceof WeakSet;
      } catch {
      }
      return !1;
    }
    function isElement(x) {
      return !x || typeof x != "object" ? !1 : typeof HTMLElement < "u" && x instanceof HTMLElement ? !0 : typeof x.nodeName == "string" && typeof x.getAttribute == "function";
    }
    function inspectString(str, opts) {
      if (str.length > opts.maxStringLength) {
        var remaining = str.length - opts.maxStringLength, trailer = "... " + remaining + " more character" + (remaining > 1 ? "s" : "");
        return inspectString($slice.call(str, 0, opts.maxStringLength), opts) + trailer;
      }
      var s = $replace.call($replace.call(str, /(['\\])/g, "\\$1"), /[\x00-\x1f]/g, lowbyte);
      return wrapQuotes(s, "single", opts);
    }
    function lowbyte(c) {
      var n = c.charCodeAt(0), x = {
        8: "b",
        9: "t",
        10: "n",
        12: "f",
        13: "r"
      }[n];
      return x ? "\\" + x : "\\x" + (n < 16 ? "0" : "") + $toUpperCase.call(n.toString(16));
    }
    function markBoxed(str) {
      return "Object(" + str + ")";
    }
    function weakCollectionOf(type) {
      return type + " { ? }";
    }
    function collectionOf(type, size, entries, indent) {
      var joinedEntries = indent ? indentedJoin(entries, indent) : $join.call(entries, ", ");
      return type + " (" + size + ") {" + joinedEntries + "}";
    }
    function singleLineValues(xs) {
      for (var i = 0; i < xs.length; i++)
        if (indexOf(xs[i], `
`) >= 0)
          return !1;
      return !0;
    }
    function getIndent(opts, depth) {
      var baseIndent;
      if (opts.indent === "	")
        baseIndent = "	";
      else if (typeof opts.indent == "number" && opts.indent > 0)
        baseIndent = $join.call(Array(opts.indent + 1), " ");
      else
        return null;
      return {
        base: baseIndent,
        prev: $join.call(Array(depth + 1), baseIndent)
      };
    }
    function indentedJoin(xs, indent) {
      if (xs.length === 0)
        return "";
      var lineJoiner = `
` + indent.prev + indent.base;
      return lineJoiner + $join.call(xs, "," + lineJoiner) + `
` + indent.prev;
    }
    function arrObjKeys(obj, inspect) {
      var isArr = isArray(obj), xs = [];
      if (isArr) {
        xs.length = obj.length;
        for (var i = 0; i < obj.length; i++)
          xs[i] = has2(obj, i) ? inspect(obj[i], obj) : "";
      }
      var syms = typeof gOPS == "function" ? gOPS(obj) : [], symMap;
      if (hasShammedSymbols) {
        symMap = {};
        for (var k = 0; k < syms.length; k++)
          symMap["$" + syms[k]] = syms[k];
      }
      for (var key in obj)
        has2(obj, key) && (isArr && String(Number(key)) === key && key < obj.length || hasShammedSymbols && symMap["$" + key] instanceof Symbol || ($test.call(/[^\w$]/, key) ? xs.push(inspect(key, obj) + ": " + inspect(obj[key], obj)) : xs.push(key + ": " + inspect(obj[key], obj))));
      if (typeof gOPS == "function")
        for (var j = 0; j < syms.length; j++)
          isEnumerable.call(obj, syms[j]) && xs.push("[" + inspect(syms[j]) + "]: " + inspect(obj[syms[j]], obj));
      return xs;
    }
  }
});

// ../../node_modules/.pnpm/side-channel@1.0.6/node_modules/side-channel/index.js
var require_side_channel = __commonJS({
  "../../node_modules/.pnpm/side-channel@1.0.6/node_modules/side-channel/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var GetIntrinsic = require_get_intrinsic(), callBound = require_callBound(), inspect = require_object_inspect(), $TypeError = require_type2(), $WeakMap = GetIntrinsic("%WeakMap%", !0), $Map = GetIntrinsic("%Map%", !0), $weakMapGet = callBound("WeakMap.prototype.get", !0), $weakMapSet = callBound("WeakMap.prototype.set", !0), $weakMapHas = callBound("WeakMap.prototype.has", !0), $mapGet = callBound("Map.prototype.get", !0), $mapSet = callBound("Map.prototype.set", !0), $mapHas = callBound("Map.prototype.has", !0), listGetNode = function(list2, key) {
      for (var prev = list2, curr; (curr = prev.next) !== null; prev = curr)
        if (curr.key === key)
          return prev.next = curr.next, curr.next = /** @type {NonNullable<typeof list.next>} */
          list2.next, list2.next = curr, curr;
    }, listGet = function(objects, key) {
      var node = listGetNode(objects, key);
      return node && node.value;
    }, listSet = function(objects, key, value) {
      var node = listGetNode(objects, key);
      node ? node.value = value : objects.next = /** @type {import('.').ListNode<typeof value>} */
      {
        // eslint-disable-line no-param-reassign, no-extra-parens
        key,
        next: objects.next,
        value
      };
    }, listHas = function(objects, key) {
      return !!listGetNode(objects, key);
    };
    module.exports = function() {
      var $wm, $m, $o, channel = {
        assert: function(key) {
          if (!channel.has(key))
            throw new $TypeError("Side channel does not contain " + inspect(key));
        },
        get: function(key) {
          if ($WeakMap && key && (typeof key == "object" || typeof key == "function")) {
            if ($wm)
              return $weakMapGet($wm, key);
          } else if ($Map) {
            if ($m)
              return $mapGet($m, key);
          } else if ($o)
            return listGet($o, key);
        },
        has: function(key) {
          if ($WeakMap && key && (typeof key == "object" || typeof key == "function")) {
            if ($wm)
              return $weakMapHas($wm, key);
          } else if ($Map) {
            if ($m)
              return $mapHas($m, key);
          } else if ($o)
            return listHas($o, key);
          return !1;
        },
        set: function(key, value) {
          $WeakMap && key && (typeof key == "object" || typeof key == "function") ? ($wm || ($wm = new $WeakMap()), $weakMapSet($wm, key, value)) : $Map ? ($m || ($m = new $Map()), $mapSet($m, key, value)) : ($o || ($o = { key: {}, next: null }), listSet($o, key, value));
        }
      };
      return channel;
    };
  }
});

// ../../node_modules/.pnpm/qs@6.11.0/node_modules/qs/lib/formats.js
var require_formats = __commonJS({
  "../../node_modules/.pnpm/qs@6.11.0/node_modules/qs/lib/formats.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var replace = String.prototype.replace, percentTwenties = /%20/g, Format = {
      RFC1738: "RFC1738",
      RFC3986: "RFC3986"
    };
    module.exports = {
      default: Format.RFC3986,
      formatters: {
        RFC1738: function(value) {
          return replace.call(value, percentTwenties, "+");
        },
        RFC3986: function(value) {
          return String(value);
        }
      },
      RFC1738: Format.RFC1738,
      RFC3986: Format.RFC3986
    };
  }
});

// ../../node_modules/.pnpm/qs@6.11.0/node_modules/qs/lib/utils.js
var require_utils14 = __commonJS({
  "../../node_modules/.pnpm/qs@6.11.0/node_modules/qs/lib/utils.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var formats2 = require_formats(), has2 = Object.prototype.hasOwnProperty, isArray = Array.isArray, hexTable = function() {
      for (var array = [], i = 0; i < 256; ++i)
        array.push("%" + ((i < 16 ? "0" : "") + i.toString(16)).toUpperCase());
      return array;
    }(), compactQueue = function(queue) {
      for (; queue.length > 1; ) {
        var item = queue.pop(), obj = item.obj[item.prop];
        if (isArray(obj)) {
          for (var compacted = [], j = 0; j < obj.length; ++j)
            typeof obj[j] < "u" && compacted.push(obj[j]);
          item.obj[item.prop] = compacted;
        }
      }
    }, arrayToObject = function(source, options) {
      for (var obj = options && options.plainObjects ? /* @__PURE__ */ Object.create(null) : {}, i = 0; i < source.length; ++i)
        typeof source[i] < "u" && (obj[i] = source[i]);
      return obj;
    }, merge = function merge2(target, source, options) {
      if (!source)
        return target;
      if (typeof source != "object") {
        if (isArray(target))
          target.push(source);
        else if (target && typeof target == "object")
          (options && (options.plainObjects || options.allowPrototypes) || !has2.call(Object.prototype, source)) && (target[source] = !0);
        else
          return [target, source];
        return target;
      }
      if (!target || typeof target != "object")
        return [target].concat(source);
      var mergeTarget = target;
      return isArray(target) && !isArray(source) && (mergeTarget = arrayToObject(target, options)), isArray(target) && isArray(source) ? (source.forEach(function(item, i) {
        if (has2.call(target, i)) {
          var targetItem = target[i];
          targetItem && typeof targetItem == "object" && item && typeof item == "object" ? target[i] = merge2(targetItem, item, options) : target.push(item);
        } else
          target[i] = item;
      }), target) : Object.keys(source).reduce(function(acc, key) {
        var value = source[key];
        return has2.call(acc, key) ? acc[key] = merge2(acc[key], value, options) : acc[key] = value, acc;
      }, mergeTarget);
    }, assign = function(target, source) {
      return Object.keys(source).reduce(function(acc, key) {
        return acc[key] = source[key], acc;
      }, target);
    }, decode = function(str, decoder, charset) {
      var strWithoutPlus = str.replace(/\+/g, " ");
      if (charset === "iso-8859-1")
        return strWithoutPlus.replace(/%[0-9a-f]{2}/gi, unescape);
      try {
        return decodeURIComponent(strWithoutPlus);
      } catch {
        return strWithoutPlus;
      }
    }, encode = function(str, defaultEncoder, charset, kind, format4) {
      if (str.length === 0)
        return str;
      var string = str;
      if (typeof str == "symbol" ? string = Symbol.prototype.toString.call(str) : typeof str != "string" && (string = String(str)), charset === "iso-8859-1")
        return escape(string).replace(/%u[0-9a-f]{4}/gi, function($0) {
          return "%26%23" + parseInt($0.slice(2), 16) + "%3B";
        });
      for (var out = "", i = 0; i < string.length; ++i) {
        var c = string.charCodeAt(i);
        if (c === 45 || c === 46 || c === 95 || c === 126 || c >= 48 && c <= 57 || c >= 65 && c <= 90 || c >= 97 && c <= 122 || format4 === formats2.RFC1738 && (c === 40 || c === 41)) {
          out += string.charAt(i);
          continue;
        }
        if (c < 128) {
          out = out + hexTable[c];
          continue;
        }
        if (c < 2048) {
          out = out + (hexTable[192 | c >> 6] + hexTable[128 | c & 63]);
          continue;
        }
        if (c < 55296 || c >= 57344) {
          out = out + (hexTable[224 | c >> 12] + hexTable[128 | c >> 6 & 63] + hexTable[128 | c & 63]);
          continue;
        }
        i += 1, c = 65536 + ((c & 1023) << 10 | string.charCodeAt(i) & 1023), out += hexTable[240 | c >> 18] + hexTable[128 | c >> 12 & 63] + hexTable[128 | c >> 6 & 63] + hexTable[128 | c & 63];
      }
      return out;
    }, compact2 = function(value) {
      for (var queue = [{ obj: { o: value }, prop: "o" }], refs = [], i = 0; i < queue.length; ++i)
        for (var item = queue[i], obj = item.obj[item.prop], keys = Object.keys(obj), j = 0; j < keys.length; ++j) {
          var key = keys[j], val = obj[key];
          typeof val == "object" && val !== null && refs.indexOf(val) === -1 && (queue.push({ obj, prop: key }), refs.push(val));
        }
      return compactQueue(queue), value;
    }, isRegExp = function(obj) {
      return Object.prototype.toString.call(obj) === "[object RegExp]";
    }, isBuffer = function(obj) {
      return !obj || typeof obj != "object" ? !1 : !!(obj.constructor && obj.constructor.isBuffer && obj.constructor.isBuffer(obj));
    }, combine = function(a, b) {
      return [].concat(a, b);
    }, maybeMap = function(val, fn) {
      if (isArray(val)) {
        for (var mapped = [], i = 0; i < val.length; i += 1)
          mapped.push(fn(val[i]));
        return mapped;
      }
      return fn(val);
    };
    module.exports = {
      arrayToObject,
      assign,
      combine,
      compact: compact2,
      decode,
      encode,
      isBuffer,
      isRegExp,
      maybeMap,
      merge
    };
  }
});

// ../../node_modules/.pnpm/qs@6.11.0/node_modules/qs/lib/stringify.js
var require_stringify2 = __commonJS({
  "../../node_modules/.pnpm/qs@6.11.0/node_modules/qs/lib/stringify.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var getSideChannel = require_side_channel(), utils = require_utils14(), formats2 = require_formats(), has2 = Object.prototype.hasOwnProperty, arrayPrefixGenerators = {
      brackets: function(prefix) {
        return prefix + "[]";
      },
      comma: "comma",
      indices: function(prefix, key) {
        return prefix + "[" + key + "]";
      },
      repeat: function(prefix) {
        return prefix;
      }
    }, isArray = Array.isArray, split = String.prototype.split, push2 = Array.prototype.push, pushToArray = function(arr, valueOrArray) {
      push2.apply(arr, isArray(valueOrArray) ? valueOrArray : [valueOrArray]);
    }, toISO = Date.prototype.toISOString, defaultFormat = formats2.default, defaults = {
      addQueryPrefix: !1,
      allowDots: !1,
      charset: "utf-8",
      charsetSentinel: !1,
      delimiter: "&",
      encode: !0,
      encoder: utils.encode,
      encodeValuesOnly: !1,
      format: defaultFormat,
      formatter: formats2.formatters[defaultFormat],
      // deprecated
      indices: !1,
      serializeDate: function(date) {
        return toISO.call(date);
      },
      skipNulls: !1,
      strictNullHandling: !1
    }, isNonNullishPrimitive = function(v) {
      return typeof v == "string" || typeof v == "number" || typeof v == "boolean" || typeof v == "symbol" || typeof v == "bigint";
    }, sentinel = {}, stringify = function stringify2(object, prefix, generateArrayPrefix, commaRoundTrip, strictNullHandling, skipNulls, encoder, filter, sort2, allowDots, serializeDate, format4, formatter, encodeValuesOnly, charset, sideChannel) {
      for (var obj = object, tmpSc = sideChannel, step = 0, findFlag = !1; (tmpSc = tmpSc.get(sentinel)) !== void 0 && !findFlag; ) {
        var pos = tmpSc.get(object);
        if (step += 1, typeof pos < "u") {
          if (pos === step)
            throw new RangeError("Cyclic object value");
          findFlag = !0;
        }
        typeof tmpSc.get(sentinel) > "u" && (step = 0);
      }
      if (typeof filter == "function" ? obj = filter(prefix, obj) : obj instanceof Date ? obj = serializeDate(obj) : generateArrayPrefix === "comma" && isArray(obj) && (obj = utils.maybeMap(obj, function(value2) {
        return value2 instanceof Date ? serializeDate(value2) : value2;
      })), obj === null) {
        if (strictNullHandling)
          return encoder && !encodeValuesOnly ? encoder(prefix, defaults.encoder, charset, "key", format4) : prefix;
        obj = "";
      }
      if (isNonNullishPrimitive(obj) || utils.isBuffer(obj)) {
        if (encoder) {
          var keyValue = encodeValuesOnly ? prefix : encoder(prefix, defaults.encoder, charset, "key", format4);
          if (generateArrayPrefix === "comma" && encodeValuesOnly) {
            for (var valuesArray = split.call(String(obj), ","), valuesJoined = "", i = 0; i < valuesArray.length; ++i)
              valuesJoined += (i === 0 ? "" : ",") + formatter(encoder(valuesArray[i], defaults.encoder, charset, "value", format4));
            return [formatter(keyValue) + (commaRoundTrip && isArray(obj) && valuesArray.length === 1 ? "[]" : "") + "=" + valuesJoined];
          }
          return [formatter(keyValue) + "=" + formatter(encoder(obj, defaults.encoder, charset, "value", format4))];
        }
        return [formatter(prefix) + "=" + formatter(String(obj))];
      }
      var values = [];
      if (typeof obj > "u")
        return values;
      var objKeys;
      if (generateArrayPrefix === "comma" && isArray(obj))
        objKeys = [{ value: obj.length > 0 ? obj.join(",") || null : void 0 }];
      else if (isArray(filter))
        objKeys = filter;
      else {
        var keys = Object.keys(obj);
        objKeys = sort2 ? keys.sort(sort2) : keys;
      }
      for (var adjustedPrefix = commaRoundTrip && isArray(obj) && obj.length === 1 ? prefix + "[]" : prefix, j = 0; j < objKeys.length; ++j) {
        var key = objKeys[j], value = typeof key == "object" && typeof key.value < "u" ? key.value : obj[key];
        if (!(skipNulls && value === null)) {
          var keyPrefix = isArray(obj) ? typeof generateArrayPrefix == "function" ? generateArrayPrefix(adjustedPrefix, key) : adjustedPrefix : adjustedPrefix + (allowDots ? "." + key : "[" + key + "]");
          sideChannel.set(object, step);
          var valueSideChannel = getSideChannel();
          valueSideChannel.set(sentinel, sideChannel), pushToArray(values, stringify2(
            value,
            keyPrefix,
            generateArrayPrefix,
            commaRoundTrip,
            strictNullHandling,
            skipNulls,
            encoder,
            filter,
            sort2,
            allowDots,
            serializeDate,
            format4,
            formatter,
            encodeValuesOnly,
            charset,
            valueSideChannel
          ));
        }
      }
      return values;
    }, normalizeStringifyOptions = function(opts) {
      if (!opts)
        return defaults;
      if (opts.encoder !== null && typeof opts.encoder < "u" && typeof opts.encoder != "function")
        throw new TypeError("Encoder has to be a function.");
      var charset = opts.charset || defaults.charset;
      if (typeof opts.charset < "u" && opts.charset !== "utf-8" && opts.charset !== "iso-8859-1")
        throw new TypeError("The charset option must be either utf-8, iso-8859-1, or undefined");
      var format4 = formats2.default;
      if (typeof opts.format < "u") {
        if (!has2.call(formats2.formatters, opts.format))
          throw new TypeError("Unknown format option provided.");
        format4 = opts.format;
      }
      var formatter = formats2.formatters[format4], filter = defaults.filter;
      return (typeof opts.filter == "function" || isArray(opts.filter)) && (filter = opts.filter), {
        addQueryPrefix: typeof opts.addQueryPrefix == "boolean" ? opts.addQueryPrefix : defaults.addQueryPrefix,
        allowDots: typeof opts.allowDots > "u" ? defaults.allowDots : !!opts.allowDots,
        charset,
        charsetSentinel: typeof opts.charsetSentinel == "boolean" ? opts.charsetSentinel : defaults.charsetSentinel,
        delimiter: typeof opts.delimiter > "u" ? defaults.delimiter : opts.delimiter,
        encode: typeof opts.encode == "boolean" ? opts.encode : defaults.encode,
        encoder: typeof opts.encoder == "function" ? opts.encoder : defaults.encoder,
        encodeValuesOnly: typeof opts.encodeValuesOnly == "boolean" ? opts.encodeValuesOnly : defaults.encodeValuesOnly,
        filter,
        format: format4,
        formatter,
        serializeDate: typeof opts.serializeDate == "function" ? opts.serializeDate : defaults.serializeDate,
        skipNulls: typeof opts.skipNulls == "boolean" ? opts.skipNulls : defaults.skipNulls,
        sort: typeof opts.sort == "function" ? opts.sort : null,
        strictNullHandling: typeof opts.strictNullHandling == "boolean" ? opts.strictNullHandling : defaults.strictNullHandling
      };
    };
    module.exports = function(object, opts) {
      var obj = object, options = normalizeStringifyOptions(opts), objKeys, filter;
      typeof options.filter == "function" ? (filter = options.filter, obj = filter("", obj)) : isArray(options.filter) && (filter = options.filter, objKeys = filter);
      var keys = [];
      if (typeof obj != "object" || obj === null)
        return "";
      var arrayFormat;
      opts && opts.arrayFormat in arrayPrefixGenerators ? arrayFormat = opts.arrayFormat : opts && "indices" in opts ? arrayFormat = opts.indices ? "indices" : "repeat" : arrayFormat = "indices";
      var generateArrayPrefix = arrayPrefixGenerators[arrayFormat];
      if (opts && "commaRoundTrip" in opts && typeof opts.commaRoundTrip != "boolean")
        throw new TypeError("`commaRoundTrip` must be a boolean, or absent");
      var commaRoundTrip = generateArrayPrefix === "comma" && opts && opts.commaRoundTrip;
      objKeys || (objKeys = Object.keys(obj)), options.sort && objKeys.sort(options.sort);
      for (var sideChannel = getSideChannel(), i = 0; i < objKeys.length; ++i) {
        var key = objKeys[i];
        options.skipNulls && obj[key] === null || pushToArray(keys, stringify(
          obj[key],
          key,
          generateArrayPrefix,
          commaRoundTrip,
          options.strictNullHandling,
          options.skipNulls,
          options.encode ? options.encoder : null,
          options.filter,
          options.sort,
          options.allowDots,
          options.serializeDate,
          options.format,
          options.formatter,
          options.encodeValuesOnly,
          options.charset,
          sideChannel
        ));
      }
      var joined = keys.join(options.delimiter), prefix = options.addQueryPrefix === !0 ? "?" : "";
      return options.charsetSentinel && (options.charset === "iso-8859-1" ? prefix += "utf8=%26%2310003%3B&" : prefix += "utf8=%E2%9C%93&"), joined.length > 0 ? prefix + joined : "";
    };
  }
});

// ../../node_modules/.pnpm/qs@6.11.0/node_modules/qs/lib/parse.js
var require_parse2 = __commonJS({
  "../../node_modules/.pnpm/qs@6.11.0/node_modules/qs/lib/parse.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var utils = require_utils14(), has2 = Object.prototype.hasOwnProperty, isArray = Array.isArray, defaults = {
      allowDots: !1,
      allowPrototypes: !1,
      allowSparse: !1,
      arrayLimit: 20,
      charset: "utf-8",
      charsetSentinel: !1,
      comma: !1,
      decoder: utils.decode,
      delimiter: "&",
      depth: 5,
      ignoreQueryPrefix: !1,
      interpretNumericEntities: !1,
      parameterLimit: 1e3,
      parseArrays: !0,
      plainObjects: !1,
      strictNullHandling: !1
    }, interpretNumericEntities = function(str) {
      return str.replace(/&#(\d+);/g, function($0, numberStr) {
        return String.fromCharCode(parseInt(numberStr, 10));
      });
    }, parseArrayValue = function(val, options) {
      return val && typeof val == "string" && options.comma && val.indexOf(",") > -1 ? val.split(",") : val;
    }, isoSentinel = "utf8=%26%2310003%3B", charsetSentinel = "utf8=%E2%9C%93", parseValues = function(str, options) {
      var obj = {}, cleanStr = options.ignoreQueryPrefix ? str.replace(/^\?/, "") : str, limit = options.parameterLimit === 1 / 0 ? void 0 : options.parameterLimit, parts = cleanStr.split(options.delimiter, limit), skipIndex = -1, i, charset = options.charset;
      if (options.charsetSentinel)
        for (i = 0; i < parts.length; ++i)
          parts[i].indexOf("utf8=") === 0 && (parts[i] === charsetSentinel ? charset = "utf-8" : parts[i] === isoSentinel && (charset = "iso-8859-1"), skipIndex = i, i = parts.length);
      for (i = 0; i < parts.length; ++i)
        if (i !== skipIndex) {
          var part = parts[i], bracketEqualsPos = part.indexOf("]="), pos = bracketEqualsPos === -1 ? part.indexOf("=") : bracketEqualsPos + 1, key, val;
          pos === -1 ? (key = options.decoder(part, defaults.decoder, charset, "key"), val = options.strictNullHandling ? null : "") : (key = options.decoder(part.slice(0, pos), defaults.decoder, charset, "key"), val = utils.maybeMap(
            parseArrayValue(part.slice(pos + 1), options),
            function(encodedVal) {
              return options.decoder(encodedVal, defaults.decoder, charset, "value");
            }
          )), val && options.interpretNumericEntities && charset === "iso-8859-1" && (val = interpretNumericEntities(val)), part.indexOf("[]=") > -1 && (val = isArray(val) ? [val] : val), has2.call(obj, key) ? obj[key] = utils.combine(obj[key], val) : obj[key] = val;
        }
      return obj;
    }, parseObject = function(chain, val, options, valuesParsed) {
      for (var leaf = valuesParsed ? val : parseArrayValue(val, options), i = chain.length - 1; i >= 0; --i) {
        var obj, root = chain[i];
        if (root === "[]" && options.parseArrays)
          obj = [].concat(leaf);
        else {
          obj = options.plainObjects ? /* @__PURE__ */ Object.create(null) : {};
          var cleanRoot = root.charAt(0) === "[" && root.charAt(root.length - 1) === "]" ? root.slice(1, -1) : root, index = parseInt(cleanRoot, 10);
          !options.parseArrays && cleanRoot === "" ? obj = { 0: leaf } : !isNaN(index) && root !== cleanRoot && String(index) === cleanRoot && index >= 0 && options.parseArrays && index <= options.arrayLimit ? (obj = [], obj[index] = leaf) : cleanRoot !== "__proto__" && (obj[cleanRoot] = leaf);
        }
        leaf = obj;
      }
      return leaf;
    }, parseKeys = function(givenKey, val, options, valuesParsed) {
      if (givenKey) {
        var key = options.allowDots ? givenKey.replace(/\.([^.[]+)/g, "[$1]") : givenKey, brackets = /(\[[^[\]]*])/, child = /(\[[^[\]]*])/g, segment = options.depth > 0 && brackets.exec(key), parent = segment ? key.slice(0, segment.index) : key, keys = [];
        if (parent) {
          if (!options.plainObjects && has2.call(Object.prototype, parent) && !options.allowPrototypes)
            return;
          keys.push(parent);
        }
        for (var i = 0; options.depth > 0 && (segment = child.exec(key)) !== null && i < options.depth; ) {
          if (i += 1, !options.plainObjects && has2.call(Object.prototype, segment[1].slice(1, -1)) && !options.allowPrototypes)
            return;
          keys.push(segment[1]);
        }
        return segment && keys.push("[" + key.slice(segment.index) + "]"), parseObject(keys, val, options, valuesParsed);
      }
    }, normalizeParseOptions = function(opts) {
      if (!opts)
        return defaults;
      if (opts.decoder !== null && opts.decoder !== void 0 && typeof opts.decoder != "function")
        throw new TypeError("Decoder has to be a function.");
      if (typeof opts.charset < "u" && opts.charset !== "utf-8" && opts.charset !== "iso-8859-1")
        throw new TypeError("The charset option must be either utf-8, iso-8859-1, or undefined");
      var charset = typeof opts.charset > "u" ? defaults.charset : opts.charset;
      return {
        allowDots: typeof opts.allowDots > "u" ? defaults.allowDots : !!opts.allowDots,
        allowPrototypes: typeof opts.allowPrototypes == "boolean" ? opts.allowPrototypes : defaults.allowPrototypes,
        allowSparse: typeof opts.allowSparse == "boolean" ? opts.allowSparse : defaults.allowSparse,
        arrayLimit: typeof opts.arrayLimit == "number" ? opts.arrayLimit : defaults.arrayLimit,
        charset,
        charsetSentinel: typeof opts.charsetSentinel == "boolean" ? opts.charsetSentinel : defaults.charsetSentinel,
        comma: typeof opts.comma == "boolean" ? opts.comma : defaults.comma,
        decoder: typeof opts.decoder == "function" ? opts.decoder : defaults.decoder,
        delimiter: typeof opts.delimiter == "string" || utils.isRegExp(opts.delimiter) ? opts.delimiter : defaults.delimiter,
        // eslint-disable-next-line no-implicit-coercion, no-extra-parens
        depth: typeof opts.depth == "number" || opts.depth === !1 ? +opts.depth : defaults.depth,
        ignoreQueryPrefix: opts.ignoreQueryPrefix === !0,
        interpretNumericEntities: typeof opts.interpretNumericEntities == "boolean" ? opts.interpretNumericEntities : defaults.interpretNumericEntities,
        parameterLimit: typeof opts.parameterLimit == "number" ? opts.parameterLimit : defaults.parameterLimit,
        parseArrays: opts.parseArrays !== !1,
        plainObjects: typeof opts.plainObjects == "boolean" ? opts.plainObjects : defaults.plainObjects,
        strictNullHandling: typeof opts.strictNullHandling == "boolean" ? opts.strictNullHandling : defaults.strictNullHandling
      };
    };
    module.exports = function(str, opts) {
      var options = normalizeParseOptions(opts);
      if (str === "" || str === null || typeof str > "u")
        return options.plainObjects ? /* @__PURE__ */ Object.create(null) : {};
      for (var tempObj = typeof str == "string" ? parseValues(str, options) : str, obj = options.plainObjects ? /* @__PURE__ */ Object.create(null) : {}, keys = Object.keys(tempObj), i = 0; i < keys.length; ++i) {
        var key = keys[i], newObj = parseKeys(key, tempObj[key], options, typeof str == "string");
        obj = utils.merge(obj, newObj, options);
      }
      return options.allowSparse === !0 ? obj : utils.compact(obj);
    };
  }
});

// ../../node_modules/.pnpm/qs@6.11.0/node_modules/qs/lib/index.js
var require_lib9 = __commonJS({
  "../../node_modules/.pnpm/qs@6.11.0/node_modules/qs/lib/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var stringify = require_stringify2(), parse4 = require_parse2(), formats2 = require_formats();
    module.exports = {
      formats: formats2,
      parse: parse4,
      stringify
    };
  }
});

// ../../node_modules/.pnpm/body-parser@1.20.2/node_modules/body-parser/lib/types/urlencoded.js
var require_urlencoded = __commonJS({
  "../../node_modules/.pnpm/body-parser@1.20.2/node_modules/body-parser/lib/types/urlencoded.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var bytes = require_bytes(), contentType = require_content_type(), createError2 = require_http_errors(), debug4 = require_src2()("body-parser:urlencoded"), deprecate = require_depd()("body-parser"), read = require_read(), typeis = require_type_is();
    module.exports = urlencoded;
    var parsers = /* @__PURE__ */ Object.create(null);
    function urlencoded(options) {
      var opts = options || {};
      opts.extended === void 0 && deprecate("undefined extended: provide extended option");
      var extended = opts.extended !== !1, inflate = opts.inflate !== !1, limit = typeof opts.limit != "number" ? bytes.parse(opts.limit || "100kb") : opts.limit, type = opts.type || "application/x-www-form-urlencoded", verify = opts.verify || !1;
      if (verify !== !1 && typeof verify != "function")
        throw new TypeError("option verify must be function");
      var queryparse = extended ? extendedparser(opts) : simpleparser(opts), shouldParse = typeof type != "function" ? typeChecker(type) : type;
      function parse4(body) {
        return body.length ? queryparse(body) : {};
      }
      return function(req, res, next) {
        if (req._body) {
          debug4("body already parsed"), next();
          return;
        }
        if (req.body = req.body || {}, !typeis.hasBody(req)) {
          debug4("skip empty body"), next();
          return;
        }
        if (debug4("content-type %j", req.headers["content-type"]), !shouldParse(req)) {
          debug4("skip parsing"), next();
          return;
        }
        var charset = getCharset(req) || "utf-8";
        if (charset !== "utf-8") {
          debug4("invalid charset"), next(createError2(415, 'unsupported charset "' + charset.toUpperCase() + '"', {
            charset,
            type: "charset.unsupported"
          }));
          return;
        }
        read(req, res, next, parse4, debug4, {
          debug: debug4,
          encoding: charset,
          inflate,
          limit,
          verify
        });
      };
    }
    function extendedparser(options) {
      var parameterLimit = options.parameterLimit !== void 0 ? options.parameterLimit : 1e3, parse4 = parser("qs");
      if (isNaN(parameterLimit) || parameterLimit < 1)
        throw new TypeError("option parameterLimit must be a positive number");
      return isFinite(parameterLimit) && (parameterLimit = parameterLimit | 0), function(body) {
        var paramCount = parameterCount(body, parameterLimit);
        if (paramCount === void 0)
          throw debug4("too many parameters"), createError2(413, "too many parameters", {
            type: "parameters.too.many"
          });
        var arrayLimit = Math.max(100, paramCount);
        return debug4("parse extended urlencoding"), parse4(body, {
          allowPrototypes: !0,
          arrayLimit,
          depth: 1 / 0,
          parameterLimit
        });
      };
    }
    function getCharset(req) {
      try {
        return (contentType.parse(req).parameters.charset || "").toLowerCase();
      } catch {
        return;
      }
    }
    function parameterCount(body, limit) {
      for (var count = 0, index = 0; (index = body.indexOf("&", index)) !== -1; )
        if (count++, index++, count === limit)
          return;
      return count;
    }
    function parser(name) {
      var mod = parsers[name];
      if (mod !== void 0)
        return mod.parse;
      switch (name) {
        case "qs":
          mod = require_lib9();
          break;
        case "querystring":
          mod = __require("querystring");
          break;
      }
      return parsers[name] = mod, mod.parse;
    }
    function simpleparser(options) {
      var parameterLimit = options.parameterLimit !== void 0 ? options.parameterLimit : 1e3, parse4 = parser("querystring");
      if (isNaN(parameterLimit) || parameterLimit < 1)
        throw new TypeError("option parameterLimit must be a positive number");
      return isFinite(parameterLimit) && (parameterLimit = parameterLimit | 0), function(body) {
        var paramCount = parameterCount(body, parameterLimit);
        if (paramCount === void 0)
          throw debug4("too many parameters"), createError2(413, "too many parameters", {
            type: "parameters.too.many"
          });
        return debug4("parse urlencoding"), parse4(body, void 0, void 0, { maxKeys: parameterLimit });
      };
    }
    function typeChecker(type) {
      return function(req) {
        return !!typeis(req, type);
      };
    }
  }
});

// ../../node_modules/.pnpm/body-parser@1.20.2/node_modules/body-parser/index.js
var require_body_parser = __commonJS({
  "../../node_modules/.pnpm/body-parser@1.20.2/node_modules/body-parser/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var deprecate = require_depd()("body-parser"), parsers = /* @__PURE__ */ Object.create(null);
    exports = module.exports = deprecate.function(
      bodyParser2,
      "bodyParser: use individual json/urlencoded middlewares"
    );
    Object.defineProperty(exports, "json", {
      configurable: !0,
      enumerable: !0,
      get: createParserGetter("json")
    });
    Object.defineProperty(exports, "raw", {
      configurable: !0,
      enumerable: !0,
      get: createParserGetter("raw")
    });
    Object.defineProperty(exports, "text", {
      configurable: !0,
      enumerable: !0,
      get: createParserGetter("text")
    });
    Object.defineProperty(exports, "urlencoded", {
      configurable: !0,
      enumerable: !0,
      get: createParserGetter("urlencoded")
    });
    function bodyParser2(options) {
      var opts = Object.create(options || null, {
        type: {
          configurable: !0,
          enumerable: !0,
          value: void 0,
          writable: !0
        }
      }), _urlencoded = exports.urlencoded(opts), _json = exports.json(opts);
      return function(req, res, next) {
        _json(req, res, function(err2) {
          if (err2)
            return next(err2);
          _urlencoded(req, res, next);
        });
      };
    }
    function createParserGetter(name) {
      return function() {
        return loadParser(name);
      };
    }
    function loadParser(parserName) {
      var parser = parsers[parserName];
      if (parser !== void 0)
        return parser;
      switch (parserName) {
        case "json":
          parser = require_json6();
          break;
        case "raw":
          parser = require_raw();
          break;
        case "text":
          parser = require_text3();
          break;
        case "urlencoded":
          parser = require_urlencoded();
          break;
      }
      return parsers[parserName] = parser;
    }
  }
});

// ../../node_modules/.pnpm/merge-descriptors@1.0.1/node_modules/merge-descriptors/index.js
var require_merge_descriptors = __commonJS({
  "../../node_modules/.pnpm/merge-descriptors@1.0.1/node_modules/merge-descriptors/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = merge;
    var hasOwnProperty = Object.prototype.hasOwnProperty;
    function merge(dest, src, redefine) {
      if (!dest)
        throw new TypeError("argument dest is required");
      if (!src)
        throw new TypeError("argument src is required");
      return redefine === void 0 && (redefine = !0), Object.getOwnPropertyNames(src).forEach(function(name) {
        if (!(!redefine && hasOwnProperty.call(dest, name))) {
          var descriptor = Object.getOwnPropertyDescriptor(src, name);
          Object.defineProperty(dest, name, descriptor);
        }
      }), dest;
    }
  }
});

// ../../node_modules/.pnpm/encodeurl@1.0.2/node_modules/encodeurl/index.js
var require_encodeurl = __commonJS({
  "../../node_modules/.pnpm/encodeurl@1.0.2/node_modules/encodeurl/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = encodeUrl;
    var ENCODE_CHARS_REGEXP = /(?:[^\x21\x25\x26-\x3B\x3D\x3F-\x5B\x5D\x5F\x61-\x7A\x7E]|%(?:[^0-9A-Fa-f]|[0-9A-Fa-f][^0-9A-Fa-f]|$))+/g, UNMATCHED_SURROGATE_PAIR_REGEXP = /(^|[^\uD800-\uDBFF])[\uDC00-\uDFFF]|[\uD800-\uDBFF]([^\uDC00-\uDFFF]|$)/g, UNMATCHED_SURROGATE_PAIR_REPLACE = "$1\uFFFD$2";
    function encodeUrl(url) {
      return String(url).replace(UNMATCHED_SURROGATE_PAIR_REGEXP, UNMATCHED_SURROGATE_PAIR_REPLACE).replace(ENCODE_CHARS_REGEXP, encodeURI);
    }
  }
});

// ../../node_modules/.pnpm/escape-html@1.0.3/node_modules/escape-html/index.js
var require_escape_html = __commonJS({
  "../../node_modules/.pnpm/escape-html@1.0.3/node_modules/escape-html/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var matchHtmlRegExp = /["'&<>]/;
    module.exports = escapeHtml;
    function escapeHtml(string) {
      var str = "" + string, match2 = matchHtmlRegExp.exec(str);
      if (!match2)
        return str;
      var escape2, html = "", index = 0, lastIndex = 0;
      for (index = match2.index; index < str.length; index++) {
        switch (str.charCodeAt(index)) {
          case 34:
            escape2 = "&quot;";
            break;
          case 38:
            escape2 = "&amp;";
            break;
          case 39:
            escape2 = "&#39;";
            break;
          case 60:
            escape2 = "&lt;";
            break;
          case 62:
            escape2 = "&gt;";
            break;
          default:
            continue;
        }
        lastIndex !== index && (html += str.substring(lastIndex, index)), lastIndex = index + 1, html += escape2;
      }
      return lastIndex !== index ? html + str.substring(lastIndex, index) : html;
    }
  }
});

// ../../node_modules/.pnpm/parseurl@1.3.3/node_modules/parseurl/index.js
var require_parseurl = __commonJS({
  "../../node_modules/.pnpm/parseurl@1.3.3/node_modules/parseurl/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var url = __require("url"), parse4 = url.parse, Url = url.Url;
    module.exports = parseurl;
    module.exports.original = originalurl;
    function parseurl(req) {
      var url2 = req.url;
      if (url2 !== void 0) {
        var parsed = req._parsedUrl;
        return fresh(url2, parsed) ? parsed : (parsed = fastparse(url2), parsed._raw = url2, req._parsedUrl = parsed);
      }
    }
    function originalurl(req) {
      var url2 = req.originalUrl;
      if (typeof url2 != "string")
        return parseurl(req);
      var parsed = req._parsedOriginalUrl;
      return fresh(url2, parsed) ? parsed : (parsed = fastparse(url2), parsed._raw = url2, req._parsedOriginalUrl = parsed);
    }
    function fastparse(str) {
      if (typeof str != "string" || str.charCodeAt(0) !== 47)
        return parse4(str);
      for (var pathname = str, query = null, search = null, i = 1; i < str.length; i++)
        switch (str.charCodeAt(i)) {
          case 63:
            search === null && (pathname = str.substring(0, i), query = str.substring(i + 1), search = str.substring(i));
            break;
          case 9:
          case 10:
          case 12:
          case 13:
          case 32:
          case 35:
          case 160:
          case 65279:
            return parse4(str);
        }
      var url2 = Url !== void 0 ? new Url() : {};
      return url2.path = str, url2.href = str, url2.pathname = pathname, search !== null && (url2.query = query, url2.search = search), url2;
    }
    function fresh(url2, parsedUrl) {
      return typeof parsedUrl == "object" && parsedUrl !== null && (Url === void 0 || parsedUrl instanceof Url) && parsedUrl._raw === url2;
    }
  }
});

// ../../node_modules/.pnpm/finalhandler@1.2.0/node_modules/finalhandler/index.js
var require_finalhandler = __commonJS({
  "../../node_modules/.pnpm/finalhandler@1.2.0/node_modules/finalhandler/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var debug4 = require_src2()("finalhandler"), encodeUrl = require_encodeurl(), escapeHtml = require_escape_html(), onFinished = require_on_finished(), parseUrl = require_parseurl(), statuses = require_statuses(), unpipe = require_unpipe(), DOUBLE_SPACE_REGEXP = /\x20{2}/g, NEWLINE_REGEXP = /\n/g, defer2 = typeof setImmediate == "function" ? setImmediate : function(fn) {
      process.nextTick(fn.bind.apply(fn, arguments));
    }, isFinished = onFinished.isFinished;
    function createHtmlDocument(message) {
      var body = escapeHtml(message).replace(NEWLINE_REGEXP, "<br>").replace(DOUBLE_SPACE_REGEXP, " &nbsp;");
      return `<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<title>Error</title>
</head>
<body>
<pre>` + body + `</pre>
</body>
</html>
`;
    }
    module.exports = finalhandler;
    function finalhandler(req, res, options) {
      var opts = options || {}, env = opts.env || process.env.NODE_ENV || "development", onerror = opts.onerror;
      return function(err2) {
        var headers, msg, status;
        if (!err2 && headersSent(res)) {
          debug4("cannot 404 after headers sent");
          return;
        }
        if (err2 ? (status = getErrorStatusCode(err2), status === void 0 ? status = getResponseStatusCode(res) : headers = getErrorHeaders(err2), msg = getErrorMessage(err2, status, env)) : (status = 404, msg = "Cannot " + req.method + " " + encodeUrl(getResourceName(req))), debug4("default %s", status), err2 && onerror && defer2(onerror, err2, req, res), headersSent(res)) {
          debug4("cannot %d after headers sent", status), req.socket.destroy();
          return;
        }
        send2(req, res, status, headers, msg);
      };
    }
    function getErrorHeaders(err2) {
      if (!(!err2.headers || typeof err2.headers != "object")) {
        for (var headers = /* @__PURE__ */ Object.create(null), keys = Object.keys(err2.headers), i = 0; i < keys.length; i++) {
          var key = keys[i];
          headers[key] = err2.headers[key];
        }
        return headers;
      }
    }
    function getErrorMessage(err2, status, env) {
      var msg;
      return env !== "production" && (msg = err2.stack, !msg && typeof err2.toString == "function" && (msg = err2.toString())), msg || statuses.message[status];
    }
    function getErrorStatusCode(err2) {
      if (typeof err2.status == "number" && err2.status >= 400 && err2.status < 600)
        return err2.status;
      if (typeof err2.statusCode == "number" && err2.statusCode >= 400 && err2.statusCode < 600)
        return err2.statusCode;
    }
    function getResourceName(req) {
      try {
        return parseUrl.original(req).pathname;
      } catch {
        return "resource";
      }
    }
    function getResponseStatusCode(res) {
      var status = res.statusCode;
      return (typeof status != "number" || status < 400 || status > 599) && (status = 500), status;
    }
    function headersSent(res) {
      return typeof res.headersSent != "boolean" ? !!res._header : res.headersSent;
    }
    function send2(req, res, status, headers, message) {
      function write() {
        var body = createHtmlDocument(message);
        if (res.statusCode = status, res.statusMessage = statuses.message[status], res.removeHeader("Content-Encoding"), res.removeHeader("Content-Language"), res.removeHeader("Content-Range"), setHeaders(res, headers), res.setHeader("Content-Security-Policy", "default-src 'none'"), res.setHeader("X-Content-Type-Options", "nosniff"), res.setHeader("Content-Type", "text/html; charset=utf-8"), res.setHeader("Content-Length", Buffer.byteLength(body, "utf8")), req.method === "HEAD") {
          res.end();
          return;
        }
        res.end(body, "utf8");
      }
      if (isFinished(req)) {
        write();
        return;
      }
      unpipe(req), onFinished(req, write), req.resume();
    }
    function setHeaders(res, headers) {
      if (headers)
        for (var keys = Object.keys(headers), i = 0; i < keys.length; i++) {
          var key = keys[i];
          res.setHeader(key, headers[key]);
        }
    }
  }
});

// ../../node_modules/.pnpm/array-flatten@1.1.1/node_modules/array-flatten/array-flatten.js
var require_array_flatten = __commonJS({
  "../../node_modules/.pnpm/array-flatten@1.1.1/node_modules/array-flatten/array-flatten.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = arrayFlatten;
    function flattenWithDepth(array, result, depth) {
      for (var i = 0; i < array.length; i++) {
        var value = array[i];
        depth > 0 && Array.isArray(value) ? flattenWithDepth(value, result, depth - 1) : result.push(value);
      }
      return result;
    }
    function flattenForever(array, result) {
      for (var i = 0; i < array.length; i++) {
        var value = array[i];
        Array.isArray(value) ? flattenForever(value, result) : result.push(value);
      }
      return result;
    }
    function arrayFlatten(array, depth) {
      return depth == null ? flattenForever(array, []) : flattenWithDepth(array, [], depth);
    }
  }
});

// ../../node_modules/.pnpm/path-to-regexp@0.1.7/node_modules/path-to-regexp/index.js
var require_path_to_regexp = __commonJS({
  "../../node_modules/.pnpm/path-to-regexp@0.1.7/node_modules/path-to-regexp/index.js"(exports, module) {
    init_cjs_shims();
    module.exports = pathtoRegexp;
    var MATCHING_GROUP_REGEXP = /\((?!\?)/g;
    function pathtoRegexp(path3, keys, options) {
      options = options || {}, keys = keys || [];
      var strict = options.strict, end = options.end !== !1, flags = options.sensitive ? "" : "i", extraOffset = 0, keysOffset = keys.length, i = 0, name = 0, m;
      if (path3 instanceof RegExp) {
        for (; m = MATCHING_GROUP_REGEXP.exec(path3.source); )
          keys.push({
            name: name++,
            optional: !1,
            offset: m.index
          });
        return path3;
      }
      if (Array.isArray(path3))
        return path3 = path3.map(function(value) {
          return pathtoRegexp(value, keys, options).source;
        }), new RegExp("(?:" + path3.join("|") + ")", flags);
      for (path3 = ("^" + path3 + (strict ? "" : path3[path3.length - 1] === "/" ? "?" : "/?")).replace(/\/\(/g, "/(?:").replace(/([\/\.])/g, "\\$1").replace(/(\\\/)?(\\\.)?:(\w+)(\(.*?\))?(\*)?(\?)?/g, function(match2, slash, format4, key, capture, star, optional, offset) {
        slash = slash || "", format4 = format4 || "", capture = capture || "([^\\/" + format4 + "]+?)", optional = optional || "", keys.push({
          name: key,
          optional: !!optional,
          offset: offset + extraOffset
        });
        var result = "" + (optional ? "" : slash) + "(?:" + format4 + (optional ? slash : "") + capture + (star ? "((?:[\\/" + format4 + "].+?)?)" : "") + ")" + optional;
        return extraOffset += result.length - match2.length, result;
      }).replace(/\*/g, function(star, index2) {
        for (var len = keys.length; len-- > keysOffset && keys[len].offset > index2; )
          keys[len].offset += 3;
        return "(.*)";
      }); m = MATCHING_GROUP_REGEXP.exec(path3); ) {
        for (var escapeCount = 0, index = m.index; path3.charAt(--index) === "\\"; )
          escapeCount++;
        escapeCount % 2 !== 1 && ((keysOffset + i === keys.length || keys[keysOffset + i].offset > m.index) && keys.splice(keysOffset + i, 0, {
          name: name++,
          // Unnamed matching groups must be consistently linear.
          optional: !1,
          offset: m.index
        }), i++);
      }
      return path3 += end ? "$" : path3[path3.length - 1] === "/" ? "" : "(?=\\/|$)", new RegExp(path3, flags);
    }
  }
});

// ../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/router/layer.js
var require_layer = __commonJS({
  "../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/router/layer.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var pathRegexp = require_path_to_regexp(), debug4 = require_src2()("express:router:layer"), hasOwnProperty = Object.prototype.hasOwnProperty;
    module.exports = Layer;
    function Layer(path3, options, fn) {
      if (!(this instanceof Layer))
        return new Layer(path3, options, fn);
      debug4("new %o", path3);
      var opts = options || {};
      this.handle = fn, this.name = fn.name || "<anonymous>", this.params = void 0, this.path = void 0, this.regexp = pathRegexp(path3, this.keys = [], opts), this.regexp.fast_star = path3 === "*", this.regexp.fast_slash = path3 === "/" && opts.end === !1;
    }
    Layer.prototype.handle_error = function(error, req, res, next) {
      var fn = this.handle;
      if (fn.length !== 4)
        return next(error);
      try {
        fn(error, req, res, next);
      } catch (err2) {
        next(err2);
      }
    };
    Layer.prototype.handle_request = function(req, res, next) {
      var fn = this.handle;
      if (fn.length > 3)
        return next();
      try {
        fn(req, res, next);
      } catch (err2) {
        next(err2);
      }
    };
    Layer.prototype.match = function(path3) {
      var match3;
      if (path3 != null) {
        if (this.regexp.fast_slash)
          return this.params = {}, this.path = "", !0;
        if (this.regexp.fast_star)
          return this.params = { 0: decode_param(path3) }, this.path = path3, !0;
        match3 = this.regexp.exec(path3);
      }
      if (!match3)
        return this.params = void 0, this.path = void 0, !1;
      this.params = {}, this.path = match3[0];
      for (var keys = this.keys, params = this.params, i = 1; i < match3.length; i++) {
        var key = keys[i - 1], prop = key.name, val = decode_param(match3[i]);
        (val !== void 0 || !hasOwnProperty.call(params, prop)) && (params[prop] = val);
      }
      return !0;
    };
    function decode_param(val) {
      if (typeof val != "string" || val.length === 0)
        return val;
      try {
        return decodeURIComponent(val);
      } catch (err2) {
        throw err2 instanceof URIError && (err2.message = "Failed to decode param '" + val + "'", err2.status = err2.statusCode = 400), err2;
      }
    }
  }
});

// ../../node_modules/.pnpm/methods@1.1.2/node_modules/methods/index.js
var require_methods = __commonJS({
  "../../node_modules/.pnpm/methods@1.1.2/node_modules/methods/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var http3 = __require("http");
    module.exports = getCurrentNodeMethods() || getBasicNodeMethods();
    function getCurrentNodeMethods() {
      return http3.METHODS && http3.METHODS.map(function(method) {
        return method.toLowerCase();
      });
    }
    function getBasicNodeMethods() {
      return [
        "get",
        "post",
        "put",
        "head",
        "delete",
        "options",
        "trace",
        "copy",
        "lock",
        "mkcol",
        "move",
        "purge",
        "propfind",
        "proppatch",
        "unlock",
        "report",
        "mkactivity",
        "checkout",
        "merge",
        "m-search",
        "notify",
        "subscribe",
        "unsubscribe",
        "patch",
        "search",
        "connect"
      ];
    }
  }
});

// ../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/router/route.js
var require_route = __commonJS({
  "../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/router/route.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var debug4 = require_src2()("express:router:route"), flatten = require_array_flatten(), Layer = require_layer(), methods = require_methods(), slice = Array.prototype.slice, toString2 = Object.prototype.toString;
    module.exports = Route;
    function Route(path3) {
      this.path = path3, this.stack = [], debug4("new %o", path3), this.methods = {};
    }
    Route.prototype._handles_method = function(method) {
      if (this.methods._all)
        return !0;
      var name = typeof method == "string" ? method.toLowerCase() : method;
      return name === "head" && !this.methods.head && (name = "get"), !!this.methods[name];
    };
    Route.prototype._options = function() {
      var methods2 = Object.keys(this.methods);
      this.methods.get && !this.methods.head && methods2.push("head");
      for (var i = 0; i < methods2.length; i++)
        methods2[i] = methods2[i].toUpperCase();
      return methods2;
    };
    Route.prototype.dispatch = function(req, res, done) {
      var idx = 0, stack = this.stack, sync = 0;
      if (stack.length === 0)
        return done();
      var method = typeof req.method == "string" ? req.method.toLowerCase() : req.method;
      method === "head" && !this.methods.head && (method = "get"), req.route = this, next();
      function next(err2) {
        if (err2 && err2 === "route")
          return done();
        if (err2 && err2 === "router")
          return done(err2);
        if (++sync > 100)
          return setImmediate(next, err2);
        var layer = stack[idx++];
        if (!layer)
          return done(err2);
        layer.method && layer.method !== method ? next(err2) : err2 ? layer.handle_error(err2, req, res, next) : layer.handle_request(req, res, next), sync = 0;
      }
    };
    Route.prototype.all = function() {
      for (var handles = flatten(slice.call(arguments)), i = 0; i < handles.length; i++) {
        var handle = handles[i];
        if (typeof handle != "function") {
          var type = toString2.call(handle), msg = "Route.all() requires a callback function but got a " + type;
          throw new TypeError(msg);
        }
        var layer = Layer("/", {}, handle);
        layer.method = void 0, this.methods._all = !0, this.stack.push(layer);
      }
      return this;
    };
    methods.forEach(function(method) {
      Route.prototype[method] = function() {
        for (var handles = flatten(slice.call(arguments)), i = 0; i < handles.length; i++) {
          var handle = handles[i];
          if (typeof handle != "function") {
            var type = toString2.call(handle), msg = "Route." + method + "() requires a callback function but got a " + type;
            throw new Error(msg);
          }
          debug4("%s %o", method, this.path);
          var layer = Layer("/", {}, handle);
          layer.method = method, this.methods[method] = !0, this.stack.push(layer);
        }
        return this;
      };
    });
  }
});

// ../../node_modules/.pnpm/utils-merge@1.0.1/node_modules/utils-merge/index.js
var require_utils_merge = __commonJS({
  "../../node_modules/.pnpm/utils-merge@1.0.1/node_modules/utils-merge/index.js"(exports, module) {
    init_cjs_shims();
    exports = module.exports = function(a, b) {
      if (a && b)
        for (var key in b)
          a[key] = b[key];
      return a;
    };
  }
});

// ../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/router/index.js
var require_router = __commonJS({
  "../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/router/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Route = require_route(), Layer = require_layer(), methods = require_methods(), mixin = require_utils_merge(), debug4 = require_src2()("express:router"), deprecate = require_depd()("express"), flatten = require_array_flatten(), parseUrl = require_parseurl(), setPrototypeOf = require_setprototypeof(), objectRegExp = /^\[object (\S+)\]$/, slice = Array.prototype.slice, toString2 = Object.prototype.toString, proto = module.exports = function(options) {
      var opts = options || {};
      function router(req, res, next) {
        router.handle(req, res, next);
      }
      return setPrototypeOf(router, proto), router.params = {}, router._params = [], router.caseSensitive = opts.caseSensitive, router.mergeParams = opts.mergeParams, router.strict = opts.strict, router.stack = [], router;
    };
    proto.param = function(name, fn) {
      if (typeof name == "function") {
        deprecate("router.param(fn): Refactor to use path params"), this._params.push(name);
        return;
      }
      var params = this._params, len = params.length, ret;
      name[0] === ":" && (deprecate("router.param(" + JSON.stringify(name) + ", fn): Use router.param(" + JSON.stringify(name.slice(1)) + ", fn) instead"), name = name.slice(1));
      for (var i = 0; i < len; ++i)
        (ret = params[i](name, fn)) && (fn = ret);
      if (typeof fn != "function")
        throw new Error("invalid param() call for " + name + ", got " + fn);
      return (this.params[name] = this.params[name] || []).push(fn), this;
    };
    proto.handle = function(req, res, out) {
      var self2 = this;
      debug4("dispatching %s %s", req.method, req.url);
      var idx = 0, protohost = getProtohost(req.url) || "", removed = "", slashAdded = !1, sync = 0, paramcalled = {}, options = [], stack = self2.stack, parentParams = req.params, parentUrl = req.baseUrl || "", done = restore(out, req, "baseUrl", "next", "params");
      req.next = next, req.method === "OPTIONS" && (done = wrap(done, function(old, err2) {
        if (err2 || options.length === 0)
          return old(err2);
        sendOptionsResponse(res, options, old);
      })), req.baseUrl = parentUrl, req.originalUrl = req.originalUrl || req.url, next();
      function next(err2) {
        var layerError = err2 === "route" ? null : err2;
        if (slashAdded && (req.url = req.url.slice(1), slashAdded = !1), removed.length !== 0 && (req.baseUrl = parentUrl, req.url = protohost + removed + req.url.slice(protohost.length), removed = ""), layerError === "router") {
          setImmediate(done, null);
          return;
        }
        if (idx >= stack.length) {
          setImmediate(done, layerError);
          return;
        }
        if (++sync > 100)
          return setImmediate(next, err2);
        var path3 = getPathname(req);
        if (path3 == null)
          return done(layerError);
        for (var layer, match2, route; match2 !== !0 && idx < stack.length; )
          if (layer = stack[idx++], match2 = matchLayer(layer, path3), route = layer.route, typeof match2 != "boolean" && (layerError = layerError || match2), match2 === !0 && route) {
            if (layerError) {
              match2 = !1;
              continue;
            }
            var method = req.method, has_method = route._handles_method(method);
            !has_method && method === "OPTIONS" && appendMethods(options, route._options()), !has_method && method !== "HEAD" && (match2 = !1);
          }
        if (match2 !== !0)
          return done(layerError);
        route && (req.route = route), req.params = self2.mergeParams ? mergeParams(layer.params, parentParams) : layer.params;
        var layerPath = layer.path;
        self2.process_params(layer, paramcalled, req, res, function(err3) {
          err3 ? next(layerError || err3) : route ? layer.handle_request(req, res, next) : trim_prefix(layer, layerError, layerPath, path3), sync = 0;
        });
      }
      function trim_prefix(layer, layerError, layerPath, path3) {
        if (layerPath.length !== 0) {
          if (layerPath !== path3.slice(0, layerPath.length)) {
            next(layerError);
            return;
          }
          var c = path3[layerPath.length];
          if (c && c !== "/" && c !== ".")
            return next(layerError);
          debug4("trim prefix (%s) from url %s", layerPath, req.url), removed = layerPath, req.url = protohost + req.url.slice(protohost.length + removed.length), !protohost && req.url[0] !== "/" && (req.url = "/" + req.url, slashAdded = !0), req.baseUrl = parentUrl + (removed[removed.length - 1] === "/" ? removed.substring(0, removed.length - 1) : removed);
        }
        debug4("%s %s : %s", layer.name, layerPath, req.originalUrl), layerError ? layer.handle_error(layerError, req, res, next) : layer.handle_request(req, res, next);
      }
    };
    proto.process_params = function(layer, called, req, res, done) {
      var params = this.params, keys = layer.keys;
      if (!keys || keys.length === 0)
        return done();
      var i = 0, name, paramIndex = 0, key, paramVal, paramCallbacks, paramCalled;
      function param(err2) {
        if (err2)
          return done(err2);
        if (i >= keys.length)
          return done();
        if (paramIndex = 0, key = keys[i++], name = key.name, paramVal = req.params[name], paramCallbacks = params[name], paramCalled = called[name], paramVal === void 0 || !paramCallbacks)
          return param();
        if (paramCalled && (paramCalled.match === paramVal || paramCalled.error && paramCalled.error !== "route"))
          return req.params[name] = paramCalled.value, param(paramCalled.error);
        called[name] = paramCalled = {
          error: null,
          match: paramVal,
          value: paramVal
        }, paramCallback();
      }
      function paramCallback(err2) {
        var fn = paramCallbacks[paramIndex++];
        if (paramCalled.value = req.params[key.name], err2) {
          paramCalled.error = err2, param(err2);
          return;
        }
        if (!fn)
          return param();
        try {
          fn(req, res, paramCallback, paramVal, key.name);
        } catch (e) {
          paramCallback(e);
        }
      }
      param();
    };
    proto.use = function(fn) {
      var offset = 0, path3 = "/";
      if (typeof fn != "function") {
        for (var arg = fn; Array.isArray(arg) && arg.length !== 0; )
          arg = arg[0];
        typeof arg != "function" && (offset = 1, path3 = fn);
      }
      var callbacks = flatten(slice.call(arguments, offset));
      if (callbacks.length === 0)
        throw new TypeError("Router.use() requires a middleware function");
      for (var i = 0; i < callbacks.length; i++) {
        var fn = callbacks[i];
        if (typeof fn != "function")
          throw new TypeError("Router.use() requires a middleware function but got a " + gettype(fn));
        debug4("use %o %s", path3, fn.name || "<anonymous>");
        var layer = new Layer(path3, {
          sensitive: this.caseSensitive,
          strict: !1,
          end: !1
        }, fn);
        layer.route = void 0, this.stack.push(layer);
      }
      return this;
    };
    proto.route = function(path3) {
      var route2 = new Route(path3), layer = new Layer(path3, {
        sensitive: this.caseSensitive,
        strict: this.strict,
        end: !0
      }, route2.dispatch.bind(route2));
      return layer.route = route2, this.stack.push(layer), route2;
    };
    methods.concat("all").forEach(function(method) {
      proto[method] = function(path3) {
        var route = this.route(path3);
        return route[method].apply(route, slice.call(arguments, 1)), this;
      };
    });
    function appendMethods(list2, addition) {
      for (var i = 0; i < addition.length; i++) {
        var method = addition[i];
        list2.indexOf(method) === -1 && list2.push(method);
      }
    }
    function getPathname(req) {
      try {
        return parseUrl(req).pathname;
      } catch {
        return;
      }
    }
    function getProtohost(url) {
      if (!(typeof url != "string" || url.length === 0 || url[0] === "/")) {
        var searchIndex = url.indexOf("?"), pathLength = searchIndex !== -1 ? searchIndex : url.length, fqdnIndex = url.slice(0, pathLength).indexOf("://");
        return fqdnIndex !== -1 ? url.substring(0, url.indexOf("/", 3 + fqdnIndex)) : void 0;
      }
    }
    function gettype(obj) {
      var type = typeof obj;
      return type !== "object" ? type : toString2.call(obj).replace(objectRegExp, "$1");
    }
    function matchLayer(layer, path3) {
      try {
        return layer.match(path3);
      } catch (err2) {
        return err2;
      }
    }
    function mergeParams(params, parent) {
      if (typeof parent != "object" || !parent)
        return params;
      var obj = mixin({}, parent);
      if (!(0 in params) || !(0 in parent))
        return mixin(obj, params);
      for (var i = 0, o = 0; i in params; )
        i++;
      for (; o in parent; )
        o++;
      for (i--; i >= 0; i--)
        params[i + o] = params[i], i < o && delete params[i];
      return mixin(obj, params);
    }
    function restore(fn, obj) {
      for (var props = new Array(arguments.length - 2), vals = new Array(arguments.length - 2), i = 0; i < props.length; i++)
        props[i] = arguments[i + 2], vals[i] = obj[props[i]];
      return function() {
        for (var i2 = 0; i2 < props.length; i2++)
          obj[props[i2]] = vals[i2];
        return fn.apply(this, arguments);
      };
    }
    function sendOptionsResponse(res, options, next) {
      try {
        var body = options.join(",");
        res.set("Allow", body), res.send(body);
      } catch (err2) {
        next(err2);
      }
    }
    function wrap(old, fn) {
      return function() {
        var args = new Array(arguments.length + 1);
        args[0] = old;
        for (var i = 0, len = arguments.length; i < len; i++)
          args[i + 1] = arguments[i];
        fn.apply(this, args);
      };
    }
  }
});

// ../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/middleware/init.js
var require_init = __commonJS({
  "../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/middleware/init.js"(exports) {
    "use strict";
    init_cjs_shims();
    var setPrototypeOf = require_setprototypeof();
    exports.init = function(app) {
      return function(req, res, next) {
        app.enabled("x-powered-by") && res.setHeader("X-Powered-By", "Express"), req.res = res, res.req = req, req.next = next, setPrototypeOf(req, app.request), setPrototypeOf(res, app.response), res.locals = res.locals || /* @__PURE__ */ Object.create(null), next();
      };
    };
  }
});

// ../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/middleware/query.js
var require_query = __commonJS({
  "../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/middleware/query.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var merge = require_utils_merge(), parseUrl = require_parseurl(), qs = require_lib9();
    module.exports = function(options) {
      var opts = merge({}, options), queryparse = qs.parse;
      return typeof options == "function" && (queryparse = options, opts = void 0), opts !== void 0 && opts.allowPrototypes === void 0 && (opts.allowPrototypes = !0), function(req, res, next) {
        if (!req.query) {
          var val = parseUrl(req).query;
          req.query = queryparse(val, opts);
        }
        next();
      };
    };
  }
});

// ../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/view.js
var require_view = __commonJS({
  "../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/view.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var debug4 = require_src2()("express:view"), path3 = __require("path"), fs6 = __require("fs"), dirname5 = path3.dirname, basename3 = path3.basename, extname2 = path3.extname, join6 = path3.join, resolve2 = path3.resolve;
    module.exports = View;
    function View(name, options) {
      var opts = options || {};
      if (this.defaultEngine = opts.defaultEngine, this.ext = extname2(name), this.name = name, this.root = opts.root, !this.ext && !this.defaultEngine)
        throw new Error("No default engine was specified and no extension was provided.");
      var fileName = name;
      if (this.ext || (this.ext = this.defaultEngine[0] !== "." ? "." + this.defaultEngine : this.defaultEngine, fileName += this.ext), !opts.engines[this.ext]) {
        var mod = this.ext.slice(1);
        debug4('require "%s"', mod);
        var fn = __require(mod).__express;
        if (typeof fn != "function")
          throw new Error('Module "' + mod + '" does not provide a view engine.');
        opts.engines[this.ext] = fn;
      }
      this.engine = opts.engines[this.ext], this.path = this.lookup(fileName);
    }
    View.prototype.lookup = function(name) {
      var path4, roots = [].concat(this.root);
      debug4('lookup "%s"', name);
      for (var i = 0; i < roots.length && !path4; i++) {
        var root = roots[i], loc = resolve2(root, name), dir = dirname5(loc), file = basename3(loc);
        path4 = this.resolve(dir, file);
      }
      return path4;
    };
    View.prototype.render = function(options, callback) {
      debug4('render "%s"', this.path), this.engine(this.path, options, callback);
    };
    View.prototype.resolve = function(dir, file) {
      var ext = this.ext, path4 = join6(dir, file), stat = tryStat(path4);
      if (stat && stat.isFile() || (path4 = join6(dir, basename3(file, ext), "index" + ext), stat = tryStat(path4), stat && stat.isFile()))
        return path4;
    };
    function tryStat(path4) {
      debug4('stat "%s"', path4);
      try {
        return fs6.statSync(path4);
      } catch {
        return;
      }
    }
  }
});

// ../../node_modules/.pnpm/content-disposition@0.5.4/node_modules/content-disposition/index.js
var require_content_disposition = __commonJS({
  "../../node_modules/.pnpm/content-disposition@0.5.4/node_modules/content-disposition/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = contentDisposition;
    module.exports.parse = parse4;
    var basename3 = __require("path").basename, Buffer2 = require_safe_buffer2().Buffer, ENCODE_URL_ATTR_CHAR_REGEXP = /[\x00-\x20"'()*,/:;<=>?@[\\\]{}\x7f]/g, HEX_ESCAPE_REGEXP = /%[0-9A-Fa-f]{2}/, HEX_ESCAPE_REPLACE_REGEXP = /%([0-9A-Fa-f]{2})/g, NON_LATIN1_REGEXP = /[^\x20-\x7e\xa0-\xff]/g, QESC_REGEXP = /\\([\u0000-\u007f])/g, QUOTE_REGEXP = /([\\"])/g, PARAM_REGEXP = /;[\x09\x20]*([!#$%&'*+.0-9A-Z^_`a-z|~-]+)[\x09\x20]*=[\x09\x20]*("(?:[\x20!\x23-\x5b\x5d-\x7e\x80-\xff]|\\[\x20-\x7e])*"|[!#$%&'*+.0-9A-Z^_`a-z|~-]+)[\x09\x20]*/g, TEXT_REGEXP = /^[\x20-\x7e\x80-\xff]+$/, TOKEN_REGEXP = /^[!#$%&'*+.0-9A-Z^_`a-z|~-]+$/, EXT_VALUE_REGEXP = /^([A-Za-z0-9!#$%&+\-^_`{}~]+)'(?:[A-Za-z]{2,3}(?:-[A-Za-z]{3}){0,3}|[A-Za-z]{4,8}|)'((?:%[0-9A-Fa-f]{2}|[A-Za-z0-9!#$&+.^_`|~-])+)$/, DISPOSITION_TYPE_REGEXP = /^([!#$%&'*+.0-9A-Z^_`a-z|~-]+)[\x09\x20]*(?:$|;)/;
    function contentDisposition(filename, options) {
      var opts = options || {}, type = opts.type || "attachment", params = createparams(filename, opts.fallback);
      return format4(new ContentDisposition(type, params));
    }
    function createparams(filename, fallback) {
      if (filename !== void 0) {
        var params = {};
        if (typeof filename != "string")
          throw new TypeError("filename must be a string");
        if (fallback === void 0 && (fallback = !0), typeof fallback != "string" && typeof fallback != "boolean")
          throw new TypeError("fallback must be a string or boolean");
        if (typeof fallback == "string" && NON_LATIN1_REGEXP.test(fallback))
          throw new TypeError("fallback must be ISO-8859-1 string");
        var name = basename3(filename), isQuotedString = TEXT_REGEXP.test(name), fallbackName = typeof fallback != "string" ? fallback && getlatin1(name) : basename3(fallback), hasFallback = typeof fallbackName == "string" && fallbackName !== name;
        return (hasFallback || !isQuotedString || HEX_ESCAPE_REGEXP.test(name)) && (params["filename*"] = name), (isQuotedString || hasFallback) && (params.filename = hasFallback ? fallbackName : name), params;
      }
    }
    function format4(obj) {
      var parameters = obj.parameters, type = obj.type;
      if (!type || typeof type != "string" || !TOKEN_REGEXP.test(type))
        throw new TypeError("invalid type");
      var string = String(type).toLowerCase();
      if (parameters && typeof parameters == "object")
        for (var param, params = Object.keys(parameters).sort(), i = 0; i < params.length; i++) {
          param = params[i];
          var val = param.substr(-1) === "*" ? ustring(parameters[param]) : qstring(parameters[param]);
          string += "; " + param + "=" + val;
        }
      return string;
    }
    function decodefield(str) {
      var match2 = EXT_VALUE_REGEXP.exec(str);
      if (!match2)
        throw new TypeError("invalid extended field value");
      var charset = match2[1].toLowerCase(), encoded = match2[2], value, binary = encoded.replace(HEX_ESCAPE_REPLACE_REGEXP, pdecode);
      switch (charset) {
        case "iso-8859-1":
          value = getlatin1(binary);
          break;
        case "utf-8":
          value = Buffer2.from(binary, "binary").toString("utf8");
          break;
        default:
          throw new TypeError("unsupported charset in extended field");
      }
      return value;
    }
    function getlatin1(val) {
      return String(val).replace(NON_LATIN1_REGEXP, "?");
    }
    function parse4(string) {
      if (!string || typeof string != "string")
        throw new TypeError("argument string is required");
      var match2 = DISPOSITION_TYPE_REGEXP.exec(string);
      if (!match2)
        throw new TypeError("invalid type format");
      var index = match2[0].length, type = match2[1].toLowerCase(), key, names = [], params = {}, value;
      for (index = PARAM_REGEXP.lastIndex = match2[0].substr(-1) === ";" ? index - 1 : index; match2 = PARAM_REGEXP.exec(string); ) {
        if (match2.index !== index)
          throw new TypeError("invalid parameter format");
        if (index += match2[0].length, key = match2[1].toLowerCase(), value = match2[2], names.indexOf(key) !== -1)
          throw new TypeError("invalid duplicate parameter");
        if (names.push(key), key.indexOf("*") + 1 === key.length) {
          key = key.slice(0, -1), value = decodefield(value), params[key] = value;
          continue;
        }
        typeof params[key] != "string" && (value[0] === '"' && (value = value.substr(1, value.length - 2).replace(QESC_REGEXP, "$1")), params[key] = value);
      }
      if (index !== -1 && index !== string.length)
        throw new TypeError("invalid parameter format");
      return new ContentDisposition(type, params);
    }
    function pdecode(str, hex) {
      return String.fromCharCode(parseInt(hex, 16));
    }
    function pencode(char) {
      return "%" + String(char).charCodeAt(0).toString(16).toUpperCase();
    }
    function qstring(val) {
      var str = String(val);
      return '"' + str.replace(QUOTE_REGEXP, "\\$1") + '"';
    }
    function ustring(val) {
      var str = String(val), encoded = encodeURIComponent(str).replace(ENCODE_URL_ATTR_CHAR_REGEXP, pencode);
      return "UTF-8''" + encoded;
    }
    function ContentDisposition(type, parameters) {
      this.type = type, this.parameters = parameters;
    }
  }
});

// ../../node_modules/.pnpm/etag@1.8.1/node_modules/etag/index.js
var require_etag = __commonJS({
  "../../node_modules/.pnpm/etag@1.8.1/node_modules/etag/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = etag;
    var crypto = __require("crypto"), Stats = __require("fs").Stats, toString2 = Object.prototype.toString;
    function entitytag(entity) {
      if (entity.length === 0)
        return '"0-2jmj7l5rSw0yVb/vlWAYkK/YBwk"';
      var hash = crypto.createHash("sha1").update(entity, "utf8").digest("base64").substring(0, 27), len = typeof entity == "string" ? Buffer.byteLength(entity, "utf8") : entity.length;
      return '"' + len.toString(16) + "-" + hash + '"';
    }
    function etag(entity, options) {
      if (entity == null)
        throw new TypeError("argument entity is required");
      var isStats = isstats(entity), weak = options && typeof options.weak == "boolean" ? options.weak : isStats;
      if (!isStats && typeof entity != "string" && !Buffer.isBuffer(entity))
        throw new TypeError("argument entity must be string, Buffer, or fs.Stats");
      var tag = isStats ? stattag(entity) : entitytag(entity);
      return weak ? "W/" + tag : tag;
    }
    function isstats(obj) {
      return typeof Stats == "function" && obj instanceof Stats ? !0 : obj && typeof obj == "object" && "ctime" in obj && toString2.call(obj.ctime) === "[object Date]" && "mtime" in obj && toString2.call(obj.mtime) === "[object Date]" && "ino" in obj && typeof obj.ino == "number" && "size" in obj && typeof obj.size == "number";
    }
    function stattag(stat) {
      var mtime = stat.mtime.getTime().toString(16), size = stat.size.toString(16);
      return '"' + size + "-" + mtime + '"';
    }
  }
});

// ../../node_modules/.pnpm/fresh@0.5.2/node_modules/fresh/index.js
var require_fresh = __commonJS({
  "../../node_modules/.pnpm/fresh@0.5.2/node_modules/fresh/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var CACHE_CONTROL_NO_CACHE_REGEXP = /(?:^|,)\s*?no-cache\s*?(?:,|$)/;
    module.exports = fresh;
    function fresh(reqHeaders, resHeaders) {
      var modifiedSince = reqHeaders["if-modified-since"], noneMatch = reqHeaders["if-none-match"];
      if (!modifiedSince && !noneMatch)
        return !1;
      var cacheControl = reqHeaders["cache-control"];
      if (cacheControl && CACHE_CONTROL_NO_CACHE_REGEXP.test(cacheControl))
        return !1;
      if (noneMatch && noneMatch !== "*") {
        var etag = resHeaders.etag;
        if (!etag)
          return !1;
        for (var etagStale = !0, matches = parseTokenList(noneMatch), i = 0; i < matches.length; i++) {
          var match2 = matches[i];
          if (match2 === etag || match2 === "W/" + etag || "W/" + match2 === etag) {
            etagStale = !1;
            break;
          }
        }
        if (etagStale)
          return !1;
      }
      if (modifiedSince) {
        var lastModified = resHeaders["last-modified"], modifiedStale = !lastModified || !(parseHttpDate(lastModified) <= parseHttpDate(modifiedSince));
        if (modifiedStale)
          return !1;
      }
      return !0;
    }
    function parseHttpDate(date) {
      var timestamp = date && Date.parse(date);
      return typeof timestamp == "number" ? timestamp : NaN;
    }
    function parseTokenList(str) {
      for (var end = 0, list2 = [], start = 0, i = 0, len = str.length; i < len; i++)
        switch (str.charCodeAt(i)) {
          case 32:
            start === end && (start = end = i + 1);
            break;
          case 44:
            list2.push(str.substring(start, end)), start = end = i + 1;
            break;
          default:
            end = i + 1;
            break;
        }
      return list2.push(str.substring(start, end)), list2;
    }
  }
});

// ../../node_modules/.pnpm/mime@1.6.0/node_modules/mime/types.json
var require_types13 = __commonJS({
  "../../node_modules/.pnpm/mime@1.6.0/node_modules/mime/types.json"(exports, module) {
    module.exports = { "application/andrew-inset": ["ez"], "application/applixware": ["aw"], "application/atom+xml": ["atom"], "application/atomcat+xml": ["atomcat"], "application/atomsvc+xml": ["atomsvc"], "application/bdoc": ["bdoc"], "application/ccxml+xml": ["ccxml"], "application/cdmi-capability": ["cdmia"], "application/cdmi-container": ["cdmic"], "application/cdmi-domain": ["cdmid"], "application/cdmi-object": ["cdmio"], "application/cdmi-queue": ["cdmiq"], "application/cu-seeme": ["cu"], "application/dash+xml": ["mpd"], "application/davmount+xml": ["davmount"], "application/docbook+xml": ["dbk"], "application/dssc+der": ["dssc"], "application/dssc+xml": ["xdssc"], "application/ecmascript": ["ecma"], "application/emma+xml": ["emma"], "application/epub+zip": ["epub"], "application/exi": ["exi"], "application/font-tdpfr": ["pfr"], "application/font-woff": [], "application/font-woff2": [], "application/geo+json": ["geojson"], "application/gml+xml": ["gml"], "application/gpx+xml": ["gpx"], "application/gxf": ["gxf"], "application/gzip": ["gz"], "application/hyperstudio": ["stk"], "application/inkml+xml": ["ink", "inkml"], "application/ipfix": ["ipfix"], "application/java-archive": ["jar", "war", "ear"], "application/java-serialized-object": ["ser"], "application/java-vm": ["class"], "application/javascript": ["js", "mjs"], "application/json": ["json", "map"], "application/json5": ["json5"], "application/jsonml+json": ["jsonml"], "application/ld+json": ["jsonld"], "application/lost+xml": ["lostxml"], "application/mac-binhex40": ["hqx"], "application/mac-compactpro": ["cpt"], "application/mads+xml": ["mads"], "application/manifest+json": ["webmanifest"], "application/marc": ["mrc"], "application/marcxml+xml": ["mrcx"], "application/mathematica": ["ma", "nb", "mb"], "application/mathml+xml": ["mathml"], "application/mbox": ["mbox"], "application/mediaservercontrol+xml": ["mscml"], "application/metalink+xml": ["metalink"], "application/metalink4+xml": ["meta4"], "application/mets+xml": ["mets"], "application/mods+xml": ["mods"], "application/mp21": ["m21", "mp21"], "application/mp4": ["mp4s", "m4p"], "application/msword": ["doc", "dot"], "application/mxf": ["mxf"], "application/octet-stream": ["bin", "dms", "lrf", "mar", "so", "dist", "distz", "pkg", "bpk", "dump", "elc", "deploy", "exe", "dll", "deb", "dmg", "iso", "img", "msi", "msp", "msm", "buffer"], "application/oda": ["oda"], "application/oebps-package+xml": ["opf"], "application/ogg": ["ogx"], "application/omdoc+xml": ["omdoc"], "application/onenote": ["onetoc", "onetoc2", "onetmp", "onepkg"], "application/oxps": ["oxps"], "application/patch-ops-error+xml": ["xer"], "application/pdf": ["pdf"], "application/pgp-encrypted": ["pgp"], "application/pgp-signature": ["asc", "sig"], "application/pics-rules": ["prf"], "application/pkcs10": ["p10"], "application/pkcs7-mime": ["p7m", "p7c"], "application/pkcs7-signature": ["p7s"], "application/pkcs8": ["p8"], "application/pkix-attr-cert": ["ac"], "application/pkix-cert": ["cer"], "application/pkix-crl": ["crl"], "application/pkix-pkipath": ["pkipath"], "application/pkixcmp": ["pki"], "application/pls+xml": ["pls"], "application/postscript": ["ai", "eps", "ps"], "application/prs.cww": ["cww"], "application/pskc+xml": ["pskcxml"], "application/raml+yaml": ["raml"], "application/rdf+xml": ["rdf"], "application/reginfo+xml": ["rif"], "application/relax-ng-compact-syntax": ["rnc"], "application/resource-lists+xml": ["rl"], "application/resource-lists-diff+xml": ["rld"], "application/rls-services+xml": ["rs"], "application/rpki-ghostbusters": ["gbr"], "application/rpki-manifest": ["mft"], "application/rpki-roa": ["roa"], "application/rsd+xml": ["rsd"], "application/rss+xml": ["rss"], "application/rtf": ["rtf"], "application/sbml+xml": ["sbml"], "application/scvp-cv-request": ["scq"], "application/scvp-cv-response": ["scs"], "application/scvp-vp-request": ["spq"], "application/scvp-vp-response": ["spp"], "application/sdp": ["sdp"], "application/set-payment-initiation": ["setpay"], "application/set-registration-initiation": ["setreg"], "application/shf+xml": ["shf"], "application/smil+xml": ["smi", "smil"], "application/sparql-query": ["rq"], "application/sparql-results+xml": ["srx"], "application/srgs": ["gram"], "application/srgs+xml": ["grxml"], "application/sru+xml": ["sru"], "application/ssdl+xml": ["ssdl"], "application/ssml+xml": ["ssml"], "application/tei+xml": ["tei", "teicorpus"], "application/thraud+xml": ["tfi"], "application/timestamped-data": ["tsd"], "application/vnd.3gpp.pic-bw-large": ["plb"], "application/vnd.3gpp.pic-bw-small": ["psb"], "application/vnd.3gpp.pic-bw-var": ["pvb"], "application/vnd.3gpp2.tcap": ["tcap"], "application/vnd.3m.post-it-notes": ["pwn"], "application/vnd.accpac.simply.aso": ["aso"], "application/vnd.accpac.simply.imp": ["imp"], "application/vnd.acucobol": ["acu"], "application/vnd.acucorp": ["atc", "acutc"], "application/vnd.adobe.air-application-installer-package+zip": ["air"], "application/vnd.adobe.formscentral.fcdt": ["fcdt"], "application/vnd.adobe.fxp": ["fxp", "fxpl"], "application/vnd.adobe.xdp+xml": ["xdp"], "application/vnd.adobe.xfdf": ["xfdf"], "application/vnd.ahead.space": ["ahead"], "application/vnd.airzip.filesecure.azf": ["azf"], "application/vnd.airzip.filesecure.azs": ["azs"], "application/vnd.amazon.ebook": ["azw"], "application/vnd.americandynamics.acc": ["acc"], "application/vnd.amiga.ami": ["ami"], "application/vnd.android.package-archive": ["apk"], "application/vnd.anser-web-certificate-issue-initiation": ["cii"], "application/vnd.anser-web-funds-transfer-initiation": ["fti"], "application/vnd.antix.game-component": ["atx"], "application/vnd.apple.installer+xml": ["mpkg"], "application/vnd.apple.mpegurl": ["m3u8"], "application/vnd.apple.pkpass": ["pkpass"], "application/vnd.aristanetworks.swi": ["swi"], "application/vnd.astraea-software.iota": ["iota"], "application/vnd.audiograph": ["aep"], "application/vnd.blueice.multipass": ["mpm"], "application/vnd.bmi": ["bmi"], "application/vnd.businessobjects": ["rep"], "application/vnd.chemdraw+xml": ["cdxml"], "application/vnd.chipnuts.karaoke-mmd": ["mmd"], "application/vnd.cinderella": ["cdy"], "application/vnd.claymore": ["cla"], "application/vnd.cloanto.rp9": ["rp9"], "application/vnd.clonk.c4group": ["c4g", "c4d", "c4f", "c4p", "c4u"], "application/vnd.cluetrust.cartomobile-config": ["c11amc"], "application/vnd.cluetrust.cartomobile-config-pkg": ["c11amz"], "application/vnd.commonspace": ["csp"], "application/vnd.contact.cmsg": ["cdbcmsg"], "application/vnd.cosmocaller": ["cmc"], "application/vnd.crick.clicker": ["clkx"], "application/vnd.crick.clicker.keyboard": ["clkk"], "application/vnd.crick.clicker.palette": ["clkp"], "application/vnd.crick.clicker.template": ["clkt"], "application/vnd.crick.clicker.wordbank": ["clkw"], "application/vnd.criticaltools.wbs+xml": ["wbs"], "application/vnd.ctc-posml": ["pml"], "application/vnd.cups-ppd": ["ppd"], "application/vnd.curl.car": ["car"], "application/vnd.curl.pcurl": ["pcurl"], "application/vnd.dart": ["dart"], "application/vnd.data-vision.rdz": ["rdz"], "application/vnd.dece.data": ["uvf", "uvvf", "uvd", "uvvd"], "application/vnd.dece.ttml+xml": ["uvt", "uvvt"], "application/vnd.dece.unspecified": ["uvx", "uvvx"], "application/vnd.dece.zip": ["uvz", "uvvz"], "application/vnd.denovo.fcselayout-link": ["fe_launch"], "application/vnd.dna": ["dna"], "application/vnd.dolby.mlp": ["mlp"], "application/vnd.dpgraph": ["dpg"], "application/vnd.dreamfactory": ["dfac"], "application/vnd.ds-keypoint": ["kpxx"], "application/vnd.dvb.ait": ["ait"], "application/vnd.dvb.service": ["svc"], "application/vnd.dynageo": ["geo"], "application/vnd.ecowin.chart": ["mag"], "application/vnd.enliven": ["nml"], "application/vnd.epson.esf": ["esf"], "application/vnd.epson.msf": ["msf"], "application/vnd.epson.quickanime": ["qam"], "application/vnd.epson.salt": ["slt"], "application/vnd.epson.ssf": ["ssf"], "application/vnd.eszigno3+xml": ["es3", "et3"], "application/vnd.ezpix-album": ["ez2"], "application/vnd.ezpix-package": ["ez3"], "application/vnd.fdf": ["fdf"], "application/vnd.fdsn.mseed": ["mseed"], "application/vnd.fdsn.seed": ["seed", "dataless"], "application/vnd.flographit": ["gph"], "application/vnd.fluxtime.clip": ["ftc"], "application/vnd.framemaker": ["fm", "frame", "maker", "book"], "application/vnd.frogans.fnc": ["fnc"], "application/vnd.frogans.ltf": ["ltf"], "application/vnd.fsc.weblaunch": ["fsc"], "application/vnd.fujitsu.oasys": ["oas"], "application/vnd.fujitsu.oasys2": ["oa2"], "application/vnd.fujitsu.oasys3": ["oa3"], "application/vnd.fujitsu.oasysgp": ["fg5"], "application/vnd.fujitsu.oasysprs": ["bh2"], "application/vnd.fujixerox.ddd": ["ddd"], "application/vnd.fujixerox.docuworks": ["xdw"], "application/vnd.fujixerox.docuworks.binder": ["xbd"], "application/vnd.fuzzysheet": ["fzs"], "application/vnd.genomatix.tuxedo": ["txd"], "application/vnd.geogebra.file": ["ggb"], "application/vnd.geogebra.tool": ["ggt"], "application/vnd.geometry-explorer": ["gex", "gre"], "application/vnd.geonext": ["gxt"], "application/vnd.geoplan": ["g2w"], "application/vnd.geospace": ["g3w"], "application/vnd.gmx": ["gmx"], "application/vnd.google-apps.document": ["gdoc"], "application/vnd.google-apps.presentation": ["gslides"], "application/vnd.google-apps.spreadsheet": ["gsheet"], "application/vnd.google-earth.kml+xml": ["kml"], "application/vnd.google-earth.kmz": ["kmz"], "application/vnd.grafeq": ["gqf", "gqs"], "application/vnd.groove-account": ["gac"], "application/vnd.groove-help": ["ghf"], "application/vnd.groove-identity-message": ["gim"], "application/vnd.groove-injector": ["grv"], "application/vnd.groove-tool-message": ["gtm"], "application/vnd.groove-tool-template": ["tpl"], "application/vnd.groove-vcard": ["vcg"], "application/vnd.hal+xml": ["hal"], "application/vnd.handheld-entertainment+xml": ["zmm"], "application/vnd.hbci": ["hbci"], "application/vnd.hhe.lesson-player": ["les"], "application/vnd.hp-hpgl": ["hpgl"], "application/vnd.hp-hpid": ["hpid"], "application/vnd.hp-hps": ["hps"], "application/vnd.hp-jlyt": ["jlt"], "application/vnd.hp-pcl": ["pcl"], "application/vnd.hp-pclxl": ["pclxl"], "application/vnd.hydrostatix.sof-data": ["sfd-hdstx"], "application/vnd.ibm.minipay": ["mpy"], "application/vnd.ibm.modcap": ["afp", "listafp", "list3820"], "application/vnd.ibm.rights-management": ["irm"], "application/vnd.ibm.secure-container": ["sc"], "application/vnd.iccprofile": ["icc", "icm"], "application/vnd.igloader": ["igl"], "application/vnd.immervision-ivp": ["ivp"], "application/vnd.immervision-ivu": ["ivu"], "application/vnd.insors.igm": ["igm"], "application/vnd.intercon.formnet": ["xpw", "xpx"], "application/vnd.intergeo": ["i2g"], "application/vnd.intu.qbo": ["qbo"], "application/vnd.intu.qfx": ["qfx"], "application/vnd.ipunplugged.rcprofile": ["rcprofile"], "application/vnd.irepository.package+xml": ["irp"], "application/vnd.is-xpr": ["xpr"], "application/vnd.isac.fcs": ["fcs"], "application/vnd.jam": ["jam"], "application/vnd.jcp.javame.midlet-rms": ["rms"], "application/vnd.jisp": ["jisp"], "application/vnd.joost.joda-archive": ["joda"], "application/vnd.kahootz": ["ktz", "ktr"], "application/vnd.kde.karbon": ["karbon"], "application/vnd.kde.kchart": ["chrt"], "application/vnd.kde.kformula": ["kfo"], "application/vnd.kde.kivio": ["flw"], "application/vnd.kde.kontour": ["kon"], "application/vnd.kde.kpresenter": ["kpr", "kpt"], "application/vnd.kde.kspread": ["ksp"], "application/vnd.kde.kword": ["kwd", "kwt"], "application/vnd.kenameaapp": ["htke"], "application/vnd.kidspiration": ["kia"], "application/vnd.kinar": ["kne", "knp"], "application/vnd.koan": ["skp", "skd", "skt", "skm"], "application/vnd.kodak-descriptor": ["sse"], "application/vnd.las.las+xml": ["lasxml"], "application/vnd.llamagraphics.life-balance.desktop": ["lbd"], "application/vnd.llamagraphics.life-balance.exchange+xml": ["lbe"], "application/vnd.lotus-1-2-3": ["123"], "application/vnd.lotus-approach": ["apr"], "application/vnd.lotus-freelance": ["pre"], "application/vnd.lotus-notes": ["nsf"], "application/vnd.lotus-organizer": ["org"], "application/vnd.lotus-screencam": ["scm"], "application/vnd.lotus-wordpro": ["lwp"], "application/vnd.macports.portpkg": ["portpkg"], "application/vnd.mcd": ["mcd"], "application/vnd.medcalcdata": ["mc1"], "application/vnd.mediastation.cdkey": ["cdkey"], "application/vnd.mfer": ["mwf"], "application/vnd.mfmp": ["mfm"], "application/vnd.micrografx.flo": ["flo"], "application/vnd.micrografx.igx": ["igx"], "application/vnd.mif": ["mif"], "application/vnd.mobius.daf": ["daf"], "application/vnd.mobius.dis": ["dis"], "application/vnd.mobius.mbk": ["mbk"], "application/vnd.mobius.mqy": ["mqy"], "application/vnd.mobius.msl": ["msl"], "application/vnd.mobius.plc": ["plc"], "application/vnd.mobius.txf": ["txf"], "application/vnd.mophun.application": ["mpn"], "application/vnd.mophun.certificate": ["mpc"], "application/vnd.mozilla.xul+xml": ["xul"], "application/vnd.ms-artgalry": ["cil"], "application/vnd.ms-cab-compressed": ["cab"], "application/vnd.ms-excel": ["xls", "xlm", "xla", "xlc", "xlt", "xlw"], "application/vnd.ms-excel.addin.macroenabled.12": ["xlam"], "application/vnd.ms-excel.sheet.binary.macroenabled.12": ["xlsb"], "application/vnd.ms-excel.sheet.macroenabled.12": ["xlsm"], "application/vnd.ms-excel.template.macroenabled.12": ["xltm"], "application/vnd.ms-fontobject": ["eot"], "application/vnd.ms-htmlhelp": ["chm"], "application/vnd.ms-ims": ["ims"], "application/vnd.ms-lrm": ["lrm"], "application/vnd.ms-officetheme": ["thmx"], "application/vnd.ms-outlook": ["msg"], "application/vnd.ms-pki.seccat": ["cat"], "application/vnd.ms-pki.stl": ["stl"], "application/vnd.ms-powerpoint": ["ppt", "pps", "pot"], "application/vnd.ms-powerpoint.addin.macroenabled.12": ["ppam"], "application/vnd.ms-powerpoint.presentation.macroenabled.12": ["pptm"], "application/vnd.ms-powerpoint.slide.macroenabled.12": ["sldm"], "application/vnd.ms-powerpoint.slideshow.macroenabled.12": ["ppsm"], "application/vnd.ms-powerpoint.template.macroenabled.12": ["potm"], "application/vnd.ms-project": ["mpp", "mpt"], "application/vnd.ms-word.document.macroenabled.12": ["docm"], "application/vnd.ms-word.template.macroenabled.12": ["dotm"], "application/vnd.ms-works": ["wps", "wks", "wcm", "wdb"], "application/vnd.ms-wpl": ["wpl"], "application/vnd.ms-xpsdocument": ["xps"], "application/vnd.mseq": ["mseq"], "application/vnd.musician": ["mus"], "application/vnd.muvee.style": ["msty"], "application/vnd.mynfc": ["taglet"], "application/vnd.neurolanguage.nlu": ["nlu"], "application/vnd.nitf": ["ntf", "nitf"], "application/vnd.noblenet-directory": ["nnd"], "application/vnd.noblenet-sealer": ["nns"], "application/vnd.noblenet-web": ["nnw"], "application/vnd.nokia.n-gage.data": ["ngdat"], "application/vnd.nokia.n-gage.symbian.install": ["n-gage"], "application/vnd.nokia.radio-preset": ["rpst"], "application/vnd.nokia.radio-presets": ["rpss"], "application/vnd.novadigm.edm": ["edm"], "application/vnd.novadigm.edx": ["edx"], "application/vnd.novadigm.ext": ["ext"], "application/vnd.oasis.opendocument.chart": ["odc"], "application/vnd.oasis.opendocument.chart-template": ["otc"], "application/vnd.oasis.opendocument.database": ["odb"], "application/vnd.oasis.opendocument.formula": ["odf"], "application/vnd.oasis.opendocument.formula-template": ["odft"], "application/vnd.oasis.opendocument.graphics": ["odg"], "application/vnd.oasis.opendocument.graphics-template": ["otg"], "application/vnd.oasis.opendocument.image": ["odi"], "application/vnd.oasis.opendocument.image-template": ["oti"], "application/vnd.oasis.opendocument.presentation": ["odp"], "application/vnd.oasis.opendocument.presentation-template": ["otp"], "application/vnd.oasis.opendocument.spreadsheet": ["ods"], "application/vnd.oasis.opendocument.spreadsheet-template": ["ots"], "application/vnd.oasis.opendocument.text": ["odt"], "application/vnd.oasis.opendocument.text-master": ["odm"], "application/vnd.oasis.opendocument.text-template": ["ott"], "application/vnd.oasis.opendocument.text-web": ["oth"], "application/vnd.olpc-sugar": ["xo"], "application/vnd.oma.dd2+xml": ["dd2"], "application/vnd.openofficeorg.extension": ["oxt"], "application/vnd.openxmlformats-officedocument.presentationml.presentation": ["pptx"], "application/vnd.openxmlformats-officedocument.presentationml.slide": ["sldx"], "application/vnd.openxmlformats-officedocument.presentationml.slideshow": ["ppsx"], "application/vnd.openxmlformats-officedocument.presentationml.template": ["potx"], "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet": ["xlsx"], "application/vnd.openxmlformats-officedocument.spreadsheetml.template": ["xltx"], "application/vnd.openxmlformats-officedocument.wordprocessingml.document": ["docx"], "application/vnd.openxmlformats-officedocument.wordprocessingml.template": ["dotx"], "application/vnd.osgeo.mapguide.package": ["mgp"], "application/vnd.osgi.dp": ["dp"], "application/vnd.osgi.subsystem": ["esa"], "application/vnd.palm": ["pdb", "pqa", "oprc"], "application/vnd.pawaafile": ["paw"], "application/vnd.pg.format": ["str"], "application/vnd.pg.osasli": ["ei6"], "application/vnd.picsel": ["efif"], "application/vnd.pmi.widget": ["wg"], "application/vnd.pocketlearn": ["plf"], "application/vnd.powerbuilder6": ["pbd"], "application/vnd.previewsystems.box": ["box"], "application/vnd.proteus.magazine": ["mgz"], "application/vnd.publishare-delta-tree": ["qps"], "application/vnd.pvi.ptid1": ["ptid"], "application/vnd.quark.quarkxpress": ["qxd", "qxt", "qwd", "qwt", "qxl", "qxb"], "application/vnd.realvnc.bed": ["bed"], "application/vnd.recordare.musicxml": ["mxl"], "application/vnd.recordare.musicxml+xml": ["musicxml"], "application/vnd.rig.cryptonote": ["cryptonote"], "application/vnd.rim.cod": ["cod"], "application/vnd.rn-realmedia": ["rm"], "application/vnd.rn-realmedia-vbr": ["rmvb"], "application/vnd.route66.link66+xml": ["link66"], "application/vnd.sailingtracker.track": ["st"], "application/vnd.seemail": ["see"], "application/vnd.sema": ["sema"], "application/vnd.semd": ["semd"], "application/vnd.semf": ["semf"], "application/vnd.shana.informed.formdata": ["ifm"], "application/vnd.shana.informed.formtemplate": ["itp"], "application/vnd.shana.informed.interchange": ["iif"], "application/vnd.shana.informed.package": ["ipk"], "application/vnd.simtech-mindmapper": ["twd", "twds"], "application/vnd.smaf": ["mmf"], "application/vnd.smart.teacher": ["teacher"], "application/vnd.solent.sdkm+xml": ["sdkm", "sdkd"], "application/vnd.spotfire.dxp": ["dxp"], "application/vnd.spotfire.sfs": ["sfs"], "application/vnd.stardivision.calc": ["sdc"], "application/vnd.stardivision.draw": ["sda"], "application/vnd.stardivision.impress": ["sdd"], "application/vnd.stardivision.math": ["smf"], "application/vnd.stardivision.writer": ["sdw", "vor"], "application/vnd.stardivision.writer-global": ["sgl"], "application/vnd.stepmania.package": ["smzip"], "application/vnd.stepmania.stepchart": ["sm"], "application/vnd.sun.wadl+xml": ["wadl"], "application/vnd.sun.xml.calc": ["sxc"], "application/vnd.sun.xml.calc.template": ["stc"], "application/vnd.sun.xml.draw": ["sxd"], "application/vnd.sun.xml.draw.template": ["std"], "application/vnd.sun.xml.impress": ["sxi"], "application/vnd.sun.xml.impress.template": ["sti"], "application/vnd.sun.xml.math": ["sxm"], "application/vnd.sun.xml.writer": ["sxw"], "application/vnd.sun.xml.writer.global": ["sxg"], "application/vnd.sun.xml.writer.template": ["stw"], "application/vnd.sus-calendar": ["sus", "susp"], "application/vnd.svd": ["svd"], "application/vnd.symbian.install": ["sis", "sisx"], "application/vnd.syncml+xml": ["xsm"], "application/vnd.syncml.dm+wbxml": ["bdm"], "application/vnd.syncml.dm+xml": ["xdm"], "application/vnd.tao.intent-module-archive": ["tao"], "application/vnd.tcpdump.pcap": ["pcap", "cap", "dmp"], "application/vnd.tmobile-livetv": ["tmo"], "application/vnd.trid.tpt": ["tpt"], "application/vnd.triscape.mxs": ["mxs"], "application/vnd.trueapp": ["tra"], "application/vnd.ufdl": ["ufd", "ufdl"], "application/vnd.uiq.theme": ["utz"], "application/vnd.umajin": ["umj"], "application/vnd.unity": ["unityweb"], "application/vnd.uoml+xml": ["uoml"], "application/vnd.vcx": ["vcx"], "application/vnd.visio": ["vsd", "vst", "vss", "vsw"], "application/vnd.visionary": ["vis"], "application/vnd.vsf": ["vsf"], "application/vnd.wap.wbxml": ["wbxml"], "application/vnd.wap.wmlc": ["wmlc"], "application/vnd.wap.wmlscriptc": ["wmlsc"], "application/vnd.webturbo": ["wtb"], "application/vnd.wolfram.player": ["nbp"], "application/vnd.wordperfect": ["wpd"], "application/vnd.wqd": ["wqd"], "application/vnd.wt.stf": ["stf"], "application/vnd.xara": ["xar"], "application/vnd.xfdl": ["xfdl"], "application/vnd.yamaha.hv-dic": ["hvd"], "application/vnd.yamaha.hv-script": ["hvs"], "application/vnd.yamaha.hv-voice": ["hvp"], "application/vnd.yamaha.openscoreformat": ["osf"], "application/vnd.yamaha.openscoreformat.osfpvg+xml": ["osfpvg"], "application/vnd.yamaha.smaf-audio": ["saf"], "application/vnd.yamaha.smaf-phrase": ["spf"], "application/vnd.yellowriver-custom-menu": ["cmp"], "application/vnd.zul": ["zir", "zirz"], "application/vnd.zzazz.deck+xml": ["zaz"], "application/voicexml+xml": ["vxml"], "application/wasm": ["wasm"], "application/widget": ["wgt"], "application/winhlp": ["hlp"], "application/wsdl+xml": ["wsdl"], "application/wspolicy+xml": ["wspolicy"], "application/x-7z-compressed": ["7z"], "application/x-abiword": ["abw"], "application/x-ace-compressed": ["ace"], "application/x-apple-diskimage": [], "application/x-arj": ["arj"], "application/x-authorware-bin": ["aab", "x32", "u32", "vox"], "application/x-authorware-map": ["aam"], "application/x-authorware-seg": ["aas"], "application/x-bcpio": ["bcpio"], "application/x-bdoc": [], "application/x-bittorrent": ["torrent"], "application/x-blorb": ["blb", "blorb"], "application/x-bzip": ["bz"], "application/x-bzip2": ["bz2", "boz"], "application/x-cbr": ["cbr", "cba", "cbt", "cbz", "cb7"], "application/x-cdlink": ["vcd"], "application/x-cfs-compressed": ["cfs"], "application/x-chat": ["chat"], "application/x-chess-pgn": ["pgn"], "application/x-chrome-extension": ["crx"], "application/x-cocoa": ["cco"], "application/x-conference": ["nsc"], "application/x-cpio": ["cpio"], "application/x-csh": ["csh"], "application/x-debian-package": ["udeb"], "application/x-dgc-compressed": ["dgc"], "application/x-director": ["dir", "dcr", "dxr", "cst", "cct", "cxt", "w3d", "fgd", "swa"], "application/x-doom": ["wad"], "application/x-dtbncx+xml": ["ncx"], "application/x-dtbook+xml": ["dtb"], "application/x-dtbresource+xml": ["res"], "application/x-dvi": ["dvi"], "application/x-envoy": ["evy"], "application/x-eva": ["eva"], "application/x-font-bdf": ["bdf"], "application/x-font-ghostscript": ["gsf"], "application/x-font-linux-psf": ["psf"], "application/x-font-pcf": ["pcf"], "application/x-font-snf": ["snf"], "application/x-font-type1": ["pfa", "pfb", "pfm", "afm"], "application/x-freearc": ["arc"], "application/x-futuresplash": ["spl"], "application/x-gca-compressed": ["gca"], "application/x-glulx": ["ulx"], "application/x-gnumeric": ["gnumeric"], "application/x-gramps-xml": ["gramps"], "application/x-gtar": ["gtar"], "application/x-hdf": ["hdf"], "application/x-httpd-php": ["php"], "application/x-install-instructions": ["install"], "application/x-iso9660-image": [], "application/x-java-archive-diff": ["jardiff"], "application/x-java-jnlp-file": ["jnlp"], "application/x-latex": ["latex"], "application/x-lua-bytecode": ["luac"], "application/x-lzh-compressed": ["lzh", "lha"], "application/x-makeself": ["run"], "application/x-mie": ["mie"], "application/x-mobipocket-ebook": ["prc", "mobi"], "application/x-ms-application": ["application"], "application/x-ms-shortcut": ["lnk"], "application/x-ms-wmd": ["wmd"], "application/x-ms-wmz": ["wmz"], "application/x-ms-xbap": ["xbap"], "application/x-msaccess": ["mdb"], "application/x-msbinder": ["obd"], "application/x-mscardfile": ["crd"], "application/x-msclip": ["clp"], "application/x-msdos-program": [], "application/x-msdownload": ["com", "bat"], "application/x-msmediaview": ["mvb", "m13", "m14"], "application/x-msmetafile": ["wmf", "emf", "emz"], "application/x-msmoney": ["mny"], "application/x-mspublisher": ["pub"], "application/x-msschedule": ["scd"], "application/x-msterminal": ["trm"], "application/x-mswrite": ["wri"], "application/x-netcdf": ["nc", "cdf"], "application/x-ns-proxy-autoconfig": ["pac"], "application/x-nzb": ["nzb"], "application/x-perl": ["pl", "pm"], "application/x-pilot": [], "application/x-pkcs12": ["p12", "pfx"], "application/x-pkcs7-certificates": ["p7b", "spc"], "application/x-pkcs7-certreqresp": ["p7r"], "application/x-rar-compressed": ["rar"], "application/x-redhat-package-manager": ["rpm"], "application/x-research-info-systems": ["ris"], "application/x-sea": ["sea"], "application/x-sh": ["sh"], "application/x-shar": ["shar"], "application/x-shockwave-flash": ["swf"], "application/x-silverlight-app": ["xap"], "application/x-sql": ["sql"], "application/x-stuffit": ["sit"], "application/x-stuffitx": ["sitx"], "application/x-subrip": ["srt"], "application/x-sv4cpio": ["sv4cpio"], "application/x-sv4crc": ["sv4crc"], "application/x-t3vm-image": ["t3"], "application/x-tads": ["gam"], "application/x-tar": ["tar"], "application/x-tcl": ["tcl", "tk"], "application/x-tex": ["tex"], "application/x-tex-tfm": ["tfm"], "application/x-texinfo": ["texinfo", "texi"], "application/x-tgif": ["obj"], "application/x-ustar": ["ustar"], "application/x-virtualbox-hdd": ["hdd"], "application/x-virtualbox-ova": ["ova"], "application/x-virtualbox-ovf": ["ovf"], "application/x-virtualbox-vbox": ["vbox"], "application/x-virtualbox-vbox-extpack": ["vbox-extpack"], "application/x-virtualbox-vdi": ["vdi"], "application/x-virtualbox-vhd": ["vhd"], "application/x-virtualbox-vmdk": ["vmdk"], "application/x-wais-source": ["src"], "application/x-web-app-manifest+json": ["webapp"], "application/x-x509-ca-cert": ["der", "crt", "pem"], "application/x-xfig": ["fig"], "application/x-xliff+xml": ["xlf"], "application/x-xpinstall": ["xpi"], "application/x-xz": ["xz"], "application/x-zmachine": ["z1", "z2", "z3", "z4", "z5", "z6", "z7", "z8"], "application/xaml+xml": ["xaml"], "application/xcap-diff+xml": ["xdf"], "application/xenc+xml": ["xenc"], "application/xhtml+xml": ["xhtml", "xht"], "application/xml": ["xml", "xsl", "xsd", "rng"], "application/xml-dtd": ["dtd"], "application/xop+xml": ["xop"], "application/xproc+xml": ["xpl"], "application/xslt+xml": ["xslt"], "application/xspf+xml": ["xspf"], "application/xv+xml": ["mxml", "xhvml", "xvml", "xvm"], "application/yang": ["yang"], "application/yin+xml": ["yin"], "application/zip": ["zip"], "audio/3gpp": [], "audio/adpcm": ["adp"], "audio/basic": ["au", "snd"], "audio/midi": ["mid", "midi", "kar", "rmi"], "audio/mp3": [], "audio/mp4": ["m4a", "mp4a"], "audio/mpeg": ["mpga", "mp2", "mp2a", "mp3", "m2a", "m3a"], "audio/ogg": ["oga", "ogg", "spx"], "audio/s3m": ["s3m"], "audio/silk": ["sil"], "audio/vnd.dece.audio": ["uva", "uvva"], "audio/vnd.digital-winds": ["eol"], "audio/vnd.dra": ["dra"], "audio/vnd.dts": ["dts"], "audio/vnd.dts.hd": ["dtshd"], "audio/vnd.lucent.voice": ["lvp"], "audio/vnd.ms-playready.media.pya": ["pya"], "audio/vnd.nuera.ecelp4800": ["ecelp4800"], "audio/vnd.nuera.ecelp7470": ["ecelp7470"], "audio/vnd.nuera.ecelp9600": ["ecelp9600"], "audio/vnd.rip": ["rip"], "audio/wav": ["wav"], "audio/wave": [], "audio/webm": ["weba"], "audio/x-aac": ["aac"], "audio/x-aiff": ["aif", "aiff", "aifc"], "audio/x-caf": ["caf"], "audio/x-flac": ["flac"], "audio/x-m4a": [], "audio/x-matroska": ["mka"], "audio/x-mpegurl": ["m3u"], "audio/x-ms-wax": ["wax"], "audio/x-ms-wma": ["wma"], "audio/x-pn-realaudio": ["ram", "ra"], "audio/x-pn-realaudio-plugin": ["rmp"], "audio/x-realaudio": [], "audio/x-wav": [], "audio/xm": ["xm"], "chemical/x-cdx": ["cdx"], "chemical/x-cif": ["cif"], "chemical/x-cmdf": ["cmdf"], "chemical/x-cml": ["cml"], "chemical/x-csml": ["csml"], "chemical/x-xyz": ["xyz"], "font/collection": ["ttc"], "font/otf": ["otf"], "font/ttf": ["ttf"], "font/woff": ["woff"], "font/woff2": ["woff2"], "image/apng": ["apng"], "image/bmp": ["bmp"], "image/cgm": ["cgm"], "image/g3fax": ["g3"], "image/gif": ["gif"], "image/ief": ["ief"], "image/jp2": ["jp2", "jpg2"], "image/jpeg": ["jpeg", "jpg", "jpe"], "image/jpm": ["jpm"], "image/jpx": ["jpx", "jpf"], "image/ktx": ["ktx"], "image/png": ["png"], "image/prs.btif": ["btif"], "image/sgi": ["sgi"], "image/svg+xml": ["svg", "svgz"], "image/tiff": ["tiff", "tif"], "image/vnd.adobe.photoshop": ["psd"], "image/vnd.dece.graphic": ["uvi", "uvvi", "uvg", "uvvg"], "image/vnd.djvu": ["djvu", "djv"], "image/vnd.dvb.subtitle": [], "image/vnd.dwg": ["dwg"], "image/vnd.dxf": ["dxf"], "image/vnd.fastbidsheet": ["fbs"], "image/vnd.fpx": ["fpx"], "image/vnd.fst": ["fst"], "image/vnd.fujixerox.edmics-mmr": ["mmr"], "image/vnd.fujixerox.edmics-rlc": ["rlc"], "image/vnd.ms-modi": ["mdi"], "image/vnd.ms-photo": ["wdp"], "image/vnd.net-fpx": ["npx"], "image/vnd.wap.wbmp": ["wbmp"], "image/vnd.xiff": ["xif"], "image/webp": ["webp"], "image/x-3ds": ["3ds"], "image/x-cmu-raster": ["ras"], "image/x-cmx": ["cmx"], "image/x-freehand": ["fh", "fhc", "fh4", "fh5", "fh7"], "image/x-icon": ["ico"], "image/x-jng": ["jng"], "image/x-mrsid-image": ["sid"], "image/x-ms-bmp": [], "image/x-pcx": ["pcx"], "image/x-pict": ["pic", "pct"], "image/x-portable-anymap": ["pnm"], "image/x-portable-bitmap": ["pbm"], "image/x-portable-graymap": ["pgm"], "image/x-portable-pixmap": ["ppm"], "image/x-rgb": ["rgb"], "image/x-tga": ["tga"], "image/x-xbitmap": ["xbm"], "image/x-xpixmap": ["xpm"], "image/x-xwindowdump": ["xwd"], "message/rfc822": ["eml", "mime"], "model/gltf+json": ["gltf"], "model/gltf-binary": ["glb"], "model/iges": ["igs", "iges"], "model/mesh": ["msh", "mesh", "silo"], "model/vnd.collada+xml": ["dae"], "model/vnd.dwf": ["dwf"], "model/vnd.gdl": ["gdl"], "model/vnd.gtw": ["gtw"], "model/vnd.mts": ["mts"], "model/vnd.vtu": ["vtu"], "model/vrml": ["wrl", "vrml"], "model/x3d+binary": ["x3db", "x3dbz"], "model/x3d+vrml": ["x3dv", "x3dvz"], "model/x3d+xml": ["x3d", "x3dz"], "text/cache-manifest": ["appcache", "manifest"], "text/calendar": ["ics", "ifb"], "text/coffeescript": ["coffee", "litcoffee"], "text/css": ["css"], "text/csv": ["csv"], "text/hjson": ["hjson"], "text/html": ["html", "htm", "shtml"], "text/jade": ["jade"], "text/jsx": ["jsx"], "text/less": ["less"], "text/markdown": ["markdown", "md"], "text/mathml": ["mml"], "text/n3": ["n3"], "text/plain": ["txt", "text", "conf", "def", "list", "log", "in", "ini"], "text/prs.lines.tag": ["dsc"], "text/richtext": ["rtx"], "text/rtf": [], "text/sgml": ["sgml", "sgm"], "text/slim": ["slim", "slm"], "text/stylus": ["stylus", "styl"], "text/tab-separated-values": ["tsv"], "text/troff": ["t", "tr", "roff", "man", "me", "ms"], "text/turtle": ["ttl"], "text/uri-list": ["uri", "uris", "urls"], "text/vcard": ["vcard"], "text/vnd.curl": ["curl"], "text/vnd.curl.dcurl": ["dcurl"], "text/vnd.curl.mcurl": ["mcurl"], "text/vnd.curl.scurl": ["scurl"], "text/vnd.dvb.subtitle": ["sub"], "text/vnd.fly": ["fly"], "text/vnd.fmi.flexstor": ["flx"], "text/vnd.graphviz": ["gv"], "text/vnd.in3d.3dml": ["3dml"], "text/vnd.in3d.spot": ["spot"], "text/vnd.sun.j2me.app-descriptor": ["jad"], "text/vnd.wap.wml": ["wml"], "text/vnd.wap.wmlscript": ["wmls"], "text/vtt": ["vtt"], "text/x-asm": ["s", "asm"], "text/x-c": ["c", "cc", "cxx", "cpp", "h", "hh", "dic"], "text/x-component": ["htc"], "text/x-fortran": ["f", "for", "f77", "f90"], "text/x-handlebars-template": ["hbs"], "text/x-java-source": ["java"], "text/x-lua": ["lua"], "text/x-markdown": ["mkd"], "text/x-nfo": ["nfo"], "text/x-opml": ["opml"], "text/x-org": [], "text/x-pascal": ["p", "pas"], "text/x-processing": ["pde"], "text/x-sass": ["sass"], "text/x-scss": ["scss"], "text/x-setext": ["etx"], "text/x-sfv": ["sfv"], "text/x-suse-ymp": ["ymp"], "text/x-uuencode": ["uu"], "text/x-vcalendar": ["vcs"], "text/x-vcard": ["vcf"], "text/xml": [], "text/yaml": ["yaml", "yml"], "video/3gpp": ["3gp", "3gpp"], "video/3gpp2": ["3g2"], "video/h261": ["h261"], "video/h263": ["h263"], "video/h264": ["h264"], "video/jpeg": ["jpgv"], "video/jpm": ["jpgm"], "video/mj2": ["mj2", "mjp2"], "video/mp2t": ["ts"], "video/mp4": ["mp4", "mp4v", "mpg4"], "video/mpeg": ["mpeg", "mpg", "mpe", "m1v", "m2v"], "video/ogg": ["ogv"], "video/quicktime": ["qt", "mov"], "video/vnd.dece.hd": ["uvh", "uvvh"], "video/vnd.dece.mobile": ["uvm", "uvvm"], "video/vnd.dece.pd": ["uvp", "uvvp"], "video/vnd.dece.sd": ["uvs", "uvvs"], "video/vnd.dece.video": ["uvv", "uvvv"], "video/vnd.dvb.file": ["dvb"], "video/vnd.fvt": ["fvt"], "video/vnd.mpegurl": ["mxu", "m4u"], "video/vnd.ms-playready.media.pyv": ["pyv"], "video/vnd.uvvu.mp4": ["uvu", "uvvu"], "video/vnd.vivo": ["viv"], "video/webm": ["webm"], "video/x-f4v": ["f4v"], "video/x-fli": ["fli"], "video/x-flv": ["flv"], "video/x-m4v": ["m4v"], "video/x-matroska": ["mkv", "mk3d", "mks"], "video/x-mng": ["mng"], "video/x-ms-asf": ["asf", "asx"], "video/x-ms-vob": ["vob"], "video/x-ms-wm": ["wm"], "video/x-ms-wmv": ["wmv"], "video/x-ms-wmx": ["wmx"], "video/x-ms-wvx": ["wvx"], "video/x-msvideo": ["avi"], "video/x-sgi-movie": ["movie"], "video/x-smv": ["smv"], "x-conference/x-cooltalk": ["ice"] };
  }
});

// ../../node_modules/.pnpm/mime@1.6.0/node_modules/mime/mime.js
var require_mime = __commonJS({
  "../../node_modules/.pnpm/mime@1.6.0/node_modules/mime/mime.js"(exports, module) {
    init_cjs_shims();
    var path3 = __require("path"), fs6 = __require("fs");
    function Mime() {
      this.types = /* @__PURE__ */ Object.create(null), this.extensions = /* @__PURE__ */ Object.create(null);
    }
    Mime.prototype.define = function(map) {
      for (var type in map) {
        for (var exts = map[type], i = 0; i < exts.length; i++)
          process.env.DEBUG_MIME && this.types[exts[i]] && console.warn((this._loading || "define()").replace(/.*\//, ""), 'changes "' + exts[i] + '" extension type from ' + this.types[exts[i]] + " to " + type), this.types[exts[i]] = type;
        this.extensions[type] || (this.extensions[type] = exts[0]);
      }
    };
    Mime.prototype.load = function(file) {
      this._loading = file;
      var map = {}, content = fs6.readFileSync(file, "ascii"), lines = content.split(/[\r\n]+/);
      lines.forEach(function(line) {
        var fields = line.replace(/\s*#.*|^\s*|\s*$/g, "").split(/\s+/);
        map[fields.shift()] = fields;
      }), this.define(map), this._loading = null;
    };
    Mime.prototype.lookup = function(path4, fallback) {
      var ext = path4.replace(/^.*[\.\/\\]/, "").toLowerCase();
      return this.types[ext] || fallback || this.default_type;
    };
    Mime.prototype.extension = function(mimeType) {
      var type = mimeType.match(/^\s*([^;\s]*)(?:;|\s|$)/)[1].toLowerCase();
      return this.extensions[type];
    };
    var mime = new Mime();
    mime.define(require_types13());
    mime.default_type = mime.lookup("bin");
    mime.Mime = Mime;
    mime.charsets = {
      lookup: function(mimeType, fallback) {
        return /^text\/|^application\/(javascript|json)/.test(mimeType) ? "UTF-8" : fallback;
      }
    };
    module.exports = mime;
  }
});

// ../../node_modules/.pnpm/ms@2.1.3/node_modules/ms/index.js
var require_ms2 = __commonJS({
  "../../node_modules/.pnpm/ms@2.1.3/node_modules/ms/index.js"(exports, module) {
    init_cjs_shims();
    var s = 1e3, m = s * 60, h = m * 60, d = h * 24, w = d * 7, y = d * 365.25;
    module.exports = function(val, options) {
      options = options || {};
      var type = typeof val;
      if (type === "string" && val.length > 0)
        return parse4(val);
      if (type === "number" && isFinite(val))
        return options.long ? fmtLong(val) : fmtShort(val);
      throw new Error(
        "val is not a non-empty string or a valid number. val=" + JSON.stringify(val)
      );
    };
    function parse4(str) {
      if (str = String(str), !(str.length > 100)) {
        var match2 = /^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(
          str
        );
        if (match2) {
          var n = parseFloat(match2[1]), type = (match2[2] || "ms").toLowerCase();
          switch (type) {
            case "years":
            case "year":
            case "yrs":
            case "yr":
            case "y":
              return n * y;
            case "weeks":
            case "week":
            case "w":
              return n * w;
            case "days":
            case "day":
            case "d":
              return n * d;
            case "hours":
            case "hour":
            case "hrs":
            case "hr":
            case "h":
              return n * h;
            case "minutes":
            case "minute":
            case "mins":
            case "min":
            case "m":
              return n * m;
            case "seconds":
            case "second":
            case "secs":
            case "sec":
            case "s":
              return n * s;
            case "milliseconds":
            case "millisecond":
            case "msecs":
            case "msec":
            case "ms":
              return n;
            default:
              return;
          }
        }
      }
    }
    function fmtShort(ms) {
      var msAbs = Math.abs(ms);
      return msAbs >= d ? Math.round(ms / d) + "d" : msAbs >= h ? Math.round(ms / h) + "h" : msAbs >= m ? Math.round(ms / m) + "m" : msAbs >= s ? Math.round(ms / s) + "s" : ms + "ms";
    }
    function fmtLong(ms) {
      var msAbs = Math.abs(ms);
      return msAbs >= d ? plural(ms, msAbs, d, "day") : msAbs >= h ? plural(ms, msAbs, h, "hour") : msAbs >= m ? plural(ms, msAbs, m, "minute") : msAbs >= s ? plural(ms, msAbs, s, "second") : ms + " ms";
    }
    function plural(ms, msAbs, n, name) {
      var isPlural = msAbs >= n * 1.5;
      return Math.round(ms / n) + " " + name + (isPlural ? "s" : "");
    }
  }
});

// ../../node_modules/.pnpm/range-parser@1.2.1/node_modules/range-parser/index.js
var require_range_parser = __commonJS({
  "../../node_modules/.pnpm/range-parser@1.2.1/node_modules/range-parser/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = rangeParser;
    function rangeParser(size, str, options) {
      if (typeof str != "string")
        throw new TypeError("argument str must be a string");
      var index = str.indexOf("=");
      if (index === -1)
        return -2;
      var arr = str.slice(index + 1).split(","), ranges = [];
      ranges.type = str.slice(0, index);
      for (var i = 0; i < arr.length; i++) {
        var range = arr[i].split("-"), start = parseInt(range[0], 10), end = parseInt(range[1], 10);
        isNaN(start) ? (start = size - end, end = size - 1) : isNaN(end) && (end = size - 1), end > size - 1 && (end = size - 1), !(isNaN(start) || isNaN(end) || start > end || start < 0) && ranges.push({
          start,
          end
        });
      }
      return ranges.length < 1 ? -1 : options && options.combine ? combineRanges(ranges) : ranges;
    }
    function combineRanges(ranges) {
      for (var ordered = ranges.map(mapWithIndex).sort(sortByRangeStart), j = 0, i = 1; i < ordered.length; i++) {
        var range = ordered[i], current = ordered[j];
        range.start > current.end + 1 ? ordered[++j] = range : range.end > current.end && (current.end = range.end, current.index = Math.min(current.index, range.index));
      }
      ordered.length = j + 1;
      var combined = ordered.sort(sortByRangeIndex).map(mapWithoutIndex);
      return combined.type = ranges.type, combined;
    }
    function mapWithIndex(range, index) {
      return {
        start: range.start,
        end: range.end,
        index
      };
    }
    function mapWithoutIndex(range) {
      return {
        start: range.start,
        end: range.end
      };
    }
    function sortByRangeIndex(a, b) {
      return a.index - b.index;
    }
    function sortByRangeStart(a, b) {
      return a.start - b.start;
    }
  }
});

// ../../node_modules/.pnpm/send@0.18.0/node_modules/send/index.js
var require_send = __commonJS({
  "../../node_modules/.pnpm/send@0.18.0/node_modules/send/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var createError2 = require_http_errors(), debug4 = require_src2()("send"), deprecate = require_depd()("send"), destroy = require_destroy3(), encodeUrl = require_encodeurl(), escapeHtml = require_escape_html(), etag = require_etag(), fresh = require_fresh(), fs6 = __require("fs"), mime = require_mime(), ms = require_ms2(), onFinished = require_on_finished(), parseRange = require_range_parser(), path3 = __require("path"), statuses = require_statuses(), Stream = __require("stream"), util2 = __require("util"), extname2 = path3.extname, join6 = path3.join, normalize = path3.normalize, resolve2 = path3.resolve, sep3 = path3.sep, BYTES_RANGE_REGEXP = /^ *bytes=/, MAX_MAXAGE = 60 * 60 * 24 * 365 * 1e3, UP_PATH_REGEXP = /(?:^|[\\/])\.\.(?:[\\/]|$)/;
    module.exports = send2;
    module.exports.mime = mime;
    function send2(req, path4, options) {
      return new SendStream(req, path4, options);
    }
    function SendStream(req, path4, options) {
      Stream.call(this);
      var opts = options || {};
      if (this.options = opts, this.path = path4, this.req = req, this._acceptRanges = opts.acceptRanges !== void 0 ? !!opts.acceptRanges : !0, this._cacheControl = opts.cacheControl !== void 0 ? !!opts.cacheControl : !0, this._etag = opts.etag !== void 0 ? !!opts.etag : !0, this._dotfiles = opts.dotfiles !== void 0 ? opts.dotfiles : "ignore", this._dotfiles !== "ignore" && this._dotfiles !== "allow" && this._dotfiles !== "deny")
        throw new TypeError('dotfiles option must be "allow", "deny", or "ignore"');
      this._hidden = !!opts.hidden, opts.hidden !== void 0 && deprecate("hidden: use dotfiles: '" + (this._hidden ? "allow" : "ignore") + "' instead"), opts.dotfiles === void 0 && (this._dotfiles = void 0), this._extensions = opts.extensions !== void 0 ? normalizeList(opts.extensions, "extensions option") : [], this._immutable = opts.immutable !== void 0 ? !!opts.immutable : !1, this._index = opts.index !== void 0 ? normalizeList(opts.index, "index option") : ["index.html"], this._lastModified = opts.lastModified !== void 0 ? !!opts.lastModified : !0, this._maxage = opts.maxAge || opts.maxage, this._maxage = typeof this._maxage == "string" ? ms(this._maxage) : Number(this._maxage), this._maxage = isNaN(this._maxage) ? 0 : Math.min(Math.max(0, this._maxage), MAX_MAXAGE), this._root = opts.root ? resolve2(opts.root) : null, !this._root && opts.from && this.from(opts.from);
    }
    util2.inherits(SendStream, Stream);
    SendStream.prototype.etag = deprecate.function(function(val) {
      return this._etag = !!val, debug4("etag %s", this._etag), this;
    }, "send.etag: pass etag as option");
    SendStream.prototype.hidden = deprecate.function(function(val) {
      return this._hidden = !!val, this._dotfiles = void 0, debug4("hidden %s", this._hidden), this;
    }, "send.hidden: use dotfiles option");
    SendStream.prototype.index = deprecate.function(function(paths) {
      var index2 = paths ? normalizeList(paths, "paths argument") : [];
      return debug4("index %o", paths), this._index = index2, this;
    }, "send.index: pass index as option");
    SendStream.prototype.root = function(path4) {
      return this._root = resolve2(String(path4)), debug4("root %s", this._root), this;
    };
    SendStream.prototype.from = deprecate.function(
      SendStream.prototype.root,
      "send.from: pass root as option"
    );
    SendStream.prototype.root = deprecate.function(
      SendStream.prototype.root,
      "send.root: pass root as option"
    );
    SendStream.prototype.maxage = deprecate.function(function(maxAge) {
      return this._maxage = typeof maxAge == "string" ? ms(maxAge) : Number(maxAge), this._maxage = isNaN(this._maxage) ? 0 : Math.min(Math.max(0, this._maxage), MAX_MAXAGE), debug4("max-age %d", this._maxage), this;
    }, "send.maxage: pass maxAge as option");
    SendStream.prototype.error = function(status, err2) {
      if (hasListeners(this, "error"))
        return this.emit("error", createHttpError(status, err2));
      var res = this.res, msg = statuses.message[status] || String(status), doc = createHtmlDocument("Error", escapeHtml(msg));
      clearHeaders(res), err2 && err2.headers && setHeaders(res, err2.headers), res.statusCode = status, res.setHeader("Content-Type", "text/html; charset=UTF-8"), res.setHeader("Content-Length", Buffer.byteLength(doc)), res.setHeader("Content-Security-Policy", "default-src 'none'"), res.setHeader("X-Content-Type-Options", "nosniff"), res.end(doc);
    };
    SendStream.prototype.hasTrailingSlash = function() {
      return this.path[this.path.length - 1] === "/";
    };
    SendStream.prototype.isConditionalGET = function() {
      return this.req.headers["if-match"] || this.req.headers["if-unmodified-since"] || this.req.headers["if-none-match"] || this.req.headers["if-modified-since"];
    };
    SendStream.prototype.isPreconditionFailure = function() {
      var req = this.req, res = this.res, match2 = req.headers["if-match"];
      if (match2) {
        var etag2 = res.getHeader("ETag");
        return !etag2 || match2 !== "*" && parseTokenList(match2).every(function(match3) {
          return match3 !== etag2 && match3 !== "W/" + etag2 && "W/" + match3 !== etag2;
        });
      }
      var unmodifiedSince = parseHttpDate(req.headers["if-unmodified-since"]);
      if (!isNaN(unmodifiedSince)) {
        var lastModified = parseHttpDate(res.getHeader("Last-Modified"));
        return isNaN(lastModified) || lastModified > unmodifiedSince;
      }
      return !1;
    };
    SendStream.prototype.removeContentHeaderFields = function() {
      var res = this.res;
      res.removeHeader("Content-Encoding"), res.removeHeader("Content-Language"), res.removeHeader("Content-Length"), res.removeHeader("Content-Range"), res.removeHeader("Content-Type");
    };
    SendStream.prototype.notModified = function() {
      var res = this.res;
      debug4("not modified"), this.removeContentHeaderFields(), res.statusCode = 304, res.end();
    };
    SendStream.prototype.headersAlreadySent = function() {
      var err2 = new Error("Can't set headers after they are sent.");
      debug4("headers already sent"), this.error(500, err2);
    };
    SendStream.prototype.isCachable = function() {
      var statusCode = this.res.statusCode;
      return statusCode >= 200 && statusCode < 300 || statusCode === 304;
    };
    SendStream.prototype.onStatError = function(error) {
      switch (error.code) {
        case "ENAMETOOLONG":
        case "ENOENT":
        case "ENOTDIR":
          this.error(404, error);
          break;
        default:
          this.error(500, error);
          break;
      }
    };
    SendStream.prototype.isFresh = function() {
      return fresh(this.req.headers, {
        etag: this.res.getHeader("ETag"),
        "last-modified": this.res.getHeader("Last-Modified")
      });
    };
    SendStream.prototype.isRangeFresh = function() {
      var ifRange = this.req.headers["if-range"];
      if (!ifRange)
        return !0;
      if (ifRange.indexOf('"') !== -1) {
        var etag2 = this.res.getHeader("ETag");
        return !!(etag2 && ifRange.indexOf(etag2) !== -1);
      }
      var lastModified = this.res.getHeader("Last-Modified");
      return parseHttpDate(lastModified) <= parseHttpDate(ifRange);
    };
    SendStream.prototype.redirect = function(path4) {
      var res = this.res;
      if (hasListeners(this, "directory")) {
        this.emit("directory", res, path4);
        return;
      }
      if (this.hasTrailingSlash()) {
        this.error(403);
        return;
      }
      var loc = encodeUrl(collapseLeadingSlashes(this.path + "/")), doc = createHtmlDocument("Redirecting", 'Redirecting to <a href="' + escapeHtml(loc) + '">' + escapeHtml(loc) + "</a>");
      res.statusCode = 301, res.setHeader("Content-Type", "text/html; charset=UTF-8"), res.setHeader("Content-Length", Buffer.byteLength(doc)), res.setHeader("Content-Security-Policy", "default-src 'none'"), res.setHeader("X-Content-Type-Options", "nosniff"), res.setHeader("Location", loc), res.end(doc);
    };
    SendStream.prototype.pipe = function(res) {
      var root = this._root;
      this.res = res;
      var path4 = decode(this.path);
      if (path4 === -1)
        return this.error(400), res;
      if (~path4.indexOf("\0"))
        return this.error(400), res;
      var parts;
      if (root !== null) {
        if (path4 && (path4 = normalize("." + sep3 + path4)), UP_PATH_REGEXP.test(path4))
          return debug4('malicious path "%s"', path4), this.error(403), res;
        parts = path4.split(sep3), path4 = normalize(join6(root, path4));
      } else {
        if (UP_PATH_REGEXP.test(path4))
          return debug4('malicious path "%s"', path4), this.error(403), res;
        parts = normalize(path4).split(sep3), path4 = resolve2(path4);
      }
      if (containsDotFile(parts)) {
        var access2 = this._dotfiles;
        switch (access2 === void 0 && (access2 = parts[parts.length - 1][0] === "." ? this._hidden ? "allow" : "ignore" : "allow"), debug4('%s dotfile "%s"', access2, path4), access2) {
          case "allow":
            break;
          case "deny":
            return this.error(403), res;
          case "ignore":
          default:
            return this.error(404), res;
        }
      }
      return this._index.length && this.hasTrailingSlash() ? (this.sendIndex(path4), res) : (this.sendFile(path4), res);
    };
    SendStream.prototype.send = function(path4, stat) {
      var len = stat.size, options = this.options, opts = {}, res = this.res, req = this.req, ranges = req.headers.range, offset = options.start || 0;
      if (headersSent(res)) {
        this.headersAlreadySent();
        return;
      }
      if (debug4('pipe "%s"', path4), this.setHeader(path4, stat), this.type(path4), this.isConditionalGET()) {
        if (this.isPreconditionFailure()) {
          this.error(412);
          return;
        }
        if (this.isCachable() && this.isFresh()) {
          this.notModified();
          return;
        }
      }
      if (len = Math.max(0, len - offset), options.end !== void 0) {
        var bytes = options.end - offset + 1;
        len > bytes && (len = bytes);
      }
      if (this._acceptRanges && BYTES_RANGE_REGEXP.test(ranges)) {
        if (ranges = parseRange(len, ranges, {
          combine: !0
        }), this.isRangeFresh() || (debug4("range stale"), ranges = -2), ranges === -1)
          return debug4("range unsatisfiable"), res.setHeader("Content-Range", contentRange("bytes", len)), this.error(416, {
            headers: { "Content-Range": res.getHeader("Content-Range") }
          });
        ranges !== -2 && ranges.length === 1 && (debug4("range %j", ranges), res.statusCode = 206, res.setHeader("Content-Range", contentRange("bytes", len, ranges[0])), offset += ranges[0].start, len = ranges[0].end - ranges[0].start + 1);
      }
      for (var prop in options)
        opts[prop] = options[prop];
      if (opts.start = offset, opts.end = Math.max(offset, offset + len - 1), res.setHeader("Content-Length", len), req.method === "HEAD") {
        res.end();
        return;
      }
      this.stream(path4, opts);
    };
    SendStream.prototype.sendFile = function(path4) {
      var i = 0, self2 = this;
      debug4('stat "%s"', path4), fs6.stat(path4, function(err2, stat) {
        if (err2 && err2.code === "ENOENT" && !extname2(path4) && path4[path4.length - 1] !== sep3)
          return next(err2);
        if (err2)
          return self2.onStatError(err2);
        if (stat.isDirectory())
          return self2.redirect(path4);
        self2.emit("file", path4, stat), self2.send(path4, stat);
      });
      function next(err2) {
        if (self2._extensions.length <= i)
          return err2 ? self2.onStatError(err2) : self2.error(404);
        var p = path4 + "." + self2._extensions[i++];
        debug4('stat "%s"', p), fs6.stat(p, function(err3, stat) {
          if (err3)
            return next(err3);
          if (stat.isDirectory())
            return next();
          self2.emit("file", p, stat), self2.send(p, stat);
        });
      }
    };
    SendStream.prototype.sendIndex = function(path4) {
      var i = -1, self2 = this;
      function next(err2) {
        if (++i >= self2._index.length)
          return err2 ? self2.onStatError(err2) : self2.error(404);
        var p = join6(path4, self2._index[i]);
        debug4('stat "%s"', p), fs6.stat(p, function(err3, stat) {
          if (err3)
            return next(err3);
          if (stat.isDirectory())
            return next();
          self2.emit("file", p, stat), self2.send(p, stat);
        });
      }
      next();
    };
    SendStream.prototype.stream = function(path4, options) {
      var self2 = this, res = this.res, stream3 = fs6.createReadStream(path4, options);
      this.emit("stream", stream3), stream3.pipe(res);
      function cleanup2() {
        destroy(stream3, !0);
      }
      onFinished(res, cleanup2), stream3.on("error", function(err2) {
        cleanup2(), self2.onStatError(err2);
      }), stream3.on("end", function() {
        self2.emit("end");
      });
    };
    SendStream.prototype.type = function(path4) {
      var res = this.res;
      if (!res.getHeader("Content-Type")) {
        var type2 = mime.lookup(path4);
        if (!type2) {
          debug4("no content-type");
          return;
        }
        var charset = mime.charsets.lookup(type2);
        debug4("content-type %s", type2), res.setHeader("Content-Type", type2 + (charset ? "; charset=" + charset : ""));
      }
    };
    SendStream.prototype.setHeader = function(path4, stat) {
      var res = this.res;
      if (this.emit("headers", res, path4, stat), this._acceptRanges && !res.getHeader("Accept-Ranges") && (debug4("accept ranges"), res.setHeader("Accept-Ranges", "bytes")), this._cacheControl && !res.getHeader("Cache-Control")) {
        var cacheControl = "public, max-age=" + Math.floor(this._maxage / 1e3);
        this._immutable && (cacheControl += ", immutable"), debug4("cache-control %s", cacheControl), res.setHeader("Cache-Control", cacheControl);
      }
      if (this._lastModified && !res.getHeader("Last-Modified")) {
        var modified = stat.mtime.toUTCString();
        debug4("modified %s", modified), res.setHeader("Last-Modified", modified);
      }
      if (this._etag && !res.getHeader("ETag")) {
        var val = etag(stat);
        debug4("etag %s", val), res.setHeader("ETag", val);
      }
    };
    function clearHeaders(res) {
      for (var headers = getHeaderNames(res), i = 0; i < headers.length; i++)
        res.removeHeader(headers[i]);
    }
    function collapseLeadingSlashes(str) {
      for (var i = 0; i < str.length && str[i] === "/"; i++)
        ;
      return i > 1 ? "/" + str.substr(i) : str;
    }
    function containsDotFile(parts) {
      for (var i = 0; i < parts.length; i++) {
        var part = parts[i];
        if (part.length > 1 && part[0] === ".")
          return !0;
      }
      return !1;
    }
    function contentRange(type, size, range) {
      return type + " " + (range ? range.start + "-" + range.end : "*") + "/" + size;
    }
    function createHtmlDocument(title, body) {
      return `<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<title>` + title + `</title>
</head>
<body>
<pre>` + body + `</pre>
</body>
</html>
`;
    }
    function createHttpError(status, err2) {
      return err2 ? err2 instanceof Error ? createError2(status, err2, { expose: !1 }) : createError2(status, err2) : createError2(status);
    }
    function decode(path4) {
      try {
        return decodeURIComponent(path4);
      } catch {
        return -1;
      }
    }
    function getHeaderNames(res) {
      return typeof res.getHeaderNames != "function" ? Object.keys(res._headers || {}) : res.getHeaderNames();
    }
    function hasListeners(emitter, type) {
      var count = typeof emitter.listenerCount != "function" ? emitter.listeners(type).length : emitter.listenerCount(type);
      return count > 0;
    }
    function headersSent(res) {
      return typeof res.headersSent != "boolean" ? !!res._header : res.headersSent;
    }
    function normalizeList(val, name) {
      for (var list2 = [].concat(val || []), i = 0; i < list2.length; i++)
        if (typeof list2[i] != "string")
          throw new TypeError(name + " must be array of strings or false");
      return list2;
    }
    function parseHttpDate(date) {
      var timestamp = date && Date.parse(date);
      return typeof timestamp == "number" ? timestamp : NaN;
    }
    function parseTokenList(str) {
      for (var end = 0, list2 = [], start = 0, i = 0, len = str.length; i < len; i++)
        switch (str.charCodeAt(i)) {
          case 32:
            start === end && (start = end = i + 1);
            break;
          case 44:
            start !== end && list2.push(str.substring(start, end)), start = end = i + 1;
            break;
          default:
            end = i + 1;
            break;
        }
      return start !== end && list2.push(str.substring(start, end)), list2;
    }
    function setHeaders(res, headers) {
      for (var keys = Object.keys(headers), i = 0; i < keys.length; i++) {
        var key = keys[i];
        res.setHeader(key, headers[key]);
      }
    }
  }
});

// ../../node_modules/.pnpm/forwarded@0.2.0/node_modules/forwarded/index.js
var require_forwarded = __commonJS({
  "../../node_modules/.pnpm/forwarded@0.2.0/node_modules/forwarded/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = forwarded;
    function forwarded(req) {
      if (!req)
        throw new TypeError("argument req is required");
      var proxyAddrs = parse4(req.headers["x-forwarded-for"] || ""), socketAddr = getSocketAddr(req), addrs = [socketAddr].concat(proxyAddrs);
      return addrs;
    }
    function getSocketAddr(req) {
      return req.socket ? req.socket.remoteAddress : req.connection.remoteAddress;
    }
    function parse4(header2) {
      for (var end = header2.length, list2 = [], start = header2.length, i = header2.length - 1; i >= 0; i--)
        switch (header2.charCodeAt(i)) {
          case 32:
            start === end && (start = end = i);
            break;
          case 44:
            start !== end && list2.push(header2.substring(start, end)), start = end = i;
            break;
          default:
            start = i;
            break;
        }
      return start !== end && list2.push(header2.substring(start, end)), list2;
    }
  }
});

// ../../node_modules/.pnpm/ipaddr.js@1.9.1/node_modules/ipaddr.js/lib/ipaddr.js
var require_ipaddr = __commonJS({
  "../../node_modules/.pnpm/ipaddr.js@1.9.1/node_modules/ipaddr.js/lib/ipaddr.js"(exports, module) {
    init_cjs_shims();
    (function() {
      var expandIPv6, ipaddr, ipv4Part, ipv4Regexes, ipv6Part, ipv6Regexes, matchCIDR, root, zoneIndex;
      ipaddr = {}, root = this, typeof module < "u" && module !== null && module.exports ? module.exports = ipaddr : root.ipaddr = ipaddr, matchCIDR = function(first, second, partSize, cidrBits) {
        var part, shift;
        if (first.length !== second.length)
          throw new Error("ipaddr: cannot match CIDR for objects with different lengths");
        for (part = 0; cidrBits > 0; ) {
          if (shift = partSize - cidrBits, shift < 0 && (shift = 0), first[part] >> shift !== second[part] >> shift)
            return !1;
          cidrBits -= partSize, part += 1;
        }
        return !0;
      }, ipaddr.subnetMatch = function(address, rangeList, defaultName) {
        var k, len, rangeName, rangeSubnets, subnet;
        defaultName == null && (defaultName = "unicast");
        for (rangeName in rangeList)
          for (rangeSubnets = rangeList[rangeName], rangeSubnets[0] && !(rangeSubnets[0] instanceof Array) && (rangeSubnets = [rangeSubnets]), k = 0, len = rangeSubnets.length; k < len; k++)
            if (subnet = rangeSubnets[k], address.kind() === subnet[0].kind() && address.match.apply(address, subnet))
              return rangeName;
        return defaultName;
      }, ipaddr.IPv4 = function() {
        function IPv4(octets) {
          var k, len, octet;
          if (octets.length !== 4)
            throw new Error("ipaddr: ipv4 octet count should be 4");
          for (k = 0, len = octets.length; k < len; k++)
            if (octet = octets[k], !(0 <= octet && octet <= 255))
              throw new Error("ipaddr: ipv4 octet should fit in 8 bits");
          this.octets = octets;
        }
        return IPv4.prototype.kind = function() {
          return "ipv4";
        }, IPv4.prototype.toString = function() {
          return this.octets.join(".");
        }, IPv4.prototype.toNormalizedString = function() {
          return this.toString();
        }, IPv4.prototype.toByteArray = function() {
          return this.octets.slice(0);
        }, IPv4.prototype.match = function(other, cidrRange) {
          var ref;
          if (cidrRange === void 0 && (ref = other, other = ref[0], cidrRange = ref[1]), other.kind() !== "ipv4")
            throw new Error("ipaddr: cannot match ipv4 address with non-ipv4 one");
          return matchCIDR(this.octets, other.octets, 8, cidrRange);
        }, IPv4.prototype.SpecialRanges = {
          unspecified: [[new IPv4([0, 0, 0, 0]), 8]],
          broadcast: [[new IPv4([255, 255, 255, 255]), 32]],
          multicast: [[new IPv4([224, 0, 0, 0]), 4]],
          linkLocal: [[new IPv4([169, 254, 0, 0]), 16]],
          loopback: [[new IPv4([127, 0, 0, 0]), 8]],
          carrierGradeNat: [[new IPv4([100, 64, 0, 0]), 10]],
          private: [[new IPv4([10, 0, 0, 0]), 8], [new IPv4([172, 16, 0, 0]), 12], [new IPv4([192, 168, 0, 0]), 16]],
          reserved: [[new IPv4([192, 0, 0, 0]), 24], [new IPv4([192, 0, 2, 0]), 24], [new IPv4([192, 88, 99, 0]), 24], [new IPv4([198, 51, 100, 0]), 24], [new IPv4([203, 0, 113, 0]), 24], [new IPv4([240, 0, 0, 0]), 4]]
        }, IPv4.prototype.range = function() {
          return ipaddr.subnetMatch(this, this.SpecialRanges);
        }, IPv4.prototype.toIPv4MappedAddress = function() {
          return ipaddr.IPv6.parse("::ffff:" + this.toString());
        }, IPv4.prototype.prefixLengthFromSubnetMask = function() {
          var cidr, i, k, octet, stop, zeros, zerotable;
          for (zerotable = {
            0: 8,
            128: 7,
            192: 6,
            224: 5,
            240: 4,
            248: 3,
            252: 2,
            254: 1,
            255: 0
          }, cidr = 0, stop = !1, i = k = 3; k >= 0; i = k += -1)
            if (octet = this.octets[i], octet in zerotable) {
              if (zeros = zerotable[octet], stop && zeros !== 0)
                return null;
              zeros !== 8 && (stop = !0), cidr += zeros;
            } else
              return null;
          return 32 - cidr;
        }, IPv4;
      }(), ipv4Part = "(0?\\d+|0x[a-f0-9]+)", ipv4Regexes = {
        fourOctet: new RegExp("^" + ipv4Part + "\\." + ipv4Part + "\\." + ipv4Part + "\\." + ipv4Part + "$", "i"),
        longValue: new RegExp("^" + ipv4Part + "$", "i")
      }, ipaddr.IPv4.parser = function(string) {
        var match2, parseIntAuto, part, shift, value;
        if (parseIntAuto = function(string2) {
          return string2[0] === "0" && string2[1] !== "x" ? parseInt(string2, 8) : parseInt(string2);
        }, match2 = string.match(ipv4Regexes.fourOctet))
          return function() {
            var k, len, ref, results;
            for (ref = match2.slice(1, 6), results = [], k = 0, len = ref.length; k < len; k++)
              part = ref[k], results.push(parseIntAuto(part));
            return results;
          }();
        if (match2 = string.match(ipv4Regexes.longValue)) {
          if (value = parseIntAuto(match2[1]), value > 4294967295 || value < 0)
            throw new Error("ipaddr: address outside defined range");
          return function() {
            var k, results;
            for (results = [], shift = k = 0; k <= 24; shift = k += 8)
              results.push(value >> shift & 255);
            return results;
          }().reverse();
        } else
          return null;
      }, ipaddr.IPv6 = function() {
        function IPv6(parts, zoneId) {
          var i, k, l, len, part, ref;
          if (parts.length === 16)
            for (this.parts = [], i = k = 0; k <= 14; i = k += 2)
              this.parts.push(parts[i] << 8 | parts[i + 1]);
          else if (parts.length === 8)
            this.parts = parts;
          else
            throw new Error("ipaddr: ipv6 part count should be 8 or 16");
          for (ref = this.parts, l = 0, len = ref.length; l < len; l++)
            if (part = ref[l], !(0 <= part && part <= 65535))
              throw new Error("ipaddr: ipv6 part should fit in 16 bits");
          zoneId && (this.zoneId = zoneId);
        }
        return IPv6.prototype.kind = function() {
          return "ipv6";
        }, IPv6.prototype.toString = function() {
          return this.toNormalizedString().replace(/((^|:)(0(:|$))+)/, "::");
        }, IPv6.prototype.toRFC5952String = function() {
          var bestMatchIndex, bestMatchLength, match2, regex, string;
          for (regex = /((^|:)(0(:|$)){2,})/g, string = this.toNormalizedString(), bestMatchIndex = 0, bestMatchLength = -1; match2 = regex.exec(string); )
            match2[0].length > bestMatchLength && (bestMatchIndex = match2.index, bestMatchLength = match2[0].length);
          return bestMatchLength < 0 ? string : string.substring(0, bestMatchIndex) + "::" + string.substring(bestMatchIndex + bestMatchLength);
        }, IPv6.prototype.toByteArray = function() {
          var bytes, k, len, part, ref;
          for (bytes = [], ref = this.parts, k = 0, len = ref.length; k < len; k++)
            part = ref[k], bytes.push(part >> 8), bytes.push(part & 255);
          return bytes;
        }, IPv6.prototype.toNormalizedString = function() {
          var addr, part, suffix;
          return addr = function() {
            var k, len, ref, results;
            for (ref = this.parts, results = [], k = 0, len = ref.length; k < len; k++)
              part = ref[k], results.push(part.toString(16));
            return results;
          }.call(this).join(":"), suffix = "", this.zoneId && (suffix = "%" + this.zoneId), addr + suffix;
        }, IPv6.prototype.toFixedLengthString = function() {
          var addr, part, suffix;
          return addr = function() {
            var k, len, ref, results;
            for (ref = this.parts, results = [], k = 0, len = ref.length; k < len; k++)
              part = ref[k], results.push(part.toString(16).padStart(4, "0"));
            return results;
          }.call(this).join(":"), suffix = "", this.zoneId && (suffix = "%" + this.zoneId), addr + suffix;
        }, IPv6.prototype.match = function(other, cidrRange) {
          var ref;
          if (cidrRange === void 0 && (ref = other, other = ref[0], cidrRange = ref[1]), other.kind() !== "ipv6")
            throw new Error("ipaddr: cannot match ipv6 address with non-ipv6 one");
          return matchCIDR(this.parts, other.parts, 16, cidrRange);
        }, IPv6.prototype.SpecialRanges = {
          unspecified: [new IPv6([0, 0, 0, 0, 0, 0, 0, 0]), 128],
          linkLocal: [new IPv6([65152, 0, 0, 0, 0, 0, 0, 0]), 10],
          multicast: [new IPv6([65280, 0, 0, 0, 0, 0, 0, 0]), 8],
          loopback: [new IPv6([0, 0, 0, 0, 0, 0, 0, 1]), 128],
          uniqueLocal: [new IPv6([64512, 0, 0, 0, 0, 0, 0, 0]), 7],
          ipv4Mapped: [new IPv6([0, 0, 0, 0, 0, 65535, 0, 0]), 96],
          rfc6145: [new IPv6([0, 0, 0, 0, 65535, 0, 0, 0]), 96],
          rfc6052: [new IPv6([100, 65435, 0, 0, 0, 0, 0, 0]), 96],
          "6to4": [new IPv6([8194, 0, 0, 0, 0, 0, 0, 0]), 16],
          teredo: [new IPv6([8193, 0, 0, 0, 0, 0, 0, 0]), 32],
          reserved: [[new IPv6([8193, 3512, 0, 0, 0, 0, 0, 0]), 32]]
        }, IPv6.prototype.range = function() {
          return ipaddr.subnetMatch(this, this.SpecialRanges);
        }, IPv6.prototype.isIPv4MappedAddress = function() {
          return this.range() === "ipv4Mapped";
        }, IPv6.prototype.toIPv4Address = function() {
          var high, low, ref;
          if (!this.isIPv4MappedAddress())
            throw new Error("ipaddr: trying to convert a generic ipv6 address to ipv4");
          return ref = this.parts.slice(-2), high = ref[0], low = ref[1], new ipaddr.IPv4([high >> 8, high & 255, low >> 8, low & 255]);
        }, IPv6.prototype.prefixLengthFromSubnetMask = function() {
          var cidr, i, k, part, stop, zeros, zerotable;
          for (zerotable = {
            0: 16,
            32768: 15,
            49152: 14,
            57344: 13,
            61440: 12,
            63488: 11,
            64512: 10,
            65024: 9,
            65280: 8,
            65408: 7,
            65472: 6,
            65504: 5,
            65520: 4,
            65528: 3,
            65532: 2,
            65534: 1,
            65535: 0
          }, cidr = 0, stop = !1, i = k = 7; k >= 0; i = k += -1)
            if (part = this.parts[i], part in zerotable) {
              if (zeros = zerotable[part], stop && zeros !== 0)
                return null;
              zeros !== 16 && (stop = !0), cidr += zeros;
            } else
              return null;
          return 128 - cidr;
        }, IPv6;
      }(), ipv6Part = "(?:[0-9a-f]+::?)+", zoneIndex = "%[0-9a-z]{1,}", ipv6Regexes = {
        zoneIndex: new RegExp(zoneIndex, "i"),
        native: new RegExp("^(::)?(" + ipv6Part + ")?([0-9a-f]+)?(::)?(" + zoneIndex + ")?$", "i"),
        transitional: new RegExp("^((?:" + ipv6Part + ")|(?:::)(?:" + ipv6Part + ")?)" + (ipv4Part + "\\." + ipv4Part + "\\." + ipv4Part + "\\." + ipv4Part) + ("(" + zoneIndex + ")?$"), "i")
      }, expandIPv6 = function(string, parts) {
        var colonCount, lastColon, part, replacement, replacementCount, zoneId;
        if (string.indexOf("::") !== string.lastIndexOf("::"))
          return null;
        for (zoneId = (string.match(ipv6Regexes.zoneIndex) || [])[0], zoneId && (zoneId = zoneId.substring(1), string = string.replace(/%.+$/, "")), colonCount = 0, lastColon = -1; (lastColon = string.indexOf(":", lastColon + 1)) >= 0; )
          colonCount++;
        if (string.substr(0, 2) === "::" && colonCount--, string.substr(-2, 2) === "::" && colonCount--, colonCount > parts)
          return null;
        for (replacementCount = parts - colonCount, replacement = ":"; replacementCount--; )
          replacement += "0:";
        return string = string.replace("::", replacement), string[0] === ":" && (string = string.slice(1)), string[string.length - 1] === ":" && (string = string.slice(0, -1)), parts = function() {
          var k, len, ref, results;
          for (ref = string.split(":"), results = [], k = 0, len = ref.length; k < len; k++)
            part = ref[k], results.push(parseInt(part, 16));
          return results;
        }(), {
          parts,
          zoneId
        };
      }, ipaddr.IPv6.parser = function(string) {
        var addr, k, len, match2, octet, octets, zoneId;
        if (ipv6Regexes.native.test(string))
          return expandIPv6(string, 8);
        if ((match2 = string.match(ipv6Regexes.transitional)) && (zoneId = match2[6] || "", addr = expandIPv6(match2[1].slice(0, -1) + zoneId, 6), addr.parts)) {
          for (octets = [parseInt(match2[2]), parseInt(match2[3]), parseInt(match2[4]), parseInt(match2[5])], k = 0, len = octets.length; k < len; k++)
            if (octet = octets[k], !(0 <= octet && octet <= 255))
              return null;
          return addr.parts.push(octets[0] << 8 | octets[1]), addr.parts.push(octets[2] << 8 | octets[3]), {
            parts: addr.parts,
            zoneId: addr.zoneId
          };
        }
        return null;
      }, ipaddr.IPv4.isIPv4 = ipaddr.IPv6.isIPv6 = function(string) {
        return this.parser(string) !== null;
      }, ipaddr.IPv4.isValid = function(string) {
        var e;
        try {
          return new this(this.parser(string)), !0;
        } catch (error1) {
          return e = error1, !1;
        }
      }, ipaddr.IPv4.isValidFourPartDecimal = function(string) {
        return !!(ipaddr.IPv4.isValid(string) && string.match(/^(0|[1-9]\d*)(\.(0|[1-9]\d*)){3}$/));
      }, ipaddr.IPv6.isValid = function(string) {
        var addr, e;
        if (typeof string == "string" && string.indexOf(":") === -1)
          return !1;
        try {
          return addr = this.parser(string), new this(addr.parts, addr.zoneId), !0;
        } catch (error1) {
          return e = error1, !1;
        }
      }, ipaddr.IPv4.parse = function(string) {
        var parts;
        if (parts = this.parser(string), parts === null)
          throw new Error("ipaddr: string is not formatted like ip address");
        return new this(parts);
      }, ipaddr.IPv6.parse = function(string) {
        var addr;
        if (addr = this.parser(string), addr.parts === null)
          throw new Error("ipaddr: string is not formatted like ip address");
        return new this(addr.parts, addr.zoneId);
      }, ipaddr.IPv4.parseCIDR = function(string) {
        var maskLength, match2, parsed;
        if ((match2 = string.match(/^(.+)\/(\d+)$/)) && (maskLength = parseInt(match2[2]), maskLength >= 0 && maskLength <= 32))
          return parsed = [this.parse(match2[1]), maskLength], Object.defineProperty(parsed, "toString", {
            value: function() {
              return this.join("/");
            }
          }), parsed;
        throw new Error("ipaddr: string is not formatted like an IPv4 CIDR range");
      }, ipaddr.IPv4.subnetMaskFromPrefixLength = function(prefix) {
        var filledOctetCount, j, octets;
        if (prefix = parseInt(prefix), prefix < 0 || prefix > 32)
          throw new Error("ipaddr: invalid IPv4 prefix length");
        for (octets = [0, 0, 0, 0], j = 0, filledOctetCount = Math.floor(prefix / 8); j < filledOctetCount; )
          octets[j] = 255, j++;
        return filledOctetCount < 4 && (octets[filledOctetCount] = Math.pow(2, prefix % 8) - 1 << 8 - prefix % 8), new this(octets);
      }, ipaddr.IPv4.broadcastAddressFromCIDR = function(string) {
        var cidr, error, i, ipInterfaceOctets, octets, subnetMaskOctets;
        try {
          for (cidr = this.parseCIDR(string), ipInterfaceOctets = cidr[0].toByteArray(), subnetMaskOctets = this.subnetMaskFromPrefixLength(cidr[1]).toByteArray(), octets = [], i = 0; i < 4; )
            octets.push(parseInt(ipInterfaceOctets[i], 10) | parseInt(subnetMaskOctets[i], 10) ^ 255), i++;
          return new this(octets);
        } catch (error1) {
          throw error = error1, new Error("ipaddr: the address does not have IPv4 CIDR format");
        }
      }, ipaddr.IPv4.networkAddressFromCIDR = function(string) {
        var cidr, error, i, ipInterfaceOctets, octets, subnetMaskOctets;
        try {
          for (cidr = this.parseCIDR(string), ipInterfaceOctets = cidr[0].toByteArray(), subnetMaskOctets = this.subnetMaskFromPrefixLength(cidr[1]).toByteArray(), octets = [], i = 0; i < 4; )
            octets.push(parseInt(ipInterfaceOctets[i], 10) & parseInt(subnetMaskOctets[i], 10)), i++;
          return new this(octets);
        } catch (error1) {
          throw error = error1, new Error("ipaddr: the address does not have IPv4 CIDR format");
        }
      }, ipaddr.IPv6.parseCIDR = function(string) {
        var maskLength, match2, parsed;
        if ((match2 = string.match(/^(.+)\/(\d+)$/)) && (maskLength = parseInt(match2[2]), maskLength >= 0 && maskLength <= 128))
          return parsed = [this.parse(match2[1]), maskLength], Object.defineProperty(parsed, "toString", {
            value: function() {
              return this.join("/");
            }
          }), parsed;
        throw new Error("ipaddr: string is not formatted like an IPv6 CIDR range");
      }, ipaddr.isValid = function(string) {
        return ipaddr.IPv6.isValid(string) || ipaddr.IPv4.isValid(string);
      }, ipaddr.parse = function(string) {
        if (ipaddr.IPv6.isValid(string))
          return ipaddr.IPv6.parse(string);
        if (ipaddr.IPv4.isValid(string))
          return ipaddr.IPv4.parse(string);
        throw new Error("ipaddr: the address has neither IPv6 nor IPv4 format");
      }, ipaddr.parseCIDR = function(string) {
        var e;
        try {
          return ipaddr.IPv6.parseCIDR(string);
        } catch (error1) {
          e = error1;
          try {
            return ipaddr.IPv4.parseCIDR(string);
          } catch (error12) {
            throw e = error12, new Error("ipaddr: the address has neither IPv6 nor IPv4 CIDR format");
          }
        }
      }, ipaddr.fromByteArray = function(bytes) {
        var length;
        if (length = bytes.length, length === 4)
          return new ipaddr.IPv4(bytes);
        if (length === 16)
          return new ipaddr.IPv6(bytes);
        throw new Error("ipaddr: the binary input is neither an IPv6 nor IPv4 address");
      }, ipaddr.process = function(string) {
        var addr;
        return addr = this.parse(string), addr.kind() === "ipv6" && addr.isIPv4MappedAddress() ? addr.toIPv4Address() : addr;
      };
    }).call(exports);
  }
});

// ../../node_modules/.pnpm/proxy-addr@2.0.7/node_modules/proxy-addr/index.js
var require_proxy_addr = __commonJS({
  "../../node_modules/.pnpm/proxy-addr@2.0.7/node_modules/proxy-addr/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = proxyaddr;
    module.exports.all = alladdrs;
    module.exports.compile = compile;
    var forwarded = require_forwarded(), ipaddr = require_ipaddr(), DIGIT_REGEXP = /^[0-9]+$/, isip = ipaddr.isValid, parseip = ipaddr.parse, IP_RANGES = {
      linklocal: ["169.254.0.0/16", "fe80::/10"],
      loopback: ["127.0.0.1/8", "::1/128"],
      uniquelocal: ["10.0.0.0/8", "172.16.0.0/12", "192.168.0.0/16", "fc00::/7"]
    };
    function alladdrs(req, trust) {
      var addrs = forwarded(req);
      if (!trust)
        return addrs;
      typeof trust != "function" && (trust = compile(trust));
      for (var i = 0; i < addrs.length - 1; i++)
        trust(addrs[i], i) || (addrs.length = i + 1);
      return addrs;
    }
    function compile(val) {
      if (!val)
        throw new TypeError("argument is required");
      var trust;
      if (typeof val == "string")
        trust = [val];
      else if (Array.isArray(val))
        trust = val.slice();
      else
        throw new TypeError("unsupported trust argument");
      for (var i = 0; i < trust.length; i++)
        val = trust[i], Object.prototype.hasOwnProperty.call(IP_RANGES, val) && (val = IP_RANGES[val], trust.splice.apply(trust, [i, 1].concat(val)), i += val.length - 1);
      return compileTrust(compileRangeSubnets(trust));
    }
    function compileRangeSubnets(arr) {
      for (var rangeSubnets = new Array(arr.length), i = 0; i < arr.length; i++)
        rangeSubnets[i] = parseipNotation(arr[i]);
      return rangeSubnets;
    }
    function compileTrust(rangeSubnets) {
      var len = rangeSubnets.length;
      return len === 0 ? trustNone : len === 1 ? trustSingle(rangeSubnets[0]) : trustMulti(rangeSubnets);
    }
    function parseipNotation(note) {
      var pos = note.lastIndexOf("/"), str = pos !== -1 ? note.substring(0, pos) : note;
      if (!isip(str))
        throw new TypeError("invalid IP address: " + str);
      var ip = parseip(str);
      pos === -1 && ip.kind() === "ipv6" && ip.isIPv4MappedAddress() && (ip = ip.toIPv4Address());
      var max = ip.kind() === "ipv6" ? 128 : 32, range = pos !== -1 ? note.substring(pos + 1, note.length) : null;
      if (range === null ? range = max : DIGIT_REGEXP.test(range) ? range = parseInt(range, 10) : ip.kind() === "ipv4" && isip(range) ? range = parseNetmask(range) : range = null, range <= 0 || range > max)
        throw new TypeError("invalid range on address: " + note);
      return [ip, range];
    }
    function parseNetmask(netmask) {
      var ip = parseip(netmask), kind = ip.kind();
      return kind === "ipv4" ? ip.prefixLengthFromSubnetMask() : null;
    }
    function proxyaddr(req, trust) {
      if (!req)
        throw new TypeError("req argument is required");
      if (!trust)
        throw new TypeError("trust argument is required");
      var addrs = alladdrs(req, trust), addr = addrs[addrs.length - 1];
      return addr;
    }
    function trustNone() {
      return !1;
    }
    function trustMulti(subnets) {
      return function(addr) {
        if (!isip(addr))
          return !1;
        for (var ip = parseip(addr), ipconv, kind = ip.kind(), i = 0; i < subnets.length; i++) {
          var subnet = subnets[i], subnetip = subnet[0], subnetkind = subnetip.kind(), subnetrange = subnet[1], trusted = ip;
          if (kind !== subnetkind) {
            if (subnetkind === "ipv4" && !ip.isIPv4MappedAddress())
              continue;
            ipconv || (ipconv = subnetkind === "ipv4" ? ip.toIPv4Address() : ip.toIPv4MappedAddress()), trusted = ipconv;
          }
          if (trusted.match(subnetip, subnetrange))
            return !0;
        }
        return !1;
      };
    }
    function trustSingle(subnet) {
      var subnetip = subnet[0], subnetkind = subnetip.kind(), subnetisipv4 = subnetkind === "ipv4", subnetrange = subnet[1];
      return function(addr) {
        if (!isip(addr))
          return !1;
        var ip = parseip(addr), kind = ip.kind();
        if (kind !== subnetkind) {
          if (subnetisipv4 && !ip.isIPv4MappedAddress())
            return !1;
          ip = subnetisipv4 ? ip.toIPv4Address() : ip.toIPv4MappedAddress();
        }
        return ip.match(subnetip, subnetrange);
      };
    }
  }
});

// ../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/utils.js
var require_utils15 = __commonJS({
  "../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/utils.js"(exports) {
    "use strict";
    init_cjs_shims();
    var Buffer2 = require_safe_buffer2().Buffer, contentDisposition = require_content_disposition(), contentType = require_content_type(), deprecate = require_depd()("express"), flatten = require_array_flatten(), mime = require_send().mime, etag = require_etag(), proxyaddr = require_proxy_addr(), qs = require_lib9(), querystring = __require("querystring");
    exports.etag = createETagGenerator({ weak: !1 });
    exports.wetag = createETagGenerator({ weak: !0 });
    exports.isAbsolute = function(path3) {
      if (path3[0] === "/" || path3[1] === ":" && (path3[2] === "\\" || path3[2] === "/") || path3.substring(0, 2) === "\\\\")
        return !0;
    };
    exports.flatten = deprecate.function(
      flatten,
      "utils.flatten: use array-flatten npm module instead"
    );
    exports.normalizeType = function(type) {
      return ~type.indexOf("/") ? acceptParams(type) : { value: mime.lookup(type), params: {} };
    };
    exports.normalizeTypes = function(types) {
      for (var ret = [], i = 0; i < types.length; ++i)
        ret.push(exports.normalizeType(types[i]));
      return ret;
    };
    exports.contentDisposition = deprecate.function(
      contentDisposition,
      "utils.contentDisposition: use content-disposition npm module instead"
    );
    function acceptParams(str) {
      for (var parts = str.split(/ *; */), ret = { value: parts[0], quality: 1, params: {} }, i = 1; i < parts.length; ++i) {
        var pms = parts[i].split(/ *= */);
        pms[0] === "q" ? ret.quality = parseFloat(pms[1]) : ret.params[pms[0]] = pms[1];
      }
      return ret;
    }
    exports.compileETag = function(val) {
      var fn;
      if (typeof val == "function")
        return val;
      switch (val) {
        case !0:
        case "weak":
          fn = exports.wetag;
          break;
        case !1:
          break;
        case "strong":
          fn = exports.etag;
          break;
        default:
          throw new TypeError("unknown value for etag function: " + val);
      }
      return fn;
    };
    exports.compileQueryParser = function(val) {
      var fn;
      if (typeof val == "function")
        return val;
      switch (val) {
        case !0:
        case "simple":
          fn = querystring.parse;
          break;
        case !1:
          fn = newObject;
          break;
        case "extended":
          fn = parseExtendedQueryString;
          break;
        default:
          throw new TypeError("unknown value for query parser function: " + val);
      }
      return fn;
    };
    exports.compileTrust = function(val) {
      return typeof val == "function" ? val : val === !0 ? function() {
        return !0;
      } : typeof val == "number" ? function(a, i) {
        return i < val;
      } : (typeof val == "string" && (val = val.split(",").map(function(v) {
        return v.trim();
      })), proxyaddr.compile(val || []));
    };
    exports.setCharset = function(type, charset) {
      if (!type || !charset)
        return type;
      var parsed = contentType.parse(type);
      return parsed.parameters.charset = charset, contentType.format(parsed);
    };
    function createETagGenerator(options) {
      return function(body, encoding) {
        var buf = Buffer2.isBuffer(body) ? body : Buffer2.from(body, encoding);
        return etag(buf, options);
      };
    }
    function parseExtendedQueryString(str) {
      return qs.parse(str, {
        allowPrototypes: !0
      });
    }
    function newObject() {
      return {};
    }
  }
});

// ../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/application.js
var require_application = __commonJS({
  "../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/application.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var finalhandler = require_finalhandler(), Router = require_router(), methods = require_methods(), middleware = require_init(), query = require_query(), debug4 = require_src2()("express:application"), View = require_view(), http3 = __require("http"), compileETag = require_utils15().compileETag, compileQueryParser = require_utils15().compileQueryParser, compileTrust = require_utils15().compileTrust, deprecate = require_depd()("express"), flatten = require_array_flatten(), merge = require_utils_merge(), resolve2 = __require("path").resolve, setPrototypeOf = require_setprototypeof(), hasOwnProperty = Object.prototype.hasOwnProperty, slice = Array.prototype.slice, app = exports = module.exports = {}, trustProxyDefaultSymbol = "@@symbol:trust_proxy_default";
    app.init = function() {
      this.cache = {}, this.engines = {}, this.settings = {}, this.defaultConfiguration();
    };
    app.defaultConfiguration = function() {
      var env = process.env.NODE_ENV || "development";
      this.enable("x-powered-by"), this.set("etag", "weak"), this.set("env", env), this.set("query parser", "extended"), this.set("subdomain offset", 2), this.set("trust proxy", !1), Object.defineProperty(this.settings, trustProxyDefaultSymbol, {
        configurable: !0,
        value: !0
      }), debug4("booting in %s mode", env), this.on("mount", function(parent) {
        this.settings[trustProxyDefaultSymbol] === !0 && typeof parent.settings["trust proxy fn"] == "function" && (delete this.settings["trust proxy"], delete this.settings["trust proxy fn"]), setPrototypeOf(this.request, parent.request), setPrototypeOf(this.response, parent.response), setPrototypeOf(this.engines, parent.engines), setPrototypeOf(this.settings, parent.settings);
      }), this.locals = /* @__PURE__ */ Object.create(null), this.mountpath = "/", this.locals.settings = this.settings, this.set("view", View), this.set("views", resolve2("views")), this.set("jsonp callback name", "callback"), env === "production" && this.enable("view cache"), Object.defineProperty(this, "router", {
        get: function() {
          throw new Error(`'app.router' is deprecated!
Please see the 3.x to 4.x migration guide for details on how to update your app.`);
        }
      });
    };
    app.lazyrouter = function() {
      this._router || (this._router = new Router({
        caseSensitive: this.enabled("case sensitive routing"),
        strict: this.enabled("strict routing")
      }), this._router.use(query(this.get("query parser fn"))), this._router.use(middleware.init(this)));
    };
    app.handle = function(req, res, callback) {
      var router = this._router, done = callback || finalhandler(req, res, {
        env: this.get("env"),
        onerror: logerror.bind(this)
      });
      if (!router) {
        debug4("no routes defined on app"), done();
        return;
      }
      router.handle(req, res, done);
    };
    app.use = function(fn) {
      var offset = 0, path3 = "/";
      if (typeof fn != "function") {
        for (var arg = fn; Array.isArray(arg) && arg.length !== 0; )
          arg = arg[0];
        typeof arg != "function" && (offset = 1, path3 = fn);
      }
      var fns = flatten(slice.call(arguments, offset));
      if (fns.length === 0)
        throw new TypeError("app.use() requires a middleware function");
      this.lazyrouter();
      var router = this._router;
      return fns.forEach(function(fn2) {
        if (!fn2 || !fn2.handle || !fn2.set)
          return router.use(path3, fn2);
        debug4(".use app under %s", path3), fn2.mountpath = path3, fn2.parent = this, router.use(path3, function(req, res, next) {
          var orig = req.app;
          fn2.handle(req, res, function(err2) {
            setPrototypeOf(req, orig.request), setPrototypeOf(res, orig.response), next(err2);
          });
        }), fn2.emit("mount", this);
      }, this), this;
    };
    app.route = function(path3) {
      return this.lazyrouter(), this._router.route(path3);
    };
    app.engine = function(ext, fn) {
      if (typeof fn != "function")
        throw new Error("callback function required");
      var extension = ext[0] !== "." ? "." + ext : ext;
      return this.engines[extension] = fn, this;
    };
    app.param = function(name, fn) {
      if (this.lazyrouter(), Array.isArray(name)) {
        for (var i = 0; i < name.length; i++)
          this.param(name[i], fn);
        return this;
      }
      return this._router.param(name, fn), this;
    };
    app.set = function(setting, val) {
      if (arguments.length === 1) {
        for (var settings = this.settings; settings && settings !== Object.prototype; ) {
          if (hasOwnProperty.call(settings, setting))
            return settings[setting];
          settings = Object.getPrototypeOf(settings);
        }
        return;
      }
      switch (debug4('set "%s" to %o', setting, val), this.settings[setting] = val, setting) {
        case "etag":
          this.set("etag fn", compileETag(val));
          break;
        case "query parser":
          this.set("query parser fn", compileQueryParser(val));
          break;
        case "trust proxy":
          this.set("trust proxy fn", compileTrust(val)), Object.defineProperty(this.settings, trustProxyDefaultSymbol, {
            configurable: !0,
            value: !1
          });
          break;
      }
      return this;
    };
    app.path = function() {
      return this.parent ? this.parent.path() + this.mountpath : "";
    };
    app.enabled = function(setting) {
      return !!this.set(setting);
    };
    app.disabled = function(setting) {
      return !this.set(setting);
    };
    app.enable = function(setting) {
      return this.set(setting, !0);
    };
    app.disable = function(setting) {
      return this.set(setting, !1);
    };
    methods.forEach(function(method) {
      app[method] = function(path3) {
        if (method === "get" && arguments.length === 1)
          return this.set(path3);
        this.lazyrouter();
        var route = this._router.route(path3);
        return route[method].apply(route, slice.call(arguments, 1)), this;
      };
    });
    app.all = function(path3) {
      this.lazyrouter();
      for (var route = this._router.route(path3), args = slice.call(arguments, 1), i = 0; i < methods.length; i++)
        route[methods[i]].apply(route, args);
      return this;
    };
    app.del = deprecate.function(app.delete, "app.del: Use app.delete instead");
    app.render = function(name, options, callback) {
      var cache2 = this.cache, done = callback, engines = this.engines, opts = options, renderOptions = {}, view;
      if (typeof options == "function" && (done = options, opts = {}), merge(renderOptions, this.locals), opts._locals && merge(renderOptions, opts._locals), merge(renderOptions, opts), renderOptions.cache == null && (renderOptions.cache = this.enabled("view cache")), renderOptions.cache && (view = cache2[name]), !view) {
        var View2 = this.get("view");
        if (view = new View2(name, {
          defaultEngine: this.get("view engine"),
          root: this.get("views"),
          engines
        }), !view.path) {
          var dirs = Array.isArray(view.root) && view.root.length > 1 ? 'directories "' + view.root.slice(0, -1).join('", "') + '" or "' + view.root[view.root.length - 1] + '"' : 'directory "' + view.root + '"', err2 = new Error('Failed to lookup view "' + name + '" in views ' + dirs);
          return err2.view = view, done(err2);
        }
        renderOptions.cache && (cache2[name] = view);
      }
      tryRender(view, renderOptions, done);
    };
    app.listen = function() {
      var server = http3.createServer(this);
      return server.listen.apply(server, arguments);
    };
    function logerror(err2) {
      this.get("env") !== "test" && console.error(err2.stack || err2.toString());
    }
    function tryRender(view, options, callback) {
      try {
        view.render(options, callback);
      } catch (err2) {
        callback(err2);
      }
    }
  }
});

// ../../node_modules/.pnpm/negotiator@0.6.3/node_modules/negotiator/lib/charset.js
var require_charset = __commonJS({
  "../../node_modules/.pnpm/negotiator@0.6.3/node_modules/negotiator/lib/charset.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = preferredCharsets;
    module.exports.preferredCharsets = preferredCharsets;
    var simpleCharsetRegExp = /^\s*([^\s;]+)\s*(?:;(.*))?$/;
    function parseAcceptCharset(accept) {
      for (var accepts = accept.split(","), i = 0, j = 0; i < accepts.length; i++) {
        var charset = parseCharset(accepts[i].trim(), i);
        charset && (accepts[j++] = charset);
      }
      return accepts.length = j, accepts;
    }
    function parseCharset(str, i) {
      var match2 = simpleCharsetRegExp.exec(str);
      if (!match2)
        return null;
      var charset = match2[1], q = 1;
      if (match2[2])
        for (var params = match2[2].split(";"), j = 0; j < params.length; j++) {
          var p = params[j].trim().split("=");
          if (p[0] === "q") {
            q = parseFloat(p[1]);
            break;
          }
        }
      return {
        charset,
        q,
        i
      };
    }
    function getCharsetPriority(charset, accepted, index) {
      for (var priority = { o: -1, q: 0, s: 0 }, i = 0; i < accepted.length; i++) {
        var spec3 = specify(charset, accepted[i], index);
        spec3 && (priority.s - spec3.s || priority.q - spec3.q || priority.o - spec3.o) < 0 && (priority = spec3);
      }
      return priority;
    }
    function specify(charset, spec3, index) {
      var s = 0;
      if (spec3.charset.toLowerCase() === charset.toLowerCase())
        s |= 1;
      else if (spec3.charset !== "*")
        return null;
      return {
        i: index,
        o: spec3.i,
        q: spec3.q,
        s
      };
    }
    function preferredCharsets(accept, provided) {
      var accepts = parseAcceptCharset(accept === void 0 ? "*" : accept || "");
      if (!provided)
        return accepts.filter(isQuality).sort(compareSpecs).map(getFullCharset);
      var priorities = provided.map(function(type, index) {
        return getCharsetPriority(type, accepts, index);
      });
      return priorities.filter(isQuality).sort(compareSpecs).map(function(priority) {
        return provided[priorities.indexOf(priority)];
      });
    }
    function compareSpecs(a, b) {
      return b.q - a.q || b.s - a.s || a.o - b.o || a.i - b.i || 0;
    }
    function getFullCharset(spec3) {
      return spec3.charset;
    }
    function isQuality(spec3) {
      return spec3.q > 0;
    }
  }
});

// ../../node_modules/.pnpm/negotiator@0.6.3/node_modules/negotiator/lib/encoding.js
var require_encoding = __commonJS({
  "../../node_modules/.pnpm/negotiator@0.6.3/node_modules/negotiator/lib/encoding.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = preferredEncodings;
    module.exports.preferredEncodings = preferredEncodings;
    var simpleEncodingRegExp = /^\s*([^\s;]+)\s*(?:;(.*))?$/;
    function parseAcceptEncoding(accept) {
      for (var accepts = accept.split(","), hasIdentity = !1, minQuality = 1, i = 0, j = 0; i < accepts.length; i++) {
        var encoding = parseEncoding(accepts[i].trim(), i);
        encoding && (accepts[j++] = encoding, hasIdentity = hasIdentity || specify("identity", encoding), minQuality = Math.min(minQuality, encoding.q || 1));
      }
      return hasIdentity || (accepts[j++] = {
        encoding: "identity",
        q: minQuality,
        i
      }), accepts.length = j, accepts;
    }
    function parseEncoding(str, i) {
      var match2 = simpleEncodingRegExp.exec(str);
      if (!match2)
        return null;
      var encoding = match2[1], q = 1;
      if (match2[2])
        for (var params = match2[2].split(";"), j = 0; j < params.length; j++) {
          var p = params[j].trim().split("=");
          if (p[0] === "q") {
            q = parseFloat(p[1]);
            break;
          }
        }
      return {
        encoding,
        q,
        i
      };
    }
    function getEncodingPriority(encoding, accepted, index) {
      for (var priority = { o: -1, q: 0, s: 0 }, i = 0; i < accepted.length; i++) {
        var spec3 = specify(encoding, accepted[i], index);
        spec3 && (priority.s - spec3.s || priority.q - spec3.q || priority.o - spec3.o) < 0 && (priority = spec3);
      }
      return priority;
    }
    function specify(encoding, spec3, index) {
      var s = 0;
      if (spec3.encoding.toLowerCase() === encoding.toLowerCase())
        s |= 1;
      else if (spec3.encoding !== "*")
        return null;
      return {
        i: index,
        o: spec3.i,
        q: spec3.q,
        s
      };
    }
    function preferredEncodings(accept, provided) {
      var accepts = parseAcceptEncoding(accept || "");
      if (!provided)
        return accepts.filter(isQuality).sort(compareSpecs).map(getFullEncoding);
      var priorities = provided.map(function(type, index) {
        return getEncodingPriority(type, accepts, index);
      });
      return priorities.filter(isQuality).sort(compareSpecs).map(function(priority) {
        return provided[priorities.indexOf(priority)];
      });
    }
    function compareSpecs(a, b) {
      return b.q - a.q || b.s - a.s || a.o - b.o || a.i - b.i || 0;
    }
    function getFullEncoding(spec3) {
      return spec3.encoding;
    }
    function isQuality(spec3) {
      return spec3.q > 0;
    }
  }
});

// ../../node_modules/.pnpm/negotiator@0.6.3/node_modules/negotiator/lib/language.js
var require_language = __commonJS({
  "../../node_modules/.pnpm/negotiator@0.6.3/node_modules/negotiator/lib/language.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = preferredLanguages;
    module.exports.preferredLanguages = preferredLanguages;
    var simpleLanguageRegExp = /^\s*([^\s\-;]+)(?:-([^\s;]+))?\s*(?:;(.*))?$/;
    function parseAcceptLanguage(accept) {
      for (var accepts = accept.split(","), i = 0, j = 0; i < accepts.length; i++) {
        var language = parseLanguage(accepts[i].trim(), i);
        language && (accepts[j++] = language);
      }
      return accepts.length = j, accepts;
    }
    function parseLanguage(str, i) {
      var match2 = simpleLanguageRegExp.exec(str);
      if (!match2)
        return null;
      var prefix = match2[1], suffix = match2[2], full = prefix;
      suffix && (full += "-" + suffix);
      var q = 1;
      if (match2[3])
        for (var params = match2[3].split(";"), j = 0; j < params.length; j++) {
          var p = params[j].split("=");
          p[0] === "q" && (q = parseFloat(p[1]));
        }
      return {
        prefix,
        suffix,
        q,
        i,
        full
      };
    }
    function getLanguagePriority(language, accepted, index) {
      for (var priority = { o: -1, q: 0, s: 0 }, i = 0; i < accepted.length; i++) {
        var spec3 = specify(language, accepted[i], index);
        spec3 && (priority.s - spec3.s || priority.q - spec3.q || priority.o - spec3.o) < 0 && (priority = spec3);
      }
      return priority;
    }
    function specify(language, spec3, index) {
      var p = parseLanguage(language);
      if (!p)
        return null;
      var s = 0;
      if (spec3.full.toLowerCase() === p.full.toLowerCase())
        s |= 4;
      else if (spec3.prefix.toLowerCase() === p.full.toLowerCase())
        s |= 2;
      else if (spec3.full.toLowerCase() === p.prefix.toLowerCase())
        s |= 1;
      else if (spec3.full !== "*")
        return null;
      return {
        i: index,
        o: spec3.i,
        q: spec3.q,
        s
      };
    }
    function preferredLanguages(accept, provided) {
      var accepts = parseAcceptLanguage(accept === void 0 ? "*" : accept || "");
      if (!provided)
        return accepts.filter(isQuality).sort(compareSpecs).map(getFullLanguage);
      var priorities = provided.map(function(type, index) {
        return getLanguagePriority(type, accepts, index);
      });
      return priorities.filter(isQuality).sort(compareSpecs).map(function(priority) {
        return provided[priorities.indexOf(priority)];
      });
    }
    function compareSpecs(a, b) {
      return b.q - a.q || b.s - a.s || a.o - b.o || a.i - b.i || 0;
    }
    function getFullLanguage(spec3) {
      return spec3.full;
    }
    function isQuality(spec3) {
      return spec3.q > 0;
    }
  }
});

// ../../node_modules/.pnpm/negotiator@0.6.3/node_modules/negotiator/lib/mediaType.js
var require_mediaType = __commonJS({
  "../../node_modules/.pnpm/negotiator@0.6.3/node_modules/negotiator/lib/mediaType.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = preferredMediaTypes;
    module.exports.preferredMediaTypes = preferredMediaTypes;
    var simpleMediaTypeRegExp = /^\s*([^\s\/;]+)\/([^;\s]+)\s*(?:;(.*))?$/;
    function parseAccept(accept) {
      for (var accepts = splitMediaTypes(accept), i = 0, j = 0; i < accepts.length; i++) {
        var mediaType = parseMediaType(accepts[i].trim(), i);
        mediaType && (accepts[j++] = mediaType);
      }
      return accepts.length = j, accepts;
    }
    function parseMediaType(str, i) {
      var match2 = simpleMediaTypeRegExp.exec(str);
      if (!match2)
        return null;
      var params = /* @__PURE__ */ Object.create(null), q = 1, subtype = match2[2], type = match2[1];
      if (match2[3])
        for (var kvps = splitParameters(match2[3]).map(splitKeyValuePair), j = 0; j < kvps.length; j++) {
          var pair = kvps[j], key = pair[0].toLowerCase(), val = pair[1], value = val && val[0] === '"' && val[val.length - 1] === '"' ? val.substr(1, val.length - 2) : val;
          if (key === "q") {
            q = parseFloat(value);
            break;
          }
          params[key] = value;
        }
      return {
        type,
        subtype,
        params,
        q,
        i
      };
    }
    function getMediaTypePriority(type, accepted, index) {
      for (var priority = { o: -1, q: 0, s: 0 }, i = 0; i < accepted.length; i++) {
        var spec3 = specify(type, accepted[i], index);
        spec3 && (priority.s - spec3.s || priority.q - spec3.q || priority.o - spec3.o) < 0 && (priority = spec3);
      }
      return priority;
    }
    function specify(type, spec3, index) {
      var p = parseMediaType(type), s = 0;
      if (!p)
        return null;
      if (spec3.type.toLowerCase() == p.type.toLowerCase())
        s |= 4;
      else if (spec3.type != "*")
        return null;
      if (spec3.subtype.toLowerCase() == p.subtype.toLowerCase())
        s |= 2;
      else if (spec3.subtype != "*")
        return null;
      var keys = Object.keys(spec3.params);
      if (keys.length > 0)
        if (keys.every(function(k) {
          return spec3.params[k] == "*" || (spec3.params[k] || "").toLowerCase() == (p.params[k] || "").toLowerCase();
        }))
          s |= 1;
        else
          return null;
      return {
        i: index,
        o: spec3.i,
        q: spec3.q,
        s
      };
    }
    function preferredMediaTypes(accept, provided) {
      var accepts = parseAccept(accept === void 0 ? "*/*" : accept || "");
      if (!provided)
        return accepts.filter(isQuality).sort(compareSpecs).map(getFullType);
      var priorities = provided.map(function(type, index) {
        return getMediaTypePriority(type, accepts, index);
      });
      return priorities.filter(isQuality).sort(compareSpecs).map(function(priority) {
        return provided[priorities.indexOf(priority)];
      });
    }
    function compareSpecs(a, b) {
      return b.q - a.q || b.s - a.s || a.o - b.o || a.i - b.i || 0;
    }
    function getFullType(spec3) {
      return spec3.type + "/" + spec3.subtype;
    }
    function isQuality(spec3) {
      return spec3.q > 0;
    }
    function quoteCount(string) {
      for (var count = 0, index = 0; (index = string.indexOf('"', index)) !== -1; )
        count++, index++;
      return count;
    }
    function splitKeyValuePair(str) {
      var index = str.indexOf("="), key, val;
      return index === -1 ? key = str : (key = str.substr(0, index), val = str.substr(index + 1)), [key, val];
    }
    function splitMediaTypes(accept) {
      for (var accepts = accept.split(","), i = 1, j = 0; i < accepts.length; i++)
        quoteCount(accepts[j]) % 2 == 0 ? accepts[++j] = accepts[i] : accepts[j] += "," + accepts[i];
      return accepts.length = j + 1, accepts;
    }
    function splitParameters(str) {
      for (var parameters = str.split(";"), i = 1, j = 0; i < parameters.length; i++)
        quoteCount(parameters[j]) % 2 == 0 ? parameters[++j] = parameters[i] : parameters[j] += ";" + parameters[i];
      parameters.length = j + 1;
      for (var i = 0; i < parameters.length; i++)
        parameters[i] = parameters[i].trim();
      return parameters;
    }
  }
});

// ../../node_modules/.pnpm/negotiator@0.6.3/node_modules/negotiator/index.js
var require_negotiator = __commonJS({
  "../../node_modules/.pnpm/negotiator@0.6.3/node_modules/negotiator/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var preferredCharsets = require_charset(), preferredEncodings = require_encoding(), preferredLanguages = require_language(), preferredMediaTypes = require_mediaType();
    module.exports = Negotiator;
    module.exports.Negotiator = Negotiator;
    function Negotiator(request2) {
      if (!(this instanceof Negotiator))
        return new Negotiator(request2);
      this.request = request2;
    }
    Negotiator.prototype.charset = function(available) {
      var set2 = this.charsets(available);
      return set2 && set2[0];
    };
    Negotiator.prototype.charsets = function(available) {
      return preferredCharsets(this.request.headers["accept-charset"], available);
    };
    Negotiator.prototype.encoding = function(available) {
      var set2 = this.encodings(available);
      return set2 && set2[0];
    };
    Negotiator.prototype.encodings = function(available) {
      return preferredEncodings(this.request.headers["accept-encoding"], available);
    };
    Negotiator.prototype.language = function(available) {
      var set2 = this.languages(available);
      return set2 && set2[0];
    };
    Negotiator.prototype.languages = function(available) {
      return preferredLanguages(this.request.headers["accept-language"], available);
    };
    Negotiator.prototype.mediaType = function(available) {
      var set2 = this.mediaTypes(available);
      return set2 && set2[0];
    };
    Negotiator.prototype.mediaTypes = function(available) {
      return preferredMediaTypes(this.request.headers.accept, available);
    };
    Negotiator.prototype.preferredCharset = Negotiator.prototype.charset;
    Negotiator.prototype.preferredCharsets = Negotiator.prototype.charsets;
    Negotiator.prototype.preferredEncoding = Negotiator.prototype.encoding;
    Negotiator.prototype.preferredEncodings = Negotiator.prototype.encodings;
    Negotiator.prototype.preferredLanguage = Negotiator.prototype.language;
    Negotiator.prototype.preferredLanguages = Negotiator.prototype.languages;
    Negotiator.prototype.preferredMediaType = Negotiator.prototype.mediaType;
    Negotiator.prototype.preferredMediaTypes = Negotiator.prototype.mediaTypes;
  }
});

// ../../node_modules/.pnpm/accepts@1.3.8/node_modules/accepts/index.js
var require_accepts = __commonJS({
  "../../node_modules/.pnpm/accepts@1.3.8/node_modules/accepts/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Negotiator = require_negotiator(), mime = require_mime_types();
    module.exports = Accepts;
    function Accepts(req) {
      if (!(this instanceof Accepts))
        return new Accepts(req);
      this.headers = req.headers, this.negotiator = new Negotiator(req);
    }
    Accepts.prototype.type = Accepts.prototype.types = function(types_) {
      var types = types_;
      if (types && !Array.isArray(types)) {
        types = new Array(arguments.length);
        for (var i = 0; i < types.length; i++)
          types[i] = arguments[i];
      }
      if (!types || types.length === 0)
        return this.negotiator.mediaTypes();
      if (!this.headers.accept)
        return types[0];
      var mimes2 = types.map(extToMime), accepts = this.negotiator.mediaTypes(mimes2.filter(validMime)), first = accepts[0];
      return first ? types[mimes2.indexOf(first)] : !1;
    };
    Accepts.prototype.encoding = Accepts.prototype.encodings = function(encodings_) {
      var encodings = encodings_;
      if (encodings && !Array.isArray(encodings)) {
        encodings = new Array(arguments.length);
        for (var i = 0; i < encodings.length; i++)
          encodings[i] = arguments[i];
      }
      return !encodings || encodings.length === 0 ? this.negotiator.encodings() : this.negotiator.encodings(encodings)[0] || !1;
    };
    Accepts.prototype.charset = Accepts.prototype.charsets = function(charsets_) {
      var charsets = charsets_;
      if (charsets && !Array.isArray(charsets)) {
        charsets = new Array(arguments.length);
        for (var i = 0; i < charsets.length; i++)
          charsets[i] = arguments[i];
      }
      return !charsets || charsets.length === 0 ? this.negotiator.charsets() : this.negotiator.charsets(charsets)[0] || !1;
    };
    Accepts.prototype.lang = Accepts.prototype.langs = Accepts.prototype.language = Accepts.prototype.languages = function(languages_) {
      var languages = languages_;
      if (languages && !Array.isArray(languages)) {
        languages = new Array(arguments.length);
        for (var i = 0; i < languages.length; i++)
          languages[i] = arguments[i];
      }
      return !languages || languages.length === 0 ? this.negotiator.languages() : this.negotiator.languages(languages)[0] || !1;
    };
    function extToMime(type) {
      return type.indexOf("/") === -1 ? mime.lookup(type) : type;
    }
    function validMime(type) {
      return typeof type == "string";
    }
  }
});

// ../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/request.js
var require_request = __commonJS({
  "../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/request.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var accepts = require_accepts(), deprecate = require_depd()("express"), isIP = __require("net").isIP, typeis = require_type_is(), http3 = __require("http"), fresh = require_fresh(), parseRange = require_range_parser(), parse4 = require_parseurl(), proxyaddr = require_proxy_addr(), req = Object.create(http3.IncomingMessage.prototype);
    module.exports = req;
    req.get = req.header = function(name) {
      if (!name)
        throw new TypeError("name argument is required to req.get");
      if (typeof name != "string")
        throw new TypeError("name must be a string to req.get");
      var lc = name.toLowerCase();
      switch (lc) {
        case "referer":
        case "referrer":
          return this.headers.referrer || this.headers.referer;
        default:
          return this.headers[lc];
      }
    };
    req.accepts = function() {
      var accept = accepts(this);
      return accept.types.apply(accept, arguments);
    };
    req.acceptsEncodings = function() {
      var accept = accepts(this);
      return accept.encodings.apply(accept, arguments);
    };
    req.acceptsEncoding = deprecate.function(
      req.acceptsEncodings,
      "req.acceptsEncoding: Use acceptsEncodings instead"
    );
    req.acceptsCharsets = function() {
      var accept = accepts(this);
      return accept.charsets.apply(accept, arguments);
    };
    req.acceptsCharset = deprecate.function(
      req.acceptsCharsets,
      "req.acceptsCharset: Use acceptsCharsets instead"
    );
    req.acceptsLanguages = function() {
      var accept = accepts(this);
      return accept.languages.apply(accept, arguments);
    };
    req.acceptsLanguage = deprecate.function(
      req.acceptsLanguages,
      "req.acceptsLanguage: Use acceptsLanguages instead"
    );
    req.range = function(size, options) {
      var range2 = this.get("Range");
      if (range2)
        return parseRange(size, range2, options);
    };
    req.param = function(name, defaultValue) {
      var params = this.params || {}, body = this.body || {}, query = this.query || {}, args = arguments.length === 1 ? "name" : "name, default";
      return deprecate("req.param(" + args + "): Use req.params, req.body, or req.query instead"), params[name] != null && params.hasOwnProperty(name) ? params[name] : body[name] != null ? body[name] : query[name] != null ? query[name] : defaultValue;
    };
    req.is = function(types) {
      var arr = types;
      if (!Array.isArray(types)) {
        arr = new Array(arguments.length);
        for (var i = 0; i < arr.length; i++)
          arr[i] = arguments[i];
      }
      return typeis(this, arr);
    };
    defineGetter(req, "protocol", function() {
      var proto = this.connection.encrypted ? "https" : "http", trust = this.app.get("trust proxy fn");
      if (!trust(this.connection.remoteAddress, 0))
        return proto;
      var header2 = this.get("X-Forwarded-Proto") || proto, index = header2.indexOf(",");
      return index !== -1 ? header2.substring(0, index).trim() : header2.trim();
    });
    defineGetter(req, "secure", function() {
      return this.protocol === "https";
    });
    defineGetter(req, "ip", function() {
      var trust = this.app.get("trust proxy fn");
      return proxyaddr(this, trust);
    });
    defineGetter(req, "ips", function() {
      var trust = this.app.get("trust proxy fn"), addrs = proxyaddr.all(this, trust);
      return addrs.reverse().pop(), addrs;
    });
    defineGetter(req, "subdomains", function() {
      var hostname2 = this.hostname;
      if (!hostname2)
        return [];
      var offset = this.app.get("subdomain offset"), subdomains2 = isIP(hostname2) ? [hostname2] : hostname2.split(".").reverse();
      return subdomains2.slice(offset);
    });
    defineGetter(req, "path", function() {
      return parse4(this).pathname;
    });
    defineGetter(req, "hostname", function() {
      var trust = this.app.get("trust proxy fn"), host = this.get("X-Forwarded-Host");
      if (!host || !trust(this.connection.remoteAddress, 0) ? host = this.get("Host") : host.indexOf(",") !== -1 && (host = host.substring(0, host.indexOf(",")).trimRight()), !!host) {
        var offset = host[0] === "[" ? host.indexOf("]") + 1 : 0, index = host.indexOf(":", offset);
        return index !== -1 ? host.substring(0, index) : host;
      }
    });
    defineGetter(req, "host", deprecate.function(function() {
      return this.hostname;
    }, "req.host: Use req.hostname instead"));
    defineGetter(req, "fresh", function() {
      var method = this.method, res = this.res, status = res.statusCode;
      return method !== "GET" && method !== "HEAD" ? !1 : status >= 200 && status < 300 || status === 304 ? fresh(this.headers, {
        etag: res.get("ETag"),
        "last-modified": res.get("Last-Modified")
      }) : !1;
    });
    defineGetter(req, "stale", function() {
      return !this.fresh;
    });
    defineGetter(req, "xhr", function() {
      var val = this.get("X-Requested-With") || "";
      return val.toLowerCase() === "xmlhttprequest";
    });
    function defineGetter(obj, name, getter) {
      Object.defineProperty(obj, name, {
        configurable: !0,
        enumerable: !0,
        get: getter
      });
    }
  }
});

// ../../node_modules/.pnpm/cookie-signature@1.0.6/node_modules/cookie-signature/index.js
var require_cookie_signature = __commonJS({
  "../../node_modules/.pnpm/cookie-signature@1.0.6/node_modules/cookie-signature/index.js"(exports) {
    init_cjs_shims();
    var crypto = __require("crypto");
    exports.sign = function(val, secret) {
      if (typeof val != "string")
        throw new TypeError("Cookie value must be provided as a string.");
      if (typeof secret != "string")
        throw new TypeError("Secret string must be provided.");
      return val + "." + crypto.createHmac("sha256", secret).update(val).digest("base64").replace(/\=+$/, "");
    };
    exports.unsign = function(val, secret) {
      if (typeof val != "string")
        throw new TypeError("Signed cookie string must be provided.");
      if (typeof secret != "string")
        throw new TypeError("Secret string must be provided.");
      var str = val.slice(0, val.lastIndexOf(".")), mac = exports.sign(str, secret);
      return sha1(mac) == sha1(val) ? str : !1;
    };
    function sha1(str) {
      return crypto.createHash("sha1").update(str).digest("hex");
    }
  }
});

// ../../node_modules/.pnpm/cookie@0.6.0/node_modules/cookie/index.js
var require_cookie = __commonJS({
  "../../node_modules/.pnpm/cookie@0.6.0/node_modules/cookie/index.js"(exports) {
    "use strict";
    init_cjs_shims();
    exports.parse = parse4;
    exports.serialize = serialize;
    var __toString = Object.prototype.toString, fieldContentRegExp = /^[\u0009\u0020-\u007e\u0080-\u00ff]+$/;
    function parse4(str, options) {
      if (typeof str != "string")
        throw new TypeError("argument str must be a string");
      for (var obj = {}, opt = options || {}, dec = opt.decode || decode, index = 0; index < str.length; ) {
        var eqIdx = str.indexOf("=", index);
        if (eqIdx === -1)
          break;
        var endIdx = str.indexOf(";", index);
        if (endIdx === -1)
          endIdx = str.length;
        else if (endIdx < eqIdx) {
          index = str.lastIndexOf(";", eqIdx - 1) + 1;
          continue;
        }
        var key = str.slice(index, eqIdx).trim();
        if (obj[key] === void 0) {
          var val = str.slice(eqIdx + 1, endIdx).trim();
          val.charCodeAt(0) === 34 && (val = val.slice(1, -1)), obj[key] = tryDecode(val, dec);
        }
        index = endIdx + 1;
      }
      return obj;
    }
    function serialize(name, val, options) {
      var opt = options || {}, enc = opt.encode || encode;
      if (typeof enc != "function")
        throw new TypeError("option encode is invalid");
      if (!fieldContentRegExp.test(name))
        throw new TypeError("argument name is invalid");
      var value = enc(val);
      if (value && !fieldContentRegExp.test(value))
        throw new TypeError("argument val is invalid");
      var str = name + "=" + value;
      if (opt.maxAge != null) {
        var maxAge = opt.maxAge - 0;
        if (isNaN(maxAge) || !isFinite(maxAge))
          throw new TypeError("option maxAge is invalid");
        str += "; Max-Age=" + Math.floor(maxAge);
      }
      if (opt.domain) {
        if (!fieldContentRegExp.test(opt.domain))
          throw new TypeError("option domain is invalid");
        str += "; Domain=" + opt.domain;
      }
      if (opt.path) {
        if (!fieldContentRegExp.test(opt.path))
          throw new TypeError("option path is invalid");
        str += "; Path=" + opt.path;
      }
      if (opt.expires) {
        var expires = opt.expires;
        if (!isDate(expires) || isNaN(expires.valueOf()))
          throw new TypeError("option expires is invalid");
        str += "; Expires=" + expires.toUTCString();
      }
      if (opt.httpOnly && (str += "; HttpOnly"), opt.secure && (str += "; Secure"), opt.partitioned && (str += "; Partitioned"), opt.priority) {
        var priority = typeof opt.priority == "string" ? opt.priority.toLowerCase() : opt.priority;
        switch (priority) {
          case "low":
            str += "; Priority=Low";
            break;
          case "medium":
            str += "; Priority=Medium";
            break;
          case "high":
            str += "; Priority=High";
            break;
          default:
            throw new TypeError("option priority is invalid");
        }
      }
      if (opt.sameSite) {
        var sameSite = typeof opt.sameSite == "string" ? opt.sameSite.toLowerCase() : opt.sameSite;
        switch (sameSite) {
          case !0:
            str += "; SameSite=Strict";
            break;
          case "lax":
            str += "; SameSite=Lax";
            break;
          case "strict":
            str += "; SameSite=Strict";
            break;
          case "none":
            str += "; SameSite=None";
            break;
          default:
            throw new TypeError("option sameSite is invalid");
        }
      }
      return str;
    }
    function decode(str) {
      return str.indexOf("%") !== -1 ? decodeURIComponent(str) : str;
    }
    function encode(val) {
      return encodeURIComponent(val);
    }
    function isDate(val) {
      return __toString.call(val) === "[object Date]" || val instanceof Date;
    }
    function tryDecode(str, decode2) {
      try {
        return decode2(str);
      } catch {
        return str;
      }
    }
  }
});

// ../../node_modules/.pnpm/vary@1.1.2/node_modules/vary/index.js
var require_vary = __commonJS({
  "../../node_modules/.pnpm/vary@1.1.2/node_modules/vary/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = vary;
    module.exports.append = append;
    var FIELD_NAME_REGEXP = /^[!#$%&'*+\-.^_`|~0-9A-Za-z]+$/;
    function append(header2, field) {
      if (typeof header2 != "string")
        throw new TypeError("header argument is required");
      if (!field)
        throw new TypeError("field argument is required");
      for (var fields = Array.isArray(field) ? field : parse4(String(field)), j = 0; j < fields.length; j++)
        if (!FIELD_NAME_REGEXP.test(fields[j]))
          throw new TypeError("field argument contains an invalid header name");
      if (header2 === "*")
        return header2;
      var val = header2, vals = parse4(header2.toLowerCase());
      if (fields.indexOf("*") !== -1 || vals.indexOf("*") !== -1)
        return "*";
      for (var i = 0; i < fields.length; i++) {
        var fld = fields[i].toLowerCase();
        vals.indexOf(fld) === -1 && (vals.push(fld), val = val ? val + ", " + fields[i] : fields[i]);
      }
      return val;
    }
    function parse4(header2) {
      for (var end = 0, list2 = [], start = 0, i = 0, len = header2.length; i < len; i++)
        switch (header2.charCodeAt(i)) {
          case 32:
            start === end && (start = end = i + 1);
            break;
          case 44:
            list2.push(header2.substring(start, end)), start = end = i + 1;
            break;
          default:
            end = i + 1;
            break;
        }
      return list2.push(header2.substring(start, end)), list2;
    }
    function vary(res, field) {
      if (!res || !res.getHeader || !res.setHeader)
        throw new TypeError("res argument is required");
      var val = res.getHeader("Vary") || "", header2 = Array.isArray(val) ? val.join(", ") : String(val);
      (val = append(header2, field)) && res.setHeader("Vary", val);
    }
  }
});

// ../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/response.js
var require_response = __commonJS({
  "../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/response.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var Buffer2 = require_safe_buffer2().Buffer, contentDisposition = require_content_disposition(), createError2 = require_http_errors(), deprecate = require_depd()("express"), encodeUrl = require_encodeurl(), escapeHtml = require_escape_html(), http3 = __require("http"), isAbsolute = require_utils15().isAbsolute, onFinished = require_on_finished(), path3 = __require("path"), statuses = require_statuses(), merge = require_utils_merge(), sign = require_cookie_signature().sign, normalizeType = require_utils15().normalizeType, normalizeTypes = require_utils15().normalizeTypes, setCharset = require_utils15().setCharset, cookie = require_cookie(), send2 = require_send(), extname2 = path3.extname, mime = send2.mime, resolve2 = path3.resolve, vary = require_vary(), res = Object.create(http3.ServerResponse.prototype);
    module.exports = res;
    var charsetRegExp = /;\s*charset\s*=/, schemaAndHostRegExp = /^(?:[a-zA-Z][a-zA-Z0-9+.-]*:)?\/\/[^\\\/\?]+/;
    res.status = function(code) {
      return (typeof code == "string" || Math.floor(code) !== code) && code > 99 && code < 1e3 && deprecate("res.status(" + JSON.stringify(code) + "): use res.status(" + Math.floor(code) + ") instead"), this.statusCode = code, this;
    };
    res.links = function(links) {
      var link2 = this.get("Link") || "";
      return link2 && (link2 += ", "), this.set("Link", link2 + Object.keys(links).map(function(rel) {
        return "<" + links[rel] + '>; rel="' + rel + '"';
      }).join(", "));
    };
    res.send = function(body) {
      var chunk = body, encoding, req = this.req, type, app = this.app;
      switch (arguments.length === 2 && (typeof arguments[0] != "number" && typeof arguments[1] == "number" ? (deprecate("res.send(body, status): Use res.status(status).send(body) instead"), this.statusCode = arguments[1]) : (deprecate("res.send(status, body): Use res.status(status).send(body) instead"), this.statusCode = arguments[0], chunk = arguments[1])), typeof chunk == "number" && arguments.length === 1 && (this.get("Content-Type") || this.type("txt"), deprecate("res.send(status): Use res.sendStatus(status) instead"), this.statusCode = chunk, chunk = statuses.message[chunk]), typeof chunk) {
        case "string":
          this.get("Content-Type") || this.type("html");
          break;
        case "boolean":
        case "number":
        case "object":
          if (chunk === null)
            chunk = "";
          else if (Buffer2.isBuffer(chunk))
            this.get("Content-Type") || this.type("bin");
          else
            return this.json(chunk);
          break;
      }
      typeof chunk == "string" && (encoding = "utf8", type = this.get("Content-Type"), typeof type == "string" && this.set("Content-Type", setCharset(type, "utf-8")));
      var etagFn = app.get("etag fn"), generateETag = !this.get("ETag") && typeof etagFn == "function", len;
      chunk !== void 0 && (Buffer2.isBuffer(chunk) ? len = chunk.length : !generateETag && chunk.length < 1e3 ? len = Buffer2.byteLength(chunk, encoding) : (chunk = Buffer2.from(chunk, encoding), encoding = void 0, len = chunk.length), this.set("Content-Length", len));
      var etag;
      return generateETag && len !== void 0 && (etag = etagFn(chunk, encoding)) && this.set("ETag", etag), req.fresh && (this.statusCode = 304), (this.statusCode === 204 || this.statusCode === 304) && (this.removeHeader("Content-Type"), this.removeHeader("Content-Length"), this.removeHeader("Transfer-Encoding"), chunk = ""), this.statusCode === 205 && (this.set("Content-Length", "0"), this.removeHeader("Transfer-Encoding"), chunk = ""), req.method === "HEAD" ? this.end() : this.end(chunk, encoding), this;
    };
    res.json = function(obj) {
      var val = obj;
      arguments.length === 2 && (typeof arguments[1] == "number" ? (deprecate("res.json(obj, status): Use res.status(status).json(obj) instead"), this.statusCode = arguments[1]) : (deprecate("res.json(status, obj): Use res.status(status).json(obj) instead"), this.statusCode = arguments[0], val = arguments[1]));
      var app = this.app, escape2 = app.get("json escape"), replacer = app.get("json replacer"), spaces = app.get("json spaces"), body = stringify(val, replacer, spaces, escape2);
      return this.get("Content-Type") || this.set("Content-Type", "application/json"), this.send(body);
    };
    res.jsonp = function(obj) {
      var val = obj;
      arguments.length === 2 && (typeof arguments[1] == "number" ? (deprecate("res.jsonp(obj, status): Use res.status(status).jsonp(obj) instead"), this.statusCode = arguments[1]) : (deprecate("res.jsonp(status, obj): Use res.status(status).jsonp(obj) instead"), this.statusCode = arguments[0], val = arguments[1]));
      var app = this.app, escape2 = app.get("json escape"), replacer = app.get("json replacer"), spaces = app.get("json spaces"), body = stringify(val, replacer, spaces, escape2), callback = this.req.query[app.get("jsonp callback name")];
      return this.get("Content-Type") || (this.set("X-Content-Type-Options", "nosniff"), this.set("Content-Type", "application/json")), Array.isArray(callback) && (callback = callback[0]), typeof callback == "string" && callback.length !== 0 && (this.set("X-Content-Type-Options", "nosniff"), this.set("Content-Type", "text/javascript"), callback = callback.replace(/[^\[\]\w$.]/g, ""), body === void 0 ? body = "" : typeof body == "string" && (body = body.replace(/\u2028/g, "\\u2028").replace(/\u2029/g, "\\u2029")), body = "/**/ typeof " + callback + " === 'function' && " + callback + "(" + body + ");"), this.send(body);
    };
    res.sendStatus = function(statusCode) {
      var body = statuses.message[statusCode] || String(statusCode);
      return this.statusCode = statusCode, this.type("txt"), this.send(body);
    };
    res.sendFile = function(path4, options, callback) {
      var done = callback, req = this.req, res2 = this, next = req.next, opts = options || {};
      if (!path4)
        throw new TypeError("path argument is required to res.sendFile");
      if (typeof path4 != "string")
        throw new TypeError("path must be a string to res.sendFile");
      if (typeof options == "function" && (done = options, opts = {}), !opts.root && !isAbsolute(path4))
        throw new TypeError("path must be absolute or specify root to res.sendFile");
      var pathname = encodeURI(path4), file = send2(req, pathname, opts);
      sendfile(res2, file, opts, function(err2) {
        if (done)
          return done(err2);
        if (err2 && err2.code === "EISDIR")
          return next();
        err2 && err2.code !== "ECONNABORTED" && err2.syscall !== "write" && next(err2);
      });
    };
    res.sendfile = function(path4, options, callback) {
      var done = callback, req = this.req, res2 = this, next = req.next, opts = options || {};
      typeof options == "function" && (done = options, opts = {});
      var file = send2(req, path4, opts);
      sendfile(res2, file, opts, function(err2) {
        if (done)
          return done(err2);
        if (err2 && err2.code === "EISDIR")
          return next();
        err2 && err2.code !== "ECONNABORTED" && err2.syscall !== "write" && next(err2);
      });
    };
    res.sendfile = deprecate.function(
      res.sendfile,
      "res.sendfile: Use res.sendFile instead"
    );
    res.download = function(path4, filename, options, callback) {
      var done = callback, name = filename, opts = options || null;
      typeof filename == "function" ? (done = filename, name = null, opts = null) : typeof options == "function" && (done = options, opts = null), typeof filename == "object" && (typeof options == "function" || options === void 0) && (name = null, opts = filename);
      var headers = {
        "Content-Disposition": contentDisposition(name || path4)
      };
      if (opts && opts.headers)
        for (var keys = Object.keys(opts.headers), i = 0; i < keys.length; i++) {
          var key = keys[i];
          key.toLowerCase() !== "content-disposition" && (headers[key] = opts.headers[key]);
        }
      opts = Object.create(opts), opts.headers = headers;
      var fullPath = opts.root ? path4 : resolve2(path4);
      return this.sendFile(fullPath, opts, done);
    };
    res.contentType = res.type = function(type) {
      var ct = type.indexOf("/") === -1 ? mime.lookup(type) : type;
      return this.set("Content-Type", ct);
    };
    res.format = function(obj) {
      var req = this.req, next = req.next, keys = Object.keys(obj).filter(function(v) {
        return v !== "default";
      }), key = keys.length > 0 ? req.accepts(keys) : !1;
      return this.vary("Accept"), key ? (this.set("Content-Type", normalizeType(key).value), obj[key](req, this, next)) : obj.default ? obj.default(req, this, next) : next(createError2(406, {
        types: normalizeTypes(keys).map(function(o) {
          return o.value;
        })
      })), this;
    };
    res.attachment = function(filename) {
      return filename && this.type(extname2(filename)), this.set("Content-Disposition", contentDisposition(filename)), this;
    };
    res.append = function(field, val) {
      var prev = this.get(field), value = val;
      return prev && (value = Array.isArray(prev) ? prev.concat(val) : Array.isArray(val) ? [prev].concat(val) : [prev, val]), this.set(field, value);
    };
    res.set = res.header = function(field, val) {
      if (arguments.length === 2) {
        var value = Array.isArray(val) ? val.map(String) : String(val);
        if (field.toLowerCase() === "content-type") {
          if (Array.isArray(value))
            throw new TypeError("Content-Type cannot be set to an Array");
          if (!charsetRegExp.test(value)) {
            var charset = mime.charsets.lookup(value.split(";")[0]);
            charset && (value += "; charset=" + charset.toLowerCase());
          }
        }
        this.setHeader(field, value);
      } else
        for (var key in field)
          this.set(key, field[key]);
      return this;
    };
    res.get = function(field) {
      return this.getHeader(field);
    };
    res.clearCookie = function(name, options) {
      var opts = merge({ expires: /* @__PURE__ */ new Date(1), path: "/" }, options);
      return this.cookie(name, "", opts);
    };
    res.cookie = function(name, value, options) {
      var opts = merge({}, options), secret = this.req.secret, signed = opts.signed;
      if (signed && !secret)
        throw new Error('cookieParser("secret") required for signed cookies');
      var val = typeof value == "object" ? "j:" + JSON.stringify(value) : String(value);
      if (signed && (val = "s:" + sign(val, secret)), opts.maxAge != null) {
        var maxAge = opts.maxAge - 0;
        isNaN(maxAge) || (opts.expires = new Date(Date.now() + maxAge), opts.maxAge = Math.floor(maxAge / 1e3));
      }
      return opts.path == null && (opts.path = "/"), this.append("Set-Cookie", cookie.serialize(name, String(val), opts)), this;
    };
    res.location = function(url) {
      var loc;
      url === "back" ? loc = this.req.get("Referrer") || "/" : loc = String(url);
      var m = schemaAndHostRegExp.exec(loc), pos = m ? m[0].length + 1 : 0;
      return loc = loc.slice(0, pos) + encodeUrl(loc.slice(pos)), this.set("Location", loc);
    };
    res.redirect = function(url) {
      var address = url, body, status = 302;
      arguments.length === 2 && (typeof arguments[0] == "number" ? (status = arguments[0], address = arguments[1]) : (deprecate("res.redirect(url, status): Use res.redirect(status, url) instead"), status = arguments[1])), address = this.location(address).get("Location"), this.format({
        text: function() {
          body = statuses.message[status] + ". Redirecting to " + address;
        },
        html: function() {
          var u = escapeHtml(address);
          body = "<p>" + statuses.message[status] + '. Redirecting to <a href="' + u + '">' + u + "</a></p>";
        },
        default: function() {
          body = "";
        }
      }), this.statusCode = status, this.set("Content-Length", Buffer2.byteLength(body)), this.req.method === "HEAD" ? this.end() : this.end(body);
    };
    res.vary = function(field) {
      return !field || Array.isArray(field) && !field.length ? (deprecate("res.vary(): Provide a field name"), this) : (vary(this, field), this);
    };
    res.render = function(view, options, callback) {
      var app = this.req.app, done = callback, opts = options || {}, req = this.req, self2 = this;
      typeof options == "function" && (done = options, opts = {}), opts._locals = self2.locals, done = done || function(err2, str) {
        if (err2)
          return req.next(err2);
        self2.send(str);
      }, app.render(view, opts, done);
    };
    function sendfile(res2, file, options, callback) {
      var done = !1, streaming;
      function onaborted() {
        if (!done) {
          done = !0;
          var err2 = new Error("Request aborted");
          err2.code = "ECONNABORTED", callback(err2);
        }
      }
      function ondirectory() {
        if (!done) {
          done = !0;
          var err2 = new Error("EISDIR, read");
          err2.code = "EISDIR", callback(err2);
        }
      }
      function onerror(err2) {
        done || (done = !0, callback(err2));
      }
      function onend() {
        done || (done = !0, callback());
      }
      function onfile() {
        streaming = !1;
      }
      function onfinish(err2) {
        if (err2 && err2.code === "ECONNRESET")
          return onaborted();
        if (err2)
          return onerror(err2);
        done || setImmediate(function() {
          if (streaming !== !1 && !done) {
            onaborted();
            return;
          }
          done || (done = !0, callback());
        });
      }
      function onstream() {
        streaming = !0;
      }
      file.on("directory", ondirectory), file.on("end", onend), file.on("error", onerror), file.on("file", onfile), file.on("stream", onstream), onFinished(res2, onfinish), options.headers && file.on("headers", function(res3) {
        for (var obj = options.headers, keys = Object.keys(obj), i = 0; i < keys.length; i++) {
          var k = keys[i];
          res3.setHeader(k, obj[k]);
        }
      }), file.pipe(res2);
    }
    function stringify(value, replacer, spaces, escape2) {
      var json = replacer || spaces ? JSON.stringify(value, replacer, spaces) : JSON.stringify(value);
      return escape2 && typeof json == "string" && (json = json.replace(/[<>&]/g, function(c) {
        switch (c.charCodeAt(0)) {
          case 60:
            return "\\u003c";
          case 62:
            return "\\u003e";
          case 38:
            return "\\u0026";
          default:
            return c;
        }
      })), json;
    }
  }
});

// ../../node_modules/.pnpm/serve-static@1.15.0/node_modules/serve-static/index.js
var require_serve_static = __commonJS({
  "../../node_modules/.pnpm/serve-static@1.15.0/node_modules/serve-static/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var encodeUrl = require_encodeurl(), escapeHtml = require_escape_html(), parseUrl = require_parseurl(), resolve2 = __require("path").resolve, send2 = require_send(), url = __require("url");
    module.exports = serveStatic;
    module.exports.mime = send2.mime;
    function serveStatic(root, options) {
      if (!root)
        throw new TypeError("root path required");
      if (typeof root != "string")
        throw new TypeError("root path must be a string");
      var opts = Object.create(options || null), fallthrough = opts.fallthrough !== !1, redirect = opts.redirect !== !1, setHeaders = opts.setHeaders;
      if (setHeaders && typeof setHeaders != "function")
        throw new TypeError("option setHeaders must be function");
      opts.maxage = opts.maxage || opts.maxAge || 0, opts.root = resolve2(root);
      var onDirectory = redirect ? createRedirectDirectoryListener() : createNotFoundDirectoryListener();
      return function(req, res, next) {
        if (req.method !== "GET" && req.method !== "HEAD") {
          if (fallthrough)
            return next();
          res.statusCode = 405, res.setHeader("Allow", "GET, HEAD"), res.setHeader("Content-Length", "0"), res.end();
          return;
        }
        var forwardError = !fallthrough, originalUrl = parseUrl.original(req), path3 = parseUrl(req).pathname;
        path3 === "/" && originalUrl.pathname.substr(-1) !== "/" && (path3 = "");
        var stream2 = send2(req, path3, opts);
        stream2.on("directory", onDirectory), setHeaders && stream2.on("headers", setHeaders), fallthrough && stream2.on("file", function() {
          forwardError = !0;
        }), stream2.on("error", function(err2) {
          if (forwardError || !(err2.statusCode < 500)) {
            next(err2);
            return;
          }
          next();
        }), stream2.pipe(res);
      };
    }
    function collapseLeadingSlashes(str) {
      for (var i = 0; i < str.length && str.charCodeAt(i) === 47; i++)
        ;
      return i > 1 ? "/" + str.substr(i) : str;
    }
    function createHtmlDocument(title, body) {
      return `<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<title>` + title + `</title>
</head>
<body>
<pre>` + body + `</pre>
</body>
</html>
`;
    }
    function createNotFoundDirectoryListener() {
      return function() {
        this.error(404);
      };
    }
    function createRedirectDirectoryListener() {
      return function(res) {
        if (this.hasTrailingSlash()) {
          this.error(404);
          return;
        }
        var originalUrl = parseUrl.original(this.req);
        originalUrl.path = null, originalUrl.pathname = collapseLeadingSlashes(originalUrl.pathname + "/");
        var loc = encodeUrl(url.format(originalUrl)), doc = createHtmlDocument("Redirecting", 'Redirecting to <a href="' + escapeHtml(loc) + '">' + escapeHtml(loc) + "</a>");
        res.statusCode = 301, res.setHeader("Content-Type", "text/html; charset=UTF-8"), res.setHeader("Content-Length", Buffer.byteLength(doc)), res.setHeader("Content-Security-Policy", "default-src 'none'"), res.setHeader("X-Content-Type-Options", "nosniff"), res.setHeader("Location", loc), res.end(doc);
      };
    }
  }
});

// ../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/express.js
var require_express = __commonJS({
  "../../node_modules/.pnpm/express@4.19.2/node_modules/express/lib/express.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    var bodyParser2 = require_body_parser(), EventEmitter3 = __require("events").EventEmitter, mixin = require_merge_descriptors(), proto = require_application(), Route = require_route(), Router = require_router(), req = require_request(), res = require_response();
    exports = module.exports = createApplication;
    function createApplication() {
      var app = function(req2, res2, next) {
        app.handle(req2, res2, next);
      };
      return mixin(app, EventEmitter3.prototype, !1), mixin(app, proto, !1), app.request = Object.create(req, {
        app: { configurable: !0, enumerable: !0, writable: !0, value: app }
      }), app.response = Object.create(res, {
        app: { configurable: !0, enumerable: !0, writable: !0, value: app }
      }), app.init(), app;
    }
    exports.application = proto;
    exports.request = req;
    exports.response = res;
    exports.Route = Route;
    exports.Router = Router;
    exports.json = bodyParser2.json;
    exports.query = require_query();
    exports.raw = bodyParser2.raw;
    exports.static = require_serve_static();
    exports.text = bodyParser2.text;
    exports.urlencoded = bodyParser2.urlencoded;
    var removedMiddlewares = [
      "bodyParser",
      "compress",
      "cookieSession",
      "session",
      "logger",
      "cookieParser",
      "favicon",
      "responseTime",
      "errorHandler",
      "timeout",
      "methodOverride",
      "vhost",
      "csrf",
      "directory",
      "limit",
      "multipart",
      "staticCache"
    ];
    removedMiddlewares.forEach(function(name) {
      Object.defineProperty(exports, name, {
        get: function() {
          throw new Error("Most middleware (like " + name + ") is no longer bundled with Express and must be installed separately. Please see https://github.com/senchalabs/connect#middleware.");
        },
        configurable: !0
      });
    });
  }
});

// ../../node_modules/.pnpm/express@4.19.2/node_modules/express/index.js
var require_express2 = __commonJS({
  "../../node_modules/.pnpm/express@4.19.2/node_modules/express/index.js"(exports, module) {
    "use strict";
    init_cjs_shims();
    module.exports = require_express();
  }
});

// ../../node_modules/.pnpm/lodash.pickby@4.6.0/node_modules/lodash.pickby/index.js
var require_lodash6 = __commonJS({
  "../../node_modules/.pnpm/lodash.pickby@4.6.0/node_modules/lodash.pickby/index.js"(exports, module) {
    init_cjs_shims();
    var LARGE_ARRAY_SIZE = 200, FUNC_ERROR_TEXT = "Expected a function", HASH_UNDEFINED = "__lodash_hash_undefined__", UNORDERED_COMPARE_FLAG = 1, PARTIAL_COMPARE_FLAG = 2, INFINITY = 1 / 0, MAX_SAFE_INTEGER = 9007199254740991, argsTag = "[object Arguments]", arrayTag = "[object Array]", boolTag = "[object Boolean]", dateTag = "[object Date]", errorTag = "[object Error]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", mapTag = "[object Map]", numberTag = "[object Number]", objectTag = "[object Object]", promiseTag = "[object Promise]", regexpTag = "[object RegExp]", setTag = "[object Set]", stringTag = "[object String]", symbolTag = "[object Symbol]", weakMapTag = "[object WeakMap]", arrayBufferTag = "[object ArrayBuffer]", dataViewTag = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]", reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/, reLeadingDot = /^\./, rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, reRegExpChar = /[\\^$.*+?()[\]{}|]/g, reEscapeChar = /\\(\\)?/g, reIsHostCtor = /^\[object .+?Constructor\]$/, reIsUint = /^(?:0|[1-9]\d*)$/, typedArrayTags = {};
    typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = !0;
    typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = !1;
    var freeGlobal = typeof global == "object" && global && global.Object === Object && global, freeSelf = typeof self == "object" && self && self.Object === Object && self, root = freeGlobal || freeSelf || Function("return this")(), freeExports = typeof exports == "object" && exports && !exports.nodeType && exports, freeModule = freeExports && typeof module == "object" && module && !module.nodeType && module, moduleExports = freeModule && freeModule.exports === freeExports, freeProcess = moduleExports && freeGlobal.process, nodeUtil = function() {
      try {
        return freeProcess && freeProcess.binding("util");
      } catch {
      }
    }(), nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
    function arrayPush(array, values) {
      for (var index = -1, length = values.length, offset = array.length; ++index < length; )
        array[offset + index] = values[index];
      return array;
    }
    function arraySome(array, predicate) {
      for (var index = -1, length = array ? array.length : 0; ++index < length; )
        if (predicate(array[index], index, array))
          return !0;
      return !1;
    }
    function baseProperty(key) {
      return function(object) {
        return object?.[key];
      };
    }
    function baseTimes(n, iteratee) {
      for (var index = -1, result = Array(n); ++index < n; )
        result[index] = iteratee(index);
      return result;
    }
    function baseUnary(func) {
      return function(value) {
        return func(value);
      };
    }
    function getValue(object, key) {
      return object?.[key];
    }
    function isHostObject(value) {
      var result = !1;
      if (value != null && typeof value.toString != "function")
        try {
          result = !!(value + "");
        } catch {
        }
      return result;
    }
    function mapToArray(map) {
      var index = -1, result = Array(map.size);
      return map.forEach(function(value, key) {
        result[++index] = [key, value];
      }), result;
    }
    function overArg(func, transform2) {
      return function(arg) {
        return func(transform2(arg));
      };
    }
    function setToArray(set2) {
      var index = -1, result = Array(set2.size);
      return set2.forEach(function(value) {
        result[++index] = value;
      }), result;
    }
    var arrayProto = Array.prototype, funcProto = Function.prototype, objectProto = Object.prototype, coreJsData = root["__core-js_shared__"], maskSrcKey = function() {
      var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
      return uid ? "Symbol(src)_1." + uid : "";
    }(), funcToString = funcProto.toString, hasOwnProperty = objectProto.hasOwnProperty, objectToString = objectProto.toString, reIsNative = RegExp(
      "^" + funcToString.call(hasOwnProperty).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
    ), Symbol2 = root.Symbol, Uint8Array2 = root.Uint8Array, getPrototype = overArg(Object.getPrototypeOf, Object), propertyIsEnumerable = objectProto.propertyIsEnumerable, splice = arrayProto.splice, nativeGetSymbols = Object.getOwnPropertySymbols, nativeKeys = overArg(Object.keys, Object), DataView2 = getNative(root, "DataView"), Map2 = getNative(root, "Map"), Promise2 = getNative(root, "Promise"), Set2 = getNative(root, "Set"), WeakMap2 = getNative(root, "WeakMap"), nativeCreate = getNative(Object, "create"), dataViewCtorString = toSource(DataView2), mapCtorString = toSource(Map2), promiseCtorString = toSource(Promise2), setCtorString = toSource(Set2), weakMapCtorString = toSource(WeakMap2), symbolProto = Symbol2 ? Symbol2.prototype : void 0, symbolValueOf = symbolProto ? symbolProto.valueOf : void 0, symbolToString = symbolProto ? symbolProto.toString : void 0;
    function Hash(entries) {
      var index = -1, length = entries ? entries.length : 0;
      for (this.clear(); ++index < length; ) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function hashClear() {
      this.__data__ = nativeCreate ? nativeCreate(null) : {};
    }
    function hashDelete(key) {
      return this.has(key) && delete this.__data__[key];
    }
    function hashGet(key) {
      var data = this.__data__;
      if (nativeCreate) {
        var result = data[key];
        return result === HASH_UNDEFINED ? void 0 : result;
      }
      return hasOwnProperty.call(data, key) ? data[key] : void 0;
    }
    function hashHas(key) {
      var data = this.__data__;
      return nativeCreate ? data[key] !== void 0 : hasOwnProperty.call(data, key);
    }
    function hashSet(key, value) {
      var data = this.__data__;
      return data[key] = nativeCreate && value === void 0 ? HASH_UNDEFINED : value, this;
    }
    Hash.prototype.clear = hashClear;
    Hash.prototype.delete = hashDelete;
    Hash.prototype.get = hashGet;
    Hash.prototype.has = hashHas;
    Hash.prototype.set = hashSet;
    function ListCache(entries) {
      var index = -1, length = entries ? entries.length : 0;
      for (this.clear(); ++index < length; ) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function listCacheClear() {
      this.__data__ = [];
    }
    function listCacheDelete(key) {
      var data = this.__data__, index = assocIndexOf(data, key);
      if (index < 0)
        return !1;
      var lastIndex = data.length - 1;
      return index == lastIndex ? data.pop() : splice.call(data, index, 1), !0;
    }
    function listCacheGet(key) {
      var data = this.__data__, index = assocIndexOf(data, key);
      return index < 0 ? void 0 : data[index][1];
    }
    function listCacheHas(key) {
      return assocIndexOf(this.__data__, key) > -1;
    }
    function listCacheSet(key, value) {
      var data = this.__data__, index = assocIndexOf(data, key);
      return index < 0 ? data.push([key, value]) : data[index][1] = value, this;
    }
    ListCache.prototype.clear = listCacheClear;
    ListCache.prototype.delete = listCacheDelete;
    ListCache.prototype.get = listCacheGet;
    ListCache.prototype.has = listCacheHas;
    ListCache.prototype.set = listCacheSet;
    function MapCache(entries) {
      var index = -1, length = entries ? entries.length : 0;
      for (this.clear(); ++index < length; ) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function mapCacheClear() {
      this.__data__ = {
        hash: new Hash(),
        map: new (Map2 || ListCache)(),
        string: new Hash()
      };
    }
    function mapCacheDelete(key) {
      return getMapData(this, key).delete(key);
    }
    function mapCacheGet(key) {
      return getMapData(this, key).get(key);
    }
    function mapCacheHas(key) {
      return getMapData(this, key).has(key);
    }
    function mapCacheSet(key, value) {
      return getMapData(this, key).set(key, value), this;
    }
    MapCache.prototype.clear = mapCacheClear;
    MapCache.prototype.delete = mapCacheDelete;
    MapCache.prototype.get = mapCacheGet;
    MapCache.prototype.has = mapCacheHas;
    MapCache.prototype.set = mapCacheSet;
    function SetCache(values) {
      var index = -1, length = values ? values.length : 0;
      for (this.__data__ = new MapCache(); ++index < length; )
        this.add(values[index]);
    }
    function setCacheAdd(value) {
      return this.__data__.set(value, HASH_UNDEFINED), this;
    }
    function setCacheHas(value) {
      return this.__data__.has(value);
    }
    SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
    SetCache.prototype.has = setCacheHas;
    function Stack(entries) {
      this.__data__ = new ListCache(entries);
    }
    function stackClear() {
      this.__data__ = new ListCache();
    }
    function stackDelete(key) {
      return this.__data__.delete(key);
    }
    function stackGet(key) {
      return this.__data__.get(key);
    }
    function stackHas(key) {
      return this.__data__.has(key);
    }
    function stackSet(key, value) {
      var cache2 = this.__data__;
      if (cache2 instanceof ListCache) {
        var pairs = cache2.__data__;
        if (!Map2 || pairs.length < LARGE_ARRAY_SIZE - 1)
          return pairs.push([key, value]), this;
        cache2 = this.__data__ = new MapCache(pairs);
      }
      return cache2.set(key, value), this;
    }
    Stack.prototype.clear = stackClear;
    Stack.prototype.delete = stackDelete;
    Stack.prototype.get = stackGet;
    Stack.prototype.has = stackHas;
    Stack.prototype.set = stackSet;
    function arrayLikeKeys(value, inherited) {
      var result = isArray(value) || isArguments(value) ? baseTimes(value.length, String) : [], length = result.length, skipIndexes = !!length;
      for (var key in value)
        (inherited || hasOwnProperty.call(value, key)) && !(skipIndexes && (key == "length" || isIndex(key, length))) && result.push(key);
      return result;
    }
    function assocIndexOf(array, key) {
      for (var length = array.length; length--; )
        if (eq(array[length][0], key))
          return length;
      return -1;
    }
    function baseGet(object, path3) {
      path3 = isKey(path3, object) ? [path3] : castPath(path3);
      for (var index = 0, length = path3.length; object != null && index < length; )
        object = object[toKey(path3[index++])];
      return index && index == length ? object : void 0;
    }
    function baseGetAllKeys(object, keysFunc, symbolsFunc) {
      var result = keysFunc(object);
      return isArray(object) ? result : arrayPush(result, symbolsFunc(object));
    }
    function baseGetTag(value) {
      return objectToString.call(value);
    }
    function baseHasIn(object, key) {
      return object != null && key in Object(object);
    }
    function baseIsEqual(value, other, customizer, bitmask, stack) {
      return value === other ? !0 : value == null || other == null || !isObject4(value) && !isObjectLike(other) ? value !== value && other !== other : baseIsEqualDeep(value, other, baseIsEqual, customizer, bitmask, stack);
    }
    function baseIsEqualDeep(object, other, equalFunc, customizer, bitmask, stack) {
      var objIsArr = isArray(object), othIsArr = isArray(other), objTag = arrayTag, othTag = arrayTag;
      objIsArr || (objTag = getTag(object), objTag = objTag == argsTag ? objectTag : objTag), othIsArr || (othTag = getTag(other), othTag = othTag == argsTag ? objectTag : othTag);
      var objIsObj = objTag == objectTag && !isHostObject(object), othIsObj = othTag == objectTag && !isHostObject(other), isSameTag = objTag == othTag;
      if (isSameTag && !objIsObj)
        return stack || (stack = new Stack()), objIsArr || isTypedArray(object) ? equalArrays(object, other, equalFunc, customizer, bitmask, stack) : equalByTag(object, other, objTag, equalFunc, customizer, bitmask, stack);
      if (!(bitmask & PARTIAL_COMPARE_FLAG)) {
        var objIsWrapped = objIsObj && hasOwnProperty.call(object, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty.call(other, "__wrapped__");
        if (objIsWrapped || othIsWrapped) {
          var objUnwrapped = objIsWrapped ? object.value() : object, othUnwrapped = othIsWrapped ? other.value() : other;
          return stack || (stack = new Stack()), equalFunc(objUnwrapped, othUnwrapped, customizer, bitmask, stack);
        }
      }
      return isSameTag ? (stack || (stack = new Stack()), equalObjects(object, other, equalFunc, customizer, bitmask, stack)) : !1;
    }
    function baseIsMatch(object, source, matchData, customizer) {
      var index = matchData.length, length = index, noCustomizer = !customizer;
      if (object == null)
        return !length;
      for (object = Object(object); index--; ) {
        var data = matchData[index];
        if (noCustomizer && data[2] ? data[1] !== object[data[0]] : !(data[0] in object))
          return !1;
      }
      for (; ++index < length; ) {
        data = matchData[index];
        var key = data[0], objValue = object[key], srcValue = data[1];
        if (noCustomizer && data[2]) {
          if (objValue === void 0 && !(key in object))
            return !1;
        } else {
          var stack = new Stack();
          if (customizer)
            var result = customizer(objValue, srcValue, key, object, source, stack);
          if (!(result === void 0 ? baseIsEqual(srcValue, objValue, customizer, UNORDERED_COMPARE_FLAG | PARTIAL_COMPARE_FLAG, stack) : result))
            return !1;
        }
      }
      return !0;
    }
    function baseIsNative(value) {
      if (!isObject4(value) || isMasked(value))
        return !1;
      var pattern = isFunction(value) || isHostObject(value) ? reIsNative : reIsHostCtor;
      return pattern.test(toSource(value));
    }
    function baseIsTypedArray(value) {
      return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[objectToString.call(value)];
    }
    function baseIteratee(value) {
      return typeof value == "function" ? value : value == null ? identity : typeof value == "object" ? isArray(value) ? baseMatchesProperty(value[0], value[1]) : baseMatches(value) : property(value);
    }
    function baseKeys(object) {
      if (!isPrototype(object))
        return nativeKeys(object);
      var result = [];
      for (var key in Object(object))
        hasOwnProperty.call(object, key) && key != "constructor" && result.push(key);
      return result;
    }
    function baseKeysIn(object) {
      if (!isObject4(object))
        return nativeKeysIn(object);
      var isProto = isPrototype(object), result = [];
      for (var key in object)
        key == "constructor" && (isProto || !hasOwnProperty.call(object, key)) || result.push(key);
      return result;
    }
    function baseMatches(source) {
      var matchData = getMatchData(source);
      return matchData.length == 1 && matchData[0][2] ? matchesStrictComparable(matchData[0][0], matchData[0][1]) : function(object) {
        return object === source || baseIsMatch(object, source, matchData);
      };
    }
    function baseMatchesProperty(path3, srcValue) {
      return isKey(path3) && isStrictComparable(srcValue) ? matchesStrictComparable(toKey(path3), srcValue) : function(object) {
        var objValue = get2(object, path3);
        return objValue === void 0 && objValue === srcValue ? hasIn(object, path3) : baseIsEqual(srcValue, objValue, void 0, UNORDERED_COMPARE_FLAG | PARTIAL_COMPARE_FLAG);
      };
    }
    function basePickBy(object, props, predicate) {
      for (var index = -1, length = props.length, result = {}; ++index < length; ) {
        var key = props[index], value = object[key];
        predicate(value, key) && (result[key] = value);
      }
      return result;
    }
    function basePropertyDeep(path3) {
      return function(object) {
        return baseGet(object, path3);
      };
    }
    function baseToString(value) {
      if (typeof value == "string")
        return value;
      if (isSymbol(value))
        return symbolToString ? symbolToString.call(value) : "";
      var result = value + "";
      return result == "0" && 1 / value == -INFINITY ? "-0" : result;
    }
    function castPath(value) {
      return isArray(value) ? value : stringToPath(value);
    }
    function equalArrays(array, other, equalFunc, customizer, bitmask, stack) {
      var isPartial = bitmask & PARTIAL_COMPARE_FLAG, arrLength = array.length, othLength = other.length;
      if (arrLength != othLength && !(isPartial && othLength > arrLength))
        return !1;
      var stacked = stack.get(array);
      if (stacked && stack.get(other))
        return stacked == other;
      var index = -1, result = !0, seen = bitmask & UNORDERED_COMPARE_FLAG ? new SetCache() : void 0;
      for (stack.set(array, other), stack.set(other, array); ++index < arrLength; ) {
        var arrValue = array[index], othValue = other[index];
        if (customizer)
          var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
        if (compared !== void 0) {
          if (compared)
            continue;
          result = !1;
          break;
        }
        if (seen) {
          if (!arraySome(other, function(othValue2, othIndex) {
            if (!seen.has(othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, customizer, bitmask, stack)))
              return seen.add(othIndex);
          })) {
            result = !1;
            break;
          }
        } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, customizer, bitmask, stack))) {
          result = !1;
          break;
        }
      }
      return stack.delete(array), stack.delete(other), result;
    }
    function equalByTag(object, other, tag, equalFunc, customizer, bitmask, stack) {
      switch (tag) {
        case dataViewTag:
          if (object.byteLength != other.byteLength || object.byteOffset != other.byteOffset)
            return !1;
          object = object.buffer, other = other.buffer;
        case arrayBufferTag:
          return !(object.byteLength != other.byteLength || !equalFunc(new Uint8Array2(object), new Uint8Array2(other)));
        case boolTag:
        case dateTag:
        case numberTag:
          return eq(+object, +other);
        case errorTag:
          return object.name == other.name && object.message == other.message;
        case regexpTag:
        case stringTag:
          return object == other + "";
        case mapTag:
          var convert = mapToArray;
        case setTag:
          var isPartial = bitmask & PARTIAL_COMPARE_FLAG;
          if (convert || (convert = setToArray), object.size != other.size && !isPartial)
            return !1;
          var stacked = stack.get(object);
          if (stacked)
            return stacked == other;
          bitmask |= UNORDERED_COMPARE_FLAG, stack.set(object, other);
          var result = equalArrays(convert(object), convert(other), equalFunc, customizer, bitmask, stack);
          return stack.delete(object), result;
        case symbolTag:
          if (symbolValueOf)
            return symbolValueOf.call(object) == symbolValueOf.call(other);
      }
      return !1;
    }
    function equalObjects(object, other, equalFunc, customizer, bitmask, stack) {
      var isPartial = bitmask & PARTIAL_COMPARE_FLAG, objProps = keys(object), objLength = objProps.length, othProps = keys(other), othLength = othProps.length;
      if (objLength != othLength && !isPartial)
        return !1;
      for (var index = objLength; index--; ) {
        var key = objProps[index];
        if (!(isPartial ? key in other : hasOwnProperty.call(other, key)))
          return !1;
      }
      var stacked = stack.get(object);
      if (stacked && stack.get(other))
        return stacked == other;
      var result = !0;
      stack.set(object, other), stack.set(other, object);
      for (var skipCtor = isPartial; ++index < objLength; ) {
        key = objProps[index];
        var objValue = object[key], othValue = other[key];
        if (customizer)
          var compared = isPartial ? customizer(othValue, objValue, key, other, object, stack) : customizer(objValue, othValue, key, object, other, stack);
        if (!(compared === void 0 ? objValue === othValue || equalFunc(objValue, othValue, customizer, bitmask, stack) : compared)) {
          result = !1;
          break;
        }
        skipCtor || (skipCtor = key == "constructor");
      }
      if (result && !skipCtor) {
        var objCtor = object.constructor, othCtor = other.constructor;
        objCtor != othCtor && "constructor" in object && "constructor" in other && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor) && (result = !1);
      }
      return stack.delete(object), stack.delete(other), result;
    }
    function getAllKeysIn(object) {
      return baseGetAllKeys(object, keysIn, getSymbolsIn);
    }
    function getMapData(map, key) {
      var data = map.__data__;
      return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
    }
    function getMatchData(object) {
      for (var result = keys(object), length = result.length; length--; ) {
        var key = result[length], value = object[key];
        result[length] = [key, value, isStrictComparable(value)];
      }
      return result;
    }
    function getNative(object, key) {
      var value = getValue(object, key);
      return baseIsNative(value) ? value : void 0;
    }
    var getSymbols = nativeGetSymbols ? overArg(nativeGetSymbols, Object) : stubArray, getSymbolsIn = nativeGetSymbols ? function(object) {
      for (var result = []; object; )
        arrayPush(result, getSymbols(object)), object = getPrototype(object);
      return result;
    } : stubArray, getTag = baseGetTag;
    (DataView2 && getTag(new DataView2(new ArrayBuffer(1))) != dataViewTag || Map2 && getTag(new Map2()) != mapTag || Promise2 && getTag(Promise2.resolve()) != promiseTag || Set2 && getTag(new Set2()) != setTag || WeakMap2 && getTag(new WeakMap2()) != weakMapTag) && (getTag = function(value) {
      var result = objectToString.call(value), Ctor = result == objectTag ? value.constructor : void 0, ctorString = Ctor ? toSource(Ctor) : void 0;
      if (ctorString)
        switch (ctorString) {
          case dataViewCtorString:
            return dataViewTag;
          case mapCtorString:
            return mapTag;
          case promiseCtorString:
            return promiseTag;
          case setCtorString:
            return setTag;
          case weakMapCtorString:
            return weakMapTag;
        }
      return result;
    });
    function hasPath(object, path3, hasFunc) {
      path3 = isKey(path3, object) ? [path3] : castPath(path3);
      for (var result, index = -1, length = path3.length; ++index < length; ) {
        var key = toKey(path3[index]);
        if (!(result = object != null && hasFunc(object, key)))
          break;
        object = object[key];
      }
      if (result)
        return result;
      var length = object ? object.length : 0;
      return !!length && isLength(length) && isIndex(key, length) && (isArray(object) || isArguments(object));
    }
    function isIndex(value, length) {
      return length = length ?? MAX_SAFE_INTEGER, !!length && (typeof value == "number" || reIsUint.test(value)) && value > -1 && value % 1 == 0 && value < length;
    }
    function isKey(value, object) {
      if (isArray(value))
        return !1;
      var type = typeof value;
      return type == "number" || type == "symbol" || type == "boolean" || value == null || isSymbol(value) ? !0 : reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object != null && value in Object(object);
    }
    function isKeyable(value) {
      var type = typeof value;
      return type == "string" || type == "number" || type == "symbol" || type == "boolean" ? value !== "__proto__" : value === null;
    }
    function isMasked(func) {
      return !!maskSrcKey && maskSrcKey in func;
    }
    function isPrototype(value) {
      var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto;
      return value === proto;
    }
    function isStrictComparable(value) {
      return value === value && !isObject4(value);
    }
    function matchesStrictComparable(key, srcValue) {
      return function(object) {
        return object == null ? !1 : object[key] === srcValue && (srcValue !== void 0 || key in Object(object));
      };
    }
    function nativeKeysIn(object) {
      var result = [];
      if (object != null)
        for (var key in Object(object))
          result.push(key);
      return result;
    }
    var stringToPath = memoize(function(string) {
      string = toString2(string);
      var result = [];
      return reLeadingDot.test(string) && result.push(""), string.replace(rePropName, function(match2, number, quote, string2) {
        result.push(quote ? string2.replace(reEscapeChar, "$1") : number || match2);
      }), result;
    });
    function toKey(value) {
      if (typeof value == "string" || isSymbol(value))
        return value;
      var result = value + "";
      return result == "0" && 1 / value == -INFINITY ? "-0" : result;
    }
    function toSource(func) {
      if (func != null) {
        try {
          return funcToString.call(func);
        } catch {
        }
        try {
          return func + "";
        } catch {
        }
      }
      return "";
    }
    function memoize(func, resolver) {
      if (typeof func != "function" || resolver && typeof resolver != "function")
        throw new TypeError(FUNC_ERROR_TEXT);
      var memoized = function() {
        var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache2 = memoized.cache;
        if (cache2.has(key))
          return cache2.get(key);
        var result = func.apply(this, args);
        return memoized.cache = cache2.set(key, result), result;
      };
      return memoized.cache = new (memoize.Cache || MapCache)(), memoized;
    }
    memoize.Cache = MapCache;
    function eq(value, other) {
      return value === other || value !== value && other !== other;
    }
    function isArguments(value) {
      return isArrayLikeObject(value) && hasOwnProperty.call(value, "callee") && (!propertyIsEnumerable.call(value, "callee") || objectToString.call(value) == argsTag);
    }
    var isArray = Array.isArray;
    function isArrayLike(value) {
      return value != null && isLength(value.length) && !isFunction(value);
    }
    function isArrayLikeObject(value) {
      return isObjectLike(value) && isArrayLike(value);
    }
    function isFunction(value) {
      var tag = isObject4(value) ? objectToString.call(value) : "";
      return tag == funcTag || tag == genTag;
    }
    function isLength(value) {
      return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
    }
    function isObject4(value) {
      var type = typeof value;
      return !!value && (type == "object" || type == "function");
    }
    function isObjectLike(value) {
      return !!value && typeof value == "object";
    }
    function isSymbol(value) {
      return typeof value == "symbol" || isObjectLike(value) && objectToString.call(value) == symbolTag;
    }
    var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
    function toString2(value) {
      return value == null ? "" : baseToString(value);
    }
    function get2(object, path3, defaultValue) {
      var result = object == null ? void 0 : baseGet(object, path3);
      return result === void 0 ? defaultValue : result;
    }
    function hasIn(object, path3) {
      return object != null && hasPath(object, path3, baseHasIn);
    }
    function keys(object) {
      return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
    }
    function keysIn(object) {
      return isArrayLike(object) ? arrayLikeKeys(object, !0) : baseKeysIn(object);
    }
    function pickBy3(object, predicate) {
      return object == null ? {} : basePickBy(object, getAllKeysIn(object), baseIteratee(predicate));
    }
    function identity(value) {
      return value;
    }
    function property(path3) {
      return isKey(path3) ? baseProperty(toKey(path3)) : basePropertyDeep(path3);
    }
    function stubArray() {
      return [];
    }
    module.exports = pickBy3;
  }
});

// ../../node_modules/.pnpm/lodash.sortby@4.7.0/node_modules/lodash.sortby/index.js
var require_lodash7 = __commonJS({
  "../../node_modules/.pnpm/lodash.sortby@4.7.0/node_modules/lodash.sortby/index.js"(exports, module) {
    init_cjs_shims();
    var LARGE_ARRAY_SIZE = 200, FUNC_ERROR_TEXT = "Expected a function", HASH_UNDEFINED = "__lodash_hash_undefined__", UNORDERED_COMPARE_FLAG = 1, PARTIAL_COMPARE_FLAG = 2, INFINITY = 1 / 0, MAX_SAFE_INTEGER = 9007199254740991, argsTag = "[object Arguments]", arrayTag = "[object Array]", boolTag = "[object Boolean]", dateTag = "[object Date]", errorTag = "[object Error]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", mapTag = "[object Map]", numberTag = "[object Number]", objectTag = "[object Object]", promiseTag = "[object Promise]", regexpTag = "[object RegExp]", setTag = "[object Set]", stringTag = "[object String]", symbolTag = "[object Symbol]", weakMapTag = "[object WeakMap]", arrayBufferTag = "[object ArrayBuffer]", dataViewTag = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]", reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/, reLeadingDot = /^\./, rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, reRegExpChar = /[\\^$.*+?()[\]{}|]/g, reEscapeChar = /\\(\\)?/g, reIsHostCtor = /^\[object .+?Constructor\]$/, reIsUint = /^(?:0|[1-9]\d*)$/, typedArrayTags = {};
    typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = !0;
    typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = !1;
    var freeGlobal = typeof global == "object" && global && global.Object === Object && global, freeSelf = typeof self == "object" && self && self.Object === Object && self, root = freeGlobal || freeSelf || Function("return this")(), freeExports = typeof exports == "object" && exports && !exports.nodeType && exports, freeModule = freeExports && typeof module == "object" && module && !module.nodeType && module, moduleExports = freeModule && freeModule.exports === freeExports, freeProcess = moduleExports && freeGlobal.process, nodeUtil = function() {
      try {
        return freeProcess && freeProcess.binding("util");
      } catch {
      }
    }(), nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
    function apply(func, thisArg, args) {
      switch (args.length) {
        case 0:
          return func.call(thisArg);
        case 1:
          return func.call(thisArg, args[0]);
        case 2:
          return func.call(thisArg, args[0], args[1]);
        case 3:
          return func.call(thisArg, args[0], args[1], args[2]);
      }
      return func.apply(thisArg, args);
    }
    function arrayMap(array, iteratee) {
      for (var index = -1, length = array ? array.length : 0, result = Array(length); ++index < length; )
        result[index] = iteratee(array[index], index, array);
      return result;
    }
    function arrayPush(array, values) {
      for (var index = -1, length = values.length, offset = array.length; ++index < length; )
        array[offset + index] = values[index];
      return array;
    }
    function arraySome(array, predicate) {
      for (var index = -1, length = array ? array.length : 0; ++index < length; )
        if (predicate(array[index], index, array))
          return !0;
      return !1;
    }
    function baseProperty(key) {
      return function(object) {
        return object?.[key];
      };
    }
    function baseSortBy(array, comparer) {
      var length = array.length;
      for (array.sort(comparer); length--; )
        array[length] = array[length].value;
      return array;
    }
    function baseTimes(n, iteratee) {
      for (var index = -1, result = Array(n); ++index < n; )
        result[index] = iteratee(index);
      return result;
    }
    function baseUnary(func) {
      return function(value) {
        return func(value);
      };
    }
    function getValue(object, key) {
      return object?.[key];
    }
    function isHostObject(value) {
      var result = !1;
      if (value != null && typeof value.toString != "function")
        try {
          result = !!(value + "");
        } catch {
        }
      return result;
    }
    function mapToArray(map) {
      var index = -1, result = Array(map.size);
      return map.forEach(function(value, key) {
        result[++index] = [key, value];
      }), result;
    }
    function overArg(func, transform2) {
      return function(arg) {
        return func(transform2(arg));
      };
    }
    function setToArray(set2) {
      var index = -1, result = Array(set2.size);
      return set2.forEach(function(value) {
        result[++index] = value;
      }), result;
    }
    var arrayProto = Array.prototype, funcProto = Function.prototype, objectProto = Object.prototype, coreJsData = root["__core-js_shared__"], maskSrcKey = function() {
      var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
      return uid ? "Symbol(src)_1." + uid : "";
    }(), funcToString = funcProto.toString, hasOwnProperty = objectProto.hasOwnProperty, objectToString = objectProto.toString, reIsNative = RegExp(
      "^" + funcToString.call(hasOwnProperty).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
    ), Symbol2 = root.Symbol, Uint8Array2 = root.Uint8Array, propertyIsEnumerable = objectProto.propertyIsEnumerable, splice = arrayProto.splice, spreadableSymbol = Symbol2 ? Symbol2.isConcatSpreadable : void 0, nativeKeys = overArg(Object.keys, Object), nativeMax = Math.max, DataView2 = getNative(root, "DataView"), Map2 = getNative(root, "Map"), Promise2 = getNative(root, "Promise"), Set2 = getNative(root, "Set"), WeakMap2 = getNative(root, "WeakMap"), nativeCreate = getNative(Object, "create"), dataViewCtorString = toSource(DataView2), mapCtorString = toSource(Map2), promiseCtorString = toSource(Promise2), setCtorString = toSource(Set2), weakMapCtorString = toSource(WeakMap2), symbolProto = Symbol2 ? Symbol2.prototype : void 0, symbolValueOf = symbolProto ? symbolProto.valueOf : void 0, symbolToString = symbolProto ? symbolProto.toString : void 0;
    function Hash(entries) {
      var index = -1, length = entries ? entries.length : 0;
      for (this.clear(); ++index < length; ) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function hashClear() {
      this.__data__ = nativeCreate ? nativeCreate(null) : {};
    }
    function hashDelete(key) {
      return this.has(key) && delete this.__data__[key];
    }
    function hashGet(key) {
      var data = this.__data__;
      if (nativeCreate) {
        var result = data[key];
        return result === HASH_UNDEFINED ? void 0 : result;
      }
      return hasOwnProperty.call(data, key) ? data[key] : void 0;
    }
    function hashHas(key) {
      var data = this.__data__;
      return nativeCreate ? data[key] !== void 0 : hasOwnProperty.call(data, key);
    }
    function hashSet(key, value) {
      var data = this.__data__;
      return data[key] = nativeCreate && value === void 0 ? HASH_UNDEFINED : value, this;
    }
    Hash.prototype.clear = hashClear;
    Hash.prototype.delete = hashDelete;
    Hash.prototype.get = hashGet;
    Hash.prototype.has = hashHas;
    Hash.prototype.set = hashSet;
    function ListCache(entries) {
      var index = -1, length = entries ? entries.length : 0;
      for (this.clear(); ++index < length; ) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function listCacheClear() {
      this.__data__ = [];
    }
    function listCacheDelete(key) {
      var data = this.__data__, index = assocIndexOf(data, key);
      if (index < 0)
        return !1;
      var lastIndex = data.length - 1;
      return index == lastIndex ? data.pop() : splice.call(data, index, 1), !0;
    }
    function listCacheGet(key) {
      var data = this.__data__, index = assocIndexOf(data, key);
      return index < 0 ? void 0 : data[index][1];
    }
    function listCacheHas(key) {
      return assocIndexOf(this.__data__, key) > -1;
    }
    function listCacheSet(key, value) {
      var data = this.__data__, index = assocIndexOf(data, key);
      return index < 0 ? data.push([key, value]) : data[index][1] = value, this;
    }
    ListCache.prototype.clear = listCacheClear;
    ListCache.prototype.delete = listCacheDelete;
    ListCache.prototype.get = listCacheGet;
    ListCache.prototype.has = listCacheHas;
    ListCache.prototype.set = listCacheSet;
    function MapCache(entries) {
      var index = -1, length = entries ? entries.length : 0;
      for (this.clear(); ++index < length; ) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function mapCacheClear() {
      this.__data__ = {
        hash: new Hash(),
        map: new (Map2 || ListCache)(),
        string: new Hash()
      };
    }
    function mapCacheDelete(key) {
      return getMapData(this, key).delete(key);
    }
    function mapCacheGet(key) {
      return getMapData(this, key).get(key);
    }
    function mapCacheHas(key) {
      return getMapData(this, key).has(key);
    }
    function mapCacheSet(key, value) {
      return getMapData(this, key).set(key, value), this;
    }
    MapCache.prototype.clear = mapCacheClear;
    MapCache.prototype.delete = mapCacheDelete;
    MapCache.prototype.get = mapCacheGet;
    MapCache.prototype.has = mapCacheHas;
    MapCache.prototype.set = mapCacheSet;
    function SetCache(values) {
      var index = -1, length = values ? values.length : 0;
      for (this.__data__ = new MapCache(); ++index < length; )
        this.add(values[index]);
    }
    function setCacheAdd(value) {
      return this.__data__.set(value, HASH_UNDEFINED), this;
    }
    function setCacheHas(value) {
      return this.__data__.has(value);
    }
    SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
    SetCache.prototype.has = setCacheHas;
    function Stack(entries) {
      this.__data__ = new ListCache(entries);
    }
    function stackClear() {
      this.__data__ = new ListCache();
    }
    function stackDelete(key) {
      return this.__data__.delete(key);
    }
    function stackGet(key) {
      return this.__data__.get(key);
    }
    function stackHas(key) {
      return this.__data__.has(key);
    }
    function stackSet(key, value) {
      var cache2 = this.__data__;
      if (cache2 instanceof ListCache) {
        var pairs = cache2.__data__;
        if (!Map2 || pairs.length < LARGE_ARRAY_SIZE - 1)
          return pairs.push([key, value]), this;
        cache2 = this.__data__ = new MapCache(pairs);
      }
      return cache2.set(key, value), this;
    }
    Stack.prototype.clear = stackClear;
    Stack.prototype.delete = stackDelete;
    Stack.prototype.get = stackGet;
    Stack.prototype.has = stackHas;
    Stack.prototype.set = stackSet;
    function arrayLikeKeys(value, inherited) {
      var result = isArray(value) || isArguments(value) ? baseTimes(value.length, String) : [], length = result.length, skipIndexes = !!length;
      for (var key in value)
        (inherited || hasOwnProperty.call(value, key)) && !(skipIndexes && (key == "length" || isIndex(key, length))) && result.push(key);
      return result;
    }
    function assocIndexOf(array, key) {
      for (var length = array.length; length--; )
        if (eq(array[length][0], key))
          return length;
      return -1;
    }
    var baseEach = createBaseEach(baseForOwn);
    function baseFlatten(array, depth, predicate, isStrict, result) {
      var index = -1, length = array.length;
      for (predicate || (predicate = isFlattenable), result || (result = []); ++index < length; ) {
        var value = array[index];
        depth > 0 && predicate(value) ? depth > 1 ? baseFlatten(value, depth - 1, predicate, isStrict, result) : arrayPush(result, value) : isStrict || (result[result.length] = value);
      }
      return result;
    }
    var baseFor = createBaseFor();
    function baseForOwn(object, iteratee) {
      return object && baseFor(object, iteratee, keys);
    }
    function baseGet(object, path3) {
      path3 = isKey(path3, object) ? [path3] : castPath(path3);
      for (var index = 0, length = path3.length; object != null && index < length; )
        object = object[toKey(path3[index++])];
      return index && index == length ? object : void 0;
    }
    function baseGetTag(value) {
      return objectToString.call(value);
    }
    function baseHasIn(object, key) {
      return object != null && key in Object(object);
    }
    function baseIsEqual(value, other, customizer, bitmask, stack) {
      return value === other ? !0 : value == null || other == null || !isObject4(value) && !isObjectLike(other) ? value !== value && other !== other : baseIsEqualDeep(value, other, baseIsEqual, customizer, bitmask, stack);
    }
    function baseIsEqualDeep(object, other, equalFunc, customizer, bitmask, stack) {
      var objIsArr = isArray(object), othIsArr = isArray(other), objTag = arrayTag, othTag = arrayTag;
      objIsArr || (objTag = getTag(object), objTag = objTag == argsTag ? objectTag : objTag), othIsArr || (othTag = getTag(other), othTag = othTag == argsTag ? objectTag : othTag);
      var objIsObj = objTag == objectTag && !isHostObject(object), othIsObj = othTag == objectTag && !isHostObject(other), isSameTag = objTag == othTag;
      if (isSameTag && !objIsObj)
        return stack || (stack = new Stack()), objIsArr || isTypedArray(object) ? equalArrays(object, other, equalFunc, customizer, bitmask, stack) : equalByTag(object, other, objTag, equalFunc, customizer, bitmask, stack);
      if (!(bitmask & PARTIAL_COMPARE_FLAG)) {
        var objIsWrapped = objIsObj && hasOwnProperty.call(object, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty.call(other, "__wrapped__");
        if (objIsWrapped || othIsWrapped) {
          var objUnwrapped = objIsWrapped ? object.value() : object, othUnwrapped = othIsWrapped ? other.value() : other;
          return stack || (stack = new Stack()), equalFunc(objUnwrapped, othUnwrapped, customizer, bitmask, stack);
        }
      }
      return isSameTag ? (stack || (stack = new Stack()), equalObjects(object, other, equalFunc, customizer, bitmask, stack)) : !1;
    }
    function baseIsMatch(object, source, matchData, customizer) {
      var index = matchData.length, length = index, noCustomizer = !customizer;
      if (object == null)
        return !length;
      for (object = Object(object); index--; ) {
        var data = matchData[index];
        if (noCustomizer && data[2] ? data[1] !== object[data[0]] : !(data[0] in object))
          return !1;
      }
      for (; ++index < length; ) {
        data = matchData[index];
        var key = data[0], objValue = object[key], srcValue = data[1];
        if (noCustomizer && data[2]) {
          if (objValue === void 0 && !(key in object))
            return !1;
        } else {
          var stack = new Stack();
          if (customizer)
            var result = customizer(objValue, srcValue, key, object, source, stack);
          if (!(result === void 0 ? baseIsEqual(srcValue, objValue, customizer, UNORDERED_COMPARE_FLAG | PARTIAL_COMPARE_FLAG, stack) : result))
            return !1;
        }
      }
      return !0;
    }
    function baseIsNative(value) {
      if (!isObject4(value) || isMasked(value))
        return !1;
      var pattern = isFunction(value) || isHostObject(value) ? reIsNative : reIsHostCtor;
      return pattern.test(toSource(value));
    }
    function baseIsTypedArray(value) {
      return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[objectToString.call(value)];
    }
    function baseIteratee(value) {
      return typeof value == "function" ? value : value == null ? identity : typeof value == "object" ? isArray(value) ? baseMatchesProperty(value[0], value[1]) : baseMatches(value) : property(value);
    }
    function baseKeys(object) {
      if (!isPrototype(object))
        return nativeKeys(object);
      var result = [];
      for (var key in Object(object))
        hasOwnProperty.call(object, key) && key != "constructor" && result.push(key);
      return result;
    }
    function baseMap(collection, iteratee) {
      var index = -1, result = isArrayLike(collection) ? Array(collection.length) : [];
      return baseEach(collection, function(value, key, collection2) {
        result[++index] = iteratee(value, key, collection2);
      }), result;
    }
    function baseMatches(source) {
      var matchData = getMatchData(source);
      return matchData.length == 1 && matchData[0][2] ? matchesStrictComparable(matchData[0][0], matchData[0][1]) : function(object) {
        return object === source || baseIsMatch(object, source, matchData);
      };
    }
    function baseMatchesProperty(path3, srcValue) {
      return isKey(path3) && isStrictComparable(srcValue) ? matchesStrictComparable(toKey(path3), srcValue) : function(object) {
        var objValue = get2(object, path3);
        return objValue === void 0 && objValue === srcValue ? hasIn(object, path3) : baseIsEqual(srcValue, objValue, void 0, UNORDERED_COMPARE_FLAG | PARTIAL_COMPARE_FLAG);
      };
    }
    function baseOrderBy(collection, iteratees, orders) {
      var index = -1;
      iteratees = arrayMap(iteratees.length ? iteratees : [identity], baseUnary(baseIteratee));
      var result = baseMap(collection, function(value, key, collection2) {
        var criteria = arrayMap(iteratees, function(iteratee) {
          return iteratee(value);
        });
        return { criteria, index: ++index, value };
      });
      return baseSortBy(result, function(object, other) {
        return compareMultiple(object, other, orders);
      });
    }
    function basePropertyDeep(path3) {
      return function(object) {
        return baseGet(object, path3);
      };
    }
    function baseRest(func, start) {
      return start = nativeMax(start === void 0 ? func.length - 1 : start, 0), function() {
        for (var args = arguments, index = -1, length = nativeMax(args.length - start, 0), array = Array(length); ++index < length; )
          array[index] = args[start + index];
        index = -1;
        for (var otherArgs = Array(start + 1); ++index < start; )
          otherArgs[index] = args[index];
        return otherArgs[start] = array, apply(func, this, otherArgs);
      };
    }
    function baseToString(value) {
      if (typeof value == "string")
        return value;
      if (isSymbol(value))
        return symbolToString ? symbolToString.call(value) : "";
      var result = value + "";
      return result == "0" && 1 / value == -INFINITY ? "-0" : result;
    }
    function castPath(value) {
      return isArray(value) ? value : stringToPath(value);
    }
    function compareAscending(value, other) {
      if (value !== other) {
        var valIsDefined = value !== void 0, valIsNull = value === null, valIsReflexive = value === value, valIsSymbol = isSymbol(value), othIsDefined = other !== void 0, othIsNull = other === null, othIsReflexive = other === other, othIsSymbol = isSymbol(other);
        if (!othIsNull && !othIsSymbol && !valIsSymbol && value > other || valIsSymbol && othIsDefined && othIsReflexive && !othIsNull && !othIsSymbol || valIsNull && othIsDefined && othIsReflexive || !valIsDefined && othIsReflexive || !valIsReflexive)
          return 1;
        if (!valIsNull && !valIsSymbol && !othIsSymbol && value < other || othIsSymbol && valIsDefined && valIsReflexive && !valIsNull && !valIsSymbol || othIsNull && valIsDefined && valIsReflexive || !othIsDefined && valIsReflexive || !othIsReflexive)
          return -1;
      }
      return 0;
    }
    function compareMultiple(object, other, orders) {
      for (var index = -1, objCriteria = object.criteria, othCriteria = other.criteria, length = objCriteria.length, ordersLength = orders.length; ++index < length; ) {
        var result = compareAscending(objCriteria[index], othCriteria[index]);
        if (result) {
          if (index >= ordersLength)
            return result;
          var order = orders[index];
          return result * (order == "desc" ? -1 : 1);
        }
      }
      return object.index - other.index;
    }
    function createBaseEach(eachFunc, fromRight) {
      return function(collection, iteratee) {
        if (collection == null)
          return collection;
        if (!isArrayLike(collection))
          return eachFunc(collection, iteratee);
        for (var length = collection.length, index = fromRight ? length : -1, iterable = Object(collection); (fromRight ? index-- : ++index < length) && iteratee(iterable[index], index, iterable) !== !1; )
          ;
        return collection;
      };
    }
    function createBaseFor(fromRight) {
      return function(object, iteratee, keysFunc) {
        for (var index = -1, iterable = Object(object), props = keysFunc(object), length = props.length; length--; ) {
          var key = props[fromRight ? length : ++index];
          if (iteratee(iterable[key], key, iterable) === !1)
            break;
        }
        return object;
      };
    }
    function equalArrays(array, other, equalFunc, customizer, bitmask, stack) {
      var isPartial = bitmask & PARTIAL_COMPARE_FLAG, arrLength = array.length, othLength = other.length;
      if (arrLength != othLength && !(isPartial && othLength > arrLength))
        return !1;
      var stacked = stack.get(array);
      if (stacked && stack.get(other))
        return stacked == other;
      var index = -1, result = !0, seen = bitmask & UNORDERED_COMPARE_FLAG ? new SetCache() : void 0;
      for (stack.set(array, other), stack.set(other, array); ++index < arrLength; ) {
        var arrValue = array[index], othValue = other[index];
        if (customizer)
          var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
        if (compared !== void 0) {
          if (compared)
            continue;
          result = !1;
          break;
        }
        if (seen) {
          if (!arraySome(other, function(othValue2, othIndex) {
            if (!seen.has(othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, customizer, bitmask, stack)))
              return seen.add(othIndex);
          })) {
            result = !1;
            break;
          }
        } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, customizer, bitmask, stack))) {
          result = !1;
          break;
        }
      }
      return stack.delete(array), stack.delete(other), result;
    }
    function equalByTag(object, other, tag, equalFunc, customizer, bitmask, stack) {
      switch (tag) {
        case dataViewTag:
          if (object.byteLength != other.byteLength || object.byteOffset != other.byteOffset)
            return !1;
          object = object.buffer, other = other.buffer;
        case arrayBufferTag:
          return !(object.byteLength != other.byteLength || !equalFunc(new Uint8Array2(object), new Uint8Array2(other)));
        case boolTag:
        case dateTag:
        case numberTag:
          return eq(+object, +other);
        case errorTag:
          return object.name == other.name && object.message == other.message;
        case regexpTag:
        case stringTag:
          return object == other + "";
        case mapTag:
          var convert = mapToArray;
        case setTag:
          var isPartial = bitmask & PARTIAL_COMPARE_FLAG;
          if (convert || (convert = setToArray), object.size != other.size && !isPartial)
            return !1;
          var stacked = stack.get(object);
          if (stacked)
            return stacked == other;
          bitmask |= UNORDERED_COMPARE_FLAG, stack.set(object, other);
          var result = equalArrays(convert(object), convert(other), equalFunc, customizer, bitmask, stack);
          return stack.delete(object), result;
        case symbolTag:
          if (symbolValueOf)
            return symbolValueOf.call(object) == symbolValueOf.call(other);
      }
      return !1;
    }
    function equalObjects(object, other, equalFunc, customizer, bitmask, stack) {
      var isPartial = bitmask & PARTIAL_COMPARE_FLAG, objProps = keys(object), objLength = objProps.length, othProps = keys(other), othLength = othProps.length;
      if (objLength != othLength && !isPartial)
        return !1;
      for (var index = objLength; index--; ) {
        var key = objProps[index];
        if (!(isPartial ? key in other : hasOwnProperty.call(other, key)))
          return !1;
      }
      var stacked = stack.get(object);
      if (stacked && stack.get(other))
        return stacked == other;
      var result = !0;
      stack.set(object, other), stack.set(other, object);
      for (var skipCtor = isPartial; ++index < objLength; ) {
        key = objProps[index];
        var objValue = object[key], othValue = other[key];
        if (customizer)
          var compared = isPartial ? customizer(othValue, objValue, key, other, object, stack) : customizer(objValue, othValue, key, object, other, stack);
        if (!(compared === void 0 ? objValue === othValue || equalFunc(objValue, othValue, customizer, bitmask, stack) : compared)) {
          result = !1;
          break;
        }
        skipCtor || (skipCtor = key == "constructor");
      }
      if (result && !skipCtor) {
        var objCtor = object.constructor, othCtor = other.constructor;
        objCtor != othCtor && "constructor" in object && "constructor" in other && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor) && (result = !1);
      }
      return stack.delete(object), stack.delete(other), result;
    }
    function getMapData(map, key) {
      var data = map.__data__;
      return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
    }
    function getMatchData(object) {
      for (var result = keys(object), length = result.length; length--; ) {
        var key = result[length], value = object[key];
        result[length] = [key, value, isStrictComparable(value)];
      }
      return result;
    }
    function getNative(object, key) {
      var value = getValue(object, key);
      return baseIsNative(value) ? value : void 0;
    }
    var getTag = baseGetTag;
    (DataView2 && getTag(new DataView2(new ArrayBuffer(1))) != dataViewTag || Map2 && getTag(new Map2()) != mapTag || Promise2 && getTag(Promise2.resolve()) != promiseTag || Set2 && getTag(new Set2()) != setTag || WeakMap2 && getTag(new WeakMap2()) != weakMapTag) && (getTag = function(value) {
      var result = objectToString.call(value), Ctor = result == objectTag ? value.constructor : void 0, ctorString = Ctor ? toSource(Ctor) : void 0;
      if (ctorString)
        switch (ctorString) {
          case dataViewCtorString:
            return dataViewTag;
          case mapCtorString:
            return mapTag;
          case promiseCtorString:
            return promiseTag;
          case setCtorString:
            return setTag;
          case weakMapCtorString:
            return weakMapTag;
        }
      return result;
    });
    function hasPath(object, path3, hasFunc) {
      path3 = isKey(path3, object) ? [path3] : castPath(path3);
      for (var result, index = -1, length = path3.length; ++index < length; ) {
        var key = toKey(path3[index]);
        if (!(result = object != null && hasFunc(object, key)))
          break;
        object = object[key];
      }
      if (result)
        return result;
      var length = object ? object.length : 0;
      return !!length && isLength(length) && isIndex(key, length) && (isArray(object) || isArguments(object));
    }
    function isFlattenable(value) {
      return isArray(value) || isArguments(value) || !!(spreadableSymbol && value && value[spreadableSymbol]);
    }
    function isIndex(value, length) {
      return length = length ?? MAX_SAFE_INTEGER, !!length && (typeof value == "number" || reIsUint.test(value)) && value > -1 && value % 1 == 0 && value < length;
    }
    function isIterateeCall(value, index, object) {
      if (!isObject4(object))
        return !1;
      var type = typeof index;
      return (type == "number" ? isArrayLike(object) && isIndex(index, object.length) : type == "string" && index in object) ? eq(object[index], value) : !1;
    }
    function isKey(value, object) {
      if (isArray(value))
        return !1;
      var type = typeof value;
      return type == "number" || type == "symbol" || type == "boolean" || value == null || isSymbol(value) ? !0 : reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object != null && value in Object(object);
    }
    function isKeyable(value) {
      var type = typeof value;
      return type == "string" || type == "number" || type == "symbol" || type == "boolean" ? value !== "__proto__" : value === null;
    }
    function isMasked(func) {
      return !!maskSrcKey && maskSrcKey in func;
    }
    function isPrototype(value) {
      var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto;
      return value === proto;
    }
    function isStrictComparable(value) {
      return value === value && !isObject4(value);
    }
    function matchesStrictComparable(key, srcValue) {
      return function(object) {
        return object == null ? !1 : object[key] === srcValue && (srcValue !== void 0 || key in Object(object));
      };
    }
    var stringToPath = memoize(function(string) {
      string = toString2(string);
      var result = [];
      return reLeadingDot.test(string) && result.push(""), string.replace(rePropName, function(match2, number, quote, string2) {
        result.push(quote ? string2.replace(reEscapeChar, "$1") : number || match2);
      }), result;
    });
    function toKey(value) {
      if (typeof value == "string" || isSymbol(value))
        return value;
      var result = value + "";
      return result == "0" && 1 / value == -INFINITY ? "-0" : result;
    }
    function toSource(func) {
      if (func != null) {
        try {
          return funcToString.call(func);
        } catch {
        }
        try {
          return func + "";
        } catch {
        }
      }
      return "";
    }
    var sortBy3 = baseRest(function(collection, iteratees) {
      if (collection == null)
        return [];
      var length = iteratees.length;
      return length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1]) ? iteratees = [] : length > 2 && isIterateeCall(iteratees[0], iteratees[1], iteratees[2]) && (iteratees = [iteratees[0]]), baseOrderBy(collection, baseFlatten(iteratees, 1), []);
    });
    function memoize(func, resolver) {
      if (typeof func != "function" || resolver && typeof resolver != "function")
        throw new TypeError(FUNC_ERROR_TEXT);
      var memoized = function() {
        var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache2 = memoized.cache;
        if (cache2.has(key))
          return cache2.get(key);
        var result = func.apply(this, args);
        return memoized.cache = cache2.set(key, result), result;
      };
      return memoized.cache = new (memoize.Cache || MapCache)(), memoized;
    }
    memoize.Cache = MapCache;
    function eq(value, other) {
      return value === other || value !== value && other !== other;
    }
    function isArguments(value) {
      return isArrayLikeObject(value) && hasOwnProperty.call(value, "callee") && (!propertyIsEnumerable.call(value, "callee") || objectToString.call(value) == argsTag);
    }
    var isArray = Array.isArray;
    function isArrayLike(value) {
      return value != null && isLength(value.length) && !isFunction(value);
    }
    function isArrayLikeObject(value) {
      return isObjectLike(value) && isArrayLike(value);
    }
    function isFunction(value) {
      var tag = isObject4(value) ? objectToString.call(value) : "";
      return tag == funcTag || tag == genTag;
    }
    function isLength(value) {
      return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
    }
    function isObject4(value) {
      var type = typeof value;
      return !!value && (type == "object" || type == "function");
    }
    function isObjectLike(value) {
      return !!value && typeof value == "object";
    }
    function isSymbol(value) {
      return typeof value == "symbol" || isObjectLike(value) && objectToString.call(value) == symbolTag;
    }
    var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
    function toString2(value) {
      return value == null ? "" : baseToString(value);
    }
    function get2(object, path3, defaultValue) {
      var result = object == null ? void 0 : baseGet(object, path3);
      return result === void 0 ? defaultValue : result;
    }
    function hasIn(object, path3) {
      return object != null && hasPath(object, path3, baseHasIn);
    }
    function keys(object) {
      return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
    }
    function identity(value) {
      return value;
    }
    function property(path3) {
      return isKey(path3) ? baseProperty(toKey(path3)) : basePropertyDeep(path3);
    }
    module.exports = sortBy3;
  }
});

// ../../node_modules/.pnpm/lodash._reinterpolate@3.0.0/node_modules/lodash._reinterpolate/index.js
var require_lodash8 = __commonJS({
  "../../node_modules/.pnpm/lodash._reinterpolate@3.0.0/node_modules/lodash._reinterpolate/index.js"(exports, module) {
    init_cjs_shims();
    var reInterpolate = /<%=([\s\S]+?)%>/g;
    module.exports = reInterpolate;
  }
});

// ../../node_modules/.pnpm/lodash.templatesettings@4.2.0/node_modules/lodash.templatesettings/index.js
var require_lodash9 = __commonJS({
  "../../node_modules/.pnpm/lodash.templatesettings@4.2.0/node_modules/lodash.templatesettings/index.js"(exports, module) {
    init_cjs_shims();
    var reInterpolate = require_lodash8(), INFINITY = 1 / 0, nullTag = "[object Null]", symbolTag = "[object Symbol]", undefinedTag = "[object Undefined]", reUnescapedHtml = /[&<>"']/g, reHasUnescapedHtml = RegExp(reUnescapedHtml.source), reEscape = /<%-([\s\S]+?)%>/g, reEvaluate = /<%([\s\S]+?)%>/g, htmlEscapes = {
      "&": "&amp;",
      "<": "&lt;",
      ">": "&gt;",
      '"': "&quot;",
      "'": "&#39;"
    }, freeGlobal = typeof global == "object" && global && global.Object === Object && global, freeSelf = typeof self == "object" && self && self.Object === Object && self, root = freeGlobal || freeSelf || Function("return this")();
    function arrayMap(array, iteratee) {
      for (var index = -1, length = array == null ? 0 : array.length, result = Array(length); ++index < length; )
        result[index] = iteratee(array[index], index, array);
      return result;
    }
    function basePropertyOf(object) {
      return function(key) {
        return object?.[key];
      };
    }
    var escapeHtmlChar = basePropertyOf(htmlEscapes), objectProto = Object.prototype, hasOwnProperty = objectProto.hasOwnProperty, nativeObjectToString = objectProto.toString, Symbol2 = root.Symbol, symToStringTag = Symbol2 ? Symbol2.toStringTag : void 0, symbolProto = Symbol2 ? Symbol2.prototype : void 0, symbolToString = symbolProto ? symbolProto.toString : void 0, templateSettings = {
      /**
       * Used to detect `data` property values to be HTML-escaped.
       *
       * @memberOf _.templateSettings
       * @type {RegExp}
       */
      escape: reEscape,
      /**
       * Used to detect code to be evaluated.
       *
       * @memberOf _.templateSettings
       * @type {RegExp}
       */
      evaluate: reEvaluate,
      /**
       * Used to detect `data` property values to inject.
       *
       * @memberOf _.templateSettings
       * @type {RegExp}
       */
      interpolate: reInterpolate,
      /**
       * Used to reference the data object in the template text.
       *
       * @memberOf _.templateSettings
       * @type {string}
       */
      variable: "",
      /**
       * Used to import variables into the compiled template.
       *
       * @memberOf _.templateSettings
       * @type {Object}
       */
      imports: {
        /**
         * A reference to the `lodash` function.
         *
         * @memberOf _.templateSettings.imports
         * @type {Function}
         */
        _: { escape: escape2 }
      }
    };
    function baseGetTag(value) {
      return value == null ? value === void 0 ? undefinedTag : nullTag : symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
    }
    function baseToString(value) {
      if (typeof value == "string")
        return value;
      if (isArray(value))
        return arrayMap(value, baseToString) + "";
      if (isSymbol(value))
        return symbolToString ? symbolToString.call(value) : "";
      var result = value + "";
      return result == "0" && 1 / value == -INFINITY ? "-0" : result;
    }
    function getRawTag(value) {
      var isOwn = hasOwnProperty.call(value, symToStringTag), tag = value[symToStringTag];
      try {
        value[symToStringTag] = void 0;
        var unmasked = !0;
      } catch {
      }
      var result = nativeObjectToString.call(value);
      return unmasked && (isOwn ? value[symToStringTag] = tag : delete value[symToStringTag]), result;
    }
    function objectToString(value) {
      return nativeObjectToString.call(value);
    }
    var isArray = Array.isArray;
    function isObjectLike(value) {
      return value != null && typeof value == "object";
    }
    function isSymbol(value) {
      return typeof value == "symbol" || isObjectLike(value) && baseGetTag(value) == symbolTag;
    }
    function toString2(value) {
      return value == null ? "" : baseToString(value);
    }
    function escape2(string) {
      return string = toString2(string), string && reHasUnescapedHtml.test(string) ? string.replace(reUnescapedHtml, escapeHtmlChar) : string;
    }
    module.exports = templateSettings;
  }
});

// ../../node_modules/.pnpm/lodash.template@4.5.0/node_modules/lodash.template/index.js
var require_lodash10 = __commonJS({
  "../../node_modules/.pnpm/lodash.template@4.5.0/node_modules/lodash.template/index.js"(exports, module) {
    init_cjs_shims();
    var reInterpolate = require_lodash8(), templateSettings = require_lodash9(), HOT_COUNT = 800, HOT_SPAN = 16, INFINITY = 1 / 0, MAX_SAFE_INTEGER = 9007199254740991, argsTag = "[object Arguments]", arrayTag = "[object Array]", asyncTag = "[object AsyncFunction]", boolTag = "[object Boolean]", dateTag = "[object Date]", domExcTag = "[object DOMException]", errorTag = "[object Error]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", mapTag = "[object Map]", numberTag = "[object Number]", nullTag = "[object Null]", objectTag = "[object Object]", proxyTag = "[object Proxy]", regexpTag = "[object RegExp]", setTag = "[object Set]", stringTag = "[object String]", symbolTag = "[object Symbol]", undefinedTag = "[object Undefined]", weakMapTag = "[object WeakMap]", arrayBufferTag = "[object ArrayBuffer]", dataViewTag = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]", reEmptyStringLeading = /\b__p \+= '';/g, reEmptyStringMiddle = /\b(__p \+=) '' \+/g, reEmptyStringTrailing = /(__e\(.*?\)|\b__t\)) \+\n'';/g, reRegExpChar = /[\\^$.*+?()[\]{}|]/g, reEsTemplate = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, reIsHostCtor = /^\[object .+?Constructor\]$/, reIsUint = /^(?:0|[1-9]\d*)$/, reNoMatch = /($^)/, reUnescapedString = /['\n\r\u2028\u2029\\]/g, typedArrayTags = {};
    typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = !0;
    typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = !1;
    var stringEscapes = {
      "\\": "\\",
      "'": "'",
      "\n": "n",
      "\r": "r",
      "\u2028": "u2028",
      "\u2029": "u2029"
    }, freeGlobal = typeof global == "object" && global && global.Object === Object && global, freeSelf = typeof self == "object" && self && self.Object === Object && self, root = freeGlobal || freeSelf || Function("return this")(), freeExports = typeof exports == "object" && exports && !exports.nodeType && exports, freeModule = freeExports && typeof module == "object" && module && !module.nodeType && module, moduleExports = freeModule && freeModule.exports === freeExports, freeProcess = moduleExports && freeGlobal.process, nodeUtil = function() {
      try {
        var types = freeModule && freeModule.require && freeModule.require("util").types;
        return types || freeProcess && freeProcess.binding && freeProcess.binding("util");
      } catch {
      }
    }(), nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
    function apply(func, thisArg, args) {
      switch (args.length) {
        case 0:
          return func.call(thisArg);
        case 1:
          return func.call(thisArg, args[0]);
        case 2:
          return func.call(thisArg, args[0], args[1]);
        case 3:
          return func.call(thisArg, args[0], args[1], args[2]);
      }
      return func.apply(thisArg, args);
    }
    function arrayMap(array, iteratee) {
      for (var index = -1, length = array == null ? 0 : array.length, result = Array(length); ++index < length; )
        result[index] = iteratee(array[index], index, array);
      return result;
    }
    function baseTimes(n, iteratee) {
      for (var index = -1, result = Array(n); ++index < n; )
        result[index] = iteratee(index);
      return result;
    }
    function baseUnary(func) {
      return function(value) {
        return func(value);
      };
    }
    function baseValues(object, props) {
      return arrayMap(props, function(key) {
        return object[key];
      });
    }
    function escapeStringChar(chr) {
      return "\\" + stringEscapes[chr];
    }
    function getValue(object, key) {
      return object?.[key];
    }
    function overArg(func, transform2) {
      return function(arg) {
        return func(transform2(arg));
      };
    }
    var funcProto = Function.prototype, objectProto = Object.prototype, coreJsData = root["__core-js_shared__"], funcToString = funcProto.toString, hasOwnProperty = objectProto.hasOwnProperty, maskSrcKey = function() {
      var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
      return uid ? "Symbol(src)_1." + uid : "";
    }(), nativeObjectToString = objectProto.toString, objectCtorString = funcToString.call(Object), reIsNative = RegExp(
      "^" + funcToString.call(hasOwnProperty).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
    ), Buffer2 = moduleExports ? root.Buffer : void 0, Symbol2 = root.Symbol, getPrototype = overArg(Object.getPrototypeOf, Object), propertyIsEnumerable = objectProto.propertyIsEnumerable, symToStringTag = Symbol2 ? Symbol2.toStringTag : void 0, defineProperty = function() {
      try {
        var func = getNative(Object, "defineProperty");
        return func({}, "", {}), func;
      } catch {
      }
    }(), nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : void 0, nativeKeys = overArg(Object.keys, Object), nativeMax = Math.max, nativeNow = Date.now, symbolProto = Symbol2 ? Symbol2.prototype : void 0, symbolToString = symbolProto ? symbolProto.toString : void 0;
    function arrayLikeKeys(value, inherited) {
      var isArr = isArray(value), isArg = !isArr && isArguments(value), isBuff = !isArr && !isArg && isBuffer(value), isType2 = !isArr && !isArg && !isBuff && isTypedArray(value), skipIndexes = isArr || isArg || isBuff || isType2, result = skipIndexes ? baseTimes(value.length, String) : [], length = result.length;
      for (var key in value)
        (inherited || hasOwnProperty.call(value, key)) && !(skipIndexes && // Safari 9 has enumerable `arguments.length` in strict mode.
        (key == "length" || // Node.js 0.10 has enumerable non-index properties on buffers.
        isBuff && (key == "offset" || key == "parent") || // PhantomJS 2 has enumerable non-index properties on typed arrays.
        isType2 && (key == "buffer" || key == "byteLength" || key == "byteOffset") || // Skip index properties.
        isIndex(key, length))) && result.push(key);
      return result;
    }
    function assignValue(object, key, value) {
      var objValue = object[key];
      (!(hasOwnProperty.call(object, key) && eq(objValue, value)) || value === void 0 && !(key in object)) && baseAssignValue(object, key, value);
    }
    function baseAssignValue(object, key, value) {
      key == "__proto__" && defineProperty ? defineProperty(object, key, {
        configurable: !0,
        enumerable: !0,
        value,
        writable: !0
      }) : object[key] = value;
    }
    function baseGetTag(value) {
      return value == null ? value === void 0 ? undefinedTag : nullTag : symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
    }
    function baseIsArguments(value) {
      return isObjectLike(value) && baseGetTag(value) == argsTag;
    }
    function baseIsNative(value) {
      if (!isObject4(value) || isMasked(value))
        return !1;
      var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
      return pattern.test(toSource(value));
    }
    function baseIsTypedArray(value) {
      return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
    }
    function baseKeys(object) {
      if (!isPrototype(object))
        return nativeKeys(object);
      var result = [];
      for (var key in Object(object))
        hasOwnProperty.call(object, key) && key != "constructor" && result.push(key);
      return result;
    }
    function baseKeysIn(object) {
      if (!isObject4(object))
        return nativeKeysIn(object);
      var isProto = isPrototype(object), result = [];
      for (var key in object)
        key == "constructor" && (isProto || !hasOwnProperty.call(object, key)) || result.push(key);
      return result;
    }
    function baseRest(func, start) {
      return setToString(overRest(func, start, identity), func + "");
    }
    var baseSetToString = defineProperty ? function(func, string) {
      return defineProperty(func, "toString", {
        configurable: !0,
        enumerable: !1,
        value: constant(string),
        writable: !0
      });
    } : identity;
    function baseToString(value) {
      if (typeof value == "string")
        return value;
      if (isArray(value))
        return arrayMap(value, baseToString) + "";
      if (isSymbol(value))
        return symbolToString ? symbolToString.call(value) : "";
      var result = value + "";
      return result == "0" && 1 / value == -INFINITY ? "-0" : result;
    }
    function copyObject(source, props, object, customizer) {
      var isNew = !object;
      object || (object = {});
      for (var index = -1, length = props.length; ++index < length; ) {
        var key = props[index], newValue = customizer ? customizer(object[key], source[key], key, object, source) : void 0;
        newValue === void 0 && (newValue = source[key]), isNew ? baseAssignValue(object, key, newValue) : assignValue(object, key, newValue);
      }
      return object;
    }
    function createAssigner(assigner) {
      return baseRest(function(object, sources2) {
        var index = -1, length = sources2.length, customizer = length > 1 ? sources2[length - 1] : void 0, guard = length > 2 ? sources2[2] : void 0;
        for (customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : void 0, guard && isIterateeCall(sources2[0], sources2[1], guard) && (customizer = length < 3 ? void 0 : customizer, length = 1), object = Object(object); ++index < length; ) {
          var source = sources2[index];
          source && assigner(object, source, index, customizer);
        }
        return object;
      });
    }
    function customDefaultsAssignIn(objValue, srcValue, key, object) {
      return objValue === void 0 || eq(objValue, objectProto[key]) && !hasOwnProperty.call(object, key) ? srcValue : objValue;
    }
    function getNative(object, key) {
      var value = getValue(object, key);
      return baseIsNative(value) ? value : void 0;
    }
    function getRawTag(value) {
      var isOwn = hasOwnProperty.call(value, symToStringTag), tag = value[symToStringTag];
      try {
        value[symToStringTag] = void 0;
        var unmasked = !0;
      } catch {
      }
      var result = nativeObjectToString.call(value);
      return unmasked && (isOwn ? value[symToStringTag] = tag : delete value[symToStringTag]), result;
    }
    function isIndex(value, length) {
      var type = typeof value;
      return length = length ?? MAX_SAFE_INTEGER, !!length && (type == "number" || type != "symbol" && reIsUint.test(value)) && value > -1 && value % 1 == 0 && value < length;
    }
    function isIterateeCall(value, index, object) {
      if (!isObject4(object))
        return !1;
      var type = typeof index;
      return (type == "number" ? isArrayLike(object) && isIndex(index, object.length) : type == "string" && index in object) ? eq(object[index], value) : !1;
    }
    function isMasked(func) {
      return !!maskSrcKey && maskSrcKey in func;
    }
    function isPrototype(value) {
      var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto;
      return value === proto;
    }
    function nativeKeysIn(object) {
      var result = [];
      if (object != null)
        for (var key in Object(object))
          result.push(key);
      return result;
    }
    function objectToString(value) {
      return nativeObjectToString.call(value);
    }
    function overRest(func, start, transform2) {
      return start = nativeMax(start === void 0 ? func.length - 1 : start, 0), function() {
        for (var args = arguments, index = -1, length = nativeMax(args.length - start, 0), array = Array(length); ++index < length; )
          array[index] = args[start + index];
        index = -1;
        for (var otherArgs = Array(start + 1); ++index < start; )
          otherArgs[index] = args[index];
        return otherArgs[start] = transform2(array), apply(func, this, otherArgs);
      };
    }
    var setToString = shortOut(baseSetToString);
    function shortOut(func) {
      var count = 0, lastCalled = 0;
      return function() {
        var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
        if (lastCalled = stamp, remaining > 0) {
          if (++count >= HOT_COUNT)
            return arguments[0];
        } else
          count = 0;
        return func.apply(void 0, arguments);
      };
    }
    function toSource(func) {
      if (func != null) {
        try {
          return funcToString.call(func);
        } catch {
        }
        try {
          return func + "";
        } catch {
        }
      }
      return "";
    }
    function eq(value, other) {
      return value === other || value !== value && other !== other;
    }
    var isArguments = baseIsArguments(/* @__PURE__ */ function() {
      return arguments;
    }()) ? baseIsArguments : function(value) {
      return isObjectLike(value) && hasOwnProperty.call(value, "callee") && !propertyIsEnumerable.call(value, "callee");
    }, isArray = Array.isArray;
    function isArrayLike(value) {
      return value != null && isLength(value.length) && !isFunction(value);
    }
    var isBuffer = nativeIsBuffer || stubFalse;
    function isError2(value) {
      if (!isObjectLike(value))
        return !1;
      var tag = baseGetTag(value);
      return tag == errorTag || tag == domExcTag || typeof value.message == "string" && typeof value.name == "string" && !isPlainObject(value);
    }
    function isFunction(value) {
      if (!isObject4(value))
        return !1;
      var tag = baseGetTag(value);
      return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
    }
    function isLength(value) {
      return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
    }
    function isObject4(value) {
      var type = typeof value;
      return value != null && (type == "object" || type == "function");
    }
    function isObjectLike(value) {
      return value != null && typeof value == "object";
    }
    function isPlainObject(value) {
      if (!isObjectLike(value) || baseGetTag(value) != objectTag)
        return !1;
      var proto = getPrototype(value);
      if (proto === null)
        return !0;
      var Ctor = hasOwnProperty.call(proto, "constructor") && proto.constructor;
      return typeof Ctor == "function" && Ctor instanceof Ctor && funcToString.call(Ctor) == objectCtorString;
    }
    function isSymbol(value) {
      return typeof value == "symbol" || isObjectLike(value) && baseGetTag(value) == symbolTag;
    }
    var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
    function toString2(value) {
      return value == null ? "" : baseToString(value);
    }
    var assignInWith = createAssigner(function(object, source, srcIndex, customizer) {
      copyObject(source, keysIn(source), object, customizer);
    });
    function keys(object) {
      return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
    }
    function keysIn(object) {
      return isArrayLike(object) ? arrayLikeKeys(object, !0) : baseKeysIn(object);
    }
    function template2(string, options, guard) {
      var settings = templateSettings.imports._.templateSettings || templateSettings;
      guard && isIterateeCall(string, options, guard) && (options = void 0), string = toString2(string), options = assignInWith({}, options, settings, customDefaultsAssignIn);
      var imports = assignInWith({}, options.imports, settings.imports, customDefaultsAssignIn), importsKeys = keys(imports), importsValues = baseValues(imports, importsKeys), isEscaping, isEvaluating, index = 0, interpolate = options.interpolate || reNoMatch, source = "__p += '", reDelimiters = RegExp(
        (options.escape || reNoMatch).source + "|" + interpolate.source + "|" + (interpolate === reInterpolate ? reEsTemplate : reNoMatch).source + "|" + (options.evaluate || reNoMatch).source + "|$",
        "g"
      ), sourceURL = hasOwnProperty.call(options, "sourceURL") ? "//# sourceURL=" + (options.sourceURL + "").replace(/[\r\n]/g, " ") + `
` : "";
      string.replace(reDelimiters, function(match2, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset) {
        return interpolateValue || (interpolateValue = esTemplateValue), source += string.slice(index, offset).replace(reUnescapedString, escapeStringChar), escapeValue && (isEscaping = !0, source += `' +
__e(` + escapeValue + `) +
'`), evaluateValue && (isEvaluating = !0, source += `';
` + evaluateValue + `;
__p += '`), interpolateValue && (source += `' +
((__t = (` + interpolateValue + `)) == null ? '' : __t) +
'`), index = offset + match2.length, match2;
      }), source += `';
`;
      var variable = hasOwnProperty.call(options, "variable") && options.variable;
      variable || (source = `with (obj) {
` + source + `
}
`), source = (isEvaluating ? source.replace(reEmptyStringLeading, "") : source).replace(reEmptyStringMiddle, "$1").replace(reEmptyStringTrailing, "$1;"), source = "function(" + (variable || "obj") + `) {
` + (variable ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (isEscaping ? ", __e = _.escape" : "") + (isEvaluating ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + source + `return __p
}`;
      var result = attempt(function() {
        return Function(importsKeys, sourceURL + "return " + source).apply(void 0, importsValues);
      });
      if (result.source = source, isError2(result))
        throw result;
      return result;
    }
    var attempt = baseRest(function(func, args) {
      try {
        return apply(func, void 0, args);
      } catch (e) {
        return isError2(e) ? e : new Error(e);
      }
    });
    function constant(value) {
      return function() {
        return value;
      };
    }
    function identity(value) {
      return value;
    }
    function stubFalse() {
      return !1;
    }
    module.exports = template2;
  }
});

// ../../node_modules/.pnpm/lodash.uniqby@4.7.0/node_modules/lodash.uniqby/index.js
var require_lodash11 = __commonJS({
  "../../node_modules/.pnpm/lodash.uniqby@4.7.0/node_modules/lodash.uniqby/index.js"(exports, module) {
    init_cjs_shims();
    var LARGE_ARRAY_SIZE = 200, FUNC_ERROR_TEXT = "Expected a function", HASH_UNDEFINED = "__lodash_hash_undefined__", UNORDERED_COMPARE_FLAG = 1, PARTIAL_COMPARE_FLAG = 2, INFINITY = 1 / 0, MAX_SAFE_INTEGER = 9007199254740991, argsTag = "[object Arguments]", arrayTag = "[object Array]", boolTag = "[object Boolean]", dateTag = "[object Date]", errorTag = "[object Error]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", mapTag = "[object Map]", numberTag = "[object Number]", objectTag = "[object Object]", promiseTag = "[object Promise]", regexpTag = "[object RegExp]", setTag = "[object Set]", stringTag = "[object String]", symbolTag = "[object Symbol]", weakMapTag = "[object WeakMap]", arrayBufferTag = "[object ArrayBuffer]", dataViewTag = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]", reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/, reLeadingDot = /^\./, rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, reRegExpChar = /[\\^$.*+?()[\]{}|]/g, reEscapeChar = /\\(\\)?/g, reIsHostCtor = /^\[object .+?Constructor\]$/, reIsUint = /^(?:0|[1-9]\d*)$/, typedArrayTags = {};
    typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = !0;
    typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = !1;
    var freeGlobal = typeof global == "object" && global && global.Object === Object && global, freeSelf = typeof self == "object" && self && self.Object === Object && self, root = freeGlobal || freeSelf || Function("return this")(), freeExports = typeof exports == "object" && exports && !exports.nodeType && exports, freeModule = freeExports && typeof module == "object" && module && !module.nodeType && module, moduleExports = freeModule && freeModule.exports === freeExports, freeProcess = moduleExports && freeGlobal.process, nodeUtil = function() {
      try {
        return freeProcess && freeProcess.binding("util");
      } catch {
      }
    }(), nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
    function arrayIncludes(array, value) {
      var length = array ? array.length : 0;
      return !!length && baseIndexOf(array, value, 0) > -1;
    }
    function arrayIncludesWith(array, value, comparator) {
      for (var index = -1, length = array ? array.length : 0; ++index < length; )
        if (comparator(value, array[index]))
          return !0;
      return !1;
    }
    function arraySome(array, predicate) {
      for (var index = -1, length = array ? array.length : 0; ++index < length; )
        if (predicate(array[index], index, array))
          return !0;
      return !1;
    }
    function baseFindIndex(array, predicate, fromIndex, fromRight) {
      for (var length = array.length, index = fromIndex + (fromRight ? 1 : -1); fromRight ? index-- : ++index < length; )
        if (predicate(array[index], index, array))
          return index;
      return -1;
    }
    function baseIndexOf(array, value, fromIndex) {
      if (value !== value)
        return baseFindIndex(array, baseIsNaN, fromIndex);
      for (var index = fromIndex - 1, length = array.length; ++index < length; )
        if (array[index] === value)
          return index;
      return -1;
    }
    function baseIsNaN(value) {
      return value !== value;
    }
    function baseProperty(key) {
      return function(object) {
        return object?.[key];
      };
    }
    function baseTimes(n, iteratee) {
      for (var index = -1, result = Array(n); ++index < n; )
        result[index] = iteratee(index);
      return result;
    }
    function baseUnary(func) {
      return function(value) {
        return func(value);
      };
    }
    function cacheHas(cache2, key) {
      return cache2.has(key);
    }
    function getValue(object, key) {
      return object?.[key];
    }
    function isHostObject(value) {
      var result = !1;
      if (value != null && typeof value.toString != "function")
        try {
          result = !!(value + "");
        } catch {
        }
      return result;
    }
    function mapToArray(map) {
      var index = -1, result = Array(map.size);
      return map.forEach(function(value, key) {
        result[++index] = [key, value];
      }), result;
    }
    function overArg(func, transform2) {
      return function(arg) {
        return func(transform2(arg));
      };
    }
    function setToArray(set2) {
      var index = -1, result = Array(set2.size);
      return set2.forEach(function(value) {
        result[++index] = value;
      }), result;
    }
    var arrayProto = Array.prototype, funcProto = Function.prototype, objectProto = Object.prototype, coreJsData = root["__core-js_shared__"], maskSrcKey = function() {
      var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
      return uid ? "Symbol(src)_1." + uid : "";
    }(), funcToString = funcProto.toString, hasOwnProperty = objectProto.hasOwnProperty, objectToString = objectProto.toString, reIsNative = RegExp(
      "^" + funcToString.call(hasOwnProperty).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
    ), Symbol2 = root.Symbol, Uint8Array2 = root.Uint8Array, propertyIsEnumerable = objectProto.propertyIsEnumerable, splice = arrayProto.splice, nativeKeys = overArg(Object.keys, Object), DataView2 = getNative(root, "DataView"), Map2 = getNative(root, "Map"), Promise2 = getNative(root, "Promise"), Set2 = getNative(root, "Set"), WeakMap2 = getNative(root, "WeakMap"), nativeCreate = getNative(Object, "create"), dataViewCtorString = toSource(DataView2), mapCtorString = toSource(Map2), promiseCtorString = toSource(Promise2), setCtorString = toSource(Set2), weakMapCtorString = toSource(WeakMap2), symbolProto = Symbol2 ? Symbol2.prototype : void 0, symbolValueOf = symbolProto ? symbolProto.valueOf : void 0, symbolToString = symbolProto ? symbolProto.toString : void 0;
    function Hash(entries) {
      var index = -1, length = entries ? entries.length : 0;
      for (this.clear(); ++index < length; ) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function hashClear() {
      this.__data__ = nativeCreate ? nativeCreate(null) : {};
    }
    function hashDelete(key) {
      return this.has(key) && delete this.__data__[key];
    }
    function hashGet(key) {
      var data = this.__data__;
      if (nativeCreate) {
        var result = data[key];
        return result === HASH_UNDEFINED ? void 0 : result;
      }
      return hasOwnProperty.call(data, key) ? data[key] : void 0;
    }
    function hashHas(key) {
      var data = this.__data__;
      return nativeCreate ? data[key] !== void 0 : hasOwnProperty.call(data, key);
    }
    function hashSet(key, value) {
      var data = this.__data__;
      return data[key] = nativeCreate && value === void 0 ? HASH_UNDEFINED : value, this;
    }
    Hash.prototype.clear = hashClear;
    Hash.prototype.delete = hashDelete;
    Hash.prototype.get = hashGet;
    Hash.prototype.has = hashHas;
    Hash.prototype.set = hashSet;
    function ListCache(entries) {
      var index = -1, length = entries ? entries.length : 0;
      for (this.clear(); ++index < length; ) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function listCacheClear() {
      this.__data__ = [];
    }
    function listCacheDelete(key) {
      var data = this.__data__, index = assocIndexOf(data, key);
      if (index < 0)
        return !1;
      var lastIndex = data.length - 1;
      return index == lastIndex ? data.pop() : splice.call(data, index, 1), !0;
    }
    function listCacheGet(key) {
      var data = this.__data__, index = assocIndexOf(data, key);
      return index < 0 ? void 0 : data[index][1];
    }
    function listCacheHas(key) {
      return assocIndexOf(this.__data__, key) > -1;
    }
    function listCacheSet(key, value) {
      var data = this.__data__, index = assocIndexOf(data, key);
      return index < 0 ? data.push([key, value]) : data[index][1] = value, this;
    }
    ListCache.prototype.clear = listCacheClear;
    ListCache.prototype.delete = listCacheDelete;
    ListCache.prototype.get = listCacheGet;
    ListCache.prototype.has = listCacheHas;
    ListCache.prototype.set = listCacheSet;
    function MapCache(entries) {
      var index = -1, length = entries ? entries.length : 0;
      for (this.clear(); ++index < length; ) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }
    function mapCacheClear() {
      this.__data__ = {
        hash: new Hash(),
        map: new (Map2 || ListCache)(),
        string: new Hash()
      };
    }
    function mapCacheDelete(key) {
      return getMapData(this, key).delete(key);
    }
    function mapCacheGet(key) {
      return getMapData(this, key).get(key);
    }
    function mapCacheHas(key) {
      return getMapData(this, key).has(key);
    }
    function mapCacheSet(key, value) {
      return getMapData(this, key).set(key, value), this;
    }
    MapCache.prototype.clear = mapCacheClear;
    MapCache.prototype.delete = mapCacheDelete;
    MapCache.prototype.get = mapCacheGet;
    MapCache.prototype.has = mapCacheHas;
    MapCache.prototype.set = mapCacheSet;
    function SetCache(values) {
      var index = -1, length = values ? values.length : 0;
      for (this.__data__ = new MapCache(); ++index < length; )
        this.add(values[index]);
    }
    function setCacheAdd(value) {
      return this.__data__.set(value, HASH_UNDEFINED), this;
    }
    function setCacheHas(value) {
      return this.__data__.has(value);
    }
    SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
    SetCache.prototype.has = setCacheHas;
    function Stack(entries) {
      this.__data__ = new ListCache(entries);
    }
    function stackClear() {
      this.__data__ = new ListCache();
    }
    function stackDelete(key) {
      return this.__data__.delete(key);
    }
    function stackGet(key) {
      return this.__data__.get(key);
    }
    function stackHas(key) {
      return this.__data__.has(key);
    }
    function stackSet(key, value) {
      var cache2 = this.__data__;
      if (cache2 instanceof ListCache) {
        var pairs = cache2.__data__;
        if (!Map2 || pairs.length < LARGE_ARRAY_SIZE - 1)
          return pairs.push([key, value]), this;
        cache2 = this.__data__ = new MapCache(pairs);
      }
      return cache2.set(key, value), this;
    }
    Stack.prototype.clear = stackClear;
    Stack.prototype.delete = stackDelete;
    Stack.prototype.get = stackGet;
    Stack.prototype.has = stackHas;
    Stack.prototype.set = stackSet;
    function arrayLikeKeys(value, inherited) {
      var result = isArray(value) || isArguments(value) ? baseTimes(value.length, String) : [], length = result.length, skipIndexes = !!length;
      for (var key in value)
        (inherited || hasOwnProperty.call(value, key)) && !(skipIndexes && (key == "length" || isIndex(key, length))) && result.push(key);
      return result;
    }
    function assocIndexOf(array, key) {
      for (var length = array.length; length--; )
        if (eq(array[length][0], key))
          return length;
      return -1;
    }
    function baseGet(object, path3) {
      path3 = isKey(path3, object) ? [path3] : castPath(path3);
      for (var index = 0, length = path3.length; object != null && index < length; )
        object = object[toKey(path3[index++])];
      return index && index == length ? object : void 0;
    }
    function baseGetTag(value) {
      return objectToString.call(value);
    }
    function baseHasIn(object, key) {
      return object != null && key in Object(object);
    }
    function baseIsEqual(value, other, customizer, bitmask, stack) {
      return value === other ? !0 : value == null || other == null || !isObject4(value) && !isObjectLike(other) ? value !== value && other !== other : baseIsEqualDeep(value, other, baseIsEqual, customizer, bitmask, stack);
    }
    function baseIsEqualDeep(object, other, equalFunc, customizer, bitmask, stack) {
      var objIsArr = isArray(object), othIsArr = isArray(other), objTag = arrayTag, othTag = arrayTag;
      objIsArr || (objTag = getTag(object), objTag = objTag == argsTag ? objectTag : objTag), othIsArr || (othTag = getTag(other), othTag = othTag == argsTag ? objectTag : othTag);
      var objIsObj = objTag == objectTag && !isHostObject(object), othIsObj = othTag == objectTag && !isHostObject(other), isSameTag = objTag == othTag;
      if (isSameTag && !objIsObj)
        return stack || (stack = new Stack()), objIsArr || isTypedArray(object) ? equalArrays(object, other, equalFunc, customizer, bitmask, stack) : equalByTag(object, other, objTag, equalFunc, customizer, bitmask, stack);
      if (!(bitmask & PARTIAL_COMPARE_FLAG)) {
        var objIsWrapped = objIsObj && hasOwnProperty.call(object, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty.call(other, "__wrapped__");
        if (objIsWrapped || othIsWrapped) {
          var objUnwrapped = objIsWrapped ? object.value() : object, othUnwrapped = othIsWrapped ? other.value() : other;
          return stack || (stack = new Stack()), equalFunc(objUnwrapped, othUnwrapped, customizer, bitmask, stack);
        }
      }
      return isSameTag ? (stack || (stack = new Stack()), equalObjects(object, other, equalFunc, customizer, bitmask, stack)) : !1;
    }
    function baseIsMatch(object, source, matchData, customizer) {
      var index = matchData.length, length = index, noCustomizer = !customizer;
      if (object == null)
        return !length;
      for (object = Object(object); index--; ) {
        var data = matchData[index];
        if (noCustomizer && data[2] ? data[1] !== object[data[0]] : !(data[0] in object))
          return !1;
      }
      for (; ++index < length; ) {
        data = matchData[index];
        var key = data[0], objValue = object[key], srcValue = data[1];
        if (noCustomizer && data[2]) {
          if (objValue === void 0 && !(key in object))
            return !1;
        } else {
          var stack = new Stack();
          if (customizer)
            var result = customizer(objValue, srcValue, key, object, source, stack);
          if (!(result === void 0 ? baseIsEqual(srcValue, objValue, customizer, UNORDERED_COMPARE_FLAG | PARTIAL_COMPARE_FLAG, stack) : result))
            return !1;
        }
      }
      return !0;
    }
    function baseIsNative(value) {
      if (!isObject4(value) || isMasked(value))
        return !1;
      var pattern = isFunction(value) || isHostObject(value) ? reIsNative : reIsHostCtor;
      return pattern.test(toSource(value));
    }
    function baseIsTypedArray(value) {
      return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[objectToString.call(value)];
    }
    function baseIteratee(value) {
      return typeof value == "function" ? value : value == null ? identity : typeof value == "object" ? isArray(value) ? baseMatchesProperty(value[0], value[1]) : baseMatches(value) : property(value);
    }
    function baseKeys(object) {
      if (!isPrototype(object))
        return nativeKeys(object);
      var result = [];
      for (var key in Object(object))
        hasOwnProperty.call(object, key) && key != "constructor" && result.push(key);
      return result;
    }
    function baseMatches(source) {
      var matchData = getMatchData(source);
      return matchData.length == 1 && matchData[0][2] ? matchesStrictComparable(matchData[0][0], matchData[0][1]) : function(object) {
        return object === source || baseIsMatch(object, source, matchData);
      };
    }
    function baseMatchesProperty(path3, srcValue) {
      return isKey(path3) && isStrictComparable(srcValue) ? matchesStrictComparable(toKey(path3), srcValue) : function(object) {
        var objValue = get2(object, path3);
        return objValue === void 0 && objValue === srcValue ? hasIn(object, path3) : baseIsEqual(srcValue, objValue, void 0, UNORDERED_COMPARE_FLAG | PARTIAL_COMPARE_FLAG);
      };
    }
    function basePropertyDeep(path3) {
      return function(object) {
        return baseGet(object, path3);
      };
    }
    function baseToString(value) {
      if (typeof value == "string")
        return value;
      if (isSymbol(value))
        return symbolToString ? symbolToString.call(value) : "";
      var result = value + "";
      return result == "0" && 1 / value == -INFINITY ? "-0" : result;
    }
    function baseUniq(array, iteratee, comparator) {
      var index = -1, includes = arrayIncludes, length = array.length, isCommon = !0, result = [], seen = result;
      if (comparator)
        isCommon = !1, includes = arrayIncludesWith;
      else if (length >= LARGE_ARRAY_SIZE) {
        var set2 = iteratee ? null : createSet(array);
        if (set2)
          return setToArray(set2);
        isCommon = !1, includes = cacheHas, seen = new SetCache();
      } else
        seen = iteratee ? [] : result;
      outer:
        for (; ++index < length; ) {
          var value = array[index], computed = iteratee ? iteratee(value) : value;
          if (value = comparator || value !== 0 ? value : 0, isCommon && computed === computed) {
            for (var seenIndex = seen.length; seenIndex--; )
              if (seen[seenIndex] === computed)
                continue outer;
            iteratee && seen.push(computed), result.push(value);
          } else
            includes(seen, computed, comparator) || (seen !== result && seen.push(computed), result.push(value));
        }
      return result;
    }
    function castPath(value) {
      return isArray(value) ? value : stringToPath(value);
    }
    var createSet = Set2 && 1 / setToArray(new Set2([, -0]))[1] == INFINITY ? function(values) {
      return new Set2(values);
    } : noop;
    function equalArrays(array, other, equalFunc, customizer, bitmask, stack) {
      var isPartial = bitmask & PARTIAL_COMPARE_FLAG, arrLength = array.length, othLength = other.length;
      if (arrLength != othLength && !(isPartial && othLength > arrLength))
        return !1;
      var stacked = stack.get(array);
      if (stacked && stack.get(other))
        return stacked == other;
      var index = -1, result = !0, seen = bitmask & UNORDERED_COMPARE_FLAG ? new SetCache() : void 0;
      for (stack.set(array, other), stack.set(other, array); ++index < arrLength; ) {
        var arrValue = array[index], othValue = other[index];
        if (customizer)
          var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
        if (compared !== void 0) {
          if (compared)
            continue;
          result = !1;
          break;
        }
        if (seen) {
          if (!arraySome(other, function(othValue2, othIndex) {
            if (!seen.has(othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, customizer, bitmask, stack)))
              return seen.add(othIndex);
          })) {
            result = !1;
            break;
          }
        } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, customizer, bitmask, stack))) {
          result = !1;
          break;
        }
      }
      return stack.delete(array), stack.delete(other), result;
    }
    function equalByTag(object, other, tag, equalFunc, customizer, bitmask, stack) {
      switch (tag) {
        case dataViewTag:
          if (object.byteLength != other.byteLength || object.byteOffset != other.byteOffset)
            return !1;
          object = object.buffer, other = other.buffer;
        case arrayBufferTag:
          return !(object.byteLength != other.byteLength || !equalFunc(new Uint8Array2(object), new Uint8Array2(other)));
        case boolTag:
        case dateTag:
        case numberTag:
          return eq(+object, +other);
        case errorTag:
          return object.name == other.name && object.message == other.message;
        case regexpTag:
        case stringTag:
          return object == other + "";
        case mapTag:
          var convert = mapToArray;
        case setTag:
          var isPartial = bitmask & PARTIAL_COMPARE_FLAG;
          if (convert || (convert = setToArray), object.size != other.size && !isPartial)
            return !1;
          var stacked = stack.get(object);
          if (stacked)
            return stacked == other;
          bitmask |= UNORDERED_COMPARE_FLAG, stack.set(object, other);
          var result = equalArrays(convert(object), convert(other), equalFunc, customizer, bitmask, stack);
          return stack.delete(object), result;
        case symbolTag:
          if (symbolValueOf)
            return symbolValueOf.call(object) == symbolValueOf.call(other);
      }
      return !1;
    }
    function equalObjects(object, other, equalFunc, customizer, bitmask, stack) {
      var isPartial = bitmask & PARTIAL_COMPARE_FLAG, objProps = keys(object), objLength = objProps.length, othProps = keys(other), othLength = othProps.length;
      if (objLength != othLength && !isPartial)
        return !1;
      for (var index = objLength; index--; ) {
        var key = objProps[index];
        if (!(isPartial ? key in other : hasOwnProperty.call(other, key)))
          return !1;
      }
      var stacked = stack.get(object);
      if (stacked && stack.get(other))
        return stacked == other;
      var result = !0;
      stack.set(object, other), stack.set(other, object);
      for (var skipCtor = isPartial; ++index < objLength; ) {
        key = objProps[index];
        var objValue = object[key], othValue = other[key];
        if (customizer)
          var compared = isPartial ? customizer(othValue, objValue, key, other, object, stack) : customizer(objValue, othValue, key, object, other, stack);
        if (!(compared === void 0 ? objValue === othValue || equalFunc(objValue, othValue, customizer, bitmask, stack) : compared)) {
          result = !1;
          break;
        }
        skipCtor || (skipCtor = key == "constructor");
      }
      if (result && !skipCtor) {
        var objCtor = object.constructor, othCtor = other.constructor;
        objCtor != othCtor && "constructor" in object && "constructor" in other && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor) && (result = !1);
      }
      return stack.delete(object), stack.delete(other), result;
    }
    function getMapData(map, key) {
      var data = map.__data__;
      return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
    }
    function getMatchData(object) {
      for (var result = keys(object), length = result.length; length--; ) {
        var key = result[length], value = object[key];
        result[length] = [key, value, isStrictComparable(value)];
      }
      return result;
    }
    function getNative(object, key) {
      var value = getValue(object, key);
      return baseIsNative(value) ? value : void 0;
    }
    var getTag = baseGetTag;
    (DataView2 && getTag(new DataView2(new ArrayBuffer(1))) != dataViewTag || Map2 && getTag(new Map2()) != mapTag || Promise2 && getTag(Promise2.resolve()) != promiseTag || Set2 && getTag(new Set2()) != setTag || WeakMap2 && getTag(new WeakMap2()) != weakMapTag) && (getTag = function(value) {
      var result = objectToString.call(value), Ctor = result == objectTag ? value.constructor : void 0, ctorString = Ctor ? toSource(Ctor) : void 0;
      if (ctorString)
        switch (ctorString) {
          case dataViewCtorString:
            return dataViewTag;
          case mapCtorString:
            return mapTag;
          case promiseCtorString:
            return promiseTag;
          case setCtorString:
            return setTag;
          case weakMapCtorString:
            return weakMapTag;
        }
      return result;
    });
    function hasPath(object, path3, hasFunc) {
      path3 = isKey(path3, object) ? [path3] : castPath(path3);
      for (var result, index = -1, length = path3.length; ++index < length; ) {
        var key = toKey(path3[index]);
        if (!(result = object != null && hasFunc(object, key)))
          break;
        object = object[key];
      }
      if (result)
        return result;
      var length = object ? object.length : 0;
      return !!length && isLength(length) && isIndex(key, length) && (isArray(object) || isArguments(object));
    }
    function isIndex(value, length) {
      return length = length ?? MAX_SAFE_INTEGER, !!length && (typeof value == "number" || reIsUint.test(value)) && value > -1 && value % 1 == 0 && value < length;
    }
    function isKey(value, object) {
      if (isArray(value))
        return !1;
      var type = typeof value;
      return type == "number" || type == "symbol" || type == "boolean" || value == null || isSymbol(value) ? !0 : reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object != null && value in Object(object);
    }
    function isKeyable(value) {
      var type = typeof value;
      return type == "string" || type == "number" || type == "symbol" || type == "boolean" ? value !== "__proto__" : value === null;
    }
    function isMasked(func) {
      return !!maskSrcKey && maskSrcKey in func;
    }
    function isPrototype(value) {
      var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto;
      return value === proto;
    }
    function isStrictComparable(value) {
      return value === value && !isObject4(value);
    }
    function matchesStrictComparable(key, srcValue) {
      return function(object) {
        return object == null ? !1 : object[key] === srcValue && (srcValue !== void 0 || key in Object(object));
      };
    }
    var stringToPath = memoize(function(string) {
      string = toString2(string);
      var result = [];
      return reLeadingDot.test(string) && result.push(""), string.replace(rePropName, function(match2, number, quote, string2) {
        result.push(quote ? string2.replace(reEscapeChar, "$1") : number || match2);
      }), result;
    });
    function toKey(value) {
      if (typeof value == "string" || isSymbol(value))
        return value;
      var result = value + "";
      return result == "0" && 1 / value == -INFINITY ? "-0" : result;
    }
    function toSource(func) {
      if (func != null) {
        try {
          return funcToString.call(func);
        } catch {
        }
        try {
          return func + "";
        } catch {
        }
      }
      return "";
    }
    function uniqBy3(array, iteratee) {
      return array && array.length ? baseUniq(array, baseIteratee(iteratee, 2)) : [];
    }
    function memoize(func, resolver) {
      if (typeof func != "function" || resolver && typeof resolver != "function")
        throw new TypeError(FUNC_ERROR_TEXT);
      var memoized = function() {
        var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache2 = memoized.cache;
        if (cache2.has(key))
          return cache2.get(key);
        var result = func.apply(this, args);
        return memoized.cache = cache2.set(key, result), result;
      };
      return memoized.cache = new (memoize.Cache || MapCache)(), memoized;
    }
    memoize.Cache = MapCache;
    function eq(value, other) {
      return value === other || value !== value && other !== other;
    }
    function isArguments(value) {
      return isArrayLikeObject(value) && hasOwnProperty.call(value, "callee") && (!propertyIsEnumerable.call(value, "callee") || objectToString.call(value) == argsTag);
    }
    var isArray = Array.isArray;
    function isArrayLike(value) {
      return value != null && isLength(value.length) && !isFunction(value);
    }
    function isArrayLikeObject(value) {
      return isObjectLike(value) && isArrayLike(value);
    }
    function isFunction(value) {
      var tag = isObject4(value) ? objectToString.call(value) : "";
      return tag == funcTag || tag == genTag;
    }
    function isLength(value) {
      return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
    }
    function isObject4(value) {
      var type = typeof value;
      return !!value && (type == "object" || type == "function");
    }
    function isObjectLike(value) {
      return !!value && typeof value == "object";
    }
    function isSymbol(value) {
      return typeof value == "symbol" || isObjectLike(value) && objectToString.call(value) == symbolTag;
    }
    var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
    function toString2(value) {
      return value == null ? "" : baseToString(value);
    }
    function get2(object, path3, defaultValue) {
      var result = object == null ? void 0 : baseGet(object, path3);
      return result === void 0 ? defaultValue : result;
    }
    function hasIn(object, path3) {
      return object != null && hasPath(object, path3, baseHasIn);
    }
    function keys(object) {
      return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
    }
    function identity(value) {
      return value;
    }
    function noop() {
    }
    function property(path3) {
      return isKey(path3) ? baseProperty(toKey(path3)) : basePropertyDeep(path3);
    }
    module.exports = uniqBy3;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/internal/constants.js
var require_constants3 = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/internal/constants.js"(exports, module) {
    init_cjs_shims();
    var SEMVER_SPEC_VERSION = "2.0.0", MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || /* istanbul ignore next */
    9007199254740991, MAX_SAFE_COMPONENT_LENGTH = 16, MAX_SAFE_BUILD_LENGTH = 250, RELEASE_TYPES = [
      "major",
      "premajor",
      "minor",
      "preminor",
      "patch",
      "prepatch",
      "prerelease"
    ];
    module.exports = {
      MAX_LENGTH: 256,
      MAX_SAFE_COMPONENT_LENGTH,
      MAX_SAFE_BUILD_LENGTH,
      MAX_SAFE_INTEGER,
      RELEASE_TYPES,
      SEMVER_SPEC_VERSION,
      FLAG_INCLUDE_PRERELEASE: 1,
      FLAG_LOOSE: 2
    };
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/internal/debug.js
var require_debug2 = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/internal/debug.js"(exports, module) {
    init_cjs_shims();
    var debug4 = typeof process == "object" && process.env && process.env.NODE_DEBUG && /\bsemver\b/i.test(process.env.NODE_DEBUG) ? (...args) => console.error("SEMVER", ...args) : () => {
    };
    module.exports = debug4;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/internal/re.js
var require_re = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/internal/re.js"(exports, module) {
    init_cjs_shims();
    var {
      MAX_SAFE_COMPONENT_LENGTH,
      MAX_SAFE_BUILD_LENGTH,
      MAX_LENGTH
    } = require_constants3(), debug4 = require_debug2();
    exports = module.exports = {};
    var re = exports.re = [], safeRe = exports.safeRe = [], src = exports.src = [], t7 = exports.t = {}, R = 0, LETTERDASHNUMBER = "[a-zA-Z0-9-]", safeRegexReplacements = [
      ["\\s", 1],
      ["\\d", MAX_LENGTH],
      [LETTERDASHNUMBER, MAX_SAFE_BUILD_LENGTH]
    ], makeSafeRegex = (value) => {
      for (let [token, max] of safeRegexReplacements)
        value = value.split(`${token}*`).join(`${token}{0,${max}}`).split(`${token}+`).join(`${token}{1,${max}}`);
      return value;
    }, createToken = (name, value, isGlobal) => {
      let safe = makeSafeRegex(value), index = R++;
      debug4(name, index, value), t7[name] = index, src[index] = value, re[index] = new RegExp(value, isGlobal ? "g" : void 0), safeRe[index] = new RegExp(safe, isGlobal ? "g" : void 0);
    };
    createToken("NUMERICIDENTIFIER", "0|[1-9]\\d*");
    createToken("NUMERICIDENTIFIERLOOSE", "\\d+");
    createToken("NONNUMERICIDENTIFIER", `\\d*[a-zA-Z-]${LETTERDASHNUMBER}*`);
    createToken("MAINVERSION", `(${src[t7.NUMERICIDENTIFIER]})\\.(${src[t7.NUMERICIDENTIFIER]})\\.(${src[t7.NUMERICIDENTIFIER]})`);
    createToken("MAINVERSIONLOOSE", `(${src[t7.NUMERICIDENTIFIERLOOSE]})\\.(${src[t7.NUMERICIDENTIFIERLOOSE]})\\.(${src[t7.NUMERICIDENTIFIERLOOSE]})`);
    createToken("PRERELEASEIDENTIFIER", `(?:${src[t7.NUMERICIDENTIFIER]}|${src[t7.NONNUMERICIDENTIFIER]})`);
    createToken("PRERELEASEIDENTIFIERLOOSE", `(?:${src[t7.NUMERICIDENTIFIERLOOSE]}|${src[t7.NONNUMERICIDENTIFIER]})`);
    createToken("PRERELEASE", `(?:-(${src[t7.PRERELEASEIDENTIFIER]}(?:\\.${src[t7.PRERELEASEIDENTIFIER]})*))`);
    createToken("PRERELEASELOOSE", `(?:-?(${src[t7.PRERELEASEIDENTIFIERLOOSE]}(?:\\.${src[t7.PRERELEASEIDENTIFIERLOOSE]})*))`);
    createToken("BUILDIDENTIFIER", `${LETTERDASHNUMBER}+`);
    createToken("BUILD", `(?:\\+(${src[t7.BUILDIDENTIFIER]}(?:\\.${src[t7.BUILDIDENTIFIER]})*))`);
    createToken("FULLPLAIN", `v?${src[t7.MAINVERSION]}${src[t7.PRERELEASE]}?${src[t7.BUILD]}?`);
    createToken("FULL", `^${src[t7.FULLPLAIN]}$`);
    createToken("LOOSEPLAIN", `[v=\\s]*${src[t7.MAINVERSIONLOOSE]}${src[t7.PRERELEASELOOSE]}?${src[t7.BUILD]}?`);
    createToken("LOOSE", `^${src[t7.LOOSEPLAIN]}$`);
    createToken("GTLT", "((?:<|>)?=?)");
    createToken("XRANGEIDENTIFIERLOOSE", `${src[t7.NUMERICIDENTIFIERLOOSE]}|x|X|\\*`);
    createToken("XRANGEIDENTIFIER", `${src[t7.NUMERICIDENTIFIER]}|x|X|\\*`);
    createToken("XRANGEPLAIN", `[v=\\s]*(${src[t7.XRANGEIDENTIFIER]})(?:\\.(${src[t7.XRANGEIDENTIFIER]})(?:\\.(${src[t7.XRANGEIDENTIFIER]})(?:${src[t7.PRERELEASE]})?${src[t7.BUILD]}?)?)?`);
    createToken("XRANGEPLAINLOOSE", `[v=\\s]*(${src[t7.XRANGEIDENTIFIERLOOSE]})(?:\\.(${src[t7.XRANGEIDENTIFIERLOOSE]})(?:\\.(${src[t7.XRANGEIDENTIFIERLOOSE]})(?:${src[t7.PRERELEASELOOSE]})?${src[t7.BUILD]}?)?)?`);
    createToken("XRANGE", `^${src[t7.GTLT]}\\s*${src[t7.XRANGEPLAIN]}$`);
    createToken("XRANGELOOSE", `^${src[t7.GTLT]}\\s*${src[t7.XRANGEPLAINLOOSE]}$`);
    createToken("COERCEPLAIN", `(^|[^\\d])(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}})(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?`);
    createToken("COERCE", `${src[t7.COERCEPLAIN]}(?:$|[^\\d])`);
    createToken("COERCEFULL", src[t7.COERCEPLAIN] + `(?:${src[t7.PRERELEASE]})?(?:${src[t7.BUILD]})?(?:$|[^\\d])`);
    createToken("COERCERTL", src[t7.COERCE], !0);
    createToken("COERCERTLFULL", src[t7.COERCEFULL], !0);
    createToken("LONETILDE", "(?:~>?)");
    createToken("TILDETRIM", `(\\s*)${src[t7.LONETILDE]}\\s+`, !0);
    exports.tildeTrimReplace = "$1~";
    createToken("TILDE", `^${src[t7.LONETILDE]}${src[t7.XRANGEPLAIN]}$`);
    createToken("TILDELOOSE", `^${src[t7.LONETILDE]}${src[t7.XRANGEPLAINLOOSE]}$`);
    createToken("LONECARET", "(?:\\^)");
    createToken("CARETTRIM", `(\\s*)${src[t7.LONECARET]}\\s+`, !0);
    exports.caretTrimReplace = "$1^";
    createToken("CARET", `^${src[t7.LONECARET]}${src[t7.XRANGEPLAIN]}$`);
    createToken("CARETLOOSE", `^${src[t7.LONECARET]}${src[t7.XRANGEPLAINLOOSE]}$`);
    createToken("COMPARATORLOOSE", `^${src[t7.GTLT]}\\s*(${src[t7.LOOSEPLAIN]})$|^$`);
    createToken("COMPARATOR", `^${src[t7.GTLT]}\\s*(${src[t7.FULLPLAIN]})$|^$`);
    createToken("COMPARATORTRIM", `(\\s*)${src[t7.GTLT]}\\s*(${src[t7.LOOSEPLAIN]}|${src[t7.XRANGEPLAIN]})`, !0);
    exports.comparatorTrimReplace = "$1$2$3";
    createToken("HYPHENRANGE", `^\\s*(${src[t7.XRANGEPLAIN]})\\s+-\\s+(${src[t7.XRANGEPLAIN]})\\s*$`);
    createToken("HYPHENRANGELOOSE", `^\\s*(${src[t7.XRANGEPLAINLOOSE]})\\s+-\\s+(${src[t7.XRANGEPLAINLOOSE]})\\s*$`);
    createToken("STAR", "(<|>)?=?\\s*\\*");
    createToken("GTE0", "^\\s*>=\\s*0\\.0\\.0\\s*$");
    createToken("GTE0PRE", "^\\s*>=\\s*0\\.0\\.0-0\\s*$");
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/internal/parse-options.js
var require_parse_options = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/internal/parse-options.js"(exports, module) {
    init_cjs_shims();
    var looseOption = Object.freeze({ loose: !0 }), emptyOpts = Object.freeze({}), parseOptions = (options) => options ? typeof options != "object" ? looseOption : options : emptyOpts;
    module.exports = parseOptions;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/internal/identifiers.js
var require_identifiers = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/internal/identifiers.js"(exports, module) {
    init_cjs_shims();
    var numeric = /^[0-9]+$/, compareIdentifiers = (a, b) => {
      let anum = numeric.test(a), bnum = numeric.test(b);
      return anum && bnum && (a = +a, b = +b), a === b ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a < b ? -1 : 1;
    }, rcompareIdentifiers = (a, b) => compareIdentifiers(b, a);
    module.exports = {
      compareIdentifiers,
      rcompareIdentifiers
    };
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/classes/semver.js
var require_semver2 = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/classes/semver.js"(exports, module) {
    init_cjs_shims();
    var debug4 = require_debug2(), { MAX_LENGTH, MAX_SAFE_INTEGER } = require_constants3(), { safeRe: re, t: t7 } = require_re(), parseOptions = require_parse_options(), { compareIdentifiers } = require_identifiers(), SemVer = class _SemVer {
      constructor(version2, options) {
        if (options = parseOptions(options), version2 instanceof _SemVer) {
          if (version2.loose === !!options.loose && version2.includePrerelease === !!options.includePrerelease)
            return version2;
          version2 = version2.version;
        } else if (typeof version2 != "string")
          throw new TypeError(`Invalid version. Must be a string. Got type "${typeof version2}".`);
        if (version2.length > MAX_LENGTH)
          throw new TypeError(
            `version is longer than ${MAX_LENGTH} characters`
          );
        debug4("SemVer", version2, options), this.options = options, this.loose = !!options.loose, this.includePrerelease = !!options.includePrerelease;
        let m = version2.trim().match(options.loose ? re[t7.LOOSE] : re[t7.FULL]);
        if (!m)
          throw new TypeError(`Invalid Version: ${version2}`);
        if (this.raw = version2, this.major = +m[1], this.minor = +m[2], this.patch = +m[3], this.major > MAX_SAFE_INTEGER || this.major < 0)
          throw new TypeError("Invalid major version");
        if (this.minor > MAX_SAFE_INTEGER || this.minor < 0)
          throw new TypeError("Invalid minor version");
        if (this.patch > MAX_SAFE_INTEGER || this.patch < 0)
          throw new TypeError("Invalid patch version");
        m[4] ? this.prerelease = m[4].split(".").map((id) => {
          if (/^[0-9]+$/.test(id)) {
            let num = +id;
            if (num >= 0 && num < MAX_SAFE_INTEGER)
              return num;
          }
          return id;
        }) : this.prerelease = [], this.build = m[5] ? m[5].split(".") : [], this.format();
      }
      format() {
        return this.version = `${this.major}.${this.minor}.${this.patch}`, this.prerelease.length && (this.version += `-${this.prerelease.join(".")}`), this.version;
      }
      toString() {
        return this.version;
      }
      compare(other) {
        if (debug4("SemVer.compare", this.version, this.options, other), !(other instanceof _SemVer)) {
          if (typeof other == "string" && other === this.version)
            return 0;
          other = new _SemVer(other, this.options);
        }
        return other.version === this.version ? 0 : this.compareMain(other) || this.comparePre(other);
      }
      compareMain(other) {
        return other instanceof _SemVer || (other = new _SemVer(other, this.options)), compareIdentifiers(this.major, other.major) || compareIdentifiers(this.minor, other.minor) || compareIdentifiers(this.patch, other.patch);
      }
      comparePre(other) {
        if (other instanceof _SemVer || (other = new _SemVer(other, this.options)), this.prerelease.length && !other.prerelease.length)
          return -1;
        if (!this.prerelease.length && other.prerelease.length)
          return 1;
        if (!this.prerelease.length && !other.prerelease.length)
          return 0;
        let i = 0;
        do {
          let a = this.prerelease[i], b = other.prerelease[i];
          if (debug4("prerelease compare", i, a, b), a === void 0 && b === void 0)
            return 0;
          if (b === void 0)
            return 1;
          if (a === void 0)
            return -1;
          if (a === b)
            continue;
          return compareIdentifiers(a, b);
        } while (++i);
      }
      compareBuild(other) {
        other instanceof _SemVer || (other = new _SemVer(other, this.options));
        let i = 0;
        do {
          let a = this.build[i], b = other.build[i];
          if (debug4("build compare", i, a, b), a === void 0 && b === void 0)
            return 0;
          if (b === void 0)
            return 1;
          if (a === void 0)
            return -1;
          if (a === b)
            continue;
          return compareIdentifiers(a, b);
        } while (++i);
      }
      // preminor will bump the version up to the next minor release, and immediately
      // down to pre-release. premajor and prepatch work the same way.
      inc(release2, identifier, identifierBase) {
        switch (release2) {
          case "premajor":
            this.prerelease.length = 0, this.patch = 0, this.minor = 0, this.major++, this.inc("pre", identifier, identifierBase);
            break;
          case "preminor":
            this.prerelease.length = 0, this.patch = 0, this.minor++, this.inc("pre", identifier, identifierBase);
            break;
          case "prepatch":
            this.prerelease.length = 0, this.inc("patch", identifier, identifierBase), this.inc("pre", identifier, identifierBase);
            break;
          case "prerelease":
            this.prerelease.length === 0 && this.inc("patch", identifier, identifierBase), this.inc("pre", identifier, identifierBase);
            break;
          case "major":
            (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) && this.major++, this.minor = 0, this.patch = 0, this.prerelease = [];
            break;
          case "minor":
            (this.patch !== 0 || this.prerelease.length === 0) && this.minor++, this.patch = 0, this.prerelease = [];
            break;
          case "patch":
            this.prerelease.length === 0 && this.patch++, this.prerelease = [];
            break;
          case "pre": {
            let base = Number(identifierBase) ? 1 : 0;
            if (!identifier && identifierBase === !1)
              throw new Error("invalid increment argument: identifier is empty");
            if (this.prerelease.length === 0)
              this.prerelease = [base];
            else {
              let i = this.prerelease.length;
              for (; --i >= 0; )
                typeof this.prerelease[i] == "number" && (this.prerelease[i]++, i = -2);
              if (i === -1) {
                if (identifier === this.prerelease.join(".") && identifierBase === !1)
                  throw new Error("invalid increment argument: identifier already exists");
                this.prerelease.push(base);
              }
            }
            if (identifier) {
              let prerelease = [identifier, base];
              identifierBase === !1 && (prerelease = [identifier]), compareIdentifiers(this.prerelease[0], identifier) === 0 ? isNaN(this.prerelease[1]) && (this.prerelease = prerelease) : this.prerelease = prerelease;
            }
            break;
          }
          default:
            throw new Error(`invalid increment argument: ${release2}`);
        }
        return this.raw = this.format(), this.build.length && (this.raw += `+${this.build.join(".")}`), this;
      }
    };
    module.exports = SemVer;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/parse.js
var require_parse3 = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/parse.js"(exports, module) {
    init_cjs_shims();
    var SemVer = require_semver2(), parse4 = (version2, options, throwErrors = !1) => {
      if (version2 instanceof SemVer)
        return version2;
      try {
        return new SemVer(version2, options);
      } catch (er) {
        if (!throwErrors)
          return null;
        throw er;
      }
    };
    module.exports = parse4;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/valid.js
var require_valid = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/valid.js"(exports, module) {
    init_cjs_shims();
    var parse4 = require_parse3(), valid2 = (version2, options) => {
      let v = parse4(version2, options);
      return v ? v.version : null;
    };
    module.exports = valid2;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/clean.js
var require_clean = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/clean.js"(exports, module) {
    init_cjs_shims();
    var parse4 = require_parse3(), clean = (version2, options) => {
      let s = parse4(version2.trim().replace(/^[=v]+/, ""), options);
      return s ? s.version : null;
    };
    module.exports = clean;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/inc.js
var require_inc = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/inc.js"(exports, module) {
    init_cjs_shims();
    var SemVer = require_semver2(), inc = (version2, release2, options, identifier, identifierBase) => {
      typeof options == "string" && (identifierBase = identifier, identifier = options, options = void 0);
      try {
        return new SemVer(
          version2 instanceof SemVer ? version2.version : version2,
          options
        ).inc(release2, identifier, identifierBase).version;
      } catch {
        return null;
      }
    };
    module.exports = inc;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/diff.js
var require_diff = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/diff.js"(exports, module) {
    init_cjs_shims();
    var parse4 = require_parse3(), diff2 = (version1, version2) => {
      let v1 = parse4(version1, null, !0), v2 = parse4(version2, null, !0), comparison = v1.compare(v2);
      if (comparison === 0)
        return null;
      let v1Higher = comparison > 0, highVersion = v1Higher ? v1 : v2, lowVersion = v1Higher ? v2 : v1, highHasPre = !!highVersion.prerelease.length;
      if (!!lowVersion.prerelease.length && !highHasPre)
        return !lowVersion.patch && !lowVersion.minor ? "major" : highVersion.patch ? "patch" : highVersion.minor ? "minor" : "major";
      let prefix = highHasPre ? "pre" : "";
      return v1.major !== v2.major ? prefix + "major" : v1.minor !== v2.minor ? prefix + "minor" : v1.patch !== v2.patch ? prefix + "patch" : "prerelease";
    };
    module.exports = diff2;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/major.js
var require_major = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/major.js"(exports, module) {
    init_cjs_shims();
    var SemVer = require_semver2(), major = (a, loose) => new SemVer(a, loose).major;
    module.exports = major;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/minor.js
var require_minor = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/minor.js"(exports, module) {
    init_cjs_shims();
    var SemVer = require_semver2(), minor = (a, loose) => new SemVer(a, loose).minor;
    module.exports = minor;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/patch.js
var require_patch = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/patch.js"(exports, module) {
    init_cjs_shims();
    var SemVer = require_semver2(), patch = (a, loose) => new SemVer(a, loose).patch;
    module.exports = patch;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/prerelease.js
var require_prerelease = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/prerelease.js"(exports, module) {
    init_cjs_shims();
    var parse4 = require_parse3(), prerelease = (version2, options) => {
      let parsed = parse4(version2, options);
      return parsed && parsed.prerelease.length ? parsed.prerelease : null;
    };
    module.exports = prerelease;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/compare.js
var require_compare = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/compare.js"(exports, module) {
    init_cjs_shims();
    var SemVer = require_semver2(), compare2 = (a, b, loose) => new SemVer(a, loose).compare(new SemVer(b, loose));
    module.exports = compare2;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/rcompare.js
var require_rcompare = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/rcompare.js"(exports, module) {
    init_cjs_shims();
    var compare2 = require_compare(), rcompare = (a, b, loose) => compare2(b, a, loose);
    module.exports = rcompare;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/compare-loose.js
var require_compare_loose = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/compare-loose.js"(exports, module) {
    init_cjs_shims();
    var compare2 = require_compare(), compareLoose = (a, b) => compare2(a, b, !0);
    module.exports = compareLoose;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/compare-build.js
var require_compare_build = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/compare-build.js"(exports, module) {
    init_cjs_shims();
    var SemVer = require_semver2(), compareBuild = (a, b, loose) => {
      let versionA = new SemVer(a, loose), versionB = new SemVer(b, loose);
      return versionA.compare(versionB) || versionA.compareBuild(versionB);
    };
    module.exports = compareBuild;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/sort.js
var require_sort = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/sort.js"(exports, module) {
    init_cjs_shims();
    var compareBuild = require_compare_build(), sort2 = (list2, loose) => list2.sort((a, b) => compareBuild(a, b, loose));
    module.exports = sort2;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/rsort.js
var require_rsort = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/rsort.js"(exports, module) {
    init_cjs_shims();
    var compareBuild = require_compare_build(), rsort = (list2, loose) => list2.sort((a, b) => compareBuild(b, a, loose));
    module.exports = rsort;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/gt.js
var require_gt = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/gt.js"(exports, module) {
    init_cjs_shims();
    var compare2 = require_compare(), gt2 = (a, b, loose) => compare2(a, b, loose) > 0;
    module.exports = gt2;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/lt.js
var require_lt = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/lt.js"(exports, module) {
    init_cjs_shims();
    var compare2 = require_compare(), lt = (a, b, loose) => compare2(a, b, loose) < 0;
    module.exports = lt;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/eq.js
var require_eq2 = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/eq.js"(exports, module) {
    init_cjs_shims();
    var compare2 = require_compare(), eq = (a, b, loose) => compare2(a, b, loose) === 0;
    module.exports = eq;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/neq.js
var require_neq = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/neq.js"(exports, module) {
    init_cjs_shims();
    var compare2 = require_compare(), neq = (a, b, loose) => compare2(a, b, loose) !== 0;
    module.exports = neq;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/gte.js
var require_gte = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/gte.js"(exports, module) {
    init_cjs_shims();
    var compare2 = require_compare(), gte = (a, b, loose) => compare2(a, b, loose) >= 0;
    module.exports = gte;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/lte.js
var require_lte = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/lte.js"(exports, module) {
    init_cjs_shims();
    var compare2 = require_compare(), lte = (a, b, loose) => compare2(a, b, loose) <= 0;
    module.exports = lte;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/cmp.js
var require_cmp = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/cmp.js"(exports, module) {
    init_cjs_shims();
    var eq = require_eq2(), neq = require_neq(), gt2 = require_gt(), gte = require_gte(), lt = require_lt(), lte = require_lte(), cmp = (a, op, b, loose) => {
      switch (op) {
        case "===":
          return typeof a == "object" && (a = a.version), typeof b == "object" && (b = b.version), a === b;
        case "!==":
          return typeof a == "object" && (a = a.version), typeof b == "object" && (b = b.version), a !== b;
        case "":
        case "=":
        case "==":
          return eq(a, b, loose);
        case "!=":
          return neq(a, b, loose);
        case ">":
          return gt2(a, b, loose);
        case ">=":
          return gte(a, b, loose);
        case "<":
          return lt(a, b, loose);
        case "<=":
          return lte(a, b, loose);
        default:
          throw new TypeError(`Invalid operator: ${op}`);
      }
    };
    module.exports = cmp;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/coerce.js
var require_coerce = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/coerce.js"(exports, module) {
    init_cjs_shims();
    var SemVer = require_semver2(), parse4 = require_parse3(), { safeRe: re, t: t7 } = require_re(), coerce = (version2, options) => {
      if (version2 instanceof SemVer)
        return version2;
      if (typeof version2 == "number" && (version2 = String(version2)), typeof version2 != "string")
        return null;
      options = options || {};
      let match2 = null;
      if (!options.rtl)
        match2 = version2.match(options.includePrerelease ? re[t7.COERCEFULL] : re[t7.COERCE]);
      else {
        let coerceRtlRegex = options.includePrerelease ? re[t7.COERCERTLFULL] : re[t7.COERCERTL], next;
        for (; (next = coerceRtlRegex.exec(version2)) && (!match2 || match2.index + match2[0].length !== version2.length); )
          (!match2 || next.index + next[0].length !== match2.index + match2[0].length) && (match2 = next), coerceRtlRegex.lastIndex = next.index + next[1].length + next[2].length;
        coerceRtlRegex.lastIndex = -1;
      }
      if (match2 === null)
        return null;
      let major = match2[2], minor = match2[3] || "0", patch = match2[4] || "0", prerelease = options.includePrerelease && match2[5] ? `-${match2[5]}` : "", build2 = options.includePrerelease && match2[6] ? `+${match2[6]}` : "";
      return parse4(`${major}.${minor}.${patch}${prerelease}${build2}`, options);
    };
    module.exports = coerce;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/internal/lrucache.js
var require_lrucache = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/internal/lrucache.js"(exports, module) {
    init_cjs_shims();
    var LRUCache = class {
      constructor() {
        this.max = 1e3, this.map = /* @__PURE__ */ new Map();
      }
      get(key) {
        let value = this.map.get(key);
        if (value !== void 0)
          return this.map.delete(key), this.map.set(key, value), value;
      }
      delete(key) {
        return this.map.delete(key);
      }
      set(key, value) {
        if (!this.delete(key) && value !== void 0) {
          if (this.map.size >= this.max) {
            let firstKey = this.map.keys().next().value;
            this.delete(firstKey);
          }
          this.map.set(key, value);
        }
        return this;
      }
    };
    module.exports = LRUCache;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/classes/range.js
var require_range2 = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/classes/range.js"(exports, module) {
    init_cjs_shims();
    var Range3 = class _Range {
      constructor(range, options) {
        if (options = parseOptions(options), range instanceof _Range)
          return range.loose === !!options.loose && range.includePrerelease === !!options.includePrerelease ? range : new _Range(range.raw, options);
        if (range instanceof Comparator)
          return this.raw = range.value, this.set = [[range]], this.format(), this;
        if (this.options = options, this.loose = !!options.loose, this.includePrerelease = !!options.includePrerelease, this.raw = range.trim().split(/\s+/).join(" "), this.set = this.raw.split("||").map((r2) => this.parseRange(r2.trim())).filter((c) => c.length), !this.set.length)
          throw new TypeError(`Invalid SemVer Range: ${this.raw}`);
        if (this.set.length > 1) {
          let first = this.set[0];
          if (this.set = this.set.filter((c) => !isNullSet(c[0])), this.set.length === 0)
            this.set = [first];
          else if (this.set.length > 1) {
            for (let c of this.set)
              if (c.length === 1 && isAny(c[0])) {
                this.set = [c];
                break;
              }
          }
        }
        this.format();
      }
      format() {
        return this.range = this.set.map((comps) => comps.join(" ").trim()).join("||").trim(), this.range;
      }
      toString() {
        return this.range;
      }
      parseRange(range) {
        let memoKey = ((this.options.includePrerelease && FLAG_INCLUDE_PRERELEASE) | (this.options.loose && FLAG_LOOSE)) + ":" + range, cached = cache2.get(memoKey);
        if (cached)
          return cached;
        let loose = this.options.loose, hr = loose ? re[t7.HYPHENRANGELOOSE] : re[t7.HYPHENRANGE];
        range = range.replace(hr, hyphenReplace(this.options.includePrerelease)), debug4("hyphen replace", range), range = range.replace(re[t7.COMPARATORTRIM], comparatorTrimReplace), debug4("comparator trim", range), range = range.replace(re[t7.TILDETRIM], tildeTrimReplace), debug4("tilde trim", range), range = range.replace(re[t7.CARETTRIM], caretTrimReplace), debug4("caret trim", range);
        let rangeList = range.split(" ").map((comp) => parseComparator(comp, this.options)).join(" ").split(/\s+/).map((comp) => replaceGTE0(comp, this.options));
        loose && (rangeList = rangeList.filter((comp) => (debug4("loose invalid filter", comp, this.options), !!comp.match(re[t7.COMPARATORLOOSE])))), debug4("range list", rangeList);
        let rangeMap = /* @__PURE__ */ new Map(), comparators = rangeList.map((comp) => new Comparator(comp, this.options));
        for (let comp of comparators) {
          if (isNullSet(comp))
            return [comp];
          rangeMap.set(comp.value, comp);
        }
        rangeMap.size > 1 && rangeMap.has("") && rangeMap.delete("");
        let result = [...rangeMap.values()];
        return cache2.set(memoKey, result), result;
      }
      intersects(range, options) {
        if (!(range instanceof _Range))
          throw new TypeError("a Range is required");
        return this.set.some((thisComparators) => isSatisfiable(thisComparators, options) && range.set.some((rangeComparators) => isSatisfiable(rangeComparators, options) && thisComparators.every((thisComparator) => rangeComparators.every((rangeComparator) => thisComparator.intersects(rangeComparator, options)))));
      }
      // if ANY of the sets match ALL of its comparators, then pass
      test(version2) {
        if (!version2)
          return !1;
        if (typeof version2 == "string")
          try {
            version2 = new SemVer(version2, this.options);
          } catch {
            return !1;
          }
        for (let i = 0; i < this.set.length; i++)
          if (testSet(this.set[i], version2, this.options))
            return !0;
        return !1;
      }
    };
    module.exports = Range3;
    var LRU = require_lrucache(), cache2 = new LRU(), parseOptions = require_parse_options(), Comparator = require_comparator(), debug4 = require_debug2(), SemVer = require_semver2(), {
      safeRe: re,
      t: t7,
      comparatorTrimReplace,
      tildeTrimReplace,
      caretTrimReplace
    } = require_re(), { FLAG_INCLUDE_PRERELEASE, FLAG_LOOSE } = require_constants3(), isNullSet = (c) => c.value === "<0.0.0-0", isAny = (c) => c.value === "", isSatisfiable = (comparators, options) => {
      let result = !0, remainingComparators = comparators.slice(), testComparator = remainingComparators.pop();
      for (; result && remainingComparators.length; )
        result = remainingComparators.every((otherComparator) => testComparator.intersects(otherComparator, options)), testComparator = remainingComparators.pop();
      return result;
    }, parseComparator = (comp, options) => (debug4("comp", comp, options), comp = replaceCarets(comp, options), debug4("caret", comp), comp = replaceTildes(comp, options), debug4("tildes", comp), comp = replaceXRanges(comp, options), debug4("xrange", comp), comp = replaceStars(comp, options), debug4("stars", comp), comp), isX = (id) => !id || id.toLowerCase() === "x" || id === "*", replaceTildes = (comp, options) => comp.trim().split(/\s+/).map((c) => replaceTilde(c, options)).join(" "), replaceTilde = (comp, options) => {
      let r2 = options.loose ? re[t7.TILDELOOSE] : re[t7.TILDE];
      return comp.replace(r2, (_2, M, m, p, pr) => {
        debug4("tilde", comp, _2, M, m, p, pr);
        let ret;
        return isX(M) ? ret = "" : isX(m) ? ret = `>=${M}.0.0 <${+M + 1}.0.0-0` : isX(p) ? ret = `>=${M}.${m}.0 <${M}.${+m + 1}.0-0` : pr ? (debug4("replaceTilde pr", pr), ret = `>=${M}.${m}.${p}-${pr} <${M}.${+m + 1}.0-0`) : ret = `>=${M}.${m}.${p} <${M}.${+m + 1}.0-0`, debug4("tilde return", ret), ret;
      });
    }, replaceCarets = (comp, options) => comp.trim().split(/\s+/).map((c) => replaceCaret(c, options)).join(" "), replaceCaret = (comp, options) => {
      debug4("caret", comp, options);
      let r2 = options.loose ? re[t7.CARETLOOSE] : re[t7.CARET], z2 = options.includePrerelease ? "-0" : "";
      return comp.replace(r2, (_2, M, m, p, pr) => {
        debug4("caret", comp, _2, M, m, p, pr);
        let ret;
        return isX(M) ? ret = "" : isX(m) ? ret = `>=${M}.0.0${z2} <${+M + 1}.0.0-0` : isX(p) ? M === "0" ? ret = `>=${M}.${m}.0${z2} <${M}.${+m + 1}.0-0` : ret = `>=${M}.${m}.0${z2} <${+M + 1}.0.0-0` : pr ? (debug4("replaceCaret pr", pr), M === "0" ? m === "0" ? ret = `>=${M}.${m}.${p}-${pr} <${M}.${m}.${+p + 1}-0` : ret = `>=${M}.${m}.${p}-${pr} <${M}.${+m + 1}.0-0` : ret = `>=${M}.${m}.${p}-${pr} <${+M + 1}.0.0-0`) : (debug4("no pr"), M === "0" ? m === "0" ? ret = `>=${M}.${m}.${p}${z2} <${M}.${m}.${+p + 1}-0` : ret = `>=${M}.${m}.${p}${z2} <${M}.${+m + 1}.0-0` : ret = `>=${M}.${m}.${p} <${+M + 1}.0.0-0`), debug4("caret return", ret), ret;
      });
    }, replaceXRanges = (comp, options) => (debug4("replaceXRanges", comp, options), comp.split(/\s+/).map((c) => replaceXRange(c, options)).join(" ")), replaceXRange = (comp, options) => {
      comp = comp.trim();
      let r2 = options.loose ? re[t7.XRANGELOOSE] : re[t7.XRANGE];
      return comp.replace(r2, (ret, gtlt, M, m, p, pr) => {
        debug4("xRange", comp, ret, gtlt, M, m, p, pr);
        let xM = isX(M), xm = xM || isX(m), xp = xm || isX(p), anyX = xp;
        return gtlt === "=" && anyX && (gtlt = ""), pr = options.includePrerelease ? "-0" : "", xM ? gtlt === ">" || gtlt === "<" ? ret = "<0.0.0-0" : ret = "*" : gtlt && anyX ? (xm && (m = 0), p = 0, gtlt === ">" ? (gtlt = ">=", xm ? (M = +M + 1, m = 0, p = 0) : (m = +m + 1, p = 0)) : gtlt === "<=" && (gtlt = "<", xm ? M = +M + 1 : m = +m + 1), gtlt === "<" && (pr = "-0"), ret = `${gtlt + M}.${m}.${p}${pr}`) : xm ? ret = `>=${M}.0.0${pr} <${+M + 1}.0.0-0` : xp && (ret = `>=${M}.${m}.0${pr} <${M}.${+m + 1}.0-0`), debug4("xRange return", ret), ret;
      });
    }, replaceStars = (comp, options) => (debug4("replaceStars", comp, options), comp.trim().replace(re[t7.STAR], "")), replaceGTE0 = (comp, options) => (debug4("replaceGTE0", comp, options), comp.trim().replace(re[options.includePrerelease ? t7.GTE0PRE : t7.GTE0], "")), hyphenReplace = (incPr) => ($0, from, fM, fm, fp, fpr, fb, to, tM, tm, tp, tpr) => (isX(fM) ? from = "" : isX(fm) ? from = `>=${fM}.0.0${incPr ? "-0" : ""}` : isX(fp) ? from = `>=${fM}.${fm}.0${incPr ? "-0" : ""}` : fpr ? from = `>=${from}` : from = `>=${from}${incPr ? "-0" : ""}`, isX(tM) ? to = "" : isX(tm) ? to = `<${+tM + 1}.0.0-0` : isX(tp) ? to = `<${tM}.${+tm + 1}.0-0` : tpr ? to = `<=${tM}.${tm}.${tp}-${tpr}` : incPr ? to = `<${tM}.${tm}.${+tp + 1}-0` : to = `<=${to}`, `${from} ${to}`.trim()), testSet = (set2, version2, options) => {
      for (let i = 0; i < set2.length; i++)
        if (!set2[i].test(version2))
          return !1;
      if (version2.prerelease.length && !options.includePrerelease) {
        for (let i = 0; i < set2.length; i++)
          if (debug4(set2[i].semver), set2[i].semver !== Comparator.ANY && set2[i].semver.prerelease.length > 0) {
            let allowed = set2[i].semver;
            if (allowed.major === version2.major && allowed.minor === version2.minor && allowed.patch === version2.patch)
              return !0;
          }
        return !1;
      }
      return !0;
    };
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/classes/comparator.js
var require_comparator = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/classes/comparator.js"(exports, module) {
    init_cjs_shims();
    var ANY = Symbol("SemVer ANY"), Comparator = class _Comparator {
      static get ANY() {
        return ANY;
      }
      constructor(comp, options) {
        if (options = parseOptions(options), comp instanceof _Comparator) {
          if (comp.loose === !!options.loose)
            return comp;
          comp = comp.value;
        }
        comp = comp.trim().split(/\s+/).join(" "), debug4("comparator", comp, options), this.options = options, this.loose = !!options.loose, this.parse(comp), this.semver === ANY ? this.value = "" : this.value = this.operator + this.semver.version, debug4("comp", this);
      }
      parse(comp) {
        let r2 = this.options.loose ? re[t7.COMPARATORLOOSE] : re[t7.COMPARATOR], m = comp.match(r2);
        if (!m)
          throw new TypeError(`Invalid comparator: ${comp}`);
        this.operator = m[1] !== void 0 ? m[1] : "", this.operator === "=" && (this.operator = ""), m[2] ? this.semver = new SemVer(m[2], this.options.loose) : this.semver = ANY;
      }
      toString() {
        return this.value;
      }
      test(version2) {
        if (debug4("Comparator.test", version2, this.options.loose), this.semver === ANY || version2 === ANY)
          return !0;
        if (typeof version2 == "string")
          try {
            version2 = new SemVer(version2, this.options);
          } catch {
            return !1;
          }
        return cmp(version2, this.operator, this.semver, this.options);
      }
      intersects(comp, options) {
        if (!(comp instanceof _Comparator))
          throw new TypeError("a Comparator is required");
        return this.operator === "" ? this.value === "" ? !0 : new Range3(comp.value, options).test(this.value) : comp.operator === "" ? comp.value === "" ? !0 : new Range3(this.value, options).test(comp.semver) : (options = parseOptions(options), options.includePrerelease && (this.value === "<0.0.0-0" || comp.value === "<0.0.0-0") || !options.includePrerelease && (this.value.startsWith("<0.0.0") || comp.value.startsWith("<0.0.0")) ? !1 : !!(this.operator.startsWith(">") && comp.operator.startsWith(">") || this.operator.startsWith("<") && comp.operator.startsWith("<") || this.semver.version === comp.semver.version && this.operator.includes("=") && comp.operator.includes("=") || cmp(this.semver, "<", comp.semver, options) && this.operator.startsWith(">") && comp.operator.startsWith("<") || cmp(this.semver, ">", comp.semver, options) && this.operator.startsWith("<") && comp.operator.startsWith(">")));
      }
    };
    module.exports = Comparator;
    var parseOptions = require_parse_options(), { safeRe: re, t: t7 } = require_re(), cmp = require_cmp(), debug4 = require_debug2(), SemVer = require_semver2(), Range3 = require_range2();
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/satisfies.js
var require_satisfies = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/functions/satisfies.js"(exports, module) {
    init_cjs_shims();
    var Range3 = require_range2(), satisfies = (version2, range, options) => {
      try {
        range = new Range3(range, options);
      } catch {
        return !1;
      }
      return range.test(version2);
    };
    module.exports = satisfies;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/to-comparators.js
var require_to_comparators = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/to-comparators.js"(exports, module) {
    init_cjs_shims();
    var Range3 = require_range2(), toComparators = (range, options) => new Range3(range, options).set.map((comp) => comp.map((c) => c.value).join(" ").trim().split(" "));
    module.exports = toComparators;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/max-satisfying.js
var require_max_satisfying = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/max-satisfying.js"(exports, module) {
    init_cjs_shims();
    var SemVer = require_semver2(), Range3 = require_range2(), maxSatisfying = (versions2, range, options) => {
      let max = null, maxSV = null, rangeObj = null;
      try {
        rangeObj = new Range3(range, options);
      } catch {
        return null;
      }
      return versions2.forEach((v) => {
        rangeObj.test(v) && (!max || maxSV.compare(v) === -1) && (max = v, maxSV = new SemVer(max, options));
      }), max;
    };
    module.exports = maxSatisfying;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/min-satisfying.js
var require_min_satisfying = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/min-satisfying.js"(exports, module) {
    init_cjs_shims();
    var SemVer = require_semver2(), Range3 = require_range2(), minSatisfying = (versions2, range, options) => {
      let min = null, minSV = null, rangeObj = null;
      try {
        rangeObj = new Range3(range, options);
      } catch {
        return null;
      }
      return versions2.forEach((v) => {
        rangeObj.test(v) && (!min || minSV.compare(v) === 1) && (min = v, minSV = new SemVer(min, options));
      }), min;
    };
    module.exports = minSatisfying;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/min-version.js
var require_min_version = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/min-version.js"(exports, module) {
    init_cjs_shims();
    var SemVer = require_semver2(), Range3 = require_range2(), gt2 = require_gt(), minVersion = (range, loose) => {
      range = new Range3(range, loose);
      let minver = new SemVer("0.0.0");
      if (range.test(minver) || (minver = new SemVer("0.0.0-0"), range.test(minver)))
        return minver;
      minver = null;
      for (let i = 0; i < range.set.length; ++i) {
        let comparators = range.set[i], setMin = null;
        comparators.forEach((comparator) => {
          let compver = new SemVer(comparator.semver.version);
          switch (comparator.operator) {
            case ">":
              compver.prerelease.length === 0 ? compver.patch++ : compver.prerelease.push(0), compver.raw = compver.format();
            case "":
            case ">=":
              (!setMin || gt2(compver, setMin)) && (setMin = compver);
              break;
            case "<":
            case "<=":
              break;
            default:
              throw new Error(`Unexpected operation: ${comparator.operator}`);
          }
        }), setMin && (!minver || gt2(minver, setMin)) && (minver = setMin);
      }
      return minver && range.test(minver) ? minver : null;
    };
    module.exports = minVersion;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/valid.js
var require_valid2 = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/valid.js"(exports, module) {
    init_cjs_shims();
    var Range3 = require_range2(), validRange2 = (range, options) => {
      try {
        return new Range3(range, options).range || "*";
      } catch {
        return null;
      }
    };
    module.exports = validRange2;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/outside.js
var require_outside = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/outside.js"(exports, module) {
    init_cjs_shims();
    var SemVer = require_semver2(), Comparator = require_comparator(), { ANY } = Comparator, Range3 = require_range2(), satisfies = require_satisfies(), gt2 = require_gt(), lt = require_lt(), lte = require_lte(), gte = require_gte(), outside = (version2, range, hilo, options) => {
      version2 = new SemVer(version2, options), range = new Range3(range, options);
      let gtfn, ltefn, ltfn, comp, ecomp;
      switch (hilo) {
        case ">":
          gtfn = gt2, ltefn = lte, ltfn = lt, comp = ">", ecomp = ">=";
          break;
        case "<":
          gtfn = lt, ltefn = gte, ltfn = gt2, comp = "<", ecomp = "<=";
          break;
        default:
          throw new TypeError('Must provide a hilo val of "<" or ">"');
      }
      if (satisfies(version2, range, options))
        return !1;
      for (let i = 0; i < range.set.length; ++i) {
        let comparators = range.set[i], high = null, low = null;
        if (comparators.forEach((comparator) => {
          comparator.semver === ANY && (comparator = new Comparator(">=0.0.0")), high = high || comparator, low = low || comparator, gtfn(comparator.semver, high.semver, options) ? high = comparator : ltfn(comparator.semver, low.semver, options) && (low = comparator);
        }), high.operator === comp || high.operator === ecomp || (!low.operator || low.operator === comp) && ltefn(version2, low.semver))
          return !1;
        if (low.operator === ecomp && ltfn(version2, low.semver))
          return !1;
      }
      return !0;
    };
    module.exports = outside;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/gtr.js
var require_gtr = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/gtr.js"(exports, module) {
    init_cjs_shims();
    var outside = require_outside(), gtr = (version2, range, options) => outside(version2, range, ">", options);
    module.exports = gtr;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/ltr.js
var require_ltr = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/ltr.js"(exports, module) {
    init_cjs_shims();
    var outside = require_outside(), ltr = (version2, range, options) => outside(version2, range, "<", options);
    module.exports = ltr;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/intersects.js
var require_intersects = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/intersects.js"(exports, module) {
    init_cjs_shims();
    var Range3 = require_range2(), intersects = (r1, r2, options) => (r1 = new Range3(r1, options), r2 = new Range3(r2, options), r1.intersects(r2, options));
    module.exports = intersects;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/simplify.js
var require_simplify = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/simplify.js"(exports, module) {
    init_cjs_shims();
    var satisfies = require_satisfies(), compare2 = require_compare();
    module.exports = (versions2, range, options) => {
      let set2 = [], first = null, prev = null, v = versions2.sort((a, b) => compare2(a, b, options));
      for (let version2 of v)
        satisfies(version2, range, options) ? (prev = version2, first || (first = version2)) : (prev && set2.push([first, prev]), prev = null, first = null);
      first && set2.push([first, null]);
      let ranges = [];
      for (let [min, max] of set2)
        min === max ? ranges.push(min) : !max && min === v[0] ? ranges.push("*") : max ? min === v[0] ? ranges.push(`<=${max}`) : ranges.push(`${min} - ${max}`) : ranges.push(`>=${min}`);
      let simplified = ranges.join(" || "), original = typeof range.raw == "string" ? range.raw : String(range);
      return simplified.length < original.length ? simplified : range;
    };
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/subset.js
var require_subset = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/ranges/subset.js"(exports, module) {
    init_cjs_shims();
    var Range3 = require_range2(), Comparator = require_comparator(), { ANY } = Comparator, satisfies = require_satisfies(), compare2 = require_compare(), subset = (sub, dom, options = {}) => {
      if (sub === dom)
        return !0;
      sub = new Range3(sub, options), dom = new Range3(dom, options);
      let sawNonNull = !1;
      OUTER:
        for (let simpleSub of sub.set) {
          for (let simpleDom of dom.set) {
            let isSub = simpleSubset(simpleSub, simpleDom, options);
            if (sawNonNull = sawNonNull || isSub !== null, isSub)
              continue OUTER;
          }
          if (sawNonNull)
            return !1;
        }
      return !0;
    }, minimumVersionWithPreRelease = [new Comparator(">=0.0.0-0")], minimumVersion = [new Comparator(">=0.0.0")], simpleSubset = (sub, dom, options) => {
      if (sub === dom)
        return !0;
      if (sub.length === 1 && sub[0].semver === ANY) {
        if (dom.length === 1 && dom[0].semver === ANY)
          return !0;
        options.includePrerelease ? sub = minimumVersionWithPreRelease : sub = minimumVersion;
      }
      if (dom.length === 1 && dom[0].semver === ANY) {
        if (options.includePrerelease)
          return !0;
        dom = minimumVersion;
      }
      let eqSet = /* @__PURE__ */ new Set(), gt2, lt;
      for (let c of sub)
        c.operator === ">" || c.operator === ">=" ? gt2 = higherGT(gt2, c, options) : c.operator === "<" || c.operator === "<=" ? lt = lowerLT(lt, c, options) : eqSet.add(c.semver);
      if (eqSet.size > 1)
        return null;
      let gtltComp;
      if (gt2 && lt) {
        if (gtltComp = compare2(gt2.semver, lt.semver, options), gtltComp > 0)
          return null;
        if (gtltComp === 0 && (gt2.operator !== ">=" || lt.operator !== "<="))
          return null;
      }
      for (let eq of eqSet) {
        if (gt2 && !satisfies(eq, String(gt2), options) || lt && !satisfies(eq, String(lt), options))
          return null;
        for (let c of dom)
          if (!satisfies(eq, String(c), options))
            return !1;
        return !0;
      }
      let higher, lower, hasDomLT, hasDomGT, needDomLTPre = lt && !options.includePrerelease && lt.semver.prerelease.length ? lt.semver : !1, needDomGTPre = gt2 && !options.includePrerelease && gt2.semver.prerelease.length ? gt2.semver : !1;
      needDomLTPre && needDomLTPre.prerelease.length === 1 && lt.operator === "<" && needDomLTPre.prerelease[0] === 0 && (needDomLTPre = !1);
      for (let c of dom) {
        if (hasDomGT = hasDomGT || c.operator === ">" || c.operator === ">=", hasDomLT = hasDomLT || c.operator === "<" || c.operator === "<=", gt2) {
          if (needDomGTPre && c.semver.prerelease && c.semver.prerelease.length && c.semver.major === needDomGTPre.major && c.semver.minor === needDomGTPre.minor && c.semver.patch === needDomGTPre.patch && (needDomGTPre = !1), c.operator === ">" || c.operator === ">=") {
            if (higher = higherGT(gt2, c, options), higher === c && higher !== gt2)
              return !1;
          } else if (gt2.operator === ">=" && !satisfies(gt2.semver, String(c), options))
            return !1;
        }
        if (lt) {
          if (needDomLTPre && c.semver.prerelease && c.semver.prerelease.length && c.semver.major === needDomLTPre.major && c.semver.minor === needDomLTPre.minor && c.semver.patch === needDomLTPre.patch && (needDomLTPre = !1), c.operator === "<" || c.operator === "<=") {
            if (lower = lowerLT(lt, c, options), lower === c && lower !== lt)
              return !1;
          } else if (lt.operator === "<=" && !satisfies(lt.semver, String(c), options))
            return !1;
        }
        if (!c.operator && (lt || gt2) && gtltComp !== 0)
          return !1;
      }
      return !(gt2 && hasDomLT && !lt && gtltComp !== 0 || lt && hasDomGT && !gt2 && gtltComp !== 0 || needDomGTPre || needDomLTPre);
    }, higherGT = (a, b, options) => {
      if (!a)
        return b;
      let comp = compare2(a.semver, b.semver, options);
      return comp > 0 ? a : comp < 0 || b.operator === ">" && a.operator === ">=" ? b : a;
    }, lowerLT = (a, b, options) => {
      if (!a)
        return b;
      let comp = compare2(a.semver, b.semver, options);
      return comp < 0 ? a : comp > 0 || b.operator === "<" && a.operator === "<=" ? b : a;
    };
    module.exports = subset;
  }
});

// ../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/index.js
var require_semver3 = __commonJS({
  "../../node_modules/.pnpm/semver@7.6.2/node_modules/semver/index.js"(exports, module) {
    init_cjs_shims();
    var internalRe = require_re(), constants = require_constants3(), SemVer = require_semver2(), identifiers = require_identifiers(), parse4 = require_parse3(), valid2 = require_valid(), clean = require_clean(), inc = require_inc(), diff2 = require_diff(), major = require_major(), minor = require_minor(), patch = require_patch(), prerelease = require_prerelease(), compare2 = require_compare(), rcompare = require_rcompare(), compareLoose = require_compare_loose(), compareBuild = require_compare_build(), sort2 = require_sort(), rsort = require_rsort(), gt2 = require_gt(), lt = require_lt(), eq = require_eq2(), neq = require_neq(), gte = require_gte(), lte = require_lte(), cmp = require_cmp(), coerce = require_coerce(), Comparator = require_comparator(), Range3 = require_range2(), satisfies = require_satisfies(), toComparators = require_to_comparators(), maxSatisfying = require_max_satisfying(), minSatisfying = require_min_satisfying(), minVersion = require_min_version(), validRange2 = require_valid2(), outside = require_outside(), gtr = require_gtr(), ltr = require_ltr(), intersects = require_intersects(), simplifyRange = require_simplify(), subset = require_subset();
    module.exports = {
      parse: parse4,
      valid: valid2,
      clean,
      inc,
      diff: diff2,
      major,
      minor,
      patch,
      prerelease,
      compare: compare2,
      rcompare,
      compareLoose,
      compareBuild,
      sort: sort2,
      rsort,
      gt: gt2,
      lt,
      eq,
      neq,
      gte,
      lte,
      cmp,
      coerce,
      Comparator,
      Range: Range3,
      satisfies,
      toComparators,
      maxSatisfying,
      minSatisfying,
      minVersion,
      validRange: validRange2,
      outside,
      gtr,
      ltr,
      intersects,
      simplifyRange,
      subset,
      SemVer,
      re: internalRe.re,
      src: internalRe.src,
      tokens: internalRe.t,
      SEMVER_SPEC_VERSION: constants.SEMVER_SPEC_VERSION,
      RELEASE_TYPES: constants.RELEASE_TYPES,
      compareIdentifiers: identifiers.compareIdentifiers,
      rcompareIdentifiers: identifiers.rcompareIdentifiers
    };
  }
});

// src/index.ts
init_cjs_shims();

// ../theme/dist/index.js
init_cjs_shims();

// ../theme/dist/cli/commands/theme/check.js
init_cjs_shims();

// ../theme/dist/cli/flags.js
init_cjs_shims();
var import_core = __toESM(require_lib(), 1);
var themeFlags = {
  path: import_core.Flags.string({
    description: "The path to your theme directory.",
    env: "SHOPIFY_FLAG_PATH",
    parse: async (input) => resolvePath(input),
    default: async () => cwd(),
    noCacheDefault: !0
  }),
  password: import_core.Flags.string({
    description: "Password generated from the Theme Access app.",
    env: "SHOPIFY_CLI_THEME_TOKEN"
  }),
  store: import_core.Flags.string({
    char: "s",
    description: "Store URL. It can be the store prefix (example) or the full myshopify.com URL (example.myshopify.com, https://example.myshopify.com).",
    env: "SHOPIFY_FLAG_STORE",
    parse: async (input) => normalizeStoreFqdn(input)
  }),
  environment: import_core.Flags.string({
    char: "e",
    description: "The environment to apply to the current command.",
    env: "SHOPIFY_FLAG_ENVIRONMENT"
  })
};

// ../theme/dist/cli/services/check.js
init_cjs_shims();
var import_theme_check_node = __toESM(require_dist5(), 1), import_yaml = __toESM(require_dist4(), 1);
function failLevelToSeverity(failLevel) {
  switch (failLevel) {
    case "error":
      return import_theme_check_node.Severity.ERROR;
    case "suggestion":
    case "warning":
      return import_theme_check_node.Severity.WARNING;
    case "style":
    case "info":
      return import_theme_check_node.Severity.INFO;
    case "crash":
      return;
  }
}
function severityToLabel(severity) {
  switch (severity) {
    case import_theme_check_node.Severity.ERROR:
      return "error";
    case import_theme_check_node.Severity.WARNING:
      return "warning";
    case import_theme_check_node.Severity.INFO:
      return "info";
  }
}
function getSnippet(absolutePath, startLine, endLine) {
  let snippetLines = readFileSync(absolutePath).toString().split(`
`).slice(startLine, endLine + 1), isSingleLine = snippetLines.length === 1;
  return snippetLines.map((line, index) => {
    let lineNumber = startLine + index + 1, formattedLine = isSingleLine ? line.trim() : line;
    return `${lineNumber}  ${formattedLine}`;
  }).join(`
`);
}
function severityToToken(severity) {
  switch (severity) {
    case import_theme_check_node.Severity.ERROR:
      return { error: `
[error]:` };
    case import_theme_check_node.Severity.WARNING:
      return { warn: `
[warning]:` };
    case import_theme_check_node.Severity.INFO:
      return { info: `
[info]:` };
  }
}
function formatOffenses(offenses) {
  return offenses.map((offense, index) => {
    let { message, absolutePath, start, end, check: check2, severity } = offense, codeSnippet = getSnippet(absolutePath, start.line, end.line), offensePadding = `${index === offenses.length - 1 ? "" : `

`}`;
    return [
      severityToToken(severity),
      { bold: `${check2}` },
      { subdued: `
${message}` },
      `

${codeSnippet}`,
      offensePadding
    ];
  }).flat();
}
var offenseSeverityAscending = (offenseA, offenseB) => offenseA.severity - offenseB.severity;
function sortOffenses(offenses) {
  let offensesByFile = offenses.reduce((acc, offense) => {
    let { absolutePath } = offense;
    return acc[absolutePath] || (acc[absolutePath] = []), acc[absolutePath].push(offense), acc;
  }, {});
  return Object.keys(offensesByFile).reduce((acc, filePath) => (acc[filePath] = offensesByFile[filePath].sort(offenseSeverityAscending), acc), {});
}
function countOffenseTypes(offenses) {
  return offenses.reduce((acc, offense) => (!Object.prototype.hasOwnProperty.call(acc, offense.severity) && (acc[offense.severity] = 0), acc[offense.severity]++, acc), {});
}
function formatSummary(offenses, offensesByFile, theme) {
  let summary = [`${theme.length} files inspected`];
  if (offenses.length === 0)
    summary.push("with no offenses found.");
  else {
    summary.push(`with ${offenses.length} total offenses found across ${Object.keys(offensesByFile).length} files.`);
    let counts = countOffenseTypes(offenses);
    counts[import_theme_check_node.Severity.ERROR] && summary.push(`
${counts[import_theme_check_node.Severity.ERROR]} errors.`), counts[import_theme_check_node.Severity.WARNING] && summary.push(`
${counts[import_theme_check_node.Severity.WARNING]} warnings.`), counts[import_theme_check_node.Severity.INFO] && summary.push(`
${counts[import_theme_check_node.Severity.INFO]} info issues.`);
  }
  return summary;
}
function renderOffensesText(offensesByFile, themeRootPath) {
  Object.keys(offensesByFile).sort().forEach((filePath) => {
    let headlineFilePath = filePath.replace(themeRootPath, "").slice(1);
    renderInfo({
      headline: headlineFilePath,
      body: formatOffenses(offensesByFile[filePath])
    });
  });
}
function formatOffensesJson(offensesByFile) {
  return Object.entries(offensesByFile).map(([path3, offenses]) => {
    let transformedOffenses = offenses.map((offense) => ({
      check: offense.check,
      severity: severityToLabel(offense.severity),
      start_row: offense.start.line,
      start_column: offense.start.character,
      end_row: offense.end.line,
      end_column: offense.end.character,
      message: offense.message
    })), counts = countOffenseTypes(offenses);
    return {
      path: path3,
      offenses: transformedOffenses,
      errorCount: counts[import_theme_check_node.Severity.ERROR] || 0,
      warningCount: counts[import_theme_check_node.Severity.WARNING] || 0,
      infoCount: counts[import_theme_check_node.Severity.INFO] || 0
    };
  });
}
function handleExit(offenses, failLevel) {
  failLevel || process.exit(0);
  let failSeverity = failLevelToSeverity(failLevel), shouldFail = failSeverity !== void 0 && offenses.some((offense) => offense.severity <= failSeverity);
  process.exit(shouldFail ? 1 : 0);
}
function commentString(input) {
  return input.split(`
`).map((line) => `# ${line}`).join(`
`);
}
async function initConfig(root) {
  let basefile = ".theme-check.yml", filePath = joinPath(root, basefile);
  if (await fileExists(filePath)) {
    outputInfo(`${basefile} already exists at ${root}`);
    return;
  }
  let { settings } = await (0, import_theme_check_node.loadConfig)(void 0, root), checksYml = commentString(import_yaml.default.stringify(settings)), initConfigYml = import_yaml.default.stringify({ extends: "theme-check:recommended", ignore: ["node_modules/**"] });
  await writeFile(filePath, `${initConfigYml}${checksYml}`), outputSuccess(`Created ${basefile} at ${root}`);
}
var saveToDiskFixApplicator = async (sourceCode, fix) => {
  let updatedSource = (0, import_theme_check_node.applyFixToString)(sourceCode.source, fix);
  await writeFile(sourceCode.absolutePath, updatedSource);
};
async function performAutoFixes(sourceCodes, offenses) {
  await (0, import_theme_check_node.autofix)(sourceCodes, offenses, saveToDiskFixApplicator);
}
async function outputActiveConfig(themeRoot, configPath) {
  let { ignore, settings, root } = await (0, import_theme_check_node.loadConfig)(configPath, themeRoot), config2 = {
    // loadConfig flattens all configs, it doesn't extend anything
    extends: [],
    // Depending on how the configs were merged during loadConfig, there may be
    // duplicate patterns to ignore. We can clean them before outputting.
    ignore: [...new Set(ignore)],
    root,
    // Dump out the active settings for all checks.
    ...settings
  };
  outputInfo(import_yaml.default.stringify(config2));
}
async function outputActiveChecks(root, configPath) {
  let { settings, ignore, checks } = await (0, import_theme_check_node.loadConfig)(configPath, root), ignorePatterns = [...new Set(ignore)], checksList = Object.keys(settings).reduce((acc, checkCode) => {
    let { severity, enabled, ...additional } = settings[checkCode];
    if (!enabled)
      return acc;
    let severityLabel = severityToLabel(severity === void 0 ? import_theme_check_node.Severity.INFO : severity), meta = checks.find((check2) => check2.meta.code === checkCode), metafields = meta && meta.meta ? {
      description: meta.meta.docs.description,
      doc: meta.meta.docs.url
    } : {};
    return acc[checkCode] = {
      severity: severityLabel,
      ...metafields,
      // Manually formatting ignore patterns to keep single line array output
      ignored_patterns: `[${ignorePatterns.join(", ")}]`,
      ...additional
    }, acc;
  }, {});
  outputInfo(import_yaml.default.stringify(checksList));
}
function isExtendedWriteStream(stream2) {
  return "_handle" in stream2 && typeof stream2._handle == "object" && stream2._handle !== null && typeof stream2._handle.setBlocking == "function";
}

// ../theme/dist/cli/utilities/theme-command.js
init_cjs_shims();

// ../theme/dist/cli/constants.js
init_cjs_shims();
var configurationFileName = "shopify.theme.toml";

// ../theme/dist/cli/utilities/theme-command.js
var ThemeCommand = class extends base_command_default {
  passThroughFlags(flags, { allowedFlags }) {
    let passThroughFlags = [];
    for (let [label, value] of Object.entries(flags))
      if ((allowedFlags ?? []).includes(label))
        typeof value == "boolean" ? value && passThroughFlags.push(`--${label}`) : Array.isArray(value) ? value.forEach((element) => passThroughFlags.push(`--${label}`, `${element}`)) : passThroughFlags.push(`--${label}`, `${value}`);
      else
        continue;
    return passThroughFlags;
  }
  environmentsFilename() {
    return configurationFileName;
  }
};

// ../theme/dist/cli/commands/theme/check.js
var import_core3 = __toESM(require_lib(), 1);

// ../cli-kit/dist/public/node/cli.js
init_cjs_shims();
var import_core2 = __toESM(require_lib());
import { fileURLToPath } from "url";
async function warnIfOldNodeVersion() {
  let nodeVersion = process.versions.node, nodeMajorVersion = Number(nodeVersion.split(".")[0]);
  if (nodeMajorVersion < 18) {
    let { renderWarning: renderWarning2 } = await import("./ui-GHKHPRP2.js");
    renderWarning2({
      headline: "Upgrade to a supported Node version now.",
      body: [
        `Node ${nodeMajorVersion} has reached end-of-life and poses security risks. When you upgrade to a`,
        {
          link: {
            url: "https://nodejs.dev/en/about/previous-releases",
            label: "supported version"
          }
        },
        { char: "," },
        "you'll be able to use Shopify CLI without interruption."
      ]
    });
  }
}
function setupEnvironmentVariables(options) {
  process.argv.includes("--verbose") && (process.env.DEBUG = process.env.DEBUG ?? "*"), options.development && (process.env.SHOPIFY_CLI_ENV = process.env.SHOPIFY_CLI_ENV ?? "development");
}
function forceNoColor() {
  (process.argv.includes("--no-color") || isTruthy(process.env.NO_COLOR) || isTruthy(process.env.SHOPIFY_FLAG_NO_COLOR) || process.env.TERM === "dumb") && (process.env.FORCE_COLOR = "0");
}
async function runCLI(options) {
  setupEnvironmentVariables(options), forceNoColor(), await warnIfOldNodeVersion();
  let { errorHandler: errorHandler2 } = await import("./error-handler-5G7W7NBW.js"), { isDevelopment } = await import("./local-IRPCVBNP.js"), oclif = await import("./lib-6LEA5PZ7.js"), { ShopifyConfig } = await import("./custom-oclif-loader-DXBW5MGT.js");
  isDevelopment() && (oclif.default.settings.debug = !0);
  try {
    let config2 = new ShopifyConfig({ root: fileURLToPath(options.moduleURL) });
    await config2.load(), await oclif.default.run(void 0, config2), await oclif.default.flush(), printEventsJson();
  } catch (error) {
    return await errorHandler2(error), oclif.default.Errors.handle(error);
  }
}
async function useLocalCLIIfDetected(filepath) {
  let { environmentVariables: environmentVariables2 } = await import("./constants-C6OOAW2P.js"), { joinPath: join6 } = await import("./path-T2RCZTRE.js"), { exec: exec2 } = await import("./system-N2OPVMOD.js");
  if (!isTruthy(process.env[environmentVariables2.enableCliRedirect]) || isTruthy(process.env[environmentVariables2.skipCliRedirect]) || process.env.npm_config_user_agent)
    return !1;
  let cliPackage = await localCliPackage();
  if (!cliPackage)
    return !1;
  let correctExecutablePath = join6(cliPackage.path, cliPackage.bin.shopify);
  if (correctExecutablePath === filepath)
    return !1;
  try {
    await exec2(correctExecutablePath, process.argv.slice(2, process.argv.length), {
      stdio: "inherit",
      env: { [environmentVariables2.skipCliRedirect]: "1" }
    });
  } catch (processError) {
    process.exit(processError.exitCode);
  }
  return !0;
}
async function localCliPackage() {
  let { captureOutput } = await import("./system-N2OPVMOD.js"), npmListOutput = "", localShopifyCLI = {};
  try {
    npmListOutput = await captureOutput("npm", ["list", "@shopify/cli", "--json", "-l"]), localShopifyCLI = JSON.parse(npmListOutput);
  } catch {
    return;
  }
  return {
    ...localShopifyCLI.peerDependencies,
    ...localShopifyCLI.devDependencies,
    ...localShopifyCLI.dependencies
  }["@shopify/cli"];
}
var globalFlags = {
  "no-color": import_core2.Flags.boolean({
    hidden: !1,
    description: "Disable color output.",
    env: "SHOPIFY_FLAG_NO_COLOR"
  }),
  verbose: import_core2.Flags.boolean({
    hidden: !1,
    description: "Increase the verbosity of the output.",
    env: "SHOPIFY_FLAG_VERBOSE"
  })
};

// ../theme/dist/cli/commands/theme/check.js
var import_theme_check_node2 = __toESM(require_dist5(), 1);
var _a, Check = class extends ThemeCommand {
  async run() {
    let { flags } = await this.parse(_a), path3 = flags.path, config2 = flags.config?.startsWith(":") && import_theme_check_node2.LegacyIdentifiers.has(flags.config.slice(1)) ? import_theme_check_node2.LegacyIdentifiers.get(flags.config.slice(1)) : flags.config;
    if (flags.init) {
      await initConfig(path3);
      return;
    }
    if (flags.version) {
      let pkgJsonPath = await findPathUp(joinPath("node_modules", "@shopify", "theme-check-node", "package.json"), {
        type: "file",
        cwd: moduleDirectory(import.meta.url)
      }), version2 = "unknown";
      pkgJsonPath && (version2 = await getPackageVersion(pkgJsonPath) || "unknown"), outputInfo(version2);
      return;
    }
    if (flags.print) {
      await outputActiveConfig(path3, config2);
      return;
    }
    if (flags.list) {
      await outputActiveChecks(path3, config2);
      return;
    }
    let { offenses, theme } = await (0, import_theme_check_node2.themeCheckRun)(path3, config2, (message) => {
      process.env.SHOPIFY_TMP_FLAG_DEBUG && consoleError(message);
    }), offensesByFile = sortOffenses(offenses);
    if (flags.output === "text" && (renderOffensesText(offensesByFile, path3), (offenses.length ? renderInfo : renderSuccess)({
      headline: "Theme Check Summary.",
      body: formatSummary(offenses, offensesByFile, theme)
    })), flags.output === "json") {
      let stdout = process.stdout;
      isExtendedWriteStream(stdout) && stdout._handle.setBlocking(!0), outputInfo(JSON.stringify(formatOffensesJson(offensesByFile)));
    }
    return flags["auto-correct"] && await performAutoFixes(theme, offenses), handleExit(offenses, flags["fail-level"]);
  }
};
_a = Check;
Check.summary = "Validate the theme.";
Check.descriptionWithMarkdown = "Calls and runs [Theme Check](https://shopify.dev/docs/themes/tools/theme-check) to analyze your theme code for errors and to ensure that it follows theme and Liquid best practices. [Learn more about the checks that Theme Check runs.](https://shopify.dev/docs/themes/tools/theme-check/checks)";
Check.description = _a.descriptionWithoutMarkdown();
Check.flags = {
  ...globalFlags,
  path: themeFlags.path,
  "auto-correct": import_core3.Flags.boolean({
    char: "a",
    required: !1,
    description: "Automatically fix offenses",
    env: "SHOPIFY_FLAG_AUTO_CORRECT"
  }),
  config: import_core3.Flags.string({
    char: "C",
    required: !1,
    description: `Use the config provided, overriding .theme-check.yml if present
      Supports all theme-check: config values, e.g., theme-check:theme-app-extension,
      theme-check:recommended, theme-check:all
      For backwards compatibility, :theme_app_extension is also supported `,
    env: "SHOPIFY_FLAG_CONFIG"
  }),
  "fail-level": import_core3.Flags.string({
    required: !1,
    description: "Minimum severity for exit with error code",
    env: "SHOPIFY_FLAG_FAIL_LEVEL",
    options: ["crash", "error", "suggestion", "style", "warning", "info"],
    default: "error"
  }),
  init: import_core3.Flags.boolean({
    required: !1,
    description: "Generate a .theme-check.yml file",
    env: "SHOPIFY_FLAG_INIT"
  }),
  list: import_core3.Flags.boolean({
    required: !1,
    description: "List enabled checks",
    env: "SHOPIFY_FLAG_LIST"
  }),
  output: import_core3.Flags.string({
    char: "o",
    required: !1,
    description: "The output format to use",
    env: "SHOPIFY_FLAG_OUTPUT",
    options: ["text", "json"],
    default: "text"
  }),
  print: import_core3.Flags.boolean({
    required: !1,
    description: "Output active config to STDOUT",
    env: "SHOPIFY_FLAG_PRINT"
  }),
  version: import_core3.Flags.boolean({
    char: "v",
    required: !1,
    description: "Print Theme Check version",
    env: "SHOPIFY_FLAG_VERSION"
  }),
  environment: themeFlags.environment
};
var check_default = Check;

// ../theme/dist/cli/commands/theme/console.js
init_cjs_shims();

// ../theme/dist/cli/utilities/theme-store.js
init_cjs_shims();

// ../theme/dist/cli/services/local-storage.js
init_cjs_shims();
var _themeLocalStorageInstance, _developmentThemeLocalStorageInstance, _replThemeLocalStorageInstance, _themeStoreLocalStorageInstance;
function themeLocalStorage() {
  return _themeLocalStorageInstance || (_themeLocalStorageInstance = new LocalStorage({ projectName: "shopify-cli-theme-conf" })), _themeLocalStorageInstance;
}
function developmentThemeLocalStorage() {
  return _developmentThemeLocalStorageInstance || (_developmentThemeLocalStorageInstance = new LocalStorage({
    projectName: "shopify-cli-development-theme-config"
  })), _developmentThemeLocalStorageInstance;
}
function replThemeLocalStorage() {
  return _replThemeLocalStorageInstance || (_replThemeLocalStorageInstance = new LocalStorage({
    projectName: "shopify-cli-repl-theme-config"
  })), _replThemeLocalStorageInstance;
}
function themeStoreLocalStorage() {
  return _themeStoreLocalStorageInstance || (_themeStoreLocalStorageInstance = new LocalStorage({
    projectName: "shopify-cli-theme-store-password"
  })), _themeStoreLocalStorageInstance;
}
function getThemeStore() {
  return themeLocalStorage().get("themeStore");
}
function setThemeStore(store) {
  themeLocalStorage().set("themeStore", store);
}
function getDevelopmentTheme() {
  return outputDebug(outputContent`Getting development theme...`), developmentThemeLocalStorage().get(getThemeStore());
}
function setDevelopmentTheme(theme) {
  outputDebug(outputContent`Setting development theme...`), developmentThemeLocalStorage().set(getThemeStore(), theme);
}
function removeDevelopmentTheme() {
  outputDebug(outputContent`Removing development theme...`), developmentThemeLocalStorage().delete(getThemeStore());
}
function getREPLTheme() {
  return outputDebug(outputContent`Getting REPL theme...`), replThemeLocalStorage().get(getThemeStore());
}
function setREPLTheme(theme) {
  outputDebug(outputContent`Setting REPL theme to ${theme}...`), replThemeLocalStorage().set(getThemeStore(), theme);
}
function removeREPLTheme() {
  outputDebug(outputContent`Removing REPL theme...`), replThemeLocalStorage().delete(getThemeStore());
}
function getStorefrontPassword() {
  let themeStore = getThemeStore();
  return outputDebug(outputContent`Getting storefront password for shop ${themeStore}...`), themeStoreLocalStorage().get(getThemeStore());
}
function setStorefrontPassword(password) {
  let themeStore = getThemeStore();
  outputDebug(outputContent`Setting storefront password for shop ${themeStore}...`), themeStoreLocalStorage().set(themeStore, password);
}
function removeStorefrontPassword() {
  let themeStore = getThemeStore();
  outputDebug(outputContent`Removing storefront password for ${themeStore}...`), themeStoreLocalStorage().delete(themeStore);
}

// ../theme/dist/cli/utilities/theme-store.js
function ensureThemeStore(flags) {
  let store = flags.store || getThemeStore();
  if (!store)
    throw new AbortError("A store is required", `Specify the store passing ${outputContent`${outputToken.genericShellCommand(`--${themeFlags.store.name}={your_store_url}`)}`.value} or set the ${outputContent`${outputToken.genericShellCommand(themeFlags.store.env)}`.value} environment variable.`);
  return setThemeStore(store), store;
}

// ../theme/dist/cli/services/console.js
init_cjs_shims();

// ../theme/dist/cli/utilities/theme-environment/storefront-session.js
init_cjs_shims();

// ../theme/dist/cli/utilities/theme-environment/cookies.js
init_cjs_shims();
function parseCookies(cookies) {
  let cookiesRecord = {};
  return cookies.split(";").forEach((cookie) => {
    let parts = cookie.match(/(.*?)=(.*)$/) ?? [], key = parts[1]?.trim(), value = parts[2]?.trim() ?? "";
    key && (cookiesRecord[key] = value);
  }), cookiesRecord;
}
function serializeCookies(cookies) {
  return Object.entries(cookies).map(([key, value]) => `${key}=${value}`).join("; ");
}

// ../theme/dist/cli/utilities/theme-environment/storefront-utils.js
init_cjs_shims();
function storefrontReplaceTemplatesParams(replaceTemplates) {
  let params = new URLSearchParams();
  for (let [path3, content] of Object.entries(replaceTemplates))
    params.append(`replace_templates[${path3}]`, content);
  return params.append("_method", "GET"), params;
}
function defaultHeaders() {
  return {
    "User-Agent": `Shopify CLI; v=${CLI_KIT_VERSION}`
  };
}

// ../theme/dist/cli/utilities/theme-environment/storefront-session.js
async function isStorefrontPasswordProtected(storeURL) {
  return (await fetch2(prependHttps(storeURL), {
    method: "GET",
    redirect: "manual"
  })).status === 302;
}
async function isStorefrontPasswordCorrect(password, store) {
  let response = await fetch2(`${prependHttps(store)}/password`, {
    headers: {
      "cache-control": "no-cache",
      "content-type": "application/x-www-form-urlencoded"
    },
    body: `form_type=storefront_password&utf8=%E2%9C%93&password=${password}`,
    method: "POST",
    redirect: "manual"
  });
  if (response.status === 429)
    throw new AbortError(`Too many incorrect password attempts. Please try again after ${response.headers.get("retry-after")} seconds.`);
  return response.status === 302 && response.headers.get("location") === `${prependHttps(store)}/`;
}
async function getStorefrontSessionCookies(storeUrl, themeId, password, headers = {}) {
  let cookieRecord = {}, shopifyEssential = await sessionEssentialCookie(storeUrl, themeId, headers);
  if (!shopifyEssential)
    throw new AbortError('Your development session could not be created because the "_shopify_essential" could not be defined. Please, check your internet connection.');
  if (cookieRecord._shopify_essential = shopifyEssential, !password)
    return cookieRecord;
  let storefrontDigest = await enrichSessionWithStorefrontPassword(shopifyEssential, storeUrl, password, headers);
  if (!storefrontDigest)
    throw new AbortError("Your development session could not be created because the store password is invalid. Please, retry with a different password.");
  return cookieRecord.storefront_digest = storefrontDigest, cookieRecord;
}
async function sessionEssentialCookie(storeUrl, themeId, headers) {
  let params = new URLSearchParams({
    preview_theme_id: themeId,
    _fd: "0",
    pb: "0"
  }), url = `${storeUrl}?${params}`, setCookies = (await fetch2(url, {
    method: "HEAD",
    redirect: "manual",
    headers: {
      ...headers,
      ...defaultHeaders()
    }
  })).headers.raw()["set-cookie"] ?? [];
  return getCookie(setCookies, "_shopify_essential");
}
async function enrichSessionWithStorefrontPassword(shopifyEssential, storeUrl, password, headers) {
  let params = new URLSearchParams({ password }), setCookies = (await fetch2(`${storeUrl}/password`, {
    method: "POST",
    redirect: "manual",
    body: params,
    headers: {
      ...headers,
      ...defaultHeaders(),
      Cookie: serializeCookies({ _shopify_essential: shopifyEssential })
    }
  })).headers.raw()["set-cookie"] ?? [];
  return getCookie(setCookies, "storefront_digest");
}
function getCookie(setCookieArray, cookieName) {
  let cookie = setCookieArray.find((cookie2) => parseCookies(cookie2)[cookieName]);
  return cookie ? parseCookies(cookie)[cookieName] : void 0;
}
function prependHttps(url) {
  return `https://${url}`;
}

// ../theme/dist/cli/utilities/repl/repl-theme-manager.js
init_cjs_shims();

// ../cli-kit/dist/public/node/themes/theme-manager.js
init_cjs_shims();

// ../cli-kit/dist/public/node/themes/api.js
init_cjs_shims();

// ../cli-kit/dist/public/node/themes/urls.js
init_cjs_shims();
function themePreviewUrl(theme, session) {
  let store = session.storeFqdn;
  return theme.role === "live" ? `https://${store}` : `https://${store}?preview_theme_id=${theme.id}`;
}
function themeEditorUrl(theme, session) {
  return `https://${session.storeFqdn}/admin/themes/${theme.id}/editor`;
}
function storeAdminUrl(session) {
  return `https://${session.storeFqdn}/admin`;
}

// ../cli-kit/dist/public/node/api/rest-api-throttler.js
init_cjs_shims();
var MAX_NUMBER_OF_PARALLEL_REQUESTS = 5, MARGIN_TO_RATE_LIMIT = 5, DELAY_FOR_TOO_MANY_PARALLEL_REQUESTS = 1e3, DELAY_FOR_TOO_CLOSE_TO_API_LIMIT = 4e3, THEME_CONTEXT = "theme";
async function throttle(request2) {
  return new Promise((resolve2, _reject) => {
    let performRequest = () => {
      throttlingState(THEME_CONTEXT).requestCounter += 1, resolve2(request2());
    }, throttleByHeader = () => {
      isReachingApiLimit() ? setTimeout(() => throttleByParallelCounter(performRequest), DELAY_FOR_TOO_CLOSE_TO_API_LIMIT) : throttleByParallelCounter(performRequest);
    }, throttleByParallelCounter = (command) => {
      hasTooManyRequests() ? setTimeout(() => throttleByParallelCounter(throttleByHeader), DELAY_FOR_TOO_MANY_PARALLEL_REQUESTS) : command();
    };
    throttleByParallelCounter(throttleByHeader);
  }).finally(() => {
    throttlingState(THEME_CONTEXT).requestCounter -= 1;
  });
}
function updateApiCallLimitFromResponse(response) {
  let callLimit = extractApiCallLimitFromResponse(response);
  if (!callLimit)
    return;
  let [used, limit] = callLimit;
  latestRequestInfo().apiCallLimit = { used, limit };
}
function hasTooManyRequests() {
  return throttlingState(THEME_CONTEXT).requestCounter > MAX_NUMBER_OF_PARALLEL_REQUESTS;
}
function isReachingApiLimit() {
  let { used, limit } = latestRequestInfo().apiCallLimit;
  return used >= limit - MARGIN_TO_RATE_LIMIT;
}
function latestRequestInfo() {
  return throttlingState(THEME_CONTEXT).latestRequestInfo;
}
function throttlingState(context) {
  let stateForContext = _throttlingState[context];
  if (stateForContext === void 0) {
    let startingState = {
      requestCounter: 0,
      latestRequestInfo: {
        apiCallLimit: { used: 0, limit: 40 }
      }
    };
    return _throttlingState[context] = startingState, startingState;
  } else
    return stateForContext;
}
var _throttlingState = {};
function extractRetryDelayMsFromResponse(response) {
  let retryAfterStr = header(response, "retry-after"), retryAfter = tryParseInt(retryAfterStr);
  return retryAfter || 0;
}
async function delayAwareRetry(response, operation) {
  let retryDelay = extractRetryDelayMsFromResponse(response);
  return new Promise((resolve2, _reject) => {
    setTimeout(() => resolve2(operation()), retryDelay);
  });
}
function extractApiCallLimitFromResponse(response) {
  let apiCallLimit = header(response, "x-shopify-shop-api-call-limit"), [used, limit] = apiCallLimit.split("/").map((num) => tryParseInt(num)).filter(Boolean);
  if (!(!used || !limit))
    return [used, limit];
}
function header(response, name) {
  let header2 = response.headers[name];
  return header2?.length === 1 ? header2[0] ?? "" : "";
}

// ../cli-kit/dist/public/node/api/admin.js
init_cjs_shims();

// ../cli-kit/dist/private/node/api/rest.js
init_cjs_shims();
function restRequestBody(requestBody) {
  if (requestBody)
    return JSON.stringify(requestBody);
}
function restRequestUrl(session, apiVersion, path3, searchParams = {}, env = process.env) {
  let themeKitAccessDomain = env[environmentVariables.themeKitAccessDomain] || defaultThemeKitAccessDomain, url = new URL(isThemeAccessSession(session) ? `https://${themeKitAccessDomain}/cli/admin/api/${apiVersion}${path3}.json` : `https://${session.storeFqdn}/admin/api/${apiVersion}${path3}.json`);
  return Object.entries(searchParams).forEach(([name, value]) => url.searchParams.set(name, value)), url.toString();
}
function restRequestHeaders(session) {
  let store = session.storeFqdn, token = session.token, headers = buildHeaders(session.token);
  return isThemeAccessSession(session) && (headers["X-Shopify-Shop"] = store, headers["X-Shopify-Access-Token"] = token), headers;
}
function isThemeAccessSession(session) {
  return session.token.startsWith("shptka_");
}

// ../cli-kit/dist/public/node/api/admin.js
async function adminRequest2(query, session, variables) {
  let api = "Admin", version2 = await fetchLatestSupportedApiVersion(session), url = adminUrl(session.storeFqdn, version2);
  return graphqlRequest({ query, api, url, token: session.token, variables });
}
async function fetchLatestSupportedApiVersion(session) {
  return (await supportedApiVersions(session)).reverse()[0];
}
async function supportedApiVersions(session) {
  return (await fetchApiVersions(session)).filter((item) => item.supported).map((item) => item.handle).sort();
}
async function fetchApiVersions(session) {
  let url = adminUrl(session.storeFqdn, "unstable"), query = apiVersionQuery();
  try {
    return (await graphqlRequest({
      query,
      api: "Admin",
      url,
      token: session.token,
      variables: {},
      responseOptions: { handleErrors: !1 }
    })).publicApiVersions;
  } catch (error) {
    if (error instanceof ClientError && error.response.status === 403) {
      let storeName = session.storeFqdn.replace(".myshopify.com", "");
      throw new AbortError(outputContent`Looks like you don't have access this dev store: (${outputToken.link(storeName, `https://${session.storeFqdn}`)})`, outputContent`If you're not the owner, create a dev store staff account for yourself`);
    }
    throw new BugError("Unknown error connecting to your store");
  }
}
function adminUrl(store, version2) {
  return `https://${store}/admin/api/${version2 || "unstable"}/graphql.json`;
}
function apiVersionQuery() {
  return gql`
    query {
      publicApiVersions {
        handle
        supported
      }
    }
  `;
}
async function restRequest(method, path3, session, requestBody, searchParams = {}, apiVersion = "unstable") {
  let url = restRequestUrl(session, apiVersion, path3, searchParams), body = restRequestBody(requestBody), headers = restRequestHeaders(session), response = await fetch2(url, {
    headers,
    method,
    body
  });
  return {
    json: await response.json().catch(() => ({})),
    status: response.status,
    headers: response.headers.raw()
  };
}

// ../cli-kit/dist/public/node/themes/factories.js
init_cjs_shims();

// ../cli-kit/dist/public/node/themes/types.js
init_cjs_shims();
var Operation;
(function(Operation2) {
  Operation2.Delete = "DELETE", Operation2.Upload = "UPLOAD";
})(Operation || (Operation = {}));

// ../cli-kit/dist/public/node/themes/factories.js
function buildTheme(themeJson) {
  if (!themeJson)
    return;
  themeJson.processing ?? (themeJson.processing = !1), themeJson.createdAtRuntime ?? (themeJson.createdAtRuntime = !1);
  let { id, name, role, processing, createdAtRuntime } = themeJson;
  return {
    id,
    name,
    processing,
    createdAtRuntime,
    role: role === "main" ? "live" : role
  };
}
function buildChecksum(asset) {
  if (!asset)
    return;
  let { key, checksum: checksum2 } = asset;
  return { key, checksum: checksum2 };
}
function buildThemeAsset(asset) {
  if (!asset)
    return;
  let { key, checksum: checksum2, attachment, value } = asset;
  return { key, checksum: checksum2, attachment, value };
}
function buildBulkUploadResults(bulkUploadResponse, assets) {
  return bulkUploadResponse ? bulkUploadResponse.map((bulkUpload, index) => ({
    key: assets[index].key,
    success: bulkUpload.code === 200,
    errors: bulkUpload.body.errors || {},
    asset: bulkUpload.body.asset,
    operation: Operation.Upload
  })) : [];
}

// ../cli-kit/dist/public/node/themes/api.js
async function fetchTheme(id, session) {
  let response = await request("GET", `/themes/${id}`, session, void 0, { fields: "id,name,role,processing" });
  return buildTheme(response.json.theme);
}
async function fetchThemes(session) {
  let themes = (await request("GET", "/themes", session, void 0, { fields: "id,name,role,processing" })).json?.themes;
  return themes?.length > 0 ? themes.map(buildTheme) : [];
}
async function createTheme(params, session) {
  let response = await request("POST", "/themes", session, { theme: { ...params } });
  return buildTheme({ ...response.json.theme, createdAtRuntime: !0 });
}
async function fetchThemeAsset(id, key, session) {
  let response = await request("GET", `/themes/${id}/assets`, session, void 0, {
    "asset[key]": key
  });
  return buildThemeAsset(response.json.asset);
}
async function deleteThemeAsset(id, key, session) {
  return !!(await request("DELETE", `/themes/${id}/assets`, session, void 0, {
    "asset[key]": key
  })).json.message;
}
async function bulkUploadThemeAssets(id, assets, session) {
  let response = await request("PUT", `/themes/${id}/assets/bulk`, session, { assets });
  if (response.status !== 207)
    throw new AbortError("Upload failed, could not reach the server");
  return buildBulkUploadResults(response.json.results, assets);
}
async function fetchChecksums(id, session) {
  let assets = (await request("GET", `/themes/${id}/assets`, session, void 0, { fields: "key,checksum" })).json.assets;
  return assets?.length > 0 ? assets.map(buildChecksum) : [];
}
async function updateTheme(id, params, session) {
  let response = await request("PUT", `/themes/${id}`, session, { theme: { id, ...params } });
  return buildTheme(response.json.theme);
}
async function publishTheme(id, session) {
  return updateTheme(id, { role: "main" }, session);
}
async function deleteTheme(id, session) {
  let response = await request("DELETE", `/themes/${id}`, session);
  return buildTheme(response.json.theme);
}
async function request(method, path3, session, params, searchParams = {}) {
  let response = await throttle(() => restRequest(method, path3, session, params, searchParams)), status = response.status;
  switch (updateApiCallLimitFromResponse(response), !0) {
    case (status >= 200 && status <= 399):
      return response;
    case status === 404:
      return response;
    case status === 429:
      return delayAwareRetry(response, () => request(method, path3, session, params, searchParams));
    case status === 403:
      return handleForbiddenError(response, session);
    case status === 401:
      throw new AbortError(`[${status}] API request unauthorized error`);
    case status === 422:
      throw new AbortError(`[${status}] API request unprocessable content: ${errors(response)}`);
    case (status >= 400 && status <= 499):
      throw new AbortError(`[${status}] API request client error`);
    case (status >= 500 && status <= 599):
      throw new AbortError(`[${status}] API request server error`);
    default:
      throw new AbortError(`[${status}] API request unexpected error`);
  }
}
function handleForbiddenError(response, session) {
  let store = session.storeFqdn, adminUrl2 = storeAdminUrl(session), error = errorMessage(response);
  throw error.match(/Cannot delete generated asset/) !== null ? new AbortError(error) : new AbortError(`You are not authorized to edit themes on "${store}".`, `You can't use Shopify CLI with development stores if you only have Partner staff member access. If you want to use Shopify CLI to work on a development store, then you should be the store owner or create a staff account on the store.

If you're the store owner, then you need to log in to the store directly using the store URL at least once (for example, using "${adminUrl2}") before you log in using Shopify CLI. Logging in to the Shopify admin directly connects the development store with your Shopify login.`);
}
function errors(response) {
  return JSON.stringify(response.json?.errors);
}
function errorMessage(response) {
  let message = response.json?.message;
  return typeof message == "string" ? message : "";
}

// ../cli-kit/dist/private/node/themes/generate-theme-name.js
init_cjs_shims();

// ../cli-kit/dist/private/node/themes/replace-invalid-characters.js
init_cjs_shims();
function replaceInvalidCharacters(identifier) {
  let findAllMatches = "g", enablesUnicodeSupport = "u";
  return identifier.replace(new RegExp(/[^\p{Letter}\p{Number}\p{Mark}-]/, `${findAllMatches}${enablesUnicodeSupport}`), "-");
}

// ../cli-kit/dist/private/node/themes/generate-theme-name.js
import { randomBytes } from "crypto";
import { hostname } from "os";
var API_NAME_LIMIT = 50;
function generateThemeName(context) {
  let hostNameWithoutDomain = hostname().split(".")[0], hash = randomBytes(3).toString("hex"), name = `${context} ()`, hostNameCharacterLimit = API_NAME_LIMIT - name.length - hash.length - 1, identifier = replaceInvalidCharacters(`${hash}-${hostNameWithoutDomain.substring(0, hostNameCharacterLimit)}`);
  return `${context} (${identifier})`;
}

// ../cli-kit/dist/public/node/themes/utils.js
init_cjs_shims();
var DEVELOPMENT_THEME_ROLE = "development", LIVE_THEME_ROLE = "live", UNPUBLISHED_THEME_ROLE = "unpublished";
function isDevelopmentTheme(theme) {
  return theme.role === DEVELOPMENT_THEME_ROLE;
}
async function promptThemeName(message) {
  let defaultName = await getRandomName("creative");
  return renderTextPrompt({
    message,
    defaultValue: defaultName
  });
}

// ../cli-kit/dist/public/node/themes/theme-manager.js
var ThemeManager = class {
  constructor(adminSession) {
    this.adminSession = adminSession;
  }
  async findOrCreate() {
    let theme = await this.fetch();
    return theme || (theme = await this.create()), theme;
  }
  async fetch() {
    if (!this.themeId)
      return;
    let theme = await fetchTheme(parseInt(this.themeId, 10), this.adminSession);
    return theme || this.removeTheme(), theme;
  }
  generateThemeName(context) {
    return generateThemeName(context);
  }
  async create(themeRole, themeName) {
    let name = themeName || generateThemeName(this.context), role = themeRole || DEVELOPMENT_THEME_ROLE, theme = await createTheme({
      name,
      role
    }, this.adminSession);
    if (!theme)
      throw new BugError(`Could not create theme with name "${name}" and role "${role}"`);
    return this.setTheme(theme.id.toString()), theme;
  }
};

// ../theme/dist/cli/utilities/repl/repl-theme-manager.js
var REPLThemeManager = class extends ThemeManager {
  constructor(adminSession) {
    super(adminSession), this.context = "REPL", this.themeId = getREPLTheme();
  }
  async create(themeRole, themeName) {
    let theme = await super.create(themeRole, themeName);
    return await this.uploadThemeAssets(theme), theme;
  }
  async findOrCreate() {
    let theme = await this.fetch();
    if (!theme) {
      let themeName = `Liquid Console (${CLI_KIT_VERSION})`;
      theme = await this.create(DEVELOPMENT_THEME_ROLE, themeName);
    }
    return theme;
  }
  setTheme(themeName) {
    setREPLTheme(themeName);
  }
  removeTheme() {
    removeREPLTheme();
  }
  async uploadThemeAssets(theme) {
    let assets = [
      { key: "config/settings_data.json", value: "{}" },
      { key: "config/settings_schema.json", value: "[]" },
      { key: "snippets/eval.liquid", value: "" },
      { key: "layout/password.liquid", value: "{{ content_for_header }}{{ content_for_layout }}" },
      { key: "layout/theme.liquid", value: "{{ content_for_header }}{{ content_for_layout }}" },
      { key: "sections/announcement-bar.liquid", value: "" },
      {
        key: "templates/index.json",
        value: JSON.stringify({
          sections: {
            announcement: { type: "announcement-bar", settings: {} }
          },
          order: ["announcement"]
        })
      }
    ];
    await bulkUploadThemeAssets(theme.id, assets, this.adminSession);
  }
};

// ../theme/dist/cli/utilities/repl/storefront-password-prompt.js
init_cjs_shims();
async function ensureValidPassword(password, store) {
  let finalPassword = password || getStorefrontPassword() || await promptPassword("Enter your theme password"), isPasswordRemoved = !1;
  for (; !await isStorefrontPasswordCorrect(finalPassword, store); )
    isPasswordRemoved || (removeStorefrontPassword(), isPasswordRemoved = !0), finalPassword = await promptPassword("Incorrect password provided. Please try again");
  return setStorefrontPassword(finalPassword), finalPassword;
}
async function promptPassword(prompt) {
  return renderTextPrompt({
    message: prompt,
    password: !0
  });
}

// ../theme/dist/cli/utilities/repl/repl.js
init_cjs_shims();

// ../theme/dist/cli/utilities/repl/evaluator.js
init_cjs_shims();

// ../theme/dist/cli/utilities/theme-environment/storefront-renderer.js
init_cjs_shims();
async function render2(session, context) {
  let url = buildStorefrontUrl(session, context);
  outputDebug(`\u2192 Rendering ${url} (with ${Object.keys(context.replaceTemplates)})...`);
  let bodyParams = storefrontReplaceTemplatesParams(context.replaceTemplates), headers = await buildHeaders2(session, context), response = await fetch2(url, {
    method: "POST",
    body: bodyParams,
    headers: {
      ...headers,
      ...defaultHeaders()
    }
  });
  return outputDebug(`\u2190 ${response.status} (request_id: ${response.headers.get("x-request-id")})`), response;
}
async function buildHeaders2(session, context) {
  return isThemeAccessSession2(session) ? buildThemeAccessHeaders(session, context) : buildStandardHeaders(session, context);
}
async function buildStandardHeaders(session, context) {
  let cookies = await buildCookies(session, context);
  return {
    Authorization: `Bearer ${await ensureAuthenticatedStorefront([])}`,
    Cookie: cookies,
    ...context.headers
  };
}
async function buildThemeAccessHeaders(session, context) {
  let cookies = await buildCookies(session, context), storefrontToken = await ensureAuthenticatedStorefront([]), filteredHeaders = {}, filterKeys = ["ACCEPT", "CONTENT-TYPE", "CONTENT-LENGTH"];
  for (let [key, value] of Object.entries(context.headers))
    filterKeys.includes(key.toUpperCase()) && (filteredHeaders[key] = value);
  return {
    ...filteredHeaders,
    ...themeAccessHeaders(session),
    Authorization: `Bearer ${storefrontToken}`,
    Cookie: cookies
  };
}
async function buildCookies(session, { themeId, cookies: cookieString }) {
  let cookies = parseCookies(cookieString), baseUrl = buildBaseStorefrontUrl(session), headers = isThemeAccessSession2(session) ? themeAccessHeaders(session) : {}, storefrontPassword = session.storefrontPassword, sessionCookies = await getStorefrontSessionCookies(baseUrl, themeId, storefrontPassword, headers);
  return serializeCookies({
    ...cookies,
    ...sessionCookies
  });
}
function buildStorefrontUrl(session, { path: path3, sectionId, query }) {
  let url = `${buildBaseStorefrontUrl(session)}${path3}`, params = new URLSearchParams({
    _fd: "0",
    pb: "0"
  });
  for (let [key, value] of query)
    params.append(key, value);
  return sectionId && params.append("section_id", sectionId), `${url}?${params}`;
}
function buildBaseStorefrontUrl(session) {
  return isThemeAccessSession2(session) ? "https://theme-kit-access.shopifyapps.com/cli/sfr" : `https://${session.storeFqdn}`;
}
function isThemeAccessSession2(session) {
  return session.token.startsWith("shptka_");
}
function themeAccessHeaders(session) {
  return {
    "X-Shopify-Shop": session.storeFqdn,
    "X-Shopify-Access-Token": session.token
  };
}

// ../theme/dist/cli/utilities/repl/evaluator.js
async function evaluate(config2) {
  try {
    return evaluateSnippet(config2);
  } catch (error) {
    outputInfo(outputContent`${outputToken.errorText(error.message)}`), outputDebug(error.stack || "Error backtrace not found");
  }
}
async function evaluateSnippet(config2) {
  return await evalResult(config2) || await evalContext(config2) || await evalAssignmentContext(config2) || await evalSyntaxError(config2) || void 0;
}
async function evalResult(config2) {
  outputDebug(`Evaluating snippet - ${config2.snippet}`);
  let input = `{ "type": "display", "value": {{ ${config2.snippet} | json }} }`, request2 = await makeRequest({ ...config2, snippet: input }), text = await request2.text();
  return successfulRequest(request2.status, text) ? parseDisplayResult(text) : void 0;
}
async function evalContext(config2) {
  outputDebug(`Evaluating context - ${config2.snippet}`);
  let json = `{ "type": "context", "value": "{% ${config2.snippet.replace(/"/g, '\\"')} %}" }`, request2 = await makeRequest({ ...config2, snippet: json }), text = await request2.text();
  successfulRequest(request2.status, text) && config2.replSession.push(JSON.parse(json));
}
async function evalAssignmentContext(config2) {
  if (outputDebug(`Evaluating assignment context - ${config2.snippet}`), isSmartAssignment(config2.snippet))
    return config2.snippet = `assign ${config2.snippet}`, outputInfo(outputContent`${outputToken.gray(`> ${config2.snippet}`)}`), evalContext(config2);
}
async function evalSyntaxError(config2) {
  outputDebug(`Evaluating syntax error - ${config2.snippet}`);
  let body = "";
  if (isStandardAssignment(config2.snippet) || (body = await (await makeRequest({ ...config2, snippet: `{{ ${config2.snippet} }}` })).text()), hasLiquidError(body) || (body = await (await makeRequest({ ...config2, snippet: `{% ${config2.snippet} %}` })).text()), hasLiquidError(body)) {
    let error = body.replace(/ \(snippets\/eval line \d+\)/, "");
    printSyntaxError(config2.snippet, error);
  }
}
function printSyntaxError(snippet, error) {
  if (error.includes("Unknown tag")) {
    outputInfo(outputContent`${outputToken.errorText(`Unknown object, property, tag, or filter: '${snippet}'`)}`);
    return;
  }
  let resultContent = stripHTMLContent(error);
  resultContent && outputInfo(outputContent`${outputToken.errorText(resultContent)}`);
}
async function makeRequest(config2) {
  let requestBody = buildRequestBody(config2), response = await render2(config2.themeSession, {
    path: config2.url,
    query: [],
    themeId: config2.themeId,
    cookies: "",
    sectionId: "announcement-bar",
    headers: {},
    replaceTemplates: {
      "sections/announcement-bar.liquid": "{% render 'eval' %}",
      "snippets/eval.liquid": `
${requestBody}
`
    }
  });
  return isExpiredSession(response) && expiredSessionError(), isTooManyRequests(response) && tooManyRequestsError(), isResourceNotFound(response) && notFoundError(), response;
}
function buildRequestBody(config2) {
  return `[${[...config2.replSession.map((item) => JSON.stringify(item)), config2.snippet].join(",").replace(/\\"/g, '"')}]`;
}
function parseDisplayResult(result) {
  let resultContent = stripHTMLContent(result);
  if (resultContent)
    return JSON.parse(resultContent)?.find((item) => item.type === "display")?.value;
}
function stripHTMLContent(result) {
  let splitResult = result.split(`
`).slice(1, -1);
  if (splitResult.length !== 0)
    return splitResult.join("");
}
function hasLiquidError(body) {
  return /Liquid syntax error/.test(body);
}
function isStandardAssignment(input) {
  return /^\s*assign\s*((?:\(?[\w\-.[\]]\)?)+)\s*=\s*(.*)\s*/m.test(input);
}
function isExpiredSession(response) {
  return response.status === 401 || response.status === 403;
}
function isTooManyRequests(response) {
  return response.status === 430 || response.status === 429;
}
function isResourceNotFound(response) {
  return response.headers.get("server-timing")?.includes('pageType;desc="404"') || !1;
}
function expiredSessionError() {
  throw outputInfo(outputContent`${outputToken.errorText("Session expired. Please initiate a new one.")}`), new AbortSilentError();
}
function tooManyRequestsError() {
  throw outputInfo(outputContent`${outputToken.errorText("Evaluations limit reached. Try again later.")}`), new AbortSilentError();
}
function notFoundError() {
  throw outputInfo(outputContent`${outputToken.errorText("Page not found. Please provide a valid --url value.")}`), new AbortSilentError();
}
function isSmartAssignment(input) {
  return /^\s*((?:\(?[\w\-.[\]]\)?)+)\s*=\s*(.*)\s*/m.test(input);
}
function successfulRequest(status, text) {
  return status === 200 && !hasLiquidError(text);
}

// ../theme/dist/cli/utilities/repl/presenter.js
init_cjs_shims();
function presentValue(value) {
  if (hasJsonError(value)) {
    consoleWarn("Object can't be printed, but you can access its fields. Read more at https://shopify.dev/docs/api/liquid.");
    return;
  }
  if (value == null) {
    renderValue("null");
    return;
  }
  let formattedOutput = JSON.stringify(value, null, 2);
  renderValue(formattedOutput);
}
function hasJsonError(output) {
  if (Array.isArray(output))
    return output.length > 0 ? hasJsonError(output[0]) : !1;
  if (output && typeof output == "object") {
    let errorMessage2 = output.error;
    return typeof errorMessage2 == "string" && errorMessage2.includes("json not allowed for this object");
  }
  return !1;
}
function renderValue(value) {
  return outputInfo(outputContent`${outputToken.cyan(value)}`);
}

// ../theme/dist/cli/utilities/repl/repl.js
import { createInterface } from "readline";
var DELIMITER_WARNING = `Liquid Console doesn't support Liquid delimiters such as '{{ ... }}' or '{% ... %}'.
Please use 'collections.first' instead of '{{ collections.first }}'.`;
async function replLoop(themeSession, themeId, url) {
  process.stdin.isTTY && process.stdin.ref();
  let rl = createInterface({
    input: process.stdin,
    output: process.stdout
  }), replSession = [];
  rl.on("line", (input) => {
    handleInput(input, themeSession, themeId, url, rl, replSession);
  }), rl.prompt();
}
async function handleInput(inputValue, themeSession, themeId, url, rl, replSession) {
  try {
    if (hasDelimiter(inputValue))
      return consoleWarn(DELIMITER_WARNING), rl.prompt();
    let evaluatedValue = await evaluate({ snippet: inputValue, themeSession, themeId, url, replSession });
    presentValue(evaluatedValue), rl.prompt();
  } catch (error) {
    throw shutdownReplSession(error), rl.close(), new AbortSilentError();
  }
}
function shutdownReplSession(error) {
  error instanceof Error && (outputInfo(outputContent`${outputToken.errorText(`Shopify Liquid console error: ${error.message}`)}`), outputDebug(error.stack || "Error backtrace not found"));
}
function hasDelimiter(input) {
  return /^\s*(\{\{|{%)/.test(input);
}

// ../theme/dist/cli/services/console.js
async function ensureReplEnv(adminSession, storePasswordFlag) {
  let themeId = await findOrCreateReplTheme(adminSession), storePassword = await isStorefrontPasswordProtected(adminSession.storeFqdn) ? await ensureValidPassword(storePasswordFlag, adminSession.storeFqdn) : void 0;
  return {
    themeId,
    storePassword
  };
}
async function findOrCreateReplTheme(adminSession) {
  return (await new REPLThemeManager(adminSession).findOrCreate()).id.toString();
}
async function initializeRepl(adminSession, storefrontToken, themeId, url, password) {
  consoleLog(`Welcome to Shopify Liquid console
(press Ctrl + C to exit)`);
  let themeSession = {
    ...adminSession,
    storefrontToken,
    storefrontPassword: password,
    expiresAt: /* @__PURE__ */ new Date()
  };
  return replLoop(themeSession, themeId, url);
}

// ../theme/dist/cli/commands/theme/console.js
var import_core4 = __toESM(require_lib(), 1);
var _a2, Console = class extends ThemeCommand {
  async run() {
    let { flags } = await this.parse(_a2), store = ensureThemeStore(flags), { url, port, password: themeAccessPassword } = flags, theme = `liquid-console-repl-${CLI_KIT_VERSION}`, adminSession = await ensureAuthenticatedThemes(store, themeAccessPassword, [], !0), storefrontToken = await ensureAuthenticatedStorefront([], themeAccessPassword), authUrl = `http://localhost:${port}/password`;
    if (flags["dev-preview"]) {
      outputInfo("This feature is currently in development and is not ready for use or testing yet."), flags.port && renderPortDeprecationWarning();
      let { themeId, storePassword } = await ensureReplEnv(adminSession, flags["store-password"]);
      await initializeRepl(adminSession, storefrontToken, themeId, url, storePassword);
      return;
    }
    return renderInfo({
      body: [
        "Activate the Shopify Liquid console in",
        { link: { label: "your browser", url: authUrl } },
        "and enter your store password if prompted."
      ]
    }), execCLI2(["theme", "console", "--url", url, "--port", port ?? "9293", "--theme", theme], {
      store,
      adminToken: adminSession.token,
      storefrontToken
    });
  }
};
_a2 = Console;
Console.summary = "Shopify Liquid REPL (read-eval-print loop) tool";
Console.usage = ["theme:console", "theme:console --url /products/classic-leather-jacket"];
Console.descriptionWithMarkdown = `Starts the Shopify Liquid REPL (read-eval-print loop) tool. This tool provides an interactive terminal interface for evaluating Liquid code and exploring Liquid objects, filters, and tags using real store data.

  You can also provide context to the console using a URL, as some Liquid objects are context-specific`;
Console.description = _a2.descriptionWithoutMarkdown();
Console.flags = {
  ...globalFlags,
  store: themeFlags.store,
  password: themeFlags.password,
  environment: themeFlags.environment,
  url: import_core4.Flags.string({
    description: "The url to be used as context",
    env: "SHOPIFY_FLAG_URL",
    default: "/"
  }),
  port: import_core4.Flags.string({
    description: "Local port to serve authentication service.",
    env: "SHOPIFY_FLAG_PORT"
  }),
  "store-password": import_core4.Flags.string({
    description: "The password for storefronts with password protection.",
    env: "SHOPIFY_FLAG_STORE_PASSWORD"
  }),
  "dev-preview": import_core4.Flags.boolean({
    hidden: !0,
    description: "Enables the developer preview for the upcoming `theme console` implementation.",
    env: "SHOPIFY_FLAG_BETA"
  })
};
var console_default = Console;
function renderPortDeprecationWarning() {
  renderWarning({
    headline: ["The", { command: "--port" }, "flag has been deprecated."],
    body: [
      { command: "shopify theme console" },
      "no longer requires a port to run. The",
      { command: "--port" },
      "flag is in the process of being deprecated and will be removed soon."
    ]
  });
}

// ../theme/dist/cli/commands/theme/delete.js
init_cjs_shims();

// ../theme/dist/cli/services/delete.js
init_cjs_shims();

// ../theme/dist/cli/utilities/theme-selector.js
init_cjs_shims();

// ../theme/dist/cli/utilities/theme-selector/fetch.js
init_cjs_shims();
var ALLOWED_ROLES = ["live", "unpublished", "development"];
async function fetchStoreThemes(session) {
  let store = session.storeFqdn, themes = (await fetchThemes(session)).filter(isRoleAllowed);
  if (themes.length === 0)
    throw new AbortError(`There are no themes in the ${store} store`);
  return themes.sort(byRole);
}
function isRoleAllowed(theme) {
  return ALLOWED_ROLES.includes(theme.role);
}
function byRole(themeA, themeB) {
  return ALLOWED_ROLES.indexOf(themeA.role) - ALLOWED_ROLES.indexOf(themeB.role);
}

// ../theme/dist/cli/utilities/theme-selector/filter.js
init_cjs_shims();
function filterThemes(store, themes, filter) {
  return filterByRole(store, themes, filter) || filterByTheme(store, themes, filter);
}
function filterByRole(store, themes, filter) {
  let role = filter.role;
  if (!role)
    return;
  let error = `No themes on the store ${store} match the role "${role}"`;
  return filterArray(themes, (theme) => theme.role === role).orThrow(error);
}
function filterByTheme(store, themes, filter) {
  return filter.themeIdentifiers.flatMap((identifier) => {
    let error = `No themes on the store ${store} match the ID or name "${identifier}"`;
    return filterArray(themes, (theme) => `${theme.id}` === identifier || theme.name.toLowerCase() === identifier.toLowerCase() ? !0 : isPartialMatch(theme.name.toLowerCase(), identifier.toLowerCase())).orThrow(error);
  });
}
function filterArray(themes, predicate) {
  let filteredThemes = themes.filter(predicate);
  return filteredThemes.length > 0 ? { orThrow: (_errorMessage) => filteredThemes } : {
    orThrow: (errorMessage2) => {
      throw new AbortError(errorMessage2);
    }
  };
}
var Filter = class {
  constructor(queryProps) {
    this.queryProps = queryProps;
  }
  get role() {
    for (let role of ALLOWED_ROLES)
      if (this.queryProps[role])
        return role;
  }
  get themeIdentifiers() {
    return [this.queryProps.theme, this.queryProps.themes].flat().filter((i) => !!i);
  }
  any() {
    return Object.values(this.queryProps).some((val) => val?.length !== void 0 ? val.length > 0 : !!val);
  }
};
function isPartialMatch(themeName, identifier) {
  let trimmedIdentifier = identifier.replace(/(^\*)|(\*$)/g, "");
  return identifier.startsWith("*") && identifier.endsWith("*") ? themeName.includes(trimmedIdentifier) : identifier.startsWith("*") ? themeName.endsWith(trimmedIdentifier) : identifier.endsWith("*") ? themeName.startsWith(trimmedIdentifier) : !1;
}

// ../theme/dist/cli/utilities/theme-selector.js
async function findOrSelectTheme(session, options) {
  let themes = await fetchStoreThemes(session), filter = new Filter(options.filter), store = session.storeFqdn;
  return filter.any() ? filterThemes(store, themes, filter)[0] : renderAutocompletePrompt({
    message: options.header ?? "",
    choices: themes.map((theme) => {
      let yoursLabel = theme.id.toString() === getDevelopmentTheme() ? " [yours]" : "";
      return {
        value: theme,
        label: `${theme.name}${yoursLabel}`,
        group: capitalize(theme.role)
      };
    })
  });
}
async function findThemes(session, filterProps) {
  let themes = await fetchStoreThemes(session), filter = new Filter(filterProps), store = session.storeFqdn;
  return filter.any() ? filterThemes(store, themes, filter) : [];
}

// ../theme/dist/cli/utilities/theme-ui.js
init_cjs_shims();
function themeComponent(theme) {
  return [
    `'${theme.name}'`,
    {
      subdued: `(#${theme.id})`
    }
  ];
}
function themesComponent(themes) {
  return { list: { items: themes.map(themeComponent) } };
}
async function currentDirectoryConfirmed(force) {
  return force || (renderWarning({ body: "It doesn't seem like you're running this command in a theme directory." }), !process.stdout.isTTY) ? !0 : renderConfirmationPrompt({
    message: "Do you want to proceed?"
  });
}
async function renderTasksToStdErr(tasks) {
  tasks.length > 0 && await renderTasks(tasks, { renderOptions: { stdout: process.stderr } });
}

// ../theme/dist/cli/utilities/development-theme-manager.js
init_cjs_shims();
var DEVELOPMENT_THEME_NOT_FOUND = (themeId) => `Development theme #${themeId} could not be found. Please create a new development theme.`, NO_DEVELOPMENT_THEME_ID_SET = "No development theme ID has been set. Please create a development theme first.", DevelopmentThemeManager = class extends ThemeManager {
  constructor(adminSession) {
    super(adminSession), this.context = "Development", this.themeId = getDevelopmentTheme();
  }
  async find() {
    let theme = await this.fetch();
    if (!theme)
      throw new AbortError(this.themeId ? DEVELOPMENT_THEME_NOT_FOUND(this.themeId) : NO_DEVELOPMENT_THEME_ID_SET);
    return theme;
  }
  setTheme(themeId) {
    setDevelopmentTheme(themeId);
  }
  removeTheme() {
    removeDevelopmentTheme();
  }
};

// ../theme/dist/cli/services/delete.js
async function deleteThemes(adminSession, options) {
  let themeIds = options.themes;
  options.development && (themeIds = [(await new DevelopmentThemeManager(adminSession).find()).id.toString()]);
  let store = adminSession.storeFqdn, themes = await findThemesByDeleteOptions(adminSession, { ...options, themes: themeIds, development: !1 });
  !options.force && !await isConfirmed(themes, store) || (await Promise.all(themes.map((theme) => (isDevelopmentTheme(theme) && removeDevelopmentTheme(), deleteTheme(theme.id, adminSession)))), renderSuccess({
    body: pluralize(themes, (themes2) => [`The following themes were deleted from ${store}:`, themesComponent(themes2)], (theme) => ["The theme", ...themeComponent(theme), `was deleted from ${store}.`])
  }));
}
async function findThemesByDeleteOptions(adminSession, options) {
  if (options.selectTheme || options.themes.length > 0)
    return findThemes(adminSession, options);
  let store = adminSession.storeFqdn;
  return [await findOrSelectTheme(adminSession, {
    header: `Select a theme to delete from ${store}`,
    filter: { development: options.development }
  })];
}
async function isConfirmed(themes, store) {
  let options = {
    message: pluralize(themes, (_themes) => [`Delete the following themes from ${store}?`], (theme) => ["Delete", ...themeComponent(theme), `from ${store}?`]),
    confirmationMessage: "Yes, confirm changes",
    cancellationMessage: "Cancel"
  };
  return themes.length > 1 && (options.infoTable = { "": themes.map(themeComponent) }), renderConfirmationPrompt(options);
}
function renderDeprecatedArgsWarning(argv) {
  let ids = argv.join(" ");
  renderWarning({
    body: [
      "Positional arguments are deprecated. Use the",
      { command: "--theme" },
      `flag instead:

`,
      { command: `$ shopify theme delete --theme ${ids}` },
      { char: "." }
    ]
  });
}

// ../theme/dist/cli/commands/theme/delete.js
var import_core5 = __toESM(require_lib(), 1);
var _a3, Delete = class extends ThemeCommand {
  async run() {
    let { flags, argv } = await this.parse(_a3), { development, force, password, theme } = flags, themes = [...argv, ...theme ?? []], store = ensureThemeStore(flags), adminSession = await ensureAuthenticatedThemes(store, password);
    argv.length > 0 && renderDeprecatedArgsWarning(argv), await deleteThemes(adminSession, {
      selectTheme: flags["show-all"],
      development,
      themes,
      force
    });
  }
};
_a3 = Delete;
Delete.summary = "Delete remote themes from the connected store. This command can't be undone.";
Delete.descriptionWithMarkdown = `Deletes a theme from your store.

  You can specify multiple themes by ID. If no theme is specified, then you're prompted to select the theme that you want to delete from the list of themes in your store.

  You're asked to confirm that you want to delete the specified themes before they are deleted. You can skip this confirmation using the \`--force\` flag.`;
Delete.description = _a3.descriptionWithoutMarkdown();
Delete.strict = !1;
Delete.flags = {
  ...globalFlags,
  password: themeFlags.password,
  development: import_core5.Flags.boolean({
    char: "d",
    description: "Delete your development theme.",
    env: "SHOPIFY_FLAG_DEVELOPMENT"
  }),
  "show-all": import_core5.Flags.boolean({
    char: "a",
    description: "Include others development themes in theme list.",
    env: "SHOPIFY_FLAG_SHOW_ALL"
  }),
  force: import_core5.Flags.boolean({
    char: "f",
    description: "Skip confirmation.",
    env: "SHOPIFY_FLAG_FORCE"
  }),
  theme: import_core5.Flags.string({
    char: "t",
    description: "Theme ID or name of the remote theme.",
    env: "SHOPIFY_FLAG_THEME_ID",
    multiple: !0
  }),
  store: themeFlags.store,
  environment: themeFlags.environment
};
var delete_default = Delete;

// ../theme/dist/cli/commands/theme/dev.js
init_cjs_shims();

// ../theme/dist/cli/services/dev.js
init_cjs_shims();

// ../theme/dist/cli/utilities/theme-fs.js
init_cjs_shims();

// ../theme/dist/cli/utilities/asset-checksum.js
init_cjs_shims();
async function checksum(root, path3) {
  let content = await readThemeFile(root, path3);
  return content ? (Buffer.isBuffer(content) || (isTextFile(path3) && (content = content.replace(/\r\n/g, `
`)), isJson(path3) && (content = normalizeJson(content), isThemeAsset(path3) || (content = content.replace(/(?<!\\)\//g, "\\/")))), md5(content)) : "";
}
function normalizeJson(jsonStr) {
  let inStr = !1, wasBackslash = !1, formattedStr = "";
  for (let char of jsonStr)
    char === '"' && !wasBackslash && (inStr = !inStr), !(!inStr && (char === " " || char === `
`)) && (formattedStr += char, wasBackslash = char === "\\" && !wasBackslash);
  return formattedStr;
}
function md5(content) {
  let buffer = Buffer.isBuffer(content) ? content : Buffer.from(content);
  return fileHash(buffer);
}
function rejectGeneratedStaticAssets(themeChecksums) {
  return themeChecksums.filter(({ key }) => key.startsWith("assets/") ? !hasLiquidSource(themeChecksums, key) : !0);
}
function hasLiquidSource(checksums, key) {
  return checksums.some((checksum2) => checksum2.key === `${key}.liquid`);
}

// ../cli-kit/dist/public/node/mimes.js
init_cjs_shims();

// ../../node_modules/.pnpm/mrmime@1.0.1/node_modules/mrmime/index.mjs
init_cjs_shims();
var mimes = {
  ez: "application/andrew-inset",
  aw: "application/applixware",
  atom: "application/atom+xml",
  atomcat: "application/atomcat+xml",
  atomdeleted: "application/atomdeleted+xml",
  atomsvc: "application/atomsvc+xml",
  dwd: "application/atsc-dwd+xml",
  held: "application/atsc-held+xml",
  rsat: "application/atsc-rsat+xml",
  bdoc: "application/bdoc",
  xcs: "application/calendar+xml",
  ccxml: "application/ccxml+xml",
  cdfx: "application/cdfx+xml",
  cdmia: "application/cdmi-capability",
  cdmic: "application/cdmi-container",
  cdmid: "application/cdmi-domain",
  cdmio: "application/cdmi-object",
  cdmiq: "application/cdmi-queue",
  cu: "application/cu-seeme",
  mpd: "application/dash+xml",
  davmount: "application/davmount+xml",
  dbk: "application/docbook+xml",
  dssc: "application/dssc+der",
  xdssc: "application/dssc+xml",
  es: "application/ecmascript",
  ecma: "application/ecmascript",
  emma: "application/emma+xml",
  emotionml: "application/emotionml+xml",
  epub: "application/epub+zip",
  exi: "application/exi",
  fdt: "application/fdt+xml",
  pfr: "application/font-tdpfr",
  geojson: "application/geo+json",
  gml: "application/gml+xml",
  gpx: "application/gpx+xml",
  gxf: "application/gxf",
  gz: "application/gzip",
  hjson: "application/hjson",
  stk: "application/hyperstudio",
  ink: "application/inkml+xml",
  inkml: "application/inkml+xml",
  ipfix: "application/ipfix",
  its: "application/its+xml",
  jar: "application/java-archive",
  war: "application/java-archive",
  ear: "application/java-archive",
  ser: "application/java-serialized-object",
  class: "application/java-vm",
  js: "application/javascript",
  mjs: "application/javascript",
  json: "application/json",
  map: "application/json",
  json5: "application/json5",
  jsonml: "application/jsonml+json",
  jsonld: "application/ld+json",
  lgr: "application/lgr+xml",
  lostxml: "application/lost+xml",
  hqx: "application/mac-binhex40",
  cpt: "application/mac-compactpro",
  mads: "application/mads+xml",
  webmanifest: "application/manifest+json",
  mrc: "application/marc",
  mrcx: "application/marcxml+xml",
  ma: "application/mathematica",
  nb: "application/mathematica",
  mb: "application/mathematica",
  mathml: "application/mathml+xml",
  mbox: "application/mbox",
  mscml: "application/mediaservercontrol+xml",
  metalink: "application/metalink+xml",
  meta4: "application/metalink4+xml",
  mets: "application/mets+xml",
  maei: "application/mmt-aei+xml",
  musd: "application/mmt-usd+xml",
  mods: "application/mods+xml",
  m21: "application/mp21",
  mp21: "application/mp21",
  mp4s: "application/mp4",
  m4p: "application/mp4",
  doc: "application/msword",
  dot: "application/msword",
  mxf: "application/mxf",
  nq: "application/n-quads",
  nt: "application/n-triples",
  cjs: "application/node",
  bin: "application/octet-stream",
  dms: "application/octet-stream",
  lrf: "application/octet-stream",
  mar: "application/octet-stream",
  so: "application/octet-stream",
  dist: "application/octet-stream",
  distz: "application/octet-stream",
  pkg: "application/octet-stream",
  bpk: "application/octet-stream",
  dump: "application/octet-stream",
  elc: "application/octet-stream",
  deploy: "application/octet-stream",
  exe: "application/octet-stream",
  dll: "application/octet-stream",
  deb: "application/octet-stream",
  dmg: "application/octet-stream",
  iso: "application/octet-stream",
  img: "application/octet-stream",
  msi: "application/octet-stream",
  msp: "application/octet-stream",
  msm: "application/octet-stream",
  buffer: "application/octet-stream",
  oda: "application/oda",
  opf: "application/oebps-package+xml",
  ogx: "application/ogg",
  omdoc: "application/omdoc+xml",
  onetoc: "application/onenote",
  onetoc2: "application/onenote",
  onetmp: "application/onenote",
  onepkg: "application/onenote",
  oxps: "application/oxps",
  relo: "application/p2p-overlay+xml",
  xer: "application/patch-ops-error+xml",
  pdf: "application/pdf",
  pgp: "application/pgp-encrypted",
  asc: "application/pgp-signature",
  sig: "application/pgp-signature",
  prf: "application/pics-rules",
  p10: "application/pkcs10",
  p7m: "application/pkcs7-mime",
  p7c: "application/pkcs7-mime",
  p7s: "application/pkcs7-signature",
  p8: "application/pkcs8",
  ac: "application/pkix-attr-cert",
  cer: "application/pkix-cert",
  crl: "application/pkix-crl",
  pkipath: "application/pkix-pkipath",
  pki: "application/pkixcmp",
  pls: "application/pls+xml",
  ai: "application/postscript",
  eps: "application/postscript",
  ps: "application/postscript",
  provx: "application/provenance+xml",
  cww: "application/prs.cww",
  pskcxml: "application/pskc+xml",
  raml: "application/raml+yaml",
  rdf: "application/rdf+xml",
  owl: "application/rdf+xml",
  rif: "application/reginfo+xml",
  rnc: "application/relax-ng-compact-syntax",
  rl: "application/resource-lists+xml",
  rld: "application/resource-lists-diff+xml",
  rs: "application/rls-services+xml",
  rapd: "application/route-apd+xml",
  sls: "application/route-s-tsid+xml",
  rusd: "application/route-usd+xml",
  gbr: "application/rpki-ghostbusters",
  mft: "application/rpki-manifest",
  roa: "application/rpki-roa",
  rsd: "application/rsd+xml",
  rss: "application/rss+xml",
  rtf: "application/rtf",
  sbml: "application/sbml+xml",
  scq: "application/scvp-cv-request",
  scs: "application/scvp-cv-response",
  spq: "application/scvp-vp-request",
  spp: "application/scvp-vp-response",
  sdp: "application/sdp",
  senmlx: "application/senml+xml",
  sensmlx: "application/sensml+xml",
  setpay: "application/set-payment-initiation",
  setreg: "application/set-registration-initiation",
  shf: "application/shf+xml",
  siv: "application/sieve",
  sieve: "application/sieve",
  smi: "application/smil+xml",
  smil: "application/smil+xml",
  rq: "application/sparql-query",
  srx: "application/sparql-results+xml",
  gram: "application/srgs",
  grxml: "application/srgs+xml",
  sru: "application/sru+xml",
  ssdl: "application/ssdl+xml",
  ssml: "application/ssml+xml",
  swidtag: "application/swid+xml",
  tei: "application/tei+xml",
  teicorpus: "application/tei+xml",
  tfi: "application/thraud+xml",
  tsd: "application/timestamped-data",
  toml: "application/toml",
  trig: "application/trig",
  ttml: "application/ttml+xml",
  ubj: "application/ubjson",
  rsheet: "application/urc-ressheet+xml",
  td: "application/urc-targetdesc+xml",
  vxml: "application/voicexml+xml",
  wasm: "application/wasm",
  wgt: "application/widget",
  hlp: "application/winhlp",
  wsdl: "application/wsdl+xml",
  wspolicy: "application/wspolicy+xml",
  xaml: "application/xaml+xml",
  xav: "application/xcap-att+xml",
  xca: "application/xcap-caps+xml",
  xdf: "application/xcap-diff+xml",
  xel: "application/xcap-el+xml",
  xns: "application/xcap-ns+xml",
  xenc: "application/xenc+xml",
  xhtml: "application/xhtml+xml",
  xht: "application/xhtml+xml",
  xlf: "application/xliff+xml",
  xml: "application/xml",
  xsl: "application/xml",
  xsd: "application/xml",
  rng: "application/xml",
  dtd: "application/xml-dtd",
  xop: "application/xop+xml",
  xpl: "application/xproc+xml",
  xslt: "application/xml",
  xspf: "application/xspf+xml",
  mxml: "application/xv+xml",
  xhvml: "application/xv+xml",
  xvml: "application/xv+xml",
  xvm: "application/xv+xml",
  yang: "application/yang",
  yin: "application/yin+xml",
  zip: "application/zip",
  "3gpp": "video/3gpp",
  adp: "audio/adpcm",
  amr: "audio/amr",
  au: "audio/basic",
  snd: "audio/basic",
  mid: "audio/midi",
  midi: "audio/midi",
  kar: "audio/midi",
  rmi: "audio/midi",
  mxmf: "audio/mobile-xmf",
  mp3: "audio/mpeg",
  m4a: "audio/mp4",
  mp4a: "audio/mp4",
  mpga: "audio/mpeg",
  mp2: "audio/mpeg",
  mp2a: "audio/mpeg",
  m2a: "audio/mpeg",
  m3a: "audio/mpeg",
  oga: "audio/ogg",
  ogg: "audio/ogg",
  spx: "audio/ogg",
  opus: "audio/ogg",
  s3m: "audio/s3m",
  sil: "audio/silk",
  wav: "audio/wav",
  weba: "audio/webm",
  xm: "audio/xm",
  ttc: "font/collection",
  otf: "font/otf",
  ttf: "font/ttf",
  woff: "font/woff",
  woff2: "font/woff2",
  exr: "image/aces",
  apng: "image/apng",
  avif: "image/avif",
  bmp: "image/bmp",
  cgm: "image/cgm",
  drle: "image/dicom-rle",
  emf: "image/emf",
  fits: "image/fits",
  g3: "image/g3fax",
  gif: "image/gif",
  heic: "image/heic",
  heics: "image/heic-sequence",
  heif: "image/heif",
  heifs: "image/heif-sequence",
  hej2: "image/hej2k",
  hsj2: "image/hsj2",
  ief: "image/ief",
  jls: "image/jls",
  jp2: "image/jp2",
  jpg2: "image/jp2",
  jpeg: "image/jpeg",
  jpg: "image/jpeg",
  jpe: "image/jpeg",
  jph: "image/jph",
  jhc: "image/jphc",
  jpm: "image/jpm",
  jpx: "image/jpx",
  jpf: "image/jpx",
  jxr: "image/jxr",
  jxra: "image/jxra",
  jxrs: "image/jxrs",
  jxs: "image/jxs",
  jxsc: "image/jxsc",
  jxsi: "image/jxsi",
  jxss: "image/jxss",
  ktx: "image/ktx",
  ktx2: "image/ktx2",
  png: "image/png",
  btif: "image/prs.btif",
  pti: "image/prs.pti",
  sgi: "image/sgi",
  svg: "image/svg+xml",
  svgz: "image/svg+xml",
  t38: "image/t38",
  tif: "image/tiff",
  tiff: "image/tiff",
  tfx: "image/tiff-fx",
  webp: "image/webp",
  wmf: "image/wmf",
  "disposition-notification": "message/disposition-notification",
  u8msg: "message/global",
  u8dsn: "message/global-delivery-status",
  u8mdn: "message/global-disposition-notification",
  u8hdr: "message/global-headers",
  eml: "message/rfc822",
  mime: "message/rfc822",
  "3mf": "model/3mf",
  gltf: "model/gltf+json",
  glb: "model/gltf-binary",
  igs: "model/iges",
  iges: "model/iges",
  msh: "model/mesh",
  mesh: "model/mesh",
  silo: "model/mesh",
  mtl: "model/mtl",
  obj: "model/obj",
  stpz: "model/step+zip",
  stpxz: "model/step-xml+zip",
  stl: "model/stl",
  wrl: "model/vrml",
  vrml: "model/vrml",
  x3db: "model/x3d+fastinfoset",
  x3dbz: "model/x3d+binary",
  x3dv: "model/x3d-vrml",
  x3dvz: "model/x3d+vrml",
  x3d: "model/x3d+xml",
  x3dz: "model/x3d+xml",
  appcache: "text/cache-manifest",
  manifest: "text/cache-manifest",
  ics: "text/calendar",
  ifb: "text/calendar",
  coffee: "text/coffeescript",
  litcoffee: "text/coffeescript",
  css: "text/css",
  csv: "text/csv",
  html: "text/html",
  htm: "text/html",
  shtml: "text/html",
  jade: "text/jade",
  jsx: "text/jsx",
  less: "text/less",
  markdown: "text/markdown",
  md: "text/markdown",
  mml: "text/mathml",
  mdx: "text/mdx",
  n3: "text/n3",
  txt: "text/plain",
  text: "text/plain",
  conf: "text/plain",
  def: "text/plain",
  list: "text/plain",
  log: "text/plain",
  in: "text/plain",
  ini: "text/plain",
  dsc: "text/prs.lines.tag",
  rtx: "text/richtext",
  sgml: "text/sgml",
  sgm: "text/sgml",
  shex: "text/shex",
  slim: "text/slim",
  slm: "text/slim",
  spdx: "text/spdx",
  stylus: "text/stylus",
  styl: "text/stylus",
  tsv: "text/tab-separated-values",
  t: "text/troff",
  tr: "text/troff",
  roff: "text/troff",
  man: "text/troff",
  me: "text/troff",
  ms: "text/troff",
  ttl: "text/turtle",
  uri: "text/uri-list",
  uris: "text/uri-list",
  urls: "text/uri-list",
  vcard: "text/vcard",
  vtt: "text/vtt",
  yaml: "text/yaml",
  yml: "text/yaml",
  "3gp": "video/3gpp",
  "3g2": "video/3gpp2",
  h261: "video/h261",
  h263: "video/h263",
  h264: "video/h264",
  m4s: "video/iso.segment",
  jpgv: "video/jpeg",
  jpgm: "image/jpm",
  mj2: "video/mj2",
  mjp2: "video/mj2",
  ts: "video/mp2t",
  mp4: "video/mp4",
  mp4v: "video/mp4",
  mpg4: "video/mp4",
  mpeg: "video/mpeg",
  mpg: "video/mpeg",
  mpe: "video/mpeg",
  m1v: "video/mpeg",
  m2v: "video/mpeg",
  ogv: "video/ogg",
  qt: "video/quicktime",
  mov: "video/quicktime",
  webm: "video/webm"
};
function lookup(extn) {
  let tmp = ("" + extn).trim().toLowerCase(), idx = tmp.lastIndexOf(".");
  return mimes[~idx ? tmp.substring(++idx) : tmp];
}

// ../cli-kit/dist/public/node/mimes.js
function lookupMimeType(fileName) {
  return lookup(fileName) || "application/octet-stream";
}
function setMimeTypes(newTypes) {
  Object.entries(newTypes).forEach(([extension, mimeType]) => {
    mimes[extension] = mimeType;
  });
}

// ../theme/dist/cli/utilities/theme-fs.js
var DEFAULT_IGNORE_PATTERNS = [
  "**/.git",
  "**/.vscode",
  "**/.hg",
  "**/.bzr",
  "**/.svn",
  "**/_darcs",
  "**/CVS",
  "**/*.sublime-(project|workspace)",
  "**/.DS_Store",
  "**/.sass-cache",
  "**/Thumbs.db",
  "**/desktop.ini",
  "**/config.yml",
  "**/node_modules/",
  ".prettierrc.json"
], THEME_DIRECTORY_PATTERNS = [
  "assets/**/*.*",
  "config/**/*.json",
  "layout/**/*.liquid",
  "locales/**/*.json",
  "sections/**/*.{liquid,json}",
  "blocks/**/*.liquid",
  "snippets/**/*.liquid",
  "templates/**/*.{liquid,json}",
  "templates/customers/**/*.{liquid,json}"
], THEME_PARTITION_REGEX = {
  liquidRegex: /\.liquid$/,
  configRegex: /^config\/(settings_schema|settings_data)\.json$/,
  jsonRegex: /^(?!config\/).*\.json$/,
  contextualizedJsonRegex: /\.context\.[^.]+\.json$/i,
  staticAssetRegex: /^assets\/(?!.*\.liquid$)/
};
async function mountThemeFileSystem(root) {
  let filesPaths = await glob(THEME_DIRECTORY_PATTERNS, {
    cwd: root,
    deep: 3,
    ignore: DEFAULT_IGNORE_PATTERNS
  }), assets = await Promise.all(filesPaths.map(async (key) => checksum(root, key).then((checksum2) => ({
    key,
    checksum: checksum2
  })))), files = new Map(assets.map((asset) => [asset.key, asset]));
  return {
    root,
    files,
    delete: async (assetKey) => {
      await removeThemeFile(root, assetKey), files.delete(assetKey);
    },
    write: async (asset) => {
      await writeThemeFile(root, asset), files.set(asset.key, asset);
    },
    read: async (assetKey) => {
      let fileValue = await readThemeFile(root, assetKey), fileChecksum = await checksum(root, assetKey);
      return files.set(assetKey, buildThemeAsset({
        key: assetKey,
        value: typeof fileValue == "string" ? fileValue : "",
        checksum: fileChecksum,
        attachment: Buffer.isBuffer(fileValue) ? fileValue.toString("base64") : ""
      })), fileValue;
    }
  };
}
async function writeThemeFile(root, { key, attachment, value }) {
  let absolutePath = joinPath(root, key);
  if (await ensureDirExists(absolutePath), attachment) {
    let data = Buffer.from(attachment, "base64");
    await writeFile(absolutePath, data, { encoding: "base64" });
  } else
    await writeFile(absolutePath, value ?? "");
}
async function readThemeFile(root, path3) {
  let options = isTextFile(path3) ? { encoding: "utf8" } : {}, absolutePath = joinPath(root, path3);
  if (!await fileExists(absolutePath)) {
    outputDebug(`File ${absolutePath} can't be read because it doesn't exist...`);
    return;
  }
  return readFile(absolutePath, options);
}
async function removeThemeFile(root, path3) {
  let absolutePath = joinPath(root, path3);
  if (!await fileExists(absolutePath)) {
    outputDebug(`File ${absolutePath} can't be removed because it doesn't exist...`);
    return;
  }
  await removeFile(absolutePath);
}
function isThemeAsset(path3) {
  return path3.startsWith("assets/");
}
function isJson(path3) {
  return lookupMimeType(path3) === "application/json";
}
function partitionThemeFiles(files) {
  let liquidFiles = [], jsonFiles = [], contextualizedJsonFiles = [], configFiles = [], staticAssetFiles = [];
  return files.forEach((file) => {
    let fileKey = file.key;
    THEME_PARTITION_REGEX.liquidRegex.test(fileKey) ? liquidFiles.push(file) : THEME_PARTITION_REGEX.configRegex.test(fileKey) ? configFiles.push(file) : THEME_PARTITION_REGEX.jsonRegex.test(fileKey) ? THEME_PARTITION_REGEX.contextualizedJsonRegex.test(fileKey) ? contextualizedJsonFiles.push(file) : jsonFiles.push(file) : THEME_PARTITION_REGEX.staticAssetRegex.test(fileKey) && staticAssetFiles.push(file);
  }), { liquidFiles, jsonFiles, contextualizedJsonFiles, configFiles, staticAssetFiles };
}
async function readThemeFilesFromDisk(filesToRead, themeFileSystem) {
  outputDebug(`Reading theme files from disk: ${filesToRead.map((file) => file.key).join(", ")}`), await Promise.all(filesToRead.map(async (file) => {
    let fileKey = file.key, themeAsset = themeFileSystem.files.get(fileKey);
    if (themeAsset === void 0) {
      outputDebug(`File ${fileKey} can't be was not found under directory starting with: ${themeFileSystem.root}`);
      return;
    }
    outputDebug(`Reading theme file: ${fileKey}`);
    let fileData = await readThemeFile(themeFileSystem.root, fileKey);
    Buffer.isBuffer(fileData) ? themeAsset.attachment = fileData.toString("base64") : themeAsset.value = fileData, themeFileSystem.files.set(fileKey, themeAsset);
  })), outputDebug("All theme files were read from disk");
}
function isTextFile(path3) {
  return setMimeTypes({
    liquid: "application/liquid",
    sass: "text/x-sass",
    scss: "text/x-scss"
  }), [
    "application/javascript",
    "application/json",
    "application/liquid",
    "text/css",
    "text/x-sass",
    "text/x-scss"
  ].includes(lookupMimeType(path3));
}
async function hasRequiredThemeDirectories(path3) {
  let directories = new Set(await glob("*", {
    cwd: path3,
    deep: 1,
    onlyDirectories: !0
  }));
  return ["config", "layout", "sections", "templates"].every((dir) => directories.has(dir));
}
async function ensureDirExists(path3) {
  let directoryPath = dirPath(path3);
  await fileExists(directoryPath) || await mkdir(directoryPath);
}
function dirPath(filePath) {
  let fileName = basename(filePath), fileNameIndex = filePath.lastIndexOf(fileName);
  return filePath.substring(0, fileNameIndex);
}

// ../theme/dist/cli/utilities/theme-environment/theme-environment.js
init_cjs_shims();

// ../theme/dist/cli/utilities/theme-environment/remote-theme-watcher.js
init_cjs_shims();

// ../theme/dist/cli/utilities/theme-environment/theme-polling.js
init_cjs_shims();

// ../theme/dist/cli/utilities/asset-ignore.js
init_cjs_shims();
var SHOPIFY_IGNORE = ".shopifyignore";
async function applyIgnoreFilters(themeChecksums, themeFileSystem, options = {}) {
  let shopifyIgnore = await shopifyIgnoredPatterns(themeFileSystem), ignoreOptions = options.ignore ?? [], onlyOptions = options.only ?? [];
  return raiseWarningForNonExplicitGlobPatterns([...shopifyIgnore, ...ignoreOptions, ...onlyOptions]), themeChecksums.filter(filterBy(shopifyIgnore, ".shopifyignore")).filter(filterBy(ignoreOptions, "--ignore")).filter(filterBy(onlyOptions, "--only", !0));
}
function filterBy(patterns, type, invertMatch = !1) {
  return ({ key }) => {
    if (patterns.length === 0)
      return !0;
    let match2 = patterns.some((pattern) => matchGlob2(key, pattern) || regexMatch(key, pattern));
    return (invertMatch ? !match2 : match2) ? (outputDebug(`Ignoring theme file ${key} via ${type}...`), !1) : !0;
  };
}
async function shopifyIgnoredPatterns({ root }) {
  let shopifyIgnorePath = joinPath(root, SHOPIFY_IGNORE);
  return await fileExists(shopifyIgnorePath) ? (await readFile(shopifyIgnorePath, { encoding: "utf8" })).split(/(\r\n|\r|\n)/).map((line) => line.trim()).filter((line) => line && !line.startsWith("#")) : [];
}
function matchGlob2(key, pattern) {
  return matchGlob(key, pattern) ? !0 : shouldReplaceGlobPattern(pattern) ? matchGlob(key, pattern.replace("/*.", "/**/*.")) : !1;
}
function raiseWarningForNonExplicitGlobPatterns(patterns) {
  new Set(patterns).forEach((pattern) => {
    shouldReplaceGlobPattern(pattern) && outputWarn(`Warning: The pattern '${pattern}' does not include subdirectories. To maintain backwards compatibility, we have modified your pattern to ${pattern.replace("/*.", "/**/*.")} to explicitly include subdirectories.`);
  });
}
function shouldReplaceGlobPattern(pattern) {
  return pattern.includes("/*.") && !pattern.includes("/**/*.") && pattern.includes("templates/");
}
function regexMatch(key, pattern) {
  try {
    return key.match(pattern);
  } catch {
    return !1;
  }
}

// ../theme/dist/cli/utilities/theme-environment/theme-polling.js
var POLLING_INTERVAL = 3e3, PollingError = class extends Error {
};
function pollThemeEditorChanges(targetTheme, session, remoteChecksum, localFileSystem, options) {
  return outputDebug("Listening for changes in the theme editor"), setTimeout(() => {
    pollRemoteJsonChanges(targetTheme, session, remoteChecksum, localFileSystem, options).then((latestChecksums) => {
      pollThemeEditorChanges(targetTheme, session, latestChecksums, localFileSystem, options);
    }).catch((err2) => {
      if (err2 instanceof PollingError)
        renderError({ body: err2.message });
      else
        throw err2;
    });
  }, POLLING_INTERVAL);
}
async function pollRemoteJsonChanges(targetTheme, currentSession, remoteChecksums, localFileSystem, options) {
  let previousChecksums = await applyFileFilters(remoteChecksums, localFileSystem, options), latestChecksums = await fetchChecksums(targetTheme.id, currentSession).then((checksums) => applyFileFilters(checksums, localFileSystem, options)), changedAssets = getAssetsChangedOnRemote(previousChecksums, latestChecksums), deletedAssets = getAssetsDeletedFromRemote(latestChecksums, previousChecksums);
  return await abortIfMultipleSourcesChange(localFileSystem, changedAssets), await syncChangedAssets(targetTheme, currentSession, localFileSystem, changedAssets), await deleteRemovedAssets(localFileSystem, deletedAssets, options), latestChecksums;
}
function getAssetsDeletedFromRemote(latestChecksums, previousChecksums) {
  let latestChecksumsMap = new Map(latestChecksums.map((checksum2) => [checksum2.key, checksum2]));
  return previousChecksums.filter((previousChecksum) => latestChecksumsMap.get(previousChecksum.key) === void 0);
}
function getAssetsChangedOnRemote(previousChecksums, latestChecksums) {
  let previousChecksumsMap = new Map(previousChecksums.map((checksum2) => [checksum2.key, checksum2]));
  return latestChecksums.filter((latestAsset) => {
    let previousAsset = previousChecksumsMap.get(latestAsset.key);
    if (!previousAsset || previousAsset.checksum !== latestAsset.checksum)
      return !0;
  });
}
async function syncChangedAssets(targetTheme, currentSession, localFileSystem, assetsChangedOnRemote) {
  await Promise.all(assetsChangedOnRemote.map(async (file) => {
    if (localFileSystem.files.get(file.key)?.checksum === file.checksum)
      return;
    let asset = await fetchThemeAsset(targetTheme.id, file.key, currentSession);
    asset && (await localFileSystem.write(asset), renderText({ text: `Synced: get '${asset.key}' from remote theme` }));
  }));
}
function deleteRemovedAssets(localFileSystem, assetsDeletedFromRemote, options) {
  if (!options.noDelete)
    return Promise.all(assetsDeletedFromRemote.map((file) => localFileSystem.delete(file.key).then(() => {
      renderText({ text: `Synced: remove '${file.key}' from local theme` });
    })));
}
async function abortIfMultipleSourcesChange(localFileSystem, assetsChangedOnRemote) {
  let previousFileValues = new Map(localFileSystem.files);
  await Promise.all(assetsChangedOnRemote.map((file) => localFileSystem.read(file.key)));
  for (let asset of assetsChangedOnRemote) {
    let previousChecksum = previousFileValues.get(asset.key)?.checksum, newChecksum = localFileSystem.files.get(asset.key)?.checksum;
    if (previousChecksum !== newChecksum)
      throw new PollingError(`Detected changes to the file '${asset.key}' on both local and remote sources. Aborting...`);
  }
}
async function applyFileFilters(files, localThemeFileSystem, options) {
  return (await applyIgnoreFilters(files, localThemeFileSystem, options)).filter((file) => file.key.endsWith(".json"));
}

// ../theme/dist/cli/utilities/theme-environment/theme-reconciliation.js
init_cjs_shims();
async function reconcileJsonFiles(targetTheme, session, remoteChecksums, localThemeFileSystem, options) {
  let { filesOnlyPresentLocally, filesOnlyPresentOnRemote, filesWithConflictingChecksums } = await identifyFilesToReconcile(remoteChecksums, localThemeFileSystem, options);
  if (filesOnlyPresentLocally.length === 0 && filesOnlyPresentOnRemote.length === 0 && filesWithConflictingChecksums.length === 0)
    return outputDebug("Local and remote checksums match - no need to reconcile theme assets"), localThemeFileSystem;
  let partitionedFiles = await partitionFilesByReconciliationStrategy({
    filesOnlyPresentLocally,
    filesOnlyPresentOnRemote,
    filesWithConflictingChecksums
  }, options);
  await performFileReconciliation(targetTheme, session, localThemeFileSystem, partitionedFiles);
}
async function identifyFilesToReconcile(remoteChecksums, localThemeFileSystem, options) {
  let remoteChecksumKeys = /* @__PURE__ */ new Set(), filesOnlyPresentOnRemote = [], filesWithConflictingChecksums = [];
  for (let remoteChecksum of remoteChecksums) {
    remoteChecksumKeys.add(remoteChecksum.key);
    let localChecksum = localThemeFileSystem.files.get(remoteChecksum.key);
    localChecksum ? remoteChecksum.checksum !== localChecksum.checksum && filesWithConflictingChecksums.push(remoteChecksum) : filesOnlyPresentOnRemote.push(remoteChecksum);
  }
  let filesOnlyPresentLocally = Array.from(localThemeFileSystem.files.values()).filter((asset) => !remoteChecksumKeys.has(asset.key)), filterOptions = {
    only: options.only,
    ignore: options.ignore
  }, [filteredFilesOnlyPresentOnRemote, filteredFilesOnlyPresentLocally, filteredFilesWithConflictingChecksums] = await Promise.all([
    applyFileFilters2(filesOnlyPresentOnRemote, localThemeFileSystem, filterOptions),
    applyFileFilters2(filesOnlyPresentLocally, localThemeFileSystem, filterOptions),
    applyFileFilters2(filesWithConflictingChecksums, localThemeFileSystem, filterOptions)
  ]);
  return {
    filesOnlyPresentOnRemote: filteredFilesOnlyPresentOnRemote,
    filesOnlyPresentLocally: filteredFilesOnlyPresentLocally,
    filesWithConflictingChecksums: filteredFilesWithConflictingChecksums
  };
}
async function applyFileFilters2(files, localThemeFileSystem, options) {
  return (await applyIgnoreFilters(files, localThemeFileSystem, options)).filter((file) => file.key.endsWith(".json"));
}
async function promptFileReconciliationStrategy(files, title, options) {
  if (files.length === 0)
    return;
  renderInfo({
    body: {
      list: {
        title,
        items: files.map((file) => file.key)
      }
    }
  }), await renderSelectPrompt({
    message: "Reconciliation Strategy",
    choices: [
      { label: options.remote.label, value: REMOTE_STRATEGY },
      { label: options.local.label, value: LOCAL_STRATEGY }
    ]
  }) === REMOTE_STRATEGY ? options.remote.callback(files) : options.local.callback(files);
}
async function performFileReconciliation(targetTheme, session, localThemeFileSystem, partitionedFiles) {
  let { localFilesToDelete, filesToDownload, remoteFilesToDelete } = partitionedFiles, deleteLocalFiles = localFilesToDelete.map((file) => localThemeFileSystem.delete(file.key)), downloadRemoteFiles = filesToDownload.map(async (file) => {
    let asset = await fetchThemeAsset(targetTheme.id, file.key, session);
    if (asset)
      return localThemeFileSystem.write(asset);
  }), deleteRemoteFiles = remoteFilesToDelete.map((file) => deleteThemeAsset(targetTheme.id, file.key, session));
  (downloadRemoteFiles.length > 0 || deleteRemoteFiles.length > 0) && renderInfo({
    body: "Starting file synchronization. This may take a while if there are many or large files to download..."
  }), await Promise.all([...deleteLocalFiles, ...downloadRemoteFiles, ...deleteRemoteFiles]);
}
async function partitionFilesByReconciliationStrategy(files, options) {
  let { filesOnlyPresentLocally, filesOnlyPresentOnRemote, filesWithConflictingChecksums } = files, localFilesToDelete = [], filesToDownload = [], remoteFilesToDelete = [];
  return options.noDelete || await promptFileReconciliationStrategy(filesOnlyPresentLocally, "The files listed below are only present locally. What would you like to do?", {
    remote: {
      label: "Delete files from the local directory",
      callback: (files2) => {
        localFilesToDelete.push(...files2);
      }
    },
    local: {
      label: "Upload local files to the remote theme",
      callback: () => {
      }
    }
  }), await promptFileReconciliationStrategy(filesOnlyPresentOnRemote, "The files listed below are only present on the remote theme. What would you like to do?", {
    remote: {
      label: "Download remote files to the local directory",
      callback: (files2) => {
        filesToDownload.push(...files2);
      }
    },
    local: {
      label: "Delete files from the remote theme",
      callback: (files2) => {
        remoteFilesToDelete.push(...files2);
      }
    }
  }), await promptFileReconciliationStrategy(filesWithConflictingChecksums, "The files listed below differ between the local and remote versions. What would you like to do?", {
    remote: {
      label: "Keep the remote version",
      callback: (files2) => {
        filesToDownload.push(...files2);
      }
    },
    local: {
      label: "Keep the local version",
      callback: () => {
      }
    }
  }), { localFilesToDelete, filesToDownload, remoteFilesToDelete };
}

// ../theme/dist/cli/utilities/theme-environment/remote-theme-watcher.js
var LOCAL_STRATEGY = "local", REMOTE_STRATEGY = "remote";
async function reconcileAndPollThemeEditorChanges(targetTheme, session, remoteChecksums, localThemeFileSystem, options) {
  outputDebug("Initiating theme asset reconciliation process"), await reconcileJsonFiles(targetTheme, session, remoteChecksums, localThemeFileSystem, options);
  let updatedRemoteChecksums = await fetchChecksums(targetTheme.id, session), themeFileSystem = await mountThemeFileSystem(localThemeFileSystem.root);
  pollThemeEditorChanges(targetTheme, session, updatedRemoteChecksums, themeFileSystem, options);
}

// ../theme/dist/cli/utilities/theme-uploader.js
init_cjs_shims();
var MAX_BATCH_FILE_COUNT = 10, MAX_BATCH_BYTESIZE = 102400, MAX_UPLOAD_RETRY_COUNT = 2;
async function uploadTheme(theme, session, checksums, themeFileSystem, options = {}) {
  let remoteChecksums = rejectGeneratedStaticAssets(checksums), uploadResults = /* @__PURE__ */ new Map(), deleteTasks = await buildDeleteTasks(remoteChecksums, themeFileSystem, options, theme, session), uploadTasks = await buildUploadTasks(remoteChecksums, themeFileSystem, options, theme, session, uploadResults);
  return await renderTasksToStdErr(deleteTasks), await renderTasksToStdErr(uploadTasks), reportFailedUploads(uploadResults), uploadResults;
}
async function buildDeleteTasks(remoteChecksums, themeFileSystem, options, theme, session) {
  if (options.nodelete)
    return [];
  let filteredChecksums = await applyIgnoreFilters(remoteChecksums, themeFileSystem, options), remoteFilesToBeDeleted = await getRemoteFilesToBeDeleted(filteredChecksums, themeFileSystem, options);
  return orderFilesToBeDeleted(remoteFilesToBeDeleted).map((file) => ({
    title: `Cleaning your remote theme (removing ${file.key})`,
    task: async () => {
      await deleteThemeAsset(theme.id, file.key, session);
    }
  }));
}
async function getRemoteFilesToBeDeleted(remoteChecksums, themeFileSystem, options) {
  let localKeys = new Set(themeFileSystem.files.keys()), filesToBeDeleted = (await applyIgnoreFilters(remoteChecksums, themeFileSystem, options)).filter((checksum2) => !localKeys.has(checksum2.key));
  return outputDebug(`Files to be deleted:
${filesToBeDeleted.map((file) => `-${file.key}`).join(`
`)}`), filesToBeDeleted;
}
function orderFilesToBeDeleted(files) {
  let { contextualizedJsonFiles, jsonFiles, liquidFiles, configFiles, staticAssetFiles } = partitionThemeFiles(files);
  return [...contextualizedJsonFiles, ...jsonFiles, ...liquidFiles, ...configFiles, ...staticAssetFiles];
}
async function buildUploadTasks(remoteChecksums, themeFileSystem, options, theme, session, uploadResults) {
  let filesToUpload = await selectUploadableFiles(themeFileSystem, remoteChecksums, options);
  return await readThemeFilesFromDisk(filesToUpload, themeFileSystem), createUploadTasks(filesToUpload, themeFileSystem, session, theme, uploadResults);
}
async function selectUploadableFiles(themeFileSystem, remoteChecksums, options) {
  let localChecksums = calculateLocalChecksums(themeFileSystem), filteredLocalChecksums = await applyIgnoreFilters(localChecksums, themeFileSystem, options), remoteChecksumsMap = /* @__PURE__ */ new Map();
  remoteChecksums.forEach((remote) => {
    remoteChecksumsMap.set(remote.key, remote);
  });
  let filesToUpload = filteredLocalChecksums.filter((local) => {
    let remote = remoteChecksumsMap.get(local.key);
    return !remote || remote.checksum !== local.checksum;
  });
  return outputDebug(`Files to be uploaded:
${filesToUpload.map((file) => `-${file.key}`).join(`
`)}`), filesToUpload;
}
async function createUploadTasks(filesToUpload, themeFileSystem, session, theme, uploadResults) {
  let orderedFiles = orderFilesToBeUploaded(filesToUpload), currentFileCount = 0, totalFileCount = filesToUpload.length, uploadTasks = [];
  for (let fileType of orderedFiles) {
    let { tasks: newTasks, updatedFileCount } = await createUploadTaskForFileType(fileType, themeFileSystem, session, uploadResults, theme.id, totalFileCount, currentFileCount);
    currentFileCount = updatedFileCount, uploadTasks.push(...newTasks);
  }
  return uploadTasks;
}
function orderFilesToBeUploaded(files) {
  let { liquidFiles, jsonFiles, contextualizedJsonFiles, configFiles, staticAssetFiles } = partitionThemeFiles(files);
  return [liquidFiles, jsonFiles, contextualizedJsonFiles, configFiles, staticAssetFiles];
}
async function createUploadTaskForFileType(checksums, themeFileSystem, session, uploadResults, themeId, totalFileCount, currentFileCount) {
  if (checksums.length === 0)
    return { tasks: [], updatedFileCount: currentFileCount };
  let batches = await createBatches(checksums, themeFileSystem.root);
  return createBatchedUploadTasks(batches, themeFileSystem, session, uploadResults, themeId, totalFileCount, currentFileCount);
}
function createBatchedUploadTasks(batches, themeFileSystem, session, uploadResults, themeId, totalFileCount, currentFileCount) {
  let runningFileCount = currentFileCount;
  return {
    tasks: batches.map((batch) => (runningFileCount += batch.length, {
      title: `Uploading files to remote theme [${Math.round(runningFileCount / totalFileCount * 100)}%]`,
      task: async () => uploadBatch(batch, themeFileSystem, session, themeId, uploadResults)
    })),
    updatedFileCount: runningFileCount
  };
}
async function createBatches(files, path3) {
  let fileSizes = await Promise.all(files.map((file) => fileSize(`${path3}/${file.key}`))), batches = [], currentBatch = [], currentBatchSize = 0;
  return files.forEach((file, index) => {
    let hasEnoughItems = currentBatch.length >= MAX_BATCH_FILE_COUNT, hasEnoughByteSize = currentBatchSize >= MAX_BATCH_BYTESIZE;
    (hasEnoughItems || hasEnoughByteSize) && (batches.push(currentBatch), currentBatch = [], currentBatchSize = 0), currentBatch.push(file), currentBatchSize += fileSizes[index] ?? 0;
  }), currentBatch.length > 0 && batches.push(currentBatch), batches;
}
function calculateLocalChecksums(localThemeFileSystem) {
  let checksums = [];
  return localThemeFileSystem.files.forEach((value, key) => {
    checksums.push({
      key,
      checksum: value.checksum
    });
  }), checksums;
}
async function uploadBatch(batch, localThemeFileSystem, session, themeId, uploadResults) {
  let uploadParams = batch.map((file) => {
    let value = localThemeFileSystem.files.get(file.key)?.value, attachment = localThemeFileSystem.files.get(file.key)?.attachment;
    return {
      key: file.key,
      ...value && { value },
      ...attachment && { attachment }
    };
  });
  outputDebug(`Uploading the following files:
${batch.map((file) => `-${file.key}`).join(`
`)}`), (await handleBulkUpload(uploadParams, themeId, session)).forEach((result) => {
    uploadResults.set(result.key, result);
  });
}
async function handleBulkUpload(uploadParams, themeId, session, count = 0) {
  if (uploadParams.length === 0)
    return [];
  count > 0 && outputDebug(`Retry Attempt ${count}/${MAX_UPLOAD_RETRY_COUNT} for the following files:
      ${uploadParams.map((param) => `-${param.key}`).join(`
`)}`);
  let results = await bulkUploadThemeAssets(themeId, uploadParams, session);
  outputDebug(`File Upload Results:
${results.map((result) => `-${result.key}: ${result.success ? "success" : "failure"}`).join(`
`)}`);
  let failedUploadResults = results.filter((result) => result.success === !1);
  if (failedUploadResults.length > 0) {
    outputDebug(`The following files failed to upload:
${failedUploadResults.map((param) => `-${param.key}`).join(`
`)}`);
    let failedResults = await handleFailedUploads(failedUploadResults, uploadParams, themeId, session, count);
    return results.concat(failedResults);
  }
  return results;
}
async function handleFailedUploads(failedUploadResults, uploadParams, themeId, session, count) {
  let failedUploadsSet = new Set(failedUploadResults.map((result) => result.key)), failedUploadParams = uploadParams.filter((param) => failedUploadsSet.has(param.key));
  return count === MAX_UPLOAD_RETRY_COUNT ? (outputDebug(`Max retry count reached for the following files:
${failedUploadParams.map((param) => `-${param.key}`).join(`
`)}`), failedUploadResults) : handleBulkUpload(failedUploadParams, themeId, session, count + 1);
}
function reportFailedUploads(uploadResults) {
  for (let [key, result] of uploadResults.entries())
    if (!result.success) {
      let errorMessage2 = result.errors?.asset?.map((err2) => `-${err2}`).join(`
`);
      outputWarn(`Failed to upload file ${key}:`), outputInfo(`${errorMessage2}`), outputNewline();
    }
}

// ../theme/dist/cli/utilities/theme-environment/theme-environment.js
async function setupDevServer(theme, ctx, onReady) {
  await ensureThemeEnvironmentSetup(theme, ctx), await startDevelopmentServer(theme, ctx), onReady();
}
async function ensureThemeEnvironmentSetup(theme, ctx) {
  ctx.options.themeEditorSync && await reconcileAndPollThemeEditorChanges(theme, ctx.session, ctx.remoteChecksums, ctx.localThemeFileSystem, {
    noDelete: ctx.options.noDelete,
    ignore: ctx.options.ignore,
    only: ctx.options.only
  }), await uploadTheme(theme, ctx.session, ctx.remoteChecksums, ctx.localThemeFileSystem, {
    nodelete: ctx.options.noDelete,
    ignore: ctx.options.ignore,
    only: ctx.options.only
  });
}
async function startDevelopmentServer(_theme, _ctx) {
}

// ../theme/dist/cli/services/dev.js
var DEFAULT_HOST = "127.0.0.1", DEFAULT_PORT = "9292", THEME_REFRESH_TIMEOUT_IN_MS = 110 * 60 * 1e3;
async function dev(options) {
  if (!options["dev-preview"]) {
    await legacyDev(options);
    return;
  }
  if (!await hasRequiredThemeDirectories(options.directory) && !await currentDirectoryConfirmed(options.force))
    return;
  options.flagsToPass.includes("--poll") && renderWarning({
    body: "The CLI flag --[flag-name] is now deprecated and will be removed in future releases. It is no longer necessary with the new implementation. Please update your usage accordingly."
  }), outputInfo("This feature is currently in development and is not ready for use or testing yet.");
  let remoteChecksums = await fetchChecksums(options.theme.id, options.adminSession), localThemeFileSystem = await mountThemeFileSystem(options.directory), session = {
    ...options.adminSession,
    storefrontToken: options.storefrontToken,
    expiresAt: /* @__PURE__ */ new Date()
  }, host = options.host || DEFAULT_HOST, port = options.port || DEFAULT_PORT, ctx = {
    session,
    remoteChecksums,
    localThemeFileSystem,
    options: {
      themeEditorSync: options["theme-editor-sync"],
      host,
      port,
      open: options.open,
      liveReload: options["live-reload"],
      noDelete: options.noDelete,
      ignore: options.ignore,
      only: options.only
    }
  };
  await setupDevServer(options.theme, ctx, () => {
    renderLinks(options.store, options.theme.id.toString(), host, port);
  });
}
async function legacyDev(options) {
  if (!await hasRequiredThemeDirectories(options.directory) && !await currentDirectoryConfirmed(options.force))
    return;
  let adminToken = options.adminSession.token, storefrontToken = options.storefrontToken;
  renderLinks(options.store, options.theme.id.toString(), options.host, options.port);
  let command = ["theme", "serve", options.directory, ...options.flagsToPass];
  options.open && useEmbeddedThemeCLI() && command.push("--open"), !options.password && useEmbeddedThemeCLI() && (adminToken = void 0, storefrontToken = void 0, setInterval(() => {
    outputDebug("Refreshing theme session tokens..."), refreshTokens(options.store, options.password);
  }, THEME_REFRESH_TIMEOUT_IN_MS)), await execCLI2(command, { store: options.store, adminToken, storefrontToken });
}
function renderLinks(store, themeId, host = DEFAULT_HOST, port = DEFAULT_PORT) {
  renderSuccess({
    body: [
      {
        list: {
          title: { bold: "Preview your theme" },
          items: [
            {
              link: {
                url: `http://${host}:${port}`
              }
            }
          ]
        }
      }
    ],
    nextSteps: [
      [
        {
          link: {
            label: "Customize your theme at the theme editor",
            url: `https://${store}/admin/themes/${themeId}/editor`
          }
        }
      ],
      [
        {
          link: {
            label: "Share your theme preview",
            url: `https://${store}/?preview_theme_id=${themeId}`
          }
        },
        {
          subdued: `(https://${store}/?preview_theme_id=${themeId})`
        }
      ]
    ]
  });
}
function showDeprecationWarnings(args) {
  let eFlagIndex = args.findIndex((arg) => arg === "-e");
  eFlagIndex >= 0 && (!args[eFlagIndex + 1] || args[eFlagIndex + 1]?.startsWith("-")) && renderWarning({
    body: [
      "If you want to enable synchronization with Theme Editor, please use",
      { command: "--theme-editor-sync" },
      { char: "." },
      "The shortcut",
      { command: "-e" },
      "is now reserved for environments."
    ]
  });
}
async function refreshTokens(store, password) {
  let adminSession = await ensureAuthenticatedThemes(store, password, [], !0), storefrontToken = await ensureAuthenticatedStorefront([], password);
  return useEmbeddedThemeCLI() && await execCLI2(["theme", "token", "--admin", adminSession.token, "--sfr", storefrontToken]), { adminSession, storefrontToken };
}

// ../theme/dist/cli/utilities/embedded-cli-warning.js
init_cjs_shims();
function showEmbeddedCLIWarning() {
  useEmbeddedThemeCLI() || renderWarning({
    headline: ["`SHOPIFY_CLI_BUNDLED_THEME_CLI` is deprecated."],
    body: [
      "The",
      {
        command: "SHOPIFY_CLI_BUNDLED_THEME_CLI"
      },
      "environment variable has been deprecated and should be used for debugging purposes only. If this variable is essential to your workflow, please report an issue at",
      {
        link: {
          url: "https://github.com/Shopify/cli/issues"
        }
      },
      {
        char: "."
      }
    ]
  });
}

// ../theme/dist/cli/commands/theme/dev.js
var import_core6 = __toESM(require_lib(), 1);
var _a4, Dev = class extends ThemeCommand {
  /**
   * Executes the theme serve command.
   * Every 110 minutes, it will refresh the session token.
   */
  async run() {
    showEmbeddedCLIWarning(), showDeprecationWarnings(this.argv);
    let flags = (await this.parse(_a4)).flags, store = ensureThemeStore(flags), { ignore = [], only = [] } = flags, { adminSession, storefrontToken } = await refreshTokens(store, flags.password), theme;
    if (flags.theme) {
      let filter = { filter: { theme: flags.theme } };
      theme = await findOrSelectTheme(adminSession, filter), flags = { ...flags, theme: theme.id.toString() };
    } else {
      theme = await new DevelopmentThemeManager(adminSession).findOrCreate();
      let overwriteJson = flags["theme-editor-sync"] && theme.createdAtRuntime;
      flags = { ...flags, theme: theme.id.toString(), "overwrite-json": overwriteJson };
    }
    let flagsToPass = this.passThroughFlags(flags, { allowedFlags: _a4.cli2Flags });
    await dev({
      adminSession,
      storefrontToken,
      directory: flags.path,
      store,
      password: flags.password,
      theme,
      host: flags.host,
      port: flags.port,
      "live-reload": flags["live-reload"],
      force: flags.force,
      open: flags.open,
      flagsToPass,
      "dev-preview": flags["dev-preview"],
      "theme-editor-sync": flags["theme-editor-sync"],
      noDelete: flags.nodelete,
      ignore,
      only
    });
  }
};
_a4 = Dev;
Dev.summary = "Uploads the current theme as a development theme to the connected store, then prints theme editor and preview URLs to your terminal. While running, changes will push to the store in real time.";
Dev.descriptionWithMarkdown = `
  Uploads the current theme as the specified theme, or a [development theme](https://shopify.dev/docs/themes/tools/cli#development-themes), to a store so you can preview it.

This command returns the following information:

- A link to your development theme at http://127.0.0.1:9292. This URL can hot reload local changes to CSS and sections, or refresh the entire page when a file changes, enabling you to preview changes in real time using the store's data.

  You can specify a different network interface and port using \`--host\` and \`--port\`.

- A link to the [editor](https://shopify.dev/docs/themes/tools/online-editor) for the theme in the Shopify admin.

- A [preview link](https://help.shopify.com/manual/online-store/themes/adding-themes#share-a-theme-preview-with-others) that you can share with other developers.

If you already have a development theme for your current environment, then this command replaces the development theme with your local theme. You can override this using the \`--theme-editor-sync\` flag.

> Note: You can't preview checkout customizations using http://127.0.0.1:9292.

Development themes are deleted when you run \`shopify auth logout\`. If you need a preview link that can be used after you log out, then you should [share](https://shopify.dev/docs/api/shopify-cli/theme/theme-share) your theme or [push](https://shopify.dev/docs/api/shopify-cli/theme/theme-push) to an unpublished theme on your store.

You can run this command only in a directory that matches the [default Shopify theme folder structure](https://shopify.dev/docs/themes/tools/cli#directory-structure).`;
Dev.description = _a4.descriptionWithoutMarkdown();
Dev.flags = {
  ...globalFlags,
  path: themeFlags.path,
  host: import_core6.Flags.string({
    description: "Set which network interface the web server listens on. The default value is 127.0.0.1.",
    env: "SHOPIFY_FLAG_HOST"
  }),
  "live-reload": import_core6.Flags.string({
    description: `The live reload mode switches the server behavior when a file is modified:
- hot-reload Hot reloads local changes to CSS and sections (default)
- full-page  Always refreshes the entire page
- off        Deactivate live reload`,
    default: "hot-reload",
    options: ["hot-reload", "full-page", "off"],
    env: "SHOPIFY_FLAG_LIVE_RELOAD"
  }),
  poll: import_core6.Flags.boolean({
    description: "Force polling to detect file changes.",
    env: "SHOPIFY_FLAG_POLL"
  }),
  "theme-editor-sync": import_core6.Flags.boolean({
    description: "Synchronize Theme Editor updates in the local theme files.",
    env: "SHOPIFY_FLAG_THEME_EDITOR_SYNC"
  }),
  port: import_core6.Flags.string({
    description: "Local port to serve theme preview from.",
    env: "SHOPIFY_FLAG_PORT"
  }),
  store: themeFlags.store,
  theme: import_core6.Flags.string({
    char: "t",
    description: "Theme ID or name of the remote theme.",
    env: "SHOPIFY_FLAG_THEME_ID"
  }),
  nodelete: import_core6.Flags.boolean({
    char: "n",
    description: "Prevents files from being deleted in the remote theme when a file has been deleted locally. This applies to files that are deleted while the command is running, and files that have been deleted locally before the command is run.",
    env: "SHOPIFY_FLAG_NODELETE"
  }),
  only: import_core6.Flags.string({
    char: "o",
    multiple: !0,
    description: "Hot reload only files that match the specified pattern.",
    env: "SHOPIFY_FLAG_ONLY"
  }),
  ignore: import_core6.Flags.string({
    char: "x",
    multiple: !0,
    description: "Skip hot reloading any files that match the specified pattern.",
    env: "SHOPIFY_FLAG_IGNORE"
  }),
  stable: import_core6.Flags.boolean({
    hidden: !0,
    description: "Performs the upload by relying in the legacy upload approach (slower, but it might be more stable in some scenarios)",
    env: "SHOPIFY_FLAG_STABLE"
  }),
  force: import_core6.Flags.boolean({
    hidden: !0,
    char: "f",
    description: "Proceed without confirmation, if current directory does not seem to be theme directory.",
    env: "SHOPIFY_FLAG_FORCE"
  }),
  password: themeFlags.password,
  environment: themeFlags.environment,
  notify: import_core6.Flags.string({
    description: "The file path or URL. The file path is to a file that you want updated on idle. The URL path is where you want a webhook posted to report on file changes.",
    env: "SHOPIFY_FLAG_NOTIFY"
  }),
  open: import_core6.Flags.boolean({
    description: "Automatically launch the theme preview in your default web browser.",
    env: "SHOPIFY_FLAG_OPEN",
    default: !1
  }),
  "dev-preview": import_core6.Flags.boolean({
    hidden: !0,
    description: "Enables the developer preview for the upcoming `theme dev` implementation.",
    env: "SHOPIFY_FLAG_BETA"
  })
};
Dev.cli2Flags = [
  "host",
  "live-reload",
  "poll",
  "theme-editor-sync",
  "overwrite-json",
  "port",
  "theme",
  "nodelete",
  "only",
  "ignore",
  "stable",
  "force",
  "notify"
];
var dev_default = Dev;

// ../theme/dist/cli/commands/theme/info.js
init_cjs_shims();

// ../theme/dist/cli/services/info.js
init_cjs_shims();
function themeInfoJSON(theme, adminSession) {
  return {
    theme: {
      id: theme.id,
      name: theme.name,
      role: theme.role,
      shop: adminSession.storeFqdn,
      preview_url: themePreviewUrl(theme, adminSession),
      editor_url: themeEditorUrl(theme, adminSession)
    }
  };
}
async function fetchThemeInfo(adminSession, options) {
  let theme;
  if (options.development)
    theme = await new DevelopmentThemeManager(adminSession).findOrCreate();
  else {
    let filter = { filter: { theme: options.theme } };
    theme = await findOrSelectTheme(adminSession, filter);
  }
  return theme ? themeInfoJSON(theme, adminSession) : void 0;
}
async function fetchDevInfo(config2) {
  return [devConfigSection(), await systemInfoSection(config2)].map((sectionContents) => formatSection(...sectionContents)).join(`

`);
}
function devConfigSection() {
  let title = "Theme Configuration", store = getThemeStore() || "Not configured", developmentTheme = getDevelopmentTheme();
  return developmentTheme = developmentTheme ? `#${developmentTheme}` : "Not set", [title, `${linesToColumns([
    ["Store", store],
    ["Development Theme ID", developmentTheme]
  ])}`];
}
async function systemInfoSection(config2) {
  let title = "Tooling and System", { platform: platform2, arch } = platformAndArch(), ruby = await version() || "Not installed", lines = [
    ["Shopify CLI", await cliVersionInfo(config2)],
    ["OS", `${platform2}-${arch}`],
    ["Shell", process.env.SHELL || "unknown"],
    ["Node version", process.version],
    ["Ruby version", ruby]
  ];
  return [title, `${linesToColumns(lines)}`];
}
async function cliVersionInfo(config2) {
  let newestVersion = await checkForNewVersion("@shopify/cli", config2.cliVersion);
  if (!newestVersion)
    return config2.cliVersion;
  let upgradeMessage = getOutputUpdateCLIReminder(newestVersion);
  return [config2.cliVersion, upgradeMessage].join(" ").trim();
}

// ../theme/dist/cli/commands/theme/info.js
var import_core7 = __toESM(require_lib(), 1);
var Info = class _Info extends ThemeCommand {
  async run() {
    let { flags } = await this.parse(_Info), store = ensureThemeStore(flags), adminSession = await ensureAuthenticatedThemes(store, flags.password);
    if (flags.theme || flags.development) {
      let output = await fetchThemeInfo(adminSession, flags);
      if (!output)
        throw new AbortError("Theme not found!");
      if (flags.json)
        return outputInfo(JSON.stringify(output, null, 2));
      let infoMessage = Object.entries(output.theme).map(([key, val]) => formatSection(key, `${val}`)).join(`

`);
      outputInfo(infoMessage);
    } else {
      let infoMessage = await fetchDevInfo({ cliVersion: this.config.version });
      outputInfo(infoMessage);
    }
  }
};
Info.description = "Displays information about your theme environment, including your current store. Can also retrieve information about a specific theme.";
Info.flags = {
  ...globalFlags,
  store: themeFlags.store,
  password: themeFlags.password,
  environment: themeFlags.environment,
  development: import_core7.Flags.boolean({
    char: "d",
    description: "Retrieve info from your development theme.",
    env: "SHOPIFY_FLAG_DEVELOPMENT"
  }),
  theme: import_core7.Flags.string({
    char: "t",
    description: "Theme ID or name of the remote theme.",
    env: "SHOPIFY_FLAG_THEME_ID"
  }),
  json: import_core7.Flags.boolean({
    description: "Output the theme info as JSON.",
    default: !1,
    env: "SHOPIFY_FLAG_JSON"
  })
};
var info_default = Info;

// ../theme/dist/cli/commands/theme/init.js
init_cjs_shims();

// ../theme/dist/cli/services/init.js
init_cjs_shims();
async function cloneRepo(repoUrl, destination) {
  await downloadRepository(repoUrl, destination);
}
async function cloneRepoAndCheckoutLatestTag(repoUrl, destination) {
  await downloadRepository(repoUrl, destination, !0);
}
async function downloadRepository(repoUrl, destination, latestTag) {
  await renderTasks([
    {
      title: `Cloning ${repoUrl} into ${destination}`,
      task: async () => {
        await downloadGitRepository({
          repoUrl,
          destination,
          latestTag
        });
      }
    }
  ]);
}

// ../theme/dist/cli/commands/theme/init.js
var import_core8 = __toESM(require_lib(), 1);
var _a5, Init = class extends ThemeCommand {
  async run() {
    let { args, flags } = await this.parse(_a5), name = args.name || await this.promptName(flags.path), repoUrl = flags["clone-url"], destination = joinPath(flags.path, name);
    flags.latest ? await cloneRepoAndCheckoutLatestTag(repoUrl, destination) : await cloneRepo(repoUrl, destination);
  }
  async promptName(directory) {
    let defaultName = await generateRandomNameForSubdirectory({ suffix: "theme", directory, family: "creative" });
    return renderTextPrompt({ message: "Name of the new theme", defaultValue: defaultName });
  }
};
_a5 = Init;
Init.summary = "Clones a Git repository to use as a starting point for building a new theme.";
Init.usage = "theme:init [name]";
Init.descriptionWithMarkdown = `Clones a Git repository to your local machine to use as the starting point for building a theme.

  If no Git repository is specified, then this command creates a copy of [Dawn](https://github.com/Shopify/dawn), Shopify's example theme, with the specified name in the current folder. If no name is provided, then you're prompted to enter one.

  > Caution: If you're building a theme for the Shopify Theme Store, then you can use Dawn as a starting point. However, the theme that you submit needs to be [substantively different from Dawn](https://shopify.dev/docs/themes/store/requirements#uniqueness) so that it provides added value for users. Learn about the [ways that you can use Dawn](https://shopify.dev/docs/themes/tools/dawn#ways-to-use-dawn).
  `;
Init.description = _a5.descriptionWithoutMarkdown();
Init.args = {
  name: import_core8.Args.string({
    name: "name",
    description: "Name of the new theme",
    required: !1
  })
};
Init.flags = {
  ...globalFlags,
  path: themeFlags.path,
  "clone-url": import_core8.Flags.string({
    char: "u",
    default: "https://github.com/Shopify/dawn.git",
    description: "The Git URL to clone from. Defaults to Shopify's example theme, Dawn: https://github.com/Shopify/dawn.git",
    env: "SHOPIFY_FLAG_CLONE_URL"
  }),
  latest: import_core8.Flags.boolean({
    char: "l",
    description: "Downloads the latest release of the `clone-url`",
    env: "SHOPIFY_FLAG_LATEST"
  })
};
var init_default = Init;

// ../theme/dist/cli/commands/theme/language-server.js
init_cjs_shims();
var import_theme_language_server_node = __toESM(require_dist7(), 1), _a6, LanguageServer = class extends ThemeCommand {
  async run() {
    await this.parse(_a6), (0, import_theme_language_server_node.startServer)();
  }
};
_a6 = LanguageServer;
LanguageServer.summary = "Start a Language Server Protocol server.";
LanguageServer.descriptionWithMarkdown = "Starts the [Language Server](https://shopify.dev/docs/themes/tools/cli/language-server).";
LanguageServer.description = _a6.descriptionWithoutMarkdown();
LanguageServer.flags = {
  ...globalFlags
};
var language_server_default = LanguageServer;

// ../theme/dist/cli/commands/theme/list.js
init_cjs_shims();

// ../theme/dist/cli/services/list.js
init_cjs_shims();

// ../theme/dist/cli/services/list.columns.js
init_cjs_shims();
var columns = {
  name: {},
  role: {
    color: "dim"
  },
  id: {
    color: "dim"
  }
};

// ../cli-kit/dist/public/node/themes/conf.js
init_cjs_shims();
var _hostThemeLocalStorageInstance;
function hostThemeLocalStorage() {
  return _hostThemeLocalStorageInstance || (_hostThemeLocalStorageInstance = new LocalStorage({
    projectName: "shopify-cli-host-theme-conf"
  })), _hostThemeLocalStorageInstance;
}
function getHostTheme(storeFqdn) {
  return outputDebug(outputContent`Getting host theme...`), hostThemeLocalStorage().get(storeFqdn);
}
function setHostTheme(storeFqdn, themeId) {
  outputDebug(outputContent`Setting host theme...`), hostThemeLocalStorage().set(storeFqdn, themeId);
}
function removeHostTheme(storeFqdn) {
  outputDebug(outputContent`Removing host theme...`), hostThemeLocalStorage().delete(storeFqdn);
}

// ../theme/dist/cli/services/list.js
async function list(adminSession, options) {
  let store = adminSession.storeFqdn, filter = new Filter({
    ...ALLOWED_ROLES.reduce((roles, role) => (roles[role] = options.role === role, roles), {}),
    theme: options.id?.toString() ?? options.name
  }), storeThemes = await fetchStoreThemes(adminSession), developmentTheme = getDevelopmentTheme(), hostTheme = getHostTheme(store);
  if (filter.any() && (storeThemes = filterThemes(store, storeThemes, filter)), options.json)
    return outputInfo(JSON.stringify(storeThemes, null, 2));
  let themes = storeThemes.map(({ id, name, role }) => {
    let formattedRole = "";
    return role && (formattedRole = `[${role}]`, [developmentTheme, hostTheme].includes(`${id}`) && (formattedRole += " [yours]")), {
      id: `#${id}`,
      name,
      role: formattedRole
    };
  });
  renderTable({ rows: themes, columns });
}

// ../theme/dist/cli/commands/theme/list.js
var import_core9 = __toESM(require_lib(), 1);
var List = class _List extends ThemeCommand {
  async run() {
    let { flags } = await this.parse(_List), store = ensureThemeStore(flags), adminSession = await ensureAuthenticatedThemes(store, flags.password);
    await list(adminSession, flags);
  }
};
List.description = "Lists the themes in your store, along with their IDs and statuses.";
List.flags = {
  ...globalFlags,
  password: themeFlags.password,
  store: themeFlags.store,
  role: import_core9.Flags.custom({
    description: "Only list themes with the given role.",
    options: ALLOWED_ROLES,
    env: "SHOPIFY_FLAG_ROLE"
  })(),
  name: import_core9.Flags.string({
    description: "Only list themes that contain the given name.",
    env: "SHOPIFY_FLAG_NAME"
  }),
  id: import_core9.Flags.integer({
    description: "Only list theme with the given ID.",
    env: "SHOPIFY_FLAG_ID"
  }),
  json: import_core9.Flags.boolean({
    description: "Output the theme list as JSON.",
    default: !1,
    env: "SHOPIFY_FLAG_JSON"
  }),
  environment: themeFlags.environment
};
var list_default = List;

// ../theme/dist/cli/commands/theme/open.js
init_cjs_shims();

// ../theme/dist/cli/services/open.js
init_cjs_shims();
async function open(adminSession, options) {
  let developmentThemeManager = new DevelopmentThemeManager(adminSession), developmentTheme = (await (options.development ? developmentThemeManager.find() : developmentThemeManager.fetch()))?.id, theme = await findOrSelectTheme(adminSession, {
    header: "Select a theme to open",
    filter: {
      live: options.live,
      theme: options.development ? `${developmentTheme}` : options.theme
    }
  }), previewUrl = themePreviewUrl(theme, adminSession), editorUrl = themeEditorUrl(theme, adminSession);
  renderInfo({
    body: [
      "Preview information for theme",
      ...themeComponent(theme),
      `

`,
      {
        list: {
          items: [
            { link: { label: "Preview your theme", url: previewUrl } },
            { link: { label: "Customize your theme at the theme editor", url: editorUrl } }
          ]
        }
      }
    ]
  }), options.editor ? await openURL(editorUrl) : await openURL(previewUrl);
}

// ../theme/dist/cli/commands/theme/open.js
var import_core10 = __toESM(require_lib(), 1);
var _a7, Open = class extends ThemeCommand {
  async run() {
    let { flags } = await this.parse(_a7), store = ensureThemeStore(flags), adminSession = await ensureAuthenticatedThemes(store, flags.password);
    await open(adminSession, flags);
  }
};
_a7 = Open;
Open.summary = "Opens the preview of your remote theme.";
Open.descriptionWithMarkdown = `Returns links that let you preview the specified theme. The following links are returned:

  - A link to the [editor](https://shopify.dev/docs/themes/tools/online-editor) for the theme in the Shopify admin.
  - A [preview link](https://help.shopify.com/manual/online-store/themes/adding-themes#share-a-theme-preview-with-others) that you can share with other developers.

  If you don't specify a theme, then you're prompted to select the theme to open from the list of the themes in your store.`;
Open.description = _a7.descriptionWithoutMarkdown();
Open.flags = {
  ...globalFlags,
  password: themeFlags.password,
  development: import_core10.Flags.boolean({
    char: "d",
    description: "Open your development theme.",
    env: "SHOPIFY_FLAG_DEVELOPMENT"
  }),
  editor: import_core10.Flags.boolean({
    char: "E",
    description: "Open the theme editor for the specified theme in the browser.",
    env: "SHOPIFY_FLAG_EDITOR"
  }),
  live: import_core10.Flags.boolean({
    char: "l",
    description: "Open your live (published) theme.",
    env: "SHOPIFY_FLAG_LIVE"
  }),
  theme: import_core10.Flags.string({
    char: "t",
    description: "Theme ID or name of the remote theme.",
    env: "SHOPIFY_FLAG_THEME_ID"
  }),
  store: themeFlags.store,
  environment: themeFlags.environment
};
var open_default = Open;

// ../theme/dist/cli/commands/theme/package.js
init_cjs_shims();

// ../theme/dist/cli/services/package.js
init_cjs_shims();

// ../cli-kit/dist/public/node/archiver.js
init_cjs_shims();
var import_archiver = __toESM(require_archiver());
import { createWriteStream } from "fs";
async function zip(options) {
  let { inputDirectory, outputZipPath, matchFilePattern = "**/*" } = options;
  outputDebug(outputContent`Zipping ${outputToken.path(inputDirectory)} into ${outputToken.path(outputZipPath)}`);
  let pathsToZip = await glob(matchFilePattern, {
    cwd: inputDirectory,
    absolute: !0,
    dot: !0,
    followSymbolicLinks: !1
  });
  return new Promise((resolve2, reject) => {
    let archive = (0, import_archiver.default)("zip"), output = createWriteStream(outputZipPath);
    output.on("close", () => resolve2()), archive.on("error", (error) => reject(error)), archive.pipe(output);
    for (let filePath of pathsToZip) {
      let fileRelativePath = relativePath(inputDirectory, filePath);
      archive.file(filePath, { name: fileRelativePath });
    }
    archive.finalize();
  });
}

// ../theme/dist/cli/services/package.js
var themeFilesPattern = [
  "assets/**",
  "config/**",
  "layout/**",
  "locales/**",
  "sections/**",
  "snippets/**",
  "templates/**",
  "templates/customers/**",
  "release-notes.md",
  "update_extension.json"
].join("|");
async function packageTheme(inputDirectory) {
  let packageName = await getThemePackageName(inputDirectory), outputZipPath = `${inputDirectory}/${packageName}`, matchFilePattern = `${inputDirectory}/(${themeFilesPattern})`;
  await zip({
    inputDirectory,
    outputZipPath,
    matchFilePattern
  }), renderSuccess({
    body: ["Your local theme was packaged in", { filePath: relativizePath(outputZipPath) }]
  });
}
async function getThemePackageName(inputDirectory) {
  let settingsPath = resolvePath(inputDirectory, "config/settings_schema.json");
  if (!await fileExists(settingsPath))
    throw new AbortError("Provide a config/settings_schema.json to package your theme.");
  let themeInfo = JSON.parse(await readFile(settingsPath)).find((setting) => setting.name === "theme_info");
  if (themeInfo === void 0 || themeInfo.theme_name === void 0)
    throw new AbortError("Provide a theme_info.theme_name configuration in config/settings_schema.json");
  return `${[themeInfo.theme_name, themeInfo.theme_version].filter(Boolean).join("-")}.zip`;
}

// ../theme/dist/cli/commands/theme/package.js
var _a8, Package = class extends ThemeCommand {
  async run() {
    let { flags } = await this.parse(_a8);
    await packageTheme(flags.path);
  }
};
_a8 = Package;
Package.summary = "Package your theme into a .zip file, ready to upload to the Online Store.";
Package.descriptionWithMarkdown = `Packages your local theme files into a ZIP file that can be uploaded to Shopify.

  Only folders that match the [default Shopify theme folder structure](https://shopify.dev/docs/themes/tools/cli#directory-structure) are included in the package.

  The ZIP file uses the name \`theme_name-theme_version.zip\`, based on parameters in your [settings_schema.json](https://shopify.dev/docs/themes/architecture/config/settings-schema-json) file.`;
Package.description = _a8.descriptionWithoutMarkdown();
Package.flags = {
  ...globalFlags,
  path: themeFlags.path
};
var package_default = Package;

// ../theme/dist/cli/commands/theme/publish.js
init_cjs_shims();

// ../theme/dist/cli/services/publish.js
init_cjs_shims();
function renderArgumentsWarning(id) {
  renderWarning({
    body: [
      "The theme ID positional argument is deprecated. Use the",
      { command: "--theme" },
      `flag instead:

`,
      { command: `$ shopify theme publish --theme ${id}` },
      { char: "." }
    ]
  });
}
async function publish(adminSession, themeId, options) {
  let theme = await findOrSelectTheme(adminSession, {
    header: "Select a theme to publish",
    filter: {
      development: !1,
      live: !1,
      theme: themeId
    }
  }), previewUrl = themePreviewUrl({ ...theme, role: "live" }, adminSession);
  !options.force && !await renderConfirmationPrompt({
    message: `Do you want to make '${theme.name}' the new live theme on ${adminSession.storeFqdn}?`,
    confirmationMessage: `Yes, make '${theme.name}' the new live theme`,
    cancellationMessage: "No, cancel publish"
  }) || (await publishTheme(theme.id, adminSession), renderSuccess({
    body: [
      "The theme",
      ...themeComponent(theme),
      "is now live at",
      {
        link: {
          label: previewUrl,
          url: previewUrl
        }
      },
      { char: "." }
    ]
  }));
}

// ../theme/dist/cli/commands/theme/publish.js
var import_core11 = __toESM(require_lib(), 1);
var _a9, Publish = class extends ThemeCommand {
  async run() {
    let { flags, argv } = await this.parse(_a9), store = await ensureThemeStore(flags), adminSession = await ensureAuthenticatedThemes(store, flags.password), themeId = flags.theme || argv[0];
    argv.length > 0 && typeof argv[0] == "string" && renderArgumentsWarning(argv[0]), await publish(adminSession, themeId, flags);
  }
};
_a9 = Publish;
Publish.summary = "Set a remote theme as the live theme.";
Publish.descriptionWithMarkdown = `Publishes an unpublished theme from your theme library.

If no theme ID is specified, then you're prompted to select the theme that you want to publish from the list of themes in your store.

You can run this command only in a directory that matches the [default Shopify theme folder structure](https://shopify.dev/docs/themes/tools/cli#directory-structure).

If you want to publish your local theme, then you need to run \`shopify theme push\` first. You're asked to confirm that you want to publish the specified theme. You can skip this confirmation using the \`--force\` flag.`;
Publish.description = _a9.descriptionWithoutMarkdown();
Publish.strict = !1;
Publish.flags = {
  ...globalFlags,
  password: themeFlags.password,
  force: import_core11.Flags.boolean({
    char: "f",
    description: "Skip confirmation.",
    env: "SHOPIFY_FLAG_FORCE"
  }),
  theme: import_core11.Flags.string({
    char: "t",
    description: "Theme ID or name of the remote theme.",
    env: "SHOPIFY_FLAG_THEME_ID"
  }),
  store: themeFlags.store,
  environment: themeFlags.environment
};
var publish_default = Publish;

// ../theme/dist/cli/commands/theme/pull.js
init_cjs_shims();

// ../theme/dist/cli/services/pull.js
init_cjs_shims();

// ../theme/dist/cli/utilities/theme-downloader.js
init_cjs_shims();
async function downloadTheme(theme, session, remoteChecksums, themeFileSystem, options) {
  let deleteTasks = buildDeleteTasks2(remoteChecksums, themeFileSystem, options), downloadTasks = await buildDownloadTasks(remoteChecksums, theme, themeFileSystem, session, options), tasks = [...deleteTasks, ...downloadTasks];
  tasks.length > 0 && await renderTasks(tasks);
}
function buildDeleteTasks2(remoteChecksums, themeFileSystem, options) {
  if (options.nodelete)
    return [];
  let remoteKeys = new Set(remoteChecksums.map((checksum2) => checksum2.key));
  return Array.from(themeFileSystem.files.keys()).filter((key) => !remoteKeys.has(key)).map((key) => ({
    title: `Cleaning your local directory (removing ${key})`,
    task: async () => themeFileSystem.delete(key)
  }));
}
async function buildDownloadTasks(remoteChecksums, theme, themeFileSystem, session, options) {
  return (await applyIgnoreFilters(remoteChecksums, themeFileSystem, options)).map((checksum2) => {
    let remoteChecksumValue = checksum2.checksum;
    if (themeFileSystem.files.get(checksum2.key)?.checksum === remoteChecksumValue)
      return;
    let progress = progressPct(remoteChecksums, checksum2);
    return {
      title: `Pulling theme "${theme.name}" (#${theme.id}) from ${session.storeFqdn} [${progress}%]`,
      task: async () => downloadFile(theme, themeFileSystem, checksum2, session)
    };
  }).filter(notNull);
}
async function downloadFile(theme, fileSystem, checksum2, session) {
  let themeAsset = await fetchThemeAsset(theme.id, checksum2.key, session);
  themeAsset && await fileSystem.write(themeAsset);
}
function progressPct(themeChecksums, checksum2) {
  let current = themeChecksums.indexOf(checksum2) + 1, total = themeChecksums.length;
  return Math.round(current / total * 100);
}
function notNull(value) {
  return value != null;
}

// ../theme/dist/cli/services/pull.js
async function pull(theme, session, options) {
  let path3 = options.path, force = options.force;
  if (!await isEmptyDir(path3) && !await hasRequiredThemeDirectories(path3) && !await currentDirectoryConfirmed(force))
    return;
  let remoteChecksums = await fetchChecksums(theme.id, session), themeFileSystem = await mountThemeFileSystem(path3), themeChecksums = rejectGeneratedStaticAssets(remoteChecksums), store = session.storeFqdn, themeId = theme.id;
  await downloadTheme(theme, session, themeChecksums, themeFileSystem, options), renderSuccess({
    body: ["The theme", ...themeComponent(theme), "has been pulled."],
    nextSteps: [
      [
        {
          link: {
            label: "View your theme",
            url: `https://${store}/?preview_theme_id=${themeId}`
          }
        }
      ],
      [
        {
          link: {
            label: "Customize your theme at the theme editor",
            url: `https://${store}/admin/themes/${themeId}/editor`
          }
        }
      ]
    ]
  });
}
async function isEmptyDir(path3) {
  return (await glob("*", {
    cwd: path3,
    deep: 1,
    onlyFiles: !1
  })).length === 0;
}

// ../theme/dist/cli/commands/theme/pull.js
var import_core12 = __toESM(require_lib(), 1);
var _a10, Pull = class extends ThemeCommand {
  async run() {
    showEmbeddedCLIWarning();
    let { flags } = await this.parse(_a10), store = ensureThemeStore(flags), adminSession = await ensureAuthenticatedThemes(store, flags.password), developmentThemeManager = new DevelopmentThemeManager(adminSession), developmentTheme = await (flags.development ? developmentThemeManager.find() : developmentThemeManager.fetch());
    if (flags.beta) {
      let { path: path3, nodelete, live, development, only, ignore, force } = flags, theme = await findOrSelectTheme(adminSession, {
        header: "Select a theme to open",
        filter: {
          live,
          theme: development ? `${developmentTheme?.id}` : flags.theme
        }
      });
      await pull(theme, adminSession, { path: path3, nodelete, only, ignore, force });
      return;
    }
    let flagsForCli2 = flags;
    developmentTheme && (flagsForCli2.development && (flagsForCli2.theme = `${developmentTheme.id}`, flagsForCli2.development = !1), useEmbeddedThemeCLI() && (flagsForCli2["development-theme-id"] = developmentTheme.id));
    let flagsToPass = this.passThroughFlags(flagsForCli2, { allowedFlags: _a10.cli2Flags }), command = ["theme", "pull", flagsForCli2.path, ...flagsToPass];
    await execCLI2(command, { store, adminToken: adminSession.token });
  }
};
_a10 = Pull;
Pull.summary = "Download your remote theme files locally.";
Pull.descriptionWithMarkdown = `Retrieves theme files from Shopify.

If no theme is specified, then you're prompted to select the theme to pull from the list of the themes in your store.`;
Pull.description = _a10.descriptionWithoutMarkdown();
Pull.flags = {
  ...globalFlags,
  ...themeFlags,
  theme: import_core12.Flags.string({
    char: "t",
    description: "Theme ID or name of the remote theme.",
    env: "SHOPIFY_FLAG_THEME_ID"
  }),
  development: import_core12.Flags.boolean({
    char: "d",
    description: "Pull theme files from your remote development theme.",
    env: "SHOPIFY_FLAG_DEVELOPMENT"
  }),
  live: import_core12.Flags.boolean({
    char: "l",
    description: "Pull theme files from your remote live theme.",
    env: "SHOPIFY_FLAG_LIVE"
  }),
  nodelete: import_core12.Flags.boolean({
    char: "n",
    description: "Runs the pull command without deleting local files.",
    env: "SHOPIFY_FLAG_NODELETE"
  }),
  only: import_core12.Flags.string({
    char: "o",
    multiple: !0,
    description: "Download only the specified files (Multiple flags allowed).",
    env: "SHOPIFY_FLAG_ONLY"
  }),
  ignore: import_core12.Flags.string({
    char: "x",
    multiple: !0,
    description: "Skip downloading the specified files (Multiple flags allowed).",
    env: "SHOPIFY_FLAG_IGNORE"
  }),
  force: import_core12.Flags.boolean({
    hidden: !0,
    char: "f",
    description: "Proceed without confirmation, if current directory does not seem to be theme directory.",
    env: "SHOPIFY_FLAG_FORCE"
  }),
  stable: import_core12.Flags.boolean({
    hidden: !0,
    description: "Performs the pull command by relying on the legacy download implementation.",
    env: "SHOPIFY_FLAG_STABLE"
  }),
  beta: import_core12.Flags.boolean({
    hidden: !0,
    description: "Performs the pull command by relying on the new download implementation.",
    env: "SHOPIFY_FLAG_BETA"
  })
};
Pull.cli2Flags = ["theme", "development", "live", "nodelete", "only", "ignore", "force", "development-theme-id"];
var pull_default = Pull;

// ../theme/dist/cli/commands/theme/push.js
init_cjs_shims();

// ../theme/dist/cli/services/push.js
init_cjs_shims();
async function push(theme, session, options) {
  let themeChecksums = await fetchChecksums(theme.id, session), themeFileSystem = await mountThemeFileSystem(options.path), results = await uploadTheme(theme, session, themeChecksums, themeFileSystem, options);
  options.publish && await publishTheme(theme.id, session), await handlePushOutput(results, theme, session, options);
}
function hasUploadErrors(results) {
  for (let [_key, result] of results.entries())
    if (!result.success)
      return !0;
  return !1;
}
async function handlePushOutput(results, theme, session, options) {
  let hasErrors = hasUploadErrors(results);
  options.json ? handleJsonOutput(theme, hasErrors, session) : options.publish ? handlePublishOutput(hasErrors, session) : handleOutput(theme, hasErrors, session);
}
function handleJsonOutput(theme, hasErrors, session) {
  let output = {
    theme: {
      id: theme.id,
      name: theme.name,
      role: theme.role,
      shop: session.storeFqdn,
      editor_url: themeEditorUrl(theme, session),
      preview_url: themePreviewUrl(theme, session)
    }
  };
  if (hasErrors) {
    let message = `The theme ${themeComponent(theme).join(" ")} was pushed with errors`;
    output.theme.warning = message;
  }
  outputInfo(JSON.stringify(output));
}
function handlePublishOutput(hasErrors, session) {
  hasErrors ? renderWarning({ body: `Your theme was published with errors and is now live at https://${session.storeFqdn}` }) : renderSuccess({ body: `Your theme is now live at https://${session.storeFqdn}` });
}
function handleOutput(theme, hasErrors, session) {
  let nextSteps = [
    [
      {
        link: {
          label: "View your theme",
          url: themePreviewUrl(theme, session)
        }
      }
    ],
    [
      {
        link: {
          label: "Customize your theme at the theme editor",
          url: themeEditorUrl(theme, session)
        }
      }
    ]
  ];
  hasErrors ? renderWarning({
    body: ["The theme", ...themeComponent(theme), "was pushed with errors"],
    nextSteps
  }) : renderSuccess({
    body: ["The theme", ...themeComponent(theme), "was pushed successfully."],
    nextSteps
  });
}

// ../theme/dist/cli/commands/theme/push.js
var import_core13 = __toESM(require_lib(), 1);
var _a11, Push = class extends ThemeCommand {
  async run() {
    let { flags } = await this.parse(_a11), { path: path3, force } = flags, store = ensureThemeStore(flags), adminSession = await ensureAuthenticatedThemes(store, flags.password), workingDirectory = path3 ? resolvePath(path3) : cwd();
    if (!await hasRequiredThemeDirectories(workingDirectory) && !await currentDirectoryConfirmed(force))
      return;
    if (!flags.stable && !flags.password) {
      let { path: path4, nodelete, publish: publish2, json, force: force2, ignore, only } = flags, selectedTheme = await createOrSelectTheme(adminSession, flags);
      if (!selectedTheme)
        return;
      await push(selectedTheme, adminSession, {
        path: path4,
        nodelete,
        publish: publish2,
        json,
        force: force2,
        ignore,
        only
      });
      return;
    }
    let flagsForCli2 = flags;
    showEmbeddedCLIWarning();
    let developmentThemeManager = new DevelopmentThemeManager(adminSession), targetTheme = await (flagsForCli2.development ? developmentThemeManager.findOrCreate() : developmentThemeManager.fetch());
    targetTheme && (flagsForCli2.development && (flagsForCli2.theme = `${targetTheme.id}`, flagsForCli2.development = !1), useEmbeddedThemeCLI() && (flagsForCli2["development-theme-id"] = targetTheme.id));
    let flagsToPass = this.passThroughFlags(flagsForCli2, {
      allowedFlags: _a11.cli2Flags
    }), command = ["theme", "push", flagsForCli2.path, ...flagsToPass];
    await execCLI2(command, { store, adminToken: adminSession.token });
  }
};
_a11 = Push;
Push.summary = "Uploads your local theme files to the connected store, overwriting the remote version if specified.";
Push.usage = ["theme:push", "theme:push --unpublished --json"];
Push.descriptionWithMarkdown = `Uploads your local theme files to Shopify, overwriting the remote version if specified.

  If no theme is specified, then you're prompted to select the theme to overwrite from the list of the themes in your store.

  You can run this command only in a directory that matches the [default Shopify theme folder structure](https://shopify.dev/docs/themes/tools/cli#directory-structure).

  This command returns the following information:

  - A link to the [editor](https://shopify.dev/docs/themes/tools/online-editor) for the theme in the Shopify admin.
  - A [preview link](https://help.shopify.com/manual/online-store/themes/adding-themes#share-a-theme-preview-with-others) that you can share with others.

  If you use the \`--json\` flag, then theme information is returned in JSON format, which can be used as a machine-readable input for scripts or continuous integration.

  Sample output:

  \`\`\`json
  {
    "theme": {
      "id": 108267175958,
      "name": "MyTheme",
      "role": "unpublished",
      "shop": "mystore.myshopify.com",
      "editor_url": "https://mystore.myshopify.com/admin/themes/108267175958/editor",
      "preview_url": "https://mystore.myshopify.com/?preview_theme_id=108267175958"
    }
  }
  \`\`\`
    `;
Push.description = _a11.descriptionWithoutMarkdown();
Push.flags = {
  ...globalFlags,
  ...themeFlags,
  theme: import_core13.Flags.string({
    char: "t",
    description: "Theme ID or name of the remote theme.",
    env: "SHOPIFY_FLAG_THEME_ID"
  }),
  development: import_core13.Flags.boolean({
    char: "d",
    description: "Push theme files from your remote development theme.",
    env: "SHOPIFY_FLAG_DEVELOPMENT"
  }),
  live: import_core13.Flags.boolean({
    char: "l",
    description: "Push theme files from your remote live theme.",
    env: "SHOPIFY_FLAG_LIVE"
  }),
  unpublished: import_core13.Flags.boolean({
    char: "u",
    description: "Create a new unpublished theme and push to it.",
    env: "SHOPIFY_FLAG_UNPUBLISHED"
  }),
  nodelete: import_core13.Flags.boolean({
    char: "n",
    description: "Runs the push command without deleting local files.",
    env: "SHOPIFY_FLAG_NODELETE"
  }),
  only: import_core13.Flags.string({
    char: "o",
    description: "Download only the specified files (Multiple flags allowed).",
    multiple: !0,
    env: "SHOPIFY_FLAG_ONLY"
  }),
  ignore: import_core13.Flags.string({
    char: "x",
    description: "Skip downloading the specified files (Multiple flags allowed).",
    multiple: !0,
    env: "SHOPIFY_FLAG_IGNORE"
  }),
  json: import_core13.Flags.boolean({
    char: "j",
    description: "Output JSON instead of a UI.",
    env: "SHOPIFY_FLAG_JSON"
  }),
  "allow-live": import_core13.Flags.boolean({
    char: "a",
    description: "Allow push to a live theme.",
    env: "SHOPIFY_FLAG_ALLOW_LIVE"
  }),
  publish: import_core13.Flags.boolean({
    char: "p",
    description: "Publish as the live theme after uploading.",
    env: "SHOPIFY_FLAG_PUBLISH"
  }),
  stable: import_core13.Flags.boolean({
    hidden: !0,
    description: "Performs the upload by relying in the legacy upload approach (slower, but it might be more stable in some scenarios)",
    env: "SHOPIFY_FLAG_STABLE"
  }),
  force: import_core13.Flags.boolean({
    hidden: !0,
    char: "f",
    description: "Proceed without confirmation, if current directory does not seem to be theme directory.",
    env: "SHOPIFY_FLAG_FORCE"
  })
};
Push.cli2Flags = [
  "theme",
  "development",
  "live",
  "unpublished",
  "nodelete",
  "only",
  "ignore",
  "json",
  "allow-live",
  "publish",
  "stable",
  "force",
  "development-theme-id"
];
var push_default = Push;
async function createOrSelectTheme(adminSession, flags) {
  let { live, development, unpublished, theme } = flags;
  if (development)
    return new DevelopmentThemeManager(adminSession).findOrCreate();
  if (unpublished) {
    let themeName = theme || await promptThemeName("Name of the new theme");
    return createTheme({
      name: themeName,
      role: UNPUBLISHED_THEME_ROLE
    }, adminSession);
  } else {
    let selectedTheme = await findOrSelectTheme(adminSession, {
      header: "Select a theme to push to:",
      filter: {
        live,
        theme
      }
    });
    if (await confirmPushToTheme(selectedTheme.role, flags["allow-live"], adminSession.storeFqdn))
      return selectedTheme;
  }
}
async function confirmPushToTheme(themeRole, allowLive, storeFqdn) {
  if (themeRole === LIVE_THEME_ROLE) {
    if (allowLive)
      return !0;
    let options = {
      message: `Push theme files to the ${themeRole} theme on ${storeFqdn}?`,
      confirmationMessage: "Yes, confirm changes",
      cancellationMessage: "Cancel"
    };
    return renderConfirmationPrompt(options);
  }
  return !0;
}

// ../theme/dist/cli/commands/theme/rename.js
init_cjs_shims();

// ../theme/dist/cli/services/rename.js
init_cjs_shims();
async function renameTheme(adminSession, options) {
  let theme = await findOrSelectTheme(adminSession, {
    header: "Select a theme to rename",
    filter: {
      theme: options.theme,
      development: options.development,
      live: options.live
    }
  });
  await updateTheme(theme.id, { name: options.newName }, adminSession), renderSuccess({
    body: ["The theme", ...themeComponent(theme), "was renamed to", `'${options.newName}'`]
  });
}

// ../theme/dist/cli/commands/theme/rename.js
var import_core14 = __toESM(require_lib(), 1);
var _a12, Rename = class extends ThemeCommand {
  async run() {
    let { flags } = await this.parse(_a12), { password, development, name, theme, live } = flags, store = ensureThemeStore(flags), adminSession = await ensureAuthenticatedThemes(store, password), renameOptions = {
      newName: name || await promptThemeName("New name for the theme"),
      development,
      theme,
      live
    };
    await renameTheme(adminSession, renameOptions);
  }
};
_a12 = Rename;
Rename.summary = "Renames an existing theme.";
Rename.descriptionWithMarkdown = `Renames a theme in your store.

  If no theme is specified, then you're prompted to select the theme that you want to rename from the list of themes in your store.
  `;
Rename.description = _a12.descriptionWithoutMarkdown();
Rename.flags = {
  ...globalFlags,
  store: themeFlags.store,
  password: themeFlags.password,
  environment: themeFlags.environment,
  name: import_core14.Flags.string({
    char: "n",
    description: "The new name for the theme.",
    env: "SHOPIFY_FLAG_NEW_NAME",
    required: !1
  }),
  development: import_core14.Flags.boolean({
    char: "d",
    description: "Rename your development theme.",
    env: "SHOPIFY_FLAG_DEVELOPMENT"
  }),
  theme: import_core14.Flags.string({
    char: "t",
    description: "Theme ID or name of the remote theme.",
    env: "SHOPIFY_FLAG_THEME_ID"
  }),
  live: import_core14.Flags.boolean({
    char: "l",
    description: "Rename your remote live theme.",
    env: "SHOPIFY_FLAG_LIVE"
  })
};
var rename_default = Rename;

// ../theme/dist/cli/commands/theme/serve.js
init_cjs_shims();
var Serve = class extends dev_default {
  async run() {
    renderWarning({
      headline: ["The", { command: "shopify theme serve" }, "command is deprecated."],
      body: ["Use", { command: "shopify theme dev" }, "instead."]
    }), await super.run();
  }
};
Serve.hidden = !0;
var serve_default = Serve;

// ../theme/dist/cli/commands/theme/share.js
init_cjs_shims();
var import_core15 = __toESM(require_lib(), 1);
var _a13, Share = class extends ThemeCommand {
  async run() {
    let { flags } = await this.parse(_a13), flagsToPass = this.passThroughFlags(flags, { allowedFlags: _a13.cli2Flags }), store = ensureThemeStore(flags), adminSession = await ensureAuthenticatedThemes(store, flags.password);
    await execCLI2(["theme", "share", flags.path, ...flagsToPass], { store, adminToken: adminSession.token });
  }
};
_a13 = Share;
Share.summary = "Creates a shareable, unpublished, and new theme on your theme library with a randomized name.";
Share.descriptionWithMarkdown = `Uploads your theme as a new, unpublished theme in your theme library. The theme is given a randomized name.

  This command returns a [preview link](https://help.shopify.com/manual/online-store/themes/adding-themes#share-a-theme-preview-with-others) that you can share with others.`;
Share.description = _a13.descriptionWithoutMarkdown();
Share.flags = {
  ...globalFlags,
  ...themeFlags,
  force: import_core15.Flags.boolean({
    hidden: !0,
    char: "f",
    description: "Proceed without confirmation, if current directory does not seem to be theme directory.",
    env: "SHOPIFY_FLAG_FORCE"
  })
};
Share.cli2Flags = ["force"];
var share_default = Share;

// ../theme/dist/index.js
var COMMANDS = {
  "theme:init": init_default,
  "theme:check": check_default,
  "theme:console": console_default,
  "theme:delete": delete_default,
  "theme:dev": dev_default,
  "theme:info": info_default,
  "theme:language-server": language_server_default,
  "theme:list": list_default,
  "theme:open": open_default,
  "theme:package": package_default,
  "theme:publish": publish_default,
  "theme:pull": pull_default,
  "theme:push": push_default,
  "theme:rename": rename_default,
  "theme:serve": serve_default,
  "theme:share": share_default
}, dist_default = COMMANDS;

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/index.js
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/build.js
init_cjs_shims();
var import_core16 = __toESM(require_lib(), 1);

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/template-diff.js
init_cjs_shims();
import { symlink, cp } from "node:fs/promises";
async function prepareDiffDirectory(diffDirectory, watch) {
  let targetDirectory = temporaryDirectory({ prefix: "tmp-hydrogen-diff-" });
  outputInfo(
    `
-- Applying diff to starter template in
${source_default.dim(
      targetDirectory
    )}
`
  );
  let templateDirectory = await getStarterDir(isHydrogenMonorepo);
  await applyTemplateDiff(targetDirectory, diffDirectory, templateDirectory), await symlink(
    await getRepoNodeModules(),
    joinPath(targetDirectory, "node_modules")
  );
  let { default: chokidar } = await import("./chokidar-4TKDAB27.js"), subscriptions = watch ? [
    // Copy back the changes in generated d.ts from the
    // temporary directory to the original diff directory.
    chokidar.watch(joinPath(targetDirectory, "*.generated.d.ts"), {
      ignoreInitial: !0
    }).on("all", async (eventName, eventFilePath) => {
      let targetFile = joinPath(
        diffDirectory,
        relativePath(targetDirectory, eventFilePath)
      );
      await copyFile(eventFilePath, targetFile);
    }),
    // Copy new changes in the original diff directory to
    // the temporary directory.
    chokidar.watch(diffDirectory, {
      ignoreInitial: !0,
      ignored: [
        "**/*.generated.d.ts",
        "**/package.json",
        "**/tsconfig.json",
        "**/.shopify"
      ]
    }).on("all", async (eventName, eventFilePath) => {
      let targetFile = joinPath(
        targetDirectory,
        relativePath(diffDirectory, eventFilePath)
      ), fileInTemplate = eventFilePath.replace(
        diffDirectory,
        templateDirectory
      );
      return eventName === "unlink" ? fileExists(fileInTemplate).then(
        (exists) => exists ? (
          // Replace it with original file from the starter template.
          copyFile(fileInTemplate, targetFile)
        ) : (
          // Remove the file otherwise.
          removeFile(targetFile)
        )
      ).catch(() => {
      }) : copyFile(eventFilePath, targetFile);
    }),
    // Copy new changes in the starter template to the temporary
    // directory only if they don't overwrite the files in the
    // original diff directory, which have higher priority.
    chokidar.watch(templateDirectory, {
      ignoreInitial: !0,
      ignored: [
        "**/*.generated.d.ts",
        "**/package.json",
        "**/tsconfig.json",
        "**/.shopify"
      ]
    }).on("all", async (eventName, eventFilePath) => {
      let fileInDiff = eventFilePath.replace(
        templateDirectory,
        diffDirectory
      );
      if (await fileExists(fileInDiff))
        return;
      let targetFile = joinPath(
        targetDirectory,
        relativePath(templateDirectory, eventFilePath)
      );
      return eventName === "unlink" ? removeFile(targetFile).catch(() => {
      }) : copyFile(eventFilePath, targetFile);
    })
  ] : [];
  return {
    /**
     * The temporary directory with the starter template and diff applied.
     */
    targetDirectory,
    /**
     * Removes the temporary directory and stops the file watchers.
     */
    cleanup: async () => {
      await Promise.all(subscriptions.map((sub) => sub.close())), await removeFile(targetDirectory);
    },
    /**
     * Brings the `.shopify` directory back to the original project.
     * This is important to keep a reference of the tunnel configuration
     * so that it can be removed in the next run.
     */
    async copyShopifyConfig() {
      let source = joinPath(targetDirectory, ".shopify");
      if (!await fileExists(source))
        return;
      let target = joinPath(diffDirectory, ".shopify");
      await removeFile(target), await cp(source, target, { recursive: !0, force: !0 });
    },
    /**
     * Brings the `dist` directory back to the original project.
     * This is used to run `h2 preview` with the resulting build.
     */
    async copyDiffBuild() {
      let target = joinPath(diffDirectory, "dist");
      await removeFile(target), await Promise.all([
        cp(joinPath(targetDirectory, "dist"), target, {
          force: !0,
          recursive: !0
        }),
        copyFile(
          joinPath(targetDirectory, ".env"),
          joinPath(diffDirectory, ".env")
        )
      ]);
    },
    /**
     * Brings the generated d.ts files back to the original project.
     */
    copyDiffCodegen() {
      return Promise.all([
        copyFile(
          joinPath(targetDirectory, "storefrontapi.generated.d.ts"),
          joinPath(diffDirectory, "storefrontapi.generated.d.ts")
        ),
        copyFile(
          joinPath(targetDirectory, "customer-accountapi.generated.d.ts"),
          joinPath(diffDirectory, "customer-accountapi.generated.d.ts")
        )
      ]);
    }
  };
}
async function applyTemplateDiff(targetDirectory, diffDirectory, templateDir) {
  templateDir ??= await getStarterDir();
  let diffOptions = (await readAndParsePackageJson(
    joinPath(diffDirectory, "package.json")
  ))["h2:diff"] ?? {}, createFilter = (re, skipFiles) => (filepath) => {
    let filename = relativePath(templateDir, filepath);
    return !re.test(filename) && !skipFiles?.includes(filename);
  };
  await cp(templateDir, targetDirectory, {
    force: !0,
    recursive: !0,
    filter: createFilter(
      // Do not copy .shopify from skeleton to avoid linking in examples inadvertedly
      /(^|\/|\\)(dist|node_modules|\.cache|\.turbo|\.shopify|CHANGELOG\.md)(\/|\\|$)/i,
      diffOptions.skipFiles || []
    )
  }), await cp(diffDirectory, targetDirectory, {
    force: !0,
    recursive: !0,
    filter: createFilter(
      /(^|\/|\\)(dist|node_modules|\.cache|.turbo|package\.json|tsconfig\.json)(\/|\\|$)/i
    )
  }), await mergePackageJson(diffDirectory, targetDirectory, {
    ignoredKeys: ["h2:diff"],
    onResult: (pkgJson) => {
      pkgJson.dependencies && delete pkgJson.dependencies["@shopify/cli-hydrogen"];
      for (let key of ["build", "dev", "preview"]) {
        let scriptLine = pkgJson.scripts?.[key];
        pkgJson.scripts?.[key] && typeof scriptLine == "string" && (pkgJson.scripts[key] = scriptLine.replace(/\s+--diff/, ""));
      }
      if (diffOptions.skipDependencies && pkgJson.dependencies)
        for (let dep of diffOptions.skipDependencies)
          delete pkgJson.dependencies[dep];
      if (diffOptions.skipDevDependencies && pkgJson.devDependencies)
        for (let devDep of diffOptions.skipDevDependencies)
          delete pkgJson.devDependencies[devDep];
      return pkgJson;
    }
  }), await mergeTsConfig(diffDirectory, targetDirectory);
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/check-lockfile.js
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/package-managers.js
init_cjs_shims();
var packageManagers = [
  {
    name: "npm",
    lockfile: "package-lock.json",
    installCommand: "npm ci"
  },
  {
    name: "yarn",
    lockfile: "yarn.lock",
    installCommand: "yarn install --frozen-lockfile"
  },
  {
    name: "pnpm",
    lockfile: "pnpm-lock.yaml",
    installCommand: "pnpm install --frozen-lockfile"
  },
  {
    name: "bun",
    lockfile: "bun.lockb",
    installCommand: "bun install --frozen-lockfile"
  }
];

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/check-lockfile.js
function missingLockfileWarning(shouldExit) {
  let headline = "No lockfile found", body = "If you don\u2019t commit a lockfile, then your app might install the wrong package versions when deploying. To avoid versioning issues, generate a new lockfile and commit it to your repository.", nextSteps = [
    [
      "Generate a lockfile. Run",
      {
        command: "npm|yarn|pnpm install"
      }
    ],
    "Commit the new file to your repository"
  ];
  if (shouldExit)
    throw new AbortError(headline, body, nextSteps);
  renderWarning({ headline, body, nextSteps });
}
function multipleLockfilesWarning(packageManagers2, shouldExit) {
  let lockfileList = packageManagers2.map(({ name, lockfile: lockfile2 }) => `${lockfile2} (created by ${name})`), headline = "Multiple lockfiles found", body = [
    `Your project contains more than one lockfile. This can cause version conflicts when installing and deploying your app. The following lockfiles were detected:
`,
    { list: { items: lockfileList } }
  ], nextSteps = [
    "Delete any unneeded lockfiles",
    "Commit the change to your repository"
  ];
  if (shouldExit)
    throw new AbortError(headline, body, nextSteps);
  renderWarning({ headline, body, nextSteps });
}
function lockfileIgnoredWarning(lockfile2) {
  let headline = "Lockfile ignored by Git", body = "Your project\u2019s lockfile isn\u2019t being tracked by Git. If you don\u2019t commit a lockfile, then your app might install the wrong package versions when deploying.", nextSteps = [
    `In your project\u2019s .gitignore file, delete any references to ${lockfile2}`,
    "Commit the change to your repository"
  ];
  renderWarning({ headline, body, nextSteps });
}
async function checkLockfileStatus(directory, shouldExit = !1) {
  if (isHydrogenMonorepo && !process.env.SHOPIFY_UNIT_TEST)
    return;
  let foundPackageManagers = [];
  for (let packageManager2 of packageManagers)
    await fileExists(resolvePath(directory, packageManager2.lockfile)) && foundPackageManagers.push(packageManager2);
  if (foundPackageManagers.length === 0)
    return missingLockfileWarning(shouldExit);
  if (foundPackageManagers.length > 1)
    return multipleLockfilesWarning(foundPackageManagers, shouldExit);
  let lockfile2 = foundPackageManagers[0].lockfile;
  (await checkIfIgnoredInGitRepository(directory, [
    lockfile2
  ]).catch(() => [])).length > 0 && lockfileIgnoredWarning(lockfile2);
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/missing-routes.js
init_cjs_shims();
var REQUIRED_ROUTES = [
  "",
  "cart",
  // 'products',
  "products/:productHandle",
  "collections",
  //   'collections/all',
  "collections/:collectionHandle",
  //   'collections/:collectionHandle/:constraint',
  //   'collections/:collectionHandle/products/:productHandle',
  "sitemap.xml",
  "robots.txt",
  "pages/:pageHandle",
  //   'blogs/:blogHandle/tagged/:tagHandle',
  //   'blogs/:blogHandle/:articleHandle',
  //   'blogs/:blogHandle/:articleHandle/comments',
  "policies/:policyHandle",
  //   'variants/:variantId',
  "search",
  //   'gift_cards/:storeId/:cardId',
  // 'discount/:discountCode', => Handled in storefrontRedirect
  "account",
  "account/login",
  // 'account/addresses',
  // 'account/orders',
  "account/orders/:orderId",
  // -- Added for CAAPI:
  "account/authorize"
  // -- These were removed when migrating to CAAPI:
  // 'account/register',
  // 'account/reset/:id/:token',
  // 'account/activate/:id/:token',
  //   'password',
  //   'opening_soon',
];
function findMissingRoutes(config2, requiredRoutes = REQUIRED_ROUTES) {
  let userRoutes = Object.values(config2.routes), missingRoutes = new Set(requiredRoutes);
  for (let requiredRoute of requiredRoutes)
    for (let userRoute of userRoutes)
      if (!requiredRoute && !userRoute.path)
        missingRoutes.delete(requiredRoute);
      else if (requiredRoute && userRoute.path) {
        let currentRoute = {
          path: userRoute.path,
          parentId: userRoute.parentId
        };
        for (; currentRoute.parentId && currentRoute.parentId !== "root"; ) {
          let parentRoute = userRoutes.find(
            (r2) => r2.id === currentRoute.parentId
          );
          if (!parentRoute)
            break;
          currentRoute.path = `${parentRoute.path}/${currentRoute.path}`, currentRoute.parentId = parentRoute.parentId;
        }
        let optionalSegment = ":?[^\\/\\?]+\\?", reString = `^(${optionalSegment}\\/)?` + // Starts with an optional segment
        requiredRoute.replaceAll(".", "\\.").replace(/\//g, `\\/(${optionalSegment}\\/)?`).replace(/:[^/)?]+/g, "(:[^\\/]+|\\*)") + // Replace params with regex
        `(\\/${optionalSegment})?$`;
        new RegExp(reString).test(currentRoute.path) && missingRoutes.delete(requiredRoute);
      }
  return [...missingRoutes];
}
var LINE_LIMIT = 100;
function logMissingRoutes(routes) {
  routes.length ? renderWarning({
    headline: "Standard Shopify routes missing",
    body: `Your Hydrogen project is missing ${routes.length} standard Shopify route${routes.length > 1 ? "s" : ""}.
Including these routes improves compatibility with Shopify\u2019s platform:

` + routes.slice(0, LINE_LIMIT - (routes.length <= LINE_LIMIT ? 0 : 1)).map((route) => `\u2022 /${route}`).join(`
`) + (routes.length > LINE_LIMIT ? `
\u2022 ...and ${routes.length - LINE_LIMIT + 1} more` : "")
  }) : renderSuccess({
    headline: "All standard Shopify routes present"
  });
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/classic-compiler/build.js
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/codegen.js
init_cjs_shims();
import { spawn } from "node:child_process";
import { fileURLToPath as fileURLToPath2 } from "node:url";
var nodePath = process.argv[1], modulePath = fileURLToPath2(import.meta.url), isStandaloneProcess = nodePath === modulePath;
isStandaloneProcess && codegen({
  rootDirectory: process.argv[2],
  appDirectory: process.argv[3],
  configFilePath: process.argv[4],
  watch: !0
});
function normalizeCodegenError(errorMessage2, rootDirectory) {
  if (errorMessage2.includes("AbortError: ")) {
    let parsedError = errorMessage2.split("AbortError: ")[1] ?? "", message2 = parsedError.split(`
`)[0], details2 = parsedError.match(/tryMessage: '(.*)',$/m)?.[1];
    if (message2)
      return { message: message2, details: details2 };
  }
  let [first = "", ...rest] = errorMessage2.replaceAll("[FAILED]", "").replace(/\s{2,}/g, `
`).replace(/\n,\n/, `
`).trim().split(`
`), message = "[Codegen] " + first, details = rest.join(`
`);
  if (rootDirectory) {
    let forwardSlashRootDir = rootDirectory.replaceAll("\\", "/") + "/";
    details = details.replaceAll(forwardSlashRootDir, "");
  }
  return { message, details };
}
function spawnCodegenProcess({
  rootDirectory,
  appDirectory,
  configFilePath
}) {
  let command, args, hydrogenArgvIndex = process.argv.findIndex((a) => a === "hydrogen");
  hydrogenArgvIndex >= 1 ? (command = process.argv[0], args = [
    ...process.argv.slice(1, hydrogenArgvIndex + 1),
    "codegen",
    "--watch",
    "--path",
    rootDirectory
  ], configFilePath && args.push("--codegen-config-path", configFilePath)) : (command = "node", args = [
    fileURLToPath2(import.meta.url),
    rootDirectory,
    appDirectory ?? resolvePath("app"),
    configFilePath ?? ""
  ]);
  let child = spawn(command, args, { stdio: ["inherit", "ignore", "pipe"] });
  return child.stderr.on("data", (data) => {
    let dataString = typeof data == "string" ? data : data?.toString?.("utf8") ?? "";
    if (!dataString)
      return;
    let { message, details } = normalizeCodegenError(dataString, rootDirectory);
    /`punycode`/.test(message) || /\.body\[\d\]/.test(message) || /console\.time(End)?\(\)/.test(message) || /─ (warning|info|success) ───/.test(message) || (console.log(""), renderWarning({ headline: message, body: details }));
  }), child.on("close", (code) => {
    code && code > 0 && renderWarning({
      headline: "Codegen process exited with code " + code,
      body: "There should be more logs above."
    });
  }), child;
}
function codegen(options) {
  return generateTypes(options).catch((error) => {
    if (error instanceof AbortError)
      throw error;
    let { message, details } = normalizeCodegenError(
      error.message,
      options.rootDirectory
    );
    throw new AbortError(message, details);
  });
}
async function generateTypes({
  watch,
  configFilePath,
  forceSfapiVersion,
  ...dirs
}) {
  let { generate: generate2, loadCodegenConfig, CodegenContext } = await importLocal(
    "@graphql-codegen/cli",
    dirs.rootDirectory
  ).catch(() => {
    throw new AbortError(
      "Could not load GraphQL Codegen CLI.",
      "Please make sure you have `@graphql-codegen/cli` installed as a dev dependency."
    );
  }), { config: codegenConfig } = (
    // Load <root>/codegen.ts if available
    await loadCodegenConfig({
      configFilePath: configFilePath ?? dirs.rootDirectory
    }) || // Fall back to default config
    await generateDefaultConfig(dirs, forceSfapiVersion)
  );
  await addHooksToHydrogenOptions(codegenConfig, dirs);
  let codegenContext = new CodegenContext({
    config: {
      ...codegenConfig,
      watch,
      // Note: do not use `silent` without `watch`, it will swallow errors and
      // won't hide all logs. `errorsOnly` flag doesn't work either.
      silent: !watch,
      // @ts-expect-error this is to avoid process.cwd() in tests
      cwd: dirs.rootDirectory
    },
    // https://github.com/dotansimha/graphql-code-generator/issues/9490
    filepath: "not-used-but-must-be-set"
  });
  return codegenContext.cwd = dirs.rootDirectory, await generate2(codegenContext, !0), Object.entries(codegenConfig.generates).reduce((acc, [key, value]) => ("documents" in value && (acc[key] = (Array.isArray(value.documents) ? value.documents : [value.documents]).filter((document2) => typeof document2 == "string")), acc), {});
}
async function generateDefaultConfig({
  rootDirectory,
  appDirectory = resolvePath(rootDirectory, "app")
}, forceSfapiVersion) {
  let { getSchema, preset, pluckConfig } = await importLocal(
    "@shopify/hydrogen-codegen",
    rootDirectory
  ).catch(() => {
    throw new AbortError(
      "Could not load Hydrogen Codegen.",
      "Please make sure you have `@shopify/hydrogen-codegen` installed as a dev dependency."
    );
  }), { loadConfig: loadConfig2 } = await importLocal(
    "graphql-config",
    rootDirectory
  ).catch(() => {
    throw new AbortError(
      "Could not load GraphQL Config.",
      "Please make sure you have `graphql-config` installed as a dev dependency."
    );
  }), gqlConfig = await loadConfig2({
    rootDir: rootDirectory,
    throwOnEmpty: !1,
    throwOnMissing: !1,
    legacy: !1
  }).catch(() => {
  }), sfapiSchema = getSchema("storefront"), sfapiProject = findGqlProject(sfapiSchema, gqlConfig), caapiSchema = getSchema("customer-account", { throwIfMissing: !1 }), caapiProject = caapiSchema ? findGqlProject(caapiSchema, gqlConfig) : void 0, defaultGlob = "*!(*.d).{ts,tsx,js,jsx}", appDirRelative = relativePath(rootDirectory, appDirectory), isKnownSchema = (schema) => {
    let baseSfapiSchema = basename(sfapiSchema), baseCaapiSchema = caapiSchema && basename(caapiSchema);
    return !!(schema.endsWith(baseSfapiSchema) || baseCaapiSchema && schema.endsWith(baseCaapiSchema));
  }, otherCodegenProjects = Object.values(gqlConfig?.projects ?? {}).filter(
    (project) => project.hasExtension("codegen") && (typeof project.schema != "string" || !isKnownSchema(project.schema))
  );
  return {
    filepath: "virtual:codegen",
    config: {
      overwrite: !0,
      pluckConfig,
      generates: {
        // If the SFAPI project in GraphQL config has a codegen extension, use it.
        // Otherwise, always fallback to our default config for SFAPI.
        ...getCodegenFromGraphQLConfig(sfapiProject) ?? {
          "storefrontapi.generated.d.ts": {
            preset,
            schema: sfapiSchema,
            documents: sfapiProject?.documents ?? [
              defaultGlob,
              // E.g. ./server.(t|j)s
              joinPath(appDirRelative, "**", defaultGlob)
              // E.g. app/routes/_index.(t|j)sx
            ],
            ...!!forceSfapiVersion && {
              presetConfig: { importTypes: !1 },
              schema: {
                [`https://hydrogen-preview.myshopify.com/api/${forceSfapiVersion.split(":")[0]}/graphql.json`]: {
                  headers: {
                    "content-type": "application/json",
                    "X-Shopify-Storefront-Access-Token": forceSfapiVersion.split(":")[1] ?? "3b580e70970c4528da70c98e097c2fa0"
                  }
                }
              },
              config: {
                defaultScalarType: "string",
                scalars: { JSON: "unknown" }
              }
            }
          }
        },
        // If the CAAPI project in GraphQL config has a codegen extension, use it.
        // Otherwise, check if the user provided a list of documents to scan for queries
        // before falling back to our default config for CAAPI.
        ...getCodegenFromGraphQLConfig(caapiProject) ?? (caapiProject?.documents ? {
          "customer-accountapi.generated.d.ts": {
            preset,
            schema: caapiSchema,
            documents: caapiProject.documents
          }
        } : {}),
        // Use other unknown codegen projects from the GraphQL config as they are.
        ...otherCodegenProjects.reduce(
          (acc, project) => ({ ...acc, ...getCodegenFromGraphQLConfig(project) }),
          {}
        )
      }
    }
  };
}
function getCodegenFromGraphQLConfig(project) {
  if (project?.extensions?.codegen?.generates)
    return Object.entries(
      project.extensions.codegen.generates
    ).reduce((acc, [key, value]) => (acc[key] = { ...project, ...Array.isArray(value) ? value[0] : value }, acc), {});
}
function findGqlProject(schemaFilepath, gqlConfig) {
  if (!gqlConfig)
    return;
  let schemaFilename = basename(schemaFilepath);
  return Object.values(gqlConfig.projects || {}).find(
    (project) => typeof project.schema == "string" && project.schema.endsWith(schemaFilename)
  );
}
async function addHooksToHydrogenOptions(codegenConfig, { rootDirectory }) {
  let name = Symbol.for("name"), hydrogenProjectsOptions = Object.values(codegenConfig.generates).filter(
    (value) => {
      let foundPreset = (Array.isArray(value) ? value[0] : value)?.preset;
      if (typeof foundPreset == "object" && name in foundPreset)
        return (
          // Preset from @shopify/hydrogen-codegen (e.g. SFAPI, CAAPI)
          foundPreset[name] === "hydrogen" || // Preset from @shopify/graphql-codegen (e.g. Admin API)
          foundPreset[name] === "@shopify/graphql-codegen"
        );
    }
  );
  for (let options of hydrogenProjectsOptions) {
    let hydrogenOptions = Array.isArray(options) ? options[0] : options;
    if (hydrogenOptions) {
      let formatConfig = await getCodeFormatOptions(rootDirectory);
      hydrogenOptions.hooks = {
        beforeOneFileWrite: (file, content) => formatCode(content, formatConfig, file),
        ...hydrogenOptions.hooks
      };
    }
  }
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/bundle/analyzer.js
init_cjs_shims();
var BUNDLE_ANALYZER_JSON_FILE = "metafile.server.json", BUNDLE_ANALYZER_HTML_FILE = "server-bundle-analyzer.html";
async function classicBuildBundleAnalysis(buildPath) {
  let workerBuildPath = joinPath(buildPath, "worker"), serverMetafile = BUNDLE_ANALYZER_JSON_FILE, clientMetafile = "metafile.js.json";
  if (!(await Promise.all([
    fileExists(joinPath(workerBuildPath, serverMetafile)),
    fileExists(joinPath(workerBuildPath, clientMetafile))
  ])).every(Boolean))
    return null;
  try {
    return await Promise.all([
      classicWriteBundleAnalyzerFile(
        workerBuildPath,
        serverMetafile,
        "worker-bundle-analyzer.html"
      ),
      classicWriteBundleAnalyzerFile(
        workerBuildPath,
        clientMetafile,
        "client-bundle-analyzer.html"
      )
    ]), "file://" + joinPath(workerBuildPath, "worker-bundle-analyzer.html");
  } catch (thrown) {
    let error = thrown;
    return renderWarning({
      headline: "Could not generate bundle analysis",
      body: error?.stack ?? error?.message ?? error
    }), null;
  }
}
async function getAnalyzerTemplate() {
  return readFile(await getAssetsDir("bundle", "analyzer.html"));
}
function injectAnalyzerTemplateData(analysisTemplate, metafile) {
  return analysisTemplate.replace(
    "globalThis.METAFILE = '';",
    `globalThis.METAFILE = '${Buffer.from(metafile, "utf-8").toString(
      "base64"
    )}';`
  );
}
async function classicWriteBundleAnalyzerFile(workerBuildPath, metafileName, outputFile) {
  let metafile = await readFile(joinPath(workerBuildPath, metafileName), {
    encoding: "utf8"
  });
  await writeFile(
    joinPath(workerBuildPath, outputFile),
    injectAnalyzerTemplateData(await getAnalyzerTemplate(), metafile)
  );
}
async function getBundleAnalysisSummary(distPath) {
  try {
    return `    \u2502
 ` + (await (await import("esbuild")).analyzeMetafile(
      await readFile(joinPath(distPath, BUNDLE_ANALYZER_JSON_FILE)),
      { color: !0 }
    )).split(`
`).filter((line) => !line.match(
      /(.*)(node_modules\/|server-assets-manifest:|server-entry-module:)(react-dom|@remix-run|@shopify\/hydrogen|react-router|react-router-dom)\/(.*)/g
    )).slice(2, 12).join(`
`).replace(/dist\/worker\/_assets\/.*$/ms, `
`).replace(/\n/g, `
 `).replace(/(\.\.\/)+node_modules\//g, (match2) => source_default.dim(match2));
  } catch (error) {
    console.warn(
      "Could not generate bundle analysis summary:",
      error.message
    );
  }
}
function classicGetBundleAnalysisSummary(bundlePath) {
  return getBundleAnalysisSummary(dirname(bundlePath));
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/is-ci.js
init_cjs_shims();
function isCI() {
  let { env } = process;
  return env.CI === "false" ? !1 : !!(env.CI || env.CI_NAME || env.BUILD_NUMBER || env.TF_BUILD);
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/classic-compiler/build.js
var LOG_WORKER_BUILT = "\u{1F4E6} Worker built", WORKER_BUILD_SIZE_LIMIT = 5;
async function runClassicCompilerBuild({
  directory,
  useCodegen = !1,
  codegenConfigPath,
  sourcemap = !1,
  disableRouteWarning = !1,
  bundleStats = !0,
  lockfileCheck = !0,
  assetPath
}) {
  process.env.NODE_ENV || (process.env.NODE_ENV = "production"), assetPath && (process.env.HYDROGEN_ASSET_BASE_URL = assetPath);
  let { root, buildPath, buildPathClient, buildPathWorkerFile, publicPath } = getProjectPaths(directory);
  lockfileCheck && await checkLockfileStatus(root, isCI()), await muteRemixLogs(root), console.time(LOG_WORKER_BUILT), outputInfo(`
\u{1F3D7}\uFE0F  Building in ${process.env.NODE_ENV} mode...`);
  let [remixConfig, [{ build: build2 }, { logThrown }, { createFileWatchCache }]] = await Promise.all([
    getRemixConfig(root),
    Promise.all([
      importLocal("@remix-run/dev/dist/compiler/build.js", root),
      importLocal(
        "@remix-run/dev/dist/compiler/utils/log.js",
        root
      ),
      importLocal(
        "@remix-run/dev/dist/compiler/fileWatchCache.js",
        root
      )
    ]).catch(handleRemixImportFail),
    rmdir(buildPath, { force: !0 })
  ]);
  if (assertOxygenChecks(remixConfig), await Promise.all([
    copyPublicFiles(publicPath, buildPathClient),
    build2({
      config: remixConfig,
      options: {
        mode: process.env.NODE_ENV,
        sourcemap
      },
      logger: createRemixLogger(),
      fileWatchCache: createFileWatchCache()
    }).catch((thrown) => {
      if (logThrown(thrown), process.env.SHOPIFY_UNIT_TEST)
        throw thrown;
      process.exit(1);
    }),
    useCodegen && codegen({ ...remixConfig, configFilePath: codegenConfigPath })
  ]), process.env.NODE_ENV !== "development") {
    console.timeEnd(LOG_WORKER_BUILT);
    let bundleAnalysisPath = await classicBuildBundleAnalysis(buildPath), sizeMB = await fileSize(buildPathWorkerFile) / (1024 * 1024), formattedSize = source_default.yellow(sizeMB.toFixed(2) + " MB");
    outputInfo(
      outputContent`   ${source_default.dim(
        relativePath(root, buildPathWorkerFile)
      )}  ${bundleAnalysisPath ? outputToken.link(formattedSize, bundleAnalysisPath) : formattedSize}\n`
    ), bundleStats && bundleAnalysisPath && outputInfo(
      outputContent`${await classicGetBundleAnalysisSummary(buildPathWorkerFile) || `
`}\n    │\n    └─── ${outputToken.link(
        "Complete analysis: " + bundleAnalysisPath,
        bundleAnalysisPath
      )}\n\n`
    ), sizeMB >= WORKER_BUILD_SIZE_LIMIT && outputWarn(
      `\u{1F6A8} Smaller worker bundles are faster to deploy and run.${remixConfig.serverMinify ? "" : "\n   Minify your bundle by adding `serverMinify: true` to remix.config.js."}
   Learn more about optimizing your worker bundle file: https://h2o.fyi/debugging/bundle-size
`
    );
  }
  if (!disableRouteWarning) {
    let missingRoutes = findMissingRoutes(remixConfig);
    if (missingRoutes.length) {
      let packageManager2 = await getPackageManager(root), exec2 = packageManager2 === "npm" ? "npx" : packageManager2;
      outputWarn(
        `Heads up: Shopify stores have a number of standard routes that aren\u2019t set up yet.
Some functionality and backlinks might not work as expected until these are created or redirects are set up.
This build is missing ${missingRoutes.length} route${missingRoutes.length > 1 ? "s" : ""}. For more details, run \`${exec2} shopify hydrogen check routes\`.
`
      );
    }
  }
  process.env.NODE_ENV !== "development" && await cleanClientSourcemaps(buildPathClient);
}
async function cleanClientSourcemaps(buildPathClient) {
  let bundleFiles = await glob(joinPath(buildPathClient, "**/*.js"));
  await Promise.all(
    bundleFiles.map(async (filePath) => {
      let file = await readFile(filePath);
      return await writeFile(
        filePath,
        file.replace(/\/\/# sourceMappingURL=.+\.js\.map$/gm, "")
      );
    })
  );
}
async function copyPublicFiles(publicPath, buildPathClient) {
  if (await fileExists(publicPath))
    return copyFile(publicPath, buildPathClient);
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/bundle/vite-plugin.js
init_cjs_shims();
function hydrogenBundleAnalyzer(pluginOptions) {
  let config2;
  return {
    name: "hydrogen:bundle-analyzer",
    configResolved(_config) {
      config2 = _config;
    },
    async generateBundle(options, bundle) {
      if (!config2.build.ssr)
        return;
      let { root } = config2, workerFile = Object.values(bundle).find(
        (chunk) => chunk.type === "chunk"
      );
      if (!workerFile || workerFile.type !== "chunk" || !workerFile.facadeModuleId || !options.dir)
        return;
      let analysisTemplate = await getAnalyzerTemplate().catch(() => null);
      if (!analysisTemplate) {
        console.warn("Bundle analyzer template not found");
        return;
      }
      let allModIds = new Set(Object.keys(workerFile.modules)), modsToAnalyze = [];
      for (let modId of allModIds) {
        if (isViteCjsHelper(modId) || isViteTransformHelper(modId))
          continue;
        let mod = this.getModuleInfo(modId);
        if (mod?.id) {
          modsToAnalyze.push(mod);
          for (let importedId of [
            ...mod.importedIds,
            ...mod.dynamicallyImportedIds
          ])
            !isViteCjsHelper(importedId) && !isViteTransformHelper(importedId) && allModIds.add(importedId);
        }
      }
      let modsMeta = /* @__PURE__ */ new Map(), renderedSizes = /* @__PURE__ */ new Map(), resultError = await Promise.all(
        modsToAnalyze.map(async (mod) => {
          let relativeModId = relativePath(root, mod.id), modBundleInfo = workerFile.modules[mod.id], originalCodeBytes = modBundleInfo?.originalLength ?? mod.code?.length ?? 0, resultingCodeBytes = modBundleInfo?.renderedLength ?? 0;
          if (pluginOptions?.minify && modBundleInfo?.code) {
            let minifiedCode = await pluginOptions.minify(modBundleInfo.code, mod.id).catch(() => null);
            minifiedCode && (resultingCodeBytes = minifiedCode.length);
          }
          renderedSizes.set(relativeModId, resultingCodeBytes);
          let resolveImportString = (importString) => this.resolve(importString, mod.id), isESM = !mod.code || /(^\s*export\s+[\w\{]|^\s*import\s+[\w\{'"]|\bimport\()|\bcreateRequire\(/ms.test(
            mod.code
          ) || !/((^|\b)exports\b|\brequire\()/.test(mod.code), staticImportsMeta = createImportsMeta(
            mod.importedIds,
            "import-statement",
            root,
            resolveImportString,
            mod.code
          ), dynamicImportsMeta = createImportsMeta(
            mod.dynamicallyImportedIds,
            "dynamic-import",
            root,
            resolveImportString,
            mod.code
          ), importsMeta = (await Promise.all([...staticImportsMeta, ...dynamicImportsMeta])).reduce((acc, { importedId, ...meta }) => (isViteCjsHelper(importedId) ? isESM = !1 : isViteTransformHelper(importedId) || acc.push(meta), acc), []);
          modsMeta.set(relativeModId, {
            bytes: originalCodeBytes,
            format: isESM ? "esm" : "cjs",
            imports: importsMeta
          });
        })
      ).then(() => null).catch((error) => error);
      if (resultError) {
        console.warn(
          "Bundle analyzer failed to analyze the bundle:",
          resultError
        );
        return;
      }
      let inputs = Object.fromEntries(modsMeta.entries()), metafile = {
        inputs,
        outputs: {
          [relativePath(root, joinPath(options.dir, workerFile.fileName))]: {
            imports: workerFile.imports,
            exports: workerFile.exports,
            entryPoint: relativePath(root, workerFile.facadeModuleId),
            bytes: workerFile.code.length ?? 0,
            inputs: Object.entries(inputs).reduce((acc, [key, item]) => (acc[key] = {
              bytesInOutput: renderedSizes.get(key) ?? item.bytes ?? 0
            }, acc), {})
          }
        }
      };
      bundle[BUNDLE_ANALYZER_JSON_FILE] = {
        type: "asset",
        fileName: BUNDLE_ANALYZER_JSON_FILE,
        name: BUNDLE_ANALYZER_JSON_FILE,
        needsCodeReference: !1,
        source: JSON.stringify(metafile, null, 2)
      }, bundle[BUNDLE_ANALYZER_HTML_FILE] = {
        type: "asset",
        fileName: BUNDLE_ANALYZER_HTML_FILE,
        name: BUNDLE_ANALYZER_HTML_FILE,
        needsCodeReference: !1,
        source: injectAnalyzerTemplateData(
          analysisTemplate,
          JSON.stringify(metafile)
        )
      };
    }
  };
}
function isViteCjsHelper(id) {
  return /(commonjsHelpers\.js$|\?commonjs\-)/.test(id);
}
function isViteTransformHelper(id) {
  return id.endsWith("?transform-only");
}
async function findOriginalImportName(filepath, importerCode, resolve2) {
  let matches = importerCode.matchAll(/import\s[^'"]*?['"]([^'"]+)['"]/g) ?? [];
  for (let [, match2] of matches)
    if (match2 && (await resolve2(match2))?.id === filepath)
      return match2;
  return filepath;
}
function createImportsMeta(ids, kind, root, resolveImportString, code) {
  return ids.map(async (importedId) => ({
    importedId,
    path: relativePath(root, importedId),
    kind,
    original: code ? await findOriginalImportName(importedId, code, resolveImportString) : importedId
  }));
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/defer.js
init_cjs_shims();
function deferPromise() {
  let deferred = { state: "pending" };
  return deferred.promise = new Promise((resolve2, reject) => {
    deferred.resolve = (value) => (deferred.state === "pending" && (deferred.state = "resolved"), resolve2(value)), deferred.reject = (reason) => (deferred.state === "pending" && (deferred.state = "rejected"), reject(reason));
  }), deferred;
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/resource-cleanup.js
init_cjs_shims();
function setupResourceCleanup(cleanup2) {
  let closingPromise, processExit = process.exit;
  process.exit = async (code) => {
    closingPromise ??= cleanup2();
    let timeout = setTimeout(() => processExit(code), 5e3);
    return await closingPromise, clearTimeout(timeout), processExit(code);
  };
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/build.js
var Build = class _Build extends base_command_default {
  static descriptionWithMarkdown = "Builds a Hydrogen storefront for production. The client and app worker files are compiled to a `/dist` folder in your Hydrogen project directory.";
  static description = "Builds a Hydrogen storefront for production.";
  static flags = {
    ...commonFlags.path,
    ...commonFlags.entry,
    ...commonFlags.sourcemap,
    ...commonFlags.lockfileCheck,
    ...commonFlags.disableRouteWarning,
    ...commonFlags.codegen,
    ...commonFlags.diff,
    watch: import_core16.Flags.boolean({
      description: "Watches for changes and rebuilds the project writing output to disk.",
      env: "SHOPIFY_HYDROGEN_FLAG_WATCH"
    }),
    // For the classic compiler:
    "bundle-stats": import_core16.Flags.boolean({
      description: "Show a bundle size summary after building. Defaults to true, use `--no-bundle-stats` to disable.",
      allowNo: !0
    })
  };
  async run() {
    let { flags } = await this.parse(_Build), originalDirectory = flags.path ? resolvePath(flags.path) : process.cwd(), diff2 = flags.diff ? await prepareDiffDirectory(originalDirectory, flags.watch) : void 0, directory = diff2?.targetDirectory ?? originalDirectory, buildParams = {
      ...flagsToCamelObject(flags),
      useCodegen: flags.codegen,
      directory
    }, result = await isViteProject(directory) ? await runBuild(buildParams) : await runClassicCompilerBuild(buildParams);
    buildParams.watch ? (diff2 || result?.close) && setupResourceCleanup(async () => {
      await result?.close(), diff2 && (await diff2.copyDiffBuild(), flags.codegen && await diff2.copyDiffCodegen(), await diff2.cleanup());
    }) : (diff2 && (await diff2.copyDiffBuild(), flags.codegen && await diff2.copyDiffCodegen(), await diff2.cleanup()), process.exit(0));
  }
}, WORKER_BUILD_SIZE_LIMIT2 = 5;
async function runBuild({
  entry: ssrEntry,
  directory,
  useCodegen = !1,
  codegenConfigPath,
  sourcemap = !0,
  disableRouteWarning = !1,
  lockfileCheck = !0,
  assetPath = "/",
  bundleStats = !isCI(),
  watch = !1,
  onServerBuildStart,
  onServerBuildFinish
}) {
  process.env.NODE_ENV || (process.env.NODE_ENV = "production");
  let root = directory ?? process.cwd();
  lockfileCheck && await checkLockfileStatus(root, isCI());
  let [
    vite,
    { userViteConfig, remixConfig, clientOutDir, serverOutDir, serverOutFile }
  ] = await Promise.all([
    // Avoid static imports because this file is imported by `deploy` command,
    // which must have a hard dependency on 'vite'.
    importVite(root),
    getViteConfig(root, ssrEntry)
  ]), customLogger = vite.createLogger(watch ? "warn" : void 0);
  process.env.SHOPIFY_UNIT_TEST && (customLogger.info = (msg) => collectLog("info", msg), customLogger.warn = (msg) => collectLog("warn", msg), customLogger.error = (msg) => collectLog("error", msg));
  let serverMinify = userViteConfig.build?.minify ?? !0, commonConfig = {
    root,
    mode: process.env.NODE_ENV,
    base: assetPath,
    customLogger
  }, clientBuildStatus, clientBuild = await vite.build({
    ...commonConfig,
    build: {
      emptyOutDir: !0,
      copyPublicDir: !0,
      // Disable client sourcemaps in production
      sourcemap: process.env.NODE_ENV !== "production" && sourcemap,
      watch: watch ? {} : null
    },
    plugins: [
      {
        name: "hydrogen:cli:client",
        buildStart() {
          clientBuildStatus?.resolve(), clientBuildStatus = deferPromise();
        },
        buildEnd(error) {
          error && clientBuildStatus.reject(error);
        },
        writeBundle() {
          clientBuildStatus.resolve();
        },
        closeWatcher() {
          this.error(new Error("Process exited before client build finished."));
        }
      }
    ]
  });
  console.log("");
  let serverBuildStatus, serverBuild = await vite.build({
    ...commonConfig,
    build: {
      sourcemap,
      ssr: ssrEntry ?? !0,
      emptyOutDir: !1,
      copyPublicDir: !1,
      minify: serverMinify,
      // Ensure the server rebuild start after the client one
      watch: watch ? { buildDelay: 100 } : null
    },
    plugins: [
      {
        name: "hydrogen:cli:server",
        async buildStart() {
          await clientBuildStatus.promise, serverBuildStatus?.resolve(), serverBuildStatus = deferPromise(), await onServerBuildStart?.();
        },
        async writeBundle() {
          serverBuildStatus?.state !== "rejected" && await onServerBuildFinish?.(), serverBuildStatus.resolve();
        },
        closeWatcher() {
          this.error(new Error("Process exited before server build finished."));
        }
      },
      ...bundleStats ? [
        hydrogenBundleAnalyzer({
          minify: serverMinify ? (code, filepath) => vite.transformWithEsbuild(code, filepath, {
            minify: !0,
            minifyWhitespace: !0,
            minifySyntax: !0,
            minifyIdentifiers: !0,
            sourcemap: !1,
            treeShaking: !1,
            // Tree-shaking would drop most exports in routes
            legalComments: "none",
            target: "esnext"
          }).then((result) => result.code) : void 0
        })
      ] : []
    ]
  });
  watch || await Promise.all([
    removeFile(joinPath(clientOutDir, ".vite")),
    removeFile(joinPath(serverOutDir, ".vite")),
    removeFile(joinPath(serverOutDir, "assets"))
  ]);
  let codegenOptions = {
    rootDirectory: root,
    appDirectory: remixConfig.appDirectory,
    configFilePath: codegenConfigPath
  }, codegenProcess = useCodegen ? watch ? spawnCodegenProcess(codegenOptions) : await codegen(codegenOptions).then(() => {
  }) : void 0;
  if (!watch && process.env.NODE_ENV !== "development") {
    if (bundleStats) {
      let bundleAnalysisPath = "file://" + joinPath(serverOutDir, BUNDLE_ANALYZER_HTML_FILE);
      outputInfo(
        outputContent`${await getBundleAnalysisSummary(serverOutDir) || `
`}\n    │\n    └─── ${outputToken.link(
          "Complete analysis: " + bundleAnalysisPath,
          bundleAnalysisPath
        )}\n\n`
      );
    }
    await fileSize(serverOutFile) / (1024 * 1024) >= WORKER_BUILD_SIZE_LIMIT2 && outputWarn(
      `\u{1F6A8} Smaller worker bundles are faster to deploy and run.${serverMinify ? "" : "\n   Minify your bundle by adding `build.minify: true` to vite.config.js."}
   Learn more about optimizing your worker bundle file: https://h2o.fyi/debugging/bundle-size
`
    );
  }
  if (!watch && !disableRouteWarning) {
    let missingRoutes = findMissingRoutes(remixConfig);
    if (missingRoutes.length) {
      let packageManager2 = await getPackageManager(root), exec2 = packageManager2 === "npm" ? "npx" : packageManager2;
      outputWarn(
        `Heads up: Shopify stores have a number of standard routes that aren\u2019t set up yet.
Some functionality and backlinks might not work as expected until these are created or redirects are set up.
This build is missing ${missingRoutes.length} route${missingRoutes.length > 1 ? "s" : ""}. For more details, run \`${exec2} shopify hydrogen check routes\`.
`
      );
    }
  }
  return {
    async close() {
      codegenProcess?.removeAllListeners("close"), codegenProcess?.kill("SIGINT");
      let promises = [];
      "close" in clientBuild && promises.push(clientBuild.close()), "close" in serverBuild && promises.push(serverBuild.close()), await Promise.allSettled(promises), (clientBuildStatus?.state === "pending" || serverBuildStatus?.state === "pending") && (clientBuildStatus?.promise.catch(() => {
      }), clientBuildStatus?.reject(), serverBuildStatus?.promise.catch(() => {
      }), serverBuildStatus?.reject(), await new Promise((resolve2) => setTimeout(resolve2, 500)));
    }
  };
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/check.js
init_cjs_shims();
var import_core17 = __toESM(require_lib(), 1), GenerateRoute = class _GenerateRoute extends base_command_default {
  static descriptionWithMarkdown = "Checks whether your Hydrogen app includes a set of standard Shopify routes.";
  static description = "Returns diagnostic information about a Hydrogen storefront.";
  static flags = {
    ...commonFlags.path
  };
  static args = {
    resource: import_core17.Args.string({
      name: "resource",
      description: "The resource to check. Currently only 'routes' is supported.",
      required: !0,
      options: ["routes"]
    })
  };
  async run() {
    let { flags, args } = await this.parse(_GenerateRoute), directory = flags.path ? resolvePath(flags.path) : process.cwd();
    if (args.resource === "routes")
      await runCheckRoutes({ directory });
    else
      throw new Error("Invalid command argument.");
  }
};
async function runCheckRoutes({ directory }) {
  let remixConfig = await getRemixConfig(directory);
  logMissingRoutes(findMissingRoutes(remixConfig));
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/codegen.js
init_cjs_shims();
var import_core18 = __toESM(require_lib(), 1);
var Codegen = class _Codegen extends base_command_default {
  static descriptionWithMarkdown = "Automatically generates GraphQL types for your project\u2019s Storefront API queries.";
  static description = "Generate types for the Storefront API queries found in your project.";
  static flags = {
    ...commonFlags.path,
    "codegen-config-path": import_core18.Flags.string({
      description: "Specify a path to a codegen configuration file. Defaults to `<root>/codegen.ts` if it exists.",
      required: !1
    }),
    "force-sfapi-version": import_core18.Flags.string({
      description: "Force generating Storefront API types for a specific version instead of using the one provided in Hydrogen. A token can also be provided with this format: `<version>:<token>`.",
      hidden: !0
    }),
    watch: import_core18.Flags.boolean({
      description: "Watch the project for changes to update types on file save.",
      required: !1,
      default: !1
    }),
    ...commonFlags.diff
  };
  async run() {
    let { flags } = await this.parse(_Codegen), originalDirectory = flags.path ? resolvePath(flags.path) : process.cwd(), diff2 = flags.diff ? await prepareDiffDirectory(originalDirectory, flags.watch) : void 0, directory = diff2?.targetDirectory ?? originalDirectory;
    await runCodegen({
      ...flagsToCamelObject(flags),
      directory
    }), diff2 && (await diff2.copyDiffCodegen(), await diff2.cleanup());
  }
};
async function runCodegen({
  directory,
  codegenConfigPath,
  forceSfapiVersion,
  watch
}) {
  let { root } = getProjectPaths(directory), remixConfig = await getRemixConfig(root);
  console.log("");
  let generatedFiles = await codegen({
    ...remixConfig,
    configFilePath: codegenConfigPath,
    forceSfapiVersion,
    watch
  });
  watch || renderSuccess({
    headline: "Generated types for GraphQL:",
    body: {
      list: {
        items: Object.entries(generatedFiles).map(
          ([key, value]) => key + `
` + value.map((item) => source_default.dim(`- ${item}`)).join(`
`)
        )
      }
    }
  });
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/debug/cpu.js
init_cjs_shims();
var import_core19 = __toESM(require_lib(), 1);

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/classic-compiler/debug-cpu.js
init_cjs_shims();
async function runClassicCompilerDebugCpu({
  directory,
  hooks: hooks2
}) {
  let [{ watch }, { createFileWatchCache }] = await Promise.all([
    importLocal("@remix-run/dev/dist/compiler/watch.js", directory),
    importLocal(
      "@remix-run/dev/dist/compiler/fileWatchCache.js",
      directory
    )
  ]).catch(handleRemixImportFail), fileWatchCache = createFileWatchCache(), closeWatcher = await watch(
    {
      config: await getRemixConfig(directory),
      options: {
        mode: process.env.NODE_ENV,
        sourcemap: !0
      },
      fileWatchCache,
      logger: createRemixLogger()
    },
    {
      onBuildStart: hooks2.onServerBuildStart,
      async onBuildFinish(context, duration, succeeded) {
        succeeded ? await hooks2.onServerBuildFinish() : outputWarn(`
Build failed, waiting for changes to restart...`);
      },
      async onFileChanged(file) {
        fileWatchCache.invalidateFile(file);
      },
      async onFileDeleted(file) {
        fileWatchCache.invalidateFile(file);
      }
    }
  );
  return {
    async close() {
      await closeWatcher();
    }
  };
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/cpu-profiler.js
init_cjs_shims();
import { Session } from "node:inspector";
async function createCpuStartupProfiler(root) {
  let { createMiniOxygen } = await importLocal(
    "@shopify/mini-oxygen/node",
    root
  ).catch(handleMiniOxygenImportFail), miniOxygen = createMiniOxygen({
    script: "export default {}",
    modules: !0,
    log: () => {
    }
  });
  return {
    async run(scriptPath, sourceEntrypoint) {
      let [script] = await Promise.all([
        readFile(scriptPath),
        miniOxygen.ready()
      ]), stopProfiler = await startProfiler();
      await miniOxygen.reload({ script });
      let rawProfile = await stopProfiler();
      return enhanceProfileNodes(
        rawProfile,
        scriptPath + ".map",
        sourceEntrypoint
      );
    },
    async close() {
      await miniOxygen.dispose();
    }
  };
}
function startProfiler() {
  let session = new Session();
  return session.connect(), new Promise((resolveStart) => {
    session.post("Profiler.enable", () => {
      session.post("Profiler.start", () => {
        resolveStart(() => new Promise((resolveStop, rejectStop) => {
          session.post("Profiler.stop", (err2, { profile }) => {
            if (session.disconnect(), err2)
              return rejectStop(err2);
            resolveStop(profile);
          });
        }));
      });
    });
  });
}
async function enhanceProfileNodes(profile, sourceMapPath, sourceEntrypoint) {
  let { SourceMapConsumer } = await import("./source-map-7AAPWPHZ.js"), sourceMap = JSON.parse(await readFile(sourceMapPath)), smc = await new SourceMapConsumer(sourceMap, "file://" + sourceMapPath), scriptDescendants = /* @__PURE__ */ new Set(), totalScriptTimeMicrosec = 0, totalTimeMicrosec = profile.endTime - profile.startTime, timePerSample = profile.samples?.length ? totalTimeMicrosec / profile.samples.length : 0;
  for (let node of profile.nodes)
    (node.callFrame.url === "<script>" || scriptDescendants.has(node.id)) && (scriptDescendants.add(node.id), node.children?.forEach((id) => scriptDescendants.add(id))), scriptDescendants.has(node.id) ? (augmentNode(node, smc), node.callFrame.url === "<script>" && !node.callFrame.functionName && !node.callFrame.lineNumber && !node.callFrame.columnNumber && (node.callFrame.url = sourceEntrypoint ?? "", node.callFrame.functionName = "(top-level app code)"), totalScriptTimeMicrosec += Math.round((node.hitCount ?? 0) * timePerSample * 1e3) / 1e3) : silenceNode(node);
  return smc.destroy(), {
    profile,
    totalTimeMs: totalTimeMicrosec / 1e3,
    totalScriptTimeMs: totalScriptTimeMicrosec / 1e3
  };
}
function augmentNode(node, smc) {
  let originalPosition = smc.originalPositionFor({
    line: node.callFrame.lineNumber + 1,
    column: node.callFrame.columnNumber + 1
  });
  node.callFrame.url = originalPosition.source || node.callFrame.url, node.callFrame.functionName = originalPosition.name || node.callFrame.functionName, node.callFrame.lineNumber = originalPosition.line ? originalPosition.line - 1 : node.callFrame.lineNumber, node.callFrame.columnNumber = originalPosition.column ?? node.callFrame.columnNumber;
}
function silenceNode(node) {
  Object.assign(node, {
    children: [],
    callFrame: {
      functionName: "(profiler)",
      scriptId: "0",
      url: "",
      lineNumber: -1,
      columnNumber: -1
    }
  });
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/debug/cpu.js
var DEFAULT_OUTPUT_PATH = "startup.cpuprofile", DebugCpu = class _DebugCpu extends base_command_default {
  static descriptionWithMarkdown = "Builds the app and runs the resulting code to profile the server startup time, watching for changes. This command can be used to [debug slow app startup times](https://shopify.dev/docs/custom-storefronts/hydrogen/debugging/cpu-startup) that cause failed deployments in Oxygen.\n\n  The profiling results are written to a `.cpuprofile` file that can be viewed with certain tools such as [Flame Chart Visualizer for Visual Studio Code](https://marketplace.visualstudio.com/items?itemName=ms-vscode.vscode-js-profile-flame).";
  static description = "Builds and profiles the server startup time the app.";
  static flags = {
    ...commonFlags.path,
    ...commonFlags.diff,
    ...commonFlags.entry,
    output: import_core19.Flags.string({
      description: `Specify a path to generate the profile file. Defaults to "${DEFAULT_OUTPUT_PATH}".`,
      default: DEFAULT_OUTPUT_PATH,
      required: !1
    })
  };
  async run() {
    let { flags } = await this.parse(_DebugCpu), originalDirectory = flags.path ? resolvePath(flags.path) : process.cwd(), diff2 = flags.diff ? await prepareDiffDirectory(originalDirectory, !0) : void 0, { close } = await runDebugCpu({
      ...flagsToCamelObject(flags),
      directory: diff2?.targetDirectory ?? originalDirectory,
      output: resolvePath(originalDirectory, flags.output)
    });
    setupResourceCleanup(async () => {
      await close(), await diff2?.cleanup();
    });
  }
};
async function runDebugCpu({ directory, entry, output }) {
  process.env.NODE_ENV || (process.env.NODE_ENV = "production"), muteDevLogs({ workerReload: !1 });
  let { buildPath, buildPathWorkerFile } = getProjectPaths(directory);
  outputInfo(
    `\u23F3\uFE0F Starting profiler for CPU startup... Profile will be written to:
` + source_default.dim(output)
  );
  let times = 0, sourceEntrypoint, profiler = await createCpuStartupProfiler(directory), hooks2 = {
    onServerBuildStart() {
      times > 0 && process.stdout.write(ansi_escapes_default.eraseLines(4)), outputInfo(`
#${++times} Building and profiling...`);
    },
    async onServerBuildFinish() {
      let { profile, totalScriptTimeMs } = await profiler.run(
        buildPathWorkerFile,
        sourceEntrypoint
      );
      process.stdout.write(ansi_escapes_default.eraseLines(2)), outputInfo(
        `#${times} Total time: ${totalScriptTimeMs.toLocaleString()} ms
${source_default.dim(output)}`
      ), await writeFile(output, JSON.stringify(profile, null, 2)), outputInfo(`
Waiting for changes...`);
    }
  };
  if (await isClassicProject(directory))
    return runClassicCompilerDebugCpu({
      directory,
      output,
      buildPathWorkerFile,
      hooks: hooks2
    });
  let maybeViteConfig = await getViteConfig(directory).catch(() => null);
  buildPathWorkerFile = maybeViteConfig?.serverOutFile ?? joinPath(buildPath, "server", "index.js"), sourceEntrypoint = maybeViteConfig?.remixConfig.serverEntryPoint ?? "";
  let buildProcess = await runBuild({
    entry,
    directory,
    watch: !0,
    sourcemap: !0,
    disableRouteWarning: !0,
    lockfileCheck: !1,
    bundleStats: !1,
    ...hooks2,
    onServerBuildStart() {
      return times === 0 && process.stdout.write(ansi_escapes_default.eraseLines(1)), hooks2.onServerBuildStart();
    }
  });
  return {
    async close() {
      await Promise.allSettled([buildProcess.close(), profiler.close()]);
    }
  };
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/deploy.js
init_cjs_shims();
var import_core20 = __toESM(require_lib(), 1);

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/index.js
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/utils/utils.js
init_cjs_shims();
import fs from "fs";
import path, { dirname as dirname2 } from "path";
import { fileURLToPath as fileURLToPath3 } from "url";
var deployDefaults = {
  assetsDirDefault: "dist/client/",
  buildCommandDefault: "npm build",
  verificationDurationDefault: 180,
  maxUploadAttempts: 3,
  maxResumabeUploadAttempts: 9,
  workerDirDefault: "dist/worker/"
};
function errorHandler(error) {
  if (isClientError(error)) {
    if (error.statusCode === 401)
      throw new AbortError(
        "You are not authorized to perform this action. Please check your deployment token."
      );
    if (error.statusCode === 429)
      throw new AbortError(
        "You've made too many requests. Please try again later"
      );
  }
  if (error instanceof AbortError && error.message.includes("503"))
    throw new AbortError(
      "The server is currently unavailable. Please try again later."
    );
}
var Header = /* @__PURE__ */ ((Header22) => (Header22.OxygenNamespaceHandle = "X-Oxygen-Namespace-Handle", Header22))(Header || {});
function isClientError(error) {
  return typeof error == "object" && error !== null && "statusCode" in error;
}
function loadPackageJson(projectFolder) {
  let jsonPath;
  if (projectFolder)
    jsonPath = path.join(projectFolder, "package.json");
  else {
    let __filename2 = fileURLToPath3(import.meta.url), __dirname2 = dirname2(__filename2);
    jsonPath = path.join(__dirname2, "../../package.json");
  }
  if (!fs.existsSync(jsonPath))
    return {};
  let packageJsonData = fs.readFileSync(jsonPath, "utf8");
  return JSON.parse(packageJsonData);
}
function stderrLogger(log) {
  process.stderr.write(`${log}
`);
}
var maxLabelLength = 375;
function parseToken(inputToken) {
  try {
    let decodedToken = Buffer.from(inputToken, "base64").toString("utf-8"), rawToken = JSON.parse(decodedToken);
    return convertKeysToCamelCase(rawToken);
  } catch {
    throw new Error(
      "Error processing deployment token. Please check your token and try again."
    );
  }
}
function authBypassTokenDurationParse(authBypassTokenDurationFlag) {
  if (!authBypassTokenDurationFlag)
    return;
  let duration = Number(authBypassTokenDurationFlag);
  if (isNaN(duration))
    throw new AbortError(
      "Invalid duration format. Please specify the duration in hours (e.g., '10')."
    );
  if (duration > 12 || duration < 1)
    throw new AbortError(
      "Invalid duration length. Please specify the duration (in hours) between 1 to 12 hours."
    );
  return duration;
}
async function verifyConfig({
  config: config2,
  performedBuild = !1
}) {
  let { rootPath, workerDir, assetsDir, skipBuild, workerOnly } = config2, checkPaths = {
    root: rootPath
  };
  (skipBuild || performedBuild) && (checkPaths.worker = joinPath(rootPath, workerDir), workerOnly || (checkPaths.assets = joinPath(rootPath, assetsDir)));
  for (let pathType of Object.keys(checkPaths))
    await checkPath(checkPaths[pathType], pathType);
  if (!/^https:\/\/(?:[\w-]+\.)*[\w-]+|^https:\/\/\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/.test(config2.deploymentUrl))
    throw new Error(`Invalid deployment service URL: ${config2.deploymentUrl}`);
}
async function checkPath(path22, pathType) {
  if (!await fileExists(path22))
    throw pathType === "assets" && outputWarn(
      'Use the "workerOnly" flag to perform a worker-only deployment.',
      stderrLogger
    ), new Error(`Path not found: ${path22}`);
}
function convertKeysToCamelCase(obj) {
  return typeof obj == "object" ? Object.keys(obj).reduce((result, key) => {
    let camelCaseKey = key.replace(
      /([-_][a-z])/gi,
      ($1) => $1.toUpperCase().replace("-", "").replace("_", "")
    );
    if (obj[key] === void 0)
      throw new Error(`Invalid token: ${key} is undefined`);
    return result[camelCaseKey] = convertKeysToCamelCase(obj[key]), result;
  }, {}) : obj;
}

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/utils/bugsnag.js
init_cjs_shims();
var import_node = __toESM(require_bugsnag(), 1);
var BugsnagClient;
function setupBugsnag(disableBugsnag) {
  if (disableBugsnag)
    return;
  if (import_node.default._client)
    return import_node.default;
  let bugsnagServerOptions = {
    apiKey: "21fd37fe87ead4b9c5a8eed90752b455",
    autoDetectErrors: !0,
    appVersion: loadPackageJson().version,
    logger: null
  };
  return import_node.default.start(bugsnagServerOptions);
}
function initializeBugsnag(disableBugsnag) {
  BugsnagClient = setupBugsnag(disableBugsnag);
}
function getBugsnag() {
  return BugsnagClient;
}
function sanitizeError(error, rootPath) {
  if (!rootPath)
    return error;
  let replaceRootPath = (message) => message.replace(new RegExp(rootPath, "g"), "***");
  if (error instanceof Error) {
    let cleanError = Object.create(Object.getPrototypeOf(error));
    return Object.assign(cleanError, error, {
      message: replaceRootPath(error.message),
      stack: error.stack ? replaceRootPath(error.stack) : void 0
    }), cleanError;
  }
  return replaceRootPath(error);
}

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/utils/metrics-exporter.js
init_cjs_shims();
var MetricName = /* @__PURE__ */ ((MetricName2) => (MetricName2.BuildTime = "build_time", MetricName2.NumFilesRequested = "num_files_requested", MetricName2.NumFilesUploaded = "num_files_uploaded", MetricName2.TotalSizeUploaded = "total_size_uploaded", MetricName2.TotalSizeRequested = "total_size_requested", MetricName2.TotalTime = "total_time", MetricName2.UploadTime = "upload_time", MetricName2.DeploymentCompletedTime = "deployment_completed_time", MetricName2.DeploymentRoutableTime = "deployment_routable_time", MetricName2))(MetricName || {}), MetricsExporter = class {
  metrics = {};
  metricPrefix = "oxygen.cli";
  defaultTags;
  exportUrl;
  constructor(options) {
    let { version: cliVersion } = loadPackageJson(), { version: hydrogenVersion } = loadPackageJson(
      `${options.rootPath}/node_modules/@shopify/hydrogen`
    );
    this.defaultTags = {
      ci_provider: options.ciProvider,
      cli_version: `oxygen-cli@${cliVersion || "unknown"}`,
      hydrogen_version: hydrogenVersion || "unknown"
    }, this.exportUrl = "https://metrics.myshopify.dev";
  }
  add(name, value, tags = {}) {
    let metric = {
      value,
      tags
    };
    this.metrics[name] ? this.metrics[name].push(metric) : this.metrics[name] = [metric];
  }
  formatTags(tags) {
    return Object.entries(tags).map(([key, value]) => `${key}:${value}`);
  }
  async export() {
    let metricsToExport = Object.entries(this.metrics).map(([metricName, values]) => {
      let name = `${this.metricPrefix}.${metricName}`;
      return values.map(({ value, tags }) => ({
        name,
        type: "gauge",
        value,
        tags: this.formatTags({ ...tags, ...this.defaultTags })
      }));
    }).flat();
    try {
      await fetch2(this.exportUrl, {
        method: "POST",
        body: JSON.stringify({ events: metricsToExport })
      });
    } catch (error) {
      let Bugsnag2 = getBugsnag();
      Bugsnag2 && (error instanceof Error || typeof error == "string") && Bugsnag2.notify(error);
    }
  }
};

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/build-initiate.js
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/graphql/build-initiate.js
init_cjs_shims();
var BuildInitiateQuery = `
  mutation BuildInitiate($environment: EnvironmentSelectorInput, $labels: [String!]) {
    buildInitiate(environment: $environment, labels: $labels) {
      build {
        id
        assetPath
      }
      userErrors {
        message
      }
    }
  }
`;

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/build-initiate.js
async function buildInitiate(options) {
  let { config: config2, logger, environment, labels = [] } = options, variables = {
    environment,
    labels
  };
  try {
    let response = await graphqlRequest({
      query: BuildInitiateQuery,
      api: "Oxygen",
      url: `${config2.deploymentUrl}/api/v2/admin/graphql`,
      token: config2.deploymentToken.accessToken,
      variables,
      addedHeaders: {
        [Header.OxygenNamespaceHandle]: config2.deploymentToken.namespace
      }
    });
    if (response.buildInitiate.userErrors.length >= 1)
      throw new AbortError(
        `Failed to create build. ${response.buildInitiate.userErrors[0]?.message}`
      );
    return outputCompleted(
      `Build initiated successfully with id ${response.buildInitiate.build.id}.`,
      logger
    ), response.buildInitiate;
  } catch (error) {
    throw errorHandler(error), error;
  }
}

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/build-cancel.js
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/graphql/build-cancel.js
init_cjs_shims();
var BuildCancelQuery = `
  mutation BuildCancel($buildId: ID!, $reason: String!) {
    buildCancel(id: $buildId, reason: $reason) {
      build {
        id
      }
      userErrors {
        message
      }
    }
  }
`;

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/build-cancel.js
async function buildCancel(options) {
  let { config: config2, buildId, reason, logger } = options, variables = {
    buildId,
    reason
  };
  try {
    let response = await graphqlRequest({
      query: BuildCancelQuery,
      api: "Oxygen",
      url: `${config2.deploymentUrl}/api/v2/admin/graphql`,
      token: config2.deploymentToken.accessToken,
      addedHeaders: {
        [Header.OxygenNamespaceHandle]: config2.deploymentToken.namespace
      },
      variables
    });
    if (response.buildCancel.userErrors.length >= 1)
      throw new AbortError(
        `Failed to cancel build: ${response.buildCancel.userErrors[0]?.message}`
      );
    return outputInfo(`Build with id ${buildId} cancelled.`, logger), response.buildCancel;
  } catch (error) {
    throw errorHandler(error), error;
  }
}

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/get-upload-files.js
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/types.js
init_cjs_shims();
var FileType = /* @__PURE__ */ ((FileType2) => (FileType2.Worker = "WORKER", FileType2.Asset = "ASSET", FileType2))(FileType || {}), VerificationError = class extends Error {
}, DeploymentCompletedVerificationError = class extends Error {
};

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/get-upload-files.js
async function getUploadFiles(config2, metricsExporter) {
  let workerPath = joinPath(config2.rootPath, config2.workerDir), workerFiles = await glob(`${workerPath}/**`), manifest = createManifestEntries({
    files: workerFiles,
    basePath: workerPath,
    type: FileType.Worker,
    filter: workerFileFilter
  });
  if (!config2.workerOnly) {
    let assetPath = joinPath(config2.rootPath, config2.assetsDir), assetFiles = await glob(`${assetPath}/**`);
    manifest = [
      ...manifest,
      ...createManifestEntries({
        files: assetFiles,
        basePath: assetPath,
        type: FileType.Asset,
        filter: assetFileFilter
      })
    ];
  }
  metricsExporter?.add(MetricName.NumFilesRequested, manifest.length);
  let totalSize = manifest.reduce((total, file) => total + file.fileSize, 0) / 1024;
  return metricsExporter?.add(MetricName.TotalSizeRequested, totalSize), manifest;
}
function createHash(file) {
  let buff = readFileSync(file);
  return fileHash(buff);
}
function createManifestEntries(params) {
  let { files, basePath, type, filter } = params, manifest = [];
  return files.forEach((file) => {
    let filePath = relativePath(basePath, file);
    filter && !filter(filePath) || manifest.push({
      filePath,
      fileSize: fileSizeSync(file),
      mimeType: lookupMimeType(file),
      fileType: type,
      fileHash: createHash(file)
    });
  }), manifest;
}
function workerFileFilter(fileName) {
  let allowedExtensions = [".js.map", ".mjs.map", ".map", ".js", ".mjs"], regexString = `^(${["index"].join(
    "|"
  )})(${allowedExtensions.join("|")})$`;
  return new RegExp(regexString).test(fileName.toLowerCase());
}
function assetFileFilter(fileName) {
  let regexString = `(${[".map"].join("|")})$`;
  return !new RegExp(regexString).test(fileName.toLowerCase());
}

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/deployment-initiate.js
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/graphql/deployment-initiate.js
init_cjs_shims();
var DeploymentInitiateQuery = `
  mutation DeploymentInitiate($buildId: ID, $environment: EnvironmentSelectorInput, $labels: [String!], $files: [FileInput!]!) {
    deploymentInitiate(buildId: $buildId, environment: $environment, labels: $labels, files: $files) {
      deployment {
        id
      }
      deploymentTargets {
        filePath
        fileSize
        uploadUrl
        fileType
        parameters {
          name
          value
        }
      }
      deploymentConfiguration {
        timeoutInSeconds
      }
      userErrors {
        message
      }
    }
  }
`;

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/deployment-initiate.js
async function deploymentInitiate(options) {
  let { config: config2, input, logger } = options, variables = {
    buildId: input.buildId,
    environment: input.environment,
    files: input.manifest,
    labels: input.labels
  };
  try {
    let response = await graphqlRequest({
      query: DeploymentInitiateQuery,
      api: "Oxygen",
      url: `${config2.deploymentUrl}/api/v2/admin/graphql`,
      token: config2.deploymentToken.accessToken,
      variables,
      addedHeaders: {
        [Header.OxygenNamespaceHandle]: config2.deploymentToken.namespace
      }
    });
    if (response.deploymentInitiate.userErrors.length >= 1)
      throw new AbortError(
        `Failed to create deployment. ${response.deploymentInitiate.userErrors[0]?.message}`
      );
    return outputCompleted(
      `Deployment initiated, ${response.deploymentInitiate.deploymentTargets.length} files to upload.`,
      logger
    ), response.deploymentInitiate;
  } catch (error) {
    throw errorHandler(error), error;
  }
}

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/deployment-complete.js
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/graphql/deployment-complete.js
init_cjs_shims();
var DeploymentCompleteQuery = `
  mutation DeploymentComplete($deploymentId: ID!, $generateAuthBypassToken: Boolean, $authBypassTokenDuration: Int, $environmentVariables: [EnvironmentVariableInput!]) {
    deploymentComplete(id: $deploymentId, generateAuthBypassToken: $generateAuthBypassToken, authBypassTokenDuration: $authBypassTokenDuration, environmentVariables: $environmentVariables) {
      deployment {
        id
        url
      }
      authBypassToken
      userErrors {
        message
      }
    }
  }
`;

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/deployment-complete.js
async function deploymentComplete(config2, deploymentId) {
  let variables = {
    deploymentId,
    generateAuthBypassToken: config2.generateAuthBypassToken
  };
  if (config2.generateAuthBypassToken)
    variables.authBypassTokenDuration = authBypassTokenDurationParse(
      config2.authBypassTokenDuration
    );
  else if (config2.authBypassTokenDuration)
    throw new AbortError(
      "authBypassTokenDuration is set but generateAuthBypassToken is not enabled"
    );
  config2.overriddenEnvironmentVariables && (variables.environmentVariables = config2.overriddenEnvironmentVariables);
  try {
    let response = await graphqlRequest({
      query: DeploymentCompleteQuery,
      api: "Oxygen",
      url: `${config2.deploymentUrl}/api/v2/admin/graphql`,
      token: config2.deploymentToken.accessToken,
      variables,
      addedHeaders: {
        [Header.OxygenNamespaceHandle]: config2.deploymentToken.namespace
      }
    });
    if (response.deploymentComplete.userErrors.length >= 1)
      throw new AbortError(
        `Failed to complete deployment: ${response.deploymentComplete.userErrors[0]?.message}`
      );
    return response.deploymentComplete;
  } catch (error) {
    throw errorHandler(error), error;
  }
}

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/verify-deployment.js
init_cjs_shims();
async function verifyDeployment(options) {
  let { config: config2, url, logger, hooks: hooks2 } = options;
  hooks2?.onVerificationStart?.(), outputInfo("Verifying worker deployment is routable...", logger);
  let attempts = 0, delay = 0, calledVerificationError = !1, startTime = Date.now(), handleInterval = async () => {
    if (attempts < 10 ? delay = 500 : attempts % 5 === 0 && (delay += 5e3), (Date.now() - startTime) / 1e3 + delay / 1e3 > config2.verificationMaxDuration) {
      let error = new VerificationError(
        "Unable to verify that the worker is accessible."
      );
      throw calledVerificationError || (calledVerificationError = !0, hooks2?.onVerificationError?.(error)), error;
    }
    attempts++, await new Promise((resolve2) => setTimeout(resolve2, delay)), await check2();
  }, check2 = async () => {
    try {
      if ((await fetch2(`${url}/.oxygen/deployment`, {
        method: "HEAD"
      })).status === 200)
        return outputInfo("Deployment verification check passed", logger), hooks2?.onVerificationComplete?.(), Promise.resolve();
      await handleInterval();
    } catch {
      await handleInterval();
    }
  };
  await check2();
}

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/deployment-cancel.js
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/graphql/deployment-cancel.js
init_cjs_shims();
var DeploymentCancelQuery = `
mutation DeploymentCancel($deploymentId: ID!, $reason: String!) {
  deploymentCancel(id: $deploymentId, reason: $reason) {
    deployment {
      id
    }
    userErrors {
      message
    }
  }
}
`;

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/deployment-cancel.js
async function deploymentCancel(options) {
  let { config: config2, deploymentId, reason, logger } = options, variables = {
    deploymentId,
    reason
  };
  try {
    let response = await graphqlRequest({
      query: DeploymentCancelQuery,
      api: "Oxygen",
      url: `${config2.deploymentUrl}/api/v2/admin/graphql`,
      token: config2.deploymentToken.accessToken,
      variables,
      addedHeaders: {
        [Header.OxygenNamespaceHandle]: config2.deploymentToken.namespace
      }
    });
    if (response.deploymentCancel.userErrors.length >= 1)
      throw new AbortError(
        response.deploymentCancel.userErrors[0]?.message || ""
      );
    return outputInfo(`Deployment with id ${deploymentId} cancelled.`, logger), response.deploymentCancel;
  } catch (error) {
    throw errorHandler(error), error;
  }
}

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/upload-files.js
init_cjs_shims();
import { Agent } from "https";
var import_async = __toESM(require_async(), 1);
async function uploadFiles(options) {
  let { config: config2, logger, targets, hooks: hooks2 } = options;
  outputInfo(`Uploading ${targets.length} files...`, logger);
  let totalUploadSize = targets.reduce((total, target) => total + target.fileSize, 0) / 1024;
  options.metricsExporter?.add(MetricName.TotalSizeUploaded, totalUploadSize), options.metricsExporter?.add(MetricName.NumFilesUploaded, targets.length);
  let agent = new Agent({ keepAlive: !0 });
  hooks2?.onUploadFilesStart?.();
  let startTime = performance.now();
  return (0, import_async.mapLimit)(targets, 6, async (target) => {
    await uploadFile(config2, target, agent);
  }).then(() => {
    let endTime = performance.now();
    hooks2?.onUploadFilesComplete?.(), options.metricsExporter?.add(MetricName.UploadTime, endTime - startTime), outputCompleted("Files uploaded successfully", logger);
  }).catch((err2) => {
    throw hooks2?.onUploadFilesError?.(err2), err2;
  }).finally(() => {
    agent.destroy();
  });
}
async function uploadFile(config2, target, agent) {
  let localFolderPath = target.fileType === "WORKER" ? joinPath(config2.rootPath, config2.workerDir) : joinPath(config2.rootPath, config2.assetsDir);
  if (target.parameters !== null && target.parameters.length > 0) {
    let form = formData();
    target.parameters.forEach((param) => {
      form.append(param.name, param.value);
    }), form.append(
      "file",
      createFileReadStream(joinPath(localFolderPath, target.filePath))
    ), await formUpload(form, target, agent);
  } else {
    let initData = await initiateResumableUpload(target, agent);
    await performResumableUpload(
      joinPath(localFolderPath, target.filePath),
      initData,
      agent
    );
  }
}
async function formUpload(form, target, agent, attemptNumber = 0) {
  try {
    let controller = new AbortController(), timeout = setTimeout(() => {
      controller.abort();
    }, 12e4), response = await fetch2(target.uploadUrl, {
      method: "POST",
      body: form,
      signal: controller.signal,
      headers: {
        Connection: "keep-alive"
      },
      agent
    });
    if (clearTimeout(timeout), !response.ok)
      throw new Error(`${response.status}`);
  } catch (err2) {
    if (isErrorCode(err2, "ENOENT"))
      throw new Error(`File not found: ${target.filePath}`);
    if (attemptNumber < Number(deployDefaults.maxUploadAttempts))
      await formUpload(form, target, agent, attemptNumber + 1);
    else
      throw err2 instanceof Error && err2.name === "AbortError" ? new Error(`Request timeout whilst uploading ${target.filePath}`) : new Error(`Failed to upload file ${target.filePath}`);
  }
}
async function initiateResumableUpload(target, agent) {
  return fetch2(target.uploadUrl, {
    method: "POST",
    headers: {
      "x-goog-resumable": "start",
      "X-Goog-Content-Length-Range": `0,${target.fileSize}`,
      "User-Agent": "oxygen-cli"
    },
    agent
  }).then((res) => ({
    sessionUri: res.headers.get("x-guploader-uploadid"),
    location: res.headers.get("location"),
    target
  })).catch((err2) => {
    throw new Error(
      `Failed to initiate resumable upload for file ${target.filePath} (status code ${err2.statusCode})`
    );
  });
}
async function performResumableUpload(localFilePath, initData, agent, startByte = 0, attemptNumber = 0) {
  await uploadResumable(
    initData.location,
    localFilePath,
    startByte,
    agent
  ).catch(async (err2) => {
    if (isErrorCode(err2, "ENOENT"))
      throw new Error(`File not found: ${initData.target.filePath}`);
    if (err2 && attemptNumber >= Number(deployDefaults.maxResumabeUploadAttempts))
      throw new Error(
        `Failed to upload file ${initData.target.filePath} after ${deployDefaults.maxResumabeUploadAttempts} attempts`
      );
    let status = await resumableUploadStatus(
      initData.location,
      initData.target.fileSize,
      agent
    );
    if (!status.complete) {
      let nextAttemptStartByte = status.lastReceivedByte, attempt = attemptNumber + 1;
      await performResumableUpload(
        localFilePath,
        initData,
        agent,
        nextAttemptStartByte,
        attempt
      );
    }
  });
}
async function uploadResumable(location2, filePath, lastReceivedByte, agent) {
  let file = createFileReadStream(filePath, { start: lastReceivedByte });
  return fetch2(location2, {
    method: "PUT",
    body: file,
    agent
  }).then((res) => res.status);
}
async function resumableUploadStatus(location2, fileSize2, agent) {
  let getLastByte = (range) => {
    if (!range || range.split("-").length !== 2)
      return 0;
    let rangeParts = range.split("-");
    return parseInt(rangeParts[1], 10);
  };
  return fetch2(location2, {
    method: "PUT",
    headers: {
      "Content-Length": "0",
      "Content-Range": `bytes */${fileSize2}`
    },
    agent
  }).then((res) => ({
    complete: res.status === 200,
    lastReceivedByte: getLastByte(res.headers.get("range"))
  })).catch((err2) => (console.error(err2), {
    complete: !1,
    lastReceivedByte: 0
  }));
}
function isErrorCode(err2, code) {
  return err2 instanceof Error && "code" in err2 && err2.code === code;
}

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/verify-deployment-completed.js
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/graphql/deployment-verification-details.js
init_cjs_shims();
var DeploymentVerificationDetailsQuery = `
  query DeploymentVerificationDetails($deploymentId: ID!) {
    deploymentVerificationDetails(id: $deploymentId) {
      url
      status
      error
    }
  }
`, Status = /* @__PURE__ */ ((Status2) => (Status2.Pending = "PENDING", Status2.Deployed = "DEPLOYED", Status2.Failed = "FAILED", Status2.Cancelled = "CANCELLED", Status2))(Status || {});

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/verify-deployment-completed.js
async function verifyDeploymentCompleted(options, deploymentId) {
  let { config: config2, logger, timeoutInSeconds, hooks: hooks2 } = options, variables = {
    deploymentId
  };
  hooks2?.onDeploymentCompletedVerificationStart?.(), outputInfo("Verifying deployment completed...", logger);
  let startTime = Date.now(), handleInterval = async () => {
    if ((Date.now() - startTime) / 1e3 + 3e3 / 1e3 > timeoutInSeconds)
      throw hooks2?.onDeploymentCompletedVerificationError?.(), new Error(
        `Deployment not completed after ${timeoutInSeconds} seconds.`
      );
    return await new Promise((resolve2) => setTimeout(resolve2, 3e3)), check2();
  }, check2 = async () => {
    let data = (await graphqlRequest({
      query: DeploymentVerificationDetailsQuery,
      api: "Oxygen",
      url: `${config2.deploymentUrl}/api/v2/admin/graphql`,
      token: config2.deploymentToken.accessToken,
      variables,
      addedHeaders: {
        [Header.OxygenNamespaceHandle]: config2.deploymentToken.namespace
      }
    })).deploymentVerificationDetails;
    if (data == null)
      throw hooks2?.onDeploymentCompletedVerificationError?.(), new DeploymentCompletedVerificationError("Deployment not found");
    if (data.status === Status.Deployed)
      return outputCompleted("Deployment to Oxygen completed successfully", logger), hooks2?.onDeploymentCompleted?.(), data;
    if (data.status === Status.Failed || data.status === Status.Cancelled)
      throw hooks2?.onDeploymentFailed?.(data), new DeploymentCompletedVerificationError(
        data.error ? `Deployment ${data.status.toLocaleLowerCase()}, error: ${data.error}` : `Deployment ${data.status.toLocaleLowerCase()}`
      );
    return handleInterval();
  };
  return check2();
}

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/build-project.js
init_cjs_shims();
import { spawn as spawn2 } from "child_process";
import { PassThrough } from "stream";
async function buildProject(options) {
  let { config: config2, assetPath, hooks: hooks2 } = options, Bugsnag2 = getBugsnag();
  if (hooks2?.buildFunction) {
    let startTime = performance.now();
    return hooks2.buildFunction(assetPath).then(() => {
      options.metricsExporter?.add(
        MetricName.BuildTime,
        performance.now() - startTime
      );
    }).catch((error) => {
      throw new Error(`Build function failed with error: ${error}`);
    });
  }
  let assetPathEnvironment = assetPath ? { HYDROGEN_ASSET_BASE_URL: assetPath } : {};
  try {
    await new Promise((resolve2, reject) => {
      let stderr = "", stderrStream = new PassThrough();
      stderrStream.on("data", (chunk) => {
        stderr += chunk, process.stderr.write(chunk);
      });
      let startTime = performance.now(), buildCommand = spawn2(config2.buildCommand, [], {
        stdio: ["inherit", "pipe", "pipe"],
        env: {
          // eslint-disable-next-line no-process-env
          ...process.env,
          ...assetPathEnvironment
        },
        cwd: config2.rootPath,
        shell: !0
      });
      buildCommand.stderr?.pipe(stderrStream), buildCommand.stdout?.pipe(stderrStream), buildCommand.on("close", (code) => {
        if (code === 0 && options.metricsExporter?.add(
          MetricName.BuildTime,
          performance.now() - startTime
        ), Bugsnag2?.addMetadata("buildCommand", {
          command: config2.buildCommand,
          stderr,
          code
        }), code !== 0) {
          reject(code);
          return;
        }
        resolve2(code);
      });
    });
  } catch (error) {
    throw new Error(`Build failed with error code: ${error}`);
  }
}

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/metadata.js
init_cjs_shims();
async function getMetadata(config2, logger) {
  let ciInfo = ciPlatform(), metadata2 = ciInfo.metadata ?? {};
  try {
    let gitCommit = await latestCommit(config2.rootPath);
    metadata2.actor || (metadata2.actor = gitCommit.author_name), metadata2.commitDate || (metadata2.commitDate = gitCommit.date), metadata2.commitMessage || (metadata2.commitMessage = gitCommit.message), gitCommit.branch && (metadata2.branch = gitCommit.branch), gitCommit.hash && (metadata2.commitSha = gitCommit.hash);
  } catch {
    outputWarn(
      "Could not retrieve Git history, commit message will be unavailable.",
      logger
    );
  }
  return {
    name: ciInfo.isCI ? ciInfo.name : "none",
    ...metadata2,
    actor: config2.metadata.user ?? metadata2.actor,
    commitMessage: createCommitTitle(
      config2.metadata.description ?? metadata2.commitMessage
    ),
    commitSha: config2.metadata.version ?? metadata2.commitSha,
    url: config2.metadata.url ?? metadata2.url
  };
}
async function latestCommit(path3) {
  let gitCommit = await getLatestGitCommit(path3), branch = (/HEAD -> ([^,]*)/.exec(gitCommit.refs) || [])[1], headRef = process.env.GITHUB_HEAD_REF;
  if (!headRef)
    return {
      ...gitCommit,
      branch
    };
  let match2 = /Merge ([\w\d]+) into [\w\d]+/.exec(gitCommit.message);
  return {
    ...gitCommit,
    branch: headRef,
    hash: match2 ? match2[1] : gitCommit.hash
  };
}
function createCommitTitle(commitMessage) {
  if (!commitMessage)
    return;
  let title = commitMessage.split(/\r?\n/)[0]?.trim() || "", jsonTitle = JSON.stringify(title), isTruncated = !1;
  for (; jsonTitle.length > maxLabelLength; ) {
    let lastSpaceIndex = title.lastIndexOf(" ", maxLabelLength - 3);
    title = `${title.substring(
      0,
      lastSpaceIndex > -1 ? lastSpaceIndex : maxLabelLength - 3
    )}`.trimEnd(), isTruncated = !0, jsonTitle = JSON.stringify(title);
  }
  return isTruncated ? `${title}...` : title;
}
function getEnvironmentInput(config2, metadata2) {
  if (config2.defaultEnvironment)
    return;
  let tag = config2.environmentTag || metadata2.branch;
  return tag ? { tag } : void 0;
}
function createLabels(metadata2) {
  let labels = [], checkLabel = (labelKey, labelValue) => {
    let jsonString = JSON.stringify(labelValue);
    if (jsonString.length > maxLabelLength)
      throw new Error(
        `Provided ${labelKey} metadata exceeds maximum length (max ${maxLabelLength} characters).`
      );
    let label = `${labelKey}=${jsonString}`;
    labels.push(label);
  };
  if (metadata2.name !== "none" && labels.push(`ci-platform=${JSON.stringify(metadata2.name)}`), metadata2.name !== "unknown") {
    let keyMapping2 = {
      attempt: "attempt",
      run: "runId"
    };
    for (let [key, value] of Object.entries(keyMapping2)) {
      let metadataKey = key;
      metadata2[metadataKey] && labels.push(
        `${metadata2.name}-${value}=${JSON.stringify(metadata2[metadataKey])}`
      );
    }
  }
  let keyMapping = {
    actor: "user",
    branch: "branch",
    commitDate: "commit-date",
    commitMessage: "description",
    commitSha: "version",
    url: "url"
  };
  for (let [key, value] of Object.entries(keyMapping)) {
    let metadataKey = key;
    metadata2[metadataKey] && checkLabel(value, metadata2[metadataKey]);
  }
  return labels;
}

// ../../node_modules/.pnpm/@shopify+oxygen-cli@4.4.9_@oclif+core@3.26.5_@shopify+cli-kit@packages+cli-kit/node_modules/@shopify/oxygen-cli/dist/deploy/index.js
async function createDeploy(options) {
  let cliStartTime = performance.now();
  initializeBugsnag(!options.config.bugsnag);
  let Bugsnag2 = getBugsnag();
  Bugsnag2?.addMetadata("config", {
    ...options.config,
    deploymentToken: { ...options.config.deploymentToken, accessToken: "***" },
    rootPath: "***"
  });
  let { config: config2, hooks: hooks2 } = options, logger = options.logger ?? stderrLogger, build2 = {}, buildCompleted, deployment, metricsExporter;
  try {
    let metadata2 = await getMetadata(config2, logger), labels = createLabels(metadata2), environment = getEnvironmentInput(config2, metadata2);
    if (Bugsnag2?.addMetadata("metadata", {
      environment,
      labels,
      metadata: metadata2
    }), metricsExporter = new MetricsExporter({
      ciProvider: metadata2.name || "unknown",
      rootPath: config2.rootPath
    }), !config2.workerOnly && !config2.skipBuild) {
      let buildInitiateResponse = await buildInitiate({
        config: config2,
        environment,
        labels,
        logger
      });
      build2.id = buildInitiateResponse.build.id, build2.assetPath = buildInitiateResponse.build.assetPath;
    }
    config2.skipBuild || (await buildProject({
      config: config2,
      assetPath: build2.assetPath,
      hooks: hooks2,
      metricsExporter
    }), await verifyConfig({ config: config2, performedBuild: !0 })), buildCompleted = !0;
    let manifest = await getUploadFiles(config2, metricsExporter);
    Bugsnag2?.addMetadata("manifest", manifest);
    let deploymentInitiateInput = build2.id ? { buildId: build2.id, manifest } : { environment, manifest, labels };
    deployment = await deploymentInitiate({
      config: config2,
      input: deploymentInitiateInput,
      logger
    }), await uploadFiles({
      config: config2,
      targets: deployment.deploymentTargets,
      hooks: hooks2,
      logger,
      metricsExporter
    });
    let deploymentCompleteRequestStartTime = performance.now(), deploymentCompleteOp = await deploymentComplete(
      config2,
      deployment.deployment.id
    );
    metricsExporter.add(MetricName.TotalTime, performance.now() - cliStartTime), await verifyDeploymentCompleted(
      {
        config: config2,
        hooks: hooks2,
        logger,
        timeoutInSeconds: deployment.deploymentConfiguration.timeoutInSeconds
      },
      deployment.deployment.id
    ), metricsExporter.add(
      MetricName.DeploymentCompletedTime,
      performance.now() - deploymentCompleteRequestStartTime
    ), config2.skipVerification || (await verifyDeployment({
      config: config2,
      url: deploymentCompleteOp.deployment.url,
      logger,
      hooks: hooks2
    }), metricsExporter.add(
      MetricName.DeploymentRoutableTime,
      performance.now() - deploymentCompleteRequestStartTime
    ));
    let completedDeployment = {
      url: deploymentCompleteOp.deployment.url
    }, successMessage = `
The deployment can be reached at the ${completedDeployment.url} preview URL`;
    return deploymentCompleteOp.authBypassToken && (completedDeployment.authBypassToken = deploymentCompleteOp.authBypassToken, successMessage += `. The auth bypass token for the deployment is ${completedDeployment.authBypassToken}`), outputSuccess(successMessage, logger), completedDeployment;
  } catch (error) {
    return config2.bugsnag && Bugsnag2 && (error instanceof Error || typeof error == "string") && Bugsnag2.notify(sanitizeError(error, config2.rootPath)), error instanceof Error ? (error instanceof VerificationError || error instanceof DeploymentCompletedVerificationError ? outputWarn(error.message, logger) : build2.id && !buildCompleted ? (outputWarn(
      `Build failed with: ${error.message}, cancelling build.`,
      logger
    ), await buildCancel({
      config: config2,
      buildId: build2.id,
      reason: error.message,
      logger
    }).catch((err2) => {
      err2 instanceof Error && outputWarn(`Failed to cancel build: ${err2.message}`, logger);
    })) : deployment?.deployment.id && (outputWarn(
      `Deployment failed with: ${error.message}, cancelling deployment.`,
      logger
    ), await deploymentCancel({
      config: config2,
      deploymentId: deployment.deployment.id,
      reason: error.message,
      logger
    }).catch((err2) => {
      err2 instanceof Error && outputWarn(`Failed to cancel deployment: ${err2.message}`, logger);
    })), Promise.reject(error)) : (console.error("Unknown error", error), Promise.reject(new Error("Unknown error")));
  } finally {
    metricsExporter?.export();
  }
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/get-oxygen-deployment-data.js
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/render-errors.js
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/admin-urls.js
init_cjs_shims();
function newHydrogenStorefrontUrl(session) {
  let { storeFqdn } = session;
  return `https://${storeFqdn}/admin/custom_storefronts/new`;
}
function hydrogenStorefrontsUrl(session) {
  let { storeFqdn } = session;
  return `https://${storeFqdn}/admin/custom_storefronts`;
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/render-errors.js
function renderMissingStorefront({
  session,
  storefront,
  cliCommand
}) {
  renderFatalError({
    name: "NoStorefrontError",
    type: 0,
    message: outputContent`${outputToken.errorText(
      "Couldn\u2019t find Hydrogen storefront."
    )}`.value,
    skipOclifErrorHandling: !0,
    tryMessage: outputContent`Couldn’t find ${storefront.title} (ID: ${parseGid(
      storefront.id
    )}) on ${session.storeFqdn}. Check that the storefront exists and run ${outputToken.genericShellCommand(
      `${cliCommand} link`
    )} to link this project to it.\n\n${outputToken.link(
      "Hydrogen Storefronts Admin",
      hydrogenStorefrontsUrl(session)
    )}`.value
  });
}
function renderMissingLink({ noStorefronts = !1 }) {
  renderInfo({
    headline: noStorefronts ? "You don't have a Hydrogen storefront to link to" : "You haven't linked your project to a storefront yet",
    body: [
      "Link your local environment to a Hydrogen storefront. Enable automatic environment variable injection and access to",
      { command: "env list" },
      ",",
      { command: "env pull" },
      ",",
      { command: "env push" },
      ", and",
      { command: "deploy" },
      "commands. Use",
      { command: "unlink" },
      "to disconnect from the storefront."
    ]
  });
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/graphql/admin/get-oxygen-data.js
init_cjs_shims();
var GetDeploymentDataQuery = `#graphql
  query GetDeploymentToken($id: ID!) {
    hydrogenStorefront(id: $id) {
      oxygenDeploymentToken
      environments {
        name
        handle
        branch
        type
      }
    }
  }
`;
async function getOxygenData(adminSession, storefrontId) {
  let { hydrogenStorefront } = await adminRequest(
    GetDeploymentDataQuery,
    adminSession,
    {
      id: storefrontId
    }
  );
  return { storefront: hydrogenStorefront };
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/verify-linked-storefront.js
init_cjs_shims();
async function verifyLinkedStorefront({
  root,
  session,
  config: config2,
  cliCommand
}) {
  let storefronts = await getStorefronts(session), configuredStorefront = config2.storefront?.id ? storefronts.find(({ id }) => id === config2.storefront.id) : void 0;
  return configuredStorefront || (renderMissingLink({ noStorefronts: !storefronts.length }), await linkStorefront(root, session, config2, {
    force: !0,
    cliCommand,
    storefronts
  }));
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/get-oxygen-deployment-data.js
async function getOxygenDeploymentData({
  root
}) {
  let [{ session, config: config2 }, cliCommand] = await Promise.all([
    login(root),
    getCliCommand()
  ]), linkedStorefront = await verifyLinkedStorefront({
    root,
    session,
    config: config2,
    cliCommand
  });
  if (!linkedStorefront)
    return;
  config2.storefront = linkedStorefront;
  let { storefront } = await getOxygenData(session, config2.storefront.id);
  if (!storefront) {
    renderMissingStorefront({
      session,
      storefront: config2.storefront,
      cliCommand
    });
    return;
  }
  if (!storefront.oxygenDeploymentToken) {
    outputWarn("Could not retrieve a deployment token.");
    return;
  }
  return storefront;
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/deploy.js
var DEPLOY_OUTPUT_FILE_HANDLE = "h2_deploy_log.json", deploymentLogger = (message, level = "info") => {
  (level === "error" || level === "warn") && outputWarn(message);
}, Deploy = class _Deploy extends base_command_default {
  static descriptionWithMarkdown = "Builds and deploys your Hydrogen storefront to Oxygen. Requires an Oxygen deployment token to be set with the `--token` flag or an environment variable (`SHOPIFY_HYDROGEN_DEPLOYMENT_TOKEN`). If the storefront is [linked](https://shopify.dev/docs/api/shopify-cli/hydrogen/hydrogen-link) then the Oxygen deployment token for the linked storefront will be used automatically.";
  static description = "Builds and deploys a Hydrogen storefront to Oxygen.";
  static flags = {
    ...commonFlags.entry,
    ...commonFlags.env,
    ...commonFlags.envBranch,
    ...overrideFlag(commonFlags.envFile, {
      "env-file": {
        description: "Path to an environment file to override existing environment variables for the deployment.",
        default: void 0
      }
    }),
    preview: import_core20.Flags.boolean({
      description: "Deploys to the Preview environment. Overrides --env-branch and Git metadata.",
      required: !1,
      default: !1
    }),
    force: import_core20.Flags.boolean({
      char: "f",
      description: "Forces a deployment to proceed if there are uncommited changes in its Git repository.",
      default: !1,
      env: "SHOPIFY_HYDROGEN_FLAG_FORCE",
      required: !1
    }),
    "no-verify": import_core20.Flags.boolean({
      description: "Skip the routability verification step after deployment.",
      default: !1,
      required: !1
    }),
    "auth-bypass-token": import_core20.Flags.boolean({
      description: "Generate an authentication bypass token, which can be used to perform end-to-end tests against the deployment.",
      required: !1,
      default: !1,
      env: "AUTH_BYPASS_TOKEN"
    }),
    "auth-bypass-token-duration": import_core20.Flags.string({
      description: "Specify the duration (in hours) up to 12 hours for the authentication bypass token. Defaults to `2`",
      required: !1,
      env: "AUTH_BYPASS_TOKEN_DURATION",
      dependsOn: ["auth-bypass-token"]
    }),
    "build-command": import_core20.Flags.string({
      description: "Specify a build command to run before deploying. If not specified, `shopify hydrogen build` will be used.",
      required: !1
    }),
    ...commonFlags.lockfileCheck,
    ...commonFlags.path,
    ...commonFlags.shop,
    "json-output": import_core20.Flags.boolean({
      allowNo: !0,
      description: "Create a JSON file containing the deployment details in CI environments. Defaults to true, use `--no-json-output` to disable.",
      required: !1,
      default: !0
    }),
    token: import_core20.Flags.string({
      char: "t",
      description: "Oxygen deployment token. Defaults to the linked storefront's token if available.",
      env: "SHOPIFY_HYDROGEN_DEPLOYMENT_TOKEN",
      required: !1
    }),
    "metadata-description": import_core20.Flags.string({
      description: "Description of the changes in the deployment. Defaults to the commit message of the latest commit if there are no uncommited changes.",
      required: !1,
      env: "SHOPIFY_HYDROGEN_FLAG_METADATA_DESCRIPTION"
    }),
    "metadata-url": import_core20.Flags.string({
      required: !1,
      env: "SHOPIFY_HYDROGEN_FLAG_METADATA_URL",
      hidden: !0
    }),
    "metadata-user": import_core20.Flags.string({
      description: "User that initiated the deployment. Will be saved and displayed in the Shopify admin",
      required: !1,
      env: "SHOPIFY_HYDROGEN_FLAG_METADATA_USER"
    }),
    "metadata-version": import_core20.Flags.string({
      required: !1,
      env: "SHOPIFY_HYDROGEN_FLAG_METADATA_VERSION",
      hidden: !0
    }),
    ...commonFlags.diff
  };
  async run() {
    let { flags } = await this.parse(_Deploy), deploymentOptions = this.flagsToOxygenDeploymentOptions(flags);
    if (flags.diff) {
      let diff2 = await prepareDiffDirectory(deploymentOptions.path, !1);
      deploymentOptions.path = diff2.targetDirectory, setupResourceCleanup(diff2.cleanup);
    }
    await runDeploy(deploymentOptions), process.exit(0);
  }
  flagsToOxygenDeploymentOptions(flags) {
    return {
      ...flagsToCamelObject(flags),
      defaultEnvironment: flags.preview,
      environmentFile: flags["env-file"],
      path: flags.path ? resolvePath(flags.path) : process.cwd()
    };
  }
};
function createUnexpectedAbortError(message) {
  return new AbortError(
    message || "The deployment failed due to an unexpected error.",
    "Retrying the deployment may succeed.",
    [
      [
        "If the issue persists, please check the",
        {
          link: {
            label: "Shopify status page",
            url: "https://status.shopify.com/"
          }
        },
        "for any known issues."
      ]
    ]
  );
}
async function runDeploy(options) {
  let {
    authBypassTokenDuration,
    authBypassToken: generateAuthBypassToken,
    buildCommand,
    defaultEnvironment,
    env: envHandle,
    envBranch,
    environmentFile,
    force: forceOnUncommitedChanges,
    noVerify,
    lockfileCheck,
    jsonOutput,
    path: root,
    shop,
    metadataUrl,
    metadataUser,
    metadataVersion,
    entry: ssrEntry
  } = options, { metadataDescription } = options, isCleanGit = !0;
  try {
    await ensureIsClean(root);
  } catch (error) {
    if (error instanceof GitDirectoryNotCleanError && (isCleanGit = !1), !forceOnUncommitedChanges && !isCleanGit) {
      let errorMessage2 = "Uncommitted changes detected", changedFiles, nextSteps = [
        [
          "Commit your changes before deploying or use the",
          { command: "--force" },
          "flag to deploy with uncommitted changes."
        ]
      ];
      try {
        changedFiles = (await execAsync("git status -s", { cwd: root })).stdout;
      } catch {
      }
      throw changedFiles && (errorMessage2 += `:

${changedFiles.trimEnd()}`, packageManagers.forEach(({ name, lockfile: lockfile2, installCommand }) => {
        changedFiles.includes(lockfile2) && nextSteps.push([
          `If you are using ${name}, try running`,
          { command: installCommand },
          `to avoid changes to ${lockfile2}.`
        ]);
      })), new AbortError(errorMessage2, null, nextSteps);
    }
  }
  let isCI2 = ciPlatform().isCI, token = options.token, branch, commitHash, deploymentData, userChosenEnvironmentTag, gitCommit;
  try {
    gitCommit = await getLatestGitCommit(root), branch = (/HEAD -> ([^,]*)/.exec(gitCommit.refs) || [])[1], commitHash = gitCommit.hash;
  } catch {
    outputWarn("Could not retrieve Git history."), branch = void 0;
  }
  !metadataDescription && !isCleanGit && (renderWarning({
    headline: "No deployment description provided",
    body: [
      "Deploying uncommited changes, but no description has been provided. Use the ",
      { command: "--metadata-description" },
      "flag to provide a description. If no description is provided, the description defaults to ",
      { userInput: "<sha> with additional changes" },
      " using the SHA of the last commit."
    ]
  }), metadataDescription = `${commitHash} with additional changes`);
  let overriddenEnvironmentVariables;
  if (environmentFile) {
    let { variables } = await readAndParseDotEnv(environmentFile);
    overriddenEnvironmentVariables = Object.entries(variables).map(
      ([key, value]) => ({
        isSecret: !0,
        key,
        value
      })
    );
  }
  let userProvidedEnvironmentTag = null, isPreview = !1;
  if (isCI2 && envHandle)
    throw new AbortError(
      "Can't specify an environment handle in CI",
      "Environments are automatically picked up by the current Git branch."
    );
  if (isCI2 && envBranch && (userProvidedEnvironmentTag = envBranch), !isCI2) {
    if (deploymentData = await getOxygenDeploymentData({
      root,
      flagShop: shop
    }), !deploymentData)
      return;
    token = token || deploymentData.oxygenDeploymentToken, envHandle ? (userProvidedEnvironmentTag = findEnvironmentOrThrow(
      deploymentData.environments || [],
      envHandle
    ).branch, userProvidedEnvironmentTag === null && (isPreview = !0)) : envBranch && (userProvidedEnvironmentTag = findEnvironmentByBranchOrThrow(
      deploymentData.environments || [],
      envBranch
    ).branch);
  }
  if (!token) {
    let errMessage = isCI2 ? [
      "No deployment token provided. Use the ",
      { command: "--token" },
      " flag to provide a token."
    ] : "Could not obtain an Oxygen deployment token, please try again or contact Shopify support.";
    throw new AbortError(errMessage);
  }
  if (!isCI2 && !defaultEnvironment && !envHandle && !envBranch && deploymentData?.environments)
    if (deploymentData.environments.length > 1) {
      let choices = orderEnvironmentsBySafety(
        deploymentData.environments
      ).map(({ name, branch: branch2, handle, type }) => ({
        label: createEnvironmentCliChoiceLabel(name, handle, branch2),
        // The preview environment will never have an associated branch so
        // we're using a custom string here to identify it later in our code.
        // Using a period at the end of the value is an invalid branch name
        // in Git so we can be sure that this won't conflict with a merchant's
        // repository.
        value: type === "PREVIEW" ? "shopify-preview-environment." : branch2
      }));
      userChosenEnvironmentTag = await renderSelectPrompt({
        message: "Select an environment to deploy to",
        choices,
        defaultValue: branch
      });
    } else
      outputInfo(
        `Using current checked out branch ${branch} as environment tag`
      );
  let deploymentUrl = "https://oxygen.shopifyapps.com";
  process.env.UNSAFE_SHOPIFY_HYDROGEN_DEPLOYMENT_URL && (deploymentUrl = process.env.UNSAFE_SHOPIFY_HYDROGEN_DEPLOYMENT_URL, outputWarn(
    "Using a custom deployment service. Don't do this in production!"
  ));
  let fallbackEnvironmentTag = branch;
  userChosenEnvironmentTag === "shopify-preview-environment." && (fallbackEnvironmentTag = void 0, userChosenEnvironmentTag = void 0, isPreview = !0);
  let assetsDir = "dist/client", workerDir = "dist/worker", isClassicCompiler = await isClassicProject(root);
  if (!isClassicCompiler) {
    let viteConfig = await getViteConfig(root, ssrEntry).catch(() => null);
    viteConfig ? (assetsDir = relativePath(root, viteConfig.clientOutDir), workerDir = relativePath(root, viteConfig.serverOutDir)) : workerDir = "dist/server";
  }
  let config2 = {
    assetsDir,
    bugsnag: !0,
    deploymentUrl,
    defaultEnvironment: defaultEnvironment || isPreview,
    deploymentToken: parseToken(token),
    environmentTag: userProvidedEnvironmentTag || userChosenEnvironmentTag || fallbackEnvironmentTag,
    generateAuthBypassToken,
    authBypassTokenDuration,
    verificationMaxDuration: 180,
    metadata: {
      ...metadataDescription ? { description: metadataDescription } : {},
      ...metadataUrl ? { url: metadataUrl } : {},
      ...metadataUser ? { user: metadataUser } : {},
      ...metadataVersion ? { version: metadataVersion } : {}
    },
    skipVerification: noVerify,
    rootPath: root,
    skipBuild: !1,
    workerOnly: !1,
    workerDir,
    overriddenEnvironmentVariables
  };
  if (!isCI2 && !config2.defaultEnvironment && (userProvidedEnvironmentTag || userChosenEnvironmentTag)) {
    let chosenEnvironment = findEnvironmentByBranchOrThrow(
      deploymentData.environments,
      config2.environmentTag
    ), confirmationMessage = `Creating a deployment against ${createEnvironmentCliChoiceLabel(
      chosenEnvironment.name,
      chosenEnvironment.handle,
      chosenEnvironment.branch
    )}`;
    if (!await renderConfirmationPrompt({
      confirmationMessage: "Yes, confirm deploy",
      cancellationMessage: "No, cancel deploy",
      message: outputContent`${confirmationMessage}

Continue?`.value
    }))
      return;
  }
  let resolveUpload, uploadPromise = new Promise((resolve2) => {
    resolveUpload = resolve2;
  }), resolveRoutableCheck, routableCheckPromise = new Promise((resolve2) => {
    resolveRoutableCheck = resolve2;
  }), resolveDeploymentCompletedVerification, deploymentCompletedVerificationPromise = new Promise(
    (resolve2) => {
      resolveDeploymentCompletedVerification = resolve2;
    }
  ), deployError = null, resolveDeploy, rejectDeploy, deployPromise = new Promise((resolve2, reject) => {
    resolveDeploy = resolve2, rejectDeploy = reject;
  }), hooks2 = {
    onDeploymentCompleted: () => resolveDeploymentCompletedVerification(),
    onVerificationComplete: () => resolveRoutableCheck(),
    onDeploymentCompletedVerificationError() {
      deployError = new AbortError(
        "Unable to verify the deployment was completed successfully",
        "Please verify the deployment status in the Shopify Admin and retry deploying if necessary."
      );
    },
    onDeploymentFailed: (details) => {
      deployError = createUnexpectedAbortError(details.error || details.status);
    },
    onUploadFilesStart: () => uploadStart(),
    onUploadFilesComplete: () => resolveUpload(),
    onVerificationError: (error) => {
      deployError = new AbortError(
        error.message,
        "Please verify the deployment status in the Shopify Admin and retry deploying if necessary."
      );
    },
    onUploadFilesError: (error) => {
      deployError = new AbortError(
        error.message,
        "Check your connection and try again. If the problem persists, try again later or contact support."
      );
    }
  };
  buildCommand ? config2.buildCommand = buildCommand : hooks2.buildFunction = async (assetPath) => {
    outputInfo(
      outputContent`${source_default.whiteBright("Building project...")}`.value
    ), await (isClassicCompiler ? runClassicCompilerBuild : runBuild)({
      directory: root,
      assetPath,
      lockfileCheck,
      sourcemap: !0,
      useCodegen: !1,
      entry: ssrEntry
    });
  };
  let uploadStart = async () => {
    outputInfo(
      outputContent`${source_default.whiteBright(`Deploying to Oxygen..
`)}`.value
    ), await renderTasks([
      {
        title: "Uploading files",
        task: async () => await uploadPromise
      },
      {
        title: "Verifying deployment has been completed",
        task: async () => await deploymentCompletedVerificationPromise
      },
      {
        title: "Verifying deployment is routable",
        task: async () => await routableCheckPromise,
        skip: () => noVerify
      }
    ]);
  };
  return await createDeploy({ config: config2, hooks: hooks2, logger: deploymentLogger }).then(async (completedDeployment) => {
    if (!completedDeployment) {
      rejectDeploy(createUnexpectedAbortError());
      return;
    }
    let nextSteps = [];
    isCI2 ? jsonOutput && nextSteps.push([
      "View the deployment information in",
      { subdued: DEPLOY_OUTPUT_FILE_HANDLE }
    ]) : (nextSteps.push([
      "Open",
      { link: { url: completedDeployment.url } },
      "in your browser to view your deployment."
    ]), completedDeployment?.authBypassToken && nextSteps.push([
      "Use the",
      { subdued: completedDeployment.authBypassToken },
      "token to perform end-to-end tests against the deployment."
    ])), renderSuccess({
      body: ["Successfully deployed to Oxygen"],
      nextSteps
    }), isCI2 && jsonOutput && await writeFile(
      DEPLOY_OUTPUT_FILE_HANDLE,
      JSON.stringify(completedDeployment)
    ), resolveDeploy();
  }).catch((error) => {
    rejectDeploy(deployError || error);
  }), deployPromise;
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/dev.js
init_cjs_shims();
var import_core22 = __toESM(require_lib(), 1);

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/upgrade.js
init_cjs_shims();
var import_semver = __toESM(require_semver(), 1);
import { createRequire } from "node:module";

// ../../node_modules/.pnpm/cli-truncate@4.0.0/node_modules/cli-truncate/index.js
init_cjs_shims();

// ../../node_modules/.pnpm/string-width@7.1.0/node_modules/string-width/index.js
init_cjs_shims();

// ../../node_modules/.pnpm/get-east-asian-width@1.2.0/node_modules/get-east-asian-width/index.js
init_cjs_shims();

// ../../node_modules/.pnpm/get-east-asian-width@1.2.0/node_modules/get-east-asian-width/lookup.js
init_cjs_shims();
function isAmbiguous(x) {
  return x === 161 || x === 164 || x === 167 || x === 168 || x === 170 || x === 173 || x === 174 || x >= 176 && x <= 180 || x >= 182 && x <= 186 || x >= 188 && x <= 191 || x === 198 || x === 208 || x === 215 || x === 216 || x >= 222 && x <= 225 || x === 230 || x >= 232 && x <= 234 || x === 236 || x === 237 || x === 240 || x === 242 || x === 243 || x >= 247 && x <= 250 || x === 252 || x === 254 || x === 257 || x === 273 || x === 275 || x === 283 || x === 294 || x === 295 || x === 299 || x >= 305 && x <= 307 || x === 312 || x >= 319 && x <= 322 || x === 324 || x >= 328 && x <= 331 || x === 333 || x === 338 || x === 339 || x === 358 || x === 359 || x === 363 || x === 462 || x === 464 || x === 466 || x === 468 || x === 470 || x === 472 || x === 474 || x === 476 || x === 593 || x === 609 || x === 708 || x === 711 || x >= 713 && x <= 715 || x === 717 || x === 720 || x >= 728 && x <= 731 || x === 733 || x === 735 || x >= 768 && x <= 879 || x >= 913 && x <= 929 || x >= 931 && x <= 937 || x >= 945 && x <= 961 || x >= 963 && x <= 969 || x === 1025 || x >= 1040 && x <= 1103 || x === 1105 || x === 8208 || x >= 8211 && x <= 8214 || x === 8216 || x === 8217 || x === 8220 || x === 8221 || x >= 8224 && x <= 8226 || x >= 8228 && x <= 8231 || x === 8240 || x === 8242 || x === 8243 || x === 8245 || x === 8251 || x === 8254 || x === 8308 || x === 8319 || x >= 8321 && x <= 8324 || x === 8364 || x === 8451 || x === 8453 || x === 8457 || x === 8467 || x === 8470 || x === 8481 || x === 8482 || x === 8486 || x === 8491 || x === 8531 || x === 8532 || x >= 8539 && x <= 8542 || x >= 8544 && x <= 8555 || x >= 8560 && x <= 8569 || x === 8585 || x >= 8592 && x <= 8601 || x === 8632 || x === 8633 || x === 8658 || x === 8660 || x === 8679 || x === 8704 || x === 8706 || x === 8707 || x === 8711 || x === 8712 || x === 8715 || x === 8719 || x === 8721 || x === 8725 || x === 8730 || x >= 8733 && x <= 8736 || x === 8739 || x === 8741 || x >= 8743 && x <= 8748 || x === 8750 || x >= 8756 && x <= 8759 || x === 8764 || x === 8765 || x === 8776 || x === 8780 || x === 8786 || x === 8800 || x === 8801 || x >= 8804 && x <= 8807 || x === 8810 || x === 8811 || x === 8814 || x === 8815 || x === 8834 || x === 8835 || x === 8838 || x === 8839 || x === 8853 || x === 8857 || x === 8869 || x === 8895 || x === 8978 || x >= 9312 && x <= 9449 || x >= 9451 && x <= 9547 || x >= 9552 && x <= 9587 || x >= 9600 && x <= 9615 || x >= 9618 && x <= 9621 || x === 9632 || x === 9633 || x >= 9635 && x <= 9641 || x === 9650 || x === 9651 || x === 9654 || x === 9655 || x === 9660 || x === 9661 || x === 9664 || x === 9665 || x >= 9670 && x <= 9672 || x === 9675 || x >= 9678 && x <= 9681 || x >= 9698 && x <= 9701 || x === 9711 || x === 9733 || x === 9734 || x === 9737 || x === 9742 || x === 9743 || x === 9756 || x === 9758 || x === 9792 || x === 9794 || x === 9824 || x === 9825 || x >= 9827 && x <= 9829 || x >= 9831 && x <= 9834 || x === 9836 || x === 9837 || x === 9839 || x === 9886 || x === 9887 || x === 9919 || x >= 9926 && x <= 9933 || x >= 9935 && x <= 9939 || x >= 9941 && x <= 9953 || x === 9955 || x === 9960 || x === 9961 || x >= 9963 && x <= 9969 || x === 9972 || x >= 9974 && x <= 9977 || x === 9979 || x === 9980 || x === 9982 || x === 9983 || x === 10045 || x >= 10102 && x <= 10111 || x >= 11094 && x <= 11097 || x >= 12872 && x <= 12879 || x >= 57344 && x <= 63743 || x >= 65024 && x <= 65039 || x === 65533 || x >= 127232 && x <= 127242 || x >= 127248 && x <= 127277 || x >= 127280 && x <= 127337 || x >= 127344 && x <= 127373 || x === 127375 || x === 127376 || x >= 127387 && x <= 127404 || x >= 917760 && x <= 917999 || x >= 983040 && x <= 1048573 || x >= 1048576 && x <= 1114109;
}
function isFullWidth(x) {
  return x === 12288 || x >= 65281 && x <= 65376 || x >= 65504 && x <= 65510;
}
function isWide(x) {
  return x >= 4352 && x <= 4447 || x === 8986 || x === 8987 || x === 9001 || x === 9002 || x >= 9193 && x <= 9196 || x === 9200 || x === 9203 || x === 9725 || x === 9726 || x === 9748 || x === 9749 || x >= 9800 && x <= 9811 || x === 9855 || x === 9875 || x === 9889 || x === 9898 || x === 9899 || x === 9917 || x === 9918 || x === 9924 || x === 9925 || x === 9934 || x === 9940 || x === 9962 || x === 9970 || x === 9971 || x === 9973 || x === 9978 || x === 9981 || x === 9989 || x === 9994 || x === 9995 || x === 10024 || x === 10060 || x === 10062 || x >= 10067 && x <= 10069 || x === 10071 || x >= 10133 && x <= 10135 || x === 10160 || x === 10175 || x === 11035 || x === 11036 || x === 11088 || x === 11093 || x >= 11904 && x <= 11929 || x >= 11931 && x <= 12019 || x >= 12032 && x <= 12245 || x >= 12272 && x <= 12287 || x >= 12289 && x <= 12350 || x >= 12353 && x <= 12438 || x >= 12441 && x <= 12543 || x >= 12549 && x <= 12591 || x >= 12593 && x <= 12686 || x >= 12688 && x <= 12771 || x >= 12783 && x <= 12830 || x >= 12832 && x <= 12871 || x >= 12880 && x <= 19903 || x >= 19968 && x <= 42124 || x >= 42128 && x <= 42182 || x >= 43360 && x <= 43388 || x >= 44032 && x <= 55203 || x >= 63744 && x <= 64255 || x >= 65040 && x <= 65049 || x >= 65072 && x <= 65106 || x >= 65108 && x <= 65126 || x >= 65128 && x <= 65131 || x >= 94176 && x <= 94180 || x === 94192 || x === 94193 || x >= 94208 && x <= 100343 || x >= 100352 && x <= 101589 || x >= 101632 && x <= 101640 || x >= 110576 && x <= 110579 || x >= 110581 && x <= 110587 || x === 110589 || x === 110590 || x >= 110592 && x <= 110882 || x === 110898 || x >= 110928 && x <= 110930 || x === 110933 || x >= 110948 && x <= 110951 || x >= 110960 && x <= 111355 || x === 126980 || x === 127183 || x === 127374 || x >= 127377 && x <= 127386 || x >= 127488 && x <= 127490 || x >= 127504 && x <= 127547 || x >= 127552 && x <= 127560 || x === 127568 || x === 127569 || x >= 127584 && x <= 127589 || x >= 127744 && x <= 127776 || x >= 127789 && x <= 127797 || x >= 127799 && x <= 127868 || x >= 127870 && x <= 127891 || x >= 127904 && x <= 127946 || x >= 127951 && x <= 127955 || x >= 127968 && x <= 127984 || x === 127988 || x >= 127992 && x <= 128062 || x === 128064 || x >= 128066 && x <= 128252 || x >= 128255 && x <= 128317 || x >= 128331 && x <= 128334 || x >= 128336 && x <= 128359 || x === 128378 || x === 128405 || x === 128406 || x === 128420 || x >= 128507 && x <= 128591 || x >= 128640 && x <= 128709 || x === 128716 || x >= 128720 && x <= 128722 || x >= 128725 && x <= 128727 || x >= 128732 && x <= 128735 || x === 128747 || x === 128748 || x >= 128756 && x <= 128764 || x >= 128992 && x <= 129003 || x === 129008 || x >= 129292 && x <= 129338 || x >= 129340 && x <= 129349 || x >= 129351 && x <= 129535 || x >= 129648 && x <= 129660 || x >= 129664 && x <= 129672 || x >= 129680 && x <= 129725 || x >= 129727 && x <= 129733 || x >= 129742 && x <= 129755 || x >= 129760 && x <= 129768 || x >= 129776 && x <= 129784 || x >= 131072 && x <= 196605 || x >= 196608 && x <= 262141;
}

// ../../node_modules/.pnpm/get-east-asian-width@1.2.0/node_modules/get-east-asian-width/index.js
function validate2(codePoint) {
  if (!Number.isSafeInteger(codePoint))
    throw new TypeError(`Expected a code point, got \`${typeof codePoint}\`.`);
}
function eastAsianWidth(codePoint, { ambiguousAsWide = !1 } = {}) {
  return validate2(codePoint), isFullWidth(codePoint) || isWide(codePoint) || ambiguousAsWide && isAmbiguous(codePoint) ? 2 : 1;
}

// ../../node_modules/.pnpm/string-width@7.1.0/node_modules/string-width/index.js
var import_emoji_regex = __toESM(require_emoji_regex(), 1), segmenter = new Intl.Segmenter();
function stringWidth(string, options = {}) {
  if (typeof string != "string" || string.length === 0)
    return 0;
  let {
    ambiguousIsNarrow = !0,
    countAnsiEscapeCodes = !1
  } = options;
  if (countAnsiEscapeCodes || (string = stripAnsi(string)), string.length === 0)
    return 0;
  let width = 0, eastAsianWidthOptions = { ambiguousAsWide: !ambiguousIsNarrow };
  for (let { segment: character } of segmenter.segment(string)) {
    let codePoint = character.codePointAt(0);
    if (!(codePoint <= 31 || codePoint >= 127 && codePoint <= 159) && !(codePoint >= 768 && codePoint <= 879)) {
      if ((0, import_emoji_regex.default)().test(character)) {
        width += 2;
        continue;
      }
      width += eastAsianWidth(codePoint, eastAsianWidthOptions);
    }
  }
  return width;
}

// ../../node_modules/.pnpm/cli-truncate@4.0.0/node_modules/cli-truncate/index.js
function getIndexOfNearestSpace(string, wantedIndex, shouldSearchRight) {
  if (string.charAt(wantedIndex) === " ")
    return wantedIndex;
  let direction = shouldSearchRight ? 1 : -1;
  for (let index = 0; index <= 3; index++) {
    let finalIndex = wantedIndex + index * direction;
    if (string.charAt(finalIndex) === " ")
      return finalIndex;
  }
  return wantedIndex;
}
function cliTruncate(text, columns3, options = {}) {
  let {
    position = "end",
    space = !1,
    preferTruncationOnSpace = !1
  } = options, { truncationCharacter = "\u2026" } = options;
  if (typeof text != "string")
    throw new TypeError(`Expected \`input\` to be a string, got ${typeof text}`);
  if (typeof columns3 != "number")
    throw new TypeError(`Expected \`columns\` to be a number, got ${typeof columns3}`);
  if (columns3 < 1)
    return "";
  if (columns3 === 1)
    return truncationCharacter;
  let length = stringWidth(text);
  if (length <= columns3)
    return text;
  if (position === "start") {
    if (preferTruncationOnSpace) {
      let nearestSpace = getIndexOfNearestSpace(text, length - columns3 + 1, !0);
      return truncationCharacter + sliceAnsi(text, nearestSpace, length).trim();
    }
    return space === !0 && (truncationCharacter += " "), truncationCharacter + sliceAnsi(text, length - columns3 + stringWidth(truncationCharacter), length);
  }
  if (position === "middle") {
    space === !0 && (truncationCharacter = ` ${truncationCharacter} `);
    let half = Math.floor(columns3 / 2);
    if (preferTruncationOnSpace) {
      let spaceNearFirstBreakPoint = getIndexOfNearestSpace(text, half), spaceNearSecondBreakPoint = getIndexOfNearestSpace(text, length - (columns3 - half) + 1, !0);
      return sliceAnsi(text, 0, spaceNearFirstBreakPoint) + truncationCharacter + sliceAnsi(text, spaceNearSecondBreakPoint, length).trim();
    }
    return sliceAnsi(text, 0, half) + truncationCharacter + sliceAnsi(text, length - (columns3 - half) + stringWidth(truncationCharacter), length);
  }
  if (position === "end") {
    if (preferTruncationOnSpace) {
      let nearestSpace = getIndexOfNearestSpace(text, columns3 - 1);
      return sliceAnsi(text, 0, nearestSpace) + truncationCharacter;
    }
    return space === !0 && (truncationCharacter = ` ${truncationCharacter}`), sliceAnsi(text, 0, columns3 - stringWidth(truncationCharacter)) + truncationCharacter;
  }
  throw new Error(`Expected \`options.position\` to be either \`start\`, \`middle\` or \`end\`, got ${position}`);
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/upgrade.js
var import_core21 = __toESM(require_lib(), 1);
var INSTRUCTIONS_FOLDER = ".hydrogen", Upgrade2 = class _Upgrade extends base_command_default {
  static descriptionWithMarkdown = "Upgrade Hydrogen project dependencies, preview features, fixes and breaking changes. The command also generates an instruction file for each upgrade.";
  static description = "Upgrade Remix and Hydrogen npm dependencies.";
  static flags = {
    ...commonFlags.path,
    version: import_core21.Flags.string({
      description: "A target hydrogen version to update to",
      required: !1,
      char: "v"
    }),
    force: import_core21.Flags.boolean({
      description: "Ignore warnings and force the upgrade to the target version",
      env: "SHOPIFY_HYDROGEN_FLAG_FORCE",
      char: "f"
    })
  };
  async run() {
    let { flags } = await this.parse(_Upgrade);
    await runUpgrade({
      ...flagsToCamelObject(flags),
      appPath: flags.path ? resolvePath(flags.path) : process.cwd()
    });
  }
}, CACHED_CHANGELOG = null;
async function runUpgrade({
  appPath,
  version: targetVersion,
  force
}) {
  force || (await checkIsGitRepo(appPath), await checkDirtyGitBranch(appPath));
  let { currentVersion, currentDependencies } = await getHydrogenVersion({
    appPath
  });
  if (import_semver.default.prerelease(currentVersion))
    throw new AbortError(
      "The upgrade command cannot be run over a prerelease Hydrogen version"
    );
  let changelog = await getChangelog(), { availableUpgrades } = getAvailableUpgrades({
    releases: changelog.releases,
    currentVersion,
    currentDependencies
  });
  if (!availableUpgrades?.length) {
    renderSuccess({
      headline: `You are on the latest Hydrogen version: ${getAbsoluteVersion(
        currentVersion
      )}`
    });
    return;
  }
  let confirmed = !1, selectedRelease, cumulativeRelease;
  do
    selectedRelease = await getSelectedRelease({
      currentVersion,
      targetVersion,
      availableUpgrades
    }), cumulativeRelease = getCummulativeRelease({
      availableUpgrades,
      currentVersion,
      currentDependencies,
      selectedRelease
    }), confirmed = await displayConfirmation({
      cumulativeRelease,
      selectedRelease
    });
  while (!confirmed);
  let instrunctionsFilePathPromise = generateUpgradeInstructionsFile({
    appPath,
    cumulativeRelease,
    currentVersion,
    selectedRelease
  });
  await upgradeNodeModules({ appPath, selectedRelease, currentDependencies }), await validateUpgrade({
    appPath,
    selectedRelease
  });
  let instrunctionsFilePath = await instrunctionsFilePathPromise;
  await displayUpgradeSummary({
    appPath,
    currentVersion,
    instrunctionsFilePath,
    selectedRelease
  });
}
function checkIsGitRepo(appPath) {
  return ensureInsideGitDirectory(appPath).catch(() => {
    throw new AbortError(
      "The upgrade command can only be run on a git repository",
      "Please run the command inside a git repository or run 'git init' to create one"
    );
  });
}
async function checkDirtyGitBranch(appPath) {
  if (!await isClean(appPath))
    throw new AbortError(
      "The upgrade command can only be run on a clean git branch",
      "Please commit your changes or re-run the command on a clean branch"
    );
}
async function getHydrogenVersion({ appPath }) {
  let { root } = getProjectPaths(appPath), packageJsonPath = joinPath(root, "package.json"), packageJson;
  try {
    packageJson = JSON.parse(await readFile(packageJsonPath));
  } catch {
    throw new AbortError(
      "Could not find a valid package.json",
      "Please make sure you are running the command in a npm project"
    );
  }
  let currentDependencies = {
    ...packageJson?.dependencies,
    ...packageJson?.devDependencies
  }, currentVersion = currentDependencies["@shopify/hydrogen"];
  if (!currentVersion)
    throw new AbortError(
      "Could not find a valid Hydrogen version in package.json",
      "Please make sure you are running the command in a Hydrogen project"
    );
  return { currentVersion, currentDependencies };
}
async function getChangelog() {
  if (CACHED_CHANGELOG)
    return CACHED_CHANGELOG;
  if (isHydrogenMonorepo && hydrogenPackagesPath && process.env.FORCE_CHANGELOG_SOURCE !== "remote")
    return createRequire(import.meta.url)(joinPath(
      dirname(hydrogenPackagesPath),
      "docs",
      "changelog.json"
    ));
  try {
    let response = await fetch("https://hydrogen.shopify.dev/changelog.json");
    if (!response.ok)
      throw new Error("Failed to fetch changelog.json");
    let json = await response.json();
    if ("releases" in json && "url" in json)
      return CACHED_CHANGELOG = json, CACHED_CHANGELOG;
  } catch {
  }
  throw new AbortError(
    "Failed to fetch Hydrogen changelog",
    "Ensure you have internet connection and try again"
  );
}
function hasOutdatedDependencies({
  release: release2,
  currentDependencies
}) {
  return Object.entries({
    ...release2.dependencies,
    ...release2.devDependencies
  }).some(([name, version2]) => {
    let currentDependencyVersion = currentDependencies?.[name];
    return currentDependencyVersion ? import_semver.default.gt(
      getAbsoluteVersion(version2),
      getAbsoluteVersion(currentDependencyVersion)
    ) : !1;
  });
}
function isUpgradeableRelease({
  currentDependencies,
  currentPinnedVersion,
  release: release2
}) {
  return import_semver.default.gt(release2.version, currentPinnedVersion) ? !0 : getAbsoluteVersion(release2.version) === currentPinnedVersion ? hasOutdatedDependencies({ release: release2, currentDependencies }) : !1;
}
function getAvailableUpgrades({
  releases,
  currentVersion,
  currentDependencies
}) {
  let currentPinnedVersion = getAbsoluteVersion(currentVersion), currentMajorVersion = "", availableUpgrades = releases.filter((release2) => isUpgradeableRelease({
    release: release2,
    currentPinnedVersion,
    currentDependencies
  }) && currentMajorVersion !== release2.version ? (currentMajorVersion = release2.version, !0) : !1), uniqueAvailableUpgrades = availableUpgrades.reduce((acc, release2) => (acc[release2.version] || (acc[release2.version] = release2), acc), {});
  return { availableUpgrades, uniqueAvailableUpgrades };
}
async function getSelectedRelease({
  targetVersion,
  availableUpgrades,
  currentVersion
}) {
  return (targetVersion ? availableUpgrades.find(
    (release2) => getAbsoluteVersion(release2.version) === getAbsoluteVersion(targetVersion)
  ) : void 0) ?? promptUpgradeOptions(currentVersion, availableUpgrades);
}
function getCummulativeRelease({
  availableUpgrades,
  selectedRelease,
  currentVersion,
  currentDependencies
}) {
  let currentPinnedVersion = getAbsoluteVersion(currentVersion);
  return availableUpgrades?.length ? availableUpgrades.filter((release2) => import_semver.default.gt(release2.version, currentPinnedVersion) && import_semver.default.lte(release2.version, selectedRelease.version) ? !0 : !(getAbsoluteVersion(release2.version) === currentPinnedVersion) || !currentDependencies ? !1 : hasOutdatedDependencies({ release: release2, currentDependencies })).reduce(
    (acc, release2) => (acc.features = [...acc.features, ...release2.features], acc.fixes = [...acc.fixes, ...release2.fixes], acc),
    { features: [], fixes: [] }
  ) : { features: [], fixes: [] };
}
function displayConfirmation({
  cumulativeRelease,
  selectedRelease
}) {
  let { features, fixes } = cumulativeRelease;
  return (features.length || fixes.length) && renderInfo({
    headline: "Included in this upgrade:",
    //@ts-ignore we know that filter(Boolean) will always return an array
    customSections: [
      features.length && {
        title: "Features",
        body: [
          {
            list: {
              items: features.map((item) => item.title)
            }
          }
        ]
      },
      fixes.length && {
        title: "Fixes",
        body: [
          {
            list: {
              items: fixes.map((item) => item.title)
            }
          }
        ]
      }
    ].filter(Boolean)
  }), renderConfirmationPrompt({
    message: `Are you sure you want to upgrade to ${selectedRelease.version}?`,
    cancellationMessage: "No, choose another version",
    defaultValue: !0
  });
}
function isRemixDependency([name]) {
  return !!name.includes("@remix-run");
}
function maybeIncludeDependency({
  currentDependencies,
  dependency: [name, version2],
  selectedRelease
}) {
  let existingDependencyVersion = currentDependencies[name];
  return isRemixDependency([name, version2]) || existingDependencyVersion === "next" ? !1 : selectedRelease.dependenciesMeta?.[name] ? !selectedRelease.dependenciesMeta?.[name]?.required ? !1 : !!(!existingDependencyVersion || import_semver.default.lt(
    getAbsoluteVersion(existingDependencyVersion),
    getAbsoluteVersion(version2)
  )) : !0;
}
function buildUpgradeCommandArgs({
  selectedRelease,
  currentDependencies
}) {
  let args = [];
  for (let dependency7 of Object.entries(selectedRelease.dependencies))
    maybeIncludeDependency({
      currentDependencies,
      dependency: dependency7,
      selectedRelease
    }) && args.push(`${dependency7[0]}@${getAbsoluteVersion(dependency7[1])}`);
  for (let dependency7 of Object.entries(selectedRelease.devDependencies))
    maybeIncludeDependency({
      currentDependencies,
      dependency: dependency7,
      selectedRelease
    }) && args.push(`${dependency7[0]}@${getAbsoluteVersion(dependency7[1])}`);
  let currentRemix = Object.entries(currentDependencies).find(isRemixDependency), selectedRemix = Object.entries(selectedRelease.dependencies).find(
    isRemixDependency
  );
  return currentRemix && selectedRemix && import_semver.default.lt(
    getAbsoluteVersion(currentRemix[1]),
    getAbsoluteVersion(selectedRemix[1])
  ) && args.push(
    ...appendRemixDependencies({ currentDependencies, selectedRemix })
  ), args;
}
async function upgradeNodeModules({
  appPath,
  selectedRelease,
  currentDependencies
}) {
  await renderTasks(
    [
      {
        title: "Upgrading dependencies",
        task: async () => {
          await installNodeModules({
            directory: appPath,
            packageManager: await getPackageManager(appPath),
            args: buildUpgradeCommandArgs({
              selectedRelease,
              currentDependencies
            })
          });
        }
      }
    ],
    {}
  );
}
function appendRemixDependencies({
  currentDependencies,
  selectedRemix
}) {
  let command = [];
  for (let [name, version2] of Object.entries(currentDependencies))
    isRemixDependency([name, version2]) && command.push(`${name}@${getAbsoluteVersion(selectedRemix[1])}`);
  return command;
}
function getAbsoluteVersion(version2) {
  let result = import_semver.default.minVersion(version2);
  if (!result)
    throw new AbortError(`Invalid version: ${version2}`);
  return result.version;
}
async function promptUpgradeOptions(currentVersion, availableUpgrades) {
  if (!availableUpgrades?.length)
    throw new AbortError("No upgrade options available");
  let choices = availableUpgrades.map((release2, index) => {
    let { version: version2, title } = release2, tag = index === 0 ? "(latest)" : import_semver.default.patch(version2) === 0 ? "(major)" : getAbsoluteVersion(currentVersion) === getAbsoluteVersion(version2) ? "(outdated)" : "";
    return `${import_semver.default.major(version2)}${import_semver.default.minor(version2)}`, {
      // group: majorVersion,
      label: `${version2} ${tag} - ${cliTruncate(title, 54)}`,
      value: release2
    };
  });
  return renderSelectPrompt({
    message: `Available Hydrogen versions (current: ${currentVersion})`,
    choices,
    defaultValue: choices[0]?.value
    // Latest version
  });
}
async function displayUpgradeSummary({
  appPath,
  currentVersion,
  selectedRelease,
  instrunctionsFilePath
}) {
  let updatedDependenciesList = [
    ...Object.entries(selectedRelease.dependencies || {}).map(
      ([name, version2]) => `${name}@${version2}`
    ),
    ...Object.entries(selectedRelease.devDependencies || {}).map(
      ([name, version2]) => `${name}@${version2}`
    )
  ], nextSteps = [];
  if (typeof instrunctionsFilePath == "string") {
    let instructions = `Upgrade instructions created at:
file://${instrunctionsFilePath}`;
    nextSteps.push(instructions);
  }
  let releaseNotesUrl = `https://hydrogen.shopify.dev/releases/${selectedRelease.version}`;
  nextSteps.push(`Release notes:
${releaseNotesUrl}`);
  let currentPinnedVersion = getAbsoluteVersion(currentVersion), selectedPinnedVersion = getAbsoluteVersion(selectedRelease.version), upgradedDependenciesOnly = currentPinnedVersion === selectedPinnedVersion, fromToMsg = `${currentPinnedVersion} \u2192 ${selectedPinnedVersion}`, headline = upgradedDependenciesOnly ? `You've have upgraded Hydrogen ${selectedPinnedVersion} dependencies` : `You've have upgraded from ${fromToMsg}`, packageManager2 = await getPackageManager(appPath);
  return renderSuccess({
    headline,
    // @ts-ignore we know that filter(Boolean) will always return an array
    customSections: [
      {
        title: "Updated dependencies",
        body: [
          {
            list: {
              items: updatedDependenciesList
            }
          }
        ]
      },
      {
        title: "What\u2019s next?",
        body: [
          {
            list: {
              items: nextSteps
            }
          }
        ]
      },
      {
        title: "Undo these upgrades?",
        body: [
          {
            list: {
              items: [
                `Run \`git restore . && git clean -df && ${packageManager2} i\``
              ]
            }
          }
        ]
      }
    ].filter(Boolean)
  });
}
async function validateUpgrade({
  appPath,
  selectedRelease
}) {
  let updatedVersion = (await getDependencies(joinPath(appPath, "package.json")))["@shopify/hydrogen"];
  if (!updatedVersion)
    throw new AbortError("Hydrogen version not found in package.json");
  let updatedPinnedVersion = getAbsoluteVersion(updatedVersion);
  if (updatedPinnedVersion !== selectedRelease.version)
    throw new AbortError(
      `Failed to upgrade to Hydrogen version ${selectedRelease.version}`,
      `You are still on version ${updatedPinnedVersion}`
    );
}
function generateStepMd(item) {
  let { steps } = item, heading = `### ${item.title} [#${item.id}](${item.pr})
`, body = steps?.map((step, stepIndex) => {
    let pr = item.pr ? `[#${item.id}](${item.pr})
` : "", title = steps.length > 1 ? `#### Step: ${stepIndex + 1}. ${step.title} ${pr}
` : `#### ${step.title.trim()}
`, info2 = step.info ? `> ${step.info}
` : "", code = step.code ? `${Buffer.from(step.code, "base64")}
` : "", docs = item.docs ? `[docs](${item.docs})
` : "";
    return `${title}${info2}${docs}${pr}${code}`;
  }).join(`
`);
  return `${heading}
${body}`;
}
async function generateUpgradeInstructionsFile({
  appPath,
  cumulativeRelease,
  currentVersion,
  selectedRelease
}) {
  let filename = "", { featuresMd, breakingChangesMd } = cumulativeRelease.features.filter((feature) => feature.steps).reduce(
    (acc, feature) => (feature.breaking ? acc.breakingChangesMd.push(generateStepMd(feature)) : acc.featuresMd.push(generateStepMd(feature)), acc),
    { featuresMd: [], breakingChangesMd: [] }
  ), fixesMd = cumulativeRelease.fixes.filter((fixes) => fixes.steps).map(generateStepMd);
  if (!featuresMd.length && !fixesMd.length) {
    renderInfo({
      headline: "No upgrade instructions generated",
      body: "There are no additional upgrade instructions for this version."
    });
    return;
  }
  let absoluteFrom = getAbsoluteVersion(currentVersion), absoluteTo = getAbsoluteVersion(selectedRelease.version);
  filename = `upgrade-${absoluteFrom}-to-${absoluteTo}.md`;
  let instructionsFolderPath = joinPath(appPath, INSTRUCTIONS_FOLDER), md = `${`# Hydrogen upgrade guide: ${absoluteFrom} to ${absoluteTo}`}

----
`;
  breakingChangesMd.length && (md += `
## Breaking changes

${breakingChangesMd.join(`
`)}
----
`), featuresMd.length && (md += `
## Features

${featuresMd.join(`
`)}
----
`), fixesMd.length && (md += `
${featuresMd.length ? `----

` : ""}## Fixes

${fixesMd.join(
    `
`
  )}`);
  let filePath = joinPath(instructionsFolderPath, filename);
  try {
    await isDirectory(instructionsFolderPath);
  } catch {
    await mkdir(instructionsFolderPath);
  }
  if (!await fileExists(filePath))
    await touchFile(filePath);
  else {
    if (await renderConfirmationPrompt({
      message: `A previous upgrade instructions file already exists for this version.
Do you want to overwrite it?`,
      defaultValue: !1
    }))
      await removeFile(`${filePath}.old`);
    else
      return;
    await touchFile(filePath);
  }
  return await writeFile(filePath, md), `${INSTRUCTIONS_FOLDER}/${filename}`;
}
async function displayDevUpgradeNotice({
  targetPath
}) {
  try {
    let appPath = targetPath ? resolvePath(targetPath) : process.cwd(), { currentVersion, currentDependencies } = await getHydrogenVersion({
      appPath
    });
    if (import_semver.default.prerelease(currentVersion) || /^[a-z]+$/i.test(currentVersion))
      return;
    let changelog = await getChangelog(), { availableUpgrades, uniqueAvailableUpgrades } = getAvailableUpgrades({
      releases: changelog.releases,
      currentVersion,
      currentDependencies
    });
    if (availableUpgrades.length === 0 || !availableUpgrades[0]?.version)
      return;
    let pinnedLatestVersion = getAbsoluteVersion(
      availableUpgrades[0].version
    ), pinnedCurrentVersion = getAbsoluteVersion(currentVersion), isLatestHydrogenPackage = pinnedCurrentVersion === pinnedLatestVersion, currentReleaseIndex = isLatestHydrogenPackage ? changelog.releases.findIndex(
      (release2) => getAbsoluteVersion(release2.version) !== pinnedCurrentVersion
    ) : changelog.releases.findIndex(
      (release2) => getAbsoluteVersion(release2.version) === pinnedCurrentVersion
    ), relevantReleases = changelog.releases.slice(0, currentReleaseIndex), nextReleases = Object.values(
      [...relevantReleases].reverse().reduce((acc, release2) => (acc[release2.version] ??= `${release2.version} - ${release2.title}`, acc), {})
    ).slice(0, 5), headline = Object.keys(uniqueAvailableUpgrades).length > 1 ? `There are ${Object.keys(uniqueAvailableUpgrades).length} new @shopify/hydrogen versions available.` : "There's a new @shopify/hydrogen version available.", cliCommand = await getCliCommand();
    renderInfo({
      headline,
      body: [
        `Current: ${currentVersion} | Latest: ${pinnedLatestVersion}` + (isLatestHydrogenPackage ? " with updated dependencies" : "")
      ],
      customSections: [
        ...nextReleases.length > 0 ? [
          {
            title: `The next ${nextReleases.length} version(s) include`,
            body: [
              {
                list: {
                  items: [
                    ...nextReleases,
                    availableUpgrades.length > 5 ? "...more" : ""
                  ].flat().filter(Boolean)
                }
              }
            ].filter(Boolean)
          }
        ] : [],
        {
          title: "Next steps",
          body: [
            {
              list: {
                items: [
                  `Run \`${cliCommand} upgrade\` or \`${cliCommand} upgrade --version ${relevantReleases[0]?.version ?? "<version>"}\``,
                  "Read release notes at https://hydrogen.shopify.dev/releases"
                ]
              }
            }
          ]
        }
      ]
    });
  } catch (error) {
    let abortError = error;
    renderWarning({
      headline: abortError.message,
      body: abortError.tryMessage ?? void 0
    });
  }
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/classic-compiler/dev.js
init_cjs_shims();
import fs2 from "node:fs/promises";

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/mini-oxygen/index.js
init_cjs_shims();
async function buildAssetsUrl(port, root) {
  let { buildAssetsUrl: _buildAssetsUrl } = await importLocal(
    "@shopify/mini-oxygen",
    root
  ).catch(handleMiniOxygenImportFail);
  return _buildAssetsUrl(port);
}
async function startMiniOxygen(options, useNodeRuntime = !1) {
  if (useNodeRuntime) {
    process.env.MINIFLARE_SUBREQUEST_LIMIT = 100;
    let { startNodeServer } = await import("./node-QK7Q2TRB.js");
    return startNodeServer(options);
  }
  let { startWorkerdServer } = await import("./workerd-KAYMO4VM.js");
  return startWorkerdServer(options);
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/virtual-routes.js
init_cjs_shims();
var VIRTUAL_ROUTES_DIR = "virtual-routes/routes", VIRTUAL_ROOT = "virtual-routes/virtual-root";
async function addVirtualRoutes(config2) {
  let distPath = process.env.SHOPIFY_UNIT_TEST && hydrogenPackagesPath ? joinPath(hydrogenPackagesPath, "hydrogen", "src", "vite") : await getAssetsDir(), userRouteList = Object.values(config2.routes), virtualRoutesPath = joinPath(distPath, VIRTUAL_ROUTES_DIR);
  for (let absoluteFilePath of await glob(
    joinPath(virtualRoutesPath, "**", "*")
  )) {
    let routePath = relativePath(virtualRoutesPath, absoluteFilePath).replace(/\.[jt]sx?$/, "").replaceAll("\\", "/"), isIndex = /(^|\/)index$/.test(routePath), normalizedVirtualRoutePath = isIndex ? routePath.slice(0, -5).replace(/\/$/, "") || void 0 : (
      // TODO: support v2 flat routes?
      routePath.replace(/\$/g, ":").replace(/[\[\]]/g, "")
    );
    if (!userRouteList.some(
      (r2) => r2.parentId === "root" && r2.path === normalizedVirtualRoutePath
    )) {
      let id = VIRTUAL_ROUTES_DIR + "/" + routePath;
      config2.routes[id] = {
        id,
        parentId: VIRTUAL_ROOT,
        path: normalizedVirtualRoutePath,
        index: isIndex || void 0,
        caseSensitive: void 0,
        file: relativePath(config2.appDirectory, absoluteFilePath)
      }, config2.routes[VIRTUAL_ROOT] || (config2.routes[VIRTUAL_ROOT] = {
        id: VIRTUAL_ROOT,
        path: "",
        file: relativePath(
          config2.appDirectory,
          joinPath(distPath, VIRTUAL_ROOT + ".jsx")
        )
      });
    }
  }
  return config2;
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/live-reload.js
init_cjs_shims();
import http from "node:http";
async function setupLiveReload(devServerPort, root) {
  try {
    let [{ updates: hmrUpdates }, { serve }, { detectLoaderChanges }, { ok: ok2, err: err2 }] = await Promise.all([
      importLocal(
        "@remix-run/dev/dist/devServer_unstable/hmr.js",
        root
      ),
      importLocal(
        "@remix-run/dev/dist/devServer_unstable/socket.js",
        root
      ),
      importLocal(
        "@remix-run/dev/dist/devServer_unstable/hdr.js",
        root
      ),
      importLocal("@remix-run/dev/dist/result.js", root)
    ]).catch(handleRemixImportFail), state = {}, server = http.createServer(function(req, res) {
      res.writeHead(200), res.end();
    }).listen(devServerPort), socket = serve(server);
    return {
      onBuildStart: (ctx) => {
        state.loaderChanges = detectLoaderChanges(ctx).then(ok2, err2);
      },
      onBuildManifest: (manifest) => {
        state.manifest = manifest;
      },
      onAppReady: async (ctx) => {
        let nextState = { prevManifest: state.manifest };
        try {
          let loaderChanges = await state.loaderChanges;
          loaderChanges.ok && (nextState.prevLoaderHashes = loaderChanges.value), loaderChanges.ok && state.manifest && state.prevManifest ? socket.hmr(
            state.manifest,
            hmrUpdates(
              ctx.config,
              state.manifest,
              state.prevManifest,
              loaderChanges.value,
              state.prevLoaderHashes
            )
          ) : state.prevManifest && socket.reload();
        } finally {
          Object.assign(state, nextState);
        }
      },
      close: () => {
        socket.close(), server.close();
      }
    };
  } catch (error) {
    console.warn(
      "Could not start HMR server. Please make sure your Remix packages are in sync with Hydrogen. Defaulting to regular live reload.",
      error.stack
    );
  }
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/classic-compiler/dev.js
var LOG_REBUILDING = "\u{1F9F1} Rebuilding...", LOG_REBUILT = "\u{1F680} Rebuilt";
async function runClassicCompilerDev({
  port: appPort2,
  path: appPath,
  codegen: useCodegen = !1,
  legacyRuntime = !1,
  codegenConfigPath,
  disableVirtualRoutes,
  env: envHandle,
  envBranch,
  debug: debug4 = !1,
  sourcemap = !0,
  disableVersionCheck = !1,
  inspectorPort,
  customerAccountPush: customerAccountPushFlag = !1,
  shouldLiveReload = !0,
  envFile,
  cliConfig,
  verbose
}) {
  process.env.NODE_ENV || (process.env.NODE_ENV = "development"), verbose && setH2OVerbose(), isH2Verbose() || muteDevLogs();
  let { root, publicPath, buildPathClient, buildPathWorkerFile } = getProjectPaths(appPath), copyFilesPromise = copyPublicFiles(publicPath, buildPathClient), cliCommandPromise = getCliCommand(root), reloadConfig = async () => {
    let config2 = await getRemixConfig(root);
    return disableVirtualRoutes ? config2 : addVirtualRoutes(config2).catch((error) => (outputDebug(
      "Could not add virtual routes: " + (error?.stack ?? error?.message ?? error)
    ), config2));
  }, getFilePaths = (file) => {
    let fileRelative = relativePath(root, file);
    return [fileRelative, resolvePath(root, fileRelative)];
  }, serverBundleExists = () => fileExists(buildPathWorkerFile);
  appPort2 || (appPort2 = await findPort(DEFAULT_APP_PORT));
  let assetsPort = legacyRuntime ? 0 : await findPort(appPort2 + 100);
  assetsPort && (process.env.HYDROGEN_ASSET_BASE_URL = await buildAssetsUrl(
    assetsPort,
    root
  ));
  let backgroundPromise = getDevConfigInBackground(
    root,
    customerAccountPushFlag,
    envFile
  ), tunnelPromise = cliConfig && backgroundPromise.then(({ customerAccountPush, storefrontId }) => {
    if (customerAccountPush)
      return startTunnelAndPushConfig(
        root,
        cliConfig,
        appPort2,
        storefrontId
      );
  }), remixConfig = await reloadConfig();
  assertOxygenChecks(remixConfig);
  let envPromise = backgroundPromise.then(
    ({ fetchRemote, localVariables }) => getAllEnvironmentVariables({
      root,
      fetchRemote,
      envBranch,
      envHandle,
      localVariables,
      envFile
    })
  ), [{ watch }, { createFileWatchCache }] = await Promise.all([
    importLocal("@remix-run/dev/dist/compiler/watch.js", root),
    importLocal(
      "@remix-run/dev/dist/compiler/fileWatchCache.js",
      root
    )
  ]).catch(handleRemixImportFail), isInitialBuild = !0, initialBuildDurationMs = 0, initialBuildStartTimeMs = Date.now(), liveReload = shouldLiveReload ? await setupLiveReload(remixConfig.dev?.port ?? 8002, root) : void 0, miniOxygen, codegenProcess;
  async function safeStartMiniOxygen() {
    if (miniOxygen)
      return;
    let { allVariables, logInjectedVariables } = await envPromise;
    miniOxygen = await startMiniOxygen(
      {
        root,
        debug: debug4,
        appPort: appPort2,
        assetsPort,
        inspectorPort,
        watch: !liveReload,
        buildPathWorkerFile,
        buildPathClient,
        env: allVariables
      },
      legacyRuntime
    ), logInjectedVariables();
    let host = (await tunnelPromise)?.host ?? miniOxygen.listeningAt, cliCommand = await cliCommandPromise;
    enhanceH2Logs({ host, cliCommand, ...remixConfig });
    let { storefrontTitle } = await backgroundPromise;
    miniOxygen.showBanner({
      appName: storefrontTitle,
      headlinePrefix: initialBuildDurationMs > 0 ? `Initial build: ${initialBuildDurationMs}ms
` : "",
      host
    }), useCodegen && (codegenProcess = spawnCodegenProcess({
      ...remixConfig,
      configFilePath: codegenConfigPath
    })), checkRemixVersions(root), disableVersionCheck || displayDevUpgradeNotice({ targetPath: appPath }), customerAccountPushFlag && isMockShop(allVariables) && notifyIssueWithTunnelAndMockShop(cliCommand);
  }
  let fileWatchCache = createFileWatchCache(), skipRebuildLogs = !1, closeWatcher = await watch(
    {
      config: remixConfig,
      options: {
        mode: process.env.NODE_ENV,
        sourcemap
      },
      fileWatchCache,
      logger: createRemixLogger()
    },
    {
      reloadConfig,
      onBuildStart(ctx) {
        !isInitialBuild && !skipRebuildLogs && (outputInfo(LOG_REBUILDING), console.time(LOG_REBUILT)), liveReload?.onBuildStart(ctx);
      },
      onBuildManifest: liveReload?.onBuildManifest,
      async onBuildFinish(context, duration, succeeded) {
        if (isInitialBuild ? (await copyFilesPromise, initialBuildDurationMs = Date.now() - initialBuildStartTimeMs, isInitialBuild = !1) : skipRebuildLogs || (skipRebuildLogs = !1, console.timeEnd(LOG_REBUILT), miniOxygen || console.log("")), !miniOxygen && !await serverBundleExists())
          return renderFatalError({
            name: "BuildError",
            type: 0,
            message: "MiniOxygen cannot start because the server bundle has not been generated.",
            skipOclifErrorHandling: !0,
            tryMessage: "This is likely due to an error in your app and Remix is unable to compile. Try fixing the app and MiniOxygen will start."
          });
        succeeded && (miniOxygen ? liveReload && await miniOxygen.reload() : await safeStartMiniOxygen(), liveReload?.onAppReady(context));
      },
      async onFileCreated(file) {
        let [relative, absolute] = getFilePaths(file);
        outputInfo(`
\u{1F4C4} File created: ${relative}`), absolute.startsWith(publicPath) && await copyPublicFiles(
          absolute,
          absolute.replace(publicPath, buildPathClient)
        );
      },
      async onFileChanged(file) {
        fileWatchCache.invalidateFile(file);
        let [relative, absolute] = getFilePaths(file);
        if (outputInfo(`
\u{1F4C4} File changed: ${relative}`), relative.endsWith(envFile)) {
          skipRebuildLogs = !0;
          let { fetchRemote } = await backgroundPromise, { allVariables, logInjectedVariables } = await getAllEnvironmentVariables({
            root,
            fetchRemote,
            envBranch,
            envHandle,
            envFile
          });
          logInjectedVariables(), await miniOxygen.reload({
            env: allVariables
          });
        }
        absolute.startsWith(publicPath) && await copyPublicFiles(
          absolute,
          absolute.replace(publicPath, buildPathClient)
        );
      },
      async onFileDeleted(file) {
        fileWatchCache.invalidateFile(file);
        let [relative, absolute] = getFilePaths(file);
        outputInfo(`
\u{1F4C4} File deleted: ${relative}`), absolute.startsWith(publicPath) && await fs2.unlink(absolute.replace(publicPath, buildPathClient));
      }
    }
  );
  return {
    getUrl: () => miniOxygen.listeningAt,
    async close() {
      codegenProcess?.removeAllListeners("close"), codegenProcess?.kill("SIGINT"), await Promise.allSettled([
        closeWatcher(),
        miniOxygen?.close(),
        Promise.resolve(tunnelPromise).then((tunnel) => tunnel?.cleanup?.())
      ]);
    }
  };
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/deps-optimizer.js
init_cjs_shims();
var throttledOptimizableDeps = /* @__PURE__ */ new Set(), debouncedBannerTimeout;
function createEntryPointErrorHandler({
  disableDepsOptimizer,
  showSuccessBanner: showSuccessBanner2,
  configFile,
  formatOptionsPromise
}) {
  return async function({
    optimizableDependency,
    stack
  }) {
    let message = stack.split(`
`)[0] ?? stack, cleanStack = stack.split(`
`).filter((line) => !line.includes("virtual:remix")).join(`
`), headline = "MiniOxygen encountered an error while running your app's entry point";
    if (optimizableDependency)
      if (disableDepsOptimizer || !configFile) {
        let depError = new BugError(
          `${headline}:

${source_default.dim(message)}`,
          `Try adding '${source_default.yellow(
            optimizableDependency
          )}' to your Vite config in ssr.optimizeDeps.include`
        );
        depError.stack = cleanStack, renderFatalError(depError);
      } else
        throttledOptimizableDeps.has(optimizableDependency) || (throttledOptimizableDeps.add(optimizableDependency), setTimeout(
          () => throttledOptimizableDeps.delete(optimizableDependency),
          2e3
        ), addToViteOptimizeDeps(
          optimizableDependency,
          configFile,
          await formatOptionsPromise,
          cleanStack
        ).then(() => {
          setTimeout(() => {
            outputInfo(
              `
Added '${source_default.yellow(
                optimizableDependency
              )}' to your Vite config in ssr.optimizeDeps.include
`
            );
          }, 200), clearTimeout(debouncedBannerTimeout), debouncedBannerTimeout = setTimeout(showSuccessBanner2, 2e3);
        }).catch((error) => {
          clearTimeout(debouncedBannerTimeout), renderFatalError(error);
        }));
    else {
      let unknownError = new BugError(
        headline + `:

` + source_default.dim(message)
      );
      unknownError.stack = cleanStack, renderFatalError(unknownError);
    }
  };
}
var ssrOptimizeDepsIncludeRule = {
  rule: {
    pattern: "[$$$]",
    inside: {
      kind: "pair",
      stopBy: "end",
      has: {
        field: "key",
        regex: "include",
        stopBy: "end"
      },
      inside: {
        kind: "pair",
        stopBy: "end",
        has: {
          field: "key",
          regex: "optimizeDeps",
          stopBy: "end"
        },
        inside: {
          kind: "pair",
          stopBy: "end",
          has: {
            field: "key",
            regex: "ssr",
            stopBy: "end"
          }
        }
      }
    }
  }
};
async function addToViteOptimizeDeps(dependency7, configFile, formatOptions, errorStack) {
  let ext = extname(configFile).replace(/^\.m?/, ""), astGrep = await importLangAstGrep(ext);
  await replaceFileContent(configFile, formatOptions, (content) => {
    let node = astGrep.parse(content).root().find(ssrOptimizeDepsIncludeRule);
    if (!node)
      throw new AbortError(
        `The dependency '${source_default.yellow(
          dependency7
        )}' needs to be optimized by Vite, but couldn't be added to the Vite config.`,
        `Add the following code manually to your Vite config:

` + source_default.yellow(`ssr: {optimizeDeps: {include: ['${dependency7}']}}`)
      );
    if (!!node.find({
      rule: {
        kind: "string_fragment",
        regex: `^${dependency7}$`
      }
    })) {
      let error = new BugError(
        `A dependency related to '${source_default.yellow(
          dependency7
        )}' might need to be optimized by Vite but couldn't be configured automatically:

${source_default.dim(
          errorStack.split(`
`)[0]
        )}`,
        "If your app doesn't load, check the following stack trace and try fixing the problem by adding the imported dependency to the `ssr.optimizeDeps.include` array in your Vite config file."
      );
      throw error.stack = errorStack, error;
    }
    let { start } = node.range();
    return content.slice(0, start.index + 1) + `'${dependency7}',` + content.slice(start.index + 1);
  });
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/dev.js
var Dev2 = class _Dev extends base_command_default {
  static descriptionWithMarkdown = `Runs a Hydrogen storefront in a local runtime that emulates an Oxygen worker for development.

  If your project is [linked](https://shopify.dev/docs/api/shopify-cli/hydrogen/hydrogen-link) to a Hydrogen storefront, then its environment variables will be loaded with the runtime.`;
  static description = "Runs Hydrogen storefront in an Oxygen worker for development.";
  static flags = {
    ...commonFlags.path,
    ...commonFlags.entry,
    ...overrideFlag(commonFlags.port, {
      port: { default: void 0, required: !1 }
    }),
    ...commonFlags.codegen,
    "disable-virtual-routes": import_core22.Flags.boolean({
      description: "Disable rendering fallback routes when a route file doesn't exist.",
      env: "SHOPIFY_HYDROGEN_FLAG_DISABLE_VIRTUAL_ROUTES",
      default: !1
    }),
    ...commonFlags.debug,
    ...commonFlags.inspectorPort,
    ...commonFlags.env,
    ...commonFlags.envBranch,
    ...commonFlags.envFile,
    "disable-version-check": import_core22.Flags.boolean({
      description: "Skip the version check when running `hydrogen dev`",
      default: !1,
      required: !1
    }),
    ...commonFlags.diff,
    ...commonFlags.customerAccountPush,
    ...commonFlags.verbose,
    host: import_core22.Flags.boolean({
      description: "Expose the server to the local network",
      default: !1,
      required: !1
    }),
    "disable-deps-optimizer": import_core22.Flags.boolean({
      description: "Disable adding dependencies to Vite's `ssr.optimizeDeps.include` automatically",
      env: "SHOPIFY_HYDROGEN_FLAG_DISABLE_DEPS_OPTIMIZER",
      default: !1
    }),
    // For the classic compiler:
    worker: deprecated("--worker", { isBoolean: !0 }),
    ...overrideFlag(commonFlags.legacyRuntime, {
      "legacy-runtime": {
        description: "[Classic Remix Compiler] " + commonFlags.legacyRuntime["legacy-runtime"].description
      }
    }),
    ...overrideFlag(commonFlags.sourcemap, {
      sourcemap: {
        description: "[Classic Remix Compiler] " + commonFlags.sourcemap.sourcemap.description
      }
    })
  };
  async run() {
    let { flags } = await this.parse(_Dev), originalDirectory = flags.path ? resolvePath(flags.path) : process.cwd(), diff2 = flags.diff ? await prepareDiffDirectory(originalDirectory, !0) : void 0, directory = diff2?.targetDirectory ?? originalDirectory, devParams = {
      ...flagsToCamelObject(flags),
      customerAccountPush: flags["customer-account-push__unstable"],
      path: directory,
      cliConfig: this.config
    }, { close } = await isViteProject(directory) ? await runDev(devParams) : await runClassicCompilerDev(devParams);
    setupResourceCleanup(async () => {
      await close(), diff2 && (await diff2.copyShopifyConfig(), await diff2.cleanup());
    });
  }
};
async function runDev({
  entry: ssrEntry,
  port: appPort2,
  path: appPath,
  host,
  codegen: useCodegen = !1,
  codegenConfigPath,
  disableVirtualRoutes,
  disableDepsOptimizer = !1,
  envBranch,
  env: envHandle,
  debug: debug4 = !1,
  disableVersionCheck = !1,
  inspectorPort,
  customerAccountPush: customerAccountPushFlag = !1,
  envFile,
  cliConfig,
  verbose
}) {
  process.env.NODE_ENV || (process.env.NODE_ENV = "development"), verbose && setH2OVerbose(), isH2Verbose() || muteDevLogs();
  let root = appPath ?? process.cwd(), cliCommandPromise = getCliCommand(root), backgroundPromise = getDevConfigInBackground(
    root,
    customerAccountPushFlag,
    envFile
  ), envPromise = backgroundPromise.then(
    ({ fetchRemote, localVariables }) => getAllEnvironmentVariables({
      root,
      envBranch,
      envHandle,
      fetchRemote,
      localVariables,
      envFile
    })
  );
  debug4 && !inspectorPort && (inspectorPort = await findPort(DEFAULT_INSPECTOR_PORT));
  let vite = await importVite(root);
  hydrogenPackagesPath && await removeFile(joinPath(root, "node_modules/.vite"));
  let formatOptionsPromise = Promise.resolve().then(
    () => getCodeFormatOptions(root)
  ), viteServer = await vite.createServer({
    root,
    clearScreen: !1,
    customLogger: process.env.SHOPIFY_UNIT_TEST ? Object.assign(vite.createLogger(), {
      info: (msg) => collectLog("info", msg),
      warn: (msg) => collectLog("warn", msg),
      error: (msg) => collectLog("error", msg)
    }) : void 0,
    server: {
      host: host ? !0 : void 0,
      // Allow Vite to read files from the Hydrogen packages in local development.
      fs: hydrogenPackagesPath ? { allow: [root, hydrogenPackagesPath] } : void 0
    },
    plugins: [
      {
        name: "hydrogen:cli",
        configResolved(config2) {
          findHydrogenPlugin(config2)?.api?.registerPluginOptions({
            disableVirtualRoutes
          }), findOxygenPlugin(config2)?.api?.registerPluginOptions({
            debug: debug4,
            entry: ssrEntry,
            envPromise: envPromise.then(({ allVariables: allVariables2 }) => allVariables2),
            inspectorPort,
            logRequestLine,
            entryPointErrorHandler: createEntryPointErrorHandler({
              disableDepsOptimizer,
              configFile: config2.configFile,
              formatOptionsPromise,
              showSuccessBanner: () => showSuccessBanner({
                disableVirtualRoutes,
                debug: debug4,
                inspectorPort,
                finalHost,
                storefrontTitle
              })
            })
          });
        },
        configureServer: (viteDevServer) => {
          customerAccountPushFlag && viteDevServer.middlewares.use((req, res, next) => {
            let host2 = req.headers.host;
            host2?.includes(TUNNEL_DOMAIN.ORIGINAL) && (req.headers.host = host2.replace(
              TUNNEL_DOMAIN.ORIGINAL,
              TUNNEL_DOMAIN.REBRANDED
            )), next();
          });
        }
      }
    ]
  }), h2Plugin = findHydrogenPlugin(viteServer.config);
  if (!h2Plugin)
    throw await viteServer.close(), new AbortError(
      "Hydrogen plugin not found.",
      "Add `hydrogen()` plugin to your Vite config."
    );
  let h2PluginOptions = h2Plugin.api?.getPluginOptions?.(), codegenProcess, setupCodegen = useCodegen ? () => {
    codegenProcess?.kill(0), codegenProcess = spawnCodegenProcess({
      rootDirectory: root,
      configFilePath: codegenConfigPath,
      appDirectory: h2PluginOptions?.remixConfig?.appDirectory
    });
  } : void 0;
  setupCodegen?.(), hydrogenPackagesPath && setupMonorepoReload(viteServer, hydrogenPackagesPath, setupCodegen);
  let publicPort = appPort2 ?? viteServer.config.server.port ?? DEFAULT_APP_PORT, [tunnel, cliCommand] = await Promise.all([
    backgroundPromise.then(
      ({ customerAccountPush, storefrontId }) => customerAccountPush ? startTunnelAndPushConfig(root, cliConfig, publicPort, storefrontId) : void 0
    ),
    cliCommandPromise,
    viteServer.listen(publicPort)
  ]), publicUrl = new URL(
    viteServer.resolvedUrls.local[0] ?? viteServer.resolvedUrls.network[0]
  ), finalHost = tunnel?.host || publicUrl.toString() || publicUrl.origin;
  enhanceH2Logs({
    rootDirectory: root,
    host: finalHost,
    cliCommand
  });
  let { logInjectedVariables, allVariables } = await envPromise;
  logInjectedVariables(), console.log(""), viteServer.printUrls(), viteServer.bindCLIShortcuts({ print: !0 }), console.log(`
`);
  let storefrontTitle = (await backgroundPromise).storefrontTitle;
  return showSuccessBanner({
    disableVirtualRoutes,
    debug: debug4,
    inspectorPort,
    finalHost,
    storefrontTitle
  }), disableVersionCheck || displayDevUpgradeNotice({ targetPath: root }), customerAccountPushFlag && isMockShop(allVariables) && notifyIssueWithTunnelAndMockShop(cliCommand), {
    getUrl: () => finalHost,
    async close() {
      codegenProcess?.removeAllListeners("close"), codegenProcess?.kill("SIGINT"), await Promise.allSettled([viteServer.close(), tunnel?.cleanup?.()]);
    }
  };
}
function showSuccessBanner({
  disableVirtualRoutes,
  debug: debug4,
  inspectorPort,
  finalHost,
  storefrontTitle
}) {
  let customSections = [];
  disableVirtualRoutes || customSections.push({ body: getUtilityBannerlines(finalHost) }), debug4 && inspectorPort && customSections.push({
    body: { warn: getDebugBannerLine(inspectorPort) }
  }), renderSuccess({
    body: [
      `View ${storefrontTitle ? source_default.cyan(storefrontTitle) : "Hydrogen"} app:`,
      { link: { url: finalHost } }
    ],
    customSections
  });
}
function setupMonorepoReload(viteServer, monorepoPackagesPath, setupCodegen) {
  viteServer.httpServer?.once("listening", () => {
    viteServer.watcher.add(
      monorepoPackagesPath + "hydrogen/dist/vite/plugin.js"
    ), viteServer.watcher.add(
      monorepoPackagesPath + "mini-oxygen/dist/vite/plugin.js"
    ), viteServer.watcher.add(
      monorepoPackagesPath + "mini-oxygen/dist/vite/worker-entry.js"
    ), viteServer.watcher.add(
      monorepoPackagesPath + "hydrogen-codegen/dist/esm/index.js"
    ), viteServer.watcher.on("change", async (file) => {
      file.includes(monorepoPackagesPath) && (file.includes("/packages/hydrogen-codegen/") ? setupCodegen && (setupCodegen(), renderInfo({
        headline: "The Hydrogen Codegen source has been modified.",
        body: "The codegen process has been restarted."
      })) : (await viteServer.restart(!0), console.log(""), renderInfo({
        headline: "The H2O Vite plugins have been modified.",
        body: "The Vite server has been restarted to reflect the changes."
      })));
    });
  });
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/env/list.js
init_cjs_shims();
var EnvList = class _EnvList extends base_command_default {
  static descriptionWithMarkdown = "Lists all environments available on the linked Hydrogen storefront.";
  static description = "List the environments on your linked Hydrogen storefront.";
  static flags = {
    ...commonFlags.path
  };
  async run() {
    let { flags } = await this.parse(_EnvList);
    await runEnvList(flags);
  }
};
async function runEnvList({ path: root = process.cwd() }) {
  let [{ session, config: config2 }, cliCommand] = await Promise.all([
    login(root),
    getCliCommand()
  ]), linkedStorefront = await verifyLinkedStorefront({
    root,
    session,
    config: config2,
    cliCommand
  });
  if (!linkedStorefront)
    return;
  config2.storefront = linkedStorefront;
  let storefront = await getStorefrontEnvironments(
    session,
    config2.storefront.id
  );
  if (!storefront) {
    renderMissingStorefront({
      session,
      storefront: config2.storefront,
      cliCommand
    });
    return;
  }
  let previewEnvironmentIndex = storefront.environments.findIndex(
    (env) => env.type === "PREVIEW"
  ), previewEnvironment = storefront.environments.splice(
    previewEnvironmentIndex,
    1
  );
  storefront.environments.push(previewEnvironment[0]), outputInfo(
    pluralizedEnvironments({
      environments: storefront.environments,
      storefrontTitle: config2.storefront.title
    }).toString()
  ), storefront.environments.forEach(({ name, handle, branch, type, url }) => {
    outputNewline();
    let environmentUrl = type === "PRODUCTION" ? storefront.productionUrl : url;
    outputInfo(
      outputContent`${createEnvironmentCliChoiceLabel(name, handle, branch)}`.value
    ), environmentUrl && outputInfo(outputContent`    ${environmentUrl}`.value);
  }), outputNewline();
}
var pluralizedEnvironments = ({
  environments,
  storefrontTitle
}) => pluralize(
  environments,
  (environments2) => `Showing ${environments2.length} environments for the Hydrogen storefront ${storefrontTitle}`,
  (_environment) => `Showing 1 environment for the Hydrogen storefront ${storefrontTitle}`,
  () => `There are no environments for the Hydrogen storefront ${storefrontTitle}`
);

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/env/pull.js
init_cjs_shims();

// ../../node_modules/.pnpm/diff@5.1.0/node_modules/diff/lib/index.mjs
init_cjs_shims();
function Diff() {
}
Diff.prototype = {
  diff: function(oldString, newString) {
    var options = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, callback = options.callback;
    typeof options == "function" && (callback = options, options = {}), this.options = options;
    var self2 = this;
    function done(value) {
      return callback ? (setTimeout(function() {
        callback(void 0, value);
      }, 0), !0) : value;
    }
    oldString = this.castInput(oldString), newString = this.castInput(newString), oldString = this.removeEmpty(this.tokenize(oldString)), newString = this.removeEmpty(this.tokenize(newString));
    var newLen = newString.length, oldLen = oldString.length, editLength = 1, maxEditLength = newLen + oldLen;
    options.maxEditLength && (maxEditLength = Math.min(maxEditLength, options.maxEditLength));
    var bestPath = [{
      newPos: -1,
      components: []
    }], oldPos = this.extractCommon(bestPath[0], newString, oldString, 0);
    if (bestPath[0].newPos + 1 >= newLen && oldPos + 1 >= oldLen)
      return done([{
        value: this.join(newString),
        count: newString.length
      }]);
    function execEditLength() {
      for (var diagonalPath = -1 * editLength; diagonalPath <= editLength; diagonalPath += 2) {
        var basePath = void 0, addPath = bestPath[diagonalPath - 1], removePath = bestPath[diagonalPath + 1], _oldPos = (removePath ? removePath.newPos : 0) - diagonalPath;
        addPath && (bestPath[diagonalPath - 1] = void 0);
        var canAdd = addPath && addPath.newPos + 1 < newLen, canRemove = removePath && 0 <= _oldPos && _oldPos < oldLen;
        if (!canAdd && !canRemove) {
          bestPath[diagonalPath] = void 0;
          continue;
        }
        if (!canAdd || canRemove && addPath.newPos < removePath.newPos ? (basePath = clonePath(removePath), self2.pushComponent(basePath.components, void 0, !0)) : (basePath = addPath, basePath.newPos++, self2.pushComponent(basePath.components, !0, void 0)), _oldPos = self2.extractCommon(basePath, newString, oldString, diagonalPath), basePath.newPos + 1 >= newLen && _oldPos + 1 >= oldLen)
          return done(buildValues(self2, basePath.components, newString, oldString, self2.useLongestToken));
        bestPath[diagonalPath] = basePath;
      }
      editLength++;
    }
    if (callback)
      (function exec2() {
        setTimeout(function() {
          if (editLength > maxEditLength)
            return callback();
          execEditLength() || exec2();
        }, 0);
      })();
    else
      for (; editLength <= maxEditLength; ) {
        var ret = execEditLength();
        if (ret)
          return ret;
      }
  },
  pushComponent: function(components, added, removed) {
    var last = components[components.length - 1];
    last && last.added === added && last.removed === removed ? components[components.length - 1] = {
      count: last.count + 1,
      added,
      removed
    } : components.push({
      count: 1,
      added,
      removed
    });
  },
  extractCommon: function(basePath, newString, oldString, diagonalPath) {
    for (var newLen = newString.length, oldLen = oldString.length, newPos = basePath.newPos, oldPos = newPos - diagonalPath, commonCount = 0; newPos + 1 < newLen && oldPos + 1 < oldLen && this.equals(newString[newPos + 1], oldString[oldPos + 1]); )
      newPos++, oldPos++, commonCount++;
    return commonCount && basePath.components.push({
      count: commonCount
    }), basePath.newPos = newPos, oldPos;
  },
  equals: function(left, right) {
    return this.options.comparator ? this.options.comparator(left, right) : left === right || this.options.ignoreCase && left.toLowerCase() === right.toLowerCase();
  },
  removeEmpty: function(array) {
    for (var ret = [], i = 0; i < array.length; i++)
      array[i] && ret.push(array[i]);
    return ret;
  },
  castInput: function(value) {
    return value;
  },
  tokenize: function(value) {
    return value.split("");
  },
  join: function(chars) {
    return chars.join("");
  }
};
function buildValues(diff2, components, newString, oldString, useLongestToken) {
  for (var componentPos = 0, componentLen = components.length, newPos = 0, oldPos = 0; componentPos < componentLen; componentPos++) {
    var component = components[componentPos];
    if (component.removed) {
      if (component.value = diff2.join(oldString.slice(oldPos, oldPos + component.count)), oldPos += component.count, componentPos && components[componentPos - 1].added) {
        var tmp = components[componentPos - 1];
        components[componentPos - 1] = components[componentPos], components[componentPos] = tmp;
      }
    } else {
      if (!component.added && useLongestToken) {
        var value = newString.slice(newPos, newPos + component.count);
        value = value.map(function(value2, i) {
          var oldValue = oldString[oldPos + i];
          return oldValue.length > value2.length ? oldValue : value2;
        }), component.value = diff2.join(value);
      } else
        component.value = diff2.join(newString.slice(newPos, newPos + component.count));
      newPos += component.count, component.added || (oldPos += component.count);
    }
  }
  var lastComponent = components[componentLen - 1];
  return componentLen > 1 && typeof lastComponent.value == "string" && (lastComponent.added || lastComponent.removed) && diff2.equals("", lastComponent.value) && (components[componentLen - 2].value += lastComponent.value, components.pop()), components;
}
function clonePath(path3) {
  return {
    newPos: path3.newPos,
    components: path3.components.slice(0)
  };
}
var characterDiff = new Diff();
var extendedWordChars = /^[A-Za-z\xC0-\u02C6\u02C8-\u02D7\u02DE-\u02FF\u1E00-\u1EFF]+$/, reWhitespace = /\S/, wordDiff = new Diff();
wordDiff.equals = function(left, right) {
  return this.options.ignoreCase && (left = left.toLowerCase(), right = right.toLowerCase()), left === right || this.options.ignoreWhitespace && !reWhitespace.test(left) && !reWhitespace.test(right);
};
wordDiff.tokenize = function(value) {
  for (var tokens = value.split(/([^\S\r\n]+|[()[\]{}'"\r\n]|\b)/), i = 0; i < tokens.length - 1; i++)
    !tokens[i + 1] && tokens[i + 2] && extendedWordChars.test(tokens[i]) && extendedWordChars.test(tokens[i + 2]) && (tokens[i] += tokens[i + 2], tokens.splice(i + 1, 2), i--);
  return tokens;
};
var lineDiff = new Diff();
lineDiff.tokenize = function(value) {
  var retLines = [], linesAndNewlines = value.split(/(\n|\r\n)/);
  linesAndNewlines[linesAndNewlines.length - 1] || linesAndNewlines.pop();
  for (var i = 0; i < linesAndNewlines.length; i++) {
    var line = linesAndNewlines[i];
    i % 2 && !this.options.newlineIsToken ? retLines[retLines.length - 1] += line : (this.options.ignoreWhitespace && (line = line.trim()), retLines.push(line));
  }
  return retLines;
};
function diffLines(oldStr, newStr, callback) {
  return lineDiff.diff(oldStr, newStr, callback);
}
var sentenceDiff = new Diff();
sentenceDiff.tokenize = function(value) {
  return value.split(/(\S.+?[.!?])(?=\s+|$)/);
};
var cssDiff = new Diff();
cssDiff.tokenize = function(value) {
  return value.split(/([{}:;,]|\s+)/);
};
function _typeof(obj) {
  "@babel/helpers - typeof";
  return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? _typeof = function(obj2) {
    return typeof obj2;
  } : _typeof = function(obj2) {
    return obj2 && typeof Symbol == "function" && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
  }, _typeof(obj);
}
var objectPrototypeToString = Object.prototype.toString, jsonDiff = new Diff();
jsonDiff.useLongestToken = !0;
jsonDiff.tokenize = lineDiff.tokenize;
jsonDiff.castInput = function(value) {
  var _this$options = this.options, undefinedReplacement = _this$options.undefinedReplacement, _this$options$stringi = _this$options.stringifyReplacer, stringifyReplacer = _this$options$stringi === void 0 ? function(k, v) {
    return typeof v > "u" ? undefinedReplacement : v;
  } : _this$options$stringi;
  return typeof value == "string" ? value : JSON.stringify(canonicalize(value, null, null, stringifyReplacer), stringifyReplacer, "  ");
};
jsonDiff.equals = function(left, right) {
  return Diff.prototype.equals.call(jsonDiff, left.replace(/,([\r\n])/g, "$1"), right.replace(/,([\r\n])/g, "$1"));
};
function canonicalize(obj, stack, replacementStack, replacer, key) {
  stack = stack || [], replacementStack = replacementStack || [], replacer && (obj = replacer(key, obj));
  var i;
  for (i = 0; i < stack.length; i += 1)
    if (stack[i] === obj)
      return replacementStack[i];
  var canonicalizedObj;
  if (objectPrototypeToString.call(obj) === "[object Array]") {
    for (stack.push(obj), canonicalizedObj = new Array(obj.length), replacementStack.push(canonicalizedObj), i = 0; i < obj.length; i += 1)
      canonicalizedObj[i] = canonicalize(obj[i], stack, replacementStack, replacer, key);
    return stack.pop(), replacementStack.pop(), canonicalizedObj;
  }
  if (obj && obj.toJSON && (obj = obj.toJSON()), _typeof(obj) === "object" && obj !== null) {
    stack.push(obj), canonicalizedObj = {}, replacementStack.push(canonicalizedObj);
    var sortedKeys = [], _key;
    for (_key in obj)
      obj.hasOwnProperty(_key) && sortedKeys.push(_key);
    for (sortedKeys.sort(), i = 0; i < sortedKeys.length; i += 1)
      _key = sortedKeys[i], canonicalizedObj[_key] = canonicalize(obj[_key], stack, replacementStack, replacer, _key);
    stack.pop(), replacementStack.pop();
  } else
    canonicalizedObj = obj;
  return canonicalizedObj;
}
var arrayDiff = new Diff();
arrayDiff.tokenize = function(value) {
  return value.slice();
};
arrayDiff.join = arrayDiff.removeEmpty = function(value) {
  return value;
};

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/env/pull.js
var EnvPull = class _EnvPull extends base_command_default {
  static descriptionWithMarkdown = "Pulls environment variables from the linked Hydrogen storefront and writes them to an `.env` file.";
  static description = "Populate your .env with variables from your Hydrogen storefront.";
  static flags = {
    ...commonFlags.env,
    ...commonFlags.envBranch,
    ...commonFlags.envFile,
    ...commonFlags.path,
    ...commonFlags.force
  };
  async run() {
    let { flags } = await this.parse(_EnvPull);
    await runEnvPull({ ...flagsToCamelObject(flags) });
  }
};
async function runEnvPull({
  env: envHandle,
  envBranch,
  path: root = process.cwd(),
  envFile,
  force
}) {
  let [{ session, config: config2 }, cliCommand] = await Promise.all([
    login(root),
    getCliCommand()
  ]), linkedStorefront = await verifyLinkedStorefront({
    root,
    session,
    config: config2,
    cliCommand
  });
  if (!linkedStorefront)
    return;
  if (config2.storefront = linkedStorefront, envHandle || envBranch) {
    let environments = (await getStorefrontEnvironments(session, config2.storefront.id))?.environments || [];
    envHandle ? findEnvironmentOrThrow(environments, envHandle) : envBranch && (envHandle = findEnvironmentByBranchOrThrow(
      environments,
      envBranch
    ).handle);
  }
  let storefront = await getStorefrontEnvVariables(
    session,
    config2.storefront.id,
    envHandle
  );
  if (!storefront) {
    renderMissingStorefront({
      session,
      storefront: config2.storefront,
      cliCommand
    });
    return;
  }
  if (!storefront.environmentVariables.length) {
    outputInfo("No environment variables found.");
    return;
  }
  let variables = storefront.environmentVariables;
  if (!variables.length)
    return;
  let fileName = source_default.whiteBright(envFile), dotEnvPath = resolvePath(root, envFile), fetchedEnv = {};
  if (variables.forEach(({ isSecret, key, value }) => {
    fetchedEnv[key] = isSecret ? '""' : value;
  }), await fileExists(dotEnvPath) && !force) {
    let existingEnv = await readFile(dotEnvPath), patchedEnv = patchEnvFile(existingEnv, fetchedEnv);
    if (existingEnv === patchedEnv) {
      renderInfo({
        body: `No changes to your ${fileName} file`
      });
      return;
    }
    let diff2 = diffLines(existingEnv, patchedEnv);
    if (!await renderConfirmationPrompt({
      confirmationMessage: "Yes, confirm changes",
      cancellationMessage: "No, make changes later",
      message: outputContent`We'll make the following changes to your ${fileName} file:

${outputToken.linesDiff(diff2)}
Continue?`.value
    }))
      return;
    await writeFile(dotEnvPath, patchedEnv);
  } else {
    let newEnv = patchEnvFile(null, fetchedEnv);
    await writeFile(dotEnvPath, newEnv);
  }
  variables.some(({ isSecret }) => isSecret) && renderWarning({
    body: `${config2.storefront.title} contains environment variables marked as secret, so their values weren\u2019t pulled.`
  }), renderSuccess({
    body: ["Changes have been made to your", { filePath: fileName }, "file"]
  });
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/env/push.js
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/graphql/admin/push-variables.js
init_cjs_shims();
var PushVariablesMutation = `#graphql
  mutation PushVariables(
    $storefrontId: ID!,
    $environmentId: ID!,
    $environmentVariablesInput: [HydrogenStorefrontEnvironmentVariableInput!]!,
  ) {
    hydrogenStorefrontEnvironmentVariableBulkReplace(
      storefrontId: $storefrontId,
      environmentId: $environmentId,
      environmentVariablesInput: $environmentVariablesInput,
    ) {
      userErrors {
        code
        message
      }
    }
  }
`;
async function pushStorefrontEnvVariables(adminSession, storefrontId, environmentId, variables) {
  let { hydrogenStorefrontEnvironmentVariableBulkReplace } = await adminRequest(
    PushVariablesMutation,
    adminSession,
    {
      storefrontId,
      environmentId,
      environmentVariablesInput: variables
    }
  ), { userErrors } = hydrogenStorefrontEnvironmentVariableBulkReplace;
  return { userErrors };
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/env/push.js
var EnvPush = class _EnvPush extends base_command_default {
  static description = "Push environment variables from the local .env file to your linked Hydrogen storefront.";
  static flags = {
    ...commonFlags.env,
    ...commonFlags.envFile,
    ...commonFlags.path
  };
  async run() {
    let { flags } = await this.parse(_EnvPush);
    await runEnvPush({ ...flagsToCamelObject(flags) });
  }
};
async function runEnvPush({
  env: envHandle,
  envFile,
  path: path3 = process.cwd()
}) {
  let validatedEnvironment, dotEnvPath = resolvePath(path3, envFile), { variables: localVariables } = await readAndParseDotEnv(dotEnvPath), [{ session, config: config2 }, cliCommand] = await Promise.all([
    login(path3),
    getCliCommand()
  ]), linkedStorefront = await verifyLinkedStorefront({
    root: path3,
    session,
    config: config2,
    cliCommand
  });
  if (!linkedStorefront)
    return;
  config2.storefront = linkedStorefront;
  let { environments: environmentsData } = await getStorefrontEnvironments(session, config2.storefront.id) ?? {};
  if (!environmentsData)
    throw new AbortError("Failed to fetch environments");
  let environments = orderEnvironmentsBySafety(environmentsData);
  if (environments.length === 0)
    throw new AbortError("No environments found");
  if (envHandle)
    validatedEnvironment = findEnvironmentOrThrow(environments, envHandle);
  else {
    let choices = [
      ...environments.map(({ id, name, branch, handle }) => ({
        label: createEnvironmentCliChoiceLabel(name, handle, branch),
        value: id
      }))
    ], pushToBranchSelection = await renderSelectPrompt({
      message: "Select an environment to overwrite its environment variables:",
      choices
    });
    validatedEnvironment = environments.find(
      ({ id }) => id === pushToBranchSelection
    );
  }
  let { environmentVariables: environmentVariables2 = [] } = await getStorefrontEnvVariables(
    session,
    config2.storefront.id,
    validatedEnvironment.handle
  ) ?? {}, comparableRemoteVars = environmentVariables2.filter(
    ({ isSecret, readOnly }) => !isSecret && !readOnly
  ).sort((a, b) => a.key.localeCompare(b.key)).map(({ key, value }) => createDotEnvFileLine(key, value)).join(`
`) + `
`, compareableLocalVars = Object.keys(localVariables).sort((a, b) => a.localeCompare(b)).reduce((acc, key) => {
    let { isSecret, readOnly } = environmentVariables2.find((variable) => variable.key === key) ?? {};
    return isSecret || readOnly ? acc : [...acc, createDotEnvFileLine(key, localVariables[key])];
  }, []).join(`
`) + `
`;
  if (!validatedEnvironment.name)
    throw new AbortError("Missing environment name");
  let remoteReadOnlyOrSecrets = environmentVariables2.reduce(
    (acc, { isSecret, readOnly, key }) => {
      if (!isSecret && !readOnly)
        return acc;
      let localVar = localVariables[key], remoteVar = environmentVariables2.find(
        (variable) => variable.key === key
      );
      return localVar === remoteVar?.value ? acc : [...acc, key];
    },
    []
  );
  if (remoteReadOnlyOrSecrets.length && outputWarn(
    `Variables that are read only or contain secret values cannot be pushed from the CLI: ${remoteReadOnlyOrSecrets.join(
      ", "
    )}.
`
  ), compareableLocalVars === comparableRemoteVars) {
    renderInfo({
      body: "No changes to your environment variables."
    });
    return;
  } else {
    let diff2 = diffLines(comparableRemoteVars, compareableLocalVars);
    if (!await renderConfirmationPrompt({
      confirmationMessage: "Yes, confirm changes",
      cancellationMessage: "No, make changes later",
      message: outputContent`We'll make the following changes to your environment variables for ${validatedEnvironment.name}:

${outputToken.linesDiff(diff2)}
Continue?`.value
    }))
      return;
  }
  if (!validatedEnvironment.id)
    throw new AbortError("Missing environment ID");
  let { userErrors } = await pushStorefrontEnvVariables(
    session,
    config2.storefront.id,
    validatedEnvironment.id,
    Object.entries(localVariables).map(([key, value]) => ({ key, value }))
  );
  if (userErrors.length)
    throw new AbortError(
      "Failed to upload and save environment variables.",
      userErrors[0]?.message
    );
  renderSuccess({
    body: `Environment variables push to ${validatedEnvironment.name ?? "Preview"} was successful.`
  });
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/g.js
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/generate/route.js
init_cjs_shims();
var import_core23 = __toESM(require_lib(), 1);
var GenerateRoute2 = class _GenerateRoute extends base_command_default {
  static descriptionWithMarkdown = "Generates a set of default routes from the starter template.";
  static description = "Generates a standard Shopify route.";
  static flags = {
    adapter: import_core23.Flags.string({
      description: "Remix adapter used in the route. The default is `@shopify/remix-oxygen`.",
      env: "SHOPIFY_HYDROGEN_FLAG_ADAPTER"
    }),
    typescript: import_core23.Flags.boolean({
      description: "Generate TypeScript files",
      env: "SHOPIFY_HYDROGEN_FLAG_TYPESCRIPT"
    }),
    "locale-param": import_core23.Flags.string({
      description: "The param name in Remix routes for the i18n locale, if any. Example: `locale` becomes ($locale).",
      env: "SHOPIFY_HYDROGEN_FLAG_ADAPTER"
    }),
    ...commonFlags.force,
    ...commonFlags.path
  };
  static hidden;
  static args = {
    routeName: import_core23.Args.string({
      name: "routeName",
      description: `The route to generate. One of ${ALL_ROUTE_CHOICES.join()}.`,
      required: !0,
      options: ALL_ROUTE_CHOICES,
      env: "SHOPIFY_HYDROGEN_ARG_ROUTE"
    })
  };
  async run() {
    let {
      flags,
      args: { routeName }
    } = await this.parse(_GenerateRoute), directory = flags.path ? resolvePath(flags.path) : process.cwd();
    await runGenerate({
      ...flags,
      directory,
      routeName,
      localePrefix: flags["locale-param"]
    });
  }
};
async function runGenerate(options) {
  let { routes } = await generateRoutes({
    ...options,
    v1RouteConvention: isV1RouteConventionInstalled()
  }), padEnd = 3 + routes.reduce(
    (acc, route) => Math.max(acc, route.destinationRoute.length),
    0
  ), successfulGenerationCount = routes.filter(
    ({ operation }) => operation !== "skipped"
  ).length;
  renderSuccess({
    headline: `${successfulGenerationCount} of ${routes.length} route${routes.length > 1 ? "s" : ""} generated`,
    body: {
      list: {
        items: routes.map(
          ({ operation, destinationRoute }) => destinationRoute.padEnd(padEnd) + source_default.dim(`[${operation}]`)
        )
      }
    }
  });
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/g.js
var GenerateRouteShortcut = class extends base_command_default {
  static description = "Shortcut for `hydrogen generate`. See `hydrogen generate --help` for more information.";
  static strict = !1;
  static hidden = !0;
  async run() {
    let [command, ...args] = this.argv;
    if (command === "r" || command === "route")
      return new GenerateRoute2(args, this.config).run();
    throw new Error(`Invalid command argument "${command}".`);
  }
};

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/generate/routes.js
init_cjs_shims();
var GenerateRoutes = class _GenerateRoutes extends base_command_default {
  static description = "Generates all supported standard shopify routes.";
  static hidden;
  static flags = GenerateRoute2.flags;
  async run() {
    let { flags } = await this.parse(_GenerateRoutes);
    await GenerateRoute2.run([
      "all",
      ...Object.entries(flags).map(([name, value]) => value === !0 ? `--${name}` : `--${name}=${value}`)
    ]);
  }
};

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/init.js
init_cjs_shims();
var import_core24 = __toESM(require_lib(), 1);

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/check-cli-version.js
init_cjs_shims();
import { fileURLToPath as fileURLToPath4 } from "node:url";
var UPGRADABLE_CLI_NAMES = {
  cli: "@shopify/cli",
  cliHydrogen: "@shopify/cli-hydrogen",
  createApp: "@shopify/create-hydrogen"
};
async function checkCurrentCLIVersion() {
  if (isHydrogenMonorepo && !process.env.SHOPIFY_UNIT_TEST)
    return;
  let { content: pkgJson } = await findUpAndReadPackageJson(
    fileURLToPath4(import.meta.url)
  ).catch(() => ({ content: void 0 })), pkgName = pkgJson?.name, currentVersion = pkgJson?.version;
  if (!pkgName || !currentVersion || !Object.values(UPGRADABLE_CLI_NAMES).some((name) => name === pkgName) || currentVersion.includes("next") || currentVersion.includes("experimental") || currentVersion.includes("snapshot"))
    return;
  let newVersionAvailable = await checkForNewVersion(pkgName, currentVersion);
  if (!newVersionAvailable)
    return;
  let reference = [
    {
      link: {
        label: "Hydrogen releases",
        url: "https://github.com/Shopify/hydrogen/releases"
      }
    }
  ];
  return pkgName === UPGRADABLE_CLI_NAMES.cli && reference.push({
    link: {
      label: "Global CLI reference",
      url: "https://shopify.dev/docs/api/shopify-cli/"
    }
  }), (packageManager2) => {
    packageManager2 ??= packageManagerFromUserAgent(), (packageManager2 === "unknown" || !packageManager2) && (packageManager2 = inferPackageManagerForGlobalCLI()), packageManager2 === "unknown" && (packageManager2 = "npm");
    let installMessage = pkgName === UPGRADABLE_CLI_NAMES.cli ? `Please install the latest Shopify CLI version with \`${packageManager2 === "yarn" ? `yarn global add ${UPGRADABLE_CLI_NAMES.cli}` : `${packageManager2} install -g ${UPGRADABLE_CLI_NAMES.cli}`}\` and try again.` : `Please use the latest version with \`${packageManager2} create @shopify/hydrogen@latest\``;
    return renderInfo({
      headline: "Upgrade available",
      body: `Version ${newVersionAvailable} of ${pkgName} is now available.
You are currently running v${currentVersion}.

` + installMessage,
      reference
    }), { currentVersion, newVersion: newVersionAvailable };
  };
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/onboarding/index.js
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/onboarding/local.js
init_cjs_shims();
import { cp as cp2 } from "node:fs/promises";
async function setupLocalStarterTemplate(options, controller) {
  let templateAction = options.mockShop ? "mock" : await renderSelectPrompt({
    message: "Connect to Shopify",
    choices: [
      {
        label: "Use sample data from mock.shop (You can connect a Shopify account later)",
        value: "mock"
      },
      { label: "Link your Shopify account", value: "link" }
    ],
    defaultValue: "mock",
    abortSignal: controller.signal
  }), storefrontInfo = templateAction === "link" ? await handleStorefrontLink(controller) : void 0, project = await handleProjectLocation({
    ...options,
    storefrontInfo,
    controller
  });
  if (!project)
    return;
  templateAction === "mock" && (project.storefrontTitle = "Mock.shop");
  let abort2 = createAbortHandler(controller, project), createStorefrontPromise = storefrontInfo && !storefrontInfo.id && createStorefront(storefrontInfo.session, storefrontInfo.title).then(async ({ storefront, jobId }) => (jobId && await waitForJob(storefrontInfo.session, jobId), storefront)).catch(abort2), templateDir = await getStarterDir(), backgroundWorkPromise = cp2(
    templateDir,
    project.directory,
    // Filter out the `app` directory and server.ts, which will be generated later
    {
      force: !0,
      recursive: !0,
      filter: (filepath) => !/^(app\/|dist\/|node_modules\/|server\.ts|\.shopify\/)/i.test(
        relativePath(templateDir, filepath)
      )
    }
  ).then(
    () => (
      // Generate project entries and their file dependencies
      generateProjectEntries({
        rootDirectory: project.directory,
        appDirectory: joinPath(project.directory, "app"),
        typescript: !0
        // Will be transpiled later
      })
    )
  ).catch(abort2), initMsg = {
    create: "Creating storefront",
    setup: `Setting up ${options.quickstart ? "Quickstart " : ""}project`,
    install: "Installing dependencies. This could take a few minutes"
  }, tasks = [
    {
      title: initMsg.create,
      task: async () => {
        await createStorefrontPromise;
      }
    },
    {
      title: initMsg.setup,
      task: async () => {
        await backgroundWorkPromise;
      }
    }
  ], cliCommand = await getCliCommand(), envLeadingComment = `# The variables added in this file are only available locally in MiniOxygen.
# Run \`${cliCommand} link\` to also inject environment variables from your storefront,
# or \`${cliCommand} env pull\` to populate this file.`;
  backgroundWorkPromise = backgroundWorkPromise.then(() => {
    let promises = [
      replaceFileContent(
        joinPath(project.directory, "package.json"),
        !1,
        (content) => (content = maybeInjectCliHydrogen(content), content.replace(
          /"name": "[^"]+"/,
          `"name": "${hyphenate(storefrontInfo?.title ?? project.name)}"`
        ))
      )
    ], storefrontToLink;
    return storefrontInfo ? (promises.push(
      // Save linked storefront in project
      setUserAccount(project.directory, storefrontInfo),
      // Write empty dotenv file to fallback to remote Oxygen variables
      writeFile(joinPath(project.directory, ".env"), envLeadingComment)
    ), storefrontInfo.id ? storefrontToLink = { id: storefrontInfo.id, title: storefrontInfo.title } : createStorefrontPromise && promises.push(
      createStorefrontPromise.then((createdStorefront) => {
        storefrontToLink = createdStorefront;
      })
    )) : templateAction === "mock" && promises.push(
      // Set required env vars
      writeFile(
        joinPath(project.directory, ".env"),
        envLeadingComment + `
` + [["SESSION_SECRET", "foobar"]].map(([key, value]) => `${key}="${value}"`).join(`
`) + `
`
      )
    ), Promise.all(promises).then(() => {
      if (storefrontToLink)
        return setStorefront(project.directory, storefrontToLink);
    }).catch(abort2);
  });
  let { language, transpileProject } = await handleLanguage(
    project.directory,
    controller,
    options.language
  );
  backgroundWorkPromise = backgroundWorkPromise.then(() => transpileProject().catch(abort2)).then(
    () => options.git ? createInitialCommit(project.directory) : void 0
  );
  let { setupCss, cssStrategy } = await handleCssStrategy(
    project.directory,
    controller,
    options.styling
  );
  cssStrategy && (backgroundWorkPromise = backgroundWorkPromise.then(() => setupCss().catch(abort2)).then(
    () => options.git ? commitAll(
      project.directory,
      "Setup " + CSS_STRATEGY_NAME_MAP[cssStrategy]
    ) : void 0
  ));
  let { packageManager: packageManager2, shouldInstallDeps, installDeps } = await handleDependencies(
    project.directory,
    controller,
    options.packageManager,
    options.installDeps
  ), setupSummary = {
    language,
    packageManager: packageManager2,
    cssStrategy,
    depsInstalled: !1,
    cliCommand: await getCliCommand("", packageManager2)
  };
  if (shouldInstallDeps) {
    let installingDepsPromise = backgroundWorkPromise.then(async () => {
      try {
        await installDeps(), setupSummary.depsInstalled = !0;
      } catch (error) {
        setupSummary.depsError = error;
      }
    });
    tasks.push({
      title: initMsg.install,
      task: async () => {
        await installingDepsPromise;
      }
    });
  }
  let { createShortcut, showShortcutBanner } = await handleCliShortcut(
    controller,
    setupSummary.cliCommand,
    options.shortcut
  );
  if (createShortcut && (backgroundWorkPromise = backgroundWorkPromise.then(async () => {
    await createShortcut() && (setupSummary.cliCommand = ALIAS_NAME);
  }), showShortcutBanner()), options.quickstart ? console.log(`
`) : renderSuccess({
    headline: [
      { userInput: storefrontInfo?.title ?? project.name },
      "is ready to build."
    ]
  }), (options.i18n ?? options.routes) !== void 0 || await renderConfirmationPrompt({
    message: "Do you want to scaffold routes and core functionality?",
    confirmationMessage: "Yes, set up now",
    cancellationMessage: "No, set up later " + source_default.dim(`(run \`${setupSummary.cliCommand} setup\`)`),
    abortSignal: controller.signal
  })) {
    let { i18nStrategy, setupI18n } = await handleI18n(
      controller,
      setupSummary.cliCommand,
      options.i18n
    ), { setupRoutes } = await handleRouteGeneration(
      controller,
      options.routes ?? !0
      // TODO: Remove default value when multi-select UI component is available
    );
    setupSummary.i18n = i18nStrategy, backgroundWorkPromise = backgroundWorkPromise.then(async () => {
      await setupI18n({
        rootDirectory: project.directory,
        contextCreate: language === "ts" ? "app/lib/context.ts" : "app/lib/context.js"
      }).then(
        () => options.git ? commitAll(
          project.directory,
          `Setup markets support using ${i18nStrategy}`
        ) : void 0
      ).catch((error) => {
        setupSummary.i18nError = error;
      }), await setupRoutes(project.directory, language, {
        i18nStrategy,
        // The init process might have added and modified files. Do not overwrite them.
        // E.g. CSS imports might have been added to the root.
        overwriteFileDeps: !1
      }).then((routes) => {
        if (setupSummary.routes = routes, options.git && routes)
          return commitAll(
            project.directory,
            "Generate routes for core functionality"
          );
      }).catch((error) => {
        setupSummary.routesError = error;
      });
    });
  }
  return await renderTasks(tasks), options.git && await commitAll(project.directory, "Lockfile"), await renderProjectReady(project, setupSummary), {
    ...project,
    ...setupSummary
  };
}
function maybeInjectCliHydrogen(pkgJsonContent) {
  let hydrogenDep = pkgJsonContent.match(
    /^\s+"@shopify\/hydrogen":\s+"[^"]+",\n/m
  )?.[0];
  if (hydrogenDep && /"0\.0\.0-\w+-/.test(hydrogenDep)) {
    let cliHydrogenDep = hydrogenDep.replace("hydrogen", "cli-hydrogen");
    pkgJsonContent = pkgJsonContent.replace(
      hydrogenDep,
      cliHydrogenDep + hydrogenDep
    );
  }
  return pkgJsonContent;
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/onboarding/remote.js
init_cjs_shims();
import { readdir } from "node:fs/promises";

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/template-downloader.js
init_cjs_shims();
var import_gunzip_maybe = __toESM(require_gunzip_maybe(), 1), import_tar_fs = __toESM(require_tar_fs(), 1);
import path2 from "node:path";
import { pipeline } from "stream/promises";

// ../cli-kit/dist/public/node/github.js
init_cjs_shims();
function parseGitHubRepositoryURL(url) {
  let match2 = /^(?:(?:https:\/\/)?([^:/]+\.[^:/]+)\/|git@([^:/]+)[:/]|([^/]+):)?([^/\s]+)\/([^/\s#]+)(?:((?:\/[^/\s#]+)+))?(?:\/)?(?:#(.+))?/.exec(url);
  if (!match2) {
    let exampleFormats = [
      "github:user/repo",
      "user/repo/subdirectory",
      "git@github.com:user/repo",
      "user/repo#dev",
      "https://github.com/user/repo"
    ];
    return err(new Error(`Parsing the url ${url} failed. Supported formats are ${exampleFormats.join(", ")}.`));
  }
  let site = match2[1] || match2[2] || match2[3] || "github.com", normalizedSite = site === "github" ? "github.com" : site, user = match2[4], name = match2[5].replace(/\.git$/, ""), subDirectory = match2[6]?.slice(1), ref = match2[7], branch = ref ? `#${ref}` : "", ssh = `git@${normalizedSite}:${user}/${name}`, http3 = `https://${normalizedSite}/${user}/${name}`, full = ["https:/", normalizedSite, user, name, subDirectory].join("/").concat(branch);
  return ok({ full, site: normalizedSite, user, name, ref, subDirectory, ssh, http: http3 });
}
function parseGitHubRepositoryReference(reference) {
  let url = new URL(reference), branch = url.hash ? url.hash.slice(1) : void 0, [_2, user, repo, ...repoPath] = url.pathname.split("/"), filePath = repoPath.length > 0 ? repoPath.join("/") : void 0;
  return {
    baseURL: `${url.origin}/${user}/${repo}`,
    branch,
    filePath
  };
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/template-downloader.js
var REPO_RELEASES_URL = "https://api.github.com/repos/shopify/hydrogen/releases/latest", getTryMessage = (status) => status === 403 ? "If you are using a VPN, WARP, or similar service, consider disabling it momentarily." : void 0;
async function getLatestReleaseDownloadUrl(signal) {
  let response = await fetch2(REPO_RELEASES_URL, { signal });
  if (!response.ok || response.status >= 400)
    throw new AbortError(
      `Failed to fetch the latest release information. Status ${response.status} ${response.statusText.replace(/\.$/, "")}.`,
      getTryMessage(response.status)
    );
  let release2 = await response.json();
  return {
    // @shopify/package-name@version => package-name@version
    version: release2.name.split("/").pop() ?? release2.name,
    url: release2.tarball_url
  };
}
async function downloadMonorepoTarball(url, storageDir, signal) {
  let response = await fetch2(url, { signal });
  if (!response.ok || response.status >= 400)
    throw new AbortError(
      `Failed to download the latest release files. Status ${response.status} ${response.statusText}}`,
      getTryMessage(response.status)
    );
  await pipeline(
    // Download
    response.body,
    // Decompress
    (0, import_gunzip_maybe.default)(),
    // Unpack
    (0, import_tar_fs.extract)(storageDir, {
      strip: 1,
      filter: (name) => (name = name.replace(storageDir, ""), !name.startsWith(path2.normalize("/templates/")) && !name.startsWith(path2.normalize("/examples/")))
    })
  );
}
async function downloadMonorepoTemplates({
  signal
} = {}) {
  if (isHydrogenMonorepo && process.env.FORCE_TEMPLATES_SOURCE !== "remote") {
    let templatesDir = path2.dirname(getSkeletonSourceDir());
    return {
      version: "local",
      templatesDir,
      examplesDir: path2.resolve(templatesDir, "..", "examples")
    };
  }
  try {
    let { version: version2, url } = await getLatestReleaseDownloadUrl(signal), templateStoragePath = await getAssetsDir("internal-templates");
    await fileExists(templateStoragePath) || await mkdir(templateStoragePath);
    let templateStorageVersionPath = path2.join(templateStoragePath, version2);
    return await fileExists(templateStorageVersionPath) || await downloadMonorepoTarball(url, templateStorageVersionPath, signal), {
      version: version2,
      templatesDir: path2.join(templateStorageVersionPath, "templates"),
      examplesDir: path2.join(templateStorageVersionPath, "examples")
    };
  } catch (e) {
    let error = e;
    throw new AbortError(
      `Could not download Hydrogen templates from GitHub.
Please check your internet connection and the following error:

` + error.message,
      error.tryMessage
    );
  }
}
async function downloadExternalRepo(appTemplate, signal) {
  let parsed = parseGitHubRepositoryURL(appTemplate);
  if (parsed.isErr())
    throw new AbortError(parsed.error.message);
  let templateStoragePath = await getAssetsDir("external-templates");
  await fileExists(templateStoragePath) || await mkdir(templateStoragePath);
  let result = parsed.value, templateDir = joinPath(
    templateStoragePath,
    result.full.replace(/^https?:\/\//, "").replace(/[^\w]+/, "_")
  );
  return await fileExists(templateDir) && await rmdir(templateDir, { force: !0 }), await downloadGitRepository({
    repoUrl: result.full,
    destination: templateDir,
    shallow: !0
  }), await rmdir(joinPath(templateDir, ".git"), { force: !0 }), { templateDir };
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/onboarding/remote.js
var DEMO_STORE_REPO = "shopify/hydrogen-demo-store";
async function setupRemoteTemplate(options, controller) {
  let appTemplate = options.template === "demo-store" ? DEMO_STORE_REPO : options.template, abort2 = createAbortHandler(controller), backgroundDownloadPromise = appTemplate.includes("/") ? getExternalTemplate(appTemplate, controller.signal).catch(abort2) : getMonorepoTemplate(appTemplate, controller.signal).catch(abort2), project = await handleProjectLocation({ ...options, controller });
  if (!project)
    return;
  abort2 = createAbortHandler(controller, project);
  let downloaded = await backgroundDownloadPromise;
  if (controller.signal.aborted)
    return;
  let backgroundWorkPromise = Promise.resolve().then(async () => {
    if (controller.signal.aborted)
      return;
    let { sourcePath, skeletonPath } = downloaded;
    if ((await readAndParsePackageJson(
      joinPath(sourcePath, "package.json")
    )).scripts?.dev?.includes("--diff"))
      return applyTemplateDiff(project.directory, sourcePath, skeletonPath);
    await copyFile(sourcePath, project.directory), await replaceFileContent(
      joinPath(project.directory, "package.json"),
      !1,
      (content) => (
        // Remove the cli plugin dependency from the package.json because it's
        // only used for monorepo development. This line is present in non-diff
        // examples like `express` when scaffolding a new project:
        content.replace(/^\s*"@shopify\/cli-hydrogen": "[^"]+",?\n/m, "")
      )
    );
  }).catch(abort2), supportsTranspilation = await fileExists(
    joinPath(downloaded.sourcePath, "tsconfig.json")
  ), { language, transpileProject } = supportsTranspilation ? await handleLanguage(project.directory, controller, options.language) : { language: "js", transpileProject: () => Promise.resolve() };
  backgroundWorkPromise = backgroundWorkPromise.then(() => transpileProject().catch(abort2)).then(
    () => options.git ? createInitialCommit(project.directory) : void 0
  );
  let { packageManager: packageManager2, shouldInstallDeps, installDeps } = await handleDependencies(
    project.directory,
    controller,
    options.packageManager,
    options.installDeps
  ), setupSummary = {
    language,
    packageManager: packageManager2,
    depsInstalled: !1,
    cliCommand: await getCliCommand("", packageManager2)
  }, tasks = [
    {
      title: "Downloading template",
      task: async () => {
        await backgroundDownloadPromise;
      }
    },
    {
      title: "Setting up project",
      task: async () => {
        await backgroundWorkPromise;
      }
    }
  ];
  if (shouldInstallDeps && tasks.push({
    title: "Installing dependencies. This could take a few minutes",
    task: async () => {
      try {
        await installDeps(), setupSummary.depsInstalled = !0;
      } catch (error) {
        setupSummary.depsError = error;
      }
    }
  }), !controller.signal.aborted)
    return await renderTasks(tasks), options.git && await commitAll(project.directory, "Lockfile"), await renderProjectReady(project, setupSummary), renderInfo({
      headline: `Your project will display inventory from ${options.template.endsWith(DEMO_STORE_REPO) ? "the Hydrogen Demo Store" : "Mock.shop"}.`,
      body: `To connect this project to your Shopify store\u2019s inventory, update \`${project.name}/.env\` with your store ID and Storefront API key.`
    }), {
      ...project,
      ...setupSummary
    };
}
async function getExternalTemplate(appTemplate, signal) {
  let { templateDir } = await downloadExternalRepo(appTemplate, signal);
  return { sourcePath: templateDir };
}
async function getMonorepoTemplate(appTemplate, signal) {
  let { templatesDir, examplesDir } = await downloadMonorepoTemplates({
    signal
  }), skeletonPath = joinPath(templatesDir, "skeleton"), templatePath = joinPath(templatesDir, appTemplate), examplePath = joinPath(examplesDir, appTemplate);
  if (await fileExists(templatePath))
    return { skeletonPath, sourcePath: templatePath };
  if (await fileExists(examplePath))
    return { skeletonPath, sourcePath: examplePath };
  let availableTemplates = (await Promise.all([readdir(examplesDir), readdir(templatesDir)]).catch(
    () => []
  )).flat().filter((name) => name !== "skeleton" && !name.endsWith(".md")).concat("demo-store").sort();
  throw new AbortError(
    `Unknown value in \`--template\` flag "${appTemplate}".
Skip the flag or provide the name of a template or example in the Hydrogen repository or a URL to a git repository.`,
    availableTemplates.length === 0 ? "" : { list: { title: "Available templates:", items: availableTemplates } }
  );
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/onboarding/index.js
async function setupTemplate(options) {
  let controller = new AbortController2();
  try {
    let template2 = options.template;
    return template2 ? await setupRemoteTemplate({ ...options, template: template2 }, controller) : await setupLocalStarterTemplate(options, controller);
  } catch (error) {
    throw controller.abort(), error;
  }
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/init.js
var FLAG_MAP = { f: "force" }, Init2 = class _Init extends base_command_default {
  static descriptionWithMarkdown = "Creates a new Hydrogen storefront.";
  static description = "Creates a new Hydrogen storefront.";
  static flags = {
    ...commonFlags.force,
    path: import_core24.Flags.string({
      description: "The path to the directory of the new Hydrogen storefront.",
      env: "SHOPIFY_HYDROGEN_FLAG_PATH"
    }),
    language: import_core24.Flags.string({
      description: "Sets the template language to use. One of `js` or `ts`.",
      choices: Object.keys(LANGUAGES),
      env: "SHOPIFY_HYDROGEN_FLAG_LANGUAGE"
    }),
    template: import_core24.Flags.string({
      description: "Scaffolds project based on an existing template or example from the Hydrogen repository.",
      env: "SHOPIFY_HYDROGEN_FLAG_TEMPLATE"
    }),
    ...commonFlags.installDeps,
    "mock-shop": import_core24.Flags.boolean({
      description: "Use mock.shop as the data source for the storefront.",
      env: "SHOPIFY_HYDROGEN_FLAG_MOCK_DATA"
    }),
    ...commonFlags.styling,
    ...commonFlags.markets,
    ...commonFlags.shortcut,
    routes: import_core24.Flags.boolean({
      description: "Generate routes for all pages.",
      env: "SHOPIFY_HYDROGEN_FLAG_ROUTES",
      allowNo: !0
    }),
    git: import_core24.Flags.boolean({
      description: "Init Git and create initial commits.",
      env: "SHOPIFY_HYDROGEN_FLAG_GIT",
      default: !0,
      allowNo: !0
    }),
    quickstart: import_core24.Flags.boolean({
      description: "Scaffolds a new Hydrogen project with a set of sensible defaults. Equivalent to `shopify hydrogen init --path hydrogen-quickstart --mock-shop --language js --shortcut --routes --markets none`",
      env: "SHOPIFY_HYDROGEN_FLAG_QUICKSTART",
      default: !1
    }),
    "package-manager": import_core24.Flags.string({
      env: "SHOPIFY_HYDROGEN_FLAG_PACKAGE_MANAGER",
      hidden: !0,
      options: ["npm", "yarn", "pnpm", "unknown"]
    })
  };
  async run() {
    let { flags } = await this.parse(_Init);
    await runInit(flagsToCamelObject(flags));
  }
};
async function runInit({
  markets,
  ...options
} = parseProcessFlags(
  process.argv,
  FLAG_MAP
)) {
  if (supressNodeExperimentalWarnings(), !options.i18n && markets && (options.i18n = markets), options.i18n && !I18N_CHOICES.includes(options.i18n))
    throw new AbortError(
      `Invalid URL structure strategy: ${options.i18n}. Must be one of ${I18N_CHOICES.join(", ")}`
    );
  if (options.styling && !STYLING_CHOICES.includes(options.styling))
    throw new AbortError(
      `Invalid styling strategy: ${options.styling}. Must be one of ${STYLING_CHOICES.join(", ")}`
    );
  options.git ??= !0, options.quickstart && (options.i18n ??= "none", options.installDeps ??= !0, options.language ??= "js", options.mockShop ??= !0, options.path ??= "./hydrogen-quickstart", options.routes ??= !0, options.shortcut ??= !0, options.styling ??= "none");
  let showUpgrade = await checkCurrentCLIVersion();
  return showUpgrade && showUpgrade(options.packageManager), setupTemplate(options);
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/list.js
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/lib/graphql/admin/list-storefronts.js
init_cjs_shims();
var ListStorefrontsQuery = `#graphql
  query ListStorefronts {
    hydrogenStorefronts {
      id
      title
      productionUrl
      currentProductionDeployment {
        id
        createdAt
        commitMessage
      }
    }
  }
`;
async function getStorefrontsWithDeployment(adminSession) {
  let { hydrogenStorefronts } = await adminRequest(
    ListStorefrontsQuery,
    adminSession
  );
  return hydrogenStorefronts.map((storefront) => ({
    ...storefront,
    parsedId: parseGid(storefront.id)
  }));
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/list.js
var List2 = class _List extends base_command_default {
  static descriptionWithMarkdown = "Lists all remote Hydrogen storefronts available to link to your local development environment.";
  static description = "Returns a list of Hydrogen storefronts available on a given shop.";
  static flags = {
    ...commonFlags.path
  };
  async run() {
    let { flags } = await this.parse(_List);
    await runList(flags);
  }
};
async function runList({ path: root = process.cwd() }) {
  let { session } = await login(root), storefronts = await getStorefrontsWithDeployment(session);
  storefronts.length > 0 ? (outputNewline(), outputInfo(
    pluralizedStorefronts({
      storefronts,
      shop: session.storeFqdn
    }).toString()
  ), storefronts.forEach(
    ({ currentProductionDeployment, id, productionUrl, title }) => {
      outputNewline(), outputInfo(
        outputContent`${source_default.whiteBright(title)} ${source_default.dim(
          `(id: ${parseGid(id)})`
        )}`.value
      ), productionUrl && outputInfo(
        outputContent`    ${source_default.whiteBright(productionUrl)}`.value
      ), currentProductionDeployment && outputInfo(
        outputContent`    ${source_default.dim(
          formatDeployment(currentProductionDeployment)
        )}`.value
      );
    }
  )) : renderInfo({
    headline: "Hydrogen storefronts",
    body: "There are no Hydrogen storefronts on your Shop.",
    nextSteps: [
      `Ensure you are logged in to the correct shop (currently: ${session.storeFqdn})`,
      `Create a new Hydrogen storefront: Run \`${await getCliCommand(
        root
      )} link\` or visit ${newHydrogenStorefrontUrl(session)}`
    ]
  });
}
var dateFormat = new Intl.DateTimeFormat("default", {
  year: "numeric",
  month: "numeric",
  day: "numeric"
});
function formatDeployment(deployment) {
  let message = "";
  if (!deployment)
    return message;
  if (message += dateFormat.format(new Date(deployment.createdAt)), deployment.commitMessage) {
    let title = deployment.commitMessage.split(/\n/)[0];
    message += `, ${title}`;
  }
  return message;
}
var pluralizedStorefronts = ({
  storefronts,
  shop
}) => pluralize(
  storefronts,
  (storefronts2) => `Showing ${storefronts2.length} Hydrogen storefronts for the store ${shop}`,
  (_storefront) => `Showing 1 Hydrogen storefront for the store ${shop}`
);

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/login.js
init_cjs_shims();
var Login = class _Login extends base_command_default {
  static descriptionWithMarkdown = "Logs in to the specified shop and saves the shop domain to the project.";
  static description = "Login to your Shopify account.";
  static flags = {
    ...commonFlags.path,
    ...commonFlags.shop
  };
  async run() {
    let { flags } = await this.parse(_Login);
    await runLogin(flags);
  }
};
async function runLogin({
  path: root = process.cwd(),
  shop: shopFlag
}) {
  outputNewline(), enhanceAuthLogs(!0);
  let { config: config2 } = await login(root, shopFlag ?? !0);
  renderLoginSuccess(config2);
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/logout.js
init_cjs_shims();
var Logout2 = class _Logout extends base_command_default {
  static descriptionWithMarkdown = "Log out from the current shop.";
  static description = "Logout of your local session.";
  static flags = {
    ...commonFlags.path
  };
  async run() {
    let { flags } = await this.parse(_Logout);
    await runLogout(flags);
  }
};
async function runLogout({ path: root = process.cwd() }) {
  outputNewline(), await logout(root), renderSuccess({ body: "You are logged out from Shopify." });
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/preview.js
init_cjs_shims();
var import_core25 = __toESM(require_lib(), 1);
var Preview = class _Preview extends base_command_default {
  static descriptionWithMarkdown = "Runs a server in your local development environment that serves your Hydrogen app's production build. Requires running the [build](https://shopify.dev/docs/api/shopify-cli/hydrogen/hydrogen-build) command first.";
  static description = "Runs a Hydrogen storefront in an Oxygen worker for production.";
  static flags = {
    ...commonFlags.path,
    ...commonFlags.port,
    worker: deprecated("--worker", { isBoolean: !0 }),
    ...commonFlags.legacyRuntime,
    ...commonFlags.env,
    ...commonFlags.envBranch,
    ...commonFlags.envFile,
    ...commonFlags.inspectorPort,
    ...commonFlags.debug,
    ...commonFlags.verbose,
    // For building the app:
    build: import_core25.Flags.boolean({
      description: "Builds the app before starting the preview server."
    }),
    watch: import_core25.Flags.boolean({
      description: "Watches for changes and rebuilds the project.",
      dependsOn: ["build"]
    }),
    ...overrideFlag(commonFlags.entry, {
      entry: { dependsOn: ["build"] }
    }),
    ...overrideFlag(commonFlags.codegen, {
      codegen: { dependsOn: ["build"] }
    }),
    // Diff in preview only makes sense when combined with --build.
    // Without the build flag, preview only needs access to the existing
    // `dist` directory in the project, so there's no need to merge the
    // project with the skeleton template in a temporary directory.
    ...overrideFlag(commonFlags.diff, {
      diff: { dependsOn: ["build"] }
    })
  };
  async run() {
    let { flags } = await this.parse(_Preview), originalDirectory = flags.path ? resolvePath(flags.path) : process.cwd(), diff2 = flags.build && flags.diff ? await prepareDiffDirectory(originalDirectory, flags.watch) : void 0, directory = diff2?.targetDirectory ?? originalDirectory, { close } = await runPreview({
      ...flagsToCamelObject(flags),
      directory
    });
    setupResourceCleanup(async () => {
      await close(), diff2 && (await diff2.copyDiffBuild(), flags.codegen && await diff2.copyDiffCodegen(), await diff2.cleanup());
    });
  }
};
async function runPreview({
  port: appPort2,
  directory,
  legacyRuntime = !1,
  env: envHandle,
  envBranch,
  inspectorPort,
  debug: debug4,
  verbose,
  build: shouldBuild = !1,
  watch = !1,
  codegen: useCodegen = !1,
  codegenConfigPath,
  entry,
  envFile
}) {
  process.env.NODE_ENV || (process.env.NODE_ENV = watch ? "development" : "production"), verbose && setH2OVerbose(), isH2Verbose() || muteDevLogs();
  let { root, buildPath, buildPathWorkerFile, buildPathClient } = getProjectPaths(directory), useClassicCompiler = await isClassicProject(root);
  if (watch && useClassicCompiler)
    throw new AbortError(
      "Preview in watch mode is not supported for classic Remix projects.",
      "Please use the dev command instead, which is the equivalent for classic projects."
    );
  let miniOxygen, projectBuild = deferPromise(), buildOptions = {
    directory: root,
    entry,
    disableRouteWarning: !1,
    lockfileCheck: !1,
    sourcemap: !0,
    bundleStats: !1,
    useCodegen,
    codegenConfigPath
  }, buildProcess = shouldBuild ? useClassicCompiler ? await runClassicCompilerBuild({
    ...buildOptions
  }).then(projectBuild.resolve) : await runBuild({
    ...buildOptions,
    watch,
    async onServerBuildFinish() {
      projectBuild.state === "pending" ? projectBuild.resolve() : outputInfo("\u{1F3D7}\uFE0F  Project rebuilt. Reloading server..."), await miniOxygen?.reload();
    }
  }) : projectBuild.resolve();
  useClassicCompiler || (buildPathWorkerFile = (await getViteConfig(root).catch(() => null))?.serverOutFile ?? joinPath(buildPath, "server", "index.js"));
  let { shop, storefront } = await getConfig(root), fetchRemote = !!shop && !!storefront?.id, { allVariables, logInjectedVariables } = await getAllEnvironmentVariables(
    {
      root,
      fetchRemote,
      envBranch,
      envHandle,
      envFile
    }
  );
  appPort2 || (appPort2 = await findPort(DEFAULT_APP_PORT));
  let assetsPort = legacyRuntime ? 0 : await findPort(appPort2 + 100);
  return await projectBuild.promise, logInjectedVariables(), miniOxygen = await startMiniOxygen(
    {
      root,
      appPort: appPort2,
      assetsPort,
      env: allVariables,
      buildPathClient,
      buildPathWorkerFile,
      inspectorPort,
      debug: debug4,
      watch
    },
    legacyRuntime
  ), miniOxygen.showBanner({
    mode: "preview",
    headlinePrefix: watch ? "Watching for changes. " : ""
  }), {
    async close() {
      await Promise.allSettled([miniOxygen.close(), buildProcess?.close()]);
    }
  };
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/setup.js
init_cjs_shims();
var Setup = class _Setup extends base_command_default {
  static description = "Scaffold routes and core functionality.";
  static flags = {
    ...commonFlags.path,
    ...commonFlags.force,
    ...commonFlags.markets,
    ...commonFlags.shortcut,
    ...overrideFlag(commonFlags.installDeps, {
      "install-deps": { default: !0 }
    })
  };
  async run() {
    let { flags } = await this.parse(_Setup), directory = flags.path ? resolvePath(flags.path) : process.cwd();
    await runSetup({
      ...flagsToCamelObject(flags),
      directory
    });
  }
};
async function runSetup(options) {
  let controller = new AbortController2(), { rootDirectory, appDirectory } = await getRemixConfig(options.directory), location2 = basename(rootDirectory), cliCommandPromise = getCliCommand(), backgroundWorkPromise = Promise.resolve(), tasks = [
    {
      title: "Setting up project",
      task: async () => {
        await backgroundWorkPromise;
      }
    }
  ], i18nStrategy = options.markets ? options.markets : await renderI18nPrompt({
    abortSignal: controller.signal,
    extraChoices: { none: "Set up later" }
  }), i18n = i18nStrategy === "none" ? void 0 : i18nStrategy, { needsRouteGeneration, setupRoutes } = await handleRouteGeneration(
    controller
  ), routes;
  if (needsRouteGeneration) {
    let templateRoot = await getTemplateAppFile(".."), [typescript, dtsFiles] = await Promise.all([
      fileExists(joinPath(rootDirectory, "tsconfig.json")),
      glob("*.d.ts", { cwd: templateRoot })
    ]);
    backgroundWorkPromise = backgroundWorkPromise.then(
      () => Promise.all([
        ...dtsFiles.map(
          (filename) => copyFile(
            joinPath(templateRoot, filename),
            resolvePath(rootDirectory, filename)
          )
        ),
        // Copy app entries
        generateProjectEntries({
          rootDirectory,
          appDirectory,
          typescript
        })
      ])
    ).then(async () => {
      routes = await setupRoutes(rootDirectory, typescript ? "ts" : "js", {
        i18nStrategy: i18n,
        // User might have added files before running this command.
        // We should overwrite them to ensure the routes are set up correctly.
        // Relies on Git to restore the files if needed.
        overwriteFileDeps: !0
      });
    });
  }
  i18n && (backgroundWorkPromise = backgroundWorkPromise.then(
    () => setupI18nStrategy(i18n, { rootDirectory })
  ));
  let cliCommand = await Promise.resolve(cliCommandPromise), { createShortcut, showShortcutBanner } = await handleCliShortcut(
    controller,
    cliCommand,
    options.shortcut
  );
  !i18n && !needsRouteGeneration && !createShortcut || (createShortcut && (backgroundWorkPromise = backgroundWorkPromise.then(async () => {
    await createShortcut() && (cliCommand = ALIAS_NAME);
  }), showShortcutBanner()), await renderTasks(tasks), await renderProjectReady(
    {
      location: location2,
      name: location2,
      directory: rootDirectory
    },
    {
      cliCommand,
      depsInstalled: !0,
      packageManager: "npm",
      i18n,
      routes
    }
  ));
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/setup/css.js
init_cjs_shims();
var import_core26 = __toESM(require_lib(), 1);
var SetupCSS = class _SetupCSS extends base_command_default {
  static descriptionWithMarkdown = "Adds support for certain CSS strategies to your project.";
  static description = "Setup CSS strategies for your project.";
  static flags = {
    ...commonFlags.path,
    ...commonFlags.force,
    ...overrideFlag(commonFlags.installDeps, { "install-deps": { default: !0 } })
  };
  static args = {
    strategy: import_core26.Args.string({
      name: "strategy",
      description: `The CSS strategy to setup. One of ${SETUP_CSS_STRATEGIES.join()}`,
      options: SETUP_CSS_STRATEGIES
    })
  };
  async run() {
    let { flags, args } = await this.parse(_SetupCSS), directory = flags.path ? resolvePath(flags.path) : process.cwd();
    await runSetupCSS({
      ...flagsToCamelObject(flags),
      strategy: args.strategy,
      directory
    });
  }
};
async function runSetupCSS({
  strategy: flagStrategy,
  directory,
  force = !1,
  installDeps = !0
}) {
  let viteConfig = await getViteConfig(directory).catch(() => null);
  if (!viteConfig)
    throw new AbortError(
      "No Vite config found. This command is only supported in Vite projects."
    );
  let { remixConfig } = viteConfig, strategy = flagStrategy || await renderCssPrompt();
  if (strategy === "css-modules" || strategy === "postcss") {
    renderSuccess({
      headline: `Vite works out of the box with ${CSS_STRATEGY_NAME_MAP[strategy]}.`,
      body: `See the Vite documentation for more information:
${CSS_STRATEGY_HELP_URL_MAP[strategy]}`
    });
    return;
  }
  let setupOutput = await setupCssStrategy(strategy, remixConfig, force);
  if (!setupOutput)
    return;
  let { workPromise, generatedAssets, needsInstallDeps } = setupOutput, tasks = [
    {
      title: "Updating files",
      task: async () => {
        await workPromise;
      }
    }
  ], isNpm = !1;
  if (installDeps && needsInstallDeps) {
    let gettingPkgManagerPromise = getPackageManager(
      remixConfig.rootDirectory
    );
    tasks.push({
      title: "Installing new dependencies",
      task: async () => {
        let packageManager2 = await gettingPkgManagerPromise;
        isNpm = packageManager2 === "npm" || packageManager2 === "unknown", await installNodeModules({
          directory: remixConfig.rootDirectory,
          packageManager: packageManager2,
          args: []
        });
      }
    });
  }
  await renderTasks(tasks), renderSuccess({
    headline: `${CSS_STRATEGY_NAME_MAP[strategy]} setup complete.`,
    body: (generatedAssets.length > 0 ? `You can now modify CSS configuration in the following files:
` + generatedAssets.map((file) => `  - ${file}`).join(`
`) + `
` : "") + `
For more information, visit ${CSS_STRATEGY_HELP_URL_MAP[strategy]}`
  }), needsInstallDeps && isNpm && strategy === "tailwind" && renderWarning({
    body: [
      `Due to a bug in NPM, you might need to reinstall dependencies again.
Run`,
      { command: "npm install" }
    ]
  });
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/setup/markets.js
init_cjs_shims();
var import_core27 = __toESM(require_lib(), 1);
var SetupMarkets = class _SetupMarkets extends base_command_default {
  static descriptionWithMarkdown = "Adds support for multiple [markets](https://shopify.dev/docs/custom-storefronts/hydrogen/markets) to your project by using the URL structure.";
  static description = "Setup support for multiple markets in your project.";
  static flags = {
    ...commonFlags.path
  };
  static args = {
    strategy: import_core27.Args.string({
      name: "strategy",
      description: `The URL structure strategy to setup multiple markets. One of ${SETUP_I18N_STRATEGIES.join()}`,
      options: SETUP_I18N_STRATEGIES
    })
  };
  async run() {
    let { flags, args } = await this.parse(_SetupMarkets), directory = flags.path ? resolvePath(flags.path) : process.cwd();
    await runSetupMarkets({
      ...flagsToCamelObject(flags),
      strategy: args.strategy,
      directory
    });
  }
};
async function runSetupMarkets({
  strategy: flagStrategy,
  directory
}) {
  let remixConfigPromise = getRemixConfig(directory), strategy = flagStrategy || await renderI18nPrompt(), remixConfig = await remixConfigPromise;
  await renderTasks([
    {
      title: "Updating files",
      task: async () => {
        await setupI18nStrategy(strategy, remixConfig);
      }
    }
  ]), renderSuccess({
    headline: `Makerts support setup complete with strategy ${I18N_STRATEGY_NAME_MAP[strategy].toLocaleLowerCase()}.`,
    body: `You can now modify the supported locales in ${remixConfig.serverEntryPoint ?? "your server entry file."}
`
  });
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/setup/vite.js
init_cjs_shims();
var SetupVite = class _SetupVite extends base_command_default {
  static description = "EXPERIMENTAL: Upgrades the project to use Vite.";
  static flags = {
    ...commonFlags.path
  };
  async run() {
    let { flags } = await this.parse(_SetupVite), directory = flags.path ? resolvePath(flags.path) : process.cwd();
    await runSetupVite({
      ...flagsToCamelObject(flags),
      directory
    });
  }
}, tailwindPostCSSConfig = `export default {
  plugins: {
    tailwindcss: {},
    autoprefixer: {},
  },
};
`;
async function runSetupVite({ directory }) {
  if (outputNewline(), await hasViteConfig(directory))
    throw new AbortError("This project already has a Vite config file.");
  let [rawRemixConfig, pkgJson, formatOptions] = await Promise.all([
    getRawRemixConfig(directory),
    readAndParsePackageJson(joinPath(directory, "package.json")),
    getCodeFormatOptions(directory)
  ]), serverEntry = rawRemixConfig.server || "server.js", isTS = serverEntry.endsWith(".ts"), fileExt = isTS ? "tsx" : "jsx", viteAssets = await getAssetsDir("vite"), usesTailwind = !!rawRemixConfig.tailwind, postCssConfigPath = resolvePath(directory, "postcss.config.js"), handlePartialIssue = () => {
  }, backgroundWorkPromise = Promise.all([
    removeFile(resolvePath(directory, "remix.config.js")).catch(
      handlePartialIssue
    ),
    moveFile(
      resolvePath(directory, "remix.env.d.ts"),
      resolvePath(directory, "env.d.ts")
    ).then(
      () => replaceFileContent(
        resolvePath(directory, "env.d.ts"),
        !1,
        (content) => content.replace('types="@remix-run/dev"', 'types="vite/client"')
      )
    ).catch(handlePartialIssue),
    moveFile(
      resolvePath(directory, ".eslintrc.js"),
      resolvePath(directory, ".eslintrc.cjs")
    ).catch(handlePartialIssue),
    // Adjust PostCSS configuration:
    readFile(resolvePath(directory, "postcss.config.js")).then(async (postCssContent) => {
      !postCssContent.includes("tailwindcss") && usesTailwind && (postCssContent = await formatCode(
        postCssContent.replace(
          /(plugins:\s+{)/,
          `$1
    tailwindcss: {},`
        ),
        formatOptions
      ));
      let isCJS = postCssContent.includes("module.exports") || postCssContent.includes("exports.") || postCssContent.includes("require(");
      return writeFile(
        isCJS ? postCssConfigPath.replace(".js", ".cjs") : postCssConfigPath,
        postCssContent
      );
    }).catch(async () => {
      if (usesTailwind && !await fileExists(postCssConfigPath) && !await fileExists(postCssConfigPath.replace(".js", ".cjs")))
        return writeFile(postCssConfigPath, tailwindPostCSSConfig);
    }).catch(handlePartialIssue),
    // Adjust dependencies:
    mergePackageJson(viteAssets, directory, {
      onResult(pkgJson2) {
        return pkgJson2.dependencies && delete pkgJson2.dependencies["@remix-run/css-bundle"], pkgJson2.devDependencies && pkgJson2.devDependencies["@vanilla-extract/css"] && (pkgJson2.devDependencies["@vanilla-extract/vite-plugin"] = "^4.0.0", pkgJson2.devDependencies = Object.keys(pkgJson2.devDependencies).sort().reduce((acc, key) => (acc[key] = pkgJson2.devDependencies?.[key], acc), {})), pkgJson2;
      }
    }),
    // Build `vite.config.js` for the project:
    readFile(resolvePath(viteAssets, "vite.config.js")).then(
      async (viteConfigContent) => {
        !!pkgJson.devDependencies?.["@vanilla-extract/css"] && (viteConfigContent = viteConfigContent.replace(
          /\n\n/g,
          `
import {vanillaExtractPlugin} from '@vanilla-extract/vite-plugin';

`
        ).replace(/^(\s+)\],/m, `$1  vanillaExtractPlugin(),
$1],`));
        let { future, appDirectory, ignoredRouteFiles, routes } = rawRemixConfig;
        for (let flag of [
          "v3_fetcherPersist",
          "v3_throwAbortReason",
          "v3_relativeSplatPath"
        ])
          future?.[flag] || (viteConfigContent = viteConfigContent.replace(
            `${flag}: true`,
            `${flag}: false`
          ));
        appDirectory && appDirectory !== "app" && (viteConfigContent = viteConfigContent.replace(
          /^(\s+)(future:)/m,
          `$1appDirectory: '${appDirectory}',
$1$2`
        )), ignoredRouteFiles && (viteConfigContent = viteConfigContent.replace(
          /^(\s+)(future:)/m,
          `$1ignoredRouteFiles: ${JSON.stringify(ignoredRouteFiles)},
$1$2`
        )), routes && (viteConfigContent = viteConfigContent.replace(
          /^(\s+)(future:)/m,
          `$1routes: ${routes.toString()},
$1$2`
        ));
        let viteConfigPath = resolvePath(
          directory,
          "vite.config." + fileExt.slice(0, 2)
        );
        return viteConfigContent = await formatCode(
          viteConfigContent,
          formatOptions,
          viteConfigPath
        ), writeFile(viteConfigPath, viteConfigContent);
      }
    ),
    // Adjust server entry:
    replaceFileContent(
      resolvePath(directory, serverEntry),
      !1,
      (content) => (isTS ? `// @ts-ignore
` : "") + content.replace(
        "@remix-run/dev/server-build",
        "virtual:remix/server-build"
      )
    ),
    // Adjust CSS imports in the project routes:
    importLangAstGrep(fileExt).then(async (astGrep) => {
      let appDirectory = resolvePath(
        directory,
        rawRemixConfig.appDirectory ?? "app"
      ), rootFilepath = joinPath(appDirectory, "root." + fileExt);
      await new Promise(async (resolve2, reject) => {
        await astGrep.findInFiles(
          {
            paths: [rootFilepath, joinPath(appDirectory, "routes")],
            matcher: {
              rule: {
                kind: "string_fragment",
                regex: "\\.css$",
                inside: {
                  kind: "import_statement",
                  stopBy: "end"
                }
              }
            }
          },
          async (err2, nodes) => {
            err2 && reject(err2);
            let nodeMap = {};
            nodes.forEach((node) => {
              if (node.text().endsWith(".module.css"))
                return;
              let filename = node.getRoot().filename(), content = node.getRoot().root().text(), position = node.range().end.index, tmp = nodeMap[filename] || { content, positions: [] };
              tmp.positions.push(position), nodeMap[filename] = tmp;
            }), await Promise.all(
              Object.entries(nodeMap).flatMap(
                ([filename, { content, positions }]) => {
                  positions.reverse();
                  for (let position of positions)
                    content = content.slice(0, position) + "?url" + content.slice(position);
                  return writeFile(filename, content);
                }
              )
            ), resolve2(null);
          }
        ) === 0 && resolve2(null);
      }), await replaceFileContent(rootFilepath, formatOptions, (content) => {
        let root = astGrep.parse(content).root(), liveReloadRegex = "LiveReload", hasLiveReloadRule = {
          kind: "identifier",
          regex: liveReloadRegex
        }, liveReloadImport = root.find({
          rule: {
            kind: "import_specifier",
            regex: liveReloadRegex,
            inside: {
              kind: "import_statement",
              stopBy: "end"
            }
          }
        }), liveReloadElements = root.findAll({
          rule: {
            any: [
              {
                kind: "jsx_self_closing_element",
                has: hasLiveReloadRule
              },
              {
                kind: "jsx_element",
                has: {
                  kind: "jsx_opening_element",
                  has: hasLiveReloadRule
                }
              }
            ]
          }
        });
        for (let node of [
          // From bottom to top
          ...liveReloadElements.reverse(),
          liveReloadImport
        ]) {
          if (!node)
            continue;
          let { start, end } = node.range();
          content = content.slice(0, start.index) + content.slice(end.index);
        }
        return content.replace(/,\s*,/g, ",").replace(
          /import\s+{\s+cssBundleHref\s+}\s+from\s+['"]@remix-run\/css-bundle['"];?\n/,
          ""
        ).replace(/\.\.\.\(\s*cssBundleHref[^)]+\),?/, "");
      });
    })
  ]);
  await renderTasks([
    {
      title: "Updating files",
      task: async () => {
        await backgroundWorkPromise;
      }
    },
    {
      title: "Installing new dependencies",
      task: async () => {
        await installNodeModules({
          directory,
          packageManager: await getPackageManager(directory),
          args: []
        });
      }
    }
  ]), renderSuccess({
    headline: "Your Vite project is ready!",
    body: `We've modified your project to use Vite.
Please use Git to review the changes.`,
    nextSteps: [
      rawRemixConfig.mdx ? "Setup MDX support in Vite: https://remix.run/docs/en/main/future/vite#add-mdx-plugin" : "",
      "See more information about Vite in Remix at https://remix.run/docs/en/main/future/vite"
    ].filter(Boolean)
  });
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/shortcut.js
init_cjs_shims();
var Shortcut = class extends base_command_default {
  static descriptionWithMarkdown = "Creates a global h2 shortcut for Shopify CLI using shell aliases.\n\n  The following shells are supported:\n\n  - Bash (using `~/.bashrc`)\n  - ZSH (using `~/.zshrc`)\n  - Fish (using `~/.config/fish/functions`)\n  - PowerShell (added to `$PROFILE`)\n\n  After the alias is created, you can call Shopify CLI from anywhere in your project using `h2 <command>`.";
  static description = `Creates a global \`${ALIAS_NAME}\` shortcut for the Hydrogen CLI`;
  async run() {
    await runCreateShortcut();
  }
};
async function runCreateShortcut() {
  let shortcuts = await createPlatformShortcut();
  shortcuts.length > 0 ? renderSuccess({
    headline: `Shortcut ready for the following shells: ${shortcuts.join(
      ", "
    )}.
Restart your terminal session and run \`${ALIAS_NAME}\` from your local project.`
  }) : renderFatalError({
    name: "error",
    type: 0,
    message: "No supported shell found.",
    skipOclifErrorHandling: !0,
    tryMessage: "Please create a shortcut manually."
  });
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/commands/hydrogen/unlink.js
init_cjs_shims();
var Unlink = class _Unlink extends base_command_default {
  static descriptionWithMarkdown = "Unlinks your local development environment from a remote Hydrogen storefront.";
  static description = "Unlink a local project from a Hydrogen storefront.";
  static flags = {
    ...commonFlags.path
  };
  async run() {
    let { flags } = await this.parse(_Unlink);
    await unlinkStorefront(flags);
  }
};
async function unlinkStorefront({ path: path3 }) {
  let actualPath = path3 ?? process.cwd(), { storefront: configStorefront } = await getConfig(actualPath);
  if (!configStorefront) {
    outputWarn("This project isn't linked to a Hydrogen storefront.");
    return;
  }
  let storefrontTitle = configStorefront.title;
  await unsetStorefront(actualPath), renderSuccess({
    body: ["You are no longer linked to", { bold: storefrontTitle }]
  });
}

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/hooks/init.js
init_cjs_shims();
import { createRequire as createRequire2 } from "node:module";
import { spawnSync } from "node:child_process";
var hook = async function(options) {
  if (!options.id?.startsWith("hydrogen:") || options.id === "hydrogen:init")
    return;
  let projectPath = cwd(), pathFlagRE = /^--path($|=)/, pathFlagIndex = options.argv.findIndex((arg) => pathFlagRE.test(arg));
  if (pathFlagIndex !== -1) {
    let pathFlagValue = options.argv[pathFlagIndex]?.split("=")[1] ?? options.argv[pathFlagIndex + 1];
    pathFlagValue && !pathFlagValue.startsWith("--") && (projectPath = resolvePath(projectPath, pathFlagValue));
  }
  if (isHydrogenProject(projectPath) || (outputNewline(), renderWarning({
    headline: "Looks like you're trying to run a Hydrogen command outside of a Hydrogen project.",
    body: [
      "Run",
      { command: "shopify hydrogen init" },
      "to create a new Hydrogen project or use the",
      { command: "--path" },
      `flag to specify an existing Hydrogen project.

`,
      { subdued: projectPath }
    ],
    reference: [
      "Getting started: https://shopify.dev/docs/storefronts/headless/hydrogen",
      "CLI commands: https://shopify.dev/docs/api/shopify-cli/hydrogen"
    ]
  }), process.exit(1)), commandNeedsVM(options.id, options.argv) && !process.execArgv.includes(EXPERIMENTAL_VM_MODULES_FLAG) && !(process.env.NODE_OPTIONS ?? "").includes(EXPERIMENTAL_VM_MODULES_FLAG)) {
    outputDebug(
      `Restarting CLI process with ${EXPERIMENTAL_VM_MODULES_FLAG} flag.`
    );
    let [command, ...args] = process.argv;
    args.unshift(EXPERIMENTAL_VM_MODULES_FLAG);
    let result = spawnSync(command, args, { stdio: "inherit" });
    process.exit(result.status ?? 1);
  }
}, EXPERIMENTAL_VM_MODULES_FLAG = "--experimental-vm-modules";
function commandNeedsVM(id = "", argv = []) {
  return id === "hydrogen:debug:cpu" || ["hydrogen:dev", "hydrogen:preview"].includes(id) && argv.includes("--legacy-runtime");
}
function isHydrogenProject(projectPath) {
  try {
    let require22 = createRequire2(import.meta.url), { dependencies, scripts } = require22(joinPath(
      projectPath,
      "package.json"
    ));
    return !!dependencies?.["@shopify/hydrogen"] || // Diff examples don't have dependencies:
    !!scripts?.dev?.includes("--diff");
  } catch {
    return !1;
  }
}
var init_default2 = hook;

// ../../node_modules/.pnpm/@shopify+cli-hydrogen@8.4.0_@graphql-codegen+cli@5.0.2_react-dom@17.0.2_react@17.0.2/node_modules/@shopify/cli-hydrogen/dist/index.js
var COMMANDS2 = {
  "hydrogen:dev": Dev2,
  "hydrogen:build": Build,
  "hydrogen:check": GenerateRoute,
  "hydrogen:codegen": Codegen,
  "hydrogen:deploy": Deploy,
  "hydrogen:g": GenerateRouteShortcut,
  "hydrogen:init": Init2,
  "hydrogen:link": Link,
  "hydrogen:list": List2,
  "hydrogen:login": Login,
  "hydrogen:logout": Logout2,
  "hydrogen:preview": Preview,
  "hydrogen:setup": Setup,
  "hydrogen:shortcut": Shortcut,
  "hydrogen:unlink": Unlink,
  "hydrogen:upgrade": Upgrade2,
  "hydrogen:customer-account-push": CustomerAccountPush,
  "hydrogen:debug:cpu": DebugCpu,
  "hydrogen:env:list": EnvList,
  "hydrogen:env:pull": EnvPull,
  "hydrogen:env:push": EnvPush,
  "hydrogen:generate:route": GenerateRoute2,
  "hydrogen:generate:routes": GenerateRoutes,
  "hydrogen:setup:css": SetupCSS,
  "hydrogen:setup:markets": SetupMarkets,
  "hydrogen:setup:vite": SetupVite
}, HOOKS = {
  init: init_default2
};

// ../app/dist/cli/index.js
init_cjs_shims();

// ../app/dist/cli/commands/app/build.js
init_cjs_shims();

// ../app/dist/cli/flags.js
init_cjs_shims();
var import_core28 = __toESM(require_lib(), 1);
var appFlags = {
  path: import_core28.Flags.string({
    description: "The path to your app directory.",
    parse: async (input) => resolvePath(input),
    default: async () => cwd(),
    noCacheDefault: !0,
    env: "SHOPIFY_FLAG_PATH"
  }),
  config: import_core28.Flags.string({
    hidden: !1,
    char: "c",
    description: "The name of the app configuration.",
    env: "SHOPIFY_FLAG_APP_CONFIG"
  })
};

// ../app/dist/cli/models/app/loader.js
init_cjs_shims();

// ../app/dist/cli/models/app/app.js
init_cjs_shims();

// ../app/dist/cli/models/app/validation/common.js
init_cjs_shims();
function validateUrl(zodType, { httpsOnly = !1, message = "Invalid URL" } = {}) {
  return zodType.refine((value) => isValidUrl(value, httpsOnly), { message }).refine((value) => !value.includes(`
`), { message });
}
function isValidUrl(input, httpsOnly) {
  try {
    let url = new URL(input);
    return httpsOnly ? url.protocol === "https:" : ["http:", "https:"].includes(url.protocol);
  } catch {
    return !1;
  }
}
function ensurePathStartsWithSlash(arg) {
  return typeof arg == "string" && !arg.startsWith("/") ? `/${arg}` : arg;
}

// ../app/dist/cli/utilities/types.js
init_cjs_shims();
function isType(schema, item) {
  return schema.safeParse(item).success;
}

// ../app/dist/cli/utilities/developer-platform-client.js
init_cjs_shims();

// ../app/dist/cli/utilities/developer-platform-client/partners-client.js
init_cjs_shims();

// ../app/dist/cli/api/graphql/create_app.js
init_cjs_shims();
var CreateAppQuery = gql`
  mutation AppCreate(
    $org: Int!
    $title: String!
    $appUrl: Url!
    $redir: [Url]!
    $type: AppType
    $requestedAccessScopes: [String!]
  ) {
    appCreate(
      input: {
        organizationID: $org
        title: $title
        applicationUrl: $appUrl
        redirectUrlWhitelist: $redir
        appType: $type
        requestedAccessScopes: $requestedAccessScopes
      }
    ) {
      app {
        id
        title
        apiKey
        organizationId
        apiSecretKeys {
          secret
        }
        appType
        grantedScopes
        applicationUrl
        redirectUrlWhitelist
        requestedAccessScopes
        webhookApiVersion
        embedded
        posEmbedded
        preferencesUrl
        gdprWebhooks {
          customerDeletionUrl
          customerDataRequestUrl
          shopDeletionUrl
        }
        appProxy {
          subPath
          subPathPrefix
          url
        }
        disabledFlags
      }
      userErrors {
        field
        message
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/all_dev_stores_by_org.js
init_cjs_shims();
var AllDevStoresByOrganizationQuery = gql`
  query FindOrganization($id: ID!) {
    organizations(id: $id, first: 1) {
      nodes {
        id
        stores(first: 500, archived: false, type: [DEVELOPMENT, PLUS_SANDBOX]) {
          nodes {
            shopId
            link
            shopDomain
            shopName
            transferDisabled
            convertableToPartnerTest
          }
        }
      }
    }
  }
`;

// ../app/dist/cli/services/context/partner-account-info.js
init_cjs_shims();

// ../app/dist/cli/api/graphql/current_account_info.js
init_cjs_shims();
var CurrentAccountInfoQuery = gql`
  query currentAccountInfo {
    currentAccountInfo {
      __typename
      ... on ServiceAccount {
        orgName
      }
      ... on UserAccount {
        email
      }
    }
  }
`;
async function getCurrentAccountInfo(developerPlatformClient) {
  let { currentAccountInfo } = await developerPlatformClient.currentAccountInfo();
  if (!currentAccountInfo)
    throw new AbortError("Unable to get current user account");
  return mapAccountInfo(currentAccountInfo);
}
function mapAccountInfo(accountInfo) {
  return accountInfo.__typename === "UserAccount" ? {
    type: "UserAccount",
    email: accountInfo.email
  } : accountInfo.__typename === "ServiceAccount" ? {
    type: "ServiceAccount",
    orgName: accountInfo.orgName
  } : { type: "UnknownAccount" };
}

// ../app/dist/cli/services/context/partner-account-info.js
function isUserAccount(account) {
  return account.type === "UserAccount";
}
function isServiceAccount(account) {
  return account.type === "ServiceAccount";
}
async function fetchCurrentAccountInformation(developerPlatformClient) {
  try {
    return await getCurrentAccountInfo(developerPlatformClient);
  } catch {
    return outputDebug("Error fetching user account info"), { type: "UnknownAccount" };
  }
}

// ../app/dist/cli/models/organization.js
init_cjs_shims();
var OrganizationSource;
(function(OrganizationSource2) {
  OrganizationSource2.Partners = "Partners", OrganizationSource2.BusinessPlatform = "BusinessPlatform";
})(OrganizationSource || (OrganizationSource = {}));

// ../app/dist/cli/api/graphql/all_app_extension_registrations.js
init_cjs_shims();
var AllAppExtensionRegistrationsQuery = gql`
  query allAppExtensionRegistrations($apiKey: String!) {
    app(apiKey: $apiKey) {
      extensionRegistrations {
        id
        uuid
        title
        type
        draftVersion {
          config
          context
        }
        activeVersion {
          config
          context
        }
      }
      configurationRegistrations {
        id
        uuid
        title
        type
        draftVersion {
          config
          context
        }
        activeVersion {
          config
          context
        }
      }
      dashboardManagedExtensionRegistrations {
        id
        uuid
        title
        type
        activeVersion {
          config
          context
        }
        draftVersion {
          config
          context
        }
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/app_active_version.js
init_cjs_shims();
var ActiveAppVersionQuery = gql`
  query activeAppVersion($apiKey: String!) {
    app(apiKey: $apiKey) {
      activeAppVersion {
        appModuleVersions {
          registrationId
          registrationUuid
          registrationTitle
          type
          config
          specification {
            identifier
            name
            experience
            options {
              managementExperience
            }
          }
        }
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/app_deploy.js
init_cjs_shims();
var AppDeploy = gql`
  mutation AppDeploy(
    $apiKey: String!
    $bundleUrl: String
    $appModules: [AppModuleSettings!]
    $skipPublish: Boolean
    $message: String
    $versionTag: String
    $commitReference: String
  ) {
    appDeploy(
      input: {
        apiKey: $apiKey
        bundleUrl: $bundleUrl
        appModules: $appModules
        skipPublish: $skipPublish
        message: $message
        versionTag: $versionTag
        commitReference: $commitReference
      }
    ) {
      appVersion {
        uuid
        id
        message
        versionTag
        location
        appModuleVersions {
          uuid
          registrationUuid
          validationErrors {
            message
            field
          }
        }
      }
      userErrors {
        message
        field
        category
        details
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/generate_signed_upload_url.js
init_cjs_shims();
var GenerateSignedUploadUrl = gql`
  mutation GenerateSignedUploadUrl($apiKey: String!, $bundleFormat: Int!) {
    appVersionGenerateSignedUploadUrl(input: {apiKey: $apiKey, bundleFormat: $bundleFormat}) {
      signedUploadUrl
      userErrors {
        field
        message
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/extension_create.js
init_cjs_shims();
var ExtensionCreateQuery = gql`
  mutation ExtensionCreate(
    $apiKey: String!
    $type: ExtensionType!
    $title: String!
    $config: JSON!
    $context: String
    $handle: String
  ) {
    extensionCreate(
      input: {apiKey: $apiKey, type: $type, title: $title, config: $config, context: $context, handle: $handle}
    ) {
      extensionRegistration {
        id
        uuid
        type
        title
        draftVersion {
          config
          registrationId
          lastUserInteractionAt
          validationErrors {
            field
            message
          }
        }
      }
      userErrors {
        field
        message
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/convert_dev_to_transfer_disabled_store.js
init_cjs_shims();
var ConvertDevToTransferDisabledStoreQuery = gql`
  mutation convertDevToTestStore($input: ConvertDevToTestStoreInput!) {
    convertDevToTestStore(input: $input) {
      convertedToTestStore
      userErrors {
        message
        field
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/find_store_by_domain.js
init_cjs_shims();
var FindStoreByDomainQuery = gql`
  query FindOrganization($orgId: ID!, $shopDomain: String) {
    organizations(id: $orgId, first: 1) {
      nodes {
        id
        businessName
        stores(shopDomain: $shopDomain, first: 1, archived: false) {
          nodes {
            shopId
            link
            shopDomain
            shopName
            transferDisabled
            convertableToPartnerTest
          }
        }
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/get_versions_list.js
init_cjs_shims();
var AppVersionsQuery = gql`
  query AppVersionsQuery($apiKey: String!) {
    app(apiKey: $apiKey) {
      id
      organizationId
      title
      appVersions {
        nodes {
          createdAt
          createdBy {
            displayName
          }
          message
          status
          versionTag
        }
        pageInfo {
          totalResults
        }
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/development_preview.js
init_cjs_shims();
var DevelopmentStorePreviewUpdateQuery = gql`
  mutation DevelopmentStorePreviewUpdate($input: DevelopmentStorePreviewUpdateInput!) {
    developmentStorePreviewUpdate(input: $input) {
      app {
        id
        developmentStorePreviewEnabled
      }
      userErrors {
        message
        field
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/find_app_preview_mode.js
init_cjs_shims();
var FindAppPreviewModeQuery = gql`
  query FindAppPreviewMode($apiKey: String!) {
    app(apiKey: $apiKey) {
      developmentStorePreviewEnabled
    }
  }
`;

// ../app/dist/cli/api/graphql/app_versions_diff.js
init_cjs_shims();
var AppVersionsDiffQuery = gql`
  query AppVersionsDiff($apiKey: String!, $versionId: ID!) {
    app(apiKey: $apiKey) {
      versionsDiff(appVersionId: $versionId) {
        added {
          uuid
          registrationTitle
          specification {
            identifier
            experience
            options {
              managementExperience
            }
          }
        }
        updated {
          uuid
          registrationTitle
          specification {
            identifier
            experience
            options {
              managementExperience
            }
          }
        }
        removed {
          uuid
          registrationTitle
          specification {
            identifier
            experience
            options {
              managementExperience
            }
          }
        }
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/app_release.js
init_cjs_shims();
var AppRelease = gql`
  mutation AppRelease($apiKey: String!, $appVersionId: ID, $versionTag: String) {
    appRelease(input: {apiKey: $apiKey, appVersionId: $appVersionId, versionTag: $versionTag}) {
      appVersion {
        versionTag
        message
        location
      }
      userErrors {
        message
        field
        category
        details
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/app_version_by_tag.js
init_cjs_shims();
var AppVersionByTagQuery = gql`
  query AppVersionByTag($apiKey: String!, $versionTag: String!) {
    app(apiKey: $apiKey) {
      appVersion(versionTag: $versionTag) {
        id
        uuid
        versionTag
        location
        message
        appModuleVersions {
          config
          specification {
            identifier
            name
            experience
            options {
              managementExperience
            }
          }
        }
      }
    }
  }
`;

// ../app/dist/cli/services/webhook/request-sample.js
init_cjs_shims();
var sendSampleWebhookMutation = `
  mutation samplePayload($topic: String!, $api_version: String!, $address: String!, $delivery_method: String!, $shared_secret: String!, $api_key: String) {
    sendSampleWebhook(input: {topic: $topic, apiVersion: $api_version, address: $address, deliveryMethod: $delivery_method, sharedSecret: $shared_secret, apiKey: $api_key}) {
        samplePayload
        success
        headers
        userErrors {
          message
        }
    }
  }
`;
async function getWebhookSample(developerPlatformClient, variables) {
  let { sendSampleWebhook: result } = await developerPlatformClient.sendSampleWebhook(variables);
  return result;
}

// ../app/dist/cli/services/webhook/request-api-versions.js
init_cjs_shims();
var GetApiVersionsQuery = `
  query getApiVersions {
    publicApiVersions
  }
`;
async function requestApiVersions(developerPlatformClient) {
  let { publicApiVersions: result } = await developerPlatformClient.apiVersions(), unstableIdx = result.indexOf("unstable");
  return unstableIdx === -1 ? result.sort().reverse() : (result.splice(unstableIdx, 1), result.sort().reverse(), result.push("unstable")), result;
}

// ../app/dist/cli/services/webhook/request-topics.js
init_cjs_shims();
var getTopicsQuery = `
  query getWebhookTopics($api_version: String!) {
    webhookTopics(apiVersion: $api_version)
  }
`;
async function requestTopics(developerPlatformClient, apiVersion) {
  let variables = { api_version: apiVersion }, { webhookTopics: result } = await developerPlatformClient.topics(variables);
  return result;
}

// ../app/dist/cli/api/graphql/extension_migrate_flow_extension.js
init_cjs_shims();
var MigrateFlowExtensionMutation = gql`
  mutation MigrateFlowExtension($apiKey: String!, $registrationId: ID!) {
    migrateFlowExtension(input: {apiKey: $apiKey, registrationId: $registrationId}) {
      migratedFlowExtension
      userErrors {
        field
        message
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/update_urls.js
init_cjs_shims();
var UpdateURLsQuery = gql`
  mutation appUpdate($apiKey: String!, $applicationUrl: Url!, $redirectUrlWhitelist: [Url]!, $appProxy: AppProxyInput) {
    appUpdate(
      input: {
        apiKey: $apiKey
        applicationUrl: $applicationUrl
        redirectUrlWhitelist: $redirectUrlWhitelist
        appProxy: $appProxy
      }
    ) {
      userErrors {
        message
        field
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/template_specifications.js
init_cjs_shims();
var RemoteTemplateSpecificationsQuery = gql`
  query RemoteTemplateSpecifications($version: String, $apiKey: String) {
    templateSpecifications(version: $version, apiKey: $apiKey) {
      identifier
      name
      defaultName
      group
      sortPriority
      supportLinks
      types {
        url
        type
        extensionPoints
        supportedFlavors {
          name
          value
          path
        }
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/functions/target_schema_definition.js
init_cjs_shims();
var TargetSchemaDefinitionQuery = gql`
  query TargetSchemaDefinitionQuery($apiKey: String!, $version: String!, $target: String!) {
    definition: functionTargetSchemaDefinition(apiKey: $apiKey, version: $version, target: $target)
  }
`;

// ../app/dist/cli/api/graphql/functions/api_schema_definition.js
init_cjs_shims();
var ApiSchemaDefinitionQuery = gql`
  query ApiSchemaDefinitionQuery($apiKey: String!, $version: String!, $type: String!) {
    definition: functionApiSchemaDefinition(apiKey: $apiKey, version: $version, type: $type)
  }
`;

// ../app/dist/cli/api/graphql/extension_migrate_to_ui_extension.js
init_cjs_shims();
var MigrateToUiExtensionQuery = gql`
  mutation MigrateToUiExtension($apiKey: String!, $registrationId: ID!) {
    migrateToUiExtension(input: {apiKey: $apiKey, registrationId: $registrationId}) {
      migratedToUiExtension
      userErrors {
        field
        message
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/extension_specifications.js
init_cjs_shims();
var ExtensionSpecificationsQuery = gql`
  query fetchSpecifications($api_key: String!) {
    extensionSpecifications(apiKey: $api_key) {
      name
      externalName
      externalIdentifier
      identifier
      gated
      experience
      options {
        managementExperience
        registrationLimit
      }
      features {
        argo {
          surface
        }
      }
      validationSchema {
        jsonSchema
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/find_org_basic.js
init_cjs_shims();
var FindOrganizationBasicQuery = gql`
  query FindOrganization($id: ID!) {
    organizations(id: $id, first: 1) {
      nodes {
        id
        businessName
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/extension_migrate_app_module.js
init_cjs_shims();
var MigrateAppModuleMutation = gql`
  mutation MigrateAppModule($apiKey: String!, $registrationId: ID!, $type: String!) {
    migrateAppModule(input: {apiKey: $apiKey, registrationId: $registrationId, type: $type}) {
      migratedAppModule
      userErrors {
        field
        message
      }
    }
  }
`;

// ../app/dist/cli/api/graphql/subscribe_to_app_logs.js
init_cjs_shims();
var AppLogsSubscribeMutation = gql`
  mutation AppLogsSubscribe($apiKey: String!, $shopIds: [ID!]!) {
    appLogsSubscribe(input: {apiKey: $apiKey, shopIds: $shopIds}) {
      jwtToken
      success
      errors
    }
  }
`;

// ../app/dist/cli/api/graphql/partners/generated/all-orgs.js
init_cjs_shims();
var AllOrgs = {
  kind: "Document",
  definitions: [
    {
      kind: "OperationDefinition",
      operation: "query",
      name: { kind: "Name", value: "AllOrgs" },
      selectionSet: {
        kind: "SelectionSet",
        selections: [
          {
            kind: "Field",
            name: { kind: "Name", value: "organizations" },
            arguments: [
              { kind: "Argument", name: { kind: "Name", value: "first" }, value: { kind: "IntValue", value: "200" } }
            ],
            selectionSet: {
              kind: "SelectionSet",
              selections: [
                {
                  kind: "Field",
                  name: { kind: "Name", value: "nodes" },
                  selectionSet: {
                    kind: "SelectionSet",
                    selections: [
                      { kind: "Field", name: { kind: "Name", value: "id" } },
                      { kind: "Field", name: { kind: "Name", value: "businessName" } },
                      { kind: "Field", name: { kind: "Name", value: "__typename" } }
                    ]
                  }
                },
                { kind: "Field", name: { kind: "Name", value: "__typename" } }
              ]
            }
          }
        ]
      }
    }
  ]
};

// ../app/dist/cli/api/graphql/partners/generated/update-draft.js
init_cjs_shims();
var ExtensionUpdateDraft = {
  kind: "Document",
  definitions: [
    {
      kind: "OperationDefinition",
      operation: "mutation",
      name: { kind: "Name", value: "ExtensionUpdateDraft" },
      variableDefinitions: [
        {
          kind: "VariableDefinition",
          variable: { kind: "Variable", name: { kind: "Name", value: "apiKey" } },
          type: { kind: "NonNullType", type: { kind: "NamedType", name: { kind: "Name", value: "String" } } }
        },
        {
          kind: "VariableDefinition",
          variable: { kind: "Variable", name: { kind: "Name", value: "registrationId" } },
          type: { kind: "NonNullType", type: { kind: "NamedType", name: { kind: "Name", value: "ID" } } }
        },
        {
          kind: "VariableDefinition",
          variable: { kind: "Variable", name: { kind: "Name", value: "config" } },
          type: { kind: "NonNullType", type: { kind: "NamedType", name: { kind: "Name", value: "JSON" } } }
        },
        {
          kind: "VariableDefinition",
          variable: { kind: "Variable", name: { kind: "Name", value: "context" } },
          type: { kind: "NamedType", name: { kind: "Name", value: "String" } }
        },
        {
          kind: "VariableDefinition",
          variable: { kind: "Variable", name: { kind: "Name", value: "handle" } },
          type: { kind: "NamedType", name: { kind: "Name", value: "String" } }
        }
      ],
      selectionSet: {
        kind: "SelectionSet",
        selections: [
          {
            kind: "Field",
            name: { kind: "Name", value: "extensionUpdateDraft" },
            arguments: [
              {
                kind: "Argument",
                name: { kind: "Name", value: "input" },
                value: {
                  kind: "ObjectValue",
                  fields: [
                    {
                      kind: "ObjectField",
                      name: { kind: "Name", value: "apiKey" },
                      value: { kind: "Variable", name: { kind: "Name", value: "apiKey" } }
                    },
                    {
                      kind: "ObjectField",
                      name: { kind: "Name", value: "registrationId" },
                      value: { kind: "Variable", name: { kind: "Name", value: "registrationId" } }
                    },
                    {
                      kind: "ObjectField",
                      name: { kind: "Name", value: "config" },
                      value: { kind: "Variable", name: { kind: "Name", value: "config" } }
                    },
                    {
                      kind: "ObjectField",
                      name: { kind: "Name", value: "context" },
                      value: { kind: "Variable", name: { kind: "Name", value: "context" } }
                    },
                    {
                      kind: "ObjectField",
                      name: { kind: "Name", value: "handle" },
                      value: { kind: "Variable", name: { kind: "Name", value: "handle" } }
                    }
                  ]
                }
              }
            ],
            selectionSet: {
              kind: "SelectionSet",
              selections: [
                {
                  kind: "Field",
                  name: { kind: "Name", value: "userErrors" },
                  selectionSet: {
                    kind: "SelectionSet",
                    selections: [
                      { kind: "Field", name: { kind: "Name", value: "field" } },
                      { kind: "Field", name: { kind: "Name", value: "message" } },
                      { kind: "Field", name: { kind: "Name", value: "__typename" } }
                    ]
                  }
                },
                { kind: "Field", name: { kind: "Name", value: "__typename" } }
              ]
            }
          }
        ]
      }
    }
  ]
};

// ../app/dist/cli/api/graphql/find_app.js
init_cjs_shims();
var FindAppQuery = gql`
  query FindApp($apiKey: String!) {
    app(apiKey: $apiKey) {
      id
      title
      apiKey
      organizationId
      apiSecretKeys {
        secret
      }
      appType
      grantedScopes
      applicationUrl
      redirectUrlWhitelist
      requestedAccessScopes
      webhookApiVersion
      embedded
      posEmbedded
      preferencesUrl
      gdprWebhooks {
        customerDeletionUrl
        customerDataRequestUrl
        shopDeletionUrl
      }
      appProxy {
        subPath
        subPathPrefix
        url
      }
      developmentStorePreviewEnabled
      disabledFlags
    }
  }
`;

// ../app/dist/cli/api/graphql/find_org.js
init_cjs_shims();
var FindOrganizationQuery = gql`
  query FindOrganization($id: ID!, $title: String) {
    organizations(id: $id, first: 1) {
      nodes {
        id
        businessName
        apps(first: 25, title: $title) {
          pageInfo {
            hasNextPage
          }
          nodes {
            id
            title
            apiKey
          }
        }
      }
    }
  }
`;

// ../app/dist/cli/services/dev/fetch.js
init_cjs_shims();
var NoOrgError = class extends AbortError {
  constructor(partnersAccount, organizationId) {
    let accountIdentifier = "unknown", identifierMessage = (formattedIdentifier2) => `an ${formattedIdentifier2}`;
    isServiceAccount(partnersAccount) ? (accountIdentifier = partnersAccount.orgName, identifierMessage = (formattedIdentifier2) => `the ${formattedIdentifier2} organization`) : isUserAccount(partnersAccount) && (accountIdentifier = partnersAccount.email, identifierMessage = (formattedIdentifier2) => `the ${formattedIdentifier2} user`);
    let formattedIdentifier = outputContent`${outputToken.yellow(accountIdentifier)}`.value, nextSteps = [
      [
        `Your current active session is associated with ${identifierMessage(formattedIdentifier)} account. To start a new session with a different account, run`,
        { command: "shopify auth logout" }
      ],
      [
        "Have you",
        {
          link: {
            label: "created a Shopify Partners organization",
            url: "https://partners.shopify.com/signup"
          }
        },
        {
          char: "?"
        }
      ],
      [
        "Does your account include",
        {
          subdued: "Manage app"
        },
        "permissions?, please contact the owner of the organization to grant you access."
      ],
      "Have you confirmed your accounts from the emails you received?",
      [
        "Need to connect to a different App or organization? Run the command again with",
        {
          command: "--reset"
        }
      ]
    ];
    organizationId && nextSteps.push([
      "Do you have access to the right Shopify Partners organization? The CLI is loading",
      { link: { label: "this organization", url: `https://partner.shopify.com/${organizationId}` } }
    ]), super("No Organization found", void 0, nextSteps);
  }
};
async function fetchOrganizations() {
  let organizations = [];
  for (let client of allDeveloperPlatformClients()) {
    let clientOrganizations = await client.organizations();
    organizations.push(...clientOrganizations);
  }
  if (organizations.length === 0) {
    let developerPlatformClient = selectDeveloperPlatformClient(), accountInfo = await fetchCurrentAccountInformation(developerPlatformClient);
    throw new NoOrgError(accountInfo);
  }
  return organizations;
}
async function fetchAppPreviewMode(apiKey, developerPlatformClient) {
  return (await developerPlatformClient.appPreviewMode({ apiKey })).app?.developmentStorePreviewEnabled;
}
async function fetchOrgFromId(id, developerPlatformClient) {
  let org = await developerPlatformClient.orgFromId(id);
  if (!org)
    throw new NoOrgError((await developerPlatformClient.session()).accountInfo, id);
  return org;
}
async function fetchStoreByDomain(orgId, shopDomain, developerPlatformClient) {
  let org = (await developerPlatformClient.storeByDomain(orgId, shopDomain)).organizations.nodes[0];
  if (!org)
    return;
  let source = developerPlatformClient.requiresOrganization ? OrganizationSource.BusinessPlatform : OrganizationSource.Partners, parsedOrg = { id: org.id, businessName: org.businessName, source }, store = org.stores.nodes[0];
  return { organization: parsedOrg, store };
}

// ../app/dist/cli/utilities/developer-platform-client/partners-client.js
var MAGIC_URL = "https://shopify.dev/apps/default-app-home", MAGIC_REDIRECT_URL = "https://shopify.dev/apps/default-app-home/api/auth";
function getAppVars(org, name, isLaunchable = !0, scopesArray) {
  return isLaunchable ? {
    org: parseInt(org.id, 10),
    title: `${name}`,
    appUrl: "https://example.com",
    redir: ["https://example.com/api/auth"],
    requestedAccessScopes: scopesArray ?? [],
    type: "undecided"
  } : {
    org: parseInt(org.id, 10),
    title: `${name}`,
    appUrl: MAGIC_URL,
    redir: [MAGIC_REDIRECT_URL],
    requestedAccessScopes: scopesArray ?? [],
    type: "undecided"
  };
}
var PartnersClient = class {
  constructor(session) {
    this.clientName = ClientName.Partners, this.webUiName = "Partner Dashboard", this.supportsAtomicDeployments = !1, this.requiresOrganization = !1, this._session = session;
  }
  async session() {
    if (!this._session) {
      if (isUnitTest())
        throw new Error("PartnersClient.session() should not be invoked dynamically in a unit test");
      let token = await ensureAuthenticatedPartners();
      this._session = {
        token,
        accountInfo: { type: "UnknownAccount" }
      };
      let accountInfo = await fetchCurrentAccountInformation(this);
      this._session = { token, accountInfo };
    }
    return this._session;
  }
  async request(query, variables = void 0) {
    return partnersRequest(query, await this.token(), variables);
  }
  async requestDoc(document2, variables) {
    return partnersRequestDoc(document2, await this.token(), variables);
  }
  async token() {
    return (await this.session()).token;
  }
  async refreshToken() {
    let newToken = await ensureAuthenticatedPartners([], process.env, { noPrompt: !0 }), session = await this.session();
    return newToken && (session.token = newToken), session.token;
  }
  async accountInfo() {
    return (await this.session()).accountInfo;
  }
  async appFromId({ apiKey }) {
    let variables = { apiKey }, app = (await this.request(FindAppQuery, variables)).app;
    if (app) {
      let flags = filterDisabledFlags(app.disabledFlags);
      return {
        ...app,
        flags,
        developerPlatformClient: this
      };
    }
  }
  async organizations() {
    try {
      return (await this.requestDoc(AllOrgs)).organizations.nodes.map((org) => ({
        id: org.id,
        businessName: org.businessName,
        source: OrganizationSource.Partners
      }));
    } catch (error) {
      if (error.statusCode === 404)
        return [];
      throw error;
    }
  }
  async orgFromId(orgId) {
    let variables = { id: orgId }, org = (await this.request(FindOrganizationBasicQuery, variables)).organizations.nodes[0];
    return org && (org.source = OrganizationSource.Partners), org;
  }
  async orgAndApps(orgId) {
    let result = await this.fetchOrgAndApps(orgId);
    return {
      organization: result.organization,
      apps: result.apps.nodes,
      hasMorePages: result.apps.pageInfo.hasNextPage
    };
  }
  async appsForOrg(organizationId, term) {
    let result = await this.fetchOrgAndApps(organizationId, term);
    return {
      apps: result.apps.nodes,
      hasMorePages: result.apps.pageInfo.hasNextPage
    };
  }
  async specifications({ apiKey }) {
    let variables = { api_key: apiKey };
    return (await this.request(ExtensionSpecificationsQuery, variables)).extensionSpecifications;
  }
  async templateSpecifications({ apiKey }) {
    let variables = { apiKey };
    return (await this.request(RemoteTemplateSpecificationsQuery, variables)).templateSpecifications.map((template2) => {
      let { types, ...rest } = template2;
      return {
        ...rest,
        ...types[0]
      };
    });
  }
  async createApp(org, name, options) {
    let variables = getAppVars(org, name, options?.isLaunchable, options?.scopesArray), result = await this.request(CreateAppQuery, variables);
    if (result.appCreate.userErrors.length > 0) {
      let errors2 = result.appCreate.userErrors.map((error) => error.message).join(", ");
      throw new AbortError(errors2);
    }
    let flags = filterDisabledFlags(result.appCreate.app.disabledFlags);
    return { ...result.appCreate.app, organizationId: org.id, newApp: !0, flags, developerPlatformClient: this };
  }
  async devStoresForOrg(orgId) {
    let variables = { id: orgId };
    return (await this.request(AllDevStoresByOrganizationQuery, variables)).organizations.nodes[0].stores.nodes;
  }
  async appExtensionRegistrations({ apiKey }) {
    let variables = { apiKey };
    return this.request(AllAppExtensionRegistrationsQuery, variables);
  }
  async appVersions({ apiKey }) {
    let variables = { apiKey };
    return this.request(AppVersionsQuery, variables);
  }
  async appVersionByTag({ apiKey }, versionTag) {
    let input = { apiKey, versionTag };
    return this.request(AppVersionByTagQuery, input);
  }
  async appVersionsDiff({ apiKey }, { appVersionId }) {
    let variables = { apiKey, versionId: appVersionId };
    return this.request(AppVersionsDiffQuery, variables);
  }
  async activeAppVersion({ apiKey }) {
    let variables = { apiKey }, version2 = (await this.request(ActiveAppVersionQuery, variables)).app.activeAppVersion;
    if (version2)
      return {
        ...version2,
        appModuleVersions: version2.appModuleVersions.map((mod) => ({
          ...mod,
          config: mod.config ? JSON.parse(mod.config) : {}
        }))
      };
  }
  async functionUploadUrl() {
    return this.request(FunctionUploadUrlGenerateMutation);
  }
  async createExtension(input) {
    return this.request(ExtensionCreateQuery, input);
  }
  async updateExtension(extensionInput) {
    return this.requestDoc(ExtensionUpdateDraft, extensionInput);
  }
  async deploy(deployInput) {
    let { organizationId, ...deployOptions } = deployInput, variables = deployOptions;
    return variables.appModules = variables.appModules?.map((element) => {
      let { uid, ...otherFields } = element;
      return otherFields;
    }), this.request(AppDeploy, variables);
  }
  async release({ app: { apiKey }, version: { appVersionId } }) {
    let input = { apiKey, appVersionId };
    return this.request(AppRelease, input);
  }
  async generateSignedUploadUrl(app) {
    let variables = { apiKey: app.apiKey, bundleFormat: 1 }, result = await this.request(GenerateSignedUploadUrl, variables);
    return {
      assetUrl: result.appVersionGenerateSignedUploadUrl.signedUploadUrl,
      userErrors: result.appVersionGenerateSignedUploadUrl.userErrors
    };
  }
  async convertToTransferDisabledStore(input) {
    return this.request(ConvertDevToTransferDisabledStoreQuery, input);
  }
  async storeByDomain(orgId, shopDomain) {
    let variables = { orgId, shopDomain };
    return this.request(FindStoreByDomainQuery, variables);
  }
  async updateDeveloperPreview(input) {
    return this.request(DevelopmentStorePreviewUpdateQuery, input);
  }
  async appPreviewMode(input) {
    return this.request(FindAppPreviewModeQuery, input);
  }
  async sendSampleWebhook(input) {
    return this.request(sendSampleWebhookMutation, input);
  }
  async apiVersions() {
    return this.request(GetApiVersionsQuery);
  }
  async topics(input) {
    return this.request(getTopicsQuery, input);
  }
  async migrateFlowExtension(input) {
    return this.request(MigrateFlowExtensionMutation, input);
  }
  async migrateAppModule(input) {
    return this.request(MigrateAppModuleMutation, input);
  }
  async updateURLs(input) {
    return this.request(UpdateURLsQuery, input);
  }
  async currentAccountInfo() {
    return this.request(CurrentAccountInfoQuery);
  }
  async targetSchemaDefinition(input) {
    return (await this.request(TargetSchemaDefinitionQuery, input)).definition;
  }
  async apiSchemaDefinition(input) {
    return (await this.request(ApiSchemaDefinitionQuery, input)).definition;
  }
  async migrateToUiExtension(input) {
    return this.request(MigrateToUiExtensionQuery, input);
  }
  toExtensionGraphQLType(input) {
    return input.toUpperCase();
  }
  async subscribeToAppLogs(input) {
    return this.request(AppLogsSubscribeMutation, input);
  }
  async appDeepLink({ id, organizationId }) {
    return `https://${await partnersFqdn()}/${organizationId}/apps/${id}`;
  }
  async devSessionCreate(_input) {
    throw new Error("Unsupported operation");
  }
  async devSessionUpdate(_input) {
    throw new Error("Unsupported operation");
  }
  async devSessionDelete(_input) {
    throw new Error("Unsupported operation");
  }
  async fetchOrgAndApps(orgId, title) {
    let params = { id: orgId };
    title && (params.title = title);
    let org = (await this.request(FindOrganizationQuery, params)).organizations.nodes[0];
    if (!org) {
      let partnersSession = await this.session();
      throw new NoOrgError(partnersSession.accountInfo, orgId);
    }
    let parsedOrg = { id: org.id, businessName: org.businessName, source: OrganizationSource.Partners }, appsWithOrg = org.apps.nodes.map((app) => ({ ...app, organizationId: org.id }));
    return { organization: parsedOrg, apps: { ...org.apps, nodes: appsWithOrg }, stores: [] };
  }
};

// ../app/dist/cli/utilities/developer-platform-client/app-management-client.js
init_cjs_shims();

// ../app/dist/cli/utilities/developer-platform-client/app-management-client/graphql/create-app.js
init_cjs_shims();
var CreateAppMutation = gql`
  mutation CreateApp($appSource: AppSourceInput!, $name: String!) {
    appCreate(appSource: $appSource, name: $name) {
      app {
        id
        key
      }
      userErrors {
        category
        message
        on
      }
    }
  }
`;

// ../app/dist/cli/utilities/developer-platform-client/app-management-client/graphql/active-app-release.js
init_cjs_shims();
var ActiveAppReleaseQuery = gql`
  query activeAppRelease($appId: ID!) {
    app(id: $appId) {
      id
      key
      activeRoot {
        clientCredentials {
          secrets {
            key
          }
        }
      }
      activeRelease {
        id
        version {
          name
          appModules {
            uuid
            handle
            config
            specification {
              identifier
              externalIdentifier
              name
            }
          }
        }
      }
    }
  }
`;

// ../app/dist/cli/utilities/developer-platform-client/app-management-client/graphql/specifications.js
init_cjs_shims();
var SpecificationsQuery = gql`
  query fetchSpecifications {
    specifications {
      name
      identifier
      externalIdentifier
      features
      uidStrategy {
        appModuleLimit
      }
    }
  }
`;

// ../app/dist/cli/utilities/developer-platform-client/app-management-client/graphql/app-versions.js
init_cjs_shims();
var AppVersionsQuery2 = gql`
  query AppVersions($appId: ID!) {
    app(id: $appId) {
      id
      activeRelease {
        id
        version {
          id
        }
      }
    }
    versions(appId: $appId) {
      id
      createdAt
      createdBy
      metadata {
        message
        versionTag
      }
    }
  }
`;

// ../app/dist/cli/utilities/developer-platform-client/app-management-client/graphql/create-app-version.js
init_cjs_shims();
var CreateAppVersionMutation = gql`
  mutation CreateAppVersion($appId: ID!, $appSource: AppSourceInput!, $name: String!, $metadata: VersionMetadataInput) {
    appVersionCreate(appId: $appId, appSource: $appSource, name: $name, metadata: $metadata) {
      version {
        id
        appModules {
          uuid
          handle
          config
          specification {
            identifier
            name
          }
        }
        metadata {
          versionTag
        }
      }
      userErrors {
        field
        message
        category
        code
        on
      }
    }
  }
`;

// ../app/dist/cli/utilities/developer-platform-client/app-management-client/graphql/release-version.js
init_cjs_shims();
var ReleaseVersionMutation = gql`
  mutation ReleaseVersion($appId: ID!, $versionId: ID!) {
    appReleaseCreate(appId: $appId, versionId: $versionId) {
      release {
        version {
          id
          metadata {
            message
            versionTag
          }
        }
      }
      userErrors {
        field
        message
        category
        code
        on
      }
    }
  }
`;

// ../app/dist/cli/utilities/developer-platform-client/app-management-client/graphql/apps.js
init_cjs_shims();
var AppsQuery = gql`
  query listApps {
    apps {
      id
      key
      activeRelease {
        id
        version {
          name
          appModules {
            uuid
            handle
            config
            specification {
              externalIdentifier
            }
          }
        }
      }
    }
  }
`;

// ../app/dist/cli/utilities/developer-platform-client/app-management-client/graphql/organization.js
init_cjs_shims();
var OrganizationQuery = gql`
  query FindOrganizations($organizationId: OrganizationID!) {
    currentUserAccount {
      organization(id: $organizationId) {
        id
        name
      }
    }
  }
`;

// ../app/dist/cli/utilities/developer-platform-client/app-management-client/graphql/user-info.js
init_cjs_shims();
var UserInfoQuery = gql`
  query UserInfo {
    currentUserAccount {
      uuid
      email
    }
  }
`;

// ../app/dist/cli/utilities/developer-platform-client/app-management-client/graphql/create-asset-url.js
init_cjs_shims();
var CreateAssetURLMutation = gql`
  mutation CreateAssetURL {
    appRequestSourceUploadUrl {
      sourceUploadUrl
      userErrors {
        field
        message
      }
    }
  }
`;

// ../app/dist/cli/utilities/developer-platform-client/app-management-client/graphql/app-version-by-id.js
init_cjs_shims();
var AppVersionByIdQuery = gql`
  query AppVersionById($versionId: ID!) {
    version(id: $versionId) {
      id
      metadata {
        versionTag
      }
      appModules {
        uuid
        handle
        config
        specification {
          identifier
          externalIdentifier
          name
        }
      }
    }
  }
`;

// ../app/dist/cli/utilities/developer-platform-client/app-management-client/graphql/organization_beta_flags.js
init_cjs_shims();
function organizationBetaFlagsQuery(flags) {
  return gql`
    query OrganizationBetaFlags($organizationId: OrganizationID!) {
      organization(organizationId: $organizationId) {
        id
        ${flags.map((flag) => `flag_${flag}: hasFeatureFlag(handle: "${flag}")`).join(`
        `)}
      }
    }`;
}

// ../app/dist/cli/api/graphql/business-platform-destinations/generated/organizations.js
init_cjs_shims();
var ListOrganizations = {
  kind: "Document",
  definitions: [
    {
      kind: "OperationDefinition",
      operation: "query",
      name: { kind: "Name", value: "ListOrganizations" },
      selectionSet: {
        kind: "SelectionSet",
        selections: [
          {
            kind: "Field",
            name: { kind: "Name", value: "currentUserAccount" },
            selectionSet: {
              kind: "SelectionSet",
              selections: [
                { kind: "Field", name: { kind: "Name", value: "uuid" } },
                {
                  kind: "Field",
                  name: { kind: "Name", value: "organizations" },
                  selectionSet: {
                    kind: "SelectionSet",
                    selections: [
                      {
                        kind: "Field",
                        name: { kind: "Name", value: "nodes" },
                        selectionSet: {
                          kind: "SelectionSet",
                          selections: [
                            { kind: "Field", name: { kind: "Name", value: "id" } },
                            { kind: "Field", name: { kind: "Name", value: "name" } },
                            { kind: "Field", name: { kind: "Name", value: "__typename" } }
                          ]
                        }
                      },
                      { kind: "Field", name: { kind: "Name", value: "__typename" } }
                    ]
                  }
                },
                { kind: "Field", name: { kind: "Name", value: "__typename" } }
              ]
            }
          }
        ]
      }
    }
  ]
};

// ../app/dist/cli/models/extensions/specifications/app_config_app_home.js
init_cjs_shims();

// ../app/dist/cli/models/extensions/specification.js
init_cjs_shims();

// ../app/dist/cli/models/extensions/schemas.js
init_cjs_shims();
var MAX_EXTENSION_HANDLE_LENGTH = 30, MetafieldSchema = z.object({
  namespace: z.string(),
  key: z.string()
}), CollectBuyerConsentCapabilitySchema = z.object({
  sms_marketing: z.boolean().optional(),
  customer_privacy: z.boolean().optional()
}), IframeCapabilitySchema = z.object({
  sources: z.array(z.string()).optional()
}), CapabilitiesSchema = z.object({
  network_access: z.boolean().optional(),
  block_progress: z.boolean().optional(),
  api_access: z.boolean().optional(),
  collect_buyer_consent: CollectBuyerConsentCapabilitySchema.optional(),
  iframe: IframeCapabilitySchema.optional()
}), ExtensionsArraySchema = z.object({
  type: z.string().optional(),
  extensions: z.array(z.any()).optional()
}), NewExtensionPointSchema = z.object({
  target: z.string(),
  module: z.string(),
  metafields: z.array(MetafieldSchema).optional(),
  default_placement: z.string().optional()
}), NewExtensionPointsSchema = z.array(NewExtensionPointSchema), ApiVersionSchema = z.string(), FieldSchema = z.object({
  key: z.string().optional(),
  name: z.string().optional(),
  description: z.string().optional(),
  required: z.boolean().optional(),
  default_value: z.any().optional(),
  type: z.string(),
  validations: z.array(z.any()).optional()
}), SettingsSchema = z.object({
  fields: z.array(FieldSchema).optional()
}), HandleSchema = z.string().trim().nonempty("Handle can't be empty").max(MAX_EXTENSION_HANDLE_LENGTH, `Handle can't exceed ${MAX_EXTENSION_HANDLE_LENGTH} characters`).regex(/^[a-zA-Z0-9-]*$/, "Handle can only contain alphanumeric characters and hyphens").refine((handle) => !handle.startsWith("-") && !handle.endsWith("-"), "Handle can't start or end with a hyphen").refine((handle) => [...handle].some((char) => char !== "-"), "Handle can't be all hyphens"), BaseSchema = z.object({
  name: z.string(),
  type: z.string(),
  handle: HandleSchema.optional(),
  uid: z.string().optional(),
  description: z.string().optional(),
  api_version: ApiVersionSchema.optional(),
  extension_points: z.any().optional(),
  capabilities: CapabilitiesSchema.optional(),
  metafields: z.array(MetafieldSchema).optional().default([]),
  settings: SettingsSchema.optional()
}), BaseSchemaWithHandle = BaseSchema.extend({
  handle: HandleSchema
}), UnifiedSchema = z.object({
  api_version: ApiVersionSchema.optional(),
  description: z.string().optional(),
  extensions: z.array(z.any()),
  settings: SettingsSchema.optional()
});

// ../app/dist/cli/constants.js
init_cjs_shims();
var environmentVariableNames = {
  skipEsbuildReactDedeuplication: "SHOPIFY_CLI_SKIP_ESBUILD_REACT_DEDUPLICATION",
  disableGraphiQLExplorer: "SHOPIFY_CLI_DISABLE_GRAPHIQL",
  useDynamicConfigSpecifications: "SHOPIFY_CLI_DYNAMIC_CONFIG",
  enableAppLogPolling: "SHOPIFY_CLI_ENABLE_APP_LOG_POLLING"
}, configurationFileNames = {
  app: "shopify.app.toml",
  web: "shopify.web.toml",
  appEnvironments: "shopify.environments.toml",
  lockFile: ".shopify.lock"
}, dotEnvFileNames = {
  production: ".env"
}, versions = {
  reactTypes: "17.0.30"
}, blocks = {
  extensions: {
    directoryName: "extensions",
    defaultRegistrationLimit: 1
  },
  web: {
    directoryName: "web",
    configurationName: configurationFileNames.web
  }
}, ports = {
  graphiql: 3457
}, EsbuildEnvVarRegex = /^([a-zA-Z_$])([a-zA-Z0-9_$])*$/;

// ../cli-kit/dist/public/common/object.js
init_cjs_shims();

// ../cli-kit/dist/private/common/array.js
init_cjs_shims();
function unionArrayStrategy(destinationArray, sourceArray) {
  return Array.from(/* @__PURE__ */ new Set([...destinationArray, ...sourceArray]));
}

// ../cli-kit/dist/public/common/object.js
var import_deepmerge = __toESM(require_cjs2()), import_pickBy = __toESM(require_pickBy()), import_mapValues = __toESM(require_mapValues()), import_isEqual = __toESM(require_isEqual()), import_differenceWith = __toESM(require_differenceWith()), import_fromPairs = __toESM(require_fromPairs()), import_toPairs = __toESM(require_toPairs()), import_get = __toESM(require_get()), import_set = __toESM(require_set()), import_isEmpty = __toESM(require_isEmpty());
function deepMergeObjects(lhs, rhs, arrayMergeStrategy = unionArrayStrategy) {
  return (0, import_deepmerge.default)(lhs, rhs, { arrayMerge: arrayMergeStrategy });
}
function pickBy(object, predicate) {
  return (0, import_pickBy.default)(object, predicate);
}
function deepCompare(one, two) {
  return (0, import_isEqual.default)(one, two);
}
function deepDifference(one, two) {
  let changes = (0, import_differenceWith.default)((0, import_toPairs.default)(one), (0, import_toPairs.default)(two), deepCompare), changes2 = (0, import_differenceWith.default)((0, import_toPairs.default)(two), (0, import_toPairs.default)(one), deepCompare);
  return [(0, import_fromPairs.default)(changes), (0, import_fromPairs.default)(changes2)];
}
function getPathValue(object, path3) {
  return (0, import_get.default)(object, path3) === void 0 ? void 0 : (0, import_get.default)(object, path3);
}
function setPathValue(object, path3, value) {
  return (0, import_set.default)(object, path3, value);
}
function isEmpty(object) {
  return (0, import_isEmpty.default)(object);
}
function compact(object) {
  return Object.fromEntries(Object.entries(object).filter(([_2, value]) => value != null));
}

// ../app/dist/cli/models/extensions/specification.js
function createExtensionSpecification(spec3) {
  let merged = { ...{
    // these two fields are going to be overridden by the extension specification API response,
    // but we need them to have a default value for tests
    externalIdentifier: `${spec3.identifier}_external`,
    additionalIdentifiers: [],
    externalName: capitalize(spec3.identifier.replace(/_/g, " ")),
    surface: "test-surface",
    partnersWebIdentifier: spec3.identifier,
    schema: BaseSchema,
    registrationLimit: blocks.extensions.defaultRegistrationLimit,
    transform: spec3.transformLocalToRemote,
    reverseTransform: spec3.transformRemoteToLocal,
    experience: spec3.experience ?? "extension",
    uidStrategy: spec3.uidStrategy ?? (spec3.experience === "configuration" ? "single" : "uuid")
  }, ...spec3 };
  return {
    ...merged,
    contributeToAppConfigurationSchema: (appConfigSchema) => merged.uidStrategy !== "single" ? appConfigSchema : appConfigSchema.merge(merged.schema),
    parseConfigurationObject: (configurationObject) => {
      let parseResult = merged.schema.safeParse(configurationObject);
      return parseResult.success ? {
        state: "ok",
        data: parseResult.data,
        errors: void 0
      } : {
        state: "error",
        data: void 0,
        errors: parseResult.error.errors
      };
    }
  };
}
function createConfigExtensionSpecification(spec3) {
  let appModuleFeatures = spec3.appModuleFeatures ?? (() => []);
  return createExtensionSpecification({
    identifier: spec3.identifier,
    // This casting is required because `name` and `type` are mandatory for the existing extension spec configurations,
    // however, app config extensions config content is parsed from the `shopify.app.toml`
    schema: spec3.schema,
    appModuleFeatures,
    transformLocalToRemote: resolveAppConfigTransform(spec3.transformConfig),
    transformRemoteToLocal: resolveReverseAppConfigTransform(spec3.schema, spec3.transformConfig),
    experience: "configuration",
    uidStrategy: spec3.uidStrategy ?? "single"
  });
}
function neutralTopLevelSchema(...keys) {
  return z.object(Object.fromEntries(keys.map((key) => [key, z.any()])));
}
function createContractBasedConfigModuleSpecification(identifier, ...topLevelKeys) {
  let schema = neutralTopLevelSchema(...topLevelKeys);
  return createConfigExtensionSpecification({
    identifier,
    schema,
    transformConfig: {
      // outgoing config is already scoped to this module and passed directly along
      forward(obj) {
        return obj;
      },
      // incoming config from the platform is included in app config as-is
      reverse(obj) {
        return obj;
      }
    }
  });
}
function resolveAppConfigTransform(transformConfig) {
  return transformConfig ? Object.keys(transformConfig).includes("forward") ? transformConfig.forward : (content) => appConfigTransform(content, transformConfig) : (content) => defaultAppConfigTransform(content);
}
function resolveReverseAppConfigTransform(schema, transformConfig) {
  return transformConfig ? Object.keys(transformConfig).includes("reverse") ? transformConfig.reverse : (content) => appConfigTransform(content, transformConfig, !0) : (content) => defaultAppConfigReverseTransform(schema, content);
}
function appConfigTransform(content, config2, reverse = !1) {
  let transformedContent = {};
  for (let [mappedPath, objectPath] of Object.entries(config2)) {
    let originPath = reverse ? mappedPath : objectPath, targetPath = reverse ? objectPath : mappedPath, sourceValue = getPathValue(content, originPath);
    sourceValue !== void 0 && setPathValue(transformedContent, targetPath, sourceValue);
  }
  return transformedContent;
}
function defaultAppConfigTransform(content) {
  return Object.keys(content).reduce((result, key) => {
    let isObjectNotArray = content[key] !== null && typeof content[key] == "object" && !Array.isArray(content[key]);
    return { ...result, ...isObjectNotArray ? { ...content[key] } : { [key]: content[key] } };
  }, {});
}
function defaultAppConfigReverseTransform(schema, content) {
  return Object.keys(schema._def.shape()).reduce((result, key) => {
    let innerSchema = schema._def.shape()[key];
    return innerSchema instanceof z.ZodOptional && (innerSchema = innerSchema._def.innerType), innerSchema instanceof z.ZodObject ? result[key] = defaultAppConfigReverseTransform(innerSchema, content) : (content[key] !== void 0 && (result[key] = content[key]), delete content[key]), result;
  }, {});
}

// ../app/dist/cli/models/extensions/specifications/app_config_app_home.js
var AppHomeSchema = z.object({
  application_url: validateUrl(z.string({ required_error: "Valid URL is required" })),
  embedded: z.boolean({ required_error: "Boolean is required", invalid_type_error: "Value must be Boolean" }),
  app_preferences: z.object({
    url: validateUrl(z.string().max(255, { message: "String must be less than 255 characters" }))
  }).optional()
}), AppHomeTransformConfig = {
  app_url: "application_url",
  embedded: "embedded",
  preferences_url: "app_preferences.url"
}, AppHomeSpecIdentifier = "app_home", appHomeSpec = createConfigExtensionSpecification({
  identifier: AppHomeSpecIdentifier,
  schema: AppHomeSchema,
  transformConfig: AppHomeTransformConfig
}), app_config_app_home_default = appHomeSpec;

// ../app/dist/cli/models/extensions/specifications/app_config_branding.js
init_cjs_shims();
var BrandingSchema = z.object({
  name: z.string({ required_error: "String is required" }).max(30, { message: "String must be less than 30 characters" }),
  handle: z.string({ required_error: "String is required" }).max(256, { message: "String must be less than 256 characters long" }).refine((value) => value && /^\w*(?!-)[a-z0-9-]+(?<!-)$/.test(value), {
    message: "String can't contain special characters"
  }).optional()
}), BrandingTransformConfig = {
  name: "name",
  app_handle: "handle"
}, BrandingSpecIdentifier = "branding", appBrandingSpec = createConfigExtensionSpecification({
  identifier: BrandingSpecIdentifier,
  schema: BrandingSchema,
  transformConfig: BrandingTransformConfig
}), app_config_branding_default = appBrandingSpec;

// ../app/dist/cli/models/extensions/specifications/app_config_webhook.js
init_cjs_shims();

// ../app/dist/cli/models/extensions/specifications/app_config_webhook_schemas/webhooks_schema.js
init_cjs_shims();

// ../app/dist/cli/models/extensions/specifications/app_config_webhook_schemas/webhook_subscription_schema.js
init_cjs_shims();

// ../app/dist/cli/models/extensions/specifications/validation/common.js
init_cjs_shims();
var httpsRegex = /^(https:\/\/)/, pubSubRegex = /^pubsub:\/\/(?<gcp_project_id>[^:]+):(?<gcp_topic>.+)$/, arnRegex = /^arn:aws:events:(?<aws_region>[a-z]{2}-[a-z]+-[0-9]+)::event-source\/aws\.partner\/shopify\.com(\.test)?\/(?<api_client_id>\d+)\/(?<event_source_name>.+)$/, removeTrailingSlash = (arg) => typeof arg == "string" && arg.endsWith("/") ? arg.replace(/\/+$/, "") : arg, WebhookSubscriptionUriValidation = z.string({ invalid_type_error: "Value must be string" }).refine((uri) => uri.startsWith("/") ? !0 : httpsRegex.test(uri) || pubSubRegex.test(uri) || arnRegex.test(uri), {
  message: "URI format isn't correct. Valid formats include: relative path starting with a slash, HTTPS URL, pubsub://{project-id}:{topic-id} or Eventbridge ARN"
});

// ../app/dist/cli/models/extensions/specifications/app_config_webhook_schemas/webhook_subscription_schema.js
var ComplianceTopic;
(function(ComplianceTopic2) {
  ComplianceTopic2.CustomersRedact = "customers/redact", ComplianceTopic2.CustomersDataRequest = "customers/data_request", ComplianceTopic2.ShopRedact = "shop/redact";
})(ComplianceTopic || (ComplianceTopic = {}));
var WebhookSubscriptionSchema = z.object({
  topics: z.array(z.string({ invalid_type_error: "Values within array must be a string" }), {
    invalid_type_error: "Value must be string[]"
  }).optional(),
  uri: z.preprocess(removeTrailingSlash, WebhookSubscriptionUriValidation, { required_error: "Missing value at" }),
  include_fields: z.array(z.string({ invalid_type_error: "Value must be a string" })).optional(),
  filter: z.string({ invalid_type_error: "Value must be a string" }).optional(),
  compliance_topics: z.array(z.enum([ComplianceTopic.CustomersRedact, ComplianceTopic.CustomersDataRequest, ComplianceTopic.ShopRedact]), {
    invalid_type_error: "Value must be an array containing values: customers/redact, customers/data_request or shop/redact"
  }).optional()
});

// ../app/dist/cli/models/extensions/specifications/validation/app_config_webhook.js
init_cjs_shims();
function webhookValidator(schema, ctx) {
  let webhookSubscriptionErrors = validateSubscriptions(schema);
  if (webhookSubscriptionErrors)
    return ctx.addIssue(webhookSubscriptionErrors), z.NEVER;
}
function validateSubscriptions(webhookConfig) {
  let { subscriptions = [] } = webhookConfig, uniqueSubscriptionSet = /* @__PURE__ */ new Set(), duplicatedSubscriptionsFields = [];
  if (!subscriptions.length)
    return;
  if (webhookConfig.privacy_compliance && webhookConfig.subscriptions?.some((subscription) => subscription.compliance_topics))
    return {
      code: z.ZodIssueCode.custom,
      message: "The privacy_compliance section can't be used if there are subscriptions including compliance_topics"
    };
  let complianceTopics = subscriptions.flatMap((subscription) => subscription.compliance_topics).filter(Boolean);
  if (uniq(complianceTopics).length !== complianceTopics.length)
    return {
      code: z.ZodIssueCode.custom,
      message: "You can\u2019t have multiple subscriptions with the same compliance topic",
      fatal: !0,
      path: ["subscriptions"]
    };
  for (let [i, { uri, topics = [], compliance_topics = [], filter = "" }] of subscriptions.entries()) {
    let path3 = ["subscriptions", i];
    if (!topics.length && !compliance_topics.length)
      return {
        code: z.ZodIssueCode.custom,
        message: "Either topics or compliance_topics must be added to the webhook subscription",
        path: path3
      };
    topics.forEach((topic) => {
      let key = `${topic}::${uri}::${filter}`;
      if (uniqueSubscriptionSet.has(key)) {
        let subscriptionFieldsString = filter ? source_default.dim(`

topic: ${topic}
uri: ${uri}
filter: ${filter}`) : source_default.dim(`

topic: ${topic}
uri: ${uri}`);
        duplicatedSubscriptionsFields.push(subscriptionFieldsString);
      }
      uniqueSubscriptionSet.add(key);
    });
  }
  if (duplicatedSubscriptionsFields.length > 0) {
    let fieldsArrToString = duplicatedSubscriptionsFields.join("");
    return {
      code: z.ZodIssueCode.custom,
      message: `Multiple subscriptions with the exact same topic, uri, and filter. To resolve, remove or edit the duplicates ${fieldsArrToString}`,
      path: ["subscriptions"]
    };
  }
}

// ../app/dist/cli/models/extensions/specifications/transform/app_config_webhook.js
init_cjs_shims();
function transformFromWebhookConfig(content) {
  let webhooks = getPathValue(content, "webhooks");
  if (!webhooks)
    return content;
  let { api_version } = webhooks;
  return { api_version };
}
function transformToWebhookConfig(content) {
  let webhooks = {}, apiVersion = getPathValue(content, "api_version");
  return webhooks = { ...apiVersion ? { webhooks: { api_version: apiVersion } } : {} }, webhooks;
}
function mergeAllWebhooks(subscriptions) {
  if (subscriptions.length === 0)
    return;
  let topicSubscriptions = subscriptions.filter((subscription) => subscription.topics !== void 0).flatMap(({ compliance_topics, topics, ...rest }) => sortArrayAlphabetically(topics)?.map((topic) => ({ topics: [topic], ...rest })) ?? []), complianceSubscriptions = subscriptions.filter((subscription) => subscription.topics === void 0 || subscription.compliance_topics !== void 0).map(({ compliance_topics, topics, ...rest }) => ({ compliance_topics, ...rest })), mergedComplianceSubscriptions = reduceWebhooks(complianceSubscriptions, "compliance_topics"), sortedComplianceTopicsSubscriptions = sortComplianceTopics(mergedComplianceSubscriptions);
  return [...sortWebhooksByUri(sortedComplianceTopicsSubscriptions), ...sortWebhooksByUri(topicSubscriptions)];
}
function sortArrayAlphabetically(array) {
  return array?.sort((first, second) => first.localeCompare(second));
}
function sortWebhooksByUri(subscriptions) {
  return subscriptions.sort((oneSub, twoSub) => oneSub.uri.localeCompare(twoSub.uri));
}
function sortComplianceTopics(subscriptions) {
  return subscriptions.forEach((sub) => sub.compliance_topics = sortArrayAlphabetically(sub.compliance_topics)), subscriptions;
}
function findSubscription(subscriptions, subscription) {
  return subscriptions.find((sub) => sub.uri === subscription.uri && deepCompare(sub.include_fields ?? [], subscription.include_fields ?? []) && sub.filter === subscription.filter);
}
function reduceWebhooks(subscriptions, property) {
  return subscriptions.reduce((accumulator, subscription) => {
    let existingSubscription = findSubscription(accumulator, subscription);
    return existingSubscription ? property && subscription?.[property]?.length ? existingSubscription[property]?.push(...subscription[property]) : (subscription.topics && (existingSubscription.topics ?? (existingSubscription.topics = []), existingSubscription.topics.push(...subscription.topics)), subscription.compliance_topics && (existingSubscription.compliance_topics ?? (existingSubscription.compliance_topics = []), existingSubscription.compliance_topics.push(...subscription.compliance_topics))) : accumulator.push(subscription), accumulator;
  }, []);
}

// ../app/dist/cli/models/extensions/specifications/app_config_webhook_schemas/webhooks_schema.js
var WebhooksConfigSchema = z.object({
  api_version: z.string({ required_error: "String is required" }),
  privacy_compliance: z.object({
    customer_deletion_url: WebhookSubscriptionUriValidation.optional(),
    customer_data_request_url: WebhookSubscriptionUriValidation.optional(),
    shop_deletion_url: WebhookSubscriptionUriValidation.optional()
  }).optional(),
  subscriptions: z.array(WebhookSubscriptionSchema).optional().transform((value) => mergeAllWebhooks(value ?? []))
}), WebhooksSchema = z.object({
  webhooks: WebhooksConfigSchema.superRefine(webhookValidator)
});

// ../app/dist/cli/models/extensions/specifications/app_config_webhook.js
var WebhooksSpecIdentifier = "webhooks", WebhookTransformConfig = {
  forward: transformFromWebhookConfig,
  reverse: (content) => transformToWebhookConfig(content)
}, appWebhooksSpec = createConfigExtensionSpecification({
  identifier: WebhooksSpecIdentifier,
  schema: WebhooksSchema,
  transformConfig: WebhookTransformConfig
}), app_config_webhook_default = appWebhooksSpec;

// ../app/dist/cli/models/extensions/specifications/app_config_app_access.js
init_cjs_shims();
var AppAccessSchema = z.object({
  access: z.object({
    admin: z.object({
      direct_api_mode: z.union([z.literal("online"), z.literal("offline")]).optional(),
      embedded_app_direct_api_access: z.boolean().optional()
    }).optional()
  }).optional(),
  access_scopes: z.object({
    scopes: z.string().transform((scopes) => normalizeDelimitedString(scopes) ?? "").optional(),
    required_scopes: z.array(z.string()).optional(),
    optional_scopes: z.array(z.string()).optional(),
    use_legacy_install_flow: z.boolean().optional()
  }).optional(),
  auth: z.object({
    redirect_urls: z.array(validateUrl(z.string()))
  })
}), AppAccessSpecIdentifier = "app_access", AppAccessTransformConfig = {
  access: "access",
  scopes: "access_scopes.scopes",
  required_scopes: "access_scopes.required_scopes",
  optional_scopes: "access_scopes.optional_scopes",
  use_legacy_install_flow: "access_scopes.use_legacy_install_flow",
  redirect_url_allowlist: "auth.redirect_urls"
}, appAccessSpec = createConfigExtensionSpecification({
  identifier: AppAccessSpecIdentifier,
  schema: AppAccessSchema,
  transformConfig: AppAccessTransformConfig
}), app_config_app_access_default = appAccessSpec;

// ../app/dist/cli/models/extensions/extension-instance.js
init_cjs_shims();

// ../app/dist/cli/models/extensions/specifications/app_config_app_proxy.js
init_cjs_shims();
var AppProxySchema = z.object({
  app_proxy: z.object({
    url: validateUrl(z.string({ invalid_type_error: "Value must be a valid URL" })),
    subpath: z.string({ invalid_type_error: "Value must be a string" }),
    prefix: z.string({ invalid_type_error: "Value must be a string" })
  }).optional()
}), AppProxySpecIdentifier = "app_proxy", appProxySpec = createConfigExtensionSpecification({
  identifier: AppProxySpecIdentifier,
  schema: AppProxySchema
}), app_config_app_proxy_default = appProxySpec;

// ../app/dist/cli/models/extensions/specifications/app_config_point_of_sale.js
init_cjs_shims();
var PosConfigurationSchema = z.object({
  pos: z.object({
    embedded: z.boolean({ invalid_type_error: "Value must be Boolean" })
  }).optional()
}), PosSpecIdentifier = "point_of_sale", appPOSSpec = createConfigExtensionSpecification({
  identifier: PosSpecIdentifier,
  schema: PosConfigurationSchema
}), app_config_point_of_sale_default = appPOSSpec;

// ../app/dist/cli/models/extensions/specifications/app_config_privacy_compliance_webhooks.js
init_cjs_shims();
var PrivacyComplianceWebhooksTransformConfig = {
  forward: transformToPrivacyComplianceWebhooksModule,
  reverse: (content, options) => transformFromPrivacyComplianceWebhooksModule(content, options)
}, PrivacyComplianceWebhooksSpecIdentifier = "privacy_compliance_webhooks", appPrivacyComplienceSpec = createConfigExtensionSpecification({
  identifier: PrivacyComplianceWebhooksSpecIdentifier,
  schema: WebhooksSchema,
  transformConfig: PrivacyComplianceWebhooksTransformConfig
}), app_config_privacy_compliance_webhooks_default = appPrivacyComplienceSpec;
function transformToPrivacyComplianceWebhooksModule(content, appConfiguration) {
  let webhooks = getPathValue(content, "webhooks"), appUrl;
  "application_url" in appConfiguration && (appUrl = appConfiguration?.application_url);
  let urls = compact({
    customers_redact_url: relativeUri(getCustomersDeletionUri(webhooks), appUrl),
    customers_data_request_url: relativeUri(getCustomersDataRequestUri(webhooks), appUrl),
    shop_redact_url: relativeUri(getShopDeletionUri(webhooks), appUrl)
  });
  if (Object.keys(urls).length === 0)
    return urls;
  {
    let { api_version } = webhooks;
    return {
      api_version,
      ...urls
    };
  }
}
function transformFromPrivacyComplianceWebhooksModule(content, options) {
  let customersRedactUrl = getPathValue(content, "customers_redact_url"), customersDataRequestUrl = getPathValue(content, "customers_data_request_url"), shopRedactUrl = getPathValue(content, "shop_redact_url");
  if (options?.flags?.includes(Flag.DeclarativeWebhooks)) {
    let webhooks = [];
    return customersDataRequestUrl && webhooks.push({ compliance_topics: [ComplianceTopic.CustomersDataRequest], uri: customersDataRequestUrl }), customersRedactUrl && webhooks.push({ compliance_topics: [ComplianceTopic.CustomersRedact], uri: customersRedactUrl }), shopRedactUrl && webhooks.push({ compliance_topics: [ComplianceTopic.ShopRedact], uri: shopRedactUrl }), webhooks.length === 0 ? {} : { webhooks: { subscriptions: mergeAllWebhooks(webhooks), privacy_compliance: void 0 } };
  }
  return customersRedactUrl || customersDataRequestUrl || shopRedactUrl ? {
    webhooks: {
      privacy_compliance: {
        ...customersRedactUrl ? { customer_deletion_url: customersRedactUrl } : {},
        ...customersDataRequestUrl ? { customer_data_request_url: customersDataRequestUrl } : {},
        ...shopRedactUrl ? { shop_deletion_url: shopRedactUrl } : {}
      }
    }
  } : {};
}
function getComplianceUri(webhooks, complianceTopic) {
  return webhooks.subscriptions?.find((subscription) => subscription.compliance_topics?.includes(complianceTopic))?.uri;
}
function relativeUri(uri, appUrl) {
  return appUrl && uri?.startsWith("/") ? `${appUrl}${uri}` : uri;
}
function getCustomersDeletionUri(webhooks) {
  return getComplianceUri(webhooks, "customers/redact") || webhooks?.privacy_compliance?.customer_deletion_url;
}
function getCustomersDataRequestUri(webhooks) {
  return getComplianceUri(webhooks, "customers/data_request") || webhooks?.privacy_compliance?.customer_data_request_url;
}
function getShopDeletionUri(webhooks) {
  return getComplianceUri(webhooks, "shop/redact") || webhooks?.privacy_compliance?.shop_deletion_url;
}

// ../app/dist/cli/models/extensions/specifications/app_config_webhook_subscription.js
init_cjs_shims();
var WebhookSubscriptionSpecIdentifier = "webhook_subscription", SingleWebhookSubscriptionSchema = z.object({
  topic: z.string(),
  api_version: z.string(),
  uri: z.preprocess(removeTrailingSlash, WebhookSubscriptionUriValidation, { required_error: "Missing value at" }),
  include_fields: z.array(z.string({ invalid_type_error: "Value must be a string" })).optional(),
  filter: z.string({ invalid_type_error: "Value must be a string" }).optional()
});
function transformToWebhookSubscriptionConfig(content) {
  let { api_version: _2, topic, ...otherFields } = content;
  return {
    webhooks: {
      subscriptions: [{
        topics: [topic],
        ...otherFields
      }]
    }
  };
}
var WebhookSubscriptionTransformConfig = {
  forward: (content, appConfiguration) => {
    let webhookConfig = content, appUrl;
    return "application_url" in appConfiguration && (appUrl = appConfiguration?.application_url), {
      ...webhookConfig,
      uri: appUrl && webhookConfig.uri.startsWith("/") ? `${appUrl}${webhookConfig.uri}` : webhookConfig.uri
    };
  },
  reverse: transformToWebhookSubscriptionConfig
}, appWebhookSubscriptionSpec = createConfigExtensionSpecification({
  identifier: WebhookSubscriptionSpecIdentifier,
  schema: SingleWebhookSubscriptionSchema,
  transformConfig: WebhookSubscriptionTransformConfig,
  uidStrategy: "dynamic"
}), app_config_webhook_subscription_default = appWebhookSubscriptionSpec;

// ../app/dist/cli/services/build/extension.js
init_cjs_shims();

// ../app/dist/cli/services/build/theme-check.js
init_cjs_shims();
var import_theme_check_node3 = __toESM(require_dist5(), 1);
function getSnippet2(absolutePath, startLine, endLine) {
  let snippetLines = readFileSync(absolutePath).toString().split(`
`).slice(startLine, endLine + 1), isSingleLine = snippetLines.length === 1;
  return snippetLines.map((line, index) => {
    let lineNumber = startLine + index + 1, formattedLine = isSingleLine ? line.trim() : line;
    return `${lineNumber}  ${formattedLine}`;
  }).join(`
`);
}
function severityToToken2(severity) {
  switch (severity) {
    case import_theme_check_node3.Severity.ERROR:
      return { error: `
[error]:` };
    case import_theme_check_node3.Severity.WARNING:
      return { warn: `
[warning]:` };
    case import_theme_check_node3.Severity.INFO:
      return { info: `
[info]:` };
  }
}
function formatOffenses2(offenses) {
  return offenses.map((offense, index) => {
    let { message, absolutePath, start, end, check: check2, severity } = offense, codeSnippet = getSnippet2(absolutePath, start.line, end.line), offensePadding = `${index === offenses.length - 1 ? "" : `

`}`;
    return [
      severityToToken2(severity),
      { bold: `${check2}` },
      { subdued: `
${message}` },
      `

${codeSnippet}`,
      offensePadding
    ];
  }).flat();
}
async function runThemeCheck(directory) {
  let offenses = await (0, import_theme_check_node3.check)(directory, "theme-check:theme-app-extension"), formattedOffenses = formatOffenses2(offenses);
  return itemToString(formattedOffenses);
}

// ../app/dist/cli/services/extensions/bundle.js
init_cjs_shims();

// ../app/dist/cli/utilities/extensions/theme.js
init_cjs_shims();
import { createInterface as createInterface2 } from "readline";
var ignoredFilePatterns = [
  ".git",
  ".hg",
  ".bzr",
  ".svn",
  "_darcs",
  "CVS",
  ".sublime-(project|workspace)",
  ".DS_Store",
  ".sass-cache",
  "Thumbs.db",
  "desktop.ini",
  "config.yml",
  "node_modules",
  ".gitkeep",
  ".shopifyignore",
  "*.toml"
];
async function themeExtensionFiles(themeExtension) {
  let filename = ".shopifyignore", filepath = joinPath(themeExtension.directory, filename), ignore = ignoredFilePatterns.map((pattern) => joinPath("*", pattern));
  if (fileExistsSync(filepath)) {
    let patterns = await parseIgnoreFile(filepath);
    ignore.push(...patterns);
  }
  return glob("*/*", {
    absolute: !0,
    cwd: themeExtension.directory,
    ignore
  });
}
function parseIgnoreFile(filepath) {
  return new Promise((resolve2, reject) => {
    let patterns = [], readLineInterface = createInterface2({
      input: createFileReadStream(filepath),
      crlfDelay: 1 / 0
    });
    readLineInterface.on("line", (line) => {
      let trimmedLine = line.trim();
      trimmedLine.length > 0 && !trimmedLine.startsWith("#") && patterns.push(trimmedLine);
    }), readLineInterface.on("close", () => {
      resolve2(patterns);
    }), readLineInterface.on("error", (error) => {
      reject(error);
    });
  });
}

// ../app/dist/cli/utilities/extensions/flow-template.js
init_cjs_shims();
var includedFilePatterns = ["*.flow", "*.json", "*.toml"];
async function flowTemplateExtensionFiles(flowTemplateExtension) {
  let include = includedFilePatterns.map((pattern) => joinPath("**", pattern));
  return glob(include, {
    absolute: !0,
    cwd: flowTemplateExtension.directory
  });
}

// ../app/dist/cli/services/extensions/bundle.js
import { context as esContext, formatMessagesSync } from "esbuild";
var import_esbuild_graphql_loader = __toESM(require_lib6(), 1);
async function bundleExtension(options, processEnv = process.env) {
  let esbuildOptions = getESBuildOptions(options, processEnv), context = await esContext(esbuildOptions);
  if (options.watch)
    await context.watch();
  else {
    let result = await context.rebuild();
    onResult(result, options), await context.dispose();
  }
  options.watchSignal && options.watchSignal.addEventListener("abort", async () => {
    await context.dispose();
  });
}
async function bundleThemeExtension(extension, options) {
  options.stdout.write(`Bundling theme extension ${extension.localIdentifier}...`);
  let files = await themeExtensionFiles(extension);
  await Promise.all(files.map(function(filepath) {
    let relativePathName = relativePath(extension.directory, filepath), outputFile = joinPath(extension.outputPath, relativePathName);
    return copyFile(filepath, outputFile);
  }));
}
async function bundleFlowTemplateExtension(extension) {
  let files = await flowTemplateExtensionFiles(extension);
  await Promise.all(files.map(function(filepath) {
    let relativePathName = relativePath(extension.directory, filepath), outputFile = joinPath(extension.outputPath, relativePathName);
    if (filepath !== outputFile)
      return copyFile(filepath, outputFile);
  }));
}
function onResult(result, options) {
  let warnings = result?.warnings ?? [], errors2 = result?.errors ?? [];
  warnings.length > 0 && formatMessagesSync(warnings, { kind: "warning" }).forEach((warning) => {
    options.stdout.write(warning);
  }), errors2.length > 0 && formatMessagesSync(errors2, { kind: "error" }).forEach((error) => {
    options.stderr.write(error);
  });
}
function getESBuildOptions(options, processEnv = process.env) {
  let validEnvs = pickBy(processEnv, (value, key) => EsbuildEnvVarRegex.test(key) && value), env = { ...options.env, ...validEnvs }, define2 = Object.keys(env || {}).reduce((acc, key) => ({
    ...acc,
    [`process.env.${key}`]: JSON.stringify(env[key])
  }), { "process.env.NODE_ENV": JSON.stringify(options.environment) }), esbuildOptions = {
    outfile: options.outputPath,
    stdin: options.stdin,
    bundle: !0,
    define: define2,
    jsx: "automatic",
    loader: {
      ".esnext": "ts",
      ".js": "jsx"
    },
    legalComments: "none",
    minify: options.minify,
    plugins: getPlugins(options.stdin.resolveDir, processEnv),
    target: "es6",
    resolveExtensions: [".tsx", ".ts", ".js", ".json", ".esnext", ".mjs", ".ejs"]
  };
  if (options.watch) {
    let watch = options.watch;
    esbuildOptions.plugins?.push({
      name: "rebuild-plugin",
      setup(build2) {
        build2.onEnd(async (result) => {
          onResult(result, options), await watch(result);
        });
      }
    });
  }
  return options.sourceMaps && (esbuildOptions.sourcemap = !0, esbuildOptions.sourceRoot = `${options.stdin.resolveDir}/src`), esbuildOptions;
}
function getPlugins(resolveDir, processEnv = process.env) {
  let plugins = [import_esbuild_graphql_loader.default.default()], skipReactDeduplication = isTruthy(processEnv[environmentVariableNames.skipEsbuildReactDedeuplication]);
  if (resolveDir && !skipReactDeduplication) {
    let resolvedReactPath;
    try {
      resolvedReactPath = __require.resolve("react", { paths: [resolveDir] });
    } catch {
      outputDebug(`Unable to load React in ${resolveDir}, skipping React de-duplication`);
    }
    resolvedReactPath && (outputDebug(`Deduplicating React dependency for ${resolveDir}, using ${resolvedReactPath}`), plugins.push(deduplicateReactPlugin(resolvedReactPath)));
  }
  return plugins;
}
function deduplicateReactPlugin(resolvedReactPath) {
  return {
    name: "shopify:deduplicate-react",
    setup({ onResolve }) {
      onResolve({ filter: /^react$/ }, (_args) => ({
        path: resolvedReactPath
      }));
    }
  };
}

// ../app/dist/cli/services/function/build.js
init_cjs_shims();

// ../app/dist/cli/services/function/binaries.js
init_cjs_shims();
import stream from "node:stream/promises";
import * as gzip from "node:zlib";
import { fileURLToPath as fileURLToPath5 } from "node:url";
var JAVY_VERSION = "v3.0.1", FUNCTION_RUNNER_VERSION = "v5.1.3", DownloadableBinary = class {
  constructor(name, version2, gitHubRepo) {
    this.name = name, this.version = version2;
    let filename = process.platform === "win32" ? `${name}.exe` : name;
    this.path = joinPath(dirname(fileURLToPath5(import.meta.url)), "..", "bin", filename), this.gitHubRepo = gitHubRepo;
  }
  downloadUrl(processPlatform, processArch) {
    let platform2, arch;
    switch (processPlatform.toLowerCase()) {
      case "darwin":
        platform2 = "macos";
        break;
      case "linux":
        platform2 = "linux";
        break;
      case "win32":
        platform2 = "windows";
        break;
      default:
        throw Error(`Unsupported platform ${processPlatform}`);
    }
    switch (processArch.toLowerCase()) {
      case "arm":
      case "arm64":
        arch = "arm";
        break;
      case "ia32":
      case "x64":
        arch = "x86_64";
        break;
      default:
        throw Error(`Unsupported architecture ${processArch}`);
    }
    let archPlatform = `${arch}-${platform2}`;
    if (!["arm-linux", "arm-macos", "x86_64-macos", "x86_64-windows", "x86_64-linux"].includes(archPlatform))
      throw Error(`Unsupported platform/architecture combination ${processPlatform}/${processArch}`);
    return `https://github.com/${this.gitHubRepo}/releases/download/${this.version}/${this.name}-${archPlatform}-${this.version}.gz`;
  }
  async processResponse(responseStream, outputStream) {
    let gunzip = gzip.createGunzip();
    await stream.pipeline(responseStream, gunzip, outputStream);
  }
}, _javy, _functionRunner;
function javyBinary() {
  return _javy || (_javy = new DownloadableBinary("javy", JAVY_VERSION, "bytecodealliance/javy")), _javy;
}
function functionRunnerBinary() {
  return _functionRunner || (_functionRunner = new DownloadableBinary("function-runner", FUNCTION_RUNNER_VERSION, "Shopify/function-runner")), _functionRunner;
}
async function installBinary(bin) {
  if (await fileExists(bin.path))
    return;
  let url = bin.downloadUrl(process.platform, process.arch);
  outputDebug(`Downloading ${bin.name} ${bin.version} from ${url} to ${bin.path}`), await mkdir(dirname(bin.path));
  let resp = await fetch(url);
  if (resp.status !== 200)
    throw new Error(`Downloading ${bin.name} failed with status code of ${resp.status}`);
  let responseStream = resp.body;
  if (responseStream === null)
    throw new Error(`Downloading ${bin.name} failed with empty response body`);
  let outputStream = createFileWriteStream(bin.path);
  await bin.processResponse(responseStream, outputStream), await chmod(bin.path, 509);
}

// ../app/dist/cli/services/function/build.js
import { build as esBuild } from "esbuild";
async function buildJSFunction(fun, options) {
  let exports = jsExports(fun), javyBuilder = exports.length === 0 ? DefaultJavyBuilder : new ExportJavyBuilder(exports);
  return options.useTasks ? buildJSFunctionWithTasks(fun, options, javyBuilder) : buildJSFunctionWithoutTasks(fun, options, javyBuilder);
}
async function buildJSFunctionWithoutTasks(fun, options, builder) {
  options.signal?.aborted || (options.stdout.write(`Building function ${fun.localIdentifier}...`), options.stdout.write(`Building GraphQL types...
`), await buildGraphqlTypes(fun, options)), options.signal?.aborted || (options.stdout.write(`Bundling JS function...
`), await builder.bundle(fun, options)), options.signal?.aborted || (options.stdout.write(`Running javy...
`), await builder.compile(fun, options)), options.signal?.aborted || options.stdout.write(`Done!
`);
}
async function buildJSFunctionWithTasks(fun, options, builder) {
  await renderTasks([
    {
      title: "Building GraphQL types",
      task: async () => {
        await buildGraphqlTypes(fun, options);
      }
    },
    {
      title: "Bundling JS function",
      task: async () => {
        await builder.bundle(fun, options);
      }
    },
    {
      title: "Running javy",
      task: async () => {
        await builder.compile(fun, options);
      }
    }
  ]);
}
async function buildGraphqlTypes(fun, options) {
  if (!fun.isJavaScript)
    throw new Error("GraphQL types can only be built for JavaScript functions");
  return runWithTimer("cmd_all_timing_network_ms")(async () => exec("npm", ["exec", "--", "graphql-code-generator", "--config", "package.json"], {
    cwd: fun.directory,
    stderr: options.stderr,
    signal: options.signal
  }));
}
async function bundleExtension2(fun, options, processEnv = process.env) {
  let entryPoint = await findPathUp("node_modules/@shopify/shopify_function/index.ts", {
    type: "file",
    cwd: fun.directory
  });
  if (!entryPoint)
    throw new Error("Could not find the Shopify Function runtime. Make sure you have '@shopify/shopify_function' installed");
  if (!fun.entrySourceFilePath)
    throw new Error("Could not find your function entry point. It must be in src/index.js or src/index.ts");
  let esbuildOptions = {
    ...getESBuildOptions2(fun.directory, fun.entrySourceFilePath, options.app.dotenv?.variables ?? {}, processEnv),
    entryPoints: [entryPoint]
  };
  return esBuild(esbuildOptions);
}
function getESBuildOptions2(directory, userFunction, appEnv, processEnv = process.env) {
  let validEnvs = pickBy(processEnv, (value, key) => EsbuildEnvVarRegex.test(key) && value), env = { ...appEnv, ...validEnvs }, define2 = Object.keys(env || {}).reduce((acc, key) => ({
    ...acc,
    [`process.env.${key}`]: JSON.stringify(env[key])
  }), {});
  return {
    outfile: joinPath(directory, "dist/function.js"),
    alias: {
      "user-function": userFunction
    },
    define: define2,
    logLevel: "silent",
    bundle: !0,
    legalComments: "none",
    target: "es2022",
    format: "esm"
  };
}
async function runJavy(fun, options, extra = []) {
  let args = ["compile", "-d", "-o", fun.outputPath, "dist/function.js", ...extra];
  return exec(javyBinary().path, args, {
    cwd: fun.directory,
    stdout: "inherit",
    stderr: "inherit",
    signal: options.signal
  });
}
async function installJavy(app) {
  if (app.allExtensions.some((ext) => ext.features.includes("function") && ext.isJavaScript)) {
    let javy = javyBinary();
    await installBinary(javy);
  }
}
async function runFunctionRunner(fun, options) {
  let functionRunner = functionRunnerBinary();
  await installBinary(functionRunner);
  let outputAsJson = options.json ? ["--json"] : [], withInput = options.input ? ["--input", options.input] : [], exportName = options.export ? ["--export", options.export] : [];
  return exec(functionRunner.path, ["-f", fun.outputPath, ...withInput, ...outputAsJson, ...exportName], {
    cwd: fun.directory,
    stdin: "inherit",
    stdout: "inherit",
    stderr: "inherit"
  });
}
var DefaultJavyBuilder = {
  async bundle(fun, options) {
    return bundleExtension2(fun, options);
  },
  async compile(fun, options) {
    return runJavy(fun, options);
  }
}, JAVY_WORLD = "shopify-function", ExportJavyBuilder = class {
  constructor(exports) {
    this.exports = exports;
  }
  async bundle(fun, options, processEnv = process.env) {
    if (!fun.entrySourceFilePath)
      throw new Error("Could not find your function entry point. It must be in src/index.js or src/index.ts");
    let contents = this.entrypointContents;
    outputDebug("Generating dist/function.js using generated module:"), outputDebug(contents);
    let esbuildOptions = {
      ...getESBuildOptions2(fun.directory, fun.entrySourceFilePath, options.app.dotenv?.variables ?? {}, processEnv),
      stdin: {
        contents,
        loader: "ts",
        resolveDir: fun.directory
      }
    };
    return esBuild(esbuildOptions);
  }
  async compile(fun, options) {
    let witContent = this.wit;
    return outputDebug("Generating world to use with Javy:"), outputDebug(witContent), inTemporaryDirectory(async (dir) => {
      let witPath = joinPath(dir, "javy-world.wit");
      return await writeFile(witPath, witContent), runJavy(fun, options, ["--wit", witPath, "-n", JAVY_WORLD]);
    });
  }
  get wit() {
    let witExports = this.exports.map((name) => `export %${hyphenate(name)}: func();`);
    return `package function:impl;

world ${JAVY_WORLD} {
  ${witExports.join(`
  `)}
}`;
  }
  get entrypointContents() {
    let prelude = `
import __runFunction from "@shopify/shopify_function/run"`, exports = this.exports.map((name) => {
      let identifier = camelize(name), alias = camelize(`run-${name}`);
      return `
import { ${identifier} as ${alias} } from "user-function"
export function ${identifier}() { return __runFunction(${alias}) }`;
    });
    return `${prelude}
${exports.join(`
`)}`;
  }
};
function jsExports(fun) {
  let targets = fun.configuration.targeting || [], withoutExport = targets.filter((target) => !target.export), withExport = targets.filter((target) => !!target.export);
  if (targets.length > 1 && withoutExport.length > 0)
    throw new Error(`Can't infer export name for targets:
${withoutExport.map(({ target }) => `- '${target}'`).join(`
`)}
All targets must have an export when multiple targets are present.`);
  let withInvalidExportName = withExport.filter((target) => !target.export.match(/^[a-z0-9-]+$/));
  if (withInvalidExportName.length > 0) {
    let message = [], invalidExportNames = withInvalidExportName.map((target) => `'${target.export}'`);
    throw message.push(`Invalid export names: ${invalidExportNames.join(", ")}.

The TOML's exports must be kebab-case (lowercase, hyphen or numbers) to comply with WebAssembly's Component Model.

JavaScript exports with camelCase names are automatically mapped to kebab-case Wasm exports.
`), message.push("Suggested TOML changes:"), withInvalidExportName.forEach((target) => {
      let name = target.export;
      message.push(`- Change export for '${target.target}' to '${hyphenate(name)}'.`);
    }), new Error(message.join(`
`));
  }
  return withExport.map((target) => target.export);
}

// ../app/dist/cli/services/build/extension.js
var import_proper_lockfile = __toESM(require_proper_lockfile(), 1);
async function buildThemeExtension(extension, options) {
  if (options.environment === "development")
    return;
  options.stdout.write("Running theme check on your Theme app extension...");
  let offenses = await runThemeCheck(extension.directory);
  options.stdout.write(offenses);
}
async function buildFlowTemplateExtension(extension, options) {
  options.stdout.write(`Building Flow Template extension ${extension.localIdentifier}...`), await bundleFlowTemplateExtension(extension), options.stdout.write(`${extension.localIdentifier} successfully built`);
}
async function buildUIExtension(extension, options) {
  options.stdout.write(`Bundling UI extension ${extension.localIdentifier}...`);
  let env = options.app.dotenv?.variables ?? {};
  options.appURL && (env.APP_URL = options.appURL);
  try {
    await bundleExtension({
      minify: !0,
      outputPath: extension.outputPath,
      stdin: {
        contents: extension.getBundleExtensionStdinContent(),
        resolveDir: extension.directory,
        loader: "tsx"
      },
      environment: options.environment,
      env,
      stderr: options.stderr,
      stdout: options.stdout
    });
  } catch {
    throw new AbortError(`Failed to bundle extension ${extension.localIdentifier}. Please check the extension source code for errors.`);
  }
  await extension.buildValidation(), options.stdout.write(`${extension.localIdentifier} successfully built`);
}
async function buildFunctionExtension(extension, options) {
  let lockfilePath = joinPath(extension.directory, ".build-lock"), releaseLock;
  try {
    releaseLock = await import_proper_lockfile.default.lock(extension.directory, { retries: 20, lockfilePath });
  } catch (error) {
    throw outputDebug(`Failed to acquire function build lock: ${error.message}`), new AbortError("Failed to build function.", "This is likely due to another in-progress build.", [
      "Ensure there are no other function builds in-progress.",
      "Delete the `.build-lock` file in your function directory."
    ]);
  }
  try {
    extension.isJavaScript ? await runCommandOrBuildJSFunction(extension, options) : await buildOtherFunction(extension, options);
  } finally {
    await releaseLock();
  }
}
async function runCommandOrBuildJSFunction(extension, options) {
  return extension.buildCommand ? runCommand(extension.buildCommand, extension, options) : buildJSFunction(extension, options);
}
async function buildOtherFunction(extension, options) {
  if (!extension.buildCommand)
    throw options.stderr.write(`The function extension ${extension.localIdentifier} doesn't have a build command or it's empty`), options.stderr.write(`
    Edit the shopify.function.extension.toml configuration file and set how to build the extension.

    [build]
    command = "{COMMAND}"

    Note that the command must output a dist/index.wasm file.
    `), new AbortSilentError();
  return runCommand(extension.buildCommand, extension, options);
}
async function runCommand(buildCommand, extension, options) {
  let buildCommandComponents = buildCommand.split(" ");
  options.stdout.write(`Building function ${extension.localIdentifier}...`), await exec(buildCommandComponents[0], buildCommandComponents.slice(1), {
    stdout: options.stdout,
    stderr: options.stderr,
    cwd: extension.directory,
    signal: options.signal
  });
}

// ../app/dist/cli/services/deploy/upload.js
init_cjs_shims();

// ../app/dist/cli/services/deploy/theme-extension-config.js
init_cjs_shims();
async function themeExtensionConfig(themeExtension) {
  let files = {}, themeFiles = await themeExtensionFiles(themeExtension);
  return await Promise.all(themeFiles.map(async (filepath) => {
    let relativePathName = relativePath(themeExtension.directory, filepath), encoding = dirname(relativePathName) === "assets" ? "binary" : "utf8", fileContents = await readFile(filepath, { encoding });
    files[relativePathName] = Buffer.from(fileContents, encoding).toString("base64");
  })), { theme_extension: { files } };
}

// ../cli-kit/dist/public/common/collection.js
init_cjs_shims();
var import_groupBy = __toESM(require_groupBy()), import_partition = __toESM(require_partition());
function groupBy(collection, iteratee) {
  return (0, import_groupBy.default)(collection, iteratee);
}
function partition(collection, callback) {
  return (0, import_partition.default)(collection, callback);
}

// ../app/dist/cli/services/deploy/upload.js
async function uploadThemeExtensions(themeExtensions, options) {
  let { apiKey, identifiers, developerPlatformClient } = options;
  await Promise.all(themeExtensions.map(async (themeExtension) => {
    let themeExtensionConfig2 = await themeExtensionConfig(themeExtension), themeId = identifiers.extensionIds[themeExtension.localIdentifier], themeExtensionInput = {
      apiKey,
      config: JSON.stringify(themeExtensionConfig2),
      context: void 0,
      registrationId: themeId,
      handle: themeExtension.handle
    }, result = await developerPlatformClient.updateExtension(themeExtensionInput);
    if (result.extensionUpdateDraft?.userErrors && result.extensionUpdateDraft?.userErrors.length > 0) {
      let errors2 = result.extensionUpdateDraft.userErrors.map((error) => error.message).join(", ");
      throw new AbortError(errors2);
    }
  }));
}
async function uploadExtensionsBundle(options) {
  let signedURL, deployError;
  if (options.bundlePath) {
    signedURL = await getExtensionUploadURL(options.developerPlatformClient, {
      id: options.apiKey,
      apiKey: options.apiKey,
      organizationId: options.organizationId
    });
    let form = formData(), buffer = readFileSync(options.bundlePath);
    form.append("my_upload", buffer), await fetch2(signedURL, {
      method: "put",
      body: buffer,
      headers: form.getHeaders()
    });
  }
  let variables = {
    appId: options.appId,
    apiKey: options.apiKey,
    name: options.name,
    organizationId: options.organizationId,
    skipPublish: !options.release,
    message: options.message,
    versionTag: options.version,
    commitReference: options.commitReference
  };
  signedURL && (variables.bundleUrl = signedURL), options.appModules.length > 0 && (variables.appModules = options.appModules);
  let result = await handlePartnersErrors(() => options.developerPlatformClient.deploy(variables));
  if (result.appDeploy?.userErrors?.length > 0) {
    let customSections = deploymentErrorsToCustomSections(result.appDeploy.userErrors, options.extensionIds, {
      version: options.version
    });
    if (result.appDeploy.appVersion)
      deployError = result.appDeploy.userErrors.map((error) => error.message).join(", ");
    else
      throw new AbortError({ bold: "Version couldn't be created." }, null, [], customSections);
  }
  return {
    validationErrors: result.appDeploy.appVersion.appModuleVersions.filter((ver) => ver.validationErrors.length > 0).map((ver) => ({ uuid: ver.registrationUuid, errors: ver.validationErrors })),
    versionTag: result.appDeploy.appVersion.versionTag,
    location: result.appDeploy.appVersion.location,
    message: result.appDeploy.appVersion.message,
    deployError
  };
}
var VALIDATION_ERRORS_TITLE = `
Validation errors`, GENERIC_ERRORS_TITLE = `
`;
function deploymentErrorsToCustomSections(errors2, extensionIds, flags = {}) {
  let isExtensionError = (error) => error.details?.some((detail) => detail.extension_id) ?? !1, isCliError = (error, extensionIds2) => {
    let errorExtensionId = error.details?.find((detail) => typeof detail.extension_id < "u")?.extension_id.toString() ?? "";
    return Object.values(extensionIds2).includes(errorExtensionId);
  }, [extensionErrors, nonExtensionErrors] = partition(errors2, (error) => isExtensionError(error)), [cliErrors, partnersErrors] = partition(extensionErrors, (error) => isCliError(error, extensionIds));
  return [
    ...generalErrorsSection(nonExtensionErrors, { version: flags.version }),
    ...cliErrorsSections(cliErrors, extensionIds),
    ...partnersErrorsSections(partnersErrors)
  ];
}
function generalErrorsSection(errors2, flags = {}) {
  return errors2.length > 0 ? errors2.filter((error) => error.field.includes("version_tag") && error.message === "has already been taken").length > 0 && flags.version ? [
    {
      body: [
        "An app version with the name",
        { userInput: flags.version },
        "already exists. Deploy again with a different version name."
      ]
    }
  ] : errors2.length === 1 ? [
    {
      body: errors2[0].message
    }
  ] : [
    {
      body: {
        list: {
          items: errors2.map((error) => error.message)
        }
      }
    }
  ] : [];
}
function cliErrorsSections(errors2, identifiers) {
  return errors2.reduce((sections, error) => {
    let field = error.field.join(".").replace("extension_points", "extensions.targeting"), errorMessage2 = field === "base" ? error.message : `${field}: ${error.message}`, remoteTitle = error.details.find((detail) => typeof detail.extension_title < "u")?.extension_title, specificationIdentifier = error.details.find((detail) => typeof detail.specification_identifier < "u")?.specification_identifier, extensionIdentifier = error.details.find((detail) => typeof detail.extension_id < "u")?.extension_id.toString(), extensionName = Object.keys(identifiers).find((key) => identifiers[key] === extensionIdentifier) ?? remoteTitle;
    specificationIdentifier === "webhook_subscription" && (extensionName = "Webhook Subscription");
    let existingSection = sections.find((section) => section.title === extensionName);
    if (existingSection) {
      let sectionBody = existingSection.body, errorsList = error.category === "invalid" ? sectionBody.find((listToken) => listToken.list.title === VALIDATION_ERRORS_TITLE) : sectionBody.find((listToken) => listToken.list.title === GENERIC_ERRORS_TITLE);
      errorsList ? errorsList.list.items.includes(errorMessage2) || errorsList.list.items.push(errorMessage2) : sectionBody.push({
        list: {
          title: error.category === "invalid" ? VALIDATION_ERRORS_TITLE : GENERIC_ERRORS_TITLE,
          items: [errorMessage2]
        }
      });
    } else
      sections.push({
        title: extensionName,
        body: [
          {
            list: {
              title: error.category === "invalid" ? VALIDATION_ERRORS_TITLE : GENERIC_ERRORS_TITLE,
              items: [errorMessage2]
            }
          }
        ]
      });
    return sections.forEach((section) => {
      section.body.sort((a, b) => a.list.title === VALIDATION_ERRORS_TITLE ? 1 : b.list.title === VALIDATION_ERRORS_TITLE ? -1 : 0);
    }), sections;
  }, []);
}
function partnersErrorsSections(errors2) {
  return errors2.reduce((sections, error) => {
    let extensionIdentifier = error.details.find((detail) => typeof detail.extension_title < "u")?.extension_title, existingSection = sections.find((section) => section.title === extensionIdentifier);
    return existingSection ? existingSection.errorCount += 1 : sections.push({
      title: extensionIdentifier,
      errorCount: 1
    }), sections;
  }, []).map((section) => ({
    title: section.title,
    body: `
${section.errorCount} error${section.errorCount > 1 ? "s" : ""} found in your extension. Fix these issues in the Partner Dashboard and try deploying again.`
  }));
}
async function getExtensionUploadURL(developerPlatformClient, app) {
  let result = await handlePartnersErrors(() => developerPlatformClient.generateSignedUploadUrl(app));
  if (result.userErrors?.length > 0) {
    let errors2 = result.userErrors.map((error) => error.message).join(", ");
    throw new AbortError(errors2);
  }
  return result.assetUrl;
}
async function uploadWasmBlob(extensionIdentifier, wasmPath, developerPlatformClient) {
  let { url, moduleId, headers, maxSize } = await getFunctionExtensionUploadUrlFromPartners(developerPlatformClient);
  headers["Content-Type"] = "application/wasm";
  let functionContent = await readFile(wasmPath, {}), res = await fetch2(url, { body: functionContent, headers, method: "PUT" }), resBody = res.body?.read()?.toString() || "";
  if (res.status === 200)
    return { url, moduleId };
  if (res.status === 400 && resBody.includes("EntityTooLarge")) {
    let errorMessage2 = outputContent`The size of the Wasm binary file for Function ${extensionIdentifier} is too large. It must be less than ${maxSize}.`;
    throw new AbortError(errorMessage2);
  } else if (res.status >= 400 && res.status < 500) {
    let errorMessage2 = outputContent`Something went wrong uploading the Function ${extensionIdentifier}. The server responded with status ${res.status.toString()} and body: ${resBody}`;
    throw new BugError(errorMessage2);
  } else {
    let errorMessage2 = outputContent`Something went wrong uploading the Function ${extensionIdentifier}. Try again.`;
    throw new AbortError(errorMessage2);
  }
}
async function getFunctionExtensionUploadUrlFromPartners(developerPlatformClient) {
  return (await handlePartnersErrors(() => developerPlatformClient.functionUploadUrl())).functionUploadUrlGenerate.generatedUrlDetails;
}
async function handlePartnersErrors(request2) {
  try {
    return await request2();
  } catch (error) {
    if (error.errors?.[0]?.extensions?.type === "unsupported_client_version") {
      let packageManager2 = await getPackageManager(cwd());
      throw new AbortError(["Upgrade your CLI version to run the", { command: "deploy" }, "command."], null, [
        ["Run", { command: formatPackageManagerCommand(packageManager2, "shopify upgrade") }]
      ]);
    }
    throw error;
  }
}

// ../app/dist/cli/models/extensions/extension-instance.js
var CONFIG_EXTENSION_IDS = [
  AppAccessSpecIdentifier,
  AppHomeSpecIdentifier,
  AppProxySpecIdentifier,
  BrandingSpecIdentifier,
  PosSpecIdentifier,
  app_config_privacy_compliance_webhooks_default,
  WebhookSubscriptionSpecIdentifier,
  WebhooksSpecIdentifier
], ExtensionInstance = class {
  get graphQLType() {
    return (this.specification.graphQLType ?? this.specification.identifier).toUpperCase();
  }
  get type() {
    return this.configuration.type;
  }
  get humanName() {
    return this.specification.externalName;
  }
  get name() {
    return this.configuration.name;
  }
  get dependency() {
    return this.specification.dependency;
  }
  get externalType() {
    return this.specification.externalIdentifier;
  }
  get surface() {
    return this.specification.surface;
  }
  get isPreviewable() {
    return this.features.includes("ui_preview");
  }
  get isThemeExtension() {
    return this.features.includes("theme");
  }
  get isFunctionExtension() {
    return this.features.includes("function");
  }
  get isESBuildExtension() {
    return this.features.includes("esbuild");
  }
  get isAppConfigExtension() {
    return ["single", "dynamic"].includes(this.specification.uidStrategy);
  }
  get isFlow() {
    return this.specification.identifier.includes("flow");
  }
  get isEditorExtensionCollection() {
    return this.specification.identifier === "editor_extension_collection";
  }
  get features() {
    return this.specification.appModuleFeatures(this.configuration);
  }
  get outputFileName() {
    return `${this.handle}.js`;
  }
  constructor(options) {
    if (this.configuration = options.configuration, this.configurationPath = options.configurationPath, this.entrySourceFilePath = options.entryPath ?? "", this.directory = options.directory, this.specification = options.specification, this.devUUID = `dev-${randomUUID()}`, this.handle = this.buildHandle(), this.localIdentifier = this.handle, this.idEnvironmentVariableName = `SHOPIFY_${constantize(this.localIdentifier)}_ID`, this.outputPath = this.directory, this.uid = this.configuration.uid ?? randomUUID(), (this.features.includes("esbuild") || this.type === "tax_calculation") && (this.outputPath = joinPath(this.directory, "dist", `${this.outputFileName}`)), this.isFunctionExtension) {
      let config2 = this.configuration;
      this.outputPath = joinPath(this.directory, config2.build.path ?? joinPath("dist", "index.wasm"));
    }
  }
  get draftMessages() {
    return this.isAppConfigExtension ? { successMessage: void 0, errorMessage: void 0 } : { successMessage: `Draft updated successfully for extension: ${this.localIdentifier}`, errorMessage: "Error while deploying updated extension draft" };
  }
  get isUUIDStrategyExtension() {
    return this.specification.uidStrategy === "uuid";
  }
  get isSingleStrategyExtension() {
    return this.specification.uidStrategy === "single";
  }
  get isDynamicStrategyExtension() {
    return this.specification.uidStrategy === "dynamic";
  }
  get outputPrefix() {
    return this.handle;
  }
  isSentToMetrics() {
    return !this.isAppConfigExtension;
  }
  isReturnedAsInfo() {
    return !this.isAppConfigExtension;
  }
  async deployConfig({ apiKey, developerPlatformClient, appConfiguration }) {
    return this.isFunctionExtension ? this.functionDeployConfig({ apiKey, developerPlatformClient, appConfiguration }) : this.commonDeployConfig(apiKey, appConfiguration);
  }
  async functionDeployConfig({ apiKey, developerPlatformClient }) {
    let { moduleId } = await uploadWasmBlob(this.localIdentifier, this.outputPath, developerPlatformClient);
    return this.specification.deployConfig?.(this.configuration, this.directory, apiKey, moduleId);
  }
  async commonDeployConfig(apiKey, appConfiguration) {
    let deployConfig = await this.specification.deployConfig?.(this.configuration, this.directory, apiKey, void 0), transformedConfig = this.specification.transformLocalToRemote?.(this.configuration, appConfiguration), resultDeployConfig = deployConfig ?? transformedConfig ?? void 0;
    return resultDeployConfig && Object.keys(resultDeployConfig).length > 0 ? resultDeployConfig : void 0;
  }
  validate() {
    return this.specification.validate ? this.specification.validate(this.configuration, this.configurationPath, this.directory) : Promise.resolve(ok(void 0));
  }
  preDeployValidation() {
    return this.specification.preDeployValidation ? this.specification.preDeployValidation(this) : Promise.resolve();
  }
  buildValidation() {
    return this.specification.buildValidation ? this.specification.buildValidation(this) : Promise.resolve();
  }
  async publishURL(options) {
    let fqdn = await partnersFqdn(), parnersPath = this.specification.partnersWebIdentifier;
    return `https://${fqdn}/${options.orgId}/apps/${options.appId}/extensions/${parnersPath}/${options.extensionId}`;
  }
  // UI Specific properties
  getBundleExtensionStdinContent() {
    return this.specification.getBundleExtensionStdinContent ? this.specification.getBundleExtensionStdinContent(this.configuration) : `import '.${this.entrySourceFilePath?.replace(this.directory, "")}';`;
  }
  shouldFetchCartUrl() {
    return this.features.includes("cart_url");
  }
  hasExtensionPointTarget(target) {
    return this.specification.hasExtensionPointTarget?.(this.configuration, target) || !1;
  }
  // Functions specific properties
  get buildCommand() {
    return this.configuration.build.command;
  }
  get watchBuildPaths() {
    if (this.isFunctionExtension) {
      let config2 = this.configuration, configuredPaths = config2.build.watch ? [config2.build.watch].flat() : [];
      if (!this.isJavaScript && configuredPaths.length === 0)
        return null;
      let watchPaths = configuredPaths ?? [];
      return this.isJavaScript && configuredPaths.length === 0 && watchPaths.push(joinPath("src", "**", "*.{js,ts}")), watchPaths.push(joinPath("**", "!(.)*.graphql")), watchPaths.map((path3) => joinPath(this.directory, path3));
    } else
      return this.isESBuildExtension ? [joinPath(this.directory, "src", "**", "*.{ts,tsx,js,jsx}")] : this.isThemeExtension ? [joinPath(this.directory, "*", "*")] : [];
  }
  async watchConfigurationPaths() {
    if (this.isAppConfigExtension)
      return [this.configurationPath];
    {
      let additionalPaths = [];
      return await fileExists(joinPath(this.directory, "locales")) && additionalPaths.push(joinPath(this.directory, "locales", "**.json")), additionalPaths.push(joinPath(this.directory, "**.toml")), additionalPaths;
    }
  }
  get inputQueryPath() {
    return joinPath(this.directory, "input.graphql");
  }
  get isJavaScript() {
    return !!(this.entrySourceFilePath?.endsWith(".js") || this.entrySourceFilePath?.endsWith(".ts"));
  }
  async build(options) {
    if (this.isThemeExtension)
      return buildThemeExtension(this, options);
    if (this.isFunctionExtension)
      return buildFunctionExtension(this, options);
    if (this.features.includes("esbuild"))
      return buildUIExtension(this, options);
    if (this.specification.identifier === "flow_template" && options.environment === "production")
      return buildFlowTemplateExtension(this, options);
    this.type === "tax_calculation" && (await touchFile(this.outputPath), await writeFile(this.outputPath, "(()=>{})();"));
  }
  async buildForBundle(options, bundleDirectory, identifiers) {
    let extensionId = identifiers?.extensions[this.localIdentifier] ?? this.configuration.uid ?? this.handle, outputFile = this.isThemeExtension ? "" : joinPath("dist", `${this.outputFileName}`);
    this.features.includes("bundling") && (this.outputPath = joinPath(bundleDirectory, extensionId, outputFile)), await this.build(options), this.isThemeExtension && useThemebundling() && await bundleThemeExtension(this, options);
  }
  get singleTarget() {
    let targets = getPathValue(this.configuration, "targeting") ?? [];
    if (targets.length === 1)
      return targets[0]?.target;
  }
  get contextValue() {
    let context = this.singleTarget ?? "";
    return this.isFlow && (context = this.configuration.handle ?? ""), context;
  }
  async bundleConfig({ identifiers, developerPlatformClient, apiKey, appConfiguration }) {
    let configValue = await this.deployConfig({ apiKey, developerPlatformClient, appConfiguration });
    if (!configValue)
      return;
    let result = {
      config: JSON.stringify(configValue),
      context: this.contextValue,
      handle: this.handle
    }, uuid = this.isUUIDStrategyExtension ? identifiers.extensions[this.localIdentifier] : identifiers.extensionsNonUuidManaged[this.localIdentifier], uid = this.isUUIDStrategyExtension ? this.uid : uuid;
    return {
      ...result,
      uid,
      uuid,
      specificationIdentifier: developerPlatformClient.toExtensionGraphQLType(this.graphQLType)
    };
  }
  buildHandle() {
    switch (this.specification.uidStrategy) {
      case "single":
        return slugify(this.specification.identifier);
      case "uuid":
        return this.configuration.handle ?? slugify(this.configuration.name ?? "");
      case "dynamic":
        let subscription = this.configuration, handle = `${subscription.topic}${subscription.uri}${subscription.filter}`;
        return hashString(handle).substring(0, 30);
    }
  }
};

// ../app/dist/cli/api/graphql/app-dev/generated/dev-session-create.js
init_cjs_shims();
var DevSessionCreate = {
  kind: "Document",
  definitions: [
    {
      kind: "OperationDefinition",
      operation: "mutation",
      name: { kind: "Name", value: "DevSessionCreate" },
      variableDefinitions: [
        {
          kind: "VariableDefinition",
          variable: { kind: "Variable", name: { kind: "Name", value: "appId" } },
          type: { kind: "NonNullType", type: { kind: "NamedType", name: { kind: "Name", value: "String" } } }
        },
        {
          kind: "VariableDefinition",
          variable: { kind: "Variable", name: { kind: "Name", value: "assetsUrl" } },
          type: { kind: "NonNullType", type: { kind: "NamedType", name: { kind: "Name", value: "String" } } }
        }
      ],
      selectionSet: {
        kind: "SelectionSet",
        selections: [
          {
            kind: "Field",
            name: { kind: "Name", value: "devSessionCreate" },
            arguments: [
              {
                kind: "Argument",
                name: { kind: "Name", value: "appId" },
                value: { kind: "Variable", name: { kind: "Name", value: "appId" } }
              },
              {
                kind: "Argument",
                name: { kind: "Name", value: "assetsUrl" },
                value: { kind: "Variable", name: { kind: "Name", value: "assetsUrl" } }
              }
            ],
            selectionSet: {
              kind: "SelectionSet",
              selections: [
                {
                  kind: "Field",
                  name: { kind: "Name", value: "userErrors" },
                  selectionSet: {
                    kind: "SelectionSet",
                    selections: [
                      { kind: "Field", name: { kind: "Name", value: "message" } },
                      { kind: "Field", name: { kind: "Name", value: "__typename" } }
                    ]
                  }
                },
                { kind: "Field", name: { kind: "Name", value: "__typename" } }
              ]
            }
          }
        ]
      }
    }
  ]
};

// ../app/dist/cli/api/graphql/app-dev/generated/dev-session-update.js
init_cjs_shims();
var DevSessionUpdate = {
  kind: "Document",
  definitions: [
    {
      kind: "OperationDefinition",
      operation: "mutation",
      name: { kind: "Name", value: "DevSessionUpdate" },
      variableDefinitions: [
        {
          kind: "VariableDefinition",
          variable: { kind: "Variable", name: { kind: "Name", value: "appId" } },
          type: { kind: "NonNullType", type: { kind: "NamedType", name: { kind: "Name", value: "String" } } }
        },
        {
          kind: "VariableDefinition",
          variable: { kind: "Variable", name: { kind: "Name", value: "assetsUrl" } },
          type: { kind: "NonNullType", type: { kind: "NamedType", name: { kind: "Name", value: "String" } } }
        }
      ],
      selectionSet: {
        kind: "SelectionSet",
        selections: [
          {
            kind: "Field",
            name: { kind: "Name", value: "devSessionUpdate" },
            arguments: [
              {
                kind: "Argument",
                name: { kind: "Name", value: "appId" },
                value: { kind: "Variable", name: { kind: "Name", value: "appId" } }
              },
              {
                kind: "Argument",
                name: { kind: "Name", value: "assetsUrl" },
                value: { kind: "Variable", name: { kind: "Name", value: "assetsUrl" } }
              }
            ],
            selectionSet: {
              kind: "SelectionSet",
              selections: [
                {
                  kind: "Field",
                  name: { kind: "Name", value: "userErrors" },
                  selectionSet: {
                    kind: "SelectionSet",
                    selections: [
                      { kind: "Field", name: { kind: "Name", value: "message" } },
                      { kind: "Field", name: { kind: "Name", value: "__typename" } }
                    ]
                  }
                },
                { kind: "Field", name: { kind: "Name", value: "__typename" } }
              ]
            }
          }
        ]
      }
    }
  ]
};

// ../app/dist/cli/api/graphql/app-dev/generated/dev-session-delete.js
init_cjs_shims();
var DevSessionDelete = {
  kind: "Document",
  definitions: [
    {
      kind: "OperationDefinition",
      operation: "mutation",
      name: { kind: "Name", value: "DevSessionDelete" },
      variableDefinitions: [
        {
          kind: "VariableDefinition",
          variable: { kind: "Variable", name: { kind: "Name", value: "appId" } },
          type: { kind: "NonNullType", type: { kind: "NamedType", name: { kind: "Name", value: "String" } } }
        }
      ],
      selectionSet: {
        kind: "SelectionSet",
        selections: [
          {
            kind: "Field",
            name: { kind: "Name", value: "devSessionDelete" },
            arguments: [
              {
                kind: "Argument",
                name: { kind: "Name", value: "appId" },
                value: { kind: "Variable", name: { kind: "Name", value: "appId" } }
              }
            ],
            selectionSet: {
              kind: "SelectionSet",
              selections: [
                {
                  kind: "Field",
                  name: { kind: "Name", value: "userErrors" },
                  selectionSet: {
                    kind: "SelectionSet",
                    selections: [
                      { kind: "Field", name: { kind: "Name", value: "message" } },
                      { kind: "Field", name: { kind: "Name", value: "__typename" } }
                    ]
                  }
                },
                { kind: "Field", name: { kind: "Name", value: "__typename" } }
              ]
            }
          }
        ]
      }
    }
  ]
};

// ../app/dist/cli/api/graphql/business-platform-organizations/generated/fetch_dev_store_by_domain.js
init_cjs_shims();
var FetchDevStoreByDomain = {
  kind: "Document",
  definitions: [
    {
      kind: "OperationDefinition",
      operation: "query",
      name: { kind: "Name", value: "FetchDevStoreByDomain" },
      variableDefinitions: [
        {
          kind: "VariableDefinition",
          variable: { kind: "Variable", name: { kind: "Name", value: "domain" } },
          type: { kind: "NamedType", name: { kind: "Name", value: "String" } }
        }
      ],
      selectionSet: {
        kind: "SelectionSet",
        selections: [
          {
            kind: "Field",
            name: { kind: "Name", value: "organization" },
            selectionSet: {
              kind: "SelectionSet",
              selections: [
                { kind: "Field", name: { kind: "Name", value: "id" } },
                { kind: "Field", name: { kind: "Name", value: "name" } },
                {
                  kind: "Field",
                  name: { kind: "Name", value: "properties" },
                  arguments: [
                    {
                      kind: "Argument",
                      name: { kind: "Name", value: "filters" },
                      value: {
                        kind: "ObjectValue",
                        fields: [
                          {
                            kind: "ObjectField",
                            name: { kind: "Name", value: "field" },
                            value: { kind: "EnumValue", value: "STORE_TYPE" }
                          },
                          {
                            kind: "ObjectField",
                            name: { kind: "Name", value: "operator" },
                            value: { kind: "EnumValue", value: "EQUALS" }
                          },
                          {
                            kind: "ObjectField",
                            name: { kind: "Name", value: "value" },
                            value: { kind: "StringValue", value: "app_development", block: !1 }
                          }
                        ]
                      }
                    },
                    {
                      kind: "Argument",
                      name: { kind: "Name", value: "search" },
                      value: { kind: "Variable", name: { kind: "Name", value: "domain" } }
                    },
                    {
                      kind: "Argument",
                      name: { kind: "Name", value: "offeringHandles" },
                      value: { kind: "ListValue", values: [{ kind: "StringValue", value: "shop", block: !1 }] }
                    }
                  ],
                  selectionSet: {
                    kind: "SelectionSet",
                    selections: [
                      {
                        kind: "Field",
                        name: { kind: "Name", value: "edges" },
                        selectionSet: {
                          kind: "SelectionSet",
                          selections: [
                            {
                              kind: "Field",
                              name: { kind: "Name", value: "node" },
                              selectionSet: {
                                kind: "SelectionSet",
                                selections: [
                                  {
                                    kind: "InlineFragment",
                                    typeCondition: { kind: "NamedType", name: { kind: "Name", value: "Shop" } },
                                    selectionSet: {
                                      kind: "SelectionSet",
                                      selections: [
                                        { kind: "Field", name: { kind: "Name", value: "__typename" } },
                                        { kind: "Field", name: { kind: "Name", value: "id" } },
                                        { kind: "Field", name: { kind: "Name", value: "externalId" } },
                                        { kind: "Field", name: { kind: "Name", value: "name" } },
                                        { kind: "Field", name: { kind: "Name", value: "storeType" } },
                                        { kind: "Field", name: { kind: "Name", value: "primaryDomain" } },
                                        { kind: "Field", name: { kind: "Name", value: "shortName" } }
                                      ]
                                    }
                                  },
                                  { kind: "Field", name: { kind: "Name", value: "__typename" } }
                                ]
                              }
                            },
                            { kind: "Field", name: { kind: "Name", value: "__typename" } }
                          ]
                        }
                      },
                      { kind: "Field", name: { kind: "Name", value: "__typename" } }
                    ]
                  }
                },
                { kind: "Field", name: { kind: "Name", value: "__typename" } }
              ]
            }
          }
        ]
      }
    }
  ]
};

// ../app/dist/cli/api/graphql/business-platform-organizations/generated/list_app_dev_stores.js
init_cjs_shims();
var ListAppDevStores = {
  kind: "Document",
  definitions: [
    {
      kind: "OperationDefinition",
      operation: "query",
      name: { kind: "Name", value: "ListAppDevStores" },
      selectionSet: {
        kind: "SelectionSet",
        selections: [
          {
            kind: "Field",
            name: { kind: "Name", value: "organization" },
            selectionSet: {
              kind: "SelectionSet",
              selections: [
                { kind: "Field", name: { kind: "Name", value: "id" } },
                { kind: "Field", name: { kind: "Name", value: "name" } },
                {
                  kind: "Field",
                  name: { kind: "Name", value: "properties" },
                  arguments: [
                    {
                      kind: "Argument",
                      name: { kind: "Name", value: "filters" },
                      value: {
                        kind: "ObjectValue",
                        fields: [
                          {
                            kind: "ObjectField",
                            name: { kind: "Name", value: "field" },
                            value: { kind: "EnumValue", value: "STORE_TYPE" }
                          },
                          {
                            kind: "ObjectField",
                            name: { kind: "Name", value: "operator" },
                            value: { kind: "EnumValue", value: "EQUALS" }
                          },
                          {
                            kind: "ObjectField",
                            name: { kind: "Name", value: "value" },
                            value: { kind: "StringValue", value: "app_development", block: !1 }
                          }
                        ]
                      }
                    },
                    {
                      kind: "Argument",
                      name: { kind: "Name", value: "offeringHandles" },
                      value: { kind: "ListValue", values: [{ kind: "StringValue", value: "shop", block: !1 }] }
                    }
                  ],
                  selectionSet: {
                    kind: "SelectionSet",
                    selections: [
                      {
                        kind: "Field",
                        name: { kind: "Name", value: "edges" },
                        selectionSet: {
                          kind: "SelectionSet",
                          selections: [
                            {
                              kind: "Field",
                              name: { kind: "Name", value: "node" },
                              selectionSet: {
                                kind: "SelectionSet",
                                selections: [
                                  {
                                    kind: "InlineFragment",
                                    typeCondition: { kind: "NamedType", name: { kind: "Name", value: "Shop" } },
                                    selectionSet: {
                                      kind: "SelectionSet",
                                      selections: [
                                        { kind: "Field", name: { kind: "Name", value: "__typename" } },
                                        { kind: "Field", name: { kind: "Name", value: "id" } },
                                        { kind: "Field", name: { kind: "Name", value: "externalId" } },
                                        { kind: "Field", name: { kind: "Name", value: "name" } },
                                        { kind: "Field", name: { kind: "Name", value: "storeType" } },
                                        { kind: "Field", name: { kind: "Name", value: "primaryDomain" } },
                                        { kind: "Field", name: { kind: "Name", value: "shortName" } }
                                      ]
                                    }
                                  },
                                  { kind: "Field", name: { kind: "Name", value: "__typename" } }
                                ]
                              }
                            },
                            { kind: "Field", name: { kind: "Name", value: "__typename" } }
                          ]
                        }
                      },
                      { kind: "Field", name: { kind: "Name", value: "__typename" } }
                    ]
                  }
                },
                { kind: "Field", name: { kind: "Name", value: "__typename" } }
              ]
            }
          }
        ]
      }
    }
  ]
};

// ../cli-kit/dist/public/node/api/app-management.js
init_cjs_shims();
var import_bottleneck = __toESM(require_lib3()), limiter = new import_bottleneck.default({
  minTime: 150,
  maxConcurrent: 10
});
async function appManagementRequest(orgId, query, token, variables) {
  let api = "App Management", url = `https://${await appManagementFqdn()}/app_management/unstable/organizations/${orgId}/graphql.json`;
  return limiter.schedule(() => graphqlRequest({
    query,
    api,
    url,
    token,
    variables,
    responseOptions: { onResponse: handleDeprecations }
  }));
}
function handleDeprecations(response) {
  if (!response.extensions)
    return;
  let deprecationDates = [];
  for (let deprecation of response.extensions.deprecations)
    deprecation.supportedUntilDate && deprecationDates.push(new Date(deprecation.supportedUntilDate));
  setNextDeprecationDate(deprecationDates);
}

// ../cli-kit/dist/public/node/api/app-dev.js
init_cjs_shims();
var import_bottleneck2 = __toESM(require_lib3()), limiter2 = new import_bottleneck2.default({
  minTime: 150,
  maxConcurrent: 10
});
async function appDevRequest(query, shopFqdn, token, variables) {
  let api = "App Dev", url = `https://${await normalizeStoreFqdn(shopFqdn)}/app_dev/unstable/graphql.json`;
  return limiter2.schedule(() => graphqlRequestDoc({
    query,
    api,
    url,
    token,
    variables
  }));
}

// ../app/dist/cli/utilities/developer-platform-client/app-management-client.js
var TEMPLATE_JSON_URL = "https://raw.githubusercontent.com/Shopify/extensions-templates/main/templates.json", AppManagementClient = class {
  constructor(session) {
    this.clientName = ClientName.AppManagement, this.webUiName = "Developer Dashboard", this.requiresOrganization = !0, this.supportsAtomicDeployments = !0, this._session = session;
  }
  async subscribeToAppLogs(input) {
    throw new Error(`Not Implemented: ${input}`);
  }
  async session() {
    if (!this._session) {
      if (isUnitTest())
        throw new Error("AppManagementClient.session() should not be invoked dynamically in a unit test");
      let userInfoResult = await businessPlatformRequest(UserInfoQuery, await this.businessPlatformToken()), token = await ensureAuthenticatedAppManagement();
      userInfoResult.currentUserAccount ? this._session = {
        token,
        accountInfo: {
          type: "UserAccount",
          email: userInfoResult.currentUserAccount.email
        }
      } : this._session = {
        token,
        accountInfo: {
          type: "UnknownAccount"
        }
      };
    }
    return this._session;
  }
  async token() {
    return (await this.session()).token;
  }
  async refreshToken() {
    let newToken = await ensureAuthenticatedAppManagement([], process.env, { noPrompt: !0 }), session = await this.session();
    return newToken && (session.token = newToken), session.token;
  }
  async businessPlatformToken() {
    if (isUnitTest())
      throw new Error("AppManagementClient.businessPlatformToken() should not be invoked dynamically in a unit test");
    return this._businessPlatformToken || (this._businessPlatformToken = await ensureAuthenticatedBusinessPlatform()), this._businessPlatformToken;
  }
  async accountInfo() {
    return (await this.session()).accountInfo;
  }
  async appFromId(appIdentifiers) {
    let { app } = await this.fetchApp(appIdentifiers), { name, appModules } = app.activeRelease.version, appAccessModule = appModules.find((mod) => mod.specification.externalIdentifier === "app_access"), appHomeModule = appModules.find((mod) => mod.specification.externalIdentifier === "app_home"), apiSecretKeys = app.activeRoot.clientCredentials.secrets.map((secret) => ({ secret: secret.key }));
    return {
      id: app.id,
      title: name,
      apiKey: app.key,
      apiSecretKeys,
      organizationId: appIdentifiers.organizationId,
      grantedScopes: appAccessModule?.config?.scopes ?? [],
      applicationUrl: appHomeModule?.config?.app_url,
      flags: [],
      developerPlatformClient: this
    };
  }
  async organizations() {
    let organizationsResult = await businessPlatformRequestDoc(ListOrganizations, await this.businessPlatformToken());
    return organizationsResult.currentUserAccount ? organizationsResult.currentUserAccount.organizations.nodes.map((org) => ({
      id: idFromEncodedGid(org.id),
      businessName: org.name,
      source: OrganizationSource.BusinessPlatform
    })) : [];
  }
  async orgFromId(orgId) {
    let variables = { organizationId: encodedGidFromId(orgId) }, org = (await businessPlatformRequest(OrganizationQuery, await this.businessPlatformToken(), variables)).currentUserAccount.organization;
    if (org)
      return {
        id: orgId,
        businessName: org.name,
        source: OrganizationSource.BusinessPlatform
      };
  }
  async orgAndApps(organizationId) {
    let [organization, { apps, hasMorePages }] = await Promise.all([
      this.orgFromId(organizationId),
      this.appsForOrg(organizationId)
    ]);
    return { organization, apps, hasMorePages };
  }
  async appsForOrg(organizationId, _term) {
    return {
      apps: (await appManagementRequest(organizationId, AppsQuery, await this.token())).apps.map((app) => ({
        id: app.id,
        apiKey: app.key,
        title: app.activeRelease.version.name,
        organizationId
      })),
      hasMorePages: !1
    };
  }
  async specifications({ organizationId }) {
    return (await appManagementRequest(organizationId, SpecificationsQuery, await this.token())).specifications.map((spec3) => ({
      name: spec3.name,
      externalName: spec3.name,
      identifier: spec3.identifier,
      externalIdentifier: spec3.externalIdentifier,
      gated: !1,
      options: {
        managementExperience: "cli",
        registrationLimit: spec3.uidStrategy.appModuleLimit
      },
      experience: experience(spec3.identifier)
    }));
  }
  async templateSpecifications({ organizationId }) {
    let response, templates2;
    try {
      response = await fetch2(TEMPLATE_JSON_URL), templates2 = await response.json();
    } catch {
      throw new AbortError([
        "Failed to fetch extension templates from",
        { link: { url: TEMPLATE_JSON_URL } },
        { char: "." },
        "This likely means a problem with GitHub."
      ], [
        { link: { url: "https://www.githubstatus.com", label: "Check if GitHub is experiencing downtime" } },
        "or try again later."
      ]);
    }
    let counter = 0;
    return (await allowedTemplates(templates2, async (betaFlags) => this.organizationBetaFlags(organizationId, betaFlags))).map((template2) => ({ ...template2, sortPriority: counter++ }));
  }
  async createApp(org, name, options) {
    let variables = createAppVars(name, options?.isLaunchable, options?.scopesArray), mutation = CreateAppMutation, result = await appManagementRequest(org.id, mutation, await this.token(), variables);
    if (result.appCreate.userErrors?.length > 0) {
      let errors2 = result.appCreate.userErrors.map((error) => error.message).join(", ");
      throw new AbortError(errors2);
    }
    let flags = filterDisabledFlags([]), createdApp = result.appCreate.app;
    return {
      ...createdApp,
      title: name,
      apiKey: createdApp.key,
      apiSecretKeys: [],
      grantedScopes: options?.scopesArray ?? [],
      organizationId: org.id,
      newApp: !0,
      flags,
      developerPlatformClient: this
    };
  }
  // we are returning OrganizationStore type here because we want to keep types consistent btwn
  // partners-client and app-management-client. Since we need transferDisabled and convertableToPartnerTest values
  // from the Partners OrganizationStore schema, we will return this type for now
  async devStoresForOrg(orgId) {
    let organization = (await businessPlatformOrganizationsRequestDoc(ListAppDevStores, await this.businessPlatformToken(), orgId)).organization;
    if (!organization)
      throw new AbortError("No organization found");
    let shopArray = organization.properties?.edges.map((value) => value.node) ?? [];
    return mapBusinessPlatformStoresToOrganizationStores(shopArray);
  }
  async appExtensionRegistrations(appIdentifiers) {
    let { app } = await this.fetchApp(appIdentifiers), configurationRegistrations = [], extensionRegistrations = [];
    return app.activeRelease.version.appModules.forEach((mod) => {
      let registration = {
        id: mod.uuid,
        uid: mod.uuid,
        uuid: mod.uuid,
        title: mod.specification.name,
        type: mod.specification.identifier
      };
      CONFIG_EXTENSION_IDS.includes(mod.uuid) ? configurationRegistrations.push(registration) : extensionRegistrations.push(registration);
    }), {
      app: {
        dashboardManagedExtensionRegistrations: [],
        configurationRegistrations,
        extensionRegistrations
      }
    };
  }
  async appVersions({ id, organizationId, title }) {
    let query = AppVersionsQuery2, variables = { appId: id }, result = await appManagementRequest(organizationId, query, await this.token(), variables);
    return {
      app: {
        id: result.app.id,
        organizationId,
        title,
        appVersions: {
          nodes: result.versions.map((version2) => ({
            createdAt: version2.createdAt,
            createdBy: {
              displayName: version2.createdBy
            },
            versionTag: version2.metadata.versionTag,
            status: version2.id === result.app.activeRelease.version.id ? "active" : "inactive",
            versionId: version2.id,
            message: version2.metadata.message
          })),
          pageInfo: {
            totalResults: result.versions.length
          }
        }
      }
    };
  }
  async appVersionByTag({ id: appId, apiKey, organizationId }, tag) {
    let query = AppVersionsQuery2, variables = { appId }, result = await appManagementRequest(organizationId, query, await this.token(), variables);
    if (!result.app)
      throw new AbortError(`App not found for API key: ${apiKey}`);
    let version2 = result.versions.find((version3) => version3.metadata.versionTag === tag);
    if (!version2)
      throw new AbortError(`Version not found for tag: ${tag}`);
    let query2 = AppVersionByIdQuery, variables2 = { versionId: version2.id }, versionInfo = (await appManagementRequest(organizationId, query2, await this.token(), variables2)).version;
    return {
      app: {
        appVersion: {
          id: parseInt(versionInfo.id, 10),
          uuid: versionInfo.id,
          versionTag: versionInfo.metadata.versionTag,
          location: [await appDeepLink({ organizationId, id: appId }), "versions", numberFromGid(versionInfo.id)].join("/"),
          message: "",
          appModuleVersions: versionInfo.appModules.map((mod) => ({
            registrationId: mod.uuid,
            registrationUid: mod.uuid,
            registrationUuid: mod.uuid,
            registrationTitle: mod.handle,
            type: mod.specification.externalIdentifier,
            config: JSON.stringify(mod.config),
            specification: {
              ...mod.specification,
              identifier: mod.specification.externalIdentifier,
              options: { managementExperience: "cli" },
              experience: experience(mod.specification.identifier)
            }
          }))
        }
      }
    };
  }
  async appVersionsDiff(app, { versionId }) {
    let variables = { versionId }, [currentVersion, selectedVersion] = await Promise.all([
      this.activeAppVersionRawResult(app),
      appManagementRequest(app.organizationId, AppVersionByIdQuery, await this.token(), variables)
    ]), currentModules = currentVersion.app.activeRelease.version.appModules, selectedVersionModules = selectedVersion.version.appModules, { added, removed, updated } = diffAppModules({ currentModules, selectedVersionModules });
    function formattedModule(mod) {
      return {
        uuid: mod.uuid,
        registrationTitle: mod.handle,
        specification: {
          identifier: mod.specification.identifier,
          experience: experience(mod.specification.identifier),
          options: {
            managementExperience: "cli"
          }
        }
      };
    }
    return {
      app: {
        versionsDiff: {
          added: added.map(formattedModule),
          updated: updated.map(formattedModule),
          removed: removed.map(formattedModule)
        }
      }
    };
  }
  async activeAppVersion(app) {
    let result = await this.activeAppVersionRawResult(app);
    return {
      appModuleVersions: result.app.activeRelease.version.appModules.map((mod) => ({
        registrationId: mod.uuid,
        registrationUid: mod.uuid,
        registrationUuid: mod.uuid,
        registrationTitle: mod.handle,
        type: mod.specification.externalIdentifier,
        config: mod.config,
        specification: {
          ...mod.specification,
          identifier: mod.specification.identifier,
          options: { managementExperience: "cli" },
          experience: experience(mod.specification.identifier)
        }
      })),
      ...result.app.activeRelease
    };
  }
  async functionUploadUrl() {
    throw new BugError("Not implemented: functionUploadUrl");
  }
  async generateSignedUploadUrl({ organizationId }) {
    let result = await appManagementRequest(organizationId, CreateAssetURLMutation, await this.token());
    return {
      assetUrl: result.appRequestSourceUploadUrl.sourceUploadUrl,
      userErrors: result.appRequestSourceUploadUrl.userErrors
    };
  }
  async updateExtension(_extensionInput) {
    throw new BugError("Not implemented: updateExtension");
  }
  async deploy({ appId, name, appModules, organizationId, versionTag, bundleUrl, skipPublish: noRelease }) {
    let updatedName = name, brandingModule = appModules?.find((mod) => mod.specificationIdentifier === BrandingSpecIdentifier);
    brandingModule && (updatedName = JSON.parse(brandingModule.config).name);
    let variables = {
      appId,
      name: updatedName,
      appSource: {
        assetsUrl: bundleUrl,
        appModules: (appModules ?? []).map((mod) => ({
          uid: mod.uid ?? mod.uuid ?? mod.handle,
          specificationIdentifier: mod.specificationIdentifier,
          handle: mod.handle,
          config: JSON.parse(mod.config)
        }))
      },
      metadata: versionTag ? { versionTag } : {}
    }, result = await appManagementRequest(organizationId, CreateAppVersionMutation, await this.token(), variables), { version: version2, userErrors } = result.appVersionCreate;
    if (!version2)
      return { appDeploy: { userErrors } };
    let versionResult = {
      appDeploy: {
        appVersion: {
          uuid: version2.id,
          // Need to deal with ID properly as it's expected to be a number... how do we use it?
          id: parseInt(version2.id, 10),
          versionTag: version2.metadata.versionTag,
          location: await versionDeepLink(organizationId, appId, version2.id),
          appModuleVersions: version2.appModules.map((mod) => ({
            uuid: mod.uuid,
            registrationUuid: mod.uuid,
            validationErrors: []
          })),
          message: version2.metadata.message
        },
        userErrors: userErrors?.map((err2) => ({ ...err2, details: [] }))
      }
    };
    if (noRelease)
      return versionResult;
    let releaseVariables = { appId, versionId: version2.id }, releaseResult = await appManagementRequest(organizationId, ReleaseVersionMutation, await this.token(), releaseVariables);
    return releaseResult.appReleaseCreate?.userErrors && (versionResult.appDeploy.userErrors = (versionResult.appDeploy.userErrors ?? []).concat(releaseResult.appReleaseCreate.userErrors.map((err2) => ({ ...err2, details: [] })))), versionResult;
  }
  async release({ app: { id: appId, organizationId }, version: { versionId } }) {
    let releaseVariables = { appId, versionId }, releaseResult = await appManagementRequest(organizationId, ReleaseVersionMutation, await this.token(), releaseVariables);
    return {
      appRelease: {
        appVersion: {
          versionTag: releaseResult.appReleaseCreate.release.version.metadata.versionTag,
          message: releaseResult.appReleaseCreate.release.version.metadata.message,
          location: [
            await appDeepLink({ organizationId, id: appId }),
            "versions",
            numberFromGid(releaseResult.appReleaseCreate.release.version.id)
          ].join("/")
        },
        userErrors: releaseResult.appReleaseCreate.userErrors?.map((err2) => ({
          field: err2.field,
          message: err2.message,
          category: "",
          details: []
        }))
      }
    };
  }
  // we are using FindStoreByDomainSchema type here because we want to keep types consistent btwn
  // partners-client and app-management-client. Since we need transferDisabled and convertableToPartnerTest values
  // from the Partners FindByStoreDomainSchema, we will return this type for now
  async storeByDomain(orgId, shopDomain) {
    let queryVariables = { domain: shopDomain }, organization = (await businessPlatformOrganizationsRequestDoc(FetchDevStoreByDomain, await this.businessPlatformToken(), orgId, queryVariables)).organization;
    if (!organization)
      throw new AbortError("No organization found");
    let bpStoresArray = organization.properties?.edges.map((value) => value.node) ?? [], storesArray = mapBusinessPlatformStoresToOrganizationStores(bpStoresArray);
    return {
      organizations: {
        nodes: [
          {
            id: organization.id,
            businessName: organization.name,
            stores: {
              nodes: storesArray
            }
          }
        ]
      }
    };
  }
  async createExtension(_input) {
    throw new BugError("Not implemented: createExtension");
  }
  async convertToTransferDisabledStore(_input) {
    throw new BugError("Not implemented: convertToTransferDisabledStore");
  }
  async updateDeveloperPreview(_input) {
    throw new BugError("Not implemented: updateDeveloperPreview");
  }
  async appPreviewMode(_input) {
    throw new BugError("Not implemented: appPreviewMode");
  }
  async sendSampleWebhook(_input) {
    return outputWarn("\u26A0\uFE0F sendSampleWebhook is not implemented"), {
      sendSampleWebhook: {
        samplePayload: "",
        headers: "{}",
        success: !0,
        userErrors: []
      }
    };
  }
  async apiVersions() {
    return outputWarn("\u26A0\uFE0F apiVersions is not implemented"), { publicApiVersions: ["unstable"] };
  }
  async topics(_input) {
    throw new BugError("Not implemented: topics");
  }
  async migrateFlowExtension(_input) {
    throw new BugError("Not implemented: migrateFlowExtension");
  }
  async migrateAppModule(_input) {
    throw new BugError("Not implemented: migrateAppModule");
  }
  async updateURLs(_input) {
    return outputWarn("\u26A0\uFE0F updateURLs is not implemented"), { appUpdate: { userErrors: [] } };
  }
  async currentAccountInfo() {
    throw new BugError("Not implemented: currentAccountInfo");
  }
  async targetSchemaDefinition(_input) {
    throw new BugError("Not implemented: targetSchemaDefinition");
  }
  async apiSchemaDefinition(_input) {
    throw new BugError("Not implemented: apiSchemaDefinition");
  }
  async migrateToUiExtension(_input) {
    throw new BugError("Not implemented: migrateToUiExtension");
  }
  toExtensionGraphQLType(input) {
    return input.toLowerCase();
  }
  async appDeepLink({ id, organizationId }) {
    return appDeepLink({ id, organizationId });
  }
  async devSessionCreate({ appId, assetsUrl, shopFqdn }) {
    let appIdNumber = String(numberFromGid(appId));
    return appDevRequest(DevSessionCreate, shopFqdn, await this.token(), { appId: appIdNumber, assetsUrl });
  }
  async devSessionUpdate({ appId, assetsUrl, shopFqdn }) {
    let appIdNumber = String(numberFromGid(appId));
    return appDevRequest(DevSessionUpdate, shopFqdn, await this.token(), { appId: appIdNumber, assetsUrl });
  }
  async devSessionDelete({ appId, shopFqdn }) {
    let appIdNumber = String(numberFromGid(appId));
    return appDevRequest(DevSessionDelete, shopFqdn, await this.token(), { appId: appIdNumber });
  }
  async fetchApp({ id, organizationId }) {
    let query = ActiveAppReleaseQuery, variables = { appId: id };
    return appManagementRequest(organizationId, query, await this.token(), variables);
  }
  async activeAppVersionRawResult({ id, organizationId }) {
    let variables = { appId: id };
    return appManagementRequest(organizationId, ActiveAppReleaseQuery, await this.token(), variables);
  }
  async organizationBetaFlags(organizationId, allBetaFlags) {
    let variables = { organizationId: encodedGidFromId(organizationId) }, flagsResult = await businessPlatformOrganizationsRequest(organizationBetaFlagsQuery(allBetaFlags), await this.businessPlatformToken(), organizationId, variables), result = {};
    return allBetaFlags.forEach((flag) => {
      result[flag] = !!flagsResult.organization[`flag_${flag}`];
    }), result;
  }
}, MAGIC_URL2 = "https://shopify.dev/apps/default-app-home", MAGIC_REDIRECT_URL2 = "https://shopify.dev/apps/default-app-home/api/auth";
function createAppVars(name, isLaunchable = !0, scopesArray) {
  return {
    appSource: {
      appModules: [
        {
          // Change the uid to AppHomeSpecIdentifier
          uid: "app_home",
          specificationIdentifier: AppHomeSpecIdentifier,
          config: {
            app_url: isLaunchable ? "https://example.com" : MAGIC_URL2,
            embedded: isLaunchable
          }
        },
        {
          // Change the uid to BrandingSpecIdentifier
          uid: "branding",
          specificationIdentifier: BrandingSpecIdentifier,
          config: { name }
        },
        {
          // Change the uid to WebhooksSpecIdentifier
          uid: "webhooks",
          specificationIdentifier: WebhooksSpecIdentifier,
          config: { api_version: "2024-01" }
        },
        {
          // Change the uid to AppAccessSpecIdentifier
          uid: "app_access",
          specificationIdentifier: AppAccessSpecIdentifier,
          config: {
            redirect_url_allowlist: isLaunchable ? ["https://example.com/api/auth"] : [MAGIC_REDIRECT_URL2],
            ...scopesArray && { scopes: scopesArray.map((scope) => scope.trim()).join(",") }
          }
        }
      ]
    },
    name
  };
}
function encodedGidFromId(id) {
  let gid = `gid://organization/Organization/${id}`;
  return Buffer.from(gid).toString("base64");
}
function idFromEncodedGid(gid) {
  let decodedGid = Buffer.from(gid, "base64").toString("ascii");
  return numberFromGid(decodedGid).toString();
}
function numberFromGid(gid) {
  return Number(gid.match(/^gid.*\/(\d+)$/)[1]);
}
async function appDeepLink({ id, organizationId }) {
  return `https://${await developerDashboardFqdn()}/dashboard/${organizationId}/apps/${numberFromGid(id)}`;
}
async function versionDeepLink(organizationId, appId, versionId) {
  return `${await appDeepLink({ organizationId, id: appId })}/versions/${numberFromGid(versionId)}`;
}
function diffAppModules({ currentModules, selectedVersionModules }) {
  let currentModuleUids = currentModules.map((mod) => mod.uuid), selectedVersionModuleUids = selectedVersionModules.map((mod) => mod.uuid), removed = currentModules.filter((mod) => !selectedVersionModuleUids.includes(mod.uuid)), added = selectedVersionModules.filter((mod) => !currentModuleUids.includes(mod.uuid)), addedUids = added.map((mod) => mod.uuid), updated = selectedVersionModules.filter((mod) => !addedUids.includes(mod.uuid));
  return { added, removed, updated };
}
async function allowedTemplates(templates2, betaFlagsFetcher) {
  let allBetaFlags = Array.from(new Set(templates2.map((ext) => ext.organizationBetaFlags ?? []).flat())), enabledBetaFlags = await betaFlagsFetcher(allBetaFlags);
  return templates2.filter((ext) => {
    let hasAnyNeededBetas = !ext.organizationBetaFlags || ext.organizationBetaFlags.every((flag) => enabledBetaFlags[flag]), satisfiesMinCliVersion = !ext.minimumCliVersion || versionSatisfies(CLI_KIT_VERSION, `>=${ext.minimumCliVersion}`);
    return hasAnyNeededBetas && satisfiesMinCliVersion;
  });
}
function experience(identifier) {
  return CONFIG_EXTENSION_IDS.includes(identifier) ? "configuration" : "extension";
}
function mapBusinessPlatformStoresToOrganizationStores(storesArray) {
  return storesArray.map((store) => {
    let { externalId, primaryDomain, name } = store;
    return {
      shopId: externalId,
      link: primaryDomain,
      shopDomain: primaryDomain,
      shopName: name,
      transferDisabled: !0,
      convertableToPartnerTest: !0
    };
  });
}

// ../app/dist/cli/utilities/developer-platform-client.js
var ClientName;
(function(ClientName2) {
  ClientName2.AppManagement = "app-management", ClientName2.Partners = "partners";
})(ClientName || (ClientName = {}));
function allDeveloperPlatformClients() {
  let clients = [new PartnersClient()];
  return isTruthy(process.env.USE_APP_MANAGEMENT_API) && clients.push(new AppManagementClient()), clients;
}
async function sniffServiceOptionsAndAppConfigToSelectPlatformClient(options) {
  if (options.developerPlatformClient)
    return options.developerPlatformClient;
  try {
    let { configuration } = await loadAppConfiguration({
      ...options,
      userProvidedConfigName: options.configName
    });
    return selectDeveloperPlatformClient({ configuration });
  } catch {
    return new PartnersClient();
  }
}
function selectDeveloperPlatformClient({ configuration, organization } = {}) {
  return isTruthy(process.env.USE_APP_MANAGEMENT_API) ? organization ? selectDeveloperPlatformClientByOrg(organization) : selectDeveloperPlatformClientByConfig(configuration) : new PartnersClient();
}
function selectDeveloperPlatformClientByOrg(organization) {
  return organization.source === OrganizationSource.BusinessPlatform ? new AppManagementClient() : new PartnersClient();
}
function selectDeveloperPlatformClientByConfig(configuration) {
  return !configuration || isCurrentAppSchema(configuration) && configuration.organization_id ? new AppManagementClient() : new PartnersClient();
}
var Flag;
(function(Flag2) {
  Flag2[Flag2.DeclarativeWebhooks = 0] = "DeclarativeWebhooks";
})(Flag || (Flag = {}));
var FlagMap = {
  "5b25141b": Flag.DeclarativeWebhooks
};
function filterDisabledFlags(disabledFlags = []) {
  let defaultActiveFlags = [Flag.DeclarativeWebhooks], remoteDisabledFlags = disabledFlags.map((flag) => FlagMap[flag]);
  return defaultActiveFlags.filter((flag) => !remoteDisabledFlags.includes(flag));
}

// ../app/dist/cli/models/app/app.js
var LegacyAppSchema = z.object({
  client_id: z.number().optional(),
  name: z.string().optional(),
  scopes: z.string().transform((scopes) => normalizeDelimitedString(scopes) ?? "").default(""),
  extension_directories: z.array(z.string()).optional().transform(removeTrailingPathSeparator),
  web_directories: z.array(z.string()).optional(),
  webhooks: z.object({
    api_version: z.string({ required_error: "String is required" }),
    subscriptions: z.array(WebhookSubscriptionSchema).optional()
  }).optional()
}).strict();
function removeTrailingPathSeparator(value) {
  return value?.map((dir) => dir.replace(/[\/\\]+$/, ""));
}
var AppSchema = z.object({
  client_id: z.string(),
  app_id: z.string().optional(),
  organization_id: z.string().optional(),
  build: z.object({
    automatically_update_urls_on_dev: z.boolean().optional(),
    dev_store_url: z.string().optional(),
    include_config_on_deploy: z.boolean().optional()
  }).optional(),
  extension_directories: z.array(z.string()).optional().transform(removeTrailingPathSeparator),
  web_directories: z.array(z.string()).optional()
}), AppConfigurationSchema = z.union([LegacyAppSchema, AppSchema]);
function getAppVersionedSchema(specs, allowDynamicallySpecifiedConfigs = !1) {
  let schema = specs.reduce((schema2, spec3) => spec3.contributeToAppConfigurationSchema(schema2), AppSchema);
  return allowDynamicallySpecifiedConfigs ? schema.passthrough() : specs.length > 0 ? schema.strict() : schema;
}
function isLegacyAppSchema(item) {
  let { path: path3, ...rest } = item;
  return isType(LegacyAppSchema, rest);
}
function isCurrentAppSchema(item) {
  let { path: path3, ...rest } = item;
  return isType(AppSchema.nonstrict(), rest);
}
function getAppScopes(config2) {
  return isLegacyAppSchema(config2) ? config2.scopes : isCurrentAppSchema(config2) ? config2.access_scopes?.scopes ?? "" : "";
}
function getAppScopesArray(config2) {
  let scopes = getAppScopes(config2);
  return scopes.length ? scopes.split(",").map((scope) => scope.trim()) : [];
}
function filterNonVersionedAppFields(configuration) {
  let builtInFieldNames = Object.keys(AppSchema.shape).concat("path");
  return Object.keys(configuration).filter((fieldName) => !builtInFieldNames.includes(fieldName));
}
var WebType;
(function(WebType2) {
  WebType2.Frontend = "frontend", WebType2.Backend = "backend", WebType2.Background = "background";
})(WebType || (WebType = {}));
var WebConfigurationAuthCallbackPathSchema = z.preprocess(ensurePathStartsWithSlash, z.string()), baseWebConfigurationSchema = z.object({
  auth_callback_path: z.union([WebConfigurationAuthCallbackPathSchema, WebConfigurationAuthCallbackPathSchema.array()]).optional(),
  webhooks_path: z.preprocess(ensurePathStartsWithSlash, z.string()).optional(),
  port: z.number().max(65536).min(0).optional(),
  commands: z.object({
    build: z.string().optional(),
    predev: z.string().optional(),
    dev: z.string()
  }),
  name: z.string().optional(),
  hmr_server: z.object({ http_paths: z.string().array() }).optional()
}), webTypes = z.enum([WebType.Frontend, WebType.Backend, WebType.Background]).default(WebType.Frontend), WebConfigurationSchema = z.union([
  baseWebConfigurationSchema.extend({ roles: z.array(webTypes) }),
  baseWebConfigurationSchema.extend({ type: webTypes })
]), ProcessedWebConfigurationSchema = baseWebConfigurationSchema.extend({ roles: z.array(webTypes) }), App = class {
  constructor({ name, directory, packageManager: packageManager2, configuration, nodeDependencies, webs, modules, usesWorkspaces: usesWorkspaces2, dotenv, errors: errors2, specifications, configSchema, remoteFlags }) {
    this.idEnvironmentVariableName = "SHOPIFY_API_KEY", this.name = name, this.directory = directory, this.packageManager = packageManager2, this.configuration = configuration, this.nodeDependencies = nodeDependencies, this.webs = webs, this.dotenv = dotenv, this.realExtensions = modules, this.errors = errors2, this.usesWorkspaces = usesWorkspaces2, this.specifications = specifications, this.configSchema = configSchema ?? AppSchema, this.remoteFlags = remoteFlags ?? [];
  }
  get allExtensions() {
    return this.remoteFlags.includes(Flag.DeclarativeWebhooks) || this.filterDeclarativeWebhooksConfig(), this.includeConfigOnDeploy ? this.realExtensions : this.realExtensions.filter((ext) => !ext.isAppConfigExtension);
  }
  get draftableExtensions() {
    return this.realExtensions.filter((ext) => ext.isUUIDStrategyExtension || ext.specification.identifier === AppAccessSpecIdentifier);
  }
  async manifest() {
    let modules = await Promise.all(this.realExtensions.map(async (module) => {
      let config2 = await module.commonDeployConfig("", this.configuration);
      return {
        type: module.externalType,
        handle: module.handle,
        uid: module.uid,
        assets: module.handle,
        target: module.contextValue,
        config: config2 ?? {}
      };
    })), realModules = getArrayRejectingUndefined(modules);
    return {
      name: this.name,
      handle: "",
      modules: realModules
    };
  }
  async updateDependencies() {
    let nodeDependencies = await getDependencies(joinPath(this.directory, "package.json"));
    this.nodeDependencies = nodeDependencies;
  }
  async preDeployValidation() {
    let functionExtensionsWithUiHandle = this.allExtensions.filter((ext) => ext.isFunctionExtension && ext.configuration.ui?.handle);
    if (functionExtensionsWithUiHandle.length > 0) {
      let errors2 = validateFunctionExtensionsWithUiHandle(functionExtensionsWithUiHandle, this.allExtensions);
      if (errors2)
        throw new AbortError("Invalid function configuration", errors2.join(`
`));
    }
    let extensionCollections = this.allExtensions.filter((ext) => ext.isEditorExtensionCollection);
    if (extensionCollections.length > 0) {
      let errors2 = validateExtensionsHandlesInCollection(extensionCollections, this.allExtensions);
      if (errors2)
        throw new AbortError("Invalid editor extension collection configuration", errors2.join(`

`));
    }
    await Promise.all([this.allExtensions.map((ext) => ext.preDeployValidation())]);
  }
  extensionsForType(specification) {
    return this.allExtensions.filter((extension) => extension.type === specification.identifier || extension.type === specification.externalIdentifier);
  }
  updateExtensionUUIDS(uuids) {
    this.allExtensions.forEach((extension) => {
      extension.devUUID = uuids[extension.localIdentifier] ?? extension.devUUID;
    });
  }
  appIsLaunchable() {
    let frontendConfig = this.webs.find((web2) => isWebType(web2, WebType.Frontend)), backendConfig = this.webs.find((web2) => isWebType(web2, WebType.Backend));
    return !!(frontendConfig || backendConfig);
  }
  creationDefaultOptions() {
    return {
      isLaunchable: this.appIsLaunchable(),
      scopesArray: getAppScopesArray(this.configuration),
      name: this.name
    };
  }
  removeExtension(extensionHandle) {
    this.realExtensions = this.realExtensions.filter((ext) => ext.handle !== extensionHandle);
  }
  get includeConfigOnDeploy() {
    return isLegacyAppSchema(this.configuration) ? !1 : this.configuration.build?.include_config_on_deploy;
  }
  filterDeclarativeWebhooksConfig() {
    let webhooksConfigIndex = this.realExtensions.findIndex((ext) => ext.handle === "webhooks"), complianceWebhooksConfigIndex = this.realExtensions.findIndex((ext) => ext.handle === "privacy-compliance-webhooks");
    webhooksConfigIndex > -1 && setPathValue(this.realExtensions, `${webhooksConfigIndex}.configuration.webhooks.subscriptions`, []), complianceWebhooksConfigIndex > -1 && setPathValue(this.realExtensions, `${complianceWebhooksConfigIndex}.configuration.webhooks.subscriptions`, []);
  }
};
function validateFunctionExtensionsWithUiHandle(functionExtensionsWithUiHandle, allExtensions) {
  let errors2 = [];
  return functionExtensionsWithUiHandle.forEach((extension) => {
    let uiHandle = extension.configuration.ui.handle, matchingExtension = findExtensionByHandle(allExtensions, uiHandle);
    matchingExtension ? matchingExtension.configuration.type !== "ui_extension" && errors2.push(`[${extension.name}] - Local app must contain one extension of type 'ui_extension' and handle '${uiHandle}'`) : errors2.push(`[${extension.name}] - Local app must contain a ui_extension with handle '${uiHandle}'`);
  }), errors2.length > 0 ? errors2 : void 0;
}
function validateExtensionsHandlesInCollection(editorExtensionCollections, allExtensions) {
  let errors2 = [], allowableTypesForExtensionInCollection = ["ui_extension"];
  return editorExtensionCollections.forEach((collection) => {
    collection.configuration.inCollection.forEach((extension) => {
      let matchingExtension = findExtensionByHandle(allExtensions, extension.handle);
      matchingExtension ? allowableTypesForExtensionInCollection.includes(matchingExtension.specification.identifier) ? matchingExtension.specification.identifier === "ui_extension" && matchingExtension.configuration.extension_points.forEach((extensionPoint) => {
        extensionPoint.target.startsWith("admin.") && errors2.push(`[${collection.handle}] editor extension collection: Remove extension '${matchingExtension.configuration.handle}' with target '${extensionPoint.target}' from this collection. This extension target is not supported in collections.`);
      }) : errors2.push(`[${collection.handle}] editor extension collection: Remove extension of type '${matchingExtension.specification.identifier}' from this collection. This extension type is not supported in collections.`) : errors2.push(`[${collection.handle}] editor extension collection: Add extension with handle '${extension.handle}' to local app. Local app must include extension with handle '${extension.handle}'.`);
    });
  }), errors2.length > 0 ? errors2 : void 0;
}
function findExtensionByHandle(allExtensions, handle) {
  return allExtensions.find((ext) => ext.handle === handle);
}
async function getUIExtensionRendererVersion(extension) {
  let rendererDependency = extension.dependency;
  if (rendererDependency)
    return getDependencyVersion(rendererDependency, extension.directory);
}
async function getDependencyVersion(dependency7, directory) {
  let dependencyName = dependency7.replace("-react", "").split("/"), pattern = joinPath("node_modules", dependencyName[0], dependencyName[1], "package.json"), packagePath2 = await findPathUp(pattern, {
    cwd: directory,
    type: "file",
    allowSymlinks: !0
  });
  if (!packagePath2)
    return "not_found";
  packagePath2 = await fileRealPath(packagePath2);
  let packageContent = await readAndParsePackageJson(packagePath2);
  return packageContent.version ? { name: dependency7, version: packageContent.version } : "not_found";
}

// ../app/dist/cli/metadata.js
init_cjs_shims();
var metadata = createRuntimeMetadataContainer({
  cmd_app_warning_api_key_deprecation_displayed: !1
}), metadata_default = metadata;

// ../app/dist/cli/services/local-storage.js
init_cjs_shims();
var _appLocalStorageInstance;
function appLocalStorage() {
  return _appLocalStorageInstance || (_appLocalStorageInstance = new LocalStorage({ projectName: "shopify-cli-app" })), _appLocalStorageInstance;
}
function getCachedAppInfo(directory, config2 = appLocalStorage()) {
  let normalized = normalizePath(directory);
  return outputDebug(outputContent`Reading cached app information for directory ${outputToken.path(normalized)}...`), config2.get(normalized);
}
function clearCachedAppInfo(directory, config2 = appLocalStorage()) {
  let normalized = normalizePath(directory);
  outputDebug(outputContent`Clearing app information for directory ${outputToken.path(normalized)}...`), config2.delete(normalized);
}
function setCachedAppInfo(options, config2 = appLocalStorage()) {
  options.directory = normalizePath(options.directory), outputDebug(outputContent`Storing app information for directory ${outputToken.path(options.directory)}:${outputToken.json(options)}`);
  let savedApp = config2.get(options.directory);
  savedApp ? config2.set(options.directory, {
    ...savedApp,
    ...options
  }) : config2.set(options.directory, options);
}
function clearCurrentConfigFile(directory, config2 = appLocalStorage()) {
  let normalized = normalizePath(directory), savedApp = config2.get(normalized);
  config2.set(normalized, {
    ...savedApp,
    configFile: void 0
  });
}
var _commandLocalStorageInstance;
function commandLocalStorage() {
  return _commandLocalStorageInstance || (_commandLocalStorageInstance = new LocalStorage({ projectName: "shopify-cli-app-command" })), _commandLocalStorageInstance;
}
function setCachedCommandInfo(data) {
  let id = process.env.COMMAND_RUN_ID;
  if (!id)
    return;
  let store = commandLocalStorage(), info2 = store.get(id);
  store.set(id, {
    ...info2,
    ...data
  });
}
function getCachedCommandInfo() {
  let id = process.env.COMMAND_RUN_ID;
  return id ? commandLocalStorage().get(id) : void 0;
}
function clearCachedCommandInfo() {
  commandLocalStorage().clear();
}
function setCachedCommandTomlMap(tomls) {
  setCachedCommandInfo({ tomls });
}
function setCachedCommandTomlPreference(selectedToml) {
  setCachedCommandInfo({ selectedToml });
}

// ../app/dist/cli/services/app/config/use.js
init_cjs_shims();

// ../app/dist/cli/prompts/config.js
init_cjs_shims();
async function selectConfigName(directory, defaultName = "") {
  let namePromptOptions = buildTextPromptOptions(defaultName), configName = await renderTextPrompt(namePromptOptions);
  for (; await fileExists(joinPath(directory, filenameFromName(configName))) && await renderConfirmationPrompt({
    message: `Configuration file ${filenameFromName(configName)} already exists. Do you want to choose a different configuration name?`,
    confirmationMessage: "Yes, I'll choose a different name",
    cancellationMessage: "No, overwrite my existing configuration file"
  }); )
    configName = await renderTextPrompt(namePromptOptions);
  return filenameFromName(configName);
}
function filenameFromName(name, highlight = !1) {
  let slugifiedName = slugify(name);
  return slugifiedName === "" ? "shopify.app.toml" : `shopify.app.${highlight ? source_default.cyan(slugifiedName) : slugifiedName}.toml`;
}
async function findConfigFiles(directory) {
  return glob(joinPath(directory, "shopify.app*.toml"));
}
async function selectConfigFile(directory) {
  let files = (await findConfigFiles(directory)).map((path3) => basename(path3));
  if (files.length === 0)
    return err("Could not find any shopify.app.toml file in the directory.");
  if (files.length === 1)
    return ok(files[0]);
  let chosen = await renderSelectPrompt({
    message: "Configuration file",
    choices: files.map((file) => ({ label: file, value: file }))
  });
  return ok(chosen);
}
function buildTextPromptOptions(initialAnswer) {
  return {
    message: "Configuration file name:",
    initialAnswer,
    validate: validate3,
    preview: (value) => `${filenameFromName(value, !0)} will be generated in your root directory`
  };
}
function validate3(value) {
  if (slugify(value).length > 238)
    return "The file name is too long.";
}

// ../app/dist/cli/services/context.js
init_cjs_shims();

// ../app/dist/cli/services/dev/select-app.js
init_cjs_shims();

// ../app/dist/cli/services/dev/prompt-helpers.js
init_cjs_shims();
function searchForAppsByNameFactory(developerPlatformClient, orgId) {
  return async (term) => {
    let result = await developerPlatformClient.appsForOrg(orgId, term);
    return { apps: result.apps, hasMorePages: result.hasMorePages };
  };
}

// ../app/dist/cli/prompts/dev.js
init_cjs_shims();

// ../app/dist/cli/utilities/app/config/getTomls.js
init_cjs_shims();
import { readdirSync } from "fs";
async function getTomls(appDirectory) {
  if (!appDirectory)
    return {};
  let clientIds = {}, files = readdirSync(appDirectory);
  return await Promise.all(files.map(async (file) => {
    if (isValidFormatAppConfigurationFileName(file)) {
      let filePath = joinPath(appDirectory, file), parsedToml = await loadConfigurationFileContent(filePath);
      parsedToml.client_id && (clientIds[parsedToml.client_id] = file);
    }
  })), clientIds;
}

// ../app/dist/cli/prompts/dev.js
async function selectOrganizationPrompt(organizations) {
  if (organizations.length === 1)
    return organizations[0];
  let orgList = organizations.map((org) => ({ label: org.businessName, value: org.id })), id = await renderAutocompletePrompt({
    message: "Which organization is this work for?",
    choices: orgList
  });
  return organizations.find((org) => org.id === id);
}
async function selectAppPrompt(onSearchForAppsByName, apps, hasMorePages, options) {
  let tomls = await getTomls(options?.directory);
  tomls && setCachedCommandTomlMap(tomls);
  let toAnswer = (app) => tomls[app?.apiKey] ? { label: `${app.title} (${tomls[app.apiKey]})`, value: app.apiKey } : { label: app.title, value: app.apiKey }, currentAppChoices = apps, apiKey = await renderAutocompletePrompt({
    message: "Which existing app is this for?",
    choices: currentAppChoices.map(toAnswer),
    hasMorePages,
    search: async (term) => {
      let result = await onSearchForAppsByName(term);
      return currentAppChoices = result.apps, {
        data: currentAppChoices.map(toAnswer),
        meta: {
          hasNextPage: result.hasMorePages
        }
      };
    }
  });
  return currentAppChoices.find((app) => app.apiKey === apiKey);
}
async function selectStorePrompt(stores, showDomainOnPrompt) {
  if (stores.length === 0)
    return;
  if (stores.length === 1)
    return outputCompleted(`Using your default dev store, ${stores[0].shopName}, to preview your project.`), stores[0];
  let storeList = stores.map((store) => {
    let label = store.shopName;
    return showDomainOnPrompt && store.shopDomain && (label = `${store.shopName} (${store.shopDomain})`), { label, value: store.shopId };
  }), id = await renderAutocompletePrompt({
    message: "Which store would you like to use to view your project?",
    choices: storeList
  });
  return stores.find((store) => store.shopId === id);
}
async function confirmConversionToTransferDisabledStorePrompt() {
  return renderConfirmationPrompt({
    message: "Make this store transfer-disabled? For security, once you use a development store to preview an app locally, the store can never be transferred to a merchant to use as a production store.",
    confirmationMessage: "Yes, make this store transfer-disabled permanently",
    cancellationMessage: "No, select another store",
    defaultValue: !1
  });
}
async function appNamePrompt(currentName) {
  return renderTextPrompt({
    message: "App name",
    defaultValue: currentName,
    validate: (value) => {
      if (value.length === 0)
        return "App name can't be empty";
      if (value.length > 30)
        return "Enter a shorter name (30 character max.)";
      if (value.includes("shopify"))
        return `Name can't contain "shopify." Enter another name.`;
    }
  });
}
async function reloadStoreListPrompt(org) {
  return renderConfirmationPrompt({
    message: "Finished creating a dev store?",
    confirmationMessage: `Yes, ${org.businessName} has a new dev store`,
    cancellationMessage: "No, cancel dev"
  });
}
async function createAsNewAppPrompt() {
  return renderConfirmationPrompt({
    message: "Create this project as a new app on Shopify?",
    confirmationMessage: "Yes, create it as a new app",
    cancellationMessage: "No, connect it to an existing app"
  });
}
async function reuseDevConfigPrompt() {
  return renderConfirmationPrompt({
    message: "Deploy to the same org and app as you used for dev?",
    confirmationMessage: "Yes, deploy in the same way",
    cancellationMessage: "No, use a different org or app"
  });
}
function updateURLsPrompt(currentAppUrl, currentRedirectUrls) {
  return renderConfirmationPrompt({
    message: "Have Shopify automatically update your app's URL in order to create a preview experience?",
    confirmationMessage: "Yes, automatically update",
    cancellationMessage: "No, never",
    infoTable: {
      "Current app URL": [currentAppUrl],
      "Current redirect URLs": currentRedirectUrls
    }
  });
}

// ../app/dist/cli/services/dev/select-app.js
async function selectOrCreateApp(localAppName, apps, hasMorePages, org, developerPlatformClient, options) {
  let createNewApp = apps.length === 0;
  if (createNewApp || (outputInfo(`
Before proceeding, your project needs to be associated with an app.
`), createNewApp = await createAsNewAppPrompt()), createNewApp) {
    let name = await appNamePrompt(localAppName);
    return developerPlatformClient.createApp(org, name, options);
  } else {
    let app = await selectAppPrompt(searchForAppsByNameFactory(developerPlatformClient, org.id), apps, hasMorePages, {
      directory: options?.directory
    }), selectedToml = (getCachedCommandInfo()?.tomls ?? {})[app.apiKey];
    return selectedToml && setCachedCommandTomlPreference(selectedToml), await developerPlatformClient.appFromId(app);
  }
}

// ../app/dist/cli/services/dev/select-store.js
init_cjs_shims();
var CreateStoreLink = async (orgId) => `Looks like you don't have a dev store in the Partners org you selected. Keep going \u2014 create a dev store on Shopify Partners:
${`https://${await partnersFqdn()}/${orgId}/stores/new?store_type=dev_store`}
`;
async function selectStore(stores, org, developerPlatformClient) {
  let showDomainOnPrompt = developerPlatformClient.clientName === ClientName.AppManagement, store = await selectStorePrompt(stores, showDomainOnPrompt);
  if (!store) {
    if (outputInfo(`
${await CreateStoreLink(org.id)}`), await sleep(5), !await reloadStoreListPrompt(org))
      throw new CancelExecution();
    let data = await waitForCreatedStore(org.id, developerPlatformClient);
    store = await selectStore(data, org, developerPlatformClient);
  }
  let storeIsValid = await convertToTransferDisabledStoreIfNeeded(store, org.id, developerPlatformClient, "prompt-first");
  for (; !storeIsValid; ) {
    if (store = await selectStorePrompt(stores, showDomainOnPrompt), !store)
      throw new CancelExecution();
    storeIsValid = await convertToTransferDisabledStoreIfNeeded(store, org.id, developerPlatformClient, "prompt-first");
  }
  return store;
}
async function waitForCreatedStore(orgId, developerPlatformClient) {
  let data = [];
  return await renderTasks([
    {
      title: "Fetching organization data",
      task: async () => {
        for (let i = 0; i < 10; i++) {
          let stores = await developerPlatformClient.devStoresForOrg(orgId);
          if (stores.length > 0) {
            data = stores;
            return;
          }
          await sleep(3);
        }
      }
    }
  ]), data;
}
async function convertToTransferDisabledStoreIfNeeded(store, orgId, developerPlatformClient, conversionMode) {
  if (store.transferDisabled || firstPartyDev())
    return !0;
  if (!store.transferDisabled && !store.convertableToPartnerTest)
    throw new AbortError(`The store you specified (${store.shopDomain}) is not a dev store`, "Run dev --reset and select an eligible dev store.");
  switch (conversionMode) {
    case "prompt-first":
      return await confirmConversionToTransferDisabledStorePrompt() ? (await convertStoreToTransferDisabled(store, orgId, developerPlatformClient), !0) : !1;
    case "never":
      throw new AbortError("The store you specified is not transfer-disabled", "Try running 'dev --reset' and selecting a different store, or choosing to convert this one.");
  }
}
async function convertStoreToTransferDisabled(store, orgId, developerPlatformClient) {
  let variables = {
    input: {
      organizationID: parseInt(orgId, 10),
      shopId: store.shopId
    }
  }, result = await developerPlatformClient.convertToTransferDisabledStore(variables);
  if (!result.convertDevToTestStore.convertedToTestStore) {
    let errors2 = result.convertDevToTestStore.userErrors.map((error) => error.message).join(", ");
    throw new BugError(`Error converting store ${store.shopDomain} to a transfer-disabled store: ${errors2}`, "This store might not be compatible with draft apps, please try a different store");
  }
  outputSuccess(`Converted ${store.shopDomain} to a transfer-disabled store`);
}

// ../app/dist/cli/services/context/identifiers.js
init_cjs_shims();

// ../app/dist/cli/services/context/identifiers-extensions.js
init_cjs_shims();

// ../app/dist/cli/services/context/id-manual-matching.js
init_cjs_shims();

// ../app/dist/cli/services/context/prompts.js
init_cjs_shims();
async function matchConfirmationPrompt(local, remote, type = "extension") {
  return renderConfirmationPrompt({
    message: `Match ${local.handle} (local name) with ${remote.title} (name on Shopify Partners, ID: ${remote.id})?`,
    confirmationMessage: `Yes, match to existing ${type}`,
    cancellationMessage: `No, create as a new ${type}`
  });
}
async function selectRemoteSourcePrompt(localSource, remoteSourcesOfSameType) {
  let remoteOptions = remoteSourcesOfSameType.map((remote) => ({
    label: `Match it to ${remote.title} (ID: ${remote.id} on Shopify Partners)`,
    value: remote.uuid
  }));
  remoteOptions.push({ label: "Create new extension", value: "create" });
  let uuid = await renderAutocompletePrompt({
    message: `How would you like to deploy your "${localSource.handle}"?`,
    choices: remoteOptions
  });
  return remoteSourcesOfSameType.find((remote) => remote.uuid === uuid);
}
async function extensionMigrationPrompt(toMigrate, includeRemoteType = !0) {
  let migrationNames = toMigrate.map(({ local }) => `"${local.handle}"`).join(", "), allMigrationTypes = toMigrate.map(({ remote }) => remote.type.toLocaleLowerCase()), uniqueMigrationTypes = allMigrationTypes.filter((type, i) => allMigrationTypes.indexOf(type) === i).map((name) => `"${name}"`).join(", "), migrationEndType = toMigrate.map(({ local }) => `"${local.type}"`).join(", ");
  renderInfo({
    headline: "Extension migrations can't be undone.",
    body: `Your ${migrationNames} configuration has been updated. Migrating gives you access to new features and won't impact the end user experience. All previous extension versions will reflect this change.`
  });
  let confirmMessage = includeRemoteType ? `Yes, confirm migration from ${uniqueMigrationTypes} to ${migrationEndType}` : "Yes, confirm migration";
  return renderConfirmationPrompt({
    message: `Migrate ${migrationNames}?`,
    confirmationMessage: confirmMessage,
    cancellationMessage: "No, cancel"
  });
}

// ../app/dist/cli/services/context/id-manual-matching.js
async function manualMatchIds(options) {
  let identifiers = {}, pendingRemote = options.remote, pendingLocal = options.local;
  for (let currentLocal of options.local) {
    let remoteSourcesOfSameType = pendingRemote.filter((remoteSource) => remoteSource.type === currentLocal.graphQLType);
    if (remoteSourcesOfSameType.length === 0)
      continue;
    let selected = await selectRemoteSourcePrompt(currentLocal, remoteSourcesOfSameType);
    selected && (identifiers[currentLocal.localIdentifier] = selected.uuid, pendingRemote = pendingRemote.filter((remote) => remote.uuid !== selected.uuid), pendingLocal = pendingLocal.filter((local) => local.localIdentifier !== currentLocal.localIdentifier));
  }
  return {
    identifiers,
    toCreate: pendingLocal,
    onlyRemote: pendingRemote
  };
}

// ../app/dist/cli/services/context/id-matching.js
init_cjs_shims();
var sameTypeAndName = (local, remote) => remote.type === local.graphQLType && slugify(remote.title) === slugify(local.handle);
function matchByNameAndType(local, remote) {
  let uniqueLocal = uniqBy(local, (elem) => [elem.graphQLType, elem.handle]), uniqueRemote = uniqBy(remote, (elem) => [elem.type, elem.title]), matched = {};
  uniqueLocal.forEach((localSource) => {
    let possibleMatch = uniqueRemote.find((remoteSource) => sameTypeAndName(localSource, remoteSource));
    possibleMatch && (matched[localSource.localIdentifier] = possibleMatch.uuid);
  });
  let pendingLocal = local.filter((elem) => !matched[elem.localIdentifier]), pendingRemote = remote.filter((registration) => !Object.values(matched).includes(registration.uuid)), { toConfirm, toCreate, toManualMatch } = matchByUniqueType(pendingLocal, pendingRemote);
  return { matched, toCreate, toConfirm, toManualMatch };
}
function matchByUID(local, remote) {
  let matched = {};
  local.forEach((localSource) => {
    let possibleMatch = remote.find((remoteSource) => remoteSource.uid === localSource.uid);
    possibleMatch && (matched[localSource.localIdentifier] = possibleMatch.uid);
  });
  let toCreate = local.filter((elem) => !matched[elem.localIdentifier]);
  return { matched, toCreate, toConfirm: [], toManualMatch: { local: [], remote: [] } };
}
function migrateLegacyFunctions(ids, localSources, remoteSources) {
  let migrated = {}, pendingMigrations = {};
  remoteSources.filter((extension) => extension.type === "FUNCTION").forEach((functionExtension) => {
    let config2 = functionExtension.draftVersion?.config;
    if (config2 === void 0)
      return;
    let parsedConfig = JSON.parse(config2), legacyId = parsedConfig.legacy_function_id;
    legacyId && (pendingMigrations[legacyId] = functionExtension.uuid);
    let legacyUuid = parsedConfig.legacy_function_uuid;
    legacyUuid && (pendingMigrations[legacyUuid] = functionExtension.uuid);
  }), localSources.filter((extension) => extension.type === "function").forEach((functionExtension) => {
    let localId = ids[functionExtension.localIdentifier];
    if (localId === void 0)
      return;
    let remoteId = pendingMigrations[localId];
    remoteId && (delete pendingMigrations[functionExtension.localIdentifier], migrated[functionExtension.localIdentifier] = remoteId);
  });
  let pendingLocal = localSources.filter((elem) => !migrated[elem.localIdentifier]), pendingRemote = remoteSources.filter((registration) => !Object.values(migrated).includes(registration.uuid));
  return {
    migrated,
    pending: {
      local: pendingLocal,
      remote: pendingRemote
    }
  };
}
function matchByUniqueType(localSources, remoteSources) {
  let localGroups = groupBy(localSources, "graphQLType"), localUnique = Object.values(pickBy(localGroups, (group, _key) => group.length === 1)).flat(), remoteGroups = groupBy(remoteSources, "type"), remoteUniqueMap = pickBy(remoteGroups, (group, _key) => group.length === 1), toConfirm = [], toCreate = [];
  for (let local of localUnique) {
    let remote = remoteUniqueMap[local.graphQLType];
    remote && remote[0] ? toConfirm.push({ local, remote: remote[0] }) : toCreate.push(local);
  }
  let localDuplicated = difference(localSources, localUnique), remotePending = difference(remoteSources, toConfirm.map((elem) => elem.remote)), [localPending, localToCreate] = partition(localDuplicated, (local) => remotePending.map((remote) => remote.type).includes(local.graphQLType));
  return toCreate.push(...localToCreate), {
    toCreate,
    toConfirm,
    toManualMatch: {
      local: localPending,
      remote: remotePending
    }
  };
}
async function automaticMatchmaking(localSources, remoteSources, identifiers, developerPlatformClient) {
  let useUidMatching = developerPlatformClient.supportsAtomicDeployments, ids = getExtensionIds(localSources, identifiers), localIds = Object.values(ids), existsRemotely = (local2) => remoteSources.some((remote2) => {
    if (remote2.type !== developerPlatformClient.toExtensionGraphQLType(local2.graphQLType))
      return !1;
    let remoteIdField = useUidMatching ? "uid" : "uuid";
    return ids[local2.localIdentifier] === remote2[remoteIdField];
  }), { migrated: migratedFunctions, pending: pendingAfterMigratingFunctions } = migrateLegacyFunctions(ids, localSources.filter((local2) => !existsRemotely(local2)), remoteSources.filter((remote2) => !localIds.includes(remote2.uuid))), { local, remote } = pendingAfterMigratingFunctions, { matched, toCreate, toConfirm, toManualMatch } = useUidMatching ? matchByUID(local, remote) : matchByNameAndType(local, remote);
  return {
    identifiers: { ...ids, ...matched, ...migratedFunctions },
    toConfirm,
    toCreate,
    toManualMatch
  };
}
function getExtensionIds(localSources, identifiers) {
  let localSourcesIds = localSources.map((source) => source.localIdentifier);
  return pickBy(identifiers, (_2, id) => localSourcesIds.includes(id));
}

// ../app/dist/cli/services/dev/create-extension.js
init_cjs_shims();
async function createExtension(apiKey, graphQLType, handle, developerPlatformClient, context) {
  let variables = {
    apiKey,
    type: graphQLType,
    title: handle,
    config: JSON.stringify({}),
    context: context ?? null,
    handle
  }, result = await developerPlatformClient.createExtension(variables);
  if (result.extensionCreate.userErrors?.length > 0) {
    let errors2 = result.extensionCreate.userErrors.map((error) => error.message).join(", ");
    throw new AbortError(errors2);
  }
  return result.extensionCreate.extensionRegistration;
}

// ../app/dist/cli/services/dev/migrate-to-ui-extension.js
init_cjs_shims();
function getUIExtensionsToMigrate(localSources, remoteSources, identifiers) {
  let ids = getExtensionIds(localSources, identifiers), remoteExtensionTypesToMigrate = ["CHECKOUT_UI_EXTENSION", "POS_UI_EXTENSION"];
  return localSources.reduce((accumulator, localSource) => {
    if (localSource.type === "ui_extension") {
      let remoteSource = remoteSources.find((source) => {
        let matchesId = source.uuid === ids[localSource.localIdentifier], matchesTitle = slugify(source.title) === slugify(localSource.handle);
        return matchesId || matchesTitle;
      });
      if (!remoteSource)
        return accumulator;
      remoteExtensionTypesToMigrate.includes(remoteSource.type) && accumulator.push({ local: localSource, remote: remoteSource });
    }
    return accumulator;
  }, []);
}
async function migrateExtensionsToUIExtension(extensionsToMigrate, appId, remoteExtensions, developerPlatformClient) {
  return await Promise.all(extensionsToMigrate.map(({ remote }) => migrateExtensionToUIExtension(appId, remote.id, developerPlatformClient))), remoteExtensions.map((extension) => extensionsToMigrate.some(({ remote }) => remote.id === extension.id) ? {
    ...extension,
    type: "UI_EXTENSION"
  } : extension);
}
async function migrateExtensionToUIExtension(apiKey, registrationId, developerPlatformClient) {
  let variables = {
    apiKey,
    registrationId
  }, result = await developerPlatformClient.migrateToUiExtension(variables);
  if (result?.migrateToUiExtension?.userErrors?.length > 0) {
    let errors2 = result.migrateToUiExtension.userErrors.map((error) => error.message).join(", ");
    throw new AbortError(errors2);
  }
  if (!result?.migrateToUiExtension?.migratedToUiExtension)
    throw new AbortError("Couldn't migrate to UI extension");
}

// ../app/dist/cli/services/dev/migrate-flow-extension.js
init_cjs_shims();
function getFlowExtensionsToMigrate(localSources, remoteSources, identifiers) {
  let ids = getExtensionIds(localSources, identifiers), localExtensionTypesToMigrate = ["flow_action", "flow_trigger"], remoteExtensionTypesToMigrate = ["flow_action_definition", "flow_trigger_definition"], typesMap = /* @__PURE__ */ new Map([
    ["flow_action", "flow_action_definition"],
    ["flow_trigger", "flow_trigger_definition"]
  ]), local = localSources.filter((source) => localExtensionTypesToMigrate.includes(source.type)), remote = remoteSources.filter((source) => remoteExtensionTypesToMigrate.includes(source.type)), remoteSourcesMap = /* @__PURE__ */ new Map();
  return remote.forEach((remoteSource) => {
    remoteSourcesMap.set(remoteSource.uuid, remoteSource), remoteSourcesMap.set(slugify(remoteSource.title), remoteSource);
  }), local.reduce((accumulator, localSource) => {
    let localSourceId = ids[localSource.localIdentifier] ?? "unknown", remoteSource = remoteSourcesMap.get(localSourceId) || remoteSourcesMap.get(localSource.localIdentifier), typeMatch = typesMap.get(localSource.type) === remoteSource?.type;
    return remoteSource && typeMatch && accumulator.push({ local: localSource, remote: remoteSource }), accumulator;
  }, []);
}
async function migrateFlowExtensions(extensionsToMigrate, appId, remoteExtensions, developerPlatformClient) {
  let migratedIDs = await Promise.all(extensionsToMigrate.map(({ remote }) => migrateFlowExtension(appId, remote.id, developerPlatformClient))), typesMap = /* @__PURE__ */ new Map([
    ["flow_action_definition", "FLOW_ACTION"],
    ["flow_trigger_definition", "FLOW_TRIGGER"]
  ]);
  return remoteExtensions.filter((extension) => migratedIDs.includes(extension.id)).map((extension) => ({
    ...extension,
    type: typesMap.get(extension.type) ?? extension.type
  }));
}
async function migrateFlowExtension(apiKey, registrationId, developerPlatformClient) {
  let variables = {
    apiKey,
    registrationId
  }, result = await developerPlatformClient.migrateFlowExtension(variables);
  if (result?.migrateFlowExtension?.userErrors?.length > 0) {
    let errors2 = result.migrateFlowExtension.userErrors.map((error) => error.message).join(", ");
    throw new AbortError(errors2);
  }
  if (!result?.migrateFlowExtension?.migratedFlowExtension)
    throw new AbortError("Couldn't migrate to Flow extension");
  return registrationId;
}

// ../app/dist/cli/services/dev/migrate-app-module.js
init_cjs_shims();
function getPaymentsExtensionsToMigrate(localSources, remoteSources, identifiers) {
  let ids = getExtensionIds(localSources, identifiers), localExtensionTypesToMigrate = ["payments_extension"], remoteExtensionTypesToMigrate = [
    "payments_app",
    "payments_app_credit_card",
    "payments_app_custom_credit_card",
    "payments_app_custom_onsite",
    "payments_app_redeemable"
  ], typesMap = /* @__PURE__ */ new Map();
  typesMap.set("payments_extension", [
    "payments_app",
    "payments_app_credit_card",
    "payments_app_custom_credit_card",
    "payments_app_custom_onsite",
    "payments_app_redeemable"
  ]);
  let local = localSources.filter((source) => localExtensionTypesToMigrate.includes(source.type)), remote = remoteSources.filter((source) => remoteExtensionTypesToMigrate.includes(source.type)), remoteSourcesMap = /* @__PURE__ */ new Map();
  return remote.forEach((remoteSource) => {
    remoteSourcesMap.set(remoteSource.uuid, remoteSource), remoteSourcesMap.set(slugify(remoteSource.title.substring(0, MAX_EXTENSION_HANDLE_LENGTH)), remoteSource);
  }), local.reduce((accumulator, localSource) => {
    let localSourceId = ids[localSource.localIdentifier] ?? "unknown", remoteSource = remoteSourcesMap.get(localSourceId) || remoteSourcesMap.get(localSource.localIdentifier), typeMatch = typesMap.get(localSource.type)?.includes(remoteSource?.type ?? "undefined");
    return remoteSource && typeMatch && accumulator.push({ local: localSource, remote: remoteSource }), accumulator;
  }, []);
}
async function migrateAppModules(extensionsToMigrate, appId, type, remoteExtensions, developerPlatformClient) {
  let migratedIDs = await Promise.all(extensionsToMigrate.map(({ remote }) => migrateAppModule(appId, remote.id, type, developerPlatformClient)));
  return remoteExtensions.filter((extension) => migratedIDs.includes(extension.id)).map((extension) => ({
    ...extension,
    type: type.toUpperCase()
  }));
}
async function migrateAppModule(apiKey, registrationId, type, developerPlatformClient) {
  let variables = {
    apiKey,
    registrationId,
    type
  }, result = await developerPlatformClient.migrateAppModule(variables);
  if (result?.migrateAppModule?.userErrors?.length > 0) {
    let errors2 = result.migrateAppModule.userErrors.map((error) => error.message).join(", ");
    throw new AbortError(errors2);
  }
  if (!result?.migrateAppModule?.migratedAppModule)
    throw new AbortError(`Couldn't migrate to app module ${type}`);
  return registrationId;
}

// ../app/dist/cli/services/context/identifiers-extensions.js
async function ensureExtensionsIds(options, { extensionRegistrations: initialRemoteExtensions, dashboardManagedExtensionRegistrations: dashboardOnlyExtensions }) {
  let remoteExtensions = initialRemoteExtensions, validIdentifiers = options.envIdentifiers.extensions ?? {}, localExtensions = options.app.allExtensions.filter((ext) => ext.isUUIDStrategyExtension), uiExtensionsToMigrate = getUIExtensionsToMigrate(localExtensions, remoteExtensions, validIdentifiers), flowExtensionsToMigrate = getFlowExtensionsToMigrate(localExtensions, dashboardOnlyExtensions, validIdentifiers), paymentsExtensionsToMigrate = getPaymentsExtensionsToMigrate(localExtensions, dashboardOnlyExtensions, validIdentifiers);
  if (uiExtensionsToMigrate.length > 0) {
    if (!await extensionMigrationPrompt(uiExtensionsToMigrate))
      throw new AbortSilentError();
    remoteExtensions = await migrateExtensionsToUIExtension(uiExtensionsToMigrate, options.appId, remoteExtensions, options.developerPlatformClient);
  }
  if (flowExtensionsToMigrate.length > 0) {
    if (!await extensionMigrationPrompt(flowExtensionsToMigrate, !1))
      throw new AbortSilentError();
    let newRemoteExtensions = await migrateFlowExtensions(flowExtensionsToMigrate, options.appId, dashboardOnlyExtensions, options.developerPlatformClient);
    remoteExtensions = remoteExtensions.concat(newRemoteExtensions);
  }
  if (paymentsExtensionsToMigrate.length > 0) {
    if (!await extensionMigrationPrompt(paymentsExtensionsToMigrate, !1))
      throw new AbortSilentError();
    let newRemoteExtensions = await migrateAppModules(paymentsExtensionsToMigrate, options.appId, "payments_extension", dashboardOnlyExtensions, options.developerPlatformClient);
    remoteExtensions = remoteExtensions.concat(newRemoteExtensions);
  }
  let matchExtensions = await automaticMatchmaking(localExtensions, remoteExtensions, validIdentifiers, options.developerPlatformClient), validMatches = matchExtensions.identifiers, extensionsToCreate = matchExtensions.toCreate ?? [];
  for (let pending of matchExtensions.toConfirm)
    await matchConfirmationPrompt(pending.local, pending.remote) ? validMatches[pending.local.localIdentifier] = pending.remote.uuid : extensionsToCreate.push(pending.local);
  if (matchExtensions.toManualMatch.local.length > 0) {
    let matchResult = await manualMatchIds(matchExtensions.toManualMatch);
    validMatches = { ...validMatches, ...matchResult.identifiers }, extensionsToCreate.push(...matchResult.toCreate);
  }
  return {
    validMatches,
    extensionsToCreate,
    dashboardOnlyExtensions
  };
}
async function deployConfirmed(options, extensionRegistrations, configurationRegistrations, { validMatches, extensionsToCreate }) {
  let { uuidUidStrategyExtensions, singleAndDynamicStrategyExtensions } = groupRegistrationByUidStrategy(extensionRegistrations, configurationRegistrations, options.app.specifications || []), { extensionsNonUuidManaged, extensionsIdsNonUuidManaged } = await ensureNonUuidManagedExtensionsIds(singleAndDynamicStrategyExtensions, options.app, options.appId, options.includeDraftExtensions, options.developerPlatformClient), validMatchesById = {};
  if (extensionsToCreate.length > 0) {
    let newIdentifiers = await createExtensions(extensionsToCreate, options.appId, options.developerPlatformClient);
    for (let [localIdentifier, registration] of Object.entries(newIdentifiers))
      validMatches[localIdentifier] = registration.uuid, validMatchesById[localIdentifier] = registration.id;
  }
  for (let [localIdentifier, uuid] of Object.entries(validMatches)) {
    let registration = uuidUidStrategyExtensions.find((registration2) => registration2.uuid === uuid);
    registration && (validMatchesById[localIdentifier] = registration.id);
  }
  return {
    extensions: validMatches,
    extensionIds: { ...validMatchesById, ...extensionsIdsNonUuidManaged },
    extensionsNonUuidManaged
  };
}
function matchWebhooks(remoteSource, extension) {
  let remoteVersionConfig = remoteSource.activeVersion?.config, remoteVersionConfigObj = remoteVersionConfig ? JSON.parse(remoteVersionConfig) : {}, localConfig = extension.configuration, remoteUri = remoteVersionConfigObj.uri || "";
  return remoteVersionConfigObj.topic === localConfig.topic && remoteUri.endsWith(localConfig.uri) && remoteVersionConfigObj.filter === localConfig.filter;
}
function loadExtensionIds(remoteConfigurationRegistrations, developerPlatformClient, localExtensionRegistrations, extensionsToCreate, validMatches, validMatchesById) {
  localExtensionRegistrations.forEach((local) => {
    let possibleMatches = remoteConfigurationRegistrations.filter((remote) => remote.type === developerPlatformClient.toExtensionGraphQLType(local.graphQLType)), match2;
    local.isSingleStrategyExtension && possibleMatches.length === 1 ? match2 = possibleMatches[0] : local.isDynamicStrategyExtension && (match2 = possibleMatches.find((possibleMatch) => matchWebhooks(possibleMatch, local))), match2 ? (validMatches[local.localIdentifier] = match2.uuid, validMatchesById[local.localIdentifier] = match2.id) : extensionsToCreate.push(local);
  });
}
async function ensureNonUuidManagedExtensionsIds(remoteConfigurationRegistrations, app, appId, includeDraftExtensions = !1, developerPlatformClient) {
  let localExtensionRegistrations = includeDraftExtensions ? app.draftableExtensions : app.allExtensions;
  localExtensionRegistrations = localExtensionRegistrations.filter((ext) => !ext.isUUIDStrategyExtension);
  let extensionsToCreate = [], validMatches = {}, validMatchesById = {};
  if (loadExtensionIds(remoteConfigurationRegistrations, developerPlatformClient, localExtensionRegistrations, extensionsToCreate, validMatches, validMatchesById), extensionsToCreate.length > 0) {
    let newIdentifiers = await createExtensions(extensionsToCreate, appId, developerPlatformClient, !1);
    for (let [localIdentifier, registration] of Object.entries(newIdentifiers))
      validMatches[localIdentifier] = registration.uuid, validMatchesById[localIdentifier] = registration.id;
  }
  return { extensionsNonUuidManaged: validMatches, extensionsIdsNonUuidManaged: validMatchesById };
}
async function createExtensions(extensions, appId, developerPlatformClient, output = !0) {
  let result = {};
  for (let extension of extensions)
    if (developerPlatformClient.supportsAtomicDeployments)
      result[extension.localIdentifier] = {
        id: extension.uid,
        uid: extension.uid,
        uuid: extension.uid,
        type: extension.type,
        title: extension.handle
      };
    else {
      let registration = await createExtension(appId, extension.graphQLType, extension.handle, developerPlatformClient, extension.contextValue);
      output && outputCompleted(`Created extension ${extension.handle}.`), result[extension.localIdentifier] = registration;
    }
  return result;
}
function groupRegistrationByUidStrategy(extensionRegistrations, configurationRegistrations, specifications) {
  let dynamicUidStrategySpecs = specifications.filter((spec3) => spec3.uidStrategy === "dynamic").map((spec3) => spec3.identifier), groupedExtensions = groupBy(extensionRegistrations, (registration) => dynamicUidStrategySpecs.includes(registration.type.toLowerCase())), singleAndDynamicStrategyExtensions = configurationRegistrations.concat(groupedExtensions.true ?? []);
  return { uuidUidStrategyExtensions: groupedExtensions.false ?? [], singleAndDynamicStrategyExtensions };
}

// ../app/dist/cli/services/context/breakdown-extensions.js
init_cjs_shims();

// ../app/dist/cli/services/release/version-diff.js
init_cjs_shims();
async function versionDiffByVersion(app, versionTag, developerPlatformClient) {
  let versionDetails = await versionDetailsByTag(app, versionTag, developerPlatformClient), { app: { versionsDiff } } = await developerPlatformClient.appVersionsDiff(app, {
    versionId: versionDetails.uuid,
    appVersionId: versionDetails.id
  });
  return { versionsDiff, versionDetails };
}
async function versionDetailsByTag(app, versionTag, developerPlatformClient) {
  try {
    let { app: { appVersion } } = await developerPlatformClient.appVersionByTag(app, versionTag);
    return appVersion;
  } catch {
    throw renderError({
      headline: "Version couldn't be released.",
      body: ["Version", { userInput: versionTag }, "could not be found."]
    }), new AbortSilentError();
  }
}

// ../app/dist/cli/services/app/select-app.js
init_cjs_shims();
async function selectApp() {
  let org = await selectOrg(), developerPlatformClient = selectDeveloperPlatformClient({ organization: org }), { apps, hasMorePages } = await developerPlatformClient.appsForOrg(org.id), selectedApp = await selectAppPrompt(searchForAppsByNameFactory(developerPlatformClient, org.id), apps, hasMorePages);
  return await developerPlatformClient.appFromId(selectedApp);
}
function extensionTypeStrategy(specs, type) {
  return type ? specs.find((spec4) => spec4.identifier === type || spec4.externalIdentifier === type || spec4.additionalIdentifiers?.includes(type))?.uidStrategy : void 0;
}
async function fetchAppRemoteConfiguration(remoteApp, developerPlatformClient, specifications, flags) {
  let appModuleVersionsConfig = (await developerPlatformClient.activeAppVersion(remoteApp))?.appModuleVersions.filter((module) => extensionTypeStrategy(specifications, module.specification?.identifier) !== "uuid") || [];
  return appModuleVersionsConfig.length === 0 ? void 0 : remoteAppConfigurationExtensionContent(appModuleVersionsConfig, specifications, flags);
}
function remoteAppConfigurationExtensionContent(configRegistrations, specifications, flags) {
  let remoteAppConfig = {}, configSpecifications = specifications.filter((spec3) => spec3.uidStrategy !== "uuid");
  return configRegistrations.forEach((module) => {
    let configSpec = configSpecifications.find((spec3) => spec3.identifier === module.specification?.identifier.toLowerCase());
    if (!configSpec)
      return;
    let config2 = module.config;
    config2 && (remoteAppConfig = deepMergeObjects(remoteAppConfig, configSpec.transformRemoteToLocal?.(config2, { flags }) ?? config2));
  }), { ...remoteAppConfig };
}

// ../app/dist/cli/services/app/write-app-configuration-file.js
init_cjs_shims();
async function writeAppConfigurationFile(configuration, schema) {
  outputDebug(`Writing app configuration to ${configuration.path}`);
  let initialComment = `# Learn more about configuring your app at https://shopify.dev/docs/apps/tools/cli/configuration
`, scopesComment = `
# Learn more at https://shopify.dev/docs/apps/tools/cli/configuration#access_scopes`, condensedWebhooksAppConfiguration = condenseComplianceAndNonComplianceWebhooks(configuration), sorted = rewriteConfiguration(schema, condensedWebhooksAppConfiguration), fileSplit = encodeToml(sorted).split(/(\r\n|\r|\n)/);
  fileSplit.unshift(`
`), fileSplit.unshift(initialComment), fileSplit.forEach((line, index) => {
    line === "[access_scopes]" && fileSplit.splice(index + 1, 0, scopesComment);
  });
  let file = fileSplit.join("");
  writeFileSync(configuration.path, file);
}
var rewriteConfiguration = (schema, config2) => {
  let configCopy = config2;
  if (typeof config2 == "object" && config2 !== null && config2 !== void 0 && "app_id" in config2 && !("organization_id" in config2)) {
    let { app_id, ...rest } = config2;
    configCopy = rest;
  }
  if (schema == null)
    return null;
  if (schema instanceof z.ZodNullable || schema instanceof z.ZodOptional)
    return rewriteConfiguration(schema.unwrap(), configCopy);
  if (schema instanceof z.ZodArray)
    return configCopy.map((item) => rewriteConfiguration(schema.element, item));
  if (schema instanceof z.ZodEffects)
    return rewriteConfiguration(schema._def.schema, configCopy);
  if (schema instanceof z.ZodObject) {
    let entries = Object.entries(schema.shape), confObj = configCopy, result = {};
    entries.forEach(([key, subSchema]) => {
      if (confObj !== void 0 && confObj[key] !== void 0) {
        let value = rewriteConfiguration(subSchema, confObj[key]);
        !(value instanceof Array) && value instanceof Object && Object.keys(value).length === 0 && (value = void 0), result = { ...result, [key]: value };
      }
    });
    let blockedKeys = ["path", "scopes"];
    return Object.entries(confObj).filter(([key]) => !blockedKeys.includes(key)).sort(([key, _value]) => key.localeCompare(key)).forEach(([key, value]) => {
      entries.map(([key2]) => key2).includes(key) || (result = { ...result, [key]: value });
    }), result;
  }
  return config2;
};
function condenseComplianceAndNonComplianceWebhooks(config2) {
  let webhooksConfig = config2.webhooks;
  if (webhooksConfig?.subscriptions?.length) {
    let appUrl = removeTrailingSlash(config2?.application_url);
    webhooksConfig.subscriptions = reduceWebhooks(webhooksConfig.subscriptions), webhooksConfig.subscriptions = webhooksConfig.subscriptions.map(({ uri, ...subscription }) => ({
      uri: appUrl && uri.includes(appUrl) ? uri.replace(appUrl, "") : uri,
      ...subscription
    }));
  }
  return config2;
}

// ../app/dist/cli/services/context/breakdown-extensions.js
function buildExtensionBreakdownInfo(title) {
  return { title, experience: "extension" };
}
function buildDashboardBreakdownInfo(title) {
  return { title, experience: "dashboard" };
}
async function extensionsIdentifiersDeployBreakdown(options) {
  let remoteExtensionsRegistrations = await fetchRemoteExtensionsRegistrations(options), extensionsToConfirm = await ensureExtensionsIds(options, remoteExtensionsRegistrations.app);
  extensionsToConfirm.dashboardOnlyExtensions.length > 0 && (remoteExtensionsRegistrations = await fetchRemoteExtensionsRegistrations(options));
  let extensionIdentifiersBreakdown = loadLocalExtensionsIdentifiersBreakdown(extensionsToConfirm);
  return options.release && (extensionIdentifiersBreakdown = await resolveRemoteExtensionIdentifiersBreakdown(options.developerPlatformClient, options.remoteApp, extensionsToConfirm.validMatches, extensionsToConfirm.extensionsToCreate, extensionsToConfirm.dashboardOnlyExtensions, options.app.specifications ?? []) ?? extensionIdentifiersBreakdown), {
    extensionIdentifiersBreakdown,
    extensionsToConfirm,
    remoteExtensionsRegistrations: remoteExtensionsRegistrations.app
  };
}
async function extensionsIdentifiersReleaseBreakdown(developerPlatformClient, app, version2) {
  let { versionsDiff, versionDetails } = await versionDiffByVersion(app, version2, developerPlatformClient), mapIsExtension = (extensions) => extensions.filter((extension) => extension.specification.experience === "extension" && extension.specification.identifier !== "webhook_subscription").map((extension) => buildExtensionBreakdownInfo(extension.registrationTitle)), mapIsDashboard = (extensions) => extensions.filter((extension) => extension.specification.options.managementExperience === "dashboard").map((extension) => buildDashboardBreakdownInfo(extension.registrationTitle));
  return { extensionIdentifiersBreakdown: {
    onlyRemote: [...mapIsExtension(versionsDiff.removed), ...mapIsDashboard(versionsDiff.removed)],
    toCreate: [...mapIsExtension(versionsDiff.added), ...mapIsDashboard(versionsDiff.added)],
    toUpdate: [...mapIsExtension(versionsDiff.updated), ...mapIsDashboard(versionsDiff.updated)]
  }, versionDetails };
}
async function configExtensionsIdentifiersBreakdown({ developerPlatformClient, remoteApp, localApp, versionAppModules, release: release2 }) {
  if (localApp.allExtensions.filter((extension) => extension.isAppConfigExtension).length !== 0)
    return release2 ? resolveRemoteConfigExtensionIdentifiersBreakdown(developerPlatformClient, remoteApp, localApp, versionAppModules) : loadLocalConfigExtensionIdentifiersBreakdown(localApp);
}
function loadLocalConfigExtensionIdentifiersBreakdown(app) {
  return {
    existingFieldNames: filterNonVersionedAppFields(app.configuration),
    existingUpdatedFieldNames: [],
    newFieldNames: [],
    deletedFieldNames: []
  };
}
async function fetchRemoteExtensionsRegistrations(options) {
  return options.developerPlatformClient.appExtensionRegistrations(options.remoteApp);
}
async function resolveRemoteConfigExtensionIdentifiersBreakdown(developerPlatformClient, remoteApp, app, versionAppModules) {
  let remoteConfig = await fetchAppRemoteConfiguration(remoteApp, developerPlatformClient, app.specifications ?? [], app.remoteFlags) ?? {}, baselineConfig = versionAppModules ? remoteAppConfigurationExtensionContent(versionAppModules, app.specifications ?? [], app.remoteFlags) : app.configuration;
  baselineConfig?.webhooks?.subscriptions?.length && (baselineConfig.webhooks.subscriptions = baselineConfig.webhooks.subscriptions.map((subscription) => (subscription.uri.startsWith("/") && (subscription.uri = `${baselineConfig.application_url}${subscription.uri}`), subscription)));
  let diffConfigContent = buildDiffConfigContent(baselineConfig, remoteConfig, app.configSchema), versionedLocalFieldNames = filterNonVersionedAppFields(baselineConfig), remoteDiffModifications = diffConfigContent ? getFieldsFromDiffConfigContent(diffConfigContent.baselineContent) : [], localDiffModifications = diffConfigContent ? getFieldsFromDiffConfigContent(diffConfigContent.updatedContent) : [], notModifiedVersionedLocalFieldNames = versionedLocalFieldNames.filter((field) => !remoteDiffModifications.includes(field) && !localDiffModifications.includes(field)), modifiedVersionedLocalFieldNames = versionedLocalFieldNames.filter((field) => remoteDiffModifications.includes(field) && localDiffModifications.includes(field)), newVersionedLocalFieldNames = localDiffModifications.filter((field) => !remoteDiffModifications.includes(field) && versionedLocalFieldNames.includes(field)), deletedVersionedLocalFieldNames = remoteDiffModifications.filter((field) => !localDiffModifications.includes(field) && field !== "handle");
  return {
    existingFieldNames: notModifiedVersionedLocalFieldNames,
    existingUpdatedFieldNames: modifiedVersionedLocalFieldNames,
    newFieldNames: newVersionedLocalFieldNames,
    deletedFieldNames: deletedVersionedLocalFieldNames
  };
}
function buildDiffConfigContent(localConfig, remoteConfig, schema) {
  let [updated, baseline] = deepDifference({ ...rewriteConfiguration(schema, localConfig), build: void 0 }, { ...rewriteConfiguration(schema, remoteConfig), build: void 0 });
  if (!deepCompare(updated, baseline))
    return {
      baselineContent: encodeToml(baseline),
      updatedContent: encodeToml(updated)
    };
}
function getFieldsFromDiffConfigContent(diffConfigContent) {
  let fields = diffConfigContent.split(/\n\s*\n/).flatMap((section) => {
    let lines = section.split(`
`);
    if (lines.length === 0)
      return [];
    let firstLineMatch = lines[0].match(/^(?:\[(\w+)|(\w+)\s*=)/);
    if (!firstLineMatch)
      return [];
    let firstFieldName = firstLineMatch[1] || firstLineMatch[2];
    if (!firstFieldName)
      return [];
    if (firstFieldName.includes("."))
      return [firstFieldName.split(".")[0]];
    let otherFieldNames = firstLineMatch[2] ? lines.slice(1).map((line) => line.match(/^(\w+)\s*=/)).filter(Boolean).map((match2) => match2[1]) : [];
    return [firstFieldName, ...otherFieldNames];
  }).filter((match2) => match2 !== void 0);
  return Array.from(new Set(fields));
}
function loadLocalExtensionsIdentifiersBreakdown({ validMatches: localRegistration, extensionsToCreate: localSourceToCreate, dashboardOnlyExtensions }) {
  let identifiersToUpdate = Object.keys(localRegistration).map(buildExtensionBreakdownInfo), identifiersToCreate = localSourceToCreate.map((source) => buildExtensionBreakdownInfo(source.localIdentifier)), dashboardToUpdate = dashboardOnlyExtensions.filter((dashboard) => !Object.values(localRegistration).includes(dashboard.uuid)).map((dashboard) => buildDashboardBreakdownInfo(dashboard.title));
  return {
    onlyRemote: [],
    toCreate: [],
    toUpdate: [...identifiersToUpdate, ...identifiersToCreate, ...dashboardToUpdate]
  };
}
async function resolveRemoteExtensionIdentifiersBreakdown(developerPlatformClient, remoteApp, localRegistration, toCreate, dashboardOnly, specs) {
  let activeAppVersion = await developerPlatformClient.activeAppVersion(remoteApp);
  if (!activeAppVersion)
    return;
  let extensionIdentifiersBreakdown = loadExtensionsIdentifiersBreakdown(activeAppVersion, localRegistration, toCreate, specs), dashboardOnlyFinal = dashboardOnly.filter((dashboardOnly2) => !Object.values(localRegistration).includes(dashboardOnly2.uuid) && !toCreate.map((source) => source.localIdentifier).includes(dashboardOnly2.uuid)), dashboardIdentifiersBreakdown = loadDashboardIdentifiersBreakdown(dashboardOnlyFinal, activeAppVersion);
  return {
    onlyRemote: [...extensionIdentifiersBreakdown.onlyRemote, ...dashboardIdentifiersBreakdown.onlyRemote],
    toCreate: [...extensionIdentifiersBreakdown.toCreate, ...dashboardIdentifiersBreakdown.toCreate],
    toUpdate: [...extensionIdentifiersBreakdown.toUpdate, ...dashboardIdentifiersBreakdown.toUpdate]
  };
}
function loadExtensionsIdentifiersBreakdown(activeAppVersion, localRegistration, toCreate, specs) {
  let extensionModules = activeAppVersion?.appModuleVersions.filter((ext) => extensionTypeStrategy(specs, ext.specification?.identifier) === "uuid"), extensionsToUpdate = Object.entries(localRegistration).filter(([_identifier, uuid]) => extensionModules.map((module) => module.registrationUuid).includes(uuid)).map(([identifier, _uuid]) => identifier), extensionsToCreate = Object.entries(localRegistration).filter(([_identifier, uuid]) => !extensionModules.map((module) => module.registrationUuid).includes(uuid)).map(([identifier, _uuid]) => identifier);
  return extensionsToCreate = Array.from(new Set(extensionsToCreate.concat(toCreate.map((source) => source.localIdentifier)))), {
    onlyRemote: extensionModules.filter((module) => !Object.values(localRegistration).includes(module.registrationUuid) && !toCreate.map((source) => source.localIdentifier).includes(module.registrationUuid)).map((module) => module.registrationTitle).map(buildExtensionBreakdownInfo),
    toCreate: extensionsToCreate.map(buildExtensionBreakdownInfo),
    toUpdate: extensionsToUpdate.map(buildExtensionBreakdownInfo)
  };
}
function loadDashboardIdentifiersBreakdown(currentRegistrations, activeAppVersion) {
  let currentVersions = activeAppVersion?.appModuleVersions.filter((module) => module.specification.options.managementExperience === "dashboard") || [], versionsNotIncluded = (version2) => !currentRegistrations.map((registration) => registration.uuid).includes(version2.registrationUuid), onlyRemote = currentVersions.filter(versionsNotIncluded).map((module) => buildDashboardBreakdownInfo(module.registrationTitle)), registrationIncluded = (registration) => currentVersions.map((version2) => version2.registrationUuid).includes(registration.uuid), registrationNotIncluded = (registration) => !registrationIncluded(registration), toCreate = currentRegistrations.filter(registrationNotIncluded).map((registration) => buildDashboardBreakdownInfo(registration.title)), toUpdate = currentRegistrations.filter(registrationIncluded).map((registration) => buildDashboardBreakdownInfo(registration.title));
  return {
    onlyRemote,
    toCreate,
    toUpdate
  };
}

// ../app/dist/cli/prompts/deploy-release.js
init_cjs_shims();

// ../app/dist/cli/prompts/ui/deploy-release-info-table-section.js
init_cjs_shims();
var NewItem = {
  bullet: "+",
  color: "green",
  suffix: "(new)"
}, UpdatedItem = {
  color: "#FF8800",
  suffix: "(updated)"
}, RemovedItem = {
  bullet: "-",
  color: "red",
  suffix: "(removed)"
};
function buildDeployReleaseInfoTableSection(section) {
  return [
    ...section.new.map((item) => buildItem(item, NewItem)),
    ...section.updated ? section.updated.map((item) => buildItem(item, UpdatedItem)) : [],
    ...section.unchanged,
    ...section.removed.map((item) => buildItem(item, RemovedItem))
  ];
}
function buildItem(item, itemTemplate) {
  let itemContent = typeof item == "string" ? [item, { subdued: itemTemplate.suffix ?? "" }] : item;
  return { ...itemTemplate.bullet ? { bullet: itemTemplate.bullet } : {}, item: itemContent, color: itemTemplate.color };
}

// ../app/dist/cli/prompts/deploy-release.js
async function deployOrReleaseConfirmationPrompt({ force, extensionIdentifiersBreakdown, configExtensionIdentifiersBreakdown, appTitle, release: release2 }) {
  if (await metadata_default.addPublicMetadata(() => buildConfigurationBreakdownMetadata(configExtensionIdentifiersBreakdown)), force)
    return !0;
  let extensionsContentPrompt = await buildExtensionsContentPrompt(extensionIdentifiersBreakdown), configContentPrompt = await buildConfigContentPrompt(release2, configExtensionIdentifiersBreakdown);
  return deployConfirmationPrompt({
    appTitle,
    extensionsContentPrompt,
    configContentPrompt,
    release: release2
  });
}
async function deployConfirmationPrompt({ appTitle, extensionsContentPrompt: { extensionsInfoTable, hasDeletedExtensions }, configContentPrompt, release: release2 }) {
  let timeBeforeConfirmationMs = (/* @__PURE__ */ new Date()).valueOf(), confirmationResponse = !0, infoTable = [];
  configContentPrompt && infoTable.push(configContentPrompt.configInfoTable.items.length === 0 ? { ...configContentPrompt.configInfoTable, emptyItemsText: "No changes", items: [] } : configContentPrompt.configInfoTable);
  let isDangerous = appTitle !== void 0 && hasDeletedExtensions;
  extensionsInfoTable ? infoTable.push(isDangerous ? { ...extensionsInfoTable, helperText: "Removing extensions can permanentely delete app user data" } : extensionsInfoTable) : infoTable.push({ header: "Extensions:", emptyItemsText: "None", items: [] });
  let question = `${release2 ? "Release" : "Create"} a new version${appTitle ? ` of ${appTitle}` : ""}?`;
  isDangerous ? confirmationResponse = await renderDangerousConfirmationPrompt({
    message: question,
    infoTable,
    confirmation: appTitle
  }) : confirmationResponse = await renderConfirmationPrompt({
    message: question,
    infoTable,
    confirmationMessage: `Yes, ${release2 ? "release" : "create"} this new version`,
    cancellationMessage: "No, cancel"
  });
  let timeToConfirmOrCancelMs = (/* @__PURE__ */ new Date()).valueOf() - timeBeforeConfirmationMs;
  return await metadata_default.addPublicMetadata(() => ({
    cmd_deploy_confirm_cancelled: !confirmationResponse,
    cmd_deploy_confirm_time_to_complete_ms: timeToConfirmOrCancelMs
  })), confirmationResponse;
}
async function buildExtensionsContentPrompt(extensionsContentBreakdown) {
  let { onlyRemote, toCreate: toCreateBreakdown, toUpdate } = extensionsContentBreakdown, mapExtensionToInfoTableItem = (extension, preffix) => {
    switch (extension.experience) {
      case "dashboard":
        return [extension.title, { subdued: `(${preffix}from Partner Dashboard)` }];
      case "extension":
        return extension.title;
    }
  }, extensionsInfoTable, section = {
    new: toCreateBreakdown.map((extension) => mapExtensionToInfoTableItem(extension, "new, ")),
    unchanged: toUpdate.map((extension) => mapExtensionToInfoTableItem(extension, "")),
    removed: onlyRemote.map((extension) => mapExtensionToInfoTableItem(extension, "removed, "))
  }, extensionsInfo = buildDeployReleaseInfoTableSection(section), hasDeletedExtensions = onlyRemote.length > 0;
  return extensionsInfo.length > 0 && (extensionsInfoTable = {
    header: "Extensions:",
    items: extensionsInfo
  }), await metadata_default.addPublicMetadata(() => ({
    cmd_deploy_confirm_new_registrations: toCreateBreakdown.length,
    cmd_deploy_confirm_updated_registrations: toUpdate.length,
    cmd_deploy_confirm_removed_registrations: onlyRemote.length
  })), { extensionsInfoTable, hasDeletedExtensions };
}
async function buildConfigContentPrompt(release2, configContentBreakdown) {
  if (!configContentBreakdown)
    return;
  let { existingFieldNames, existingUpdatedFieldNames, newFieldNames, deletedFieldNames } = configContentBreakdown, configurationInfo = buildDeployReleaseInfoTableSection({
    new: newFieldNames,
    updated: existingUpdatedFieldNames,
    unchanged: existingFieldNames,
    removed: deletedFieldNames
  });
  return { configInfoTable: {
    header: "Configuration:",
    items: newFieldNames.length > 0 || existingUpdatedFieldNames.length > 0 || deletedFieldNames.length > 0 || !release2 ? configurationInfo : []
  } };
}
function buildConfigurationBreakdownMetadata(configExtensionIdentifiersBreakdown) {
  if (!configExtensionIdentifiersBreakdown)
    return { cmd_deploy_include_config_used: !1 };
  let { existingFieldNames, existingUpdatedFieldNames, newFieldNames, deletedFieldNames } = configExtensionIdentifiersBreakdown, currentConfiguration = [...existingUpdatedFieldNames, ...newFieldNames, ...existingFieldNames];
  return {
    cmd_deploy_include_config_used: !0,
    ...currentConfiguration.length > 0 ? { cmd_deploy_config_modules_breakdown: JSON.stringify(currentConfiguration.sort()) } : {},
    ...existingUpdatedFieldNames.length > 0 ? { cmd_deploy_config_modules_updated: JSON.stringify(existingUpdatedFieldNames.sort()) } : {},
    ...newFieldNames.length > 0 ? { cmd_deploy_config_modules_added: JSON.stringify(newFieldNames.sort()) } : {},
    ...deletedFieldNames.length > 0 ? { cmd_deploy_config_modules_deleted: JSON.stringify(deletedFieldNames.sort()) } : {}
  };
}

// ../app/dist/cli/services/context/identifiers.js
async function ensureDeploymentIdsPresence(options) {
  let { extensionIdentifiersBreakdown, extensionsToConfirm, remoteExtensionsRegistrations } = await extensionsIdentifiersDeployBreakdown(options), configExtensionIdentifiersBreakdown = await configExtensionsIdentifiersBreakdown({
    developerPlatformClient: options.developerPlatformClient,
    apiKey: options.appId,
    localApp: options.app,
    remoteApp: options.remoteApp,
    release: options.release
  });
  if (!await deployOrReleaseConfirmationPrompt({
    extensionIdentifiersBreakdown,
    configExtensionIdentifiersBreakdown,
    appTitle: options.remoteApp?.title,
    release: options.release,
    force: options.force
  }))
    throw new AbortSilentError();
  let result = await deployConfirmed(options, remoteExtensionsRegistrations.extensionRegistrations, remoteExtensionsRegistrations.configurationRegistrations, extensionsToConfirm);
  return {
    app: options.appId,
    extensions: result.extensions,
    extensionIds: result.extensionIds,
    extensionsNonUuidManaged: result.extensionsNonUuidManaged
  };
}

// ../app/dist/cli/services/app/config/link.js
init_cjs_shims();

// ../app/dist/cli/services/generate/fetch-extension-specifications.js
init_cjs_shims();

// ../app/dist/cli/models/extensions/load-specifications.js
init_cjs_shims();

// ../app/dist/cli/models/extensions/specifications/checkout_post_purchase.js
init_cjs_shims();
var dependency = "@shopify/post-purchase-ui-extensions", checkoutPostPurchaseSpec = createExtensionSpecification({
  identifier: "checkout_post_purchase",
  dependency,
  partnersWebIdentifier: "post_purchase",
  schema: BaseSchema,
  appModuleFeatures: (_2) => ["ui_preview", "bundling", "esbuild", "single_js_entry_path"],
  deployConfig: async (config2, _2) => ({ metafields: config2.metafields })
}), checkout_post_purchase_default = checkoutPostPurchaseSpec;

// ../app/dist/cli/models/extensions/specifications/checkout_ui_extension.js
init_cjs_shims();

// ../app/dist/cli/utilities/extensions/locales-configuration.js
init_cjs_shims();
import fs3 from "fs";
var L10N_FILE_SIZE_LIMIT = 16 * 1024, L10N_BUNDLE_SIZE_LIMIT = 256 * 1024;
async function loadLocalesConfig(extensionPath, extensionIdentifier) {
  let localesPaths = await glob(joinPath(extensionPath, "locales/*.json"));
  if (localesPaths.length === 0)
    return {};
  let totalBundleSize = bundleSize(localesPaths), defaultLanguageCode = findDefaultLocale(localesPaths);
  if (defaultLanguageCode.length === 0)
    throw new AbortError(`Missing default language in ${extensionIdentifier} configuration`, "Make sure to have a {locale}.default.json file in your locales directory");
  if (defaultLanguageCode.length > 1)
    throw new AbortError(`Error loading ${extensionIdentifier}`, 'There must be one (and only one) locale identified as the default locale: e.g. "en.default.json"');
  if (totalBundleSize > L10N_BUNDLE_SIZE_LIMIT)
    throw new AbortError(`Error loading ${extensionIdentifier}`, `Total size of all locale files must be less than ${L10N_BUNDLE_SIZE_LIMIT}`);
  for (let locale of localesPaths) {
    let size = fs3.statSync(locale).size;
    if (size > L10N_FILE_SIZE_LIMIT)
      throw new AbortError(`Error loading ${extensionIdentifier}`, `Locale file ${locale} size must be less than ${L10N_FILE_SIZE_LIMIT}`);
    if (size === 0)
      throw new AbortError(`Error loading ${extensionIdentifier}`, `Locale file ${locale} can't be empty`);
  }
  return {
    default_locale: defaultLanguageCode[0],
    translations: getAllLocales(localesPaths)
  };
}
function findDefaultLocale(filePaths) {
  return filePaths.filter((locale) => basename(locale).endsWith(".default.json")).map((locale) => basename(locale).split(".")[0]);
}
function getAllLocales(localesPath) {
  let all = {};
  for (let localePath of localesPath) {
    let localeCode = basename(localePath).split(".")[0], locale = fs3.readFileSync(localePath, "base64");
    all[localeCode] = locale;
  }
  return all;
}
function bundleSize(localesPaths) {
  return localesPaths.map((locale) => fs3.statSync(locale).size).reduce((acc, size) => acc + size, 0);
}

// ../app/dist/cli/models/extensions/specifications/checkout_ui_extension.js
var dependency2 = "@shopify/checkout-ui-extensions", CheckoutSchema = BaseSchema.extend({
  extension_points: z.array(z.string()).optional(),
  settings: z.object({
    fields: z.any().optional()
  }).optional()
}), checkoutSpec = createExtensionSpecification({
  identifier: "checkout_ui_extension",
  dependency: dependency2,
  schema: CheckoutSchema,
  appModuleFeatures: (_2) => ["ui_preview", "bundling", "cart_url", "esbuild", "single_js_entry_path"],
  deployConfig: async (config2, directory) => ({
    extension_points: config2.extension_points,
    capabilities: config2.capabilities,
    metafields: config2.metafields,
    name: config2.name,
    settings: config2.settings,
    localization: await loadLocalesConfig(directory, "checkout_ui")
  })
}), checkout_ui_extension_default = checkoutSpec;

// ../app/dist/cli/models/extensions/specifications/flow_action.js
init_cjs_shims();

// ../app/dist/cli/services/flow/validation.js
init_cjs_shims();

// ../app/dist/cli/services/flow/constants.js
init_cjs_shims();
var SUPPORTED_COMMERCE_OBJECTS = {
  customer_reference: "customer_reference",
  order_reference: "order_reference",
  product_reference: "product_reference",
  marketing_activity_reference: "marketing_activity_reference",
  abandonment_reference: "abandonment_reference",
  company_reference: "company_reference",
  company_contact_reference: "company_contact_reference"
}, PARTNERS_COMMERCE_OBJECTS = [
  "customer",
  "order",
  "product",
  "marketing_activity",
  "abandonment",
  "company",
  "company_contact"
], TRIGGER_SUPPORTED_COMMERCE_OBJECTS = [
  SUPPORTED_COMMERCE_OBJECTS.customer_reference,
  SUPPORTED_COMMERCE_OBJECTS.order_reference,
  SUPPORTED_COMMERCE_OBJECTS.product_reference,
  SUPPORTED_COMMERCE_OBJECTS.company_reference,
  SUPPORTED_COMMERCE_OBJECTS.company_contact_reference
], ACTION_SUPPORTED_COMMERCE_OBJECTS = [
  SUPPORTED_COMMERCE_OBJECTS.customer_reference,
  SUPPORTED_COMMERCE_OBJECTS.order_reference,
  SUPPORTED_COMMERCE_OBJECTS.product_reference,
  SUPPORTED_COMMERCE_OBJECTS.marketing_activity_reference,
  SUPPORTED_COMMERCE_OBJECTS.abandonment_reference,
  SUPPORTED_COMMERCE_OBJECTS.company_reference,
  SUPPORTED_COMMERCE_OBJECTS.company_contact_reference
], UI_TYPES = {
  boolean: "boolean",
  email: "email",
  multiLineText: "multi_line_text_field",
  int: "number_integer",
  singleLineText: "single_line_text_field",
  url: "url",
  decimal: "number_decimal",
  schemaTypeReference: "schema_type_reference"
}, uiTypesMap = [
  [UI_TYPES.boolean, "checkbox"],
  [UI_TYPES.email, "email"],
  [UI_TYPES.multiLineText, "text-multi-line"],
  [UI_TYPES.int, "int"],
  [UI_TYPES.singleLineText, "text-single-line"],
  [UI_TYPES.url, "url"],
  [UI_TYPES.decimal, "number"],
  [UI_TYPES.schemaTypeReference, "schema-type-reference"]
], supportedActionTypes = [
  UI_TYPES.boolean,
  UI_TYPES.email,
  UI_TYPES.multiLineText,
  UI_TYPES.int,
  UI_TYPES.singleLineText,
  UI_TYPES.url,
  UI_TYPES.decimal
], supportedTriggerTypes = [
  UI_TYPES.boolean,
  UI_TYPES.email,
  UI_TYPES.singleLineText,
  UI_TYPES.url,
  UI_TYPES.decimal,
  UI_TYPES.schemaTypeReference
], actionUiTypesMap = uiTypesMap.filter(([key]) => supportedActionTypes.includes(key)), triggerUiTypesMap = uiTypesMap.filter(([key]) => supportedTriggerTypes.includes(key));

// ../app/dist/cli/models/extensions/specifications/flow_trigger.js
init_cjs_shims();

// ../app/dist/cli/services/flow/utils.js
init_cjs_shims();
var loadSchemaFromPath = async (extensionPath, patchPath) => {
  if (!patchPath)
    return "";
  let path3 = await glob(joinPath(extensionPath, patchPath));
  if (path3.length > 1)
    throw new Error("Multiple files found for schema path");
  if (path3.length === 0)
    throw new Error("No file found for schema path");
  return readFile(path3[0]);
};

// ../app/dist/cli/services/flow/serialize-fields.js
init_cjs_shims();
var actionTypesToUiTypes = new Map(actionUiTypesMap), triggerTypesToUiTypes = new Map(triggerUiTypesMap), serializeConfigField = (field, type) => {
  let typesToUiTypes = type === "flow_action" ? actionTypesToUiTypes : triggerTypesToUiTypes, typeIsSchemaTypeReference = isSchemaTypeReference(field.type), uiType = typeIsSchemaTypeReference ? typesToUiTypes.get("schema_type_reference") : typesToUiTypes.get(field.type);
  if (typeof field.key != "string")
    throw new AbortError(`key property must be specified for non-commerce object fields in ${JSON.stringify(field)}`);
  if (!uiType)
    throw new AbortError(`Field type ${field.type} is not supported on Flow ${type === "flow_action" ? "Actions" : "Triggers"}`);
  let serializedField = {
    name: field.key,
    description: field.description,
    uiType
  };
  return type === "flow_action" && (serializedField.label = field.name, serializedField.required = field.required), typeIsSchemaTypeReference && (serializedField.typeRefName = field.type.replace("schema.", "")), serializedField;
}, serializeCommerceObjectField = (field, type) => {
  if (type === "flow_trigger" && !TRIGGER_SUPPORTED_COMMERCE_OBJECTS.includes(field.type))
    throw new AbortError(`Commerce object ${field.type} is not supported for Flow Triggers`);
  if (type === "flow_action" && !ACTION_SUPPORTED_COMMERCE_OBJECTS.includes(field.type))
    throw new AbortError(`Commerce object ${field.type} is not supported for Flow Actions`);
  let commerceObject = field.type.replace("_reference", ""), serializedField = {
    name: `${commerceObject}_id`,
    uiType: type === "flow_action" ? "commerce-object-id" : commerceObject,
    description: field.description
  };
  return type === "flow_action" && (serializedField.label = `${pascalize(commerceObject)} ID`, serializedField.required = field.required), serializedField;
}, serializeFields = (type, fields) => fields ? fields.map((field) => Object.keys(SUPPORTED_COMMERCE_OBJECTS).includes(field.type) ? serializeCommerceObjectField(field, type) : serializeConfigField(field, type)) : [];

// ../app/dist/cli/models/extensions/specifications/flow_trigger.js
var FlowTriggerSettingsSchema = FieldSchema.extend({
  key: z.string().regex(/^[a-zA-Z\s]*$/, {
    message: "String must contain only alphabetic characters and spaces"
  }).optional()
}), FlowTriggerExtensionSchema = BaseSchemaWithHandle.extend({
  type: z.literal("flow_trigger"),
  schema: z.string().optional(),
  settings: z.object({
    fields: z.array(FlowTriggerSettingsSchema).optional()
  }).optional()
}).refine((config2) => {
  let fields = config2.settings?.fields ?? [], settingsFieldsAreValid = fields.every((field, index) => validateFieldShape(field, "flow_trigger", config2.handle, index)), schemaPresenceIsValid = validateTriggerSchemaPresence(fields, config2.schema);
  return settingsFieldsAreValid && schemaPresenceIsValid;
}), flowTriggerSpecification = createExtensionSpecification({
  identifier: "flow_trigger",
  schema: FlowTriggerExtensionSchema,
  // Flow doesn't have anything to bundle but we need to set this to true to
  // ensure that the extension configuration is uploaded after registration in
  // https://github.com/Shopify/cli/blob/73ac91c0f40be0a57d1b18cb34254b12d3a071af/packages/app/src/cli/services/deploy.ts#L107
  // Should be removed after unified deployment is 100% rolled out
  appModuleFeatures: (_2) => ["bundling"],
  deployConfig: async (config2, extensionPath) => ({
    title: config2.name,
    description: config2.description,
    fields: serializeFields("flow_trigger", config2.settings?.fields),
    schema_patch: await loadSchemaFromPath(extensionPath, config2.schema)
  })
}), flow_trigger_default = flowTriggerSpecification;

// ../app/dist/cli/services/flow/validation.js
function fieldValidationErrorMessage(property, configField, handle, index) {
  let errorMessage2 = `'${property}' property must be a string for 'field[${index}]' ${JSON.stringify(configField)} of flow extension '${handle}'`;
  return { required_error: errorMessage2, invalid_type_error: errorMessage2 };
}
var baseFieldSchema = z.object({
  type: z.string(),
  description: z.string().optional()
}).strict(), validateFieldShape = (configField, type, extensionHandle, index) => {
  let isCommerceObjectField = Object.keys(SUPPORTED_COMMERCE_OBJECTS).includes(configField.type);
  return isCommerceObjectField ? isCommerceObjectField ? baseFieldSchema.extend({
    required: z.boolean().optional()
  }).parse(configField) : baseFieldSchema.parse(configField) : type === "flow_action" ? baseFieldSchema.extend({
    key: z.string(fieldValidationErrorMessage("key", configField, extensionHandle, index)),
    name: z.string(fieldValidationErrorMessage("name", configField, extensionHandle, index)),
    required: z.boolean().optional()
  }).parse(configField) : FlowTriggerSettingsSchema.parse(configField);
}, startsWithHttps = (url) => url.startsWith("https://"), isSchemaTypeReference = (type) => type.startsWith("schema."), validateCustomConfigurationPageConfig = (configPageUrl, configPagePreviewUrl, validationUrl) => {
  if (configPageUrl || configPagePreviewUrl) {
    if (!configPageUrl)
      throw new z.ZodError([
        {
          code: z.ZodIssueCode.custom,
          path: ["extensions[0].config_page_url"],
          message: "To set a custom configuration page a `config_page_url` must be specified."
        }
      ]);
    if (!configPagePreviewUrl)
      throw new z.ZodError([
        {
          code: z.ZodIssueCode.custom,
          path: ["extensions[0].config_page_preview_url"],
          message: "To set a custom configuration page a `config_page_preview_url` must be specified."
        }
      ]);
    if (!validationUrl)
      throw new z.ZodError([
        {
          code: z.ZodIssueCode.custom,
          path: ["extensions[0].validation_url"],
          message: "To set a custom configuration page a `validation_url` must be specified."
        }
      ]);
  }
  return !0;
}, validateTriggerSchemaPresence = (fields, schema) => {
  if (fields.some((field) => isSchemaTypeReference(field.type)) && !schema)
    throw new z.ZodError([
      {
        code: z.ZodIssueCode.custom,
        path: ["extensions[0].schema"],
        message: "To reference schema types a `schema` must be specified."
      }
    ]);
  return !0;
}, validateReturnTypeConfig = (returnTypeRef, schema) => {
  if (returnTypeRef || schema) {
    if (!returnTypeRef)
      throw new z.ZodError([
        {
          code: z.ZodIssueCode.custom,
          path: ["extensions[0].return_type_ref"],
          message: "When uploading a schema a `return_type_ref` must be specified."
        }
      ]);
    if (!schema)
      throw new z.ZodError([
        {
          code: z.ZodIssueCode.custom,
          path: ["extensions[0].schema"],
          message: "To set a return type a `schema` must be specified."
        }
      ]);
  }
  return !0;
};

// ../app/dist/cli/models/extensions/specifications/flow_action.js
var FlowActionExtensionSchema = BaseSchemaWithHandle.extend({
  type: z.literal("flow_action"),
  runtime_url: z.string().url().refine(startsWithHttps),
  validation_url: z.string().url().refine(startsWithHttps).optional(),
  config_page_url: z.string().url().refine(startsWithHttps).optional(),
  config_page_preview_url: z.string().url().refine(startsWithHttps).optional(),
  schema: z.string().optional(),
  return_type_ref: z.string().optional()
}).refine((config2) => {
  let configurationPageIsValid = validateCustomConfigurationPageConfig(config2.config_page_url, config2.config_page_preview_url, config2.validation_url), settingsFieldsAreValid = (config2.settings?.fields ?? []).every((field, index) => validateFieldShape(field, "flow_action", config2.handle, index)), returnTypeIsValid = validateReturnTypeConfig(config2.return_type_ref, config2.schema);
  return configurationPageIsValid && settingsFieldsAreValid && returnTypeIsValid;
}), flowActionSpecification = createExtensionSpecification({
  identifier: "flow_action",
  schema: FlowActionExtensionSchema,
  // Flow doesn't have anything to bundle but we need to set this to true to
  // ensure that the extension configuration is uploaded after registration in
  // https://github.com/Shopify/cli/blob/73ac91c0f40be0a57d1b18cb34254b12d3a071af/packages/app/src/cli/services/deploy.ts#L107
  // Should be removed after unified deployment is 100% rolled out
  appModuleFeatures: (_2) => ["bundling"],
  deployConfig: async (config2, extensionPath) => ({
    title: config2.name,
    description: config2.description,
    url: config2.runtime_url,
    fields: serializeFields("flow_action", config2.settings?.fields),
    validation_url: config2.validation_url,
    custom_configuration_page_url: config2.config_page_url,
    custom_configuration_page_preview_url: config2.config_page_preview_url,
    schema_patch: await loadSchemaFromPath(extensionPath, config2.schema),
    return_type_ref: config2.return_type_ref
  })
}), flow_action_default = flowActionSpecification;

// ../app/dist/cli/models/extensions/specifications/flow_template.js
init_cjs_shims();
import fs4 from "fs";
var VALID_CATEGORIES = [
  "buyer_experience",
  "customers",
  "fulfillment",
  "inventory_and_merch",
  "loyalty",
  "orders",
  "promotion",
  "risk",
  "b2b",
  "payment_reminders",
  "custom_data",
  "error_monitoring"
], FLOW_TEAM_CATEGORIES = ["capture_at_fulfillment"], FlowTemplateExtensionSchema = BaseSchemaWithHandle.extend({
  type: z.literal("flow_template"),
  description: z.string().max(1024),
  template: z.object({
    categories: z.array(z.string().refine((category) => VALID_CATEGORIES.concat(FLOW_TEAM_CATEGORIES).includes(category), (category) => ({
      message: `${category} is not a valid category. Valid categories include: ${VALID_CATEGORIES.join(", ")}.`
    }))),
    module: z.string(),
    require_app: z.boolean().optional(),
    discoverable: z.boolean().optional(),
    allow_one_click_activate: z.boolean().optional(),
    enabled: z.boolean().optional()
  })
}), flowTemplateSpec = createExtensionSpecification({
  identifier: "flow_template",
  schema: FlowTemplateExtensionSchema,
  appModuleFeatures: (_2) => ["ui_preview", "bundling"],
  deployConfig: async (config2, extensionPath) => ({
    template_handle: config2.handle,
    name: config2.name,
    description: config2.description,
    categories: config2.template.categories,
    require_app: config2.template.require_app,
    discoverable: config2.template.discoverable,
    allow_one_click_activate: config2.template.allow_one_click_activate,
    enabled: config2.template.enabled,
    definition: await loadWorkflow(extensionPath, config2.template.module),
    localization: await loadLocalesConfig(extensionPath, config2.name)
  })
});
async function loadWorkflow(path3, workflowPath) {
  let flowFilePath = (await glob(joinPath(path3, workflowPath)))[0];
  if (!flowFilePath)
    throw new AbortError(`Missing flow file with the path ${joinPath(path3, workflowPath)}`);
  return fs4.readFileSync(flowFilePath, "base64");
}
var flow_template_default = flowTemplateSpec;

// ../app/dist/cli/models/extensions/specifications/function.js
init_cjs_shims();
var FunctionExtensionSchema = BaseSchema.extend({
  build: z.object({
    command: z.string().transform((value) => value.trim() === "" ? void 0 : value).optional(),
    path: z.string().optional(),
    watch: z.union([z.string(), z.string().array()]).optional()
  }),
  configuration_ui: z.boolean().optional().default(!0),
  ui: z.object({
    enable_create: z.boolean().optional(),
    paths: z.object({
      create: z.string(),
      details: z.string()
    }).optional(),
    handle: z.string().optional()
  }).optional(),
  api_version: z.string(),
  input: z.object({
    variables: z.object({
      namespace: z.string(),
      key: z.string()
    }).optional()
  }).optional(),
  targeting: z.array(z.object({
    target: z.string(),
    input_query: z.string().optional(),
    export: z.string().optional()
  })).optional()
}), functionSpec = createExtensionSpecification({
  identifier: "function",
  additionalIdentifiers: [
    "order_discounts",
    "cart_checkout_validation",
    "cart_transform",
    "delivery_customization",
    "payment_customization",
    "product_discounts",
    "shipping_discounts",
    "fulfillment_constraints",
    "order_routing_location_rule",
    "local_pickup_delivery_option_generator",
    "pickup_point_delivery_option_generator"
  ],
  schema: FunctionExtensionSchema,
  appModuleFeatures: (_2) => ["function"],
  deployConfig: async (config2, directory, apiKey, moduleId) => {
    let inputQuery, inputQueryPath = joinPath(directory, "input.graphql");
    await fileExists(inputQueryPath) && (inputQuery = await readFile(inputQueryPath));
    let targets = config2.targeting && await Promise.all(config2.targeting.map(async (config3) => {
      let inputQuery2;
      return config3.input_query && (inputQuery2 = await readInputQuery(joinPath(directory, config3.input_query))), { handle: config3.target, export: config3.export, input_query: inputQuery2 };
    })), ui;
    return config2.ui?.paths && (ui = {
      app_bridge: {
        details_path: config2.ui.paths.details,
        create_path: config2.ui.paths.create
      }
    }), config2.ui?.handle !== void 0 && (ui = {
      ...ui,
      ui_extension_handle: config2.ui.handle
    }), {
      title: config2.name,
      module_id: moduleId,
      description: config2.description,
      app_key: apiKey,
      api_type: config2.type === "function" ? void 0 : config2.type,
      api_version: config2.api_version,
      input_query: inputQuery,
      input_query_variables: config2.input?.variables ? {
        single_json_metafield: config2.input.variables
      } : void 0,
      ui,
      enable_creation_ui: config2.ui?.enable_create ?? !0,
      localization: await loadLocalesConfig(directory, "function"),
      targets
    };
  },
  preDeployValidation: async (extension) => {
    if (!await fileExists(extension.outputPath))
      throw new AbortError(outputContent`The function extension "${extension.handle}" hasn't compiled the wasm in the expected path: ${extension.outputPath}`, "Make sure the build command outputs the wasm in the expected directory.");
  }
});
async function readInputQuery(path3) {
  if (await fileExists(path3))
    return readFile(path3);
  throw new AbortError(`No input query file at ${path3}.`, "Create the file or remove the line referencing it in the extension's TOML.");
}
var function_default = functionSpec;

// ../app/dist/cli/models/extensions/specifications/payments_app_extension.js
init_cjs_shims();

// ../app/dist/cli/models/extensions/specifications/payments_app_extension_schemas/offsite_payments_app_extension_schema.js
init_cjs_shims();

// ../app/dist/cli/models/extensions/specifications/payments_app_extension_schemas/base_payments_app_extension_schema.js
init_cjs_shims();
var MAX_LABEL_SIZE = 50, BasePaymentsAppExtensionSchema = BaseSchema.extend({
  api_version: z.string(),
  payment_session_url: z.string().url(),
  refund_session_url: z.string().url().optional(),
  capture_session_url: z.string().url().optional(),
  void_session_url: z.string().url().optional(),
  supported_countries: z.array(z.string()),
  supported_payment_methods: z.array(z.string()),
  test_mode_available: z.boolean(),
  merchant_label: z.string().max(MAX_LABEL_SIZE),
  input: z.object({
    metafield_identifiers: z.object({
      namespace: z.string(),
      key: z.string()
    }).optional()
  }).optional()
}), BuyerLabelSchema = z.object({
  buyer_label: z.string().max(MAX_LABEL_SIZE).optional(),
  buyer_label_translations: z.array(z.object({ locale: z.string(), label: z.string() })).optional()
}), DeferredPaymentsSchema = z.object({
  supports_installments: z.boolean(),
  supports_deferred_payments: z.boolean()
}), MultipleCaptureSchema = z.object({
  multiple_capture: z.boolean().optional()
}), ConfirmationSchema = z.object({
  confirmation_callback_url: z.string().url().optional(),
  supports_3ds: z.boolean()
}), SupportedBuyerContextsSchema = z.object({
  supported_buyer_contexts: z.array(z.object({
    currency: z.string(),
    countries: z.array(z.string()).nonempty().optional()
  }).strict()).optional().refine((values) => values === void 0 || values.every((value) => value.countries) || values.every((value) => !value.countries), {
    message: "Must all be defined with only a currency, or must all be defined with a currency plus countries -- a mixture of the two is not allowed"
  })
});

// ../app/dist/cli/models/extensions/specifications/payments_app_extension_schemas/offsite_payments_app_extension_schema.js
var OFFSITE_TARGET = "payments.offsite.render", OffsitePaymentsAppExtensionSchema = BasePaymentsAppExtensionSchema.merge(BuyerLabelSchema).merge(DeferredPaymentsSchema).merge(ConfirmationSchema).merge(MultipleCaptureSchema).merge(SupportedBuyerContextsSchema).extend({
  targeting: z.array(z.object({ target: z.literal(OFFSITE_TARGET) })).length(1),
  supports_oversell_protection: z.boolean().optional()
}).refine((schema) => !schema.supports_oversell_protection || schema.confirmation_callback_url, {
  message: "Property required when supports_oversell_protection is true",
  path: ["confirmation_callback_url"]
}).refine((schema) => schema.supports_installments === schema.supports_deferred_payments, {
  message: "supports_installments and supports_deferred_payments must be the same"
});
function offsiteDeployConfigToCLIConfig(config2) {
  return {
    api_version: config2.api_version,
    payment_session_url: config2.start_payment_session_url,
    refund_session_url: config2.start_refund_session_url,
    capture_session_url: config2.start_capture_session_url,
    void_session_url: config2.start_void_session_url,
    confirmation_callback_url: config2.confirmation_callback_url,
    multiple_capture: config2.multiple_capture,
    merchant_label: config2.merchant_label,
    supported_countries: config2.supported_countries,
    supported_payment_methods: config2.supported_payment_methods,
    supported_buyer_contexts: config2.supported_buyer_contexts,
    test_mode_available: config2.test_mode_available,
    buyer_label: config2.default_buyer_label,
    buyer_label_translations: config2.buyer_label_to_locale,
    supports_oversell_protection: config2.supports_oversell_protection,
    supports_3ds: config2.supports_3ds,
    supports_deferred_payments: config2.supports_deferred_payments,
    supports_installments: config2.supports_installments
  };
}
async function offsitePaymentsAppExtensionDeployConfig(config2) {
  return {
    api_version: config2.api_version,
    start_payment_session_url: config2.payment_session_url,
    start_refund_session_url: config2.refund_session_url,
    start_capture_session_url: config2.capture_session_url,
    start_void_session_url: config2.void_session_url,
    confirmation_callback_url: config2.confirmation_callback_url,
    multiple_capture: config2.multiple_capture,
    merchant_label: config2.merchant_label,
    supported_countries: config2.supported_countries,
    supported_payment_methods: config2.supported_payment_methods,
    supported_buyer_contexts: config2.supported_buyer_contexts,
    test_mode_available: config2.test_mode_available,
    default_buyer_label: config2.buyer_label,
    buyer_label_to_locale: config2.buyer_label_translations,
    supports_oversell_protection: config2.supports_oversell_protection,
    supports_3ds: config2.supports_3ds,
    supports_deferred_payments: config2.supports_deferred_payments,
    supports_installments: config2.supports_installments
  };
}

// ../app/dist/cli/models/extensions/specifications/payments_app_extension_schemas/redeemable_payments_app_extension_schema.js
init_cjs_shims();

// ../app/dist/cli/models/extensions/specifications/transform/extension_uuid_to_handle.js
init_cjs_shims();
function extensionUuidToHandle(config2, allExtensions) {
  let uiExtensionHandle = config2.ui_extension_handle;
  if (uiExtensionHandle || !("ui_extension_registration_uuid" in config2))
    return uiExtensionHandle;
  let uiExtensionTitle = allExtensions.find((ext) => ext.uuid === config2.ui_extension_registration_uuid)?.title;
  return uiExtensionTitle ? slugify(uiExtensionTitle) : uiExtensionHandle;
}

// ../app/dist/cli/models/extensions/specifications/payments_app_extension_schemas/redeemable_payments_app_extension_schema.js
var REDEEMABLE_TARGET = "payments.redeemable.render", RedeemablePaymentsAppExtensionSchema = BasePaymentsAppExtensionSchema.merge(BuyerLabelSchema).merge(SupportedBuyerContextsSchema).extend({
  targeting: z.array(z.object({ target: z.literal(REDEEMABLE_TARGET) })).length(1),
  api_version: z.string(),
  balance_url: z.string().url(),
  ui_extension_handle: z.string().optional(),
  checkout_payment_method_fields: z.array(z.object({
    type: z.union([z.literal("string"), z.literal("number"), z.literal("boolean")]),
    required: z.boolean(),
    key: z.string()
  })).optional()
});
function redeemableDeployConfigToCLIConfig(config2, allExtensions) {
  let uiExtensionHandle = extensionUuidToHandle(config2, allExtensions);
  return {
    api_version: config2.api_version,
    payment_session_url: config2.start_payment_session_url,
    refund_session_url: config2.start_refund_session_url,
    capture_session_url: config2.start_capture_session_url,
    void_session_url: config2.start_void_session_url,
    merchant_label: config2.merchant_label,
    supported_countries: config2.supported_countries,
    supported_payment_methods: config2.supported_payment_methods,
    supported_buyer_contexts: config2.supported_buyer_contexts,
    test_mode_available: config2.test_mode_available,
    buyer_label: config2.default_buyer_label,
    buyer_label_translations: config2.buyer_label_to_locale,
    balance_url: config2.balance_url,
    checkout_payment_method_fields: config2.checkout_payment_method_fields?.map((field) => ({
      key: field.key,
      type: field.type,
      required: field.required
    })),
    ui_extension_handle: uiExtensionHandle
  };
}
async function redeemablePaymentsAppExtensionDeployConfig(config2) {
  let redeemableType = config2.supported_payment_methods[0] === "gift-card" ? "gift_card" : null;
  return {
    api_version: config2.api_version,
    start_payment_session_url: config2.payment_session_url,
    start_refund_session_url: config2.refund_session_url,
    start_capture_session_url: config2.capture_session_url,
    start_void_session_url: config2.void_session_url,
    merchant_label: config2.merchant_label,
    supported_countries: config2.supported_countries,
    supported_payment_methods: config2.supported_payment_methods,
    supported_buyer_contexts: config2.supported_buyer_contexts,
    test_mode_available: config2.test_mode_available,
    default_buyer_label: config2.buyer_label,
    buyer_label_to_locale: config2.buyer_label_translations,
    balance_url: config2.balance_url,
    redeemable_type: redeemableType,
    checkout_payment_method_fields: config2.checkout_payment_method_fields,
    ui_extension_handle: config2.ui_extension_handle
  };
}

// ../app/dist/cli/models/extensions/specifications/payments_app_extension_schemas/custom_onsite_payments_app_extension_schema.js
init_cjs_shims();
var CUSTOM_ONSITE_TARGET = "payments.custom-onsite.render", MAX_CHECKOUT_PAYMENT_METHOD_FIELDS = 7, CustomOnsitePaymentsAppExtensionSchema = BasePaymentsAppExtensionSchema.merge(BuyerLabelSchema).merge(DeferredPaymentsSchema).merge(ConfirmationSchema).merge(SupportedBuyerContextsSchema).extend({
  targeting: z.array(z.object({ target: z.literal(CUSTOM_ONSITE_TARGET) })).length(1),
  update_payment_session_url: z.string().url().optional(),
  multiple_capture: z.boolean().optional(),
  supports_oversell_protection: z.boolean().optional(),
  modal_payment_method_fields: z.array(z.object({})).optional(),
  ui_extension_handle: z.string().optional(),
  checkout_payment_method_fields: z.array(z.object({
    type: z.union([z.literal("string"), z.literal("number"), z.literal("boolean")]),
    required: z.boolean(),
    key: z.string()
  })).max(MAX_CHECKOUT_PAYMENT_METHOD_FIELDS, `The extension can't have more than ${MAX_CHECKOUT_PAYMENT_METHOD_FIELDS} checkout_payment_method_fields`).optional()
}).refine((schema) => schema.supports_installments === schema.supports_deferred_payments, {
  message: "supports_installments and supports_deferred_payments must be the same"
});
function customOnsiteDeployConfigToCLIConfig(config2, allExtensions) {
  let uiExtensionHandle = extensionUuidToHandle(config2, allExtensions);
  return {
    api_version: config2.api_version,
    payment_session_url: config2.start_payment_session_url,
    refund_session_url: config2.start_refund_session_url,
    capture_session_url: config2.start_capture_session_url,
    void_session_url: config2.start_void_session_url,
    confirmation_callback_url: config2.confirmation_callback_url,
    update_payment_session_url: config2.update_payment_session_url,
    merchant_label: config2.merchant_label,
    supports_oversell_protection: config2.supports_oversell_protection,
    supports_3ds: config2.supports_3ds,
    supports_installments: config2.supports_installments,
    supports_deferred_payments: config2.supports_deferred_payments,
    supported_countries: config2.supported_countries,
    supported_payment_methods: config2.supported_payment_methods,
    supported_buyer_contexts: config2.supported_buyer_contexts,
    test_mode_available: config2.test_mode_available,
    multiple_capture: config2.multiple_capture,
    buyer_label: config2.default_buyer_label,
    buyer_label_translations: config2.buyer_label_to_locale,
    checkout_payment_method_fields: config2.checkout_payment_method_fields,
    modal_payment_method_fields: config2.modal_payment_method_fields,
    ui_extension_handle: uiExtensionHandle
  };
}
async function customOnsitePaymentsAppExtensionDeployConfig(config2) {
  return {
    api_version: config2.api_version,
    start_payment_session_url: config2.payment_session_url,
    start_refund_session_url: config2.refund_session_url,
    start_capture_session_url: config2.capture_session_url,
    start_void_session_url: config2.void_session_url,
    confirmation_callback_url: config2.confirmation_callback_url,
    update_payment_session_url: config2.update_payment_session_url,
    merchant_label: config2.merchant_label,
    supports_oversell_protection: config2.supports_oversell_protection,
    supports_3ds: config2.supports_3ds,
    supports_installments: config2.supports_installments,
    supports_deferred_payments: config2.supports_deferred_payments,
    supported_countries: config2.supported_countries,
    supported_payment_methods: config2.supported_payment_methods,
    supported_buyer_contexts: config2.supported_buyer_contexts,
    test_mode_available: config2.test_mode_available,
    multiple_capture: config2.multiple_capture,
    default_buyer_label: config2.buyer_label,
    buyer_label_to_locale: config2.buyer_label_translations,
    checkout_payment_method_fields: config2.checkout_payment_method_fields,
    modal_payment_method_fields: config2.modal_payment_method_fields,
    ui_extension_handle: config2.ui_extension_handle
  };
}

// ../app/dist/cli/models/extensions/specifications/payments_app_extension_schemas/custom_credit_card_payments_app_extension_schema.js
init_cjs_shims();
var CUSTOM_CREDIT_CARD_TARGET = "payments.custom-credit-card.render", MAX_CHECKOUT_PAYMENT_METHOD_FIELDS2 = 7, CustomCreditCardPaymentsAppExtensionSchema = BasePaymentsAppExtensionSchema.merge(ConfirmationSchema).merge(SupportedBuyerContextsSchema).required({
  refund_session_url: !0,
  capture_session_url: !0,
  void_session_url: !0
}).extend({
  targeting: z.array(z.object({ target: z.literal(CUSTOM_CREDIT_CARD_TARGET) })).length(1),
  api_version: z.string(),
  multiple_capture: z.boolean(),
  checkout_hosted_fields: z.array(z.string()).optional(),
  ui_extension_handle: z.string().optional(),
  encryption_certificate_fingerprint: z.string().min(1, { message: "Encryption certificate fingerprint can't be blank" }),
  checkout_payment_method_fields: z.array(z.object({
    type: z.union([z.literal("string"), z.literal("number"), z.literal("boolean")]),
    required: z.boolean(),
    key: z.string()
  })).max(MAX_CHECKOUT_PAYMENT_METHOD_FIELDS2, `The extension can't have more than ${MAX_CHECKOUT_PAYMENT_METHOD_FIELDS2} checkout_payment_method_fields`).optional()
});
function customCreditCardDeployConfigToCLIConfig(config2, allExtensions) {
  let uiExtensionHandle = extensionUuidToHandle(config2, allExtensions);
  return {
    api_version: config2.api_version,
    payment_session_url: config2.start_payment_session_url,
    refund_session_url: config2.start_refund_session_url,
    capture_session_url: config2.start_capture_session_url,
    void_session_url: config2.start_void_session_url,
    confirmation_callback_url: config2.confirmation_callback_url,
    merchant_label: config2.merchant_label,
    supports_3ds: config2.supports_3ds,
    supported_countries: config2.supported_countries,
    supported_payment_methods: config2.supported_payment_methods,
    supported_buyer_contexts: config2.supported_buyer_contexts,
    encryption_certificate_fingerprint: config2.encryption_certificate.fingerprint,
    test_mode_available: config2.test_mode_available,
    multiple_capture: config2.multiple_capture,
    checkout_payment_method_fields: config2.checkout_payment_method_fields,
    checkout_hosted_fields: config2.checkout_hosted_fields,
    ui_extension_handle: uiExtensionHandle
  };
}
async function customCreditCardPaymentsAppExtensionDeployConfig(config2) {
  return {
    api_version: config2.api_version,
    start_payment_session_url: config2.payment_session_url,
    start_refund_session_url: config2.refund_session_url,
    start_capture_session_url: config2.capture_session_url,
    start_void_session_url: config2.void_session_url,
    confirmation_callback_url: config2.confirmation_callback_url,
    merchant_label: config2.merchant_label,
    supports_3ds: config2.supports_3ds,
    supported_countries: config2.supported_countries,
    supported_buyer_contexts: config2.supported_buyer_contexts,
    encryption_certificate_fingerprint: config2.encryption_certificate_fingerprint,
    supported_payment_methods: config2.supported_payment_methods,
    test_mode_available: config2.test_mode_available,
    multiple_capture: config2.multiple_capture,
    checkout_payment_method_fields: config2.checkout_payment_method_fields,
    checkout_hosted_fields: config2.checkout_hosted_fields,
    ui_extension_handle: config2.ui_extension_handle
  };
}

// ../app/dist/cli/models/extensions/specifications/payments_app_extension_schemas/credit_card_payments_app_extension_schema.js
init_cjs_shims();
var CREDIT_CARD_TARGET = "payments.credit-card.render", MAX_CHECKOUT_PAYMENT_METHOD_FIELDS3 = 7, CreditCardPaymentsAppExtensionSchema = BasePaymentsAppExtensionSchema.merge(DeferredPaymentsSchema).merge(ConfirmationSchema).merge(MultipleCaptureSchema).merge(SupportedBuyerContextsSchema).required({
  refund_session_url: !0,
  capture_session_url: !0,
  void_session_url: !0
}).extend({
  targeting: z.array(z.object({ target: z.literal(CREDIT_CARD_TARGET) })).length(1),
  verification_session_url: z.string().url().optional(),
  ui_extension_handle: z.string().optional(),
  encryption_certificate_fingerprint: z.string().min(1, { message: "Encryption certificate fingerprint can't be blank" }),
  checkout_payment_method_fields: z.array(z.object({
    type: z.union([z.literal("string"), z.literal("number"), z.literal("boolean")]),
    required: z.boolean(),
    key: z.string()
  })).max(MAX_CHECKOUT_PAYMENT_METHOD_FIELDS3, `The extension can't have more than ${MAX_CHECKOUT_PAYMENT_METHOD_FIELDS3} checkout_payment_method_fields`).optional()
}).refine((schema) => !schema.supports_3ds || schema.confirmation_callback_url, {
  message: "Property required when supports_3ds is true",
  path: ["confirmation_callback_url"]
}).refine((schema) => schema.supports_installments === schema.supports_deferred_payments, {
  message: "supports_installments and supports_deferred_payments must be the same"
});
function creditCardDeployConfigToCLIConfig(config2, allExtensions) {
  let uiExtensionHandle = extensionUuidToHandle(config2, allExtensions);
  return {
    api_version: config2.api_version,
    payment_session_url: config2.start_payment_session_url,
    refund_session_url: config2.start_refund_session_url,
    capture_session_url: config2.start_capture_session_url,
    void_session_url: config2.start_void_session_url,
    confirmation_callback_url: config2.confirmation_callback_url,
    multiple_capture: config2.multiple_capture,
    merchant_label: config2.merchant_label,
    supported_countries: config2.supported_countries,
    supported_payment_methods: config2.supported_payment_methods,
    supported_buyer_contexts: config2.supported_buyer_contexts,
    test_mode_available: config2.test_mode_available,
    supports_3ds: config2.supports_3ds,
    supports_deferred_payments: config2.supports_deferred_payments,
    supports_installments: config2.supports_installments,
    verification_session_url: config2.start_verification_session_url,
    encryption_certificate_fingerprint: config2.encryption_certificate.fingerprint,
    checkout_payment_method_fields: config2.checkout_payment_method_fields,
    ui_extension_handle: uiExtensionHandle
  };
}
async function creditCardPaymentsAppExtensionDeployConfig(config2) {
  return {
    api_version: config2.api_version,
    start_payment_session_url: config2.payment_session_url,
    start_refund_session_url: config2.refund_session_url,
    start_capture_session_url: config2.capture_session_url,
    start_void_session_url: config2.void_session_url,
    confirmation_callback_url: config2.confirmation_callback_url,
    multiple_capture: config2.multiple_capture,
    merchant_label: config2.merchant_label,
    supported_countries: config2.supported_countries,
    supported_payment_methods: config2.supported_payment_methods,
    supported_buyer_contexts: config2.supported_buyer_contexts,
    test_mode_available: config2.test_mode_available,
    supports_3ds: config2.supports_3ds,
    supports_deferred_payments: config2.supports_deferred_payments,
    encryption_certificate_fingerprint: config2.encryption_certificate_fingerprint,
    supports_installments: config2.supports_installments,
    start_verification_session_url: config2.verification_session_url,
    checkout_payment_method_fields: config2.checkout_payment_method_fields,
    ui_extension_handle: config2.ui_extension_handle
  };
}

// ../app/dist/cli/models/extensions/specifications/payments_app_extension.js
var PaymentsAppExtensionSchema = z.union([
  OffsitePaymentsAppExtensionSchema,
  RedeemablePaymentsAppExtensionSchema,
  CustomOnsitePaymentsAppExtensionSchema,
  CustomCreditCardPaymentsAppExtensionSchema,
  CreditCardPaymentsAppExtensionSchema
]), paymentExtensionSpec = createExtensionSpecification({
  identifier: "payments_extension",
  schema: PaymentsAppExtensionSchema,
  appModuleFeatures: (_2) => [],
  deployConfig: async (config2, _2) => {
    switch (config2.targeting[0].target) {
      case OFFSITE_TARGET:
        return offsitePaymentsAppExtensionDeployConfig(config2);
      case REDEEMABLE_TARGET:
        return redeemablePaymentsAppExtensionDeployConfig(config2);
      case CREDIT_CARD_TARGET:
        return creditCardPaymentsAppExtensionDeployConfig(config2);
      case CUSTOM_ONSITE_TARGET:
        return customOnsitePaymentsAppExtensionDeployConfig(config2);
      case CUSTOM_CREDIT_CARD_TARGET:
        return customCreditCardPaymentsAppExtensionDeployConfig(config2);
      default:
        return {};
    }
  }
}), payments_app_extension_default = paymentExtensionSpec;

// ../app/dist/cli/models/extensions/specifications/pos_ui_extension.js
init_cjs_shims();
var dependency3 = "@shopify/retail-ui-extensions", posUISpec = createExtensionSpecification({
  identifier: "pos_ui_extension",
  dependency: dependency3,
  schema: BaseSchema,
  appModuleFeatures: (_2) => ["ui_preview", "bundling", "esbuild", "single_js_entry_path"],
  deployConfig: async (config2, directory) => {
    let result = await getDependencyVersion(dependency3, directory);
    if (result === "not_found")
      throw new BugError(`Dependency ${dependency3} not found`);
    return {
      name: config2.name,
      description: config2.description,
      renderer_version: result?.version
    };
  }
}), pos_ui_extension_default = posUISpec;

// ../app/dist/cli/models/extensions/specifications/product_subscription.js
init_cjs_shims();
var dependency4 = "@shopify/admin-ui-extensions", productSubscriptionSpec = createExtensionSpecification({
  identifier: "product_subscription",
  additionalIdentifiers: ["subscription_management"],
  dependency: dependency4,
  graphQLType: "subscription_management",
  schema: BaseSchema,
  appModuleFeatures: (_2) => ["ui_preview", "bundling", "esbuild", "single_js_entry_path"],
  deployConfig: async (_2, directory) => {
    let result = await getDependencyVersion(dependency4, directory);
    if (result === "not_found")
      throw new BugError(`Dependency ${dependency4} not found`);
    return { renderer_version: result?.version };
  }
}), product_subscription_default = productSubscriptionSpec;

// ../app/dist/cli/models/extensions/specifications/tax_calculation.js
init_cjs_shims();
var TaxCalculationsSchema = BaseSchema.extend({
  production_api_base_url: z.string(),
  benchmark_api_base_url: z.string().optional(),
  calculate_taxes_api_endpoint: z.string(),
  input: z.object({
    metafield_identifiers: z.object({
      namespace: z.string(),
      key: z.string()
    }).optional()
  }).optional()
}), spec = createExtensionSpecification({
  identifier: "tax_calculation",
  schema: TaxCalculationsSchema,
  appModuleFeatures: (_2) => ["bundling"],
  deployConfig: async (config2, _2) => ({
    production_api_base_url: config2.production_api_base_url,
    benchmark_api_base_url: config2.benchmark_api_base_url,
    calculate_taxes_api_endpoint: config2.calculate_taxes_api_endpoint,
    metafields: config2.metafields,
    api_version: config2.api_version,
    metafield_identifiers: config2.input?.metafield_identifiers
  })
}), tax_calculation_default = spec;

// ../app/dist/cli/models/extensions/specifications/marketing_activity_extension.js
init_cjs_shims();

// ../app/dist/cli/models/extensions/specifications/marketing_activity_extension_schemas/marketing_activity_extension_schema.js
init_cjs_shims();
var BaseFieldSchema = z.object({
  id: z.string(),
  ui_type: z.string()
}), CommonFieldSchema = BaseFieldSchema.extend({
  name: z.string(),
  label: z.string(),
  help_text: z.string().optional(),
  required: z.boolean()
}), BudgetScheduleFieldSchema = CommonFieldSchema.extend({
  ui_type: z.literal("budget-schedule"),
  use_scheduling: z.boolean(),
  use_end_date: z.boolean(),
  use_daily_budget: z.boolean(),
  use_lifetime_budget: z.boolean()
}), DiscountPickerFieldSchema = CommonFieldSchema.extend({
  ui_type: z.literal("discount-picker"),
  min_resources: z.number().nullable(),
  max_resources: z.number().nullable()
}), ScheduleFieldSchema = CommonFieldSchema.extend({
  ui_type: z.literal("schedule"),
  use_end_date: z.boolean()
}), ProductPickerFieldSchema = CommonFieldSchema.extend({
  ui_type: z.literal("product-picker"),
  allow_product_image_selection: z.boolean(),
  allow_uploaded_image_as_product_image: z.boolean(),
  allow_free_image_as_product_image: z.boolean(),
  min_resources: z.number().optional(),
  max_resources: z.number().optional(),
  min_image_select_per_product: z.number().optional(),
  max_image_select_per_product: z.number().optional()
}), SingleLineTextFieldSchema = CommonFieldSchema.extend({
  ui_type: z.enum(["text-single-line", "text-email", "text-tel", "text-url"]),
  placeholder: z.string().optional(),
  min_length: z.number(),
  max_length: z.number()
}), TextMultiLineFieldSchema = CommonFieldSchema.extend({
  ui_type: z.literal("text-multi-line"),
  placeholder: z.string(),
  min_length: z.number(),
  max_length: z.number()
}), DividerFieldSchema = BaseFieldSchema.extend({
  ui_type: z.literal("divider"),
  title: z.string(),
  name: z.string()
}), SelectFieldSchema = CommonFieldSchema.extend({
  ui_type: z.enum(["select-single", "select-multiple"]),
  choices: z.array(z.object({
    label: z.string(),
    value: z.string()
  }))
}), ParagraphFieldSchema = BaseFieldSchema.extend({
  ui_type: z.literal("paragraph"),
  heading: z.string().optional(),
  body: z.string().optional()
}), TypeAheadFieldSchema = CommonFieldSchema.extend({
  ui_type: z.literal("type-ahead"),
  placeholder: z.string()
}), NumberFieldSchema = CommonFieldSchema.extend({
  ui_type: z.enum(["number-float", "number-integer"]),
  min: z.number(),
  max: z.number(),
  step: z.number()
}), ImagePickerFieldSchema = CommonFieldSchema.extend({
  ui_type: z.literal("image-picker"),
  min_resources: z.number(),
  max_resources: z.number(),
  allow_free_images: z.boolean(),
  alt_text_required: z.boolean()
}), UISchemaMapping = {
  "budget-schedule": BudgetScheduleFieldSchema,
  "discount-picker": DiscountPickerFieldSchema,
  schedule: ScheduleFieldSchema,
  "product-picker": ProductPickerFieldSchema,
  "text-single-line": SingleLineTextFieldSchema,
  "text-email": SingleLineTextFieldSchema,
  "text-tel": SingleLineTextFieldSchema,
  "text-url": SingleLineTextFieldSchema,
  "text-multi-line": TextMultiLineFieldSchema,
  "select-single": SelectFieldSchema,
  "select-multiple": SelectFieldSchema,
  paragraph: ParagraphFieldSchema,
  "type-ahead": TypeAheadFieldSchema,
  "number-float": NumberFieldSchema,
  "number-integer": NumberFieldSchema,
  "image-picker": ImagePickerFieldSchema,
  divider: DividerFieldSchema
}, MarketingActivityExtensionSchema = BaseSchema.extend({
  title: z.string().min(1),
  description: z.string().min(1),
  app_api_url: z.string(),
  tactic: z.enum([
    "ad",
    "retargeting",
    "post",
    "message",
    "transactional",
    "newsletter",
    "abandoned_cart",
    "affililate",
    "loyalty",
    "link",
    "storefront_app"
  ]),
  marketing_channel: z.enum(["social", "search", "email", "sms", "display", "marketplace"]),
  referring_domain: z.string().optional(),
  is_automation: z.boolean().optional(),
  use_external_editor: z.boolean().optional(),
  preview_data: z.object({
    types: z.array(z.object({
      label: z.string(),
      value: z.string()
    })).max(3).min(1)
  }),
  fields: z.array(z.any().superRefine((val, ctx) => {
    if (typeof val != "object")
      return ctx.addIssue({
        message: "Field must be an object",
        code: z.ZodIssueCode.custom
      });
    if (val.ui_type === void 0)
      return ctx.addIssue({
        message: "Field must have a ui_type",
        code: z.ZodIssueCode.custom
      });
    let schema = UISchemaMapping[val.ui_type];
    if (schema === void 0)
      return ctx.addIssue({
        message: `Unknown ui_type for Field: ${val.ui_type}`,
        code: z.ZodIssueCode.custom
      });
    let result = schema.safeParse(val);
    if (!result.success)
      return ctx.addIssue({
        message: `Error found on Field "${val.name}": ${result.error.message}`,
        code: z.ZodIssueCode.custom
      });
  })).min(1)
});

// ../app/dist/cli/models/extensions/specifications/marketing_activity_extension.js
var spec2 = createExtensionSpecification({
  identifier: "marketing_activity_extension_cli",
  schema: MarketingActivityExtensionSchema,
  appModuleFeatures: (_2) => ["bundling"],
  deployConfig: async (config2, _2) => ({
    title: config2.title,
    description: config2.description,
    app_api_url: config2.app_api_url,
    tactic: config2.tactic,
    marketing_channel: config2.marketing_channel,
    referring_domain: config2.referring_domain,
    is_automation: config2.is_automation,
    use_external_editor: config2.use_external_editor,
    preview_data: config2.preview_data,
    fields: config2.fields
  })
}), marketing_activity_extension_default = spec2;

// ../app/dist/cli/models/extensions/specifications/theme.js
init_cjs_shims();
var themeSpec = createExtensionSpecification({
  identifier: "theme",
  schema: BaseSchema,
  partnersWebIdentifier: "theme_app_extension",
  graphQLType: "theme_app_extension",
  appModuleFeatures: (_2) => useThemebundling() ? ["bundling", "theme"] : ["theme"],
  deployConfig: async () => {
    if (useThemebundling())
      return { theme_extension: { files: {} } };
  },
  preDeployValidation: async (extension) => validateThemeExtension(extension)
}), theme_default = themeSpec, kilobytes = 1024, megabytes = kilobytes * 1024, BUNDLE_SIZE_LIMIT_MB = 10, BUNDLE_SIZE_LIMIT = BUNDLE_SIZE_LIMIT_MB * megabytes, LIQUID_SIZE_LIMIT_KB = 500, LIQUID_SIZE_LIMIT = LIQUID_SIZE_LIMIT_KB * kilobytes, SUPPORTED_ASSET_EXTS = [".jpg", ".jpeg", ".json", ".js", ".css", ".png", ".svg", ".wasm"], SUPPORTED_LOCALE_EXTS = [".json"], SUPPORTED_EXTS = {
  assets: {
    validator: new RegExp(`${SUPPORTED_ASSET_EXTS.join("|")}$`),
    failureMessage: (_filename) => `Only these filetypes are supported in assets: ${SUPPORTED_ASSET_EXTS.join(", ")}`
  },
  blocks: {
    validator: /.liquid$/,
    failureMessage: (_filename) => "Only .liquid files are allowed in blocks."
  },
  locales: {
    validator: new RegExp(`${SUPPORTED_LOCALE_EXTS.join("|")}$`),
    failureMessage: (_filename) => `Only these filetypes are supported in locales: ${SUPPORTED_LOCALE_EXTS.join(", ")}`
  },
  snippets: {
    validator: /.liquid$/,
    failureMessage: (_filename) => "Only .liquid files are allowed in snippets."
  }
}, SUPPORTED_BUCKETS = Object.keys(SUPPORTED_EXTS);
async function validateThemeExtension(extension) {
  let themeFiles = await themeExtensionFiles(extension), liquidBytes = [], extensionBytes = [];
  await Promise.all(themeFiles.map(async (filepath) => {
    let relativePathName = relativePath(extension.directory, filepath), directoryName = dirname(relativePathName);
    validateFile(relativePathName, directoryName);
    let filesize = await fileSize(filepath);
    extensionBytes.push(filesize), ["blocks", "snippets"].includes(directoryName) && liquidBytes.push(filesize);
  })), validateExtensionBytes(arraySum(extensionBytes)), validateLiquidBytes(arraySum(liquidBytes));
}
function validateExtensionBytes(extensionBytesTotal) {
  if (extensionBytesTotal > BUNDLE_SIZE_LIMIT) {
    let humanBundleSize = `${(extensionBytesTotal / megabytes).toFixed(2)} MB`;
    throw new AbortError(`Your theme app extension exceeds the file size limit (${BUNDLE_SIZE_LIMIT_MB} MB). It's currently ${humanBundleSize}.`, "Reduce your total file size and try again.");
  }
}
function validateLiquidBytes(liquidBytesTotal) {
  if (liquidBytesTotal > LIQUID_SIZE_LIMIT) {
    let humanLiquidSize = `${(liquidBytesTotal / kilobytes).toFixed(2)} kB`;
    throw new AbortError(`Your theme app extension exceeds the total liquid file size limit (${LIQUID_SIZE_LIMIT_KB} kB). It's currently ${humanLiquidSize}.`, "Reduce your total file size and try again.");
  }
}
function validateFile(filepath, dirname5) {
  if (!SUPPORTED_BUCKETS.includes(dirname5))
    throw new AbortError(outputContent`Your theme app extension includes files in an unsupported directory, ${outputToken.path(dirname5)}`, `Make sure all theme app extension files are in the supported directories: ${SUPPORTED_BUCKETS.join(", ")}`);
  let filenameValidation = SUPPORTED_EXTS[dirname5];
  if (!filepath.match(filenameValidation.validator))
    throw new AbortError(`Invalid filename in your theme app extension: ${filepath}
${filenameValidation.failureMessage(filepath)}`);
}
function arraySum(array) {
  return array.reduce((num1, num2) => num1 + num2, 0);
}

// ../app/dist/cli/models/extensions/specifications/ui_extension.js
init_cjs_shims();

// ../app/dist/cli/services/dev/extension/utilities.js
init_cjs_shims();

// ../app/dist/cli/utilities/extensions/fetch-product-variant.js
init_cjs_shims();

// ../app/dist/cli/api/graphql/get_variant_id.js
init_cjs_shims();
var FindProductVariantQuery = gql`
  query {
    products(first: 1, query: "published_status:published") {
      edges {
        node {
          id
          variants(first: 1) {
            edges {
              node {
                id
              }
            }
          }
        }
      }
    }
  }
`;

// ../app/dist/cli/utilities/extensions/fetch-product-variant.js
async function fetchProductVariant(store) {
  let adminSession = await ensureAuthenticatedAdmin(store), result = await adminRequest2(FindProductVariantQuery, adminSession);
  if (result.products.edges.length === 0)
    throw new AbortError("Could not find a product variant", `Your store needs to have at least one product to test a 'checkout_ui' extension

You can add a new product here: https://${store}/admin/products/new`);
  return result.products.edges[0].node.variants.edges[0].node.id.split("/").pop();
}

// ../app/dist/cli/services/dev/extension/utilities.js
var CUSTOMER_ACCOUNT_CHECKOUT_RENDERED_TARGETS = /* @__PURE__ */ new Set([
  "customer-account.order-status.cart-line-item.render-after",
  "customer-account.order-status.cart-line-list.render-after",
  "customer-account.order-status.customer-information.render-after",
  "customer-account.order-status.block.render"
]);
async function buildCartURLIfNeeded(extensions, store, checkoutCartUrl) {
  return extensions.filter((extension) => extension.shouldFetchCartUrl()).length > 0 ? checkoutCartUrl || `/cart/${await fetchProductVariant(store)}:1` : void 0;
}
function getExtensionPointTargetSurface(extensionPointTarget) {
  let domain = extensionPointTarget.toLowerCase().replace(/(::|\.).+$/, ""), page = extensionPointTarget.split(".")[1];
  switch (domain) {
    case "purchase":
      return page === "post" ? "post_purchase" : "checkout";
    case "customeraccount":
    case "customer-account":
      return CUSTOMER_ACCOUNT_CHECKOUT_RENDERED_TARGETS.has(extensionPointTarget) ? "checkout" : "customer-accounts";
    case "pos":
      return "point_of_sale";
    default:
      return domain;
  }
}

// ../app/dist/cli/models/extensions/specifications/ui_extension.js
var dependency5 = "@shopify/checkout-ui-extensions", validatePoints = (config2) => config2.extension_points !== void 0 || config2.targeting !== void 0, missingExtensionPointsMessage = "No extension targets defined, add a `targeting` field to your configuration", UIExtensionSchema = BaseSchema.extend({
  extension_points: NewExtensionPointsSchema.optional(),
  targeting: NewExtensionPointsSchema.optional()
}).refine((config2) => validatePoints(config2), missingExtensionPointsMessage).transform((config2) => {
  let extensionPoints = (config2.targeting ?? config2.extension_points ?? []).map((targeting) => ({
    target: targeting.target,
    module: targeting.module,
    metafields: targeting.metafields ?? config2.metafields ?? [],
    default_placement_reference: targeting.default_placement
  }));
  return { ...config2, extension_points: extensionPoints };
}), uiExtensionSpec = createExtensionSpecification({
  identifier: "ui_extension",
  dependency: dependency5,
  schema: UIExtensionSchema,
  appModuleFeatures: (config2) => {
    let basic = ["ui_preview", "bundling", "esbuild"];
    return config2?.extension_points?.find((extensionPoint) => getExtensionPointTargetSurface(extensionPoint.target) === "checkout") !== void 0 ? [...basic, "cart_url"] : basic;
  },
  validate: async (config2, path3, directory) => validateUIExtensionPointConfig(directory, config2.extension_points, path3),
  deployConfig: async (config2, directory) => ({
    api_version: config2.api_version,
    extension_points: config2.extension_points,
    capabilities: config2.capabilities,
    name: config2.name,
    description: config2.description,
    settings: config2.settings,
    localization: await loadLocalesConfig(directory, config2.type)
  }),
  getBundleExtensionStdinContent: (config2) => config2.extension_points.map(({ module }) => `import '${module}';`).join(`
`),
  hasExtensionPointTarget: (config2, requestedTarget) => config2.extension_points.find((extensionPoint) => extensionPoint.target === requestedTarget) !== void 0
});
async function validateUIExtensionPointConfig(directory, extensionPoints, configPath) {
  let errors2 = [], uniqueTargets = [], duplicateTargets = [];
  if (!extensionPoints || extensionPoints.length === 0)
    return err(missingExtensionPointsMessage);
  for await (let { module, target } of extensionPoints) {
    let fullPath = joinPath(directory, module);
    if (!await fileExists(fullPath)) {
      let notFoundPath = outputToken.path(joinPath(directory, module));
      errors2.push(outputContent`Couldn't find ${notFoundPath}
Please check the module path for ${target}`.value);
    }
    uniqueTargets.indexOf(target) === -1 ? uniqueTargets.push(target) : duplicateTargets.push(target);
  }
  return duplicateTargets.length && errors2.push(`Duplicate targets found: ${duplicateTargets.join(", ")}
Extension point targets must be unique`), errors2.length ? (errors2.push(`Please check the configuration in ${configPath}`), err(errors2.join(`

`))) : ok({});
}
var ui_extension_default = uiExtensionSpec;

// ../app/dist/cli/models/extensions/specifications/web_pixel_extension.js
init_cjs_shims();
var kilobytes2 = 1024, BUNDLE_SIZE_LIMIT_KB = 128, BUNDLE_SIZE_LIMIT2 = BUNDLE_SIZE_LIMIT_KB * kilobytes2, dependency6 = "@shopify/web-pixels-extension", WebPixelSchema = BaseSchema.extend({
  runtime_context: z.string(),
  version: z.string().optional(),
  configuration: z.any(),
  customer_privacy: z.object({
    analytics: z.boolean(),
    preferences: z.boolean(),
    marketing: z.boolean(),
    sale_of_data: z.enum(["enabled", "disabled", "ldu"])
  }).optional(),
  settings: z.any()
}), webPixelSpec = createExtensionSpecification({
  identifier: "web_pixel_extension",
  dependency: dependency6,
  partnersWebIdentifier: "web_pixel",
  schema: WebPixelSchema,
  appModuleFeatures: (_2) => ["bundling", "esbuild", "single_js_entry_path"],
  deployConfig: async (config2, _2) => ({
    runtime_context: config2.runtime_context,
    customer_privacy: config2.customer_privacy,
    runtime_configuration_definition: config2.settings
  }),
  buildValidation: async (extension) => {
    let bundleSize2 = await fileSize(extension.outputPath);
    if (bundleSize2 > BUNDLE_SIZE_LIMIT2) {
      let humanReadableBundleSize = `${(bundleSize2 / kilobytes2).toFixed(2)} kB`;
      throw new AbortError(`Your web pixel extension exceeds the total file size limit (${BUNDLE_SIZE_LIMIT_KB} kB). It's currently ${humanReadableBundleSize}.`, "Reduce your total file size and try again.");
    }
  },
  preDeployValidation: async (extension) => {
    if (extension.configuration.configuration)
      throw new AbortError("The property configuration is deprecated and no longer supported.", "It has been replaced by settings.");
    return Promise.resolve();
  }
}), web_pixel_extension_default = webPixelSpec;

// ../app/dist/cli/models/extensions/specifications/editor_extension_collection.js
init_cjs_shims();
var IncludeSchema = z.object({
  handle: z.string()
}), EditorExtensionCollectionSchema = BaseSchema.extend({
  include: z.array(IncludeSchema).optional(),
  includes: z.array(z.string()).optional(),
  type: z.literal("editor_extension_collection")
}).transform((data) => {
  let includes = data.includes?.map((handle) => ({ handle })) ?? [], include = data.include ?? [];
  return {
    ...data,
    inCollection: [...includes, ...include]
  };
}), editorExtensionCollectionSpecification = createExtensionSpecification({
  identifier: "editor_extension_collection",
  schema: EditorExtensionCollectionSchema,
  appModuleFeatures: (_2) => [],
  validate: async (config2, path3) => {
    let errors2 = [];
    return config2.inCollection.length < 2 && errors2.push(`${config2.handle}: This editor extension collection must include at least 2 extensions`), errors2.length > 0 ? (errors2.push(`Please check the configuration in ${path3}`), err(errors2.join(`

`))) : ok({});
  },
  deployConfig: async (config2, directory) => ({
    name: config2.name,
    handle: config2.handle,
    in_collection: config2.inCollection,
    localization: await loadLocalesConfig(directory, config2.name)
  })
}), editor_extension_collection_default = editorExtensionCollectionSpecification;

// ../app/dist/cli/models/extensions/specifications/custom_data.js
init_cjs_shims();
var CustomDataSpecIdentifier = "data", customDataSpec = createContractBasedConfigModuleSpecification(CustomDataSpecIdentifier, "product", "metaobjects"), custom_data_default = customDataSpec;

// ../app/dist/cli/models/extensions/load-specifications.js
var SORTED_CONFIGURATION_SPEC_IDENTIFIERS = [
  BrandingSpecIdentifier,
  AppAccessSpecIdentifier,
  WebhooksSpecIdentifier,
  WebhookSubscriptionSpecIdentifier,
  PrivacyComplianceWebhooksSpecIdentifier,
  AppProxySpecIdentifier,
  PosSpecIdentifier,
  AppHomeSpecIdentifier,
  CustomDataSpecIdentifier
];
async function loadLocalExtensionsSpecifications() {
  let sortConfigModules = (specA, specB) => SORTED_CONFIGURATION_SPEC_IDENTIFIERS.indexOf(specA.identifier) - SORTED_CONFIGURATION_SPEC_IDENTIFIERS.indexOf(specB.identifier);
  return loadSpecifications().sort(sortConfigModules);
}
function loadSpecifications() {
  let configModuleSpecs = [
    app_config_app_access_default,
    app_config_app_home_default,
    app_config_app_proxy_default,
    app_config_branding_default,
    app_config_point_of_sale_default,
    app_config_privacy_compliance_webhooks_default,
    app_config_webhook_default,
    app_config_webhook_subscription_default,
    custom_data_default
  ], moduleSpecs = [
    checkout_post_purchase_default,
    checkout_ui_extension_default,
    flow_action_default,
    flow_template_default,
    flow_trigger_default,
    function_default,
    payments_app_extension_default,
    pos_ui_extension_default,
    product_subscription_default,
    tax_calculation_default,
    marketing_activity_extension_default,
    theme_default,
    ui_extension_default,
    web_pixel_extension_default,
    editor_extension_collection_default
  ];
  return [...configModuleSpecs, ...moduleSpecs];
}

// ../app/dist/cli/utilities/json-schema.js
init_cjs_shims();

// ../cli-kit/dist/public/node/json-schema.js
init_cjs_shims();
var import_ajv = __toESM(require_ajv()), import_json_schema_ref_parser = __toESM(require_lib7());
async function normaliseJsonSchema(schema) {
  let parsedSchema = JSON.parse(schema);
  return await import_json_schema_ref_parser.default.dereference(parsedSchema, { resolve: { external: !1 } }), parsedSchema;
}
function jsonSchemaValidate(subject, schema) {
  let validator = new import_ajv.Ajv({ allowUnionTypes: !0 }).compile(schema);
  validator(subject);
  let jsonSchemaErrors;
  return validator.errors && validator.errors.length > 0 ? (jsonSchemaErrors = convertJsonSchemaErrors(validator.errors, subject, schema), {
    state: "error",
    data: void 0,
    errors: jsonSchemaErrors,
    rawErrors: validator.errors
  }) : {
    state: "ok",
    data: subject,
    errors: void 0,
    rawErrors: void 0
  };
}
function convertJsonSchemaErrors(rawErrors, subject, schema) {
  return simplifyUnionErrors(rawErrors, subject, schema).map((error) => {
    let path3 = error.instancePath.split("/").slice(1);
    if (error.params.missingProperty) {
      let missingProperty = error.params.missingProperty;
      return { path: [...path3, missingProperty], message: "Required" };
    }
    if (error.params.type) {
      let expectedType = error.params.type, actualType = getPathValue(subject, path3.join("."));
      return { path: path3, message: `Expected ${expectedType}, received ${typeof actualType}` };
    }
    if (error.keyword === "anyOf" || error.keyword === "oneOf")
      return { path: path3, message: "Invalid input" };
    if (error.params.allowedValues) {
      let allowedValues = error.params.allowedValues, actualValue = getPathValue(subject, path3.join("."));
      return {
        path: path3,
        message: `Invalid enum value. Expected ${allowedValues.map((value) => JSON.stringify(value)).join(" | ")}, received ${JSON.stringify(actualValue)}`.replace(/"/g, "'")
      };
    }
    if (error.params.comparison) {
      let comparison = error.params.comparison, limit = error.params.limit, actualValue = getPathValue(subject, path3.join(".")), comparisonText = comparison;
      switch (comparison) {
        case "<=":
          comparisonText = "less than or equal to";
          break;
        case "<":
          comparisonText = "less than";
          break;
        case ">=":
          comparisonText = "greater than or equal to";
          break;
        case ">":
          comparisonText = "greater than";
          break;
      }
      return {
        path: path3,
        message: capitalize(`${typeof actualValue} must be ${comparisonText} ${limit}`)
      };
    }
    return {
      path: path3,
      message: error.message
    };
  });
}
function simplifyUnionErrors(rawErrors, subject, schema) {
  let ajv = new import_ajv.Ajv(), errors2 = rawErrors, resolvedUnionErrors = /* @__PURE__ */ new Set();
  for (; ; ) {
    let unionError = errors2.filter((error) => (error.keyword === "oneOf" || error.keyword === "anyOf") && !resolvedUnionErrors.has(error.instancePath))[0];
    if (unionError === void 0)
      break;
    let unrelatedErrors = errors2.filter((error) => !error.instancePath.startsWith(unionError.instancePath)), simplifiedUnionRelatedErrors = [unionError], dottedSchemaPath = unionError.schemaPath.replace("#/", "").replace(/\//g, "."), unionSchemas = getPathValue(schema, dottedSchemaPath), subjectValue = getPathValue(subject, unionError.instancePath.split("/").slice(1).join("."));
    if (unionSchemas !== void 0 && subjectValue !== void 0) {
      let correctValuesAndErrors = unionSchemas.map((candidateSchemaFromUnion) => {
        let candidateSchemaValidator = ajv.compile(candidateSchemaFromUnion);
        candidateSchemaValidator(subjectValue);
        let score = 0;
        return candidateSchemaFromUnion.type === "object" && (score = Object.keys(candidateSchemaFromUnion.properties).reduce((acc, propertyName) => {
          let subSchema = candidateSchemaFromUnion.properties[propertyName], subjectValueSlice = getPathValue(subjectValue, propertyName);
          return ajv.compile(subSchema)(subjectValueSlice) ? acc + 1 : acc;
        }, score)), [score, candidateSchemaValidator.errors];
      }).sort(([scoreA], [scoreB]) => scoreA - scoreB);
      if (correctValuesAndErrors.length >= 2) {
        let [bestScore, bestErrors] = correctValuesAndErrors[correctValuesAndErrors.length - 1], [penultimateScore] = correctValuesAndErrors[correctValuesAndErrors.length - 2];
        bestScore !== penultimateScore && (simplifiedUnionRelatedErrors = [
          unionError,
          ...bestErrors.map((bestError) => ({
            ...bestError,
            instancePath: unionError.instancePath + bestError.instancePath
          }))
        ]);
      }
    }
    errors2 = [...unrelatedErrors, ...simplifiedUnionRelatedErrors], resolvedUnionErrors.add(unionError.instancePath);
  }
  return errors2;
}

// ../app/dist/cli/utilities/json-schema.js
async function unifiedConfigurationParserFactory(merged) {
  let contractJsonSchema = merged.validationSchema?.jsonSchema;
  if (contractJsonSchema === void 0 || isEmpty(JSON.parse(contractJsonSchema)))
    return merged.parseConfigurationObject;
  let contract = await normaliseJsonSchema(contractJsonSchema);
  return (config2) => {
    let zodParse = merged.parseConfigurationObject(config2), zodValidatedData = zodParse.state === "ok" ? zodParse.data : void 0, jsonSchemaParse = jsonSchemaValidate(zodValidatedData ?? config2, contract), errors2 = zodParse.errors || [];
    jsonSchemaParse.state === "error" && (errors2 = errors2.concat(jsonSchemaParse.errors));
    let errorSet = /* @__PURE__ */ new Set();
    return errors2 = errors2.filter((error) => {
      let key = JSON.stringify({ path: error.path, message: error.message });
      return errorSet.has(key) ? !1 : (errorSet.add(key), !0);
    }), zodParse.state !== "ok" || errors2.length > 0 ? {
      state: "error",
      data: void 0,
      errors: errors2
    } : {
      state: "ok",
      data: zodValidatedData,
      errors: void 0
    };
  };
}

// ../app/dist/cli/services/generate/fetch-extension-specifications.js
async function fetchSpecifications({ developerPlatformClient, app }) {
  let extensionSpecifications = (await developerPlatformClient.specifications(app)).filter((specification) => ["extension", "configuration"].includes(specification.experience)).map((spec3) => {
    let newSpec = spec3;
    return spec3.identifier === "theme_app_extension" && (spec3.identifier = "theme"), spec3.identifier === "subscription_management" && (spec3.identifier = "product_subscription"), newSpec.registrationLimit = spec3.options.registrationLimit, newSpec.surface = spec3.features?.argo?.surface, spec3.identifier === "checkout_post_purchase" && (newSpec.surface = "post_purchase"), newSpec;
  }), local = await loadLocalExtensionsSpecifications();
  return [...await mergeLocalAndRemoteSpecs(local, extensionSpecifications)];
}
async function mergeLocalAndRemoteSpecs(local, remote) {
  let updated = local.map(async (spec3) => {
    let remoteSpec = remote.find((remote2) => remote2.identifier === spec3.identifier);
    if (remoteSpec) {
      let merged = { ...spec3, ...remoteSpec, loadedRemoteSpecs: !0 }, parseConfigurationObject2 = await unifiedConfigurationParserFactory(merged);
      return {
        ...merged,
        parseConfigurationObject: parseConfigurationObject2
      };
    }
  }), result = getArrayRejectingUndefined(await Promise.all(updated)), presentLocalMissingRemote = local.filter((spec3) => !result.find((result2) => result2.identifier === spec3.identifier));
  presentLocalMissingRemote.length > 0 && outputDebug(`The following extension specifications were defined locally but not found in the remote specifications: ${presentLocalMissingRemote.map((spec3) => spec3.identifier).sort().join(", ")}`);
  let presentRemoteMissingLocal = remote.filter((spec3) => !result.find((result2) => result2.identifier === spec3.identifier));
  return presentRemoteMissingLocal.length > 0 && outputDebug(`The following extension specifications were found in the remote specifications but not defined locally: ${presentRemoteMissingLocal.map((spec3) => spec3.identifier).sort().join(", ")}`), result;
}

// ../app/dist/cli/services/app/config/link.js
async function link(options, shouldRenderSuccess = !0) {
  let { remoteApp, appDirectory, developerPlatformClient } = await selectOrCreateRemoteAppToLinkTo(options), specifications = await fetchSpecifications({
    developerPlatformClient,
    app: remoteApp
  }), flags = remoteApp.flags, localAppOptions = await loadLocalAppOptions(options, specifications, flags, remoteApp.apiKey), configFileName = await loadConfigurationFileName(remoteApp, options, {
    appDirectory: localAppOptions.appDirectory,
    format: localAppOptions.configFormat
  });
  await logMetadataForLoadedContext(remoteApp);
  let mergedAppConfiguration = await overwriteLocalConfigFileWithRemoteAppConfiguration({
    configFileName,
    remoteApp,
    developerPlatformClient,
    specifications,
    flags,
    appDirectory,
    localAppOptions
  });
  return shouldRenderSuccess && renderSuccessMessage(configFileName, mergedAppConfiguration.name, localAppOptions.packageManager), mergedAppConfiguration;
}
async function selectOrCreateRemoteAppToLinkTo(options) {
  let developerPlatformClient = await sniffServiceOptionsAndAppConfigToSelectPlatformClient(options), { creationOptions, appDirectory: possibleAppDirectory } = await getAppCreationDefaultsFromLocalApp(options), appDirectory = possibleAppDirectory || options.directory;
  if (options.apiKey) {
    let remoteApp2 = await appFromId({ apiKey: options.apiKey, developerPlatformClient });
    if (!remoteApp2) {
      let errorMessage2 = InvalidApiKeyErrorMessage(options.apiKey);
      throw new AbortError(errorMessage2.message, errorMessage2.tryMessage);
    }
    return {
      remoteApp: remoteApp2,
      appDirectory,
      developerPlatformClient
    };
  }
  let remoteApp = await fetchOrCreateOrganizationApp(creationOptions, appDirectory);
  return developerPlatformClient = remoteApp.developerPlatformClient ?? developerPlatformClient, {
    remoteApp,
    appDirectory,
    developerPlatformClient
  };
}
async function getAppCreationDefaultsFromLocalApp(options) {
  let appCreationDefaults = {
    isLaunchable: !1,
    scopesArray: [],
    name: ""
  };
  try {
    let app = await loadApp({
      specifications: await loadLocalExtensionsSpecifications(),
      directory: options.directory,
      mode: "report",
      userProvidedConfigName: options.baseConfigName,
      remoteFlags: void 0
    }), configuration = app.configuration;
    return isCurrentAppSchema(configuration) ? { creationOptions: appCreationDefaults } : { creationOptions: app.creationDefaultOptions(), appDirectory: app.directory };
  } catch {
    return { creationOptions: appCreationDefaults };
  }
}
async function loadLocalAppOptions(options, specifications, remoteFlags, remoteAppApiKey) {
  try {
    let app = await loadApp({
      specifications,
      directory: options.directory,
      mode: "report",
      userProvidedConfigName: options.baseConfigName,
      remoteFlags
    }), configuration = app.configuration;
    if (isCurrentAppSchema(configuration)) {
      if (app.configuration.client_id === remoteAppApiKey)
        return {
          state: "reusable-current-app",
          configFormat: "current",
          scopes: getAppScopes(configuration),
          localAppIdMatchedRemote: !0,
          existingBuildOptions: configuration.build,
          existingConfig: configuration,
          appDirectory: app.directory,
          packageManager: app.packageManager
        };
    } else
      return {
        state: "legacy",
        configFormat: "legacy",
        scopes: getAppScopes(configuration),
        localAppIdMatchedRemote: !1,
        existingBuildOptions: void 0,
        existingConfig: configuration,
        appDirectory: app.directory,
        packageManager: app.packageManager
      };
    return {
      state: "unable-to-reuse-current-config",
      configFormat: "current",
      scopes: "",
      localAppIdMatchedRemote: !0,
      appDirectory: void 0,
      existingBuildOptions: void 0,
      existingConfig: void 0,
      packageManager: "npm"
    };
  } catch {
    return {
      state: "unable-to-load-config",
      configFormat: "legacy",
      scopes: "",
      localAppIdMatchedRemote: !1,
      appDirectory: void 0,
      existingBuildOptions: void 0,
      existingConfig: void 0,
      packageManager: "npm"
    };
  }
}
async function loadConfigurationFileName(remoteApp, options, localAppInfo) {
  let cache2 = getCachedCommandInfo();
  if (cache2?.selectedToml)
    return cache2.selectedToml;
  if (options.configName)
    return getAppConfigurationFileName(options.configName);
  if (localAppInfo.format === "legacy")
    return configurationFileNames.app;
  let currentToml = (await getTomls(options.directory))[remoteApp.apiKey];
  return currentToml || selectConfigName(localAppInfo.appDirectory || options.directory, remoteApp.title);
}
async function overwriteLocalConfigFileWithRemoteAppConfiguration(options) {
  let { remoteApp, developerPlatformClient, specifications, flags, configFileName, appDirectory, localAppOptions } = options, configFilePath = joinPath(appDirectory, configFileName), remoteAppConfiguration = await fetchAppRemoteConfiguration(remoteApp, developerPlatformClient, specifications, flags);
  if (!remoteAppConfiguration) {
    let locallyProvidedScopes = localAppOptions.scopes;
    remoteAppConfiguration = buildAppConfigurationFromRemoteAppProperties(remoteApp, locallyProvidedScopes);
  }
  let replaceLocalArrayStrategy = (_destinationArray, sourceArray) => sourceArray, mergedAppConfiguration = {
    ...deepMergeObjects({
      ...localAppOptions.existingConfig ?? {},
      // Scopes changes position from the template config format to the current one. Delete it if its left behind.
      scopes: void 0
    }, {
      app_id: remoteApp.id,
      client_id: remoteApp.apiKey,
      path: configFilePath,
      ...developerPlatformClient.requiresOrganization ? { organization_id: remoteApp.organizationId } : {},
      ...remoteAppConfiguration
    }, replaceLocalArrayStrategy),
    // Always use our prefered build options
    build: buildOptionsForGeneratedConfigFile({
      existingBuildOptions: localAppOptions.existingBuildOptions,
      linkedAppAndClientIdFromFileAreInSync: localAppOptions.localAppIdMatchedRemote,
      linkedAppWasNewlyCreated: !!remoteApp.newApp
    })
  }, schema = getAppVersionedSchema(specifications);
  return await writeAppConfigurationFile(mergedAppConfiguration, schema), setCurrentConfigPreference(mergedAppConfiguration, { configFileName, directory: appDirectory }), mergedAppConfiguration;
}
function buildOptionsForGeneratedConfigFile(options) {
  let { existingBuildOptions, linkedAppAndClientIdFromFileAreInSync, linkedAppWasNewlyCreated } = options, buildOptions = {
    ...linkedAppWasNewlyCreated ? { include_config_on_deploy: !0 } : {},
    ...linkedAppAndClientIdFromFileAreInSync ? existingBuildOptions : {}
  };
  if (!isEmpty(buildOptions))
    return buildOptions;
}
function renderSuccessMessage(configFileName, appName, packageManager2) {
  renderSuccess({
    headline: `${configFileName} is now linked to "${appName}" on Shopify`,
    body: `Using ${configFileName} as your default config.`,
    nextSteps: [
      [`Make updates to ${configFileName} in your local project`],
      [
        "To upload your config, run",
        {
          command: formatPackageManagerCommand(packageManager2, "shopify app deploy")
        }
      ]
    ],
    reference: [
      {
        link: {
          label: "App configuration",
          url: "https://shopify.dev/docs/apps/tools/cli/configuration"
        }
      }
    ]
  });
}
function buildAppConfigurationFromRemoteAppProperties(remoteApp, locallyProvidedScopes) {
  return {
    ...addBrandingConfig(remoteApp),
    ...addPosConfig(remoteApp),
    ...addRemoteAppWebhooksConfig(remoteApp),
    ...addRemoteAppAccessConfig(locallyProvidedScopes, remoteApp),
    ...addRemoteAppProxyConfig(remoteApp),
    ...addRemoteAppHomeConfig(remoteApp)
  };
}
function addRemoteAppHomeConfig(remoteApp) {
  let homeConfig = {
    application_url: remoteApp.applicationUrl?.replace(/\/$/, "") || "",
    embedded: remoteApp.embedded === void 0 ? !0 : remoteApp.embedded
  };
  return remoteApp.preferencesUrl ? {
    ...homeConfig,
    app_preferences: {
      url: remoteApp.preferencesUrl
    }
  } : { ...homeConfig };
}
function addRemoteAppProxyConfig(remoteApp) {
  return remoteApp.appProxy?.url ? {
    app_proxy: {
      url: remoteApp.appProxy.url,
      subpath: remoteApp.appProxy.subPath,
      prefix: remoteApp.appProxy.subPathPrefix
    }
  } : {};
}
function addRemoteAppWebhooksConfig(remoteApp) {
  let hasAnyPrivacyWebhook = remoteApp.gdprWebhooks?.customerDataRequestUrl || remoteApp.gdprWebhooks?.customerDeletionUrl || remoteApp.gdprWebhooks?.shopDeletionUrl, privacyComplianceContent = {
    privacy_compliance: {
      customer_data_request_url: remoteApp.gdprWebhooks?.customerDataRequestUrl,
      customer_deletion_url: remoteApp.gdprWebhooks?.customerDeletionUrl,
      shop_deletion_url: remoteApp.gdprWebhooks?.shopDeletionUrl
    }
  };
  return {
    webhooks: {
      api_version: remoteApp.webhookApiVersion || "2023-07",
      ...hasAnyPrivacyWebhook ? privacyComplianceContent : {}
    }
  };
}
function addRemoteAppAccessConfig(locallyProvidedScopes, remoteApp) {
  let accessScopesContent = {};
  return remoteApp.requestedAccessScopes ? accessScopesContent = {
    scopes: remoteApp.requestedAccessScopes.join(",")
  } : locallyProvidedScopes === "" ? accessScopesContent = {
    use_legacy_install_flow: !0
  } : accessScopesContent = {
    scopes: locallyProvidedScopes,
    use_legacy_install_flow: !0
  }, {
    auth: {
      redirect_urls: remoteApp.redirectUrlWhitelist ?? []
    },
    access_scopes: accessScopesContent
  };
}
function addPosConfig(remoteApp) {
  return {
    pos: {
      embedded: remoteApp.posEmbedded || !1
    }
  };
}
function addBrandingConfig(remoteApp) {
  return {
    name: remoteApp.title
  };
}

// ../app/dist/cli/models/app/identifiers.js
init_cjs_shims();
async function updateAppIdentifiers({ app, identifiers, command, developerPlatformClient }, systemEnvironment = process.env) {
  if (developerPlatformClient.supportsAtomicDeployments)
    for (let extension of app.allExtensions)
      await addUidToToml(extension);
  let dotenvFile = app.dotenv;
  dotenvFile || (dotenvFile = {
    path: joinPath(app.directory, getDotEnvFileName(app.configuration.path)),
    variables: {}
  });
  let updatedVariables = { ...app.dotenv?.variables ?? {} };
  systemEnvironment[app.idEnvironmentVariableName] || (updatedVariables[app.idEnvironmentVariableName] = identifiers.app), Object.keys(identifiers.extensions).forEach((identifier) => {
    let envVariable = `SHOPIFY_${constantize(identifier)}_ID`;
    systemEnvironment[envVariable] || (updatedVariables[envVariable] = identifiers.extensions[identifier]);
  });
  let write = JSON.stringify(dotenvFile.variables) !== JSON.stringify(updatedVariables) && (command === "deploy" || command === "release");
  return dotenvFile.variables = updatedVariables, write && await writeDotEnv(dotenvFile), app.dotenv = dotenvFile, app;
}
async function addUidToToml(extension) {
  if (!extension.isUUIDStrategyExtension)
    return;
  let tomlContents = await readFile(extension.configurationPath), extensionConfig = decodeToml(tomlContents), extensions = getPathValue(extensionConfig, "extensions");
  if ("uid" in extensionConfig)
    return;
  if (extensions) {
    let currentExtension = extensions.find((ext) => ext.handle === extension.handle);
    if (currentExtension && "uid" in currentExtension)
      return;
  }
  let updatedTomlContents = tomlContents;
  if (extensions?.length > 1) {
    let regex = new RegExp(`(\\n?(\\s*)handle\\s*=\\s*"${extension.handle}")`);
    updatedTomlContents = tomlContents.replace(regex, `$1
$2uid = "${extension.uid}"`);
  } else {
    if ("uid" in extensionConfig)
      return;
    let regex = /\n?((\s*)type\s*=\s*"\S*")/;
    updatedTomlContents = tomlContents.replace(regex, `$2
uid = "${extension.uid}"
$1`);
  }
  await writeFile(extension.configurationPath, updatedTomlContents);
}
function getAppIdentifiers({ app }, developerPlatformClient, systemEnvironment = process.env) {
  let envVariables = {
    ...app.dotenv?.variables,
    ...systemEnvironment
  }, extensionsIdentifiers = {}, processExtension = (extension) => {
    Object.keys(envVariables).includes(extension.idEnvironmentVariableName) && (extensionsIdentifiers[extension.localIdentifier] = envVariables[extension.idEnvironmentVariableName]), developerPlatformClient.supportsAtomicDeployments && (extensionsIdentifiers[extension.localIdentifier] = extension.uid);
  };
  return app.allExtensions.forEach(processExtension), {
    app: envVariables[app.idEnvironmentVariableName],
    extensions: extensionsIdentifiers
  };
}

// ../app/dist/cli/services/context.js
var InvalidApiKeyErrorMessage = (apiKey) => ({
  message: outputContent`Invalid Client ID: ${apiKey}`,
  tryMessage: outputContent`You can find the Client ID in the app settings in the Partners Dashboard.`
});
async function ensureGenerateContext(options) {
  let { appId, apiKey } = options, developerPlatformClient = options.developerPlatformClient;
  if (apiKey) {
    let app = await appFromId({ id: appId, apiKey, developerPlatformClient });
    if (!app) {
      let errorMessage2 = InvalidApiKeyErrorMessage(apiKey);
      throw new AbortError(errorMessage2.message, errorMessage2.tryMessage);
    }
    return await logMetadataForLoadedContext(app), app;
  }
  let { cachedInfo, remoteApp } = await getAppContext(options);
  if (developerPlatformClient = remoteApp?.developerPlatformClient ?? developerPlatformClient, cachedInfo?.appId && cachedInfo?.orgId) {
    let org = await fetchOrgFromId(cachedInfo.orgId, developerPlatformClient), app = remoteApp || await appFromId({
      id: cachedInfo.appGid,
      apiKey: cachedInfo.appId,
      organizationId: org.id,
      developerPlatformClient
    });
    if (!app || !org) {
      let errorMessage2 = InvalidApiKeyErrorMessage(cachedInfo.appId);
      throw new AbortError(errorMessage2.message, errorMessage2.tryMessage);
    }
    return showReusedGenerateValues(org.businessName, cachedInfo), await logMetadataForLoadedContext({
      organizationId: app.organizationId,
      apiKey: app.apiKey
    }), app;
  } else {
    let orgId = cachedInfo?.orgId;
    if (!orgId) {
      let org = await selectOrg();
      developerPlatformClient = selectDeveloperPlatformClient({ organization: org }), orgId = org.id;
    }
    let { organization, apps, hasMorePages } = await developerPlatformClient.orgAndApps(orgId), localAppName = await loadAppName(options.directory), selectedApp = await selectOrCreateApp(localAppName, apps, hasMorePages, organization, developerPlatformClient);
    return setCachedAppInfo({
      appId: selectedApp.apiKey,
      title: selectedApp.title,
      directory: options.directory,
      orgId
    }), await logMetadataForLoadedContext({
      organizationId: selectedApp.organizationId,
      apiKey: selectedApp.apiKey
    }), selectedApp;
  }
}
async function ensureDevContext(options) {
  let developerPlatformClient = options.developerPlatformClient, { configuration, cachedInfo, remoteApp } = await getAppContext({
    ...options,
    enableLinkingPrompt: !options.apiKey
  });
  developerPlatformClient = remoteApp?.developerPlatformClient ?? developerPlatformClient;
  let orgId = getOrganization() || cachedInfo?.orgId;
  if (!orgId) {
    let org = await selectOrg();
    developerPlatformClient = selectDeveloperPlatformClient({ organization: org }), orgId = org.id;
  }
  let organization = await fetchOrgFromId(orgId, developerPlatformClient), { app: selectedApp, store: selectedStore } = await fetchDevDataFromOptions(options, orgId, developerPlatformClient);
  if (!selectedApp || !selectedStore) {
    let [cachedApp, cachedStore] = await Promise.all([
      selectedApp || remoteApp || cachedInfo?.appId && appFromId({ id: cachedInfo.appGid, apiKey: cachedInfo.appId, organizationId: orgId, developerPlatformClient }),
      selectedStore || cachedInfo?.storeFqdn && storeFromFqdn(cachedInfo.storeFqdn, orgId, developerPlatformClient)
    ]);
    if (cachedApp)
      selectedApp = cachedApp;
    else {
      let { apps, hasMorePages } = await developerPlatformClient.appsForOrg(orgId), localAppName = await loadAppName(options.directory);
      selectedApp = await selectOrCreateApp(localAppName, apps, hasMorePages, organization, developerPlatformClient);
    }
    if (cachedStore)
      selectedStore = cachedStore;
    else {
      let allStores = await developerPlatformClient.devStoresForOrg(orgId);
      selectedStore = await selectStore(allStores, organization, developerPlatformClient);
    }
  }
  let specifications = await fetchSpecifications({ developerPlatformClient, app: selectedApp });
  selectedApp = {
    ...selectedApp,
    configuration: await fetchAppRemoteConfiguration(selectedApp, developerPlatformClient, specifications, selectedApp.flags)
  };
  let localApp = await loadApp({
    directory: options.directory,
    specifications,
    userProvidedConfigName: getAppConfigurationShorthand(configuration.path),
    remoteFlags: selectedApp.flags
  }), rightApp = selectedApp.apiKey === cachedInfo?.appId;
  if (isCurrentAppSchema(configuration) && rightApp) {
    cachedInfo && (cachedInfo.storeFqdn = selectedStore?.shopDomain);
    let newConfiguration = {
      ...configuration,
      build: {
        ...configuration.build,
        dev_store_url: selectedStore?.shopDomain
      }
    };
    localApp.configuration = newConfiguration, await writeAppConfigurationFile(newConfiguration, localApp.configSchema);
  } else
    (!cachedInfo || rightApp) && setCachedAppInfo({
      appId: selectedApp.apiKey,
      title: selectedApp.title,
      directory: options.directory,
      storeFqdn: selectedStore?.shopDomain,
      orgId
    });
  showReusedDevValues({
    selectedApp,
    selectedStore,
    cachedInfo,
    organization
  });
  let result = buildOutput(selectedApp, selectedStore, localApp, cachedInfo);
  return await logMetadataForLoadedContext({
    organizationId: result.remoteApp.organizationId,
    apiKey: result.remoteApp.apiKey
  }), result;
}
var resetHelpMessage = [
  "You can pass ",
  { command: "--reset" },
  " to your command to reset your app configuration."
], appFromId = async (options) => {
  let organizationId = options.organizationId, developerPlatformClient = options.developerPlatformClient;
  if (!organizationId && (organizationId = "0", developerPlatformClient.requiresOrganization)) {
    let org = await selectOrg();
    developerPlatformClient = selectDeveloperPlatformClient({ organization: org }), organizationId = org.id;
  }
  let app = await developerPlatformClient.appFromId({
    id: options.id ?? "no-id-available",
    apiKey: options.apiKey,
    organizationId
  });
  if (!app)
    throw new AbortError(["Couldn't find the app with Client ID", { command: options.apiKey }], resetHelpMessage);
  return app;
}, storeFromFqdn = async (storeFqdn, orgId, developerPlatformClient) => {
  let result = await fetchStoreByDomain(orgId, storeFqdn, developerPlatformClient);
  if (result?.store)
    return await convertToTransferDisabledStoreIfNeeded(result.store, orgId, developerPlatformClient, "never"), result.store;
  throw new AbortError(`Couldn't find the store with domain "${storeFqdn}".`, resetHelpMessage);
};
function buildOutput(app, store, localApp, cachedInfo) {
  return {
    remoteApp: {
      ...app,
      apiSecret: app.apiSecretKeys.length === 0 ? void 0 : app.apiSecretKeys[0].secret
    },
    remoteAppUpdated: app.apiKey !== cachedInfo?.previousAppId,
    storeFqdn: store.shopDomain,
    storeId: store.shopId,
    updateURLs: cachedInfo?.updateURLs,
    localApp
  };
}
async function fetchDevAppAndPrompt(app, developerPlatformClient) {
  let cachedInfo = getCachedAppInfo(app.directory), devAppId = cachedInfo?.appId;
  if (!devAppId)
    return;
  let remoteApp = await appFromId({
    apiKey: devAppId,
    id: cachedInfo.appGid,
    organizationId: cachedInfo.orgId ?? "0",
    developerPlatformClient
  });
  if (!remoteApp)
    return;
  let org = await fetchOrgFromId(remoteApp.organizationId, remoteApp.developerPlatformClient);
  return showDevValues(org.businessName ?? "unknown", remoteApp.title), await reuseDevConfigPrompt() ? remoteApp : void 0;
}
async function ensureThemeExtensionDevContext(extension, apiKey, developerPlatformClient) {
  let remoteRegistrations = (await developerPlatformClient.appExtensionRegistrations({
    id: apiKey,
    apiKey,
    organizationId: "1"
  })).app.extensionRegistrations.filter((extension2) => extension2.type === "THEME_APP_EXTENSION");
  return remoteRegistrations.length > 0 ? remoteRegistrations[0] : await createExtension(apiKey, extension.graphQLType, extension.handle, developerPlatformClient);
}
async function ensureDeployContext(options) {
  let { reset, force, noRelease } = options, developerPlatformClient = options.developerPlatformClient, enableLinkingPrompt = !options.apiKey && !isCurrentAppSchema(options.app.configuration), [remoteApp] = await fetchAppAndIdentifiers(options, developerPlatformClient, !0, enableLinkingPrompt);
  developerPlatformClient = remoteApp.developerPlatformClient ?? developerPlatformClient;
  let specifications = await fetchSpecifications({ developerPlatformClient, app: remoteApp }), app = await loadApp({
    specifications,
    directory: options.app.directory,
    userProvidedConfigName: getAppConfigurationShorthand(options.app.configuration.path),
    remoteFlags: remoteApp.flags
  }), org = await fetchOrgFromId(remoteApp.organizationId, developerPlatformClient);
  await ensureIncludeConfigOnDeploy({ org, app, remoteApp, reset, force });
  let identifiers = await ensureDeploymentIdsPresence({
    app,
    appId: remoteApp.apiKey,
    appName: remoteApp.title,
    force,
    release: !noRelease,
    developerPlatformClient,
    envIdentifiers: getAppIdentifiers({ app }, developerPlatformClient),
    remoteApp
  });
  options = {
    ...options,
    app: await updateAppIdentifiers({ app, identifiers, command: "deploy", developerPlatformClient })
  };
  let result = {
    app: options.app,
    remoteApp: {
      id: remoteApp.id,
      apiKey: remoteApp.apiKey,
      title: remoteApp.title,
      appType: remoteApp.appType,
      organizationId: remoteApp.organizationId,
      grantedScopes: remoteApp.grantedScopes,
      flags: remoteApp.flags,
      developerPlatformClient
    },
    identifiers,
    release: !noRelease
  };
  return await logMetadataForLoadedContext({
    organizationId: result.remoteApp.organizationId,
    apiKey: result.identifiers.app
  }), result;
}
async function ensureIncludeConfigOnDeploy({ org, app, remoteApp, reset, force }) {
  let previousIncludeConfigOnDeploy = app.includeConfigOnDeploy;
  reset && (previousIncludeConfigOnDeploy = void 0), force && (previousIncludeConfigOnDeploy = previousIncludeConfigOnDeploy ?? !1), renderCurrentlyUsedConfigInfo({
    org: org.businessName,
    appName: remoteApp.title,
    appDotEnv: app.dotenv?.path,
    configFile: isCurrentAppSchema(app.configuration) ? basename(app.configuration.path) : void 0,
    resetMessage: resetHelpMessage,
    includeConfigOnDeploy: previousIncludeConfigOnDeploy
  }), !(force || previousIncludeConfigOnDeploy !== void 0) && await promptIncludeConfigOnDeploy({
    appDirectory: app.directory,
    localApp: app
  });
}
async function promptIncludeConfigOnDeploy(options) {
  let shouldIncludeConfigDeploy = await includeConfigOnDeployPrompt(options.localApp.configuration.path), localConfiguration = options.localApp.configuration;
  localConfiguration.build = {
    ...localConfiguration.build,
    include_config_on_deploy: shouldIncludeConfigDeploy
  }, await writeAppConfigurationFile(localConfiguration, options.localApp.configSchema), await metadata_default.addPublicMetadata(() => ({ cmd_deploy_confirm_include_config_used: shouldIncludeConfigDeploy }));
}
function includeConfigOnDeployPrompt(configPath) {
  return renderConfirmationPrompt({
    message: `Include \`${basename(configPath)}\` configuration on \`deploy\`?`,
    confirmationMessage: "Yes, always (Recommended)",
    cancellationMessage: "No, never"
  });
}
async function ensureReleaseContext(options) {
  let developerPlatformClient = options.developerPlatformClient ?? selectDeveloperPlatformClient({ configuration: options.app.configuration }), [remoteApp, envIdentifiers] = await fetchAppAndIdentifiers(options, developerPlatformClient, !0, !0);
  developerPlatformClient = remoteApp.developerPlatformClient ?? developerPlatformClient;
  let identifiers = envIdentifiers;
  options = {
    ...options,
    app: await updateAppIdentifiers({ app: options.app, identifiers, command: "release", developerPlatformClient })
  };
  let result = {
    app: options.app,
    apiKey: remoteApp.apiKey,
    remoteApp,
    developerPlatformClient
  };
  return await logMetadataForLoadedContext({ organizationId: remoteApp.organizationId, apiKey: remoteApp.apiKey }), result;
}
async function ensureVersionsListContext(options) {
  let developerPlatformClient = options.developerPlatformClient ?? selectDeveloperPlatformClient({ configuration: options.app.configuration }), [remoteApp] = await fetchAppAndIdentifiers(options, developerPlatformClient);
  return developerPlatformClient = remoteApp.developerPlatformClient ?? developerPlatformClient, await logMetadataForLoadedContext({ organizationId: remoteApp.organizationId, apiKey: remoteApp.apiKey }), {
    developerPlatformClient,
    remoteApp
  };
}
async function fetchOrCreateOrganizationApp(options, directory) {
  let { isLaunchable, scopesArray, name } = options, org = await selectOrg(), developerPlatformClient = selectDeveloperPlatformClient({ organization: org }), { organization, apps, hasMorePages } = await developerPlatformClient.orgAndApps(org.id), remoteApp = await selectOrCreateApp(name, apps, hasMorePages, organization, developerPlatformClient, {
    isLaunchable,
    scopesArray,
    directory
  });
  return remoteApp.developerPlatformClient = developerPlatformClient, await logMetadataForLoadedContext({ organizationId: remoteApp.organizationId, apiKey: remoteApp.apiKey }), remoteApp;
}
async function fetchAppAndIdentifiers(options, initialDeveloperPlatformClient, reuseFromDev = !0, enableLinkingPrompt = !1) {
  let developerPlatformClient = initialDeveloperPlatformClient, app = options.app, reuseDevCache = reuseFromDev, envIdentifiers = getAppIdentifiers({ app }, developerPlatformClient), remoteApp, configuration = await linkIfNecessary(app.directory, options.reset, enableLinkingPrompt);
  if (configuration !== void 0 && (envIdentifiers = { app: void 0, extensions: {} }, reuseDevCache = !1, app.configuration = configuration, developerPlatformClient = selectDeveloperPlatformClient({ configuration })), isCurrentAppSchema(app.configuration)) {
    let apiKey = options.apiKey ?? app.configuration.client_id, appGid = app.configuration.app_id;
    remoteApp = await appFromId({
      id: appGid,
      apiKey,
      organizationId: app.configuration.organization_id,
      developerPlatformClient
    });
  } else
    options.apiKey ? remoteApp = await appFromId({ apiKey: options.apiKey, developerPlatformClient }) : envIdentifiers.app ? remoteApp = await appFromId({ apiKey: envIdentifiers.app, developerPlatformClient }) : reuseDevCache && (remoteApp = await fetchDevAppAndPrompt(app, developerPlatformClient));
  return remoteApp || (remoteApp = await fetchOrCreateOrganizationApp(app.creationDefaultOptions())), await logMetadataForLoadedContext({ organizationId: remoteApp.organizationId, apiKey: remoteApp.apiKey }), [remoteApp, envIdentifiers];
}
async function fetchDevDataFromOptions(options, orgId, developerPlatformClient) {
  let [selectedApp, orgWithStore] = await Promise.all([
    (async () => {
      let selectedApp2;
      if (options.apiKey) {
        if (selectedApp2 = await appFromId({ apiKey: options.apiKey, developerPlatformClient }), !selectedApp2) {
          let errorMessage2 = InvalidApiKeyErrorMessage(options.apiKey);
          throw new AbortError(errorMessage2.message, errorMessage2.tryMessage);
        }
        return selectedApp2;
      }
    })(),
    (async () => {
      if (options.storeFqdn) {
        let orgWithStore2 = await fetchStoreByDomain(orgId, options.storeFqdn, developerPlatformClient);
        if (!orgWithStore2)
          throw new AbortError(`Could not find Organization for id ${orgId}.`);
        if (!orgWithStore2.store) {
          let partners = await partnersFqdn(), org = orgWithStore2.organization;
          throw new AbortError(`Could not find ${options.storeFqdn} in the Organization ${org.businessName} as a valid store.`, `Visit https://${partners}/${org.id}/stores to create a new development or Shopify Plus sandbox store in your organization`);
        }
        return orgWithStore2;
      }
    })()
  ]), selectedStore;
  return options.storeFqdn && (selectedStore = orgWithStore.store, await convertToTransferDisabledStoreIfNeeded(selectedStore, orgWithStore.organization.id, developerPlatformClient, "never")), { app: selectedApp, store: selectedStore };
}
async function getAppContext({ reset, directory, developerPlatformClient, configName, enableLinkingPrompt = !0 }) {
  await linkIfNecessary(directory, reset, enableLinkingPrompt);
  let cachedInfo = getCachedAppInfo(directory), { configuration } = await loadAppConfiguration({
    directory,
    userProvidedConfigName: configName
  }), remoteApp;
  return isCurrentAppSchema(configuration) && (remoteApp = await appFromId({
    apiKey: configuration.client_id,
    id: configuration.app_id,
    organizationId: configuration.organization_id,
    developerPlatformClient
  }), cachedInfo = {
    ...cachedInfo,
    directory,
    configFile: basename(configuration.path),
    orgId: remoteApp.organizationId,
    appId: remoteApp.apiKey,
    title: remoteApp.title,
    storeFqdn: configuration.build?.dev_store_url,
    updateURLs: configuration.build?.automatically_update_urls_on_dev
  }, await logMetadataForLoadedContext({ organizationId: remoteApp.organizationId, apiKey: remoteApp.apiKey })), {
    configuration,
    cachedInfo,
    remoteApp
  };
}
async function linkIfNecessary(directory, reset, enableLinkingPrompt) {
  let previousCachedInfo = getCachedAppInfo(directory);
  reset && clearCachedAppInfo(directory);
  let firstTimeSetup = previousCachedInfo === void 0, usingConfigWithNoTomls = previousCachedInfo?.configFile !== void 0 && (await glob(joinPath(directory, "shopify.app*.toml"))).length === 0;
  if (reset || enableLinkingPrompt && (firstTimeSetup || usingConfigWithNoTomls))
    return link({ directory, baseConfigName: previousCachedInfo?.configFile }, !1);
}
async function selectOrg() {
  let orgs = await fetchOrganizations();
  return await selectOrganizationPrompt(orgs);
}
function showReusedDevValues({ organization, selectedApp, selectedStore, cachedInfo }) {
  if (!cachedInfo || sniffForJson())
    return;
  let updateURLs2 = "Not yet configured";
  cachedInfo.updateURLs !== void 0 && (updateURLs2 = cachedInfo.updateURLs ? "Yes" : "No"), renderCurrentlyUsedConfigInfo({
    org: organization.businessName,
    appName: selectedApp.title,
    devStore: selectedStore.shopDomain,
    updateURLs: updateURLs2,
    configFile: cachedInfo.configFile,
    resetMessage: resetHelpMessage
  });
}
function renderCurrentlyUsedConfigInfo({ org, appName, devStore, updateURLs: updateURLs2, configFile, appDotEnv, resetMessage, includeConfigOnDeploy }) {
  let items = [`App:             ${appName}`];
  org && items.unshift(`Org:             ${org}`), devStore && items.push(`Dev store:       ${devStore}`), updateURLs2 && items.push(`Update URLs:     ${updateURLs2}`), includeConfigOnDeploy !== void 0 && items.push(`Include config:  ${includeConfigOnDeploy ? "Yes" : "No"}`);
  let body = [{ list: { items } }];
  resetMessage && (body = [...body, `
`, ...resetMessage]);
  let fileName = appDotEnv && basename(appDotEnv) || configFile && getAppConfigurationFileName(configFile);
  renderInfo({
    headline: configFile ? `Using ${fileName}:` : "Using these settings:",
    body
  });
}
function showReusedGenerateValues(org, cachedAppInfo) {
  renderCurrentlyUsedConfigInfo({
    org,
    appName: cachedAppInfo.title,
    configFile: cachedAppInfo.configFile,
    resetMessage: resetHelpMessage
  });
}
function showDevValues(org, appName) {
  renderInfo({
    headline: "Your configs for dev were:",
    body: {
      list: {
        items: [`Org:        ${org}`, `App:        ${appName}`]
      }
    }
  });
}
async function logMetadataForLoadedContext(app) {
  await metadata_default.addPublicMetadata(() => ({
    partner_id: tryParseInt(app.organizationId),
    api_key: app.apiKey
  }));
}
async function enableDeveloperPreview({ apiKey, developerPlatformClient }) {
  return developerPreviewUpdate({ apiKey, developerPlatformClient, enabled: !0 });
}
async function disableDeveloperPreview({ apiKey, developerPlatformClient }) {
  await developerPreviewUpdate({ apiKey, developerPlatformClient, enabled: !1 });
}
async function developerPreviewUpdate({ apiKey, developerPlatformClient, enabled }) {
  let input = {
    input: {
      apiKey,
      enabled
    }
  }, userErrors = (await developerPlatformClient.updateDeveloperPreview(input)).developmentStorePreviewUpdate.userErrors;
  return !userErrors || userErrors.length === 0;
}

// ../app/dist/cli/services/app/config/use.js
async function use({ directory, configName, warningContent, shouldRenderSuccess = !0, reset = !1 }) {
  if (reset) {
    clearCurrentConfigFile(directory);
    let packageManager2 = await getPackageManager(directory);
    renderSuccess({
      headline: "Cleared current configuration.",
      body: [
        "In order to set a new current configuration, please run",
        { command: formatPackageManagerCommand(packageManager2, "shopify app config use CONFIG_NAME") },
        { char: "." }
      ]
    });
    return;
  }
  warningContent && renderWarning(warningContent);
  let configFileName = (await getConfigFileName(directory, configName)).valueOrAbort(), { configuration } = await loadAppConfiguration({
    userProvidedConfigName: configFileName,
    directory
  });
  return setCurrentConfigPreference(configuration, { configFileName, directory }), shouldRenderSuccess && renderSuccess({
    headline: `Using configuration file ${configFileName}`
  }), await logMetadata(configuration), configFileName;
}
function setCurrentConfigPreference(configuration, options) {
  let { configFileName, directory } = options;
  if (isCurrentAppSchema(configuration) && configuration.client_id)
    setCachedAppInfo({
      directory,
      configFile: configFileName
    });
  else
    throw new AbortError(`Configuration file ${configFileName} needs a client_id.`);
}
async function getConfigFileName(directory, configName) {
  if (configName) {
    let configFile = getAppConfigurationFileName(configName);
    return await fileExists(joinPath(directory, configFile)) ? ok(configFile) : err(`Could not find configuration file ${configFile}`);
  }
  return selectConfigFile(directory);
}
async function logMetadata(configuration) {
  await logMetadataForLoadedContext({
    organizationId: configuration.organization_id || "0",
    apiKey: configuration.client_id
  });
}

// ../cli-kit/dist/public/node/framework.js
init_cjs_shims();
import { existsSync, readFileSync as readFileSync2 } from "fs";
var frameworks = [
  {
    name: "remix",
    detectors: {
      every: [
        {
          path: "package.json",
          matchContent: '"(dev)?(d|D)ependencies":\\s*{[^}]*"@remix-run\\/.*":\\s*".+?"[^}]*}'
        },
        {
          path: "package.json",
          matchContent: '"(dev)?(d|D)ependencies":\\s*{[^}]*"react":\\s*".+?"[^}]*}'
        }
      ]
    }
  },
  {
    name: "nextjs",
    detectors: {
      every: [
        {
          path: "package.json",
          matchContent: '"(dev)?(d|D)ependencies":\\s*{[^}]*"next":\\s*".+?"[^}]*}'
        },
        {
          path: "package.json",
          matchContent: '"(dev)?(d|D)ependencies":\\s*{[^}]*"react":\\s*".+?"[^}]*}'
        }
      ]
    }
  },
  {
    name: "express",
    detectors: {
      every: [
        {
          path: "package.json",
          matchContent: '"(dev)?(d|D)ependencies":\\s*{[^}]*"express":\\s*".+?"[^}]*}'
        }
      ]
    }
  },
  {
    name: "rails",
    detectors: {
      every: [
        {
          path: "Gemfile",
          matchContent: 'gem "rails"'
        }
      ]
    }
  },
  {
    name: "flask",
    detectors: {
      every: [
        {
          path: "Pipfile",
          matchContent: "flask"
        }
      ]
    }
  },
  {
    name: "django",
    detectors: {
      every: [
        {
          path: "Pipfile",
          matchContent: "django"
        }
      ]
    }
  },
  {
    name: "laravel",
    detectors: {
      every: [
        {
          path: "composer.json",
          matchContent: '"require":\\s*{[^}]*"laravel/framework":\\s*".+?"[^}]*}'
        }
      ]
    }
  },
  {
    name: "symfony",
    detectors: {
      every: [
        {
          path: "composer.json",
          matchContent: '"require":\\s*{[^}]*"symfony\\/.*":\\s*".+?"[^}]*}'
        }
      ]
    }
  }
];
async function resolveFramework(rootDirectory) {
  let fwConfigFiles = {}, matchedFramework = frameworks.find((framework) => (!framework.detectors?.some || framework.detectors?.some?.reduce((_previousDetectorsMatch, detector) => matchDetector(detector, loadFwConfigFile(rootDirectory, detector.path, fwConfigFiles)), !1)) && (!framework.detectors?.every || framework.detectors?.every?.reduce((previousDetectorsMatch, detector) => previousDetectorsMatch ? matchDetector(detector, loadFwConfigFile(rootDirectory, detector.path, fwConfigFiles)) : !1, !0)));
  return matchedFramework ? matchedFramework.name : "unknown";
}
function matchDetector(detector, fwConfigFiles = {}) {
  return fwConfigFiles[detector.path] ? !detector.matchContent || new RegExp(detector.matchContent).test(fwConfigFiles[detector.path]) : !1;
}
function loadFwConfigFile(rootPath, fwConfigFileName, fwConfigFiles = {}) {
  if (fwConfigFiles[fwConfigFileName])
    return fwConfigFiles;
  let fwConfigFilePath = joinPath(rootPath, fwConfigFileName);
  if (!existsSync(fwConfigFilePath))
    return fwConfigFiles;
  let rawContent = readFileSync2(fwConfigFilePath, { encoding: "utf8" });
  return fwConfigFiles[fwConfigFileName] = rawContent, fwConfigFiles;
}

// ../app/dist/cli/models/app/loader.js
var defaultExtensionDirectory = "extensions/*", abort = (errorMessage2) => {
  throw new AbortError(errorMessage2);
}, noopAbortOrReport = (_errorMessage, fallback, _configurationPath) => fallback;
async function loadConfigurationFileContent(filepath, abortOrReport = abort, decode = decodeToml) {
  if (!await fileExists(filepath))
    return abortOrReport(outputContent`Couldn't find an app toml file at ${outputToken.path(filepath)}`, {}, filepath);
  try {
    let configurationContent = await readFile(filepath);
    return decode(configurationContent);
  } catch (err2) {
    if (err2.line && err2.pos && err2.col)
      return abortOrReport(outputContent`Fix the following error in ${outputToken.path(filepath)}:\n${err2.message}`, {}, filepath);
    throw err2;
  }
}
async function parseConfigurationFile(schema, filepath, abortOrReport = abort, decode = decodeToml, preloadedContent) {
  let fallbackOutput = {}, configurationObject = preloadedContent ?? await loadConfigurationFileContent(filepath, abortOrReport, decode);
  return configurationObject ? { ...parseConfigurationObject(schema, filepath, configurationObject, abortOrReport), path: filepath } : fallbackOutput;
}
function parseHumanReadableError(issues) {
  let humanReadableError = "";
  return issues.forEach((issue) => {
    let path3 = issue.path ? issue?.path.join(".") : "n/a";
    humanReadableError += `\u2022 [${path3}]: ${issue.message}
`;
  }), humanReadableError;
}
function parseConfigurationObject(schema, filepath, configurationObject, abortOrReport = abort) {
  let fallbackOutput = {}, parseResult = schema.safeParse(configurationObject);
  return parseResult.success ? parseResult.data : abortOrReport(outputContent`\n${outputToken.errorText("Validation errors")} in ${outputToken.path(filepath)}:\n\n${parseHumanReadableError(parseResult.error.issues)}`, fallbackOutput, filepath);
}
function parseConfigurationObjectAgainstSpecification(spec3, filepath, configurationObject, abortOrReport) {
  let parsed = spec3.parseConfigurationObject(configurationObject);
  switch (parsed.state) {
    case "ok":
      return parsed.data;
    case "error": {
      let fallbackOutput = {};
      return abortOrReport(outputContent`App configuration is not valid\nValidation errors in ${outputToken.path(filepath)}:\n\n${parseHumanReadableError(parsed.errors)}`, fallbackOutput, filepath);
    }
  }
}
var AppErrors = class {
  constructor() {
    this.errors = {};
  }
  addError(path3, message) {
    this.errors[path3] = message;
  }
  getError(path3) {
    return this.errors[path3];
  }
  isEmpty() {
    return Object.keys(this.errors).length === 0;
  }
  toJSON() {
    return Object.values(this.errors);
  }
};
async function checkFolderIsValidApp(directory) {
  if (!((await findConfigFiles(directory)).length > 0))
    throw new AbortError(outputContent`Couldn't find an app toml file at ${outputToken.path(directory)}, is this an app directory?`);
}
async function loadApp(options) {
  let specifications = options.specifications, state = await getAppConfigurationState(options.directory, options.userProvidedConfigName), loadedConfiguration = await loadAppConfigurationFromState(state, specifications, options.remoteFlags ?? []);
  return new AppLoader({
    mode: options.mode,
    loadedConfiguration
  }).loaded();
}
function getDotEnvFileName(configurationPath) {
  let configurationShorthand = getAppConfigurationShorthand(configurationPath);
  return configurationShorthand ? `${dotEnvFileNames.production}.${configurationShorthand}` : dotEnvFileNames.production;
}
async function loadDotEnv(appDirectory, configurationPath) {
  let dotEnvFile, dotEnvPath = joinPath(appDirectory, getDotEnvFileName(configurationPath));
  return await fileExists(dotEnvPath) && (dotEnvFile = await readAndParseDotEnv(dotEnvPath)), dotEnvFile;
}
var alreadyShownCLIWarning = !1, AppLoader = class {
  constructor({ mode, loadedConfiguration }) {
    this.errors = new AppErrors(), this.mode = mode ?? "strict", this.specifications = loadedConfiguration.specifications, this.remoteFlags = loadedConfiguration.remoteFlags, this.loadedConfiguration = loadedConfiguration;
  }
  async loaded() {
    let { configuration, directory, configurationLoadResultMetadata, configSchema } = this.loadedConfiguration;
    await logMetadataFromAppLoadingProcess(configurationLoadResultMetadata);
    let dotenv = await loadDotEnv(directory, configuration.path), extensions = await this.loadExtensions(directory, configuration), packageJSONPath = joinPath(directory, "package.json"), name = await loadAppName(directory), nodeDependencies = await getDependencies(packageJSONPath), packageManager2 = await getPackageManager(directory);
    this.showGlobalCLIWarningIfNeeded(nodeDependencies, packageManager2);
    let { webs, usedCustomLayout: usedCustomLayoutForWeb } = await this.loadWebs(directory, configuration.web_directories), usesWorkspaces2 = await usesWorkspaces(directory), appClass = new App({
      name,
      directory,
      packageManager: packageManager2,
      configuration,
      nodeDependencies,
      webs,
      modules: extensions,
      usesWorkspaces: usesWorkspaces2,
      dotenv,
      specifications: this.specifications,
      configSchema,
      remoteFlags: this.remoteFlags
    });
    return this.errors.isEmpty() || (appClass.errors = this.errors), await logMetadataForLoadedApp(appClass, {
      usedCustomLayoutForWeb,
      usedCustomLayoutForExtensions: configuration.extension_directories !== void 0
    }), appClass;
  }
  findSpecificationForType(type) {
    return this.specifications.find((spec3) => spec3.identifier === type || spec3.externalIdentifier === type || spec3.additionalIdentifiers?.includes(type));
  }
  parseConfigurationFile(schema, filepath, decode = decodeToml) {
    return parseConfigurationFile(schema, filepath, this.abortOrReport.bind(this), decode);
  }
  showGlobalCLIWarningIfNeeded(nodeDependencies, packageManager2) {
    let hasLocalCLI = nodeDependencies["@shopify/cli"] !== void 0;
    if (currentProcessIsGlobal() && hasLocalCLI && !sniffForJson() && !alreadyShownCLIWarning) {
      let warningContent = {
        headline: "You are running a global installation of Shopify CLI",
        body: [
          `This project has Shopify CLI as a local dependency in package.json. If you prefer to use that version, run the command with your package manager (e.g. ${packageManager2} run shopify).`
        ],
        link: {
          label: "For more information, see Shopify CLI documentation",
          url: "https://shopify.dev/docs/apps/tools/cli"
        }
      };
      renderInfo(warningContent), alreadyShownCLIWarning = !0;
    }
  }
  async loadWebs(appDirectory, webDirectories) {
    let webConfigGlobs = [...webDirectories ?? ["**"]].map((webGlob) => joinPath(appDirectory, webGlob, configurationFileNames.web));
    webConfigGlobs.push(`!${joinPath(appDirectory, "**/node_modules/**")}`);
    let webTomlPaths = await glob(webConfigGlobs), webs = await Promise.all(webTomlPaths.map((path3) => this.loadWeb(path3)));
    this.validateWebs(webs);
    let webTomlsInStandardLocation = await glob(joinPath(appDirectory, `web/**/${configurationFileNames.web}`)), usedCustomLayout = webDirectories !== void 0 || webTomlsInStandardLocation.length !== webTomlPaths.length;
    return { webs, usedCustomLayout };
  }
  validateWebs(webs) {
    [WebType.Backend, WebType.Frontend].forEach((webType) => {
      let websOfType = webs.filter((web2) => web2.configuration.roles.includes(webType));
      websOfType.length > 1 && this.abortOrReport(outputContent`You can only have one web with the ${outputToken.yellow(webType)} role in your app`, void 0, joinPath(websOfType[1].directory, configurationFileNames.web));
    });
  }
  async loadWeb(WebConfigurationFile) {
    let config2 = await this.parseConfigurationFile(WebConfigurationSchema, WebConfigurationFile), roles = new Set("roles" in config2 ? config2.roles : []);
    "type" in config2 && roles.add(config2.type);
    let { type, ...processedWebConfiguration } = { ...config2, roles: Array.from(roles), type: void 0 };
    return {
      directory: dirname(WebConfigurationFile),
      configuration: processedWebConfiguration,
      framework: await resolveFramework(dirname(WebConfigurationFile))
    };
  }
  async createExtensionInstance(type, configurationObject, configurationPath, directory) {
    let specification = this.findSpecificationForType(type), entryPath, usedKnownSpecification = !1;
    if (specification)
      usedKnownSpecification = !0;
    else
      return this.abortOrReport(outputContent`Invalid extension type "${type}" in "${relativizePath(configurationPath)}"`, void 0, configurationPath);
    let configuration = parseConfigurationObjectAgainstSpecification(specification, configurationPath, configurationObject, this.abortOrReport.bind(this));
    usedKnownSpecification && (entryPath = await this.findEntryPath(directory, specification));
    let extensionInstance = new ExtensionInstance({
      configuration,
      configurationPath,
      entryPath,
      directory,
      specification
    });
    if (usedKnownSpecification) {
      let validateResult = await extensionInstance.validate();
      validateResult.isErr() && this.abortOrReport(outputContent`\n${validateResult.error}`, void 0, configurationPath);
    }
    return extensionInstance;
  }
  async loadExtensions(appDirectory, appConfiguration) {
    if (this.specifications.length === 0)
      return [];
    let extensionPromises = await this.createExtensionInstances(appDirectory, appConfiguration.extension_directories), configExtensionPromises = isCurrentAppSchema(appConfiguration) ? await this.createConfigExtensionInstances(appDirectory, appConfiguration) : [], webhookPromises = isCurrentAppSchema(appConfiguration) ? this.createWebhookSubscriptionInstances(appDirectory, appConfiguration) : [], extensions = await Promise.all([...extensionPromises, ...configExtensionPromises, ...webhookPromises]), allExtensions = getArrayRejectingUndefined(extensions.flat()), handles = /* @__PURE__ */ new Set();
    return allExtensions.forEach((extension) => {
      if (extension.handle && handles.has(extension.handle)) {
        let matchingExtensions = allExtensions.filter((ext) => ext.handle === extension.handle), result = joinWithAnd(matchingExtensions.map((ext) => ext.configuration.name)), handle = outputToken.cyan(extension.handle);
        this.abortOrReport(outputContent`Duplicated handle "${handle}" in extensions ${result}. Handle needs to be unique per extension.`, void 0, extension.configurationPath);
      } else
        extension.handle && handles.add(extension.handle);
    }), this.validatePrintActionExtensionsUniqueness(allExtensions), allExtensions;
  }
  async createExtensionInstances(appDirectory, extensionDirectories) {
    let extensionConfigPaths = [...extensionDirectories ?? [defaultExtensionDirectory]].map((extensionPath) => joinPath(appDirectory, extensionPath, "*.extension.toml"));
    return extensionConfigPaths.push(`!${joinPath(appDirectory, "**/node_modules/**")}`), (await glob(extensionConfigPaths)).map(async (configurationPath) => {
      let directory = dirname(configurationPath), obj = await loadConfigurationFileContent(configurationPath), { extensions, type } = ExtensionsArraySchema.parse(obj);
      if (extensions) {
        let configuration = await this.parseConfigurationFile(UnifiedSchema, configurationPath), extensionsInstancesPromises = configuration.extensions.map(async (extensionConfig) => {
          let mergedConfig = { ...configuration, ...extensionConfig }, { extensions: extensions2, ...restConfig } = mergedConfig;
          return restConfig.handle || (this.abortOrReport(outputContent`Missing handle for extension "${restConfig.name}" at ${relativePath(appDirectory, configurationPath)}`, void 0, configurationPath), restConfig.handle = "unknown-handle"), this.createExtensionInstance(mergedConfig.type, restConfig, configurationPath, directory);
        });
        return Promise.all(extensionsInstancesPromises);
      } else
        return type ? this.createExtensionInstance(type, obj, configurationPath, directory) : this.abortOrReport(outputContent`Invalid extension type at "${outputToken.path(relativePath(appDirectory, configurationPath))}". Please specify a type.`, void 0, configurationPath);
    });
  }
  createWebhookSubscriptionInstances(directory, appConfiguration) {
    let specification = this.findSpecificationForType(WebhookSubscriptionSpecIdentifier);
    if (!specification)
      return [];
    let specConfiguration = parseConfigurationObject(WebhooksSchema, appConfiguration.path, appConfiguration, this.abortOrReport.bind(this)), { api_version, subscriptions = [] } = specConfiguration.webhooks;
    return getArrayRejectingUndefined(subscriptions.flatMap((subscription) => {
      let { uri, topics, compliance_topics: _2, ...optionalFields } = subscription;
      return topics?.map((topic) => ({ api_version, uri, topic, ...optionalFields }));
    })).map(async (subscription) => this.createExtensionInstance(specification.identifier, subscription, appConfiguration.path, directory));
  }
  async createConfigExtensionInstances(directory, appConfiguration) {
    let extensionInstancesWithKeys = await Promise.all(this.specifications.filter((specification) => specification.uidStrategy === "single").map(async (specification) => {
      let specConfiguration = parseConfigurationObjectAgainstSpecification(specification, appConfiguration.path, appConfiguration, this.abortOrReport.bind(this));
      return Object.keys(specConfiguration).length === 0 ? [null, Object.keys(specConfiguration)] : [await this.createExtensionInstance(specification.identifier, specConfiguration, appConfiguration.path, directory).then((extensionInstance) => this.validateConfigurationExtensionInstance(appConfiguration.client_id, appConfiguration, extensionInstance)), Object.keys(specConfiguration)];
    })), unusedKeys = Object.keys(appConfiguration).filter((key) => !extensionInstancesWithKeys.some(([_2, keys]) => keys.includes(key))).filter((key) => ![...Object.keys(AppSchema.shape), "path"].includes(key));
    return unusedKeys.length > 0 && outputDebug(outputContent`Unused keys in app configuration: ${outputToken.json(unusedKeys)}`), extensionInstancesWithKeys.filter(([instance]) => instance).map(([instance]) => instance);
  }
  async validateConfigurationExtensionInstance(apiKey, appConfiguration, extensionInstance) {
    return extensionInstance && await extensionInstance.commonDeployConfig(apiKey, appConfiguration) ? extensionInstance : void 0;
  }
  async findEntryPath(directory, specification) {
    let entryPath;
    return specification.appModuleFeatures().includes("single_js_entry_path") ? (entryPath = (await Promise.all(["index"].flatMap((name) => [`${name}.js`, `${name}.jsx`, `${name}.ts`, `${name}.tsx`]).flatMap((fileName) => [`src/${fileName}`, `${fileName}`]).map((relativePath2) => joinPath(directory, relativePath2)).map(async (sourcePath) => await fileExists(sourcePath) ? sourcePath : void 0))).find((sourcePath) => sourcePath !== void 0), entryPath || this.abortOrReport(outputContent`Couldn't find an index.{js,jsx,ts,tsx} file in the directories ${outputToken.path(directory)} or ${outputToken.path(joinPath(directory, "src"))}`, void 0, directory)) : specification.identifier === "function" && (entryPath = (await Promise.all(["src/index.js", "src/index.ts", "src/main.rs"].map((relativePath2) => joinPath(directory, relativePath2)).map(async (sourcePath) => await fileExists(sourcePath) ? sourcePath : void 0))).find((sourcePath) => sourcePath !== void 0)), entryPath;
  }
  abortOrReport(errorMessage2, fallback, configurationPath) {
    if (this.mode === "strict")
      throw new AbortError(errorMessage2);
    return this.errors.addError(configurationPath, errorMessage2), fallback;
  }
  validatePrintActionExtensionsUniqueness(allExtensions) {
    let duplicates = {};
    allExtensions.filter((ext) => ext.type === "ui_extension").forEach((extension) => {
      extension.configuration.extension_points.flatMap((point) => point.target).filter((target) => printTargets.includes(target)).forEach((target) => {
        let targetExtensions = duplicates[target] ?? [];
        if (targetExtensions.push(extension), duplicates[target] = targetExtensions, targetExtensions.length > 1) {
          let extensionHandles = ["", ...targetExtensions.map((ext) => ext.configuration.handle)].join(`
  \xB7 `);
          this.abortOrReport(outputContent`A single target can't support two print action extensions from the same app. Point your extensions at different targets, or remove an extension.\n\nThe following extensions both target ${target}:${extensionHandles}`, void 0, extension.configurationPath);
        }
      });
    });
  }
};
async function loadAppConfiguration(options) {
  let specifications = options.specifications ?? await loadLocalExtensionsSpecifications(), state = await getAppConfigurationState(options.directory, options.userProvidedConfigName), result = await loadAppConfigurationFromState(state, specifications, options.remoteFlags ?? []);
  return await logMetadataFromAppLoadingProcess(result.configurationLoadResultMetadata), result;
}
async function getAppConfigurationState(workingDirectory, userProvidedConfigName) {
  let configName = userProvidedConfigName, appDirectory = await getAppDirectory(workingDirectory), configSource = configName ? "flag" : "cached", cachedCurrentConfigName = getCachedAppInfo(appDirectory)?.configFile, cachedCurrentConfigPath = cachedCurrentConfigName ? joinPath(appDirectory, cachedCurrentConfigName) : null;
  if (!configName && cachedCurrentConfigPath && !fileExistsSync(cachedCurrentConfigPath)) {
    let warningContent = {
      headline: `Couldn't find ${cachedCurrentConfigName}`,
      body: [
        "If you have multiple config files, select a new one. If you only have one config file, it's been selected as your default."
      ]
    };
    configName = await use({ directory: appDirectory, warningContent, shouldRenderSuccess: !1 });
  }
  configName = configName ?? cachedCurrentConfigName;
  let { configurationPath, configurationFileName: configurationFileName2 } = await getConfigurationPath(appDirectory, configName), file = await loadConfigurationFileContent(configurationPath);
  if (isCurrentAppSchema(file)) {
    let parsedConfig = await parseConfigurationFile(AppSchema, configurationPath);
    return {
      state: "connected-app",
      appDirectory,
      configurationPath,
      basicConfiguration: {
        ...file,
        ...parsedConfig
      },
      configSource,
      configurationFileName: configurationFileName2
    };
  } else {
    let parsedConfig = await parseConfigurationFile(LegacyAppSchema, configurationPath);
    return {
      appDirectory,
      configurationPath,
      state: "template-only",
      startingOptions: {
        ...file,
        ...parsedConfig
      },
      configSource,
      configurationFileName: configurationFileName2
    };
  }
}
async function loadAppConfigurationFromState(configState, specifications, remoteFlags) {
  let file, schemaForConfigurationFile;
  {
    let appSchema;
    switch (configState.state) {
      case "template-only": {
        file = {
          ...configState.startingOptions
        }, delete file.path, appSchema = LegacyAppSchema;
        break;
      }
      case "connected-app": {
        file = {
          ...configState.basicConfiguration
        }, delete file.path, appSchema = getAppVersionedSchema(specifications);
        break;
      }
    }
    let parseStrictSchemaEnabled = specifications.length > 0;
    schemaForConfigurationFile = appSchema, parseStrictSchemaEnabled && (schemaForConfigurationFile = deepStrict(appSchema));
  }
  let configuration = await parseConfigurationFile(schemaForConfigurationFile, configState.configurationPath, abort, decodeToml, file), configurationLoadResultMetadata = {
    usesLinkedConfig: !1,
    allClientIdsByConfigName: await getAllLinkedConfigClientIds(configState.appDirectory, {
      [configState.configurationFileName]: configuration.client_id
    })
  };
  switch (configState.state) {
    case "template-only":
      break;
    case "connected-app": {
      let gitTracked = !1;
      try {
        gitTracked = !(await checkIfIgnoredInGitRepository(configState.appDirectory, [configState.configurationPath]))[0];
      } catch {
      }
      configurationLoadResultMetadata = {
        ...configurationLoadResultMetadata,
        usesLinkedConfig: !0,
        name: configState.configurationFileName,
        gitTracked,
        source: configState.configSource,
        usesCliManagedUrls: configuration.build?.automatically_update_urls_on_dev
      };
    }
  }
  return {
    directory: configState.appDirectory,
    configuration,
    configurationLoadResultMetadata,
    configSchema: schemaForConfigurationFile,
    specifications,
    remoteFlags
  };
}
async function getConfigurationPath(appDirectory, configName) {
  let configurationFileName2 = getAppConfigurationFileName(configName), configurationPath = joinPath(appDirectory, configurationFileName2);
  if (await fileExists(configurationPath))
    return { configurationPath, configurationFileName: configurationFileName2 };
  throw new AbortError(outputContent`Couldn't find ${configurationFileName2} in ${outputToken.path(appDirectory)}.`);
}
async function getAppDirectory(directory) {
  if (!await fileExists(directory))
    throw new AbortError(outputContent`Couldn't find directory ${outputToken.path(directory)}`);
  let appDirectory = await findPathUp(async (directory2) => {
    if ((await glob(joinPath(directory2, appConfigurationFileNameGlob))).length > 0)
      return directory2;
  }, {
    cwd: directory,
    type: "directory"
  });
  if (appDirectory)
    return appDirectory;
  throw new AbortError(outputContent`Couldn't find an app toml file at ${outputToken.path(directory)}, is this an app directory?`);
}
async function getAllLinkedConfigClientIds(appDirectory, prefetchedConfigs) {
  let candidates = await glob(joinPath(appDirectory, appConfigurationFileNameGlob)), entries = (await Promise.all(candidates.map(async (candidateFile) => {
    let configName = basename(candidateFile);
    if (prefetchedConfigs[configName] !== void 0 && typeof prefetchedConfigs[configName] == "string")
      return [configName, prefetchedConfigs[configName]];
    try {
      let configuration = await parseConfigurationFile(
        // we only care about the client ID, so no need to parse the entire file
        z.object({ client_id: z.string().optional() }),
        candidateFile,
        // we're not interested in error reporting at all
        noopAbortOrReport
      );
      if (configuration.client_id !== void 0)
        return [configName, configuration.client_id];
    } catch {
    }
  }))).filter((entry) => entry !== void 0);
  return Object.fromEntries(entries);
}
async function loadAppName(appDirectory) {
  let packageJSONPath = joinPath(appDirectory, "package.json");
  return await getPackageName(packageJSONPath) ?? basename(appDirectory);
}
async function getProjectType(webs) {
  let backendWebs = webs.filter((web2) => isWebType(web2, WebType.Backend)), frontendWebs = webs.filter((web2) => isWebType(web2, WebType.Frontend));
  if (backendWebs.length > 1) {
    outputDebug("Unable to decide project type as multiple web backends");
    return;
  } else {
    if (backendWebs.length === 0 && frontendWebs.length > 0)
      return "frontend";
    if (backendWebs.length === 0) {
      outputDebug("Unable to decide project type as no web backend");
      return;
    }
  }
  let { directory } = backendWebs[0], nodeConfigFile = joinPath(directory, "package.json"), rubyConfigFile = joinPath(directory, "Gemfile"), phpConfigFile = joinPath(directory, "composer.json");
  if (await fileExists(nodeConfigFile))
    return "node";
  if (await fileExists(rubyConfigFile))
    return "ruby";
  if (await fileExists(phpConfigFile))
    return "php";
}
function isWebType(web2, type) {
  return web2.configuration.roles.includes(type);
}
async function logMetadataForLoadedApp(app, loadingStrategy) {
  let webs = app.webs, extensionsToAddToMetrics = app.allExtensions.filter((ext) => ext.isSentToMetrics()), appName = app.name, appDirectory = app.directory, sortedAppScopes = getAppScopesArray(app.configuration).sort(), appUsesWorkspaces = app.usesWorkspaces;
  await logMetadataForLoadedAppUsingRawValues(webs, extensionsToAddToMetrics, loadingStrategy, appName, appDirectory, sortedAppScopes, appUsesWorkspaces);
}
async function logMetadataForLoadedAppUsingRawValues(webs, extensionsToAddToMetrics, loadingStrategy, appName, appDirectory, sortedAppScopes, appUsesWorkspaces) {
  await metadata_default.addPublicMetadata(async () => {
    let projectType = await getProjectType(webs), extensionFunctionCount = extensionsToAddToMetrics.filter((extension) => extension.isFunctionExtension).length, extensionUICount = extensionsToAddToMetrics.filter((extension) => extension.isESBuildExtension).length, extensionThemeCount = extensionsToAddToMetrics.filter((extension) => extension.isThemeExtension).length, extensionTotalCount = extensionsToAddToMetrics.length, webBackendCount = webs.filter((web2) => isWebType(web2, WebType.Backend)).length, webBackendFramework = webBackendCount === 1 ? webs.filter((web2) => isWebType(web2, WebType.Backend))[0]?.framework : void 0, webFrontendCount = webs.filter((web2) => isWebType(web2, WebType.Frontend)).length, extensionsBreakdownMapping = {};
    for (let extension of extensionsToAddToMetrics)
      extensionsBreakdownMapping[extension.type] === void 0 ? extensionsBreakdownMapping[extension.type] = 1 : extensionsBreakdownMapping[extension.type]++;
    return {
      project_type: projectType,
      app_extensions_any: extensionTotalCount > 0,
      app_extensions_breakdown: JSON.stringify(extensionsBreakdownMapping),
      app_extensions_count: extensionTotalCount,
      app_extensions_custom_layout: loadingStrategy.usedCustomLayoutForExtensions,
      app_extensions_function_any: extensionFunctionCount > 0,
      app_extensions_function_count: extensionFunctionCount,
      app_extensions_theme_any: extensionThemeCount > 0,
      app_extensions_theme_count: extensionThemeCount,
      app_extensions_ui_any: extensionUICount > 0,
      app_extensions_ui_count: extensionUICount,
      app_name_hash: hashString(appName),
      app_path_hash: hashString(appDirectory),
      app_scopes: JSON.stringify(sortedAppScopes),
      app_web_backend_any: webBackendCount > 0,
      app_web_backend_count: webBackendCount,
      app_web_custom_layout: loadingStrategy.usedCustomLayoutForWeb,
      app_web_framework: webBackendFramework,
      app_web_frontend_any: webFrontendCount > 0,
      app_web_frontend_count: webFrontendCount,
      env_package_manager_workspaces: appUsesWorkspaces
    };
  }), await metadata_default.addSensitiveMetadata(async () => ({
    app_name: appName
  }));
}
async function logMetadataFromAppLoadingProcess(loadMetadata) {
  await metadata_default.addPublicMetadata(async () => ({
    // Generic config as code instrumentation
    cmd_app_all_configs_any: Object.keys(loadMetadata.allClientIdsByConfigName).length > 0,
    cmd_app_all_configs_clients: JSON.stringify(loadMetadata.allClientIdsByConfigName),
    cmd_app_linked_config_used: loadMetadata.usesLinkedConfig,
    ...loadMetadata.usesLinkedConfig ? {
      cmd_app_linked_config_name: loadMetadata.name,
      cmd_app_linked_config_git_tracked: loadMetadata.gitTracked,
      cmd_app_linked_config_source: loadMetadata.source,
      cmd_app_linked_config_uses_cli_managed_urls: loadMetadata.usesCliManagedUrls
    } : {}
  }));
}
var appConfigurationFileNameRegex = /^shopify\.app(\.[-\w]+)?\.toml$/, appConfigurationFileNameGlob = "shopify.app*.toml";
function getAppConfigurationFileName(configName) {
  return configName ? isValidFormatAppConfigurationFileName(configName) ? configName : `shopify.app.${slugify(configName)}.toml` : configurationFileNames.app;
}
function getAppConfigurationShorthand(path3) {
  return basename(path3).match(appConfigurationFileNameRegex)?.[1]?.slice(1);
}
function isValidFormatAppConfigurationFileName(configName) {
  return !!appConfigurationFileNameRegex.test(configName);
}
var printTargets = [
  "admin.order-details.print-action.render",
  "admin.order-index.selection-print-action.render",
  "admin.product-details.print-action.render",
  "admin.product-index.selection-print-action.render"
];

// ../app/dist/cli/services/build.js
init_cjs_shims();

// ../app/dist/cli/services/web.js
init_cjs_shims();
async function web(command, { web: web2, stdout, stderr, signal, env = {} }) {
  let script = web2.configuration.commands[command];
  if (!script)
    return;
  let [cmd, ...args] = script.split(" ");
  await exec(cmd, args, { cwd: web2.directory, stdout, stderr, signal, env }), stdout.write("Web successfully built.");
}

// ../app/dist/cli/services/dependencies.js
init_cjs_shims();
async function installAppDependencies(app) {
  return await renderTasks([
    {
      title: "Installing dependencies",
      task: async () => {
        await installNPMDependenciesRecursively({
          packageManager: app.packageManager,
          directory: app.directory,
          deep: 3
        });
      }
    }
  ]), await app.updateDependencies(), app;
}

// ../app/dist/cli/services/build.js
async function build(options) {
  !options.skipDependenciesInstallation && !options.app.usesWorkspaces && await installAppDependencies(options.app);
  let env = {};
  options.apiKey && (env.SHOPIFY_API_KEY = options.apiKey), await installJavy(options.app), await renderConcurrent({
    processes: [
      ...options.app.webs.map((web2) => ({
        prefix: ["web", ...web2.configuration.roles].join("-"),
        action: async (stdout, stderr, signal) => {
          await web("build", { web: web2, stdout, stderr, signal, env });
        }
      })),
      ...options.app.allExtensions.map((ext) => ({
        prefix: ext.localIdentifier,
        action: async (stdout, stderr, signal) => {
          await ext.build({ stdout, stderr, signal, app: options.app, environment: "production" });
        }
      }))
    ],
    showTimestamps: !1
  }), renderSuccess({ headline: [{ userInput: options.app.name }, "built!"] });
}
var build_default = build;

// ../app/dist/cli/utilities/app-command.js
init_cjs_shims();
var AppCommand = class extends base_command_default {
  environmentsFilename() {
    return configurationFileNames.appEnvironments;
  }
};

// ../app/dist/cli/prompts/deprecation-warnings.js
init_cjs_shims();
async function showApiKeyDeprecationWarning() {
  await metadata_default.addPublicMetadata(() => ({
    cmd_app_warning_api_key_deprecation_displayed: !0
  })), renderWarning({
    body: ["The flag", { command: "api-key" }, "has been deprecated in favor of", { command: "client-id" }]
  });
}

// ../app/dist/cli/commands/app/build.js
var import_core29 = __toESM(require_lib(), 1);
var _a14, Build2 = class extends AppCommand {
  async run() {
    let { flags } = await this.parse(_a14);
    flags["api-key"] && await showApiKeyDeprecationWarning();
    let apiKey = flags["client-id"] || flags["api-key"];
    await addPublicMetadata(() => ({
      cmd_app_dependency_installation_skipped: flags["skip-dependencies-installation"]
    }));
    let specifications = await loadLocalExtensionsSpecifications(), app = await loadApp({
      specifications,
      directory: flags.path,
      userProvidedConfigName: flags.config
    });
    await build_default({ app, skipDependenciesInstallation: flags["skip-dependencies-installation"], apiKey });
  }
};
_a14 = Build2;
Build2.summary = "Build the app, including extensions.";
Build2.descriptionWithMarkdown = "This command executes the build script specified in the element's TOML file. You can specify a custom script in the file. To learn about configuration files in Shopify apps, refer to [App configuration](https://shopify.dev/docs/apps/tools/cli/configuration).\n\n  If you're building a [theme app extension](https://shopify.dev/docs/apps/online-store/theme-app-extensions), then running the `build` command runs [Theme Check](https://shopify.dev/docs/themes/tools/theme-check) against your extension to ensure that it's valid.";
Build2.description = _a14.descriptionWithoutMarkdown();
Build2.flags = {
  ...globalFlags,
  ...appFlags,
  "skip-dependencies-installation": import_core29.Flags.boolean({
    hidden: !1,
    description: "Skips the installation of dependencies. Deprecated, use workspaces instead.",
    env: "SHOPIFY_FLAG_SKIP_DEPENDENCIES_INSTALLATION",
    default: !1
  }),
  "api-key": import_core29.Flags.string({
    hidden: !0,
    description: "Application's API key that will be exposed at build time.",
    env: "SHOPIFY_FLAG_API_KEY",
    exclusive: ["config"]
  }),
  "client-id": import_core29.Flags.string({
    hidden: !1,
    description: "Application's Client ID that will be exposed at build time.",
    env: "SHOPIFY_FLAG_CLIENT_ID",
    exclusive: ["config"]
  })
};
var build_default2 = Build2;

// ../app/dist/cli/commands/app/config/link.js
init_cjs_shims();
var import_core30 = __toESM(require_lib(), 1);
var _a15, ConfigLink = class extends AppCommand {
  async run() {
    let { flags } = await this.parse(_a15), options = {
      directory: flags.path,
      apiKey: flags["client-id"]
    };
    await link(options);
  }
};
_a15 = ConfigLink;
ConfigLink.summary = "Fetch your app configuration from the Partner Dashboard.";
ConfigLink.descriptionWithMarkdown = `Pulls app configuration from the Partner Dashboard and creates or overwrites a configuration file. You can create a new app with this command to start with a default configuration file.

  For more information on the format of the created TOML configuration file, refer to the [App configuration](https://shopify.dev/docs/apps/tools/cli/configuration) page.
  `;
ConfigLink.description = _a15.descriptionWithoutMarkdown();
ConfigLink.flags = {
  ...globalFlags,
  ...appFlags,
  "client-id": import_core30.Flags.string({
    hidden: !1,
    description: "The Client ID of your app.",
    env: "SHOPIFY_FLAG_CLIENT_ID"
  })
};
var link_default = ConfigLink;

// ../app/dist/cli/commands/app/config/use.js
init_cjs_shims();
var import_core31 = __toESM(require_lib(), 1);
var _a16, { config, ...appFlagsWithoutConfig } = appFlags, ConfigUse = class extends AppCommand {
  async run() {
    let { flags, args } = await this.parse(_a16);
    await checkFolderIsValidApp(flags.path), await use({ directory: flags.path, configName: args.config, reset: flags.reset });
  }
};
_a16 = ConfigUse;
ConfigUse.summary = "Activate an app configuration.";
ConfigUse.descriptionWithMarkdown = "Sets default configuration when you run app-related CLI commands. If you omit the `config-name` parameter, then you'll be prompted to choose from the configuration files in your project.";
ConfigUse.description = _a16.descriptionWithoutMarkdown();
ConfigUse.flags = {
  ...globalFlags,
  ...appFlagsWithoutConfig,
  reset: import_core31.Flags.boolean({
    hidden: !1,
    description: "Reset current configuration.",
    env: "SHOPIFY_FLAG_RESET",
    default: !1
  })
};
ConfigUse.args = {
  // we want to this argument to be optional so that the user
  // can also select one from the list of available app tomls.
  config: import_core31.Args.string({
    description: "The name of the app configuration. Can be 'shopify.app.staging.toml' or simply 'staging'."
  })
};
var use_default = ConfigUse;

// ../app/dist/cli/commands/app/demo/watcher.js
init_cjs_shims();

// ../app/dist/cli/services/dev/app-events/app-event-watcher.js
init_cjs_shims();

// ../app/dist/cli/services/dev/app-events/file-watcher.js
init_cjs_shims();

// ../cli-kit/dist/public/node/hrtime.js
init_cjs_shims();
function startHRTime() {
  return process.hrtime();
}
function endHRTimeInMs(startTime) {
  let endTime = process.hrtime(startTime);
  return (endTime[0] * 1e3 + endTime[1] / 1e6).toFixed(2);
}

// ../app/dist/cli/services/dev/app-events/file-watcher.js
async function startFileWatcher(app, options, onChange) {
  let { default: chokidar } = await import("./chokidar-4TKDAB27.js"), appConfigurationPath = app.configuration.path, extensionDirectories = [...app.configuration.extension_directories ?? ["extensions"]].map((directory) => joinPath(app.directory, directory)), extensionPaths = app.realExtensions.map((ext) => normalizePath(ext.directory)).filter((dir) => dir !== app.directory), watchPaths = [appConfigurationPath, ...extensionDirectories], watcher = chokidar.watch(watchPaths, {
    ignored: ["**/node_modules/**", "**/.git/**", "**/*.test.*", "**/dist/**", "**/*.swp"],
    persistent: !0,
    ignoreInitial: !0
  });
  watcher.on("all", (event, path3) => {
    let startTime = startHRTime(), isConfigAppPath = path3 === appConfigurationPath, extensionPath = extensionPaths.find((dir) => isSubpath(dir, path3)) ?? (isConfigAppPath ? app.directory : "unknown"), isToml = path3.endsWith(".toml");
    if (outputDebug(`\u{1F300}: ${event} ${path3.replace(app.directory, "")}
`), !(extensionPath === "unknown" && !isToml))
      switch (event) {
        case "change":
          onChange(isToml ? { type: "extensions_config_updated", path: path3, extensionPath, startTime } : { type: "file_updated", path: path3, extensionPath, startTime });
          break;
        case "add":
          if (!isToml) {
            onChange({ type: "file_created", path: path3, extensionPath, startTime });
            break;
          }
          let totalWaitedTime = 0, realPath = dirname(path3), intervalId = setInterval(() => {
            fileExistsSync(joinPath(realPath, configurationFileNames.lockFile)) ? (outputDebug(`Waiting for extension to complete creation: ${path3}
`), totalWaitedTime += 500) : (clearInterval(intervalId), extensionPaths.push(realPath), onChange({ type: "extension_folder_created", path: realPath, extensionPath, startTime })), totalWaitedTime >= 2e4 && (clearInterval(intervalId), options.stderr.write(`Extension creation detection timeout at path: ${path3}
You might need to restart dev`));
          }, 200);
          break;
        case "unlink":
          if (path3.endsWith(configurationFileNames.lockFile))
            break;
          isConfigAppPath ? onChange({ type: "app_config_deleted", path: path3, extensionPath, startTime }) : isToml ? (extensionPaths = extensionPaths.filter((extPath) => extPath !== extensionPath), onChange({ type: "extension_folder_deleted", path: extensionPath, extensionPath, startTime })) : setTimeout(() => {
            extensionPaths.includes(extensionPath) && onChange({ type: "file_deleted", path: path3, extensionPath, startTime });
          }, 500);
          break;
        case "addDir":
        case "unlinkDir":
          break;
      }
  }), listenForAbortOnWatcher(watcher, options);
}
var listenForAbortOnWatcher = (watcher, options) => {
  options.signal.addEventListener("abort", () => {
    outputDebug("Closing file watcher", options.stdout), watcher.close().then(() => outputDebug("File watching closed", options.stdout)).catch((error) => outputDebug(`File watching failed to close: ${error.message}`, options.stderr));
  });
};

// ../app/dist/cli/services/dev/app-events/app-diffing.js
init_cjs_shims();
function appDiff(app, newApp, includeUpdated = !0) {
  let oldExtensions = app.realExtensions, oldExtensionsHandles = oldExtensions.map((ext) => ext.handle), newExtensions = newApp.realExtensions, newExtensionsHandles = newExtensions.map((ext) => ext.handle), createdExtensions = newExtensions.filter((ext) => !oldExtensionsHandles.includes(ext.handle)), deletedExtensions = oldExtensions.filter((ext) => !newExtensionsHandles.includes(ext.handle)), updatedExtensions;
  return includeUpdated && (updatedExtensions = newExtensions.filter((ext) => {
    let oldConfig = oldExtensions.find((oldExt) => oldExt.handle === ext.handle)?.configuration, newConfig = ext.configuration;
    return oldConfig === void 0 ? !1 : JSON.stringify(oldConfig) !== JSON.stringify(newConfig);
  })), {
    created: createdExtensions,
    updated: updatedExtensions ?? [],
    deleted: deletedExtensions
  };
}

// ../app/dist/cli/services/dev/app-events/app-event-watcher.js
var import_micromatch = __toESM(require_micromatch(), 1);
import EventEmitter from "events";
var EventType;
(function(EventType3) {
  EventType3[EventType3.Updated = 0] = "Updated", EventType3[EventType3.UpdatedSourceFile = 1] = "UpdatedSourceFile", EventType3[EventType3.Deleted = 2] = "Deleted", EventType3[EventType3.Created = 3] = "Created";
})(EventType || (EventType = {}));
var handlers = {
  extension_folder_deleted: ExtensionFolderDeletedHandler,
  extension_folder_created: ExtensionFolderCreatedHandler,
  file_created: FileChangeHandler,
  file_deleted: FileChangeHandler,
  file_updated: FileChangeHandler,
  extensions_config_updated: TomlChangeHandler,
  app_config_deleted: AppConfigDeletedHandler
}, AppEventWatcher = class extends EventEmitter {
  constructor(app, options) {
    super(), this.app = app, this.options = options ?? { stdout: process.stdout, stderr: process.stderr, signal: new AbortSignal() };
  }
  async start() {
    await startFileWatcher(this.app, this.options, (event) => {
      let extensions = this.app.realExtensions.filter((ext) => ext.directory === event.extensionPath);
      handlers[event.type]({ event, app: this.app, extensions, options: this.options }).then((appEvent) => {
        if (this.app = appEvent.app, appEvent.extensionEvents.length === 0) {
          outputDebug("Change detected, but no extensions were affected", this.options.stdout);
          return;
        }
        this.emit("all", appEvent);
      }).catch((error) => {
        this.options.stderr.write(`Error handling event: ${error.message}`);
      });
    });
  }
  onEvent(listener) {
    return this.addListener("all", listener), this;
  }
};
async function ExtensionFolderDeletedHandler({ event, app, extensions }) {
  let events = extensions.map((ext) => (app.removeExtension(ext.handle), { type: EventType.Deleted, extension: ext }));
  return { app, extensionEvents: events, startTime: event.startTime, path: event.path };
}
async function FileChangeHandler({ event, app, extensions }) {
  let events = extensions.map((ext) => {
    let buildPaths = ext.watchBuildPaths ?? [];
    return { type: import_micromatch.default.isMatch(event.path, buildPaths) ? EventType.UpdatedSourceFile : EventType.Updated, extension: ext };
  });
  return { app, extensionEvents: events, startTime: event.startTime, path: event.path };
}
async function ExtensionFolderCreatedHandler({ event, app, options }) {
  let newApp = await reloadApp(app, options), extensionEvents = mapAppDiffToEvents(appDiff(app, newApp, !1));
  return { app: newApp, extensionEvents, startTime: event.startTime, path: event.path };
}
async function TomlChangeHandler({ event, app, options }) {
  let newApp = await reloadApp(app, options), extensionEvents = mapAppDiffToEvents(appDiff(app, newApp));
  return { app: newApp, extensionEvents, startTime: event.startTime, path: event.path };
}
function mapAppDiffToEvents(appDiff2) {
  let createdEvents = appDiff2.created.map((ext) => ({ type: EventType.Created, extension: ext })), deletedEvents = appDiff2.deleted.map((ext) => ({ type: EventType.Deleted, extension: ext })), updatedEvents = appDiff2.updated.map((ext) => ({ type: EventType.UpdatedSourceFile, extension: ext }));
  return [...createdEvents, ...deletedEvents, ...updatedEvents];
}
async function AppConfigDeletedHandler(_input) {
  throw new AbortError("The active app.toml was deleted, exiting");
}
async function reloadApp(app, options) {
  let start = startHRTime();
  try {
    let newApp = await loadApp({
      specifications: app.specifications,
      directory: app.directory,
      userProvidedConfigName: basename(app.configuration.path),
      remoteFlags: app.remoteFlags
    });
    return outputDebug(`App reloaded [${endHRTimeInMs(start)}ms]`, options.stdout), newApp;
  } catch (error) {
    return outputWarn(`Error reloading app: ${error.message}`, options.stderr), app;
  }
}

// ../app/dist/cli/commands/app/demo/watcher.js
var DemoWatcher = class _DemoWatcher extends AppCommand {
  async run() {
    let { flags } = await this.parse(_DemoWatcher), specifications = await loadLocalExtensionsSpecifications(), app = await loadApp({
      specifications,
      directory: flags.path,
      userProvidedConfigName: flags.config,
      mode: "report"
    }), watcher = new AppEventWatcher(app);
    await watcher.start(), outputInfo(`Watching for changes in ${app.name}...`), watcher.onEvent(async ({ app: _newApp, extensionEvents, startTime, path: path3 }) => {
      outputInfo(`\u{1F195} Event [${endHRTimeInMs(startTime)}ms]`), outputInfo(`  \u{1F4C2} ${path3}`), extensionEvents.forEach((event) => {
        switch (event.type) {
          case EventType.Created:
            outputInfo(`  \u2705 Extension created - ${source_default.green(event.extension.handle)}`);
            break;
          case EventType.Deleted:
            outputInfo(`  \u274C Extension deleted: ${source_default.red(event.extension.handle)}`);
            break;
          case EventType.Updated:
            outputInfo(`  \u{1F504} Updated: ${source_default.yellow(event.extension.handle)}`);
            break;
          case EventType.UpdatedSourceFile:
            outputInfo(`  \u{1F504} Updated: ${source_default.yellow(event.extension.handle)} (\u{1F3D7}\uFE0F needs rebuild)`);
            break;
        }
      });
    }), setInterval(() => {
    }, 1 << 30);
  }
};
DemoWatcher.summary = "Watch and prints out changes to an app.";
DemoWatcher.hidden = !0;
DemoWatcher.flags = {
  ...globalFlags,
  ...appFlags
};
var watcher_default = DemoWatcher;

// ../app/dist/cli/commands/app/deploy.js
init_cjs_shims();

// ../app/dist/cli/services/deploy.js
init_cjs_shims();

// ../app/dist/cli/services/deploy/bundle.js
init_cjs_shims();
async function bundleAndBuildExtensions(options, systemEnvironment = process.env) {
  await inTemporaryDirectory(async (tmpDir) => {
    let bundleDirectory = joinPath(tmpDir, "bundle");
    if (mkdirSync(bundleDirectory), await touchFile(joinPath(bundleDirectory, ".shopify")), isTruthy(systemEnvironment.USE_APP_MANAGEMENT_API)) {
      let appManifest = await options.app.manifest(), manifestPath = joinPath(bundleDirectory, "manifest.json");
      writeFileSync(manifestPath, JSON.stringify(appManifest, null, 2));
    }
    await installJavy(options.app), await renderConcurrent({
      processes: options.app.allExtensions.map((extension) => ({
        prefix: extension.localIdentifier,
        action: async (stdout, stderr, signal) => {
          await extension.buildForBundle({ stderr, stdout, signal, app: options.app, environment: "production" }, bundleDirectory, options.identifiers);
        }
      })),
      showTimestamps: !1
    }), options.bundlePath && await zip({
      inputDirectory: bundleDirectory,
      outputZipPath: options.bundlePath
    });
  });
}

// ../app/dist/cli/services/deploy.js
async function deploy(options) {
  let developerPlatformClient = options.developerPlatformClient ?? selectDeveloperPlatformClient({ configuration: options.app.configuration }), { app, identifiers, remoteApp, release: release2 } = await ensureDeployContext({ ...options, developerPlatformClient });
  developerPlatformClient = remoteApp.developerPlatformClient ?? developerPlatformClient;
  let apiKey = identifiers?.app ?? remoteApp.apiKey;
  outputNewline(), release2 ? outputInfo(`Releasing a new app version as part of ${remoteApp.title}`) : outputInfo(`Creating a new app version as part of ${remoteApp.title}`), outputNewline();
  let uploadExtensionsBundleResult;
  await inTemporaryDirectory(async (tmpDir) => {
    try {
      let bundle = app.allExtensions.some((ext) => ext.features.includes("bundling")), bundlePath;
      bundle && (bundlePath = joinPath(tmpDir, "bundle.zip"), await mkdir(dirname(bundlePath))), await bundleAndBuildExtensions({ app, bundlePath, identifiers });
      let uploadTaskTitle;
      release2 ? uploadTaskTitle = "Releasing an app version" : uploadTaskTitle = "Creating an app version", await renderTasks([
        {
          title: "Running validation",
          task: async () => {
            await app.preDeployValidation();
          }
        },
        {
          title: uploadTaskTitle,
          task: async () => {
            let appModules = await Promise.all(app.allExtensions.flatMap((ext) => ext.bundleConfig({ identifiers, developerPlatformClient, apiKey, appConfiguration: app.configuration })));
            if (uploadExtensionsBundleResult = await uploadExtensionsBundle({
              appId: remoteApp.id,
              apiKey,
              name: app.name,
              organizationId: remoteApp.organizationId,
              bundlePath,
              appModules: getArrayRejectingUndefined(appModules),
              release: release2,
              developerPlatformClient,
              extensionIds: identifiers.extensionIds,
              message: options.message,
              version: options.version,
              commitReference: options.commitReference
            }), !useThemebundling()) {
              let themeExtensions = app.allExtensions.filter((ext) => ext.isThemeExtension);
              await uploadThemeExtensions(themeExtensions, { apiKey, identifiers, developerPlatformClient });
            }
            app = await updateAppIdentifiers({ app, identifiers, command: "deploy", developerPlatformClient });
          }
        }
      ]), await outputCompletionMessage({
        app,
        release: release2,
        uploadExtensionsBundleResult
      });
    } catch (error) {
      throw await updateAppIdentifiers({ app, identifiers, command: "deploy", developerPlatformClient }), error;
    }
  });
}
async function outputCompletionMessage({ app, release: release2, uploadExtensionsBundleResult }) {
  let linkAndMessage = [
    { link: { label: uploadExtensionsBundleResult.versionTag, url: uploadExtensionsBundleResult.location } },
    uploadExtensionsBundleResult.message ? `
${uploadExtensionsBundleResult.message}` : ""
  ];
  return release2 ? uploadExtensionsBundleResult.deployError ? renderInfo({
    headline: "New version created, but not released.",
    body: [...linkAndMessage, `

${uploadExtensionsBundleResult.deployError}`]
  }) : renderSuccess({
    headline: "New version released to users.",
    body: linkAndMessage
  }) : renderSuccess({
    headline: "New version created.",
    body: linkAndMessage,
    nextSteps: [
      [
        "Run",
        {
          command: formatPackageManagerCommand(app.packageManager, "shopify app release", `--version=${uploadExtensionsBundleResult.versionTag}`)
        },
        "to release this version to users."
      ]
    ]
  });
}

// ../app/dist/cli/validations/version-name.js
init_cjs_shims();
function validateVersion(version2) {
  if (typeof version2 > "u")
    return;
  let errorMessage2 = ["Invalid version name:", { userInput: version2 }], versionMaxLength = 100;
  if (version2.length > versionMaxLength)
    throw new AbortError(errorMessage2, `Version name must be ${versionMaxLength} characters or less.`);
  let invalidCompleteWords = [".", ".."];
  if (invalidCompleteWords.find((invalidCompleteWord) => version2 === invalidCompleteWord))
    throw new AbortError(errorMessage2, `Version name may not be any of: ${invalidCompleteWords.map((word) => `'${word}'`).join(" , ")}`);
  let validChars = /^[a-zA-Z0-9.\-_]+$/;
  if (!version2.match(validChars))
    throw new AbortError(errorMessage2, [
      "Version name can only contain alphanumeric characters, periods, hyphens, and underscores"
    ]);
}

// ../app/dist/cli/validations/message.js
init_cjs_shims();
function validateMessage(message) {
  if (typeof message > "u")
    return;
  let errorMessage2 = ["Invalid message:", { userInput: message }], messageMaxLength = 200;
  if (message.length > messageMaxLength)
    throw new AbortError(errorMessage2, `Message name must be ${messageMaxLength} characters or less.`);
}

// ../app/dist/cli/commands/app/deploy.js
var import_core32 = __toESM(require_lib(), 1);
var _a17, Deploy2 = class extends AppCommand {
  async run() {
    let { flags } = await this.parse(_a17);
    await metadata_default.addPublicMetadata(() => ({
      cmd_deploy_flag_message_used: !!flags.message,
      cmd_deploy_flag_version_used: !!flags.version,
      cmd_deploy_flag_source_url_used: !!flags["source-control-url"]
    })), validateVersion(flags.version), validateMessage(flags.message), flags["api-key"] ? await showApiKeyDeprecationWarning() : process.env.SHOPIFY_API_KEY && (flags["api-key"] = process.env.SHOPIFY_API_KEY);
    let apiKey = flags["client-id"] || flags["api-key"];
    await addPublicMetadata(() => ({
      cmd_app_reset_used: flags.reset
    }));
    let app = await loadApp({
      directory: flags.path,
      userProvidedConfigName: flags.config,
      specifications: await loadLocalExtensionsSpecifications()
    }), requiredNonTTYFlags = ["force"];
    !apiKey && !app.configuration.client_id && requiredNonTTYFlags.push("client-id"), this.failMissingNonTTYFlags(flags, requiredNonTTYFlags), await deploy({
      app,
      apiKey,
      reset: flags.reset,
      force: flags.force,
      noRelease: flags["no-release"],
      message: flags.message,
      version: flags.version,
      commitReference: flags["source-control-url"]
    });
  }
};
_a17 = Deploy2;
Deploy2.summary = "Deploy your Shopify app.";
Deploy2.descriptionWithMarkdown = `[Builds the app](https://shopify.dev/docs/api/shopify-cli/app/app-build), then deploys your app configuration and extensions.

  This command creates an app version, which is a snapshot of your app configuration and all extensions, including the app extensions that you manage in the Partner Dashboard. This version is then released to users.

  This command doesn't deploy your [web app](https://shopify.dev/docs/apps/tools/cli/structure#web-components). You need to [deploy your web app](https://shopify.dev/docs/apps/deployment/web) to your own hosting solution.
  `;
Deploy2.description = _a17.descriptionWithoutMarkdown();
Deploy2.flags = {
  ...globalFlags,
  ...appFlags,
  "api-key": import_core32.Flags.string({
    hidden: !0,
    description: "The API key of your app.",
    env: "SHOPIFY_FLAG_APP_API_KEY",
    exclusive: ["config"]
  }),
  "client-id": import_core32.Flags.string({
    hidden: !1,
    description: "The Client ID of your app.",
    env: "SHOPIFY_FLAG_CLIENT_ID",
    exclusive: ["config"]
  }),
  reset: import_core32.Flags.boolean({
    hidden: !1,
    description: "Reset all your settings.",
    env: "SHOPIFY_FLAG_RESET",
    default: !1,
    exclusive: ["config"]
  }),
  force: import_core32.Flags.boolean({
    hidden: !1,
    description: "Deploy without asking for confirmation.",
    env: "SHOPIFY_FLAG_FORCE",
    char: "f"
  }),
  "no-release": import_core32.Flags.boolean({
    hidden: !1,
    description: "Creates a version but doesn't release it - it's not made available to merchants.",
    env: "SHOPIFY_FLAG_NO_RELEASE",
    default: !1
  }),
  message: import_core32.Flags.string({
    hidden: !1,
    description: "Optional message that will be associated with this version. This is for internal use only and won't be available externally.",
    env: "SHOPIFY_FLAG_MESSAGE"
  }),
  version: import_core32.Flags.string({
    hidden: !1,
    description: "Optional version tag that will be associated with this app version. If not provided, an auto-generated identifier will be generated for this app version.",
    env: "SHOPIFY_FLAG_VERSION"
  }),
  "source-control-url": import_core32.Flags.string({
    hidden: !1,
    description: "URL associated with the new app version.",
    env: "SHOPIFY_FLAG_SOURCE_CONTROL_URL"
  })
};
var deploy_default = Deploy2;

// ../app/dist/cli/commands/app/dev.js
init_cjs_shims();

// ../app/dist/cli/services/dev.js
init_cjs_shims();

// ../app/dist/cli/services/dev/urls.js
init_cjs_shims();

// ../cli-kit/dist/public/node/tcp.js
init_cjs_shims();
async function getAvailableTCPPort(preferredPort, options) {
  if (preferredPort && await checkPortAvailability(preferredPort))
    return outputDebug(outputContent`Port ${preferredPort.toString()} is free`), preferredPort;
  outputDebug(outputContent`Getting a random port...`);
  let randomPort = await retryOnError(() => getRandomPort("localhost"), options?.maxTries, options?.waitTimeInSeconds);
  return outputDebug(outputContent`Random port obtained: ${outputToken.raw(`${randomPort}`)}`), randomPort;
}
async function checkPortAvailability(portNumber) {
  return await checkPort(portNumber) === portNumber;
}
async function retryOnError(execute, maxTries = 5, waitTimeInSeconds = 1) {
  let retryCount = 1;
  for (; ; )
    try {
      return await execute();
    } catch (error) {
      if (retryCount++ < maxTries)
        outputDebug(outputContent`Unknown problem getting a random port: ${error.message}`), await sleep(waitTimeInSeconds);
      else
        throw new AbortError(error.message);
    }
}

// ../cli-kit/dist/public/common/url.js
init_cjs_shims();

// ../app/dist/cli/services/dev/urls.js
async function generateFrontendURL(options) {
  let frontendPort = 4040, frontendUrl = "", usingLocalhost = !1;
  if (codespaceURL())
    return frontendUrl = `https://${codespaceURL()}-${frontendPort}.${codespacePortForwardingDomain()}`, { frontendUrl, frontendPort, usingLocalhost };
  if (gitpodURL()) {
    let defaultUrl = gitpodURL()?.replace("https://", "");
    return frontendUrl = `https://${frontendPort}-${defaultUrl}`, { frontendUrl, frontendPort, usingLocalhost };
  }
  if (isSpin() && !options.tunnelUrl) {
    let cliPortProcfileExecution = appPort();
    if (cliPortProcfileExecution !== void 0 && await checkPortAvailability(cliPortProcfileExecution))
      return frontendUrl = `https://${appHost()}`, { frontendUrl, frontendPort: cliPortProcfileExecution, usingLocalhost };
    let cliPortManualExecution = await fetchSpinPort(spinVariables.partnersSpinService, spinVariables.manualCliSpinPortName);
    if (cliPortManualExecution !== void 0)
      return frontendUrl = `https://cli.${await spinFqdn()}`, { frontendUrl, frontendPort: cliPortManualExecution, usingLocalhost };
    throw new AbortError(`Error building cli url in spin, cli as service port: ${cliPortProcfileExecution}, manual cli port: ${cliPortManualExecution}`);
  }
  if (options.tunnelUrl) {
    let matches = options.tunnelUrl.match(/(https:\/\/[^:]+):([0-9]+)/);
    if (!matches)
      throw new AbortError(`Invalid tunnel URL: ${options.tunnelUrl}`, 'Valid format: "https://my-tunnel-url:port"');
    return frontendPort = Number(matches[2]), frontendUrl = matches[1], { frontendUrl, frontendPort, usingLocalhost };
  }
  if (options.noTunnel)
    frontendPort = await getAvailableTCPPort(), frontendUrl = "http://localhost", usingLocalhost = !0;
  else if (options.tunnelClient) {
    let url = await pollTunnelURL(options.tunnelClient);
    frontendPort = options.tunnelClient.port, frontendUrl = url;
  }
  return { frontendUrl, frontendPort, usingLocalhost };
}
async function pollTunnelURL(tunnelClient) {
  return new Promise((resolve2, reject) => {
    let retries = 0, pollTunnelStatus = async () => {
      let result = tunnelClient.getTunnelStatus();
      if (outputDebug(`Polling tunnel status for ${tunnelClient.provider} (attempt ${retries}): ${result.status}`), result.status === "error")
        return reject(new AbortError(result.message, result.tryMessage));
      result.status === "connected" ? resolve2(result.url) : (retries += 1, startPolling());
    }, startPolling = () => {
      setTimeout(pollTunnelStatus, 500);
    };
    pollTunnelStatus();
  });
}
function generatePartnersURLs(baseURL, authCallbackPath, proxyFields) {
  let redirectUrlWhitelist;
  authCallbackPath && authCallbackPath.length > 0 ? redirectUrlWhitelist = (Array.isArray(authCallbackPath) ? authCallbackPath : [authCallbackPath]).reduce((acc, path3) => (path3 && path3.length > 0 && acc.push(`${baseURL}${path3}`), acc), []) : redirectUrlWhitelist = [
    `${baseURL}/auth/callback`,
    `${baseURL}/auth/shopify/callback`,
    `${baseURL}/api/auth/callback`
  ];
  let appProxy = proxyFields ? {
    appProxy: {
      proxyUrl: replaceHost(proxyFields.url, baseURL),
      proxySubPath: proxyFields.subpath,
      proxySubPathPrefix: proxyFields.prefix
    }
  } : {};
  return {
    applicationUrl: baseURL,
    redirectUrlWhitelist,
    ...appProxy
  };
}
function replaceHost(oldUrl, newUrl) {
  let oldUrlObject = new URL(oldUrl), newUrlObject = new URL(newUrl);
  return oldUrlObject.host = newUrlObject.host, oldUrlObject.toString().replace(/\/$/, "");
}
async function updateURLs(urls, apiKey, developerPlatformClient, localApp) {
  let variables = { apiKey, ...urls }, result = await developerPlatformClient.updateURLs(variables);
  if (result.appUpdate.userErrors.length > 0) {
    let errors2 = result.appUpdate.userErrors.map((error) => error.message).join(", ");
    throw new AbortError(errors2);
  }
  if (localApp && isCurrentAppSchema(localApp.configuration) && localApp.configuration.client_id === apiKey) {
    let localConfiguration = {
      ...localApp.configuration,
      application_url: urls.applicationUrl,
      auth: {
        ...localApp.configuration.auth ?? {},
        redirect_urls: urls.redirectUrlWhitelist
      }
    };
    urls.appProxy && (localConfiguration = {
      ...localConfiguration,
      app_proxy: {
        url: urls.appProxy.proxyUrl,
        subpath: urls.appProxy.proxySubPath,
        prefix: urls.appProxy.proxySubPathPrefix
      }
    }), await writeAppConfigurationFile(localConfiguration, localApp.configSchema);
  }
}
async function getURLs(remoteAppConfig) {
  let result = {
    applicationUrl: remoteAppConfig?.application_url ?? "",
    redirectUrlWhitelist: remoteAppConfig?.auth?.redirect_urls ?? []
  };
  return remoteAppConfig?.app_proxy && (result.appProxy = {
    proxyUrl: remoteAppConfig?.app_proxy.url,
    proxySubPath: remoteAppConfig?.app_proxy.subpath,
    proxySubPathPrefix: remoteAppConfig?.app_proxy.prefix
  }), result;
}
async function shouldOrPromptUpdateURLs(options) {
  if (options.localApp && options.localApp.configuration.client_id !== options.apiKey || options.newApp || !terminalSupportsRawMode())
    return !0;
  let shouldUpdateURLs = options.cachedUpdateURLs === !0;
  if (options.cachedUpdateURLs === void 0)
    if (shouldUpdateURLs = await updateURLsPrompt(options.currentURLs.applicationUrl, options.currentURLs.redirectUrlWhitelist), options.localApp && isCurrentAppSchema(options.localApp.configuration)) {
      let localConfiguration = options.localApp.configuration;
      localConfiguration.build = {
        ...localConfiguration.build,
        automatically_update_urls_on_dev: shouldUpdateURLs
      }, await writeAppConfigurationFile(localConfiguration, options.localApp.configSchema);
    } else
      setCachedAppInfo({ directory: options.appDirectory, updateURLs: shouldUpdateURLs });
  return shouldUpdateURLs;
}
async function startTunnelPlugin(config2, port, provider) {
  let hooks2 = await fanoutHooks(config2, "tunnel_start", { port, provider }), results = Object.values(hooks2).filter((tunnelResponse) => !tunnelResponse?.isErr() || tunnelResponse.error.type !== "invalid-provider");
  if (results.length > 1)
    throw new BugError(`Multiple tunnel plugins for ${provider} found`);
  let first = results[0];
  if (!first)
    throw new BugError(`We couldn't find the ${provider} tunnel plugin`);
  if (first.isErr())
    throw new AbortError(`${provider} failed to start the tunnel.
${first.error.message}`, [
      "What to try:",
      {
        list: {
          items: [
            ["Try to run the command again"],
            ["Add the flag", { command: "--tunnel-url {URL}" }, "to use a custom tunnel URL"]
          ]
        }
      }
    ]);
  return first.value;
}

// ../app/dist/cli/services/dev/processes/setup-dev-processes.js
init_cjs_shims();

// ../app/dist/cli/services/dev/processes/theme-app-extension.js
init_cjs_shims();

// ../app/dist/cli/utilities/extensions/theme/host-theme-manager.js
init_cjs_shims();

// ../app/dist/cli/utilities/extensions/theme/host-theme-watcher.js
init_cjs_shims();
var UPDATER_TIMEOUT = 5 * 60 * 1e3, FAILED_TO_CREATE_THEME_MESSAGE = 'The host theme could not be created to host your theme app extension. Please try again or use the "--theme" flag to use an existing theme as the host theme.';
async function waitForThemeToBeProcessed(themeId, adminSession, startTime = Date.now()) {
  for (; await themeIsProcessing(themeId, adminSession, startTime); )
    ;
}
async function themeIsProcessing(themeId, session, startTime) {
  let theme = await fetchTheme(themeId, session);
  if (!theme || themeProcessingTimedOut(theme, startTime))
    throw new AbortError(FAILED_TO_CREATE_THEME_MESSAGE);
  return await sleep(3), theme.processing;
}
function themeProcessingTimedOut(theme, startTime) {
  return theme.processing && Date.now() - startTime >= UPDATER_TIMEOUT;
}

// ../app/dist/cli/utilities/extensions/theme/host-theme-manager.js
var DEFAULT_THEME_ZIP = "https://codeload.github.com/Shopify/dawn/zip/refs/tags/v15.0.0", FALLBACK_THEME_ZIP = "https://cdn.shopify.com/theme-store/uhrdefhlndzaoyrgylhto59sx2i7.jpg", retryAttemps = 3, HostThemeManager = class extends ThemeManager {
  constructor(adminSession, config2 = { devPreview: !1 }) {
    super(adminSession), this.context = "App Ext. Host", this.themeId = getHostTheme(adminSession.storeFqdn), this.devPreview = config2.devPreview;
  }
  async findOrCreate() {
    let theme = await this.fetch();
    return theme || (theme = this.devPreview ? await this.createHostTheme() : await this.create()), theme;
  }
  setTheme(themeId) {
    setHostTheme(this.adminSession.storeFqdn, themeId);
  }
  removeTheme() {
    removeHostTheme(this.adminSession.storeFqdn);
  }
  async createHostTheme() {
    let options = {
      role: DEVELOPMENT_THEME_ROLE,
      name: this.generateThemeName(this.context),
      src: DEFAULT_THEME_ZIP
    };
    for (let attempt = 0; attempt < retryAttemps; attempt++) {
      outputDebug(`Attempt ${attempt}/${retryAttemps}: Creating theme with name "${options.name}" and role "${options.role}"`);
      try {
        let theme2 = await createTheme(options, this.adminSession);
        if (theme2)
          return this.setTheme(theme2.id.toString()), outputDebug(`Waiting for theme with id "${theme2.id}" to be processed`), await waitForThemeToBeProcessed(theme2.id, this.adminSession), theme2;
        throw new Error();
      } catch {
        outputDebug(`Failed to create theme with name "${options.name}" and role "${options.role}". Retrying...`);
      }
    }
    outputDebug(`Theme creation failed after ${retryAttemps} retries. Creating theme using fallback theme zip`);
    let theme = await createTheme({ ...options, src: FALLBACK_THEME_ZIP }, this.adminSession);
    if (!theme)
      throw outputDebug("Theme creation failed. Exiting process."), new BugError(`Could not create theme with name "${options.name}" and role "${options.role}"`);
    return theme;
  }
};

// ../app/dist/cli/services/dev/theme-extension-args.js
init_cjs_shims();
async function themeExtensionArgs(extension, apiKey, developerPlatformClient, options) {
  let extensionId = (await ensureThemeExtensionDevContext(extension, apiKey, developerPlatformClient)).id, directory = extension.directory, extensionTitle = extension.localIdentifier, extensionType = extension.graphQLType, args = [
    directory,
    "--api-key",
    apiKey,
    "--extension-id",
    extensionId,
    "--extension-title",
    extensionTitle,
    "--extension-type",
    extensionType
  ];
  return options.theme && args.push("--theme", options.theme), options.themeExtensionPort && args.push("--port", options.themeExtensionPort.toString()), options.generateTmpTheme && args.push("--generate-tmp-theme"), options.notify && args.push("--notify", options.notify), args;
}

// ../app/dist/cli/services/dev/processes/theme-app-extension.js
var PARTNERS_TOKEN_REFRESH_TIMEOUT_IN_MS = 3 * 60 * 1e3, runThemeAppExtensionsServer = async ({ stdout, stderr, abortSignal }, { adminSession, themeExtensionServerArgs: args, storefrontToken, developerPlatformClient }) => {
  let refreshSequence = (attempt = 0) => {
    outputDebug(`Refreshing Developer Platform token (attempt ${attempt})...`, stdout), refreshToken(developerPlatformClient).then(() => {
      outputDebug("Refreshed Developer Platform token successfully", stdout);
    }).catch((error) => {
      if (outputDebug(`Failed to refresh Developer Platform token: ${error}`, stderr), attempt < 3)
        setTimeout(() => refreshSequence(attempt + 1), 3e4);
      else
        throw error;
    });
  };
  setInterval(refreshSequence, PARTNERS_TOKEN_REFRESH_TIMEOUT_IN_MS), await refreshToken(developerPlatformClient), await execCLI2(["extension", "serve", ...args], {
    store: adminSession.storeFqdn,
    adminToken: adminSession.token,
    storefrontToken,
    stdout,
    stderr,
    signal: abortSignal
  });
};
async function setupPreviewThemeAppExtensionsProcess({ allExtensions, apiKey, storeFqdn, theme, themeExtensionPort, notify, developerPlatformClient }) {
  let themeExtensions = allExtensions.filter((ext) => ext.isThemeExtension);
  if (themeExtensions.length === 0)
    return;
  let adminSession = await ensureAuthenticatedAdmin(storeFqdn), extension = themeExtensions[0], optionsToOverwrite = {};
  theme || (optionsToOverwrite = {
    theme: (await new HostThemeManager(adminSession).findOrCreate()).id.toString(),
    generateTmpTheme: !0
  });
  let [storefrontToken, args] = await Promise.all([
    ensureAuthenticatedStorefront(),
    themeExtensionArgs(extension, apiKey, developerPlatformClient, {
      theme,
      themeExtensionPort,
      notify,
      ...optionsToOverwrite
    })
  ]);
  return {
    type: "theme-app-extensions",
    prefix: "theme-extensions",
    function: runThemeAppExtensionsServer,
    options: {
      adminSession,
      themeExtensionServerArgs: args,
      storefrontToken,
      developerPlatformClient
    }
  };
}
async function refreshToken(developerPlatformClient) {
  let newToken = await developerPlatformClient.refreshToken();
  useEmbeddedThemeCLI() && await execCLI2(["theme", "token", "--partners", newToken]);
}

// ../app/dist/cli/services/dev/processes/theme-app-extension-next.js
init_cjs_shims();
async function setupPreviewThemeAppExtensionsProcess2(options) {
  outputInfo("This feature is currently in development and is not ready for use or testing yet.");
  let { allExtensions, storeFqdn, theme, themeExtensionPort, developerPlatformClient } = options;
  if (allExtensions.filter((ext) => ext.isThemeExtension).length === 0)
    return;
  let adminSession = await ensureAuthenticatedAdmin(storeFqdn), themeId = await findOrCreateHostTheme(adminSession, theme);
  return renderInfo({
    headline: { info: "Setup your theme app extension in the host theme:" },
    link: {
      label: `https://${adminSession.storeFqdn}/admin/themes/${themeId}/editor`,
      url: `https://${adminSession.storeFqdn}/admin/themes/${themeId}/editor`
    }
  }), {
    type: "theme-app-extensions",
    prefix: "theme-extensions",
    function: runThemeAppExtensionsServerNext,
    options: {
      adminSession,
      developerPlatformClient,
      themeId,
      themeExtensionPort
    }
  };
}
async function findOrCreateHostTheme(adminSession, theme) {
  let hostTheme;
  if (theme)
    outputDebug(`Fetching theme with provided id ${theme}`), hostTheme = await fetchTheme(parseInt(theme, 10), adminSession);
  else {
    let themeManager = new HostThemeManager(adminSession, { devPreview: !0 });
    await renderTasks([
      {
        title: "Configuring host theme for theme app extension",
        task: async () => {
          outputDebug("Finding or creating host theme for theme app extensions"), hostTheme = await themeManager.findOrCreate();
        }
      }
    ]);
  }
  if (!hostTheme)
    throw new AbortError("Could not find or create a host theme for theme app extensions");
  return hostTheme.id.toString();
}
var runThemeAppExtensionsServerNext = async ({ stdout: _stdout, stderr: _stderr, abortSignal: _abortSignal }, _PreviewThemeAppExtensionsOptions) => {
  await initializeFSWatcher(), await startThemeAppExtensionDevelopmentServer();
};
async function initializeFSWatcher() {
}
async function startThemeAppExtensionDevelopmentServer() {
}

// ../app/dist/cli/services/dev/processes/previewable-extension.js
init_cjs_shims();

// ../app/dist/cli/services/dev/extension.js
init_cjs_shims();

// ../app/dist/cli/services/dev/extension/websocket.js
init_cjs_shims();

// ../app/dist/cli/services/dev/extension/payload/store.js
init_cjs_shims();

// ../app/dist/cli/services/dev/extension/payload.js
init_cjs_shims();

// ../app/dist/cli/services/dev/extension/localization.js
init_cjs_shims();
async function getLocalizationFilePaths(extension) {
  let localePath = joinPath(extension.directory, "locales");
  return glob([joinPath(localePath, "*.json")]);
}
async function getLocalization(extension, options) {
  let localeFiles = await getLocalizationFilePaths(extension);
  if (!localeFiles.length)
    return { localization: void 0, status: "" };
  let localization = options.currentLocalizationPayload ? options.currentLocalizationPayload : {
    defaultLocale: "en",
    translations: {},
    lastUpdated: 0
  }, status = "success";
  try {
    await Promise.all(localeFiles.map(async (localeFile) => {
      let [locale, ...fileNameSegments] = localeFile.split("/").pop().split(".");
      if (locale)
        return fileNameSegments[0] === "default" && (localization.defaultLocale = locale), compileLocalizationFiles(locale, localeFile, localization, extension, options);
    })), localization.lastUpdated = Date.now(), outputInfo(`Parsed locales for extension ${extension.handle} at ${extension.directory}`, options.stdout);
  } catch {
    status = "error";
  }
  return {
    localization,
    status
  };
}
async function compileLocalizationFiles(locale, path3, localization, extension, options) {
  let localeContent;
  try {
    localeContent = await readFile(path3), localization.translations[locale] = JSON.parse(localeContent);
  } catch (error) {
    let message = `Error parsing ${locale} locale for ${extension.handle} at ${path3}: ${error.message}`;
    throw outputWarn(message, options.stderr), new import_ts_error.ExtendableError(message);
  }
}

// ../app/dist/cli/utilities/extensions/configuration.js
init_cjs_shims();
function getUIExtensionResourceURL(uiExtensionType, options) {
  switch (uiExtensionType) {
    case "checkout_ui_extension":
      return { url: options.checkoutCartUrl };
    case "product_subscription":
      return { url: options.subscriptionProductUrl ?? "" };
    default:
      return { url: "" };
  }
}

// ../cli-kit/dist/public/node/ui/components.js
init_cjs_shims();

// ../app/dist/cli/services/dev/extension/payload.js
async function getUIExtensionPayload(extension, options) {
  return useConcurrentOutputContext({ outputPrefix: extension.outputPrefix }, async () => {
    let url = `${options.url}/extensions/${extension.devUUID}`, { localization, status: localizationStatus } = await getLocalization(extension, options), renderer = await getUIExtensionRendererVersion(extension);
    return {
      assets: {
        main: {
          name: "main",
          url: `${url}/assets/${extension.outputFileName}`,
          lastUpdated: await fileLastUpdatedTimestamp(extension.outputPath) ?? 0
        }
      },
      capabilities: {
        blockProgress: extension.configuration.capabilities?.block_progress || !1,
        networkAccess: extension.configuration.capabilities?.network_access || !1,
        apiAccess: extension.configuration.capabilities?.api_access || !1,
        collectBuyerConsent: {
          smsMarketing: extension.configuration.capabilities?.collect_buyer_consent?.sms_marketing || !1,
          customerPrivacy: extension.configuration.capabilities?.collect_buyer_consent?.customer_privacy || !1
        },
        iframe: {
          sources: extension.configuration.capabilities?.iframe?.sources || []
        }
      },
      development: {
        ...options.currentDevelopmentPayload,
        resource: getUIExtensionResourceURL(extension.configuration.type, options),
        root: {
          url
        },
        hidden: options.currentDevelopmentPayload?.hidden || !1,
        localizationStatus,
        status: options.currentDevelopmentPayload?.status || "success",
        ...options.currentDevelopmentPayload || { status: "success" }
      },
      extensionPoints: getExtensionPoints(extension.configuration.extension_points, url),
      localization: localization ?? null,
      metafields: extension.configuration.metafields.length === 0 ? null : extension.configuration.metafields,
      type: extension.configuration.type,
      externalType: extension.externalType,
      uuid: extension.devUUID,
      surface: extension.surface,
      // eslint-disable-next-line @typescript-eslint/ban-ts-comment
      // @ts-ignore
      version: renderer?.version,
      title: extension.configuration.name,
      handle: extension.handle,
      name: extension.configuration.name,
      description: extension.configuration.description,
      apiVersion: extension.configuration.api_version,
      approvalScopes: options.grantedScopes,
      settings: extension.configuration.settings
    };
  });
}
function getExtensionPoints(extensionPoints, url) {
  return isNewExtensionPointsSchema(extensionPoints) ? extensionPoints.map((extensionPoint) => {
    let { target, resource } = extensionPoint;
    return {
      ...extensionPoint,
      surface: getExtensionPointTargetSurface(target),
      root: {
        url: `${url}/${target}`
      },
      resource: resource || { url: "" }
    };
  }) : extensionPoints;
}
function isNewExtensionPointsSchema(extensionPoints) {
  return Array.isArray(extensionPoints) && extensionPoints.every((extensionPoint) => typeof extensionPoint == "object");
}

// ../app/dist/cli/utilities/app/app-url.js
init_cjs_shims();
function buildAppURLForWeb(storeFqdn, apiKey) {
  return `https://${storeFqdn}/admin/oauth/redirect_from_cli?client_id=${apiKey}`;
}
function buildAppURLForMobile(storeFqdn, apiKey) {
  let hostUrl = `${storeFqdn}/admin/apps/${apiKey}`, hostParam = Buffer.from(hostUrl).toString("base64").replace(/[=]/g, "");
  return `https://${hostUrl}?shop=${storeFqdn}&host=${hostParam}`;
}

// ../app/dist/cli/services/dev/extension/payload/store.js
import { EventEmitter as EventEmitter2 } from "events";
var ExtensionsPayloadStoreEvent;
(function(ExtensionsPayloadStoreEvent2) {
  ExtensionsPayloadStoreEvent2.Update = "PayloadUpdatedEvent:UPDATE";
})(ExtensionsPayloadStoreEvent || (ExtensionsPayloadStoreEvent = {}));
async function getExtensionsPayloadStoreRawPayload(options) {
  return {
    app: {
      title: options.appName,
      apiKey: options.apiKey,
      url: buildAppURLForWeb(options.storeFqdn, options.apiKey),
      mobileUrl: buildAppURLForMobile(options.storeFqdn, options.apiKey)
    },
    appId: options.id,
    version: options.manifestVersion,
    root: {
      url: new URL("/extensions", options.url).toString()
    },
    socket: {
      url: options.websocketURL
    },
    devConsole: {
      url: new URL("/extensions/dev-console", options.url).toString()
    },
    store: options.storeFqdn,
    extensions: await Promise.all(options.extensions.map((extension) => getUIExtensionPayload(extension, options)))
  };
}
var ExtensionsPayloadStore = class extends EventEmitter2 {
  constructor(rawPayload, options) {
    super(), this.rawPayload = rawPayload, this.options = options;
  }
  getConnectedPayload() {
    let rawPayload = this.getRawPayload();
    return {
      app: rawPayload.app,
      appId: rawPayload.appId,
      store: rawPayload.store,
      extensions: rawPayload.extensions
    };
  }
  getRawPayloadFilteredByExtensionIds(extensionIds) {
    return {
      ...this.rawPayload,
      extensions: this.rawPayload.extensions.filter((extension) => extensionIds.includes(extension.uuid))
    };
  }
  getRawPayload() {
    return this.rawPayload;
  }
  updateApp(app) {
    this.rawPayload = deepMergeObjects(this.rawPayload, {
      app
    }), this.emitUpdate([]);
  }
  updateExtensions(extensions) {
    let updatedExtensionsPayload = this.rawPayload.extensions.map((rawPayloadExtension) => {
      let foundExtension = extensions.find((ext) => ext.uuid === rawPayloadExtension.uuid);
      if (foundExtension) {
        if (isNewExtensionPointsSchema(foundExtension.extensionPoints) && isNewExtensionPointsSchema(rawPayloadExtension.extensionPoints)) {
          let foundExtensionPointsPayloadMap = foundExtension.extensionPoints.reduce((acc, ex) => ({ ...acc, [ex.target]: ex }), {});
          rawPayloadExtension.extensionPoints = deepMergeObjects(rawPayloadExtension.extensionPoints, foundExtension.extensionPoints, (destinationArray) => destinationArray.map((extensionPoint) => {
            let extensionPointPayload = foundExtensionPointsPayloadMap[extensionPoint.target];
            return extensionPointPayload ? deepMergeObjects(extensionPoint, extensionPointPayload) : extensionPoint;
          }));
          let { extensionPoints, ...rest } = foundExtension;
          return deepMergeObjects(rawPayloadExtension, rest);
        }
        return deepMergeObjects(rawPayloadExtension, foundExtension);
      }
      return rawPayloadExtension;
    });
    this.rawPayload = {
      ...this.rawPayload,
      extensions: updatedExtensionsPayload
    }, this.emitUpdate(extensions.map((extension) => extension.uuid));
  }
  async updateExtension(extension, options, development) {
    let payloadExtensions = this.rawPayload.extensions, index = payloadExtensions.findIndex((extensionPayload) => extensionPayload.uuid === extension.devUUID);
    if (index === -1) {
      outputDebug(outputContent`Could not updateExtension() for extension with uuid: ${extension.devUUID}`, options.stderr);
      return;
    }
    payloadExtensions[index] = await getUIExtensionPayload(extension, {
      ...this.options,
      currentDevelopmentPayload: development || { status: payloadExtensions[index]?.development.status },
      currentLocalizationPayload: payloadExtensions[index]?.localization
    }), this.rawPayload.extensions = payloadExtensions, this.emitUpdate([extension.devUUID]);
  }
  emitUpdate(extensionIds) {
    this.emit(ExtensionsPayloadStoreEvent.Update, extensionIds);
  }
};

// ../app/dist/cli/services/dev/extension/websocket/handlers.js
init_cjs_shims();

// ../app/dist/cli/services/dev/extension/websocket/models.js
init_cjs_shims();
var EventType2;
(function(EventType3) {
  EventType3.Update = "update", EventType3.Dispatch = "dispatch";
})(EventType2 || (EventType2 = {}));

// ../app/dist/cli/services/dev/extension/websocket/handlers.js
function websocketUpgradeHandler(wss, options) {
  return (request2, socket, head) => {
    request2.url === "/extensions" && (outputDebug("Upgrading HTTP request to a websocket connection", options.stdout), wss.handleUpgrade(request2, socket, head, getConnectionDoneHandler(wss, options)));
  };
}
function getConnectionDoneHandler(wss, options) {
  return (ws) => {
    outputDebug("Websocket connection successfully established", options.stdout);
    let connectedPayload = {
      event: "connected",
      data: options.payloadStore.getConnectedPayload(),
      version: options.manifestVersion
    };
    outputDebug(outputContent`Sending connected payload: ${outputToken.json(connectedPayload)}`, options.stdout), ws.send(JSON.stringify(connectedPayload)), ws.on("message", getOnMessageHandler(wss, options));
  };
}
function getOnMessageHandler(wss, options) {
  return (data) => {
    let jsonData = JSON.parse(data.toString()), { event: eventType, data: eventData } = jsonData;
    if (outputDebug(outputContent`Received websocket message with event type ${eventType} and data:
${outputToken.json(eventData)}
          `, options.stdout), eventType === "update") {
      let payloadStoreApiKey = options.payloadStore.getRawPayload().app.apiKey, eventAppApiKey = eventData.app?.apiKey;
      if (eventData.app) {
        if (payloadStoreApiKey !== eventAppApiKey)
          return;
        options.payloadStore.updateApp(eventData.app);
      }
      eventData.extensions && options.payloadStore.updateExtensions(eventData.extensions);
    } else if (eventType === "dispatch") {
      let outGoingMessage = getOutgoingDispatchMessage(jsonData, options);
      notifyClients(wss, outGoingMessage, options);
    }
  };
}
function getPayloadUpdateHandler(wss, options) {
  return (extensionIds) => {
    let payload = {
      event: EventType2.Update,
      version: options.manifestVersion,
      data: {
        ...options.payloadStore.getRawPayloadFilteredByExtensionIds(extensionIds)
      }
    };
    outputDebug(outputContent`Sending websocket update event to the websocket clients:
  ${outputToken.json(payload)}
    `, options.stdout), notifyClients(wss, payload, options);
  };
}
function notifyClients(wss, payload, options) {
  outputDebug(outputContent`Sending websocket with event type ${payload.event} and data:
${outputToken.json(payload.data)}
        `, options.stdout);
  let stringPayload = JSON.stringify(payload);
  wss.clients.forEach((ws) => ws.send(stringPayload));
}
function getOutgoingDispatchMessage(incomingMessage, options) {
  let extensionsPayload = options.payloadStore.getRawPayload();
  return {
    ...incomingMessage,
    version: options.manifestVersion,
    data: {
      ...incomingMessage.data,
      extensions: [],
      store: extensionsPayload.store,
      app: extensionsPayload.app
    }
  };
}

// ../app/dist/cli/services/dev/extension/websocket.js
var PING_INTERVAL_SEC = 10;
function setupWebsocketConnection(options) {
  let wss = new import_websocket_server.default({ noServer: !0, clientTracking: !0 }), timer = pingAliveClientsPeriodically(wss);
  return options.httpServer.on("upgrade", websocketUpgradeHandler(wss, options)), options.payloadStore.on(ExtensionsPayloadStoreEvent.Update, getPayloadUpdateHandler(wss, options)), {
    close: () => {
      wss.close(), clearInterval(timer);
    }
  };
}
function pingAliveClientsPeriodically(wss) {
  return setInterval(() => {
    wss.clients.forEach((ws) => {
      ws.readyState < 2 && ws.ping();
    });
  }, PING_INTERVAL_SEC * 1e3);
}

// ../app/dist/cli/services/dev/extension/bundler.js
init_cjs_shims();

// ../app/dist/cli/services/dev/update-extension.js
init_cjs_shims();
async function updateExtensionDraft({ extension, developerPlatformClient, apiKey, registrationId, stdout, stderr, appConfiguration }) {
  let encodedFile;
  if (extension.features.includes("esbuild")) {
    let content = await readFile(extension.outputPath);
    if (!content)
      return;
    encodedFile = Buffer.from(content).toString("base64");
  }
  let config2;
  extension.isThemeExtension ? config2 = await themeExtensionConfig(extension) : config2 = await extension.deployConfig({ apiKey, developerPlatformClient, appConfiguration }) || {};
  let extensionInput = {
    apiKey,
    config: JSON.stringify({
      ...config2,
      serialized_script: encodedFile
    }),
    handle: extension.handle,
    context: extension.contextValue,
    registrationId
  }, mutationResult = await developerPlatformClient.updateExtension(extensionInput);
  if (mutationResult.extensionUpdateDraft?.userErrors && mutationResult.extensionUpdateDraft?.userErrors?.length > 0) {
    let errors2 = mutationResult.extensionUpdateDraft.userErrors.map((error) => error.message).join(", ");
    stderr.write(`Error while updating drafts: ${errors2}`);
  } else {
    let draftUpdateSuccesMessage = extension.draftMessages.successMessage;
    draftUpdateSuccesMessage && outputInfo(draftUpdateSuccesMessage, stdout);
  }
}
async function reloadExtensionConfig({ extension }) {
  let abort2 = (errorMessage2, _fallbackOutput, _path, rawErrors) => {
    let message = typeof errorMessage2 == "string" ? errorMessage2 : errorMessage2.value;
    throw rawErrors && (message = errorsToString(rawErrors)), new AbortError(message);
  }, configObject = await loadConfigurationFileContent(extension.configurationPath), { extensions } = ExtensionsArraySchema.parse(configObject);
  if (extensions) {
    let configuration = await parseConfigurationFile(UnifiedSchema, extension.configurationPath, abort2), extensionConfig = configuration.extensions.find((config2) => config2.handle === extension.handle);
    extensionConfig || abort2(`ERROR: Invalid handle
  - Expected handle: "${extension.handle}"
  - Configuration file path: ${relativizePath(extension.configurationPath)}.
  - Handles are immutable, you can't change them once they are set.`), configObject = { ...configuration, ...extensionConfig };
  }
  let newConfig = await parseConfigurationObjectAgainstSpecification(extension.specification, extension.configurationPath, configObject, abort2), previousConfig = extension.configuration;
  return extension.configuration = newConfig, {
    previousConfig,
    newConfig
  };
}

// ../app/dist/cli/services/dev/extension/bundler.js
var import_micromatch2 = __toESM(require_micromatch(), 1);
async function setupBundlerAndFileWatcher(options) {
  let { default: chokidar } = await import("./chokidar-4TKDAB27.js"), abortController = new AbortController2(), bundlers = [];
  return options.devOptions.extensions.filter((ext) => ext.isESBuildExtension).forEach(async (extension) => {
    bundlers.push(bundleExtension({
      minify: !1,
      outputPath: extension.outputPath,
      environment: "development",
      env: {
        ...options.devOptions.appDotEnvFile?.variables ?? {},
        APP_URL: options.devOptions.url
      },
      stdin: {
        contents: extension.getBundleExtensionStdinContent(),
        resolveDir: extension.directory,
        loader: "tsx"
      },
      stderr: options.devOptions.stderr,
      stdout: options.devOptions.stdout,
      watchSignal: abortController.signal,
      watch: async (result) => {
        let error = (result?.errors?.length ?? 0) > 0;
        outputDebug(`The Javascript bundle of the UI extension with ID ${extension.devUUID} has ${error ? "an error" : "changed"}`, error ? options.devOptions.stderr : options.devOptions.stdout);
        try {
          await options.payloadStore.updateExtension(extension, options.devOptions, {
            status: error ? "error" : "success"
          });
        } catch {
        }
      },
      sourceMaps: !0
    }));
    let localeWatcher = chokidar.watch(joinPath(extension.directory, "locales", "**.json")).on("change", (_event, path3) => {
      outputDebug(`Locale file at path ${path3} changed`, options.devOptions.stdout), options.payloadStore.updateExtension(extension, options.devOptions).then((_closed) => {
        outputDebug(`Notified extension ${extension.devUUID} about the locale change.`, options.devOptions.stdout);
      }).catch((_2) => {
      });
    });
    abortController.signal.addEventListener("abort", () => {
      outputDebug(`Closing locale file watching for extension with ID ${extension.devUUID}`, options.devOptions.stdout), localeWatcher.close().then(() => {
        outputDebug(`Locale file watching closed for extension with ${extension.devUUID}`, options.devOptions.stdout);
      }).catch((error) => {
        outputDebug(`Locale file watching failed to close for extension with ${extension.devUUID}: ${error.message}`, options.devOptions.stderr);
      });
    });
  }), await Promise.all(bundlers), {
    close: () => {
      abortController.abort();
    }
  };
}
async function setupExtensionWatcher({ extension, app, url, stdout, stderr, signal, onChange, onReloadAndBuildError }) {
  let { default: chokidar } = await import("./chokidar-4TKDAB27.js"), buildPaths = extension.watchBuildPaths;
  if (!buildPaths) {
    outputWarn(`Extension ${extension.localIdentifier} is missing the 'build.watch' setting, automatic builds are disabled.`, stdout);
    return;
  }
  let configurationPaths = await extension.watchConfigurationPaths();
  outputDebug(`
Watching extension: ${extension.localIdentifier} for:
Rebuild and Redeploy Paths:
	${buildPaths.join(`
	`)}

Redeploy Paths:
	${configurationPaths.join(`
	`)}
`.trim(), stdout);
  let listenForAbortOnWatcher2 = (watcher) => {
    signal.addEventListener("abort", () => {
      outputDebug(`Closing file watching for extension with ID ${extension.devUUID}`, stdout), watcher.close().then(() => {
        outputDebug(`File watching closed for extension with ${extension.devUUID}`, stdout);
      }).catch((error) => {
        outputDebug(`File watching failed to close for extension with ${extension.devUUID}: ${error.message}`, stderr);
      });
    });
  }, buildController, allPaths = [...buildPaths, ...configurationPaths], functionRebuildAndRedeployWatcher = chokidar.watch(allPaths, { ignored: "**/*.test.*" }).on("change", (path3) => {
    outputDebug(`Extension file at path ${path3} changed`, stdout), buildController && buildController.abort(), buildController = new AbortController2();
    let buildSignal = buildController.signal, shouldBuild = import_micromatch2.default.isMatch(path3, buildPaths);
    reloadAndbuildIfNecessary(extension, shouldBuild, {
      app,
      stdout,
      stderr,
      useTasks: !1,
      signal: buildSignal,
      environment: "development",
      appURL: url
    }).then(({ newConfig, previousConfig }) => {
      if (shouldBuild)
        return buildSignal.aborted ? void 0 : onChange();
      if (!deepCompare(newConfig, previousConfig))
        return onChange();
    }).catch((error) => onReloadAndBuildError(error));
  });
  listenForAbortOnWatcher2(functionRebuildAndRedeployWatcher);
}
async function reloadAndbuildIfNecessary(extension, build2, options) {
  let reloadedConfig = reloadExtensionConfig({ extension, stdout: options.stdout });
  return build2 ? extension.build(options).then(() => reloadedConfig) : reloadedConfig;
}

// ../app/dist/cli/services/dev/extension/server.js
init_cjs_shims();

// ../app/dist/cli/services/dev/extension/server/middlewares.js
init_cjs_shims();

// ../app/dist/cli/services/dev/extension/server/utilities.js
init_cjs_shims();

// ../../node_modules/.pnpm/h3@0.7.21/node_modules/h3/dist/index.mjs
init_cjs_shims();

// ../../node_modules/.pnpm/ufo@0.8.6/node_modules/ufo/dist/index.mjs
init_cjs_shims();
var r = String.fromCharCode;
var TRAILING_SLASH_RE = /\/$|\/\?/;
function hasTrailingSlash(input = "", queryParams = !1) {
  return queryParams ? TRAILING_SLASH_RE.test(input) : input.endsWith("/");
}
function withoutTrailingSlash(input = "", queryParams = !1) {
  if (!queryParams)
    return (hasTrailingSlash(input) ? input.slice(0, -1) : input) || "/";
  if (!hasTrailingSlash(input, !0))
    return input || "/";
  let [s0, ...s] = input.split("?");
  return (s0.slice(0, -1) || "/") + (s.length ? `?${s.join("?")}` : "");
}

// ../../node_modules/.pnpm/destr@1.2.2/node_modules/destr/dist/index.mjs
init_cjs_shims();

// ../../node_modules/.pnpm/radix3@0.1.2/node_modules/radix3/dist/index.mjs
init_cjs_shims();
var NODE_TYPES = {
  NORMAL: 0,
  WILDCARD: 1,
  PLACEHOLDER: 2
};
function createRouter(options = {}) {
  let ctx = {
    rootNode: createRadixNode(),
    staticRoutesMap: {}
  };
  if (options.routes)
    for (let path3 in options.routes)
      insert(ctx, path3, options.routes[path3]);
  return {
    ctx,
    lookup: (path3) => lookup2(ctx, path3),
    lookupAll: (prefix) => lookupAll(ctx, prefix),
    insert: (path3, data) => insert(ctx, path3, data),
    remove: (path3) => remove(ctx, path3)
  };
}
function lookup2(ctx, path3) {
  let staticPathNode = ctx.staticRoutesMap[path3];
  if (staticPathNode)
    return staticPathNode.data;
  let sections = path3.split("/"), params = {}, paramsFound = !1, wildcardNode = null, node = ctx.rootNode, wildCardParam = null;
  for (let i = 0; i < sections.length; i++) {
    let section = sections[i];
    node.wildcardChildNode !== null && (wildcardNode = node.wildcardChildNode, wildCardParam = sections.slice(i).join("/"));
    let nextNode = node.children[section];
    if (nextNode !== void 0)
      node = nextNode;
    else if (node = node.placeholderChildNode, node !== null)
      params[node.paramName] = section, paramsFound = !0;
    else
      break;
  }
  return (node === null || node.data === null) && wildcardNode !== null && (node = wildcardNode, params[node.paramName || "_"] = wildCardParam, paramsFound = !0), node ? paramsFound ? {
    ...node.data,
    params: paramsFound ? params : void 0
  } : node.data : null;
}
function lookupAll(ctx, prefix) {
  let sections = prefix.split("/"), node = ctx.rootNode, resultArray = [], endSections = sections.length - 1;
  for (let i = 0; i < sections.length; i++) {
    let section = sections[i];
    node.data && resultArray.push(node.data);
    let nextNode = node.children[section];
    if (nextNode !== void 0)
      node = nextNode;
    else if (i === endSections) {
      let keys = Object.keys(node.children);
      for (let j = 0; j < keys.length; j++) {
        let key = keys[j];
        key.startsWith(section) && (nextNode = node.children[key], nextNode.data && resultArray.push(nextNode.data));
      }
    }
  }
  return resultArray;
}
function insert(ctx, path3, data) {
  let isStaticRoute = !0, sections = path3.split("/"), node = ctx.rootNode, _unnamedPlaceholderCtr = 0;
  for (let i = 0; i < sections.length; i++) {
    let section = sections[i], children = node.children, childNode;
    if (childNode = children[section])
      node = childNode;
    else {
      let type = getNodeType2(section);
      childNode = createRadixNode({ type, parent: node }), node.children[section] = childNode, type === NODE_TYPES.PLACEHOLDER ? (childNode.paramName = section === "*" ? `_${_unnamedPlaceholderCtr++}` : section.slice(1), node.placeholderChildNode = childNode, isStaticRoute = !1) : type === NODE_TYPES.WILDCARD && (node.wildcardChildNode = childNode, childNode.paramName = section.substring(3) || "_", isStaticRoute = !1), node = childNode;
    }
  }
  return node.data = data, isStaticRoute === !0 && (ctx.staticRoutesMap[path3] = node), node;
}
function remove(ctx, path3) {
  let success = !1, sections = path3.split("/"), node = ctx.rootNode;
  for (let i = 0; i < sections.length; i++) {
    let section = sections[i];
    if (node = node.children[section], !node)
      return success;
  }
  if (node.data) {
    let lastSection = sections[sections.length - 1];
    if (node.data = null, Object.keys(node.children).length === 0) {
      let parentNode = node.parent;
      delete parentNode[lastSection], parentNode.wildcardChildNode = null, parentNode.placeholderChildNode = null;
    }
    success = !0;
  }
  return success;
}
function createRadixNode(options = {}) {
  return {
    type: options.type || NODE_TYPES.NORMAL,
    parent: options.parent || null,
    children: {},
    data: options.data || null,
    paramName: options.paramName || null,
    wildcardChildNode: null,
    placeholderChildNode: null
  };
}
function getNodeType2(str) {
  return str.startsWith("**") ? NODE_TYPES.WILDCARD : str[0] === ":" || str === "*" ? NODE_TYPES.PLACEHOLDER : NODE_TYPES.NORMAL;
}

// ../../node_modules/.pnpm/h3@0.7.21/node_modules/h3/dist/index.mjs
var H3Error = class extends Error {
  constructor() {
    super(...arguments), this.statusCode = 500, this.fatal = !1, this.unhandled = !1, this.statusMessage = "Internal Server Error";
  }
};
H3Error.__h3_error__ = !0;
function createError(input) {
  if (typeof input == "string")
    return new H3Error(input);
  if (isError(input))
    return input;
  let err2 = new H3Error(input.message ?? input.statusMessage, input.cause ? { cause: input.cause } : void 0);
  if ("stack" in input)
    try {
      Object.defineProperty(err2, "stack", { get() {
        return input.stack;
      } });
    } catch {
      try {
        err2.stack = input.stack;
      } catch {
      }
    }
  return input.statusCode && (err2.statusCode = input.statusCode), input.statusMessage && (err2.statusMessage = input.statusMessage), input.data && (err2.data = input.data), input.fatal !== void 0 && (err2.fatal = input.fatal), input.unhandled !== void 0 && (err2.unhandled = input.unhandled), err2;
}
function sendError(event, error, debug4) {
  if (event.res.writableEnded)
    return;
  let h3Error = isError(error) ? error : createError(error), responseBody = {
    statusCode: h3Error.statusCode,
    statusMessage: h3Error.statusMessage,
    stack: [],
    data: h3Error.data
  };
  debug4 && (responseBody.stack = (h3Error.stack || "").split(`
`).map((l) => l.trim())), !event.res.writableEnded && (event.res.statusCode = h3Error.statusCode, event.res.statusMessage = h3Error.statusMessage, event.res.setHeader("Content-Type", MIMES.json), event.res.end(JSON.stringify(responseBody, null, 2)));
}
function isError(input) {
  return input?.constructor?.__h3_error__ === !0;
}
var RawBodySymbol = Symbol.for("h3RawBody"), ParsedBodySymbol = Symbol.for("h3ParsedBody");
var MIMES = {
  html: "text/html",
  json: "application/json"
}, defer = typeof setImmediate < "u" ? setImmediate : (fn) => fn();
function send(event, data, type) {
  return type && defaultContentType(event, type), new Promise((resolve2) => {
    defer(() => {
      event.res.end(data), resolve2(void 0);
    });
  });
}
function defaultContentType(event, type) {
  type && !event.res.getHeader("Content-Type") && event.res.setHeader("Content-Type", type);
}
function sendRedirect(event, location2, code = 302) {
  event.res.statusCode = code, event.res.setHeader("Location", location2);
  let html = `<!DOCTYPE html><html><head><meta http-equiv="refresh" content="0; url=${location2.replace(/"/g, "%22")}"></head></html>`;
  return send(event, html, MIMES.html);
}
function isStream(data) {
  return data && typeof data == "object" && typeof data.pipe == "function" && typeof data.on == "function";
}
function sendStream(event, data) {
  return new Promise((resolve2, reject) => {
    data.pipe(event.res), data.on("end", () => resolve2(void 0)), data.on("error", (error) => reject(createError(error)));
  });
}
var H3Headers = class {
  constructor(init4) {
    init4 ? Array.isArray(init4) ? this._headers = Object.fromEntries(init4.map(([key, value]) => [key.toLowerCase(), value])) : init4 && "append" in init4 ? this._headers = Object.fromEntries([...init4.entries()]) : this._headers = Object.fromEntries(Object.entries(init4).map(([key, value]) => [key.toLowerCase(), value])) : this._headers = {};
  }
  append(name, value) {
    let _name = name.toLowerCase();
    this.set(_name, [this.get(_name), value].filter(Boolean).join(", "));
  }
  delete(name) {
    delete this._headers[name.toLowerCase()];
  }
  get(name) {
    return this._headers[name.toLowerCase()];
  }
  has(name) {
    return name.toLowerCase() in this._headers;
  }
  set(name, value) {
    this._headers[name.toLowerCase()] = String(value);
  }
  forEach(callbackfn) {
    Object.entries(this._headers).forEach(([key, value]) => callbackfn(value, key, this));
  }
}, H3Response = class _H3Response {
  constructor(body = null, init4 = {}) {
    this.body = null, this.type = "default", this.bodyUsed = !1, this.headers = new H3Headers(init4.headers), this.status = init4.status ?? 200, this.statusText = init4.statusText || "", this.redirected = !!init4.status && [301, 302, 307, 308].includes(init4.status), this._body = body, this.url = "", this.ok = this.status < 300 && this.status > 199;
  }
  clone() {
    return new _H3Response(this.body, {
      headers: this.headers,
      status: this.status,
      statusText: this.statusText
    });
  }
  arrayBuffer() {
    return Promise.resolve(this._body);
  }
  blob() {
    return Promise.resolve(this._body);
  }
  formData() {
    return Promise.resolve(this._body);
  }
  json() {
    return Promise.resolve(this._body);
  }
  text() {
    return Promise.resolve(this._body);
  }
}, H3Event = class {
  constructor(req, res) {
    this.__is_event__ = !0, this.context = {}, this.req = req, this.res = res, this.event = this, req.event = this, req.context = this.context, req.req = req, req.res = res, res.event = this, res.res = res, res.req = res.req || {}, res.req.res = res, res.req.req = req;
  }
  respondWith(r2) {
    Promise.resolve(r2).then((_response) => {
      if (this.res.writableEnded)
        return;
      let response = _response instanceof H3Response ? _response : new H3Response(_response);
      if (response.headers.forEach((value, key) => {
        this.res.setHeader(key, value);
      }), response.status && (this.res.statusCode = response.status), response.statusText && (this.res.statusMessage = response.statusText), response.redirected && this.res.setHeader("Location", response.url), !response._body)
        return this.res.end();
      if (typeof response._body == "string" || "buffer" in response._body || "byteLength" in response._body)
        return this.res.end(response._body);
      response.headers.has("content-type") || response.headers.set("content-type", MIMES.json), this.res.end(JSON.stringify(response._body));
    });
  }
};
function createEvent(req, res) {
  return new H3Event(req, res);
}
function callHandler(handler, req, res) {
  let isMiddleware = handler.length > 2;
  return new Promise((resolve2, reject) => {
    let next = (err2) => (isMiddleware && (res.off("close", next), res.off("error", next)), err2 ? reject(createError(err2)) : resolve2(void 0));
    try {
      let returned = handler(req, res, next);
      isMiddleware && returned === void 0 ? (res.once("close", next), res.once("error", next)) : resolve2(returned);
    } catch (err2) {
      next(err2);
    }
  });
}
function defineEventHandler(handler) {
  return handler.__is_handler__ = !0, handler;
}
var eventHandler = defineEventHandler;
function isEventHandler(input) {
  return "__is_handler__" in input;
}
function toEventHandler(handler) {
  if (isEventHandler(handler))
    return handler;
  if (typeof handler != "function")
    throw new TypeError("Invalid handler. It should be a function:", handler);
  return eventHandler((event) => callHandler(handler, event.req, event.res));
}
function defineLazyEventHandler(factory) {
  let _promise, _resolved, resolveHandler = () => _resolved ? Promise.resolve(_resolved) : (_promise || (_promise = Promise.resolve(factory()).then((r2) => {
    let handler = r2.default || r2;
    if (typeof handler != "function")
      throw new TypeError("Invalid lazy handler result. It should be a function:", handler);
    return _resolved = toEventHandler(r2.default || r2), _resolved;
  })), _promise);
  return eventHandler((event) => _resolved ? _resolved(event) : resolveHandler().then((handler) => handler(event)));
}
var lazyEventHandler = defineLazyEventHandler;
function createApp(options = {}) {
  let stack = [], handler = createAppEventHandler(stack, options), nodeHandler = async function(req, res) {
    let event = createEvent(req, res);
    try {
      await handler(event);
    } catch (_error) {
      let error = createError(_error);
      isError(_error) || (error.unhandled = !0), options.onError ? await options.onError(error, event) : ((error.unhandled || error.fatal) && console.error("[h3]", error.fatal ? "[fatal]" : "[unhandled]", error), await sendError(event, error, !!options.debug));
    }
  }, app = nodeHandler;
  return app.nodeHandler = nodeHandler, app.stack = stack, app.handler = handler, app.use = (arg1, arg2, arg3) => use2(app, arg1, arg2, arg3), app;
}
function use2(app, arg1, arg2, arg3) {
  return Array.isArray(arg1) ? arg1.forEach((i) => use2(app, i, arg2, arg3)) : Array.isArray(arg2) ? arg2.forEach((i) => use2(app, arg1, i, arg3)) : typeof arg1 == "string" ? app.stack.push(normalizeLayer({ ...arg3, route: arg1, handler: arg2 })) : typeof arg1 == "function" ? app.stack.push(normalizeLayer({ ...arg2, route: "/", handler: arg1 })) : app.stack.push(normalizeLayer({ ...arg1 })), app;
}
function createAppEventHandler(stack, options) {
  let spacing = options.debug ? 2 : void 0;
  return eventHandler(async (event) => {
    event.req.originalUrl = event.req.originalUrl || event.req.url || "/";
    let reqUrl = event.req.url || "/";
    for (let layer of stack) {
      if (layer.route.length > 1) {
        if (!reqUrl.startsWith(layer.route))
          continue;
        event.req.url = reqUrl.slice(layer.route.length) || "/";
      } else
        event.req.url = reqUrl;
      if (layer.match && !layer.match(event.req.url, event))
        continue;
      let val = await layer.handler(event);
      if (event.res.writableEnded)
        return;
      let type = typeof val;
      if (type === "string")
        return send(event, val, MIMES.html);
      if (isStream(val))
        return sendStream(event, val);
      if (val === null)
        return event.res.statusCode = 204, send(event);
      if (type === "object" || type === "boolean" || type === "number") {
        if (val.buffer)
          return send(event, val);
        if (val instanceof Error)
          throw createError(val);
        return send(event, JSON.stringify(val, null, spacing), MIMES.json);
      }
    }
    if (!event.res.writableEnded)
      throw createError({ statusCode: 404, statusMessage: "Not Found" });
  });
}
function normalizeLayer(input) {
  let handler = input.handler || input.handle;
  return handler.handler && (handler = handler.handler), input.lazy ? handler = lazyEventHandler(handler) : isEventHandler(handler) || (handler = toEventHandler(handler)), {
    route: withoutTrailingSlash(input.route),
    match: input.match,
    handler
  };
}
var RouterMethods = ["connect", "delete", "get", "head", "options", "post", "put", "trace", "patch"];
function createRouter2() {
  let _router = createRouter({}), routes = {}, router = {}, addRoute = (path3, handler, method) => {
    let route = routes[path3];
    return route || (routes[path3] = route = { handlers: {} }, _router.insert(path3, route)), Array.isArray(method) ? method.forEach((m) => addRoute(path3, handler, m)) : route.handlers[method] = toEventHandler(handler), router;
  };
  router.use = router.add = (path3, handler, method) => addRoute(path3, handler, method || "all");
  for (let method of RouterMethods)
    router[method] = (path3, handle) => router.add(path3, handle, method);
  return router.handler = eventHandler((event) => {
    let path3 = event.req.url || "/", queryUrlIndex = path3.lastIndexOf("?");
    queryUrlIndex > -1 && (path3 = path3.substring(0, queryUrlIndex));
    let matched = _router.lookup(path3);
    if (!matched)
      throw createError({
        statusCode: 404,
        name: "Not Found",
        statusMessage: `Cannot find any route matching ${event.req.url || "/"}.`
      });
    let method = (event.req.method || "get").toLowerCase(), handler = matched.handlers[method] || matched.handlers.all;
    if (!handler)
      throw createError({
        statusCode: 405,
        name: "Method Not Allowed",
        statusMessage: `Method ${method} is not allowed on this route.`
      });
    let params = matched.params || {};
    return event.event.context.params = params, event.req.context.params = params, handler(event);
  }), router;
}

// ../app/dist/cli/services/dev/extension/server/utilities.js
function getRedirectUrl(extension, options) {
  let { url: resourceUrl } = getUIExtensionResourceURL(extension.configuration.type, options);
  if (extension.surface === "checkout" && resourceUrl) {
    let rawUrl = new URL(`https://${options.storeFqdn}/`);
    return rawUrl.pathname = resourceUrl, rawUrl.searchParams.append("dev", `${options.url}/extensions`), rawUrl.toString();
  } else {
    let rawUrl = new URL(`https://${options.storeFqdn}/`);
    return rawUrl.pathname = "admin/extensions-dev", rawUrl.searchParams.append("url", getExtensionUrl(extension, options)), rawUrl.toString();
  }
}
function getExtensionPointRedirectUrl(requestedTarget, extension, options) {
  let surface = getExtensionPointTargetSurface(requestedTarget), rawUrl = new URL(`https://${options.storeFqdn}/`);
  switch (surface) {
    case "checkout":
      rawUrl.pathname = options.checkoutCartUrl, rawUrl.searchParams.append("dev", `${options.url}/extensions`);
      break;
    case "admin":
      rawUrl.pathname = "admin/extensions-dev", rawUrl.searchParams.append("url", getExtensionUrl(extension, options)), rawUrl.searchParams.append("target", requestedTarget);
      break;
    case "customer-accounts":
      rawUrl = getCustomerAccountsRedirectUrl(extension, options, requestedTarget);
      break;
    default:
      return;
  }
  return rawUrl.toString();
}
function getCustomerAccountsRedirectUrl(extension, options, requestedTarget = "") {
  let origin = `${options.url}/extensions`, storeId = options.storeId, [_2, ...storeDomainParts] = options.storeFqdn.split("."), customerAccountHost = isSpinEnvironment() ? storeDomainParts.join(".") : "shopify.com", rawUrl = new URL(`https://${customerAccountHost}/${storeId}/account/extensions-development`);
  return rawUrl.searchParams.append("origin", origin), rawUrl.searchParams.append("extensionId", extension.devUUID), rawUrl.searchParams.append("source", "CUSTOMER_ACCOUNT_EXTENSION"), rawUrl.searchParams.append("appId", options.id ?? ""), requestedTarget !== "" && rawUrl.searchParams.append("target", requestedTarget), rawUrl;
}
function getExtensionUrl(extension, options) {
  let extensionUrl = new URL(options.url);
  return extensionUrl.pathname = `/extensions/${extension.devUUID}`, extensionUrl.toString();
}
function sendError2(response, error) {
  sendError(response.event, createError(error));
}

// ../app/dist/cli/services/dev/extension/templates.js
init_cjs_shims();

// ../cli-kit/dist/public/node/liquid.js
init_cjs_shims();
var import_liquidjs = __toESM(require_liquid_node_cjs());
function renderLiquidTemplate(templateContent, data) {
  let engine = new import_liquidjs.Liquid();
  return engine.render(engine.parse(templateContent), data);
}
async function recursiveLiquidTemplateCopy(from, to, data) {
  outputDebug(outputContent`Copying template from directory ${outputToken.path(from)} to ${outputToken.path(to)}`);
  let sortedTemplateFiles = (await glob(joinPath(from, "**/*"), { dot: !0 })).map((path3) => path3.split("/")).sort((lhs, rhs) => lhs.length < rhs.length ? 1 : -1).map((components) => components.join("/"));
  await Promise.all(sortedTemplateFiles.map(async (templateItemPath) => {
    let outputPath = await renderLiquidTemplate(joinPath(to, relativePath(from, templateItemPath)), data);
    if (await isDirectory(templateItemPath))
      await mkdir(outputPath);
    else if (templateItemPath.endsWith(".liquid")) {
      await mkdir(dirname(outputPath));
      let content = await readFile(templateItemPath), contentOutput = await renderLiquidTemplate(content, data), isExecutable = await fileHasExecutablePermissions(templateItemPath), outputPathWithoutLiquid = outputPath.replace(".liquid", "");
      await copyFile(templateItemPath, outputPathWithoutLiquid), await writeFile(outputPathWithoutLiquid, contentOutput), isExecutable && await chmod(outputPathWithoutLiquid, 493);
    } else if (templateItemPath.endsWith(".raw")) {
      let outputPathWithoutRaw = outputPath.replace(".raw", "");
      await copyFile(templateItemPath, outputPathWithoutRaw);
    } else
      await copyFile(templateItemPath, outputPath);
  }));
}

// ../app/dist/cli/services/dev/extension/templates.js
var TemplateNotFoundError = class extends BugError {
  constructor(options) {
    super(`Couldn't find template ${options.template} for extension surface ${options.extensionSurface}`);
  }
};
async function getHTML(options) {
  let templatePath = await getTemplatePath(options), templateContent = await readFile(templatePath);
  return renderLiquidTemplate(templateContent, options.data);
}
async function getTemplatePath(options) {
  let templatesDirectory = await getTemplatesDirectory(), globPatterns = [];
  options.extensionSurface && globPatterns.push(joinPath(templatesDirectory, `${options.extensionSurface}/${options.template}.html.liquid`)), globPatterns.push(joinPath(templatesDirectory, `${options.template}.html.liquid`));
  let globMatches = await glob(globPatterns);
  if (globMatches.length === 0)
    throw new TemplateNotFoundError(options);
  return globMatches[0];
}
async function getTemplatesDirectory() {
  return await findPathUp("templates/ui-extensions/html", {
    type: "directory",
    cwd: moduleDirectory(import.meta.url)
  });
}

// ../app/dist/cli/services/dev/extension/server/middlewares.js
function corsMiddleware(_request, response, next) {
  response.setHeader("Access-Control-Allow-Origin", "*"), response.setHeader("Access-Control-Allow-Methods", "GET, OPTIONS"), response.setHeader("Access-Control-Allow-Headers", "Accept, Content-Type, Content-Length, Accept-Encoding, X-CSRF-Token, Authorization, ngrok-skip-browser-warning"), next();
}
function noCacheMiddleware(_request, response, next) {
  response.setHeader("Cache-Control", "no-cache"), next();
}
async function redirectToDevConsoleMiddleware(_request, response, _next) {
  await sendRedirect(response.event, "/extensions/dev-console", 307);
}
async function fileServerMiddleware(_request, response, _next, options) {
  let { filePath } = options;
  if (await isDirectory(filePath) && (filePath += filePath.endsWith("/") ? "index.html" : "/index.html"), !await fileExists(filePath))
    return sendError2(response, { statusCode: 404, statusMessage: `Not Found: ${filePath}` });
  let fileContent = await readFile(filePath), extensionToContent = {
    ".ico": "image/x-icon",
    ".html": "text/html",
    ".js": "text/javascript",
    ".json": "application/json",
    ".wasm": "application/wasm",
    ".css": "text/css",
    ".png": "image/png",
    ".jpg": "image/jpeg",
    ".jpeg": "image/jpeg",
    ".wav": "audio/wav",
    ".mp3": "audio/mpeg",
    ".svg": "image/svg+xml",
    ".pdf": "application/pdf",
    ".doc": "application/msword"
  }, extensionName = extname(filePath), contentType = extensionToContent[extensionName] || "text/plain";
  response.setHeader("Content-Type", contentType), response.writeHead(200), response.end(fileContent);
}
function getExtensionAssetMiddleware({ devOptions }) {
  return async (request2, response, next) => {
    let { extensionId, assetPath } = request2.context.params, extension = devOptions.extensions.find((extension2) => extension2.devUUID === extensionId);
    if (!extension)
      return sendError2(response, {
        statusCode: 404,
        statusMessage: `Extension with id ${extensionId} not found`
      });
    let buildDirectory = extension.outputPath.replace(`${extension.outputFileName}`, "");
    return fileServerMiddleware(request2, response, next, {
      filePath: joinPath(buildDirectory, assetPath)
    });
  };
}
function getExtensionsPayloadMiddleware({ payloadStore }) {
  return async (_request, response, _next) => {
    response.setHeader("content-type", "application/json"), response.end(JSON.stringify(payloadStore.getRawPayload()));
  };
}
async function devConsoleIndexMiddleware(request2, response, next) {
  let rootDirectory = await findPathUp(joinPath("assets", "dev-console"), {
    type: "directory",
    cwd: moduleDirectory(import.meta.url)
  });
  return rootDirectory ? fileServerMiddleware(request2, response, next, {
    filePath: rootDirectory
  }) : sendError2(response, {
    statusCode: 404,
    statusMessage: "Could not find root directory for dev console"
  });
}
async function devConsoleAssetsMiddleware(request2, response, next) {
  let { assetPath } = request2.context.params, rootDirectory = await findPathUp(joinPath("assets", "dev-console", "extensions", "dev-console", "assets"), {
    type: "directory",
    cwd: moduleDirectory(import.meta.url)
  });
  return rootDirectory ? fileServerMiddleware(request2, response, next, {
    filePath: joinPath(rootDirectory, assetPath)
  }) : sendError2(response, {
    statusCode: 404,
    statusMessage: "Could not find root directory for dev console asset"
  });
}
function getLogMiddleware({ devOptions }) {
  return async (request2, _response, next) => {
    outputDebug(`UI extensions server received a ${request2.method} request to URL ${request2.url}`, devOptions.stdout), next();
  };
}
function getExtensionPayloadMiddleware({ devOptions }) {
  return async (request2, response, _next) => {
    let extensionID = request2.context.params.extensionId, extension = devOptions.extensions.find((extension2) => extension2.devUUID === extensionID);
    if (!extension)
      return sendError2(response, {
        statusCode: 404,
        statusMessage: `Extension with id ${extensionID} not found`
      });
    if (request2.headers.accept?.startsWith("text/html"))
      if (extension.type === "checkout_post_purchase") {
        let body = await getHTML({
          data: {
            url: getExtensionUrl(extension, devOptions)
          },
          template: "index",
          extensionSurface: "post_purchase"
        });
        await send(response.event, body);
        return;
      } else {
        let url = getRedirectUrl(extension, devOptions);
        await sendRedirect(response.event, url, 307);
        return;
      }
    response.setHeader("content-type", "application/json"), response.end(JSON.stringify({
      app: {
        apiKey: devOptions.apiKey
      },
      version: devOptions.manifestVersion,
      root: {
        url: new URL("/extensions", devOptions.url).toString()
      },
      socket: {
        url: getWebsocketUrl(devOptions)
      },
      devConsole: {
        url: new URL("/extensions/dev-console", devOptions.url).toString()
      },
      store: devOptions.storeFqdn,
      extension: await getUIExtensionPayload(extension, devOptions)
    }));
  };
}
function getExtensionPointMiddleware({ devOptions }) {
  return async (request2, response, _next) => {
    let extensionID = request2.context.params.extensionId, requestedTarget = request2.context.params.extensionPointTarget, extension = devOptions.extensions.find((extension2) => extension2.devUUID === extensionID);
    if (!extension)
      return sendError2(response, {
        statusCode: 404,
        statusMessage: `Extension with id ${extensionID} not found`
      });
    if (!extension.hasExtensionPointTarget(requestedTarget))
      return sendError2(response, {
        statusCode: 404,
        statusMessage: `Extension with id ${extensionID} has not configured the "${requestedTarget}" extension target`
      });
    let url = getExtensionPointRedirectUrl(requestedTarget, extension, devOptions);
    if (!url)
      return sendError2(response, {
        statusCode: 404,
        statusMessage: `Redirect url can't be constructed for extension with id ${extensionID} and extension target "${requestedTarget}"`
      });
    await sendRedirect(response.event, url, 307);
  };
}
function getWebsocketUrl(devOptions) {
  let socket = new URL("/extensions", devOptions.url);
  return socket.protocol = "wss:", socket.toString();
}

// ../app/dist/cli/services/dev/extension/server.js
import { createServer } from "http";
function setupHTTPServer(options) {
  let httpApp = createApp(), httpRouter = createRouter2();
  httpApp.use(getLogMiddleware(options)), httpApp.use(corsMiddleware), httpApp.use(noCacheMiddleware), httpRouter.use("/extensions/dev-console", devConsoleIndexMiddleware), httpRouter.use("/extensions/dev-console/assets/**:assetPath", devConsoleAssetsMiddleware), httpRouter.use("/extensions/:extensionId", getExtensionPayloadMiddleware(options)), httpRouter.use("/extensions/:extensionId/", getExtensionPayloadMiddleware(options)), httpRouter.use("/extensions/:extensionId/:extensionPointTarget", getExtensionPointMiddleware(options)), httpRouter.use("/extensions/:extensionId/assets/**:assetPath", getExtensionAssetMiddleware(options)), httpRouter.use("/extensions", getExtensionsPayloadMiddleware(options)), httpRouter.use("/extensions/", getExtensionsPayloadMiddleware(options)), httpRouter.use("/", redirectToDevConsoleMiddleware), httpApp.use(httpRouter);
  let httpServer = createServer(httpApp);
  return httpServer.listen(options.devOptions.port), httpServer;
}

// ../app/dist/cli/services/dev/extension.js
async function devUIExtensions(options) {
  let payloadStoreOptions = {
    ...options,
    websocketURL: getWebSocketUrl(options.url)
  }, payloadStoreRawPayload = await getExtensionsPayloadStoreRawPayload(payloadStoreOptions), payloadStore = new ExtensionsPayloadStore(payloadStoreRawPayload, payloadStoreOptions);
  outputDebug("Setting up the UI extensions HTTP server...", options.stdout);
  let httpServer = setupHTTPServer({ devOptions: options, payloadStore });
  outputDebug("Setting up the UI extensions Websocket server...", options.stdout);
  let websocketConnection = setupWebsocketConnection({ ...options, httpServer, payloadStore });
  outputDebug("Setting up the UI extensions bundler and file watching...", options.stdout);
  let fileWatcher = await setupBundlerAndFileWatcher({ devOptions: options, payloadStore });
  options.signal.addEventListener("abort", () => {
    outputDebug("Closing the UI extensions dev server..."), fileWatcher.close(), websocketConnection.close(), httpServer.close();
  });
}
function getWebSocketUrl(url) {
  let websocketURL = new URL("/extensions", url);
  return websocketURL.protocol = "wss:", websocketURL.toString();
}

// ../app/dist/cli/services/dev/processes/previewable-extension.js
var MANIFEST_VERSION = "3", launchPreviewableExtensionProcess = async ({ stderr, stdout, abortSignal }, { apiKey, storeFqdn, storeId, subscriptionProductUrl, port, cartUrl, proxyUrl, appName, appDotEnvFile, appId, grantedScopes, previewableExtensions, appDirectory }) => {
  await devUIExtensions({
    appName,
    appDotEnvFile,
    appDirectory,
    id: appId,
    extensions: previewableExtensions,
    stdout,
    stderr,
    signal: abortSignal,
    url: proxyUrl,
    port,
    storeFqdn,
    storeId,
    apiKey,
    grantedScopes,
    checkoutCartUrl: cartUrl,
    subscriptionProductUrl,
    manifestVersion: MANIFEST_VERSION
  });
};
async function setupPreviewableExtensionsProcess({ allExtensions, storeFqdn, checkoutCartUrl, ...options }) {
  let previewableExtensions = allExtensions.filter((ext) => ext.isPreviewable);
  if (previewableExtensions.length === 0)
    return;
  let cartUrl = await buildCartURLIfNeeded(previewableExtensions, storeFqdn, checkoutCartUrl);
  return {
    prefix: "extensions",
    type: "previewable-extension",
    function: launchPreviewableExtensionProcess,
    options: {
      pathPrefix: "/extensions",
      port: -1,
      storeFqdn,
      previewableExtensions,
      cartUrl,
      ...options
    }
  };
}

// ../app/dist/cli/services/dev/processes/draftable-extension.js
init_cjs_shims();

// ../cli-kit/dist/public/common/retry.js
init_cjs_shims();
async function performActionWithRetryAfterRecovery(performAction, recoveryProcedure) {
  let returnVal;
  try {
    return returnVal = await performAction(), returnVal;
  } catch {
    return await recoveryProcedure(), performAction();
  }
}

// ../app/dist/cli/services/dev/processes/draftable-extension.js
var pushUpdatesForDraftableExtensions = async ({ stderr, stdout, abortSignal: signal }, { extensions, developerPlatformClient, apiKey, remoteExtensionIds: remoteExtensions, proxyUrl, localApp: app }) => {
  await installJavy(app);
  async function refreshToken2() {
    await developerPlatformClient.refreshToken();
  }
  await Promise.all(extensions.map(async (extension) => useConcurrentOutputContext({ outputPrefix: extension.outputPrefix }, async () => {
    await extension.build({
      app,
      stdout,
      stderr,
      useTasks: !1,
      signal,
      environment: "development"
    });
    let registrationId = remoteExtensions[extension.localIdentifier];
    if (!registrationId)
      throw new AbortError(`Extension ${extension.localIdentifier} not found on remote app.`);
    return await updateExtensionDraft({
      extension,
      developerPlatformClient,
      apiKey,
      registrationId,
      stdout,
      stderr,
      appConfiguration: app.configuration
    }), setupExtensionWatcher({
      extension,
      app,
      url: proxyUrl,
      stdout,
      stderr,
      signal,
      onChange: async () => performActionWithRetryAfterRecovery(async () => updateExtensionDraft({
        extension,
        developerPlatformClient,
        apiKey,
        registrationId,
        stdout,
        stderr,
        appConfiguration: app.configuration
      }), refreshToken2),
      onReloadAndBuildError: async (error) => {
        let draftUpdateErrorMessage = extension.draftMessages.errorMessage;
        draftUpdateErrorMessage && outputWarn(`${draftUpdateErrorMessage}: ${error.message}`, stdout);
      }
    });
  })));
};
async function setupDraftableExtensionsProcess({ localApp, apiKey, developerPlatformClient, remoteApp, ...options }) {
  let draftableExtensions = localApp.draftableExtensions;
  if (draftableExtensions.length === 0)
    return;
  let prodEnvIdentifiers = getAppIdentifiers({ app: localApp }, developerPlatformClient), { extensionIds: remoteExtensionIds, extensions: extensionsUuids } = await ensureDeploymentIdsPresence({
    app: localApp,
    remoteApp,
    appId: apiKey,
    appName: remoteApp.title,
    force: !0,
    release: !0,
    developerPlatformClient,
    envIdentifiers: prodEnvIdentifiers,
    includeDraftExtensions: !0
  });
  return localApp.updateExtensionUUIDS(extensionsUuids), {
    type: "draftable-extension",
    prefix: "extensions",
    function: pushUpdatesForDraftableExtensions,
    options: {
      localApp,
      apiKey,
      developerPlatformClient,
      ...options,
      extensions: draftableExtensions,
      remoteExtensionIds
    }
  };
}

// ../app/dist/cli/services/dev/processes/uninstall-webhook.js
init_cjs_shims();

// ../app/dist/cli/services/dev/processes/utils.js
init_cjs_shims();
function frontAndBackendConfig(webs) {
  let frontendConfig = webs.find((web2) => isWebType(web2, WebType.Frontend)), backendConfig = webs.find((web2) => isWebType(web2, WebType.Backend));
  return { frontendConfig, backendConfig };
}

// ../app/dist/cli/services/webhook/send-app-uninstalled-webhook.js
init_cjs_shims();

// ../app/dist/cli/services/webhook/trigger-local-webhook.js
init_cjs_shims();
async function triggerLocalWebhook(address, body, headers) {
  let options = {
    method: "POST",
    body,
    headers: {
      "Content-Type": "application/json",
      ...JSON.parse(headers)
    }
  }, response = await fetch2(address, options);
  return response.status >= 200 && response.status < 300;
}

// ../app/dist/cli/services/webhook/trigger-flags.js
init_cjs_shims();
var DELIVERY_METHOD = {
  LOCALHOST: "localhost",
  HTTP: "http",
  PUBSUB: "google-pub-sub",
  EVENTBRIDGE: "event-bridge"
}, PROTOCOL = {
  LOCALHOST: new RegExp("^http:", "i"),
  HTTP: new RegExp("^https:", "i"),
  PUBSUB: new RegExp("^pubsub:"),
  EVENTBRIDGE: new RegExp("^arn:aws:events:")
};
function isAddressAllowedForDeliveryMethod(address, deliveryMethod) {
  let expectedDeliveryMethod = deliveryMethodForAddress(address);
  return expectedDeliveryMethod === DELIVERY_METHOD.LOCALHOST && deliveryMethod === DELIVERY_METHOD.HTTP ? !0 : expectedDeliveryMethod === deliveryMethod;
}
function isLocal(address) {
  return PROTOCOL.LOCALHOST.test(address) ? new URL(address.toLowerCase()).hostname === "localhost" : !1;
}
function validateAddressMethod(address, deliveryMethod) {
  if (!isAddressAllowedForDeliveryMethod(address, deliveryMethod))
    throw new AbortError(`Can't deliver your webhook payload to this address using '${deliveryMethod}'`, "Use a valid URL for address", deliveryMethodInstructions(deliveryMethod));
  let method = deliveryMethod;
  return isLocal(address) && (method = DELIVERY_METHOD.LOCALHOST), [address.trim(), method];
}
function deliveryMethodInstructions(method) {
  return method === DELIVERY_METHOD.HTTP ? [
    "For remote HTTP testing, use a URL that starts with https://",
    "For local HTTP testing, use http://localhost:{port}/{url-path}"
  ] : method === DELIVERY_METHOD.PUBSUB ? ["For Google Pub/Sub, use pubsub://{project-id}:{topic-id}"] : method === DELIVERY_METHOD.EVENTBRIDGE ? ["For Amazon EventBridge, use an Amazon Resource Name (ARN) starting with arn:aws:events:"] : [];
}
function parseApiVersionFlag(passedVersion, availableVersions) {
  if (availableVersions.includes(passedVersion))
    return passedVersion;
  throw new AbortError(`Api Version '${passedVersion}' does not exist`, `Allowed values: ${availableVersions.join(", ")}`, ["Try again with a valid api-version value"]);
}
function parseTopicFlag(passedTopic, apiVersion, availableTopics) {
  if (availableTopics.length === 0)
    throw new AbortError(`No topics found for '${apiVersion}'`);
  let translatedTopic = equivalentTopic(passedTopic.trim(), availableTopics);
  if (translatedTopic === void 0)
    throw new AbortError(`Topic '${passedTopic}' does not exist for ApiVersion '${apiVersion}'`, `Allowed values: ${availableTopics.join(", ")}`, ["Try again with a valid api-version - topic pair"]);
  return translatedTopic;
}
function equivalentTopic(passedTopic, availableTopics) {
  return availableTopics.includes(passedTopic) ? passedTopic : availableTopics.find((elm) => elm.toUpperCase().replace("/", "_") === passedTopic);
}
function deliveryMethodForAddress(address) {
  if (address) {
    if (PROTOCOL.PUBSUB.test(address))
      return DELIVERY_METHOD.PUBSUB;
    if (PROTOCOL.EVENTBRIDGE.test(address))
      return DELIVERY_METHOD.EVENTBRIDGE;
    if (isLocal(address))
      return DELIVERY_METHOD.LOCALHOST;
    if (PROTOCOL.HTTP.test(address))
      return DELIVERY_METHOD.HTTP;
  }
}

// ../app/dist/cli/services/webhook/send-app-uninstalled-webhook.js
async function sendUninstallWebhookToAppServer(options) {
  let variables = {
    topic: "app/uninstalled",
    api_version: (await requestApiVersions(options.developerPlatformClient))[1],
    address: options.address,
    delivery_method: DELIVERY_METHOD.LOCALHOST,
    shared_secret: options.sharedSecret
  }, sample = await getWebhookSample(options.developerPlatformClient, variables);
  options.stdout.write("Sending APP_UNINSTALLED webhook to app server"), await sleep(3);
  let result = await triggerWebhook(options, sample);
  return options.stdout.write(result ? "APP_UNINSTALLED webhook delivered" : "APP_UNINSTALLED webhook delivery failed"), result;
}
async function triggerWebhook(options, sample) {
  let tries = 0;
  for (; tries < 3; ) {
    try {
      return await triggerLocalWebhook(options.address, sample.samplePayload, JSON.stringify({
        ...JSON.parse(sample.headers),
        "X-Shopify-Shop-Domain": options.storeFqdn
      }));
    } catch (error) {
      if (error instanceof FetchError && error.code === "ECONNREFUSED")
        tries < 3 && (options.stdout.write("App isn't responding yet, retrying in 5 seconds"), await sleep(5));
      else
        throw error;
    }
    tries++;
  }
  return options.stdout.write("App hasn't started in time, giving up"), !1;
}

// ../app/dist/cli/services/dev/processes/uninstall-webhook.js
var sendWebhook = async ({ stdout }, options) => {
  await sendUninstallWebhookToAppServer({
    stdout,
    developerPlatformClient: options.developerPlatformClient,
    address: `http://localhost:${options.deliveryPort}${options.webhooksPath}`,
    sharedSecret: options.apiSecret,
    storeFqdn: options.storeFqdn
  });
};
function setupSendUninstallWebhookProcess({ webs, remoteAppUpdated, backendPort, frontendPort, ...options }) {
  let { backendConfig, frontendConfig } = frontAndBackendConfig(webs), webhooksPath = webs.map(({ configuration }) => configuration.webhooks_path).find((path3) => path3) || "/api/webhooks";
  if (webhooksPath && remoteAppUpdated && (frontendConfig || backendConfig))
    return {
      type: "send-webhook",
      prefix: "webhooks",
      function: sendWebhook,
      options: {
        deliveryPort: backendConfig ? backendPort : frontendPort,
        webhooksPath,
        ...options
      }
    };
}

// ../app/dist/cli/services/dev/processes/graphiql.js
init_cjs_shims();

// ../app/dist/cli/services/dev/graphiql/server.js
init_cjs_shims();

// ../app/dist/cli/services/dev/graphiql/templates/graphiql.js
init_cjs_shims();
var import_react5 = __toESM(require_react(), 1), import_server2 = __toESM(require_server_node(), 1), import_polaris = __toESM(require_cjs5(), 1);

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/index.mjs
init_cjs_shims();

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/AlertCircleIcon.svg.mjs
init_cjs_shims();
var import_react = __toESM(require_react2(), 1), SvgAlertCircleIcon = function(props) {
  return /* @__PURE__ */ import_react.default.createElement("svg", Object.assign({
    viewBox: "0 0 20 20"
  }, props), /* @__PURE__ */ import_react.default.createElement("path", {
    d: "M10 6a.75.75 0 0 1 .75.75v3.5a.75.75 0 0 1-1.5 0v-3.5a.75.75 0 0 1 .75-.75Z"
  }), /* @__PURE__ */ import_react.default.createElement("path", {
    d: "M11 13a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z"
  }), /* @__PURE__ */ import_react.default.createElement("path", {
    fillRule: "evenodd",
    d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-1.5 0a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0Z"
  }));
};
SvgAlertCircleIcon.displayName = "AlertCircleIcon";

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/DisabledIcon.svg.mjs
init_cjs_shims();
var import_react2 = __toESM(require_react2(), 1), SvgDisabledIcon = function(props) {
  return /* @__PURE__ */ import_react2.default.createElement("svg", Object.assign({
    viewBox: "0 0 20 20"
  }, props), /* @__PURE__ */ import_react2.default.createElement("path", {
    fillRule: "evenodd",
    d: "M17 10a7 7 0 1 1-14 0 7 7 0 0 1 14 0Zm-3.677 4.383a5.5 5.5 0 0 1-7.706-7.706l7.706 7.706Zm1.06-1.06-7.706-7.706a5.5 5.5 0 0 1 7.706 7.706Z"
  }));
};
SvgDisabledIcon.displayName = "DisabledIcon";

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/icons/LinkIcon.svg.mjs
init_cjs_shims();
var import_react3 = __toESM(require_react2(), 1), SvgLinkIcon = function(props) {
  return /* @__PURE__ */ import_react3.default.createElement("svg", Object.assign({
    viewBox: "0 0 20 20"
  }, props), /* @__PURE__ */ import_react3.default.createElement("path", {
    fillRule: "evenodd",
    d: "M15.842 4.175a3.746 3.746 0 0 0-5.298 0l-2.116 2.117a3.75 3.75 0 0 0 .01 5.313l.338.336a.75.75 0 1 0 1.057-1.064l-.339-.337a2.25 2.25 0 0 1-.005-3.187l2.116-2.117a2.246 2.246 0 1 1 3.173 3.18l-1.052 1.047a.75.75 0 0 0 1.058 1.064l1.052-1.047a3.746 3.746 0 0 0 .006-5.305Zm-11.664 11.67a3.75 3.75 0 0 0 5.304 0l2.121-2.121a3.75 3.75 0 0 0 0-5.303l-.362-.362a.75.75 0 0 0-1.06 1.06l.362.362a2.25 2.25 0 0 1 0 3.182l-2.122 2.122a2.25 2.25 0 1 1-3.182-3.182l1.07-1.07a.75.75 0 1 0-1.062-1.06l-1.069 1.069a3.75 3.75 0 0 0 0 5.303Z"
  }));
};
SvgLinkIcon.displayName = "LinkIcon";

// ../../node_modules/.pnpm/@shopify+polaris-icons@8.0.0/node_modules/@shopify/polaris-icons/dist/index.mjs
var import_react4 = __toESM(require_react2(), 1);

// ../app/dist/cli/services/dev/graphiql/templates/graphiql.js
var controlKey = platformAndArch().platform === "darwin" ? "MAC_COMMAND_KEY" : "Ctrl", graphiqlIntroMessage = `
# Welcome to GraphiQL for the Shopify Admin API! If you've used
# GraphiQL before, you can jump to the next tab.
#
# GraphiQL is an in-browser tool for writing, validating, and
# testing GraphQL queries.
#
# Type queries into this side of the screen, and you will see intelligent
# typeaheads aware of the current GraphQL type schema and live syntax and
# validation errors highlighted within the text.
#
# GraphQL queries typically start with a "{" character. Lines that start
# with a # are ignored.
#
# Keyboard shortcuts:
#
#   Prettify query:  Shift-${controlKey}-P (or press the prettify button)
#
#  Merge fragments:  Shift-${controlKey}-M (or press the merge button)
#
#        Run Query:  ${controlKey}-Enter (or press the play button)
#
#    Auto Complete:  ${controlKey}-Space (or just start typing)
#
`, defaultQuery = `query shopInfo {
  shop {
    name
    url
    myshopifyDomain
    plan {
      displayName
      partnerDevelopment
      shopifyPlus
    }
  }
}
`.replace(/\n/g, "\\n");
function graphiqlTemplate({ apiVersion, apiVersions, appName, appUrl, key, storeFqdn }) {
  return `<!DOCTYPE html>
<html lang="en">
  <head>
    <title>GraphiQL</title>
    <link rel="shortcut icon" href="{{url}}/graphiql/favicon.ico" type="image/x-icon" />
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@shopify/polaris@12.10.0/build/esm/styles.css" />
    <style>
      body {
        height: 100%;
        margin: 0;
        width: 100%;
        overflow: hidden;
      }
      .Polaris-Page--fullWidth {
        width: 100%;
      }
      #top-bar {
        border-bottom: 1px solid var(--p-color-border);
      }
      #top-bar #top-error-bar {
        display: none;
      }
      #top-error-bar .Polaris-FullscreenBar__BackAction {
        /* hide default back button in FullscreenBar component */
        display: none;
      }
      #top-error-bar button {
        /* hide X to dismiss banner */
        display: none;
      }
      #top-bar .top-bar-section {
        display: inline-flex;
        align-items: center;
        gap: 8px;
      }
      #top-bar .Polaris-Grid-Cell:nth-child(2) {
        justify-self: right;
      }
      #top-bar #scopes-note {
        display: inline-flex;
        align-items: center;
        height: 100%;
      }
      #top-bar .status-badge-option {
        gap: 8px;
        display: none;
      }
      #top-bar #status-badge-running {
        display: flex;
      }
      #graphiql {
        height: 100vh;
        display: flex;
        flex-direction: column;
      }
      #graphiql-explorer {
        flex-grow: 1;
        overflow: auto;
      }
      #top-bar #outbound-links a {
        line-height: 0;
      }
      #top-bar #outbound-links a:hover .Polaris-Text--root {
        text-decoration: underline;
      }
      #top-bar #outbound-links a span.Polaris-Text--root {
        max-width: max(12vw, 150px);
        text-overflow: ellipsis;
        overflow: hidden;
        white-space: nowrap;
      }
      .with-shrunk-icon .Polaris-Icon {
        height: 1rem;
        width: 1rem;
        margin: 0.125rem;
      }
      @media only screen and (max-width: 1550px) {
        .top-bar-section-title {
          display: none;
        }
      }
      @media only screen and (max-width: 1150px) {
        #top-bar #outbound-links a span.Polaris-Text--root {
          max-width: max(12vw, 140px);
        }
      }
      @media only screen and (max-width: 1080px) {
        #top-bar .Polaris-Grid-Cell:nth-child(2) {
          justify-self: left;
        }
      }
      @media only screen and (max-width: 650px) {
        #top-bar #outbound-links a span.Polaris-Text--root {
          max-width: 17vw;
        }
      }
    </style>

    <script
      src="https://cdn.jsdelivr.net/npm/react@17/umd/react.development.js"
      integrity="sha512-Vf2xGDzpqUOEIKO+X2rgTLWPY+65++WPwCHkX2nFMu9IcstumPsf/uKKRd5prX3wOu8Q0GBylRpsDB26R6ExOg=="
      crossorigin="anonymous"
    ></script>
    <script
      src="https://cdn.jsdelivr.net/npm/react-dom@17/umd/react-dom.development.js"
      integrity="sha512-Wr9OKCTtq1anK0hq5bY3X/AvDI5EflDSAh0mE9gma+4hl+kXdTJPKZ3TwLMBcrgUeoY0s3dq9JjhCQc7vddtFg=="
      crossorigin="anonymous"
    ></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/graphiql/graphiql.min.css" />
  </head>
  <body>
    <div id="graphiql">
      ${(0, import_server2.renderToStaticMarkup)(import_react5.default.createElement(
    import_polaris.AppProvider,
    { i18n: {} },
    import_react5.default.createElement(
      "div",
      { id: "top-bar" },
      import_react5.default.createElement(
        import_polaris.Box,
        { background: "bg-surface", padding: "400" },
        import_react5.default.createElement(
          import_polaris.BlockStack,
          { gap: "300" },
          import_react5.default.createElement(
            import_polaris.Grid,
            { columns: { xs: 3, sm: 3, md: 3 } },
            import_react5.default.createElement(
              import_polaris.Grid.Cell,
              { columnSpan: { xs: 3, sm: 3, md: 3, lg: 7, xl: 7 } },
              import_react5.default.createElement(
                import_polaris.InlineStack,
                { gap: "400" },
                import_react5.default.createElement(
                  "div",
                  { id: "status-badge", className: "top-bar-section" },
                  import_react5.default.createElement(
                    "div",
                    { className: "status-badge-option", id: "status-badge-running" },
                    import_react5.default.createElement("span", { className: "top-bar-section-title" }, "Status: "),
                    import_react5.default.createElement(import_polaris.Badge, { tone: "success", progress: "complete" }, "Running")
                  ),
                  import_react5.default.createElement(
                    "div",
                    { className: "status-badge-option with-shrunk-icon", id: "status-badge-unauthorized" },
                    import_react5.default.createElement("span", { className: "top-bar-section-title" }, "Status: "),
                    import_react5.default.createElement(import_polaris.Badge, { tone: "attention", icon: SvgAlertCircleIcon }, "App uninstalled")
                  ),
                  import_react5.default.createElement(
                    "div",
                    { className: "status-badge-option with-shrunk-icon", id: "status-badge-disconnected" },
                    import_react5.default.createElement("span", { className: "top-bar-section-title" }, "Status: "),
                    import_react5.default.createElement(import_polaris.Badge, { tone: "critical", icon: SvgDisabledIcon }, "Disconnected")
                  )
                ),
                import_react5.default.createElement(
                  "div",
                  { id: "version-select", className: "top-bar-section" },
                  import_react5.default.createElement("span", { className: "top-bar-section-title" }, "API version: "),
                  import_react5.default.createElement(import_polaris.Select, { label: "API version", labelHidden: !0, options: apiVersions, value: apiVersion, onChange: () => {
                  } })
                ),
                linkPills({ storeFqdn, appName, appUrl })
              )
            ),
            import_react5.default.createElement(
              import_polaris.Grid.Cell,
              { columnSpan: { xs: 3, sm: 3, md: 3, lg: 5, xl: 5 } },
              import_react5.default.createElement(
                "div",
                { id: "scopes-note", className: "top-bar-section" },
                import_react5.default.createElement(import_polaris.Text, { as: "span", tone: "subdued" }, "GraphiQL runs on the same access scopes you\u2019ve defined in the TOML file for your app.")
              )
            )
          ),
          import_react5.default.createElement(
            "div",
            { id: "top-error-bar" },
            import_react5.default.createElement(
              import_polaris.Banner,
              { tone: "critical", onDismiss: () => {
              }, icon: SvgDisabledIcon },
              import_react5.default.createElement(
                "p",
                null,
                "The server has been stopped. Restart ",
                import_react5.default.createElement("code", null, "dev"),
                " from the CLI."
              )
            )
          )
        )
      )
    )
  ))}
      <div id="graphiql-explorer">Loading...</div>
    </div>
    <script
      src="https://cdn.jsdelivr.net/npm/graphiql@3.0.4/graphiql.min.js"
      type="application/javascript"
    ></script>
    <script>
      const macCommandKey = String.fromCodePoint(8984)
      const renderGraphiQL = function(apiVersion) {
        ReactDOM.render(
          React.createElement(GraphiQL, {
            fetcher: GraphiQL.createFetcher({
              url: '{{url}}/graphiql/graphql.json?key=${key ?? ""}&api_version=' + apiVersion,
            }),
            defaultEditorToolsVisibility: true,
            {% if query %}
            query: '{{query}}',
            {% endif %}
            defaultTabs: [
              {query: "${graphiqlIntroMessage.replace(/"/g, '\\"').replace(/\n/g, "\\n")}".replace(/MAC_COMMAND_KEY/g, macCommandKey)},
              {%for query in defaultQueries%}
                {query: "{%if query.preface %}{{query.preface}}\\n{% endif %}{{query.query}}", variables: "{{query.variables}}"},
              {%endfor%}
            ],
            isHeadersEditorEnabled: false,
          }),
          document.getElementById('graphiql-explorer'),
        )
      }
      renderGraphiQL('${apiVersion}')

      // Update the version when the select changes
      document.getElementById('version-select').addEventListener('change', function(event) {
        document.querySelector('#version-select .Polaris-Select__SelectedOption').innerText = event.target.value
        renderGraphiQL(event.target.value)
      })

      // Start out optimistic
      let serverIsLive = true
      let appIsInstalled = true

      const updateBadge = function() {
        const topErrorBar = document.querySelector('#graphiql #top-error-bar')
        const statusDiv = document.querySelector('#graphiql #status-badge')
        const allBadgeDivs = Array.from(statusDiv.querySelectorAll('.status-badge-option'))
        let activeBadge = 'running'
        if (!appIsInstalled) activeBadge = 'unauthorized'
        if (!serverIsLive) activeBadge = 'disconnected'
        allBadgeDivs.forEach(function(badge) {
          if (badge.id == ('status-badge-' + activeBadge)) {
            badge.style.display = 'flex'
          } else {
            badge.style.display = 'none'
          }
        })
        topErrorBar.style.display = serverIsLive ? 'none' : 'block'
      }
      const statusInterval = setInterval(updateBadge, 1000)

      // Warn when the server has been stopped
      const displayErrorServerStoppedTimeouts = []
      const pingInterval = setInterval(function() {
        displayErrorServerStoppedTimeouts.push(setTimeout(function() { serverIsLive = false }, 3000))
        fetch('{{url}}/graphiql/ping')
          .then(function(response) {
            if (response.status === 200) {
              while (displayErrorServerStoppedTimeouts.length > 0) {
                const timeout = displayErrorServerStoppedTimeouts.pop()
                clearTimeout(timeout)
              }
              serverIsLive = true
            } else {
              serverIsLive = false
            }
          })
      }, 2000)

      // Verify the current store/app connection
      setInterval(function() {
        fetch('{{ url }}/graphiql/status')
          .then(async function(response) {
            const {status, storeFqdn, appName, appUrl} = await response.json()
            appIsInstalled = status === 'OK'
            if (storeFqdn) {
              document.getElementById('outbound-links').innerHTML = \`${(0, import_server2.renderToStaticMarkup)(
    // Create HTML string with substitutions included
    import_react5.default.createElement(
      import_polaris.AppProvider,
      { i18n: {} },
      // eslint-disable-next-line no-template-curly-in-string
      linkPills({ storeFqdn: "${storeFqdn}", appName: "${appName}", appUrl: "${appUrl}" })
    )
  )}\`
            }
          })
      }, 5000)
    </script>
  </body>
</html>
`;
}
function linkPills({ storeFqdn, appName, appUrl }) {
  return import_react5.default.createElement(
    "div",
    { id: "outbound-links", className: "top-bar-section with-shrunk-icon" },
    import_react5.default.createElement("span", { className: "top-bar-section-title" }, "Store: "),
    import_react5.default.createElement(
      import_polaris.Link,
      { url: `https://${storeFqdn}/admin`, target: "_blank" },
      import_react5.default.createElement(import_polaris.Badge, { tone: "info", icon: SvgLinkIcon, children: storeFqdn })
    ),
    import_react5.default.createElement("span", { className: "top-bar-section-title" }, "App: "),
    import_react5.default.createElement(
      import_polaris.Link,
      { url: appUrl, target: "_blank" },
      import_react5.default.createElement(import_polaris.Badge, { tone: "info", icon: SvgLinkIcon, children: appName })
    )
  );
}

// ../app/dist/cli/services/dev/graphiql/templates/unauthorized.js
init_cjs_shims();
var import_react6 = __toESM(require_react(), 1), import_server3 = __toESM(require_server_node(), 1), import_polaris2 = __toESM(require_cjs5(), 1), shopifySvg = import_react6.default.createElement(
  "svg",
  { width: "102", height: "28", viewBox: "0 0 102 28", fill: "none", xmlns: "http://www.w3.org/2000/svg" },
  import_react6.default.createElement("path", { d: "M21.4028 5.3032C21.3836 5.16414 21.2615 5.08697 21.16 5.07856C21.0594 5.07016 19.0881 5.04036 19.0881 5.04036C19.0881 5.04036 17.4395 3.44802 17.2767 3.28603C17.1138 3.12405 16.7957 3.17295 16.6721 3.20962C16.6705 3.21039 16.3625 3.30513 15.8439 3.46483C15.7571 3.18517 15.6296 2.84134 15.4475 2.49597C14.8606 1.38194 14.0009 0.792838 12.9623 0.79131C12.9608 0.79131 12.96 0.79131 12.9585 0.79131C12.8862 0.79131 12.8148 0.798187 12.7426 0.804299C12.7119 0.767624 12.6811 0.731712 12.6489 0.696564C12.1964 0.215194 11.6164 -0.0193788 10.9211 0.00125134C9.57979 0.0394553 8.24384 1.00296 7.16064 2.7145C6.39856 3.91869 5.81855 5.43157 5.65415 6.6029C4.11386 7.0774 3.0368 7.40901 3.01299 7.41665C2.23554 7.65962 2.21096 7.68331 2.10955 8.41224C2.03427 8.96314 0 24.6084 0 24.6084L17.0477 27.541L24.4365 25.7141C24.4365 25.7141 21.422 5.44226 21.4028 5.3032ZM14.9904 3.72767C14.5979 3.84839 14.1515 3.98593 13.6675 4.13492C13.6575 3.45948 13.5769 2.51966 13.2604 1.70744C14.2783 1.89923 14.7792 3.04458 14.9904 3.72767ZM12.7756 4.40999C11.8822 4.68506 10.9073 4.98534 9.92933 5.28639C10.2044 4.23884 10.726 3.19587 11.3667 2.51202C11.6048 2.25758 11.9382 1.97411 12.3331 1.81212C12.7042 2.58231 12.7848 3.67266 12.7756 4.40999ZM10.948 0.889112C11.263 0.882236 11.528 0.951003 11.7546 1.09923C11.392 1.28643 11.0417 1.55539 10.7129 1.9061C9.86096 2.81536 9.20797 4.22661 8.94754 5.5882C8.13552 5.83806 7.34118 6.08333 6.60983 6.30797C7.07153 4.16472 8.87763 0.94871 10.948 0.889112Z", fill: "#95BF47" }),
  import_react6.default.createElement("path", { d: "M21.1611 5.07934C21.0605 5.07093 19.0892 5.04114 19.0892 5.04114C19.0892 5.04114 17.4406 3.44879 17.2778 3.28681C17.2171 3.22645 17.1349 3.19512 17.0488 3.18213L17.0496 27.5402L24.4376 25.7141C24.4376 25.7141 21.4231 5.44304 21.4039 5.30398C21.3847 5.16492 21.2618 5.08774 21.1611 5.07934Z", fill: "#5E8E3E" }),
  import_react6.default.createElement("path", { d: "M12.9528 8.85773L12.0947 12.0508C12.0947 12.0508 11.1375 11.6176 10.0028 11.6886C8.33885 11.7933 8.32118 12.8371 8.33808 13.0991C8.42873 14.5272 12.2061 14.8389 12.4181 18.1841C12.5848 20.8156 11.0146 22.6158 8.75216 22.7579C6.03647 22.9283 4.5415 21.3352 4.5415 21.3352L5.11691 18.9008C5.11691 18.9008 6.62186 20.0301 7.82644 19.9545C8.61311 19.9048 8.89428 19.2683 8.86585 18.8183C8.74755 16.9554 5.67157 17.0655 5.4772 14.0046C5.31357 11.4289 7.01443 8.81876 10.7672 8.58343C12.213 8.49097 12.9528 8.85773 12.9528 8.85773Z", fill: "white" }),
  import_react6.default.createElement("path", { d: "M34.1664 15.544C33.3168 15.0855 32.8802 14.699 32.8802 14.1677C32.8802 13.4917 33.4867 13.0575 34.4338 13.0575C35.5364 13.0575 36.5208 13.516 36.5208 13.516L37.2973 11.15C37.2973 11.15 36.5833 10.5945 34.4818 10.5945C31.5574 10.5945 29.5306 12.2602 29.5306 14.602C29.5306 15.9297 30.4769 16.9437 31.7395 17.6675C32.759 18.2465 33.1232 18.6572 33.1232 19.2605C33.1232 19.888 32.6135 20.395 31.6671 20.395C30.2567 20.395 28.9248 19.6705 28.9248 19.6705L28.0996 22.0365C28.0996 22.0365 29.3302 22.8572 31.4004 22.8572C34.4102 22.8572 36.5704 21.3847 36.5704 18.7292C36.5696 17.306 35.4777 16.292 34.1664 15.544Z", fill: "black" }),
  import_react6.default.createElement("path", { d: "M46.1564 10.571C44.6759 10.571 43.5108 11.2712 42.6132 12.333L42.5645 12.3087L43.8507 5.62222H40.5011L37.249 22.6405H40.5986L41.7149 16.8232C42.1515 14.6262 43.2922 13.275 44.3604 13.275C45.1125 13.275 45.4043 13.782 45.4043 14.5065C45.4043 14.965 45.3555 15.5205 45.2588 15.979L43.997 22.6412H47.3466L48.6571 15.7615C48.8027 15.037 48.9002 14.1685 48.9002 13.5887C48.8987 11.7055 47.9036 10.571 46.1564 10.571Z", fill: "black" }),
  import_react6.default.createElement("path", { d: "M56.4709 10.571C52.4416 10.571 49.7725 14.192 49.7725 18.223C49.7725 20.8058 51.3741 22.8815 54.3839 22.8815C58.34 22.8815 61.0099 19.3575 61.0099 15.2295C61.0099 12.84 59.6018 10.571 56.4709 10.571ZM54.8205 20.3238C53.6798 20.3238 53.1944 19.3583 53.1944 18.151C53.1944 16.2443 54.1896 13.1303 56.0099 13.1303C57.1993 13.1303 57.5872 14.1443 57.5872 15.134C57.5872 17.1855 56.5928 20.3238 54.8205 20.3238Z", fill: "black" }),
  import_react6.default.createElement("path", { d: "M69.5778 10.571C67.3171 10.571 66.0339 12.5505 66.0339 12.5505H65.9859L66.1802 10.7643H63.2192C63.0737 11.9715 62.8062 13.8055 62.5396 15.1818L60.2095 27.3718H63.5591L64.481 22.4473H64.5542C64.5542 22.4473 65.2415 22.8815 66.5201 22.8815C70.4518 22.8815 73.0242 18.8748 73.0242 14.8187C73.0242 12.5748 72.029 10.571 69.5778 10.571ZM66.3738 20.3715C65.5044 20.3715 64.99 19.8888 64.99 19.8888L65.5485 16.7748C65.9371 14.699 67.029 13.3228 68.1941 13.3228C69.2136 13.3228 69.529 14.264 69.529 15.1575C69.529 17.306 68.2428 20.3715 66.3738 20.3715Z", fill: "black" }),
  import_react6.default.createElement("path", { d: "M77.8058 5.79121C76.7383 5.79121 75.8887 6.63622 75.8887 7.72221C75.8887 8.71197 76.5196 9.38797 77.4659 9.38797H77.5147C78.5586 9.38797 79.4562 8.68771 79.4806 7.45697C79.4806 6.49147 78.8253 5.79121 77.8058 5.79121Z", fill: "black" }),
  import_react6.default.createElement("path", { d: "M73.1216 22.6405H76.4704L78.7525 10.837H75.3785L73.1216 22.6405Z", fill: "black" }),
  import_react6.default.createElement("path", { d: "M87.2711 10.8127H84.9411L85.0622 10.2572C85.2565 9.12274 85.9362 8.10874 87.0525 8.10874C87.6483 8.10874 88.12 8.27774 88.12 8.27774L88.7753 5.67074C88.7753 5.67074 88.1931 5.38124 86.9549 5.38124C85.7655 5.38124 84.5768 5.71924 83.6785 6.49149C82.5378 7.45699 82.0037 8.85674 81.737 10.2572L81.6402 10.8127H80.0866L79.6012 13.3235H81.1549L79.3833 22.6413H82.7329L84.5045 13.3235H86.8102L87.2711 10.8127Z", fill: "black" }),
  import_react6.default.createElement("path", { d: "M95.3288 10.837C95.3288 10.837 93.2349 16.0836 92.2947 18.9475H92.2459C92.1819 18.0252 91.4207 10.837 91.4207 10.837H87.9012L89.9166 21.675C89.9653 21.916 89.9409 22.0615 89.8434 22.2305C89.4548 22.9785 88.7995 23.703 88.0231 24.2343C87.3922 24.6928 86.6881 24.9823 86.1304 25.1755L87.0523 28C87.732 27.8553 89.1394 27.2998 90.3288 26.1895C91.858 24.7655 93.2654 22.5685 94.7215 19.575L98.8231 10.8362H95.3288V10.837Z", fill: "black" })
), polarisUnauthorizedContent = (0, import_server3.renderToStaticMarkup)(import_react6.default.createElement(
  import_polaris2.AppProvider,
  { i18n: {} },
  import_react6.default.createElement(
    import_polaris2.Page,
    { narrowWidth: !0 },
    import_react6.default.createElement(
      "div",
      { className: "card-wrapper" },
      import_react6.default.createElement(
        import_polaris2.Card,
        { padding: "600" },
        import_react6.default.createElement(
          import_polaris2.BlockStack,
          { gap: "500" },
          shopifySvg,
          import_react6.default.createElement(
            "div",
            { id: "pre-install" },
            import_react6.default.createElement(
              import_polaris2.BlockStack,
              { gap: "200" },
              import_react6.default.createElement(import_polaris2.Text, { variant: "headingMd", as: "h2" }, "Install your app to access GraphiQL"),
              import_react6.default.createElement("p", null, "The GraphiQL Explorer relies on your app being installed on your development store to access its data."),
              import_react6.default.createElement(
                "p",
                { id: "card-cta" },
                import_react6.default.createElement(import_polaris2.Button, { id: "app-install-button" }, "Install your app")
              )
            )
          ),
          import_react6.default.createElement(
            "div",
            { id: "post-install" },
            import_react6.default.createElement(
              import_polaris2.BlockStack,
              { gap: "200" },
              import_react6.default.createElement(import_polaris2.Text, { variant: "headingMd", as: "h2" }, "Loading GraphiQL..."),
              import_react6.default.createElement(
                "p",
                null,
                "If you're not redirected automatically, ",
                import_react6.default.createElement(import_polaris2.Link, { url: "{{url}}/graphiql" }, "click here"),
                "."
              )
            )
          )
        )
      )
    )
  )
)), unauthorizedTemplate = `
<!DOCTYPE html>
<html>
  <head>
    <title>GraphiQL Explorer - App Not Installed</title>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">

    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@shopify/polaris@12.10.0/build/esm/styles.css" />
    <style>
      .vertical-center {
        display: flex;
        flex-direction: row;
        align-items: center;
        height: 100%;
      }
      .card-wrapper {
        max-width: 480px;
        margin-left: 20px;
        margin-right: 20px;
      }
      #post-install {
        display: none;
      }
    </style>

    <script type="text/javascript">
      let appInstalled = false
      let newTab = null

      setInterval(function() {
        fetch('{{ url }}/graphiql/status')
          .then(async function(response) {
            const body = await response.json()
            if (body.status === 'OK') {
              if (newTab) newTab.close()
              document.getElementById('pre-install').style.display = 'none'
              document.getElementById('post-install').style.display = 'block'
              window.location.href = window.location.href
            }
          })
      }, 5000)

      function openAppInstallTab() {
        newTab = window.open('{{ previewUrl }}', '_blank')
      }

      document.addEventListener("DOMContentLoaded", function() {
        document.getElementById('app-install-button').onclick = openAppInstallTab
      })
    </script>
  </head>
  <body>
    <div class="vertical-center">
      ${polarisUnauthorizedContent}
    </div>
  </body>
</html>
`;

// ../app/dist/cli/services/dev/graphiql/server.js
var import_express = __toESM(require_express2(), 1), import_body_parser = __toESM(require_body_parser(), 1);
import { encode as queryStringEncode } from "node:querystring";
import { createRequire as createRequire3 } from "module";
var require2 = createRequire3(import.meta.url), TokenRefreshError = class extends AbortError {
  constructor() {
    super("Failed to refresh credentials. Check that your app is installed, and try again.");
  }
};
function corsMiddleware2(_req, res, next) {
  res.setHeader("Access-Control-Allow-Origin", "*"), res.setHeader("Access-Control-Allow-Methods", "GET, OPTIONS"), res.setHeader("Access-Control-Allow-Headers", "Accept, Content-Type, Content-Length, Accept-Encoding, X-CSRF-Token, Authorization, ngrok-skip-browser-warning"), next();
}
function setupGraphiQLServer({ stdout, port, appName, appUrl, apiKey, apiSecret, key, storeFqdn }) {
  outputDebug(`Setting up GraphiQL HTTP server on port ${port}...`, stdout);
  let localhostUrl = `http://localhost:${port}`, app = (0, import_express.default)();
  function failIfUnmatchedKey(str, res) {
    return !key || str === key ? !1 : (res.status(404).send(`Invalid path ${res.req.originalUrl}`), !0);
  }
  let _token;
  async function token() {
    return _token || (_token = await refreshToken2()), _token;
  }
  async function refreshToken2() {
    try {
      outputDebug("refreshing token", stdout), _token = void 0;
      let queryString = queryStringEncode({
        client_id: apiKey,
        client_secret: apiSecret,
        grant_type: "client_credentials"
      });
      return (await (await fetch2(`https://${storeFqdn}/admin/oauth/access_token?${queryString}`, {
        method: "POST",
        headers: {
          "Content-Type": "application/json"
        }
      })).json()).access_token;
    } catch {
      throw new TokenRefreshError();
    }
  }
  app.get("/graphiql/ping", corsMiddleware2, (_req, res) => {
    res.send("pong");
  });
  let faviconPath = require2.resolve("./assets/graphiql/favicon.ico");
  app.get("/graphiql/favicon.ico", (_req, res) => {
    res.sendFile(faviconPath);
  });
  let stylePath = require2.resolve("./assets/style.css");
  app.get("/graphiql/simple.css", (_req, res) => {
    res.sendFile(stylePath);
  });
  async function fetchApiVersionsWithTokenRefresh() {
    return performActionWithRetryAfterRecovery(async () => supportedApiVersions({ storeFqdn, token: await token() }), refreshToken2);
  }
  return app.get("/graphiql/status", (_req, res) => {
    fetchApiVersionsWithTokenRefresh().then(() => res.send({ status: "OK", storeFqdn, appName, appUrl })).catch(() => res.send({ status: "UNAUTHENTICATED" }));
  }), app.get("/graphiql", async (req, res) => {
    if (outputDebug("Handling /graphiql request", stdout), failIfUnmatchedKey(req.query.key, res))
      return;
    let apiVersions;
    try {
      apiVersions = await fetchApiVersionsWithTokenRefresh();
    } catch (err2) {
      if (err2 instanceof TokenRefreshError)
        return res.send(await renderLiquidTemplate(unauthorizedTemplate, {
          previewUrl: appUrl,
          url: localhostUrl
        }));
      throw err2;
    }
    let apiVersion = apiVersions.sort().reverse()[0], query = req.query.query ? decodeURIComponent(req.query.query).replace(/\n/g, "\\n") : void 0;
    res.send(await renderLiquidTemplate(graphiqlTemplate({
      apiVersion,
      apiVersions: [...apiVersions, "unstable"],
      appName,
      appUrl,
      key,
      storeFqdn
    }), {
      url: localhostUrl,
      defaultQueries: [{ query: defaultQuery }],
      query
    }));
  }), app.use(import_body_parser.default.json()), app.post("/graphiql/graphql.json", async (req, res) => {
    if (outputDebug("Handling /graphiql/graphql.json request", stdout), failIfUnmatchedKey(req.query.key, res))
      return;
    let graphqlUrl = adminUrl(storeFqdn, req.query.api_version);
    try {
      let reqBody = JSON.stringify(req.body), runRequest = async () => {
        let headers = {
          Accept: "application/json",
          "Content-Type": "application/json",
          "X-Shopify-Access-Token": await token(),
          "User-Agent": `ShopifyCLIGraphiQL/${CLI_KIT_VERSION}`
        };
        return fetch2(graphqlUrl, {
          method: req.method,
          headers,
          body: reqBody
        });
      }, result = await runRequest();
      result.status === 401 && (outputDebug("Token expired, fetching new token", stdout), await refreshToken2(), result = await runRequest()), res.setHeader("Content-Type", "application/json"), res.statusCode = result.status;
      let responseBody = await result.json();
      res.json(responseBody);
    } catch (error) {
      res.statusCode = 500, error instanceof Error ? res.json({ errors: [error.message] }) : res.json({ errors: ["Unknown error"] });
    }
    res.end();
  }), app.listen(port, () => stdout.write(`GraphiQL server started on port ${port}`));
}

// ../app/dist/cli/services/dev/processes/graphiql.js
async function setupGraphiQLServerProcess(options) {
  return {
    type: "graphiql",
    prefix: "graphiql",
    options,
    function: launchGraphiQLServer
  };
}
var launchGraphiQLServer = async ({ stdout, abortSignal }, options) => {
  let httpServer = setupGraphiQLServer({ ...options, stdout });
  abortSignal.addEventListener("abort", async () => {
    httpServer.close();
  });
};

// ../app/dist/cli/services/dev/processes/web.js
init_cjs_shims();
async function setupWebProcesses({ webs, proxyUrl, frontendPort, backendPort, apiKey, apiSecret, scopes }) {
  let { frontendConfig } = frontAndBackendConfig(webs), hmrServerPort = frontendConfig?.configuration.hmr_server ? await getAvailableTCPPort() : void 0, shopCustomDomain = isSpinEnvironment() ? `shopify.${await spinFqdn()}` : void 0, webProcessSetups = webs.map(async (web2) => {
    let port = await getWebProcessPort({ web: web2, frontendPort, backendPort }), hmrServerOptions = hmrServerPort && web2.configuration.roles.includes(WebType.Frontend) ? {
      port: hmrServerPort,
      httpPaths: web2.configuration.hmr_server.http_paths
    } : void 0;
    return {
      type: "web",
      prefix: web2.configuration.name ?? ["web", ...web2.configuration.roles].join("-"),
      function: launchWebProcess,
      options: {
        port,
        portFromConfig: web2.configuration.port,
        apiKey,
        apiSecret,
        hostname: proxyUrl,
        backendPort,
        // when we delete `dev.ts` we can rename frontendServerPort to frontendPort
        frontendServerPort: frontendPort,
        directory: web2.directory,
        devCommand: web2.configuration.commands.dev,
        preDevCommand: web2.configuration.commands.predev,
        scopes,
        shopCustomDomain,
        hmrServerOptions,
        roles: web2.configuration.roles
      }
    };
  });
  return Promise.all(webProcessSetups);
}
async function getWebProcessPort({ web: web2, frontendPort, backendPort }) {
  return isWebType(web2, WebType.Frontend) ? frontendPort : isWebType(web2, WebType.Backend) ? backendPort : getAvailableTCPPort();
}
async function launchWebProcess({ stdout, stderr, abortSignal: signal }, { port, apiKey, apiSecret, hostname: hostname2, backendPort, frontendServerPort, directory, devCommand, preDevCommand, scopes, shopCustomDomain, hmrServerOptions }) {
  let hmrServerPort = hmrServerOptions?.port, env = {
    SHOPIFY_API_KEY: apiKey,
    SHOPIFY_API_SECRET: apiSecret,
    HOST: hostname2,
    SCOPES: scopes,
    NODE_ENV: "development",
    ...shopCustomDomain && {
      SHOP_CUSTOM_DOMAIN: shopCustomDomain
    },
    BACKEND_PORT: `${backendPort}`,
    FRONTEND_PORT: `${frontendServerPort}`,
    ...hmrServerPort && {
      HMR_SERVER_PORT: `${hmrServerPort}`
    },
    APP_URL: hostname2,
    APP_ENV: "development",
    // Note: These are Remix-specific variables
    REMIX_DEV_ORIGIN: hostname2
  }, baseCommandRunConfig = { signal, directory, port, env, stdout, stderr };
  preDevCommand && (stdout.write(`Running pre-dev command: "${preDevCommand}"`), await runCommands({ ...baseCommandRunConfig, command: preDevCommand, showOutput: isVerbose() })), await runCommands({ ...baseCommandRunConfig, command: devCommand, showOutput: !0 });
}
async function runCommands({ command, signal, directory, port, env, showOutput, stdout, stderr }) {
  let commands4 = command.split("&&").map((cmd) => cmd.trim()) ?? [];
  for (let command2 of commands4) {
    let [cmd, ...args] = command2.split(" ");
    cmd?.length !== 0 && await exec(cmd, args, {
      cwd: directory,
      stdout: showOutput ? stdout : void 0,
      stderr,
      signal,
      env: {
        ...env,
        PORT: `${port}`,
        // Note: These are Laravel variables for backwards compatibility with 2.0 templates.
        SERVER_PORT: `${port}`
      }
    });
  }
}

// ../app/dist/cli/services/dev/processes/app-logs-polling.js
init_cjs_shims();

// ../app/dist/cli/services/app-logs/dev/poll-app-logs.js
init_cjs_shims();

// ../app/dist/cli/services/app-logs/dev/write-app-logs.js
init_cjs_shims();

// ../app/dist/cli/services/app-logs/utils.js
init_cjs_shims();

// ../app/dist/cli/services/app-logs/types.js
init_cjs_shims();
var FunctionRunLog = class {
  constructor({ export: exportValue, input, inputBytes, output, outputBytes, logs: logs2, functionId, fuelConsumed, errorMessage: errorMessage2, errorType }) {
    this.export = exportValue, this.input = input, this.inputBytes = inputBytes, this.output = output, this.outputBytes = outputBytes, this.logs = logs2, this.functionId = functionId, this.fuelConsumed = fuelConsumed, this.errorMessage = errorMessage2, this.errorType = errorType;
  }
}, NetworkAccessResponseFromCacheLog = class {
  constructor({ cacheEntryEpochMs, cacheTtlMs, httpRequest, httpResponse }) {
    this.cacheEntryEpochMs = cacheEntryEpochMs, this.cacheTtlMs = cacheTtlMs, this.httpRequest = httpRequest, this.httpResponse = httpResponse;
  }
}, BackgroundExecutionReason;
(function(BackgroundExecutionReason2) {
  BackgroundExecutionReason2[BackgroundExecutionReason2.NoCachedResponse = 0] = "NoCachedResponse", BackgroundExecutionReason2[BackgroundExecutionReason2.CacheAboutToExpire = 1] = "CacheAboutToExpire", BackgroundExecutionReason2[BackgroundExecutionReason2.Unknown = 2] = "Unknown";
})(BackgroundExecutionReason || (BackgroundExecutionReason = {}));
var NetworkAccessRequestExecutionInBackgroundLog = class {
  constructor({ reason, httpRequest }) {
    this.reason = reason, this.httpRequest = httpRequest;
  }
}, NetworkAccessRequestExecutedLog = class {
  constructor({ attempt, connectTimeMs, writeReadTimeMs, httpRequest, httpResponse, error }) {
    this.attempt = attempt, this.connectTimeMs = connectTimeMs, this.writeReadTimeMs = writeReadTimeMs, this.httpRequest = httpRequest, this.httpResponse = httpResponse, this.error = error;
  }
};

// ../../node_modules/.pnpm/camelcase-keys@9.1.3/node_modules/camelcase-keys/index.js
init_cjs_shims();

// ../../node_modules/.pnpm/map-obj@5.0.0/node_modules/map-obj/index.js
init_cjs_shims();
var isObject2 = (value) => typeof value == "object" && value !== null, isObjectCustom = (value) => isObject2(value) && !(value instanceof RegExp) && !(value instanceof Error) && !(value instanceof Date), mapObjectSkip = Symbol("mapObjectSkip"), _mapObject = (object, mapper, options, isSeen = /* @__PURE__ */ new WeakMap()) => {
  if (options = {
    deep: !1,
    target: {},
    ...options
  }, isSeen.has(object))
    return isSeen.get(object);
  isSeen.set(object, options.target);
  let { target } = options;
  delete options.target;
  let mapArray = (array) => array.map((element) => isObjectCustom(element) ? _mapObject(element, mapper, options, isSeen) : element);
  if (Array.isArray(object))
    return mapArray(object);
  for (let [key, value] of Object.entries(object)) {
    let mapResult = mapper(key, value, object);
    if (mapResult === mapObjectSkip)
      continue;
    let [newKey, newValue, { shouldRecurse = !0 } = {}] = mapResult;
    newKey !== "__proto__" && (options.deep && shouldRecurse && isObjectCustom(newValue) && (newValue = Array.isArray(newValue) ? mapArray(newValue) : _mapObject(newValue, mapper, options, isSeen)), target[newKey] = newValue);
  }
  return target;
};
function mapObject(object, mapper, options) {
  if (!isObject2(object))
    throw new TypeError(`Expected an object, got \`${object}\` (${typeof object})`);
  return _mapObject(object, mapper, options);
}

// ../../node_modules/.pnpm/camelcase@8.0.0/node_modules/camelcase/index.js
init_cjs_shims();
var UPPERCASE = /[\p{Lu}]/u, LOWERCASE = /[\p{Ll}]/u, LEADING_CAPITAL = /^[\p{Lu}](?![\p{Lu}])/gu, IDENTIFIER = /([\p{Alpha}\p{N}_]|$)/u, SEPARATORS = /[_.\- ]+/, LEADING_SEPARATORS = new RegExp("^" + SEPARATORS.source), SEPARATORS_AND_IDENTIFIER = new RegExp(SEPARATORS.source + IDENTIFIER.source, "gu"), NUMBERS_AND_IDENTIFIER = new RegExp("\\d+" + IDENTIFIER.source, "gu"), preserveCamelCase = (string, toLowerCase, toUpperCase, preserveConsecutiveUppercase2) => {
  let isLastCharLower = !1, isLastCharUpper = !1, isLastLastCharUpper = !1, isLastLastCharPreserved = !1;
  for (let index = 0; index < string.length; index++) {
    let character = string[index];
    isLastLastCharPreserved = index > 2 ? string[index - 3] === "-" : !0, isLastCharLower && UPPERCASE.test(character) ? (string = string.slice(0, index) + "-" + string.slice(index), isLastCharLower = !1, isLastLastCharUpper = isLastCharUpper, isLastCharUpper = !0, index++) : isLastCharUpper && isLastLastCharUpper && LOWERCASE.test(character) && (!isLastLastCharPreserved || preserveConsecutiveUppercase2) ? (string = string.slice(0, index - 1) + "-" + string.slice(index - 1), isLastLastCharUpper = isLastCharUpper, isLastCharUpper = !1, isLastCharLower = !0) : (isLastCharLower = toLowerCase(character) === character && toUpperCase(character) !== character, isLastLastCharUpper = isLastCharUpper, isLastCharUpper = toUpperCase(character) === character && toLowerCase(character) !== character);
  }
  return string;
}, preserveConsecutiveUppercase = (input, toLowerCase) => (LEADING_CAPITAL.lastIndex = 0, input.replaceAll(LEADING_CAPITAL, (match2) => toLowerCase(match2))), postProcess = (input, toUpperCase) => (SEPARATORS_AND_IDENTIFIER.lastIndex = 0, NUMBERS_AND_IDENTIFIER.lastIndex = 0, input.replaceAll(NUMBERS_AND_IDENTIFIER, (match2, pattern, offset) => ["_", "-"].includes(input.charAt(offset + match2.length)) ? match2 : toUpperCase(match2)).replaceAll(SEPARATORS_AND_IDENTIFIER, (_2, identifier) => toUpperCase(identifier)));
function camelCase(input, options) {
  if (!(typeof input == "string" || Array.isArray(input)))
    throw new TypeError("Expected the input to be `string | string[]`");
  if (options = {
    pascalCase: !1,
    preserveConsecutiveUppercase: !1,
    ...options
  }, Array.isArray(input) ? input = input.map((x) => x.trim()).filter((x) => x.length).join("-") : input = input.trim(), input.length === 0)
    return "";
  let toLowerCase = options.locale === !1 ? (string) => string.toLowerCase() : (string) => string.toLocaleLowerCase(options.locale), toUpperCase = options.locale === !1 ? (string) => string.toUpperCase() : (string) => string.toLocaleUpperCase(options.locale);
  return input.length === 1 ? SEPARATORS.test(input) ? "" : options.pascalCase ? toUpperCase(input) : toLowerCase(input) : (input !== toLowerCase(input) && (input = preserveCamelCase(input, toLowerCase, toUpperCase, options.preserveConsecutiveUppercase)), input = input.replace(LEADING_SEPARATORS, ""), input = options.preserveConsecutiveUppercase ? preserveConsecutiveUppercase(input, toLowerCase) : toLowerCase(input), options.pascalCase && (input = toUpperCase(input.charAt(0)) + input.slice(1)), postProcess(input, toUpperCase));
}

// ../../node_modules/.pnpm/quick-lru@6.1.2/node_modules/quick-lru/index.js
init_cjs_shims();
var QuickLRU = class extends Map {
  constructor(options = {}) {
    if (super(), !(options.maxSize && options.maxSize > 0))
      throw new TypeError("`maxSize` must be a number greater than 0");
    if (typeof options.maxAge == "number" && options.maxAge === 0)
      throw new TypeError("`maxAge` must be a number greater than 0");
    this.maxSize = options.maxSize, this.maxAge = options.maxAge || Number.POSITIVE_INFINITY, this.onEviction = options.onEviction, this.cache = /* @__PURE__ */ new Map(), this.oldCache = /* @__PURE__ */ new Map(), this._size = 0;
  }
  // TODO: Use private class methods when targeting Node.js 16.
  _emitEvictions(cache2) {
    if (typeof this.onEviction == "function")
      for (let [key, item] of cache2)
        this.onEviction(key, item.value);
  }
  _deleteIfExpired(key, item) {
    return typeof item.expiry == "number" && item.expiry <= Date.now() ? (typeof this.onEviction == "function" && this.onEviction(key, item.value), this.delete(key)) : !1;
  }
  _getOrDeleteIfExpired(key, item) {
    if (this._deleteIfExpired(key, item) === !1)
      return item.value;
  }
  _getItemValue(key, item) {
    return item.expiry ? this._getOrDeleteIfExpired(key, item) : item.value;
  }
  _peek(key, cache2) {
    let item = cache2.get(key);
    return this._getItemValue(key, item);
  }
  _set(key, value) {
    this.cache.set(key, value), this._size++, this._size >= this.maxSize && (this._size = 0, this._emitEvictions(this.oldCache), this.oldCache = this.cache, this.cache = /* @__PURE__ */ new Map());
  }
  _moveToRecent(key, item) {
    this.oldCache.delete(key), this._set(key, item);
  }
  *_entriesAscending() {
    for (let item of this.oldCache) {
      let [key, value] = item;
      this.cache.has(key) || this._deleteIfExpired(key, value) === !1 && (yield item);
    }
    for (let item of this.cache) {
      let [key, value] = item;
      this._deleteIfExpired(key, value) === !1 && (yield item);
    }
  }
  get(key) {
    if (this.cache.has(key)) {
      let item = this.cache.get(key);
      return this._getItemValue(key, item);
    }
    if (this.oldCache.has(key)) {
      let item = this.oldCache.get(key);
      if (this._deleteIfExpired(key, item) === !1)
        return this._moveToRecent(key, item), item.value;
    }
  }
  set(key, value, { maxAge = this.maxAge } = {}) {
    let expiry = typeof maxAge == "number" && maxAge !== Number.POSITIVE_INFINITY ? Date.now() + maxAge : void 0;
    return this.cache.has(key) ? this.cache.set(key, {
      value,
      expiry
    }) : this._set(key, { value, expiry }), this;
  }
  has(key) {
    return this.cache.has(key) ? !this._deleteIfExpired(key, this.cache.get(key)) : this.oldCache.has(key) ? !this._deleteIfExpired(key, this.oldCache.get(key)) : !1;
  }
  peek(key) {
    if (this.cache.has(key))
      return this._peek(key, this.cache);
    if (this.oldCache.has(key))
      return this._peek(key, this.oldCache);
  }
  delete(key) {
    let deleted = this.cache.delete(key);
    return deleted && this._size--, this.oldCache.delete(key) || deleted;
  }
  clear() {
    this.cache.clear(), this.oldCache.clear(), this._size = 0;
  }
  resize(newSize) {
    if (!(newSize && newSize > 0))
      throw new TypeError("`maxSize` must be a number greater than 0");
    let items = [...this._entriesAscending()], removeCount = items.length - newSize;
    removeCount < 0 ? (this.cache = new Map(items), this.oldCache = /* @__PURE__ */ new Map(), this._size = items.length) : (removeCount > 0 && this._emitEvictions(items.slice(0, removeCount)), this.oldCache = new Map(items.slice(removeCount)), this.cache = /* @__PURE__ */ new Map(), this._size = 0), this.maxSize = newSize;
  }
  *keys() {
    for (let [key] of this)
      yield key;
  }
  *values() {
    for (let [, value] of this)
      yield value;
  }
  *[Symbol.iterator]() {
    for (let item of this.cache) {
      let [key, value] = item;
      this._deleteIfExpired(key, value) === !1 && (yield [key, value.value]);
    }
    for (let item of this.oldCache) {
      let [key, value] = item;
      this.cache.has(key) || this._deleteIfExpired(key, value) === !1 && (yield [key, value.value]);
    }
  }
  *entriesDescending() {
    let items = [...this.cache];
    for (let i = items.length - 1; i >= 0; --i) {
      let item = items[i], [key, value] = item;
      this._deleteIfExpired(key, value) === !1 && (yield [key, value.value]);
    }
    items = [...this.oldCache];
    for (let i = items.length - 1; i >= 0; --i) {
      let item = items[i], [key, value] = item;
      this.cache.has(key) || this._deleteIfExpired(key, value) === !1 && (yield [key, value.value]);
    }
  }
  *entriesAscending() {
    for (let [key, value] of this._entriesAscending())
      yield [key, value.value];
  }
  get size() {
    if (!this._size)
      return this.oldCache.size;
    let oldCacheSize = 0;
    for (let key of this.oldCache.keys())
      this.cache.has(key) || oldCacheSize++;
    return Math.min(this._size + oldCacheSize, this.maxSize);
  }
  entries() {
    return this.entriesAscending();
  }
  forEach(callbackFunction, thisArgument = this) {
    for (let [key, value] of this.entriesAscending())
      callbackFunction.call(thisArgument, value, key, this);
  }
  get [Symbol.toStringTag]() {
    return JSON.stringify([...this.entriesAscending()]);
  }
};

// ../../node_modules/.pnpm/camelcase-keys@9.1.3/node_modules/camelcase-keys/index.js
var has = (array, key) => array.some((element) => typeof element == "string" ? element === key : (element.lastIndex = 0, element.test(key))), cache = new QuickLRU({ maxSize: 1e5 }), isObject3 = (value) => typeof value == "object" && value !== null && !(value instanceof RegExp) && !(value instanceof Error) && !(value instanceof Date), transform = (input, options = {}) => {
  if (!isObject3(input))
    return input;
  let {
    exclude,
    pascalCase = !1,
    stopPaths,
    deep = !1,
    preserveConsecutiveUppercase: preserveConsecutiveUppercase2 = !1
  } = options, stopPathsSet = new Set(stopPaths), makeMapper = (parentPath) => (key, value) => {
    if (deep && isObject3(value)) {
      let path3 = parentPath === void 0 ? key : `${parentPath}.${key}`;
      stopPathsSet.has(path3) || (value = mapObject(value, makeMapper(path3)));
    }
    if (!(exclude && has(exclude, key))) {
      let cacheKey = pascalCase ? `${key}_` : key;
      if (cache.has(cacheKey))
        key = cache.get(cacheKey);
      else {
        let returnValue = camelCase(key, { pascalCase, locale: !1, preserveConsecutiveUppercase: preserveConsecutiveUppercase2 });
        key.length < 100 && cache.set(cacheKey, returnValue), key = returnValue;
      }
    }
    return [key, value];
  };
  return mapObject(input, makeMapper(void 0));
};
function camelcaseKeys(input, options) {
  return Array.isArray(input) ? Object.keys(input).map((key) => transform(input[key], options)) : transform(input, options);
}

// ../app/dist/cli/services/app-logs/utils.js
var POLLING_INTERVAL_MS = 450, POLLING_ERROR_RETRY_INTERVAL_MS = 5 * 1e3, POLLING_THROTTLE_RETRY_INTERVAL_MS = 60 * 1e3, ONE_MILLION = 1e6, LOG_TYPE_FUNCTION_RUN = "function_run", LOG_TYPE_FUNCTION_NETWORK_ACCESS = "function_network_access", LOG_TYPE_RESPONSE_FROM_CACHE = "function_network_access.response_from_cache", LOG_TYPE_REQUEST_EXECUTION_IN_BACKGROUND = "function_network_access.request_execution_in_background", LOG_TYPE_REQUEST_EXECUTION = "function_network_access.request_execution", REQUEST_EXECUTION_IN_BACKGROUND_NO_CACHED_RESPONSE_REASON = "no_cached_response", REQUEST_EXECUTION_IN_BACKGROUND_CACHE_ABOUT_TO_EXPIRE_REASON = "cached_response_about_to_expire";
function parseFunctionRunPayload(payload) {
  let parsedPayload = JSON.parse(payload);
  return new FunctionRunLog({
    export: parsedPayload.export,
    input: parsedPayload.input,
    inputBytes: parsedPayload.input_bytes,
    output: parsedPayload.output,
    outputBytes: parsedPayload.output_bytes,
    logs: parsedPayload.logs,
    functionId: parsedPayload.function_id,
    fuelConsumed: parsedPayload.fuel_consumed,
    errorMessage: parsedPayload.error_message,
    errorType: parsedPayload.error_type
  });
}
function parseNetworkAccessResponseFromCachePayload(payload) {
  let parsedPayload = JSON.parse(payload);
  return new NetworkAccessResponseFromCacheLog({
    cacheEntryEpochMs: parsedPayload.cache_entry_epoch_ms,
    cacheTtlMs: parsedPayload.cache_ttl_ms,
    httpRequest: parsedPayload.http_request,
    httpResponse: parsedPayload.http_response
  });
}
var reasonStringToEnum = {
  no_cached_response: BackgroundExecutionReason.NoCachedResponse,
  cached_response_about_to_expire: BackgroundExecutionReason.CacheAboutToExpire
};
function parseNetworkAccessRequestExecutionInBackgroundPayload(payload) {
  let parsedPayload = JSON.parse(payload);
  return new NetworkAccessRequestExecutionInBackgroundLog({
    reason: reasonStringToEnum[parsedPayload.reason] ?? BackgroundExecutionReason.Unknown,
    httpRequest: parsedPayload.http_request
  });
}
function parseNetworkAccessRequestExecutedPayload(payload) {
  let parsedPayload = JSON.parse(payload);
  return new NetworkAccessRequestExecutedLog({
    attempt: parsedPayload.attempt,
    connectTimeMs: parsedPayload.connect_time_ms || null,
    writeReadTimeMs: parsedPayload.write_read_time_ms || null,
    httpRequest: parsedPayload.http_request,
    httpResponse: parsedPayload.http_response || null,
    error: parsedPayload.error || null
  });
}
var generateFetchAppLogUrl = async (cursor, filters) => {
  let url = `https://${await partnersFqdn()}/app_logs/poll`;
  return cursor && (url += `?cursor=${cursor}`, filters?.status && (url += `&status=${filters.status}`), filters?.source && (url += `&source=${filters.source}`)), url;
}, fetchAppLogs = async (jwtToken, cursor, filters) => {
  let url = await generateFetchAppLogUrl(cursor, filters);
  return fetch2(url, {
    method: "GET",
    headers: {
      Authorization: `Bearer ${jwtToken}`
    }
  });
}, handleFetchAppLogsError = async (input) => {
  let { errors: errors2 } = input.response, retryIntervalMs = POLLING_INTERVAL_MS, nextJwtToken = null;
  return errors2.length > 0 && (outputDebug(`Errors: ${errors2.map((error) => error.message).join(", ")}`), errors2.some((error) => error.status === 401) ? nextJwtToken = await input.onResubscribe() : errors2.some((error) => error.status === 429) ? (retryIntervalMs = POLLING_THROTTLE_RETRY_INTERVAL_MS, input.onThrottle(retryIntervalMs)) : (retryIntervalMs = POLLING_ERROR_RETRY_INTERVAL_MS, input.onUnknownError(retryIntervalMs))), { retryIntervalMs, nextJwtToken };
};
function sourcesForApp(app) {
  return app.allExtensions.flatMap((extension) => extension.isFunctionExtension ? [`extensions.${extension.configuration.handle}`] : []);
}
var toFormattedAppLogJson = (appLog, appLogPayload, prettyPrint = !0) => {
  let { cursor: _2, ...appLogWithoutCursor } = appLog, toSaveData = camelcaseKeys({
    ...appLogWithoutCursor,
    payload: appLogPayload,
    localTime: formatLocalDate(appLog.log_timestamp)
  }, { deep: !0 });
  return appLogPayload instanceof FunctionRunLog && (toSaveData.payload.logs = appLogPayload.logs.split(`
`).filter(Boolean)), prettyPrint ? JSON.stringify(toSaveData, null, 2) : JSON.stringify(toSaveData);
}, parseAppLogPayload = (payload, logType) => {
  let parsedPayload = camelcaseKeys(JSON.parse(payload), { deep: !0 });
  return logType === LOG_TYPE_FUNCTION_RUN ? new FunctionRunLog(parsedPayload) : logType === LOG_TYPE_RESPONSE_FROM_CACHE ? new NetworkAccessResponseFromCacheLog(parsedPayload) : logType === LOG_TYPE_REQUEST_EXECUTION_IN_BACKGROUND ? new NetworkAccessRequestExecutionInBackgroundLog(parsedPayload) : logType === LOG_TYPE_REQUEST_EXECUTION ? new NetworkAccessRequestExecutedLog(parsedPayload) : parsedPayload;
}, subscribeToAppLogs = async (developerPlatformClient, variables) => {
  let result = await developerPlatformClient.subscribeToAppLogs(variables), { jwtToken, success, errors: errors2 } = result.appLogsSubscribe;
  if (outputDebug(`Token: ${jwtToken}
`), outputDebug(`API Key: ${variables.apiKey}
`), errors2 && errors2.length > 0) {
    let errorOutput = errors2.join(", ");
    throw outputWarn(`Errors subscribing to app logs: ${errorOutput}`), outputWarn("App log streaming is not available in this session."), new AbortError(errorOutput);
  } else
    outputDebug(`Subscribed to App Events for shop ID(s) ${variables.shopIds}`), outputDebug(`Success: ${success}
`);
  return jwtToken;
};
function prettyPrintJsonIfPossible(json) {
  try {
    if (typeof json == "string") {
      let jsonObject = JSON.parse(json);
      return JSON.stringify(jsonObject, null, 2);
    } else
      return typeof json == "object" && json !== null ? JSON.stringify(json, null, 2) : json;
  } catch (error) {
    throw new Error(`Error parsing JSON: ${error}`);
  }
}

// ../cli-kit/dist/public/node/logs.js
init_cjs_shims();
var getLogsDir = () => logsFolder(), createLogsDir = async (path3) => {
  await mkdir(joinPath(logsFolder(), path3));
}, writeLog = async (path3, logData) => {
  await writeFile(joinPath(logsFolder(), path3), logData);
};

// ../app/dist/cli/services/app-logs/dev/write-app-logs.js
var writeAppLogsToFile = async ({ appLog, appLogPayload, apiKey, stdout }) => {
  let identifier = randomUUID().substring(0, 6), fileName = `${formatTimestampToFilename(appLog.log_timestamp)}_${appLog.source_namespace}_${appLog.source}_${identifier}.json`, path3 = joinPath(apiKey, fileName), fullOutputPath = joinPath(getLogsDir(), path3);
  try {
    return await writeLog(path3, toFormattedAppLogJson(appLog, appLogPayload)), {
      fullOutputPath,
      identifier
    };
  } catch (error) {
    throw stdout.write(`Error while writing log to file: ${error}
`), error;
  }
};
function formatTimestampToFilename(logTimestamp) {
  let date = new Date(logTimestamp), year = date.getUTCFullYear(), month = (date.getUTCMonth() + 1).toString().padStart(2, "0"), day = date.getUTCDate().toString().padStart(2, "0"), hours = date.getUTCHours().toString().padStart(2, "0"), minutes = date.getUTCMinutes().toString().padStart(2, "0"), seconds = date.getUTCSeconds().toString().padStart(2, "0"), milliseconds = date.getUTCMilliseconds().toString().padStart(3, "0");
  return `${year}${month}${day}_${hours}${minutes}${seconds}_${milliseconds}Z`;
}

// ../app/dist/cli/services/app-logs/dev/poll-app-logs.js
var pollAppLogs = async ({ stdout, appLogsFetchInput: { jwtToken, cursor }, apiKey, resubscribeCallback }) => {
  try {
    let nextJwtToken = jwtToken, retryIntervalMs = POLLING_INTERVAL_MS, httpResponse = await fetchAppLogs(jwtToken, cursor), response = await httpResponse.json(), { errors: errors2 } = response;
    if (errors2) {
      let errorResponse = {
        errors: errors2.map((error) => ({ message: error, status: httpResponse.status }))
      }, result = await handleFetchAppLogsError({
        response: errorResponse,
        onThrottle: (retryIntervalMs2) => {
          outputWarn("Request throttled while polling app logs."), outputWarn(`Retrying in ${retryIntervalMs2 / 1e3} seconds.`);
        },
        onUnknownError: (retryIntervalMs2) => {
          outputWarn("Error while polling app logs."), outputWarn(`Retrying in ${retryIntervalMs2 / 1e3} seconds.`);
        },
        onResubscribe: () => resubscribeCallback()
      });
      result.nextJwtToken && (nextJwtToken = result.nextJwtToken), retryIntervalMs = result.retryIntervalMs;
    }
    let data = response;
    if (data.app_logs) {
      let { app_logs: appLogs } = data;
      for (let log of appLogs) {
        let payload = JSON.parse(log.payload);
        await useConcurrentOutputContext({ outputPrefix: log.source, stripAnsi: !1 }, async () => {
          log.log_type === LOG_TYPE_FUNCTION_RUN ? (handleFunctionRunLog(log, payload, stdout), payload = new FunctionRunLog(camelcaseKeys(payload, { deep: !0 }))) : log.log_type.startsWith(LOG_TYPE_FUNCTION_NETWORK_ACCESS) ? handleFunctionNetworkAccessLog(log, payload, stdout) : stdout.write(JSON.stringify(payload));
          let logFile = await writeAppLogsToFile({
            appLog: log,
            appLogPayload: payload,
            apiKey,
            stdout
          });
          stdout.write(outputContent`${outputToken.gray("\u2514 ")}${outputToken.link("Open log file", `file://${logFile.fullOutputPath}`, `Log: ${logFile.fullOutputPath}`)} ${outputToken.gray(`(${logFile.identifier})`)}\n`.value);
        });
      }
    }
    let cursorFromResponse = data?.cursor;
    setTimeout(() => {
      pollAppLogs({
        stdout,
        appLogsFetchInput: {
          jwtToken: nextJwtToken,
          cursor: cursorFromResponse || cursor
        },
        apiKey,
        resubscribeCallback
      }).catch((error) => {
        outputDebug(`Unexpected error during polling: ${error}}
`);
      });
    }, retryIntervalMs);
  } catch (error) {
    outputWarn("Error while polling app logs."), outputWarn(`Retrying in ${POLLING_ERROR_RETRY_INTERVAL_MS / 1e3} seconds.`), outputDebug(`${error}}
`), setTimeout(() => {
      pollAppLogs({
        stdout,
        appLogsFetchInput: {
          jwtToken,
          cursor: void 0
        },
        apiKey,
        resubscribeCallback
      }).catch((error2) => {
        outputDebug(`Unexpected error during polling: ${error2}}
`);
      });
    }, POLLING_ERROR_RETRY_INTERVAL_MS);
  }
};
function handleFunctionRunLog(log, payload, stdout) {
  let fuel = (payload.fuel_consumed / ONE_MILLION).toFixed(4);
  log.status === "success" ? stdout.write(`Function export "${payload.export}" executed successfully using ${fuel}M instructions.`) : log.status === "failure" && stdout.write(`\u274C Function export "${payload.export}" failed to execute with error: ${payload.error_type}`);
  let logs2 = payload.logs;
  logs2.length > 0 && stdout.write(logs2.split(`
`).filter(Boolean).map((line) => outputContent`${outputToken.gray("\u2502 ")}${line}`.value).join(`
`));
}
function handleFunctionNetworkAccessLog(log, payload, stdout) {
  log.log_type === LOG_TYPE_RESPONSE_FROM_CACHE ? stdout.write("Function network access response retrieved from cache.") : log.log_type === LOG_TYPE_REQUEST_EXECUTION_IN_BACKGROUND ? payload.reason === REQUEST_EXECUTION_IN_BACKGROUND_NO_CACHED_RESPONSE_REASON ? stdout.write("Function network access request executing in background because there is no cached response.") : payload.reason === REQUEST_EXECUTION_IN_BACKGROUND_CACHE_ABOUT_TO_EXPIRE_REASON && stdout.write("Function network access request executing in background because the cached response is about to expire.") : log.log_type === LOG_TYPE_REQUEST_EXECUTION && (log.status === "success" ? stdout.write("Function network access request executed successfully.") : log.status === "failure" && stdout.write(`\u274C Function network access request failed to execute with error: ${payload.error}.`));
}

// ../app/dist/cli/services/dev/processes/app-logs-polling.js
async function setupAppLogsPollingProcess({ developerPlatformClient, subscription: { shopIds, apiKey } }) {
  let { token } = await developerPlatformClient.session();
  return {
    type: "app-logs-subscribe",
    prefix: "app-logs",
    function: subscribeAndStartPolling,
    options: {
      developerPlatformClient,
      appLogsSubscribeVariables: {
        shopIds,
        apiKey,
        token
      }
    }
  };
}
var subscribeAndStartPolling = async ({ stdout, stderr: _stderr, abortSignal: _abortSignal }, { developerPlatformClient, appLogsSubscribeVariables }) => {
  try {
    let jwtToken = await subscribeToAppLogs(developerPlatformClient, appLogsSubscribeVariables), apiKey = appLogsSubscribeVariables.apiKey;
    await createLogsDir(apiKey), await pollAppLogs({
      stdout,
      appLogsFetchInput: { jwtToken },
      apiKey,
      resubscribeCallback: () => subscribeToAppLogs(developerPlatformClient, appLogsSubscribeVariables)
    });
  } catch {
  }
};

// ../app/dist/cli/utilities/app/http-reverse-proxy.js
init_cjs_shims();
import * as http2 from "http";
async function getProxyingWebServer(rules, abortSignal) {
  let { default: httpProxy } = await import("./http-proxy-GGTVQ6CU.js"), proxy = httpProxy.createProxy(), server = http2.createServer(getProxyServerRequestListener(rules, proxy));
  return server.on("upgrade", getProxyServerWebsocketUpgradeListener(rules, proxy)), abortSignal.addEventListener("abort", () => {
    outputDebug("Closing reverse HTTP proxy"), server.close();
  }), { server };
}
function getProxyServerWebsocketUpgradeListener(rules, proxy) {
  return function(req, socket, head) {
    let target = match(rules, req, !0);
    if (target)
      return proxy.ws(req, socket, head, { target }, (err2) => {
        outputWarn(`Error forwarding websocket request: ${err2}`);
      });
    socket.destroy();
  };
}
function getProxyServerRequestListener(rules, proxy) {
  return function(req, res) {
    let target = match(rules, req);
    if (target)
      return proxy.web(req, res, { target }, (err2) => {
        outputWarn(`Error forwarding web request: ${err2}`);
      });
    outputDebug(`
Reverse HTTP proxy error - Invalid path: ${req.url}
These are the allowed paths:
${outputToken.json(JSON.stringify(rules))}
`), res.statusCode = 500, res.end(`Invalid path ${req.url}`);
  };
}
function match(rules, req, websocket = !1) {
  let path3 = req.url ?? "/";
  for (let pathPrefix in rules)
    if (path3.startsWith(pathPrefix))
      return rules[pathPrefix];
  return websocket && rules.websocket ? rules.websocket : rules.default;
}

// ../app/dist/cli/services/dev/processes/setup-dev-processes.js
async function setupDevProcesses({ localApp, remoteAppUpdated, developerPlatformClient, remoteApp, storeFqdn, storeId, commandOptions, network, graphiqlPort, graphiqlKey }) {
  let apiKey = remoteApp.apiKey, apiSecret = remoteApp.apiSecret ?? "", appPreviewUrl = buildAppURLForWeb(storeFqdn, apiKey), env = getEnvironmentVariables(), shouldRenderGraphiQL = !isTruthy(env[environmentVariableNames.disableGraphiQLExplorer]), shouldPerformAppLogPolling = localApp.allExtensions.some((extension) => extension.isFunctionExtension), processes = [
    ...await setupWebProcesses({
      webs: localApp.webs,
      proxyUrl: network.proxyUrl,
      frontendPort: network.frontendPort,
      backendPort: network.backendPort,
      apiKey,
      apiSecret,
      scopes: getAppScopes(localApp.configuration)
    }),
    shouldRenderGraphiQL ? await setupGraphiQLServerProcess({
      appName: remoteApp.title,
      appUrl: appPreviewUrl,
      port: graphiqlPort,
      apiKey,
      apiSecret,
      key: graphiqlKey,
      storeFqdn
    }) : void 0,
    await setupPreviewableExtensionsProcess({
      allExtensions: localApp.allExtensions,
      storeFqdn,
      storeId,
      apiKey,
      subscriptionProductUrl: commandOptions.subscriptionProductUrl,
      checkoutCartUrl: commandOptions.checkoutCartUrl,
      proxyUrl: network.proxyUrl,
      appName: localApp.name,
      appDotEnvFile: localApp.dotenv,
      grantedScopes: remoteApp.grantedScopes,
      appId: remoteApp.id,
      appDirectory: localApp.directory
    }),
    await setupDraftableExtensionsProcess({
      localApp,
      remoteApp,
      apiKey,
      developerPlatformClient,
      proxyUrl: network.proxyUrl
    }),
    commandOptions.devPreview ? await setupPreviewThemeAppExtensionsProcess2({
      allExtensions: localApp.allExtensions,
      storeFqdn,
      developerPlatformClient,
      theme: commandOptions.theme,
      themeExtensionPort: commandOptions.themeExtensionPort
    }) : await setupPreviewThemeAppExtensionsProcess({
      allExtensions: localApp.allExtensions,
      storeFqdn,
      apiKey,
      developerPlatformClient,
      theme: commandOptions.theme,
      themeExtensionPort: commandOptions.themeExtensionPort,
      notify: commandOptions.notify
    }),
    setupSendUninstallWebhookProcess({
      webs: localApp.webs,
      backendPort: network.backendPort,
      frontendPort: network.frontendPort,
      developerPlatformClient,
      storeFqdn,
      apiSecret,
      remoteAppUpdated
    }),
    shouldPerformAppLogPolling ? await setupAppLogsPollingProcess({
      developerPlatformClient,
      subscription: {
        shopIds: [storeId],
        apiKey
      }
    }) : void 0
  ].filter(stripUndefineds), processesWithProxy = await setPortsAndAddProxyProcess(processes, network.proxyPort), previewUrl = processesWithProxy.filter((process2) => process2.type === "previewable-extension").length > 0 ? `${network.proxyUrl}/extensions/dev-console` : appPreviewUrl;
  return {
    processes: processesWithProxy,
    previewUrl,
    graphiqlUrl: shouldRenderGraphiQL ? `http://localhost:${graphiqlPort}/graphiql${graphiqlKey ? `?key=${graphiqlKey}` : ""}` : void 0
  };
}
var stripUndefineds = (process2) => process2 !== void 0 && process2 !== !1;
async function setPortsAndAddProxyProcess(processes, proxyPort) {
  let processesAndRules = await Promise.all(processes.map(async (process2) => {
    let rules = {};
    if (process2.type === "web" && process2.options.roles.includes(WebType.Frontend)) {
      let targetPort = process2.options.portFromConfig || process2.options.port;
      rules.default = `http://localhost:${targetPort}`;
      let hmrServer = process2.options.hmrServerOptions;
      hmrServer && (rules.websocket = `http://localhost:${hmrServer.port}`, hmrServer.httpPaths.forEach((path3) => rules[path3] = `http://localhost:${hmrServer.port}`)), process2.options.port = targetPort;
    } else if (process2.type === "previewable-extension") {
      let targetPort = await getAvailableTCPPort();
      rules[process2.options.pathPrefix] = `http://localhost:${targetPort}`, process2.options.port = targetPort;
    }
    return { process: process2, rules };
  })), newProcesses = processesAndRules.map(({ process: process2 }) => process2), allRules = processesAndRules.map(({ rules }) => rules).reduce((acc, rules) => ({ ...acc, ...rules }), {});
  return Object.keys(allRules).length > 0 && newProcesses.push({
    type: "proxy-server",
    prefix: "proxy",
    function: startProxyServer,
    options: {
      port: proxyPort,
      rules: allRules
    }
  }), newProcesses;
}
var startProxyServer = async ({ abortSignal }, { port, rules }) => {
  let { server } = await getProxyingWebServer(rules, abortSignal);
  await server.listen(port);
};

// ../app/dist/cli/services/dev/ui.js
init_cjs_shims();

// ../app/dist/cli/services/dev/ui/components/Dev.js
init_cjs_shims();

// ../cli-kit/dist/public/node/ui/hooks.js
init_cjs_shims();

// ../app/dist/cli/services/dev/ui/components/Dev.js
var import_react7 = __toESM(require_react(), 1);

// ../cli-kit/dist/public/node/ink.js
init_cjs_shims();

// ../app/dist/cli/services/dev/ui/components/Dev.js
var calculatePrefixColumnSize = (processes, extensions) => Math.max(...processes.map((process2) => process2.prefix.length), ...extensions.map((extension) => extension.handle.length)), Dev3 = ({ abortController, processes, previewUrl, graphiqlUrl = "", graphiqlPort, app, pollingTime = 5e3, developerPreview, isEditionWeek: isEditionWeek2 }) => {
  let { canEnablePreviewMode: canEnablePreviewMode2, developmentStorePreviewEnabled } = app, { isRawModeSupported: canUseShortcuts } = use_stdin_default(), pollingInterval = (0, import_react7.useRef)(), localhostGraphiqlUrl = `http://localhost:${graphiqlPort}/graphiql`, defaultStatusMessage = `Preview URL: ${previewUrl}${graphiqlUrl ? `
GraphiQL URL: ${localhostGraphiqlUrl}` : ""}`, [statusMessage, setStatusMessage] = (0, import_react7.useState)(defaultStatusMessage), { isAborted } = useAbortSignal(abortController.signal, async (err2) => {
    err2 ? setStatusMessage("Shutting down dev because of an error ...") : (setStatusMessage("Shutting down dev ..."), setTimeout(() => {
      isUnitTest() || treeKill(process.pid, "SIGINT", !1, () => {
        process.exit(0);
      });
    }, 2e3)), clearInterval(pollingInterval.current), await developerPreview.disable();
  }), [devPreviewEnabled, setDevPreviewEnabled] = (0, import_react7.useState)(!0), [error, setError] = (0, import_react7.useState)(void 0), errorHandledProcesses = (0, import_react7.useMemo)(() => processes.map((process2) => ({
    ...process2,
    action: async (stdout, stderr, signal) => {
      try {
        return await process2.action(stdout, stderr, signal);
      } catch (error2) {
        abortController.abort(error2);
      }
    }
  })), [processes, abortController]);
  (0, import_react7.useEffect)(() => {
    let pollDevPreviewMode = async () => {
      try {
        let enabled = await developerPreview.fetchMode();
        setDevPreviewEnabled(enabled ?? !1), setError("");
      } catch {
        setError("Failed to fetch the latest status of the development store preview, trying again in 5 seconds.");
      }
    }, enablePreviewMode = async () => {
      try {
        await developerPreview.enable(), setError("");
      } catch {
        setError("Failed to turn on development store preview automatically.\nTry turning it on manually by pressing `d`."), setDevPreviewEnabled(!!developmentStorePreviewEnabled);
      }
    };
    if (canEnablePreviewMode2) {
      enablePreviewMode();
      let startPolling = () => setInterval(
        // eslint-disable-next-line @typescript-eslint/no-misused-promises
        () => pollDevPreviewMode(),
        pollingTime
      );
      pollingInterval.current = startPolling();
    }
    return () => {
      clearInterval(pollingInterval.current);
    };
  }, [canEnablePreviewMode2]), use_input_default((input, key) => {
    handleCtrlC(input, key, () => abortController.abort()), (async () => {
      try {
        if (setError(""), input === "p" && previewUrl)
          await metadata_default.addPublicMetadata(() => ({
            cmd_dev_preview_url_opened: !0
          })), await openURL(previewUrl);
        else if (input === "g" && graphiqlUrl)
          await metadata_default.addPublicMetadata(() => ({
            cmd_dev_graphiql_opened: !0
          })), await openURL(localhostGraphiqlUrl);
        else if (input === "q")
          abortController.abort();
        else if (input === "e" && isEditionWeek2)
          await openURL("https://shopify.link/yQmk");
        else if (input === "d" && canEnablePreviewMode2) {
          await metadata_default.addPublicMetadata(() => ({
            cmd_dev_dev_preview_toggle_used: !0
          }));
          let newDevPreviewEnabled = !devPreviewEnabled;
          setDevPreviewEnabled(newDevPreviewEnabled);
          try {
            if (!await developerPreview.update(newDevPreviewEnabled))
              throw new Error(`Failed to turn ${newDevPreviewEnabled ? "on" : "off"} development store preview.`);
          } catch {
            setDevPreviewEnabled(devPreviewEnabled), setError(`Failed to turn ${newDevPreviewEnabled ? "on" : "off"} development store preview.`);
          }
        }
      } catch {
        setError("Failed to handle your input.");
      }
    })();
  }, { isActive: !!canUseShortcuts });
  let now = /* @__PURE__ */ new Date(), season = now.getMonth() > 3 ? "Summer" : "Winter", year = now.getFullYear();
  return import_react7.default.createElement(
    import_react7.default.Fragment,
    null,
    import_react7.default.createElement(ConcurrentOutput, { processes: errorHandledProcesses, prefixColumnSize: calculatePrefixColumnSize(errorHandledProcesses, app.extensions), abortSignal: abortController.signal, keepRunningAfterProcessesResolve: !0 }),
    isAborted ? null : import_react7.default.createElement(
      Box_default,
      { marginY: 1, paddingTop: 1, flexDirection: "column", flexGrow: 1, borderStyle: "single", borderBottom: !1, borderLeft: !1, borderRight: !1, borderTop: !0 },
      canUseShortcuts ? import_react7.default.createElement(
        Box_default,
        { flexDirection: "column" },
        isEditionWeek2 ? import_react7.default.createElement(
          Text,
          null,
          figures_default.pointerSmall,
          " Press ",
          import_react7.default.createElement(Text, { bold: !0 }, "e"),
          " ",
          figures_default.lineVertical,
          " check out ",
          season,
          " Edition",
          ` ${year}`,
          ", live NOW with 100+ product announcements!"
        ) : null,
        canEnablePreviewMode2 ? import_react7.default.createElement(
          Text,
          null,
          figures_default.pointerSmall,
          " Press ",
          import_react7.default.createElement(Text, { bold: !0 }, "d"),
          " ",
          figures_default.lineVertical,
          " toggle development store preview: ",
          devPreviewEnabled ? import_react7.default.createElement(Text, { color: "green" }, "\u2714 on") : import_react7.default.createElement(Text, { color: "red" }, "\u2716 off")
        ) : null,
        graphiqlUrl ? import_react7.default.createElement(
          Text,
          null,
          figures_default.pointerSmall,
          " Press ",
          import_react7.default.createElement(Text, { bold: !0 }, "g"),
          " ",
          figures_default.lineVertical,
          " open GraphiQL (Admin API) in your browser"
        ) : null,
        import_react7.default.createElement(
          Text,
          null,
          figures_default.pointerSmall,
          " Press ",
          import_react7.default.createElement(Text, { bold: !0 }, "p"),
          " ",
          figures_default.lineVertical,
          " preview in your browser"
        ),
        import_react7.default.createElement(
          Text,
          null,
          figures_default.pointerSmall,
          " Press ",
          import_react7.default.createElement(Text, { bold: !0 }, "q"),
          " ",
          figures_default.lineVertical,
          " quit"
        )
      ) : null,
      import_react7.default.createElement(
        Box_default,
        { marginTop: canUseShortcuts ? 1 : 0 },
        import_react7.default.createElement(Text, null, statusMessage)
      ),
      error ? import_react7.default.createElement(Text, { color: "red" }, error) : null
    )
  );
};

// ../app/dist/cli/services/dev/ui.js
var import_react8 = __toESM(require_react(), 1);
async function outputUpdateURLsResult(updated, urls, remoteApp, localApp) {
  let dashboardURL = await partnersURL(remoteApp.organizationId, remoteApp.id);
  if (remoteApp.newApp)
    renderInfo({
      headline: `For your convenience, we've given your app a default URL: ${urls.applicationUrl}.`,
      body: [
        "You can update your app's URL anytime in the",
        dashboardURL,
        "But once your app is live, updating its URL will disrupt user access."
      ]
    });
  else if (!updated)
    if (isCurrentAppSchema(localApp.configuration)) {
      let fileName = basename(localApp.configuration.path), configName = getAppConfigurationShorthand(fileName), pushCommandArgs = configName ? [`--config=${configName}`] : [];
      renderInfo({
        body: [
          `To update URLs manually, add the following URLs to ${fileName} under auth > redirect_urls and run
`,
          {
            command: formatPackageManagerCommand(localApp.packageManager, "shopify app config push", ...pushCommandArgs)
          },
          `

`,
          { list: { items: urls.redirectUrlWhitelist } }
        ]
      });
    } else
      renderInfo({
        body: [
          "To make URL updates manually, you can add the following URLs as redirects in your",
          dashboardURL,
          { char: ":" },
          `

`,
          { list: { items: urls.redirectUrlWhitelist } }
        ]
      });
}
async function renderDev({ processes, previewUrl, app, abortController, graphiqlUrl, graphiqlPort, developerPreview, shopFqdn }) {
  if (terminalSupportsRawMode(process.stdin))
    return render(import_react8.default.createElement(Dev3, { processes, abortController, previewUrl, app, graphiqlUrl, graphiqlPort, developerPreview, isEditionWeek: isEditionWeek(), shopFqdn }), {
      exitOnCtrlC: !1
    });
  await renderDevNonInteractive({ processes, app, abortController, developerPreview, shopFqdn });
}
async function partnersURL(organizationId, appId) {
  return {
    link: {
      label: "Partners Dashboard",
      url: `https://${await partnersFqdn()}/${organizationId}/apps/${appId}/edit`
    }
  };
}
async function renderDevNonInteractive({ processes, app: { canEnablePreviewMode: canEnablePreviewMode2 }, abortController, developerPreview }) {
  return canEnablePreviewMode2 && (await developerPreview.enable(), abortController?.signal.addEventListener("abort", async () => {
    await developerPreview.disable();
  })), Promise.all(processes.map(async (concurrentProcess) => {
    await concurrentProcess.action(process.stdout, process.stderr, abortController.signal);
  }));
}
function isEditionWeek() {
  if (isTruthy(process.env.IS_EDITION_WEEK))
    return !0;
  if (isUnitTest())
    return !1;
  let editionStart = /* @__PURE__ */ new Date("2024-01-31T17:00:00.000Z"), editionWeekEnd = /* @__PURE__ */ new Date("2024-02-07T17:00:00.000Z"), now = /* @__PURE__ */ new Date();
  return now >= editionStart && now <= editionWeekEnd;
}

// ../app/dist/cli/services/extensions/common.js
init_cjs_shims();
import { fileURLToPath as fileURLToPath6 } from "url";
async function ensureDownloadedExtensionFlavorExists(extensionFlavor, templateDownloadDir) {
  let templatePath = extensionFlavor?.path || "", origin = joinPath(templateDownloadDir, templatePath);
  if (!await fileExists(origin))
    throw new AbortError(`
The extension is not available for ${extensionFlavor?.value}`);
  return origin;
}
async function ensureLocalExtensionFlavorExists(extensionFlavor) {
  let templatePath = extensionFlavor?.path || "", templateDirectory = await findPathUp(templatePath, {
    cwd: dirname(fileURLToPath6(import.meta.url)),
    type: "directory"
  });
  if (!templateDirectory)
    throw new AbortError(`
The extension is not available for ${extensionFlavor?.value}`);
  return templateDirectory;
}
async function ensureExtensionDirectoryExists({ name, app }) {
  let hyphenizedName = hyphenate(name), extensionDirectory = joinPath(app.directory, blocks.extensions.directoryName, hyphenizedName);
  if (await fileExists(extensionDirectory))
    throw new AbortError(`
A directory with this name (${hyphenizedName}) already exists.
Choose a new name for your extension.`);
  return await mkdir(extensionDirectory), await touchFile(joinPath(extensionDirectory, configurationFileNames.lockFile)), extensionDirectory;
}
async function canEnablePreviewMode({ localApp, developerPlatformClient, apiKey, organizationId }) {
  let { dashboardManagedExtensionRegistrations } = (await developerPlatformClient.appExtensionRegistrations({
    id: apiKey,
    apiKey,
    organizationId
  })).app;
  return dashboardManagedExtensionRegistrations.length > 0 || localApp.allExtensions.filter((ext) => ext.isThemeExtension).length > 0 || localApp.allExtensions.length > 0;
}

// ../app/dist/cli/utilities/analytics.js
init_cjs_shims();
async function getAnalyticsTunnelType(options, tunnelUrl) {
  return tunnelUrl ? tunnelUrl.includes("localhost") ? "localhost" : (await getListOfTunnelPlugins(options)).plugins.find((plugin) => tunnelUrl?.includes(plugin)) ?? "custom" : void 0;
}

// ../app/dist/cli/services/dev.js
async function dev2(commandOptions) {
  let config2 = await prepareForDev(commandOptions);
  await actionsBeforeSettingUpDevProcesses(config2);
  let { processes, graphiqlUrl, previewUrl } = await setupDevProcesses(config2);
  await actionsBeforeLaunchingDevProcesses(config2), await launchDevProcesses({ processes, previewUrl, graphiqlUrl, config: config2 });
}
async function prepareForDev(commandOptions) {
  let tunnelPort = await getAvailableTCPPort(), tunnelClient;
  !commandOptions.tunnelUrl && !commandOptions.noTunnel && (tunnelClient = await startTunnelPlugin(commandOptions.commandConfig, tunnelPort, "cloudflare"));
  let { configuration } = await loadAppConfiguration({
    ...commandOptions,
    userProvidedConfigName: commandOptions.configName
  }), developerPlatformClient = selectDeveloperPlatformClient({ configuration }), devContextOptions = { ...commandOptions, developerPlatformClient }, { storeFqdn, storeId, remoteApp, remoteAppUpdated, updateURLs: cachedUpdateURLs, localApp: app } = await ensureDevContext(devContextOptions);
  developerPlatformClient = remoteApp.developerPlatformClient ?? developerPlatformClient;
  let apiKey = remoteApp.apiKey, localApp = app;
  !commandOptions.skipDependenciesInstallation && !localApp.usesWorkspaces && (localApp = await installAppDependencies(localApp));
  let graphiqlPort = commandOptions.graphiqlPort || await getAvailableTCPPort(ports.graphiql), { graphiqlKey } = commandOptions;
  graphiqlPort !== (commandOptions.graphiqlPort || ports.graphiql) && renderWarning({
    headline: [
      "A random port will be used for GraphiQL because",
      { command: `${ports.graphiql}` },
      "is not available."
    ],
    body: [
      "If you want to keep your session in GraphiQL, you can choose a different one by setting the",
      { command: "--graphiql-port" },
      "flag."
    ]
  });
  let { webs, ...network } = await setupNetworkingOptions(localApp.webs, graphiqlPort, {
    noTunnel: commandOptions.noTunnel,
    tunnelUrl: commandOptions.tunnelUrl
  }, tunnelClient, remoteApp.configuration);
  localApp.webs = webs;
  let partnerUrlsUpdated = await handleUpdatingOfPartnerUrls(webs, commandOptions.update, network, localApp, cachedUpdateURLs, remoteApp, apiKey, developerPlatformClient);
  return {
    storeFqdn,
    storeId,
    remoteApp,
    remoteAppUpdated,
    localApp,
    developerPlatformClient,
    commandOptions,
    network,
    partnerUrlsUpdated,
    graphiqlPort,
    graphiqlKey
  };
}
async function actionsBeforeSettingUpDevProcesses({ localApp, remoteApp }) {
  if (isCurrentAppSchema(localApp.configuration) && !localApp.configuration.access_scopes?.use_legacy_install_flow && localApp.configuration.access_scopes?.scopes !== remoteApp.configuration?.access_scopes?.scopes) {
    let nextSteps = [
      [
        "Run",
        { command: formatPackageManagerCommand(localApp.packageManager, "shopify app deploy") },
        "to push your scopes to the Partner Dashboard"
      ]
    ];
    renderWarning({
      headline: ["The scopes in your TOML don't match the scopes in your Partner Dashboard"],
      body: [
        `Scopes in ${basename(localApp.configuration.path)}:`,
        scopesMessage(getAppScopesArray(localApp.configuration)),
        `
`,
        "Scopes in Partner Dashboard:",
        scopesMessage(remoteApp.configuration?.access_scopes?.scopes?.split(",") || [])
      ],
      nextSteps
    });
  }
}
async function actionsBeforeLaunchingDevProcesses(config2) {
  setPreviousAppId(config2.commandOptions.directory, config2.remoteApp.apiKey), await logMetadataForDev({
    devOptions: config2.commandOptions,
    tunnelUrl: config2.network.proxyUrl,
    shouldUpdateURLs: config2.partnerUrlsUpdated,
    storeFqdn: config2.storeFqdn
  }), await reportAnalyticsEvent({ config: config2.commandOptions.commandConfig, exitMode: "ok" });
}
async function handleUpdatingOfPartnerUrls(webs, commandSpecifiedToUpdate, network, localApp, cachedUpdateURLs, remoteApp, apiKey, developerPlatformClient) {
  let { backendConfig, frontendConfig } = frontAndBackendConfig(webs), shouldUpdateURLs = !1;
  if ((frontendConfig || backendConfig) && commandSpecifiedToUpdate) {
    let newURLs = generatePartnersURLs(network.proxyUrl, webs.map(({ configuration }) => configuration.auth_callback_path).find((path3) => path3), isCurrentAppSchema(localApp.configuration) ? localApp.configuration.app_proxy : void 0);
    shouldUpdateURLs = await shouldOrPromptUpdateURLs({
      currentURLs: network.currentUrls,
      appDirectory: localApp.directory,
      cachedUpdateURLs,
      newApp: remoteApp.newApp,
      localApp,
      apiKey
    }), shouldUpdateURLs && await updateURLs(newURLs, apiKey, developerPlatformClient, localApp), await outputUpdateURLsResult(shouldUpdateURLs, newURLs, remoteApp, localApp);
  }
  return shouldUpdateURLs;
}
async function setupNetworkingOptions(webs, graphiqlPort, frontEndOptions, tunnelClient, remoteAppConfig) {
  let { backendConfig, frontendConfig } = frontAndBackendConfig(webs);
  await validateCustomPorts(webs, graphiqlPort);
  let [{ frontendUrl, frontendPort: proxyPort, usingLocalhost }, backendPort, currentUrls] = await Promise.all([
    generateFrontendURL({
      ...frontEndOptions,
      tunnelClient
    }),
    getBackendPort() || backendConfig?.configuration.port || getAvailableTCPPort(),
    getURLs(remoteAppConfig)
  ]), proxyUrl = usingLocalhost ? `${frontendUrl}:${proxyPort}` : frontendUrl, frontendPort = frontendConfig?.configuration.port;
  return frontendConfig && (frontendPort || (frontendPort = frontendConfig === backendConfig ? backendPort : await getAvailableTCPPort()), frontendConfig.configuration.port = frontendPort), frontendPort = frontendPort ?? await getAvailableTCPPort(), {
    proxyUrl,
    proxyPort,
    frontendPort,
    backendPort,
    currentUrls,
    webs
  };
}
async function launchDevProcesses({ processes, previewUrl, graphiqlUrl, config: config2 }) {
  let abortController = new AbortController2(), processesForTaskRunner = processes.map((process2) => ({
    prefix: process2.prefix,
    action: async (stdout, stderr, signal) => {
      let fn = process2.function;
      return fn({ stdout, stderr, abortSignal: signal }, process2.options);
    }
  })), apiKey = config2.remoteApp.apiKey, developerPlatformClient = config2.developerPlatformClient, app = {
    canEnablePreviewMode: await canEnablePreviewMode({
      localApp: config2.localApp,
      developerPlatformClient,
      apiKey,
      organizationId: config2.remoteApp.organizationId
    }),
    developmentStorePreviewEnabled: config2.remoteApp.developmentStorePreviewEnabled,
    apiKey,
    developerPlatformClient,
    extensions: config2.localApp.allExtensions
  };
  return renderDev({
    processes: processesForTaskRunner,
    previewUrl,
    graphiqlUrl,
    graphiqlPort: config2.graphiqlPort,
    app,
    abortController,
    developerPreview: developerPreviewController(apiKey, developerPlatformClient),
    shopFqdn: config2.storeFqdn
  });
}
function developerPreviewController(apiKey, developerPlatformClient) {
  let refreshToken2 = async () => {
    await developerPlatformClient.refreshToken();
  }, withRefreshToken = async (fn) => {
    try {
      return await performActionWithRetryAfterRecovery(async () => fn(developerPlatformClient), refreshToken2);
    } catch (err2) {
      throw outputDebug("Failed to refresh token"), err2;
    }
  };
  return {
    fetchMode: async () => withRefreshToken(async (developerPlatformClient2) => !!await fetchAppPreviewMode(apiKey, developerPlatformClient2)),
    enable: async () => withRefreshToken(async (developerPlatformClient2) => {
      await enableDeveloperPreview({ apiKey, developerPlatformClient: developerPlatformClient2 });
    }),
    disable: async () => withRefreshToken(async (developerPlatformClient2) => {
      await disableDeveloperPreview({ apiKey, developerPlatformClient: developerPlatformClient2 });
    }),
    update: async (state) => withRefreshToken(async (developerPlatformClient2) => developerPreviewUpdate({ apiKey, developerPlatformClient: developerPlatformClient2, enabled: state }))
  };
}
async function logMetadataForDev(options) {
  let tunnelType = await getAnalyticsTunnelType(options.devOptions.commandConfig, options.tunnelUrl);
  await metadata_default.addPublicMetadata(() => ({
    cmd_dev_tunnel_type: tunnelType,
    cmd_dev_tunnel_custom_hash: tunnelType === "custom" ? hashString(options.tunnelUrl) : void 0,
    cmd_dev_urls_updated: options.shouldUpdateURLs,
    store_fqdn_hash: hashString(options.storeFqdn),
    cmd_app_dependency_installation_skipped: options.devOptions.skipDependenciesInstallation,
    cmd_app_reset_used: options.devOptions.reset
  })), await metadata_default.addSensitiveMetadata(() => ({
    store_fqdn: options.storeFqdn,
    cmd_dev_tunnel_custom: tunnelType === "custom" ? options.tunnelUrl : void 0
  }));
}
function scopesMessage(scopes) {
  return {
    list: {
      items: scopes.length === 0 ? ["No scopes"] : scopes
    }
  };
}
async function validateCustomPorts(webConfigs, graphiqlPort) {
  let allPorts = webConfigs.map((config2) => config2.configuration.port).filter((port) => port), duplicatedPort = allPorts.find((port, index) => allPorts.indexOf(port) !== index);
  if (duplicatedPort)
    throw new AbortError(`Found port ${duplicatedPort} for multiple webs.`, "Please define a unique port for each web.");
  await Promise.all([
    ...allPorts.map(async (port) => {
      if (!await checkPortAvailability(port))
        throw new AbortError(`Hard-coded port ${port} is not available, please choose a different one.`);
    }),
    (async () => {
      if (!await checkPortAvailability(graphiqlPort)) {
        let errorMessage2 = `Port ${graphiqlPort} is not available for serving GraphiQL.`, tryMessage = ["Choose a different port by setting the", { command: "--graphiql-port" }, "flag."];
        throw new AbortError(errorMessage2, tryMessage);
      }
    })()
  ]);
}
function setPreviousAppId(directory, apiKey) {
  setCachedAppInfo({ directory, previousAppId: apiKey });
}

// ../app/dist/cli/commands/app/dev.js
var import_core33 = __toESM(require_lib(), 1);
var _a18, Dev4 = class extends AppCommand {
  static analyticsStopCommand() {
    return "app dev stop";
  }
  async run() {
    let { flags } = await this.parse(_a18);
    flags["api-key"] || process.env.SHOPIFY_API_KEY && (flags["api-key"] = process.env.SHOPIFY_API_KEY), flags["api-key"] && await showApiKeyDeprecationWarning();
    let apiKey = flags["client-id"] || flags["api-key"];
    await addPublicMetadata(() => ({
      cmd_app_dependency_installation_skipped: flags["skip-dependencies-installation"],
      cmd_app_reset_used: flags.reset,
      cmd_dev_tunnel_type: flags["tunnel-url"] ? "custom" : "cloudflare"
    }));
    let commandConfig = this.config;
    await checkFolderIsValidApp(flags.path);
    let devOptions = {
      directory: flags.path,
      configName: flags.config,
      apiKey,
      storeFqdn: flags.store,
      reset: flags.reset,
      update: !flags["no-update"],
      skipDependenciesInstallation: flags["skip-dependencies-installation"],
      commandConfig,
      subscriptionProductUrl: flags["subscription-product-url"],
      checkoutCartUrl: flags["checkout-cart-url"],
      tunnelUrl: flags["tunnel-url"],
      noTunnel: flags["no-tunnel"],
      theme: flags.theme,
      themeExtensionPort: flags["theme-app-extension-port"],
      notify: flags.notify,
      graphiqlPort: flags["graphiql-port"],
      graphiqlKey: flags["graphiql-key"],
      devPreview: flags["dev-preview"]
    };
    await dev2(devOptions);
  }
};
_a18 = Dev4;
Dev4.summary = "Run the app.";
Dev4.descriptionWithMarkdown = `[Builds the app](https://shopify.dev/docs/api/shopify-cli/app/app-build) and lets you preview it on a [development store](https://shopify.dev/docs/apps/tools/development-stores) or [Plus sandbox store](https://help.shopify.com/partners/dashboard/managing-stores/plus-sandbox-store).

  To preview your app on a development store or Plus sandbox store, Shopify CLI walks you through the following steps. If you've run \`dev\` before, then your settings are saved and some of these steps are skipped. You can reset these configurations using \`dev --reset\` to go through all of them again:

- Associating your project with an app associated with your Partner account or organization, or creating a new app.
- Selecting a development store or Plus sandbox store to use for testing. If you have only one store, then it's selected automatically.
- Installing your app on the store using the provided install link.
- Creating a tunnel between your local environment and the store using Cloudflare.

  You can use your own tunneling software instead, by passing your tunnel URL with the \`--tunnel-url\` flag.
- Updating the app URLs that are set in the Partner Dashboard.

  To avoid overwriting any URLs that are already set, select the No, never option. If you select this option, then you're provided with URLs that you can manually add in the Partner Dashboard so you can preview your app.

- Enabling development store preview for extensions.
- Serving [GraphiQL for the Admin API](https://shopify.dev/docs/apps/tools/graphiql-admin-api#use-a-local-graphiql-instance) using your app's credentials and access scopes.
- Building and serving your app and app extensions.

If you're using the PHP or Ruby app template, then you need to complete the following steps before you can preview your app for the first time:

- PHP: [Set up your Laravel app](https://github.com/Shopify/shopify-app-template-php#setting-up-your-laravel-app)
- Ruby: [Set up your Rails app](https://github.com/Shopify/shopify-app-template-ruby#setting-up-your-rails-app)

> Caution: To use a development store or Plus sandbox store with Shopify CLI, you need to be the store owner, or have a [staff account](https://help.shopify.com/manual/your-account/staff-accounts) on the store. Staff accounts are created automatically the first time you access a development store with your Partner staff account through the Partner Dashboard.
`;
Dev4.description = _a18.descriptionWithoutMarkdown();
Dev4.flags = {
  ...globalFlags,
  ...appFlags,
  "api-key": import_core33.Flags.string({
    hidden: !0,
    description: "The API key of your app.",
    env: "SHOPIFY_FLAG_APP_API_KEY",
    exclusive: ["config"]
  }),
  "client-id": import_core33.Flags.string({
    hidden: !1,
    description: "The Client ID of your app.",
    env: "SHOPIFY_FLAG_CLIENT_ID",
    exclusive: ["config"]
  }),
  store: import_core33.Flags.string({
    hidden: !1,
    char: "s",
    description: "Store URL. Must be an existing development or Shopify Plus sandbox store.",
    env: "SHOPIFY_FLAG_STORE",
    parse: async (input) => normalizeStoreFqdn(input)
  }),
  reset: import_core33.Flags.boolean({
    hidden: !1,
    description: "Reset all your settings.",
    env: "SHOPIFY_FLAG_RESET",
    default: !1,
    exclusive: ["config"]
  }),
  "skip-dependencies-installation": import_core33.Flags.boolean({
    hidden: !1,
    description: "Skips the installation of dependencies. Deprecated, use workspaces instead.",
    env: "SHOPIFY_FLAG_SKIP_DEPENDENCIES_INSTALLATION",
    default: !1
  }),
  "no-update": import_core33.Flags.boolean({
    hidden: !1,
    description: "Skips the Partners Dashboard URL update step.",
    env: "SHOPIFY_FLAG_NO_UPDATE",
    default: !1
  }),
  "subscription-product-url": import_core33.Flags.string({
    hidden: !1,
    description: 'Resource URL for subscription UI extension. Format: "/products/{productId}"',
    env: "SHOPIFY_FLAG_SUBSCRIPTION_PRODUCT_URL"
  }),
  "checkout-cart-url": import_core33.Flags.string({
    hidden: !1,
    description: 'Resource URL for checkout UI extension. Format: "/cart/{productVariantID}:{productQuantity}"',
    env: "SHOPIFY_FLAG_CHECKOUT_CART_URL"
  }),
  "tunnel-url": import_core33.Flags.string({
    hidden: !1,
    description: 'Use a custom tunnel, it must be running before executing dev. Format: "https://my-tunnel-url:port".',
    env: "SHOPIFY_FLAG_TUNNEL_URL",
    exclusive: ["no-tunnel", "tunnel"]
  }),
  "no-tunnel": import_core33.Flags.boolean({
    hidden: !0,
    description: "Automatic creation of a tunnel is disabled. Service entry point will listen to localhost instead",
    env: "SHOPIFY_FLAG_NO_TUNNEL",
    default: !1,
    exclusive: ["tunnel-url", "tunnel"]
  }),
  theme: import_core33.Flags.string({
    hidden: !1,
    char: "t",
    description: "Theme ID or name of the theme app extension host theme.",
    env: "SHOPIFY_FLAG_THEME"
  }),
  "theme-app-extension-port": import_core33.Flags.integer({
    hidden: !1,
    description: "Local port of the theme app extension development server.",
    env: "SHOPIFY_FLAG_THEME_APP_EXTENSION_PORT"
  }),
  notify: import_core33.Flags.string({
    description: "The file path or URL. The file path is to a file that you want updated on idle. The URL path is where you want a webhook posted to report on file changes.",
    env: "SHOPIFY_FLAG_NOTIFY"
  }),
  "graphiql-port": import_core33.Flags.integer({
    hidden: !0,
    description: "Local port of the GraphiQL development server.",
    env: "SHOPIFY_FLAG_GRAPHIQL_PORT"
  }),
  "graphiql-key": import_core33.Flags.string({
    hidden: !0,
    description: "Key used to authenticate GraphiQL requests. Should be specified if exposing GraphiQL on a publicly accessible URL. By default, no key is required.",
    env: "SHOPIFY_FLAG_GRAPHIQL_KEY"
  }),
  "dev-preview": import_core33.Flags.boolean({
    hidden: !0,
    description: "Enables the developer preview for the upcoming `app dev` implementation for building theme app extensions.",
    env: "SHOPIFY_FLAG_BETA"
  })
};
var dev_default2 = Dev4;

// ../app/dist/cli/commands/app/logs.js
init_cjs_shims();

// ../app/dist/cli/services/logs.js
init_cjs_shims();

// ../app/dist/cli/services/app-logs/logs-command/ui.js
init_cjs_shims();

// ../app/dist/cli/services/app-logs/logs-command/ui/components/Logs.js
init_cjs_shims();

// ../app/dist/cli/services/app-logs/logs-command/ui/components/hooks/usePollAppLogs.js
init_cjs_shims();

// ../app/dist/cli/services/app-logs/logs-command/poll-app-logs.js
init_cjs_shims();
var pollAppLogs2 = async ({ jwtToken, cursor, filters }) => {
  let response = await fetchAppLogs(jwtToken, cursor, filters), responseJson = await response.json();
  if (!response.ok) {
    let errorResponse = responseJson;
    if (response.status === 401 || response.status === 429 || response.status >= 500)
      return {
        errors: [{ status: response.status, message: `${errorResponse.errors.join(", ")}` }]
      };
    throw new AbortError(`${errorResponse.errors.join(", ")} while fetching app logs`);
  }
  let data = responseJson, filteredLogs = filterLogs(data.app_logs, filters);
  return {
    cursor: data.cursor,
    appLogs: filteredLogs
  };
};
function filterLogs(appLogs, filters) {
  let filterLogs2 = appLogs;
  return (filters.status !== void 0 || filters.sources !== void 0) && (filterLogs2 = filterLogs2.filter((log) => {
    let statusMatch = filters.status === void 0 ? !0 : log.status === filters.status, sourceMatch = filters.sources === void 0 ? !0 : filters.sources.includes(`${log.source_namespace}.${log.source}`);
    return statusMatch && sourceMatch;
  })), filterLogs2;
}

// ../app/dist/cli/services/app-logs/logs-command/ui/components/hooks/usePollAppLogs.js
var import_react9 = __toESM(require_react(), 1);
function usePollAppLogs({ initialJwt, filters, resubscribeCallback }) {
  let [errors2, setErrors] = (0, import_react9.useState)([]), [appLogOutputs, setAppLogOutputs] = (0, import_react9.useState)([]);
  return (0, import_react9.useEffect)(() => {
    let poll = async ({ jwtToken, cursor, filters: filters2 }) => {
      let nextJwtToken = jwtToken, retryIntervalMs = POLLING_INTERVAL_MS, response = await pollAppLogs2({ jwtToken, cursor, filters: filters2 }), errorResponse = response;
      if (errorResponse.errors) {
        let result = await handleFetchAppLogsError({
          response: errorResponse,
          onThrottle: (retryIntervalMs2) => {
            setErrors(["Request throttled while polling app logs.", `Retrying in ${retryIntervalMs2 / 1e3}s`]);
          },
          onUnknownError: (retryIntervalMs2) => {
            setErrors(["Error while polling app logs", `Retrying in ${retryIntervalMs2 / 1e3}s`]);
          },
          onResubscribe: () => resubscribeCallback()
        });
        result.nextJwtToken && (nextJwtToken = result.nextJwtToken), retryIntervalMs = result.retryIntervalMs;
      } else
        setErrors((errors3) => errors3.length ? [] : errors3);
      let { cursor: nextCursor, appLogs } = response;
      if (appLogs)
        for (let log of appLogs) {
          let appLog, description, executionTime;
          switch (log.log_type) {
            case LOG_TYPE_FUNCTION_RUN:
              appLog = parseFunctionRunPayload(log.payload), description = `export "${appLog.export}" executed in ${(appLog.fuelConsumed / ONE_MILLION).toFixed(4)}M instructions`;
              break;
            case LOG_TYPE_RESPONSE_FROM_CACHE:
              appLog = parseNetworkAccessResponseFromCachePayload(log.payload), description = "network access response retrieved from cache";
              break;
            case LOG_TYPE_REQUEST_EXECUTION_IN_BACKGROUND:
              appLog = parseNetworkAccessRequestExecutionInBackgroundPayload(log.payload), description = "network access request executing in background";
              break;
            case LOG_TYPE_REQUEST_EXECUTION:
              appLog = parseNetworkAccessRequestExecutedPayload(log.payload), executionTime = appLog.connectTimeMs && appLog.writeReadTimeMs ? appLog.connectTimeMs + appLog.writeReadTimeMs : null, description = `network access request executed${executionTime ? ` in ${executionTime} ms` : ""}`;
              break;
            default:
              return;
          }
          let prefix = {
            status: log.status === "success" ? "Success" : "Failure",
            source: log.source,
            description,
            logTimestamp: formatLocalDate(log.log_timestamp)
          };
          setAppLogOutputs((prev) => [...prev, { appLog, prefix }]);
        }
      setTimeout(() => {
        poll({ jwtToken: nextJwtToken, cursor: nextCursor || cursor, filters: filters2 }).catch((error) => {
          throw error;
        });
      }, retryIntervalMs);
    };
    poll({ jwtToken: initialJwt, cursor: "", filters }).catch((error) => {
      throw error;
    });
  }, []), { appLogOutputs, errors: errors2 };
}

// ../app/dist/cli/services/app-logs/logs-command/ui/components/Logs.js
var import_react10 = __toESM(require_react(), 1);
var getBackgroundExecutionReasonMessage = (reason) => {
  switch (reason) {
    case BackgroundExecutionReason.NoCachedResponse:
      return "No cached response available";
    case BackgroundExecutionReason.CacheAboutToExpire:
      return "Cache is about to expire";
    default:
      return "Unknown reason";
  }
}, Logs = ({ pollOptions: { jwtToken, filters }, resubscribeCallback }) => {
  let { appLogOutputs, errors: errors2 } = usePollAppLogs({ filters, initialJwt: jwtToken, resubscribeCallback });
  return import_react10.default.createElement(
    import_react10.default.Fragment,
    null,
    appLogOutputs.map(({ appLog, prefix }, index) => import_react10.default.createElement(
      Box_default,
      { flexDirection: "column", key: index },
      import_react10.default.createElement(
        Box_default,
        { flexDirection: "row", gap: 1 },
        import_react10.default.createElement(
          Text,
          null,
          import_react10.default.createElement(
            Text,
            { color: "green" },
            prefix.logTimestamp,
            " "
          ),
          import_react10.default.createElement(
            Text,
            { color: "blueBright" },
            `${prefix.source}`,
            " "
          ),
          import_react10.default.createElement(
            Text,
            { color: prefix.status === "Success" ? "green" : "red" },
            prefix.status,
            " "
          ),
          import_react10.default.createElement(Text, null, prefix.description)
        )
      ),
      import_react10.default.createElement(
        Box_default,
        { flexDirection: "column", marginLeft: 4 },
        appLog instanceof FunctionRunLog && import_react10.default.createElement(
          import_react10.default.Fragment,
          null,
          import_react10.default.createElement(Text, null, appLog.logs),
          appLog.input && import_react10.default.createElement(
            import_react10.default.Fragment,
            null,
            import_react10.default.createElement(
              Text,
              null,
              "Input (",
              appLog.inputBytes,
              " bytes): "
            ),
            import_react10.default.createElement(Text, null, prettyPrintJsonIfPossible(appLog.input))
          ),
          appLog.output && import_react10.default.createElement(
            import_react10.default.Fragment,
            null,
            import_react10.default.createElement(
              Text,
              null,
              `
`,
              "Output (",
              appLog.outputBytes,
              " bytes):"
            ),
            import_react10.default.createElement(Text, null, prettyPrintJsonIfPossible(appLog.output))
          )
        ),
        appLog instanceof NetworkAccessResponseFromCacheLog && import_react10.default.createElement(
          import_react10.default.Fragment,
          null,
          import_react10.default.createElement(
            Text,
            null,
            "Cache write time: ",
            new Date(appLog.cacheEntryEpochMs).toISOString()
          ),
          import_react10.default.createElement(
            Text,
            null,
            "Cache TTL: ",
            appLog.cacheTtlMs / 1e3,
            " s"
          ),
          import_react10.default.createElement(Text, null, "HTTP request:"),
          import_react10.default.createElement(Text, null, prettyPrintJsonIfPossible(appLog.httpRequest)),
          import_react10.default.createElement(Text, null, "HTTP response:"),
          import_react10.default.createElement(Text, null, prettyPrintJsonIfPossible(appLog.httpResponse))
        ),
        appLog instanceof NetworkAccessRequestExecutionInBackgroundLog && import_react10.default.createElement(
          import_react10.default.Fragment,
          null,
          import_react10.default.createElement(
            Text,
            null,
            "Reason: ",
            getBackgroundExecutionReasonMessage(appLog.reason)
          ),
          import_react10.default.createElement(Text, null, "HTTP request:"),
          import_react10.default.createElement(Text, null, prettyPrintJsonIfPossible(appLog.httpRequest))
        ),
        appLog instanceof NetworkAccessRequestExecutedLog && import_react10.default.createElement(
          import_react10.default.Fragment,
          null,
          import_react10.default.createElement(
            Text,
            null,
            "Attempt: ",
            appLog.attempt
          ),
          appLog.connectTimeMs && import_react10.default.createElement(
            Text,
            null,
            "Connect time: ",
            appLog.connectTimeMs,
            " ms"
          ),
          appLog.writeReadTimeMs && import_react10.default.createElement(
            Text,
            null,
            "Write read time: ",
            appLog.writeReadTimeMs,
            " ms"
          ),
          import_react10.default.createElement(Text, null, "HTTP request:"),
          import_react10.default.createElement(Text, null, prettyPrintJsonIfPossible(appLog.httpRequest)),
          appLog.httpResponse && import_react10.default.createElement(
            import_react10.default.Fragment,
            null,
            import_react10.default.createElement(Text, null, "HTTP response:"),
            import_react10.default.createElement(Text, null, prettyPrintJsonIfPossible(appLog.httpResponse))
          ),
          appLog.error && import_react10.default.createElement(
            Text,
            null,
            "Error: ",
            appLog.error
          )
        )
      )
    )),
    errors2.length > 0 && import_react10.default.createElement(Box_default, { flexDirection: "column" }, errors2.map((error, index) => import_react10.default.createElement(
      Box_default,
      { key: index },
      import_react10.default.createElement(Text, { color: "red" }, error)
    )))
  );
};

// ../app/dist/cli/services/app-logs/logs-command/ui.js
var import_react11 = __toESM(require_react(), 1);
async function renderLogs({ pollOptions, options: { variables, developerPlatformClient } }) {
  let resubscribeCallback = async () => subscribeToAppLogs(developerPlatformClient, variables);
  return render(import_react11.default.createElement(Logs, { pollOptions, resubscribeCallback }));
}

// ../app/dist/cli/services/app-logs/logs-command/render-json-logs.js
init_cjs_shims();
async function renderJsonLogs({ pollOptions: { cursor, filters, jwtToken }, options: { variables, developerPlatformClient } }) {
  let response = await pollAppLogs2({ cursor, filters, jwtToken }), retryIntervalMs = POLLING_INTERVAL_MS, nextJwtToken = jwtToken, errorResponse = response;
  if (errorResponse.errors) {
    let result = await handleFetchAppLogsError({
      response: errorResponse,
      onThrottle: (retryIntervalMs2) => {
        outputInfo(JSON.stringify({ message: "Request throttled while polling app logs.", retry_in_ms: retryIntervalMs2 }));
      },
      onUnknownError: (retryIntervalMs2) => {
        outputInfo(JSON.stringify({ message: "Error while polling app logs.", retry_in_ms: retryIntervalMs2 }));
      },
      onResubscribe: () => subscribeToAppLogs(developerPlatformClient, variables)
    });
    result.nextJwtToken && (nextJwtToken = result.nextJwtToken), retryIntervalMs = result.retryIntervalMs;
  }
  let { cursor: nextCursor, appLogs } = response;
  appLogs && appLogs.forEach((log) => {
    outputInfo(toFormattedAppLogJson(log, parseAppLogPayload(log.payload, log.log_type), !1));
  }), setTimeout(() => {
    renderJsonLogs({
      options: { variables, developerPlatformClient },
      pollOptions: {
        jwtToken: nextJwtToken || jwtToken,
        cursor: nextCursor || cursor,
        filters
      }
    }).catch((error) => {
      throw error;
    });
  }, retryIntervalMs);
}

// ../app/dist/cli/services/logs.js
async function logs(commandOptions) {
  let logsConfig = await prepareForLogs(commandOptions), validSources = sourcesForApp(logsConfig.localApp);
  if (validSources.length === 0)
    throw new AbortError("This app has no log sources. Learn more about app logs at https://shopify.dev/docs/api/shopify-cli/app/app-logs");
  if (commandOptions.sources) {
    let invalidSources = commandOptions.sources.filter((source) => !validSources.includes(source));
    if (invalidSources.length)
      throw new AbortError(`Invalid sources: ${invalidSources.join(", ")}. Valid sources are: ${validSources.join(", ")}`);
  }
  let variables = {
    shopIds: [logsConfig.storeId],
    apiKey: logsConfig.apiKey,
    token: ""
  }, jwtToken = await subscribeToAppLogs(logsConfig.developerPlatformClient, variables), filters = {
    status: commandOptions.status,
    sources: commandOptions.sources
  }, pollOptions = {
    jwtToken,
    filters
  };
  commandOptions.format === "json" ? (consoleLog(JSON.stringify({ message: "Waiting for app logs..." })), await renderJsonLogs({
    options: {
      variables,
      developerPlatformClient: logsConfig.developerPlatformClient
    },
    pollOptions
  })) : (consoleLog(`Waiting for app logs...
`), await renderLogs({
    options: {
      variables,
      developerPlatformClient: logsConfig.developerPlatformClient
    },
    pollOptions
  }));
}
async function prepareForLogs(commandOptions) {
  let { configuration } = await loadAppConfiguration({
    ...commandOptions,
    userProvidedConfigName: commandOptions.configName
  }), developerPlatformClient = selectDeveloperPlatformClient({ configuration }), devContextOptions = { ...commandOptions, developerPlatformClient }, { storeId, remoteApp, localApp } = await ensureDevContext(devContextOptions);
  developerPlatformClient = remoteApp.developerPlatformClient ?? developerPlatformClient;
  let apiKey = remoteApp.apiKey;
  return {
    storeId,
    developerPlatformClient,
    apiKey,
    localApp
  };
}

// ../app/dist/cli/commands/app/logs.js
var import_core34 = __toESM(require_lib(), 1);
var _a19, Logs2 = class extends AppCommand {
  async run() {
    let { flags } = await this.parse(_a19), apiKey = flags["client-id"] || flags["api-key"], sources2 = flags.source;
    await checkFolderIsValidApp(flags.path);
    let logOptions = {
      apiKey,
      directory: flags.path,
      storeFqdn: flags.store,
      sources: sources2,
      status: flags.status,
      configName: flags.config,
      reset: flags.reset,
      format: flags.json ? "json" : "text"
    };
    await logs(logOptions);
  }
};
_a19 = Logs2;
Logs2.summary = "Stream detailed logs for your Shopify app.";
Logs2.descriptionWithMarkdown = "\n  Opens a real-time stream of detailed app logs from the selected app and store.\n  Use the `--source` argument to limit output to a particular log source, such as a specific Shopify Function handle. Use the `shopify app logs sources` command to view a list of sources.\n  Use the `--status` argument to filter on status, either `success` or `failure`.\n  ```\n  shopify app logs --status=success --source=extension.discount-function\n  ```\n  ";
Logs2.description = _a19.descriptionWithoutMarkdown();
Logs2.flags = {
  ...globalFlags,
  ...appFlags,
  "api-key": dev_default2.flags["api-key"],
  "client-id": dev_default2.flags["client-id"],
  store: dev_default2.flags.store,
  reset: dev_default2.flags.reset,
  "no-tunnel": dev_default2.flags["no-tunnel"],
  "graphiql-port": dev_default2.flags["graphiql-port"],
  "graphiql-key": dev_default2.flags["graphiql-key"],
  "dev-preview": dev_default2.flags["dev-preview"],
  source: import_core34.Flags.string({
    description: "Filters output to the specified log source.",
    env: "SHOPIFY_FLAG_SOURCE",
    multiple: !0
  }),
  status: import_core34.Flags.string({
    description: "Filters output to the specified status (success or failure).",
    options: ["success", "failure"],
    env: "SHOPIFY_FLAG_STATUS"
  }),
  json: import_core34.Flags.boolean({
    char: "j",
    description: "Log the run result as a JSON object.",
    env: "SHOPIFY_FLAG_JSON"
  })
};
var logs_default = Logs2;

// ../app/dist/cli/commands/app/app-logs/sources.js
init_cjs_shims();

// ../app/dist/cli/services/app-logs/sources.js
init_cjs_shims();
function sources(app) {
  let sources2 = sourcesForApp(app), sourcesByNamespace = /* @__PURE__ */ new Map();
  sources2.forEach((source) => {
    let tokens = source.split(".");
    if (tokens.length >= 2) {
      let sourceNamespace = tokens[0];
      sourcesByNamespace.has(sourceNamespace) || sourcesByNamespace.set(sourceNamespace, []), sourcesByNamespace.set(sourceNamespace, [...sourcesByNamespace.get(sourceNamespace), source]);
    }
  });
  for (let [namespace, sources3] of sourcesByNamespace)
    outputInfo(formatSection(namespace, sources3.join(`
`)));
}

// ../app/dist/cli/commands/app/app-logs/sources.js
var _a20, Sources = class extends AppCommand {
  async run() {
    let { flags } = await this.parse(_a20), specifications = await loadLocalExtensionsSpecifications(), app = await loadApp({
      specifications,
      directory: flags.path,
      userProvidedConfigName: flags.config,
      mode: "report"
    });
    app.errors ? process.exit(2) : sources(app);
  }
};
_a20 = Sources;
Sources.summary = "Print out a list of sources that may be used with the logs command.";
Sources.descriptionWithMarkdown = "The output source names can be used with the `--source` argument of `shopify app logs` to filter log output. Currently only function extensions are supported as sources.";
Sources.description = _a20.descriptionWithoutMarkdown();
Sources.flags = {
  ...globalFlags,
  ...appFlags
};
var sources_default = Sources;

// ../app/dist/cli/commands/app/env/pull.js
init_cjs_shims();

// ../app/dist/cli/services/app/env/pull.js
init_cjs_shims();

// ../app/dist/cli/services/app/fetch-app-from-config-or-select.js
init_cjs_shims();
async function fetchAppFromConfigOrSelect(app, developerPlatformClient = selectDeveloperPlatformClient({ configuration: app.configuration })) {
  let organizationApp;
  if (isCurrentAppSchema(app.configuration)) {
    let apiKey = app.configuration.client_id;
    if (organizationApp = await developerPlatformClient.appFromId({
      id: app.configuration.app_id ?? "no-id-available",
      apiKey,
      organizationId: app.configuration.organization_id ?? "0"
    }), !organizationApp) {
      let errorMessage2 = InvalidApiKeyErrorMessage(apiKey);
      throw new AbortError(errorMessage2.message, errorMessage2.tryMessage);
    }
  } else
    organizationApp = await selectApp();
  return organizationApp;
}

// ../app/dist/cli/services/app/env/pull.js
async function pullEnv(app, { envFile }) {
  return updateEnvFile(app, envFile);
}
async function updateEnvFile(app, envFile) {
  let orgApp = await fetchAppFromConfigOrSelect(app);
  await logMetadataForLoadedContext(orgApp);
  let updatedValues = {
    SHOPIFY_API_KEY: orgApp.apiKey,
    SHOPIFY_API_SECRET: orgApp.apiSecretKeys[0]?.secret,
    SCOPES: getAppScopes(app.configuration)
  };
  if (await fileExists(envFile)) {
    let envFileContent = await readFile(envFile), updatedEnvFileContent = patchEnvFile(envFileContent, updatedValues);
    if (updatedEnvFileContent === envFileContent)
      return outputContent`No changes to ${outputToken.path(envFile)}`;
    {
      await writeFile(envFile, updatedEnvFileContent);
      let diff2 = diffLines(envFileContent ?? "", updatedEnvFileContent);
      return outputContent`Updated ${outputToken.path(envFile)} to be:

${updatedEnvFileContent}

Here's what changed:

${outputToken.linesDiff(diff2)}
  `;
    }
  } else {
    let newEnvFileContent = patchEnvFile(null, updatedValues);
    return await writeFile(envFile, newEnvFileContent), outputContent`Created ${outputToken.path(envFile)}:

${newEnvFileContent}
`;
  }
}

// ../app/dist/cli/commands/app/env/pull.js
var import_core35 = __toESM(require_lib(), 1);
var _a21, EnvPull2 = class extends AppCommand {
  async run() {
    let { flags } = await this.parse(_a21), specifications = await loadLocalExtensionsSpecifications(), app = await loadApp({
      specifications,
      directory: flags.path,
      userProvidedConfigName: flags.config,
      mode: "report"
    }), envFile = joinPath(app.directory, flags["env-file"] ?? getDotEnvFileName(app.configuration.path));
    outputInfo(await pullEnv(app, { envFile }));
  }
};
_a21 = EnvPull2;
EnvPull2.summary = "Pull app and extensions environment variables.";
EnvPull2.descriptionWithMarkdown = "Creates or updates an `.env` files that contains app and app extension environment variables.\n\n  When an existing `.env` file is updated, changes to the variables are displayed in the terminal output. Existing variables and commented variables are preserved.";
EnvPull2.description = _a21.descriptionWithoutMarkdown();
EnvPull2.flags = {
  ...globalFlags,
  ...appFlags,
  "env-file": import_core35.Flags.string({
    hidden: !1,
    description: "Specify an environment file to update if the update flag is set",
    env: "SHOPIFY_FLAG_ENV_FILE"
  })
};
var pull_default2 = EnvPull2;

// ../app/dist/cli/commands/app/env/show.js
init_cjs_shims();

// ../app/dist/cli/services/app/env/show.js
init_cjs_shims();
async function showEnv(app, developerPlatformClient = selectDeveloperPlatformClient({ configuration: app.configuration })) {
  return outputEnv(app, "text", developerPlatformClient);
}
async function outputEnv(app, format4, developerPlatformClient = selectDeveloperPlatformClient({ configuration: app.configuration })) {
  let orgApp = await fetchAppFromConfigOrSelect(app, developerPlatformClient);
  return await logMetadataForLoadedContext(orgApp), format4 === "json" ? outputContent`${outputToken.json({
    SHOPIFY_API_KEY: orgApp.apiKey,
    SHOPIFY_API_SECRET: orgApp.apiSecretKeys[0]?.secret,
    SCOPES: getAppScopes(app.configuration)
  })}` : outputContent`
    ${outputToken.green("SHOPIFY_API_KEY")}=${orgApp.apiKey}
    ${outputToken.green("SHOPIFY_API_SECRET")}=${orgApp.apiSecretKeys[0]?.secret ?? ""}
    ${outputToken.green("SCOPES")}=${getAppScopes(app.configuration)}
  `;
}

// ../app/dist/cli/commands/app/env/show.js
var _a22, EnvShow = class extends AppCommand {
  async run() {
    let { flags } = await this.parse(_a22), specifications = await loadLocalExtensionsSpecifications(), app = await loadApp({
      specifications,
      directory: flags.path,
      userProvidedConfigName: flags.config,
      mode: "report"
    });
    outputInfo(await showEnv(app));
  }
};
_a22 = EnvShow;
EnvShow.summary = "Display app and extensions environment variables.";
EnvShow.descriptionWithMarkdown = "Displays environment variables that can be used to deploy apps and app extensions.";
EnvShow.description = _a22.descriptionWithoutMarkdown();
EnvShow.flags = {
  ...globalFlags,
  ...appFlags
};
var show_default = EnvShow;

// ../app/dist/cli/commands/app/function/build.js
init_cjs_shims();

// ../app/dist/cli/services/function/common.js
init_cjs_shims();
var import_core36 = __toESM(require_lib(), 1);
var functionFlags = {
  path: import_core36.Flags.string({
    hidden: !1,
    description: "The path to your function directory.",
    parse: async (input) => resolvePath(input),
    default: async () => cwd(),
    noCacheDefault: !0,
    env: "SHOPIFY_FLAG_PATH"
  })
};
async function inFunctionContext({ path: path3, userProvidedConfigName, callback }) {
  let specifications = await loadLocalExtensionsSpecifications(), app = await loadApp({ specifications, directory: path3, userProvidedConfigName }), allFunctions = app.allExtensions.filter((ext) => ext.isFunctionExtension), ourFunction = allFunctions.find((fun) => fun.directory === path3);
  if (ourFunction)
    return callback(app, ourFunction);
  if (isTerminalInteractive()) {
    let selectedFunction = await renderAutocompletePrompt({
      message: "Which function?",
      choices: allFunctions.map((shopifyFunction) => ({ label: shopifyFunction.handle, value: shopifyFunction }))
    });
    return callback(app, selectedFunction);
  } else
    throw new AbortError("Run this command from a function directory or use `--path` to specify a function directory.");
}

// ../app/dist/cli/commands/app/function/build.js
var _a23, FunctionBuild = class extends base_command_default {
  async run() {
    let { flags } = await this.parse(_a23);
    await inFunctionContext({
      path: flags.path,
      userProvidedConfigName: flags.config,
      callback: async (app, ourFunction) => {
        await buildFunctionExtension(ourFunction, {
          app,
          stdout: process.stdout,
          stderr: process.stderr,
          useTasks: !0,
          environment: "production"
        }), renderSuccess({ headline: "Function built successfully." });
      }
    });
  }
};
_a23 = FunctionBuild;
FunctionBuild.summary = "Compile a function to wasm.";
FunctionBuild.descriptionWithMarkdown = "Compiles the function in your current directory to WebAssembly (Wasm) for testing purposes.";
FunctionBuild.description = _a23.descriptionWithoutMarkdown();
FunctionBuild.flags = {
  ...globalFlags,
  ...appFlags,
  ...functionFlags
};
var build_default3 = FunctionBuild;

// ../app/dist/cli/commands/app/function/replay.js
init_cjs_shims();

// ../app/dist/cli/services/function/replay.js
init_cjs_shims();

// ../app/dist/cli/services/function/ui.js
init_cjs_shims();

// ../app/dist/cli/services/function/ui/components/Replay/Replay.js
init_cjs_shims();

// ../app/dist/cli/services/function/ui/components/Replay/hooks/useFunctionWatcher.js
init_cjs_shims();
var import_react12 = __toESM(require_react(), 1);
import { Writable } from "stream";
function useFunctionWatcher({ selectedRun, abortController, app, extension }) {
  let functionRunFromSelectedRun = {
    type: "functionRun",
    input: selectedRun.payload.input,
    output: selectedRun.payload.output,
    logs: selectedRun.payload.logs,
    name: selectedRun.source,
    size: 0,
    memory_usage: 0,
    instructions: selectedRun.payload.fuelConsumed
  }, [logs2, setLogs] = (0, import_react12.useState)([]), [recentFunctionRuns, setRecentFunctionRuns] = (0, import_react12.useState)([
    functionRunFromSelectedRun,
    functionRunFromSelectedRun
  ]), [error, setError] = (0, import_react12.useState)(void 0), { input, export: runExport } = selectedRun.payload, [statusMessage, setStatusMessage] = (0, import_react12.useState)(`Watching for changes to ${selectedRun.source}...`);
  return (0, import_react12.useEffect)(() => {
    let watchAbortController = new AbortController2();
    abortController.signal.addEventListener("abort", () => {
      watchAbortController.abort();
    });
    let runFunction = async () => {
      let functionRun = await runFunctionRunnerWithLogInput(extension, JSON.stringify(input), runExport);
      setRecentFunctionRuns((recentFunctionRuns2) => [functionRun, recentFunctionRuns2[0]]), setStatusMessage(`Watching for changes to ${selectedRun.source}...`), setLogs((logs3) => [...logs3, functionRun]);
    }, initialReplay = async () => {
      setStatusMessage("Replaying log with local function..."), await runFunction();
    }, startWatchingFunction = async () => {
      let customStdout = new Writable({
        write(chunk, _enconding, next) {
          setLogs((logs3) => [...logs3, { type: "systemMessage", message: chunk.toString() }]), next();
        }
      });
      await setupExtensionWatcher({
        extension,
        app,
        stdout: customStdout,
        stderr: customStdout,
        onChange: async () => {
          setError(void 0), setStatusMessage("Re-running with latest changes..."), await runFunction();
        },
        onReloadAndBuildError: async (error2) => {
          error2 instanceof FatalError ? setError(`Fatal error while reloading and building extension: ${error2.formattedMessage || error2.message}`) : setError(`Error while reloading and building extension: ${error2.message}`);
        },
        signal: watchAbortController.signal
      });
    };
    return initialReplay().then(() => {
      startWatchingFunction();
    }), () => {
      watchAbortController.abort();
    };
  }, [input, runExport, app, extension]), useAbortSignal(abortController.signal, async () => {
    setTimeout(() => {
      isUnitTest() || treeKill(process.pid, "SIGINT", !1, () => {
        process.exit(0);
      });
    }, 2e3);
  }), { logs: logs2, statusMessage, recentFunctionRuns, error };
}
async function runFunctionRunnerWithLogInput(fun, input, exportName) {
  let functionRunnerOutput = "", customStdout = new Writable({
    write(chunk, _encoding, next) {
      functionRunnerOutput += chunk, next();
    }
  });
  return await exec("npm", ["exec", "--", "function-runner", "--json", "-f", fun.outputPath, "--export", exportName], {
    cwd: fun.directory,
    input,
    stdout: customStdout,
    stderr: "inherit"
  }), { ...JSON.parse(functionRunnerOutput), type: "functionRun" };
}

// ../app/dist/cli/services/function/ui/components/Replay/Replay.js
var import_react13 = __toESM(require_react(), 1);
var Replay = ({ selectedRun, abortController, app, extension }) => {
  let { isAborted } = useAbortSignal(abortController.signal), { isRawModeSupported: canUseShortcuts } = use_stdin_default(), { logs: logs2, statusMessage, recentFunctionRuns, error } = useFunctionWatcher({
    selectedRun,
    abortController,
    app,
    extension
  });
  return use_input_default((input, key) => {
    handleCtrlC(input, key, () => abortController.abort()), input === "q" && abortController.abort();
  }, { isActive: !!canUseShortcuts }), import_react13.default.createElement(
    import_react13.default.Fragment,
    null,
    import_react13.default.createElement(Static, { items: logs2 }, (log, index) => import_react13.default.createElement(
      Box_default,
      { key: `replayOutputScrollerLog${index}`, flexDirection: "column" },
      import_react13.default.createElement(ReplayLog, { log })
    )),
    isAborted ? null : import_react13.default.createElement(
      Box_default,
      { marginY: 1, paddingTop: 1, flexDirection: "column", flexGrow: 1, borderStyle: "single", borderBottom: !1, borderLeft: !1, borderRight: !1, borderTop: !0 },
      canUseShortcuts ? import_react13.default.createElement(
        Box_default,
        { flexDirection: "column" },
        import_react13.default.createElement(
          Box_default,
          { flexDirection: "row" },
          import_react13.default.createElement(
            Text,
            null,
            figures_default.pointerSmall,
            " ",
            statusMessage
          )
        ),
        import_react13.default.createElement(StatsDisplay, { recentFunctionRuns }),
        import_react13.default.createElement(
          Text,
          null,
          figures_default.pointerSmall,
          " Press ",
          import_react13.default.createElement(Text, { bold: !0 }, "q"),
          " ",
          figures_default.lineVertical,
          " quit"
        )
      ) : null,
      error ? import_react13.default.createElement(Text, { color: "red" }, error) : null
    )
  );
};
function Header2({ title, backgroundColor }) {
  let numSpaces = Math.max(Math.round((28 - title.length) / 2), 0), spaces = " ".repeat(numSpaces);
  return import_react13.default.createElement(
    Text,
    { backgroundColor, color: "black" },
    `

`,
    spaces,
    title,
    spaces,
    `
`
  );
}
function InputDisplay({ input }) {
  return import_react13.default.createElement(
    Box_default,
    { flexDirection: "column" },
    import_react13.default.createElement(Header2, { title: "Input", backgroundColor: "yellow" }),
    import_react13.default.createElement(Text, null, prettyPrintJsonIfPossible(input))
  );
}
function LogDisplay({ logs: logs2 }) {
  return import_react13.default.createElement(
    Box_default,
    { flexDirection: "column" },
    import_react13.default.createElement(Header2, { title: "Logs", backgroundColor: "blueBright" }),
    import_react13.default.createElement(Text, null, logs2)
  );
}
function OutputDisplay({ output }) {
  return import_react13.default.createElement(
    Box_default,
    { flexDirection: "column" },
    import_react13.default.createElement(Header2, { title: "Output", backgroundColor: "greenBright" }),
    import_react13.default.createElement(Text, null, prettyPrintJsonIfPossible(output))
  );
}
function BenchmarkDisplay({ functionRun }) {
  return import_react13.default.createElement(
    Box_default,
    { flexDirection: "column" },
    import_react13.default.createElement(Header2, { title: "Benchmark Results", backgroundColor: "green" }),
    import_react13.default.createElement(
      Text,
      null,
      "Name: ",
      functionRun.name
    ),
    import_react13.default.createElement(
      Text,
      null,
      "Linear Memory Usage: ",
      functionRun.memory_usage,
      "KB"
    ),
    import_react13.default.createElement(
      Text,
      null,
      "Instructions: ",
      functionRun.instructions / 1e3,
      "K"
    ),
    import_react13.default.createElement(
      Text,
      null,
      "Size: ",
      functionRun.size,
      "KB"
    )
  );
}
function StatsDisplay({ recentFunctionRuns }) {
  let delta = recentFunctionRuns[0].instructions - recentFunctionRuns[1].instructions;
  return import_react13.default.createElement(
    Box_default,
    { flexDirection: "column" },
    import_react13.default.createElement(
      Text,
      null,
      figures_default.pointerSmall,
      " Instruction count delta: ",
      delta
    )
  );
}
function ReplayLog({ log }) {
  switch (log.type) {
    case "functionRun":
      return import_react13.default.createElement(
        Box_default,
        { flexDirection: "column" },
        import_react13.default.createElement(InputDisplay, { input: log.input }),
        import_react13.default.createElement(LogDisplay, { logs: log.logs }),
        import_react13.default.createElement(OutputDisplay, { output: log.output }),
        import_react13.default.createElement(BenchmarkDisplay, { functionRun: log })
      );
    case "systemMessage":
      return import_react13.default.createElement(Text, null, log.message);
    default:
      return null;
  }
}

// ../app/dist/cli/services/function/ui.js
var import_react14 = __toESM(require_react(), 1);
async function renderReplay({ selectedRun, abortController, app, extension }) {
  return render(import_react14.default.createElement(Replay, { selectedRun, abortController, app, extension }), {
    exitOnCtrlC: !1
  });
}

// ../app/dist/cli/services/generate-schema.js
init_cjs_shims();
async function ensureConnectedAppFunctionContext(options) {
  let { app } = options, developerPlatformClient = options.developerPlatformClient ?? selectDeveloperPlatformClient({ configuration: options.app.configuration }), apiKey = options.apiKey || getAppIdentifiers({ app }, developerPlatformClient).app;
  if (!apiKey) {
    if (!isTerminalInteractive())
      throw new AbortError(outputContent`No Client ID was provided.`, outputContent`Provide a Client ID with the --client-id flag.`);
    apiKey = (await fetchOrCreateOrganizationApp(app.creationDefaultOptions())).apiKey;
  }
  return { apiKey, developerPlatformClient };
}
async function generateSchemaService(options) {
  let { extension, stdout } = options, { apiKey, developerPlatformClient } = await ensureConnectedAppFunctionContext(options), { api_version: version2, type, targeting } = extension.configuration, definition = await (!!targeting?.length ? generateSchemaFromTarget({
    localIdentifier: extension.localIdentifier,
    developerPlatformClient,
    apiKey,
    target: targeting[0].target,
    version: version2
  }) : generateSchemaFromType({
    localIdentifier: extension.localIdentifier,
    developerPlatformClient,
    apiKey,
    type,
    version: version2
  }));
  if (stdout)
    outputInfo(definition);
  else {
    let outputPath = joinPath(options.path, "schema.graphql");
    await writeFile(outputPath, definition), outputInfo(`GraphQL Schema for ${extension.localIdentifier} written to ${outputPath}`);
  }
}
async function generateSchemaFromTarget({ localIdentifier, developerPlatformClient, apiKey, target, version: version2 }) {
  let variables = {
    apiKey,
    target,
    version: version2
  }, definition = await developerPlatformClient.targetSchemaDefinition(variables);
  if (!definition)
    throw new AbortError(outputContent`A schema could not be generated for ${localIdentifier}`, outputContent`Check that the Function targets and version are valid.`);
  return definition;
}
async function generateSchemaFromType({ localIdentifier, developerPlatformClient, apiKey, version: version2, type }) {
  let variables = {
    apiKey,
    version: version2,
    type
  }, definition = await developerPlatformClient.apiSchemaDefinition(variables);
  if (!definition)
    throw new AbortError(outputContent`A schema could not be generated for ${localIdentifier}`, outputContent`Check that the Function API type and version are valid.`);
  return definition;
}

// ../app/dist/cli/prompts/function/replay.js
init_cjs_shims();
async function selectFunctionRunPrompt(functionRuns) {
  if (functionRuns.length === 0)
    return;
  let toAnswer = (functionRun) => ({
    label: `${functionRun.logTimestamp} (${functionRun.status}) - ${functionRun.identifier}`,
    value: functionRun
  }), functionRunsList = functionRuns.map(toAnswer);
  return await renderAutocompletePrompt({
    message: "Which function run would you like to replay locally?",
    choices: functionRunsList
  });
}

// ../app/dist/cli/services/function/replay.js
import { readdirSync as readdirSync2 } from "fs";
var LOG_SELECTOR_LIMIT = 100;
async function replay(options) {
  let { watch, extension, app } = options, abortController = new AbortController2();
  try {
    let { apiKey } = await ensureConnectedAppFunctionContext(options), functionRunsDir = joinPath(getLogsDir(), apiKey), selectedRun = options.log ? await getRunFromIdentifier(functionRunsDir, extension.handle, options.log) : await getRunFromSelector(functionRunsDir, extension.handle), { input, export: runExport } = selectedRun.payload;
    watch ? await renderReplay({
      selectedRun,
      abortController,
      app,
      extension
    }) : await runFunctionRunnerWithLogInput2(extension, options, JSON.stringify(input), runExport);
  } catch (error) {
    throw abortController.abort(), error;
  }
}
async function runFunctionRunnerWithLogInput2(fun, options, input, exportName) {
  let outputAsJson = options.json ? ["--json"] : [];
  return exec("npm", ["exec", "--", "function-runner", "-f", fun.outputPath, ...outputAsJson, "--export", exportName], {
    cwd: fun.directory,
    input,
    stdout: "inherit",
    stderr: "inherit"
  });
}
async function getRunFromIdentifier(functionRunsDir, functionHandle, identifier) {
  let runPath = await findFunctionRun(functionRunsDir, functionHandle, identifier);
  if (runPath === void 0)
    throw new AbortError(`No log found for '${identifier}'.
Searched ${functionRunsDir} for function ${functionHandle}.`);
  let fileData = await readFile(runPath);
  return JSON.parse(fileData);
}
function parseLogFilename(filename) {
  let splitFilename = filename.split(/[_.]/);
  if (!(splitFilename.length < 6))
    return {
      namespace: splitFilename[3],
      functionHandle: splitFilename[4],
      identifier: splitFilename[5]
    };
}
async function findFunctionRun(functionRunsDir, functionHandle, identifier) {
  let fileName = readdirSync2(functionRunsDir).find((filename) => {
    let fileMetadata = parseLogFilename(filename);
    return fileMetadata?.namespace === "extensions" && fileMetadata?.functionHandle === functionHandle && fileMetadata?.identifier === identifier;
  });
  return fileName ? joinPath(functionRunsDir, fileName) : void 0;
}
async function getRunFromSelector(functionRunsDir, functionHandle) {
  let functionRuns = await getFunctionRunData(functionRunsDir, functionHandle), selectedRun = await selectFunctionRunPrompt(functionRuns);
  if (selectedRun === void 0)
    throw new AbortError(`No logs found in ${functionRunsDir}`);
  return selectedRun;
}
async function getFunctionRunData(functionRunsDir, functionHandle) {
  let allFunctionRunFileNames = readdirSync2(functionRunsDir).filter((filename) => {
    let fileMetadata = parseLogFilename(filename);
    return fileMetadata?.namespace === "extensions" && fileMetadata?.functionHandle === functionHandle;
  }).reverse(), functionRunData = [];
  for (let i = 0; i < allFunctionRunFileNames.length && functionRunData.length < LOG_SELECTOR_LIMIT; i += LOG_SELECTOR_LIMIT) {
    let functionRunFilePaths = allFunctionRunFileNames.slice(i, i + LOG_SELECTOR_LIMIT).map((functionRunFile) => joinPath(functionRunsDir, functionRunFile)), filteredFunctionRunDataFromChunk = (await Promise.all(functionRunFilePaths.map(async (functionRunFilePath) => {
      let fileData = await readFile(functionRunFilePath);
      return {
        ...JSON.parse(fileData),
        identifier: getIdentifierFromFilename(functionRunFilePath)
      };
    }))).filter((run) => run.payload.input != null);
    functionRunData = functionRunData.concat(filteredFunctionRunDataFromChunk);
  }
  return functionRunData;
}
function getIdentifierFromFilename(fileName) {
  return fileName.split("_").pop().substring(0, 6);
}

// ../app/dist/cli/commands/app/function/replay.js
var import_core37 = __toESM(require_lib(), 1), _a24, FunctionReplay = class extends base_command_default {
  async run() {
    let { flags } = await this.parse(_a24);
    flags["api-key"] && await showApiKeyDeprecationWarning();
    let apiKey = flags["client-id"] || flags["api-key"];
    await inFunctionContext({
      path: flags.path,
      userProvidedConfigName: flags.config,
      callback: async (app, ourFunction) => {
        await replay({
          app,
          extension: ourFunction,
          apiKey,
          path: flags.path,
          log: flags.log,
          json: flags.json,
          watch: flags.watch
        });
      }
    });
  }
};
_a24 = FunctionReplay;
FunctionReplay.summary = "Replays a function run from an app log.";
FunctionReplay.descriptionWithMarkdown = "Runs the function from your current directory for [testing purposes](https://shopify.dev/docs/apps/functions/testing-and-debugging). To learn how you can monitor and debug functions when errors occur, refer to [Shopify Functions error handling](https://shopify.dev/docs/api/functions/errors).";
FunctionReplay.description = _a24.descriptionWithoutMarkdown();
FunctionReplay.flags = {
  ...globalFlags,
  ...appFlags,
  ...functionFlags,
  "api-key": import_core37.Flags.string({
    hidden: !0,
    description: "Application's API key",
    env: "SHOPIFY_FLAG_API_KEY",
    exclusive: ["config"]
  }),
  "client-id": import_core37.Flags.string({
    hidden: !1,
    description: "Application's Client ID",
    env: "SHOPIFY_FLAG_CLIENT_ID",
    exclusive: ["config"]
  }),
  log: import_core37.Flags.string({
    char: "l",
    description: "Specifies a log identifier to replay instead of selecting from a list. The identifier is provided in the output of `shopify app dev` and is the suffix of the log file name.",
    env: "SHOPIFY_FLAG_LOG"
  }),
  json: import_core37.Flags.boolean({
    char: "j",
    hidden: !1,
    description: "Output the function run result as a JSON object.",
    env: "SHOPIFY_FLAG_JSON"
  }),
  watch: import_core37.Flags.boolean({
    char: "w",
    hidden: !1,
    allowNo: !0,
    default: !0,
    description: "Re-run the function when the source code changes.",
    env: "SHOPIFY_FLAG_WATCH"
  })
};
var replay_default = FunctionReplay;

// ../app/dist/cli/commands/app/function/run.js
init_cjs_shims();
var import_core38 = __toESM(require_lib(), 1);
var _a25, DEFAULT_FUNCTION_EXPORT = "_start", FunctionRun = class extends base_command_default {
  async run() {
    let { flags } = await this.parse(_a25);
    await inFunctionContext({
      path: flags.path,
      userProvidedConfigName: flags.config,
      callback: async (_app, ourFunction) => {
        let functionExport = DEFAULT_FUNCTION_EXPORT;
        if (flags.export !== void 0)
          outputDebug(`Using export ${flags.export} from the --export flag.`), functionExport = flags.export;
        else if (ourFunction.configuration.targeting !== void 0 && ourFunction.configuration.targeting.length > 0) {
          let targeting = ourFunction.configuration.targeting;
          if (targeting.length > 1 && isTTY({})) {
            let targets = targeting.map((target) => ({
              label: target.target,
              value: target.export || DEFAULT_FUNCTION_EXPORT
            }));
            functionExport = await renderAutocompletePrompt({
              message: "Which target would you like to execute?",
              choices: targets
            });
          } else
            functionExport = targeting?.[0]?.export || DEFAULT_FUNCTION_EXPORT, outputDebug(`Using export '${functionExport}'. Use the --export flag or an interactive terminal to select a different export.`);
        } else
          outputDebug(`No targeting information found. Using the default export '${functionExport}'. Use the --export flag or an interactive terminal to select a different export.`);
        await runFunctionRunner(ourFunction, {
          json: flags.json,
          input: flags.input,
          export: functionExport
        });
      }
    });
  }
};
_a25 = FunctionRun;
FunctionRun.summary = "Run a function locally for testing.";
FunctionRun.descriptionWithMarkdown = "Runs the function from your current directory for [testing purposes](https://shopify.dev/docs/apps/functions/testing-and-debugging). To learn how you can monitor and debug functions when errors occur, refer to [Shopify Functions error handling](https://shopify.dev/docs/api/functions/errors).";
FunctionRun.description = _a25.descriptionWithoutMarkdown();
FunctionRun.flags = {
  ...globalFlags,
  ...appFlags,
  ...functionFlags,
  input: import_core38.Flags.string({
    char: "i",
    description: "The input JSON to pass to the function. If omitted, standard input is used.",
    env: "SHOPIFY_FLAG_INPUT"
  }),
  export: import_core38.Flags.string({
    char: "e",
    hidden: !1,
    description: "Name of the WebAssembly export to invoke.",
    env: "SHOPIFY_FLAG_EXPORT"
  }),
  json: import_core38.Flags.boolean({
    char: "j",
    hidden: !1,
    description: "Log the run result as a JSON object.",
    env: "SHOPIFY_FLAG_JSON"
  })
};
var run_default = FunctionRun;

// ../app/dist/cli/commands/app/function/schema.js
init_cjs_shims();
var import_core39 = __toESM(require_lib(), 1);
var _a26, FetchSchema = class extends base_command_default {
  async run() {
    let { flags } = await this.parse(_a26);
    flags["api-key"] && await showApiKeyDeprecationWarning();
    let apiKey = flags["client-id"] || flags["api-key"];
    await inFunctionContext({
      path: flags.path,
      userProvidedConfigName: flags.config,
      callback: async (app, ourFunction) => {
        await generateSchemaService({
          app,
          extension: ourFunction,
          apiKey,
          stdout: flags.stdout,
          path: flags.path
        });
      }
    });
  }
};
_a26 = FetchSchema;
FetchSchema.summary = "Fetch the latest GraphQL schema for a function.";
FetchSchema.descriptionWithMarkdown = "Generates the latest [GraphQL schema](https://shopify.dev/docs/apps/functions/input-output#graphql-schema) for a function in your app. Run this command from the function directory.\n\n  This command uses the API type and version of your function, as defined in your extension TOML file, to generate the latest GraphQL schema. The schema is written to the `schema.graphql` file.";
FetchSchema.description = _a26.descriptionWithoutMarkdown();
FetchSchema.flags = {
  ...globalFlags,
  ...appFlags,
  ...functionFlags,
  "api-key": import_core39.Flags.string({
    hidden: !0,
    name: "API key",
    description: "The API key to fetch the schema with.",
    env: "SHOPIFY_FLAG_APP_API_KEY",
    exclusive: ["config"]
  }),
  "client-id": import_core39.Flags.string({
    hidden: !1,
    description: "The Client ID to fetch the schema with.",
    env: "SHOPIFY_FLAG_CLIENT_ID",
    exclusive: ["config"]
  }),
  stdout: import_core39.Flags.boolean({
    description: "Output the schema to stdout instead of writing to a file.",
    required: !1,
    default: !1,
    env: "SHOPIFY_FLAG_STDOUT"
  })
};
var schema_default = FetchSchema;

// ../app/dist/cli/commands/app/function/typegen.js
init_cjs_shims();
var _a27, FunctionTypegen = class extends base_command_default {
  async run() {
    let { flags } = await this.parse(_a27);
    await inFunctionContext({
      path: flags.path,
      userProvidedConfigName: flags.config,
      callback: async (app, ourFunction) => {
        await buildGraphqlTypes(ourFunction, { stdout: process.stdout, stderr: process.stderr, app }), renderSuccess({ headline: "GraphQL types generated successfully." });
      }
    });
  }
};
_a27 = FunctionTypegen;
FunctionTypegen.summary = "Generate GraphQL types for a JavaScript function.";
FunctionTypegen.descriptionWithMarkdown = "Creates GraphQL types based on your [input query](https://shopify.dev/docs/apps/functions/input-output#input) for a function written in JavaScript.";
FunctionTypegen.description = _a27.descriptionWithoutMarkdown();
FunctionTypegen.flags = {
  ...globalFlags,
  ...appFlags,
  ...functionFlags
};
var typegen_default = FunctionTypegen;

// ../app/dist/cli/commands/app/generate/extension.js
init_cjs_shims();

// ../app/dist/cli/services/generate.js
init_cjs_shims();

// ../app/dist/cli/services/generate/fetch-template-specifications.js
init_cjs_shims();
async function fetchExtensionTemplates(developerPlatformClient, app, availableSpecifications) {
  return (await developerPlatformClient.templateSpecifications(app)).filter((template2) => availableSpecifications.includes(template2.identifier) || availableSpecifications.includes(template2.type));
}

// ../app/dist/cli/prompts/generate/extension.js
init_cjs_shims();
function buildChoices(extensionTemplates, unavailableExtensions = []) {
  let templateSpecChoices = [
    ...extensionTemplates.map((spec3) => ({
      label: spec3.name,
      value: spec3.identifier,
      group: spec3.group || "Other",
      sortPriority: spec3.sortPriority ?? Number.MAX_SAFE_INTEGER
    })),
    ...unavailableExtensions.map((spec3) => ({
      label: `${spec3.name} (limit reached)`,
      value: spec3.identifier,
      group: spec3.group || "Other",
      disabled: !0,
      sortPriority: spec3.sortPriority ?? Number.MAX_SAFE_INTEGER
    }))
  ], compareChoices = (c1, c2) => c1.sortPriority === c2.sortPriority ? c1.label.localeCompare(c2.label) : c1.sortPriority - c2.sortPriority;
  return templateSpecChoices.sort(compareChoices);
}
var generateExtensionPrompts = async (options) => {
  let extensionTemplates = options.extensionTemplates, templateType = options.templateType, extensionFlavor = options.extensionFlavor;
  if (!templateType) {
    if (extensionFlavor && (extensionTemplates = extensionTemplates.filter((template2) => template2.supportedFlavors.map((elem) => elem.value).includes(extensionFlavor))), extensionTemplates.length === 0)
      throw new AbortError("You have reached the limit for the number of extensions you can create.");
    templateType = await renderAutocompletePrompt({
      message: "Type of extension?",
      choices: buildChoices(extensionTemplates, options.unavailableExtensions)
    });
  }
  let extensionTemplate = extensionTemplates.find((template2) => template2.identifier === templateType), name = options.name || await promptName(options.directory, extensionTemplate.defaultName), flavor = options.extensionFlavor ?? await promptFlavor(extensionTemplate);
  return { extensionTemplate, extensionContent: { name, flavor } };
};
async function promptName(directory, defaultName, number = 1) {
  let separator = defaultName.includes(" ") ? " " : "-", name = number <= 1 ? defaultName : `${defaultName}${separator}${number}`, fullPath = joinPath(directory, slugify(name));
  return fileExistsSync(fullPath) ? promptName(directory, defaultName, number + 1) : renderTextPrompt({
    message: "Name your extension:",
    defaultValue: name
  });
}
async function promptFlavor(extensionTemplate) {
  if (extensionTemplate.supportedFlavors.length !== 0)
    return extensionTemplate.supportedFlavors.length === 1 && extensionTemplate.supportedFlavors[0] ? extensionTemplate.supportedFlavors[0].value : renderSelectPrompt({
      message: "What would you like to work in?",
      choices: extensionTemplate.supportedFlavors.map((flavor) => ({
        label: flavor.name,
        value: flavor.value
      })),
      defaultValue: "react"
    });
}
var extension_default = generateExtensionPrompts;

// ../app/dist/cli/services/generate/extension.js
init_cjs_shims();
function getTemplateLanguage(flavor) {
  switch (flavor) {
    case "vanilla-js":
    case "react":
    case "typescript":
    case "typescript-react":
      return "javascript";
    case "rust":
    case "wasm":
      return flavor;
    default:
      return;
  }
}
async function generateExtensionTemplate(options) {
  let extensionName = options.extensionChoices.name, extensionFlavorValue = options.extensionChoices.flavor, extensionFlavor = options.extensionTemplate.supportedFlavors.find((flavor) => flavor.value === extensionFlavorValue), directory = await ensureExtensionDirectoryExists({ app: options.app, name: extensionName }), url = options.cloneUrl || options.extensionTemplate.url, uid = options.developerPlatformClient.supportsAtomicDeployments ? randomUUID() : void 0, initOptions = {
    directory,
    url,
    app: options.app,
    type: options.extensionTemplate.type,
    name: extensionName,
    extensionFlavor,
    uid
  };
  return await extensionInit(initOptions), { directory: relativizePath(directory), extensionTemplate: options.extensionTemplate };
}
async function extensionInit(options) {
  try {
    switch (options.type) {
      case "theme":
        await themeExtensionInit(options);
        break;
      case "function":
        await functionExtensionInit(options);
        break;
      default:
        await uiExtensionInit(options);
        break;
    }
    let lockFilePath = joinPath(options.directory, configurationFileNames.lockFile);
    await removeFile(lockFilePath);
  } catch (error) {
    throw await removeFile(options.directory), error;
  }
}
async function themeExtensionInit({ directory, url, type, name, extensionFlavor, uid }) {
  return inTemporaryDirectory(async (tmpDir) => {
    let templateDirectory = await downloadOrFindTemplateDirectory(url, extensionFlavor, tmpDir);
    await recursiveLiquidTemplateCopy(templateDirectory, directory, { name, type, uid });
  });
}
async function functionExtensionInit({ directory, url, app, name, extensionFlavor, uid }) {
  let templateLanguage = getTemplateLanguage(extensionFlavor?.value), taskList = [];
  taskList.push({
    title: "Generating function extension",
    task: async () => {
      if (await inTemporaryDirectory(async (tmpDir) => {
        let templateDirectory = await downloadOrFindTemplateDirectory(url, extensionFlavor, tmpDir);
        await recursiveLiquidTemplateCopy(templateDirectory, directory, {
          name,
          handle: slugify(name),
          flavor: extensionFlavor?.value,
          uid
        });
      }), templateLanguage === "javascript") {
        let srcFileExtension = getSrcFileExtension(extensionFlavor?.value || "rust");
        await changeIndexFileExtension(directory, srcFileExtension, "!(*.graphql)");
      }
    }
  }), templateLanguage === "javascript" && taskList.push({
    title: "Installing additional dependencies",
    task: async () => {
      app.usesWorkspaces && app.packageManager === "npm" && await installNodeModules({ packageManager: "npm", directory: app.directory });
      let requiredDependencies = getFunctionRuntimeDependencies(templateLanguage);
      await addNPMDependenciesIfNeeded(requiredDependencies, {
        packageManager: app.packageManager,
        type: "prod",
        directory: app.usesWorkspaces ? directory : app.directory
      });
    }
  }), templateLanguage === "javascript" && taskList.push({
    title: "Building GraphQL types",
    task: async () => {
      await buildGraphqlTypes({ directory, isJavaScript: !0 }, { stdout: process.stdout, stderr: process.stderr, app });
    }
  }), await renderTasks(taskList);
}
async function uiExtensionInit({ directory, url, app, name, extensionFlavor, uid }) {
  let templateLanguage = getTemplateLanguage(extensionFlavor?.value);
  await renderTasks([
    {
      title: "Generating extension",
      task: async () => {
        let srcFileExtension = getSrcFileExtension(extensionFlavor?.value ?? "vanilla-js");
        await inTemporaryDirectory(async (tmpDir) => {
          let templateDirectory = await downloadOrFindTemplateDirectory(url, extensionFlavor, tmpDir);
          await recursiveLiquidTemplateCopy(templateDirectory, directory, {
            srcFileExtension,
            name,
            handle: slugify(name),
            flavor: extensionFlavor?.value ?? "",
            uid
          });
        }), templateLanguage === "javascript" && (await changeIndexFileExtension(directory, srcFileExtension), await removeUnwantedTemplateFilesPerFlavor(directory, extensionFlavor.value));
      }
    },
    {
      title: "Installing dependencies",
      task: async () => {
        let packageManager2 = app.packageManager;
        if (app.usesWorkspaces)
          getTemplateLanguage(extensionFlavor?.value) === "javascript" && await installNodeModules({
            packageManager: packageManager2,
            directory: app.directory
          });
        else {
          await addResolutionOrOverrideIfNeeded(app.directory, extensionFlavor?.value);
          let extensionPackageJsonPath = joinPath(directory, "package.json"), requiredDependencies = await getProdDependencies(extensionPackageJsonPath);
          await addNPMDependenciesIfNeeded(requiredDependencies, {
            packageManager: packageManager2,
            type: "prod",
            directory: app.directory
          }), await removeFile(extensionPackageJsonPath);
        }
      }
    }
  ]);
}
function getSrcFileExtension(extensionFlavor) {
  return {
    "vanilla-js": "js",
    react: "jsx",
    typescript: "ts",
    "typescript-react": "tsx",
    rust: "rs",
    wasm: "wasm",
    liquid: "liquid",
    "config-only": ""
  }[extensionFlavor] ?? "js";
}
function getFunctionRuntimeDependencies(templateLanguage) {
  let dependencies = [];
  return templateLanguage === "javascript" && dependencies.push({ name: "@shopify/shopify_function", version: "0.1.0" }, { name: "javy", version: "0.1.1" }), dependencies;
}
async function changeIndexFileExtension(extensionDirectory, fileExtension, renameGlob = "*") {
  let srcFilePaths = await glob(joinPath(extensionDirectory, "src", renameGlob)), srcFileExensionsToChange = [];
  for (let srcFilePath of srcFilePaths)
    srcFileExensionsToChange.push(moveFile(srcFilePath, `${srcFilePath}.${fileExtension}`));
  await Promise.all(srcFileExensionsToChange);
}
async function removeUnwantedTemplateFilesPerFlavor(extensionDirectory, extensionFlavor) {
  extensionFlavor !== "typescript-react" && await removeFile(joinPath(extensionDirectory, "tsconfig.json"));
}
async function addResolutionOrOverrideIfNeeded(directory, extensionFlavor) {
  extensionFlavor === "typescript-react" && await addResolutionOrOverride(directory, { "@types/react": versions.reactTypes });
}
async function getProdDependencies(packageJsonPath) {
  if (!await fileExists(packageJsonPath))
    return [];
  let packageJsonContent = await readAndParsePackageJson(packageJsonPath);
  return Object.entries(packageJsonContent?.dependencies ?? {}).map(([name, version2]) => ({ name, version: version2 }));
}
async function downloadOrFindTemplateDirectory(url, extensionFlavor, tmpDir) {
  if (url === "https://github.com/Shopify/cli")
    return ensureLocalExtensionFlavorExists(extensionFlavor);
  {
    let templateDownloadDir = joinPath(tmpDir, "download");
    return await mkdir(templateDownloadDir), await downloadGitRepository({
      repoUrl: url,
      destination: templateDownloadDir,
      shallow: !0
    }), ensureDownloadedExtensionFlavorExists(extensionFlavor, templateDownloadDir);
  }
}

// ../app/dist/cli/services/generate.js
async function generate(options) {
  let developerPlatformClient = await sniffServiceOptionsAndAppConfigToSelectPlatformClient(options), remoteApp = await ensureGenerateContext({ ...options, developerPlatformClient });
  developerPlatformClient = remoteApp.developerPlatformClient ?? developerPlatformClient;
  let specifications = await fetchSpecifications({ developerPlatformClient, app: remoteApp }), app = await loadApp({
    directory: options.directory,
    userProvidedConfigName: options.configName,
    specifications
  }), availableSpecifications = specifications.map((spec3) => spec3.identifier), extensionTemplates = await fetchExtensionTemplates(developerPlatformClient, remoteApp, availableSpecifications), promptOptions = await buildPromptOptions(extensionTemplates, specifications, app, options), promptAnswers = await extension_default(promptOptions);
  await saveAnalyticsMetadata(promptAnswers, options.template);
  let generateExtensionOptions = buildGenerateOptions(promptAnswers, app, options, developerPlatformClient), generatedExtension = await generateExtensionTemplate(generateExtensionOptions);
  renderSuccessMessage2(generatedExtension, app.packageManager);
}
async function buildPromptOptions(extensionTemplates, specifications, app, options) {
  let extensionTemplate = await handleTypeParameter(options.template, app, extensionTemplates, specifications);
  validateExtensionFlavor(extensionTemplate, options.flavor);
  let { validTemplates, templatesOverlimit } = checkLimits(extensionTemplates, specifications, app);
  return {
    templateType: extensionTemplate?.identifier,
    name: options.name,
    extensionFlavor: options.flavor,
    directory: joinPath(options.directory, "extensions"),
    app,
    extensionTemplates: validTemplates ?? [],
    unavailableExtensions: templatesOverlimit ?? [],
    reset: options.reset
  };
}
function checkLimits(extensionTemplates, specifications, app) {
  return groupBy(extensionTemplates, (template2) => !limitReached(app, specifications, template2) ? "validTemplates" : "templatesOverlimit");
}
function limitReached(app, specifications, template2) {
  let type = template2.type, specification = specifications.find((spec3) => spec3.identifier === type || spec3.externalIdentifier === type);
  return app.extensionsForType({ identifier: type, externalIdentifier: type }).length >= (specification?.registrationLimit || 1);
}
async function saveAnalyticsMetadata(promptAnswers, typeFlag) {
  let { extensionContent } = promptAnswers;
  return metadata_default.addPublicMetadata(() => ({
    cmd_scaffold_template_flavor: extensionContent.flavor,
    cmd_scaffold_type: promptAnswers.extensionTemplate.identifier,
    cmd_scaffold_used_prompts_for_type: !typeFlag
  }));
}
function buildGenerateOptions(promptAnswers, app, options, developerPlatformClient) {
  return {
    app,
    cloneUrl: options.cloneUrl,
    extensionChoices: promptAnswers.extensionContent,
    extensionTemplate: promptAnswers.extensionTemplate,
    developerPlatformClient
  };
}
function renderSuccessMessage2(extension, packageManager2) {
  let formattedSuccessfulMessage = formatSuccessfulRunMessage(extension.extensionTemplate, extension.directory, packageManager2);
  renderSuccess(formattedSuccessfulMessage);
}
function validateExtensionFlavor(extensionTemplate, flavor) {
  if (!flavor || !extensionTemplate)
    return;
  let possibleFlavors = extensionTemplate.supportedFlavors.map((flavor2) => flavor2.value);
  if (!possibleFlavors.includes(flavor))
    throw new AbortError("Invalid template for extension type", `Expected template to be one of the following: ${possibleFlavors.join(", ")}.`);
}
function formatSuccessfulRunMessage(extensionTemplate, extensionDirectory, depndencyManager) {
  let options = {
    headline: ["Your extension was created in", { filePath: extensionDirectory }, { char: "." }],
    nextSteps: [],
    reference: []
  };
  return extensionTemplate.type !== "function" && options.nextSteps.push([
    "To preview this extension along with the rest of the project, run",
    { command: `${formatPackageManagerCommand(depndencyManager, "shopify app dev")}` }
  ]), extensionTemplate.supportLinks[0] && options.reference.push([
    "For more details, see the",
    { link: { label: "docs", url: extensionTemplate.supportLinks[0] } }
  ]), options;
}
async function handleTypeParameter(typeFlag, app, extensionTemplates, specifications) {
  if (!typeFlag)
    return;
  let extensionTemplate = extensionTemplates.find((spec3) => spec3.identifier === typeFlag);
  if (!extensionTemplate) {
    let isShopifolk = await isShopify(), allExternalTypes = extensionTemplates.map((spec3) => spec3.identifier), tryMsg = isShopifolk ? "You might need to enable some flags on your Organization or App" : void 0;
    throw new AbortError(`Unknown extension type: ${typeFlag}.
The following extension types are supported: ${allExternalTypes.join(", ")}`, tryMsg);
  }
  if (limitReached(app, specifications, extensionTemplate))
    throw new AbortError(`Invalid extension type: ${typeFlag}`, `You have reached the limit of extension(s) of type ${extensionTemplate.type} per app`);
  return extensionTemplate;
}
var generate_default = generate;

// ../app/dist/cli/commands/app/generate/extension.js
var import_core40 = __toESM(require_lib(), 1);
var _a28, AppGenerateExtension = class extends AppCommand {
  static analyticsNameOverride() {
    return "app scaffold extension";
  }
  async run() {
    let { flags } = await this.parse(_a28);
    flags["api-key"] && await showApiKeyDeprecationWarning();
    let apiKey = flags["client-id"] || flags["api-key"];
    if (await metadata_default.addPublicMetadata(() => ({
      cmd_scaffold_required_auth: !0,
      cmd_scaffold_template_custom: flags["clone-url"] !== void 0,
      cmd_scaffold_type_owner: "@shopify/app"
    })), flags.type) {
      renderWarning({
        headline: ["The flag --type has been deprecated in favor of --template."],
        body: ["Please use --template instead."]
      });
      return;
    }
    await checkFolderIsValidApp(flags.path), await generate_default({
      directory: flags.path,
      reset: flags.reset,
      apiKey,
      name: flags.name,
      cloneUrl: flags["clone-url"],
      template: flags.template,
      flavor: flags.flavor,
      configName: flags.config
    });
  }
};
_a28 = AppGenerateExtension;
AppGenerateExtension.summary = "Generate a new app Extension.";
AppGenerateExtension.examples = ["<%= config.bin %> <%= command.id %>"];
AppGenerateExtension.descriptionWithMarkdown = `Generates a new [app extension](https://shopify.dev/docs/apps/app-extensions). For a list of app extensions that you can generate using this command, refer to [Supported extensions](https://shopify.dev/docs/apps/structure/app-extensions/list).

  Each new app extension is created in a folder under \`extensions/\`. To learn more about the extensions file structure, refer to [App structure](https://shopify.dev/docs/apps/tools/cli/structure) and the documentation for your extension.
  `;
AppGenerateExtension.description = _a28.descriptionWithoutMarkdown();
AppGenerateExtension.flags = {
  ...globalFlags,
  ...appFlags,
  type: import_core40.Flags.string({
    char: "t",
    hidden: !1,
    description: "Deprecated. Please use --template",
    env: "SHOPIFY_FLAG_EXTENSION_TYPE"
  }),
  template: import_core40.Flags.string({
    char: "t",
    hidden: !1,
    description: "Extension template",
    env: "SHOPIFY_FLAG_EXTENSION_TEMPLATE"
  }),
  name: import_core40.Flags.string({
    char: "n",
    hidden: !1,
    description: "name of your Extension",
    env: "SHOPIFY_FLAG_NAME"
  }),
  "clone-url": import_core40.Flags.string({
    hidden: !0,
    char: "u",
    description: "The Git URL to clone the function extensions templates from. Defaults to: https://github.com/Shopify/function-examples",
    env: "SHOPIFY_FLAG_CLONE_URL"
  }),
  flavor: import_core40.Flags.string({
    hidden: !1,
    description: "Choose a starting template for your extension, where applicable",
    options: ["vanilla-js", "react", "typescript", "typescript-react", "wasm", "rust"],
    env: "SHOPIFY_FLAG_FLAVOR"
  }),
  reset: import_core40.Flags.boolean({
    hidden: !1,
    description: "Reset all your settings.",
    env: "SHOPIFY_FLAG_RESET",
    default: !1,
    exclusive: ["config"]
  }),
  "api-key": import_core40.Flags.string({
    hidden: !0,
    description: "The API key of your app.",
    env: "SHOPIFY_FLAG_APP_API_KEY",
    exclusive: ["config"]
  }),
  "client-id": import_core40.Flags.string({
    hidden: !1,
    description: "The Client ID of your app.",
    env: "SHOPIFY_FLAG_CLIENT_ID",
    exclusive: ["config"]
  })
};
AppGenerateExtension.args = {
  file: import_core40.Args.string()
};
var extension_default2 = AppGenerateExtension;

// ../app/dist/cli/commands/app/generate/schema.js
init_cjs_shims();
var _a29, GenerateSchema = class extends schema_default {
};
_a29 = GenerateSchema;
GenerateSchema.hidden = !0;
GenerateSchema.descriptionWithMarkdown = "[DEPRECATED, use `app function schema`] Generates the latest [GraphQL schema](https://shopify.dev/docs/apps/functions/input-output#graphql-schema) for a function in your app. Run this command from the function directory.\n\n  This command uses the API type and version of your function, as defined in your extension TOML file, to generate the latest GraphQL schema. The schema is written to the `schema.graphql` file.";
GenerateSchema.description = _a29.descriptionWithoutMarkdown();
var schema_default2 = GenerateSchema;

// ../app/dist/cli/commands/app/import-extensions.js
init_cjs_shims();

// ../app/dist/cli/services/payments/extension-to-toml.js
init_cjs_shims();
function typeToContext(type) {
  switch (type) {
    case DashboardPaymentExtensionType.Offsite:
      return OFFSITE_TARGET;
    case DashboardPaymentExtensionType.CreditCard:
      return CREDIT_CARD_TARGET;
    case DashboardPaymentExtensionType.CustomCreditCard:
      return CUSTOM_CREDIT_CARD_TARGET;
    case DashboardPaymentExtensionType.CustomOnsite:
      return CUSTOM_ONSITE_TARGET;
    case DashboardPaymentExtensionType.Redeemable:
      return REDEEMABLE_TARGET;
  }
}
var DashboardPaymentExtensionType;
(function(DashboardPaymentExtensionType2) {
  DashboardPaymentExtensionType2.Offsite = "payments_app", DashboardPaymentExtensionType2.CreditCard = "payments_app_credit_card", DashboardPaymentExtensionType2.CustomCreditCard = "payments_app_custom_credit_card", DashboardPaymentExtensionType2.CustomOnsite = "payments_app_custom_onsite", DashboardPaymentExtensionType2.Redeemable = "payments_app_redeemable";
})(DashboardPaymentExtensionType || (DashboardPaymentExtensionType = {}));
function buildTomlObject(extension, allExtensions) {
  let context = extension.activeVersion?.context || extension.draftVersion?.context || typeToContext(extension.type);
  switch (context) {
    case OFFSITE_TARGET:
      return buildPaymentsToml(extension, allExtensions, offsiteDeployConfigToCLIConfig);
    case CREDIT_CARD_TARGET:
      return buildPaymentsToml(extension, allExtensions, creditCardDeployConfigToCLIConfig);
    case CUSTOM_CREDIT_CARD_TARGET:
      return buildPaymentsToml(extension, allExtensions, customCreditCardDeployConfigToCLIConfig);
    case CUSTOM_ONSITE_TARGET:
      return buildPaymentsToml(extension, allExtensions, customOnsiteDeployConfigToCLIConfig);
    case REDEEMABLE_TARGET:
      return buildPaymentsToml(extension, allExtensions, redeemableDeployConfigToCLIConfig);
    default:
      throw new Error(`Unsupported extension: ${context}`);
  }
}
function buildPaymentsToml(extension, allExtensions, serialize) {
  let versionConfig = (extension.activeVersion ?? extension.draftVersion)?.config;
  if (!versionConfig)
    throw new Error("No config found for extension");
  let dashboardConfig = JSON.parse(versionConfig), cliConfig = serialize(dashboardConfig, allExtensions);
  cliConfig && delete cliConfig.api_version;
  let context = extension.activeVersion?.context || extension.draftVersion?.context || typeToContext(extension.type), localExtensionRepresentation = {
    api_version: dashboardConfig.api_version,
    extensions: [
      {
        name: extension.title,
        type: "payments_extension",
        handle: slugify(extension.title.substring(0, MAX_EXTENSION_HANDLE_LENGTH)),
        ...cliConfig,
        targeting: [
          {
            target: `${context}`
          }
        ]
      }
    ]
  };
  return encodeToml(localExtensionRepresentation);
}

// ../app/dist/cli/services/flow/extension-to-toml.js
init_cjs_shims();

// ../app/dist/cli/services/flow/serialize-partners-fields.js
init_cjs_shims();
var uiTypesToTypes = new Map(uiTypesMap.map((typeMapping) => [typeMapping[1], typeMapping[0]])), serializeConfigField2 = (field, type) => {
  let fieldType = uiTypesToTypes.get(field.uiType);
  if (!fieldType)
    throw new AbortError(`Field type ${field.uiType} is not supported`);
  let serializedField = {
    key: field.name,
    description: field.description ? field.description : void 0,
    type: fieldType
  };
  return type === "flow_action_definition" && (serializedField.name = field.label, serializedField.required = field.required), serializedField;
}, serializeCommerceObjectField2 = (field, type) => {
  let serializedField = {
    type: type === "flow_action_definition" ? `${field.name.replace("_id", "")}_reference` : `${field.uiType}_reference`
  };
  return type === "flow_action_definition" && (serializedField.required = field.required), serializedField;
}, configFromSerializedFields = (type, fields) => fields ? fields.map((field) => field.uiType === "commerce-object-id" || PARTNERS_COMMERCE_OBJECTS.includes(field.uiType) ? serializeCommerceObjectField2(field, type) : serializeConfigField2(field, type)) : [];

// ../app/dist/cli/services/flow/extension-to-toml.js
function buildTomlObject2(extension) {
  let versionConfig = extension.activeVersion?.config ?? extension.draftVersion?.config;
  if (!versionConfig)
    throw new Error("No config found for extension");
  let config2 = JSON.parse(versionConfig), fields = configFromSerializedFields(extension.type, config2.fields ?? []), defaultURL = extension.type === "flow_action_definition" ? "https://url.com/api/execute" : void 0, localExtensionRepresentation = {
    extensions: [
      {
        type: extension.type.replace("_definition", ""),
        name: config2.title,
        handle: slugify(extension.title.substring(0, MAX_EXTENSION_HANDLE_LENGTH)),
        description: config2.description,
        runtime_url: config2.url ?? defaultURL,
        config_page_url: config2.custom_configuration_page_url,
        config_page_preview_url: config2.custom_configuration_page_preview_url,
        validation_url: config2.validation_url
      }
    ],
    settings: (fields?.length ?? 0) > 0 ? { fields } : void 0
  };
  return encodeToml(localExtensionRepresentation);
}

// ../app/dist/cli/services/marketing_activity/extension-to-toml.js
init_cjs_shims();
var PLATFORM_CHANNEL_MAP = {
  facebook: "social",
  instagram: "social",
  google: "search",
  pinterest: "social",
  bing: "search",
  email: "email",
  snapchat: "social",
  sms: "sms",
  verizon_media: "display",
  ebay: "marketplace",
  tiktok: "social",
  flow: "email"
}, PLATFORM_DOMAIN_MAP = {
  facebook: "facebook.com",
  instagram: "instagram.com",
  google: "google.com",
  pinterest: "pinterest.com",
  bing: "bing.com",
  snapchat: "snapchat.com",
  verizon_media: null,
  email: null,
  sms: null,
  ebay: "ebay.com",
  tiktok: "tiktok.com",
  flow: null
};
function buildTomlObject3(extension) {
  let versionConfig = extension.activeVersion?.config ?? extension.draftVersion?.config;
  if (!versionConfig)
    throw new Error("No config found for extension");
  let config2 = JSON.parse(versionConfig), localExtensionRepresentation = {
    extensions: [
      {
        type: "marketing_activity_extension_cli",
        name: config2.title,
        handle: slugify(extension.title.substring(0, MAX_EXTENSION_HANDLE_LENGTH)),
        title: config2.title,
        description: config2.description,
        app_api_url: config2.app_api_url,
        tactic: config2.tactic,
        marketing_channel: PLATFORM_CHANNEL_MAP[config2.platform] ?? "",
        referring_domain: PLATFORM_DOMAIN_MAP[config2.platform] ?? "",
        is_automation: config2.is_automation,
        use_external_editor: config2.use_external_editor,
        preview_data: config2.preview_data,
        fields: config2.fields
      }
    ]
  };
  return encodeToml(localExtensionRepresentation);
}

// ../app/dist/cli/services/import-extensions.js
init_cjs_shims();

// ../app/dist/cli/services/fetch-extensions.js
init_cjs_shims();
async function getExtensions({ developerPlatformClient, apiKey, organizationId, extensionTypes }) {
  let initialRemoteExtensions = await developerPlatformClient.appExtensionRegistrations({
    id: apiKey,
    apiKey,
    organizationId
  }), { dashboardManagedExtensionRegistrations, extensionRegistrations } = initialRemoteExtensions.app;
  return extensionRegistrations.concat(dashboardManagedExtensionRegistrations).filter((ext) => {
    let isNeededExtensionType = extensionTypes.includes(ext.type.toLowerCase()), hasActiveVersion = ext.activeVersion && ext.activeVersion.config, hasDraftVersion = ext.draftVersion && ext.draftVersion.config;
    return isNeededExtensionType && (hasActiveVersion || hasDraftVersion);
  });
}

// ../app/dist/cli/services/import-extensions.js
async function importExtensions(options) {
  let developerPlatformClient = options.developerPlatformClient ?? selectDeveloperPlatformClient({ configuration: options.app.configuration }), [remoteApp, _2] = await fetchAppAndIdentifiers({ ...options, reset: !1 }, developerPlatformClient, !1);
  await logMetadataForLoadedContext(remoteApp);
  let initialRemoteExtensions = await developerPlatformClient.appExtensionRegistrations({
    id: remoteApp.apiKey,
    apiKey: remoteApp.apiKey,
    organizationId: remoteApp.organizationId
  }), { extensionRegistrations } = initialRemoteExtensions.app, extensions = await getExtensions({
    developerPlatformClient,
    apiKey: remoteApp.apiKey,
    organizationId: remoteApp.organizationId,
    extensionTypes: options.extensionTypes
  });
  if (extensions.length === 0) {
    renderSuccess({ headline: ["No extensions to migrate."] });
    return;
  }
  let choices = extensions.map((ext) => ({ label: ext.title, value: ext.uuid }));
  choices.push({ label: "All", value: "All" });
  let promptAnswer = await renderSelectPrompt({ message: "Extensions to migrate", choices }), extensionsToMigrate = promptAnswer === "All" ? extensions : [extensions.find((ext) => ext?.uuid === promptAnswer)], extensionUuids = {}, importPromises = extensionsToMigrate.map(async (ext) => {
    let directory = await ensureExtensionDirectoryExists({ app: options.app, name: ext.title }), tomlObject = options.buildTomlObject(ext, extensionRegistrations), path3 = joinPath(directory, "shopify.extension.toml");
    await writeFile(path3, tomlObject);
    let handle = slugify(ext.title.substring(0, MAX_EXTENSION_HANDLE_LENGTH));
    return extensionUuids[handle] = ext.uuid, { extension: ext, directory: joinPath("extensions", basename(directory)) };
  }), generatedExtensions = await Promise.all(importPromises);
  renderSuccessMessages(generatedExtensions), await updateAppIdentifiers({
    app: options.app,
    identifiers: {
      extensions: extensionUuids,
      app: remoteApp.apiKey
    },
    command: "deploy",
    developerPlatformClient
  });
}
function renderSuccessMessages(generatedExtensions) {
  renderSuccess({
    headline: ["Imported the following extensions from the dashboard:"],
    body: generatedExtensions.map((gen) => outputContent`• "${gen.extension.title}" at: ${gen.directory}`.value).join(`
`)
  });
}

// ../app/dist/cli/commands/app/import-extensions.js
var import_core41 = __toESM(require_lib(), 1);
var getMigrationChoices = (isShopifolk) => [
  {
    label: "Payments Extensions",
    value: "payments",
    extensionTypes: [
      "payments_app",
      "payments_app_credit_card",
      "payments_app_custom_credit_card",
      "payments_app_custom_onsite",
      "payments_app_redeemable",
      "payments_extension"
    ],
    buildTomlObject
  },
  {
    label: "Flow Extensions",
    value: "flow",
    extensionTypes: ["flow_action_definition", "flow_trigger_definition"],
    buildTomlObject: buildTomlObject2
  },
  ...isShopifolk ? [
    {
      label: "Marketing Activity Extensions",
      value: "marketing activity",
      extensionTypes: ["marketing_activity_extension"],
      buildTomlObject: buildTomlObject3
    }
  ] : []
], ImportExtensions = class _ImportExtensions extends AppCommand {
  async run() {
    let { flags } = await this.parse(_ImportExtensions), specifications = await loadLocalExtensionsSpecifications(), app = await loadApp({
      specifications,
      directory: flags.path,
      userProvidedConfigName: flags.config
    }), isShopifolk = await isShopify(), migrationChoices = getMigrationChoices(isShopifolk), choices = migrationChoices.map((choice) => ({ label: choice.label, value: choice.value })), promptAnswer = await renderSelectPrompt({ message: "Extension type to migrate", choices }), migrationChoice = migrationChoices.find((choice) => choice.value === promptAnswer);
    if (migrationChoice === void 0) {
      renderFatalError(new AbortError("Invalid migration choice"));
      return;
    }
    await importExtensions({
      app,
      apiKey: flags["client-id"],
      extensionTypes: migrationChoice.extensionTypes,
      buildTomlObject: migrationChoice.buildTomlObject
    });
  }
};
ImportExtensions.description = "Import dashboard-managed extensions into your app.";
ImportExtensions.flags = {
  ...globalFlags,
  ...appFlags,
  "client-id": import_core41.Flags.string({
    hidden: !1,
    description: "The Client ID of your app.",
    env: "SHOPIFY_FLAG_CLIENT_ID",
    exclusive: ["config"]
  })
};
var import_extensions_default = ImportExtensions;

// ../app/dist/cli/commands/app/info.js
init_cjs_shims();

// ../app/dist/cli/services/info.js
init_cjs_shims();
async function info(app, options) {
  return options.developerPlatformClient = options.developerPlatformClient ?? selectDeveloperPlatformClient({ configuration: app.configuration }), options.webEnv ? infoWeb(app, options) : infoApp(app, options);
}
async function infoWeb(app, { format: format4 }) {
  return outputEnv(app, format4);
}
async function infoApp(app, options) {
  if (options.format === "json") {
    let extensionsInfo = withPurgedSchemas(app.allExtensions.filter((ext) => ext.isReturnedAsInfo())), appWithSupportedExtensions = {
      ...app,
      allExtensions: extensionsInfo
    };
    return "realExtensions" in appWithSupportedExtensions && (appWithSupportedExtensions.realExtensions = withPurgedSchemas(appWithSupportedExtensions.realExtensions)), "specifications" in appWithSupportedExtensions && (appWithSupportedExtensions = {
      ...appWithSupportedExtensions,
      specifications: appWithSupportedExtensions.specifications?.map((spec3) => objectWithoutSchema(spec3))
    }), outputContent`${JSON.stringify(Object.fromEntries(Object.entries(appWithSupportedExtensions).filter(([key]) => key !== "configSchema")), null, 2)}`;
  } else
    return new AppInfo(app, options).output();
}
function objectWithoutSchema(obj) {
  if ("schema" in obj) {
    let { schema, ...rest } = obj;
    return rest;
  }
  return obj;
}
function withPurgedSchemas(extensions) {
  return extensions.map((ext) => {
    if ("specification" in ext && ext.specification) {
      let specification = ext.specification, specificationWithoutSchema = objectWithoutSchema(specification);
      return { ...ext, specification: specificationWithoutSchema };
    } else
      return ext;
  });
}
var UNKNOWN_TEXT = outputContent`${outputToken.italic("unknown")}`.value, NOT_CONFIGURED_TEXT = outputContent`${outputToken.italic("Not yet configured")}`.value, AppInfo = class {
  constructor(app, options) {
    this.app = app, this.options = options;
  }
  async output() {
    return [
      await this.devConfigsSection(),
      this.projectSettingsSection(),
      await this.appComponentsSection(),
      await this.systemInfoSection()
    ].map((sectionContents) => formatSection(...sectionContents)).join(`

`);
  }
  async devConfigsSection() {
    let title = "Current app configuration", developerPlatformClient = this.options.developerPlatformClient, { cachedInfo, remoteApp } = await getAppContext({
      developerPlatformClient,
      directory: this.app.directory,
      reset: !1,
      configName: this.options.configName,
      enableLinkingPrompt: !1
    });
    developerPlatformClient = remoteApp?.developerPlatformClient ?? developerPlatformClient;
    let postscript = outputContent`💡 To change these, run ${outputToken.packagejsonScript(this.app.packageManager, "dev", "--reset")}`.value, updateUrls;
    cachedInfo?.updateURLs === void 0 ? updateUrls = NOT_CONFIGURED_TEXT : updateUrls = cachedInfo.updateURLs ? "Yes" : "No";
    let partnersAccountInfo = ["Partners account", "unknown"], retrievedAccountInfo = await developerPlatformClient.accountInfo();
    isServiceAccount(retrievedAccountInfo) ? partnersAccountInfo = ["Service account", retrievedAccountInfo.orgName] : isUserAccount(retrievedAccountInfo) && (partnersAccountInfo = ["Partners account", retrievedAccountInfo.email]);
    let lines = [
      ["Configuration file", cachedInfo?.configFile || configurationFileNames.app],
      ["App name", cachedInfo?.title || NOT_CONFIGURED_TEXT],
      ["Client ID", cachedInfo?.appId || NOT_CONFIGURED_TEXT],
      ["Access scopes", getAppScopes(this.app.configuration)],
      ["Dev store", cachedInfo?.storeFqdn || NOT_CONFIGURED_TEXT],
      ["Update URLs", updateUrls],
      partnersAccountInfo
    ];
    return [title, `${linesToColumns(lines)}

${postscript}`];
  }
  projectSettingsSection() {
    let title = "Your Project", lines = [["Root location", this.app.directory]];
    return [title, linesToColumns(lines)];
  }
  async appComponentsSection() {
    let title = "Directory Components", body = this.webComponentsSection();
    function augmentWithExtensions(extensions, outputFormatter) {
      new Set(extensions.map((ext) => ext.type)).forEach((extensionType) => {
        let relevantExtensions = extensions.filter((extension) => extension.type === extensionType);
        relevantExtensions[0] && (body += `

${outputContent`${outputToken.subheading(relevantExtensions[0].externalType)}`.value}`, relevantExtensions.forEach((extension) => {
          body += `${outputFormatter(extension)}`;
        }));
      });
    }
    let supportedExtensions = this.app.allExtensions.filter((ext) => ext.isReturnedAsInfo());
    return augmentWithExtensions(supportedExtensions, this.extensionSubSection.bind(this)), this.app.errors?.isEmpty() === !1 && (body += `

${outputContent`${outputToken.subheading("Extensions with errors")}`.value}`, supportedExtensions.forEach((extension) => {
      body += `${this.invalidExtensionSubSection(extension)}`;
    })), [title, body];
  }
  webComponentsSection() {
    let errors2 = [], subtitle = [outputContent`${outputToken.subheading("web")}`.value], toplevel = ["\u{1F4C2} web", ""], sublevels = [];
    this.app.webs.forEach((web2) => {
      if (web2.configuration)
        if (web2.configuration.name) {
          let { name, roles } = web2.configuration;
          sublevels.push([`    \u{1F4C2} ${name} (${roles.join(",")})`, relativePath(this.app.directory, web2.directory)]);
        } else
          web2.configuration.roles.forEach((role) => {
            sublevels.push([`    \u{1F4C2} ${role}`, relativePath(this.app.directory, web2.directory)]);
          });
      else
        sublevels.push([`  \u{1F4C2} ${UNKNOWN_TEXT}`, relativePath(this.app.directory, web2.directory)]);
      if (this.app.errors) {
        let error = this.app.errors.getError(`${web2.directory}/${configurationFileNames.web}`);
        error && errors2.push(error);
      }
    });
    let errorContent = `
${errors2.map(this.formattedError).join(`
`)}`;
    return errorContent.trim() === "" && (errorContent = ""), `${subtitle}
${linesToColumns([toplevel, ...sublevels])}${errorContent}`;
  }
  extensionSubSection(extension) {
    let config2 = extension.configuration, details = [
      [`\u{1F4C2} ${extension.handle}`, relativePath(this.app.directory, extension.directory)],
      ["     config file", relativePath(extension.directory, extension.configurationPath)]
    ];
    return config2 && config2.metafields?.length && details.push(["     metafields", `${config2.metafields.length}`]), `
${linesToColumns(details)}`;
  }
  invalidExtensionSubSection(extension) {
    let error = this.app.errors?.getError(extension.configurationPath);
    if (!error)
      return "";
    let details = [
      [`\u{1F4C2} ${extension.handle}`, relativePath(this.app.directory, extension.directory)],
      ["     config file", relativePath(extension.directory, extension.configurationPath)]
    ], formattedError = this.formattedError(error);
    return `
${linesToColumns(details)}
${formattedError}`;
  }
  formattedError(str) {
    let [errorFirstLine, ...errorRemainingLines] = stringifyMessage(str).split(`
`), errorLines = [`! ${errorFirstLine}`, ...errorRemainingLines.map((line) => `  ${line}`)];
    return outputContent`${outputToken.errorText(errorLines.join(`
`))}`.value;
  }
  async systemInfoSection() {
    let title = "Tooling and System", { platform: platform2, arch } = platformAndArch(), lines = [
      ["Shopify CLI", CLI_KIT_VERSION],
      ["Package manager", this.app.packageManager],
      ["OS", `${platform2}-${arch}`],
      ["Shell", process.env.SHELL || "unknown"],
      ["Node version", process.version]
    ];
    return [title, `${linesToColumns(lines)}`];
  }
};

// ../app/dist/cli/commands/app/info.js
var import_core42 = __toESM(require_lib(), 1);
var _a30, AppInfo2 = class extends AppCommand {
  async run() {
    let { flags } = await this.parse(_a30), specifications = await loadLocalExtensionsSpecifications(), app = await loadApp({
      specifications,
      directory: flags.path,
      userProvidedConfigName: flags.config,
      mode: "report"
    });
    outputInfo(await info(app, {
      format: flags.json ? "json" : "text",
      webEnv: flags["web-env"],
      configName: flags.config
    })), app.errors && process.exit(2);
  }
};
_a30 = AppInfo2;
AppInfo2.summary = "Print basic information about your app and extensions.";
AppInfo2.descriptionWithMarkdown = `The information returned includes the following:

  - The app and development store or Plus sandbox store that's used when you run the [dev](https://shopify.dev/docs/api/shopify-cli/app/app-dev) command. You can reset these configurations using [\`dev --reset\`](https://shopify.dev/docs/api/shopify-cli/app/app-dev#flags-propertydetail-reset).
  - The [structure](https://shopify.dev/docs/apps/tools/cli/structure) of your app project.
  - The [access scopes](https://shopify.dev/docs/api/usage) your app has requested.
  - System information, including the package manager and version of Shopify CLI used in the project.`;
AppInfo2.description = _a30.descriptionWithoutMarkdown();
AppInfo2.flags = {
  ...globalFlags,
  ...appFlags,
  json: import_core42.Flags.boolean({
    hidden: !1,
    description: "format output as JSON",
    env: "SHOPIFY_FLAG_JSON"
  }),
  "web-env": import_core42.Flags.boolean({
    hidden: !1,
    description: "Outputs environment variables necessary for running and deploying web/.",
    env: "SHOPIFY_FLAG_OUTPUT_WEB_ENV",
    default: !1
  })
};
var info_default2 = AppInfo2;

// ../app/dist/cli/commands/app/init.js
init_cjs_shims();

// ../create-app/dist/commands/init.js
init_cjs_shims();

// ../create-app/dist/prompts/init.js
init_cjs_shims();
var templates = {
  remix: {
    url: "https://github.com/Shopify/shopify-app-template-remix",
    label: "Start with Remix (recommended)",
    visible: !0,
    branches: {
      prompt: "For your Remix template, which language do you want?",
      options: {
        javascript: { branch: "javascript", label: "JavaScript" },
        typescript: { branch: "main", label: "TypeScript" }
      }
    }
  },
  none: {
    url: "https://github.com/Shopify/shopify-app-template-none",
    label: "Start by adding your first extension",
    visible: !0
  },
  node: {
    url: "https://github.com/Shopify/shopify-app-template-node",
    visible: !1
  },
  php: {
    url: "https://github.com/Shopify/shopify-app-template-php",
    visible: !1
  },
  ruby: {
    url: "https://github.com/Shopify/shopify-app-template-ruby",
    visible: !1
  }
}, allTemplates = Object.keys(templates), visibleTemplates = allTemplates.filter((key) => templates[key].visible), templateOptionsInOrder = ["remix", "none"], init = async (options) => {
  let name = options.name, template2 = options.template, flavor = options.flavor, defaults = {
    name: await generateRandomNameForSubdirectory({ suffix: "app", directory: options.directory }),
    template: templates.remix.url
  }, welcomed = !1;
  name || (renderText({ text: `
Welcome. Let\u2019s get started by naming your app project. You can change it later.` }), welcomed = !0, name = await renderTextPrompt({
    message: "Your project name?",
    defaultValue: defaults.name,
    validate: (value) => {
      if (value.length === 0)
        return "App name can't be empty";
      if (value.length > 30)
        return "Enter a shorter name (30 character max.)";
      if (value.toLowerCase().includes("shopify"))
        return "App name can't include the word 'shopify'";
    }
  })), template2 || (welcomed || (renderText({ text: `
Welcome. Let\u2019s get started by choosing a template for your app project.` }), welcomed = !0), template2 = await renderSelectPrompt({
    choices: templateOptionsInOrder.map((key) => ({
      label: templates[key].label || key,
      value: key
    })),
    message: "Get started building your app:",
    defaultValue: allTemplates.find((key) => templates[key].url === defaults.template)
  }));
  let answers = {
    ...options,
    name,
    template: template2,
    templateType: isPredefinedTemplate(template2) ? template2 : "custom",
    globalCLIResult: { install: !1, alreadyInstalled: !1 }
  }, selectedUrl, branch;
  if (answers.templateType !== "custom") {
    let selectedTemplate = templates[answers.templateType];
    selectedUrl = selectedTemplate.url, selectedTemplate.branches && (flavor ? branch = selectedTemplate.branches.options[flavor]?.branch : branch = await renderSelectPrompt({
      message: selectedTemplate.branches.prompt || "Choose a flavor:",
      choices: Object.entries(selectedTemplate.branches.options).map(([_key, branch2]) => ({
        value: branch2.branch,
        label: branch2.label
      }))
    }));
  }
  return branch && (selectedUrl += `#${branch}`), answers.template = selectedUrl || answers.template || defaults.template, answers.globalCLIResult = await installGlobalCLIPrompt(), answers;
}, init_default3 = init;
function isPredefinedTemplate(template2) {
  return allTemplates.includes(template2);
}

// ../create-app/dist/services/init.js
init_cjs_shims();

// ../create-app/dist/utils/template/npm.js
init_cjs_shims();
import { platform } from "os";
async function updateCLIDependencies({ packageJSON, local, useGlobalCLI }) {
  if (packageJSON.dependencies = packageJSON.dependencies || {}, useGlobalCLI ? delete packageJSON.dependencies["@shopify/cli"] : packageJSON.dependencies["@shopify/cli"] = CLI_KIT_VERSION, delete packageJSON.dependencies["@shopify/app"], local) {
    let cliPath = await packagePath("cli");
    packageJSON.dependencies["@shopify/cli"] = cliPath;
    let dependencyOverrides = {
      "@shopify/cli": cliPath
    };
    packageJSON.overrides = packageJSON.overrides ? { ...packageJSON.overrides, ...dependencyOverrides } : dependencyOverrides, packageJSON.resolutions = packageJSON.resolutions ? { ...packageJSON.resolutions, ...dependencyOverrides } : dependencyOverrides;
  }
  return packageJSON;
}
async function packagePath(packageName) {
  return `file:${await findPathUp(`packages/${packageName}`, {
    type: "directory",
    cwd: moduleDirectory(import.meta.url)
  })}`;
}
async function getDeepInstallNPMTasks({ from, packageManager: packageManager2 }) {
  let args = platform() === "win32" && packageManager2 === "yarn" ? ["--network-concurrency", "1"] : [];
  return installNodeModules({ directory: normalizePath(from), packageManager: packageManager2, args });
}

// ../create-app/dist/utils/template/cleanup.js
init_cjs_shims();
async function cleanup(webOutputDirectory) {
  let gitPaths = await glob([
    joinPath(webOutputDirectory, "**", ".git"),
    joinPath(webOutputDirectory, "**", ".github"),
    joinPath(webOutputDirectory, "**", ".gitmodules"),
    joinPath(webOutputDirectory, "LICENSE*"),
    joinPath(webOutputDirectory, "**", "frontend/LICENSE*"),
    joinPath(webOutputDirectory, "package.json.cli2")
  ], {
    dot: !0,
    onlyFiles: !1,
    onlyDirectories: !1,
    ignore: ["**/node_modules/**"]
  });
  return Promise.all(gitPaths.map((path3) => rmdir(path3, { force: !0 }))).then(() => {
  });
}

// ../create-app/dist/services/init.js
async function init2(options) {
  let packageManager2 = options.packageManager, hyphenizedName = hyphenate(options.name), outputDirectory = joinPath(options.directory, hyphenizedName), githubRepo = parseGitHubRepositoryReference(options.template);
  await ensureAppDirectoryIsAvailable(outputDirectory, hyphenizedName), await clearCache(outputDirectory), renderInfo({
    body: [
      "Initializing project with",
      { command: packageManager2 },
      `
Use the`,
      { command: "--package-manager" },
      "flag to select a different package manager."
    ]
  }), await inTemporaryDirectory(async (tmpDir) => {
    let templateDownloadDir = joinPath(tmpDir, "download"), templatePathDir = githubRepo.filePath ? joinPath(templateDownloadDir, githubRepo.filePath) : templateDownloadDir, templateScaffoldDir = joinPath(tmpDir, "app"), repoUrl = githubRepo.branch ? `${githubRepo.baseURL}#${githubRepo.branch}` : githubRepo.baseURL;
    await mkdir(templateDownloadDir);
    let tasks = [
      {
        title: `Downloading template from ${repoUrl}`,
        task: async () => {
          await downloadGitRepository({
            repoUrl,
            destination: templateDownloadDir,
            shallow: !0
          });
        }
      }
    ];
    tasks.push({
      title: "Parsing liquid",
      task: async () => {
        await recursiveLiquidTemplateCopy(templatePathDir, templateScaffoldDir, {
          dependency_manager: packageManager2,
          app_name: options.name
        });
      }
    }, {
      title: "Updating package.json",
      task: async () => {
        let packageJSON = (await findUpAndReadPackageJson(templateScaffoldDir)).content;
        packageJSON.name = hyphenizedName, packageJSON.author = await username() ?? "", packageJSON.private = !0;
        let workspacesFolders = ["extensions/*"].concat(detectAdditionalWorkspacesFolders(templateScaffoldDir));
        switch (packageManager2) {
          case "npm":
          case "yarn":
          case "bun":
            packageJSON.workspaces = workspacesFolders;
            break;
          case "pnpm": {
            let workspacesContent = workspacesFolders.map((folder) => ` - '${folder}'`).join(`
`);
            await writeFile(joinPath(templateScaffoldDir, "pnpm-workspace.yaml"), `packages:
${workspacesContent}`), await appendFile(joinPath(templateScaffoldDir, ".npmrc"), `auto-install-peers=true
`);
            break;
          }
          case "unknown":
            throw new UnknownPackageManagerError();
        }
        await updateCLIDependencies({
          packageJSON,
          local: options.local,
          directory: templateScaffoldDir,
          useGlobalCLI: options.useGlobalCLI
        }), await writePackageJSON(templateScaffoldDir, packageJSON);
      }
    }), options.postCloneActions.removeLockfilesFromGitignore && tasks.push({
      title: "Removing lockfiles from .gitignore",
      task: async () => {
        let gitignorePath = joinPath(templateScaffoldDir, ".gitignore");
        if (await fileExists(gitignorePath)) {
          let existingContent = await readFile(gitignorePath);
          lockfiles.forEach((lockfile2) => {
            let lockfileRegex = new RegExp(`^${lockfile2.replace(/[.*+?^${}()|[\]\\]/g, "\\$&")}$`, "gm");
            existingContent = existingContent.replace(lockfileRegex, "");
          }), await writeFile(gitignorePath, existingContent.trim());
        }
      }
    }), await isShopify() && tasks.push({
      title: "[Shopifolks-only] Configuring the project's NPM registry",
      task: async () => {
        let npmrcPath = joinPath(templateScaffoldDir, ".npmrc");
        await appendFile(npmrcPath, `@shopify:registry=https://registry.npmjs.org
`);
      }
    }), tasks.push({
      title: `Installing dependencies with ${packageManager2}`,
      task: async () => {
        await getDeepInstallNPMTasks({ from: templateScaffoldDir, packageManager: packageManager2 });
      }
    }, {
      title: "Cleaning up",
      task: async () => {
        await cleanup(templateScaffoldDir);
      }
    }, {
      title: "Initializing a Git repository...",
      task: async () => {
        await initializeGitRepository(templateScaffoldDir);
      }
    }), await renderTasks(tasks), await moveFile(templateScaffoldDir, outputDirectory);
  }), renderSuccess({
    headline: [{ userInput: hyphenizedName }, "is ready for you to build!"],
    nextSteps: [
      ["Run", { command: `cd ${hyphenizedName}` }],
      ["For extensions, run", { command: formatPackageManagerCommand(packageManager2, "shopify app generate extension") }],
      ["To see your app, run", { command: formatPackageManagerCommand(packageManager2, "shopify app dev") }]
    ],
    reference: [
      { link: { label: "Shopify docs", url: "https://shopify.dev" } },
      [
        "For an overview of commands, run",
        { command: `${formatPackageManagerCommand(packageManager2, "shopify app", "--help")}` }
      ]
    ]
  });
}
async function ensureAppDirectoryIsAvailable(directory, name) {
  if (await fileExists(directory))
    throw new AbortError(`
A directory with this name (${name}) already exists.
Choose a new name for your app.`);
}
async function clearCache(directory) {
  let appCache = new LocalStorage({ projectName: "shopify-cli-app" }), normalizedDirectory = normalizePath(directory);
  appCache.delete(normalizedDirectory);
}
function detectAdditionalWorkspacesFolders(directory) {
  return ["web", "web/frontend"].filter((folder) => fileExistsSync(joinPath(directory, folder)));
}
var init_default4 = init2;

// ../create-app/dist/commands/init.js
var import_core43 = __toESM(require_lib(), 1);
var _a31, Init3 = class extends base_command_default {
  async run() {
    let { flags } = await this.parse(_a31);
    this.validateTemplateValue(flags.template), this.validateFlavorValue(flags.template, flags.flavor);
    let inferredPackageManager = this.inferPackageManager(flags["package-manager"]), promptAnswers = await init_default3({
      name: flags.name,
      template: flags.template,
      flavor: flags.flavor,
      directory: flags.path
    });
    promptAnswers.globalCLIResult.install && await installGlobalShopifyCLI(inferredPackageManager), await addPublicMetadata(() => ({
      cmd_create_app_template: promptAnswers.templateType,
      cmd_create_app_template_url: promptAnswers.template
    })), await init_default4({
      name: promptAnswers.name,
      packageManager: inferredPackageManager,
      template: promptAnswers.template,
      local: flags.local,
      directory: flags.path,
      useGlobalCLI: promptAnswers.globalCLIResult.alreadyInstalled || promptAnswers.globalCLIResult.install,
      postCloneActions: {
        removeLockfilesFromGitignore: promptAnswers.templateType !== "custom"
      }
    });
  }
  validateTemplateValue(template2) {
    if (!template2)
      return;
    let url = this.parseURL(template2);
    if (url && url.origin !== "https://github.com")
      throw new AbortError("Only GitHub repository references are supported, e.g., https://github.com/Shopify/<repository>/[subpath]#[branch]");
    if (!url && !isPredefinedTemplate(template2))
      throw new AbortError(outputContent`Only ${visibleTemplates.map((alias) => outputContent`${outputToken.yellow(alias)}`.value).join(", ")} template aliases are supported, please provide a valid URL`);
  }
  validateFlavorValue(template2, flavor) {
    if (!template2) {
      if (flavor)
        throw new AbortError(outputContent`The ${outputToken.yellow("--flavor")} flag requires the ${outputToken.yellow("--template")} flag to be set`);
      return;
    }
    if (!flavor)
      return;
    if (!isPredefinedTemplate(template2))
      throw new AbortError(outputContent`The ${outputToken.yellow("--flavor")} flag is not supported for custom templates`);
    let templateConfig = templates[template2];
    if (!templateConfig.branches)
      throw new AbortError(outputContent`The ${outputToken.yellow(template2)} template does not support flavors`);
    if (!templateConfig.branches.options[flavor])
      throw new AbortError(outputContent`Invalid option for ${outputToken.yellow("--flavor")}\nThe ${outputToken.yellow("--flavor")} flag for ${outputToken.yellow(template2)} accepts only ${Object.keys(templateConfig.branches.options).map((alias) => outputContent`${outputToken.yellow(alias)}`.value).join(", ")}`);
  }
  parseURL(url) {
    try {
      return new URL(url);
    } catch {
      return;
    }
  }
  inferPackageManager(optionsPackageManager) {
    if (optionsPackageManager && packageManager.includes(optionsPackageManager))
      return optionsPackageManager;
    let usedPackageManager = packageManagerFromUserAgent();
    if (usedPackageManager !== "unknown")
      return usedPackageManager;
    let globalPackageManager = inferPackageManagerForGlobalCLI();
    return globalPackageManager !== "unknown" ? globalPackageManager : "npm";
  }
};
_a31 = Init3;
Init3.summary = "Create a new app project";
Init3.flags = {
  ...globalFlags,
  name: import_core43.Flags.string({
    char: "n",
    env: "SHOPIFY_FLAG_NAME",
    hidden: !1
  }),
  path: import_core43.Flags.string({
    char: "p",
    env: "SHOPIFY_FLAG_PATH",
    parse: async (input) => resolvePath(input),
    default: async () => cwd(),
    hidden: !1
  }),
  template: import_core43.Flags.string({
    description: `The app template. Accepts one of the following:
       - <${visibleTemplates.join("|")}>
       - Any GitHub repo with optional branch and subpath, e.g., https://github.com/Shopify/<repository>/[subpath]#[branch]`,
    env: "SHOPIFY_FLAG_TEMPLATE"
  }),
  flavor: import_core43.Flags.string({
    description: "Which flavor of the given template to use.",
    env: "SHOPIFY_FLAG_TEMPLATE_FLAVOR"
  }),
  "package-manager": import_core43.Flags.string({
    char: "d",
    env: "SHOPIFY_FLAG_PACKAGE_MANAGER",
    hidden: !1,
    options: ["npm", "yarn", "pnpm", "bun"]
  }),
  local: import_core43.Flags.boolean({
    char: "l",
    env: "SHOPIFY_FLAG_LOCAL",
    default: !1,
    hidden: !0
  })
};
var init_default5 = Init3;

// ../app/dist/cli/commands/app/release.js
init_cjs_shims();

// ../app/dist/cli/services/release.js
init_cjs_shims();
async function release(options) {
  let { developerPlatformClient, app, remoteApp } = await ensureReleaseContext(options), { extensionIdentifiersBreakdown, versionDetails } = await extensionsIdentifiersReleaseBreakdown(developerPlatformClient, remoteApp, options.version), configExtensionIdentifiersBreakdown = await configExtensionsIdentifiersBreakdown({
    developerPlatformClient,
    apiKey: remoteApp.apiKey,
    localApp: app,
    remoteApp,
    versionAppModules: versionDetails.appModuleVersions.map((appModuleVersion) => ({
      ...appModuleVersion,
      ...appModuleVersion.config ? { config: JSON.parse(appModuleVersion.config) } : {}
    })),
    release: !0
  });
  if (!await deployOrReleaseConfirmationPrompt({
    configExtensionIdentifiersBreakdown,
    extensionIdentifiersBreakdown,
    appTitle: remoteApp.title,
    release: !0,
    force: options.force
  }))
    throw new AbortSilentError();
  let tasks = [
    {
      title: "Releasing version",
      task: async (context) => {
        context.appRelease = await developerPlatformClient.release({
          app: remoteApp,
          version: {
            versionId: versionDetails.uuid,
            appVersionId: versionDetails.id
          }
        });
      }
    }
  ], { appRelease: { appRelease: release2 } } = await renderTasks(tasks), linkAndMessage = [
    { link: { label: versionDetails.versionTag, url: versionDetails.location } },
    versionDetails.message ? `
${versionDetails.message}` : ""
  ];
  release2.userErrors?.length > 0 ? renderError({
    headline: "Version couldn't be released.",
    body: [
      ...linkAndMessage,
      `${linkAndMessage.length > 0 ? `

` : ""}${release2.userErrors.map((error) => error.message).join(", ")}`
    ]
  }) : renderSuccess({
    headline: "Version released to users.",
    body: linkAndMessage
  });
}

// ../app/dist/cli/commands/app/release.js
var import_core44 = __toESM(require_lib(), 1);
var _a32, Release = class extends AppCommand {
  async run() {
    let { flags } = await this.parse(_a32);
    flags["api-key"] && await showApiKeyDeprecationWarning();
    let apiKey = flags["client-id"] || flags["api-key"];
    await addPublicMetadata(() => ({
      cmd_app_reset_used: flags.reset
    }));
    let specifications = await loadLocalExtensionsSpecifications(), app = await loadApp({
      specifications,
      directory: flags.path,
      userProvidedConfigName: flags.config
    }), requiredNonTTYFlags = ["force"];
    !apiKey && !app.configuration.client_id && requiredNonTTYFlags.push("client-id"), this.failMissingNonTTYFlags(flags, requiredNonTTYFlags), await release({
      app,
      apiKey,
      reset: flags.reset,
      force: flags.force,
      version: flags.version
    });
  }
};
_a32 = Release;
Release.summary = "Release an app version.";
Release.usage = "app:release --version <version>";
Release.descriptionWithMarkdown = "Releases an existing app version. Pass the name of the version that you want to release using the `--version` flag.";
Release.description = _a32.descriptionWithoutMarkdown();
Release.flags = {
  ...globalFlags,
  ...appFlags,
  "api-key": import_core44.Flags.string({
    hidden: !0,
    description: "The API key of your app.",
    env: "SHOPIFY_FLAG_APP_API_KEY",
    exclusive: ["config"]
  }),
  "client-id": import_core44.Flags.string({
    hidden: !1,
    description: "The Client ID of your app.",
    env: "SHOPIFY_FLAG_CLIENT_ID",
    exclusive: ["config"]
  }),
  reset: import_core44.Flags.boolean({
    hidden: !1,
    description: "Reset all your settings.",
    env: "SHOPIFY_FLAG_RESET",
    default: !1
  }),
  force: import_core44.Flags.boolean({
    hidden: !1,
    description: "Release without asking for confirmation.",
    env: "SHOPIFY_FLAG_FORCE",
    char: "f"
  }),
  version: import_core44.Flags.string({
    hidden: !1,
    description: "The name of the app version to release.",
    env: "SHOPIFY_FLAG_VERSION",
    required: !0
  })
};
var release_default = Release;

// ../app/dist/cli/commands/app/versions/list.js
init_cjs_shims();

// ../app/dist/cli/services/versions-list.js
init_cjs_shims();
var TABLE_FORMATTING_CHARS = 12;
async function fetchAppVersions(developerPlatformClient, app, json) {
  let res = await developerPlatformClient.appVersions(app);
  if (!res.app)
    throw new AbortError(`Invalid API Key: ${app.apiKey}`);
  let appVersions = res.app.appVersions.nodes.map((appVersion) => {
    let message = appVersion.message ?? "";
    return {
      ...appVersion,
      status: appVersion.status === "active" && !json ? source_default.green(`\u2605 ${appVersion.status}`) : appVersion.status,
      createdBy: appVersion.createdBy?.displayName ?? "",
      createdAt: formatDate(new Date(appVersion.createdAt)),
      message
    };
  });
  if (!json) {
    let maxLineLength = (process.stdout.columns ?? 75) - TABLE_FORMATTING_CHARS, maxMessageLength = maxLineLength;
    appVersions.forEach((appVersion) => {
      let combinedLength = appVersion.message.length + appVersion.versionTag.length + unstyled(appVersion.status).length + appVersion.createdAt.length + appVersion.createdBy.length;
      if (combinedLength > maxLineLength) {
        let combinedWithoutMessageLength = combinedLength - appVersion.message.length, newMaxLength = Math.max(maxLineLength - combinedWithoutMessageLength, 10);
        newMaxLength < maxMessageLength && (maxMessageLength = newMaxLength);
      }
    }), appVersions.forEach((appVersion) => {
      appVersion.message.length > maxMessageLength && (appVersion.message = `${appVersion.message.slice(0, maxMessageLength - 3)}...`);
    });
  }
  return {
    appVersions,
    totalResults: res.app.appVersions.pageInfo.totalResults,
    app: res.app
  };
}
async function versionList(options) {
  let result = await ensureVersionsListContext(options), developerPlatformClient = options.developerPlatformClient ?? result.developerPlatformClient, { organizationId, title } = result.remoteApp, { appVersions, totalResults } = await fetchAppVersions(developerPlatformClient, result.remoteApp, options.json), { businessName: org } = await fetchOrgFromId(organizationId, developerPlatformClient);
  if (options.json)
    return outputInfo(JSON.stringify(appVersions, null, 2));
  if (renderCurrentlyUsedConfigInfo({
    org,
    appName: title,
    configFile: isCurrentAppSchema(options.app.configuration) ? basename(options.app.configuration.path) : void 0
  }), appVersions.length === 0) {
    outputInfo("No app versions found for this app");
    return;
  }
  renderTable({
    rows: appVersions,
    columns: {
      versionTag: { header: "VERSION" },
      status: { header: "STATUS" },
      message: { header: "MESSAGE" },
      createdAt: { header: "DATE CREATED" },
      createdBy: { header: "CREATED BY" }
    }
  });
  let link2 = outputToken.link(developerPlatformClient.webUiName, [await developerPlatformClient.appDeepLink(result.remoteApp), "versions"].join("/"));
  outputInfo(outputContent`\nView all ${String(totalResults)} app versions in the ${link2}`);
}

// ../app/dist/cli/commands/app/versions/list.js
var import_core45 = __toESM(require_lib(), 1), _a33, VersionsList = class extends AppCommand {
  async run() {
    let { flags } = await this.parse(_a33);
    flags["api-key"] && await showApiKeyDeprecationWarning();
    let apiKey = flags["client-id"] || flags["api-key"], specifications = await loadLocalExtensionsSpecifications(), app = await loadApp({
      specifications,
      directory: flags.path,
      userProvidedConfigName: flags.config
    });
    await versionList({
      app,
      apiKey,
      reset: !1,
      json: flags.json
    });
  }
};
_a33 = VersionsList;
VersionsList.summary = "List deployed versions of your app.";
VersionsList.descriptionWithMarkdown = "Lists the deployed app versions. An app version is a snapshot of your app extensions.";
VersionsList.description = _a33.descriptionWithoutMarkdown();
VersionsList.examples = ["<%= config.bin %> <%= command.id %>"];
VersionsList.flags = {
  ...globalFlags,
  ...appFlags,
  "api-key": import_core45.Flags.string({
    hidden: !0,
    description: "Application's API key to fetch versions for.",
    env: "SHOPIFY_FLAG_API_KEY",
    exclusive: ["config"]
  }),
  "client-id": import_core45.Flags.string({
    hidden: !1,
    description: "The Client ID to fetch versions for.",
    env: "SHOPIFY_FLAG_CLIENT_ID",
    exclusive: ["config"]
  }),
  json: import_core45.Flags.boolean({
    description: "Output the versions list as JSON.",
    default: !1,
    env: "SHOPIFY_FLAG_JSON"
  })
};
VersionsList.args = {
  file: import_core45.Args.string()
};
var list_default2 = VersionsList;

// ../app/dist/cli/commands/app/webhook/trigger.js
init_cjs_shims();

// ../app/dist/cli/services/webhook/trigger.js
init_cjs_shims();

// ../app/dist/cli/services/webhook/trigger-options.js
init_cjs_shims();

// ../app/dist/cli/prompts/webhook/trigger.js
init_cjs_shims();
async function topicPrompt(availableTopics) {
  let choicesList = availableTopics.map((topic) => ({ label: topic, value: topic }));
  return await renderAutocompletePrompt({
    message: "Webhook Topic",
    choices: choicesList
  });
}
async function apiVersionPrompt(availableVersions) {
  return renderSelectPrompt({
    message: "Webhook ApiVersion",
    choices: availableVersions.map((version2) => ({ label: version2, value: version2 }))
  });
}
async function deliveryMethodPrompt() {
  return renderSelectPrompt({
    message: "Delivery method",
    choices: [
      { label: "HTTP", value: DELIVERY_METHOD.HTTP },
      { label: "Google Pub/Sub", value: DELIVERY_METHOD.PUBSUB },
      { label: "Amazon EventBridge", value: DELIVERY_METHOD.EVENTBRIDGE }
    ]
  });
}
async function addressPrompt(deliveryMethod) {
  return (await renderTextPrompt({
    message: "Address for delivery",
    validate: (value) => {
      let trimmed = value.trim();
      if (trimmed.length === 0)
        return "Address can't be empty";
      if (!isAddressAllowedForDeliveryMethod(trimmed, deliveryMethod))
        return `Invalid address.
${deliveryMethodInstructionsAsString(deliveryMethod)}`;
    }
  })).trim();
}
function deliveryMethodInstructions2(method) {
  return method === DELIVERY_METHOD.HTTP ? [
    "For remote HTTP testing, use a URL that starts with https://",
    "For local HTTP testing, use http://localhost:{port}/{url-path}"
  ] : method === DELIVERY_METHOD.PUBSUB ? ["For Google Pub/Sub, use pubsub://{project-id}:{topic-id}"] : method === DELIVERY_METHOD.EVENTBRIDGE ? ["For Amazon EventBridge, use an Amazon Resource Name (ARN) starting with arn:aws:events:"] : [];
}
function deliveryMethodInstructionsAsString(method) {
  return deliveryMethodInstructions2(method).map((hint) => `      \xB7 ${stringifyMessage(hint)}`).join(`
`);
}

// ../app/dist/cli/services/webhook/trigger-options.js
async function collectCredentials(clientId, secret, app, deliveryMethod) {
  if (secret && (clientId || deliveryMethod !== DELIVERY_METHOD.EVENTBRIDGE))
    return { clientSecret: secret, apiKey: clientId };
  let orgApp = await fetchAppFromConfigOrSelect(app);
  return isCurrentAppSchema(app.configuration) && renderCurrentlyUsedConfigInfo({
    appName: orgApp.title,
    configFile: basename(app.configuration.path)
  }), {
    clientSecret: orgApp.apiSecretKeys.find((elm) => elm.secret).secret,
    apiKey: orgApp.apiKey,
    developerPlatformClient: orgApp.developerPlatformClient
  };
}
async function collectApiVersion(developerPlatformClient, apiVersion) {
  let apiVersions = await requestApiVersions(developerPlatformClient);
  return apiVersion ? parseApiVersionFlag(apiVersion, apiVersions) : apiVersionPrompt(apiVersions);
}
async function collectTopic(developerPlatformClient, apiVersion, topic) {
  if (topic)
    return parseTopicFlag(topic, apiVersion, await requestTopics(developerPlatformClient, apiVersion));
  let topics = await requestTopics(developerPlatformClient, apiVersion);
  return topicPrompt(topics);
}
async function collectAddressAndMethod(deliveryMethod, address) {
  let actualMethod = deliveryMethod || deliveryMethodForAddress(address) || await deliveryMethodPrompt(), actualAddress = address || await addressPrompt(actualMethod);
  return validateAddressMethod(actualAddress, actualMethod);
}

// ../app/dist/cli/services/webhook/trigger.js
async function webhookTriggerService(flags) {
  let app = await loadApp({
    directory: flags.path,
    userProvidedConfigName: flags.config,
    specifications: await loadLocalExtensionsSpecifications()
  }), developerPlatformClient = flags.developerPlatformClient ?? selectDeveloperPlatformClient({ configuration: app.configuration }), options = await validateAndCollectFlags(flags, developerPlatformClient, app);
  await sendSample(options);
}
async function validateAndCollectFlags(flags, developerPlatformClient, app) {
  let apiVersion = await collectApiVersion(developerPlatformClient, flags.apiVersion), topic = await collectTopic(developerPlatformClient, apiVersion, flags.topic), [address, deliveryMethod] = await collectAddressAndMethod(flags.deliveryMethod, flags.address), clientCredentials = await collectCredentials(flags.clientId, flags.clientSecret, app, deliveryMethod);
  return {
    topic,
    apiVersion,
    deliveryMethod,
    address,
    apiKey: clientCredentials.apiKey,
    clientSecret: clientCredentials.clientSecret,
    developerPlatformClient: clientCredentials.developerPlatformClient ?? developerPlatformClient
  };
}
async function sendSample(options) {
  let variables = {
    topic: options.topic,
    api_version: options.apiVersion,
    address: options.address,
    delivery_method: options.deliveryMethod,
    shared_secret: options.clientSecret,
    api_key: options.apiKey
  }, sample = await getWebhookSample(options.developerPlatformClient, variables);
  if (!sample.success) {
    consoleError(`Request errors:
${formatErrors(sample.userErrors)}`);
    return;
  }
  if (options.deliveryMethod === DELIVERY_METHOD.LOCALHOST) {
    if (await triggerLocalWebhook(options.address, sample.samplePayload, sample.headers)) {
      outputSuccess("Localhost delivery sucessful");
      return;
    }
    consoleError("Localhost delivery failed");
    return;
  }
  sample.samplePayload === JSON.stringify({}) && outputSuccess("Webhook has been enqueued for delivery");
}
function formatErrors(errors2) {
  try {
    return errors2.map((element) => JSON.parse(element.message).map((msg) => `  \xB7 ${msg}`).join(`
`)).join(`
`);
  } catch {
    return JSON.stringify(errors2);
  }
}

// ../app/dist/cli/commands/app/webhook/trigger.js
var import_core46 = __toESM(require_lib(), 1);
var _a34, WebhookTrigger = class extends base_command_default {
  async run() {
    let { flags } = await this.parse(_a34), usedFlags = {
      topic: flags.topic,
      apiVersion: flags["api-version"],
      deliveryMethod: flags["delivery-method"],
      address: flags.address,
      clientId: flags["client-id"],
      clientSecret: flags["client-secret"] || flags["shared-secret"],
      path: flags.path,
      config: flags.config
    };
    flags["shared-secret"] && renderWarning({
      headline: [
        "The flag shared-secret has been deprecated in favor of client-secret and will eventually be deleted."
      ],
      body: ["Please use --client-secret instead."]
    }), await webhookTriggerService(usedFlags);
  }
};
_a34 = WebhookTrigger;
WebhookTrigger.summary = "Trigger delivery of a sample webhook topic payload to a designated address.";
WebhookTrigger.descriptionWithMarkdown = `
  Triggers the delivery of a sample Admin API event topic payload to a designated address.

  You should use this command to experiment with webhooks, to initially test your webhook configuration, or for unit testing. However, to test your webhook configuration from end to end, you should always trigger webhooks by performing the related action in Shopify.

  Because most webhook deliveries use remote endpoints, you can trigger the command from any directory where you can use Shopify CLI, and send the webhook to any of the supported endpoint types. For example, you can run the command from your app's local directory, but send the webhook to a staging environment endpoint.

  To learn more about using webhooks in a Shopify app, refer to [Webhooks overview](https://shopify.dev/docs/apps/webhooks).

  ### Limitations

  - Webhooks triggered using this method always have the same payload, so they can't be used to test scenarios that differ based on the payload contents.
  - Webhooks triggered using this method aren't retried when they fail.
  - Trigger requests are rate-limited using the [Partner API rate limit](https://shopify.dev/docs/api/partner#rate_limits).
  - You can't use this method to validate your API webhook subscriptions.
  `;
WebhookTrigger.description = _a34.descriptionWithoutMarkdown();
WebhookTrigger.flags = {
  ...appFlags,
  help: import_core46.Flags.help({
    required: !1,
    hidden: !1,
    env: "SHOPIFY_FLAG_HELP",
    description: "This help. When you run the trigger command the CLI will prompt you for any information that isn't passed using flags."
  }),
  topic: import_core46.Flags.string({
    required: !1,
    hidden: !1,
    env: "SHOPIFY_FLAG_TOPIC",
    description: "The requested webhook topic."
  }),
  "api-version": import_core46.Flags.string({
    required: !1,
    hidden: !1,
    env: "SHOPIFY_FLAG_API_VERSION",
    description: "The API Version of the webhook topic."
  }),
  "delivery-method": import_core46.Flags.string({
    required: !1,
    hidden: !1,
    options: [DELIVERY_METHOD.HTTP, DELIVERY_METHOD.PUBSUB, DELIVERY_METHOD.EVENTBRIDGE],
    env: "SHOPIFY_FLAG_DELIVERY_METHOD",
    description: "Method chosen to deliver the topic payload. If not passed, it's inferred from the address."
  }),
  "client-id": import_core46.Flags.string({
    hidden: !1,
    description: "The Client ID of your app.",
    env: "SHOPIFY_FLAG_CLIENT_ID",
    exclusive: ["config"]
  }),
  "shared-secret": import_core46.Flags.string({
    required: !1,
    hidden: !1,
    env: "SHOPIFY_FLAG_SHARED_SECRET",
    description: "Deprecated. Please use client-secret."
  }),
  "client-secret": import_core46.Flags.string({
    required: !1,
    hidden: !1,
    env: "SHOPIFY_FLAG_CLIENT_SECRET",
    description: "Your app's client secret. This secret allows us to return the X-Shopify-Hmac-SHA256 header that lets you validate the origin of the response that you receive."
  }),
  address: import_core46.Flags.string({
    required: !1,
    hidden: !1,
    env: "SHOPIFY_FLAG_ADDRESS",
    description: `The URL where the webhook payload should be sent.
                    You will need a different address type for each delivery-method:
                    ${deliveryMethodInstructionsAsString(DELIVERY_METHOD.HTTP)}
                    ${deliveryMethodInstructionsAsString(DELIVERY_METHOD.PUBSUB)}
                    ${deliveryMethodInstructionsAsString(DELIVERY_METHOD.EVENTBRIDGE)}`
  })
};
var trigger_default = WebhookTrigger;

// ../app/dist/cli/commands/webhook/trigger.js
init_cjs_shims();
var WebhookTriggerDeprecated = class extends trigger_default {
  async run() {
    return renderWarning({
      body: [
        { command: "webhook trigger" },
        'is now under the "app" topic. Use',
        { command: "app webhook trigger" },
        "instead.",
        "This alias will be removed in a future release."
      ]
    }), super.run();
  }
};
WebhookTriggerDeprecated.hidden = !0;
var trigger_default2 = WebhookTriggerDeprecated;

// ../app/dist/cli/hooks/clear_command_cache.js
init_cjs_shims();
var init3 = async (_options) => {
  clearCachedCommandInfo(), process.env.COMMAND_RUN_ID = randomUUID();
}, clear_command_cache_default = init3;

// ../app/dist/cli/hooks/public_metadata.js
init_cjs_shims();
var gatherPublicMetadata = async () => metadata_default.getAllPublicMetadata(), public_metadata_default = gatherPublicMetadata;

// ../app/dist/cli/hooks/sensitive_metadata.js
init_cjs_shims();
var gatherSensitiveMetadata = async () => metadata_default.getAllSensitiveMetadata(), sensitive_metadata_default = gatherSensitiveMetadata;

// ../app/dist/cli/index.js
var commands = {
  "app:build": build_default2,
  "app:deploy": deploy_default,
  "app:dev": dev_default2,
  "app:logs": logs_default,
  "app:logs:sources": sources_default,
  "app:import-extensions": import_extensions_default,
  "app:info": info_default2,
  "app:init": init_default5,
  "app:release": release_default,
  "app:config:link": link_default,
  "app:config:use": use_default,
  "app:env:pull": pull_default2,
  "app:env:show": show_default,
  "app:generate:schema": schema_default2,
  "app:function:build": build_default3,
  "app:function:replay": replay_default,
  "app:function:run": run_default,
  "app:function:schema": schema_default,
  "app:function:typegen": typegen_default,
  "app:generate:extension": extension_default2,
  "app:versions:list": list_default2,
  "app:webhook:trigger": trigger_default,
  "webhook:trigger": trigger_default2,
  "demo:watcher": watcher_default
}, AppSensitiveMetadataHook = sensitive_metadata_default, AppInitHook = clear_command_cache_default, AppPublicMetadataHook = public_metadata_default;

// ../../node_modules/.pnpm/@oclif+plugin-commands@3.3.2/node_modules/@oclif/plugin-commands/lib/index.js
init_cjs_shims();

// ../../node_modules/.pnpm/@oclif+plugin-commands@3.3.2/node_modules/@oclif/plugin-commands/lib/commands/commands.js
init_cjs_shims();
var import_core48 = __toESM(require_lib(), 1), import_lodash = __toESM(require_lodash6(), 1), import_lodash2 = __toESM(require_lodash7(), 1), import_lodash3 = __toESM(require_lodash10(), 1), import_lodash4 = __toESM(require_lodash11(), 1);
import { EOL as EOL2 } from "node:os";

// ../../node_modules/.pnpm/@oclif+plugin-commands@3.3.2/node_modules/@oclif/plugin-commands/lib/utils/tree.js
init_cjs_shims();
var import_core47 = __toESM(require_lib(), 1), addNodes = (tree, commandParts) => {
  let existingNode = tree.search(commandParts[0]);
  existingNode && commandParts[1] ? addNodes(existingNode, commandParts.slice(1)) : (tree.insert(commandParts[0]), commandParts.length > 1 && addNodes(tree.search(commandParts[0]), commandParts.slice(1)));
}, createCommandTree = (commands4, topicSeparator = ":") => {
  let tree = import_core47.ux.tree();
  for (let command of commands4) {
    let commandParts = command.id.split(topicSeparator);
    addNodes(tree, commandParts);
  }
  return tree;
}, tree_default = createCommandTree;

// ../../node_modules/.pnpm/@oclif+plugin-commands@3.3.2/node_modules/@oclif/plugin-commands/lib/commands/commands.js
var Commands = class _Commands extends import_core48.Command {
  static description = "list all the commands";
  static enableJsonFlag = !0;
  static flags = {
    deprecated: import_core48.Flags.boolean({ description: "show deprecated commands" }),
    help: import_core48.Flags.help({ char: "h" }),
    hidden: import_core48.Flags.boolean({ description: "show hidden commands" }),
    tree: import_core48.Flags.boolean({ description: "show tree of commands" }),
    ...import_core48.ux.table.flags()
  };
  async run() {
    let { flags } = await this.parse(_Commands), commands4 = this.getCommands();
    if (flags.hidden || (commands4 = commands4.filter((c) => !c.hidden)), !flags.deprecated) {
      let deprecatedAliases = new Set(commands4.filter((c) => c.deprecateAliases).flatMap((c) => c.aliases));
      commands4 = commands4.filter((c) => c.state !== "deprecated" && !deprecatedAliases.has(c.id));
    }
    let { config: config2 } = this;
    if (commands4 = (0, import_lodash2.default)(commands4, "id").map((command) => (command.description = typeof command.description == "string" && (0, import_lodash3.default)(command.description)({ command, config: config2 }) || void 0, command.summary = typeof command.summary == "string" && (0, import_lodash3.default)(command.summary)({ command, config: config2 }) || void 0, command.usage = typeof command.usage == "string" && (0, import_lodash3.default)(command.usage)({ command, config: config2 }) || void 0, command.id = (0, import_core48.toConfiguredId)(command.id, config2), command)), this.jsonEnabled() && !flags.tree) {
      let formatted = await Promise.all(commands4.map(async (cmd) => {
        let commandClass;
        try {
          commandClass = await cmd.load();
        } catch (error) {
          this.debug(error);
        }
        let obj = { ...cmd, ...commandClass };
        for (; commandClass !== void 0; )
          commandClass = Object.getPrototypeOf(commandClass) ?? void 0, Object.assign(obj, (0, import_lodash.default)(commandClass, (v) => v !== void 0));
        return delete obj.plugin, this.removeCycles(obj);
      }));
      return (0, import_lodash4.default)(formatted, "id");
    }
    if (flags.tree) {
      let tree = tree_default(commands4, config2.topicSeparator);
      return this.jsonEnabled() || tree.display(), tree;
    }
    import_core48.ux.table(commands4.map((command) => (command.description = (command.description ?? "").split(EOL2)[0], command.summary = command.summary ?? (command.description ?? "").split(EOL2)[0], command.hidden = !!command.hidden, command.usage ??= "", command)), {
      description: {
        extended: !0
      },
      hidden: {
        extended: !0
      },
      id: {
        header: "Command"
      },
      pluginName: {
        extended: !0,
        header: "Plugin"
      },
      pluginType: {
        extended: !0,
        header: "Type"
      },
      summary: {},
      usage: {
        extended: !0
      }
    }, {
      // to-do: investigate this oclif/core error when printLine is enabled
      // printLine: this.log,
      ...flags
      // parsed flags
    });
  }
  getCommands() {
    return this.config.commands;
  }
  removeCycles(object) {
    let seenObjects = /* @__PURE__ */ new WeakMap(), _removeCycles = (obj) => {
      if (Object.prototype.toString.call(obj) === "[object Object]") {
        let dictionary = obj;
        if (seenObjects.has(dictionary))
          return;
        seenObjects.set(dictionary, void 0);
        for (let key in dictionary)
          _removeCycles(dictionary[key]) === void 0 && delete dictionary[key];
      } else if (Array.isArray(obj))
        for (let i in obj)
          _removeCycles(obj[i]) === void 0 && (obj[i] = null);
      return obj;
    };
    return _removeCycles(object);
  }
};

// ../../node_modules/.pnpm/@oclif+plugin-commands@3.3.2/node_modules/@oclif/plugin-commands/lib/index.js
var commands2 = {
  commands: Commands
};

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/index.js
init_cjs_shims();

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/commands/plugins/index.js
init_cjs_shims();
var import_core53 = __toESM(require_lib(), 1);

// ../../node_modules/.pnpm/object-treeify@4.0.1/node_modules/object-treeify/lib/index.js
init_cjs_shims();

// ../../node_modules/.pnpm/object-treeify@4.0.1/node_modules/object-treeify/lib/assert.js
init_cjs_shims();
var assert_default = (condition, message) => {
  if (!condition)
    throw new Error(message);
};

// ../../node_modules/.pnpm/object-treeify@4.0.1/node_modules/object-treeify/lib/index.js
var buildCtx = (opts) => {
  let ctx = {
    joined: !0,
    spacerNoNeighbour: "   ",
    spacerNeighbour: "\u2502  ",
    keyNoNeighbour: "\u2514\u2500 ",
    keyNeighbour: "\u251C\u2500 ",
    separator: ": ",
    renderFn: (node) => ["boolean", "string", "number"].includes(typeof node) ? node : void 0,
    sortFn: null,
    breakCircularWith: " (circular ref.)",
    ...opts
  };
  return assert_default(Object.keys(ctx).length === 9, "Unexpected Option(s) provided"), assert_default(typeof ctx.joined == "boolean", 'Option "joined" has invalid format'), assert_default(typeof ctx.spacerNoNeighbour == "string", 'Option "spacerNoNeighbour" has invalid format'), assert_default(typeof ctx.spacerNeighbour == "string", 'Option "spacerNeighbour" has invalid format'), assert_default(typeof ctx.keyNoNeighbour == "string", 'Option "keyNoNeighbour" has invalid format'), assert_default(typeof ctx.keyNeighbour == "string", 'Option "keyNeighbour" has invalid format'), assert_default(typeof ctx.separator == "string", 'Option "separator" has invalid format'), assert_default(typeof ctx.renderFn == "function", 'Option "renderFn" has invalid format'), assert_default(typeof ctx.sortFn == "function" || ctx.sortFn === null, 'Option "sortFn" has invalid format'), assert_default(
    typeof ctx.breakCircularWith == "string" || ctx.breakCircularWith === null,
    'Option "breakCircularWith" has invalid format'
  ), ctx;
}, lib_default = (tree, opts = {}) => {
  let ctx = buildCtx(opts), result = [], rootRendered = ctx.renderFn(tree);
  rootRendered !== void 0 && result.push(String(rootRendered));
  let sort2 = (input) => ctx.sortFn === null ? input.reverse() : input.sort((a, b) => ctx.sortFn(b, a)), neighbours = [], keys = sort2(Object.keys(tree)).map((k) => [k]), lookup3 = [tree];
  for (; keys.length !== 0; ) {
    let key = keys.pop(), node = lookup3[key.length - 1][key[key.length - 1]], isCircular = ctx.breakCircularWith !== null && lookup3.includes(node);
    neighbours[key.length - 1] = keys.length !== 0 && keys[keys.length - 1].length === key.length;
    let nodeRendered = ctx.renderFn(node);
    result.push([
      neighbours.slice(0, key.length - 1).map((n) => n ? ctx.spacerNeighbour : ctx.spacerNoNeighbour).join(""),
      neighbours[key.length - 1] ? ctx.keyNeighbour : ctx.keyNoNeighbour,
      key[key.length - 1],
      nodeRendered === void 0 ? "" : `${ctx.separator}${node}`,
      isCircular ? ctx.breakCircularWith : ""
    ].join("")), node instanceof Object && !Array.isArray(node) && !isCircular && (keys.push(...sort2(Object.keys(node)).map((k) => key.concat(k))), lookup3[key.length] = node);
  }
  return ctx.joined === !0 ? result.join(`
`) : result;
};

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/plugins.js
init_cjs_shims();
var import_core52 = __toESM(require_lib(), 1);
var import_debug4 = __toESM(require_src(), 1), import_semver2 = __toESM(require_semver3(), 1);
import { spawn as spawn4 } from "node:child_process";
import { access, mkdir as mkdir2, readFile as readFile3, rename, rm, writeFile as writeFile2 } from "node:fs/promises";
import { basename as basename2, dirname as dirname3, join as join3, resolve } from "node:path";
import { fileURLToPath as fileURLToPath8 } from "node:url";

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/npm.js
init_cjs_shims();
var import_core50 = __toESM(require_lib(), 1), import_debug2 = __toESM(require_src(), 1);
import { readFile as readFile2 } from "node:fs/promises";
import { createRequire as createRequire4 } from "node:module";
import { join as join2, sep } from "node:path";

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/spawn.js
init_cjs_shims();
var import_core49 = __toESM(require_lib(), 1), import_debug = __toESM(require_src(), 1);
import { spawn as cpSpawn } from "node:child_process";
var debug = (0, import_debug.default)("@oclif/plugin-plugins:spawn");
async function spawn3(modulePath2, args = [], { cwd: cwd2, logLevel }) {
  return new Promise((resolve2, reject) => {
    process.platform === "win32" && modulePath2.endsWith(".js") && (args.unshift(`"${modulePath2}"`), modulePath2 = "node"), debug("modulePath", modulePath2), debug("args", args);
    let spawned = cpSpawn(modulePath2, args, {
      cwd: cwd2,
      env: {
        ...npmRunPathEnv(),
        // Disable husky hooks because a plugin might be trying to install them, which will
        // break the install since the install location isn't a .git directory.
        HUSKY: "0"
      },
      stdio: "pipe",
      windowsVerbatimArguments: !0,
      ...process.platform === "win32" && modulePath2.toLowerCase().endsWith(".cmd") && { shell: !0 }
    }), possibleLastLinesOfNpmInstall = ["up to date", "added"], stderr = [], stdout = [], loggedStderr = [], loggedStdout = [], shouldPrint = (str) => {
      let noOtherOutput = loggedStderr.length === 0 && loggedStdout.length === 0, isLastLine = possibleLastLinesOfNpmInstall.some((line) => str.startsWith(line));
      return noOtherOutput && isLastLine && logLevel === "notice" ? !1 : logLevel !== "silent";
    };
    spawned.stderr?.setEncoding("utf8"), spawned.stderr?.on("data", (d) => {
      let output = d.toString().trim();
      stderr.push(output), shouldPrint(output) ? (loggedStderr.push(output), import_core49.ux.log(output)) : debug(output);
    }), spawned.stdout?.setEncoding("utf8"), spawned.stdout?.on("data", (d) => {
      let output = d.toString().trim();
      stdout.push(output), shouldPrint(output) ? (loggedStdout.push(output), import_core49.ux.log(output)) : debug(output);
    }), spawned.on("error", reject), spawned.on("exit", (code) => {
      code === 0 ? resolve2({ stderr, stdout }) : reject(new import_core49.Errors.CLIError(`${modulePath2} ${args.join(" ")} exited with code ${code}`, {
        suggestions: ["Run with DEBUG=@oclif/plugin-plugins* to see debug output."]
      }));
    });
  });
}

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/npm.js
var debug2 = (0, import_debug2.default)("@oclif/plugin-plugins:npm"), NPM = class {
  bin;
  config;
  logLevel;
  constructor({ config: config2, logLevel }) {
    this.config = config2, this.logLevel = logLevel;
  }
  async exec(args = [], options) {
    let bin = await this.findNpm();
    debug2("npm binary path", bin), args.push(`--loglevel=${this.logLevel}`, "--no-fund"), this.config.npmRegistry && args.push(`--registry=${this.config.npmRegistry}`), options.logLevel !== "notice" && options.logLevel !== "silent" && import_core50.ux.logToStderr(`${options.cwd}: ${bin} ${args.join(" ")}`), debug2(`${options.cwd}: ${bin} ${args.join(" ")}`);
    try {
      let output = await spawn3(bin, args, options);
      return debug2("npm done"), output;
    } catch (error) {
      throw debug2("npm error", error), error;
    }
  }
  async install(args, opts) {
    let prod = opts.prod ? ["--omit", "dev"] : [];
    return this.exec(["install", ...args, ...prod, "--no-audit"], opts);
  }
  async uninstall(args, opts) {
    return this.exec(["uninstall", ...args], opts);
  }
  async update(args, opts) {
    return this.exec(["update", ...args], opts);
  }
  async view(args, opts) {
    return this.exec(["view", ...args], { ...opts, logLevel: "silent" });
  }
  /**
   * Get the path to the npm CLI file.
   * This will resolve npm to the pinned version in `@oclif/plugin-plugins/package.json` if it exists.
   * Otherwise, it will use the globally installed npm.
   *
   * @returns The path to the `npm/bin/npm-cli.js` file.
   */
  async findNpm() {
    if (this.bin)
      return this.bin;
    try {
      let npmPjsonPath = createRequire4(import.meta.url).resolve("npm/package.json"), npmPjson = JSON.parse(await readFile2(npmPjsonPath, { encoding: "utf8" })), npmPath = npmPjsonPath.slice(0, Math.max(0, npmPjsonPath.lastIndexOf(sep)));
      this.bin = join2(npmPath, npmPjson.bin.npm);
    } catch {
      let { default: which } = await import("./lib-CPSRXLFM.js");
      this.bin = await which("npm");
    }
    if (!this.bin)
      throw new import_core50.Errors.CLIError("npm not found");
    return this.bin;
  }
};

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/util.js
init_cjs_shims();
function compare(a, b) {
  let itemA = a === void 0 ? 0 : a, itemB = b === void 0 ? 0 : b;
  if (Array.isArray(itemA) && Array.isArray(itemB)) {
    if (itemA.length === 0 && itemB.length === 0)
      return 0;
    let diff2 = compare(itemA[0], itemB[0]);
    return diff2 !== 0 ? diff2 : compare(itemA.slice(1), itemB.slice(1));
  }
  return itemA < itemB ? -1 : itemA > itemB ? 1 : 0;
}
function sortBy2(arr, fn) {
  return arr.sort((a, b) => compare(fn(a), fn(b)));
}
function uniqWith(arr, fn) {
  return arr.filter((a, i) => !arr.some((b, j) => j > i && fn(a, b)));
}

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/yarn.js
init_cjs_shims();
var import_core51 = __toESM(require_lib(), 1), import_debug3 = __toESM(require_src(), 1);
import { createRequire as createRequire5 } from "node:module";
import { fileURLToPath as fileURLToPath7 } from "node:url";
var require3 = createRequire5(import.meta.url), debug3 = (0, import_debug3.default)("@oclif/plugin-plugins:yarn"), Yarn = class {
  bin;
  config;
  logLevel;
  constructor({ config: config2, logLevel }) {
    this.config = config2, this.logLevel = logLevel;
  }
  async exec(args = [], options) {
    let bin = await this.findYarn();
    debug3("yarn binary path", bin), options.logLevel === "verbose" && args.push("--verbose"), this.config.npmRegistry && args.push(`--registry=${this.config.npmRegistry}`), options.logLevel !== "notice" && options.logLevel !== "silent" && import_core51.ux.logToStderr(`${options.cwd}: ${bin} ${args.join(" ")}`), debug3(`${options.cwd}: ${bin} ${args.join(" ")}`);
    try {
      let output = await spawn3(bin, args, options);
      return debug3("yarn done"), output;
    } catch (error) {
      throw debug3("yarn error", error), error;
    }
  }
  async install(args, opts) {
    return this.exec(["install", ...args], opts);
  }
  async findYarn() {
    if (this.bin)
      return this.bin;
    try {
      this.bin = require3.resolve("yarn/bin/yarn.js", { paths: [this.config.root, fileURLToPath7(import.meta.url)] });
    } catch {
      let { default: which } = await import("./lib-CPSRXLFM.js");
      this.bin = await which("yarn");
    }
    if (!this.bin)
      throw new import_core51.Errors.CLIError("yarn not found");
    return this.bin;
  }
};

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/plugins.js
var initPJSON = {
  dependencies: {},
  oclif: { plugins: [], schema: 1 },
  private: !0
};
async function fileExists2(filePath) {
  try {
    return await access(filePath), !0;
  } catch {
    return !1;
  }
}
function dedupePlugins(plugins) {
  return uniqWith(
    plugins,
    // @ts-expect-error because typescript doesn't think it's possible for a plugin to have the `link` type here
    (a, b) => a.name === b.name || a.type === "link" && b.type === "link" && a.root === b.root
  );
}
function extractIssuesLocation(bugs, repository) {
  if (bugs)
    return typeof bugs == "string" ? bugs : bugs.url;
  if (repository)
    return typeof repository == "string" ? repository : repository.url.replace("git+", "").replace(".git", "");
}
function notifyUser(plugin, output) {
  [...output.stdout, ...output.stderr].some((l) => l.includes("npm WARN")) && (import_core52.ux.logToStderr(source_default.bold.yellow(`
These warnings can only be addressed by the owner(s) of ${plugin.name}.`)), (plugin.pjson.bugs || plugin.pjson.repository) && import_core52.ux.logToStderr(`We suggest that you create an issue at ${extractIssuesLocation(plugin.pjson.bugs, plugin.pjson.repository)} and ask the plugin owners to address them.
`));
}
var Plugins = class {
  config;
  npm;
  debug;
  logLevel;
  constructor(options) {
    this.config = options.config, this.debug = (0, import_debug4.default)("@oclif/plugin-plugins"), this.logLevel = options.logLevel ?? "notice", this.npm = new NPM({
      config: this.config,
      logLevel: this.logLevel
    });
  }
  async add(...plugins) {
    let pjson = await this.pjson(), mergedPlugins = [...pjson.oclif.plugins || [], ...plugins];
    await this.savePJSON({
      ...pjson,
      oclif: {
        ...pjson.oclif,
        plugins: dedupePlugins(mergedPlugins)
      }
    });
  }
  friendlyName(name) {
    let { pluginPrefix, scope } = this.config.pjson.oclif;
    return scope ? name.match(`@${scope}/${pluginPrefix ?? "plugin"}-(.+)`)?.[1] ?? name : name;
  }
  async hasPlugin(name) {
    let list2 = await this.list(), friendlyName = this.friendlyName(name), unfriendlyName = this.unfriendlyName(name) ?? name;
    return list2.find((p) => this.friendlyName(p.name) === friendlyName) ?? // friendly
    list2.find((p) => this.unfriendlyName(p.name) === unfriendlyName) ?? // unfriendly
    list2.find((p) => p.type === "link" && resolve(p.root) === resolve(name)) ?? // link
    !1;
  }
  async install(name, { force = !1, tag = "latest" } = {}) {
    await this.maybeCleanUp();
    try {
      this.debug(`installing plugin ${name}`);
      let options = { cwd: this.config.dataDir, logLevel: this.logLevel, prod: !0 };
      await this.ensurePJSON();
      let plugin, args = force ? ["--force"] : [];
      if (name.includes(":")) {
        let url = name, output = await this.npm.install([...args, url], options), { dependencies } = await this.pjson(), { default: npa } = await import("./npa-RLWNZ3BM.js"), normalizedUrl = npa(url), installedPluginName = Object.entries(dependencies ?? {}).find(([, u]) => {
          let normalized = npa(u);
          return normalized.hosted?.type === normalizedUrl.hosted?.type && normalized.hosted?.user === normalizedUrl.hosted?.user && normalized.hosted?.project === normalizedUrl.hosted?.project;
        })?.[0];
        if (!installedPluginName)
          throw new import_core52.Errors.CLIError(`Could not find plugin name for ${url}`);
        let root = join3(this.config.dataDir, "node_modules", installedPluginName);
        plugin = await import_core52.Config.load({
          devPlugins: !1,
          name: installedPluginName,
          root,
          userPlugins: !1
        }), notifyUser(plugin, output), this.isValidPlugin(plugin), await this.add({ name: installedPluginName, type: "user", url });
        let safeToNotExist = /* @__PURE__ */ new Set(["oclif.manifest.json", "oclif.lock", "npm-shrinkwrap.json"]), files = (plugin.pjson.files ?? []).map((f) => join3(root, f)).filter((f) => !safeToNotExist.has(basename2(f)));
        this.debug(`checking for existence of files: ${files.join(", ")}`);
        let results = Object.fromEntries(await Promise.all(files?.map(async (f) => [f, await fileExists2(f)]) ?? []));
        this.debug(results), Object.values(results).every(Boolean) || import_core52.ux.warn("This plugin from github may not work as expected because the prepare script did not produce all the expected files.");
      } else {
        let range = (0, import_semver2.validRange)(tag), unfriendly = this.unfriendlyName(name);
        unfriendly && await this.npmHasPackage(unfriendly) && (name = unfriendly), await this.npmHasPackage(name, !0);
        let output = await this.npm.install([...args, `${name}@${tag}`], options);
        this.debug(`loading plugin ${name}...`), plugin = await import_core52.Config.load({
          devPlugins: !1,
          name,
          root: join3(this.config.dataDir, "node_modules", name),
          userPlugins: !1
        }), this.debug(`finished loading plugin ${name} at root ${plugin.root}`), notifyUser(plugin, output), this.isValidPlugin(plugin), await this.add({ name, tag: range ?? tag, type: "user" });
      }
      return await rm(join3(this.config.dataDir, "yarn.lock"), { force: !0 }), plugin;
    } catch (error) {
      throw this.debug("error installing plugin:", error), await this.uninstall(name).catch((error2) => this.debug(error2)), String(error).includes("EACCES") ? new import_core52.Errors.CLIError(error, {
        suggestions: [
          `Plugin failed to install because of a permissions error.
Does your current user own the directory ${this.config.dataDir}?`
        ]
      }) : error;
    }
  }
  async link(p, { install: install2 }) {
    let c = await import_core52.Config.load(resolve(p));
    return this.isValidPlugin(c), install2 && (await fileExists2(join3(c.root, "yarn.lock")) ? (this.debug("installing dependencies with yarn"), await new Yarn({ config: this.config, logLevel: this.logLevel }).install([], {
      cwd: c.root,
      logLevel: this.logLevel
    })) : await fileExists2(join3(c.root, "package-lock.json")) ? (this.debug("installing dependencies with npm"), await this.npm.install([], {
      cwd: c.root,
      logLevel: this.logLevel,
      prod: !1
    })) : await fileExists2(join3(c.root, "pnpm-lock.yaml")) ? import_core52.ux.warn(`pnpm is not supported for installing after a link. The link succeeded, but you may need to run 'pnpm install' in ${c.root}.`) : import_core52.ux.warn(`No lockfile found in ${c.root}. The link succeeded, but you may need to install the dependencies in your project.`)), await this.add({ name: c.name, root: c.root, type: "link" }), c;
  }
  async list() {
    return (await this.pjson()).oclif.plugins;
  }
  async maybeUnfriendlyName(name) {
    await this.ensurePJSON();
    let unfriendly = this.unfriendlyName(name);
    return this.debug(`checking registry for expanded package name ${unfriendly}`), unfriendly && await this.npmHasPackage(unfriendly) ? unfriendly : (this.debug(`expanded package name ${unfriendly} not found, using given package name ${name}`), name);
  }
  async pjson() {
    let pjson = await this.readPJSON(), plugins = pjson ? normalizePlugins(pjson.oclif.plugins) : [];
    return {
      ...initPJSON,
      ...pjson,
      oclif: {
        ...initPJSON.oclif,
        ...pjson?.oclif,
        plugins
      }
    };
  }
  async remove(name) {
    let pjson = await this.pjson();
    pjson.dependencies && delete pjson.dependencies[name], await this.savePJSON({
      ...pjson,
      oclif: {
        ...pjson.oclif,
        plugins: pjson.oclif.plugins.filter((p) => p.name !== name)
      }
    });
  }
  unfriendlyName(name) {
    if (name.includes("@"))
      return;
    let { pluginPrefix, scope } = this.config.pjson.oclif;
    if (scope)
      return `@${scope}/${pluginPrefix ?? "plugin"}-${name}`;
  }
  async uninstall(name) {
    try {
      ((await this.pjson()).oclif.plugins ?? []).some((p) => typeof p == "object" && p.type === "user" && p.name === name) && await this.npm.uninstall([name], {
        cwd: this.config.dataDir,
        logLevel: this.logLevel
      });
    } catch (error) {
      import_core52.ux.warn(error);
    } finally {
      await this.remove(name);
    }
  }
  async update() {
    let plugins = (await this.list()).filter((p) => p.type === "user");
    if (plugins.length === 0)
      return;
    await this.maybeCleanUp();
    let aliases = this.config.pjson.oclif.aliases || {};
    for (let [name, to] of Object.entries(aliases))
      plugins.find((p) => p.name === name) && (to && await this.install(to), await this.uninstall(name), plugins = plugins.filter((p) => p.name !== name));
    let urlPlugins = plugins.filter((p) => !!p.url);
    urlPlugins.length > 0 && await this.npm.update(urlPlugins.map((p) => p.name), {
      cwd: this.config.dataDir,
      logLevel: this.logLevel
    });
    let npmPlugins = plugins.filter((p) => !p.url), jitPlugins = this.config.pjson.oclif.jitPlugins ?? {}, modifiedPlugins = [];
    npmPlugins.length > 0 && await this.npm.install(npmPlugins.map((p) => {
      if (!(0, import_semver2.valid)(p.tag))
        return `${p.name}@${p.tag}`;
      if (p.tag && (0, import_semver2.valid)(p.tag) && jitPlugins[p.name] && (0, import_semver2.gt)(p.tag, jitPlugins[p.name]))
        return `${p.name}@${p.tag}`;
      let tag = jitPlugins[p.name] ?? p.tag;
      return modifiedPlugins.push({ ...p, tag }), `${p.name}@${tag}`;
    }), { cwd: this.config.dataDir, logLevel: this.logLevel, prod: !0 }), await this.add(...modifiedPlugins);
  }
  async ensurePJSON() {
    await fileExists2(this.pjsonPath) || (this.debug(`creating ${this.pjsonPath} with pjson: ${JSON.stringify(initPJSON, null, 2)}`), await this.savePJSON(initPJSON));
  }
  isValidPlugin(p) {
    if (p.valid || this.config.plugins.get("@oclif/plugin-legacy") || // @ts-expect-error because _base is private
    p._base.includes("@oclif/plugin-legacy"))
      return !0;
    throw new import_core52.Errors.CLIError("plugin is invalid", {
      suggestions: [
        `Plugin failed to install because it does not appear to be a valid CLI plugin.
If you are sure it is, contact the CLI developer noting this error.`
      ]
    });
  }
  async maybeCleanUp() {
    if (await fileExists2(join3(this.config.dataDir, "yarn.lock")))
      try {
        this.debug("Found yarn.lock! Removing yarn.lock and node_modules..."), await Promise.all([
          rename(join3(this.config.dataDir, "node_modules"), join3(this.config.dataDir, "node_modules.old")),
          rm(join3(this.config.dataDir, "yarn.lock"), { force: !0 })
        ]);
        let rmScript = join3(dirname3(fileURLToPath8(import.meta.url)), "rm.js");
        this.debug(`spawning ${rmScript} to remove node_modules.old`), spawn4(process.argv[0], [rmScript, join3(this.config.dataDir, "node_modules.old")], {
          detached: !0,
          stdio: "ignore",
          ...this.config.windows ? { shell: !0 } : {}
        }).unref();
      } catch (error) {
        this.debug("Error cleaning up yarn.lock and node_modules:", error);
      }
  }
  async npmHasPackage(name, throwOnNotFound = !1) {
    try {
      return await this.npm.view([name], {
        cwd: this.config.dataDir,
        logLevel: this.logLevel
      }), this.debug(`Found ${name} in the registry.`), !0;
    } catch (error) {
      if (this.debug(error), throwOnNotFound)
        throw new import_core52.Errors.CLIError(`${name} does not exist in the registry.`);
      return !1;
    }
  }
  get pjsonPath() {
    return join3(this.config.dataDir, "package.json");
  }
  async readPJSON() {
    try {
      return JSON.parse(await readFile3(this.pjsonPath, "utf8"));
    } catch (error) {
      this.debug(error);
      let err2 = error;
      err2.code !== "ENOENT" && process.emitWarning(err2);
    }
  }
  async savePJSON(pjson) {
    this.debug(`saving pjson at ${this.pjsonPath}`, JSON.stringify(pjson, null, 2)), await mkdir2(dirname3(this.pjsonPath), { recursive: !0 }), await writeFile2(this.pjsonPath, JSON.stringify({ name: this.config.name, ...pjson }, null, 2));
  }
}, normalizePlugins = (input) => dedupePlugins((input ?? []).map((p) => typeof p == "string" ? {
  name: p,
  tag: "latest",
  type: "user"
} : p));

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/commands/plugins/index.js
var PluginsIndex = class _PluginsIndex extends import_core53.Command {
  static description = "List installed plugins.";
  static enableJsonFlag = !0;
  static examples = ["<%= config.bin %> <%= command.id %>"];
  static flags = {
    core: import_core53.Flags.boolean({ description: "Show core plugins." })
  };
  plugins;
  async run() {
    let { flags } = await this.parse(_PluginsIndex);
    this.plugins = new Plugins({
      config: this.config
    });
    let plugins = this.config.getPluginsList();
    sortBy2(plugins, (p) => this.plugins.friendlyName(p.name)), flags.core || (plugins = plugins.filter((p) => p.type !== "core" && p.type !== "dev")), plugins.length === 0 && this.log("No plugins installed.");
    let results = this.config.getPluginsList(), userAndLinkedPlugins = new Set(results.filter((p) => p.type === "user" || p.type === "link").map((p) => p.name)), jitPluginsConfig = this.config.pjson.oclif.jitPlugins ?? {}, jitPlugins = Object.entries(jitPluginsConfig).map(([name, version2]) => ({ name, type: "jit", version: version2 })).filter((p) => !userAndLinkedPlugins.has(p.name));
    return sortBy2(jitPlugins, (p) => p.name), this.jsonEnabled() || (this.display(plugins), this.displayJitPlugins(jitPlugins)), [...results.filter((p) => !p.parent), ...jitPlugins];
  }
  createTree(plugin) {
    let tree = {};
    for (let p of plugin.children)
      tree[this.formatPlugin(p)] = this.createTree(p);
    return tree;
  }
  display(plugins) {
    for (let plugin of plugins.filter((p) => !p.parent))
      if (this.log(this.formatPlugin(plugin)), plugin.children && plugin.children.length > 0) {
        let tree = this.createTree(plugin);
        this.log(lib_default(tree));
      }
  }
  displayJitPlugins(jitPlugins) {
    if (jitPlugins.length !== 0) {
      this.log(source_default.dim(`
Uninstalled JIT Plugins:`));
      for (let { name, version: version2 } of jitPlugins)
        this.log(`${this.plugins.friendlyName(name)} ${source_default.dim(version2)}`);
    }
  }
  formatPlugin(plugin) {
    let output = `${this.plugins.friendlyName(plugin.name)} ${source_default.dim(plugin.version)}`;
    return plugin.type !== "user" && (output += source_default.dim(` (${plugin.type})`)), plugin.type === "link" ? output += ` ${plugin.root}` : plugin.tag && plugin.tag !== "latest" && (output += source_default.dim(` (${String(plugin.tag)})`)), output;
  }
};

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/commands/plugins/inspect.js
init_cjs_shims();
var import_core54 = __toESM(require_lib(), 1);
import { readFile as readFile4 } from "node:fs/promises";
import { dirname as dirname4, join as join4, sep as sep2 } from "node:path";

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/log-level.js
init_cjs_shims();
var LOG_LEVELS = ["silent", "error", "warn", "notice", "http", "info", "verbose", "silly"];
function determineLogLevel(config2, flags, defaultLevel) {
  if (flags.verbose)
    return "verbose";
  if (flags.silent)
    return "silent";
  let envVar = config2.scopedEnvVar("NPM_LOG_LEVEL");
  return LOG_LEVELS.includes(envVar) ? envVar : defaultLevel;
}

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/commands/plugins/inspect.js
function trimUntil(fsPath, part) {
  let parts = fsPath.split(sep2), indices = parts.reduce((result, current, index) => current === part ? [...result, index] : result, []), partIndex = Math.max(...indices);
  return partIndex === -1 ? fsPath : parts.slice(0, partIndex + 1).join(sep2);
}
var PluginsInspect = class _PluginsInspect extends import_core54.Command {
  static args = {
    plugin: import_core54.Args.string({
      default: ".",
      description: "Plugin to inspect.",
      required: !0
    })
  };
  static description = "Displays installation properties of a plugin.";
  static enableJsonFlag = !0;
  static examples = ['<%= config.bin %> <%= command.id %> <%- config.pjson.oclif.examplePlugin || "myplugin" %> '];
  static flags = {
    help: import_core54.Flags.help({ char: "h" }),
    verbose: import_core54.Flags.boolean({ char: "v" })
  };
  static strict = !1;
  static usage = "plugins:inspect PLUGIN...";
  plugins;
  async findDep(plugin, dependency7) {
    let dependencyPath = join4(...dependency7.split("/")), start = join4(plugin.root, "node_modules"), paths = [start];
    for (; (start.match(/node_modules/g) ?? []).length > 1; )
      start = trimUntil(dirname4(start), "node_modules"), paths.push(start);
    for (let p of paths)
      try {
        let fullPath = join4(p, dependencyPath), pkgJsonPath = join4(fullPath, "package.json"), pkgJson = JSON.parse(await readFile4(pkgJsonPath, "utf8"));
        return { pkgPath: fullPath, version: pkgJson.version };
      } catch {
      }
    return { pkgPath: null, version: null };
  }
  findPlugin(pluginName) {
    let pluginConfig = this.config.getPluginsList().find((plg) => plg.name === pluginName);
    if (pluginConfig)
      return pluginConfig;
    throw this.config.pjson.oclif.jitPlugins?.[pluginName] && this.warn(`Plugin ${pluginName} is a JIT plugin. It will be installed the first time you run one of it's commands.`), new Error(`${pluginName} not installed`);
  }
  async inspect(pluginName, verbose = !1) {
    let plugin = this.findPlugin(pluginName), dependencies = {}, depsJson = {};
    for (let dep of sortBy2(Object.keys({ ...plugin.pjson.dependencies }), (d) => d)) {
      let { pkgPath, version: version2 } = await this.findDep(plugin, dep);
      if (!version2)
        continue;
      let from = plugin.pjson.dependencies?.[dep], versionMsg = source_default.dim(from ? `${from} => ${version2}` : version2), msg = verbose ? `${dep} ${versionMsg} ${pkgPath}` : `${dep} ${versionMsg}`;
      dependencies[msg] = null, depsJson[dep] = { from, version: version2 };
    }
    let tree = {
      [source_default.bold.cyan(plugin.name)]: {
        [`version ${plugin.version}`]: null,
        ...plugin.tag ? { [`tag ${plugin.tag}`]: null } : {},
        ...plugin.pjson.homepage ? { [`homepage ${plugin.pjson.homepage}`]: null } : {},
        [`location ${plugin.root}`]: null,
        commands: Object.fromEntries(sortBy2(plugin.commandIDs, (c) => c).map((id) => [id, null])),
        dependencies
      }
    };
    return this.log(lib_default(tree)), { ...plugin, deps: depsJson };
  }
  /* eslint-disable no-await-in-loop */
  async run() {
    let { argv, flags } = await this.parse(_PluginsInspect);
    this.plugins = new Plugins({
      config: this.config,
      logLevel: determineLogLevel(this.config, flags, "silent")
    });
    let aliases = this.config.pjson.oclif.aliases ?? {}, plugins = [];
    for (let name of argv) {
      name === "." && (name = JSON.parse(await readFile4("package.json", "utf8")).name), aliases[name] === null && this.error(`${name} is blocked`), name = aliases[name] ?? name;
      let pluginName = await this.plugins.maybeUnfriendlyName(name) ?? name;
      try {
        plugins.push(await this.inspect(pluginName, flags.verbose));
      } catch (error) {
        throw this.log(source_default.bold.red("failed")), error;
      }
    }
    return plugins;
  }
};

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/commands/plugins/install.js
init_cjs_shims();
var import_core55 = __toESM(require_lib(), 1);
var import_validate_npm_package_name = __toESM(require_lib4(), 1);
var PluginsInstall = class _PluginsInstall extends import_core55.Command {
  static aliases = ["plugins:add"];
  static args = {
    plugin: import_core55.Args.string({ description: "Plugin to install.", required: !0 })
  };
  static description = `Uses bundled npm executable to install plugins into <%= config.dataDir %>

Installation of a user-installed plugin will override a core plugin.

Use the <%= config.scopedEnvVarKey('NPM_LOG_LEVEL') %> environment variable to set the npm loglevel.
Use the <%= config.scopedEnvVarKey('NPM_REGISTRY') %> environment variable to set the npm registry.`;
  static enableJsonFlag = !0;
  static examples = [
    {
      command: '<%= config.bin %> <%= command.id %> <%- config.pjson.oclif.examplePlugin || "myplugin" %> ',
      description: "Install a plugin from npm registry."
    },
    {
      command: "<%= config.bin %> <%= command.id %> https://github.com/someuser/someplugin",
      description: "Install a plugin from a github url."
    },
    {
      command: "<%= config.bin %> <%= command.id %> someuser/someplugin",
      description: "Install a plugin from a github slug."
    }
  ];
  static flags = {
    force: import_core55.Flags.boolean({
      char: "f",
      description: "Force npm to fetch remote resources even if a local copy exists on disk."
    }),
    help: import_core55.Flags.help({ char: "h" }),
    jit: import_core55.Flags.boolean({
      hidden: !0,
      async parse(input, ctx) {
        if (input === !1 || input === void 0)
          return input;
        let requestedPlugins = ctx.argv.filter((a) => !a.startsWith("-"));
        if (requestedPlugins.length === 0)
          return input;
        let jitPluginsConfig = ctx.config.pjson.oclif.jitPlugins ?? {};
        if (Object.keys(jitPluginsConfig).length === 0)
          return input;
        let plugins = new Plugins({ config: ctx.config }), nonJitPluginsNames = (await Promise.all(requestedPlugins.map(async (plugin) => {
          let name = await plugins.maybeUnfriendlyName(plugin);
          return { jit: !!jitPluginsConfig[name], name };
        }))).filter((p) => !p.jit).map((p) => p.name);
        if (nonJitPluginsNames.length > 0)
          throw new import_core55.Errors.CLIError(`The following plugins are not JIT plugins: ${nonJitPluginsNames.join(", ")}`);
        return input;
      }
    }),
    silent: import_core55.Flags.boolean({
      char: "s",
      description: "Silences npm output.",
      exclusive: ["verbose"]
    }),
    verbose: import_core55.Flags.boolean({
      char: "v",
      description: "Show verbose npm output.",
      exclusive: ["silent"]
    })
  };
  static strict = !1;
  static summary = "Installs a plugin into <%= config.bin %>.";
  flags;
  // In this case we want these operations to happen
  // sequentially so the `no-await-in-loop` rule is ignored
  async parsePlugin(plugins, input) {
    if (input.startsWith("git+ssh://") || input.endsWith(".git"))
      return { type: "repo", url: input };
    let getNameAndTag = async (input2) => {
      let regexAtSymbolNotAtBeginning = /(?<!^)@/, [splitName, tag2 = "latest"] = input2.split(regexAtSymbolNotAtBeginning), name2 = splitName.startsWith("@") ? splitName : await plugins.maybeUnfriendlyName(splitName);
      if (validateNpmPkgName(name2), this.flags.jit) {
        let jitVersion = this.config.pjson.oclif?.jitPlugins?.[name2];
        return jitVersion ? (regexAtSymbolNotAtBeginning.test(input2) && this.warn(`--jit flag is present along side a tag. Ignoring tag ${tag2} and using the version specified in package.json (${jitVersion}).`), { name: name2, tag: jitVersion }) : (this.warn(`--jit flag is present but ${name2} is not a JIT plugin. Installing ${tag2} instead.`), { name: name2, tag: tag2 });
      }
      return { name: name2, tag: tag2 };
    };
    if (input.startsWith("@") && input.includes("/")) {
      let { name: name2, tag: tag2 } = await getNameAndTag(input);
      return { name: name2, tag: tag2, type: "npm" };
    }
    if (input.includes("/"))
      return input.includes(":") ? { type: "repo", url: input } : { type: "repo", url: `https://github.com/${input}` };
    let { name, tag } = await getNameAndTag(input);
    return { name, tag, type: "npm" };
  }
  async run() {
    let { argv, flags } = await this.parse(_PluginsInstall);
    this.flags = flags;
    let plugins = new Plugins({
      config: this.config,
      logLevel: determineLogLevel(this.config, this.flags, "notice")
    }), aliases = this.config.pjson.oclif.aliases || {};
    for (let name of argv) {
      aliases[name] === null && this.error(`${name} is blocked`), name = aliases[name] || name;
      let p = await this.parsePlugin(plugins, name), plugin;
      await this.config.runHook("plugins:preinstall", {
        plugin: p
      });
      try {
        p.type === "npm" ? (import_core55.ux.action.start(`${this.config.name}: Installing plugin ${source_default.cyan(plugins.friendlyName(p.name) + "@" + p.tag)}`), plugin = await plugins.install(p.name, {
          force: flags.force,
          tag: p.tag
        })) : (import_core55.ux.action.start(`${this.config.name}: Installing plugin ${source_default.cyan(p.url)}`), plugin = await plugins.install(p.url, { force: flags.force }));
      } catch (error) {
        throw import_core55.ux.action.stop(source_default.bold.red("failed")), error;
      }
      import_core55.ux.action.stop(`installed v${plugin.version}`);
    }
  }
};
function validateNpmPkgName(name) {
  if (!(0, import_validate_npm_package_name.default)(name).validForNewPackages)
    throw new import_core55.Errors.CLIError("Invalid npm package name.");
}

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/commands/plugins/link.js
init_cjs_shims();
var import_core56 = __toESM(require_lib(), 1);
var PluginsLink = class _PluginsLink extends import_core56.Command {
  static args = {
    path: import_core56.Args.string({ default: ".", description: "path to plugin", name: "path", required: !0 })
  };
  static description = `Links a plugin into the CLI for development.
Installation of a linked plugin will override a user-installed or core plugin.

e.g. If you have a user-installed or core plugin that has a 'hello' command, installing a linked plugin with a 'hello' command will override the user-installed or core plugin implementation. This is useful for development work.
`;
  static examples = ['<%= config.bin %> <%= command.id %> <%- config.pjson.oclif.examplePlugin || "myplugin" %> '];
  static flags = {
    help: import_core56.Flags.help({ char: "h" }),
    install: import_core56.Flags.boolean({
      allowNo: !0,
      default: !0,
      description: "Install dependencies after linking the plugin."
    }),
    verbose: import_core56.Flags.boolean({ char: "v" })
  };
  async run() {
    let { args, flags } = await this.parse(_PluginsLink), plugins = new Plugins({
      config: this.config,
      logLevel: determineLogLevel(this.config, flags, "silent")
    });
    import_core56.ux.action.start(`${this.config.name}: Linking plugin ${source_default.cyan(args.path)}`), await plugins.link(args.path, { install: flags.install }), import_core56.ux.action.stop();
  }
};

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/commands/plugins/reset.js
init_cjs_shims();
var import_core57 = __toESM(require_lib(), 1);
import { rm as rm2 } from "node:fs/promises";
import { join as join5 } from "node:path";
var Reset = class _Reset extends import_core57.Command {
  static flags = {
    hard: import_core57.Flags.boolean({
      summary: "Delete node_modules and package manager related files in addition to uninstalling plugins."
    }),
    reinstall: import_core57.Flags.boolean({
      summary: "Reinstall all plugins after uninstalling."
    })
  };
  static summary = "Remove all user-installed and linked plugins.";
  async run() {
    let { flags } = await this.parse(_Reset), plugins = new Plugins({
      config: this.config
    }), userPlugins = await plugins.list();
    this.log(`Found ${userPlugins.length} plugin${userPlugins.length === 0 ? "" : "s"}:`);
    for (let plugin of userPlugins)
      this.log(`- ${plugin.name} ${source_default.dim(this.config.plugins.get(plugin.name)?.version)} ${source_default.dim(`(${plugin.type})`)}`);
    if (flags.hard) {
      let filesToDelete = [
        join5(this.config.dataDir, "node_modules"),
        join5(this.config.dataDir, "package.json"),
        join5(this.config.dataDir, "yarn.lock"),
        join5(this.config.dataDir, "package-lock.json")
      ];
      this.log("\u2705 Removed the following files:");
      for (let file of filesToDelete)
        this.log(`- ${file}`);
      await Promise.all(filesToDelete.map((file) => rm2(file, { force: !0, recursive: !0 })));
      for (let plugin of userPlugins)
        this.log(`\u2705 ${plugin.type === "link" ? "Unlinked" : "Uninstalled"} ${plugin.name}`);
    } else
      for (let plugin of userPlugins)
        try {
          await plugins.uninstall(plugin.name), this.log(`\u2705 ${plugin.type === "link" ? "Unlinked" : "Uninstalled"} ${plugin.name}`);
        } catch {
          this.warn(`Failed to uninstall ${plugin.name}`);
        }
    if (flags.reinstall) {
      this.log("Reinstall flag passed:");
      for (let plugin of userPlugins) {
        if (plugin.type === "link")
          try {
            let newPlugin = await plugins.link(plugin.root, { install: !1 }), newVersion = source_default.dim(`-> ${newPlugin.version}`);
            this.log(`\u2705 Relinked ${plugin.name} ${newVersion}`);
          } catch {
            this.warn(`Failed to relink ${plugin.name}`);
          }
        if (plugin.type === "user")
          try {
            let newPlugin = plugin.url ? await plugins.install(plugin.url) : await plugins.install(plugin.name, { tag: plugin.tag }), newVersion = source_default.dim(`-> ${newPlugin.version}`), tag = plugin.tag ? `@${plugin.tag}` : plugin.url ? ` (${plugin.url})` : "";
            this.log(`\u2705 Reinstalled ${plugin.name}${tag} ${newVersion}`);
          } catch {
            this.warn(`Failed to reinstall ${plugin.name}`);
          }
      }
    }
  }
};

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/commands/plugins/uninstall.js
init_cjs_shims();
var import_core58 = __toESM(require_lib(), 1);
function removeTags(plugin) {
  if (plugin.includes("@")) {
    let chunked = plugin.split("@");
    return !chunked.at(-1)?.includes("/") && chunked.length > 1 && chunked.pop(), chunked.join("@");
  }
  return plugin;
}
var PluginsUninstall = class _PluginsUninstall extends import_core58.Command {
  static aliases = ["plugins:unlink", "plugins:remove"];
  static args = {
    plugin: import_core58.Args.string({ description: "plugin to uninstall" })
  };
  static description = "Removes a plugin from the CLI.";
  static examples = ['<%= config.bin %> <%= command.id %> <%- config.pjson.oclif.examplePlugin || "myplugin" %>'];
  static flags = {
    help: import_core58.Flags.help({ char: "h" }),
    verbose: import_core58.Flags.boolean({ char: "v" })
  };
  static strict = !1;
  // In this case we want these operations to happen
  // sequentially so the `no-await-in-loop` rule is ignored
  async run() {
    let { argv, flags } = await this.parse(_PluginsUninstall), plugins = new Plugins({
      config: this.config,
      logLevel: determineLogLevel(this.config, flags, "silent")
    });
    argv.length === 0 && argv.push(".");
    for (let plugin of argv) {
      let friendly = removeTags(plugins.friendlyName(plugin)), unfriendly = await plugins.hasPlugin(removeTags(plugin));
      if (!unfriendly) {
        let p = this.config.getPluginsList().find((p2) => p2.name === plugin);
        return p?.parent ? this.error(`${friendly} is installed via plugin ${p.parent.name}, uninstall ${p.parent.name} instead`) : this.error(`${friendly} is not installed`);
      }
      try {
        let { name } = unfriendly, displayName = friendly === "." ? name : friendly ?? name;
        import_core58.ux.action.start(`${this.config.name}: Uninstalling ${displayName}`), await plugins.uninstall(name);
      } catch (error) {
        throw import_core58.ux.action.stop(source_default.bold.red("failed")), error;
      }
      import_core58.ux.action.stop();
    }
  }
};

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/commands/plugins/update.js
init_cjs_shims();
var import_core59 = __toESM(require_lib(), 1);
var PluginsUpdate = class _PluginsUpdate extends import_core59.Command {
  static description = "Update installed plugins.";
  static flags = {
    help: import_core59.Flags.help({ char: "h" }),
    verbose: import_core59.Flags.boolean({ char: "v" })
  };
  async run() {
    let { flags } = await this.parse(_PluginsUpdate), plugins = new Plugins({
      config: this.config,
      logLevel: determineLogLevel(this.config, flags, "silent")
    });
    import_core59.ux.action.start(`${this.config.name}: Updating plugins`), await plugins.update(), import_core59.ux.action.stop();
  }
};

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/hooks/update.js
init_cjs_shims();
var update = async function() {
  let plugins = new Plugins({
    config: this.config
  });
  try {
    await plugins.update();
  } catch (error) {
    error instanceof Error && this.error(error.message);
  }
};

// ../../node_modules/.pnpm/@oclif+plugin-plugins@5.1.2/node_modules/@oclif/plugin-plugins/lib/index.js
var commands3 = {
  plugins: PluginsIndex,
  "plugins:inspect": PluginsInspect,
  "plugins:install": PluginsInstall,
  "plugins:link": PluginsLink,
  "plugins:reset": Reset,
  "plugins:uninstall": PluginsUninstall,
  "plugins:update": PluginsUpdate
}, hooks = {
  update
};

// ../plugin-did-you-mean/dist/index.js
init_cjs_shims();

// ../plugin-did-you-mean/dist/services/conf.js
init_cjs_shims();
function isAutocorrectEnabled(conf = getConfig2()) {
  return conf.get("autocorrectEnabled");
}
function setAutocorrect(value, conf = getConfig2()) {
  conf.set("autocorrectEnabled", value);
}
function getConfig2() {
  return configInstance || (configInstance = new LocalStorage({ projectName: "did-you-mean" })), configInstance;
}
var configInstance;

// ../plugin-did-you-mean/dist/commands/config/autocorrect/off.js
init_cjs_shims();

// ../plugin-did-you-mean/dist/services/constants.js
init_cjs_shims();
var autocorrectStatus = {
  on: "Autocorrect on. The system will automatically run commands even when you mistype them.",
  off: "Autocorrect off. You'll need to confirm corrections for mistyped commands."
};

// ../plugin-did-you-mean/dist/commands/config/autocorrect/off.js
var _a35, AutocorrectOff = class extends base_command_default {
  async run() {
    setAutocorrect(!1), renderInfo({ body: autocorrectStatus.off });
  }
};
_a35 = AutocorrectOff;
AutocorrectOff.summary = "Disable autocorrect. Off by default.";
AutocorrectOff.descriptionWithMarkdown = `Disable autocorrect. Off by default.

  When autocorrection is enabled, Shopify CLI automatically runs a corrected version of your command if a correction is available.

  When autocorrection is disabled, you need to confirm that you want to run corrections for mistyped commands.
`;
AutocorrectOff.description = _a35.descriptionWithoutMarkdown();
var off_default = AutocorrectOff;

// ../plugin-did-you-mean/dist/commands/config/autocorrect/status.js
init_cjs_shims();
var _a36, AutocorrectStatus = class extends base_command_default {
  async run() {
    isAutocorrectEnabled() ? renderInfo({ body: autocorrectStatus.on }) : renderInfo({ body: autocorrectStatus.off });
  }
};
_a36 = AutocorrectStatus;
AutocorrectStatus.summary = "Check whether autocorrect is enabled or disabled. On by default.";
AutocorrectStatus.descriptionWithMarkdown = `Check whether autocorrect is enabled or disabled. On by default.

  When autocorrection is enabled, Shopify CLI automatically runs a corrected version of your command if a correction is available.

  When autocorrection is disabled, you need to confirm that you want to run corrections for mistyped commands.
`;
AutocorrectStatus.description = _a36.descriptionWithoutMarkdown();
var status_default = AutocorrectStatus;

// ../plugin-did-you-mean/dist/commands/config/autocorrect/on.js
init_cjs_shims();
var _a37, AutocorrectOn = class extends base_command_default {
  async run() {
    setAutocorrect(!0), renderInfo({ body: autocorrectStatus.on });
  }
};
_a37 = AutocorrectOn;
AutocorrectOn.summary = "Enable autocorrect. Off by default.";
AutocorrectOn.descriptionWithMarkdown = `Enable autocorrect. Off by default.

  When autocorrection is enabled, Shopify CLI automatically runs a corrected version of your command if a correction is available.

  When autocorrection is disabled, you need to confirm that you want to run corrections for mistyped commands.
`;
AutocorrectOn.description = _a37.descriptionWithoutMarkdown();
var on_default = AutocorrectOn;

// ../../node_modules/.pnpm/n-gram@2.0.2/node_modules/n-gram/index.js
init_cjs_shims();
var bigram = nGram(2), trigram = nGram(3);
function nGram(n) {
  if (typeof n != "number" || Number.isNaN(n) || n < 1 || n === Number.POSITIVE_INFINITY)
    throw new Error("`" + n + "` is not a valid argument for `n-gram`");
  return grams;
  function grams(value) {
    let nGrams = [];
    if (value == null)
      return nGrams;
    let source = typeof value.slice == "function" ? value : String(value), index = source.length - n + 1;
    if (index < 1)
      return nGrams;
    for (; index--; )
      nGrams[index] = source.slice(index, index + n);
    return nGrams;
  }
}

// ../plugin-did-you-mean/dist/index.js
function sanitizeCmd(cmd) {
  return cmd.replace(/:/g, " ");
}
function relativeScore(commandBigrams, userCommandBigrams) {
  let map = {};
  commandBigrams.forEach((elem) => {
    map[elem] = map[elem] ? map[elem] + 1 : 1;
  });
  let result = [];
  for (let key of userCommandBigrams)
    key in map && map[key] > 0 && (result.push(key), map[key]--);
  return result.length;
}
function findAlternativeCommand(opts) {
  if (opts.id.length < 2)
    return;
  let hiddenCommands = new Set(opts.config.commands.filter((cmd) => cmd.hidden).map((cmd) => cmd.id)), availableCommands = Array.from(new Set([...opts.config.commandIDs, ...opts.config.commands.flatMap((cmd) => cmd.aliases)].filter((cmd) => !hiddenCommands.has(cmd)))), userCommandBigrams = bigram(opts.id), commandsWithScores = availableCommands.map((cmd) => {
    let commandBigram = bigram(cmd);
    return { score: relativeScore(commandBigram, userCommandBigrams), cmd };
  }).filter(({ score }) => score >= 2).sort((first, second) => {
    let scoreDifference = second.score - first.score;
    return scoreDifference !== 0 ? scoreDifference : first.cmd.length - second.cmd.length;
  });
  if (outputDebug(`'Did you mean' options: ${JSON.stringify(commandsWithScores)}`), commandsWithScores.length > 0) {
    let { cmd } = commandsWithScores[0];
    return cmd;
  }
}
async function shouldRunCommand(result, userCommand) {
  return isAutocorrectEnabled() ? (renderInfo({
    body: ["Autocorrecting", { command: sanitizeCmd(userCommand) }, "to", { command: sanitizeCmd(result) }, { char: "." }]
  }), !0) : renderConfirmationPrompt({
    message: [
      "Command",
      { command: userCommand },
      "not found. Did you mean",
      { command: sanitizeCmd(result) },
      { char: "?" }
    ]
  });
}
var DidYouMeanCommands = {
  "config:autocorrect:off": off_default,
  "config:autocorrect:status": status_default,
  "config:autocorrect:on": on_default
}, DidYouMeanHook = async function(opts) {
  let result = findAlternativeCommand(opts), userCommand = sanitizeCmd(opts.id);
  if (opts.argv && (opts.argv.includes("-f") || opts.argv.includes("--force")) || !result) {
    renderFatalError(new AbortError(`Command '${userCommand}' not found.`));
    return;
  }
  await shouldRunCommand(result, userCommand) && await this.config.runCommand(result, opts.argv);
};

// src/index.ts
import fs5 from "fs";

// ../plugin-cloudflare/dist/tunnel.js
init_cjs_shims();

// ../plugin-cloudflare/dist/provider.js
init_cjs_shims();

// ../cli-kit/dist/public/node/plugins/tunnel.js
init_cjs_shims();
var TunnelError = class extends import_ts_error.ExtendableError {
  constructor(type, message) {
    super(message), this.type = type;
  }
}, defineProvider = (input) => async () => input, startTunnel = (options) => async (inputs) => inputs.provider !== options.provider ? err(new TunnelError("invalid-provider")) : options.action(inputs.port);

// ../plugin-cloudflare/dist/provider.js
var TUNNEL_PROVIDER = "cloudflare", provider_default = defineProvider({ name: TUNNEL_PROVIDER });

// ../plugin-cloudflare/dist/install-cloudflared.js
init_cjs_shims();
import { fileURLToPath as fileURLToPath9 } from "url";
import util from "util";
import { pipeline as pipeline2 } from "stream";
import { execSync, execFileSync } from "child_process";
var CURRENT_CLOUDFLARE_VERSION = "2024.8.2", CLOUDFLARE_REPO = `https://github.com/cloudflare/cloudflared/releases/download/${CURRENT_CLOUDFLARE_VERSION}/`, LINUX_URL = {
  arm64: "cloudflared-linux-arm64",
  arm: "cloudflared-linux-arm",
  x64: "cloudflared-linux-amd64",
  ia32: "cloudflared-linux-386"
}, MACOS_URL = {
  arm64: "cloudflared-darwin-arm64.tgz",
  x64: "cloudflared-darwin-amd64.tgz"
}, WINDOWS_URL = {
  x64: "cloudflared-windows-amd64.exe",
  ia32: "cloudflared-windows-386.exe",
  arm64: "cloudflared-windows-amd64.exe"
}, URL2 = {
  linux: LINUX_URL,
  darwin: MACOS_URL,
  win32: WINDOWS_URL
};
function getURL(platform2 = process.platform, arch = process.arch) {
  if (!Object.keys(URL2).includes(platform2))
    throw new Error(`Unsupported system platform: ${platform2}`);
  let fileName = URL2[platform2][arch];
  if (fileName === void 0)
    throw new Error(`Unsupported system arch: ${arch}`);
  return CLOUDFLARE_REPO + fileName;
}
function getBinPathTarget(env = process.env, platform2 = process.platform) {
  return env.SHOPIFY_CLI_CLOUDFLARED_PATH ? env.SHOPIFY_CLI_CLOUDFLARED_PATH : joinPath(dirname(fileURLToPath9(import.meta.url)), "..", "bin", platform2 === "win32" ? "cloudflared.exe" : "cloudflared");
}
async function install(env = process.env, platform2 = process.platform, arch = process.arch) {
  if (env.SHOPIFY_CLI_IGNORE_CLOUDFLARED) {
    outputDebug("Skipping cloudflared installation because SHOPIFY_CLI_IGNORE_CLOUDFLARED is set");
    return;
  }
  let fileUrlPath = getURL(platform2, arch), binTarget = getBinPathTarget(env, platform2);
  if (fileExistsSync(binTarget))
    try {
      let versionArray = execFileSync(binTarget, ["--version"], { encoding: "utf8" }).split(" "), versionNumber = versionArray.length > 2 ? versionArray[2] : "0.0.0";
      if (!versionIsGreaterThan(CURRENT_CLOUDFLARE_VERSION, versionNumber)) {
        outputDebug("cloudflared already installed, skipping");
        return;
      }
    } catch {
      outputDebug("version check failed, reinstalling");
    }
  if (platform2 === "linux")
    await installLinux(fileUrlPath, binTarget);
  else if (platform2 === "darwin")
    await installMacos(fileUrlPath, binTarget);
  else if (platform2 === "win32")
    await installWindows(fileUrlPath, binTarget);
  else
    throw new Error(`Unsupported platform: ${platform2}`);
}
function versionIsGreaterThan(versionA, versionB) {
  let [majorA, minorA, patchA] = versionA.split(".").map(Number), [majorB, minorB, patchB] = versionB.split(".").map(Number);
  return majorA !== majorB ? (majorA ?? 0) > (majorB ?? 0) : minorA !== minorB ? (minorA ?? 0) > (minorB ?? 0) : (patchA ?? 0) > (patchB ?? 0);
}
async function installLinux(file, binTarget) {
  await downloadFile2(file, binTarget), await chmod(binTarget, "755");
}
async function installWindows(file, binTarget) {
  await downloadFile2(file, binTarget);
}
async function installMacos(file, binTarget) {
  await downloadFile2(file, `${binTarget}.tgz`);
  let filename = basename(`${binTarget}.tgz`);
  execSync(`tar -xzf ${filename}`, { cwd: dirname(binTarget) }), unlinkFileSync(`${binTarget}.tgz`), await renameFile(`${dirname(binTarget)}/cloudflared`, binTarget);
}
async function downloadFile2(url, to) {
  fileExistsSync(dirname(to)) || mkdirSync(dirname(to));
  let streamPipeline = util.promisify(pipeline2), response = await fetch(url, { redirect: "follow" });
  if (!response.ok || !response.body)
    throw new Error(`Couldn't download file ${url} (${response.status} ${response.statusText})`);
  let fileObject = createFileWriteStream(to);
  return await streamPipeline(response.body, fileObject), to;
}

// ../plugin-cloudflare/dist/tunnel.js
import { Writable as Writable2 } from "stream";
import { fileURLToPath as fileURLToPath10 } from "url";
var tunnel_default = startTunnel({ provider: TUNNEL_PROVIDER, action: hookStart }), TUNNEL_TIMEOUT = isUnitTest() ? 0.2 : 40, MAX_RETRIES = 5;
async function hookStart(port) {
  try {
    let client = new TunnelClientInstance(port);
    return await client.startTunnel(), ok(client);
  } catch (error) {
    let tunnelError = new TunnelError("unknown", error.message);
    return err(tunnelError);
  }
}
var TunnelClientInstance = class {
  constructor(port) {
    this.provider = TUNNEL_PROVIDER, this.currentStatus = { status: "not-started" }, this.abortController = void 0, this.port = port;
  }
  async startTunnel() {
    try {
      await install(), this.tunnel();
    } catch (error) {
      this.currentStatus = { status: "error", message: error.message, tryMessage: whatToTry() };
    }
  }
  getTunnelStatus() {
    return this.currentStatus;
  }
  stopTunnel() {
    this.abortController?.abort();
  }
  tunnel(retries = 0) {
    this.abortController = new AbortController2();
    let resolved = !1;
    if (retries >= MAX_RETRIES) {
      resolved = !0, this.currentStatus = {
        status: "error",
        message: "Could not start Cloudflare tunnel: max retries reached.",
        tryMessage: whatToTry()
      };
      return;
    }
    let args = ["tunnel", "--url", `http://localhost:${this.port}`, "--no-autoupdate"], errors2 = [], connected = !1, url;
    this.currentStatus = { status: "starting" }, setTimeout(() => {
      if (!resolved) {
        resolved = !0;
        let lastErrors = [...new Set(errors2)].slice(-5).join(`
`);
        lastErrors === "" ? this.currentStatus = {
          status: "error",
          message: "Could not start Cloudflare tunnel: unknown error.",
          tryMessage: whatToTry()
        } : this.currentStatus = { status: "error", message: lastErrors, tryMessage: whatToTry() }, this.abortController?.abort();
      }
    }, TUNNEL_TIMEOUT * 1e3);
    let self2 = this, customStdout = new Writable2({
      write(chunk, _2, callback) {
        if (outputDebug(chunk.toString()), resolved)
          return;
        url || (url = findUrl(chunk)), findConnection(chunk) && (connected = !0), connected && (url ? (resolved = !0, self2.currentStatus = { status: "connected", url }) : self2.currentStatus = { status: "error", message: "Could not start Cloudflare tunnel: URL not found." });
        let errorMessage2 = findError(chunk);
        errorMessage2 && errors2.push(errorMessage2), callback();
      }
    });
    exec(getBinPathTarget2(), args, {
      stdout: customStdout,
      stderr: customStdout,
      signal: this.abortController.signal,
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      externalErrorHandler: async (error) => {
        if (resolved)
          throw new BugError(`Could not start Cloudflare tunnel: process crashed after stablishing a connection: ${error.message}`, whatToTry());
        outputDebug(`Cloudflare tunnel crashed: ${error.message}, restarting...`), isUnitTest() || await sleep(1), this.tunnel(retries + 1);
      }
    });
  }
};
function whatToTry() {
  return [
    "What to try:",
    {
      list: {
        items: [
          ["Run the command again"],
          ["Add the flag", { command: "--tunnel-url {URL}" }, "to use a custom tunnel URL"]
        ]
      }
    }
  ];
}
function findUrl(data) {
  let regex = new RegExp(`(https:\\/\\/[^\\s]+\\.${getTunnelDomain()})`), match2 = data.toString().match(regex) ?? void 0;
  return match2 && match2[1];
}
function findError(data) {
  if ([
    /failed to request quick Tunnel/,
    /failed to unmarshal quick Tunnel/,
    /failed to parse quick Tunnel ID/,
    /failed to provision routing/,
    /ERR Couldn't start tunnel/,
    /ERR Failed to serve quic connection/,
    /ERR Failed to create new quic connection error/
  ].some((error) => error.test(data.toString())))
    return `Could not start Cloudflare tunnel: ${cleanCloudflareLog(data.toString())}`;
}
function cleanCloudflareLog(input) {
  let prefixRegex = /^[0-9TZ:-]+ (ERR )?/g, suffixRegex = /connIndex.*/g;
  return input.replace(prefixRegex, "").replace(suffixRegex, "");
}
function findConnection(data) {
  let match2 = data.toString().match(/(INF Registered tunnel connection|INF Connection)/) ?? void 0;
  return match2 && match2[0];
}
function getBinPathTarget2() {
  return process.env.SHOPIFY_CLI_CLOUDFLARED_PATH ? process.env.SHOPIFY_CLI_CLOUDFLARED_PATH : joinPath(dirname(fileURLToPath10(import.meta.url)), "..", "bin", process.platform === "win32" ? "cloudflared.exe" : "cloudflared");
}
function getTunnelDomain() {
  return process.env.SHOPIFY_CLI_CLOUDFLARED_DOMAIN ?? "trycloudflare.com";
}

// src/index.ts
var HydrogenInitHook = HOOKS.init;
process.on("uncaughtException", (err2) => {
  fs5.writeSync(process.stderr.fd, `${err2.stack || err2.message || err2}
`), process.exit(1);
});
var signals = ["SIGINT", "SIGTERM", "SIGQUIT"];
signals.forEach((signal) => {
  process.on(signal, () => {
    process.exit(1);
  });
});
var columns2 = Number(process.env.SHOPIFY_CLI_COLUMNS);
isNaN(columns2) || (process.stdout.columns = columns2);
async function runShopifyCLI({ development }) {
  !development && await useLocalCLIIfDetected(import.meta.url) || await runCLI({
    moduleURL: import.meta.url,
    development
  });
}
commands3.plugins.hidden = !0;
commands3["plugins:install"].description = "";
var appCommands = Object.keys(commands);
appCommands.forEach((command) => {
  commands[command].customPluginName = "@shopify/app";
});
var themeCommands = Object.keys(dist_default);
themeCommands.forEach((command) => {
  dist_default[command].customPluginName = "@shopify/theme";
});
var hydrogenCommands = Object.keys(COMMANDS2);
hydrogenCommands.forEach((command) => {
  COMMANDS2[command].customPluginName = "@shopify/cli-hydrogen";
});
var pluginCommandsCommands = Object.keys(commands2);
pluginCommandsCommands.forEach((command) => {
  commands2[command].customPluginName = "@oclif/plugin-commands";
});
var didYouMeanCommands = Object.keys(DidYouMeanCommands);
didYouMeanCommands.forEach((command) => {
  DidYouMeanCommands[command].customPluginName = "@shopify/plugin-did-you-mean";
});
var pluginPluginsCommands = Object.keys(commands3);
pluginPluginsCommands.forEach((command) => {
  commands3[command].customPluginName = "@oclif/plugin-plugins";
});
var COMMANDS3 = {
  ...commands,
  ...dist_default,
  ...commands3,
  ...DidYouMeanCommands,
  ...commands2,
  ...COMMANDS2,
  search: Search,
  upgrade: Upgrade,
  version: Version,
  help: HelpCommand,
  "auth:logout": Logout,
  "debug:command-flags": CommandFlags,
  demo: Demo,
  "demo:catalog": Catalog,
  "demo:generate-file": GenerateFile,
  "demo:print-ai-prompt": PrintAIPrompt,
  "kitchen-sink": KitchenSinkAll,
  "kitchen-sink:async": KitchenSinkAsync,
  "kitchen-sink:prompts": KitchenSinkPrompts,
  "kitchen-sink:static": KitchenSinkStatic,
  "docs:generate": DocsGenerate
}, src_default = runShopifyCLI;
export {
  AppInitHook,
  AppPublicMetadataHook,
  AppSensitiveMetadataHook,
  COMMANDS3 as COMMANDS,
  DidYouMeanHook,
  HydrogenInitHook,
  hooks as PluginHook,
  provider_default as TunnelProviderHook,
  tunnel_default as TunnelStartHook,
  src_default as default
};
/*! Bundled license information:

isobject/index.js:
  (*!
   * isobject <https://github.com/jonschlinkert/isobject>
   *
   * Copyright (c) 2014-2015, Jon Schlinkert.
   * Licensed under the MIT License.
   *)

line-column/lib/line-column.js:
  (**
   * line-column - Convert efficiently index to/from line-column in a string
   * @module  lineColumn
   * @license MIT
   *)

json-to-ast/build.js:
  (*!
   * repeat-string <https://github.com/jonschlinkert/repeat-string>
   *
   * Copyright (c) 2014-2015, Jon Schlinkert.
   * Licensed under the MIT License.
   *)

archiver/lib/error.js:
  (**
   * Archiver Core
   *
   * @ignore
   * @license [MIT]{@link https://github.com/archiverjs/node-archiver/blob/master/LICENSE}
   * @copyright (c) 2012-2014 Chris Talkington, contributors.
   *)

safe-buffer/index.js:
  (*! safe-buffer. MIT License. Feross Aboukhadijeh <https://feross.org/opensource> *)

archiver/lib/core.js:
  (**
   * Archiver Core
   *
   * @ignore
   * @license [MIT]{@link https://github.com/archiverjs/node-archiver/blob/master/LICENSE}
   * @copyright (c) 2012-2014 Chris Talkington, contributors.
   *)

crc-32/crc32.js:
  (*! crc32.js (C) 2014-present SheetJS -- http://sheetjs.com *)

zip-stream/index.js:
  (**
   * ZipStream
   *
   * @ignore
   * @license [MIT]{@link https://github.com/archiverjs/node-zip-stream/blob/master/LICENSE}
   * @copyright (c) 2014 Chris Talkington, contributors.
   *)

archiver/lib/plugins/zip.js:
  (**
   * ZIP Format Plugin
   *
   * @module plugins/zip
   * @license [MIT]{@link https://github.com/archiverjs/node-archiver/blob/master/LICENSE}
   * @copyright (c) 2012-2014 Chris Talkington, contributors.
   *)

archiver/lib/plugins/tar.js:
  (**
   * TAR Format Plugin
   *
   * @module plugins/tar
   * @license [MIT]{@link https://github.com/archiverjs/node-archiver/blob/master/LICENSE}
   * @copyright (c) 2012-2014 Chris Talkington, contributors.
   *)

archiver/lib/plugins/json.js:
  (**
   * JSON Format Plugin
   *
   * @module plugins/json
   * @license [MIT]{@link https://github.com/archiverjs/node-archiver/blob/master/LICENSE}
   * @copyright (c) 2012-2014 Chris Talkington, contributors.
   *)

archiver/index.js:
  (**
   * Archiver Vending
   *
   * @ignore
   * @license [MIT]{@link https://github.com/archiverjs/node-archiver/blob/master/LICENSE}
   * @copyright (c) 2012-2014 Chris Talkington, contributors.
   *)

react-dom/cjs/react-dom-server-legacy.node.production.min.js:
  (**
   * @license React
   * react-dom-server-legacy.node.production.min.js
   *
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *)

react-dom/cjs/react-dom-server.node.production.min.js:
  (**
   * @license React
   * react-dom-server.node.production.min.js
   *
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *)

react-dom/cjs/react-dom-server-legacy.node.development.js:
  (**
   * @license React
   * react-dom-server-legacy.node.development.js
   *
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *)

react-dom/cjs/react-dom-server.node.development.js:
  (**
   * @license React
   * react-dom-server.node.development.js
   *
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *)

object-assign/index.js:
  (*
  object-assign
  (c) Sindre Sorhus
  @license MIT
  *)

react/cjs/react.production.min.js:
  (** @license React v17.0.2
   * react.production.min.js
   *
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *)

react/cjs/react.development.js:
  (** @license React v17.0.2
   * react.development.js
   *
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *)

react-dom/cjs/react-dom.production.min.js:
  (**
   * @license React
   * react-dom.production.min.js
   *
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *)

react-dom/cjs/react-dom.development.js:
  (**
   * @license React
   * react-dom.development.js
   *
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *)
  (**
   * Checks if an event is supported in the current execution environment.
   *
   * NOTE: This will not work correctly for non-generic events such as `change`,
   * `reset`, `load`, `error`, and `select`.
   *
   * Borrows from Modernizr.
   *
   * @param {string} eventNameSuffix Event name, e.g. "click".
   * @return {boolean} True if the event is supported.
   * @internal
   * @license Modernizr 3.0.0pre (Custom Build) | MIT
   *)

react-is/cjs/react-is.production.min.js:
  (** @license React v16.13.1
   * react-is.production.min.js
   *
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *)

react-is/cjs/react-is.development.js:
  (** @license React v16.13.1
   * react-is.development.js
   *
   * Copyright (c) Facebook, Inc. and its affiliates.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   *)

depd/index.js:
  (*!
   * depd
   * Copyright(c) 2014-2018 Douglas Christopher Wilson
   * MIT Licensed
   *)

bytes/index.js:
  (*!
   * bytes
   * Copyright(c) 2012-2014 TJ Holowaychuk
   * Copyright(c) 2015 Jed Watson
   * MIT Licensed
   *)

content-type/index.js:
  (*!
   * content-type
   * Copyright(c) 2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

statuses/index.js:
  (*!
   * statuses
   * Copyright(c) 2014 Jonathan Ong
   * Copyright(c) 2016 Douglas Christopher Wilson
   * MIT Licensed
   *)

toidentifier/index.js:
  (*!
   * toidentifier
   * Copyright(c) 2016 Douglas Christopher Wilson
   * MIT Licensed
   *)

http-errors/index.js:
  (*!
   * http-errors
   * Copyright(c) 2014 Jonathan Ong
   * Copyright(c) 2016 Douglas Christopher Wilson
   * MIT Licensed
   *)

destroy/index.js:
  (*!
   * destroy
   * Copyright(c) 2014 Jonathan Ong
   * Copyright(c) 2015-2022 Douglas Christopher Wilson
   * MIT Licensed
   *)

unpipe/index.js:
  (*!
   * unpipe
   * Copyright(c) 2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

raw-body/index.js:
  (*!
   * raw-body
   * Copyright(c) 2013-2014 Jonathan Ong
   * Copyright(c) 2014-2022 Douglas Christopher Wilson
   * MIT Licensed
   *)

ee-first/index.js:
  (*!
   * ee-first
   * Copyright(c) 2014 Jonathan Ong
   * MIT Licensed
   *)

on-finished/index.js:
  (*!
   * on-finished
   * Copyright(c) 2013 Jonathan Ong
   * Copyright(c) 2014 Douglas Christopher Wilson
   * MIT Licensed
   *)

body-parser/lib/read.js:
  (*!
   * body-parser
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

media-typer/index.js:
  (*!
   * media-typer
   * Copyright(c) 2014 Douglas Christopher Wilson
   * MIT Licensed
   *)

type-is/index.js:
  (*!
   * type-is
   * Copyright(c) 2014 Jonathan Ong
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

body-parser/lib/types/json.js:
  (*!
   * body-parser
   * Copyright(c) 2014 Jonathan Ong
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

body-parser/lib/types/raw.js:
  (*!
   * body-parser
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

body-parser/lib/types/text.js:
  (*!
   * body-parser
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

body-parser/lib/types/urlencoded.js:
  (*!
   * body-parser
   * Copyright(c) 2014 Jonathan Ong
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

body-parser/index.js:
  (*!
   * body-parser
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

merge-descriptors/index.js:
  (*!
   * merge-descriptors
   * Copyright(c) 2014 Jonathan Ong
   * Copyright(c) 2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

encodeurl/index.js:
  (*!
   * encodeurl
   * Copyright(c) 2016 Douglas Christopher Wilson
   * MIT Licensed
   *)

escape-html/index.js:
  (*!
   * escape-html
   * Copyright(c) 2012-2013 TJ Holowaychuk
   * Copyright(c) 2015 Andreas Lubbe
   * Copyright(c) 2015 Tiancheng "Timothy" Gu
   * MIT Licensed
   *)

parseurl/index.js:
  (*!
   * parseurl
   * Copyright(c) 2014 Jonathan Ong
   * Copyright(c) 2014-2017 Douglas Christopher Wilson
   * MIT Licensed
   *)

finalhandler/index.js:
  (*!
   * finalhandler
   * Copyright(c) 2014-2022 Douglas Christopher Wilson
   * MIT Licensed
   *)

express/lib/router/layer.js:
  (*!
   * express
   * Copyright(c) 2009-2013 TJ Holowaychuk
   * Copyright(c) 2013 Roman Shtylman
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

methods/index.js:
  (*!
   * methods
   * Copyright(c) 2013-2014 TJ Holowaychuk
   * Copyright(c) 2015-2016 Douglas Christopher Wilson
   * MIT Licensed
   *)

express/lib/router/route.js:
  (*!
   * express
   * Copyright(c) 2009-2013 TJ Holowaychuk
   * Copyright(c) 2013 Roman Shtylman
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

express/lib/router/index.js:
  (*!
   * express
   * Copyright(c) 2009-2013 TJ Holowaychuk
   * Copyright(c) 2013 Roman Shtylman
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

express/lib/middleware/init.js:
  (*!
   * express
   * Copyright(c) 2009-2013 TJ Holowaychuk
   * Copyright(c) 2013 Roman Shtylman
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

express/lib/middleware/query.js:
  (*!
   * express
   * Copyright(c) 2009-2013 TJ Holowaychuk
   * Copyright(c) 2013 Roman Shtylman
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

express/lib/view.js:
  (*!
   * express
   * Copyright(c) 2009-2013 TJ Holowaychuk
   * Copyright(c) 2013 Roman Shtylman
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

content-disposition/index.js:
  (*!
   * content-disposition
   * Copyright(c) 2014-2017 Douglas Christopher Wilson
   * MIT Licensed
   *)

etag/index.js:
  (*!
   * etag
   * Copyright(c) 2014-2016 Douglas Christopher Wilson
   * MIT Licensed
   *)

fresh/index.js:
  (*!
   * fresh
   * Copyright(c) 2012 TJ Holowaychuk
   * Copyright(c) 2016-2017 Douglas Christopher Wilson
   * MIT Licensed
   *)

range-parser/index.js:
  (*!
   * range-parser
   * Copyright(c) 2012-2014 TJ Holowaychuk
   * Copyright(c) 2015-2016 Douglas Christopher Wilson
   * MIT Licensed
   *)

send/index.js:
  (*!
   * send
   * Copyright(c) 2012 TJ Holowaychuk
   * Copyright(c) 2014-2022 Douglas Christopher Wilson
   * MIT Licensed
   *)

forwarded/index.js:
  (*!
   * forwarded
   * Copyright(c) 2014-2017 Douglas Christopher Wilson
   * MIT Licensed
   *)

proxy-addr/index.js:
  (*!
   * proxy-addr
   * Copyright(c) 2014-2016 Douglas Christopher Wilson
   * MIT Licensed
   *)

express/lib/utils.js:
  (*!
   * express
   * Copyright(c) 2009-2013 TJ Holowaychuk
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

express/lib/application.js:
  (*!
   * express
   * Copyright(c) 2009-2013 TJ Holowaychuk
   * Copyright(c) 2013 Roman Shtylman
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

negotiator/index.js:
  (*!
   * negotiator
   * Copyright(c) 2012 Federico Romero
   * Copyright(c) 2012-2014 Isaac Z. Schlueter
   * Copyright(c) 2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

accepts/index.js:
  (*!
   * accepts
   * Copyright(c) 2014 Jonathan Ong
   * Copyright(c) 2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

express/lib/request.js:
  (*!
   * express
   * Copyright(c) 2009-2013 TJ Holowaychuk
   * Copyright(c) 2013 Roman Shtylman
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

cookie/index.js:
  (*!
   * cookie
   * Copyright(c) 2012-2014 Roman Shtylman
   * Copyright(c) 2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

vary/index.js:
  (*!
   * vary
   * Copyright(c) 2014-2017 Douglas Christopher Wilson
   * MIT Licensed
   *)

express/lib/response.js:
  (*!
   * express
   * Copyright(c) 2009-2013 TJ Holowaychuk
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

serve-static/index.js:
  (*!
   * serve-static
   * Copyright(c) 2010 Sencha Inc.
   * Copyright(c) 2011 TJ Holowaychuk
   * Copyright(c) 2014-2016 Douglas Christopher Wilson
   * MIT Licensed
   *)

express/lib/express.js:
  (*!
   * express
   * Copyright(c) 2009-2013 TJ Holowaychuk
   * Copyright(c) 2013 Roman Shtylman
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)

express/index.js:
  (*!
   * express
   * Copyright(c) 2009-2013 TJ Holowaychuk
   * Copyright(c) 2013 Roman Shtylman
   * Copyright(c) 2014-2015 Douglas Christopher Wilson
   * MIT Licensed
   *)
*/
//# sourceMappingURL=index.js.map
